'''
# `data_akamai_property_rules_builder`

Refer to the Terraform Registry for docs: [`data_akamai_property_rules_builder`](https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder).
'''
import abc
import builtins
import datetime
import enum
import typing

import jsii
import publication
import typing_extensions

from typeguard import check_type

from .._jsii import *

import cdktf as _cdktf_9a9027ec
import constructs as _constructs_77d1e7e8


class DataAkamaiPropertyRulesBuilder(
    _cdktf_9a9027ec.TerraformDataSource,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilder",
):
    '''Represents a {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder akamai_property_rules_builder}.'''

    def __init__(
        self,
        scope: _constructs_77d1e7e8.Construct,
        id_: builtins.str,
        *,
        id: typing.Optional[builtins.str] = None,
        rules_v20230105: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20230530: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20230920: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20231030: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20240109: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109", typing.Dict[builtins.str, typing.Any]]] = None,
        connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
        count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
        depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
        for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
        lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
        provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
        provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''Create a new {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder akamai_property_rules_builder} Data Source.

        :param scope: The scope in which to define this construct.
        :param id_: The scoped construct ID. Must be unique amongst siblings in the same scope
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param rules_v20230105: rules_v2023_01_05 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_01_05 DataAkamaiPropertyRulesBuilder#rules_v2023_01_05}
        :param rules_v20230530: rules_v2023_05_30 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_05_30 DataAkamaiPropertyRulesBuilder#rules_v2023_05_30}
        :param rules_v20230920: rules_v2023_09_20 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_09_20 DataAkamaiPropertyRulesBuilder#rules_v2023_09_20}
        :param rules_v20231030: rules_v2023_10_30 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_10_30 DataAkamaiPropertyRulesBuilder#rules_v2023_10_30}
        :param rules_v20240109: rules_v2024_01_09 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2024_01_09 DataAkamaiPropertyRulesBuilder#rules_v2024_01_09}
        :param connection: 
        :param count: 
        :param depends_on: 
        :param for_each: 
        :param lifecycle: 
        :param provider: 
        :param provisioners: 
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acef2b9a06d87ce3b4c4f865c9686829948f24c27bc462c19671aaa3854c5ed4)
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument id_", value=id_, expected_type=type_hints["id_"])
        config = DataAkamaiPropertyRulesBuilderConfig(
            id=id,
            rules_v20230105=rules_v20230105,
            rules_v20230530=rules_v20230530,
            rules_v20230920=rules_v20230920,
            rules_v20231030=rules_v20231030,
            rules_v20240109=rules_v20240109,
            connection=connection,
            count=count,
            depends_on=depends_on,
            for_each=for_each,
            lifecycle=lifecycle,
            provider=provider,
            provisioners=provisioners,
        )

        jsii.create(self.__class__, self, [scope, id_, config])

    @jsii.member(jsii_name="generateConfigForImport")
    @builtins.classmethod
    def generate_config_for_import(
        cls,
        scope: _constructs_77d1e7e8.Construct,
        import_to_id: builtins.str,
        import_from_id: builtins.str,
        provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
    ) -> _cdktf_9a9027ec.ImportableResource:
        '''Generates CDKTF code for importing a DataAkamaiPropertyRulesBuilder resource upon running "cdktf plan ".

        :param scope: The scope in which to define this construct.
        :param import_to_id: The construct id used in the generated config for the DataAkamaiPropertyRulesBuilder to import.
        :param import_from_id: The id of the existing DataAkamaiPropertyRulesBuilder that should be imported. Refer to the {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#import import section} in the documentation of this resource for the id to use
        :param provider: ? Optional instance of the provider where the DataAkamaiPropertyRulesBuilder to import is found.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3e57f2caeb0b80b76298c6c8ab9fd08455c33e1f5805a260f921e38ef45cd6)
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument import_to_id", value=import_to_id, expected_type=type_hints["import_to_id"])
            check_type(argname="argument import_from_id", value=import_from_id, expected_type=type_hints["import_from_id"])
            check_type(argname="argument provider", value=provider, expected_type=type_hints["provider"])
        return typing.cast(_cdktf_9a9027ec.ImportableResource, jsii.sinvoke(cls, "generateConfigForImport", [scope, import_to_id, import_from_id, provider]))

    @jsii.member(jsii_name="putRulesV20230105")
    def put_rules_v20230105(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105(
            name=name,
            advanced_override=advanced_override,
            behavior=behavior,
            children=children,
            comments=comments,
            criteria_locked=criteria_locked,
            criteria_must_satisfy=criteria_must_satisfy,
            criterion=criterion,
            custom_override=custom_override,
            is_secure=is_secure,
            template_link=template_link,
            template_uuid=template_uuid,
            uuid=uuid,
            variable=variable,
        )

        return typing.cast(None, jsii.invoke(self, "putRulesV20230105", [value]))

    @jsii.member(jsii_name="putRulesV20230530")
    def put_rules_v20230530(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530(
            name=name,
            advanced_override=advanced_override,
            behavior=behavior,
            children=children,
            comments=comments,
            criteria_locked=criteria_locked,
            criteria_must_satisfy=criteria_must_satisfy,
            criterion=criterion,
            custom_override=custom_override,
            is_secure=is_secure,
            template_link=template_link,
            template_uuid=template_uuid,
            uuid=uuid,
            variable=variable,
        )

        return typing.cast(None, jsii.invoke(self, "putRulesV20230530", [value]))

    @jsii.member(jsii_name="putRulesV20230920")
    def put_rules_v20230920(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920(
            name=name,
            advanced_override=advanced_override,
            behavior=behavior,
            children=children,
            comments=comments,
            criteria_locked=criteria_locked,
            criteria_must_satisfy=criteria_must_satisfy,
            criterion=criterion,
            custom_override=custom_override,
            is_secure=is_secure,
            template_link=template_link,
            template_uuid=template_uuid,
            uuid=uuid,
            variable=variable,
        )

        return typing.cast(None, jsii.invoke(self, "putRulesV20230920", [value]))

    @jsii.member(jsii_name="putRulesV20231030")
    def put_rules_v20231030(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030(
            name=name,
            advanced_override=advanced_override,
            behavior=behavior,
            children=children,
            comments=comments,
            criteria_locked=criteria_locked,
            criteria_must_satisfy=criteria_must_satisfy,
            criterion=criterion,
            custom_override=custom_override,
            is_secure=is_secure,
            template_link=template_link,
            template_uuid=template_uuid,
            uuid=uuid,
            variable=variable,
        )

        return typing.cast(None, jsii.invoke(self, "putRulesV20231030", [value]))

    @jsii.member(jsii_name="putRulesV20240109")
    def put_rules_v20240109(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109(
            name=name,
            advanced_override=advanced_override,
            behavior=behavior,
            children=children,
            comments=comments,
            criteria_locked=criteria_locked,
            criteria_must_satisfy=criteria_must_satisfy,
            criterion=criterion,
            custom_override=custom_override,
            is_secure=is_secure,
            template_link=template_link,
            template_uuid=template_uuid,
            uuid=uuid,
            variable=variable,
        )

        return typing.cast(None, jsii.invoke(self, "putRulesV20240109", [value]))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetRulesV20230105")
    def reset_rules_v20230105(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRulesV20230105", []))

    @jsii.member(jsii_name="resetRulesV20230530")
    def reset_rules_v20230530(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRulesV20230530", []))

    @jsii.member(jsii_name="resetRulesV20230920")
    def reset_rules_v20230920(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRulesV20230920", []))

    @jsii.member(jsii_name="resetRulesV20231030")
    def reset_rules_v20231030(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRulesV20231030", []))

    @jsii.member(jsii_name="resetRulesV20240109")
    def reset_rules_v20240109(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRulesV20240109", []))

    @jsii.member(jsii_name="synthesizeAttributes")
    def _synthesize_attributes(self) -> typing.Mapping[builtins.str, typing.Any]:
        return typing.cast(typing.Mapping[builtins.str, typing.Any], jsii.invoke(self, "synthesizeAttributes", []))

    @jsii.member(jsii_name="synthesizeHclAttributes")
    def _synthesize_hcl_attributes(self) -> typing.Mapping[builtins.str, typing.Any]:
        return typing.cast(typing.Mapping[builtins.str, typing.Any], jsii.invoke(self, "synthesizeHclAttributes", []))

    @jsii.python.classproperty
    @jsii.member(jsii_name="tfResourceType")
    def TF_RESOURCE_TYPE(cls) -> builtins.str:
        return typing.cast(builtins.str, jsii.sget(cls, "tfResourceType"))

    @builtins.property
    @jsii.member(jsii_name="json")
    def json(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "json"))

    @builtins.property
    @jsii.member(jsii_name="ruleFormat")
    def rule_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ruleFormat"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20230105")
    def rules_v20230105(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105OutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105OutputReference", jsii.get(self, "rulesV20230105"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20230530")
    def rules_v20230530(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530OutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530OutputReference", jsii.get(self, "rulesV20230530"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20230920")
    def rules_v20230920(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920OutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920OutputReference", jsii.get(self, "rulesV20230920"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20231030")
    def rules_v20231030(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030OutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030OutputReference", jsii.get(self, "rulesV20231030"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20240109")
    def rules_v20240109(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109OutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109OutputReference", jsii.get(self, "rulesV20240109"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20230105Input")
    def rules_v20230105_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105"], jsii.get(self, "rulesV20230105Input"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20230530Input")
    def rules_v20230530_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530"], jsii.get(self, "rulesV20230530Input"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20230920Input")
    def rules_v20230920_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920"], jsii.get(self, "rulesV20230920Input"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20231030Input")
    def rules_v20231030_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030"], jsii.get(self, "rulesV20231030Input"))

    @builtins.property
    @jsii.member(jsii_name="rulesV20240109Input")
    def rules_v20240109_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109"], jsii.get(self, "rulesV20240109Input"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__332a15df44218be82bc9b15a4440f8801e2071f0741933f5506f85e8f8714886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderConfig",
    jsii_struct_bases=[_cdktf_9a9027ec.TerraformMetaArguments],
    name_mapping={
        "connection": "connection",
        "count": "count",
        "depends_on": "dependsOn",
        "for_each": "forEach",
        "lifecycle": "lifecycle",
        "provider": "provider",
        "provisioners": "provisioners",
        "id": "id",
        "rules_v20230105": "rulesV20230105",
        "rules_v20230530": "rulesV20230530",
        "rules_v20230920": "rulesV20230920",
        "rules_v20231030": "rulesV20231030",
        "rules_v20240109": "rulesV20240109",
    },
)
class DataAkamaiPropertyRulesBuilderConfig(_cdktf_9a9027ec.TerraformMetaArguments):
    def __init__(
        self,
        *,
        connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
        count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
        depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
        for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
        lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
        provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
        provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
        id: typing.Optional[builtins.str] = None,
        rules_v20230105: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20230530: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20230920: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20231030: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030", typing.Dict[builtins.str, typing.Any]]] = None,
        rules_v20240109: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param connection: 
        :param count: 
        :param depends_on: 
        :param for_each: 
        :param lifecycle: 
        :param provider: 
        :param provisioners: 
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param rules_v20230105: rules_v2023_01_05 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_01_05 DataAkamaiPropertyRulesBuilder#rules_v2023_01_05}
        :param rules_v20230530: rules_v2023_05_30 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_05_30 DataAkamaiPropertyRulesBuilder#rules_v2023_05_30}
        :param rules_v20230920: rules_v2023_09_20 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_09_20 DataAkamaiPropertyRulesBuilder#rules_v2023_09_20}
        :param rules_v20231030: rules_v2023_10_30 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_10_30 DataAkamaiPropertyRulesBuilder#rules_v2023_10_30}
        :param rules_v20240109: rules_v2024_01_09 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2024_01_09 DataAkamaiPropertyRulesBuilder#rules_v2024_01_09}
        '''
        if isinstance(lifecycle, dict):
            lifecycle = _cdktf_9a9027ec.TerraformResourceLifecycle(**lifecycle)
        if isinstance(rules_v20230105, dict):
            rules_v20230105 = DataAkamaiPropertyRulesBuilderRulesV20230105(**rules_v20230105)
        if isinstance(rules_v20230530, dict):
            rules_v20230530 = DataAkamaiPropertyRulesBuilderRulesV20230530(**rules_v20230530)
        if isinstance(rules_v20230920, dict):
            rules_v20230920 = DataAkamaiPropertyRulesBuilderRulesV20230920(**rules_v20230920)
        if isinstance(rules_v20231030, dict):
            rules_v20231030 = DataAkamaiPropertyRulesBuilderRulesV20231030(**rules_v20231030)
        if isinstance(rules_v20240109, dict):
            rules_v20240109 = DataAkamaiPropertyRulesBuilderRulesV20240109(**rules_v20240109)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4364c214ff2336fcb6b1f39fda7db8f63abea2d1664b5a431bfe2a4fb66b67b0)
            check_type(argname="argument connection", value=connection, expected_type=type_hints["connection"])
            check_type(argname="argument count", value=count, expected_type=type_hints["count"])
            check_type(argname="argument depends_on", value=depends_on, expected_type=type_hints["depends_on"])
            check_type(argname="argument for_each", value=for_each, expected_type=type_hints["for_each"])
            check_type(argname="argument lifecycle", value=lifecycle, expected_type=type_hints["lifecycle"])
            check_type(argname="argument provider", value=provider, expected_type=type_hints["provider"])
            check_type(argname="argument provisioners", value=provisioners, expected_type=type_hints["provisioners"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument rules_v20230105", value=rules_v20230105, expected_type=type_hints["rules_v20230105"])
            check_type(argname="argument rules_v20230530", value=rules_v20230530, expected_type=type_hints["rules_v20230530"])
            check_type(argname="argument rules_v20230920", value=rules_v20230920, expected_type=type_hints["rules_v20230920"])
            check_type(argname="argument rules_v20231030", value=rules_v20231030, expected_type=type_hints["rules_v20231030"])
            check_type(argname="argument rules_v20240109", value=rules_v20240109, expected_type=type_hints["rules_v20240109"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if connection is not None:
            self._values["connection"] = connection
        if count is not None:
            self._values["count"] = count
        if depends_on is not None:
            self._values["depends_on"] = depends_on
        if for_each is not None:
            self._values["for_each"] = for_each
        if lifecycle is not None:
            self._values["lifecycle"] = lifecycle
        if provider is not None:
            self._values["provider"] = provider
        if provisioners is not None:
            self._values["provisioners"] = provisioners
        if id is not None:
            self._values["id"] = id
        if rules_v20230105 is not None:
            self._values["rules_v20230105"] = rules_v20230105
        if rules_v20230530 is not None:
            self._values["rules_v20230530"] = rules_v20230530
        if rules_v20230920 is not None:
            self._values["rules_v20230920"] = rules_v20230920
        if rules_v20231030 is not None:
            self._values["rules_v20231030"] = rules_v20231030
        if rules_v20240109 is not None:
            self._values["rules_v20240109"] = rules_v20240109

    @builtins.property
    def connection(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, _cdktf_9a9027ec.WinrmProvisionerConnection]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("connection")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, _cdktf_9a9027ec.WinrmProvisionerConnection]], result)

    @builtins.property
    def count(
        self,
    ) -> typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("count")
        return typing.cast(typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]], result)

    @builtins.property
    def depends_on(
        self,
    ) -> typing.Optional[typing.List[_cdktf_9a9027ec.ITerraformDependable]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("depends_on")
        return typing.cast(typing.Optional[typing.List[_cdktf_9a9027ec.ITerraformDependable]], result)

    @builtins.property
    def for_each(self) -> typing.Optional[_cdktf_9a9027ec.ITerraformIterator]:
        '''
        :stability: experimental
        '''
        result = self._values.get("for_each")
        return typing.cast(typing.Optional[_cdktf_9a9027ec.ITerraformIterator], result)

    @builtins.property
    def lifecycle(self) -> typing.Optional[_cdktf_9a9027ec.TerraformResourceLifecycle]:
        '''
        :stability: experimental
        '''
        result = self._values.get("lifecycle")
        return typing.cast(typing.Optional[_cdktf_9a9027ec.TerraformResourceLifecycle], result)

    @builtins.property
    def provider(self) -> typing.Optional[_cdktf_9a9027ec.TerraformProvider]:
        '''
        :stability: experimental
        '''
        result = self._values.get("provider")
        return typing.cast(typing.Optional[_cdktf_9a9027ec.TerraformProvider], result)

    @builtins.property
    def provisioners(
        self,
    ) -> typing.Optional[typing.List[typing.Union[_cdktf_9a9027ec.FileProvisioner, _cdktf_9a9027ec.LocalExecProvisioner, _cdktf_9a9027ec.RemoteExecProvisioner]]]:
        '''
        :stability: experimental
        '''
        result = self._values.get("provisioners")
        return typing.cast(typing.Optional[typing.List[typing.Union[_cdktf_9a9027ec.FileProvisioner, _cdktf_9a9027ec.LocalExecProvisioner, _cdktf_9a9027ec.RemoteExecProvisioner]]], result)

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rules_v20230105(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105"]:
        '''rules_v2023_01_05 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_01_05 DataAkamaiPropertyRulesBuilder#rules_v2023_01_05}
        '''
        result = self._values.get("rules_v20230105")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105"], result)

    @builtins.property
    def rules_v20230530(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530"]:
        '''rules_v2023_05_30 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_05_30 DataAkamaiPropertyRulesBuilder#rules_v2023_05_30}
        '''
        result = self._values.get("rules_v20230530")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530"], result)

    @builtins.property
    def rules_v20230920(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920"]:
        '''rules_v2023_09_20 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_09_20 DataAkamaiPropertyRulesBuilder#rules_v2023_09_20}
        '''
        result = self._values.get("rules_v20230920")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920"], result)

    @builtins.property
    def rules_v20231030(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030"]:
        '''rules_v2023_10_30 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2023_10_30 DataAkamaiPropertyRulesBuilder#rules_v2023_10_30}
        '''
        result = self._values.get("rules_v20231030")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030"], result)

    @builtins.property
    def rules_v20240109(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109"]:
        '''rules_v2024_01_09 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rules_v2024_01_09 DataAkamaiPropertyRulesBuilder#rules_v2024_01_09}
        '''
        result = self._values.get("rules_v20240109")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105",
    jsii_struct_bases=[],
    name_mapping={
        "name": "name",
        "advanced_override": "advancedOverride",
        "behavior": "behavior",
        "children": "children",
        "comments": "comments",
        "criteria_locked": "criteriaLocked",
        "criteria_must_satisfy": "criteriaMustSatisfy",
        "criterion": "criterion",
        "custom_override": "customOverride",
        "is_secure": "isSecure",
        "template_link": "templateLink",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable": "variable",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105:
    def __init__(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        if isinstance(custom_override, dict):
            custom_override = DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride(**custom_override)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17be5f5396b124d2b64da8b5ae7f2c13769f109df146029ddcfccda897ee3bda)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument advanced_override", value=advanced_override, expected_type=type_hints["advanced_override"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument children", value=children, expected_type=type_hints["children"])
            check_type(argname="argument comments", value=comments, expected_type=type_hints["comments"])
            check_type(argname="argument criteria_locked", value=criteria_locked, expected_type=type_hints["criteria_locked"])
            check_type(argname="argument criteria_must_satisfy", value=criteria_must_satisfy, expected_type=type_hints["criteria_must_satisfy"])
            check_type(argname="argument criterion", value=criterion, expected_type=type_hints["criterion"])
            check_type(argname="argument custom_override", value=custom_override, expected_type=type_hints["custom_override"])
            check_type(argname="argument is_secure", value=is_secure, expected_type=type_hints["is_secure"])
            check_type(argname="argument template_link", value=template_link, expected_type=type_hints["template_link"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable", value=variable, expected_type=type_hints["variable"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "name": name,
        }
        if advanced_override is not None:
            self._values["advanced_override"] = advanced_override
        if behavior is not None:
            self._values["behavior"] = behavior
        if children is not None:
            self._values["children"] = children
        if comments is not None:
            self._values["comments"] = comments
        if criteria_locked is not None:
            self._values["criteria_locked"] = criteria_locked
        if criteria_must_satisfy is not None:
            self._values["criteria_must_satisfy"] = criteria_must_satisfy
        if criterion is not None:
            self._values["criterion"] = criterion
        if custom_override is not None:
            self._values["custom_override"] = custom_override
        if is_secure is not None:
            self._values["is_secure"] = is_secure
        if template_link is not None:
            self._values["template_link"] = template_link
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable is not None:
            self._values["variable"] = variable

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def advanced_override(self) -> typing.Optional[builtins.str]:
        '''XML metadata of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        '''
        result = self._values.get("advanced_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Behavior"]]]:
        '''behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Behavior"]]], result)

    @builtins.property
    def children(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of child rules for a particular rule in JSON format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        '''
        result = self._values.get("children")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def comments(self) -> typing.Optional[builtins.str]:
        '''The comments for a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        '''
        result = self._values.get("comments")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criteria_locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether changes to 'criterion' objects are prohibited.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        '''
        result = self._values.get("criteria_locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def criteria_must_satisfy(self) -> typing.Optional[builtins.str]:
        '''States whether 'all' criteria need to match or 'any'.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        '''
        result = self._values.get("criteria_must_satisfy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criterion(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Criterion"]]]:
        '''criterion block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        '''
        result = self._values.get("criterion")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Criterion"]]], result)

    @builtins.property
    def custom_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride"]:
        '''custom_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        '''
        result = self._values.get("custom_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride"], result)

    @builtins.property
    def is_secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether a rule is secure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        '''
        result = self._values.get("is_secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_link(self) -> typing.Optional[builtins.str]:
        '''The template link for the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        '''
        result = self._values.get("template_link")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of a rule template.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Variable"]]]:
        '''variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        result = self._values.get("variable")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Variable"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105Behavior",
    jsii_struct_bases=[],
    name_mapping={
        "adaptive_acceleration": "adaptiveAcceleration",
        "adaptive_image_compression": "adaptiveImageCompression",
        "ad_scaler_circuit_breaker": "adScalerCircuitBreaker",
        "advanced": "advanced",
        "aggregated_reporting": "aggregatedReporting",
        "akamaizer": "akamaizer",
        "akamaizer_tag": "akamaizerTag",
        "all_http_in_cache_hierarchy": "allHttpInCacheHierarchy",
        "allow_cloudlets_origins": "allowCloudletsOrigins",
        "allow_delete": "allowDelete",
        "allow_https_cache_key_sharing": "allowHttpsCacheKeySharing",
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_options": "allowOptions",
        "allow_patch": "allowPatch",
        "allow_post": "allowPost",
        "allow_put": "allowPut",
        "allow_transfer_encoding": "allowTransferEncoding",
        "alt_svc_header": "altSvcHeader",
        "api_prioritization": "apiPrioritization",
        "application_load_balancer": "applicationLoadBalancer",
        "audience_segmentation": "audienceSegmentation",
        "auto_domain_validation": "autoDomainValidation",
        "base_directory": "baseDirectory",
        "boss_beaconing": "bossBeaconing",
        "breadcrumbs": "breadcrumbs",
        "break_connection": "breakConnection",
        "brotli": "brotli",
        "cache_error": "cacheError",
        "cache_id": "cacheId",
        "cache_key_ignore_case": "cacheKeyIgnoreCase",
        "cache_key_query_params": "cacheKeyQueryParams",
        "cache_key_rewrite": "cacheKeyRewrite",
        "cache_post": "cachePost",
        "cache_redirect": "cacheRedirect",
        "cache_tag": "cacheTag",
        "cache_tag_visible": "cacheTagVisible",
        "caching": "caching",
        "central_authorization": "centralAuthorization",
        "chase_redirects": "chaseRedirects",
        "client_characteristics": "clientCharacteristics",
        "cloud_interconnects": "cloudInterconnects",
        "cloud_wrapper": "cloudWrapper",
        "cloud_wrapper_advanced": "cloudWrapperAdvanced",
        "conditional_origin": "conditionalOrigin",
        "construct_response": "constructResponse",
        "content_characteristics": "contentCharacteristics",
        "content_characteristics_amd": "contentCharacteristicsAmd",
        "content_characteristics_dd": "contentCharacteristicsDd",
        "content_characteristics_wsd_large_file": "contentCharacteristicsWsdLargeFile",
        "content_characteristics_wsd_live": "contentCharacteristicsWsdLive",
        "content_characteristics_wsd_vod": "contentCharacteristicsWsdVod",
        "content_pre_position": "contentPrePosition",
        "content_targeting_protection": "contentTargetingProtection",
        "cors_support": "corsSupport",
        "cp_code": "cpCode",
        "custom_behavior": "customBehavior",
        "datastream": "datastream",
        "dcp": "dcp",
        "dcp_auth_hmac_transformation": "dcpAuthHmacTransformation",
        "dcp_auth_regex_transformation": "dcpAuthRegexTransformation",
        "dcp_auth_substring_transformation": "dcpAuthSubstringTransformation",
        "dcp_auth_variable_extractor": "dcpAuthVariableExtractor",
        "dcp_default_authz_groups": "dcpDefaultAuthzGroups",
        "dcp_dev_relations": "dcpDevRelations",
        "dcp_real_time_auth": "dcpRealTimeAuth",
        "delivery_receipt": "deliveryReceipt",
        "deny_access": "denyAccess",
        "deny_direct_failover_access": "denyDirectFailoverAccess",
        "device_characteristic_cache_id": "deviceCharacteristicCacheId",
        "device_characteristic_header": "deviceCharacteristicHeader",
        "dns_async_refresh": "dnsAsyncRefresh",
        "dns_prefresh": "dnsPrefresh",
        "downgrade_protocol": "downgradeProtocol",
        "download_complete_marker": "downloadCompleteMarker",
        "download_notification": "downloadNotification",
        "downstream_cache": "downstreamCache",
        "dynamic_throughtput_optimization": "dynamicThroughtputOptimization",
        "dynamic_throughtput_optimization_override": "dynamicThroughtputOptimizationOverride",
        "dynamic_web_content": "dynamicWebContent",
        "ecms_bulk_upload": "ecmsBulkUpload",
        "ecms_database": "ecmsDatabase",
        "ecms_dataset": "ecmsDataset",
        "ecms_object_key": "ecmsObjectKey",
        "edge_connect": "edgeConnect",
        "edge_load_balancing_advanced": "edgeLoadBalancingAdvanced",
        "edge_load_balancing_data_center": "edgeLoadBalancingDataCenter",
        "edge_load_balancing_origin": "edgeLoadBalancingOrigin",
        "edge_origin_authorization": "edgeOriginAuthorization",
        "edge_redirector": "edgeRedirector",
        "edge_scape": "edgeScape",
        "edge_side_includes": "edgeSideIncludes",
        "edge_worker": "edgeWorker",
        "enhanced_akamai_protocol": "enhancedAkamaiProtocol",
        "enhanced_proxy_detection": "enhancedProxyDetection",
        "epd_forward_header_enrichment": "epdForwardHeaderEnrichment",
        "fail_action": "failAction",
        "failover_bot_manager_feature_compatibility": "failoverBotManagerFeatureCompatibility",
        "fast_invalidate": "fastInvalidate",
        "first_party_marketing": "firstPartyMarketing",
        "first_party_marketing_plus": "firstPartyMarketingPlus",
        "forward_rewrite": "forwardRewrite",
        "front_end_optimization": "frontEndOptimization",
        "g2_oheader": "g2Oheader",
        "global_request_number": "globalRequestNumber",
        "graphql_caching": "graphqlCaching",
        "gzip_response": "gzipResponse",
        "hd_data_advanced": "hdDataAdvanced",
        "health_detection": "healthDetection",
        "hsaf_eip_binding": "hsafEipBinding",
        "http2": "http2",
        "http3": "http3",
        "http_strict_transport_security": "httpStrictTransportSecurity",
        "http_to_https_upgrade": "httpToHttpsUpgrade",
        "image_and_video_manager": "imageAndVideoManager",
        "image_manager": "imageManager",
        "image_manager_video": "imageManagerVideo",
        "im_override": "imOverride",
        "include": "include",
        "input_validation": "inputValidation",
        "instant": "instant",
        "instant_config": "instantConfig",
        "large_file_optimization": "largeFileOptimization",
        "large_file_optimization_advanced": "largeFileOptimizationAdvanced",
        "limit_bit_rate": "limitBitRate",
        "log_custom": "logCustom",
        "manifest_personalization": "manifestPersonalization",
        "manifest_rerouting": "manifestRerouting",
        "manual_server_push": "manualServerPush",
        "media_acceleration": "mediaAcceleration",
        "media_acceleration_quic_optout": "mediaAccelerationQuicOptout",
        "media_client": "mediaClient",
        "media_file_retrieval_optimization": "mediaFileRetrievalOptimization",
        "media_origin_failover": "mediaOriginFailover",
        "metadata_caching": "metadataCaching",
        "mobile_sdk_performance": "mobileSdkPerformance",
        "modify_incoming_request_header": "modifyIncomingRequestHeader",
        "modify_incoming_response_header": "modifyIncomingResponseHeader",
        "modify_outgoing_request_header": "modifyOutgoingRequestHeader",
        "modify_outgoing_response_header": "modifyOutgoingResponseHeader",
        "modify_via_header": "modifyViaHeader",
        "m_pulse": "mPulse",
        "origin": "origin",
        "origin_characteristics": "originCharacteristics",
        "origin_characteristics_wsd": "originCharacteristicsWsd",
        "origin_failure_recovery_method": "originFailureRecoveryMethod",
        "origin_failure_recovery_policy": "originFailureRecoveryPolicy",
        "origin_ip_acl": "originIpAcl",
        "persistent_client_connection": "persistentClientConnection",
        "persistent_connection": "persistentConnection",
        "personally_identifiable_information": "personallyIdentifiableInformation",
        "phased_release": "phasedRelease",
        "preconnect": "preconnect",
        "predictive_content_delivery": "predictiveContentDelivery",
        "predictive_prefetching": "predictivePrefetching",
        "prefetch": "prefetch",
        "prefetchable": "prefetchable",
        "prefresh_cache": "prefreshCache",
        "quality": "quality",
        "quic_beta": "quicBeta",
        "random_seek": "randomSeek",
        "rapid": "rapid",
        "read_timeout": "readTimeout",
        "real_time_reporting": "realTimeReporting",
        "real_user_monitoring": "realUserMonitoring",
        "redirect": "redirect",
        "redirectplus": "redirectplus",
        "referer_checking": "refererChecking",
        "remove_query_parameter": "removeQueryParameter",
        "remove_vary": "removeVary",
        "report": "report",
        "request_control": "requestControl",
        "request_type_marker": "requestTypeMarker",
        "resource_optimizer": "resourceOptimizer",
        "resource_optimizer_extended_compatibility": "resourceOptimizerExtendedCompatibility",
        "response_code": "responseCode",
        "response_cookie": "responseCookie",
        "restrict_object_caching": "restrictObjectCaching",
        "return_cache_status": "returnCacheStatus",
        "rewrite_url": "rewriteUrl",
        "rum_custom": "rumCustom",
        "saas_definitions": "saasDefinitions",
        "sales_force_commerce_cloud_client": "salesForceCommerceCloudClient",
        "sales_force_commerce_cloud_provider": "salesForceCommerceCloudProvider",
        "sales_force_commerce_cloud_provider_host_header": "salesForceCommerceCloudProviderHostHeader",
        "save_post_dca_processing": "savePostDcaProcessing",
        "schedule_invalidation": "scheduleInvalidation",
        "script_management": "scriptManagement",
        "segmented_content_protection": "segmentedContentProtection",
        "segmented_media_optimization": "segmentedMediaOptimization",
        "segmented_media_streaming_prefetch": "segmentedMediaStreamingPrefetch",
        "set_variable": "setVariable",
        "shutr": "shutr",
        "simulate_error_code": "simulateErrorCode",
        "site_shield": "siteShield",
        "standard_tls_migration": "standardTlsMigration",
        "standard_tls_migration_override": "standardTlsMigrationOverride",
        "strict_header_parsing": "strictHeaderParsing",
        "sub_customer": "subCustomer",
        "sure_route": "sureRoute",
        "tcp_optimization": "tcpOptimization",
        "tea_leaf": "teaLeaf",
        "tiered_distribution": "tieredDistribution",
        "tiered_distribution_advanced": "tieredDistributionAdvanced",
        "tiered_distribution_customization": "tieredDistributionCustomization",
        "timeout": "timeout",
        "uid_configuration": "uidConfiguration",
        "validate_entity_tag": "validateEntityTag",
        "verify_json_web_token": "verifyJsonWebToken",
        "verify_json_web_token_for_dcp": "verifyJsonWebTokenForDcp",
        "verify_token_authorization": "verifyTokenAuthorization",
        "virtual_waiting_room": "virtualWaitingRoom",
        "virtual_waiting_room_with_edge_workers": "virtualWaitingRoomWithEdgeWorkers",
        "visitor_prioritization": "visitorPrioritization",
        "visitor_prioritization_fifo": "visitorPrioritizationFifo",
        "visitor_prioritization_fifo_standalone": "visitorPrioritizationFifoStandalone",
        "watermarking": "watermarking",
        "web_application_firewall": "webApplicationFirewall",
        "webdav": "webdav",
        "web_sockets": "webSockets",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105Behavior:
    def __init__(
        self,
        *,
        adaptive_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        adaptive_image_compression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression", typing.Dict[builtins.str, typing.Any]]] = None,
        ad_scaler_circuit_breaker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker", typing.Dict[builtins.str, typing.Any]]] = None,
        advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        aggregated_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag", typing.Dict[builtins.str, typing.Any]]] = None,
        all_http_in_cache_hierarchy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_cloudlets_origins: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_delete: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_cache_key_sharing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_downgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_options: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_patch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_put: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_transfer_encoding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding", typing.Dict[builtins.str, typing.Any]]] = None,
        alt_svc_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        api_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        application_load_balancer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer", typing.Dict[builtins.str, typing.Any]]] = None,
        audience_segmentation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation", typing.Dict[builtins.str, typing.Any]]] = None,
        auto_domain_validation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation", typing.Dict[builtins.str, typing.Any]]] = None,
        base_directory: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory", typing.Dict[builtins.str, typing.Any]]] = None,
        boss_beaconing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing", typing.Dict[builtins.str, typing.Any]]] = None,
        breadcrumbs: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs", typing.Dict[builtins.str, typing.Any]]] = None,
        break_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        brotli: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_ignore_case: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_query_params: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag_visible: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible", typing.Dict[builtins.str, typing.Any]]] = None,
        caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        central_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        chase_redirects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects", typing.Dict[builtins.str, typing.Any]]] = None,
        client_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_interconnects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        conditional_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        construct_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_amd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_dd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_large_file: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_live: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_vod: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod", typing.Dict[builtins.str, typing.Any]]] = None,
        content_pre_position: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition", typing.Dict[builtins.str, typing.Any]]] = None,
        content_targeting_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        cors_support: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        custom_behavior: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior", typing.Dict[builtins.str, typing.Any]]] = None,
        datastream: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_hmac_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_regex_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_substring_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_variable_extractor: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_default_authz_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_dev_relations: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_real_time_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        delivery_receipt: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_direct_failover_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_async_refresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_prefresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        downgrade_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        download_complete_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        download_notification: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification", typing.Dict[builtins.str, typing.Any]]] = None,
        downstream_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_web_content: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_bulk_upload: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_database: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_dataset: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_object_key: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_connect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_data_center: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_origin_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_redirector: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_scape: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_side_includes: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_worker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_akamai_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_proxy_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        epd_forward_header_enrichment: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment", typing.Dict[builtins.str, typing.Any]]] = None,
        fail_action: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction", typing.Dict[builtins.str, typing.Any]]] = None,
        failover_bot_manager_feature_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        fast_invalidate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing_plus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus", typing.Dict[builtins.str, typing.Any]]] = None,
        forward_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        front_end_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        g2_oheader: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader", typing.Dict[builtins.str, typing.Any]]] = None,
        global_request_number: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber", typing.Dict[builtins.str, typing.Any]]] = None,
        graphql_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        gzip_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        hd_data_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        health_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        hsaf_eip_binding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding", typing.Dict[builtins.str, typing.Any]]] = None,
        http2: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2", typing.Dict[builtins.str, typing.Any]]] = None,
        http3: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3", typing.Dict[builtins.str, typing.Any]]] = None,
        http_strict_transport_security: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity", typing.Dict[builtins.str, typing.Any]]] = None,
        http_to_https_upgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade", typing.Dict[builtins.str, typing.Any]]] = None,
        image_and_video_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager_video: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo", typing.Dict[builtins.str, typing.Any]]] = None,
        im_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        include: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude", typing.Dict[builtins.str, typing.Any]]] = None,
        input_validation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation", typing.Dict[builtins.str, typing.Any]]] = None,
        instant: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant", typing.Dict[builtins.str, typing.Any]]] = None,
        instant_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        limit_bit_rate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate", typing.Dict[builtins.str, typing.Any]]] = None,
        log_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_personalization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_rerouting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting", typing.Dict[builtins.str, typing.Any]]] = None,
        manual_server_push: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration_quic_optout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout", typing.Dict[builtins.str, typing.Any]]] = None,
        media_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient", typing.Dict[builtins.str, typing.Any]]] = None,
        media_file_retrieval_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        media_origin_failover: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        mobile_sdk_performance: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_via_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        m_pulse: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse", typing.Dict[builtins.str, typing.Any]]] = None,
        origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics_wsd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_ip_acl: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_client_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        personally_identifiable_information: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation", typing.Dict[builtins.str, typing.Any]]] = None,
        phased_release: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease", typing.Dict[builtins.str, typing.Any]]] = None,
        preconnect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_content_delivery: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_prefetching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetchable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable", typing.Dict[builtins.str, typing.Any]]] = None,
        prefresh_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache", typing.Dict[builtins.str, typing.Any]]] = None,
        quality: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality", typing.Dict[builtins.str, typing.Any]]] = None,
        quic_beta: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta", typing.Dict[builtins.str, typing.Any]]] = None,
        random_seek: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek", typing.Dict[builtins.str, typing.Any]]] = None,
        rapid: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid", typing.Dict[builtins.str, typing.Any]]] = None,
        read_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        real_time_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        real_user_monitoring: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring", typing.Dict[builtins.str, typing.Any]]] = None,
        redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        redirectplus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus", typing.Dict[builtins.str, typing.Any]]] = None,
        referer_checking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_query_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_vary: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary", typing.Dict[builtins.str, typing.Any]]] = None,
        report: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport", typing.Dict[builtins.str, typing.Any]]] = None,
        request_control: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer_extended_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        response_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        restrict_object_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        return_cache_status: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus", typing.Dict[builtins.str, typing.Any]]] = None,
        rewrite_url: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl", typing.Dict[builtins.str, typing.Any]]] = None,
        rum_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        saas_definitions: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        save_post_dca_processing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing", typing.Dict[builtins.str, typing.Any]]] = None,
        schedule_invalidation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation", typing.Dict[builtins.str, typing.Any]]] = None,
        script_management: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_content_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_streaming_prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        set_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        shutr: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr", typing.Dict[builtins.str, typing.Any]]] = None,
        simulate_error_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode", typing.Dict[builtins.str, typing.Any]]] = None,
        site_shield: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        strict_header_parsing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing", typing.Dict[builtins.str, typing.Any]]] = None,
        sub_customer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer", typing.Dict[builtins.str, typing.Any]]] = None,
        sure_route: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute", typing.Dict[builtins.str, typing.Any]]] = None,
        tcp_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        tea_leaf: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_customization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization", typing.Dict[builtins.str, typing.Any]]] = None,
        timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        uid_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        validate_entity_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token_for_dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo_standalone: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone", typing.Dict[builtins.str, typing.Any]]] = None,
        watermarking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking", typing.Dict[builtins.str, typing.Any]]] = None,
        web_application_firewall: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall", typing.Dict[builtins.str, typing.Any]]] = None,
        webdav: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav", typing.Dict[builtins.str, typing.Any]]] = None,
        web_sockets: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param adaptive_acceleration: adaptive_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        :param adaptive_image_compression: adaptive_image_compression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        :param ad_scaler_circuit_breaker: ad_scaler_circuit_breaker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        :param advanced: advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param aggregated_reporting: aggregated_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        :param akamaizer: akamaizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        :param akamaizer_tag: akamaizer_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        :param all_http_in_cache_hierarchy: all_http_in_cache_hierarchy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        :param allow_cloudlets_origins: allow_cloudlets_origins block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        :param allow_delete: allow_delete block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        :param allow_https_cache_key_sharing: allow_https_cache_key_sharing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        :param allow_https_downgrade: allow_https_downgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_options: allow_options block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        :param allow_patch: allow_patch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        :param allow_post: allow_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        :param allow_put: allow_put block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        :param allow_transfer_encoding: allow_transfer_encoding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        :param alt_svc_header: alt_svc_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        :param api_prioritization: api_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        :param application_load_balancer: application_load_balancer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        :param audience_segmentation: audience_segmentation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        :param auto_domain_validation: auto_domain_validation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        :param base_directory: base_directory block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        :param boss_beaconing: boss_beaconing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        :param breadcrumbs: breadcrumbs block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        :param break_connection: break_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        :param brotli: brotli block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        :param cache_error: cache_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        :param cache_id: cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        :param cache_key_ignore_case: cache_key_ignore_case block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        :param cache_key_query_params: cache_key_query_params block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        :param cache_key_rewrite: cache_key_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        :param cache_post: cache_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        :param cache_redirect: cache_redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        :param cache_tag: cache_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        :param cache_tag_visible: cache_tag_visible block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        :param caching: caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param central_authorization: central_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        :param chase_redirects: chase_redirects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        :param client_characteristics: client_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        :param cloud_interconnects: cloud_interconnects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        :param cloud_wrapper: cloud_wrapper block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        :param cloud_wrapper_advanced: cloud_wrapper_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        :param conditional_origin: conditional_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        :param construct_response: construct_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        :param content_characteristics: content_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        :param content_characteristics_amd: content_characteristics_amd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        :param content_characteristics_dd: content_characteristics_dd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        :param content_characteristics_wsd_large_file: content_characteristics_wsd_large_file block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        :param content_characteristics_wsd_live: content_characteristics_wsd_live block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        :param content_characteristics_wsd_vod: content_characteristics_wsd_vod block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        :param content_pre_position: content_pre_position block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        :param content_targeting_protection: content_targeting_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        :param cors_support: cors_support block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param custom_behavior: custom_behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        :param datastream: datastream block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        :param dcp: dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        :param dcp_auth_hmac_transformation: dcp_auth_hmac_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        :param dcp_auth_regex_transformation: dcp_auth_regex_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        :param dcp_auth_substring_transformation: dcp_auth_substring_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        :param dcp_auth_variable_extractor: dcp_auth_variable_extractor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        :param dcp_default_authz_groups: dcp_default_authz_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        :param dcp_dev_relations: dcp_dev_relations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        :param dcp_real_time_auth: dcp_real_time_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        :param delivery_receipt: delivery_receipt block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        :param deny_access: deny_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        :param deny_direct_failover_access: deny_direct_failover_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        :param device_characteristic_cache_id: device_characteristic_cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        :param device_characteristic_header: device_characteristic_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        :param dns_async_refresh: dns_async_refresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        :param dns_prefresh: dns_prefresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        :param downgrade_protocol: downgrade_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        :param download_complete_marker: download_complete_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        :param download_notification: download_notification block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        :param downstream_cache: downstream_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        :param dynamic_throughtput_optimization: dynamic_throughtput_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        :param dynamic_throughtput_optimization_override: dynamic_throughtput_optimization_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        :param dynamic_web_content: dynamic_web_content block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param ecms_bulk_upload: ecms_bulk_upload block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        :param ecms_database: ecms_database block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        :param ecms_dataset: ecms_dataset block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        :param ecms_object_key: ecms_object_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        :param edge_connect: edge_connect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        :param edge_load_balancing_advanced: edge_load_balancing_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        :param edge_load_balancing_data_center: edge_load_balancing_data_center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        :param edge_load_balancing_origin: edge_load_balancing_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        :param edge_origin_authorization: edge_origin_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        :param edge_redirector: edge_redirector block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        :param edge_scape: edge_scape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        :param edge_side_includes: edge_side_includes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        :param edge_worker: edge_worker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        :param enhanced_akamai_protocol: enhanced_akamai_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        :param enhanced_proxy_detection: enhanced_proxy_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        :param epd_forward_header_enrichment: epd_forward_header_enrichment block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        :param fail_action: fail_action block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        :param failover_bot_manager_feature_compatibility: failover_bot_manager_feature_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        :param fast_invalidate: fast_invalidate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        :param first_party_marketing: first_party_marketing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        :param first_party_marketing_plus: first_party_marketing_plus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        :param forward_rewrite: forward_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        :param front_end_optimization: front_end_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#front_end_optimization DataAkamaiPropertyRulesBuilder#front_end_optimization}
        :param g2_oheader: g2oheader block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        :param global_request_number: global_request_number block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        :param graphql_caching: graphql_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        :param gzip_response: gzip_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        :param hd_data_advanced: hd_data_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        :param health_detection: health_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        :param hsaf_eip_binding: hsaf_eip_binding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        :param http2: http2 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        :param http3: http3 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        :param http_strict_transport_security: http_strict_transport_security block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        :param http_to_https_upgrade: http_to_https_upgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        :param image_and_video_manager: image_and_video_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        :param image_manager: image_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        :param image_manager_video: image_manager_video block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        :param im_override: im_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        :param include: include block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        :param input_validation: input_validation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#input_validation DataAkamaiPropertyRulesBuilder#input_validation}
        :param instant: instant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        :param instant_config: instant_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        :param large_file_optimization: large_file_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        :param large_file_optimization_advanced: large_file_optimization_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        :param limit_bit_rate: limit_bit_rate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        :param log_custom: log_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        :param manifest_personalization: manifest_personalization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        :param manifest_rerouting: manifest_rerouting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        :param manual_server_push: manual_server_push block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        :param media_acceleration: media_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        :param media_acceleration_quic_optout: media_acceleration_quic_optout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        :param media_client: media_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        :param media_file_retrieval_optimization: media_file_retrieval_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        :param media_origin_failover: media_origin_failover block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        :param metadata_caching: metadata_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        :param mobile_sdk_performance: mobile_sdk_performance block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        :param modify_incoming_request_header: modify_incoming_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        :param modify_incoming_response_header: modify_incoming_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        :param modify_outgoing_request_header: modify_outgoing_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        :param modify_outgoing_response_header: modify_outgoing_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        :param modify_via_header: modify_via_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        :param m_pulse: m_pulse block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param origin: origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param origin_characteristics: origin_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        :param origin_characteristics_wsd: origin_characteristics_wsd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        :param origin_failure_recovery_method: origin_failure_recovery_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        :param origin_failure_recovery_policy: origin_failure_recovery_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        :param origin_ip_acl: origin_ip_acl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        :param persistent_client_connection: persistent_client_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        :param persistent_connection: persistent_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        :param personally_identifiable_information: personally_identifiable_information block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        :param phased_release: phased_release block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        :param preconnect: preconnect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        :param predictive_content_delivery: predictive_content_delivery block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        :param predictive_prefetching: predictive_prefetching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        :param prefetch: prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param prefetchable: prefetchable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        :param prefresh_cache: prefresh_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        :param quality: quality block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        :param quic_beta: quic_beta block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        :param random_seek: random_seek block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        :param rapid: rapid block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        :param read_timeout: read_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        :param real_time_reporting: real_time_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        :param real_user_monitoring: real_user_monitoring block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param redirect: redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirectplus: redirectplus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        :param referer_checking: referer_checking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        :param remove_query_parameter: remove_query_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        :param remove_vary: remove_vary block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        :param report: report block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        :param request_control: request_control block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        :param request_type_marker: request_type_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        :param resource_optimizer: resource_optimizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        :param resource_optimizer_extended_compatibility: resource_optimizer_extended_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        :param response_code: response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param response_cookie: response_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        :param restrict_object_caching: restrict_object_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        :param return_cache_status: return_cache_status block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        :param rewrite_url: rewrite_url block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        :param rum_custom: rum_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        :param saas_definitions: saas_definitions block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        :param sales_force_commerce_cloud_client: sales_force_commerce_cloud_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        :param sales_force_commerce_cloud_provider: sales_force_commerce_cloud_provider block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        :param sales_force_commerce_cloud_provider_host_header: sales_force_commerce_cloud_provider_host_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        :param save_post_dca_processing: save_post_dca_processing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        :param schedule_invalidation: schedule_invalidation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        :param script_management: script_management block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        :param segmented_content_protection: segmented_content_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        :param segmented_media_optimization: segmented_media_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        :param segmented_media_streaming_prefetch: segmented_media_streaming_prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        :param set_variable: set_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        :param shutr: shutr block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#shutr DataAkamaiPropertyRulesBuilder#shutr}
        :param simulate_error_code: simulate_error_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        :param site_shield: site_shield block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        :param standard_tls_migration: standard_tls_migration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        :param standard_tls_migration_override: standard_tls_migration_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        :param strict_header_parsing: strict_header_parsing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        :param sub_customer: sub_customer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        :param sure_route: sure_route block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param tcp_optimization: tcp_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        :param tea_leaf: tea_leaf block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        :param tiered_distribution: tiered_distribution block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        :param tiered_distribution_advanced: tiered_distribution_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        :param tiered_distribution_customization: tiered_distribution_customization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        :param timeout: timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uid_configuration: uid_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        :param validate_entity_tag: validate_entity_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        :param verify_json_web_token: verify_json_web_token block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        :param verify_json_web_token_for_dcp: verify_json_web_token_for_dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        :param verify_token_authorization: verify_token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        :param virtual_waiting_room: virtual_waiting_room block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        :param virtual_waiting_room_with_edge_workers: virtual_waiting_room_with_edge_workers block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        :param visitor_prioritization: visitor_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        :param visitor_prioritization_fifo: visitor_prioritization_fifo block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        :param visitor_prioritization_fifo_standalone: visitor_prioritization_fifo_standalone block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        :param watermarking: watermarking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        :param web_application_firewall: web_application_firewall block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        :param webdav: webdav block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        :param web_sockets: web_sockets block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        if isinstance(adaptive_acceleration, dict):
            adaptive_acceleration = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration(**adaptive_acceleration)
        if isinstance(adaptive_image_compression, dict):
            adaptive_image_compression = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression(**adaptive_image_compression)
        if isinstance(ad_scaler_circuit_breaker, dict):
            ad_scaler_circuit_breaker = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker(**ad_scaler_circuit_breaker)
        if isinstance(advanced, dict):
            advanced = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced(**advanced)
        if isinstance(aggregated_reporting, dict):
            aggregated_reporting = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting(**aggregated_reporting)
        if isinstance(akamaizer, dict):
            akamaizer = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer(**akamaizer)
        if isinstance(akamaizer_tag, dict):
            akamaizer_tag = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag(**akamaizer_tag)
        if isinstance(all_http_in_cache_hierarchy, dict):
            all_http_in_cache_hierarchy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy(**all_http_in_cache_hierarchy)
        if isinstance(allow_cloudlets_origins, dict):
            allow_cloudlets_origins = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins(**allow_cloudlets_origins)
        if isinstance(allow_delete, dict):
            allow_delete = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete(**allow_delete)
        if isinstance(allow_https_cache_key_sharing, dict):
            allow_https_cache_key_sharing = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing(**allow_https_cache_key_sharing)
        if isinstance(allow_https_downgrade, dict):
            allow_https_downgrade = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade(**allow_https_downgrade)
        if isinstance(allow_options, dict):
            allow_options = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions(**allow_options)
        if isinstance(allow_patch, dict):
            allow_patch = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch(**allow_patch)
        if isinstance(allow_post, dict):
            allow_post = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost(**allow_post)
        if isinstance(allow_put, dict):
            allow_put = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut(**allow_put)
        if isinstance(allow_transfer_encoding, dict):
            allow_transfer_encoding = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding(**allow_transfer_encoding)
        if isinstance(alt_svc_header, dict):
            alt_svc_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader(**alt_svc_header)
        if isinstance(api_prioritization, dict):
            api_prioritization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization(**api_prioritization)
        if isinstance(application_load_balancer, dict):
            application_load_balancer = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer(**application_load_balancer)
        if isinstance(audience_segmentation, dict):
            audience_segmentation = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation(**audience_segmentation)
        if isinstance(auto_domain_validation, dict):
            auto_domain_validation = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation(**auto_domain_validation)
        if isinstance(base_directory, dict):
            base_directory = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory(**base_directory)
        if isinstance(boss_beaconing, dict):
            boss_beaconing = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing(**boss_beaconing)
        if isinstance(breadcrumbs, dict):
            breadcrumbs = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs(**breadcrumbs)
        if isinstance(break_connection, dict):
            break_connection = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection(**break_connection)
        if isinstance(brotli, dict):
            brotli = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli(**brotli)
        if isinstance(cache_error, dict):
            cache_error = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError(**cache_error)
        if isinstance(cache_id, dict):
            cache_id = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId(**cache_id)
        if isinstance(cache_key_ignore_case, dict):
            cache_key_ignore_case = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase(**cache_key_ignore_case)
        if isinstance(cache_key_query_params, dict):
            cache_key_query_params = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams(**cache_key_query_params)
        if isinstance(cache_key_rewrite, dict):
            cache_key_rewrite = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite(**cache_key_rewrite)
        if isinstance(cache_post, dict):
            cache_post = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost(**cache_post)
        if isinstance(cache_redirect, dict):
            cache_redirect = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect(**cache_redirect)
        if isinstance(cache_tag, dict):
            cache_tag = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag(**cache_tag)
        if isinstance(cache_tag_visible, dict):
            cache_tag_visible = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible(**cache_tag_visible)
        if isinstance(caching, dict):
            caching = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching(**caching)
        if isinstance(central_authorization, dict):
            central_authorization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization(**central_authorization)
        if isinstance(chase_redirects, dict):
            chase_redirects = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects(**chase_redirects)
        if isinstance(client_characteristics, dict):
            client_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics(**client_characteristics)
        if isinstance(cloud_interconnects, dict):
            cloud_interconnects = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects(**cloud_interconnects)
        if isinstance(cloud_wrapper, dict):
            cloud_wrapper = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper(**cloud_wrapper)
        if isinstance(cloud_wrapper_advanced, dict):
            cloud_wrapper_advanced = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced(**cloud_wrapper_advanced)
        if isinstance(conditional_origin, dict):
            conditional_origin = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin(**conditional_origin)
        if isinstance(construct_response, dict):
            construct_response = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse(**construct_response)
        if isinstance(content_characteristics, dict):
            content_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics(**content_characteristics)
        if isinstance(content_characteristics_amd, dict):
            content_characteristics_amd = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd(**content_characteristics_amd)
        if isinstance(content_characteristics_dd, dict):
            content_characteristics_dd = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd(**content_characteristics_dd)
        if isinstance(content_characteristics_wsd_large_file, dict):
            content_characteristics_wsd_large_file = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile(**content_characteristics_wsd_large_file)
        if isinstance(content_characteristics_wsd_live, dict):
            content_characteristics_wsd_live = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive(**content_characteristics_wsd_live)
        if isinstance(content_characteristics_wsd_vod, dict):
            content_characteristics_wsd_vod = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod(**content_characteristics_wsd_vod)
        if isinstance(content_pre_position, dict):
            content_pre_position = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition(**content_pre_position)
        if isinstance(content_targeting_protection, dict):
            content_targeting_protection = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection(**content_targeting_protection)
        if isinstance(cors_support, dict):
            cors_support = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport(**cors_support)
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode(**cp_code)
        if isinstance(custom_behavior, dict):
            custom_behavior = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior(**custom_behavior)
        if isinstance(datastream, dict):
            datastream = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream(**datastream)
        if isinstance(dcp, dict):
            dcp = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp(**dcp)
        if isinstance(dcp_auth_hmac_transformation, dict):
            dcp_auth_hmac_transformation = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation(**dcp_auth_hmac_transformation)
        if isinstance(dcp_auth_regex_transformation, dict):
            dcp_auth_regex_transformation = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation(**dcp_auth_regex_transformation)
        if isinstance(dcp_auth_substring_transformation, dict):
            dcp_auth_substring_transformation = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation(**dcp_auth_substring_transformation)
        if isinstance(dcp_auth_variable_extractor, dict):
            dcp_auth_variable_extractor = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor(**dcp_auth_variable_extractor)
        if isinstance(dcp_default_authz_groups, dict):
            dcp_default_authz_groups = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups(**dcp_default_authz_groups)
        if isinstance(dcp_dev_relations, dict):
            dcp_dev_relations = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations(**dcp_dev_relations)
        if isinstance(dcp_real_time_auth, dict):
            dcp_real_time_auth = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth(**dcp_real_time_auth)
        if isinstance(delivery_receipt, dict):
            delivery_receipt = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt(**delivery_receipt)
        if isinstance(deny_access, dict):
            deny_access = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess(**deny_access)
        if isinstance(deny_direct_failover_access, dict):
            deny_direct_failover_access = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess(**deny_direct_failover_access)
        if isinstance(device_characteristic_cache_id, dict):
            device_characteristic_cache_id = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId(**device_characteristic_cache_id)
        if isinstance(device_characteristic_header, dict):
            device_characteristic_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader(**device_characteristic_header)
        if isinstance(dns_async_refresh, dict):
            dns_async_refresh = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh(**dns_async_refresh)
        if isinstance(dns_prefresh, dict):
            dns_prefresh = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh(**dns_prefresh)
        if isinstance(downgrade_protocol, dict):
            downgrade_protocol = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol(**downgrade_protocol)
        if isinstance(download_complete_marker, dict):
            download_complete_marker = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker(**download_complete_marker)
        if isinstance(download_notification, dict):
            download_notification = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification(**download_notification)
        if isinstance(downstream_cache, dict):
            downstream_cache = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache(**downstream_cache)
        if isinstance(dynamic_throughtput_optimization, dict):
            dynamic_throughtput_optimization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization(**dynamic_throughtput_optimization)
        if isinstance(dynamic_throughtput_optimization_override, dict):
            dynamic_throughtput_optimization_override = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride(**dynamic_throughtput_optimization_override)
        if isinstance(dynamic_web_content, dict):
            dynamic_web_content = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent(**dynamic_web_content)
        if isinstance(ecms_bulk_upload, dict):
            ecms_bulk_upload = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload(**ecms_bulk_upload)
        if isinstance(ecms_database, dict):
            ecms_database = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase(**ecms_database)
        if isinstance(ecms_dataset, dict):
            ecms_dataset = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset(**ecms_dataset)
        if isinstance(ecms_object_key, dict):
            ecms_object_key = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey(**ecms_object_key)
        if isinstance(edge_connect, dict):
            edge_connect = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect(**edge_connect)
        if isinstance(edge_load_balancing_advanced, dict):
            edge_load_balancing_advanced = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced(**edge_load_balancing_advanced)
        if isinstance(edge_load_balancing_data_center, dict):
            edge_load_balancing_data_center = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter(**edge_load_balancing_data_center)
        if isinstance(edge_load_balancing_origin, dict):
            edge_load_balancing_origin = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin(**edge_load_balancing_origin)
        if isinstance(edge_origin_authorization, dict):
            edge_origin_authorization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization(**edge_origin_authorization)
        if isinstance(edge_redirector, dict):
            edge_redirector = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector(**edge_redirector)
        if isinstance(edge_scape, dict):
            edge_scape = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape(**edge_scape)
        if isinstance(edge_side_includes, dict):
            edge_side_includes = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes(**edge_side_includes)
        if isinstance(edge_worker, dict):
            edge_worker = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker(**edge_worker)
        if isinstance(enhanced_akamai_protocol, dict):
            enhanced_akamai_protocol = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol(**enhanced_akamai_protocol)
        if isinstance(enhanced_proxy_detection, dict):
            enhanced_proxy_detection = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection(**enhanced_proxy_detection)
        if isinstance(epd_forward_header_enrichment, dict):
            epd_forward_header_enrichment = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment(**epd_forward_header_enrichment)
        if isinstance(fail_action, dict):
            fail_action = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction(**fail_action)
        if isinstance(failover_bot_manager_feature_compatibility, dict):
            failover_bot_manager_feature_compatibility = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility(**failover_bot_manager_feature_compatibility)
        if isinstance(fast_invalidate, dict):
            fast_invalidate = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate(**fast_invalidate)
        if isinstance(first_party_marketing, dict):
            first_party_marketing = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing(**first_party_marketing)
        if isinstance(first_party_marketing_plus, dict):
            first_party_marketing_plus = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus(**first_party_marketing_plus)
        if isinstance(forward_rewrite, dict):
            forward_rewrite = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite(**forward_rewrite)
        if isinstance(front_end_optimization, dict):
            front_end_optimization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization(**front_end_optimization)
        if isinstance(g2_oheader, dict):
            g2_oheader = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader(**g2_oheader)
        if isinstance(global_request_number, dict):
            global_request_number = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber(**global_request_number)
        if isinstance(graphql_caching, dict):
            graphql_caching = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching(**graphql_caching)
        if isinstance(gzip_response, dict):
            gzip_response = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse(**gzip_response)
        if isinstance(hd_data_advanced, dict):
            hd_data_advanced = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced(**hd_data_advanced)
        if isinstance(health_detection, dict):
            health_detection = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection(**health_detection)
        if isinstance(hsaf_eip_binding, dict):
            hsaf_eip_binding = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding(**hsaf_eip_binding)
        if isinstance(http2, dict):
            http2 = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2(**http2)
        if isinstance(http3, dict):
            http3 = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3(**http3)
        if isinstance(http_strict_transport_security, dict):
            http_strict_transport_security = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity(**http_strict_transport_security)
        if isinstance(http_to_https_upgrade, dict):
            http_to_https_upgrade = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade(**http_to_https_upgrade)
        if isinstance(image_and_video_manager, dict):
            image_and_video_manager = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager(**image_and_video_manager)
        if isinstance(image_manager, dict):
            image_manager = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager(**image_manager)
        if isinstance(image_manager_video, dict):
            image_manager_video = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo(**image_manager_video)
        if isinstance(im_override, dict):
            im_override = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride(**im_override)
        if isinstance(include, dict):
            include = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude(**include)
        if isinstance(input_validation, dict):
            input_validation = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation(**input_validation)
        if isinstance(instant, dict):
            instant = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant(**instant)
        if isinstance(instant_config, dict):
            instant_config = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig(**instant_config)
        if isinstance(large_file_optimization, dict):
            large_file_optimization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization(**large_file_optimization)
        if isinstance(large_file_optimization_advanced, dict):
            large_file_optimization_advanced = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced(**large_file_optimization_advanced)
        if isinstance(limit_bit_rate, dict):
            limit_bit_rate = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate(**limit_bit_rate)
        if isinstance(log_custom, dict):
            log_custom = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom(**log_custom)
        if isinstance(manifest_personalization, dict):
            manifest_personalization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization(**manifest_personalization)
        if isinstance(manifest_rerouting, dict):
            manifest_rerouting = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting(**manifest_rerouting)
        if isinstance(manual_server_push, dict):
            manual_server_push = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush(**manual_server_push)
        if isinstance(media_acceleration, dict):
            media_acceleration = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration(**media_acceleration)
        if isinstance(media_acceleration_quic_optout, dict):
            media_acceleration_quic_optout = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout(**media_acceleration_quic_optout)
        if isinstance(media_client, dict):
            media_client = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient(**media_client)
        if isinstance(media_file_retrieval_optimization, dict):
            media_file_retrieval_optimization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization(**media_file_retrieval_optimization)
        if isinstance(media_origin_failover, dict):
            media_origin_failover = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover(**media_origin_failover)
        if isinstance(metadata_caching, dict):
            metadata_caching = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching(**metadata_caching)
        if isinstance(mobile_sdk_performance, dict):
            mobile_sdk_performance = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance(**mobile_sdk_performance)
        if isinstance(modify_incoming_request_header, dict):
            modify_incoming_request_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader(**modify_incoming_request_header)
        if isinstance(modify_incoming_response_header, dict):
            modify_incoming_response_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader(**modify_incoming_response_header)
        if isinstance(modify_outgoing_request_header, dict):
            modify_outgoing_request_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader(**modify_outgoing_request_header)
        if isinstance(modify_outgoing_response_header, dict):
            modify_outgoing_response_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader(**modify_outgoing_response_header)
        if isinstance(modify_via_header, dict):
            modify_via_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader(**modify_via_header)
        if isinstance(m_pulse, dict):
            m_pulse = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse(**m_pulse)
        if isinstance(origin, dict):
            origin = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin(**origin)
        if isinstance(origin_characteristics, dict):
            origin_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics(**origin_characteristics)
        if isinstance(origin_characteristics_wsd, dict):
            origin_characteristics_wsd = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd(**origin_characteristics_wsd)
        if isinstance(origin_failure_recovery_method, dict):
            origin_failure_recovery_method = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod(**origin_failure_recovery_method)
        if isinstance(origin_failure_recovery_policy, dict):
            origin_failure_recovery_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy(**origin_failure_recovery_policy)
        if isinstance(origin_ip_acl, dict):
            origin_ip_acl = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl(**origin_ip_acl)
        if isinstance(persistent_client_connection, dict):
            persistent_client_connection = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection(**persistent_client_connection)
        if isinstance(persistent_connection, dict):
            persistent_connection = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection(**persistent_connection)
        if isinstance(personally_identifiable_information, dict):
            personally_identifiable_information = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation(**personally_identifiable_information)
        if isinstance(phased_release, dict):
            phased_release = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease(**phased_release)
        if isinstance(preconnect, dict):
            preconnect = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect(**preconnect)
        if isinstance(predictive_content_delivery, dict):
            predictive_content_delivery = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery(**predictive_content_delivery)
        if isinstance(predictive_prefetching, dict):
            predictive_prefetching = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching(**predictive_prefetching)
        if isinstance(prefetch, dict):
            prefetch = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch(**prefetch)
        if isinstance(prefetchable, dict):
            prefetchable = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable(**prefetchable)
        if isinstance(prefresh_cache, dict):
            prefresh_cache = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache(**prefresh_cache)
        if isinstance(quality, dict):
            quality = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality(**quality)
        if isinstance(quic_beta, dict):
            quic_beta = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta(**quic_beta)
        if isinstance(random_seek, dict):
            random_seek = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek(**random_seek)
        if isinstance(rapid, dict):
            rapid = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid(**rapid)
        if isinstance(read_timeout, dict):
            read_timeout = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout(**read_timeout)
        if isinstance(real_time_reporting, dict):
            real_time_reporting = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting(**real_time_reporting)
        if isinstance(real_user_monitoring, dict):
            real_user_monitoring = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring(**real_user_monitoring)
        if isinstance(redirect, dict):
            redirect = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect(**redirect)
        if isinstance(redirectplus, dict):
            redirectplus = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus(**redirectplus)
        if isinstance(referer_checking, dict):
            referer_checking = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking(**referer_checking)
        if isinstance(remove_query_parameter, dict):
            remove_query_parameter = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter(**remove_query_parameter)
        if isinstance(remove_vary, dict):
            remove_vary = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary(**remove_vary)
        if isinstance(report, dict):
            report = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport(**report)
        if isinstance(request_control, dict):
            request_control = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl(**request_control)
        if isinstance(request_type_marker, dict):
            request_type_marker = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker(**request_type_marker)
        if isinstance(resource_optimizer, dict):
            resource_optimizer = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer(**resource_optimizer)
        if isinstance(resource_optimizer_extended_compatibility, dict):
            resource_optimizer_extended_compatibility = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility(**resource_optimizer_extended_compatibility)
        if isinstance(response_code, dict):
            response_code = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode(**response_code)
        if isinstance(response_cookie, dict):
            response_cookie = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie(**response_cookie)
        if isinstance(restrict_object_caching, dict):
            restrict_object_caching = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching(**restrict_object_caching)
        if isinstance(return_cache_status, dict):
            return_cache_status = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus(**return_cache_status)
        if isinstance(rewrite_url, dict):
            rewrite_url = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl(**rewrite_url)
        if isinstance(rum_custom, dict):
            rum_custom = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom(**rum_custom)
        if isinstance(saas_definitions, dict):
            saas_definitions = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions(**saas_definitions)
        if isinstance(sales_force_commerce_cloud_client, dict):
            sales_force_commerce_cloud_client = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient(**sales_force_commerce_cloud_client)
        if isinstance(sales_force_commerce_cloud_provider, dict):
            sales_force_commerce_cloud_provider = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider(**sales_force_commerce_cloud_provider)
        if isinstance(sales_force_commerce_cloud_provider_host_header, dict):
            sales_force_commerce_cloud_provider_host_header = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader(**sales_force_commerce_cloud_provider_host_header)
        if isinstance(save_post_dca_processing, dict):
            save_post_dca_processing = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing(**save_post_dca_processing)
        if isinstance(schedule_invalidation, dict):
            schedule_invalidation = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation(**schedule_invalidation)
        if isinstance(script_management, dict):
            script_management = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement(**script_management)
        if isinstance(segmented_content_protection, dict):
            segmented_content_protection = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection(**segmented_content_protection)
        if isinstance(segmented_media_optimization, dict):
            segmented_media_optimization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization(**segmented_media_optimization)
        if isinstance(segmented_media_streaming_prefetch, dict):
            segmented_media_streaming_prefetch = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch(**segmented_media_streaming_prefetch)
        if isinstance(set_variable, dict):
            set_variable = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable(**set_variable)
        if isinstance(shutr, dict):
            shutr = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr(**shutr)
        if isinstance(simulate_error_code, dict):
            simulate_error_code = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode(**simulate_error_code)
        if isinstance(site_shield, dict):
            site_shield = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield(**site_shield)
        if isinstance(standard_tls_migration, dict):
            standard_tls_migration = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration(**standard_tls_migration)
        if isinstance(standard_tls_migration_override, dict):
            standard_tls_migration_override = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride(**standard_tls_migration_override)
        if isinstance(strict_header_parsing, dict):
            strict_header_parsing = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing(**strict_header_parsing)
        if isinstance(sub_customer, dict):
            sub_customer = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer(**sub_customer)
        if isinstance(sure_route, dict):
            sure_route = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute(**sure_route)
        if isinstance(tcp_optimization, dict):
            tcp_optimization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization(**tcp_optimization)
        if isinstance(tea_leaf, dict):
            tea_leaf = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf(**tea_leaf)
        if isinstance(tiered_distribution, dict):
            tiered_distribution = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution(**tiered_distribution)
        if isinstance(tiered_distribution_advanced, dict):
            tiered_distribution_advanced = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced(**tiered_distribution_advanced)
        if isinstance(tiered_distribution_customization, dict):
            tiered_distribution_customization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization(**tiered_distribution_customization)
        if isinstance(timeout, dict):
            timeout = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout(**timeout)
        if isinstance(uid_configuration, dict):
            uid_configuration = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration(**uid_configuration)
        if isinstance(validate_entity_tag, dict):
            validate_entity_tag = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag(**validate_entity_tag)
        if isinstance(verify_json_web_token, dict):
            verify_json_web_token = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken(**verify_json_web_token)
        if isinstance(verify_json_web_token_for_dcp, dict):
            verify_json_web_token_for_dcp = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp(**verify_json_web_token_for_dcp)
        if isinstance(verify_token_authorization, dict):
            verify_token_authorization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization(**verify_token_authorization)
        if isinstance(virtual_waiting_room, dict):
            virtual_waiting_room = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom(**virtual_waiting_room)
        if isinstance(virtual_waiting_room_with_edge_workers, dict):
            virtual_waiting_room_with_edge_workers = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers(**virtual_waiting_room_with_edge_workers)
        if isinstance(visitor_prioritization, dict):
            visitor_prioritization = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization(**visitor_prioritization)
        if isinstance(visitor_prioritization_fifo, dict):
            visitor_prioritization_fifo = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo(**visitor_prioritization_fifo)
        if isinstance(visitor_prioritization_fifo_standalone, dict):
            visitor_prioritization_fifo_standalone = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone(**visitor_prioritization_fifo_standalone)
        if isinstance(watermarking, dict):
            watermarking = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking(**watermarking)
        if isinstance(web_application_firewall, dict):
            web_application_firewall = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall(**web_application_firewall)
        if isinstance(webdav, dict):
            webdav = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav(**webdav)
        if isinstance(web_sockets, dict):
            web_sockets = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets(**web_sockets)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb55d3d69a2c78038b6a628d86efe34cd24a2671c078bd92bb61972beaf32149)
            check_type(argname="argument adaptive_acceleration", value=adaptive_acceleration, expected_type=type_hints["adaptive_acceleration"])
            check_type(argname="argument adaptive_image_compression", value=adaptive_image_compression, expected_type=type_hints["adaptive_image_compression"])
            check_type(argname="argument ad_scaler_circuit_breaker", value=ad_scaler_circuit_breaker, expected_type=type_hints["ad_scaler_circuit_breaker"])
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument aggregated_reporting", value=aggregated_reporting, expected_type=type_hints["aggregated_reporting"])
            check_type(argname="argument akamaizer", value=akamaizer, expected_type=type_hints["akamaizer"])
            check_type(argname="argument akamaizer_tag", value=akamaizer_tag, expected_type=type_hints["akamaizer_tag"])
            check_type(argname="argument all_http_in_cache_hierarchy", value=all_http_in_cache_hierarchy, expected_type=type_hints["all_http_in_cache_hierarchy"])
            check_type(argname="argument allow_cloudlets_origins", value=allow_cloudlets_origins, expected_type=type_hints["allow_cloudlets_origins"])
            check_type(argname="argument allow_delete", value=allow_delete, expected_type=type_hints["allow_delete"])
            check_type(argname="argument allow_https_cache_key_sharing", value=allow_https_cache_key_sharing, expected_type=type_hints["allow_https_cache_key_sharing"])
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_options", value=allow_options, expected_type=type_hints["allow_options"])
            check_type(argname="argument allow_patch", value=allow_patch, expected_type=type_hints["allow_patch"])
            check_type(argname="argument allow_post", value=allow_post, expected_type=type_hints["allow_post"])
            check_type(argname="argument allow_put", value=allow_put, expected_type=type_hints["allow_put"])
            check_type(argname="argument allow_transfer_encoding", value=allow_transfer_encoding, expected_type=type_hints["allow_transfer_encoding"])
            check_type(argname="argument alt_svc_header", value=alt_svc_header, expected_type=type_hints["alt_svc_header"])
            check_type(argname="argument api_prioritization", value=api_prioritization, expected_type=type_hints["api_prioritization"])
            check_type(argname="argument application_load_balancer", value=application_load_balancer, expected_type=type_hints["application_load_balancer"])
            check_type(argname="argument audience_segmentation", value=audience_segmentation, expected_type=type_hints["audience_segmentation"])
            check_type(argname="argument auto_domain_validation", value=auto_domain_validation, expected_type=type_hints["auto_domain_validation"])
            check_type(argname="argument base_directory", value=base_directory, expected_type=type_hints["base_directory"])
            check_type(argname="argument boss_beaconing", value=boss_beaconing, expected_type=type_hints["boss_beaconing"])
            check_type(argname="argument breadcrumbs", value=breadcrumbs, expected_type=type_hints["breadcrumbs"])
            check_type(argname="argument break_connection", value=break_connection, expected_type=type_hints["break_connection"])
            check_type(argname="argument brotli", value=brotli, expected_type=type_hints["brotli"])
            check_type(argname="argument cache_error", value=cache_error, expected_type=type_hints["cache_error"])
            check_type(argname="argument cache_id", value=cache_id, expected_type=type_hints["cache_id"])
            check_type(argname="argument cache_key_ignore_case", value=cache_key_ignore_case, expected_type=type_hints["cache_key_ignore_case"])
            check_type(argname="argument cache_key_query_params", value=cache_key_query_params, expected_type=type_hints["cache_key_query_params"])
            check_type(argname="argument cache_key_rewrite", value=cache_key_rewrite, expected_type=type_hints["cache_key_rewrite"])
            check_type(argname="argument cache_post", value=cache_post, expected_type=type_hints["cache_post"])
            check_type(argname="argument cache_redirect", value=cache_redirect, expected_type=type_hints["cache_redirect"])
            check_type(argname="argument cache_tag", value=cache_tag, expected_type=type_hints["cache_tag"])
            check_type(argname="argument cache_tag_visible", value=cache_tag_visible, expected_type=type_hints["cache_tag_visible"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument central_authorization", value=central_authorization, expected_type=type_hints["central_authorization"])
            check_type(argname="argument chase_redirects", value=chase_redirects, expected_type=type_hints["chase_redirects"])
            check_type(argname="argument client_characteristics", value=client_characteristics, expected_type=type_hints["client_characteristics"])
            check_type(argname="argument cloud_interconnects", value=cloud_interconnects, expected_type=type_hints["cloud_interconnects"])
            check_type(argname="argument cloud_wrapper", value=cloud_wrapper, expected_type=type_hints["cloud_wrapper"])
            check_type(argname="argument cloud_wrapper_advanced", value=cloud_wrapper_advanced, expected_type=type_hints["cloud_wrapper_advanced"])
            check_type(argname="argument conditional_origin", value=conditional_origin, expected_type=type_hints["conditional_origin"])
            check_type(argname="argument construct_response", value=construct_response, expected_type=type_hints["construct_response"])
            check_type(argname="argument content_characteristics", value=content_characteristics, expected_type=type_hints["content_characteristics"])
            check_type(argname="argument content_characteristics_amd", value=content_characteristics_amd, expected_type=type_hints["content_characteristics_amd"])
            check_type(argname="argument content_characteristics_dd", value=content_characteristics_dd, expected_type=type_hints["content_characteristics_dd"])
            check_type(argname="argument content_characteristics_wsd_large_file", value=content_characteristics_wsd_large_file, expected_type=type_hints["content_characteristics_wsd_large_file"])
            check_type(argname="argument content_characteristics_wsd_live", value=content_characteristics_wsd_live, expected_type=type_hints["content_characteristics_wsd_live"])
            check_type(argname="argument content_characteristics_wsd_vod", value=content_characteristics_wsd_vod, expected_type=type_hints["content_characteristics_wsd_vod"])
            check_type(argname="argument content_pre_position", value=content_pre_position, expected_type=type_hints["content_pre_position"])
            check_type(argname="argument content_targeting_protection", value=content_targeting_protection, expected_type=type_hints["content_targeting_protection"])
            check_type(argname="argument cors_support", value=cors_support, expected_type=type_hints["cors_support"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument custom_behavior", value=custom_behavior, expected_type=type_hints["custom_behavior"])
            check_type(argname="argument datastream", value=datastream, expected_type=type_hints["datastream"])
            check_type(argname="argument dcp", value=dcp, expected_type=type_hints["dcp"])
            check_type(argname="argument dcp_auth_hmac_transformation", value=dcp_auth_hmac_transformation, expected_type=type_hints["dcp_auth_hmac_transformation"])
            check_type(argname="argument dcp_auth_regex_transformation", value=dcp_auth_regex_transformation, expected_type=type_hints["dcp_auth_regex_transformation"])
            check_type(argname="argument dcp_auth_substring_transformation", value=dcp_auth_substring_transformation, expected_type=type_hints["dcp_auth_substring_transformation"])
            check_type(argname="argument dcp_auth_variable_extractor", value=dcp_auth_variable_extractor, expected_type=type_hints["dcp_auth_variable_extractor"])
            check_type(argname="argument dcp_default_authz_groups", value=dcp_default_authz_groups, expected_type=type_hints["dcp_default_authz_groups"])
            check_type(argname="argument dcp_dev_relations", value=dcp_dev_relations, expected_type=type_hints["dcp_dev_relations"])
            check_type(argname="argument dcp_real_time_auth", value=dcp_real_time_auth, expected_type=type_hints["dcp_real_time_auth"])
            check_type(argname="argument delivery_receipt", value=delivery_receipt, expected_type=type_hints["delivery_receipt"])
            check_type(argname="argument deny_access", value=deny_access, expected_type=type_hints["deny_access"])
            check_type(argname="argument deny_direct_failover_access", value=deny_direct_failover_access, expected_type=type_hints["deny_direct_failover_access"])
            check_type(argname="argument device_characteristic_cache_id", value=device_characteristic_cache_id, expected_type=type_hints["device_characteristic_cache_id"])
            check_type(argname="argument device_characteristic_header", value=device_characteristic_header, expected_type=type_hints["device_characteristic_header"])
            check_type(argname="argument dns_async_refresh", value=dns_async_refresh, expected_type=type_hints["dns_async_refresh"])
            check_type(argname="argument dns_prefresh", value=dns_prefresh, expected_type=type_hints["dns_prefresh"])
            check_type(argname="argument downgrade_protocol", value=downgrade_protocol, expected_type=type_hints["downgrade_protocol"])
            check_type(argname="argument download_complete_marker", value=download_complete_marker, expected_type=type_hints["download_complete_marker"])
            check_type(argname="argument download_notification", value=download_notification, expected_type=type_hints["download_notification"])
            check_type(argname="argument downstream_cache", value=downstream_cache, expected_type=type_hints["downstream_cache"])
            check_type(argname="argument dynamic_throughtput_optimization", value=dynamic_throughtput_optimization, expected_type=type_hints["dynamic_throughtput_optimization"])
            check_type(argname="argument dynamic_throughtput_optimization_override", value=dynamic_throughtput_optimization_override, expected_type=type_hints["dynamic_throughtput_optimization_override"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument ecms_bulk_upload", value=ecms_bulk_upload, expected_type=type_hints["ecms_bulk_upload"])
            check_type(argname="argument ecms_database", value=ecms_database, expected_type=type_hints["ecms_database"])
            check_type(argname="argument ecms_dataset", value=ecms_dataset, expected_type=type_hints["ecms_dataset"])
            check_type(argname="argument ecms_object_key", value=ecms_object_key, expected_type=type_hints["ecms_object_key"])
            check_type(argname="argument edge_connect", value=edge_connect, expected_type=type_hints["edge_connect"])
            check_type(argname="argument edge_load_balancing_advanced", value=edge_load_balancing_advanced, expected_type=type_hints["edge_load_balancing_advanced"])
            check_type(argname="argument edge_load_balancing_data_center", value=edge_load_balancing_data_center, expected_type=type_hints["edge_load_balancing_data_center"])
            check_type(argname="argument edge_load_balancing_origin", value=edge_load_balancing_origin, expected_type=type_hints["edge_load_balancing_origin"])
            check_type(argname="argument edge_origin_authorization", value=edge_origin_authorization, expected_type=type_hints["edge_origin_authorization"])
            check_type(argname="argument edge_redirector", value=edge_redirector, expected_type=type_hints["edge_redirector"])
            check_type(argname="argument edge_scape", value=edge_scape, expected_type=type_hints["edge_scape"])
            check_type(argname="argument edge_side_includes", value=edge_side_includes, expected_type=type_hints["edge_side_includes"])
            check_type(argname="argument edge_worker", value=edge_worker, expected_type=type_hints["edge_worker"])
            check_type(argname="argument enhanced_akamai_protocol", value=enhanced_akamai_protocol, expected_type=type_hints["enhanced_akamai_protocol"])
            check_type(argname="argument enhanced_proxy_detection", value=enhanced_proxy_detection, expected_type=type_hints["enhanced_proxy_detection"])
            check_type(argname="argument epd_forward_header_enrichment", value=epd_forward_header_enrichment, expected_type=type_hints["epd_forward_header_enrichment"])
            check_type(argname="argument fail_action", value=fail_action, expected_type=type_hints["fail_action"])
            check_type(argname="argument failover_bot_manager_feature_compatibility", value=failover_bot_manager_feature_compatibility, expected_type=type_hints["failover_bot_manager_feature_compatibility"])
            check_type(argname="argument fast_invalidate", value=fast_invalidate, expected_type=type_hints["fast_invalidate"])
            check_type(argname="argument first_party_marketing", value=first_party_marketing, expected_type=type_hints["first_party_marketing"])
            check_type(argname="argument first_party_marketing_plus", value=first_party_marketing_plus, expected_type=type_hints["first_party_marketing_plus"])
            check_type(argname="argument forward_rewrite", value=forward_rewrite, expected_type=type_hints["forward_rewrite"])
            check_type(argname="argument front_end_optimization", value=front_end_optimization, expected_type=type_hints["front_end_optimization"])
            check_type(argname="argument g2_oheader", value=g2_oheader, expected_type=type_hints["g2_oheader"])
            check_type(argname="argument global_request_number", value=global_request_number, expected_type=type_hints["global_request_number"])
            check_type(argname="argument graphql_caching", value=graphql_caching, expected_type=type_hints["graphql_caching"])
            check_type(argname="argument gzip_response", value=gzip_response, expected_type=type_hints["gzip_response"])
            check_type(argname="argument hd_data_advanced", value=hd_data_advanced, expected_type=type_hints["hd_data_advanced"])
            check_type(argname="argument health_detection", value=health_detection, expected_type=type_hints["health_detection"])
            check_type(argname="argument hsaf_eip_binding", value=hsaf_eip_binding, expected_type=type_hints["hsaf_eip_binding"])
            check_type(argname="argument http2", value=http2, expected_type=type_hints["http2"])
            check_type(argname="argument http3", value=http3, expected_type=type_hints["http3"])
            check_type(argname="argument http_strict_transport_security", value=http_strict_transport_security, expected_type=type_hints["http_strict_transport_security"])
            check_type(argname="argument http_to_https_upgrade", value=http_to_https_upgrade, expected_type=type_hints["http_to_https_upgrade"])
            check_type(argname="argument image_and_video_manager", value=image_and_video_manager, expected_type=type_hints["image_and_video_manager"])
            check_type(argname="argument image_manager", value=image_manager, expected_type=type_hints["image_manager"])
            check_type(argname="argument image_manager_video", value=image_manager_video, expected_type=type_hints["image_manager_video"])
            check_type(argname="argument im_override", value=im_override, expected_type=type_hints["im_override"])
            check_type(argname="argument include", value=include, expected_type=type_hints["include"])
            check_type(argname="argument input_validation", value=input_validation, expected_type=type_hints["input_validation"])
            check_type(argname="argument instant", value=instant, expected_type=type_hints["instant"])
            check_type(argname="argument instant_config", value=instant_config, expected_type=type_hints["instant_config"])
            check_type(argname="argument large_file_optimization", value=large_file_optimization, expected_type=type_hints["large_file_optimization"])
            check_type(argname="argument large_file_optimization_advanced", value=large_file_optimization_advanced, expected_type=type_hints["large_file_optimization_advanced"])
            check_type(argname="argument limit_bit_rate", value=limit_bit_rate, expected_type=type_hints["limit_bit_rate"])
            check_type(argname="argument log_custom", value=log_custom, expected_type=type_hints["log_custom"])
            check_type(argname="argument manifest_personalization", value=manifest_personalization, expected_type=type_hints["manifest_personalization"])
            check_type(argname="argument manifest_rerouting", value=manifest_rerouting, expected_type=type_hints["manifest_rerouting"])
            check_type(argname="argument manual_server_push", value=manual_server_push, expected_type=type_hints["manual_server_push"])
            check_type(argname="argument media_acceleration", value=media_acceleration, expected_type=type_hints["media_acceleration"])
            check_type(argname="argument media_acceleration_quic_optout", value=media_acceleration_quic_optout, expected_type=type_hints["media_acceleration_quic_optout"])
            check_type(argname="argument media_client", value=media_client, expected_type=type_hints["media_client"])
            check_type(argname="argument media_file_retrieval_optimization", value=media_file_retrieval_optimization, expected_type=type_hints["media_file_retrieval_optimization"])
            check_type(argname="argument media_origin_failover", value=media_origin_failover, expected_type=type_hints["media_origin_failover"])
            check_type(argname="argument metadata_caching", value=metadata_caching, expected_type=type_hints["metadata_caching"])
            check_type(argname="argument mobile_sdk_performance", value=mobile_sdk_performance, expected_type=type_hints["mobile_sdk_performance"])
            check_type(argname="argument modify_incoming_request_header", value=modify_incoming_request_header, expected_type=type_hints["modify_incoming_request_header"])
            check_type(argname="argument modify_incoming_response_header", value=modify_incoming_response_header, expected_type=type_hints["modify_incoming_response_header"])
            check_type(argname="argument modify_outgoing_request_header", value=modify_outgoing_request_header, expected_type=type_hints["modify_outgoing_request_header"])
            check_type(argname="argument modify_outgoing_response_header", value=modify_outgoing_response_header, expected_type=type_hints["modify_outgoing_response_header"])
            check_type(argname="argument modify_via_header", value=modify_via_header, expected_type=type_hints["modify_via_header"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument origin_characteristics", value=origin_characteristics, expected_type=type_hints["origin_characteristics"])
            check_type(argname="argument origin_characteristics_wsd", value=origin_characteristics_wsd, expected_type=type_hints["origin_characteristics_wsd"])
            check_type(argname="argument origin_failure_recovery_method", value=origin_failure_recovery_method, expected_type=type_hints["origin_failure_recovery_method"])
            check_type(argname="argument origin_failure_recovery_policy", value=origin_failure_recovery_policy, expected_type=type_hints["origin_failure_recovery_policy"])
            check_type(argname="argument origin_ip_acl", value=origin_ip_acl, expected_type=type_hints["origin_ip_acl"])
            check_type(argname="argument persistent_client_connection", value=persistent_client_connection, expected_type=type_hints["persistent_client_connection"])
            check_type(argname="argument persistent_connection", value=persistent_connection, expected_type=type_hints["persistent_connection"])
            check_type(argname="argument personally_identifiable_information", value=personally_identifiable_information, expected_type=type_hints["personally_identifiable_information"])
            check_type(argname="argument phased_release", value=phased_release, expected_type=type_hints["phased_release"])
            check_type(argname="argument preconnect", value=preconnect, expected_type=type_hints["preconnect"])
            check_type(argname="argument predictive_content_delivery", value=predictive_content_delivery, expected_type=type_hints["predictive_content_delivery"])
            check_type(argname="argument predictive_prefetching", value=predictive_prefetching, expected_type=type_hints["predictive_prefetching"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument prefetchable", value=prefetchable, expected_type=type_hints["prefetchable"])
            check_type(argname="argument prefresh_cache", value=prefresh_cache, expected_type=type_hints["prefresh_cache"])
            check_type(argname="argument quality", value=quality, expected_type=type_hints["quality"])
            check_type(argname="argument quic_beta", value=quic_beta, expected_type=type_hints["quic_beta"])
            check_type(argname="argument random_seek", value=random_seek, expected_type=type_hints["random_seek"])
            check_type(argname="argument rapid", value=rapid, expected_type=type_hints["rapid"])
            check_type(argname="argument read_timeout", value=read_timeout, expected_type=type_hints["read_timeout"])
            check_type(argname="argument real_time_reporting", value=real_time_reporting, expected_type=type_hints["real_time_reporting"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirectplus", value=redirectplus, expected_type=type_hints["redirectplus"])
            check_type(argname="argument referer_checking", value=referer_checking, expected_type=type_hints["referer_checking"])
            check_type(argname="argument remove_query_parameter", value=remove_query_parameter, expected_type=type_hints["remove_query_parameter"])
            check_type(argname="argument remove_vary", value=remove_vary, expected_type=type_hints["remove_vary"])
            check_type(argname="argument report", value=report, expected_type=type_hints["report"])
            check_type(argname="argument request_control", value=request_control, expected_type=type_hints["request_control"])
            check_type(argname="argument request_type_marker", value=request_type_marker, expected_type=type_hints["request_type_marker"])
            check_type(argname="argument resource_optimizer", value=resource_optimizer, expected_type=type_hints["resource_optimizer"])
            check_type(argname="argument resource_optimizer_extended_compatibility", value=resource_optimizer_extended_compatibility, expected_type=type_hints["resource_optimizer_extended_compatibility"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument response_cookie", value=response_cookie, expected_type=type_hints["response_cookie"])
            check_type(argname="argument restrict_object_caching", value=restrict_object_caching, expected_type=type_hints["restrict_object_caching"])
            check_type(argname="argument return_cache_status", value=return_cache_status, expected_type=type_hints["return_cache_status"])
            check_type(argname="argument rewrite_url", value=rewrite_url, expected_type=type_hints["rewrite_url"])
            check_type(argname="argument rum_custom", value=rum_custom, expected_type=type_hints["rum_custom"])
            check_type(argname="argument saas_definitions", value=saas_definitions, expected_type=type_hints["saas_definitions"])
            check_type(argname="argument sales_force_commerce_cloud_client", value=sales_force_commerce_cloud_client, expected_type=type_hints["sales_force_commerce_cloud_client"])
            check_type(argname="argument sales_force_commerce_cloud_provider", value=sales_force_commerce_cloud_provider, expected_type=type_hints["sales_force_commerce_cloud_provider"])
            check_type(argname="argument sales_force_commerce_cloud_provider_host_header", value=sales_force_commerce_cloud_provider_host_header, expected_type=type_hints["sales_force_commerce_cloud_provider_host_header"])
            check_type(argname="argument save_post_dca_processing", value=save_post_dca_processing, expected_type=type_hints["save_post_dca_processing"])
            check_type(argname="argument schedule_invalidation", value=schedule_invalidation, expected_type=type_hints["schedule_invalidation"])
            check_type(argname="argument script_management", value=script_management, expected_type=type_hints["script_management"])
            check_type(argname="argument segmented_content_protection", value=segmented_content_protection, expected_type=type_hints["segmented_content_protection"])
            check_type(argname="argument segmented_media_optimization", value=segmented_media_optimization, expected_type=type_hints["segmented_media_optimization"])
            check_type(argname="argument segmented_media_streaming_prefetch", value=segmented_media_streaming_prefetch, expected_type=type_hints["segmented_media_streaming_prefetch"])
            check_type(argname="argument set_variable", value=set_variable, expected_type=type_hints["set_variable"])
            check_type(argname="argument shutr", value=shutr, expected_type=type_hints["shutr"])
            check_type(argname="argument simulate_error_code", value=simulate_error_code, expected_type=type_hints["simulate_error_code"])
            check_type(argname="argument site_shield", value=site_shield, expected_type=type_hints["site_shield"])
            check_type(argname="argument standard_tls_migration", value=standard_tls_migration, expected_type=type_hints["standard_tls_migration"])
            check_type(argname="argument standard_tls_migration_override", value=standard_tls_migration_override, expected_type=type_hints["standard_tls_migration_override"])
            check_type(argname="argument strict_header_parsing", value=strict_header_parsing, expected_type=type_hints["strict_header_parsing"])
            check_type(argname="argument sub_customer", value=sub_customer, expected_type=type_hints["sub_customer"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument tcp_optimization", value=tcp_optimization, expected_type=type_hints["tcp_optimization"])
            check_type(argname="argument tea_leaf", value=tea_leaf, expected_type=type_hints["tea_leaf"])
            check_type(argname="argument tiered_distribution", value=tiered_distribution, expected_type=type_hints["tiered_distribution"])
            check_type(argname="argument tiered_distribution_advanced", value=tiered_distribution_advanced, expected_type=type_hints["tiered_distribution_advanced"])
            check_type(argname="argument tiered_distribution_customization", value=tiered_distribution_customization, expected_type=type_hints["tiered_distribution_customization"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uid_configuration", value=uid_configuration, expected_type=type_hints["uid_configuration"])
            check_type(argname="argument validate_entity_tag", value=validate_entity_tag, expected_type=type_hints["validate_entity_tag"])
            check_type(argname="argument verify_json_web_token", value=verify_json_web_token, expected_type=type_hints["verify_json_web_token"])
            check_type(argname="argument verify_json_web_token_for_dcp", value=verify_json_web_token_for_dcp, expected_type=type_hints["verify_json_web_token_for_dcp"])
            check_type(argname="argument verify_token_authorization", value=verify_token_authorization, expected_type=type_hints["verify_token_authorization"])
            check_type(argname="argument virtual_waiting_room", value=virtual_waiting_room, expected_type=type_hints["virtual_waiting_room"])
            check_type(argname="argument virtual_waiting_room_with_edge_workers", value=virtual_waiting_room_with_edge_workers, expected_type=type_hints["virtual_waiting_room_with_edge_workers"])
            check_type(argname="argument visitor_prioritization", value=visitor_prioritization, expected_type=type_hints["visitor_prioritization"])
            check_type(argname="argument visitor_prioritization_fifo", value=visitor_prioritization_fifo, expected_type=type_hints["visitor_prioritization_fifo"])
            check_type(argname="argument visitor_prioritization_fifo_standalone", value=visitor_prioritization_fifo_standalone, expected_type=type_hints["visitor_prioritization_fifo_standalone"])
            check_type(argname="argument watermarking", value=watermarking, expected_type=type_hints["watermarking"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
            check_type(argname="argument webdav", value=webdav, expected_type=type_hints["webdav"])
            check_type(argname="argument web_sockets", value=web_sockets, expected_type=type_hints["web_sockets"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if adaptive_acceleration is not None:
            self._values["adaptive_acceleration"] = adaptive_acceleration
        if adaptive_image_compression is not None:
            self._values["adaptive_image_compression"] = adaptive_image_compression
        if ad_scaler_circuit_breaker is not None:
            self._values["ad_scaler_circuit_breaker"] = ad_scaler_circuit_breaker
        if advanced is not None:
            self._values["advanced"] = advanced
        if aggregated_reporting is not None:
            self._values["aggregated_reporting"] = aggregated_reporting
        if akamaizer is not None:
            self._values["akamaizer"] = akamaizer
        if akamaizer_tag is not None:
            self._values["akamaizer_tag"] = akamaizer_tag
        if all_http_in_cache_hierarchy is not None:
            self._values["all_http_in_cache_hierarchy"] = all_http_in_cache_hierarchy
        if allow_cloudlets_origins is not None:
            self._values["allow_cloudlets_origins"] = allow_cloudlets_origins
        if allow_delete is not None:
            self._values["allow_delete"] = allow_delete
        if allow_https_cache_key_sharing is not None:
            self._values["allow_https_cache_key_sharing"] = allow_https_cache_key_sharing
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_options is not None:
            self._values["allow_options"] = allow_options
        if allow_patch is not None:
            self._values["allow_patch"] = allow_patch
        if allow_post is not None:
            self._values["allow_post"] = allow_post
        if allow_put is not None:
            self._values["allow_put"] = allow_put
        if allow_transfer_encoding is not None:
            self._values["allow_transfer_encoding"] = allow_transfer_encoding
        if alt_svc_header is not None:
            self._values["alt_svc_header"] = alt_svc_header
        if api_prioritization is not None:
            self._values["api_prioritization"] = api_prioritization
        if application_load_balancer is not None:
            self._values["application_load_balancer"] = application_load_balancer
        if audience_segmentation is not None:
            self._values["audience_segmentation"] = audience_segmentation
        if auto_domain_validation is not None:
            self._values["auto_domain_validation"] = auto_domain_validation
        if base_directory is not None:
            self._values["base_directory"] = base_directory
        if boss_beaconing is not None:
            self._values["boss_beaconing"] = boss_beaconing
        if breadcrumbs is not None:
            self._values["breadcrumbs"] = breadcrumbs
        if break_connection is not None:
            self._values["break_connection"] = break_connection
        if brotli is not None:
            self._values["brotli"] = brotli
        if cache_error is not None:
            self._values["cache_error"] = cache_error
        if cache_id is not None:
            self._values["cache_id"] = cache_id
        if cache_key_ignore_case is not None:
            self._values["cache_key_ignore_case"] = cache_key_ignore_case
        if cache_key_query_params is not None:
            self._values["cache_key_query_params"] = cache_key_query_params
        if cache_key_rewrite is not None:
            self._values["cache_key_rewrite"] = cache_key_rewrite
        if cache_post is not None:
            self._values["cache_post"] = cache_post
        if cache_redirect is not None:
            self._values["cache_redirect"] = cache_redirect
        if cache_tag is not None:
            self._values["cache_tag"] = cache_tag
        if cache_tag_visible is not None:
            self._values["cache_tag_visible"] = cache_tag_visible
        if caching is not None:
            self._values["caching"] = caching
        if central_authorization is not None:
            self._values["central_authorization"] = central_authorization
        if chase_redirects is not None:
            self._values["chase_redirects"] = chase_redirects
        if client_characteristics is not None:
            self._values["client_characteristics"] = client_characteristics
        if cloud_interconnects is not None:
            self._values["cloud_interconnects"] = cloud_interconnects
        if cloud_wrapper is not None:
            self._values["cloud_wrapper"] = cloud_wrapper
        if cloud_wrapper_advanced is not None:
            self._values["cloud_wrapper_advanced"] = cloud_wrapper_advanced
        if conditional_origin is not None:
            self._values["conditional_origin"] = conditional_origin
        if construct_response is not None:
            self._values["construct_response"] = construct_response
        if content_characteristics is not None:
            self._values["content_characteristics"] = content_characteristics
        if content_characteristics_amd is not None:
            self._values["content_characteristics_amd"] = content_characteristics_amd
        if content_characteristics_dd is not None:
            self._values["content_characteristics_dd"] = content_characteristics_dd
        if content_characteristics_wsd_large_file is not None:
            self._values["content_characteristics_wsd_large_file"] = content_characteristics_wsd_large_file
        if content_characteristics_wsd_live is not None:
            self._values["content_characteristics_wsd_live"] = content_characteristics_wsd_live
        if content_characteristics_wsd_vod is not None:
            self._values["content_characteristics_wsd_vod"] = content_characteristics_wsd_vod
        if content_pre_position is not None:
            self._values["content_pre_position"] = content_pre_position
        if content_targeting_protection is not None:
            self._values["content_targeting_protection"] = content_targeting_protection
        if cors_support is not None:
            self._values["cors_support"] = cors_support
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if custom_behavior is not None:
            self._values["custom_behavior"] = custom_behavior
        if datastream is not None:
            self._values["datastream"] = datastream
        if dcp is not None:
            self._values["dcp"] = dcp
        if dcp_auth_hmac_transformation is not None:
            self._values["dcp_auth_hmac_transformation"] = dcp_auth_hmac_transformation
        if dcp_auth_regex_transformation is not None:
            self._values["dcp_auth_regex_transformation"] = dcp_auth_regex_transformation
        if dcp_auth_substring_transformation is not None:
            self._values["dcp_auth_substring_transformation"] = dcp_auth_substring_transformation
        if dcp_auth_variable_extractor is not None:
            self._values["dcp_auth_variable_extractor"] = dcp_auth_variable_extractor
        if dcp_default_authz_groups is not None:
            self._values["dcp_default_authz_groups"] = dcp_default_authz_groups
        if dcp_dev_relations is not None:
            self._values["dcp_dev_relations"] = dcp_dev_relations
        if dcp_real_time_auth is not None:
            self._values["dcp_real_time_auth"] = dcp_real_time_auth
        if delivery_receipt is not None:
            self._values["delivery_receipt"] = delivery_receipt
        if deny_access is not None:
            self._values["deny_access"] = deny_access
        if deny_direct_failover_access is not None:
            self._values["deny_direct_failover_access"] = deny_direct_failover_access
        if device_characteristic_cache_id is not None:
            self._values["device_characteristic_cache_id"] = device_characteristic_cache_id
        if device_characteristic_header is not None:
            self._values["device_characteristic_header"] = device_characteristic_header
        if dns_async_refresh is not None:
            self._values["dns_async_refresh"] = dns_async_refresh
        if dns_prefresh is not None:
            self._values["dns_prefresh"] = dns_prefresh
        if downgrade_protocol is not None:
            self._values["downgrade_protocol"] = downgrade_protocol
        if download_complete_marker is not None:
            self._values["download_complete_marker"] = download_complete_marker
        if download_notification is not None:
            self._values["download_notification"] = download_notification
        if downstream_cache is not None:
            self._values["downstream_cache"] = downstream_cache
        if dynamic_throughtput_optimization is not None:
            self._values["dynamic_throughtput_optimization"] = dynamic_throughtput_optimization
        if dynamic_throughtput_optimization_override is not None:
            self._values["dynamic_throughtput_optimization_override"] = dynamic_throughtput_optimization_override
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if ecms_bulk_upload is not None:
            self._values["ecms_bulk_upload"] = ecms_bulk_upload
        if ecms_database is not None:
            self._values["ecms_database"] = ecms_database
        if ecms_dataset is not None:
            self._values["ecms_dataset"] = ecms_dataset
        if ecms_object_key is not None:
            self._values["ecms_object_key"] = ecms_object_key
        if edge_connect is not None:
            self._values["edge_connect"] = edge_connect
        if edge_load_balancing_advanced is not None:
            self._values["edge_load_balancing_advanced"] = edge_load_balancing_advanced
        if edge_load_balancing_data_center is not None:
            self._values["edge_load_balancing_data_center"] = edge_load_balancing_data_center
        if edge_load_balancing_origin is not None:
            self._values["edge_load_balancing_origin"] = edge_load_balancing_origin
        if edge_origin_authorization is not None:
            self._values["edge_origin_authorization"] = edge_origin_authorization
        if edge_redirector is not None:
            self._values["edge_redirector"] = edge_redirector
        if edge_scape is not None:
            self._values["edge_scape"] = edge_scape
        if edge_side_includes is not None:
            self._values["edge_side_includes"] = edge_side_includes
        if edge_worker is not None:
            self._values["edge_worker"] = edge_worker
        if enhanced_akamai_protocol is not None:
            self._values["enhanced_akamai_protocol"] = enhanced_akamai_protocol
        if enhanced_proxy_detection is not None:
            self._values["enhanced_proxy_detection"] = enhanced_proxy_detection
        if epd_forward_header_enrichment is not None:
            self._values["epd_forward_header_enrichment"] = epd_forward_header_enrichment
        if fail_action is not None:
            self._values["fail_action"] = fail_action
        if failover_bot_manager_feature_compatibility is not None:
            self._values["failover_bot_manager_feature_compatibility"] = failover_bot_manager_feature_compatibility
        if fast_invalidate is not None:
            self._values["fast_invalidate"] = fast_invalidate
        if first_party_marketing is not None:
            self._values["first_party_marketing"] = first_party_marketing
        if first_party_marketing_plus is not None:
            self._values["first_party_marketing_plus"] = first_party_marketing_plus
        if forward_rewrite is not None:
            self._values["forward_rewrite"] = forward_rewrite
        if front_end_optimization is not None:
            self._values["front_end_optimization"] = front_end_optimization
        if g2_oheader is not None:
            self._values["g2_oheader"] = g2_oheader
        if global_request_number is not None:
            self._values["global_request_number"] = global_request_number
        if graphql_caching is not None:
            self._values["graphql_caching"] = graphql_caching
        if gzip_response is not None:
            self._values["gzip_response"] = gzip_response
        if hd_data_advanced is not None:
            self._values["hd_data_advanced"] = hd_data_advanced
        if health_detection is not None:
            self._values["health_detection"] = health_detection
        if hsaf_eip_binding is not None:
            self._values["hsaf_eip_binding"] = hsaf_eip_binding
        if http2 is not None:
            self._values["http2"] = http2
        if http3 is not None:
            self._values["http3"] = http3
        if http_strict_transport_security is not None:
            self._values["http_strict_transport_security"] = http_strict_transport_security
        if http_to_https_upgrade is not None:
            self._values["http_to_https_upgrade"] = http_to_https_upgrade
        if image_and_video_manager is not None:
            self._values["image_and_video_manager"] = image_and_video_manager
        if image_manager is not None:
            self._values["image_manager"] = image_manager
        if image_manager_video is not None:
            self._values["image_manager_video"] = image_manager_video
        if im_override is not None:
            self._values["im_override"] = im_override
        if include is not None:
            self._values["include"] = include
        if input_validation is not None:
            self._values["input_validation"] = input_validation
        if instant is not None:
            self._values["instant"] = instant
        if instant_config is not None:
            self._values["instant_config"] = instant_config
        if large_file_optimization is not None:
            self._values["large_file_optimization"] = large_file_optimization
        if large_file_optimization_advanced is not None:
            self._values["large_file_optimization_advanced"] = large_file_optimization_advanced
        if limit_bit_rate is not None:
            self._values["limit_bit_rate"] = limit_bit_rate
        if log_custom is not None:
            self._values["log_custom"] = log_custom
        if manifest_personalization is not None:
            self._values["manifest_personalization"] = manifest_personalization
        if manifest_rerouting is not None:
            self._values["manifest_rerouting"] = manifest_rerouting
        if manual_server_push is not None:
            self._values["manual_server_push"] = manual_server_push
        if media_acceleration is not None:
            self._values["media_acceleration"] = media_acceleration
        if media_acceleration_quic_optout is not None:
            self._values["media_acceleration_quic_optout"] = media_acceleration_quic_optout
        if media_client is not None:
            self._values["media_client"] = media_client
        if media_file_retrieval_optimization is not None:
            self._values["media_file_retrieval_optimization"] = media_file_retrieval_optimization
        if media_origin_failover is not None:
            self._values["media_origin_failover"] = media_origin_failover
        if metadata_caching is not None:
            self._values["metadata_caching"] = metadata_caching
        if mobile_sdk_performance is not None:
            self._values["mobile_sdk_performance"] = mobile_sdk_performance
        if modify_incoming_request_header is not None:
            self._values["modify_incoming_request_header"] = modify_incoming_request_header
        if modify_incoming_response_header is not None:
            self._values["modify_incoming_response_header"] = modify_incoming_response_header
        if modify_outgoing_request_header is not None:
            self._values["modify_outgoing_request_header"] = modify_outgoing_request_header
        if modify_outgoing_response_header is not None:
            self._values["modify_outgoing_response_header"] = modify_outgoing_response_header
        if modify_via_header is not None:
            self._values["modify_via_header"] = modify_via_header
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if origin is not None:
            self._values["origin"] = origin
        if origin_characteristics is not None:
            self._values["origin_characteristics"] = origin_characteristics
        if origin_characteristics_wsd is not None:
            self._values["origin_characteristics_wsd"] = origin_characteristics_wsd
        if origin_failure_recovery_method is not None:
            self._values["origin_failure_recovery_method"] = origin_failure_recovery_method
        if origin_failure_recovery_policy is not None:
            self._values["origin_failure_recovery_policy"] = origin_failure_recovery_policy
        if origin_ip_acl is not None:
            self._values["origin_ip_acl"] = origin_ip_acl
        if persistent_client_connection is not None:
            self._values["persistent_client_connection"] = persistent_client_connection
        if persistent_connection is not None:
            self._values["persistent_connection"] = persistent_connection
        if personally_identifiable_information is not None:
            self._values["personally_identifiable_information"] = personally_identifiable_information
        if phased_release is not None:
            self._values["phased_release"] = phased_release
        if preconnect is not None:
            self._values["preconnect"] = preconnect
        if predictive_content_delivery is not None:
            self._values["predictive_content_delivery"] = predictive_content_delivery
        if predictive_prefetching is not None:
            self._values["predictive_prefetching"] = predictive_prefetching
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if prefetchable is not None:
            self._values["prefetchable"] = prefetchable
        if prefresh_cache is not None:
            self._values["prefresh_cache"] = prefresh_cache
        if quality is not None:
            self._values["quality"] = quality
        if quic_beta is not None:
            self._values["quic_beta"] = quic_beta
        if random_seek is not None:
            self._values["random_seek"] = random_seek
        if rapid is not None:
            self._values["rapid"] = rapid
        if read_timeout is not None:
            self._values["read_timeout"] = read_timeout
        if real_time_reporting is not None:
            self._values["real_time_reporting"] = real_time_reporting
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirectplus is not None:
            self._values["redirectplus"] = redirectplus
        if referer_checking is not None:
            self._values["referer_checking"] = referer_checking
        if remove_query_parameter is not None:
            self._values["remove_query_parameter"] = remove_query_parameter
        if remove_vary is not None:
            self._values["remove_vary"] = remove_vary
        if report is not None:
            self._values["report"] = report
        if request_control is not None:
            self._values["request_control"] = request_control
        if request_type_marker is not None:
            self._values["request_type_marker"] = request_type_marker
        if resource_optimizer is not None:
            self._values["resource_optimizer"] = resource_optimizer
        if resource_optimizer_extended_compatibility is not None:
            self._values["resource_optimizer_extended_compatibility"] = resource_optimizer_extended_compatibility
        if response_code is not None:
            self._values["response_code"] = response_code
        if response_cookie is not None:
            self._values["response_cookie"] = response_cookie
        if restrict_object_caching is not None:
            self._values["restrict_object_caching"] = restrict_object_caching
        if return_cache_status is not None:
            self._values["return_cache_status"] = return_cache_status
        if rewrite_url is not None:
            self._values["rewrite_url"] = rewrite_url
        if rum_custom is not None:
            self._values["rum_custom"] = rum_custom
        if saas_definitions is not None:
            self._values["saas_definitions"] = saas_definitions
        if sales_force_commerce_cloud_client is not None:
            self._values["sales_force_commerce_cloud_client"] = sales_force_commerce_cloud_client
        if sales_force_commerce_cloud_provider is not None:
            self._values["sales_force_commerce_cloud_provider"] = sales_force_commerce_cloud_provider
        if sales_force_commerce_cloud_provider_host_header is not None:
            self._values["sales_force_commerce_cloud_provider_host_header"] = sales_force_commerce_cloud_provider_host_header
        if save_post_dca_processing is not None:
            self._values["save_post_dca_processing"] = save_post_dca_processing
        if schedule_invalidation is not None:
            self._values["schedule_invalidation"] = schedule_invalidation
        if script_management is not None:
            self._values["script_management"] = script_management
        if segmented_content_protection is not None:
            self._values["segmented_content_protection"] = segmented_content_protection
        if segmented_media_optimization is not None:
            self._values["segmented_media_optimization"] = segmented_media_optimization
        if segmented_media_streaming_prefetch is not None:
            self._values["segmented_media_streaming_prefetch"] = segmented_media_streaming_prefetch
        if set_variable is not None:
            self._values["set_variable"] = set_variable
        if shutr is not None:
            self._values["shutr"] = shutr
        if simulate_error_code is not None:
            self._values["simulate_error_code"] = simulate_error_code
        if site_shield is not None:
            self._values["site_shield"] = site_shield
        if standard_tls_migration is not None:
            self._values["standard_tls_migration"] = standard_tls_migration
        if standard_tls_migration_override is not None:
            self._values["standard_tls_migration_override"] = standard_tls_migration_override
        if strict_header_parsing is not None:
            self._values["strict_header_parsing"] = strict_header_parsing
        if sub_customer is not None:
            self._values["sub_customer"] = sub_customer
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if tcp_optimization is not None:
            self._values["tcp_optimization"] = tcp_optimization
        if tea_leaf is not None:
            self._values["tea_leaf"] = tea_leaf
        if tiered_distribution is not None:
            self._values["tiered_distribution"] = tiered_distribution
        if tiered_distribution_advanced is not None:
            self._values["tiered_distribution_advanced"] = tiered_distribution_advanced
        if tiered_distribution_customization is not None:
            self._values["tiered_distribution_customization"] = tiered_distribution_customization
        if timeout is not None:
            self._values["timeout"] = timeout
        if uid_configuration is not None:
            self._values["uid_configuration"] = uid_configuration
        if validate_entity_tag is not None:
            self._values["validate_entity_tag"] = validate_entity_tag
        if verify_json_web_token is not None:
            self._values["verify_json_web_token"] = verify_json_web_token
        if verify_json_web_token_for_dcp is not None:
            self._values["verify_json_web_token_for_dcp"] = verify_json_web_token_for_dcp
        if verify_token_authorization is not None:
            self._values["verify_token_authorization"] = verify_token_authorization
        if virtual_waiting_room is not None:
            self._values["virtual_waiting_room"] = virtual_waiting_room
        if virtual_waiting_room_with_edge_workers is not None:
            self._values["virtual_waiting_room_with_edge_workers"] = virtual_waiting_room_with_edge_workers
        if visitor_prioritization is not None:
            self._values["visitor_prioritization"] = visitor_prioritization
        if visitor_prioritization_fifo is not None:
            self._values["visitor_prioritization_fifo"] = visitor_prioritization_fifo
        if visitor_prioritization_fifo_standalone is not None:
            self._values["visitor_prioritization_fifo_standalone"] = visitor_prioritization_fifo_standalone
        if watermarking is not None:
            self._values["watermarking"] = watermarking
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall
        if webdav is not None:
            self._values["webdav"] = webdav
        if web_sockets is not None:
            self._values["web_sockets"] = web_sockets

    @builtins.property
    def adaptive_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration"]:
        '''adaptive_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        '''
        result = self._values.get("adaptive_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration"], result)

    @builtins.property
    def adaptive_image_compression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression"]:
        '''adaptive_image_compression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        '''
        result = self._values.get("adaptive_image_compression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression"], result)

    @builtins.property
    def ad_scaler_circuit_breaker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker"]:
        '''ad_scaler_circuit_breaker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        '''
        result = self._values.get("ad_scaler_circuit_breaker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker"], result)

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced"]:
        '''advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced"], result)

    @builtins.property
    def aggregated_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting"]:
        '''aggregated_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        '''
        result = self._values.get("aggregated_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting"], result)

    @builtins.property
    def akamaizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer"]:
        '''akamaizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        '''
        result = self._values.get("akamaizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer"], result)

    @builtins.property
    def akamaizer_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag"]:
        '''akamaizer_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        '''
        result = self._values.get("akamaizer_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag"], result)

    @builtins.property
    def all_http_in_cache_hierarchy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy"]:
        '''all_http_in_cache_hierarchy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        '''
        result = self._values.get("all_http_in_cache_hierarchy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy"], result)

    @builtins.property
    def allow_cloudlets_origins(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins"]:
        '''allow_cloudlets_origins block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        '''
        result = self._values.get("allow_cloudlets_origins")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins"], result)

    @builtins.property
    def allow_delete(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete"]:
        '''allow_delete block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        '''
        result = self._values.get("allow_delete")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete"], result)

    @builtins.property
    def allow_https_cache_key_sharing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing"]:
        '''allow_https_cache_key_sharing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        '''
        result = self._values.get("allow_https_cache_key_sharing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing"], result)

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade"]:
        '''allow_https_downgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade"], result)

    @builtins.property
    def allow_options(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions"]:
        '''allow_options block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        '''
        result = self._values.get("allow_options")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions"], result)

    @builtins.property
    def allow_patch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch"]:
        '''allow_patch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        '''
        result = self._values.get("allow_patch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch"], result)

    @builtins.property
    def allow_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost"]:
        '''allow_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        '''
        result = self._values.get("allow_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost"], result)

    @builtins.property
    def allow_put(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut"]:
        '''allow_put block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        '''
        result = self._values.get("allow_put")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut"], result)

    @builtins.property
    def allow_transfer_encoding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding"]:
        '''allow_transfer_encoding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        '''
        result = self._values.get("allow_transfer_encoding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding"], result)

    @builtins.property
    def alt_svc_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader"]:
        '''alt_svc_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        '''
        result = self._values.get("alt_svc_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader"], result)

    @builtins.property
    def api_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization"]:
        '''api_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        '''
        result = self._values.get("api_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization"], result)

    @builtins.property
    def application_load_balancer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer"]:
        '''application_load_balancer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        '''
        result = self._values.get("application_load_balancer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer"], result)

    @builtins.property
    def audience_segmentation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation"]:
        '''audience_segmentation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        '''
        result = self._values.get("audience_segmentation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation"], result)

    @builtins.property
    def auto_domain_validation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation"]:
        '''auto_domain_validation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        '''
        result = self._values.get("auto_domain_validation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation"], result)

    @builtins.property
    def base_directory(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory"]:
        '''base_directory block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        '''
        result = self._values.get("base_directory")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory"], result)

    @builtins.property
    def boss_beaconing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing"]:
        '''boss_beaconing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        '''
        result = self._values.get("boss_beaconing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing"], result)

    @builtins.property
    def breadcrumbs(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs"]:
        '''breadcrumbs block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        '''
        result = self._values.get("breadcrumbs")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs"], result)

    @builtins.property
    def break_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection"]:
        '''break_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        '''
        result = self._values.get("break_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection"], result)

    @builtins.property
    def brotli(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli"]:
        '''brotli block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        '''
        result = self._values.get("brotli")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli"], result)

    @builtins.property
    def cache_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError"]:
        '''cache_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        '''
        result = self._values.get("cache_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError"], result)

    @builtins.property
    def cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId"]:
        '''cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        '''
        result = self._values.get("cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId"], result)

    @builtins.property
    def cache_key_ignore_case(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase"]:
        '''cache_key_ignore_case block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        '''
        result = self._values.get("cache_key_ignore_case")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase"], result)

    @builtins.property
    def cache_key_query_params(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams"]:
        '''cache_key_query_params block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        '''
        result = self._values.get("cache_key_query_params")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams"], result)

    @builtins.property
    def cache_key_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite"]:
        '''cache_key_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        '''
        result = self._values.get("cache_key_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite"], result)

    @builtins.property
    def cache_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost"]:
        '''cache_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        '''
        result = self._values.get("cache_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost"], result)

    @builtins.property
    def cache_redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect"]:
        '''cache_redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        '''
        result = self._values.get("cache_redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect"], result)

    @builtins.property
    def cache_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag"]:
        '''cache_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        '''
        result = self._values.get("cache_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag"], result)

    @builtins.property
    def cache_tag_visible(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible"]:
        '''cache_tag_visible block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        '''
        result = self._values.get("cache_tag_visible")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible"], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching"]:
        '''caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching"], result)

    @builtins.property
    def central_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization"]:
        '''central_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        '''
        result = self._values.get("central_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization"], result)

    @builtins.property
    def chase_redirects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects"]:
        '''chase_redirects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        '''
        result = self._values.get("chase_redirects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects"], result)

    @builtins.property
    def client_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics"]:
        '''client_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        '''
        result = self._values.get("client_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics"], result)

    @builtins.property
    def cloud_interconnects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects"]:
        '''cloud_interconnects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        '''
        result = self._values.get("cloud_interconnects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects"], result)

    @builtins.property
    def cloud_wrapper(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper"]:
        '''cloud_wrapper block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        '''
        result = self._values.get("cloud_wrapper")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper"], result)

    @builtins.property
    def cloud_wrapper_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced"]:
        '''cloud_wrapper_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        '''
        result = self._values.get("cloud_wrapper_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced"], result)

    @builtins.property
    def conditional_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin"]:
        '''conditional_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        '''
        result = self._values.get("conditional_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin"], result)

    @builtins.property
    def construct_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse"]:
        '''construct_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        '''
        result = self._values.get("construct_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse"], result)

    @builtins.property
    def content_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics"]:
        '''content_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        '''
        result = self._values.get("content_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics"], result)

    @builtins.property
    def content_characteristics_amd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd"]:
        '''content_characteristics_amd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        '''
        result = self._values.get("content_characteristics_amd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd"], result)

    @builtins.property
    def content_characteristics_dd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd"]:
        '''content_characteristics_dd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        '''
        result = self._values.get("content_characteristics_dd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd"], result)

    @builtins.property
    def content_characteristics_wsd_large_file(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile"]:
        '''content_characteristics_wsd_large_file block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        '''
        result = self._values.get("content_characteristics_wsd_large_file")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile"], result)

    @builtins.property
    def content_characteristics_wsd_live(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive"]:
        '''content_characteristics_wsd_live block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        '''
        result = self._values.get("content_characteristics_wsd_live")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive"], result)

    @builtins.property
    def content_characteristics_wsd_vod(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod"]:
        '''content_characteristics_wsd_vod block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        '''
        result = self._values.get("content_characteristics_wsd_vod")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod"], result)

    @builtins.property
    def content_pre_position(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition"]:
        '''content_pre_position block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        '''
        result = self._values.get("content_pre_position")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition"], result)

    @builtins.property
    def content_targeting_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection"]:
        '''content_targeting_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        '''
        result = self._values.get("content_targeting_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection"], result)

    @builtins.property
    def cors_support(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport"]:
        '''cors_support block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        '''
        result = self._values.get("cors_support")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport"], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode"], result)

    @builtins.property
    def custom_behavior(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior"]:
        '''custom_behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        '''
        result = self._values.get("custom_behavior")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior"], result)

    @builtins.property
    def datastream(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream"]:
        '''datastream block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        '''
        result = self._values.get("datastream")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream"], result)

    @builtins.property
    def dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp"]:
        '''dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        '''
        result = self._values.get("dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp"], result)

    @builtins.property
    def dcp_auth_hmac_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation"]:
        '''dcp_auth_hmac_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        '''
        result = self._values.get("dcp_auth_hmac_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation"], result)

    @builtins.property
    def dcp_auth_regex_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation"]:
        '''dcp_auth_regex_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        '''
        result = self._values.get("dcp_auth_regex_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation"], result)

    @builtins.property
    def dcp_auth_substring_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation"]:
        '''dcp_auth_substring_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        '''
        result = self._values.get("dcp_auth_substring_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation"], result)

    @builtins.property
    def dcp_auth_variable_extractor(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor"]:
        '''dcp_auth_variable_extractor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        '''
        result = self._values.get("dcp_auth_variable_extractor")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor"], result)

    @builtins.property
    def dcp_default_authz_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups"]:
        '''dcp_default_authz_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        '''
        result = self._values.get("dcp_default_authz_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups"], result)

    @builtins.property
    def dcp_dev_relations(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations"]:
        '''dcp_dev_relations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        '''
        result = self._values.get("dcp_dev_relations")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations"], result)

    @builtins.property
    def dcp_real_time_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth"]:
        '''dcp_real_time_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        '''
        result = self._values.get("dcp_real_time_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth"], result)

    @builtins.property
    def delivery_receipt(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt"]:
        '''delivery_receipt block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        '''
        result = self._values.get("delivery_receipt")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt"], result)

    @builtins.property
    def deny_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess"]:
        '''deny_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        '''
        result = self._values.get("deny_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess"], result)

    @builtins.property
    def deny_direct_failover_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess"]:
        '''deny_direct_failover_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        '''
        result = self._values.get("deny_direct_failover_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess"], result)

    @builtins.property
    def device_characteristic_cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId"]:
        '''device_characteristic_cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        '''
        result = self._values.get("device_characteristic_cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId"], result)

    @builtins.property
    def device_characteristic_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader"]:
        '''device_characteristic_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        '''
        result = self._values.get("device_characteristic_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader"], result)

    @builtins.property
    def dns_async_refresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh"]:
        '''dns_async_refresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        '''
        result = self._values.get("dns_async_refresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh"], result)

    @builtins.property
    def dns_prefresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh"]:
        '''dns_prefresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        '''
        result = self._values.get("dns_prefresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh"], result)

    @builtins.property
    def downgrade_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol"]:
        '''downgrade_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        '''
        result = self._values.get("downgrade_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol"], result)

    @builtins.property
    def download_complete_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker"]:
        '''download_complete_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        '''
        result = self._values.get("download_complete_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker"], result)

    @builtins.property
    def download_notification(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification"]:
        '''download_notification block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        '''
        result = self._values.get("download_notification")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification"], result)

    @builtins.property
    def downstream_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache"]:
        '''downstream_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        '''
        result = self._values.get("downstream_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache"], result)

    @builtins.property
    def dynamic_throughtput_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization"]:
        '''dynamic_throughtput_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        '''
        result = self._values.get("dynamic_throughtput_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization"], result)

    @builtins.property
    def dynamic_throughtput_optimization_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride"]:
        '''dynamic_throughtput_optimization_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        '''
        result = self._values.get("dynamic_throughtput_optimization_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride"], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent"]:
        '''dynamic_web_content block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent"], result)

    @builtins.property
    def ecms_bulk_upload(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload"]:
        '''ecms_bulk_upload block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        '''
        result = self._values.get("ecms_bulk_upload")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload"], result)

    @builtins.property
    def ecms_database(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase"]:
        '''ecms_database block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        '''
        result = self._values.get("ecms_database")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase"], result)

    @builtins.property
    def ecms_dataset(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset"]:
        '''ecms_dataset block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        '''
        result = self._values.get("ecms_dataset")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset"], result)

    @builtins.property
    def ecms_object_key(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey"]:
        '''ecms_object_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        '''
        result = self._values.get("ecms_object_key")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey"], result)

    @builtins.property
    def edge_connect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect"]:
        '''edge_connect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        '''
        result = self._values.get("edge_connect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect"], result)

    @builtins.property
    def edge_load_balancing_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced"]:
        '''edge_load_balancing_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        '''
        result = self._values.get("edge_load_balancing_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced"], result)

    @builtins.property
    def edge_load_balancing_data_center(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter"]:
        '''edge_load_balancing_data_center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        '''
        result = self._values.get("edge_load_balancing_data_center")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter"], result)

    @builtins.property
    def edge_load_balancing_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin"]:
        '''edge_load_balancing_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        '''
        result = self._values.get("edge_load_balancing_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin"], result)

    @builtins.property
    def edge_origin_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization"]:
        '''edge_origin_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        '''
        result = self._values.get("edge_origin_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization"], result)

    @builtins.property
    def edge_redirector(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector"]:
        '''edge_redirector block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        '''
        result = self._values.get("edge_redirector")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector"], result)

    @builtins.property
    def edge_scape(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape"]:
        '''edge_scape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        '''
        result = self._values.get("edge_scape")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape"], result)

    @builtins.property
    def edge_side_includes(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes"]:
        '''edge_side_includes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        '''
        result = self._values.get("edge_side_includes")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes"], result)

    @builtins.property
    def edge_worker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker"]:
        '''edge_worker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        '''
        result = self._values.get("edge_worker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker"], result)

    @builtins.property
    def enhanced_akamai_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol"]:
        '''enhanced_akamai_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        '''
        result = self._values.get("enhanced_akamai_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol"], result)

    @builtins.property
    def enhanced_proxy_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection"]:
        '''enhanced_proxy_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        '''
        result = self._values.get("enhanced_proxy_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection"], result)

    @builtins.property
    def epd_forward_header_enrichment(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment"]:
        '''epd_forward_header_enrichment block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        '''
        result = self._values.get("epd_forward_header_enrichment")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment"], result)

    @builtins.property
    def fail_action(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction"]:
        '''fail_action block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        '''
        result = self._values.get("fail_action")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction"], result)

    @builtins.property
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility"]:
        '''failover_bot_manager_feature_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        '''
        result = self._values.get("failover_bot_manager_feature_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility"], result)

    @builtins.property
    def fast_invalidate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate"]:
        '''fast_invalidate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        '''
        result = self._values.get("fast_invalidate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate"], result)

    @builtins.property
    def first_party_marketing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing"]:
        '''first_party_marketing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        '''
        result = self._values.get("first_party_marketing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing"], result)

    @builtins.property
    def first_party_marketing_plus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus"]:
        '''first_party_marketing_plus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        '''
        result = self._values.get("first_party_marketing_plus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus"], result)

    @builtins.property
    def forward_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite"]:
        '''forward_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        '''
        result = self._values.get("forward_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite"], result)

    @builtins.property
    def front_end_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization"]:
        '''front_end_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#front_end_optimization DataAkamaiPropertyRulesBuilder#front_end_optimization}
        '''
        result = self._values.get("front_end_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization"], result)

    @builtins.property
    def g2_oheader(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader"]:
        '''g2oheader block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        '''
        result = self._values.get("g2_oheader")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader"], result)

    @builtins.property
    def global_request_number(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber"]:
        '''global_request_number block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        '''
        result = self._values.get("global_request_number")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber"], result)

    @builtins.property
    def graphql_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching"]:
        '''graphql_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        '''
        result = self._values.get("graphql_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching"], result)

    @builtins.property
    def gzip_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse"]:
        '''gzip_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        '''
        result = self._values.get("gzip_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse"], result)

    @builtins.property
    def hd_data_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced"]:
        '''hd_data_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        '''
        result = self._values.get("hd_data_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced"], result)

    @builtins.property
    def health_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection"]:
        '''health_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        '''
        result = self._values.get("health_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection"], result)

    @builtins.property
    def hsaf_eip_binding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding"]:
        '''hsaf_eip_binding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        '''
        result = self._values.get("hsaf_eip_binding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding"], result)

    @builtins.property
    def http2(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2"]:
        '''http2 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        '''
        result = self._values.get("http2")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2"], result)

    @builtins.property
    def http3(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3"]:
        '''http3 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        '''
        result = self._values.get("http3")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3"], result)

    @builtins.property
    def http_strict_transport_security(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity"]:
        '''http_strict_transport_security block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        '''
        result = self._values.get("http_strict_transport_security")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity"], result)

    @builtins.property
    def http_to_https_upgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade"]:
        '''http_to_https_upgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        '''
        result = self._values.get("http_to_https_upgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade"], result)

    @builtins.property
    def image_and_video_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager"]:
        '''image_and_video_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        '''
        result = self._values.get("image_and_video_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager"], result)

    @builtins.property
    def image_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager"]:
        '''image_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        '''
        result = self._values.get("image_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager"], result)

    @builtins.property
    def image_manager_video(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo"]:
        '''image_manager_video block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        '''
        result = self._values.get("image_manager_video")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo"], result)

    @builtins.property
    def im_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride"]:
        '''im_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        '''
        result = self._values.get("im_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride"], result)

    @builtins.property
    def include(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude"]:
        '''include block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        '''
        result = self._values.get("include")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude"], result)

    @builtins.property
    def input_validation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation"]:
        '''input_validation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#input_validation DataAkamaiPropertyRulesBuilder#input_validation}
        '''
        result = self._values.get("input_validation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation"], result)

    @builtins.property
    def instant(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant"]:
        '''instant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        '''
        result = self._values.get("instant")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant"], result)

    @builtins.property
    def instant_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig"]:
        '''instant_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        '''
        result = self._values.get("instant_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig"], result)

    @builtins.property
    def large_file_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization"]:
        '''large_file_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        '''
        result = self._values.get("large_file_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization"], result)

    @builtins.property
    def large_file_optimization_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced"]:
        '''large_file_optimization_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        '''
        result = self._values.get("large_file_optimization_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced"], result)

    @builtins.property
    def limit_bit_rate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate"]:
        '''limit_bit_rate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        '''
        result = self._values.get("limit_bit_rate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate"], result)

    @builtins.property
    def log_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom"]:
        '''log_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        '''
        result = self._values.get("log_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom"], result)

    @builtins.property
    def manifest_personalization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization"]:
        '''manifest_personalization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        '''
        result = self._values.get("manifest_personalization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization"], result)

    @builtins.property
    def manifest_rerouting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting"]:
        '''manifest_rerouting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        '''
        result = self._values.get("manifest_rerouting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting"], result)

    @builtins.property
    def manual_server_push(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush"]:
        '''manual_server_push block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        '''
        result = self._values.get("manual_server_push")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush"], result)

    @builtins.property
    def media_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration"]:
        '''media_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        '''
        result = self._values.get("media_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration"], result)

    @builtins.property
    def media_acceleration_quic_optout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout"]:
        '''media_acceleration_quic_optout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        '''
        result = self._values.get("media_acceleration_quic_optout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout"], result)

    @builtins.property
    def media_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient"]:
        '''media_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        '''
        result = self._values.get("media_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient"], result)

    @builtins.property
    def media_file_retrieval_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization"]:
        '''media_file_retrieval_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        '''
        result = self._values.get("media_file_retrieval_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization"], result)

    @builtins.property
    def media_origin_failover(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover"]:
        '''media_origin_failover block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        '''
        result = self._values.get("media_origin_failover")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover"], result)

    @builtins.property
    def metadata_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching"]:
        '''metadata_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        '''
        result = self._values.get("metadata_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching"], result)

    @builtins.property
    def mobile_sdk_performance(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance"]:
        '''mobile_sdk_performance block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        '''
        result = self._values.get("mobile_sdk_performance")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance"], result)

    @builtins.property
    def modify_incoming_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader"]:
        '''modify_incoming_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        '''
        result = self._values.get("modify_incoming_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader"], result)

    @builtins.property
    def modify_incoming_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader"]:
        '''modify_incoming_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        '''
        result = self._values.get("modify_incoming_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader"], result)

    @builtins.property
    def modify_outgoing_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader"]:
        '''modify_outgoing_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        '''
        result = self._values.get("modify_outgoing_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader"], result)

    @builtins.property
    def modify_outgoing_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader"]:
        '''modify_outgoing_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        '''
        result = self._values.get("modify_outgoing_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader"], result)

    @builtins.property
    def modify_via_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader"]:
        '''modify_via_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        '''
        result = self._values.get("modify_via_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader"], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse"]:
        '''m_pulse block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse"], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin"]:
        '''origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin"], result)

    @builtins.property
    def origin_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics"]:
        '''origin_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        '''
        result = self._values.get("origin_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics"], result)

    @builtins.property
    def origin_characteristics_wsd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd"]:
        '''origin_characteristics_wsd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        '''
        result = self._values.get("origin_characteristics_wsd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd"], result)

    @builtins.property
    def origin_failure_recovery_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod"]:
        '''origin_failure_recovery_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        '''
        result = self._values.get("origin_failure_recovery_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod"], result)

    @builtins.property
    def origin_failure_recovery_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy"]:
        '''origin_failure_recovery_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        '''
        result = self._values.get("origin_failure_recovery_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy"], result)

    @builtins.property
    def origin_ip_acl(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl"]:
        '''origin_ip_acl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        '''
        result = self._values.get("origin_ip_acl")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl"], result)

    @builtins.property
    def persistent_client_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection"]:
        '''persistent_client_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        '''
        result = self._values.get("persistent_client_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection"], result)

    @builtins.property
    def persistent_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection"]:
        '''persistent_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        '''
        result = self._values.get("persistent_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection"], result)

    @builtins.property
    def personally_identifiable_information(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation"]:
        '''personally_identifiable_information block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        '''
        result = self._values.get("personally_identifiable_information")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation"], result)

    @builtins.property
    def phased_release(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease"]:
        '''phased_release block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        '''
        result = self._values.get("phased_release")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease"], result)

    @builtins.property
    def preconnect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect"]:
        '''preconnect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        '''
        result = self._values.get("preconnect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect"], result)

    @builtins.property
    def predictive_content_delivery(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery"]:
        '''predictive_content_delivery block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        '''
        result = self._values.get("predictive_content_delivery")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery"], result)

    @builtins.property
    def predictive_prefetching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching"]:
        '''predictive_prefetching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        '''
        result = self._values.get("predictive_prefetching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching"], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch"]:
        '''prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch"], result)

    @builtins.property
    def prefetchable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable"]:
        '''prefetchable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        '''
        result = self._values.get("prefetchable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable"], result)

    @builtins.property
    def prefresh_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache"]:
        '''prefresh_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        '''
        result = self._values.get("prefresh_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache"], result)

    @builtins.property
    def quality(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality"]:
        '''quality block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        '''
        result = self._values.get("quality")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality"], result)

    @builtins.property
    def quic_beta(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta"]:
        '''quic_beta block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        '''
        result = self._values.get("quic_beta")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta"], result)

    @builtins.property
    def random_seek(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek"]:
        '''random_seek block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        '''
        result = self._values.get("random_seek")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek"], result)

    @builtins.property
    def rapid(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid"]:
        '''rapid block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        '''
        result = self._values.get("rapid")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid"], result)

    @builtins.property
    def read_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout"]:
        '''read_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        '''
        result = self._values.get("read_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout"], result)

    @builtins.property
    def real_time_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting"]:
        '''real_time_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        '''
        result = self._values.get("real_time_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting"], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring"]:
        '''real_user_monitoring block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring"], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect"]:
        '''redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect"], result)

    @builtins.property
    def redirectplus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus"]:
        '''redirectplus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        '''
        result = self._values.get("redirectplus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus"], result)

    @builtins.property
    def referer_checking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking"]:
        '''referer_checking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        '''
        result = self._values.get("referer_checking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking"], result)

    @builtins.property
    def remove_query_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter"]:
        '''remove_query_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        '''
        result = self._values.get("remove_query_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter"], result)

    @builtins.property
    def remove_vary(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary"]:
        '''remove_vary block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        '''
        result = self._values.get("remove_vary")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary"], result)

    @builtins.property
    def report(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport"]:
        '''report block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        '''
        result = self._values.get("report")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport"], result)

    @builtins.property
    def request_control(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl"]:
        '''request_control block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        '''
        result = self._values.get("request_control")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl"], result)

    @builtins.property
    def request_type_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker"]:
        '''request_type_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        '''
        result = self._values.get("request_type_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker"], result)

    @builtins.property
    def resource_optimizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer"]:
        '''resource_optimizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        '''
        result = self._values.get("resource_optimizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer"], result)

    @builtins.property
    def resource_optimizer_extended_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility"]:
        '''resource_optimizer_extended_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        '''
        result = self._values.get("resource_optimizer_extended_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility"], result)

    @builtins.property
    def response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode"]:
        '''response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode"], result)

    @builtins.property
    def response_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie"]:
        '''response_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        '''
        result = self._values.get("response_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie"], result)

    @builtins.property
    def restrict_object_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching"]:
        '''restrict_object_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        '''
        result = self._values.get("restrict_object_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching"], result)

    @builtins.property
    def return_cache_status(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus"]:
        '''return_cache_status block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        '''
        result = self._values.get("return_cache_status")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus"], result)

    @builtins.property
    def rewrite_url(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl"]:
        '''rewrite_url block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        '''
        result = self._values.get("rewrite_url")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl"], result)

    @builtins.property
    def rum_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom"]:
        '''rum_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        '''
        result = self._values.get("rum_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom"], result)

    @builtins.property
    def saas_definitions(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions"]:
        '''saas_definitions block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        '''
        result = self._values.get("saas_definitions")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions"], result)

    @builtins.property
    def sales_force_commerce_cloud_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient"]:
        '''sales_force_commerce_cloud_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        '''
        result = self._values.get("sales_force_commerce_cloud_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider"]:
        '''sales_force_commerce_cloud_provider block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        '''sales_force_commerce_cloud_provider_host_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider_host_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader"], result)

    @builtins.property
    def save_post_dca_processing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing"]:
        '''save_post_dca_processing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        '''
        result = self._values.get("save_post_dca_processing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing"], result)

    @builtins.property
    def schedule_invalidation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation"]:
        '''schedule_invalidation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        '''
        result = self._values.get("schedule_invalidation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation"], result)

    @builtins.property
    def script_management(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement"]:
        '''script_management block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        '''
        result = self._values.get("script_management")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement"], result)

    @builtins.property
    def segmented_content_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection"]:
        '''segmented_content_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        '''
        result = self._values.get("segmented_content_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection"], result)

    @builtins.property
    def segmented_media_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization"]:
        '''segmented_media_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        '''
        result = self._values.get("segmented_media_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization"], result)

    @builtins.property
    def segmented_media_streaming_prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch"]:
        '''segmented_media_streaming_prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        '''
        result = self._values.get("segmented_media_streaming_prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch"], result)

    @builtins.property
    def set_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable"]:
        '''set_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        '''
        result = self._values.get("set_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable"], result)

    @builtins.property
    def shutr(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr"]:
        '''shutr block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#shutr DataAkamaiPropertyRulesBuilder#shutr}
        '''
        result = self._values.get("shutr")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr"], result)

    @builtins.property
    def simulate_error_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode"]:
        '''simulate_error_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        '''
        result = self._values.get("simulate_error_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode"], result)

    @builtins.property
    def site_shield(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield"]:
        '''site_shield block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        '''
        result = self._values.get("site_shield")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield"], result)

    @builtins.property
    def standard_tls_migration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration"]:
        '''standard_tls_migration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        '''
        result = self._values.get("standard_tls_migration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration"], result)

    @builtins.property
    def standard_tls_migration_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride"]:
        '''standard_tls_migration_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        '''
        result = self._values.get("standard_tls_migration_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride"], result)

    @builtins.property
    def strict_header_parsing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing"]:
        '''strict_header_parsing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        '''
        result = self._values.get("strict_header_parsing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing"], result)

    @builtins.property
    def sub_customer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer"]:
        '''sub_customer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        '''
        result = self._values.get("sub_customer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer"], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute"]:
        '''sure_route block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute"], result)

    @builtins.property
    def tcp_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization"]:
        '''tcp_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        '''
        result = self._values.get("tcp_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization"], result)

    @builtins.property
    def tea_leaf(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf"]:
        '''tea_leaf block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        '''
        result = self._values.get("tea_leaf")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf"], result)

    @builtins.property
    def tiered_distribution(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution"]:
        '''tiered_distribution block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        '''
        result = self._values.get("tiered_distribution")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution"], result)

    @builtins.property
    def tiered_distribution_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced"]:
        '''tiered_distribution_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        '''
        result = self._values.get("tiered_distribution_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced"], result)

    @builtins.property
    def tiered_distribution_customization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization"]:
        '''tiered_distribution_customization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        '''
        result = self._values.get("tiered_distribution_customization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization"], result)

    @builtins.property
    def timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout"]:
        '''timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout"], result)

    @builtins.property
    def uid_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration"]:
        '''uid_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        '''
        result = self._values.get("uid_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration"], result)

    @builtins.property
    def validate_entity_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag"]:
        '''validate_entity_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        '''
        result = self._values.get("validate_entity_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag"], result)

    @builtins.property
    def verify_json_web_token(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken"]:
        '''verify_json_web_token block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        '''
        result = self._values.get("verify_json_web_token")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken"], result)

    @builtins.property
    def verify_json_web_token_for_dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp"]:
        '''verify_json_web_token_for_dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        '''
        result = self._values.get("verify_json_web_token_for_dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp"], result)

    @builtins.property
    def verify_token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization"]:
        '''verify_token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        '''
        result = self._values.get("verify_token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization"], result)

    @builtins.property
    def virtual_waiting_room(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom"]:
        '''virtual_waiting_room block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        '''
        result = self._values.get("virtual_waiting_room")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom"], result)

    @builtins.property
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        '''virtual_waiting_room_with_edge_workers block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        '''
        result = self._values.get("virtual_waiting_room_with_edge_workers")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers"], result)

    @builtins.property
    def visitor_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization"]:
        '''visitor_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        '''
        result = self._values.get("visitor_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization"], result)

    @builtins.property
    def visitor_prioritization_fifo(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo"]:
        '''visitor_prioritization_fifo block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        '''
        result = self._values.get("visitor_prioritization_fifo")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo"], result)

    @builtins.property
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone"]:
        '''visitor_prioritization_fifo_standalone block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        '''
        result = self._values.get("visitor_prioritization_fifo_standalone")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone"], result)

    @builtins.property
    def watermarking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking"]:
        '''watermarking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        '''
        result = self._values.get("watermarking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking"], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall"]:
        '''web_application_firewall block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall"], result)

    @builtins.property
    def webdav(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav"]:
        '''webdav block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        '''
        result = self._values.get("webdav")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav"], result)

    @builtins.property
    def web_sockets(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets"]:
        '''web_sockets block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        result = self._values.get("web_sockets")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105Behavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker",
    jsii_struct_bases=[],
    name_mapping={
        "fallback_action_response_code_based": "fallbackActionResponseCodeBased",
        "locked": "locked",
        "response_code_based": "responseCodeBased",
        "response_codes": "responseCodes",
        "response_delay_based": "responseDelayBased",
        "response_delay_threshold": "responseDelayThreshold",
        "return_error_response_code_based": "returnErrorResponseCodeBased",
        "specify_your_own_response_code_based": "specifyYourOwnResponseCodeBased",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker:
    def __init__(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685f8aab0ecd3889630226f28313d28c772d65ed2370851705a1fc68b43c6ea3)
            check_type(argname="argument fallback_action_response_code_based", value=fallback_action_response_code_based, expected_type=type_hints["fallback_action_response_code_based"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code_based", value=response_code_based, expected_type=type_hints["response_code_based"])
            check_type(argname="argument response_codes", value=response_codes, expected_type=type_hints["response_codes"])
            check_type(argname="argument response_delay_based", value=response_delay_based, expected_type=type_hints["response_delay_based"])
            check_type(argname="argument response_delay_threshold", value=response_delay_threshold, expected_type=type_hints["response_delay_threshold"])
            check_type(argname="argument return_error_response_code_based", value=return_error_response_code_based, expected_type=type_hints["return_error_response_code_based"])
            check_type(argname="argument specify_your_own_response_code_based", value=specify_your_own_response_code_based, expected_type=type_hints["specify_your_own_response_code_based"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fallback_action_response_code_based is not None:
            self._values["fallback_action_response_code_based"] = fallback_action_response_code_based
        if locked is not None:
            self._values["locked"] = locked
        if response_code_based is not None:
            self._values["response_code_based"] = response_code_based
        if response_codes is not None:
            self._values["response_codes"] = response_codes
        if response_delay_based is not None:
            self._values["response_delay_based"] = response_delay_based
        if response_delay_threshold is not None:
            self._values["response_delay_threshold"] = response_delay_threshold
        if return_error_response_code_based is not None:
            self._values["return_error_response_code_based"] = return_error_response_code_based
        if specify_your_own_response_code_based is not None:
            self._values["specify_your_own_response_code_based"] = specify_your_own_response_code_based
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def fallback_action_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        '''
        result = self._values.get("fallback_action_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the response code from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        '''
        result = self._values.get("response_code_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_codes(self) -> typing.Optional[builtins.str]:
        '''Specifies the codes in the partner's response that trigger the fallback action,  either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        '''
        result = self._values.get("response_codes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_delay_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the delayed response from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        '''
        result = self._values.get("response_delay_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_delay_threshold(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum response delay that, if exceeded, triggers the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        '''
        result = self._values.get("response_delay_threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def return_error_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the error to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        '''
        result = self._values.get("return_error_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_your_own_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Defines a custom error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        '''
        result = self._values.get("specify_your_own_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreakerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreakerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4db19b55c16052f855f861f1cd4b36c94da76d2b378c7aea3fd688c851d24f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFallbackActionResponseCodeBased")
    def reset_fallback_action_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFallbackActionResponseCodeBased", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCodeBased")
    def reset_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodeBased", []))

    @jsii.member(jsii_name="resetResponseCodes")
    def reset_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodes", []))

    @jsii.member(jsii_name="resetResponseDelayBased")
    def reset_response_delay_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayBased", []))

    @jsii.member(jsii_name="resetResponseDelayThreshold")
    def reset_response_delay_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayThreshold", []))

    @jsii.member(jsii_name="resetReturnErrorResponseCodeBased")
    def reset_return_error_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnErrorResponseCodeBased", []))

    @jsii.member(jsii_name="resetSpecifyYourOwnResponseCodeBased")
    def reset_specify_your_own_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyYourOwnResponseCodeBased", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBasedInput")
    def fallback_action_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fallbackActionResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeBasedInput")
    def response_code_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodesInput")
    def response_codes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayBasedInput")
    def response_delay_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseDelayBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayThresholdInput")
    def response_delay_threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseDelayThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBasedInput")
    def return_error_response_code_based_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "returnErrorResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBasedInput")
    def specify_your_own_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "specifyYourOwnResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBased")
    def fallback_action_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fallbackActionResponseCodeBased"))

    @fallback_action_response_code_based.setter
    def fallback_action_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b38aae20391b96027c80110373952a3306ef1d702ba13b5c3bb930b245d46d39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fallbackActionResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03db5eafcee8383e2175865668b09b49cfb42892bf9e741e51dad0f5dfd327e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodeBased")
    def response_code_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseCodeBased"))

    @response_code_based.setter
    def response_code_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ad4bb556ea33b46b8ea4c25969ad23bb725762a484ac539937c863ff6b61de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodes")
    def response_codes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseCodes"))

    @response_codes.setter
    def response_codes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf83e1d18909d86d8c8de6d5f99e1ac6f7923778f4e581e35ff82b1183758bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayBased")
    def response_delay_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseDelayBased"))

    @response_delay_based.setter
    def response_delay_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c0e608c3344e3363973604ab7c666b02e80f5282f97bfc0a9cdc8fe2c884c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayThreshold")
    def response_delay_threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseDelayThreshold"))

    @response_delay_threshold.setter
    def response_delay_threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988cefda399bf965bf70869373ca5e13c13cd2ad094bb1506aae68d4051291bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBased")
    def return_error_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "returnErrorResponseCodeBased"))

    @return_error_response_code_based.setter
    def return_error_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191ac0f9d8cb9e6b6d6972c634f8604127c2b09b405aade5df14106861cba0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "returnErrorResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBased")
    def specify_your_own_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "specifyYourOwnResponseCodeBased"))

    @specify_your_own_response_code_based.setter
    def specify_your_own_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b8254ad4aecf2ef41c3a5d07406f86eb1d969c3ab008239e61ede7c6e10e638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyYourOwnResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6991ce874e71e1c94558f15a7526c1acab994db1bdacae0801045c34df4c3a06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6931289d4ba2c23ed91442913d0dd93d92a00ff762c8f53ffdafc4f4f3ec3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e0fb54b272b1f57dfc17bb05821ef08d6330a869fb2169c53139c6300061ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "ab_logic": "abLogic",
        "ab_testing": "abTesting",
        "compression": "compression",
        "cookie_name": "cookieName",
        "enable_brotli_compression": "enableBrotliCompression",
        "enable_for_noncacheable": "enableForNoncacheable",
        "enable_preconnect": "enablePreconnect",
        "enable_push": "enablePush",
        "enable_ro": "enableRo",
        "locked": "locked",
        "preload_enable": "preloadEnable",
        "source": "source",
        "template_uuid": "templateUuid",
        "title_brotli": "titleBrotli",
        "title_http2_server_push": "titleHttp2ServerPush",
        "title_preconnect": "titlePreconnect",
        "title_preload": "titlePreload",
        "title_ro": "titleRo",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration:
    def __init__(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8398a23f9020d5a091b007fb60cbdfc57a35d0ad0b5c79a0d5959ea88ae8aa56)
            check_type(argname="argument ab_logic", value=ab_logic, expected_type=type_hints["ab_logic"])
            check_type(argname="argument ab_testing", value=ab_testing, expected_type=type_hints["ab_testing"])
            check_type(argname="argument compression", value=compression, expected_type=type_hints["compression"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument enable_brotli_compression", value=enable_brotli_compression, expected_type=type_hints["enable_brotli_compression"])
            check_type(argname="argument enable_for_noncacheable", value=enable_for_noncacheable, expected_type=type_hints["enable_for_noncacheable"])
            check_type(argname="argument enable_preconnect", value=enable_preconnect, expected_type=type_hints["enable_preconnect"])
            check_type(argname="argument enable_push", value=enable_push, expected_type=type_hints["enable_push"])
            check_type(argname="argument enable_ro", value=enable_ro, expected_type=type_hints["enable_ro"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preload_enable", value=preload_enable, expected_type=type_hints["preload_enable"])
            check_type(argname="argument source", value=source, expected_type=type_hints["source"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_brotli", value=title_brotli, expected_type=type_hints["title_brotli"])
            check_type(argname="argument title_http2_server_push", value=title_http2_server_push, expected_type=type_hints["title_http2_server_push"])
            check_type(argname="argument title_preconnect", value=title_preconnect, expected_type=type_hints["title_preconnect"])
            check_type(argname="argument title_preload", value=title_preload, expected_type=type_hints["title_preload"])
            check_type(argname="argument title_ro", value=title_ro, expected_type=type_hints["title_ro"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_logic is not None:
            self._values["ab_logic"] = ab_logic
        if ab_testing is not None:
            self._values["ab_testing"] = ab_testing
        if compression is not None:
            self._values["compression"] = compression
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if enable_brotli_compression is not None:
            self._values["enable_brotli_compression"] = enable_brotli_compression
        if enable_for_noncacheable is not None:
            self._values["enable_for_noncacheable"] = enable_for_noncacheable
        if enable_preconnect is not None:
            self._values["enable_preconnect"] = enable_preconnect
        if enable_push is not None:
            self._values["enable_push"] = enable_push
        if enable_ro is not None:
            self._values["enable_ro"] = enable_ro
        if locked is not None:
            self._values["locked"] = locked
        if preload_enable is not None:
            self._values["preload_enable"] = preload_enable
        if source is not None:
            self._values["source"] = source
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_brotli is not None:
            self._values["title_brotli"] = title_brotli
        if title_http2_server_push is not None:
            self._values["title_http2_server_push"] = title_http2_server_push
        if title_preconnect is not None:
            self._values["title_preconnect"] = title_preconnect
        if title_preload is not None:
            self._values["title_preload"] = title_preload
        if title_ro is not None:
            self._values["title_ro"] = title_ro
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def ab_logic(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to use Adaptive Acceleration in an A/B testing environment.

        To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        '''
        result = self._values.get("ab_logic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ab_testing(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        '''
        result = self._values.get("ab_testing")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compression(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        '''
        result = self._values.get("compression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_brotli_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression, converting your origin content to cache on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        '''
        result = self._values.get("enable_brotli_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_for_noncacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression to non-cacheable content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        '''
        result = self._values.get("enable_for_noncacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_preconnect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time.

        See ``Automatic Preconnect`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        '''
        result = self._values.get("enable_preconnect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_push(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Recognizes resources like JavaScript, CSS, and images  based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app.

        See ``Automatic Server Push`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        '''
        result = self._values.get("enable_push")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ro(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        '''
        result = self._values.get("enable_ro")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preload_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to preload necessary fonts before they fetch and process other resources.

        See ``Automatic Font Preload`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        '''
        result = self._values.get("preload_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def source(self) -> typing.Optional[builtins.str]:
        '''The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``.

        The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        '''
        result = self._values.get("source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_brotli(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        '''
        result = self._values.get("title_brotli")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_http2_server_push(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        '''
        result = self._values.get("title_http2_server_push")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preconnect(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        '''
        result = self._values.get("title_preconnect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preload(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        '''
        result = self._values.get("title_preload")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_ro(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        '''
        result = self._values.get("title_ro")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce397b94b949ea697fbfe59cf05a12795b6e1527555ff174aface96fbba18a83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbLogic")
    def reset_ab_logic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbLogic", []))

    @jsii.member(jsii_name="resetAbTesting")
    def reset_ab_testing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbTesting", []))

    @jsii.member(jsii_name="resetCompression")
    def reset_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompression", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetEnableBrotliCompression")
    def reset_enable_brotli_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBrotliCompression", []))

    @jsii.member(jsii_name="resetEnableForNoncacheable")
    def reset_enable_for_noncacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableForNoncacheable", []))

    @jsii.member(jsii_name="resetEnablePreconnect")
    def reset_enable_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePreconnect", []))

    @jsii.member(jsii_name="resetEnablePush")
    def reset_enable_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePush", []))

    @jsii.member(jsii_name="resetEnableRo")
    def reset_enable_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreloadEnable")
    def reset_preload_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreloadEnable", []))

    @jsii.member(jsii_name="resetSource")
    def reset_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSource", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleBrotli")
    def reset_title_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleBrotli", []))

    @jsii.member(jsii_name="resetTitleHttp2ServerPush")
    def reset_title_http2_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleHttp2ServerPush", []))

    @jsii.member(jsii_name="resetTitlePreconnect")
    def reset_title_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreconnect", []))

    @jsii.member(jsii_name="resetTitlePreload")
    def reset_title_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreload", []))

    @jsii.member(jsii_name="resetTitleRo")
    def reset_title_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleRo", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="abLogicInput")
    def ab_logic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abLogicInput"))

    @builtins.property
    @jsii.member(jsii_name="abTestingInput")
    def ab_testing_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abTestingInput"))

    @builtins.property
    @jsii.member(jsii_name="compressionInput")
    def compression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "compressionInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompressionInput")
    def enable_brotli_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBrotliCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheableInput")
    def enable_for_noncacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableForNoncacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePreconnectInput")
    def enable_preconnect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePushInput")
    def enable_push_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePushInput"))

    @builtins.property
    @jsii.member(jsii_name="enableRoInput")
    def enable_ro_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadEnableInput")
    def preload_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceInput")
    def source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleBrotliInput")
    def title_brotli_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleBrotliInput"))

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPushInput")
    def title_http2_server_push_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleHttp2ServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreconnectInput")
    def title_preconnect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreloadInput")
    def title_preload_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreloadInput"))

    @builtins.property
    @jsii.member(jsii_name="titleRoInput")
    def title_ro_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleRoInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="abLogic")
    def ab_logic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abLogic"))

    @ab_logic.setter
    def ab_logic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df7f6fe5a804584584994589a40171fdbd353ec43bd18f330d308182326c3523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abLogic", value)

    @builtins.property
    @jsii.member(jsii_name="abTesting")
    def ab_testing(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abTesting"))

    @ab_testing.setter
    def ab_testing(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b6c487a023d559f4a4c4c0d7144006ef144695a0b9127e42d39bc1595b3523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abTesting", value)

    @builtins.property
    @jsii.member(jsii_name="compression")
    def compression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "compression"))

    @compression.setter
    def compression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e009f024e9f690d57c37653a40a981f2b249dfd4c353240333c3973063f56f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compression", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb028b0a9fa9725494f6526160c192ab363160f92c9bc92c7135726033c49e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompression")
    def enable_brotli_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBrotliCompression"))

    @enable_brotli_compression.setter
    def enable_brotli_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1442d18d9187006402ea106b0df1076b11a22fff704b6bc5f6b6f55620d6f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBrotliCompression", value)

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheable")
    def enable_for_noncacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableForNoncacheable"))

    @enable_for_noncacheable.setter
    def enable_for_noncacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2bb8e3100c9054eba613a1a129a6db3836a691eb9b9e7b7414f1bcf421930e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableForNoncacheable", value)

    @builtins.property
    @jsii.member(jsii_name="enablePreconnect")
    def enable_preconnect(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePreconnect"))

    @enable_preconnect.setter
    def enable_preconnect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb34ef8a043e979b2cccc38b50003eee402b187653cdba20670d58c18577c1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="enablePush")
    def enable_push(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePush"))

    @enable_push.setter
    def enable_push(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14336263d369be69481abc1bc0242c3e4e43cdc7c032321c615891a34611e240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePush", value)

    @builtins.property
    @jsii.member(jsii_name="enableRo")
    def enable_ro(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRo"))

    @enable_ro.setter
    def enable_ro(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__390833eb1ca36a72f4658403c5339ba4a32271267afe4156132ab938eda0a005)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRo", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ba5f32d760bd1952547902550bfb1be815b8b71adf8fbb5058e0e7dace91cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preloadEnable")
    def preload_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preloadEnable"))

    @preload_enable.setter
    def preload_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f2d33b2e2f0bc34c1d114b19caeba46902d554d4f93f338dcb3855f83f2ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preloadEnable", value)

    @builtins.property
    @jsii.member(jsii_name="source")
    def source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "source"))

    @source.setter
    def source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__394219d49cf188e44fe542d3961fbef7ff6dee626622e822ae6bcd2737b1cd23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "source", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__717bec8f00768713a8a9e0d12ecd61b854c408b43c2628e7f84e0192809a7cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleBrotli")
    def title_brotli(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleBrotli"))

    @title_brotli.setter
    def title_brotli(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b098a15f3e9ff76ad728a123d23ec0a1ad20fbaef333b20632879904c163fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleBrotli", value)

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPush")
    def title_http2_server_push(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleHttp2ServerPush"))

    @title_http2_server_push.setter
    def title_http2_server_push(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5b571ecddcfa82c5496dd298dde45ced15011ed75793531016306b2d3edbe18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleHttp2ServerPush", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreconnect")
    def title_preconnect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreconnect"))

    @title_preconnect.setter
    def title_preconnect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88befd8f7bf9b4eca8650b15f2ca56c720fdd277993fa7205bb8c39b765d060d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreload")
    def title_preload(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreload"))

    @title_preload.setter
    def title_preload(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e344b01d2780bcc4cf625342eb6c1233ef8e0b97144887322f1cc72673729f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreload", value)

    @builtins.property
    @jsii.member(jsii_name="titleRo")
    def title_ro(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleRo"))

    @title_ro.setter
    def title_ro(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515455833004b372f84fc27f9aac6e03bd05a1583fdd3258f0d59e9e406b5f5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleRo", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab39efa2c6604683802cb1b9b7487bce8b77b3d0f10fa005e9c7d0c4bba6060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83df80d7b263cc337c18a00504942c114bf88b9d2c7cdb35b569f4d887ebd5d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression",
    jsii_struct_bases=[],
    name_mapping={
        "compress_mobile": "compressMobile",
        "compress_standard": "compressStandard",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier1_mobile_compression_method": "tier1MobileCompressionMethod",
        "tier1_mobile_compression_value": "tier1MobileCompressionValue",
        "tier1_standard_compression_method": "tier1StandardCompressionMethod",
        "tier1_standard_compression_value": "tier1StandardCompressionValue",
        "tier2_mobile_compression_method": "tier2MobileCompressionMethod",
        "tier2_mobile_compression_value": "tier2MobileCompressionValue",
        "tier2_standard_compression_method": "tier2StandardCompressionMethod",
        "tier2_standard_compression_value": "tier2StandardCompressionValue",
        "tier3_mobile_compression_method": "tier3MobileCompressionMethod",
        "tier3_mobile_compression_value": "tier3MobileCompressionValue",
        "tier3_standard_compression_method": "tier3StandardCompressionMethod",
        "tier3_standard_compression_value": "tier3StandardCompressionValue",
        "title_aic_mobile": "titleAicMobile",
        "title_aic_nonmobile": "titleAicNonmobile",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression:
    def __init__(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c888b1283c26a0b3d694f13eb4a6532d64c4ee76e9ed953a4a88162564dabc)
            check_type(argname="argument compress_mobile", value=compress_mobile, expected_type=type_hints["compress_mobile"])
            check_type(argname="argument compress_standard", value=compress_standard, expected_type=type_hints["compress_standard"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_mobile_compression_method", value=tier1_mobile_compression_method, expected_type=type_hints["tier1_mobile_compression_method"])
            check_type(argname="argument tier1_mobile_compression_value", value=tier1_mobile_compression_value, expected_type=type_hints["tier1_mobile_compression_value"])
            check_type(argname="argument tier1_standard_compression_method", value=tier1_standard_compression_method, expected_type=type_hints["tier1_standard_compression_method"])
            check_type(argname="argument tier1_standard_compression_value", value=tier1_standard_compression_value, expected_type=type_hints["tier1_standard_compression_value"])
            check_type(argname="argument tier2_mobile_compression_method", value=tier2_mobile_compression_method, expected_type=type_hints["tier2_mobile_compression_method"])
            check_type(argname="argument tier2_mobile_compression_value", value=tier2_mobile_compression_value, expected_type=type_hints["tier2_mobile_compression_value"])
            check_type(argname="argument tier2_standard_compression_method", value=tier2_standard_compression_method, expected_type=type_hints["tier2_standard_compression_method"])
            check_type(argname="argument tier2_standard_compression_value", value=tier2_standard_compression_value, expected_type=type_hints["tier2_standard_compression_value"])
            check_type(argname="argument tier3_mobile_compression_method", value=tier3_mobile_compression_method, expected_type=type_hints["tier3_mobile_compression_method"])
            check_type(argname="argument tier3_mobile_compression_value", value=tier3_mobile_compression_value, expected_type=type_hints["tier3_mobile_compression_value"])
            check_type(argname="argument tier3_standard_compression_method", value=tier3_standard_compression_method, expected_type=type_hints["tier3_standard_compression_method"])
            check_type(argname="argument tier3_standard_compression_value", value=tier3_standard_compression_value, expected_type=type_hints["tier3_standard_compression_value"])
            check_type(argname="argument title_aic_mobile", value=title_aic_mobile, expected_type=type_hints["title_aic_mobile"])
            check_type(argname="argument title_aic_nonmobile", value=title_aic_nonmobile, expected_type=type_hints["title_aic_nonmobile"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compress_mobile is not None:
            self._values["compress_mobile"] = compress_mobile
        if compress_standard is not None:
            self._values["compress_standard"] = compress_standard
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_mobile_compression_method is not None:
            self._values["tier1_mobile_compression_method"] = tier1_mobile_compression_method
        if tier1_mobile_compression_value is not None:
            self._values["tier1_mobile_compression_value"] = tier1_mobile_compression_value
        if tier1_standard_compression_method is not None:
            self._values["tier1_standard_compression_method"] = tier1_standard_compression_method
        if tier1_standard_compression_value is not None:
            self._values["tier1_standard_compression_value"] = tier1_standard_compression_value
        if tier2_mobile_compression_method is not None:
            self._values["tier2_mobile_compression_method"] = tier2_mobile_compression_method
        if tier2_mobile_compression_value is not None:
            self._values["tier2_mobile_compression_value"] = tier2_mobile_compression_value
        if tier2_standard_compression_method is not None:
            self._values["tier2_standard_compression_method"] = tier2_standard_compression_method
        if tier2_standard_compression_value is not None:
            self._values["tier2_standard_compression_value"] = tier2_standard_compression_value
        if tier3_mobile_compression_method is not None:
            self._values["tier3_mobile_compression_method"] = tier3_mobile_compression_method
        if tier3_mobile_compression_value is not None:
            self._values["tier3_mobile_compression_value"] = tier3_mobile_compression_value
        if tier3_standard_compression_method is not None:
            self._values["tier3_standard_compression_method"] = tier3_standard_compression_method
        if tier3_standard_compression_value is not None:
            self._values["tier3_standard_compression_value"] = tier3_standard_compression_value
        if title_aic_mobile is not None:
            self._values["title_aic_mobile"] = title_aic_mobile
        if title_aic_nonmobile is not None:
            self._values["title_aic_nonmobile"] = title_aic_nonmobile
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compress_mobile(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over cellular mobile networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        '''
        result = self._values.get("compress_mobile")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def compress_standard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over non-cellular networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        '''
        result = self._values.get("compress_standard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        '''
        result = self._values.get("tier1_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        '''
        result = self._values.get("tier1_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier1_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        '''
        result = self._values.get("tier1_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        '''
        result = self._values.get("tier1_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        '''
        result = self._values.get("tier2_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        '''
        result = self._values.get("tier2_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        '''
        result = self._values.get("tier2_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        '''
        result = self._values.get("tier2_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        '''
        result = self._values.get("tier3_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        '''
        result = self._values.get("tier3_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        '''
        result = self._values.get("tier3_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        '''
        result = self._values.get("tier3_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def title_aic_mobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        '''
        result = self._values.get("title_aic_mobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_aic_nonmobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        '''
        result = self._values.get("title_aic_nonmobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6fd200d8fa37adcff7518734cc238f16190fda58a71f5d092e6acf7b321d9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompressMobile")
    def reset_compress_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressMobile", []))

    @jsii.member(jsii_name="resetCompressStandard")
    def reset_compress_standard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressStandard", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionMethod")
    def reset_tier1_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionValue")
    def reset_tier1_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionMethod")
    def reset_tier1_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionValue")
    def reset_tier1_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionMethod")
    def reset_tier2_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionValue")
    def reset_tier2_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionMethod")
    def reset_tier2_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionValue")
    def reset_tier2_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionMethod")
    def reset_tier3_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionValue")
    def reset_tier3_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionMethod")
    def reset_tier3_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionValue")
    def reset_tier3_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTitleAicMobile")
    def reset_title_aic_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicMobile", []))

    @jsii.member(jsii_name="resetTitleAicNonmobile")
    def reset_title_aic_nonmobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicNonmobile", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compressMobileInput")
    def compress_mobile_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="compressStandardInput")
    def compress_standard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressStandardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethodInput")
    def tier1_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValueInput")
    def tier1_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethodInput")
    def tier1_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValueInput")
    def tier1_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethodInput")
    def tier2_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValueInput")
    def tier2_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethodInput")
    def tier2_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValueInput")
    def tier2_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethodInput")
    def tier3_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValueInput")
    def tier3_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethodInput")
    def tier3_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValueInput")
    def tier3_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicMobileInput")
    def title_aic_mobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobileInput")
    def title_aic_nonmobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicNonmobileInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compressMobile")
    def compress_mobile(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressMobile"))

    @compress_mobile.setter
    def compress_mobile(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9407eeecc2456cd55625b05c7de231bf48de4d9e1b612bc195591ce006c7eb3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressMobile", value)

    @builtins.property
    @jsii.member(jsii_name="compressStandard")
    def compress_standard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressStandard"))

    @compress_standard.setter
    def compress_standard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15efa0af217a148411693be7bd20ad5ecaefa6620aebf949db3d08f44c0b4228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressStandard", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ddc3b0198a563b355aabaa2d459ae229dfc23befed88fe5db31fa7f0cdfd57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb1eda6c3a9a187faa2bd790254bb722f34224adbd81c00c13f01609820ec1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethod")
    def tier1_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1MobileCompressionMethod"))

    @tier1_mobile_compression_method.setter
    def tier1_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e468850572053f03dc19b33725f2676048389326d4b3261d97f9015acbce9754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValue")
    def tier1_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1MobileCompressionValue"))

    @tier1_mobile_compression_value.setter
    def tier1_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b87c985da1b825a7ed6b57503543dacf326fa50047ac712138f73a5d782486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethod")
    def tier1_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1StandardCompressionMethod"))

    @tier1_standard_compression_method.setter
    def tier1_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6a9314643e4a66338d9517f881ead07500b01a4b2354c101a8ad745977dd9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValue")
    def tier1_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1StandardCompressionValue"))

    @tier1_standard_compression_value.setter
    def tier1_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feb50694ee7150140c39342de594f8eff46371ab2aba5cd1cee2343720aa554f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethod")
    def tier2_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2MobileCompressionMethod"))

    @tier2_mobile_compression_method.setter
    def tier2_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a36e8728b2c7632632cff632c7fb9e465bf081ea710cb06d015d0dd24cdf167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValue")
    def tier2_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2MobileCompressionValue"))

    @tier2_mobile_compression_value.setter
    def tier2_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190a51959bafdc882bf69a760290a51674cd8f267808da123299e1099e31965c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethod")
    def tier2_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2StandardCompressionMethod"))

    @tier2_standard_compression_method.setter
    def tier2_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0e88e4e4e5aaa6c1399838d69792ff19ecee5b909c39b31527ec1ac847cf50f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValue")
    def tier2_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2StandardCompressionValue"))

    @tier2_standard_compression_value.setter
    def tier2_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__121643a1131051ac6e11364b832b3dc35c362a14c1e9ce47c5fbcaa50a5fdb12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethod")
    def tier3_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3MobileCompressionMethod"))

    @tier3_mobile_compression_method.setter
    def tier3_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa4139bb1c6bf4cb9f303b313b8526853fd832f6193754ba25a87f467be68c94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValue")
    def tier3_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3MobileCompressionValue"))

    @tier3_mobile_compression_value.setter
    def tier3_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed6dbba77b7d543edd00729d5f9ee49ad38c28d20ecb4a637a1a4e0850c69091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethod")
    def tier3_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3StandardCompressionMethod"))

    @tier3_standard_compression_method.setter
    def tier3_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98e66d1b4ccaa310e7c4bd50f9d2c5224b2c75313a608515c63692834bd18451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValue")
    def tier3_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3StandardCompressionValue"))

    @tier3_standard_compression_value.setter
    def tier3_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0872b7247c3264b9beeb2ab8341b3d22cc054b75b42dfbb450ef78d88ce6613e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicMobile")
    def title_aic_mobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicMobile"))

    @title_aic_mobile.setter
    def title_aic_mobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ccc43be76cb3a92a68ea1fc124a0074c63503415fc6570b69a48a7e987db9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicMobile", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobile")
    def title_aic_nonmobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicNonmobile"))

    @title_aic_nonmobile.setter
    def title_aic_nonmobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cccb6fa862b6f948c239e535365f82d03a85eb5a81300fca84e201cd08f8400a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicNonmobile", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52927ea3c313a6cbfd7318d58a3cd309df5522770086728065038644a897990d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f6ac8245782c4e3b43ae0a4216994a62e565f0497d620154f1305e7774b8fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387697263234a9ecf36b5b515f61c0d5d72d0ac825e910bf9d21a4d44a7772fe)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246681faf2cb67945f5060148ef11a39828d61118278a017916c35682fd5794c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daed56a9fcbe071214d432056e4decb93e7b4e979531d7a7859f8a94764e4b07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f1e493073e6f9f91585d7b2ec4b1c66281bdeabb5bd0dfb019305cfeb394ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55280c38ded586921424ea760d6ee4d02824df95d2ade8b3120feed8bf46e65a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fcd42a9637e5c496e7eeed2ae9b25db85dd27cf1777641a0339f246b4d93363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f09085e94c33a31afee761788ca191b8cf9799ac07d060815a1481b2ad3e3bf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb88ccc6d28150a41765a9d88e43c8ef3cf1653585bcfa07778941a00f7afb46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting",
    jsii_struct_bases=[],
    name_mapping={
        "attribute1": "attribute1",
        "attribute2": "attribute2",
        "attribute3": "attribute3",
        "attribute4": "attribute4",
        "attributes_count": "attributesCount",
        "enabled": "enabled",
        "locked": "locked",
        "report_name": "reportName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting:
    def __init__(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20c150d8f65582e485045c7f62cd06bc42d3cfcb322060623c63a74bd7b014a)
            check_type(argname="argument attribute1", value=attribute1, expected_type=type_hints["attribute1"])
            check_type(argname="argument attribute2", value=attribute2, expected_type=type_hints["attribute2"])
            check_type(argname="argument attribute3", value=attribute3, expected_type=type_hints["attribute3"])
            check_type(argname="argument attribute4", value=attribute4, expected_type=type_hints["attribute4"])
            check_type(argname="argument attributes_count", value=attributes_count, expected_type=type_hints["attributes_count"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument report_name", value=report_name, expected_type=type_hints["report_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if attribute1 is not None:
            self._values["attribute1"] = attribute1
        if attribute2 is not None:
            self._values["attribute2"] = attribute2
        if attribute3 is not None:
            self._values["attribute3"] = attribute3
        if attribute4 is not None:
            self._values["attribute4"] = attribute4
        if attributes_count is not None:
            self._values["attributes_count"] = attributes_count
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if report_name is not None:
            self._values["report_name"] = report_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def attribute1(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        '''
        result = self._values.get("attribute1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute2(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        '''
        result = self._values.get("attribute2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute3(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        '''
        result = self._values.get("attribute3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute4(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        '''
        result = self._values.get("attribute4")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attributes_count(self) -> typing.Optional[jsii.Number]:
        '''The number of attributes to include in the report, ranging from 1 to 4.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        '''
        result = self._values.get("attributes_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables aggregated reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def report_name(self) -> typing.Optional[builtins.str]:
        '''The unique name of the aggregated report within the property.

        If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        '''
        result = self._values.get("report_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71aa84d7b848e3d1baf1ecf78144f1c094707e8af7d4851f9793825c0084d42c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAttribute1")
    def reset_attribute1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute1", []))

    @jsii.member(jsii_name="resetAttribute2")
    def reset_attribute2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute2", []))

    @jsii.member(jsii_name="resetAttribute3")
    def reset_attribute3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute3", []))

    @jsii.member(jsii_name="resetAttribute4")
    def reset_attribute4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute4", []))

    @jsii.member(jsii_name="resetAttributesCount")
    def reset_attributes_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttributesCount", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReportName")
    def reset_report_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReportName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="attribute1Input")
    def attribute1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute1Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute2Input")
    def attribute2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute2Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute3Input")
    def attribute3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute3Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute4Input")
    def attribute4_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute4Input"))

    @builtins.property
    @jsii.member(jsii_name="attributesCountInput")
    def attributes_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "attributesCountInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reportNameInput")
    def report_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reportNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="attribute1")
    def attribute1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute1"))

    @attribute1.setter
    def attribute1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__256ba134b38a553639db4697af53b5c89004ee236df94079076d458b295d0648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute1", value)

    @builtins.property
    @jsii.member(jsii_name="attribute2")
    def attribute2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute2"))

    @attribute2.setter
    def attribute2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b870898bb4078d495485b79e4848724a8939102867d3382d455428c3269d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute2", value)

    @builtins.property
    @jsii.member(jsii_name="attribute3")
    def attribute3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute3"))

    @attribute3.setter
    def attribute3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa5cb012c1aa9e3b4d507ec4c4e0a66b90d1d0236cc987cf179012201bcf500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute3", value)

    @builtins.property
    @jsii.member(jsii_name="attribute4")
    def attribute4(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute4"))

    @attribute4.setter
    def attribute4(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e6bf910aa155efdc3d57343cb82d09e74d8fa1ac5ac8b880619bdf0888e557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute4", value)

    @builtins.property
    @jsii.member(jsii_name="attributesCount")
    def attributes_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "attributesCount"))

    @attributes_count.setter
    def attributes_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082db1629ed56cef08ab47eeb96ed89500fb7ed0c258e0040312dc83aab696bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attributesCount", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4fc374780340bc1f6bffb7821f80a9a7234dbf9c940470df4a642d11243b3a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f66cd11107aaaa31a5eeed25c0fd7be41f155f95fee323c113d75304925974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reportName")
    def report_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reportName"))

    @report_name.setter
    def report_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c2188e9843fe9b641edf10a1bac2b31042d709dc7191137c7be11d842bae88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reportName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a7877f112a14693805743feb95180d2aee01ee9e5d9131db1943bef05941db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46249f29b07b9304020ffddc27ca2354a9ef1d19633aa53a909d252a51e9186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7a531e0832114fe4b95cf74a4c1b51f51b392120bb30012b0e8197869c75bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf9f7991a6fd097b100d77ea30f4954c43e99c88cbb201d3b1a5036e7df4d79)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamaizer behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988fe9735135d3c7a6cbb774a74c98d197f6193253711d161ef4d019322ae8b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1bc9bd5d5aee4804f425329fae8f9ec7bc52a597ceebef35aee58b7edc29aa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50e10604980783c1b05d25ef5beb407e168e6e95c66a4dbb6da48a0552fa0f50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5d861d75bed33ce5eac20422dbb6de0790683f1728f465b0a7b78d6184b2c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33925e34128e22b908b8677314dbb1eb3f201a86114fc38a894acc6967e5bec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c825a392d7812409baeb0f555608d6cc2fb6bc5c46220b9a4ef7de32f84f9063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag",
    jsii_struct_bases=[],
    name_mapping={
        "include_tags_attribute": "includeTagsAttribute",
        "locked": "locked",
        "match_hostname": "matchHostname",
        "replace_all": "replaceAll",
        "replacement_hostname": "replacementHostname",
        "scope": "scope",
        "tags_attribute": "tagsAttribute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag:
    def __init__(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ca2b193519c0914f127955cd84449f00d0a751d18f384b3f447385c57437d88)
            check_type(argname="argument include_tags_attribute", value=include_tags_attribute, expected_type=type_hints["include_tags_attribute"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_hostname", value=match_hostname, expected_type=type_hints["match_hostname"])
            check_type(argname="argument replace_all", value=replace_all, expected_type=type_hints["replace_all"])
            check_type(argname="argument replacement_hostname", value=replacement_hostname, expected_type=type_hints["replacement_hostname"])
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument tags_attribute", value=tags_attribute, expected_type=type_hints["tags_attribute"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if include_tags_attribute is not None:
            self._values["include_tags_attribute"] = include_tags_attribute
        if locked is not None:
            self._values["locked"] = locked
        if match_hostname is not None:
            self._values["match_hostname"] = match_hostname
        if replace_all is not None:
            self._values["replace_all"] = replace_all
        if replacement_hostname is not None:
            self._values["replacement_hostname"] = replacement_hostname
        if scope is not None:
            self._values["scope"] = scope
        if tags_attribute is not None:
            self._values["tags_attribute"] = tags_attribute
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def include_tags_attribute(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the ``tagsAttribute`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        '''
        result = self._values.get("include_tags_attribute")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to match on as a Perl-compatible regular expression.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        '''
        result = self._values.get("match_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replace_all(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches when enabled, otherwise replaces only the first match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        '''
        result = self._values.get("replace_all")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def replacement_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement hostname for the tag to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        '''
        result = self._values.get("replacement_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scope(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of HTML content the ``tagsAttribute`` refers to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        '''
        result = self._values.get("scope")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tags_attribute(self) -> typing.Optional[builtins.str]:
        '''Specifies the tag or tag/attribute combination to operate on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        '''
        result = self._values.get("tags_attribute")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a6e57127d590f887e2b34b4d1e3f36a8bcbec2064a4fbeab494ce8d1a0094a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetIncludeTagsAttribute")
    def reset_include_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeTagsAttribute", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchHostname")
    def reset_match_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchHostname", []))

    @jsii.member(jsii_name="resetReplaceAll")
    def reset_replace_all(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplaceAll", []))

    @jsii.member(jsii_name="resetReplacementHostname")
    def reset_replacement_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacementHostname", []))

    @jsii.member(jsii_name="resetScope")
    def reset_scope(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScope", []))

    @jsii.member(jsii_name="resetTagsAttribute")
    def reset_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTagsAttribute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttributeInput")
    def include_tags_attribute_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeTagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchHostnameInput")
    def match_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="replaceAllInput")
    def replace_all_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "replaceAllInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementHostnameInput")
    def replacement_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="scopeInput")
    def scope_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scopeInput"))

    @builtins.property
    @jsii.member(jsii_name="tagsAttributeInput")
    def tags_attribute_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttribute")
    def include_tags_attribute(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeTagsAttribute"))

    @include_tags_attribute.setter
    def include_tags_attribute(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd7ce6c97c5f74dae2fb7789171948d735eba999c2b37008b074d37601da8420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeTagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d64bd1aba9654dadf08d54f0031a5c0102b7d23a1136d515e32c46323192e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchHostname")
    def match_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchHostname"))

    @match_hostname.setter
    def match_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f243872e15161d407e6c5cb1975ba504cb1ff087602ec6ed726a61442eae51a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchHostname", value)

    @builtins.property
    @jsii.member(jsii_name="replaceAll")
    def replace_all(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "replaceAll"))

    @replace_all.setter
    def replace_all(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5507a2979e52a16b54eec4e466c0f1a399dbe94c6c03915466cd4801c7d636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replaceAll", value)

    @builtins.property
    @jsii.member(jsii_name="replacementHostname")
    def replacement_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacementHostname"))

    @replacement_hostname.setter
    def replacement_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dfc780a4c6b29f71596366833865ac8984841ab81ea7373bec6ecf64c65286a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacementHostname", value)

    @builtins.property
    @jsii.member(jsii_name="scope")
    def scope(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scope"))

    @scope.setter
    def scope(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6a9166e1f6b836f0f222a2fe7231ecbdc04c199607cc1ef27701f1f60986229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scope", value)

    @builtins.property
    @jsii.member(jsii_name="tagsAttribute")
    def tags_attribute(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tagsAttribute"))

    @tags_attribute.setter
    def tags_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69956929a0041afb1e10834ff497d1f59ae5e3bd888371a4c36e5685446529e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edad90df5788fab2b5c664aa38d62e80979568ff776436572535f8ac7f62ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a40884fa82a229c67f2c830fbaae7a4225a4bb53683b276cc02ffcba1b589f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd61b6db46baf3b6314953a83f460963eaeca2ca2f37d67cc3d1b0419e32dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cad663c3217929a62ba5c4b97265361209521a121285782dc818ea9fb647517)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables all HTTP requests for parent servers in the cache hierarchy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25574b721b2d11da035381d7abd973d24e9cb01ba88146f0c55ab6737786fd86)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8762cc37d7862cd2bccd12b91e54ed8e88ff60a0601845c56ba244c41a5db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__508e1ab6e9c7ccf4686795be80a1b946de493034b8df8fed2927a5f3776821e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905aa2dbbd45345e558194abc0978bfaab1efd24cf3aaec39584c409b3460fd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cede92b3d0a5639c9abb2d5fd9e5088df4320776f514e99975925c2bdbececb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7b25a9cec83d05fdf7cd148beca17a58439f527e270c71724ef6cdd6f64e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "honor_base_directory": "honorBaseDirectory",
        "locked": "locked",
        "purge_origin_query_parameter": "purgeOriginQueryParameter",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2765d76e4d8d65ef044559adbb1769514ad9e4b3de6e94d51e3951bf8db665)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument honor_base_directory", value=honor_base_directory, expected_type=type_hints["honor_base_directory"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_origin_query_parameter", value=purge_origin_query_parameter, expected_type=type_hints["purge_origin_query_parameter"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if honor_base_directory is not None:
            self._values["honor_base_directory"] = honor_base_directory
        if locked is not None:
            self._values["locked"] = locked
        if purge_origin_query_parameter is not None:
            self._values["purge_origin_query_parameter"] = purge_origin_query_parameter
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_base_directory(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior.

        If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        '''
        result = self._values.get("honor_base_directory")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_origin_query_parameter(self) -> typing.Optional[builtins.str]:
        '''When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge.

        Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        '''
        result = self._values.get("purge_origin_query_parameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOriginsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOriginsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55cd5cdf24c2fb885726647993ef5e3dae8747cc3ec6e1fc9dbfcfb8104cfd74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHonorBaseDirectory")
    def reset_honor_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorBaseDirectory", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeOriginQueryParameter")
    def reset_purge_origin_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeOriginQueryParameter", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectoryInput")
    def honor_base_directory_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorBaseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameterInput")
    def purge_origin_query_parameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeOriginQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef9fc9914fdca6070423674b8b8f5158935a01b4bcd5fd58d136aecea6fad069)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectory")
    def honor_base_directory(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorBaseDirectory"))

    @honor_base_directory.setter
    def honor_base_directory(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cdb9954826ff2ef8e0a633425ed1901577e7016c0d08cb613e83b5f8785f4a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorBaseDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ef7a37078ebf9d67fa0fce9ca99a07c4684cf8b6f4e581209bf2660aecc105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameter")
    def purge_origin_query_parameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeOriginQueryParameter"))

    @purge_origin_query_parameter.setter
    def purge_origin_query_parameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a734dbac7316ce0b9c4514620adf4e20d4f6f79813bc566957ab127284122dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeOriginQueryParameter", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27876ab8ab9c057993f4b69d862e43534f0434eedb89f0145fc80dbb608b89a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96541f881f27a33f09c914e221156e6a694357f3c4bee8c02124125bb8d834ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e240a4126906684af6a670e835ff3322c6e4457991ba37a5d27dc165e0af68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete",
    jsii_struct_bases=[],
    name_mapping={
        "allow_body": "allowBody",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete:
    def __init__(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6deda17c1693d969427dcdc2c588cfcdd806c87093f9dfd79bac42f2990b0971)
            check_type(argname="argument allow_body", value=allow_body, expected_type=type_hints["allow_body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_body is not None:
            self._values["allow_body"] = allow_body
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_body(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows data in the body of the DELETE request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        '''
        result = self._values.get("allow_body")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows DELETE requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDeleteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDeleteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e97b4dcfa199ebaa34bee20deafda47d0592275864517df14921ac42276fe41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBody")
    def reset_allow_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBodyInput")
    def allow_body_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBody")
    def allow_body(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowBody"))

    @allow_body.setter
    def allow_body(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7987593e0a66b06bbd899922e28346849c35343761d31827763bd3fcbc1c5b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBody", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60d139e5186618db0f8662623c17a6f7467a09f277b787d92b5ca45a1e3ae89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460ddc46bfbd187c4b7765c37d59a1f7877cfed3e359af8fb930780b1ae571b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ddd87c4d2fe9dd8518b8234853ce30575559a70b8bc69d029a5c2e5b5d909d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7126522a842e4773f290ae3f9a23e5c1794c132d7ddcfc49731080a4de6a4421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7caea8125c035007c1e5bc70b8444b287dc495129a5aa0b96549f65b699310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60747e32daa4caa1c6809d72429c98cb1ac505c847c9c7a936c3cc59e4cb8aa5)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HTTPS cache key sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c14f03e8ec3bbc445c91f90ebb80511b319f7ad4947342cad01fde9ec750792)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89de039a4de1bedff8bf16906d614554028130a5667eab61b5536bad8a6dfac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f6c37452f194af1213497c61c8a7b30f2fee3ea6346a16bff3124ce6fe21bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e1fe2e62a7c9f16972738856a2d56124f4019190e9814a37a05b6851dd6cb97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7eb87cf8260d82af665c01d28a0ace68fc745e47c18e84ed2ee63c91cf1fc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21088ae58e6abc597e76960db8ffae5a2f29a796e14238de61214704c2039a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3b1ce9b7af3c86db6c67034359519b27c8cc0078cc2094072e41ebc3a68feb)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Downgrades to HTTP protocol for the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db61c38cec5a28611d3b0c42040a4444c8bf29b19a82a44bd38f832799216e6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77f7f5ea99463c76c527ccc56fbe8d72b5c357af0fb5eaf15d5b2c0ba9d7907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3cd5e7658ba4aa7ca5b464d0e72bd8a85f41aca1e82e7fe9be3401c15dec59f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2912d767da3178971cf3b75527b4383251bc14696e22d3751a66e4cc79d4d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a93ea30027e74ec259b130f69163ff4331b55f8808ec6f1532fc7dd150de0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3fea5761c40929689ec8b4d107f0255db3568ff349bc420bf1378e91f0ebd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957c81dafca868bd14076c1e1036a8143fe5d4d0386c32afc69cdebb39b10349)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response.

        Set this to ``false`` to deny OPTIONS requests and respond with a 501 error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f722f6389a6a7d3df6558aedf049df2009b06bb216ba3e32bfb296837e00ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b5188c3f42dd6a2dc945ac1e3c2ec07eaa93672b68af126b6bce1f9d55c993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffff2eb9a0d4ddaeef1fa1edd367fdd0070cd72fa908f4367b12ad9737e2dbf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d96cca64374b0c0f64e8ab190251e4e48ee6215cc52dc90f038cdc161c7a248f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1db627122fa03a7ecbe539813fe55e20c86140da81d2e90dbdb7af85093393e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c97978be8a5b8f18d6d6bf7a3ca7b2f9274804b2528e640997eac66acf0543a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be3fa8320ac40cd99a520c7b4349d07e660b041a3c0ebdbfcc4cc39f88bd0e5)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PATCH requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce52e1f42645e7722732f10f6708146cd30c4e0308cb4f21d26ad50370e4ebfb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f4b7302fe9e1dda9efdbab755e276aabc9aed737e15ceab29a79054ff56cb14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8f0b7f55ce37ceb84130f5173fc50dd8166658083276087ca5197c4d4a7556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c43cfe6d0ee5ae7df7864740e2bda4d6b5ddc2f074aedd31958c6dc4affc55d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784ae5f896e2a62f1a9f8a5735b66e52e45ea07d44aee59a64a1379077470529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0133d8a071a9dd14cf7354be78f59e93774146351081b5c9456ef151010bbcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost",
    jsii_struct_bases=[],
    name_mapping={
        "allow_without_content_length": "allowWithoutContentLength",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost:
    def __init__(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99efe25366e8e0d345a5748e473754d3afc8aa7574df5b1be6c7f7a570aadb67)
            check_type(argname="argument allow_without_content_length", value=allow_without_content_length, expected_type=type_hints["allow_without_content_length"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_without_content_length is not None:
            self._values["allow_without_content_length"] = allow_without_content_length
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_without_content_length(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error.

        With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        '''
        result = self._values.get("allow_without_content_length")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9393f6e3f694f33b0d4f59a7d365a93c59c156944eb42989d8690d68a293ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowWithoutContentLength")
    def reset_allow_without_content_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowWithoutContentLength", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLengthInput")
    def allow_without_content_length_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowWithoutContentLengthInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLength")
    def allow_without_content_length(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowWithoutContentLength"))

    @allow_without_content_length.setter
    def allow_without_content_length(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1d9f5861aaf3864b7219a4603c1ce654888649dfedb67c46cd445a67cc023d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowWithoutContentLength", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ac9116662d1e20ae7b75d48ab215c1a30f6a8d690e362621f16c374974ddf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c894dd7dc48f0246fa864a9a9b9326af950c6928dd335627f7c9ffe1a363c454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983a0127bf1bde3b52eb4760c41b988449fd59a6985c310e421617b38bbcf824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edb8356fbca1fa7a9abf7b2981fd0f8b1265cc181ccef9032464b0054253955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb4dd7ad39dee2e6c67c07d20733543ae3f742508d3498a1b04a37a644992720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__672e642925f442c0217761547716c19112f4ac6c810aae5f38ddfe5c52d1dffa)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PUT requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34f086dd7dab62900b1d8e7e53cca522aa1f0169fe9dca849b36c127cbc4940)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb373381b21a75f671e6a51eecedb6da68eec0a6d5fa30703ec8b7e02b2eeb1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6f257a4cf32eebb1c43dc55cd67b6e57a74c36e33d7e3e6854bd1643570e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b6b07c19f016a9eb8e0ef8c22692d538eac80fef83fa9eb20109d05245342fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1b03d8d3768d8aee07ac90830f4127e8494ed039f924d55152d62d10346ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dff6ec2cc6775ee3a3e86a8f82f3bf7c134cfbc4fdbed14294f13c7904641159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410457bc2e001330ccaf89eb27c87040c7d957203890e434fb8e3e9e138ed2af)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Chunked Transfer Encoding requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncodingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncodingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b7cfd141a269d593ed6666dbbc48a64854b04710abe19735d136e5f6fd60a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97454e385b9dfbeb4ce17f2a97379ba63a29ef24f9e9bc0a923fb1ac80963743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee9fdf37be95e22b06e59fe455853ec3f93df4384840f5369fc0d6f7fd4d1e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20fed451b2847b991136b6dfc252c5dacc08bb7cc7e13a15d48769ec8ba67ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63da22583c2856144265771099cfaf5f66b13f67dfbe060fa0165f2a565dc2d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e51b217592c8297d686245465def11eec09ebbc3c9e04cf4888afdd76de3f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "max_age": "maxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba25a4cc56f111d3a26301087541b29572770e19a7924fd0199f0d87f4030c82)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[jsii.Number]:
        '''Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header.

        The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c1f3f5f2505c90b8ba5d8f237f53b2bcc92e47a8934241fe118bd6670cdf09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61cca4c34880d4b6d72d7508fd29d36af238fc3bc2a593cdf01db57ef9edd34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba702d1feb2fb934a8f3fc441cb077aa05e5392deeee6c9bf005f8eaeb67e4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183de904522474c2b9a393ce31f1317327b19a7835181f21221943bf9e52ebd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e4286e1b57bee6bc1b80d071ef67acde0811509c1a97e51ce10ea6148a6460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e45ba58b97fb8f42017e30490227bebd5438225d9630f5f002b0bc29403e8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "alternate_response_cache_ttl": "alternateResponseCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "label": "label",
        "locked": "locked",
        "net_storage": "netStorage",
        "net_storage_path": "netStoragePath",
        "template_uuid": "templateUuid",
        "throttled_cp_code": "throttledCpCode",
        "throttled_status_code": "throttledStatusCode",
        "use_throttled_cp_code": "useThrottledCpCode",
        "use_throttled_status_code": "useThrottledStatusCode",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization:
    def __init__(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage(**net_storage)
        if isinstance(throttled_cp_code, dict):
            throttled_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode(**throttled_cp_code)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143980a3af0c9ee5a4b0e3055a63739c7033472fe092d104bd6a9226b567f4ca)
            check_type(argname="argument alternate_response_cache_ttl", value=alternate_response_cache_ttl, expected_type=type_hints["alternate_response_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throttled_cp_code", value=throttled_cp_code, expected_type=type_hints["throttled_cp_code"])
            check_type(argname="argument throttled_status_code", value=throttled_status_code, expected_type=type_hints["throttled_status_code"])
            check_type(argname="argument use_throttled_cp_code", value=use_throttled_cp_code, expected_type=type_hints["use_throttled_cp_code"])
            check_type(argname="argument use_throttled_status_code", value=use_throttled_status_code, expected_type=type_hints["use_throttled_status_code"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if alternate_response_cache_ttl is not None:
            self._values["alternate_response_cache_ttl"] = alternate_response_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throttled_cp_code is not None:
            self._values["throttled_cp_code"] = throttled_cp_code
        if throttled_status_code is not None:
            self._values["throttled_status_code"] = throttled_status_code
        if use_throttled_cp_code is not None:
            self._values["use_throttled_cp_code"] = use_throttled_cp_code
        if use_throttled_status_code is not None:
            self._values["use_throttled_status_code"] = use_throttled_status_code
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def alternate_response_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the alternate response's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        '''
        result = self._values.get("alternate_response_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the API Prioritization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this API Prioritization policy from any others in the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''Specify the full NetStorage path for the alternate response, including trailing file name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throttled_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode"]:
        '''throttled_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        '''
        result = self._values.get("throttled_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode"], result)

    @builtins.property
    def throttled_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code for requests that receive the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        '''
        result = self._values.get("throttled_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def use_throttled_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to apply an alternative CP code for requests served the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        '''
        result = self._values.get("use_throttled_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def use_throttled_status_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a specific HTTP response code to a throttled request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        '''
        result = self._values.get("use_throttled_status_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723d6d12e15dbb0ca173c5dc3b7fd049f9796c559cedc3e7b8bffbcc879043e5)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ee30b6cc75a831b0341037c62ae6b0479618802ebec7dc593e8530092305ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619d2cf1eccaee85c1b6978fdeb5547be43e3f997e283501af86a9ffe8ac5f3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b04b987cf9514f869c809df7c51ad1c5cd137b905de8c8811df7652e8d5246e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2cc19a989dd2244b592b9c05e3e4bf3922181b5eede5a2834293823234b8c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe1b4f913b0aa52d4c9af1a1e20aad536d1523d9051392223199db6b8b617ab)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6df393235f6dc8a51afbe434b30b5fd3745f597d2a4ae774279ab8bce2ef4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f4e04b6d1a3ec7edf04b4b257b8d9c3ce063cf915a9dec9d5fec6784863b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cbd1383a3bec8219cc8f88d6abd5e250edaeae9e39d734ae4d89887076c1cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c58d6680e9fe7c5497ada4bed91d98a2fda548bde7763d60c1e5f2bc6ea7a6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c27c81b096317953f2ff14e0e523445f94be3b1d480d78b0b4e5cce7e477f98e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c84155d3a67f7d25316676c9e20c5dae8d9a408625fa840c700699df5a33f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="putThrottledCpCode")
    def put_throttled_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putThrottledCpCode", [value]))

    @jsii.member(jsii_name="resetAlternateResponseCacheTtl")
    def reset_alternate_response_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlternateResponseCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThrottledCpCode")
    def reset_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledCpCode", []))

    @jsii.member(jsii_name="resetThrottledStatusCode")
    def reset_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUseThrottledCpCode")
    def reset_use_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledCpCode", []))

    @jsii.member(jsii_name="resetUseThrottledStatusCode")
    def reset_use_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCode")
    def throttled_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeOutputReference", jsii.get(self, "throttledCpCode"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtlInput")
    def alternate_response_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "alternateResponseCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCodeInput")
    def throttled_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode"], jsii.get(self, "throttledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCodeInput")
    def throttled_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "throttledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCodeInput")
    def use_throttled_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCodeInput")
    def use_throttled_status_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtl")
    def alternate_response_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "alternateResponseCacheTtl"))

    @alternate_response_cache_ttl.setter
    def alternate_response_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5abf757a36eecd29131cac503487540bf8de275461584494788781ac903535f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "alternateResponseCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78cd2237d1075f9c20ba5d9cc1301505183f9fa95a130888da0916fb0dc70030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c950a2055fedc2f6228ddefd92b5deef537de379cb139277436f869e61b5e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8a20045d5be364b07104a2c9e0990074c4d0e6efa016c73129d984097e6297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9b110d5b9e2f3d75e9e78772eea4ebce98f5d685a32f422d5ca25b8da7407a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed22d25998a8cef9f7ca015c64466b981dd7d2c460d455b48f9d93e399396a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCode")
    def throttled_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "throttledStatusCode"))

    @throttled_status_code.setter
    def throttled_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1bcbf1970259d781cb55d19ac20802648a93c225c08dc361f12286a328387a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throttledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCode")
    def use_throttled_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledCpCode"))

    @use_throttled_cp_code.setter
    def use_throttled_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b3c4f98c8b715ac24ce1047d38c60e7089a897678f00c50e861c0fc457397c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCode")
    def use_throttled_status_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledStatusCode"))

    @use_throttled_status_code.setter
    def use_throttled_status_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e065f7cd3771497365c0226fe614feb5ba45921be995d2aa9eef1bd25d24528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05afb2a14b9843ec5c3dead1b07ab3e4a2d1f30e12de7b34ebea79d4bc98117)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebf1d180941e936c6ed56be867c6e51286c87d5bc957a7c47e13cfa36655c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9013a8b72da84ec72606189ea5fb4973fe810644705d36a9725c1c344f088db)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7ab21a00468427a8f42d73e986e4ee6a19f1124ae54decb22c123436d31690)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57313351de658f56a41a4974c33fd8fdf7441825058794a2e4a2d4cff35c944)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b22a2f5db0701bcf14e8055416a92f5b705926cadb094286d987a4f0e1c807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335ea52c7379fde82921648011344cbe6df8f6a32e692ce9107b8325c00858ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1aba76c3b9e92fa3bd98d40b2fc40956763e923bccaf2a5bd763fc79ed6daf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65944815df4cd073f1f7a99a8838a7e7fdd25174d622225e6e1a92e3f9b148e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbbfd1d78ef04a716fbe9540698aec36caaac15998e3ed95a8516275cb62815)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1461828ad11a36c72969ff69a2dc3fd68e2900936c58d1a808a55bf1627ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2a87f8d4ebf991a9c2ebba9361ca0f08897c56186ff8c1b5bc9a396f1002ac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3a78a0e7ea215c7392580e1ca6739523c05d533a3c6aef2a9d1c8247edab73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16f3a0c9f38a332223866db29b15c9d7b2ff9012f1d6a997e4b8072f93bf7f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0138644521b7d575479bc80bbcfe4c48c354c90345520fd20a0512a68005b590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f827644db509ff8f87dbd88ae88b84cdbb959d6f0e1c2b60fee61b00f36495bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer",
    jsii_struct_bases=[],
    name_mapping={
        "all_down_net_storage": "allDownNetStorage",
        "all_down_net_storage_file": "allDownNetStorageFile",
        "all_down_status_code": "allDownStatusCode",
        "all_down_title": "allDownTitle",
        "allow_cache_prefresh": "allowCachePrefresh",
        "cached_content_title": "cachedContentTitle",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "failover_attempts_threshold": "failoverAttemptsThreshold",
        "failover_mode": "failoverMode",
        "failover_origin_map": "failoverOriginMap",
        "failover_status_codes": "failoverStatusCodes",
        "failover_title": "failoverTitle",
        "label": "label",
        "locked": "locked",
        "origin_cookie_name": "originCookieName",
        "specify_stickiness_cookie_domain": "specifyStickinessCookieDomain",
        "stickiness_cookie_automatic_salt": "stickinessCookieAutomaticSalt",
        "stickiness_cookie_domain": "stickinessCookieDomain",
        "stickiness_cookie_salt": "stickinessCookieSalt",
        "stickiness_cookie_set_http_only_flag": "stickinessCookieSetHttpOnlyFlag",
        "stickiness_cookie_type": "stickinessCookieType",
        "stickiness_duration": "stickinessDuration",
        "stickiness_expiration_date": "stickinessExpirationDate",
        "stickiness_refresh": "stickinessRefresh",
        "stickiness_title": "stickinessTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer:
    def __init__(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(all_down_net_storage, dict):
            all_down_net_storage = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage(**all_down_net_storage)
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1a8e412f97951c8f5a6c9fa9b90fccf39ece25b4179936301747f9ef983cd0)
            check_type(argname="argument all_down_net_storage", value=all_down_net_storage, expected_type=type_hints["all_down_net_storage"])
            check_type(argname="argument all_down_net_storage_file", value=all_down_net_storage_file, expected_type=type_hints["all_down_net_storage_file"])
            check_type(argname="argument all_down_status_code", value=all_down_status_code, expected_type=type_hints["all_down_status_code"])
            check_type(argname="argument all_down_title", value=all_down_title, expected_type=type_hints["all_down_title"])
            check_type(argname="argument allow_cache_prefresh", value=allow_cache_prefresh, expected_type=type_hints["allow_cache_prefresh"])
            check_type(argname="argument cached_content_title", value=cached_content_title, expected_type=type_hints["cached_content_title"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_attempts_threshold", value=failover_attempts_threshold, expected_type=type_hints["failover_attempts_threshold"])
            check_type(argname="argument failover_mode", value=failover_mode, expected_type=type_hints["failover_mode"])
            check_type(argname="argument failover_origin_map", value=failover_origin_map, expected_type=type_hints["failover_origin_map"])
            check_type(argname="argument failover_status_codes", value=failover_status_codes, expected_type=type_hints["failover_status_codes"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_cookie_name", value=origin_cookie_name, expected_type=type_hints["origin_cookie_name"])
            check_type(argname="argument specify_stickiness_cookie_domain", value=specify_stickiness_cookie_domain, expected_type=type_hints["specify_stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_automatic_salt", value=stickiness_cookie_automatic_salt, expected_type=type_hints["stickiness_cookie_automatic_salt"])
            check_type(argname="argument stickiness_cookie_domain", value=stickiness_cookie_domain, expected_type=type_hints["stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_salt", value=stickiness_cookie_salt, expected_type=type_hints["stickiness_cookie_salt"])
            check_type(argname="argument stickiness_cookie_set_http_only_flag", value=stickiness_cookie_set_http_only_flag, expected_type=type_hints["stickiness_cookie_set_http_only_flag"])
            check_type(argname="argument stickiness_cookie_type", value=stickiness_cookie_type, expected_type=type_hints["stickiness_cookie_type"])
            check_type(argname="argument stickiness_duration", value=stickiness_duration, expected_type=type_hints["stickiness_duration"])
            check_type(argname="argument stickiness_expiration_date", value=stickiness_expiration_date, expected_type=type_hints["stickiness_expiration_date"])
            check_type(argname="argument stickiness_refresh", value=stickiness_refresh, expected_type=type_hints["stickiness_refresh"])
            check_type(argname="argument stickiness_title", value=stickiness_title, expected_type=type_hints["stickiness_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if all_down_net_storage is not None:
            self._values["all_down_net_storage"] = all_down_net_storage
        if all_down_net_storage_file is not None:
            self._values["all_down_net_storage_file"] = all_down_net_storage_file
        if all_down_status_code is not None:
            self._values["all_down_status_code"] = all_down_status_code
        if all_down_title is not None:
            self._values["all_down_title"] = all_down_title
        if allow_cache_prefresh is not None:
            self._values["allow_cache_prefresh"] = allow_cache_prefresh
        if cached_content_title is not None:
            self._values["cached_content_title"] = cached_content_title
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_attempts_threshold is not None:
            self._values["failover_attempts_threshold"] = failover_attempts_threshold
        if failover_mode is not None:
            self._values["failover_mode"] = failover_mode
        if failover_origin_map is not None:
            self._values["failover_origin_map"] = failover_origin_map
        if failover_status_codes is not None:
            self._values["failover_status_codes"] = failover_status_codes
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if origin_cookie_name is not None:
            self._values["origin_cookie_name"] = origin_cookie_name
        if specify_stickiness_cookie_domain is not None:
            self._values["specify_stickiness_cookie_domain"] = specify_stickiness_cookie_domain
        if stickiness_cookie_automatic_salt is not None:
            self._values["stickiness_cookie_automatic_salt"] = stickiness_cookie_automatic_salt
        if stickiness_cookie_domain is not None:
            self._values["stickiness_cookie_domain"] = stickiness_cookie_domain
        if stickiness_cookie_salt is not None:
            self._values["stickiness_cookie_salt"] = stickiness_cookie_salt
        if stickiness_cookie_set_http_only_flag is not None:
            self._values["stickiness_cookie_set_http_only_flag"] = stickiness_cookie_set_http_only_flag
        if stickiness_cookie_type is not None:
            self._values["stickiness_cookie_type"] = stickiness_cookie_type
        if stickiness_duration is not None:
            self._values["stickiness_duration"] = stickiness_duration
        if stickiness_expiration_date is not None:
            self._values["stickiness_expiration_date"] = stickiness_expiration_date
        if stickiness_refresh is not None:
            self._values["stickiness_refresh"] = stickiness_refresh
        if stickiness_title is not None:
            self._values["stickiness_title"] = stickiness_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def all_down_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage"]:
        '''all_down_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        '''
        result = self._values.get("all_down_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage"], result)

    @builtins.property
    def all_down_net_storage_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        '''
        result = self._values.get("all_down_net_storage_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP response code when all load-balancing origins are unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        '''
        result = self._values.get("all_down_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        '''
        result = self._values.get("all_down_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_cache_prefresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows the cache to prefresh.  Only appropriate if all origins serve the same content for the same URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        '''
        result = self._values.get("allow_cache_prefresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cached_content_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        '''
        result = self._values.get("cached_content_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the Application Load Balancer Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_attempts_threshold(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of failed requests that would trigger the failover process.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        '''
        result = self._values.get("failover_attempts_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_mode(self) -> typing.Optional[builtins.str]:
        '''Determines what to do if an origin fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        '''
        result = self._values.get("failover_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_origin_map(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap"]]]:
        '''failover_origin_map block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        '''
        result = self._values.get("failover_origin_map")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap"]]], result)

    @builtins.property
    def failover_status_codes(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        '''
        result = self._values.get("failover_status_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Application Load Balancer policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name for your session cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        '''
        result = self._values.get("origin_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        '''
        result = self._values.get("specify_stickiness_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable this if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        '''
        result = self._values.get("stickiness_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the stickiness cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        '''
        result = self._values.get("stickiness_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        '''
        result = self._values.get("stickiness_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ensures the cookie is transmitted only over HTTP.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        '''
        result = self._values.get("stickiness_cookie_set_http_only_flag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Determines how a cookie persistently associates the client with a load-balanced origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        '''
        result = self._values.get("stickiness_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_duration(self) -> typing.Optional[builtins.str]:
        '''Sets how long it is before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        '''
        result = self._values.get("stickiness_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        '''
        result = self._values.get("stickiness_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extends the duration of the cookie with each new request.

        When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        '''
        result = self._values.get("stickiness_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        '''
        result = self._values.get("stickiness_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a38c4c00b2b21f7c862a8d1adf647a220d804f6734e298698621c5c24e36f7a)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab0e196ccc599bca76c7535edc34d63f0a45b153d6265e91b83cbeff11cf669)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b59b0deaa637d74a49af16103d6df37bd0039108b84225111fc47932128cb385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b46d8b9f24be2ca35c0257a5a47230d85bd8b6d50e84b8be179102ae4be054a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6187118e0940f151cd93362fd9a215d5873d996c5510baadd431dbfa6bf341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22e6f255889acc751499ebb7dd2f0258a633b864d30e5b371c86acc8dc7fca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba667150b98605e32c6ed3a56d8ce8454a08ad50dc6a4cbe119d7776d97eb35e)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b314d27b4fd7bc93cc16551be124cdcbe665d9d6fa6c61cfef24d45f705d8805)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9debc32aa675baa7dfe4e76c9d83b6fd81411bde87573ae419c627b0dc65747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7104906312f2f984c1081dc59d5e9291767c6ec0dd888c6f69f54d83b9b8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb22c53031d106a0589da6f39c5a4cca34971ecfcdc76c3192b5478b176f8726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap",
    jsii_struct_bases=[],
    name_mapping={"from_origin_id": "fromOriginId", "to_origin_ids": "toOriginIds"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap:
    def __init__(
        self,
        *,
        from_origin_id: typing.Optional[builtins.str] = None,
        to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param from_origin_id: Specifies the origin whose failure triggers the mapping rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        :param to_origin_ids: Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc894112b3e431552361d80015b755e9a227280384b4e62b7a7af524b627d43a)
            check_type(argname="argument from_origin_id", value=from_origin_id, expected_type=type_hints["from_origin_id"])
            check_type(argname="argument to_origin_ids", value=to_origin_ids, expected_type=type_hints["to_origin_ids"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if from_origin_id is not None:
            self._values["from_origin_id"] = from_origin_id
        if to_origin_ids is not None:
            self._values["to_origin_ids"] = to_origin_ids

    @builtins.property
    def from_origin_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin whose failure triggers the mapping rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        '''
        result = self._values.get("from_origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_origin_ids(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        result = self._values.get("to_origin_ids")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f308841e0f705ec6f45d87e20d62480d59777fd93f3c78e38503dc98bc04d9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe2be3286a9245019d4f137f013987d1dd04e91675be342ff513e8c7ffa5264)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1adc23ce9c3fe4ea6bf75f82d53f47aaf51aad0db58688d83b743d1c2ae5998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1934b97b13456de907c5aa887880c8e293953c07d071ed4d4815601a2461cbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e74a8b443bf0a46ca8e13d9fafc76f303bc315ed60f4230d8a740573db7208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ad90843e4a8eda0460c8cf0f656e1ebaea754cbf7330fc945654bd4b99998be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18656608b18d5bdd167e214f08b331707a00f60b970e19dc07fe79371bcdf549)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFromOriginId")
    def reset_from_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFromOriginId", []))

    @jsii.member(jsii_name="resetToOriginIds")
    def reset_to_origin_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToOriginIds", []))

    @builtins.property
    @jsii.member(jsii_name="fromOriginIdInput")
    def from_origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fromOriginIdInput"))

    @builtins.property
    @jsii.member(jsii_name="toOriginIdsInput")
    def to_origin_ids_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "toOriginIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="fromOriginId")
    def from_origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fromOriginId"))

    @from_origin_id.setter
    def from_origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d8db7fde48a50d478b58e4d9bc3fac00f611217a0686c28f152ebcaa4d9d14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fromOriginId", value)

    @builtins.property
    @jsii.member(jsii_name="toOriginIds")
    def to_origin_ids(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "toOriginIds"))

    @to_origin_ids.setter
    def to_origin_ids(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18253010eea2f927f7edb7dea36b62f4be698285d2d34695fb7041e8402223ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toOriginIds", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134d0f07b676ced8b5633224911ae2e9173b29df267d471f38d71a24774bfe95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b56845939d892c78b219f5c8f9f16c581bbb8b2cd1e03c5ae10ebedf45be9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAllDownNetStorage")
    def put_all_down_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putAllDownNetStorage", [value]))

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putFailoverOriginMap")
    def put_failover_origin_map(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079241c2c3b0f8204301f45fb85140908e899bc57cbb6ece81f44ab7e4444345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverOriginMap", [value]))

    @jsii.member(jsii_name="resetAllDownNetStorage")
    def reset_all_down_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorage", []))

    @jsii.member(jsii_name="resetAllDownNetStorageFile")
    def reset_all_down_net_storage_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorageFile", []))

    @jsii.member(jsii_name="resetAllDownStatusCode")
    def reset_all_down_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownStatusCode", []))

    @jsii.member(jsii_name="resetAllDownTitle")
    def reset_all_down_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownTitle", []))

    @jsii.member(jsii_name="resetAllowCachePrefresh")
    def reset_allow_cache_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCachePrefresh", []))

    @jsii.member(jsii_name="resetCachedContentTitle")
    def reset_cached_content_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachedContentTitle", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverAttemptsThreshold")
    def reset_failover_attempts_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverAttemptsThreshold", []))

    @jsii.member(jsii_name="resetFailoverMode")
    def reset_failover_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMode", []))

    @jsii.member(jsii_name="resetFailoverOriginMap")
    def reset_failover_origin_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverOriginMap", []))

    @jsii.member(jsii_name="resetFailoverStatusCodes")
    def reset_failover_status_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverStatusCodes", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginCookieName")
    def reset_origin_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCookieName", []))

    @jsii.member(jsii_name="resetSpecifyStickinessCookieDomain")
    def reset_specify_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieAutomaticSalt")
    def reset_stickiness_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieDomain")
    def reset_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieSalt")
    def reset_stickiness_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieSetHttpOnlyFlag")
    def reset_stickiness_cookie_set_http_only_flag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSetHttpOnlyFlag", []))

    @jsii.member(jsii_name="resetStickinessCookieType")
    def reset_stickiness_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieType", []))

    @jsii.member(jsii_name="resetStickinessDuration")
    def reset_stickiness_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessDuration", []))

    @jsii.member(jsii_name="resetStickinessExpirationDate")
    def reset_stickiness_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessExpirationDate", []))

    @jsii.member(jsii_name="resetStickinessRefresh")
    def reset_stickiness_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessRefresh", []))

    @jsii.member(jsii_name="resetStickinessTitle")
    def reset_stickiness_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorage")
    def all_down_net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference, jsii.get(self, "allDownNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMap")
    def failover_origin_map(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapList, jsii.get(self, "failoverOriginMap"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFileInput")
    def all_down_net_storage_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownNetStorageFileInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageInput")
    def all_down_net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "allDownNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCodeInput")
    def all_down_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownTitleInput")
    def all_down_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefreshInput")
    def allow_cache_prefresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCachePrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitleInput")
    def cached_content_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cachedContentTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThresholdInput")
    def failover_attempts_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverAttemptsThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverModeInput")
    def failover_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverModeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMapInput")
    def failover_origin_map_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "failoverOriginMapInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodesInput")
    def failover_status_codes_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverStatusCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originCookieNameInput")
    def origin_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomainInput")
    def specify_stickiness_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyStickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSaltInput")
    def stickiness_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomainInput")
    def stickiness_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSaltInput")
    def stickiness_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlagInput")
    def stickiness_cookie_set_http_only_flag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieSetHttpOnlyFlagInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieTypeInput")
    def stickiness_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessDurationInput")
    def stickiness_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDateInput")
    def stickiness_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessRefreshInput")
    def stickiness_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessTitleInput")
    def stickiness_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFile")
    def all_down_net_storage_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownNetStorageFile"))

    @all_down_net_storage_file.setter
    def all_down_net_storage_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a48ef39f21c29e8bb0716702faa4e7548436a1cbaad9b5d76b2052c4a8b7a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownNetStorageFile", value)

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCode")
    def all_down_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownStatusCode"))

    @all_down_status_code.setter
    def all_down_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9be254dfed0a52bc4d9960c1aa01c1d90348dbd46b3cfe7689a46b9037bf99b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="allDownTitle")
    def all_down_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownTitle"))

    @all_down_title.setter
    def all_down_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce7e487dce38cf6b8787eedd16ef98027f612d3b7a2a37be578fe960c95a835d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefresh")
    def allow_cache_prefresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCachePrefresh"))

    @allow_cache_prefresh.setter
    def allow_cache_prefresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__821d09c467e8caeb05da717cc2c9d975a4edfa135a8ab32cf81bf74283c0473e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCachePrefresh", value)

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitle")
    def cached_content_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cachedContentTitle"))

    @cached_content_title.setter
    def cached_content_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0100d06f26950798eaa6520799095a93b25777e23dfb9cb42752a7a6e3200a66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cachedContentTitle", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3a8dc7c5599e2924e3693988b60acd5148d40f7c7012cffcfd81d1ed9abd10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThreshold")
    def failover_attempts_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverAttemptsThreshold"))

    @failover_attempts_threshold.setter
    def failover_attempts_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__808fbc75d67088523d90de92e3c96c434907921d39faab64ac66f0b9629609b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverAttemptsThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMode")
    def failover_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMode"))

    @failover_mode.setter
    def failover_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7275ddec3cffe2f28e62802e741adda33436ab216623a9358c5173b7c66f248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodes")
    def failover_status_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverStatusCodes"))

    @failover_status_codes.setter
    def failover_status_codes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b076d0df10ff7ce510fd5c74485ccb4fff4407251728f76500a74c604e8e262e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverStatusCodes", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc720b4364cfbceac2294ab9b13248584be68dcf0ad2dec2c0ae361096091ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3736059067e89248a3a578b4a8ef2a0ecd7423a5cf45402e3d978f57377d2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39024d44f4aa2829beb1d84b698a8e119240a665391dbca945e8a60701739d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originCookieName")
    def origin_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCookieName"))

    @origin_cookie_name.setter
    def origin_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ea00aaee5aca3c712aaed8b939c3f6f34c109e999e137b83eafc9e3885e4fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomain")
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyStickinessCookieDomain"))

    @specify_stickiness_cookie_domain.setter
    def specify_stickiness_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae187f8bc77574a8a147f715cd76fe9da213b6ff207af0f02a5d4a54647120b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyStickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSalt")
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieAutomaticSalt"))

    @stickiness_cookie_automatic_salt.setter
    def stickiness_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c4c0a88d1e3b2884796d7f92473f9d15e4ba9cd0e19dcfd166e649bd6b6046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomain")
    def stickiness_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieDomain"))

    @stickiness_cookie_domain.setter
    def stickiness_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2767da244aec78fa4a2b80c28a9f9e4cadd979a059de7fdb531c4758ca3961c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSalt")
    def stickiness_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieSalt"))

    @stickiness_cookie_salt.setter
    def stickiness_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0bc0ef4db48ec5de761b4ccb3f2cc8942c38da1ea8200db04ee993362df95a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlag")
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieSetHttpOnlyFlag"))

    @stickiness_cookie_set_http_only_flag.setter
    def stickiness_cookie_set_http_only_flag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3d33074aa36fd12bbb59cd947513eea10b2683a52ac976d7a8979a32bde0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSetHttpOnlyFlag", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieType")
    def stickiness_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieType"))

    @stickiness_cookie_type.setter
    def stickiness_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe95849a9b7ee1c252386344960a4952c53b88ecebeece22369a2e9f7e328c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessDuration")
    def stickiness_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessDuration"))

    @stickiness_duration.setter
    def stickiness_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0189e202653a1d4033a89dd4c88e84798638f6ab1c1d0b282cc23e7f197204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessDuration", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDate")
    def stickiness_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessExpirationDate"))

    @stickiness_expiration_date.setter
    def stickiness_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e048e833a35a8747f7849db42f635a3f7bc0a5533f7b8a5fa58d97b9d667f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessRefresh")
    def stickiness_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessRefresh"))

    @stickiness_refresh.setter
    def stickiness_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d557fdf3317f9bfa816dafb39cde69ff0398e565d62ae4d5b876ac1c428ab2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessTitle")
    def stickiness_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessTitle"))

    @stickiness_title.setter
    def stickiness_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2267ff1fa55b490b1064a33610942bd50833dfe9f7f59daa2ac02d37f48afd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75534fa986a757187c90004dcee8e0b4f18f98c0106060c2e4ce81e9fb9001bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea95c9ef1ca8d4a7402918158b8b234bcfb3240954ecdfa413982c51e583a9db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be9d7450a865353415ec4b5cd922dd5be02c2689ed15d9bb713534b460b1f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_automatic_salt": "populationCookieAutomaticSalt",
        "population_cookie_domain": "populationCookieDomain",
        "population_cookie_include_rule_name": "populationCookieIncludeRuleName",
        "population_cookie_salt": "populationCookieSalt",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "segment_tracking_cookie_name": "segmentTrackingCookieName",
        "segment_tracking_custom_header": "segmentTrackingCustomHeader",
        "segment_tracking_method": "segmentTrackingMethod",
        "segment_tracking_query_param": "segmentTrackingQueryParam",
        "segment_tracking_title": "segmentTrackingTitle",
        "specify_population_cookie_domain": "specifyPopulationCookieDomain",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ce5eec33adbd6fe8ad4d6c57c18ceeca87ddcc07ca3bf92d5ad23778533ad2)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_automatic_salt", value=population_cookie_automatic_salt, expected_type=type_hints["population_cookie_automatic_salt"])
            check_type(argname="argument population_cookie_domain", value=population_cookie_domain, expected_type=type_hints["population_cookie_domain"])
            check_type(argname="argument population_cookie_include_rule_name", value=population_cookie_include_rule_name, expected_type=type_hints["population_cookie_include_rule_name"])
            check_type(argname="argument population_cookie_salt", value=population_cookie_salt, expected_type=type_hints["population_cookie_salt"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument segment_tracking_cookie_name", value=segment_tracking_cookie_name, expected_type=type_hints["segment_tracking_cookie_name"])
            check_type(argname="argument segment_tracking_custom_header", value=segment_tracking_custom_header, expected_type=type_hints["segment_tracking_custom_header"])
            check_type(argname="argument segment_tracking_method", value=segment_tracking_method, expected_type=type_hints["segment_tracking_method"])
            check_type(argname="argument segment_tracking_query_param", value=segment_tracking_query_param, expected_type=type_hints["segment_tracking_query_param"])
            check_type(argname="argument segment_tracking_title", value=segment_tracking_title, expected_type=type_hints["segment_tracking_title"])
            check_type(argname="argument specify_population_cookie_domain", value=specify_population_cookie_domain, expected_type=type_hints["specify_population_cookie_domain"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_automatic_salt is not None:
            self._values["population_cookie_automatic_salt"] = population_cookie_automatic_salt
        if population_cookie_domain is not None:
            self._values["population_cookie_domain"] = population_cookie_domain
        if population_cookie_include_rule_name is not None:
            self._values["population_cookie_include_rule_name"] = population_cookie_include_rule_name
        if population_cookie_salt is not None:
            self._values["population_cookie_salt"] = population_cookie_salt
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if segment_tracking_cookie_name is not None:
            self._values["segment_tracking_cookie_name"] = segment_tracking_cookie_name
        if segment_tracking_custom_header is not None:
            self._values["segment_tracking_custom_header"] = segment_tracking_custom_header
        if segment_tracking_method is not None:
            self._values["segment_tracking_method"] = segment_tracking_method
        if segment_tracking_query_param is not None:
            self._values["segment_tracking_query_param"] = segment_tracking_query_param
        if segment_tracking_title is not None:
            self._values["segment_tracking_title"] = segment_tracking_title
        if specify_population_cookie_domain is not None:
            self._values["specify_population_cookie_domain"] = specify_population_cookie_domain
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Audience Segmentation cloudlet feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''Specifies a suffix to append to the cookie name.

        This helps distinguish this audience segmentation policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        '''
        result = self._values.get("population_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the population cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        '''
        result = self._values.get("population_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes in the session cookie the name of the rule in which this behavior appears.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        '''
        result = self._values.get("population_cookie_include_rule_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        '''
        result = self._values.get("population_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Specifies when the segmentation cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the lifetime of the segmentation cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If disabled, sets the expiration time only if the cookie is not yet present in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_cookie_name(self) -> typing.Optional[builtins.str]:
        '''This cookie name specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        '''
        result = self._values.get("segment_tracking_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_custom_header(self) -> typing.Optional[builtins.str]:
        '''This custom HTTP header specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        '''
        result = self._values.get("segment_tracking_custom_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the method to pass segment information to the origin.

        The Cloudlet passes the rule applied to a given request location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        '''
        result = self._values.get("segment_tracking_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_query_param(self) -> typing.Optional[builtins.str]:
        '''This query parameter specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        '''
        result = self._values.get("segment_tracking_query_param")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        '''
        result = self._values.get("segment_tracking_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_population_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to specify a cookie domain with the population cookie.

        It tells the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        '''
        result = self._values.get("specify_population_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b83ff9278946d04d6b7521f18ce0c1629d99cf7c7954317debb72ec1ea99f9)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb13b7fb33aa7c53ecf45ef394614c5c8f0ff229f02096a1e73542c9ab0010f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c354fe0b75e57041532da915190a8e125081bd9001540d0e53a01dad6982cdc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53a701397c1df4bea53483d00ac96a4fc4a5b2132990ef879902c72c07ee4f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93536d16b261b526c65f572c8d930fc642155e296a3d77ea92b9ff3ad8beb8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1abc67994ebf108a57499ad05b185855b0b37dfafc8ce9a6aa31eb83c20790)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieAutomaticSalt")
    def reset_population_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieDomain")
    def reset_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetPopulationCookieIncludeRuleName")
    def reset_population_cookie_include_rule_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieIncludeRuleName", []))

    @jsii.member(jsii_name="resetPopulationCookieSalt")
    def reset_population_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetSegmentTrackingCookieName")
    def reset_segment_tracking_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCookieName", []))

    @jsii.member(jsii_name="resetSegmentTrackingCustomHeader")
    def reset_segment_tracking_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCustomHeader", []))

    @jsii.member(jsii_name="resetSegmentTrackingMethod")
    def reset_segment_tracking_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingMethod", []))

    @jsii.member(jsii_name="resetSegmentTrackingQueryParam")
    def reset_segment_tracking_query_param(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingQueryParam", []))

    @jsii.member(jsii_name="resetSegmentTrackingTitle")
    def reset_segment_tracking_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingTitle", []))

    @jsii.member(jsii_name="resetSpecifyPopulationCookieDomain")
    def reset_specify_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSaltInput")
    def population_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomainInput")
    def population_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleNameInput")
    def population_cookie_include_rule_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieIncludeRuleNameInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieSaltInput")
    def population_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieNameInput")
    def segment_tracking_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeaderInput")
    def segment_tracking_custom_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCustomHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethodInput")
    def segment_tracking_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParamInput")
    def segment_tracking_query_param_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingQueryParamInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitleInput")
    def segment_tracking_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomainInput")
    def specify_population_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyPopulationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246c1fc17c11b265ae8600c4b9c77600c3d5d9bbea13c75ddd12ba3fc4041566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9fa87bfa7c6765a53fc8f44811161bcaf3f1e1eb4c09349a3b09cc03b6aa9d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9edbd20d6c5325e15e76a7795129a0e3bfeb1694afa77186bf81d5b86f05bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5951df52aff10e62a8ba7bb139f5ca98b88d483c7224e13a3af36d3f5a9e8988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ded89a15e1ace94f5d54576a37ef35f8b621f2ed7c2f532c9cb4824ac6ae3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSalt")
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieAutomaticSalt"))

    @population_cookie_automatic_salt.setter
    def population_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525829294094f01c43c93e8fa10dca0e968a129b0a329d42f9d2ccaab00b2fa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomain")
    def population_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieDomain"))

    @population_cookie_domain.setter
    def population_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f647b6531089733ab1749a29b052eb118fe1e36cff099598cc1ddc5d503045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleName")
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieIncludeRuleName"))

    @population_cookie_include_rule_name.setter
    def population_cookie_include_rule_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a15cfba5cdfb7cf3cbb40442a00baa28bac8d69126f20a2e96846baa691671f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieIncludeRuleName", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieSalt")
    def population_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieSalt"))

    @population_cookie_salt.setter
    def population_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e17cfa7537d340b3676634b608c1444f90baa1c016623c65305b35ca0455e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff05f56cbb68ac83a4f8c9b6a6a51f126b78816bddbc8c60ad9eb365c1c0be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e631ac0ecf4af0faad54ce9b58f04e05801d1bbe1699823de45d387e7ea070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c457e2044e566e0e5d997ea77b88b6c386621467f71ce7e1f0327966917092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df113c56bd73742c2444f547aa5ba72e74e43ff4fe635d1de43c0133eb839f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieName")
    def segment_tracking_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCookieName"))

    @segment_tracking_cookie_name.setter
    def segment_tracking_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410a230c2eeec3717afbd70b060fa9774675669ce1e34fe09156502731ba048a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeader")
    def segment_tracking_custom_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCustomHeader"))

    @segment_tracking_custom_header.setter
    def segment_tracking_custom_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e5a288d922acd52c398db3cbb186b08929262996843d1a75295d30c5a2b2cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCustomHeader", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethod")
    def segment_tracking_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingMethod"))

    @segment_tracking_method.setter
    def segment_tracking_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58ebc39a7f9590a541ecede9ff9135684305ff91d443190ae16230c3ae756e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingMethod", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParam")
    def segment_tracking_query_param(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingQueryParam"))

    @segment_tracking_query_param.setter
    def segment_tracking_query_param(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993b595c41ca1d46d3793a05c14480a05b5b984fe751e608fde9e72514a3d9cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingQueryParam", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitle")
    def segment_tracking_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingTitle"))

    @segment_tracking_title.setter
    def segment_tracking_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77a8f6bc4de4e4289b254d8a1f155c3c95661fca4f5a972d2399cb1aee27d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingTitle", value)

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomain")
    def specify_population_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyPopulationCookieDomain"))

    @specify_population_cookie_domain.setter
    def specify_population_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c0339dbc7a58d9d3aebaef2c4495da0cb31a1f7134ca0045353aba4ba69d06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyPopulationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4126a8436f54b33d222c425afb6949d2c19e444747ede1592214c56f869d2635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de01bb0e2b46ffd075e554b10991e6b55750526e57ceb594763fc47368cfa2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62015621bc3469d77b5bac5bcf182756d809f60566c62eb5d533bde551443f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation",
    jsii_struct_bases=[],
    name_mapping={
        "autodv": "autodv",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation:
    def __init__(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7281a113339b5a2a164969980897d08da08ed1101dd3845da8caa95a4e2dd6)
            check_type(argname="argument autodv", value=autodv, expected_type=type_hints["autodv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if autodv is not None:
            self._values["autodv"] = autodv
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def autodv(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        '''
        result = self._values.get("autodv")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9991c0c5ed660969fa46c5274c3050f2244d41482e6a44b02b7e27a2c6811b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAutodv")
    def reset_autodv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutodv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="autodvInput")
    def autodv_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "autodvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="autodv")
    def autodv(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "autodv"))

    @autodv.setter
    def autodv(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__682bf0713dd5191280e1287d5d02d0d515b75e6d240dc9d93cf665d25c949487)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "autodv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd6a5b136dd20e3c93df884e1f6f9b8ec942e268aaf96ca1d3f2678afddf3ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63957ea8ae6f8f11b8e58b97a5b6b000385634525f15e362a1f94a6413213c90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74cf4508c1b8ad1cb560d01b38ee107b94047b66f92dbcc2c0ba5d70ebaccf88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e29425f02a3c5f2f2e8eec06fb2f3459b9cbb045f70548b8ced30c96b515f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6706cbbc5cceed4764275b82bf80a5a406efd95c8097c9397b9aef9d9b8052eb)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the base path of content on your origin server.

        The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectoryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectoryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d6bb527d482540560baaf7d9b9a0db5f2bc9d74750ca2aff4873a2e1211c42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d414a4cfc2cdf28e49409e59b7d51f493a712d44814cfcb58b8188d3b7ce7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ce9e6291faa701a715c2a26ecd4b73e2d86e5e37b40ceecadd976ef363a341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a04eaa087848fc01fbcc89dcd4b548b7ab8a147d84066499f1c326e88fe7bcea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34a0f0ed4f4dc2df377d88facff36b01fc44f6f90186fc291dfd9267cc23daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1bd5e6a7714ee88c1d0e461732ff2889d472236ab3eb248d5e8ce0e104cb1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing",
    jsii_struct_bases=[],
    name_mapping={
        "conditional_error_pattern": "conditionalErrorPattern",
        "conditional_http_status": "conditionalHttpStatus",
        "conditional_sampling_frequency": "conditionalSamplingFrequency",
        "cpcodes": "cpcodes",
        "enabled": "enabled",
        "forward_type": "forwardType",
        "locked": "locked",
        "request_type": "requestType",
        "sampling_frequency": "samplingFrequency",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing:
    def __init__(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6d091d7a4aa93bfae11fe45e819b8f28cf66990d05309a5a76036010277d77)
            check_type(argname="argument conditional_error_pattern", value=conditional_error_pattern, expected_type=type_hints["conditional_error_pattern"])
            check_type(argname="argument conditional_http_status", value=conditional_http_status, expected_type=type_hints["conditional_http_status"])
            check_type(argname="argument conditional_sampling_frequency", value=conditional_sampling_frequency, expected_type=type_hints["conditional_sampling_frequency"])
            check_type(argname="argument cpcodes", value=cpcodes, expected_type=type_hints["cpcodes"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_type", value=forward_type, expected_type=type_hints["forward_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument sampling_frequency", value=sampling_frequency, expected_type=type_hints["sampling_frequency"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if conditional_error_pattern is not None:
            self._values["conditional_error_pattern"] = conditional_error_pattern
        if conditional_http_status is not None:
            self._values["conditional_http_status"] = conditional_http_status
        if conditional_sampling_frequency is not None:
            self._values["conditional_sampling_frequency"] = conditional_sampling_frequency
        if cpcodes is not None:
            self._values["cpcodes"] = cpcodes
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_type is not None:
            self._values["forward_type"] = forward_type
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if sampling_frequency is not None:
            self._values["sampling_frequency"] = sampling_frequency
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def conditional_error_pattern(self) -> typing.Optional[builtins.str]:
        '''A space-separated set of error patterns that trigger beacons to conditional feeds.

        Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        '''
        result = self._values.get("conditional_error_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def conditional_http_status(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response status codes or ranges that trigger the beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        '''
        result = self._values.get("conditional_http_status")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def conditional_sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a conditional sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        '''
        result = self._values.get("conditional_sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cpcodes(self) -> typing.Optional[builtins.str]:
        '''The space-separated list of CP codes that trigger the beacons.

        You need to specify the same set of CP codes within BOSS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        '''
        result = self._values.get("cpcodes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable diagnostic data beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        '''
        result = self._values.get("forward_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        '''
        result = self._values.get("sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65e7f534fbba6338f70db15120fb0572fc2d30cc8e435f8e30a0afbf04646e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConditionalErrorPattern")
    def reset_conditional_error_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalErrorPattern", []))

    @jsii.member(jsii_name="resetConditionalHttpStatus")
    def reset_conditional_http_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalHttpStatus", []))

    @jsii.member(jsii_name="resetConditionalSamplingFrequency")
    def reset_conditional_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalSamplingFrequency", []))

    @jsii.member(jsii_name="resetCpcodes")
    def reset_cpcodes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpcodes", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardType")
    def reset_forward_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetSamplingFrequency")
    def reset_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingFrequency", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPatternInput")
    def conditional_error_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalErrorPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatusInput")
    def conditional_http_status_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "conditionalHttpStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequencyInput")
    def conditional_sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalSamplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="cpcodesInput")
    def cpcodes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cpcodesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardTypeInput")
    def forward_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingFrequencyInput")
    def sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "samplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPattern")
    def conditional_error_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalErrorPattern"))

    @conditional_error_pattern.setter
    def conditional_error_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4224932b13e33a71ab2f27a6dd629b1b88802f41ecaab34632fa1d51a8784c0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalErrorPattern", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatus")
    def conditional_http_status(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "conditionalHttpStatus"))

    @conditional_http_status.setter
    def conditional_http_status(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e712cf4620c52c765db38e0b091494f68e619302fcaf017c8af20aaa7fe1294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalHttpStatus", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequency")
    def conditional_sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalSamplingFrequency"))

    @conditional_sampling_frequency.setter
    def conditional_sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed79123c9832f8fa4579193198fcfe7c4d66f27d82e9e2eeb18f46ebd882f0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalSamplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="cpcodes")
    def cpcodes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cpcodes"))

    @cpcodes.setter
    def cpcodes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a82fc614df2755fe13e0ae0a3d2bc91ff0bcbebd0551aea0acbf2d6bae19b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpcodes", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a374fe34c10a9207ac4a9893c0708fbc3d86ebd87377508bf69638528c30cb81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardType")
    def forward_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardType"))

    @forward_type.setter
    def forward_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589ac09fc93b137450032e2949692328a33784c2ecc9d7de4afc43ad3410e097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75cb7e6cf0117507d32337fd70b2346ec7ec95eeac0fbf1b16cd82742fd2ded0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07feea11db7c604d41b04507c70ac9303b1aca5aedcc30a9b1a5626d01f9963a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="samplingFrequency")
    def sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "samplingFrequency"))

    @sampling_frequency.setter
    def sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b90d00368563915d647e6748fbca89bae1c90079299cdc28f74fa6099ce9f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0004d99c9af13bcd8ba5d906c120087f08066faf8d30f6a1060654ad1558a246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c43e28232446489ca63bea62c865249b413460844582ae5ad52ab0972cf2a6b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d931d12b02b040d1010dbf9e384b313dc9d4225e31dbc937ca2a1aebb87c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "logging_enabled": "loggingEnabled",
        "opt_mode": "optMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcec8052a58989cb44738bcee1835b2b725ddb9fcc6bc74131beb5ecf53d96c4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument logging_enabled", value=logging_enabled, expected_type=type_hints["logging_enabled"])
            check_type(argname="argument opt_mode", value=opt_mode, expected_type=type_hints["opt_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if logging_enabled is not None:
            self._values["logging_enabled"] = logging_enabled
        if opt_mode is not None:
            self._values["opt_mode"] = opt_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Breadcrumbs feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def logging_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client.

        This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        '''
        result = self._values.get("logging_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def opt_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to include Breadcrumbs data in the response header.

        To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        '''
        result = self._values.get("opt_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45769b6797aa7478627b43887aed9d48df1d05d82e1b18968c9566cae7509ba4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLoggingEnabled")
    def reset_logging_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoggingEnabled", []))

    @jsii.member(jsii_name="resetOptMode")
    def reset_opt_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="loggingEnabledInput")
    def logging_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "loggingEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="optModeInput")
    def opt_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__882e706215eb009e24c4458839a0454a02dea83e9c4af351fd94ae3913846e60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eee1e205d20bf5a66b385c4665c5e634cea19d16107b33f69f1ed0ee8414ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="loggingEnabled")
    def logging_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "loggingEnabled"))

    @logging_enabled.setter
    def logging_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a8984c103bbe1ee9c14ee04f53945b90f0ac77d5c125439e4dbac8e317faa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loggingEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="optMode")
    def opt_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optMode"))

    @opt_mode.setter
    def opt_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4593df195ad037b728621495b993a193b676d9f7d7e08f23f28c7523194ec4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ba25b552d3000e9295cbd873bd38fe4a6c4e2ae5a5d60c9f18a41f2080fd2cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85301caff2d9b7e485bb242986f19e595f735a30d3e0ad00bfe638ec498ca89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd496763d84c4640abf012642312a84776701477682476255fec3f2db6aaa57f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e701779107b60b7e5652755b24711f76d3ae616b6e2bea455a4937e6053c14)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the break connection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78b3cacb029bfe2a8d6042445c33b4bd8eaa552a7ce1017727b6c1b2c78b80e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d098909cf8cb39b257fb9ef2cc795caf11215e745490db345ad0f8849e2493f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e45a5f21baa2bf9c4583920bc732d5e0b7ad90b8aaa527ac1924d28923ee2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048245b83819c85c2279593d28b8b23b6bbbc43fda85a22523e96d54c812d598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9dfd72d33039fb261dbe340b000472f8f561531846c30d4629fd137d93aa82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafc4c5845b277d0c3b2b3fe833d058681bcdb3510c65434674bf7dc52ed05e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710e87cbe458adb28c2b814100a93ab6e02930a8c231035d7aeeb3b57666ae14)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Fetches Brotli-compressed assets from your origin and caches them on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotliOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotliOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af330e05c7358ce8100ebcacb5aabdce5ccc5dff0297a2e86dd292931c747bb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17cc0e03f483fb2fe73b69fe2394d23861725998e602f8a6a3d5128418fc344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e12d888778bb79c8ea3361b6e6d7e00aa8a47642a69ab4b90b2f33c67a0a72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca7aa396891f9064149dc99eaa1816304701e1a1fb239d09baf0e281b833f42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d0cfd45b10113ad9e7a010115db8e4b171daab0098ed810fc3ac1afa161dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bda4f9825914e81d76aa670c9e00de266fbe23fab12ba08d97eb85b14199040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "preserve_stale": "preserveStale",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a1816f18b618cc45ca336c3c0c645c6c3a8d953f758e75cba9afb7345cf73f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preserve_stale", value=preserve_stale, expected_type=type_hints["preserve_stale"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if preserve_stale is not None:
            self._values["preserve_stale"] = preserve_stale
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the error-caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preserve_stale(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes.

        This avoids re-fetching and re-caching content after transient errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        '''
        result = self._values.get("preserve_stale")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Overrides the default caching duration of ``10s``.

        Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45dce10569bb5f523cacd1bfeae4f66a32c9f0dfebe4112a1618377cd5cdc110)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreserveStale")
    def reset_preserve_stale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveStale", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveStaleInput")
    def preserve_stale_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveStaleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa024b6c5e952bd86fb605514f5d4c587277d70c6298ec5457ddffe1069cc10e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c0649016549870b829bd730f2429d19f5f2f59dcf5348d0ac23ce1a5552478b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preserveStale")
    def preserve_stale(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveStale"))

    @preserve_stale.setter
    def preserve_stale(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817f67d64606f2fbc0c7cd93633409bd116c61d1e6d35a364a645592d08823fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveStale", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1a9d0495a21626110361eeb9418575b0ffef3d664df4fa0cc712edab6e18f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34273042b3179d7e2e15d5c2364fbd89131044e6721ffd8695feab01f0f50045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7deeb8452d89784ea469fed3bbbde86faaba98e1bb408fa40e4c246a36bec68b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6052780d2c644408e0eb7ed860e5aa78d3c057e1f1caf85cea6364da766ebc6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "include_value": "includeValue",
        "locked": "locked",
        "optional": "optional",
        "rule": "rule",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b57d87449490625a999bd5515cfafd247213c9ca61b7fece1b17169cbab887)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument include_value", value=include_value, expected_type=type_hints["include_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optional", value=optional, expected_type=type_hints["optional"])
            check_type(argname="argument rule", value=rule, expected_type=type_hints["rule"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if include_value is not None:
            self._values["include_value"] = include_value
        if locked is not None:
            self._values["locked"] = locked
        if optional is not None:
            self._values["optional"] = optional
        if rule is not None:
            self._values["rule"] = rule
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def include_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes the value of the specified elements in the cache ID. Otherwise only their names are included.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        '''
        result = self._values.get("include_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optional(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Requires the behavior's specified elements to be present for content to cache.

        When disabled, requests that lack the specified elements are still cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        '''
        result = self._values.get("optional")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rule(self) -> typing.Optional[builtins.str]:
        '''Specifies how to modify the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        '''
        result = self._values.get("rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the variable you want to include in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9534b04f9dc24dda5d721e5c47a73b9fb410e550bd2da71eb37625865bd06cd2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetIncludeValue")
    def reset_include_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptional")
    def reset_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptional", []))

    @jsii.member(jsii_name="resetRule")
    def reset_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRule", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="includeValueInput")
    def include_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optionalInput")
    def optional_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optionalInput"))

    @builtins.property
    @jsii.member(jsii_name="ruleInput")
    def rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ruleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b483c85d045d8ccc9b5a4348615959dfd8bf485a0b350d57423123ea2cafe56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="includeValue")
    def include_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeValue"))

    @include_value.setter
    def include_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b30af3d1789a2a969db8bfe9d604e228008f2f033143ac9152254feaba9bd350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1598b4c1654be50e239ecd2fa871eeab085679030ec5d9a0b997f09fbb7e0275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optional")
    def optional(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optional"))

    @optional.setter
    def optional(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff822030c4514f991b1d0cc6cb23686527fdb8c15caff84cabd0dd979b40c1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optional", value)

    @builtins.property
    @jsii.member(jsii_name="rule")
    def rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rule"))

    @rule.setter
    def rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f27709a2223baf9f97b6d4b7bb7a3f1e48ba37ddd55316ca574be2a776caa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rule", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7dc9604d917ec0e3c97e36fd4f82bd0469dbe1d0baf7c7309210c2dfb31948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6719e0e12a3603153a8f498d72e3160ead48b0d9d427c1a4745dca7cb87e9c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6485fb249872fc8554168ad979aacceaebd59e7979f1b7194f8fa21a2178d8ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d4efadb6c60d792772706f9d27aeafd5ede694040a0a37607231fc5de5e83a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e770960cfe48b63c623ae32343517221e7e5fb8a1888639f6ea3941ce80851db)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ignores case when forming cache keys.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d166cb89e7b0400255ad2d220c222bed85575ec95d1a26c7440b977fbc180f2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27053e1f491c553a5e3e538a7ba1499b2bec65571d0edb27e8a7de095babc588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73ea182b74ed4667c7b47f39e3509b0383ed0f453dd0f7a71b240a88df33175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e08cc9ac38c722dddc6a8b110c4bc2f7a0652eb7ef81c620eb4eba93e3ab627f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db655f61edf4041798237684b546594b7591499dfe95c3f927a27f6f5cef1c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271c5fdd09fba265f11a1f9ae554802d86ad5dcb94889fabd7c3be775b1742e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "exact_match": "exactMatch",
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d28011623e0aafad090757dff1b8dad74c025445ee1426a9a06fbaf95e6bfc3)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument exact_match", value=exact_match, expected_type=type_hints["exact_match"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if exact_match is not None:
            self._values["exact_match"] = exact_match
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Configures how sets of query string parameters translate to cache keys.

        Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exact_match(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        '''
        result = self._values.get("exact_match")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of parameter field names to include in or exclude from the cache key.

        By default, these match the field names as string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParamsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParamsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1a89274c86997c86ad83da20d9148a033d7436956311cb381918e1e8612a1b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetExactMatch")
    def reset_exact_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExactMatch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="exactMatchInput")
    def exact_match_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "exactMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9424cbc7d7477b6a7727e07c00465cf3ce8a6fe6ded725a51e8c9e990aef0a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="exactMatch")
    def exact_match(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "exactMatch"))

    @exact_match.setter
    def exact_match(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98471cb9d708fc1072f5bb75750eb3cb1ea7c612a5ae940c25c904605c800439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exactMatch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc1e1c5ea7b32daf5dbb084e13216cbba4233bf6c95234a20d1c9b2246cd78c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac72c24c47f8842e7191af420668de21648ce0ad8bf47bf5ae59cdb01cfec7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca9db3ce0988b1f6df2c39aaa536883e0493e29c9952cebc3bfae8c1516e155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e976bc68a2ab60c68929ffc87c98cb33671e409e7e088cc35db47c400dcab406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf0d7096255f575aa35bed24191e6f6cac1ea2b6fcc6a12f3206fa0452987c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "purge_key": "purgeKey",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c55129f0696824e93a881e995390b217cb4d709fd08226e7c76b4c4de8f65ecf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_key", value=purge_key, expected_type=type_hints["purge_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if purge_key is not None:
            self._values["purge_key"] = purge_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the new cache key path as an alphanumeric value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        '''
        result = self._values.get("purge_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086127b732be4317abe226d9f1458647edaa8d9e3baf35c64c8bd0b9bc049630)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeKey")
    def reset_purge_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeKeyInput")
    def purge_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5984a029d56f9b7f8ba62aba6dfc27e59af4e8379564649c6c112e2706e5fcb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeKey")
    def purge_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeKey"))

    @purge_key.setter
    def purge_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e1cf57eacb3fe82de87c0e9d4143fa3a637baeb0a3816d271f03771f16cb803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6697fd9a7a4a9b35635c26364f11944e9ff2d6a4fa1f634598f1b94d0fc518e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4da375e08786c75ca6e07d2fd353eadb950c96dc7adbb94fe56c8c7e8846a85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf1930637728c1f4bd1e3fb890f13bcfa3bc613af7648aafa9262e61a203588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_body": "useBody",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3055bcea43761a47b3023748309ffff287a2c6e88506927df6075331261b239d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_body", value=use_body, expected_type=type_hints["use_body"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_body is not None:
            self._values["use_body"] = use_body
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables caching of POST responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_body(self) -> typing.Optional[builtins.str]:
        '''Define how and whether to use the POST message body as a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        '''
        result = self._values.get("use_body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6edd0133255038a5d4e6931b9fdf98a7b0a6544f25be09a640fc8aeac107bc9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseBody")
    def reset_use_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseBody", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useBodyInput")
    def use_body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "useBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb4b2902c0ac46363d4158f2122bbc05aca05f1904ef96f7a2bf414faee0f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db05675b0196216032bd9e6f23cb89defb1d0389ed9759df016becb266d4b6ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9af41670d5d6f5e9cd55da4376d2a21cebd5d4c9d286e6565c94c46db88a35e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useBody")
    def use_body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "useBody"))

    @use_body.setter
    def use_body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4492b1dff4b6b1538642642758600dbe127b83803460529d350d9f8ab33e840c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useBody", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad783184b4526d2147cddc8be8d6b318d9a9deb5194ccfe783bf35d8f2e7ea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913e97591e44de5b089adcaa6573a3c3e4d2dc37c1d897c34cc7b4eaf1fed971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3a55f40ddcbf2c20496be8686afd465f456b0b218f57fdd726e6bbb3877b927)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the redirect caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134a2fc97e5e88f41f75f77f30e7929bd8d1067ba66963dfe49cafc1646f7827)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc728e731f9beff4d038dd0d2c2e9bc5d56bc5f567eabd84be825bfcbb5064fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__015e79ab0f904cf65d62f9ddeb552e2757e601187d232378ea5df59c961938f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92efef3c710ceba08cedc940268711c88fd7562ba18040bd7e0b9c811568b06b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93bff958e1ef982e0355bafba6dbe9e9baa5ffb2534573b4e25dee53d6e32dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f965caf67ce3c999a8bf561414eda071b137fdae2c10b741e3ee03f1d46244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "tag": "tag",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10fe5fcc93895ce61616d7d919cca21f23aba1607683848aea7c18393802a848)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument tag", value=tag, expected_type=type_hints["tag"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if tag is not None:
            self._values["tag"] = tag
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tag(self) -> typing.Optional[builtins.str]:
        '''Specifies the cache tag you want to add to your cached content.

        A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_``|~-]`

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        '''
        result = self._values.get("tag")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83fcfdf37c1401ebfaca20684ecfc169e2cd0392b23fd5265135e7fd7dcede4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTag")
    def reset_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTag", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="tagInput")
    def tag_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abb617762597fa7ca015c5e56c8529cac29d3197b668328aa7ae5d1db6e94a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="tag")
    def tag(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tag"))

    @tag.setter
    def tag(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f0f3d29fc07501699b33b0225999af3e6c2795edce9137bbac0de145361a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tag", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dbcd9dd70f612867a80d97c2146f925d5f9114fca0cd3482e07744a00dda356)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab75b768d3c1152bbc0e3e4b994b917ae2a937f409dbfad1e1e987e20f30c498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8eaa8ea56f53d0e9a9c619b7acfbf4c87e192d9404f3bf76ed5a99a8daee73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbbb842cf24d28e544e6f25b53c02ecd057aa13445023093d70a589555493bc)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specifies when to include the ``Edge-Cache-Tag`` in responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisibleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisibleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40f679d615a308e66970cbffcf8e2c7c2fbc9f269cee341256da33d6c9b9c18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c221d3bec904723c143d04fa8cedf4c552c031b9bc3fb1921eac89d9e2c1a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b5aa7f858a55bb6cfdfae1fc1a83f9fe503084f6d7de38842341a4abd8e4c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49310d1c9a2b8308b8cbf80e2372b8a772ce83ac3c20ab12c82a8ab29a38f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00621d2d74dccd87b5bbfac6a07c06f0c968fa21fb63b4211e9435c111376c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d934b61405d8cef5f930b0d4de25e00434f35c10bead82e24710b1062a8070b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "cacheability_settings": "cacheabilitySettings",
        "cache_control_directives": "cacheControlDirectives",
        "default_ttl": "defaultTtl",
        "enhanced_rfc_support": "enhancedRfcSupport",
        "expiration_settings": "expirationSettings",
        "honor_max_age": "honorMaxAge",
        "honor_must_revalidate": "honorMustRevalidate",
        "honor_no_cache": "honorNoCache",
        "honor_no_store": "honorNoStore",
        "honor_private": "honorPrivate",
        "honor_proxy_revalidate": "honorProxyRevalidate",
        "honor_s_maxage": "honorSMaxage",
        "locked": "locked",
        "must_revalidate": "mustRevalidate",
        "revalidation_settings": "revalidationSettings",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f961cfb9d3a5655c900d8076d36c92c636bc14b63e1061501f90ed21619804ed)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument cacheability_settings", value=cacheability_settings, expected_type=type_hints["cacheability_settings"])
            check_type(argname="argument cache_control_directives", value=cache_control_directives, expected_type=type_hints["cache_control_directives"])
            check_type(argname="argument default_ttl", value=default_ttl, expected_type=type_hints["default_ttl"])
            check_type(argname="argument enhanced_rfc_support", value=enhanced_rfc_support, expected_type=type_hints["enhanced_rfc_support"])
            check_type(argname="argument expiration_settings", value=expiration_settings, expected_type=type_hints["expiration_settings"])
            check_type(argname="argument honor_max_age", value=honor_max_age, expected_type=type_hints["honor_max_age"])
            check_type(argname="argument honor_must_revalidate", value=honor_must_revalidate, expected_type=type_hints["honor_must_revalidate"])
            check_type(argname="argument honor_no_cache", value=honor_no_cache, expected_type=type_hints["honor_no_cache"])
            check_type(argname="argument honor_no_store", value=honor_no_store, expected_type=type_hints["honor_no_store"])
            check_type(argname="argument honor_private", value=honor_private, expected_type=type_hints["honor_private"])
            check_type(argname="argument honor_proxy_revalidate", value=honor_proxy_revalidate, expected_type=type_hints["honor_proxy_revalidate"])
            check_type(argname="argument honor_s_maxage", value=honor_s_maxage, expected_type=type_hints["honor_s_maxage"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument must_revalidate", value=must_revalidate, expected_type=type_hints["must_revalidate"])
            check_type(argname="argument revalidation_settings", value=revalidation_settings, expected_type=type_hints["revalidation_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if cacheability_settings is not None:
            self._values["cacheability_settings"] = cacheability_settings
        if cache_control_directives is not None:
            self._values["cache_control_directives"] = cache_control_directives
        if default_ttl is not None:
            self._values["default_ttl"] = default_ttl
        if enhanced_rfc_support is not None:
            self._values["enhanced_rfc_support"] = enhanced_rfc_support
        if expiration_settings is not None:
            self._values["expiration_settings"] = expiration_settings
        if honor_max_age is not None:
            self._values["honor_max_age"] = honor_max_age
        if honor_must_revalidate is not None:
            self._values["honor_must_revalidate"] = honor_must_revalidate
        if honor_no_cache is not None:
            self._values["honor_no_cache"] = honor_no_cache
        if honor_no_store is not None:
            self._values["honor_no_store"] = honor_no_store
        if honor_private is not None:
            self._values["honor_private"] = honor_private
        if honor_proxy_revalidate is not None:
            self._values["honor_proxy_revalidate"] = honor_proxy_revalidate
        if honor_s_maxage is not None:
            self._values["honor_s_maxage"] = honor_s_maxage
        if locked is not None:
            self._values["locked"] = locked
        if must_revalidate is not None:
            self._values["must_revalidate"] = must_revalidate
        if revalidation_settings is not None:
            self._values["revalidation_settings"] = revalidation_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cacheability_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        '''
        result = self._values.get("cacheability_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_control_directives(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        '''
        result = self._values.get("cache_control_directives")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_ttl(self) -> typing.Optional[builtins.str]:
        '''Set the ``MAX_AGE`` header for the cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        '''
        result = self._values.get("default_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enhanced_rfc_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        '''
        result = self._values.get("enhanced_rfc_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        '''
        result = self._values.get("expiration_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def honor_max_age(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        '''
        result = self._values.get("honor_max_age")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        '''
        result = self._values.get("honor_must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_cache(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request.

        Effectively, set the time to live ``ttl`` to zero seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        '''
        result = self._values.get("honor_no_cache")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        '''
        result = self._values.get("honor_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``private`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        '''
        result = self._values.get("honor_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_proxy_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        '''
        result = self._values.get("honor_proxy_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_s_maxage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        '''
        result = self._values.get("honor_s_maxage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin.

        If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        '''
        result = self._values.get("must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def revalidation_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        '''
        result = self._values.get("revalidation_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''The maximum time content may remain cached.

        Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48796e8205266a5a11eef13c7df046ca7dd8771d20115b2e3243711770dd997)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetCacheabilitySettings")
    def reset_cacheability_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheabilitySettings", []))

    @jsii.member(jsii_name="resetCacheControlDirectives")
    def reset_cache_control_directives(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheControlDirectives", []))

    @jsii.member(jsii_name="resetDefaultTtl")
    def reset_default_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultTtl", []))

    @jsii.member(jsii_name="resetEnhancedRfcSupport")
    def reset_enhanced_rfc_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedRfcSupport", []))

    @jsii.member(jsii_name="resetExpirationSettings")
    def reset_expiration_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationSettings", []))

    @jsii.member(jsii_name="resetHonorMaxAge")
    def reset_honor_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMaxAge", []))

    @jsii.member(jsii_name="resetHonorMustRevalidate")
    def reset_honor_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMustRevalidate", []))

    @jsii.member(jsii_name="resetHonorNoCache")
    def reset_honor_no_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoCache", []))

    @jsii.member(jsii_name="resetHonorNoStore")
    def reset_honor_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoStore", []))

    @jsii.member(jsii_name="resetHonorPrivate")
    def reset_honor_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorPrivate", []))

    @jsii.member(jsii_name="resetHonorProxyRevalidate")
    def reset_honor_proxy_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorProxyRevalidate", []))

    @jsii.member(jsii_name="resetHonorSMaxage")
    def reset_honor_s_maxage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorSMaxage", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMustRevalidate")
    def reset_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMustRevalidate", []))

    @jsii.member(jsii_name="resetRevalidationSettings")
    def reset_revalidation_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevalidationSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettingsInput")
    def cacheability_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheabilitySettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectivesInput")
    def cache_control_directives_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheControlDirectivesInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultTtlInput")
    def default_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "defaultTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupportInput")
    def enhanced_rfc_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enhancedRfcSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationSettingsInput")
    def expiration_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMaxAgeInput")
    def honor_max_age_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidateInput")
    def honor_must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoCacheInput")
    def honor_no_cache_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoStoreInput")
    def honor_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="honorPrivateInput")
    def honor_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidateInput")
    def honor_proxy_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorProxyRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorSMaxageInput")
    def honor_s_maxage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorSMaxageInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mustRevalidateInput")
    def must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="revalidationSettingsInput")
    def revalidation_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "revalidationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ddeac020d27f9b29fdd17ff8635bab2528071a790d1f2044dd3b9e77b8cb73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettings")
    def cacheability_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheabilitySettings"))

    @cacheability_settings.setter
    def cacheability_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779cc96a476ca5c1d247d4d19bff17d7c4d93d2e1b74110e1e8042a60bf6e669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheabilitySettings", value)

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectives")
    def cache_control_directives(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheControlDirectives"))

    @cache_control_directives.setter
    def cache_control_directives(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513c3065a86020a55666722f4fd3a789b38978e7756033c74eeff9ec7a68efb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheControlDirectives", value)

    @builtins.property
    @jsii.member(jsii_name="defaultTtl")
    def default_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "defaultTtl"))

    @default_ttl.setter
    def default_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eff02bff47f49e09f1da9205e5636d83b3e75eac60039d091ef1af7612f6776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultTtl", value)

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupport")
    def enhanced_rfc_support(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enhancedRfcSupport"))

    @enhanced_rfc_support.setter
    def enhanced_rfc_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08810bdaed25487dd452f70f0dd98c33184e05a62f51114aadc388a28ea4319f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enhancedRfcSupport", value)

    @builtins.property
    @jsii.member(jsii_name="expirationSettings")
    def expiration_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationSettings"))

    @expiration_settings.setter
    def expiration_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c944a2b0ab0822f52872342b8c3b0e0b89f5b8b5344c88fb078262a0d90af79a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="honorMaxAge")
    def honor_max_age(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMaxAge"))

    @honor_max_age.setter
    def honor_max_age(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3036dfb43a7d6869546e05cb8d6ce3ea34f14a2483d05b8642b20ac3e1f31da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidate")
    def honor_must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMustRevalidate"))

    @honor_must_revalidate.setter
    def honor_must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4eca2b72c36a142067c9322646fb5dcebf75d3942d5ee1379aac13d314c2dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoCache")
    def honor_no_cache(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoCache"))

    @honor_no_cache.setter
    def honor_no_cache(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52106e92a618b5fc8ef0210315f2baad850d138bb0932d712f1fa4ecfbe6e099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoCache", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoStore")
    def honor_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoStore"))

    @honor_no_store.setter
    def honor_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fce14d576131d8bd5e4c2b7cb18de0659d84caca26963472ec3b2942c899886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="honorPrivate")
    def honor_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorPrivate"))

    @honor_private.setter
    def honor_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da7d0a4db09f001266d89c1e40929a5a15267e5f0053089bc58ce6e6a5ad9b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidate")
    def honor_proxy_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorProxyRevalidate"))

    @honor_proxy_revalidate.setter
    def honor_proxy_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39eb5cbe25a5e771bb9d6b4a94cbe1715a8adcfbdf6aa3141cafd3c8b4876833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorProxyRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorSMaxage")
    def honor_s_maxage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorSMaxage"))

    @honor_s_maxage.setter
    def honor_s_maxage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8811af19186accb176fae49db6769168f6399fc25763074e4ae760a7d0572204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorSMaxage", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5f33437189a0767475e2b008617be47bd613db5a2d6eec75485b4c9a4152f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mustRevalidate")
    def must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mustRevalidate"))

    @must_revalidate.setter
    def must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d82e92ce1506f70ec03f97b20f6cda9cd17f81b8ee8793cbe6b8e5798535d47c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="revalidationSettings")
    def revalidation_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "revalidationSettings"))

    @revalidation_settings.setter
    def revalidation_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b208221d18b252667ba84961e477370b715b14bc9cae03dfb61ac62a17ca38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revalidationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc941ba7d8376b5fb69a18689e0d8be0044763fff19f1ba0a9be70d2522f9ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2002571ce0bfa1314cf0e22222b9be61826d8bed633e4a6f6f73908a120e7d55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba77c6f232d750f9860a42da4067098271758e53ba869a59a66c0e97940b6cd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2788f75484e14f25a43070a1d6d3d612a5b8f3ca44ecda600d11db4d1772ed91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d69a9e1e234b260fef254a8b9403e87dffa5f98760f09805e95504ef2f59ee3c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the centralized authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1476797f224e3063aafe6c236e488739c41a005736ef3f0709920319856ad4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5181fa63b60c1150f3f8e75422d29f481b25a627a4c24bcb47fc1fc392c0f00e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b543073f584b9a3f807c414f93afcf481ec99f7cf485f8316eae226334b40d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8d5036ca913d0217c789631c9783fb049dbd2da40ff8ea34e12ae59a4e1dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e69c198d700a689dd394a86dc9b8a2c1f0cb31bf1c34d0e759958ba0e3b19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6f7d182f702bf2b06fdd7be6793d94b0947772f48c60b0827f63f4fa611202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "limit": "limit",
        "locked": "locked",
        "serve404": "serve404",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8be1406b1f897468f40de341a5bdc9e4790d4c9131597a13b6756147c0aed8)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serve404", value=serve404, expected_type=type_hints["serve404"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if limit is not None:
            self._values["limit"] = limit
        if locked is not None:
            self._values["locked"] = locked
        if serve404 is not None:
            self._values["serve404"] = serve404
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to chase redirects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def limit(self) -> typing.Optional[builtins.str]:
        '''Specifies, as a string, the maximum number of redirects to follow.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serve404(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        '''
        result = self._values.get("serve404")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6df016139cd72790464b0339fbd36ed056bab39e037ebfcfac19bbff0057e9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServe404")
    def reset_serve404(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServe404", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serve404Input")
    def serve404_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "serve404Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef3e871ccd288078070d12fea046aaf1ed44096b429f90ebd5952673e64ae12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef891b1ae137bd5141cf2d36c69f8b9f4992e24d0a9705212dae00faab07dc1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e7c7dd44b397289b738c39acaea478e0e4074b736c3bd0dd28a7da0b1a40e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serve404")
    def serve404(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "serve404"))

    @serve404.setter
    def serve404(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547d31f90e48f3002da4b10770bdaa710ce185c517ec07b05c488ae48e6e0a27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serve404", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59dedbe680c2133baf90635c5e053e2a83fc8ff0e7b76df24687a7a9b8590268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2b19fba55a6ed2b6eb2597919912ee637eaba569dc02e095cfa5f32fde2788c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22417035ef4e1b9d9baf526b9346a6a5d9a8d3c1cec0c75348d258b151028f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "country": "country",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics:
    def __init__(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a510357b2540396d543634d72f83dcef7e0ab73e37a0c1ab05dc5635587b413e)
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if country is not None:
            self._values["country"] = country
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the client request's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db29cb45074b1ca1718d081b1bb8f90ee4f3aff2744950a5a6e194395e096b8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc763d629da8bad48ca40b4f28f8c23aa7e1d9a4c25aa767e1c23082307f4a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__792c83de90e1022cda790e5d9954a147f4ce568a4427d895983329347b0a0247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcae48b2090bfe3b6c2146fe1eb25a36c4f3d5449cf7a872219281076cda1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f3541796fa4378d965ef48a7fcfcec91810e824402a770d0b4363fff0d95f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573cec39ee809aea002064152b00861217fdf1054e595d6935505296843ee40c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects",
    jsii_struct_bases=[],
    name_mapping={
        "cloud_locations": "cloudLocations",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects:
    def __init__(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bfdd5ab135b2116bbae9d64f02eaf654ca10b7ff8581c820f8632db296f7ef8)
            check_type(argname="argument cloud_locations", value=cloud_locations, expected_type=type_hints["cloud_locations"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloud_locations is not None:
            self._values["cloud_locations"] = cloud_locations
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloud_locations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the geographical locations of your cloud origin.

        You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        '''
        result = self._values.get("cloud_locations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Channels the traffic to maximize the egress discount at the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df23bc2c108d033413f8b5b26fe079ed054882133eee449a186fa9f22cc40ed2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudLocations")
    def reset_cloud_locations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudLocations", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudLocationsInput")
    def cloud_locations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cloudLocationsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudLocations")
    def cloud_locations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cloudLocations"))

    @cloud_locations.setter
    def cloud_locations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a183b98ab52c02ee424e78cdadb17d2edcd13bea7da398071820ab2b6339f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudLocations", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7394666204a6e4abd922793d2f86675bbff1aa8d29c8bca5b978d97569ec8b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2296df7e7ecac117e9aaa46b12fd802bc3e3d6503d01227d54bea03958e627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eac9742546af1ca039cabf4d18ff6a61704188f94eae7760d9f0ba0cb2770d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12383f265fb5c72aa5884bd1e7cd7ab2d2fad51540973d36eda7840fd0ae06e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da51d097c63c5fb9a9a142d3cbf5169edb6a0ad9ad462e6538b6c46e99e5a2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "location": "location",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b20e17ad0af5525de12a9729ae1c86b487da5b0969a84c6475bbf2c37e7f79)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Wrapper behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''The location you want to distribute your Cloud Wrapper cache space to.

        This behavior allows all locations configured in your Cloud Wrapper configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "custom_failover_map": "customFailoverMap",
        "enabled": "enabled",
        "failover_map": "failoverMap",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced:
    def __init__(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc36e1d910fc8ffabd063652a44e0e58d0c41aad22d398ae9c3a56b746447e43)
            check_type(argname="argument custom_failover_map", value=custom_failover_map, expected_type=type_hints["custom_failover_map"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_map", value=failover_map, expected_type=type_hints["failover_map"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_failover_map is not None:
            self._values["custom_failover_map"] = custom_failover_map
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_map is not None:
            self._values["failover_map"] = failover_map
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        '''
        result = self._values.get("custom_failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables failover for Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        '''
        result = self._values.get("failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad6e4f71fdf7fe2d7454e156ff3d8254aa6d2ab91e299beb3a6d2c24af7e8b8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomFailoverMap")
    def reset_custom_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomFailoverMap", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverMap")
    def reset_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMap", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMapInput")
    def custom_failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customFailoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverMapInput")
    def failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMap")
    def custom_failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customFailoverMap"))

    @custom_failover_map.setter
    def custom_failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae676d33dcb09fb132b08a31456c74d68d4772a22248360736e91141528fd0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customFailoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a5140767a60230c336cd38ae475cefffd9f2d7ede43efb2f14f452069a7ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMap")
    def failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMap"))

    @failover_map.setter
    def failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9480712d10e76f8a4ba75aa42de1a12b86df8132df7c2368eda28cd67d13b170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc278eea5dc49f82d4e903e680be3f0d88f0d67310a1bbcbefff8a9878b167f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622d257d3a83bd3004d1428b7a18018f3acf1a8554ffc49573bbcc35a0e00148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e79fa1921adebdc0446a250a0d7df8a83b0dccce4996bc60205a2374bc655c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2b22bd69dfaea2c992bffbe47162b3ba3295172e77dd6e6f710d9be8d84336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73f7577d93822bc55c94474fe49e200800459bef26292cea8bd0a151951b606)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a0be59425b76cc0a317633e8162e657ef4840648637b85600a363fb465beed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96982bb85091763d36c75b88a06a7347b34930267f0bb05b1cd887074048a50d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc47c315f7e555d0a43120c782043a83e965c73e54fec92571e83451bb72fb2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01732f10f23debcc62be3fa77450f86336422557603941f0ab83d1d56e806009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc1d66973daa212eeb4b134c1f69eda84c5ca37da06722501733db71c2bc29f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf188acfe09b9cd060b6468bed1261b863af74f4f11e22f98c15320fb95f602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68030a4f86a1c242f045223c3e9c285ca3a357c79beda854be8449c3e95b2eb7)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.'''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae5f1eede85b3b93b4c1a1d5c183d05eca04f9804181653c5be4fadb37c850c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4def981dbeef4a5cb55bb6a61712b9c9ab96a15c4aff6a3c25c6183e399d49d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ffdf5da7f3d950ed8201b114c482030a9529e257f15786158eda8724c8617c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68c94cc7b00021756eac767e0dde0106c44bf9278994e03f4fed1d419dbce46f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38aa40fcc8e8712e144af7ee5855532938b3287c0c9f8cb7c6786f27ba7e9286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae920239a7a014a8b01defbb77513beab4d8a2599571123145a938577d9868d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse",
    jsii_struct_bases=[],
    name_mapping={
        "body": "body",
        "enabled": "enabled",
        "force_eviction": "forceEviction",
        "ignore_purge": "ignorePurge",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse:
    def __init__(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063a4deebc24b2346276153d36915b44ce25c7bffb6f162dc4c3471b42e2a35e)
            check_type(argname="argument body", value=body, expected_type=type_hints["body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_eviction", value=force_eviction, expected_type=type_hints["force_eviction"])
            check_type(argname="argument ignore_purge", value=ignore_purge, expected_type=type_hints["ignore_purge"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if body is not None:
            self._values["body"] = body
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_eviction is not None:
            self._values["force_eviction"] = force_eviction
        if ignore_purge is not None:
            self._values["ignore_purge"] = ignore_purge
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def body(self) -> typing.Optional[builtins.str]:
        '''HTML response of up to 2000 characters to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        '''
        result = self._values.get("body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Serves the custom response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_eviction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        '''
        result = self._values.get("force_eviction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_purge(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to ignore the custom response when purging.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        '''
        result = self._values.get("ignore_purge")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP response code to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b03ba065f29f5c785fbbdc7f9107a32e2fa247bebba2bf202f8f53202e92d81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBody")
    def reset_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceEviction")
    def reset_force_eviction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceEviction", []))

    @jsii.member(jsii_name="resetIgnorePurge")
    def reset_ignore_purge(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnorePurge", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bodyInput")
    def body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceEvictionInput")
    def force_eviction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceEvictionInput"))

    @builtins.property
    @jsii.member(jsii_name="ignorePurgeInput")
    def ignore_purge_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignorePurgeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="body")
    def body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "body"))

    @body.setter
    def body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0f8b262391c0213f12a3638cfe0cbe54ef0414d3ad2bbe538da022b45bc7f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "body", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6756992a5e95bcf9ddf8004db8034516ea0c98beb8c3439587ff1041590f3072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceEviction")
    def force_eviction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceEviction"))

    @force_eviction.setter
    def force_eviction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01176d0048dec1cedd80358d945bcb82ac55d2d1338944b2c2a7a628cd94ddd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceEviction", value)

    @builtins.property
    @jsii.member(jsii_name="ignorePurge")
    def ignore_purge(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignorePurge"))

    @ignore_purge.setter
    def ignore_purge(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dbed27131bededfa32e57df8a159c8a90f74041863ba65134d46e4b1d82d95c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignorePurge", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c018aa55090e536768e15f32ebd5d8e70e262bdafb6214299279c2709a79c67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f45acd50dc2a6ae7f2a470afff0ae917767d5bb843feff063f25bc22d59bf05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746b9c1517c653f52676b5fb21bc321d165883d55e9e78e45788dcd137f03e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda6990251b5348dad9a1499b42c1ec4401d618cdc6361d60207a34066898685)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50aaaf1dfb962e6ac82f76df6576dc1c641cfbb56bb00f451b0a1d09da170803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ad5a0cbc6de2bbf4f3ec071aab3ba9a22f5d9f53f752237d77f11e986bb8ff)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_dash_custom": "segmentDurationDashCustom",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hds_custom": "segmentDurationHdsCustom",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_hls_custom": "segmentDurationHlsCustom",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_duration_smooth_custom": "segmentDurationSmoothCustom",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c9656b854d2d29de2aaefa3c85cffa9729c7e3bb9d52a5345b08997e938856)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_dash_custom", value=segment_duration_dash_custom, expected_type=type_hints["segment_duration_dash_custom"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hds_custom", value=segment_duration_hds_custom, expected_type=type_hints["segment_duration_hds_custom"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_hls_custom", value=segment_duration_hls_custom, expected_type=type_hints["segment_duration_hls_custom"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_duration_smooth_custom", value=segment_duration_smooth_custom, expected_type=type_hints["segment_duration_smooth_custom"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_dash_custom is not None:
            self._values["segment_duration_dash_custom"] = segment_duration_dash_custom
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hds_custom is not None:
            self._values["segment_duration_hds_custom"] = segment_duration_hds_custom
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_hls_custom is not None:
            self._values["segment_duration_hls_custom"] = segment_duration_hls_custom
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_duration_smooth_custom is not None:
            self._values["segment_duration_smooth_custom"] = segment_duration_smooth_custom
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        '''
        result = self._values.get("segment_duration_dash_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        '''
        result = self._values.get("segment_duration_hds_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        '''
        result = self._values.get("segment_duration_hls_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        '''
        result = self._values.get("segment_duration_smooth_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d832c11be048c726b933a2af42d610153ee890e2d315e9090ad4949fd3dc3b6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationDashCustom")
    def reset_segment_duration_dash_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDashCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHdsCustom")
    def reset_segment_duration_hds_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHdsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationHlsCustom")
    def reset_segment_duration_hls_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHlsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentDurationSmoothCustom")
    def reset_segment_duration_smooth_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmoothCustom", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustomInput")
    def segment_duration_dash_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationDashCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustomInput")
    def segment_duration_hds_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHdsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustomInput")
    def segment_duration_hls_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHlsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustomInput")
    def segment_duration_smooth_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationSmoothCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e00d1dc9e2f5996b15d94ad27d6a8cac64b6e83ce09b1e5ccbc139356300b2ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88db7336ae81c0d1eb57ffa17aa2a22b9a2e903db3365b41121aaf7c38886517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__341b34c0d762b4ff49e46032aa5919a46645f9c867aea368c4743510244157ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caaddd770ec31c207f330270eac18169e95f93889a49f65a7544d5d6afbabc78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e376d65dfbfc70dbf4c856fc19b10b258456ba840c68e9f7bbd2ca12dae6d3b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578fdc33269611397938b3c2f8e7f9bc2d684f92f4d76499c828a0dd9ee53745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ebb291a9da5104168fd71bbd958397c146bef31926b00d181e7a34583542b98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef470cbab9bb9c8189f89f0e5fb55c0efbd8ca34634f67a381d5a4af1b8ae36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustom")
    def segment_duration_dash_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationDashCustom"))

    @segment_duration_dash_custom.setter
    def segment_duration_dash_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aded8318b9a9a20241042f4320b35d5ecacfb0eebeb6982ef3ad19866e4c49c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDashCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eefc98313937fcbd6d3b915acacf687732ae00c43c6c762f430c72189f45cb5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustom")
    def segment_duration_hds_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHdsCustom"))

    @segment_duration_hds_custom.setter
    def segment_duration_hds_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39285c31b1060b80e00bfc35f3ac050470083a78dd63814d8bbbbf26a2d94059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHdsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2312507d860e720c788559bc301f40fc36cd6cea089c5b0046d885874bbac275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustom")
    def segment_duration_hls_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHlsCustom"))

    @segment_duration_hls_custom.setter
    def segment_duration_hls_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d04d3e8ecbc90501675d49bf5742767be25a133112f16f67c0a4d0952fd292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHlsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5af9a58f631c9676b8d180be52d3abec82e7ae5198aad30936f581bfdab64cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustom")
    def segment_duration_smooth_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationSmoothCustom"))

    @segment_duration_smooth_custom.setter
    def segment_duration_smooth_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760fc3f569cab2762e79dbc1fd78284db70d82761308f993a3fcfab182f6c887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmoothCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742dd3a63576cbc95daad1a7fb21279d54ab2be6192fcb1df54a1d24a433f067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff4b4c219d90b7576f56532f1643ddc0a0c3516e31b4191ba0258a70b6f4772c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__072c4a626f41cd80e44cdc96f57153d3cded1251093efae824ff940c5722e968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97bb163fad6e5d3b2d73f5661721e554cebfe41b2ef749a82fccba679f0c7c0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881da71711a850c11f7fc75a75a48c088c23fe8339e9faf0d49679398b943090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74172ddd9851fc98b30f3f8c9e59a2558d92f0f08fd8e338d8c6680627bb5c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c48afcda3e1357a4b10aaeb9d236849dc79cbace013f478827165cfaab601493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7144979117ce0a8ab2ddf562305e26246ec69b8c3d6ae056f85bf1707f8690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "optimize_option": "optimizeOption",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce9b4e543b75487922ba68bd58efecbaf2966d9f44f60abda236623b4b706b3)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_option", value=optimize_option, expected_type=type_hints["optimize_option"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_option is not None:
            self._values["optimize_option"] = optimize_option
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_option(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes the delivery throughput and download times for large files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        '''
        result = self._values.get("optimize_option")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40726b685951aef7ae0bdb99c819e6882197716e39eeee8d86055774032aa28a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeOption")
    def reset_optimize_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeOption", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeOptionInput")
    def optimize_option_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optimizeOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76865c40d0b25f11c81339ed0588119f1b687c43022c45d8f7df0d5adf4f921c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19dbfccc25f9a9f758ff4a6e7e1963bf15bf478932a45ad60f44890e7b715ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e70a503e274ef7329f7859556a1ffc4afaf35121bf131210550482e539331514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6dee890c69351638da82e16413c22b4899de812d6b1a9f9bc95aab1411b1f35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeOption")
    def optimize_option(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optimizeOption"))

    @optimize_option.setter
    def optimize_option(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1af3441e161a910d6f619cd06b1c8919ef18ff4bbff75d558a1761a1ee4710f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeOption", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e250ba8f56c0bdc7fdb16af8ea612c8e1238e7442116ff700dbde65fb255d430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4217da966591e162051a90eabb3a98cf73a4a10f74a608a98fe6a55d96b5cbce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ebbb107dd3c0161601d02565a4577bf04f588efd2e9737fe4c5992b6592c64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f299328cfc8a4715e223d33112f7469cd6f184483e284a4afc2761f7a146eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29da795674f262649c0b2f36e0cb9e476d8996ad8b143e433f7729d1085eb41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330224c298494d127f7435d9117daf5604bd6a7742e9f0d195dc4023e29e9194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d723bf494e0a4a9513192fcd93f87ff6c5346a17247d19611f1acfb1f388ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__606dbebbfbf7002d44cfc6ba9a0dddcc762c42c4b1598fcf95e2506d9bd8c1ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef7d192689c70baede78e0dcdd5cc803a5cdcdfb80a959cfd33b470c02abf91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39c25ff4f0071e73f5f07afbc50447e7f0d721cd00ff7b81cea04039f5bac18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec68e3fb450627afe12113bfb54de3606c4f772277a10768f0777fbad259ec20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb44373a1f8960093a3a399d54d656def27d69a70324a83b7e97dcfceae872e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__609e3934cd4555900704f81568c18f21b897fa336b666602b3d914d5b4eac3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce06301ac5a2ff702042e0c9ebc26a7e714f0acf83e88452f8824271b5a6669b)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFileOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFileOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__284a7cd3f8b78ffebcc20c28ff28e12db5d654feb2552bc9c1bbf633bb221347)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae404d7e9ce0148009b839718f4637e3c05c7b5bcc0c27e63c2366250f06ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0e87dff8b389b55dd8148cbcdcd08e1eb24e7c4cb8e0c654617674813ab7592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84f73531fd654a0f9d27dd69afc7e28a58957d06082adf2a55989efb9f18cb49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05edb7a4fdfaa0a7433c61228d513e9058679111af20c76fc312b22142c9359f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc350c7e5dac45423a3abebafc2b2cddcf9ce876d32bc9592ac51c4a6fb3e1da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ce1135b45402a0ade3fe90ba43bab6f1c2752227494a9367480e46591ca521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148b7677a8bef95020082269433f018710d606f632d145c466b64868b64dd8a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f18ed09de17cb7bf5b4954b51cd43da79b1ecc224ec58d6d124257a410059b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24003efaea3c1f9574f6667956d82687e47b98e174770db814a93630db3dd3a3)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLiveOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLiveOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f43d322112a0800e34156bde823045b80af4f727bc577a9ae899fa4d2de3795)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44501e7a908bc1fd0f0b16f3cf33becdd0cd34519c4a5e3f110c8b6f319f38f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e889c8c8f0f1394afbda9bdf5c1be12c2c1727514d928cdb67d3a595712bb82d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11559447844a3fe9aa600ea43357cf4071485ecbd573844c7c38956bd9ac5c77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4251c2f8415f0e258a7e57905701d4584ceccf29e5c207f10ec3915cecc9724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891c4b13381628aaa1b3acdf7130a8cd484d935ea0a436b3bb31107fda1638af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7318b9c29dda1d37db53f46e21216e827220d0c606fdab7994826c90be68f9f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__439a386f3300030393f649c6282925699f2ca14e048880d7cb7d5620863ebb80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f030777716b65383f118e32a208385a13a8187d99ac22f737deb8015fa7f99b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6423eabce51b704c336c8a39372d19bb5241c708ca0ee80d638bc621d23bdcd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9275e1b019d592a1b5c8af667487a8d6c1297887e9dc143ac7c690d36d4e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6649014448c647ccb872902edd43b17aeecb882acf5a673e63040b39bd876191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e18e2c811c8a20be9e7e38bf70d9450edb0e9513d87e42df89d6e30082d4db80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afbd2a10d459b7219b3223a9ffb39723d0c0aab24657ce89781aca526b2403ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3a174eb630fad9e131732f0c4c82d84e16b841a8ab19ce43df425b09b07170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ee8ebbfdfc30e053f2f7a090d99bcd761ea941d652f6db3101f418e8e9557c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c39a361698e91ec2c4e0afd3eda7876e5fec7eb8bd094652578791241fb8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f159ca02428a850d56bef8fea7a157cafb148734fdbc176f7d5c21d6a978a0f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af07f27acf00b662ec146a2fe00cd9cf06ae916b74bad8ab79485ce593151085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b506bdf823262a565a44baf1804bfb628c0d51f04b7b57249dbdf95884826b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e741bcc44672cda273b91da6400a2d8196c28b68cd69ce639f8c0936c78d8a)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6297f9eeda94ecd3d66dd7e7b4a6e37fe7ee63fe8b8e2bc68fbb94392825dceb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bded6386a5b3f1f607b4d9ff6e67ecdc7e72e47bb666b6416dccd6a9ffe6aee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fc5f894e287c4739808c053cae624c79de9764b60b736392187a182c81c601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4d23dcb03d1409e64ea535d60abdc6e742f02c5d62d1ea8ce3d50ef745f165a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2a9810c37704b73a9c603aafb6dcce87a739ef021b18ddaccbcb88c85f2f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d7691214b5396e3f429038c53bb1e3a1974fa41b6e6ab7437a4c65f6a115f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c4f6d4dd182ca345f102d506e92d994a547585bc66b52ff36baa5e86b18af16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e68ccf183c095054bbbfd47596f008d02bd67bf17fa42fde886ada70d7d87d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155f627561789b493781b57ba9fdfa2cdbfb67bd16918b1f1808dfd9f4c20a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a62c2b273f39bdabd85fe5dbe03dbb733bfffa9d6a42bc564ad0de17fddee07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca6753342465ccd709e5e76ae3f56f5169afdefa65afb68199d32c40e18d3b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c742dbb358ec0edce2bb000f96cf38477f6e33fa282d624f4c2283992ae203e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33aac649b599621a3ddd9e37d16483256d71f2b436f2f9ea03050b47a90fb83e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7bfad10d99b6752e1a3917a14e1852c10485690c0324553fe7b7b91c80c230f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1594049fb3ec7d716c16e17b31469a0388e31d368df779d5f79a37d9515d6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a30ed9a3dfc79ca01b5a715c929f5ed1387c3d78ff33c480424e81c5f82adc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ce58958d44ee17d54be595e50233a504259e7be068f196ee93bd0233329fff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb81283996e6ffc0eef32f85ff3feda950fe18fb1c71e8969f4cd8de7f84c33f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019c156e80d9649d65dc84dfc276283432a952daa66efc30101d837cd9b5ecca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb545cc90c77c11b374af19906c8ba75c1c1737dc90ded965270fbc92139b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "first_location": "firstLocation",
        "locked": "locked",
        "second_location": "secondLocation",
        "source_type": "sourceType",
        "targets": "targets",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138c1062d14b86a5fd06cc01ec604c252a5bd1eba99b00bcd596f50492c401b8)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument first_location", value=first_location, expected_type=type_hints["first_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument second_location", value=second_location, expected_type=type_hints["second_location"])
            check_type(argname="argument source_type", value=source_type, expected_type=type_hints["source_type"])
            check_type(argname="argument targets", value=targets, expected_type=type_hints["targets"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if first_location is not None:
            self._values["first_location"] = first_location
        if locked is not None:
            self._values["locked"] = locked
        if second_location is not None:
            self._values["second_location"] = second_location
        if source_type is not None:
            self._values["source_type"] = source_type
        if targets is not None:
            self._values["targets"] = targets
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content PrePosition behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def first_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.'''
        result = self._values.get("first_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def second_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.'''
        result = self._values.get("second_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def source_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.'''
        result = self._values.get("source_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def targets(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.'''
        result = self._values.get("targets")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePositionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePositionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f27e53c2a31708e085a49d42ae0ab31148fbd31c15f6f6203040cc221ebe071)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFirstLocation")
    def reset_first_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondLocation")
    def reset_second_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondLocation", []))

    @jsii.member(jsii_name="resetSourceType")
    def reset_source_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSourceType", []))

    @jsii.member(jsii_name="resetTargets")
    def reset_targets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargets", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="firstLocationInput")
    def first_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "firstLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondLocationInput")
    def second_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceTypeInput")
    def source_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="targetsInput")
    def targets_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a96d8653198af9013aed7411a23992475a63e3021d7dcce7340f631ed3b1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="firstLocation")
    def first_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "firstLocation"))

    @first_location.setter
    def first_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5d2577a2e294ca133db61052116c0fef4e550cbfe2ca4c0e34da019e6c09c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "firstLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ace87cb15fe0234b61ebb9a91de81232a9bff47f08cd5ef753b3699354264990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondLocation")
    def second_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondLocation"))

    @second_location.setter
    def second_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a271059edcdd52b9c9840e281008ee02c9b216338f0f5074d1eab2050417bc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondLocation", value)

    @builtins.property
    @jsii.member(jsii_name="sourceType")
    def source_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sourceType"))

    @source_type.setter
    def source_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df570ee151cacbd61aad13973ab8d1dc2725f7572fa284b427d32847515b725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sourceType", value)

    @builtins.property
    @jsii.member(jsii_name="targets")
    def targets(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targets"))

    @targets.setter
    def targets(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b6fcea4afe5747f48574caae367e4542e5393c7c30325a3f3d2dacebb56863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targets", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a12fcdddea1ac2c813e339bfce7baced5e730a7f0b6ca2c65bf8f2b4946fef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc407e70b2cdcfb3f2a4eb4de4e573ab3cca52e3069ea015f5ed4fbb98420406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078682c9db0aad61893d5ea4966bfd90c9a9829cddbfe4a271d0764f2f7f838a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection",
    jsii_struct_bases=[],
    name_mapping={
        "countries": "countries",
        "dmas": "dmas",
        "enabled": "enabled",
        "enable_geo_protection": "enableGeoProtection",
        "enable_geo_redirect_on_deny": "enableGeoRedirectOnDeny",
        "enable_ip_protection": "enableIpProtection",
        "enable_ip_redirect_on_deny": "enableIpRedirectOnDeny",
        "enable_referrer_protection": "enableReferrerProtection",
        "enable_referrer_redirect_on_deny": "enableReferrerRedirectOnDeny",
        "geo_protection_mode": "geoProtectionMode",
        "geo_protection_title": "geoProtectionTitle",
        "geo_redirect_url": "geoRedirectUrl",
        "ip_addresses": "ipAddresses",
        "ip_protection_mode": "ipProtectionMode",
        "ip_protection_title": "ipProtectionTitle",
        "ip_redirect_url": "ipRedirectUrl",
        "locked": "locked",
        "override_ip_addresses": "overrideIpAddresses",
        "referrer_domains": "referrerDomains",
        "referrer_protection_mode": "referrerProtectionMode",
        "referrer_protection_title": "referrerProtectionTitle",
        "referrer_redirect_url": "referrerRedirectUrl",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection:
    def __init__(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf906679cf3eaa0e0c9c02d6d116125ad37437b25ae16b333d11503b424ecb4)
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument dmas", value=dmas, expected_type=type_hints["dmas"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_geo_protection", value=enable_geo_protection, expected_type=type_hints["enable_geo_protection"])
            check_type(argname="argument enable_geo_redirect_on_deny", value=enable_geo_redirect_on_deny, expected_type=type_hints["enable_geo_redirect_on_deny"])
            check_type(argname="argument enable_ip_protection", value=enable_ip_protection, expected_type=type_hints["enable_ip_protection"])
            check_type(argname="argument enable_ip_redirect_on_deny", value=enable_ip_redirect_on_deny, expected_type=type_hints["enable_ip_redirect_on_deny"])
            check_type(argname="argument enable_referrer_protection", value=enable_referrer_protection, expected_type=type_hints["enable_referrer_protection"])
            check_type(argname="argument enable_referrer_redirect_on_deny", value=enable_referrer_redirect_on_deny, expected_type=type_hints["enable_referrer_redirect_on_deny"])
            check_type(argname="argument geo_protection_mode", value=geo_protection_mode, expected_type=type_hints["geo_protection_mode"])
            check_type(argname="argument geo_protection_title", value=geo_protection_title, expected_type=type_hints["geo_protection_title"])
            check_type(argname="argument geo_redirect_url", value=geo_redirect_url, expected_type=type_hints["geo_redirect_url"])
            check_type(argname="argument ip_addresses", value=ip_addresses, expected_type=type_hints["ip_addresses"])
            check_type(argname="argument ip_protection_mode", value=ip_protection_mode, expected_type=type_hints["ip_protection_mode"])
            check_type(argname="argument ip_protection_title", value=ip_protection_title, expected_type=type_hints["ip_protection_title"])
            check_type(argname="argument ip_redirect_url", value=ip_redirect_url, expected_type=type_hints["ip_redirect_url"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_ip_addresses", value=override_ip_addresses, expected_type=type_hints["override_ip_addresses"])
            check_type(argname="argument referrer_domains", value=referrer_domains, expected_type=type_hints["referrer_domains"])
            check_type(argname="argument referrer_protection_mode", value=referrer_protection_mode, expected_type=type_hints["referrer_protection_mode"])
            check_type(argname="argument referrer_protection_title", value=referrer_protection_title, expected_type=type_hints["referrer_protection_title"])
            check_type(argname="argument referrer_redirect_url", value=referrer_redirect_url, expected_type=type_hints["referrer_redirect_url"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if countries is not None:
            self._values["countries"] = countries
        if dmas is not None:
            self._values["dmas"] = dmas
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_geo_protection is not None:
            self._values["enable_geo_protection"] = enable_geo_protection
        if enable_geo_redirect_on_deny is not None:
            self._values["enable_geo_redirect_on_deny"] = enable_geo_redirect_on_deny
        if enable_ip_protection is not None:
            self._values["enable_ip_protection"] = enable_ip_protection
        if enable_ip_redirect_on_deny is not None:
            self._values["enable_ip_redirect_on_deny"] = enable_ip_redirect_on_deny
        if enable_referrer_protection is not None:
            self._values["enable_referrer_protection"] = enable_referrer_protection
        if enable_referrer_redirect_on_deny is not None:
            self._values["enable_referrer_redirect_on_deny"] = enable_referrer_redirect_on_deny
        if geo_protection_mode is not None:
            self._values["geo_protection_mode"] = geo_protection_mode
        if geo_protection_title is not None:
            self._values["geo_protection_title"] = geo_protection_title
        if geo_redirect_url is not None:
            self._values["geo_redirect_url"] = geo_redirect_url
        if ip_addresses is not None:
            self._values["ip_addresses"] = ip_addresses
        if ip_protection_mode is not None:
            self._values["ip_protection_mode"] = ip_protection_mode
        if ip_protection_title is not None:
            self._values["ip_protection_title"] = ip_protection_title
        if ip_redirect_url is not None:
            self._values["ip_redirect_url"] = ip_redirect_url
        if locked is not None:
            self._values["locked"] = locked
        if override_ip_addresses is not None:
            self._values["override_ip_addresses"] = override_ip_addresses
        if referrer_domains is not None:
            self._values["referrer_domains"] = referrer_domains
        if referrer_protection_mode is not None:
            self._values["referrer_protection_mode"] = referrer_protection_mode
        if referrer_protection_title is not None:
            self._values["referrer_protection_title"] = referrer_protection_title
        if referrer_redirect_url is not None:
            self._values["referrer_redirect_url"] = referrer_redirect_url
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def dmas(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of Designated Market Area codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        '''
        result = self._values.get("dmas")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content Targeting feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, verifies IP addresses are unique to specific geographic regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        '''
        result = self._values.get("enable_geo_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        '''
        result = self._values.get("enable_geo_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to control access to your content from specific sets of IP addresses and CIDR blocks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        '''
        result = self._values.get("enable_ip_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        '''
        result = self._values.get("enable_ip_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        '''
        result = self._values.get("enable_referrer_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        '''
        result = self._values.get("enable_referrer_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        '''
        result = self._values.get("geo_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        '''
        result = self._values.get("geo_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        '''
        result = self._values.get("geo_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks to allow or deny.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        '''
        result = self._values.get("ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def ip_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        '''
        result = self._values.get("ip_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        '''
        result = self._values.get("ip_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        '''
        result = self._values.get("ip_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        '''
        result = self._values.get("override_ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of domains from which to allow or deny traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        '''
        result = self._values.get("referrer_domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specify the action to take.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        '''
        result = self._values.get("referrer_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        '''
        result = self._values.get("referrer_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        '''
        result = self._values.get("referrer_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4375286cdd7f1e8900f8d3f4f9aa9926bc09dff914d6152b79dad435630aea10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetDmas")
    def reset_dmas(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDmas", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableGeoProtection")
    def reset_enable_geo_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoProtection", []))

    @jsii.member(jsii_name="resetEnableGeoRedirectOnDeny")
    def reset_enable_geo_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableIpProtection")
    def reset_enable_ip_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpProtection", []))

    @jsii.member(jsii_name="resetEnableIpRedirectOnDeny")
    def reset_enable_ip_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableReferrerProtection")
    def reset_enable_referrer_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerProtection", []))

    @jsii.member(jsii_name="resetEnableReferrerRedirectOnDeny")
    def reset_enable_referrer_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerRedirectOnDeny", []))

    @jsii.member(jsii_name="resetGeoProtectionMode")
    def reset_geo_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionMode", []))

    @jsii.member(jsii_name="resetGeoProtectionTitle")
    def reset_geo_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionTitle", []))

    @jsii.member(jsii_name="resetGeoRedirectUrl")
    def reset_geo_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoRedirectUrl", []))

    @jsii.member(jsii_name="resetIpAddresses")
    def reset_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAddresses", []))

    @jsii.member(jsii_name="resetIpProtectionMode")
    def reset_ip_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionMode", []))

    @jsii.member(jsii_name="resetIpProtectionTitle")
    def reset_ip_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionTitle", []))

    @jsii.member(jsii_name="resetIpRedirectUrl")
    def reset_ip_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpRedirectUrl", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideIpAddresses")
    def reset_override_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideIpAddresses", []))

    @jsii.member(jsii_name="resetReferrerDomains")
    def reset_referrer_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerDomains", []))

    @jsii.member(jsii_name="resetReferrerProtectionMode")
    def reset_referrer_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionMode", []))

    @jsii.member(jsii_name="resetReferrerProtectionTitle")
    def reset_referrer_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionTitle", []))

    @jsii.member(jsii_name="resetReferrerRedirectUrl")
    def reset_referrer_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerRedirectUrl", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="dmasInput")
    def dmas_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "dmasInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtectionInput")
    def enable_geo_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDenyInput")
    def enable_geo_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpProtectionInput")
    def enable_ip_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDenyInput")
    def enable_ip_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtectionInput")
    def enable_referrer_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDenyInput")
    def enable_referrer_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionModeInput")
    def geo_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitleInput")
    def geo_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrlInput")
    def geo_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAddressesInput")
    def ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "ipAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionModeInput")
    def ip_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitleInput")
    def ip_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrlInput")
    def ip_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddressesInput")
    def override_ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "overrideIpAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerDomainsInput")
    def referrer_domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "referrerDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionModeInput")
    def referrer_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitleInput")
    def referrer_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrlInput")
    def referrer_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c990e692852915a621d3637ebe389b1ac8295315c1274381730fdcfcd04c92e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="dmas")
    def dmas(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "dmas"))

    @dmas.setter
    def dmas(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948a958e6444e702cf0cb4656be9ea5bc8833334737224b7ada144afad67527a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dmas", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e8c693c6f84761214e541af0dbe9b82aa673c07e7c7735dccc54af6366cc16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtection")
    def enable_geo_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoProtection"))

    @enable_geo_protection.setter
    def enable_geo_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5107916369e56d951c0997acd35a90dfa6495338e72b583bb05cdb57b2443da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDeny")
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoRedirectOnDeny"))

    @enable_geo_redirect_on_deny.setter
    def enable_geo_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c2a6e4c6453dff2520c3de9152b26022c935231517230a8434db8bfa2e23c6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpProtection")
    def enable_ip_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpProtection"))

    @enable_ip_protection.setter
    def enable_ip_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e103d234836244acd7eddc42dd55b9d668d74f82c9ac9d6f5da88f1902d1145c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDeny")
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpRedirectOnDeny"))

    @enable_ip_redirect_on_deny.setter
    def enable_ip_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80a6efe7ee1f1ee84561a0d485121aeb0758872108ab744c8fb24f19c5ca174f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtection")
    def enable_referrer_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerProtection"))

    @enable_referrer_protection.setter
    def enable_referrer_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3b6205d72109335492c2fbe5c5a35ad48a3a783f00c35b79f7ce0cf91e2293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDeny")
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerRedirectOnDeny"))

    @enable_referrer_redirect_on_deny.setter
    def enable_referrer_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a46052d1dd75d711b0e3a01c0f6a75b4a3b020c4e906a038b11f4e21f3a78c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionMode")
    def geo_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionMode"))

    @geo_protection_mode.setter
    def geo_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__625a0dac415b3d2d9f781dbbf3015a308f28eeffc30d0a6f13068ace8a788ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitle")
    def geo_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionTitle"))

    @geo_protection_title.setter
    def geo_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f99910fb077931246536aff572b2ec84b9d6cfbd463a2454f23679796a8e5f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrl")
    def geo_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoRedirectUrl"))

    @geo_redirect_url.setter
    def geo_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850b670cbe03205084d196ce1d8cb51f038d336a3aaa5cec1923725b4e8ac157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="ipAddresses")
    def ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "ipAddresses"))

    @ip_addresses.setter
    def ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c797303f8f0b0cb78552e864ceb9ac79d57fb77c2716f0f5aa69fa94091a3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionMode")
    def ip_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionMode"))

    @ip_protection_mode.setter
    def ip_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760576b99ad4d04e5c35ce0244b384e413b1e733286c42d0c850cbce3e1f7b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitle")
    def ip_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionTitle"))

    @ip_protection_title.setter
    def ip_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cd93ea5f9b31821b3438b3c8005c3c55914f42033d794984e4b8384cb996111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrl")
    def ip_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipRedirectUrl"))

    @ip_redirect_url.setter
    def ip_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060992252d55f70d724e5f14deb6eb8b23dc13eef2838cfa2f706a947cb801f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd381c2ef2c3ab84049cfd83f1719d2d7f1ec4095aa6ec8dd45c1cd7359a75cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddresses")
    def override_ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "overrideIpAddresses"))

    @override_ip_addresses.setter
    def override_ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f95864c18f96344cd74da46e9f552de70a109ed05f550c7800b8e9ab52d3ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideIpAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="referrerDomains")
    def referrer_domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "referrerDomains"))

    @referrer_domains.setter
    def referrer_domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa80fbb48201154e9155137ae5945178b6525e5f1be755d90e0e95a35d1322fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerDomains", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionMode")
    def referrer_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionMode"))

    @referrer_protection_mode.setter
    def referrer_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490a017f3cf0dccb46e0927a38c25e78527464ecb304c34639212561efc194e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitle")
    def referrer_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionTitle"))

    @referrer_protection_title.setter
    def referrer_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84c037f50cbeea639c4c9d4fa2f28d0335ebfd1b04d42829bd0c767a5cb48d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrl")
    def referrer_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerRedirectUrl"))

    @referrer_redirect_url.setter
    def referrer_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee74ece1f868c9cbed550264f832c05ce308bea20c58b2b1cc58f2f4090cb323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53fdad051562ab5a0a5c1aae8ba590139ff3655183de076f37d391aa56784813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e799ba4a664b046c9431e8c3bc0aed2e09ae8e4bb7971d88fa8a5a9ef4527a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40768231b1b6d7bd391c6cb97340bedab7e68e5f4e4d98cec4e205eaaf7442f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f4cc139874e81b9c4d46e5561e729c13963d3d54498d1ed8b1ea341c057260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport",
    jsii_struct_bases=[],
    name_mapping={
        "allow_credentials": "allowCredentials",
        "allow_headers": "allowHeaders",
        "allow_origins": "allowOrigins",
        "enabled": "enabled",
        "expose_headers": "exposeHeaders",
        "headers": "headers",
        "locked": "locked",
        "methods": "methods",
        "origins": "origins",
        "preflight_max_age": "preflightMaxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport:
    def __init__(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6eb929a60b78f8fb5ac5b844a1f4d76e998dc4f5b3c8063864ad0496219c425)
            check_type(argname="argument allow_credentials", value=allow_credentials, expected_type=type_hints["allow_credentials"])
            check_type(argname="argument allow_headers", value=allow_headers, expected_type=type_hints["allow_headers"])
            check_type(argname="argument allow_origins", value=allow_origins, expected_type=type_hints["allow_origins"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expose_headers", value=expose_headers, expected_type=type_hints["expose_headers"])
            check_type(argname="argument headers", value=headers, expected_type=type_hints["headers"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument methods", value=methods, expected_type=type_hints["methods"])
            check_type(argname="argument origins", value=origins, expected_type=type_hints["origins"])
            check_type(argname="argument preflight_max_age", value=preflight_max_age, expected_type=type_hints["preflight_max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_credentials is not None:
            self._values["allow_credentials"] = allow_credentials
        if allow_headers is not None:
            self._values["allow_headers"] = allow_headers
        if allow_origins is not None:
            self._values["allow_origins"] = allow_origins
        if enabled is not None:
            self._values["enabled"] = enabled
        if expose_headers is not None:
            self._values["expose_headers"] = expose_headers
        if headers is not None:
            self._values["headers"] = headers
        if locked is not None:
            self._values["locked"] = locked
        if methods is not None:
            self._values["methods"] = methods
        if origins is not None:
            self._values["origins"] = origins
        if preflight_max_age is not None:
            self._values["preflight_max_age"] = preflight_max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_credentials(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Accepts requests made using credentials, like cookies or TLS client certificates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        '''
        result = self._values.get("allow_credentials")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_headers(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, defines which headers to allow when making the actual request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        '''
        result = self._values.get("allow_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_origins(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, sets which origin hostnames to accept requests from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        '''
        result = self._values.get("allow_origins")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables CORS feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expose_headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''In responses to preflight requests, lists names of headers that clients can access.

        By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        '''
        result = self._values.get("expose_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the supported request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        '''
        result = self._values.get("headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def methods(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        '''
        result = self._values.get("methods")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origins(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin hostnames to accept requests from.

        The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        '''
        result = self._values.get("origins")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def preflight_max_age(self) -> typing.Optional[builtins.str]:
        '''Defines the number of seconds that the browser should cache the response to a preflight request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        '''
        result = self._values.get("preflight_max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53f753e76a5da4057c49d93ad15ca05b0bb278c8021aba3d69f69da090c361d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowCredentials")
    def reset_allow_credentials(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCredentials", []))

    @jsii.member(jsii_name="resetAllowHeaders")
    def reset_allow_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHeaders", []))

    @jsii.member(jsii_name="resetAllowOrigins")
    def reset_allow_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOrigins", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExposeHeaders")
    def reset_expose_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExposeHeaders", []))

    @jsii.member(jsii_name="resetHeaders")
    def reset_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaders", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethods")
    def reset_methods(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethods", []))

    @jsii.member(jsii_name="resetOrigins")
    def reset_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigins", []))

    @jsii.member(jsii_name="resetPreflightMaxAge")
    def reset_preflight_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreflightMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowCredentialsInput")
    def allow_credentials_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCredentialsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHeadersInput")
    def allow_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOriginsInput")
    def allow_origins_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="exposeHeadersInput")
    def expose_headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "exposeHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="headersInput")
    def headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headersInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodsInput")
    def methods_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "methodsInput"))

    @builtins.property
    @jsii.member(jsii_name="originsInput")
    def origins_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originsInput"))

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAgeInput")
    def preflight_max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preflightMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCredentials")
    def allow_credentials(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCredentials"))

    @allow_credentials.setter
    def allow_credentials(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a610fd21d4f796dd20e4d464eae966f20c7ccf0f8a617246f54e4720e348da28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCredentials", value)

    @builtins.property
    @jsii.member(jsii_name="allowHeaders")
    def allow_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowHeaders"))

    @allow_headers.setter
    def allow_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dce478a0296e52767f8325d682cf949e0fd2afbba65aff109974bfc63bfa108)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="allowOrigins")
    def allow_origins(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowOrigins"))

    @allow_origins.setter
    def allow_origins(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3b478f412319c0348374e6e5435ad3f65be02c8fa42a753c323dc9f0e32258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOrigins", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6bdfe7e38567746320178a1456a4e42aca1e6770e11b7d335b18ad1d634fea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="exposeHeaders")
    def expose_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "exposeHeaders"))

    @expose_headers.setter
    def expose_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecdd5c484b6e4b24288a8e0fad4d56e2f50b66e8ef315d853883331c895e4f9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exposeHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="headers")
    def headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headers"))

    @headers.setter
    def headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3ad7ac9ab95ae3511e2693c4b5f14dd45ffdfc339fba25a95c4754274c1b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headers", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a3f1cd670b1f7bb94ca45d05d634e59350ce48df455187fdfa57fb33a22e5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="methods")
    def methods(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "methods"))

    @methods.setter
    def methods(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f4daa170edbf346630eb68451d09607c8e8b3429e1f427702bd29ac07f9a27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "methods", value)

    @builtins.property
    @jsii.member(jsii_name="origins")
    def origins(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "origins"))

    @origins.setter
    def origins(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129584e0c30e08c08687678cbec2890d3c134a497f8545e7b442af8749cefecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origins", value)

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAge")
    def preflight_max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preflightMaxAge"))

    @preflight_max_age.setter
    def preflight_max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e686457ca30bc35040dedfcbd40722d2fedc6add7b342d50c518ba22001eac64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preflightMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9b17889f294c802cf815a696b28df7f228d5fc9262fd841a2d8da1455912d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549dba8c5e0930bce6adf0a36046478a29bfc950d6f94eeba60084c9421c7ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7b0bfb16f4fd72db52bce7c8d9f7926614d5c68adeb378f3b227574a24d452f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbec5240b1d09a2a42eed47e82790513dd694cf4c0e31f3ac1a0e90538857d26)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__122b4ef481dd71109455c05f46819d7ee27d340af3b3896ed0105724266bd5ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c196f5be9f9ecbf3bf9b80e202e3967a38e55943a13874a07cc3f11bedc5a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32cccc295f6c728bb8a4f56f8585ec4725a2a76ef7532fcc92492c26b8166cec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b03e8965170afa5309c26d9355819cbb6b4f0f9bd1ca19135f3fdd7e207479b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0761fb6c46749929f93a367a3590cfb47adba9c5d4b81e655850e480763f254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f565d5024ed241fc63043d68cd0d306b6d77a95bc38c2431add591e4a2258e09)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eae7cc49f6eb76f7437c075d3b5634945625cb91dfa0727e76a0cbbe3424271)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e8d2c56e32715da11ca4537c2dd6d5e0f68e5ffcdbf47494ff6b33157e25fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ba250a4fb5e6d264c43a2dee315ff3b877c20992b63c3267d2f594247341c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1cf28cdb8ebdf10556d08d3c4ceac193be419acce31f01a3466f1428abffa70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c3f2168db7cb83defa2475dba2e8bcde8e47275224be9d375a02da07fbbcf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c610a3bc834d8ff024882086b560398c595d5fd73e82546c4f81922257a26b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a9cf580ec9c14f30a0a146bdb6c76b56597763f68bc993a3c159fa0ad9c0431)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1724ea218fc6484d8c10d33f59d972f2253ebd9981f4e96a3f84215eb94c33c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4b617d232b1820554c7d3e9546a68f292e41bf1008a6fc57d4fdcafface887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2397c32b8b7d83d39c5202e62a42a38e273a865c117741472012d8f9c4b0268a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f91e31bc813830256e9209212fc58c4744e26f34066343790cb145bd16f97d12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e385be49288765ed9b409765c36ff4235356345f2e49fbfdd3d96303e013d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e3800e5956e1a0d41a247149eac351d30ba22c60febb575c9e0ca02e01fb17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior",
    jsii_struct_bases=[],
    name_mapping={
        "behavior_id": "behaviorId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior:
    def __init__(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a879f7617bd507e329651dba1db5bc35786ed51e05438edbf6852dd6d43000)
            check_type(argname="argument behavior_id", value=behavior_id, expected_type=type_hints["behavior_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior_id is not None:
            self._values["behavior_id"] = behavior_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior_id(self) -> typing.Optional[builtins.str]:
        '''The unique identifier for the predefined custom behavior you want to insert into the current rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        '''
        result = self._values.get("behavior_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df99bfe402120b141d28f083c35e28c329bbd1d130d702d58afefd47b4328637)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehaviorId")
    def reset_behavior_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehaviorId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorIdInput")
    def behavior_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorId")
    def behavior_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behaviorId"))

    @behavior_id.setter
    def behavior_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54078868d9854c37f859ee2917a9e9c40c41c0f92c17c0aa8eba0a7fcbeb62ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behaviorId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df337ae84ac9f87e6738eff843680f7aa5ba97cb4a5a7504804b53a90f91fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45ee5c8df902718644f392f2815aca52c5578f999a8a22ca6d6c5ab7cafbc5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e2eeacec754df88e0990081952d14b6596292b9b485ebd49a8e516f6d097b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d81d995fc00a932b69d4d61ffa05634a09324808d1069087fad7b6686522bf25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_stream_title": "beaconStreamTitle",
        "collect_midgress_traffic": "collectMidgressTraffic",
        "datastream_ids": "datastreamIds",
        "enabled": "enabled",
        "locked": "locked",
        "log_enabled": "logEnabled",
        "log_stream_name": "logStreamName",
        "log_stream_title": "logStreamTitle",
        "sampling_percentage": "samplingPercentage",
        "stream_type": "streamType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream:
    def __init__(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[jsii.Number] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6954c3398f90b1497c654fe22e291317f51fb07ed1fe94e5a5aedf0d2b9210c3)
            check_type(argname="argument beacon_stream_title", value=beacon_stream_title, expected_type=type_hints["beacon_stream_title"])
            check_type(argname="argument collect_midgress_traffic", value=collect_midgress_traffic, expected_type=type_hints["collect_midgress_traffic"])
            check_type(argname="argument datastream_ids", value=datastream_ids, expected_type=type_hints["datastream_ids"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_enabled", value=log_enabled, expected_type=type_hints["log_enabled"])
            check_type(argname="argument log_stream_name", value=log_stream_name, expected_type=type_hints["log_stream_name"])
            check_type(argname="argument log_stream_title", value=log_stream_title, expected_type=type_hints["log_stream_title"])
            check_type(argname="argument sampling_percentage", value=sampling_percentage, expected_type=type_hints["sampling_percentage"])
            check_type(argname="argument stream_type", value=stream_type, expected_type=type_hints["stream_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_stream_title is not None:
            self._values["beacon_stream_title"] = beacon_stream_title
        if collect_midgress_traffic is not None:
            self._values["collect_midgress_traffic"] = collect_midgress_traffic
        if datastream_ids is not None:
            self._values["datastream_ids"] = datastream_ids
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if log_enabled is not None:
            self._values["log_enabled"] = log_enabled
        if log_stream_name is not None:
            self._values["log_stream_name"] = log_stream_name
        if log_stream_title is not None:
            self._values["log_stream_title"] = log_stream_title
        if sampling_percentage is not None:
            self._values["sampling_percentage"] = sampling_percentage
        if stream_type is not None:
            self._values["stream_type"] = stream_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        '''
        result = self._values.get("beacon_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def collect_midgress_traffic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        '''
        result = self._values.get("collect_midgress_traffic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def datastream_ids(self) -> typing.Optional[builtins.str]:
        '''A set of dash-separated DataStream ID values to limit the scope of reported data.

        By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        '''
        result = self._values.get("datastream_ids")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables DataStream reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables log collection for the property by associating it with DataStream configurations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        '''
        result = self._values.get("log_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_stream_name(self) -> typing.Optional[jsii.Number]:
        '''Specifies the unique IDs of streams configured for the property.

        For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        '''
        result = self._values.get("log_stream_name")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def log_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        '''
        result = self._values.get("log_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of log data you want to collect for this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        '''
        result = self._values.get("sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def stream_type(self) -> typing.Optional[builtins.str]:
        '''Specify the DataStream type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        '''
        result = self._values.get("stream_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastreamOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastreamOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e58f81909bfb7515e62d594a557e7db9b95bee536491b88119fff73bcbdd90ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconStreamTitle")
    def reset_beacon_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconStreamTitle", []))

    @jsii.member(jsii_name="resetCollectMidgressTraffic")
    def reset_collect_midgress_traffic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCollectMidgressTraffic", []))

    @jsii.member(jsii_name="resetDatastreamIds")
    def reset_datastream_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastreamIds", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogEnabled")
    def reset_log_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEnabled", []))

    @jsii.member(jsii_name="resetLogStreamName")
    def reset_log_stream_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamName", []))

    @jsii.member(jsii_name="resetLogStreamTitle")
    def reset_log_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamTitle", []))

    @jsii.member(jsii_name="resetSamplingPercentage")
    def reset_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingPercentage", []))

    @jsii.member(jsii_name="resetStreamType")
    def reset_stream_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStreamType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitleInput")
    def beacon_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTrafficInput")
    def collect_midgress_traffic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "collectMidgressTrafficInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamIdsInput")
    def datastream_ids_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datastreamIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logEnabledInput")
    def log_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamNameInput")
    def log_stream_name_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "logStreamNameInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamTitleInput")
    def log_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingPercentageInput")
    def sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "samplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="streamTypeInput")
    def stream_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "streamTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitle")
    def beacon_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconStreamTitle"))

    @beacon_stream_title.setter
    def beacon_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a223fc89a695ca4e54f9f4e3286dc36ff848f18d3091b891230515e0021a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTraffic")
    def collect_midgress_traffic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "collectMidgressTraffic"))

    @collect_midgress_traffic.setter
    def collect_midgress_traffic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e137218b79130cf45cfb6862ff126a7eb704bd571323f92e63d192c0ce62dd10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "collectMidgressTraffic", value)

    @builtins.property
    @jsii.member(jsii_name="datastreamIds")
    def datastream_ids(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "datastreamIds"))

    @datastream_ids.setter
    def datastream_ids(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0875060693d9949c2f10396256420b12bce25c53f5c65074c544099022f817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "datastreamIds", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3911a638cf7169e2f097c74f955651e509b47386fa75fcb438f9eff98883d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f94f3f5c81e21807c8d1abeb015f494cf9666243f253a5b8eb1a0f8422e39dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logEnabled")
    def log_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEnabled"))

    @log_enabled.setter
    def log_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba68872dd101072d7cb3945a12b7c28a952c445d3d96db5503098bc837d951f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamName")
    def log_stream_name(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "logStreamName"))

    @log_stream_name.setter
    def log_stream_name(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4478c8ee6e9714e9d3e95e4a3ed72135a342057b85237a29a0bab5405b5edae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamName", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamTitle")
    def log_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logStreamTitle"))

    @log_stream_title.setter
    def log_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714a49332657a74f0fcfadbe9f7105320baade45b6dc43988a6b19f5f279c7d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="samplingPercentage")
    def sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "samplingPercentage"))

    @sampling_percentage.setter
    def sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43bb039c91fa86fcc14aed89c123df74fb8b09538781c8e2740e070dd308cd7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="streamType")
    def stream_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "streamType"))

    @stream_type.setter
    def stream_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55cf53d6410cb1fdf05cc1ebaefc8bd54044c286206fce8af924583eda81801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "streamType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2514c23c32e342f55830650c5272b3375d8445b0822a456db876967869eeceac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__169ec4d3eec30b95575e6787586e41ce91e7c538592985860671acd9d26b5e19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef045d62cfd4805eab620a545fbb96b4e2aa74d0db7e128a56a4025b7e2681d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous": "anonymous",
        "enabled": "enabled",
        "gwenabled": "gwenabled",
        "locked": "locked",
        "namespace_id": "namespaceId",
        "template_uuid": "templateUuid",
        "tlsenabled": "tlsenabled",
        "uuid": "uuid",
        "wsenabled": "wsenabled",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp:
    def __init__(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e691c3a7a9929e475fedd6261fb20d1450025adbbc8ead1e6658c769bf52c7)
            check_type(argname="argument anonymous", value=anonymous, expected_type=type_hints["anonymous"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument gwenabled", value=gwenabled, expected_type=type_hints["gwenabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_id", value=namespace_id, expected_type=type_hints["namespace_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tlsenabled", value=tlsenabled, expected_type=type_hints["tlsenabled"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument wsenabled", value=wsenabled, expected_type=type_hints["wsenabled"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous is not None:
            self._values["anonymous"] = anonymous
        if enabled is not None:
            self._values["enabled"] = enabled
        if gwenabled is not None:
            self._values["gwenabled"] = gwenabled
        if locked is not None:
            self._values["locked"] = locked
        if namespace_id is not None:
            self._values["namespace_id"] = namespace_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tlsenabled is not None:
            self._values["tlsenabled"] = tlsenabled
        if uuid is not None:
            self._values["uuid"] = uuid
        if wsenabled is not None:
            self._values["wsenabled"] = wsenabled

    @builtins.property
    def anonymous(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        '''
        result = self._values.get("anonymous")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables IoT Edge Connect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def gwenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured HTTP connection on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        '''
        result = self._values.get("gwenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the globally reserved name for a specific configuration.

        It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration.  You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        '''
        result = self._values.get("namespace_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tlsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured MQTT connection on port 8883.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        '''
        result = self._values.get("tlsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def wsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        result = self._values.get("wsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "hash_conversion_algorithm": "hashConversionAlgorithm",
        "hash_conversion_key": "hashConversionKey",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation:
    def __init__(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48e3cd1832dc4a322fc2e6db4719cc3f7a8c12692f8b12889fe5eb7529c8321)
            check_type(argname="argument hash_conversion_algorithm", value=hash_conversion_algorithm, expected_type=type_hints["hash_conversion_algorithm"])
            check_type(argname="argument hash_conversion_key", value=hash_conversion_key, expected_type=type_hints["hash_conversion_key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hash_conversion_algorithm is not None:
            self._values["hash_conversion_algorithm"] = hash_conversion_algorithm
        if hash_conversion_key is not None:
            self._values["hash_conversion_key"] = hash_conversion_key
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def hash_conversion_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        '''
        result = self._values.get("hash_conversion_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_conversion_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the key to generate the hash, ideally a long random string to ensure adequate security.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        '''
        result = self._values.get("hash_conversion_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c37c107a436e19f9ca8f17e80ab9e65a00a21e88cade3fcf6b5b9a8dbeb087f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHashConversionAlgorithm")
    def reset_hash_conversion_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionAlgorithm", []))

    @jsii.member(jsii_name="resetHashConversionKey")
    def reset_hash_conversion_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithmInput")
    def hash_conversion_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionKeyInput")
    def hash_conversion_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithm")
    def hash_conversion_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionAlgorithm"))

    @hash_conversion_algorithm.setter
    def hash_conversion_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e313a9b2011dada4fa0df2a85172bf827192a482148987e13d411cffd61243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hashConversionKey")
    def hash_conversion_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionKey"))

    @hash_conversion_key.setter
    def hash_conversion_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033d3c0221ca14bd44ad50281bb0e36b23cc1af928540bc821fd375cceb54923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionKey", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c618d390bd24e32450a58739873d131585bc11a86e31d55847b64eb2e1a68bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7193ddbba4c03dbf1c1e2ee5fe4e0fb0c335396daac37d5b52c4ce6e435c16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2b2b4b63ec0aae31a775ba454d82837d4a1d0ed5621880e378188aabbb68b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7a6b06e4499e67a3f983cf70a7d92685931343894be3a105d0e3601018b766e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9b66bc2b3d4532090cfcb6245ed01ea411dfce371aef65994866a34cb4c06c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with a single grouping to capture the text.

        For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69a90817bca628510d083162971db15314db9703a55ef3463596229f21cf0a1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bbaf23de5a5aa3d98b2a9b1b885de73486f761073a4d2ef58f1a2e3723bd6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8578290e70da8f5f16a85a2602cf9af244fc26e02693099689cb77350defa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75f7c49e0b8506b7feeec031a626f766e6118ff2cf94ce06f61a8e0edfc55a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc555ef67b0aee8d7608a3335c605222fe22c34e1ac6ba99f4ba5094b47c9e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb6d7ec842efae2a2fd2767d9803cb51ebc5a609db0df793f8b74c3280a758f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "substring_end": "substringEnd",
        "substring_start": "substringStart",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7d1302c0ebc6f5c0aea7d886236a9052ed9f3f8ad9a7c42d14e3ec608ab9f46)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument substring_end", value=substring_end, expected_type=type_hints["substring_end"])
            check_type(argname="argument substring_start", value=substring_start, expected_type=type_hints["substring_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if substring_end is not None:
            self._values["substring_end"] = substring_end
        if substring_start is not None:
            self._values["substring_start"] = substring_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def substring_end(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        '''
        result = self._values.get("substring_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def substring_start(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the first character to extract.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        '''
        result = self._values.get("substring_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc43d6a4ab9c06f80c2a55c2e3885006b567c9d42c611f58873d31f239038b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSubstringEnd")
    def reset_substring_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringEnd", []))

    @jsii.member(jsii_name="resetSubstringStart")
    def reset_substring_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="substringEndInput")
    def substring_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringEndInput"))

    @builtins.property
    @jsii.member(jsii_name="substringStartInput")
    def substring_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cca3b9c153ecc0de0a6c843c2147d8bf9c06064c1103933445e64aa45a7e1bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="substringEnd")
    def substring_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringEnd"))

    @substring_end.setter
    def substring_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79b7086f20ca98d6b2301f3881e21d363a4fa4ff692cf8b7ef68156c9368952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringEnd", value)

    @builtins.property
    @jsii.member(jsii_name="substringStart")
    def substring_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringStart"))

    @substring_start.setter
    def substring_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74815e467e1c866076f2257509034444159eb3e37bb62055b01f31ff65bfd533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__369491ee3256886f3e7796f3e54dbc71d8833e39df35e98500424f52764247e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649548c6728d50594efd3e760f2ccc7e5df81c6c7482fdcb972c9c2a9cc2dedb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd7ca1aa7a570b198a9657ac214c5322791c034c07e614241f3e431f9e46a5e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_field": "certificateField",
        "dcp_mutual_auth_processing_variable_id": "dcpMutualAuthProcessingVariableId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor:
    def __init__(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9ab412a29dd27081f8e86b6e1cf88569a579481f66f4cacbc6fdf0bc8d85d1)
            check_type(argname="argument certificate_field", value=certificate_field, expected_type=type_hints["certificate_field"])
            check_type(argname="argument dcp_mutual_auth_processing_variable_id", value=dcp_mutual_auth_processing_variable_id, expected_type=type_hints["dcp_mutual_auth_processing_variable_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_field is not None:
            self._values["certificate_field"] = certificate_field
        if dcp_mutual_auth_processing_variable_id is not None:
            self._values["dcp_mutual_auth_processing_variable_id"] = dcp_mutual_auth_processing_variable_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_field(self) -> typing.Optional[builtins.str]:
        '''Specifies the field in the client certificate to extract the variable from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        '''
        result = self._values.get("certificate_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dcp_mutual_auth_processing_variable_id(self) -> typing.Optional[builtins.str]:
        '''Where to store the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        '''
        result = self._values.get("dcp_mutual_auth_processing_variable_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89b12a63fd1b6b09675edc81880d5b56048bf82f2e9c9b7eb55f0f170fbabe1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateField")
    def reset_certificate_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateField", []))

    @jsii.member(jsii_name="resetDcpMutualAuthProcessingVariableId")
    def reset_dcp_mutual_auth_processing_variable_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpMutualAuthProcessingVariableId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldInput")
    def certificate_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableIdInput")
    def dcp_mutual_auth_processing_variable_id_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dcpMutualAuthProcessingVariableIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateField")
    def certificate_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateField"))

    @certificate_field.setter
    def certificate_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c4fa12cb4665f5e021a9a921ae801d8daa30f092d92086c54b1c47c71acbdf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateField", value)

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableId")
    def dcp_mutual_auth_processing_variable_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dcpMutualAuthProcessingVariableId"))

    @dcp_mutual_auth_processing_variable_id.setter
    def dcp_mutual_auth_processing_variable_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6f7116ab5c0d366e16431c700ff26c7fea445344ffbf73975c49c080638421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dcpMutualAuthProcessingVariableId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d506668f3b7c96262629587659fb5d20a35ed702b8543b2478ec110ef3aee3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ff83b790437919c0f1a6957777925982a5ef52d4ee5fa2ace3efd20f3da8c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad18ea09eb2b0ef4adc62a626346f3d6c9613f47d247af25e453d2effb1e725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdbce220555cfe79cdb89475aad8733fd279b8fdf4c1e0b38f21933217556e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups",
    jsii_struct_bases=[],
    name_mapping={
        "group_names": "groupNames",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups:
    def __init__(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8271445c670fb144ab96b869eddc711a2756e361d3603627000e35a28fa1d403)
            check_type(argname="argument group_names", value=group_names, expected_type=type_hints["group_names"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if group_names is not None:
            self._values["group_names"] = group_names
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def group_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of authorization groups to assign to all connecting devices.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        '''
        result = self._values.get("group_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8014f840ee97e3fb603d6900e682672ebec15dda72b800cb320136cc35a477)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetGroupNames")
    def reset_group_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGroupNames", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="groupNamesInput")
    def group_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "groupNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="groupNames")
    def group_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "groupNames"))

    @group_names.setter
    def group_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa290273c975964892dfcdf6507c840d12d762ae35393be90e253229f2611a0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "groupNames", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e22f313dc35044c00e9a5e6405c4297b5f4ae87a103b1e5c87c7ffe9a986d92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a819304187066f4a5e71c0980d6b9e8b3f2e432ce41c20ba2d6abef04f0814bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fa406afbe7dca5f8817d4aaf1960ed215cb5ec9a4ec61abd1a8f16dd5a9383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c625614448b65402c6066a5144089ad825477b82902144a89d1212881f985a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations",
    jsii_struct_bases=[],
    name_mapping={
        "custom_values": "customValues",
        "enabled": "enabled",
        "hostname": "hostname",
        "locked": "locked",
        "path": "path",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations:
    def __init__(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7df63500c80993a915b7bd9e5bd88679d88a6871914a922054dfb079ca8e47)
            check_type(argname="argument custom_values", value=custom_values, expected_type=type_hints["custom_values"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_values is not None:
            self._values["custom_values"] = custom_values
        if enabled is not None:
            self._values["enabled"] = enabled
        if hostname is not None:
            self._values["hostname"] = hostname
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_values(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify custom JWT server connection values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        '''
        result = self._values.get("custom_values")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the default JWT server and sets the authentication endpoint to a default path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the JWT server's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d45cd0f426cc647ed19eab6efe284bd15159d1217d30ba174d80a6a0da09d9bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomValues")
    def reset_custom_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValues", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customValuesInput")
    def custom_values_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customValues")
    def custom_values(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customValues"))

    @custom_values.setter
    def custom_values(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6e93ae81cf9e335d0a44b72911da9b7d1851cbc29d913e4611377c59c7fb07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValues", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad2a8a7c518554509317afbdfbd53917951db3620b9083d9b219b46dd1ac92b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4fe4a90eba8cc274d49862e1c1569b8a4558d9a39f617b703ffdecab0cee2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5563e69abeea7efaf848db12b05b1ccb1710e3b928e2ae1d879afa82acf21438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5161969eb557c542f403c2cbd0e54ed3a47fda4cbdd64a5251f35b03ad1d9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4b5f5b5b49a9ed5747da2e4cfcd1521584f25cba275ceacbd8ed5cd6bd0dc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4bda23465b59794be5c3e43e534dc77333e8052b4d440549d357e86b2008888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a16ce273c5e2d0472b9bbc4a5c9d4df46a5752fa0b3fb18191ff3e75d26894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06cc13809f4ce64a79c335d1a3bd660e166c1fa25e4eab626cad6e23a2653b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymous")
    def reset_anonymous(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymous", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGwenabled")
    def reset_gwenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGwenabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceId")
    def reset_namespace_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTlsenabled")
    def reset_tlsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsenabled", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWsenabled")
    def reset_wsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWsenabled", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousInput")
    def anonymous_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "anonymousInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="gwenabledInput")
    def gwenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "gwenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceIdInput")
    def namespace_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsenabledInput")
    def tlsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tlsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="wsenabledInput")
    def wsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "wsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymous")
    def anonymous(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "anonymous"))

    @anonymous.setter
    def anonymous(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9006866474b06b60eed1b0ba69f9e0e3647369808e87aea68f60f6d24eb0888b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymous", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__442301f98e36911e18be3230cc89600bd799d0e969bd48e04466179de8ecf013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="gwenabled")
    def gwenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "gwenabled"))

    @gwenabled.setter
    def gwenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb34bbe81e3d4053f6d27a11fa1eaf7ab3a90da2f01c1dbb31f6c534e70282b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gwenabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46c48e9c880563c61a4fa1cdf25941981ec19397336a76b3a3b4693f461502f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceId")
    def namespace_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceId"))

    @namespace_id.setter
    def namespace_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3684bd77640d1fa1d3dffa3cdae3771e2cdb5f6c78e4f62551385a5e9d08f25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a1f9d9a0db77b2cd77a0e953dc91c6abdb34b33bc17f66fb4b11a053c140a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tlsenabled")
    def tlsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tlsenabled"))

    @tlsenabled.setter
    def tlsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a81b5417c9652dc91155735d5cde097567086b347400cf9f08d20664383c4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05af0f9c9bbec2e2df8388a547c389d18456224b625c97eee5a2c2e47cd79bc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="wsenabled")
    def wsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "wsenabled"))

    @wsenabled.setter
    def wsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__642e5d2750a41b52d0a941b4423264cdb6d9fad09dbdf0b9a1432fb935c92d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada50520088b8320fe7cd3db4361270357f3b315168b764c2ee6964a57a26381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth",
    jsii_struct_bases=[],
    name_mapping={
        "extract_hostname": "extractHostname",
        "extract_jurisdiction": "extractJurisdiction",
        "extract_namespace": "extractNamespace",
        "hostname_claim": "hostnameClaim",
        "jurisdiction_claim": "jurisdictionClaim",
        "locked": "locked",
        "namespace_claim": "namespaceClaim",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth:
    def __init__(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d7a5a1fabce30005f1ed93346dcf83fccf44b7d666af13451861d1de81180d)
            check_type(argname="argument extract_hostname", value=extract_hostname, expected_type=type_hints["extract_hostname"])
            check_type(argname="argument extract_jurisdiction", value=extract_jurisdiction, expected_type=type_hints["extract_jurisdiction"])
            check_type(argname="argument extract_namespace", value=extract_namespace, expected_type=type_hints["extract_namespace"])
            check_type(argname="argument hostname_claim", value=hostname_claim, expected_type=type_hints["hostname_claim"])
            check_type(argname="argument jurisdiction_claim", value=jurisdiction_claim, expected_type=type_hints["jurisdiction_claim"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_claim", value=namespace_claim, expected_type=type_hints["namespace_claim"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if extract_hostname is not None:
            self._values["extract_hostname"] = extract_hostname
        if extract_jurisdiction is not None:
            self._values["extract_jurisdiction"] = extract_jurisdiction
        if extract_namespace is not None:
            self._values["extract_namespace"] = extract_namespace
        if hostname_claim is not None:
            self._values["hostname_claim"] = hostname_claim
        if jurisdiction_claim is not None:
            self._values["jurisdiction_claim"] = jurisdiction_claim
        if locked is not None:
            self._values["locked"] = locked
        if namespace_claim is not None:
            self._values["namespace_claim"] = namespace_claim
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def extract_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a hostname from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        '''
        result = self._values.get("extract_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_jurisdiction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a jurisdiction that defines a geographically distributed set of servers from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        '''
        result = self._values.get("extract_jurisdiction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_namespace(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a namespace from JSON web tokens (JWT).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        '''
        result = self._values.get("extract_namespace")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the hostname from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        '''
        result = self._values.get("hostname_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jurisdiction_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the jurisdiction from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        '''
        result = self._values.get("jurisdiction_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the namespace from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        '''
        result = self._values.get("namespace_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c07ecf8da3a8066659a8dd6760386d31ed1526a20e4750f95ff5869c47320b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExtractHostname")
    def reset_extract_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractHostname", []))

    @jsii.member(jsii_name="resetExtractJurisdiction")
    def reset_extract_jurisdiction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractJurisdiction", []))

    @jsii.member(jsii_name="resetExtractNamespace")
    def reset_extract_namespace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractNamespace", []))

    @jsii.member(jsii_name="resetHostnameClaim")
    def reset_hostname_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameClaim", []))

    @jsii.member(jsii_name="resetJurisdictionClaim")
    def reset_jurisdiction_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJurisdictionClaim", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceClaim")
    def reset_namespace_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceClaim", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="extractHostnameInput")
    def extract_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="extractJurisdictionInput")
    def extract_jurisdiction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractJurisdictionInput"))

    @builtins.property
    @jsii.member(jsii_name="extractNamespaceInput")
    def extract_namespace_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractNamespaceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameClaimInput")
    def hostname_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaimInput")
    def jurisdiction_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jurisdictionClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceClaimInput")
    def namespace_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="extractHostname")
    def extract_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractHostname"))

    @extract_hostname.setter
    def extract_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970bc65ef9bc2b615721aee5d0597c4b904788945a24774c2ca8c6fdaf210377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractHostname", value)

    @builtins.property
    @jsii.member(jsii_name="extractJurisdiction")
    def extract_jurisdiction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractJurisdiction"))

    @extract_jurisdiction.setter
    def extract_jurisdiction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff4da5f3da3fa944404164e9420414cdc1a4e85e436f88349ab392085f55f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractJurisdiction", value)

    @builtins.property
    @jsii.member(jsii_name="extractNamespace")
    def extract_namespace(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractNamespace"))

    @extract_namespace.setter
    def extract_namespace(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bbe3a0abd911d03c2c3d34b6ff165c5b283df0446b9f83e03f4bdcf098e01cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractNamespace", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameClaim")
    def hostname_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostnameClaim"))

    @hostname_claim.setter
    def hostname_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd507e1409f601413ef692bd8ced31753e4ff18204f4c169a5ae44e9f81aed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameClaim", value)

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaim")
    def jurisdiction_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jurisdictionClaim"))

    @jurisdiction_claim.setter
    def jurisdiction_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293026829f49589ce5c251e5c10d3ba0c2e2d3ee026a3391c6199c27d262b95b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jurisdictionClaim", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6150383e5b109185f63f0f08974ad7eca48b244d979c334177ed84758cf38a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceClaim")
    def namespace_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceClaim"))

    @namespace_claim.setter
    def namespace_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83dd213d021a922e5ac20fb5761264c7a46b09b5d3622d87e8403dcd138163c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceClaim", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa268a6d2a548648041c6ae6203ff9aa065f7a02e3db7749124c71271af007e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__028b930bd0b0f9b92f207a6c9cdda020642bbe2925b6dbc2a735255d859ee94c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410ae3667fbf9b7bbc6056a33ca7fb5e0b1b7040c1b313926853068fe1816a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776252d3b635ba4f2c136d4531629ffdf6b7c68bed6cc4cf63120a638fa361c4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceiptOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceiptOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410025654ceb6af239ab319412028b4c2f8eaac4a9140854d28b11e669e14d8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2520942a67c58d8890bd0441f9d8338bc4cf1c5826dd4a06a40cbf49d41d90bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__415a64f32ae39283203433977876189a55b891aafcbb41df0bc237385320e735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2d3eba7bc7081efe7f20c4ec89b0823bb2634fa822b0b111a9ed2b8bd4bfde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fbc943f4d00b209b2311f51a0059607f02fa4e82f2f68ed2611649e17fa9997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6dbd3ff7ceb35bdbd333219d0956fd7e553df984ec1e6a6332d7fbd5dcd1e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "reason": "reason",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef8dbe0b5c7d473a4228fe1ab79cc4106db4c837d412b298a171a9cf9b81ad4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reason", value=reason, expected_type=type_hints["reason"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if reason is not None:
            self._values["reason"] = reason
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies access when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reason(self) -> typing.Optional[builtins.str]:
        '''Text message that keys why access is denied.

        Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        '''
        result = self._values.get("reason")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebbf21a04069a0a53c1a3e1147f22dcf75b8f3fbea079937158e268ddb0d6232)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReason")
    def reset_reason(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReason", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reasonInput")
    def reason_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reasonInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd4cf450dad32870a5b861d3b31ad5fd1b17fbe06c5d03473b440eee13d2a32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82848acf2822fd0f0fa9279cf3d372538b38501ac2e73f38c4f345a84de63dd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reason")
    def reason(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reason"))

    @reason.setter
    def reason(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f9370aa4e572484a28a52ea94099109f9bd921ae07e2be25d22f6e35f33659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reason", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea931b9cf0a7ee55eed5fc6048f1be466ebec646e77b65ec3251f730c9c35fb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a49a5d1d7d42d4eb35f1a56eab73c5797883a04efe94f23ac44ffcf621cf08e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7704841b1d984f114f7f104600191740c5fbe0a3bd08977d9d3c10e2edc2d4d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f77845fbb23dae2fd59979db06548281f8f1c2a97c265f084ba81d3dcfffb9e7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a30fa683bbaca75c1b73ee2adbad6b63c5438b782fefefcfc96ce141c28634)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138be3c20dd3280237f854246ac1e0283e7ae8cab5ccba2cabceb0f3cfcd4f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3166b8c4560bac669264043ea7fe42462285c58d8b28b3598b1d6d5314adc16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e6ed07e6ef7fd2c2ef4d5f694009a4253748aa7537e934db89cbf921c4b114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9124904eaf70c2f0b2be5048a6535fc50b02fc35b07056aba56078aba9783fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c4bfa00c24bc1a980b5e220551798b3944c1daf2c5ef3c993a2024155ca02a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311b454d0fb9a70663e8bba0115b274222dacebb572f756bd73a6a82e6301163)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of information about the device with which to generate a separate cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0243e71377615fda437f0578cfcd17bd0966dfaa6909e9501dc9e012b2c27c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd59756caa35f235ad39a706db9508c87cc70fcbcfc1ef813e6453a1b74541f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dad59541b72ae7314650809d5067416796ba96af98af0e78738df4d76f584da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1697d52d1c1d1a46e07583f5eeb37f92322c0739e4f2284a949acc60d90a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559145da4afef32146c923b6b66e44b11cd02ed1b52786a66bc34a59bf5e8508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e158238195f7f5260bb3b11e99dbdef7e9a4d45399c11444fb08d05a23bfbd24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__185b57003880c7969494c480b95971995582da047d9e1e6fc65dd025b44ec26c)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of information about the requesting device to send to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409c8f1e6f189a465d6f7478e20f087aca1c10ebf305f135307051e52b7faf35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393f5327a994021dd8ef9fc58c9e804f65846470734d66ef4523887fac29942c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd3e510fe55de32caf261cbf6507fc8511dcd56e74f51764081e0fe5f1ac8df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87715fb727675ca3f1651d8edc45710f288266edcc2ccca21551d12a6caa41e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10244b61ae39a288e0025e085562d512ec8ddecb3c4e4ed3d565a44f06d80724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da29c8bfd3a689f1e29fbd2b579a2c49afd884c54e2e3eaeb8187efe275e442b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949aeff43c5ee4f455207fa6ca8ad78778e2e503064cc8c60166623543747642)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh an expired DNS record after serving content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Set the maximum allowed time an expired DNS record may be active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da2d502502f68823348e30a8a9489fab7db888c5cd5647609533dddf8778ff8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b721a18d2427df3329a7d69e700c90c50da0cc00fead50be875ee467c138e83c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea40f71b0d07da2eef7abd43ca95bd65a288603ce1010df0f2ce257cec34e44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd3ff7ec51ea6e2d83c870dc437f96349554eb19876d4c863cc62d36d5408742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb1a80e8a49684ed2ba59c6a9143741ca021a55a9b71bac61e2cebbf34cee498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb7e5a3bfb8473ddc472d092bf4df529f2a68c006c3c56db35f5d2dcd871916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef452866750fa0b92c04943d133938ba6f136d484e21563d2a4e9e0ad02f84f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh",
    jsii_struct_bases=[],
    name_mapping={
        "delay": "delay",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh:
    def __init__(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e8c77a957e7e2fbeb26b60c369a26b18f20c7010471c179a17f9f81d23022e8)
            check_type(argname="argument delay", value=delay, expected_type=type_hints["delay"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if delay is not None:
            self._values["delay"] = delay
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def delay(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        '''
        result = self._values.get("delay")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh DNS records before they expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c076b845593fce1d291190d0e985100bd0b696cdec829aaa490d40c7b7cdb63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDelay")
    def reset_delay(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDelay", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="delayInput")
    def delay_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "delayInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="delay")
    def delay(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "delay"))

    @delay.setter
    def delay(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16f777f285a3a2a505897a2b0f06fcefdd4d18f6c8ae28ada832b9521d8fb35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "delay", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89cf88382e4bb3c7496d82f49b0062a6bf8b6bed48df286bdaf0fde91eb9201f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2703e887a8296c00cb321979dc09b03c726c130e0aa6c90c1800758a3455bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc2f6e8845c906ee27b9a075aa66c88d21dfe7113720baedb24f77dd71f7b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cd4a177c4d78e79fd892825de96fed1bf9336c1880b28b7898ea19c9fd4627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ade43d45e8590cdd9f6384de8f1ed8118c20ff8bf6bab06ea0d1dcea4240148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ac20f0d1ebfbb2a9ef40be47f05bccbe13c9372e2c61b60416fba64d99b2ba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1544e5caf17322e8dcb20a5c7d4a014dd54d6ac5f0a6d22eeec84e887fb64b2c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the protocol downgrading behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d14da358690fb5134072c1a397646f38de6c32a8c0a744c3781ce22ce4c403a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6198d9a28b13aea21855129955d3b3e4a07a73ac3fdc6e5c1be97010b7ed77e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a378c7891af5b825c4cf23a1d57c0b6d7b286a45564268b1eebbab273f4fd4d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4211abff5b5a59ede053359d33d75544bebc5891fef851d40117a980cef38134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2acf5a8f11b4d63bf4a16b99e599a78045458b833724435246bc092b9d08d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0cdf795a43fe14444d2570a60caa0decedac7f85be3ed493943200331ee32a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8392d50c4e488fedef7cc6548ebd36ce54f849cd0f42c740f7c64063e86ea65)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2587d5c2d34d1e02e0f23d59d37064ca47d964888bf7f88c8578de5167310fb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcef75b82379fb32c8801c3efd572c24ba598ef772b5eaf47e71192290cefc63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1ad8901f2f893b7d7d2fbaebecb17429432e475df2bc23997ce2bd2a5f0f7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a024864f42832ccf973be71bf6102cb8dcc22073609dfd4338e9ea6f061a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c9871a55d415bd05470ee609ddb78b342aaf13bf1e7ff897ee2257a35019d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce2fd5e64980698df21c80f0f7e9d30ac2f3ce050107c2292a6932b52affc8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23895fc9b0424196ec40de5bb75fe4ff0eddf497b037bf11fc6eaa69d59b072a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotificationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotificationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b50fee2900097fa7bbdd4c6fc9bb9acb439f33d07c94eb404bd4f9432d0fe4df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577e849b39f1d51d08bca25c4c4eb85bd9a4554832739e873a6fe1f2d46ca899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd90e9d9e1af20aa53199f973cc765f313f3778440245aee428ccaba7aaf1e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11cd7f02d7bed13c5668d8c65042f9a8dea2fd058fc54cd37c39e7ad6e0b6d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73beecf012a5b8fef173d3343974ab6fdbdf203b682bb1e75c6e41283f07a4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__434f684a8fc8e4adc03a7ce934c1b257db32ae0af57ca4a4e07407ffa288991f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache",
    jsii_struct_bases=[],
    name_mapping={
        "allow_behavior": "allowBehavior",
        "behavior": "behavior",
        "locked": "locked",
        "send_headers": "sendHeaders",
        "send_private": "sendPrivate",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache:
    def __init__(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70279619a1f82adbb7cdd7b4bd4ab1d0659e10029ee0d720a92a4cf195d770a4)
            check_type(argname="argument allow_behavior", value=allow_behavior, expected_type=type_hints["allow_behavior"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument send_headers", value=send_headers, expected_type=type_hints["send_headers"])
            check_type(argname="argument send_private", value=send_private, expected_type=type_hints["send_private"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_behavior is not None:
            self._values["allow_behavior"] = allow_behavior
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if send_headers is not None:
            self._values["send_headers"] = send_headers
        if send_private is not None:
            self._values["send_private"] = send_private
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_behavior(self) -> typing.Optional[builtins.str]:
        '''Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        '''
        result = self._values.get("allow_behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching instructions the edge server sends to the end user's client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def send_headers(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP headers to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        '''
        result = self._values.get("send_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def send_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        '''
        result = self._values.get("send_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfceef6492d0784f5ce0e2c8a1211c9e129ca1b317ae75abb3bc78d2c2520606)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBehavior")
    def reset_allow_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBehavior", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSendHeaders")
    def reset_send_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendHeaders", []))

    @jsii.member(jsii_name="resetSendPrivate")
    def reset_send_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendPrivate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBehaviorInput")
    def allow_behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sendHeadersInput")
    def send_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sendHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="sendPrivateInput")
    def send_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sendPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBehavior")
    def allow_behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowBehavior"))

    @allow_behavior.setter
    def allow_behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe89c77bfaf019231281c0d6f5513e3df71661b7b121e61b5e8f3ea6c6d13f8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBehavior", value)

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c660005c8ca2f28037672ce7384661d7876b5d0c1da6e3511c66e592698cd823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcba37031e26973e4f3a8788274a97f65e5eb6549ed0888d56eb6a7b9b69d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sendHeaders")
    def send_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sendHeaders"))

    @send_headers.setter
    def send_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e7b3c8699f0033ba4d85c2f75d8435c734a74492bb99c68b293ba509f1efada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="sendPrivate")
    def send_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sendPrivate"))

    @send_private.setter
    def send_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002554a1642e9c6de1f8aab2d3b68ae6a0483304f9b5831631d7351413af0113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75bb90b55ecdbecd578819df3fe530e5f203c18329b40ea7c361b4b5642fc2bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90c577c30a9e5384314eaff329d675ff71ffa9c5cdc3e839fa4daec21cfddc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1d4fcf3ac8126ec5364d1bfd74557507fde7697a91b36318d19c8d3b1516c6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d75cdaae9c3f053bd3ffed1c3299e833af3092dad1455a4dcbbebe994ff460a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cfd526848dbec4efb6da5b555ab4d8cc5b2389a56ce8a1ea7eff550fdaf1db4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the quick retry feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49c284a17209a1f6f8ce0bf2c9c313f5593423019aaf3f9c953a7187b68a605b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6080600224447dda4c4d92d9bae195139aa019305553acc2cd565f01e89d5359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c30d586af34163bd55fdb51a54096764ac3adf966bd809ba556130edfc0dd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dd3ec5ff81310ced81700db571e4e4d6a4570cfb57d0c94df08cad3c918a133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac394bd3b9cb6f00c7200da44b5d2bbb2549eb9682c416c53c8858d40e8f451f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554d6f94d2726fe0f48ed705bd73bcc497ada902f09536e44f3a089853cd7000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "throughput": "throughput",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f6e653373e46f23711dd058bdcffb5f968a98e8744f51ca8bc748e9a23e5c9)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throughput", value=throughput, expected_type=type_hints["throughput"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throughput is not None:
            self._values["throughput"] = throughput
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throughput(self) -> typing.Optional[builtins.str]:
        '''Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps.

        If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        '''
        result = self._values.get("throughput")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94dc2f50d51a74c13db8b8862355dc3bdfca6d3ce4225dc65a383e436eefba99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThroughput")
    def reset_throughput(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThroughput", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throughputInput")
    def throughput_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "throughputInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f479d79828a5826116fcbec06a246a68336fb8ddba213bbe8bc58ad920f978d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377223cccb625bbd403396895ee2588582504be501b8e9fc6a9771822d644ea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throughput")
    def throughput(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "throughput"))

    @throughput.setter
    def throughput(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089269fa9c16d03ba43d8fb6646c5b4ec69f009e9c28574be5cb164d276f152e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throughput", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af843e5dbec430d23a1cc21a61fba17430ca36f58936635ab255a2ca753a036f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d0b93e00cd2a14e74c7f4f5c91c8064e56a808d9647ddcf10b058c780918e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent",
    jsii_struct_bases=[],
    name_mapping={
        "image_compression": "imageCompression",
        "locked": "locked",
        "prefetch": "prefetch",
        "real_user_monitoring": "realUserMonitoring",
        "sure_route": "sureRoute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent:
    def __init__(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee21b89f6451c4dbbfd8616d96c8a763ce0a0284b8561aa37f56bf7cd2477f3)
            check_type(argname="argument image_compression", value=image_compression, expected_type=type_hints["image_compression"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if image_compression is not None:
            self._values["image_compression"] = image_compression
        if locked is not None:
            self._values["locked"] = locked
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def image_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables image compression for subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        '''
        result = self._values.get("image_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows subcustomer content to prefetch over HTTP/2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes how subcustomer traffic routes from origin to edge servers.  See the ``sureRoute`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ea34ed0c204dfecf9085e0d3484277ea8055b17a45b146c8dbc3b194c385ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetImageCompression")
    def reset_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageCompression", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="imageCompressionInput")
    def image_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "imageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="imageCompression")
    def image_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "imageCompression"))

    @image_compression.setter
    def image_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0042982c5078fcc0348bd1b44e09c9951e814e3eeb3fdfba6451bfc32ff972b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageCompression", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1978c40149fc3550f396e7b55f8e3c7a86e7154aab5371b0a12b9eaad13546)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetch"))

    @prefetch.setter
    def prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7479ea30489856c33bd6aa3566d16e411b8c2857ee291a0f06e0beea8a142027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetch", value)

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "realUserMonitoring"))

    @real_user_monitoring.setter
    def real_user_monitoring(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc880785a06f2ab887d7f1293d74d21d852965357a27e7b17443908b5e23363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "realUserMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sureRoute"))

    @sure_route.setter
    def sure_route(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1848f014220f7f32105305c27b0484dc0b296bf3057a2e022219a7741f79973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sureRoute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae276a331d8a705c609f6b0ebdc1e11e9bca22744df5a17b3c845dcc79865cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85b65ac546cf2c3ca87727097184c3e482403cca7b1be1416b1d8fce4a5a434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3e93186a7417cd5e27c97f00b636325c37592bc230686e1478bb12840e373f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d2a32595950dd4636720f1d5738ed8b2aa974f699c2c65fd5feef7357b266e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables sending a compressed archive file with objects.

        Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUploadOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUploadOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba9c60a52fdbff556ea41fb8d082052a3ed5d1cc94691548121983c8b743c9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e181b03f26e7a68543f26429a253c076556a5ba5afb0368f2e02d77fe30ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b654469659737217e5ddf7e3f52dbe07b070ffb92c0b33ed801d5f0ba8c24495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee84287aae2788669d21a6069cfc407f99cd2ab26fd601286cb4b48a29f22fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe19833af30f3a5225ad9a7b9f35ef5d5926353acc7461b3876fa7f62c79ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744d09e8821b4ccb4169dbdc83f49bb662065a13dc62a576caafcec3f24cdff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase",
    jsii_struct_bases=[],
    name_mapping={
        "database": "database",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase:
    def __init__(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7a2279dba636da765c559bb092b226111c0c34954aa0c60b79006b5581aed9)
            check_type(argname="argument database", value=database, expected_type=type_hints["database"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if database is not None:
            self._values["database"] = database
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def database(self) -> typing.Optional[builtins.str]:
        '''Specifies a default database for this property.

        If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        '''
        result = self._values.get("database")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a database name in requests.

        If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the database name. By default, it points to ``database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the database name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce0003c92f75c2d58747e8d129d5f72e2d425084c3cecf294f3930ca83c8e4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDatabase")
    def reset_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatabase", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="databaseInput")
    def database_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "databaseInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="database")
    def database(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "database"))

    @database.setter
    def database(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703cba26929cc727c2e314f89ec0ce1605f27ec147c33261b717fec0722ccd7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "database", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f8df8ef20f5a72a15a6e2861c99440891e49eb8c5fce82be8d0191991c03148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30a0fa609dec65eb96fe060b4dfa8ae2668f9a3a12bf9f58f848156c7a15b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e80024f0a2afd7c3e7bf7f46f0ec258cdc0616e2261888d9ec4a334cceaea3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2adb7fdeb1b2c5ecef3ebfc044d9d07177bf260f52d2294506279491aa55d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cafa9ada783216c98ee8d7d738bb8c6775238917a494e3dd1fbf0ce71f33d3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d39c9fb6f2452726880f34fa3428d3f038aa0fead0b6bc6b24afadab8d8700)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a4c895b032ac9b7dfee911c510d109de51916f0ca0c455f170793e9294c2883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b016bd65188659eb343053d5f4ad00bd437d47755279c04c5233e50697f8cc7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset",
    jsii_struct_bases=[],
    name_mapping={
        "dataset": "dataset",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset:
    def __init__(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4056e8eb9b0fcbb46fee0b66470787a91d63b9c0d6b962bfc7a753dcca69df)
            check_type(argname="argument dataset", value=dataset, expected_type=type_hints["dataset"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dataset is not None:
            self._values["dataset"] = dataset
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def dataset(self) -> typing.Optional[builtins.str]:
        '''Specifies a default data set for this property.

        If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        '''
        result = self._values.get("dataset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a data set name in requests.

        If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the data set name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatasetOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatasetOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a42228e0d70acbb5f7c218e1a8dc632556bd7f4b1006e15b851a0df6029943cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDataset")
    def reset_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataset", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="datasetInput")
    def dataset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datasetInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="dataset")
    def dataset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataset"))

    @dataset.setter
    def dataset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987b0a792d23cf0f3da7e4569dd0b949564d8c6d4db566648bc15760dd24fc76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataset", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce4c191669d1fd7d724556b6868921537c785195e105619c4c9e951b4707f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6768fc0a407b322563615fdf21159f7fe3b4134ee269d000084ddb465ee953c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85b5d86f797feb1c0a73a1fe09ac871733b2a9a4401fd4a92c72117067d228c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29b32a72b353df5dc2c5788bde4d23486769dffb8b98edcb45cf18e8ce048c0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e908fc2dd5d1a81cdd09ec2f431b8fdd2b256fbbf5a4b8b4d509c61f5d65bae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661485c66f4a044fb8ebac94e6b963243f8cdf9e3a03ea7522bdf72f17fabc7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a617074be7bc03347efd3022f96e5fe3d4a0a1d5acce0ac11e1b7d11066cb61a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d46c8bbd604db53aaa1ef0c48d01ce7d0a9affe9c97d2480a42c4b1313b8976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e6f4997ce231d6bcbdfab25da56d1a47e0f9207c3a43a90ffba59caf37ef13)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc3153b8d664b3d99b7884b4a7a8243657c54986835f68c49037f23fabcee0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f64ccb61019f65885e520888d5ea7a78bfdd4ea52e09b827e8486525a0e7979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e3f557e7c8a4f0201a5457b18423fef44aa66b01eea378cd61421d8ce2d357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd087bafc611b63c6684b40a653aa73fbff3e2243e8926b50a751eb5a5ee8a51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9fc9726606e5e5711029231beb01839f4c0e07a7b49ba08087af5c4c785e665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6629e390e5c6d081a2fd3c6f95b817a56ab425bdc56e792636c9738642411a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect",
    jsii_struct_bases=[],
    name_mapping={
        "aggregate_lines": "aggregateLines",
        "aggregate_size": "aggregateSize",
        "aggregate_time": "aggregateTime",
        "api_connector": "apiConnector",
        "api_data_elements": "apiDataElements",
        "destination_hostname": "destinationHostname",
        "destination_path": "destinationPath",
        "enabled": "enabled",
        "locked": "locked",
        "override_aggregate_settings": "overrideAggregateSettings",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect:
    def __init__(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5918165c10164352334b7d0a8f3708bb69a74387a949116eb599ab4b094adabf)
            check_type(argname="argument aggregate_lines", value=aggregate_lines, expected_type=type_hints["aggregate_lines"])
            check_type(argname="argument aggregate_size", value=aggregate_size, expected_type=type_hints["aggregate_size"])
            check_type(argname="argument aggregate_time", value=aggregate_time, expected_type=type_hints["aggregate_time"])
            check_type(argname="argument api_connector", value=api_connector, expected_type=type_hints["api_connector"])
            check_type(argname="argument api_data_elements", value=api_data_elements, expected_type=type_hints["api_data_elements"])
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_aggregate_settings", value=override_aggregate_settings, expected_type=type_hints["override_aggregate_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aggregate_lines is not None:
            self._values["aggregate_lines"] = aggregate_lines
        if aggregate_size is not None:
            self._values["aggregate_size"] = aggregate_size
        if aggregate_time is not None:
            self._values["aggregate_time"] = aggregate_time
        if api_connector is not None:
            self._values["api_connector"] = api_connector
        if api_data_elements is not None:
            self._values["api_data_elements"] = api_data_elements
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if override_aggregate_settings is not None:
            self._values["override_aggregate_settings"] = override_aggregate_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def aggregate_lines(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum number of lines to include in each log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        '''
        result = self._values.get("aggregate_lines")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the log's maximum size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        '''
        result = self._values.get("aggregate_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_time(self) -> typing.Optional[builtins.str]:
        '''Specifies how often logs are generated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        '''
        result = self._values.get("aggregate_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_connector(self) -> typing.Optional[builtins.str]:
        '''Describes the API connector type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        '''
        result = self._values.get("api_connector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_data_elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data set to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        '''
        result = self._values.get("api_data_elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the target hostname accepting push API requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the push API's endpoint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Monitor's log-publishing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_aggregate_settings(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides default log settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        '''
        result = self._values.get("override_aggregate_settings")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa012517267b91ceae8cf23094478e336941091572916886943e242d52a773d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAggregateLines")
    def reset_aggregate_lines(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateLines", []))

    @jsii.member(jsii_name="resetAggregateSize")
    def reset_aggregate_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateSize", []))

    @jsii.member(jsii_name="resetAggregateTime")
    def reset_aggregate_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateTime", []))

    @jsii.member(jsii_name="resetApiConnector")
    def reset_api_connector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiConnector", []))

    @jsii.member(jsii_name="resetApiDataElements")
    def reset_api_data_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiDataElements", []))

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideAggregateSettings")
    def reset_override_aggregate_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideAggregateSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aggregateLinesInput")
    def aggregate_lines_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateLinesInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateSizeInput")
    def aggregate_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateTimeInput")
    def aggregate_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="apiConnectorInput")
    def api_connector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiConnectorInput"))

    @builtins.property
    @jsii.member(jsii_name="apiDataElementsInput")
    def api_data_elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "apiDataElementsInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettingsInput")
    def override_aggregate_settings_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideAggregateSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateLines")
    def aggregate_lines(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateLines"))

    @aggregate_lines.setter
    def aggregate_lines(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a874cead1c384aa5818c268d4b4e3060f1fcd235f27b98f79fcf23ccc29dca22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateLines", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateSize")
    def aggregate_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateSize"))

    @aggregate_size.setter
    def aggregate_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec054407ac75acab2d58d8ed8ad5692de46b22622fd951989351e5fdeeba75b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateSize", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateTime")
    def aggregate_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateTime"))

    @aggregate_time.setter
    def aggregate_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d007742bb224f791fbf8c56cc14d27a99e17645daa1f2c66b7f9868c654cdf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateTime", value)

    @builtins.property
    @jsii.member(jsii_name="apiConnector")
    def api_connector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiConnector"))

    @api_connector.setter
    def api_connector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21fc9a7a53feb67aba510e9a00784b4ae92026d952a78692aa712a4524a0e6c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiConnector", value)

    @builtins.property
    @jsii.member(jsii_name="apiDataElements")
    def api_data_elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "apiDataElements"))

    @api_data_elements.setter
    def api_data_elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665a55852be269b3148eaae3344443b3c2249b07d39b47c3f4a937589915354f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiDataElements", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c48bc9588511c3323a29debe1efc0739fc588f1071ef18e7f6a994f79dc992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bc424de76055faa4a28297e7f4c5d5361b44abfd48b55076ac68c443a1a45f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118e9dff1dead2b7a21cf3563fc194757f861c41de76c88edcb05cf933484929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__245563b9331ad99e84fa88a63894747575c31439a91a4af0bfe194a960e34643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettings")
    def override_aggregate_settings(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideAggregateSettings"))

    @override_aggregate_settings.setter
    def override_aggregate_settings(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1881e0f99eab092bcca5b67039ae57e0edc6a00686e83592836dcbb89bbb28be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideAggregateSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08aa73cb2a9e5592020430d1910a37885b74ce56b16d3a8e2324156ee411fff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a660e2d208d4941c589676a58fdb6edacf131c98ae55c57827cdf25f6015931b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ba4f310f45dba69d291de9fab6602a8f7c4ca9073c2968d8a0bff56c8fa8a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6daa3d4290bfff5544e02ed95c723c9a89dda495168acfd3ee466c874e3572d)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A description of what the ``xml`` block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cde696864c49833bd443d91fc04a23d2619204cabb88c51c823a8bf61af76db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf33c6254aae23911020b5281b469c849031db25f3f31ff2bf608611a7ed8179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0021c7716ae29fadf0ddb9fa48c761eba25211285516abde4ad04d11b34ddea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361dbcb11bd93dba52dd6398bbc5210849290f411ab30fd1e83a463778027c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d989795b44fcc7746290c59c2ea11bf9e335c29be3b238f67c554dca3ff1f162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee500f317ff6436fef9ce65499a02d5bfbafabd879331fdfabe3c9883faff8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed9e91524feb53e480d7d1c2c756243d7cc11fe04b3c6929170d43718f5307e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_failover": "enableFailover",
        "failover_rules": "failoverRules",
        "failover_title": "failoverTitle",
        "hostname": "hostname",
        "ip": "ip",
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fda8d5e5f4e6801a84a0a29499d77ed525710a3ad70844e57024774fa8ac3f)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_failover", value=enable_failover, expected_type=type_hints["enable_failover"])
            check_type(argname="argument failover_rules", value=failover_rules, expected_type=type_hints["failover_rules"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_failover is not None:
            self._values["enable_failover"] = enable_failover
        if failover_rules is not None:
            self._values["failover_rules"] = failover_rules
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if hostname is not None:
            self._values["hostname"] = hostname
        if ip is not None:
            self._values["ip"] = ip
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB data center, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify failover rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        '''
        result = self._values.get("enable_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_rules(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]]:
        '''failover_rules block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        '''
        result = self._values.get("failover_rules")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the data center's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip(self) -> typing.Optional[builtins.str]:
        '''Specifies this data center's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    jsii_struct_bases=[],
    name_mapping={
        "absolute_path": "absolutePath",
        "context_root": "contextRoot",
        "failover_hostname": "failoverHostname",
        "modify_request": "modifyRequest",
        "override_hostname": "overrideHostname",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules:
    def __init__(
        self,
        *,
        absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        context_root: typing.Optional[builtins.str] = None,
        failover_hostname: typing.Optional[builtins.str] = None,
        modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param absolute_path: When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        :param context_root: Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        :param failover_hostname: The hostname of the data center to fail over to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        :param modify_request: Allows you to modify the request's hostname or path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        :param override_hostname: Overrides the request's hostname with the ``failover_hostname``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5005b20221cf0843379d0065d8d525a1f128f390c229f34cb8113cce887cc0)
            check_type(argname="argument absolute_path", value=absolute_path, expected_type=type_hints["absolute_path"])
            check_type(argname="argument context_root", value=context_root, expected_type=type_hints["context_root"])
            check_type(argname="argument failover_hostname", value=failover_hostname, expected_type=type_hints["failover_hostname"])
            check_type(argname="argument modify_request", value=modify_request, expected_type=type_hints["modify_request"])
            check_type(argname="argument override_hostname", value=override_hostname, expected_type=type_hints["override_hostname"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if absolute_path is not None:
            self._values["absolute_path"] = absolute_path
        if context_root is not None:
            self._values["context_root"] = context_root
        if failover_hostname is not None:
            self._values["failover_hostname"] = failover_hostname
        if modify_request is not None:
            self._values["modify_request"] = modify_request
        if override_hostname is not None:
            self._values["override_hostname"] = override_hostname

    @builtins.property
    def absolute_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page.

        Otherwise when disabled, the path is appended to the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        '''
        result = self._values.get("absolute_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def context_root(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        '''
        result = self._values.get("context_root")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_hostname(self) -> typing.Optional[builtins.str]:
        '''The hostname of the data center to fail over to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        '''
        result = self._values.get("failover_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def modify_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the request's hostname or path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        '''
        result = self._values.get("modify_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Overrides the request's hostname with the ``failover_hostname``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        result = self._values.get("override_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88570699fa299031b23b103dde94118d97c340bdc8cc9aa77745c72a21be694)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c17954f3bb2686d16084e18fb173048028f334bd7a1805909566123f792f7f8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b25d23d69bac69a3683d81434ddbe534c943ce95a9db944fc8c9d47592ec926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e29b96f34ca359cad0814e0e7d8e141e9f9c4b6dcd1a7082760d7dc1044345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a898a54c4846d724947dac9a4e90c549786cd9aa6da4384d18b9e5ecc69193a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef1189965e68556d00d1604e584c4398653236f60eedf7da2ec3e89df5e53d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de001784347dc79b5e0fb3962ae0dbbf7f1aa75b3299c241034f33508a74f45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAbsolutePath")
    def reset_absolute_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbsolutePath", []))

    @jsii.member(jsii_name="resetContextRoot")
    def reset_context_root(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContextRoot", []))

    @jsii.member(jsii_name="resetFailoverHostname")
    def reset_failover_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverHostname", []))

    @jsii.member(jsii_name="resetModifyRequest")
    def reset_modify_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyRequest", []))

    @jsii.member(jsii_name="resetOverrideHostname")
    def reset_override_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideHostname", []))

    @builtins.property
    @jsii.member(jsii_name="absolutePathInput")
    def absolute_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "absolutePathInput"))

    @builtins.property
    @jsii.member(jsii_name="contextRootInput")
    def context_root_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contextRootInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverHostnameInput")
    def failover_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyRequestInput")
    def modify_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideHostnameInput")
    def override_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="absolutePath")
    def absolute_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "absolutePath"))

    @absolute_path.setter
    def absolute_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__805f37629c0c064666070462353daeca6bd7bb06cf36f5e4f204f8bddeb98d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "absolutePath", value)

    @builtins.property
    @jsii.member(jsii_name="contextRoot")
    def context_root(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contextRoot"))

    @context_root.setter
    def context_root(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f95f4ed11fb0ef661ac062ca3b4d0a0aaf7f96b45843892817b51d43d1eca07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contextRoot", value)

    @builtins.property
    @jsii.member(jsii_name="failoverHostname")
    def failover_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverHostname"))

    @failover_hostname.setter
    def failover_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b205de80828a41fdffb13ce51442820567704d470b5a9c95d0364c0b6c612177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverHostname", value)

    @builtins.property
    @jsii.member(jsii_name="modifyRequest")
    def modify_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyRequest"))

    @modify_request.setter
    def modify_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb77611d64077569795b624ed502bacf4c07c1c451bebea08e6541eb6ee34d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="overrideHostname")
    def override_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideHostname"))

    @override_hostname.setter
    def override_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9bf79abda87bc540c90dc27f36f0fc1b45931944a968f2e7d137b6aa861286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideHostname", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7a98ace876f07ff341c69ae7c968d4c457fd2aa897753cf6cdf74d4457436a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4c055dbba8d4b3b805c3e29f5ec6527aa5fcd1ca720e2b6ab05e050e5cf1e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFailoverRules")
    def put_failover_rules(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6777bd401f8b606c123eccf7e55a3d74420b2f006c37c8fd413851222089c537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverRules", [value]))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableFailover")
    def reset_enable_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableFailover", []))

    @jsii.member(jsii_name="resetFailoverRules")
    def reset_failover_rules(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverRules", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="failoverRules")
    def failover_rules(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesList, jsii.get(self, "failoverRules"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableFailoverInput")
    def enable_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverRulesInput")
    def failover_rules_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "failoverRulesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e8eb4be8a1c7948e749d8bf75d45c9854200a8c3e8d3c83aeb9a3bd14b5fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbae9ea7f8953995fc8f3db1ebe8dd19e2df32f03a4de6e28a6571af06766653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableFailover")
    def enable_failover(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableFailover"))

    @enable_failover.setter
    def enable_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e8af80fcaec13bc12417070b8510bd2409fa3a35038bfb7e847f7271ac437c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableFailover", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59226ed3b4bbe12134f7cb8186f0a945de46ecde4f7cc7687e829f68cdedeb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e169ef52d279bbba08491b11dfc120bb1573b142c1d288190e1ed24c93fe82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ip"))

    @ip.setter
    def ip(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b4bb931832f92bd98a8d859f455b4dd6aabb3d9150ddfb238875c3c03ec191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a19b6fdd14066b812db30d6f4f4821bce8893ae7c3cb8e5416f521fd42b827c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc18c3304c172a8b0e71278cd7b75158d321e10d1851652e94a7c4761bf2399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3419eef25658daebb89cd66515549ba806e7e37319e32a80534ca19fa2e959c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a39d710f752d641ed77da9279aeee26e078fc1caec93d809dd617d12b6e4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed580a79740f36173f585f5ae5a31f95f4b1a91d8ad0beef7c5791ed8df91b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_session_persistence": "enableSessionPersistence",
        "hostname": "hostname",
        "id": "id",
        "locked": "locked",
        "session_persistence_title": "sessionPersistenceTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf740f4971e6f30eb6cb7590a1ad841ffa0ee7199b2d9bbc4bd4b41a703ce1a)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_session_persistence", value=enable_session_persistence, expected_type=type_hints["enable_session_persistence"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_persistence_title", value=session_persistence_title, expected_type=type_hints["session_persistence_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_session_persistence is not None:
            self._values["enable_session_persistence"] = enable_session_persistence
        if hostname is not None:
            self._values["hostname"] = hostname
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if session_persistence_title is not None:
            self._values["session_persistence_title"] = session_persistence_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that marks users' persistent sessions.

        The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB origin, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_session_persistence(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify a cookie to pin the user's browser session to one data center.

        When disabled, ELB's default load balancing may send users to various data centers within the same session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        '''
        result = self._values.get("enable_session_persistence")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname associated with the ELB rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique descriptive string for this ELB origin.

        The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_persistence_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        '''
        result = self._values.get("session_persistence_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb47c706f4e1e2effda88273fd48000af23846897613754261e21cb392d9138)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableSessionPersistence")
    def reset_enable_session_persistence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableSessionPersistence", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionPersistenceTitle")
    def reset_session_persistence_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionPersistenceTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistenceInput")
    def enable_session_persistence_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableSessionPersistenceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitleInput")
    def session_persistence_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sessionPersistenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e4b6047db78f90fc50dc12be7306916d81668a5e20c21c186b0925d12b323b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d0dedef4bc735496d60b612af097b1f45f0e8e8c7d3ec87e8eaeced99ae3f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistence")
    def enable_session_persistence(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableSessionPersistence"))

    @enable_session_persistence.setter
    def enable_session_persistence(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3873c3d3618ef224c5302d839defb9c99a2c1b04b7701be4541b33e8ae400d03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableSessionPersistence", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527f542684fe0eb4d05965b7624534e5a961fca7e953e23f704ab8c925598a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__682ac013a1197e6d374b3073c7519e021ab7f64008096e2be63da3e543f2b3ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6816173d6522e7a59bacdf0a4277bc9b625ed0caee660b8e12c603b66fd26a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitle")
    def session_persistence_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sessionPersistenceTitle"))

    @session_persistence_title.setter
    def session_persistence_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7b56c53eb45bba03e887dc23d1fff74f5938791e6281ff8569857736b5922a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionPersistenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d50610e8f10089da901b15919927f9ea9b18403fa78d3a7904daf578c8de75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b25223feb72d27b5db3aad0a21371c8e36a7e9b6cfe1d189b015db77bcdd53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78eb0994a2898aa328d9aced14c3fbcbc62bfe291cb755fe67bb50516d9174bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "domain": "domain",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e422d791e8ad5468587c96186b1d504c4ef170768ffbf40bd0f007f9ae1835d0)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if domain is not None:
            self._values["domain"] = domain
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to use for authorization.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cookie-authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the value of the authorization cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70e8474aabcb1e4b6938c8f3e3dce82ab9c8eeba030671bada2cd6d36c24a29)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7c0ed2aaebba8850465b96f267b5d3b218cf2d7a21c6a1a1c691cfb998d395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8538137a8e49a21dc791afc5a5b5d5d57201d99b10a1e727fc6f7739b436128)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df337f39f47808ad01d4dd4ec40fab94417f18a476e20dc877f57c0effa1827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f998a83ff15fefaaa07ce838a11394e23a23a95667a34d0ccc65a3a7d247d452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4546f26626e7a5f559fdd67ca8ed134fb5d4213beaeba9737e58b65ce2f08f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a6fd3b1686a1f1d138b3f237909c087d0722bd58699c0f628f45c94ac135d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2836ff6208387d2dc421f9ffac84faf6a3ed8b361722415ab5a39744deabad35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd4a739dd9d2fe628bd329a87bd9fd680cd0a5e07b078810cbb92c550103de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8cef1e7b551f3dc097a3a8fbbfd5610ded2dad785e43232d097ca1785f6e3d3)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Edge Redirector Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322c8caff75cda9ce41e7071b6502102c365ffeb46252cdbcce915af46eaa4ea)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331b70246d0424ac580992bcd882838d8a8173aebe6ef6cd98982c8485c18eb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d36ec3d70a967bb20679e2fadfc726ebd66916a0e1831e4daefd050ff34ead)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22df294ec5db3745b304bf3aab2fc64f0075ac8efe19ade7b56fbd843c0c9c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a61c19d963f8e86a0762b4a3e6d941a1bad54cf2022fb9bc96cc4d44c8cf311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd6d9167f90e4e8d5ad818f25b58e7fb1a15e302c7f56ea86e006ff7a2f48b9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd75c69093da552e4b86c745ac5ace837bf4a7a430843bf350005a2ff1c4fbd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3e1ffe59f935cec45f9e7513f61232fc284a478722d2f3b4380c76b744b959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835bb49524e3b7efd9a0369aee912a53d52f18f6e1b0685e5296af0562851016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e6ad5c4160dbd4d71e833e1a681f5d248d00526a2590380217ca1c8096e307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe098e9cc12a24f1736e864ec797350e12c85c7b6c7e5d6f5a7325a7480526ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__795f311c094550016d3386fd35b079b11dc794ba75cf65130accb72d9f3996c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3f358993d0e4fae91bce591bbafb28174fddddc4bc3e2ae103744532491423e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f79e3fb861807cfb123636a7904501f4391011bcb3ea6a36c809007becea33a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257fc42b6e4591673e59273ab712c47aecfe9ac7e864a706b1df9b46150d9402)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a331432ee99e95b3b030e15af9466c085dd730dcc4affba61968175901a8bc5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd86d0a39d3ff2b43a2fff0068f3117024aa92eb7843001371afb173475d9a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5baa961a76b4d24cd3ce0dcfbf3efcdfd997741b0051d45fcb05a01191be09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__489525e0f4dcd38565d4e2d7cc0589dc93c217f362c54c4b0dbc149724393c9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b6b66c17938f0e9802751ab3a9a98abe67c47eb177cf831e5cec316e3fad44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes",
    jsii_struct_bases=[],
    name_mapping={
        "detect_injection": "detectInjection",
        "enabled": "enabled",
        "enable_via_http": "enableViaHttp",
        "i18_n_charset": "i18NCharset",
        "i18_n_status": "i18NStatus",
        "locked": "locked",
        "pass_client_ip": "passClientIp",
        "pass_set_cookie": "passSetCookie",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes:
    def __init__(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3512083f336313d452f4828ec30bebbe0e57f42c22fefc832a29f4f9a7b1297a)
            check_type(argname="argument detect_injection", value=detect_injection, expected_type=type_hints["detect_injection"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_via_http", value=enable_via_http, expected_type=type_hints["enable_via_http"])
            check_type(argname="argument i18_n_charset", value=i18_n_charset, expected_type=type_hints["i18_n_charset"])
            check_type(argname="argument i18_n_status", value=i18_n_status, expected_type=type_hints["i18_n_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument pass_client_ip", value=pass_client_ip, expected_type=type_hints["pass_client_ip"])
            check_type(argname="argument pass_set_cookie", value=pass_set_cookie, expected_type=type_hints["pass_set_cookie"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if detect_injection is not None:
            self._values["detect_injection"] = detect_injection
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_via_http is not None:
            self._values["enable_via_http"] = enable_via_http
        if i18_n_charset is not None:
            self._values["i18_n_charset"] = i18_n_charset
        if i18_n_status is not None:
            self._values["i18_n_status"] = i18_n_status
        if locked is not None:
            self._values["locked"] = locked
        if pass_client_ip is not None:
            self._values["pass_client_ip"] = pass_client_ip
        if pass_set_cookie is not None:
            self._values["pass_set_cookie"] = pass_set_cookie
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def detect_injection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies attempts to inject ESI code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        '''
        result = self._values.get("detect_injection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ESI processing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_via_http(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        '''
        result = self._values.get("enable_via_http")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def i18_n_charset(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        '''
        result = self._values.get("i18_n_charset")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def i18_n_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Provides internationalization support for ESI.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        '''
        result = self._values.get("i18_n_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass the client IP header to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        '''
        result = self._values.get("pass_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_set_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass your origin server's cookies to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        '''
        result = self._values.get("pass_set_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebbef6665e1f56dfb27808743feeb5e2069ae625e643e858f8ae72ed6777b407)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDetectInjection")
    def reset_detect_injection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectInjection", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableViaHttp")
    def reset_enable_via_http(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableViaHttp", []))

    @jsii.member(jsii_name="resetI18NCharset")
    def reset_i18_n_charset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NCharset", []))

    @jsii.member(jsii_name="resetI18NStatus")
    def reset_i18_n_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPassClientIp")
    def reset_pass_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassClientIp", []))

    @jsii.member(jsii_name="resetPassSetCookie")
    def reset_pass_set_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassSetCookie", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="detectInjectionInput")
    def detect_injection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectInjectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableViaHttpInput")
    def enable_via_http_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableViaHttpInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NCharsetInput")
    def i18_n_charset_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "i18NCharsetInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NStatusInput")
    def i18_n_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "i18NStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="passClientIpInput")
    def pass_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="passSetCookieInput")
    def pass_set_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passSetCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="detectInjection")
    def detect_injection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectInjection"))

    @detect_injection.setter
    def detect_injection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__252b50783a5be2fd89e1929b4004808938316a21368383a2845e4b483e155bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectInjection", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eaa0f9444163adc8e52702eedbcd61807b32fb816ddc7597a36bfcc74e1c036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableViaHttp")
    def enable_via_http(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableViaHttp"))

    @enable_via_http.setter
    def enable_via_http(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d047da01ac0244ddb90c45bc35da34f4daa438f1a9845d019e73f7ad88e26b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableViaHttp", value)

    @builtins.property
    @jsii.member(jsii_name="i18NCharset")
    def i18_n_charset(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "i18NCharset"))

    @i18_n_charset.setter
    def i18_n_charset(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__778c32d3168a3c8b1bb5ca9a64453f2773fc5231e0efa1ee0302709fbc4e4d3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NCharset", value)

    @builtins.property
    @jsii.member(jsii_name="i18NStatus")
    def i18_n_status(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "i18NStatus"))

    @i18_n_status.setter
    def i18_n_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9afa658730a449f7be68fc8081114344eb922b8704e87e45347d31cf892cf9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d4b7705d497be428338a2adf8de55bf458483242ab614b02692f56d41cb1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="passClientIp")
    def pass_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passClientIp"))

    @pass_client_ip.setter
    def pass_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6340b8c4046cb4fa8e08af75bc5a310eefe1fe1b33e5a9f324b9085e172d5043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="passSetCookie")
    def pass_set_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passSetCookie"))

    @pass_set_cookie.setter
    def pass_set_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd54c91d3da8f8bd684dacf9900b7efb6fb239a73139021a3090164169b03fb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passSetCookie", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1a43918d0568717b85dcf91e505b477ca39670c25a8d5256b574d33e95b622d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3c2b71de25c46ea28975c95079a2b7185d96ef74f430f68856fbb2bc02fef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc6a37b3ca54b3b810afb48a6f3a10d4aeaebd054b1d0103f7733ea5c871156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker",
    jsii_struct_bases=[],
    name_mapping={
        "create_edge_worker": "createEdgeWorker",
        "edge_worker_id": "edgeWorkerId",
        "enabled": "enabled",
        "locked": "locked",
        "resource_tier": "resourceTier",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker:
    def __init__(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e5fdfd937e0323177bc35434f87eb4267fb0c1feb22ac57d87fd09b22f20124)
            check_type(argname="argument create_edge_worker", value=create_edge_worker, expected_type=type_hints["create_edge_worker"])
            check_type(argname="argument edge_worker_id", value=edge_worker_id, expected_type=type_hints["edge_worker_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument resource_tier", value=resource_tier, expected_type=type_hints["resource_tier"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if create_edge_worker is not None:
            self._values["create_edge_worker"] = create_edge_worker
        if edge_worker_id is not None:
            self._values["edge_worker_id"] = edge_worker_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if resource_tier is not None:
            self._values["resource_tier"] = resource_tier
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def create_edge_worker(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        '''
        result = self._values.get("create_edge_worker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def edge_worker_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the EdgeWorker application to apply to this rule's web traffic.

        You can use the ``EdgeWorkers API`` to get this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        '''
        result = self._values.get("edge_worker_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies specified EdgeWorker functionality to this rule's web traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def resource_tier(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        '''
        result = self._values.get("resource_tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d925da961fd558995fcc44611d62c56866f43971ae49a533aedc3311c54945ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCreateEdgeWorker")
    def reset_create_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreateEdgeWorker", []))

    @jsii.member(jsii_name="resetEdgeWorkerId")
    def reset_edge_worker_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkerId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResourceTier")
    def reset_resource_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceTier", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorkerInput")
    def create_edge_worker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "createEdgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerIdInput")
    def edge_worker_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "edgeWorkerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceTierInput")
    def resource_tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "resourceTierInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorker")
    def create_edge_worker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "createEdgeWorker"))

    @create_edge_worker.setter
    def create_edge_worker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8e27ff3aa6faf43a7701254883d9b11330057e7cfb75a651e0ac22faff2fcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createEdgeWorker", value)

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerId")
    def edge_worker_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "edgeWorkerId"))

    @edge_worker_id.setter
    def edge_worker_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80fc0b846be61ffb8048fc9706099d5f58f4ef7be95ef204b5d955e10b0d700f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "edgeWorkerId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d728fe77926d8fa3f7120ac521cc702e3d2a2db7ca90a03d682bb3c64280b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10e33a262af9527cc7978aaf42e31d3091155a1a4522dcdd68954b8b8fce619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="resourceTier")
    def resource_tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "resourceTier"))

    @resource_tier.setter
    def resource_tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1388f424a0018d66d690debfd7eda77607e23768e9255a018a834470fa97cce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resourceTier", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04766ffa63e763247d31c00b381bba1fc1e2d158a86a722352aac4f41db2dcc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95431b851631cb259ac01afd05704e1e4f7e2726093c54859f07fbf8badeb158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac393c9488e3497394effc03875160786f266bdc03de49bef56df07a4b38cd1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e17bbbc904bed074d76a40d0be5c2ebc51bb9ac25381d220418629083b24bc5)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b129e3dc4aba5520f2a932bbf869f26fd954e5ff2f9270dee83a927005acab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb2a9ec3558e97528bd3a55fe0b23f358d54b4ba35def3f8cb0ce492dddc6fb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2169a070aff82f2bb961c7347f1192fe5cd39540ba979ff56438532d9b606b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc523dc28647536f03f8a964c1a31b951997163df66096baa260ebeb34c68c19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b05542450701e8e97a6addbaac241bc03f8b8c255f03b5196ccfe7445769411f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c4763a1b41df78f86a85354e20b9aa1c1ff754afe568e1a04b111d2b41f690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous_vpn": "anonymousVpn",
        "best_practice_action": "bestPracticeAction",
        "best_practice_redirecturl": "bestPracticeRedirecturl",
        "detect_anonymous_vpn": "detectAnonymousVpn",
        "detect_anonymous_vpn_action": "detectAnonymousVpnAction",
        "detect_anonymous_vpn_redirecturl": "detectAnonymousVpnRedirecturl",
        "detect_hosting_provider": "detectHostingProvider",
        "detect_hosting_provider_action": "detectHostingProviderAction",
        "detect_hosting_provider_redirecturl": "detectHostingProviderRedirecturl",
        "detect_public_proxy": "detectPublicProxy",
        "detect_public_proxy_action": "detectPublicProxyAction",
        "detect_public_proxy_redirecturl": "detectPublicProxyRedirecturl",
        "detect_residential_proxy": "detectResidentialProxy",
        "detect_residential_proxy_action": "detectResidentialProxyAction",
        "detect_residential_proxy_redirecturl": "detectResidentialProxyRedirecturl",
        "detect_smart_dns_proxy": "detectSmartDnsProxy",
        "detect_smart_dns_proxy_action": "detectSmartDnsProxyAction",
        "detect_smart_dns_proxy_redirecturl": "detectSmartDnsProxyRedirecturl",
        "detect_tor_exit_node": "detectTorExitNode",
        "detect_tor_exit_node_action": "detectTorExitNodeAction",
        "detect_tor_exit_node_redirecturl": "detectTorExitNodeRedirecturl",
        "detect_vpn_data_center": "detectVpnDataCenter",
        "detect_vpn_data_center_action": "detectVpnDataCenterAction",
        "detect_vpn_data_center_redirecturl": "detectVpnDataCenterRedirecturl",
        "enable_configuration_mode": "enableConfigurationMode",
        "enabled": "enabled",
        "forward_header_enrichment": "forwardHeaderEnrichment",
        "hosting_provider": "hostingProvider",
        "locked": "locked",
        "public_proxy": "publicProxy",
        "residential_proxy": "residentialProxy",
        "smart_dns_proxy": "smartDnsProxy",
        "template_uuid": "templateUuid",
        "tor_exit_node": "torExitNode",
        "uuid": "uuid",
        "vpn_data_center": "vpnDataCenter",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection:
    def __init__(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e7f3ee2097ce40d6d29056c7cdc36bf0c4f923c9a36c16f6434e7412e15002)
            check_type(argname="argument anonymous_vpn", value=anonymous_vpn, expected_type=type_hints["anonymous_vpn"])
            check_type(argname="argument best_practice_action", value=best_practice_action, expected_type=type_hints["best_practice_action"])
            check_type(argname="argument best_practice_redirecturl", value=best_practice_redirecturl, expected_type=type_hints["best_practice_redirecturl"])
            check_type(argname="argument detect_anonymous_vpn", value=detect_anonymous_vpn, expected_type=type_hints["detect_anonymous_vpn"])
            check_type(argname="argument detect_anonymous_vpn_action", value=detect_anonymous_vpn_action, expected_type=type_hints["detect_anonymous_vpn_action"])
            check_type(argname="argument detect_anonymous_vpn_redirecturl", value=detect_anonymous_vpn_redirecturl, expected_type=type_hints["detect_anonymous_vpn_redirecturl"])
            check_type(argname="argument detect_hosting_provider", value=detect_hosting_provider, expected_type=type_hints["detect_hosting_provider"])
            check_type(argname="argument detect_hosting_provider_action", value=detect_hosting_provider_action, expected_type=type_hints["detect_hosting_provider_action"])
            check_type(argname="argument detect_hosting_provider_redirecturl", value=detect_hosting_provider_redirecturl, expected_type=type_hints["detect_hosting_provider_redirecturl"])
            check_type(argname="argument detect_public_proxy", value=detect_public_proxy, expected_type=type_hints["detect_public_proxy"])
            check_type(argname="argument detect_public_proxy_action", value=detect_public_proxy_action, expected_type=type_hints["detect_public_proxy_action"])
            check_type(argname="argument detect_public_proxy_redirecturl", value=detect_public_proxy_redirecturl, expected_type=type_hints["detect_public_proxy_redirecturl"])
            check_type(argname="argument detect_residential_proxy", value=detect_residential_proxy, expected_type=type_hints["detect_residential_proxy"])
            check_type(argname="argument detect_residential_proxy_action", value=detect_residential_proxy_action, expected_type=type_hints["detect_residential_proxy_action"])
            check_type(argname="argument detect_residential_proxy_redirecturl", value=detect_residential_proxy_redirecturl, expected_type=type_hints["detect_residential_proxy_redirecturl"])
            check_type(argname="argument detect_smart_dns_proxy", value=detect_smart_dns_proxy, expected_type=type_hints["detect_smart_dns_proxy"])
            check_type(argname="argument detect_smart_dns_proxy_action", value=detect_smart_dns_proxy_action, expected_type=type_hints["detect_smart_dns_proxy_action"])
            check_type(argname="argument detect_smart_dns_proxy_redirecturl", value=detect_smart_dns_proxy_redirecturl, expected_type=type_hints["detect_smart_dns_proxy_redirecturl"])
            check_type(argname="argument detect_tor_exit_node", value=detect_tor_exit_node, expected_type=type_hints["detect_tor_exit_node"])
            check_type(argname="argument detect_tor_exit_node_action", value=detect_tor_exit_node_action, expected_type=type_hints["detect_tor_exit_node_action"])
            check_type(argname="argument detect_tor_exit_node_redirecturl", value=detect_tor_exit_node_redirecturl, expected_type=type_hints["detect_tor_exit_node_redirecturl"])
            check_type(argname="argument detect_vpn_data_center", value=detect_vpn_data_center, expected_type=type_hints["detect_vpn_data_center"])
            check_type(argname="argument detect_vpn_data_center_action", value=detect_vpn_data_center_action, expected_type=type_hints["detect_vpn_data_center_action"])
            check_type(argname="argument detect_vpn_data_center_redirecturl", value=detect_vpn_data_center_redirecturl, expected_type=type_hints["detect_vpn_data_center_redirecturl"])
            check_type(argname="argument enable_configuration_mode", value=enable_configuration_mode, expected_type=type_hints["enable_configuration_mode"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_header_enrichment", value=forward_header_enrichment, expected_type=type_hints["forward_header_enrichment"])
            check_type(argname="argument hosting_provider", value=hosting_provider, expected_type=type_hints["hosting_provider"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument public_proxy", value=public_proxy, expected_type=type_hints["public_proxy"])
            check_type(argname="argument residential_proxy", value=residential_proxy, expected_type=type_hints["residential_proxy"])
            check_type(argname="argument smart_dns_proxy", value=smart_dns_proxy, expected_type=type_hints["smart_dns_proxy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tor_exit_node", value=tor_exit_node, expected_type=type_hints["tor_exit_node"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument vpn_data_center", value=vpn_data_center, expected_type=type_hints["vpn_data_center"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous_vpn is not None:
            self._values["anonymous_vpn"] = anonymous_vpn
        if best_practice_action is not None:
            self._values["best_practice_action"] = best_practice_action
        if best_practice_redirecturl is not None:
            self._values["best_practice_redirecturl"] = best_practice_redirecturl
        if detect_anonymous_vpn is not None:
            self._values["detect_anonymous_vpn"] = detect_anonymous_vpn
        if detect_anonymous_vpn_action is not None:
            self._values["detect_anonymous_vpn_action"] = detect_anonymous_vpn_action
        if detect_anonymous_vpn_redirecturl is not None:
            self._values["detect_anonymous_vpn_redirecturl"] = detect_anonymous_vpn_redirecturl
        if detect_hosting_provider is not None:
            self._values["detect_hosting_provider"] = detect_hosting_provider
        if detect_hosting_provider_action is not None:
            self._values["detect_hosting_provider_action"] = detect_hosting_provider_action
        if detect_hosting_provider_redirecturl is not None:
            self._values["detect_hosting_provider_redirecturl"] = detect_hosting_provider_redirecturl
        if detect_public_proxy is not None:
            self._values["detect_public_proxy"] = detect_public_proxy
        if detect_public_proxy_action is not None:
            self._values["detect_public_proxy_action"] = detect_public_proxy_action
        if detect_public_proxy_redirecturl is not None:
            self._values["detect_public_proxy_redirecturl"] = detect_public_proxy_redirecturl
        if detect_residential_proxy is not None:
            self._values["detect_residential_proxy"] = detect_residential_proxy
        if detect_residential_proxy_action is not None:
            self._values["detect_residential_proxy_action"] = detect_residential_proxy_action
        if detect_residential_proxy_redirecturl is not None:
            self._values["detect_residential_proxy_redirecturl"] = detect_residential_proxy_redirecturl
        if detect_smart_dns_proxy is not None:
            self._values["detect_smart_dns_proxy"] = detect_smart_dns_proxy
        if detect_smart_dns_proxy_action is not None:
            self._values["detect_smart_dns_proxy_action"] = detect_smart_dns_proxy_action
        if detect_smart_dns_proxy_redirecturl is not None:
            self._values["detect_smart_dns_proxy_redirecturl"] = detect_smart_dns_proxy_redirecturl
        if detect_tor_exit_node is not None:
            self._values["detect_tor_exit_node"] = detect_tor_exit_node
        if detect_tor_exit_node_action is not None:
            self._values["detect_tor_exit_node_action"] = detect_tor_exit_node_action
        if detect_tor_exit_node_redirecturl is not None:
            self._values["detect_tor_exit_node_redirecturl"] = detect_tor_exit_node_redirecturl
        if detect_vpn_data_center is not None:
            self._values["detect_vpn_data_center"] = detect_vpn_data_center
        if detect_vpn_data_center_action is not None:
            self._values["detect_vpn_data_center_action"] = detect_vpn_data_center_action
        if detect_vpn_data_center_redirecturl is not None:
            self._values["detect_vpn_data_center_redirecturl"] = detect_vpn_data_center_redirecturl
        if enable_configuration_mode is not None:
            self._values["enable_configuration_mode"] = enable_configuration_mode
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_header_enrichment is not None:
            self._values["forward_header_enrichment"] = forward_header_enrichment
        if hosting_provider is not None:
            self._values["hosting_provider"] = hosting_provider
        if locked is not None:
            self._values["locked"] = locked
        if public_proxy is not None:
            self._values["public_proxy"] = public_proxy
        if residential_proxy is not None:
            self._values["residential_proxy"] = residential_proxy
        if smart_dns_proxy is not None:
            self._values["smart_dns_proxy"] = smart_dns_proxy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tor_exit_node is not None:
            self._values["tor_exit_node"] = tor_exit_node
        if uuid is not None:
            self._values["uuid"] = uuid
        if vpn_data_center is not None:
            self._values["vpn_data_center"] = vpn_data_center

    @builtins.property
    def anonymous_vpn(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        '''
        result = self._values.get("anonymous_vpn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        '''
        result = self._values.get("best_practice_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        '''
        result = self._values.get("best_practice_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from anonymous VPNs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        '''
        result = self._values.get("detect_anonymous_vpn")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_anonymous_vpn_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        '''
        result = self._values.get("detect_anonymous_vpn_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        '''
        result = self._values.get("detect_anonymous_vpn_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This detects requests from a hosting provider.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        '''
        result = self._values.get("detect_hosting_provider")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_hosting_provider_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        '''
        result = self._values.get("detect_hosting_provider_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the absolute URL to which to redirect requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        '''
        result = self._values.get("detect_hosting_provider_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from public proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        '''
        result = self._values.get("detect_public_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_public_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        '''
        result = self._values.get("detect_public_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        '''
        result = self._values.get("detect_public_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from a residential proxy.

        See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        '''
        result = self._values.get("detect_residential_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_residential_proxy_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        '''
        result = self._values.get("detect_residential_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        '''
        result = self._values.get("detect_residential_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from smart DNS proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        '''
        result = self._values.get("detect_smart_dns_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_smart_dns_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        '''
        result = self._values.get("detect_smart_dns_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        '''
        result = self._values.get("detect_smart_dns_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        '''
        result = self._values.get("detect_tor_exit_node")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_tor_exit_node_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        '''
        result = self._values.get("detect_tor_exit_node_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        '''
        result = self._values.get("detect_tor_exit_node_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        '''
        result = self._values.get("detect_vpn_data_center")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_vpn_data_center_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        '''
        result = self._values.get("detect_vpn_data_center_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        '''
        result = self._values.get("detect_vpn_data_center_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_configuration_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        '''
        result = self._values.get("enable_configuration_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies GeoGuard proxy detection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_header_enrichment(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation.

        See the ``epdForwardHeaderEnrichment`` behavior for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        '''
        result = self._values.get("forward_header_enrichment")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hosting_provider(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        '''
        result = self._values.get("hosting_provider")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def public_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        '''
        result = self._values.get("public_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def residential_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        '''
        result = self._values.get("residential_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smart_dns_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        '''
        result = self._values.get("smart_dns_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tor_exit_node(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        '''
        result = self._values.get("tor_exit_node")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vpn_data_center(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        result = self._values.get("vpn_data_center")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f8afb0b13c2f2d6a15635602f9bb6b3a7a7f029c707dfed744214538ee7d48f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymousVpn")
    def reset_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymousVpn", []))

    @jsii.member(jsii_name="resetBestPracticeAction")
    def reset_best_practice_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeAction", []))

    @jsii.member(jsii_name="resetBestPracticeRedirecturl")
    def reset_best_practice_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpn")
    def reset_detect_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpn", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnAction")
    def reset_detect_anonymous_vpn_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnAction", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnRedirecturl")
    def reset_detect_anonymous_vpn_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnRedirecturl", []))

    @jsii.member(jsii_name="resetDetectHostingProvider")
    def reset_detect_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProvider", []))

    @jsii.member(jsii_name="resetDetectHostingProviderAction")
    def reset_detect_hosting_provider_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderAction", []))

    @jsii.member(jsii_name="resetDetectHostingProviderRedirecturl")
    def reset_detect_hosting_provider_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderRedirecturl", []))

    @jsii.member(jsii_name="resetDetectPublicProxy")
    def reset_detect_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxy", []))

    @jsii.member(jsii_name="resetDetectPublicProxyAction")
    def reset_detect_public_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyAction", []))

    @jsii.member(jsii_name="resetDetectPublicProxyRedirecturl")
    def reset_detect_public_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectResidentialProxy")
    def reset_detect_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxy", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyAction")
    def reset_detect_residential_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyAction", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyRedirecturl")
    def reset_detect_residential_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxy")
    def reset_detect_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxy", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyAction")
    def reset_detect_smart_dns_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyAction", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyRedirecturl")
    def reset_detect_smart_dns_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectTorExitNode")
    def reset_detect_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNode", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeAction")
    def reset_detect_tor_exit_node_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeAction", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeRedirecturl")
    def reset_detect_tor_exit_node_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenter")
    def reset_detect_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenter", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterAction")
    def reset_detect_vpn_data_center_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterAction", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterRedirecturl")
    def reset_detect_vpn_data_center_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterRedirecturl", []))

    @jsii.member(jsii_name="resetEnableConfigurationMode")
    def reset_enable_configuration_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableConfigurationMode", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardHeaderEnrichment")
    def reset_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetHostingProvider")
    def reset_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostingProvider", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPublicProxy")
    def reset_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicProxy", []))

    @jsii.member(jsii_name="resetResidentialProxy")
    def reset_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResidentialProxy", []))

    @jsii.member(jsii_name="resetSmartDnsProxy")
    def reset_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmartDnsProxy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTorExitNode")
    def reset_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTorExitNode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVpnDataCenter")
    def reset_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVpnDataCenter", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpnInput")
    def anonymous_vpn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "anonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeActionInput")
    def best_practice_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturlInput")
    def best_practice_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnActionInput")
    def detect_anonymous_vpn_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnInput")
    def detect_anonymous_vpn_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectAnonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturlInput")
    def detect_anonymous_vpn_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderActionInput")
    def detect_hosting_provider_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderInput")
    def detect_hosting_provider_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectHostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturlInput")
    def detect_hosting_provider_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyActionInput")
    def detect_public_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyInput")
    def detect_public_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectPublicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturlInput")
    def detect_public_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyActionInput")
    def detect_residential_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyInput")
    def detect_residential_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectResidentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturlInput")
    def detect_residential_proxy_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyActionInput")
    def detect_smart_dns_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyInput")
    def detect_smart_dns_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectSmartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturlInput")
    def detect_smart_dns_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeActionInput")
    def detect_tor_exit_node_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeInput")
    def detect_tor_exit_node_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectTorExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturlInput")
    def detect_tor_exit_node_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterActionInput")
    def detect_vpn_data_center_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterInput")
    def detect_vpn_data_center_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectVpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturlInput")
    def detect_vpn_data_center_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationModeInput")
    def enable_configuration_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enableConfigurationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichmentInput")
    def forward_header_enrichment_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="hostingProviderInput")
    def hosting_provider_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="publicProxyInput")
    def public_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="residentialProxyInput")
    def residential_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "residentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxyInput")
    def smart_dns_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "smartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="torExitNodeInput")
    def tor_exit_node_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "torExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenterInput")
    def vpn_data_center_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "vpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpn")
    def anonymous_vpn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "anonymousVpn"))

    @anonymous_vpn.setter
    def anonymous_vpn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412510d0ee3891986f3318f70d5c85e090e3e9060bd11f088cc5b0d7feb1f5ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeAction")
    def best_practice_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeAction"))

    @best_practice_action.setter
    def best_practice_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6106fd42ddc67aae2fd56ecc4335882fdc453f7c1f63746337ec4e384c253275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeAction", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturl")
    def best_practice_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeRedirecturl"))

    @best_practice_redirecturl.setter
    def best_practice_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8995e663bdc8eb4f4d4cd110afc4f0ff95727ba766a8e7e00fe5526a783e1d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpn")
    def detect_anonymous_vpn(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectAnonymousVpn"))

    @detect_anonymous_vpn.setter
    def detect_anonymous_vpn(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8a29d733ecde1146999710f0cc9de6112cf6c6b081f710064ff33c2afe135c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnAction")
    def detect_anonymous_vpn_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnAction"))

    @detect_anonymous_vpn_action.setter
    def detect_anonymous_vpn_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecebb7929fc5b27ac1a06b5fc46bef22ba736a3e8413cd3cddf1b9dba3140c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturl")
    def detect_anonymous_vpn_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnRedirecturl"))

    @detect_anonymous_vpn_redirecturl.setter
    def detect_anonymous_vpn_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff83ecdc47e697b24f982e5a543af1cbfd926e7866ea298b184003f4303702d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProvider")
    def detect_hosting_provider(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectHostingProvider"))

    @detect_hosting_provider.setter
    def detect_hosting_provider(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822fcb723caf87da625626ad536d7540608568c746fecdf4ed1004b8175a492b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderAction")
    def detect_hosting_provider_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderAction"))

    @detect_hosting_provider_action.setter
    def detect_hosting_provider_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8436fc5ec72f4b0d0b29f7b5647571a443b42f0552ae3b6d47047cd5bc806060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturl")
    def detect_hosting_provider_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderRedirecturl"))

    @detect_hosting_provider_redirecturl.setter
    def detect_hosting_provider_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3439e124cf9ec23519c8a28b65c842b190561b6eaf70d2c787fe02bf12691afa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxy")
    def detect_public_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectPublicProxy"))

    @detect_public_proxy.setter
    def detect_public_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf8beafc75ae108632a84063eead37191763070bce96da67153da803b1ecb3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyAction")
    def detect_public_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyAction"))

    @detect_public_proxy_action.setter
    def detect_public_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ed9d97fd2346e6e7517baf89e2e29c34ca637d90b854ed7c759d8cc0e1d690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturl")
    def detect_public_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyRedirecturl"))

    @detect_public_proxy_redirecturl.setter
    def detect_public_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2291ebe004e7150f21f9efefe61072eddbc3027edb213073a899061f1311fa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxy")
    def detect_residential_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectResidentialProxy"))

    @detect_residential_proxy.setter
    def detect_residential_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5692323b801770c096e798e8b270b7cf792d5389d2bc6929f9d2926d79eeb729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyAction")
    def detect_residential_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyAction"))

    @detect_residential_proxy_action.setter
    def detect_residential_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a590777ca528a355d6a55f651e46713d614ac8992f588b8e33225967cea66d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturl")
    def detect_residential_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyRedirecturl"))

    @detect_residential_proxy_redirecturl.setter
    def detect_residential_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0604d8589bcdcd7dbc91c2b3a9d45c9148fca1e402d3a16bdf69f4c15268d42e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxy")
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectSmartDnsProxy"))

    @detect_smart_dns_proxy.setter
    def detect_smart_dns_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d213d97c8942de76c1766adf7e47cd2286b67f5a4cbfe74acc4b96aee4bb10fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyAction")
    def detect_smart_dns_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyAction"))

    @detect_smart_dns_proxy_action.setter
    def detect_smart_dns_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a72c246c533d540639a81b09522636886e418aa54d73e883700fdcec7f04a688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturl")
    def detect_smart_dns_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyRedirecturl"))

    @detect_smart_dns_proxy_redirecturl.setter
    def detect_smart_dns_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__527d4dcc2ff69620d913a5bfd24ade77f8679fd11f8c185a03ec9e4d5d5af1a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNode")
    def detect_tor_exit_node(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectTorExitNode"))

    @detect_tor_exit_node.setter
    def detect_tor_exit_node(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be97001315ffb7813b3bacaf809e53f79fe4c626aa1aded6c6a54bbc0545aa7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeAction")
    def detect_tor_exit_node_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeAction"))

    @detect_tor_exit_node_action.setter
    def detect_tor_exit_node_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6df94700dcc032c257d15aa095afe1d9e6621d3945b37674bcc87b2630bab23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturl")
    def detect_tor_exit_node_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeRedirecturl"))

    @detect_tor_exit_node_redirecturl.setter
    def detect_tor_exit_node_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51b768948ebcd943d92dccd0ab8ed1b3fb55b2789fefd91e35fb8108603ea1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenter")
    def detect_vpn_data_center(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectVpnDataCenter"))

    @detect_vpn_data_center.setter
    def detect_vpn_data_center(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6356a4845f9a944773595f9dd8e3e023058b62a80f5d09196d202b78fa58694c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterAction")
    def detect_vpn_data_center_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterAction"))

    @detect_vpn_data_center_action.setter
    def detect_vpn_data_center_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195775d3b5c4b235b3de5bc4e16bf39b5f14ccc525ba8b4fc0f4b2e362fbab55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturl")
    def detect_vpn_data_center_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterRedirecturl"))

    @detect_vpn_data_center_redirecturl.setter
    def detect_vpn_data_center_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f91a834c3149c7cbb87253659dfb6f28b36c2b2afceb41654e4f112926075e42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationMode")
    def enable_configuration_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enableConfigurationMode"))

    @enable_configuration_mode.setter
    def enable_configuration_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebff9cfcb780af92b26c0f2fe46ab8b461ca2f06fe23f125bc63257115e2a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableConfigurationMode", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bfe320dcf9c72ccfcb9cf84b0cf65328049c38f3202e53dde655d4edce34c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichment")
    def forward_header_enrichment(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forwardHeaderEnrichment"))

    @forward_header_enrichment.setter
    def forward_header_enrichment(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4581848c8452ff97363ce633b8f054823752b76436df61b1412be133d71c7124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHeaderEnrichment", value)

    @builtins.property
    @jsii.member(jsii_name="hostingProvider")
    def hosting_provider(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostingProvider"))

    @hosting_provider.setter
    def hosting_provider(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f434f7fe7cb396e476418cda9a1e6df3f58f8a6529899f230041b53a6f15aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f090431cb4ccc485bf5a141b3223e56d30ee444968e0469e19060bd462b96413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="publicProxy")
    def public_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicProxy"))

    @public_proxy.setter
    def public_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6396cbe9bbcf194e5e39064165dcf286cf22d03e4bc1a221dea99a4b7ff618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="residentialProxy")
    def residential_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "residentialProxy"))

    @residential_proxy.setter
    def residential_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fe64e898f0e71427d408cdf46b2ac9be98d20b20976aefa92042b39b57d81c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "residentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxy")
    def smart_dns_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "smartDnsProxy"))

    @smart_dns_proxy.setter
    def smart_dns_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c76d34c579081b1e91ee591764380b1d39fc4d5b2853887520e405567b54896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924ff20239fe84cb58e194235000cd42d856f970b679842007e6a927f250205c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="torExitNode")
    def tor_exit_node(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "torExitNode"))

    @tor_exit_node.setter
    def tor_exit_node(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c61d02ec6a504398842dafe2b1259dda5158b019cee832a1cb4aa4bdf5e612d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "torExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3626bafabb780f25f5f559a29905e24ed98de4f89d1f4824209af86190f4921b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenter")
    def vpn_data_center(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vpnDataCenter"))

    @vpn_data_center.setter
    def vpn_data_center(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944cda9e51421227329d522e6e9af794e29d1361f1eac4e3c5d48cddeaaf02d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc07c6417b12ef23a75019eaec7ce11173b1c76b66a8b1ccf1115216112c429f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e240ba6ef704796f7a1a9163257d5a0f21141e4651ca5ddf84e5c61fefcae233)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy.

        The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichmentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichmentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deffe0d0262f51b2c89e70824c0b074be807fec982dd4c6aaf6bdb3f06f6b26a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201871a13af5e1129374147d8d4378db2a46cd178660f3613d1c2251b72fd692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7761fa018d0918d529d801cbdec424c39e77d05d89ef59f7b59a8a10a2945f7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989d06f9784136f532c61c740c312a6cb95ffdb3c5878b981d226e971dd062c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c90580e753910cbc14cb64b46fb6cc356df82624e4f44615e63580cce501cb0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ad4ad2dcb9087bf058503a569bdb4c9f747d5d6ea932c522541ec8d19cabe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction",
    jsii_struct_bases=[],
    name_mapping={
        "action_type": "actionType",
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "cex_custom_path": "cexCustomPath",
        "cex_hostname": "cexHostname",
        "cex_path": "cexPath",
        "content_custom_path": "contentCustomPath",
        "content_hostname": "contentHostname",
        "content_path": "contentPath",
        "cp_code": "cpCode",
        "dynamic_custom_path": "dynamicCustomPath",
        "dynamic_method": "dynamicMethod",
        "dynamic_path": "dynamicPath",
        "enabled": "enabled",
        "locked": "locked",
        "modify_protocol": "modifyProtocol",
        "net_storage_hostname": "netStorageHostname",
        "net_storage_path": "netStoragePath",
        "preserve_query_string": "preserveQueryString",
        "protocol": "protocol",
        "redirect_custom_path": "redirectCustomPath",
        "redirect_hostname": "redirectHostname",
        "redirect_hostname_type": "redirectHostnameType",
        "redirect_method": "redirectMethod",
        "redirect_path": "redirectPath",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction:
    def __init__(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode(**cp_code)
        if isinstance(net_storage_hostname, dict):
            net_storage_hostname = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname(**net_storage_hostname)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4ee38765b25e0c4b208b7718ed73435382a434730816f1e0f4ee399e7129c9)
            check_type(argname="argument action_type", value=action_type, expected_type=type_hints["action_type"])
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument cex_custom_path", value=cex_custom_path, expected_type=type_hints["cex_custom_path"])
            check_type(argname="argument cex_hostname", value=cex_hostname, expected_type=type_hints["cex_hostname"])
            check_type(argname="argument cex_path", value=cex_path, expected_type=type_hints["cex_path"])
            check_type(argname="argument content_custom_path", value=content_custom_path, expected_type=type_hints["content_custom_path"])
            check_type(argname="argument content_hostname", value=content_hostname, expected_type=type_hints["content_hostname"])
            check_type(argname="argument content_path", value=content_path, expected_type=type_hints["content_path"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument dynamic_custom_path", value=dynamic_custom_path, expected_type=type_hints["dynamic_custom_path"])
            check_type(argname="argument dynamic_method", value=dynamic_method, expected_type=type_hints["dynamic_method"])
            check_type(argname="argument dynamic_path", value=dynamic_path, expected_type=type_hints["dynamic_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_protocol", value=modify_protocol, expected_type=type_hints["modify_protocol"])
            check_type(argname="argument net_storage_hostname", value=net_storage_hostname, expected_type=type_hints["net_storage_hostname"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument preserve_query_string", value=preserve_query_string, expected_type=type_hints["preserve_query_string"])
            check_type(argname="argument protocol", value=protocol, expected_type=type_hints["protocol"])
            check_type(argname="argument redirect_custom_path", value=redirect_custom_path, expected_type=type_hints["redirect_custom_path"])
            check_type(argname="argument redirect_hostname", value=redirect_hostname, expected_type=type_hints["redirect_hostname"])
            check_type(argname="argument redirect_hostname_type", value=redirect_hostname_type, expected_type=type_hints["redirect_hostname_type"])
            check_type(argname="argument redirect_method", value=redirect_method, expected_type=type_hints["redirect_method"])
            check_type(argname="argument redirect_path", value=redirect_path, expected_type=type_hints["redirect_path"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action_type is not None:
            self._values["action_type"] = action_type
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if cex_custom_path is not None:
            self._values["cex_custom_path"] = cex_custom_path
        if cex_hostname is not None:
            self._values["cex_hostname"] = cex_hostname
        if cex_path is not None:
            self._values["cex_path"] = cex_path
        if content_custom_path is not None:
            self._values["content_custom_path"] = content_custom_path
        if content_hostname is not None:
            self._values["content_hostname"] = content_hostname
        if content_path is not None:
            self._values["content_path"] = content_path
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if dynamic_custom_path is not None:
            self._values["dynamic_custom_path"] = dynamic_custom_path
        if dynamic_method is not None:
            self._values["dynamic_method"] = dynamic_method
        if dynamic_path is not None:
            self._values["dynamic_path"] = dynamic_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modify_protocol is not None:
            self._values["modify_protocol"] = modify_protocol
        if net_storage_hostname is not None:
            self._values["net_storage_hostname"] = net_storage_hostname
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if preserve_query_string is not None:
            self._values["preserve_query_string"] = preserve_query_string
        if protocol is not None:
            self._values["protocol"] = protocol
        if redirect_custom_path is not None:
            self._values["redirect_custom_path"] = redirect_custom_path
        if redirect_hostname is not None:
            self._values["redirect_hostname"] = redirect_hostname
        if redirect_hostname_type is not None:
            self._values["redirect_hostname_type"] = redirect_hostname_type
        if redirect_method is not None:
            self._values["redirect_method"] = redirect_method
        if redirect_path is not None:
            self._values["redirect_path"] = redirect_path
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the basic action to take when there is a failure to contact the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        '''
        result = self._values.get("action_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        '''
        result = self._values.get("cex_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies a hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        '''
        result = self._values.get("cex_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cex_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        '''
        result = self._values.get("cex_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        '''
        result = self._values.get("content_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the static hostname for the alternate redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        '''
        result = self._values.get("content_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        '''
        result = self._values.get("content_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode"], result)

    @builtins.property
    def dynamic_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the original requested path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        '''
        result = self._values.get("dynamic_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        '''
        result = self._values.get("dynamic_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dynamic_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        '''
        result = self._values.get("dynamic_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled in case of a failure to contact the origin, the current behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the redirect's protocol using the value of the ``protocol`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        '''
        result = self._values.get("modify_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage_hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname"]:
        '''net_storage_hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        '''
        result = self._values.get("net_storage_hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        '''
        result = self._values.get("preserve_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def protocol(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        '''
        result = self._values.get("protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses the ``redirectPath`` to customize a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        '''
        result = self._values.get("redirect_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_hostname(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        '''
        result = self._values.get("redirect_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_hostname_type(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve or customize the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        '''
        result = self._values.get("redirect_hostname_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        '''
        result = self._values.get("redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def redirect_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        '''
        result = self._values.get("redirect_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement pattern that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static portion of the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Identifies the component of the request that identifies the SaaS dynamic fail action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns a new HTTP status code to the failure response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60940e03e6a5aac851f599496036615082295c7d985ef1bc49023ba0908f379b)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89145d63056c67e9c276cf2a03ae14c56df00ebc19b2b1c818e178706e9b9e1a)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e4f1c1ba9c3d34d50a458f8ead4429d40fb29a6e9afa3e0da8175aec66fb171)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d496e393bfb30ee5cf8e17d1e8ebf4b47375c0573eba9b8589d9427a14fa0b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089cc86dcfa25945099c22165431bbdd6ceae9a89c3d7d8a773140c767f4dc58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8482493a0c8c3906bc3fafa5d099450cefa80070494c88d1ad511771a88c72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a2f9453a3516433e0d0996e7314362445d6f639bcf0f54c1cd28907c72f0ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8f56253460bda255fbb81c49560084fb29705b459b07e9f01fe4e2cbb4ca6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9314fc402dd4fc6120764c354406d0154677df16b6147d27acc23aaee92535)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95534b2ad76104cacccb4705802878f177ef4e83bb9cf6494206f4fe0ca6d6d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652812a85e57e029e7797059305bbb6c22cf9b2d26ac6cddd09a90ae1725cd67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7126f0aff339c13901d62aee50b3e4e8db4f17563936d545030997d10720da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30fb4af5a15a0a31b66a930ec0f1c33360124620dfc778642faabb0374d64aa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a004367165b778064c80239fdda58d2572d11bd0c8b622c0341f4b7373f9775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbda534eb1dc5cbcb5f8ed44644797a8f094fc5a14b2e4bd4b98e7746dd9533)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436f5b8f03be0b693ffc24c84348b2505999176a95dc1fb5ced04206acbcfad1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37218d259ae14c374b7f58ef7a5ed52a5c5ee7c54effeb5eef2666a36ed7d2aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a383c1b49136472063d3a961f53e7f0c0b16c6ee0ce1709c0c7fead6b1b08be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38e5bb4bf89a4d508b940502880fccd2e193b0bffd02ed6e5bc213fc40f65f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbcbb50040b635f6cca6bb5deb7bdf3d773fc2cbc05ed9f316a54e5fe55466e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9a1f0ff480662ae2d52bf5cd5998a335e0e1396f93c80c0608ec36a7ab051a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value]))

    @jsii.member(jsii_name="putNetStorageHostname")
    def put_net_storage_hostname(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorageHostname", [value]))

    @jsii.member(jsii_name="resetActionType")
    def reset_action_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetActionType", []))

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCexCustomPath")
    def reset_cex_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexCustomPath", []))

    @jsii.member(jsii_name="resetCexHostname")
    def reset_cex_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexHostname", []))

    @jsii.member(jsii_name="resetCexPath")
    def reset_cex_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexPath", []))

    @jsii.member(jsii_name="resetContentCustomPath")
    def reset_content_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCustomPath", []))

    @jsii.member(jsii_name="resetContentHostname")
    def reset_content_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentHostname", []))

    @jsii.member(jsii_name="resetContentPath")
    def reset_content_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPath", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDynamicCustomPath")
    def reset_dynamic_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicCustomPath", []))

    @jsii.member(jsii_name="resetDynamicMethod")
    def reset_dynamic_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicMethod", []))

    @jsii.member(jsii_name="resetDynamicPath")
    def reset_dynamic_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyProtocol")
    def reset_modify_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyProtocol", []))

    @jsii.member(jsii_name="resetNetStorageHostname")
    def reset_net_storage_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorageHostname", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetPreserveQueryString")
    def reset_preserve_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveQueryString", []))

    @jsii.member(jsii_name="resetProtocol")
    def reset_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProtocol", []))

    @jsii.member(jsii_name="resetRedirectCustomPath")
    def reset_redirect_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectCustomPath", []))

    @jsii.member(jsii_name="resetRedirectHostname")
    def reset_redirect_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostname", []))

    @jsii.member(jsii_name="resetRedirectHostnameType")
    def reset_redirect_hostname_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostnameType", []))

    @jsii.member(jsii_name="resetRedirectMethod")
    def reset_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectMethod", []))

    @jsii.member(jsii_name="resetRedirectPath")
    def reset_redirect_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectPath", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostname")
    def net_storage_hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostnameOutputReference, jsii.get(self, "netStorageHostname"))

    @builtins.property
    @jsii.member(jsii_name="actionTypeInput")
    def action_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="cexCustomPathInput")
    def cex_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cexCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cexHostnameInput")
    def cex_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="cexPathInput")
    def cex_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCustomPathInput")
    def content_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentHostnameInput")
    def content_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPathInput")
    def content_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPathInput")
    def dynamic_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicMethodInput")
    def dynamic_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicPathInput")
    def dynamic_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyProtocolInput")
    def modify_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostnameInput")
    def net_storage_hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname], jsii.get(self, "netStorageHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveQueryStringInput")
    def preserve_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="protocolInput")
    def protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "protocolInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPathInput")
    def redirect_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameInput")
    def redirect_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameTypeInput")
    def redirect_hostname_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectMethodInput")
    def redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectPathInput")
    def redirect_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectPathInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="actionType")
    def action_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "actionType"))

    @action_type.setter
    def action_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61c4e1eccf60110c0500d25018ec3fb4221e6ea684fc5b946228a863da10b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "actionType", value)

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18fcf5bc6d2d131cbf6641dc24d8b77c23981abd352926fd5d8c36bf15a6634c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="cexCustomPath")
    def cex_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cexCustomPath"))

    @cex_custom_path.setter
    def cex_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada2f286c78d1e8cfbe0d3b223d141f6261133e775ec09477c8f02ec4eb8b2a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="cexHostname")
    def cex_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexHostname"))

    @cex_hostname.setter
    def cex_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__245561b414e5fb41915574f03292b136f2ec170e41db63ce7f665d35a5c8be02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexHostname", value)

    @builtins.property
    @jsii.member(jsii_name="cexPath")
    def cex_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexPath"))

    @cex_path.setter
    def cex_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62871771b78ea9cd94f7dc648c23a0e054cf8373259907500ad38e6abc223e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentCustomPath")
    def content_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCustomPath"))

    @content_custom_path.setter
    def content_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77908eee69bdafe829cd7a84530ce325c525ef1b8f14ecd4adf7aabd422d60f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentHostname")
    def content_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentHostname"))

    @content_hostname.setter
    def content_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aad2f0730e0c6760df9e1a6df03904b90acc5859de443450ac4517b54072356e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentHostname", value)

    @builtins.property
    @jsii.member(jsii_name="contentPath")
    def content_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentPath"))

    @content_path.setter
    def content_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7648f0ea6dcd2d1e9c2fbca6385b45b3e1e8fbe3ffd37153730a1ccd55a82635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPath")
    def dynamic_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicCustomPath"))

    @dynamic_custom_path.setter
    def dynamic_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a681d46b7b63dd417bed788f4d84f520249f0547bca82e998e7e27fc742fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicMethod")
    def dynamic_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicMethod"))

    @dynamic_method.setter
    def dynamic_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6e62a94ddd40d420a5f4982f1cc07607e1e2f49f5e29ff7acf8f38c2ee49e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicMethod", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicPath")
    def dynamic_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicPath"))

    @dynamic_path.setter
    def dynamic_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47ec44015f315302e0f72f0c58b9842bcf93e5f49980812d27e5d0b4d776f6da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59de9d861584f68a3f2a218579af1b04c3f519371cb31f8a804f88b384806152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f18c67f108ede31213d0a89e26cae66973425d901a483eb443dd498679b6c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyProtocol")
    def modify_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyProtocol"))

    @modify_protocol.setter
    def modify_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380e89d7a1d861e7087286991071bd688068845ede0f51c9da69fdcc9a0b8522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691a04b608d096c82a7951e269c77899d4acad0d3144d2645e9b66cc4b2d8410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="preserveQueryString")
    def preserve_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveQueryString"))

    @preserve_query_string.setter
    def preserve_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33bbf48fc001285f48399cc4420ba5a94d77d6898ac179c6cc53290e9376ca91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="protocol")
    def protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "protocol"))

    @protocol.setter
    def protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816c83dde6f725650dfcc87f85aa9171c01958698399fbdcd44c17224f866e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "protocol", value)

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPath")
    def redirect_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirectCustomPath"))

    @redirect_custom_path.setter
    def redirect_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee3cc6245a799e070595f77eb8cd76688e7bf77fbac35119c45b08bf820e0b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostname")
    def redirect_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostname"))

    @redirect_hostname.setter
    def redirect_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998cc8f17f42751f7220d488906aec66b3714f07db52d98f5e166e6bb2de123a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostname", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameType")
    def redirect_hostname_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostnameType"))

    @redirect_hostname_type.setter
    def redirect_hostname_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a16136fc7352b8b14c789670649474b18f0fe3727922a0ed7a95c73cc284d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostnameType", value)

    @builtins.property
    @jsii.member(jsii_name="redirectMethod")
    def redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectMethod"))

    @redirect_method.setter
    def redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9069e66f13f684fee13c7f66b92f5a187fe54061f65c0ec2b4b5edc33a56c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="redirectPath")
    def redirect_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectPath"))

    @redirect_path.setter
    def redirect_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5364a052fcf7ece43730f1d69def98af502e3c66810df0c4410117438f7f6bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectPath", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea232490646f6f07af48bec15b04444ad903a0c12a7dbc1e8f31a492d195118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52197fa2ea2c96fe742d99df1ca76db63c5b1d9cba275ec982f9aa4d2e49ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59e1a915673bc3a25613be6764b8680feea881f2ecff9d2608bd18b9d43a0016)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b9817d187cc25690a6af30037f3a5c90dda2892b8e5da86e97e04294bccc3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195dad56ce513f91aa6da90c68734c1b26a348fac007ab6c58ee8e1b8d818b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85e59f766d1dacb0b375485906e852047dae9b880c47d72cf3a1612d0ca4219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fde08df161ff6caef90c3e23f0b1255e5f8ab29573b1f8d46d8d770e03237f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc9a9e067a108049db88a797e2db31f615e9f2999589ddd7055ad759007e9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48cf514efd1b4b4645fb7ffec2ce8800779e0de5962264f9cc6f2f3ca904bda2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e209c0155cbcf349d9ade099b5b046a5d1cf8bb801aa144911faa8c96bb67b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc9b0efab67f551e7e93f1a0d1b83c367c973ae2c1909c9ea5997f728196edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14225dffe12a80b5867d9f28edcded1e883cd45386a3d8b40f5e43bef43bb3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "compatibility": "compatibility",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility:
    def __init__(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec24d504dada3d6275c462dc5a5a1106bd19c3c8449af28de807f085ccb4a14)
            check_type(argname="argument compatibility", value=compatibility, expected_type=type_hints["compatibility"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compatibility is not None:
            self._values["compatibility"] = compatibility
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compatibility(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This behavior does not include any options. Specifying the behavior itself enables it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        '''
        result = self._values.get("compatibility")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__230c7f08d0b11e9bd218337749181ae15be0da7cadf5346f5a8008524afab217)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompatibility")
    def reset_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompatibility", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compatibilityInput")
    def compatibility_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compatibility")
    def compatibility(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compatibility"))

    @compatibility.setter
    def compatibility(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58b6fc6a910588ffe9ee86bf1e21200589560b73ce8caf80cef0468d3a73bbe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compatibility", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708e5845ced316e0820ff49d4164d183aec1e8fd7c0a5024a3b56c898cb135fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc1ce8701e4369b86cb65fde0fbc30169c689d9e3c16be16c8aeb81c0a79881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a95b044b09e92106fecb80508af9495f94103e83eeb7a03224a7e3fede3672a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16885581489da92e4b54a7223a0d37610f8089b4f4b02da486ed8f7eb842d42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03dd65a83666d6c7d30ee71fd2aca4425e4b5eb693f82505dbe5ea8b10fe386)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, forces a validation test for all edge content to which the behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e40a216beada2f306f8a094a68ff8eee4b3ae6aea13a11b96f87292ebe369b7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c7c6c14913e7f96c19cce940deb9d0cfef8e24dd638d748816b32da488d603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234ce0a2b9973b69bae0f544cb239a9d7814ce0bd8ed12a92308fa29f5df5091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b7b2024ae01135371691c80972dc54bb3c9c5d0a9a645ed9dba2787e7f452c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eab23e9dec3f0d1b1ae358c46a9c84ec141268d0f95a2c929e224af4ed223b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9061c335ebcb4339e454ec1205abce4e1ef869d2721b9602ef55392aa8da92e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11ead7f6065d059fbaea62f991631707a7774b33a2e02e3fb38598d92a7d626)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6377a43bb7ec8bb496814452f475a8ce953a824675c71a38f1f7524b87a13d5d)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ebc78bdc7ad501473acdd5f8acbb5a597870abc50417aeec4dbe0eb7d2692ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2701426bdd262f8d22c21b365d7a943674dea012d6d4450ecbf548aa9c6c52d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2250b63d7beb35d20f75055f68a88e5a8befddf1f7ef922f8d4895bb655b5ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb7b6f4d81c4a3195955fa05a5a3f487da448803af491ff908119695774cb76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f430fa4d87a3d1886bc4a2b84f0ba06ad730d22608688c450bb9f0df03743f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7fd3e85e06fd2b0f663e9384359acfbb92989c2cfd472994fc37c323afb5be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847861f1bc36d484a459b194aea8e7e2e02cc477cc747f06caaa4245546b92a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9247bc157ad024b9a5f6b91c4d76a14370d12cdd5ec3a8309898afe40d3bcde8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb936fb4a3c32c4bef7e1079feb6d7016fbd2fe512f7375d5fc3b1b68acd8011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492fbb9e37190e8b8c24093014367678f5a2d8da69f2486594e48bfd02fbc57b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc5ee1f8ec8e7822ce753db6dcae779dfe1d7f9185e70e9553336eede5a2d8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ebf72e9042efd85df69b65ba028b12fc9e40afe8d479ae30207d6c3a5f4647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9799788e18f8c71dc28001ef0c30ced90bb3e24dbb2d19b09bf4cf52cf80e472)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Plus Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc403b6d512623fffab83b3a645d913e6d4e0b7901d063fadd7e4e62b19d705)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13f933154660b682cf75b8ea6c15de2a8f7bf195cc8cc3333e4d68098540ada)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f27410e8c200d1feaa74907330f77cd57b86750f00ebe7f311472ed0ddd56a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840ec1b73f2a5a9841b2b173a6c1ed4156f587e70c0cbda5c47cd1c00c235d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86000a7f80689e1d59745a2770f12b8717b80b7eda833a7a0038b1dfa6f59fc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90660415844fc9d29ebdeade9b13e0f5f0fc63580b363c7bf722395e101b239)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd64c14ae3c2ae5e6c504e1efa153babf00d53fe6f86d59f143c14e77a5bc5ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e574ce97038ff234bf190cd2017e9cbb6e028b1d8189b1cfc8c513fe1b5f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587488f0c4a16fff6f2a7d588c51163ab5ac5180f4cbd15c5b5016da8e120a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45177ec244f1eacae151c108c74f2b38024beafd7b41402521bee4e414f99b8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907fb76381ea229bf29fc498b1d96e80af38937b81d42701a2a6a4ce87eb9a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df1be0f4653faf779546f732f0f2f87ff1e3895d09e0fe659584c5832f50fb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61f5908032fe6348f47da3e1b34e3f3e08c31ef3194c5b920faa518ee744a90b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae69b327fb435173f41c37ed121b36406cbe17ce6c0fd420b190e04a740ab07)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Forward Rewrite Cloudlet behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc3202a80ba67dea64417e7b8551857fe5aab7eb41e460418b62820ce9f6ab1)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470fdfe184a7c41c5c63b77936225e2f8c3f39e6c73dbc94a792f4145f2a05ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34033f9582f9edf15212bd43d31f0de736228e9a555eb73be8d4f38eca209f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__441dce0108849391b618f0dce828e4a704b901a5eac25507c014fbc0bb464570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7917f0d417cccda108df2eba12c0fcf69e251a7cfa15afd59fe5e89fd8e19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386cf387ab546fe6e5ee70ca6c3c5d6f4d5579236ba72d3af2579d78c87d21d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6baa2a6d418cc36458dfca4b2e2b17c522a407e10148a39b2edaaf60af8debb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76cd8e5602bc70edb20644e953c3fc1906abf96a9fa1bba597cc3b86f139a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b082c5fa079d9c2b92f7af2eec8c8f0bfd5c4105158fda4c08ebccc054494dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bc3a52cfa8a5be6f338493cf7b8bff69ee80e6bd9ed076b1fb7ca1443a67d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca277384b6537980391dedc8701785354bf3725198996d82b37d119fc70d0c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb54e929d54a6d5e566a562a1fd8e0058fe9d2834d697cc51ff7bea0a18f47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8238b94361c5c2f8d81e4019afa9f23f7ecb26bad86946a7b03f28337cca6e96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the front-end optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3b845d9cdbe77a556243ea71dc90fa7178fc4137f9720a4fc763bdc04cf23ef)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the front-end optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe4532d9fe5f855407cf94429cb516aef7c59a94c1dc1366f3ec365c0d8fbc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0764567e3603463647ae9393939421bbf316dc32f7e8e3bcd6ae6549b910337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a390efb7740b7a59aa45e543abf65f911e4f54d540c44a18db73104ab90275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79953f3064eade73a3168ce04691ead49cd4732ede0957ea67797ce292560858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4440a7c6574ebbbeb28da04706b1bc8847ae74f1b91728237d5e8c4d53b5d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad6efd8b6b72a0341215a9c987abf1d17ac1af0cca8cad6f96a8c5d5c7ce9747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader",
    jsii_struct_bases=[],
    name_mapping={
        "custom_sign_string": "customSignString",
        "data_header": "dataHeader",
        "enabled": "enabled",
        "encoding_version": "encodingVersion",
        "locked": "locked",
        "nonce": "nonce",
        "secret_key": "secretKey",
        "signed_header": "signedHeader",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader:
    def __init__(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba36ce71b989c7cafa254fa1fc6a5a159563b7534f7bef40db17933fb7a8ec24)
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument data_header", value=data_header, expected_type=type_hints["data_header"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument signed_header", value=signed_header, expected_type=type_hints["signed_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if data_header is not None:
            self._values["data_header"] = data_header
        if enabled is not None:
            self._values["enabled"] = enabled
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if locked is not None:
            self._values["locked"] = locked
        if nonce is not None:
            self._values["nonce"] = nonce
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if signed_header is not None:
            self._values["signed_header"] = signed_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of data to be encrypted as a combination of concatenated strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def data_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header that contains the request data that needs to be encrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        '''
        result = self._values.get("data_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the g2o verification behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the cryptographic ``nonce`` string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signed_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header containing encrypted request data.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        '''
        result = self._values.get("signed_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, the encrypted string is based on the forwarded URL.

        If enabled, you can use ``customSignString`` to customize the set of data to encrypt.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2OheaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2OheaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70476d55d9de557e710f80e5f02575b689dc447c7f1f5e04f86cfb1db22565f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDataHeader")
    def reset_data_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataHeader", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetSignedHeader")
    def reset_signed_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignedHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="dataHeaderInput")
    def data_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dataHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="signedHeaderInput")
    def signed_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "signedHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc7ee2054f491de3a9a927c53f463e3e2a9b0e4b00dfb7e893ce2730d69597d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="dataHeader")
    def data_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataHeader"))

    @data_header.setter
    def data_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d70f8d06d48d2b5a1518750614bf76333504a9aec182af3fa7692cc1df42c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cbc570f4759f026571cce5834fd646e59a7bf628e0299491f0dbec26aa3bbc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12304cb71928df49a50a4178cf1d3b69a5ed54efed5b0bddef94e85b76b07760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a80937371ea366affb665fbbdcef2228c1a459a3f2c47af4ce3c03330a7fac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__992ea4e519454c240ef1c57d7873ab6c0df4ff69475261373b08329c6c3a0ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad4f6e38d124e552ac2c76258a5cffaa30c87495df45d8d6d55de5014d07e41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="signedHeader")
    def signed_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "signedHeader"))

    @signed_header.setter
    def signed_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e1ed2a9e6f12cc29d5defe9d3bfce55dbc94560a5bd2614b18b2a6d4176fea8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signedHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783a89d04017c7b207ca7ffba7544caf1ced18d554d5cc8f37a6edfd52437545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e963127959b6a86ab5846a6b7032d1128fa66ab5648119efa80b56f62ac0ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0f41e011bef0e602281ed1b301433dc8cae9d8d5dc71e24ece1383fa485318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cbcc1715ad71391c1cec2c88aa477554e1b8f507a04c29cf0e2045fee5eff1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "output_option": "outputOption",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b6fba6f25c2c87baf9d108cb3004b5976300ef5e235758e0f191d49ef77231)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument output_option", value=output_option, expected_type=type_hints["output_option"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if output_option is not None:
            self._values["output_option"] = output_option
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def output_option(self) -> typing.Optional[builtins.str]:
        '''Specifies how to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        '''
        result = self._values.get("output_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the variable to assign the GRN value to.

        You need to pre-declare any ``variable`` you specify within the rule tree.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumberOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumberOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96cf843671acd5823b66c2b1724d38e31e971c1746557de8c6edc4c5f492a734)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOutputOption")
    def reset_output_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOutputOption", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="outputOptionInput")
    def output_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "outputOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f8442e80bf3bae221d686085bc04b7934bfc2b8e7918f6bd0aa60da2713ca80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef95d5ccd8358a7fcea9c66e748d4e461b0940a02b88a83a9ce272a5682cef97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="outputOption")
    def output_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "outputOption"))

    @output_option.setter
    def output_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7678d13726c3e3f16d0392ad249f5a27efd3e57e61e95ccc027af8d981b7a8ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "outputOption", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1fb684b763cbb4178c135a3383ced19016c33f1b78e06210ba97a6b03f04f40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aedc118b9e2f1d3ed5eb32ca2de39e2cf2a5ed8eb47f20370f2b02fb13fdf0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f10fb110cadbb37bd752d7e0832feab4d1e52e2b7a12fd9b40744f84341ba9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1886a6e2921df1a23b5fe7ef4944f4c698b24a184ade00e3f72c1031f06bc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "cache_responses_with_errors": "cacheResponsesWithErrors",
        "enabled": "enabled",
        "locked": "locked",
        "operations_json_body_parameter_name": "operationsJsonBodyParameterName",
        "operations_url_query_parameter_name": "operationsUrlQueryParameterName",
        "post_request_processing_error_handling": "postRequestProcessingErrorHandling",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching:
    def __init__(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c299d2ca7277ac0212551214d8d9f4728f3adaec45ebf7e479f116d41078170)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument cache_responses_with_errors", value=cache_responses_with_errors, expected_type=type_hints["cache_responses_with_errors"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument operations_json_body_parameter_name", value=operations_json_body_parameter_name, expected_type=type_hints["operations_json_body_parameter_name"])
            check_type(argname="argument operations_url_query_parameter_name", value=operations_url_query_parameter_name, expected_type=type_hints["operations_url_query_parameter_name"])
            check_type(argname="argument post_request_processing_error_handling", value=post_request_processing_error_handling, expected_type=type_hints["post_request_processing_error_handling"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if cache_responses_with_errors is not None:
            self._values["cache_responses_with_errors"] = cache_responses_with_errors
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if operations_json_body_parameter_name is not None:
            self._values["operations_json_body_parameter_name"] = operations_json_body_parameter_name
        if operations_url_query_parameter_name is not None:
            self._values["operations_url_query_parameter_name"] = operations_url_query_parameter_name
        if post_request_processing_error_handling is not None:
            self._values["post_request_processing_error_handling"] = post_request_processing_error_handling
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_responses_with_errors(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches responses that include an ``error`` field at the top of the response body object.

        Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        '''
        result = self._values.get("cache_responses_with_errors")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables GraphQL caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def operations_json_body_parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the JSON body parameter that identifies GraphQL POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        '''
        result = self._values.get("operations_json_body_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def operations_url_query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of a query parameter that identifies requests as GraphQL queries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        '''
        result = self._values.get("operations_url_query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def post_request_processing_error_handling(self) -> typing.Optional[builtins.str]:
        '''Specify what happens if GraphQL query processing fails on POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        '''
        result = self._values.get("post_request_processing_error_handling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab8199c442c4f03b7a3eec4dbd681e210a8d16a701d50d3be318f25ea62857d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetCacheResponsesWithErrors")
    def reset_cache_responses_with_errors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheResponsesWithErrors", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOperationsJsonBodyParameterName")
    def reset_operations_json_body_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsJsonBodyParameterName", []))

    @jsii.member(jsii_name="resetOperationsUrlQueryParameterName")
    def reset_operations_url_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsUrlQueryParameterName", []))

    @jsii.member(jsii_name="resetPostRequestProcessingErrorHandling")
    def reset_post_request_processing_error_handling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPostRequestProcessingErrorHandling", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrorsInput")
    def cache_responses_with_errors_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheResponsesWithErrorsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterNameInput")
    def operations_json_body_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsJsonBodyParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterNameInput")
    def operations_url_query_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsUrlQueryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandlingInput")
    def post_request_processing_error_handling_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "postRequestProcessingErrorHandlingInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95847f57a321cf8fc2374dbc0e7897ed7fff33c0fa575db994f397e8b512d3c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrors")
    def cache_responses_with_errors(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheResponsesWithErrors"))

    @cache_responses_with_errors.setter
    def cache_responses_with_errors(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9656524ad81d9cc90828940d78bd24c0ff2b9cafc3cf95e2d18c17b7cd85bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheResponsesWithErrors", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012885861ac77a13b2e1e024d2715cab93db33b5da1f570d0c82c403fe879a7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9849210525e90340615cb3cc9159caa4ac25725e846f1ad04a31d48fc3da2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterName")
    def operations_json_body_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsJsonBodyParameterName"))

    @operations_json_body_parameter_name.setter
    def operations_json_body_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0cd768f825e1bfd46a13eb3ba0a0febeaf1ca6551e67e8f5237ee20e4cce077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsJsonBodyParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterName")
    def operations_url_query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsUrlQueryParameterName"))

    @operations_url_query_parameter_name.setter
    def operations_url_query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5741cb4fe5f25e7b821a05d967c213cffed8e6bdd6f31dab010d2c50867c4a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsUrlQueryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandling")
    def post_request_processing_error_handling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "postRequestProcessingErrorHandling"))

    @post_request_processing_error_handling.setter
    def post_request_processing_error_handling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab710b3c7740742bf67fe9546c4340111f429732b60c42e9b9f45ef5b55731a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "postRequestProcessingErrorHandling", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5740588497139bf7a1021656ba86c9dfa88fd89263aa750349e6b871287b4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3d628d7c3b02dd179e008472a097926b8ebf0b5b680270dde8e0c9c0743e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bca85997d862694e4f7c6981e791cc835f3520b08b5c44fa06f0552b9ef9465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e847c436217b401d556566d6f542bf7d9340778fe0e0368225536f56ff4b23)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify when to compress responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__571c91d6cbe000167e3b4f06a21b46f78037d5db85db1c3b4b855a249f992704)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975e6a176d77f8766445f9cd694c77c4cd99ce9dc35e55096c686596fde2ede4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6c8c40de9f04fb72207a3592d6eb8d1ea0a2f6fe4318cb90902276a3304e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01250a7408dcc25cf22cf9aa844ed5c0b034ad4ae465524e21e7f13a2dd3f0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faa2f393103f5596d8bf4539a0527c9f3060f7d0f4ac1824c06062ec38aab762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f2a8a7d35d292c719aa5ed46f9943096654a041a843da31dcf03f5556822dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74d8c2cc97d8c07f792ad21d025206e977515d67c7d3ebf269c339fdc16bf22)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bd2a0c4e8aa0b56d7b8a6d8aae92e90b179b93e03f46d571171d340eb26273)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caea3cbdbc0d9d4fd4d8fa30cbef1a3a5a348e1cc6e971fc6d1b100385d36172)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67cbad3c5a23a853ab6a906f801d665e63424aac4c6f1b399ab4279cdbe04e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216c8c04e0f9fb3d7364605d924bfa06e8e1f7627cd78b6d3bc99077df3fc1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a1ea473c84b8535297f1a1a23632af9970d2553e2d884d8124dae3c67f791b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57e4f717ddd393635f707cb19dd0b4f7871b688b217f13b964d8c5d813fb2b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215883a091b8959dbdfc412e8808e9cda8517266ad5676b15307e833e037f1f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_reconnects": "maximumReconnects",
        "retry_count": "retryCount",
        "retry_interval": "retryInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9017d649920f0de239f846e88defe2022f0d593713d639d4c44c4d192d724f8e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_reconnects", value=maximum_reconnects, expected_type=type_hints["maximum_reconnects"])
            check_type(argname="argument retry_count", value=retry_count, expected_type=type_hints["retry_count"])
            check_type(argname="argument retry_interval", value=retry_interval, expected_type=type_hints["retry_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_reconnects is not None:
            self._values["maximum_reconnects"] = maximum_reconnects
        if retry_count is not None:
            self._values["retry_count"] = retry_count
        if retry_interval is not None:
            self._values["retry_interval"] = retry_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_reconnects(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum number of times the edge server will contact your origin server.

        If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        '''
        result = self._values.get("maximum_reconnects")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_count(self) -> typing.Optional[jsii.Number]:
        '''The number of consecutive connection failures that mark an IP address as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        '''
        result = self._values.get("retry_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        '''
        result = self._values.get("retry_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e8826e3adf3a3359f035e6f3446a40464f512023ea8861e5c93a3de48d8fbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumReconnects")
    def reset_maximum_reconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumReconnects", []))

    @jsii.member(jsii_name="resetRetryCount")
    def reset_retry_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryCount", []))

    @jsii.member(jsii_name="resetRetryInterval")
    def reset_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumReconnectsInput")
    def maximum_reconnects_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maximumReconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="retryCountInput")
    def retry_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "retryCountInput"))

    @builtins.property
    @jsii.member(jsii_name="retryIntervalInput")
    def retry_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "retryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2cd5d2fd6f991adb463cc9873f34146489b8c0e60d2189c7a6f54203e5acc01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumReconnects")
    def maximum_reconnects(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maximumReconnects"))

    @maximum_reconnects.setter
    def maximum_reconnects(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8b665f8ec08690aa9f91e17686a7acf2ef2e9c6ccffc991b5b528cc50b21a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumReconnects", value)

    @builtins.property
    @jsii.member(jsii_name="retryCount")
    def retry_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "retryCount"))

    @retry_count.setter
    def retry_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc30e4df3f022008980eb94f07ad287464be50d801a46fe16b0e1ed45f0a54a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryCount", value)

    @builtins.property
    @jsii.member(jsii_name="retryInterval")
    def retry_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "retryInterval"))

    @retry_interval.setter
    def retry_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1084f8dadecc524f98ac1ff2f460bc4afdc58fc8718b3f1f93bf3f93dda0d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c2baa71f7bebfe38970838e38293298dc42718d7ce3fb2b0dec0553041f8f69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b53fcd8819f7a49256c094e79d49f8fcd1fe5cf44f3ca8d071d20dd414c777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d446e113cb50b7521710579ca76ffe75d3d849fe6353d83ca168f7e5cb2a6fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding",
    jsii_struct_bases=[],
    name_mapping={
        "custom_extracted_serial": "customExtractedSerial",
        "enabled": "enabled",
        "hash_max_value": "hashMaxValue",
        "hash_min_value": "hashMinValue",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier": "tier",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding:
    def __init__(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2a23c4186580d40fcf67e890f3179600ba052402a84f7ba0516574c5f57330)
            check_type(argname="argument custom_extracted_serial", value=custom_extracted_serial, expected_type=type_hints["custom_extracted_serial"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hash_max_value", value=hash_max_value, expected_type=type_hints["hash_max_value"])
            check_type(argname="argument hash_min_value", value=hash_min_value, expected_type=type_hints["hash_min_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier", value=tier, expected_type=type_hints["tier"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_extracted_serial is not None:
            self._values["custom_extracted_serial"] = custom_extracted_serial
        if enabled is not None:
            self._values["enabled"] = enabled
        if hash_max_value is not None:
            self._values["hash_max_value"] = hash_max_value
        if hash_min_value is not None:
            self._values["hash_min_value"] = hash_min_value
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier is not None:
            self._values["tier"] = tier
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_extracted_serial(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to pull the serial number from the variable value set in the ``advanced`` behavior.

        Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        '''
        result = self._values.get("custom_extracted_serial")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HSAF for Edge IP Binding customers with a large footprint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hash_max_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        '''
        result = self._values.get("hash_max_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def hash_min_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the minimum value for the HSAF hash range, from 2 through 2045.

        This needs to be lower than ``hashMaxValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        '''
        result = self._values.get("hash_min_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier(self) -> typing.Optional[builtins.str]:
        '''Specifies where the behavior is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        '''
        result = self._values.get("tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBindingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBindingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d47d1a268c059b36132dfbb417d70b2f5381b45ea341a0d6d4815e12d7ea84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomExtractedSerial")
    def reset_custom_extracted_serial(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomExtractedSerial", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHashMaxValue")
    def reset_hash_max_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMaxValue", []))

    @jsii.member(jsii_name="resetHashMinValue")
    def reset_hash_min_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMinValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier")
    def reset_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerialInput")
    def custom_extracted_serial_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customExtractedSerialInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMaxValueInput")
    def hash_max_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMaxValueInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMinValueInput")
    def hash_min_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMinValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tierInput")
    def tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tierInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerial")
    def custom_extracted_serial(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customExtractedSerial"))

    @custom_extracted_serial.setter
    def custom_extracted_serial(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1ce2cb4072c6fa45886872d7a0f0eaae3abced4087e63e8deef921e4885512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customExtractedSerial", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca74a8d2a8e9cd6a3c7ab2f49f9a5f26ec24fc9e5b35a84b6c8d84e5b32b373a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hashMaxValue")
    def hash_max_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMaxValue"))

    @hash_max_value.setter
    def hash_max_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fab6dd1de1f6118cc221152997f4e529ac9d72dc717acc4691d645383ac3050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMaxValue", value)

    @builtins.property
    @jsii.member(jsii_name="hashMinValue")
    def hash_min_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMinValue"))

    @hash_min_value.setter
    def hash_min_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea172ee2a41a98d9fdd0d29c13820e6bbb979be04809cd2b47c15313e291e57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMinValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd700bff160e1c7b290aad6a55309ad037896fbd5dbe8602306ae4305b05243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5fbdd9f27aa5053d459141e42f25cfbc96d53a6aeab1dce9f4b31e7fe6c1889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier")
    def tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier"))

    @tier.setter
    def tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e831aaafd709858cf346626bdeb8ec8f8bb36078cce7201ddf809d242000f474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969055a67179881a429e4bb14be4478c5124830aea9867d7525453fc8dabfe8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a829618fda74b007f25df6efb7252576f432ba5dd0604bcda6897d1d58e721e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc3e65307a7e329c26be535f2a650371c283c37bc193265909bb925fb8044653)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__933c3ff009e41cd9c6647842bbc42b354a75eafa4ce4b9a88cae0ce74220c8c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__681d71bcc6e91a86db0ebc825bfdbd557b65b31baaf23c38de648ed930a3a24b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa2341c5a305e0edc22d18d01ee17b77096febcd2e80c456fbd619112e3ecec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464ff6557b50d913f9df4a1cabf7feab0993729308fd3fcfa777761c680c169c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb271fada17c332493e5b6a298ef838c1055c5859a50b9e32cfae23a8f96702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__427198335b9577777e84e04163501cf6b719c91b58e2cb3fa204095be222387c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d102b623dedd36de1e94f740c2d65761838bf0a126f6bf1a0e1d06441627af8)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables HTTP/3 connections between requesting clients and Akamai edge servers.

        You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54cb1c1506dec74cc19752c03ae64a7dcbda330a0d55e4d378e2e2f2c87e938b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__635c3c2ccdc09521d8ec49bd26698446e2d1f0e10690faa67bbdebcf9f0de913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6bc5507c4b82e8c4206711c5dfc8519c4384ab1868eb1394a03e2e67aef1f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bc69965d8089978ec11042b2277418b6b335a6434065213fad6e8ec60ba547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d331e55f3084e60897acd24bb852166bf026e4d46fc38c9faad4302fcaf925a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09494caccdc5fe57889f16e250608f01ed739de002876ddb420a639bba041a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "include_sub_domains": "includeSubDomains",
        "locked": "locked",
        "max_age": "maxAge",
        "preload": "preload",
        "redirect": "redirect",
        "redirect_status_code": "redirectStatusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d274107f2a2befbad5bcd5a3986a8c0e72d1033c982ed1de83c5da8e7976233)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument include_sub_domains", value=include_sub_domains, expected_type=type_hints["include_sub_domains"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument preload", value=preload, expected_type=type_hints["preload"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirect_status_code", value=redirect_status_code, expected_type=type_hints["redirect_status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if include_sub_domains is not None:
            self._values["include_sub_domains"] = include_sub_domains
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if preload is not None:
            self._values["preload"] = preload
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirect_status_code is not None:
            self._values["redirect_status_code"] = redirect_status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies HSTS to this set of requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def include_sub_domains(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies HSTS to all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        '''
        result = self._values.get("include_sub_domains")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration for which to apply HSTS for new browser connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        '''
        result = self._values.get("preload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects all HTTP requests to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies a response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        '''
        result = self._values.get("redirect_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44815e8b4c28191d70149dc1cccdfc8fd9163f91c916f8109d74feb7fc8a004e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetIncludeSubDomains")
    def reset_include_sub_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeSubDomains", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetPreload")
    def reset_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreload", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectStatusCode")
    def reset_redirect_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="includeSubDomainsInput")
    def include_sub_domains_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeSubDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadInput")
    def preload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCodeInput")
    def redirect_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e254309a5e850fd09b1b8c1ad0ef26b113780978c4848c501bdf1c7d5ea86e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="includeSubDomains")
    def include_sub_domains(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeSubDomains"))

    @include_sub_domains.setter
    def include_sub_domains(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c2fae5c9880d92adef5e17a39e241ecc87ed1097a84dbef23b3b9b11a6397d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeSubDomains", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed88c86071c1e9733aeb67c5cfd65920978c9b9e19eeb7e032a3d71d2d709d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14815d38e73c4c6abfe1395e06e7ce7b73aedd23a915ee7fe703b1a88f6eaedc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="preload")
    def preload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preload"))

    @preload.setter
    def preload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69d1ef02b5285b7b559113bc53872eb4ee682680ae6d84a804219ad4ce99ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preload", value)

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirect"))

    @redirect.setter
    def redirect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258df6ad7aa75ca3d65f3ec7c046bc6ee1e1b18166d9deb0959a1e3694f71370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirect", value)

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCode")
    def redirect_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectStatusCode"))

    @redirect_status_code.setter
    def redirect_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082b9d7d43706482a9f7f3888f75cd6cc5db24ec5284fa81a12d9f1db823c322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d1d82dc16acb3a6437df1496ab1b4a996760c36e527ee06a76786ded26bd9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10d51bf7b8c422f1b20d762c1e0c24630d0282ba67c7d3ae8b49332b87d3b07a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412dfc71eb98d08887c93888b6cc40f7c3690f73bd7dc9165e8dde46623e8156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "upgrade": "upgrade",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec76cb285b0d4ebf4ae2db64bb3cc0d980339e24871bd635cff88c435206aea)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upgrade", value=upgrade, expected_type=type_hints["upgrade"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upgrade is not None:
            self._values["upgrade"] = upgrade
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upgrade(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        '''
        result = self._values.get("upgrade")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8972dd006da76507361d14bf380e7514e96fb7f0322e65310332a5b32b32cae4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpgrade")
    def reset_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpgrade", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upgradeInput")
    def upgrade_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b2a24a3c144e4901266bb1206d67abcf8093ee2093b448905976288cca0868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e0605333d8644e61717102a2462d7fb8d7757604034c4125b74aab3aba0c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upgrade")
    def upgrade(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upgrade"))

    @upgrade.setter
    def upgrade(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d0c9590346c2dc4786cea80bb318c9386acfdfb1a6de65efa680153b4eec6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upgrade", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d230ae2e04d2f3187c68272af2fb93ace5f30376829d50fe559a1fc1f9eceb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2ce4c7e6df3aefbf6aa7ddc37eaf3315ceef3bc797497a8fbf61494f4b9463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride",
    jsii_struct_bases=[],
    name_mapping={
        "dpr": "dpr",
        "dprvar": "dprvar",
        "exclude_all_query_parameters": "excludeAllQueryParameters",
        "excluded_query_parameters": "excludedQueryParameters",
        "format": "format",
        "formatvar": "formatvar",
        "locked": "locked",
        "override": "override",
        "policy": "policy",
        "policyvar": "policyvar",
        "policyvar_i_mvar": "policyvarIMvar",
        "policyvar_name": "policyvarName",
        "template_uuid": "templateUuid",
        "typesel": "typesel",
        "uuid": "uuid",
        "width": "width",
        "widthvar": "widthvar",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride:
    def __init__(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd89813a7d29d7ac964bc6a5a808600e24be896c929a1540fc6443ead24246ff)
            check_type(argname="argument dpr", value=dpr, expected_type=type_hints["dpr"])
            check_type(argname="argument dprvar", value=dprvar, expected_type=type_hints["dprvar"])
            check_type(argname="argument exclude_all_query_parameters", value=exclude_all_query_parameters, expected_type=type_hints["exclude_all_query_parameters"])
            check_type(argname="argument excluded_query_parameters", value=excluded_query_parameters, expected_type=type_hints["excluded_query_parameters"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument formatvar", value=formatvar, expected_type=type_hints["formatvar"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override", value=override, expected_type=type_hints["override"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument policyvar", value=policyvar, expected_type=type_hints["policyvar"])
            check_type(argname="argument policyvar_i_mvar", value=policyvar_i_mvar, expected_type=type_hints["policyvar_i_mvar"])
            check_type(argname="argument policyvar_name", value=policyvar_name, expected_type=type_hints["policyvar_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument typesel", value=typesel, expected_type=type_hints["typesel"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument widthvar", value=widthvar, expected_type=type_hints["widthvar"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dpr is not None:
            self._values["dpr"] = dpr
        if dprvar is not None:
            self._values["dprvar"] = dprvar
        if exclude_all_query_parameters is not None:
            self._values["exclude_all_query_parameters"] = exclude_all_query_parameters
        if excluded_query_parameters is not None:
            self._values["excluded_query_parameters"] = excluded_query_parameters
        if format is not None:
            self._values["format"] = format
        if formatvar is not None:
            self._values["formatvar"] = formatvar
        if locked is not None:
            self._values["locked"] = locked
        if override is not None:
            self._values["override"] = override
        if policy is not None:
            self._values["policy"] = policy
        if policyvar is not None:
            self._values["policyvar"] = policyvar
        if policyvar_i_mvar is not None:
            self._values["policyvar_i_mvar"] = policyvar_i_mvar
        if policyvar_name is not None:
            self._values["policyvar_name"] = policyvar_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if typesel is not None:
            self._values["typesel"] = typesel
        if uuid is not None:
            self._values["uuid"] = uuid
        if width is not None:
            self._values["width"] = width
        if widthvar is not None:
            self._values["widthvar"] = widthvar

    @builtins.property
    def dpr(self) -> typing.Optional[jsii.Number]:
        '''Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        '''
        result = self._values.get("dpr")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def dprvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired pixel density.

        The variable specifies the same type of data as the ``dpr`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        '''
        result = self._values.get("dprvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exclude_all_query_parameters(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to exclude all query parameters from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        '''
        result = self._values.get("exclude_all_query_parameters")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def excluded_query_parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies individual query parameters to exclude from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        '''
        result = self._values.get("excluded_query_parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def formatvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the name of the browser you want to optimize images for.

        The variable specifies the same type of data as the ``format`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        '''
        result = self._values.get("formatvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override(self) -> typing.Optional[builtins.str]:
        '''Selects the type of query parameter you want to set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        '''
        result = self._values.get("override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''This selects the desired Image and Video Manager policy name directly.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        '''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired Image and Video Manager policy name to apply to image requests.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        '''
        result = self._values.get("policyvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_i_mvar(self) -> typing.Optional[builtins.str]:
        '''This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        '''
        result = self._values.get("policyvar_i_mvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_name(self) -> typing.Optional[builtins.str]:
        '''This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        '''
        result = self._values.get("policyvar_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typesel(self) -> typing.Optional[builtins.str]:
        '''Specifies how to set a query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        '''
        result = self._values.get("typesel")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[jsii.Number]:
        '''Sets the image's desired pixel width directly.

        If the Image Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def widthvar(self) -> typing.Optional[builtins.str]:
        '''Selects the variable with the desired width.

        If the Image and Video Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        result = self._values.get("widthvar")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52bfffcd65130950aa11597e458d1059d3c84b53ce6a69daa3d04650c2dc7f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDpr")
    def reset_dpr(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDpr", []))

    @jsii.member(jsii_name="resetDprvar")
    def reset_dprvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDprvar", []))

    @jsii.member(jsii_name="resetExcludeAllQueryParameters")
    def reset_exclude_all_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludeAllQueryParameters", []))

    @jsii.member(jsii_name="resetExcludedQueryParameters")
    def reset_excluded_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludedQueryParameters", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetFormatvar")
    def reset_formatvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatvar", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride")
    def reset_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetPolicyvar")
    def reset_policyvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvar", []))

    @jsii.member(jsii_name="resetPolicyvarIMvar")
    def reset_policyvar_i_mvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarIMvar", []))

    @jsii.member(jsii_name="resetPolicyvarName")
    def reset_policyvar_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTypesel")
    def reset_typesel(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypesel", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthvar")
    def reset_widthvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthvar", []))

    @builtins.property
    @jsii.member(jsii_name="dprInput")
    def dpr_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "dprInput"))

    @builtins.property
    @jsii.member(jsii_name="dprvarInput")
    def dprvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dprvarInput"))

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParametersInput")
    def exclude_all_query_parameters_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "excludeAllQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParametersInput")
    def excluded_query_parameters_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "excludedQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="formatvarInput")
    def formatvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatvarInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideInput")
    def override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvarInput")
    def policyvar_i_mvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarIMvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarInput")
    def policyvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarNameInput")
    def policyvar_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeselInput")
    def typesel_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeselInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthvarInput")
    def widthvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthvarInput"))

    @builtins.property
    @jsii.member(jsii_name="dpr")
    def dpr(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "dpr"))

    @dpr.setter
    def dpr(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81596ca12a5df9ff7701b3e20157976fb30faf8291974e361f5477525ee76851)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dpr", value)

    @builtins.property
    @jsii.member(jsii_name="dprvar")
    def dprvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dprvar"))

    @dprvar.setter
    def dprvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6aa6618551bec4ea296103f09cf6b9a5c487a404966f16e2d79c3db9b28e72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dprvar", value)

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParameters")
    def exclude_all_query_parameters(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "excludeAllQueryParameters"))

    @exclude_all_query_parameters.setter
    def exclude_all_query_parameters(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da817944ce50a9d45181efd3ae6642ab8245b8ea06b73f3540394d4c980dee4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludeAllQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParameters")
    def excluded_query_parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "excludedQueryParameters"))

    @excluded_query_parameters.setter
    def excluded_query_parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27255cf52ab4c361d921c49f3b13e8ca3b583370c288f0c5ba72ac5d38f57f3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludedQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473b69de4daf024618343204b390845b6cc967b398bbd4b75781cc44d56c29ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="formatvar")
    def formatvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatvar"))

    @formatvar.setter
    def formatvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a96c1faa39fb2eba9f704848b1bd8c58cec187ed6d045bbf7ee6619cd1c3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatvar", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459514a71f15769a2a74cc331d5b52d283944a640e786316a7e362b333277c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override")
    def override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "override"))

    @override.setter
    def override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5653ddc804ab02acdb8240dc85d6bbe691efe1ef9dc9222afeb142b09a3e9a55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65bdbcdbfbe0e115241fb3c313435073ff175684dcf16e8a5bc7941480f263f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="policyvar")
    def policyvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvar"))

    @policyvar.setter
    def policyvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f6e69299754dd814fb2af44f4915f6b47dba920037a393ecefe69a2183751d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvar")
    def policyvar_i_mvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarIMvar"))

    @policyvar_i_mvar.setter
    def policyvar_i_mvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd9a2acdee63fd53a094daf3c60b5de59896de0066c57e6bc85acfb40ee93d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarIMvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarName")
    def policyvar_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarName"))

    @policyvar_name.setter
    def policyvar_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a48b0ab9be7f48db5cbf9f45a155b601cc23c4f69e5527f327adccdd4c1ec405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd85587f7b20c13858797781998242de6fe70164feb436ab2ad2f342e80073d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="typesel")
    def typesel(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typesel"))

    @typesel.setter
    def typesel(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde214750c51f3a9e989dc9b099c961223da2d324cdec61817c8139823a1a57d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typesel", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7f2029f2cd4c91a1542e1f7d7927493b4c8943c84f4389fa83bad3ddaa05a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "width"))

    @width.setter
    def width(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96cab7eeb8d1ad06e586c02716af9edb5edbb4deb193ed9a555f83902a17a4ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthvar")
    def widthvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthvar"))

    @widthvar.setter
    def widthvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03557c1676cf9051338a6ac0ab40507046327232d31265e04bd4170ba107df02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthvar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e330b95002ebccddf2c09f8b708ffb39a97f8f83dd5edd3d2079d5841a17befa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager",
    jsii_struct_bases=[],
    name_mapping={
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "image_set": "imageSet",
        "locked": "locked",
        "policy_set_type": "policySetType",
        "resize": "resize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "video_set": "videoSet",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager:
    def __init__(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a72e88fb5f1940373966e7f6b00f97f52f8eb679c6092c049ecda664e0964a8)
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument image_set", value=image_set, expected_type=type_hints["image_set"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set_type", value=policy_set_type, expected_type=type_hints["policy_set_type"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument video_set", value=video_set, expected_type=type_hints["video_set"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if image_set is not None:
            self._values["image_set"] = image_set
        if locked is not None:
            self._values["locked"] = locked
        if policy_set_type is not None:
            self._values["policy_set_type"] = policy_set_type
        if resize is not None:
            self._values["resize"] = resize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if video_set is not None:
            self._values["video_set"] = video_set

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.'''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.'''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def image_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.'''
        result = self._values.get("image_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.'''
        result = self._values.get("policy_set_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.'''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def video_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.'''
        result = self._values.get("video_set")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c8b527691f439dce9ac21022769ebd992befeee0e28a7851ef2982d2ab4db9)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531b0593f5b516425f34b5b2dc01d2cf09d3dd852d8f4b25dd273d079ade2745)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c375bc0a2dc801a7cf82fa74d8c9ac8cae0b12b4e6ca0678382139cf9707f67b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d092a3359a8e9f4a2272e2a18516c95b12ea0ab962cf63ef0cddd91e1f48b5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5faaea4a75dee34c5c7e6a7fee2a735d7c2c6395456b706fd5e9ddf328c9041b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c52025c9967b65c4ec401b34ada4f5cba32ffff8c5fb6251443651c8da2600c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1c03fd0b377de194513b25efa8896aded51a96bed46977c1de448fd9c74511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b839f931429ac01bba976f9b1bc7c08f72abd568b35278b5bf3d9aa8d3db67f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8926527de350a37b8eef9a16d1c3ea45ddaed7f899a74a6dbbb22cf53ee148e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b309d1092a4b806b038022eb81e2548d20ecbb8637d070d0d4af2f9b1c3b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a1cc7a63f78bad7222087757d26dc6b23418390506df6e47bd3e2ad99e92250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11b44146eb4ddb8c58b85ec99e053766010d07d995978cb62e43cb77773196f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a032f2dbd292c1732fd2f91bef192e40e8f0054dce3fe8d01d908079ebb82e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745f0ac002046665449c6049bd711cf0667c6f70409a3e6c92464525afe4afab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684a04ab4077f8bcdddd901332be275a462323540114e0d0b211ead9672ccea8)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37ad1bc7faa5ebf8cde542abe3c57e6260c1255465d7a4a61746d523ff9ac7a)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f496b5582b299abf1d68d952e2a291cb90829c17b77850e86f35cf1717277520)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ce4ba3a6293ccd500c9931839a2bcfe22f749da688d1354815730e07de2d5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45b5c2565ebfeb8d1a008e4ca1197f182b0e2bdeb14bd8ab7969d1a718971de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588ae0f082c205a30828e1e17fa481f57eacac789704ae2852d98cbf6cabfd0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f91f682c49b91219464d6f20a0a96180ef3cfa687d8007408c8cdb345f9f880c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aafbdd75a2e0633e91f2c6c6c59a137ae424b19f1c6a64274ac30f02b342a01f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ce8109da65dae6076f88bf11e3e8a28772fc904c0976b01669336656b557dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa604ddf06333f54845ac5c7f8b2dffd1e5703682d98b40476098bb948f3b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8cbc138554d5fdba94e6b544a29e202fd937f360ccfbc45732aa772ba758b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e09c61acd30b20b06b93f9502c8b11c4db4501b384a8b72441226f89c9aa492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78dbc88ce1fce5d57984e7a683fea2793c094c2ca739739b8d020abc7e05ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36d2e5f4fc0d491ff1854ea6363784293045e15ccdf63b6715ef5256e4b24eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5169a1413c0fce7bd05d9cd8837c6cb4eff56b3f519773fd4d9253b7caf335)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetImageSet")
    def reset_image_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageSet", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySetType")
    def reset_policy_set_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySetType", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVideoSet")
    def reset_video_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVideoSet", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="imageSetInput")
    def image_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "imageSetInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetTypeInput")
    def policy_set_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="videoSetInput")
    def video_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "videoSetInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a72c34a1a66326cec92fcbb169376152c15bb56ac3f68c4779fa4d59d98b34c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eddb352110b3997634d21663b4001366aa70701e082149369a9e08fc992c485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="imageSet")
    def image_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "imageSet"))

    @image_set.setter
    def image_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f84814deee19ec11b2471d0ff365f380c637eb011e2774f7887637aa1b2f748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageSet", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de056229d0c76e8a2fb57a35732a3e729c000fb999c1737cd22c93cb837881b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySetType")
    def policy_set_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySetType"))

    @policy_set_type.setter
    def policy_set_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9821a06445eb4ab2c243cb38833b64d510050418b0408d79ea77e2822f68e9a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySetType", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d54982da16e3ea3adba01d0247def6adeb158019eb0345c2348a1b5e42f3712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a43d60126cccceb209a6f33a744674638cf11c59bdf98fce3c5f27919729f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd790024a4a72a0ea7acc57513bea004956f17ea01fe272abeb350bade0b9896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="videoSet")
    def video_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "videoSet"))

    @video_set.setter
    def video_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c3796f64f733fa82eebd898e4becff94b2e2a4c1cd968e3c52d8c1b93afc71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "videoSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ae154327eb9a13db2c88e05cda45fd4b28e39d5aa4c2cfc41f39af62eeafe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad962fb7ad76addfd318506c1bf53828633a1117e552c4d0af227d2d439abe77)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images.

        The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file.

        This produces the smallest file size possible that retains image quality.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable image management capabilities and generate a corresponding API token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters.

        If you don't specify a label, ``default`` becomes the prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        The ``advanced`` option needs to be inactive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.

        Note that enabling this may affect screen layout in unexpected ways.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9199b5ca6014af92fe8005985c0d71aa369c76b5a4815fdcaaf1348690760feb)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5a61d07617649f64c088c32ab5913392233924cca49410cba20a769d3e113e)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be73304711198b018ec0f4812c965e3ea8d834a71a6c1d516df9da98d0009c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ebedb0c1487fb136c63386e2e8ad7d3a88437b35bad880b6527c2bc7ce941eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6a68a0cacdbabf2e6121120b96ab6cf9af7a70fbc278e7fbd7bf7c0cbd6f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f961db8b2dcc6c8369b001e351aebd3c6722f5f4fb04a8fecb97dd3f10b392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df34d51783997bee0765f2e4d42ace5decd254ba1dff8e95acf3f0aa72f3cf7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ca03581e3f56216470a2f7d1370a1efc0412c85c3a48340e026ca38f61d65e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06216c0cf7d36f204c37d468fa762618934cda67edd1099a7a22ffe5c218cd77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c830f652a72f4f96f8ce062d42ac5b4c4177d5451c5162191a8171203fa5f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99f1a3273bb4f86e734d4788a23360c1114b39c8992757a042872a2d2f01ac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ef58935aa795173045233722c3ed10e68e975579e30601a42beea1e2752bb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384ab8f65ec9167c3dc9990a1eb754a04b4c606674f6e2bdc7066f7de1ccecb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d7c9762b15d95f0eb36de798b4aa7ee6d83ed8a6fce23d0b4be83759cbfa87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d726778ea9f4fa870c6558569a9d753ceb3749a3655bd51c30ebd5e4b5d9f0c6)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2a9b518b63fa3c2f04ed81a18a9e10d4445fb7650b010f9ab60cc274c14f85)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3080b0d5a9d4e6802c539c7743f0d4bbfbe890aeb023ecd06256bc190471d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c1bdd5edf29978657c315256e5179caa2588f90620bfaab0ccdba45b52b3392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d9163edd32c7d626cac23b412445e4765b354bc6ca0e96a74b97826bc970f6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75066303f75c6a1ceb7d168e9886a65fc1b1588ab2bb858b3cafb05a46b6f948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02080aa73b762941430dc13e9a9c98a11185f7f7b1338586af17ed53dcb66cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be95cb90e5fb82e0605c042bc3b6ce33b571e676ab2afaa74dacc73af830a63)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68915cd1c0a6a113a2c186fa5dcb6a331ac6fff4d3b3c1210b166dfd64be9eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba672e67b1a6e4c1b4c243c28e468822edad5bd20766adf0dc6fe96540ab6dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56bf7c44a68ac81e5f32d6b8e592a7bd0b289ac46b4ffed8bc5a698942c33225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41024d2625ff4118b329ecd3beaf554a8e17454140eb6e60e22fd5fd8657ffd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465702c33f59a6b8a75267a3e7e9cb7562ccf14af0f04b14bcb38e22b6166b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba500be2405cfcc867a66099793e2efc3a8c4a7289c87420c1fbe0dd9d49e2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f957ce5add30b6549b2dfcaff8b4e67eb3191142ef7881145f0ad4014ca9e09d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__486f3c8bcfe35bca98a6c350fa17c0a97f7512dda42d7c43341f00e309e35192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c9874da5088767c52bfd21c5a71ab6817f170c7c8dabf0eaa2035585ea7b45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f3faf3bf38cf17c81c43c56301a149506286d2488e25ff8f2519465f83f5a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb7ad45f45ee1866cd1b96b8ce9392d00fd9931e3fa4b384f0c218bdf0f7248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb5dea7dd4b40373f5ce091e0c7e9b84bddb6f97b0526076d83d1c6c750e0015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__182148952808b7e5e778f420df5992a2156e1f78f59e6c7506bef3b555437ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23f7bcef6f3f1c6a03953334f70de8968a31bde22c9a9bc1619ca9b1e180b27e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa8e80b7d6f2695c1615868639c3d89cf16a88d768e80a5a1ab1b171cc75d6ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5a1493a0616799c2ebb6a310554bb7df22209dab799288974c31a3ebe6ed94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d283285c8bab3a814442cf31303f934243ee73f84d003c5bdb993c2fb7065f62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__402d64ad890bc2f36f00b675295657c2174493ba8cb75fca0fedc9796d103dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ecd9dfab533c8520f16393415aa86d77ed4618e9e16dc6802898f5c41a428f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3097dce73df8b9519266981d55758fc2e1486fa6afdec3559099e775016121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3101bdcf8f5f18ac2daea4dcb1c7d498b9c271952326abee19b637db98ae02a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85da73db19f1db92d89657ab59556c75f709c75635d433e933684b7d35161d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949587feb03cbcb1d43af67ceca4848c8353fd722e253ed22238fcec83bf2ef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0740c88e635b2a3ee7cdcad9aa2f0c5e5ce358c8103ced812e66ab21c0b2472f)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, applies a single standard policy based on your property name.

        Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, automatically converts videos to the best file type for the requesting device.

        This produces the smallest file size that retains image quality, based on the user agent and the initial image file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Image and Video Manager's video optimization to the current content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``.

        The policy name can include up to 64 alphanumeric, dash, or underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''To optimize caching, assign a region close to your site's heaviest traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229fa7684e6c1eddbcb78a44f2859e45ad4b712650aa4252f1fe20d62cdf6314)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__858411bf7fa1cdd6f89309fcaa5c9a20f2d94d1d1826e4974da42bbdfa48f38b)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f3e2ff83f7799419ee5240211eac5c6a7e6254ee5e0802e7fb7bc34e204a0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd19cb0dc6372f3c24f3bcaabc4f6c292291b103870ba7b11b39a161e02f735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6280536ef9268380dd49c8f6c8e166cf254fe04bab0e25b631ba98b98348fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25833e89c8eaeb470118f0c0c5d206844033304c28825381728421a37cb333b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a91c6f4fde07d6c0b9e114f4ff1a622c29313576a34979cecdaa9f03f4acee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710b88b6269506509079583fd5272c667888a04334899710eab68d0fe611e33c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81fbf38602ac56180a1afc5ac59a687809a22d5d6656f1f551083f674dcbd0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e9e300d041c72907a519d56b67e187276655ae29c44334c931435e93f103aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8c241348a3e455880acbcde985de74702be7d7f6a47b5d6ac8e113be75d996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ad6f2f411d5eb09693bc27ba2ffc6e36c4052342b1d711316e5be9c12797ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb9fd7b2a6e4541f3989b62e6e8116231d1f882bf2a486ea5633dce23aa4cd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4462b0abd0fa54b45aed2f799994da89bb16e46f556ef6fcc077dd0e1294f9d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c677640a80966eeaaef81aab78b56ad619a5fee5c8cd91afccc09eabfd44210)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2fcd2d30078d37ca2cb37a3ba5888004dd33341c18e153fc095276cb2c72032)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05f912e3e1be41b3794d6b91ba7bc48dac6d0405ff600236309daa15c05f1d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8202397879f949fa9113f2e17fe00351504dab844274cd0ea3abd96977cd127f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264c954279379af9348d7ec76064b1308fb8ed4646a9a39a28909d97eda0e055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38cd55cf59c474b656e9fc5ecbf338251e6da3edd62edfd904bfb629c2ae460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f74dac2cc49ad3f02b14972aaba89e7b7581db66d86e61ef2d759928791058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9dd953d1806d26854e8f9292149772e30ac3ed188e2e6406ba447ba63b5aa1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974d3aa0f3cbdc23291823c3053a0144105f893ab50ef4f62eb98d89fdd60d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ad3b5445fd84f27e614e83bf239241f7f13b38ce5a7fadc751b8562876250a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ffc986ee0e08508d927e1a339677b0ff9075bc8ea21532f96637114ce11dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f8b2510d104f6eb028753d750d7a1c9636ba0edffaf16b3ac4b354dbb3d4358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6cecb333a4836f5041063980d4ec4b1b2f862b0a46e7734dabe009cbd882fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4bb8542e57e606c977e5112e5abd675fed4bbd1bbf6b38041e08cc9ab01efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b67ce1b73443eade1c4185250c341513e8425cfad67cd51b3ae9d610d8ecfc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8682427f3babd98afe584ef8e28daeb044bd7ef72565738c5268fdea51e12e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a023c385822aa106dfc6dd7018d196a2505f917e75463fda8f39fdc1ce695717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e110fd913feaadc02de86d5cc2297a088c2dddebf72e6df6d8b61173c80c8c72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39edebaf2ed43520438b6e9586a3678a4c23c7c11f5922b709eb5e4613cd8818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07628eb5290d24453074a4950467c0a2f769536112db767f7fbad59ea580928b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c994553b419f463dd03770c2f8cfcef7e984de8118d50a5c8c2d1f2a5c6e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170f86614ff55ddf0fb4edcc164bf56e1e77a673cae3aab5e25def027c2a3f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d26a938f41aef8c989fd8ebd511b35d588325959ae6b5c2a988ea6560b3f815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31fd8355e90c9a0a1d083deef99fd5fd02bd3dc2f5c21c2890bba1a2105e554e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57808553527b7481116825e0e164f28a97270aef48f8b2486de47f608ad863dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a3602c2424e0bd26a3ce9359ca634f5943e7aafcffd8a1c8dd76e7109ba7b45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7799cf09d5f50468ab0cbd80711c04098271afbcfa224c8d592b5eb68bd2c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__027e3eabcee2bd236b49ee53e31b8b677a2678c18bb5ff485264f51666a4d549)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f2804d29c2c10deccad59c77ea907bb90582487d6935978711e72cac1f8f23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf9fcfe155ce559711e01420a4dab485552c6e5559ae3cd7285a30e642f3506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034e6c049d1fc1580c218e9ccb46370df4b887c17a76894196b04d7e428ab39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude",
    jsii_struct_bases=[],
    name_mapping={
        "id": "id",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude:
    def __init__(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961e2aeba79c11df100cc9e5c4adb51ef3efff633a47cfc1138e613ea5733479)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Identifies the include you want to add to your rule tree.

        You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorIncludeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorIncludeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fabd2bc07a9bd363218f0f56fc12d03c063d6727829b3ae33778dc5a3c5fc67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3875b77fc572f0e3e895e237689eb88c6d9eca528266f67854bc73e1cb9a496b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5302b5b8f4e7b5e9190f0023e764fa780098a18b62e7b9e4b86c852e868ee2eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3a17aa8bbbb2b0969a83ec501c7e2f28dd3877732c124c15b259a98148b03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ab6b02a3e35dfc0ff09beceaca727229ce457036d3c26c01404daee3173340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3169bceb5062714bb51185898fb7af32099092b7b0e7b5d45c7f69ae67a75380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation",
    jsii_struct_bases=[],
    name_mapping={
        "allow_large_post_body": "allowLargePostBody",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "failure302_uri": "failure302Uri",
        "label": "label",
        "locked": "locked",
        "penalty302_uri": "penalty302Uri",
        "penalty403_net_storage_path": "penalty403NetStoragePath",
        "penalty_action": "penaltyAction",
        "penalty_branded_deny_cache_ttl": "penaltyBrandedDenyCacheTtl",
        "penalty_net_storage": "penaltyNetStorage",
        "penalty_threshold": "penaltyThreshold",
        "penalty_title": "penaltyTitle",
        "reset_on_valid": "resetOnValid",
        "template_uuid": "templateUuid",
        "user_identification_by_cookie": "userIdentificationByCookie",
        "user_identification_by_headers": "userIdentificationByHeaders",
        "user_identification_by_ip": "userIdentificationByIp",
        "user_identification_by_params": "userIdentificationByParams",
        "user_identification_key_cookie": "userIdentificationKeyCookie",
        "user_identification_key_headers": "userIdentificationKeyHeaders",
        "user_identification_key_params": "userIdentificationKeyParams",
        "user_identification_title": "userIdentificationTitle",
        "uuid": "uuid",
        "validate_on_origin_header_name": "validateOnOriginHeaderName",
        "validate_on_origin_header_value": "validateOnOriginHeaderValue",
        "validate_on_origin_response_code": "validateOnOriginResponseCode",
        "validate_on_origin_with": "validateOnOriginWith",
        "validation_title": "validationTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation:
    def __init__(
        self,
        *,
        allow_large_post_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure302_uri: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        penalty302_uri: typing.Optional[builtins.str] = None,
        penalty403_net_storage_path: typing.Optional[builtins.str] = None,
        penalty_action: typing.Optional[builtins.str] = None,
        penalty_branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        penalty_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        penalty_threshold: typing.Optional[jsii.Number] = None,
        penalty_title: typing.Optional[builtins.str] = None,
        reset_on_valid: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        validate_on_origin_header_name: typing.Optional[builtins.str] = None,
        validate_on_origin_header_value: typing.Optional[builtins.str] = None,
        validate_on_origin_response_code: typing.Optional[jsii.Number] = None,
        validate_on_origin_with: typing.Optional[builtins.str] = None,
        validation_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_large_post_body: Fails POST request bodies that exceed 16 KB when enabled, otherwise allows them to pass with no validation for policy compliance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_large_post_body DataAkamaiPropertyRulesBuilder#allow_large_post_body}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Applies the Input Validation Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failure302_uri: Specifies the redirect link for invalid requests that have not yet triggered a penalty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure302_uri DataAkamaiPropertyRulesBuilder#failure302_uri}
        :param label: Distinguishes this Input Validation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param penalty302_uri: Specifies the redirect link for end users who trigger the penalty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty302_uri DataAkamaiPropertyRulesBuilder#penalty302_uri}
        :param penalty403_net_storage_path: Specifies the full path to the static 403 response content relative to the ``downloadDomainName`` in the ``penaltyNetStorage`` object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty403_net_storage_path DataAkamaiPropertyRulesBuilder#penalty403_net_storage_path}
        :param penalty_action: Once the ``penaltyThreshold`` of invalid requests is met, this specifies the response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_action DataAkamaiPropertyRulesBuilder#penalty_action}
        :param penalty_branded_deny_cache_ttl: Specifies the penalty response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#penalty_branded_deny_cache_ttl}
        :param penalty_net_storage: penalty_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_net_storage DataAkamaiPropertyRulesBuilder#penalty_net_storage}
        :param penalty_threshold: Specifies the number of invalid requests permitted before executing the ``penaltyAction``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_threshold DataAkamaiPropertyRulesBuilder#penalty_threshold}
        :param penalty_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_title DataAkamaiPropertyRulesBuilder#penalty_title}
        :param reset_on_valid: Upon receiving a valid request, enabling this resets the ``penaltyThreshold`` counter to zero. Otherwise, even those series of invalid requests that are interrupted by valid requests may trigger the ``penaltyAction``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset_on_valid DataAkamaiPropertyRulesBuilder#reset_on_valid}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by specific HTTP headers on GET or POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: When enabled, identifies users by specific IP address. Do not enable this if you are concerned about DDoS attacks from many different IP addresses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by specific query parameters on GET or POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: This specifies the cookie name whose value needs to remain constant across requests to identify a user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: This specifies the HTTP headers whose combined set of values identify each end user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: This specifies the query parameters whose combined set of values identify each end user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param validate_on_origin_header_name: If ``validateOnOriginWith`` is set to ``RESPONSE_CODE_AND_HEADER``, this specifies the header name for a request that the origin identifies as invalid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_header_name DataAkamaiPropertyRulesBuilder#validate_on_origin_header_name}
        :param validate_on_origin_header_value: If ``validateOnOriginWith`` is set to ``RESPONSE_CODE_AND_HEADER``, this specifies an invalid request's header value that corresponds to the ``validateOnOriginHeaderName``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_header_value DataAkamaiPropertyRulesBuilder#validate_on_origin_header_value}
        :param validate_on_origin_response_code: Unless ``validateOnOriginWith`` is ``DISABLED``, this identifies the integer response code for requests the origin identifies as invalid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_response_code DataAkamaiPropertyRulesBuilder#validate_on_origin_response_code}
        :param validate_on_origin_with: For any validation that edge servers can't perform alone, this specifies additional validation steps based on how the origin identifies an invalid request. If a request is invalid, the origin can indicate this to the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_with DataAkamaiPropertyRulesBuilder#validate_on_origin_with}
        :param validation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validation_title DataAkamaiPropertyRulesBuilder#validation_title}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy(**cloudlet_policy)
        if isinstance(penalty_net_storage, dict):
            penalty_net_storage = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage(**penalty_net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eb728d6e120798b8090ed97efb7385a8f1eb7503a97415c59d082d3cabcb253)
            check_type(argname="argument allow_large_post_body", value=allow_large_post_body, expected_type=type_hints["allow_large_post_body"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failure302_uri", value=failure302_uri, expected_type=type_hints["failure302_uri"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument penalty302_uri", value=penalty302_uri, expected_type=type_hints["penalty302_uri"])
            check_type(argname="argument penalty403_net_storage_path", value=penalty403_net_storage_path, expected_type=type_hints["penalty403_net_storage_path"])
            check_type(argname="argument penalty_action", value=penalty_action, expected_type=type_hints["penalty_action"])
            check_type(argname="argument penalty_branded_deny_cache_ttl", value=penalty_branded_deny_cache_ttl, expected_type=type_hints["penalty_branded_deny_cache_ttl"])
            check_type(argname="argument penalty_net_storage", value=penalty_net_storage, expected_type=type_hints["penalty_net_storage"])
            check_type(argname="argument penalty_threshold", value=penalty_threshold, expected_type=type_hints["penalty_threshold"])
            check_type(argname="argument penalty_title", value=penalty_title, expected_type=type_hints["penalty_title"])
            check_type(argname="argument reset_on_valid", value=reset_on_valid, expected_type=type_hints["reset_on_valid"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_identification_by_cookie", value=user_identification_by_cookie, expected_type=type_hints["user_identification_by_cookie"])
            check_type(argname="argument user_identification_by_headers", value=user_identification_by_headers, expected_type=type_hints["user_identification_by_headers"])
            check_type(argname="argument user_identification_by_ip", value=user_identification_by_ip, expected_type=type_hints["user_identification_by_ip"])
            check_type(argname="argument user_identification_by_params", value=user_identification_by_params, expected_type=type_hints["user_identification_by_params"])
            check_type(argname="argument user_identification_key_cookie", value=user_identification_key_cookie, expected_type=type_hints["user_identification_key_cookie"])
            check_type(argname="argument user_identification_key_headers", value=user_identification_key_headers, expected_type=type_hints["user_identification_key_headers"])
            check_type(argname="argument user_identification_key_params", value=user_identification_key_params, expected_type=type_hints["user_identification_key_params"])
            check_type(argname="argument user_identification_title", value=user_identification_title, expected_type=type_hints["user_identification_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument validate_on_origin_header_name", value=validate_on_origin_header_name, expected_type=type_hints["validate_on_origin_header_name"])
            check_type(argname="argument validate_on_origin_header_value", value=validate_on_origin_header_value, expected_type=type_hints["validate_on_origin_header_value"])
            check_type(argname="argument validate_on_origin_response_code", value=validate_on_origin_response_code, expected_type=type_hints["validate_on_origin_response_code"])
            check_type(argname="argument validate_on_origin_with", value=validate_on_origin_with, expected_type=type_hints["validate_on_origin_with"])
            check_type(argname="argument validation_title", value=validation_title, expected_type=type_hints["validation_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_large_post_body is not None:
            self._values["allow_large_post_body"] = allow_large_post_body
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failure302_uri is not None:
            self._values["failure302_uri"] = failure302_uri
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if penalty302_uri is not None:
            self._values["penalty302_uri"] = penalty302_uri
        if penalty403_net_storage_path is not None:
            self._values["penalty403_net_storage_path"] = penalty403_net_storage_path
        if penalty_action is not None:
            self._values["penalty_action"] = penalty_action
        if penalty_branded_deny_cache_ttl is not None:
            self._values["penalty_branded_deny_cache_ttl"] = penalty_branded_deny_cache_ttl
        if penalty_net_storage is not None:
            self._values["penalty_net_storage"] = penalty_net_storage
        if penalty_threshold is not None:
            self._values["penalty_threshold"] = penalty_threshold
        if penalty_title is not None:
            self._values["penalty_title"] = penalty_title
        if reset_on_valid is not None:
            self._values["reset_on_valid"] = reset_on_valid
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_identification_by_cookie is not None:
            self._values["user_identification_by_cookie"] = user_identification_by_cookie
        if user_identification_by_headers is not None:
            self._values["user_identification_by_headers"] = user_identification_by_headers
        if user_identification_by_ip is not None:
            self._values["user_identification_by_ip"] = user_identification_by_ip
        if user_identification_by_params is not None:
            self._values["user_identification_by_params"] = user_identification_by_params
        if user_identification_key_cookie is not None:
            self._values["user_identification_key_cookie"] = user_identification_key_cookie
        if user_identification_key_headers is not None:
            self._values["user_identification_key_headers"] = user_identification_key_headers
        if user_identification_key_params is not None:
            self._values["user_identification_key_params"] = user_identification_key_params
        if user_identification_title is not None:
            self._values["user_identification_title"] = user_identification_title
        if uuid is not None:
            self._values["uuid"] = uuid
        if validate_on_origin_header_name is not None:
            self._values["validate_on_origin_header_name"] = validate_on_origin_header_name
        if validate_on_origin_header_value is not None:
            self._values["validate_on_origin_header_value"] = validate_on_origin_header_value
        if validate_on_origin_response_code is not None:
            self._values["validate_on_origin_response_code"] = validate_on_origin_response_code
        if validate_on_origin_with is not None:
            self._values["validate_on_origin_with"] = validate_on_origin_with
        if validation_title is not None:
            self._values["validation_title"] = validation_title

    @builtins.property
    def allow_large_post_body(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Fails POST request bodies that exceed 16 KB when enabled, otherwise allows them to pass with no validation for policy compliance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_large_post_body DataAkamaiPropertyRulesBuilder#allow_large_post_body}
        '''
        result = self._values.get("allow_large_post_body")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the Input Validation Cloudlet behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failure302_uri(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect link for invalid requests that have not yet triggered a penalty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure302_uri DataAkamaiPropertyRulesBuilder#failure302_uri}
        '''
        result = self._values.get("failure302_uri")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''Distinguishes this Input Validation policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def penalty302_uri(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect link for end users who trigger the penalty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty302_uri DataAkamaiPropertyRulesBuilder#penalty302_uri}
        '''
        result = self._values.get("penalty302_uri")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def penalty403_net_storage_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the full path to the static 403 response content relative to the ``downloadDomainName`` in the ``penaltyNetStorage`` object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty403_net_storage_path DataAkamaiPropertyRulesBuilder#penalty403_net_storage_path}
        '''
        result = self._values.get("penalty403_net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def penalty_action(self) -> typing.Optional[builtins.str]:
        '''Once the ``penaltyThreshold`` of invalid requests is met, this specifies the response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_action DataAkamaiPropertyRulesBuilder#penalty_action}
        '''
        result = self._values.get("penalty_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def penalty_branded_deny_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the penalty response's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#penalty_branded_deny_cache_ttl}
        '''
        result = self._values.get("penalty_branded_deny_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def penalty_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage"]:
        '''penalty_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_net_storage DataAkamaiPropertyRulesBuilder#penalty_net_storage}
        '''
        result = self._values.get("penalty_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage"], result)

    @builtins.property
    def penalty_threshold(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of invalid requests permitted before executing the ``penaltyAction``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_threshold DataAkamaiPropertyRulesBuilder#penalty_threshold}
        '''
        result = self._values.get("penalty_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def penalty_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_title DataAkamaiPropertyRulesBuilder#penalty_title}
        '''
        result = self._values.get("penalty_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def reset_on_valid(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Upon receiving a valid request, enabling this resets the ``penaltyThreshold`` counter to zero.

        Otherwise, even those series of invalid requests that are interrupted by valid requests may trigger the ``penaltyAction``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset_on_valid DataAkamaiPropertyRulesBuilder#reset_on_valid}
        '''
        result = self._values.get("reset_on_valid")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_by_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the value of a cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        '''
        result = self._values.get("user_identification_by_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by specific HTTP headers on GET or POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        '''
        result = self._values.get("user_identification_by_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by specific IP address.

        Do not enable this if you are concerned about DDoS attacks from many different IP addresses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        '''
        result = self._values.get("user_identification_by_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_params(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by specific query parameters on GET or POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        '''
        result = self._values.get("user_identification_by_params")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_key_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the cookie name whose value needs to remain constant across requests to identify a user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        '''
        result = self._values.get("user_identification_key_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_key_headers(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the HTTP headers whose combined set of values identify each end user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        '''
        result = self._values.get("user_identification_key_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_key_params(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the query parameters whose combined set of values identify each end user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        '''
        result = self._values.get("user_identification_key_params")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        '''
        result = self._values.get("user_identification_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def validate_on_origin_header_name(self) -> typing.Optional[builtins.str]:
        '''If ``validateOnOriginWith`` is set to ``RESPONSE_CODE_AND_HEADER``, this specifies the header name for a request that the origin identifies as invalid.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_header_name DataAkamaiPropertyRulesBuilder#validate_on_origin_header_name}
        '''
        result = self._values.get("validate_on_origin_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def validate_on_origin_header_value(self) -> typing.Optional[builtins.str]:
        '''If ``validateOnOriginWith`` is set to ``RESPONSE_CODE_AND_HEADER``, this specifies an invalid request's header value that corresponds to the ``validateOnOriginHeaderName``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_header_value DataAkamaiPropertyRulesBuilder#validate_on_origin_header_value}
        '''
        result = self._values.get("validate_on_origin_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def validate_on_origin_response_code(self) -> typing.Optional[jsii.Number]:
        '''Unless ``validateOnOriginWith`` is ``DISABLED``, this identifies the integer response code for requests the origin identifies as invalid.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_response_code DataAkamaiPropertyRulesBuilder#validate_on_origin_response_code}
        '''
        result = self._values.get("validate_on_origin_response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def validate_on_origin_with(self) -> typing.Optional[builtins.str]:
        '''For any validation that edge servers can't perform alone, this specifies additional validation steps based on how the origin identifies an invalid request.

        If a request is invalid, the origin can indicate this to the edge server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_with DataAkamaiPropertyRulesBuilder#validate_on_origin_with}
        '''
        result = self._values.get("validate_on_origin_with")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def validation_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validation_title DataAkamaiPropertyRulesBuilder#validation_title}
        '''
        result = self._values.get("validation_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b35721e2e3fb9dbb4be1c39da28597291c61ce1e0002dbd4776f4d217422a694)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8a2c65f4aba9b0f6b8011e820a311fc2298c5b2dce354c6b81ca9191bbb927)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ec7d09de7a2fe25d2621b04963237c740b2593469a2224e60c4136f3f965528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7a31f63a39b3b62fb7f4096ad27d2ce3efa39365415078ce528355f8a62b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f935644469021ba95b0e587a909fca7f4ef2f0abb5ff4161ba89986481926f2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e2ad7e05ead9095e4a0a986c427c98f29ab3d3217e86305cb42e9b85229a07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putPenaltyNetStorage")
    def put_penalty_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putPenaltyNetStorage", [value]))

    @jsii.member(jsii_name="resetAllowLargePostBody")
    def reset_allow_large_post_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowLargePostBody", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailure302Uri")
    def reset_failure302_uri(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailure302Uri", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPenalty302Uri")
    def reset_penalty302_uri(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPenalty302Uri", []))

    @jsii.member(jsii_name="resetPenalty403NetStoragePath")
    def reset_penalty403_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPenalty403NetStoragePath", []))

    @jsii.member(jsii_name="resetPenaltyAction")
    def reset_penalty_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPenaltyAction", []))

    @jsii.member(jsii_name="resetPenaltyBrandedDenyCacheTtl")
    def reset_penalty_branded_deny_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPenaltyBrandedDenyCacheTtl", []))

    @jsii.member(jsii_name="resetPenaltyNetStorage")
    def reset_penalty_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPenaltyNetStorage", []))

    @jsii.member(jsii_name="resetPenaltyThreshold")
    def reset_penalty_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPenaltyThreshold", []))

    @jsii.member(jsii_name="resetPenaltyTitle")
    def reset_penalty_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPenaltyTitle", []))

    @jsii.member(jsii_name="resetResetOnValid")
    def reset_reset_on_valid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResetOnValid", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserIdentificationByCookie")
    def reset_user_identification_by_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationByHeaders")
    def reset_user_identification_by_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationByIp")
    def reset_user_identification_by_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByIp", []))

    @jsii.member(jsii_name="resetUserIdentificationByParams")
    def reset_user_identification_by_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByParams", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyCookie")
    def reset_user_identification_key_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyHeaders")
    def reset_user_identification_key_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyParams")
    def reset_user_identification_key_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyParams", []))

    @jsii.member(jsii_name="resetUserIdentificationTitle")
    def reset_user_identification_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValidateOnOriginHeaderName")
    def reset_validate_on_origin_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateOnOriginHeaderName", []))

    @jsii.member(jsii_name="resetValidateOnOriginHeaderValue")
    def reset_validate_on_origin_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateOnOriginHeaderValue", []))

    @jsii.member(jsii_name="resetValidateOnOriginResponseCode")
    def reset_validate_on_origin_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateOnOriginResponseCode", []))

    @jsii.member(jsii_name="resetValidateOnOriginWith")
    def reset_validate_on_origin_with(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateOnOriginWith", []))

    @jsii.member(jsii_name="resetValidationTitle")
    def reset_validation_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidationTitle", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="penaltyNetStorage")
    def penalty_net_storage(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorageOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorageOutputReference", jsii.get(self, "penaltyNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="allowLargePostBodyInput")
    def allow_large_post_body_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowLargePostBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failure302UriInput")
    def failure302_uri_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failure302UriInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="penalty302UriInput")
    def penalty302_uri_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "penalty302UriInput"))

    @builtins.property
    @jsii.member(jsii_name="penalty403NetStoragePathInput")
    def penalty403_net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "penalty403NetStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="penaltyActionInput")
    def penalty_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "penaltyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="penaltyBrandedDenyCacheTtlInput")
    def penalty_branded_deny_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "penaltyBrandedDenyCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="penaltyNetStorageInput")
    def penalty_net_storage_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage"], jsii.get(self, "penaltyNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="penaltyThresholdInput")
    def penalty_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "penaltyThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="penaltyTitleInput")
    def penalty_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "penaltyTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="resetOnValidInput")
    def reset_on_valid_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resetOnValidInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookieInput")
    def user_identification_by_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeadersInput")
    def user_identification_by_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIpInput")
    def user_identification_by_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByIpInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParamsInput")
    def user_identification_by_params_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookieInput")
    def user_identification_key_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationKeyCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeadersInput")
    def user_identification_key_headers_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParamsInput")
    def user_identification_key_params_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitleInput")
    def user_identification_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginHeaderNameInput")
    def validate_on_origin_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "validateOnOriginHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginHeaderValueInput")
    def validate_on_origin_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "validateOnOriginHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginResponseCodeInput")
    def validate_on_origin_response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "validateOnOriginResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginWithInput")
    def validate_on_origin_with_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "validateOnOriginWithInput"))

    @builtins.property
    @jsii.member(jsii_name="validationTitleInput")
    def validation_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "validationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowLargePostBody")
    def allow_large_post_body(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowLargePostBody"))

    @allow_large_post_body.setter
    def allow_large_post_body(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dbbf4eb8d642a2c0434450a013697bbf13fb96b64e6d1407014bff1036cc16b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowLargePostBody", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd17f23a41cf7cc6de370175165ea98104280b2630ad106b2cced82b2117ee53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failure302Uri")
    def failure302_uri(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failure302Uri"))

    @failure302_uri.setter
    def failure302_uri(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d35ae409623ae84e9c4e8ef35e847af7fe9e8a9518d69185b0b683cc795f952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failure302Uri", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46bbc939b44bba2d2311bcb8bb0ce49d9ad829ba3c056a6519e3a8304dd6092e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5c609863b26cbc703115a5bb86441d1e3885d12d17d8f433152c963bcf67b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="penalty302Uri")
    def penalty302_uri(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "penalty302Uri"))

    @penalty302_uri.setter
    def penalty302_uri(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ced3c25830a6205ba035670836877fd70f51e48fa5042af3f3e3c2c0e6f00e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "penalty302Uri", value)

    @builtins.property
    @jsii.member(jsii_name="penalty403NetStoragePath")
    def penalty403_net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "penalty403NetStoragePath"))

    @penalty403_net_storage_path.setter
    def penalty403_net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dc9ccc3266c9f08fd5a0997e77eb07275c91c4229a717de6af8f8c24c8f0e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "penalty403NetStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="penaltyAction")
    def penalty_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "penaltyAction"))

    @penalty_action.setter
    def penalty_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287f4aa6bcae122782774fff1972e7161a43890ac8efa1adf593b6cb3732c8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "penaltyAction", value)

    @builtins.property
    @jsii.member(jsii_name="penaltyBrandedDenyCacheTtl")
    def penalty_branded_deny_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "penaltyBrandedDenyCacheTtl"))

    @penalty_branded_deny_cache_ttl.setter
    def penalty_branded_deny_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2f5e8f2ca7a162c9672ddaf11831f116af14243b35f30294d78d45ac5ad757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "penaltyBrandedDenyCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="penaltyThreshold")
    def penalty_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "penaltyThreshold"))

    @penalty_threshold.setter
    def penalty_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba704dd14e349c85db7b48795db4f9aafd76e97e537ea29096c8ee05bea0a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "penaltyThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="penaltyTitle")
    def penalty_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "penaltyTitle"))

    @penalty_title.setter
    def penalty_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e67aa398d8c2d4d68944c5f15455e98afc8f7f5f6e3f0f418eda7d7f2a64bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "penaltyTitle", value)

    @builtins.property
    @jsii.member(jsii_name="resetOnValid")
    def reset_on_valid(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resetOnValid"))

    @reset_on_valid.setter
    def reset_on_valid(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4422b3132cde08f5d3fdbc8d1153700f36fe0761e111ee9fa71116a286d68bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resetOnValid", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9051c3dd0c56b5991168b7e9b9ff287aed61e1076b23a83247be5377d1bf2512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookie")
    def user_identification_by_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByCookie"))

    @user_identification_by_cookie.setter
    def user_identification_by_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098023f5c957b24901b434e206f3d1a2156765e7b666ffb60e66f5cfe6632121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeaders")
    def user_identification_by_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByHeaders"))

    @user_identification_by_headers.setter
    def user_identification_by_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6f40b97fbd8b6f31d5e880cecfd1b8a9d8facb613447b6e0e1d7ec296db1f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIp")
    def user_identification_by_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByIp"))

    @user_identification_by_ip.setter
    def user_identification_by_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbdaac07ee77c37ec0d3c48252d474c83e8255284cea4e44957b492d75ca329)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByIp", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParams")
    def user_identification_by_params(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByParams"))

    @user_identification_by_params.setter
    def user_identification_by_params(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e48255ff61c676cfe83eca2d581c6600f8fc94dfdc01dcd2ca5f2df1f4c778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookie")
    def user_identification_key_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationKeyCookie"))

    @user_identification_key_cookie.setter
    def user_identification_key_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5910bf14cd5a57968afe12d0140a469a0665364c636f38775b45fb652dfbd13b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeaders")
    def user_identification_key_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyHeaders"))

    @user_identification_key_headers.setter
    def user_identification_key_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f80ad959c9d752fccd0fdd725c46737f630ba586d50cd9bfab050f089e177f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParams")
    def user_identification_key_params(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyParams"))

    @user_identification_key_params.setter
    def user_identification_key_params(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d004f2230c5464c9f32958abebaedff3bf7e725f851e78aed2f624c2870d01d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitle")
    def user_identification_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationTitle"))

    @user_identification_title.setter
    def user_identification_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe2d5fa782856af5a4202ee39973aa2bfbb8903bd8e6bac1f6223d7b2ddab99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6237458acec2ef169e7f1dcb9b9630079c5c03039050bab5165ed00c4bc992a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginHeaderName")
    def validate_on_origin_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "validateOnOriginHeaderName"))

    @validate_on_origin_header_name.setter
    def validate_on_origin_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076af5be94daa3aed0b5ac8543d0c8e1e92a49691632db7e4cfe88dcdbe82cfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validateOnOriginHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginHeaderValue")
    def validate_on_origin_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "validateOnOriginHeaderValue"))

    @validate_on_origin_header_value.setter
    def validate_on_origin_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75bcc372eaed8d58064761ac0a9316975c476ef8375ec5d883fb782a3d105fd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validateOnOriginHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginResponseCode")
    def validate_on_origin_response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "validateOnOriginResponseCode"))

    @validate_on_origin_response_code.setter
    def validate_on_origin_response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2367f6e349a656799858696547e8cc2fc06cab0acd83c21a427b9afb1c88aa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validateOnOriginResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="validateOnOriginWith")
    def validate_on_origin_with(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "validateOnOriginWith"))

    @validate_on_origin_with.setter
    def validate_on_origin_with(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9ccc36efb5b0f6bb6c78431f12dd37912466ba8ca382f4e82319b067a75a76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validateOnOriginWith", value)

    @builtins.property
    @jsii.member(jsii_name="validationTitle")
    def validation_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "validationTitle"))

    @validation_title.setter
    def validation_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53885b41fd95fc8936603ae4c75666059cd099331d927b6e46740730ea3471e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__203992919fcb94dbac391ce3d8e70ce8c5ab33ef354a5a8dae80133b470581fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb47067065f176851b8927c202b94ae674348dbc311613770fb4394d9df4654)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59260b9f5d809b5792ab8270e9718001656037d7f0818dd71671dc33e3bc1a54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dadb0636437beb528daf4ea18614b7f23cd646347cf6ce1e5d1658df9db1160c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa66aa3332bc39886869fbfbda59530496c8f8581052cbf0ca2f2f1d4bd27575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4661baccb952ef23466393c5e858fe46815b89de3d3e4b2e14d09187ba16de75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b4cf77637484d7466f3e2731c1c2d763cd417f79fbc829f8e82d455653e297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant",
    jsii_struct_bases=[],
    name_mapping={
        "custom_link_relations": "customLinkRelations",
        "locked": "locked",
        "prefetch_cacheable": "prefetchCacheable",
        "prefetch_html": "prefetchHtml",
        "prefetch_no_store": "prefetchNoStore",
        "prefetch_no_store_extensions": "prefetchNoStoreExtensions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant:
    def __init__(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082bd36c745e3707d2b8edb1e45f6c3bd3b56115264c58e68c3894080b691381)
            check_type(argname="argument custom_link_relations", value=custom_link_relations, expected_type=type_hints["custom_link_relations"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch_cacheable", value=prefetch_cacheable, expected_type=type_hints["prefetch_cacheable"])
            check_type(argname="argument prefetch_html", value=prefetch_html, expected_type=type_hints["prefetch_html"])
            check_type(argname="argument prefetch_no_store", value=prefetch_no_store, expected_type=type_hints["prefetch_no_store"])
            check_type(argname="argument prefetch_no_store_extensions", value=prefetch_no_store_extensions, expected_type=type_hints["prefetch_no_store_extensions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_link_relations is not None:
            self._values["custom_link_relations"] = custom_link_relations
        if locked is not None:
            self._values["locked"] = locked
        if prefetch_cacheable is not None:
            self._values["prefetch_cacheable"] = prefetch_cacheable
        if prefetch_html is not None:
            self._values["prefetch_html"] = prefetch_html
        if prefetch_no_store is not None:
            self._values["prefetch_no_store"] = prefetch_no_store
        if prefetch_no_store_extensions is not None:
            self._values["prefetch_no_store_extensions"] = prefetch_no_store_extensions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_link_relations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify link relation values that activate the prefetching behavior.

        For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        '''
        result = self._values.get("custom_link_relations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_cacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior.

        Only applies to content with the ``tieredDistribution`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        '''
        result = self._values.get("prefetch_cacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_html(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered.

        This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        '''
        result = self._values.get("prefetch_html")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option.

        Only applies to content with the ``sureRoute`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        '''
        result = self._values.get("prefetch_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store_extensions(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        '''
        result = self._values.get("prefetch_no_store_extensions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6cd0e4979b0fec83ad0e438bdbff79d39aee567bd61c1997196c384e87b1e0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the InstantConfig behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71839fa9d45326811bd93d7e94ad920135f296fe126cfcff1c707a7ced56e0b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d1b3cfa4229a59d063a41bde8d9361725b465d826bfc0a98b50c439908c71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ea219551cd8bbb9900d38492701af4d07c50faae00535a8d3daa0e8df932a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a65094a708c1ddf8c7107433533e8404ff9f69a112ce2b91b102f8b588d4f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5160ec71b4fc974cd9af7431c4f9417d38bd259e1a23b7b0d23cb1f1310d4449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a457d4af66807bdddd39758303fccb9e54a73de0b91373838554ede8081e928c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ff850cbc861d191f9bbde1f06026270cd9faae01e5da18d79c089b5770cacf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLinkRelations")
    def reset_custom_link_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLinkRelations", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetchCacheable")
    def reset_prefetch_cacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchCacheable", []))

    @jsii.member(jsii_name="resetPrefetchHtml")
    def reset_prefetch_html(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchHtml", []))

    @jsii.member(jsii_name="resetPrefetchNoStore")
    def reset_prefetch_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStore", []))

    @jsii.member(jsii_name="resetPrefetchNoStoreExtensions")
    def reset_prefetch_no_store_extensions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStoreExtensions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelationsInput")
    def custom_link_relations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customLinkRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheableInput")
    def prefetch_cacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchCacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchHtmlInput")
    def prefetch_html_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchHtmlInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensionsInput")
    def prefetch_no_store_extensions_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "prefetchNoStoreExtensionsInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreInput")
    def prefetch_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelations")
    def custom_link_relations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customLinkRelations"))

    @custom_link_relations.setter
    def custom_link_relations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f6cf6a96c0e8cd38a48ced35181444e7539077e4618ae80f97585ac9db9621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLinkRelations", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f2d26aa3d01f2d40ad577baae1dd065985c6d4cbc3cdf0f242de78ce348b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheable")
    def prefetch_cacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchCacheable"))

    @prefetch_cacheable.setter
    def prefetch_cacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0acd97a9476e5b9775b7204460a37e9839e3924e528e3c8a2e83b1ee937ff6ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchCacheable", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchHtml")
    def prefetch_html(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchHtml"))

    @prefetch_html.setter
    def prefetch_html(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bebb7d5a5ae6b9d0bf417d38482a62c066abdb7f43b3aad42d680d119ecbb54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchHtml", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStore")
    def prefetch_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchNoStore"))

    @prefetch_no_store.setter
    def prefetch_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1c2b2aff7ae21ba71d333121950a3030c30adcef511f1bfc62313325254a207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensions")
    def prefetch_no_store_extensions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "prefetchNoStoreExtensions"))

    @prefetch_no_store_extensions.setter
    def prefetch_no_store_extensions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7207c7bc3ee70833b83c859cc030fb9daa78bfa80ccbcf0fae2928e162daefdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStoreExtensions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c6fa04b01d2dae523d9858228fdafe1a57afc1108120defb8edb9c0b985094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87210da1a0ace2a3ffb36fd844ec81519a804b3fc4e2bf8000d0f005a891c198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__307a79c531d0b66dbd11c3833fe3d751447cf27c9cef15dc3a6081ebc14c10d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "enable_partial_object_caching": "enablePartialObjectCaching",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "minimum_size": "minimumSize",
        "template_uuid": "templateUuid",
        "use_versioning": "useVersioning",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd2edae12c305734b9da0d8d55fe49756c3aaf6892f3d4868f1331a1796c7f1)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_partial_object_caching", value=enable_partial_object_caching, expected_type=type_hints["enable_partial_object_caching"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument minimum_size", value=minimum_size, expected_type=type_hints["minimum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_versioning", value=use_versioning, expected_type=type_hints["use_versioning"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_partial_object_caching is not None:
            self._values["enable_partial_object_caching"] = enable_partial_object_caching
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if minimum_size is not None:
            self._values["minimum_size"] = minimum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_versioning is not None:
            self._values["use_versioning"] = use_versioning
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_partial_object_caching(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to cache partial objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        '''
        result = self._values.get("enable_partial_object_caching")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def minimum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        '''
        result = self._values.get("minimum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_versioning(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        '''
        result = self._values.get("use_versioning")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "fragment_size": "fragmentSize",
        "locked": "locked",
        "object_size": "objectSize",
        "prefetch_after_request": "prefetchAfterRequest",
        "prefetch_during_request": "prefetchDuringRequest",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2080905349f26ad4ebd98d98498a0c69f658ec29899c8d4b333eda8751166a6)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument fragment_size", value=fragment_size, expected_type=type_hints["fragment_size"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument prefetch_after_request", value=prefetch_after_request, expected_type=type_hints["prefetch_after_request"])
            check_type(argname="argument prefetch_during_request", value=prefetch_during_request, expected_type=type_hints["prefetch_during_request"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if fragment_size is not None:
            self._values["fragment_size"] = fragment_size
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if prefetch_after_request is not None:
            self._values["prefetch_after_request"] = prefetch_after_request
        if prefetch_during_request is not None:
            self._values["prefetch_during_request"] = prefetch_during_request
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def fragment_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of each fragment used for partial object caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        '''
        result = self._values.get("fragment_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the file at which point to apply partial object (POC) caching.

        Append a numeric value with a ``MB`` or ``GB`` suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prefetch_after_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch after the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        '''
        result = self._values.get("prefetch_after_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def prefetch_during_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch during the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        '''
        result = self._values.get("prefetch_during_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d127387c2cee3c476ce67fcccdaf104858bae9755c01d590a5a4f519a2f7ccc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFragmentSize")
    def reset_fragment_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFragmentSize", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPrefetchAfterRequest")
    def reset_prefetch_after_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchAfterRequest", []))

    @jsii.member(jsii_name="resetPrefetchDuringRequest")
    def reset_prefetch_during_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchDuringRequest", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="fragmentSizeInput")
    def fragment_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fragmentSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequestInput")
    def prefetch_after_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchAfterRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequestInput")
    def prefetch_during_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchDuringRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfbed70488e50316458b2444d7ffa265bde77834f2d2cacb91e995b5e9d36347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="fragmentSize")
    def fragment_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fragmentSize"))

    @fragment_size.setter
    def fragment_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e60ecab5da5e302f47fc5f3ae661e035e7a2fa78639760b6cee179770ec9a71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fragmentSize", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a118709debeb84ef0404b3e045021893401246d89d7ea076e1e2f983ac3c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e38eb9bd732321b19404b92a1095eae312ec42cefc309ca16d5f7fb72d1b365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequest")
    def prefetch_after_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchAfterRequest"))

    @prefetch_after_request.setter
    def prefetch_after_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb5030d84a431a4a2fb06c2be95d69b5d067eff835f6d57b6b03d576c15ba67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchAfterRequest", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequest")
    def prefetch_during_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchDuringRequest"))

    @prefetch_during_request.setter
    def prefetch_during_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1e83de715777cf2245279e2c5016877b07f9d3d1551195285c324a9e6f4548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchDuringRequest", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23976e11d65212cb1d6ba94f8f4935d65434c3d5ec2b3ab903d13f97a4346167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10eeb1ecb57c790e47e2b65146c96acc1c8b8802f0851b3f808905a12f85ff0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d041231c1436af577fa002be9386ce322b0cd4e5047b83b59aa63986e8d625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8892cfa374b2d8de5f85922ed9fc86b85fa6d653ea2585eefdbbd41038af4c73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnablePartialObjectCaching")
    def reset_enable_partial_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePartialObjectCaching", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMinimumSize")
    def reset_minimum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinimumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseVersioning")
    def reset_use_versioning(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseVersioning", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCachingInput")
    def enable_partial_object_caching_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enablePartialObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="minimumSizeInput")
    def minimum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minimumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useVersioningInput")
    def use_versioning_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useVersioningInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42490bfeb8cc7e989736c9c746e99385cf226732770b91a8751659e55c8b68f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCaching")
    def enable_partial_object_caching(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enablePartialObjectCaching"))

    @enable_partial_object_caching.setter
    def enable_partial_object_caching(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d04efe0747c7cba97160f33f2f4ce661d5fe5a05be542c2fbe9f2e8d1618ebdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePartialObjectCaching", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a36dfb89418e2e6e4ef99dc0dfbc78fc88bc3163e686c8c7b20b6387858530c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73add711342316f7131722736b3cac8ebbe239b22236b940b97857ede7c47306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="minimumSize")
    def minimum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minimumSize"))

    @minimum_size.setter
    def minimum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0b758d6e14bedf930c33fd24bbdc95390ae02332ffa7d4665ad38c58da9214)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minimumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436a8a55b10f1aa361339452552cbde07e7994f0d38c5a6a33a28473bad67694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useVersioning")
    def use_versioning(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useVersioning"))

    @use_versioning.setter
    def use_versioning(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695a51e50c9f368321919bc4e2626038e8c969960db9ed7166d155d6a4d0a2b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useVersioning", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83d797b7990f877b64a05c26d767b60003a536d80302d74527e3743bed72086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ceaad778e04a051a119ea35ee35fba57f52e230a40426272e410adbea49075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate",
    jsii_struct_bases=[],
    name_mapping={
        "bitrate_table": "bitrateTable",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "threshold_table": "thresholdTable",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate:
    def __init__(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99d8351a318a87c4e6a41e6a2610d37e8457f6539120f6aecb8af64226b79da)
            check_type(argname="argument bitrate_table", value=bitrate_table, expected_type=type_hints["bitrate_table"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument threshold_table", value=threshold_table, expected_type=type_hints["threshold_table"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_table is not None:
            self._values["bitrate_table"] = bitrate_table
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if threshold_table is not None:
            self._values["threshold_table"] = threshold_table
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bitrate_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable"]]]:
        '''bitrate_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        '''
        result = self._values.get("bitrate_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable"]]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates the bit rate limiting behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable"]]]:
        '''threshold_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        '''
        result = self._values.get("threshold_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable"]]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable",
    jsii_struct_bases=[],
    name_mapping={"bitrate_unit": "bitrateUnit", "bitrate_value": "bitrateValue"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable:
    def __init__(
        self,
        *,
        bitrate_unit: typing.Optional[builtins.str] = None,
        bitrate_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param bitrate_unit: The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        :param bitrate_value: The numeric indicator of the download rate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600fe9e168d25ed014c66fa5abff158bae759d1e2dfa588823a41b38e88931a3)
            check_type(argname="argument bitrate_unit", value=bitrate_unit, expected_type=type_hints["bitrate_unit"])
            check_type(argname="argument bitrate_value", value=bitrate_value, expected_type=type_hints["bitrate_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_unit is not None:
            self._values["bitrate_unit"] = bitrate_unit
        if bitrate_value is not None:
            self._values["bitrate_value"] = bitrate_value

    @builtins.property
    def bitrate_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        '''
        result = self._values.get("bitrate_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def bitrate_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the download rate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        result = self._values.get("bitrate_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eeace3094ebdc596581c82890ea12c19bd6efefd56abc5e32cbde5ef8af714d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b43ff59a8fa0344672d2fb2b3488ae9abaa0d11248e6a73f52cb7437c1c5505)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c0a8e133cdd15372db4be0c86759defde6eb9c13503cc8a2613eea4836b089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c83f619b404ff63da205e6d34d1fd4cf0b65b75f06cfbbb40f3aa83d94a50ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7378cb5ea4e7d5807a879659e1a5118f2c4f82aef335442f79e2c2778bb84c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af814249ac8e28c97b8d2e165b5636b4da36002a06035c9d3f54de2dc0af3e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17c47c2d6028ea9b9e1d36ddc6c04e56b07859cceb7664adf329ff20733a2035)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBitrateUnit")
    def reset_bitrate_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateUnit", []))

    @jsii.member(jsii_name="resetBitrateValue")
    def reset_bitrate_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateValue", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnitInput")
    def bitrate_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bitrateUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateValueInput")
    def bitrate_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bitrateValueInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnit")
    def bitrate_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bitrateUnit"))

    @bitrate_unit.setter
    def bitrate_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8d2371b30768e60978d322c5ca37fdb357f5ab116e2001aecf3ac94f2133d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateUnit", value)

    @builtins.property
    @jsii.member(jsii_name="bitrateValue")
    def bitrate_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bitrateValue"))

    @bitrate_value.setter
    def bitrate_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8738531bd27a3d1aa2422719dd8c424c09b06bc3aeb7dd920d930b79257c1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a4ae207c66e35f8d0ddd0c6d5b74da367b1136267ee449f84219ba4d789eb46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b908503f1fb0f5aa3ef77eb66da84cd97f4124936fe7bb3cec3d4288ec5584a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBitrateTable")
    def put_bitrate_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b05b6d1f049244a9ca5ec472cfdb4af6a42fe45763674d5173181e10d5cdf212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBitrateTable", [value]))

    @jsii.member(jsii_name="putThresholdTable")
    def put_threshold_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b086987d3fc918d33bfd7bf3da07baea1427f2af75c94073b8f2edcf7248c9a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putThresholdTable", [value]))

    @jsii.member(jsii_name="resetBitrateTable")
    def reset_bitrate_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateTable", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThresholdTable")
    def reset_threshold_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdTable", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateTable")
    def bitrate_table(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableList, jsii.get(self, "bitrateTable"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTable")
    def threshold_table(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableList", jsii.get(self, "thresholdTable"))

    @builtins.property
    @jsii.member(jsii_name="bitrateTableInput")
    def bitrate_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "bitrateTableInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTableInput")
    def threshold_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable"]]], jsii.get(self, "thresholdTableInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddec9a194c25a74e9a2b299f1eb48d0ca7fb9fe63676b9e88752f01f7c65a87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b02e6a9f9a541d206c0fbc55511f596f9e1b17c5b06e4462d06af9714ec91e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea217c31aded82b4df3a3126fb92660ab41131e5da494984d9f597110083ca41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b922b3e54f2095ea543becb0d568797edff889de2b551b4662c6ef887b3adf50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f325545342f80d911991c527c2d305c8b6be70507bd31560cd4dde3e6ab9c3a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable",
    jsii_struct_bases=[],
    name_mapping={
        "threshold_unit": "thresholdUnit",
        "threshold_value": "thresholdValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable:
    def __init__(
        self,
        *,
        threshold_unit: typing.Optional[builtins.str] = None,
        threshold_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param threshold_unit: The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        :param threshold_value: The numeric indicator of the minimum file size or elapsed download time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef39f3869069f6316e43fc4201c8f8a38f6d60e7a9445e87816513f46d84669)
            check_type(argname="argument threshold_unit", value=threshold_unit, expected_type=type_hints["threshold_unit"])
            check_type(argname="argument threshold_value", value=threshold_value, expected_type=type_hints["threshold_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if threshold_unit is not None:
            self._values["threshold_unit"] = threshold_unit
        if threshold_value is not None:
            self._values["threshold_value"] = threshold_value

    @builtins.property
    def threshold_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        '''
        result = self._values.get("threshold_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the minimum file size or elapsed download time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        result = self._values.get("threshold_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66ff4fd80de3dd3dd06f0b9b1487daf230841c80d015b7357645d61f02a5720)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb5e5ccd33594e1ec03306d3970be41b7accca884cf63c83d1f801b58cc3292)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070051471aefe11bdf13ca4c0e04af6ccdd1b7b11547a259cd25a0bde211404f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09eac6f6eebe15cfdeb165dbe4a5c22b39cd86b9871df3a2f788986ccaf1e448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8ccb3eae92a5d18363b7ab511e75465f2b64ebce9b39af7fbb3d015976209a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51f8ad9700d66a00c910db6e216f1aec8359588607ed761af40d71ada2ea859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc0435ecd19580d83af920ebb0bfb35776f492c1c251453ae9e9fe266f4a79a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetThresholdUnit")
    def reset_threshold_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdUnit", []))

    @jsii.member(jsii_name="resetThresholdValue")
    def reset_threshold_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdValue", []))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnitInput")
    def threshold_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdValueInput")
    def threshold_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "thresholdValueInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnit")
    def threshold_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdUnit"))

    @threshold_unit.setter
    def threshold_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bbcd63a130dbf297faaa91a053938c9a1e28a157151fc3cab41b41099b39bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdUnit", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdValue")
    def threshold_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "thresholdValue"))

    @threshold_value.setter
    def threshold_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3249a81c92bb1cbc288dddebde2f3f0f7b8aacd343ef2412f9132937204cc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9038ecc4fcb3937edb4eaee7b608686f289bf349defcd5339a7a0f8ea4527cce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f220b8b35dd67b845fb01ab2867017719c2c4e1798a68c044113c0c6d818406a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d50c04a27009827ee203a4f8d466c4df3d8ce2ddd10c12a559b26c126eb16ae)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__031525cd86a943f7e6e7b8611dcc3327497f09429ada77346e372751f9d6fd8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3abf3e425d2500a44bece91978d98ea8b22d40f2d9c682ec0cf1fea275707ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c65a06238aa7eac30a1f374ac91ac77342a6ad32fe16c5baf69881271aa909f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e225d1e3ed418f08c9eadc86affd7fab2b7b5745db9cdb110cb5de3cd1438121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom",
    jsii_struct_bases=[],
    name_mapping={
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_custom_log_field": "logCustomLogField",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom:
    def __init__(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad544ff81fa9a1a64c1d8a1c8a34e9973ee149af3e2616194cefdbf618a31cc)
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a166f60f6a23742a93da6a678cc7442e95f37cd5d19a15ba901ebd91b5bac627)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f23fae21155a03e7dec14f5b8fe05f14ea593aa1473097d0bd37c181bd7f0da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fd2a2ab4388696f1eb0339e499efb7c7a95012525c88c03e913c2fc47e054f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6bd498f976f86487cbad2ed21b55dd1d48f9e74c78751b77d4b50fa61e51a39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6368c1cee885c64fcb5f37e28422ccb00215110c0ebaa7e356055e3658366ec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd860e2a0dc967967def95dab73ff8cf98ec213697a7411ee649461b3530b97d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f756eb2ab05ac6330049bcdfac3414e616068edfca144eb7a78ea4b9504658ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse",
    jsii_struct_bases=[],
    name_mapping={
        "api_key": "apiKey",
        "buffer_size": "bufferSize",
        "config_override": "configOverride",
        "enabled": "enabled",
        "loader_version": "loaderVersion",
        "locked": "locked",
        "require_pci": "requirePci",
        "template_uuid": "templateUuid",
        "title_optional": "titleOptional",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse:
    def __init__(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28fded08ea63ba1bcbdea92e08ce261d0bdc52ab2296f4679388db0c1c37fd31)
            check_type(argname="argument api_key", value=api_key, expected_type=type_hints["api_key"])
            check_type(argname="argument buffer_size", value=buffer_size, expected_type=type_hints["buffer_size"])
            check_type(argname="argument config_override", value=config_override, expected_type=type_hints["config_override"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument loader_version", value=loader_version, expected_type=type_hints["loader_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument require_pci", value=require_pci, expected_type=type_hints["require_pci"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_optional", value=title_optional, expected_type=type_hints["title_optional"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if api_key is not None:
            self._values["api_key"] = api_key
        if buffer_size is not None:
            self._values["buffer_size"] = buffer_size
        if config_override is not None:
            self._values["config_override"] = config_override
        if enabled is not None:
            self._values["enabled"] = enabled
        if loader_version is not None:
            self._values["loader_version"] = loader_version
        if locked is not None:
            self._values["locked"] = locked
        if require_pci is not None:
            self._values["require_pci"] = require_pci
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_optional is not None:
            self._values["title_optional"] = title_optional
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def api_key(self) -> typing.Optional[builtins.str]:
        '''This generated value uniquely identifies sections of your website for you to analyze independently.

        To access this value, see ``Enable mPulse in Property Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        '''
        result = self._values.get("api_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def buffer_size(self) -> typing.Optional[builtins.str]:
        '''Allows you to override the browser's default (150) maximum number of reported performance timeline entries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        '''
        result = self._values.get("buffer_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def config_override(self) -> typing.Optional[builtins.str]:
        '''A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs.

        It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``.  See ``Configuration Overrides`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        '''
        result = self._values.get("config_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies performance monitoring to this behavior's set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def loader_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        '''
        result = self._values.get("loader_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def require_pci(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        '''
        result = self._values.get("require_pci")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_optional(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        '''
        result = self._values.get("title_optional")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b787c4850424137913aacefba79fb57c0a9b86e7cdcbc97c42d88cc0d4c1300f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApiKey")
    def reset_api_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiKey", []))

    @jsii.member(jsii_name="resetBufferSize")
    def reset_buffer_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBufferSize", []))

    @jsii.member(jsii_name="resetConfigOverride")
    def reset_config_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigOverride", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLoaderVersion")
    def reset_loader_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoaderVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequirePci")
    def reset_require_pci(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequirePci", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleOptional")
    def reset_title_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleOptional", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="apiKeyInput")
    def api_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="bufferSizeInput")
    def buffer_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bufferSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="configOverrideInput")
    def config_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="loaderVersionInput")
    def loader_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "loaderVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requirePciInput")
    def require_pci_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "requirePciInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleOptionalInput")
    def title_optional_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleOptionalInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="apiKey")
    def api_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiKey"))

    @api_key.setter
    def api_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50588f1b98cd846ca437c0382958f4e5df91a0b9fd862ea1c2bcbc447e3211ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiKey", value)

    @builtins.property
    @jsii.member(jsii_name="bufferSize")
    def buffer_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bufferSize"))

    @buffer_size.setter
    def buffer_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b634993316dd8fbd113e64b11a015fe1ed98d400510bb6445732073cf08ea57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bufferSize", value)

    @builtins.property
    @jsii.member(jsii_name="configOverride")
    def config_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configOverride"))

    @config_override.setter
    def config_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2a095c90b10c17016e12640bf27960b2f4b6260ffab6e8f920e4ff151ccb49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configOverride", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d7a602a72f0022e3f40f022286904e3bb3bf6d16aa19be8d4de6c8b9547fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="loaderVersion")
    def loader_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "loaderVersion"))

    @loader_version.setter
    def loader_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a939a8a7af35b76db4ce67643cca8e702b411259fd3bb6cd775147da18f870c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loaderVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab6b3beec4863ae50be145fc31ac2e1b161213f2abaeadb304301182df059b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requirePci")
    def require_pci(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "requirePci"))

    @require_pci.setter
    def require_pci(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51cd2640dcd8b7712d2e9ab327be89f073a0f511d3c728545a1abf86a31963b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requirePci", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67f09814a13b1f06fdeac3d588489e9f278e1e050fff060bce558edc431f1310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleOptional")
    def title_optional(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleOptional"))

    @title_optional.setter
    def title_optional(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d364c48680ae64863443f5688dc571dbf8a58552b9838921b62debd1c9af74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleOptional", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801f471dbc10e6b6ca087f17bad75b1678a8b030d2a3ffc140e02debf73668e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d578ca746cb915d48c4b647c54f4e4793235a27db15cb2c2e5ae8b2ea587f6dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "hls_enabled": "hlsEnabled",
        "hls_enable_debug_headers": "hlsEnableDebugHeaders",
        "hls_filter_in_bitrate_ranges": "hlsFilterInBitrateRanges",
        "hls_filter_in_bitrates": "hlsFilterInBitrates",
        "hls_mode": "hlsMode",
        "hls_preferred_bitrate": "hlsPreferredBitrate",
        "hls_query_param_enabled": "hlsQueryParamEnabled",
        "hls_query_param_secret_key": "hlsQueryParamSecretKey",
        "hls_query_param_transition_key": "hlsQueryParamTransitionKey",
        "hls_show_advanced": "hlsShowAdvanced",
        "hls_title": "hlsTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cca6922809b9253eddc0ad1e15787b968a976e184941ce4a909d31e3be15319)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hls_enabled", value=hls_enabled, expected_type=type_hints["hls_enabled"])
            check_type(argname="argument hls_enable_debug_headers", value=hls_enable_debug_headers, expected_type=type_hints["hls_enable_debug_headers"])
            check_type(argname="argument hls_filter_in_bitrate_ranges", value=hls_filter_in_bitrate_ranges, expected_type=type_hints["hls_filter_in_bitrate_ranges"])
            check_type(argname="argument hls_filter_in_bitrates", value=hls_filter_in_bitrates, expected_type=type_hints["hls_filter_in_bitrates"])
            check_type(argname="argument hls_mode", value=hls_mode, expected_type=type_hints["hls_mode"])
            check_type(argname="argument hls_preferred_bitrate", value=hls_preferred_bitrate, expected_type=type_hints["hls_preferred_bitrate"])
            check_type(argname="argument hls_query_param_enabled", value=hls_query_param_enabled, expected_type=type_hints["hls_query_param_enabled"])
            check_type(argname="argument hls_query_param_secret_key", value=hls_query_param_secret_key, expected_type=type_hints["hls_query_param_secret_key"])
            check_type(argname="argument hls_query_param_transition_key", value=hls_query_param_transition_key, expected_type=type_hints["hls_query_param_transition_key"])
            check_type(argname="argument hls_show_advanced", value=hls_show_advanced, expected_type=type_hints["hls_show_advanced"])
            check_type(argname="argument hls_title", value=hls_title, expected_type=type_hints["hls_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if hls_enabled is not None:
            self._values["hls_enabled"] = hls_enabled
        if hls_enable_debug_headers is not None:
            self._values["hls_enable_debug_headers"] = hls_enable_debug_headers
        if hls_filter_in_bitrate_ranges is not None:
            self._values["hls_filter_in_bitrate_ranges"] = hls_filter_in_bitrate_ranges
        if hls_filter_in_bitrates is not None:
            self._values["hls_filter_in_bitrates"] = hls_filter_in_bitrates
        if hls_mode is not None:
            self._values["hls_mode"] = hls_mode
        if hls_preferred_bitrate is not None:
            self._values["hls_preferred_bitrate"] = hls_preferred_bitrate
        if hls_query_param_enabled is not None:
            self._values["hls_query_param_enabled"] = hls_query_param_enabled
        if hls_query_param_secret_key is not None:
            self._values["hls_query_param_secret_key"] = hls_query_param_secret_key
        if hls_query_param_transition_key is not None:
            self._values["hls_query_param_transition_key"] = hls_query_param_transition_key
        if hls_show_advanced is not None:
            self._values["hls_show_advanced"] = hls_show_advanced
        if hls_title is not None:
            self._values["hls_title"] = hls_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Manifest Personalization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to customize the HLS master manifest that's sent to the requesting client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        '''
        result = self._values.get("hls_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enable_debug_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        '''
        result = self._values.get("hls_enable_debug_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_filter_in_bitrate_ranges(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        '''
        result = self._values.get("hls_filter_in_bitrate_ranges")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_filter_in_bitrates(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        '''
        result = self._values.get("hls_filter_in_bitrates")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_mode(self) -> typing.Optional[builtins.str]:
        '''Applies with ``hlsEnabled`` on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        '''
        result = self._values.get("hls_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_preferred_bitrate(self) -> typing.Optional[builtins.str]:
        '''Sets the preferred bit rate in Kbps.

        This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        '''
        result = self._values.get("hls_preferred_bitrate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies query parameters for the HLS master manifest to customize the manifest's content.

        Any settings specified in the query string override those already configured in Property Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        '''
        result = self._values.get("hls_query_param_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_query_param_secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a primary key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        '''
        result = self._values.get("hls_query_param_secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        '''
        result = self._values.get("hls_query_param_transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        '''
        result = self._values.get("hls_show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        '''
        result = self._values.get("hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__106a59b83f75ced15e95108bca78fe086a98ae1877acac4ddab4aea72d4146cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHlsEnabled")
    def reset_hls_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnabled", []))

    @jsii.member(jsii_name="resetHlsEnableDebugHeaders")
    def reset_hls_enable_debug_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnableDebugHeaders", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrateRanges")
    def reset_hls_filter_in_bitrate_ranges(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrateRanges", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrates")
    def reset_hls_filter_in_bitrates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrates", []))

    @jsii.member(jsii_name="resetHlsMode")
    def reset_hls_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMode", []))

    @jsii.member(jsii_name="resetHlsPreferredBitrate")
    def reset_hls_preferred_bitrate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsPreferredBitrate", []))

    @jsii.member(jsii_name="resetHlsQueryParamEnabled")
    def reset_hls_query_param_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamEnabled", []))

    @jsii.member(jsii_name="resetHlsQueryParamSecretKey")
    def reset_hls_query_param_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamSecretKey", []))

    @jsii.member(jsii_name="resetHlsQueryParamTransitionKey")
    def reset_hls_query_param_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamTransitionKey", []))

    @jsii.member(jsii_name="resetHlsShowAdvanced")
    def reset_hls_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsShowAdvanced", []))

    @jsii.member(jsii_name="resetHlsTitle")
    def reset_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeadersInput")
    def hls_enable_debug_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnableDebugHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnabledInput")
    def hls_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRangesInput")
    def hls_filter_in_bitrate_ranges_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitrateRangesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitratesInput")
    def hls_filter_in_bitrates_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitratesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsModeInput")
    def hls_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsModeInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrateInput")
    def hls_preferred_bitrate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsPreferredBitrateInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabledInput")
    def hls_query_param_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsQueryParamEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKeyInput")
    def hls_query_param_secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamSecretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKeyInput")
    def hls_query_param_transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamTransitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvancedInput")
    def hls_show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsShowAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsTitleInput")
    def hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7caaefb80690d2fc20c752f5b1134c969209bdd694aafa0c1da92d7ac26af33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnabled")
    def hls_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnabled"))

    @hls_enabled.setter
    def hls_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1229a15466adf7e56e100a2e25115570b951ddc9c79574ccca2024e7c98fc5ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeaders")
    def hls_enable_debug_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnableDebugHeaders"))

    @hls_enable_debug_headers.setter
    def hls_enable_debug_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa8a036e7c054c52d65be88e8d43709bccea8f30ff3482ea963d6db7e16d8a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnableDebugHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRanges")
    def hls_filter_in_bitrate_ranges(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrateRanges"))

    @hls_filter_in_bitrate_ranges.setter
    def hls_filter_in_bitrate_ranges(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2240f96a07a73c5d7361bce3c2a0cb3010d4c5f5e8094937fcdd41d879b2a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrateRanges", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrates")
    def hls_filter_in_bitrates(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrates"))

    @hls_filter_in_bitrates.setter
    def hls_filter_in_bitrates(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__104cb6778009af0100a8d95da025f7b7c123982769ab7b98941df7d84ae3271c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrates", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMode")
    def hls_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsMode"))

    @hls_mode.setter
    def hls_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c40dab4c361d362940fafceebc912848c2717e551fb1e92d099987a9083f501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMode", value)

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrate")
    def hls_preferred_bitrate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsPreferredBitrate"))

    @hls_preferred_bitrate.setter
    def hls_preferred_bitrate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4534b2f4a104d8640839185f0001b57e3630d7a13337c9eeb3f33d048c23012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsPreferredBitrate", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabled")
    def hls_query_param_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsQueryParamEnabled"))

    @hls_query_param_enabled.setter
    def hls_query_param_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a72f203dd698a697c6fff67f5ec58f23a313dbf73b1aa8ec191cb527ec51b782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKey")
    def hls_query_param_secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamSecretKey"))

    @hls_query_param_secret_key.setter
    def hls_query_param_secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fbd5747d32cfd3f739aeea5a361ca7b660ac0117c0cc04001b3b8838f47db24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamSecretKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKey")
    def hls_query_param_transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamTransitionKey"))

    @hls_query_param_transition_key.setter
    def hls_query_param_transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208f15064ed3fa4eda7e28e1135fab506345debbb1855ef0ba722d955446f169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamTransitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvanced")
    def hls_show_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsShowAdvanced"))

    @hls_show_advanced.setter
    def hls_show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0348acd105ffce06174d8a23011c7e3d1497821016c008e2054da14f979792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsShowAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="hlsTitle")
    def hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsTitle"))

    @hls_title.setter
    def hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc8197695d4fe87428a6d30044ad7a84c3f3c0092f76b9ff7f87923dab72bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226ad1c17c931cfe47b442c9111db0792190dc9869f3de9980b5ae9bb3123b59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__990b49f26dcbf5111197243456923600862d7b4f92ae182972d6b90d8d4be7d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f84ff1efa2aabe504f71aee09db8aa266e332c9bcbcb6619cb928c986607162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb7ea1cdc9f1dfdfa65df904ed8b6cbff5d03616e4f5c8295b493e556da0608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "partner": "partner",
        "template_uuid": "templateUuid",
        "username": "username",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__781a88c33824aa0f53809927495f4d6579683a8f94dcb0bf7b9c513b2b9d337e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument partner", value=partner, expected_type=type_hints["partner"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument username", value=username, expected_type=type_hints["username"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if partner is not None:
            self._values["partner"] = partner
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if username is not None:
            self._values["username"] = username
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner(self) -> typing.Optional[builtins.str]:
        '''Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        '''
        result = self._values.get("partner")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def username(self) -> typing.Optional[builtins.str]:
        '''The user name for your Adobe Primetime account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        '''
        result = self._values.get("username")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestReroutingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestReroutingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8286ef5c55bbe06efb88260ae2c2283cea6fcd57fe02688b0775a8bd9a16042)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPartner")
    def reset_partner(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartner", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsername")
    def reset_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsername", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerInput")
    def partner_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usernameInput")
    def username_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usernameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75994945e1ff914c8193f564c3651e01e94e64b1c0496a1b7515a1ab9d54792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="partner")
    def partner(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partner"))

    @partner.setter
    def partner(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f16f3a96db266057b8f4737c2ce34b1de53da4cc81b727cbb21d654af497fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partner", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b22e845771f9fae0b7018b41087896e8a9b736cc7155b17166de8a67003ee99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="username")
    def username(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "username"))

    @username.setter
    def username(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e2977f4d8ef022ae7fa56c04ef453ef932f704cad0c1cb125bcfe66de3d4ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "username", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f458ab4aba360f0af8af4fdd072477b1b9cab7c8329cd92ab6b53bb5e53ab05e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d7307018631dfd1c3f6a90b3437213473ef5a3d7eb8248320e04d2e4a13cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "serverpushlist": "serverpushlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ad96e64e9ee36cd59631a8962b8402e377f19b00622a5ef286041de9f6ed99)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serverpushlist", value=serverpushlist, expected_type=type_hints["serverpushlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if serverpushlist is not None:
            self._values["serverpushlist"] = serverpushlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serverpushlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of objects to load into the client browser's cache over HTTP2.

        Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        '''
        result = self._values.get("serverpushlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPushOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPushOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2068465ecd485a44d35151aac97be4bf4ee36386e206a841c7992140d7b43614)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServerpushlist")
    def reset_serverpushlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerpushlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serverpushlistInput")
    def serverpushlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "serverpushlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834e7403e60e0c9f2a82807b6f94aeae45cea5201319a31661df8c153f08f1f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serverpushlist")
    def serverpushlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "serverpushlist"))

    @serverpushlist.setter
    def serverpushlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e29284bbe33c643103b69f1dcb32d31798d6a2c451f57c0b4a7cf48561b26a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serverpushlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785df7412c4d0e62f8147c07039639dfe7d4283d655d20b96b081746a2a0359a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d37bdd42f99abffd08c312f61f6de0f3ae0d0acbadfd3f05ecfb3b416e4098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5217b7b6c24e48628a2d12d050ddee566171768cbe354549259cf686e6ebd83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bab96763427f45afa35ca483617aebb8759a3811a9c093b94043111b326f17a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Media Acceleration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbd8537291ad66d806f1027db59de7e734ce46e82e51822575ec368d78fbd8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb5b95b3a32017d679cdede97ac9302793c5abe11a5802d381af2f0f09a4778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7123272e2e924cb9a6dc37b70b2c673803cc2814926baf3d7766c96d053a78c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e259b704074788a61b87abb6f6bff1a073849597e15e1e1325d61779b69f4ffc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e62d66fbf7d4d94414067243de10f149c7722eae7661825caeef9cec134d0733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6daf243b9fa65239767d34a82504ee3ddeac4eac8b982229893450a9cc5801df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "optout": "optout",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd65519b3b8a1acb80315496a27bd12a91e4cd10580f13b5850eb7738809880)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optout", value=optout, expected_type=type_hints["optout"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if optout is not None:
            self._values["optout"] = optout
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optout(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        '''
        result = self._values.get("optout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a8fd7971b14947f2cf956077f235d4c50e62ac0a5612404123099bd966fcb54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptout")
    def reset_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptout", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optoutInput")
    def optout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optoutInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b43b7368b30f4e3675e41f30f5b9e8613d34e25cbfc587bbe71a4269d676d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optout")
    def optout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optout"))

    @optout.setter
    def optout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fac84fc8ac3a48aa1560a44e3fdcc71a9121e0f685a0a7834eb8decea5e5179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optout", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__371485525b64347697b0136db94800750d516b5d63b985ef48239ba3025ced3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49baf15ee629b9901efea15b7c73d9b9634ec8ba4b186096a09e052a150b9c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d505bc9a2b9bb11c1f7fb8eb491a06b9017eef3d1fe64fe1ae71f5e2978a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_id": "beaconId",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_hybrid_http_udp": "useHybridHttpUdp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient:
    def __init__(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0486d8ef3b23249d79d3f898f73a8dcddbc6a9f53816b1b7be9f7d4bc68977e)
            check_type(argname="argument beacon_id", value=beacon_id, expected_type=type_hints["beacon_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_hybrid_http_udp", value=use_hybrid_http_udp, expected_type=type_hints["use_hybrid_http_udp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_id is not None:
            self._values["beacon_id"] = beacon_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_hybrid_http_udp is not None:
            self._values["use_hybrid_http_udp"] = use_hybrid_http_udp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ID of data source's beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        '''
        result = self._values.get("beacon_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables client-side download analytics.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_hybrid_http_udp(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the hybrid HTTP/UDP protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        '''
        result = self._values.get("use_hybrid_http_udp")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8cd3780db8896dae69c18017f9f32f8f15c5af85e839472f87611c7df901a9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconId")
    def reset_beacon_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHybridHttpUdp")
    def reset_use_hybrid_http_udp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHybridHttpUdp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconIdInput")
    def beacon_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdpInput")
    def use_hybrid_http_udp_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHybridHttpUdpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconId")
    def beacon_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconId"))

    @beacon_id.setter
    def beacon_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64c2047635d6eaa97c4b72a3fedb92283c4a26843a2f694ce3858b89bfcb126)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297369dece63591b7101675f7e999a2474996378e1c0a82788a80f68f1a69090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a299bacd9decb8b0cb33b475bc313ee722b57bf31130a7c10364a577926d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bf2c8c4af04e413124f55f98d8660099b870a4a897540571641cb9a5b18123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdp")
    def use_hybrid_http_udp(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHybridHttpUdp"))

    @use_hybrid_http_udp.setter
    def use_hybrid_http_udp(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e3cc7418b672e106392cf65ee6de9ca7eb6769567b28196c40ee7d4ec8584a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHybridHttpUdp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254fc6bef0d5cf0c030266f783b7c745484b625d88b3c622f18d3981cb279d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189d61b69ea758269d488a731215d6af63fb626948881c1581ae5007100da906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0959f21751bcef57225e487585bcae56cde32ec7bfd66fb252d99de091028a2)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the partial-object caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2c63e8743e740a2d7000ff83f9fc280039d903a87e62013cd304642f491f44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__896b5a9d70e853a76697c52879f64cd68d41cfee12704c8c5e7ffcd3edce2534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea487f228ef07394ec57075122bb8707aa3c89e9009b566e2da0570b3ce15ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea58d80279e7563d01e6d2d57535cbef34be0af0d1fe528bd332c7e15ab52e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b6115743c9bd9bfa3fb8aa725280750ae3659dbf472f26b4f73855ba18e14b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4cbbef818c91b432e4468c0415dcb157a05881af8735526a9af15def2444dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover",
    jsii_struct_bases=[],
    name_mapping={
        "cache_error_response": "cacheErrorResponse",
        "cache_window": "cacheWindow",
        "client_response_code": "clientResponseCode",
        "detect_object_unavailable": "detectObjectUnavailable",
        "detect_object_unavailable_title": "detectObjectUnavailableTitle",
        "detect_origin_unavailable": "detectOriginUnavailable",
        "detect_origin_unavailable_title": "detectOriginUnavailableTitle",
        "detect_origin_unresponsive": "detectOriginUnresponsive",
        "detect_origin_unresponsive_title": "detectOriginUnresponsiveTitle",
        "locked": "locked",
        "object_unavailable_alternate_host": "objectUnavailableAlternateHost",
        "object_unavailable_backup_host": "objectUnavailableBackupHost",
        "object_unavailable_blacklist_origin_ip": "objectUnavailableBlacklistOriginIp",
        "object_unavailable_blacklist_window": "objectUnavailableBlacklistWindow",
        "object_unavailable_change_protocol": "objectUnavailableChangeProtocol",
        "object_unavailable_detection_level": "objectUnavailableDetectionLevel",
        "object_unavailable_include_query_string": "objectUnavailableIncludeQueryString",
        "object_unavailable_modified_path": "objectUnavailableModifiedPath",
        "object_unavailable_modify_request_path": "objectUnavailableModifyRequestPath",
        "object_unavailable_protocol": "objectUnavailableProtocol",
        "object_unavailable_recovery": "objectUnavailableRecovery",
        "object_unavailable_redirect_method": "objectUnavailableRedirectMethod",
        "object_unavailable_response_codes": "objectUnavailableResponseCodes",
        "object_unavailable_retry_limit": "objectUnavailableRetryLimit",
        "origin_unavailable_alternate_host": "originUnavailableAlternateHost",
        "origin_unavailable_backup_host": "originUnavailableBackupHost",
        "origin_unavailable_blacklist_origin_ip": "originUnavailableBlacklistOriginIp",
        "origin_unavailable_blacklist_window": "originUnavailableBlacklistWindow",
        "origin_unavailable_change_protocol": "originUnavailableChangeProtocol",
        "origin_unavailable_detection_level": "originUnavailableDetectionLevel",
        "origin_unavailable_include_query_string": "originUnavailableIncludeQueryString",
        "origin_unavailable_modified_path": "originUnavailableModifiedPath",
        "origin_unavailable_modify_request_path": "originUnavailableModifyRequestPath",
        "origin_unavailable_protocol": "originUnavailableProtocol",
        "origin_unavailable_recovery": "originUnavailableRecovery",
        "origin_unavailable_redirect_method": "originUnavailableRedirectMethod",
        "origin_unavailable_response_codes": "originUnavailableResponseCodes",
        "origin_unavailable_retry_limit": "originUnavailableRetryLimit",
        "origin_unresponsive_alternate_host": "originUnresponsiveAlternateHost",
        "origin_unresponsive_backup_host": "originUnresponsiveBackupHost",
        "origin_unresponsive_blacklist_origin_ip": "originUnresponsiveBlacklistOriginIp",
        "origin_unresponsive_blacklist_window": "originUnresponsiveBlacklistWindow",
        "origin_unresponsive_change_protocol": "originUnresponsiveChangeProtocol",
        "origin_unresponsive_detection_level": "originUnresponsiveDetectionLevel",
        "origin_unresponsive_include_query_string": "originUnresponsiveIncludeQueryString",
        "origin_unresponsive_modified_path": "originUnresponsiveModifiedPath",
        "origin_unresponsive_modify_request_path": "originUnresponsiveModifyRequestPath",
        "origin_unresponsive_protocol": "originUnresponsiveProtocol",
        "origin_unresponsive_recovery": "originUnresponsiveRecovery",
        "origin_unresponsive_redirect_method": "originUnresponsiveRedirectMethod",
        "origin_unresponsive_retry_limit": "originUnresponsiveRetryLimit",
        "other_options": "otherOptions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover:
    def __init__(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27dbe2d5d79d7e72bdba9b8ab97f38a23ab42b239ced48b04c875104da1e50ee)
            check_type(argname="argument cache_error_response", value=cache_error_response, expected_type=type_hints["cache_error_response"])
            check_type(argname="argument cache_window", value=cache_window, expected_type=type_hints["cache_window"])
            check_type(argname="argument client_response_code", value=client_response_code, expected_type=type_hints["client_response_code"])
            check_type(argname="argument detect_object_unavailable", value=detect_object_unavailable, expected_type=type_hints["detect_object_unavailable"])
            check_type(argname="argument detect_object_unavailable_title", value=detect_object_unavailable_title, expected_type=type_hints["detect_object_unavailable_title"])
            check_type(argname="argument detect_origin_unavailable", value=detect_origin_unavailable, expected_type=type_hints["detect_origin_unavailable"])
            check_type(argname="argument detect_origin_unavailable_title", value=detect_origin_unavailable_title, expected_type=type_hints["detect_origin_unavailable_title"])
            check_type(argname="argument detect_origin_unresponsive", value=detect_origin_unresponsive, expected_type=type_hints["detect_origin_unresponsive"])
            check_type(argname="argument detect_origin_unresponsive_title", value=detect_origin_unresponsive_title, expected_type=type_hints["detect_origin_unresponsive_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_unavailable_alternate_host", value=object_unavailable_alternate_host, expected_type=type_hints["object_unavailable_alternate_host"])
            check_type(argname="argument object_unavailable_backup_host", value=object_unavailable_backup_host, expected_type=type_hints["object_unavailable_backup_host"])
            check_type(argname="argument object_unavailable_blacklist_origin_ip", value=object_unavailable_blacklist_origin_ip, expected_type=type_hints["object_unavailable_blacklist_origin_ip"])
            check_type(argname="argument object_unavailable_blacklist_window", value=object_unavailable_blacklist_window, expected_type=type_hints["object_unavailable_blacklist_window"])
            check_type(argname="argument object_unavailable_change_protocol", value=object_unavailable_change_protocol, expected_type=type_hints["object_unavailable_change_protocol"])
            check_type(argname="argument object_unavailable_detection_level", value=object_unavailable_detection_level, expected_type=type_hints["object_unavailable_detection_level"])
            check_type(argname="argument object_unavailable_include_query_string", value=object_unavailable_include_query_string, expected_type=type_hints["object_unavailable_include_query_string"])
            check_type(argname="argument object_unavailable_modified_path", value=object_unavailable_modified_path, expected_type=type_hints["object_unavailable_modified_path"])
            check_type(argname="argument object_unavailable_modify_request_path", value=object_unavailable_modify_request_path, expected_type=type_hints["object_unavailable_modify_request_path"])
            check_type(argname="argument object_unavailable_protocol", value=object_unavailable_protocol, expected_type=type_hints["object_unavailable_protocol"])
            check_type(argname="argument object_unavailable_recovery", value=object_unavailable_recovery, expected_type=type_hints["object_unavailable_recovery"])
            check_type(argname="argument object_unavailable_redirect_method", value=object_unavailable_redirect_method, expected_type=type_hints["object_unavailable_redirect_method"])
            check_type(argname="argument object_unavailable_response_codes", value=object_unavailable_response_codes, expected_type=type_hints["object_unavailable_response_codes"])
            check_type(argname="argument object_unavailable_retry_limit", value=object_unavailable_retry_limit, expected_type=type_hints["object_unavailable_retry_limit"])
            check_type(argname="argument origin_unavailable_alternate_host", value=origin_unavailable_alternate_host, expected_type=type_hints["origin_unavailable_alternate_host"])
            check_type(argname="argument origin_unavailable_backup_host", value=origin_unavailable_backup_host, expected_type=type_hints["origin_unavailable_backup_host"])
            check_type(argname="argument origin_unavailable_blacklist_origin_ip", value=origin_unavailable_blacklist_origin_ip, expected_type=type_hints["origin_unavailable_blacklist_origin_ip"])
            check_type(argname="argument origin_unavailable_blacklist_window", value=origin_unavailable_blacklist_window, expected_type=type_hints["origin_unavailable_blacklist_window"])
            check_type(argname="argument origin_unavailable_change_protocol", value=origin_unavailable_change_protocol, expected_type=type_hints["origin_unavailable_change_protocol"])
            check_type(argname="argument origin_unavailable_detection_level", value=origin_unavailable_detection_level, expected_type=type_hints["origin_unavailable_detection_level"])
            check_type(argname="argument origin_unavailable_include_query_string", value=origin_unavailable_include_query_string, expected_type=type_hints["origin_unavailable_include_query_string"])
            check_type(argname="argument origin_unavailable_modified_path", value=origin_unavailable_modified_path, expected_type=type_hints["origin_unavailable_modified_path"])
            check_type(argname="argument origin_unavailable_modify_request_path", value=origin_unavailable_modify_request_path, expected_type=type_hints["origin_unavailable_modify_request_path"])
            check_type(argname="argument origin_unavailable_protocol", value=origin_unavailable_protocol, expected_type=type_hints["origin_unavailable_protocol"])
            check_type(argname="argument origin_unavailable_recovery", value=origin_unavailable_recovery, expected_type=type_hints["origin_unavailable_recovery"])
            check_type(argname="argument origin_unavailable_redirect_method", value=origin_unavailable_redirect_method, expected_type=type_hints["origin_unavailable_redirect_method"])
            check_type(argname="argument origin_unavailable_response_codes", value=origin_unavailable_response_codes, expected_type=type_hints["origin_unavailable_response_codes"])
            check_type(argname="argument origin_unavailable_retry_limit", value=origin_unavailable_retry_limit, expected_type=type_hints["origin_unavailable_retry_limit"])
            check_type(argname="argument origin_unresponsive_alternate_host", value=origin_unresponsive_alternate_host, expected_type=type_hints["origin_unresponsive_alternate_host"])
            check_type(argname="argument origin_unresponsive_backup_host", value=origin_unresponsive_backup_host, expected_type=type_hints["origin_unresponsive_backup_host"])
            check_type(argname="argument origin_unresponsive_blacklist_origin_ip", value=origin_unresponsive_blacklist_origin_ip, expected_type=type_hints["origin_unresponsive_blacklist_origin_ip"])
            check_type(argname="argument origin_unresponsive_blacklist_window", value=origin_unresponsive_blacklist_window, expected_type=type_hints["origin_unresponsive_blacklist_window"])
            check_type(argname="argument origin_unresponsive_change_protocol", value=origin_unresponsive_change_protocol, expected_type=type_hints["origin_unresponsive_change_protocol"])
            check_type(argname="argument origin_unresponsive_detection_level", value=origin_unresponsive_detection_level, expected_type=type_hints["origin_unresponsive_detection_level"])
            check_type(argname="argument origin_unresponsive_include_query_string", value=origin_unresponsive_include_query_string, expected_type=type_hints["origin_unresponsive_include_query_string"])
            check_type(argname="argument origin_unresponsive_modified_path", value=origin_unresponsive_modified_path, expected_type=type_hints["origin_unresponsive_modified_path"])
            check_type(argname="argument origin_unresponsive_modify_request_path", value=origin_unresponsive_modify_request_path, expected_type=type_hints["origin_unresponsive_modify_request_path"])
            check_type(argname="argument origin_unresponsive_protocol", value=origin_unresponsive_protocol, expected_type=type_hints["origin_unresponsive_protocol"])
            check_type(argname="argument origin_unresponsive_recovery", value=origin_unresponsive_recovery, expected_type=type_hints["origin_unresponsive_recovery"])
            check_type(argname="argument origin_unresponsive_redirect_method", value=origin_unresponsive_redirect_method, expected_type=type_hints["origin_unresponsive_redirect_method"])
            check_type(argname="argument origin_unresponsive_retry_limit", value=origin_unresponsive_retry_limit, expected_type=type_hints["origin_unresponsive_retry_limit"])
            check_type(argname="argument other_options", value=other_options, expected_type=type_hints["other_options"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_error_response is not None:
            self._values["cache_error_response"] = cache_error_response
        if cache_window is not None:
            self._values["cache_window"] = cache_window
        if client_response_code is not None:
            self._values["client_response_code"] = client_response_code
        if detect_object_unavailable is not None:
            self._values["detect_object_unavailable"] = detect_object_unavailable
        if detect_object_unavailable_title is not None:
            self._values["detect_object_unavailable_title"] = detect_object_unavailable_title
        if detect_origin_unavailable is not None:
            self._values["detect_origin_unavailable"] = detect_origin_unavailable
        if detect_origin_unavailable_title is not None:
            self._values["detect_origin_unavailable_title"] = detect_origin_unavailable_title
        if detect_origin_unresponsive is not None:
            self._values["detect_origin_unresponsive"] = detect_origin_unresponsive
        if detect_origin_unresponsive_title is not None:
            self._values["detect_origin_unresponsive_title"] = detect_origin_unresponsive_title
        if locked is not None:
            self._values["locked"] = locked
        if object_unavailable_alternate_host is not None:
            self._values["object_unavailable_alternate_host"] = object_unavailable_alternate_host
        if object_unavailable_backup_host is not None:
            self._values["object_unavailable_backup_host"] = object_unavailable_backup_host
        if object_unavailable_blacklist_origin_ip is not None:
            self._values["object_unavailable_blacklist_origin_ip"] = object_unavailable_blacklist_origin_ip
        if object_unavailable_blacklist_window is not None:
            self._values["object_unavailable_blacklist_window"] = object_unavailable_blacklist_window
        if object_unavailable_change_protocol is not None:
            self._values["object_unavailable_change_protocol"] = object_unavailable_change_protocol
        if object_unavailable_detection_level is not None:
            self._values["object_unavailable_detection_level"] = object_unavailable_detection_level
        if object_unavailable_include_query_string is not None:
            self._values["object_unavailable_include_query_string"] = object_unavailable_include_query_string
        if object_unavailable_modified_path is not None:
            self._values["object_unavailable_modified_path"] = object_unavailable_modified_path
        if object_unavailable_modify_request_path is not None:
            self._values["object_unavailable_modify_request_path"] = object_unavailable_modify_request_path
        if object_unavailable_protocol is not None:
            self._values["object_unavailable_protocol"] = object_unavailable_protocol
        if object_unavailable_recovery is not None:
            self._values["object_unavailable_recovery"] = object_unavailable_recovery
        if object_unavailable_redirect_method is not None:
            self._values["object_unavailable_redirect_method"] = object_unavailable_redirect_method
        if object_unavailable_response_codes is not None:
            self._values["object_unavailable_response_codes"] = object_unavailable_response_codes
        if object_unavailable_retry_limit is not None:
            self._values["object_unavailable_retry_limit"] = object_unavailable_retry_limit
        if origin_unavailable_alternate_host is not None:
            self._values["origin_unavailable_alternate_host"] = origin_unavailable_alternate_host
        if origin_unavailable_backup_host is not None:
            self._values["origin_unavailable_backup_host"] = origin_unavailable_backup_host
        if origin_unavailable_blacklist_origin_ip is not None:
            self._values["origin_unavailable_blacklist_origin_ip"] = origin_unavailable_blacklist_origin_ip
        if origin_unavailable_blacklist_window is not None:
            self._values["origin_unavailable_blacklist_window"] = origin_unavailable_blacklist_window
        if origin_unavailable_change_protocol is not None:
            self._values["origin_unavailable_change_protocol"] = origin_unavailable_change_protocol
        if origin_unavailable_detection_level is not None:
            self._values["origin_unavailable_detection_level"] = origin_unavailable_detection_level
        if origin_unavailable_include_query_string is not None:
            self._values["origin_unavailable_include_query_string"] = origin_unavailable_include_query_string
        if origin_unavailable_modified_path is not None:
            self._values["origin_unavailable_modified_path"] = origin_unavailable_modified_path
        if origin_unavailable_modify_request_path is not None:
            self._values["origin_unavailable_modify_request_path"] = origin_unavailable_modify_request_path
        if origin_unavailable_protocol is not None:
            self._values["origin_unavailable_protocol"] = origin_unavailable_protocol
        if origin_unavailable_recovery is not None:
            self._values["origin_unavailable_recovery"] = origin_unavailable_recovery
        if origin_unavailable_redirect_method is not None:
            self._values["origin_unavailable_redirect_method"] = origin_unavailable_redirect_method
        if origin_unavailable_response_codes is not None:
            self._values["origin_unavailable_response_codes"] = origin_unavailable_response_codes
        if origin_unavailable_retry_limit is not None:
            self._values["origin_unavailable_retry_limit"] = origin_unavailable_retry_limit
        if origin_unresponsive_alternate_host is not None:
            self._values["origin_unresponsive_alternate_host"] = origin_unresponsive_alternate_host
        if origin_unresponsive_backup_host is not None:
            self._values["origin_unresponsive_backup_host"] = origin_unresponsive_backup_host
        if origin_unresponsive_blacklist_origin_ip is not None:
            self._values["origin_unresponsive_blacklist_origin_ip"] = origin_unresponsive_blacklist_origin_ip
        if origin_unresponsive_blacklist_window is not None:
            self._values["origin_unresponsive_blacklist_window"] = origin_unresponsive_blacklist_window
        if origin_unresponsive_change_protocol is not None:
            self._values["origin_unresponsive_change_protocol"] = origin_unresponsive_change_protocol
        if origin_unresponsive_detection_level is not None:
            self._values["origin_unresponsive_detection_level"] = origin_unresponsive_detection_level
        if origin_unresponsive_include_query_string is not None:
            self._values["origin_unresponsive_include_query_string"] = origin_unresponsive_include_query_string
        if origin_unresponsive_modified_path is not None:
            self._values["origin_unresponsive_modified_path"] = origin_unresponsive_modified_path
        if origin_unresponsive_modify_request_path is not None:
            self._values["origin_unresponsive_modify_request_path"] = origin_unresponsive_modify_request_path
        if origin_unresponsive_protocol is not None:
            self._values["origin_unresponsive_protocol"] = origin_unresponsive_protocol
        if origin_unresponsive_recovery is not None:
            self._values["origin_unresponsive_recovery"] = origin_unresponsive_recovery
        if origin_unresponsive_redirect_method is not None:
            self._values["origin_unresponsive_redirect_method"] = origin_unresponsive_redirect_method
        if origin_unresponsive_retry_limit is not None:
            self._values["origin_unresponsive_retry_limit"] = origin_unresponsive_retry_limit
        if other_options is not None:
            self._values["other_options"] = other_options
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cache_error_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches the error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        '''
        result = self._values.get("cache_error_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_window(self) -> typing.Optional[builtins.str]:
        '''This sets error response's TTL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        '''
        result = self._values.get("cache_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_response_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the response code served to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        '''
        result = self._values.get("client_response_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_object_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin has content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        '''
        result = self._values.get("detect_object_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_object_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        '''
        result = self._values.get("detect_object_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin server responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        '''
        result = self._values.get("detect_origin_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        '''
        result = self._values.get("detect_origin_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unresponsive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure what happens when the origin is unresponsive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        '''
        result = self._values.get("detect_origin_unresponsive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unresponsive_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        '''
        result = self._values.get("detect_origin_unresponsive_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        '''
        result = self._values.get("object_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        '''
        result = self._values.get("object_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("object_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        '''
        result = self._values.get("object_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Changes the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        '''
        result = self._values.get("object_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        '''
        result = self._values.get("object_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        '''
        result = self._values.get("object_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        '''
        result = self._values.get("object_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to modify the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        '''
        result = self._values.get("object_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        '''
        result = self._values.get("object_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        '''
        result = self._values.get("object_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        '''
        result = self._values.get("object_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def object_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when there are content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        '''
        result = self._values.get("object_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def object_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        '''
        result = self._values.get("object_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        '''
        result = self._values.get("origin_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        '''
        result = self._values.get("origin_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        '''
        result = self._values.get("origin_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        '''
        result = self._values.get("origin_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        '''
        result = self._values.get("origin_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        '''
        result = self._values.get("origin_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        '''
        result = self._values.get("origin_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        '''
        result = self._values.get("origin_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        '''
        result = self._values.get("origin_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        '''
        result = self._values.get("origin_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies either a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        '''
        result = self._values.get("origin_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when the origin responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        '''
        result = self._values.get("origin_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origin_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        '''
        result = self._values.get("origin_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        '''
        result = self._values.get("origin_unresponsive_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        '''
        result = self._values.get("origin_unresponsive_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unresponsive_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        '''
        result = self._values.get("origin_unresponsive_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This allows you to change the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        '''
        result = self._values.get("origin_unresponsive_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify the level of response to slow origin connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        '''
        result = self._values.get("origin_unresponsive_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        '''
        result = self._values.get("origin_unresponsive_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        '''
        result = self._values.get("origin_unresponsive_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        '''
        result = self._values.get("origin_unresponsive_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies which protocol to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        '''
        result = self._values.get("origin_unresponsive_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        '''
        result = self._values.get("origin_unresponsive_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        '''
        result = self._values.get("origin_unresponsive_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unresponsive_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        '''
        result = self._values.get("origin_unresponsive_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def other_options(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        '''
        result = self._values.get("other_options")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailoverOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailoverOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe0218da7f7bffa183bbbd3846e689b4634506b52d4e26c648f8ba8647cc017)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCacheErrorResponse")
    def reset_cache_error_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheErrorResponse", []))

    @jsii.member(jsii_name="resetCacheWindow")
    def reset_cache_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheWindow", []))

    @jsii.member(jsii_name="resetClientResponseCode")
    def reset_client_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientResponseCode", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailable")
    def reset_detect_object_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailable", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailableTitle")
    def reset_detect_object_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailable")
    def reset_detect_origin_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailable", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailableTitle")
    def reset_detect_origin_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsive")
    def reset_detect_origin_unresponsive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsive", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsiveTitle")
    def reset_detect_origin_unresponsive_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsiveTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectUnavailableAlternateHost")
    def reset_object_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBackupHost")
    def reset_object_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistOriginIp")
    def reset_object_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistWindow")
    def reset_object_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetObjectUnavailableChangeProtocol")
    def reset_object_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableDetectionLevel")
    def reset_object_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetObjectUnavailableIncludeQueryString")
    def reset_object_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifiedPath")
    def reset_object_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifyRequestPath")
    def reset_object_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableProtocol")
    def reset_object_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableRecovery")
    def reset_object_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRecovery", []))

    @jsii.member(jsii_name="resetObjectUnavailableRedirectMethod")
    def reset_object_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetObjectUnavailableResponseCodes")
    def reset_object_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetObjectUnavailableRetryLimit")
    def reset_object_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnavailableAlternateHost")
    def reset_origin_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBackupHost")
    def reset_origin_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistOriginIp")
    def reset_origin_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistWindow")
    def reset_origin_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnavailableChangeProtocol")
    def reset_origin_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableDetectionLevel")
    def reset_origin_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnavailableIncludeQueryString")
    def reset_origin_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifiedPath")
    def reset_origin_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifyRequestPath")
    def reset_origin_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableProtocol")
    def reset_origin_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableRecovery")
    def reset_origin_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRecovery", []))

    @jsii.member(jsii_name="resetOriginUnavailableRedirectMethod")
    def reset_origin_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnavailableResponseCodes")
    def reset_origin_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetOriginUnavailableRetryLimit")
    def reset_origin_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveAlternateHost")
    def reset_origin_unresponsive_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBackupHost")
    def reset_origin_unresponsive_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistOriginIp")
    def reset_origin_unresponsive_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistWindow")
    def reset_origin_unresponsive_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveChangeProtocol")
    def reset_origin_unresponsive_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveDetectionLevel")
    def reset_origin_unresponsive_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveIncludeQueryString")
    def reset_origin_unresponsive_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifiedPath")
    def reset_origin_unresponsive_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifyRequestPath")
    def reset_origin_unresponsive_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveProtocol")
    def reset_origin_unresponsive_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRecovery")
    def reset_origin_unresponsive_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRecovery", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRedirectMethod")
    def reset_origin_unresponsive_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRetryLimit")
    def reset_origin_unresponsive_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRetryLimit", []))

    @jsii.member(jsii_name="resetOtherOptions")
    def reset_other_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOtherOptions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponseInput")
    def cache_error_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheErrorResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheWindowInput")
    def cache_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="clientResponseCodeInput")
    def client_response_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableInput")
    def detect_object_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectObjectUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitleInput")
    def detect_object_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectObjectUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableInput")
    def detect_origin_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitleInput")
    def detect_origin_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveInput")
    def detect_origin_unresponsive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnresponsiveInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitleInput")
    def detect_origin_unresponsive_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnresponsiveTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHostInput")
    def object_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHostInput")
    def object_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIpInput")
    def object_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindowInput")
    def object_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocolInput")
    def object_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevelInput")
    def object_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryStringInput")
    def object_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPathInput")
    def object_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPathInput")
    def object_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocolInput")
    def object_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecoveryInput")
    def object_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethodInput")
    def object_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "objectUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodesInput")
    def object_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "objectUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimitInput")
    def object_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHostInput")
    def origin_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHostInput")
    def origin_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIpInput")
    def origin_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindowInput")
    def origin_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocolInput")
    def origin_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevelInput")
    def origin_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryStringInput")
    def origin_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPathInput")
    def origin_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPathInput")
    def origin_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocolInput")
    def origin_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecoveryInput")
    def origin_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethodInput")
    def origin_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodesInput")
    def origin_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimitInput")
    def origin_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHostInput")
    def origin_unresponsive_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHostInput")
    def origin_unresponsive_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIpInput")
    def origin_unresponsive_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindowInput")
    def origin_unresponsive_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocolInput")
    def origin_unresponsive_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevelInput")
    def origin_unresponsive_detection_level_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryStringInput")
    def origin_unresponsive_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPathInput")
    def origin_unresponsive_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPathInput")
    def origin_unresponsive_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocolInput")
    def origin_unresponsive_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecoveryInput")
    def origin_unresponsive_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethodInput")
    def origin_unresponsive_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnresponsiveRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimitInput")
    def origin_unresponsive_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="otherOptionsInput")
    def other_options_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "otherOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponse")
    def cache_error_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheErrorResponse"))

    @cache_error_response.setter
    def cache_error_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9aafbeadc7b02a618741db76028a8630f48b0f413a54ddcfb84998326be460f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheErrorResponse", value)

    @builtins.property
    @jsii.member(jsii_name="cacheWindow")
    def cache_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheWindow"))

    @cache_window.setter
    def cache_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbb42601e3bdf15390e098e1adfc53279ed6af10b7b2fcba4e17930789e1ed09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheWindow", value)

    @builtins.property
    @jsii.member(jsii_name="clientResponseCode")
    def client_response_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientResponseCode"))

    @client_response_code.setter
    def client_response_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2517cc7041a4c9616e01f67cde08310a12561817f77d58a3836273d7ac8bad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailable")
    def detect_object_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectObjectUnavailable"))

    @detect_object_unavailable.setter
    def detect_object_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa1a71e6da00dae4f114d54a490ef0ba6d4bf4c9f3b6a73ab37afd8da7336bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitle")
    def detect_object_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectObjectUnavailableTitle"))

    @detect_object_unavailable_title.setter
    def detect_object_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9f59d3b9f2434e33802cd630a0e9727cf39cf5f346fb71ed234b7e05800e1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailable")
    def detect_origin_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnavailable"))

    @detect_origin_unavailable.setter
    def detect_origin_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8550bc8885ffed78fad34e35af7019f101160ad73379738f6cec8dee32de1e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitle")
    def detect_origin_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnavailableTitle"))

    @detect_origin_unavailable_title.setter
    def detect_origin_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0d97f10f68ed4c6681f3ce629cd282fac178e47c92fdc3dd205924c240090b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsive")
    def detect_origin_unresponsive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnresponsive"))

    @detect_origin_unresponsive.setter
    def detect_origin_unresponsive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30739d1cf3ba39e6b4974d23a89fde171ca9113f4e20361394ea3b8c58e08a9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsive", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitle")
    def detect_origin_unresponsive_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnresponsiveTitle"))

    @detect_origin_unresponsive_title.setter
    def detect_origin_unresponsive_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a3eb53801474776a1504a450ab994c55042fdd02e736edef7e9adaeaa41bc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsiveTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a43d775fa71e49ea9b8547a49664c52e3d690beeea6713fe814ef5042da4af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHost")
    def object_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableAlternateHost"))

    @object_unavailable_alternate_host.setter
    def object_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a7670affa3f8bf7222fe95630a67050d4221b898b7deee53d4bcbdd44e2f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHost")
    def object_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBackupHost"))

    @object_unavailable_backup_host.setter
    def object_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a541a47dd1faddfb81ce825a8a77cfa2e3b0323eb2f3fcb46838b5b328798c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIp")
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableBlacklistOriginIp"))

    @object_unavailable_blacklist_origin_ip.setter
    def object_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35c4fd342a81431c7231823cdbb6393a48728a762e244738a19cf1263129b411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindow")
    def object_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBlacklistWindow"))

    @object_unavailable_blacklist_window.setter
    def object_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea14f37d0e04ff5b6abcaf6bab795f39ec2a880c81c29991101354076373426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocol")
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableChangeProtocol"))

    @object_unavailable_change_protocol.setter
    def object_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2749b977f2b62d17d2c94e9d5d026bac8206a5d8ec809b4ab40c2c0836f63f1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevel")
    def object_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableDetectionLevel"))

    @object_unavailable_detection_level.setter
    def object_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9737a8753a808c7ff61c7fbe3a01b5ca855c8fb8da2b8da042b470bc51b28e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryString")
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableIncludeQueryString"))

    @object_unavailable_include_query_string.setter
    def object_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5effb2eeba77bc93f32590deb741d3086a42b39e6896a76fd9590cb38228d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPath")
    def object_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableModifiedPath"))

    @object_unavailable_modified_path.setter
    def object_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0e1fab64061703c9fd93ed7870d79ed5449bf943900d1ae11c1d0036761465b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPath")
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableModifyRequestPath"))

    @object_unavailable_modify_request_path.setter
    def object_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397c7329dd885ad9ecb9801600117823048d704a97b98c12ae70805d2c1059b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocol")
    def object_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableProtocol"))

    @object_unavailable_protocol.setter
    def object_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dca7dc12eae08533a5d53eb599ecd6e44ae855dfbbd006b864c07a7aebdb055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecovery")
    def object_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRecovery"))

    @object_unavailable_recovery.setter
    def object_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a480062561f365589e2d99ab46003656925a495e8bdf4df149d513fe35f89b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethod")
    def object_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "objectUnavailableRedirectMethod"))

    @object_unavailable_redirect_method.setter
    def object_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6e08d4187163db0f1429c84cf4633a3dbfcf4df01e10efb460f0a0f1f82adc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodes")
    def object_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "objectUnavailableResponseCodes"))

    @object_unavailable_response_codes.setter
    def object_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f44e5a41ede2109e3f157dfd0dd1d6e13f9a1e0b0b51f5f1dfbb5184a6c0ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimit")
    def object_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRetryLimit"))

    @object_unavailable_retry_limit.setter
    def object_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__966aa57a0eb61da0cb25b046b69e81e062f71003f48b41e02722102125fba07e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHost")
    def origin_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableAlternateHost"))

    @origin_unavailable_alternate_host.setter
    def origin_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__954a17e7847c55cf9b6fc831e3f37b510b089ebca8159bebad6b47629b184ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHost")
    def origin_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBackupHost"))

    @origin_unavailable_backup_host.setter
    def origin_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b6d10fbf60f4b434bb30180830befebec8e1dcf25943a41b7aec6119926b918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIp")
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableBlacklistOriginIp"))

    @origin_unavailable_blacklist_origin_ip.setter
    def origin_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d97285de1f72f8580569f46fbb88457f4f0c0a1662e1fdeebe282408d36163f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindow")
    def origin_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBlacklistWindow"))

    @origin_unavailable_blacklist_window.setter
    def origin_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8904cedd7d5f7b7fd9f99b1a0fb8331d9443ab23351b51cff5aa3de2bfcb4433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocol")
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableChangeProtocol"))

    @origin_unavailable_change_protocol.setter
    def origin_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea50cb7d0fe8ef14f55cd9b7b6c38c17cf6067b1591541ac01c99d6a9dea477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevel")
    def origin_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableDetectionLevel"))

    @origin_unavailable_detection_level.setter
    def origin_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab807d0f019d5baf11260d74c74c10abc40df3b51c4e436034016cd79b9ba54a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryString")
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableIncludeQueryString"))

    @origin_unavailable_include_query_string.setter
    def origin_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa6e5fe13dff3a9c6b51f9ea974f936689559e19131f991094648d41fe26e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPath")
    def origin_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableModifiedPath"))

    @origin_unavailable_modified_path.setter
    def origin_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb35cc809c183ff27a5aa167ca7afae6d83bb81d20a6ce87ba068f1a41789d31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPath")
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableModifyRequestPath"))

    @origin_unavailable_modify_request_path.setter
    def origin_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__242c64eea4708ec1bc583c721b46a72e586e1af8fb4425ca3e27b9659755a1ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocol")
    def origin_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableProtocol"))

    @origin_unavailable_protocol.setter
    def origin_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c82aff9b7bbf8373a6d24b98f1179629dc11963047580f8039ee2c0552b06a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecovery")
    def origin_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRecovery"))

    @origin_unavailable_recovery.setter
    def origin_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15798fd9a4502def56e5e1e2f08b5eb04aefc6c402ff6fa3bfab3554de435a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethod")
    def origin_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnavailableRedirectMethod"))

    @origin_unavailable_redirect_method.setter
    def origin_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a113ba77915fca5b2884a5618e323ede665d3c0e62ced47c87b7bdf54c8e07e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodes")
    def origin_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "originUnavailableResponseCodes"))

    @origin_unavailable_response_codes.setter
    def origin_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1172f21a4afb351988fdbb5dd3758ac74089d6c5028fda633306b781623d669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimit")
    def origin_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRetryLimit"))

    @origin_unavailable_retry_limit.setter
    def origin_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cbadba114b4bf1415efd37c9c98e6e780598a561c8fde9b5d99308fbb8241d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHost")
    def origin_unresponsive_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveAlternateHost"))

    @origin_unresponsive_alternate_host.setter
    def origin_unresponsive_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__235f003216a37c0c06c79cc0a2c9640408bbf7a7ee64f0193295aa022baf549a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHost")
    def origin_unresponsive_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBackupHost"))

    @origin_unresponsive_backup_host.setter
    def origin_unresponsive_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f39f7c00bdf5c97bcbe318a4f67caa70e00de1d23c8097d88e24466a34f757f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIp")
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveBlacklistOriginIp"))

    @origin_unresponsive_blacklist_origin_ip.setter
    def origin_unresponsive_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e21f81658080f920084398c56e7b3014df0b5f68da472e31d28c7833c304e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindow")
    def origin_unresponsive_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBlacklistWindow"))

    @origin_unresponsive_blacklist_window.setter
    def origin_unresponsive_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc28658f7ee25777bc373d3ce10d58be4a6acc417937bb712f2244b660ccaaf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocol")
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveChangeProtocol"))

    @origin_unresponsive_change_protocol.setter
    def origin_unresponsive_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b513f14a104ba4f84fc928d8be7133e2dde94c224a5b697faf5500109d9164b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevel")
    def origin_unresponsive_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveDetectionLevel"))

    @origin_unresponsive_detection_level.setter
    def origin_unresponsive_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8196f6be8e6fe20e4da4533001473befc7940ca4428ffc82bd4891f35871258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryString")
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveIncludeQueryString"))

    @origin_unresponsive_include_query_string.setter
    def origin_unresponsive_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6ecd728d85ba87016436488acd6263ed87bb2923792f49eaf7c940090a3eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPath")
    def origin_unresponsive_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveModifiedPath"))

    @origin_unresponsive_modified_path.setter
    def origin_unresponsive_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686fe4d603a613dea1616d6d4d8912a8f64c298d24969c2150b08d5dbfc7fdd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPath")
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveModifyRequestPath"))

    @origin_unresponsive_modify_request_path.setter
    def origin_unresponsive_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a97342cc018412117b9116713af1cac1e78d90b2bb0708f0a02a1590eb877a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocol")
    def origin_unresponsive_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveProtocol"))

    @origin_unresponsive_protocol.setter
    def origin_unresponsive_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a911a7b8679d22ba7eee923cf5426fb4dcb4930e1b72544b7852598bb3615f42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecovery")
    def origin_unresponsive_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRecovery"))

    @origin_unresponsive_recovery.setter
    def origin_unresponsive_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7fad801ae99cee5bb113da2787791228831fe405b5aa2ecc5ae107db4aa671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethod")
    def origin_unresponsive_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnresponsiveRedirectMethod"))

    @origin_unresponsive_redirect_method.setter
    def origin_unresponsive_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1be8dde4dc0d1b0fe0ec591e19a08a2751f59fc626d5b2854f5e290c772dcc65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimit")
    def origin_unresponsive_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRetryLimit"))

    @origin_unresponsive_retry_limit.setter
    def origin_unresponsive_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03cdbe5e43248ce9a78cf94e77393a16d40a7cd8446a348068a1ecd4b9a2e815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="otherOptions")
    def other_options(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "otherOptions"))

    @other_options.setter
    def other_options(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cced09201f33a49feb725fbcaf5bfe1574d0fb6dce17fda6f9ba4bfcbb26c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "otherOptions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb85ccf233658b99ab5de3332660cd3d5d6defdf95cc468e3a5ba1993076ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d51db9a48589ceb5b88e981dde9381c3f14d8a28ad65b10a2b1e3bfb5df4a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463bdabd87508189d2cde0141305fb39ddbffb46800ba79e62c78bfd94e41a66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b07db59147651c66ed55326efcb4177ee9ccb0b6be55999ceb7004892664d435)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables metadata caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d97a51f33c2ee3e4a06316b39b044b7834a5c8062ee47daa1b5a6f958d91754)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fa6e41dde02ada213afb6839c62413ba02960d58dcac1db15c5a01a8d96b0d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88274ea52109059b2cb2fe3aaaf558dca3a315030d4ac38eb80fbbb3e924df2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed2fe50f9b5a85ee200bfe1a24db48ff5ec2374ed199872025c3b837ec22cfc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6618ae6118dec2b64dd057d6b51011582428a702e26f473138eb36eff12356f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355a2eb9395d9f7ecbfd13aa5b69d15eb2031c24742d20d1c036f1a580f0c163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "secondary_multipath_to_origin": "secondaryMultipathToOrigin",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92dc8379a946c599061a8fa359935130be6510a874f832b3152c1eb2e5c8b2b4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument secondary_multipath_to_origin", value=secondary_multipath_to_origin, expected_type=type_hints["secondary_multipath_to_origin"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if secondary_multipath_to_origin is not None:
            self._values["secondary_multipath_to_origin"] = secondary_multipath_to_origin
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Mobile App Performance SDK.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends secondary multi-path requests to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        '''
        result = self._values.get("secondary_multipath_to_origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformanceOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformanceOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174f0dd63e81f566ce89803816979f27214dd3bcbe10f3e610ab5761606f05de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondaryMultipathToOrigin")
    def reset_secondary_multipath_to_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondaryMultipathToOrigin", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOriginInput")
    def secondary_multipath_to_origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondaryMultipathToOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c20560aed2b4c0b2a74cd3e073b46aff51e0bdb842e2d58b7144eefcf23fed53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4319da64a26990d7720a28b9293b4b4678c88335247815dbe68b3507644836ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOrigin")
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondaryMultipathToOrigin"))

    @secondary_multipath_to_origin.setter
    def secondary_multipath_to_origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95fee70bfd4219210b2a3d57e5732a643658d845fca25a8f4634d5a959bb62c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondaryMultipathToOrigin", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56fae786976ae52078aeb3f3ac2539394081333ebf1be63b7963ef7186f94dfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7446f2284dd869258d3d228b58a8e46ff782a24cdb536b2ed62cbfee6f9e1dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c52ea35b7b0831e342b6695e221c84fcf0dbc7c2a924669a2d49a7241929d539)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6fd5d841629f339751ad5f96a2ed757d91efd4a7505b0ca45813bef7ce6303)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Supplies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47fcb46927e7f363989cf5c2bb67f6b65b545a23ddd19febb32c4b1ffc1506fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5cd4f2253917746ce72601c31208de6fbc7ecbfff1f559ee57062ea3eb3f9c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9d58c86a5c5a574478c0480b121555b4c5c221cb07e837ccc0ad6c4a97abe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c38b76be47c8cd0a68b1e151225538223aa0fe4b553d278e673fcd0ffdefe8e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e98cb21650715b01c40c4361fc98a061e4211315c4764f2458eb01ea0bb801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f68a901ff1c74d64b843edab15e957f475335d104dbc4cd8f26c68c407d530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d93a6b7a8ca544aa7143cb846f45cc09e9bcd9c3a74efe489fb759b67cf45a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5922d4a2980f5e329171ad177034d32980b80653b5b600e633b65f3589b00167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eca3a008fd3697cfce269b273950816d17e81d238e22319e48046aa4ff5ad8f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae84a20ee60f05a947a7a5e0f82ab3c54110910f35869a6151eec6cede324b43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8cab3a86514a2638e797e7a3f547b9541f3e10398fcaa4e9ed6e3bd66ff0724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1edd111f6b760884e02adf78ec99b4c52b9a744ac63c96601368e8e208f08795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a0063c17b2418c6af3733efdc1be0bc7a5cb4a64a67b401aac480ae55c1bce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f62561f226b0e5b30a6c1bdac592cc2d058218b0563a273327cb4834212da45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf75156ab6df59bc6fdc15e756e6145c41cc5a4746a723578dc20439c04d146)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the header's new value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0360e18c0eae0e92c0f41f7f6653228a32bf6776ec9aaf8550945caeb5432bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263daa1915bfe8ed45f46ce54804bfe9dcdce559e272ae8f472ebebe98b87687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450e4d80330299f16fef531bbe1cb79111ddb6159506f8b45b594c64e01cbca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e8ddd338a89584468ff616575bfd49ade76c47ef844e9641eea7ce5f778fde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a71700f9be54621ae3ac9ab35a53dff4a58a2291a41b2f7405c0567e875ff5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad4ef4ef5c546f731033ec68b7f61c71d4be0264248d5f71f6b57690f771e78c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2010187d5533802582ae1c55a2685ce1684361e4747b5bf30155c57cafbf17d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00eb07ee1d7e0bab7ee2930f94427cd7bebdf088dfcdf327132d04b626a2207e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c49026b30a90e38f897b7caf13b9cd14f55681b8c0b3a7809402092a00cb706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c3d3f3883d0afc07fdf07c41f37138021d7fb8e5f32596ec49d36291a28674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__392d9e15c1555024acfb24b1e0aef7db23bc472e424832609ffc1ff53823a903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343162f4037672b186726acdcccdde10c5b6c4872585f00c173d5131df1e8e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f8683fa853439532c3940a02db613463137b2516ea9592b11be552b72273a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66492182e322d9950cc5242e017a72f5f7cc919f538a2a11433e825bbec6b964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55662e821f844c073fb40d2786d6000ce698c793818b939a3b3e0fc96679d2ae)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ca7a8032894a8ce73837150655ec1aa00807892001a890b29e89a42adcbe76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc815ca1d9158b0ee4770a837701eb858e72bc4b95c48c59aa22f65fad5a959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4823aee033fb0bf938492d8ff7b6e17d47ee5913e739f2714a7cb17ecf9ed697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525d06f1b69dbaead09011cb1f70f17d28a7586f200c5b4115dc5e137593c228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398fe82f840e452e9433f693ce70d727bd8d2af8f9bc619b5f1a4352edc11f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e6f6a559bb01298a0deee927cb937d2ff1e8d73ce3168a7d22df5902bb13a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ff3e4dedccfd6dcf6e1099096d58d2737e9dce9a37d99bf1a16421d24e1e37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069ccbb21dad1ad5d1630d5aa47a9e817fd8cb6b5c9606010ca87542546908cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818e00489a66630f13ba02022d4b04508e7ee1265725d2504ca7846ee58b3941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09bb39c6a0559f41c51ed93a694e0b7b8f9b5362218f945e85f82fa7d28e9a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17e03d30e3a19f13357f660e36c5b21889333c3e067435876ed56ac84541899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac10a38d51953caee57f135f2fe4d01d722f15c567d6303a8a67f952b3c1e429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ef59d3d2556d27700472587b00e8c77b8e55e973d9ab85bbd2e310bf540a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f96210aba7cbfba67926fde0f7194de72d79f38fca6454270a665c78934c22a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da33081663e6733068f15ddf400c3dc403c6d0bcc5248fd994b94c7892ac8e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e6942a8f6e1bcf0134ac484659c8a79a1b34fb29c466ca8632c94780c04ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347a440f50522715593a5462b6d52426d036c1eb0390480aaa85fd24c79a8378)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the existing value of the header to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c171786f53eaa613cffb7141b3c695827acd7cdc4b25755c4a5a532e0896c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf530f3d60a1c58de41486727289fbf6d9710214cb6f5ccccac89100b9feee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f3f1c9733cc01d86884f025206fd83e3d6313f42f2ae422f861653858d7f607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0dabfac234230804dd926464612e55a527005e001d3492c5cef06eaa829e7b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5376830158f8cd8aa7a3a90d1d93e9717fb12533d5cc4451f00bec5ec8d67cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc4f57db58c1ac2219e7690daa9ab6e42eee9a70e776a644dd53c60d40b23e3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1ba4cd6ff340e53ea1b7b094f09875734d047f42b8f2b8a46b78450afa2e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29315188e2fdd8945038783b41d60150a0f2e67b1f3d8791499537824e93b795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8862133b071526e1e80ac1b6962ed540defffbb5aae2d53948809c84d4a182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8853bdb40c90145c535a9210d504e4840743ce9ea631eb323975ec6dbf393e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a803483157c7ad6c283fcceb39c2fb68ffa912c688e6ea27a1cb4e1fdff6f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ee0781a1c6f1f97d32270c6802dc5781c106e9c9cfd343306d17a338a7841d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9badfcf52ea1afb86d61894e590dc8819f8acca87f26cb8528049d9671fc99d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9695aa0842138661ae297a04433722cce16b56958e0885d5a62a847bbd26a5ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a46958f5f0c654141b55a83143ddfa118e4f5f54141053e3f7195a7973bb03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eace61c826d2b33a21660075ef0682764b4ceee6637f46f9b89323fcb5424c9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "modification_option": "modificationOption",
        "rename_header_to": "renameHeaderTo",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db31795c0f5e398f4c3f8593ba772e5cfab5cd2ff329a27cd71a228e730af12)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modification_option", value=modification_option, expected_type=type_hints["modification_option"])
            check_type(argname="argument rename_header_to", value=rename_header_to, expected_type=type_hints["rename_header_to"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modification_option is not None:
            self._values["modification_option"] = modification_option
        if rename_header_to is not None:
            self._values["rename_header_to"] = rename_header_to
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``Via`` header modifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modification_option(self) -> typing.Optional[builtins.str]:
        '''Specify how you want to handle the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        '''
        result = self._values.get("modification_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rename_header_to(self) -> typing.Optional[builtins.str]:
        '''Specifies a new name to replace the existing ``Via`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        '''
        result = self._values.get("rename_header_to")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8547b62758a7d2f0c30e9d855408ddcf6b0972d9e42ff619183818a45ac2c61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModificationOption")
    def reset_modification_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModificationOption", []))

    @jsii.member(jsii_name="resetRenameHeaderTo")
    def reset_rename_header_to(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRenameHeaderTo", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modificationOptionInput")
    def modification_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "modificationOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="renameHeaderToInput")
    def rename_header_to_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "renameHeaderToInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f447e03bffe4d87fbbbd9943d3c808bf2d3ca214d238ad5ac4c799c85e5ddf76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e20fb9ac82939d940b6fc630bf265f6ec1b8383a31bf8bd31894b80b1ff9f6d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modificationOption")
    def modification_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "modificationOption"))

    @modification_option.setter
    def modification_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd975a2727af375fce5c22012c68b77b8d34f6014d83a2c36e73276e204e449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modificationOption", value)

    @builtins.property
    @jsii.member(jsii_name="renameHeaderTo")
    def rename_header_to(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "renameHeaderTo"))

    @rename_header_to.setter
    def rename_header_to(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de745fb794356edfe3611d7226a463f1bc3ab86cddc6327b943e299df8546c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "renameHeaderTo", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8bcbdda0d9c6fd7ac81b9df2d236eb5c2c3c006185a0f33c8a69c9bb2c83ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5147e50fabd9a1faa9265faca75807ad299b7c71d321c8eb9a7ee46088374485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8548f0480ea2c08b54449ffda12eccd9ff42ddfe5ef0672e4ccb9fea46d06efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cache_key_hostname": "cacheKeyHostname",
        "compress": "compress",
        "custom_certificate_authorities": "customCertificateAuthorities",
        "custom_certificates": "customCertificates",
        "custom_forward_host_header": "customForwardHostHeader",
        "custom_valid_cn_values": "customValidCnValues",
        "enable_true_client_ip": "enableTrueClientIp",
        "forward_host_header": "forwardHostHeader",
        "hostname": "hostname",
        "http_port": "httpPort",
        "https_port": "httpsPort",
        "ip_version": "ipVersion",
        "locked": "locked",
        "mslorigin": "mslorigin",
        "net_storage": "netStorage",
        "origin_certificate": "originCertificate",
        "origin_certs_to_honor": "originCertsToHonor",
        "origin_id": "originId",
        "origin_sni": "originSni",
        "origin_type": "originType",
        "ports": "ports",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "second_hostname": "secondHostname",
        "second_hostname_enabled": "secondHostnameEnabled",
        "standard_certificate_authorities": "standardCertificateAuthorities",
        "template_uuid": "templateUuid",
        "true_client_ip_client_setting": "trueClientIpClientSetting",
        "true_client_ip_header": "trueClientIpHeader",
        "use_unique_cache_key": "useUniqueCacheKey",
        "uuid": "uuid",
        "verification_mode": "verificationMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin:
    def __init__(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685eae61c083d186330bf98a83dea6c4e0924092771105597871bbdc26237f32)
            check_type(argname="argument cache_key_hostname", value=cache_key_hostname, expected_type=type_hints["cache_key_hostname"])
            check_type(argname="argument compress", value=compress, expected_type=type_hints["compress"])
            check_type(argname="argument custom_certificate_authorities", value=custom_certificate_authorities, expected_type=type_hints["custom_certificate_authorities"])
            check_type(argname="argument custom_certificates", value=custom_certificates, expected_type=type_hints["custom_certificates"])
            check_type(argname="argument custom_forward_host_header", value=custom_forward_host_header, expected_type=type_hints["custom_forward_host_header"])
            check_type(argname="argument custom_valid_cn_values", value=custom_valid_cn_values, expected_type=type_hints["custom_valid_cn_values"])
            check_type(argname="argument enable_true_client_ip", value=enable_true_client_ip, expected_type=type_hints["enable_true_client_ip"])
            check_type(argname="argument forward_host_header", value=forward_host_header, expected_type=type_hints["forward_host_header"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument http_port", value=http_port, expected_type=type_hints["http_port"])
            check_type(argname="argument https_port", value=https_port, expected_type=type_hints["https_port"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mslorigin", value=mslorigin, expected_type=type_hints["mslorigin"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument origin_certificate", value=origin_certificate, expected_type=type_hints["origin_certificate"])
            check_type(argname="argument origin_certs_to_honor", value=origin_certs_to_honor, expected_type=type_hints["origin_certs_to_honor"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument origin_sni", value=origin_sni, expected_type=type_hints["origin_sni"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument ports", value=ports, expected_type=type_hints["ports"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument second_hostname", value=second_hostname, expected_type=type_hints["second_hostname"])
            check_type(argname="argument second_hostname_enabled", value=second_hostname_enabled, expected_type=type_hints["second_hostname_enabled"])
            check_type(argname="argument standard_certificate_authorities", value=standard_certificate_authorities, expected_type=type_hints["standard_certificate_authorities"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument true_client_ip_client_setting", value=true_client_ip_client_setting, expected_type=type_hints["true_client_ip_client_setting"])
            check_type(argname="argument true_client_ip_header", value=true_client_ip_header, expected_type=type_hints["true_client_ip_header"])
            check_type(argname="argument use_unique_cache_key", value=use_unique_cache_key, expected_type=type_hints["use_unique_cache_key"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_mode", value=verification_mode, expected_type=type_hints["verification_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_key_hostname is not None:
            self._values["cache_key_hostname"] = cache_key_hostname
        if compress is not None:
            self._values["compress"] = compress
        if custom_certificate_authorities is not None:
            self._values["custom_certificate_authorities"] = custom_certificate_authorities
        if custom_certificates is not None:
            self._values["custom_certificates"] = custom_certificates
        if custom_forward_host_header is not None:
            self._values["custom_forward_host_header"] = custom_forward_host_header
        if custom_valid_cn_values is not None:
            self._values["custom_valid_cn_values"] = custom_valid_cn_values
        if enable_true_client_ip is not None:
            self._values["enable_true_client_ip"] = enable_true_client_ip
        if forward_host_header is not None:
            self._values["forward_host_header"] = forward_host_header
        if hostname is not None:
            self._values["hostname"] = hostname
        if http_port is not None:
            self._values["http_port"] = http_port
        if https_port is not None:
            self._values["https_port"] = https_port
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if locked is not None:
            self._values["locked"] = locked
        if mslorigin is not None:
            self._values["mslorigin"] = mslorigin
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if origin_certificate is not None:
            self._values["origin_certificate"] = origin_certificate
        if origin_certs_to_honor is not None:
            self._values["origin_certs_to_honor"] = origin_certs_to_honor
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if origin_sni is not None:
            self._values["origin_sni"] = origin_sni
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if ports is not None:
            self._values["ports"] = ports
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if second_hostname is not None:
            self._values["second_hostname"] = second_hostname
        if second_hostname_enabled is not None:
            self._values["second_hostname_enabled"] = second_hostname_enabled
        if standard_certificate_authorities is not None:
            self._values["standard_certificate_authorities"] = standard_certificate_authorities
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if true_client_ip_client_setting is not None:
            self._values["true_client_ip_client_setting"] = true_client_ip_client_setting
        if true_client_ip_header is not None:
            self._values["true_client_ip_header"] = true_client_ip_header
        if use_unique_cache_key is not None:
            self._values["use_unique_cache_key"] = use_unique_cache_key
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_mode is not None:
            self._values["verification_mode"] = verification_mode

    @builtins.property
    def cache_key_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to use when forming a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        '''
        result = self._values.get("cache_key_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compress(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``gzip`` compression for non-NetStorage origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        '''
        result = self._values.get("compress")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_certificate_authorities(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities"]]]:
        '''custom_certificate_authorities block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        '''
        result = self._values.get("custom_certificate_authorities")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities"]]], result)

    @builtins.property
    def custom_certificates(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates"]]]:
        '''custom_certificates block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        '''
        result = self._values.get("custom_certificates")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates"]]], result)

    @builtins.property
    def custom_forward_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the custom host header the edge server should pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        '''
        result = self._values.get("custom_forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_valid_cn_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields.

        Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        '''
        result = self._values.get("custom_valid_cn_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_true_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server.

        This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        '''
        result = self._values.get("enable_true_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_host_header(self) -> typing.Optional[builtins.str]:
        '''When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        '''
        result = self._values.get("forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        '''
        result = self._values.get("http_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def https_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``.

        This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        '''
        result = self._values.get("https_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP version to use when getting content from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mslorigin(self) -> typing.Optional[builtins.str]:
        '''This specifies the media's origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        '''
        result = self._values.get("mslorigin")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage"], result)

    @builtins.property
    def origin_certificate(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        '''
        result = self._values.get("origin_certificate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_certs_to_honor(self) -> typing.Optional[builtins.str]:
        '''Specifies which certificate to trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        '''
        result = self._values.get("origin_certs_to_honor")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the Edge Load Balancing origin.

        This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_sni(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value.

        See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        '''
        result = self._values.get("origin_sni")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Choose where your content is retrieved from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ports(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        '''
        result = self._values.get("ports")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies replacement text for what ``saasRegex`` matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static part of the SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of the request that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        '''
        result = self._values.get("second_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Available only for certain products. This specifies whether you want to use an additional origin server address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        '''
        result = self._values.get("second_hostname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def standard_certificate_authorities(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.'''
        result = self._values.get("standard_certificate_authorities")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def true_client_ip_client_setting(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin.

        Otherwise the edge server removes it and sets the value itself.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        '''
        result = self._values.get("true_client_ip_client_setting")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def true_client_ip_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        '''
        result = self._values.get("true_client_ip_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_unique_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        '''
        result = self._values.get("use_unique_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_mode(self) -> typing.Optional[builtins.str]:
        '''For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        result = self._values.get("verification_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "access_key_encrypted_storage": "accessKeyEncryptedStorage",
        "adc_title": "adcTitle",
        "authentication_method": "authenticationMethod",
        "authentication_method_title": "authenticationMethodTitle",
        "aws_access_key_id": "awsAccessKeyId",
        "aws_access_key_version_guid": "awsAccessKeyVersionGuid",
        "aws_host": "awsHost",
        "aws_region": "awsRegion",
        "aws_secret_access_key": "awsSecretAccessKey",
        "aws_service": "awsService",
        "country": "country",
        "custom_sign_string": "customSignString",
        "direct_connect_geo": "directConnectGeo",
        "encoding_version": "encodingVersion",
        "gcs_access_key_version_guid": "gcsAccessKeyVersionGuid",
        "gcs_hmac_key_access_id": "gcsHmacKeyAccessId",
        "gcs_hmac_key_secret": "gcsHmacKeySecret",
        "locked": "locked",
        "mslkey": "mslkey",
        "mslname": "mslname",
        "nonce": "nonce",
        "secret_key": "secretKey",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics:
    def __init__(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523ee84e1ca703c77ab9edba579b041f5db1e796fc265ccb37c03f0f4ee7c4b2)
            check_type(argname="argument access_key_encrypted_storage", value=access_key_encrypted_storage, expected_type=type_hints["access_key_encrypted_storage"])
            check_type(argname="argument adc_title", value=adc_title, expected_type=type_hints["adc_title"])
            check_type(argname="argument authentication_method", value=authentication_method, expected_type=type_hints["authentication_method"])
            check_type(argname="argument authentication_method_title", value=authentication_method_title, expected_type=type_hints["authentication_method_title"])
            check_type(argname="argument aws_access_key_id", value=aws_access_key_id, expected_type=type_hints["aws_access_key_id"])
            check_type(argname="argument aws_access_key_version_guid", value=aws_access_key_version_guid, expected_type=type_hints["aws_access_key_version_guid"])
            check_type(argname="argument aws_host", value=aws_host, expected_type=type_hints["aws_host"])
            check_type(argname="argument aws_region", value=aws_region, expected_type=type_hints["aws_region"])
            check_type(argname="argument aws_secret_access_key", value=aws_secret_access_key, expected_type=type_hints["aws_secret_access_key"])
            check_type(argname="argument aws_service", value=aws_service, expected_type=type_hints["aws_service"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument direct_connect_geo", value=direct_connect_geo, expected_type=type_hints["direct_connect_geo"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument gcs_access_key_version_guid", value=gcs_access_key_version_guid, expected_type=type_hints["gcs_access_key_version_guid"])
            check_type(argname="argument gcs_hmac_key_access_id", value=gcs_hmac_key_access_id, expected_type=type_hints["gcs_hmac_key_access_id"])
            check_type(argname="argument gcs_hmac_key_secret", value=gcs_hmac_key_secret, expected_type=type_hints["gcs_hmac_key_secret"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mslkey", value=mslkey, expected_type=type_hints["mslkey"])
            check_type(argname="argument mslname", value=mslname, expected_type=type_hints["mslname"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_key_encrypted_storage is not None:
            self._values["access_key_encrypted_storage"] = access_key_encrypted_storage
        if adc_title is not None:
            self._values["adc_title"] = adc_title
        if authentication_method is not None:
            self._values["authentication_method"] = authentication_method
        if authentication_method_title is not None:
            self._values["authentication_method_title"] = authentication_method_title
        if aws_access_key_id is not None:
            self._values["aws_access_key_id"] = aws_access_key_id
        if aws_access_key_version_guid is not None:
            self._values["aws_access_key_version_guid"] = aws_access_key_version_guid
        if aws_host is not None:
            self._values["aws_host"] = aws_host
        if aws_region is not None:
            self._values["aws_region"] = aws_region
        if aws_secret_access_key is not None:
            self._values["aws_secret_access_key"] = aws_secret_access_key
        if aws_service is not None:
            self._values["aws_service"] = aws_service
        if country is not None:
            self._values["country"] = country
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if direct_connect_geo is not None:
            self._values["direct_connect_geo"] = direct_connect_geo
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if gcs_access_key_version_guid is not None:
            self._values["gcs_access_key_version_guid"] = gcs_access_key_version_guid
        if gcs_hmac_key_access_id is not None:
            self._values["gcs_hmac_key_access_id"] = gcs_hmac_key_access_id
        if gcs_hmac_key_secret is not None:
            self._values["gcs_hmac_key_secret"] = gcs_hmac_key_secret
        if locked is not None:
            self._values["locked"] = locked
        if mslkey is not None:
            self._values["mslkey"] = mslkey
        if mslname is not None:
            self._values["mslname"] = mslname
        if nonce is not None:
            self._values["nonce"] = nonce
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def access_key_encrypted_storage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables secure use of access keys defined in Cloud Access Manager.

        Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        '''
        result = self._values.get("access_key_encrypted_storage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def adc_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        '''
        result = self._values.get("adc_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the authentication method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        '''
        result = self._values.get("authentication_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        '''
        result = self._values.get("authentication_method_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_id(self) -> typing.Optional[builtins.str]:
        '''Specifies active access key ID linked to your AWS account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        '''
        result = self._values.get("aws_access_key_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        '''
        result = self._values.get("aws_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes.

        If you leave this option empty, it inherits the hostname from the ``origin`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        '''
        result = self._values.get("aws_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_region(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS region code of the location where your bucket resides.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        '''
        result = self._values.get("aws_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_secret_access_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        '''
        result = self._values.get("aws_secret_access_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_service(self) -> typing.Optional[builtins.str]:
        '''This specifies the subdomain of your AWS service.

        It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        '''
        result = self._values.get("aws_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data to be encrypted as a series of enumerated variable names.

        See ``Built-in system variables`` for guidance on each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def direct_connect_geo(self) -> typing.Optional[builtins.str]:
        '''Provides a region used by Akamai Direct Connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        '''
        result = self._values.get("direct_connect_geo")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def gcs_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        '''
        result = self._values.get("gcs_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_access_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the active access ID linked to your Google account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        '''
        result = self._values.get("gcs_hmac_key_access_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_secret(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        '''
        result = self._values.get("gcs_hmac_key_secret")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mslkey(self) -> typing.Optional[builtins.str]:
        '''Specifies the access key provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        '''
        result = self._values.get("mslkey")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin name provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        '''
        result = self._values.get("mslname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the nonce.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to customize your signed string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fabedfbf3d57c11b519d7499b3c13ccf61040507931b6d259bc243b1412ea347)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessKeyEncryptedStorage")
    def reset_access_key_encrypted_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessKeyEncryptedStorage", []))

    @jsii.member(jsii_name="resetAdcTitle")
    def reset_adc_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdcTitle", []))

    @jsii.member(jsii_name="resetAuthenticationMethod")
    def reset_authentication_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethod", []))

    @jsii.member(jsii_name="resetAuthenticationMethodTitle")
    def reset_authentication_method_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethodTitle", []))

    @jsii.member(jsii_name="resetAwsAccessKeyId")
    def reset_aws_access_key_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyId", []))

    @jsii.member(jsii_name="resetAwsAccessKeyVersionGuid")
    def reset_aws_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetAwsHost")
    def reset_aws_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsHost", []))

    @jsii.member(jsii_name="resetAwsRegion")
    def reset_aws_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsRegion", []))

    @jsii.member(jsii_name="resetAwsSecretAccessKey")
    def reset_aws_secret_access_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsSecretAccessKey", []))

    @jsii.member(jsii_name="resetAwsService")
    def reset_aws_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsService", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDirectConnectGeo")
    def reset_direct_connect_geo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDirectConnectGeo", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetGcsAccessKeyVersionGuid")
    def reset_gcs_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetGcsHmacKeyAccessId")
    def reset_gcs_hmac_key_access_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeyAccessId", []))

    @jsii.member(jsii_name="resetGcsHmacKeySecret")
    def reset_gcs_hmac_key_secret(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeySecret", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMslkey")
    def reset_mslkey(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslkey", []))

    @jsii.member(jsii_name="resetMslname")
    def reset_mslname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslname", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorageInput")
    def access_key_encrypted_storage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessKeyEncryptedStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="adcTitleInput")
    def adc_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "adcTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodInput")
    def authentication_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitleInput")
    def authentication_method_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyIdInput")
    def aws_access_key_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyIdInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuidInput")
    def aws_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="awsHostInput")
    def aws_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsHostInput"))

    @builtins.property
    @jsii.member(jsii_name="awsRegionInput")
    def aws_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKeyInput")
    def aws_secret_access_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsSecretAccessKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="awsServiceInput")
    def aws_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="directConnectGeoInput")
    def direct_connect_geo_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "directConnectGeoInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuidInput")
    def gcs_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessIdInput")
    def gcs_hmac_key_access_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeyAccessIdInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecretInput")
    def gcs_hmac_key_secret_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeySecretInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mslkeyInput")
    def mslkey_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslkeyInput"))

    @builtins.property
    @jsii.member(jsii_name="mslnameInput")
    def mslname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslnameInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorage")
    def access_key_encrypted_storage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessKeyEncryptedStorage"))

    @access_key_encrypted_storage.setter
    def access_key_encrypted_storage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16ead657674ba0c5768bf4bff7bc3aafdf0f50a73249acce1a850444c7a06e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessKeyEncryptedStorage", value)

    @builtins.property
    @jsii.member(jsii_name="adcTitle")
    def adc_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "adcTitle"))

    @adc_title.setter
    def adc_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f78f5d857ef7264cb918d082221ff7554b85a5e25f36e035ec3c8a30bc781b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "adcTitle", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethod")
    def authentication_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethod"))

    @authentication_method.setter
    def authentication_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39e58a72808e8f1500894f74194aacce0486170085dea4d9bc7a24ab9a098142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethod", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitle")
    def authentication_method_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethodTitle"))

    @authentication_method_title.setter
    def authentication_method_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73eb9b83f0e8d6b26323d84d17aa11314c07818c124b8901a5cff1d44d02717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethodTitle", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyId")
    def aws_access_key_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyId"))

    @aws_access_key_id.setter
    def aws_access_key_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5274f3efcf7aa614562dbf59fa4e67c2807633b4eacfe5e7f09dfe1454bcb45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyId", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuid")
    def aws_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyVersionGuid"))

    @aws_access_key_version_guid.setter
    def aws_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb2b769a37c580157b4a59f9387eab9998dabb31072248a301b58a90194c83fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="awsHost")
    def aws_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsHost"))

    @aws_host.setter
    def aws_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac8434fe018d0e8b6cbbbf7ca9fbe0e83dcbf65f2150269c823f09b74c4e556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsHost", value)

    @builtins.property
    @jsii.member(jsii_name="awsRegion")
    def aws_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsRegion"))

    @aws_region.setter
    def aws_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186b4d13cc9053faa69869e86329df01f20882ecd1f6dd41cca0d8acc08e3642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKey")
    def aws_secret_access_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsSecretAccessKey"))

    @aws_secret_access_key.setter
    def aws_secret_access_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ba23be3bc2f1036ab376bf6d05fe27d58271a22e7e462f55dbd2d17304e4a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsSecretAccessKey", value)

    @builtins.property
    @jsii.member(jsii_name="awsService")
    def aws_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsService"))

    @aws_service.setter
    def aws_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d155709d61f92d584875e2acdcd65168d70f8f7b614d46adaee7f199c60ea1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsService", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d93acb6e51272b4cbda2ad4c011b89b5e3f7124e84f24a845f54b461ed18d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91afed080b5240435067d0bd58675c30f90c416bf6427a9850f480c1ad14ff88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="directConnectGeo")
    def direct_connect_geo(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "directConnectGeo"))

    @direct_connect_geo.setter
    def direct_connect_geo(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52a1136b2f9fa5cdf4a5b1421a7901c9a1ec211b75623ac7eb00ae12f8c3528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "directConnectGeo", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0269e57e05366e91312359bb0d5482f66f9c48bac1f969e4f6c24b19a5d3da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuid")
    def gcs_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsAccessKeyVersionGuid"))

    @gcs_access_key_version_guid.setter
    def gcs_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f21bfb2cd3886440df1faebdc6987589c3ab5711ec6b8e3c82f111f67fb7644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessId")
    def gcs_hmac_key_access_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeyAccessId"))

    @gcs_hmac_key_access_id.setter
    def gcs_hmac_key_access_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6028a1b3b03cf27a28c47972821bc2157e8cc14d885671b2cce8d6936ab549e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeyAccessId", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecret")
    def gcs_hmac_key_secret(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeySecret"))

    @gcs_hmac_key_secret.setter
    def gcs_hmac_key_secret(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84260efac5bf145d59fac4ff57f1169a813cc64f6319add2fa721834dc3ed045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeySecret", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef141a9775c4e90cd8fa8f14f95ccf3a1dbab8ffbec1a7d2b95f18fb71fab245)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mslkey")
    def mslkey(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslkey"))

    @mslkey.setter
    def mslkey(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe75e817abc0484e51635d2a44e6d7edef9fcdec13dff9267bc42cf4a9ded44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslkey", value)

    @builtins.property
    @jsii.member(jsii_name="mslname")
    def mslname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslname"))

    @mslname.setter
    def mslname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9eee8333b1b7340ea5f2d899916307500728f3c0d2553593dd37dfcabf281c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslname", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7780ca41206bd73930fe4ae9debbdf7a0fcc633577973c1bf0df13f4bfbc112b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5213ba5e7fa145499314abec508093e89c4d945440096b4695fd88771bdee65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8df5685219fd238e7d1ecbe31ed2b6c97f4b045969b40b4f659d113b2a568c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4bd60629b6c5ab1cb54dba5f3fa41e04549ac349036b6f945b5f6876cc4654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9772b0914337663ae4b71176261f039c0e80c3cfd192bc77e1b7967a8f9a0807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47325d541428b22786f53aa2362af6cb1d360acf7bf11af3d06a4f10033b7998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origintype": "origintype",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5cb556285de71aa117313587380803cc35398420bafc0fa4720e0bb9f008c8)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origintype", value=origintype, expected_type=type_hints["origintype"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origintype is not None:
            self._values["origintype"] = origintype
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origintype(self) -> typing.Optional[builtins.str]:
        '''Specifies an origin type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        '''
        result = self._values.get("origintype")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb9b28b5ffdf0c60648ecf608942104134a7e478c7c9ec8cd7eb4470a2ba661)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOrigintype")
    def reset_origintype(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigintype", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="origintypeInput")
    def origintype_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "origintypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d352121a2f6600045970d55a6fc41b1d0b69a8d90f70367ba60fa7d397cfe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="origintype")
    def origintype(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "origintype"))

    @origintype.setter
    def origintype(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9002c6afc8874d464cc360becd3c9439dd214529ccec4d96c4011d652b411cfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origintype", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495f07b6303df2a566e4f49b064f6d881bba269479aacadc9231ac104407b2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b460b630d5641cc456ee3edda64793127569cec6829938f72972c7a1525564a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a92b28f675f1a46909d0886018c318d28df382841914a68516f5654bd049f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6071d23ac14ae71b290b6728a0c892b24f772cb1181aff5bc5a7004155d417bd)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f178a21d01fcc02fa0dd9eb18ed66e6246977d90289321301233a84a57fda3)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4568bd5df9956aa557afd9cc1ffe469b25e93ac1f5779508efd92785dd50b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca2666efe09e7b563b96249b1ea7dafc78c43fdb97cdb72a19f4f840b05cef64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40be8dfbb222918a9561b934f99a14ef138e8f1a508cc356a2d45637d9a613b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee662eacd50e797b570ffee89ad82b5c5430b5b962736272d23c29ead721bcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8adf839cab2a5e10e09bd0b0ca5ae446b26df5ba076c9ac4454f35999da521b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aefcca396f16d5d2b8a2fe89ff34e47bb3bd227b04175db66514333161ebc9b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7bb9b415ccf6a69f2d4825739da51c078f5e8fe3fe477461bdefed087fa56ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa896a65f1e90b02baf2ed076e7a65820db2b859cbbefc61cf59eb280d772b2)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1065efe96c14af3c94ab5791b5d1ed9fede997e95446fd9198b9ac0c1cfd9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4d85596bf86f863f9d2edecafb7a5d484dc4b6791296588c1a9316b77c3107)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b06d6c7530f27af0eb0f3cb937ec3575ba1d63ba06b9b3d17b5c95d009a34bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2d4c0eed62f417b9c1e7110a00fd95350be0661bd58649ee80f58109f83f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae55bc0f3ade90ada7eea02549e7673f1df184af69337a8e5cfa2abe6691cb2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723e70779642c27dbe19556d520ea9c9caa39b5dd85026960eca373b885efcc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55220a23b8801ca123fc7672b3f61a35d0f6a35791c0d734a83ec8d936ebaaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7197875ec38758640349a29985e2627486ef3fa5a0c445018ec67c44ea59606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45b6a93cbcaf5dca37cd0284b124cfd2f71eb4c7c75069b4ceedf5d69b7c7b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92fc63563e34a94f56ab3d7f884d7e8afbbf27866abe0fce4b407074947a6b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__617ada5ac0e43e43495034b2b0b75a93ce39863878dd38e1363b01c822f5958d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02791dc03981efa9e472b9f9a818b1ff29e3f62eb1999bac93ef03849435445b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7771a09512db5fb376ba70264fbfeed650938b0ae6375db02665df45ca0a722c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0c7dac000c2b98c6ca582195eb5011729fd3a1a635f3401af1da1b8bbb4934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f6761d0d4562581f70deaa083f815b0e855f864ef23aeb1785a8f3ef364211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90bdf7ad6e17c17beb7887b5ba355e27a497e76ba80888faf45ac2fd3506ac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df476f510be18a02e11ce1516f4637472bee60604611cee6f6ab903ad17c6e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e49ae29d2f279e1c38ba50f2d64dbd04ee01fd1bd6182361610b67c50578c23d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed5672f56e04c7673048e94b36d3b75761cad34ee0a7caab2f376c9d0521180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a36b63f4afb9851049ab1cb087dbd019c3f2e9d66942e7221e23c02ea6bf1a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a1f9ab520acefb092450d12fbf4464f88779a4c786ac1a29ad8d0599355731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5c74c2cf5bf255f8b315488a4b12d43d1924009c5dd3b9aef5de2a593ca1c1)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0d4241dd5f29bc49ace719a0dd4f9219a867de8b8ef95dddfda655c330a34e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__016b2e7f8551b48c0381d2ab4910898235da626e85447d5e9dbfb11d8d269379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb53c3442d490b2aadb9701fc66aeb880d3df82f4844a9cef96906c03eccde9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853e2ffb4f391756e6af207079ac4b3b98cb75ecb16607111986ac178aa082fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec1fab4e16506acab193b529aff385565ac66fdaf566c5f64d60c8b563ec0fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb17ff09a5ce0a98503f102276e6a2c13867b8fd95529e26989fd771a96d6ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f8692b4973492060b6a96c160174a07d6a6a0f27a97b9501b5520f2c9f6b6dd)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790786596d9bb4f5048ab08e03d8122f92bb017783e733c589d130210610cc99)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492a5c655ec1aebc335bceb2e93a9ffb4a90a7baed4f8a2f7df9c23e95265872)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a9c98861c17cb46cfd3523f3e8f3b962f3319758b79f6d4ebe424e8f5dfe80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1b0f6da5a2a95f1cbca35d0319daf83af77c84a0d9f07af5c61dc1adb15aae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d443eda85a8b92aa4bb6b0a1cfd975f5edceb138a6c666def2d49e663ff6b189)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54adf2bc0a3be5c3bf17da75054938109ead92dbca27ab1178646c0cf77bb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fb49a6bb3e080d3fdc7e8821f095b1a66a697be998a0cf0f42f83b28362bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01038abbbca63fcf4876810a779bcaf36041b5a42ac05fb4ac3b668275c04baf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fcb04e409a30ba4276306aa0e4c728376fe775429deae5777cd1925e5d2cec9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ee350f2a4e20d461dbf323f49ab0760c99d91478c60e4b3bab0b7a44ff6f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__593d0984b985442a600246277ff83fcc12f2091ecca5e3d36eadd39cc107758c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a49b697351627de7a5f652bfaf72f1348cb109d4f19c1b61690a77d1c92bf7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae7af7ce8e99e03186feea839fd92eedf89ad949039683fce6abedd52fffc6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fa8b8dfc0a406a9309a305b827321ec58847fe0a8322846ac656121d1dcfeb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b5c66cff31d93e1d23281ccd9b9d9751d5521eff63ac43e75450c6b77f8704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3bf4f3712b261625e55f74660af1480d3a628ceb8618dd5d60b8ad1011e0223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad72966c6b0c7d511012c37496399fb72dba8d9595e005ae4e700b33e9b92920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ae116d01079ea7e6795eae57ff75ebd47f199a857a3c91b07d460d203724e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5880c32ff9236b6cb2bde787b1a37594de9b8554d641a15fa989d9de5fd644b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2fc9257a3083fb36768d1d4b7b5cf73877374132429a092bc0c30c11f38791b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711598a27dbeadd4dbc95a6a33bcccaac815d6eb00c8fefcecb1c4220a4332ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb4b99fbc81e3f7a88c15996ba8a5ebec5a311c200a72d074849f260b2f665f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0bd128db884694d4a5eb77bf49daf081ff39c7e7ae664ac67cec8a374ace63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e41846edbd4bfac41e77964361ce7fefb2332fc27325815bb10361914850ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec9fd9d0842e9fc6b829af1d3bcef27f8586ed504a87e77a181219fe7467bfd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8977d4cf4374fff01946c9fd3750e6f62d208b7c0b59d157d1d16379295cafb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe8eee389fe46339a051ce4210c766e3b576c0a217016b202f1d1b11143ddbf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcb707133f849baae51ea6924a1c248a8ae63d6ddb61fad9649708c302f4e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc1619676c4da74aaf116f855b2d1f6be05d5280e74a76b6b48ba87a43fb658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bcc804e3fef7b6ab0497c60ad918e2063fabc6a32b7d976533cdff105c0aef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c354da404f7357aa0df8dde9df0fd67499cf006044f908b78c0c0a052a603c9)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfeebb17049df608eab22182e24e6f3365b685be38857aeec4d71d80a6a8447b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77bf2948a5f9b57fa81468cd004182b759ccb6412842472ecb17db08aa2a411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__886298c4f29bd6504ea2cdce4487d7601118dd3e065555fd8ffd2cfb0c229af0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4686f75ee8f7af53bd558988c873791c43befddda5a70aeecc4e185dad147f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64cb21e54dcb55ea8a50d0305bee30c79428844843b741b0d579b576a630d083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6e3aa0a187bb9cb0c754c86814e764571401c6ea3bb4599b4ef89e0dfda44e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod",
    jsii_struct_bases=[],
    name_mapping={
        "custom_status_code": "customStatusCode",
        "locked": "locked",
        "recovery_method": "recoveryMethod",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod:
    def __init__(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0a6cc761b0770f2451c37f70c54f0007b6bda987ddff274f55a48d2f3e4040)
            check_type(argname="argument custom_status_code", value=custom_status_code, expected_type=type_hints["custom_status_code"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument recovery_method", value=recovery_method, expected_type=type_hints["recovery_method"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_status_code is not None:
            self._values["custom_status_code"] = custom_status_code
        if locked is not None:
            self._values["locked"] = locked
        if recovery_method is not None:
            self._values["recovery_method"] = recovery_method
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom status code to be sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        '''
        result = self._values.get("custom_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def recovery_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        '''
        result = self._values.get("recovery_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c96a409bcea79fb9ba3b0c8b4d3ce319a0e1bdd1153359b45e1bc63501aecd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomStatusCode")
    def reset_custom_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatusCode", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRecoveryMethod")
    def reset_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryMethod", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customStatusCodeInput")
    def custom_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryMethodInput")
    def recovery_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "recoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatusCode")
    def custom_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatusCode"))

    @custom_status_code.setter
    def custom_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed8b57a4de6c020bbf820a8654d9a330e59db242c9d2ce3e4adb2f984125b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082e33b9ed2325ff23b220127d6b51da72f816776a2d672325e1b250a1de550c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="recoveryMethod")
    def recovery_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "recoveryMethod"))

    @recovery_method.setter
    def recovery_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0051fdd8615b7bb70b5981dbeb22ee267f70d42a3652e433cbef9b2287cdc32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "recoveryMethod", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ec1f25fd78e724c05dc24384994e33dbddccdd075b099fb2b83ef9a93965c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322e88898b8351935bd99658c590dda68a56e671746dbe1bcc437aaf6e2cc605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7d947f8776966c644c53151626b5c3c16a35a8ec5d2681b56aba84c0254c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "binary_equivalent_content": "binaryEquivalentContent",
        "enabled": "enabled",
        "enable_ip_avoidance": "enableIpAvoidance",
        "ip_avoidance_error_threshold": "ipAvoidanceErrorThreshold",
        "ip_avoidance_retry_interval": "ipAvoidanceRetryInterval",
        "locked": "locked",
        "monitor_origin_responsiveness": "monitorOriginResponsiveness",
        "monitor_response_codes1": "monitorResponseCodes1",
        "monitor_response_codes2": "monitorResponseCodes2",
        "monitor_response_codes3": "monitorResponseCodes3",
        "monitor_status_codes1": "monitorStatusCodes1",
        "monitor_status_codes1_enable_recovery": "monitorStatusCodes1EnableRecovery",
        "monitor_status_codes1_enable_retry": "monitorStatusCodes1EnableRetry",
        "monitor_status_codes1_recovery_config_name": "monitorStatusCodes1RecoveryConfigName",
        "monitor_status_codes2": "monitorStatusCodes2",
        "monitor_status_codes2_enable_recovery": "monitorStatusCodes2EnableRecovery",
        "monitor_status_codes2_enable_retry": "monitorStatusCodes2EnableRetry",
        "monitor_status_codes2_recovery_config_name": "monitorStatusCodes2RecoveryConfigName",
        "monitor_status_codes3": "monitorStatusCodes3",
        "monitor_status_codes3_enable_recovery": "monitorStatusCodes3EnableRecovery",
        "monitor_status_codes3_enable_retry": "monitorStatusCodes3EnableRetry",
        "monitor_status_codes3_recovery_config_name": "monitorStatusCodes3RecoveryConfigName",
        "origin_responsiveness_custom_timeout": "originResponsivenessCustomTimeout",
        "origin_responsiveness_enable_recovery": "originResponsivenessEnableRecovery",
        "origin_responsiveness_enable_retry": "originResponsivenessEnableRetry",
        "origin_responsiveness_monitoring": "originResponsivenessMonitoring",
        "origin_responsiveness_recovery_config_name": "originResponsivenessRecoveryConfigName",
        "origin_responsiveness_timeout": "originResponsivenessTimeout",
        "status_code_monitoring1": "statusCodeMonitoring1",
        "status_code_monitoring2": "statusCodeMonitoring2",
        "status_code_monitoring3": "statusCodeMonitoring3",
        "template_uuid": "templateUuid",
        "tuning_parameters": "tuningParameters",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy:
    def __init__(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae28f3df58bd42566a361f99927c8151d8d0f05306e6680c86ca4298e48d813)
            check_type(argname="argument binary_equivalent_content", value=binary_equivalent_content, expected_type=type_hints["binary_equivalent_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_ip_avoidance", value=enable_ip_avoidance, expected_type=type_hints["enable_ip_avoidance"])
            check_type(argname="argument ip_avoidance_error_threshold", value=ip_avoidance_error_threshold, expected_type=type_hints["ip_avoidance_error_threshold"])
            check_type(argname="argument ip_avoidance_retry_interval", value=ip_avoidance_retry_interval, expected_type=type_hints["ip_avoidance_retry_interval"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument monitor_origin_responsiveness", value=monitor_origin_responsiveness, expected_type=type_hints["monitor_origin_responsiveness"])
            check_type(argname="argument monitor_response_codes1", value=monitor_response_codes1, expected_type=type_hints["monitor_response_codes1"])
            check_type(argname="argument monitor_response_codes2", value=monitor_response_codes2, expected_type=type_hints["monitor_response_codes2"])
            check_type(argname="argument monitor_response_codes3", value=monitor_response_codes3, expected_type=type_hints["monitor_response_codes3"])
            check_type(argname="argument monitor_status_codes1", value=monitor_status_codes1, expected_type=type_hints["monitor_status_codes1"])
            check_type(argname="argument monitor_status_codes1_enable_recovery", value=monitor_status_codes1_enable_recovery, expected_type=type_hints["monitor_status_codes1_enable_recovery"])
            check_type(argname="argument monitor_status_codes1_enable_retry", value=monitor_status_codes1_enable_retry, expected_type=type_hints["monitor_status_codes1_enable_retry"])
            check_type(argname="argument monitor_status_codes1_recovery_config_name", value=monitor_status_codes1_recovery_config_name, expected_type=type_hints["monitor_status_codes1_recovery_config_name"])
            check_type(argname="argument monitor_status_codes2", value=monitor_status_codes2, expected_type=type_hints["monitor_status_codes2"])
            check_type(argname="argument monitor_status_codes2_enable_recovery", value=monitor_status_codes2_enable_recovery, expected_type=type_hints["monitor_status_codes2_enable_recovery"])
            check_type(argname="argument monitor_status_codes2_enable_retry", value=monitor_status_codes2_enable_retry, expected_type=type_hints["monitor_status_codes2_enable_retry"])
            check_type(argname="argument monitor_status_codes2_recovery_config_name", value=monitor_status_codes2_recovery_config_name, expected_type=type_hints["monitor_status_codes2_recovery_config_name"])
            check_type(argname="argument monitor_status_codes3", value=monitor_status_codes3, expected_type=type_hints["monitor_status_codes3"])
            check_type(argname="argument monitor_status_codes3_enable_recovery", value=monitor_status_codes3_enable_recovery, expected_type=type_hints["monitor_status_codes3_enable_recovery"])
            check_type(argname="argument monitor_status_codes3_enable_retry", value=monitor_status_codes3_enable_retry, expected_type=type_hints["monitor_status_codes3_enable_retry"])
            check_type(argname="argument monitor_status_codes3_recovery_config_name", value=monitor_status_codes3_recovery_config_name, expected_type=type_hints["monitor_status_codes3_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_custom_timeout", value=origin_responsiveness_custom_timeout, expected_type=type_hints["origin_responsiveness_custom_timeout"])
            check_type(argname="argument origin_responsiveness_enable_recovery", value=origin_responsiveness_enable_recovery, expected_type=type_hints["origin_responsiveness_enable_recovery"])
            check_type(argname="argument origin_responsiveness_enable_retry", value=origin_responsiveness_enable_retry, expected_type=type_hints["origin_responsiveness_enable_retry"])
            check_type(argname="argument origin_responsiveness_monitoring", value=origin_responsiveness_monitoring, expected_type=type_hints["origin_responsiveness_monitoring"])
            check_type(argname="argument origin_responsiveness_recovery_config_name", value=origin_responsiveness_recovery_config_name, expected_type=type_hints["origin_responsiveness_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_timeout", value=origin_responsiveness_timeout, expected_type=type_hints["origin_responsiveness_timeout"])
            check_type(argname="argument status_code_monitoring1", value=status_code_monitoring1, expected_type=type_hints["status_code_monitoring1"])
            check_type(argname="argument status_code_monitoring2", value=status_code_monitoring2, expected_type=type_hints["status_code_monitoring2"])
            check_type(argname="argument status_code_monitoring3", value=status_code_monitoring3, expected_type=type_hints["status_code_monitoring3"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tuning_parameters", value=tuning_parameters, expected_type=type_hints["tuning_parameters"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if binary_equivalent_content is not None:
            self._values["binary_equivalent_content"] = binary_equivalent_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_ip_avoidance is not None:
            self._values["enable_ip_avoidance"] = enable_ip_avoidance
        if ip_avoidance_error_threshold is not None:
            self._values["ip_avoidance_error_threshold"] = ip_avoidance_error_threshold
        if ip_avoidance_retry_interval is not None:
            self._values["ip_avoidance_retry_interval"] = ip_avoidance_retry_interval
        if locked is not None:
            self._values["locked"] = locked
        if monitor_origin_responsiveness is not None:
            self._values["monitor_origin_responsiveness"] = monitor_origin_responsiveness
        if monitor_response_codes1 is not None:
            self._values["monitor_response_codes1"] = monitor_response_codes1
        if monitor_response_codes2 is not None:
            self._values["monitor_response_codes2"] = monitor_response_codes2
        if monitor_response_codes3 is not None:
            self._values["monitor_response_codes3"] = monitor_response_codes3
        if monitor_status_codes1 is not None:
            self._values["monitor_status_codes1"] = monitor_status_codes1
        if monitor_status_codes1_enable_recovery is not None:
            self._values["monitor_status_codes1_enable_recovery"] = monitor_status_codes1_enable_recovery
        if monitor_status_codes1_enable_retry is not None:
            self._values["monitor_status_codes1_enable_retry"] = monitor_status_codes1_enable_retry
        if monitor_status_codes1_recovery_config_name is not None:
            self._values["monitor_status_codes1_recovery_config_name"] = monitor_status_codes1_recovery_config_name
        if monitor_status_codes2 is not None:
            self._values["monitor_status_codes2"] = monitor_status_codes2
        if monitor_status_codes2_enable_recovery is not None:
            self._values["monitor_status_codes2_enable_recovery"] = monitor_status_codes2_enable_recovery
        if monitor_status_codes2_enable_retry is not None:
            self._values["monitor_status_codes2_enable_retry"] = monitor_status_codes2_enable_retry
        if monitor_status_codes2_recovery_config_name is not None:
            self._values["monitor_status_codes2_recovery_config_name"] = monitor_status_codes2_recovery_config_name
        if monitor_status_codes3 is not None:
            self._values["monitor_status_codes3"] = monitor_status_codes3
        if monitor_status_codes3_enable_recovery is not None:
            self._values["monitor_status_codes3_enable_recovery"] = monitor_status_codes3_enable_recovery
        if monitor_status_codes3_enable_retry is not None:
            self._values["monitor_status_codes3_enable_retry"] = monitor_status_codes3_enable_retry
        if monitor_status_codes3_recovery_config_name is not None:
            self._values["monitor_status_codes3_recovery_config_name"] = monitor_status_codes3_recovery_config_name
        if origin_responsiveness_custom_timeout is not None:
            self._values["origin_responsiveness_custom_timeout"] = origin_responsiveness_custom_timeout
        if origin_responsiveness_enable_recovery is not None:
            self._values["origin_responsiveness_enable_recovery"] = origin_responsiveness_enable_recovery
        if origin_responsiveness_enable_retry is not None:
            self._values["origin_responsiveness_enable_retry"] = origin_responsiveness_enable_retry
        if origin_responsiveness_monitoring is not None:
            self._values["origin_responsiveness_monitoring"] = origin_responsiveness_monitoring
        if origin_responsiveness_recovery_config_name is not None:
            self._values["origin_responsiveness_recovery_config_name"] = origin_responsiveness_recovery_config_name
        if origin_responsiveness_timeout is not None:
            self._values["origin_responsiveness_timeout"] = origin_responsiveness_timeout
        if status_code_monitoring1 is not None:
            self._values["status_code_monitoring1"] = status_code_monitoring1
        if status_code_monitoring2 is not None:
            self._values["status_code_monitoring2"] = status_code_monitoring2
        if status_code_monitoring3 is not None:
            self._values["status_code_monitoring3"] = status_code_monitoring3
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tuning_parameters is not None:
            self._values["tuning_parameters"] = tuning_parameters
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def binary_equivalent_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Synchronizes content between the primary and backup origins, byte for byte.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        '''
        result = self._values.get("binary_equivalent_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates and configures a recovery policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_avoidance(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Temporarily blocks an origin IP address that experienced a certain number of failures.

        When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        '''
        result = self._values.get("enable_ip_avoidance")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip_avoidance_error_threshold(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of failures that need to occur to an origin address before it's blocked.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        '''
        result = self._values.get("ip_avoidance_error_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_avoidance_retry_interval(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of seconds after which the IP address is removed from the blocklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        '''
        result = self._values.get("ip_avoidance_retry_interval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        '''
        result = self._values.get("monitor_origin_responsiveness")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_response_codes1(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        '''
        result = self._values.get("monitor_response_codes1")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes2(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        '''
        result = self._values.get("monitor_response_codes2")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes3(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here..

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        '''
        result = self._values.get("monitor_response_codes3")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_status_codes1(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        '''
        result = self._values.get("monitor_status_codes1")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes1_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        '''
        result = self._values.get("monitor_status_codes1_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes1_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes2(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        '''
        result = self._values.get("monitor_status_codes2")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes2_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        '''
        result = self._values.get("monitor_status_codes2_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes2_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes3(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        '''
        result = self._values.get("monitor_status_codes3")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes3_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        '''
        result = self._values.get("monitor_status_codes3_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes3_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_custom_timeout(self) -> typing.Optional[jsii.Number]:
        '''Specify a custom timeout, from 1 to 10 seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        '''
        result = self._values.get("origin_responsiveness_custom_timeout")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a recovery action for a specific failure condition.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        '''
        result = self._values.get("origin_responsiveness_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        '''
        result = self._values.get("origin_responsiveness_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_monitoring(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        '''
        result = self._values.get("origin_responsiveness_monitoring")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        '''
        result = self._values.get("origin_responsiveness_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_timeout(self) -> typing.Optional[builtins.str]:
        '''The timeout threshold that triggers a retry or recovery action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        '''
        result = self._values.get("origin_responsiveness_timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring1(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        '''
        result = self._values.get("status_code_monitoring1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring2(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        '''
        result = self._values.get("status_code_monitoring2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring3(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        '''
        result = self._values.get("status_code_monitoring3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tuning_parameters(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        '''
        result = self._values.get("tuning_parameters")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d6574ee6f28da323807367e77572d2b044950ae7587ea401b7d5bd68169c987)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBinaryEquivalentContent")
    def reset_binary_equivalent_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBinaryEquivalentContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableIpAvoidance")
    def reset_enable_ip_avoidance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpAvoidance", []))

    @jsii.member(jsii_name="resetIpAvoidanceErrorThreshold")
    def reset_ip_avoidance_error_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceErrorThreshold", []))

    @jsii.member(jsii_name="resetIpAvoidanceRetryInterval")
    def reset_ip_avoidance_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceRetryInterval", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMonitorOriginResponsiveness")
    def reset_monitor_origin_responsiveness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorOriginResponsiveness", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes1")
    def reset_monitor_response_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes1", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes2")
    def reset_monitor_response_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes2", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes3")
    def reset_monitor_response_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1")
    def reset_monitor_status_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRecovery")
    def reset_monitor_status_codes1_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRetry")
    def reset_monitor_status_codes1_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1RecoveryConfigName")
    def reset_monitor_status_codes1_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2")
    def reset_monitor_status_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRecovery")
    def reset_monitor_status_codes2_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRetry")
    def reset_monitor_status_codes2_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2RecoveryConfigName")
    def reset_monitor_status_codes2_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3")
    def reset_monitor_status_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRecovery")
    def reset_monitor_status_codes3_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRetry")
    def reset_monitor_status_codes3_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3RecoveryConfigName")
    def reset_monitor_status_codes3_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3RecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessCustomTimeout")
    def reset_origin_responsiveness_custom_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessCustomTimeout", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRecovery")
    def reset_origin_responsiveness_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRecovery", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRetry")
    def reset_origin_responsiveness_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRetry", []))

    @jsii.member(jsii_name="resetOriginResponsivenessMonitoring")
    def reset_origin_responsiveness_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessMonitoring", []))

    @jsii.member(jsii_name="resetOriginResponsivenessRecoveryConfigName")
    def reset_origin_responsiveness_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessRecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessTimeout")
    def reset_origin_responsiveness_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessTimeout", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring1")
    def reset_status_code_monitoring1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring1", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring2")
    def reset_status_code_monitoring2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring2", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring3")
    def reset_status_code_monitoring3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring3", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTuningParameters")
    def reset_tuning_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTuningParameters", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContentInput")
    def binary_equivalent_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "binaryEquivalentContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidanceInput")
    def enable_ip_avoidance_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpAvoidanceInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThresholdInput")
    def ip_avoidance_error_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceErrorThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryIntervalInput")
    def ip_avoidance_retry_interval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceRetryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsivenessInput")
    def monitor_origin_responsiveness_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorOriginResponsivenessInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1Input")
    def monitor_response_codes1_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2Input")
    def monitor_response_codes2_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3Input")
    def monitor_response_codes3_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecoveryInput")
    def monitor_status_codes1_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetryInput")
    def monitor_status_codes1_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1Input")
    def monitor_status_codes1_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigNameInput")
    def monitor_status_codes1_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes1RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecoveryInput")
    def monitor_status_codes2_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetryInput")
    def monitor_status_codes2_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2Input")
    def monitor_status_codes2_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigNameInput")
    def monitor_status_codes2_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes2RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecoveryInput")
    def monitor_status_codes3_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetryInput")
    def monitor_status_codes3_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3Input")
    def monitor_status_codes3_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigNameInput")
    def monitor_status_codes3_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes3RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeoutInput")
    def origin_responsiveness_custom_timeout_input(
        self,
    ) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originResponsivenessCustomTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecoveryInput")
    def origin_responsiveness_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetryInput")
    def origin_responsiveness_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoringInput")
    def origin_responsiveness_monitoring_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigNameInput")
    def origin_responsiveness_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessRecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeoutInput")
    def origin_responsiveness_timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1Input")
    def status_code_monitoring1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring1Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2Input")
    def status_code_monitoring2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring2Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3Input")
    def status_code_monitoring3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring3Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tuningParametersInput")
    def tuning_parameters_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tuningParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContent")
    def binary_equivalent_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "binaryEquivalentContent"))

    @binary_equivalent_content.setter
    def binary_equivalent_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2cc06b47e8d0a0a54bd0790ead9b30fad6b457ace93200f90207dbe9266e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "binaryEquivalentContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035dc1363b2b10120fe461b1d6776de9cbcfaf71525b62da5d6ff7032ad5112c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidance")
    def enable_ip_avoidance(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpAvoidance"))

    @enable_ip_avoidance.setter
    def enable_ip_avoidance(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2750b07989f298700426358fe64fa00bdae30e37b2abd296b4fe03e8c1b912f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpAvoidance", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThreshold")
    def ip_avoidance_error_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceErrorThreshold"))

    @ip_avoidance_error_threshold.setter
    def ip_avoidance_error_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cdcfac4160dbf62a675eaa93591828d3731b006a143e7105d8e0760aa650803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceErrorThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryInterval")
    def ip_avoidance_retry_interval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceRetryInterval"))

    @ip_avoidance_retry_interval.setter
    def ip_avoidance_retry_interval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dfb1053b84300acfd5ad43b9fe4bb788dd0cb960eac1327897a028eeb05874a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceRetryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddaecaae55ea8a2b6ccb9a0223cbfde5d6fcf1d2a5db71cabfb16b6d8ebc170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsiveness")
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorOriginResponsiveness"))

    @monitor_origin_responsiveness.setter
    def monitor_origin_responsiveness(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__130c7b9a5987d75c37047e9f4e7750f785cadddfbefb0ad226192c06778dfde1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorOriginResponsiveness", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1")
    def monitor_response_codes1(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes1"))

    @monitor_response_codes1.setter
    def monitor_response_codes1(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b9c4de63116dc498d03aab33dc1efaadfd20a2f64802aed3a78442f148ec61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2")
    def monitor_response_codes2(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes2"))

    @monitor_response_codes2.setter
    def monitor_response_codes2(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13afcc2e4671068a5a19b1e8649e42be167e97269b1f90cbd00f5c10ca03a590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3")
    def monitor_response_codes3(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes3"))

    @monitor_response_codes3.setter
    def monitor_response_codes3(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d7be1259cf596662307d89d94bdb79c3798ef8b5c1f486c48e1c61169884b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1")
    def monitor_status_codes1(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1"))

    @monitor_status_codes1.setter
    def monitor_status_codes1(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd5a34be760694bbf35efa159631ea8431d5778821fb007cf069fde0ace79b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecovery")
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRecovery"))

    @monitor_status_codes1_enable_recovery.setter
    def monitor_status_codes1_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a7b13864a1a1379b6c23978d827415aae9d9980c876b26158005cdc15952f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetry")
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRetry"))

    @monitor_status_codes1_enable_retry.setter
    def monitor_status_codes1_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842c6ad77268f65debb23338d15199c8e84cda2b07fb5a4b2ad1a4064c7d4061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigName")
    def monitor_status_codes1_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes1RecoveryConfigName"))

    @monitor_status_codes1_recovery_config_name.setter
    def monitor_status_codes1_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57bd7872b31dd216b6cbf6de619ae0ff9665c443dee6986c9c3478abfd1aa66f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2")
    def monitor_status_codes2(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2"))

    @monitor_status_codes2.setter
    def monitor_status_codes2(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f44e7687cd082c2a4fb6ca42e6c48434c70636cbde987dfeef9dfd9b0ec0094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecovery")
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRecovery"))

    @monitor_status_codes2_enable_recovery.setter
    def monitor_status_codes2_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a36c5cf0c755b0a7bb8dfbfc1711790c9d55971edc8c51df1d8156ba19c8538d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetry")
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRetry"))

    @monitor_status_codes2_enable_retry.setter
    def monitor_status_codes2_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9da8fadd0c2f6b53e63d8bb1c91a1bd148759c63154495ab743a44b50c8b339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigName")
    def monitor_status_codes2_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes2RecoveryConfigName"))

    @monitor_status_codes2_recovery_config_name.setter
    def monitor_status_codes2_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da703fd26a7a3e82c9fea75249a6dd25d2d9fbb425a50a1d71ff584b6261058e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3")
    def monitor_status_codes3(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3"))

    @monitor_status_codes3.setter
    def monitor_status_codes3(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276d4a341d982c172d9765d385c176c87713d067aff0de4647b25efd7d87444d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecovery")
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRecovery"))

    @monitor_status_codes3_enable_recovery.setter
    def monitor_status_codes3_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720235a39342b12ff8bff36bea20a5482891139c54cf330d99fe48f72bc086ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetry")
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRetry"))

    @monitor_status_codes3_enable_retry.setter
    def monitor_status_codes3_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67f4d30abc183b44304012707bd0ac61af28a8d6a3335b0f7a18756b792c27c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigName")
    def monitor_status_codes3_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes3RecoveryConfigName"))

    @monitor_status_codes3_recovery_config_name.setter
    def monitor_status_codes3_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7da3972bd4fcf2aeeabf38732c009074235b741cd4a00ef171f9822aba1d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeout")
    def origin_responsiveness_custom_timeout(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originResponsivenessCustomTimeout"))

    @origin_responsiveness_custom_timeout.setter
    def origin_responsiveness_custom_timeout(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__321e2e2ae5348d3608061f6ebe9f247a52d56ce4e4b8ecc620af3856b23ce053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessCustomTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecovery")
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRecovery"))

    @origin_responsiveness_enable_recovery.setter
    def origin_responsiveness_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ceb723ca5cc79e8be61df718371d500229e9761f377fcd1e0f64cf2199d2909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetry")
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRetry"))

    @origin_responsiveness_enable_retry.setter
    def origin_responsiveness_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bdee7dbbcfc9e66c5b0c8f7d7e66650596e535c366c890fad864017f853865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoring")
    def origin_responsiveness_monitoring(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessMonitoring"))

    @origin_responsiveness_monitoring.setter
    def origin_responsiveness_monitoring(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc8376ff52a7f1eca8cff9dcfa2999947747cabdfecd160414b6f5467cc2dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigName")
    def origin_responsiveness_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessRecoveryConfigName"))

    @origin_responsiveness_recovery_config_name.setter
    def origin_responsiveness_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68bf059edffa009a26a4a38338186ae21c94e10d41a7452783bc1074771c0b39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessRecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeout")
    def origin_responsiveness_timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessTimeout"))

    @origin_responsiveness_timeout.setter
    def origin_responsiveness_timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc48712db77795117568a3d129ef302b9aab8d012a63cc48feb56bf35ec29b6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1")
    def status_code_monitoring1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring1"))

    @status_code_monitoring1.setter
    def status_code_monitoring1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d548f93f0fc05f0b330767f08dc534c11d58b2cf5150eb106652ab434b5484e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring1", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2")
    def status_code_monitoring2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring2"))

    @status_code_monitoring2.setter
    def status_code_monitoring2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d325d0c945d6922722f6e289de4ab2d82b70b95dd516d262f9d625bb87bc6d70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring2", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3")
    def status_code_monitoring3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring3"))

    @status_code_monitoring3.setter
    def status_code_monitoring3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6309cfddc86a13df4a1ff16107b13bfa7632ab5906830f6108e526f2c5eea92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring3", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de95d84e1f45d988941bed4684ad77ea256e1227cf19b95bc041fe7ad2e200ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tuningParameters")
    def tuning_parameters(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tuningParameters"))

    @tuning_parameters.setter
    def tuning_parameters(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d8ab04f8752c03b27f02b17d4b1e12c6aec28c167e3e5895dab3791d9135000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tuningParameters", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3edfcad6a7ce26960c5b06da1ed4149d6ea4781c61879503c0fc236ba6a364c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a63f7d7f5fd6c7186c0fd63df89c51efe351dbdc4f595cfdb61acb31f16770de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a36f97c67ba7f47b259f2dd5e404b9cb3b50c20a0fed81708d2e8ec3bcd99e)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Origin IP Access Control List behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAclOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAclOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b77c0f6e0a24fcd0bad32d4dd8847a8146f834d212a34b61a8397150ad57635c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfb5c05c8042d3e8d5d9367f9b92e788e6bdea7d219e4fa39e52fae4100e6e9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67e57027128250c7446e56ddef9d767017cddc5ee285fbbc0e4245f9e51989c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68c8a19fb359657471eff9b4eacf3ca816583c1af57b90e38478c61b17e5fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b804cf2192dc7d40a92f928c088521d22b97ef62efb999aa8666aaad71c27bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cf78c369732a5f606664c2efd6ba036fae83468bcd2823e55359292904cc81b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c497a8c22c37219c5ea137bf177c96d4d574aeec89f6e4d33af1f4d4f06b1d8)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edfd671fbf79b53f47d6d5fb8230fa5373fd259f0648eb8444a06b3db4378ad8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d88953a7a2fbc0586b308062e18c9fb72b6b2cd7b076fa039b6ff5581ab9fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6027c6efad2716a04307da899c37b71b4bc94d09a4bfc7dad289994fc9ac7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd4458584e8b3809033a4d0533cbdfab7ef4b18364a19c208e151a52eb75744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ee93c05e038484ff50bd018d165ebc74e9aa3617a1ff34d9c9d5118e1232d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f269f2cd40624ef43f14aa3a127ad04fbb214f9bbe81c71071a9389a0f3b880)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCustomCertificateAuthorities")
    def put_custom_certificate_authorities(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abf4c7e000179396370832ea8047b8562a2c1bb49b8be663262594f2fd9bb4c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificateAuthorities", [value]))

    @jsii.member(jsii_name="putCustomCertificates")
    def put_custom_certificates(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc504243295b2c7b7a3767633fb4b0733450a373e2e297fa5adecbd47a4592a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificates", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetCacheKeyHostname")
    def reset_cache_key_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyHostname", []))

    @jsii.member(jsii_name="resetCompress")
    def reset_compress(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompress", []))

    @jsii.member(jsii_name="resetCustomCertificateAuthorities")
    def reset_custom_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificateAuthorities", []))

    @jsii.member(jsii_name="resetCustomCertificates")
    def reset_custom_certificates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificates", []))

    @jsii.member(jsii_name="resetCustomForwardHostHeader")
    def reset_custom_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomForwardHostHeader", []))

    @jsii.member(jsii_name="resetCustomValidCnValues")
    def reset_custom_valid_cn_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValidCnValues", []))

    @jsii.member(jsii_name="resetEnableTrueClientIp")
    def reset_enable_true_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTrueClientIp", []))

    @jsii.member(jsii_name="resetForwardHostHeader")
    def reset_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHostHeader", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetHttpPort")
    def reset_http_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpPort", []))

    @jsii.member(jsii_name="resetHttpsPort")
    def reset_https_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpsPort", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMslorigin")
    def reset_mslorigin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslorigin", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetOriginCertificate")
    def reset_origin_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertificate", []))

    @jsii.member(jsii_name="resetOriginCertsToHonor")
    def reset_origin_certs_to_honor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertsToHonor", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetOriginSni")
    def reset_origin_sni(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSni", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetPorts")
    def reset_ports(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPorts", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetSecondHostname")
    def reset_second_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostname", []))

    @jsii.member(jsii_name="resetSecondHostnameEnabled")
    def reset_second_hostname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostnameEnabled", []))

    @jsii.member(jsii_name="resetStandardCertificateAuthorities")
    def reset_standard_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardCertificateAuthorities", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrueClientIpClientSetting")
    def reset_true_client_ip_client_setting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpClientSetting", []))

    @jsii.member(jsii_name="resetTrueClientIpHeader")
    def reset_true_client_ip_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpHeader", []))

    @jsii.member(jsii_name="resetUseUniqueCacheKey")
    def reset_use_unique_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseUniqueCacheKey", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationMode")
    def reset_verification_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationMode", []))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthorities")
    def custom_certificate_authorities(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesList, jsii.get(self, "customCertificateAuthorities"))

    @builtins.property
    @jsii.member(jsii_name="customCertificates")
    def custom_certificates(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesList, jsii.get(self, "customCertificates"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostnameInput")
    def cache_key_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheKeyHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="compressInput")
    def compress_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthoritiesInput")
    def custom_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "customCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificatesInput")
    def custom_certificates_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]]], jsii.get(self, "customCertificatesInput"))

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeaderInput")
    def custom_forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customForwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="customValidCnValuesInput")
    def custom_valid_cn_values_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customValidCnValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIpInput")
    def enable_true_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTrueClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeaderInput")
    def forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="httpPortInput")
    def http_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpPortInput"))

    @builtins.property
    @jsii.member(jsii_name="httpsPortInput")
    def https_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpsPortInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="msloriginInput")
    def mslorigin_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "msloriginInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertificateInput")
    def origin_certificate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonorInput")
    def origin_certs_to_honor_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertsToHonorInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="originSniInput")
    def origin_sni_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originSniInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="portsInput")
    def ports_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "portsInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabledInput")
    def second_hostname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondHostnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameInput")
    def second_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthoritiesInput")
    def standard_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "standardCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSettingInput")
    def true_client_ip_client_setting_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "trueClientIpClientSettingInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeaderInput")
    def true_client_ip_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trueClientIpHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKeyInput")
    def use_unique_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useUniqueCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationModeInput")
    def verification_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostname")
    def cache_key_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheKeyHostname"))

    @cache_key_hostname.setter
    def cache_key_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8008447b4b2d71aecef90472555aadad0ae50a55f74d0d482e65bd237c616659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKeyHostname", value)

    @builtins.property
    @jsii.member(jsii_name="compress")
    def compress(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compress"))

    @compress.setter
    def compress(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9353b6d881c5d83d0705cf7a039df4edbd5483a260f142d7fa96c514ab3f5d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compress", value)

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeader")
    def custom_forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customForwardHostHeader"))

    @custom_forward_host_header.setter
    def custom_forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffc3f877bbdcae505ccb719819f6cca8d5943eb8ebb0c40983bf6976ada0319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customForwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="customValidCnValues")
    def custom_valid_cn_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customValidCnValues"))

    @custom_valid_cn_values.setter
    def custom_valid_cn_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360572b9d9c91bf04f1d01a506c9da7fcdca537e087ea46823fff89e935c324c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValidCnValues", value)

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIp")
    def enable_true_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTrueClientIp"))

    @enable_true_client_ip.setter
    def enable_true_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4fcaf5ea7114925022e5b0b57e31128396cc35b75e518cb07220f574d0e61d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTrueClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeader")
    def forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardHostHeader"))

    @forward_host_header.setter
    def forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc75e2faea65fef65c2beed5e4ebd5f2c0c245bfa493ec92abae4329eea105b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a6439e7994310ca9424d0f485e4d816d97d86b563f830e6d6a54fd14a147d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="httpPort")
    def http_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpPort"))

    @http_port.setter
    def http_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83745cde89f688684cf43f5d4162aa1647be1f7c51b406db18fa6ffb589e9436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpPort", value)

    @builtins.property
    @jsii.member(jsii_name="httpsPort")
    def https_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpsPort"))

    @https_port.setter
    def https_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707e97a0d7254e8d6d74d6541d1829626691bed315148a803287b695e4761448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpsPort", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f900f040c5f8ce75a801981c7c27ed95404f6aec7474af3f3ce8c536e947d6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f33b78a8f52daf3f9c89831ce36d6bd70c4b5369f8ed41ae0ca2c2978cbb3bce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mslorigin")
    def mslorigin(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslorigin"))

    @mslorigin.setter
    def mslorigin(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8b9932cecd815ea5b7cf8dbcc5eab5a29dac6e3bbd61c720c9b2d112752d03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslorigin", value)

    @builtins.property
    @jsii.member(jsii_name="originCertificate")
    def origin_certificate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertificate"))

    @origin_certificate.setter
    def origin_certificate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a5fe7e8abab55624c5471ccb8099f585fb1eca973ba4186d2266a8fa4e7d052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonor")
    def origin_certs_to_honor(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertsToHonor"))

    @origin_certs_to_honor.setter
    def origin_certs_to_honor(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1820e30e59c11608469935ddaa175084c72e5d44d28c7851e46d8fd10472b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertsToHonor", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52a20b90d577460e0814d323eccd2e696e67c3cc87bfa7e3e80bc6b74ddd75ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="originSni")
    def origin_sni(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originSni"))

    @origin_sni.setter
    def origin_sni(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a04e64b0a56015ff51312962ad1d122599c7c2b0f372b97769990f8d14bcd78b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSni", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f094440fa49f77828ea3089a05d78a42e6f4c51fdeaeacb83c36394b3017f116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="ports")
    def ports(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ports"))

    @ports.setter
    def ports(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__390c629e4bca77d9271cfc7409d0bbb299e415259dac96f3e852e2be5cf59dbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ports", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876d006c6307f0c1091be338b711ec6c8f997c5ff7076bba0202b98d874071b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675f8e65a6bb1efb8cdb1686efe21177170faff0f552d0f68915470ba2ed944b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409dad5d1ef9cbd7708d9c4f8c12d2fe47bd5cdd6a9c19ec8a32e4f63e4c1fe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f3ea5f0584c4e03440d58f8d7e58498d3cc5b3151016af2617d5b7261eb345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eaff6d3da6a80d71e33dd74d8beef0c3b2142d3f0fbcaccc5cce4edb083af56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6679caad26bd8a60cbac2312bddf50904b61b14742629cca38b31930cf873e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41bac95d003a9e2a4c19eed364dd71dc061f6ecdc40f0ae257c26f55ff7d504)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf82367d1e06c14a4392bdc04c7d1159f10d2dc860a577536ba582527eb22c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostname")
    def second_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondHostname"))

    @second_hostname.setter
    def second_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06b567fcc0b5087c04ce8e826e920b81454420d58a636da5984432b77fcd802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostname", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabled")
    def second_hostname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondHostnameEnabled"))

    @second_hostname_enabled.setter
    def second_hostname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea7306fc5d592524968780d0d6070cef465fdff3e49ea733e17ceca106eb9391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthorities")
    def standard_certificate_authorities(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "standardCertificateAuthorities"))

    @standard_certificate_authorities.setter
    def standard_certificate_authorities(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfd6099074e8bb25e3f334281166a2bd45ae9b066b06d6a8efaede78fa0c46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardCertificateAuthorities", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d12675c86c9080a84f8c3c31ac2efeda282781aa49864a19387e46090d7acc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSetting")
    def true_client_ip_client_setting(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "trueClientIpClientSetting"))

    @true_client_ip_client_setting.setter
    def true_client_ip_client_setting(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f79d00a2b224abe2a72ab6b3644c31b4c5b28c30acf98db1d5488546b83dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpClientSetting", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeader")
    def true_client_ip_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trueClientIpHeader"))

    @true_client_ip_header.setter
    def true_client_ip_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd471b758a418ab93b379b9507c921260bf0361425b8c3f21144d697fc81818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpHeader", value)

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKey")
    def use_unique_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useUniqueCacheKey"))

    @use_unique_cache_key.setter
    def use_unique_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8562f262e1a80095f836ee35849b0c4acf1fb25f53e9bc5ac9e54e630902b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useUniqueCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f859560a5c29d0d3e12fe0360d7fed6bd417913800c6dd81a44c83557db56011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationMode")
    def verification_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationMode"))

    @verification_mode.setter
    def verification_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56edfdf77bb1535be12017629e3f054e86d55250e52e932ebd6748ce37f4456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd0dc76f69e383315e1b046d01e5ecf21509ab02cbe57c00786d19ee186ed4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f1f28dd156266d2187c6ba0b55b1690ad2c1d26dad97d54e63aaea78a21bfe1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdaptiveAcceleration")
    def put_adaptive_acceleration(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration(
            ab_logic=ab_logic,
            ab_testing=ab_testing,
            compression=compression,
            cookie_name=cookie_name,
            enable_brotli_compression=enable_brotli_compression,
            enable_for_noncacheable=enable_for_noncacheable,
            enable_preconnect=enable_preconnect,
            enable_push=enable_push,
            enable_ro=enable_ro,
            locked=locked,
            preload_enable=preload_enable,
            source=source,
            template_uuid=template_uuid,
            title_brotli=title_brotli,
            title_http2_server_push=title_http2_server_push,
            title_preconnect=title_preconnect,
            title_preload=title_preload,
            title_ro=title_ro,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveAcceleration", [value]))

    @jsii.member(jsii_name="putAdaptiveImageCompression")
    def put_adaptive_image_compression(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression(
            compress_mobile=compress_mobile,
            compress_standard=compress_standard,
            locked=locked,
            template_uuid=template_uuid,
            tier1_mobile_compression_method=tier1_mobile_compression_method,
            tier1_mobile_compression_value=tier1_mobile_compression_value,
            tier1_standard_compression_method=tier1_standard_compression_method,
            tier1_standard_compression_value=tier1_standard_compression_value,
            tier2_mobile_compression_method=tier2_mobile_compression_method,
            tier2_mobile_compression_value=tier2_mobile_compression_value,
            tier2_standard_compression_method=tier2_standard_compression_method,
            tier2_standard_compression_value=tier2_standard_compression_value,
            tier3_mobile_compression_method=tier3_mobile_compression_method,
            tier3_mobile_compression_value=tier3_mobile_compression_value,
            tier3_standard_compression_method=tier3_standard_compression_method,
            tier3_standard_compression_value=tier3_standard_compression_value,
            title_aic_mobile=title_aic_mobile,
            title_aic_nonmobile=title_aic_nonmobile,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveImageCompression", [value]))

    @jsii.member(jsii_name="putAdScalerCircuitBreaker")
    def put_ad_scaler_circuit_breaker(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker(
            fallback_action_response_code_based=fallback_action_response_code_based,
            locked=locked,
            response_code_based=response_code_based,
            response_codes=response_codes,
            response_delay_based=response_delay_based,
            response_delay_threshold=response_delay_threshold,
            return_error_response_code_based=return_error_response_code_based,
            specify_your_own_response_code_based=specify_your_own_response_code_based,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdScalerCircuitBreaker", [value]))

    @jsii.member(jsii_name="putAdvanced")
    def put_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvanced", [value]))

    @jsii.member(jsii_name="putAggregatedReporting")
    def put_aggregated_reporting(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting(
            attribute1=attribute1,
            attribute2=attribute2,
            attribute3=attribute3,
            attribute4=attribute4,
            attributes_count=attributes_count,
            enabled=enabled,
            locked=locked,
            report_name=report_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAggregatedReporting", [value]))

    @jsii.member(jsii_name="putAkamaizer")
    def put_akamaizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizer", [value]))

    @jsii.member(jsii_name="putAkamaizerTag")
    def put_akamaizer_tag(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag(
            include_tags_attribute=include_tags_attribute,
            locked=locked,
            match_hostname=match_hostname,
            replace_all=replace_all,
            replacement_hostname=replacement_hostname,
            scope=scope,
            tags_attribute=tags_attribute,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizerTag", [value]))

    @jsii.member(jsii_name="putAllHttpInCacheHierarchy")
    def put_all_http_in_cache_hierarchy(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllHttpInCacheHierarchy", [value]))

    @jsii.member(jsii_name="putAllowCloudletsOrigins")
    def put_allow_cloudlets_origins(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins(
            enabled=enabled,
            honor_base_directory=honor_base_directory,
            locked=locked,
            purge_origin_query_parameter=purge_origin_query_parameter,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowCloudletsOrigins", [value]))

    @jsii.member(jsii_name="putAllowDelete")
    def put_allow_delete(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete(
            allow_body=allow_body,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowDelete", [value]))

    @jsii.member(jsii_name="putAllowHttpsCacheKeySharing")
    def put_allow_https_cache_key_sharing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsCacheKeySharing", [value]))

    @jsii.member(jsii_name="putAllowHttpsDowngrade")
    def put_allow_https_downgrade(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsDowngrade", [value]))

    @jsii.member(jsii_name="putAllowOptions")
    def put_allow_options(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowOptions", [value]))

    @jsii.member(jsii_name="putAllowPatch")
    def put_allow_patch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPatch", [value]))

    @jsii.member(jsii_name="putAllowPost")
    def put_allow_post(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost(
            allow_without_content_length=allow_without_content_length,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPost", [value]))

    @jsii.member(jsii_name="putAllowPut")
    def put_allow_put(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPut", [value]))

    @jsii.member(jsii_name="putAllowTransferEncoding")
    def put_allow_transfer_encoding(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowTransferEncoding", [value]))

    @jsii.member(jsii_name="putAltSvcHeader")
    def put_alt_svc_header(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader(
            locked=locked, max_age=max_age, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAltSvcHeader", [value]))

    @jsii.member(jsii_name="putApiPrioritization")
    def put_api_prioritization(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization(
            alternate_response_cache_ttl=alternate_response_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            label=label,
            locked=locked,
            net_storage=net_storage,
            net_storage_path=net_storage_path,
            template_uuid=template_uuid,
            throttled_cp_code=throttled_cp_code,
            throttled_status_code=throttled_status_code,
            use_throttled_cp_code=use_throttled_cp_code,
            use_throttled_status_code=use_throttled_status_code,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApiPrioritization", [value]))

    @jsii.member(jsii_name="putApplicationLoadBalancer")
    def put_application_load_balancer(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer(
            all_down_net_storage=all_down_net_storage,
            all_down_net_storage_file=all_down_net_storage_file,
            all_down_status_code=all_down_status_code,
            all_down_title=all_down_title,
            allow_cache_prefresh=allow_cache_prefresh,
            cached_content_title=cached_content_title,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            failover_attempts_threshold=failover_attempts_threshold,
            failover_mode=failover_mode,
            failover_origin_map=failover_origin_map,
            failover_status_codes=failover_status_codes,
            failover_title=failover_title,
            label=label,
            locked=locked,
            origin_cookie_name=origin_cookie_name,
            specify_stickiness_cookie_domain=specify_stickiness_cookie_domain,
            stickiness_cookie_automatic_salt=stickiness_cookie_automatic_salt,
            stickiness_cookie_domain=stickiness_cookie_domain,
            stickiness_cookie_salt=stickiness_cookie_salt,
            stickiness_cookie_set_http_only_flag=stickiness_cookie_set_http_only_flag,
            stickiness_cookie_type=stickiness_cookie_type,
            stickiness_duration=stickiness_duration,
            stickiness_expiration_date=stickiness_expiration_date,
            stickiness_refresh=stickiness_refresh,
            stickiness_title=stickiness_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApplicationLoadBalancer", [value]))

    @jsii.member(jsii_name="putAudienceSegmentation")
    def put_audience_segmentation(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_automatic_salt=population_cookie_automatic_salt,
            population_cookie_domain=population_cookie_domain,
            population_cookie_include_rule_name=population_cookie_include_rule_name,
            population_cookie_salt=population_cookie_salt,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_refresh=population_refresh,
            population_title=population_title,
            segment_tracking_cookie_name=segment_tracking_cookie_name,
            segment_tracking_custom_header=segment_tracking_custom_header,
            segment_tracking_method=segment_tracking_method,
            segment_tracking_query_param=segment_tracking_query_param,
            segment_tracking_title=segment_tracking_title,
            specify_population_cookie_domain=specify_population_cookie_domain,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAudienceSegmentation", [value]))

    @jsii.member(jsii_name="putAutoDomainValidation")
    def put_auto_domain_validation(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation(
            autodv=autodv, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAutoDomainValidation", [value]))

    @jsii.member(jsii_name="putBaseDirectory")
    def put_base_directory(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putBaseDirectory", [value_]))

    @jsii.member(jsii_name="putBossBeaconing")
    def put_boss_beaconing(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing(
            conditional_error_pattern=conditional_error_pattern,
            conditional_http_status=conditional_http_status,
            conditional_sampling_frequency=conditional_sampling_frequency,
            cpcodes=cpcodes,
            enabled=enabled,
            forward_type=forward_type,
            locked=locked,
            request_type=request_type,
            sampling_frequency=sampling_frequency,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBossBeaconing", [value]))

    @jsii.member(jsii_name="putBreadcrumbs")
    def put_breadcrumbs(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs(
            enabled=enabled,
            locked=locked,
            logging_enabled=logging_enabled,
            opt_mode=opt_mode,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBreadcrumbs", [value]))

    @jsii.member(jsii_name="putBreakConnection")
    def put_break_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBreakConnection", [value]))

    @jsii.member(jsii_name="putBrotli")
    def put_brotli(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBrotli", [value]))

    @jsii.member(jsii_name="putCacheError")
    def put_cache_error(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError(
            enabled=enabled,
            locked=locked,
            preserve_stale=preserve_stale,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheError", [value]))

    @jsii.member(jsii_name="putCacheId")
    def put_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId(
            elements=elements,
            include_value=include_value,
            locked=locked,
            optional=optional,
            rule=rule,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheId", [value]))

    @jsii.member(jsii_name="putCacheKeyIgnoreCase")
    def put_cache_key_ignore_case(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyIgnoreCase", [value]))

    @jsii.member(jsii_name="putCacheKeyQueryParams")
    def put_cache_key_query_params(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams(
            behavior=behavior,
            exact_match=exact_match,
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyQueryParams", [value]))

    @jsii.member(jsii_name="putCacheKeyRewrite")
    def put_cache_key_rewrite(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite(
            locked=locked, purge_key=purge_key, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyRewrite", [value]))

    @jsii.member(jsii_name="putCachePost")
    def put_cache_post(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_body=use_body,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCachePost", [value]))

    @jsii.member(jsii_name="putCacheRedirect")
    def put_cache_redirect(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheRedirect", [value]))

    @jsii.member(jsii_name="putCacheTag")
    def put_cache_tag(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag(
            locked=locked, tag=tag, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTag", [value]))

    @jsii.member(jsii_name="putCacheTagVisible")
    def put_cache_tag_visible(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTagVisible", [value]))

    @jsii.member(jsii_name="putCaching")
    def put_caching(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching(
            behavior=behavior,
            cacheability_settings=cacheability_settings,
            cache_control_directives=cache_control_directives,
            default_ttl=default_ttl,
            enhanced_rfc_support=enhanced_rfc_support,
            expiration_settings=expiration_settings,
            honor_max_age=honor_max_age,
            honor_must_revalidate=honor_must_revalidate,
            honor_no_cache=honor_no_cache,
            honor_no_store=honor_no_store,
            honor_private=honor_private,
            honor_proxy_revalidate=honor_proxy_revalidate,
            honor_s_maxage=honor_s_maxage,
            locked=locked,
            must_revalidate=must_revalidate,
            revalidation_settings=revalidation_settings,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCaching", [value]))

    @jsii.member(jsii_name="putCentralAuthorization")
    def put_central_authorization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCentralAuthorization", [value]))

    @jsii.member(jsii_name="putChaseRedirects")
    def put_chase_redirects(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects(
            enabled=enabled,
            limit=limit,
            locked=locked,
            serve404=serve404,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChaseRedirects", [value]))

    @jsii.member(jsii_name="putClientCharacteristics")
    def put_client_characteristics(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics(
            country=country, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putClientCharacteristics", [value]))

    @jsii.member(jsii_name="putCloudInterconnects")
    def put_cloud_interconnects(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects(
            cloud_locations=cloud_locations,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudInterconnects", [value]))

    @jsii.member(jsii_name="putCloudWrapper")
    def put_cloud_wrapper(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper(
            enabled=enabled,
            location=location,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapper", [value]))

    @jsii.member(jsii_name="putCloudWrapperAdvanced")
    def put_cloud_wrapper_advanced(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced(
            custom_failover_map=custom_failover_map,
            enabled=enabled,
            failover_map=failover_map,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapperAdvanced", [value]))

    @jsii.member(jsii_name="putConditionalOrigin")
    def put_conditional_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putConditionalOrigin", [value]))

    @jsii.member(jsii_name="putConstructResponse")
    def put_construct_response(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse(
            body=body,
            enabled=enabled,
            force_eviction=force_eviction,
            ignore_purge=ignore_purge,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putConstructResponse", [value]))

    @jsii.member(jsii_name="putContentCharacteristics")
    def put_content_characteristics(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristics", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsAmd")
    def put_content_characteristics_amd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_dash_custom=segment_duration_dash_custom,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hds_custom=segment_duration_hds_custom,
            segment_duration_hls=segment_duration_hls,
            segment_duration_hls_custom=segment_duration_hls_custom,
            segment_duration_smooth=segment_duration_smooth,
            segment_duration_smooth_custom=segment_duration_smooth_custom,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsAmd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsDd")
    def put_content_characteristics_dd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            optimize_option=optimize_option,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsDd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLargeFile")
    def put_content_characteristics_wsd_large_file(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLargeFile", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLive")
    def put_content_characteristics_wsd_live(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLive", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdVod")
    def put_content_characteristics_wsd_vod(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdVod", [value]))

    @jsii.member(jsii_name="putContentPrePosition")
    def put_content_pre_position(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition(
            enabled=enabled,
            first_location=first_location,
            locked=locked,
            second_location=second_location,
            source_type=source_type,
            targets=targets,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentPrePosition", [value]))

    @jsii.member(jsii_name="putContentTargetingProtection")
    def put_content_targeting_protection(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection(
            countries=countries,
            dmas=dmas,
            enabled=enabled,
            enable_geo_protection=enable_geo_protection,
            enable_geo_redirect_on_deny=enable_geo_redirect_on_deny,
            enable_ip_protection=enable_ip_protection,
            enable_ip_redirect_on_deny=enable_ip_redirect_on_deny,
            enable_referrer_protection=enable_referrer_protection,
            enable_referrer_redirect_on_deny=enable_referrer_redirect_on_deny,
            geo_protection_mode=geo_protection_mode,
            geo_protection_title=geo_protection_title,
            geo_redirect_url=geo_redirect_url,
            ip_addresses=ip_addresses,
            ip_protection_mode=ip_protection_mode,
            ip_protection_title=ip_protection_title,
            ip_redirect_url=ip_redirect_url,
            locked=locked,
            override_ip_addresses=override_ip_addresses,
            referrer_domains=referrer_domains,
            referrer_protection_mode=referrer_protection_mode,
            referrer_protection_title=referrer_protection_title,
            referrer_redirect_url=referrer_redirect_url,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentTargetingProtection", [value]))

    @jsii.member(jsii_name="putCorsSupport")
    def put_cors_support(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport(
            allow_credentials=allow_credentials,
            allow_headers=allow_headers,
            allow_origins=allow_origins,
            enabled=enabled,
            expose_headers=expose_headers,
            headers=headers,
            locked=locked,
            methods=methods,
            origins=origins,
            preflight_max_age=preflight_max_age,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCorsSupport", [value]))

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value_]))

    @jsii.member(jsii_name="putCustomBehavior")
    def put_custom_behavior(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior(
            behavior_id=behavior_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCustomBehavior", [value]))

    @jsii.member(jsii_name="putDatastream")
    def put_datastream(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[jsii.Number] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream(
            beacon_stream_title=beacon_stream_title,
            collect_midgress_traffic=collect_midgress_traffic,
            datastream_ids=datastream_ids,
            enabled=enabled,
            locked=locked,
            log_enabled=log_enabled,
            log_stream_name=log_stream_name,
            log_stream_title=log_stream_title,
            sampling_percentage=sampling_percentage,
            stream_type=stream_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDatastream", [value]))

    @jsii.member(jsii_name="putDcp")
    def put_dcp(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp(
            anonymous=anonymous,
            enabled=enabled,
            gwenabled=gwenabled,
            locked=locked,
            namespace_id=namespace_id,
            template_uuid=template_uuid,
            tlsenabled=tlsenabled,
            uuid=uuid,
            wsenabled=wsenabled,
        )

        return typing.cast(None, jsii.invoke(self, "putDcp", [value]))

    @jsii.member(jsii_name="putDcpAuthHmacTransformation")
    def put_dcp_auth_hmac_transformation(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation(
            hash_conversion_algorithm=hash_conversion_algorithm,
            hash_conversion_key=hash_conversion_key,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthHmacTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthRegexTransformation")
    def put_dcp_auth_regex_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation(
            locked=locked,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthRegexTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthSubstringTransformation")
    def put_dcp_auth_substring_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation(
            locked=locked,
            substring_end=substring_end,
            substring_start=substring_start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthSubstringTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthVariableExtractor")
    def put_dcp_auth_variable_extractor(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor(
            certificate_field=certificate_field,
            dcp_mutual_auth_processing_variable_id=dcp_mutual_auth_processing_variable_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthVariableExtractor", [value]))

    @jsii.member(jsii_name="putDcpDefaultAuthzGroups")
    def put_dcp_default_authz_groups(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups(
            group_names=group_names,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDefaultAuthzGroups", [value]))

    @jsii.member(jsii_name="putDcpDevRelations")
    def put_dcp_dev_relations(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations(
            custom_values=custom_values,
            enabled=enabled,
            hostname=hostname,
            locked=locked,
            path=path,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDevRelations", [value]))

    @jsii.member(jsii_name="putDcpRealTimeAuth")
    def put_dcp_real_time_auth(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth(
            extract_hostname=extract_hostname,
            extract_jurisdiction=extract_jurisdiction,
            extract_namespace=extract_namespace,
            hostname_claim=hostname_claim,
            jurisdiction_claim=jurisdiction_claim,
            locked=locked,
            namespace_claim=namespace_claim,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpRealTimeAuth", [value]))

    @jsii.member(jsii_name="putDeliveryReceipt")
    def put_delivery_receipt(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeliveryReceipt", [value]))

    @jsii.member(jsii_name="putDenyAccess")
    def put_deny_access(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess(
            enabled=enabled,
            locked=locked,
            reason=reason,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDenyAccess", [value]))

    @jsii.member(jsii_name="putDenyDirectFailoverAccess")
    def put_deny_direct_failover_access(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDenyDirectFailoverAccess", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicCacheId")
    def put_device_characteristic_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicCacheId", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicHeader")
    def put_device_characteristic_header(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicHeader", [value]))

    @jsii.member(jsii_name="putDnsAsyncRefresh")
    def put_dns_async_refresh(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsAsyncRefresh", [value]))

    @jsii.member(jsii_name="putDnsPrefresh")
    def put_dns_prefresh(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh(
            delay=delay,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsPrefresh", [value]))

    @jsii.member(jsii_name="putDowngradeProtocol")
    def put_downgrade_protocol(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDowngradeProtocol", [value]))

    @jsii.member(jsii_name="putDownloadCompleteMarker")
    def put_download_complete_marker(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadCompleteMarker", [value]))

    @jsii.member(jsii_name="putDownloadNotification")
    def put_download_notification(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadNotification", [value]))

    @jsii.member(jsii_name="putDownstreamCache")
    def put_downstream_cache(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache(
            allow_behavior=allow_behavior,
            behavior=behavior,
            locked=locked,
            send_headers=send_headers,
            send_private=send_private,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDownstreamCache", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimization")
    def put_dynamic_throughtput_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimization", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimizationOverride")
    def put_dynamic_throughtput_optimization_override(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride(
            locked=locked,
            template_uuid=template_uuid,
            throughput=throughput,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimizationOverride", [value]))

    @jsii.member(jsii_name="putDynamicWebContent")
    def put_dynamic_web_content(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent(
            image_compression=image_compression,
            locked=locked,
            prefetch=prefetch,
            real_user_monitoring=real_user_monitoring,
            sure_route=sure_route,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicWebContent", [value]))

    @jsii.member(jsii_name="putEcmsBulkUpload")
    def put_ecms_bulk_upload(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsBulkUpload", [value]))

    @jsii.member(jsii_name="putEcmsDatabase")
    def put_ecms_database(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase(
            database=database,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDatabase", [value]))

    @jsii.member(jsii_name="putEcmsDataset")
    def put_ecms_dataset(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset(
            dataset=dataset,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDataset", [value]))

    @jsii.member(jsii_name="putEcmsObjectKey")
    def put_ecms_object_key(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey(
            locked=locked, regex=regex, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsObjectKey", [value]))

    @jsii.member(jsii_name="putEdgeConnect")
    def put_edge_connect(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect(
            aggregate_lines=aggregate_lines,
            aggregate_size=aggregate_size,
            aggregate_time=aggregate_time,
            api_connector=api_connector,
            api_data_elements=api_data_elements,
            destination_hostname=destination_hostname,
            destination_path=destination_path,
            enabled=enabled,
            locked=locked,
            override_aggregate_settings=override_aggregate_settings,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeConnect", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingAdvanced")
    def put_edge_load_balancing_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingAdvanced", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingDataCenter")
    def put_edge_load_balancing_data_center(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter(
            cookie_name=cookie_name,
            description=description,
            enable_failover=enable_failover,
            failover_rules=failover_rules,
            failover_title=failover_title,
            hostname=hostname,
            ip=ip,
            locked=locked,
            origin_id=origin_id,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingDataCenter", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingOrigin")
    def put_edge_load_balancing_origin(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin(
            cookie_name=cookie_name,
            description=description,
            enable_session_persistence=enable_session_persistence,
            hostname=hostname,
            id=id,
            locked=locked,
            session_persistence_title=session_persistence_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingOrigin", [value]))

    @jsii.member(jsii_name="putEdgeOriginAuthorization")
    def put_edge_origin_authorization(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization(
            cookie_name=cookie_name,
            domain=domain,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeOriginAuthorization", [value_]))

    @jsii.member(jsii_name="putEdgeRedirector")
    def put_edge_redirector(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeRedirector", [value]))

    @jsii.member(jsii_name="putEdgeScape")
    def put_edge_scape(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeScape", [value]))

    @jsii.member(jsii_name="putEdgeSideIncludes")
    def put_edge_side_includes(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes(
            detect_injection=detect_injection,
            enabled=enabled,
            enable_via_http=enable_via_http,
            i18_n_charset=i18_n_charset,
            i18_n_status=i18_n_status,
            locked=locked,
            pass_client_ip=pass_client_ip,
            pass_set_cookie=pass_set_cookie,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeSideIncludes", [value]))

    @jsii.member(jsii_name="putEdgeWorker")
    def put_edge_worker(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker(
            create_edge_worker=create_edge_worker,
            edge_worker_id=edge_worker_id,
            enabled=enabled,
            locked=locked,
            resource_tier=resource_tier,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorker", [value]))

    @jsii.member(jsii_name="putEnhancedAkamaiProtocol")
    def put_enhanced_akamai_protocol(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedAkamaiProtocol", [value]))

    @jsii.member(jsii_name="putEnhancedProxyDetection")
    def put_enhanced_proxy_detection(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection(
            anonymous_vpn=anonymous_vpn,
            best_practice_action=best_practice_action,
            best_practice_redirecturl=best_practice_redirecturl,
            detect_anonymous_vpn=detect_anonymous_vpn,
            detect_anonymous_vpn_action=detect_anonymous_vpn_action,
            detect_anonymous_vpn_redirecturl=detect_anonymous_vpn_redirecturl,
            detect_hosting_provider=detect_hosting_provider,
            detect_hosting_provider_action=detect_hosting_provider_action,
            detect_hosting_provider_redirecturl=detect_hosting_provider_redirecturl,
            detect_public_proxy=detect_public_proxy,
            detect_public_proxy_action=detect_public_proxy_action,
            detect_public_proxy_redirecturl=detect_public_proxy_redirecturl,
            detect_residential_proxy=detect_residential_proxy,
            detect_residential_proxy_action=detect_residential_proxy_action,
            detect_residential_proxy_redirecturl=detect_residential_proxy_redirecturl,
            detect_smart_dns_proxy=detect_smart_dns_proxy,
            detect_smart_dns_proxy_action=detect_smart_dns_proxy_action,
            detect_smart_dns_proxy_redirecturl=detect_smart_dns_proxy_redirecturl,
            detect_tor_exit_node=detect_tor_exit_node,
            detect_tor_exit_node_action=detect_tor_exit_node_action,
            detect_tor_exit_node_redirecturl=detect_tor_exit_node_redirecturl,
            detect_vpn_data_center=detect_vpn_data_center,
            detect_vpn_data_center_action=detect_vpn_data_center_action,
            detect_vpn_data_center_redirecturl=detect_vpn_data_center_redirecturl,
            enable_configuration_mode=enable_configuration_mode,
            enabled=enabled,
            forward_header_enrichment=forward_header_enrichment,
            hosting_provider=hosting_provider,
            locked=locked,
            public_proxy=public_proxy,
            residential_proxy=residential_proxy,
            smart_dns_proxy=smart_dns_proxy,
            template_uuid=template_uuid,
            tor_exit_node=tor_exit_node,
            uuid=uuid,
            vpn_data_center=vpn_data_center,
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedProxyDetection", [value]))

    @jsii.member(jsii_name="putEpdForwardHeaderEnrichment")
    def put_epd_forward_header_enrichment(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEpdForwardHeaderEnrichment", [value]))

    @jsii.member(jsii_name="putFailAction")
    def put_fail_action(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction(
            action_type=action_type,
            allow_fcm_parent_override=allow_fcm_parent_override,
            cex_custom_path=cex_custom_path,
            cex_hostname=cex_hostname,
            cex_path=cex_path,
            content_custom_path=content_custom_path,
            content_hostname=content_hostname,
            content_path=content_path,
            cp_code=cp_code,
            dynamic_custom_path=dynamic_custom_path,
            dynamic_method=dynamic_method,
            dynamic_path=dynamic_path,
            enabled=enabled,
            locked=locked,
            modify_protocol=modify_protocol,
            net_storage_hostname=net_storage_hostname,
            net_storage_path=net_storage_path,
            preserve_query_string=preserve_query_string,
            protocol=protocol,
            redirect_custom_path=redirect_custom_path,
            redirect_hostname=redirect_hostname,
            redirect_hostname_type=redirect_hostname_type,
            redirect_method=redirect_method,
            redirect_path=redirect_path,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailAction", [value]))

    @jsii.member(jsii_name="putFailoverBotManagerFeatureCompatibility")
    def put_failover_bot_manager_feature_compatibility(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility(
            compatibility=compatibility,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailoverBotManagerFeatureCompatibility", [value]))

    @jsii.member(jsii_name="putFastInvalidate")
    def put_fast_invalidate(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFastInvalidate", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketing")
    def put_first_party_marketing(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketing", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketingPlus")
    def put_first_party_marketing_plus(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketingPlus", [value]))

    @jsii.member(jsii_name="putForwardRewrite")
    def put_forward_rewrite(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putForwardRewrite", [value]))

    @jsii.member(jsii_name="putFrontEndOptimization")
    def put_front_end_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the front-end optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFrontEndOptimization", [value]))

    @jsii.member(jsii_name="putG2Oheader")
    def put_g2_oheader(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader(
            custom_sign_string=custom_sign_string,
            data_header=data_header,
            enabled=enabled,
            encoding_version=encoding_version,
            locked=locked,
            nonce=nonce,
            secret_key=secret_key,
            signed_header=signed_header,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putG2Oheader", [value]))

    @jsii.member(jsii_name="putGlobalRequestNumber")
    def put_global_request_number(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber(
            header_name=header_name,
            locked=locked,
            output_option=output_option,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putGlobalRequestNumber", [value]))

    @jsii.member(jsii_name="putGraphqlCaching")
    def put_graphql_caching(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching(
            advanced=advanced,
            cache_responses_with_errors=cache_responses_with_errors,
            enabled=enabled,
            locked=locked,
            operations_json_body_parameter_name=operations_json_body_parameter_name,
            operations_url_query_parameter_name=operations_url_query_parameter_name,
            post_request_processing_error_handling=post_request_processing_error_handling,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putGraphqlCaching", [value]))

    @jsii.member(jsii_name="putGzipResponse")
    def put_gzip_response(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putGzipResponse", [value]))

    @jsii.member(jsii_name="putHdDataAdvanced")
    def put_hd_data_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putHdDataAdvanced", [value]))

    @jsii.member(jsii_name="putHealthDetection")
    def put_health_detection(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection(
            locked=locked,
            maximum_reconnects=maximum_reconnects,
            retry_count=retry_count,
            retry_interval=retry_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHealthDetection", [value]))

    @jsii.member(jsii_name="putHsafEipBinding")
    def put_hsaf_eip_binding(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding(
            custom_extracted_serial=custom_extracted_serial,
            enabled=enabled,
            hash_max_value=hash_max_value,
            hash_min_value=hash_min_value,
            locked=locked,
            template_uuid=template_uuid,
            tier=tier,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHsafEipBinding", [value]))

    @jsii.member(jsii_name="putHttp2")
    def put_http2(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp2", [value]))

    @jsii.member(jsii_name="putHttp3")
    def put_http3(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp3", [value]))

    @jsii.member(jsii_name="putHttpStrictTransportSecurity")
    def put_http_strict_transport_security(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity(
            enable=enable,
            include_sub_domains=include_sub_domains,
            locked=locked,
            max_age=max_age,
            preload=preload,
            redirect=redirect,
            redirect_status_code=redirect_status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHttpStrictTransportSecurity", [value]))

    @jsii.member(jsii_name="putHttpToHttpsUpgrade")
    def put_http_to_https_upgrade(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade(
            locked=locked, template_uuid=template_uuid, upgrade=upgrade, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttpToHttpsUpgrade", [value]))

    @jsii.member(jsii_name="putImageAndVideoManager")
    def put_image_and_video_manager(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager(
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            image_set=image_set,
            locked=locked,
            policy_set_type=policy_set_type,
            resize=resize,
            template_uuid=template_uuid,
            uuid=uuid,
            video_set=video_set,
        )

        return typing.cast(None, jsii.invoke(self, "putImageAndVideoManager", [value]))

    @jsii.member(jsii_name="putImageManager")
    def put_image_manager(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManager", [value]))

    @jsii.member(jsii_name="putImageManagerVideo")
    def put_image_manager_video(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManagerVideo", [value]))

    @jsii.member(jsii_name="putImOverride")
    def put_im_override(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride(
            dpr=dpr,
            dprvar=dprvar,
            exclude_all_query_parameters=exclude_all_query_parameters,
            excluded_query_parameters=excluded_query_parameters,
            format=format,
            formatvar=formatvar,
            locked=locked,
            override=override,
            policy=policy,
            policyvar=policyvar,
            policyvar_i_mvar=policyvar_i_mvar,
            policyvar_name=policyvar_name,
            template_uuid=template_uuid,
            typesel=typesel,
            uuid=uuid,
            width=width,
            widthvar=widthvar,
        )

        return typing.cast(None, jsii.invoke(self, "putImOverride", [value]))

    @jsii.member(jsii_name="putInclude")
    def put_include(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude(
            id=id, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInclude", [value]))

    @jsii.member(jsii_name="putInputValidation")
    def put_input_validation(
        self,
        *,
        allow_large_post_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure302_uri: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        penalty302_uri: typing.Optional[builtins.str] = None,
        penalty403_net_storage_path: typing.Optional[builtins.str] = None,
        penalty_action: typing.Optional[builtins.str] = None,
        penalty_branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        penalty_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        penalty_threshold: typing.Optional[jsii.Number] = None,
        penalty_title: typing.Optional[builtins.str] = None,
        reset_on_valid: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        validate_on_origin_header_name: typing.Optional[builtins.str] = None,
        validate_on_origin_header_value: typing.Optional[builtins.str] = None,
        validate_on_origin_response_code: typing.Optional[jsii.Number] = None,
        validate_on_origin_with: typing.Optional[builtins.str] = None,
        validation_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_large_post_body: Fails POST request bodies that exceed 16 KB when enabled, otherwise allows them to pass with no validation for policy compliance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_large_post_body DataAkamaiPropertyRulesBuilder#allow_large_post_body}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Applies the Input Validation Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failure302_uri: Specifies the redirect link for invalid requests that have not yet triggered a penalty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure302_uri DataAkamaiPropertyRulesBuilder#failure302_uri}
        :param label: Distinguishes this Input Validation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param penalty302_uri: Specifies the redirect link for end users who trigger the penalty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty302_uri DataAkamaiPropertyRulesBuilder#penalty302_uri}
        :param penalty403_net_storage_path: Specifies the full path to the static 403 response content relative to the ``downloadDomainName`` in the ``penaltyNetStorage`` object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty403_net_storage_path DataAkamaiPropertyRulesBuilder#penalty403_net_storage_path}
        :param penalty_action: Once the ``penaltyThreshold`` of invalid requests is met, this specifies the response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_action DataAkamaiPropertyRulesBuilder#penalty_action}
        :param penalty_branded_deny_cache_ttl: Specifies the penalty response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#penalty_branded_deny_cache_ttl}
        :param penalty_net_storage: penalty_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_net_storage DataAkamaiPropertyRulesBuilder#penalty_net_storage}
        :param penalty_threshold: Specifies the number of invalid requests permitted before executing the ``penaltyAction``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_threshold DataAkamaiPropertyRulesBuilder#penalty_threshold}
        :param penalty_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#penalty_title DataAkamaiPropertyRulesBuilder#penalty_title}
        :param reset_on_valid: Upon receiving a valid request, enabling this resets the ``penaltyThreshold`` counter to zero. Otherwise, even those series of invalid requests that are interrupted by valid requests may trigger the ``penaltyAction``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset_on_valid DataAkamaiPropertyRulesBuilder#reset_on_valid}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by specific HTTP headers on GET or POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: When enabled, identifies users by specific IP address. Do not enable this if you are concerned about DDoS attacks from many different IP addresses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by specific query parameters on GET or POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: This specifies the cookie name whose value needs to remain constant across requests to identify a user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: This specifies the HTTP headers whose combined set of values identify each end user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: This specifies the query parameters whose combined set of values identify each end user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param validate_on_origin_header_name: If ``validateOnOriginWith`` is set to ``RESPONSE_CODE_AND_HEADER``, this specifies the header name for a request that the origin identifies as invalid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_header_name DataAkamaiPropertyRulesBuilder#validate_on_origin_header_name}
        :param validate_on_origin_header_value: If ``validateOnOriginWith`` is set to ``RESPONSE_CODE_AND_HEADER``, this specifies an invalid request's header value that corresponds to the ``validateOnOriginHeaderName``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_header_value DataAkamaiPropertyRulesBuilder#validate_on_origin_header_value}
        :param validate_on_origin_response_code: Unless ``validateOnOriginWith`` is ``DISABLED``, this identifies the integer response code for requests the origin identifies as invalid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_response_code DataAkamaiPropertyRulesBuilder#validate_on_origin_response_code}
        :param validate_on_origin_with: For any validation that edge servers can't perform alone, this specifies additional validation steps based on how the origin identifies an invalid request. If a request is invalid, the origin can indicate this to the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_on_origin_with DataAkamaiPropertyRulesBuilder#validate_on_origin_with}
        :param validation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validation_title DataAkamaiPropertyRulesBuilder#validation_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation(
            allow_large_post_body=allow_large_post_body,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            failure302_uri=failure302_uri,
            label=label,
            locked=locked,
            penalty302_uri=penalty302_uri,
            penalty403_net_storage_path=penalty403_net_storage_path,
            penalty_action=penalty_action,
            penalty_branded_deny_cache_ttl=penalty_branded_deny_cache_ttl,
            penalty_net_storage=penalty_net_storage,
            penalty_threshold=penalty_threshold,
            penalty_title=penalty_title,
            reset_on_valid=reset_on_valid,
            template_uuid=template_uuid,
            user_identification_by_cookie=user_identification_by_cookie,
            user_identification_by_headers=user_identification_by_headers,
            user_identification_by_ip=user_identification_by_ip,
            user_identification_by_params=user_identification_by_params,
            user_identification_key_cookie=user_identification_key_cookie,
            user_identification_key_headers=user_identification_key_headers,
            user_identification_key_params=user_identification_key_params,
            user_identification_title=user_identification_title,
            uuid=uuid,
            validate_on_origin_header_name=validate_on_origin_header_name,
            validate_on_origin_header_value=validate_on_origin_header_value,
            validate_on_origin_response_code=validate_on_origin_response_code,
            validate_on_origin_with=validate_on_origin_with,
            validation_title=validation_title,
        )

        return typing.cast(None, jsii.invoke(self, "putInputValidation", [value]))

    @jsii.member(jsii_name="putInstant")
    def put_instant(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant(
            custom_link_relations=custom_link_relations,
            locked=locked,
            prefetch_cacheable=prefetch_cacheable,
            prefetch_html=prefetch_html,
            prefetch_no_store=prefetch_no_store,
            prefetch_no_store_extensions=prefetch_no_store_extensions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putInstant", [value]))

    @jsii.member(jsii_name="putInstantConfig")
    def put_instant_config(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInstantConfig", [value]))

    @jsii.member(jsii_name="putLargeFileOptimization")
    def put_large_file_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization(
            enabled=enabled,
            enable_partial_object_caching=enable_partial_object_caching,
            locked=locked,
            maximum_size=maximum_size,
            minimum_size=minimum_size,
            template_uuid=template_uuid,
            use_versioning=use_versioning,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimization", [value]))

    @jsii.member(jsii_name="putLargeFileOptimizationAdvanced")
    def put_large_file_optimization_advanced(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced(
            enabled=enabled,
            fragment_size=fragment_size,
            locked=locked,
            object_size=object_size,
            prefetch_after_request=prefetch_after_request,
            prefetch_during_request=prefetch_during_request,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimizationAdvanced", [value]))

    @jsii.member(jsii_name="putLimitBitRate")
    def put_limit_bit_rate(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate(
            bitrate_table=bitrate_table,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            threshold_table=threshold_table,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLimitBitRate", [value]))

    @jsii.member(jsii_name="putLogCustom")
    def put_log_custom(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom(
            custom_log_field=custom_log_field,
            locked=locked,
            log_custom_log_field=log_custom_log_field,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLogCustom", [value]))

    @jsii.member(jsii_name="putManifestPersonalization")
    def put_manifest_personalization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization(
            enabled=enabled,
            hls_enabled=hls_enabled,
            hls_enable_debug_headers=hls_enable_debug_headers,
            hls_filter_in_bitrate_ranges=hls_filter_in_bitrate_ranges,
            hls_filter_in_bitrates=hls_filter_in_bitrates,
            hls_mode=hls_mode,
            hls_preferred_bitrate=hls_preferred_bitrate,
            hls_query_param_enabled=hls_query_param_enabled,
            hls_query_param_secret_key=hls_query_param_secret_key,
            hls_query_param_transition_key=hls_query_param_transition_key,
            hls_show_advanced=hls_show_advanced,
            hls_title=hls_title,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestPersonalization", [value]))

    @jsii.member(jsii_name="putManifestRerouting")
    def put_manifest_rerouting(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting(
            locked=locked,
            partner=partner,
            template_uuid=template_uuid,
            username=username,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestRerouting", [value]))

    @jsii.member(jsii_name="putManualServerPush")
    def put_manual_server_push(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush(
            locked=locked,
            serverpushlist=serverpushlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManualServerPush", [value]))

    @jsii.member(jsii_name="putMediaAcceleration")
    def put_media_acceleration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAcceleration", [value]))

    @jsii.member(jsii_name="putMediaAccelerationQuicOptout")
    def put_media_acceleration_quic_optout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout(
            locked=locked, optout=optout, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAccelerationQuicOptout", [value]))

    @jsii.member(jsii_name="putMediaClient")
    def put_media_client(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient(
            beacon_id=beacon_id,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_hybrid_http_udp=use_hybrid_http_udp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaClient", [value]))

    @jsii.member(jsii_name="putMediaFileRetrievalOptimization")
    def put_media_file_retrieval_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaFileRetrievalOptimization", [value]))

    @jsii.member(jsii_name="putMediaOriginFailover")
    def put_media_origin_failover(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover(
            cache_error_response=cache_error_response,
            cache_window=cache_window,
            client_response_code=client_response_code,
            detect_object_unavailable=detect_object_unavailable,
            detect_object_unavailable_title=detect_object_unavailable_title,
            detect_origin_unavailable=detect_origin_unavailable,
            detect_origin_unavailable_title=detect_origin_unavailable_title,
            detect_origin_unresponsive=detect_origin_unresponsive,
            detect_origin_unresponsive_title=detect_origin_unresponsive_title,
            locked=locked,
            object_unavailable_alternate_host=object_unavailable_alternate_host,
            object_unavailable_backup_host=object_unavailable_backup_host,
            object_unavailable_blacklist_origin_ip=object_unavailable_blacklist_origin_ip,
            object_unavailable_blacklist_window=object_unavailable_blacklist_window,
            object_unavailable_change_protocol=object_unavailable_change_protocol,
            object_unavailable_detection_level=object_unavailable_detection_level,
            object_unavailable_include_query_string=object_unavailable_include_query_string,
            object_unavailable_modified_path=object_unavailable_modified_path,
            object_unavailable_modify_request_path=object_unavailable_modify_request_path,
            object_unavailable_protocol=object_unavailable_protocol,
            object_unavailable_recovery=object_unavailable_recovery,
            object_unavailable_redirect_method=object_unavailable_redirect_method,
            object_unavailable_response_codes=object_unavailable_response_codes,
            object_unavailable_retry_limit=object_unavailable_retry_limit,
            origin_unavailable_alternate_host=origin_unavailable_alternate_host,
            origin_unavailable_backup_host=origin_unavailable_backup_host,
            origin_unavailable_blacklist_origin_ip=origin_unavailable_blacklist_origin_ip,
            origin_unavailable_blacklist_window=origin_unavailable_blacklist_window,
            origin_unavailable_change_protocol=origin_unavailable_change_protocol,
            origin_unavailable_detection_level=origin_unavailable_detection_level,
            origin_unavailable_include_query_string=origin_unavailable_include_query_string,
            origin_unavailable_modified_path=origin_unavailable_modified_path,
            origin_unavailable_modify_request_path=origin_unavailable_modify_request_path,
            origin_unavailable_protocol=origin_unavailable_protocol,
            origin_unavailable_recovery=origin_unavailable_recovery,
            origin_unavailable_redirect_method=origin_unavailable_redirect_method,
            origin_unavailable_response_codes=origin_unavailable_response_codes,
            origin_unavailable_retry_limit=origin_unavailable_retry_limit,
            origin_unresponsive_alternate_host=origin_unresponsive_alternate_host,
            origin_unresponsive_backup_host=origin_unresponsive_backup_host,
            origin_unresponsive_blacklist_origin_ip=origin_unresponsive_blacklist_origin_ip,
            origin_unresponsive_blacklist_window=origin_unresponsive_blacklist_window,
            origin_unresponsive_change_protocol=origin_unresponsive_change_protocol,
            origin_unresponsive_detection_level=origin_unresponsive_detection_level,
            origin_unresponsive_include_query_string=origin_unresponsive_include_query_string,
            origin_unresponsive_modified_path=origin_unresponsive_modified_path,
            origin_unresponsive_modify_request_path=origin_unresponsive_modify_request_path,
            origin_unresponsive_protocol=origin_unresponsive_protocol,
            origin_unresponsive_recovery=origin_unresponsive_recovery,
            origin_unresponsive_redirect_method=origin_unresponsive_redirect_method,
            origin_unresponsive_retry_limit=origin_unresponsive_retry_limit,
            other_options=other_options,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaOriginFailover", [value]))

    @jsii.member(jsii_name="putMetadataCaching")
    def put_metadata_caching(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataCaching", [value]))

    @jsii.member(jsii_name="putMobileSdkPerformance")
    def put_mobile_sdk_performance(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance(
            enabled=enabled,
            locked=locked,
            secondary_multipath_to_origin=secondary_multipath_to_origin,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMobileSdkPerformance", [value]))

    @jsii.member(jsii_name="putModifyIncomingRequestHeader")
    def put_modify_incoming_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyIncomingResponseHeader")
    def put_modify_incoming_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingRequestHeader")
    def put_modify_outgoing_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingResponseHeader")
    def put_modify_outgoing_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyViaHeader")
    def put_modify_via_header(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader(
            enabled=enabled,
            locked=locked,
            modification_option=modification_option,
            rename_header_to=rename_header_to,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyViaHeader", [value]))

    @jsii.member(jsii_name="putMPulse")
    def put_m_pulse(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse(
            api_key=api_key,
            buffer_size=buffer_size,
            config_override=config_override,
            enabled=enabled,
            loader_version=loader_version,
            locked=locked,
            require_pci=require_pci,
            template_uuid=template_uuid,
            title_optional=title_optional,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMPulse", [value]))

    @jsii.member(jsii_name="putOrigin")
    def put_origin(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin(
            cache_key_hostname=cache_key_hostname,
            compress=compress,
            custom_certificate_authorities=custom_certificate_authorities,
            custom_certificates=custom_certificates,
            custom_forward_host_header=custom_forward_host_header,
            custom_valid_cn_values=custom_valid_cn_values,
            enable_true_client_ip=enable_true_client_ip,
            forward_host_header=forward_host_header,
            hostname=hostname,
            http_port=http_port,
            https_port=https_port,
            ip_version=ip_version,
            locked=locked,
            mslorigin=mslorigin,
            net_storage=net_storage,
            origin_certificate=origin_certificate,
            origin_certs_to_honor=origin_certs_to_honor,
            origin_id=origin_id,
            origin_sni=origin_sni,
            origin_type=origin_type,
            ports=ports,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            second_hostname=second_hostname,
            second_hostname_enabled=second_hostname_enabled,
            standard_certificate_authorities=standard_certificate_authorities,
            template_uuid=template_uuid,
            true_client_ip_client_setting=true_client_ip_client_setting,
            true_client_ip_header=true_client_ip_header,
            use_unique_cache_key=use_unique_cache_key,
            uuid=uuid,
            verification_mode=verification_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putOrigin", [value]))

    @jsii.member(jsii_name="putOriginCharacteristics")
    def put_origin_characteristics(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics(
            access_key_encrypted_storage=access_key_encrypted_storage,
            adc_title=adc_title,
            authentication_method=authentication_method,
            authentication_method_title=authentication_method_title,
            aws_access_key_id=aws_access_key_id,
            aws_access_key_version_guid=aws_access_key_version_guid,
            aws_host=aws_host,
            aws_region=aws_region,
            aws_secret_access_key=aws_secret_access_key,
            aws_service=aws_service,
            country=country,
            custom_sign_string=custom_sign_string,
            direct_connect_geo=direct_connect_geo,
            encoding_version=encoding_version,
            gcs_access_key_version_guid=gcs_access_key_version_guid,
            gcs_hmac_key_access_id=gcs_hmac_key_access_id,
            gcs_hmac_key_secret=gcs_hmac_key_secret,
            locked=locked,
            mslkey=mslkey,
            mslname=mslname,
            nonce=nonce,
            secret_key=secret_key,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristics", [value]))

    @jsii.member(jsii_name="putOriginCharacteristicsWsd")
    def put_origin_characteristics_wsd(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd(
            locked=locked,
            origintype=origintype,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristicsWsd", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryMethod")
    def put_origin_failure_recovery_method(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod(
            custom_status_code=custom_status_code,
            locked=locked,
            recovery_method=recovery_method,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryMethod", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryPolicy")
    def put_origin_failure_recovery_policy(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy(
            binary_equivalent_content=binary_equivalent_content,
            enabled=enabled,
            enable_ip_avoidance=enable_ip_avoidance,
            ip_avoidance_error_threshold=ip_avoidance_error_threshold,
            ip_avoidance_retry_interval=ip_avoidance_retry_interval,
            locked=locked,
            monitor_origin_responsiveness=monitor_origin_responsiveness,
            monitor_response_codes1=monitor_response_codes1,
            monitor_response_codes2=monitor_response_codes2,
            monitor_response_codes3=monitor_response_codes3,
            monitor_status_codes1=monitor_status_codes1,
            monitor_status_codes1_enable_recovery=monitor_status_codes1_enable_recovery,
            monitor_status_codes1_enable_retry=monitor_status_codes1_enable_retry,
            monitor_status_codes1_recovery_config_name=monitor_status_codes1_recovery_config_name,
            monitor_status_codes2=monitor_status_codes2,
            monitor_status_codes2_enable_recovery=monitor_status_codes2_enable_recovery,
            monitor_status_codes2_enable_retry=monitor_status_codes2_enable_retry,
            monitor_status_codes2_recovery_config_name=monitor_status_codes2_recovery_config_name,
            monitor_status_codes3=monitor_status_codes3,
            monitor_status_codes3_enable_recovery=monitor_status_codes3_enable_recovery,
            monitor_status_codes3_enable_retry=monitor_status_codes3_enable_retry,
            monitor_status_codes3_recovery_config_name=monitor_status_codes3_recovery_config_name,
            origin_responsiveness_custom_timeout=origin_responsiveness_custom_timeout,
            origin_responsiveness_enable_recovery=origin_responsiveness_enable_recovery,
            origin_responsiveness_enable_retry=origin_responsiveness_enable_retry,
            origin_responsiveness_monitoring=origin_responsiveness_monitoring,
            origin_responsiveness_recovery_config_name=origin_responsiveness_recovery_config_name,
            origin_responsiveness_timeout=origin_responsiveness_timeout,
            status_code_monitoring1=status_code_monitoring1,
            status_code_monitoring2=status_code_monitoring2,
            status_code_monitoring3=status_code_monitoring3,
            template_uuid=template_uuid,
            tuning_parameters=tuning_parameters,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryPolicy", [value]))

    @jsii.member(jsii_name="putOriginIpAcl")
    def put_origin_ip_acl(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putOriginIpAcl", [value]))

    @jsii.member(jsii_name="putPersistentClientConnection")
    def put_persistent_client_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentClientConnection", [value]))

    @jsii.member(jsii_name="putPersistentConnection")
    def put_persistent_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentConnection", [value]))

    @jsii.member(jsii_name="putPersonallyIdentifiableInformation")
    def put_personally_identifiable_information(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPersonallyIdentifiableInformation", [value]))

    @jsii.member(jsii_name="putPhasedRelease")
    def put_phased_release(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            failover_duration=failover_duration,
            failover_enabled=failover_enabled,
            failover_response_code=failover_response_code,
            failover_title=failover_title,
            label=label,
            locked=locked,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_expiration_date=population_expiration_date,
            population_refresh=population_refresh,
            population_title=population_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPhasedRelease", [value]))

    @jsii.member(jsii_name="putPreconnect")
    def put_preconnect(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect(
            locked=locked,
            preconnectlist=preconnectlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPreconnect", [value]))

    @jsii.member(jsii_name="putPredictiveContentDelivery")
    def put_predictive_content_delivery(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPredictiveContentDelivery", [value]))

    @jsii.member(jsii_name="putPredictivePrefetching")
    def put_predictive_prefetching(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching(
            accuracy_target=accuracy_target,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPredictivePrefetching", [value]))

    @jsii.member(jsii_name="putPrefetch")
    def put_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetch", [value]))

    @jsii.member(jsii_name="putPrefetchable")
    def put_prefetchable(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetchable", [value]))

    @jsii.member(jsii_name="putPrefreshCache")
    def put_prefresh_cache(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache(
            enabled=enabled,
            locked=locked,
            prefreshval=prefreshval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPrefreshCache", [value]))

    @jsii.member(jsii_name="putQuality")
    def put_quality(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality(
            audience_settings=audience_settings,
            catalog_size=catalog_size,
            content_settings=content_settings,
            content_type=content_type,
            country=country,
            delivery_format=delivery_format,
            delivery_type=delivery_type,
            download_type=download_type,
            end_user_location=end_user_location,
            locked=locked,
            maximum_concurrent_users=maximum_concurrent_users,
            object_size=object_size,
            optimize_for=optimize_for,
            origin_settings=origin_settings,
            popularity_distribution=popularity_distribution,
            refresh_rate=refresh_rate,
            segment_duration=segment_duration,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuality", [value]))

    @jsii.member(jsii_name="putQuicBeta")
    def put_quic_beta(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta(
            enabled=enabled,
            locked=locked,
            quic_offer_percentage=quic_offer_percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuicBeta", [value]))

    @jsii.member(jsii_name="putRandomSeek")
    def put_random_seek(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek(
            flv=flv,
            locked=locked,
            maximum_size=maximum_size,
            mp4=mp4,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRandomSeek", [value]))

    @jsii.member(jsii_name="putRapid")
    def put_rapid(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRapid", [value]))

    @jsii.member(jsii_name="putReadTimeout")
    def put_read_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putReadTimeout", [value_]))

    @jsii.member(jsii_name="putRealTimeReporting")
    def put_real_time_reporting(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting(
            advanced=advanced,
            beacon_sampling_percentage=beacon_sampling_percentage,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRealTimeReporting", [value]))

    @jsii.member(jsii_name="putRealUserMonitoring")
    def put_real_user_monitoring(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRealUserMonitoring", [value]))

    @jsii.member(jsii_name="putRedirect")
    def put_redirect(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect(
            destination_hostname=destination_hostname,
            destination_hostname_other=destination_hostname_other,
            destination_hostname_sibling=destination_hostname_sibling,
            destination_hostname_subdomain=destination_hostname_subdomain,
            destination_path=destination_path,
            destination_path_other=destination_path_other,
            destination_path_prefix=destination_path_prefix,
            destination_path_suffix=destination_path_suffix,
            destination_path_suffix_status=destination_path_suffix_status,
            destination_protocol=destination_protocol,
            locked=locked,
            mobile_default_choice=mobile_default_choice,
            query_string=query_string,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirect", [value]))

    @jsii.member(jsii_name="putRedirectplus")
    def put_redirectplus(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus(
            destination=destination,
            enabled=enabled,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirectplus", [value]))

    @jsii.member(jsii_name="putRefererChecking")
    def put_referer_checking(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking(
            allow_children=allow_children,
            domains=domains,
            enabled=enabled,
            locked=locked,
            strict=strict,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRefererChecking", [value]))

    @jsii.member(jsii_name="putRemoveQueryParameter")
    def put_remove_query_parameter(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter(
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveQueryParameter", [value]))

    @jsii.member(jsii_name="putRemoveVary")
    def put_remove_vary(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveVary", [value]))

    @jsii.member(jsii_name="putReport")
    def put_report(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport(
            cookies=cookies,
            custom_log_field=custom_log_field,
            locked=locked,
            log_accept_language=log_accept_language,
            log_cookies=log_cookies,
            log_custom_log_field=log_custom_log_field,
            log_edge_ip=log_edge_ip,
            log_host=log_host,
            log_referer=log_referer,
            log_user_agent=log_user_agent,
            log_x_forwarded_for=log_x_forwarded_for,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReport", [value]))

    @jsii.member(jsii_name="putRequestControl")
    def put_request_control(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl(
            branded403_file=branded403_file,
            branded403_status_code=branded403_status_code,
            branded403_url=branded403_url,
            branded_deny_cache_ttl=branded_deny_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            enable_branded403=enable_branded403,
            enabled=enabled,
            locked=locked,
            net_storage=net_storage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestControl", [value]))

    @jsii.member(jsii_name="putRequestTypeMarker")
    def put_request_type_marker(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker(
            locked=locked,
            request_type=request_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestTypeMarker", [value]))

    @jsii.member(jsii_name="putResourceOptimizer")
    def put_resource_optimizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizer", [value]))

    @jsii.member(jsii_name="putResourceOptimizerExtendedCompatibility")
    def put_resource_optimizer_extended_compatibility(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility(
            enable_all_features=enable_all_features,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizerExtendedCompatibility", [value]))

    @jsii.member(jsii_name="putResponseCode")
    def put_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode(
            locked=locked,
            override206=override206,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCode", [value]))

    @jsii.member(jsii_name="putResponseCookie")
    def put_response_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie(
            cookie_name=cookie_name,
            default_domain=default_domain,
            default_path=default_path,
            domain=domain,
            duration=duration,
            enabled=enabled,
            expiration_date=expiration_date,
            expires=expires,
            format=format,
            http_only=http_only,
            locked=locked,
            path=path,
            same_site=same_site,
            secure=secure,
            template_uuid=template_uuid,
            type=type,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCookie", [value_]))

    @jsii.member(jsii_name="putRestrictObjectCaching")
    def put_restrict_object_caching(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching(
            locked=locked,
            maximum_size=maximum_size,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRestrictObjectCaching", [value]))

    @jsii.member(jsii_name="putReturnCacheStatus")
    def put_return_cache_status(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus(
            locked=locked,
            response_header_name=response_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReturnCacheStatus", [value]))

    @jsii.member(jsii_name="putRewriteUrl")
    def put_rewrite_url(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl(
            behavior=behavior,
            keep_query_string=keep_query_string,
            locked=locked,
            match=match,
            match_multiple=match_multiple,
            match_regex=match_regex,
            target_path=target_path,
            target_path_prepend=target_path_prepend,
            target_regex=target_regex,
            target_url=target_url,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRewriteUrl", [value]))

    @jsii.member(jsii_name="putRumCustom")
    def put_rum_custom(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom(
            locked=locked,
            rum_group_name=rum_group_name,
            rum_sample_rate=rum_sample_rate,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRumCustom", [value]))

    @jsii.member(jsii_name="putSaasDefinitions")
    def put_saas_definitions(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions(
            application_action=application_action,
            application_cname_enabled=application_cname_enabled,
            application_cname_level=application_cname_level,
            application_cookie=application_cookie,
            application_query_string=application_query_string,
            application_regex=application_regex,
            application_replace=application_replace,
            application_title=application_title,
            customer_action=customer_action,
            customer_cname_enabled=customer_cname_enabled,
            customer_cname_level=customer_cname_level,
            customer_cookie=customer_cookie,
            customer_query_string=customer_query_string,
            customer_regex=customer_regex,
            customer_replace=customer_replace,
            customer_title=customer_title,
            locked=locked,
            template_uuid=template_uuid,
            users_action=users_action,
            users_cname_enabled=users_cname_enabled,
            users_cname_level=users_cname_level,
            users_cookie=users_cookie,
            users_query_string=users_query_string,
            users_regex=users_regex,
            users_replace=users_replace,
            users_title=users_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSaasDefinitions", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudClient")
    def put_sales_force_commerce_cloud_client(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient(
            allow_override_origin_cache_key=allow_override_origin_cache_key,
            connector_id=connector_id,
            enabled=enabled,
            locked=locked,
            origin_host_header=origin_host_header,
            origin_type=origin_type,
            sf3_c_origin_host=sf3_c_origin_host,
            sf3_c_origin_host_header=sf3_c_origin_host_header,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudClient", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProvider")
    def put_sales_force_commerce_cloud_provider(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProvider", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProviderHostHeader")
    def put_sales_force_commerce_cloud_provider_host_header(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader(
            host_header_source=host_header_source,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProviderHostHeader", [value]))

    @jsii.member(jsii_name="putSavePostDcaProcessing")
    def put_save_post_dca_processing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSavePostDcaProcessing", [value]))

    @jsii.member(jsii_name="putScheduleInvalidation")
    def put_schedule_invalidation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation(
            locked=locked,
            refresh_method=refresh_method,
            repeat=repeat,
            repeat_interval=repeat_interval,
            start=start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScheduleInvalidation", [value]))

    @jsii.member(jsii_name="putScriptManagement")
    def put_script_management(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement(
            enabled=enabled,
            locked=locked,
            serviceworker=serviceworker,
            template_uuid=template_uuid,
            timestamp=timestamp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScriptManagement", [value]))

    @jsii.member(jsii_name="putSegmentedContentProtection")
    def put_segmented_content_protection(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection(
            acl=acl,
            dash_media_encryption=dash_media_encryption,
            data_payload=data_payload,
            enabled=enabled,
            enable_token_in_uri=enable_token_in_uri,
            field_carry_over=field_carry_over,
            header_for_salt=header_for_salt,
            hls_master_manifest_files=hls_master_manifest_files,
            hls_media_encryption=hls_media_encryption,
            ip=ip,
            key=key,
            locked=locked,
            media_encryption_title=media_encryption_title,
            revoked_list_id=revoked_list_id,
            salt=salt,
            session_id=session_id,
            template_uuid=template_uuid,
            token_authentication_title=token_authentication_title,
            token_auth_hls_title=token_auth_hls_title,
            token_revocation_enabled=token_revocation_enabled,
            token_revocation_title=token_revocation_title,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedContentProtection", [value]))

    @jsii.member(jsii_name="putSegmentedMediaOptimization")
    def put_segmented_media_optimization(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization(
            behavior=behavior,
            dvr_type=dvr_type,
            dvr_window=dvr_window,
            enable_ull_streaming=enable_ull_streaming,
            end_time=end_time,
            live_type=live_type,
            locked=locked,
            show_advanced=show_advanced,
            start_time=start_time,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaOptimization", [value]))

    @jsii.member(jsii_name="putSegmentedMediaStreamingPrefetch")
    def put_segmented_media_streaming_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaStreamingPrefetch", [value]))

    @jsii.member(jsii_name="putSetVariable")
    def put_set_variable(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[builtins.str] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[builtins.str] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[builtins.str] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable(
            algorithm=algorithm,
            case_sensitive=case_sensitive,
            certificate_field_name=certificate_field_name,
            cookie_name=cookie_name,
            device_profile=device_profile,
            encryption_key=encryption_key,
            encryption_mode=encryption_mode,
            end_index=end_index,
            except_chars=except_chars,
            extract_location=extract_location,
            force_chars=force_chars,
            format_string=format_string,
            generator=generator,
            global_substitution=global_substitution,
            header_name=header_name,
            hmac_algorithm=hmac_algorithm,
            hmac_key=hmac_key,
            initialization_vector=initialization_vector,
            ipv4_prefix=ipv4_prefix,
            ipv6_prefix=ipv6_prefix,
            ip_version=ip_version,
            location_id=location_id,
            locked=locked,
            max=max,
            max_random_number=max_random_number,
            min=min,
            min_random_number=min_random_number,
            nonce=nonce,
            number_of_bytes=number_of_bytes,
            operand_one=operand_one,
            param_name=param_name,
            path_component_offset=path_component_offset,
            prepend_bytes=prepend_bytes,
            query_parameter_name=query_parameter_name,
            regex=regex,
            replacement=replacement,
            response_header_name=response_header_name,
            separator=separator,
            set_cookie_name=set_cookie_name,
            start_index=start_index,
            sub_string=sub_string,
            template_uuid=template_uuid,
            transform=transform,
            uuid=uuid,
            value_source=value_source,
            variable_name=variable_name,
            variable_value=variable_value,
        )

        return typing.cast(None, jsii.invoke(self, "putSetVariable", [value]))

    @jsii.member(jsii_name="putShutr")
    def put_shutr(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status DataAkamaiPropertyRulesBuilder#status}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr(
            locked=locked, status=status, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putShutr", [value]))

    @jsii.member(jsii_name="putSimulateErrorCode")
    def put_simulate_error_code(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode(
            error_type=error_type,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSimulateErrorCode", [value]))

    @jsii.member(jsii_name="putSiteShield")
    def put_site_shield(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield(
            locked=locked,
            nossmap=nossmap,
            ssmap=ssmap,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSiteShield", [value]))

    @jsii.member(jsii_name="putStandardTlsMigration")
    def put_standard_tls_migration(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration(
            allow_https_downgrade=allow_https_downgrade,
            allow_https_upgrade=allow_https_upgrade,
            cache_sharing_duration=cache_sharing_duration,
            cache_sharing_start_time=cache_sharing_start_time,
            enabled=enabled,
            is_certificate_sni_only=is_certificate_sni_only,
            is_tiered_distribution_used=is_tiered_distribution_used,
            locked=locked,
            migration_duration=migration_duration,
            migration_from=migration_from,
            migration_start_time=migration_start_time,
            td_location=td_location,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigration", [value]))

    @jsii.member(jsii_name="putStandardTlsMigrationOverride")
    def put_standard_tls_migration_override(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride(
            info=info, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigrationOverride", [value]))

    @jsii.member(jsii_name="putStrictHeaderParsing")
    def put_strict_header_parsing(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing(
            locked=locked,
            strict_mode=strict_mode,
            template_uuid=template_uuid,
            uuid=uuid,
            valid_mode=valid_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putStrictHeaderParsing", [value]))

    @jsii.member(jsii_name="putSubCustomer")
    def put_sub_customer(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer(
            access_control=access_control,
            cache_key=cache_key,
            caching=caching,
            content_compressor=content_compressor,
            dynamic_web_content=dynamic_web_content,
            enabled=enabled,
            geo_location=geo_location,
            ip=ip,
            large_file_delivery=large_file_delivery,
            live_video_delivery=live_video_delivery,
            locked=locked,
            modify_path=modify_path,
            on_demand_video_delivery=on_demand_video_delivery,
            origin=origin,
            partner_domain_suffix=partner_domain_suffix,
            referrer=referrer,
            refresh_content=refresh_content,
            site_failover=site_failover,
            template_uuid=template_uuid,
            token_authorization=token_authorization,
            uuid=uuid,
            web_application_firewall=web_application_firewall,
        )

        return typing.cast(None, jsii.invoke(self, "putSubCustomer", [value]))

    @jsii.member(jsii_name="putSureRoute")
    def put_sure_route(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute(
            allow_fcm_parent_override=allow_fcm_parent_override,
            custom_map=custom_map,
            custom_stat_key=custom_stat_key,
            enable_custom_key=enable_custom_key,
            enabled=enabled,
            force_ssl_forward=force_ssl_forward,
            locked=locked,
            race_stat_ttl=race_stat_ttl,
            sr_download_link_title=sr_download_link_title,
            template_uuid=template_uuid,
            test_object_url=test_object_url,
            to_host=to_host,
            to_host_status=to_host_status,
            type=type,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSureRoute", [value]))

    @jsii.member(jsii_name="putTcpOptimization")
    def put_tcp_optimization(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putTcpOptimization", [value]))

    @jsii.member(jsii_name="putTeaLeaf")
    def put_tea_leaf(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf(
            enabled=enabled,
            ibm_customer_id=ibm_customer_id,
            limit_to_dynamic=limit_to_dynamic,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTeaLeaf", [value]))

    @jsii.member(jsii_name="putTieredDistribution")
    def put_tiered_distribution(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistribution", [value]))

    @jsii.member(jsii_name="putTieredDistributionAdvanced")
    def put_tiered_distribution_advanced(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced(
            allowall=allowall,
            enabled=enabled,
            locked=locked,
            method=method,
            policy=policy,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionAdvanced", [value]))

    @jsii.member(jsii_name="putTieredDistributionCustomization")
    def put_tiered_distribution_customization(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization(
            cloudwrapper_map_migration_title=cloudwrapper_map_migration_title,
            custom_map_enabled=custom_map_enabled,
            custom_map_name=custom_map_name,
            hash_algorithm=hash_algorithm,
            location=location,
            locked=locked,
            map_migration_enabled=map_migration_enabled,
            migration_end_date=migration_end_date,
            migration_start_date=migration_start_date,
            migration_within_cw_maps_enabled=migration_within_cw_maps_enabled,
            serial_end=serial_end,
            serial_start=serial_start,
            template_uuid=template_uuid,
            tier1_title=tier1_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionCustomization", [value]))

    @jsii.member(jsii_name="putTimeout")
    def put_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putTimeout", [value_]))

    @jsii.member(jsii_name="putUidConfiguration")
    def put_uid_configuration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration(
            enabled=enabled,
            extract_location=extract_location,
            header_name=header_name,
            legal_text=legal_text,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putUidConfiguration", [value]))

    @jsii.member(jsii_name="putValidateEntityTag")
    def put_validate_entity_tag(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putValidateEntityTag", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebToken")
    def put_verify_json_web_token(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken(
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_location=extract_location,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebToken", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebTokenForDcp")
    def put_verify_json_web_token_for_dcp(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp(
            authorizations=authorizations,
            client_id=client_id,
            custom_header=custom_header,
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_authorizations=extract_authorizations,
            extract_client_id=extract_client_id,
            extract_location=extract_location,
            extract_user_name=extract_user_name,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            primary_location=primary_location,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            user_name=user_name,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebTokenForDcp", [value]))

    @jsii.member(jsii_name="putVerifyTokenAuthorization")
    def put_verify_token_authorization(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization(
            algorithm=algorithm,
            escape_hmac_inputs=escape_hmac_inputs,
            failure_response=failure_response,
            ignore_query_string=ignore_query_string,
            key=key,
            location=location,
            location_id=location_id,
            locked=locked,
            salt=salt,
            template_uuid=template_uuid,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyTokenAuthorization", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoom")
    def put_virtual_waiting_room(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoom", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomWithEdgeWorkers")
    def put_virtual_waiting_room_with_edge_workers(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomWithEdgeWorkers", [value]))

    @jsii.member(jsii_name="putVisitorPrioritization")
    def put_visitor_prioritization(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization(
            allowed_user_cookie_advanced=allowed_user_cookie_advanced,
            allowed_user_cookie_automatic_salt=allowed_user_cookie_automatic_salt,
            allowed_user_cookie_domain=allowed_user_cookie_domain,
            allowed_user_cookie_domain_type=allowed_user_cookie_domain_type,
            allowed_user_cookie_duration=allowed_user_cookie_duration,
            allowed_user_cookie_enabled=allowed_user_cookie_enabled,
            allowed_user_cookie_http_only=allowed_user_cookie_http_only,
            allowed_user_cookie_label=allowed_user_cookie_label,
            allowed_user_cookie_management_title=allowed_user_cookie_management_title,
            allowed_user_cookie_refresh=allowed_user_cookie_refresh,
            allowed_user_cookie_salt=allowed_user_cookie_salt,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            user_identification_by_cookie=user_identification_by_cookie,
            user_identification_by_headers=user_identification_by_headers,
            user_identification_by_ip=user_identification_by_ip,
            user_identification_by_params=user_identification_by_params,
            user_identification_key_cookie=user_identification_key_cookie,
            user_identification_key_headers=user_identification_key_headers,
            user_identification_key_params=user_identification_key_params,
            user_identification_title=user_identification_title,
            uuid=uuid,
            waiting_room_cache_ttl=waiting_room_cache_ttl,
            waiting_room_cookie_advanced=waiting_room_cookie_advanced,
            waiting_room_cookie_automatic_salt=waiting_room_cookie_automatic_salt,
            waiting_room_cookie_domain=waiting_room_cookie_domain,
            waiting_room_cookie_domain_type=waiting_room_cookie_domain_type,
            waiting_room_cookie_duration=waiting_room_cookie_duration,
            waiting_room_cookie_enabled=waiting_room_cookie_enabled,
            waiting_room_cookie_http_only=waiting_room_cookie_http_only,
            waiting_room_cookie_label=waiting_room_cookie_label,
            waiting_room_cookie_management_title=waiting_room_cookie_management_title,
            waiting_room_cookie_salt=waiting_room_cookie_salt,
            waiting_room_cookie_share_label=waiting_room_cookie_share_label,
            waiting_room_cp_code=waiting_room_cp_code,
            waiting_room_directory=waiting_room_directory,
            waiting_room_management_title=waiting_room_management_title,
            waiting_room_net_storage=waiting_room_net_storage,
            waiting_room_status_code=waiting_room_status_code,
            waiting_room_use_cp_code=waiting_room_use_cp_code,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritization", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifo")
    def put_visitor_prioritization_fifo(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifo", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifoStandalone")
    def put_visitor_prioritization_fifo_standalone(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifoStandalone", [value]))

    @jsii.member(jsii_name="putWatermarking")
    def put_watermarking(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking(
            ab_variant_location=ab_variant_location,
            decryption_password1=decryption_password1,
            decryption_password2=decryption_password2,
            decryption_password_id1=decryption_password_id1,
            decryption_password_id2=decryption_password_id2,
            enable=enable,
            locked=locked,
            miscellaneous_settings_title=miscellaneous_settings_title,
            pattern_decryption_enable=pattern_decryption_enable,
            pattern_encryption_title=pattern_encryption_title,
            signature_verification_enable=signature_verification_enable,
            template_uuid=template_uuid,
            token_signing_title=token_signing_title,
            use_original_as_a=use_original_as_a,
            uuid=uuid,
            verification_key_id1=verification_key_id1,
            verification_key_id2=verification_key_id2,
            verification_public_key1=verification_public_key1,
            verification_public_key2=verification_public_key2,
        )

        return typing.cast(None, jsii.invoke(self, "putWatermarking", [value]))

    @jsii.member(jsii_name="putWebApplicationFirewall")
    def put_web_application_firewall(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall(
            firewall_configuration=firewall_configuration,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putWebApplicationFirewall", [value]))

    @jsii.member(jsii_name="putWebdav")
    def put_webdav(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebdav", [value]))

    @jsii.member(jsii_name="putWebSockets")
    def put_web_sockets(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebSockets", [value]))

    @jsii.member(jsii_name="resetAdaptiveAcceleration")
    def reset_adaptive_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveAcceleration", []))

    @jsii.member(jsii_name="resetAdaptiveImageCompression")
    def reset_adaptive_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveImageCompression", []))

    @jsii.member(jsii_name="resetAdScalerCircuitBreaker")
    def reset_ad_scaler_circuit_breaker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdScalerCircuitBreaker", []))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetAggregatedReporting")
    def reset_aggregated_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregatedReporting", []))

    @jsii.member(jsii_name="resetAkamaizer")
    def reset_akamaizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizer", []))

    @jsii.member(jsii_name="resetAkamaizerTag")
    def reset_akamaizer_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizerTag", []))

    @jsii.member(jsii_name="resetAllHttpInCacheHierarchy")
    def reset_all_http_in_cache_hierarchy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllHttpInCacheHierarchy", []))

    @jsii.member(jsii_name="resetAllowCloudletsOrigins")
    def reset_allow_cloudlets_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCloudletsOrigins", []))

    @jsii.member(jsii_name="resetAllowDelete")
    def reset_allow_delete(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowDelete", []))

    @jsii.member(jsii_name="resetAllowHttpsCacheKeySharing")
    def reset_allow_https_cache_key_sharing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsCacheKeySharing", []))

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowOptions")
    def reset_allow_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOptions", []))

    @jsii.member(jsii_name="resetAllowPatch")
    def reset_allow_patch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPatch", []))

    @jsii.member(jsii_name="resetAllowPost")
    def reset_allow_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPost", []))

    @jsii.member(jsii_name="resetAllowPut")
    def reset_allow_put(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPut", []))

    @jsii.member(jsii_name="resetAllowTransferEncoding")
    def reset_allow_transfer_encoding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowTransferEncoding", []))

    @jsii.member(jsii_name="resetAltSvcHeader")
    def reset_alt_svc_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAltSvcHeader", []))

    @jsii.member(jsii_name="resetApiPrioritization")
    def reset_api_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiPrioritization", []))

    @jsii.member(jsii_name="resetApplicationLoadBalancer")
    def reset_application_load_balancer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationLoadBalancer", []))

    @jsii.member(jsii_name="resetAudienceSegmentation")
    def reset_audience_segmentation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSegmentation", []))

    @jsii.member(jsii_name="resetAutoDomainValidation")
    def reset_auto_domain_validation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutoDomainValidation", []))

    @jsii.member(jsii_name="resetBaseDirectory")
    def reset_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBaseDirectory", []))

    @jsii.member(jsii_name="resetBossBeaconing")
    def reset_boss_beaconing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBossBeaconing", []))

    @jsii.member(jsii_name="resetBreadcrumbs")
    def reset_breadcrumbs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreadcrumbs", []))

    @jsii.member(jsii_name="resetBreakConnection")
    def reset_break_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreakConnection", []))

    @jsii.member(jsii_name="resetBrotli")
    def reset_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrotli", []))

    @jsii.member(jsii_name="resetCacheError")
    def reset_cache_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheError", []))

    @jsii.member(jsii_name="resetCacheId")
    def reset_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheId", []))

    @jsii.member(jsii_name="resetCacheKeyIgnoreCase")
    def reset_cache_key_ignore_case(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyIgnoreCase", []))

    @jsii.member(jsii_name="resetCacheKeyQueryParams")
    def reset_cache_key_query_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyQueryParams", []))

    @jsii.member(jsii_name="resetCacheKeyRewrite")
    def reset_cache_key_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyRewrite", []))

    @jsii.member(jsii_name="resetCachePost")
    def reset_cache_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachePost", []))

    @jsii.member(jsii_name="resetCacheRedirect")
    def reset_cache_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheRedirect", []))

    @jsii.member(jsii_name="resetCacheTag")
    def reset_cache_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTag", []))

    @jsii.member(jsii_name="resetCacheTagVisible")
    def reset_cache_tag_visible(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTagVisible", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetCentralAuthorization")
    def reset_central_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCentralAuthorization", []))

    @jsii.member(jsii_name="resetChaseRedirects")
    def reset_chase_redirects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaseRedirects", []))

    @jsii.member(jsii_name="resetClientCharacteristics")
    def reset_client_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCharacteristics", []))

    @jsii.member(jsii_name="resetCloudInterconnects")
    def reset_cloud_interconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudInterconnects", []))

    @jsii.member(jsii_name="resetCloudWrapper")
    def reset_cloud_wrapper(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapper", []))

    @jsii.member(jsii_name="resetCloudWrapperAdvanced")
    def reset_cloud_wrapper_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapperAdvanced", []))

    @jsii.member(jsii_name="resetConditionalOrigin")
    def reset_conditional_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalOrigin", []))

    @jsii.member(jsii_name="resetConstructResponse")
    def reset_construct_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConstructResponse", []))

    @jsii.member(jsii_name="resetContentCharacteristics")
    def reset_content_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristics", []))

    @jsii.member(jsii_name="resetContentCharacteristicsAmd")
    def reset_content_characteristics_amd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsAmd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsDd")
    def reset_content_characteristics_dd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsDd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLargeFile")
    def reset_content_characteristics_wsd_large_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLargeFile", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLive")
    def reset_content_characteristics_wsd_live(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLive", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdVod")
    def reset_content_characteristics_wsd_vod(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdVod", []))

    @jsii.member(jsii_name="resetContentPrePosition")
    def reset_content_pre_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPrePosition", []))

    @jsii.member(jsii_name="resetContentTargetingProtection")
    def reset_content_targeting_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentTargetingProtection", []))

    @jsii.member(jsii_name="resetCorsSupport")
    def reset_cors_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCorsSupport", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetCustomBehavior")
    def reset_custom_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomBehavior", []))

    @jsii.member(jsii_name="resetDatastream")
    def reset_datastream(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastream", []))

    @jsii.member(jsii_name="resetDcp")
    def reset_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcp", []))

    @jsii.member(jsii_name="resetDcpAuthHmacTransformation")
    def reset_dcp_auth_hmac_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthHmacTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthRegexTransformation")
    def reset_dcp_auth_regex_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthRegexTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthSubstringTransformation")
    def reset_dcp_auth_substring_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthSubstringTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthVariableExtractor")
    def reset_dcp_auth_variable_extractor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthVariableExtractor", []))

    @jsii.member(jsii_name="resetDcpDefaultAuthzGroups")
    def reset_dcp_default_authz_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDefaultAuthzGroups", []))

    @jsii.member(jsii_name="resetDcpDevRelations")
    def reset_dcp_dev_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDevRelations", []))

    @jsii.member(jsii_name="resetDcpRealTimeAuth")
    def reset_dcp_real_time_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpRealTimeAuth", []))

    @jsii.member(jsii_name="resetDeliveryReceipt")
    def reset_delivery_receipt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryReceipt", []))

    @jsii.member(jsii_name="resetDenyAccess")
    def reset_deny_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyAccess", []))

    @jsii.member(jsii_name="resetDenyDirectFailoverAccess")
    def reset_deny_direct_failover_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyDirectFailoverAccess", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicCacheId")
    def reset_device_characteristic_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicCacheId", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicHeader")
    def reset_device_characteristic_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicHeader", []))

    @jsii.member(jsii_name="resetDnsAsyncRefresh")
    def reset_dns_async_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsAsyncRefresh", []))

    @jsii.member(jsii_name="resetDnsPrefresh")
    def reset_dns_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsPrefresh", []))

    @jsii.member(jsii_name="resetDowngradeProtocol")
    def reset_downgrade_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDowngradeProtocol", []))

    @jsii.member(jsii_name="resetDownloadCompleteMarker")
    def reset_download_complete_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadCompleteMarker", []))

    @jsii.member(jsii_name="resetDownloadNotification")
    def reset_download_notification(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadNotification", []))

    @jsii.member(jsii_name="resetDownstreamCache")
    def reset_downstream_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownstreamCache", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimization")
    def reset_dynamic_throughtput_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimization", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimizationOverride")
    def reset_dynamic_throughtput_optimization_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimizationOverride", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEcmsBulkUpload")
    def reset_ecms_bulk_upload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsBulkUpload", []))

    @jsii.member(jsii_name="resetEcmsDatabase")
    def reset_ecms_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDatabase", []))

    @jsii.member(jsii_name="resetEcmsDataset")
    def reset_ecms_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDataset", []))

    @jsii.member(jsii_name="resetEcmsObjectKey")
    def reset_ecms_object_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsObjectKey", []))

    @jsii.member(jsii_name="resetEdgeConnect")
    def reset_edge_connect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeConnect", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingAdvanced")
    def reset_edge_load_balancing_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingAdvanced", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingDataCenter")
    def reset_edge_load_balancing_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingDataCenter", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingOrigin")
    def reset_edge_load_balancing_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingOrigin", []))

    @jsii.member(jsii_name="resetEdgeOriginAuthorization")
    def reset_edge_origin_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeOriginAuthorization", []))

    @jsii.member(jsii_name="resetEdgeRedirector")
    def reset_edge_redirector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeRedirector", []))

    @jsii.member(jsii_name="resetEdgeScape")
    def reset_edge_scape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeScape", []))

    @jsii.member(jsii_name="resetEdgeSideIncludes")
    def reset_edge_side_includes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeSideIncludes", []))

    @jsii.member(jsii_name="resetEdgeWorker")
    def reset_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorker", []))

    @jsii.member(jsii_name="resetEnhancedAkamaiProtocol")
    def reset_enhanced_akamai_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedAkamaiProtocol", []))

    @jsii.member(jsii_name="resetEnhancedProxyDetection")
    def reset_enhanced_proxy_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedProxyDetection", []))

    @jsii.member(jsii_name="resetEpdForwardHeaderEnrichment")
    def reset_epd_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEpdForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetFailAction")
    def reset_fail_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailAction", []))

    @jsii.member(jsii_name="resetFailoverBotManagerFeatureCompatibility")
    def reset_failover_bot_manager_feature_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverBotManagerFeatureCompatibility", []))

    @jsii.member(jsii_name="resetFastInvalidate")
    def reset_fast_invalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFastInvalidate", []))

    @jsii.member(jsii_name="resetFirstPartyMarketing")
    def reset_first_party_marketing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketing", []))

    @jsii.member(jsii_name="resetFirstPartyMarketingPlus")
    def reset_first_party_marketing_plus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketingPlus", []))

    @jsii.member(jsii_name="resetForwardRewrite")
    def reset_forward_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardRewrite", []))

    @jsii.member(jsii_name="resetFrontEndOptimization")
    def reset_front_end_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFrontEndOptimization", []))

    @jsii.member(jsii_name="resetG2Oheader")
    def reset_g2_oheader(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2Oheader", []))

    @jsii.member(jsii_name="resetGlobalRequestNumber")
    def reset_global_request_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalRequestNumber", []))

    @jsii.member(jsii_name="resetGraphqlCaching")
    def reset_graphql_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGraphqlCaching", []))

    @jsii.member(jsii_name="resetGzipResponse")
    def reset_gzip_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGzipResponse", []))

    @jsii.member(jsii_name="resetHdDataAdvanced")
    def reset_hd_data_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHdDataAdvanced", []))

    @jsii.member(jsii_name="resetHealthDetection")
    def reset_health_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHealthDetection", []))

    @jsii.member(jsii_name="resetHsafEipBinding")
    def reset_hsaf_eip_binding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsafEipBinding", []))

    @jsii.member(jsii_name="resetHttp2")
    def reset_http2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp2", []))

    @jsii.member(jsii_name="resetHttp3")
    def reset_http3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp3", []))

    @jsii.member(jsii_name="resetHttpStrictTransportSecurity")
    def reset_http_strict_transport_security(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpStrictTransportSecurity", []))

    @jsii.member(jsii_name="resetHttpToHttpsUpgrade")
    def reset_http_to_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpToHttpsUpgrade", []))

    @jsii.member(jsii_name="resetImageAndVideoManager")
    def reset_image_and_video_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageAndVideoManager", []))

    @jsii.member(jsii_name="resetImageManager")
    def reset_image_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManager", []))

    @jsii.member(jsii_name="resetImageManagerVideo")
    def reset_image_manager_video(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManagerVideo", []))

    @jsii.member(jsii_name="resetImOverride")
    def reset_im_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImOverride", []))

    @jsii.member(jsii_name="resetInclude")
    def reset_include(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInclude", []))

    @jsii.member(jsii_name="resetInputValidation")
    def reset_input_validation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInputValidation", []))

    @jsii.member(jsii_name="resetInstant")
    def reset_instant(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstant", []))

    @jsii.member(jsii_name="resetInstantConfig")
    def reset_instant_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstantConfig", []))

    @jsii.member(jsii_name="resetLargeFileOptimization")
    def reset_large_file_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimization", []))

    @jsii.member(jsii_name="resetLargeFileOptimizationAdvanced")
    def reset_large_file_optimization_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimizationAdvanced", []))

    @jsii.member(jsii_name="resetLimitBitRate")
    def reset_limit_bit_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitBitRate", []))

    @jsii.member(jsii_name="resetLogCustom")
    def reset_log_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustom", []))

    @jsii.member(jsii_name="resetManifestPersonalization")
    def reset_manifest_personalization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestPersonalization", []))

    @jsii.member(jsii_name="resetManifestRerouting")
    def reset_manifest_rerouting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestRerouting", []))

    @jsii.member(jsii_name="resetManualServerPush")
    def reset_manual_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManualServerPush", []))

    @jsii.member(jsii_name="resetMediaAcceleration")
    def reset_media_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAcceleration", []))

    @jsii.member(jsii_name="resetMediaAccelerationQuicOptout")
    def reset_media_acceleration_quic_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAccelerationQuicOptout", []))

    @jsii.member(jsii_name="resetMediaClient")
    def reset_media_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaClient", []))

    @jsii.member(jsii_name="resetMediaFileRetrievalOptimization")
    def reset_media_file_retrieval_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaFileRetrievalOptimization", []))

    @jsii.member(jsii_name="resetMediaOriginFailover")
    def reset_media_origin_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaOriginFailover", []))

    @jsii.member(jsii_name="resetMetadataCaching")
    def reset_metadata_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataCaching", []))

    @jsii.member(jsii_name="resetMobileSdkPerformance")
    def reset_mobile_sdk_performance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileSdkPerformance", []))

    @jsii.member(jsii_name="resetModifyIncomingRequestHeader")
    def reset_modify_incoming_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyIncomingResponseHeader")
    def reset_modify_incoming_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingRequestHeader")
    def reset_modify_outgoing_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingResponseHeader")
    def reset_modify_outgoing_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyViaHeader")
    def reset_modify_via_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyViaHeader", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetOriginCharacteristics")
    def reset_origin_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristics", []))

    @jsii.member(jsii_name="resetOriginCharacteristicsWsd")
    def reset_origin_characteristics_wsd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristicsWsd", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryMethod")
    def reset_origin_failure_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryMethod", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryPolicy")
    def reset_origin_failure_recovery_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryPolicy", []))

    @jsii.member(jsii_name="resetOriginIpAcl")
    def reset_origin_ip_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginIpAcl", []))

    @jsii.member(jsii_name="resetPersistentClientConnection")
    def reset_persistent_client_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentClientConnection", []))

    @jsii.member(jsii_name="resetPersistentConnection")
    def reset_persistent_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentConnection", []))

    @jsii.member(jsii_name="resetPersonallyIdentifiableInformation")
    def reset_personally_identifiable_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersonallyIdentifiableInformation", []))

    @jsii.member(jsii_name="resetPhasedRelease")
    def reset_phased_release(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPhasedRelease", []))

    @jsii.member(jsii_name="resetPreconnect")
    def reset_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnect", []))

    @jsii.member(jsii_name="resetPredictiveContentDelivery")
    def reset_predictive_content_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictiveContentDelivery", []))

    @jsii.member(jsii_name="resetPredictivePrefetching")
    def reset_predictive_prefetching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictivePrefetching", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetPrefetchable")
    def reset_prefetchable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchable", []))

    @jsii.member(jsii_name="resetPrefreshCache")
    def reset_prefresh_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshCache", []))

    @jsii.member(jsii_name="resetQuality")
    def reset_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuality", []))

    @jsii.member(jsii_name="resetQuicBeta")
    def reset_quic_beta(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicBeta", []))

    @jsii.member(jsii_name="resetRandomSeek")
    def reset_random_seek(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandomSeek", []))

    @jsii.member(jsii_name="resetRapid")
    def reset_rapid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRapid", []))

    @jsii.member(jsii_name="resetReadTimeout")
    def reset_read_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReadTimeout", []))

    @jsii.member(jsii_name="resetRealTimeReporting")
    def reset_real_time_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealTimeReporting", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectplus")
    def reset_redirectplus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectplus", []))

    @jsii.member(jsii_name="resetRefererChecking")
    def reset_referer_checking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefererChecking", []))

    @jsii.member(jsii_name="resetRemoveQueryParameter")
    def reset_remove_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveQueryParameter", []))

    @jsii.member(jsii_name="resetRemoveVary")
    def reset_remove_vary(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveVary", []))

    @jsii.member(jsii_name="resetReport")
    def reset_report(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReport", []))

    @jsii.member(jsii_name="resetRequestControl")
    def reset_request_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestControl", []))

    @jsii.member(jsii_name="resetRequestTypeMarker")
    def reset_request_type_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestTypeMarker", []))

    @jsii.member(jsii_name="resetResourceOptimizer")
    def reset_resource_optimizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizer", []))

    @jsii.member(jsii_name="resetResourceOptimizerExtendedCompatibility")
    def reset_resource_optimizer_extended_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizerExtendedCompatibility", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetResponseCookie")
    def reset_response_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCookie", []))

    @jsii.member(jsii_name="resetRestrictObjectCaching")
    def reset_restrict_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRestrictObjectCaching", []))

    @jsii.member(jsii_name="resetReturnCacheStatus")
    def reset_return_cache_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnCacheStatus", []))

    @jsii.member(jsii_name="resetRewriteUrl")
    def reset_rewrite_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRewriteUrl", []))

    @jsii.member(jsii_name="resetRumCustom")
    def reset_rum_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumCustom", []))

    @jsii.member(jsii_name="resetSaasDefinitions")
    def reset_saas_definitions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasDefinitions", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudClient")
    def reset_sales_force_commerce_cloud_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudClient", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProvider")
    def reset_sales_force_commerce_cloud_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProvider", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProviderHostHeader")
    def reset_sales_force_commerce_cloud_provider_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProviderHostHeader", []))

    @jsii.member(jsii_name="resetSavePostDcaProcessing")
    def reset_save_post_dca_processing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSavePostDcaProcessing", []))

    @jsii.member(jsii_name="resetScheduleInvalidation")
    def reset_schedule_invalidation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScheduleInvalidation", []))

    @jsii.member(jsii_name="resetScriptManagement")
    def reset_script_management(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScriptManagement", []))

    @jsii.member(jsii_name="resetSegmentedContentProtection")
    def reset_segmented_content_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedContentProtection", []))

    @jsii.member(jsii_name="resetSegmentedMediaOptimization")
    def reset_segmented_media_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaOptimization", []))

    @jsii.member(jsii_name="resetSegmentedMediaStreamingPrefetch")
    def reset_segmented_media_streaming_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaStreamingPrefetch", []))

    @jsii.member(jsii_name="resetSetVariable")
    def reset_set_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetVariable", []))

    @jsii.member(jsii_name="resetShutr")
    def reset_shutr(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShutr", []))

    @jsii.member(jsii_name="resetSimulateErrorCode")
    def reset_simulate_error_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSimulateErrorCode", []))

    @jsii.member(jsii_name="resetSiteShield")
    def reset_site_shield(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteShield", []))

    @jsii.member(jsii_name="resetStandardTlsMigration")
    def reset_standard_tls_migration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigration", []))

    @jsii.member(jsii_name="resetStandardTlsMigrationOverride")
    def reset_standard_tls_migration_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigrationOverride", []))

    @jsii.member(jsii_name="resetStrictHeaderParsing")
    def reset_strict_header_parsing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictHeaderParsing", []))

    @jsii.member(jsii_name="resetSubCustomer")
    def reset_sub_customer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubCustomer", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTcpOptimization")
    def reset_tcp_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTcpOptimization", []))

    @jsii.member(jsii_name="resetTeaLeaf")
    def reset_tea_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTeaLeaf", []))

    @jsii.member(jsii_name="resetTieredDistribution")
    def reset_tiered_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistribution", []))

    @jsii.member(jsii_name="resetTieredDistributionAdvanced")
    def reset_tiered_distribution_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionAdvanced", []))

    @jsii.member(jsii_name="resetTieredDistributionCustomization")
    def reset_tiered_distribution_customization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionCustomization", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUidConfiguration")
    def reset_uid_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUidConfiguration", []))

    @jsii.member(jsii_name="resetValidateEntityTag")
    def reset_validate_entity_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateEntityTag", []))

    @jsii.member(jsii_name="resetVerifyJsonWebToken")
    def reset_verify_json_web_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebToken", []))

    @jsii.member(jsii_name="resetVerifyJsonWebTokenForDcp")
    def reset_verify_json_web_token_for_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebTokenForDcp", []))

    @jsii.member(jsii_name="resetVerifyTokenAuthorization")
    def reset_verify_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyTokenAuthorization", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoom")
    def reset_virtual_waiting_room(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoom", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomWithEdgeWorkers")
    def reset_virtual_waiting_room_with_edge_workers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomWithEdgeWorkers", []))

    @jsii.member(jsii_name="resetVisitorPrioritization")
    def reset_visitor_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritization", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifo")
    def reset_visitor_prioritization_fifo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifo", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifoStandalone")
    def reset_visitor_prioritization_fifo_standalone(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifoStandalone", []))

    @jsii.member(jsii_name="resetWatermarking")
    def reset_watermarking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWatermarking", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @jsii.member(jsii_name="resetWebdav")
    def reset_webdav(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebdav", []))

    @jsii.member(jsii_name="resetWebSockets")
    def reset_web_sockets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebSockets", []))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAcceleration")
    def adaptive_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAccelerationOutputReference, jsii.get(self, "adaptiveAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompression")
    def adaptive_image_compression(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompressionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompressionOutputReference, jsii.get(self, "adaptiveImageCompression"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreaker")
    def ad_scaler_circuit_breaker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreakerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreakerOutputReference, jsii.get(self, "adScalerCircuitBreaker"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvancedOutputReference, jsii.get(self, "advanced"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReporting")
    def aggregated_reporting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReportingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReportingOutputReference, jsii.get(self, "aggregatedReporting"))

    @builtins.property
    @jsii.member(jsii_name="akamaizer")
    def akamaizer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerOutputReference, jsii.get(self, "akamaizer"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTag")
    def akamaizer_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTagOutputReference, jsii.get(self, "akamaizerTag"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchy")
    def all_http_in_cache_hierarchy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchyOutputReference, jsii.get(self, "allHttpInCacheHierarchy"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOrigins")
    def allow_cloudlets_origins(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOriginsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOriginsOutputReference, jsii.get(self, "allowCloudletsOrigins"))

    @builtins.property
    @jsii.member(jsii_name="allowDelete")
    def allow_delete(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDeleteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDeleteOutputReference, jsii.get(self, "allowDelete"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharing")
    def allow_https_cache_key_sharing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharingOutputReference, jsii.get(self, "allowHttpsCacheKeySharing"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngradeOutputReference, jsii.get(self, "allowHttpsDowngrade"))

    @builtins.property
    @jsii.member(jsii_name="allowOptions")
    def allow_options(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptionsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptionsOutputReference, jsii.get(self, "allowOptions"))

    @builtins.property
    @jsii.member(jsii_name="allowPatch")
    def allow_patch(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatchOutputReference, jsii.get(self, "allowPatch"))

    @builtins.property
    @jsii.member(jsii_name="allowPost")
    def allow_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPostOutputReference, jsii.get(self, "allowPost"))

    @builtins.property
    @jsii.member(jsii_name="allowPut")
    def allow_put(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPutOutputReference, jsii.get(self, "allowPut"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncoding")
    def allow_transfer_encoding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncodingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncodingOutputReference, jsii.get(self, "allowTransferEncoding"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeader")
    def alt_svc_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeaderOutputReference, jsii.get(self, "altSvcHeader"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritization")
    def api_prioritization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationOutputReference, jsii.get(self, "apiPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancer")
    def application_load_balancer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerOutputReference, jsii.get(self, "applicationLoadBalancer"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentation")
    def audience_segmentation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationOutputReference, jsii.get(self, "audienceSegmentation"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidation")
    def auto_domain_validation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidationOutputReference, jsii.get(self, "autoDomainValidation"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectory")
    def base_directory(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectoryOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectoryOutputReference, jsii.get(self, "baseDirectory"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconing")
    def boss_beaconing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconingOutputReference, jsii.get(self, "bossBeaconing"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbs")
    def breadcrumbs(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbsOutputReference, jsii.get(self, "breadcrumbs"))

    @builtins.property
    @jsii.member(jsii_name="breakConnection")
    def break_connection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnectionOutputReference, jsii.get(self, "breakConnection"))

    @builtins.property
    @jsii.member(jsii_name="brotli")
    def brotli(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotliOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotliOutputReference, jsii.get(self, "brotli"))

    @builtins.property
    @jsii.member(jsii_name="cacheError")
    def cache_error(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheErrorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheErrorOutputReference, jsii.get(self, "cacheError"))

    @builtins.property
    @jsii.member(jsii_name="cacheId")
    def cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheIdOutputReference, jsii.get(self, "cacheId"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCase")
    def cache_key_ignore_case(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCaseOutputReference, jsii.get(self, "cacheKeyIgnoreCase"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParams")
    def cache_key_query_params(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParamsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParamsOutputReference, jsii.get(self, "cacheKeyQueryParams"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewrite")
    def cache_key_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewriteOutputReference, jsii.get(self, "cacheKeyRewrite"))

    @builtins.property
    @jsii.member(jsii_name="cachePost")
    def cache_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePostOutputReference, jsii.get(self, "cachePost"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirect")
    def cache_redirect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirectOutputReference, jsii.get(self, "cacheRedirect"))

    @builtins.property
    @jsii.member(jsii_name="cacheTag")
    def cache_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagOutputReference, jsii.get(self, "cacheTag"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisible")
    def cache_tag_visible(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisibleOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisibleOutputReference, jsii.get(self, "cacheTagVisible"))

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachingOutputReference, jsii.get(self, "caching"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorization")
    def central_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorizationOutputReference, jsii.get(self, "centralAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirects")
    def chase_redirects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirectsOutputReference, jsii.get(self, "chaseRedirects"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristics")
    def client_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristicsOutputReference, jsii.get(self, "clientCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnects")
    def cloud_interconnects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnectsOutputReference, jsii.get(self, "cloudInterconnects"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapper")
    def cloud_wrapper(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperOutputReference, jsii.get(self, "cloudWrapper"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvanced")
    def cloud_wrapper_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvancedOutputReference, jsii.get(self, "cloudWrapperAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOrigin")
    def conditional_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOriginOutputReference, jsii.get(self, "conditionalOrigin"))

    @builtins.property
    @jsii.member(jsii_name="constructResponse")
    def construct_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponseOutputReference, jsii.get(self, "constructResponse"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristics")
    def content_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsOutputReference, jsii.get(self, "contentCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmd")
    def content_characteristics_amd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmdOutputReference, jsii.get(self, "contentCharacteristicsAmd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDd")
    def content_characteristics_dd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDdOutputReference, jsii.get(self, "contentCharacteristicsDd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFile")
    def content_characteristics_wsd_large_file(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFileOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFileOutputReference, jsii.get(self, "contentCharacteristicsWsdLargeFile"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLive")
    def content_characteristics_wsd_live(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLiveOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLiveOutputReference, jsii.get(self, "contentCharacteristicsWsdLive"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVod")
    def content_characteristics_wsd_vod(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVodOutputReference, jsii.get(self, "contentCharacteristicsWsdVod"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePosition")
    def content_pre_position(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePositionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePositionOutputReference, jsii.get(self, "contentPrePosition"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtection")
    def content_targeting_protection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtectionOutputReference, jsii.get(self, "contentTargetingProtection"))

    @builtins.property
    @jsii.member(jsii_name="corsSupport")
    def cors_support(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupportOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupportOutputReference, jsii.get(self, "corsSupport"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="customBehavior")
    def custom_behavior(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehaviorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehaviorOutputReference, jsii.get(self, "customBehavior"))

    @builtins.property
    @jsii.member(jsii_name="datastream")
    def datastream(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastreamOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastreamOutputReference, jsii.get(self, "datastream"))

    @builtins.property
    @jsii.member(jsii_name="dcp")
    def dcp(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpOutputReference, jsii.get(self, "dcp"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformation")
    def dcp_auth_hmac_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformationOutputReference, jsii.get(self, "dcpAuthHmacTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformation")
    def dcp_auth_regex_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformationOutputReference, jsii.get(self, "dcpAuthRegexTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformation")
    def dcp_auth_substring_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformationOutputReference, jsii.get(self, "dcpAuthSubstringTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractor")
    def dcp_auth_variable_extractor(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractorOutputReference, jsii.get(self, "dcpAuthVariableExtractor"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroups")
    def dcp_default_authz_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroupsOutputReference, jsii.get(self, "dcpDefaultAuthzGroups"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelations")
    def dcp_dev_relations(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelationsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelationsOutputReference, jsii.get(self, "dcpDevRelations"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuth")
    def dcp_real_time_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuthOutputReference, jsii.get(self, "dcpRealTimeAuth"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceipt")
    def delivery_receipt(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceiptOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceiptOutputReference, jsii.get(self, "deliveryReceipt"))

    @builtins.property
    @jsii.member(jsii_name="denyAccess")
    def deny_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccessOutputReference, jsii.get(self, "denyAccess"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccess")
    def deny_direct_failover_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccessOutputReference, jsii.get(self, "denyDirectFailoverAccess"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheId")
    def device_characteristic_cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheIdOutputReference, jsii.get(self, "deviceCharacteristicCacheId"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeader")
    def device_characteristic_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeaderOutputReference, jsii.get(self, "deviceCharacteristicHeader"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefresh")
    def dns_async_refresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefreshOutputReference, jsii.get(self, "dnsAsyncRefresh"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefresh")
    def dns_prefresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefreshOutputReference, jsii.get(self, "dnsPrefresh"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocol")
    def downgrade_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocolOutputReference, jsii.get(self, "downgradeProtocol"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarker")
    def download_complete_marker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarkerOutputReference, jsii.get(self, "downloadCompleteMarker"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotification")
    def download_notification(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotificationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotificationOutputReference, jsii.get(self, "downloadNotification"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCache")
    def downstream_cache(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCacheOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCacheOutputReference, jsii.get(self, "downstreamCache"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimization")
    def dynamic_throughtput_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOutputReference, jsii.get(self, "dynamicThroughtputOptimization"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverride")
    def dynamic_throughtput_optimization_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverrideOutputReference, jsii.get(self, "dynamicThroughtputOptimizationOverride"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContentOutputReference, jsii.get(self, "dynamicWebContent"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUpload")
    def ecms_bulk_upload(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUploadOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUploadOutputReference, jsii.get(self, "ecmsBulkUpload"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabase")
    def ecms_database(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabaseOutputReference, jsii.get(self, "ecmsDatabase"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDataset")
    def ecms_dataset(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatasetOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatasetOutputReference, jsii.get(self, "ecmsDataset"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKey")
    def ecms_object_key(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKeyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKeyOutputReference, jsii.get(self, "ecmsObjectKey"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnect")
    def edge_connect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnectOutputReference, jsii.get(self, "edgeConnect"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvanced")
    def edge_load_balancing_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvancedOutputReference, jsii.get(self, "edgeLoadBalancingAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenter")
    def edge_load_balancing_data_center(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterOutputReference, jsii.get(self, "edgeLoadBalancingDataCenter"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOrigin")
    def edge_load_balancing_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOriginOutputReference, jsii.get(self, "edgeLoadBalancingOrigin"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorization")
    def edge_origin_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorizationOutputReference, jsii.get(self, "edgeOriginAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirector")
    def edge_redirector(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorOutputReference, jsii.get(self, "edgeRedirector"))

    @builtins.property
    @jsii.member(jsii_name="edgeScape")
    def edge_scape(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScapeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScapeOutputReference, jsii.get(self, "edgeScape"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludes")
    def edge_side_includes(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludesOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludesOutputReference, jsii.get(self, "edgeSideIncludes"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorker")
    def edge_worker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorkerOutputReference, jsii.get(self, "edgeWorker"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocol")
    def enhanced_akamai_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocolOutputReference, jsii.get(self, "enhancedAkamaiProtocol"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetection")
    def enhanced_proxy_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetectionOutputReference, jsii.get(self, "enhancedProxyDetection"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichment")
    def epd_forward_header_enrichment(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichmentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichmentOutputReference, jsii.get(self, "epdForwardHeaderEnrichment"))

    @builtins.property
    @jsii.member(jsii_name="failAction")
    def fail_action(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionOutputReference, jsii.get(self, "failAction"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibility")
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibilityOutputReference, jsii.get(self, "failoverBotManagerFeatureCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidate")
    def fast_invalidate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidateOutputReference, jsii.get(self, "fastInvalidate"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketing")
    def first_party_marketing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingOutputReference, jsii.get(self, "firstPartyMarketing"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlus")
    def first_party_marketing_plus(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusOutputReference, jsii.get(self, "firstPartyMarketingPlus"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewrite")
    def forward_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteOutputReference, jsii.get(self, "forwardRewrite"))

    @builtins.property
    @jsii.member(jsii_name="frontEndOptimization")
    def front_end_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimizationOutputReference, jsii.get(self, "frontEndOptimization"))

    @builtins.property
    @jsii.member(jsii_name="g2Oheader")
    def g2_oheader(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2OheaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2OheaderOutputReference, jsii.get(self, "g2Oheader"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumber")
    def global_request_number(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumberOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumberOutputReference, jsii.get(self, "globalRequestNumber"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCaching")
    def graphql_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCachingOutputReference, jsii.get(self, "graphqlCaching"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponse")
    def gzip_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponseOutputReference, jsii.get(self, "gzipResponse"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvanced")
    def hd_data_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvancedOutputReference, jsii.get(self, "hdDataAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="healthDetection")
    def health_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetectionOutputReference, jsii.get(self, "healthDetection"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBinding")
    def hsaf_eip_binding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBindingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBindingOutputReference, jsii.get(self, "hsafEipBinding"))

    @builtins.property
    @jsii.member(jsii_name="http2")
    def http2(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2OutputReference, jsii.get(self, "http2"))

    @builtins.property
    @jsii.member(jsii_name="http3")
    def http3(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3OutputReference, jsii.get(self, "http3"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurity")
    def http_strict_transport_security(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurityOutputReference, jsii.get(self, "httpStrictTransportSecurity"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgrade")
    def http_to_https_upgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgradeOutputReference, jsii.get(self, "httpToHttpsUpgrade"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManager")
    def image_and_video_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerOutputReference, jsii.get(self, "imageAndVideoManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManager")
    def image_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerOutputReference, jsii.get(self, "imageManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideo")
    def image_manager_video(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoOutputReference, jsii.get(self, "imageManagerVideo"))

    @builtins.property
    @jsii.member(jsii_name="imOverride")
    def im_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverrideOutputReference, jsii.get(self, "imOverride"))

    @builtins.property
    @jsii.member(jsii_name="include")
    def include(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorIncludeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorIncludeOutputReference, jsii.get(self, "include"))

    @builtins.property
    @jsii.member(jsii_name="inputValidation")
    def input_validation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationOutputReference, jsii.get(self, "inputValidation"))

    @builtins.property
    @jsii.member(jsii_name="instant")
    def instant(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantOutputReference, jsii.get(self, "instant"))

    @builtins.property
    @jsii.member(jsii_name="instantConfig")
    def instant_config(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfigOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfigOutputReference, jsii.get(self, "instantConfig"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimization")
    def large_file_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationOutputReference, jsii.get(self, "largeFileOptimization"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvanced")
    def large_file_optimization_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvancedOutputReference, jsii.get(self, "largeFileOptimizationAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRate")
    def limit_bit_rate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateOutputReference, jsii.get(self, "limitBitRate"))

    @builtins.property
    @jsii.member(jsii_name="logCustom")
    def log_custom(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustomOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustomOutputReference, jsii.get(self, "logCustom"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalization")
    def manifest_personalization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalizationOutputReference, jsii.get(self, "manifestPersonalization"))

    @builtins.property
    @jsii.member(jsii_name="manifestRerouting")
    def manifest_rerouting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestReroutingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestReroutingOutputReference, jsii.get(self, "manifestRerouting"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPush")
    def manual_server_push(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPushOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPushOutputReference, jsii.get(self, "manualServerPush"))

    @builtins.property
    @jsii.member(jsii_name="mediaAcceleration")
    def media_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationOutputReference, jsii.get(self, "mediaAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptout")
    def media_acceleration_quic_optout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptoutOutputReference, jsii.get(self, "mediaAccelerationQuicOptout"))

    @builtins.property
    @jsii.member(jsii_name="mediaClient")
    def media_client(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClientOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClientOutputReference, jsii.get(self, "mediaClient"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimization")
    def media_file_retrieval_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimizationOutputReference, jsii.get(self, "mediaFileRetrievalOptimization"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailover")
    def media_origin_failover(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailoverOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailoverOutputReference, jsii.get(self, "mediaOriginFailover"))

    @builtins.property
    @jsii.member(jsii_name="metadataCaching")
    def metadata_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCachingOutputReference, jsii.get(self, "metadataCaching"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformance")
    def mobile_sdk_performance(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformanceOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformanceOutputReference, jsii.get(self, "mobileSdkPerformance"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeader")
    def modify_incoming_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeaderOutputReference, jsii.get(self, "modifyIncomingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeader")
    def modify_incoming_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeaderOutputReference, jsii.get(self, "modifyIncomingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeader")
    def modify_outgoing_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeaderOutputReference, jsii.get(self, "modifyOutgoingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeader")
    def modify_outgoing_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeaderOutputReference, jsii.get(self, "modifyOutgoingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeader")
    def modify_via_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeaderOutputReference, jsii.get(self, "modifyViaHeader"))

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulseOutputReference, jsii.get(self, "mPulse"))

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginOutputReference, jsii.get(self, "origin"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristics")
    def origin_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsOutputReference, jsii.get(self, "originCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsd")
    def origin_characteristics_wsd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsdOutputReference, jsii.get(self, "originCharacteristicsWsd"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethod")
    def origin_failure_recovery_method(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethodOutputReference, jsii.get(self, "originFailureRecoveryMethod"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicy")
    def origin_failure_recovery_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicyOutputReference, jsii.get(self, "originFailureRecoveryPolicy"))

    @builtins.property
    @jsii.member(jsii_name="originIpAcl")
    def origin_ip_acl(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAclOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAclOutputReference, jsii.get(self, "originIpAcl"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnection")
    def persistent_client_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnectionOutputReference", jsii.get(self, "persistentClientConnection"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnection")
    def persistent_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnectionOutputReference", jsii.get(self, "persistentConnection"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformation")
    def personally_identifiable_information(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformationOutputReference", jsii.get(self, "personallyIdentifiableInformation"))

    @builtins.property
    @jsii.member(jsii_name="phasedRelease")
    def phased_release(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseOutputReference", jsii.get(self, "phasedRelease"))

    @builtins.property
    @jsii.member(jsii_name="preconnect")
    def preconnect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnectOutputReference", jsii.get(self, "preconnect"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDelivery")
    def predictive_content_delivery(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDeliveryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDeliveryOutputReference", jsii.get(self, "predictiveContentDelivery"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetching")
    def predictive_prefetching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetchingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetchingOutputReference", jsii.get(self, "predictivePrefetching"))

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchOutputReference", jsii.get(self, "prefetch"))

    @builtins.property
    @jsii.member(jsii_name="prefetchable")
    def prefetchable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchableOutputReference", jsii.get(self, "prefetchable"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCache")
    def prefresh_cache(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCacheOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCacheOutputReference", jsii.get(self, "prefreshCache"))

    @builtins.property
    @jsii.member(jsii_name="quality")
    def quality(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQualityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQualityOutputReference", jsii.get(self, "quality"))

    @builtins.property
    @jsii.member(jsii_name="quicBeta")
    def quic_beta(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBetaOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBetaOutputReference", jsii.get(self, "quicBeta"))

    @builtins.property
    @jsii.member(jsii_name="randomSeek")
    def random_seek(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeekOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeekOutputReference", jsii.get(self, "randomSeek"))

    @builtins.property
    @jsii.member(jsii_name="rapid")
    def rapid(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapidOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapidOutputReference", jsii.get(self, "rapid"))

    @builtins.property
    @jsii.member(jsii_name="readTimeout")
    def read_timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeoutOutputReference", jsii.get(self, "readTimeout"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReporting")
    def real_time_reporting(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReportingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReportingOutputReference", jsii.get(self, "realTimeReporting"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoringOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoringOutputReference", jsii.get(self, "realUserMonitoring"))

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectOutputReference", jsii.get(self, "redirect"))

    @builtins.property
    @jsii.member(jsii_name="redirectplus")
    def redirectplus(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplusOutputReference", jsii.get(self, "redirectplus"))

    @builtins.property
    @jsii.member(jsii_name="refererChecking")
    def referer_checking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererCheckingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererCheckingOutputReference", jsii.get(self, "refererChecking"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameter")
    def remove_query_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameterOutputReference", jsii.get(self, "removeQueryParameter"))

    @builtins.property
    @jsii.member(jsii_name="removeVary")
    def remove_vary(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVaryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVaryOutputReference", jsii.get(self, "removeVary"))

    @builtins.property
    @jsii.member(jsii_name="report")
    def report(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReportOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReportOutputReference", jsii.get(self, "report"))

    @builtins.property
    @jsii.member(jsii_name="requestControl")
    def request_control(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlOutputReference", jsii.get(self, "requestControl"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarker")
    def request_type_marker(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarkerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarkerOutputReference", jsii.get(self, "requestTypeMarker"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizer")
    def resource_optimizer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerOutputReference", jsii.get(self, "resourceOptimizer"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibility")
    def resource_optimizer_extended_compatibility(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibilityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibilityOutputReference", jsii.get(self, "resourceOptimizerExtendedCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCodeOutputReference", jsii.get(self, "responseCode"))

    @builtins.property
    @jsii.member(jsii_name="responseCookie")
    def response_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookieOutputReference", jsii.get(self, "responseCookie"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCaching")
    def restrict_object_caching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCachingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCachingOutputReference", jsii.get(self, "restrictObjectCaching"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatus")
    def return_cache_status(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatusOutputReference", jsii.get(self, "returnCacheStatus"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrl")
    def rewrite_url(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrlOutputReference", jsii.get(self, "rewriteUrl"))

    @builtins.property
    @jsii.member(jsii_name="rumCustom")
    def rum_custom(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustomOutputReference", jsii.get(self, "rumCustom"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitions")
    def saas_definitions(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitionsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitionsOutputReference", jsii.get(self, "saasDefinitions"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClient")
    def sales_force_commerce_cloud_client(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClientOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClientOutputReference", jsii.get(self, "salesForceCommerceCloudClient"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProvider")
    def sales_force_commerce_cloud_provider(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderOutputReference", jsii.get(self, "salesForceCommerceCloudProvider"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeader")
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference", jsii.get(self, "salesForceCommerceCloudProviderHostHeader"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessing")
    def save_post_dca_processing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessingOutputReference", jsii.get(self, "savePostDcaProcessing"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidation")
    def schedule_invalidation(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidationOutputReference", jsii.get(self, "scheduleInvalidation"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagement")
    def script_management(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagementOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagementOutputReference", jsii.get(self, "scriptManagement"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtection")
    def segmented_content_protection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtectionOutputReference", jsii.get(self, "segmentedContentProtection"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimization")
    def segmented_media_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimizationOutputReference", jsii.get(self, "segmentedMediaOptimization"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetch")
    def segmented_media_streaming_prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetchOutputReference", jsii.get(self, "segmentedMediaStreamingPrefetch"))

    @builtins.property
    @jsii.member(jsii_name="setVariable")
    def set_variable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariableOutputReference", jsii.get(self, "setVariable"))

    @builtins.property
    @jsii.member(jsii_name="shutr")
    def shutr(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutrOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutrOutputReference", jsii.get(self, "shutr"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCode")
    def simulate_error_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCodeOutputReference", jsii.get(self, "simulateErrorCode"))

    @builtins.property
    @jsii.member(jsii_name="siteShield")
    def site_shield(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldOutputReference", jsii.get(self, "siteShield"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigration")
    def standard_tls_migration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOutputReference", jsii.get(self, "standardTlsMigration"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverride")
    def standard_tls_migration_override(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverrideOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverrideOutputReference", jsii.get(self, "standardTlsMigrationOverride"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsing")
    def strict_header_parsing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsingOutputReference", jsii.get(self, "strictHeaderParsing"))

    @builtins.property
    @jsii.member(jsii_name="subCustomer")
    def sub_customer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomerOutputReference", jsii.get(self, "subCustomer"))

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRouteOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRouteOutputReference", jsii.get(self, "sureRoute"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimization")
    def tcp_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimizationOutputReference", jsii.get(self, "tcpOptimization"))

    @builtins.property
    @jsii.member(jsii_name="teaLeaf")
    def tea_leaf(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeafOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeafOutputReference", jsii.get(self, "teaLeaf"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistribution")
    def tiered_distribution(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionOutputReference", jsii.get(self, "tieredDistribution"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvanced")
    def tiered_distribution_advanced(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvancedOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvancedOutputReference", jsii.get(self, "tieredDistributionAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomization")
    def tiered_distribution_customization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomizationOutputReference", jsii.get(self, "tieredDistributionCustomization"))

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeoutOutputReference", jsii.get(self, "timeout"))

    @builtins.property
    @jsii.member(jsii_name="uidConfiguration")
    def uid_configuration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfigurationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfigurationOutputReference", jsii.get(self, "uidConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTag")
    def validate_entity_tag(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTagOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTagOutputReference", jsii.get(self, "validateEntityTag"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebToken")
    def verify_json_web_token(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenOutputReference", jsii.get(self, "verifyJsonWebToken"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcp")
    def verify_json_web_token_for_dcp(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcpOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcpOutputReference", jsii.get(self, "verifyJsonWebTokenForDcp"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorization")
    def verify_token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorizationOutputReference", jsii.get(self, "verifyTokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoom")
    def virtual_waiting_room(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomOutputReference", jsii.get(self, "virtualWaitingRoom"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkers")
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference", jsii.get(self, "virtualWaitingRoomWithEdgeWorkers"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritization")
    def visitor_prioritization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationOutputReference", jsii.get(self, "visitorPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifo")
    def visitor_prioritization_fifo(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoOutputReference", jsii.get(self, "visitorPrioritizationFifo"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandalone")
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandaloneOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandaloneOutputReference", jsii.get(self, "visitorPrioritizationFifoStandalone"))

    @builtins.property
    @jsii.member(jsii_name="watermarking")
    def watermarking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarkingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarkingOutputReference", jsii.get(self, "watermarking"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallOutputReference", jsii.get(self, "webApplicationFirewall"))

    @builtins.property
    @jsii.member(jsii_name="webdav")
    def webdav(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdavOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdavOutputReference", jsii.get(self, "webdav"))

    @builtins.property
    @jsii.member(jsii_name="webSockets")
    def web_sockets(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSocketsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSocketsOutputReference", jsii.get(self, "webSockets"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAccelerationInput")
    def adaptive_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration], jsii.get(self, "adaptiveAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompressionInput")
    def adaptive_image_compression_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression], jsii.get(self, "adaptiveImageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreakerInput")
    def ad_scaler_circuit_breaker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker], jsii.get(self, "adScalerCircuitBreakerInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReportingInput")
    def aggregated_reporting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting], jsii.get(self, "aggregatedReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerInput")
    def akamaizer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer], jsii.get(self, "akamaizerInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTagInput")
    def akamaizer_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag], jsii.get(self, "akamaizerTagInput"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchyInput")
    def all_http_in_cache_hierarchy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy], jsii.get(self, "allHttpInCacheHierarchyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOriginsInput")
    def allow_cloudlets_origins_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins], jsii.get(self, "allowCloudletsOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowDeleteInput")
    def allow_delete_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete], jsii.get(self, "allowDeleteInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharingInput")
    def allow_https_cache_key_sharing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "allowHttpsCacheKeySharingInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOptionsInput")
    def allow_options_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions], jsii.get(self, "allowOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPatchInput")
    def allow_patch_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch], jsii.get(self, "allowPatchInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPostInput")
    def allow_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost], jsii.get(self, "allowPostInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPutInput")
    def allow_put_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut], jsii.get(self, "allowPutInput"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncodingInput")
    def allow_transfer_encoding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding], jsii.get(self, "allowTransferEncodingInput"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeaderInput")
    def alt_svc_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader], jsii.get(self, "altSvcHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritizationInput")
    def api_prioritization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization], jsii.get(self, "apiPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancerInput")
    def application_load_balancer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer], jsii.get(self, "applicationLoadBalancerInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentationInput")
    def audience_segmentation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation], jsii.get(self, "audienceSegmentationInput"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidationInput")
    def auto_domain_validation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation], jsii.get(self, "autoDomainValidationInput"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectoryInput")
    def base_directory_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory], jsii.get(self, "baseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconingInput")
    def boss_beaconing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing], jsii.get(self, "bossBeaconingInput"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbsInput")
    def breadcrumbs_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs], jsii.get(self, "breadcrumbsInput"))

    @builtins.property
    @jsii.member(jsii_name="breakConnectionInput")
    def break_connection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection], jsii.get(self, "breakConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="brotliInput")
    def brotli_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli], jsii.get(self, "brotliInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorInput")
    def cache_error_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError], jsii.get(self, "cacheErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheIdInput")
    def cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId], jsii.get(self, "cacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCaseInput")
    def cache_key_ignore_case_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase], jsii.get(self, "cacheKeyIgnoreCaseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParamsInput")
    def cache_key_query_params_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams], jsii.get(self, "cacheKeyQueryParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewriteInput")
    def cache_key_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite], jsii.get(self, "cacheKeyRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="cachePostInput")
    def cache_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost], jsii.get(self, "cachePostInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirectInput")
    def cache_redirect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect], jsii.get(self, "cacheRedirectInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagInput")
    def cache_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag], jsii.get(self, "cacheTagInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisibleInput")
    def cache_tag_visible_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible], jsii.get(self, "cacheTagVisibleInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorizationInput")
    def central_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization], jsii.get(self, "centralAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirectsInput")
    def chase_redirects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects], jsii.get(self, "chaseRedirectsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristicsInput")
    def client_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics], jsii.get(self, "clientCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnectsInput")
    def cloud_interconnects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects], jsii.get(self, "cloudInterconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvancedInput")
    def cloud_wrapper_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced], jsii.get(self, "cloudWrapperAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperInput")
    def cloud_wrapper_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper], jsii.get(self, "cloudWrapperInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOriginInput")
    def conditional_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin], jsii.get(self, "conditionalOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="constructResponseInput")
    def construct_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse], jsii.get(self, "constructResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmdInput")
    def content_characteristics_amd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd], jsii.get(self, "contentCharacteristicsAmdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDdInput")
    def content_characteristics_dd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd], jsii.get(self, "contentCharacteristicsDdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsInput")
    def content_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics], jsii.get(self, "contentCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFileInput")
    def content_characteristics_wsd_large_file_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "contentCharacteristicsWsdLargeFileInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLiveInput")
    def content_characteristics_wsd_live_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive], jsii.get(self, "contentCharacteristicsWsdLiveInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVodInput")
    def content_characteristics_wsd_vod_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod], jsii.get(self, "contentCharacteristicsWsdVodInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePositionInput")
    def content_pre_position_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition], jsii.get(self, "contentPrePositionInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtectionInput")
    def content_targeting_protection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection], jsii.get(self, "contentTargetingProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="corsSupportInput")
    def cors_support_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport], jsii.get(self, "corsSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="customBehaviorInput")
    def custom_behavior_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior], jsii.get(self, "customBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamInput")
    def datastream_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream], jsii.get(self, "datastreamInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformationInput")
    def dcp_auth_hmac_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation], jsii.get(self, "dcpAuthHmacTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformationInput")
    def dcp_auth_regex_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation], jsii.get(self, "dcpAuthRegexTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformationInput")
    def dcp_auth_substring_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation], jsii.get(self, "dcpAuthSubstringTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractorInput")
    def dcp_auth_variable_extractor_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor], jsii.get(self, "dcpAuthVariableExtractorInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroupsInput")
    def dcp_default_authz_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups], jsii.get(self, "dcpDefaultAuthzGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelationsInput")
    def dcp_dev_relations_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations], jsii.get(self, "dcpDevRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpInput")
    def dcp_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp], jsii.get(self, "dcpInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuthInput")
    def dcp_real_time_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth], jsii.get(self, "dcpRealTimeAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceiptInput")
    def delivery_receipt_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt], jsii.get(self, "deliveryReceiptInput"))

    @builtins.property
    @jsii.member(jsii_name="denyAccessInput")
    def deny_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess], jsii.get(self, "denyAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccessInput")
    def deny_direct_failover_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess], jsii.get(self, "denyDirectFailoverAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheIdInput")
    def device_characteristic_cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId], jsii.get(self, "deviceCharacteristicCacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeaderInput")
    def device_characteristic_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader], jsii.get(self, "deviceCharacteristicHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefreshInput")
    def dns_async_refresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh], jsii.get(self, "dnsAsyncRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefreshInput")
    def dns_prefresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh], jsii.get(self, "dnsPrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocolInput")
    def downgrade_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol], jsii.get(self, "downgradeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarkerInput")
    def download_complete_marker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker], jsii.get(self, "downloadCompleteMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotificationInput")
    def download_notification_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification], jsii.get(self, "downloadNotificationInput"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCacheInput")
    def downstream_cache_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache], jsii.get(self, "downstreamCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationInput")
    def dynamic_throughtput_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization], jsii.get(self, "dynamicThroughtputOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverrideInput")
    def dynamic_throughtput_optimization_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "dynamicThroughtputOptimizationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUploadInput")
    def ecms_bulk_upload_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload], jsii.get(self, "ecmsBulkUploadInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabaseInput")
    def ecms_database_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase], jsii.get(self, "ecmsDatabaseInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatasetInput")
    def ecms_dataset_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset], jsii.get(self, "ecmsDatasetInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKeyInput")
    def ecms_object_key_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey], jsii.get(self, "ecmsObjectKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnectInput")
    def edge_connect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect], jsii.get(self, "edgeConnectInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvancedInput")
    def edge_load_balancing_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "edgeLoadBalancingAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenterInput")
    def edge_load_balancing_data_center_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "edgeLoadBalancingDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOriginInput")
    def edge_load_balancing_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "edgeLoadBalancingOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorizationInput")
    def edge_origin_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization], jsii.get(self, "edgeOriginAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirectorInput")
    def edge_redirector_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector], jsii.get(self, "edgeRedirectorInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeScapeInput")
    def edge_scape_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape], jsii.get(self, "edgeScapeInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludesInput")
    def edge_side_includes_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes], jsii.get(self, "edgeSideIncludesInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerInput")
    def edge_worker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker], jsii.get(self, "edgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocolInput")
    def enhanced_akamai_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol], jsii.get(self, "enhancedAkamaiProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetectionInput")
    def enhanced_proxy_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection], jsii.get(self, "enhancedProxyDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichmentInput")
    def epd_forward_header_enrichment_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "epdForwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="failActionInput")
    def fail_action_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction], jsii.get(self, "failActionInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibilityInput")
    def failover_bot_manager_feature_compatibility_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "failoverBotManagerFeatureCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidateInput")
    def fast_invalidate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate], jsii.get(self, "fastInvalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingInput")
    def first_party_marketing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing], jsii.get(self, "firstPartyMarketingInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlusInput")
    def first_party_marketing_plus_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus], jsii.get(self, "firstPartyMarketingPlusInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewriteInput")
    def forward_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite], jsii.get(self, "forwardRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="frontEndOptimizationInput")
    def front_end_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization], jsii.get(self, "frontEndOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OheaderInput")
    def g2_oheader_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader], jsii.get(self, "g2OheaderInput"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumberInput")
    def global_request_number_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber], jsii.get(self, "globalRequestNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCachingInput")
    def graphql_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching], jsii.get(self, "graphqlCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponseInput")
    def gzip_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse], jsii.get(self, "gzipResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvancedInput")
    def hd_data_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced], jsii.get(self, "hdDataAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="healthDetectionInput")
    def health_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection], jsii.get(self, "healthDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBindingInput")
    def hsaf_eip_binding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding], jsii.get(self, "hsafEipBindingInput"))

    @builtins.property
    @jsii.member(jsii_name="http2Input")
    def http2_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2], jsii.get(self, "http2Input"))

    @builtins.property
    @jsii.member(jsii_name="http3Input")
    def http3_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3], jsii.get(self, "http3Input"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurityInput")
    def http_strict_transport_security_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity], jsii.get(self, "httpStrictTransportSecurityInput"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgradeInput")
    def http_to_https_upgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade], jsii.get(self, "httpToHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManagerInput")
    def image_and_video_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager], jsii.get(self, "imageAndVideoManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerInput")
    def image_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager], jsii.get(self, "imageManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideoInput")
    def image_manager_video_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo], jsii.get(self, "imageManagerVideoInput"))

    @builtins.property
    @jsii.member(jsii_name="imOverrideInput")
    def im_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride], jsii.get(self, "imOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="includeInput")
    def include_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude], jsii.get(self, "includeInput"))

    @builtins.property
    @jsii.member(jsii_name="inputValidationInput")
    def input_validation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation], jsii.get(self, "inputValidationInput"))

    @builtins.property
    @jsii.member(jsii_name="instantConfigInput")
    def instant_config_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig], jsii.get(self, "instantConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="instantInput")
    def instant_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant], jsii.get(self, "instantInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvancedInput")
    def large_file_optimization_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "largeFileOptimizationAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationInput")
    def large_file_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization], jsii.get(self, "largeFileOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRateInput")
    def limit_bit_rate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate], jsii.get(self, "limitBitRateInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomInput")
    def log_custom_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom], jsii.get(self, "logCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalizationInput")
    def manifest_personalization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization], jsii.get(self, "manifestPersonalizationInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestReroutingInput")
    def manifest_rerouting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting], jsii.get(self, "manifestReroutingInput"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPushInput")
    def manual_server_push_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush], jsii.get(self, "manualServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationInput")
    def media_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration], jsii.get(self, "mediaAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptoutInput")
    def media_acceleration_quic_optout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout], jsii.get(self, "mediaAccelerationQuicOptoutInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaClientInput")
    def media_client_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient], jsii.get(self, "mediaClientInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimizationInput")
    def media_file_retrieval_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization], jsii.get(self, "mediaFileRetrievalOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailoverInput")
    def media_origin_failover_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover], jsii.get(self, "mediaOriginFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataCachingInput")
    def metadata_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching], jsii.get(self, "metadataCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformanceInput")
    def mobile_sdk_performance_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance], jsii.get(self, "mobileSdkPerformanceInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeaderInput")
    def modify_incoming_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader], jsii.get(self, "modifyIncomingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeaderInput")
    def modify_incoming_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader], jsii.get(self, "modifyIncomingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeaderInput")
    def modify_outgoing_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader], jsii.get(self, "modifyOutgoingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeaderInput")
    def modify_outgoing_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader], jsii.get(self, "modifyOutgoingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeaderInput")
    def modify_via_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader], jsii.get(self, "modifyViaHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsInput")
    def origin_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics], jsii.get(self, "originCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsdInput")
    def origin_characteristics_wsd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd], jsii.get(self, "originCharacteristicsWsdInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethodInput")
    def origin_failure_recovery_method_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod], jsii.get(self, "originFailureRecoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicyInput")
    def origin_failure_recovery_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "originFailureRecoveryPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="originIpAclInput")
    def origin_ip_acl_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl], jsii.get(self, "originIpAclInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnectionInput")
    def persistent_client_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection"], jsii.get(self, "persistentClientConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnectionInput")
    def persistent_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection"], jsii.get(self, "persistentConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformationInput")
    def personally_identifiable_information_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation"], jsii.get(self, "personallyIdentifiableInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="phasedReleaseInput")
    def phased_release_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease"], jsii.get(self, "phasedReleaseInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectInput")
    def preconnect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect"], jsii.get(self, "preconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDeliveryInput")
    def predictive_content_delivery_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery"], jsii.get(self, "predictiveContentDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetchingInput")
    def predictive_prefetching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching"], jsii.get(self, "predictivePrefetchingInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchableInput")
    def prefetchable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable"], jsii.get(self, "prefetchableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch"], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCacheInput")
    def prefresh_cache_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache"], jsii.get(self, "prefreshCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="qualityInput")
    def quality_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality"], jsii.get(self, "qualityInput"))

    @builtins.property
    @jsii.member(jsii_name="quicBetaInput")
    def quic_beta_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta"], jsii.get(self, "quicBetaInput"))

    @builtins.property
    @jsii.member(jsii_name="randomSeekInput")
    def random_seek_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek"], jsii.get(self, "randomSeekInput"))

    @builtins.property
    @jsii.member(jsii_name="rapidInput")
    def rapid_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid"], jsii.get(self, "rapidInput"))

    @builtins.property
    @jsii.member(jsii_name="readTimeoutInput")
    def read_timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout"], jsii.get(self, "readTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReportingInput")
    def real_time_reporting_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting"], jsii.get(self, "realTimeReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring"], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect"], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectplusInput")
    def redirectplus_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus"], jsii.get(self, "redirectplusInput"))

    @builtins.property
    @jsii.member(jsii_name="refererCheckingInput")
    def referer_checking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking"], jsii.get(self, "refererCheckingInput"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameterInput")
    def remove_query_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter"], jsii.get(self, "removeQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="removeVaryInput")
    def remove_vary_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary"], jsii.get(self, "removeVaryInput"))

    @builtins.property
    @jsii.member(jsii_name="reportInput")
    def report_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport"], jsii.get(self, "reportInput"))

    @builtins.property
    @jsii.member(jsii_name="requestControlInput")
    def request_control_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl"], jsii.get(self, "requestControlInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarkerInput")
    def request_type_marker_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker"], jsii.get(self, "requestTypeMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibilityInput")
    def resource_optimizer_extended_compatibility_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility"], jsii.get(self, "resourceOptimizerExtendedCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerInput")
    def resource_optimizer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer"], jsii.get(self, "resourceOptimizerInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode"], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCookieInput")
    def response_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie"], jsii.get(self, "responseCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCachingInput")
    def restrict_object_caching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching"], jsii.get(self, "restrictObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatusInput")
    def return_cache_status_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus"], jsii.get(self, "returnCacheStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrlInput")
    def rewrite_url_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl"], jsii.get(self, "rewriteUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="rumCustomInput")
    def rum_custom_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom"], jsii.get(self, "rumCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitionsInput")
    def saas_definitions_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions"], jsii.get(self, "saasDefinitionsInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClientInput")
    def sales_force_commerce_cloud_client_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient"], jsii.get(self, "salesForceCommerceCloudClientInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeaderInput")
    def sales_force_commerce_cloud_provider_host_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader"], jsii.get(self, "salesForceCommerceCloudProviderHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderInput")
    def sales_force_commerce_cloud_provider_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider"], jsii.get(self, "salesForceCommerceCloudProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessingInput")
    def save_post_dca_processing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing"], jsii.get(self, "savePostDcaProcessingInput"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidationInput")
    def schedule_invalidation_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation"], jsii.get(self, "scheduleInvalidationInput"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagementInput")
    def script_management_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement"], jsii.get(self, "scriptManagementInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtectionInput")
    def segmented_content_protection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection"], jsii.get(self, "segmentedContentProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimizationInput")
    def segmented_media_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization"], jsii.get(self, "segmentedMediaOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetchInput")
    def segmented_media_streaming_prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch"], jsii.get(self, "segmentedMediaStreamingPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="setVariableInput")
    def set_variable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable"], jsii.get(self, "setVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="shutrInput")
    def shutr_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr"], jsii.get(self, "shutrInput"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCodeInput")
    def simulate_error_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode"], jsii.get(self, "simulateErrorCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="siteShieldInput")
    def site_shield_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield"], jsii.get(self, "siteShieldInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationInput")
    def standard_tls_migration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration"], jsii.get(self, "standardTlsMigrationInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverrideInput")
    def standard_tls_migration_override_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride"], jsii.get(self, "standardTlsMigrationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsingInput")
    def strict_header_parsing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing"], jsii.get(self, "strictHeaderParsingInput"))

    @builtins.property
    @jsii.member(jsii_name="subCustomerInput")
    def sub_customer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer"], jsii.get(self, "subCustomerInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute"], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimizationInput")
    def tcp_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization"], jsii.get(self, "tcpOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="teaLeafInput")
    def tea_leaf_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf"], jsii.get(self, "teaLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvancedInput")
    def tiered_distribution_advanced_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced"], jsii.get(self, "tieredDistributionAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomizationInput")
    def tiered_distribution_customization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization"], jsii.get(self, "tieredDistributionCustomizationInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionInput")
    def tiered_distribution_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution"], jsii.get(self, "tieredDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout"], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uidConfigurationInput")
    def uid_configuration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration"], jsii.get(self, "uidConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTagInput")
    def validate_entity_tag_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag"], jsii.get(self, "validateEntityTagInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcpInput")
    def verify_json_web_token_for_dcp_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp"], jsii.get(self, "verifyJsonWebTokenForDcpInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenInput")
    def verify_json_web_token_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken"], jsii.get(self, "verifyJsonWebTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorizationInput")
    def verify_token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization"], jsii.get(self, "verifyTokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomInput")
    def virtual_waiting_room_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom"], jsii.get(self, "virtualWaitingRoomInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkersInput")
    def virtual_waiting_room_with_edge_workers_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers"], jsii.get(self, "virtualWaitingRoomWithEdgeWorkersInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoInput")
    def visitor_prioritization_fifo_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo"], jsii.get(self, "visitorPrioritizationFifoInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandaloneInput")
    def visitor_prioritization_fifo_standalone_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone"], jsii.get(self, "visitorPrioritizationFifoStandaloneInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationInput")
    def visitor_prioritization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization"], jsii.get(self, "visitorPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="watermarkingInput")
    def watermarking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking"], jsii.get(self, "watermarkingInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall"], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="webdavInput")
    def webdav_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav"], jsii.get(self, "webdavInput"))

    @builtins.property
    @jsii.member(jsii_name="webSocketsInput")
    def web_sockets_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets"], jsii.get(self, "webSocketsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887189596fcac20226764e2d208f01be3ce283c6e3d14b5b815491649795f5c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8752c0c9c1917cc5c7b2af1c9d863c2edf5196ea177a6e31cdd609c128cc24d7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the persistent connections behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141de19b0493a3eb015f081a2a63aef41849c75060d7b39a74288494ed026d54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22000876e4dd144809c96f4f9ce4e6a2910dc8e92306a23636e139b9da3fe8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f728d6f246d50ed2f7ace9a7734c62f88812f552622c528954a3ad63c1fe36f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba4f6d3c6c99ff33b14922128389fecaf4775021da68729ac81f11b548cca013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc2465c6a0fd151638277fdacd787e0f4c42a32c418beece0f72e616ec024da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745737bc285d9ac53fd00d7df5c98b2307b682245853c9b79052cf28fa1203fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098aed5a455485238005d8c43420ad0515d9861b4e4b35d04867c44e9f82e93a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94c90303c98e356968a31d3d2d5ccfa48fb0dff400d0fc695753708d806734bb)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables persistent connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes a persistent connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__240af7623a2e9a4023c89462363d0528615999f2ad251c63be6a09d39d7395bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e656fa7e205c9c357ec9742ecf6db439144d0c0d8a90e771f756ae975ea3780a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c223dd95b0e42620f4459f6dc117ebeb3ff1b94799d47bde54366b1f9cb97a5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0416354e30161288a88e91fae62a1ac24671ad3c7a627ba4931015e053867110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6e671d140615b5a6981e95478efad64a7b9d77db64049b55878a12f68467dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df8506bf3ffd55f12dbb00024a21c5077536ce4eb6e6d3cf48672c70f90e8fbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3668d1f5c9c8c89914664d9b6024c7c6f38e80c586825cea5a29ee337459dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09dd97699e07493b7bfbcb8900614b65977af0108636a850380c81a70f2d263e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, marks content as personally identifiable information (PII).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b26fb68f8708e609533ee218fa8279aca2e33a2a9b4baefc211a6db6b2482bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e62de73a9229d1eae4feddcb3d83202618f8cbfd26893176354cbc93dba610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8e1e3186aaa54e25c5e12571dca3910311ab8f108e1f88371ab3eeac93880e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ad3ffaa6266fa29f219c0f14c894eedc323e736ba4a2ba3e49d0f0d07cf30e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87dfc9cae8f9b8afe83a4efea9e2056f05152374df4b746eae3a04768e323b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07269d2689c51f89b6781891ccab11b93c3298d98bfeba0d77c857873583762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "failover_duration": "failoverDuration",
        "failover_enabled": "failoverEnabled",
        "failover_response_code": "failoverResponseCode",
        "failover_title": "failoverTitle",
        "label": "label",
        "locked": "locked",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_expiration_date": "populationExpirationDate",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8366396c5a36511cdfdd66f63cd62190a2bdb7b3440f302c652b83e966bf9fb)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_duration", value=failover_duration, expected_type=type_hints["failover_duration"])
            check_type(argname="argument failover_enabled", value=failover_enabled, expected_type=type_hints["failover_enabled"])
            check_type(argname="argument failover_response_code", value=failover_response_code, expected_type=type_hints["failover_response_code"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_expiration_date", value=population_expiration_date, expected_type=type_hints["population_expiration_date"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_duration is not None:
            self._values["failover_duration"] = failover_duration
        if failover_enabled is not None:
            self._values["failover_enabled"] = failover_enabled
        if failover_response_code is not None:
            self._values["failover_response_code"] = failover_response_code
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_expiration_date is not None:
            self._values["population_expiration_date"] = population_expiration_date
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Phased Release Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected.

        Set the value to ``0`` to immediately request the alternate origin upon failure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        '''
        result = self._values.get("failover_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        '''
        result = self._values.get("failover_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_response_code(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the set of failure codes that initiate the failover response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        '''
        result = self._values.get("failover_response_code")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Phased Release policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Select when to assign a cookie to the population of users the Cloudlet defines.

        If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies the date and time when membership expires, and the browser no longer sends the cookie.

        Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        '''
        result = self._values.get("population_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76033ada4b6beea0faed613f737605f137db13ff9281cf637d6dfafb7d1d45a3)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a230fa47ee08d7560e1c8082c92423429aaeed2940d05fa8ed4c81efc10618d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__751a5522e514401c0a85d18f1bfb56044f9bac998e2727b2475b500c4282d283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc1ea8f803a49b5c4a33fec5cd458193d1d082a02d1e3085e763df49364f8a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d90dfad1af08952bc153f82a636f62d01d5085d1098f3d63afd68fb969f09e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2ec2202be52c9b9d2f81b0d7d156b46d5d0e1b611a3b49615995e8d2dc354a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverDuration")
    def reset_failover_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverDuration", []))

    @jsii.member(jsii_name="resetFailoverEnabled")
    def reset_failover_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverEnabled", []))

    @jsii.member(jsii_name="resetFailoverResponseCode")
    def reset_failover_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverResponseCode", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationExpirationDate")
    def reset_population_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationExpirationDate", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverDurationInput")
    def failover_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverEnabledInput")
    def failover_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failoverEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCodeInput")
    def failover_response_code_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDateInput")
    def population_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d5773560720834012ac4a6387ae31cbaae8eaa82ef177586cab63ee598a07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverDuration")
    def failover_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverDuration"))

    @failover_duration.setter
    def failover_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67984dfc6eba16cacc002a219f0bd41e0dd10e1ecc5eed2995ed7a7901662677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverDuration", value)

    @builtins.property
    @jsii.member(jsii_name="failoverEnabled")
    def failover_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failoverEnabled"))

    @failover_enabled.setter
    def failover_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d783485ea9a0f69b469e3ad4692ad0500a0093ece4e2124c3c48258bf87dd55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCode")
    def failover_response_code(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverResponseCode"))

    @failover_response_code.setter
    def failover_response_code(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24793f3e005514d5f69437438523027a92eb6aef111a781bd04fd73fde97fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b197603e4f8fea865c2fe11e6636d03c0c9b7043f4598a7f85fd2a3cbdd3d95d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83057f3e5e85903a29e1f01e97d31ee2f933fb79ffc3ffe735b98dc28247d4f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77f6faf7f88170615e73a00fcfc408258259f52ff56a5156286414038f397de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69de4b652545053e86406cfc3f9819b39ee008acc89efd87693f3e08af0a3b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a3087887959bfd502d9938d657c6324ba452111e553b6b6ee514a8d0845ec11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDate")
    def population_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationExpirationDate"))

    @population_expiration_date.setter
    def population_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13e41a237e90c6c09f87aa6cd2914de4e009fb34e83f63b7b3d3fa1110c5fcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65dbd1bfdcf30d7efebdafeb49881d79d9de6e86264359340a732606ddea387f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef17d0b1539ea9dd1fef36b7d37187cd10800bdfe7a570924eb8aa60406fd6db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458a49a55875503b1cb20204eff6184c55ac4df8cfc94b6edd722f5e4a87e8ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aafe02e25029fec6871390d17375932c3cdadd97c6247fe8fcee1ef1b31f23e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c4165cae0fdf939e16c22ffce007bd63f9625eea4404c52555407af00e26b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "preconnectlist": "preconnectlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a910e555c2edc4ef3b731ecd049e6f2444c9467517afd2b430e31a1ab9cb307)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preconnectlist", value=preconnectlist, expected_type=type_hints["preconnectlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if preconnectlist is not None:
            self._values["preconnectlist"] = preconnectlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preconnectlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of hostnames to which to preconnect over HTTP2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        '''
        result = self._values.get("preconnectlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c594967b8c7d7cc477ce9eb298f554e5234c75ce21fda66d6e72829b620b43e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreconnectlist")
    def reset_preconnectlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnectlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectlistInput")
    def preconnectlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "preconnectlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f36399e4154afa951be458ac0bfd4e8c2b84260c1ae83adba0fc1e4ba1df22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preconnectlist")
    def preconnectlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "preconnectlist"))

    @preconnectlist.setter
    def preconnectlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc53e13b9fb689010a0fa9cc1fb1fc09bb115a8d3330f59dd53b4fbd820de90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preconnectlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382eb38b98352c3f46c3018473cf7c5b7cee3ab6bf555c6366acc3904e67eb85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ec7449f371d5da27356cd41a7ef851fd218f4d8a25e12c0a072b302ffa81c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2455d023461b64328cd39db037de600c7efb8e658db6998d0527029305d84fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__787cf44caebe40a1f35e60f3c44885710c43ac05477c4f9bccde2f9548e7127c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive content delivery behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDeliveryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDeliveryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b1089775c1079eb7fa8a19c3beb5bf8f6f2d0c0e545c6a76549c227c8245b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef206e5effffe5fb9a0862ccebf2d9c5b4a00de7c718dcd1dd387240b36f1bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c153d8da17193986e7b5f9a51b2ec22cf36946c216ac1d69a24cad4eef38eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40b1a1fd2d6483fbaac322b84bae984cb0e10b7201c90064913fcbfa5acb6757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__827674f189babcb9c0a6038b9a870c41c23c009b850714586dfd2b1bc7d87778)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223b615e9749a76b051c49ae1e90868ba49e1656bfada1efe495ed9bcf0136a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching",
    jsii_struct_bases=[],
    name_mapping={
        "accuracy_target": "accuracyTarget",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching:
    def __init__(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83531ce95d8c631ca40be2d16b7c7920ccc58af6d1153c0ff4b6ad3e0a4530c)
            check_type(argname="argument accuracy_target", value=accuracy_target, expected_type=type_hints["accuracy_target"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accuracy_target is not None:
            self._values["accuracy_target"] = accuracy_target
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accuracy_target(self) -> typing.Optional[builtins.str]:
        '''The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        '''
        result = self._values.get("accuracy_target")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive prefetching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetchingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetchingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6dabd131a343f9816263118b0d068160ed48e6954052f441e31701fd5c1bd09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccuracyTarget")
    def reset_accuracy_target(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccuracyTarget", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accuracyTargetInput")
    def accuracy_target_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accuracyTargetInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accuracyTarget")
    def accuracy_target(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accuracyTarget"))

    @accuracy_target.setter
    def accuracy_target(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ce7a641801a0152d05f0fef3e6fcf2f96c2cc6cf1a2c023b773d5c92cc3793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accuracyTarget", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe0a70f21a6e55cac9befda3f3c8c79d5dfbeac07da3d302aeeda97fd629a5d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f1424c4c23f2e81720409ac738b6c455c9cb82d001ee55000b0e9167644a56a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb57076300f43e4046bdc629ca9ffececd3402b06212b8d3d592d54d8b01ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887aa861c5a678dd503d2188845efba4593078af0fc5aa889d904065d54e964d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8567ce292cc728c03e103ecb66a986b6193bec845017b03bfccba785aefd6a0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c26e706d28f3a308b5296019052697360a2fd7fe8ebaa5b15b0bde78a08cd046)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies prefetching behavior when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b0ec3d8fb1124837853926530fd873146a3380a839dd1e615a6258a3e38af91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3d59ba350b313eb609374710bf6acd675e592fa085fe2f431421f8ba8511ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__995ade311b68e577b4afd294c8f182343ad2c80e4b816cf22ba4391b775e8633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77275132daa683c2315a603cd730ed9df4c769dea3f5ae03bf258c20c4163104)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f557e5ccac2ff78c605bfdc4e6dd311991e59d0d0dd329aae5bea6a105671973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5f9dc0dc0a2a11f47d8a1dab30ae8be7b805e8937740bcfd24743a204c43c20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b4106a0ed5b197ffdc592d808d7800efd7e0ba79f7fe1ed403306ce78340e7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows matching content to prefetch when referenced on a requested parent page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b984956f61fbf0ff04d50d93ee8701b28e29689c4101bb0b5851665d7aa87621)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53996785c518f84951c90d3d0580791f36fc13e98aafd30226fae5dfe54da22f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd00af88a9d9d82e442241a75fd62bf4616907428e47785aa516ddf7606ca4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__847b5238bf4fe3e80e1b50828e45d8b7de21f0e95169f1c4b4e217c1bab7d6f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7566fb6402880942222c8475f0b0fec285e4be2f2158b08184d8a29087f719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea494d9e0d4c5fcc3bb0410af4c9ecf926e4959ccd345bd0900137070bd0664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "prefreshval": "prefreshval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d60540e82813ee3eb3b55319f91ed4049dc0405707caa2bff68e3926186c282c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefreshval", value=prefreshval, expected_type=type_hints["prefreshval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if prefreshval is not None:
            self._values["prefreshval"] = prefreshval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cache prefreshing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefreshval(self) -> typing.Optional[jsii.Number]:
        '''Specifies when the prefresh occurs as a percentage of the TTL.

        For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        '''
        result = self._values.get("prefreshval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f92c5464b64a0e3c466bbc912d1bbc641ddf0598d753ed4dd230c26e2074977)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefreshval")
    def reset_prefreshval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshvalInput")
    def prefreshval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefreshvalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb73a04a8b049d890332a7bc48684671a91c739a84fbd43b27315fd02670386f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27fdec305bbe0235e2c86a6a7c973b843ffbac5667bb989ffabc428552b272f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefreshval")
    def prefreshval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefreshval"))

    @prefreshval.setter
    def prefreshval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f49a2acfad0b7a18b6ce5787b25dde4f4428818ad30be3971cdb93cedcbef16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefreshval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2b3703d751fde07b50bdb0f035c15ecb7e1b54e8fed7eca66b4aaa7a58b8ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55f28c4c343a82e0d0fb993df2277ceb17c7a7a07428eaeca32599f4989c77e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a20994d859b74cc33f772a757f6b48325a38fa4022e9c0cf2bee3f0ee7b5f771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality",
    jsii_struct_bases=[],
    name_mapping={
        "audience_settings": "audienceSettings",
        "catalog_size": "catalogSize",
        "content_settings": "contentSettings",
        "content_type": "contentType",
        "country": "country",
        "delivery_format": "deliveryFormat",
        "delivery_type": "deliveryType",
        "download_type": "downloadType",
        "end_user_location": "endUserLocation",
        "locked": "locked",
        "maximum_concurrent_users": "maximumConcurrentUsers",
        "object_size": "objectSize",
        "optimize_for": "optimizeFor",
        "origin_settings": "originSettings",
        "popularity_distribution": "popularityDistribution",
        "refresh_rate": "refreshRate",
        "segment_duration": "segmentDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality:
    def __init__(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c0d89a5bc6cbcd9bf8e1fba06b0d8f6c8609c61f6a36c9842bf216d418b6b6)
            check_type(argname="argument audience_settings", value=audience_settings, expected_type=type_hints["audience_settings"])
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_settings", value=content_settings, expected_type=type_hints["content_settings"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument delivery_format", value=delivery_format, expected_type=type_hints["delivery_format"])
            check_type(argname="argument delivery_type", value=delivery_type, expected_type=type_hints["delivery_type"])
            check_type(argname="argument download_type", value=download_type, expected_type=type_hints["download_type"])
            check_type(argname="argument end_user_location", value=end_user_location, expected_type=type_hints["end_user_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_concurrent_users", value=maximum_concurrent_users, expected_type=type_hints["maximum_concurrent_users"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_for", value=optimize_for, expected_type=type_hints["optimize_for"])
            check_type(argname="argument origin_settings", value=origin_settings, expected_type=type_hints["origin_settings"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument refresh_rate", value=refresh_rate, expected_type=type_hints["refresh_rate"])
            check_type(argname="argument segment_duration", value=segment_duration, expected_type=type_hints["segment_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if audience_settings is not None:
            self._values["audience_settings"] = audience_settings
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_settings is not None:
            self._values["content_settings"] = content_settings
        if content_type is not None:
            self._values["content_type"] = content_type
        if country is not None:
            self._values["country"] = country
        if delivery_format is not None:
            self._values["delivery_format"] = delivery_format
        if delivery_type is not None:
            self._values["delivery_type"] = delivery_type
        if download_type is not None:
            self._values["download_type"] = download_type
        if end_user_location is not None:
            self._values["end_user_location"] = end_user_location
        if locked is not None:
            self._values["locked"] = locked
        if maximum_concurrent_users is not None:
            self._values["maximum_concurrent_users"] = maximum_concurrent_users
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_for is not None:
            self._values["optimize_for"] = optimize_for
        if origin_settings is not None:
            self._values["origin_settings"] = origin_settings
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if refresh_rate is not None:
            self._values["refresh_rate"] = refresh_rate
        if segment_duration is not None:
            self._values["segment_duration"] = segment_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def audience_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        '''
        result = self._values.get("audience_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.'''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        '''
        result = self._values.get("content_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.'''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.'''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.'''
        result = self._values.get("delivery_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.'''
        result = self._values.get("delivery_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def download_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.'''
        result = self._values.get("download_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_user_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.'''
        result = self._values.get("end_user_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_concurrent_users(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.'''
        result = self._values.get("maximum_concurrent_users")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.'''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_for(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.'''
        result = self._values.get("optimize_for")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        '''
        result = self._values.get("origin_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.'''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def refresh_rate(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.'''
        result = self._values.get("refresh_rate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.'''
        result = self._values.get("segment_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQualityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQualityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8f5234ba959f006e91750442e4e8da3243347374f055663054749eb9bf5fa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAudienceSettings")
    def reset_audience_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSettings", []))

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentSettings")
    def reset_content_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentSettings", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetDeliveryFormat")
    def reset_delivery_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryFormat", []))

    @jsii.member(jsii_name="resetDeliveryType")
    def reset_delivery_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryType", []))

    @jsii.member(jsii_name="resetDownloadType")
    def reset_download_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadType", []))

    @jsii.member(jsii_name="resetEndUserLocation")
    def reset_end_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndUserLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumConcurrentUsers")
    def reset_maximum_concurrent_users(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumConcurrentUsers", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeFor")
    def reset_optimize_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeFor", []))

    @jsii.member(jsii_name="resetOriginSettings")
    def reset_origin_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSettings", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetRefreshRate")
    def reset_refresh_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshRate", []))

    @jsii.member(jsii_name="resetSegmentDuration")
    def reset_segment_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="audienceSettingsInput")
    def audience_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "audienceSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentSettingsInput")
    def content_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryFormatInput")
    def delivery_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryTypeInput")
    def delivery_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadTypeInput")
    def download_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="endUserLocationInput")
    def end_user_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endUserLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsersInput")
    def maximum_concurrent_users_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumConcurrentUsersInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeForInput")
    def optimize_for_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optimizeForInput"))

    @builtins.property
    @jsii.member(jsii_name="originSettingsInput")
    def origin_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshRateInput")
    def refresh_rate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshRateInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationInput")
    def segment_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSettings")
    def audience_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "audienceSettings"))

    @audience_settings.setter
    def audience_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18aa5293457b6bdca79cfc8a24247d455a669018c1f7b431a263e0098c8ed434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "audienceSettings", value)

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c4e8b5b250f71b139696add817bdf07e04eb87e16400b03c327b15e48929f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentSettings")
    def content_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentSettings"))

    @content_settings.setter
    def content_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceb9b5d88179789774af3b0bf5503868ddd456b7c3cd2961f9e8ac4a7d20b22e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentSettings", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf656a4e5f1b1505b197bbebf9ced16e4f09542175f4ceb6d307b74e3ce2c64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618023f3eb6714d14c8d28bb76998be769ec3101a958cf8545b1f44ca519dc19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryFormat")
    def delivery_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryFormat"))

    @delivery_format.setter
    def delivery_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6ead7594b233bbaa29c1165eb46d8a615059b991be3fa5126aabe33150c6ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryFormat", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryType")
    def delivery_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryType"))

    @delivery_type.setter
    def delivery_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3027dc905aaacffd6ac498fb2476f953ecf7998828af90f31324555709c935f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryType", value)

    @builtins.property
    @jsii.member(jsii_name="downloadType")
    def download_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadType"))

    @download_type.setter
    def download_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715d19d7c7775a15248c22d8e2945a8803a67a36794c912a638b94e45972a38b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadType", value)

    @builtins.property
    @jsii.member(jsii_name="endUserLocation")
    def end_user_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endUserLocation"))

    @end_user_location.setter
    def end_user_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a86e0c7929fc50ae2bcde0686bd1ec73283e44d6c0ac3053cdda7a114fa7d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endUserLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810173cd374a0a227ec5dab921025db4ac873e96e74d149ee52bfcee57cd06e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsers")
    def maximum_concurrent_users(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumConcurrentUsers"))

    @maximum_concurrent_users.setter
    def maximum_concurrent_users(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6328e18161b317e9c7993f02b6fcb9cfe2289151a5abc281c4e7e6dbe31991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumConcurrentUsers", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef84accde9aee9a3628fb82a82bdb27d648fa9b805946e9ca91ccb35d8253be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeFor")
    def optimize_for(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optimizeFor"))

    @optimize_for.setter
    def optimize_for(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34cb8548669183eb2a7e3ec296946e84bb84a26fc9c7c19ed8ffd82c14ef7f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeFor", value)

    @builtins.property
    @jsii.member(jsii_name="originSettings")
    def origin_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originSettings"))

    @origin_settings.setter
    def origin_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a1a1b84eb74ac2c77eed0602e06fdd2afb5c4fbf97035d2674a8bc88c46f61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSettings", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b059072d612302b5721da60c0bc1f3a267a42bef95bfcd1c41879414fee5bda5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="refreshRate")
    def refresh_rate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshRate"))

    @refresh_rate.setter
    def refresh_rate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3106819ffde142f91f45c43d65b5da5b06a0a3931e09b971a52c312b721608ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshRate", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDuration")
    def segment_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDuration"))

    @segment_duration.setter
    def segment_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f04fc585fe20ba319e27b3626fec9185a85e83d00667d45b8df69a4b45c2c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7de2f3f2d0794bee9a4ed1f61f2a3ab8b96ddc9f5cb073a5bd89eb5a0d0a45cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0eeed91a976aeaa88a387b3a08253feab9fa0394601673487e7be218361793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c29e8d0ed1804ec71dd1643587eb5733d8772747c62ffbd5d71c46467aa8c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "quic_offer_percentage": "quicOfferPercentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc635a1406f0364c4302db21fbf544532a731a96dff6d8c4c010db180fb20122)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument quic_offer_percentage", value=quic_offer_percentage, expected_type=type_hints["quic_offer_percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if quic_offer_percentage is not None:
            self._values["quic_offer_percentage"] = quic_offer_percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables QUIC support.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def quic_offer_percentage(self) -> typing.Optional[jsii.Number]:
        '''The percentage of responses for which to allow QUIC sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        '''
        result = self._values.get("quic_offer_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBetaOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBetaOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b5204f2e85786d199bd47f63895d9e5dd116ec33526f2c97d0c5d4fb6cc59dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQuicOfferPercentage")
    def reset_quic_offer_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicOfferPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentageInput")
    def quic_offer_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "quicOfferPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef501724a108690bee72d9b5daa5780f8fad6e3d254586d5397f6dd7e4a33aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89da648d7b29c739da9099ab9ce74867049a7298a2e90688a6fc9dbe9579e8f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentage")
    def quic_offer_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "quicOfferPercentage"))

    @quic_offer_percentage.setter
    def quic_offer_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6b0d235d01aa8797b308106dc73b212a92c0f0d4fe333d28a43de4951545fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "quicOfferPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f04901c775d06fae6d24028e80b796fb1f0b0e845336ce779845a3f7f672db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da93acd9e8f1211b92935cec1f083a9440ba8a7d41a7105355161477c18277af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007c80b4220f28bf4ea6781eb9d2fdf62e2924d877b4c1ad9fd65f3ff7d215aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek",
    jsii_struct_bases=[],
    name_mapping={
        "flv": "flv",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "mp4": "mp4",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek:
    def __init__(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbeda34ec1431fa1f5d19da89afcc32764a7f15c314983d365d3db1a1d513c73)
            check_type(argname="argument flv", value=flv, expected_type=type_hints["flv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument mp4", value=mp4, expected_type=type_hints["mp4"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if flv is not None:
            self._values["flv"] = flv
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if mp4 is not None:
            self._values["mp4"] = mp4
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def flv(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in FLV files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        '''
        result = self._values.get("flv")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mp4(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in MP4 files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        '''
        result = self._values.get("mp4")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeekOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeekOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e59310dcb1228b5c1750b995dbd399e5ce66404bddb4cd7303a1a339e9aa9d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFlv")
    def reset_flv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFlv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMp4")
    def reset_mp4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMp4", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="flvInput")
    def flv_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "flvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="mp4Input")
    def mp4_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mp4Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="flv")
    def flv(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "flv"))

    @flv.setter
    def flv(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d393d75fee1f507a76acb8b0e7351ed12340bf61bbe7995d391d07032bc8fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "flv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11643ff660db2f09952342d76ea5fac3b6f4d2e70c921b8cdbd97a5b87eb149d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b31bacca9d3e1bf156041f5a8f84fca2a037b9aa89b5a8b5b89f8063dfe5a0f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="mp4")
    def mp4(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mp4"))

    @mp4.setter
    def mp4(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71349c3552311b5b8dedef698fae7d4a8c2d00fff8f40cbee759b291cc1894f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mp4", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ce9a1305744388d40e1139cebd00dd67f9c6886fe499292f0e050babf009ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__168dc3934d411e56535e778ffbf94da903c400e4aeb413962c30823181c138f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe92d277838df22db24a87e2211adf7d19ce84ef4ef0ae1a54a2e82b4ecab8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e969154d3047308a11fd613487eeb50e9ad7c68e909d9beb0e66f5d6a8a6933c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables API Gateway for the current set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapidOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapidOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fc5b66cc2f8ca7a56a3000ae9a473626c56112af90014b8e16f83f131c290cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91549ab4029f3793f6f5764a1290b56acd07d87d9aa7dd86ae4c258b227599a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d387f8e80993049a76ce2c13b779bc356cb396e6d4467079562209140475c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02cd828308a46dadad7a10ca9a223373302f48862353db65a5ee64b712aa5e8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98af1b8123a5f9eb0a33549d95ccca60cf3b023ec3000bfe77b1ed425754c207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0726f14a420c7f351647ca5cc28d27fca249765eef60570ddc64c3a8316fe2d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d51f6279bc7a236d2325917eecd7232c713e4c6113813d9c6f6d1f64fbd3e4)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab2798d168a2a7f3b2e89a3692a2ff4cdd227c935290fa7d7ceaae3209790e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fd73cae18e01263e76db2cd2bd680917d61052c9da9da56e539cca8e148319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c085fb86a0d73c2c6cc0c8145d0637c9617f6cf4dbd1d86d7e1262858691c7e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4dcc208ddf307d4e82583a8aa2802847ce843d01a5bd6da33ee4858df935702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75370188ff4fd67b520891732c24c66c02a2da9325e2518c852364561167810e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02f72ce52417e63a10ad78a318a8b575800f43426c901c1b4009871426e42fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "beacon_sampling_percentage": "beaconSamplingPercentage",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04fbc9f29b4f258ad30fe47524ceecc00708aa7358e09601aad9582dc9681eaa)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument beacon_sampling_percentage", value=beacon_sampling_percentage, expected_type=type_hints["beacon_sampling_percentage"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if beacon_sampling_percentage is not None:
            self._values["beacon_sampling_percentage"] = beacon_sampling_percentage
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables advanced options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def beacon_sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage for sampling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        '''
        result = self._values.get("beacon_sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables reports on delivery of cloud hosted content at near real-time latencies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c996899b696f9d103b859443aa272af2c5879949e5543b657093d3730865e0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetBeaconSamplingPercentage")
    def reset_beacon_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconSamplingPercentage", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentageInput")
    def beacon_sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "beaconSamplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__401a8a8b075f915b1cba538d52115c73cd06acba82c9a5b6a0e607ea80b91bad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentage")
    def beacon_sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "beaconSamplingPercentage"))

    @beacon_sampling_percentage.setter
    def beacon_sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6826bb4f8d01459f074ebb64c9bb69daee8f7b9a63dc29b2337383b681b43f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconSamplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d59740c6320bd6e30bf7783a6cbc4d60386828e388eadd1667fa7c9524d766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c82c966249f998382f06b862c20632e1b25c6a84ab12eb0fdf22a0ed7502c470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac61787581f7a8ea18c6736f2a6dc95a5fd25532819857bb22cf7dde205e4c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9580aff9dab2b930989fd919d9adfa4e5e04424e77d123d9a06eb62e7f6e0de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34beab76a157a59d2578a9c382d4b4134bf6121a9988be964f23427fae28b95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a13714fbead53b520838f62aa648ced4218573fa93be3b212f4324020d35f80)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates real-use monitoring.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoringOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoringOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d40beef78f893ef4cf67322c274a2390ac9a207f27944e632239ab7d5ec371a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d02afd0d8c7dedf594f93e3ff93dc30125dfe1b64666d3df102ed2209e9f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51fd8904df3bf7ecab86626727093819c0d4521e2544a7cb330968f25d03e25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8803c1e7b685768bc0557e88759a87709538192f1ea14208d27896f12e14317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da45b4de9f8c844610a91be10a16ba41aa3405652cfca9778f711da6643b588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9700e7534ab2f3959bb11b366bdfaed7879948102a8789fc14269aec0ba58459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "destination_hostname": "destinationHostname",
        "destination_hostname_other": "destinationHostnameOther",
        "destination_hostname_sibling": "destinationHostnameSibling",
        "destination_hostname_subdomain": "destinationHostnameSubdomain",
        "destination_path": "destinationPath",
        "destination_path_other": "destinationPathOther",
        "destination_path_prefix": "destinationPathPrefix",
        "destination_path_suffix": "destinationPathSuffix",
        "destination_path_suffix_status": "destinationPathSuffixStatus",
        "destination_protocol": "destinationProtocol",
        "locked": "locked",
        "mobile_default_choice": "mobileDefaultChoice",
        "query_string": "queryString",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect:
    def __init__(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4eb128097e7c82bac732a199323a18ed97d5cb4777683e13151b91b0f87d113)
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_hostname_other", value=destination_hostname_other, expected_type=type_hints["destination_hostname_other"])
            check_type(argname="argument destination_hostname_sibling", value=destination_hostname_sibling, expected_type=type_hints["destination_hostname_sibling"])
            check_type(argname="argument destination_hostname_subdomain", value=destination_hostname_subdomain, expected_type=type_hints["destination_hostname_subdomain"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument destination_path_other", value=destination_path_other, expected_type=type_hints["destination_path_other"])
            check_type(argname="argument destination_path_prefix", value=destination_path_prefix, expected_type=type_hints["destination_path_prefix"])
            check_type(argname="argument destination_path_suffix", value=destination_path_suffix, expected_type=type_hints["destination_path_suffix"])
            check_type(argname="argument destination_path_suffix_status", value=destination_path_suffix_status, expected_type=type_hints["destination_path_suffix_status"])
            check_type(argname="argument destination_protocol", value=destination_protocol, expected_type=type_hints["destination_protocol"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mobile_default_choice", value=mobile_default_choice, expected_type=type_hints["mobile_default_choice"])
            check_type(argname="argument query_string", value=query_string, expected_type=type_hints["query_string"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_hostname_other is not None:
            self._values["destination_hostname_other"] = destination_hostname_other
        if destination_hostname_sibling is not None:
            self._values["destination_hostname_sibling"] = destination_hostname_sibling
        if destination_hostname_subdomain is not None:
            self._values["destination_hostname_subdomain"] = destination_hostname_subdomain
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if destination_path_other is not None:
            self._values["destination_path_other"] = destination_path_other
        if destination_path_prefix is not None:
            self._values["destination_path_prefix"] = destination_path_prefix
        if destination_path_suffix is not None:
            self._values["destination_path_suffix"] = destination_path_suffix
        if destination_path_suffix_status is not None:
            self._values["destination_path_suffix_status"] = destination_path_suffix_status
        if destination_protocol is not None:
            self._values["destination_protocol"] = destination_protocol
        if locked is not None:
            self._values["locked"] = locked
        if mobile_default_choice is not None:
            self._values["mobile_default_choice"] = mobile_default_choice
        if query_string is not None:
            self._values["query_string"] = query_string
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested hostname, independently from the pathname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_other(self) -> typing.Optional[builtins.str]:
        '''Specifies the full hostname with which to replace the current hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        '''
        result = self._values.get("destination_hostname_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_sibling(self) -> typing.Optional[builtins.str]:
        '''Specifies the subdomain with which to replace to the current hostname's leftmost subdomain.

        For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        '''
        result = self._values.get("destination_hostname_sibling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_subdomain(self) -> typing.Optional[builtins.str]:
        '''Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        '''
        result = self._values.get("destination_hostname_subdomain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested pathname, independently from the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_other(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        '''
        result = self._values.get("destination_path_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_prefix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path.

        For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        '''
        result = self._values.get("destination_path_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        '''
        result = self._values.get("destination_path_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix_status(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        '''
        result = self._values.get("destination_path_suffix_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_protocol(self) -> typing.Optional[builtins.str]:
        '''Choose the protocol for the redirect URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        '''
        result = self._values.get("destination_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mobile_default_choice(self) -> typing.Optional[builtins.str]:
        '''Either specify a default response for mobile browsers, or customize your own.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        '''
        result = self._values.get("mobile_default_choice")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_string(self) -> typing.Optional[builtins.str]:
        '''When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL.

        Otherwise set this to ``IGNORE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        '''
        result = self._values.get("query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Specify the redirect's response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a09935e39a04ea91051c5f94fa11d9f912ec48eb9280d8ad3aa00f290009a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationHostnameOther")
    def reset_destination_hostname_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameOther", []))

    @jsii.member(jsii_name="resetDestinationHostnameSibling")
    def reset_destination_hostname_sibling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSibling", []))

    @jsii.member(jsii_name="resetDestinationHostnameSubdomain")
    def reset_destination_hostname_subdomain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSubdomain", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetDestinationPathOther")
    def reset_destination_path_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathOther", []))

    @jsii.member(jsii_name="resetDestinationPathPrefix")
    def reset_destination_path_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathPrefix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffix")
    def reset_destination_path_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffixStatus")
    def reset_destination_path_suffix_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffixStatus", []))

    @jsii.member(jsii_name="resetDestinationProtocol")
    def reset_destination_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationProtocol", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMobileDefaultChoice")
    def reset_mobile_default_choice(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileDefaultChoice", []))

    @jsii.member(jsii_name="resetQueryString")
    def reset_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryString", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOtherInput")
    def destination_hostname_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSiblingInput")
    def destination_hostname_sibling_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSiblingInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomainInput")
    def destination_hostname_subdomain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSubdomainInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathOtherInput")
    def destination_path_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefixInput")
    def destination_path_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixInput")
    def destination_path_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatusInput")
    def destination_path_suffix_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationProtocolInput")
    def destination_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoiceInput")
    def mobile_default_choice_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mobileDefaultChoiceInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringInput")
    def query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b26089505638eff944af73516908de2285452442118da785f1f0b85495244be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOther")
    def destination_hostname_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameOther"))

    @destination_hostname_other.setter
    def destination_hostname_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bd9b69c31f69c53b721edc40b55673dca21751dffe698cac20d5f973a65c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSibling")
    def destination_hostname_sibling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSibling"))

    @destination_hostname_sibling.setter
    def destination_hostname_sibling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6fe0fed8a75946e487a3a53b23334730bcbf45efbe6c476ccfb59bfc138ee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSibling", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomain")
    def destination_hostname_subdomain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSubdomain"))

    @destination_hostname_subdomain.setter
    def destination_hostname_subdomain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6160ceed1a2d7117b7dbc068843048b9decf74ce4ad17bd9a1073d2b0ec07190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSubdomain", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18897908ea7f5f1f714bf4e3c8f5a09663670a52811334df0cdb783ce6681590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathOther")
    def destination_path_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathOther"))

    @destination_path_other.setter
    def destination_path_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__477d7fff5e8b2485f33daf3ea33c116c6da2c89090a7228295c9a242696283ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefix")
    def destination_path_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathPrefix"))

    @destination_path_prefix.setter
    def destination_path_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74065e70270de089fa93b633f3aa9a7ccee2c61e79a3708ac320e1dc876beae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffix")
    def destination_path_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffix"))

    @destination_path_suffix.setter
    def destination_path_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf300b15de8f4345ceafedf73e08eb08fc21d758a28b41a18d6fde29f1698ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatus")
    def destination_path_suffix_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffixStatus"))

    @destination_path_suffix_status.setter
    def destination_path_suffix_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64464767c864fb26be4f25e97d44db7ee1bad5dd9e842c8ea94ae1753c203a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffixStatus", value)

    @builtins.property
    @jsii.member(jsii_name="destinationProtocol")
    def destination_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationProtocol"))

    @destination_protocol.setter
    def destination_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554ac06ca33686ff8887bb7e3cb091a89d932524ca1d1f41d4dedf219d69c0f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365fdee4611756b5a64b7c8ffce486e9fec68f5472b302c770ec68d237e40120)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoice")
    def mobile_default_choice(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mobileDefaultChoice"))

    @mobile_default_choice.setter
    def mobile_default_choice(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda861bc24d70ac30927890b6af2a66d7540a11c46112ad990c00376adf488fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mobileDefaultChoice", value)

    @builtins.property
    @jsii.member(jsii_name="queryString")
    def query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryString"))

    @query_string.setter
    def query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4f329d7d875154004097b3fa4c1537f217249cc66ef591d40c3816c2afb7d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryString", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be39d2a1d5037abc5c123f56cd3ded3c06dbf7d4acfcab80d34ac9043d6518d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db7d3708e61fa1954f750a132398d476fe82da3ae4f6a3f21aa2ff8e8c5444e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbd197cf5d5e0ac24b90dfd975fbb60fee97b3044f959a89e78e83cb99c4ce68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ace8f05f4f6cdaf7183aa7035d628c24bbd85d0d74e0e596693188712262672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus",
    jsii_struct_bases=[],
    name_mapping={
        "destination": "destination",
        "enabled": "enabled",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus:
    def __init__(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22b261b9ec77fd3faaaae9693de98e93135f432e3079538b42eb0bfbe7a2e84a)
            check_type(argname="argument destination", value=destination, expected_type=type_hints["destination"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination is not None:
            self._values["destination"] = destination
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL.

        Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        '''
        result = self._values.get("destination")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the redirect feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns the status code for the redirect response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__315582ac9e976bacc64979a1bb5e987d4bcd2f4a4fd84f6e0eb3f6f5e977de2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestination")
    def reset_destination(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestination", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationInput")
    def destination_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destination")
    def destination(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destination"))

    @destination.setter
    def destination(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6d4a7f03887005814610ee55ca19c3c359d083b0073cc7ad4fcebaa08a4aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destination", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9336ded81a99828684c1bc4c2dba4cbfb377abbbe5de9c701b603b98ff74336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7be2b46ea2269218278cd711e1d5e890123c1f2482ee9926d568c16d54e69da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524c521cd7de4b63cfa5ce3982285f469b8c96c75bf88556a42c8c5428413b8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3d2d63e037ba787c3892f6aa98ffdb6365bffdd78c6f453007910fff88cdc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb7ba3f2a01f9d94bf16d42722bb13bb7e5ffac1be6ca6f8e9b2c1124ae0e3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba1ce383623124aa3763b8e5879da5ab8828b3b675f2a2a37d161b0a899ac1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking",
    jsii_struct_bases=[],
    name_mapping={
        "allow_children": "allowChildren",
        "domains": "domains",
        "enabled": "enabled",
        "locked": "locked",
        "strict": "strict",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking:
    def __init__(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b1f11bc7ff53cb72d8aa6c35b99eced2e00000423eadd55cc95b8340c4174a)
            check_type(argname="argument allow_children", value=allow_children, expected_type=type_hints["allow_children"])
            check_type(argname="argument domains", value=domains, expected_type=type_hints["domains"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict", value=strict, expected_type=type_hints["strict"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_children is not None:
            self._values["allow_children"] = allow_children
        if domains is not None:
            self._values["domains"] = domains
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if strict is not None:
            self._values["strict"] = strict
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_children(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        '''
        result = self._values.get("allow_children")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of allowed domains.

        With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        '''
        result = self._values.get("domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the referer-checking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``.

        When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        '''
        result = self._values.get("strict")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererCheckingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererCheckingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de65b9848906699176434d4cd669f330ce24957b1a08716ebb15961dbf258065)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowChildren")
    def reset_allow_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowChildren", []))

    @jsii.member(jsii_name="resetDomains")
    def reset_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomains", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrict")
    def reset_strict(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrict", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowChildrenInput")
    def allow_children_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowChildrenInput"))

    @builtins.property
    @jsii.member(jsii_name="domainsInput")
    def domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "domainsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictInput")
    def strict_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowChildren")
    def allow_children(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowChildren"))

    @allow_children.setter
    def allow_children(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bdd5833c3b700b829813185da9d4e50a1b0b394f2992f02dd05f8870208c810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowChildren", value)

    @builtins.property
    @jsii.member(jsii_name="domains")
    def domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "domains"))

    @domains.setter
    def domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8d6cd1a47e0781f78ecb8bbab7bc887486b1140e7652a86b27ad18aff9f2d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domains", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efce4d2dd987b93c7785419f44b0eb3851dfd84daca75799f5a19ec93b329a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f5da71d7d711ced9c1ec627310af5baf24035db5035b9964e2aaae2943b9e5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strict")
    def strict(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strict"))

    @strict.setter
    def strict(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3167528cbe9e2aa0b15da5fe72f1343e69dbfb8931806952f05ef2247ae826d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strict", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f856ad6311b2641ae72f5875c641a22200e7b8a1a6b4d958d000d54444ecf598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b0edb3755c12ca838184be3516971de33f57740ebfa9d539506734e0e50e9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e0a730647ab0369eeb215b3d1d3f7f355abbef3b64d0e3593f04de9aff69d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257129e826e2774e3ecd6d08719f09b4ed5e2196d3f87c4ec99fe11b32b25d02)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies parameters to remove from the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c09d9d6cade1ea3d6976900058b867f36e4dcb6f72cc7b1837532f28d5860ee3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4cfc010ff2889bebfe7c1e76a6329a8f1511ea50abd8940d56f31fc224f30d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7d24a61268e9e713d008f8b07daf8b10da96aadefe3e728c056d34cb949f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49283e6af269752a3984df1f55a416a19f82274ca457e7d335b0a8c483ab4aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b999b9afe4b46d9b908e68d14c57bd0e776f4d4eddfb1ee356077dfb32cb6a66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13633e43a16bea861bfc2372a3811b6f1d5f55ed3dbaafb0a01fb17e9492276b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__053c3327e6c904c725e0192a809280f7c766dd3c45c410eeb18e353d3bb778d8)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, removes the ``Vary`` header to ensure objects can be cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVaryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVaryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3768911e9942a184e940ca3f8a644a2bae4b1fc2df13703475644281a074d2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765e94b9b6554978b0121f32987fe9018984330c91a9bdcfa977964df0a343b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5754b422daccf50cdd1ffceccaf592afd186ac9aa897daab775d61c7ce4ef8e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b246bfff0a4f5f4e18f35f7ff68b4bfc3798d8f7b7accbe845e37c79596487c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554693b45a696a2e133f8b2fc5a35aa10c1dec072b82c2b23844efe604e6ab34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5a8943e011a5b3185f60a28413a396114dd77fbb24726468fd38ca2feae0c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport",
    jsii_struct_bases=[],
    name_mapping={
        "cookies": "cookies",
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_accept_language": "logAcceptLanguage",
        "log_cookies": "logCookies",
        "log_custom_log_field": "logCustomLogField",
        "log_edge_ip": "logEdgeIp",
        "log_host": "logHost",
        "log_referer": "logReferer",
        "log_user_agent": "logUserAgent",
        "log_x_forwarded_for": "logXForwardedFor",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport:
    def __init__(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3453fa937a2182cd43cd0f1520c5a8ebecc173307064c3875fd185d532d9145f)
            check_type(argname="argument cookies", value=cookies, expected_type=type_hints["cookies"])
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_accept_language", value=log_accept_language, expected_type=type_hints["log_accept_language"])
            check_type(argname="argument log_cookies", value=log_cookies, expected_type=type_hints["log_cookies"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument log_edge_ip", value=log_edge_ip, expected_type=type_hints["log_edge_ip"])
            check_type(argname="argument log_host", value=log_host, expected_type=type_hints["log_host"])
            check_type(argname="argument log_referer", value=log_referer, expected_type=type_hints["log_referer"])
            check_type(argname="argument log_user_agent", value=log_user_agent, expected_type=type_hints["log_user_agent"])
            check_type(argname="argument log_x_forwarded_for", value=log_x_forwarded_for, expected_type=type_hints["log_x_forwarded_for"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookies is not None:
            self._values["cookies"] = cookies
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_accept_language is not None:
            self._values["log_accept_language"] = log_accept_language
        if log_cookies is not None:
            self._values["log_cookies"] = log_cookies
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if log_edge_ip is not None:
            self._values["log_edge_ip"] = log_edge_ip
        if log_host is not None:
            self._values["log_host"] = log_host
        if log_referer is not None:
            self._values["log_referer"] = log_referer
        if log_user_agent is not None:
            self._values["log_user_agent"] = log_user_agent
        if log_x_forwarded_for is not None:
            self._values["log_x_forwarded_for"] = log_x_forwarded_for
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookies(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the set of cookies names whose values you want to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        '''
        result = self._values.get("cookies")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_accept_language(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Accept-Language`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        '''
        result = self._values.get("log_accept_language")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_cookies(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of cookies to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        '''
        result = self._values.get("log_cookies")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_edge_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to log the IP address of the Akamai edge server that served the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        '''
        result = self._values.get("log_edge_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_host(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Host`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        '''
        result = self._values.get("log_host")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_referer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Referer`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        '''
        result = self._values.get("log_referer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_user_agent(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        '''
        result = self._values.get("log_user_agent")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log any ``X-Forwarded-For`` request header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        '''
        result = self._values.get("log_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d771eb703b11e51bb0b55f227a53083aff3676e425f25b4ee09473adb28c69dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookies")
    def reset_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookies", []))

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogAcceptLanguage")
    def reset_log_accept_language(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogAcceptLanguage", []))

    @jsii.member(jsii_name="resetLogCookies")
    def reset_log_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCookies", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetLogEdgeIp")
    def reset_log_edge_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEdgeIp", []))

    @jsii.member(jsii_name="resetLogHost")
    def reset_log_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogHost", []))

    @jsii.member(jsii_name="resetLogReferer")
    def reset_log_referer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogReferer", []))

    @jsii.member(jsii_name="resetLogUserAgent")
    def reset_log_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogUserAgent", []))

    @jsii.member(jsii_name="resetLogXForwardedFor")
    def reset_log_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogXForwardedFor", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookiesInput")
    def cookies_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguageInput")
    def log_accept_language_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logAcceptLanguageInput"))

    @builtins.property
    @jsii.member(jsii_name="logCookiesInput")
    def log_cookies_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logCookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="logEdgeIpInput")
    def log_edge_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEdgeIpInput"))

    @builtins.property
    @jsii.member(jsii_name="logHostInput")
    def log_host_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logHostInput"))

    @builtins.property
    @jsii.member(jsii_name="logRefererInput")
    def log_referer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logRefererInput"))

    @builtins.property
    @jsii.member(jsii_name="logUserAgentInput")
    def log_user_agent_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logUserAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="logXForwardedForInput")
    def log_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookies")
    def cookies(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cookies"))

    @cookies.setter
    def cookies(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05cfa93873e8e0f674f5a94b52c0d908ee1dca6cdc9cca25cef905e12cf0a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookies", value)

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32118cf46fd5a10d4561aad1d53b44b6e439a59d093bf2d7c62995cec33da9d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0d6c9bbe4361ed73a080903118022029b8d267626df87896481ef5cae539bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguage")
    def log_accept_language(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logAcceptLanguage"))

    @log_accept_language.setter
    def log_accept_language(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad855db4eab3280519fb47db1f88ef07f37b52dc2d0c410da03402e048f76f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logAcceptLanguage", value)

    @builtins.property
    @jsii.member(jsii_name="logCookies")
    def log_cookies(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logCookies"))

    @log_cookies.setter
    def log_cookies(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bde5c7844c0bfce1977825b62bc71627e6c9325cd28c7ff97c85ad245cc26bfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCookies", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765ed3764663abbf5df18b36a04e05b3615d3e73d52a2538fb0e4d780c51f896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="logEdgeIp")
    def log_edge_ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEdgeIp"))

    @log_edge_ip.setter
    def log_edge_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__addc565485d2444705a887361ba0c3353906ae28ec1f42954172dcff6644ac5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEdgeIp", value)

    @builtins.property
    @jsii.member(jsii_name="logHost")
    def log_host(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logHost"))

    @log_host.setter
    def log_host(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7faed35ba3db032e044cc8e2ab681b901a60f2540f728324d91b7bb851612725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logHost", value)

    @builtins.property
    @jsii.member(jsii_name="logReferer")
    def log_referer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logReferer"))

    @log_referer.setter
    def log_referer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d1c37bea8bdafe891b415eb672fb0c432bb5b1bf47020b10927def5d63c1a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logReferer", value)

    @builtins.property
    @jsii.member(jsii_name="logUserAgent")
    def log_user_agent(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logUserAgent"))

    @log_user_agent.setter
    def log_user_agent(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ff67c34c44749fb22b2c4569c7e8d6e4d081241779e6a7024538ab38e44d75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logUserAgent", value)

    @builtins.property
    @jsii.member(jsii_name="logXForwardedFor")
    def log_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logXForwardedFor"))

    @log_x_forwarded_for.setter
    def log_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7fa9beba91415038ae85a21d4852dcd5bb2b25cc5dfbd108dbc003717b1ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062a3a360eb05d955f0e14b8cce18e43e6c345522bf6c5223214ec198440fa38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c157a9b440dcb77e5d999f3df1a9946cbaa3026e60b9c3916fbbfad3c6e0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b6890d39a05f43998bca26a8a9342f7dd9408caf80a5c076b1e6847ee91ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl",
    jsii_struct_bases=[],
    name_mapping={
        "branded403_file": "branded403File",
        "branded403_status_code": "branded403StatusCode",
        "branded403_url": "branded403Url",
        "branded_deny_cache_ttl": "brandedDenyCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "enable_branded403": "enableBranded403",
        "enabled": "enabled",
        "locked": "locked",
        "net_storage": "netStorage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl:
    def __init__(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd929ab46a51e92d6058288ac45f9579bd80c501df64e1927b909eeb27f8819a)
            check_type(argname="argument branded403_file", value=branded403_file, expected_type=type_hints["branded403_file"])
            check_type(argname="argument branded403_status_code", value=branded403_status_code, expected_type=type_hints["branded403_status_code"])
            check_type(argname="argument branded403_url", value=branded403_url, expected_type=type_hints["branded403_url"])
            check_type(argname="argument branded_deny_cache_ttl", value=branded_deny_cache_ttl, expected_type=type_hints["branded_deny_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enable_branded403", value=enable_branded403, expected_type=type_hints["enable_branded403"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if branded403_file is not None:
            self._values["branded403_file"] = branded403_file
        if branded403_status_code is not None:
            self._values["branded403_status_code"] = branded403_status_code
        if branded403_url is not None:
            self._values["branded403_url"] = branded403_url
        if branded_deny_cache_ttl is not None:
            self._values["branded_deny_cache_ttl"] = branded_deny_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enable_branded403 is not None:
            self._values["enable_branded403"] = enable_branded403
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def branded403_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        '''
        result = self._values.get("branded403_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded403_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response status code for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        '''
        result = self._values.get("branded403_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def branded403_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect URL for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        '''
        result = self._values.get("branded403_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded_deny_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the branded response page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        '''
        result = self._values.get("branded_deny_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy"], result)

    @builtins.property
    def enable_branded403(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, serves a branded 403 page for this Cloudlet instance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        '''
        result = self._values.get("enable_branded403")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Request Control Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1ccf54840f25d3ce4c7255ce8892abcc30a0ef3fa68b136dedaffde05e2ac24)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f26a979cb37a751797a435d1a548ca3fc3c374d98c46939647354b9ee35018)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e161a1b8dcf023e0dce821024c4d8d2e8772236ed26059a8fc3abb86ec58e10d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e99a0cd1940b1c9e1046b8f38ba627d7e08b0740848de6885fe4d4d499a408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e20e046e8f452e9e44f333238afed383567701e90e2bf711db27d424d5f5ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e8a032f33be5fe35821a354ceec72b81b4ec633d4a0e92eaf396a74b0c05df)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cde2cef56cdabb0a4a3fac833b5e85c2ebb0579ee1544909ce3442c82ceb7f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22520b92649295abbe4e5d9340909271bf4caa9babb34fedb7c0b408305e038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae77cef80a9131dde7126d8afc4f7639314ec30a4825cbb88f514f74bac3d86e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc0be852d831215a432f529c1d6371d630d5fcac93e79dd925b0fde79f2de77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f818d2c53c32bb8205407c9cdc37c44c866bd556e4df1cd93588fcaf2bb485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb25e42ef9d97c31c5cfa9377490744dbc56e9b9635ba63f825eb523eb05a8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetBranded403File")
    def reset_branded403_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403File", []))

    @jsii.member(jsii_name="resetBranded403StatusCode")
    def reset_branded403_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403StatusCode", []))

    @jsii.member(jsii_name="resetBranded403Url")
    def reset_branded403_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403Url", []))

    @jsii.member(jsii_name="resetBrandedDenyCacheTtl")
    def reset_branded_deny_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrandedDenyCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnableBranded403")
    def reset_enable_branded403(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBranded403", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="branded403FileInput")
    def branded403_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403FileInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCodeInput")
    def branded403_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "branded403StatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403UrlInput")
    def branded403_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403UrlInput"))

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtlInput")
    def branded_deny_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "brandedDenyCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBranded403Input")
    def enable_branded403_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBranded403Input"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403File")
    def branded403_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403File"))

    @branded403_file.setter
    def branded403_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d29c0abea2e5d23695e237ff708618ec6ae61deab12d0de5a71f81573b5378d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403File", value)

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCode")
    def branded403_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "branded403StatusCode"))

    @branded403_status_code.setter
    def branded403_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__565f909a5f6f193e08903337230f1578beb78c08f6c1ad0765cf8c03e440d723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403StatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="branded403Url")
    def branded403_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403Url"))

    @branded403_url.setter
    def branded403_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5639a3ab4f5f2fa8547e916f7427c56b4b021378f6ee628ebc520b2d6f405164)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403Url", value)

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtl")
    def branded_deny_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "brandedDenyCacheTtl"))

    @branded_deny_cache_ttl.setter
    def branded_deny_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10d16e651a2033246acaa8943df0c25fdafaf77f5c8bf8929b60750893eefc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brandedDenyCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="enableBranded403")
    def enable_branded403(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBranded403"))

    @enable_branded403.setter
    def enable_branded403(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf710fe677ead32aa7d783f7d032c7dc6db5e78dc2cc83f5e42481723ed1b4ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBranded403", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e783687e40b472944828cee4c208da37173af86a64494d2110118e9b4d349c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a90d5a232f4c816ef5dc83f338784a8c30e489251cfb7c4ce87dfb8a3dac6e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97ca2753ec80950db94911f7edd82023b247f9a4733f8debc3b34eaa1ca4e39a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0f5349c03f2fa635707fb3ce2e2723bed8a00289874e6daf9a9f4bf4bb3b12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6440111741315efa4f62339dba6a89b9db4994b1ef294788ea868a2d429958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "request_type": "requestType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f2aa13cfab011956f3211704bdc123c7e29a6e3f1e3bc3d174f7b586f3db4c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82934dc2140864c1ce6c8f0ed4c8c43fefc382878b7412a415b74b36f897e8c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8542572bb0ab48bbebdeb708beb779735bc8933a27c28b4d90b7ecd80d2857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419252fa10fa619c7448c0cba202869b5d943939194b202fa8fea1bf3c1d0d16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36aefce0160feab2bf13cc475f0da6bd860aeea7245954417d44e29269e16808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01095202b12a5facd5412b1369525ac30feb0a8b7817038015c11469711686e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56fa37f8be1352e140cabd912497a02caace862fd9e1f6d7df5921a883faa561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50db10ab44f91cc189d2e29cb0e44347a3e2a48ba5ad22feb2aff3afec6002b3)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "enable_all_features": "enableAllFeatures",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility:
    def __init__(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da7306461a3086c011cc432f827ad48fe172cdaef8ef9c4f91f3a0b33a994ee1)
            check_type(argname="argument enable_all_features", value=enable_all_features, expected_type=type_hints["enable_all_features"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_all_features is not None:
            self._values["enable_all_features"] = enable_all_features
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_all_features(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``additional support`` and error handling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        '''
        result = self._values.get("enable_all_features")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d89f3ffcc433a52ae2fd87158815205286ad99fa4d151223f2e2d189a2d0f19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableAllFeatures")
    def reset_enable_all_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAllFeatures", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeaturesInput")
    def enable_all_features_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAllFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeatures")
    def enable_all_features(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAllFeatures"))

    @enable_all_features.setter
    def enable_all_features(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ee0da8d1854060f6d9615461af8d1ee7aa6a3cf89caa48ac4388c8832bf41b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAllFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc23eac2b2649ccdd610f8a11792f814afd51780d017db29a8a86d8a9f971cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d9261aa08d34c30c6797212d66a053cd4ebfc16cddce5f10b33a11700ca3a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e5e66c76ff9fa8c29886db689a29a1fab1fccebfd5a59c6955c75b8b4e79686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5aab9aa5195b565e69139b84794730f16b0b144e9b055783048c9518d7641ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55c249aca588e7afb158a75fb4423ff170f5f6d225414cf85d249724b3ccb4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19869b57c8467ea2c5fc86cd78aeb0fb40cde319ef6b0c4d9a65b99a8238e074)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e84bd398b0b1c1569e7da3e21685d60f9e882bcbbd2340a8580b8917209bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31ed2493abe725c38c592a49de61d17f8a30e057e92a8f15cbd55ff56194b19c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7054f414ef010018ec94b5bf8b126b40336d9bf764b2633f0b3dd06db098b85d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7be68a28c04dd4172d9c28a244e90eb4a733f45477e44bfb6697d11a0f1dba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9141d293b5906697d707ee420bb42e5fbccc19b38d7b05c23dafd19972cc106d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "override206": "override206",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2728a02f9478e0198bdeb2ae04670ec7d03f68f8d61479aca67cae03fe60ffed)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override206", value=override206, expected_type=type_hints["override206"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if override206 is not None:
            self._values["override206"] = override206
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override206(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        '''
        result = self._values.get("override206")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP status code to replace the existing one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595ac921aa12ef6223b95e9a5c5d327831cda0736775802409825e950a4232d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride206")
    def reset_override206(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride206", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="override206Input")
    def override206_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "override206Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5c2cafee612359d599648d40ff7ab44d45de47bd5c61a9fa608f04269e5cee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override206")
    def override206(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "override206"))

    @override206.setter
    def override206(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174b88db3801b842a0c1a8b7492c4166e2c9ff60d8838a60580015c1fe9f6d10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override206", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf047f3dcb6eafc2f5ce3989071b8c1d0f15e6902248fa849c0b637d30b044e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4440b1e44c18c57063f3482b6e24778d56622d9ecbdd3a1e753214fe8344231e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e03219b413a2b4d7ff89b025ec26b32647ed8adb3f5d2c68088050df0e5d24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11e85bf9dc3f8fada3e7900c7a4396de169bc8b0aebac3650828596ecd2575be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "default_domain": "defaultDomain",
        "default_path": "defaultPath",
        "domain": "domain",
        "duration": "duration",
        "enabled": "enabled",
        "expiration_date": "expirationDate",
        "expires": "expires",
        "format": "format",
        "http_only": "httpOnly",
        "locked": "locked",
        "path": "path",
        "same_site": "sameSite",
        "secure": "secure",
        "template_uuid": "templateUuid",
        "type": "type",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76055b5ae7ec6c92590d8f43d181c5b6724a744e2bc6bd46f5cbe44faa623a9)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument default_domain", value=default_domain, expected_type=type_hints["default_domain"])
            check_type(argname="argument default_path", value=default_path, expected_type=type_hints["default_path"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument duration", value=duration, expected_type=type_hints["duration"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expiration_date", value=expiration_date, expected_type=type_hints["expiration_date"])
            check_type(argname="argument expires", value=expires, expected_type=type_hints["expires"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument http_only", value=http_only, expected_type=type_hints["http_only"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument same_site", value=same_site, expected_type=type_hints["same_site"])
            check_type(argname="argument secure", value=secure, expected_type=type_hints["secure"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if default_domain is not None:
            self._values["default_domain"] = default_domain
        if default_path is not None:
            self._values["default_path"] = default_path
        if domain is not None:
            self._values["domain"] = domain
        if duration is not None:
            self._values["duration"] = duration
        if enabled is not None:
            self._values["enabled"] = enabled
        if expiration_date is not None:
            self._values["expiration_date"] = expiration_date
        if expires is not None:
            self._values["expires"] = expires
        if format is not None:
            self._values["format"] = format
        if http_only is not None:
            self._values["http_only"] = http_only
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if same_site is not None:
            self._values["same_site"] = same_site
        if secure is not None:
            self._values["secure"] = secure
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie, which serves as a key to determine if the cookie is set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        '''
        result = self._values.get("default_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def default_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default path value, otherwise the set specified in the ``path`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        '''
        result = self._values.get("default_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid.

        For example, ``example.com`` makes the cookie valid for that hostname and all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def duration(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        '''
        result = self._values.get("duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set a response cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_date(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        '''
        result = self._values.get("expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def expires(self) -> typing.Optional[builtins.str]:
        '''Sets various ways to specify when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        '''
        result = self._values.get("expires")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        '''
        result = self._values.get("http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def same_site(self) -> typing.Optional[builtins.str]:
        '''This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        '''
        result = self._values.get("same_site")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        '''
        result = self._values.get("secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''What type of value to assign.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''If the cookie ``type`` is ``FIXED``, this specifies the cookie value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db91eca4fd1674a0390933f09fe59fb0990c8960c38c482badd90af8ec2f06a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDefaultDomain")
    def reset_default_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultDomain", []))

    @jsii.member(jsii_name="resetDefaultPath")
    def reset_default_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultPath", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetDuration")
    def reset_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDuration", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExpirationDate")
    def reset_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationDate", []))

    @jsii.member(jsii_name="resetExpires")
    def reset_expires(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpires", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetHttpOnly")
    def reset_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpOnly", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetSameSite")
    def reset_same_site(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSameSite", []))

    @jsii.member(jsii_name="resetSecure")
    def reset_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecure", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultDomainInput")
    def default_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultPathInput")
    def default_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultPathInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="durationInput")
    def duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "durationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationDateInput")
    def expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="expiresInput")
    def expires_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expiresInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="httpOnlyInput")
    def http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "httpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="sameSiteInput")
    def same_site_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sameSiteInput"))

    @builtins.property
    @jsii.member(jsii_name="secureInput")
    def secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secureInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5513d5550859c4f1fedf02aa55ca0abd8945670aa099c9c6ebcafbf3c1ce7248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="defaultDomain")
    def default_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultDomain"))

    @default_domain.setter
    def default_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7368993cde1389f1a9af100472a8d0662be6c365714245f8c3a35f950e29f025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultDomain", value)

    @builtins.property
    @jsii.member(jsii_name="defaultPath")
    def default_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultPath"))

    @default_path.setter
    def default_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__754fc3d91756c2d0fa52d065d48569c826443242b11ba41f1461273ee3139faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultPath", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd80dff88eaa265f73e9540d2d1571905e276c0853507c6663329b7f1bd3adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="duration")
    def duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "duration"))

    @duration.setter
    def duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf45c7848e650c4136ac78c748dfe39f976b280957aba97f2c2da4f6d959822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "duration", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f5ca4493817ce79b02b9b1010e4e1d616411d299469b1def4f9dea3346e5ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="expirationDate")
    def expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationDate"))

    @expiration_date.setter
    def expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409ab9f07b937f6db23479012ec71ea711d3329f3baf9eada32a66e6eec0e09f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="expires")
    def expires(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expires"))

    @expires.setter
    def expires(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894fabd12d088fc273cef1a5f7f8086833ae09104285463b7c62d5b5208d9db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expires", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4e0c2aa9297451682c5601a7c58d58baaf41aa51f163c2045f546c3a5ffa962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="httpOnly")
    def http_only(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "httpOnly"))

    @http_only.setter
    def http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ab98696c4dbf55ffa6b2aa80be99905913c49799e85c2e36753e8af7d5e03d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7475fff6b8278d23ed7187a0557fa7e5726f55a81d25a1b98d6e1fdd5e46e514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec86b81d546c57715a5146df2b8f2ddcad347ea57803cc7d9798759ce149fad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="sameSite")
    def same_site(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sameSite"))

    @same_site.setter
    def same_site(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4863686bd678ac88d8ea17065e3948ae482f52f60065be00cec496836a8fd7ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sameSite", value)

    @builtins.property
    @jsii.member(jsii_name="secure")
    def secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secure"))

    @secure.setter
    def secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d55f484992b48aa2076d15eeb43ffb27def7bb8f1f6ef3ac7f023bbf9ee68b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secure", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f498b316172b818a951de8b46c3a3275e4c7dc850c0524c30d7f26d6a60ae57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0bdfd54815c6d62ba087e5d62e381214edc1884fb3db7f2f1c0f8fd26936a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b743bbc616e235e23f75e30237ab06e537dc0a464164cf5f9b962782753d83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__859e40284381c18bb303419ec3539d9723adc0fc5752194f30519a141c22d7f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517df98cfb19c7d2fb621a9787dd541cd5374b37a879886057aa585e6379e63b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_size": "maximumSize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3eb09a85a9da613c4addcde020ff96bf3c5324495d440361c44b3baeaac9ade)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed maximum size of non-HTML content to cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e81d53448d07a8ade865d1db865815a182fb00b7bfffb0d4d5fcbf4485743c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955f15c7b3fdb05a847163c45b1df94739dbbf3cedf7bbfb4306ec51c4656efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4add1d09c4f5017cbdce553d4d29381f351f95852c9bfbc26b59a569660b9e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa4414c2b02517d84ad56bb1495d6cc1ff922c718c94034dc9c14e361d3ae63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597ebe8613d150444fa830c4224961877e915089155c589613bfd2af78076f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02218c9a6940b4a866822cca5df2cd9e71f7605a401dd0a15ba2d4dcdc859bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "response_header_name": "responseHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8391a6e726f061d2551a7910b6877db340768e72e540490c248edf13ba9a8c15)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the HTTP header in which to report the cache status value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e02afdac4bbdd457ccf59dac75881c266537af6df45b16dea06e93e0aa7f339)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7931786701b134d8683963c8969278546a34c1124d4d21790c2382422396c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d3c363e05fbea7b89e5a26a8cd8cd7ab686118a22eeb4f7a65b38cf946a6e6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42db3aa026499f3efcfed18cbca4dd24eacae9d58b67d31865d64500e50676fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3128c2d7a8af4fdafe5a54cd5969767d17eda2f3b9824be5bc4242bf07f7b101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136893a37931819e05edefc899fb64db5ce9a5e66935f17454e8877b0311a0d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "keep_query_string": "keepQueryString",
        "locked": "locked",
        "match": "match",
        "match_multiple": "matchMultiple",
        "match_regex": "matchRegex",
        "target_path": "targetPath",
        "target_path_prepend": "targetPathPrepend",
        "target_regex": "targetRegex",
        "target_url": "targetUrl",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6fb82f77bd61c8e529bd045c3ff3bd35b90cf1e40f90abc3215deec2fcca87)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument keep_query_string", value=keep_query_string, expected_type=type_hints["keep_query_string"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match", value=match, expected_type=type_hints["match"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument match_regex", value=match_regex, expected_type=type_hints["match_regex"])
            check_type(argname="argument target_path", value=target_path, expected_type=type_hints["target_path"])
            check_type(argname="argument target_path_prepend", value=target_path_prepend, expected_type=type_hints["target_path_prepend"])
            check_type(argname="argument target_regex", value=target_regex, expected_type=type_hints["target_regex"])
            check_type(argname="argument target_url", value=target_url, expected_type=type_hints["target_url"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if keep_query_string is not None:
            self._values["keep_query_string"] = keep_query_string
        if locked is not None:
            self._values["locked"] = locked
        if match is not None:
            self._values["match"] = match
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if match_regex is not None:
            self._values["match_regex"] = match_regex
        if target_path is not None:
            self._values["target_path"] = target_path
        if target_path_prepend is not None:
            self._values["target_path_prepend"] = target_path_prepend
        if target_regex is not None:
            self._values["target_regex"] = target_regex
        if target_url is not None:
            self._values["target_url"] = target_url
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''The action to perform on the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def keep_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, retains the original path's query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        '''
        result = self._values.get("keep_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        '''
        result = self._values.get("match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, replaces all potential matches rather than only the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        '''
        result = self._values.get("match_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        '''
        result = self._values.get("target_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path_prepend(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        '''
        result = self._values.get("target_path_prepend")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        '''
        result = self._values.get("target_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_url(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        '''
        result = self._values.get("target_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc147bf38756db3a7c3351d328d676facf0de31b8306408e114544a3961571bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetKeepQueryString")
    def reset_keep_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKeepQueryString", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatch")
    def reset_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatch", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetMatchRegex")
    def reset_match_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchRegex", []))

    @jsii.member(jsii_name="resetTargetPath")
    def reset_target_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPath", []))

    @jsii.member(jsii_name="resetTargetPathPrepend")
    def reset_target_path_prepend(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPathPrepend", []))

    @jsii.member(jsii_name="resetTargetRegex")
    def reset_target_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetRegex", []))

    @jsii.member(jsii_name="resetTargetUrl")
    def reset_target_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetUrl", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="keepQueryStringInput")
    def keep_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "keepQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchInput")
    def match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="matchRegexInput")
    def match_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathInput")
    def target_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathPrependInput")
    def target_path_prepend_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathPrependInput"))

    @builtins.property
    @jsii.member(jsii_name="targetRegexInput")
    def target_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetUrlInput")
    def target_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07bebc2279b6942fe865b36324d7ec56a77aa6fb200fe2e597a5ab587e89349c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="keepQueryString")
    def keep_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "keepQueryString"))

    @keep_query_string.setter
    def keep_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5da5ac2495a6b037b0781547ca13bb880569caacab5d79a12c30dec383567e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "keepQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beafa938f153d35e292d68be34d52a82f73d35f1f4ce54f63f310054ac3aa3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="match")
    def match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "match"))

    @match.setter
    def match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59cd7d199fd3757d9cba6e95ca593d9c733cb92aa23396021e779088787f509a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "match", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e7232b52a41fd11b8d2e0537944302205eb54392c9913b7478b9530e9cb699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="matchRegex")
    def match_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchRegex"))

    @match_regex.setter
    def match_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca0913fc93445bed97f086f67d40233c0b01391902b299c102467f366ed1fe16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetPath")
    def target_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPath"))

    @target_path.setter
    def target_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5b12c3d5c4040f7f2039903dda3aba1c2dd7b32feaf760f03344297afc94e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPath", value)

    @builtins.property
    @jsii.member(jsii_name="targetPathPrepend")
    def target_path_prepend(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPathPrepend"))

    @target_path_prepend.setter
    def target_path_prepend(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b7cc30cdb75761daa6faa2e13ed5fb0a6c2b8665cb2d8982ee9157d0f5627c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPathPrepend", value)

    @builtins.property
    @jsii.member(jsii_name="targetRegex")
    def target_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetRegex"))

    @target_regex.setter
    def target_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b072fab66905fccc896af1d9c689eec9c5d5a49b9bb65ef21587079a6ec0f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetUrl")
    def target_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetUrl"))

    @target_url.setter
    def target_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f905386cddcb951139b1720da6647167f8827c2eca8bb25ce896e4e15126b57b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetUrl", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed82cbee17d9c33463696f45777b347366cd216bf2b5c7b1766a1454611724d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd10fbf8c913e454ca910c9ff875911c7d8a656318f714c45d2ae03b4c42cba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de078e1f0ece39cc762becf70ac804ff7122fe9374c895723447a0add17dddbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "rum_group_name": "rumGroupName",
        "rum_sample_rate": "rumSampleRate",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bbb2b51f58236891f09346aa9243ceee3bf3b2df4fa54ccb50ced40ba1067b6)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument rum_group_name", value=rum_group_name, expected_type=type_hints["rum_group_name"])
            check_type(argname="argument rum_sample_rate", value=rum_sample_rate, expected_type=type_hints["rum_sample_rate"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if rum_group_name is not None:
            self._values["rum_group_name"] = rum_group_name
        if rum_sample_rate is not None:
            self._values["rum_sample_rate"] = rum_sample_rate
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rum_group_name(self) -> typing.Optional[builtins.str]:
        '''A deprecated option to specify an alternate name under which to batch this set of web traffic in your report.

        Do not use it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        '''
        result = self._values.get("rum_group_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rum_sample_rate(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of web traffic to include in your RUM report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        '''
        result = self._values.get("rum_sample_rate")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2aedbc5c5f05f632aad3d886acdf686f9e1930f0ba384625642a279b4b0ddfa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRumGroupName")
    def reset_rum_group_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumGroupName", []))

    @jsii.member(jsii_name="resetRumSampleRate")
    def reset_rum_sample_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumSampleRate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="rumGroupNameInput")
    def rum_group_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "rumGroupNameInput"))

    @builtins.property
    @jsii.member(jsii_name="rumSampleRateInput")
    def rum_sample_rate_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "rumSampleRateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d107187769ea8726013bfb186c93f3e696e4d1d70a6e4e711cb0d3a18940e39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="rumGroupName")
    def rum_group_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rumGroupName"))

    @rum_group_name.setter
    def rum_group_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddeb974adb5ce0165bc71010ba0429b09cb32565943a29d86333602df42119e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumGroupName", value)

    @builtins.property
    @jsii.member(jsii_name="rumSampleRate")
    def rum_sample_rate(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "rumSampleRate"))

    @rum_sample_rate.setter
    def rum_sample_rate(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f2110a204694a750f1bcaebdca22673549ffd4b1b49649b584724326769bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumSampleRate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b71931a43d89678b7d82ec93bf989f3cca6bac2020fe64c406ec6fd80e69755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c9d52a5f4595a950efbdc653ecd35f567b28a4b8be9d933bf1fdf5802711cd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6cce1e6d9367aeaee836b13825434abb566cfb741b066ed7fc640a84cbc6be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions",
    jsii_struct_bases=[],
    name_mapping={
        "application_action": "applicationAction",
        "application_cname_enabled": "applicationCnameEnabled",
        "application_cname_level": "applicationCnameLevel",
        "application_cookie": "applicationCookie",
        "application_query_string": "applicationQueryString",
        "application_regex": "applicationRegex",
        "application_replace": "applicationReplace",
        "application_title": "applicationTitle",
        "customer_action": "customerAction",
        "customer_cname_enabled": "customerCnameEnabled",
        "customer_cname_level": "customerCnameLevel",
        "customer_cookie": "customerCookie",
        "customer_query_string": "customerQueryString",
        "customer_regex": "customerRegex",
        "customer_replace": "customerReplace",
        "customer_title": "customerTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "users_action": "usersAction",
        "users_cname_enabled": "usersCnameEnabled",
        "users_cname_level": "usersCnameLevel",
        "users_cookie": "usersCookie",
        "users_query_string": "usersQueryString",
        "users_regex": "usersRegex",
        "users_replace": "usersReplace",
        "users_title": "usersTitle",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions:
    def __init__(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc5127c49cf7565065f9a44b2739a07a8e346acf8eb8115258195c26408106e)
            check_type(argname="argument application_action", value=application_action, expected_type=type_hints["application_action"])
            check_type(argname="argument application_cname_enabled", value=application_cname_enabled, expected_type=type_hints["application_cname_enabled"])
            check_type(argname="argument application_cname_level", value=application_cname_level, expected_type=type_hints["application_cname_level"])
            check_type(argname="argument application_cookie", value=application_cookie, expected_type=type_hints["application_cookie"])
            check_type(argname="argument application_query_string", value=application_query_string, expected_type=type_hints["application_query_string"])
            check_type(argname="argument application_regex", value=application_regex, expected_type=type_hints["application_regex"])
            check_type(argname="argument application_replace", value=application_replace, expected_type=type_hints["application_replace"])
            check_type(argname="argument application_title", value=application_title, expected_type=type_hints["application_title"])
            check_type(argname="argument customer_action", value=customer_action, expected_type=type_hints["customer_action"])
            check_type(argname="argument customer_cname_enabled", value=customer_cname_enabled, expected_type=type_hints["customer_cname_enabled"])
            check_type(argname="argument customer_cname_level", value=customer_cname_level, expected_type=type_hints["customer_cname_level"])
            check_type(argname="argument customer_cookie", value=customer_cookie, expected_type=type_hints["customer_cookie"])
            check_type(argname="argument customer_query_string", value=customer_query_string, expected_type=type_hints["customer_query_string"])
            check_type(argname="argument customer_regex", value=customer_regex, expected_type=type_hints["customer_regex"])
            check_type(argname="argument customer_replace", value=customer_replace, expected_type=type_hints["customer_replace"])
            check_type(argname="argument customer_title", value=customer_title, expected_type=type_hints["customer_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument users_action", value=users_action, expected_type=type_hints["users_action"])
            check_type(argname="argument users_cname_enabled", value=users_cname_enabled, expected_type=type_hints["users_cname_enabled"])
            check_type(argname="argument users_cname_level", value=users_cname_level, expected_type=type_hints["users_cname_level"])
            check_type(argname="argument users_cookie", value=users_cookie, expected_type=type_hints["users_cookie"])
            check_type(argname="argument users_query_string", value=users_query_string, expected_type=type_hints["users_query_string"])
            check_type(argname="argument users_regex", value=users_regex, expected_type=type_hints["users_regex"])
            check_type(argname="argument users_replace", value=users_replace, expected_type=type_hints["users_replace"])
            check_type(argname="argument users_title", value=users_title, expected_type=type_hints["users_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if application_action is not None:
            self._values["application_action"] = application_action
        if application_cname_enabled is not None:
            self._values["application_cname_enabled"] = application_cname_enabled
        if application_cname_level is not None:
            self._values["application_cname_level"] = application_cname_level
        if application_cookie is not None:
            self._values["application_cookie"] = application_cookie
        if application_query_string is not None:
            self._values["application_query_string"] = application_query_string
        if application_regex is not None:
            self._values["application_regex"] = application_regex
        if application_replace is not None:
            self._values["application_replace"] = application_replace
        if application_title is not None:
            self._values["application_title"] = application_title
        if customer_action is not None:
            self._values["customer_action"] = customer_action
        if customer_cname_enabled is not None:
            self._values["customer_cname_enabled"] = customer_cname_enabled
        if customer_cname_level is not None:
            self._values["customer_cname_level"] = customer_cname_level
        if customer_cookie is not None:
            self._values["customer_cookie"] = customer_cookie
        if customer_query_string is not None:
            self._values["customer_query_string"] = customer_query_string
        if customer_regex is not None:
            self._values["customer_regex"] = customer_regex
        if customer_replace is not None:
            self._values["customer_replace"] = customer_replace
        if customer_title is not None:
            self._values["customer_title"] = customer_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if users_action is not None:
            self._values["users_action"] = users_action
        if users_cname_enabled is not None:
            self._values["users_cname_enabled"] = users_cname_enabled
        if users_cname_level is not None:
            self._values["users_cname_level"] = users_cname_level
        if users_cookie is not None:
            self._values["users_cookie"] = users_cookie
        if users_query_string is not None:
            self._values["users_query_string"] = users_query_string
        if users_regex is not None:
            self._values["users_regex"] = users_regex
        if users_replace is not None:
            self._values["users_replace"] = users_replace
        if users_title is not None:
            self._values["users_title"] = users_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def application_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        '''
        result = self._values.get("application_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        '''
        result = self._values.get("application_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def application_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        '''
        result = self._values.get("application_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def application_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        '''
        result = self._values.get("application_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        '''
        result = self._values.get("application_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's application ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        '''
        result = self._values.get("application_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's application ID matched by ``applicationRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        '''
        result = self._values.get("application_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        '''
        result = self._values.get("application_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        '''
        result = self._values.get("customer_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        '''
        result = self._values.get("customer_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def customer_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        '''
        result = self._values.get("customer_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def customer_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        '''
        result = self._values.get("customer_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        '''
        result = self._values.get("customer_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's customer ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        '''
        result = self._values.get("customer_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's customer ID matched by ``customerRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        '''
        result = self._values.get("customer_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        '''
        result = self._values.get("customer_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        '''
        result = self._values.get("users_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        '''
        result = self._values.get("users_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def users_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        '''
        result = self._values.get("users_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def users_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        '''
        result = self._values.get("users_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        '''
        result = self._values.get("users_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's user ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        '''
        result = self._values.get("users_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's user ID matched by ``usersRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        '''
        result = self._values.get("users_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        '''
        result = self._values.get("users_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f6513eb43c8b871e4dd80c718dac4f880bfddfa0f579dd6e1fe9a49f83ecd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplicationAction")
    def reset_application_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationAction", []))

    @jsii.member(jsii_name="resetApplicationCnameEnabled")
    def reset_application_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameEnabled", []))

    @jsii.member(jsii_name="resetApplicationCnameLevel")
    def reset_application_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameLevel", []))

    @jsii.member(jsii_name="resetApplicationCookie")
    def reset_application_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCookie", []))

    @jsii.member(jsii_name="resetApplicationQueryString")
    def reset_application_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationQueryString", []))

    @jsii.member(jsii_name="resetApplicationRegex")
    def reset_application_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationRegex", []))

    @jsii.member(jsii_name="resetApplicationReplace")
    def reset_application_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationReplace", []))

    @jsii.member(jsii_name="resetApplicationTitle")
    def reset_application_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationTitle", []))

    @jsii.member(jsii_name="resetCustomerAction")
    def reset_customer_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerAction", []))

    @jsii.member(jsii_name="resetCustomerCnameEnabled")
    def reset_customer_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameEnabled", []))

    @jsii.member(jsii_name="resetCustomerCnameLevel")
    def reset_customer_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameLevel", []))

    @jsii.member(jsii_name="resetCustomerCookie")
    def reset_customer_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCookie", []))

    @jsii.member(jsii_name="resetCustomerQueryString")
    def reset_customer_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerQueryString", []))

    @jsii.member(jsii_name="resetCustomerRegex")
    def reset_customer_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerRegex", []))

    @jsii.member(jsii_name="resetCustomerReplace")
    def reset_customer_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerReplace", []))

    @jsii.member(jsii_name="resetCustomerTitle")
    def reset_customer_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsersAction")
    def reset_users_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersAction", []))

    @jsii.member(jsii_name="resetUsersCnameEnabled")
    def reset_users_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameEnabled", []))

    @jsii.member(jsii_name="resetUsersCnameLevel")
    def reset_users_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameLevel", []))

    @jsii.member(jsii_name="resetUsersCookie")
    def reset_users_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCookie", []))

    @jsii.member(jsii_name="resetUsersQueryString")
    def reset_users_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersQueryString", []))

    @jsii.member(jsii_name="resetUsersRegex")
    def reset_users_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersRegex", []))

    @jsii.member(jsii_name="resetUsersReplace")
    def reset_users_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersReplace", []))

    @jsii.member(jsii_name="resetUsersTitle")
    def reset_users_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applicationActionInput")
    def application_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationActionInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabledInput")
    def application_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applicationCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevelInput")
    def application_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "applicationCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCookieInput")
    def application_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationQueryStringInput")
    def application_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationRegexInput")
    def application_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationReplaceInput")
    def application_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationTitleInput")
    def application_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customerActionInput")
    def customer_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerActionInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabledInput")
    def customer_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customerCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevelInput")
    def customer_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "customerCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCookieInput")
    def customer_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="customerQueryStringInput")
    def customer_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="customerRegexInput")
    def customer_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="customerReplaceInput")
    def customer_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="customerTitleInput")
    def customer_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usersActionInput")
    def users_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersActionInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabledInput")
    def users_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "usersCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevelInput")
    def users_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "usersCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCookieInput")
    def users_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="usersQueryStringInput")
    def users_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="usersRegexInput")
    def users_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="usersReplaceInput")
    def users_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="usersTitleInput")
    def users_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationAction")
    def application_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationAction"))

    @application_action.setter
    def application_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__996d9f8043ee3295cacf9a1cf2359f4381b735bfa40a68586b83252c701d30ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationAction", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabled")
    def application_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applicationCnameEnabled"))

    @application_cname_enabled.setter
    def application_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8092f37cb6646e08f68df0b0a2f171443e8a44ba8e173a4a3e6b988d7bdf8bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevel")
    def application_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "applicationCnameLevel"))

    @application_cname_level.setter
    def application_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8438a4a38f2efa144a0ad849f9a63646a165802a755fd10579da6219f7b37b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCookie")
    def application_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationCookie"))

    @application_cookie.setter
    def application_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8faa04e7f30d99d03edeed1e311989ad2c7d2468d86a291dd67f1328d91a7227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCookie", value)

    @builtins.property
    @jsii.member(jsii_name="applicationQueryString")
    def application_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationQueryString"))

    @application_query_string.setter
    def application_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec47ae65fefe3ed9bbcb05567ab5c4386d85fb798a34ddd2d4ef6c502298b0c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="applicationRegex")
    def application_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationRegex"))

    @application_regex.setter
    def application_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead24b82b65327ee0996c02f0b3aee6f5b1bc5629cc71a19992bd50faeccdda9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationRegex", value)

    @builtins.property
    @jsii.member(jsii_name="applicationReplace")
    def application_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationReplace"))

    @application_replace.setter
    def application_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__383713d1551d1e1bc9ab115e289d46cefd795a7ec4d66e623f85c804bdfddde1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationReplace", value)

    @builtins.property
    @jsii.member(jsii_name="applicationTitle")
    def application_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationTitle"))

    @application_title.setter
    def application_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e60b67c85e0dda82ef6f565ba1fb49000666174045d7e566f48824094ed3e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customerAction")
    def customer_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerAction"))

    @customer_action.setter
    def customer_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3d93cbd2e2359e65fa4922ed6a2af97df605d23515c500b8e8db7c54f1f024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerAction", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabled")
    def customer_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customerCnameEnabled"))

    @customer_cname_enabled.setter
    def customer_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dee3b68282c3a421a75b9a93b91bde5d2a9baf0eee19eb3b527472ffe2fa1a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevel")
    def customer_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "customerCnameLevel"))

    @customer_cname_level.setter
    def customer_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b23910e1dd29fb7cadaa9df61d442419035e420640c616329b4a19ffddcbcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="customerCookie")
    def customer_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerCookie"))

    @customer_cookie.setter
    def customer_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3729d6f6c8964da140e18768eba4d0ffdfac7d2d0ab76d5746fae4029a8c8e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCookie", value)

    @builtins.property
    @jsii.member(jsii_name="customerQueryString")
    def customer_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerQueryString"))

    @customer_query_string.setter
    def customer_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524316ce182b935c66d09748dc7b7d37e6bbd36e51dc7067e55e07b2dc833c61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="customerRegex")
    def customer_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerRegex"))

    @customer_regex.setter
    def customer_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fde5eaca37170c5e812ed6fc44b50192c777c189d31776bfe5d8915da083505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerRegex", value)

    @builtins.property
    @jsii.member(jsii_name="customerReplace")
    def customer_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerReplace"))

    @customer_replace.setter
    def customer_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1684a97ecc0d8bd2de713cc29d3b64d491548912ce1227789ae7fe1832a3bf17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerReplace", value)

    @builtins.property
    @jsii.member(jsii_name="customerTitle")
    def customer_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerTitle"))

    @customer_title.setter
    def customer_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c2e5c52058872066ea61c0a9388e5c32bd4502d7f3f872f6ef812e1e0e58cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feb8d75a5c9a6091eb83ff83573a58f7f37096437ae440492b30a72583fab2b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf178fa3f21658a39aea65cb8ba214f408389c4bef45f634ca71bb5d5557a30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="usersAction")
    def users_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersAction"))

    @users_action.setter
    def users_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5ead8094c2dca2267d1fcda05c675228bd0641dafebeb6e9229e448b2f4152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersAction", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabled")
    def users_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "usersCnameEnabled"))

    @users_cname_enabled.setter
    def users_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd02b68f23b72dd75054b308e6ca04f28c8d4e59b42ed8608f40c63e158d8c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevel")
    def users_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "usersCnameLevel"))

    @users_cname_level.setter
    def users_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4933f5a46f5ddf7ef716619873fc1e6e92643b2c83dfbab8d81575b1229fd67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="usersCookie")
    def users_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersCookie"))

    @users_cookie.setter
    def users_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dba95e9936d2cb5a9682043a9cc302b34c6fafa9785ebc8f202e126610f15d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCookie", value)

    @builtins.property
    @jsii.member(jsii_name="usersQueryString")
    def users_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersQueryString"))

    @users_query_string.setter
    def users_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5859f12526d1ffe5b947729c2ef7deb4fbbe57ad7e7e2da543f74e6efe1d367c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="usersRegex")
    def users_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersRegex"))

    @users_regex.setter
    def users_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aedf7cf3db6dcf39c79a1e8fe15591b3b07b465e1d115a996fdb835631d18514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersRegex", value)

    @builtins.property
    @jsii.member(jsii_name="usersReplace")
    def users_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersReplace"))

    @users_replace.setter
    def users_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e9acf419975bb31a924d5f3ddd84379fe943a50141d899c9997e9d353293d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersReplace", value)

    @builtins.property
    @jsii.member(jsii_name="usersTitle")
    def users_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersTitle"))

    @users_title.setter
    def users_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ddab621892222621fe4fc6b4368869592a640798ee1a1cc4a1f1d379854f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8caadc3ead7e5a8a2368b785c191ba38f461062d3779c352055da06b698d476b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f18e46294f6f4ef89c6075fbbd33fb987dec3ec6670cf884409111b13e7cbaca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient",
    jsii_struct_bases=[],
    name_mapping={
        "allow_override_origin_cache_key": "allowOverrideOriginCacheKey",
        "connector_id": "connectorId",
        "enabled": "enabled",
        "locked": "locked",
        "origin_host_header": "originHostHeader",
        "origin_type": "originType",
        "sf3_c_origin_host": "sf3COriginHost",
        "sf3_c_origin_host_header": "sf3COriginHostHeader",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient:
    def __init__(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0210e730c4e825d30187ca2ea644d0ada3b89f3d7e0c6f38cc32130909d48220)
            check_type(argname="argument allow_override_origin_cache_key", value=allow_override_origin_cache_key, expected_type=type_hints["allow_override_origin_cache_key"])
            check_type(argname="argument connector_id", value=connector_id, expected_type=type_hints["connector_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_host_header", value=origin_host_header, expected_type=type_hints["origin_host_header"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument sf3_c_origin_host", value=sf3_c_origin_host, expected_type=type_hints["sf3_c_origin_host"])
            check_type(argname="argument sf3_c_origin_host_header", value=sf3_c_origin_host_header, expected_type=type_hints["sf3_c_origin_host_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_override_origin_cache_key is not None:
            self._values["allow_override_origin_cache_key"] = allow_override_origin_cache_key
        if connector_id is not None:
            self._values["connector_id"] = connector_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if origin_host_header is not None:
            self._values["origin_host_header"] = origin_host_header
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if sf3_c_origin_host is not None:
            self._values["sf3_c_origin_host"] = sf3_c_origin_host
        if sf3_c_origin_host_header is not None:
            self._values["sf3_c_origin_host_header"] = sf3_c_origin_host_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides the forwarding origin's cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        '''
        result = self._values.get("allow_override_origin_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def connector_id(self) -> typing.Optional[builtins.str]:
        '''An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud.

        Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud.  You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        '''
        result = self._values.get("connector_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamai Connector for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_host_header(self) -> typing.Optional[builtins.str]:
        '''Specifies where the ``Host`` header is defined.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        '''
        result = self._values.get("origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Specifies where the origin is.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        '''
        result = self._values.get("sf3_c_origin_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce host header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        '''
        result = self._values.get("sf3_c_origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a4e94221b66a84f932c44602a1ec58703e716033b7fe23a5e75846caa736797)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowOverrideOriginCacheKey")
    def reset_allow_override_origin_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOverrideOriginCacheKey", []))

    @jsii.member(jsii_name="resetConnectorId")
    def reset_connector_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConnectorId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginHostHeader")
    def reset_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginHostHeader", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetSf3COriginHost")
    def reset_sf3_c_origin_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHost", []))

    @jsii.member(jsii_name="resetSf3COriginHostHeader")
    def reset_sf3_c_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHostHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKeyInput")
    def allow_override_origin_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowOverrideOriginCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="connectorIdInput")
    def connector_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "connectorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originHostHeaderInput")
    def origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeaderInput")
    def sf3_c_origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostInput")
    def sf3_c_origin_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKey")
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowOverrideOriginCacheKey"))

    @allow_override_origin_cache_key.setter
    def allow_override_origin_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d022754417db22059f49165b1cfcfaac515fbb591d2106f59fa97d8ea765b36a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOverrideOriginCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="connectorId")
    def connector_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "connectorId"))

    @connector_id.setter
    def connector_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079923a97d690a0d7ca1733e22dfad7e3950c619612b2fa772f84d10cf8552fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "connectorId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d044a3d3cef140c57fcbedcba13a60cb300c5dc47207434ddb82e4aeaecefbb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4749e46d11ba26f7fa512c5b68273e57a276e0db5fd83431b0318e1c16a6926a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originHostHeader")
    def origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originHostHeader"))

    @origin_host_header.setter
    def origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661ab7427524d2df6d61f42f3b319fe2b9caeb26cb810a0f7795e92cfc0f7572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c029b034fc6e2f14a8586fec95d1b7126bf2737aba94a43dc68aa6e1c7ceb8ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHost")
    def sf3_c_origin_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHost"))

    @sf3_c_origin_host.setter
    def sf3_c_origin_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7130bf27f28a1684b0abeb4747cc165888722847c8b4a37288b633e3b504c1e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHost", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeader")
    def sf3_c_origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHostHeader"))

    @sf3_c_origin_host_header.setter
    def sf3_c_origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9895dd2d1a419d6c1bbabe9c1d7294ee628a5bac64d40ff6a6f48e918a380167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae9e567513a8b2b7b8f195f1b153226b848c704120f2bb3e5545ec3e157cb1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd07e8e751f11675060e191f57ae6065fdf8794253c0e2b7f54dfc5d2c9ec11f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55335c7c7cbedd9d631cd6cdb2f8c8109e4339258a91d579843471a02e82298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c239f3413b14fd0dbb98ad2a997711a6e6d1e9186e8eb5537500e6780999fdbd)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Akamai Provider for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader",
    jsii_struct_bases=[],
    name_mapping={
        "host_header_source": "hostHeaderSource",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader:
    def __init__(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dbf2e85ca3e1f0d82c9c60f77e21cfd566221ef770e32301f987e72fb39e566)
            check_type(argname="argument host_header_source", value=host_header_source, expected_type=type_hints["host_header_source"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if host_header_source is not None:
            self._values["host_header_source"] = host_header_source
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def host_header_source(self) -> typing.Optional[builtins.str]:
        '''Specify where the host header derives from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        '''
        result = self._values.get("host_header_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c9bea08266e8da4f99bc61d644c1787200bfee30fb309f4f51c429b9a0d529)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHostHeaderSource")
    def reset_host_header_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostHeaderSource", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSourceInput")
    def host_header_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostHeaderSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSource")
    def host_header_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostHeaderSource"))

    @host_header_source.setter
    def host_header_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53434faa3e65d2c5b45813ad084b428917d610fa4c5d5736e08b18bb89c28e96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostHeaderSource", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11c19be69858f2678314d603cfb1984f7023dfc65ade473d488df30df3af187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4306d65ab8c7c1927052f43f99252ddaf91f3e312043641fa819782a28da48d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17cc7c2c130097d0d671e572a8e1a557fef0c234f8bae55f6c63c32290fe5d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3318df075a3757d156fe906d7404341cf8cd6810280a26677e759effc8ef424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c207a26ea4783fecf4869c8de14fa97950d90cae45bee74f087d824a14a131c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a540ccca7075a16a02183868002c5130f5665c44f091963391b62812c7489df2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82cb558d29bc21be065e8fbe53829d7c1d04ed489456934a2abeaae16d4c5330)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b95c5a40e4d2a1cb1b3641a0ce5ef5fe3a452fe2c53695e7f80da291354522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006813c4fe1e85ceae8227cc0dbee6fc52587e3224ea527434861dde76f4b30c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e957fc69cfbf88aad2307e6aefc55a2eabcbdb17046828b4f9e4ee365dce47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803b061a809c43fee06c813a0fb87ea0862b55582b5f18fe8f4a9bed7c77f574)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables processing of POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3588be465a811c06c52b5fb9ced861399e6c5713fb4517527a3efcafd2fcf578)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19c23e9eafc996cf9ab874d71346fa38e1a795ad4b02b87f8b6c9353848e682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__948d4100219d925a6783f6728a40a1a3f6de744f08e905e5a9587c79b7134117)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5096380ff22ca4be70386eb47179b3ca19ff393d37238b804e35ee39dac89681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2b370106411198407eabaeb357900dba1e2a3f3f339a2fce72d5ac0c48a07ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb3a6dd170888da22bd35584523c796543ee8bcb98d99ade03d98353aaebadc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "refresh_method": "refreshMethod",
        "repeat": "repeat",
        "repeat_interval": "repeatInterval",
        "start": "start",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d0bc5ab6772212f15b592f13872487cf45080e19d501b306466fc6a7430ede8)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument refresh_method", value=refresh_method, expected_type=type_hints["refresh_method"])
            check_type(argname="argument repeat", value=repeat, expected_type=type_hints["repeat"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument start", value=start, expected_type=type_hints["start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if refresh_method is not None:
            self._values["refresh_method"] = refresh_method
        if repeat is not None:
            self._values["repeat"] = repeat
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if start is not None:
            self._values["start"] = start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_method(self) -> typing.Optional[builtins.str]:
        '''Specifies how to invalidate the content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        '''
        result = self._values.get("refresh_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        '''
        result = self._values.get("repeat")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies how often to invalidate content from the ``start`` time, expressed in seconds.

        For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day.  Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start(self) -> typing.Optional[builtins.str]:
        '''The UTC date and time when matching cached content is to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        '''
        result = self._values.get("start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7991729ac966f6f347061ed44b25b42126e4ed12ac869335b809afa29e8bfeb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRefreshMethod")
    def reset_refresh_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshMethod", []))

    @jsii.member(jsii_name="resetRepeat")
    def reset_repeat(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeat", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetStart")
    def reset_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshMethodInput")
    def refresh_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatInput")
    def repeat_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "repeatInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="startInput")
    def start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d87584d5460b62fa8671157ea74cd959cdf8360ed9e7a78fbdd65bb2f5066183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="refreshMethod")
    def refresh_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshMethod"))

    @refresh_method.setter
    def refresh_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd054bc17e083c896e2f6a2d935fcdc57948ffa1d144f05c42f2def868be41a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshMethod", value)

    @builtins.property
    @jsii.member(jsii_name="repeat")
    def repeat(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "repeat"))

    @repeat.setter
    def repeat(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dfcf30c9db41df8c663579bc0f86d4a0ca927297ec85f055422e96d3df86078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeat", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0023c8ffcf64f7e2b187c2ea7d383f62fbaf640c5f5293064204a10b37b61de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="start")
    def start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "start"))

    @start.setter
    def start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3218238235517371d12a73fdd87706b6e66c349d7cda2069fbdf325ca0a2f67a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "start", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda820801b560971a899606b6fc6ed396bbb3d252d4a4dc31a2d3d916e3103c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fcc7650247410737122b3e452da8c750b4ed27e99cd42789f3e3579f37fe96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429479c92df45940081e06b5a79e3d1a7235ac56ad229330a84c28b5c4e068f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "serviceworker": "serviceworker",
        "template_uuid": "templateUuid",
        "timestamp": "timestamp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d7ce0bc4fedb75df3724e8176a009831ff87127855f28d63088b4d52cea889)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serviceworker", value=serviceworker, expected_type=type_hints["serviceworker"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timestamp", value=timestamp, expected_type=type_hints["timestamp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if serviceworker is not None:
            self._values["serviceworker"] = serviceworker
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timestamp is not None:
            self._values["timestamp"] = timestamp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Script Management feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serviceworker(self) -> typing.Optional[builtins.str]:
        '''Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        '''
        result = self._values.get("serviceworker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timestamp(self) -> typing.Optional[jsii.Number]:
        '''A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        '''
        result = self._values.get("timestamp")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagementOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagementOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c609f0409b4e2338da5b6861cf3d035c900f9a6cc46f11dfd02b9c6b25974494)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServiceworker")
    def reset_serviceworker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServiceworker", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimestamp")
    def reset_timestamp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimestamp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serviceworkerInput")
    def serviceworker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serviceworkerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timestampInput")
    def timestamp_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "timestampInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__051c177dc8d6d7143d16d701629359ed17ca90e0ef52226d29164b82baac7163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d0656632891f3dccb4b5aaaa5c61ed3c273d63eaded60bcbc1343374d5099fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serviceworker")
    def serviceworker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serviceworker"))

    @serviceworker.setter
    def serviceworker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d06b719b93bc4136e9e25dc5bc4458ca0698742c9e4d51abf0ebf1b90be648f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serviceworker", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294ba90642d72c2a7263df52000820afa703c8795904bad6f12fd3b21be38195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timestamp")
    def timestamp(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "timestamp"))

    @timestamp.setter
    def timestamp(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc815e0acd6558679d805b46f63b86aceb143d2a335099766ba29720ea4e47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timestamp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678c9a4cd629ef5ed2c3fe037dd3232ad9af2cefb4672e6aa6361a7418caea4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f2b0bb99fbfe3eab0495cd7c48d2399eb32dff8d5c919b57d5a9cadf4d274d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection",
    jsii_struct_bases=[],
    name_mapping={
        "acl": "acl",
        "dash_media_encryption": "dashMediaEncryption",
        "data_payload": "dataPayload",
        "enabled": "enabled",
        "enable_token_in_uri": "enableTokenInUri",
        "field_carry_over": "fieldCarryOver",
        "header_for_salt": "headerForSalt",
        "hls_master_manifest_files": "hlsMasterManifestFiles",
        "hls_media_encryption": "hlsMediaEncryption",
        "ip": "ip",
        "key": "key",
        "locked": "locked",
        "media_encryption_title": "mediaEncryptionTitle",
        "revoked_list_id": "revokedListId",
        "salt": "salt",
        "session_id": "sessionId",
        "template_uuid": "templateUuid",
        "token_authentication_title": "tokenAuthenticationTitle",
        "token_auth_hls_title": "tokenAuthHlsTitle",
        "token_revocation_enabled": "tokenRevocationEnabled",
        "token_revocation_title": "tokenRevocationTitle",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection:
    def __init__(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e95e3a119767877483739c17429c8333b781e3e5e25cb2457d01a5d717539f)
            check_type(argname="argument acl", value=acl, expected_type=type_hints["acl"])
            check_type(argname="argument dash_media_encryption", value=dash_media_encryption, expected_type=type_hints["dash_media_encryption"])
            check_type(argname="argument data_payload", value=data_payload, expected_type=type_hints["data_payload"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_token_in_uri", value=enable_token_in_uri, expected_type=type_hints["enable_token_in_uri"])
            check_type(argname="argument field_carry_over", value=field_carry_over, expected_type=type_hints["field_carry_over"])
            check_type(argname="argument header_for_salt", value=header_for_salt, expected_type=type_hints["header_for_salt"])
            check_type(argname="argument hls_master_manifest_files", value=hls_master_manifest_files, expected_type=type_hints["hls_master_manifest_files"])
            check_type(argname="argument hls_media_encryption", value=hls_media_encryption, expected_type=type_hints["hls_media_encryption"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_encryption_title", value=media_encryption_title, expected_type=type_hints["media_encryption_title"])
            check_type(argname="argument revoked_list_id", value=revoked_list_id, expected_type=type_hints["revoked_list_id"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument session_id", value=session_id, expected_type=type_hints["session_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authentication_title", value=token_authentication_title, expected_type=type_hints["token_authentication_title"])
            check_type(argname="argument token_auth_hls_title", value=token_auth_hls_title, expected_type=type_hints["token_auth_hls_title"])
            check_type(argname="argument token_revocation_enabled", value=token_revocation_enabled, expected_type=type_hints["token_revocation_enabled"])
            check_type(argname="argument token_revocation_title", value=token_revocation_title, expected_type=type_hints["token_revocation_title"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if acl is not None:
            self._values["acl"] = acl
        if dash_media_encryption is not None:
            self._values["dash_media_encryption"] = dash_media_encryption
        if data_payload is not None:
            self._values["data_payload"] = data_payload
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_token_in_uri is not None:
            self._values["enable_token_in_uri"] = enable_token_in_uri
        if field_carry_over is not None:
            self._values["field_carry_over"] = field_carry_over
        if header_for_salt is not None:
            self._values["header_for_salt"] = header_for_salt
        if hls_master_manifest_files is not None:
            self._values["hls_master_manifest_files"] = hls_master_manifest_files
        if hls_media_encryption is not None:
            self._values["hls_media_encryption"] = hls_media_encryption
        if ip is not None:
            self._values["ip"] = ip
        if key is not None:
            self._values["key"] = key
        if locked is not None:
            self._values["locked"] = locked
        if media_encryption_title is not None:
            self._values["media_encryption_title"] = media_encryption_title
        if revoked_list_id is not None:
            self._values["revoked_list_id"] = revoked_list_id
        if salt is not None:
            self._values["salt"] = salt
        if session_id is not None:
            self._values["session_id"] = session_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authentication_title is not None:
            self._values["token_authentication_title"] = token_authentication_title
        if token_auth_hls_title is not None:
            self._values["token_auth_hls_title"] = token_auth_hls_title
        if token_revocation_enabled is not None:
            self._values["token_revocation_enabled"] = token_revocation_enabled
        if token_revocation_title is not None:
            self._values["token_revocation_title"] = token_revocation_title
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def acl(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field.

        Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        '''
        result = self._values.get("acl")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dash_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to enable DASH Media Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        '''
        result = self._values.get("dash_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def data_payload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        '''
        result = self._values.get("data_payload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the segmented content protection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_token_in_uri(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        '''
        result = self._values.get("enable_token_in_uri")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def field_carry_over(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        '''
        result = self._values.get("field_carry_over")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_for_salt(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session.

        This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        '''
        result = self._values.get("header_for_salt")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_master_manifest_files(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of filenames that form HLS master manifest URLs.

        You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        '''
        result = self._values.get("hls_master_manifest_files")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HLS Segment Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        '''
        result = self._values.get("hls_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption key to use as a shared secret to validate tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        '''
        result = self._values.get("media_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def revoked_list_id(self) -> typing.Optional[jsii.Number]:
        '''Identifies the ``TokenAuth`` tokens to block from accessing your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        '''
        result = self._values.get("revoked_list_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt as input into the token for added security.

        This value needs to match the salt used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def session_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        '''
        result = self._values.get("session_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authentication_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        '''
        result = self._values.get("token_authentication_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_auth_hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        '''
        result = self._values.get("token_auth_hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_revocation_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        '''
        result = self._values.get("token_revocation_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def token_revocation_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        '''
        result = self._values.get("token_revocation_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify advanced ``transitionKey`` and ``salt`` options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca844a0b307a6af14e234144df6ea1a33a13d10db4e22b1b12621e288a712618)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcl")
    def reset_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcl", []))

    @jsii.member(jsii_name="resetDashMediaEncryption")
    def reset_dash_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDashMediaEncryption", []))

    @jsii.member(jsii_name="resetDataPayload")
    def reset_data_payload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataPayload", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableTokenInUri")
    def reset_enable_token_in_uri(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTokenInUri", []))

    @jsii.member(jsii_name="resetFieldCarryOver")
    def reset_field_carry_over(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFieldCarryOver", []))

    @jsii.member(jsii_name="resetHeaderForSalt")
    def reset_header_for_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderForSalt", []))

    @jsii.member(jsii_name="resetHlsMasterManifestFiles")
    def reset_hls_master_manifest_files(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMasterManifestFiles", []))

    @jsii.member(jsii_name="resetHlsMediaEncryption")
    def reset_hls_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMediaEncryption", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaEncryptionTitle")
    def reset_media_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaEncryptionTitle", []))

    @jsii.member(jsii_name="resetRevokedListId")
    def reset_revoked_list_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevokedListId", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetSessionId")
    def reset_session_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthenticationTitle")
    def reset_token_authentication_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthenticationTitle", []))

    @jsii.member(jsii_name="resetTokenAuthHlsTitle")
    def reset_token_auth_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthHlsTitle", []))

    @jsii.member(jsii_name="resetTokenRevocationEnabled")
    def reset_token_revocation_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationEnabled", []))

    @jsii.member(jsii_name="resetTokenRevocationTitle")
    def reset_token_revocation_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationTitle", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aclInput")
    def acl_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "aclInput"))

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryptionInput")
    def dash_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="dataPayloadInput")
    def data_payload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dataPayloadInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUriInput")
    def enable_token_in_uri_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTokenInUriInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOverInput")
    def field_carry_over_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldCarryOverInput"))

    @builtins.property
    @jsii.member(jsii_name="headerForSaltInput")
    def header_for_salt_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headerForSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFilesInput")
    def hls_master_manifest_files_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "hlsMasterManifestFilesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryptionInput")
    def hls_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitleInput")
    def media_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="revokedListIdInput")
    def revoked_list_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "revokedListIdInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionIdInput")
    def session_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitleInput")
    def token_authentication_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthenticationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitleInput")
    def token_auth_hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthHlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabledInput")
    def token_revocation_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenRevocationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitleInput")
    def token_revocation_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenRevocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acl")
    def acl(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "acl"))

    @acl.setter
    def acl(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6aed33551e68b5a63f9bb04d358df78b1c53c972f3aa224024351b279ef6a69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acl", value)

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryption")
    def dash_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dashMediaEncryption"))

    @dash_media_encryption.setter
    def dash_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcbf805a8513b1a3f06ab3da7a6b1f029a3741000486923c99d952d954f7d971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dashMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="dataPayload")
    def data_payload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dataPayload"))

    @data_payload.setter
    def data_payload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e9363306223d59454f7e14a4987d912110f112c8d9a220ff41f5ddc0a73029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataPayload", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c63533da56b41a868d2110bf261d19dd55c547a6afd3e46f546d6befd8d8fa3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUri")
    def enable_token_in_uri(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTokenInUri"))

    @enable_token_in_uri.setter
    def enable_token_in_uri(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39abba8f9ef9377e9dd136fbf8923228be63c07b38c051a2b96f1d3b939951ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTokenInUri", value)

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOver")
    def field_carry_over(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fieldCarryOver"))

    @field_carry_over.setter
    def field_carry_over(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2033d808b3292733df4d12fd6ec276fe4e5e0f283dbd2a9e13c43e8a7b1741)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fieldCarryOver", value)

    @builtins.property
    @jsii.member(jsii_name="headerForSalt")
    def header_for_salt(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headerForSalt"))

    @header_for_salt.setter
    def header_for_salt(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9302a2eb6bee9a69e0766c680205367b2889f5911ff443a4fb7dc5ed2f55b9f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerForSalt", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFiles")
    def hls_master_manifest_files(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "hlsMasterManifestFiles"))

    @hls_master_manifest_files.setter
    def hls_master_manifest_files(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0559cbe69118ecbdf015b43a87f39e1f1b064df476fc7f44b3ce1a11ebcc1c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMasterManifestFiles", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryption")
    def hls_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsMediaEncryption"))

    @hls_media_encryption.setter
    def hls_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f6e453e238393a7bcf6a03dd3ea1acfb2a844d0ecee7fc0a0c45589286b3c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7c5306b247612456e021cd1bce6a1f618e922850ef8b7e602950d6dcc69e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236ceeda261a1e9dfbdac29d829ae1dff83badc52523fc4873d20bcee0fb5b23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f5582ac167c6bdc2e150bdf12b753ab47a9a5ddabef425a3d5e3132e402958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitle")
    def media_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaEncryptionTitle"))

    @media_encryption_title.setter
    def media_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5332eaabcbaa884fdf60b18374789b17ff477aacbc746d6b73acfe6cfc309c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="revokedListId")
    def revoked_list_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "revokedListId"))

    @revoked_list_id.setter
    def revoked_list_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12253bd7437c0fe8e0df1f5c90fc09da5ff647c61bb5cd64d96c4de78d306b83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revokedListId", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc09e180a7508f304144d6130e3bdbc2f2a55378e8419fcd55ad7e360ad1b978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="sessionId")
    def session_id(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionId"))

    @session_id.setter
    def session_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be07c1b0fe3f5b43d74b33bc9268382a5de6cb085b93cfd5fae9f0deb45c7a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b858abb7ed6c8f55400cadec11177be50a905b6a92a5523f2c55dfd6e6953ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitle")
    def token_authentication_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthenticationTitle"))

    @token_authentication_title.setter
    def token_authentication_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f4986b327edf3941e2a58d310f0dc8eadcd60d7d1f5989afb5d8d864bb81b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthenticationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitle")
    def token_auth_hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthHlsTitle"))

    @token_auth_hls_title.setter
    def token_auth_hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4917bcfd89b21a8a2677252bcb91d5f7ecb4b75db443557e057d0ec0c8b5fb9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthHlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabled")
    def token_revocation_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenRevocationEnabled"))

    @token_revocation_enabled.setter
    def token_revocation_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5adfdf896d816c49eaf1f751b5bcaa54dc869b43a51a84fa7ce2958a05992c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitle")
    def token_revocation_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenRevocationTitle"))

    @token_revocation_title.setter
    def token_revocation_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeac53c79896d1e19a95ea2d687899eefab35dca9dd7b5d157332a9c2e7dcfb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2731818c9333ad700a5bafad5bf9cf48fd8807a6b612fd834a23b6de95e58aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167f10825f01b6b25285311ab2643ca63aeb85ad334273a43d02f376a4d86a52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b7663ea6837392239dc8d95d1a6d0549d3a46003301e0d874fd42f8d643e498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95c7cb2f83888f9ef54b8122ff5974510ec5fd102b00c00a323980997bc4032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "dvr_type": "dvrType",
        "dvr_window": "dvrWindow",
        "enable_ull_streaming": "enableUllStreaming",
        "end_time": "endTime",
        "live_type": "liveType",
        "locked": "locked",
        "show_advanced": "showAdvanced",
        "start_time": "startTime",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53274eac8e96d8f372386fabebb68c19b376dd4ef39ac07ce610570f802cad90)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument dvr_type", value=dvr_type, expected_type=type_hints["dvr_type"])
            check_type(argname="argument dvr_window", value=dvr_window, expected_type=type_hints["dvr_window"])
            check_type(argname="argument enable_ull_streaming", value=enable_ull_streaming, expected_type=type_hints["enable_ull_streaming"])
            check_type(argname="argument end_time", value=end_time, expected_type=type_hints["end_time"])
            check_type(argname="argument live_type", value=live_type, expected_type=type_hints["live_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument show_advanced", value=show_advanced, expected_type=type_hints["show_advanced"])
            check_type(argname="argument start_time", value=start_time, expected_type=type_hints["start_time"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if dvr_type is not None:
            self._values["dvr_type"] = dvr_type
        if dvr_window is not None:
            self._values["dvr_window"] = dvr_window
        if enable_ull_streaming is not None:
            self._values["enable_ull_streaming"] = enable_ull_streaming
        if end_time is not None:
            self._values["end_time"] = end_time
        if live_type is not None:
            self._values["live_type"] = live_type
        if locked is not None:
            self._values["locked"] = locked
        if show_advanced is not None:
            self._values["show_advanced"] = show_advanced
        if start_time is not None:
            self._values["start_time"] = start_time
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Sets the type of media content to optimize.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_type(self) -> typing.Optional[builtins.str]:
        '''The type of DVR.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        '''
        result = self._values.get("dvr_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_window(self) -> typing.Optional[builtins.str]:
        '''Set the duration for your media, or ``0m`` if a DVR is not required.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        '''
        result = self._values.get("dvr_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_ull_streaming(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        '''
        result = self._values.get("enable_ull_streaming")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def end_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event ends.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        '''
        result = self._values.get("end_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def live_type(self) -> typing.Optional[builtins.str]:
        '''The type of live media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        '''
        result = self._values.get("live_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced media options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        '''
        result = self._values.get("show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def start_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event begins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        '''
        result = self._values.get("start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7c68bc970a7f495ef8bff5bed8ff7da3de2902a9b49c7c02e6e1347aea128c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetDvrType")
    def reset_dvr_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrType", []))

    @jsii.member(jsii_name="resetDvrWindow")
    def reset_dvr_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrWindow", []))

    @jsii.member(jsii_name="resetEnableUllStreaming")
    def reset_enable_ull_streaming(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableUllStreaming", []))

    @jsii.member(jsii_name="resetEndTime")
    def reset_end_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndTime", []))

    @jsii.member(jsii_name="resetLiveType")
    def reset_live_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetShowAdvanced")
    def reset_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShowAdvanced", []))

    @jsii.member(jsii_name="resetStartTime")
    def reset_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartTime", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrTypeInput")
    def dvr_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrWindowInput")
    def dvr_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="enableUllStreamingInput")
    def enable_ull_streaming_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableUllStreamingInput"))

    @builtins.property
    @jsii.member(jsii_name="endTimeInput")
    def end_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="liveTypeInput")
    def live_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "liveTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="showAdvancedInput")
    def show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "showAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="startTimeInput")
    def start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa6617033c7367dd463e993ec8798d534c5b0221583ea575683065d57fb35fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="dvrType")
    def dvr_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrType"))

    @dvr_type.setter
    def dvr_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17ed610fc2c3c3d5d25766200555959ae25d6c6f3e5b20a5aaeed9eeb77c9a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrType", value)

    @builtins.property
    @jsii.member(jsii_name="dvrWindow")
    def dvr_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrWindow"))

    @dvr_window.setter
    def dvr_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a225b0c5fd3afbde387786a063c5b01c944ff0a70c2290cf4b1e145b9171f5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrWindow", value)

    @builtins.property
    @jsii.member(jsii_name="enableUllStreaming")
    def enable_ull_streaming(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableUllStreaming"))

    @enable_ull_streaming.setter
    def enable_ull_streaming(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7d354f775b77a19256c2c7b406df0fff33d64ab8f307af813f6d15aed0f4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableUllStreaming", value)

    @builtins.property
    @jsii.member(jsii_name="endTime")
    def end_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endTime"))

    @end_time.setter
    def end_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59071a39978efabffe25bf4e636187e01c8f90c1d216aa7af396506596787e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endTime", value)

    @builtins.property
    @jsii.member(jsii_name="liveType")
    def live_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "liveType"))

    @live_type.setter
    def live_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7b0eebd8418a4e9325917426b5f8202628ca05cfa711ec0dbc8fb3a3da0421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62f827e429402a031010a0725c251031496623d4f6292ddd5bc847d6f761fb0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="showAdvanced")
    def show_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "showAdvanced"))

    @show_advanced.setter
    def show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__798997626f49210457feac65184f010c4f5f5b25f6b6d3cacbff5757eb19cea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "showAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="startTime")
    def start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "startTime"))

    @start_time.setter
    def start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3a640adad80cac21ce599b7a96be79a572cb3d2889512d89bc3d460b376c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startTime", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01dee6d7da98ec3d13c3c32d94a31208ef12bd0b45a321a7e2765ccd318fd574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2471b9aef331412cdb84781489898c06d8a27f578a7c0e4f296633dd61e23694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05bd3c64fa172c6561d27914ef00544f642f54bcd6225dfc75f2f7b3a1f0fda2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec8ff237ce9ec9c39820990b47817cbf56cf850b47c8bcdc2df8d23782328037)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables media stream prefetching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a320cb4871f45910b48c91a000489828a7d64715f606599ad7e5f8ae293c6eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a654114f37decc2aa016d591aae5d15a3023f927248150acbf68b51ac8ba561f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2983b45b71817793818681b83de18fcf333db14904b801382278de42d674369d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900c45bb3b926866ce27db71f04463140e15bd251baecf48b8d1659adc9d2062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__050e1589a207c1c245a448b496075dfd4fe8c23e95fb9177d3312033561a5292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74aaf00fde0f544a559f1aa1e80a0443dd4d0368e761182a2fc842accaeb4319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "case_sensitive": "caseSensitive",
        "certificate_field_name": "certificateFieldName",
        "cookie_name": "cookieName",
        "device_profile": "deviceProfile",
        "encryption_key": "encryptionKey",
        "encryption_mode": "encryptionMode",
        "end_index": "endIndex",
        "except_chars": "exceptChars",
        "extract_location": "extractLocation",
        "force_chars": "forceChars",
        "format_string": "formatString",
        "generator": "generator",
        "global_substitution": "globalSubstitution",
        "header_name": "headerName",
        "hmac_algorithm": "hmacAlgorithm",
        "hmac_key": "hmacKey",
        "initialization_vector": "initializationVector",
        "ipv4_prefix": "ipv4Prefix",
        "ipv6_prefix": "ipv6Prefix",
        "ip_version": "ipVersion",
        "location_id": "locationId",
        "locked": "locked",
        "max": "max",
        "max_random_number": "maxRandomNumber",
        "min": "min",
        "min_random_number": "minRandomNumber",
        "nonce": "nonce",
        "number_of_bytes": "numberOfBytes",
        "operand_one": "operandOne",
        "param_name": "paramName",
        "path_component_offset": "pathComponentOffset",
        "prepend_bytes": "prependBytes",
        "query_parameter_name": "queryParameterName",
        "regex": "regex",
        "replacement": "replacement",
        "response_header_name": "responseHeaderName",
        "separator": "separator",
        "set_cookie_name": "setCookieName",
        "start_index": "startIndex",
        "sub_string": "subString",
        "template_uuid": "templateUuid",
        "transform": "transform",
        "uuid": "uuid",
        "value_source": "valueSource",
        "variable_name": "variableName",
        "variable_value": "variableValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[builtins.str] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[builtins.str] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[builtins.str] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e2a2b0d7310fdd95493622fda387999c16e568bcea6d00e8b23f027ef2a053)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument certificate_field_name", value=certificate_field_name, expected_type=type_hints["certificate_field_name"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument device_profile", value=device_profile, expected_type=type_hints["device_profile"])
            check_type(argname="argument encryption_key", value=encryption_key, expected_type=type_hints["encryption_key"])
            check_type(argname="argument encryption_mode", value=encryption_mode, expected_type=type_hints["encryption_mode"])
            check_type(argname="argument end_index", value=end_index, expected_type=type_hints["end_index"])
            check_type(argname="argument except_chars", value=except_chars, expected_type=type_hints["except_chars"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument force_chars", value=force_chars, expected_type=type_hints["force_chars"])
            check_type(argname="argument format_string", value=format_string, expected_type=type_hints["format_string"])
            check_type(argname="argument generator", value=generator, expected_type=type_hints["generator"])
            check_type(argname="argument global_substitution", value=global_substitution, expected_type=type_hints["global_substitution"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument hmac_algorithm", value=hmac_algorithm, expected_type=type_hints["hmac_algorithm"])
            check_type(argname="argument hmac_key", value=hmac_key, expected_type=type_hints["hmac_key"])
            check_type(argname="argument initialization_vector", value=initialization_vector, expected_type=type_hints["initialization_vector"])
            check_type(argname="argument ipv4_prefix", value=ipv4_prefix, expected_type=type_hints["ipv4_prefix"])
            check_type(argname="argument ipv6_prefix", value=ipv6_prefix, expected_type=type_hints["ipv6_prefix"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max", value=max, expected_type=type_hints["max"])
            check_type(argname="argument max_random_number", value=max_random_number, expected_type=type_hints["max_random_number"])
            check_type(argname="argument min", value=min, expected_type=type_hints["min"])
            check_type(argname="argument min_random_number", value=min_random_number, expected_type=type_hints["min_random_number"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument number_of_bytes", value=number_of_bytes, expected_type=type_hints["number_of_bytes"])
            check_type(argname="argument operand_one", value=operand_one, expected_type=type_hints["operand_one"])
            check_type(argname="argument param_name", value=param_name, expected_type=type_hints["param_name"])
            check_type(argname="argument path_component_offset", value=path_component_offset, expected_type=type_hints["path_component_offset"])
            check_type(argname="argument prepend_bytes", value=prepend_bytes, expected_type=type_hints["prepend_bytes"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument replacement", value=replacement, expected_type=type_hints["replacement"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument separator", value=separator, expected_type=type_hints["separator"])
            check_type(argname="argument set_cookie_name", value=set_cookie_name, expected_type=type_hints["set_cookie_name"])
            check_type(argname="argument start_index", value=start_index, expected_type=type_hints["start_index"])
            check_type(argname="argument sub_string", value=sub_string, expected_type=type_hints["sub_string"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transform", value=transform, expected_type=type_hints["transform"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value_source", value=value_source, expected_type=type_hints["value_source"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_value", value=variable_value, expected_type=type_hints["variable_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if certificate_field_name is not None:
            self._values["certificate_field_name"] = certificate_field_name
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if device_profile is not None:
            self._values["device_profile"] = device_profile
        if encryption_key is not None:
            self._values["encryption_key"] = encryption_key
        if encryption_mode is not None:
            self._values["encryption_mode"] = encryption_mode
        if end_index is not None:
            self._values["end_index"] = end_index
        if except_chars is not None:
            self._values["except_chars"] = except_chars
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if force_chars is not None:
            self._values["force_chars"] = force_chars
        if format_string is not None:
            self._values["format_string"] = format_string
        if generator is not None:
            self._values["generator"] = generator
        if global_substitution is not None:
            self._values["global_substitution"] = global_substitution
        if header_name is not None:
            self._values["header_name"] = header_name
        if hmac_algorithm is not None:
            self._values["hmac_algorithm"] = hmac_algorithm
        if hmac_key is not None:
            self._values["hmac_key"] = hmac_key
        if initialization_vector is not None:
            self._values["initialization_vector"] = initialization_vector
        if ipv4_prefix is not None:
            self._values["ipv4_prefix"] = ipv4_prefix
        if ipv6_prefix is not None:
            self._values["ipv6_prefix"] = ipv6_prefix
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if max is not None:
            self._values["max"] = max
        if max_random_number is not None:
            self._values["max_random_number"] = max_random_number
        if min is not None:
            self._values["min"] = min
        if min_random_number is not None:
            self._values["min_random_number"] = min_random_number
        if nonce is not None:
            self._values["nonce"] = nonce
        if number_of_bytes is not None:
            self._values["number_of_bytes"] = number_of_bytes
        if operand_one is not None:
            self._values["operand_one"] = operand_one
        if param_name is not None:
            self._values["param_name"] = param_name
        if path_component_offset is not None:
            self._values["path_component_offset"] = path_component_offset
        if prepend_bytes is not None:
            self._values["prepend_bytes"] = prepend_bytes
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex is not None:
            self._values["regex"] = regex
        if replacement is not None:
            self._values["replacement"] = replacement
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if separator is not None:
            self._values["separator"] = separator
        if set_cookie_name is not None:
            self._values["set_cookie_name"] = set_cookie_name
        if start_index is not None:
            self._values["start_index"] = start_index
        if sub_string is not None:
            self._values["sub_string"] = sub_string
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transform is not None:
            self._values["transform"] = transform
        if uuid is not None:
            self._values["uuid"] = uuid
        if value_source is not None:
            self._values["value_source"] = value_source
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_value is not None:
            self._values["variable_value"] = variable_value

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this makes all matches case sensitive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def certificate_field_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the certificate's content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        '''
        result = self._values.get("certificate_field_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def device_profile(self) -> typing.Optional[builtins.str]:
        '''Specifies the client device attribute.

        Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        '''
        result = self._values.get("device_profile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption hex key.

        For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        '''
        result = self._values.get("encryption_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        '''
        result = self._values.get("encryption_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_index(self) -> typing.Optional[builtins.str]:
        '''Specifies the zero-based character offset at the end of the substring, without including the character at that index position.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        '''
        result = self._values.get("end_index")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def except_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters ``not`` to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        '''
        result = self._values.get("except_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''This specifies from where to get the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def force_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        '''
        result = self._values.get("force_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format_string(self) -> typing.Optional[builtins.str]:
        '''Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``.

        A blank value defaults to RFC-2616 format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        '''
        result = self._values.get("format_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def generator(self) -> typing.Optional[builtins.str]:
        '''This specifies the type of value to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        '''
        result = self._values.get("generator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def global_substitution(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches in the string, not just the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        '''
        result = self._values.get("global_substitution")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to use to generate the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        '''
        result = self._values.get("hmac_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret to use in generating the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        '''
        result = self._values.get("hmac_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def initialization_vector(self) -> typing.Optional[builtins.str]:
        '''Specifies a one-time number as an initialization vector.

        It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        '''
        result = self._values.get("initialization_vector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ipv4_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV4 address, a value between 0 and 32.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        '''
        result = self._values.get("ipv4_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ipv6_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV6 address, a value between 0 and 128.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        '''
        result = self._values.get("ipv6_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the IP version under which a subnet mask generates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``X-Akamai-Edgescape`` header's field name.

        Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max(self) -> typing.Optional[jsii.Number]:
        '''Specifies a maximum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        '''
        result = self._values.get("max")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def max_random_number(self) -> typing.Optional[builtins.str]:
        '''Specifies the upper bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        '''
        result = self._values.get("max_random_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min(self) -> typing.Optional[jsii.Number]:
        '''Specifies a minimum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        '''
        result = self._values.get("min")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min_random_number(self) -> typing.Optional[builtins.str]:
        '''Specifies the lower bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        '''
        result = self._values.get("min_random_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the one-time number used for encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def number_of_bytes(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of random hex bytes to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        '''
        result = self._values.get("number_of_bytes")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def operand_one(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        '''
        result = self._values.get("operand_one")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def param_name(self) -> typing.Optional[builtins.str]:
        '''Extracts the value for the specified parameter name from a string that contains key/value pairs.

        (Use ``separator`` below to parse them.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        '''
        result = self._values.get("param_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def path_component_offset(self) -> typing.Optional[builtins.str]:
        '''This specifies a portion of the path.

        The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        '''
        result = self._values.get("path_component_offset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prepend_bytes(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a number of random bytes to prepend to the key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        '''
        result = self._values.get("prepend_bytes")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression pattern (PCRE) to match the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replacement(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        '''
        result = self._values.get("replacement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def separator(self) -> typing.Optional[builtins.str]:
        '''Specifies the character that separates pairs of values within the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        '''
        result = self._values.get("separator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def set_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the origin's ``Set-Cookie`` response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        '''
        result = self._values.get("set_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start_index(self) -> typing.Optional[builtins.str]:
        '''Specifies the zero-based character offset at the start of the substring.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        '''
        result = self._values.get("start_index")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sub_string(self) -> typing.Optional[builtins.str]:
        '''Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        '''
        result = self._values.get("sub_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transform(self) -> typing.Optional[builtins.str]:
        '''Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        '''
        result = self._values.get("transform")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_source(self) -> typing.Optional[builtins.str]:
        '''Determines how you want to set the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        '''
        result = self._values.get("value_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the predeclared root name of the variable to modify.

        When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_value(self) -> typing.Optional[builtins.str]:
        '''This directly specifies the value to assign to the variable.

        The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        result = self._values.get("variable_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03bba3669cc950744c47a62b93f27e23c53da45c4b54e9d40e3d2fd1b9a24ce6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetCertificateFieldName")
    def reset_certificate_field_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateFieldName", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDeviceProfile")
    def reset_device_profile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceProfile", []))

    @jsii.member(jsii_name="resetEncryptionKey")
    def reset_encryption_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionKey", []))

    @jsii.member(jsii_name="resetEncryptionMode")
    def reset_encryption_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionMode", []))

    @jsii.member(jsii_name="resetEndIndex")
    def reset_end_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndIndex", []))

    @jsii.member(jsii_name="resetExceptChars")
    def reset_except_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExceptChars", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetForceChars")
    def reset_force_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceChars", []))

    @jsii.member(jsii_name="resetFormatString")
    def reset_format_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatString", []))

    @jsii.member(jsii_name="resetGenerator")
    def reset_generator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGenerator", []))

    @jsii.member(jsii_name="resetGlobalSubstitution")
    def reset_global_substitution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalSubstitution", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetHmacAlgorithm")
    def reset_hmac_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacAlgorithm", []))

    @jsii.member(jsii_name="resetHmacKey")
    def reset_hmac_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacKey", []))

    @jsii.member(jsii_name="resetInitializationVector")
    def reset_initialization_vector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInitializationVector", []))

    @jsii.member(jsii_name="resetIpv4Prefix")
    def reset_ipv4_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv4Prefix", []))

    @jsii.member(jsii_name="resetIpv6Prefix")
    def reset_ipv6_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv6Prefix", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMax")
    def reset_max(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMax", []))

    @jsii.member(jsii_name="resetMaxRandomNumber")
    def reset_max_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxRandomNumber", []))

    @jsii.member(jsii_name="resetMin")
    def reset_min(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMin", []))

    @jsii.member(jsii_name="resetMinRandomNumber")
    def reset_min_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinRandomNumber", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetNumberOfBytes")
    def reset_number_of_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumberOfBytes", []))

    @jsii.member(jsii_name="resetOperandOne")
    def reset_operand_one(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperandOne", []))

    @jsii.member(jsii_name="resetParamName")
    def reset_param_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParamName", []))

    @jsii.member(jsii_name="resetPathComponentOffset")
    def reset_path_component_offset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPathComponentOffset", []))

    @jsii.member(jsii_name="resetPrependBytes")
    def reset_prepend_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrependBytes", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetReplacement")
    def reset_replacement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacement", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetSeparator")
    def reset_separator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeparator", []))

    @jsii.member(jsii_name="resetSetCookieName")
    def reset_set_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetCookieName", []))

    @jsii.member(jsii_name="resetStartIndex")
    def reset_start_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartIndex", []))

    @jsii.member(jsii_name="resetSubString")
    def reset_sub_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubString", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransform")
    def reset_transform(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransform", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValueSource")
    def reset_value_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueSource", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValue")
    def reset_variable_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValue", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldNameInput")
    def certificate_field_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldNameInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceProfileInput")
    def device_profile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deviceProfileInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionKeyInput")
    def encryption_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionModeInput")
    def encryption_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="endIndexInput")
    def end_index_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="exceptCharsInput")
    def except_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "exceptCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="forceCharsInput")
    def force_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forceCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="formatStringInput")
    def format_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatStringInput"))

    @builtins.property
    @jsii.member(jsii_name="generatorInput")
    def generator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "generatorInput"))

    @builtins.property
    @jsii.member(jsii_name="globalSubstitutionInput")
    def global_substitution_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "globalSubstitutionInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithmInput")
    def hmac_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacKeyInput")
    def hmac_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="initializationVectorInput")
    def initialization_vector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "initializationVectorInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv4PrefixInput")
    def ipv4_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv4PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv6PrefixInput")
    def ipv6_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv6PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxInput")
    def max_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxInput"))

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumberInput")
    def max_random_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="minInput")
    def min_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minInput"))

    @builtins.property
    @jsii.member(jsii_name="minRandomNumberInput")
    def min_random_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="numberOfBytesInput")
    def number_of_bytes_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numberOfBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="operandOneInput")
    def operand_one_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operandOneInput"))

    @builtins.property
    @jsii.member(jsii_name="paramNameInput")
    def param_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paramNameInput"))

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffsetInput")
    def path_component_offset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathComponentOffsetInput"))

    @builtins.property
    @jsii.member(jsii_name="prependBytesInput")
    def prepend_bytes_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prependBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementInput")
    def replacement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="separatorInput")
    def separator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "separatorInput"))

    @builtins.property
    @jsii.member(jsii_name="setCookieNameInput")
    def set_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "setCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="startIndexInput")
    def start_index_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="subStringInput")
    def sub_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subStringInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transformInput")
    def transform_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transformInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueSourceInput")
    def value_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValueInput")
    def variable_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableValueInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ac3df6d8822d25ece5399804e9374154f19cd16f7394ab198df39ac81b273ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce9ab2d48b5545062aa1dab911cbb57e1c118826b0583ec00890b297d9b92ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="certificateFieldName")
    def certificate_field_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateFieldName"))

    @certificate_field_name.setter
    def certificate_field_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3fa5e9fd7a1990d6876c3d312e7bc76186a8c6146a2717e0c3377ecd61981d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateFieldName", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acd40ece6c9bce8ebce0cc4dc93ad48ff6b2a869b3e945d7efedcba193793d0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="deviceProfile")
    def device_profile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deviceProfile"))

    @device_profile.setter
    def device_profile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea828c3bd038fb913a3ab00138a55c94e82ea84bcf4a3bd9cc29dd03f0c97ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deviceProfile", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionKey")
    def encryption_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionKey"))

    @encryption_key.setter
    def encryption_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f72d9a1adba074134cbfc4f20f50ff9ad3e6a5165a85b6d5602ce9453c13338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionKey", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionMode")
    def encryption_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionMode"))

    @encryption_mode.setter
    def encryption_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbbc33496b31dc9f268c6bf39736cdef122f03a47ad279fd04ee34c4bb0f2e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionMode", value)

    @builtins.property
    @jsii.member(jsii_name="endIndex")
    def end_index(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endIndex"))

    @end_index.setter
    def end_index(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90e499c8c18071a87fb2e24f7e7725b30057ac13e25aecb94bb925104441b4ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endIndex", value)

    @builtins.property
    @jsii.member(jsii_name="exceptChars")
    def except_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "exceptChars"))

    @except_chars.setter
    def except_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daff6a2ca5be06ca37c4ae3dad622e931ee4c35db4ec118b88a618af4cba605e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exceptChars", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73b864a552f0a0a006d5c751a1e2dd007277ff8adc471ee7810af95e4c69a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="forceChars")
    def force_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forceChars"))

    @force_chars.setter
    def force_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b06a8b431373bcbba5fa879ee96abe9e0ea543fab45e3120592ab0ade93086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceChars", value)

    @builtins.property
    @jsii.member(jsii_name="formatString")
    def format_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatString"))

    @format_string.setter
    def format_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d83aba293331e9744e829095f75f42d9342d732ed63499b2cb8e6a9f4bc0fc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatString", value)

    @builtins.property
    @jsii.member(jsii_name="generator")
    def generator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "generator"))

    @generator.setter
    def generator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887af14204c516957ddf8c902c7c82027eecc3f085e81a520018a95b92da35e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "generator", value)

    @builtins.property
    @jsii.member(jsii_name="globalSubstitution")
    def global_substitution(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "globalSubstitution"))

    @global_substitution.setter
    def global_substitution(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4beef46b70268b116c13220eacf0940b4a66d78390691b31a6c7caf3df541db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "globalSubstitution", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35a8e9f96a47eda3f2401deaf1300819b9b07eb0ad0a9ae4c663aa8b60f9e1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithm")
    def hmac_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacAlgorithm"))

    @hmac_algorithm.setter
    def hmac_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936de23df6a37933d550cf30fcd512aaa83571e3f0c07e87f59ed4888eb3784f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hmacKey")
    def hmac_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacKey"))

    @hmac_key.setter
    def hmac_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12cd7c016862c7229eef015ccacfff03ca62099fb965ffb0e52f7b504ee921a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacKey", value)

    @builtins.property
    @jsii.member(jsii_name="initializationVector")
    def initialization_vector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "initializationVector"))

    @initialization_vector.setter
    def initialization_vector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77777c34452b07adb16c3f69c6533fa52bb6363196064018a40aac10d8b52423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "initializationVector", value)

    @builtins.property
    @jsii.member(jsii_name="ipv4Prefix")
    def ipv4_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv4Prefix"))

    @ipv4_prefix.setter
    def ipv4_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25ab582c30df97ea3137af56b51702c91fc6541e7356035cdc19229cea2c5c6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv4Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipv6Prefix")
    def ipv6_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv6Prefix"))

    @ipv6_prefix.setter
    def ipv6_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd8f0c0f61ef457087433a48807a90e3dd67b764e867e3ac4fa8f8239d7a03d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv6Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191a61852ff0d440691a5844651e6b2e3712c80ade3431dd490a1a143a4c5246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc5dc63cb1e7ba83d1a9fdbc835fb2caa09678d2bde6cdc9bcd9d08600b9934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a44c55f6a94d025b51f865cdd8e7015e1974306dfab5a492346bedf99b27b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="max")
    def max(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "max"))

    @max.setter
    def max(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16d891f2d34d63f6f62c31fb726bf639a94ab251c6d5efd1250837da9c3d006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "max", value)

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumber")
    def max_random_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxRandomNumber"))

    @max_random_number.setter
    def max_random_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__699b455064a557f9793b543c57a1f615446950d3d3afccb06e0446693e3a6d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="min")
    def min(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "min"))

    @min.setter
    def min(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c274a0caf9503f1a83651d4c6c5038b51d55001baddc37bb93f079f283def0ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "min", value)

    @builtins.property
    @jsii.member(jsii_name="minRandomNumber")
    def min_random_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minRandomNumber"))

    @min_random_number.setter
    def min_random_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e9c9b97c2feeaa9c29161c94adb92cbb40e9b804f346b0a4323135abf5962e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcacf2f4760930f2fa842ce3946f77f0a38baa1c6d64f925311d3777c27c4dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="numberOfBytes")
    def number_of_bytes(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numberOfBytes"))

    @number_of_bytes.setter
    def number_of_bytes(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7159ef45ff94955b9476c5474f097d2f95e74c79e0ce24368df3f42ad9ea50d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numberOfBytes", value)

    @builtins.property
    @jsii.member(jsii_name="operandOne")
    def operand_one(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operandOne"))

    @operand_one.setter
    def operand_one(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c46ccd9b26eb7a1b594be85826e3fdf8a4996a2de156f64478fd8c782d93d51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operandOne", value)

    @builtins.property
    @jsii.member(jsii_name="paramName")
    def param_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paramName"))

    @param_name.setter
    def param_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5a77c2fdc386ee16c134ce59e21686f62f125094c1fd88a09a769cf02ff021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paramName", value)

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffset")
    def path_component_offset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pathComponentOffset"))

    @path_component_offset.setter
    def path_component_offset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9869d102fc6f0219293c7c50d7fe8b60cb344a8107ba5cc298e49e45672e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pathComponentOffset", value)

    @builtins.property
    @jsii.member(jsii_name="prependBytes")
    def prepend_bytes(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prependBytes"))

    @prepend_bytes.setter
    def prepend_bytes(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696161c4c3684355f57c6f8613e3153aee42b1ddb11b77ea14cfd084ea638ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prependBytes", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6abe1f134f01680ad200fb64e3fa1fe6be80639cfc6089e75266240822805c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b1382ffc65d1f072111bdf238edd2017b74969129ac3b8450eb3a505c004fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="replacement")
    def replacement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacement"))

    @replacement.setter
    def replacement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df61f4e6620c01c0e5d422565d0d457b6e91bddde7dd6fbd28c6d297583d252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacement", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f211f1f859392f5f780c69ed371428f7592718a63533edacf5697fb59e80f0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="separator")
    def separator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "separator"))

    @separator.setter
    def separator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a4108f50792356ddea60e6aee41a3737125cf5be383077d39ce83310319668d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "separator", value)

    @builtins.property
    @jsii.member(jsii_name="setCookieName")
    def set_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "setCookieName"))

    @set_cookie_name.setter
    def set_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37f2d66d656a56aae3b5ef2baeecb787674c4aa177a4e42d8b16803c1b4f7056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "setCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="startIndex")
    def start_index(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "startIndex"))

    @start_index.setter
    def start_index(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85df3b8b79614427ba47b4baa7dc50559387fec11f9a784c59709acffac0ca63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startIndex", value)

    @builtins.property
    @jsii.member(jsii_name="subString")
    def sub_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subString"))

    @sub_string.setter
    def sub_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b87cd1641a208eaccb9405a4fc2f5566f67fe970ba2613e6a180be199bc527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subString", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc7490916922a366c639aca17c78dd7144ba43c32d5e3bae40fbe2382bfd00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transform")
    def transform(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transform"))

    @transform.setter
    def transform(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a38f0fc358fd0ec1c1431318eaa0291c366711609adf2c8069449c74ae6e845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transform", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f8b2a67620622f9ff124cac0da56a6ed26141b1772da641833a4daf5810469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="valueSource")
    def value_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueSource"))

    @value_source.setter
    def value_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e901bb925bf7e5ca01d5c51787d992a2e6a5128dd7852c37b8845bee21ff323f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueSource", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219de553e5a780296af83976c2368addd7f89cbbd030fae593a547d2b6caf937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValue")
    def variable_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableValue"))

    @variable_value.setter
    def variable_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e2cc7dd344ea7e268c76aed81abc94b08e4a445247d78685923106293a06f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5f69646003eada7e2e91e9a008eca4ff3ac8951511d27d469b0b667fff45dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "status": "status",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status DataAkamaiPropertyRulesBuilder#status}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f456aedd51668dd0b52f00ade2619acf0a199c6544eee88df238886f5594530)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument status", value=status, expected_type=type_hints["status"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if status is not None:
            self._values["status"] = status
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status DataAkamaiPropertyRulesBuilder#status}
        '''
        result = self._values.get("status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutrOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutrOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72b4ba11b1b901cd0a8c67f05ae41aeb398b390aa961a1633d5dcda301531928)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStatus")
    def reset_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatus", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="statusInput")
    def status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1838683ab7389595847c44bb06a0f00ac23cefb4a7e564f286a5e937bbf4451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="status")
    def status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "status"))

    @status.setter
    def status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191574813fbc61d08c9134f6d53ed997608e8af4e0cf272f5bc45a6cf49582ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "status", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e7a2b906f1b3f8bed5c22385e41a9892b82cf132dd76e147d3ff8f3fca6718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01838d40bfeceba4f56b827bc80f528d681720baf971bf22cf32e819561b70f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e799733c608836e8d44c7a760df6c97a96a1c380cddcbfa731c158cad82c2aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode",
    jsii_struct_bases=[],
    name_mapping={
        "error_type": "errorType",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode:
    def __init__(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5fd96ca75c91aea3c3f185c3f0f88b199e4ed52fef28009bb7cd67f5e46b3a)
            check_type(argname="argument error_type", value=error_type, expected_type=type_hints["error_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if error_type is not None:
            self._values["error_type"] = error_type
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def error_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        '''
        result = self._values.get("error_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c5fea6e0edc8f4720e6f506a85ec3c468bf8c6a9ff221576d48110e694b940)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetErrorType")
    def reset_error_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetErrorType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="errorTypeInput")
    def error_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "errorTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="errorType")
    def error_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "errorType"))

    @error_type.setter
    def error_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b513e4a9160beb79733287541b01b0c6bef7ed276e2a74e09b01461796c49d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "errorType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a5a35c43dd9c1cfa2be584c697c320c24340f291b56d6dab5697fe9089d785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a7071190f2e3fea32fab2af17b1fadf32b3805a42a25f6452fd2033ba987b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a23b3f9786cf673a8ed4ab3de9db3726747c9eb5762040ea5e49419438053400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee207b0aefef915e3d5c8cda0f4653c78813f7b265e31b6d2ac79a0027149196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d730e14a57ad1418beac0a2b2019ff46190373c76c2dd40b85cfc443dda765f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "nossmap": "nossmap",
        "ssmap": "ssmap",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(ssmap, dict):
            ssmap = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap(**ssmap)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce983dc9bf221aae5d0db75ca44bb8fea70fdfc6916cbf97e3c6f6e2f2ac321)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nossmap", value=nossmap, expected_type=type_hints["nossmap"])
            check_type(argname="argument ssmap", value=ssmap, expected_type=type_hints["ssmap"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if nossmap is not None:
            self._values["nossmap"] = nossmap
        if ssmap is not None:
            self._values["ssmap"] = ssmap
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nossmap(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        '''
        result = self._values.get("nossmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ssmap(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap"]:
        '''ssmap block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        '''
        result = self._values.get("ssmap")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c0a5138ac754dbe3ed4dea910c4bef7e7dc0b71a2d92da25a27a8532422cf6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putSsmap")
    def put_ssmap(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap(
            china_cdn_map=china_cdn_map,
            has_mixed_hosts=has_mixed_hosts,
            name=name,
            src=src,
            srmap=srmap,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putSsmap", [value_]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNossmap")
    def reset_nossmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNossmap", []))

    @jsii.member(jsii_name="resetSsmap")
    def reset_ssmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSsmap", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="ssmap")
    def ssmap(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmapOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmapOutputReference", jsii.get(self, "ssmap"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nossmapInput")
    def nossmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nossmapInput"))

    @builtins.property
    @jsii.member(jsii_name="ssmapInput")
    def ssmap_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap"], jsii.get(self, "ssmapInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__799caf2072a5f43474c995964963a5fa961c89f017970cfcc63b8fad22b19906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nossmap")
    def nossmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nossmap"))

    @nossmap.setter
    def nossmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f818a4fd3eaa2eb8319923c935e4bea3fb27a114d7fabc79dc01925569c00485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nossmap", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be7aef17c7b3e12807c8afda07fea8bf6913f5e41974310097f348585482abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d2e35b4492a9f031ea7176acfa71355b6bb9038e3a911ab6cccc915d0c12e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b18463b4b23f9788a73a06c0e89cecc05ebe4645bd157f1373226473b8be2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap",
    jsii_struct_bases=[],
    name_mapping={
        "china_cdn_map": "chinaCdnMap",
        "has_mixed_hosts": "hasMixedHosts",
        "name": "name",
        "src": "src",
        "srmap": "srmap",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap:
    def __init__(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e104d091e33591cb8cf2c241bd5a3206261555415227c3bad5debf2511cf97fb)
            check_type(argname="argument china_cdn_map", value=china_cdn_map, expected_type=type_hints["china_cdn_map"])
            check_type(argname="argument has_mixed_hosts", value=has_mixed_hosts, expected_type=type_hints["has_mixed_hosts"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument src", value=src, expected_type=type_hints["src"])
            check_type(argname="argument srmap", value=srmap, expected_type=type_hints["srmap"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if china_cdn_map is not None:
            self._values["china_cdn_map"] = china_cdn_map
        if has_mixed_hosts is not None:
            self._values["has_mixed_hosts"] = has_mixed_hosts
        if name is not None:
            self._values["name"] = name
        if src is not None:
            self._values["src"] = src
        if srmap is not None:
            self._values["srmap"] = srmap
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def china_cdn_map(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.'''
        result = self._values.get("china_cdn_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def has_mixed_hosts(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.'''
        result = self._values.get("has_mixed_hosts")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def src(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.'''
        result = self._values.get("src")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def srmap(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.'''
        result = self._values.get("srmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd7b3ea16260c9b70c49d66738eda08082581322bb5e4df1ec0f7af41ccd61b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetChinaCdnMap")
    def reset_china_cdn_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnMap", []))

    @jsii.member(jsii_name="resetHasMixedHosts")
    def reset_has_mixed_hosts(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHasMixedHosts", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetSrc")
    def reset_src(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrc", []))

    @jsii.member(jsii_name="resetSrmap")
    def reset_srmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrmap", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMapInput")
    def china_cdn_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chinaCdnMapInput"))

    @builtins.property
    @jsii.member(jsii_name="hasMixedHostsInput")
    def has_mixed_hosts_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hasMixedHostsInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="srcInput")
    def src_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srcInput"))

    @builtins.property
    @jsii.member(jsii_name="srmapInput")
    def srmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srmapInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMap")
    def china_cdn_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chinaCdnMap"))

    @china_cdn_map.setter
    def china_cdn_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc557c264e80e419923a90675dde1135aae5ea4fe1e4eca5e9722253f1dcdfef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chinaCdnMap", value)

    @builtins.property
    @jsii.member(jsii_name="hasMixedHosts")
    def has_mixed_hosts(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hasMixedHosts"))

    @has_mixed_hosts.setter
    def has_mixed_hosts(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72361bf4de906dc93f852a0179e9cde8eb214f718422b1bc045892c92e4e1f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hasMixedHosts", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949987ce34c1f5e75d347345f4784271390c2133d7d83174e41b70c231c6a5bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="src")
    def src(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "src"))

    @src.setter
    def src(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6131f4adbcaff0ddf7379dc8c2f98ee0bf508dbfdf041dc4346c9daae5bb7652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "src", value)

    @builtins.property
    @jsii.member(jsii_name="srmap")
    def srmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srmap"))

    @srmap.setter
    def srmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa5432b304cfeca5807fc025edc3ed512bf45be4066fcea8977e8e93ab8febe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srmap", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb00469d490fd4eacfe7efac4c2c364ea1fa2a94c1fdad6c8cd8f6e1c206769b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5417e207d87f666dbbd9e0a4653975334ab74b1b48632224e40ba90bcdeaa3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration",
    jsii_struct_bases=[],
    name_mapping={
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_https_upgrade": "allowHttpsUpgrade",
        "cache_sharing_duration": "cacheSharingDuration",
        "cache_sharing_start_time": "cacheSharingStartTime",
        "enabled": "enabled",
        "is_certificate_sni_only": "isCertificateSniOnly",
        "is_tiered_distribution_used": "isTieredDistributionUsed",
        "locked": "locked",
        "migration_duration": "migrationDuration",
        "migration_from": "migrationFrom",
        "migration_start_time": "migrationStartTime",
        "td_location": "tdLocation",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration:
    def __init__(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c58b784e742aa7dbb36097ed2162f226b6b042efdd056318db258e2b16e090)
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_https_upgrade", value=allow_https_upgrade, expected_type=type_hints["allow_https_upgrade"])
            check_type(argname="argument cache_sharing_duration", value=cache_sharing_duration, expected_type=type_hints["cache_sharing_duration"])
            check_type(argname="argument cache_sharing_start_time", value=cache_sharing_start_time, expected_type=type_hints["cache_sharing_start_time"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_certificate_sni_only", value=is_certificate_sni_only, expected_type=type_hints["is_certificate_sni_only"])
            check_type(argname="argument is_tiered_distribution_used", value=is_tiered_distribution_used, expected_type=type_hints["is_tiered_distribution_used"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument migration_duration", value=migration_duration, expected_type=type_hints["migration_duration"])
            check_type(argname="argument migration_from", value=migration_from, expected_type=type_hints["migration_from"])
            check_type(argname="argument migration_start_time", value=migration_start_time, expected_type=type_hints["migration_start_time"])
            check_type(argname="argument td_location", value=td_location, expected_type=type_hints["td_location"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_https_upgrade is not None:
            self._values["allow_https_upgrade"] = allow_https_upgrade
        if cache_sharing_duration is not None:
            self._values["cache_sharing_duration"] = cache_sharing_duration
        if cache_sharing_start_time is not None:
            self._values["cache_sharing_start_time"] = cache_sharing_start_time
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_certificate_sni_only is not None:
            self._values["is_certificate_sni_only"] = is_certificate_sni_only
        if is_tiered_distribution_used is not None:
            self._values["is_tiered_distribution_used"] = is_tiered_distribution_used
        if locked is not None:
            self._values["locked"] = locked
        if migration_duration is not None:
            self._values["migration_duration"] = migration_duration
        if migration_from is not None:
            self._values["migration_from"] = migration_from
        if migration_start_time is not None:
            self._values["migration_start_time"] = migration_start_time
        if td_location is not None:
            self._values["td_location"] = td_location
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allow temporary downgrade of HTTPS traffic to HTTP.

        This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_https_upgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows temporary upgrade of HTTP traffic to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        '''
        result = self._values.get("allow_https_upgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_sharing_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number cache sharing days.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        '''
        result = self._values.get("cache_sharing_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cache_sharing_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start cache sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        '''
        result = self._values.get("cache_sharing_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows migration to Standard TLS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_sni_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether your new certificate is SNI-only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        '''
        result = self._values.get("is_certificate_sni_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_tiered_distribution_used(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to align traffic to various ``tieredDistribution`` areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        '''
        result = self._values.get("is_tiered_distribution_used")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of days to migrate the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        '''
        result = self._values.get("migration_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def migration_from(self) -> typing.Optional[builtins.str]:
        '''What kind of traffic you're migrating from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        '''
        result = self._values.get("migration_from")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        '''
        result = self._values.get("migration_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def td_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``tieredDistribution`` location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        '''
        result = self._values.get("td_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4468d6f153f99e8aa9a9bb0a660a56c37e4cd5c1e6d2dce10c5a442dc227c9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowHttpsUpgrade")
    def reset_allow_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsUpgrade", []))

    @jsii.member(jsii_name="resetCacheSharingDuration")
    def reset_cache_sharing_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingDuration", []))

    @jsii.member(jsii_name="resetCacheSharingStartTime")
    def reset_cache_sharing_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingStartTime", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsCertificateSniOnly")
    def reset_is_certificate_sni_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateSniOnly", []))

    @jsii.member(jsii_name="resetIsTieredDistributionUsed")
    def reset_is_tiered_distribution_used(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsTieredDistributionUsed", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMigrationDuration")
    def reset_migration_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationDuration", []))

    @jsii.member(jsii_name="resetMigrationFrom")
    def reset_migration_from(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationFrom", []))

    @jsii.member(jsii_name="resetMigrationStartTime")
    def reset_migration_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartTime", []))

    @jsii.member(jsii_name="resetTdLocation")
    def reset_td_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTdLocation", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgradeInput")
    def allow_https_upgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDurationInput")
    def cache_sharing_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cacheSharingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTimeInput")
    def cache_sharing_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheSharingStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnlyInput")
    def is_certificate_sni_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificateSniOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsedInput")
    def is_tiered_distribution_used_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isTieredDistributionUsedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationDurationInput")
    def migration_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "migrationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationFromInput")
    def migration_from_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationFromInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartTimeInput")
    def migration_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="tdLocationInput")
    def td_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tdLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsDowngrade"))

    @allow_https_downgrade.setter
    def allow_https_downgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc98e36003efd4500e24b8f2ed5c6ea4a0b46c28def53271d32ed9bae804afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsDowngrade", value)

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgrade")
    def allow_https_upgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsUpgrade"))

    @allow_https_upgrade.setter
    def allow_https_upgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87959ad2b8a859ebbf4f1920b7116a03dbff2c247a6e4484573688cbda0c07d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsUpgrade", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDuration")
    def cache_sharing_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cacheSharingDuration"))

    @cache_sharing_duration.setter
    def cache_sharing_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b94ee7955cecc60100cc2da99fed3be0448cc516acddab8b9d80a5c1281c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTime")
    def cache_sharing_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheSharingStartTime"))

    @cache_sharing_start_time.setter
    def cache_sharing_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b1c27030a2436888358b266db23c5f590a6a18a066dd4f7922c778d9f6d862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f28ab1083b1ebb442e1fe495be272c02d7fe6793015b36787ce35c1390b351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnly")
    def is_certificate_sni_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificateSniOnly"))

    @is_certificate_sni_only.setter
    def is_certificate_sni_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0dc9be37b25e34653357d091269f9a798393150ad6bd812d7acc87c4600863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateSniOnly", value)

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsed")
    def is_tiered_distribution_used(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isTieredDistributionUsed"))

    @is_tiered_distribution_used.setter
    def is_tiered_distribution_used(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0c59c69d27a3dfb3bea60e700c1e5e83d22dedd88014a5e285978a0dce7d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isTieredDistributionUsed", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c82491f2488ef13e47015b86f9a49940d20a40192004f7d1e2b72f3faa532443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="migrationDuration")
    def migration_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "migrationDuration"))

    @migration_duration.setter
    def migration_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce018e7ae1b0f28f3d238a00c0666a810b5db10b24ee3590631b832e04a09f33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="migrationFrom")
    def migration_from(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationFrom"))

    @migration_from.setter
    def migration_from(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e82e1ba4c1219f66ba6fc9f6097ff1eda94940a2299f9d443ec8d9c34ae0c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationFrom", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartTime")
    def migration_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartTime"))

    @migration_start_time.setter
    def migration_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c83c03d0a684c52936a6fafa30d1141ae7a8f825cba0b30cd7397bd00f9f98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="tdLocation")
    def td_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tdLocation"))

    @td_location.setter
    def td_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc9e3db8f66039d806f95fc014b6a127c08a1c750b183768d5d4925461914be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tdLocation", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0250cfeee3a5826531effed96ea482f523f6671df4751e2411fbe7019e1f415d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a248bbc34fe2a2ab77f601351c5198a936a1d455776fabf132e26e4a80ba1645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d414c45b4d9e4e869ca2412ad6120fb38383d7b3b9639a1d8248f27ec2f4493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "info": "info",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride:
    def __init__(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa07b71328e05d917c6363e8baf33bb1394ce81078bcef27e8f000b7f4fb4f6e)
            check_type(argname="argument info", value=info, expected_type=type_hints["info"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if info is not None:
            self._values["info"] = info
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def info(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        '''
        result = self._values.get("info")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f263813d3e241f93c758530ddb6e6f6dfe75f8da8f6b0b6d33f3e20f64490c92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetInfo")
    def reset_info(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInfo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="infoInput")
    def info_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "infoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="info")
    def info(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "info"))

    @info.setter
    def info(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6618a9240763c128df52a228459562a82b6aae876aa07b646067b849a72a902d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "info", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2340644b0a4712c5e96254c03ba4b647f36b25a7013219152d3317189177fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af955be8e7b42a6bc040ea15e30be1888bcdc52515bebe2232cf4b2a548a52b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9895b15981cdf6a122bd27bae9adc8af5f151bcfe11ab5cd2b1935853d8c8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da86f2a250b2a5c926ba9756a10f34924f3f07941eb6d64d741220d72e6b5eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "strict_mode": "strictMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "valid_mode": "validMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce08b6d0f9f4b9cddd4da7258c9f88383e2e4b20b90c9107b3885c488f2e071b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict_mode", value=strict_mode, expected_type=type_hints["strict_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument valid_mode", value=valid_mode, expected_type=type_hints["valid_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if strict_mode is not None:
            self._values["strict_mode"] = strict_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if valid_mode is not None:
            self._values["valid_mode"] = valid_mode

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF.

        When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        '''
        result = self._values.get("strict_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def valid_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines.

        When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        result = self._values.get("valid_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b59d57d85b41c4180c4ab68db5dc8b1579a1355b0bd2670ca13e8e77542713ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrictMode")
    def reset_strict_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValidMode")
    def reset_valid_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidMode", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictModeInput")
    def strict_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="validModeInput")
    def valid_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "validModeInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e2f4fcb9a8d89e6841599015412a135ea3ee59435733307a693243d59b5a7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strictMode")
    def strict_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strictMode"))

    @strict_mode.setter
    def strict_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5445236ef1c737dd5491231e6f657d422da873437883fd4bd47d434a112bcdb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strictMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124de965ecf2a511a38059ea97b3c61350621ff0836844c877f84a5b595d9cbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c93dabbd1bdb679d75e3978b00653a1af7d551752a9ace78bd467e931857b46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="validMode")
    def valid_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "validMode"))

    @valid_mode.setter
    def valid_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e588fc15e64354251df291ddaf970c7f7f5a7adf43c84be4b7232541c7557b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5412af13b5a466f8d7239e7bc96e90553a230d6ef17b7cb07a64660949b2b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer",
    jsii_struct_bases=[],
    name_mapping={
        "access_control": "accessControl",
        "cache_key": "cacheKey",
        "caching": "caching",
        "content_compressor": "contentCompressor",
        "dynamic_web_content": "dynamicWebContent",
        "enabled": "enabled",
        "geo_location": "geoLocation",
        "ip": "ip",
        "large_file_delivery": "largeFileDelivery",
        "live_video_delivery": "liveVideoDelivery",
        "locked": "locked",
        "modify_path": "modifyPath",
        "on_demand_video_delivery": "onDemandVideoDelivery",
        "origin": "origin",
        "partner_domain_suffix": "partnerDomainSuffix",
        "referrer": "referrer",
        "refresh_content": "refreshContent",
        "site_failover": "siteFailover",
        "template_uuid": "templateUuid",
        "token_authorization": "tokenAuthorization",
        "uuid": "uuid",
        "web_application_firewall": "webApplicationFirewall",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer:
    def __init__(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0cca92686adf692fee35dc775a48c6c745a9db1cb026689f8fc12a5e1f27f8)
            check_type(argname="argument access_control", value=access_control, expected_type=type_hints["access_control"])
            check_type(argname="argument cache_key", value=cache_key, expected_type=type_hints["cache_key"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument content_compressor", value=content_compressor, expected_type=type_hints["content_compressor"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument geo_location", value=geo_location, expected_type=type_hints["geo_location"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument large_file_delivery", value=large_file_delivery, expected_type=type_hints["large_file_delivery"])
            check_type(argname="argument live_video_delivery", value=live_video_delivery, expected_type=type_hints["live_video_delivery"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_path", value=modify_path, expected_type=type_hints["modify_path"])
            check_type(argname="argument on_demand_video_delivery", value=on_demand_video_delivery, expected_type=type_hints["on_demand_video_delivery"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument partner_domain_suffix", value=partner_domain_suffix, expected_type=type_hints["partner_domain_suffix"])
            check_type(argname="argument referrer", value=referrer, expected_type=type_hints["referrer"])
            check_type(argname="argument refresh_content", value=refresh_content, expected_type=type_hints["refresh_content"])
            check_type(argname="argument site_failover", value=site_failover, expected_type=type_hints["site_failover"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_control is not None:
            self._values["access_control"] = access_control
        if cache_key is not None:
            self._values["cache_key"] = cache_key
        if caching is not None:
            self._values["caching"] = caching
        if content_compressor is not None:
            self._values["content_compressor"] = content_compressor
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if geo_location is not None:
            self._values["geo_location"] = geo_location
        if ip is not None:
            self._values["ip"] = ip
        if large_file_delivery is not None:
            self._values["large_file_delivery"] = large_file_delivery
        if live_video_delivery is not None:
            self._values["live_video_delivery"] = live_video_delivery
        if locked is not None:
            self._values["locked"] = locked
        if modify_path is not None:
            self._values["modify_path"] = modify_path
        if on_demand_video_delivery is not None:
            self._values["on_demand_video_delivery"] = on_demand_video_delivery
        if origin is not None:
            self._values["origin"] = origin
        if partner_domain_suffix is not None:
            self._values["partner_domain_suffix"] = partner_domain_suffix
        if referrer is not None:
            self._values["referrer"] = referrer
        if refresh_content is not None:
            self._values["refresh_content"] = refresh_content
        if site_failover is not None:
            self._values["site_failover"] = site_failover
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if uuid is not None:
            self._values["uuid"] = uuid
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall

    @builtins.property
    def access_control(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        '''
        result = self._values.get("access_control")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set which query parameters are included in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        '''
        result = self._values.get("cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies content caching rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_compressor(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows compression of subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        '''
        result = self._values.get("content_compressor")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Cloud Embed to dynamically modify your subcustomers' content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_location(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' location-based whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        '''
        result = self._values.get("geo_location")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' IP whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def large_file_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables large file delivery for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        '''
        result = self._values.get("large_file_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def live_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.'''
        result = self._values.get("live_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies a subcustomer's request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        '''
        result = self._values.get("modify_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def on_demand_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables delivery of media assets to subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        '''
        result = self._values.get("on_demand_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign origin hostnames for customers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner_domain_suffix(self) -> typing.Optional[builtins.str]:
        '''This specifies the appropriate domain suffix, which you should typically match with your property hostname.

        It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        '''
        result = self._values.get("partner_domain_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' referrer whitelists or blacklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        '''
        result = self._values.get("referrer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to reschedule when content validates for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        '''
        result = self._values.get("refresh_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def site_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure unique failover sites for each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        '''
        result = self._values.get("site_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content.

        Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic.

        Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791d21cd879b4889c1de79028dd7abf4931a599c7210c7f291438ed87b567c9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessControl")
    def reset_access_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessControl", []))

    @jsii.member(jsii_name="resetCacheKey")
    def reset_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKey", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetContentCompressor")
    def reset_content_compressor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCompressor", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGeoLocation")
    def reset_geo_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoLocation", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLargeFileDelivery")
    def reset_large_file_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileDelivery", []))

    @jsii.member(jsii_name="resetLiveVideoDelivery")
    def reset_live_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveVideoDelivery", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyPath")
    def reset_modify_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyPath", []))

    @jsii.member(jsii_name="resetOnDemandVideoDelivery")
    def reset_on_demand_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOnDemandVideoDelivery", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetPartnerDomainSuffix")
    def reset_partner_domain_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartnerDomainSuffix", []))

    @jsii.member(jsii_name="resetReferrer")
    def reset_referrer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrer", []))

    @jsii.member(jsii_name="resetRefreshContent")
    def reset_refresh_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshContent", []))

    @jsii.member(jsii_name="resetSiteFailover")
    def reset_site_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteFailover", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @builtins.property
    @jsii.member(jsii_name="accessControlInput")
    def access_control_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessControlInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyInput")
    def cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCompressorInput")
    def content_compressor_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCompressorInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="geoLocationInput")
    def geo_location_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "geoLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileDeliveryInput")
    def large_file_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "largeFileDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="liveVideoDeliveryInput")
    def live_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "liveVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyPathInput")
    def modify_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyPathInput"))

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDeliveryInput")
    def on_demand_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "onDemandVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffixInput")
    def partner_domain_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerDomainSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerInput")
    def referrer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "referrerInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshContentInput")
    def refresh_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "refreshContentInput"))

    @builtins.property
    @jsii.member(jsii_name="siteFailoverInput")
    def site_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "siteFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="accessControl")
    def access_control(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessControl"))

    @access_control.setter
    def access_control(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032e341f54b5c937bdf829dd29f996edea68c67e78516491be04b91baced1d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessControl", value)

    @builtins.property
    @jsii.member(jsii_name="cacheKey")
    def cache_key(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheKey"))

    @cache_key.setter
    def cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6955a9922cc096a6952b176155175f1de2219b9665192a0728a3a993f4dfa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caching"))

    @caching.setter
    def caching(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ae290bd16bd6a5dcfd3af32606846f27bf0f803d5437787bde3785db1b085d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caching", value)

    @builtins.property
    @jsii.member(jsii_name="contentCompressor")
    def content_compressor(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCompressor"))

    @content_compressor.setter
    def content_compressor(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75f5ae7bb27a427e20c2413e520261b228222e17b0cf4dac72a8947315f10940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCompressor", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicWebContent"))

    @dynamic_web_content.setter
    def dynamic_web_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b35814da6527239d87c5650a9ce818b4dde084906487b9734cf7340c32bc1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicWebContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8a78267cc15244ec32df71686b89dda063ae21cab82b724e3b4f3b33efc1f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="geoLocation")
    def geo_location(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "geoLocation"))

    @geo_location.setter
    def geo_location(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d23f3e9e52e8b114809b07a9edde9133d91443e38900052856032e72fe64ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoLocation", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a08eabae3df592273d0c44358051f787e6d04a6c14c8b1bc2f9eebd98cab255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="largeFileDelivery")
    def large_file_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "largeFileDelivery"))

    @large_file_delivery.setter
    def large_file_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0eea1a2221e35224920fe0c0c121d09ba62aeda412d333d824953a168f5de94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "largeFileDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="liveVideoDelivery")
    def live_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "liveVideoDelivery"))

    @live_video_delivery.setter
    def live_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c14e3cf3f1c1cc14cf88d39f3c877e159eaf4ad29f14391f51251332c62517d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00fba26efe3a66974fbb6e85e09c09c1383b995148b8661b0a8380c5f18b2982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyPath")
    def modify_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyPath"))

    @modify_path.setter
    def modify_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__165f67282643e2dab8f2494d84052d2bfedb60f13499ab1126a0f31a1500408d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyPath", value)

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDelivery")
    def on_demand_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "onDemandVideoDelivery"))

    @on_demand_video_delivery.setter
    def on_demand_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37f263a72e2675d5d32e81099a7cff48678b995a5ae7ffa5de79926f40a8d5dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "onDemandVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "origin"))

    @origin.setter
    def origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edaa4fbf5bc24c52baa6f33a15a2ad9a9957aec9f071845f6ab2de85479bc279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origin", value)

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffix")
    def partner_domain_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partnerDomainSuffix"))

    @partner_domain_suffix.setter
    def partner_domain_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2808d4c6a397e0350b3db17db6f72d766f5a96bfc5cac4982e59dde07935aa2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partnerDomainSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="referrer")
    def referrer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "referrer"))

    @referrer.setter
    def referrer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8551b657c2b4608ea20bf705b496d0aced035b565791502fc32d7db3304331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrer", value)

    @builtins.property
    @jsii.member(jsii_name="refreshContent")
    def refresh_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "refreshContent"))

    @refresh_content.setter
    def refresh_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27cff05da4235d97be8e32de2cbd516da2f77a9a689b17f46373372557a412f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshContent", value)

    @builtins.property
    @jsii.member(jsii_name="siteFailover")
    def site_failover(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "siteFailover"))

    @site_failover.setter
    def site_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8605a198d48a7bde4f38daa95d005a553390599ff018226a7fc48e667a4e9ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "siteFailover", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50a5db5b7e2dcbea9fb965e14284f097975dab0edd3cc95914a36c85acc953c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenAuthorization"))

    @token_authorization.setter
    def token_authorization(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74e64e46a587affec5fc7915b8924d694f0bc2d943adf8ac1fe9f8f230bbcbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthorization", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e71c880a7a1aa503bbb20996722bb1b4b33dd3a5a1ab5ccb0dfbdc996029f78d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "webApplicationFirewall"))

    @web_application_firewall.setter
    def web_application_firewall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11100347e588acdf0ffa206840af13d0ee7ccf36ba8ec60c54951215ca1fc91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "webApplicationFirewall", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1482ba7bb84cc4777d766f4d67846d9a7e0adc508b25fe79e5111df4258348b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute",
    jsii_struct_bases=[],
    name_mapping={
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "custom_map": "customMap",
        "custom_stat_key": "customStatKey",
        "enable_custom_key": "enableCustomKey",
        "enabled": "enabled",
        "force_ssl_forward": "forceSslForward",
        "locked": "locked",
        "race_stat_ttl": "raceStatTtl",
        "sr_download_link_title": "srDownloadLinkTitle",
        "template_uuid": "templateUuid",
        "test_object_url": "testObjectUrl",
        "to_host": "toHost",
        "to_host_status": "toHostStatus",
        "type": "type",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute:
    def __init__(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2dc1a1e6c36bb06dbc183592c920ff41c2c992948fd61e21aa23ad3b77c6fab)
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument custom_map", value=custom_map, expected_type=type_hints["custom_map"])
            check_type(argname="argument custom_stat_key", value=custom_stat_key, expected_type=type_hints["custom_stat_key"])
            check_type(argname="argument enable_custom_key", value=enable_custom_key, expected_type=type_hints["enable_custom_key"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_ssl_forward", value=force_ssl_forward, expected_type=type_hints["force_ssl_forward"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument race_stat_ttl", value=race_stat_ttl, expected_type=type_hints["race_stat_ttl"])
            check_type(argname="argument sr_download_link_title", value=sr_download_link_title, expected_type=type_hints["sr_download_link_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument test_object_url", value=test_object_url, expected_type=type_hints["test_object_url"])
            check_type(argname="argument to_host", value=to_host, expected_type=type_hints["to_host"])
            check_type(argname="argument to_host_status", value=to_host_status, expected_type=type_hints["to_host_status"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if custom_map is not None:
            self._values["custom_map"] = custom_map
        if custom_stat_key is not None:
            self._values["custom_stat_key"] = custom_stat_key
        if enable_custom_key is not None:
            self._values["enable_custom_key"] = enable_custom_key
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_ssl_forward is not None:
            self._values["force_ssl_forward"] = force_ssl_forward
        if locked is not None:
            self._values["locked"] = locked
        if race_stat_ttl is not None:
            self._values["race_stat_ttl"] = race_stat_ttl
        if sr_download_link_title is not None:
            self._values["sr_download_link_title"] = sr_download_link_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if test_object_url is not None:
            self._values["test_object_url"] = test_object_url
        if to_host is not None:
            self._values["to_host"] = to_host
        if to_host_status is not None:
            self._values["to_host_status"] = to_host_status
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map(self) -> typing.Optional[builtins.str]:
        '''If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        '''
        result = self._values.get("custom_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_stat_key(self) -> typing.Optional[builtins.str]:
        '''This specifies a hostname under which to cache race results.

        This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        '''
        result = self._values.get("custom_stat_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_custom_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        '''
        result = self._values.get("enable_custom_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the SureRoute behavior, to optimize delivery of non-cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_ssl_forward(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        '''
        result = self._values.get("force_ssl_forward")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def race_stat_ttl(self) -> typing.Optional[builtins.str]:
        '''Specifies the time-to-live to preserve SureRoute race results, typically ``30m``.

        If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        '''
        result = self._values.get("race_stat_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sr_download_link_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        '''
        result = self._values.get("sr_download_link_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def test_object_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the path and filename for your origin's test object to use in races to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        '''
        result = self._values.get("test_object_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host(self) -> typing.Optional[builtins.str]:
        '''If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        '''
        result = self._values.get("to_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host_status(self) -> typing.Optional[builtins.str]:
        '''Specifies which hostname to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        '''
        result = self._values.get("to_host_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of edge servers used to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRouteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRouteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7665df5442b384da095e6bd1743f46a80affba65bd49a0d930c94d5f81216bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCustomMap")
    def reset_custom_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMap", []))

    @jsii.member(jsii_name="resetCustomStatKey")
    def reset_custom_stat_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatKey", []))

    @jsii.member(jsii_name="resetEnableCustomKey")
    def reset_enable_custom_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCustomKey", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceSslForward")
    def reset_force_ssl_forward(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceSslForward", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRaceStatTtl")
    def reset_race_stat_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRaceStatTtl", []))

    @jsii.member(jsii_name="resetSrDownloadLinkTitle")
    def reset_sr_download_link_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrDownloadLinkTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTestObjectUrl")
    def reset_test_object_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTestObjectUrl", []))

    @jsii.member(jsii_name="resetToHost")
    def reset_to_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHost", []))

    @jsii.member(jsii_name="resetToHostStatus")
    def reset_to_host_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHostStatus", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapInput")
    def custom_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatKeyInput")
    def custom_stat_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCustomKeyInput")
    def enable_custom_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCustomKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceSslForwardInput")
    def force_ssl_forward_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceSslForwardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="raceStatTtlInput")
    def race_stat_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "raceStatTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitleInput")
    def sr_download_link_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srDownloadLinkTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="testObjectUrlInput")
    def test_object_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "testObjectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostInput")
    def to_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostStatusInput")
    def to_host_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4f49675085dffcd45ae50f969bd6d47692219347d2a327ecaa5d624f96b733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="customMap")
    def custom_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMap"))

    @custom_map.setter
    def custom_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac6c2145c154ac7e3e6f8d52a6a3713e5a91bdd9c97b6fc6c79fb2779033ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMap", value)

    @builtins.property
    @jsii.member(jsii_name="customStatKey")
    def custom_stat_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatKey"))

    @custom_stat_key.setter
    def custom_stat_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a819796dfc77a9d11d62068b97b21b7bb733bc5843c68bdda1388ae52237768d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatKey", value)

    @builtins.property
    @jsii.member(jsii_name="enableCustomKey")
    def enable_custom_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCustomKey"))

    @enable_custom_key.setter
    def enable_custom_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5183010645da7e76a43684db2be3129dd0184ff1ff708bb357de6daf525a50a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCustomKey", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__142d956ea2569a58c2a71a63735fdbdf21c977898f98fb6af43251b241cb912e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceSslForward")
    def force_ssl_forward(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceSslForward"))

    @force_ssl_forward.setter
    def force_ssl_forward(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03dc46b5f9c16b07770a5c10b8444e187e84a6f24423e692c898551da3633278)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceSslForward", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208ac108140456790809ae5916a9bfdfce0a3a0d04af229a4b69eaf3b7c3f9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="raceStatTtl")
    def race_stat_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "raceStatTtl"))

    @race_stat_ttl.setter
    def race_stat_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a54b58b8acb6f974b6bba4db411f716ef0fa0447840853c41e774469db57acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "raceStatTtl", value)

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitle")
    def sr_download_link_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srDownloadLinkTitle"))

    @sr_download_link_title.setter
    def sr_download_link_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1b8607c0cca896e8581cdfb80e00df782b60dff28d22931046bb15a7bafe0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srDownloadLinkTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4f602347640d1fded4b5516d85bf74c7e86162dca26a9a99df3f33d6534cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="testObjectUrl")
    def test_object_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "testObjectUrl"))

    @test_object_url.setter
    def test_object_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8027cc403145179065de80e035a265e10e370a43aa8f7e29cb8984f7dd14e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "testObjectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="toHost")
    def to_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHost"))

    @to_host.setter
    def to_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55af222a2b3fa42b34573e744e945eed1da54ccb4b58ac5d86e8afb5879c697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHost", value)

    @builtins.property
    @jsii.member(jsii_name="toHostStatus")
    def to_host_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHostStatus"))

    @to_host_status.setter
    def to_host_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d426fbef87c7edd338e5db4b3388891c5dca7a21fad6d2cbb6117e60df4364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHostStatus", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5885492a1a2574aaafc8392273e7048e714aec521f93cb1fc47f60db930c116b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c4c858a2d9d0d4a203206e24720fbefb4ad40efb435d75772bf3982c20c7c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78caef5819153877bac2cb82b06a0c6b00e6c6f3699b64725e2ce88b0be359dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904de1ee889416325e0bba6993d13a7a799a4bececf0801de1183cd5e5edba82)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d18e950b907d555aa109f39767f5226e4449a4824c79877e763e1f1e19ef12d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8180103b7676d9b052b1e0d05b00b76770c85206226fdf1883262b287c6e3e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560951252cfd03b46640102269d0cca3ebb91b071eb4c3075fcbd8f7cdbfbb07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1748eda2e12a3e718eb54c2d635a1699c3c2e73814d7a30ea36308ae7163d9f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1eeae55a027896d79f0bbc7babc732703913fe1ba0f1c95c458a0188df03abe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec92fd2b38b76379722ac2022ca1855eafe79e9eedc75309282e57da7103d819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "ibm_customer_id": "ibmCustomerId",
        "limit_to_dynamic": "limitToDynamic",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edf402ed297b4b4b78c05a5d584066a4434c90d7169f0da7a4b6a121bdf33eb5)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument ibm_customer_id", value=ibm_customer_id, expected_type=type_hints["ibm_customer_id"])
            check_type(argname="argument limit_to_dynamic", value=limit_to_dynamic, expected_type=type_hints["limit_to_dynamic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if ibm_customer_id is not None:
            self._values["ibm_customer_id"] = ibm_customer_id
        if limit_to_dynamic is not None:
            self._values["limit_to_dynamic"] = limit_to_dynamic
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ibm_customer_id(self) -> typing.Optional[jsii.Number]:
        '''The integer identifier for the IBM Tealeaf Connector account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        '''
        result = self._values.get("ibm_customer_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_to_dynamic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Limit traffic to dynamic, uncached (``No-Store``) content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        '''
        result = self._values.get("limit_to_dynamic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeafOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeafOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a8c25623285dbe937e68bacdc07be51a20dd472e20dcd5fa724a50e70809239)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIbmCustomerId")
    def reset_ibm_customer_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIbmCustomerId", []))

    @jsii.member(jsii_name="resetLimitToDynamic")
    def reset_limit_to_dynamic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitToDynamic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerIdInput")
    def ibm_customer_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ibmCustomerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="limitToDynamicInput")
    def limit_to_dynamic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "limitToDynamicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6678b79c56765f9891ab690e1110b432670e98540d7531fb8ced8b1520b8f1fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerId")
    def ibm_customer_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ibmCustomerId"))

    @ibm_customer_id.setter
    def ibm_customer_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21544eccf189266463d2be5092f9c38e53511ea9a79501b45d739ef65a73ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ibmCustomerId", value)

    @builtins.property
    @jsii.member(jsii_name="limitToDynamic")
    def limit_to_dynamic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "limitToDynamic"))

    @limit_to_dynamic.setter
    def limit_to_dynamic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1496cff20bb244e741db08ed3e1f15de23ee74733a4e3afa981ffec93b4884d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitToDynamic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1e429ff14b5414e3113ab230c01e7a7645f2c77a86a7f677d59440b053c7aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b1ee3db89e61953a034e6eee9fa4b24e00e4ba9d21ccccce094168bd8bb2d68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af38423c482ba8e869ba2161c594c27685762c5b9db4b941f6dcd3c6ffccc929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d37f0ca89a064323fd53c7c1178591a6ddbb7b1124273cdab3f835030f46af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c44ab6ba1db008de7b8041d7fa3f1d5ee9c24c8550621f4d50654832085ef03)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin.

        A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "allowall": "allowall",
        "enabled": "enabled",
        "locked": "locked",
        "method": "method",
        "policy": "policy",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced:
    def __init__(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82bf7c263c2383aaba9f6a02b195ca9f204a1245b97e670ce025f9e00cd3b42d)
            check_type(argname="argument allowall", value=allowall, expected_type=type_hints["allowall"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument method", value=method, expected_type=type_hints["method"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowall is not None:
            self._values["allowall"] = allowall
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if method is not None:
            self._values["method"] = method
        if policy is not None:
            self._values["policy"] = policy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allowall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.'''
        result = self._values.get("allowall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def method(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.'''
        result = self._values.get("method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.'''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe;

        ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ee3c4cacd73365ce07544d820750b9e2abe79112cdc0a6d7880d6da252322a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowall")
    def reset_allowall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowall", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethod")
    def reset_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethod", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowallInput")
    def allowall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowallInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodInput")
    def method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "methodInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowall")
    def allowall(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowall"))

    @allowall.setter
    def allowall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c9ff27a374e66eb80546c86ff09788221933ce49a355d517ce8dd324d6489d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowall", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b6a252243db89a518c0dfecd906a415d385433efb57e543459c782c9b0cd04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb6fc9b0020ac2b84bd8b7dd995bd4c6fa4aa57e1688395fdfd59ae553264f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="method")
    def method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "method"))

    @method.setter
    def method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75520ccc5ea4613749905256d8d933bd604cea472656827c474853398130bd93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "method", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67808d7594c0ae97ab677374f2967a59ac570b6794ca192fbd155249a5b65352)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607a43cb656b890bb2500ac273ba756f0339b461665dcb9b61ab7c5c953ca515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419a2bc78fae51e80410d46bfc6d7e3e26fceb46745ddf06092090883b82693d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3877089a432fd340446f0f67e57c568fac5f0f4ed9703baaf6f6ba34c187ded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1d9dad4d737a4c17cb6ab61e4d774c0048743af39f62c192525fcebe4c5f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization",
    jsii_struct_bases=[],
    name_mapping={
        "cloudwrapper_map_migration_title": "cloudwrapperMapMigrationTitle",
        "custom_map_enabled": "customMapEnabled",
        "custom_map_name": "customMapName",
        "hash_algorithm": "hashAlgorithm",
        "location": "location",
        "locked": "locked",
        "map_migration_enabled": "mapMigrationEnabled",
        "migration_end_date": "migrationEndDate",
        "migration_start_date": "migrationStartDate",
        "migration_within_cw_maps_enabled": "migrationWithinCwMapsEnabled",
        "serial_end": "serialEnd",
        "serial_start": "serialStart",
        "template_uuid": "templateUuid",
        "tier1_title": "tier1Title",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization:
    def __init__(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9b24ed3dbd8cdbe071b691f3d5f29b7ee4eda6faf44739ae1b6243a05fd893)
            check_type(argname="argument cloudwrapper_map_migration_title", value=cloudwrapper_map_migration_title, expected_type=type_hints["cloudwrapper_map_migration_title"])
            check_type(argname="argument custom_map_enabled", value=custom_map_enabled, expected_type=type_hints["custom_map_enabled"])
            check_type(argname="argument custom_map_name", value=custom_map_name, expected_type=type_hints["custom_map_name"])
            check_type(argname="argument hash_algorithm", value=hash_algorithm, expected_type=type_hints["hash_algorithm"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument map_migration_enabled", value=map_migration_enabled, expected_type=type_hints["map_migration_enabled"])
            check_type(argname="argument migration_end_date", value=migration_end_date, expected_type=type_hints["migration_end_date"])
            check_type(argname="argument migration_start_date", value=migration_start_date, expected_type=type_hints["migration_start_date"])
            check_type(argname="argument migration_within_cw_maps_enabled", value=migration_within_cw_maps_enabled, expected_type=type_hints["migration_within_cw_maps_enabled"])
            check_type(argname="argument serial_end", value=serial_end, expected_type=type_hints["serial_end"])
            check_type(argname="argument serial_start", value=serial_start, expected_type=type_hints["serial_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_title", value=tier1_title, expected_type=type_hints["tier1_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudwrapper_map_migration_title is not None:
            self._values["cloudwrapper_map_migration_title"] = cloudwrapper_map_migration_title
        if custom_map_enabled is not None:
            self._values["custom_map_enabled"] = custom_map_enabled
        if custom_map_name is not None:
            self._values["custom_map_name"] = custom_map_name
        if hash_algorithm is not None:
            self._values["hash_algorithm"] = hash_algorithm
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if map_migration_enabled is not None:
            self._values["map_migration_enabled"] = map_migration_enabled
        if migration_end_date is not None:
            self._values["migration_end_date"] = migration_end_date
        if migration_start_date is not None:
            self._values["migration_start_date"] = migration_start_date
        if migration_within_cw_maps_enabled is not None:
            self._values["migration_within_cw_maps_enabled"] = migration_within_cw_maps_enabled
        if serial_end is not None:
            self._values["serial_end"] = serial_end
        if serial_start is not None:
            self._values["serial_start"] = serial_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_title is not None:
            self._values["tier1_title"] = tier1_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudwrapper_map_migration_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        '''
        result = self._values.get("cloudwrapper_map_migration_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_map_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables custom maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        '''
        result = self._values.get("custom_map_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom map name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        '''
        result = self._values.get("custom_map_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        '''
        result = self._values.get("hash_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Location from which Cloud Wrapper migration is performed.

        User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def map_migration_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration of the custom map to Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        '''
        result = self._values.get("map_migration_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_end_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the map migration should end.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        '''
        result = self._values.get("migration_end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the map.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        '''
        result = self._values.get("migration_start_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration within Cloud Wrapper maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        '''
        result = self._values.get("migration_within_cw_maps_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_end(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial end value.

        Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        '''
        result = self._values.get("serial_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def serial_start(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial start value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        '''
        result = self._values.get("serial_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        '''
        result = self._values.get("tier1_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b18d2a7621fbbba9198000935ced9e08557c97a3eaa698da1c18df90dfbfd4fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudwrapperMapMigrationTitle")
    def reset_cloudwrapper_map_migration_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudwrapperMapMigrationTitle", []))

    @jsii.member(jsii_name="resetCustomMapEnabled")
    def reset_custom_map_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapEnabled", []))

    @jsii.member(jsii_name="resetCustomMapName")
    def reset_custom_map_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapName", []))

    @jsii.member(jsii_name="resetHashAlgorithm")
    def reset_hash_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashAlgorithm", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMapMigrationEnabled")
    def reset_map_migration_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMapMigrationEnabled", []))

    @jsii.member(jsii_name="resetMigrationEndDate")
    def reset_migration_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationEndDate", []))

    @jsii.member(jsii_name="resetMigrationStartDate")
    def reset_migration_start_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartDate", []))

    @jsii.member(jsii_name="resetMigrationWithinCwMapsEnabled")
    def reset_migration_within_cw_maps_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationWithinCwMapsEnabled", []))

    @jsii.member(jsii_name="resetSerialEnd")
    def reset_serial_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialEnd", []))

    @jsii.member(jsii_name="resetSerialStart")
    def reset_serial_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1Title")
    def reset_tier1_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1Title", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitleInput")
    def cloudwrapper_map_migration_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cloudwrapperMapMigrationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapEnabledInput")
    def custom_map_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customMapEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapNameInput")
    def custom_map_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithmInput")
    def hash_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabledInput")
    def map_migration_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mapMigrationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationEndDateInput")
    def migration_end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationEndDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartDateInput")
    def migration_start_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabledInput")
    def migration_within_cw_maps_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "migrationWithinCwMapsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="serialEndInput")
    def serial_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialEndInput"))

    @builtins.property
    @jsii.member(jsii_name="serialStartInput")
    def serial_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1TitleInput")
    def tier1_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1TitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitle")
    def cloudwrapper_map_migration_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cloudwrapperMapMigrationTitle"))

    @cloudwrapper_map_migration_title.setter
    def cloudwrapper_map_migration_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2f13d63c4b5ce16be1bdd53d2ca660dfde5786950b9cc536a935290073b22c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudwrapperMapMigrationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customMapEnabled")
    def custom_map_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customMapEnabled"))

    @custom_map_enabled.setter
    def custom_map_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2320ef210ec089b92ed7bd5efe965f4694a424c01646ec552f80a36b1c5f2ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customMapName")
    def custom_map_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMapName"))

    @custom_map_name.setter
    def custom_map_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618b6bca62448d7d4bc447741ce48065e67da412d2e466a56fbb6db5f07d8619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapName", value)

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithm")
    def hash_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashAlgorithm"))

    @hash_algorithm.setter
    def hash_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450e1af99a97f52db0751ef57dc2eaba659fc0bd35c470211a79194619a32f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a442042c81af02a8aed6518e6356b8554419b595f499b92f0e28f025f5932c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10da1cf5f17f619cf614d0fc3a3eaaaf97eacf35c76cc121f49481050aa5081b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabled")
    def map_migration_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mapMigrationEnabled"))

    @map_migration_enabled.setter
    def map_migration_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3aa73ae0b401699d2aabeef2e39aeec4a429fdb51cebaa0111ab3e2f98a82db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mapMigrationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="migrationEndDate")
    def migration_end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationEndDate"))

    @migration_end_date.setter
    def migration_end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ba9c50341bad2784dc5310997e245f391a38179f8290314b23362d4f724e41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationEndDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartDate")
    def migration_start_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartDate"))

    @migration_start_date.setter
    def migration_start_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e385d20fe470a83e35f33ead1ed49de18a1f88d2814f5ab764c2963516be434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabled")
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "migrationWithinCwMapsEnabled"))

    @migration_within_cw_maps_enabled.setter
    def migration_within_cw_maps_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bac455cc0af16da348cb3fc7d6b07b564ef4c23ab6c10f187a73c7062e0073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationWithinCwMapsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="serialEnd")
    def serial_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialEnd"))

    @serial_end.setter
    def serial_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023c136f15f20acd44488ac1a7910d24c88b231e6033f2acb9cee118f1b8d6a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialEnd", value)

    @builtins.property
    @jsii.member(jsii_name="serialStart")
    def serial_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialStart"))

    @serial_start.setter
    def serial_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8009cf38bc8a1362b36a36e501d7346275428c8ec615db5253954588229d9d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec0d0263ea3c5c2bdb02aa523053bd7c5765f112a3ee8daf2a7a684b181afac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1Title")
    def tier1_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1Title"))

    @tier1_title.setter
    def tier1_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c32b1e0261c0e0c4f00485b8b17be63833dacc274f285029836f6fb9d0b703d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1Title", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9ec0ce04e5115d2ce06c34142190187a7c11c5b544a5e3046117f70774e502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20be1d70bab69eca4372065f30a03d848bff87a1f71f6edef478b8448f47493e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a4eb40125aa3f000fe11d5e9dd29b322d3153f758cd3a3408256b9154a398b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1917950394961886f055a220710aab9fabb71e79d9c04944470050b6b7c08ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8841dd6b783bec71c0ede2efd4d553d8e0162176a6d598c20d4fb44a632c7bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__315cf289eecc32f93bcbd696e4438892f278c9dcaa92a5097a0ed6dff7e21f7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8804ce6649a96bb45ff2be5019fc0cbc4b4cc9c34b4acbb4a627f859ddcbddc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32913c9c2a694be336535ee2577e7124e5aa6cf65acaa748841810e186cdad7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220990000a7999541ba77d01e9205a144626d7108cbeded3d1109256cc17796e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fdfca74e4a5c62abc716eb2c8e00e1e4276eadb7be17acabef418c568cf227)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout, for example ``10s``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b15f4cd2e998ead0ad7e1aed71b97b5aeb14b486b70641d05809d38cabc209d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b94001d5c3e4e8ca55f09b791ce60bc76297a3ecba00407dd41f23d6ceaf126)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f984da1f59b61890055d4c343e3690c7ee468b1479425f458237942dc1972868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f53ac5f6ec922771668b954735d8bae3a37cd1ed0c4a21e56e39cd3515adc394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb8d33bfe560ed140dea747be215b194c132425cbe8ef568642d9fd03ee8c4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1affc5fedb0022af3cd4618a3922daa906793dfbc6a11bbbbdc550efa32853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "legal_text": "legalText",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03346ff9e8a4a55483e7f8ad8b6b2b993a4de9104c1337a355a1c5926993d596)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument legal_text", value=legal_text, expected_type=type_hints["legal_text"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if legal_text is not None:
            self._values["legal_text"] = legal_text
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract UIDs from client requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Where to extract the UID value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the HTTP header from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def legal_text(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        '''
        result = self._values.get("legal_text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the rule tree variable from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f2f9a1e4ccef409c7c5dae23fa8554be5cba15ec3aa5485e5efe6da001ff7f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLegalText")
    def reset_legal_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLegalText", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="legalTextInput")
    def legal_text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "legalTextInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867459d2ab8ced30121138ec614f8b0e65f2302089216d7907a220a2fdaef3e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c782d2549804009f3fa34c7caf112d641f04b5c0d8e94afe9498c977fbf900c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c3e21dd623d88997f994f956e481dccb97df593f1a80a93b11def243681931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="legalText")
    def legal_text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "legalText"))

    @legal_text.setter
    def legal_text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c83ae5daf61ed0063d61497a6ecd90742ce8061b672bfa08c30487bcce71619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "legalText", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b173fb4e4203064356e200f031e02ca7a51346c9c15271e646fc520b8e151cf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd06e40b4ec808cb7195709ecab894a8352170b5cee19ec5b286175ef456907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcf7810a86f55b534456199dbe2c91af51ada594ec03f573bdb2e8e9879c04d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0fa7085272ab42ddb6fcaeb747a8859ca3f48d80513e5736215476cbdbd5ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129fc0ac6af02aa223dbd80b808a8c56f1b4c8926032bf7c4e22ba5bb3391c28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4671c9feb8cc4ae9435017bc3e1c637c4336953532e3f9673fafc754114306ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd915c675a47d5814d08e4d720957b1e5c69bf4f598a381d5334e44be913768)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the ETag validation behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991d2f34d855f3e9a8bd558cdeaf3818e4d1d4f9f39145dc593c92f58cc55fa4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1c370eab8078e05518c864511c2b671823bb7d4d17790a7fa895b6b931a71dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cede03277f2ab4e01d0c7b96d552c9e44b85042af862451c330e0810d3bcab18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b0a10ab304dea9bcd8a1b627a95e3b20dfe731c0b15b83836d426f76ed98f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b62f3067893a06be0c8880f158b68739db772dc9b689413c8b647e525cf83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5de21758414f9bcf002824a436b98f6a30d99dff8c6b3c816e2dd2075e1dd01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken",
    jsii_struct_bases=[],
    name_mapping={
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken:
    def __init__(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb170d555a621d04bcd3048f1fd42476bddd012599bdcf20487b8162478c7114)
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specify from where to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp",
    jsii_struct_bases=[],
    name_mapping={
        "authorizations": "authorizations",
        "client_id": "clientId",
        "custom_header": "customHeader",
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_authorizations": "extractAuthorizations",
        "extract_client_id": "extractClientId",
        "extract_location": "extractLocation",
        "extract_user_name": "extractUserName",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "primary_location": "primaryLocation",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "user_name": "userName",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp:
    def __init__(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a671f4a22aeada09e6aac2b0d1eb37c294b7e84d190cc33f599a0fdc7eabd743)
            check_type(argname="argument authorizations", value=authorizations, expected_type=type_hints["authorizations"])
            check_type(argname="argument client_id", value=client_id, expected_type=type_hints["client_id"])
            check_type(argname="argument custom_header", value=custom_header, expected_type=type_hints["custom_header"])
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_authorizations", value=extract_authorizations, expected_type=type_hints["extract_authorizations"])
            check_type(argname="argument extract_client_id", value=extract_client_id, expected_type=type_hints["extract_client_id"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument extract_user_name", value=extract_user_name, expected_type=type_hints["extract_user_name"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument primary_location", value=primary_location, expected_type=type_hints["primary_location"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_name", value=user_name, expected_type=type_hints["user_name"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if authorizations is not None:
            self._values["authorizations"] = authorizations
        if client_id is not None:
            self._values["client_id"] = client_id
        if custom_header is not None:
            self._values["custom_header"] = custom_header
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_authorizations is not None:
            self._values["extract_authorizations"] = extract_authorizations
        if extract_client_id is not None:
            self._values["extract_client_id"] = extract_client_id
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if extract_user_name is not None:
            self._values["extract_user_name"] = extract_user_name
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if primary_location is not None:
            self._values["primary_location"] = primary_location
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_name is not None:
            self._values["user_name"] = user_name
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def authorizations(self) -> typing.Optional[builtins.str]:
        '''This specifies the authorization group name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        '''
        result = self._values.get("authorizations")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_id(self) -> typing.Optional[builtins.str]:
        '''This specifies the claim name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        '''
        result = self._values.get("client_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_header(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''The JWT value comes from the ``X-Akamai-DCP-Token`` header by default.

        Enabling this option allows you to extract it from another header name that you specify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        '''
        result = self._values.get("custom_header")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_authorizations(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the authorization groups stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        '''
        result = self._values.get("extract_authorizations")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_client_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the client ID claim name stored in JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        '''
        result = self._values.get("extract_client_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to get the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_user_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the user name stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        '''
        result = self._values.get("extract_user_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header to extract the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def primary_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the primary location to extract the JWT value from.

        If the specified option doesn't include the JWTs, the system checks the secondary one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        '''
        result = self._values.get("primary_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the user name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        '''
        result = self._values.get("user_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c81d79bd1e272b9cfb7240d380f18e3e44f0d5f24df2d4e36dc34214dcc19b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthorizations")
    def reset_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthorizations", []))

    @jsii.member(jsii_name="resetClientId")
    def reset_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientId", []))

    @jsii.member(jsii_name="resetCustomHeader")
    def reset_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeader", []))

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractAuthorizations")
    def reset_extract_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractAuthorizations", []))

    @jsii.member(jsii_name="resetExtractClientId")
    def reset_extract_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractClientId", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetExtractUserName")
    def reset_extract_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractUserName", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrimaryLocation")
    def reset_primary_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrimaryLocation", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserName")
    def reset_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserName", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authorizationsInput")
    def authorizations_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIdInput")
    def client_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderInput")
    def custom_header_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizationsInput")
    def extract_authorizations_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractAuthorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractClientIdInput")
    def extract_client_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractClientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="extractUserNameInput")
    def extract_user_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractUserNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="primaryLocationInput")
    def primary_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "primaryLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userNameInput")
    def user_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userNameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authorizations")
    def authorizations(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authorizations"))

    @authorizations.setter
    def authorizations(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc59b25d03756e5121e8a54f51a7cb91097473f2f47022e37629a97211eaa8d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authorizations", value)

    @builtins.property
    @jsii.member(jsii_name="clientId")
    def client_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientId"))

    @client_id.setter
    def client_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9736a327841dc6c8f0b3fd8c8e151473cb5257f1be6cd0fdcd08fe03d797c47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientId", value)

    @builtins.property
    @jsii.member(jsii_name="customHeader")
    def custom_header(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customHeader"))

    @custom_header.setter
    def custom_header(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe02399653ee5e734d61d363a2e129b07af540265153de5dc1d981ff3ecf7ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf3d33e56c5404791211febc6fd8a35a5527986b4aee626714aeca4c24de680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d30c066400c3af18adf908b4adc6898b8999b960a2de19a3d4f18986b73dbe08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizations")
    def extract_authorizations(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractAuthorizations"))

    @extract_authorizations.setter
    def extract_authorizations(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37879261def51e5995245d9dd6e1c873fe1dcc205dee9e663ab16050e60b7f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractAuthorizations", value)

    @builtins.property
    @jsii.member(jsii_name="extractClientId")
    def extract_client_id(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractClientId"))

    @extract_client_id.setter
    def extract_client_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057b4aa6686df5bdd8dc62131f25df44f69d65febf7ec3e19dbf4061b27215c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractClientId", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4f9213741a62c6800d8fccd30fe2b1c75510eaa388df86492a577624985807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="extractUserName")
    def extract_user_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractUserName"))

    @extract_user_name.setter
    def extract_user_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d97bd496c8c273b95ada10973718007de14d8709027c075cb1d0e62a94e09af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractUserName", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4904037908d151a504f5490bd9877905b98c1b561feb21693392534900df694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f83dc937cc6441aaf91b184dc2eff693bb1b1ad7a954c84f93e7d0ea4f58b4a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f396db0ea9b3a49c70e370991c8f21061ddea56d19698ba095c4235a1c0de3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="primaryLocation")
    def primary_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "primaryLocation"))

    @primary_location.setter
    def primary_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913b152e906227ac66392c48464052837da3eaf0e2d8d918b2713191e7dd2ce6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "primaryLocation", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9f9099d6eac876c6112e0c8401f029e28a521de9ac33e65d765b472a04bb1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc188097ad1e897b0adc0e1c1ef85de1e2f6ab41c9693e0171eb1dfd8ab57b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userName")
    def user_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userName"))

    @user_name.setter
    def user_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c7a46224dce2df2a23d9d417116dd3e595c57d8fd0f6e0536ae46ba8ff9203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userName", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2a0dc51bf19234d545a67d5093730a673cb340f45badb9dda250c4eadd3574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8f4b592fd37cac9e9d843b2f3d4642a25f5706df79355cd7ed181d74bd0aa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe58cd53598129c4e81790cf93a284d73505bc239b05ecd28fc72bed5e160286)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c146842a4d335aa4ea886e7d65fa94dfd246e316abb15237e9ce19ed7ad4f898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3dc86d2ece143bcf6f3dd5316e262844f79d74bd75cf9ff71720bd56091884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e75d86c0629beb3619c1996cd6f5b644057e102503d70458bb8b119b66678e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f097ff83f9591ff0cdd85225c8301fbaea962cba93f6f7d17e801046781939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3846044af008d11eabc1e90511347c93978c3b936b8dbcab1db2f0cc853abcea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479bd2482a4ea182a609ca936c3173dd869b66f809a0e1dd55571ce1e535cb8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f288193bce4deb4acdfee9ca087ca13e3e911c18d03797ed0b7db2b4997ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c3356bdeb186bfb4f0d0952c27446c5f96efa45adc668053c5176b37ee8814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d345c349cadbad5e8c83cc5d3570fd5e7af3e4d06576a5f20eda6da44de23f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d1de0a696c6b895714044146ea8d18b2b0057d79bdcc22c60a420fcb40c376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "escape_hmac_inputs": "escapeHmacInputs",
        "failure_response": "failureResponse",
        "ignore_query_string": "ignoreQueryString",
        "key": "key",
        "location": "location",
        "location_id": "locationId",
        "locked": "locked",
        "salt": "salt",
        "template_uuid": "templateUuid",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c43d6e9eb3c2c794d0dabf7a423c4491891ec5be346b91733084a87fee2232)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument escape_hmac_inputs", value=escape_hmac_inputs, expected_type=type_hints["escape_hmac_inputs"])
            check_type(argname="argument failure_response", value=failure_response, expected_type=type_hints["failure_response"])
            check_type(argname="argument ignore_query_string", value=ignore_query_string, expected_type=type_hints["ignore_query_string"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if escape_hmac_inputs is not None:
            self._values["escape_hmac_inputs"] = escape_hmac_inputs
        if failure_response is not None:
            self._values["failure_response"] = failure_response
        if ignore_query_string is not None:
            self._values["ignore_query_string"] = ignore_query_string
        if key is not None:
            self._values["key"] = key
        if location is not None:
            self._values["location"] = location
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if salt is not None:
            self._values["salt"] = salt
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def escape_hmac_inputs(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''URL-escapes HMAC inputs passed in as query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        '''
        result = self._values.get("escape_hmac_inputs")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failure_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends an HTTP error when an authentication test fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        '''
        result = self._values.get("failure_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this removes the query string from the URL used to form an encryption key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        '''
        result = self._values.get("ignore_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''The shared secret used to validate tokens, which needs to match the key used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to find the token in the incoming request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a hex value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217f1c34f863e6b42c66a1a1364e38ae5d4f6c6aae00139589f6b42302254337)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetEscapeHmacInputs")
    def reset_escape_hmac_inputs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeHmacInputs", []))

    @jsii.member(jsii_name="resetFailureResponse")
    def reset_failure_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailureResponse", []))

    @jsii.member(jsii_name="resetIgnoreQueryString")
    def reset_ignore_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnoreQueryString", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputsInput")
    def escape_hmac_inputs_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeHmacInputsInput"))

    @builtins.property
    @jsii.member(jsii_name="failureResponseInput")
    def failure_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failureResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryStringInput")
    def ignore_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignoreQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53adcedff29ef893334cb0c5ede8eea2c00776d12f0b99a53cee676178d24231)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputs")
    def escape_hmac_inputs(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeHmacInputs"))

    @escape_hmac_inputs.setter
    def escape_hmac_inputs(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ecdbd3492cf8cc2846f778c792f12095017ece02dd94b66aa82a9ac327a456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeHmacInputs", value)

    @builtins.property
    @jsii.member(jsii_name="failureResponse")
    def failure_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failureResponse"))

    @failure_response.setter
    def failure_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8ac06f019aeda6dc9e958c457fcd0471efd394c364b78a277c35990af3048d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failureResponse", value)

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryString")
    def ignore_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignoreQueryString"))

    @ignore_query_string.setter
    def ignore_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f759399585b7b04ecec082b22fa6ebfa2f4ea1cf2a8bef799c443aa2582150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignoreQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f0395d650c24427aa41a03f28c25753b48ce1ab8cbcd0216e53328f68717579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9cbecf0aa0dc7374e01bebd76a2f156353a342b58dcf9f067779cf826226a3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__919e57a032b47c92ea638161a2dc9195b1d8ca29d56b764e0f665db002b434b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1980c7b08f7686c0ad920506bb98f7d2997c5af9e795f2c1ebde061e37deb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5b6df3527904d4c1f1b4640a22e96de98b7fc395f682cca714ea835aea87eb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20086dcaf9c9e4d953ad5fedad17b2cf8ed2bb3fe9f4d5bac3a457cc622b338b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ce8d763b02ffed30133adb8e7e3423962197d47f0309985b160f5e27d12380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__358525d475d224cc0716301c555b75afc47fd87621b7c7ed6a8dcb5d7afdf1a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd5af37e82c69cf9da26969751f79ddd996af4915b4cbe2150e77ec39750b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e83783fe2cd45dfd7bb2e27c76c8e6690e02f41efbdba7199a645838ad143a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7da3d518978c6777b7fd80660a3a27c24b36a4af23b824c33812a1a78d200895)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests.

        The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__687a38ac159ad835dbf1ad2ae765bb8829fd40e4a08bff8357837e9bc376866c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27346c741a91744eac37b5c76b815153abcce5a84ba5af627dd3a4c27e352414)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411c99b9b6bf6a84b72ad8de805bc1ce34c1e20d9ad6795b3fc935d2fc941fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06416e919c7009315525ffdb5b2104ac04bca73b7198c03bae6f68ac89dd86c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6b1b2a803d7d93ad2225adbe9f18bc28f01da596505ed3d32d7f2768573c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436a28e1b9dc3bd13980ec82a1d74176465f73d16ef4958aee4b4d1fad2e1e33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad1dd7d61a9cd5db10880e19d08ed4a5707908ad83810d838d007a89171b6ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70796c500fc8b93c125ceaebb3ba7012f9e9e42437e3d5a76d7aeb9a8fe9956d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652dc028491f10655129e75c9a6a02af40927e37510ab9ccec8bedb47410c45d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3216dc168b08dc720734844c03fb14034f80730add84012fca86c96d7f6cd2d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c986c4bab6d5a8573d715c83181d7764deee1e22fb5846f399499b87a64fe8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28a41be41482c99cd9117c3e4395f1aa0619aee9f7c72e4c089bae31ff367c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b593ebc6c4cd758cd4fef81c131834d5b95a7a1c4bda28d207499ae4032e9913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe2becc09dcbc711647ffb34dae6a16f3f8a4f58350fde026c9b9b546a38922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__028e9dc0dc41ad0d56cea98591ab966fa72c575a6ab123c54a579a95422ef80d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c3913f21b04b072279431773a23ddd9dc9a85a7f4a928c2076b0da586b109eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07869081ee05a1172c502252cbfb2318f51f5ec930849435e3e00219c7f8614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea374e44d2786671a8a1f9679230a5ca759a887fcef53f25d505214b5df65e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9850765881782c7774c4a9c5a617615ed27ac7e7ba88d4f9f857994c362c531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a131b7f7a10c174874058701f36b33beb8a0527f4c0e90ac17296d9bad55e7a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_user_cookie_advanced": "allowedUserCookieAdvanced",
        "allowed_user_cookie_automatic_salt": "allowedUserCookieAutomaticSalt",
        "allowed_user_cookie_domain": "allowedUserCookieDomain",
        "allowed_user_cookie_domain_type": "allowedUserCookieDomainType",
        "allowed_user_cookie_duration": "allowedUserCookieDuration",
        "allowed_user_cookie_enabled": "allowedUserCookieEnabled",
        "allowed_user_cookie_http_only": "allowedUserCookieHttpOnly",
        "allowed_user_cookie_label": "allowedUserCookieLabel",
        "allowed_user_cookie_management_title": "allowedUserCookieManagementTitle",
        "allowed_user_cookie_refresh": "allowedUserCookieRefresh",
        "allowed_user_cookie_salt": "allowedUserCookieSalt",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "user_identification_by_cookie": "userIdentificationByCookie",
        "user_identification_by_headers": "userIdentificationByHeaders",
        "user_identification_by_ip": "userIdentificationByIp",
        "user_identification_by_params": "userIdentificationByParams",
        "user_identification_key_cookie": "userIdentificationKeyCookie",
        "user_identification_key_headers": "userIdentificationKeyHeaders",
        "user_identification_key_params": "userIdentificationKeyParams",
        "user_identification_title": "userIdentificationTitle",
        "uuid": "uuid",
        "waiting_room_cache_ttl": "waitingRoomCacheTtl",
        "waiting_room_cookie_advanced": "waitingRoomCookieAdvanced",
        "waiting_room_cookie_automatic_salt": "waitingRoomCookieAutomaticSalt",
        "waiting_room_cookie_domain": "waitingRoomCookieDomain",
        "waiting_room_cookie_domain_type": "waitingRoomCookieDomainType",
        "waiting_room_cookie_duration": "waitingRoomCookieDuration",
        "waiting_room_cookie_enabled": "waitingRoomCookieEnabled",
        "waiting_room_cookie_http_only": "waitingRoomCookieHttpOnly",
        "waiting_room_cookie_label": "waitingRoomCookieLabel",
        "waiting_room_cookie_management_title": "waitingRoomCookieManagementTitle",
        "waiting_room_cookie_salt": "waitingRoomCookieSalt",
        "waiting_room_cookie_share_label": "waitingRoomCookieShareLabel",
        "waiting_room_cp_code": "waitingRoomCpCode",
        "waiting_room_directory": "waitingRoomDirectory",
        "waiting_room_management_title": "waitingRoomManagementTitle",
        "waiting_room_net_storage": "waitingRoomNetStorage",
        "waiting_room_status_code": "waitingRoomStatusCode",
        "waiting_room_use_cp_code": "waitingRoomUseCpCode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization:
    def __init__(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(waiting_room_cp_code, dict):
            waiting_room_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode(**waiting_room_cp_code)
        if isinstance(waiting_room_net_storage, dict):
            waiting_room_net_storage = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage(**waiting_room_net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e92903fda0562590927e829545dd5b49513e6a8655f7b76dc7409aed86eff66)
            check_type(argname="argument allowed_user_cookie_advanced", value=allowed_user_cookie_advanced, expected_type=type_hints["allowed_user_cookie_advanced"])
            check_type(argname="argument allowed_user_cookie_automatic_salt", value=allowed_user_cookie_automatic_salt, expected_type=type_hints["allowed_user_cookie_automatic_salt"])
            check_type(argname="argument allowed_user_cookie_domain", value=allowed_user_cookie_domain, expected_type=type_hints["allowed_user_cookie_domain"])
            check_type(argname="argument allowed_user_cookie_domain_type", value=allowed_user_cookie_domain_type, expected_type=type_hints["allowed_user_cookie_domain_type"])
            check_type(argname="argument allowed_user_cookie_duration", value=allowed_user_cookie_duration, expected_type=type_hints["allowed_user_cookie_duration"])
            check_type(argname="argument allowed_user_cookie_enabled", value=allowed_user_cookie_enabled, expected_type=type_hints["allowed_user_cookie_enabled"])
            check_type(argname="argument allowed_user_cookie_http_only", value=allowed_user_cookie_http_only, expected_type=type_hints["allowed_user_cookie_http_only"])
            check_type(argname="argument allowed_user_cookie_label", value=allowed_user_cookie_label, expected_type=type_hints["allowed_user_cookie_label"])
            check_type(argname="argument allowed_user_cookie_management_title", value=allowed_user_cookie_management_title, expected_type=type_hints["allowed_user_cookie_management_title"])
            check_type(argname="argument allowed_user_cookie_refresh", value=allowed_user_cookie_refresh, expected_type=type_hints["allowed_user_cookie_refresh"])
            check_type(argname="argument allowed_user_cookie_salt", value=allowed_user_cookie_salt, expected_type=type_hints["allowed_user_cookie_salt"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_identification_by_cookie", value=user_identification_by_cookie, expected_type=type_hints["user_identification_by_cookie"])
            check_type(argname="argument user_identification_by_headers", value=user_identification_by_headers, expected_type=type_hints["user_identification_by_headers"])
            check_type(argname="argument user_identification_by_ip", value=user_identification_by_ip, expected_type=type_hints["user_identification_by_ip"])
            check_type(argname="argument user_identification_by_params", value=user_identification_by_params, expected_type=type_hints["user_identification_by_params"])
            check_type(argname="argument user_identification_key_cookie", value=user_identification_key_cookie, expected_type=type_hints["user_identification_key_cookie"])
            check_type(argname="argument user_identification_key_headers", value=user_identification_key_headers, expected_type=type_hints["user_identification_key_headers"])
            check_type(argname="argument user_identification_key_params", value=user_identification_key_params, expected_type=type_hints["user_identification_key_params"])
            check_type(argname="argument user_identification_title", value=user_identification_title, expected_type=type_hints["user_identification_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_cache_ttl", value=waiting_room_cache_ttl, expected_type=type_hints["waiting_room_cache_ttl"])
            check_type(argname="argument waiting_room_cookie_advanced", value=waiting_room_cookie_advanced, expected_type=type_hints["waiting_room_cookie_advanced"])
            check_type(argname="argument waiting_room_cookie_automatic_salt", value=waiting_room_cookie_automatic_salt, expected_type=type_hints["waiting_room_cookie_automatic_salt"])
            check_type(argname="argument waiting_room_cookie_domain", value=waiting_room_cookie_domain, expected_type=type_hints["waiting_room_cookie_domain"])
            check_type(argname="argument waiting_room_cookie_domain_type", value=waiting_room_cookie_domain_type, expected_type=type_hints["waiting_room_cookie_domain_type"])
            check_type(argname="argument waiting_room_cookie_duration", value=waiting_room_cookie_duration, expected_type=type_hints["waiting_room_cookie_duration"])
            check_type(argname="argument waiting_room_cookie_enabled", value=waiting_room_cookie_enabled, expected_type=type_hints["waiting_room_cookie_enabled"])
            check_type(argname="argument waiting_room_cookie_http_only", value=waiting_room_cookie_http_only, expected_type=type_hints["waiting_room_cookie_http_only"])
            check_type(argname="argument waiting_room_cookie_label", value=waiting_room_cookie_label, expected_type=type_hints["waiting_room_cookie_label"])
            check_type(argname="argument waiting_room_cookie_management_title", value=waiting_room_cookie_management_title, expected_type=type_hints["waiting_room_cookie_management_title"])
            check_type(argname="argument waiting_room_cookie_salt", value=waiting_room_cookie_salt, expected_type=type_hints["waiting_room_cookie_salt"])
            check_type(argname="argument waiting_room_cookie_share_label", value=waiting_room_cookie_share_label, expected_type=type_hints["waiting_room_cookie_share_label"])
            check_type(argname="argument waiting_room_cp_code", value=waiting_room_cp_code, expected_type=type_hints["waiting_room_cp_code"])
            check_type(argname="argument waiting_room_directory", value=waiting_room_directory, expected_type=type_hints["waiting_room_directory"])
            check_type(argname="argument waiting_room_management_title", value=waiting_room_management_title, expected_type=type_hints["waiting_room_management_title"])
            check_type(argname="argument waiting_room_net_storage", value=waiting_room_net_storage, expected_type=type_hints["waiting_room_net_storage"])
            check_type(argname="argument waiting_room_status_code", value=waiting_room_status_code, expected_type=type_hints["waiting_room_status_code"])
            check_type(argname="argument waiting_room_use_cp_code", value=waiting_room_use_cp_code, expected_type=type_hints["waiting_room_use_cp_code"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowed_user_cookie_advanced is not None:
            self._values["allowed_user_cookie_advanced"] = allowed_user_cookie_advanced
        if allowed_user_cookie_automatic_salt is not None:
            self._values["allowed_user_cookie_automatic_salt"] = allowed_user_cookie_automatic_salt
        if allowed_user_cookie_domain is not None:
            self._values["allowed_user_cookie_domain"] = allowed_user_cookie_domain
        if allowed_user_cookie_domain_type is not None:
            self._values["allowed_user_cookie_domain_type"] = allowed_user_cookie_domain_type
        if allowed_user_cookie_duration is not None:
            self._values["allowed_user_cookie_duration"] = allowed_user_cookie_duration
        if allowed_user_cookie_enabled is not None:
            self._values["allowed_user_cookie_enabled"] = allowed_user_cookie_enabled
        if allowed_user_cookie_http_only is not None:
            self._values["allowed_user_cookie_http_only"] = allowed_user_cookie_http_only
        if allowed_user_cookie_label is not None:
            self._values["allowed_user_cookie_label"] = allowed_user_cookie_label
        if allowed_user_cookie_management_title is not None:
            self._values["allowed_user_cookie_management_title"] = allowed_user_cookie_management_title
        if allowed_user_cookie_refresh is not None:
            self._values["allowed_user_cookie_refresh"] = allowed_user_cookie_refresh
        if allowed_user_cookie_salt is not None:
            self._values["allowed_user_cookie_salt"] = allowed_user_cookie_salt
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_identification_by_cookie is not None:
            self._values["user_identification_by_cookie"] = user_identification_by_cookie
        if user_identification_by_headers is not None:
            self._values["user_identification_by_headers"] = user_identification_by_headers
        if user_identification_by_ip is not None:
            self._values["user_identification_by_ip"] = user_identification_by_ip
        if user_identification_by_params is not None:
            self._values["user_identification_by_params"] = user_identification_by_params
        if user_identification_key_cookie is not None:
            self._values["user_identification_key_cookie"] = user_identification_key_cookie
        if user_identification_key_headers is not None:
            self._values["user_identification_key_headers"] = user_identification_key_headers
        if user_identification_key_params is not None:
            self._values["user_identification_key_params"] = user_identification_key_params
        if user_identification_title is not None:
            self._values["user_identification_title"] = user_identification_title
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_cache_ttl is not None:
            self._values["waiting_room_cache_ttl"] = waiting_room_cache_ttl
        if waiting_room_cookie_advanced is not None:
            self._values["waiting_room_cookie_advanced"] = waiting_room_cookie_advanced
        if waiting_room_cookie_automatic_salt is not None:
            self._values["waiting_room_cookie_automatic_salt"] = waiting_room_cookie_automatic_salt
        if waiting_room_cookie_domain is not None:
            self._values["waiting_room_cookie_domain"] = waiting_room_cookie_domain
        if waiting_room_cookie_domain_type is not None:
            self._values["waiting_room_cookie_domain_type"] = waiting_room_cookie_domain_type
        if waiting_room_cookie_duration is not None:
            self._values["waiting_room_cookie_duration"] = waiting_room_cookie_duration
        if waiting_room_cookie_enabled is not None:
            self._values["waiting_room_cookie_enabled"] = waiting_room_cookie_enabled
        if waiting_room_cookie_http_only is not None:
            self._values["waiting_room_cookie_http_only"] = waiting_room_cookie_http_only
        if waiting_room_cookie_label is not None:
            self._values["waiting_room_cookie_label"] = waiting_room_cookie_label
        if waiting_room_cookie_management_title is not None:
            self._values["waiting_room_cookie_management_title"] = waiting_room_cookie_management_title
        if waiting_room_cookie_salt is not None:
            self._values["waiting_room_cookie_salt"] = waiting_room_cookie_salt
        if waiting_room_cookie_share_label is not None:
            self._values["waiting_room_cookie_share_label"] = waiting_room_cookie_share_label
        if waiting_room_cp_code is not None:
            self._values["waiting_room_cp_code"] = waiting_room_cp_code
        if waiting_room_directory is not None:
            self._values["waiting_room_directory"] = waiting_room_directory
        if waiting_room_management_title is not None:
            self._values["waiting_room_management_title"] = waiting_room_management_title
        if waiting_room_net_storage is not None:
            self._values["waiting_room_net_storage"] = waiting_room_net_storage
        if waiting_room_status_code is not None:
            self._values["waiting_room_status_code"] = waiting_room_status_code
        if waiting_room_use_cp_code is not None:
            self._values["waiting_room_use_cp_code"] = waiting_room_use_cp_code

    @builtins.property
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets advanced configuration options for the allowed user's cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        '''
        result = self._values.get("allowed_user_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        '''
        result = self._values.get("allowed_user_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for an allowed user cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        '''
        result = self._values.get("allowed_user_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``allowedUserCookieAdvanced`` enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        '''
        result = self._values.get("allowed_user_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for the allowed user's session once allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        '''
        result = self._values.get("allowed_user_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a cookie for users who have been allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        '''
        result = self._values.get("allowed_user_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        '''
        result = self._values.get("allowed_user_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this cookie for an allowed user from others.

        The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        '''
        result = self._values.get("allowed_user_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        '''
        result = self._values.get("allowed_user_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration.

        Do not enable this option if you want to set a fixed time for all users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        '''
        result = self._values.get("allowed_user_cookie_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        '''
        result = self._values.get("allowed_user_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Visitor Prioritization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_by_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the value of a cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        '''
        result = self._values.get("user_identification_by_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        '''
        result = self._values.get("user_identification_by_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows IP addresses to identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        '''
        result = self._values.get("user_identification_by_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_params(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        '''
        result = self._values.get("user_identification_by_params")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_key_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie whose value identifies users.

        To match a user, the value of the cookie needs to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        '''
        result = self._values.get("user_identification_key_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_key_headers(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request headers whose values identify users.

        To match a user, values for all the specified headers need to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        '''
        result = self._values.get("user_identification_key_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_key_params(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request parameters whose values identify users.

        To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        '''
        result = self._values.get("user_identification_key_params")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        '''
        result = self._values.get("user_identification_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the waiting room page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        '''
        result = self._values.get("waiting_room_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        '''
        result = self._values.get("waiting_room_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        '''
        result = self._values.get("waiting_room_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        '''
        result = self._values.get("waiting_room_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        '''
        result = self._values.get("waiting_room_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for which users remain in the waiting room.

        During this time, users who refresh the waiting room page remain there.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        '''
        result = self._values.get("waiting_room_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a cookie to track a waiting room assignment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        '''
        result = self._values.get("waiting_room_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        '''
        result = self._values.get("waiting_room_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this waiting room cookie from others.

        The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        '''
        result = self._values.get("waiting_room_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        '''
        result = self._values.get("waiting_room_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        '''
        result = self._values.get("waiting_room_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        '''
        result = self._values.get("waiting_room_cookie_share_label")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        '''waiting_room_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        '''
        result = self._values.get("waiting_room_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode"], result)

    @builtins.property
    def waiting_room_directory(self) -> typing.Optional[builtins.str]:
        '''Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        '''
        result = self._values.get("waiting_room_directory")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        '''
        result = self._values.get("waiting_room_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        '''waiting_room_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        '''
        result = self._values.get("waiting_room_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage"], result)

    @builtins.property
    def waiting_room_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response code for requests sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        '''
        result = self._values.get("waiting_room_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a different CP code that tracks any requests that are sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        result = self._values.get("waiting_room_use_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4fab52806f847f24618cad9925199f1e68eb4b32e1921c4fb3757b6a39cec7)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e42ac8947cd1072424466eac45e7973799048ca692fe137165fafcd4b586556)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcdcd62669f37f9714777605c688876a837b7a089ea105127ee75b100eeec711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f41c2539cdbfc8c1239862534d0392ada9dd79d0453fb055efea3f77d36abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29483f296576096264a0bf8cd3f72b3dca55817f41c25fa4dd06527622754c43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8813a174f1b22d7525610f88cc23377a8a460428d79cdd1bd3a1970b334731ed)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Prioritization FIFO shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies how to set the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests.

        The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db54b574982556c9fbe5aa905009bd862024324268fe125de001a33b76e416a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f49f7098b8baedc2dfbb10511e18a7efd5b031144130cd9e970a373e33698f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54faebf1363728a8c74e2e3f8d4efb78da6bb452abf49fb1c2ebf8dafa8b5a93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a822a5e8b41388f314831f9a701dac0d66fe99cde33f0b82edf43b1510522c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36daff73309b9796047f4acbf91d49a958289ab704227e42454fb493e356d7bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11576e73225e597843610c81241516e817a4d42d7a8afe7ff8008554c74c5fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1764b78d418db942433902b411581598994327520a4d32a8705ed820a026dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c32071357a2cf48c8dc018775f6975a24d4ad5767c4cde6fd30f05ad84071e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d5067a9489ff4b770e64919bac5c270aa04f90113df8c345bf71038b2b8829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111549501bd61474fd45da533a55b8bb2ea74a44f737358052ca0aff44308d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4044774f3ff0891aa117db278395774e484e47d5016fb6edbe2236ef1011f550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5af7c600feb17c757a71584f3d9f3a7d025f1f506af1982848aa21999146f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52212df1c95b2402111378bd8aaffb9784a5af67e46067df9bda64ff460add6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee92c80ac22508c2fde9c6761d4cf3e1ba63ece0f84e9418a5c168939d7074b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b497293da2e489523e321bfc1da3348ae1de398a11c7ce13360db6b453e781a7)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandaloneOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5515e42c8fd916c74b08b64da3cea03ccfb01fe8ea0f42e9a66913f2768ca04d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632badc2982b6f349e9d2988748c769c6404c09f8aed58505238ac0759a30f65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0476903964d7671f67691d5adeb9f033c37377f1c004c27de1091beafab14c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf615e0160eca3c4974711e539293c90f07b2c16decdaecaa08f29292b2eebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed37dccecacf2c8d872a506f3bd8f5db20155989344edb11e55f5e8a4bc2458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93993f83e556022f7fe1431fb79f30a28d99fa03217727f745b2e917235a7828)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putWaitingRoomCpCode")
    def put_waiting_room_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomCpCode", [value]))

    @jsii.member(jsii_name="putWaitingRoomNetStorage")
    def put_waiting_room_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomNetStorage", [value]))

    @jsii.member(jsii_name="resetAllowedUserCookieAdvanced")
    def reset_allowed_user_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAdvanced", []))

    @jsii.member(jsii_name="resetAllowedUserCookieAutomaticSalt")
    def reset_allowed_user_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomain")
    def reset_allowed_user_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomain", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomainType")
    def reset_allowed_user_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomainType", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDuration")
    def reset_allowed_user_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDuration", []))

    @jsii.member(jsii_name="resetAllowedUserCookieEnabled")
    def reset_allowed_user_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieEnabled", []))

    @jsii.member(jsii_name="resetAllowedUserCookieHttpOnly")
    def reset_allowed_user_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieHttpOnly", []))

    @jsii.member(jsii_name="resetAllowedUserCookieLabel")
    def reset_allowed_user_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieLabel", []))

    @jsii.member(jsii_name="resetAllowedUserCookieManagementTitle")
    def reset_allowed_user_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieManagementTitle", []))

    @jsii.member(jsii_name="resetAllowedUserCookieRefresh")
    def reset_allowed_user_cookie_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieRefresh", []))

    @jsii.member(jsii_name="resetAllowedUserCookieSalt")
    def reset_allowed_user_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieSalt", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserIdentificationByCookie")
    def reset_user_identification_by_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationByHeaders")
    def reset_user_identification_by_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationByIp")
    def reset_user_identification_by_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByIp", []))

    @jsii.member(jsii_name="resetUserIdentificationByParams")
    def reset_user_identification_by_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByParams", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyCookie")
    def reset_user_identification_key_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyHeaders")
    def reset_user_identification_key_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyParams")
    def reset_user_identification_key_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyParams", []))

    @jsii.member(jsii_name="resetUserIdentificationTitle")
    def reset_user_identification_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomCacheTtl")
    def reset_waiting_room_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCacheTtl", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAdvanced")
    def reset_waiting_room_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAdvanced", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAutomaticSalt")
    def reset_waiting_room_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomain")
    def reset_waiting_room_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomain", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomainType")
    def reset_waiting_room_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomainType", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDuration")
    def reset_waiting_room_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDuration", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieEnabled")
    def reset_waiting_room_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieEnabled", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieHttpOnly")
    def reset_waiting_room_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieHttpOnly", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieLabel")
    def reset_waiting_room_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieManagementTitle")
    def reset_waiting_room_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieSalt")
    def reset_waiting_room_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieShareLabel")
    def reset_waiting_room_cookie_share_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieShareLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCpCode")
    def reset_waiting_room_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCpCode", []))

    @jsii.member(jsii_name="resetWaitingRoomDirectory")
    def reset_waiting_room_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomDirectory", []))

    @jsii.member(jsii_name="resetWaitingRoomManagementTitle")
    def reset_waiting_room_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomNetStorage")
    def reset_waiting_room_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomNetStorage", []))

    @jsii.member(jsii_name="resetWaitingRoomStatusCode")
    def reset_waiting_room_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomStatusCode", []))

    @jsii.member(jsii_name="resetWaitingRoomUseCpCode")
    def reset_waiting_room_use_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomUseCpCode", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCode")
    def waiting_room_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference", jsii.get(self, "waitingRoomCpCode"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorage")
    def waiting_room_net_storage(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference", jsii.get(self, "waitingRoomNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvancedInput")
    def allowed_user_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSaltInput")
    def allowed_user_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainInput")
    def allowed_user_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainTypeInput")
    def allowed_user_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDurationInput")
    def allowed_user_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "allowedUserCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabledInput")
    def allowed_user_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnlyInput")
    def allowed_user_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabelInput")
    def allowed_user_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitleInput")
    def allowed_user_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefreshInput")
    def allowed_user_cookie_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSaltInput")
    def allowed_user_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookieInput")
    def user_identification_by_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeadersInput")
    def user_identification_by_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIpInput")
    def user_identification_by_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByIpInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParamsInput")
    def user_identification_by_params_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookieInput")
    def user_identification_key_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationKeyCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeadersInput")
    def user_identification_key_headers_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParamsInput")
    def user_identification_key_params_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitleInput")
    def user_identification_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtlInput")
    def waiting_room_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvancedInput")
    def waiting_room_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSaltInput")
    def waiting_room_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainInput")
    def waiting_room_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainTypeInput")
    def waiting_room_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDurationInput")
    def waiting_room_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabledInput")
    def waiting_room_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnlyInput")
    def waiting_room_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabelInput")
    def waiting_room_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitleInput")
    def waiting_room_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSaltInput")
    def waiting_room_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabelInput")
    def waiting_room_cookie_share_label_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieShareLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCodeInput")
    def waiting_room_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode"], jsii.get(self, "waitingRoomCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectoryInput")
    def waiting_room_directory_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitleInput")
    def waiting_room_management_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorageInput")
    def waiting_room_net_storage_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage"], jsii.get(self, "waitingRoomNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCodeInput")
    def waiting_room_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCodeInput")
    def waiting_room_use_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomUseCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvanced")
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAdvanced"))

    @allowed_user_cookie_advanced.setter
    def allowed_user_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e62498910dbf2643a173f299bdf508d9bdbf06e271eb086ea0b2b255ddce4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSalt")
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAutomaticSalt"))

    @allowed_user_cookie_automatic_salt.setter
    def allowed_user_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2166c06c357705a8f360991ca4028f6cec3b1a2f980b6942527126014dbabc0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomain")
    def allowed_user_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomain"))

    @allowed_user_cookie_domain.setter
    def allowed_user_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4f0df502175ab15baa8027fba005c5388630ac812acc637ab36ea5bc90291b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainType")
    def allowed_user_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomainType"))

    @allowed_user_cookie_domain_type.setter
    def allowed_user_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124a3cdfa752fcfa6371b13595258595b7a3585ed8479ee117f0bf25cc0b4db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDuration")
    def allowed_user_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "allowedUserCookieDuration"))

    @allowed_user_cookie_duration.setter
    def allowed_user_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7ab98fa206126c9118633c9440eb27358439db917143432ea0dce96a90fdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabled")
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieEnabled"))

    @allowed_user_cookie_enabled.setter
    def allowed_user_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588062f3c84b6563937fc46da5f256c6c6c76c4189a843d1fc3e062ee4062b29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnly")
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieHttpOnly"))

    @allowed_user_cookie_http_only.setter
    def allowed_user_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f89c3853a33745af4b6bec749c028918ae166fa2c9114ea3f7f436fd43e3abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabel")
    def allowed_user_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieLabel"))

    @allowed_user_cookie_label.setter
    def allowed_user_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9d18827f89d6da4a740a7becb05bc74ad380d2c4e7f42935f14bf140ca9148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitle")
    def allowed_user_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieManagementTitle"))

    @allowed_user_cookie_management_title.setter
    def allowed_user_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec636c3dc5ef692c6a002133aca23e69511a4a7cb9fb836304f6cf3d15eda225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefresh")
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieRefresh"))

    @allowed_user_cookie_refresh.setter
    def allowed_user_cookie_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932554ffe35e00ff80c872de5204b376e7d8c81f0ae3edaedd6d18f6a41f7872)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSalt")
    def allowed_user_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieSalt"))

    @allowed_user_cookie_salt.setter
    def allowed_user_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b4e19f8a72e2106bee3094f9b0bfe7b14468fdc852a2b8538f51f30e0adcb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331016adad28a1167bf0491c93ee812ab9c36f5bedd5685fc73c615b80993a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__099b7e7ef64f9fa819519997ffe69c10a87209406c99ae9306a60d9cacdae24b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ddd1275734503e88a63b13990b7eac8885117bf37919ea1f074a6f0d5ae2cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookie")
    def user_identification_by_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByCookie"))

    @user_identification_by_cookie.setter
    def user_identification_by_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c86ac28d944469a13b6fb3cad92547d1017902aeb22b6e31931a28ca157aa39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeaders")
    def user_identification_by_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByHeaders"))

    @user_identification_by_headers.setter
    def user_identification_by_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4768492f5b78bfd877ee7d17c5e31a7ce94a0f6feb63dad38004c65cbc2f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIp")
    def user_identification_by_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByIp"))

    @user_identification_by_ip.setter
    def user_identification_by_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ecf56e0069ea1f4e97b8499a20aa213c75c27817ba1c79e68618b38ad6d8f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByIp", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParams")
    def user_identification_by_params(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByParams"))

    @user_identification_by_params.setter
    def user_identification_by_params(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4c87fc10c0f173e43190149af25f5a02f4992244fd8838c12b103fb42cd82c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookie")
    def user_identification_key_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationKeyCookie"))

    @user_identification_key_cookie.setter
    def user_identification_key_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e317c7f80d3b7e6694460298674f361dac6f109709718f413118c214030d158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeaders")
    def user_identification_key_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyHeaders"))

    @user_identification_key_headers.setter
    def user_identification_key_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__914bf0facf303b24d0af4dc5ef44ff9fdd1123056ddef96c5bf4f77fbc2f6c79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParams")
    def user_identification_key_params(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyParams"))

    @user_identification_key_params.setter
    def user_identification_key_params(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d038bb232dc45942eaeab04d04cf05dbad13a547cef893c73c2073ffd765cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitle")
    def user_identification_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationTitle"))

    @user_identification_title.setter
    def user_identification_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__165ad87061db9b26183d5b8de6e7e122c3f7ad93726a72a35dce6f4f941e9ab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__848247f37908015a4b1de6270f15359071f8ec9ad8c722490dac1bdef30c9258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtl")
    def waiting_room_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCacheTtl"))

    @waiting_room_cache_ttl.setter
    def waiting_room_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfc9aab6d4175a2cb9a558990740c3c4f6847f0c1ccf58a59815791946f0324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvanced")
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAdvanced"))

    @waiting_room_cookie_advanced.setter
    def waiting_room_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659fb8a31e9739b4eae03763931825d65317c920dfd7fd13c9bfea991a2da323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSalt")
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAutomaticSalt"))

    @waiting_room_cookie_automatic_salt.setter
    def waiting_room_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6019490a5ac4f62eb0fefbbfa87fa1218e7f5bde4364c390205f4a871d7bcd9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomain")
    def waiting_room_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomain"))

    @waiting_room_cookie_domain.setter
    def waiting_room_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82144bc2589f632e3dca351d321cd68a72622ffce5c75a4e6f854827be270af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainType")
    def waiting_room_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomainType"))

    @waiting_room_cookie_domain_type.setter
    def waiting_room_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eac5e2063599258108f5b5f1be058db3789ba998aa5d962cf0c3d4b47597ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDuration")
    def waiting_room_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCookieDuration"))

    @waiting_room_cookie_duration.setter
    def waiting_room_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8552699ba67dbd7edcca0e8f77152ded9f6d17ffa4ac4c64971112cb8863fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabled")
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieEnabled"))

    @waiting_room_cookie_enabled.setter
    def waiting_room_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d95649e668e7e7ca6876b4d27370036442698129a4009a1f9fa4d607a156b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnly")
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieHttpOnly"))

    @waiting_room_cookie_http_only.setter
    def waiting_room_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329535c2e562c127acdb1745f20cc906fe6fecd9b8e4b215fe477e6253d48589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabel")
    def waiting_room_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieLabel"))

    @waiting_room_cookie_label.setter
    def waiting_room_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f26c51bb4629e1f59d879d87fbfb0e1b372414987bd9b0c4fc20d82aeb66ad99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitle")
    def waiting_room_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieManagementTitle"))

    @waiting_room_cookie_management_title.setter
    def waiting_room_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2f71774d4d01015475775a36b3ee2760a281a1e0c28234a8d0bf5849f632ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSalt")
    def waiting_room_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieSalt"))

    @waiting_room_cookie_salt.setter
    def waiting_room_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__018cc22597529fdc9d022b2b75dac34b85d79b48999ce7a3da8e5f0a12963ed6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabel")
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieShareLabel"))

    @waiting_room_cookie_share_label.setter
    def waiting_room_cookie_share_label(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a0d175daaa97c0afc2364ba6377c8adf20f9921cf1039392ff3f91143b578a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieShareLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectory")
    def waiting_room_directory(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomDirectory"))

    @waiting_room_directory.setter
    def waiting_room_directory(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1f06945277bafcfd528e4b90a91dc454ed0fc71b638e52bd34d09325b0e97d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitle")
    def waiting_room_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomManagementTitle"))

    @waiting_room_management_title.setter
    def waiting_room_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9611d43ed35b8ce1d31810b8aea0858c1a82ceca3909e07c6131642f5b72804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCode")
    def waiting_room_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomStatusCode"))

    @waiting_room_status_code.setter
    def waiting_room_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a93669726d5f16efbf2a6bf4168b7e819e830656781f4f3ecf7c048fc77f18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCode")
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomUseCpCode"))

    @waiting_room_use_cp_code.setter
    def waiting_room_use_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37bf3452f01c786b8acabdafc83d736f3847b1743241cc421033c2bff23d67b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomUseCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb58bd90804c9ba3c4eae303ec61dbc587ec480a1e8f661be3631f33ed7f6632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b56b450f98e16ef18b1c647d844842db9633e574575e51c4725222c09d8d4b)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa18c3c77b6543af669c9932411673d5ff409b8f2bb22efc1294737fb0bc5766)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5817f898663bbe51d212973b62e41feb9b5f3f241de2478487f36f28838902e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204ca7fd3b9846961b4f2f67bc993d1f1c441bee999183140b42bfeeb14ab58a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fee540366bfcace3fd5e5397b9118ab21d811162ddfa1fe2399eb0852ffb64a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ae7723745603a5649832348275d93d20da26fb0c8c67c99bbbcbda55979ab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a1490a2237deeefe5b6099175c717692136d866e30eeb7f2b6d5baea2e6529)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305e796e49904a3ae04271e62ef5f9326b1595b297a88841c1e65894d6977fea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1e9cac90fd00e2aab66ff4169d3c160b009cd0d67fc099e63a8efa4fd9601e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a0ad2fdff7957ee45bfe9e85b697fe05024847ee46210ade84cde213a79a5ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a7a3fca3b2edf61c534962dec62f051008a46f7cc876d793309fda8a5b80e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5694846ca6ba8c47c2ba4320e70625895d5bddcbc3e223f278dd7c85c5ad749e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc09acdeb9c3788f8abdb3aaf8c89d19be8d45f851e195d4e7cc7b84aa0a73e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a65720d3553a93dcafd793ca4d3af9d4f480f1152c635af6852171319cc6532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790d1cc634e4a9a552b630d2d8fdaaad4de6beea3f40c8302af74052c5237985)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2487e9646f398b35c2219e199237508202498d592e55f50c0802293be7ef902b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421301ac2eb348dab2fd6c16d49b86475eecce6b34067bec7654e67f97dec340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52cf7959bd7f0149f332e7a12e086bf0f8e3c9217cc8ad7eac12228aeb857801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db4d23decaad2ac8b74f238969c065552b616979da9f06542d32d60e89f4558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098add49d3b51a7968c99e19b6a032d8782025a6283493db7cdc5a6f97811b11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking",
    jsii_struct_bases=[],
    name_mapping={
        "ab_variant_location": "abVariantLocation",
        "decryption_password1": "decryptionPassword1",
        "decryption_password2": "decryptionPassword2",
        "decryption_password_id1": "decryptionPasswordId1",
        "decryption_password_id2": "decryptionPasswordId2",
        "enable": "enable",
        "locked": "locked",
        "miscellaneous_settings_title": "miscellaneousSettingsTitle",
        "pattern_decryption_enable": "patternDecryptionEnable",
        "pattern_encryption_title": "patternEncryptionTitle",
        "signature_verification_enable": "signatureVerificationEnable",
        "template_uuid": "templateUuid",
        "token_signing_title": "tokenSigningTitle",
        "use_original_as_a": "useOriginalAsA",
        "uuid": "uuid",
        "verification_key_id1": "verificationKeyId1",
        "verification_key_id2": "verificationKeyId2",
        "verification_public_key1": "verificationPublicKey1",
        "verification_public_key2": "verificationPublicKey2",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking:
    def __init__(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220fbb05e974b35e4613db953355df67902db636dbfd05e5f67e1a234797676c)
            check_type(argname="argument ab_variant_location", value=ab_variant_location, expected_type=type_hints["ab_variant_location"])
            check_type(argname="argument decryption_password1", value=decryption_password1, expected_type=type_hints["decryption_password1"])
            check_type(argname="argument decryption_password2", value=decryption_password2, expected_type=type_hints["decryption_password2"])
            check_type(argname="argument decryption_password_id1", value=decryption_password_id1, expected_type=type_hints["decryption_password_id1"])
            check_type(argname="argument decryption_password_id2", value=decryption_password_id2, expected_type=type_hints["decryption_password_id2"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument miscellaneous_settings_title", value=miscellaneous_settings_title, expected_type=type_hints["miscellaneous_settings_title"])
            check_type(argname="argument pattern_decryption_enable", value=pattern_decryption_enable, expected_type=type_hints["pattern_decryption_enable"])
            check_type(argname="argument pattern_encryption_title", value=pattern_encryption_title, expected_type=type_hints["pattern_encryption_title"])
            check_type(argname="argument signature_verification_enable", value=signature_verification_enable, expected_type=type_hints["signature_verification_enable"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_signing_title", value=token_signing_title, expected_type=type_hints["token_signing_title"])
            check_type(argname="argument use_original_as_a", value=use_original_as_a, expected_type=type_hints["use_original_as_a"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_key_id1", value=verification_key_id1, expected_type=type_hints["verification_key_id1"])
            check_type(argname="argument verification_key_id2", value=verification_key_id2, expected_type=type_hints["verification_key_id2"])
            check_type(argname="argument verification_public_key1", value=verification_public_key1, expected_type=type_hints["verification_public_key1"])
            check_type(argname="argument verification_public_key2", value=verification_public_key2, expected_type=type_hints["verification_public_key2"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_variant_location is not None:
            self._values["ab_variant_location"] = ab_variant_location
        if decryption_password1 is not None:
            self._values["decryption_password1"] = decryption_password1
        if decryption_password2 is not None:
            self._values["decryption_password2"] = decryption_password2
        if decryption_password_id1 is not None:
            self._values["decryption_password_id1"] = decryption_password_id1
        if decryption_password_id2 is not None:
            self._values["decryption_password_id2"] = decryption_password_id2
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if miscellaneous_settings_title is not None:
            self._values["miscellaneous_settings_title"] = miscellaneous_settings_title
        if pattern_decryption_enable is not None:
            self._values["pattern_decryption_enable"] = pattern_decryption_enable
        if pattern_encryption_title is not None:
            self._values["pattern_encryption_title"] = pattern_encryption_title
        if signature_verification_enable is not None:
            self._values["signature_verification_enable"] = signature_verification_enable
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_signing_title is not None:
            self._values["token_signing_title"] = token_signing_title
        if use_original_as_a is not None:
            self._values["use_original_as_a"] = use_original_as_a
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_key_id1 is not None:
            self._values["verification_key_id1"] = verification_key_id1
        if verification_key_id2 is not None:
            self._values["verification_key_id2"] = verification_key_id2
        if verification_public_key1 is not None:
            self._values["verification_public_key1"] = verification_public_key1
        if verification_public_key2 is not None:
            self._values["verification_public_key2"] = verification_public_key2

    @builtins.property
    def ab_variant_location(self) -> typing.Optional[builtins.str]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        '''
        result = self._values.get("ab_variant_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password1(self) -> typing.Optional[builtins.str]:
        '''Provides the primary password used to encrypt patterns in your watermarking tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        '''
        result = self._values.get("decryption_password1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password2(self) -> typing.Optional[builtins.str]:
        '''Provides the secondary password you can use to rotate passwords.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        '''
        result = self._values.get("decryption_password2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a label that corresponds to the primary password.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        '''
        result = self._values.get("decryption_password_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        '''
        result = self._values.get("decryption_password_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the watermarking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def miscellaneous_settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        '''
        result = self._values.get("miscellaneous_settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def pattern_decryption_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        '''
        result = self._values.get("pattern_decryption_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pattern_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        '''
        result = self._values.get("pattern_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signature_verification_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can verify the signature in your watermarking token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        '''
        result = self._values.get("signature_verification_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_signing_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        '''
        result = self._values.get("token_signing_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_original_as_a(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        '''
        result = self._values.get("use_original_as_a")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the first public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        '''
        result = self._values.get("verification_key_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the optional second public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        '''
        result = self._values.get("verification_key_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key1(self) -> typing.Optional[builtins.str]:
        '''Specifies the first public key in its entirety.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        '''
        result = self._values.get("verification_public_key1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key2(self) -> typing.Optional[builtins.str]:
        '''Specifies the optional second public key in its entirety. Specify a second key to enable rotation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        result = self._values.get("verification_public_key2")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarkingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarkingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e389f46b1c7fa5892b5dea6260658825b3e110163ea161cc2357e392cc19fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbVariantLocation")
    def reset_ab_variant_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbVariantLocation", []))

    @jsii.member(jsii_name="resetDecryptionPassword1")
    def reset_decryption_password1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword1", []))

    @jsii.member(jsii_name="resetDecryptionPassword2")
    def reset_decryption_password2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword2", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId1")
    def reset_decryption_password_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId1", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId2")
    def reset_decryption_password_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId2", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMiscellaneousSettingsTitle")
    def reset_miscellaneous_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMiscellaneousSettingsTitle", []))

    @jsii.member(jsii_name="resetPatternDecryptionEnable")
    def reset_pattern_decryption_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternDecryptionEnable", []))

    @jsii.member(jsii_name="resetPatternEncryptionTitle")
    def reset_pattern_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternEncryptionTitle", []))

    @jsii.member(jsii_name="resetSignatureVerificationEnable")
    def reset_signature_verification_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignatureVerificationEnable", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenSigningTitle")
    def reset_token_signing_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenSigningTitle", []))

    @jsii.member(jsii_name="resetUseOriginalAsA")
    def reset_use_original_as_a(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOriginalAsA", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationKeyId1")
    def reset_verification_key_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId1", []))

    @jsii.member(jsii_name="resetVerificationKeyId2")
    def reset_verification_key_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId2", []))

    @jsii.member(jsii_name="resetVerificationPublicKey1")
    def reset_verification_public_key1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey1", []))

    @jsii.member(jsii_name="resetVerificationPublicKey2")
    def reset_verification_public_key2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey2", []))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocationInput")
    def ab_variant_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abVariantLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1Input")
    def decryption_password1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2Input")
    def decryption_password2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword2Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1Input")
    def decryption_password_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2Input")
    def decryption_password_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId2Input"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitleInput")
    def miscellaneous_settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "miscellaneousSettingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnableInput")
    def pattern_decryption_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "patternDecryptionEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitleInput")
    def pattern_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "patternEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnableInput")
    def signature_verification_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "signatureVerificationEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitleInput")
    def token_signing_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenSigningTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsAInput")
    def use_original_as_a_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOriginalAsAInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1Input")
    def verification_key_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2Input")
    def verification_key_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId2Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1Input")
    def verification_public_key1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2Input")
    def verification_public_key2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey2Input"))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocation")
    def ab_variant_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abVariantLocation"))

    @ab_variant_location.setter
    def ab_variant_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1584aa2ca6230eccad5f61961355bf3e38c09c487ef285e66945cae92114fe90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abVariantLocation", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1")
    def decryption_password1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword1"))

    @decryption_password1.setter
    def decryption_password1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__620811ac78d90d76db33c060be8f5bb1e9c0c9cdbbe7f702358c47501a50b639)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2")
    def decryption_password2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword2"))

    @decryption_password2.setter
    def decryption_password2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a14357d50dcb24628a1f0648a839201cfb7415d685d27a9898e5588f2c00828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword2", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1")
    def decryption_password_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId1"))

    @decryption_password_id1.setter
    def decryption_password_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3892eecd6a9ff6be77431b25c9af8ab610bb6defb9cce6f84257c5acbc543735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2")
    def decryption_password_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId2"))

    @decryption_password_id2.setter
    def decryption_password_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b5b0106fe0842e037cd6c832fb0d923a78e2ba63797e02509ad41ca25e8c0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId2", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0e1d8a1c7b258393fe82b04e6e5340fa77d3322691bad16680e2f3404fbbef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0832e1c5eceb3fdd4f3105333ecd34e69492e6fa50daf34812d2dbbd1c10b9a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitle")
    def miscellaneous_settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "miscellaneousSettingsTitle"))

    @miscellaneous_settings_title.setter
    def miscellaneous_settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa0762163e7ba94d152232299283ef8670cbb7279c2de8edf5d8b4eb7142f389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "miscellaneousSettingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnable")
    def pattern_decryption_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "patternDecryptionEnable"))

    @pattern_decryption_enable.setter
    def pattern_decryption_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b968b1a2e0950f5688e9c1e354b4e4ed750bf7915dfe1858403e151b495ddeb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternDecryptionEnable", value)

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitle")
    def pattern_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "patternEncryptionTitle"))

    @pattern_encryption_title.setter
    def pattern_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a9141c69dbb5f7b0ce77bad402716884bf8225fdf22cd6ad4497a1ef68175d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnable")
    def signature_verification_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "signatureVerificationEnable"))

    @signature_verification_enable.setter
    def signature_verification_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caea0e6f83cbc9c9232fef0fe7964029661f2879b5e1baa3c0a1ef4e1c309d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signatureVerificationEnable", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5917334e44278d8af165d66f865aca636c64854a34c5859df08c9fe029f04b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitle")
    def token_signing_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenSigningTitle"))

    @token_signing_title.setter
    def token_signing_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6243c744c559d595ef15f5284033775166996de184a86af54d7447cd2bab39b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenSigningTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsA")
    def use_original_as_a(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOriginalAsA"))

    @use_original_as_a.setter
    def use_original_as_a(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a75b8cd3e7717ebc5c7c67c3e064a304bec4c860a4a9ffc25c1269b0291e99c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOriginalAsA", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea84b05a03080062549c0dbbd1ad3e1f4cc89e5d03723787ff3e2c68a1674a37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1")
    def verification_key_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId1"))

    @verification_key_id1.setter
    def verification_key_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d536459503c77241993bef5f38c2ae1be1c8e638c5dda9695f06408fd208ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2")
    def verification_key_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId2"))

    @verification_key_id2.setter
    def verification_key_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8381832f1296437736096c39a9ec8b1dc7ee43c83dc958f97b5759a2c355896)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId2", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1")
    def verification_public_key1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey1"))

    @verification_public_key1.setter
    def verification_public_key1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a66f0df8abe7fe0ca1733e84e82bf0701da1335ba1e5005391a651292a3a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2")
    def verification_public_key2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey2"))

    @verification_public_key2.setter
    def verification_public_key2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0978e2bc22ad1e7b9e8f8499ced48927a95cf1f141088308319e2f47ebcfda4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey2", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94315385346ac19a8aadda06e34865b1b5651175c7b4870423a5e0d3a6d8e434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall",
    jsii_struct_bases=[],
    name_mapping={
        "firewall_configuration": "firewallConfiguration",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall:
    def __init__(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(firewall_configuration, dict):
            firewall_configuration = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration(**firewall_configuration)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cb9427c2ae05a6d83f333cb66f13b62d0c5d59676bbd969b7b880074d176908)
            check_type(argname="argument firewall_configuration", value=firewall_configuration, expected_type=type_hints["firewall_configuration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if firewall_configuration is not None:
            self._values["firewall_configuration"] = firewall_configuration
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def firewall_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration"]:
        '''firewall_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        '''
        result = self._values.get("firewall_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration"], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "config_id": "configId",
        "file_name": "fileName",
        "production_status": "productionStatus",
        "production_version": "productionVersion",
        "staging_status": "stagingStatus",
        "staging_version": "stagingVersion",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration:
    def __init__(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0569453f9304ea3c437c5ad45ac3657ab882ba459b3b37a944797acbbb94b4b9)
            check_type(argname="argument config_id", value=config_id, expected_type=type_hints["config_id"])
            check_type(argname="argument file_name", value=file_name, expected_type=type_hints["file_name"])
            check_type(argname="argument production_status", value=production_status, expected_type=type_hints["production_status"])
            check_type(argname="argument production_version", value=production_version, expected_type=type_hints["production_version"])
            check_type(argname="argument staging_status", value=staging_status, expected_type=type_hints["staging_status"])
            check_type(argname="argument staging_version", value=staging_version, expected_type=type_hints["staging_version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_id is not None:
            self._values["config_id"] = config_id
        if file_name is not None:
            self._values["file_name"] = file_name
        if production_status is not None:
            self._values["production_status"] = production_status
        if production_version is not None:
            self._values["production_version"] = production_version
        if staging_status is not None:
            self._values["staging_status"] = staging_status
        if staging_version is not None:
            self._values["staging_version"] = staging_version

    @builtins.property
    def config_id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.'''
        result = self._values.get("config_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def file_name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        '''
        result = self._values.get("file_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        '''
        result = self._values.get("production_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        '''
        result = self._values.get("production_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def staging_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        '''
        result = self._values.get("staging_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def staging_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        result = self._values.get("staging_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e3e6c2c68b1188bb25b8cd3a25e9562b278729520cc4c6feb1a3d08ead6651f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigId")
    def reset_config_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigId", []))

    @jsii.member(jsii_name="resetFileName")
    def reset_file_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileName", []))

    @jsii.member(jsii_name="resetProductionStatus")
    def reset_production_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionStatus", []))

    @jsii.member(jsii_name="resetProductionVersion")
    def reset_production_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionVersion", []))

    @jsii.member(jsii_name="resetStagingStatus")
    def reset_staging_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingStatus", []))

    @jsii.member(jsii_name="resetStagingVersion")
    def reset_staging_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingVersion", []))

    @builtins.property
    @jsii.member(jsii_name="configIdInput")
    def config_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "configIdInput"))

    @builtins.property
    @jsii.member(jsii_name="fileNameInput")
    def file_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fileNameInput"))

    @builtins.property
    @jsii.member(jsii_name="productionStatusInput")
    def production_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "productionStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="productionVersionInput")
    def production_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "productionVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingStatusInput")
    def staging_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stagingStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingVersionInput")
    def staging_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "stagingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="configId")
    def config_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "configId"))

    @config_id.setter
    def config_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebaa1f4d8500b1cb4961e91ca1385247d67b77461798f17e0537218d776588b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configId", value)

    @builtins.property
    @jsii.member(jsii_name="fileName")
    def file_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fileName"))

    @file_name.setter
    def file_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41140cc19dcb9bcada4ce2f6d99c73d88f4071d2d24eb0f4e0710ec1c6c9a5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fileName", value)

    @builtins.property
    @jsii.member(jsii_name="productionStatus")
    def production_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "productionStatus"))

    @production_status.setter
    def production_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983608a535ca27956d061b88a6ad87ce53889527110cf9bd139a86ddc84d0d47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionStatus", value)

    @builtins.property
    @jsii.member(jsii_name="productionVersion")
    def production_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "productionVersion"))

    @production_version.setter
    def production_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__addea865c5178038eb25e22871561b28c5b0a9b733c2aec77079d37f7e90f761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionVersion", value)

    @builtins.property
    @jsii.member(jsii_name="stagingStatus")
    def staging_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stagingStatus"))

    @staging_status.setter
    def staging_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__733dde2ca2c8c0ab19eded9466f4d3554165cd9d7a2dab0ae81d99c313414e94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingStatus", value)

    @builtins.property
    @jsii.member(jsii_name="stagingVersion")
    def staging_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "stagingVersion"))

    @staging_version.setter
    def staging_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fdd86617745778a19dadbc1dc5460f797038250ea7f7eb0fc66b4dd70884445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025fae8655ff06cef10c1879fe16c814b5c9b324f2009fb0872f1690418a19b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400b0432257c14741abf08b839bd345ee6c4bb5eff64c07c40c93605bdc2a84d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFirewallConfiguration")
    def put_firewall_configuration(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration(
            config_id=config_id,
            file_name=file_name,
            production_status=production_status,
            production_version=production_version,
            staging_status=staging_status,
            staging_version=staging_version,
        )

        return typing.cast(None, jsii.invoke(self, "putFirewallConfiguration", [value]))

    @jsii.member(jsii_name="resetFirewallConfiguration")
    def reset_firewall_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirewallConfiguration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="firewallConfiguration")
    def firewall_configuration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfigurationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfigurationOutputReference, jsii.get(self, "firewallConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="firewallConfigurationInput")
    def firewall_configuration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "firewallConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892d59acd5baba4ddf6a22de6b7819be892f5646327618edcfe8e4590d4bf9aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac49a8076428bcd8f32dbbe2055c79e95fdd70974f02ff0dd5dfd4b24b432260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee9bf40a3eda224ea788bf96bb0cb985b57c6a74e045023641f1a481216b6c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99076a4df686917ff58a9b59e449741f95ab7431120033cc1f9737c078f0c800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f76be085119e41149d911bfe5f0103a783972b2e7b4e56aa0abf2988742734)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables WebSocket traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSocketsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSocketsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f3206677132b23f719feba16ee217777dc63be3e880ba261c69a105e4436be1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abf9fd6aff3025cdb7405cf8ce53686deae9cd5a86ef0b4b1c057e38fd684645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776d4ffd2d33bb6b773f452292f1065b2728a8f6ad7fbd9f583defb97b118d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27fcf3dea89c10c3035680295deec78925333e99804f6f720e213e300a0b479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dca4a97e355b94ad71d60a19e02895a2e7d594282c7a1e2c578436ac859c8a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8e6da137664475c64a605bf7573becfb570408e47f78b4143d54ec99b1c32d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c2952ff3eec86e3c056436315f0b5f95ad3816ee36584d62960239e178b10f9)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the WebDAV behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdavOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdavOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a32456f13f18cc9d43a6ea6f9ced23eed6813add9c5d7f1352f9e7c05f057af7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8af512183c25813903e1f9aac9ea0b792a45eb7d8b71305613101f73efc8327e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c82eef3a2f08e662f160b7cbbb2ef8d9bffdebf2c57463fb44a980397cddc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec409750b2744eade5382b5c50f0c970b14afeca266cce1838bb290081958b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb62cf6f2dfbae9cb6be5e023a54b8b20c1f483522cb22c354dc59549888a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd37e2e8ed709f2ff5fb3427c05b86b0cdd3af74ea1c957ef990a98741e8e63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105Criterion",
    jsii_struct_bases=[],
    name_mapping={
        "advanced_im_match": "advancedImMatch",
        "bucket": "bucket",
        "cacheability": "cacheability",
        "china_cdn_region": "chinaCdnRegion",
        "client_certificate": "clientCertificate",
        "client_ip": "clientIp",
        "client_ip_version": "clientIpVersion",
        "cloudlets_origin": "cloudletsOrigin",
        "content_delivery_network": "contentDeliveryNetwork",
        "content_type": "contentType",
        "device_characteristic": "deviceCharacteristic",
        "ecmd_auth_groups": "ecmdAuthGroups",
        "ecmd_auth_scheme": "ecmdAuthScheme",
        "ecmd_is_authenticated": "ecmdIsAuthenticated",
        "ecmd_username": "ecmdUsername",
        "edge_workers_failure": "edgeWorkersFailure",
        "file_extension": "fileExtension",
        "filename": "filename",
        "hostname": "hostname",
        "match_advanced": "matchAdvanced",
        "match_cp_code": "matchCpCode",
        "match_response_code": "matchResponseCode",
        "match_variable": "matchVariable",
        "metadata_stage": "metadataStage",
        "origin_timeout": "originTimeout",
        "path": "path",
        "query_string_parameter": "queryStringParameter",
        "random": "random",
        "recovery_config": "recoveryConfig",
        "regular_expression": "regularExpression",
        "request_cookie": "requestCookie",
        "request_header": "requestHeader",
        "request_method": "requestMethod",
        "request_protocol": "requestProtocol",
        "request_type": "requestType",
        "response_header": "responseHeader",
        "time": "time",
        "token_authorization": "tokenAuthorization",
        "user_agent": "userAgent",
        "user_location": "userLocation",
        "user_network": "userNetwork",
        "variable_error": "variableError",
        "virtual_waiting_room_request": "virtualWaitingRoomRequest",
        "visitor_prioritization_request": "visitorPrioritizationRequest",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105Criterion:
    def __init__(
        self,
        *,
        advanced_im_match: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch", typing.Dict[builtins.str, typing.Any]]] = None,
        bucket: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket", typing.Dict[builtins.str, typing.Any]]] = None,
        cacheability: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability", typing.Dict[builtins.str, typing.Any]]] = None,
        china_cdn_region: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip_version: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlets_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        content_delivery_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        content_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_scheme: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_is_authenticated: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_username: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_workers_failure: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure", typing.Dict[builtins.str, typing.Any]]] = None,
        file_extension: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension", typing.Dict[builtins.str, typing.Any]]] = None,
        filename: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename", typing.Dict[builtins.str, typing.Any]]] = None,
        hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        match_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        match_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_stage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        path: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath", typing.Dict[builtins.str, typing.Any]]] = None,
        query_string_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        random: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom", typing.Dict[builtins.str, typing.Any]]] = None,
        recovery_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        regular_expression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression", typing.Dict[builtins.str, typing.Any]]] = None,
        request_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        request_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        request_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType", typing.Dict[builtins.str, typing.Any]]] = None,
        response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        time: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime", typing.Dict[builtins.str, typing.Any]]] = None,
        token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        user_agent: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent", typing.Dict[builtins.str, typing.Any]]] = None,
        user_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        user_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        variable_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param advanced_im_match: advanced_im_match block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        :param bucket: bucket block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param cacheability: cacheability block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        :param china_cdn_region: china_cdn_region block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        :param client_certificate: client_certificate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        :param client_ip: client_ip block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        :param client_ip_version: client_ip_version block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        :param cloudlets_origin: cloudlets_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        :param content_delivery_network: content_delivery_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        :param content_type: content_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param device_characteristic: device_characteristic block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        :param ecmd_auth_groups: ecmd_auth_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        :param ecmd_auth_scheme: ecmd_auth_scheme block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        :param ecmd_is_authenticated: ecmd_is_authenticated block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        :param ecmd_username: ecmd_username block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        :param edge_workers_failure: edge_workers_failure block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        :param file_extension: file_extension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        :param filename: filename block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        :param hostname: hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param match_advanced: match_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        :param match_cp_code: match_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        :param match_response_code: match_response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        :param match_variable: match_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        :param metadata_stage: metadata_stage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        :param origin_timeout: origin_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        :param path: path block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param query_string_parameter: query_string_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        :param random: random block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        :param recovery_config: recovery_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        :param regular_expression: regular_expression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        :param request_cookie: request_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        :param request_header: request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        :param request_method: request_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        :param request_protocol: request_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        :param request_type: request_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param response_header: response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        :param time: time block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        :param token_authorization: token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param user_agent: user_agent block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        :param user_location: user_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        :param user_network: user_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        :param variable_error: variable_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        :param virtual_waiting_room_request: virtual_waiting_room_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        :param visitor_prioritization_request: visitor_prioritization_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        if isinstance(advanced_im_match, dict):
            advanced_im_match = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch(**advanced_im_match)
        if isinstance(bucket, dict):
            bucket = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket(**bucket)
        if isinstance(cacheability, dict):
            cacheability = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability(**cacheability)
        if isinstance(china_cdn_region, dict):
            china_cdn_region = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion(**china_cdn_region)
        if isinstance(client_certificate, dict):
            client_certificate = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate(**client_certificate)
        if isinstance(client_ip, dict):
            client_ip = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp(**client_ip)
        if isinstance(client_ip_version, dict):
            client_ip_version = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion(**client_ip_version)
        if isinstance(cloudlets_origin, dict):
            cloudlets_origin = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin(**cloudlets_origin)
        if isinstance(content_delivery_network, dict):
            content_delivery_network = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork(**content_delivery_network)
        if isinstance(content_type, dict):
            content_type = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType(**content_type)
        if isinstance(device_characteristic, dict):
            device_characteristic = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic(**device_characteristic)
        if isinstance(ecmd_auth_groups, dict):
            ecmd_auth_groups = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups(**ecmd_auth_groups)
        if isinstance(ecmd_auth_scheme, dict):
            ecmd_auth_scheme = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme(**ecmd_auth_scheme)
        if isinstance(ecmd_is_authenticated, dict):
            ecmd_is_authenticated = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated(**ecmd_is_authenticated)
        if isinstance(ecmd_username, dict):
            ecmd_username = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername(**ecmd_username)
        if isinstance(edge_workers_failure, dict):
            edge_workers_failure = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure(**edge_workers_failure)
        if isinstance(file_extension, dict):
            file_extension = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension(**file_extension)
        if isinstance(filename, dict):
            filename = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename(**filename)
        if isinstance(hostname, dict):
            hostname = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname(**hostname)
        if isinstance(match_advanced, dict):
            match_advanced = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced(**match_advanced)
        if isinstance(match_cp_code, dict):
            match_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode(**match_cp_code)
        if isinstance(match_response_code, dict):
            match_response_code = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode(**match_response_code)
        if isinstance(match_variable, dict):
            match_variable = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable(**match_variable)
        if isinstance(metadata_stage, dict):
            metadata_stage = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage(**metadata_stage)
        if isinstance(origin_timeout, dict):
            origin_timeout = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout(**origin_timeout)
        if isinstance(path, dict):
            path = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath(**path)
        if isinstance(query_string_parameter, dict):
            query_string_parameter = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter(**query_string_parameter)
        if isinstance(random, dict):
            random = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom(**random)
        if isinstance(recovery_config, dict):
            recovery_config = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig(**recovery_config)
        if isinstance(regular_expression, dict):
            regular_expression = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression(**regular_expression)
        if isinstance(request_cookie, dict):
            request_cookie = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie(**request_cookie)
        if isinstance(request_header, dict):
            request_header = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader(**request_header)
        if isinstance(request_method, dict):
            request_method = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod(**request_method)
        if isinstance(request_protocol, dict):
            request_protocol = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol(**request_protocol)
        if isinstance(request_type, dict):
            request_type = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType(**request_type)
        if isinstance(response_header, dict):
            response_header = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader(**response_header)
        if isinstance(time, dict):
            time = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime(**time)
        if isinstance(token_authorization, dict):
            token_authorization = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization(**token_authorization)
        if isinstance(user_agent, dict):
            user_agent = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent(**user_agent)
        if isinstance(user_location, dict):
            user_location = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation(**user_location)
        if isinstance(user_network, dict):
            user_network = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork(**user_network)
        if isinstance(variable_error, dict):
            variable_error = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError(**variable_error)
        if isinstance(virtual_waiting_room_request, dict):
            virtual_waiting_room_request = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest(**virtual_waiting_room_request)
        if isinstance(visitor_prioritization_request, dict):
            visitor_prioritization_request = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest(**visitor_prioritization_request)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82db7952bb0ade63995916cbaca6edb5b5273c2829294799e1c3fee1974368a6)
            check_type(argname="argument advanced_im_match", value=advanced_im_match, expected_type=type_hints["advanced_im_match"])
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument cacheability", value=cacheability, expected_type=type_hints["cacheability"])
            check_type(argname="argument china_cdn_region", value=china_cdn_region, expected_type=type_hints["china_cdn_region"])
            check_type(argname="argument client_certificate", value=client_certificate, expected_type=type_hints["client_certificate"])
            check_type(argname="argument client_ip", value=client_ip, expected_type=type_hints["client_ip"])
            check_type(argname="argument client_ip_version", value=client_ip_version, expected_type=type_hints["client_ip_version"])
            check_type(argname="argument cloudlets_origin", value=cloudlets_origin, expected_type=type_hints["cloudlets_origin"])
            check_type(argname="argument content_delivery_network", value=content_delivery_network, expected_type=type_hints["content_delivery_network"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument device_characteristic", value=device_characteristic, expected_type=type_hints["device_characteristic"])
            check_type(argname="argument ecmd_auth_groups", value=ecmd_auth_groups, expected_type=type_hints["ecmd_auth_groups"])
            check_type(argname="argument ecmd_auth_scheme", value=ecmd_auth_scheme, expected_type=type_hints["ecmd_auth_scheme"])
            check_type(argname="argument ecmd_is_authenticated", value=ecmd_is_authenticated, expected_type=type_hints["ecmd_is_authenticated"])
            check_type(argname="argument ecmd_username", value=ecmd_username, expected_type=type_hints["ecmd_username"])
            check_type(argname="argument edge_workers_failure", value=edge_workers_failure, expected_type=type_hints["edge_workers_failure"])
            check_type(argname="argument file_extension", value=file_extension, expected_type=type_hints["file_extension"])
            check_type(argname="argument filename", value=filename, expected_type=type_hints["filename"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument match_advanced", value=match_advanced, expected_type=type_hints["match_advanced"])
            check_type(argname="argument match_cp_code", value=match_cp_code, expected_type=type_hints["match_cp_code"])
            check_type(argname="argument match_response_code", value=match_response_code, expected_type=type_hints["match_response_code"])
            check_type(argname="argument match_variable", value=match_variable, expected_type=type_hints["match_variable"])
            check_type(argname="argument metadata_stage", value=metadata_stage, expected_type=type_hints["metadata_stage"])
            check_type(argname="argument origin_timeout", value=origin_timeout, expected_type=type_hints["origin_timeout"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument query_string_parameter", value=query_string_parameter, expected_type=type_hints["query_string_parameter"])
            check_type(argname="argument random", value=random, expected_type=type_hints["random"])
            check_type(argname="argument recovery_config", value=recovery_config, expected_type=type_hints["recovery_config"])
            check_type(argname="argument regular_expression", value=regular_expression, expected_type=type_hints["regular_expression"])
            check_type(argname="argument request_cookie", value=request_cookie, expected_type=type_hints["request_cookie"])
            check_type(argname="argument request_header", value=request_header, expected_type=type_hints["request_header"])
            check_type(argname="argument request_method", value=request_method, expected_type=type_hints["request_method"])
            check_type(argname="argument request_protocol", value=request_protocol, expected_type=type_hints["request_protocol"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument response_header", value=response_header, expected_type=type_hints["response_header"])
            check_type(argname="argument time", value=time, expected_type=type_hints["time"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument user_agent", value=user_agent, expected_type=type_hints["user_agent"])
            check_type(argname="argument user_location", value=user_location, expected_type=type_hints["user_location"])
            check_type(argname="argument user_network", value=user_network, expected_type=type_hints["user_network"])
            check_type(argname="argument variable_error", value=variable_error, expected_type=type_hints["variable_error"])
            check_type(argname="argument virtual_waiting_room_request", value=virtual_waiting_room_request, expected_type=type_hints["virtual_waiting_room_request"])
            check_type(argname="argument visitor_prioritization_request", value=visitor_prioritization_request, expected_type=type_hints["visitor_prioritization_request"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced_im_match is not None:
            self._values["advanced_im_match"] = advanced_im_match
        if bucket is not None:
            self._values["bucket"] = bucket
        if cacheability is not None:
            self._values["cacheability"] = cacheability
        if china_cdn_region is not None:
            self._values["china_cdn_region"] = china_cdn_region
        if client_certificate is not None:
            self._values["client_certificate"] = client_certificate
        if client_ip is not None:
            self._values["client_ip"] = client_ip
        if client_ip_version is not None:
            self._values["client_ip_version"] = client_ip_version
        if cloudlets_origin is not None:
            self._values["cloudlets_origin"] = cloudlets_origin
        if content_delivery_network is not None:
            self._values["content_delivery_network"] = content_delivery_network
        if content_type is not None:
            self._values["content_type"] = content_type
        if device_characteristic is not None:
            self._values["device_characteristic"] = device_characteristic
        if ecmd_auth_groups is not None:
            self._values["ecmd_auth_groups"] = ecmd_auth_groups
        if ecmd_auth_scheme is not None:
            self._values["ecmd_auth_scheme"] = ecmd_auth_scheme
        if ecmd_is_authenticated is not None:
            self._values["ecmd_is_authenticated"] = ecmd_is_authenticated
        if ecmd_username is not None:
            self._values["ecmd_username"] = ecmd_username
        if edge_workers_failure is not None:
            self._values["edge_workers_failure"] = edge_workers_failure
        if file_extension is not None:
            self._values["file_extension"] = file_extension
        if filename is not None:
            self._values["filename"] = filename
        if hostname is not None:
            self._values["hostname"] = hostname
        if match_advanced is not None:
            self._values["match_advanced"] = match_advanced
        if match_cp_code is not None:
            self._values["match_cp_code"] = match_cp_code
        if match_response_code is not None:
            self._values["match_response_code"] = match_response_code
        if match_variable is not None:
            self._values["match_variable"] = match_variable
        if metadata_stage is not None:
            self._values["metadata_stage"] = metadata_stage
        if origin_timeout is not None:
            self._values["origin_timeout"] = origin_timeout
        if path is not None:
            self._values["path"] = path
        if query_string_parameter is not None:
            self._values["query_string_parameter"] = query_string_parameter
        if random is not None:
            self._values["random"] = random
        if recovery_config is not None:
            self._values["recovery_config"] = recovery_config
        if regular_expression is not None:
            self._values["regular_expression"] = regular_expression
        if request_cookie is not None:
            self._values["request_cookie"] = request_cookie
        if request_header is not None:
            self._values["request_header"] = request_header
        if request_method is not None:
            self._values["request_method"] = request_method
        if request_protocol is not None:
            self._values["request_protocol"] = request_protocol
        if request_type is not None:
            self._values["request_type"] = request_type
        if response_header is not None:
            self._values["response_header"] = response_header
        if time is not None:
            self._values["time"] = time
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if user_agent is not None:
            self._values["user_agent"] = user_agent
        if user_location is not None:
            self._values["user_location"] = user_location
        if user_network is not None:
            self._values["user_network"] = user_network
        if variable_error is not None:
            self._values["variable_error"] = variable_error
        if virtual_waiting_room_request is not None:
            self._values["virtual_waiting_room_request"] = virtual_waiting_room_request
        if visitor_prioritization_request is not None:
            self._values["visitor_prioritization_request"] = visitor_prioritization_request

    @builtins.property
    def advanced_im_match(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch"]:
        '''advanced_im_match block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        '''
        result = self._values.get("advanced_im_match")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch"], result)

    @builtins.property
    def bucket(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket"]:
        '''bucket block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket"], result)

    @builtins.property
    def cacheability(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability"]:
        '''cacheability block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        '''
        result = self._values.get("cacheability")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability"], result)

    @builtins.property
    def china_cdn_region(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion"]:
        '''china_cdn_region block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        '''
        result = self._values.get("china_cdn_region")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion"], result)

    @builtins.property
    def client_certificate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate"]:
        '''client_certificate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        '''
        result = self._values.get("client_certificate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate"], result)

    @builtins.property
    def client_ip(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp"]:
        '''client_ip block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        '''
        result = self._values.get("client_ip")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp"], result)

    @builtins.property
    def client_ip_version(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion"]:
        '''client_ip_version block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        '''
        result = self._values.get("client_ip_version")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion"], result)

    @builtins.property
    def cloudlets_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin"]:
        '''cloudlets_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        '''
        result = self._values.get("cloudlets_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin"], result)

    @builtins.property
    def content_delivery_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork"]:
        '''content_delivery_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        '''
        result = self._values.get("content_delivery_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork"], result)

    @builtins.property
    def content_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType"]:
        '''content_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType"], result)

    @builtins.property
    def device_characteristic(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic"]:
        '''device_characteristic block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        '''
        result = self._values.get("device_characteristic")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic"], result)

    @builtins.property
    def ecmd_auth_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups"]:
        '''ecmd_auth_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        '''
        result = self._values.get("ecmd_auth_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups"], result)

    @builtins.property
    def ecmd_auth_scheme(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme"]:
        '''ecmd_auth_scheme block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        '''
        result = self._values.get("ecmd_auth_scheme")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme"], result)

    @builtins.property
    def ecmd_is_authenticated(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated"]:
        '''ecmd_is_authenticated block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        '''
        result = self._values.get("ecmd_is_authenticated")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated"], result)

    @builtins.property
    def ecmd_username(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername"]:
        '''ecmd_username block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        '''
        result = self._values.get("ecmd_username")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername"], result)

    @builtins.property
    def edge_workers_failure(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure"]:
        '''edge_workers_failure block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        '''
        result = self._values.get("edge_workers_failure")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure"], result)

    @builtins.property
    def file_extension(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension"]:
        '''file_extension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        '''
        result = self._values.get("file_extension")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension"], result)

    @builtins.property
    def filename(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename"]:
        '''filename block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        '''
        result = self._values.get("filename")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename"], result)

    @builtins.property
    def hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname"]:
        '''hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname"], result)

    @builtins.property
    def match_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced"]:
        '''match_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        '''
        result = self._values.get("match_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced"], result)

    @builtins.property
    def match_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode"]:
        '''match_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        '''
        result = self._values.get("match_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode"], result)

    @builtins.property
    def match_response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode"]:
        '''match_response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        '''
        result = self._values.get("match_response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode"], result)

    @builtins.property
    def match_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable"]:
        '''match_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        '''
        result = self._values.get("match_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable"], result)

    @builtins.property
    def metadata_stage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage"]:
        '''metadata_stage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        '''
        result = self._values.get("metadata_stage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage"], result)

    @builtins.property
    def origin_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout"]:
        '''origin_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        '''
        result = self._values.get("origin_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout"], result)

    @builtins.property
    def path(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath"]:
        '''path block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath"], result)

    @builtins.property
    def query_string_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter"]:
        '''query_string_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        '''
        result = self._values.get("query_string_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter"], result)

    @builtins.property
    def random(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom"]:
        '''random block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        '''
        result = self._values.get("random")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom"], result)

    @builtins.property
    def recovery_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig"]:
        '''recovery_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        '''
        result = self._values.get("recovery_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig"], result)

    @builtins.property
    def regular_expression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression"]:
        '''regular_expression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        '''
        result = self._values.get("regular_expression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression"], result)

    @builtins.property
    def request_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie"]:
        '''request_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        '''
        result = self._values.get("request_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie"], result)

    @builtins.property
    def request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader"]:
        '''request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        '''
        result = self._values.get("request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader"], result)

    @builtins.property
    def request_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod"]:
        '''request_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        '''
        result = self._values.get("request_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod"], result)

    @builtins.property
    def request_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol"]:
        '''request_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        '''
        result = self._values.get("request_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol"], result)

    @builtins.property
    def request_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType"]:
        '''request_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType"], result)

    @builtins.property
    def response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader"]:
        '''response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        '''
        result = self._values.get("response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader"], result)

    @builtins.property
    def time(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime"]:
        '''time block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        '''
        result = self._values.get("time")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime"], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization"]:
        '''token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization"], result)

    @builtins.property
    def user_agent(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent"]:
        '''user_agent block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        '''
        result = self._values.get("user_agent")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent"], result)

    @builtins.property
    def user_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation"]:
        '''user_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        '''
        result = self._values.get("user_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation"], result)

    @builtins.property
    def user_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork"]:
        '''user_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        '''
        result = self._values.get("user_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork"], result)

    @builtins.property
    def variable_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError"]:
        '''variable_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        '''
        result = self._values.get("variable_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError"], result)

    @builtins.property
    def virtual_waiting_room_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest"]:
        '''virtual_waiting_room_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        '''
        result = self._values.get("virtual_waiting_room_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest"], result)

    @builtins.property
    def visitor_prioritization_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest"]:
        '''visitor_prioritization_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        result = self._values.get("visitor_prioritization_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105Criterion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa94a76f72a6ccd6aafbbd2a6ac4571b1b31459d21b8050b52a386c5c2d7c6b4)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3297b078d0fa0dd7b4d64f22d162687ad1388874e2864a5638816ed8d7917c34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e45417b467cd991a38ffeb99d72f5333ad05c95be333382d7a94902d96fa2d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195318daac84aacc923b030e1dbfafb24ea335107eb222f8e303bbf86a4357a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec8334c29f227978cb6f6e8f1a5a2964186af8a52c613b810f5aa8782f3529c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a39aaba4b3d166c9e68001d440a581426a29bab594f4504a467499f29ace5ca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e0e405e52557d32c29993db09da5a717b53a7c2ea389accf5fc48c40881e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5188c24cad6aedf98f102160dee14cfe3cf45ba53b42aeb663ee0099b67ecf30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "percentage": "percentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80e811a854a8a86bf5ea3b4aa00d566e34f3cde43fd34dcbc4cc54350da1638)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument percentage", value=percentage, expected_type=type_hints["percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if percentage is not None:
            self._values["percentage"] = percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of requests to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        '''
        result = self._values.get("percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucketOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucketOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25437d180c76a0e5b97eac11efe3a639cbe0debdfbef15e307edbb296dbee195)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPercentage")
    def reset_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="percentageInput")
    def percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "percentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc98c01bc34c4f17cea335aee97ec5586cafb8dcd3179b64e977f1913c0c044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="percentage")
    def percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "percentage"))

    @percentage.setter
    def percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674acc5e7abcb96cd0db179746b3ac0b202bebda599aa1db5aff59f79a51013a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "percentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8437a84db19e36179622a066ff60e5cdd150b526e97753f621e9cc2ccf58afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06fdecce3641321800aa4950d23f603166efb5188fa23de0f37250af58154dd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9e34ce675f2ef5e9ee43d18cd94813696cb97ad11ec3ba4a8c80bdb29eea6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69959369c3d8ef0be2adf58353c6633cf59913f2a12de5ca2cbf84a099fc335c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheabilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheabilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eef334af84d5341c0b6c19c3437d537993a00bd733ef5d60b51336e283a755e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ecfc52eda4ddd19bde5f916d26d77d5ef601c89221307e84f7660662b41c47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcbb2d195037e6fdb0b2154828ddc3fbe6b677d2bf517bd39843c5b3f47b336e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987ef285d0dce6e07a5d8b31fe56a977e3db3c1b229003cc3a1dfcbeb8de1f71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709cf6f1b591ed769d51fccfb7cc56a5639db3f2d5390e3d66b1f7bb5e1b16fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbecda0535edffb74dfe547a4146eac396cd74b8ba73a11c488d060ebf26b101)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea42a88737d759c17cc2e835a5c07d36c01038176ab0a871e609b5bb4a72a0ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eedad2ed38e2d319716388de2437fd87040eb7e7c66d8b3f4903b1de86e7381e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b762395447592740fc13393b22baf16dd0b3e92927983733e5d74ba42893f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5989bbf491a146f4fb9cd6421201ace68d245e4a1067a15a28d1eadf67efe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1b04472eb827a07b83f56e54ba601217d21a060945f0386faf8c55d847d6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f761641b5489d2fd0c4fe5fb12ea4f78f068b84807e7942076e575e17fb7a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4cb9e8f09ab1dd65e52dfd3e4ba486f832b4f50bc7ea99bb8f694b0e3a9f70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c789586f621cf4f47c3cbed3c236e511510fc62c127985fb32b4d8aacfb2f355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate",
    jsii_struct_bases=[],
    name_mapping={
        "is_certificate_present": "isCertificatePresent",
        "is_certificate_valid": "isCertificateValid",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate:
    def __init__(
        self,
        *,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__decacae98fb6ee331d58d894cd83bd772be8c0119e78bc1e471dd3efeb1f1b64)
            check_type(argname="argument is_certificate_present", value=is_certificate_present, expected_type=type_hints["is_certificate_present"])
            check_type(argname="argument is_certificate_valid", value=is_certificate_valid, expected_type=type_hints["is_certificate_valid"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if is_certificate_present is not None:
            self._values["is_certificate_present"] = is_certificate_present
        if is_certificate_valid is not None:
            self._values["is_certificate_valid"] = is_certificate_valid
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def is_certificate_present(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Executes rule behaviors only if a client certificate authenticates requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        '''
        result = self._values.get("is_certificate_present")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_valid(self) -> typing.Optional[builtins.str]:
        '''Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        '''
        result = self._values.get("is_certificate_valid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c45d61d26412c2a626c35c344faefa18b0caa83df80159b0fb9840c94cd61116)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetIsCertificatePresent")
    def reset_is_certificate_present(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificatePresent", []))

    @jsii.member(jsii_name="resetIsCertificateValid")
    def reset_is_certificate_valid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateValid", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresentInput")
    def is_certificate_present_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificatePresentInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateValidInput")
    def is_certificate_valid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "isCertificateValidInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresent")
    def is_certificate_present(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificatePresent"))

    @is_certificate_present.setter
    def is_certificate_present(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728bae78f0cd9d927948b02724a7068cfffbd99e67dc597ee7dfe3e54f9c9340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificatePresent", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateValid")
    def is_certificate_valid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "isCertificateValid"))

    @is_certificate_valid.setter
    def is_certificate_valid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010cc5cc024a61616a2d890661d7918c03cbc8ce271fa3c3e69598411c1c50b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateValid", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649d38fea6877640d48225a79c92f2d6a8aad270edf0e2c604154801ec4c8aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15718bd39b30ceaa41b704d6b1229c3571bd26c789b55b30ea521699b2848a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d74549632ba521284bdc290146f474027258b40a32226c033f164a0c5c09e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed49534360079db9063034e45c4c5962e5bc790bfc86dfadd155bead8a2fecf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "use_headers": "useHeaders",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc93bd5d4808e640babc51fccef78c0d04205fc861dadf65e835b6ffc92f3876)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_headers", value=use_headers, expected_type=type_hints["use_headers"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_headers is not None:
            self._values["use_headers"] = use_headers
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        '''
        result = self._values.get("use_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''IP or CIDR block, for example: ``71.92.0.0/14``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27fc6f748f12e7539df0dd8dc188c997e5ed9c214c20458c52eda6d1a5843438)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHeaders")
    def reset_use_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHeaders", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHeadersInput")
    def use_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589fcef75af6cdfdfde7454cecf3c1b7e4d5beaa1d9b2f76617ac70acb225601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50349598d001f8d33bb63754b967c1c59daeb846a4b4eb4c8ee61a517751f449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26dbdfbb0e77034b6e9f96135cf6345cc445978e35aa57cb647a70684add6755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHeaders")
    def use_headers(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHeaders"))

    @use_headers.setter
    def use_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75937f0866bb68f3e004c3805bfca5cf5e65a77cf9f27b82559b673048fed3e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975c583e725d0091d2781df27cd82aa2bca277cc10a98822df93a52c204e1e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b208dd06b7d134cf73c9945be6b6e9ec6ea29c3e324eb6c3ac0b23e934bd7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8036a1f582ba561c1a31571ebb8a4420bf76aa1682943de30908bdecc26a8b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_x_forwarded_for": "useXForwardedFor",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17b9305c4c41b77e7d36d7e8c7f559d7b8449cd23291812887f89bccb596698)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_x_forwarded_for", value=use_x_forwarded_for, expected_type=type_hints["use_x_forwarded_for"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_x_forwarded_for is not None:
            self._values["use_x_forwarded_for"] = use_x_forwarded_for
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        '''
        result = self._values.get("use_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The IP version of the client request, either ``IPV4`` or ``IPV6``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a80d315a27b1ed37471e9da7f030e6d889eb72eef40b67e4b0bbcf5a5bf462)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseXForwardedFor")
    def reset_use_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseXForwardedFor", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useXForwardedForInput")
    def use_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce51862a094f79095bd6b481954ac07195a849f0c0965e10182c3ef9470c4c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d71f0a00fcab9d44040c42fd6c17f3a02a176e278b70c995d104ce6869f0eeb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useXForwardedFor")
    def use_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useXForwardedFor"))

    @use_x_forwarded_for.setter
    def use_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f7f93ec2edc3bc86e6ced216c96c05f8aa976184f72e800ec4d12bdc2edcf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1808a3f0b64c5946b209fa95b75267cb39fd62ed0567c958b51fa027b1575e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52febc91a2e07fd6cd0654d534bcad745d0dc807dfcd73b424d6c279eb5fcfdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccc8dd7afb4c12a5d10fa869a36c0f5fd0032fd182bb7a087cd6166a5d982dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81de63e9490f0d2fcdf1b190e2c7df0c0d68e9a783e6e23dbc75343442f4635e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''The Cloudlets Origins identifier, limited to alphanumeric and underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b13aa0109487e340c00cc3a2c4d92c6e9055967af3343d86bbabf7a525eeb2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ceb96d1f3ce8b50276a1a1e76b02c8b313d21f3032b2080802d2de069c77135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e157242f40a378895971590db886598161465a94841ebcfb57c4e284ce112cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b94212c57d6244c615784f03113204d10be2cf1f21437900f906d1be6c64cc4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af02e99c7a29fbd44859ff95f23d28b37d9e889dfa1b7609069479396226ebd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a8dad2b4211e55ba763f7a3c11cdb8a5ef7dc0291a55ab9366168d494575f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "network": "network",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa31a37a1816497bed7e95c38e4c8d6bac56b5cc9ac76399c03d221abfaf20b0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network", value=network, expected_type=type_hints["network"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network is not None:
            self._values["network"] = network
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network(self) -> typing.Optional[builtins.str]:
        '''Match the network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        '''
        result = self._values.get("network")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d0c84470c048bf2f32a257f3190199ae62cac9364472b41056867eb95be58f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetwork")
    def reset_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetwork", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkInput")
    def network_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "networkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdfe7c22a77c0ed22ab5328e08abacf38b9d2063693eae6d7bd461419002c269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64b895b93125bbad139407f8120e79bc0b71da359a41b3d75d53ff670577e70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="network")
    def network(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "network"))

    @network.setter
    def network(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21111630d8d9eb425ff7784c5679172ec908282775d321f68d932efe68f272a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "network", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff683d7e9f4afa0a639a2974b933e2b8ff85cb3678783fcb9abfef1e2cf6293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12bd1fff4f9e477713d02c4da94660abf06fa35eb615865e5c7b2d659d9cc1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68f62b284e397fd178a8e3713e0a13e834d41a6372b471d9f1c5a1b575f4350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078f936422545f3e55d2595d8e56cd8ea078ce3a7c60b07060e5782aefb49969)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for all ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''``Content-Type`` response header value, for example ``text/html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5fd7497903ae127c36bbc6f9c41ee65661e645e6ef01268128336384aa882d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2977212fdbcaa8f6ee16ac7360d5bf8f62c0d02db48429dca7d22556123c45f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc123c3e27b88c4bb8ddfe053e3f858c359000cd0d342c2c16b5c9ff81ab625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183d2dcf1c706e5e43ed8ab6551ab41988e716fb9ed6e19bbabf2e9b25d040c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002a05d7d1a657881b7f8b44db106cc601bfed7cc9a7e894e0eec37e8c91c549)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5063955ae701ecae588de384b019e8ea5fa3a52b60bbca914a2307bb14f7c37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5331e898bcf599cc8fcd8b6569ed5f2faf18e07a0afd19951ca40e02621aaae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879c6d822b789bed92464ea6b5b1378f8a2dc2dacc19d5aa1e531fca6d8d6152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90eb4ca9b5b23feaecda8ed547685f0735a57c524d778ce2f916fe854cf76642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic",
    jsii_struct_bases=[],
    name_mapping={
        "boolean_value": "booleanValue",
        "characteristic": "characteristic",
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_wildcard": "matchWildcard",
        "numeric_match_operator": "numericMatchOperator",
        "numeric_value": "numericValue",
        "string_match_operator": "stringMatchOperator",
        "string_value": "stringValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "version_match_operator": "versionMatchOperator",
        "version_value": "versionValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic:
    def __init__(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b417cef7524f794bf4c3d36d404e6ba46baf0da1039a69a4393889808e15a4ad)
            check_type(argname="argument boolean_value", value=boolean_value, expected_type=type_hints["boolean_value"])
            check_type(argname="argument characteristic", value=characteristic, expected_type=type_hints["characteristic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument numeric_match_operator", value=numeric_match_operator, expected_type=type_hints["numeric_match_operator"])
            check_type(argname="argument numeric_value", value=numeric_value, expected_type=type_hints["numeric_value"])
            check_type(argname="argument string_match_operator", value=string_match_operator, expected_type=type_hints["string_match_operator"])
            check_type(argname="argument string_value", value=string_value, expected_type=type_hints["string_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument version_match_operator", value=version_match_operator, expected_type=type_hints["version_match_operator"])
            check_type(argname="argument version_value", value=version_value, expected_type=type_hints["version_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if boolean_value is not None:
            self._values["boolean_value"] = boolean_value
        if characteristic is not None:
            self._values["characteristic"] = characteristic
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if numeric_match_operator is not None:
            self._values["numeric_match_operator"] = numeric_match_operator
        if numeric_value is not None:
            self._values["numeric_value"] = numeric_value
        if string_match_operator is not None:
            self._values["string_match_operator"] = string_match_operator
        if string_value is not None:
            self._values["string_value"] = string_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if version_match_operator is not None:
            self._values["version_match_operator"] = version_match_operator
        if version_value is not None:
            self._values["version_value"] = version_value

    @builtins.property
    def boolean_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the ``characteristic`` expects a boolean value, this specifies the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        '''
        result = self._values.get("boolean_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def characteristic(self) -> typing.Optional[builtins.str]:
        '''Aspect of the device or browser to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        '''
        result = self._values.get("characteristic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``stringValue`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def numeric_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        '''
        result = self._values.get("numeric_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def numeric_value(self) -> typing.Optional[jsii.Number]:
        '''When the ``characteristic`` expects a numeric value, this specifies the number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        '''
        result = self._values.get("numeric_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def string_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        '''
        result = self._values.get("string_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def string_value(self) -> typing.Optional[typing.List[builtins.str]]:
        '''When the ``characteristic`` expects a string, this specifies the set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        '''
        result = self._values.get("string_value")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        '''
        result = self._values.get("version_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_value(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version number, this specifies it as a string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        result = self._values.get("version_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristicOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristicOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d288b492dd963c4839d464c3605588a079e0e924b880d70411d17d6149861b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBooleanValue")
    def reset_boolean_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBooleanValue", []))

    @jsii.member(jsii_name="resetCharacteristic")
    def reset_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCharacteristic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetNumericMatchOperator")
    def reset_numeric_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericMatchOperator", []))

    @jsii.member(jsii_name="resetNumericValue")
    def reset_numeric_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericValue", []))

    @jsii.member(jsii_name="resetStringMatchOperator")
    def reset_string_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringMatchOperator", []))

    @jsii.member(jsii_name="resetStringValue")
    def reset_string_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVersionMatchOperator")
    def reset_version_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionMatchOperator", []))

    @jsii.member(jsii_name="resetVersionValue")
    def reset_version_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionValue", []))

    @builtins.property
    @jsii.member(jsii_name="booleanValueInput")
    def boolean_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "booleanValueInput"))

    @builtins.property
    @jsii.member(jsii_name="characteristicInput")
    def characteristic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "characteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperatorInput")
    def numeric_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "numericMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="numericValueInput")
    def numeric_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numericValueInput"))

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperatorInput")
    def string_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stringMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="stringValueInput")
    def string_value_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "stringValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperatorInput")
    def version_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="versionValueInput")
    def version_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="booleanValue")
    def boolean_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "booleanValue"))

    @boolean_value.setter
    def boolean_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8bf80a773126cd5259655c51a5843627ea75e86daf886d225c460721ee2ae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "booleanValue", value)

    @builtins.property
    @jsii.member(jsii_name="characteristic")
    def characteristic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "characteristic"))

    @characteristic.setter
    def characteristic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3c4d680a774de62b4517c2be4d02ea6ef4768b233a05f4420aea53fd0242b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "characteristic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__675a4d064f070fef87097df1c22576c8c0a9166583306e4364e08581e53dc3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d092ba1e36e26c7d912373a166decffd402293006ff426f36789990c264f355d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076294dab853bced06a52715ea9d4aa3f981a9866c307812afdf42cdf38a2791)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperator")
    def numeric_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "numericMatchOperator"))

    @numeric_match_operator.setter
    def numeric_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5ec10b69ea54bbf545cdcc1e73916b9cf525ec1c88d233c97dd15e5c776a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="numericValue")
    def numeric_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numericValue"))

    @numeric_value.setter
    def numeric_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2121d4e4ba2f72f31f2b60ab52654e4914d64ca678316d9537183381746ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericValue", value)

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperator")
    def string_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stringMatchOperator"))

    @string_match_operator.setter
    def string_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033d61250472881ea1042c14d62dfe5c9d042d9f47524db7a2d3373abca67e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="stringValue")
    def string_value(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "stringValue"))

    @string_value.setter
    def string_value(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f0bd1b0968d3726db1fe5c1c6cf2a95b4fa3c6d565d8a8af71f3a1de6cc8bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a45c280d5561030b8364e5db294a4bc823ec5aa254736788796a6612b85148a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ba9b23ebe276e6986b28952d68339db7b79bac6f1d5749b4b6c9fb2b523b46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperator")
    def version_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionMatchOperator"))

    @version_match_operator.setter
    def version_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c2151b7ac9dad0cccb15675babce2e4f9406e3850dd5e8c820d33ae9001338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="versionValue")
    def version_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionValue"))

    @version_value.setter
    def version_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5f2dc5264f6e806b278fb5bbc9109e447babf3e240ed0deae1e7569442533d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88731b2bec6d687c4020bfba55f27af20d4b501ad7e44a758d9c83bc327bd915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3691602a8b4a8c27daac2faa7bcb5dc2070dac45290390c6d11d87438bf33c5f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bad5500309f497bfebd00f6b47050f67c5def9d48b7010beba7e3d6e4028e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e213f7b5c89d678841f025e3312161eaebe097145f78d8ceea328916459963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4edec5327f73714633e3a143fd372593cb8b7c5d08a05efeee1bf9d24dc39617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2c17369c5a5a5fa6710349809f845af7f93d3f52192d138b901425a08c0733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02c05d4f70cff6197abcd75f00aaf57e4190a3ca3bedc7842394e629ae24f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5637baa867d7a92fa8cd56320671c2082578402cda54d65ffbb78450d0efa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff3d77de66ef48cb4a9fa90afb7bcc115d33ced2ffbd59b85cd9b4244e4e13f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme",
    jsii_struct_bases=[],
    name_mapping={
        "auth_scheme": "authScheme",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme:
    def __init__(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c6dc34cb5c3f561704bf386acd64019192faae242896e4bcd805ddebcaa50b5)
            check_type(argname="argument auth_scheme", value=auth_scheme, expected_type=type_hints["auth_scheme"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if auth_scheme is not None:
            self._values["auth_scheme"] = auth_scheme
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def auth_scheme(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.'''
        result = self._values.get("auth_scheme")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthSchemeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthSchemeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93868b73c928d31b8711a0de83edfb7fe053d27408793bad617df6dcfdfbd7a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthScheme")
    def reset_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthScheme", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authSchemeInput")
    def auth_scheme_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authScheme")
    def auth_scheme(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authScheme"))

    @auth_scheme.setter
    def auth_scheme(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b6f0332d4df6e1f9ba3cc4d8b12c1c72e538ab3f143002d0d789288c9be49bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authScheme", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a63f2dc2d8e35b6a059848f631f87847dafbc984184dbbe1c87d46fbcb57c168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf00e59486966e962809532e685c9ab6f0ed3d819dc3fa04b69c28ec10357193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e37008f40643da5fa96eb97a996ff8023ff3dffaf8f6e4adc6cd200f5020f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2de96259c141ecd43b5470800005a66890cf0d9651e08a1cc1c8235de765a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4ab0d9907f28cbcf808cef2f49664fb7510d63e4479f9c3664dd7103605356)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticatedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticatedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0fab4b3e7c7497d41f76ad722a5fc33a4fcaa21d2e8c905d44550ef3222d804)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64db7aa09e82280c64c5226a2bee3b5ddbee4bd5334e03fe1c882272721d419b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95e5a0f29fc5e7a8812515c82a45abdcbfe9b2248a936e59fd596ff9c9391af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcacfaa84bd1752c3ea3f26434c0847382feaf5c9e4a08ed84abe7b723b66ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aca4f0b2fa5190f3c0f8b06c8b517980d9f13199488c8e0a17b7292980eda75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c9f3ed567744ebfd9ad888791253aa630d331b325502af2b5864a64cc92751d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername",
    jsii_struct_bases=[],
    name_mapping={
        "length": "length",
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername:
    def __init__(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a291b6e8b2e6f2ed08ffd5a5ea00f7111f96acec80e8cab71f371e262150b9a)
            check_type(argname="argument length", value=length, expected_type=type_hints["length"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if length is not None:
            self._values["length"] = length
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def length(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.'''
        result = self._values.get("length")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsernameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsernameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ebdca58bd428b13a7ea95dc471b9e1605fdffa8ea8c6757f3944643eb8e442)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLength")
    def reset_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLength", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lengthInput")
    def length_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lengthInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="length")
    def length(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "length"))

    @length.setter
    def length(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ab8ae50814df36df9b744b6990736dc65ac20569b1a6a20471ad7a7f51fb3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "length", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71f3a1e4d00fc3a49f60292fc97aec2d2f01b0a12f563457af3803ad9c5fa17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a24722c85e2251d1fe4ab291e668db853928f1aef5ba13ad3604fdc06de6a30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33efa9c404217be773e998712ee2aa0759fbe2899658d9cae957696c20d85657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__943ff927de9b5e5d16611e35e103692f0715ec1d453c142e4e80621cacf4d60b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf34880ffa176a0a48fe95e6e2827b07b89aee94633b83939e26a6d32ae745d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163a1809515a476fab645fb18d8f405d5e429af9668ca78626806b2dd5e26727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure",
    jsii_struct_bases=[],
    name_mapping={
        "exec_status": "execStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure:
    def __init__(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cbdd4cb38e3e15fe2f16e2182b98098543e74fd390f2e94eac6d514e5bf5c94)
            check_type(argname="argument exec_status", value=exec_status, expected_type=type_hints["exec_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if exec_status is not None:
            self._values["exec_status"] = exec_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def exec_status(self) -> typing.Optional[builtins.str]:
        '''Specify execution status.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        '''
        result = self._values.get("exec_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailureOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailureOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1fdcd6198cc49914ebe550f124a9161439b26b9de4e3f122c6c560a25ec3b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExecStatus")
    def reset_exec_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExecStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="execStatusInput")
    def exec_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "execStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="execStatus")
    def exec_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "execStatus"))

    @exec_status.setter
    def exec_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458478918b6cdef82075f1f638ba827a4f0c1d61fa49586603e6626bb8a59fa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "execStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1705f399fa696df281086b01bf85ba14e48a3728fea658797454746e1a4d6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ad47bb8c6de821c06eb8e844401e5de54e9b046bcb4572151ff6e63f725670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd33ac921525f75bbd75fd827d7116b6388790aedc86a3da00121a0a6e61732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2903346a7f9296be5e9a2e5ed1b046b13b8fa08c7f6921cf2885079fe99ddb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa415979283cdfc47a4bbf1aed824289005c7fcf4ce9cecf939e452386b736da)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5c06c1b6a04b59bb8b09096bfa42456f352daeac40422ef8b553b4f5d23483)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc7034488eb859608008c678b3eff1be05e29f58a6fa586f285e629d9b37870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f1bac09cc290f7c877a24188c96fae92e79a0d2ad468c5f931ed8169c6f957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03462b651731e38b1786e8ee883bc20a79fcebba4942016646c7f71b3b36e497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c44d267d0fd734ab3e175a1180108c8647d25420eef076639a4dcc4b5899d67c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91679b6b40ddba946cef2cf150839f35d1ea842d8ab25982745f9a8397957685)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__022793958aed3da6173234c8bed9544df36bc20d6ab3ccb773a2bb5f1b866c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fdcfcd26c0a47e79a72c0f4f7a36a14ee7bb84fb56e512d98375ad07c551981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3cd265371bdc3040355a53cd00b2ee6d32ddc5ea2ad5016ae76b873d5807ca9)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``values`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``.

        If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the filename component of the request URL.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilenameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilenameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1da8517b98f8240656853d6dcff3ea26b881d59f7bd59bfadb46374ac266715)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0f44900d6b9b349a1179cef20bbb1bc031242f0c25ea6283c5fa421ce217ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ac6d569ac2c87d234674f987fb124b52a9f6dcb4de19385c1abb369b735d408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e830fb5b1e8cf2f933f07147978e942ed8b37baa540deba60ea63571913771a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7bb7dac6ab8e26564aef626d5cde46105909b241f09adf41581daaecb03f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e07444b49394137e12098a05189494495567bdea451dc085548c86c68f3a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c2422749fdbd4de28ee7ccc9d161ddc6422e4b51b892cb1e5e9f1230c7884d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899bb26562bd737bc1b8eb25637cb7182c2dc3ea9f57b5d3c50ab3ea51673384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d187c71cd94d7a3576023cb065846a10e1b3aca881658f6d873eee8e8e569fae)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of hostnames.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d6f34b2434f4528bdcf12969bd9ef93d580b3aa6575f98ecc5e3413194917f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5f0be4f42c7c2aad91008454dd7e0c7b15a0945a128da63f16cb93b2d5e29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0ead77c8a03eaa4ef736f25bcf885a65ecb55889ae6bcf272a13db1f7ca7b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265532bb0f14aa0814e1e68e60685710d4c8306b2cc7f25fc63e6a84440fbee8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07c869e8dc389370100a7d3a0245c654eb98a62031021b2956ed981895d055a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b3909b71c893c3d73fdc50644ba369b6e7266997170fda1f687b2fd1778621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96bba91c43a54460318deb2ae33c8e63636ffdc23929b173922334f508888f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fbf1d284eb3613a4c2859da1414e614bbd0d600771273c1ee50eac3a311d545)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f881e1833052509a41113b74bccc590fb8593ea82a392e4ff1f22cce9e766c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb2a8226cd49dd59837c77e20fc286b771d4aeea7f1033545ba53c69cbe1d81e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a82663cc93cb65e28723451b7e09be1fc3aef954709ccce158bc661919b5c33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce1e66f3100382889fd6a70d6d18dc18a093446e6273319e815cc09d354cb0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1693c946c3a1314361c78b60cb003239353ea9c30f904d9da96ccd66df8c67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "close_xml": "closeXml",
        "description": "description",
        "locked": "locked",
        "open_xml": "openXml",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced:
    def __init__(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d60cfc1ec8a349b569b7c060373874fce5d0acfd56c65d96cac492484084dc)
            check_type(argname="argument close_xml", value=close_xml, expected_type=type_hints["close_xml"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument open_xml", value=open_xml, expected_type=type_hints["open_xml"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if close_xml is not None:
            self._values["close_xml"] = close_xml
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if open_xml is not None:
            self._values["open_xml"] = open_xml
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def close_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that closes the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        '''
        result = self._values.get("close_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def open_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that opens the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        '''
        result = self._values.get("open_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6b6f35fb12d41daa1d3fce40ff66bbd500ee30554be0b52ebc4ce671390acd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloseXml")
    def reset_close_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloseXml", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOpenXml")
    def reset_open_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpenXml", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="closeXmlInput")
    def close_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "closeXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="openXmlInput")
    def open_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "openXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="closeXml")
    def close_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "closeXml"))

    @close_xml.setter
    def close_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11d29542ebda1a094bcc34d4b4ee4e66d11140ca570aa409bf3f9fd9a70bfe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "closeXml", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131e7b6e55f4694f0882d152a85ddafb2685c904d00a33730b89f0be4bab70cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa86573ce3d3b75a1bdf5d9cb5eb6a7e9b2bd768c259faa8a88a9ec4dea51c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="openXml")
    def open_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "openXml"))

    @open_xml.setter
    def open_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e67a45acda0b9391790301743e8211cd7beae784013c25286caafb6ce83578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "openXml", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85842e0df82b8d45c8fbfddfb9a99a2441caf40525f6645f016f31ff595398b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db8c76841dde3616b3a1315a87d1cc21cc98b9f5bb560be7ce128c8910c95e07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c8fb2c41ff3594bb094b1db2be736630354184d509a93e5420c802a342cbb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70ee025c66f240d9c75bc3542adb11c99a28b9f078f6f8e14caeec95275674e0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e93d36526fba154e29c4da8f6e963bc530c8a8dcfb21a562af2cd650213025)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e556f0e931edb28a05b692f29115d4fcb237b8e33223b37cb53eb5d49f486c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5705981a0d20206ba17d368976e35d0bacaf2e9522841f65bf5a5fb5857c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf273871945585a9cb6c8aca7e17101145562ae77d7140a88c14070329d109a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0794e4a10e8e6ec0ea81f9549bb93ef799dac15b2277d1fbbce491a6626b1492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d2e640ff9fbab72bcdcc9026d11312fbbb856a9d98111112dcec3709ae36f62)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37807deff99b2e62a1f803471581b23e18534129a2a58f5979ca6c1d3edb1579)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b32f79033bd2381ed0d4c6337b0f4311cffe5690b08d5aa54ecdb70ea66e006)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5194655efb0f66ef209c361b7e0f49f25dd173c80bc360cfc2158ad95ea091d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4deb06a387c516b09b17ac107eb2bd3effaddfa25a018deb35443313565196a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef6ebb61d03cbe1fb31cbee3efdcdc41682987f0ecc3935d4bd9f4dc460b427a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9c1aa6dd74f5a9633f4aa0312f2ce5a6445a024486384d17abc23c86d2af87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ab94f4b39e8db30d27e011d8114ccd1456f4145ef5deea05f36c8d1e6ef07e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a24913f05c513fc220fd3931be66c4e11ecf3988a718c483fc857f51b354407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c414a98955eda8d8b0a59ba504c40a98e31d957b496936fc58149b7911f1c584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa9a08abb341ba913d4da05fb716dcb4b63f4c587dfa363f0b294e407938b796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79576b3533f80489f50eef35c1e7d6f02107ea7863aa36993b776397b6416b76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8ec4189092a2065f309ba855905cb39efc701df8fa1de4460116e5e6f343ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e260fcac8687beeddfe52a5bb1814c4558a39bdf48819a02f559232e8f7ed04f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8325d851305a48e255d31bc09b7d5732c61eae5a2bbfb37972f46503b61f1ec)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches numeric range or a specified set of ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A set of response codes to match, for example ``["404","500"]``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55b8ae4d88c1553bdfe405db9af404fe40632b1d42eb32350db4d9f6330ce7fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd5a57dc10391b53a0e277a7f579ed2a9f2f674bb83cecf3e3d630ba569f0a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4b40dd1dd7826f08fdde7ebbbddb104d41239857f98a851a40c0985136b007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c253a5d817fbd74ba8c2b69078e2b05f4c46762d30a1e9f82a00738a2daca8b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5476d761cb8fe38f992f94c7999952109b11e11d8e138201347d5085c02c7c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf06337e93871110886e8395ed3b615d7f8d699bc48fb89a2f5564b57c397db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b37a20a72bca2a83ab434501bf23c8ae782b51e3fab07bc4256c3d80105c7db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548867c879f0ad38401ac7786b634aad2b1ffc054cd8298643f217b623f1e603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f92c4ca20a5052ceed33df1dacddddcf8428acd017254c83e512bd54797ece4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "variable_expression": "variableExpression",
        "variable_name": "variableName",
        "variable_values": "variableValues",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cffb4da88f0ea213ce1c523ecec6b92b0e6977e113e4f7851051c0aa58dc042)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_expression", value=variable_expression, expected_type=type_hints["variable_expression"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_values", value=variable_values, expected_type=type_hints["variable_values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_expression is not None:
            self._values["variable_expression"] = variable_expression
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_values is not None:
            self._values["variable_values"] = variable_values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this performs a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''The type of match, based on which you use different options to specify the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_expression(self) -> typing.Optional[builtins.str]:
        '''Specifies a single matching string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        '''
        result = self._values.get("variable_expression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''The name of the variable to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies an array of matching strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        result = self._values.get("variable_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7574d5b252d54b635de8b2c763ad70afb9511424efb936af1a1f64e140e04a6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableExpression")
    def reset_variable_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableExpression", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValues")
    def reset_variable_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableExpressionInput")
    def variable_expression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValuesInput")
    def variable_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ae7c844783033256e2a26fad45e6fa6101731b3c1fb9e0e3ff82e73e44f9da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4531bd697c43d98cead9bc216297ffb0db11fe233f4a735febc95469780ceee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a287019442d4b92d6723cc093d2eb178ea2b303fe40e0eb1a56ffa3f24f4b88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bea56e7432af95e4db8812679b54074a058975d2746562d68b2f9e83fcd2d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ead1b42009735b595f76f74354d37595e32c59d2460dcae904dffc41cf541f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219ce0a5931be36f7bdf7b00692736353fea3e4e1ae105a29d761db4a2319099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac63268fc869ca9a688d874889cae688fbac59042e9087cbd452b207dddac698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d18363519adb6b5ef049e69cea5f7aa7f16f8803d9ffd762f83ac47bab4fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableExpression")
    def variable_expression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableExpression"))

    @variable_expression.setter
    def variable_expression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3f777746033de84d66f3cb0a94a23d63cc6f5af4c82ab4676fda0ce987ac5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableExpression", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1288e39b0f76b97bed2951834e1f28382c36f4a078aea2114e242612f6417f0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValues")
    def variable_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableValues"))

    @variable_values.setter
    def variable_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e9807b9acb98fbd0a16a846a15a0c630832507c1ec79aac8c6d3b1f5478839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValues", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e03e24711bf94dbcf7022280f48737a17d491765f4837f2a1f220d4f9b2cdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a473b97667af34caaf59b06e2c6a928cc1b59e06c730f15a71f4971c550d1d8c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Compares the current rule with the specified metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af386086c737e95b5fcfd9b79bbecdde9fc9e9e2804660beb117568c33cce1ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9af440f91b7dce19b1cf9ad464b331e8c6fb84f2fac7a163d76a1b82eeb72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28aa411eb64ba3b0001f2cc3bdd1811fd1cb83a835cdba86a3d9c59930752345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6bc860f87403bb2612e2d032bf28d941165d49e31f95447ad823bcbf2526cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f94546bca73b8b4e59b899d29030e538966f24e9fcf4c7935355a3f9ded0f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9308ed0a3bfb125e158f2d1e5dd02bf1b52f6f41065e9c5a1b9fcc42b889df0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12756d7a737e94d58724ccfe56d9401f078ccbd5c30d963cc9470bd6da9f26bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be6ef807eb8661cfae29d61ab3de23773ea4897a7dac195786ac95c86b39c88)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies a single required ``ORIGIN_TIMED_OUT`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00b1e433bfed74327055574326e1de288af50a271b55bbf894996abfc849fdc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e24a57f269017ebb3029a9f1815d9b1870ee90ae42f736ab4ee7d137308237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e402426845193babc7f71e1647b8fa99d03aae8b50e9a58674ae5ddc571376d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97bebe84af1501b61b5c223d2d6c1f1f4de1e5a5f6ce3b9bd9f8b72520f21b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e20e157b4fa2b4d12df90708514c37de7bbaf50946ed5c194042b428d4add90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b910acbd2bbc4c1af78e689af6179d4ca06ba9f7b1b89eed5fba677faf7a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61881f384da0dfbb23f57848e09b78da97cbf982894325d9afeeb2cdaf9450e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdvancedImMatch")
    def put_advanced_im_match(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvancedImMatch", [value]))

    @jsii.member(jsii_name="putBucket")
    def put_bucket(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket(
            locked=locked,
            percentage=percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBucket", [value]))

    @jsii.member(jsii_name="putCacheability")
    def put_cacheability(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheability", [value_]))

    @jsii.member(jsii_name="putChinaCdnRegion")
    def put_china_cdn_region(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChinaCdnRegion", [value]))

    @jsii.member(jsii_name="putClientCertificate")
    def put_client_certificate(
        self,
        *,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate(
            is_certificate_present=is_certificate_present,
            is_certificate_valid=is_certificate_valid,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificate", [value]))

    @jsii.member(jsii_name="putClientIp")
    def put_client_ip(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            use_headers=use_headers,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIp", [value]))

    @jsii.member(jsii_name="putClientIpVersion")
    def put_client_ip_version(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion(
            locked=locked,
            template_uuid=template_uuid,
            use_x_forwarded_for=use_x_forwarded_for,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIpVersion", [value_]))

    @jsii.member(jsii_name="putCloudletsOrigin")
    def put_cloudlets_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletsOrigin", [value]))

    @jsii.member(jsii_name="putContentDeliveryNetwork")
    def put_content_delivery_network(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork(
            locked=locked,
            match_operator=match_operator,
            network=network,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentDeliveryNetwork", [value]))

    @jsii.member(jsii_name="putContentType")
    def put_content_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putContentType", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristic")
    def put_device_characteristic(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic(
            boolean_value=boolean_value,
            characteristic=characteristic,
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_wildcard=match_wildcard,
            numeric_match_operator=numeric_match_operator,
            numeric_value=numeric_value,
            string_match_operator=string_match_operator,
            string_value=string_value,
            template_uuid=template_uuid,
            uuid=uuid,
            version_match_operator=version_match_operator,
            version_value=version_value,
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristic", [value]))

    @jsii.member(jsii_name="putEcmdAuthGroups")
    def put_ecmd_auth_groups(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthGroups", [value_]))

    @jsii.member(jsii_name="putEcmdAuthScheme")
    def put_ecmd_auth_scheme(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme(
            auth_scheme=auth_scheme,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthScheme", [value]))

    @jsii.member(jsii_name="putEcmdIsAuthenticated")
    def put_ecmd_is_authenticated(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdIsAuthenticated", [value]))

    @jsii.member(jsii_name="putEcmdUsername")
    def put_ecmd_username(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername(
            length=length,
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdUsername", [value_]))

    @jsii.member(jsii_name="putEdgeWorkersFailure")
    def put_edge_workers_failure(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure(
            exec_status=exec_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorkersFailure", [value]))

    @jsii.member(jsii_name="putFileExtension")
    def put_file_extension(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFileExtension", [value]))

    @jsii.member(jsii_name="putFilename")
    def put_filename(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFilename", [value]))

    @jsii.member(jsii_name="putHostname")
    def put_hostname(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putHostname", [value]))

    @jsii.member(jsii_name="putMatchAdvanced")
    def put_match_advanced(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced(
            close_xml=close_xml,
            description=description,
            locked=locked,
            open_xml=open_xml,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchAdvanced", [value]))

    @jsii.member(jsii_name="putMatchCpCode")
    def put_match_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putMatchCpCode", [value_]))

    @jsii.member(jsii_name="putMatchResponseCode")
    def put_match_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode(
            locked=locked,
            lower_bound=lower_bound,
            match_operator=match_operator,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchResponseCode", [value]))

    @jsii.member(jsii_name="putMatchVariable")
    def put_match_variable(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable(
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            variable_expression=variable_expression,
            variable_name=variable_name,
            variable_values=variable_values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchVariable", [value]))

    @jsii.member(jsii_name="putMetadataStage")
    def put_metadata_stage(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataStage", [value_]))

    @jsii.member(jsii_name="putOriginTimeout")
    def put_origin_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginTimeout", [value]))

    @jsii.member(jsii_name="putPath")
    def put_path(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            normalize=normalize,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putPath", [value]))

    @jsii.member(jsii_name="putQueryStringParameter")
    def put_query_string_parameter(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter(
            escape_value=escape_value,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            parameter_name=parameter_name,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putQueryStringParameter", [value]))

    @jsii.member(jsii_name="putRandom")
    def put_random(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom(
            bucket=bucket, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRandom", [value]))

    @jsii.member(jsii_name="putRecoveryConfig")
    def put_recovery_config(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig(
            config_name=config_name,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRecoveryConfig", [value]))

    @jsii.member(jsii_name="putRegularExpression")
    def put_regular_expression(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression(
            case_sensitive=case_sensitive,
            locked=locked,
            match_string=match_string,
            regex=regex,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRegularExpression", [value]))

    @jsii.member(jsii_name="putRequestCookie")
    def put_request_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie(
            cookie_name=cookie_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestCookie", [value_]))

    @jsii.member(jsii_name="putRequestHeader")
    def put_request_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader(
            header_name=header_name,
            locked=locked,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestHeader", [value]))

    @jsii.member(jsii_name="putRequestMethod")
    def put_request_method(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestMethod", [value_]))

    @jsii.member(jsii_name="putRequestProtocol")
    def put_request_protocol(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putRequestProtocol", [value_]))

    @jsii.member(jsii_name="putRequestType")
    def put_request_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestType", [value_]))

    @jsii.member(jsii_name="putResponseHeader")
    def put_response_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader(
            header_name=header_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseHeader", [value]))

    @jsii.member(jsii_name="putTime")
    def put_time(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime(
            apply_daylight_savings_time=apply_daylight_savings_time,
            begin_date=begin_date,
            end_date=end_date,
            lasting_date=lasting_date,
            lasting_duration=lasting_duration,
            locked=locked,
            match_operator=match_operator,
            repeat_begin_date=repeat_begin_date,
            repeat_duration=repeat_duration,
            repeat_interval=repeat_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTime", [value]))

    @jsii.member(jsii_name="putTokenAuthorization")
    def put_token_authorization(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization(
            locked=locked,
            match_operator=match_operator,
            status_list=status_list,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTokenAuthorization", [value]))

    @jsii.member(jsii_name="putUserAgent")
    def put_user_agent(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putUserAgent", [value]))

    @jsii.member(jsii_name="putUserLocation")
    def put_user_location(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation(
            check_ips=check_ips,
            continent_values=continent_values,
            country_values=country_values,
            field=field,
            locked=locked,
            match_operator=match_operator,
            region_values=region_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserLocation", [value]))

    @jsii.member(jsii_name="putUserNetwork")
    def put_user_network(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork(
            bandwidth_values=bandwidth_values,
            check_ips=check_ips,
            field=field,
            locked=locked,
            match_operator=match_operator,
            network_type_values=network_type_values,
            network_values=network_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserNetwork", [value]))

    @jsii.member(jsii_name="putVariableError")
    def put_variable_error(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError(
            locked=locked,
            result=result,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_names=variable_names,
        )

        return typing.cast(None, jsii.invoke(self, "putVariableError", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomRequest")
    def put_virtual_waiting_room_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomRequest", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationRequest")
    def put_visitor_prioritization_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationRequest", [value]))

    @jsii.member(jsii_name="resetAdvancedImMatch")
    def reset_advanced_im_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedImMatch", []))

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetCacheability")
    def reset_cacheability(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheability", []))

    @jsii.member(jsii_name="resetChinaCdnRegion")
    def reset_china_cdn_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnRegion", []))

    @jsii.member(jsii_name="resetClientCertificate")
    def reset_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificate", []))

    @jsii.member(jsii_name="resetClientIp")
    def reset_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIp", []))

    @jsii.member(jsii_name="resetClientIpVersion")
    def reset_client_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIpVersion", []))

    @jsii.member(jsii_name="resetCloudletsOrigin")
    def reset_cloudlets_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletsOrigin", []))

    @jsii.member(jsii_name="resetContentDeliveryNetwork")
    def reset_content_delivery_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentDeliveryNetwork", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDeviceCharacteristic")
    def reset_device_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristic", []))

    @jsii.member(jsii_name="resetEcmdAuthGroups")
    def reset_ecmd_auth_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthGroups", []))

    @jsii.member(jsii_name="resetEcmdAuthScheme")
    def reset_ecmd_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthScheme", []))

    @jsii.member(jsii_name="resetEcmdIsAuthenticated")
    def reset_ecmd_is_authenticated(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdIsAuthenticated", []))

    @jsii.member(jsii_name="resetEcmdUsername")
    def reset_ecmd_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdUsername", []))

    @jsii.member(jsii_name="resetEdgeWorkersFailure")
    def reset_edge_workers_failure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkersFailure", []))

    @jsii.member(jsii_name="resetFileExtension")
    def reset_file_extension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileExtension", []))

    @jsii.member(jsii_name="resetFilename")
    def reset_filename(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFilename", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetMatchAdvanced")
    def reset_match_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchAdvanced", []))

    @jsii.member(jsii_name="resetMatchCpCode")
    def reset_match_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCpCode", []))

    @jsii.member(jsii_name="resetMatchResponseCode")
    def reset_match_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchResponseCode", []))

    @jsii.member(jsii_name="resetMatchVariable")
    def reset_match_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchVariable", []))

    @jsii.member(jsii_name="resetMetadataStage")
    def reset_metadata_stage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataStage", []))

    @jsii.member(jsii_name="resetOriginTimeout")
    def reset_origin_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginTimeout", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetQueryStringParameter")
    def reset_query_string_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryStringParameter", []))

    @jsii.member(jsii_name="resetRandom")
    def reset_random(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandom", []))

    @jsii.member(jsii_name="resetRecoveryConfig")
    def reset_recovery_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryConfig", []))

    @jsii.member(jsii_name="resetRegularExpression")
    def reset_regular_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegularExpression", []))

    @jsii.member(jsii_name="resetRequestCookie")
    def reset_request_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestCookie", []))

    @jsii.member(jsii_name="resetRequestHeader")
    def reset_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestHeader", []))

    @jsii.member(jsii_name="resetRequestMethod")
    def reset_request_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestMethod", []))

    @jsii.member(jsii_name="resetRequestProtocol")
    def reset_request_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestProtocol", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetResponseHeader")
    def reset_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeader", []))

    @jsii.member(jsii_name="resetTime")
    def reset_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTime", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUserAgent")
    def reset_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserAgent", []))

    @jsii.member(jsii_name="resetUserLocation")
    def reset_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserLocation", []))

    @jsii.member(jsii_name="resetUserNetwork")
    def reset_user_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserNetwork", []))

    @jsii.member(jsii_name="resetVariableError")
    def reset_variable_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableError", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomRequest")
    def reset_virtual_waiting_room_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomRequest", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationRequest")
    def reset_visitor_prioritization_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationRequest", []))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatch")
    def advanced_im_match(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatchOutputReference, jsii.get(self, "advancedImMatch"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucketOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucketOutputReference, jsii.get(self, "bucket"))

    @builtins.property
    @jsii.member(jsii_name="cacheability")
    def cacheability(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheabilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheabilityOutputReference, jsii.get(self, "cacheability"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegion")
    def china_cdn_region(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegionOutputReference, jsii.get(self, "chinaCdnRegion"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificate")
    def client_certificate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificateOutputReference, jsii.get(self, "clientCertificate"))

    @builtins.property
    @jsii.member(jsii_name="clientIp")
    def client_ip(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpOutputReference, jsii.get(self, "clientIp"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersion")
    def client_ip_version(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersionOutputReference, jsii.get(self, "clientIpVersion"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOrigin")
    def cloudlets_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOriginOutputReference, jsii.get(self, "cloudletsOrigin"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetwork")
    def content_delivery_network(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetworkOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetworkOutputReference, jsii.get(self, "contentDeliveryNetwork"))

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentTypeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentTypeOutputReference, jsii.get(self, "contentType"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristic")
    def device_characteristic(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristicOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristicOutputReference, jsii.get(self, "deviceCharacteristic"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroups")
    def ecmd_auth_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroupsOutputReference, jsii.get(self, "ecmdAuthGroups"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthScheme")
    def ecmd_auth_scheme(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthSchemeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthSchemeOutputReference, jsii.get(self, "ecmdAuthScheme"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticated")
    def ecmd_is_authenticated(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticatedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticatedOutputReference, jsii.get(self, "ecmdIsAuthenticated"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsername")
    def ecmd_username(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsernameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsernameOutputReference, jsii.get(self, "ecmdUsername"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailure")
    def edge_workers_failure(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailureOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailureOutputReference, jsii.get(self, "edgeWorkersFailure"))

    @builtins.property
    @jsii.member(jsii_name="fileExtension")
    def file_extension(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtensionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtensionOutputReference, jsii.get(self, "fileExtension"))

    @builtins.property
    @jsii.member(jsii_name="filename")
    def filename(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilenameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilenameOutputReference, jsii.get(self, "filename"))

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostnameOutputReference, jsii.get(self, "hostname"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvanced")
    def match_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvancedOutputReference, jsii.get(self, "matchAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCode")
    def match_cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeOutputReference, jsii.get(self, "matchCpCode"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCode")
    def match_response_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCodeOutputReference, jsii.get(self, "matchResponseCode"))

    @builtins.property
    @jsii.member(jsii_name="matchVariable")
    def match_variable(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariableOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariableOutputReference, jsii.get(self, "matchVariable"))

    @builtins.property
    @jsii.member(jsii_name="metadataStage")
    def metadata_stage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStageOutputReference, jsii.get(self, "metadataStage"))

    @builtins.property
    @jsii.member(jsii_name="originTimeout")
    def origin_timeout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeoutOutputReference, jsii.get(self, "originTimeout"))

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPathOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPathOutputReference", jsii.get(self, "path"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameter")
    def query_string_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameterOutputReference", jsii.get(self, "queryStringParameter"))

    @builtins.property
    @jsii.member(jsii_name="random")
    def random(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandomOutputReference", jsii.get(self, "random"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfig")
    def recovery_config(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfigOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfigOutputReference", jsii.get(self, "recoveryConfig"))

    @builtins.property
    @jsii.member(jsii_name="regularExpression")
    def regular_expression(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpressionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpressionOutputReference", jsii.get(self, "regularExpression"))

    @builtins.property
    @jsii.member(jsii_name="requestCookie")
    def request_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookieOutputReference", jsii.get(self, "requestCookie"))

    @builtins.property
    @jsii.member(jsii_name="requestHeader")
    def request_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeaderOutputReference", jsii.get(self, "requestHeader"))

    @builtins.property
    @jsii.member(jsii_name="requestMethod")
    def request_method(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethodOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethodOutputReference", jsii.get(self, "requestMethod"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocol")
    def request_protocol(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocolOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocolOutputReference", jsii.get(self, "requestProtocol"))

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestTypeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestTypeOutputReference", jsii.get(self, "requestType"))

    @builtins.property
    @jsii.member(jsii_name="responseHeader")
    def response_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeaderOutputReference", jsii.get(self, "responseHeader"))

    @builtins.property
    @jsii.member(jsii_name="time")
    def time(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTimeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTimeOutputReference", jsii.get(self, "time"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorizationOutputReference", jsii.get(self, "tokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="userAgent")
    def user_agent(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgentOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgentOutputReference", jsii.get(self, "userAgent"))

    @builtins.property
    @jsii.member(jsii_name="userLocation")
    def user_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocationOutputReference", jsii.get(self, "userLocation"))

    @builtins.property
    @jsii.member(jsii_name="userNetwork")
    def user_network(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetworkOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetworkOutputReference", jsii.get(self, "userNetwork"))

    @builtins.property
    @jsii.member(jsii_name="variableError")
    def variable_error(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableErrorOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableErrorOutputReference", jsii.get(self, "variableError"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequest")
    def virtual_waiting_room_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequestOutputReference", jsii.get(self, "virtualWaitingRoomRequest"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequest")
    def visitor_prioritization_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequestOutputReference", jsii.get(self, "visitorPrioritizationRequest"))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatchInput")
    def advanced_im_match_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch], jsii.get(self, "advancedImMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilityInput")
    def cacheability_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability], jsii.get(self, "cacheabilityInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegionInput")
    def china_cdn_region_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion], jsii.get(self, "chinaCdnRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateInput")
    def client_certificate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate], jsii.get(self, "clientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpInput")
    def client_ip_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp], jsii.get(self, "clientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersionInput")
    def client_ip_version_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion], jsii.get(self, "clientIpVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOriginInput")
    def cloudlets_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin], jsii.get(self, "cloudletsOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetworkInput")
    def content_delivery_network_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork], jsii.get(self, "contentDeliveryNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicInput")
    def device_characteristic_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic], jsii.get(self, "deviceCharacteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroupsInput")
    def ecmd_auth_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups], jsii.get(self, "ecmdAuthGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthSchemeInput")
    def ecmd_auth_scheme_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme], jsii.get(self, "ecmdAuthSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticatedInput")
    def ecmd_is_authenticated_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated], jsii.get(self, "ecmdIsAuthenticatedInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsernameInput")
    def ecmd_username_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername], jsii.get(self, "ecmdUsernameInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailureInput")
    def edge_workers_failure_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure], jsii.get(self, "edgeWorkersFailureInput"))

    @builtins.property
    @jsii.member(jsii_name="fileExtensionInput")
    def file_extension_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension], jsii.get(self, "fileExtensionInput"))

    @builtins.property
    @jsii.member(jsii_name="filenameInput")
    def filename_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename], jsii.get(self, "filenameInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvancedInput")
    def match_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced], jsii.get(self, "matchAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCodeInput")
    def match_cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode], jsii.get(self, "matchCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCodeInput")
    def match_response_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode], jsii.get(self, "matchResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchVariableInput")
    def match_variable_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable], jsii.get(self, "matchVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataStageInput")
    def metadata_stage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage], jsii.get(self, "metadataStageInput"))

    @builtins.property
    @jsii.member(jsii_name="originTimeoutInput")
    def origin_timeout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout], jsii.get(self, "originTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath"], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameterInput")
    def query_string_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter"], jsii.get(self, "queryStringParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="randomInput")
    def random_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom"], jsii.get(self, "randomInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfigInput")
    def recovery_config_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig"], jsii.get(self, "recoveryConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="regularExpressionInput")
    def regular_expression_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression"], jsii.get(self, "regularExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="requestCookieInput")
    def request_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie"], jsii.get(self, "requestCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="requestHeaderInput")
    def request_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader"], jsii.get(self, "requestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="requestMethodInput")
    def request_method_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod"], jsii.get(self, "requestMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocolInput")
    def request_protocol_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol"], jsii.get(self, "requestProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType"], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderInput")
    def response_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader"], jsii.get(self, "responseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="timeInput")
    def time_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime"], jsii.get(self, "timeInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization"], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="userAgentInput")
    def user_agent_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent"], jsii.get(self, "userAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="userLocationInput")
    def user_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation"], jsii.get(self, "userLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="userNetworkInput")
    def user_network_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork"], jsii.get(self, "userNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="variableErrorInput")
    def variable_error_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError"], jsii.get(self, "variableErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequestInput")
    def virtual_waiting_room_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest"], jsii.get(self, "virtualWaitingRoomRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequestInput")
    def visitor_prioritization_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest"], jsii.get(self, "visitorPrioritizationRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ff4667e3645e7d778274f6d402176761c27f35b002e702405ed33e93b5e628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "normalize": "normalize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054d66a6e8715dc33bf98440f56aca124433d18636ed5dd0e30eae35b91f54cd)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument normalize", value=normalize, expected_type=type_hints["normalize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if normalize is not None:
            self._values["normalize"] = normalize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of the ``values`` array.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def normalize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Transforms URLs before comparing them with the provided value.

        URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        '''
        result = self._values.get("normalize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the URL path, excluding leading hostname and trailing query parameters.

        The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}

        Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPathOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPathOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feb49d21b49f086712d61da78ee27db7fafe351aaacd85a8dd08eadc03530b14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNormalize")
    def reset_normalize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNormalize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="normalizeInput")
    def normalize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "normalizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de4b33ba5fc7cd4457dd997d6fb1541bc13263cedccff785f39feede5a3f555f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a35ba8d1f56190feff06ae9279127893352182bead8e5e6d0f2410e5b9a25ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22dfec3e13d601622df60d0124340819e01d2af99ed754dafd3dd6c1f6547af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="normalize")
    def normalize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "normalize"))

    @normalize.setter
    def normalize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f210e91e4c61059ffbced254d95952b496559b3955c9a7e6fb67df90419453c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "normalize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e756cebc767732075b995f7d38422ef73c2a712dd21c0e16552806ae8f9e0558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95e0ff3cf6e8211fc8c4eb9c8d4a4762cfc291becdd09f28843ebaa6afa9753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7b5dfde2522b101e0a49670083707c07cec8d82b2502d0baf059980c69cad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb2540d1702352c95fd9de2df7b76d3d489662fbadb560c6d993e701fc4b761)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter",
    jsii_struct_bases=[],
    name_mapping={
        "escape_value": "escapeValue",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "parameter_name": "parameterName",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter:
    def __init__(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a22e89fb1bd53e764a6b868d4455ba5a0f8a5f78ac5b76f8ac7c4242322b733c)
            check_type(argname="argument escape_value", value=escape_value, expected_type=type_hints["escape_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument parameter_name", value=parameter_name, expected_type=type_hints["parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if escape_value is not None:
            self._values["escape_value"] = escape_value
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if parameter_name is not None:
            self._values["parameter_name"] = parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def escape_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches when the ``value`` is URL-escaped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        '''
        result = self._values.get("escape_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``parameterName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the query field, for example, ``q`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        '''
        result = self._values.get("parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The value of the query field, for example, ``string`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__420b850cd4a28acd75db3c5e1597037aa8e1843ed35b4a9c17c8e378ee6c84bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEscapeValue")
    def reset_escape_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetParameterName")
    def reset_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="escapeValueInput")
    def escape_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="parameterNameInput")
    def parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "parameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeValue")
    def escape_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeValue"))

    @escape_value.setter
    def escape_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0cd692344ecf38d362e127d73cae7fb86ddccd49ebeac9b793c5ae0a0063efa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7815c7eb6603938d6c12c1aa7144f677ddb6396633232891f5f3f150a52d120a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a630c399e6cd002a781bc57bfabefdd004f7274fe4ac67df0d7a979b2720fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a968952f34a8231d14978c5292b7a497ea8afbf7f2e358cca87491edd1261d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a73349c09d9135c52cf9409b2699e6a782d91ae818c5b04c4f5f2d883711ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8308b7ff6c2a10c13d5254477e26b404e1289a98f5e745d3d9f30d7eb4400737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76bd588fa7ac1d08327f8e994dcd28ae821894683088d3f46cc4990f3e3c0129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95db58bff20053c1fe2db8b31354bfed734472b4aa25923fdc2d58751b333b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="parameterName")
    def parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "parameterName"))

    @parameter_name.setter
    def parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5bb71661ee19cae5bb93dc2701254df7bd3284acd8b60fa6512cb45b44a55c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e101125125eff16d1ba2c6d7f361971cc39a8d78e8fb6153d6c7fd2342fc9d64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2fad26c39c82260dfd9dad358658391012057fb8b9031156182f1f85b094d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4524ec3ee0e42dda7b94033c6881e8117a3105eac86b62be293a55309bfbdc47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bed6f3a892bbaf1bfa28eca55cb068ec121cc39c78a1fc284c0e60357b17c934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e95dd309ca60ce27e23d86bff98bbc517616716c3e03d9e734bcc585e41c5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom",
    jsii_struct_bases=[],
    name_mapping={
        "bucket": "bucket",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom:
    def __init__(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5a411f5c337b658dbc79312c675f2d97073a548d41183290b9f1f06bb16fa0e)
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bucket is not None:
            self._values["bucket"] = bucket
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bucket(self) -> typing.Optional[jsii.Number]:
        '''Specify a percentage of random requests to which to apply a behavior. Any remainders do not match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5d802be91756c1027a858a80ce4ed1f0c13e3218d06b1345f395f1dbbfe65e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bucket"))

    @bucket.setter
    def bucket(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5f94161c67b4e520ff16eb89ea6f2b17a7dea8facc91a2f79d14ea137f1fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bucket", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb8da0297f7db4832e0eee72aabbac15827beef3fb6250da1b188931e78abe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c5b8137295ec0fdbbbc6c5970f6dfc763816123fd6c5cc362527ccb34be42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a508af3829386d283239626c24d99c9ba4cf47964b4a5b6d6e54abf27d97945b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0889df582821dbfb60483dade84de563e8ad17a84631877751db924a65727a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig",
    jsii_struct_bases=[],
    name_mapping={
        "config_name": "configName",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig:
    def __init__(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f550a9c5543d65c63bf0d947e164547b47d0e23385bf058759830811293198)
            check_type(argname="argument config_name", value=config_name, expected_type=type_hints["config_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_name is not None:
            self._values["config_name"] = config_name
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def config_name(self) -> typing.Optional[builtins.str]:
        '''A unique identifier used for origin failure recovery configurations.

        This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        '''
        result = self._values.get("config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa08b489acfe9467d2b3ec8ad55053c00198f7101e390377b3fe74206d1f519c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigName")
    def reset_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="configNameInput")
    def config_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="configName")
    def config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configName"))

    @config_name.setter
    def config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e580f94269eb25aa0934ae19c063f5a39d2e8b8ae6f5bb7f7c26eaf7840f1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e0dd52d12e876474b8ba0bbbf195015c5f9a552d7d05fcae068babbedf3ea00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14b35dada666e759c4499ae68090c765649d21f4a536ff5589a74edeeb200217)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4770dd8f7feb2237d950818823e92510dd243ae821bfb63b8eff699037fbd5b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff23dbe23d9dcb4979de8d9f43c01126284e04bbf4d76e825fa858e5038842e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression",
    jsii_struct_bases=[],
    name_mapping={
        "case_sensitive": "caseSensitive",
        "locked": "locked",
        "match_string": "matchString",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression:
    def __init__(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960e23e7226f95e866fb25d1085174a26c0107ed3b67f07ce0c150ab06a57b50)
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_string", value=match_string, expected_type=type_hints["match_string"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if locked is not None:
            self._values["locked"] = locked
        if match_string is not None:
            self._values["match_string"] = match_string
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive regular expression match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_string(self) -> typing.Optional[builtins.str]:
        '''The string to match, typically the contents of a dynamic variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        '''
        result = self._values.get("match_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''The regular expression (PCRE) to match against the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419d1a077572c729527e90e1197c2be604621a306a553c0f6420abf4e4258286)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchString")
    def reset_match_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchString", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchStringInput")
    def match_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchStringInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7724b4f4285834dbfbbd645c492cced9eaddc7ed7bf7d0dbf39a036925b3bd5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f00e3fd8bc8045abde48c4ec4535fcabbd1b1cec9e2131c122669d4f0c068f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchString")
    def match_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchString"))

    @match_string.setter
    def match_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45079e567928938dfda25a16679df8772ed8830abbcd0ffbb57124f60b2f238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchString", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e0e596b39fb19c1335ebd6d126f157aa50af66d64650f91af032691e66d3d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a333de5f10c2c78a362c7c6ca9b5c53099f97e89f9bc8ed13703c1edbbb7de05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61e7c81f654389ce34669cfd3e93d8cdf18ab70ed72bbaaa272e0c9bf4dc088e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1b0bdab23bb484de2d413106ef52d1cee92814b7eb01a7545fd15b2d9bf6cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6655346baf32cacc313bf397c21da5066c945801b910b19f67115caa777b62b3)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''The name of the cookie, for example, ``visitor`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``cookieName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The cookie's value, for example, ``anon`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__770c451d508d9a0c37528bc9e712a731db4fb1541bac32e21c12edf92b3f5653)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d863529fec9c65e7b7d21a91f2954b50340af4a42c11bb4c950e02be8cfff0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a79202050b2adbf02bf3b664352abb74e80ebdd9bcb1815707812462cd8c49f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9b08914a86435b9e7500f722492e2e23a7c3da287e233919126e757dd11fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bec8ac5b8da123e0ecbfa3c78a1aa41440e0d8dfd2e9adf9bf020c10d5fb3d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f7d7f7eab76a0b7c8161ee5f0559fd2fb9564a8d62c8dd21538fa86ff2332c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1503c9124d78ea9d0452fe586cc078ff05f6b05c2d0bf6f532e8c8c539c44d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a30cb9a395ea421dffbb59828ffee1b56312b29eb22033549020a413770538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fafaa5d39b64222b03290a21f746c94963a9682c0afe7470507af28efe84da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12037c21af458c321a429fc4a972f07359aca924e2b397559bec25a56d3815a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad22867ae98a1671bc5da5d735ce6e0ce92e81a265ab4e44c85d96428fa27a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323e55df731e0fecadd061aea54474251433a723a30c37f1426aa7d2bad10974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b326684dc43fbb72f9f1183db3dccb74831e02bbf0bb538d304e12e9d8f877c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b90d028bcaf716ad2f86838a322b252ec5cc9be23525e5ebd4b224a25755c52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9e6f4ef509afd38f5da3e520df6b4d127ade619ca0820f208161e4041701d1)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the request header, for example ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcfe9b26a34632a64af81ff18d90dbdb36a1e27b067fca36dce4abb39fbb1e72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3ee3e12cc01156d7f6b7923f1bd15dfb6ebb3ec98505b751405936f7706efd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c91874d87f6411226b98e7252b37455682269f0b113bf4457d6d8a9e05be5f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21873a53c2892b8409b150fde007e2ab1f26d7dc7ce057df399eb2c16038bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6c15d78d7c5624b1e7f6c50b31436aae3e6144f153a631009cf7c627a36c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e151ee46827c0fb267dda2370071eaefdcbada2940581cb8c91f13c885c9e8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5797529a9601cf7cceddb45e02ce44ed6c70c5f8da66285e02e6e70cacd02af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a242651c6e0d8728b411fa3a5ba49add16b87dcda13d50b21231024045310b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4673a57ccee9badcbb272422eafce31ca664f31dbd02424102b1dab78e5015a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89d42e28ab6e105eda6278655147bda290dbe08171464b73df69d201e9068dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a39e283ebbb347477761234330cf731c0bfb50c1da4f09d0e4fc239f78800e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003f439cd8cdee769fcb58df9c3f76010973e06bd08c99b3fe1fde43e4a2c89d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Any of these HTTP methods,  WebDAV methods, or Akamai operations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad16694120c9e5e83b793d3c36f8ed93f612eded29b163d04496eb948f556faf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b2bb7af22ad4b12bd8a82950e9198c803cafac570517f3f178c60d9bf5ba01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2d80e8b0f5dca0ed98718da11f3ddecd810d2b91453dd7f1b854439248642c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa67b6ba11f63494b303a5d951a0b9937db90f76dfc60480cf79a876018399b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878b9ef9ea3f0d52ed1c30cefdfdc478b0985d56e8f35e59e1ad308bbb82f832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c40f9cba48bfbda5ba9c818f0c70deab5584dcbeec324a0a81c7002540ad5fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bff69c7ca9e6f62d94ff7f3bda99edfb25c300e1e76fd50d05ac1c00f074a72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0a1523a789ac125babbfe02beee60aa2bcd8f0ac22bac7f6e956694b5e9091)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec897f0172ca3891d7f3a400b4395824d0a720c7ded46787432cf9691892b79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b65b715fe3d21ddcf0e89a690fb6499d2a0055992f30b80707583d563aa670)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28d9829898e21a44bdb7e062ba19c97d2bae2e5be4536ad5e4e246e8697038e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ae2cb0f90fab33d2b8434a212defa0583a5791b247c2a36e2390abcd470445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9db4fa49d933043128ebc26814d969ab66f1b6b86acb163bdf7ef4b0ec96c2a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f41385c8978686e124d1e5442c23d6093c979efb58a157cddca7ea67983d000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097380890d6a7801deca907c329991c72d51e2b3a2a5b98e2f505cee5fb7445e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1178b0bb2c72164925c09fef55f4f097e28fc7905638a987d912913fc11c9b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec784ee3019559a960a351a01af0ca77ca850d60bcbdad60a6ef278e9ffa6a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6d19f094651da053e99ba2d0a42289e8fd1de70105345e8661331f400e38a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7644ca02ac9860747264fc3b6923d9e7c87337ef176c5f9c3152a21d4c25379b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157f82f884f3b30f77bfbc0e61ebd3c7aa73626ee9a0ce73ec23bdc3f620f205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a6f7a2516d9f12e79f67d10c2862269ca43e9068de14beace166bb7e1c51739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c28f4c79a82a8e9ea4e22ff921d8fb155e8350eb74ea34eaa948a57a6e6628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7385e4a8a9d944cfbb7cca9e3d466177f6c8edebf8de1bd1bec1ea6a631be4b9)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the response header, for example ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the match is case-sensitive for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match according to various criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1441aace23c1a651fde75e6c018573c2a9acebecd22a2c159d45e03c87a6d494)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2ebc14aeff103784ba3973928fea0d521fa7133f7b24be0d2257c42a499237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9ec755a667e73d77b09d8c9ad6a5b53c64871404f71558d69650ea91453654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ae711e098f28af60815d62558653da5877c9cf6c21eb9dd024f294c75eddc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e856c3d651cfddedc381f31aed801579e956e6f205449a554e4e14c5eaac13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7dfd34419ff1173d14074a3b9e0090c3854a40041ff1557f984227ff090b85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab77659363a704cc3d70be45f81770539c2db417d89bbda42ff0f86c6d116fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970e0b703ad088e333951fcfb265a3d1602467623d56f38d6d43accba0fe358a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd84af6bca44157450f5ffce20951f7dabb9e95bfddb0b99c71853302cabbb06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef7eb71cf9fff123a6d0ab05fe1fbd1dca2aad551ec909f001d0ed728352e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b8ab41eb362a59e8da5adf0824b23797ce019e2e67b2db0411a3b6e384652f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee5ade175e513e11f131ab03220cac35f95806d50980b49eeff6f9a74a7a86a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b0d16751d4d2309fa375fa93ff8ae13a9d4f3b6ffc3d5f638c6dc2500caff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime",
    jsii_struct_bases=[],
    name_mapping={
        "apply_daylight_savings_time": "applyDaylightSavingsTime",
        "begin_date": "beginDate",
        "end_date": "endDate",
        "lasting_date": "lastingDate",
        "lasting_duration": "lastingDuration",
        "locked": "locked",
        "match_operator": "matchOperator",
        "repeat_begin_date": "repeatBeginDate",
        "repeat_duration": "repeatDuration",
        "repeat_interval": "repeatInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime:
    def __init__(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca4a8346dc34bd50e003159a9bb2a871665c0a09209ee8d351666d8b610c38d)
            check_type(argname="argument apply_daylight_savings_time", value=apply_daylight_savings_time, expected_type=type_hints["apply_daylight_savings_time"])
            check_type(argname="argument begin_date", value=begin_date, expected_type=type_hints["begin_date"])
            check_type(argname="argument end_date", value=end_date, expected_type=type_hints["end_date"])
            check_type(argname="argument lasting_date", value=lasting_date, expected_type=type_hints["lasting_date"])
            check_type(argname="argument lasting_duration", value=lasting_duration, expected_type=type_hints["lasting_duration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument repeat_begin_date", value=repeat_begin_date, expected_type=type_hints["repeat_begin_date"])
            check_type(argname="argument repeat_duration", value=repeat_duration, expected_type=type_hints["repeat_duration"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_daylight_savings_time is not None:
            self._values["apply_daylight_savings_time"] = apply_daylight_savings_time
        if begin_date is not None:
            self._values["begin_date"] = begin_date
        if end_date is not None:
            self._values["end_date"] = end_date
        if lasting_date is not None:
            self._values["lasting_date"] = lasting_date
        if lasting_duration is not None:
            self._values["lasting_duration"] = lasting_duration
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if repeat_begin_date is not None:
            self._values["repeat_begin_date"] = repeat_begin_date
        if repeat_duration is not None:
            self._values["repeat_duration"] = repeat_duration
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def apply_daylight_savings_time(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adjusts the start time plus repeat interval to account for daylight saving time.

        Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        '''
        result = self._values.get("apply_daylight_savings_time")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        '''
        result = self._values.get("begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_date(self) -> typing.Optional[builtins.str]:
        '''Sets the end of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        '''
        result = self._values.get("end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        '''
        result = self._values.get("lasting_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the end of a time period as a duration relative to the ``lastingDate``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        '''
        result = self._values.get("lasting_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies how to define the range of time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of the initial time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        '''
        result = self._values.get("repeat_begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of each repeating time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        '''
        result = self._values.get("repeat_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Sets the time between each repeating time period's starting points.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTimeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTimeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73c9fbc3cc00aadf7eaba187018ac8991f931c6d06d90795a1f73950bc7ba0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplyDaylightSavingsTime")
    def reset_apply_daylight_savings_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyDaylightSavingsTime", []))

    @jsii.member(jsii_name="resetBeginDate")
    def reset_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeginDate", []))

    @jsii.member(jsii_name="resetEndDate")
    def reset_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndDate", []))

    @jsii.member(jsii_name="resetLastingDate")
    def reset_lasting_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDate", []))

    @jsii.member(jsii_name="resetLastingDuration")
    def reset_lasting_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDuration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRepeatBeginDate")
    def reset_repeat_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatBeginDate", []))

    @jsii.member(jsii_name="resetRepeatDuration")
    def reset_repeat_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatDuration", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTimeInput")
    def apply_daylight_savings_time_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyDaylightSavingsTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="beginDateInput")
    def begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="endDateInput")
    def end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDateInput")
    def lasting_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDurationInput")
    def lasting_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDateInput")
    def repeat_begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatBeginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatDurationInput")
    def repeat_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTime")
    def apply_daylight_savings_time(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyDaylightSavingsTime"))

    @apply_daylight_savings_time.setter
    def apply_daylight_savings_time(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd0f2f31602f9a3fcdb6798b28818886b87c363dfb404274a734c0bc190d6ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyDaylightSavingsTime", value)

    @builtins.property
    @jsii.member(jsii_name="beginDate")
    def begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beginDate"))

    @begin_date.setter
    def begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b898132772b2e7a56a16bbcca3ad80299e19d1a1f5ccc51f5ee735ec2153f4a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beginDate", value)

    @builtins.property
    @jsii.member(jsii_name="endDate")
    def end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endDate"))

    @end_date.setter
    def end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f198371f0b574333ad673705a036e42aa787efca95e58453f9dd28031cbc33a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDate")
    def lasting_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDate"))

    @lasting_date.setter
    def lasting_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec8f78eee4160aaf8e4078a5a82c814ebcb9a2e539e55eddb749e77548af767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDuration")
    def lasting_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDuration"))

    @lasting_duration.setter
    def lasting_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb92cb9071b36dfb07ebc328751cbfdecde8395efb353890c2c6e391f375109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9288c327b34ea51b01688c2248da25d759006a6ca5a94dcf41b2544c2f1ea174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd796028353b4adaef02a823a8cbaf23bbeba1dc75cf277cb13e2481bab62190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDate")
    def repeat_begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatBeginDate"))

    @repeat_begin_date.setter
    def repeat_begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76b53fe5942e0219dc8f53dd4cfbd35dc9bf47f1e54d5ee871e4207db263b9eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatBeginDate", value)

    @builtins.property
    @jsii.member(jsii_name="repeatDuration")
    def repeat_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatDuration"))

    @repeat_duration.setter
    def repeat_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72961903477e5f8f2aef489962304dcc1624640f034e175ba6d871d7aab451fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatDuration", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18211868cb5df63c2eff7c05abd5f14f7b237ef24cd023019c8d79ff9de5463c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1ee479e9a68c44a801e9de5d13039f5c63a28257e349f4df175fe56cab1331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647e75d95e11921141b4234db99f1ab344c42cce0997e35c7e7e0bdc72886cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c018b2474807c466ff303dff3fad093b388ef1d019380fc79a3bf60d5b63c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "status_list": "statusList",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2f48f218077ec177c4b4ada1a5d40f3ad0ef0648cd3308642dabc567dbaa6e5)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument status_list", value=status_list, expected_type=type_hints["status_list"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if status_list is not None:
            self._values["status_list"] = status_list
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Error match scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_list(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.'''
        result = self._values.get("status_list")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5284337e192d8b87b3c89e61211d71260766fed19f56128863a10631d0fa5039)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetStatusList")
    def reset_status_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusList", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="statusListInput")
    def status_list_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "statusListInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa5e47bfd7da0de598ba4d4cfb8f515e0c35aeaae0766c7b66a4ce6dc89febd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90cfe64fe062248735df28b239792f49d7bfb54f5082d04979d460efd30a1d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="statusList")
    def status_list(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "statusList"))

    @status_list.setter
    def status_list(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473e3262e46392679529d72d8aff4c202837043ff6441e394d0ededb5af3ceb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusList", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6cf600a08064d6f768758c08ec97a332658cec080419ddfbf23e2023a706a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec91aef52ea44cd73ecba97c5f4a474ccca540f9baf03b9697ffd02fd9f04c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e59ea25fdadb27767b36da3a9f9192481abafd02dacec5fcf6a8d9af6b39a59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524aec6d16ee585ade63b81b2a2cf88a68f69c75c0709a7467a0140635c538ab)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2aa0f8f7dcade6333dc8b7ac8732de7b1366c88410fca24b57a731e91b7798)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900794168f0765a314b32807438e4c79903fe6733a9c8724ac21507b8a67d0e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfe3bc49e05030325106f1bd280fd311f4404822d472089e2c47e240f0bdcb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d520e5746451f7043481605cac6599a0767d8418cd2583a1f124d1668efdf793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5affe4bb39a2a61adbf0602a5aefc26bc899b8c62ae0828ba309ac3967206f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5465ca2645818b6b8c4770f96d0d16dd452da6990549fb0c9eca3f380a1ebcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc03ca6556f9f283fd1e8856eb63b743a17cc8c5afd9024d65e8087b5a0aee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55907749617cdf574fd8a4cb45984988ce7a342a99af9e07f6978f01776c32a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d1c1afa4994ace94c02f80fbb4a3cb944bbd6b2969577af9d10b946fca701b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation",
    jsii_struct_bases=[],
    name_mapping={
        "check_ips": "checkIps",
        "continent_values": "continentValues",
        "country_values": "countryValues",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "region_values": "regionValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation:
    def __init__(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9346f00288f1c1db0add7d0aa8a2b884033f4dbae585040a07d226765d94e22)
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument continent_values", value=continent_values, expected_type=type_hints["continent_values"])
            check_type(argname="argument country_values", value=country_values, expected_type=type_hints["country_values"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument region_values", value=region_values, expected_type=type_hints["region_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if continent_values is not None:
            self._values["continent_values"] = continent_values
        if country_values is not None:
            self._values["country_values"] = country_values
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if region_values is not None:
            self._values["region_values"] = region_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def continent_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        '''
        result = self._values.get("continent_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def country_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        '''
        result = self._values.get("country_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def region_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        '''
        result = self._values.get("region_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69a475990acce47e94b92601edbd09a394b39e392a3faa66fe8b0ffcfa38c13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetContinentValues")
    def reset_continent_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinentValues", []))

    @jsii.member(jsii_name="resetCountryValues")
    def reset_country_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountryValues", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegionValues")
    def reset_region_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="continentValuesInput")
    def continent_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="countryValuesInput")
    def country_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countryValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionValuesInput")
    def region_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43a91224a0691b71cbfdabd9c849a96cc229e10914b0a3d2c49b916372c04947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="continentValues")
    def continent_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continentValues"))

    @continent_values.setter
    def continent_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca8673c591131642e558ae790450d520eb7ff8335dacbb54890721f6c7939fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continentValues", value)

    @builtins.property
    @jsii.member(jsii_name="countryValues")
    def country_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countryValues"))

    @country_values.setter
    def country_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f70b0331d9853c2bc0c264cd306b91f303aa3a3cc57c8a6669d73a6eabe09f09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countryValues", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f30500bd79c05b610fef2661cedb5d34d228df03395b60cdd70f1f96e8fb41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78c18acd0d4e016229861f38969785e046d5c7298dcdb30062590117208a8713)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0ce224242e1aa9fcbe36f74b026ee9ba82177eabfb01f30f610bef4667f64e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regionValues")
    def region_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regionValues"))

    @region_values.setter
    def region_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd0fc85c5423b38ff3323714c4ea03b9626c5a9fb30b90e852bc570a16ddb44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regionValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65e270402acf34dfee13f714a27c83eeb2fd6461bd095bbb830c3faab92f139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5691b0f4d6a67c4d3c1ea4ef4d167e172e183280b134bebf77125083367932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de51aca9f49c53fe17ffec0f4052be7799bede96c2fabeb1e1968b71cdb568d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69d30be53daf8284fa578c8ee643a52f500ae5fb7c15981685ba872582d40ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "bandwidth_values": "bandwidthValues",
        "check_ips": "checkIps",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "network_type_values": "networkTypeValues",
        "network_values": "networkValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork:
    def __init__(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c938e198df33c4ff5da11de145ea3fe3727d1f921c75ecbb6522b86ad0a2c6f8)
            check_type(argname="argument bandwidth_values", value=bandwidth_values, expected_type=type_hints["bandwidth_values"])
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network_type_values", value=network_type_values, expected_type=type_hints["network_type_values"])
            check_type(argname="argument network_values", value=network_values, expected_type=type_hints["network_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bandwidth_values is not None:
            self._values["bandwidth_values"] = bandwidth_values
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network_type_values is not None:
            self._values["network_type_values"] = network_type_values
        if network_values is not None:
            self._values["network_values"] = network_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bandwidth_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        '''
        result = self._values.get("bandwidth_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''The type of information to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network_type_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.'''
        result = self._values.get("network_type_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def network_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Any set of specific networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        '''
        result = self._values.get("network_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909ab40565b7caf0d66827c9196fb4ed09344aff4c349ed9ce7212ede48d6a9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBandwidthValues")
    def reset_bandwidth_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBandwidthValues", []))

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetworkTypeValues")
    def reset_network_type_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkTypeValues", []))

    @jsii.member(jsii_name="resetNetworkValues")
    def reset_network_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValuesInput")
    def bandwidth_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "bandwidthValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkTypeValuesInput")
    def network_type_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkTypeValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="networkValuesInput")
    def network_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValues")
    def bandwidth_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "bandwidthValues"))

    @bandwidth_values.setter
    def bandwidth_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e10f374736e9b7aa6ce619f532431398ea6b87b10d6d0015fbd3bcafcd9e4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bandwidthValues", value)

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b0de7518e2b0d4eca57a9e433458d829708110b2acdb94187ba712169fa15e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdfc6862e99ecc44d1c5b71c25db2019f5a25aae495bbbedf6bf9cea7e73aca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00656c97cdfae31fecee9e296d5624b6e03d86e2296a6f9665d35091cb72548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88efa08b9f5e49f25c41e9f3bd5202d2b02a9e60f38a27e3a97c01738b212a3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="networkTypeValues")
    def network_type_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkTypeValues"))

    @network_type_values.setter
    def network_type_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749f3541bba7905c8c3604e19c22235750f7feab4b7b94ce0fd0407315843099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkTypeValues", value)

    @builtins.property
    @jsii.member(jsii_name="networkValues")
    def network_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkValues"))

    @network_values.setter
    def network_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e43b4d7a25803a64424581509247199247be83f8ab3028d3081cc8c3e03c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37104082d11da3b0672fcff8ece96bacdb3d85b200ec8530028cbc006cf14d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d04b3e0f77e55c0a614c6d7ab4f1d28048da3d143507c592cd34bfbb04dde2a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__388a4011724077cf9ff99cd560f11dec7563f7262e149fe829cd15609222c49c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b563deb86b62c9dc0ca8329e839460a7cfe71b043243c63020811d7846c565b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "result": "result",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_names": "variableNames",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb2377da711fb0ff5a7d4c2c402e069d6a69bddc0904fffea67b2ebfcc22f58)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument result", value=result, expected_type=type_hints["result"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_names", value=variable_names, expected_type=type_hints["variable_names"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if result is not None:
            self._values["result"] = result
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_names is not None:
            self._values["variable_names"] = variable_names

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def result(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        '''
        result = self._values.get("result")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name.

        Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        result = self._values.get("variable_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba557d89d8f6344270ffa5012005bdf6d444f4ad1a9e42fb9b5f8fe17654942a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResult")
    def reset_result(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResult", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableNames")
    def reset_variable_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableNames", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resultInput")
    def result_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resultInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNamesInput")
    def variable_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b398d51ea6ecad6f2486adbeb1e3c466ac3defb189c301884b2b2d32c3c3855c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="result")
    def result(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "result"))

    @result.setter
    def result(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fdc6fc2a279abf334d8b5c4dca94c721106c9c29a48ef740693152a53c7357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "result", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e200121985249807d6904a1b7b950b38ec7b242140246599f3562491158ea09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8138f9e99373886d27256a6b5db6f7e84e1453488bfed248982d23dd6fb286a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableNames")
    def variable_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableNames"))

    @variable_names.setter
    def variable_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e0aa795113c3057ff9c9aecc8b74d0337af4c216b836dc2bb92372c9d7ae6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableNames", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56fce9e20b6c931f76e6a62118e0b47b60086098323325c3a4cf2625117425bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf5f9905b162cf12d2ab16d04c6a03c7d5160040161fe3da467df2e77cd0750)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``virtualWaitingRoom`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d62c286ec70a3943e3fc6afa2ff1c2d048d49e99efee186179c0e0d3729e2ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec2d63fafac20df3da8e76248561d26a54f03a245197c84fe61deda0894c47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5761647ab4e66cb69276e63798a3d6b62bd20cc40fffe5073bbca3eee5f32401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e994d377f2f3161b952452ca868632d99898df938471af0e9b57f4565601511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9dcc36726fc6eec3bc2ceca48c4b62f53caf3011ddb914963101013825db591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c48ef8ccfde96be30273c61b245ea64e49e2f5840ca48049e009fca792341d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7242705ebcca93af79884a6b69b154fe26373366d1da68304acc8bd0d871d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725a4a0e0b072402946755945841cc2e170f8665e0d672da9a9f37732704288b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907d8972fc809cfe8f291f1abd8d7b11159e312568c606d55cf6f49f09496955)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__483da73d6ed85d80f9aa6bef40d1169fd5f0432848dc983f3c8a8533c7c6f4a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f5191f68bce2be096ff6f866967191c6c760fbcc7870bacba421a2feaa08d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b369b36cf4e1d5175b7a56e76f541c45e41e6bd1c78e96c7158896ea4bf9e8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__759652281d86a203a1f03309ea94d728e90f78a1b4c9df9720144946798451bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8aa8ad324e4bfa61b7fe04c54af0870fba00a7f3951ebc5a6c1c2d42a1ccfd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10c2983bb2d7f28942652b5647191b86dc258803d1a6ae3d85f871c93f66305a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride",
    jsii_struct_bases=[],
    name_mapping={"name": "name", "override_id": "overrideId"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride:
    def __init__(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d7e3a27dd594527577e65656b8f113801ca4c861ded6bc3bc23d2cfb393e0e)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument override_id", value=override_id, expected_type=type_hints["override_id"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if name is not None:
            self._values["name"] = name
        if override_id is not None:
            self._values["override_id"] = override_id

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''The name of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def override_id(self) -> typing.Optional[builtins.str]:
        '''The ID of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        result = self._values.get("override_id")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08fff4b9d75c11198a69e0f0ce7034937d16db420ca35bebab745cf5c63f43f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetOverrideId")
    def reset_override_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideId", []))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIdInput")
    def override_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideIdInput"))

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c7f1dea52f065fdefb861449c56a512bdc3b19f9a39dbbb9cfee743bef81fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="overrideId")
    def override_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "overrideId"))

    @override_id.setter
    def override_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a9c3128336492e29040fef1c1f06c0fcb52fff0df407f765bd4fdb281e4691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideId", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0314f2db5fe6a639206610373263b56d13a20b468174e1450daa34758e86eacf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88cd19be3c27a155bdb74333eb34807f41e08d67b743c1100e586f5d019b8988)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBehavior")
    def put_behavior(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c59cc511a13f21ae5485a2ed57c84f0e7ad681e1ef00a30390985109e3667db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBehavior", [value]))

    @jsii.member(jsii_name="putCriterion")
    def put_criterion(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881e820e8032c6ee17defe1d0a03a47d39b2075ee3b31d96c5b30edaf64b4031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCriterion", [value]))

    @jsii.member(jsii_name="putCustomOverride")
    def put_custom_override(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride(
            name=name, override_id=override_id
        )

        return typing.cast(None, jsii.invoke(self, "putCustomOverride", [value]))

    @jsii.member(jsii_name="putVariable")
    def put_variable(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230105Variable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64049ba73024a85ba4428dbaa6fe198c1d4f4aaea585199354055e26aa0dece1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putVariable", [value]))

    @jsii.member(jsii_name="resetAdvancedOverride")
    def reset_advanced_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedOverride", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetChildren")
    def reset_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChildren", []))

    @jsii.member(jsii_name="resetComments")
    def reset_comments(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComments", []))

    @jsii.member(jsii_name="resetCriteriaLocked")
    def reset_criteria_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaLocked", []))

    @jsii.member(jsii_name="resetCriteriaMustSatisfy")
    def reset_criteria_must_satisfy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaMustSatisfy", []))

    @jsii.member(jsii_name="resetCriterion")
    def reset_criterion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriterion", []))

    @jsii.member(jsii_name="resetCustomOverride")
    def reset_custom_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomOverride", []))

    @jsii.member(jsii_name="resetIsSecure")
    def reset_is_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSecure", []))

    @jsii.member(jsii_name="resetTemplateLink")
    def reset_template_link(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateLink", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariable")
    def reset_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariable", []))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorList, jsii.get(self, "behavior"))

    @builtins.property
    @jsii.member(jsii_name="criterion")
    def criterion(self) -> DataAkamaiPropertyRulesBuilderRulesV20230105CriterionList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CriterionList, jsii.get(self, "criterion"))

    @builtins.property
    @jsii.member(jsii_name="customOverride")
    def custom_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverrideOutputReference, jsii.get(self, "customOverride"))

    @builtins.property
    @jsii.member(jsii_name="variable")
    def variable(self) -> "DataAkamaiPropertyRulesBuilderRulesV20230105VariableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105VariableList", jsii.get(self, "variable"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverrideInput")
    def advanced_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]]], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="childrenInput")
    def children_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "childrenInput"))

    @builtins.property
    @jsii.member(jsii_name="commentsInput")
    def comments_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "commentsInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaLockedInput")
    def criteria_locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "criteriaLockedInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfyInput")
    def criteria_must_satisfy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "criteriaMustSatisfyInput"))

    @builtins.property
    @jsii.member(jsii_name="criterionInput")
    def criterion_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]]], jsii.get(self, "criterionInput"))

    @builtins.property
    @jsii.member(jsii_name="customOverrideInput")
    def custom_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride], jsii.get(self, "customOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="isSecureInput")
    def is_secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSecureInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateLinkInput")
    def template_link_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateLinkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableInput")
    def variable_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Variable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230105Variable"]]], jsii.get(self, "variableInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverride")
    def advanced_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advancedOverride"))

    @advanced_override.setter
    def advanced_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f44d17485dd67179f8df22b45013c494a8be45a6038007618eb99c2d005eb31d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advancedOverride", value)

    @builtins.property
    @jsii.member(jsii_name="children")
    def children(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "children"))

    @children.setter
    def children(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12cf64a17136e116ae8538f448ebd573b245d472f61afa584e23b69970137c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "children", value)

    @builtins.property
    @jsii.member(jsii_name="comments")
    def comments(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "comments"))

    @comments.setter
    def comments(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9b0e4a608edffc2a57f9b6ab0cc2e1494d7bd528ab5c40885fbcf60007b54b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "comments", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaLocked")
    def criteria_locked(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "criteriaLocked"))

    @criteria_locked.setter
    def criteria_locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5c9fa3df9e67cd728ce7589a3aa5d8995ee4b5de5da330c48f1dec687ca8eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaLocked", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfy")
    def criteria_must_satisfy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "criteriaMustSatisfy"))

    @criteria_must_satisfy.setter
    def criteria_must_satisfy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a699b2cbfa4f1ecee3e5f2a305fbdf6551445afdc458e4d0dc580a29118c92a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaMustSatisfy", value)

    @builtins.property
    @jsii.member(jsii_name="isSecure")
    def is_secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSecure"))

    @is_secure.setter
    def is_secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cd15b457e0348c3463f369e94dcdd9d9a7338072a7c5c969c1b6fab11f70164)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSecure", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e4f5bc1a548d249a34a09b1e27281f2c518bd39034c84eab2c47811e8105c67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="templateLink")
    def template_link(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateLink"))

    @template_link.setter
    def template_link(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca38d639cbdce10c5879f229907ff86c4bdd07b9cbe49fbe8d38951f6aa889f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateLink", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50be8ea351a4539efd5a6df849d6557be8cf503a2dbb55c00764fec10f09270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b290721c63fb3b5d345c5528f768570db62850710aae3fbb4eb77fdb062470b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e8922b7afb221cf42e258edb171bb90e86e53a8ebda77aef3eaf6b824a1a30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105Variable",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "hidden": "hidden",
        "name": "name",
        "sensitive": "sensitive",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230105Variable:
    def __init__(
        self,
        *,
        description: builtins.str,
        hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        name: builtins.str,
        sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        value: builtins.str,
    ) -> None:
        '''
        :param description: The description for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param hidden: Whether a variable should be hidden. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        :param name: The name of a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param sensitive: States whether a variable contains sensitive information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        :param value: The value for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48709c270061d1fedcdc08737e493cfc641386d8b517961b1aa2b40d0893f5c8)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument hidden", value=hidden, expected_type=type_hints["hidden"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument sensitive", value=sensitive, expected_type=type_hints["sensitive"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "description": description,
            "hidden": hidden,
            "name": name,
            "sensitive": sensitive,
            "value": value,
        }

    @builtins.property
    def description(self) -> builtins.str:
        '''The description for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        assert result is not None, "Required property 'description' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''Whether a variable should be hidden.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        '''
        result = self._values.get("hidden")
        assert result is not None, "Required property 'hidden' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''States whether a variable contains sensitive information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        '''
        result = self._values.get("sensitive")
        assert result is not None, "Required property 'sensitive' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def value(self) -> builtins.str:
        '''The value for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        assert result is not None, "Required property 'value' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230105Variable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230105VariableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105VariableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea99331d7c1ae9de9f81fa8a20537511acab228b7bad9d2e28a3a61d5ebf26b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230105VariableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3123b1d570928e1df4c3110d05f53463e4728066c67dc56079388af4f1bdfc2b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230105VariableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc39f08aaad96ac5b2bc894343b86ad9b8212860f20690e2cf6474cbfcc2372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea85941425e23e4d8d856c1918654ef181dd7d86a1b37f8a0eeacabbbecbf29e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da97c7c8d0ee649cbe4ababe1a01cbeb3d7cb753d78937389942708ebf750cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Variable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Variable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Variable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1b2d0b153ced0d00a83b3f18f9878c0bbdd1bb5a686eacc6b25ef7199c2c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230105VariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230105VariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2d49766fdd3db266e0361aa55834ee8a0894abadd5eff70d3129c3ba2dcb3c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="hiddenInput")
    def hidden_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hiddenInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="sensitiveInput")
    def sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7b823d5ae3ccada7019c5fcbca19368b388bebc6db61f2e0fd84f4e3cce651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="hidden")
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hidden"))

    @hidden.setter
    def hidden(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02c5121b6b0a116f10f8f47a7b1783c07d328323052ab7fccd169ce206b4474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hidden", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa5df6ecca5cedea5023728ddc8a639bb3198a23ab5d472d957775499c49c41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="sensitive")
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sensitive"))

    @sensitive.setter
    def sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a374bd64efa40d25ed563519046adc8f5d2900f1233da5c97f4346df4d3be02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sensitive", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d0716d64c24e637434e46cd71174be7093d49b5f1d9c0082519eac78a47190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Variable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Variable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Variable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c05523c78d8f9a8a0bd76e2d50f708f71f5493b92ba9469ea14e057d83b90f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530",
    jsii_struct_bases=[],
    name_mapping={
        "name": "name",
        "advanced_override": "advancedOverride",
        "behavior": "behavior",
        "children": "children",
        "comments": "comments",
        "criteria_locked": "criteriaLocked",
        "criteria_must_satisfy": "criteriaMustSatisfy",
        "criterion": "criterion",
        "custom_override": "customOverride",
        "is_secure": "isSecure",
        "template_link": "templateLink",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable": "variable",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530:
    def __init__(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        if isinstance(custom_override, dict):
            custom_override = DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride(**custom_override)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2856fdd58b676cbbf40aca62bf4f9bdf2151e8209dfc096548b6ca70b4eaf1)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument advanced_override", value=advanced_override, expected_type=type_hints["advanced_override"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument children", value=children, expected_type=type_hints["children"])
            check_type(argname="argument comments", value=comments, expected_type=type_hints["comments"])
            check_type(argname="argument criteria_locked", value=criteria_locked, expected_type=type_hints["criteria_locked"])
            check_type(argname="argument criteria_must_satisfy", value=criteria_must_satisfy, expected_type=type_hints["criteria_must_satisfy"])
            check_type(argname="argument criterion", value=criterion, expected_type=type_hints["criterion"])
            check_type(argname="argument custom_override", value=custom_override, expected_type=type_hints["custom_override"])
            check_type(argname="argument is_secure", value=is_secure, expected_type=type_hints["is_secure"])
            check_type(argname="argument template_link", value=template_link, expected_type=type_hints["template_link"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable", value=variable, expected_type=type_hints["variable"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "name": name,
        }
        if advanced_override is not None:
            self._values["advanced_override"] = advanced_override
        if behavior is not None:
            self._values["behavior"] = behavior
        if children is not None:
            self._values["children"] = children
        if comments is not None:
            self._values["comments"] = comments
        if criteria_locked is not None:
            self._values["criteria_locked"] = criteria_locked
        if criteria_must_satisfy is not None:
            self._values["criteria_must_satisfy"] = criteria_must_satisfy
        if criterion is not None:
            self._values["criterion"] = criterion
        if custom_override is not None:
            self._values["custom_override"] = custom_override
        if is_secure is not None:
            self._values["is_secure"] = is_secure
        if template_link is not None:
            self._values["template_link"] = template_link
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable is not None:
            self._values["variable"] = variable

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def advanced_override(self) -> typing.Optional[builtins.str]:
        '''XML metadata of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        '''
        result = self._values.get("advanced_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Behavior"]]]:
        '''behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Behavior"]]], result)

    @builtins.property
    def children(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of child rules for a particular rule in JSON format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        '''
        result = self._values.get("children")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def comments(self) -> typing.Optional[builtins.str]:
        '''The comments for a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        '''
        result = self._values.get("comments")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criteria_locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether changes to 'criterion' objects are prohibited.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        '''
        result = self._values.get("criteria_locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def criteria_must_satisfy(self) -> typing.Optional[builtins.str]:
        '''States whether 'all' criteria need to match or 'any'.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        '''
        result = self._values.get("criteria_must_satisfy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criterion(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Criterion"]]]:
        '''criterion block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        '''
        result = self._values.get("criterion")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Criterion"]]], result)

    @builtins.property
    def custom_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride"]:
        '''custom_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        '''
        result = self._values.get("custom_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride"], result)

    @builtins.property
    def is_secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether a rule is secure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        '''
        result = self._values.get("is_secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_link(self) -> typing.Optional[builtins.str]:
        '''The template link for the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        '''
        result = self._values.get("template_link")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of a rule template.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Variable"]]]:
        '''variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        result = self._values.get("variable")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Variable"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530Behavior",
    jsii_struct_bases=[],
    name_mapping={
        "adaptive_acceleration": "adaptiveAcceleration",
        "adaptive_image_compression": "adaptiveImageCompression",
        "ad_scaler_circuit_breaker": "adScalerCircuitBreaker",
        "advanced": "advanced",
        "aggregated_reporting": "aggregatedReporting",
        "akamaizer": "akamaizer",
        "akamaizer_tag": "akamaizerTag",
        "all_http_in_cache_hierarchy": "allHttpInCacheHierarchy",
        "allow_cloudlets_origins": "allowCloudletsOrigins",
        "allow_delete": "allowDelete",
        "allow_https_cache_key_sharing": "allowHttpsCacheKeySharing",
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_options": "allowOptions",
        "allow_patch": "allowPatch",
        "allow_post": "allowPost",
        "allow_put": "allowPut",
        "allow_transfer_encoding": "allowTransferEncoding",
        "alt_svc_header": "altSvcHeader",
        "api_prioritization": "apiPrioritization",
        "application_load_balancer": "applicationLoadBalancer",
        "audience_segmentation": "audienceSegmentation",
        "auto_domain_validation": "autoDomainValidation",
        "base_directory": "baseDirectory",
        "boss_beaconing": "bossBeaconing",
        "breadcrumbs": "breadcrumbs",
        "break_connection": "breakConnection",
        "brotli": "brotli",
        "cache_error": "cacheError",
        "cache_id": "cacheId",
        "cache_key_ignore_case": "cacheKeyIgnoreCase",
        "cache_key_query_params": "cacheKeyQueryParams",
        "cache_key_rewrite": "cacheKeyRewrite",
        "cache_post": "cachePost",
        "cache_redirect": "cacheRedirect",
        "cache_tag": "cacheTag",
        "cache_tag_visible": "cacheTagVisible",
        "caching": "caching",
        "central_authorization": "centralAuthorization",
        "chase_redirects": "chaseRedirects",
        "client_characteristics": "clientCharacteristics",
        "cloud_interconnects": "cloudInterconnects",
        "cloud_wrapper": "cloudWrapper",
        "cloud_wrapper_advanced": "cloudWrapperAdvanced",
        "common_media_client_data": "commonMediaClientData",
        "conditional_origin": "conditionalOrigin",
        "construct_response": "constructResponse",
        "content_characteristics": "contentCharacteristics",
        "content_characteristics_amd": "contentCharacteristicsAmd",
        "content_characteristics_dd": "contentCharacteristicsDd",
        "content_characteristics_wsd_large_file": "contentCharacteristicsWsdLargeFile",
        "content_characteristics_wsd_live": "contentCharacteristicsWsdLive",
        "content_characteristics_wsd_vod": "contentCharacteristicsWsdVod",
        "content_pre_position": "contentPrePosition",
        "content_targeting_protection": "contentTargetingProtection",
        "cors_support": "corsSupport",
        "cp_code": "cpCode",
        "custom_behavior": "customBehavior",
        "datastream": "datastream",
        "dcp": "dcp",
        "dcp_auth_hmac_transformation": "dcpAuthHmacTransformation",
        "dcp_auth_regex_transformation": "dcpAuthRegexTransformation",
        "dcp_auth_substring_transformation": "dcpAuthSubstringTransformation",
        "dcp_auth_variable_extractor": "dcpAuthVariableExtractor",
        "dcp_default_authz_groups": "dcpDefaultAuthzGroups",
        "dcp_dev_relations": "dcpDevRelations",
        "dcp_real_time_auth": "dcpRealTimeAuth",
        "delivery_receipt": "deliveryReceipt",
        "deny_access": "denyAccess",
        "deny_direct_failover_access": "denyDirectFailoverAccess",
        "device_characteristic_cache_id": "deviceCharacteristicCacheId",
        "device_characteristic_header": "deviceCharacteristicHeader",
        "dns_async_refresh": "dnsAsyncRefresh",
        "dns_prefresh": "dnsPrefresh",
        "downgrade_protocol": "downgradeProtocol",
        "download_complete_marker": "downloadCompleteMarker",
        "download_notification": "downloadNotification",
        "downstream_cache": "downstreamCache",
        "dynamic_throughtput_optimization": "dynamicThroughtputOptimization",
        "dynamic_throughtput_optimization_override": "dynamicThroughtputOptimizationOverride",
        "dynamic_web_content": "dynamicWebContent",
        "ecms_bulk_upload": "ecmsBulkUpload",
        "ecms_database": "ecmsDatabase",
        "ecms_dataset": "ecmsDataset",
        "ecms_object_key": "ecmsObjectKey",
        "edge_connect": "edgeConnect",
        "edge_load_balancing_advanced": "edgeLoadBalancingAdvanced",
        "edge_load_balancing_data_center": "edgeLoadBalancingDataCenter",
        "edge_load_balancing_origin": "edgeLoadBalancingOrigin",
        "edge_origin_authorization": "edgeOriginAuthorization",
        "edge_redirector": "edgeRedirector",
        "edge_scape": "edgeScape",
        "edge_side_includes": "edgeSideIncludes",
        "edge_worker": "edgeWorker",
        "enhanced_akamai_protocol": "enhancedAkamaiProtocol",
        "enhanced_proxy_detection": "enhancedProxyDetection",
        "epd_forward_header_enrichment": "epdForwardHeaderEnrichment",
        "fail_action": "failAction",
        "failover_bot_manager_feature_compatibility": "failoverBotManagerFeatureCompatibility",
        "fast_invalidate": "fastInvalidate",
        "first_party_marketing": "firstPartyMarketing",
        "first_party_marketing_plus": "firstPartyMarketingPlus",
        "forward_rewrite": "forwardRewrite",
        "g2_oheader": "g2Oheader",
        "global_request_number": "globalRequestNumber",
        "graphql_caching": "graphqlCaching",
        "gzip_response": "gzipResponse",
        "hd_data_advanced": "hdDataAdvanced",
        "health_detection": "healthDetection",
        "hsaf_eip_binding": "hsafEipBinding",
        "http2": "http2",
        "http3": "http3",
        "http_strict_transport_security": "httpStrictTransportSecurity",
        "http_to_https_upgrade": "httpToHttpsUpgrade",
        "image_and_video_manager": "imageAndVideoManager",
        "image_manager": "imageManager",
        "image_manager_video": "imageManagerVideo",
        "im_override": "imOverride",
        "include": "include",
        "instant": "instant",
        "instant_config": "instantConfig",
        "large_file_optimization": "largeFileOptimization",
        "large_file_optimization_advanced": "largeFileOptimizationAdvanced",
        "limit_bit_rate": "limitBitRate",
        "log_custom": "logCustom",
        "manifest_personalization": "manifestPersonalization",
        "manifest_rerouting": "manifestRerouting",
        "manual_server_push": "manualServerPush",
        "media_acceleration": "mediaAcceleration",
        "media_acceleration_quic_optout": "mediaAccelerationQuicOptout",
        "media_client": "mediaClient",
        "media_file_retrieval_optimization": "mediaFileRetrievalOptimization",
        "media_origin_failover": "mediaOriginFailover",
        "metadata_caching": "metadataCaching",
        "mobile_sdk_performance": "mobileSdkPerformance",
        "modify_incoming_request_header": "modifyIncomingRequestHeader",
        "modify_incoming_response_header": "modifyIncomingResponseHeader",
        "modify_outgoing_request_header": "modifyOutgoingRequestHeader",
        "modify_outgoing_response_header": "modifyOutgoingResponseHeader",
        "modify_via_header": "modifyViaHeader",
        "m_pulse": "mPulse",
        "origin": "origin",
        "origin_characteristics": "originCharacteristics",
        "origin_characteristics_wsd": "originCharacteristicsWsd",
        "origin_failure_recovery_method": "originFailureRecoveryMethod",
        "origin_failure_recovery_policy": "originFailureRecoveryPolicy",
        "origin_ip_acl": "originIpAcl",
        "persistent_client_connection": "persistentClientConnection",
        "persistent_connection": "persistentConnection",
        "personally_identifiable_information": "personallyIdentifiableInformation",
        "phased_release": "phasedRelease",
        "preconnect": "preconnect",
        "predictive_content_delivery": "predictiveContentDelivery",
        "predictive_prefetching": "predictivePrefetching",
        "prefetch": "prefetch",
        "prefetchable": "prefetchable",
        "prefresh_cache": "prefreshCache",
        "quality": "quality",
        "quic_beta": "quicBeta",
        "random_seek": "randomSeek",
        "rapid": "rapid",
        "read_timeout": "readTimeout",
        "real_time_reporting": "realTimeReporting",
        "real_user_monitoring": "realUserMonitoring",
        "redirect": "redirect",
        "redirectplus": "redirectplus",
        "referer_checking": "refererChecking",
        "remove_query_parameter": "removeQueryParameter",
        "remove_vary": "removeVary",
        "report": "report",
        "request_control": "requestControl",
        "request_type_marker": "requestTypeMarker",
        "resource_optimizer": "resourceOptimizer",
        "resource_optimizer_extended_compatibility": "resourceOptimizerExtendedCompatibility",
        "response_code": "responseCode",
        "response_cookie": "responseCookie",
        "restrict_object_caching": "restrictObjectCaching",
        "return_cache_status": "returnCacheStatus",
        "rewrite_url": "rewriteUrl",
        "rum_custom": "rumCustom",
        "saas_definitions": "saasDefinitions",
        "sales_force_commerce_cloud_client": "salesForceCommerceCloudClient",
        "sales_force_commerce_cloud_provider": "salesForceCommerceCloudProvider",
        "sales_force_commerce_cloud_provider_host_header": "salesForceCommerceCloudProviderHostHeader",
        "save_post_dca_processing": "savePostDcaProcessing",
        "schedule_invalidation": "scheduleInvalidation",
        "script_management": "scriptManagement",
        "segmented_content_protection": "segmentedContentProtection",
        "segmented_media_optimization": "segmentedMediaOptimization",
        "segmented_media_streaming_prefetch": "segmentedMediaStreamingPrefetch",
        "set_variable": "setVariable",
        "simulate_error_code": "simulateErrorCode",
        "site_shield": "siteShield",
        "standard_tls_migration": "standardTlsMigration",
        "standard_tls_migration_override": "standardTlsMigrationOverride",
        "strict_header_parsing": "strictHeaderParsing",
        "sub_customer": "subCustomer",
        "sure_route": "sureRoute",
        "tcp_optimization": "tcpOptimization",
        "tea_leaf": "teaLeaf",
        "tiered_distribution": "tieredDistribution",
        "tiered_distribution_advanced": "tieredDistributionAdvanced",
        "tiered_distribution_customization": "tieredDistributionCustomization",
        "timeout": "timeout",
        "uid_configuration": "uidConfiguration",
        "validate_entity_tag": "validateEntityTag",
        "verify_json_web_token": "verifyJsonWebToken",
        "verify_json_web_token_for_dcp": "verifyJsonWebTokenForDcp",
        "verify_token_authorization": "verifyTokenAuthorization",
        "virtual_waiting_room": "virtualWaitingRoom",
        "virtual_waiting_room_with_edge_workers": "virtualWaitingRoomWithEdgeWorkers",
        "visitor_prioritization": "visitorPrioritization",
        "visitor_prioritization_fifo": "visitorPrioritizationFifo",
        "visitor_prioritization_fifo_standalone": "visitorPrioritizationFifoStandalone",
        "watermarking": "watermarking",
        "web_application_firewall": "webApplicationFirewall",
        "webdav": "webdav",
        "web_sockets": "webSockets",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530Behavior:
    def __init__(
        self,
        *,
        adaptive_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        adaptive_image_compression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression", typing.Dict[builtins.str, typing.Any]]] = None,
        ad_scaler_circuit_breaker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker", typing.Dict[builtins.str, typing.Any]]] = None,
        advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        aggregated_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag", typing.Dict[builtins.str, typing.Any]]] = None,
        all_http_in_cache_hierarchy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_cloudlets_origins: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_delete: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_cache_key_sharing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_downgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_options: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_patch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_put: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_transfer_encoding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding", typing.Dict[builtins.str, typing.Any]]] = None,
        alt_svc_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        api_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        application_load_balancer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer", typing.Dict[builtins.str, typing.Any]]] = None,
        audience_segmentation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation", typing.Dict[builtins.str, typing.Any]]] = None,
        auto_domain_validation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation", typing.Dict[builtins.str, typing.Any]]] = None,
        base_directory: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory", typing.Dict[builtins.str, typing.Any]]] = None,
        boss_beaconing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing", typing.Dict[builtins.str, typing.Any]]] = None,
        breadcrumbs: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs", typing.Dict[builtins.str, typing.Any]]] = None,
        break_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        brotli: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_ignore_case: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_query_params: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag_visible: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible", typing.Dict[builtins.str, typing.Any]]] = None,
        caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        central_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        chase_redirects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects", typing.Dict[builtins.str, typing.Any]]] = None,
        client_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_interconnects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        common_media_client_data: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData", typing.Dict[builtins.str, typing.Any]]] = None,
        conditional_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        construct_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_amd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_dd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_large_file: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_live: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_vod: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod", typing.Dict[builtins.str, typing.Any]]] = None,
        content_pre_position: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition", typing.Dict[builtins.str, typing.Any]]] = None,
        content_targeting_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        cors_support: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        custom_behavior: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior", typing.Dict[builtins.str, typing.Any]]] = None,
        datastream: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_hmac_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_regex_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_substring_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_variable_extractor: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_default_authz_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_dev_relations: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_real_time_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        delivery_receipt: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_direct_failover_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_async_refresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_prefresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        downgrade_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        download_complete_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        download_notification: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification", typing.Dict[builtins.str, typing.Any]]] = None,
        downstream_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_web_content: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_bulk_upload: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_database: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_dataset: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_object_key: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_connect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_data_center: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_origin_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_redirector: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_scape: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_side_includes: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_worker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_akamai_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_proxy_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        epd_forward_header_enrichment: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment", typing.Dict[builtins.str, typing.Any]]] = None,
        fail_action: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction", typing.Dict[builtins.str, typing.Any]]] = None,
        failover_bot_manager_feature_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        fast_invalidate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing_plus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus", typing.Dict[builtins.str, typing.Any]]] = None,
        forward_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        g2_oheader: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader", typing.Dict[builtins.str, typing.Any]]] = None,
        global_request_number: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber", typing.Dict[builtins.str, typing.Any]]] = None,
        graphql_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        gzip_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        hd_data_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        health_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        hsaf_eip_binding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding", typing.Dict[builtins.str, typing.Any]]] = None,
        http2: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2", typing.Dict[builtins.str, typing.Any]]] = None,
        http3: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3", typing.Dict[builtins.str, typing.Any]]] = None,
        http_strict_transport_security: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity", typing.Dict[builtins.str, typing.Any]]] = None,
        http_to_https_upgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade", typing.Dict[builtins.str, typing.Any]]] = None,
        image_and_video_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager_video: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo", typing.Dict[builtins.str, typing.Any]]] = None,
        im_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        include: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude", typing.Dict[builtins.str, typing.Any]]] = None,
        instant: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant", typing.Dict[builtins.str, typing.Any]]] = None,
        instant_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        limit_bit_rate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate", typing.Dict[builtins.str, typing.Any]]] = None,
        log_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_personalization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_rerouting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting", typing.Dict[builtins.str, typing.Any]]] = None,
        manual_server_push: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration_quic_optout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout", typing.Dict[builtins.str, typing.Any]]] = None,
        media_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient", typing.Dict[builtins.str, typing.Any]]] = None,
        media_file_retrieval_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        media_origin_failover: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        mobile_sdk_performance: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_via_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        m_pulse: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse", typing.Dict[builtins.str, typing.Any]]] = None,
        origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics_wsd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_ip_acl: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_client_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        personally_identifiable_information: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation", typing.Dict[builtins.str, typing.Any]]] = None,
        phased_release: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease", typing.Dict[builtins.str, typing.Any]]] = None,
        preconnect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_content_delivery: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_prefetching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetchable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable", typing.Dict[builtins.str, typing.Any]]] = None,
        prefresh_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache", typing.Dict[builtins.str, typing.Any]]] = None,
        quality: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality", typing.Dict[builtins.str, typing.Any]]] = None,
        quic_beta: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta", typing.Dict[builtins.str, typing.Any]]] = None,
        random_seek: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek", typing.Dict[builtins.str, typing.Any]]] = None,
        rapid: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid", typing.Dict[builtins.str, typing.Any]]] = None,
        read_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        real_time_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        real_user_monitoring: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring", typing.Dict[builtins.str, typing.Any]]] = None,
        redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        redirectplus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus", typing.Dict[builtins.str, typing.Any]]] = None,
        referer_checking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_query_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_vary: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary", typing.Dict[builtins.str, typing.Any]]] = None,
        report: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport", typing.Dict[builtins.str, typing.Any]]] = None,
        request_control: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer_extended_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        response_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        restrict_object_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        return_cache_status: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus", typing.Dict[builtins.str, typing.Any]]] = None,
        rewrite_url: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl", typing.Dict[builtins.str, typing.Any]]] = None,
        rum_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        saas_definitions: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        save_post_dca_processing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing", typing.Dict[builtins.str, typing.Any]]] = None,
        schedule_invalidation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation", typing.Dict[builtins.str, typing.Any]]] = None,
        script_management: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_content_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_streaming_prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        set_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        simulate_error_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode", typing.Dict[builtins.str, typing.Any]]] = None,
        site_shield: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        strict_header_parsing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing", typing.Dict[builtins.str, typing.Any]]] = None,
        sub_customer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer", typing.Dict[builtins.str, typing.Any]]] = None,
        sure_route: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute", typing.Dict[builtins.str, typing.Any]]] = None,
        tcp_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        tea_leaf: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_customization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization", typing.Dict[builtins.str, typing.Any]]] = None,
        timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        uid_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        validate_entity_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token_for_dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo_standalone: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone", typing.Dict[builtins.str, typing.Any]]] = None,
        watermarking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking", typing.Dict[builtins.str, typing.Any]]] = None,
        web_application_firewall: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall", typing.Dict[builtins.str, typing.Any]]] = None,
        webdav: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav", typing.Dict[builtins.str, typing.Any]]] = None,
        web_sockets: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param adaptive_acceleration: adaptive_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        :param adaptive_image_compression: adaptive_image_compression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        :param ad_scaler_circuit_breaker: ad_scaler_circuit_breaker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        :param advanced: advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param aggregated_reporting: aggregated_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        :param akamaizer: akamaizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        :param akamaizer_tag: akamaizer_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        :param all_http_in_cache_hierarchy: all_http_in_cache_hierarchy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        :param allow_cloudlets_origins: allow_cloudlets_origins block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        :param allow_delete: allow_delete block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        :param allow_https_cache_key_sharing: allow_https_cache_key_sharing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        :param allow_https_downgrade: allow_https_downgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_options: allow_options block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        :param allow_patch: allow_patch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        :param allow_post: allow_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        :param allow_put: allow_put block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        :param allow_transfer_encoding: allow_transfer_encoding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        :param alt_svc_header: alt_svc_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        :param api_prioritization: api_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        :param application_load_balancer: application_load_balancer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        :param audience_segmentation: audience_segmentation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        :param auto_domain_validation: auto_domain_validation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        :param base_directory: base_directory block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        :param boss_beaconing: boss_beaconing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        :param breadcrumbs: breadcrumbs block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        :param break_connection: break_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        :param brotli: brotli block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        :param cache_error: cache_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        :param cache_id: cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        :param cache_key_ignore_case: cache_key_ignore_case block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        :param cache_key_query_params: cache_key_query_params block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        :param cache_key_rewrite: cache_key_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        :param cache_post: cache_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        :param cache_redirect: cache_redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        :param cache_tag: cache_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        :param cache_tag_visible: cache_tag_visible block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        :param caching: caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param central_authorization: central_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        :param chase_redirects: chase_redirects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        :param client_characteristics: client_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        :param cloud_interconnects: cloud_interconnects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        :param cloud_wrapper: cloud_wrapper block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        :param cloud_wrapper_advanced: cloud_wrapper_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        :param common_media_client_data: common_media_client_data block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        :param conditional_origin: conditional_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        :param construct_response: construct_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        :param content_characteristics: content_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        :param content_characteristics_amd: content_characteristics_amd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        :param content_characteristics_dd: content_characteristics_dd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        :param content_characteristics_wsd_large_file: content_characteristics_wsd_large_file block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        :param content_characteristics_wsd_live: content_characteristics_wsd_live block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        :param content_characteristics_wsd_vod: content_characteristics_wsd_vod block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        :param content_pre_position: content_pre_position block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        :param content_targeting_protection: content_targeting_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        :param cors_support: cors_support block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param custom_behavior: custom_behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        :param datastream: datastream block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        :param dcp: dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        :param dcp_auth_hmac_transformation: dcp_auth_hmac_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        :param dcp_auth_regex_transformation: dcp_auth_regex_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        :param dcp_auth_substring_transformation: dcp_auth_substring_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        :param dcp_auth_variable_extractor: dcp_auth_variable_extractor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        :param dcp_default_authz_groups: dcp_default_authz_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        :param dcp_dev_relations: dcp_dev_relations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        :param dcp_real_time_auth: dcp_real_time_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        :param delivery_receipt: delivery_receipt block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        :param deny_access: deny_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        :param deny_direct_failover_access: deny_direct_failover_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        :param device_characteristic_cache_id: device_characteristic_cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        :param device_characteristic_header: device_characteristic_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        :param dns_async_refresh: dns_async_refresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        :param dns_prefresh: dns_prefresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        :param downgrade_protocol: downgrade_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        :param download_complete_marker: download_complete_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        :param download_notification: download_notification block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        :param downstream_cache: downstream_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        :param dynamic_throughtput_optimization: dynamic_throughtput_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        :param dynamic_throughtput_optimization_override: dynamic_throughtput_optimization_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        :param dynamic_web_content: dynamic_web_content block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param ecms_bulk_upload: ecms_bulk_upload block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        :param ecms_database: ecms_database block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        :param ecms_dataset: ecms_dataset block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        :param ecms_object_key: ecms_object_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        :param edge_connect: edge_connect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        :param edge_load_balancing_advanced: edge_load_balancing_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        :param edge_load_balancing_data_center: edge_load_balancing_data_center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        :param edge_load_balancing_origin: edge_load_balancing_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        :param edge_origin_authorization: edge_origin_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        :param edge_redirector: edge_redirector block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        :param edge_scape: edge_scape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        :param edge_side_includes: edge_side_includes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        :param edge_worker: edge_worker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        :param enhanced_akamai_protocol: enhanced_akamai_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        :param enhanced_proxy_detection: enhanced_proxy_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        :param epd_forward_header_enrichment: epd_forward_header_enrichment block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        :param fail_action: fail_action block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        :param failover_bot_manager_feature_compatibility: failover_bot_manager_feature_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        :param fast_invalidate: fast_invalidate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        :param first_party_marketing: first_party_marketing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        :param first_party_marketing_plus: first_party_marketing_plus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        :param forward_rewrite: forward_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        :param g2_oheader: g2oheader block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        :param global_request_number: global_request_number block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        :param graphql_caching: graphql_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        :param gzip_response: gzip_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        :param hd_data_advanced: hd_data_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        :param health_detection: health_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        :param hsaf_eip_binding: hsaf_eip_binding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        :param http2: http2 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        :param http3: http3 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        :param http_strict_transport_security: http_strict_transport_security block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        :param http_to_https_upgrade: http_to_https_upgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        :param image_and_video_manager: image_and_video_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        :param image_manager: image_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        :param image_manager_video: image_manager_video block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        :param im_override: im_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        :param include: include block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        :param instant: instant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        :param instant_config: instant_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        :param large_file_optimization: large_file_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        :param large_file_optimization_advanced: large_file_optimization_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        :param limit_bit_rate: limit_bit_rate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        :param log_custom: log_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        :param manifest_personalization: manifest_personalization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        :param manifest_rerouting: manifest_rerouting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        :param manual_server_push: manual_server_push block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        :param media_acceleration: media_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        :param media_acceleration_quic_optout: media_acceleration_quic_optout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        :param media_client: media_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        :param media_file_retrieval_optimization: media_file_retrieval_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        :param media_origin_failover: media_origin_failover block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        :param metadata_caching: metadata_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        :param mobile_sdk_performance: mobile_sdk_performance block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        :param modify_incoming_request_header: modify_incoming_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        :param modify_incoming_response_header: modify_incoming_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        :param modify_outgoing_request_header: modify_outgoing_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        :param modify_outgoing_response_header: modify_outgoing_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        :param modify_via_header: modify_via_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        :param m_pulse: m_pulse block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param origin: origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param origin_characteristics: origin_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        :param origin_characteristics_wsd: origin_characteristics_wsd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        :param origin_failure_recovery_method: origin_failure_recovery_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        :param origin_failure_recovery_policy: origin_failure_recovery_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        :param origin_ip_acl: origin_ip_acl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        :param persistent_client_connection: persistent_client_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        :param persistent_connection: persistent_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        :param personally_identifiable_information: personally_identifiable_information block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        :param phased_release: phased_release block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        :param preconnect: preconnect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        :param predictive_content_delivery: predictive_content_delivery block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        :param predictive_prefetching: predictive_prefetching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        :param prefetch: prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param prefetchable: prefetchable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        :param prefresh_cache: prefresh_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        :param quality: quality block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        :param quic_beta: quic_beta block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        :param random_seek: random_seek block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        :param rapid: rapid block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        :param read_timeout: read_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        :param real_time_reporting: real_time_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        :param real_user_monitoring: real_user_monitoring block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param redirect: redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirectplus: redirectplus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        :param referer_checking: referer_checking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        :param remove_query_parameter: remove_query_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        :param remove_vary: remove_vary block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        :param report: report block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        :param request_control: request_control block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        :param request_type_marker: request_type_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        :param resource_optimizer: resource_optimizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        :param resource_optimizer_extended_compatibility: resource_optimizer_extended_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        :param response_code: response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param response_cookie: response_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        :param restrict_object_caching: restrict_object_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        :param return_cache_status: return_cache_status block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        :param rewrite_url: rewrite_url block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        :param rum_custom: rum_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        :param saas_definitions: saas_definitions block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        :param sales_force_commerce_cloud_client: sales_force_commerce_cloud_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        :param sales_force_commerce_cloud_provider: sales_force_commerce_cloud_provider block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        :param sales_force_commerce_cloud_provider_host_header: sales_force_commerce_cloud_provider_host_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        :param save_post_dca_processing: save_post_dca_processing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        :param schedule_invalidation: schedule_invalidation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        :param script_management: script_management block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        :param segmented_content_protection: segmented_content_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        :param segmented_media_optimization: segmented_media_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        :param segmented_media_streaming_prefetch: segmented_media_streaming_prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        :param set_variable: set_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        :param simulate_error_code: simulate_error_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        :param site_shield: site_shield block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        :param standard_tls_migration: standard_tls_migration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        :param standard_tls_migration_override: standard_tls_migration_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        :param strict_header_parsing: strict_header_parsing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        :param sub_customer: sub_customer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        :param sure_route: sure_route block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param tcp_optimization: tcp_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        :param tea_leaf: tea_leaf block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        :param tiered_distribution: tiered_distribution block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        :param tiered_distribution_advanced: tiered_distribution_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        :param tiered_distribution_customization: tiered_distribution_customization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        :param timeout: timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uid_configuration: uid_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        :param validate_entity_tag: validate_entity_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        :param verify_json_web_token: verify_json_web_token block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        :param verify_json_web_token_for_dcp: verify_json_web_token_for_dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        :param verify_token_authorization: verify_token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        :param virtual_waiting_room: virtual_waiting_room block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        :param virtual_waiting_room_with_edge_workers: virtual_waiting_room_with_edge_workers block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        :param visitor_prioritization: visitor_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        :param visitor_prioritization_fifo: visitor_prioritization_fifo block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        :param visitor_prioritization_fifo_standalone: visitor_prioritization_fifo_standalone block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        :param watermarking: watermarking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        :param web_application_firewall: web_application_firewall block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        :param webdav: webdav block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        :param web_sockets: web_sockets block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        if isinstance(adaptive_acceleration, dict):
            adaptive_acceleration = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration(**adaptive_acceleration)
        if isinstance(adaptive_image_compression, dict):
            adaptive_image_compression = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression(**adaptive_image_compression)
        if isinstance(ad_scaler_circuit_breaker, dict):
            ad_scaler_circuit_breaker = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker(**ad_scaler_circuit_breaker)
        if isinstance(advanced, dict):
            advanced = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced(**advanced)
        if isinstance(aggregated_reporting, dict):
            aggregated_reporting = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting(**aggregated_reporting)
        if isinstance(akamaizer, dict):
            akamaizer = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer(**akamaizer)
        if isinstance(akamaizer_tag, dict):
            akamaizer_tag = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag(**akamaizer_tag)
        if isinstance(all_http_in_cache_hierarchy, dict):
            all_http_in_cache_hierarchy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy(**all_http_in_cache_hierarchy)
        if isinstance(allow_cloudlets_origins, dict):
            allow_cloudlets_origins = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins(**allow_cloudlets_origins)
        if isinstance(allow_delete, dict):
            allow_delete = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete(**allow_delete)
        if isinstance(allow_https_cache_key_sharing, dict):
            allow_https_cache_key_sharing = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing(**allow_https_cache_key_sharing)
        if isinstance(allow_https_downgrade, dict):
            allow_https_downgrade = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade(**allow_https_downgrade)
        if isinstance(allow_options, dict):
            allow_options = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions(**allow_options)
        if isinstance(allow_patch, dict):
            allow_patch = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch(**allow_patch)
        if isinstance(allow_post, dict):
            allow_post = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost(**allow_post)
        if isinstance(allow_put, dict):
            allow_put = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut(**allow_put)
        if isinstance(allow_transfer_encoding, dict):
            allow_transfer_encoding = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding(**allow_transfer_encoding)
        if isinstance(alt_svc_header, dict):
            alt_svc_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader(**alt_svc_header)
        if isinstance(api_prioritization, dict):
            api_prioritization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization(**api_prioritization)
        if isinstance(application_load_balancer, dict):
            application_load_balancer = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer(**application_load_balancer)
        if isinstance(audience_segmentation, dict):
            audience_segmentation = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation(**audience_segmentation)
        if isinstance(auto_domain_validation, dict):
            auto_domain_validation = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation(**auto_domain_validation)
        if isinstance(base_directory, dict):
            base_directory = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory(**base_directory)
        if isinstance(boss_beaconing, dict):
            boss_beaconing = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing(**boss_beaconing)
        if isinstance(breadcrumbs, dict):
            breadcrumbs = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs(**breadcrumbs)
        if isinstance(break_connection, dict):
            break_connection = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection(**break_connection)
        if isinstance(brotli, dict):
            brotli = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli(**brotli)
        if isinstance(cache_error, dict):
            cache_error = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError(**cache_error)
        if isinstance(cache_id, dict):
            cache_id = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId(**cache_id)
        if isinstance(cache_key_ignore_case, dict):
            cache_key_ignore_case = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase(**cache_key_ignore_case)
        if isinstance(cache_key_query_params, dict):
            cache_key_query_params = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams(**cache_key_query_params)
        if isinstance(cache_key_rewrite, dict):
            cache_key_rewrite = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite(**cache_key_rewrite)
        if isinstance(cache_post, dict):
            cache_post = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost(**cache_post)
        if isinstance(cache_redirect, dict):
            cache_redirect = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect(**cache_redirect)
        if isinstance(cache_tag, dict):
            cache_tag = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag(**cache_tag)
        if isinstance(cache_tag_visible, dict):
            cache_tag_visible = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible(**cache_tag_visible)
        if isinstance(caching, dict):
            caching = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching(**caching)
        if isinstance(central_authorization, dict):
            central_authorization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization(**central_authorization)
        if isinstance(chase_redirects, dict):
            chase_redirects = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects(**chase_redirects)
        if isinstance(client_characteristics, dict):
            client_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics(**client_characteristics)
        if isinstance(cloud_interconnects, dict):
            cloud_interconnects = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects(**cloud_interconnects)
        if isinstance(cloud_wrapper, dict):
            cloud_wrapper = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper(**cloud_wrapper)
        if isinstance(cloud_wrapper_advanced, dict):
            cloud_wrapper_advanced = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced(**cloud_wrapper_advanced)
        if isinstance(common_media_client_data, dict):
            common_media_client_data = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData(**common_media_client_data)
        if isinstance(conditional_origin, dict):
            conditional_origin = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin(**conditional_origin)
        if isinstance(construct_response, dict):
            construct_response = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse(**construct_response)
        if isinstance(content_characteristics, dict):
            content_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics(**content_characteristics)
        if isinstance(content_characteristics_amd, dict):
            content_characteristics_amd = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd(**content_characteristics_amd)
        if isinstance(content_characteristics_dd, dict):
            content_characteristics_dd = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd(**content_characteristics_dd)
        if isinstance(content_characteristics_wsd_large_file, dict):
            content_characteristics_wsd_large_file = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile(**content_characteristics_wsd_large_file)
        if isinstance(content_characteristics_wsd_live, dict):
            content_characteristics_wsd_live = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive(**content_characteristics_wsd_live)
        if isinstance(content_characteristics_wsd_vod, dict):
            content_characteristics_wsd_vod = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod(**content_characteristics_wsd_vod)
        if isinstance(content_pre_position, dict):
            content_pre_position = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition(**content_pre_position)
        if isinstance(content_targeting_protection, dict):
            content_targeting_protection = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection(**content_targeting_protection)
        if isinstance(cors_support, dict):
            cors_support = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport(**cors_support)
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode(**cp_code)
        if isinstance(custom_behavior, dict):
            custom_behavior = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior(**custom_behavior)
        if isinstance(datastream, dict):
            datastream = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream(**datastream)
        if isinstance(dcp, dict):
            dcp = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp(**dcp)
        if isinstance(dcp_auth_hmac_transformation, dict):
            dcp_auth_hmac_transformation = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation(**dcp_auth_hmac_transformation)
        if isinstance(dcp_auth_regex_transformation, dict):
            dcp_auth_regex_transformation = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation(**dcp_auth_regex_transformation)
        if isinstance(dcp_auth_substring_transformation, dict):
            dcp_auth_substring_transformation = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation(**dcp_auth_substring_transformation)
        if isinstance(dcp_auth_variable_extractor, dict):
            dcp_auth_variable_extractor = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor(**dcp_auth_variable_extractor)
        if isinstance(dcp_default_authz_groups, dict):
            dcp_default_authz_groups = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups(**dcp_default_authz_groups)
        if isinstance(dcp_dev_relations, dict):
            dcp_dev_relations = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations(**dcp_dev_relations)
        if isinstance(dcp_real_time_auth, dict):
            dcp_real_time_auth = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth(**dcp_real_time_auth)
        if isinstance(delivery_receipt, dict):
            delivery_receipt = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt(**delivery_receipt)
        if isinstance(deny_access, dict):
            deny_access = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess(**deny_access)
        if isinstance(deny_direct_failover_access, dict):
            deny_direct_failover_access = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess(**deny_direct_failover_access)
        if isinstance(device_characteristic_cache_id, dict):
            device_characteristic_cache_id = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId(**device_characteristic_cache_id)
        if isinstance(device_characteristic_header, dict):
            device_characteristic_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader(**device_characteristic_header)
        if isinstance(dns_async_refresh, dict):
            dns_async_refresh = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh(**dns_async_refresh)
        if isinstance(dns_prefresh, dict):
            dns_prefresh = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh(**dns_prefresh)
        if isinstance(downgrade_protocol, dict):
            downgrade_protocol = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol(**downgrade_protocol)
        if isinstance(download_complete_marker, dict):
            download_complete_marker = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker(**download_complete_marker)
        if isinstance(download_notification, dict):
            download_notification = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification(**download_notification)
        if isinstance(downstream_cache, dict):
            downstream_cache = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache(**downstream_cache)
        if isinstance(dynamic_throughtput_optimization, dict):
            dynamic_throughtput_optimization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization(**dynamic_throughtput_optimization)
        if isinstance(dynamic_throughtput_optimization_override, dict):
            dynamic_throughtput_optimization_override = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride(**dynamic_throughtput_optimization_override)
        if isinstance(dynamic_web_content, dict):
            dynamic_web_content = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent(**dynamic_web_content)
        if isinstance(ecms_bulk_upload, dict):
            ecms_bulk_upload = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload(**ecms_bulk_upload)
        if isinstance(ecms_database, dict):
            ecms_database = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase(**ecms_database)
        if isinstance(ecms_dataset, dict):
            ecms_dataset = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset(**ecms_dataset)
        if isinstance(ecms_object_key, dict):
            ecms_object_key = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey(**ecms_object_key)
        if isinstance(edge_connect, dict):
            edge_connect = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect(**edge_connect)
        if isinstance(edge_load_balancing_advanced, dict):
            edge_load_balancing_advanced = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced(**edge_load_balancing_advanced)
        if isinstance(edge_load_balancing_data_center, dict):
            edge_load_balancing_data_center = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter(**edge_load_balancing_data_center)
        if isinstance(edge_load_balancing_origin, dict):
            edge_load_balancing_origin = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin(**edge_load_balancing_origin)
        if isinstance(edge_origin_authorization, dict):
            edge_origin_authorization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization(**edge_origin_authorization)
        if isinstance(edge_redirector, dict):
            edge_redirector = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector(**edge_redirector)
        if isinstance(edge_scape, dict):
            edge_scape = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape(**edge_scape)
        if isinstance(edge_side_includes, dict):
            edge_side_includes = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes(**edge_side_includes)
        if isinstance(edge_worker, dict):
            edge_worker = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker(**edge_worker)
        if isinstance(enhanced_akamai_protocol, dict):
            enhanced_akamai_protocol = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol(**enhanced_akamai_protocol)
        if isinstance(enhanced_proxy_detection, dict):
            enhanced_proxy_detection = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection(**enhanced_proxy_detection)
        if isinstance(epd_forward_header_enrichment, dict):
            epd_forward_header_enrichment = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment(**epd_forward_header_enrichment)
        if isinstance(fail_action, dict):
            fail_action = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction(**fail_action)
        if isinstance(failover_bot_manager_feature_compatibility, dict):
            failover_bot_manager_feature_compatibility = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility(**failover_bot_manager_feature_compatibility)
        if isinstance(fast_invalidate, dict):
            fast_invalidate = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate(**fast_invalidate)
        if isinstance(first_party_marketing, dict):
            first_party_marketing = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing(**first_party_marketing)
        if isinstance(first_party_marketing_plus, dict):
            first_party_marketing_plus = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus(**first_party_marketing_plus)
        if isinstance(forward_rewrite, dict):
            forward_rewrite = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite(**forward_rewrite)
        if isinstance(g2_oheader, dict):
            g2_oheader = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader(**g2_oheader)
        if isinstance(global_request_number, dict):
            global_request_number = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber(**global_request_number)
        if isinstance(graphql_caching, dict):
            graphql_caching = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching(**graphql_caching)
        if isinstance(gzip_response, dict):
            gzip_response = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse(**gzip_response)
        if isinstance(hd_data_advanced, dict):
            hd_data_advanced = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced(**hd_data_advanced)
        if isinstance(health_detection, dict):
            health_detection = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection(**health_detection)
        if isinstance(hsaf_eip_binding, dict):
            hsaf_eip_binding = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding(**hsaf_eip_binding)
        if isinstance(http2, dict):
            http2 = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2(**http2)
        if isinstance(http3, dict):
            http3 = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3(**http3)
        if isinstance(http_strict_transport_security, dict):
            http_strict_transport_security = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity(**http_strict_transport_security)
        if isinstance(http_to_https_upgrade, dict):
            http_to_https_upgrade = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade(**http_to_https_upgrade)
        if isinstance(image_and_video_manager, dict):
            image_and_video_manager = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager(**image_and_video_manager)
        if isinstance(image_manager, dict):
            image_manager = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager(**image_manager)
        if isinstance(image_manager_video, dict):
            image_manager_video = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo(**image_manager_video)
        if isinstance(im_override, dict):
            im_override = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride(**im_override)
        if isinstance(include, dict):
            include = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude(**include)
        if isinstance(instant, dict):
            instant = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant(**instant)
        if isinstance(instant_config, dict):
            instant_config = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig(**instant_config)
        if isinstance(large_file_optimization, dict):
            large_file_optimization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization(**large_file_optimization)
        if isinstance(large_file_optimization_advanced, dict):
            large_file_optimization_advanced = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced(**large_file_optimization_advanced)
        if isinstance(limit_bit_rate, dict):
            limit_bit_rate = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate(**limit_bit_rate)
        if isinstance(log_custom, dict):
            log_custom = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom(**log_custom)
        if isinstance(manifest_personalization, dict):
            manifest_personalization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization(**manifest_personalization)
        if isinstance(manifest_rerouting, dict):
            manifest_rerouting = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting(**manifest_rerouting)
        if isinstance(manual_server_push, dict):
            manual_server_push = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush(**manual_server_push)
        if isinstance(media_acceleration, dict):
            media_acceleration = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration(**media_acceleration)
        if isinstance(media_acceleration_quic_optout, dict):
            media_acceleration_quic_optout = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout(**media_acceleration_quic_optout)
        if isinstance(media_client, dict):
            media_client = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient(**media_client)
        if isinstance(media_file_retrieval_optimization, dict):
            media_file_retrieval_optimization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization(**media_file_retrieval_optimization)
        if isinstance(media_origin_failover, dict):
            media_origin_failover = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover(**media_origin_failover)
        if isinstance(metadata_caching, dict):
            metadata_caching = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching(**metadata_caching)
        if isinstance(mobile_sdk_performance, dict):
            mobile_sdk_performance = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance(**mobile_sdk_performance)
        if isinstance(modify_incoming_request_header, dict):
            modify_incoming_request_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader(**modify_incoming_request_header)
        if isinstance(modify_incoming_response_header, dict):
            modify_incoming_response_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader(**modify_incoming_response_header)
        if isinstance(modify_outgoing_request_header, dict):
            modify_outgoing_request_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader(**modify_outgoing_request_header)
        if isinstance(modify_outgoing_response_header, dict):
            modify_outgoing_response_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader(**modify_outgoing_response_header)
        if isinstance(modify_via_header, dict):
            modify_via_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader(**modify_via_header)
        if isinstance(m_pulse, dict):
            m_pulse = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse(**m_pulse)
        if isinstance(origin, dict):
            origin = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin(**origin)
        if isinstance(origin_characteristics, dict):
            origin_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics(**origin_characteristics)
        if isinstance(origin_characteristics_wsd, dict):
            origin_characteristics_wsd = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd(**origin_characteristics_wsd)
        if isinstance(origin_failure_recovery_method, dict):
            origin_failure_recovery_method = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod(**origin_failure_recovery_method)
        if isinstance(origin_failure_recovery_policy, dict):
            origin_failure_recovery_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy(**origin_failure_recovery_policy)
        if isinstance(origin_ip_acl, dict):
            origin_ip_acl = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl(**origin_ip_acl)
        if isinstance(persistent_client_connection, dict):
            persistent_client_connection = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection(**persistent_client_connection)
        if isinstance(persistent_connection, dict):
            persistent_connection = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection(**persistent_connection)
        if isinstance(personally_identifiable_information, dict):
            personally_identifiable_information = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation(**personally_identifiable_information)
        if isinstance(phased_release, dict):
            phased_release = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease(**phased_release)
        if isinstance(preconnect, dict):
            preconnect = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect(**preconnect)
        if isinstance(predictive_content_delivery, dict):
            predictive_content_delivery = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery(**predictive_content_delivery)
        if isinstance(predictive_prefetching, dict):
            predictive_prefetching = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching(**predictive_prefetching)
        if isinstance(prefetch, dict):
            prefetch = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch(**prefetch)
        if isinstance(prefetchable, dict):
            prefetchable = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable(**prefetchable)
        if isinstance(prefresh_cache, dict):
            prefresh_cache = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache(**prefresh_cache)
        if isinstance(quality, dict):
            quality = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality(**quality)
        if isinstance(quic_beta, dict):
            quic_beta = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta(**quic_beta)
        if isinstance(random_seek, dict):
            random_seek = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek(**random_seek)
        if isinstance(rapid, dict):
            rapid = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid(**rapid)
        if isinstance(read_timeout, dict):
            read_timeout = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout(**read_timeout)
        if isinstance(real_time_reporting, dict):
            real_time_reporting = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting(**real_time_reporting)
        if isinstance(real_user_monitoring, dict):
            real_user_monitoring = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring(**real_user_monitoring)
        if isinstance(redirect, dict):
            redirect = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect(**redirect)
        if isinstance(redirectplus, dict):
            redirectplus = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus(**redirectplus)
        if isinstance(referer_checking, dict):
            referer_checking = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking(**referer_checking)
        if isinstance(remove_query_parameter, dict):
            remove_query_parameter = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter(**remove_query_parameter)
        if isinstance(remove_vary, dict):
            remove_vary = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary(**remove_vary)
        if isinstance(report, dict):
            report = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport(**report)
        if isinstance(request_control, dict):
            request_control = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl(**request_control)
        if isinstance(request_type_marker, dict):
            request_type_marker = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker(**request_type_marker)
        if isinstance(resource_optimizer, dict):
            resource_optimizer = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer(**resource_optimizer)
        if isinstance(resource_optimizer_extended_compatibility, dict):
            resource_optimizer_extended_compatibility = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility(**resource_optimizer_extended_compatibility)
        if isinstance(response_code, dict):
            response_code = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode(**response_code)
        if isinstance(response_cookie, dict):
            response_cookie = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie(**response_cookie)
        if isinstance(restrict_object_caching, dict):
            restrict_object_caching = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching(**restrict_object_caching)
        if isinstance(return_cache_status, dict):
            return_cache_status = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus(**return_cache_status)
        if isinstance(rewrite_url, dict):
            rewrite_url = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl(**rewrite_url)
        if isinstance(rum_custom, dict):
            rum_custom = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom(**rum_custom)
        if isinstance(saas_definitions, dict):
            saas_definitions = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions(**saas_definitions)
        if isinstance(sales_force_commerce_cloud_client, dict):
            sales_force_commerce_cloud_client = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient(**sales_force_commerce_cloud_client)
        if isinstance(sales_force_commerce_cloud_provider, dict):
            sales_force_commerce_cloud_provider = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider(**sales_force_commerce_cloud_provider)
        if isinstance(sales_force_commerce_cloud_provider_host_header, dict):
            sales_force_commerce_cloud_provider_host_header = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader(**sales_force_commerce_cloud_provider_host_header)
        if isinstance(save_post_dca_processing, dict):
            save_post_dca_processing = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing(**save_post_dca_processing)
        if isinstance(schedule_invalidation, dict):
            schedule_invalidation = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation(**schedule_invalidation)
        if isinstance(script_management, dict):
            script_management = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement(**script_management)
        if isinstance(segmented_content_protection, dict):
            segmented_content_protection = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection(**segmented_content_protection)
        if isinstance(segmented_media_optimization, dict):
            segmented_media_optimization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization(**segmented_media_optimization)
        if isinstance(segmented_media_streaming_prefetch, dict):
            segmented_media_streaming_prefetch = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch(**segmented_media_streaming_prefetch)
        if isinstance(set_variable, dict):
            set_variable = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable(**set_variable)
        if isinstance(simulate_error_code, dict):
            simulate_error_code = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode(**simulate_error_code)
        if isinstance(site_shield, dict):
            site_shield = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield(**site_shield)
        if isinstance(standard_tls_migration, dict):
            standard_tls_migration = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration(**standard_tls_migration)
        if isinstance(standard_tls_migration_override, dict):
            standard_tls_migration_override = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride(**standard_tls_migration_override)
        if isinstance(strict_header_parsing, dict):
            strict_header_parsing = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing(**strict_header_parsing)
        if isinstance(sub_customer, dict):
            sub_customer = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer(**sub_customer)
        if isinstance(sure_route, dict):
            sure_route = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute(**sure_route)
        if isinstance(tcp_optimization, dict):
            tcp_optimization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization(**tcp_optimization)
        if isinstance(tea_leaf, dict):
            tea_leaf = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf(**tea_leaf)
        if isinstance(tiered_distribution, dict):
            tiered_distribution = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution(**tiered_distribution)
        if isinstance(tiered_distribution_advanced, dict):
            tiered_distribution_advanced = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced(**tiered_distribution_advanced)
        if isinstance(tiered_distribution_customization, dict):
            tiered_distribution_customization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization(**tiered_distribution_customization)
        if isinstance(timeout, dict):
            timeout = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout(**timeout)
        if isinstance(uid_configuration, dict):
            uid_configuration = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration(**uid_configuration)
        if isinstance(validate_entity_tag, dict):
            validate_entity_tag = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag(**validate_entity_tag)
        if isinstance(verify_json_web_token, dict):
            verify_json_web_token = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken(**verify_json_web_token)
        if isinstance(verify_json_web_token_for_dcp, dict):
            verify_json_web_token_for_dcp = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp(**verify_json_web_token_for_dcp)
        if isinstance(verify_token_authorization, dict):
            verify_token_authorization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization(**verify_token_authorization)
        if isinstance(virtual_waiting_room, dict):
            virtual_waiting_room = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom(**virtual_waiting_room)
        if isinstance(virtual_waiting_room_with_edge_workers, dict):
            virtual_waiting_room_with_edge_workers = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers(**virtual_waiting_room_with_edge_workers)
        if isinstance(visitor_prioritization, dict):
            visitor_prioritization = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization(**visitor_prioritization)
        if isinstance(visitor_prioritization_fifo, dict):
            visitor_prioritization_fifo = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo(**visitor_prioritization_fifo)
        if isinstance(visitor_prioritization_fifo_standalone, dict):
            visitor_prioritization_fifo_standalone = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone(**visitor_prioritization_fifo_standalone)
        if isinstance(watermarking, dict):
            watermarking = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking(**watermarking)
        if isinstance(web_application_firewall, dict):
            web_application_firewall = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall(**web_application_firewall)
        if isinstance(webdav, dict):
            webdav = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav(**webdav)
        if isinstance(web_sockets, dict):
            web_sockets = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets(**web_sockets)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16cea767c4cc9dd6df0e36918d1a784ec2beb36706a07fc7e0ecb22d57ad85c7)
            check_type(argname="argument adaptive_acceleration", value=adaptive_acceleration, expected_type=type_hints["adaptive_acceleration"])
            check_type(argname="argument adaptive_image_compression", value=adaptive_image_compression, expected_type=type_hints["adaptive_image_compression"])
            check_type(argname="argument ad_scaler_circuit_breaker", value=ad_scaler_circuit_breaker, expected_type=type_hints["ad_scaler_circuit_breaker"])
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument aggregated_reporting", value=aggregated_reporting, expected_type=type_hints["aggregated_reporting"])
            check_type(argname="argument akamaizer", value=akamaizer, expected_type=type_hints["akamaizer"])
            check_type(argname="argument akamaizer_tag", value=akamaizer_tag, expected_type=type_hints["akamaizer_tag"])
            check_type(argname="argument all_http_in_cache_hierarchy", value=all_http_in_cache_hierarchy, expected_type=type_hints["all_http_in_cache_hierarchy"])
            check_type(argname="argument allow_cloudlets_origins", value=allow_cloudlets_origins, expected_type=type_hints["allow_cloudlets_origins"])
            check_type(argname="argument allow_delete", value=allow_delete, expected_type=type_hints["allow_delete"])
            check_type(argname="argument allow_https_cache_key_sharing", value=allow_https_cache_key_sharing, expected_type=type_hints["allow_https_cache_key_sharing"])
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_options", value=allow_options, expected_type=type_hints["allow_options"])
            check_type(argname="argument allow_patch", value=allow_patch, expected_type=type_hints["allow_patch"])
            check_type(argname="argument allow_post", value=allow_post, expected_type=type_hints["allow_post"])
            check_type(argname="argument allow_put", value=allow_put, expected_type=type_hints["allow_put"])
            check_type(argname="argument allow_transfer_encoding", value=allow_transfer_encoding, expected_type=type_hints["allow_transfer_encoding"])
            check_type(argname="argument alt_svc_header", value=alt_svc_header, expected_type=type_hints["alt_svc_header"])
            check_type(argname="argument api_prioritization", value=api_prioritization, expected_type=type_hints["api_prioritization"])
            check_type(argname="argument application_load_balancer", value=application_load_balancer, expected_type=type_hints["application_load_balancer"])
            check_type(argname="argument audience_segmentation", value=audience_segmentation, expected_type=type_hints["audience_segmentation"])
            check_type(argname="argument auto_domain_validation", value=auto_domain_validation, expected_type=type_hints["auto_domain_validation"])
            check_type(argname="argument base_directory", value=base_directory, expected_type=type_hints["base_directory"])
            check_type(argname="argument boss_beaconing", value=boss_beaconing, expected_type=type_hints["boss_beaconing"])
            check_type(argname="argument breadcrumbs", value=breadcrumbs, expected_type=type_hints["breadcrumbs"])
            check_type(argname="argument break_connection", value=break_connection, expected_type=type_hints["break_connection"])
            check_type(argname="argument brotli", value=brotli, expected_type=type_hints["brotli"])
            check_type(argname="argument cache_error", value=cache_error, expected_type=type_hints["cache_error"])
            check_type(argname="argument cache_id", value=cache_id, expected_type=type_hints["cache_id"])
            check_type(argname="argument cache_key_ignore_case", value=cache_key_ignore_case, expected_type=type_hints["cache_key_ignore_case"])
            check_type(argname="argument cache_key_query_params", value=cache_key_query_params, expected_type=type_hints["cache_key_query_params"])
            check_type(argname="argument cache_key_rewrite", value=cache_key_rewrite, expected_type=type_hints["cache_key_rewrite"])
            check_type(argname="argument cache_post", value=cache_post, expected_type=type_hints["cache_post"])
            check_type(argname="argument cache_redirect", value=cache_redirect, expected_type=type_hints["cache_redirect"])
            check_type(argname="argument cache_tag", value=cache_tag, expected_type=type_hints["cache_tag"])
            check_type(argname="argument cache_tag_visible", value=cache_tag_visible, expected_type=type_hints["cache_tag_visible"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument central_authorization", value=central_authorization, expected_type=type_hints["central_authorization"])
            check_type(argname="argument chase_redirects", value=chase_redirects, expected_type=type_hints["chase_redirects"])
            check_type(argname="argument client_characteristics", value=client_characteristics, expected_type=type_hints["client_characteristics"])
            check_type(argname="argument cloud_interconnects", value=cloud_interconnects, expected_type=type_hints["cloud_interconnects"])
            check_type(argname="argument cloud_wrapper", value=cloud_wrapper, expected_type=type_hints["cloud_wrapper"])
            check_type(argname="argument cloud_wrapper_advanced", value=cloud_wrapper_advanced, expected_type=type_hints["cloud_wrapper_advanced"])
            check_type(argname="argument common_media_client_data", value=common_media_client_data, expected_type=type_hints["common_media_client_data"])
            check_type(argname="argument conditional_origin", value=conditional_origin, expected_type=type_hints["conditional_origin"])
            check_type(argname="argument construct_response", value=construct_response, expected_type=type_hints["construct_response"])
            check_type(argname="argument content_characteristics", value=content_characteristics, expected_type=type_hints["content_characteristics"])
            check_type(argname="argument content_characteristics_amd", value=content_characteristics_amd, expected_type=type_hints["content_characteristics_amd"])
            check_type(argname="argument content_characteristics_dd", value=content_characteristics_dd, expected_type=type_hints["content_characteristics_dd"])
            check_type(argname="argument content_characteristics_wsd_large_file", value=content_characteristics_wsd_large_file, expected_type=type_hints["content_characteristics_wsd_large_file"])
            check_type(argname="argument content_characteristics_wsd_live", value=content_characteristics_wsd_live, expected_type=type_hints["content_characteristics_wsd_live"])
            check_type(argname="argument content_characteristics_wsd_vod", value=content_characteristics_wsd_vod, expected_type=type_hints["content_characteristics_wsd_vod"])
            check_type(argname="argument content_pre_position", value=content_pre_position, expected_type=type_hints["content_pre_position"])
            check_type(argname="argument content_targeting_protection", value=content_targeting_protection, expected_type=type_hints["content_targeting_protection"])
            check_type(argname="argument cors_support", value=cors_support, expected_type=type_hints["cors_support"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument custom_behavior", value=custom_behavior, expected_type=type_hints["custom_behavior"])
            check_type(argname="argument datastream", value=datastream, expected_type=type_hints["datastream"])
            check_type(argname="argument dcp", value=dcp, expected_type=type_hints["dcp"])
            check_type(argname="argument dcp_auth_hmac_transformation", value=dcp_auth_hmac_transformation, expected_type=type_hints["dcp_auth_hmac_transformation"])
            check_type(argname="argument dcp_auth_regex_transformation", value=dcp_auth_regex_transformation, expected_type=type_hints["dcp_auth_regex_transformation"])
            check_type(argname="argument dcp_auth_substring_transformation", value=dcp_auth_substring_transformation, expected_type=type_hints["dcp_auth_substring_transformation"])
            check_type(argname="argument dcp_auth_variable_extractor", value=dcp_auth_variable_extractor, expected_type=type_hints["dcp_auth_variable_extractor"])
            check_type(argname="argument dcp_default_authz_groups", value=dcp_default_authz_groups, expected_type=type_hints["dcp_default_authz_groups"])
            check_type(argname="argument dcp_dev_relations", value=dcp_dev_relations, expected_type=type_hints["dcp_dev_relations"])
            check_type(argname="argument dcp_real_time_auth", value=dcp_real_time_auth, expected_type=type_hints["dcp_real_time_auth"])
            check_type(argname="argument delivery_receipt", value=delivery_receipt, expected_type=type_hints["delivery_receipt"])
            check_type(argname="argument deny_access", value=deny_access, expected_type=type_hints["deny_access"])
            check_type(argname="argument deny_direct_failover_access", value=deny_direct_failover_access, expected_type=type_hints["deny_direct_failover_access"])
            check_type(argname="argument device_characteristic_cache_id", value=device_characteristic_cache_id, expected_type=type_hints["device_characteristic_cache_id"])
            check_type(argname="argument device_characteristic_header", value=device_characteristic_header, expected_type=type_hints["device_characteristic_header"])
            check_type(argname="argument dns_async_refresh", value=dns_async_refresh, expected_type=type_hints["dns_async_refresh"])
            check_type(argname="argument dns_prefresh", value=dns_prefresh, expected_type=type_hints["dns_prefresh"])
            check_type(argname="argument downgrade_protocol", value=downgrade_protocol, expected_type=type_hints["downgrade_protocol"])
            check_type(argname="argument download_complete_marker", value=download_complete_marker, expected_type=type_hints["download_complete_marker"])
            check_type(argname="argument download_notification", value=download_notification, expected_type=type_hints["download_notification"])
            check_type(argname="argument downstream_cache", value=downstream_cache, expected_type=type_hints["downstream_cache"])
            check_type(argname="argument dynamic_throughtput_optimization", value=dynamic_throughtput_optimization, expected_type=type_hints["dynamic_throughtput_optimization"])
            check_type(argname="argument dynamic_throughtput_optimization_override", value=dynamic_throughtput_optimization_override, expected_type=type_hints["dynamic_throughtput_optimization_override"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument ecms_bulk_upload", value=ecms_bulk_upload, expected_type=type_hints["ecms_bulk_upload"])
            check_type(argname="argument ecms_database", value=ecms_database, expected_type=type_hints["ecms_database"])
            check_type(argname="argument ecms_dataset", value=ecms_dataset, expected_type=type_hints["ecms_dataset"])
            check_type(argname="argument ecms_object_key", value=ecms_object_key, expected_type=type_hints["ecms_object_key"])
            check_type(argname="argument edge_connect", value=edge_connect, expected_type=type_hints["edge_connect"])
            check_type(argname="argument edge_load_balancing_advanced", value=edge_load_balancing_advanced, expected_type=type_hints["edge_load_balancing_advanced"])
            check_type(argname="argument edge_load_balancing_data_center", value=edge_load_balancing_data_center, expected_type=type_hints["edge_load_balancing_data_center"])
            check_type(argname="argument edge_load_balancing_origin", value=edge_load_balancing_origin, expected_type=type_hints["edge_load_balancing_origin"])
            check_type(argname="argument edge_origin_authorization", value=edge_origin_authorization, expected_type=type_hints["edge_origin_authorization"])
            check_type(argname="argument edge_redirector", value=edge_redirector, expected_type=type_hints["edge_redirector"])
            check_type(argname="argument edge_scape", value=edge_scape, expected_type=type_hints["edge_scape"])
            check_type(argname="argument edge_side_includes", value=edge_side_includes, expected_type=type_hints["edge_side_includes"])
            check_type(argname="argument edge_worker", value=edge_worker, expected_type=type_hints["edge_worker"])
            check_type(argname="argument enhanced_akamai_protocol", value=enhanced_akamai_protocol, expected_type=type_hints["enhanced_akamai_protocol"])
            check_type(argname="argument enhanced_proxy_detection", value=enhanced_proxy_detection, expected_type=type_hints["enhanced_proxy_detection"])
            check_type(argname="argument epd_forward_header_enrichment", value=epd_forward_header_enrichment, expected_type=type_hints["epd_forward_header_enrichment"])
            check_type(argname="argument fail_action", value=fail_action, expected_type=type_hints["fail_action"])
            check_type(argname="argument failover_bot_manager_feature_compatibility", value=failover_bot_manager_feature_compatibility, expected_type=type_hints["failover_bot_manager_feature_compatibility"])
            check_type(argname="argument fast_invalidate", value=fast_invalidate, expected_type=type_hints["fast_invalidate"])
            check_type(argname="argument first_party_marketing", value=first_party_marketing, expected_type=type_hints["first_party_marketing"])
            check_type(argname="argument first_party_marketing_plus", value=first_party_marketing_plus, expected_type=type_hints["first_party_marketing_plus"])
            check_type(argname="argument forward_rewrite", value=forward_rewrite, expected_type=type_hints["forward_rewrite"])
            check_type(argname="argument g2_oheader", value=g2_oheader, expected_type=type_hints["g2_oheader"])
            check_type(argname="argument global_request_number", value=global_request_number, expected_type=type_hints["global_request_number"])
            check_type(argname="argument graphql_caching", value=graphql_caching, expected_type=type_hints["graphql_caching"])
            check_type(argname="argument gzip_response", value=gzip_response, expected_type=type_hints["gzip_response"])
            check_type(argname="argument hd_data_advanced", value=hd_data_advanced, expected_type=type_hints["hd_data_advanced"])
            check_type(argname="argument health_detection", value=health_detection, expected_type=type_hints["health_detection"])
            check_type(argname="argument hsaf_eip_binding", value=hsaf_eip_binding, expected_type=type_hints["hsaf_eip_binding"])
            check_type(argname="argument http2", value=http2, expected_type=type_hints["http2"])
            check_type(argname="argument http3", value=http3, expected_type=type_hints["http3"])
            check_type(argname="argument http_strict_transport_security", value=http_strict_transport_security, expected_type=type_hints["http_strict_transport_security"])
            check_type(argname="argument http_to_https_upgrade", value=http_to_https_upgrade, expected_type=type_hints["http_to_https_upgrade"])
            check_type(argname="argument image_and_video_manager", value=image_and_video_manager, expected_type=type_hints["image_and_video_manager"])
            check_type(argname="argument image_manager", value=image_manager, expected_type=type_hints["image_manager"])
            check_type(argname="argument image_manager_video", value=image_manager_video, expected_type=type_hints["image_manager_video"])
            check_type(argname="argument im_override", value=im_override, expected_type=type_hints["im_override"])
            check_type(argname="argument include", value=include, expected_type=type_hints["include"])
            check_type(argname="argument instant", value=instant, expected_type=type_hints["instant"])
            check_type(argname="argument instant_config", value=instant_config, expected_type=type_hints["instant_config"])
            check_type(argname="argument large_file_optimization", value=large_file_optimization, expected_type=type_hints["large_file_optimization"])
            check_type(argname="argument large_file_optimization_advanced", value=large_file_optimization_advanced, expected_type=type_hints["large_file_optimization_advanced"])
            check_type(argname="argument limit_bit_rate", value=limit_bit_rate, expected_type=type_hints["limit_bit_rate"])
            check_type(argname="argument log_custom", value=log_custom, expected_type=type_hints["log_custom"])
            check_type(argname="argument manifest_personalization", value=manifest_personalization, expected_type=type_hints["manifest_personalization"])
            check_type(argname="argument manifest_rerouting", value=manifest_rerouting, expected_type=type_hints["manifest_rerouting"])
            check_type(argname="argument manual_server_push", value=manual_server_push, expected_type=type_hints["manual_server_push"])
            check_type(argname="argument media_acceleration", value=media_acceleration, expected_type=type_hints["media_acceleration"])
            check_type(argname="argument media_acceleration_quic_optout", value=media_acceleration_quic_optout, expected_type=type_hints["media_acceleration_quic_optout"])
            check_type(argname="argument media_client", value=media_client, expected_type=type_hints["media_client"])
            check_type(argname="argument media_file_retrieval_optimization", value=media_file_retrieval_optimization, expected_type=type_hints["media_file_retrieval_optimization"])
            check_type(argname="argument media_origin_failover", value=media_origin_failover, expected_type=type_hints["media_origin_failover"])
            check_type(argname="argument metadata_caching", value=metadata_caching, expected_type=type_hints["metadata_caching"])
            check_type(argname="argument mobile_sdk_performance", value=mobile_sdk_performance, expected_type=type_hints["mobile_sdk_performance"])
            check_type(argname="argument modify_incoming_request_header", value=modify_incoming_request_header, expected_type=type_hints["modify_incoming_request_header"])
            check_type(argname="argument modify_incoming_response_header", value=modify_incoming_response_header, expected_type=type_hints["modify_incoming_response_header"])
            check_type(argname="argument modify_outgoing_request_header", value=modify_outgoing_request_header, expected_type=type_hints["modify_outgoing_request_header"])
            check_type(argname="argument modify_outgoing_response_header", value=modify_outgoing_response_header, expected_type=type_hints["modify_outgoing_response_header"])
            check_type(argname="argument modify_via_header", value=modify_via_header, expected_type=type_hints["modify_via_header"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument origin_characteristics", value=origin_characteristics, expected_type=type_hints["origin_characteristics"])
            check_type(argname="argument origin_characteristics_wsd", value=origin_characteristics_wsd, expected_type=type_hints["origin_characteristics_wsd"])
            check_type(argname="argument origin_failure_recovery_method", value=origin_failure_recovery_method, expected_type=type_hints["origin_failure_recovery_method"])
            check_type(argname="argument origin_failure_recovery_policy", value=origin_failure_recovery_policy, expected_type=type_hints["origin_failure_recovery_policy"])
            check_type(argname="argument origin_ip_acl", value=origin_ip_acl, expected_type=type_hints["origin_ip_acl"])
            check_type(argname="argument persistent_client_connection", value=persistent_client_connection, expected_type=type_hints["persistent_client_connection"])
            check_type(argname="argument persistent_connection", value=persistent_connection, expected_type=type_hints["persistent_connection"])
            check_type(argname="argument personally_identifiable_information", value=personally_identifiable_information, expected_type=type_hints["personally_identifiable_information"])
            check_type(argname="argument phased_release", value=phased_release, expected_type=type_hints["phased_release"])
            check_type(argname="argument preconnect", value=preconnect, expected_type=type_hints["preconnect"])
            check_type(argname="argument predictive_content_delivery", value=predictive_content_delivery, expected_type=type_hints["predictive_content_delivery"])
            check_type(argname="argument predictive_prefetching", value=predictive_prefetching, expected_type=type_hints["predictive_prefetching"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument prefetchable", value=prefetchable, expected_type=type_hints["prefetchable"])
            check_type(argname="argument prefresh_cache", value=prefresh_cache, expected_type=type_hints["prefresh_cache"])
            check_type(argname="argument quality", value=quality, expected_type=type_hints["quality"])
            check_type(argname="argument quic_beta", value=quic_beta, expected_type=type_hints["quic_beta"])
            check_type(argname="argument random_seek", value=random_seek, expected_type=type_hints["random_seek"])
            check_type(argname="argument rapid", value=rapid, expected_type=type_hints["rapid"])
            check_type(argname="argument read_timeout", value=read_timeout, expected_type=type_hints["read_timeout"])
            check_type(argname="argument real_time_reporting", value=real_time_reporting, expected_type=type_hints["real_time_reporting"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirectplus", value=redirectplus, expected_type=type_hints["redirectplus"])
            check_type(argname="argument referer_checking", value=referer_checking, expected_type=type_hints["referer_checking"])
            check_type(argname="argument remove_query_parameter", value=remove_query_parameter, expected_type=type_hints["remove_query_parameter"])
            check_type(argname="argument remove_vary", value=remove_vary, expected_type=type_hints["remove_vary"])
            check_type(argname="argument report", value=report, expected_type=type_hints["report"])
            check_type(argname="argument request_control", value=request_control, expected_type=type_hints["request_control"])
            check_type(argname="argument request_type_marker", value=request_type_marker, expected_type=type_hints["request_type_marker"])
            check_type(argname="argument resource_optimizer", value=resource_optimizer, expected_type=type_hints["resource_optimizer"])
            check_type(argname="argument resource_optimizer_extended_compatibility", value=resource_optimizer_extended_compatibility, expected_type=type_hints["resource_optimizer_extended_compatibility"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument response_cookie", value=response_cookie, expected_type=type_hints["response_cookie"])
            check_type(argname="argument restrict_object_caching", value=restrict_object_caching, expected_type=type_hints["restrict_object_caching"])
            check_type(argname="argument return_cache_status", value=return_cache_status, expected_type=type_hints["return_cache_status"])
            check_type(argname="argument rewrite_url", value=rewrite_url, expected_type=type_hints["rewrite_url"])
            check_type(argname="argument rum_custom", value=rum_custom, expected_type=type_hints["rum_custom"])
            check_type(argname="argument saas_definitions", value=saas_definitions, expected_type=type_hints["saas_definitions"])
            check_type(argname="argument sales_force_commerce_cloud_client", value=sales_force_commerce_cloud_client, expected_type=type_hints["sales_force_commerce_cloud_client"])
            check_type(argname="argument sales_force_commerce_cloud_provider", value=sales_force_commerce_cloud_provider, expected_type=type_hints["sales_force_commerce_cloud_provider"])
            check_type(argname="argument sales_force_commerce_cloud_provider_host_header", value=sales_force_commerce_cloud_provider_host_header, expected_type=type_hints["sales_force_commerce_cloud_provider_host_header"])
            check_type(argname="argument save_post_dca_processing", value=save_post_dca_processing, expected_type=type_hints["save_post_dca_processing"])
            check_type(argname="argument schedule_invalidation", value=schedule_invalidation, expected_type=type_hints["schedule_invalidation"])
            check_type(argname="argument script_management", value=script_management, expected_type=type_hints["script_management"])
            check_type(argname="argument segmented_content_protection", value=segmented_content_protection, expected_type=type_hints["segmented_content_protection"])
            check_type(argname="argument segmented_media_optimization", value=segmented_media_optimization, expected_type=type_hints["segmented_media_optimization"])
            check_type(argname="argument segmented_media_streaming_prefetch", value=segmented_media_streaming_prefetch, expected_type=type_hints["segmented_media_streaming_prefetch"])
            check_type(argname="argument set_variable", value=set_variable, expected_type=type_hints["set_variable"])
            check_type(argname="argument simulate_error_code", value=simulate_error_code, expected_type=type_hints["simulate_error_code"])
            check_type(argname="argument site_shield", value=site_shield, expected_type=type_hints["site_shield"])
            check_type(argname="argument standard_tls_migration", value=standard_tls_migration, expected_type=type_hints["standard_tls_migration"])
            check_type(argname="argument standard_tls_migration_override", value=standard_tls_migration_override, expected_type=type_hints["standard_tls_migration_override"])
            check_type(argname="argument strict_header_parsing", value=strict_header_parsing, expected_type=type_hints["strict_header_parsing"])
            check_type(argname="argument sub_customer", value=sub_customer, expected_type=type_hints["sub_customer"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument tcp_optimization", value=tcp_optimization, expected_type=type_hints["tcp_optimization"])
            check_type(argname="argument tea_leaf", value=tea_leaf, expected_type=type_hints["tea_leaf"])
            check_type(argname="argument tiered_distribution", value=tiered_distribution, expected_type=type_hints["tiered_distribution"])
            check_type(argname="argument tiered_distribution_advanced", value=tiered_distribution_advanced, expected_type=type_hints["tiered_distribution_advanced"])
            check_type(argname="argument tiered_distribution_customization", value=tiered_distribution_customization, expected_type=type_hints["tiered_distribution_customization"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uid_configuration", value=uid_configuration, expected_type=type_hints["uid_configuration"])
            check_type(argname="argument validate_entity_tag", value=validate_entity_tag, expected_type=type_hints["validate_entity_tag"])
            check_type(argname="argument verify_json_web_token", value=verify_json_web_token, expected_type=type_hints["verify_json_web_token"])
            check_type(argname="argument verify_json_web_token_for_dcp", value=verify_json_web_token_for_dcp, expected_type=type_hints["verify_json_web_token_for_dcp"])
            check_type(argname="argument verify_token_authorization", value=verify_token_authorization, expected_type=type_hints["verify_token_authorization"])
            check_type(argname="argument virtual_waiting_room", value=virtual_waiting_room, expected_type=type_hints["virtual_waiting_room"])
            check_type(argname="argument virtual_waiting_room_with_edge_workers", value=virtual_waiting_room_with_edge_workers, expected_type=type_hints["virtual_waiting_room_with_edge_workers"])
            check_type(argname="argument visitor_prioritization", value=visitor_prioritization, expected_type=type_hints["visitor_prioritization"])
            check_type(argname="argument visitor_prioritization_fifo", value=visitor_prioritization_fifo, expected_type=type_hints["visitor_prioritization_fifo"])
            check_type(argname="argument visitor_prioritization_fifo_standalone", value=visitor_prioritization_fifo_standalone, expected_type=type_hints["visitor_prioritization_fifo_standalone"])
            check_type(argname="argument watermarking", value=watermarking, expected_type=type_hints["watermarking"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
            check_type(argname="argument webdav", value=webdav, expected_type=type_hints["webdav"])
            check_type(argname="argument web_sockets", value=web_sockets, expected_type=type_hints["web_sockets"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if adaptive_acceleration is not None:
            self._values["adaptive_acceleration"] = adaptive_acceleration
        if adaptive_image_compression is not None:
            self._values["adaptive_image_compression"] = adaptive_image_compression
        if ad_scaler_circuit_breaker is not None:
            self._values["ad_scaler_circuit_breaker"] = ad_scaler_circuit_breaker
        if advanced is not None:
            self._values["advanced"] = advanced
        if aggregated_reporting is not None:
            self._values["aggregated_reporting"] = aggregated_reporting
        if akamaizer is not None:
            self._values["akamaizer"] = akamaizer
        if akamaizer_tag is not None:
            self._values["akamaizer_tag"] = akamaizer_tag
        if all_http_in_cache_hierarchy is not None:
            self._values["all_http_in_cache_hierarchy"] = all_http_in_cache_hierarchy
        if allow_cloudlets_origins is not None:
            self._values["allow_cloudlets_origins"] = allow_cloudlets_origins
        if allow_delete is not None:
            self._values["allow_delete"] = allow_delete
        if allow_https_cache_key_sharing is not None:
            self._values["allow_https_cache_key_sharing"] = allow_https_cache_key_sharing
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_options is not None:
            self._values["allow_options"] = allow_options
        if allow_patch is not None:
            self._values["allow_patch"] = allow_patch
        if allow_post is not None:
            self._values["allow_post"] = allow_post
        if allow_put is not None:
            self._values["allow_put"] = allow_put
        if allow_transfer_encoding is not None:
            self._values["allow_transfer_encoding"] = allow_transfer_encoding
        if alt_svc_header is not None:
            self._values["alt_svc_header"] = alt_svc_header
        if api_prioritization is not None:
            self._values["api_prioritization"] = api_prioritization
        if application_load_balancer is not None:
            self._values["application_load_balancer"] = application_load_balancer
        if audience_segmentation is not None:
            self._values["audience_segmentation"] = audience_segmentation
        if auto_domain_validation is not None:
            self._values["auto_domain_validation"] = auto_domain_validation
        if base_directory is not None:
            self._values["base_directory"] = base_directory
        if boss_beaconing is not None:
            self._values["boss_beaconing"] = boss_beaconing
        if breadcrumbs is not None:
            self._values["breadcrumbs"] = breadcrumbs
        if break_connection is not None:
            self._values["break_connection"] = break_connection
        if brotli is not None:
            self._values["brotli"] = brotli
        if cache_error is not None:
            self._values["cache_error"] = cache_error
        if cache_id is not None:
            self._values["cache_id"] = cache_id
        if cache_key_ignore_case is not None:
            self._values["cache_key_ignore_case"] = cache_key_ignore_case
        if cache_key_query_params is not None:
            self._values["cache_key_query_params"] = cache_key_query_params
        if cache_key_rewrite is not None:
            self._values["cache_key_rewrite"] = cache_key_rewrite
        if cache_post is not None:
            self._values["cache_post"] = cache_post
        if cache_redirect is not None:
            self._values["cache_redirect"] = cache_redirect
        if cache_tag is not None:
            self._values["cache_tag"] = cache_tag
        if cache_tag_visible is not None:
            self._values["cache_tag_visible"] = cache_tag_visible
        if caching is not None:
            self._values["caching"] = caching
        if central_authorization is not None:
            self._values["central_authorization"] = central_authorization
        if chase_redirects is not None:
            self._values["chase_redirects"] = chase_redirects
        if client_characteristics is not None:
            self._values["client_characteristics"] = client_characteristics
        if cloud_interconnects is not None:
            self._values["cloud_interconnects"] = cloud_interconnects
        if cloud_wrapper is not None:
            self._values["cloud_wrapper"] = cloud_wrapper
        if cloud_wrapper_advanced is not None:
            self._values["cloud_wrapper_advanced"] = cloud_wrapper_advanced
        if common_media_client_data is not None:
            self._values["common_media_client_data"] = common_media_client_data
        if conditional_origin is not None:
            self._values["conditional_origin"] = conditional_origin
        if construct_response is not None:
            self._values["construct_response"] = construct_response
        if content_characteristics is not None:
            self._values["content_characteristics"] = content_characteristics
        if content_characteristics_amd is not None:
            self._values["content_characteristics_amd"] = content_characteristics_amd
        if content_characteristics_dd is not None:
            self._values["content_characteristics_dd"] = content_characteristics_dd
        if content_characteristics_wsd_large_file is not None:
            self._values["content_characteristics_wsd_large_file"] = content_characteristics_wsd_large_file
        if content_characteristics_wsd_live is not None:
            self._values["content_characteristics_wsd_live"] = content_characteristics_wsd_live
        if content_characteristics_wsd_vod is not None:
            self._values["content_characteristics_wsd_vod"] = content_characteristics_wsd_vod
        if content_pre_position is not None:
            self._values["content_pre_position"] = content_pre_position
        if content_targeting_protection is not None:
            self._values["content_targeting_protection"] = content_targeting_protection
        if cors_support is not None:
            self._values["cors_support"] = cors_support
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if custom_behavior is not None:
            self._values["custom_behavior"] = custom_behavior
        if datastream is not None:
            self._values["datastream"] = datastream
        if dcp is not None:
            self._values["dcp"] = dcp
        if dcp_auth_hmac_transformation is not None:
            self._values["dcp_auth_hmac_transformation"] = dcp_auth_hmac_transformation
        if dcp_auth_regex_transformation is not None:
            self._values["dcp_auth_regex_transformation"] = dcp_auth_regex_transformation
        if dcp_auth_substring_transformation is not None:
            self._values["dcp_auth_substring_transformation"] = dcp_auth_substring_transformation
        if dcp_auth_variable_extractor is not None:
            self._values["dcp_auth_variable_extractor"] = dcp_auth_variable_extractor
        if dcp_default_authz_groups is not None:
            self._values["dcp_default_authz_groups"] = dcp_default_authz_groups
        if dcp_dev_relations is not None:
            self._values["dcp_dev_relations"] = dcp_dev_relations
        if dcp_real_time_auth is not None:
            self._values["dcp_real_time_auth"] = dcp_real_time_auth
        if delivery_receipt is not None:
            self._values["delivery_receipt"] = delivery_receipt
        if deny_access is not None:
            self._values["deny_access"] = deny_access
        if deny_direct_failover_access is not None:
            self._values["deny_direct_failover_access"] = deny_direct_failover_access
        if device_characteristic_cache_id is not None:
            self._values["device_characteristic_cache_id"] = device_characteristic_cache_id
        if device_characteristic_header is not None:
            self._values["device_characteristic_header"] = device_characteristic_header
        if dns_async_refresh is not None:
            self._values["dns_async_refresh"] = dns_async_refresh
        if dns_prefresh is not None:
            self._values["dns_prefresh"] = dns_prefresh
        if downgrade_protocol is not None:
            self._values["downgrade_protocol"] = downgrade_protocol
        if download_complete_marker is not None:
            self._values["download_complete_marker"] = download_complete_marker
        if download_notification is not None:
            self._values["download_notification"] = download_notification
        if downstream_cache is not None:
            self._values["downstream_cache"] = downstream_cache
        if dynamic_throughtput_optimization is not None:
            self._values["dynamic_throughtput_optimization"] = dynamic_throughtput_optimization
        if dynamic_throughtput_optimization_override is not None:
            self._values["dynamic_throughtput_optimization_override"] = dynamic_throughtput_optimization_override
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if ecms_bulk_upload is not None:
            self._values["ecms_bulk_upload"] = ecms_bulk_upload
        if ecms_database is not None:
            self._values["ecms_database"] = ecms_database
        if ecms_dataset is not None:
            self._values["ecms_dataset"] = ecms_dataset
        if ecms_object_key is not None:
            self._values["ecms_object_key"] = ecms_object_key
        if edge_connect is not None:
            self._values["edge_connect"] = edge_connect
        if edge_load_balancing_advanced is not None:
            self._values["edge_load_balancing_advanced"] = edge_load_balancing_advanced
        if edge_load_balancing_data_center is not None:
            self._values["edge_load_balancing_data_center"] = edge_load_balancing_data_center
        if edge_load_balancing_origin is not None:
            self._values["edge_load_balancing_origin"] = edge_load_balancing_origin
        if edge_origin_authorization is not None:
            self._values["edge_origin_authorization"] = edge_origin_authorization
        if edge_redirector is not None:
            self._values["edge_redirector"] = edge_redirector
        if edge_scape is not None:
            self._values["edge_scape"] = edge_scape
        if edge_side_includes is not None:
            self._values["edge_side_includes"] = edge_side_includes
        if edge_worker is not None:
            self._values["edge_worker"] = edge_worker
        if enhanced_akamai_protocol is not None:
            self._values["enhanced_akamai_protocol"] = enhanced_akamai_protocol
        if enhanced_proxy_detection is not None:
            self._values["enhanced_proxy_detection"] = enhanced_proxy_detection
        if epd_forward_header_enrichment is not None:
            self._values["epd_forward_header_enrichment"] = epd_forward_header_enrichment
        if fail_action is not None:
            self._values["fail_action"] = fail_action
        if failover_bot_manager_feature_compatibility is not None:
            self._values["failover_bot_manager_feature_compatibility"] = failover_bot_manager_feature_compatibility
        if fast_invalidate is not None:
            self._values["fast_invalidate"] = fast_invalidate
        if first_party_marketing is not None:
            self._values["first_party_marketing"] = first_party_marketing
        if first_party_marketing_plus is not None:
            self._values["first_party_marketing_plus"] = first_party_marketing_plus
        if forward_rewrite is not None:
            self._values["forward_rewrite"] = forward_rewrite
        if g2_oheader is not None:
            self._values["g2_oheader"] = g2_oheader
        if global_request_number is not None:
            self._values["global_request_number"] = global_request_number
        if graphql_caching is not None:
            self._values["graphql_caching"] = graphql_caching
        if gzip_response is not None:
            self._values["gzip_response"] = gzip_response
        if hd_data_advanced is not None:
            self._values["hd_data_advanced"] = hd_data_advanced
        if health_detection is not None:
            self._values["health_detection"] = health_detection
        if hsaf_eip_binding is not None:
            self._values["hsaf_eip_binding"] = hsaf_eip_binding
        if http2 is not None:
            self._values["http2"] = http2
        if http3 is not None:
            self._values["http3"] = http3
        if http_strict_transport_security is not None:
            self._values["http_strict_transport_security"] = http_strict_transport_security
        if http_to_https_upgrade is not None:
            self._values["http_to_https_upgrade"] = http_to_https_upgrade
        if image_and_video_manager is not None:
            self._values["image_and_video_manager"] = image_and_video_manager
        if image_manager is not None:
            self._values["image_manager"] = image_manager
        if image_manager_video is not None:
            self._values["image_manager_video"] = image_manager_video
        if im_override is not None:
            self._values["im_override"] = im_override
        if include is not None:
            self._values["include"] = include
        if instant is not None:
            self._values["instant"] = instant
        if instant_config is not None:
            self._values["instant_config"] = instant_config
        if large_file_optimization is not None:
            self._values["large_file_optimization"] = large_file_optimization
        if large_file_optimization_advanced is not None:
            self._values["large_file_optimization_advanced"] = large_file_optimization_advanced
        if limit_bit_rate is not None:
            self._values["limit_bit_rate"] = limit_bit_rate
        if log_custom is not None:
            self._values["log_custom"] = log_custom
        if manifest_personalization is not None:
            self._values["manifest_personalization"] = manifest_personalization
        if manifest_rerouting is not None:
            self._values["manifest_rerouting"] = manifest_rerouting
        if manual_server_push is not None:
            self._values["manual_server_push"] = manual_server_push
        if media_acceleration is not None:
            self._values["media_acceleration"] = media_acceleration
        if media_acceleration_quic_optout is not None:
            self._values["media_acceleration_quic_optout"] = media_acceleration_quic_optout
        if media_client is not None:
            self._values["media_client"] = media_client
        if media_file_retrieval_optimization is not None:
            self._values["media_file_retrieval_optimization"] = media_file_retrieval_optimization
        if media_origin_failover is not None:
            self._values["media_origin_failover"] = media_origin_failover
        if metadata_caching is not None:
            self._values["metadata_caching"] = metadata_caching
        if mobile_sdk_performance is not None:
            self._values["mobile_sdk_performance"] = mobile_sdk_performance
        if modify_incoming_request_header is not None:
            self._values["modify_incoming_request_header"] = modify_incoming_request_header
        if modify_incoming_response_header is not None:
            self._values["modify_incoming_response_header"] = modify_incoming_response_header
        if modify_outgoing_request_header is not None:
            self._values["modify_outgoing_request_header"] = modify_outgoing_request_header
        if modify_outgoing_response_header is not None:
            self._values["modify_outgoing_response_header"] = modify_outgoing_response_header
        if modify_via_header is not None:
            self._values["modify_via_header"] = modify_via_header
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if origin is not None:
            self._values["origin"] = origin
        if origin_characteristics is not None:
            self._values["origin_characteristics"] = origin_characteristics
        if origin_characteristics_wsd is not None:
            self._values["origin_characteristics_wsd"] = origin_characteristics_wsd
        if origin_failure_recovery_method is not None:
            self._values["origin_failure_recovery_method"] = origin_failure_recovery_method
        if origin_failure_recovery_policy is not None:
            self._values["origin_failure_recovery_policy"] = origin_failure_recovery_policy
        if origin_ip_acl is not None:
            self._values["origin_ip_acl"] = origin_ip_acl
        if persistent_client_connection is not None:
            self._values["persistent_client_connection"] = persistent_client_connection
        if persistent_connection is not None:
            self._values["persistent_connection"] = persistent_connection
        if personally_identifiable_information is not None:
            self._values["personally_identifiable_information"] = personally_identifiable_information
        if phased_release is not None:
            self._values["phased_release"] = phased_release
        if preconnect is not None:
            self._values["preconnect"] = preconnect
        if predictive_content_delivery is not None:
            self._values["predictive_content_delivery"] = predictive_content_delivery
        if predictive_prefetching is not None:
            self._values["predictive_prefetching"] = predictive_prefetching
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if prefetchable is not None:
            self._values["prefetchable"] = prefetchable
        if prefresh_cache is not None:
            self._values["prefresh_cache"] = prefresh_cache
        if quality is not None:
            self._values["quality"] = quality
        if quic_beta is not None:
            self._values["quic_beta"] = quic_beta
        if random_seek is not None:
            self._values["random_seek"] = random_seek
        if rapid is not None:
            self._values["rapid"] = rapid
        if read_timeout is not None:
            self._values["read_timeout"] = read_timeout
        if real_time_reporting is not None:
            self._values["real_time_reporting"] = real_time_reporting
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirectplus is not None:
            self._values["redirectplus"] = redirectplus
        if referer_checking is not None:
            self._values["referer_checking"] = referer_checking
        if remove_query_parameter is not None:
            self._values["remove_query_parameter"] = remove_query_parameter
        if remove_vary is not None:
            self._values["remove_vary"] = remove_vary
        if report is not None:
            self._values["report"] = report
        if request_control is not None:
            self._values["request_control"] = request_control
        if request_type_marker is not None:
            self._values["request_type_marker"] = request_type_marker
        if resource_optimizer is not None:
            self._values["resource_optimizer"] = resource_optimizer
        if resource_optimizer_extended_compatibility is not None:
            self._values["resource_optimizer_extended_compatibility"] = resource_optimizer_extended_compatibility
        if response_code is not None:
            self._values["response_code"] = response_code
        if response_cookie is not None:
            self._values["response_cookie"] = response_cookie
        if restrict_object_caching is not None:
            self._values["restrict_object_caching"] = restrict_object_caching
        if return_cache_status is not None:
            self._values["return_cache_status"] = return_cache_status
        if rewrite_url is not None:
            self._values["rewrite_url"] = rewrite_url
        if rum_custom is not None:
            self._values["rum_custom"] = rum_custom
        if saas_definitions is not None:
            self._values["saas_definitions"] = saas_definitions
        if sales_force_commerce_cloud_client is not None:
            self._values["sales_force_commerce_cloud_client"] = sales_force_commerce_cloud_client
        if sales_force_commerce_cloud_provider is not None:
            self._values["sales_force_commerce_cloud_provider"] = sales_force_commerce_cloud_provider
        if sales_force_commerce_cloud_provider_host_header is not None:
            self._values["sales_force_commerce_cloud_provider_host_header"] = sales_force_commerce_cloud_provider_host_header
        if save_post_dca_processing is not None:
            self._values["save_post_dca_processing"] = save_post_dca_processing
        if schedule_invalidation is not None:
            self._values["schedule_invalidation"] = schedule_invalidation
        if script_management is not None:
            self._values["script_management"] = script_management
        if segmented_content_protection is not None:
            self._values["segmented_content_protection"] = segmented_content_protection
        if segmented_media_optimization is not None:
            self._values["segmented_media_optimization"] = segmented_media_optimization
        if segmented_media_streaming_prefetch is not None:
            self._values["segmented_media_streaming_prefetch"] = segmented_media_streaming_prefetch
        if set_variable is not None:
            self._values["set_variable"] = set_variable
        if simulate_error_code is not None:
            self._values["simulate_error_code"] = simulate_error_code
        if site_shield is not None:
            self._values["site_shield"] = site_shield
        if standard_tls_migration is not None:
            self._values["standard_tls_migration"] = standard_tls_migration
        if standard_tls_migration_override is not None:
            self._values["standard_tls_migration_override"] = standard_tls_migration_override
        if strict_header_parsing is not None:
            self._values["strict_header_parsing"] = strict_header_parsing
        if sub_customer is not None:
            self._values["sub_customer"] = sub_customer
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if tcp_optimization is not None:
            self._values["tcp_optimization"] = tcp_optimization
        if tea_leaf is not None:
            self._values["tea_leaf"] = tea_leaf
        if tiered_distribution is not None:
            self._values["tiered_distribution"] = tiered_distribution
        if tiered_distribution_advanced is not None:
            self._values["tiered_distribution_advanced"] = tiered_distribution_advanced
        if tiered_distribution_customization is not None:
            self._values["tiered_distribution_customization"] = tiered_distribution_customization
        if timeout is not None:
            self._values["timeout"] = timeout
        if uid_configuration is not None:
            self._values["uid_configuration"] = uid_configuration
        if validate_entity_tag is not None:
            self._values["validate_entity_tag"] = validate_entity_tag
        if verify_json_web_token is not None:
            self._values["verify_json_web_token"] = verify_json_web_token
        if verify_json_web_token_for_dcp is not None:
            self._values["verify_json_web_token_for_dcp"] = verify_json_web_token_for_dcp
        if verify_token_authorization is not None:
            self._values["verify_token_authorization"] = verify_token_authorization
        if virtual_waiting_room is not None:
            self._values["virtual_waiting_room"] = virtual_waiting_room
        if virtual_waiting_room_with_edge_workers is not None:
            self._values["virtual_waiting_room_with_edge_workers"] = virtual_waiting_room_with_edge_workers
        if visitor_prioritization is not None:
            self._values["visitor_prioritization"] = visitor_prioritization
        if visitor_prioritization_fifo is not None:
            self._values["visitor_prioritization_fifo"] = visitor_prioritization_fifo
        if visitor_prioritization_fifo_standalone is not None:
            self._values["visitor_prioritization_fifo_standalone"] = visitor_prioritization_fifo_standalone
        if watermarking is not None:
            self._values["watermarking"] = watermarking
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall
        if webdav is not None:
            self._values["webdav"] = webdav
        if web_sockets is not None:
            self._values["web_sockets"] = web_sockets

    @builtins.property
    def adaptive_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration"]:
        '''adaptive_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        '''
        result = self._values.get("adaptive_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration"], result)

    @builtins.property
    def adaptive_image_compression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression"]:
        '''adaptive_image_compression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        '''
        result = self._values.get("adaptive_image_compression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression"], result)

    @builtins.property
    def ad_scaler_circuit_breaker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker"]:
        '''ad_scaler_circuit_breaker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        '''
        result = self._values.get("ad_scaler_circuit_breaker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker"], result)

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced"]:
        '''advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced"], result)

    @builtins.property
    def aggregated_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting"]:
        '''aggregated_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        '''
        result = self._values.get("aggregated_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting"], result)

    @builtins.property
    def akamaizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer"]:
        '''akamaizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        '''
        result = self._values.get("akamaizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer"], result)

    @builtins.property
    def akamaizer_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag"]:
        '''akamaizer_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        '''
        result = self._values.get("akamaizer_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag"], result)

    @builtins.property
    def all_http_in_cache_hierarchy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy"]:
        '''all_http_in_cache_hierarchy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        '''
        result = self._values.get("all_http_in_cache_hierarchy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy"], result)

    @builtins.property
    def allow_cloudlets_origins(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins"]:
        '''allow_cloudlets_origins block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        '''
        result = self._values.get("allow_cloudlets_origins")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins"], result)

    @builtins.property
    def allow_delete(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete"]:
        '''allow_delete block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        '''
        result = self._values.get("allow_delete")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete"], result)

    @builtins.property
    def allow_https_cache_key_sharing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing"]:
        '''allow_https_cache_key_sharing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        '''
        result = self._values.get("allow_https_cache_key_sharing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing"], result)

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade"]:
        '''allow_https_downgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade"], result)

    @builtins.property
    def allow_options(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions"]:
        '''allow_options block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        '''
        result = self._values.get("allow_options")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions"], result)

    @builtins.property
    def allow_patch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch"]:
        '''allow_patch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        '''
        result = self._values.get("allow_patch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch"], result)

    @builtins.property
    def allow_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost"]:
        '''allow_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        '''
        result = self._values.get("allow_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost"], result)

    @builtins.property
    def allow_put(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut"]:
        '''allow_put block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        '''
        result = self._values.get("allow_put")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut"], result)

    @builtins.property
    def allow_transfer_encoding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding"]:
        '''allow_transfer_encoding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        '''
        result = self._values.get("allow_transfer_encoding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding"], result)

    @builtins.property
    def alt_svc_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader"]:
        '''alt_svc_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        '''
        result = self._values.get("alt_svc_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader"], result)

    @builtins.property
    def api_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization"]:
        '''api_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        '''
        result = self._values.get("api_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization"], result)

    @builtins.property
    def application_load_balancer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer"]:
        '''application_load_balancer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        '''
        result = self._values.get("application_load_balancer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer"], result)

    @builtins.property
    def audience_segmentation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation"]:
        '''audience_segmentation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        '''
        result = self._values.get("audience_segmentation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation"], result)

    @builtins.property
    def auto_domain_validation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation"]:
        '''auto_domain_validation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        '''
        result = self._values.get("auto_domain_validation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation"], result)

    @builtins.property
    def base_directory(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory"]:
        '''base_directory block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        '''
        result = self._values.get("base_directory")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory"], result)

    @builtins.property
    def boss_beaconing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing"]:
        '''boss_beaconing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        '''
        result = self._values.get("boss_beaconing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing"], result)

    @builtins.property
    def breadcrumbs(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs"]:
        '''breadcrumbs block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        '''
        result = self._values.get("breadcrumbs")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs"], result)

    @builtins.property
    def break_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection"]:
        '''break_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        '''
        result = self._values.get("break_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection"], result)

    @builtins.property
    def brotli(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli"]:
        '''brotli block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        '''
        result = self._values.get("brotli")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli"], result)

    @builtins.property
    def cache_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError"]:
        '''cache_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        '''
        result = self._values.get("cache_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError"], result)

    @builtins.property
    def cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId"]:
        '''cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        '''
        result = self._values.get("cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId"], result)

    @builtins.property
    def cache_key_ignore_case(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase"]:
        '''cache_key_ignore_case block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        '''
        result = self._values.get("cache_key_ignore_case")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase"], result)

    @builtins.property
    def cache_key_query_params(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams"]:
        '''cache_key_query_params block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        '''
        result = self._values.get("cache_key_query_params")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams"], result)

    @builtins.property
    def cache_key_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite"]:
        '''cache_key_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        '''
        result = self._values.get("cache_key_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite"], result)

    @builtins.property
    def cache_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost"]:
        '''cache_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        '''
        result = self._values.get("cache_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost"], result)

    @builtins.property
    def cache_redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect"]:
        '''cache_redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        '''
        result = self._values.get("cache_redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect"], result)

    @builtins.property
    def cache_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag"]:
        '''cache_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        '''
        result = self._values.get("cache_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag"], result)

    @builtins.property
    def cache_tag_visible(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible"]:
        '''cache_tag_visible block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        '''
        result = self._values.get("cache_tag_visible")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible"], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching"]:
        '''caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching"], result)

    @builtins.property
    def central_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization"]:
        '''central_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        '''
        result = self._values.get("central_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization"], result)

    @builtins.property
    def chase_redirects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects"]:
        '''chase_redirects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        '''
        result = self._values.get("chase_redirects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects"], result)

    @builtins.property
    def client_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics"]:
        '''client_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        '''
        result = self._values.get("client_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics"], result)

    @builtins.property
    def cloud_interconnects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects"]:
        '''cloud_interconnects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        '''
        result = self._values.get("cloud_interconnects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects"], result)

    @builtins.property
    def cloud_wrapper(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper"]:
        '''cloud_wrapper block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        '''
        result = self._values.get("cloud_wrapper")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper"], result)

    @builtins.property
    def cloud_wrapper_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced"]:
        '''cloud_wrapper_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        '''
        result = self._values.get("cloud_wrapper_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced"], result)

    @builtins.property
    def common_media_client_data(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData"]:
        '''common_media_client_data block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        '''
        result = self._values.get("common_media_client_data")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData"], result)

    @builtins.property
    def conditional_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin"]:
        '''conditional_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        '''
        result = self._values.get("conditional_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin"], result)

    @builtins.property
    def construct_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse"]:
        '''construct_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        '''
        result = self._values.get("construct_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse"], result)

    @builtins.property
    def content_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics"]:
        '''content_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        '''
        result = self._values.get("content_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics"], result)

    @builtins.property
    def content_characteristics_amd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd"]:
        '''content_characteristics_amd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        '''
        result = self._values.get("content_characteristics_amd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd"], result)

    @builtins.property
    def content_characteristics_dd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd"]:
        '''content_characteristics_dd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        '''
        result = self._values.get("content_characteristics_dd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd"], result)

    @builtins.property
    def content_characteristics_wsd_large_file(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile"]:
        '''content_characteristics_wsd_large_file block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        '''
        result = self._values.get("content_characteristics_wsd_large_file")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile"], result)

    @builtins.property
    def content_characteristics_wsd_live(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive"]:
        '''content_characteristics_wsd_live block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        '''
        result = self._values.get("content_characteristics_wsd_live")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive"], result)

    @builtins.property
    def content_characteristics_wsd_vod(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod"]:
        '''content_characteristics_wsd_vod block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        '''
        result = self._values.get("content_characteristics_wsd_vod")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod"], result)

    @builtins.property
    def content_pre_position(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition"]:
        '''content_pre_position block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        '''
        result = self._values.get("content_pre_position")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition"], result)

    @builtins.property
    def content_targeting_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection"]:
        '''content_targeting_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        '''
        result = self._values.get("content_targeting_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection"], result)

    @builtins.property
    def cors_support(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport"]:
        '''cors_support block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        '''
        result = self._values.get("cors_support")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport"], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode"], result)

    @builtins.property
    def custom_behavior(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior"]:
        '''custom_behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        '''
        result = self._values.get("custom_behavior")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior"], result)

    @builtins.property
    def datastream(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream"]:
        '''datastream block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        '''
        result = self._values.get("datastream")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream"], result)

    @builtins.property
    def dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp"]:
        '''dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        '''
        result = self._values.get("dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp"], result)

    @builtins.property
    def dcp_auth_hmac_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation"]:
        '''dcp_auth_hmac_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        '''
        result = self._values.get("dcp_auth_hmac_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation"], result)

    @builtins.property
    def dcp_auth_regex_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation"]:
        '''dcp_auth_regex_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        '''
        result = self._values.get("dcp_auth_regex_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation"], result)

    @builtins.property
    def dcp_auth_substring_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation"]:
        '''dcp_auth_substring_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        '''
        result = self._values.get("dcp_auth_substring_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation"], result)

    @builtins.property
    def dcp_auth_variable_extractor(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor"]:
        '''dcp_auth_variable_extractor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        '''
        result = self._values.get("dcp_auth_variable_extractor")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor"], result)

    @builtins.property
    def dcp_default_authz_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups"]:
        '''dcp_default_authz_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        '''
        result = self._values.get("dcp_default_authz_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups"], result)

    @builtins.property
    def dcp_dev_relations(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations"]:
        '''dcp_dev_relations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        '''
        result = self._values.get("dcp_dev_relations")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations"], result)

    @builtins.property
    def dcp_real_time_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth"]:
        '''dcp_real_time_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        '''
        result = self._values.get("dcp_real_time_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth"], result)

    @builtins.property
    def delivery_receipt(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt"]:
        '''delivery_receipt block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        '''
        result = self._values.get("delivery_receipt")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt"], result)

    @builtins.property
    def deny_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess"]:
        '''deny_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        '''
        result = self._values.get("deny_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess"], result)

    @builtins.property
    def deny_direct_failover_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess"]:
        '''deny_direct_failover_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        '''
        result = self._values.get("deny_direct_failover_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess"], result)

    @builtins.property
    def device_characteristic_cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId"]:
        '''device_characteristic_cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        '''
        result = self._values.get("device_characteristic_cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId"], result)

    @builtins.property
    def device_characteristic_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader"]:
        '''device_characteristic_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        '''
        result = self._values.get("device_characteristic_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader"], result)

    @builtins.property
    def dns_async_refresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh"]:
        '''dns_async_refresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        '''
        result = self._values.get("dns_async_refresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh"], result)

    @builtins.property
    def dns_prefresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh"]:
        '''dns_prefresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        '''
        result = self._values.get("dns_prefresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh"], result)

    @builtins.property
    def downgrade_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol"]:
        '''downgrade_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        '''
        result = self._values.get("downgrade_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol"], result)

    @builtins.property
    def download_complete_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker"]:
        '''download_complete_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        '''
        result = self._values.get("download_complete_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker"], result)

    @builtins.property
    def download_notification(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification"]:
        '''download_notification block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        '''
        result = self._values.get("download_notification")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification"], result)

    @builtins.property
    def downstream_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache"]:
        '''downstream_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        '''
        result = self._values.get("downstream_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache"], result)

    @builtins.property
    def dynamic_throughtput_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization"]:
        '''dynamic_throughtput_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        '''
        result = self._values.get("dynamic_throughtput_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization"], result)

    @builtins.property
    def dynamic_throughtput_optimization_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride"]:
        '''dynamic_throughtput_optimization_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        '''
        result = self._values.get("dynamic_throughtput_optimization_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride"], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent"]:
        '''dynamic_web_content block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent"], result)

    @builtins.property
    def ecms_bulk_upload(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload"]:
        '''ecms_bulk_upload block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        '''
        result = self._values.get("ecms_bulk_upload")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload"], result)

    @builtins.property
    def ecms_database(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase"]:
        '''ecms_database block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        '''
        result = self._values.get("ecms_database")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase"], result)

    @builtins.property
    def ecms_dataset(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset"]:
        '''ecms_dataset block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        '''
        result = self._values.get("ecms_dataset")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset"], result)

    @builtins.property
    def ecms_object_key(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey"]:
        '''ecms_object_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        '''
        result = self._values.get("ecms_object_key")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey"], result)

    @builtins.property
    def edge_connect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect"]:
        '''edge_connect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        '''
        result = self._values.get("edge_connect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect"], result)

    @builtins.property
    def edge_load_balancing_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced"]:
        '''edge_load_balancing_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        '''
        result = self._values.get("edge_load_balancing_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced"], result)

    @builtins.property
    def edge_load_balancing_data_center(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter"]:
        '''edge_load_balancing_data_center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        '''
        result = self._values.get("edge_load_balancing_data_center")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter"], result)

    @builtins.property
    def edge_load_balancing_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin"]:
        '''edge_load_balancing_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        '''
        result = self._values.get("edge_load_balancing_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin"], result)

    @builtins.property
    def edge_origin_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization"]:
        '''edge_origin_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        '''
        result = self._values.get("edge_origin_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization"], result)

    @builtins.property
    def edge_redirector(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector"]:
        '''edge_redirector block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        '''
        result = self._values.get("edge_redirector")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector"], result)

    @builtins.property
    def edge_scape(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape"]:
        '''edge_scape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        '''
        result = self._values.get("edge_scape")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape"], result)

    @builtins.property
    def edge_side_includes(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes"]:
        '''edge_side_includes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        '''
        result = self._values.get("edge_side_includes")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes"], result)

    @builtins.property
    def edge_worker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker"]:
        '''edge_worker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        '''
        result = self._values.get("edge_worker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker"], result)

    @builtins.property
    def enhanced_akamai_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol"]:
        '''enhanced_akamai_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        '''
        result = self._values.get("enhanced_akamai_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol"], result)

    @builtins.property
    def enhanced_proxy_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection"]:
        '''enhanced_proxy_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        '''
        result = self._values.get("enhanced_proxy_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection"], result)

    @builtins.property
    def epd_forward_header_enrichment(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment"]:
        '''epd_forward_header_enrichment block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        '''
        result = self._values.get("epd_forward_header_enrichment")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment"], result)

    @builtins.property
    def fail_action(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction"]:
        '''fail_action block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        '''
        result = self._values.get("fail_action")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction"], result)

    @builtins.property
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility"]:
        '''failover_bot_manager_feature_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        '''
        result = self._values.get("failover_bot_manager_feature_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility"], result)

    @builtins.property
    def fast_invalidate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate"]:
        '''fast_invalidate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        '''
        result = self._values.get("fast_invalidate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate"], result)

    @builtins.property
    def first_party_marketing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing"]:
        '''first_party_marketing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        '''
        result = self._values.get("first_party_marketing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing"], result)

    @builtins.property
    def first_party_marketing_plus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus"]:
        '''first_party_marketing_plus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        '''
        result = self._values.get("first_party_marketing_plus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus"], result)

    @builtins.property
    def forward_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite"]:
        '''forward_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        '''
        result = self._values.get("forward_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite"], result)

    @builtins.property
    def g2_oheader(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader"]:
        '''g2oheader block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        '''
        result = self._values.get("g2_oheader")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader"], result)

    @builtins.property
    def global_request_number(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber"]:
        '''global_request_number block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        '''
        result = self._values.get("global_request_number")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber"], result)

    @builtins.property
    def graphql_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching"]:
        '''graphql_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        '''
        result = self._values.get("graphql_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching"], result)

    @builtins.property
    def gzip_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse"]:
        '''gzip_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        '''
        result = self._values.get("gzip_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse"], result)

    @builtins.property
    def hd_data_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced"]:
        '''hd_data_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        '''
        result = self._values.get("hd_data_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced"], result)

    @builtins.property
    def health_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection"]:
        '''health_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        '''
        result = self._values.get("health_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection"], result)

    @builtins.property
    def hsaf_eip_binding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding"]:
        '''hsaf_eip_binding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        '''
        result = self._values.get("hsaf_eip_binding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding"], result)

    @builtins.property
    def http2(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2"]:
        '''http2 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        '''
        result = self._values.get("http2")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2"], result)

    @builtins.property
    def http3(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3"]:
        '''http3 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        '''
        result = self._values.get("http3")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3"], result)

    @builtins.property
    def http_strict_transport_security(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity"]:
        '''http_strict_transport_security block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        '''
        result = self._values.get("http_strict_transport_security")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity"], result)

    @builtins.property
    def http_to_https_upgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade"]:
        '''http_to_https_upgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        '''
        result = self._values.get("http_to_https_upgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade"], result)

    @builtins.property
    def image_and_video_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager"]:
        '''image_and_video_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        '''
        result = self._values.get("image_and_video_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager"], result)

    @builtins.property
    def image_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager"]:
        '''image_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        '''
        result = self._values.get("image_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager"], result)

    @builtins.property
    def image_manager_video(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo"]:
        '''image_manager_video block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        '''
        result = self._values.get("image_manager_video")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo"], result)

    @builtins.property
    def im_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride"]:
        '''im_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        '''
        result = self._values.get("im_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride"], result)

    @builtins.property
    def include(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude"]:
        '''include block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        '''
        result = self._values.get("include")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude"], result)

    @builtins.property
    def instant(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant"]:
        '''instant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        '''
        result = self._values.get("instant")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant"], result)

    @builtins.property
    def instant_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig"]:
        '''instant_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        '''
        result = self._values.get("instant_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig"], result)

    @builtins.property
    def large_file_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization"]:
        '''large_file_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        '''
        result = self._values.get("large_file_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization"], result)

    @builtins.property
    def large_file_optimization_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced"]:
        '''large_file_optimization_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        '''
        result = self._values.get("large_file_optimization_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced"], result)

    @builtins.property
    def limit_bit_rate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate"]:
        '''limit_bit_rate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        '''
        result = self._values.get("limit_bit_rate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate"], result)

    @builtins.property
    def log_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom"]:
        '''log_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        '''
        result = self._values.get("log_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom"], result)

    @builtins.property
    def manifest_personalization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization"]:
        '''manifest_personalization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        '''
        result = self._values.get("manifest_personalization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization"], result)

    @builtins.property
    def manifest_rerouting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting"]:
        '''manifest_rerouting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        '''
        result = self._values.get("manifest_rerouting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting"], result)

    @builtins.property
    def manual_server_push(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush"]:
        '''manual_server_push block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        '''
        result = self._values.get("manual_server_push")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush"], result)

    @builtins.property
    def media_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration"]:
        '''media_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        '''
        result = self._values.get("media_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration"], result)

    @builtins.property
    def media_acceleration_quic_optout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout"]:
        '''media_acceleration_quic_optout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        '''
        result = self._values.get("media_acceleration_quic_optout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout"], result)

    @builtins.property
    def media_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient"]:
        '''media_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        '''
        result = self._values.get("media_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient"], result)

    @builtins.property
    def media_file_retrieval_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization"]:
        '''media_file_retrieval_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        '''
        result = self._values.get("media_file_retrieval_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization"], result)

    @builtins.property
    def media_origin_failover(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover"]:
        '''media_origin_failover block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        '''
        result = self._values.get("media_origin_failover")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover"], result)

    @builtins.property
    def metadata_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching"]:
        '''metadata_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        '''
        result = self._values.get("metadata_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching"], result)

    @builtins.property
    def mobile_sdk_performance(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance"]:
        '''mobile_sdk_performance block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        '''
        result = self._values.get("mobile_sdk_performance")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance"], result)

    @builtins.property
    def modify_incoming_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader"]:
        '''modify_incoming_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        '''
        result = self._values.get("modify_incoming_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader"], result)

    @builtins.property
    def modify_incoming_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader"]:
        '''modify_incoming_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        '''
        result = self._values.get("modify_incoming_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader"], result)

    @builtins.property
    def modify_outgoing_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader"]:
        '''modify_outgoing_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        '''
        result = self._values.get("modify_outgoing_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader"], result)

    @builtins.property
    def modify_outgoing_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader"]:
        '''modify_outgoing_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        '''
        result = self._values.get("modify_outgoing_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader"], result)

    @builtins.property
    def modify_via_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader"]:
        '''modify_via_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        '''
        result = self._values.get("modify_via_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader"], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse"]:
        '''m_pulse block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse"], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin"]:
        '''origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin"], result)

    @builtins.property
    def origin_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics"]:
        '''origin_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        '''
        result = self._values.get("origin_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics"], result)

    @builtins.property
    def origin_characteristics_wsd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd"]:
        '''origin_characteristics_wsd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        '''
        result = self._values.get("origin_characteristics_wsd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd"], result)

    @builtins.property
    def origin_failure_recovery_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod"]:
        '''origin_failure_recovery_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        '''
        result = self._values.get("origin_failure_recovery_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod"], result)

    @builtins.property
    def origin_failure_recovery_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy"]:
        '''origin_failure_recovery_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        '''
        result = self._values.get("origin_failure_recovery_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy"], result)

    @builtins.property
    def origin_ip_acl(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl"]:
        '''origin_ip_acl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        '''
        result = self._values.get("origin_ip_acl")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl"], result)

    @builtins.property
    def persistent_client_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection"]:
        '''persistent_client_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        '''
        result = self._values.get("persistent_client_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection"], result)

    @builtins.property
    def persistent_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection"]:
        '''persistent_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        '''
        result = self._values.get("persistent_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection"], result)

    @builtins.property
    def personally_identifiable_information(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation"]:
        '''personally_identifiable_information block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        '''
        result = self._values.get("personally_identifiable_information")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation"], result)

    @builtins.property
    def phased_release(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease"]:
        '''phased_release block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        '''
        result = self._values.get("phased_release")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease"], result)

    @builtins.property
    def preconnect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect"]:
        '''preconnect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        '''
        result = self._values.get("preconnect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect"], result)

    @builtins.property
    def predictive_content_delivery(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery"]:
        '''predictive_content_delivery block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        '''
        result = self._values.get("predictive_content_delivery")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery"], result)

    @builtins.property
    def predictive_prefetching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching"]:
        '''predictive_prefetching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        '''
        result = self._values.get("predictive_prefetching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching"], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch"]:
        '''prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch"], result)

    @builtins.property
    def prefetchable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable"]:
        '''prefetchable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        '''
        result = self._values.get("prefetchable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable"], result)

    @builtins.property
    def prefresh_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache"]:
        '''prefresh_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        '''
        result = self._values.get("prefresh_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache"], result)

    @builtins.property
    def quality(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality"]:
        '''quality block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        '''
        result = self._values.get("quality")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality"], result)

    @builtins.property
    def quic_beta(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta"]:
        '''quic_beta block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        '''
        result = self._values.get("quic_beta")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta"], result)

    @builtins.property
    def random_seek(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek"]:
        '''random_seek block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        '''
        result = self._values.get("random_seek")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek"], result)

    @builtins.property
    def rapid(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid"]:
        '''rapid block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        '''
        result = self._values.get("rapid")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid"], result)

    @builtins.property
    def read_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout"]:
        '''read_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        '''
        result = self._values.get("read_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout"], result)

    @builtins.property
    def real_time_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting"]:
        '''real_time_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        '''
        result = self._values.get("real_time_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting"], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring"]:
        '''real_user_monitoring block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring"], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect"]:
        '''redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect"], result)

    @builtins.property
    def redirectplus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus"]:
        '''redirectplus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        '''
        result = self._values.get("redirectplus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus"], result)

    @builtins.property
    def referer_checking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking"]:
        '''referer_checking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        '''
        result = self._values.get("referer_checking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking"], result)

    @builtins.property
    def remove_query_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter"]:
        '''remove_query_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        '''
        result = self._values.get("remove_query_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter"], result)

    @builtins.property
    def remove_vary(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary"]:
        '''remove_vary block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        '''
        result = self._values.get("remove_vary")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary"], result)

    @builtins.property
    def report(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport"]:
        '''report block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        '''
        result = self._values.get("report")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport"], result)

    @builtins.property
    def request_control(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl"]:
        '''request_control block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        '''
        result = self._values.get("request_control")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl"], result)

    @builtins.property
    def request_type_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker"]:
        '''request_type_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        '''
        result = self._values.get("request_type_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker"], result)

    @builtins.property
    def resource_optimizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer"]:
        '''resource_optimizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        '''
        result = self._values.get("resource_optimizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer"], result)

    @builtins.property
    def resource_optimizer_extended_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility"]:
        '''resource_optimizer_extended_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        '''
        result = self._values.get("resource_optimizer_extended_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility"], result)

    @builtins.property
    def response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode"]:
        '''response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode"], result)

    @builtins.property
    def response_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie"]:
        '''response_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        '''
        result = self._values.get("response_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie"], result)

    @builtins.property
    def restrict_object_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching"]:
        '''restrict_object_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        '''
        result = self._values.get("restrict_object_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching"], result)

    @builtins.property
    def return_cache_status(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus"]:
        '''return_cache_status block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        '''
        result = self._values.get("return_cache_status")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus"], result)

    @builtins.property
    def rewrite_url(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl"]:
        '''rewrite_url block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        '''
        result = self._values.get("rewrite_url")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl"], result)

    @builtins.property
    def rum_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom"]:
        '''rum_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        '''
        result = self._values.get("rum_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom"], result)

    @builtins.property
    def saas_definitions(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions"]:
        '''saas_definitions block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        '''
        result = self._values.get("saas_definitions")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions"], result)

    @builtins.property
    def sales_force_commerce_cloud_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient"]:
        '''sales_force_commerce_cloud_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        '''
        result = self._values.get("sales_force_commerce_cloud_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider"]:
        '''sales_force_commerce_cloud_provider block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        '''sales_force_commerce_cloud_provider_host_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider_host_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader"], result)

    @builtins.property
    def save_post_dca_processing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing"]:
        '''save_post_dca_processing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        '''
        result = self._values.get("save_post_dca_processing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing"], result)

    @builtins.property
    def schedule_invalidation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation"]:
        '''schedule_invalidation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        '''
        result = self._values.get("schedule_invalidation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation"], result)

    @builtins.property
    def script_management(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement"]:
        '''script_management block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        '''
        result = self._values.get("script_management")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement"], result)

    @builtins.property
    def segmented_content_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection"]:
        '''segmented_content_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        '''
        result = self._values.get("segmented_content_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection"], result)

    @builtins.property
    def segmented_media_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization"]:
        '''segmented_media_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        '''
        result = self._values.get("segmented_media_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization"], result)

    @builtins.property
    def segmented_media_streaming_prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch"]:
        '''segmented_media_streaming_prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        '''
        result = self._values.get("segmented_media_streaming_prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch"], result)

    @builtins.property
    def set_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable"]:
        '''set_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        '''
        result = self._values.get("set_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable"], result)

    @builtins.property
    def simulate_error_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode"]:
        '''simulate_error_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        '''
        result = self._values.get("simulate_error_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode"], result)

    @builtins.property
    def site_shield(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield"]:
        '''site_shield block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        '''
        result = self._values.get("site_shield")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield"], result)

    @builtins.property
    def standard_tls_migration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration"]:
        '''standard_tls_migration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        '''
        result = self._values.get("standard_tls_migration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration"], result)

    @builtins.property
    def standard_tls_migration_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride"]:
        '''standard_tls_migration_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        '''
        result = self._values.get("standard_tls_migration_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride"], result)

    @builtins.property
    def strict_header_parsing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing"]:
        '''strict_header_parsing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        '''
        result = self._values.get("strict_header_parsing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing"], result)

    @builtins.property
    def sub_customer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer"]:
        '''sub_customer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        '''
        result = self._values.get("sub_customer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer"], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute"]:
        '''sure_route block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute"], result)

    @builtins.property
    def tcp_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization"]:
        '''tcp_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        '''
        result = self._values.get("tcp_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization"], result)

    @builtins.property
    def tea_leaf(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf"]:
        '''tea_leaf block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        '''
        result = self._values.get("tea_leaf")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf"], result)

    @builtins.property
    def tiered_distribution(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution"]:
        '''tiered_distribution block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        '''
        result = self._values.get("tiered_distribution")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution"], result)

    @builtins.property
    def tiered_distribution_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced"]:
        '''tiered_distribution_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        '''
        result = self._values.get("tiered_distribution_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced"], result)

    @builtins.property
    def tiered_distribution_customization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization"]:
        '''tiered_distribution_customization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        '''
        result = self._values.get("tiered_distribution_customization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization"], result)

    @builtins.property
    def timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout"]:
        '''timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout"], result)

    @builtins.property
    def uid_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration"]:
        '''uid_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        '''
        result = self._values.get("uid_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration"], result)

    @builtins.property
    def validate_entity_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag"]:
        '''validate_entity_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        '''
        result = self._values.get("validate_entity_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag"], result)

    @builtins.property
    def verify_json_web_token(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken"]:
        '''verify_json_web_token block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        '''
        result = self._values.get("verify_json_web_token")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken"], result)

    @builtins.property
    def verify_json_web_token_for_dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp"]:
        '''verify_json_web_token_for_dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        '''
        result = self._values.get("verify_json_web_token_for_dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp"], result)

    @builtins.property
    def verify_token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization"]:
        '''verify_token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        '''
        result = self._values.get("verify_token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization"], result)

    @builtins.property
    def virtual_waiting_room(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom"]:
        '''virtual_waiting_room block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        '''
        result = self._values.get("virtual_waiting_room")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom"], result)

    @builtins.property
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        '''virtual_waiting_room_with_edge_workers block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        '''
        result = self._values.get("virtual_waiting_room_with_edge_workers")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers"], result)

    @builtins.property
    def visitor_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization"]:
        '''visitor_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        '''
        result = self._values.get("visitor_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization"], result)

    @builtins.property
    def visitor_prioritization_fifo(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo"]:
        '''visitor_prioritization_fifo block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        '''
        result = self._values.get("visitor_prioritization_fifo")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo"], result)

    @builtins.property
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone"]:
        '''visitor_prioritization_fifo_standalone block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        '''
        result = self._values.get("visitor_prioritization_fifo_standalone")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone"], result)

    @builtins.property
    def watermarking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking"]:
        '''watermarking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        '''
        result = self._values.get("watermarking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking"], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall"]:
        '''web_application_firewall block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall"], result)

    @builtins.property
    def webdav(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav"]:
        '''webdav block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        '''
        result = self._values.get("webdav")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav"], result)

    @builtins.property
    def web_sockets(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets"]:
        '''web_sockets block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        result = self._values.get("web_sockets")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530Behavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker",
    jsii_struct_bases=[],
    name_mapping={
        "fallback_action_response_code_based": "fallbackActionResponseCodeBased",
        "locked": "locked",
        "response_code_based": "responseCodeBased",
        "response_codes": "responseCodes",
        "response_delay_based": "responseDelayBased",
        "response_delay_threshold": "responseDelayThreshold",
        "return_error_response_code_based": "returnErrorResponseCodeBased",
        "specify_your_own_response_code_based": "specifyYourOwnResponseCodeBased",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker:
    def __init__(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bcaa2cc213a73423a6937fb28d2135b96939607050206dd5546f5197abbe6f1)
            check_type(argname="argument fallback_action_response_code_based", value=fallback_action_response_code_based, expected_type=type_hints["fallback_action_response_code_based"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code_based", value=response_code_based, expected_type=type_hints["response_code_based"])
            check_type(argname="argument response_codes", value=response_codes, expected_type=type_hints["response_codes"])
            check_type(argname="argument response_delay_based", value=response_delay_based, expected_type=type_hints["response_delay_based"])
            check_type(argname="argument response_delay_threshold", value=response_delay_threshold, expected_type=type_hints["response_delay_threshold"])
            check_type(argname="argument return_error_response_code_based", value=return_error_response_code_based, expected_type=type_hints["return_error_response_code_based"])
            check_type(argname="argument specify_your_own_response_code_based", value=specify_your_own_response_code_based, expected_type=type_hints["specify_your_own_response_code_based"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fallback_action_response_code_based is not None:
            self._values["fallback_action_response_code_based"] = fallback_action_response_code_based
        if locked is not None:
            self._values["locked"] = locked
        if response_code_based is not None:
            self._values["response_code_based"] = response_code_based
        if response_codes is not None:
            self._values["response_codes"] = response_codes
        if response_delay_based is not None:
            self._values["response_delay_based"] = response_delay_based
        if response_delay_threshold is not None:
            self._values["response_delay_threshold"] = response_delay_threshold
        if return_error_response_code_based is not None:
            self._values["return_error_response_code_based"] = return_error_response_code_based
        if specify_your_own_response_code_based is not None:
            self._values["specify_your_own_response_code_based"] = specify_your_own_response_code_based
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def fallback_action_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        '''
        result = self._values.get("fallback_action_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the response code from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        '''
        result = self._values.get("response_code_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_codes(self) -> typing.Optional[builtins.str]:
        '''Specifies the codes in the partner's response that trigger the fallback action,  either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        '''
        result = self._values.get("response_codes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_delay_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the delayed response from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        '''
        result = self._values.get("response_delay_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_delay_threshold(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum response delay that, if exceeded, triggers the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        '''
        result = self._values.get("response_delay_threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def return_error_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the error to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        '''
        result = self._values.get("return_error_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_your_own_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Defines a custom error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        '''
        result = self._values.get("specify_your_own_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreakerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreakerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84bf687efd8ddc3674048faf7918fe133a163b0edbae0b20f264b3ddafae8721)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFallbackActionResponseCodeBased")
    def reset_fallback_action_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFallbackActionResponseCodeBased", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCodeBased")
    def reset_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodeBased", []))

    @jsii.member(jsii_name="resetResponseCodes")
    def reset_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodes", []))

    @jsii.member(jsii_name="resetResponseDelayBased")
    def reset_response_delay_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayBased", []))

    @jsii.member(jsii_name="resetResponseDelayThreshold")
    def reset_response_delay_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayThreshold", []))

    @jsii.member(jsii_name="resetReturnErrorResponseCodeBased")
    def reset_return_error_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnErrorResponseCodeBased", []))

    @jsii.member(jsii_name="resetSpecifyYourOwnResponseCodeBased")
    def reset_specify_your_own_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyYourOwnResponseCodeBased", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBasedInput")
    def fallback_action_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fallbackActionResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeBasedInput")
    def response_code_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodesInput")
    def response_codes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayBasedInput")
    def response_delay_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseDelayBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayThresholdInput")
    def response_delay_threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseDelayThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBasedInput")
    def return_error_response_code_based_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "returnErrorResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBasedInput")
    def specify_your_own_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "specifyYourOwnResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBased")
    def fallback_action_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fallbackActionResponseCodeBased"))

    @fallback_action_response_code_based.setter
    def fallback_action_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c811bfaf7f5d0be7d8017bddfdf4a067d4fb613790b4302fa27b621751cab825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fallbackActionResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26cc132fdaef04297a22da25a3adedb177fafad2737fc32735727b750950c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodeBased")
    def response_code_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseCodeBased"))

    @response_code_based.setter
    def response_code_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd89929ac4401b1fa25dfda5b358aab47863ce9a290a56a2034fa5a0f82704b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodes")
    def response_codes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseCodes"))

    @response_codes.setter
    def response_codes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163a6e5be8b707d2be495f54391e7235a3fcfda5bf38e5a98db2af99dba2c4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayBased")
    def response_delay_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseDelayBased"))

    @response_delay_based.setter
    def response_delay_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__164a11551191cf9ba30819e6e27a83326b0d0199f665bfa5fe7cdd07c2e447a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayThreshold")
    def response_delay_threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseDelayThreshold"))

    @response_delay_threshold.setter
    def response_delay_threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469016f202b37407aeb0832833973384f5eec26b7ccf94ac2ab6f618a60f3058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBased")
    def return_error_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "returnErrorResponseCodeBased"))

    @return_error_response_code_based.setter
    def return_error_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b102e6ce0d9381bd4d3a7928c7dcd22427a1f2b94217c6a2548fbf7bceec605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "returnErrorResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBased")
    def specify_your_own_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "specifyYourOwnResponseCodeBased"))

    @specify_your_own_response_code_based.setter
    def specify_your_own_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b83a5ab42508a71a4998994633c9c74a9a45af03a1fea262457b91e0b568a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyYourOwnResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e393b246e9b95ac64a6ca2e00dc17d1ad4dc7593a9d7b02d54104b93764e9b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8832307dd4f504f38cf8b46cb1b639a8cd9efaeeacb4f82fd806b5c6aa6d0ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__363e2d014f0ad8bfb847558bf9c7827b890991d285da56c8c45c8f380d75f113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "ab_logic": "abLogic",
        "ab_testing": "abTesting",
        "compression": "compression",
        "cookie_name": "cookieName",
        "enable_brotli_compression": "enableBrotliCompression",
        "enable_for_noncacheable": "enableForNoncacheable",
        "enable_preconnect": "enablePreconnect",
        "enable_push": "enablePush",
        "enable_ro": "enableRo",
        "locked": "locked",
        "preload_enable": "preloadEnable",
        "source": "source",
        "template_uuid": "templateUuid",
        "title_brotli": "titleBrotli",
        "title_http2_server_push": "titleHttp2ServerPush",
        "title_preconnect": "titlePreconnect",
        "title_preload": "titlePreload",
        "title_ro": "titleRo",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration:
    def __init__(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b2c127c3fbf6713bb3543b53c99a51fe46107ea5a84ce6b045d8e1a17011c2)
            check_type(argname="argument ab_logic", value=ab_logic, expected_type=type_hints["ab_logic"])
            check_type(argname="argument ab_testing", value=ab_testing, expected_type=type_hints["ab_testing"])
            check_type(argname="argument compression", value=compression, expected_type=type_hints["compression"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument enable_brotli_compression", value=enable_brotli_compression, expected_type=type_hints["enable_brotli_compression"])
            check_type(argname="argument enable_for_noncacheable", value=enable_for_noncacheable, expected_type=type_hints["enable_for_noncacheable"])
            check_type(argname="argument enable_preconnect", value=enable_preconnect, expected_type=type_hints["enable_preconnect"])
            check_type(argname="argument enable_push", value=enable_push, expected_type=type_hints["enable_push"])
            check_type(argname="argument enable_ro", value=enable_ro, expected_type=type_hints["enable_ro"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preload_enable", value=preload_enable, expected_type=type_hints["preload_enable"])
            check_type(argname="argument source", value=source, expected_type=type_hints["source"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_brotli", value=title_brotli, expected_type=type_hints["title_brotli"])
            check_type(argname="argument title_http2_server_push", value=title_http2_server_push, expected_type=type_hints["title_http2_server_push"])
            check_type(argname="argument title_preconnect", value=title_preconnect, expected_type=type_hints["title_preconnect"])
            check_type(argname="argument title_preload", value=title_preload, expected_type=type_hints["title_preload"])
            check_type(argname="argument title_ro", value=title_ro, expected_type=type_hints["title_ro"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_logic is not None:
            self._values["ab_logic"] = ab_logic
        if ab_testing is not None:
            self._values["ab_testing"] = ab_testing
        if compression is not None:
            self._values["compression"] = compression
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if enable_brotli_compression is not None:
            self._values["enable_brotli_compression"] = enable_brotli_compression
        if enable_for_noncacheable is not None:
            self._values["enable_for_noncacheable"] = enable_for_noncacheable
        if enable_preconnect is not None:
            self._values["enable_preconnect"] = enable_preconnect
        if enable_push is not None:
            self._values["enable_push"] = enable_push
        if enable_ro is not None:
            self._values["enable_ro"] = enable_ro
        if locked is not None:
            self._values["locked"] = locked
        if preload_enable is not None:
            self._values["preload_enable"] = preload_enable
        if source is not None:
            self._values["source"] = source
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_brotli is not None:
            self._values["title_brotli"] = title_brotli
        if title_http2_server_push is not None:
            self._values["title_http2_server_push"] = title_http2_server_push
        if title_preconnect is not None:
            self._values["title_preconnect"] = title_preconnect
        if title_preload is not None:
            self._values["title_preload"] = title_preload
        if title_ro is not None:
            self._values["title_ro"] = title_ro
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def ab_logic(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to use Adaptive Acceleration in an A/B testing environment.

        To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        '''
        result = self._values.get("ab_logic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ab_testing(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        '''
        result = self._values.get("ab_testing")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compression(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        '''
        result = self._values.get("compression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_brotli_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression, converting your origin content to cache on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        '''
        result = self._values.get("enable_brotli_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_for_noncacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression to non-cacheable content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        '''
        result = self._values.get("enable_for_noncacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_preconnect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time.

        See ``Automatic Preconnect`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        '''
        result = self._values.get("enable_preconnect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_push(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Recognizes resources like JavaScript, CSS, and images  based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app.

        See ``Automatic Server Push`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        '''
        result = self._values.get("enable_push")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ro(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        '''
        result = self._values.get("enable_ro")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preload_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to preload necessary fonts before they fetch and process other resources.

        See ``Automatic Font Preload`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        '''
        result = self._values.get("preload_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def source(self) -> typing.Optional[builtins.str]:
        '''The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``.

        The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        '''
        result = self._values.get("source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_brotli(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        '''
        result = self._values.get("title_brotli")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_http2_server_push(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        '''
        result = self._values.get("title_http2_server_push")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preconnect(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        '''
        result = self._values.get("title_preconnect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preload(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        '''
        result = self._values.get("title_preload")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_ro(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        '''
        result = self._values.get("title_ro")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecaf9b13eb9d75d25ef86af64c75d2f6e7d4cdda0c77f4b0298b1a7b585fc4c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbLogic")
    def reset_ab_logic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbLogic", []))

    @jsii.member(jsii_name="resetAbTesting")
    def reset_ab_testing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbTesting", []))

    @jsii.member(jsii_name="resetCompression")
    def reset_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompression", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetEnableBrotliCompression")
    def reset_enable_brotli_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBrotliCompression", []))

    @jsii.member(jsii_name="resetEnableForNoncacheable")
    def reset_enable_for_noncacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableForNoncacheable", []))

    @jsii.member(jsii_name="resetEnablePreconnect")
    def reset_enable_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePreconnect", []))

    @jsii.member(jsii_name="resetEnablePush")
    def reset_enable_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePush", []))

    @jsii.member(jsii_name="resetEnableRo")
    def reset_enable_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreloadEnable")
    def reset_preload_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreloadEnable", []))

    @jsii.member(jsii_name="resetSource")
    def reset_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSource", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleBrotli")
    def reset_title_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleBrotli", []))

    @jsii.member(jsii_name="resetTitleHttp2ServerPush")
    def reset_title_http2_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleHttp2ServerPush", []))

    @jsii.member(jsii_name="resetTitlePreconnect")
    def reset_title_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreconnect", []))

    @jsii.member(jsii_name="resetTitlePreload")
    def reset_title_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreload", []))

    @jsii.member(jsii_name="resetTitleRo")
    def reset_title_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleRo", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="abLogicInput")
    def ab_logic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abLogicInput"))

    @builtins.property
    @jsii.member(jsii_name="abTestingInput")
    def ab_testing_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abTestingInput"))

    @builtins.property
    @jsii.member(jsii_name="compressionInput")
    def compression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "compressionInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompressionInput")
    def enable_brotli_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBrotliCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheableInput")
    def enable_for_noncacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableForNoncacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePreconnectInput")
    def enable_preconnect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePushInput")
    def enable_push_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePushInput"))

    @builtins.property
    @jsii.member(jsii_name="enableRoInput")
    def enable_ro_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadEnableInput")
    def preload_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceInput")
    def source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleBrotliInput")
    def title_brotli_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleBrotliInput"))

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPushInput")
    def title_http2_server_push_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleHttp2ServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreconnectInput")
    def title_preconnect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreloadInput")
    def title_preload_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreloadInput"))

    @builtins.property
    @jsii.member(jsii_name="titleRoInput")
    def title_ro_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleRoInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="abLogic")
    def ab_logic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abLogic"))

    @ab_logic.setter
    def ab_logic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678851da0611bd692c18cd27711eba4b3537b42ae3e3df2c39a0fd8d34cb542a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abLogic", value)

    @builtins.property
    @jsii.member(jsii_name="abTesting")
    def ab_testing(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abTesting"))

    @ab_testing.setter
    def ab_testing(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7632b5e8cc08325e7adce6cb8d6e3209aa15df46f2c9241ffe511bde6bda651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abTesting", value)

    @builtins.property
    @jsii.member(jsii_name="compression")
    def compression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "compression"))

    @compression.setter
    def compression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d389882eab035bd37814ba71c5b4acc05404125a0625425c327ca16d7b1792b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compression", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f276c5b31b8876c2e031184fa1a4769371af6d22bf78396eada9ea3dbd9ec38b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompression")
    def enable_brotli_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBrotliCompression"))

    @enable_brotli_compression.setter
    def enable_brotli_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89fc1aee09345a9c7a0d06730e060ecf729e50eec15db1657cd47e2e11d22707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBrotliCompression", value)

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheable")
    def enable_for_noncacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableForNoncacheable"))

    @enable_for_noncacheable.setter
    def enable_for_noncacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b3f2387ec5737f5d7ebcacefa3902667d0e0773b047662a0c5ee9fda4e2178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableForNoncacheable", value)

    @builtins.property
    @jsii.member(jsii_name="enablePreconnect")
    def enable_preconnect(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePreconnect"))

    @enable_preconnect.setter
    def enable_preconnect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f11ca7a9745a0061631ad88100e043043e53c0a8a736940a08ee4640dd0480a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="enablePush")
    def enable_push(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePush"))

    @enable_push.setter
    def enable_push(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9132557d9dea897a4c109b9ec3b900f31edc62bd6a981332d4061b8b2f1d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePush", value)

    @builtins.property
    @jsii.member(jsii_name="enableRo")
    def enable_ro(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRo"))

    @enable_ro.setter
    def enable_ro(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c0eedd531b3ab403e090f509fb99e2b7ec8a8f71ca57c82a3ab3b1d29bc6ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRo", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e880c8afc95b110e44dcb983bcb042366d73439a6443f4773304730331eddc19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preloadEnable")
    def preload_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preloadEnable"))

    @preload_enable.setter
    def preload_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180398f36b0c1e8a7b0b7e6f1888913510829f4de45801b166fc6dc6f4157f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preloadEnable", value)

    @builtins.property
    @jsii.member(jsii_name="source")
    def source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "source"))

    @source.setter
    def source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1b79039eb3ef399c1888728ae5c696bb6058aa968713ad993dcfcc7a490806e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "source", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__245edf8adcb256f1ffd807f009298a2b8cc8baefb4165c027dc3a930532ec9f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleBrotli")
    def title_brotli(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleBrotli"))

    @title_brotli.setter
    def title_brotli(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b62faf910e2f9d6a8af7b135b750603d8d45bb6ac5ac13777e1fed812ac32d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleBrotli", value)

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPush")
    def title_http2_server_push(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleHttp2ServerPush"))

    @title_http2_server_push.setter
    def title_http2_server_push(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcd0d53c5c6d02955284421d5775e61326c4a440081e10ea736a2158bd76114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleHttp2ServerPush", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreconnect")
    def title_preconnect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreconnect"))

    @title_preconnect.setter
    def title_preconnect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b70c3455d011da4fd52c297a404f480b2b077b36a3e97c8c229b16d1850243)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreload")
    def title_preload(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreload"))

    @title_preload.setter
    def title_preload(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ec06585677d9cf589925a97b8083dba26753fb0d6e07703d6ca6cbd871d37bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreload", value)

    @builtins.property
    @jsii.member(jsii_name="titleRo")
    def title_ro(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleRo"))

    @title_ro.setter
    def title_ro(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce178c1b48697cfce38f7628f948353d23662072d3f40ab97f9c561b021d8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleRo", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59f803b8f64de8e64aaea6b5eb9e6d37ddda4a3f002dbde67fa7d2c3c107ce4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086d712fb0ae90845f625ade6267b7eaf07f9e9e8c130986ea8cb4ac4faaa77e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression",
    jsii_struct_bases=[],
    name_mapping={
        "compress_mobile": "compressMobile",
        "compress_standard": "compressStandard",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier1_mobile_compression_method": "tier1MobileCompressionMethod",
        "tier1_mobile_compression_value": "tier1MobileCompressionValue",
        "tier1_standard_compression_method": "tier1StandardCompressionMethod",
        "tier1_standard_compression_value": "tier1StandardCompressionValue",
        "tier2_mobile_compression_method": "tier2MobileCompressionMethod",
        "tier2_mobile_compression_value": "tier2MobileCompressionValue",
        "tier2_standard_compression_method": "tier2StandardCompressionMethod",
        "tier2_standard_compression_value": "tier2StandardCompressionValue",
        "tier3_mobile_compression_method": "tier3MobileCompressionMethod",
        "tier3_mobile_compression_value": "tier3MobileCompressionValue",
        "tier3_standard_compression_method": "tier3StandardCompressionMethod",
        "tier3_standard_compression_value": "tier3StandardCompressionValue",
        "title_aic_mobile": "titleAicMobile",
        "title_aic_nonmobile": "titleAicNonmobile",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression:
    def __init__(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4e6ae94c584bb5182612c6cfdabedabc6ec29ef7332b9299c0d60a15f781dc)
            check_type(argname="argument compress_mobile", value=compress_mobile, expected_type=type_hints["compress_mobile"])
            check_type(argname="argument compress_standard", value=compress_standard, expected_type=type_hints["compress_standard"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_mobile_compression_method", value=tier1_mobile_compression_method, expected_type=type_hints["tier1_mobile_compression_method"])
            check_type(argname="argument tier1_mobile_compression_value", value=tier1_mobile_compression_value, expected_type=type_hints["tier1_mobile_compression_value"])
            check_type(argname="argument tier1_standard_compression_method", value=tier1_standard_compression_method, expected_type=type_hints["tier1_standard_compression_method"])
            check_type(argname="argument tier1_standard_compression_value", value=tier1_standard_compression_value, expected_type=type_hints["tier1_standard_compression_value"])
            check_type(argname="argument tier2_mobile_compression_method", value=tier2_mobile_compression_method, expected_type=type_hints["tier2_mobile_compression_method"])
            check_type(argname="argument tier2_mobile_compression_value", value=tier2_mobile_compression_value, expected_type=type_hints["tier2_mobile_compression_value"])
            check_type(argname="argument tier2_standard_compression_method", value=tier2_standard_compression_method, expected_type=type_hints["tier2_standard_compression_method"])
            check_type(argname="argument tier2_standard_compression_value", value=tier2_standard_compression_value, expected_type=type_hints["tier2_standard_compression_value"])
            check_type(argname="argument tier3_mobile_compression_method", value=tier3_mobile_compression_method, expected_type=type_hints["tier3_mobile_compression_method"])
            check_type(argname="argument tier3_mobile_compression_value", value=tier3_mobile_compression_value, expected_type=type_hints["tier3_mobile_compression_value"])
            check_type(argname="argument tier3_standard_compression_method", value=tier3_standard_compression_method, expected_type=type_hints["tier3_standard_compression_method"])
            check_type(argname="argument tier3_standard_compression_value", value=tier3_standard_compression_value, expected_type=type_hints["tier3_standard_compression_value"])
            check_type(argname="argument title_aic_mobile", value=title_aic_mobile, expected_type=type_hints["title_aic_mobile"])
            check_type(argname="argument title_aic_nonmobile", value=title_aic_nonmobile, expected_type=type_hints["title_aic_nonmobile"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compress_mobile is not None:
            self._values["compress_mobile"] = compress_mobile
        if compress_standard is not None:
            self._values["compress_standard"] = compress_standard
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_mobile_compression_method is not None:
            self._values["tier1_mobile_compression_method"] = tier1_mobile_compression_method
        if tier1_mobile_compression_value is not None:
            self._values["tier1_mobile_compression_value"] = tier1_mobile_compression_value
        if tier1_standard_compression_method is not None:
            self._values["tier1_standard_compression_method"] = tier1_standard_compression_method
        if tier1_standard_compression_value is not None:
            self._values["tier1_standard_compression_value"] = tier1_standard_compression_value
        if tier2_mobile_compression_method is not None:
            self._values["tier2_mobile_compression_method"] = tier2_mobile_compression_method
        if tier2_mobile_compression_value is not None:
            self._values["tier2_mobile_compression_value"] = tier2_mobile_compression_value
        if tier2_standard_compression_method is not None:
            self._values["tier2_standard_compression_method"] = tier2_standard_compression_method
        if tier2_standard_compression_value is not None:
            self._values["tier2_standard_compression_value"] = tier2_standard_compression_value
        if tier3_mobile_compression_method is not None:
            self._values["tier3_mobile_compression_method"] = tier3_mobile_compression_method
        if tier3_mobile_compression_value is not None:
            self._values["tier3_mobile_compression_value"] = tier3_mobile_compression_value
        if tier3_standard_compression_method is not None:
            self._values["tier3_standard_compression_method"] = tier3_standard_compression_method
        if tier3_standard_compression_value is not None:
            self._values["tier3_standard_compression_value"] = tier3_standard_compression_value
        if title_aic_mobile is not None:
            self._values["title_aic_mobile"] = title_aic_mobile
        if title_aic_nonmobile is not None:
            self._values["title_aic_nonmobile"] = title_aic_nonmobile
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compress_mobile(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over cellular mobile networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        '''
        result = self._values.get("compress_mobile")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def compress_standard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over non-cellular networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        '''
        result = self._values.get("compress_standard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        '''
        result = self._values.get("tier1_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        '''
        result = self._values.get("tier1_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier1_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        '''
        result = self._values.get("tier1_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        '''
        result = self._values.get("tier1_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        '''
        result = self._values.get("tier2_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        '''
        result = self._values.get("tier2_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        '''
        result = self._values.get("tier2_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        '''
        result = self._values.get("tier2_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        '''
        result = self._values.get("tier3_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        '''
        result = self._values.get("tier3_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        '''
        result = self._values.get("tier3_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        '''
        result = self._values.get("tier3_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def title_aic_mobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        '''
        result = self._values.get("title_aic_mobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_aic_nonmobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        '''
        result = self._values.get("title_aic_nonmobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b9d6a3af16dcc07104d6653d12a99f411f96dff81cf791aacbb7b5d514f07d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompressMobile")
    def reset_compress_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressMobile", []))

    @jsii.member(jsii_name="resetCompressStandard")
    def reset_compress_standard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressStandard", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionMethod")
    def reset_tier1_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionValue")
    def reset_tier1_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionMethod")
    def reset_tier1_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionValue")
    def reset_tier1_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionMethod")
    def reset_tier2_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionValue")
    def reset_tier2_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionMethod")
    def reset_tier2_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionValue")
    def reset_tier2_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionMethod")
    def reset_tier3_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionValue")
    def reset_tier3_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionMethod")
    def reset_tier3_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionValue")
    def reset_tier3_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTitleAicMobile")
    def reset_title_aic_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicMobile", []))

    @jsii.member(jsii_name="resetTitleAicNonmobile")
    def reset_title_aic_nonmobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicNonmobile", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compressMobileInput")
    def compress_mobile_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="compressStandardInput")
    def compress_standard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressStandardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethodInput")
    def tier1_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValueInput")
    def tier1_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethodInput")
    def tier1_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValueInput")
    def tier1_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethodInput")
    def tier2_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValueInput")
    def tier2_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethodInput")
    def tier2_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValueInput")
    def tier2_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethodInput")
    def tier3_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValueInput")
    def tier3_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethodInput")
    def tier3_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValueInput")
    def tier3_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicMobileInput")
    def title_aic_mobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobileInput")
    def title_aic_nonmobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicNonmobileInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compressMobile")
    def compress_mobile(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressMobile"))

    @compress_mobile.setter
    def compress_mobile(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed0a3d1f4fc187133359f0a75fef68f8b100991376b623a4025553259a7b0858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressMobile", value)

    @builtins.property
    @jsii.member(jsii_name="compressStandard")
    def compress_standard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressStandard"))

    @compress_standard.setter
    def compress_standard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecea5bc758843df4626faff3bda68c191c9dbf1a8cd0e68bfd5177cf459b8958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressStandard", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379578028c8882c82746a0d2767146c5c6538626909888673df633146c085ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb43116202f39e229121eee640ac4fde48bdf35bf9955bba2c75027127fce828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethod")
    def tier1_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1MobileCompressionMethod"))

    @tier1_mobile_compression_method.setter
    def tier1_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e828b7776f1a9a0128594350af11a1d79abf327ed4d691b4ce4857bebc2961cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValue")
    def tier1_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1MobileCompressionValue"))

    @tier1_mobile_compression_value.setter
    def tier1_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec0ea461b720195643fd8315d988e96fc20f7145acf2489b4e86959fb59eb93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethod")
    def tier1_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1StandardCompressionMethod"))

    @tier1_standard_compression_method.setter
    def tier1_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4fbe68c9b8786fced3d37274cc486febd873ff385275ec1370daadf74f935a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValue")
    def tier1_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1StandardCompressionValue"))

    @tier1_standard_compression_value.setter
    def tier1_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4dec3cd4f02d73571977ddb81541fc1ae1f43601cc418c4c0669e9ac5952ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethod")
    def tier2_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2MobileCompressionMethod"))

    @tier2_mobile_compression_method.setter
    def tier2_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16eef482367d533cd8d736398975182f2d2f8767b6628096d1d6312964352eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValue")
    def tier2_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2MobileCompressionValue"))

    @tier2_mobile_compression_value.setter
    def tier2_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3928576ab6d73cbd884c01feacc3bd0bfcc7c9516a4e34d6bce9067ee4a97de8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethod")
    def tier2_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2StandardCompressionMethod"))

    @tier2_standard_compression_method.setter
    def tier2_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e63b2b7ffbaa6a43836c62eca75d728fc3e47454271a95d5f284e4ed78db0a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValue")
    def tier2_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2StandardCompressionValue"))

    @tier2_standard_compression_value.setter
    def tier2_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d15ebe8c8e00c92047f4f65361c2f1cfaa5033084182ed26e0c8b09aa2e90910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethod")
    def tier3_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3MobileCompressionMethod"))

    @tier3_mobile_compression_method.setter
    def tier3_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed100ffe39941c38856dbd7b733c3d9db7a10198efe1ae542955de1f156dffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValue")
    def tier3_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3MobileCompressionValue"))

    @tier3_mobile_compression_value.setter
    def tier3_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ab45d8e60cafbad5a1715c35478f0e751e07aeeb774c60715d625141db564f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethod")
    def tier3_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3StandardCompressionMethod"))

    @tier3_standard_compression_method.setter
    def tier3_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1317f50f5d9a2229e89b0d91b20135431ca63f262eda1799e9067b1a926c80f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValue")
    def tier3_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3StandardCompressionValue"))

    @tier3_standard_compression_value.setter
    def tier3_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c679ff8af1e86420bed93eabd38db3043a72ceb94979b65fd380d98bb03ab6d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicMobile")
    def title_aic_mobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicMobile"))

    @title_aic_mobile.setter
    def title_aic_mobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f979c0de3498a895eb230b5917b791bc95d0143249d6832302004445a5dd92c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicMobile", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobile")
    def title_aic_nonmobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicNonmobile"))

    @title_aic_nonmobile.setter
    def title_aic_nonmobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3996a0b6568a64157ee6bb2acd9e76b0eb176dc3732e40a2094fc9b53d3368ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicNonmobile", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3555a7d4dd6bd1bb22d956e5cd87a060b5e531f06b549e32ab80b67105f37463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949dfba40d32acd63c32ea6d2fa0015a4611e8d52a7ce5bcc5aaec2e3893d978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e22d1a0d5cb926dbc37a696f05c2177e11ba6bb5772706b51c06824560d7d3c)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9e3882ec153328bade9fedf99c570f48d1926c1bb1734c010a2e2663e476f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f368b86ad1a662b1e3f26a731f2514b71fde0bc382ceb84465298aadb2026fcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c5e705695b4ac1d954d43f40d7e1366760ac71ac716912f7ee6b3f511e820c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e5a84cbcc0de84ea8b62e46222deb93b8d5b8caa7ce01ba54ded7370602a94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f31caebcb3ef3c178281f4bc9d22ae37ff7ff8bb67780f096eceb6acf12c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__402d25d636af826d3e19344bc9e5095c7e97295fd5862d3e176d22449beb5059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__392b9146061a2f2958592ad89fa75d4b0073c838fb6dbfd9ace3de03cee2bb26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting",
    jsii_struct_bases=[],
    name_mapping={
        "attribute1": "attribute1",
        "attribute2": "attribute2",
        "attribute3": "attribute3",
        "attribute4": "attribute4",
        "attributes_count": "attributesCount",
        "enabled": "enabled",
        "locked": "locked",
        "report_name": "reportName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting:
    def __init__(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d77a2975f707273b4c558214cf3b1b18e140dd10be18f780b08f7aa51f5485d)
            check_type(argname="argument attribute1", value=attribute1, expected_type=type_hints["attribute1"])
            check_type(argname="argument attribute2", value=attribute2, expected_type=type_hints["attribute2"])
            check_type(argname="argument attribute3", value=attribute3, expected_type=type_hints["attribute3"])
            check_type(argname="argument attribute4", value=attribute4, expected_type=type_hints["attribute4"])
            check_type(argname="argument attributes_count", value=attributes_count, expected_type=type_hints["attributes_count"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument report_name", value=report_name, expected_type=type_hints["report_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if attribute1 is not None:
            self._values["attribute1"] = attribute1
        if attribute2 is not None:
            self._values["attribute2"] = attribute2
        if attribute3 is not None:
            self._values["attribute3"] = attribute3
        if attribute4 is not None:
            self._values["attribute4"] = attribute4
        if attributes_count is not None:
            self._values["attributes_count"] = attributes_count
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if report_name is not None:
            self._values["report_name"] = report_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def attribute1(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        '''
        result = self._values.get("attribute1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute2(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        '''
        result = self._values.get("attribute2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute3(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        '''
        result = self._values.get("attribute3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute4(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        '''
        result = self._values.get("attribute4")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attributes_count(self) -> typing.Optional[jsii.Number]:
        '''The number of attributes to include in the report, ranging from 1 to 4.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        '''
        result = self._values.get("attributes_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables aggregated reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def report_name(self) -> typing.Optional[builtins.str]:
        '''The unique name of the aggregated report within the property.

        If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        '''
        result = self._values.get("report_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365877f4ec9dcc802156df9fb46d2e99e9fb20097259aaa028c76b69d42408ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAttribute1")
    def reset_attribute1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute1", []))

    @jsii.member(jsii_name="resetAttribute2")
    def reset_attribute2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute2", []))

    @jsii.member(jsii_name="resetAttribute3")
    def reset_attribute3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute3", []))

    @jsii.member(jsii_name="resetAttribute4")
    def reset_attribute4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute4", []))

    @jsii.member(jsii_name="resetAttributesCount")
    def reset_attributes_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttributesCount", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReportName")
    def reset_report_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReportName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="attribute1Input")
    def attribute1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute1Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute2Input")
    def attribute2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute2Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute3Input")
    def attribute3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute3Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute4Input")
    def attribute4_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute4Input"))

    @builtins.property
    @jsii.member(jsii_name="attributesCountInput")
    def attributes_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "attributesCountInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reportNameInput")
    def report_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reportNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="attribute1")
    def attribute1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute1"))

    @attribute1.setter
    def attribute1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecd3472963fa02947c862ffc5181002989e1d9bd81de89a14236dcf1b054f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute1", value)

    @builtins.property
    @jsii.member(jsii_name="attribute2")
    def attribute2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute2"))

    @attribute2.setter
    def attribute2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d85cad771c2a4d031f76fd72f87a04947b387134b012be10f9fffb0cd76557f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute2", value)

    @builtins.property
    @jsii.member(jsii_name="attribute3")
    def attribute3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute3"))

    @attribute3.setter
    def attribute3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8640f45cdb58be14965e97b5fdfa7b89e2ae62669b1bdf8e8bcccbbc2f1e86f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute3", value)

    @builtins.property
    @jsii.member(jsii_name="attribute4")
    def attribute4(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute4"))

    @attribute4.setter
    def attribute4(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa85400ae0d6496e637e1801d659cbcd52cdf36567657bc7e6b885bc79882fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute4", value)

    @builtins.property
    @jsii.member(jsii_name="attributesCount")
    def attributes_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "attributesCount"))

    @attributes_count.setter
    def attributes_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05e8c4c2944218c7d0406ffeb5195b9d68de46f74c027ec1dc013b360ea5ca99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attributesCount", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9ba399272411d7bd559436319695081fd10d0301331c6d62379d8cda5aa83ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453085787ec0935fa3c87fb5066efd78df63a8484aec79e1ed81ccc2b6a0fcc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reportName")
    def report_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reportName"))

    @report_name.setter
    def report_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d392ff1d0d15c03c7da72626211b688e184945f6a3d61de0f53b8bdaf00949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reportName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__920081269a5e139f24e0199833a9699a25d1f89a786316b2b3f9bf5d1ed62997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469ba3561a05305b10e778f074bead2d45a7a45a47880b3950bf8ffa253ea51e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42866da02ad26f3588492abcd20bb0906d177eb30137d887110b9993d8739384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c5ed5aa79d3ac6fcf5109f3c89f05db81ba6c84124aedbd16be8f7365d12a19)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamaizer behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b357e8d8bb93d09261d2d62f44b038300e26dc914ab79d80fc85b817875e90f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ec78cb5786940296483d60af26fb490ca9e4d0920fc14adaa6269bf640d647)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__354e80fc275a7c886f7b7d9ecc0135081359770f38bcba2a24c8313bd8685fa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da4b00fec7156136a731ad6ee5f5836f7513b795f5aeb3e0d99e322cbd71eeaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a95db3077bbf3eac392a68d8738f1b34993caa29f9c0ec9022940cd26770e50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b7d97b8cbda6bc5ba77a97b2d2e95fc48a438ea5ee9caf5734588a5d2e6bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag",
    jsii_struct_bases=[],
    name_mapping={
        "include_tags_attribute": "includeTagsAttribute",
        "locked": "locked",
        "match_hostname": "matchHostname",
        "replace_all": "replaceAll",
        "replacement_hostname": "replacementHostname",
        "scope": "scope",
        "tags_attribute": "tagsAttribute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag:
    def __init__(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faaca826576d6aaeabc322444a6704fd0a7f5fd7345706d99b50d2e679110d33)
            check_type(argname="argument include_tags_attribute", value=include_tags_attribute, expected_type=type_hints["include_tags_attribute"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_hostname", value=match_hostname, expected_type=type_hints["match_hostname"])
            check_type(argname="argument replace_all", value=replace_all, expected_type=type_hints["replace_all"])
            check_type(argname="argument replacement_hostname", value=replacement_hostname, expected_type=type_hints["replacement_hostname"])
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument tags_attribute", value=tags_attribute, expected_type=type_hints["tags_attribute"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if include_tags_attribute is not None:
            self._values["include_tags_attribute"] = include_tags_attribute
        if locked is not None:
            self._values["locked"] = locked
        if match_hostname is not None:
            self._values["match_hostname"] = match_hostname
        if replace_all is not None:
            self._values["replace_all"] = replace_all
        if replacement_hostname is not None:
            self._values["replacement_hostname"] = replacement_hostname
        if scope is not None:
            self._values["scope"] = scope
        if tags_attribute is not None:
            self._values["tags_attribute"] = tags_attribute
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def include_tags_attribute(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the ``tagsAttribute`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        '''
        result = self._values.get("include_tags_attribute")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to match on as a Perl-compatible regular expression.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        '''
        result = self._values.get("match_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replace_all(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches when enabled, otherwise replaces only the first match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        '''
        result = self._values.get("replace_all")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def replacement_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement hostname for the tag to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        '''
        result = self._values.get("replacement_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scope(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of HTML content the ``tagsAttribute`` refers to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        '''
        result = self._values.get("scope")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tags_attribute(self) -> typing.Optional[builtins.str]:
        '''Specifies the tag or tag/attribute combination to operate on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        '''
        result = self._values.get("tags_attribute")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__142fd9fc822979933e07fdb6e409d37765a68efd4c8e63fbe8741b722fcd06cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetIncludeTagsAttribute")
    def reset_include_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeTagsAttribute", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchHostname")
    def reset_match_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchHostname", []))

    @jsii.member(jsii_name="resetReplaceAll")
    def reset_replace_all(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplaceAll", []))

    @jsii.member(jsii_name="resetReplacementHostname")
    def reset_replacement_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacementHostname", []))

    @jsii.member(jsii_name="resetScope")
    def reset_scope(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScope", []))

    @jsii.member(jsii_name="resetTagsAttribute")
    def reset_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTagsAttribute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttributeInput")
    def include_tags_attribute_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeTagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchHostnameInput")
    def match_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="replaceAllInput")
    def replace_all_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "replaceAllInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementHostnameInput")
    def replacement_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="scopeInput")
    def scope_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scopeInput"))

    @builtins.property
    @jsii.member(jsii_name="tagsAttributeInput")
    def tags_attribute_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttribute")
    def include_tags_attribute(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeTagsAttribute"))

    @include_tags_attribute.setter
    def include_tags_attribute(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de74f12c710819786104ee33100efdcfa87cadef1ba46e45ee1c542de7ee39dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeTagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8b5e8d06e084957b2ed631b10776fa845a2c05dfccbb1933c85aa2319b1742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchHostname")
    def match_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchHostname"))

    @match_hostname.setter
    def match_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f272b986ceb0e15cdfeebbf7693be14bc43bf8969a2ec22f392ab9e7b548270e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchHostname", value)

    @builtins.property
    @jsii.member(jsii_name="replaceAll")
    def replace_all(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "replaceAll"))

    @replace_all.setter
    def replace_all(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db02b41c699c238a5445d719549d9ccd321260baf661f0e898b31b8dc897ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replaceAll", value)

    @builtins.property
    @jsii.member(jsii_name="replacementHostname")
    def replacement_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacementHostname"))

    @replacement_hostname.setter
    def replacement_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22cbe27ae39d8a25875f692b62c5f52ceef78f2b9b15c821308675541dcdeec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacementHostname", value)

    @builtins.property
    @jsii.member(jsii_name="scope")
    def scope(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scope"))

    @scope.setter
    def scope(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0153db9365bfb42c246843379cb08963db8604293883fe6bbe2d6d2423b0f93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scope", value)

    @builtins.property
    @jsii.member(jsii_name="tagsAttribute")
    def tags_attribute(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tagsAttribute"))

    @tags_attribute.setter
    def tags_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b518a10a61ec92bb1e75a7454204e5a1485c215bf167475979e26c2f0b8ca3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264b0c10014480de6890ef1598f2b50412bb53d0e0f10075b2eabe139fcec3df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbfc85cdc6727d5cdb3d5a8ca89c0e265cadeab541b66da10876ff447a4714f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b61d29e4baa74e426e82448e0ac59e76870e76270c54f9bdc2eba52711a1194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad28915fd26175e70f8a41da8fe819241962dac719353a22ff0139561ac3873)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables all HTTP requests for parent servers in the cache hierarchy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5adda1adc85db08e9b50491e04f486cbeb12c8926c6534738a50ca9921e64f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e3b4d7bdee87c22c5918134f39d3d949c6fcdf407e0e214814a089fc3ea9e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f382e469465b1b93c9ea652e4c686faf6f2796a1986e8293946a005f5dbde6fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c04b24c65056ab6a108caabae981591d875abbe1994ed8de1efa95826ea5eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5efeffb6c41d4716c4bbdf49b219512a87f9b70bd1ce04f263985e9f577654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb9454e7a3aa75c45c6b356ef6e07df5f0dd402fc6c30158fbe70d0f0df81228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "honor_base_directory": "honorBaseDirectory",
        "locked": "locked",
        "purge_origin_query_parameter": "purgeOriginQueryParameter",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb8a15f8147f63acac266022d898d73a0c2f53c044cb9692ef331f1e5ed7fc8)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument honor_base_directory", value=honor_base_directory, expected_type=type_hints["honor_base_directory"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_origin_query_parameter", value=purge_origin_query_parameter, expected_type=type_hints["purge_origin_query_parameter"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if honor_base_directory is not None:
            self._values["honor_base_directory"] = honor_base_directory
        if locked is not None:
            self._values["locked"] = locked
        if purge_origin_query_parameter is not None:
            self._values["purge_origin_query_parameter"] = purge_origin_query_parameter
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_base_directory(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior.

        If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        '''
        result = self._values.get("honor_base_directory")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_origin_query_parameter(self) -> typing.Optional[builtins.str]:
        '''When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge.

        Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        '''
        result = self._values.get("purge_origin_query_parameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOriginsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOriginsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b75d571b60e892dd45363cdc0de9dd3bad41dde06f1765a806f4d50cc2fcd27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHonorBaseDirectory")
    def reset_honor_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorBaseDirectory", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeOriginQueryParameter")
    def reset_purge_origin_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeOriginQueryParameter", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectoryInput")
    def honor_base_directory_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorBaseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameterInput")
    def purge_origin_query_parameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeOriginQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148d778aa9ad8d94b37b3299d9c91cbe9a0ad60c0d5d30f6157038aeed1b3521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectory")
    def honor_base_directory(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorBaseDirectory"))

    @honor_base_directory.setter
    def honor_base_directory(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5ed4372a541462de46f12934d4f758694aa895ae61c2df73c916e8e23ee5339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorBaseDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0be77974b3d08377bece5d591608228f48abed3cab2a66d5c4912a05463070a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameter")
    def purge_origin_query_parameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeOriginQueryParameter"))

    @purge_origin_query_parameter.setter
    def purge_origin_query_parameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e6363f16b47c756cdb7238db6777080b88ad4438eed52364333f5c2917a059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeOriginQueryParameter", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__006ae7e8a70a456cdcac0ecf24a65d4b2c10a9cb9130c2c365870bb1234a79fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ebfe5c621d1248d8f1bf5492a98b7be782bb8965770375e0b8cbd82d929412f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed140db835df72b19f1daeea59cde827900773bafeb21cf665d3360c6bc8783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete",
    jsii_struct_bases=[],
    name_mapping={
        "allow_body": "allowBody",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete:
    def __init__(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1599a260fa5ce5fc97d02911878a66ced4f2d0e03c6cb0e9a541bb5a94108bef)
            check_type(argname="argument allow_body", value=allow_body, expected_type=type_hints["allow_body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_body is not None:
            self._values["allow_body"] = allow_body
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_body(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows data in the body of the DELETE request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        '''
        result = self._values.get("allow_body")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows DELETE requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDeleteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDeleteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dfce9de1ba606de14f7365723ad8b1f8b9f833579336b0c729718a192aca868)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBody")
    def reset_allow_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBodyInput")
    def allow_body_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBody")
    def allow_body(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowBody"))

    @allow_body.setter
    def allow_body(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5222777c738714666bc8b8b973a720ff49178d406560de27c75ac55bf835a301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBody", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b654c0d0195b12f92f26919907e9ffefa2be0249e5a516b03de19132ecef18d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ecbb6ae44a181c63882318c0015c5e4aa011ed02579e9b5e5ada53da50e83e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2d57fa4a7a70edaf7f7fd2ddbbf22fd79db0cf94ae17d3844f1cfb08b2e280)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8da0dc0b61f0877956add721969d7a8cd89cdb671d6e33e1b5dc385fe16b3f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5b5ac04f4b6ba6f4f4438b6e1b4e7da17d3410c01c2409d80513839bd5247ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec12eed206ed4c0c2dc8edd3d4e14cc1c1e7dcdf275f85ebc223b3cc9fde6a3)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HTTPS cache key sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d3694c0fa7c3fea217be22af0eade2bceddbe1cd45dd6d85332af8f4c2918d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__601ccd378381a0a4e26ed54fce7fe5f00105fa28954a7b8f03a9be3ba14a1f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dcfa15a7ce9fb5c8a2c33231c286c8200b38905d55d2f78d051037d7136d50e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f3135964cc065342fc0d39e620e51dc6d409f07bef5264211e649cb1ff2723a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7bbad72be160f7ac387ed956ed45eca299ed1846d7f353139a7f626a3080ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ae64e3a81173a0e45a5ef2adbe45b269fc8e73cfe7737a1cc5fc5f0e002ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13cecb9532c7ef61fa237ddb4e5824939c83567a60136d5eb24814e38d951a64)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Downgrades to HTTP protocol for the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d083bc11d6b616496827c81dc3a68b091f847a365039080d7a36e0cad0d9ebbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2399f369998d20e547261116103545d8f0c69470eb502e71e6700bc985e883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd880847a562a65b1109cd66d4fd0e68067452ccfccb35dc3b92fd925b92d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7deb08551b425f969e4ac91ae0784206500682c156d4aac4af780af51d617937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63a48080022380ba76c086837e5315e4c7a8d43f489b6abede688178bd914c54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944727f6f1d878cb7306681b6bb80d79184f6ad299becdfc5f7e48248793ea68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4970b37b07b522cb2ab30570d6b0b9a568360f29a321660e669c719170d151b2)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response.

        Set this to ``false`` to deny OPTIONS requests and respond with a 501 error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7587427734f9e1900021f14965256c629ce427baf8d3a1719ecb7cba635871f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5692f679672237b60ee8ff52b9adeb54b81b37dfa54d4ccc6cdc2193c37cb1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10dd6812205369e1c290b0cc4a28ab88892bd03616cb3944eb97e4324891522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327a6ea4585d2134a8da5c3f9da3c3431c2c2fe7a5bb34a5033ffffed2eed463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbabbc47f20bf5813c7245667863df203dc6081fd794c3316243593b952632a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90656d0de56fe02d7a41d98dc6b1b28eb8953ef46f9b80f461c09a35ddd362b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc61a96d64073a719ed1eb7b732d8133b737b2a7f766e23f49c2edb3f7244a0c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PATCH requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1884e10329a9a84f0d9c0907d3539cfb9bd3db87e27944db63f70b4e25856f2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f650640974cf553787ffb346aa43c7df3af615cbdf142934d4372608b97225df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b00203f939507e545542e65a668e919d82acd7bd78f33ccedc58161d670270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d596d4ffc4fa52e87ec88a9d8a2f76559d45868392e58e95ad22a2719ba017ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352d941607be6eb5bb8ef623335036d87f7a1921befe1f9ecccb240b26c00ad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf039345faa6fb73d741d81a589d25edbc2a2bf5740bcc53dbb5079fe328c4c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost",
    jsii_struct_bases=[],
    name_mapping={
        "allow_without_content_length": "allowWithoutContentLength",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost:
    def __init__(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ccd8b696b2edd0cc6a2df8407c938505969189f9df83b3a3dba75e54ec02ed9)
            check_type(argname="argument allow_without_content_length", value=allow_without_content_length, expected_type=type_hints["allow_without_content_length"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_without_content_length is not None:
            self._values["allow_without_content_length"] = allow_without_content_length
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_without_content_length(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error.

        With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        '''
        result = self._values.get("allow_without_content_length")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebfc4eff54b217ea23c29cc4a6526f44320c8bbe9915d6d373a4df2a8154bcc0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowWithoutContentLength")
    def reset_allow_without_content_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowWithoutContentLength", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLengthInput")
    def allow_without_content_length_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowWithoutContentLengthInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLength")
    def allow_without_content_length(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowWithoutContentLength"))

    @allow_without_content_length.setter
    def allow_without_content_length(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f05ec9f29c9dd85d7469930541bda02be343299030cd057c65c588a83f0df0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowWithoutContentLength", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e920a7a95d45169b4157d5b076274b363ce3f838485c06384884dbd40b1ac294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f4b6e9b8dbfdb1a4b8d985c9ec8b2ddaaeb01700ebe65469f132135d7019da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b076930b0d216abf243b8e6a52146a74898e49d3643823dd8361df38887f5b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f48442987ef0accc8db0fa00ced6ff098f887ee92b2a7e66a96764c0ebdf0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599dac4122228098b573282461b53d7c91fccad1489e062be7584576e88bcfc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f112b96f4b47d0bb1ececed74937b6641eb13c2ea744109c0c275651aafd8ac)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PUT requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ffe13388779cff9362326f035a3beaa90234c03d1dd6a869bbc03f6716b5071)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381b6cec61448c31bbafb44a6808f0726d9d9fbb6eb70e92f6404b0e4552e2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25a6a82902ded8bc261cfbe38b3f55d566263c7da8e7916ff5034a761baccb08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__930e9af74386f40df47cc413921a394edac5b1f359ed757565148429f7ec90c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20adbb681776a846b6782bb8b93af6a1b6c69e52c5da518b0324a03ba1666109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ef8a3dee6441cbd523fee3d7cc26dafd6acb1db51448f4f2013196363b8945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d7c46c18a9dc591659475f02bb9e03d9d742f6caeffd9352a9aeacededcd563)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Chunked Transfer Encoding requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncodingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncodingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ca3b8aa842abfaeb923f6ffba60ea9bd1f6959df7bc87da773fd2c13560f07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34c61a7198a2975171b7559e50149b368642b284473f3bc2cbddb0852d14015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b09b7a627e8caeb2df79eafaf17b796bb6bca667d6ddb0ffe2a1dab87ecc000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0507ca86ea2d1a5ebb55406dbd35990ca78d2ccc630fe8558aa4904a5607d2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7b1fb3b8070cb10ef9fb2f37837914c7bed193515e34a12aff2a79eae81516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479b86b17429fd97e99b443764b950db42251b13edd447c55af04fd01ebaaf34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "max_age": "maxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d058d74b0268507e78664056692fded5164dec9122fbe5f0fc9e2d30ab3c96a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[jsii.Number]:
        '''Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header.

        The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4004096678f620bbbb8fc09b1f6c5ab9f270cf53b81414633b41b8631921bf0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d473dbecab2e28aff9702e47b43c18dd80cf9033d61b1f05f890a3903f0260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1119006a14f1e703a6b39885f7a71b3fe662d007dc1878d0f154789c1c628abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca0d2cfc2cd563fa08bac79ce4cc0f17d833cc9c52586d1bd1697e3d244aeed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f5a680e269a60ab1ad425f9dfb3a82f9b5ca7486fedd7733cf466335eb90dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dff79955709058f2b77c5d660391a011de0cc07e6e566937fe1a0e0e270a72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "alternate_response_cache_ttl": "alternateResponseCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "net_storage": "netStorage",
        "net_storage_path": "netStoragePath",
        "template_uuid": "templateUuid",
        "throttled_cp_code": "throttledCpCode",
        "throttled_status_code": "throttledStatusCode",
        "use_throttled_cp_code": "useThrottledCpCode",
        "use_throttled_status_code": "useThrottledStatusCode",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization:
    def __init__(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage(**net_storage)
        if isinstance(throttled_cp_code, dict):
            throttled_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode(**throttled_cp_code)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcfbb394d25ae6afae8f6c6bfe3f6762d992c72d6e4add3fa84ca5270937d2f8)
            check_type(argname="argument alternate_response_cache_ttl", value=alternate_response_cache_ttl, expected_type=type_hints["alternate_response_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throttled_cp_code", value=throttled_cp_code, expected_type=type_hints["throttled_cp_code"])
            check_type(argname="argument throttled_status_code", value=throttled_status_code, expected_type=type_hints["throttled_status_code"])
            check_type(argname="argument use_throttled_cp_code", value=use_throttled_cp_code, expected_type=type_hints["use_throttled_cp_code"])
            check_type(argname="argument use_throttled_status_code", value=use_throttled_status_code, expected_type=type_hints["use_throttled_status_code"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if alternate_response_cache_ttl is not None:
            self._values["alternate_response_cache_ttl"] = alternate_response_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throttled_cp_code is not None:
            self._values["throttled_cp_code"] = throttled_cp_code
        if throttled_status_code is not None:
            self._values["throttled_status_code"] = throttled_status_code
        if use_throttled_cp_code is not None:
            self._values["use_throttled_cp_code"] = use_throttled_cp_code
        if use_throttled_status_code is not None:
            self._values["use_throttled_status_code"] = use_throttled_status_code
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def alternate_response_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the alternate response's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        '''
        result = self._values.get("alternate_response_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the API Prioritization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this API Prioritization policy from any others in the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''Specify the full NetStorage path for the alternate response, including trailing file name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throttled_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode"]:
        '''throttled_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        '''
        result = self._values.get("throttled_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode"], result)

    @builtins.property
    def throttled_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code for requests that receive the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        '''
        result = self._values.get("throttled_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def use_throttled_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to apply an alternative CP code for requests served the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        '''
        result = self._values.get("use_throttled_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def use_throttled_status_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a specific HTTP response code to a throttled request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        '''
        result = self._values.get("use_throttled_status_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f33a8b44fcd3a1f5bfe4b98489f20e3a4bbe326311f09057e8d5ef525ff256)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d53fc894a9742d6529adfc95a0c16ba610491652fe21d1f2565568948737263)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5034ed7b14374c57bcb21a12916c41a7519f107f36411ddb627a44c284cf5ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59c0b16576b4fe50ffd11c93c1ac6f83d1a752124157ba4bbb0a6ac7e4228d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5febd19e096be4866e6934976af6915c0f2f0d7c9c799830684bb4d67ab22491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eea949886570db26e0ec4ffe815f892a57a121fef8bdc31adb70fb2d012704e0)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf31363d024d2b218ecb23ac2f46899610e7843701e64f2317ba8fc20c5a9c42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3692270feea3590b4c2b4a762cbdac02bf81600d0a256ac280a1cd5e04b4b7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f757d7094180bb6fe30017700bd904e3f4e990d3462fa51ff48530f31729a52c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__949054da79ec06875fcba173d55d3ea897c2325e560617b28e352e3a8a8171f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40293018387251c57cc27c6ee23869b6767fc12195cb14922ea7812e9164d001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__165463a55979b3d7ee8e24e359f6550096a098f4fd195716acbe8b54b24130e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="putThrottledCpCode")
    def put_throttled_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putThrottledCpCode", [value]))

    @jsii.member(jsii_name="resetAlternateResponseCacheTtl")
    def reset_alternate_response_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlternateResponseCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThrottledCpCode")
    def reset_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledCpCode", []))

    @jsii.member(jsii_name="resetThrottledStatusCode")
    def reset_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUseThrottledCpCode")
    def reset_use_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledCpCode", []))

    @jsii.member(jsii_name="resetUseThrottledStatusCode")
    def reset_use_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCode")
    def throttled_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeOutputReference", jsii.get(self, "throttledCpCode"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtlInput")
    def alternate_response_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "alternateResponseCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCodeInput")
    def throttled_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode"], jsii.get(self, "throttledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCodeInput")
    def throttled_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "throttledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCodeInput")
    def use_throttled_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCodeInput")
    def use_throttled_status_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtl")
    def alternate_response_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "alternateResponseCacheTtl"))

    @alternate_response_cache_ttl.setter
    def alternate_response_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84eb699ab49344dcd018b091cee4ae4c4021654bfe70a407931dbd7c9d12cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "alternateResponseCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__602c0a6244ad23e8564d259ae9ad4355a378876d1d5b9f3d89d0c93fe70cf744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ff2625bbe04181372ad14e637b24df07706a8eba2e0685e036dde76cc5e3a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e335f3c41378e9dc28e8846fe951543442e90ae7a33be4ae42220c96e226a205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4d017cf4624a0b14551a5254316e23fc044c4175d52a9d756c5ce99ac7f46f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09099bf5b9e7fbd3acc0212c6260f8bd91c5a4522d402f779f73f8c817fe8a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ffb638bffebee259738964237e3dd7deff13735dc9df30b99e37d9e84e0959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__534f8fd803ee0308fb74e71121c1e39b977148741a4befa33b9c540b9bb620a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCode")
    def throttled_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "throttledStatusCode"))

    @throttled_status_code.setter
    def throttled_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a9c3d73f867ac897b5199cfcacdd5343febe3c9e134f8432dfe280650b947a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throttledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCode")
    def use_throttled_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledCpCode"))

    @use_throttled_cp_code.setter
    def use_throttled_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67c61fe0d3e791daec2d7f244cd36bc1af04b554255db9a7e4081772f2f19385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCode")
    def use_throttled_status_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledStatusCode"))

    @use_throttled_status_code.setter
    def use_throttled_status_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2fbbd38e94a6ea2c55e3b08645f3ade21bbb428fcec481a06b394b1c331bcfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da306c831f92ae30fe34b151389fe17ff7c3001a8e1634e67afea82fd011f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05f373b794fa6750463e4ac6f20cc0659f637832a3b7a8110106049819d88783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95112e1fd850bdc587f38147f8f42b7a06a65f197693bdd2f76c03ec606d29bf)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101187b310084c6780d12c898590cb6f2d6f1e1621bc2b4b60f3355a510ff013)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2630b61a58797ad6fe8b790c04ef9ef482ac9e9cb848f7f491dfea97f017f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__295ad7d3550a7e0cc93079209214d194d297c7fb7ce008cb8e0c7f9a2bbfb09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d692345c88f7e54ac0f6fdb5f44e078e5ed562d8fc1a9bb6981757ac3eb80b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67a6b2cf120fe2269e5e030a5aef1993456abc64afcc4252e144d91e38663f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d137a971dbee792356fbca907b1bbd33e7af062368ca1a183166a6156480792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeecc6b9b061f8555c6e0f554cec693791f6fc410b8880cd95e83b5984a9acbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c579ab0423bfb12545236defe30ef5e6963c5b874acfac243e90687845496c52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2502dea3fc2d9ece46bc56a2f0ac5220de512f4bb2986f96378db8433d0cf65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce07f61161f9c4ac073a7572afd1ef7df1eed0968182cea15a1be6277c34286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a9fe80a7a4ddbd4d963102a0c7803ffd3b52af444c33272a9f301a1e0823bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d150c6ef3c02dda83516e633d123d11433907366791044f2b0c9afd8ccb2c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc123b95869a08d595f446af038cef128cfd9e1b58306ebdeae2b77d95d33709)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer",
    jsii_struct_bases=[],
    name_mapping={
        "all_down_net_storage": "allDownNetStorage",
        "all_down_net_storage_file": "allDownNetStorageFile",
        "all_down_status_code": "allDownStatusCode",
        "all_down_title": "allDownTitle",
        "allow_cache_prefresh": "allowCachePrefresh",
        "cached_content_title": "cachedContentTitle",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "failover_attempts_threshold": "failoverAttemptsThreshold",
        "failover_mode": "failoverMode",
        "failover_origin_map": "failoverOriginMap",
        "failover_status_codes": "failoverStatusCodes",
        "failover_title": "failoverTitle",
        "label": "label",
        "locked": "locked",
        "origin_cookie_name": "originCookieName",
        "specify_stickiness_cookie_domain": "specifyStickinessCookieDomain",
        "stickiness_cookie_automatic_salt": "stickinessCookieAutomaticSalt",
        "stickiness_cookie_domain": "stickinessCookieDomain",
        "stickiness_cookie_salt": "stickinessCookieSalt",
        "stickiness_cookie_set_http_only_flag": "stickinessCookieSetHttpOnlyFlag",
        "stickiness_cookie_type": "stickinessCookieType",
        "stickiness_duration": "stickinessDuration",
        "stickiness_expiration_date": "stickinessExpirationDate",
        "stickiness_refresh": "stickinessRefresh",
        "stickiness_title": "stickinessTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer:
    def __init__(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(all_down_net_storage, dict):
            all_down_net_storage = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage(**all_down_net_storage)
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48c703df5ae015e17771bbbac019326fdccb41d41697c7c18094045db31a9d5)
            check_type(argname="argument all_down_net_storage", value=all_down_net_storage, expected_type=type_hints["all_down_net_storage"])
            check_type(argname="argument all_down_net_storage_file", value=all_down_net_storage_file, expected_type=type_hints["all_down_net_storage_file"])
            check_type(argname="argument all_down_status_code", value=all_down_status_code, expected_type=type_hints["all_down_status_code"])
            check_type(argname="argument all_down_title", value=all_down_title, expected_type=type_hints["all_down_title"])
            check_type(argname="argument allow_cache_prefresh", value=allow_cache_prefresh, expected_type=type_hints["allow_cache_prefresh"])
            check_type(argname="argument cached_content_title", value=cached_content_title, expected_type=type_hints["cached_content_title"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_attempts_threshold", value=failover_attempts_threshold, expected_type=type_hints["failover_attempts_threshold"])
            check_type(argname="argument failover_mode", value=failover_mode, expected_type=type_hints["failover_mode"])
            check_type(argname="argument failover_origin_map", value=failover_origin_map, expected_type=type_hints["failover_origin_map"])
            check_type(argname="argument failover_status_codes", value=failover_status_codes, expected_type=type_hints["failover_status_codes"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_cookie_name", value=origin_cookie_name, expected_type=type_hints["origin_cookie_name"])
            check_type(argname="argument specify_stickiness_cookie_domain", value=specify_stickiness_cookie_domain, expected_type=type_hints["specify_stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_automatic_salt", value=stickiness_cookie_automatic_salt, expected_type=type_hints["stickiness_cookie_automatic_salt"])
            check_type(argname="argument stickiness_cookie_domain", value=stickiness_cookie_domain, expected_type=type_hints["stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_salt", value=stickiness_cookie_salt, expected_type=type_hints["stickiness_cookie_salt"])
            check_type(argname="argument stickiness_cookie_set_http_only_flag", value=stickiness_cookie_set_http_only_flag, expected_type=type_hints["stickiness_cookie_set_http_only_flag"])
            check_type(argname="argument stickiness_cookie_type", value=stickiness_cookie_type, expected_type=type_hints["stickiness_cookie_type"])
            check_type(argname="argument stickiness_duration", value=stickiness_duration, expected_type=type_hints["stickiness_duration"])
            check_type(argname="argument stickiness_expiration_date", value=stickiness_expiration_date, expected_type=type_hints["stickiness_expiration_date"])
            check_type(argname="argument stickiness_refresh", value=stickiness_refresh, expected_type=type_hints["stickiness_refresh"])
            check_type(argname="argument stickiness_title", value=stickiness_title, expected_type=type_hints["stickiness_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if all_down_net_storage is not None:
            self._values["all_down_net_storage"] = all_down_net_storage
        if all_down_net_storage_file is not None:
            self._values["all_down_net_storage_file"] = all_down_net_storage_file
        if all_down_status_code is not None:
            self._values["all_down_status_code"] = all_down_status_code
        if all_down_title is not None:
            self._values["all_down_title"] = all_down_title
        if allow_cache_prefresh is not None:
            self._values["allow_cache_prefresh"] = allow_cache_prefresh
        if cached_content_title is not None:
            self._values["cached_content_title"] = cached_content_title
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_attempts_threshold is not None:
            self._values["failover_attempts_threshold"] = failover_attempts_threshold
        if failover_mode is not None:
            self._values["failover_mode"] = failover_mode
        if failover_origin_map is not None:
            self._values["failover_origin_map"] = failover_origin_map
        if failover_status_codes is not None:
            self._values["failover_status_codes"] = failover_status_codes
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if origin_cookie_name is not None:
            self._values["origin_cookie_name"] = origin_cookie_name
        if specify_stickiness_cookie_domain is not None:
            self._values["specify_stickiness_cookie_domain"] = specify_stickiness_cookie_domain
        if stickiness_cookie_automatic_salt is not None:
            self._values["stickiness_cookie_automatic_salt"] = stickiness_cookie_automatic_salt
        if stickiness_cookie_domain is not None:
            self._values["stickiness_cookie_domain"] = stickiness_cookie_domain
        if stickiness_cookie_salt is not None:
            self._values["stickiness_cookie_salt"] = stickiness_cookie_salt
        if stickiness_cookie_set_http_only_flag is not None:
            self._values["stickiness_cookie_set_http_only_flag"] = stickiness_cookie_set_http_only_flag
        if stickiness_cookie_type is not None:
            self._values["stickiness_cookie_type"] = stickiness_cookie_type
        if stickiness_duration is not None:
            self._values["stickiness_duration"] = stickiness_duration
        if stickiness_expiration_date is not None:
            self._values["stickiness_expiration_date"] = stickiness_expiration_date
        if stickiness_refresh is not None:
            self._values["stickiness_refresh"] = stickiness_refresh
        if stickiness_title is not None:
            self._values["stickiness_title"] = stickiness_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def all_down_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage"]:
        '''all_down_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        '''
        result = self._values.get("all_down_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage"], result)

    @builtins.property
    def all_down_net_storage_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        '''
        result = self._values.get("all_down_net_storage_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP response code when all load-balancing origins are unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        '''
        result = self._values.get("all_down_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        '''
        result = self._values.get("all_down_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_cache_prefresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows the cache to prefresh.  Only appropriate if all origins serve the same content for the same URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        '''
        result = self._values.get("allow_cache_prefresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cached_content_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        '''
        result = self._values.get("cached_content_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the Application Load Balancer Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_attempts_threshold(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of failed requests that would trigger the failover process.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        '''
        result = self._values.get("failover_attempts_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_mode(self) -> typing.Optional[builtins.str]:
        '''Determines what to do if an origin fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        '''
        result = self._values.get("failover_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_origin_map(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap"]]]:
        '''failover_origin_map block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        '''
        result = self._values.get("failover_origin_map")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap"]]], result)

    @builtins.property
    def failover_status_codes(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        '''
        result = self._values.get("failover_status_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Application Load Balancer policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name for your session cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        '''
        result = self._values.get("origin_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        '''
        result = self._values.get("specify_stickiness_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable this if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        '''
        result = self._values.get("stickiness_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the stickiness cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        '''
        result = self._values.get("stickiness_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        '''
        result = self._values.get("stickiness_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ensures the cookie is transmitted only over HTTP.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        '''
        result = self._values.get("stickiness_cookie_set_http_only_flag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Determines how a cookie persistently associates the client with a load-balanced origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        '''
        result = self._values.get("stickiness_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_duration(self) -> typing.Optional[builtins.str]:
        '''Sets how long it is before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        '''
        result = self._values.get("stickiness_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        '''
        result = self._values.get("stickiness_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extends the duration of the cookie with each new request.

        When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        '''
        result = self._values.get("stickiness_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        '''
        result = self._values.get("stickiness_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29562254d694bbfafee96c73fc87a9207a6f68fc36a659dd3542870571d45f9)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54af023972d79c8a4a29fae9123e7a9ab98b01b9f1945002795cbc5c1136f78e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__200d6e26b32219fb3ef6902b97b6d9974ce235a6fdda221cc6df20f3616740bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2430c519461b00f305ce28cac43679621a128645f0461ee9fbd34a13592519ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3b8ef8b323834304e5c0c2a6d78768f1f70f8851c1c4fcd5627dd58e7d9e87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde6f712cd447d47895495836857e947af6c4ec606348edef8dab7a79e3880a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b2e97663bfd7eae192d0927f6e6f4f4330d57de76873300e4a0eabec7ecff8)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b09a8abead8222960c7d4ef9c4c8949ec6a8a3411838e2660af4d9304e60c8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afdcbb6528cc3f91674ef2871813bf2f887f049b42b386670b1ee94fb70fe7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cec6c61b21eea7410e9c9b9671ce55dd3aaf30229906a1d65be79d0ba4aa5e61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a041985bf57ea82e0c35ec03379e4f9edf3b74c1d7d572e30aa61ec641d3124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap",
    jsii_struct_bases=[],
    name_mapping={"from_origin_id": "fromOriginId", "to_origin_ids": "toOriginIds"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap:
    def __init__(
        self,
        *,
        from_origin_id: typing.Optional[builtins.str] = None,
        to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param from_origin_id: Specifies the origin whose failure triggers the mapping rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        :param to_origin_ids: Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__852f4d96c075318cd745ba71666b6f20568c6fd2a32eeec022956caf41e1a5ee)
            check_type(argname="argument from_origin_id", value=from_origin_id, expected_type=type_hints["from_origin_id"])
            check_type(argname="argument to_origin_ids", value=to_origin_ids, expected_type=type_hints["to_origin_ids"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if from_origin_id is not None:
            self._values["from_origin_id"] = from_origin_id
        if to_origin_ids is not None:
            self._values["to_origin_ids"] = to_origin_ids

    @builtins.property
    def from_origin_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin whose failure triggers the mapping rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        '''
        result = self._values.get("from_origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_origin_ids(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        result = self._values.get("to_origin_ids")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdf81c51053cc983cda3d8cbe97747649e1e4ea545c9c22153c5589106e882e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c2317d08d4a64d1a629723bd8b106b57ad3e2ad0180527736cf54308b51fbd)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a665918348bb25db3b2a22e83b91d197b1ba5bf18fd636f7497d37a95be4ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045e5bfb0e42926cfc7223ed829b77c6c19f3a2f48e6713497ba9fadf18763b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bdb32e2d85218f0477cb4ebe5d960d134cec0fe59b849801d45c9555790cf67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b055d44cce37e36fcabe2d8a33e6068c9b9ceb48e0a5de459efe048ffc125cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdfc7a819766a3c96ef5b0c94bb521f07fec818d8788e5e42c1e28a51513e5d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFromOriginId")
    def reset_from_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFromOriginId", []))

    @jsii.member(jsii_name="resetToOriginIds")
    def reset_to_origin_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToOriginIds", []))

    @builtins.property
    @jsii.member(jsii_name="fromOriginIdInput")
    def from_origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fromOriginIdInput"))

    @builtins.property
    @jsii.member(jsii_name="toOriginIdsInput")
    def to_origin_ids_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "toOriginIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="fromOriginId")
    def from_origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fromOriginId"))

    @from_origin_id.setter
    def from_origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d5d89194a4c2151e87cba7fab2312aafbe1e0f36257006c96183a190d65b46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fromOriginId", value)

    @builtins.property
    @jsii.member(jsii_name="toOriginIds")
    def to_origin_ids(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "toOriginIds"))

    @to_origin_ids.setter
    def to_origin_ids(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ad3da094a378860208ecdae0d813f93b1dd4a934e14e14a6ac4c20c9bf4d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toOriginIds", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1d15557a6a923a6c0887d8943c9af609719d53c4d0ac616cbee4c9b7065969d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e534fec22471664a1bd72eeacab9b39579eb9c0f857b1ccbb7d21b8a1774c11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAllDownNetStorage")
    def put_all_down_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putAllDownNetStorage", [value]))

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putFailoverOriginMap")
    def put_failover_origin_map(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7607a78a43cc594ef7a2626a39a1d81dcebb8563ca7ea302db0b3f72e0838847)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverOriginMap", [value]))

    @jsii.member(jsii_name="resetAllDownNetStorage")
    def reset_all_down_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorage", []))

    @jsii.member(jsii_name="resetAllDownNetStorageFile")
    def reset_all_down_net_storage_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorageFile", []))

    @jsii.member(jsii_name="resetAllDownStatusCode")
    def reset_all_down_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownStatusCode", []))

    @jsii.member(jsii_name="resetAllDownTitle")
    def reset_all_down_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownTitle", []))

    @jsii.member(jsii_name="resetAllowCachePrefresh")
    def reset_allow_cache_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCachePrefresh", []))

    @jsii.member(jsii_name="resetCachedContentTitle")
    def reset_cached_content_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachedContentTitle", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverAttemptsThreshold")
    def reset_failover_attempts_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverAttemptsThreshold", []))

    @jsii.member(jsii_name="resetFailoverMode")
    def reset_failover_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMode", []))

    @jsii.member(jsii_name="resetFailoverOriginMap")
    def reset_failover_origin_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverOriginMap", []))

    @jsii.member(jsii_name="resetFailoverStatusCodes")
    def reset_failover_status_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverStatusCodes", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginCookieName")
    def reset_origin_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCookieName", []))

    @jsii.member(jsii_name="resetSpecifyStickinessCookieDomain")
    def reset_specify_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieAutomaticSalt")
    def reset_stickiness_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieDomain")
    def reset_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieSalt")
    def reset_stickiness_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieSetHttpOnlyFlag")
    def reset_stickiness_cookie_set_http_only_flag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSetHttpOnlyFlag", []))

    @jsii.member(jsii_name="resetStickinessCookieType")
    def reset_stickiness_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieType", []))

    @jsii.member(jsii_name="resetStickinessDuration")
    def reset_stickiness_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessDuration", []))

    @jsii.member(jsii_name="resetStickinessExpirationDate")
    def reset_stickiness_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessExpirationDate", []))

    @jsii.member(jsii_name="resetStickinessRefresh")
    def reset_stickiness_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessRefresh", []))

    @jsii.member(jsii_name="resetStickinessTitle")
    def reset_stickiness_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorage")
    def all_down_net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference, jsii.get(self, "allDownNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMap")
    def failover_origin_map(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapList, jsii.get(self, "failoverOriginMap"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFileInput")
    def all_down_net_storage_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownNetStorageFileInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageInput")
    def all_down_net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "allDownNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCodeInput")
    def all_down_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownTitleInput")
    def all_down_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefreshInput")
    def allow_cache_prefresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCachePrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitleInput")
    def cached_content_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cachedContentTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThresholdInput")
    def failover_attempts_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverAttemptsThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverModeInput")
    def failover_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverModeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMapInput")
    def failover_origin_map_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "failoverOriginMapInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodesInput")
    def failover_status_codes_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverStatusCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originCookieNameInput")
    def origin_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomainInput")
    def specify_stickiness_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyStickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSaltInput")
    def stickiness_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomainInput")
    def stickiness_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSaltInput")
    def stickiness_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlagInput")
    def stickiness_cookie_set_http_only_flag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieSetHttpOnlyFlagInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieTypeInput")
    def stickiness_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessDurationInput")
    def stickiness_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDateInput")
    def stickiness_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessRefreshInput")
    def stickiness_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessTitleInput")
    def stickiness_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFile")
    def all_down_net_storage_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownNetStorageFile"))

    @all_down_net_storage_file.setter
    def all_down_net_storage_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ace0297d603c788f9c58c089ace9e731d61a7c029c292d8897d534fc5ff06f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownNetStorageFile", value)

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCode")
    def all_down_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownStatusCode"))

    @all_down_status_code.setter
    def all_down_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed6ccf97d5fda85845f00ec93704e07bcf627d421fcea5722c4d4e292237d8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="allDownTitle")
    def all_down_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownTitle"))

    @all_down_title.setter
    def all_down_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fefa2ca86af7d11b1abcf359d97c0868a202d4f693fb165cd8d21046afa927be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefresh")
    def allow_cache_prefresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCachePrefresh"))

    @allow_cache_prefresh.setter
    def allow_cache_prefresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3bb5392d1e89b67150076e164a6ff7ade9b094016f08fd84221fb9a5a3db1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCachePrefresh", value)

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitle")
    def cached_content_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cachedContentTitle"))

    @cached_content_title.setter
    def cached_content_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9577145c64dc08f0fdf1e8227fb0e800bd52b005f8a15e44768e77b7e6b65e9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cachedContentTitle", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__062abf21c3030cb7234b883a5c2bfac6841805650cd0382f2b523ef4ab49ce5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThreshold")
    def failover_attempts_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverAttemptsThreshold"))

    @failover_attempts_threshold.setter
    def failover_attempts_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07fa099efa46458bb9ea8b2be21f47f0deb9f8fb089821f26d285683add3ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverAttemptsThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMode")
    def failover_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMode"))

    @failover_mode.setter
    def failover_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13700ef9197d94b150b3f7741d351360ae919bb03ba9d485bf102e2439d27c7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodes")
    def failover_status_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverStatusCodes"))

    @failover_status_codes.setter
    def failover_status_codes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3f0f1c8decc12df4e74413eae379ff03dc5a27ef017d27bd73b854ceab0ce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverStatusCodes", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5227caea12447184d752a6a9176b2cb83c6200567f4bb83a90cf0e0665514204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ed460b96104ab1f928f28a528413b488f37070ef222e92ee2e871042ca2ea69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c19ffe2969c993c3a3f8b553f8cab0d974b51f2d55a32e93f7a45c33f25bdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originCookieName")
    def origin_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCookieName"))

    @origin_cookie_name.setter
    def origin_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8585cabc4a7dec2d98cca8eb66f5dbc3d0f313d9a765a102ee3674064845611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomain")
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyStickinessCookieDomain"))

    @specify_stickiness_cookie_domain.setter
    def specify_stickiness_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c8528a86edb8edf8917ebfe776317c538826e2fa5547ff87ebe5689b7e41b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyStickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSalt")
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieAutomaticSalt"))

    @stickiness_cookie_automatic_salt.setter
    def stickiness_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10ade4d26a653f29b79ade908d9a6d5934b40b7ed3ac97baf4c5048d88de2906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomain")
    def stickiness_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieDomain"))

    @stickiness_cookie_domain.setter
    def stickiness_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31d76d07c8fa848f960c31ded62d9cef68461296a68fe1805a95f59ccbcee05a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSalt")
    def stickiness_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieSalt"))

    @stickiness_cookie_salt.setter
    def stickiness_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb645e07aa675acc17154e65f0eae6b267114cdab4a34d386938aff6b9f3a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlag")
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieSetHttpOnlyFlag"))

    @stickiness_cookie_set_http_only_flag.setter
    def stickiness_cookie_set_http_only_flag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10512ccd1c7f4f5d20e1cdc958cfa2760c6464906b127ad30a785080038db519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSetHttpOnlyFlag", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieType")
    def stickiness_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieType"))

    @stickiness_cookie_type.setter
    def stickiness_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c26eeeee7637cfab5d39cd4002f8ff4b563ac65be188c9ced30aafd36c0c83e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessDuration")
    def stickiness_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessDuration"))

    @stickiness_duration.setter
    def stickiness_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aedc096563f92a5e8c39cdc230118455e519d6793e7202bfdf3b31fb33239ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessDuration", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDate")
    def stickiness_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessExpirationDate"))

    @stickiness_expiration_date.setter
    def stickiness_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c175628b717620d1a1c8c013ae60631b5155479aa282edb18bd9e77780d8354f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessRefresh")
    def stickiness_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessRefresh"))

    @stickiness_refresh.setter
    def stickiness_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7946f86de54f69b34771b07cd76aa13709ce7f15bd78e3e0847b1553b0479af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessTitle")
    def stickiness_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessTitle"))

    @stickiness_title.setter
    def stickiness_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f152fd37ef2d46b0edf3c2dd0186e8167e8f29ec2fc01009e0f221edfd4b4ef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3c279ba10ab81a96950a3619aea64a2a8a2f16bf9ee97fa7c894b17a8340cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3bb03a1d0ed5f76f61a7e1edbddb52d35bc837e21f22ecc849253df1bdf384c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901ab0a5e7ff4344be20f09cc1078cf6ada2239cc593e927d36e04f5aa9095af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_automatic_salt": "populationCookieAutomaticSalt",
        "population_cookie_domain": "populationCookieDomain",
        "population_cookie_include_rule_name": "populationCookieIncludeRuleName",
        "population_cookie_salt": "populationCookieSalt",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "segment_tracking_cookie_name": "segmentTrackingCookieName",
        "segment_tracking_custom_header": "segmentTrackingCustomHeader",
        "segment_tracking_method": "segmentTrackingMethod",
        "segment_tracking_query_param": "segmentTrackingQueryParam",
        "segment_tracking_title": "segmentTrackingTitle",
        "specify_population_cookie_domain": "specifyPopulationCookieDomain",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c53a206da7a4343a2feea91cb6460aa78c0b2c8cfec14ebd662f566e6cd0fb)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_automatic_salt", value=population_cookie_automatic_salt, expected_type=type_hints["population_cookie_automatic_salt"])
            check_type(argname="argument population_cookie_domain", value=population_cookie_domain, expected_type=type_hints["population_cookie_domain"])
            check_type(argname="argument population_cookie_include_rule_name", value=population_cookie_include_rule_name, expected_type=type_hints["population_cookie_include_rule_name"])
            check_type(argname="argument population_cookie_salt", value=population_cookie_salt, expected_type=type_hints["population_cookie_salt"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument segment_tracking_cookie_name", value=segment_tracking_cookie_name, expected_type=type_hints["segment_tracking_cookie_name"])
            check_type(argname="argument segment_tracking_custom_header", value=segment_tracking_custom_header, expected_type=type_hints["segment_tracking_custom_header"])
            check_type(argname="argument segment_tracking_method", value=segment_tracking_method, expected_type=type_hints["segment_tracking_method"])
            check_type(argname="argument segment_tracking_query_param", value=segment_tracking_query_param, expected_type=type_hints["segment_tracking_query_param"])
            check_type(argname="argument segment_tracking_title", value=segment_tracking_title, expected_type=type_hints["segment_tracking_title"])
            check_type(argname="argument specify_population_cookie_domain", value=specify_population_cookie_domain, expected_type=type_hints["specify_population_cookie_domain"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_automatic_salt is not None:
            self._values["population_cookie_automatic_salt"] = population_cookie_automatic_salt
        if population_cookie_domain is not None:
            self._values["population_cookie_domain"] = population_cookie_domain
        if population_cookie_include_rule_name is not None:
            self._values["population_cookie_include_rule_name"] = population_cookie_include_rule_name
        if population_cookie_salt is not None:
            self._values["population_cookie_salt"] = population_cookie_salt
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if segment_tracking_cookie_name is not None:
            self._values["segment_tracking_cookie_name"] = segment_tracking_cookie_name
        if segment_tracking_custom_header is not None:
            self._values["segment_tracking_custom_header"] = segment_tracking_custom_header
        if segment_tracking_method is not None:
            self._values["segment_tracking_method"] = segment_tracking_method
        if segment_tracking_query_param is not None:
            self._values["segment_tracking_query_param"] = segment_tracking_query_param
        if segment_tracking_title is not None:
            self._values["segment_tracking_title"] = segment_tracking_title
        if specify_population_cookie_domain is not None:
            self._values["specify_population_cookie_domain"] = specify_population_cookie_domain
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Audience Segmentation cloudlet feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''Specifies a suffix to append to the cookie name.

        This helps distinguish this audience segmentation policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        '''
        result = self._values.get("population_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the population cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        '''
        result = self._values.get("population_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes in the session cookie the name of the rule in which this behavior appears.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        '''
        result = self._values.get("population_cookie_include_rule_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        '''
        result = self._values.get("population_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Specifies when the segmentation cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the lifetime of the segmentation cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If disabled, sets the expiration time only if the cookie is not yet present in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_cookie_name(self) -> typing.Optional[builtins.str]:
        '''This cookie name specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        '''
        result = self._values.get("segment_tracking_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_custom_header(self) -> typing.Optional[builtins.str]:
        '''This custom HTTP header specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        '''
        result = self._values.get("segment_tracking_custom_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the method to pass segment information to the origin.

        The Cloudlet passes the rule applied to a given request location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        '''
        result = self._values.get("segment_tracking_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_query_param(self) -> typing.Optional[builtins.str]:
        '''This query parameter specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        '''
        result = self._values.get("segment_tracking_query_param")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        '''
        result = self._values.get("segment_tracking_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_population_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to specify a cookie domain with the population cookie.

        It tells the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        '''
        result = self._values.get("specify_population_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c8a8a5e35f1530d0ca1bf82354d82b97efa5f2d3d79d551d4a45731a75fa9c)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f190c9cc6c0cd19391d0fa504140fd29ca7e0124864270914da1c68c9c86773)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96fbb71c388e44534baa4bf533c7cdc4cdc84da57a33025fab45111423a1f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c33be09f2e199c86fe09f359fe9298a531c4f8d4e17b23492312812709ab6a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e091bb8a57adce73e5cf7b705b4a8ca3385b979d109d8408a09a2a319718b483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f565b369623ae002ce729c0a5395704362c39b104c427f07a1872c9efac794a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieAutomaticSalt")
    def reset_population_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieDomain")
    def reset_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetPopulationCookieIncludeRuleName")
    def reset_population_cookie_include_rule_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieIncludeRuleName", []))

    @jsii.member(jsii_name="resetPopulationCookieSalt")
    def reset_population_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetSegmentTrackingCookieName")
    def reset_segment_tracking_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCookieName", []))

    @jsii.member(jsii_name="resetSegmentTrackingCustomHeader")
    def reset_segment_tracking_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCustomHeader", []))

    @jsii.member(jsii_name="resetSegmentTrackingMethod")
    def reset_segment_tracking_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingMethod", []))

    @jsii.member(jsii_name="resetSegmentTrackingQueryParam")
    def reset_segment_tracking_query_param(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingQueryParam", []))

    @jsii.member(jsii_name="resetSegmentTrackingTitle")
    def reset_segment_tracking_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingTitle", []))

    @jsii.member(jsii_name="resetSpecifyPopulationCookieDomain")
    def reset_specify_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSaltInput")
    def population_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomainInput")
    def population_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleNameInput")
    def population_cookie_include_rule_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieIncludeRuleNameInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieSaltInput")
    def population_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieNameInput")
    def segment_tracking_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeaderInput")
    def segment_tracking_custom_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCustomHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethodInput")
    def segment_tracking_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParamInput")
    def segment_tracking_query_param_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingQueryParamInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitleInput")
    def segment_tracking_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomainInput")
    def specify_population_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyPopulationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f3e14a070bcf8953df9e4c1d4eb5ab11d920ab8ec236930eeb6b55767fcf5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720a92c4b0714d7f4639b6252d018700c2cd909fd3c8af52472f1c6eb190488f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5f3e932e1728550f79bc338c78e72e02a41e2daffef3fd5a52d18321f3928f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27c1ba97ecdf98f3f62da8409619f097a4dfde6c01bf43121227a73554dd4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa95d3e7668236668cc73f5afd51ad66a4e4f159937307597bb8aff6879a4a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSalt")
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieAutomaticSalt"))

    @population_cookie_automatic_salt.setter
    def population_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e6760437179881a78fb3278f5fad302150b8c5e44d9d714246bfb2b1fc8fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomain")
    def population_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieDomain"))

    @population_cookie_domain.setter
    def population_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c055341bf9e474e6a1e325df0bd5d48a8806aeb38ea095fe5a3ad23838db0825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleName")
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieIncludeRuleName"))

    @population_cookie_include_rule_name.setter
    def population_cookie_include_rule_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3fb775f6798157f1df79fee48fb00f6d9bcfd1a6a17ef9540e21d4ac69cfea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieIncludeRuleName", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieSalt")
    def population_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieSalt"))

    @population_cookie_salt.setter
    def population_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1eb7dcc6a87e87e328ff376a0036bd926fc7fc293077cdd584b98d271f59925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10af09c807f217535d8fa18a2772f160573b76674ddae5d8f87faec67af9a327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce82a8f8d9003a8fad86c371ec065292d144ea9b718e62d9ee438a35e8619da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30f47a617bf6e06302f3f4f1e171f74fb3d49d0e97ddd4f5345693a791b532f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee44860310f8697713f15049bc7054cac9e3b39dc5cf55a0d32f6417aec36259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieName")
    def segment_tracking_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCookieName"))

    @segment_tracking_cookie_name.setter
    def segment_tracking_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b267b37ff7830aa48400d9be197f055680074285ad367c39588204fb106d84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeader")
    def segment_tracking_custom_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCustomHeader"))

    @segment_tracking_custom_header.setter
    def segment_tracking_custom_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3dfad2a281617b12b0a65c0342edafdce188a2e0f79a945800ee9b4ba028a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCustomHeader", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethod")
    def segment_tracking_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingMethod"))

    @segment_tracking_method.setter
    def segment_tracking_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d0fc942d6bd5bcbfcf9c4fe3a6f107325d0a2b23710184ab2149f4de4dbdf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingMethod", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParam")
    def segment_tracking_query_param(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingQueryParam"))

    @segment_tracking_query_param.setter
    def segment_tracking_query_param(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a7652c0d62d4b6fac95253af53f9a68c04eef4626afaf9ff84fae1ffad91cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingQueryParam", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitle")
    def segment_tracking_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingTitle"))

    @segment_tracking_title.setter
    def segment_tracking_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f82844e5793d2e091661c5ca7afb6afef9d9006837cfe4011aab511633e265e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingTitle", value)

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomain")
    def specify_population_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyPopulationCookieDomain"))

    @specify_population_cookie_domain.setter
    def specify_population_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127c1050355ccedea3f5c1d30d39f1635f4bb314d92e592a0d63ee1c9a82e771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyPopulationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f40dc58034058176a4c153b657630fe11217fb4a5d936af296d6159655b702e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5fd5481b22ee7d672cd78781b6b25eb0f03f27da8d1bf467be23b97f221db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8a8d2402d75d494984f53a0cb89e8f46031dbf06e4b7779e6ea270f5149c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation",
    jsii_struct_bases=[],
    name_mapping={
        "autodv": "autodv",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation:
    def __init__(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce1c4659887d8c6d81267132a990a73d5ea5dd79e09b1d718c66603fa8c188a)
            check_type(argname="argument autodv", value=autodv, expected_type=type_hints["autodv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if autodv is not None:
            self._values["autodv"] = autodv
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def autodv(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        '''
        result = self._values.get("autodv")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d13f9dbb1730e48460ed1d4e6df9ce50217966457bb0a746c33bc5a73b73a8f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAutodv")
    def reset_autodv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutodv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="autodvInput")
    def autodv_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "autodvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="autodv")
    def autodv(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "autodv"))

    @autodv.setter
    def autodv(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ecf26cffafbd75fe2494f0357555ac135ffd54982701a7f532065b99149997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "autodv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e76d2f1e6e6ed260c861c100415586b080d4fea8a4e1b904a0721d063e41710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf116ca6029444ae2abe20ed9cd9c9193131270f9f5b56d57661678a29a0660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694203c3499ec213a14565166423d4fb0e882f2e6922eb9f9c0df6e1e514da39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93093b5a244d389cc72b522c1d1695ec04a93a7c6f8328c5baef8147bb825a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8608d2a68ed560bc9783e6f8704a749ce3ace39acdbef8ac10387f21e3c1c4)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the base path of content on your origin server.

        The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectoryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectoryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76d5ed0cae9a1bd6dcbfdd0f1e6b4021d5ab8517dc8a7230d0fe34ef357e787)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2698a5a6d089811ffbd5c0a17a65d2f95e446d8d162cb10a0d435c9f745e912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__649c5e3defeb5b194e06d188b143ee496b5f3f5a5768e040ab7a356135dbde49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb1327296b1970eaaa695cca7bc1f0f29f0b85eaf836bab87593a0f73599eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7554ae4a3a98752049388fe7477db93b30562d9e9ec090abcea8aeba9ca257a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79573ea7330fe0d3303528b13038860ca4ec25473d8ddb9c760b94a2d280da38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing",
    jsii_struct_bases=[],
    name_mapping={
        "conditional_error_pattern": "conditionalErrorPattern",
        "conditional_http_status": "conditionalHttpStatus",
        "conditional_sampling_frequency": "conditionalSamplingFrequency",
        "cpcodes": "cpcodes",
        "enabled": "enabled",
        "forward_type": "forwardType",
        "locked": "locked",
        "request_type": "requestType",
        "sampling_frequency": "samplingFrequency",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing:
    def __init__(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48544527a3207d150df4fd83f3b57d1d13e6cca0213126814a04b9eec6e2914d)
            check_type(argname="argument conditional_error_pattern", value=conditional_error_pattern, expected_type=type_hints["conditional_error_pattern"])
            check_type(argname="argument conditional_http_status", value=conditional_http_status, expected_type=type_hints["conditional_http_status"])
            check_type(argname="argument conditional_sampling_frequency", value=conditional_sampling_frequency, expected_type=type_hints["conditional_sampling_frequency"])
            check_type(argname="argument cpcodes", value=cpcodes, expected_type=type_hints["cpcodes"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_type", value=forward_type, expected_type=type_hints["forward_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument sampling_frequency", value=sampling_frequency, expected_type=type_hints["sampling_frequency"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if conditional_error_pattern is not None:
            self._values["conditional_error_pattern"] = conditional_error_pattern
        if conditional_http_status is not None:
            self._values["conditional_http_status"] = conditional_http_status
        if conditional_sampling_frequency is not None:
            self._values["conditional_sampling_frequency"] = conditional_sampling_frequency
        if cpcodes is not None:
            self._values["cpcodes"] = cpcodes
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_type is not None:
            self._values["forward_type"] = forward_type
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if sampling_frequency is not None:
            self._values["sampling_frequency"] = sampling_frequency
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def conditional_error_pattern(self) -> typing.Optional[builtins.str]:
        '''A space-separated set of error patterns that trigger beacons to conditional feeds.

        Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        '''
        result = self._values.get("conditional_error_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def conditional_http_status(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response status codes or ranges that trigger the beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        '''
        result = self._values.get("conditional_http_status")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def conditional_sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a conditional sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        '''
        result = self._values.get("conditional_sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cpcodes(self) -> typing.Optional[builtins.str]:
        '''The space-separated list of CP codes that trigger the beacons.

        You need to specify the same set of CP codes within BOSS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        '''
        result = self._values.get("cpcodes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable diagnostic data beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        '''
        result = self._values.get("forward_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        '''
        result = self._values.get("sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f69df797769ef23031de19cdee98c53ef3a4db4024a258d1dfbf94585f7700cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConditionalErrorPattern")
    def reset_conditional_error_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalErrorPattern", []))

    @jsii.member(jsii_name="resetConditionalHttpStatus")
    def reset_conditional_http_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalHttpStatus", []))

    @jsii.member(jsii_name="resetConditionalSamplingFrequency")
    def reset_conditional_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalSamplingFrequency", []))

    @jsii.member(jsii_name="resetCpcodes")
    def reset_cpcodes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpcodes", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardType")
    def reset_forward_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetSamplingFrequency")
    def reset_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingFrequency", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPatternInput")
    def conditional_error_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalErrorPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatusInput")
    def conditional_http_status_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "conditionalHttpStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequencyInput")
    def conditional_sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalSamplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="cpcodesInput")
    def cpcodes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cpcodesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardTypeInput")
    def forward_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingFrequencyInput")
    def sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "samplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPattern")
    def conditional_error_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalErrorPattern"))

    @conditional_error_pattern.setter
    def conditional_error_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c41215936efa051b6c5ce091d918352dcf4647065ce0bf3275e189fb000c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalErrorPattern", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatus")
    def conditional_http_status(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "conditionalHttpStatus"))

    @conditional_http_status.setter
    def conditional_http_status(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c6e2e60c23ddc77fa6320327680ef066e25104129b7315f40be4aa44f34051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalHttpStatus", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequency")
    def conditional_sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalSamplingFrequency"))

    @conditional_sampling_frequency.setter
    def conditional_sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26aaf0abf30248943929476c63c79da38746a31d977569dfc920e9d7ad49697e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalSamplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="cpcodes")
    def cpcodes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cpcodes"))

    @cpcodes.setter
    def cpcodes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4905e733cb353eaa3e566b4d9f71742415f2638907b5b4718235a2074566723d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpcodes", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828d109c96d8d39a4e1692a4a2ea170ea91955be59ccf3cd8947288eb8a1bd6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardType")
    def forward_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardType"))

    @forward_type.setter
    def forward_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ebdc0edf85cce391550b322d39b1d38acd1e6386639286a5f694d226684c7ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4903655d49eaa4b1b02352b7c8a561705fa1a76d519f643533291524d9e9807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d704421b07eeec3feee8f182e8c481e3baa15c332d2d09c2747d4f34f29118da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="samplingFrequency")
    def sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "samplingFrequency"))

    @sampling_frequency.setter
    def sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11073dbd6542aff2abb2d4d436ce9c04d8ad3566d43890e479676b155f9bd9b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d00f51425ae8025cd2f33f490b45e01e08441429936a8e06854d40c4529f1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a54600c60adcadb97aaa102b5d036303b5c487628ed4987c3a94bfa8579d4dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d08fe09c39b8414aa2995b76d1318afbb08981e1432b59051899622edfa55a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "logging_enabled": "loggingEnabled",
        "opt_mode": "optMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b725cc5c2c6ba14005635f5428cf60a87532c56f00d0e5cb5ff27b168856d165)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument logging_enabled", value=logging_enabled, expected_type=type_hints["logging_enabled"])
            check_type(argname="argument opt_mode", value=opt_mode, expected_type=type_hints["opt_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if logging_enabled is not None:
            self._values["logging_enabled"] = logging_enabled
        if opt_mode is not None:
            self._values["opt_mode"] = opt_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Breadcrumbs feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def logging_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client.

        This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        '''
        result = self._values.get("logging_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def opt_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to include Breadcrumbs data in the response header.

        To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        '''
        result = self._values.get("opt_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5bc99f82d690e45114e2162c39fdb2798d8399898c7b5eb179a23b90bc4958)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLoggingEnabled")
    def reset_logging_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoggingEnabled", []))

    @jsii.member(jsii_name="resetOptMode")
    def reset_opt_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="loggingEnabledInput")
    def logging_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "loggingEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="optModeInput")
    def opt_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d385be5ccb6ee6e801fa1e45698500bedf2936133bc5ac1db3c49e2994dc0627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07ea9d6904c25b6e2ab33c8516964050fd9cde76dbd6e530dfdbd1a52c99e04f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="loggingEnabled")
    def logging_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "loggingEnabled"))

    @logging_enabled.setter
    def logging_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a2db0b9ebcb8594b0f1e1bdb8bb955163f4c01612b93fff14fd7d9afa52c5ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loggingEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="optMode")
    def opt_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optMode"))

    @opt_mode.setter
    def opt_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e03d2b009f2cfc097c5de633fccf34f280b9fe84b959d35b9ef6666e0caa719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b823f1eee2e8d1cd7246f5514e2f2034f4ada674df25197ae6d973a9fb07fbf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf025aabd87beb19ee716bb5882fe220db6db737d27d7bd35654fa551846488)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__437ba2a2ccd44917df55510b7b11ffe84e42f272da3ef0626858d22db6eaaf74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d45ddb2b194ea03451abfe99fd9bc5ccf0a5fdac01139e28d2079993a0e249d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the break connection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__380ca5cd01ee4e789504e6c07e464e10eb71ccb01625b983be8bebf060d8a067)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0af9688df055e0b5a74677855d4dbbc33b6e595a724df6387661f7b8fc0dc948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab9fa1e58b7ce58755656026bb3d2184cfca357c910703a18a639bc04a2c16d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c6c1e5597eebda552d64d5d42af708ec36e6d124c6cbc38341c565d81e43e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c30041f58d9f58b0cfa84c71da6410ba65821b90daa4c47a647742c9c063ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18d6fcc91c59d86885029d8f17be8c1ff3b09d4b61011399d70691623a3423dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97d9c975ad45783de917b6050a87f484fe8d57bf72094cac044c71ac72134d9)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Fetches Brotli-compressed assets from your origin and caches them on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotliOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotliOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e0d43525d30240e85296358cd0e265b2e93c9dc53f674d659ad03c871a6590)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9adb522ef411aa84ad746cfd2b890ef20d43b794e54c2bebb9ba809ab0b7fb2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8192f629e84d7239173c5104a8e613c141c95d23a28ad88c462bd7a2f3467def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc6cc9cfaf418ccb632870df9f06ba2f6e55f190c65c660f86ed607c59db4f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298f83b46e75994d07d7d88ba3c3c18774bdb16df4a6f03ce864603d1531feb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc82b1b7c551d9684c7ed82af5e70ad33c1d4b698aceb2b91fe52e379cf17236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "preserve_stale": "preserveStale",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12cefd3cc456bcf9559a94d91ac3d68a9ca9eab49049eef46760c30394acac0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preserve_stale", value=preserve_stale, expected_type=type_hints["preserve_stale"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if preserve_stale is not None:
            self._values["preserve_stale"] = preserve_stale
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the error-caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preserve_stale(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes.

        This avoids re-fetching and re-caching content after transient errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        '''
        result = self._values.get("preserve_stale")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Overrides the default caching duration of ``10s``.

        Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df0a49705d34bb7b5d605de513a6eceaf5f78dda969101025f9a1033292b9b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreserveStale")
    def reset_preserve_stale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveStale", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveStaleInput")
    def preserve_stale_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveStaleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1d5342762766026c91198f5e56fdbe13aac696d06c26f87fe04029cc9a1c424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ffd3cceae0183220d17787ecf26feba42665fa719fd9eeadd0300f63015fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preserveStale")
    def preserve_stale(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveStale"))

    @preserve_stale.setter
    def preserve_stale(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36a6628ae072e6c05655d384b3183d9aa55ca0f14eee80d51d076a5a6b606b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveStale", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e79d70f6eabcdbd61bff3e91f3aa0bf5fd3f4159c6a893bcf7e891d45c510f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__565ac5aa7639893149b68cf295a337350bbcf79123e9d9027e4defca9d617c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b73f0858a71b355fbe3491c2a1ae9bb47732df7189139e6a92da14455a9b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5e984605081d1578a95b7dbb11f05dc7f5e6d3fb8801d8fe6762f10c858123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "include_value": "includeValue",
        "locked": "locked",
        "optional": "optional",
        "rule": "rule",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8a66dbbcc5f90e67afb7fdd14105ef1fea417409506fa09b060f30caef9fc6)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument include_value", value=include_value, expected_type=type_hints["include_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optional", value=optional, expected_type=type_hints["optional"])
            check_type(argname="argument rule", value=rule, expected_type=type_hints["rule"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if include_value is not None:
            self._values["include_value"] = include_value
        if locked is not None:
            self._values["locked"] = locked
        if optional is not None:
            self._values["optional"] = optional
        if rule is not None:
            self._values["rule"] = rule
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def include_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes the value of the specified elements in the cache ID. Otherwise only their names are included.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        '''
        result = self._values.get("include_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optional(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Requires the behavior's specified elements to be present for content to cache.

        When disabled, requests that lack the specified elements are still cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        '''
        result = self._values.get("optional")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rule(self) -> typing.Optional[builtins.str]:
        '''Specifies how to modify the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        '''
        result = self._values.get("rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the variable you want to include in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89dcada1f40f319c6eaf74660504679031acb8005f61c3ea0641e51c50c54fe2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetIncludeValue")
    def reset_include_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptional")
    def reset_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptional", []))

    @jsii.member(jsii_name="resetRule")
    def reset_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRule", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="includeValueInput")
    def include_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optionalInput")
    def optional_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optionalInput"))

    @builtins.property
    @jsii.member(jsii_name="ruleInput")
    def rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ruleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8168ed6d7e215cd220cacf83ca2405954d25e633aa0c1403e6ba456b7998b2e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="includeValue")
    def include_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeValue"))

    @include_value.setter
    def include_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae97ee755107b2a0fae6a560f9bbad70cf3b646edbeb1f33e60501c377c76911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__863fcd7a814c0d0029e7c6d2656fd507b3f25ae6c7c06a7309a4c053e8ae8bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optional")
    def optional(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optional"))

    @optional.setter
    def optional(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fda680b079e39da08777c9ed7a161e1c9f8de39ec8418bc7f8c82471da5151c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optional", value)

    @builtins.property
    @jsii.member(jsii_name="rule")
    def rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rule"))

    @rule.setter
    def rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf9349bebba86c59f665d1406442a2dac8ba788676528f81898cec051d56bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rule", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b254095866b4f99a1215cbc8ed4c9856424ce37d8a5ddcdeead23c7681cf2c93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e652ccffd77820ab9b1e4f99f25b9d712ee073616ea096f6ed9a6c9fe1d6e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b893bceaca8a0024d953231485c602be2da2fd66ee2c4a4baebb85f478893d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1973099ab26b6f8bc44b69d46dc77e72df339bb0f9620369a75b64c0e1d745ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af4bb578f6a3d596dd9090be55e29fd11dc26af15321d15953bbeccb852cf53)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ignores case when forming cache keys.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a80a4f32cfef92b6768c33020bbddcb47abd690fa01ef0be00ef6c71f4a8f3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29aefb3470d5d44cbab1a179a7c9fa873f3e50eb704dea562059d317a7fe9a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e011fdf229c0798e6e1839ccf69f17f65778eb0367394b72d73a5c65a363c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ebbd22fd7ac933505217aa9858cbda65f72ce2ad3ec49de078d592b3582501f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42cb02f195731030a220450139ddce27eb86b27492ff34eb7bda98a5d0e5f720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a582b38b074723e7ce5bc537f5aab1f217ea37b06491fd1c1b3dd50e802d1ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "exact_match": "exactMatch",
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94d02255b0e08839d998d36a2b3f4a59c52809f6d3ff056c03a896fc62c9acf)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument exact_match", value=exact_match, expected_type=type_hints["exact_match"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if exact_match is not None:
            self._values["exact_match"] = exact_match
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Configures how sets of query string parameters translate to cache keys.

        Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exact_match(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        '''
        result = self._values.get("exact_match")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of parameter field names to include in or exclude from the cache key.

        By default, these match the field names as string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParamsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParamsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a40571205331b40e46ea165f83c72c66b01ee05bd269db70aa7b944553fcbb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetExactMatch")
    def reset_exact_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExactMatch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="exactMatchInput")
    def exact_match_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "exactMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceb30401a3cc78036a3f8653e72c6b2a6a4ef2d248ba9a75e81c17a40d45ab51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="exactMatch")
    def exact_match(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "exactMatch"))

    @exact_match.setter
    def exact_match(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f361b47f53dab4bd113c10ac45b6ccc4f62b17e1eae5ac4efb54272e59d13e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exactMatch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8357bbddf0c4db7cf9a5577f2c4f43b826672ec098257fa876c17aa8455a3e65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1c9f5c3e67a6f3e9d87f64c7c7948211aa1cd21393da79aab24d104ad540bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf6dc689d6815991566b444cf88518af6d136f8a07aa3a90286214bf50a9ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b5b06e8ad7e0742a05f865191a9c592874504843e2618171954070213353ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c880343c6d667b5d5cc4efe46b2632d334c84ccf61cd359b51e7747b1cf4a53a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "purge_key": "purgeKey",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09d3480ac27aee2d0694b6a090d1ce249ca198ec9948e5200abf7f8edc1c773)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_key", value=purge_key, expected_type=type_hints["purge_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if purge_key is not None:
            self._values["purge_key"] = purge_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the new cache key path as an alphanumeric value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        '''
        result = self._values.get("purge_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1964765a21475fb4520a3b600163ec35ecdaa2fc5ad42ba29c1da465bc2ef2f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeKey")
    def reset_purge_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeKeyInput")
    def purge_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e3b997b04a4d159a5cbef4971bced67358066ff1d42f487ada98590079c2a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeKey")
    def purge_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeKey"))

    @purge_key.setter
    def purge_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f37b3257564da234f3c605bb0b9614393e16ed72ef60359af02a4cbe0e3478e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a425c4113e638374516aef7dbd9e651b553175d386cbf792bac713f10bdd3845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686accef2d44120300ab49fe78fa554cee6b51c6d562512834206ab471d6ede8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d3a9fb100c4083a57a3eef4ae887fe8fca7362af89f060e318c41b7ef227cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_body": "useBody",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c885bcd6f3068a15fffbce19ac0f8f1db5cd394daa0b9eb475ad15609c35def6)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_body", value=use_body, expected_type=type_hints["use_body"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_body is not None:
            self._values["use_body"] = use_body
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables caching of POST responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_body(self) -> typing.Optional[builtins.str]:
        '''Define how and whether to use the POST message body as a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        '''
        result = self._values.get("use_body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__567765c02085922fe2514c0c8530835a3afe8f5766ce116533d3f29055b96f76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseBody")
    def reset_use_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseBody", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useBodyInput")
    def use_body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "useBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e4bc3c54f92e6bf7c888877a61d77b81fc9a0c350afaf217e584ea1c142777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657188a9c0b0d2fa5dbbd88b540377c2dd7a53e54f16123ba6d2860149917247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ceffb9cdb5171dc3935c75fd75318879d5c5bf570c57e338854b185025a415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useBody")
    def use_body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "useBody"))

    @use_body.setter
    def use_body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b533bfa2416898947006eb53b78bf0f1e609b8269b307fe679cbe2022e45023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useBody", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f622be17f3ed4c6085ab3c2385f622d885a7c9f1591bcd934ebe37584d5a9b51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23265be08fa754a93c2f4d91db21934003128fc1f7c0a3f18f876c762a58d5eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0510f5899eed1a1eca886b6efbe2f011085901569240498790cf305288f48b07)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the redirect caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65ad5840a8def7fe549e73e4939cc685557e421b5d5476afaee48ccf5f83725)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293e3158a8b00f2c60fb59a128ee56232bf0c1bd271356c4780046030d1c2af0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326bfff60939bdc8a4216c410a81a61721574db2b6de2dfc7daa894b558a0880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acdfb4d3800072c35c8436aaf737af710b5fc6a512ca93b31bf370a432a0ca92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb49cb7fa81ff69e21f6c26be95d4202aa9a754d3f2084e13c3aebb3384a9cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d48365439652d356b64a75dc7058d0448de8a4b6d99060e69ef10ea687017d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "tag": "tag",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f8f4780123df2fe701dbbe24caf97b437d9498c613b2055f08799e3c26f45e9)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument tag", value=tag, expected_type=type_hints["tag"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if tag is not None:
            self._values["tag"] = tag
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tag(self) -> typing.Optional[builtins.str]:
        '''Specifies the cache tag you want to add to your cached content.

        A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_``|~-]`

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        '''
        result = self._values.get("tag")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ad5cbbe2e3d5aef501fe086dd45bf5a6bef5769e9471bee6b6113caba8846f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTag")
    def reset_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTag", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="tagInput")
    def tag_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5ab97091a51ae81339f39d892e23b28d206b61a8f9e745523bf1b975266ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="tag")
    def tag(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tag"))

    @tag.setter
    def tag(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa924639a4d56cac6168301ce409bb33aa390118a3847b8e818d34148fd43cfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tag", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cbe40d1d751c6a7d95e60201187d9394de2b437dc97ea0ec386a46a3603e914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e177148757f955dfa4e72cef46dcdfd66e86e3466a13d156912122ce3a09b07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b65c0650e30d46a76a7570ebabe734c25f319a16afc8427f0bb5e27a35a8385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c6d4d3d9c4f6eeacf8fcb443193a63d7072cbcd6bf4175d783704189af442e)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specifies when to include the ``Edge-Cache-Tag`` in responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisibleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisibleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e4e13ec025aaf07ddd9243bd68a6338645f232baf85ac1ff9128108761946c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c519aca86eaf9575fa8ae5ba34e9717f8f1f6748b3eb851734decc3875879ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1142e484be8fccb0b267217240a1692588ad50ae49d1b50e5590051989bd97f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae4a8416d436fb08b98bceb05e7c45cf4d18113330285fa6654a2a6336460cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1c75b3d5c578082bdaec31246943f5f4cad322f16ebcca13b0e370d70ab802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caeba75759b8bc851de9206b07e813198abd892329b6418f046560923846f70f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "cacheability_settings": "cacheabilitySettings",
        "cache_control_directives": "cacheControlDirectives",
        "default_ttl": "defaultTtl",
        "enhanced_rfc_support": "enhancedRfcSupport",
        "expiration_settings": "expirationSettings",
        "honor_max_age": "honorMaxAge",
        "honor_must_revalidate": "honorMustRevalidate",
        "honor_no_cache": "honorNoCache",
        "honor_no_store": "honorNoStore",
        "honor_private": "honorPrivate",
        "honor_proxy_revalidate": "honorProxyRevalidate",
        "honor_s_maxage": "honorSMaxage",
        "locked": "locked",
        "must_revalidate": "mustRevalidate",
        "revalidation_settings": "revalidationSettings",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c98f45e7ea6004d7f7660aa730757169abac783b8715045588ea9ecef4dca2)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument cacheability_settings", value=cacheability_settings, expected_type=type_hints["cacheability_settings"])
            check_type(argname="argument cache_control_directives", value=cache_control_directives, expected_type=type_hints["cache_control_directives"])
            check_type(argname="argument default_ttl", value=default_ttl, expected_type=type_hints["default_ttl"])
            check_type(argname="argument enhanced_rfc_support", value=enhanced_rfc_support, expected_type=type_hints["enhanced_rfc_support"])
            check_type(argname="argument expiration_settings", value=expiration_settings, expected_type=type_hints["expiration_settings"])
            check_type(argname="argument honor_max_age", value=honor_max_age, expected_type=type_hints["honor_max_age"])
            check_type(argname="argument honor_must_revalidate", value=honor_must_revalidate, expected_type=type_hints["honor_must_revalidate"])
            check_type(argname="argument honor_no_cache", value=honor_no_cache, expected_type=type_hints["honor_no_cache"])
            check_type(argname="argument honor_no_store", value=honor_no_store, expected_type=type_hints["honor_no_store"])
            check_type(argname="argument honor_private", value=honor_private, expected_type=type_hints["honor_private"])
            check_type(argname="argument honor_proxy_revalidate", value=honor_proxy_revalidate, expected_type=type_hints["honor_proxy_revalidate"])
            check_type(argname="argument honor_s_maxage", value=honor_s_maxage, expected_type=type_hints["honor_s_maxage"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument must_revalidate", value=must_revalidate, expected_type=type_hints["must_revalidate"])
            check_type(argname="argument revalidation_settings", value=revalidation_settings, expected_type=type_hints["revalidation_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if cacheability_settings is not None:
            self._values["cacheability_settings"] = cacheability_settings
        if cache_control_directives is not None:
            self._values["cache_control_directives"] = cache_control_directives
        if default_ttl is not None:
            self._values["default_ttl"] = default_ttl
        if enhanced_rfc_support is not None:
            self._values["enhanced_rfc_support"] = enhanced_rfc_support
        if expiration_settings is not None:
            self._values["expiration_settings"] = expiration_settings
        if honor_max_age is not None:
            self._values["honor_max_age"] = honor_max_age
        if honor_must_revalidate is not None:
            self._values["honor_must_revalidate"] = honor_must_revalidate
        if honor_no_cache is not None:
            self._values["honor_no_cache"] = honor_no_cache
        if honor_no_store is not None:
            self._values["honor_no_store"] = honor_no_store
        if honor_private is not None:
            self._values["honor_private"] = honor_private
        if honor_proxy_revalidate is not None:
            self._values["honor_proxy_revalidate"] = honor_proxy_revalidate
        if honor_s_maxage is not None:
            self._values["honor_s_maxage"] = honor_s_maxage
        if locked is not None:
            self._values["locked"] = locked
        if must_revalidate is not None:
            self._values["must_revalidate"] = must_revalidate
        if revalidation_settings is not None:
            self._values["revalidation_settings"] = revalidation_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cacheability_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        '''
        result = self._values.get("cacheability_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_control_directives(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        '''
        result = self._values.get("cache_control_directives")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_ttl(self) -> typing.Optional[builtins.str]:
        '''Set the ``MAX_AGE`` header for the cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        '''
        result = self._values.get("default_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enhanced_rfc_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        '''
        result = self._values.get("enhanced_rfc_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        '''
        result = self._values.get("expiration_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def honor_max_age(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        '''
        result = self._values.get("honor_max_age")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        '''
        result = self._values.get("honor_must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_cache(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request.

        Effectively, set the time to live ``ttl`` to zero seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        '''
        result = self._values.get("honor_no_cache")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        '''
        result = self._values.get("honor_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``private`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        '''
        result = self._values.get("honor_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_proxy_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        '''
        result = self._values.get("honor_proxy_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_s_maxage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        '''
        result = self._values.get("honor_s_maxage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin.

        If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        '''
        result = self._values.get("must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def revalidation_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        '''
        result = self._values.get("revalidation_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''The maximum time content may remain cached.

        Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91afb27f2b0fb6f591d3b945527d03c07af5b7372dc699a69d2787ffc17e544)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetCacheabilitySettings")
    def reset_cacheability_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheabilitySettings", []))

    @jsii.member(jsii_name="resetCacheControlDirectives")
    def reset_cache_control_directives(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheControlDirectives", []))

    @jsii.member(jsii_name="resetDefaultTtl")
    def reset_default_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultTtl", []))

    @jsii.member(jsii_name="resetEnhancedRfcSupport")
    def reset_enhanced_rfc_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedRfcSupport", []))

    @jsii.member(jsii_name="resetExpirationSettings")
    def reset_expiration_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationSettings", []))

    @jsii.member(jsii_name="resetHonorMaxAge")
    def reset_honor_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMaxAge", []))

    @jsii.member(jsii_name="resetHonorMustRevalidate")
    def reset_honor_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMustRevalidate", []))

    @jsii.member(jsii_name="resetHonorNoCache")
    def reset_honor_no_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoCache", []))

    @jsii.member(jsii_name="resetHonorNoStore")
    def reset_honor_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoStore", []))

    @jsii.member(jsii_name="resetHonorPrivate")
    def reset_honor_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorPrivate", []))

    @jsii.member(jsii_name="resetHonorProxyRevalidate")
    def reset_honor_proxy_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorProxyRevalidate", []))

    @jsii.member(jsii_name="resetHonorSMaxage")
    def reset_honor_s_maxage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorSMaxage", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMustRevalidate")
    def reset_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMustRevalidate", []))

    @jsii.member(jsii_name="resetRevalidationSettings")
    def reset_revalidation_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevalidationSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettingsInput")
    def cacheability_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheabilitySettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectivesInput")
    def cache_control_directives_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheControlDirectivesInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultTtlInput")
    def default_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "defaultTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupportInput")
    def enhanced_rfc_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enhancedRfcSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationSettingsInput")
    def expiration_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMaxAgeInput")
    def honor_max_age_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidateInput")
    def honor_must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoCacheInput")
    def honor_no_cache_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoStoreInput")
    def honor_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="honorPrivateInput")
    def honor_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidateInput")
    def honor_proxy_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorProxyRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorSMaxageInput")
    def honor_s_maxage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorSMaxageInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mustRevalidateInput")
    def must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="revalidationSettingsInput")
    def revalidation_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "revalidationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d667eec5b35beeb236a9891e128ce70b4fa496e356cd149168d02e6b0a5430c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettings")
    def cacheability_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheabilitySettings"))

    @cacheability_settings.setter
    def cacheability_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1e780eabff888b0fc66ca7329dbe9a10d7170c38a0d993866cf0a4f0e922bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheabilitySettings", value)

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectives")
    def cache_control_directives(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheControlDirectives"))

    @cache_control_directives.setter
    def cache_control_directives(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7920fe8d7a2cec583cf177da90cc89b0912cc2e616d0606489800d1849f13e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheControlDirectives", value)

    @builtins.property
    @jsii.member(jsii_name="defaultTtl")
    def default_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "defaultTtl"))

    @default_ttl.setter
    def default_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6335a7a99554294aba3522e8962625e02cd0fa8fe377238d03766f4753b9caa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultTtl", value)

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupport")
    def enhanced_rfc_support(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enhancedRfcSupport"))

    @enhanced_rfc_support.setter
    def enhanced_rfc_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6899dfdfc65deb8cc9fdb6d9ecd4c14769e91d9a122e08677f2ea9d1cef3bd81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enhancedRfcSupport", value)

    @builtins.property
    @jsii.member(jsii_name="expirationSettings")
    def expiration_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationSettings"))

    @expiration_settings.setter
    def expiration_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ebf01ba58cb732bd32d6ac64bfe2e67c049587aa54651f686698dc8a7e6fd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="honorMaxAge")
    def honor_max_age(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMaxAge"))

    @honor_max_age.setter
    def honor_max_age(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a820bf7a1be7430463a08fac1f7fce5b7837a0ab11d158db92775853fde9373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidate")
    def honor_must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMustRevalidate"))

    @honor_must_revalidate.setter
    def honor_must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fab7d74253b821d81b86a059fc8723323c98e1b1e43666767470ff58830ec29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoCache")
    def honor_no_cache(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoCache"))

    @honor_no_cache.setter
    def honor_no_cache(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c66d12bf3b51db8cb9712ca156d5653fbbdedee14b94dd2310e9fc7c729232b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoCache", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoStore")
    def honor_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoStore"))

    @honor_no_store.setter
    def honor_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f65954e31e9caec0bbd4bcf66ee3715df41c45aa71b14749baff841b53686e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="honorPrivate")
    def honor_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorPrivate"))

    @honor_private.setter
    def honor_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd858790e5283355749f50984f566894c1e2213a1566e21089bb4b7a8ba1360c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidate")
    def honor_proxy_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorProxyRevalidate"))

    @honor_proxy_revalidate.setter
    def honor_proxy_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cdf4dcd94940ff9b1163653755c6ad7c9f5bcc0f455b4d062610c9da132c991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorProxyRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorSMaxage")
    def honor_s_maxage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorSMaxage"))

    @honor_s_maxage.setter
    def honor_s_maxage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133e8ecdc9a9b59983406b83292f0d191db6feaef3c98f8c25f2d00a134116d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorSMaxage", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86098cb54d19f8405543449e99ad38590f92e73ff4237e8e49496fed450f13ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mustRevalidate")
    def must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mustRevalidate"))

    @must_revalidate.setter
    def must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ccdffb2730aa39b3abb2a1e43a5300e9be368ae47c9dbc81d5e7bf6328f13e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="revalidationSettings")
    def revalidation_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "revalidationSettings"))

    @revalidation_settings.setter
    def revalidation_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450eb30707f10b97a81422a9516ae529f3019b58972367db03ea047d9fb115be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revalidationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d676f344f35ed81769497588c1fc3003c7f51a88b414010568ffa47abdc9bcc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059553ebb4e1fdb1684506bf64c153eca8d23425aed571a9ce8cf89255d346eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27fdb84d9a1b3ced58aeae6507b2c8b97c63469c4e913a8845e16fe914029e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377565e805dbbc58afb0602eaf8af5134404bae1b12a0bc35e38610abbfc4fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84ae910b61db8ee22c0f15b108b00f470a6a89566cfec11054414e74744f882)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the centralized authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cca0c11fea21b180a27bc7ce46356981f9e9f48629f3d2ed0c37d0885f781377)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0354a7d1b81f694144b641b11b88d79b59446f2146815414986b37fc3b2b8801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e4f2ad1cf9894fcf844901cfed83dee82511316675ea8d37c86af05cd8403f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf1bc9196b2a1524dff7b59135b12641afe6c9df53dfe1f38597fde2f1a1b75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6413786c63018102ff3177e901bdf12e86867f90f1039d957c62fcff96a55274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d84224a2d2d382a75c316bf504d4983a63cb6e468eb51ed64dd1d281dc99a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "limit": "limit",
        "locked": "locked",
        "serve404": "serve404",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503c5ea08b2d1ae1ed49649ea2316fb0e91e55c9b7201857e15cadf30254366d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serve404", value=serve404, expected_type=type_hints["serve404"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if limit is not None:
            self._values["limit"] = limit
        if locked is not None:
            self._values["locked"] = locked
        if serve404 is not None:
            self._values["serve404"] = serve404
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to chase redirects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def limit(self) -> typing.Optional[builtins.str]:
        '''Specifies, as a string, the maximum number of redirects to follow.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serve404(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        '''
        result = self._values.get("serve404")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac54728a51e0053cf5a05ca9bf5b462bfe91b2cd22f19879cf65a50ef85cae0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServe404")
    def reset_serve404(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServe404", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serve404Input")
    def serve404_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "serve404Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51540232086801d0e58a3bc25d8b33249b75dea9f69f58e8e82c1e06c7d31d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1be3c980247c814e03f9aac57884857099a003ea01d4d78a8964c4556fe0f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138ed26b04613b76071f2b0e348211e461b6968e71d8b609bc19b47e06283163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serve404")
    def serve404(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "serve404"))

    @serve404.setter
    def serve404(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb9d73ea89bda5d2e15c24afa7ace617b6f0cc6ee01ab0e099ce668a5a32fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serve404", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9d866a9bb11fa67249ad6da9f4339dd441cf2a28876e0007d8fa6f3eb60c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8dfbc4a995b2a54d828a1302f0f06f4bc0343d49c1680de97ec7708d2746d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf0f6c5f178b2390872f88612ac7f600a33b167b8a24cfb29ee7da2a81c7957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "country": "country",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics:
    def __init__(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84eea56637753f40f872dd8e5e9d933e06267e7e970e7bdcfaca1619272f297b)
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if country is not None:
            self._values["country"] = country
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the client request's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27eefda4606d5c8981ec5d8c37ffdd4e5529ea521dda7cfa5ccd047aab291d76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34bb8ea00c65d889d0792e106e763d5153f328afd97fda3173b4b34c31a81fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aa8991df6a5228cfcef61b2b05072ed4bb1751826c20700883a020ae8803614)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc566c7b0fa178f34c2332b3b7a8e4344dd529f72b7337454f4b5ee20268433d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e280f6697adb4f21bcd52f938cfe16145e3a703433179beabbcce1909de43279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca72c96896ae285012c50c03d099efb482b2b9edbfff9afdffb8cf2886ab274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects",
    jsii_struct_bases=[],
    name_mapping={
        "cloud_locations": "cloudLocations",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects:
    def __init__(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e43c9b6bb1731af5b223915956668aaa79aab6657184385b6286f994eadbc40d)
            check_type(argname="argument cloud_locations", value=cloud_locations, expected_type=type_hints["cloud_locations"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloud_locations is not None:
            self._values["cloud_locations"] = cloud_locations
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloud_locations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the geographical locations of your cloud origin.

        You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        '''
        result = self._values.get("cloud_locations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Channels the traffic to maximize the egress discount at the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc99e76e565459c5b2a7e0108f5f50f8b9323b8f4020c1f4bc883bbf012fff4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudLocations")
    def reset_cloud_locations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudLocations", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudLocationsInput")
    def cloud_locations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cloudLocationsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudLocations")
    def cloud_locations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cloudLocations"))

    @cloud_locations.setter
    def cloud_locations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f640d5ac298e8bd59cc90d77dc11d588a6c9be9b1c2df008650d30dd03a1ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudLocations", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b52c0d5676c153057e5c1726270300f88ffd28b90767b0a8c19fcbd8a9d7f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed3830642e04e499aa3c81aa4be5cdd5c596e2365d41243807376e83532df17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd9ded087af93891603bcefd0fa0852401a5f15315ea14ea57c6b3c16375fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b602b9e9723a75cc242cb3d0924f810da3c4148f25c12e52b46549c70cc9e9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb60820875853fa9b6ed08c879562ad8657446c521775cc6084d921b60c90988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "location": "location",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae914d4a34965b4aedce9847fd7686163da6ce1bc9ff4c04f9eaf585956dc965)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Wrapper behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''The location you want to distribute your Cloud Wrapper cache space to.

        This behavior allows all locations configured in your Cloud Wrapper configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "custom_failover_map": "customFailoverMap",
        "enabled": "enabled",
        "failover_map": "failoverMap",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced:
    def __init__(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53739e9ef11f344648c64c4d0ef9053ed0cd825cdac8bf9f8e1751746c63fcc7)
            check_type(argname="argument custom_failover_map", value=custom_failover_map, expected_type=type_hints["custom_failover_map"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_map", value=failover_map, expected_type=type_hints["failover_map"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_failover_map is not None:
            self._values["custom_failover_map"] = custom_failover_map
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_map is not None:
            self._values["failover_map"] = failover_map
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        '''
        result = self._values.get("custom_failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables failover for Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        '''
        result = self._values.get("failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cec1328fa42c37ce6d25469512de52beb1ffca6f8ae37c91cbdf99e6e79502c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomFailoverMap")
    def reset_custom_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomFailoverMap", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverMap")
    def reset_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMap", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMapInput")
    def custom_failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customFailoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverMapInput")
    def failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMap")
    def custom_failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customFailoverMap"))

    @custom_failover_map.setter
    def custom_failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__357ab3e673df4b0639a3c7fadad6b0e3db6176bf214f38267da75c55bc954213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customFailoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa58ca7585a247529d088ad0992ed6303a9bc4e68a9855fc8ffd4e356425493)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMap")
    def failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMap"))

    @failover_map.setter
    def failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902ad1508b970de0536acd7dc3bfe27a22eeacbb23e751a15451eac97a6f96d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d358518669a8c64edadb456e9c657060fa6bd7cfb3c69309d3dee07f390917b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84bd594a498b27a4a12ae5001fbbd397cd2ff9aaf5bf225a24044a6d7b760ca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d753d303e21c1f958fc68312a85b448374c039267d0213993594953751724571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f672f33abd6659ceac33c0b911e862666bb7fd048068eb9bee4f347921b2969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8175f6411239be497b4696eeb990b401b43e54c8e44bc0ef337f8f9dcc1235)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce004d128651509daf0443a0d5d496be9fb27c9d96ab1a232aff72cb39782064)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3ee403050a60ffd3758e96fdb75985c762e90706a6173edce1664d9419fe04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec3c05672bf2e6bb09fc9610c09d2c518d6334ca37a9c8cbbba333fc23c73460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ced10c1cfa3bcc8511fceba1f687809fcf102e5baa1a48f01de6bb3a7d92bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__454d67022d7dbd6275e012b4f970e114b7747cff578e23797a9debc6cafae38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf7e753af5438328621a556ac946b43123ec0625ebbb1bf4963379d455dd85a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData",
    jsii_struct_bases=[],
    name_mapping={
        "enable_cmcd_segment_prefetch": "enableCmcdSegmentPrefetch",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData:
    def __init__(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a609de5809a496bb3354bc11a13d3ef5e004804fb3e77e77ff2de828d8a88f5)
            check_type(argname="argument enable_cmcd_segment_prefetch", value=enable_cmcd_segment_prefetch, expected_type=type_hints["enable_cmcd_segment_prefetch"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_cmcd_segment_prefetch is not None:
            self._values["enable_cmcd_segment_prefetch"] = enable_cmcd_segment_prefetch
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        '''
        result = self._values.get("enable_cmcd_segment_prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientDataOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientDataOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8f61437020a6edc6979a45fead86650f4ef8f14d254c1bbf5848bdcbe9a282)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableCmcdSegmentPrefetch")
    def reset_enable_cmcd_segment_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCmcdSegmentPrefetch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetchInput")
    def enable_cmcd_segment_prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCmcdSegmentPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetch")
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCmcdSegmentPrefetch"))

    @enable_cmcd_segment_prefetch.setter
    def enable_cmcd_segment_prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99c22fc5ebddfcaf1deba24a7d6080e1661c999ca9b956a83e6f91c134cdfb6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCmcdSegmentPrefetch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292f73a12cf1dab66411714ee2778ca0d0f1afd7d0f0c2d0a9a0bdddc2f3077b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53a07b9e9d930a55af010ad1d5b3b56cf4a71a05e269056384a7cdda3eabbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc4579bd6c9bf8f6172927463541fb5148f03881e0531ee6fc0674e3a1e3566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f072e9ae10329578bba6131ad7cb94599d2adee71cf38e15f1a3ed29f0a9ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8c05d19da15f1e05d403c695592f30ff088ea4bfa47d6f819dad66084a2e6c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.'''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d47e6b771cafd07991fa2ebf62a383641284db4eb642a9782c3c1e2035f65a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78aa8f6603feafab81e109db32065b243b6bab5beb781476ed24a0cd522ef0d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13830dbe47ff0c671ff01e5d0794325846cb9e89c6ca9b6507316b308cdc9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc2d82e6df85f996dba7309ac97f65f31d4bc81ea1526d231a99f2019a0e246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207b01ac43eb5f1fdeec2f288ccfa86119517bf77aec689cb684ee7a53b67cba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eac95036ff135cd9f5006799886eee4a20c1e347fdfe6d8b39593f7a53f78c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse",
    jsii_struct_bases=[],
    name_mapping={
        "body": "body",
        "enabled": "enabled",
        "force_eviction": "forceEviction",
        "ignore_purge": "ignorePurge",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse:
    def __init__(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9c924e6aeca9ae62f866cc202ecbf15a10842ef22f21e6d7be693efe4f9e2a)
            check_type(argname="argument body", value=body, expected_type=type_hints["body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_eviction", value=force_eviction, expected_type=type_hints["force_eviction"])
            check_type(argname="argument ignore_purge", value=ignore_purge, expected_type=type_hints["ignore_purge"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if body is not None:
            self._values["body"] = body
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_eviction is not None:
            self._values["force_eviction"] = force_eviction
        if ignore_purge is not None:
            self._values["ignore_purge"] = ignore_purge
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def body(self) -> typing.Optional[builtins.str]:
        '''HTML response of up to 2000 characters to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        '''
        result = self._values.get("body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Serves the custom response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_eviction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        '''
        result = self._values.get("force_eviction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_purge(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to ignore the custom response when purging.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        '''
        result = self._values.get("ignore_purge")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP response code to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99cf9892c2cf49980b7e8f2579f3735ef32979941a62fee262f87cc6e68a26c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBody")
    def reset_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceEviction")
    def reset_force_eviction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceEviction", []))

    @jsii.member(jsii_name="resetIgnorePurge")
    def reset_ignore_purge(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnorePurge", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bodyInput")
    def body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceEvictionInput")
    def force_eviction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceEvictionInput"))

    @builtins.property
    @jsii.member(jsii_name="ignorePurgeInput")
    def ignore_purge_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignorePurgeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="body")
    def body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "body"))

    @body.setter
    def body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c16ffe5cd5d37f0ad374500c9bced987dd0632add5a4cb49e8672972c0dec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "body", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b1b2e6566594f2621f65d993bd85883a162a8dcb79b4463440c371da244642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceEviction")
    def force_eviction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceEviction"))

    @force_eviction.setter
    def force_eviction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc41ec65d307b0a0a45e72201a4cf7e2805ca2c8057dff6bdffa10a1e4199d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceEviction", value)

    @builtins.property
    @jsii.member(jsii_name="ignorePurge")
    def ignore_purge(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignorePurge"))

    @ignore_purge.setter
    def ignore_purge(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7e2d8ddb6bcf18f4adcf43b983f84e53aea20083854277168a504318a61139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignorePurge", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e2f6f5294c2c344131586a85d8c6ca484dbd4bb474bf5268f9e130716219d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb4b6e84cab47c92506805a297e66098f86cef09d15e2fbf4bc7a2bc5d8a48e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd534f971c4521cdfdd935ba09f4c4a8ed54941e8920f606fd4f02f9964c65d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19937b2307b80167056c4df247c872129a916c288cc5c4d0a0c4bbe83e9d8e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef48890e6bab9976ede4569b1c58e0f3fb1aacf7f2f619fe15414c8f89842a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1a8b9689d1a791f521838a7cd755708df20046a01157346b35fbf3d46d31f3)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_dash_custom": "segmentDurationDashCustom",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hds_custom": "segmentDurationHdsCustom",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_hls_custom": "segmentDurationHlsCustom",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_duration_smooth_custom": "segmentDurationSmoothCustom",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c8ca056c3c7788b604136a82a48d9dd126f564e3b849035c9bda79048903a99)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_dash_custom", value=segment_duration_dash_custom, expected_type=type_hints["segment_duration_dash_custom"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hds_custom", value=segment_duration_hds_custom, expected_type=type_hints["segment_duration_hds_custom"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_hls_custom", value=segment_duration_hls_custom, expected_type=type_hints["segment_duration_hls_custom"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_duration_smooth_custom", value=segment_duration_smooth_custom, expected_type=type_hints["segment_duration_smooth_custom"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_dash_custom is not None:
            self._values["segment_duration_dash_custom"] = segment_duration_dash_custom
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hds_custom is not None:
            self._values["segment_duration_hds_custom"] = segment_duration_hds_custom
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_hls_custom is not None:
            self._values["segment_duration_hls_custom"] = segment_duration_hls_custom
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_duration_smooth_custom is not None:
            self._values["segment_duration_smooth_custom"] = segment_duration_smooth_custom
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        '''
        result = self._values.get("segment_duration_dash_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        '''
        result = self._values.get("segment_duration_hds_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        '''
        result = self._values.get("segment_duration_hls_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        '''
        result = self._values.get("segment_duration_smooth_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f2ee18daec14d565e58d3b192172e8fa9d241b17959c27f7c5ee2857212b6e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationDashCustom")
    def reset_segment_duration_dash_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDashCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHdsCustom")
    def reset_segment_duration_hds_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHdsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationHlsCustom")
    def reset_segment_duration_hls_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHlsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentDurationSmoothCustom")
    def reset_segment_duration_smooth_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmoothCustom", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustomInput")
    def segment_duration_dash_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationDashCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustomInput")
    def segment_duration_hds_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHdsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustomInput")
    def segment_duration_hls_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHlsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustomInput")
    def segment_duration_smooth_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationSmoothCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc739a06f105646e32d75ad44314213e9b4d892c85161709601771a33e57af2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea3512ac691e15473265c0a54e7467b98c68d3fc9ff25904a0ee1b4a1d39c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61486bbb174cc8d116e3692190d3b13c1fc3106ff8298285afde7fee5b4611c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d71dcb0044b07ddad2230e511a6da19ab2cf30c2fa99cdfe9af19e74c91031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cf76df8d629506e83daa137828477cf9f2f2f22fa05b84684a7eb49a16e3c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055305df65a432931a3ed77bce742d65dfbbe165f32296785289f99fccff5ec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b08c0d3c57b9c0b7f6513a67c9d854940c1966d6a49906145d45e2e8701a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5559ae1131576ba292feab8a546670810fe05c28fa694054d1091532c7baf8af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustom")
    def segment_duration_dash_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationDashCustom"))

    @segment_duration_dash_custom.setter
    def segment_duration_dash_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d2a3aed07150e6b808de7349f2997be331b97f8c6090dbc8b392cbeee5ce57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDashCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726cb51d764e8a453208943a8ef4866cc50e18de76cf1da1a33192d568762620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustom")
    def segment_duration_hds_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHdsCustom"))

    @segment_duration_hds_custom.setter
    def segment_duration_hds_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93be630cf5e099f940e7b0878dbc7643249f5f022633a97327ef78ae055520b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHdsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21229496ef57f3ec6bd2b0fcd2e46f8120423959cf53cc4109b7eb7d15d7c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustom")
    def segment_duration_hls_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHlsCustom"))

    @segment_duration_hls_custom.setter
    def segment_duration_hls_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a24be1a470a1aaa32cd9429bf477945fb49b8b43ec26dfecc846bdef766a720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHlsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6121d62635450386b2a0642fda931c6de61334f8283d41166483c2c91ac7ad6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustom")
    def segment_duration_smooth_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationSmoothCustom"))

    @segment_duration_smooth_custom.setter
    def segment_duration_smooth_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ae2fef0e8cecb28235de9902eac60ebfd77455bb936e67328923ba1412c2f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmoothCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3debede3d97ada4a2ac5ffc20a16f63278f9f46adbbcecec42c177facdc30d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae036e8f27a1fc3ffe6d28d72fb6aee754aaeacfb52cf04dea9f29321fec7dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8207ad4b8ed95306a81de0744bb2dd47da2886de5d833c4090019da12fb1e2e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5918a2677f8db0242a2865b4ec1ce7483bcbedd170687d23c2a237ec6463c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84e2195fb8a9481296a662d6a0d581ca7605cf2317f2f6fe5fba0ee2dff202a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d7bc8cd87d23d75378a6f522f21378d1145eeb9fe434a1e3350d2454eea79b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82fb7b87a6ea30d4ebe2da30e9bad55052da398d5f5430f11800f6f7a424f427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37491506dd793c26c0bdc2b9b66b3f3c65310a8e8e3e116074bb3d42f102ed61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "optimize_option": "optimizeOption",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a4bb5c305b7aef0b2757bbae20ff25ec5b948b574745c52c51ef98a194403f)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_option", value=optimize_option, expected_type=type_hints["optimize_option"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_option is not None:
            self._values["optimize_option"] = optimize_option
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_option(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes the delivery throughput and download times for large files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        '''
        result = self._values.get("optimize_option")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c10b8c0e79ae2cf91db9e3b70b29ef6990ca8621fea75fd612e89f5685837e1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeOption")
    def reset_optimize_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeOption", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeOptionInput")
    def optimize_option_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optimizeOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4cc63e478d2829e93a4f3f7d51a1f0f708faabc8b8f5662093adf9b61a44c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6cf0148c8e33a54959f541e0a8808ac941b17a2851db43da182555bd8c5d40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55aa2161f24d0ba0a5e9036f5872a939fe512087623a784424b67cb7a792943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6382b57abb70b802221e4e49d3bd4cadf7b56f43434123e0b64242ee1f0934e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeOption")
    def optimize_option(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optimizeOption"))

    @optimize_option.setter
    def optimize_option(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2624d630a4f5508ca2f1c90155c5f4e76f27ed3436e5d85d3bc3c2408b0929e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeOption", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1f91f3bb9f5ab7cab71c1624a7b1920ba3ec716351887a45777394dfa4177c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d515f2a888d8e145cfaa73e55b1c5e06f3419a1903c09a5ca067071dd75d6142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4775c0f6c406d4095a1f3e3fe17b1e5a730a15654219ac83f1ab6b4982ccc9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41eaeccb60247222a9efc22e408bc33bef786ce4b65d054a2c97cf7223920691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc1936ceae3676f3642451d1cc4600abb606edbf3de447459ab737f1028627f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a05d974147ed829429a0bd92e2c9ac6eb56ca1932c186cf7a30aa328f36ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71354284216367933059f0dcaa83fa7c2746b268bfa7c196ca196570b02cdf04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c187d8c50c783a7659a5f65ff5793d6fce1e75a8a20d3d30878ad800219d770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b81e716c8fc29f7bcc0bd8e38a01fe6a84492e2376993b9605788f88b3b289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb39e0803b28bce73b63f409b75dad09c2cce3b2a9b3368d3521bc07caa7970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e5141c3cb547b363807fd598c23da6c1814941f0f66d84c77635df7712fd192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb12835c41c49edfd2b51689ebe7b8044b2cdadbc6cca422030c4dc13a3db516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d492df2aa5c97a6f879bb24a64941c2cd9f0f08df1c13487f8cce64a7bdd09c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35229b4d2ede71a3949b87e8139faeef8de30420e4702b12085830a07e01686)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFileOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFileOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__394e28c65ab60a025f2263f2343f9a460ec805f956891358a415c8945157f113)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f753909c133da45ddd9a09f99831a4e3b1234a8464b39bf2394ad4d84198ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fd721d2fd250fc124a4918f93dfa4a7afbcf12986914c0988a989d1e07a1d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b10ee8d1aeeb3cfd0e8f0741bd1ee628b1f48f366114e40112de9a5dddee1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fddb8026844e7517e8486eab84f1e5c6852ee871a8728cc88142d903050de87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4686e378ac85eeb3118f0151f990b726a20bfa7df59a75b86a943ba9886c5b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__203ffbd6ab3a4048690d6b27c27832a8808394f3100a56018819fd43a11cbf13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d43f3be4a721e06aec8e08df6c894e5a1026526595fa79e156a3bf6ec8a938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34b806389733fd53e5b8e0b9b297fa57dc5c2f507d5ef53fcf37baf6a3c84e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d896ca42fe1069317d0fcf337e0cbc912798fe70359da04b27352039b3bf284d)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLiveOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLiveOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd4a08fa658bbc4baffc6a31dbb059837dff656a477cf33e65551fbf346db7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843331a429a460e7286180d7d97d77a24f37afbe84c0e5da91b658d58c1749f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f01846dfbdb314b09c5d203321beeec702bb2f023962c54da4172ab0eb9117c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95f003718ea349785db9e918ce7a2ff3b8394b3e4505c0836c9458c52091acc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3333be84e777077a5916d5fcb66533a4a13daaeb312a74aafa0c795eb0e0cda6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895b741614431e18e6f4a6184162d438e847a2d7f6efcba3f5596795352b8447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d676a99b8ce33b57400b04eaa5ea4f9cd05a8731de6a1cb27e9eb49ab17961aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ea97e0c2a72bcd12f50411df80abf6c62f859bf4b078e1a06033d21abd2ecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a4d3363781f4ad9ed12aae775f3c7b6bd0f0c1187c3d79cf5d4ae6ca0721da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5bd5f77e3dd508a40d29172799c9e762230d32993d4433c4000d1226a5d8a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8be68070ca90e618c586901ab9bec88dbb690ac0225a0d3772ea50b1329c215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5df1c575a65677b82941c5b28af340c69567b83343d6661e0932121adffd0a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aff6acae0c3a4848313d8028c3a46e887bf7d4460e32696040a2046373f3c84f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad646125d187d2b989ac3bde45fd8d1711ab21a18723dd717643ab6c171e47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44370427e7ed604730bb0e1ab00797812e5acf5c94a4bc2d0a24ca00143c85c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36cf918ca92aee5b4206798da48d0f442e0116fe96a3d665ae69dd9d0289168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c398a52a30ef7abaf4d954faf3df22c5b765c81dd94866db47fc10f1298f59d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7364d26963d393f0ca6e1dbb37adeab042d10d9fc70d297b4b3127645cefb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37102edf7c3ae9e6b8dbc4a773d13454005c8d9aa9d732b7fbc27cc2dee4973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb4998087203b1da3a4754dc24eab8ecc0eff92063e55df2333bea0ebc2b246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f9582ca4e83bbd9f61281867c9d54d63ad4dd0695b7356778a6823d915d4dfd)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3843058262ebd8599a973db920198c8b6b30a1082f3a0844cbcdd91d059dcf3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2507fe5078d0fd0052ae8b7ae65deefc20d298eeea6587b74c3ffb6969982129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab9c26c0f04a1a546d5eab77e4fc79b24e64955afc26e5200deb995519c3b2db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc0f0e883fb45f81b4cd47031060b2f0f68014c3986696247cd92221e948c39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b1ba6e15193160ff7f107f3f4ff2849acf934a871a7afeb7f49308424bb836)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f412451227342ca5c73504d3274353ab6b5f3b80b6340328e4d2a5662df70d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39919d7fe81c059678f8f04cb167e596987537b09ab4c5e992da6fea52d2c197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fd2d97577d0dffad7e2140070c1bb09e2923422cba2f19569b5ca06639be20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e22d636e02a704e192831119a6f261f3dbd771c06cd30643e992e0c29084d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8aa66cc5d0b098be27063f9ccc2e432ca0d8f37deface5128b8aade5ba9533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61695dfef80a728f2e83421150f8eb0d1f05169156b55e0721e02cc9f6624a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a5d89b71b9e6e23d53bee734b5f949eb0eb5f835f12291970f873d402a5e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607ac5a5f13d698c4227b105d3d5987267cd099ab173a00000317354356ce808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fea8f0dfcd95e841eb524b8b431525eeee5766b78ac36f93aacb183dae718a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec47f86c161168e34c8c71e61b6ed261cc6061294b036026ae599d52982aad26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee4c012a48854e1f303e36bbfdddeea7736256d9749418fa69bf540351b9348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3b04101a7b592c0510ff02c09b56e8608d48afebd568c2df46054ff839ebe70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79def181cae203325ae56459a9527693aa6618577fe7bbc73b9d8aac49d66611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bdd033beddf16f11973457d2158815ec59c376f02a58c1be94ecb2134db342b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a883a51ca209d057e3488074277c4f3635fcc650ab0da4867fa7c62c2a135b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "first_location": "firstLocation",
        "locked": "locked",
        "second_location": "secondLocation",
        "source_type": "sourceType",
        "targets": "targets",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c4c08001edf06c13d3c02a34187f27d0e4857f0bc433c48b64833461674b8b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument first_location", value=first_location, expected_type=type_hints["first_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument second_location", value=second_location, expected_type=type_hints["second_location"])
            check_type(argname="argument source_type", value=source_type, expected_type=type_hints["source_type"])
            check_type(argname="argument targets", value=targets, expected_type=type_hints["targets"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if first_location is not None:
            self._values["first_location"] = first_location
        if locked is not None:
            self._values["locked"] = locked
        if second_location is not None:
            self._values["second_location"] = second_location
        if source_type is not None:
            self._values["source_type"] = source_type
        if targets is not None:
            self._values["targets"] = targets
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content PrePosition behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def first_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.'''
        result = self._values.get("first_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def second_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.'''
        result = self._values.get("second_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def source_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.'''
        result = self._values.get("source_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def targets(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.'''
        result = self._values.get("targets")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePositionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePositionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446fb68402d2c22c3695d4dc5f943de2cf6e6c2d705a5b906529c44f41baf222)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFirstLocation")
    def reset_first_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondLocation")
    def reset_second_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondLocation", []))

    @jsii.member(jsii_name="resetSourceType")
    def reset_source_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSourceType", []))

    @jsii.member(jsii_name="resetTargets")
    def reset_targets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargets", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="firstLocationInput")
    def first_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "firstLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondLocationInput")
    def second_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceTypeInput")
    def source_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="targetsInput")
    def targets_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703b274c157529029ddb3c89a4a54c8ea5e7cf0aab237574765326ff8b2a782e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="firstLocation")
    def first_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "firstLocation"))

    @first_location.setter
    def first_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1211f219046203de9d4271bae64f7e9a706139644ec4f75eafe27f42238f0634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "firstLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60d4ff7589571f1445b3e0bda790127eea92ecc2d7fcc20ccb5c114b471dce88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondLocation")
    def second_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondLocation"))

    @second_location.setter
    def second_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5460b66693620f60e7759f6587dcc06c3f4f079c6385eab291fba8a9af127db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondLocation", value)

    @builtins.property
    @jsii.member(jsii_name="sourceType")
    def source_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sourceType"))

    @source_type.setter
    def source_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7998b118af85d091d7bbe1b99e9fa0ec22b089d031628a1fcc2a590a1971c221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sourceType", value)

    @builtins.property
    @jsii.member(jsii_name="targets")
    def targets(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targets"))

    @targets.setter
    def targets(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87024f8992771a16b08aaff1cd94186cff765fb162dc54f5b552fe1753120e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targets", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__890dfb741bd421d261d6c0b68c6a01db36b3a3abf59592f5d954ebb1caf1ece3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ae08cdc1d7e0168bb3dd1f3f309a78ac8b4e984e0a5a7c03fb757e56c50acf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d5bfafb330a6f96bf5e9b0ddc10f70174451890fff567dc07161aa3dbee888)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection",
    jsii_struct_bases=[],
    name_mapping={
        "countries": "countries",
        "dmas": "dmas",
        "enabled": "enabled",
        "enable_geo_protection": "enableGeoProtection",
        "enable_geo_redirect_on_deny": "enableGeoRedirectOnDeny",
        "enable_ip_protection": "enableIpProtection",
        "enable_ip_redirect_on_deny": "enableIpRedirectOnDeny",
        "enable_referrer_protection": "enableReferrerProtection",
        "enable_referrer_redirect_on_deny": "enableReferrerRedirectOnDeny",
        "geo_protection_mode": "geoProtectionMode",
        "geo_protection_title": "geoProtectionTitle",
        "geo_redirect_url": "geoRedirectUrl",
        "ip_addresses": "ipAddresses",
        "ip_protection_mode": "ipProtectionMode",
        "ip_protection_title": "ipProtectionTitle",
        "ip_redirect_url": "ipRedirectUrl",
        "locked": "locked",
        "override_ip_addresses": "overrideIpAddresses",
        "referrer_domains": "referrerDomains",
        "referrer_protection_mode": "referrerProtectionMode",
        "referrer_protection_title": "referrerProtectionTitle",
        "referrer_redirect_url": "referrerRedirectUrl",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection:
    def __init__(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a54085714a3799552e1ccd7965636353ad298a261b5b1963efea18c50279fa1)
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument dmas", value=dmas, expected_type=type_hints["dmas"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_geo_protection", value=enable_geo_protection, expected_type=type_hints["enable_geo_protection"])
            check_type(argname="argument enable_geo_redirect_on_deny", value=enable_geo_redirect_on_deny, expected_type=type_hints["enable_geo_redirect_on_deny"])
            check_type(argname="argument enable_ip_protection", value=enable_ip_protection, expected_type=type_hints["enable_ip_protection"])
            check_type(argname="argument enable_ip_redirect_on_deny", value=enable_ip_redirect_on_deny, expected_type=type_hints["enable_ip_redirect_on_deny"])
            check_type(argname="argument enable_referrer_protection", value=enable_referrer_protection, expected_type=type_hints["enable_referrer_protection"])
            check_type(argname="argument enable_referrer_redirect_on_deny", value=enable_referrer_redirect_on_deny, expected_type=type_hints["enable_referrer_redirect_on_deny"])
            check_type(argname="argument geo_protection_mode", value=geo_protection_mode, expected_type=type_hints["geo_protection_mode"])
            check_type(argname="argument geo_protection_title", value=geo_protection_title, expected_type=type_hints["geo_protection_title"])
            check_type(argname="argument geo_redirect_url", value=geo_redirect_url, expected_type=type_hints["geo_redirect_url"])
            check_type(argname="argument ip_addresses", value=ip_addresses, expected_type=type_hints["ip_addresses"])
            check_type(argname="argument ip_protection_mode", value=ip_protection_mode, expected_type=type_hints["ip_protection_mode"])
            check_type(argname="argument ip_protection_title", value=ip_protection_title, expected_type=type_hints["ip_protection_title"])
            check_type(argname="argument ip_redirect_url", value=ip_redirect_url, expected_type=type_hints["ip_redirect_url"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_ip_addresses", value=override_ip_addresses, expected_type=type_hints["override_ip_addresses"])
            check_type(argname="argument referrer_domains", value=referrer_domains, expected_type=type_hints["referrer_domains"])
            check_type(argname="argument referrer_protection_mode", value=referrer_protection_mode, expected_type=type_hints["referrer_protection_mode"])
            check_type(argname="argument referrer_protection_title", value=referrer_protection_title, expected_type=type_hints["referrer_protection_title"])
            check_type(argname="argument referrer_redirect_url", value=referrer_redirect_url, expected_type=type_hints["referrer_redirect_url"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if countries is not None:
            self._values["countries"] = countries
        if dmas is not None:
            self._values["dmas"] = dmas
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_geo_protection is not None:
            self._values["enable_geo_protection"] = enable_geo_protection
        if enable_geo_redirect_on_deny is not None:
            self._values["enable_geo_redirect_on_deny"] = enable_geo_redirect_on_deny
        if enable_ip_protection is not None:
            self._values["enable_ip_protection"] = enable_ip_protection
        if enable_ip_redirect_on_deny is not None:
            self._values["enable_ip_redirect_on_deny"] = enable_ip_redirect_on_deny
        if enable_referrer_protection is not None:
            self._values["enable_referrer_protection"] = enable_referrer_protection
        if enable_referrer_redirect_on_deny is not None:
            self._values["enable_referrer_redirect_on_deny"] = enable_referrer_redirect_on_deny
        if geo_protection_mode is not None:
            self._values["geo_protection_mode"] = geo_protection_mode
        if geo_protection_title is not None:
            self._values["geo_protection_title"] = geo_protection_title
        if geo_redirect_url is not None:
            self._values["geo_redirect_url"] = geo_redirect_url
        if ip_addresses is not None:
            self._values["ip_addresses"] = ip_addresses
        if ip_protection_mode is not None:
            self._values["ip_protection_mode"] = ip_protection_mode
        if ip_protection_title is not None:
            self._values["ip_protection_title"] = ip_protection_title
        if ip_redirect_url is not None:
            self._values["ip_redirect_url"] = ip_redirect_url
        if locked is not None:
            self._values["locked"] = locked
        if override_ip_addresses is not None:
            self._values["override_ip_addresses"] = override_ip_addresses
        if referrer_domains is not None:
            self._values["referrer_domains"] = referrer_domains
        if referrer_protection_mode is not None:
            self._values["referrer_protection_mode"] = referrer_protection_mode
        if referrer_protection_title is not None:
            self._values["referrer_protection_title"] = referrer_protection_title
        if referrer_redirect_url is not None:
            self._values["referrer_redirect_url"] = referrer_redirect_url
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def dmas(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of Designated Market Area codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        '''
        result = self._values.get("dmas")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content Targeting feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, verifies IP addresses are unique to specific geographic regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        '''
        result = self._values.get("enable_geo_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        '''
        result = self._values.get("enable_geo_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to control access to your content from specific sets of IP addresses and CIDR blocks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        '''
        result = self._values.get("enable_ip_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        '''
        result = self._values.get("enable_ip_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        '''
        result = self._values.get("enable_referrer_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        '''
        result = self._values.get("enable_referrer_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        '''
        result = self._values.get("geo_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        '''
        result = self._values.get("geo_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        '''
        result = self._values.get("geo_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks to allow or deny.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        '''
        result = self._values.get("ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def ip_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        '''
        result = self._values.get("ip_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        '''
        result = self._values.get("ip_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        '''
        result = self._values.get("ip_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        '''
        result = self._values.get("override_ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of domains from which to allow or deny traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        '''
        result = self._values.get("referrer_domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specify the action to take.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        '''
        result = self._values.get("referrer_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        '''
        result = self._values.get("referrer_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        '''
        result = self._values.get("referrer_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77d568b2f1a0190c9f8d323ed53f082328db406913381531f765fdd93f9d04a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetDmas")
    def reset_dmas(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDmas", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableGeoProtection")
    def reset_enable_geo_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoProtection", []))

    @jsii.member(jsii_name="resetEnableGeoRedirectOnDeny")
    def reset_enable_geo_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableIpProtection")
    def reset_enable_ip_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpProtection", []))

    @jsii.member(jsii_name="resetEnableIpRedirectOnDeny")
    def reset_enable_ip_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableReferrerProtection")
    def reset_enable_referrer_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerProtection", []))

    @jsii.member(jsii_name="resetEnableReferrerRedirectOnDeny")
    def reset_enable_referrer_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerRedirectOnDeny", []))

    @jsii.member(jsii_name="resetGeoProtectionMode")
    def reset_geo_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionMode", []))

    @jsii.member(jsii_name="resetGeoProtectionTitle")
    def reset_geo_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionTitle", []))

    @jsii.member(jsii_name="resetGeoRedirectUrl")
    def reset_geo_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoRedirectUrl", []))

    @jsii.member(jsii_name="resetIpAddresses")
    def reset_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAddresses", []))

    @jsii.member(jsii_name="resetIpProtectionMode")
    def reset_ip_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionMode", []))

    @jsii.member(jsii_name="resetIpProtectionTitle")
    def reset_ip_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionTitle", []))

    @jsii.member(jsii_name="resetIpRedirectUrl")
    def reset_ip_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpRedirectUrl", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideIpAddresses")
    def reset_override_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideIpAddresses", []))

    @jsii.member(jsii_name="resetReferrerDomains")
    def reset_referrer_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerDomains", []))

    @jsii.member(jsii_name="resetReferrerProtectionMode")
    def reset_referrer_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionMode", []))

    @jsii.member(jsii_name="resetReferrerProtectionTitle")
    def reset_referrer_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionTitle", []))

    @jsii.member(jsii_name="resetReferrerRedirectUrl")
    def reset_referrer_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerRedirectUrl", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="dmasInput")
    def dmas_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "dmasInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtectionInput")
    def enable_geo_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDenyInput")
    def enable_geo_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpProtectionInput")
    def enable_ip_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDenyInput")
    def enable_ip_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtectionInput")
    def enable_referrer_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDenyInput")
    def enable_referrer_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionModeInput")
    def geo_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitleInput")
    def geo_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrlInput")
    def geo_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAddressesInput")
    def ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "ipAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionModeInput")
    def ip_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitleInput")
    def ip_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrlInput")
    def ip_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddressesInput")
    def override_ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "overrideIpAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerDomainsInput")
    def referrer_domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "referrerDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionModeInput")
    def referrer_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitleInput")
    def referrer_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrlInput")
    def referrer_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d91127b1fa17e2535f821c9d3531105c6887135bc3edfc403b10cf0ff3bbb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="dmas")
    def dmas(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "dmas"))

    @dmas.setter
    def dmas(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776152f77eff84971a6727998959a20460b14719206daec01c33ace8abcc402b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dmas", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8534964b2e2b8d4a37bf139d092e219e03cf0b552fcbc7c8c921e5cb0626e8d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtection")
    def enable_geo_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoProtection"))

    @enable_geo_protection.setter
    def enable_geo_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2dbced2304f11637d059c08f27ebd882381a8ec17ab73e4ce36581e6ded74a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDeny")
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoRedirectOnDeny"))

    @enable_geo_redirect_on_deny.setter
    def enable_geo_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2785a5bb50c2909d3e1a47e489be3d3944667d6781b463f53460a95f4d523aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpProtection")
    def enable_ip_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpProtection"))

    @enable_ip_protection.setter
    def enable_ip_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e409f2d3514af68c2a07c9765d7e190f4fbb6facf6adb0d8e85e2ad84bff736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDeny")
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpRedirectOnDeny"))

    @enable_ip_redirect_on_deny.setter
    def enable_ip_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54acda5cdcd831b1b2e5f997739e8df071aa1f58dd50fdcb58c2a21a124dc34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtection")
    def enable_referrer_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerProtection"))

    @enable_referrer_protection.setter
    def enable_referrer_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc2605fe342aa78f2254e1d39465152ec772b1df41862072ed68ab2cbc90e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDeny")
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerRedirectOnDeny"))

    @enable_referrer_redirect_on_deny.setter
    def enable_referrer_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ebbdd116a49bbea0d55da5167b790d2417832c0b9e03d3103606ef1b94fafc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionMode")
    def geo_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionMode"))

    @geo_protection_mode.setter
    def geo_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ea566d4294f15386138168f86c7eb3e33fe1ef6d8364b380b38889ffb596d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitle")
    def geo_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionTitle"))

    @geo_protection_title.setter
    def geo_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c1725216bb6a423a93b9de5fa866887adae1caf67f9ab1496f8bc8f95c2e3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrl")
    def geo_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoRedirectUrl"))

    @geo_redirect_url.setter
    def geo_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d08ee1e6ddc97981ace43ce59d7447425c1c9f19ba2ef517c8b3e5916d4ce0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="ipAddresses")
    def ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "ipAddresses"))

    @ip_addresses.setter
    def ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2a4d8be7ca3233ffd2efe2b6c07972ff4d1d7da2c4ab2cdcb00092e25dd573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionMode")
    def ip_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionMode"))

    @ip_protection_mode.setter
    def ip_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e31a684f4a3488cbef64acf5d8e896c32d91a7fc32a92cb1dcd5a3db0c9fd26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitle")
    def ip_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionTitle"))

    @ip_protection_title.setter
    def ip_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe56215b38c9a7ba5a9f443c356e0f3bbcda2d2279a5f8caf217e93642a0900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrl")
    def ip_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipRedirectUrl"))

    @ip_redirect_url.setter
    def ip_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44767bba17d4c359db4be69bfbd1482c0e5a6b3b23eee4a3d576d62bfde5ad28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677633214fb95b49fdaa187a0623068df1a763f3b41de60ba9630f097ba86278)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddresses")
    def override_ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "overrideIpAddresses"))

    @override_ip_addresses.setter
    def override_ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6218d6a3429072ac60932c49157f57b53e24a8e96b7ba3b57e511479c9fec743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideIpAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="referrerDomains")
    def referrer_domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "referrerDomains"))

    @referrer_domains.setter
    def referrer_domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1897ba7fabcbf8ba86129b875e582fdb97fbd06b7bf947129da63877a7178957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerDomains", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionMode")
    def referrer_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionMode"))

    @referrer_protection_mode.setter
    def referrer_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba13dc872702168999d297ca77cf3a70fa7c3e2a07fc02c648903027e6f0ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitle")
    def referrer_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionTitle"))

    @referrer_protection_title.setter
    def referrer_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f8cbefde56ec73d79c42df3971a7637a71b573fbee876d1b9d5bf8ee79333a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrl")
    def referrer_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerRedirectUrl"))

    @referrer_redirect_url.setter
    def referrer_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30ed5a329d5d7d1335a6df545d0644056ef3bcf4aab6c02cf8e83be71719978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a9c03a08138b57500cc79aadf4e866539d834f1f53818264224f13ec43c583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b195f48ce387aaa2bbc6d20a88d18e30d7347d32d1b3709d5712693f5b76769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c1e87fb7e752fb38edc5cd5c3a72e67d09bf63b55ebe08e8f3d5461963767c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24760c21ed8129fafffe3878cbfce0ca6637d4cba8682fa623b7b2ab5470673e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport",
    jsii_struct_bases=[],
    name_mapping={
        "allow_credentials": "allowCredentials",
        "allow_headers": "allowHeaders",
        "allow_origins": "allowOrigins",
        "enabled": "enabled",
        "expose_headers": "exposeHeaders",
        "headers": "headers",
        "locked": "locked",
        "methods": "methods",
        "origins": "origins",
        "preflight_max_age": "preflightMaxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport:
    def __init__(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9293c7213ae5d4c25e8da54275fb268bb12ff1110462c24646edc34a4eda507)
            check_type(argname="argument allow_credentials", value=allow_credentials, expected_type=type_hints["allow_credentials"])
            check_type(argname="argument allow_headers", value=allow_headers, expected_type=type_hints["allow_headers"])
            check_type(argname="argument allow_origins", value=allow_origins, expected_type=type_hints["allow_origins"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expose_headers", value=expose_headers, expected_type=type_hints["expose_headers"])
            check_type(argname="argument headers", value=headers, expected_type=type_hints["headers"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument methods", value=methods, expected_type=type_hints["methods"])
            check_type(argname="argument origins", value=origins, expected_type=type_hints["origins"])
            check_type(argname="argument preflight_max_age", value=preflight_max_age, expected_type=type_hints["preflight_max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_credentials is not None:
            self._values["allow_credentials"] = allow_credentials
        if allow_headers is not None:
            self._values["allow_headers"] = allow_headers
        if allow_origins is not None:
            self._values["allow_origins"] = allow_origins
        if enabled is not None:
            self._values["enabled"] = enabled
        if expose_headers is not None:
            self._values["expose_headers"] = expose_headers
        if headers is not None:
            self._values["headers"] = headers
        if locked is not None:
            self._values["locked"] = locked
        if methods is not None:
            self._values["methods"] = methods
        if origins is not None:
            self._values["origins"] = origins
        if preflight_max_age is not None:
            self._values["preflight_max_age"] = preflight_max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_credentials(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Accepts requests made using credentials, like cookies or TLS client certificates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        '''
        result = self._values.get("allow_credentials")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_headers(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, defines which headers to allow when making the actual request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        '''
        result = self._values.get("allow_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_origins(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, sets which origin hostnames to accept requests from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        '''
        result = self._values.get("allow_origins")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables CORS feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expose_headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''In responses to preflight requests, lists names of headers that clients can access.

        By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        '''
        result = self._values.get("expose_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the supported request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        '''
        result = self._values.get("headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def methods(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        '''
        result = self._values.get("methods")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origins(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin hostnames to accept requests from.

        The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        '''
        result = self._values.get("origins")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def preflight_max_age(self) -> typing.Optional[builtins.str]:
        '''Defines the number of seconds that the browser should cache the response to a preflight request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        '''
        result = self._values.get("preflight_max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033b516ecc3946d5443fee2feab89d3b5f9a87129d5080334ae6f02413c9175d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowCredentials")
    def reset_allow_credentials(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCredentials", []))

    @jsii.member(jsii_name="resetAllowHeaders")
    def reset_allow_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHeaders", []))

    @jsii.member(jsii_name="resetAllowOrigins")
    def reset_allow_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOrigins", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExposeHeaders")
    def reset_expose_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExposeHeaders", []))

    @jsii.member(jsii_name="resetHeaders")
    def reset_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaders", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethods")
    def reset_methods(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethods", []))

    @jsii.member(jsii_name="resetOrigins")
    def reset_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigins", []))

    @jsii.member(jsii_name="resetPreflightMaxAge")
    def reset_preflight_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreflightMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowCredentialsInput")
    def allow_credentials_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCredentialsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHeadersInput")
    def allow_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOriginsInput")
    def allow_origins_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="exposeHeadersInput")
    def expose_headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "exposeHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="headersInput")
    def headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headersInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodsInput")
    def methods_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "methodsInput"))

    @builtins.property
    @jsii.member(jsii_name="originsInput")
    def origins_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originsInput"))

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAgeInput")
    def preflight_max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preflightMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCredentials")
    def allow_credentials(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCredentials"))

    @allow_credentials.setter
    def allow_credentials(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d29acc0d9c4072b0c1f106fe98828236a2dceaddda044a34c714f567d73ca7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCredentials", value)

    @builtins.property
    @jsii.member(jsii_name="allowHeaders")
    def allow_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowHeaders"))

    @allow_headers.setter
    def allow_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b882d2232d3859bc6220e20ef233cf3e1dc7b0d483e0c2c6b8328ee24bfb6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="allowOrigins")
    def allow_origins(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowOrigins"))

    @allow_origins.setter
    def allow_origins(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2acc35212a3826e4b7c0c25d4c2bc6dea28f08380867d7b51c351d89b50521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOrigins", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5ce1282959a9ebec7b576e49d7aa76fce0b09fecd014f637c698c2582926e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="exposeHeaders")
    def expose_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "exposeHeaders"))

    @expose_headers.setter
    def expose_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57420cb3fc0c18cb59d69444c353dd58995d1b5f7c8381f788601bdd5e99ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exposeHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="headers")
    def headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headers"))

    @headers.setter
    def headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d8ca1d3b60964f0d9aab8f745e689bac2d759cd8dab515d6969ae7dabcb4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headers", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e389e191e4e02b40caaff545656f86ad0ba3077917c70d82e25742dc09663992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="methods")
    def methods(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "methods"))

    @methods.setter
    def methods(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c355550f74ca4e6f19a5c85ea1b28e11ec6080e54880115b235626bec78cf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "methods", value)

    @builtins.property
    @jsii.member(jsii_name="origins")
    def origins(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "origins"))

    @origins.setter
    def origins(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ee94123c34c0b29f02cfaf7786dec648aaf0ec2f31ee9c171706aa3eee362be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origins", value)

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAge")
    def preflight_max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preflightMaxAge"))

    @preflight_max_age.setter
    def preflight_max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404aa868e54419b60be8b20b2cbc7ed88493a6a442b8a03348408049367fb0e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preflightMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfca11dadfd98900f00b093da8527af401230b9fbdd2b86efbfb3eb9d452d73f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78c36164c1f8fc987c22f1bc942d789039272fbf17e88f33036c0cea2fd76f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc683beaf03952a95adde4d8c10ae54f832d8e462d6425df0f38547a590f97ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06255ffb281e7c4217f4539c25f22359e41a35b6f00bfe8f8e5779384011731d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d2f7b73b536422da6c150cef2fe37e1cfe74b7e44c8bfdd0451aa33b6fba07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2593164b819895ced9b1328406aec893a7fe9c2c142f0415af7c2b2dd5397630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adbce0941d350de7cd76cd09f17d476dd57fdf554a6cacabd955352dc735f944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec36786726815d1ea2bc4f1a66b8b99bfce99f58021a5964c35243e8f10882ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd62f382b811ce4836986aa93f340ea93f04ca78c6c0faa010166350efe16a60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baaa15c3097bcf393c546ff8e6382c075419045523edd71002144bcecef1c114)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cbb5697cbaba50748945b931e2675aee08da6b34e94e84fc475f608c535b977)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195a32bc170d2d19fdb0125eef6e7cfbea21b1d6232cb4db49f89f8cdda7e3c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3433ba9f16d08292ab1fa011051a660f263e41e4f1c4894a437a857200d0551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f785a27acc89a3c41fc79fba7fa4c393d528867b4e0cfd07fa0d7193a774f13d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126e007dcafae48f6d3fba804ef6c44bad6e691b9d7aacdee4eab035dee1641e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ea5e61b02fe6e3e12132afa3ea145446c5a008ece42476c8c2527dd32aaf06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac43d85028b67555d5ce043c07ec98c8768cc5c91dff3df14af1d881880a6c46)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d535439e4f9770ec873814059360b7cbb5a0971b918a133ddfebed46652ccbc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455a142b7fa68452a19eb1a013b273f941cec5d1d18b6598203be39fdca81f71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93515c158147e657d69919afa692d6680e252f079d335a5b16dbee5489421642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d27deaceec50b114f0a6034f79d0a88a62b8299f39ebcb7621c6a7257b13d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9abf6b450a59f8a92c36963d20e0af7193b3d666f8c3898fb45a9df8818bd0a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f189371893cc430a6a73b38087bae4cb4ab89b792fbda1bc8a73ac896e27291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior",
    jsii_struct_bases=[],
    name_mapping={
        "behavior_id": "behaviorId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior:
    def __init__(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9105e4a58110a08adfa5cdd0ea03084940b884875ac621facbb54ab3ec18cf98)
            check_type(argname="argument behavior_id", value=behavior_id, expected_type=type_hints["behavior_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior_id is not None:
            self._values["behavior_id"] = behavior_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior_id(self) -> typing.Optional[builtins.str]:
        '''The unique identifier for the predefined custom behavior you want to insert into the current rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        '''
        result = self._values.get("behavior_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5587ccb22965c2ff351912caf56b39f610a7ae4e1072570c6843030d3d6fbe56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehaviorId")
    def reset_behavior_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehaviorId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorIdInput")
    def behavior_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorId")
    def behavior_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behaviorId"))

    @behavior_id.setter
    def behavior_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40175841b48255014cc5b1c386d56f8e33c59c6d8a719428cd56d2e48922b311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behaviorId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b970ec1cab6b793b8b0705be774a51029accf4778889a33641960ce6ff47053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003f2ba97a9e30592af5e955a3bf3de5f0b03ae22b7f4d0c0fce785de36d4383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c211c4ed0c668b41ecd866348d152b31c9bda656ec0291b1ea4330f1135944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d751a6e68727df05af1c62665206bad2607ebe1f141116be1b1fbf9d84a3f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_stream_title": "beaconStreamTitle",
        "collect_midgress_traffic": "collectMidgressTraffic",
        "datastream_ids": "datastreamIds",
        "enabled": "enabled",
        "locked": "locked",
        "log_enabled": "logEnabled",
        "log_stream_name": "logStreamName",
        "log_stream_title": "logStreamTitle",
        "sampling_percentage": "samplingPercentage",
        "stream_type": "streamType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream:
    def __init__(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2181af5371a36d476b2cc8af8af23f7c0557eb71f516afd742dd05cabc2e5971)
            check_type(argname="argument beacon_stream_title", value=beacon_stream_title, expected_type=type_hints["beacon_stream_title"])
            check_type(argname="argument collect_midgress_traffic", value=collect_midgress_traffic, expected_type=type_hints["collect_midgress_traffic"])
            check_type(argname="argument datastream_ids", value=datastream_ids, expected_type=type_hints["datastream_ids"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_enabled", value=log_enabled, expected_type=type_hints["log_enabled"])
            check_type(argname="argument log_stream_name", value=log_stream_name, expected_type=type_hints["log_stream_name"])
            check_type(argname="argument log_stream_title", value=log_stream_title, expected_type=type_hints["log_stream_title"])
            check_type(argname="argument sampling_percentage", value=sampling_percentage, expected_type=type_hints["sampling_percentage"])
            check_type(argname="argument stream_type", value=stream_type, expected_type=type_hints["stream_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_stream_title is not None:
            self._values["beacon_stream_title"] = beacon_stream_title
        if collect_midgress_traffic is not None:
            self._values["collect_midgress_traffic"] = collect_midgress_traffic
        if datastream_ids is not None:
            self._values["datastream_ids"] = datastream_ids
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if log_enabled is not None:
            self._values["log_enabled"] = log_enabled
        if log_stream_name is not None:
            self._values["log_stream_name"] = log_stream_name
        if log_stream_title is not None:
            self._values["log_stream_title"] = log_stream_title
        if sampling_percentage is not None:
            self._values["sampling_percentage"] = sampling_percentage
        if stream_type is not None:
            self._values["stream_type"] = stream_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        '''
        result = self._values.get("beacon_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def collect_midgress_traffic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        '''
        result = self._values.get("collect_midgress_traffic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def datastream_ids(self) -> typing.Optional[builtins.str]:
        '''A set of dash-separated DataStream ID values to limit the scope of reported data.

        By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        '''
        result = self._values.get("datastream_ids")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables DataStream reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables log collection for the property by associating it with DataStream configurations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        '''
        result = self._values.get("log_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_stream_name(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the unique IDs of streams configured for the property.

        For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        '''
        result = self._values.get("log_stream_name")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def log_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        '''
        result = self._values.get("log_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of log data you want to collect for this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        '''
        result = self._values.get("sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def stream_type(self) -> typing.Optional[builtins.str]:
        '''Specify the DataStream type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        '''
        result = self._values.get("stream_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastreamOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastreamOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfaad48532fee09d8a09b978f2fdf0b7c2dd0311058049ee9da317e97ad3057)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconStreamTitle")
    def reset_beacon_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconStreamTitle", []))

    @jsii.member(jsii_name="resetCollectMidgressTraffic")
    def reset_collect_midgress_traffic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCollectMidgressTraffic", []))

    @jsii.member(jsii_name="resetDatastreamIds")
    def reset_datastream_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastreamIds", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogEnabled")
    def reset_log_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEnabled", []))

    @jsii.member(jsii_name="resetLogStreamName")
    def reset_log_stream_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamName", []))

    @jsii.member(jsii_name="resetLogStreamTitle")
    def reset_log_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamTitle", []))

    @jsii.member(jsii_name="resetSamplingPercentage")
    def reset_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingPercentage", []))

    @jsii.member(jsii_name="resetStreamType")
    def reset_stream_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStreamType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitleInput")
    def beacon_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTrafficInput")
    def collect_midgress_traffic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "collectMidgressTrafficInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamIdsInput")
    def datastream_ids_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datastreamIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logEnabledInput")
    def log_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamNameInput")
    def log_stream_name_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "logStreamNameInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamTitleInput")
    def log_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingPercentageInput")
    def sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "samplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="streamTypeInput")
    def stream_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "streamTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitle")
    def beacon_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconStreamTitle"))

    @beacon_stream_title.setter
    def beacon_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8db3e0ba1a40e7ad071dceb991c7a6c9851d5512e83ae0cd8f7755259e07ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTraffic")
    def collect_midgress_traffic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "collectMidgressTraffic"))

    @collect_midgress_traffic.setter
    def collect_midgress_traffic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__768993dd6a11af6dd345b494ba1e9ef5c5538150d4e4435eed4df36a7636a021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "collectMidgressTraffic", value)

    @builtins.property
    @jsii.member(jsii_name="datastreamIds")
    def datastream_ids(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "datastreamIds"))

    @datastream_ids.setter
    def datastream_ids(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f48903dda5d2041d89f61256606033976e77620e4704a3f82c40d7de196a7b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "datastreamIds", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a6fc8507d557344534a7f60d07a684961a4896d2156b1484a40aa7ad5708bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6706a38afd88e4f7653ef8eb7b4805f7877cfecc680b9c650b85fea57ae0ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logEnabled")
    def log_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEnabled"))

    @log_enabled.setter
    def log_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746931d0d19031cf6af995bda40d88fcb93bb70bea5fdc24e58548ec1e1192b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamName")
    def log_stream_name(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "logStreamName"))

    @log_stream_name.setter
    def log_stream_name(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ff58e638d2132404881a2044afa17938483f86fc725af389b6ec0d3a4cc1d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamName", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamTitle")
    def log_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logStreamTitle"))

    @log_stream_title.setter
    def log_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16bb18842e003c7cc882848eb49cd636419f45daa4311fa7db11267ebbac28f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="samplingPercentage")
    def sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "samplingPercentage"))

    @sampling_percentage.setter
    def sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__886ef5effffbda1592e9404ef0cea6aba4919b4bd7fd82ff952fef13f9779291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="streamType")
    def stream_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "streamType"))

    @stream_type.setter
    def stream_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcf013b4af9b9ba89324c31126db32085522e9f60b18b042590c44a5a61067da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "streamType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2f122607b5b714dc0c6c8ece931fec5e146d19150402baef1bff50c687b0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bdd615cd79d1286f3360a545c37f9a4eedc8072933e5a1af8ee8a672361bde2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c603f86a7efd4effd7fec8595dce6921f821834657c51ac17a1effe58b33db7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous": "anonymous",
        "enabled": "enabled",
        "gwenabled": "gwenabled",
        "locked": "locked",
        "namespace_id": "namespaceId",
        "template_uuid": "templateUuid",
        "tlsenabled": "tlsenabled",
        "uuid": "uuid",
        "wsenabled": "wsenabled",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp:
    def __init__(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8c22fc33ff04a093093a939f787ed98d2bcc0618e9cc7f0261357bc16b17ba)
            check_type(argname="argument anonymous", value=anonymous, expected_type=type_hints["anonymous"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument gwenabled", value=gwenabled, expected_type=type_hints["gwenabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_id", value=namespace_id, expected_type=type_hints["namespace_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tlsenabled", value=tlsenabled, expected_type=type_hints["tlsenabled"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument wsenabled", value=wsenabled, expected_type=type_hints["wsenabled"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous is not None:
            self._values["anonymous"] = anonymous
        if enabled is not None:
            self._values["enabled"] = enabled
        if gwenabled is not None:
            self._values["gwenabled"] = gwenabled
        if locked is not None:
            self._values["locked"] = locked
        if namespace_id is not None:
            self._values["namespace_id"] = namespace_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tlsenabled is not None:
            self._values["tlsenabled"] = tlsenabled
        if uuid is not None:
            self._values["uuid"] = uuid
        if wsenabled is not None:
            self._values["wsenabled"] = wsenabled

    @builtins.property
    def anonymous(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        '''
        result = self._values.get("anonymous")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables IoT Edge Connect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def gwenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured HTTP connection on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        '''
        result = self._values.get("gwenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the globally reserved name for a specific configuration.

        It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration.  You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        '''
        result = self._values.get("namespace_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tlsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured MQTT connection on port 8883.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        '''
        result = self._values.get("tlsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def wsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        result = self._values.get("wsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "hash_conversion_algorithm": "hashConversionAlgorithm",
        "hash_conversion_key": "hashConversionKey",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation:
    def __init__(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73435f32d953550a965eb6474231cfe4f03ca3ba1ee1fc362fd98eafd1017c99)
            check_type(argname="argument hash_conversion_algorithm", value=hash_conversion_algorithm, expected_type=type_hints["hash_conversion_algorithm"])
            check_type(argname="argument hash_conversion_key", value=hash_conversion_key, expected_type=type_hints["hash_conversion_key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hash_conversion_algorithm is not None:
            self._values["hash_conversion_algorithm"] = hash_conversion_algorithm
        if hash_conversion_key is not None:
            self._values["hash_conversion_key"] = hash_conversion_key
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def hash_conversion_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        '''
        result = self._values.get("hash_conversion_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_conversion_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the key to generate the hash, ideally a long random string to ensure adequate security.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        '''
        result = self._values.get("hash_conversion_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e1a48f4a50f69e111fe097f9ebaa239ed969fbcda1df71a6a15f1bb08de278)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHashConversionAlgorithm")
    def reset_hash_conversion_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionAlgorithm", []))

    @jsii.member(jsii_name="resetHashConversionKey")
    def reset_hash_conversion_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithmInput")
    def hash_conversion_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionKeyInput")
    def hash_conversion_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithm")
    def hash_conversion_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionAlgorithm"))

    @hash_conversion_algorithm.setter
    def hash_conversion_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e597c89ddcf81bf201a6d4e8ebf1cf650b36e2109e7071af7da651ccb736c168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hashConversionKey")
    def hash_conversion_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionKey"))

    @hash_conversion_key.setter
    def hash_conversion_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a06a0da26aafc752c0076c76bb2368be2f2a194b17b65999e863799fb33725a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionKey", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93aa0c4af68804ab0348c052128e9ec566c1433b32d4972bf13ce8449b269731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02c0c39b1ac75a2e69c100d9de1bf8c9447b23469e26ad9fcaefbf41699e7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__850a075b0bb766b1563f979d36b0850841c293a894c013316449ce23d6bd5a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__193394a6234732dc6f869b84c1b18087f93f27a308e1729d9ae3db16cb54fa11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b4db3654f8b481d934e5a47142a735221c70742b7a91fb07217e8fc0a27ef3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with a single grouping to capture the text.

        For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cfaa6010f20b37b1ab8836ca3142907ba07cc072730138a2d5686456b94a2a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0cf7092b99097df518b63ea2a11e482e1e57f07f902fac2d500ea8f88baaeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79d01cb60459c295d3e430aabe75b86dd6defc02d7de49d0237dc368bc5fd74b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a525a186c428ac5139d24b1f6def7835ef1c9326bc229560db07721182edcdc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84db459b8c250f2c83efc6204e868dd54172dc02103db93cd4275b16f1ed0818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17dd2b55ee9b4e1c733398318f8a8d31ba8c9e9fb72abac2a08c069e3a563d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "substring_end": "substringEnd",
        "substring_start": "substringStart",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4b40a643aba5b870fe8f2baa3891d55b478ecf4f2703205f463d758c62b8f2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument substring_end", value=substring_end, expected_type=type_hints["substring_end"])
            check_type(argname="argument substring_start", value=substring_start, expected_type=type_hints["substring_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if substring_end is not None:
            self._values["substring_end"] = substring_end
        if substring_start is not None:
            self._values["substring_start"] = substring_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def substring_end(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        '''
        result = self._values.get("substring_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def substring_start(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the first character to extract.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        '''
        result = self._values.get("substring_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a766413597535c720abc33f6df0123bcb09ea285ee27b0226b9a15adb37184a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSubstringEnd")
    def reset_substring_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringEnd", []))

    @jsii.member(jsii_name="resetSubstringStart")
    def reset_substring_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="substringEndInput")
    def substring_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringEndInput"))

    @builtins.property
    @jsii.member(jsii_name="substringStartInput")
    def substring_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e80377711819070b3f4ffbdb7185d2ffe0ea2122ae81526cfc06f306eb895c02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="substringEnd")
    def substring_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringEnd"))

    @substring_end.setter
    def substring_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc090c1a202b58c274d0f3c56fb7b80ae64e6656ad6101922af9d262f7101f0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringEnd", value)

    @builtins.property
    @jsii.member(jsii_name="substringStart")
    def substring_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringStart"))

    @substring_start.setter
    def substring_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159bfad31ea0b2ec1d905c5d933272e77c4f609aba07414cc9c89edf1230d6c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd31d3209a339c953cac0aa14efe77c4bdd9352009799ca344e348a0aea9801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7eabf159f339f48e20d8d7fae5046c4c517afdf7d02b3cae4cd42c1b23e2c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb64780efe3aca4cef88c8e6de4273cc39a258a83de57a3db316adff9a83412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_field": "certificateField",
        "dcp_mutual_auth_processing_variable_id": "dcpMutualAuthProcessingVariableId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor:
    def __init__(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b16448a0f3922038f2a270b64cd80523ea87260ddfddd5b82cf2cba5ab51917d)
            check_type(argname="argument certificate_field", value=certificate_field, expected_type=type_hints["certificate_field"])
            check_type(argname="argument dcp_mutual_auth_processing_variable_id", value=dcp_mutual_auth_processing_variable_id, expected_type=type_hints["dcp_mutual_auth_processing_variable_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_field is not None:
            self._values["certificate_field"] = certificate_field
        if dcp_mutual_auth_processing_variable_id is not None:
            self._values["dcp_mutual_auth_processing_variable_id"] = dcp_mutual_auth_processing_variable_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_field(self) -> typing.Optional[builtins.str]:
        '''Specifies the field in the client certificate to extract the variable from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        '''
        result = self._values.get("certificate_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dcp_mutual_auth_processing_variable_id(self) -> typing.Optional[builtins.str]:
        '''Where to store the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        '''
        result = self._values.get("dcp_mutual_auth_processing_variable_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13971598db9d10aea11a49589c941b1253d100330ce7114e5911d60615c9878a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateField")
    def reset_certificate_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateField", []))

    @jsii.member(jsii_name="resetDcpMutualAuthProcessingVariableId")
    def reset_dcp_mutual_auth_processing_variable_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpMutualAuthProcessingVariableId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldInput")
    def certificate_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableIdInput")
    def dcp_mutual_auth_processing_variable_id_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dcpMutualAuthProcessingVariableIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateField")
    def certificate_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateField"))

    @certificate_field.setter
    def certificate_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ef53706e9037c4b3cb5bf1e18d0b3d0482ffdb0a4eb9d4ba011f8ec8db2fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateField", value)

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableId")
    def dcp_mutual_auth_processing_variable_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dcpMutualAuthProcessingVariableId"))

    @dcp_mutual_auth_processing_variable_id.setter
    def dcp_mutual_auth_processing_variable_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb6f72109b1264f05b454ed275775e75802dd82ed331526f4599667d3d3d4e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dcpMutualAuthProcessingVariableId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8bb7962568ef3ee7c389868ac948bfe8aa7fc41f92a8dd50f7a720609000c7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb28256f7a447e42f0b370d227aa9792e7501e2cbb02355fe446a0ef1e3b8c84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc45aadfbc7f99b5d41e602de4ff3672ab3a0c347116490a92d9d74978142be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad14cca93852e80ccbb318b37f4065d05f76097d3fdf8cbb0aecd5c751514a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups",
    jsii_struct_bases=[],
    name_mapping={
        "group_names": "groupNames",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups:
    def __init__(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3255e0cfa13ce8651f636f4cb602939957e214121b868c994d838bf09a2e3fd3)
            check_type(argname="argument group_names", value=group_names, expected_type=type_hints["group_names"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if group_names is not None:
            self._values["group_names"] = group_names
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def group_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of authorization groups to assign to all connecting devices.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        '''
        result = self._values.get("group_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba5993f61ceb63b60ae2293b992e4db56a80de8828faaea3dd587898ca98395a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetGroupNames")
    def reset_group_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGroupNames", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="groupNamesInput")
    def group_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "groupNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="groupNames")
    def group_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "groupNames"))

    @group_names.setter
    def group_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95a68b248a65d5865597c1462f90a634ad90d7534a3b28a790ada124f937c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "groupNames", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748a0cb11fa2500755c38cee46f8230e5ae2fbd9e8f353671afff4c1c2ed6fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59edcd5179ac034320e7ed789970809b9b75d21e22cc1270cf5e5791a6c7dd89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90f83be9b21f07632a4c5a558a0fff3f988234ccf09969f4b5cfc30882b8e289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d499069c612ca8647d89a5fa45c2f326361c4880f4859557a0423ffc55f8eeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations",
    jsii_struct_bases=[],
    name_mapping={
        "custom_values": "customValues",
        "enabled": "enabled",
        "hostname": "hostname",
        "locked": "locked",
        "path": "path",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations:
    def __init__(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70a5e67ffd2336b462b87a44090ef723b46a039b59df62be4bd17a3f5c2749a1)
            check_type(argname="argument custom_values", value=custom_values, expected_type=type_hints["custom_values"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_values is not None:
            self._values["custom_values"] = custom_values
        if enabled is not None:
            self._values["enabled"] = enabled
        if hostname is not None:
            self._values["hostname"] = hostname
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_values(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify custom JWT server connection values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        '''
        result = self._values.get("custom_values")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the default JWT server and sets the authentication endpoint to a default path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the JWT server's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e53b7a148005c61f0375e73fd2a79f1d91c63f591d2d6c2a521ffbb02378bfc2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomValues")
    def reset_custom_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValues", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customValuesInput")
    def custom_values_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customValues")
    def custom_values(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customValues"))

    @custom_values.setter
    def custom_values(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6faa76e425f578577ef9a6ebca6eb9b9fd070768fd1b50bca6f9ebbfc02718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValues", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a571584e6462d214f8354493993bc9a3cd1b54ea8b0fcf441d74174a0525b767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e807e97ec2ef04502a5e11c46083ccd45714a94db70b0c8715a7427d36e0c58f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cd92a86e56934a36d51ca27e34f39fa2136a8e93172c3d2bc8c5cd2abf718c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2286604175c40720b57ddd26bdda7503848b59064a97d6a3c0fa99ea8d116978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9b5eb2719c829879f0f55f665d6130aab39eb1eb334c95d9e28eb3ba77d0ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f790e0ef789c7ce3be558b4ed0ed60f3b4b7695cebbe261c81eac6ae07d106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f5db69a60f84c90413944a2ce1abf85bcfa74f7102d1cfd052cd8607f666ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1a5d521cec21d97bc1f73acc24fe64332bb030703421921a763c6f129967e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymous")
    def reset_anonymous(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymous", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGwenabled")
    def reset_gwenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGwenabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceId")
    def reset_namespace_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTlsenabled")
    def reset_tlsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsenabled", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWsenabled")
    def reset_wsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWsenabled", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousInput")
    def anonymous_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "anonymousInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="gwenabledInput")
    def gwenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "gwenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceIdInput")
    def namespace_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsenabledInput")
    def tlsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tlsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="wsenabledInput")
    def wsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "wsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymous")
    def anonymous(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "anonymous"))

    @anonymous.setter
    def anonymous(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8930332b5439ed5c34a5e534b4f6285df3d99c14b44efd7be13ff8ea5d5a8744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymous", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27066fb5c3ffe4474eb55be153bbaf9604b7926cdb991a0671ed318efbf7bc8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="gwenabled")
    def gwenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "gwenabled"))

    @gwenabled.setter
    def gwenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b1b17a49d1d1599095e4429a6481f757e0837e45f264ab0fd85d89b756337e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gwenabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92cb78e7e17fc4c1f046e5c4f1f74bd52f966a130bad21981460785ec771bfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceId")
    def namespace_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceId"))

    @namespace_id.setter
    def namespace_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853a585ea8c9cc50ef8d9a0f876f4f272f372f27200b1489b2d74ecde6fce27e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59da73a766f47e47c8480f0ebd902d7f33bc9c045a7eeea4766861a93cd4d507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tlsenabled")
    def tlsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tlsenabled"))

    @tlsenabled.setter
    def tlsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff3b3a25fe137262d73dbfbc0e47c79d174bd5306902fa80e2957d6be06003e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa19618e49ea049f6a7e090848c1ac3702c14790749ccc6d27572fd89342c73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="wsenabled")
    def wsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "wsenabled"))

    @wsenabled.setter
    def wsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba225be657e1d739e11dfd521d2b32754cee4055aff544ceae236d605aa9fe26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0420ec5ee08cbb07eac99b469203cad4b3dd63b3a10883a65fafe56c66c2b55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth",
    jsii_struct_bases=[],
    name_mapping={
        "extract_hostname": "extractHostname",
        "extract_jurisdiction": "extractJurisdiction",
        "extract_namespace": "extractNamespace",
        "hostname_claim": "hostnameClaim",
        "jurisdiction_claim": "jurisdictionClaim",
        "locked": "locked",
        "namespace_claim": "namespaceClaim",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth:
    def __init__(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48645868cea5981e21389d35ef649475edb2ef2accbaf1ab43a52e0f00ea9a0c)
            check_type(argname="argument extract_hostname", value=extract_hostname, expected_type=type_hints["extract_hostname"])
            check_type(argname="argument extract_jurisdiction", value=extract_jurisdiction, expected_type=type_hints["extract_jurisdiction"])
            check_type(argname="argument extract_namespace", value=extract_namespace, expected_type=type_hints["extract_namespace"])
            check_type(argname="argument hostname_claim", value=hostname_claim, expected_type=type_hints["hostname_claim"])
            check_type(argname="argument jurisdiction_claim", value=jurisdiction_claim, expected_type=type_hints["jurisdiction_claim"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_claim", value=namespace_claim, expected_type=type_hints["namespace_claim"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if extract_hostname is not None:
            self._values["extract_hostname"] = extract_hostname
        if extract_jurisdiction is not None:
            self._values["extract_jurisdiction"] = extract_jurisdiction
        if extract_namespace is not None:
            self._values["extract_namespace"] = extract_namespace
        if hostname_claim is not None:
            self._values["hostname_claim"] = hostname_claim
        if jurisdiction_claim is not None:
            self._values["jurisdiction_claim"] = jurisdiction_claim
        if locked is not None:
            self._values["locked"] = locked
        if namespace_claim is not None:
            self._values["namespace_claim"] = namespace_claim
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def extract_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a hostname from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        '''
        result = self._values.get("extract_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_jurisdiction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a jurisdiction that defines a geographically distributed set of servers from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        '''
        result = self._values.get("extract_jurisdiction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_namespace(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a namespace from JSON web tokens (JWT).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        '''
        result = self._values.get("extract_namespace")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the hostname from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        '''
        result = self._values.get("hostname_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jurisdiction_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the jurisdiction from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        '''
        result = self._values.get("jurisdiction_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the namespace from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        '''
        result = self._values.get("namespace_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f756da662c036c345d2eb2a430ce26556acbd95a9599b3f79f213e1f633b5cc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExtractHostname")
    def reset_extract_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractHostname", []))

    @jsii.member(jsii_name="resetExtractJurisdiction")
    def reset_extract_jurisdiction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractJurisdiction", []))

    @jsii.member(jsii_name="resetExtractNamespace")
    def reset_extract_namespace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractNamespace", []))

    @jsii.member(jsii_name="resetHostnameClaim")
    def reset_hostname_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameClaim", []))

    @jsii.member(jsii_name="resetJurisdictionClaim")
    def reset_jurisdiction_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJurisdictionClaim", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceClaim")
    def reset_namespace_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceClaim", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="extractHostnameInput")
    def extract_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="extractJurisdictionInput")
    def extract_jurisdiction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractJurisdictionInput"))

    @builtins.property
    @jsii.member(jsii_name="extractNamespaceInput")
    def extract_namespace_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractNamespaceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameClaimInput")
    def hostname_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaimInput")
    def jurisdiction_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jurisdictionClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceClaimInput")
    def namespace_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="extractHostname")
    def extract_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractHostname"))

    @extract_hostname.setter
    def extract_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65727a3cc7580b54965067a42c3b9742abfe6c6e38eedb0f74d9f10482e56de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractHostname", value)

    @builtins.property
    @jsii.member(jsii_name="extractJurisdiction")
    def extract_jurisdiction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractJurisdiction"))

    @extract_jurisdiction.setter
    def extract_jurisdiction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8588a43fc4fb659806c48a846bfc5bee6554ce1330399cde52c9b6d2190993bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractJurisdiction", value)

    @builtins.property
    @jsii.member(jsii_name="extractNamespace")
    def extract_namespace(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractNamespace"))

    @extract_namespace.setter
    def extract_namespace(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b698cccfcf875b30c2b4c0ebfe89efa6aae674327051249966c39d4e87c6d0a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractNamespace", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameClaim")
    def hostname_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostnameClaim"))

    @hostname_claim.setter
    def hostname_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a88ec3a9ff3e3463a6dce81a9606dac7da3a3ed5ded351a39664bc098c30e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameClaim", value)

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaim")
    def jurisdiction_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jurisdictionClaim"))

    @jurisdiction_claim.setter
    def jurisdiction_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca882047fac245f8880d356a0c6738291be021674c1c89b59bec6833b57e0d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jurisdictionClaim", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468e23e84300bd7b47021fcbfa868cc07bc58ae24e45e2e9b47443f9c9c71853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceClaim")
    def namespace_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceClaim"))

    @namespace_claim.setter
    def namespace_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f4f739dc784b914f786c3fcfb373acefc472805c84c84baa20f58557a52b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceClaim", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7adc54c597f4a226b33fc96ef6fcca67b466eec1895bd68091bed7d3d79913ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac604737c84b238766e251dbc8fe2b503f1f32b7b3ae120519011a9a4c8babb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36043f16e4976eabd4c68a71314bd4b3d79dcd26dcc8db0dfdb736467f806b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189bf52cbc8a58c36753f0a5f08ee6b5f4dced180f3095442f9e4a2ef75d88aa)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05fc1373674b236282f1e139a7d2d991eb7ece0fa9248464d456bf70afbc096d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92c0db1b4a2c6de54600f45eefdd120057356ffde5d73cdf70edbe74b8de564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d73e0b397209fd12583ad836ff3f408f2f623f766e81377fd8ce8166a6f41c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337703a66ab12c601764eda050b94246df69a02b941028e60ae6e6c59144d518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6258fb40bab447375286ca1a3bacb02aa3b3aabaa7152a3c4a37fd90d7f7dfb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cbdccd611d7efa6f8ae2d330c2723d373506b1089e611efc7747f29883ea83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "reason": "reason",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0136ae377af17b93f755f1e5e479a3633baaad5dfbd7b2194b64055a006ba47)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reason", value=reason, expected_type=type_hints["reason"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if reason is not None:
            self._values["reason"] = reason
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies access when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reason(self) -> typing.Optional[builtins.str]:
        '''Text message that keys why access is denied.

        Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        '''
        result = self._values.get("reason")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c6c839e56b77866d279ec72147bd83b0ab15ddeff6eae2670424d3210696ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReason")
    def reset_reason(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReason", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reasonInput")
    def reason_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reasonInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32b0afd4628922ea970dabc581e51b82e975b378945adbf2ab6a194e8cc13d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62cccc9035b7688573933d34f56eb653d7c44a9cc816d5d89455324b40e11c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reason")
    def reason(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reason"))

    @reason.setter
    def reason(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd29c25596cab2f0527f309bef95140f91f235eac9ef579c2b157602699e902d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reason", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54756a6aa5cace575c809369cc44b2bb0ca366102d3631a9dd5d5d9eddb2ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__569e214a02b7984e259702d75ba27f9869c1c187a35a827321bcde6a55903e11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5306bd4fc23dcb0894a9d09d65507cb392aee85e0c48a3d37b713078db7777a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf8744210ae6804fdbe426c949d62cbfb3ecd97cc70844fbb3e3fb5f4ddcda08)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc77aa80df984ab18406cef2a3d450098924b78ad098ff45a7c8d1cbd60fa289)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed473bd605d4ad13c16d71b70ef7949ec8f967f593ef57213a59f1c9404a608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9cafe1315ba6c2f932133444834f6a7c936da2ac125380d56259bc7c9389e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5bc964a63efe97ba6b945e542d155f1f1679ccf6ddb3f5c950dc81549eba01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc22ee1795126c1f4c8029b1df0ba41f77d2c42f4e58e589690ccaffd0ff0d83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__834ef60900daac42bc69d614f96731b76965de7b7083eef22b5d0ac051a33a3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7009ed23898ce1f11dbccf25420d8978439a7e985edb2003059081629d4a0054)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of information about the device with which to generate a separate cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b265b713809143bb6cb0a19e45b774b8c58b0174a62147783d855adb9553f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18c4d3d40e4a4c88fd2fe7ed980b480ed234a8ec695dc5ae2a094a46151ee2fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76735a35aa089dab39f82ecd04df46032ea904b7f982e9d5ed8c5a62d54a91e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67791ea6435674eb09f2ce9a0bfff17c35745d49241daa376329f80c4a5e96e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6406bdc55006e9b9209ac97f34dc93c454efb7ff13e59023d9cb39fb2a811f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ff3354f33eac4d4cb5b1cc5354322d6e07acc4b8361e2461eee1856de34532)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78ae567a63cb787eb42614ac6cc4a8cd72a06b7605198bdaba3b8a0a88b28e6b)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of information about the requesting device to send to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14feb98791b84e0ceb038f327bc198b14db89c3540f89304395a57c6d18a45cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069b690c1f185425f75e037555b7c47ab4023ff00db4c1c638c19175b408cc18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757d4eefbe644df6355a5d8cc85086215423f5ba2c674df42f64b88c19e743ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0346079043a4b7bcbf44fc686fd9bc9d5e8eaaf346d60d18fdb88850b39a86d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b361957096552f05d9c14934d7f3f99fc31b3b1ad54184a690e96559d34b82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cce5e52b92aecd1fcd8ef03c7be49bc844b7953f82c547b5578fd9de21598d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9437dc543a188f08e7d96926fdba90c94da569ec8cfb5ee07bf566c1b2f715cb)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh an expired DNS record after serving content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Set the maximum allowed time an expired DNS record may be active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee486af41cc4d05531d0c0942f91c126500e3a18c9c5d55f6de3073ce85d0bae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9974ea3f484a652e3c1482e5bb698b788e525bcca40c141daf9e247076c8c779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b730e74b7993afd9657696cd02b78b72feacdc24927b0f4fdb24780ff3ddbf18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e874c6b28141b41cb1fab03762d02a8eb33ecab042296dd117af2e512fa2e74c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b6d3cb6d0116701717703f7efb7183aab25205cb0a9393c51e5bbd26db588c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dcdcb734620d65e2dae6aa41267d0e074d20af35e18f5982bf94256a103926d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__637f5be045f155a6d03cf68fe98f0f282746f2d719be545779a59d2afd178eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh",
    jsii_struct_bases=[],
    name_mapping={
        "delay": "delay",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh:
    def __init__(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c725def29a5ae80bef1c53783be5e0b2985648e8ee468b42b2239e5a6517be)
            check_type(argname="argument delay", value=delay, expected_type=type_hints["delay"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if delay is not None:
            self._values["delay"] = delay
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def delay(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        '''
        result = self._values.get("delay")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh DNS records before they expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee40091d36c97b4e8d339b13fddf204a65c7e059d0d404f0aacc42a158c9b505)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDelay")
    def reset_delay(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDelay", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="delayInput")
    def delay_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "delayInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="delay")
    def delay(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "delay"))

    @delay.setter
    def delay(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a705c04d68e61413a0e97bf653311594f5eafa0861222a73534dcdcc0ab377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "delay", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3d445e8bb2dd4a9aa5e17f5a3190a1e866c645424162384488aeb820a6f72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b062b161404c27404823591dd3e21aaab85b1c561793f25b623167be7dfe55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae75b01cefeab6f3c3668b5c80c64436cd84cb7f3a3099a87c0f5a616c919fc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec91d8902d36140ba90d31732f5bd04acc475d82a27d6b428d9ad9c534591425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81e2c3e7db06be64aeb7e9df906bfa071c7fee3170dbffddff56a66b829e9025)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4c8d830ce45073d4e76f71536462e787ae1ac0ede4ac6e5c3ff9b78bff24c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24eb310f4973935e2081dd100eb112b9d5d6ab63105f2a79fa272be3a2562582)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the protocol downgrading behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf15e9a10f5aa9c355c617f3e3a2442c1343809f640c8b12a330123f77a6b9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da8e8c2f02c834bc329b55128bbb3001c2119aebf79cc5293a9a8d43db990e5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162b79452777fd53b52529fc234cd15588f1a35a0f6b0171844d0e3ae77ba2d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__debf2560792e5c4e6a6b164028716cc7fb37d0a2d2a922dc0aad02b44bfee9ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8502b5b3a8dc3b40caf25780de22f19b4feb183fe982fbc58b98ccb77434f5ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9056f41b6b4c1b826575d292658fa69ad28a26f250adac1314734388af1a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7981740684ec6625bff0637d7e4e51fa3bb83912b567ad42806ec74c9f159f95)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbb333c8ac1d2b242575bfbc78e5e0b6dd09f47962177ebf04390c1cfbc45808)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__553bcac8acd036f98256d9a74fc0de386726cb61485e5d07f254e336e7f98bbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ec086afb9dc1dc3d412b2205780e609c0c80292ea2034e98519a8b69701f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f68c68be8bb118522e7e490fd86b075d524c66d6eb247649d99b7484693a106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e7f2026950dcbec718b584e659c0206b0dd498fa3299671d9b86a25deefbd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58292de14b21acc8d3ec61774d65264ef7643cc607c2ea40565ef14d578d8dd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fea26b71674d9db135d363900cbd6d05ec1a52b379f596c2c4751c98114fa6)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035040aea5133c82041f95f831d2333a8112de9f1d1b166802ae327c2d81dc9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28200c9c8e28f79504a7feec7102bcca4374713eed2eef80123b52f8b9c51e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226c33badee826c0852f6ae459743a541d2e79a446c6f547f7c84d86cfb2d91d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fdb26cd8e368036667160c884f39f710aabf1f6f7b6848e6c2cde62ad3c79a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b0e3b5a6f0821088c94d0d08476bf81bc20273bc2f8338792f58164b20c312a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e7f171dd67667d0e4e2502f7ef4ecabb1c98b05eb3e97192697444277a02f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache",
    jsii_struct_bases=[],
    name_mapping={
        "allow_behavior": "allowBehavior",
        "behavior": "behavior",
        "locked": "locked",
        "send_headers": "sendHeaders",
        "send_private": "sendPrivate",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache:
    def __init__(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db40ff05f26c179571b875dbe552ad3d490c7ce47268f36507ea67873372b9ec)
            check_type(argname="argument allow_behavior", value=allow_behavior, expected_type=type_hints["allow_behavior"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument send_headers", value=send_headers, expected_type=type_hints["send_headers"])
            check_type(argname="argument send_private", value=send_private, expected_type=type_hints["send_private"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_behavior is not None:
            self._values["allow_behavior"] = allow_behavior
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if send_headers is not None:
            self._values["send_headers"] = send_headers
        if send_private is not None:
            self._values["send_private"] = send_private
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_behavior(self) -> typing.Optional[builtins.str]:
        '''Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        '''
        result = self._values.get("allow_behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching instructions the edge server sends to the end user's client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def send_headers(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP headers to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        '''
        result = self._values.get("send_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def send_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        '''
        result = self._values.get("send_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069557d45b50a66e9a4505450d4b092e22f9b2bb17164670d6a3b9d9bcc27388)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBehavior")
    def reset_allow_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBehavior", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSendHeaders")
    def reset_send_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendHeaders", []))

    @jsii.member(jsii_name="resetSendPrivate")
    def reset_send_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendPrivate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBehaviorInput")
    def allow_behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sendHeadersInput")
    def send_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sendHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="sendPrivateInput")
    def send_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sendPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBehavior")
    def allow_behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowBehavior"))

    @allow_behavior.setter
    def allow_behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e052788fef9bcc123b5380c157b01d5bc887ba4b00d5f36f896c31da1031430d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBehavior", value)

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fa00788076d54dc8524db3910355d99ce478a5ea55a64704e2c2cb4c0f46f17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69145103567a676083fcc00a48fe552649b0ad4fba79f4f2b1b0b6bce0ca0c54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sendHeaders")
    def send_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sendHeaders"))

    @send_headers.setter
    def send_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19c565a79c26bcf8e0f2bdd292579b3603490f58258e35dfb4f603dd891ea54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="sendPrivate")
    def send_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sendPrivate"))

    @send_private.setter
    def send_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf6e4939e9945cfa4b9ca1bbaf95f65764681e5453053b5cde6ccb2b35c45ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71770c4332bb5a4cc29011722f9c0d235aa9f30b20938fbd33776dae877be656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37704136d6477ab79234c072ecf7b2713cd4e0da3d457ab52d4b8accb069c6c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23878abfbc163486cd78b93bd8bcc909094a6c2e9dda524665bc3bc586d3d658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec27be77d22d9a6cd14850a540dadd684ce8a3e8b283e563578fcc628ea655ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1715938e3da9e0fb48784fab8dfc6664c0fcd50e550d91570990b985224fd904)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the quick retry feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090abdca73f711c064a9916399af0c088ad7e29588420b5ccdcd521da49f7c7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78bb514f54a90c7ab0d85f68890b1883efd6010104ca61446737594873727fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da39a32c55830ab4e8e2cc27181ad0461dd3bbf0c629cdde14a5c8ae2a5d8cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__389355ae75d740091bcd41a1426f77e016c7ba6d6a69088efe6e865f62f35f64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39028e353feba7084aee80388deeee89696916dc65a5f7f746d66df1809ee528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__758f45a99726115b62cb5e6058661750cd7c20075adb0cbde43b36de48019286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "throughput": "throughput",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813fa0b18c6a4cbbe0173055f6a27d7a15fdc0e086a3b6e55329d7b66bb86d08)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throughput", value=throughput, expected_type=type_hints["throughput"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throughput is not None:
            self._values["throughput"] = throughput
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throughput(self) -> typing.Optional[builtins.str]:
        '''Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps.

        If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        '''
        result = self._values.get("throughput")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d4f034142bb60e3ea0ee2a101b56561c0212e04250e881deacebb103f1a815)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThroughput")
    def reset_throughput(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThroughput", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throughputInput")
    def throughput_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "throughputInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f24c85bb94de29152cccdb9d02358129464024e12b23fd6c27e9b4b1b415c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce5b7196bd9b8cb0b488917563aa115c9fb76dc321370d4fa316b2304d1de49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throughput")
    def throughput(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "throughput"))

    @throughput.setter
    def throughput(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456ca905f074175dbb051ab7b24aa50c1d568869a689dd5353fb7e936ea32029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throughput", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe5d9fb1fb5432de5d54579cb1865ae5ca9ddb537d828090b42431dfd773d714)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0fd05493fbaba8651a6e2a629dd5fcda9e5be5aea670732149143ee85b198b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent",
    jsii_struct_bases=[],
    name_mapping={
        "image_compression": "imageCompression",
        "locked": "locked",
        "prefetch": "prefetch",
        "real_user_monitoring": "realUserMonitoring",
        "sure_route": "sureRoute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent:
    def __init__(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a86dbfdad20e720a9bb8f5fd9d743303e990aa3c55df0196822aec5ba48706e)
            check_type(argname="argument image_compression", value=image_compression, expected_type=type_hints["image_compression"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if image_compression is not None:
            self._values["image_compression"] = image_compression
        if locked is not None:
            self._values["locked"] = locked
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def image_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables image compression for subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        '''
        result = self._values.get("image_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows subcustomer content to prefetch over HTTP/2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes how subcustomer traffic routes from origin to edge servers.  See the ``sureRoute`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__926019ed68a4cda156299bcf3a79bc3fa6c74264d338d5c07033c7584eb450e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetImageCompression")
    def reset_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageCompression", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="imageCompressionInput")
    def image_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "imageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="imageCompression")
    def image_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "imageCompression"))

    @image_compression.setter
    def image_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__637f041fab27561e401c3a8b181fd254aaf200d34a7f1c65599593240bbd8afa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageCompression", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f203b75c1591010af9f742a82998955c506df6528423b2ad2ec8b30b728eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetch"))

    @prefetch.setter
    def prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7375581c814a1d68f40b801a9628d0dac1af02b6460c7a3dd6b5cc40b03fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetch", value)

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "realUserMonitoring"))

    @real_user_monitoring.setter
    def real_user_monitoring(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45a5ea7e6e027522608026768dff772a78524ce5f512e1787f3316acedf4603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "realUserMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sureRoute"))

    @sure_route.setter
    def sure_route(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84a24c9496071a6b533f08752731add79a7a630954465558321178058197fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sureRoute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc022f079501c939b80a3665a17aabca33d9f0ce97407b4dffb669e6f6c7bb42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e740eaf5c07fac03d8a1c8a4e7512e201694d4cec767d98b5d2e1a0b6b31cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67da7562715bee553e7051d93103df972b0cbf700dfed2d850c6e38d54b104ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd83a1ce3aa81a0ec1f50694247b8fbd523e949eb3eab84e03485073ea5a12f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables sending a compressed archive file with objects.

        Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35e9ec6c72ed124555e65deb601cfbd5f3c795391c3201de633ab5c69ac9854)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174460898b0e876166b49b5d2b823e9571432798acdd552c8f87c26c54101236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab0ba76f858dfebc5eb4ac9971d86c34e10f290dee0595acef206464a073b11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14b091ee7908ec65f0e0d360ded8e52b41212a1e9722738b29eda2d7e7ce5f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df5f844564a9d0dbecf57eadebdd5dcae7ca662cd465dbb3181a84910b0ff31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cb5d8a3c5a72a2891dc5d449ced6347b598b4c52bb2ad5a160236c467b3874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase",
    jsii_struct_bases=[],
    name_mapping={
        "database": "database",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase:
    def __init__(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89313e105009ecf1484ea8a40df670e1b4b3141d0e955a1a10125c950737cfb)
            check_type(argname="argument database", value=database, expected_type=type_hints["database"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if database is not None:
            self._values["database"] = database
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def database(self) -> typing.Optional[builtins.str]:
        '''Specifies a default database for this property.

        If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        '''
        result = self._values.get("database")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a database name in requests.

        If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the database name. By default, it points to ``database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the database name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4b52c8c78717f57b20e827878bf1eea3f8c221748942501d1e997f3c98152c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDatabase")
    def reset_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatabase", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="databaseInput")
    def database_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "databaseInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="database")
    def database(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "database"))

    @database.setter
    def database(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9192ecc0f7e0f4ab3e835316448de5cf33661833f98983a91095d6e445913a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "database", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5501412cb945fc092898701ae5938f7aac10dafd5e14bba46b29e475485feada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01f761e80cb39ec2f0a7ff27760654e041b034f50df3a5342277dc617fee8dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf4c935489b820c23f15567bb5affac68d2bd73b86e765e147a4c671fa21866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b80ba6433d7b7a64800b9adef5eecb2a6f5daaf4db833480ee8727f7235db10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0657a8d9b284df58a46fa5e21ad4ec0c3fdca710b5762c4a7913df5849c7859c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a986832a5bb7640d70bbaf9106e43a4dcc04f1dafe9dc04bd8f6a9ece34786)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53a22732a483bb97cfcf1a02ea24ff26f3c9bd5df9f48d52c97d3d6dc317f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0dd82a10af0eb2037ae86e541134f6cb9898856f6f449f59320447e54bd75fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset",
    jsii_struct_bases=[],
    name_mapping={
        "dataset": "dataset",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset:
    def __init__(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36db485b49790428f0cf9e113cd8a56ba89798f7ac5c0ac8f023c6a46907f73b)
            check_type(argname="argument dataset", value=dataset, expected_type=type_hints["dataset"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dataset is not None:
            self._values["dataset"] = dataset
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def dataset(self) -> typing.Optional[builtins.str]:
        '''Specifies a default data set for this property.

        If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        '''
        result = self._values.get("dataset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a data set name in requests.

        If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the data set name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc281538fa5209513532c1c8d503e32a90cf1ec43b0ee3e5c95f55b6965735d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDataset")
    def reset_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataset", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="datasetInput")
    def dataset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datasetInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="dataset")
    def dataset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataset"))

    @dataset.setter
    def dataset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__793a72687e41d980023103b043c3691eb790a2f895c84787a2fb98a6a149a7c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataset", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631fc8512b6b571d39cb424a6e9a856b2fabf94f6428a514406af03a37792cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac74df6907b04b9f5efd3d387745bc47a2fef4bbd9a1dfa7769fce9b54ad5a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__955062f8a704543d319504260bf02c754521228382da9121e6c4eef31d24d79a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90355e0ebbbab60b90659dc9a80755a1dc26559f373469b6b0a95d619ea32608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e92a64ac33abb2322f77a61b2b82863280e2f5ea89786bcc77640e58460042f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81dcadb850850cc525385dcbbca2d7cd5cfbc6be5257906efa0c31bd03cc1344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__402a2109d948b2067b4b7a396843ba1722f99563b1d1bc600b5f21f28ef2b4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec9bb8d94a15c5be9b2be14f2d68b7327f3e13ed340b734fbfaa4480f7c527c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79fd3ccc88631e665d83adf1c968152e061b21a14fde79b6d08fbedee6370bea)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9be8734c0a80e6a21bde59e2831c75426343132403a8d8d5e21fbf121e637ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e971768dc2be5b2db4f520cb8521f76b199452265185334aae06b970893e1be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a65d26435a9e19863636c568ac455b622ef1d138d71456b39cef044d49a24a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__914fc98e581f7b61de8fd43e8a62b2e69825a89de0c3472f9a59e75988a6d215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05a9e674283e959f28387807d5157527aff93086268b599e9a3e1069232268e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33162dd064e987cd7e4db7b608ce1c335e3333f201f9ef55c028355104a1d22a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect",
    jsii_struct_bases=[],
    name_mapping={
        "aggregate_lines": "aggregateLines",
        "aggregate_size": "aggregateSize",
        "aggregate_time": "aggregateTime",
        "api_connector": "apiConnector",
        "api_data_elements": "apiDataElements",
        "destination_hostname": "destinationHostname",
        "destination_path": "destinationPath",
        "enabled": "enabled",
        "locked": "locked",
        "override_aggregate_settings": "overrideAggregateSettings",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect:
    def __init__(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78e871fa0ec54c6d87fb82e22bd448058e2f5bc716ef0c3f7308ae8e8089c4b)
            check_type(argname="argument aggregate_lines", value=aggregate_lines, expected_type=type_hints["aggregate_lines"])
            check_type(argname="argument aggregate_size", value=aggregate_size, expected_type=type_hints["aggregate_size"])
            check_type(argname="argument aggregate_time", value=aggregate_time, expected_type=type_hints["aggregate_time"])
            check_type(argname="argument api_connector", value=api_connector, expected_type=type_hints["api_connector"])
            check_type(argname="argument api_data_elements", value=api_data_elements, expected_type=type_hints["api_data_elements"])
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_aggregate_settings", value=override_aggregate_settings, expected_type=type_hints["override_aggregate_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aggregate_lines is not None:
            self._values["aggregate_lines"] = aggregate_lines
        if aggregate_size is not None:
            self._values["aggregate_size"] = aggregate_size
        if aggregate_time is not None:
            self._values["aggregate_time"] = aggregate_time
        if api_connector is not None:
            self._values["api_connector"] = api_connector
        if api_data_elements is not None:
            self._values["api_data_elements"] = api_data_elements
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if override_aggregate_settings is not None:
            self._values["override_aggregate_settings"] = override_aggregate_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def aggregate_lines(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum number of lines to include in each log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        '''
        result = self._values.get("aggregate_lines")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the log's maximum size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        '''
        result = self._values.get("aggregate_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_time(self) -> typing.Optional[builtins.str]:
        '''Specifies how often logs are generated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        '''
        result = self._values.get("aggregate_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_connector(self) -> typing.Optional[builtins.str]:
        '''Describes the API connector type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        '''
        result = self._values.get("api_connector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_data_elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data set to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        '''
        result = self._values.get("api_data_elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the target hostname accepting push API requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the push API's endpoint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Monitor's log-publishing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_aggregate_settings(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides default log settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        '''
        result = self._values.get("override_aggregate_settings")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1f02fab238f85c2269fabfdce241f4d8b6d75bac9456a36466fc5a4e136ca2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAggregateLines")
    def reset_aggregate_lines(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateLines", []))

    @jsii.member(jsii_name="resetAggregateSize")
    def reset_aggregate_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateSize", []))

    @jsii.member(jsii_name="resetAggregateTime")
    def reset_aggregate_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateTime", []))

    @jsii.member(jsii_name="resetApiConnector")
    def reset_api_connector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiConnector", []))

    @jsii.member(jsii_name="resetApiDataElements")
    def reset_api_data_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiDataElements", []))

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideAggregateSettings")
    def reset_override_aggregate_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideAggregateSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aggregateLinesInput")
    def aggregate_lines_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateLinesInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateSizeInput")
    def aggregate_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateTimeInput")
    def aggregate_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="apiConnectorInput")
    def api_connector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiConnectorInput"))

    @builtins.property
    @jsii.member(jsii_name="apiDataElementsInput")
    def api_data_elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "apiDataElementsInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettingsInput")
    def override_aggregate_settings_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideAggregateSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateLines")
    def aggregate_lines(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateLines"))

    @aggregate_lines.setter
    def aggregate_lines(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f42ed33aaa3eb94f17a985aac1c206176bfd9334370f9fa739e6d013cef54b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateLines", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateSize")
    def aggregate_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateSize"))

    @aggregate_size.setter
    def aggregate_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0ffb959ad1efb784ac3073ab579f1a1187b77deb40f18e395c5dc65d78ee73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateSize", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateTime")
    def aggregate_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateTime"))

    @aggregate_time.setter
    def aggregate_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7afe712f496ed23ea2ea9d01e8948e1db672b4b21716b652cb572f5f11ac86c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateTime", value)

    @builtins.property
    @jsii.member(jsii_name="apiConnector")
    def api_connector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiConnector"))

    @api_connector.setter
    def api_connector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd7c7f15f03a8e3f360ffbd563e45c8acc7c8fd5892b5c24068de6ae5c4e5ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiConnector", value)

    @builtins.property
    @jsii.member(jsii_name="apiDataElements")
    def api_data_elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "apiDataElements"))

    @api_data_elements.setter
    def api_data_elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__534194eb1adb9d6bd4298c7a3f5ed2011ba3ff3006db0d6ae5d56a523d2300d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiDataElements", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02c3627de0133a94938c37dedccffc2cc9a88c7b34296c80ef17a23d9dbcadf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c9d9ae396df385f56be5a99fb212b7e0be7edab5d063605da6f1a0a264b93d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ced2c8948fd7d5dec885c1d2a1d6f700a0a7a3f47c70bbf77026fbcc38eae36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27756e8f1f04307e13527ad2a0673a69fd4a2f13cad4853b75089b3628ab25fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettings")
    def override_aggregate_settings(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideAggregateSettings"))

    @override_aggregate_settings.setter
    def override_aggregate_settings(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1369e85f3bba8376112ffe2215326cc7c6db02e8a3d27f5b459c6d9611538c60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideAggregateSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa68cda728724a12befe58905b7d1b163bfbadf179c7d4c0f78b5d0b3d6380b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aefcd8c400ca70d2c0b18923921a3197832ba1ce6b618d6457d5ff6ab2ec72f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b58536575e6d4d2b482dfd39766cee3c3da8d4120f92a1dc5a2e8f2118ebf02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb7608a100a8a533664913f2bada35df28f01225198e6da8c0e62e3f9912d4c)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A description of what the ``xml`` block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98546c72c714561662e0df521c3f60c30ea92cd2c3291e0121a3a77b08102def)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e05a0e522db73979b713ba526a85f712a8ffcd70f839feb71dd36d378899951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa6cca3fa84f73bd043028b621c4daa899d321a18eaaaeef25090917110e456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a2c043cf26b8891d60f10e96a2f8be5ce6f4cd739c68266a562ab9e7555fd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83700a1956b0877ce5ca425e9fcc4755dc7a3bd93a30e019da907fd2cc0540ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f606f86fa2e246d016dfa575f4f83c2451d8333632b67f2df8071b5a3f5f4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96d12c30b768f542895783ad09ad1c45101abcc51baa562fb88e19cea8a59463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_failover": "enableFailover",
        "failover_rules": "failoverRules",
        "failover_title": "failoverTitle",
        "hostname": "hostname",
        "ip": "ip",
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84666b8ebc24ea0264b170efa0acf6ed36f096fa1bac41067e4de86e15e3fb83)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_failover", value=enable_failover, expected_type=type_hints["enable_failover"])
            check_type(argname="argument failover_rules", value=failover_rules, expected_type=type_hints["failover_rules"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_failover is not None:
            self._values["enable_failover"] = enable_failover
        if failover_rules is not None:
            self._values["failover_rules"] = failover_rules
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if hostname is not None:
            self._values["hostname"] = hostname
        if ip is not None:
            self._values["ip"] = ip
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB data center, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify failover rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        '''
        result = self._values.get("enable_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_rules(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]]:
        '''failover_rules block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        '''
        result = self._values.get("failover_rules")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the data center's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip(self) -> typing.Optional[builtins.str]:
        '''Specifies this data center's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    jsii_struct_bases=[],
    name_mapping={
        "absolute_path": "absolutePath",
        "context_root": "contextRoot",
        "failover_hostname": "failoverHostname",
        "modify_request": "modifyRequest",
        "override_hostname": "overrideHostname",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules:
    def __init__(
        self,
        *,
        absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        context_root: typing.Optional[builtins.str] = None,
        failover_hostname: typing.Optional[builtins.str] = None,
        modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param absolute_path: When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        :param context_root: Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        :param failover_hostname: The hostname of the data center to fail over to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        :param modify_request: Allows you to modify the request's hostname or path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        :param override_hostname: Overrides the request's hostname with the ``failover_hostname``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ec65aca8df09c36eec29d6c423c1b1ac64e941047ecc042e38e0263662bd2b)
            check_type(argname="argument absolute_path", value=absolute_path, expected_type=type_hints["absolute_path"])
            check_type(argname="argument context_root", value=context_root, expected_type=type_hints["context_root"])
            check_type(argname="argument failover_hostname", value=failover_hostname, expected_type=type_hints["failover_hostname"])
            check_type(argname="argument modify_request", value=modify_request, expected_type=type_hints["modify_request"])
            check_type(argname="argument override_hostname", value=override_hostname, expected_type=type_hints["override_hostname"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if absolute_path is not None:
            self._values["absolute_path"] = absolute_path
        if context_root is not None:
            self._values["context_root"] = context_root
        if failover_hostname is not None:
            self._values["failover_hostname"] = failover_hostname
        if modify_request is not None:
            self._values["modify_request"] = modify_request
        if override_hostname is not None:
            self._values["override_hostname"] = override_hostname

    @builtins.property
    def absolute_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page.

        Otherwise when disabled, the path is appended to the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        '''
        result = self._values.get("absolute_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def context_root(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        '''
        result = self._values.get("context_root")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_hostname(self) -> typing.Optional[builtins.str]:
        '''The hostname of the data center to fail over to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        '''
        result = self._values.get("failover_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def modify_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the request's hostname or path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        '''
        result = self._values.get("modify_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Overrides the request's hostname with the ``failover_hostname``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        result = self._values.get("override_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0579ad546c79e72ac2254b47e052037d8acf6fa01d960e8056616b40c33aed08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459e9e2f0fc1f5057ed66704cda2e78a22b52952eeddd399a3317a6f1c57aca6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a35cb98a83ed62c24c198ad6df54ce4c4bcb4552491900de62c803b3746870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889fe1706148c2e954706cd50a649b3c7a1fca85a6a4fdb1023742724ef1e2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1053413a2b533a9a47d7f9ae20d384ced592b1d679ae5073ef4dd3501b70b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9346403d777230a33329ffbd47c199f821f959c70209f4e5c6caa66402288509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023bdc22289a4d2fc1373ac5ef1e2d55ffbf701f90ec0fd7e178fa21eed8800a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAbsolutePath")
    def reset_absolute_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbsolutePath", []))

    @jsii.member(jsii_name="resetContextRoot")
    def reset_context_root(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContextRoot", []))

    @jsii.member(jsii_name="resetFailoverHostname")
    def reset_failover_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverHostname", []))

    @jsii.member(jsii_name="resetModifyRequest")
    def reset_modify_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyRequest", []))

    @jsii.member(jsii_name="resetOverrideHostname")
    def reset_override_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideHostname", []))

    @builtins.property
    @jsii.member(jsii_name="absolutePathInput")
    def absolute_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "absolutePathInput"))

    @builtins.property
    @jsii.member(jsii_name="contextRootInput")
    def context_root_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contextRootInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverHostnameInput")
    def failover_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyRequestInput")
    def modify_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideHostnameInput")
    def override_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="absolutePath")
    def absolute_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "absolutePath"))

    @absolute_path.setter
    def absolute_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7837c0b81f8f691d69ffbe8c3b4cde6199069a0d5e70448621d1fcfa27dddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "absolutePath", value)

    @builtins.property
    @jsii.member(jsii_name="contextRoot")
    def context_root(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contextRoot"))

    @context_root.setter
    def context_root(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d403b7f3b1e67804f5af102486398a9ed0ec4a1267d168d8249608e5b6fc245b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contextRoot", value)

    @builtins.property
    @jsii.member(jsii_name="failoverHostname")
    def failover_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverHostname"))

    @failover_hostname.setter
    def failover_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a869407324c6c96e660a25aa37c096d9b534b38b4565d3d5452118e219ef64db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverHostname", value)

    @builtins.property
    @jsii.member(jsii_name="modifyRequest")
    def modify_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyRequest"))

    @modify_request.setter
    def modify_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ad3d0b1bcfb594b0e6d8fc048328690a4543dc6f72465b78b7cbea2691b2da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="overrideHostname")
    def override_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideHostname"))

    @override_hostname.setter
    def override_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02716ae7504df7bcf6048540b7a151263a4b52ae97098581b500aa1e0719cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideHostname", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d30dd0f4f3aefcd236e80b9fb2ab67dec24bd5b0063976d4879f1b1bb5e275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b637003621d675ebfb2cbb3201dec1d808a1c769daf61c6ab1c78df1e4e9021f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFailoverRules")
    def put_failover_rules(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb31f5ef92099663a5a7a15efe9198a1fa438ed4afa1fe99b50addc1619ea16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverRules", [value]))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableFailover")
    def reset_enable_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableFailover", []))

    @jsii.member(jsii_name="resetFailoverRules")
    def reset_failover_rules(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverRules", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="failoverRules")
    def failover_rules(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesList, jsii.get(self, "failoverRules"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableFailoverInput")
    def enable_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverRulesInput")
    def failover_rules_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "failoverRulesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a64652c815f6374b13a9be943ad8e6cf1ceadef0eb0ff0070ffdf1cac699bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__533b80ffd323ef6e6698bb5b79db64ea160e6e9fec4645d55d7bcecce419147b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableFailover")
    def enable_failover(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableFailover"))

    @enable_failover.setter
    def enable_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9d9b3f1a56b510e15b5d38802af449d6b8ef8dc515d5d983f38c47771dc19e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableFailover", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc1f6f0b92938615705955e468a7138fe44fe9d9336a23463f1a9f91936dad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987b5f1c042d416d8e7929611b290f0259a6f03864d34ec18eedeb6970c531be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ip"))

    @ip.setter
    def ip(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1acdf629011cb8c1e671eb09ebe7990705575b199809b32eea6df6452777e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4555a0559f3ae7fc3c6702c201577fe64834d5e868ab0d38e47225603530a469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96d2b219fb4148728f73ce823cde140608fe495c7f1288bdcaab5563e1722423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8897813ca900691dbfb7f8588b4bd0f95f40404560edb7d7eecbdc08589322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905ac54ab73a035f4fd77c53d99195855a6e360ead5bd3e87e71136c96c2f366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559d727a8bd0e425290e301b5ce5dcf387ef00445eb5d74a43f1d8fd09c05645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_session_persistence": "enableSessionPersistence",
        "hostname": "hostname",
        "id": "id",
        "locked": "locked",
        "session_persistence_title": "sessionPersistenceTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9150b35ca0f8c7e3fe5e88c199e47dd126e5a668b1c83dc561a87e8a782869)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_session_persistence", value=enable_session_persistence, expected_type=type_hints["enable_session_persistence"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_persistence_title", value=session_persistence_title, expected_type=type_hints["session_persistence_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_session_persistence is not None:
            self._values["enable_session_persistence"] = enable_session_persistence
        if hostname is not None:
            self._values["hostname"] = hostname
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if session_persistence_title is not None:
            self._values["session_persistence_title"] = session_persistence_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that marks users' persistent sessions.

        The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB origin, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_session_persistence(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify a cookie to pin the user's browser session to one data center.

        When disabled, ELB's default load balancing may send users to various data centers within the same session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        '''
        result = self._values.get("enable_session_persistence")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname associated with the ELB rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique descriptive string for this ELB origin.

        The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_persistence_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        '''
        result = self._values.get("session_persistence_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ffe45f1995048cc7e9c70be6697ce071c429c54174f3162e5ed94312bf54693)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableSessionPersistence")
    def reset_enable_session_persistence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableSessionPersistence", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionPersistenceTitle")
    def reset_session_persistence_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionPersistenceTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistenceInput")
    def enable_session_persistence_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableSessionPersistenceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitleInput")
    def session_persistence_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sessionPersistenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f569228e6cdce14811f8fd4778fc2624b2253bd688bed0363b66d9297c39f23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f6d89e641a58dfd73625eac0ae5e660c4c914d090de4b10752c415acc29f8d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistence")
    def enable_session_persistence(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableSessionPersistence"))

    @enable_session_persistence.setter
    def enable_session_persistence(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b06263ce14e15aae465378213209f5ff94d2895a174428c7b6493312abdb78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableSessionPersistence", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__939dd5ece17fccc280cf2ba2937c71da6e1493d1d58ec0f5a5346e9689c0f294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75fee4d38dc5d57be4b8a7107c9d4b0a8ee26517e0cd3ed9034a607a83f7fa74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4f8c9acda4bae6c663f4eb6b3e7d78d8173ea0fc13aaa86202f79a1bdac07e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitle")
    def session_persistence_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sessionPersistenceTitle"))

    @session_persistence_title.setter
    def session_persistence_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a179d14266619aaccc6e957e81bea67216b6f1ba28fe520bbf6c914926b5e815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionPersistenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e482e6f5b6127488c996f0981c8b71bdebc097aa233a5b40ad2fb8ff7a87ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30ea14da7ab6481a2ae321f44f315160707faa12e53950adb55baf79129d454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b62c6847dd5ec2d035153b05574daf0e85629fd2ab94e8b296218381f185a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "domain": "domain",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06af4f059ebb5a89d0ece762ae74f82419e54478f966c5139ee490034f3e1d81)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if domain is not None:
            self._values["domain"] = domain
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to use for authorization.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cookie-authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the value of the authorization cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25bd16b3b75576f5a8d86e7f4f1e352bbd4de613787bc740e7e7d1b788f4e49e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__184b750d6ca7c75392988bf3effd87572bff8a7e6e9ce4d7ae9b492fc0a9ae67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8e83dd2e0f709c49b42da60d0757c28551e275e0a7e0e9438302ca55945716)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c46c11c00b590b6d64eae3376f50fa649731dea2f52cac20dead105e603f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__363c1123abc01aec737636250f731b16a9eb495a743605e0ce4c298d177c3093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8daca7584028f1aff601afa0d2705e06a535b9c49a5cb5143e296608308ba46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9da8fac8e1c4b4f4f46b4f8c48a7b8631b04e4aef6cee7a7fa189fb07759ff40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f4078508e4e5cb0793ad22f13443e8c4153b4d63b5b7bababe58e81af85a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ff410c748a2866b767f6834a180502b5a404cf80f61cfc6229d23d1a5c4c401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41718eb9a9b2e209fcdd2f8869e819e149ff559ea661b36fc506e861625d7bec)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Edge Redirector Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de0f8e20cbbe3b71c5798a83bca9a08866f3e754e3155ec7415192426369512)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd718836932e5fdd022d6dc364aeb79f54670b6fa6f287540cb04691421c0a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3484dd2b59ec378561acbef6863d3b77173fa89ad69cfb50d5dfeec99e30a59f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e5ec42bb705e9b264c42a8f3f64b9e1ecc6f266c72fe990045d8ab4bada2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe88991ed55d831599719f96894ce21243bfc34d3f7a2c4bba3428c140a03ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e58065c6f2b88d5137eb0d701ed8321af9d7373539af46559fbd5795e2fac21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75142381ac04f0718b2edb2aca180101a20292216a7b8d72b916af8fb05d64e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dded737f348f0f31ff621b0367ab2f301effe76790e5f8bc9bceb01af427cd25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ed4f534b16cc14299a111752d5b451a54f4897d6505265d75d148549a009ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a03f9e151bdf62aa0c7f5bed8a2f52879219a6244a95259ea57dc2e5976879)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38893073b0768565c74c5fc3b3a39444e7b1f97a87f3e84f6310d7ccd289c8c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe335da499d7ce276503fa4078527d4a37e696fb31b294689c0f162e7cc361e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8560fb97c189f2054b42f3b2bff0ee0b9d8cfeec032f1747e421e06891f6f80c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9bee92ae23247216387ecd66818e8204c3c8dcd3dbd85350643ee3be95cf75)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06a747689ccc9fe32c15c72bbc55f95a276e1feee880842fc56d14a6e113366)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__447e96378c0a73848c34b3a70f2cdbd635728c79625e333312c25f37f588ad50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2832262ec505c1f7b3a76d55de0b9c1e98cf836496aa10cf4ebb18ebb0a5c05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d689a40f62d758271b59cfbddca57bebf227df8b5ea60a63f54aa097c8c756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b4b6e7299155380fcf692ab38ecfd6f0f3bcda5f9917ec6f785850e8ca6c127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e428f28d0e69df0b6a98538748ef24619a79976d698985e1646aaf977a7bbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes",
    jsii_struct_bases=[],
    name_mapping={
        "detect_injection": "detectInjection",
        "enabled": "enabled",
        "enable_via_http": "enableViaHttp",
        "i18_n_charset": "i18NCharset",
        "i18_n_status": "i18NStatus",
        "locked": "locked",
        "pass_client_ip": "passClientIp",
        "pass_set_cookie": "passSetCookie",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes:
    def __init__(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae848092b23566907bbb84f9dad8150d22c83a65273613aa2f5d3774cea47529)
            check_type(argname="argument detect_injection", value=detect_injection, expected_type=type_hints["detect_injection"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_via_http", value=enable_via_http, expected_type=type_hints["enable_via_http"])
            check_type(argname="argument i18_n_charset", value=i18_n_charset, expected_type=type_hints["i18_n_charset"])
            check_type(argname="argument i18_n_status", value=i18_n_status, expected_type=type_hints["i18_n_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument pass_client_ip", value=pass_client_ip, expected_type=type_hints["pass_client_ip"])
            check_type(argname="argument pass_set_cookie", value=pass_set_cookie, expected_type=type_hints["pass_set_cookie"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if detect_injection is not None:
            self._values["detect_injection"] = detect_injection
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_via_http is not None:
            self._values["enable_via_http"] = enable_via_http
        if i18_n_charset is not None:
            self._values["i18_n_charset"] = i18_n_charset
        if i18_n_status is not None:
            self._values["i18_n_status"] = i18_n_status
        if locked is not None:
            self._values["locked"] = locked
        if pass_client_ip is not None:
            self._values["pass_client_ip"] = pass_client_ip
        if pass_set_cookie is not None:
            self._values["pass_set_cookie"] = pass_set_cookie
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def detect_injection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies attempts to inject ESI code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        '''
        result = self._values.get("detect_injection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ESI processing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_via_http(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        '''
        result = self._values.get("enable_via_http")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def i18_n_charset(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        '''
        result = self._values.get("i18_n_charset")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def i18_n_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Provides internationalization support for ESI.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        '''
        result = self._values.get("i18_n_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass the client IP header to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        '''
        result = self._values.get("pass_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_set_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass your origin server's cookies to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        '''
        result = self._values.get("pass_set_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361375bd0a517b66c5094c1f760893042121793ddf2e079e53437f9b4b2f7ca1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDetectInjection")
    def reset_detect_injection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectInjection", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableViaHttp")
    def reset_enable_via_http(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableViaHttp", []))

    @jsii.member(jsii_name="resetI18NCharset")
    def reset_i18_n_charset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NCharset", []))

    @jsii.member(jsii_name="resetI18NStatus")
    def reset_i18_n_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPassClientIp")
    def reset_pass_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassClientIp", []))

    @jsii.member(jsii_name="resetPassSetCookie")
    def reset_pass_set_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassSetCookie", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="detectInjectionInput")
    def detect_injection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectInjectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableViaHttpInput")
    def enable_via_http_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableViaHttpInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NCharsetInput")
    def i18_n_charset_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "i18NCharsetInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NStatusInput")
    def i18_n_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "i18NStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="passClientIpInput")
    def pass_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="passSetCookieInput")
    def pass_set_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passSetCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="detectInjection")
    def detect_injection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectInjection"))

    @detect_injection.setter
    def detect_injection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0cfaf3039bbaa27384c4d29b2649cc287685dd4039290172d01bfbf912d775f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectInjection", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89cfa0dbb61df4eccc2d518ffac0dbc3be45a6045932e02526aff21e68ef955d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableViaHttp")
    def enable_via_http(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableViaHttp"))

    @enable_via_http.setter
    def enable_via_http(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37203e45ce98edc6d420ee6dbbf87611a04874dd433bb416c5f7703abade22df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableViaHttp", value)

    @builtins.property
    @jsii.member(jsii_name="i18NCharset")
    def i18_n_charset(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "i18NCharset"))

    @i18_n_charset.setter
    def i18_n_charset(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ceaa252d83836b02de168066ed5c7a5c794db5b68bec98dfd01e88328a0d186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NCharset", value)

    @builtins.property
    @jsii.member(jsii_name="i18NStatus")
    def i18_n_status(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "i18NStatus"))

    @i18_n_status.setter
    def i18_n_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84c5b998aa26d96703e0d7495399da5e2be7e1aec4927ca169e0bb8e74b79d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1db020f9ff851dfdcacbaf206060aae5e8c08a5920892b744297b9072e6f0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="passClientIp")
    def pass_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passClientIp"))

    @pass_client_ip.setter
    def pass_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4af6edceb3560e435b2de56107e527d29147e914f5db9abae5c09150e659b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="passSetCookie")
    def pass_set_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passSetCookie"))

    @pass_set_cookie.setter
    def pass_set_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06889e01412e0b21615c5fcfcbc27fd35cf7d7ea6345ec06317de3baf2e68e65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passSetCookie", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438b7cf0225db0264e0c93744ed5fc77d1aa82a5e768553b073478e9d922477f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f1c0413ae254ffbdaf510e8721e19ad583850e0ba503043a2a2c9321be9c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c9837d02dd2ce68e5f812a9e60b73003701e23bb898cd560a66fd3499d07ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker",
    jsii_struct_bases=[],
    name_mapping={
        "create_edge_worker": "createEdgeWorker",
        "edge_worker_id": "edgeWorkerId",
        "enabled": "enabled",
        "locked": "locked",
        "resource_tier": "resourceTier",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker:
    def __init__(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3a89abe5689ceeadb83a0175fc719c11def4b7822f51a98a9f75efd0c434dda)
            check_type(argname="argument create_edge_worker", value=create_edge_worker, expected_type=type_hints["create_edge_worker"])
            check_type(argname="argument edge_worker_id", value=edge_worker_id, expected_type=type_hints["edge_worker_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument resource_tier", value=resource_tier, expected_type=type_hints["resource_tier"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if create_edge_worker is not None:
            self._values["create_edge_worker"] = create_edge_worker
        if edge_worker_id is not None:
            self._values["edge_worker_id"] = edge_worker_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if resource_tier is not None:
            self._values["resource_tier"] = resource_tier
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def create_edge_worker(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        '''
        result = self._values.get("create_edge_worker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def edge_worker_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the EdgeWorker application to apply to this rule's web traffic.

        You can use the ``EdgeWorkers API`` to get this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        '''
        result = self._values.get("edge_worker_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies specified EdgeWorker functionality to this rule's web traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def resource_tier(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        '''
        result = self._values.get("resource_tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fe613755ed21c9cceaa3f7e0562e9bfb70f5016fda1dd615ba37f3dc926385)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCreateEdgeWorker")
    def reset_create_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreateEdgeWorker", []))

    @jsii.member(jsii_name="resetEdgeWorkerId")
    def reset_edge_worker_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkerId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResourceTier")
    def reset_resource_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceTier", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorkerInput")
    def create_edge_worker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "createEdgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerIdInput")
    def edge_worker_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "edgeWorkerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceTierInput")
    def resource_tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "resourceTierInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorker")
    def create_edge_worker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "createEdgeWorker"))

    @create_edge_worker.setter
    def create_edge_worker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dcdef2adecdeed86c6290490bc7e2da42db1cfa3a7fa0dbadc53cb516141240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createEdgeWorker", value)

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerId")
    def edge_worker_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "edgeWorkerId"))

    @edge_worker_id.setter
    def edge_worker_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51f44e241b51f3145fd2cc737b9a92381f3356f4188be058028ee0933708267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "edgeWorkerId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08045be2c3d0a04e4daa593492f782f09ca197e40c1584dedcdddbdd1304622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__502ea200f9e84edd8afe84e712c725e7ee9bdb1407486514eeeb8e90eeb7c408)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="resourceTier")
    def resource_tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "resourceTier"))

    @resource_tier.setter
    def resource_tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e93067cb4d30cbdbd1715f92a1f189c1f26494ba1c0b0b77f5aa077ef70681b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resourceTier", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81404588748d684177d5711681d2ca6082510d1a37ea53399e05716101c87ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239d140ef640f1b901cffddc27ec6c862a06338ca734d3e62636bc66d58e2a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d4f22372f31793e1bfeeaa38f8b9d3b08ea4285788912c84c5830564c2c7643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85d641501a077660bc5a72d4956da2e34d822b79a18a7de0d69e983186300709)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8616e823659fa85dd872df7cba697c1cf17c23df327363d73e9392b1c7a1de47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52cc1cb8486351545e9079f7d9ec32058e8958abe4a0bcf10db3aac535acbcfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__930859f39c7401e316a4b418b4709525dfae55374ecafadccb2047fc4f092955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2740bed0b016a9f2a77aafeb9ad474b2eb5a287119bf177dd9a4aa48d80a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5e299b1bf73d07e8269d8592559ead518051a0f46e54c1117e724b93ec1da13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9d2f03fc3fb0b0cd4f57789f97281c4c54d04a669ca5ae92da5fa0b9cd0e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous_vpn": "anonymousVpn",
        "best_practice_action": "bestPracticeAction",
        "best_practice_redirecturl": "bestPracticeRedirecturl",
        "detect_anonymous_vpn": "detectAnonymousVpn",
        "detect_anonymous_vpn_action": "detectAnonymousVpnAction",
        "detect_anonymous_vpn_redirecturl": "detectAnonymousVpnRedirecturl",
        "detect_hosting_provider": "detectHostingProvider",
        "detect_hosting_provider_action": "detectHostingProviderAction",
        "detect_hosting_provider_redirecturl": "detectHostingProviderRedirecturl",
        "detect_public_proxy": "detectPublicProxy",
        "detect_public_proxy_action": "detectPublicProxyAction",
        "detect_public_proxy_redirecturl": "detectPublicProxyRedirecturl",
        "detect_residential_proxy": "detectResidentialProxy",
        "detect_residential_proxy_action": "detectResidentialProxyAction",
        "detect_residential_proxy_redirecturl": "detectResidentialProxyRedirecturl",
        "detect_smart_dns_proxy": "detectSmartDnsProxy",
        "detect_smart_dns_proxy_action": "detectSmartDnsProxyAction",
        "detect_smart_dns_proxy_redirecturl": "detectSmartDnsProxyRedirecturl",
        "detect_tor_exit_node": "detectTorExitNode",
        "detect_tor_exit_node_action": "detectTorExitNodeAction",
        "detect_tor_exit_node_redirecturl": "detectTorExitNodeRedirecturl",
        "detect_vpn_data_center": "detectVpnDataCenter",
        "detect_vpn_data_center_action": "detectVpnDataCenterAction",
        "detect_vpn_data_center_redirecturl": "detectVpnDataCenterRedirecturl",
        "enable_configuration_mode": "enableConfigurationMode",
        "enabled": "enabled",
        "forward_header_enrichment": "forwardHeaderEnrichment",
        "hosting_provider": "hostingProvider",
        "locked": "locked",
        "public_proxy": "publicProxy",
        "residential_proxy": "residentialProxy",
        "smart_dns_proxy": "smartDnsProxy",
        "template_uuid": "templateUuid",
        "tor_exit_node": "torExitNode",
        "uuid": "uuid",
        "vpn_data_center": "vpnDataCenter",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection:
    def __init__(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fb619488c5063195a73f6ec082d7665876df491fc8404898301087af228fb4d)
            check_type(argname="argument anonymous_vpn", value=anonymous_vpn, expected_type=type_hints["anonymous_vpn"])
            check_type(argname="argument best_practice_action", value=best_practice_action, expected_type=type_hints["best_practice_action"])
            check_type(argname="argument best_practice_redirecturl", value=best_practice_redirecturl, expected_type=type_hints["best_practice_redirecturl"])
            check_type(argname="argument detect_anonymous_vpn", value=detect_anonymous_vpn, expected_type=type_hints["detect_anonymous_vpn"])
            check_type(argname="argument detect_anonymous_vpn_action", value=detect_anonymous_vpn_action, expected_type=type_hints["detect_anonymous_vpn_action"])
            check_type(argname="argument detect_anonymous_vpn_redirecturl", value=detect_anonymous_vpn_redirecturl, expected_type=type_hints["detect_anonymous_vpn_redirecturl"])
            check_type(argname="argument detect_hosting_provider", value=detect_hosting_provider, expected_type=type_hints["detect_hosting_provider"])
            check_type(argname="argument detect_hosting_provider_action", value=detect_hosting_provider_action, expected_type=type_hints["detect_hosting_provider_action"])
            check_type(argname="argument detect_hosting_provider_redirecturl", value=detect_hosting_provider_redirecturl, expected_type=type_hints["detect_hosting_provider_redirecturl"])
            check_type(argname="argument detect_public_proxy", value=detect_public_proxy, expected_type=type_hints["detect_public_proxy"])
            check_type(argname="argument detect_public_proxy_action", value=detect_public_proxy_action, expected_type=type_hints["detect_public_proxy_action"])
            check_type(argname="argument detect_public_proxy_redirecturl", value=detect_public_proxy_redirecturl, expected_type=type_hints["detect_public_proxy_redirecturl"])
            check_type(argname="argument detect_residential_proxy", value=detect_residential_proxy, expected_type=type_hints["detect_residential_proxy"])
            check_type(argname="argument detect_residential_proxy_action", value=detect_residential_proxy_action, expected_type=type_hints["detect_residential_proxy_action"])
            check_type(argname="argument detect_residential_proxy_redirecturl", value=detect_residential_proxy_redirecturl, expected_type=type_hints["detect_residential_proxy_redirecturl"])
            check_type(argname="argument detect_smart_dns_proxy", value=detect_smart_dns_proxy, expected_type=type_hints["detect_smart_dns_proxy"])
            check_type(argname="argument detect_smart_dns_proxy_action", value=detect_smart_dns_proxy_action, expected_type=type_hints["detect_smart_dns_proxy_action"])
            check_type(argname="argument detect_smart_dns_proxy_redirecturl", value=detect_smart_dns_proxy_redirecturl, expected_type=type_hints["detect_smart_dns_proxy_redirecturl"])
            check_type(argname="argument detect_tor_exit_node", value=detect_tor_exit_node, expected_type=type_hints["detect_tor_exit_node"])
            check_type(argname="argument detect_tor_exit_node_action", value=detect_tor_exit_node_action, expected_type=type_hints["detect_tor_exit_node_action"])
            check_type(argname="argument detect_tor_exit_node_redirecturl", value=detect_tor_exit_node_redirecturl, expected_type=type_hints["detect_tor_exit_node_redirecturl"])
            check_type(argname="argument detect_vpn_data_center", value=detect_vpn_data_center, expected_type=type_hints["detect_vpn_data_center"])
            check_type(argname="argument detect_vpn_data_center_action", value=detect_vpn_data_center_action, expected_type=type_hints["detect_vpn_data_center_action"])
            check_type(argname="argument detect_vpn_data_center_redirecturl", value=detect_vpn_data_center_redirecturl, expected_type=type_hints["detect_vpn_data_center_redirecturl"])
            check_type(argname="argument enable_configuration_mode", value=enable_configuration_mode, expected_type=type_hints["enable_configuration_mode"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_header_enrichment", value=forward_header_enrichment, expected_type=type_hints["forward_header_enrichment"])
            check_type(argname="argument hosting_provider", value=hosting_provider, expected_type=type_hints["hosting_provider"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument public_proxy", value=public_proxy, expected_type=type_hints["public_proxy"])
            check_type(argname="argument residential_proxy", value=residential_proxy, expected_type=type_hints["residential_proxy"])
            check_type(argname="argument smart_dns_proxy", value=smart_dns_proxy, expected_type=type_hints["smart_dns_proxy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tor_exit_node", value=tor_exit_node, expected_type=type_hints["tor_exit_node"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument vpn_data_center", value=vpn_data_center, expected_type=type_hints["vpn_data_center"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous_vpn is not None:
            self._values["anonymous_vpn"] = anonymous_vpn
        if best_practice_action is not None:
            self._values["best_practice_action"] = best_practice_action
        if best_practice_redirecturl is not None:
            self._values["best_practice_redirecturl"] = best_practice_redirecturl
        if detect_anonymous_vpn is not None:
            self._values["detect_anonymous_vpn"] = detect_anonymous_vpn
        if detect_anonymous_vpn_action is not None:
            self._values["detect_anonymous_vpn_action"] = detect_anonymous_vpn_action
        if detect_anonymous_vpn_redirecturl is not None:
            self._values["detect_anonymous_vpn_redirecturl"] = detect_anonymous_vpn_redirecturl
        if detect_hosting_provider is not None:
            self._values["detect_hosting_provider"] = detect_hosting_provider
        if detect_hosting_provider_action is not None:
            self._values["detect_hosting_provider_action"] = detect_hosting_provider_action
        if detect_hosting_provider_redirecturl is not None:
            self._values["detect_hosting_provider_redirecturl"] = detect_hosting_provider_redirecturl
        if detect_public_proxy is not None:
            self._values["detect_public_proxy"] = detect_public_proxy
        if detect_public_proxy_action is not None:
            self._values["detect_public_proxy_action"] = detect_public_proxy_action
        if detect_public_proxy_redirecturl is not None:
            self._values["detect_public_proxy_redirecturl"] = detect_public_proxy_redirecturl
        if detect_residential_proxy is not None:
            self._values["detect_residential_proxy"] = detect_residential_proxy
        if detect_residential_proxy_action is not None:
            self._values["detect_residential_proxy_action"] = detect_residential_proxy_action
        if detect_residential_proxy_redirecturl is not None:
            self._values["detect_residential_proxy_redirecturl"] = detect_residential_proxy_redirecturl
        if detect_smart_dns_proxy is not None:
            self._values["detect_smart_dns_proxy"] = detect_smart_dns_proxy
        if detect_smart_dns_proxy_action is not None:
            self._values["detect_smart_dns_proxy_action"] = detect_smart_dns_proxy_action
        if detect_smart_dns_proxy_redirecturl is not None:
            self._values["detect_smart_dns_proxy_redirecturl"] = detect_smart_dns_proxy_redirecturl
        if detect_tor_exit_node is not None:
            self._values["detect_tor_exit_node"] = detect_tor_exit_node
        if detect_tor_exit_node_action is not None:
            self._values["detect_tor_exit_node_action"] = detect_tor_exit_node_action
        if detect_tor_exit_node_redirecturl is not None:
            self._values["detect_tor_exit_node_redirecturl"] = detect_tor_exit_node_redirecturl
        if detect_vpn_data_center is not None:
            self._values["detect_vpn_data_center"] = detect_vpn_data_center
        if detect_vpn_data_center_action is not None:
            self._values["detect_vpn_data_center_action"] = detect_vpn_data_center_action
        if detect_vpn_data_center_redirecturl is not None:
            self._values["detect_vpn_data_center_redirecturl"] = detect_vpn_data_center_redirecturl
        if enable_configuration_mode is not None:
            self._values["enable_configuration_mode"] = enable_configuration_mode
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_header_enrichment is not None:
            self._values["forward_header_enrichment"] = forward_header_enrichment
        if hosting_provider is not None:
            self._values["hosting_provider"] = hosting_provider
        if locked is not None:
            self._values["locked"] = locked
        if public_proxy is not None:
            self._values["public_proxy"] = public_proxy
        if residential_proxy is not None:
            self._values["residential_proxy"] = residential_proxy
        if smart_dns_proxy is not None:
            self._values["smart_dns_proxy"] = smart_dns_proxy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tor_exit_node is not None:
            self._values["tor_exit_node"] = tor_exit_node
        if uuid is not None:
            self._values["uuid"] = uuid
        if vpn_data_center is not None:
            self._values["vpn_data_center"] = vpn_data_center

    @builtins.property
    def anonymous_vpn(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        '''
        result = self._values.get("anonymous_vpn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        '''
        result = self._values.get("best_practice_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        '''
        result = self._values.get("best_practice_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from anonymous VPNs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        '''
        result = self._values.get("detect_anonymous_vpn")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_anonymous_vpn_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        '''
        result = self._values.get("detect_anonymous_vpn_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        '''
        result = self._values.get("detect_anonymous_vpn_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This detects requests from a hosting provider.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        '''
        result = self._values.get("detect_hosting_provider")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_hosting_provider_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        '''
        result = self._values.get("detect_hosting_provider_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the absolute URL to which to redirect requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        '''
        result = self._values.get("detect_hosting_provider_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from public proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        '''
        result = self._values.get("detect_public_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_public_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        '''
        result = self._values.get("detect_public_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        '''
        result = self._values.get("detect_public_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from a residential proxy.

        See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        '''
        result = self._values.get("detect_residential_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_residential_proxy_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        '''
        result = self._values.get("detect_residential_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        '''
        result = self._values.get("detect_residential_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from smart DNS proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        '''
        result = self._values.get("detect_smart_dns_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_smart_dns_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        '''
        result = self._values.get("detect_smart_dns_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        '''
        result = self._values.get("detect_smart_dns_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        '''
        result = self._values.get("detect_tor_exit_node")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_tor_exit_node_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        '''
        result = self._values.get("detect_tor_exit_node_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        '''
        result = self._values.get("detect_tor_exit_node_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        '''
        result = self._values.get("detect_vpn_data_center")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_vpn_data_center_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        '''
        result = self._values.get("detect_vpn_data_center_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        '''
        result = self._values.get("detect_vpn_data_center_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_configuration_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        '''
        result = self._values.get("enable_configuration_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies GeoGuard proxy detection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_header_enrichment(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation.

        See the ``epdForwardHeaderEnrichment`` behavior for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        '''
        result = self._values.get("forward_header_enrichment")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hosting_provider(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        '''
        result = self._values.get("hosting_provider")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def public_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        '''
        result = self._values.get("public_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def residential_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        '''
        result = self._values.get("residential_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smart_dns_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        '''
        result = self._values.get("smart_dns_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tor_exit_node(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        '''
        result = self._values.get("tor_exit_node")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vpn_data_center(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        result = self._values.get("vpn_data_center")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f2cd7c98097afac225339ea98466e1cb778b3698d3c13e338b05ec2f26c367d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymousVpn")
    def reset_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymousVpn", []))

    @jsii.member(jsii_name="resetBestPracticeAction")
    def reset_best_practice_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeAction", []))

    @jsii.member(jsii_name="resetBestPracticeRedirecturl")
    def reset_best_practice_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpn")
    def reset_detect_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpn", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnAction")
    def reset_detect_anonymous_vpn_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnAction", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnRedirecturl")
    def reset_detect_anonymous_vpn_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnRedirecturl", []))

    @jsii.member(jsii_name="resetDetectHostingProvider")
    def reset_detect_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProvider", []))

    @jsii.member(jsii_name="resetDetectHostingProviderAction")
    def reset_detect_hosting_provider_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderAction", []))

    @jsii.member(jsii_name="resetDetectHostingProviderRedirecturl")
    def reset_detect_hosting_provider_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderRedirecturl", []))

    @jsii.member(jsii_name="resetDetectPublicProxy")
    def reset_detect_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxy", []))

    @jsii.member(jsii_name="resetDetectPublicProxyAction")
    def reset_detect_public_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyAction", []))

    @jsii.member(jsii_name="resetDetectPublicProxyRedirecturl")
    def reset_detect_public_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectResidentialProxy")
    def reset_detect_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxy", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyAction")
    def reset_detect_residential_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyAction", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyRedirecturl")
    def reset_detect_residential_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxy")
    def reset_detect_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxy", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyAction")
    def reset_detect_smart_dns_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyAction", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyRedirecturl")
    def reset_detect_smart_dns_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectTorExitNode")
    def reset_detect_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNode", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeAction")
    def reset_detect_tor_exit_node_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeAction", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeRedirecturl")
    def reset_detect_tor_exit_node_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenter")
    def reset_detect_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenter", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterAction")
    def reset_detect_vpn_data_center_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterAction", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterRedirecturl")
    def reset_detect_vpn_data_center_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterRedirecturl", []))

    @jsii.member(jsii_name="resetEnableConfigurationMode")
    def reset_enable_configuration_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableConfigurationMode", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardHeaderEnrichment")
    def reset_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetHostingProvider")
    def reset_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostingProvider", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPublicProxy")
    def reset_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicProxy", []))

    @jsii.member(jsii_name="resetResidentialProxy")
    def reset_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResidentialProxy", []))

    @jsii.member(jsii_name="resetSmartDnsProxy")
    def reset_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmartDnsProxy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTorExitNode")
    def reset_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTorExitNode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVpnDataCenter")
    def reset_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVpnDataCenter", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpnInput")
    def anonymous_vpn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "anonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeActionInput")
    def best_practice_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturlInput")
    def best_practice_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnActionInput")
    def detect_anonymous_vpn_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnInput")
    def detect_anonymous_vpn_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectAnonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturlInput")
    def detect_anonymous_vpn_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderActionInput")
    def detect_hosting_provider_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderInput")
    def detect_hosting_provider_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectHostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturlInput")
    def detect_hosting_provider_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyActionInput")
    def detect_public_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyInput")
    def detect_public_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectPublicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturlInput")
    def detect_public_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyActionInput")
    def detect_residential_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyInput")
    def detect_residential_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectResidentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturlInput")
    def detect_residential_proxy_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyActionInput")
    def detect_smart_dns_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyInput")
    def detect_smart_dns_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectSmartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturlInput")
    def detect_smart_dns_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeActionInput")
    def detect_tor_exit_node_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeInput")
    def detect_tor_exit_node_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectTorExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturlInput")
    def detect_tor_exit_node_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterActionInput")
    def detect_vpn_data_center_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterInput")
    def detect_vpn_data_center_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectVpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturlInput")
    def detect_vpn_data_center_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationModeInput")
    def enable_configuration_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enableConfigurationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichmentInput")
    def forward_header_enrichment_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="hostingProviderInput")
    def hosting_provider_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="publicProxyInput")
    def public_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="residentialProxyInput")
    def residential_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "residentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxyInput")
    def smart_dns_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "smartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="torExitNodeInput")
    def tor_exit_node_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "torExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenterInput")
    def vpn_data_center_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "vpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpn")
    def anonymous_vpn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "anonymousVpn"))

    @anonymous_vpn.setter
    def anonymous_vpn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fd5f6bd2a6c6c4b30708799399c55b4953489f0b3eadaeed5605600b51a1258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeAction")
    def best_practice_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeAction"))

    @best_practice_action.setter
    def best_practice_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e366d08b0320ea8578d6459452e395098edad0644f240c8ef513993ef8dd63c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeAction", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturl")
    def best_practice_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeRedirecturl"))

    @best_practice_redirecturl.setter
    def best_practice_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c43118f11c1b2aba46923b297c4b76e4047f76d600eb308698c2db3b3e04cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpn")
    def detect_anonymous_vpn(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectAnonymousVpn"))

    @detect_anonymous_vpn.setter
    def detect_anonymous_vpn(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__726280b3a18bbaaf67d1534b990e2c36eae69cd930c7f3eca41128be3c101b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnAction")
    def detect_anonymous_vpn_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnAction"))

    @detect_anonymous_vpn_action.setter
    def detect_anonymous_vpn_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c57de068b8e0decbb4691cfe9ecbdd694d2ee611aa003d75f38a2636430897d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturl")
    def detect_anonymous_vpn_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnRedirecturl"))

    @detect_anonymous_vpn_redirecturl.setter
    def detect_anonymous_vpn_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb46d6a925b05db158662a3aa59fc9e218f6c0a97a3dd167780db26f402b2e87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProvider")
    def detect_hosting_provider(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectHostingProvider"))

    @detect_hosting_provider.setter
    def detect_hosting_provider(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c289b4e278aad35b2f7c7af673af41fadbceabe044443fa3b2ad5c6d9a7ab19e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderAction")
    def detect_hosting_provider_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderAction"))

    @detect_hosting_provider_action.setter
    def detect_hosting_provider_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efab4e94b99ab32be864be99e4b83c8a8fce1b5e76189b3c0692e878963f8458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturl")
    def detect_hosting_provider_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderRedirecturl"))

    @detect_hosting_provider_redirecturl.setter
    def detect_hosting_provider_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e9a2b0a7548eddf2e75be475ef640827ae90058813c694bbb065348bb7a09e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxy")
    def detect_public_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectPublicProxy"))

    @detect_public_proxy.setter
    def detect_public_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b19c0be1538188da8576edc49826346f198d4a5ade68855f9c53a9371517829f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyAction")
    def detect_public_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyAction"))

    @detect_public_proxy_action.setter
    def detect_public_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c746429f850a4d1fd325c07f2ef477981de379f9b65b09087d6d88671a7c0565)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturl")
    def detect_public_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyRedirecturl"))

    @detect_public_proxy_redirecturl.setter
    def detect_public_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd616dc2e7afd760c91b4e02283fa95e3578f842bc4bfacaf827d3fc8c566b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxy")
    def detect_residential_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectResidentialProxy"))

    @detect_residential_proxy.setter
    def detect_residential_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed84f250437aa20d582c384c06b212d1913ec7d79db75e5c51bbbb4c1fe09ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyAction")
    def detect_residential_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyAction"))

    @detect_residential_proxy_action.setter
    def detect_residential_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33168211e83579bddad0eb674716fbcf8a5863f4dda0068fc4e628971579d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturl")
    def detect_residential_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyRedirecturl"))

    @detect_residential_proxy_redirecturl.setter
    def detect_residential_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db1168b0186d642d00d0f03fbaa2d4c07b9682cfcb26f0b01c9853a6182dd91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxy")
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectSmartDnsProxy"))

    @detect_smart_dns_proxy.setter
    def detect_smart_dns_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efc71591660847dd3447ad620793b23ea85505d9435943e792d63775cc8051b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyAction")
    def detect_smart_dns_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyAction"))

    @detect_smart_dns_proxy_action.setter
    def detect_smart_dns_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248fa46e23c6e011a23e4c6a4a1179ddf26919c798349a76b57f42faedf07f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturl")
    def detect_smart_dns_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyRedirecturl"))

    @detect_smart_dns_proxy_redirecturl.setter
    def detect_smart_dns_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae2e67fa3ffdf5b0ca920e2e81d743a3f5bbdbfdd9fb9e25da52bb215c9059ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNode")
    def detect_tor_exit_node(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectTorExitNode"))

    @detect_tor_exit_node.setter
    def detect_tor_exit_node(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cc600d70f45614ee47b9557c787ee51d73e902a66629275b8e10e17d4d42a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeAction")
    def detect_tor_exit_node_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeAction"))

    @detect_tor_exit_node_action.setter
    def detect_tor_exit_node_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee6a9d94dce635dbdfab500cce43d8a79f02721d546c2570a3b840a4370b93e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturl")
    def detect_tor_exit_node_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeRedirecturl"))

    @detect_tor_exit_node_redirecturl.setter
    def detect_tor_exit_node_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5324adc366a59fc9b3c0908c84e12ff08f936b63b2debd4bc104ca19f99182ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenter")
    def detect_vpn_data_center(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectVpnDataCenter"))

    @detect_vpn_data_center.setter
    def detect_vpn_data_center(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1059b4af3fb825b07d5533872f4f79f5e273cae7d59ae4860d2f1a5470cece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterAction")
    def detect_vpn_data_center_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterAction"))

    @detect_vpn_data_center_action.setter
    def detect_vpn_data_center_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2529cff1144376a299404292aab718adbf45d7bafaf312c790d6e92d9758c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturl")
    def detect_vpn_data_center_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterRedirecturl"))

    @detect_vpn_data_center_redirecturl.setter
    def detect_vpn_data_center_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786587a0ef8dc8a7c95a5b68d9d306f9d4a2ab0b887e14aa4ee4d27b5ece6be0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationMode")
    def enable_configuration_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enableConfigurationMode"))

    @enable_configuration_mode.setter
    def enable_configuration_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0426246b6159f202025976f9bf1a0c5ecbff4646ec2b91d291c4b4838c9167c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableConfigurationMode", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9477d521ffb7ae15ce5e4a6258679acc6149700812dcb3cee25bc5eb69f76c71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichment")
    def forward_header_enrichment(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forwardHeaderEnrichment"))

    @forward_header_enrichment.setter
    def forward_header_enrichment(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a418d66b6f280d1f6c6b183b05c21c7d378af2bcf44ca6e0093bd87d61a67f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHeaderEnrichment", value)

    @builtins.property
    @jsii.member(jsii_name="hostingProvider")
    def hosting_provider(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostingProvider"))

    @hosting_provider.setter
    def hosting_provider(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3518ee35018ac2267ddaa0680e9433ea9f3add2a2ebe7548f282923fc92cf541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02e38e641b631e4a9737534a617cdfcaa9f32ed6e4b36d7742b760a964012a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="publicProxy")
    def public_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicProxy"))

    @public_proxy.setter
    def public_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e583992d465f7a99b30eb9b52292d95539ab4b02bc86ad14a3b0494be773987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="residentialProxy")
    def residential_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "residentialProxy"))

    @residential_proxy.setter
    def residential_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855544c05d3353e3cdd83c9ee4b0b4afe7c51d33553846ae41a63aac840ed55a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "residentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxy")
    def smart_dns_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "smartDnsProxy"))

    @smart_dns_proxy.setter
    def smart_dns_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e507752abc5f0e4f704e593256989729cbb5501b4a119446fa5085034df590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c965bc2052a6f14c650606aefdd6bc6317fcef8c05b8d87e93d8d562a4eed806)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="torExitNode")
    def tor_exit_node(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "torExitNode"))

    @tor_exit_node.setter
    def tor_exit_node(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b790a9c72d84a5b4cc8c300fd53ffc88318357cd151ca6e1000531ab906796c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "torExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc21d1001f6b5f792fb0649b67ea192fd8e892eea8a8a995f5090c8326f0a499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenter")
    def vpn_data_center(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vpnDataCenter"))

    @vpn_data_center.setter
    def vpn_data_center(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f06867397fd1dec77c0fd212bbdbe57e856615f151a5001ede5dc9538ea26bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b754bd06bf1b891f520ddcb1ac3b65d6ed86f82781417cb9954fb285d6bdbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ec59e31db6219776cf292103450ed19d0c40e1ac7467cceacb37ffe4b19569)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy.

        The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c0279d6f6041616dd5f2fe6efa98a440da602102cb61cebda0e3b6f9872977)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76bd5dd730c1452ed9db8d1a28bbb56b625602f90bd843deaa9298a72270095)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af56652af07ff22b2b6e2394d79231cb0f0750884590908e0f5f9ad95a68744c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbc0c42e312653bdd6ba74ca19d5063f405e99e34fda525a09528a6480c8f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19b7b0e5bdadbadfc1ab5a1e2b76eab595a9fa6b53dc7cdad23acda448cc41c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__712103685489c7af9ee37bf75dff277639f774ac34affd95a459adcfe822a080)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction",
    jsii_struct_bases=[],
    name_mapping={
        "action_type": "actionType",
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "cex_custom_path": "cexCustomPath",
        "cex_hostname": "cexHostname",
        "cex_path": "cexPath",
        "content_custom_path": "contentCustomPath",
        "content_hostname": "contentHostname",
        "content_path": "contentPath",
        "cp_code": "cpCode",
        "dynamic_custom_path": "dynamicCustomPath",
        "dynamic_method": "dynamicMethod",
        "dynamic_path": "dynamicPath",
        "enabled": "enabled",
        "locked": "locked",
        "modify_protocol": "modifyProtocol",
        "net_storage_hostname": "netStorageHostname",
        "net_storage_path": "netStoragePath",
        "preserve_query_string": "preserveQueryString",
        "protocol": "protocol",
        "redirect_custom_path": "redirectCustomPath",
        "redirect_hostname": "redirectHostname",
        "redirect_hostname_type": "redirectHostnameType",
        "redirect_method": "redirectMethod",
        "redirect_path": "redirectPath",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction:
    def __init__(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode(**cp_code)
        if isinstance(net_storage_hostname, dict):
            net_storage_hostname = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname(**net_storage_hostname)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c03f25d69c80da3200e9a625369d8e211272146767ed6ebef16307ac4b96804f)
            check_type(argname="argument action_type", value=action_type, expected_type=type_hints["action_type"])
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument cex_custom_path", value=cex_custom_path, expected_type=type_hints["cex_custom_path"])
            check_type(argname="argument cex_hostname", value=cex_hostname, expected_type=type_hints["cex_hostname"])
            check_type(argname="argument cex_path", value=cex_path, expected_type=type_hints["cex_path"])
            check_type(argname="argument content_custom_path", value=content_custom_path, expected_type=type_hints["content_custom_path"])
            check_type(argname="argument content_hostname", value=content_hostname, expected_type=type_hints["content_hostname"])
            check_type(argname="argument content_path", value=content_path, expected_type=type_hints["content_path"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument dynamic_custom_path", value=dynamic_custom_path, expected_type=type_hints["dynamic_custom_path"])
            check_type(argname="argument dynamic_method", value=dynamic_method, expected_type=type_hints["dynamic_method"])
            check_type(argname="argument dynamic_path", value=dynamic_path, expected_type=type_hints["dynamic_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_protocol", value=modify_protocol, expected_type=type_hints["modify_protocol"])
            check_type(argname="argument net_storage_hostname", value=net_storage_hostname, expected_type=type_hints["net_storage_hostname"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument preserve_query_string", value=preserve_query_string, expected_type=type_hints["preserve_query_string"])
            check_type(argname="argument protocol", value=protocol, expected_type=type_hints["protocol"])
            check_type(argname="argument redirect_custom_path", value=redirect_custom_path, expected_type=type_hints["redirect_custom_path"])
            check_type(argname="argument redirect_hostname", value=redirect_hostname, expected_type=type_hints["redirect_hostname"])
            check_type(argname="argument redirect_hostname_type", value=redirect_hostname_type, expected_type=type_hints["redirect_hostname_type"])
            check_type(argname="argument redirect_method", value=redirect_method, expected_type=type_hints["redirect_method"])
            check_type(argname="argument redirect_path", value=redirect_path, expected_type=type_hints["redirect_path"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action_type is not None:
            self._values["action_type"] = action_type
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if cex_custom_path is not None:
            self._values["cex_custom_path"] = cex_custom_path
        if cex_hostname is not None:
            self._values["cex_hostname"] = cex_hostname
        if cex_path is not None:
            self._values["cex_path"] = cex_path
        if content_custom_path is not None:
            self._values["content_custom_path"] = content_custom_path
        if content_hostname is not None:
            self._values["content_hostname"] = content_hostname
        if content_path is not None:
            self._values["content_path"] = content_path
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if dynamic_custom_path is not None:
            self._values["dynamic_custom_path"] = dynamic_custom_path
        if dynamic_method is not None:
            self._values["dynamic_method"] = dynamic_method
        if dynamic_path is not None:
            self._values["dynamic_path"] = dynamic_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modify_protocol is not None:
            self._values["modify_protocol"] = modify_protocol
        if net_storage_hostname is not None:
            self._values["net_storage_hostname"] = net_storage_hostname
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if preserve_query_string is not None:
            self._values["preserve_query_string"] = preserve_query_string
        if protocol is not None:
            self._values["protocol"] = protocol
        if redirect_custom_path is not None:
            self._values["redirect_custom_path"] = redirect_custom_path
        if redirect_hostname is not None:
            self._values["redirect_hostname"] = redirect_hostname
        if redirect_hostname_type is not None:
            self._values["redirect_hostname_type"] = redirect_hostname_type
        if redirect_method is not None:
            self._values["redirect_method"] = redirect_method
        if redirect_path is not None:
            self._values["redirect_path"] = redirect_path
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the basic action to take when there is a failure to contact the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        '''
        result = self._values.get("action_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        '''
        result = self._values.get("cex_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies a hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        '''
        result = self._values.get("cex_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cex_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        '''
        result = self._values.get("cex_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        '''
        result = self._values.get("content_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the static hostname for the alternate redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        '''
        result = self._values.get("content_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        '''
        result = self._values.get("content_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode"], result)

    @builtins.property
    def dynamic_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the original requested path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        '''
        result = self._values.get("dynamic_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        '''
        result = self._values.get("dynamic_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dynamic_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        '''
        result = self._values.get("dynamic_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled in case of a failure to contact the origin, the current behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the redirect's protocol using the value of the ``protocol`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        '''
        result = self._values.get("modify_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage_hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname"]:
        '''net_storage_hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        '''
        result = self._values.get("net_storage_hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        '''
        result = self._values.get("preserve_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def protocol(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        '''
        result = self._values.get("protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses the ``redirectPath`` to customize a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        '''
        result = self._values.get("redirect_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_hostname(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        '''
        result = self._values.get("redirect_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_hostname_type(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve or customize the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        '''
        result = self._values.get("redirect_hostname_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        '''
        result = self._values.get("redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def redirect_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        '''
        result = self._values.get("redirect_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement pattern that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static portion of the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Identifies the component of the request that identifies the SaaS dynamic fail action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns a new HTTP status code to the failure response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__182c8140bccbe57addc59325dcfe6ef4ded66704ab3d9c009f91f918a70a6b39)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99f24e8d6ba63342daa760276b700d85e4eb5d32a507afc5608c72388d011fa4)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f06ce7461c4a2c2554eff9065017b2c457f8f5fd8f26c347a680c11ade9ba0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6a77b86a4c08f56b4c084ae65407456d580212ada25e061c80a61ddec5c89b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__283deee409d1f283fca3dc4dfb415f25f78e9b43e063885ac9d725a6b9b8ccfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595e5412827b05b40da808c1a801b52c2d2ce74efac4a7e4bb69742aebca8323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bbdb7a1f0e1556591561bbb0c82e9803d5293961f460189c1f4145df1b37a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6048edb4369029d1a27178bb67def180f5ede5e7002416b69acdef936e33c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0753bc9ef2b8e6f975dd591a444df96a8205c3439b6c028c95c8af9dd74a763a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b092861406783f869197fc03ae0c61d6e0e776dc034fcd62252a189231d54b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60db2d8c8b338f02b955e20fd1a7713df299ffd684a4ac2377ce75363d211032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc90d9c94c6ed279bc1e518b43327b049420ea8be6045d8712de0d112081e3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c1aae9fb97555d4568f51c8642d1871c8f43bf45938fa6e63e5c6f34075f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6e197bd2582fc0561b277718b1e856ee48138e26ae74ddc52b7fc4077d5bb33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5051ba0300e77027c573fba16a0a26bd2b5b0b2274f1a489761f1cd65d483602)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e358f8a136854739734d0ccc8f326b7e42ba1b3ef845e88405f5581c784fcde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4d47ea5617c406ed0fbdf6ad58abcd82d81abeea4749d0753c218d9b65a7cac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8548f34f668a755d840aaca4824cc1528b92eec7871cdc9784408660dacb8e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb83e517672a22b83fe7272be39c8a8949fe1defa0103a2e3d8282769aa93247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1cd3ed6920e2047fc5d6151cda5987a8647c97e79463e7ae4dce3f7fb2cbd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d825020ee49abe1b45c921dd6b8b3d6c5d90ee499a322b22d209cb93605b6bcf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value]))

    @jsii.member(jsii_name="putNetStorageHostname")
    def put_net_storage_hostname(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorageHostname", [value]))

    @jsii.member(jsii_name="resetActionType")
    def reset_action_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetActionType", []))

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCexCustomPath")
    def reset_cex_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexCustomPath", []))

    @jsii.member(jsii_name="resetCexHostname")
    def reset_cex_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexHostname", []))

    @jsii.member(jsii_name="resetCexPath")
    def reset_cex_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexPath", []))

    @jsii.member(jsii_name="resetContentCustomPath")
    def reset_content_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCustomPath", []))

    @jsii.member(jsii_name="resetContentHostname")
    def reset_content_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentHostname", []))

    @jsii.member(jsii_name="resetContentPath")
    def reset_content_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPath", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDynamicCustomPath")
    def reset_dynamic_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicCustomPath", []))

    @jsii.member(jsii_name="resetDynamicMethod")
    def reset_dynamic_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicMethod", []))

    @jsii.member(jsii_name="resetDynamicPath")
    def reset_dynamic_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyProtocol")
    def reset_modify_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyProtocol", []))

    @jsii.member(jsii_name="resetNetStorageHostname")
    def reset_net_storage_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorageHostname", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetPreserveQueryString")
    def reset_preserve_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveQueryString", []))

    @jsii.member(jsii_name="resetProtocol")
    def reset_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProtocol", []))

    @jsii.member(jsii_name="resetRedirectCustomPath")
    def reset_redirect_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectCustomPath", []))

    @jsii.member(jsii_name="resetRedirectHostname")
    def reset_redirect_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostname", []))

    @jsii.member(jsii_name="resetRedirectHostnameType")
    def reset_redirect_hostname_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostnameType", []))

    @jsii.member(jsii_name="resetRedirectMethod")
    def reset_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectMethod", []))

    @jsii.member(jsii_name="resetRedirectPath")
    def reset_redirect_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectPath", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostname")
    def net_storage_hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference, jsii.get(self, "netStorageHostname"))

    @builtins.property
    @jsii.member(jsii_name="actionTypeInput")
    def action_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="cexCustomPathInput")
    def cex_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cexCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cexHostnameInput")
    def cex_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="cexPathInput")
    def cex_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCustomPathInput")
    def content_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentHostnameInput")
    def content_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPathInput")
    def content_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPathInput")
    def dynamic_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicMethodInput")
    def dynamic_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicPathInput")
    def dynamic_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyProtocolInput")
    def modify_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostnameInput")
    def net_storage_hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname], jsii.get(self, "netStorageHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveQueryStringInput")
    def preserve_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="protocolInput")
    def protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "protocolInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPathInput")
    def redirect_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameInput")
    def redirect_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameTypeInput")
    def redirect_hostname_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectMethodInput")
    def redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectPathInput")
    def redirect_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectPathInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="actionType")
    def action_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "actionType"))

    @action_type.setter
    def action_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2c2c42c699b368da53591050af8868aaaa9fa0d60d669aaca0c03f60e918e6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "actionType", value)

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__001485debbd4a34d6fdc1376cfa50073046f0a6a5a14732c549b9b1a36a2f27f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="cexCustomPath")
    def cex_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cexCustomPath"))

    @cex_custom_path.setter
    def cex_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9151b3a37fe0d673cee9f90aca87639936c466bee96c141b19b0306d631aad19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="cexHostname")
    def cex_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexHostname"))

    @cex_hostname.setter
    def cex_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd9d822c06acafadd31535c4b18370b4dbb48bcb2fe5241682b590d9d624355)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexHostname", value)

    @builtins.property
    @jsii.member(jsii_name="cexPath")
    def cex_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexPath"))

    @cex_path.setter
    def cex_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bdbbe2d7ff013f0eaaef1a6acfe07da80fd42f6b38d4f2092ee8da6fca5c942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentCustomPath")
    def content_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCustomPath"))

    @content_custom_path.setter
    def content_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af0f2476835908ab5d82013be4062656c162b2484ac1aec2d98da26763840cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentHostname")
    def content_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentHostname"))

    @content_hostname.setter
    def content_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a493f3ec891ada461161626736e4b4bb150837d5ea247ac52106f7f19ebd3318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentHostname", value)

    @builtins.property
    @jsii.member(jsii_name="contentPath")
    def content_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentPath"))

    @content_path.setter
    def content_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecda67c09495d162f1756535a52a85d547bfbe2d88b43b9364802b788d2eb8a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPath")
    def dynamic_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicCustomPath"))

    @dynamic_custom_path.setter
    def dynamic_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7321f46e7679b13dc1fae29af1a92abeea040853d9a6ba23beb52b72bb24ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicMethod")
    def dynamic_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicMethod"))

    @dynamic_method.setter
    def dynamic_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ee925edd031c97482451bc72e2978c14fd2606ceb635d71310b2f431983001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicMethod", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicPath")
    def dynamic_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicPath"))

    @dynamic_path.setter
    def dynamic_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1207d1525561be361654684d6c3aa7c1199c63d48213ec89ca2474c5e2690a44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf489050bbd9be9e8a6534fdc58bdda69d46365b6febf881b6c8178e66be3c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b85e6355bea19d5fc3d864e77f8f92b88c4428e6336e72ef5e43a38d8f9cdda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyProtocol")
    def modify_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyProtocol"))

    @modify_protocol.setter
    def modify_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63543d829193f6ef4273684efbbfc47a5f68ee32cf37ff057dc3a885a5ebe8e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9737661e70aa12bb573bd5bc4a1b8872df7d549b858f741ab90f840525fdf88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="preserveQueryString")
    def preserve_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveQueryString"))

    @preserve_query_string.setter
    def preserve_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6db03760030b55b213aeca2383625e9dffabf8d7de410aca6a0c5a34568eb7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="protocol")
    def protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "protocol"))

    @protocol.setter
    def protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f8a97d4ea77027eec70583a850ad182ab56e72135703b9552b04b39510e2040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "protocol", value)

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPath")
    def redirect_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirectCustomPath"))

    @redirect_custom_path.setter
    def redirect_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8efea6f9cc78a90813bb2bc81d88920c1f0d43604e1cd08094d2db36f28336d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostname")
    def redirect_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostname"))

    @redirect_hostname.setter
    def redirect_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e00e788f30acd6ed9459b10056a3ae3dafe1c988a4a0eec1664143116d3b6f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostname", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameType")
    def redirect_hostname_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostnameType"))

    @redirect_hostname_type.setter
    def redirect_hostname_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4fb65e6b1422cbbc3a01bf1d8a0587dfaba6105e60943573c0c3fc972e6d912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostnameType", value)

    @builtins.property
    @jsii.member(jsii_name="redirectMethod")
    def redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectMethod"))

    @redirect_method.setter
    def redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef8f68f4e2dd1fec9e0d6e59e31c51b52d75f9a25a343f6c4f1a6aa79c126e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="redirectPath")
    def redirect_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectPath"))

    @redirect_path.setter
    def redirect_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a605bc48ef2b57ef14e57bc4592ccf959bed046cbcf21cc9f0020a53c3a59500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectPath", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d7facfce27e4d1e6b4f0116f13f5865cd55d337dc427737cf0738f79016af11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd26c7252c96c7a824cb425b706e2ac007c38393ba4cd44f9d5d081a9a13ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c167c36744b9a4ab7e9bb9cae8458258ca0b4adef15accf056a2f91e42dfc3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e777492e8b3a1cac93f9111e44aeafbc5c92024485c6dd364a93a2a0ec356a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26696f39f8f8df3662c19f2005e9a6fcb966723f3cc349dd5d092470f40dce6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d76fbb193acd41a63eb8183e22148f8aa426e6f861e1f25809ee83caeb7ce0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5f6962b5a035f9bb272bb376f83dbcea5892b0e1235478f55269130f971857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f99c1f6f312e4531f7fce1619b05a13e57b8de8d7c896ca18c517f36783d3482)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca2798b71293fe932fce3175c5b3f1b0fe8394c941054179ca01e6955ba62909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab19962f97ab93420aa1e47b491eeb536f8a06baa7c1ccfde8058ce8483a53d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d278de2dda79d051ec0176fa3128595dce1f37d3b69c15b156111062827e60c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c835295ff4af13843376297ce38f1a385ab31d2df3986eb9d0458c972bce4b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "compatibility": "compatibility",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility:
    def __init__(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16357c15ada8e0f59a3d4df7493b2071d5ee47cfc41da100bae93ab8867a8c7a)
            check_type(argname="argument compatibility", value=compatibility, expected_type=type_hints["compatibility"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compatibility is not None:
            self._values["compatibility"] = compatibility
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compatibility(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This behavior does not include any options. Specifying the behavior itself enables it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        '''
        result = self._values.get("compatibility")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adaa656ae9e7bc2e852756dce4411dd66e937256a4e382f3d54b822e302e7b82)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompatibility")
    def reset_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompatibility", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compatibilityInput")
    def compatibility_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compatibility")
    def compatibility(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compatibility"))

    @compatibility.setter
    def compatibility(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f35e718749a7881671643e5433c2b0468128ec8c8988502a19a0e6ee5eb0c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compatibility", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c841f2a51e5dd205c29be2ddf578fa175fc1522f6787f1ded07c4857b481781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1516c4c1b61e36141e9fdd1186ddf6dabd18c6f8db97396d9b9c173594aeaa2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257c93e64cf871ab90ca32b373eeff0baa713a24997a870588b3d94d2c70999b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9235b281a9730d9619bcb58921b83144603a17608d786b70bec9324c8bd84d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e4d587c0d6712f6865dcb922dac94702a38c05d7c1716e5c8e8cdf2f125ae1)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, forces a validation test for all edge content to which the behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7815d9fedead12a1be256f71f63cfa70c40a25823fcf51b0ca48744b2c7b158)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ccdbd63f7bf380a2fd6499ffbba1491b18e9713b476b38c74a39a7f810d3953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89816d35bda8b149e01bf300fbdeb38ceeeee8bd79fb43e52183f1e13d5f7c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f792e94ed8efe9c452d923928341ef09a18ee4cddcc9619138b54554ef0706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d97a2890b60c1ec10d7fce74d5b1e3b69c8b99bb64d19ec972fe88e85878ed97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d55a0308f1a0a42eb4884f3bffc102cea7de058fa8ee96f2890914a7645ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abaee182f0f76a8545b2373fdef8a57f95c531808723dcc0a85e4929f7a01a40)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d8a3d755129e012a32965e7968368cc50fbd9bf80893767e87d9ff30a624d3)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3228fa990b288986d749408b59ab5e2cd215a6af47bfea3ce28b3e9db95d0063)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0809d85827a036de88e34dc94c1c39f88b03e51ed5540d1e50f00acdef49450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a420dcfa485bb9262197f27cd6d2e59510146b1601c79782097ef5cfff929a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40964f308fc1773d0ef8c1d3df01908fa25be275fc99fd100be8a1d6b2487dff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edf8c7479c4b008ceeb329677aa973c4c8e9da8f0373ec3d2b9ba5998a5fbb6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9606b126b968ebb3e17ab4b9af4099c1aa270c573c76c6460df94809198bbfcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcaedf5492c7e21035fdd6588ac291b5eb3c2dc64da4c3523c746ea7f2404c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8844b214733b839a18244cee47676227ccc9f960ae2de055dfe6d7cfb789effa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d02503529f05e797082e3575047a4c4c0b6ec52f3b32660343b2a0afdd467f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bb1ef42eb0ce091b829a0d6ae15ab2e9f18362adaec0275772117e098153e26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400140bbfeddffad2c5f623f43ebf015025ad6d1b9113612ef0d8a573725290a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63cf1c0a922e16a2a8574de516ffa1ea785348b0292b4452c11f5dc9dc66e5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac0e01f1902ec5c9fc6fd7e2409ec6d56c63c829c1bdd2794b1dce34b005ca4)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Plus Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b6630a06babddc6c4b977eed9ba76ca5521e55fa55dade262e201fdf5b047c0)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb88dbc7a2f7d16e7d5b76c163ced160dec44a70c86c4ed7cd5cae71eb8e0e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0312e22dc19436b5c169e17de74c73f315afee5502b12b66b27e282349e5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52d40ee3378b890fd0038c6e408806afbff8eb575ce137f77f606e370015e72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5329b1e526f7599d3cfe23768f943c012ff1eae638ac7d4c44e5669e06d925d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e06bd183256b47eccfab2d55d892b359505fd10bab7821c873b5de5de0a709b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f868026d3b77f6102338f322894f27a483da2a68140989c41bc19e3ab10b5d83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df66d61e82e5ec5d1d7cb8ff3332e8a9120b72a954cbd01eae452e8138c6e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeec16a8d726c28100e8e7546d0015bc555e960a3d21fe0c997c1306a9e44dc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51abe3cb5bb1ca4ce3f0c57f63896c8595edeeb2505784e54603004074d20ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e9d1a8143f06362ca59eadf48fbfde3eceb12f29f824fa64929af3bcb7427c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c748dc8c831e6455841dcbee15a19c4db15be6b6af3bec28b9a7eae54ed03fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bbfb0c41c7c149cf3f18f1ffa46a7649724b80abf29b7fe2f3687d276464cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cb6c208d1f722a75ad4c7263789c8803823fa1f8c815fa87b4fcda4f22a5b36)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Forward Rewrite Cloudlet behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47669c31b8ff65b57d19f7dc4062f10c73e09cbc8a8bd88e8784ff0639366603)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87781d114c85655ae7aff2897b87ccc42a879bd3e141cadcf5423abaae2f2cd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bbb2dcdc7e61a564b50e975b19995b13f23a096d4a0ba0a347944110f81394e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afb23f801d80a71c6ca3a36e788efb6d6174af3411597eb4c03ec951332136f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09bbfa9c894b65ee4013af0fc58ce3e77a30eee2833317e3bc2ffde6c2fb7c4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__537e924df0c2acb603ee589c4cf7a6976c01b05ed6eb6af5c981b8548e041234)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32acd501ccbd2ffaf8cc8d1c5cdda989b8c7fe8ea9bf888db92e101721b22d16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16cc6252849a056e5360f841cfc95199c61163bc1aa27e0800e52248539f3ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d463599f4068876033bac243b0b29833176fc7ce6b3cf3639065294fccfdc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34e803d1d2e745ff8720bc795ec315ce4bce4deb8342c86f3ec4c551dc8505a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7febfd690aef90deb242b17153c7b12e8bbfa3d067fd165e57124f97e37ef04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338104720c0e5c177091e9d66f56254c3708e13b40277a921de04e4f02292d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f22831e0885b0dcb67ce5ed5cdd1da96d8d8be04a8cbb76baa8b36e1da5c06c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader",
    jsii_struct_bases=[],
    name_mapping={
        "custom_sign_string": "customSignString",
        "data_header": "dataHeader",
        "enabled": "enabled",
        "encoding_version": "encodingVersion",
        "locked": "locked",
        "nonce": "nonce",
        "secret_key": "secretKey",
        "signed_header": "signedHeader",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader:
    def __init__(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2188dc250cd5dcba78756102edede2e3d24b590c721be3eafcf72eb0933f9e)
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument data_header", value=data_header, expected_type=type_hints["data_header"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument signed_header", value=signed_header, expected_type=type_hints["signed_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if data_header is not None:
            self._values["data_header"] = data_header
        if enabled is not None:
            self._values["enabled"] = enabled
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if locked is not None:
            self._values["locked"] = locked
        if nonce is not None:
            self._values["nonce"] = nonce
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if signed_header is not None:
            self._values["signed_header"] = signed_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of data to be encrypted as a combination of concatenated strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def data_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header that contains the request data that needs to be encrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        '''
        result = self._values.get("data_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the g2o verification behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the cryptographic ``nonce`` string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signed_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header containing encrypted request data.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        '''
        result = self._values.get("signed_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, the encrypted string is based on the forwarded URL.

        If enabled, you can use ``customSignString`` to customize the set of data to encrypt.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5561f9d98a7517633880b8e84172fa909760a3e7fc9b5772b08cdda2fcc4a8f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDataHeader")
    def reset_data_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataHeader", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetSignedHeader")
    def reset_signed_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignedHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="dataHeaderInput")
    def data_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dataHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="signedHeaderInput")
    def signed_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "signedHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6c820bc1525d11789f4d7c0c6595ef1a63a6dee7df373ea0a03f88e4452e174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="dataHeader")
    def data_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataHeader"))

    @data_header.setter
    def data_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5b1e49ac9ee55ea1d70061b8c6338fa828f5c621bf26a6bd42161eb39723a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d228335c63467b10196b7fe6d417c2db27e1da357dc458c8947267d83fa08f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b522b37271bf7cf7d565dc33646e7080a081c7c3b5dc5283febc6e02cd6580)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa0fa100999083d7067260fb5ebe424894c9f93d27bd27540ea63c739bb6ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7de55a76402e1e54e1b96368d0182ae04ce45a0f92e76108dc51408aa86178d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad0d5fbb62eb5891fc29204b900109ec20d43d6d139a060c4ca9ff642fbfc22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="signedHeader")
    def signed_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "signedHeader"))

    @signed_header.setter
    def signed_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c9832a47a7f241571967dc29cffb54282e3496ca9f8175941bb2d1c7de89225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signedHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2caad6cf3c71f57364f43de1027a171ee83338315d2c88d08ada0cdb8416e9ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19972b496d2123fd96fc87c0f92395a43d08ba8edffae639928e04bd7096975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be452e0baba597fe11c79ece0d6d95fdbe0db464cae729583114e3bd29e09458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88055b443296874eefd81e28fb8e981a63395d90f250bdac54eb9dd725b84e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "output_option": "outputOption",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b231b115db607cf4181107ea2ecd9308c44dba3ea79834c54a740dd8423cbbcb)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument output_option", value=output_option, expected_type=type_hints["output_option"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if output_option is not None:
            self._values["output_option"] = output_option
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def output_option(self) -> typing.Optional[builtins.str]:
        '''Specifies how to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        '''
        result = self._values.get("output_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the variable to assign the GRN value to.

        You need to pre-declare any ``variable`` you specify within the rule tree.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c6a5c96c62ba3f02de718649245218b9a5e0fbf4556d1619d91f06516cf4a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOutputOption")
    def reset_output_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOutputOption", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="outputOptionInput")
    def output_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "outputOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e290425617ab7c3552c96add59c60bb79b25eb9a85f2bf5f55632b29c93e3e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412889d0b884a7079904289e7c2a80d452b466a713ab80b708f77d3f3fa1a7fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="outputOption")
    def output_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "outputOption"))

    @output_option.setter
    def output_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e464fba559d99ff8fb950b665b7bc40f2cda22f389fc16338c30fef118aba7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "outputOption", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849e527d1c8d2907d9059ec94ce71e1a657b0df76f0b62ee955e2ab93477934b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4a5adc99a493de92be828387f238e5f488749baae198bd344a71e0915d21c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e100ccd7562c1b8e5e9113f0fc448a2340b694ad1ec885c4ff34a9290fb5aec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12a4e9f37359c6354fef8d0d12d9d7f78b8ef5c5118b66d2203744a5317ccc3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "cache_responses_with_errors": "cacheResponsesWithErrors",
        "enabled": "enabled",
        "locked": "locked",
        "operations_json_body_parameter_name": "operationsJsonBodyParameterName",
        "operations_url_query_parameter_name": "operationsUrlQueryParameterName",
        "post_request_processing_error_handling": "postRequestProcessingErrorHandling",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching:
    def __init__(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6401c225127b7cef21b3a6a0c24fffd7d235f6545fc08b6d91094664be58f6a2)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument cache_responses_with_errors", value=cache_responses_with_errors, expected_type=type_hints["cache_responses_with_errors"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument operations_json_body_parameter_name", value=operations_json_body_parameter_name, expected_type=type_hints["operations_json_body_parameter_name"])
            check_type(argname="argument operations_url_query_parameter_name", value=operations_url_query_parameter_name, expected_type=type_hints["operations_url_query_parameter_name"])
            check_type(argname="argument post_request_processing_error_handling", value=post_request_processing_error_handling, expected_type=type_hints["post_request_processing_error_handling"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if cache_responses_with_errors is not None:
            self._values["cache_responses_with_errors"] = cache_responses_with_errors
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if operations_json_body_parameter_name is not None:
            self._values["operations_json_body_parameter_name"] = operations_json_body_parameter_name
        if operations_url_query_parameter_name is not None:
            self._values["operations_url_query_parameter_name"] = operations_url_query_parameter_name
        if post_request_processing_error_handling is not None:
            self._values["post_request_processing_error_handling"] = post_request_processing_error_handling
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_responses_with_errors(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches responses that include an ``error`` field at the top of the response body object.

        Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        '''
        result = self._values.get("cache_responses_with_errors")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables GraphQL caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def operations_json_body_parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the JSON body parameter that identifies GraphQL POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        '''
        result = self._values.get("operations_json_body_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def operations_url_query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of a query parameter that identifies requests as GraphQL queries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        '''
        result = self._values.get("operations_url_query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def post_request_processing_error_handling(self) -> typing.Optional[builtins.str]:
        '''Specify what happens if GraphQL query processing fails on POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        '''
        result = self._values.get("post_request_processing_error_handling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5bf526112b8333f0a51b1cc82107b6514bfbbfc1a6f9d5f96fff937aa08c526)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetCacheResponsesWithErrors")
    def reset_cache_responses_with_errors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheResponsesWithErrors", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOperationsJsonBodyParameterName")
    def reset_operations_json_body_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsJsonBodyParameterName", []))

    @jsii.member(jsii_name="resetOperationsUrlQueryParameterName")
    def reset_operations_url_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsUrlQueryParameterName", []))

    @jsii.member(jsii_name="resetPostRequestProcessingErrorHandling")
    def reset_post_request_processing_error_handling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPostRequestProcessingErrorHandling", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrorsInput")
    def cache_responses_with_errors_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheResponsesWithErrorsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterNameInput")
    def operations_json_body_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsJsonBodyParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterNameInput")
    def operations_url_query_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsUrlQueryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandlingInput")
    def post_request_processing_error_handling_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "postRequestProcessingErrorHandlingInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff82f6ce9f883d0a3fdfa9ec7ca98115ede9337eeab43d269935979417c32ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrors")
    def cache_responses_with_errors(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheResponsesWithErrors"))

    @cache_responses_with_errors.setter
    def cache_responses_with_errors(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ceb6ceda695eadf39609d40eb0152911ab2e1c8d464e1636b578188af44824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheResponsesWithErrors", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6378688d6acf35993e453ed5cc0f092679e76931cfe828b732858b5f5200bb5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8930515c8f5059eed0b8b820c326dcab2272ec9c8458ace7b95e58afe116f458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterName")
    def operations_json_body_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsJsonBodyParameterName"))

    @operations_json_body_parameter_name.setter
    def operations_json_body_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__858ce0e8b3ebcc21c7a778bd1fdb814a09c3053a676ef0f8cfc418cdad71147b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsJsonBodyParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterName")
    def operations_url_query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsUrlQueryParameterName"))

    @operations_url_query_parameter_name.setter
    def operations_url_query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95a2db5db9d3e8c6a8a394e1b2f99b86d00780250640b00cc70b172b8e16c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsUrlQueryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandling")
    def post_request_processing_error_handling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "postRequestProcessingErrorHandling"))

    @post_request_processing_error_handling.setter
    def post_request_processing_error_handling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5859a167c8bf0bae6bb7ca7defc74a5921b99a9f1f821685cb5a7307279e2b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "postRequestProcessingErrorHandling", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adc15524de0daab81ac047374f5e274338da1e17bf2208f8360fbbb91698892c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22439a65be371019aea6f97cbf1123ebd1383695b163e0936c70d9eea8c7cf50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e4572c45136e126571f3192438503951674893b557dfaa3c0bb311cc3f6c57d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352f54363ebb0b7bd1cddbc7accff1cc1df1d0e0bb6a99dffba7283f66215031)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify when to compress responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__373a5d4bf4674de70a4ed41e901d78251a8e3651035b21a16002211458f88e8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__074e401b9f74d05c32fa7eabbef383894e6fb90dde466721a9771df5fd2cbf58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163f85626234ec70d1143a860e5ed9ceaac5dd01d9573dbd68ff29e19798a6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9123b4ddae78a6296f39d09e1dfbee0a4d9205664deeffa47a3a5631514b192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa5471bb7dd39e7e7e66d708c48da8565b66d10186d7bd862a4232acb178bcff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15ff3c37c900f51730a3070696c64915d993b86ea3634d0188acbde9d2991b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352059d69f59b2fd9a58d42a84e24676fd11db18fbba5aa23b0b32f1a0a1f6d6)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d59369316a706f50c3db830bc00f5d847be8f01386a03f16d42a9894ed548da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9e3aea738babaafdb293fdf6b298cf5b0187c566dfd298e17a54e2cc6ec7b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6014f9cecd34468e4f446985a82faeb5cd898d6ae4c33e49117980aded43ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeda3a2d0d77b032bc7d2cdc602e0932b5f7005bd7491481d430f8b5f5282fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e12a88d989ec528960a6568d2ba6bb5574f557590e6511f252779fb021f09e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83fbf74053c66e31145686e8a885d042b3e182a445cfa23a5b5e0695d056e945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1a4576d08b16a5d6e21b1da45b433eb666959e648011998aa1e91184ff2c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_reconnects": "maximumReconnects",
        "retry_count": "retryCount",
        "retry_interval": "retryInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c92a9d76eab8ea8cba67e971c1da2f742267fe475918aa420abfcbeb91ffbf2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_reconnects", value=maximum_reconnects, expected_type=type_hints["maximum_reconnects"])
            check_type(argname="argument retry_count", value=retry_count, expected_type=type_hints["retry_count"])
            check_type(argname="argument retry_interval", value=retry_interval, expected_type=type_hints["retry_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_reconnects is not None:
            self._values["maximum_reconnects"] = maximum_reconnects
        if retry_count is not None:
            self._values["retry_count"] = retry_count
        if retry_interval is not None:
            self._values["retry_interval"] = retry_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_reconnects(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum number of times the edge server will contact your origin server.

        If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        '''
        result = self._values.get("maximum_reconnects")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_count(self) -> typing.Optional[jsii.Number]:
        '''The number of consecutive connection failures that mark an IP address as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        '''
        result = self._values.get("retry_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        '''
        result = self._values.get("retry_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79881c38d8bf318466e85affff69993955288306624c22255b2bb1c1128209a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumReconnects")
    def reset_maximum_reconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumReconnects", []))

    @jsii.member(jsii_name="resetRetryCount")
    def reset_retry_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryCount", []))

    @jsii.member(jsii_name="resetRetryInterval")
    def reset_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumReconnectsInput")
    def maximum_reconnects_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maximumReconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="retryCountInput")
    def retry_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "retryCountInput"))

    @builtins.property
    @jsii.member(jsii_name="retryIntervalInput")
    def retry_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "retryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b46028c699fd6f05032bbd1136eef13a89b1c4dbdb894a1b6f927cdaa6e1ab65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumReconnects")
    def maximum_reconnects(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maximumReconnects"))

    @maximum_reconnects.setter
    def maximum_reconnects(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31af0c1c49ab40f7e06978aee6e23f563d4348241866a120f9f77e4ac042caab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumReconnects", value)

    @builtins.property
    @jsii.member(jsii_name="retryCount")
    def retry_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "retryCount"))

    @retry_count.setter
    def retry_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31774314a1b106a9b572b1da55257588645809f342ab4d425f2d505c14eea269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryCount", value)

    @builtins.property
    @jsii.member(jsii_name="retryInterval")
    def retry_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "retryInterval"))

    @retry_interval.setter
    def retry_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4056e59e1bd735396d36b97e4be1050c790fe4dda06c208e0235d61d7346714f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf71eeb3824ac9c290efe4a8a01d9f3d9e35675578c0a3f4726e91c5874c7293)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d87c0dfc01b7d9802cbeeb2ca94b6c32cbaa19e866623fe57d1b632f725d81a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b100cf7766ad78ceb9f516758ef9aaf3e1a14c678807e8338ec47348eee03b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding",
    jsii_struct_bases=[],
    name_mapping={
        "custom_extracted_serial": "customExtractedSerial",
        "enabled": "enabled",
        "hash_max_value": "hashMaxValue",
        "hash_min_value": "hashMinValue",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier": "tier",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding:
    def __init__(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77bf58243d91cf0cff385ab5dfff692e32c3954d0cfba09c2f8c4a7a38cf080)
            check_type(argname="argument custom_extracted_serial", value=custom_extracted_serial, expected_type=type_hints["custom_extracted_serial"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hash_max_value", value=hash_max_value, expected_type=type_hints["hash_max_value"])
            check_type(argname="argument hash_min_value", value=hash_min_value, expected_type=type_hints["hash_min_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier", value=tier, expected_type=type_hints["tier"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_extracted_serial is not None:
            self._values["custom_extracted_serial"] = custom_extracted_serial
        if enabled is not None:
            self._values["enabled"] = enabled
        if hash_max_value is not None:
            self._values["hash_max_value"] = hash_max_value
        if hash_min_value is not None:
            self._values["hash_min_value"] = hash_min_value
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier is not None:
            self._values["tier"] = tier
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_extracted_serial(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to pull the serial number from the variable value set in the ``advanced`` behavior.

        Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        '''
        result = self._values.get("custom_extracted_serial")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HSAF for Edge IP Binding customers with a large footprint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hash_max_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        '''
        result = self._values.get("hash_max_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def hash_min_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the minimum value for the HSAF hash range, from 2 through 2045.

        This needs to be lower than ``hashMaxValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        '''
        result = self._values.get("hash_min_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier(self) -> typing.Optional[builtins.str]:
        '''Specifies where the behavior is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        '''
        result = self._values.get("tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4f217113b0c1be80c81261ff57b3ea1c01f93ea65c252238c534d9a88d739c5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomExtractedSerial")
    def reset_custom_extracted_serial(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomExtractedSerial", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHashMaxValue")
    def reset_hash_max_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMaxValue", []))

    @jsii.member(jsii_name="resetHashMinValue")
    def reset_hash_min_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMinValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier")
    def reset_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerialInput")
    def custom_extracted_serial_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customExtractedSerialInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMaxValueInput")
    def hash_max_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMaxValueInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMinValueInput")
    def hash_min_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMinValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tierInput")
    def tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tierInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerial")
    def custom_extracted_serial(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customExtractedSerial"))

    @custom_extracted_serial.setter
    def custom_extracted_serial(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f4f34ebf79e5bb76e7b4dbb63f361f7ce00835a04a75bcb0428aab9fcae712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customExtractedSerial", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c9e2e2f07a6bc721f6e75232e2d04ef09098c2cd599924136f8e4de8ddb2c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hashMaxValue")
    def hash_max_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMaxValue"))

    @hash_max_value.setter
    def hash_max_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4a24a4f75b58f443104c63efdc0f40e4dc1956a9949ea320b43fba75f43c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMaxValue", value)

    @builtins.property
    @jsii.member(jsii_name="hashMinValue")
    def hash_min_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMinValue"))

    @hash_min_value.setter
    def hash_min_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa92a69e074265d25a4b9683b29143fc026525648f108abe77912a6e9eddff27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMinValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2861ffd39e51ad7c11444fe54aff8b3585a52262767d31724c5529298bb07bed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7f370fcf297d67dd3c9b325d5052865553caf422cf5204621df271e654a2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier")
    def tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier"))

    @tier.setter
    def tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66cb9a9709da4c8e6f868137b9f921ee38af4442fa0f7cb73731bde20a7121db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cec77851b3ecbc0ea86e539d56d57402f5a9442a83bc56f7bdba7b6b15f8cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__521038747c3666e94e8cfad0da81a26608cd23d0d6ad725bdb143130d6328829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0ae34309894575d6b314aec3fe7b0f07b01c511891faade05069a2ee0eb587)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df370990125b8785eb19a2037c31ffc0ca39ef8a73572f5f843d35175b7519a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5133df56ab2857700c5f77d799e746ad7b129f77a7d1985fe976f50ab3cb5db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e2684ae14d438b8f97a68c68fd30e1b561c4986faf173a5daea8958e225573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0cb299b6ef3a182c0016436a4277004f11e3b99d556516dd3cf6a924666066d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05ea775c2b972e7d4442cd435080bfe8715e2d5bd747c64eed3a7034c250b162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813434e748fdaa8329f7a52a2f21408d17bb7d961c866e3745eeb289d8d576c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab30bc0ad29f2d57f3bb9a47b7b669e91dc30ce6856b3bd290bc3330b67c886)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables HTTP/3 connections between requesting clients and Akamai edge servers.

        You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343b7d61528f40be371201d6733a88e5f44b7422b48a228e455e6a0ed6bea9da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2349c75cbe456311d36c7105bc0ab6b7d85c5108d127eab48380236ba8ccc4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c04687616ff586a1c4dfde2e8c4ca0ef62967650d29a6a353c98bd3d6c3a155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd3b6e7df25614739455c5715a45546831ccef3788144fcf99fd5ace68aaba6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6600eee84cb9270026a6f6ad7b73b3a7e7bd31fc5b1c250d98092d2a6d89c7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b116f58e5a75f45cad877eafb31990f247cd3b42a9b45eb378684a09f4d8c94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "include_sub_domains": "includeSubDomains",
        "locked": "locked",
        "max_age": "maxAge",
        "preload": "preload",
        "redirect": "redirect",
        "redirect_status_code": "redirectStatusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49e34a8f6305a035cfecb248d1ebe8eadaf739c280cf5ec5c2978d2d1342cd06)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument include_sub_domains", value=include_sub_domains, expected_type=type_hints["include_sub_domains"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument preload", value=preload, expected_type=type_hints["preload"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirect_status_code", value=redirect_status_code, expected_type=type_hints["redirect_status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if include_sub_domains is not None:
            self._values["include_sub_domains"] = include_sub_domains
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if preload is not None:
            self._values["preload"] = preload
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirect_status_code is not None:
            self._values["redirect_status_code"] = redirect_status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies HSTS to this set of requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def include_sub_domains(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies HSTS to all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        '''
        result = self._values.get("include_sub_domains")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration for which to apply HSTS for new browser connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        '''
        result = self._values.get("preload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects all HTTP requests to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies a response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        '''
        result = self._values.get("redirect_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94f90a36630cc3063dd8d18394221520c28e3f449f660fc57009bd0bd37978c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetIncludeSubDomains")
    def reset_include_sub_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeSubDomains", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetPreload")
    def reset_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreload", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectStatusCode")
    def reset_redirect_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="includeSubDomainsInput")
    def include_sub_domains_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeSubDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadInput")
    def preload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCodeInput")
    def redirect_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab295056a1dc43482f725e1d30c7d09702ae3b51c5e2f950f1bd226d091e5bbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="includeSubDomains")
    def include_sub_domains(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeSubDomains"))

    @include_sub_domains.setter
    def include_sub_domains(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15651b8ae75318d65a9e380e4dcfd6707874a3f69287216044817f58b5b43212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeSubDomains", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdf0aaccde21d04aafa97b191540940fbb259b9cd6620a0420c5dd493e5da9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8007685f85d4838175c93b7248e7827cd36c35812a5b5b8cf294b08fa3e011a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="preload")
    def preload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preload"))

    @preload.setter
    def preload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94668756193d8872bfec2fd1dde66d665e5a34d1af1861f010b4783b36cbff22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preload", value)

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirect"))

    @redirect.setter
    def redirect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d920efa25e7f8988aa49aa5f37d026d3638832be46ed3221edf37bcdcaedad8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirect", value)

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCode")
    def redirect_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectStatusCode"))

    @redirect_status_code.setter
    def redirect_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe275f3f062a6eaf21773bbc8db2b220a8d645086673d57b244dd4b3ce19b7c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0fe13484e46eb09eff8858758b21e1c9e96c4952654e2a3a7ec319bfdc11a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0254161a8caf4b0dcf53c93324d2b442c6293e5469412bae2564e66d4ddd20ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef025033af228983842cb2812137ba0d3122a6552b92a943ef3ca63effd26ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "upgrade": "upgrade",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c64c3d897cb0840b1006adeea3b83bc175d02cbd37d377ae7025e4552cba2f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upgrade", value=upgrade, expected_type=type_hints["upgrade"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upgrade is not None:
            self._values["upgrade"] = upgrade
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upgrade(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        '''
        result = self._values.get("upgrade")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c69ab23ddf1d377b34ba777ddc03c2030ac95c3978cf769ae1db3f98212f66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpgrade")
    def reset_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpgrade", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upgradeInput")
    def upgrade_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b09318c2d9326f2935ed554887e0727e617682a30ef8122da351e5b9c52e87e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad040f2f2ebbca5381273725ae91191cd6454b752c96ea2a702e776058e45d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upgrade")
    def upgrade(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upgrade"))

    @upgrade.setter
    def upgrade(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2fd2b99372524356f93de6050d71fbbc58651c8af64cf4a70671e960b794454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upgrade", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6baad93db31df32caf197e3e4cafed49edb3f10a6ee879caf6ecf57c6f036588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6789ee23162d47e0fc4a1c8f72f1f83a9f5a7d883d385eaa1952f28c4def01ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride",
    jsii_struct_bases=[],
    name_mapping={
        "dpr": "dpr",
        "dprvar": "dprvar",
        "exclude_all_query_parameters": "excludeAllQueryParameters",
        "excluded_query_parameters": "excludedQueryParameters",
        "format": "format",
        "formatvar": "formatvar",
        "locked": "locked",
        "override": "override",
        "policy": "policy",
        "policyvar": "policyvar",
        "policyvar_i_mvar": "policyvarIMvar",
        "policyvar_name": "policyvarName",
        "template_uuid": "templateUuid",
        "typesel": "typesel",
        "uuid": "uuid",
        "width": "width",
        "widthvar": "widthvar",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride:
    def __init__(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3f6ee78d40aa7e4dc080649f7b654b5d98c5a95f724adfee07d910b61f6319)
            check_type(argname="argument dpr", value=dpr, expected_type=type_hints["dpr"])
            check_type(argname="argument dprvar", value=dprvar, expected_type=type_hints["dprvar"])
            check_type(argname="argument exclude_all_query_parameters", value=exclude_all_query_parameters, expected_type=type_hints["exclude_all_query_parameters"])
            check_type(argname="argument excluded_query_parameters", value=excluded_query_parameters, expected_type=type_hints["excluded_query_parameters"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument formatvar", value=formatvar, expected_type=type_hints["formatvar"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override", value=override, expected_type=type_hints["override"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument policyvar", value=policyvar, expected_type=type_hints["policyvar"])
            check_type(argname="argument policyvar_i_mvar", value=policyvar_i_mvar, expected_type=type_hints["policyvar_i_mvar"])
            check_type(argname="argument policyvar_name", value=policyvar_name, expected_type=type_hints["policyvar_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument typesel", value=typesel, expected_type=type_hints["typesel"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument widthvar", value=widthvar, expected_type=type_hints["widthvar"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dpr is not None:
            self._values["dpr"] = dpr
        if dprvar is not None:
            self._values["dprvar"] = dprvar
        if exclude_all_query_parameters is not None:
            self._values["exclude_all_query_parameters"] = exclude_all_query_parameters
        if excluded_query_parameters is not None:
            self._values["excluded_query_parameters"] = excluded_query_parameters
        if format is not None:
            self._values["format"] = format
        if formatvar is not None:
            self._values["formatvar"] = formatvar
        if locked is not None:
            self._values["locked"] = locked
        if override is not None:
            self._values["override"] = override
        if policy is not None:
            self._values["policy"] = policy
        if policyvar is not None:
            self._values["policyvar"] = policyvar
        if policyvar_i_mvar is not None:
            self._values["policyvar_i_mvar"] = policyvar_i_mvar
        if policyvar_name is not None:
            self._values["policyvar_name"] = policyvar_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if typesel is not None:
            self._values["typesel"] = typesel
        if uuid is not None:
            self._values["uuid"] = uuid
        if width is not None:
            self._values["width"] = width
        if widthvar is not None:
            self._values["widthvar"] = widthvar

    @builtins.property
    def dpr(self) -> typing.Optional[jsii.Number]:
        '''Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        '''
        result = self._values.get("dpr")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def dprvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired pixel density.

        The variable specifies the same type of data as the ``dpr`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        '''
        result = self._values.get("dprvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exclude_all_query_parameters(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to exclude all query parameters from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        '''
        result = self._values.get("exclude_all_query_parameters")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def excluded_query_parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies individual query parameters to exclude from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        '''
        result = self._values.get("excluded_query_parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def formatvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the name of the browser you want to optimize images for.

        The variable specifies the same type of data as the ``format`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        '''
        result = self._values.get("formatvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override(self) -> typing.Optional[builtins.str]:
        '''Selects the type of query parameter you want to set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        '''
        result = self._values.get("override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''This selects the desired Image and Video Manager policy name directly.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        '''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired Image and Video Manager policy name to apply to image requests.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        '''
        result = self._values.get("policyvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_i_mvar(self) -> typing.Optional[builtins.str]:
        '''This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        '''
        result = self._values.get("policyvar_i_mvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_name(self) -> typing.Optional[builtins.str]:
        '''This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        '''
        result = self._values.get("policyvar_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typesel(self) -> typing.Optional[builtins.str]:
        '''Specifies how to set a query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        '''
        result = self._values.get("typesel")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[jsii.Number]:
        '''Sets the image's desired pixel width directly.

        If the Image Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def widthvar(self) -> typing.Optional[builtins.str]:
        '''Selects the variable with the desired width.

        If the Image and Video Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        result = self._values.get("widthvar")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3984858f8f35721042edb3c6752d7c97929d4a864be5347d6e43569cc873985)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDpr")
    def reset_dpr(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDpr", []))

    @jsii.member(jsii_name="resetDprvar")
    def reset_dprvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDprvar", []))

    @jsii.member(jsii_name="resetExcludeAllQueryParameters")
    def reset_exclude_all_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludeAllQueryParameters", []))

    @jsii.member(jsii_name="resetExcludedQueryParameters")
    def reset_excluded_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludedQueryParameters", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetFormatvar")
    def reset_formatvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatvar", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride")
    def reset_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetPolicyvar")
    def reset_policyvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvar", []))

    @jsii.member(jsii_name="resetPolicyvarIMvar")
    def reset_policyvar_i_mvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarIMvar", []))

    @jsii.member(jsii_name="resetPolicyvarName")
    def reset_policyvar_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTypesel")
    def reset_typesel(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypesel", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthvar")
    def reset_widthvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthvar", []))

    @builtins.property
    @jsii.member(jsii_name="dprInput")
    def dpr_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "dprInput"))

    @builtins.property
    @jsii.member(jsii_name="dprvarInput")
    def dprvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dprvarInput"))

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParametersInput")
    def exclude_all_query_parameters_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "excludeAllQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParametersInput")
    def excluded_query_parameters_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "excludedQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="formatvarInput")
    def formatvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatvarInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideInput")
    def override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvarInput")
    def policyvar_i_mvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarIMvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarInput")
    def policyvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarNameInput")
    def policyvar_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeselInput")
    def typesel_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeselInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthvarInput")
    def widthvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthvarInput"))

    @builtins.property
    @jsii.member(jsii_name="dpr")
    def dpr(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "dpr"))

    @dpr.setter
    def dpr(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fab3f91910a3c2099b09112a41803db9f61f054b23d6f9fab4380ff554d627a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dpr", value)

    @builtins.property
    @jsii.member(jsii_name="dprvar")
    def dprvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dprvar"))

    @dprvar.setter
    def dprvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6e06da0231995dac0bdc66f1ebd128949ed90c8a9dd92512221e788d47494a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dprvar", value)

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParameters")
    def exclude_all_query_parameters(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "excludeAllQueryParameters"))

    @exclude_all_query_parameters.setter
    def exclude_all_query_parameters(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1992eeba03a3d7add7fd9fc65bf146138c6bf9956c3e336c498c04e53b8e47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludeAllQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParameters")
    def excluded_query_parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "excludedQueryParameters"))

    @excluded_query_parameters.setter
    def excluded_query_parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29ba46eac5f5334a1e89c560f6ba53ce7ebd1353fcbe64fa108f286438b484d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludedQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00399d64b0eeff0f7f95f46ebe7085499c52e02d4eb97311b09ccf89c278f7e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="formatvar")
    def formatvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatvar"))

    @formatvar.setter
    def formatvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3f34be6b23f48fea8429492e93d3da1274d1cb9244fac71b37e659fccee374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatvar", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eee84483c592fa3b67b89065385a4cc66fed1ab82a9ed6d7dc8e52ab506aa1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override")
    def override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "override"))

    @override.setter
    def override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b43eca007c4e57cf33334a992a1d5c35ae118de59c350dd26ec76ce2ca232c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2ac853cfe6c278ce4fed7f8acfaa08bb717cebc9a17f8a8f28591db3776920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="policyvar")
    def policyvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvar"))

    @policyvar.setter
    def policyvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e44593d39428e56530a340fdc82dcdbeaa05ba516210bd5d6e7eb6b9d55300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvar")
    def policyvar_i_mvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarIMvar"))

    @policyvar_i_mvar.setter
    def policyvar_i_mvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e836033d5220b0057b39e806493d30fb259f9ca179eb3471226c6cd5b412b9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarIMvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarName")
    def policyvar_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarName"))

    @policyvar_name.setter
    def policyvar_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0093dfbc706be0e09b39db6ec5affe019a81ecf6695a666fee3bf665b4b340f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcad4e30809f073d677ee72b99e90dd9d6fa248bc130a01c4850f00d9e40eb3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="typesel")
    def typesel(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typesel"))

    @typesel.setter
    def typesel(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46272ac4759cfadb9c937b271e33ad8b5f60b9eddfd3a2bb7d7d4cc911ceccdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typesel", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72791286b33cbb528c4b0b0d786fb39156bcb237092309f3ccedd4e27b3f3dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "width"))

    @width.setter
    def width(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217fc3c11916aef0c4cdc89ee61cd309293981507f6fa28846c3c35b2c338f37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthvar")
    def widthvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthvar"))

    @widthvar.setter
    def widthvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9903fa35304128ca96249e065f2748ecfa8d3aad1e6bdfe2be574f92edc4ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthvar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f0134df7b6413655209447715245d034adf6c18cf97d54be872ee6af6e8a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager",
    jsii_struct_bases=[],
    name_mapping={
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "image_set": "imageSet",
        "locked": "locked",
        "policy_set_type": "policySetType",
        "resize": "resize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "video_set": "videoSet",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager:
    def __init__(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f008c658b5ca6498632d0c71e0b966d447f8f75061b758fc82956b1e23be4180)
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument image_set", value=image_set, expected_type=type_hints["image_set"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set_type", value=policy_set_type, expected_type=type_hints["policy_set_type"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument video_set", value=video_set, expected_type=type_hints["video_set"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if image_set is not None:
            self._values["image_set"] = image_set
        if locked is not None:
            self._values["locked"] = locked
        if policy_set_type is not None:
            self._values["policy_set_type"] = policy_set_type
        if resize is not None:
            self._values["resize"] = resize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if video_set is not None:
            self._values["video_set"] = video_set

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.'''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.'''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def image_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.'''
        result = self._values.get("image_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.'''
        result = self._values.get("policy_set_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.'''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def video_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.'''
        result = self._values.get("video_set")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a84db3b2f32f81fa27581d661dad0c9c21eaa444c045caeaf08988d13142b88)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4992036570b099f472692785d2be9829a78535044e4d838520cf645fa09b460)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d7aed26c933a197e33d71aafaf0bef6803bb55e728e7a52add42ca876be8f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9edfa7129a17b86daac3fb96ab768e72556fd98fb2c92b2bbf7364bdd0ac12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b262ac11d597a770aebe825921d2b8f0b9d4adc2398f188ef346cfcfebe9f44b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff7dd77e5011a7397261d2b909c9ec95ffe2bc82990333f9ff455b7496f4525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d8b29f84d561e65b0ecd4dbb73676b406139d46226334a9058d73f5d1d7694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede09aac7cdb4602e674107c6c2ba92a63744947572e2853c2e84eb703657833)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee508dd1b7ddace678a3d407e8d655934248a65b7b454097c8a9b9dee62f071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cbb4757f61fb57e6792eef02606a3175f510d6f18a79fccf4177110d73f6c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56c6afd5698cb62e71284bdd379f39ba22f7d0af5ac26e7337ba7dd1deb68b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__522de67d876d15dc8efcea61d575c899d1474decf3f6bde4f7dd8a982bad60de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2510d6b1452861455681d537c7352c28e1086719eca82c0615e5ca277ed4fd8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df5dc7065ae82133b7a2c4b20cde4e3d0ac8d8f1ea79a5b5af27bcfbcf16cdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26f1036ce2b6498863c6b707d52ae2112812967d77188df98436b10e0e7467be)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce2d2d7dbb78a0a8d22f941db0e844e114502947ead8b54ca5d09474646264be)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa338f4a0548075ae11c3d2f14ed6ec897d88f70ab9ca4e6871467a5d4479de3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31daae3952818d47c9b666ba783762ef4e80ec311987dedf85dcf96a2b5b4731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6da1ab2e9a9eaccec5c51a3a55f6b4d23b6aa2c39bfebaf70c486d7475f94b4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703846eda6a3008c384d210ff1bdbb83180dbfd4264379ed64b8363587a6e87a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd21e12be4bc9c417c6603444d7bdc3cb5124b8a33c58c42655d6acc6bda1c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aee29d612e42d82e6b2f3fb78543943fa75e0141f511e97050fa7067f395a0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b04b996b35ac91ca9597c17adb35125f379ad98c674de8a739600919bdc7593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a85a5d31133a06642a660bfcc966975fa53c3aa5a40954b156e24b7cf5a7c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036a7edcd4f6497520af0bd0ab7ed55717201f5d6b4a8ddde82343dfd81920b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa46d48798faced8d65c9eff7e6812c488889697dddc54c18b833ada979b6f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126fb4e89b529376babe10658dfe51b97e388efea3e97b1e6d29bddfeb2c2032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc32008e1def191e12f1a0b41ec48472dc98cecf7fc08e001710474ef25131c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef471e88b954c885da3bbac695f7769bdaae980a13cfa2fde49f174567f4e99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetImageSet")
    def reset_image_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageSet", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySetType")
    def reset_policy_set_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySetType", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVideoSet")
    def reset_video_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVideoSet", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="imageSetInput")
    def image_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "imageSetInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetTypeInput")
    def policy_set_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="videoSetInput")
    def video_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "videoSetInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400bd332951ff865a733642e61f1121da906edd95b9565649a82396ae1735ede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801303473411d3a95d35ee610bf0e96d27e7a16e7aa0c54432854cfcf0dbcf5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="imageSet")
    def image_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "imageSet"))

    @image_set.setter
    def image_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea889a42e30d1829401a617722a17f39508ebb9fd316ab60aad3c8133aba317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageSet", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96da6a5448726950d2d39e3f6093902b9a1b17555d9b5f5b179707e8aaca3618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySetType")
    def policy_set_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySetType"))

    @policy_set_type.setter
    def policy_set_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fad2bf49c44dd30a5bf0d6db34423f97a1f7ab4654d9ca60f4d74fe5fe395c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySetType", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c220550dc77d19b798ecb6db5b40429ba01ae68ebc7f3bbbbe422837d7ad65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9320d80b346d18fb438f37598c52bb709db8241d6f5054a64812ea434386973b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4150026a07ca1c9fd0d456af8a6a0df3363b64451712041b38acedb9471c8fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="videoSet")
    def video_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "videoSet"))

    @video_set.setter
    def video_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e9ea6a4e432c2fa97030accc443a6319a8500d56f2f594a0286b017bda90ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "videoSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d80642cf9ad0cfafa5d09c10737255424cac016e40b58de2f123dda6d8150a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad226c4e07358982c3c8a30cbc6ae0b0046c8427223cacc471fdf634ca06aa49)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images.

        The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file.

        This produces the smallest file size possible that retains image quality.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable image management capabilities and generate a corresponding API token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters.

        If you don't specify a label, ``default`` becomes the prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        The ``advanced`` option needs to be inactive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.

        Note that enabling this may affect screen layout in unexpected ways.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216ec081b69cd199ea1df5ff0b4e764c821e24e1c47f782465385bf37e88c084)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7957297c85d87694ad3f7903ce027a592fd42ffe81bd08145fa970b38ce7716d)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5ebf7573d0fd03b6bf1f1194514d17c1dc32c34af76e81b0f40ccdac448040b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078611a234319638dc49124435a02e629a499727f78b83c194e4faeecbeed223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__305f3a9d371fcd4f7c68eb0f9789d72fb1d248d827f12657dcb1d21bb06d7946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0857170aac3bc6967b26ed0acc86559052428137aab5ac0e75316763ea39972a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892855692e311258e39c6c5a3489c6302c8d948509b22445abfb65216fb04c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47357ea657bb48e55a13207e380dabfb026bd946fb4ab96430b09d83e99d86d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d722cf06696aa142dc7014215d9c859a3b4cae4d00e6a3da815849c2555ff5ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b518f3f9dc6e2d2af9cc4b70ff8e5c883a14514d725eceb69ed2ab8e57bb86af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2c9157fe2d8f6d19ec9f5a97f4357323b6b3628cd987c59ffeefdbd0f728681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f327c021b0df07e2110eb8028a1e8e6cacaf658b3041323408a85391553876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41eccdba7d6b155870c32912359a51d989aafb98b4c3680d23ad77eeab4b5694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3fd8b937ca52238e2e4b29d2001f35c13ce4d39c49d9789f809d24a839bc60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5ca0ec10994a954e53a52fc7301ec9fec3a366baebb78551d3dfd4d0f0198b)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3409f5491da56d87f2748eef14fa646b53b70f48db58727c3e454c4b8f79f5f3)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e5ed63a5c24498b5abb32f797d535be0456fb02b01760de056e1cea4f82ecde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b4ae959c4bd46aeaba8c90fb0fa8e215b7547d7c58c1ffedad7ebd494b851a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20cdddd737074ce9983b7656a8f37c570fcb0461290af40cfce19501331bb0af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e3c3d0ed31ed39ad6f7cb6f900b2096aa7a42ab3e6aecdf3d608d8ca774dc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413ce3b9943c3140e6b5903199ff6fc18113ffa379d702d5cb125c436f7c345e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfac59dc9da1ee867c8b9f01d9156c91b6f2e5e9a8c06c19c01afa085a6f39a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f88c737dbdedddbc3bd3b2787a857f899627dd9ff3ba19b95eccc4f5c8eac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb09acc92dd5b0e93e1e6661a9a41b3740c3d86b5a892614f6f34591e0fe2bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c5108c402689cafc99eb8b7667968470ee4698c5b96df3f3da348d1140b4cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13811ec44f212c7df50c5e152f2b962bb9b97f76bc0c3108f38328b3c95082bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4f601a13e65dda8c3384f2febbee44b24aad849d75d614eb32a7cf077650dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__989ec4c166c3ca759b7c284d3dad95bb9eeb1381465a08367941d0ac61c6065e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70873aa49b7941e16ee4419330f21d98d2388f6f1c67b9991524393d5ae6fcdc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5389463c5ddb376a2b019b676458bb80b1dca5c87362b97cfd8336f794b56e61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d16970d096db060cb618a19e874bd37b5e7cbd8141fc7bd6f7ab9b9a5ad59a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff318c14f9664e8a552a82ea02c985e72d71ec3376596fecd046bf1f25751747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb4d154c5c49455e8d62ab618d0940d1c5d8b7e51b67c9469d816c0ab89d393b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9baa4e6ba17f3d1d9ccc52825da25a1b3a7a8262e2fbc3d79afdbc10f92165b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d97fb7d8d0b72abbb31e7f58d514cf4a49426cac8fb1fefe0219592fd9fc30e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f62a5efadf436e16710e79aeba1caea189b08ca9f38283c14c76638721cf44df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d918871d9d1d58ad593fb0f8bd33a0ade9440d817509e87f16f459c3ff4ba717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ae3361ca2fb59f2379549eef31eae89567e8e3277d429fbd11a405e3a34ccd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17885b0a861fb3d20f14c27707802bf79b482bef3a4d5b78411df2b6819e519d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fc4670df64264b215333953a297873cfd2aba0f3248de84b1f1cc7db7365c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b0b318f5a7aad0d9d5007fb781639023c45782ad41e51a411cff3b32fb69d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d10f8e1b778febe4357d780bc747fdd49d5967f024c9d6082ded40a12c727b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2940cd4d691aed321bc98b6ad94d7ee66fbd590b832b1a3d9983d67de2444ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83fed6d7c4b4ed3f3d269c88d9f9f1fc2e0c11b1cf1eaf13d7d1eb98e3781e92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c896b9454ca07324a55938d89fd0c1949d315b988a3931aa9aef4961fbad387a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09df559383bc7723978a7b40ab33cb438853e53f70957e8d46b3b5c4f393a04c)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, applies a single standard policy based on your property name.

        Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, automatically converts videos to the best file type for the requesting device.

        This produces the smallest file size that retains image quality, based on the user agent and the initial image file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Image and Video Manager's video optimization to the current content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``.

        The policy name can include up to 64 alphanumeric, dash, or underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''To optimize caching, assign a region close to your site's heaviest traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbaa2b3544026984a7e1da0b33dd6fabeaf7a701f8f27f68dac0a80370c5a280)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e905fa400ee90f0622872c9c1e3120445744e6df756dcc518924b37e0bda6eb7)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bc3aaf8cb6a888fcd9f8274b8a4f345cffc3b139c91a6b1a605609606aa6c0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7e9b03fbf216e0569e73ede0f955ce7b46a2f304b66c9ac0171a97c62c8c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8463c140800405827053c371e09275ba8d5f1475dfdebcf0f17e93b3c9242618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27002ecb67e7d61835390f9f25e614fb6024aa96211599898ca4a4eaa9377473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87237b05b101b1d4545bc40207c8971c898629e179365776dabe5f547b29b3bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9f263957eac09aad2f015f8279bfe8556c601f9c1a4b009b9d60cb35693da9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6369572c925a78171c719aa17c848a41cd6a7f631b730a5a250ad199a9ca9e56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0a28f90570f6e7f1c73fa05806d28d83847da6bf839deb651445559d4e49e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7641404582af843e13fb5652cf79b0b69be547c8aaf8ac2ce0e1f239006b84b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91132bca9cc4c42754188d17c0c3099cecc7adfe0abbf2e1ca8fb4d195694de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14954aef62b7d98aeb2df1290a8c51e39d9247cacd32170c8d8ce3ad1f687f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__687ca7c53600b5251d9bc7173f44b14031ad75c31643cc1aa8b811c24fd99817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f9cbba3563bd6993f84125f71010aad3357910a7af0e87a1bd917311c7b4db)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d842efbfee16ecbbfe6fc484157f5f813c7826595d57b0314f534385ced0aee2)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf92128efde98bb6727c03835224a17153047b1a4355d7e858c1317cc9f893d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c757f616906cdd2e0d89cc0b380e72f1c14d653585ece8e20bfc806cc64f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d820473e8579e13e1ba119d9707379d56a5030a8f71523babf09d87333b3ce07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72af605a3e8ffe92e3f8834e75db77091fed7e0e2549fd9d23d400423437ec07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b053f0abd8a7328572fe40c7c5ce0e0bfeeb62c1114b8375f51190ccfdd0822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b763939fff6d8b94e8fb02ba3b6cf96a370807b273dafca1121599a3dba26145)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db064feeba0760eb4c8bfc8fd7d233ec7c6160a054c9a24b18f31220c21d24fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e17870195f287c706d2c740685dff803d2ea382475aec20cd9230dd4db6622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d055a8ccc93ff1672e9aaf47c71361731714641acac0543c32bac58d570aa20c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d5ec262fd29c1e6fd6cd40626ed879397859b513d2b3e3b83377a5fb681d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600160e8795691c50905583c1b8adcb544f7e5d52f2ba74311e211d2b8f8e67a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50f1a9278353dc6803c3d094c7f079a24f03fee5269c81da6c6a882e35380bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02fbe8d76c4a66e580699c49d9d847c4ec30807f7c9050ddb4eba8af6d3c028)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad0b74c5c16c4e2c05dfc099d04752d1def8d31d41f3192caa4dab8a1716163e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777b5166ef1c99fbd5d399f0256441c40fea030c875bd8f4a0c75a977b82116f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2d45c224f4ccb5860ddcbe5ffe7d6e28a6c371fcd4746b7899c2aebcdf7551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3a3013ec972a426e7046f6cc6286e17ec1d96006891093c1c2466f60c13ba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861ccb01369a6f51122fa5ee0cea5b11f7465634ece034d2a0f54c4f65ba97d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b274002e374cdf8f01338558a1271901eee9a5ceab7c817d394145c3fdb0084)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f145c26865264ab983c6aa8c8dbea5acff711aa6a38a7c9888ae7bb847b3db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65272a9ceaa5b2dde73a2b722c8c00b3453c24c255e842132af899661ce79bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f29f3bcbbb0122f3a36819960d6874ac8bdf60d0907408ab9a129afeb8e8c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ee6f119c29c972be54d9824ce12c80ee1207a9536ae15727f4d29272911742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a9978ec56e195eeb4395f6a418fce3b66710ac63910f9a1969a908fe78d1340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70181a30249f1ee2c62318def8bb9ed3664063f7a51f5a1001ea65da43822483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2363860be2ede82880c2173859c17c89c88e8ad82681815b0403bafaee0989e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e268c3dcf804122155a4ffb990c6512ba3d98d9f620a16ca1bcab4ef606e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3eaa4fd215d60e1c222184c3c022eb3cd0e365f268dbb08ac0cd2284dae4b0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3722fc87c8688e41efd455c3aa4fd3b398af95bfc497681b5bac7f477c2e2f63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude",
    jsii_struct_bases=[],
    name_mapping={
        "id": "id",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude:
    def __init__(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04327fdb87e48cef1ecc8daf2e0d96e02e4f3bf972208b2d29097380200d447b)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Identifies the include you want to add to your rule tree.

        You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478c6614a7a87a18631339a2b725cd3cd26ebbfcc6a9624ba068c221fdbeb12c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af9cac2616b81ac53035d6c0173b76258ed692d1827908ea6a59f4a15a71a11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14dcb1b08c34c8808d73953c6f9140103db5d680ac963c0df863a1dd28d06477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8be7b9f518ca210737326f1622f89cb87483597bc9aade15938184234c357f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac38037223e49eda3de063f7136394a52c05da1a3f2eddf1be819dd7fea634c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1bd1f9c31cd235a81982e68da92fc1fb75a1f1ece95c91f7fcc78a9309f34b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant",
    jsii_struct_bases=[],
    name_mapping={
        "custom_link_relations": "customLinkRelations",
        "locked": "locked",
        "prefetch_cacheable": "prefetchCacheable",
        "prefetch_html": "prefetchHtml",
        "prefetch_no_store": "prefetchNoStore",
        "prefetch_no_store_extensions": "prefetchNoStoreExtensions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant:
    def __init__(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9baf280c33dd855e5bde3c7a7c953b95b3a314697616dc76de3a6e8869b05742)
            check_type(argname="argument custom_link_relations", value=custom_link_relations, expected_type=type_hints["custom_link_relations"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch_cacheable", value=prefetch_cacheable, expected_type=type_hints["prefetch_cacheable"])
            check_type(argname="argument prefetch_html", value=prefetch_html, expected_type=type_hints["prefetch_html"])
            check_type(argname="argument prefetch_no_store", value=prefetch_no_store, expected_type=type_hints["prefetch_no_store"])
            check_type(argname="argument prefetch_no_store_extensions", value=prefetch_no_store_extensions, expected_type=type_hints["prefetch_no_store_extensions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_link_relations is not None:
            self._values["custom_link_relations"] = custom_link_relations
        if locked is not None:
            self._values["locked"] = locked
        if prefetch_cacheable is not None:
            self._values["prefetch_cacheable"] = prefetch_cacheable
        if prefetch_html is not None:
            self._values["prefetch_html"] = prefetch_html
        if prefetch_no_store is not None:
            self._values["prefetch_no_store"] = prefetch_no_store
        if prefetch_no_store_extensions is not None:
            self._values["prefetch_no_store_extensions"] = prefetch_no_store_extensions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_link_relations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify link relation values that activate the prefetching behavior.

        For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        '''
        result = self._values.get("custom_link_relations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_cacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior.

        Only applies to content with the ``tieredDistribution`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        '''
        result = self._values.get("prefetch_cacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_html(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered.

        This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        '''
        result = self._values.get("prefetch_html")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option.

        Only applies to content with the ``sureRoute`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        '''
        result = self._values.get("prefetch_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store_extensions(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        '''
        result = self._values.get("prefetch_no_store_extensions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11844e3d84cf6117f01e31633665f9b5df9b76cf39532a54197813aa099315d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the InstantConfig behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc9bea49436875872b977a881b0136c77dfde6a2f44aa86bdde54333af51b34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7b23ef6007d6a988768737365ceb1b32d806d0536d11709e52353f2eab5154)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec39b2849a38ee52cc146aeb90f226db451c7d651c579ca003c1a3ab1b6ca516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba1f71219182311b27521d40b5cff41628c439d90622800e3498d38b6de81bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186beada2be6e5398e4747e0948f7fdfb442de3bb9f105a5a06b5620386bc48c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c805194da4e27c08763ea6361cc3bc728069620ccac3db617ce60821b277a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4c1a789d4317f5cc8d74ad7c12fb19ba3b0c359a252048c8c0c2ca66d3997f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLinkRelations")
    def reset_custom_link_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLinkRelations", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetchCacheable")
    def reset_prefetch_cacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchCacheable", []))

    @jsii.member(jsii_name="resetPrefetchHtml")
    def reset_prefetch_html(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchHtml", []))

    @jsii.member(jsii_name="resetPrefetchNoStore")
    def reset_prefetch_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStore", []))

    @jsii.member(jsii_name="resetPrefetchNoStoreExtensions")
    def reset_prefetch_no_store_extensions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStoreExtensions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelationsInput")
    def custom_link_relations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customLinkRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheableInput")
    def prefetch_cacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchCacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchHtmlInput")
    def prefetch_html_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchHtmlInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensionsInput")
    def prefetch_no_store_extensions_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "prefetchNoStoreExtensionsInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreInput")
    def prefetch_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelations")
    def custom_link_relations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customLinkRelations"))

    @custom_link_relations.setter
    def custom_link_relations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b861846e18643b94bfe675cb4432ee567128d363f2bcd2afbbd582bf381693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLinkRelations", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ded568922d03c83ee40bce1c3c752d1f6f390cf9d3746061bdf18a524624237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheable")
    def prefetch_cacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchCacheable"))

    @prefetch_cacheable.setter
    def prefetch_cacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d046d6ab2b3d1552f76d9243bcb7d5fcc823c08ca263e6bc9f9305904ce7e5e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchCacheable", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchHtml")
    def prefetch_html(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchHtml"))

    @prefetch_html.setter
    def prefetch_html(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2331135aed837889f76dfc6ca33e707d603421b9daae1eeb86fd715a41b93ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchHtml", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStore")
    def prefetch_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchNoStore"))

    @prefetch_no_store.setter
    def prefetch_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda290c0c8fcc606726b635c4015e27cbeb765fbe55ef6bc6f874a1f6640b0ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensions")
    def prefetch_no_store_extensions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "prefetchNoStoreExtensions"))

    @prefetch_no_store_extensions.setter
    def prefetch_no_store_extensions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b363623b0dca919b4aebd4a412f7a5a69af1f09434c81d7e143ec7b55caa3988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStoreExtensions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba1a5f368618e1c99e89b7feb65182269cf0ed8db201fe4d469351292d90a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a8e21df2cf646c94b85b554832a9d7e8057a3d2b3170fed722b8d5dcad6705a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873d877c7934adba18716679fc2c4c9b9b6791cdac03290318855c457ee77286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "enable_partial_object_caching": "enablePartialObjectCaching",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "minimum_size": "minimumSize",
        "template_uuid": "templateUuid",
        "use_versioning": "useVersioning",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d00883fff48d73fde266c987e1eafa779e94709e3fed008cf5733e00e74a094)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_partial_object_caching", value=enable_partial_object_caching, expected_type=type_hints["enable_partial_object_caching"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument minimum_size", value=minimum_size, expected_type=type_hints["minimum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_versioning", value=use_versioning, expected_type=type_hints["use_versioning"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_partial_object_caching is not None:
            self._values["enable_partial_object_caching"] = enable_partial_object_caching
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if minimum_size is not None:
            self._values["minimum_size"] = minimum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_versioning is not None:
            self._values["use_versioning"] = use_versioning
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_partial_object_caching(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to cache partial objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        '''
        result = self._values.get("enable_partial_object_caching")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def minimum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        '''
        result = self._values.get("minimum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_versioning(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        '''
        result = self._values.get("use_versioning")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "fragment_size": "fragmentSize",
        "locked": "locked",
        "object_size": "objectSize",
        "prefetch_after_request": "prefetchAfterRequest",
        "prefetch_during_request": "prefetchDuringRequest",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f13195228aaeba5c3d3f9d3d71da3e5b6faec7cbdfcab598e21e7b852b1398)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument fragment_size", value=fragment_size, expected_type=type_hints["fragment_size"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument prefetch_after_request", value=prefetch_after_request, expected_type=type_hints["prefetch_after_request"])
            check_type(argname="argument prefetch_during_request", value=prefetch_during_request, expected_type=type_hints["prefetch_during_request"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if fragment_size is not None:
            self._values["fragment_size"] = fragment_size
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if prefetch_after_request is not None:
            self._values["prefetch_after_request"] = prefetch_after_request
        if prefetch_during_request is not None:
            self._values["prefetch_during_request"] = prefetch_during_request
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def fragment_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of each fragment used for partial object caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        '''
        result = self._values.get("fragment_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the file at which point to apply partial object (POC) caching.

        Append a numeric value with a ``MB`` or ``GB`` suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prefetch_after_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch after the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        '''
        result = self._values.get("prefetch_after_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def prefetch_during_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch during the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        '''
        result = self._values.get("prefetch_during_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1eac3e1a7d35505dc495351d8811424aa880d951bc34c34067445fab6c4a6af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFragmentSize")
    def reset_fragment_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFragmentSize", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPrefetchAfterRequest")
    def reset_prefetch_after_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchAfterRequest", []))

    @jsii.member(jsii_name="resetPrefetchDuringRequest")
    def reset_prefetch_during_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchDuringRequest", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="fragmentSizeInput")
    def fragment_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fragmentSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequestInput")
    def prefetch_after_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchAfterRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequestInput")
    def prefetch_during_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchDuringRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aafbda944d4636ccde4487520ecf0d269307fcf67968f766f2d0c99d02db6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="fragmentSize")
    def fragment_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fragmentSize"))

    @fragment_size.setter
    def fragment_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f614240ce704f711c6500efab8077e24fbc12ff8133782e1894441cf0c7cd44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fragmentSize", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987b6dbfc49855ded72cba8428fa6b86db5f50f5d83bea13eae3f6f072bff877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83acffbe508fc900a271970c53ab18d21ae842d326778679113e105a283d8a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequest")
    def prefetch_after_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchAfterRequest"))

    @prefetch_after_request.setter
    def prefetch_after_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25eba0e9678261809614a8f8e90cceff8fc442f9c4cf89c3b657b19701fe0193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchAfterRequest", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequest")
    def prefetch_during_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchDuringRequest"))

    @prefetch_during_request.setter
    def prefetch_during_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28b64ff2023dd4a502ee0dfef873d666f3db82c856c5024cba3986f68a0d42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchDuringRequest", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75a2df82aa4885e5444f28fa61379408461562461b9f3ac9023d29a17dd7692)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8c7dcd354b17fd8af4e5b56fa978413641d42acc9257cc42903d803f6d0a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9265f498fac8d29133d5121826d8016b0483b3114248b94dc9f7f1a5bdb662e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31936019535d185ad3387a4d7b2a35fdbe4b660014b68f8a3fb7ea78166dcbb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnablePartialObjectCaching")
    def reset_enable_partial_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePartialObjectCaching", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMinimumSize")
    def reset_minimum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinimumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseVersioning")
    def reset_use_versioning(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseVersioning", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCachingInput")
    def enable_partial_object_caching_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enablePartialObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="minimumSizeInput")
    def minimum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minimumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useVersioningInput")
    def use_versioning_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useVersioningInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4dd2003dc0aaf6dd42ee8ceb9833830debc3c9f153fc4ece9d926f6b221ffa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCaching")
    def enable_partial_object_caching(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enablePartialObjectCaching"))

    @enable_partial_object_caching.setter
    def enable_partial_object_caching(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aab5f918781a53e54d2deba79561fb9dc78b20819e581afc9d3bbb628c227f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePartialObjectCaching", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fb6fd899fc3e5ed2c75219fb729b8907a571386f860d45d0af452195ddedf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6361d3e4c9ba630c3cab616c1810faabf52f17518f2cf35b17d6a7cd98082b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="minimumSize")
    def minimum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minimumSize"))

    @minimum_size.setter
    def minimum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c95796b67d25a1557ea7ef1a003fbffb460af138f8c394152b9f268e7f9ab6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minimumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f09d1fb3c42ac6aa9351c65fa03ad9f9218581d43d179f4471a4922fc54c8ecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useVersioning")
    def use_versioning(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useVersioning"))

    @use_versioning.setter
    def use_versioning(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170d6184893d77815eb3ca5450c04d653c8f504188ae14e2406e13e674c7ee7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useVersioning", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a547de3540bf51f3a24bbaa952bfa0e768e7cd584f01c3de4db3ad36c3e412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3f6a7e6bed23a1a3b1274f070be0de86c7288f022099f26c03369740660116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate",
    jsii_struct_bases=[],
    name_mapping={
        "bitrate_table": "bitrateTable",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "threshold_table": "thresholdTable",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate:
    def __init__(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a12762570fa89ea3b3b376f50a879a18132569aa47c5c024368be715293cc8)
            check_type(argname="argument bitrate_table", value=bitrate_table, expected_type=type_hints["bitrate_table"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument threshold_table", value=threshold_table, expected_type=type_hints["threshold_table"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_table is not None:
            self._values["bitrate_table"] = bitrate_table
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if threshold_table is not None:
            self._values["threshold_table"] = threshold_table
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bitrate_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable"]]]:
        '''bitrate_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        '''
        result = self._values.get("bitrate_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable"]]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates the bit rate limiting behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable"]]]:
        '''threshold_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        '''
        result = self._values.get("threshold_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable"]]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable",
    jsii_struct_bases=[],
    name_mapping={"bitrate_unit": "bitrateUnit", "bitrate_value": "bitrateValue"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable:
    def __init__(
        self,
        *,
        bitrate_unit: typing.Optional[builtins.str] = None,
        bitrate_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param bitrate_unit: The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        :param bitrate_value: The numeric indicator of the download rate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8fce3547e5dcaf827683eab8aa322fc4f7b8da936a57116d7496efdea8fb83a)
            check_type(argname="argument bitrate_unit", value=bitrate_unit, expected_type=type_hints["bitrate_unit"])
            check_type(argname="argument bitrate_value", value=bitrate_value, expected_type=type_hints["bitrate_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_unit is not None:
            self._values["bitrate_unit"] = bitrate_unit
        if bitrate_value is not None:
            self._values["bitrate_value"] = bitrate_value

    @builtins.property
    def bitrate_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        '''
        result = self._values.get("bitrate_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def bitrate_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the download rate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        result = self._values.get("bitrate_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eea7e9fea297001e0f987c9c30e8daeace54e69f0e1f8cca731f40501da89c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64abfb4768b2c8d6fe954094e3b7d0e3de1d3d6e64ba5cd4224d89f024abfb6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89cb2fd603bc5bfeee7aeed1bc5df00ff3969d450e81ef0beb90b659ec5b29f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552b9b60ac40cee5393e1f55f60717361b190ae68cb6b5e53c759e3a0eeb1efd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e657a134bbbd774013dc980a13fd67ce891ed23a1b3b84a78068e895727966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ea72aef054f5bdb436573410a54755cf5e94ef40cc4a30d51db38907b69341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25d4496650fc893514ef511818301de6c83af257e5526bb705aa2a524a62bb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBitrateUnit")
    def reset_bitrate_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateUnit", []))

    @jsii.member(jsii_name="resetBitrateValue")
    def reset_bitrate_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateValue", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnitInput")
    def bitrate_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bitrateUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateValueInput")
    def bitrate_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bitrateValueInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnit")
    def bitrate_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bitrateUnit"))

    @bitrate_unit.setter
    def bitrate_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742e9ddc79239f561e25445933d9630e541665a6ee791d86abe31679a8cc3b60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateUnit", value)

    @builtins.property
    @jsii.member(jsii_name="bitrateValue")
    def bitrate_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bitrateValue"))

    @bitrate_value.setter
    def bitrate_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a922889bd5f9d07c35091a37ea619382d2aa1106db580f859159fe772f6527e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c10ba19b2eab3868d0089ee593c587124f953e40c364f35ca30f5070ef9894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef11a75980d450e77d06879682d486780488ae668167bb43c28dc1abb3dad54f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBitrateTable")
    def put_bitrate_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add8583141ed5aae76ab083dd62666da5c377451c3490a61b7c9d0a5610762b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBitrateTable", [value]))

    @jsii.member(jsii_name="putThresholdTable")
    def put_threshold_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6011e78080e0de183f8d711561faedb0acf87ca88bb9a932d6312b53a236703d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putThresholdTable", [value]))

    @jsii.member(jsii_name="resetBitrateTable")
    def reset_bitrate_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateTable", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThresholdTable")
    def reset_threshold_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdTable", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateTable")
    def bitrate_table(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableList, jsii.get(self, "bitrateTable"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTable")
    def threshold_table(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableList", jsii.get(self, "thresholdTable"))

    @builtins.property
    @jsii.member(jsii_name="bitrateTableInput")
    def bitrate_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "bitrateTableInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTableInput")
    def threshold_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable"]]], jsii.get(self, "thresholdTableInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0bd60665b8a7f21522b1dbc7c0ea9f25cadd31bb86eada11e215282086fca75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44999dfd53d9a05d19861238b712849bb99a34a470e928e35746b5abb3338d6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b9559472f3ef93b4c21c7cc264bc7200de7aab371131774016dfae2756dd141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9c3cfd5c15ba2934c6046cb716504b5b57d0ba18f7e84caa973fdbcb9b8ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eaabc14bfdf24a2fe4a9f23d6251faba8541b9e0a28fe6846e520c365621fa3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable",
    jsii_struct_bases=[],
    name_mapping={
        "threshold_unit": "thresholdUnit",
        "threshold_value": "thresholdValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable:
    def __init__(
        self,
        *,
        threshold_unit: typing.Optional[builtins.str] = None,
        threshold_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param threshold_unit: The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        :param threshold_value: The numeric indicator of the minimum file size or elapsed download time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e51c6578e574e0f0555ca05d171f4421760d3a227df42602c9c1e96e1bcb37f9)
            check_type(argname="argument threshold_unit", value=threshold_unit, expected_type=type_hints["threshold_unit"])
            check_type(argname="argument threshold_value", value=threshold_value, expected_type=type_hints["threshold_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if threshold_unit is not None:
            self._values["threshold_unit"] = threshold_unit
        if threshold_value is not None:
            self._values["threshold_value"] = threshold_value

    @builtins.property
    def threshold_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        '''
        result = self._values.get("threshold_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the minimum file size or elapsed download time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        result = self._values.get("threshold_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190d4c5c38a5333957ef0b08d2e16b4999222e702617916314709d67d36fc8c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021241fca833145cbab1ff2a49383d7ed0229d5f132f6034ac2ea8efbcdab74d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530fb9579fe6c205295702b96b8c427928eea1df8453ff7814cfe91d24ce253a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89f1feb9e13cc5cc86548a2cd03d94c19894849a437992d2ce95bcf03825627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__accbcf542e4e5c1c48c37a686c6426a0d513d7c55d4773ea6a62b8efb9257d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35dd57489ca8ce2d3b6b454a27b1dbd9cd1802429bfc3443744d6b957e5ec3c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6435f10b9dbdc72710069d73fb53792887c1f6124eb0bd44ccf4b4ee12112581)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetThresholdUnit")
    def reset_threshold_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdUnit", []))

    @jsii.member(jsii_name="resetThresholdValue")
    def reset_threshold_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdValue", []))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnitInput")
    def threshold_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdValueInput")
    def threshold_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "thresholdValueInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnit")
    def threshold_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdUnit"))

    @threshold_unit.setter
    def threshold_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7643f18d2f1d0a362adc230264953b91718d5725799f1e414774cf70228dcb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdUnit", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdValue")
    def threshold_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "thresholdValue"))

    @threshold_value.setter
    def threshold_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5f1cd97e08dd0c300b6247417afa4a7a41c25ddfc37388c01fba93ae87887b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837b49885dc13d4fb42c47ff8f14cc7cb6b09b0eda9b6db833f55059ac9d26d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad1610ece0a96f6741f091aa325cdcd34e5827181f28d9095be31014dacc5d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c951667b9244f83ee9c4eed3dfa98f48d76bad3a3343dde06c32f4985ddefd8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8687b8b43de71e19d724c339e3815a38b0fef39a249c6c5f297a00162016ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012819f5f270e6ebc7c030a8a147fd5faf559332ec280583932a82a884eb660f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6891ffcc13952d4a09e15f7004ddd1f3aa93ff68424c8780675a6032cd866f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4addded43da36a548fef399eb8e69d42a3b53b3a15a141bf04d7428230896075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom",
    jsii_struct_bases=[],
    name_mapping={
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_custom_log_field": "logCustomLogField",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom:
    def __init__(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45017fb0d6403d043940ab7fb77d2b65c719718d40b74dfb31ec40dd311e6213)
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__084a07461076cc73350f8d579e2d7f76d37247af374e246e7f1872d877e78fa6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597dd118598238b088df79b50e4510e47d50a117368186dc952a8a21ffced755)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894f72ba6b84369adcbad68eaf42683a05b50ca51306f4fa9ccf1378e6377bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be38c5ef7b62415b1af0fccf472039466c77f9ad221ce27c40d0a70ed2f6b873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf889f97e2402c7d470d8952da1938877b846945065b316e03681c7d06b1193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68f0db8de985d4b77bf0ccea62b666f16875102d63855d36398161f5a4c86772)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9db0ceab2387a7b3feafe1b801d017ae12fc14a99904bcfd6065fa8b4ec6847f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse",
    jsii_struct_bases=[],
    name_mapping={
        "api_key": "apiKey",
        "buffer_size": "bufferSize",
        "config_override": "configOverride",
        "enabled": "enabled",
        "loader_version": "loaderVersion",
        "locked": "locked",
        "require_pci": "requirePci",
        "template_uuid": "templateUuid",
        "title_optional": "titleOptional",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse:
    def __init__(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0256dcda3abbf13c2c8c98118ec58b50ee44b5377aa8cc202af15e7c3a67150)
            check_type(argname="argument api_key", value=api_key, expected_type=type_hints["api_key"])
            check_type(argname="argument buffer_size", value=buffer_size, expected_type=type_hints["buffer_size"])
            check_type(argname="argument config_override", value=config_override, expected_type=type_hints["config_override"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument loader_version", value=loader_version, expected_type=type_hints["loader_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument require_pci", value=require_pci, expected_type=type_hints["require_pci"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_optional", value=title_optional, expected_type=type_hints["title_optional"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if api_key is not None:
            self._values["api_key"] = api_key
        if buffer_size is not None:
            self._values["buffer_size"] = buffer_size
        if config_override is not None:
            self._values["config_override"] = config_override
        if enabled is not None:
            self._values["enabled"] = enabled
        if loader_version is not None:
            self._values["loader_version"] = loader_version
        if locked is not None:
            self._values["locked"] = locked
        if require_pci is not None:
            self._values["require_pci"] = require_pci
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_optional is not None:
            self._values["title_optional"] = title_optional
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def api_key(self) -> typing.Optional[builtins.str]:
        '''This generated value uniquely identifies sections of your website for you to analyze independently.

        To access this value, see ``Enable mPulse in Property Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        '''
        result = self._values.get("api_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def buffer_size(self) -> typing.Optional[builtins.str]:
        '''Allows you to override the browser's default (150) maximum number of reported performance timeline entries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        '''
        result = self._values.get("buffer_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def config_override(self) -> typing.Optional[builtins.str]:
        '''A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs.

        It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``.  See ``Configuration Overrides`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        '''
        result = self._values.get("config_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies performance monitoring to this behavior's set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def loader_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        '''
        result = self._values.get("loader_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def require_pci(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        '''
        result = self._values.get("require_pci")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_optional(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        '''
        result = self._values.get("title_optional")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30abde26a0a26c92170d2cd7c1923d1d1e47e006ad8a90539fe9780b218f0d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApiKey")
    def reset_api_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiKey", []))

    @jsii.member(jsii_name="resetBufferSize")
    def reset_buffer_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBufferSize", []))

    @jsii.member(jsii_name="resetConfigOverride")
    def reset_config_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigOverride", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLoaderVersion")
    def reset_loader_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoaderVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequirePci")
    def reset_require_pci(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequirePci", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleOptional")
    def reset_title_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleOptional", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="apiKeyInput")
    def api_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="bufferSizeInput")
    def buffer_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bufferSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="configOverrideInput")
    def config_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="loaderVersionInput")
    def loader_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "loaderVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requirePciInput")
    def require_pci_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "requirePciInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleOptionalInput")
    def title_optional_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleOptionalInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="apiKey")
    def api_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiKey"))

    @api_key.setter
    def api_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9dfec2e68690675cc5e3f3c5c68729ff8fbb7b199252f418179d53894f44136)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiKey", value)

    @builtins.property
    @jsii.member(jsii_name="bufferSize")
    def buffer_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bufferSize"))

    @buffer_size.setter
    def buffer_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66dcd1a9cc456f488d36f7a36f48f96c3de91073a39651506c3fd12acdd42edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bufferSize", value)

    @builtins.property
    @jsii.member(jsii_name="configOverride")
    def config_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configOverride"))

    @config_override.setter
    def config_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ea5776501198af4e9c1a60acbcb695d899ee7e215b33cb4461510c8dc025b69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configOverride", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f56c04e5f6a17bb3369b792959f97ea3efb2b270c57597aa33de16783d9214e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="loaderVersion")
    def loader_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "loaderVersion"))

    @loader_version.setter
    def loader_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef21b0c929e978d06e6b567d1f2b426b2871663733dc72734b136717b8ef147a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loaderVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec110eed108a8a8eac7f851bc4ca90ea3937239df885c5521694875cacae5b02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requirePci")
    def require_pci(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "requirePci"))

    @require_pci.setter
    def require_pci(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411bf7043ba1c060f24a41557359404664ad0315c064061c204df69f490dcd37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requirePci", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0e8ef539b6c8519005f716bd49d0c2b1bd9e9fe64a9c7047fd47698a57b7f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleOptional")
    def title_optional(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleOptional"))

    @title_optional.setter
    def title_optional(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d546855150df4992bb62c7c126513c3df7f2722a1fbd87f15b57b94617026d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleOptional", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c845dd2f1f23958b6675c6e77833ddd0dcd20a50d14b2c03a75ef24ed051db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a105a67f72cd3eae4754d8e51079e155761df229760f9ff35ef2f365a563fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "hls_enabled": "hlsEnabled",
        "hls_enable_debug_headers": "hlsEnableDebugHeaders",
        "hls_filter_in_bitrate_ranges": "hlsFilterInBitrateRanges",
        "hls_filter_in_bitrates": "hlsFilterInBitrates",
        "hls_mode": "hlsMode",
        "hls_preferred_bitrate": "hlsPreferredBitrate",
        "hls_query_param_enabled": "hlsQueryParamEnabled",
        "hls_query_param_secret_key": "hlsQueryParamSecretKey",
        "hls_query_param_transition_key": "hlsQueryParamTransitionKey",
        "hls_show_advanced": "hlsShowAdvanced",
        "hls_title": "hlsTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c971e21b7c7bc3dba5f39396c2a2ecd09735ef5d75049390fe4a8bfcf0c9627b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hls_enabled", value=hls_enabled, expected_type=type_hints["hls_enabled"])
            check_type(argname="argument hls_enable_debug_headers", value=hls_enable_debug_headers, expected_type=type_hints["hls_enable_debug_headers"])
            check_type(argname="argument hls_filter_in_bitrate_ranges", value=hls_filter_in_bitrate_ranges, expected_type=type_hints["hls_filter_in_bitrate_ranges"])
            check_type(argname="argument hls_filter_in_bitrates", value=hls_filter_in_bitrates, expected_type=type_hints["hls_filter_in_bitrates"])
            check_type(argname="argument hls_mode", value=hls_mode, expected_type=type_hints["hls_mode"])
            check_type(argname="argument hls_preferred_bitrate", value=hls_preferred_bitrate, expected_type=type_hints["hls_preferred_bitrate"])
            check_type(argname="argument hls_query_param_enabled", value=hls_query_param_enabled, expected_type=type_hints["hls_query_param_enabled"])
            check_type(argname="argument hls_query_param_secret_key", value=hls_query_param_secret_key, expected_type=type_hints["hls_query_param_secret_key"])
            check_type(argname="argument hls_query_param_transition_key", value=hls_query_param_transition_key, expected_type=type_hints["hls_query_param_transition_key"])
            check_type(argname="argument hls_show_advanced", value=hls_show_advanced, expected_type=type_hints["hls_show_advanced"])
            check_type(argname="argument hls_title", value=hls_title, expected_type=type_hints["hls_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if hls_enabled is not None:
            self._values["hls_enabled"] = hls_enabled
        if hls_enable_debug_headers is not None:
            self._values["hls_enable_debug_headers"] = hls_enable_debug_headers
        if hls_filter_in_bitrate_ranges is not None:
            self._values["hls_filter_in_bitrate_ranges"] = hls_filter_in_bitrate_ranges
        if hls_filter_in_bitrates is not None:
            self._values["hls_filter_in_bitrates"] = hls_filter_in_bitrates
        if hls_mode is not None:
            self._values["hls_mode"] = hls_mode
        if hls_preferred_bitrate is not None:
            self._values["hls_preferred_bitrate"] = hls_preferred_bitrate
        if hls_query_param_enabled is not None:
            self._values["hls_query_param_enabled"] = hls_query_param_enabled
        if hls_query_param_secret_key is not None:
            self._values["hls_query_param_secret_key"] = hls_query_param_secret_key
        if hls_query_param_transition_key is not None:
            self._values["hls_query_param_transition_key"] = hls_query_param_transition_key
        if hls_show_advanced is not None:
            self._values["hls_show_advanced"] = hls_show_advanced
        if hls_title is not None:
            self._values["hls_title"] = hls_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Manifest Personalization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to customize the HLS master manifest that's sent to the requesting client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        '''
        result = self._values.get("hls_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enable_debug_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        '''
        result = self._values.get("hls_enable_debug_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_filter_in_bitrate_ranges(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        '''
        result = self._values.get("hls_filter_in_bitrate_ranges")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_filter_in_bitrates(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        '''
        result = self._values.get("hls_filter_in_bitrates")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_mode(self) -> typing.Optional[builtins.str]:
        '''Applies with ``hlsEnabled`` on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        '''
        result = self._values.get("hls_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_preferred_bitrate(self) -> typing.Optional[builtins.str]:
        '''Sets the preferred bit rate in Kbps.

        This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        '''
        result = self._values.get("hls_preferred_bitrate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies query parameters for the HLS master manifest to customize the manifest's content.

        Any settings specified in the query string override those already configured in Property Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        '''
        result = self._values.get("hls_query_param_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_query_param_secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a primary key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        '''
        result = self._values.get("hls_query_param_secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        '''
        result = self._values.get("hls_query_param_transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        '''
        result = self._values.get("hls_show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        '''
        result = self._values.get("hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b106fa593175f6db255d58f489dc3def17de337f3621ecfbf7290ca81c2407da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHlsEnabled")
    def reset_hls_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnabled", []))

    @jsii.member(jsii_name="resetHlsEnableDebugHeaders")
    def reset_hls_enable_debug_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnableDebugHeaders", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrateRanges")
    def reset_hls_filter_in_bitrate_ranges(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrateRanges", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrates")
    def reset_hls_filter_in_bitrates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrates", []))

    @jsii.member(jsii_name="resetHlsMode")
    def reset_hls_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMode", []))

    @jsii.member(jsii_name="resetHlsPreferredBitrate")
    def reset_hls_preferred_bitrate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsPreferredBitrate", []))

    @jsii.member(jsii_name="resetHlsQueryParamEnabled")
    def reset_hls_query_param_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamEnabled", []))

    @jsii.member(jsii_name="resetHlsQueryParamSecretKey")
    def reset_hls_query_param_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamSecretKey", []))

    @jsii.member(jsii_name="resetHlsQueryParamTransitionKey")
    def reset_hls_query_param_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamTransitionKey", []))

    @jsii.member(jsii_name="resetHlsShowAdvanced")
    def reset_hls_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsShowAdvanced", []))

    @jsii.member(jsii_name="resetHlsTitle")
    def reset_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeadersInput")
    def hls_enable_debug_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnableDebugHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnabledInput")
    def hls_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRangesInput")
    def hls_filter_in_bitrate_ranges_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitrateRangesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitratesInput")
    def hls_filter_in_bitrates_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitratesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsModeInput")
    def hls_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsModeInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrateInput")
    def hls_preferred_bitrate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsPreferredBitrateInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabledInput")
    def hls_query_param_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsQueryParamEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKeyInput")
    def hls_query_param_secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamSecretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKeyInput")
    def hls_query_param_transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamTransitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvancedInput")
    def hls_show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsShowAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsTitleInput")
    def hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79eac582dfea34a0ace78f74b4943daf81857ea3afdc55573655889f047c5667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnabled")
    def hls_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnabled"))

    @hls_enabled.setter
    def hls_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05952227a61a3033052295fa61fbe2223a1d23b1e66e8c3d68fd391e95ac2c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeaders")
    def hls_enable_debug_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnableDebugHeaders"))

    @hls_enable_debug_headers.setter
    def hls_enable_debug_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5face566e566151031f9edb8cde8139c4f9af291976112e900c3a444b55380db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnableDebugHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRanges")
    def hls_filter_in_bitrate_ranges(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrateRanges"))

    @hls_filter_in_bitrate_ranges.setter
    def hls_filter_in_bitrate_ranges(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78edb16b014679a3688ed5a04f9e9e56b7f435edb2e7e875dc08c291fe85d8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrateRanges", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrates")
    def hls_filter_in_bitrates(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrates"))

    @hls_filter_in_bitrates.setter
    def hls_filter_in_bitrates(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69c952a688beeef2c8613bb4f1c973d90d1d0a071bbfa3b86dc904311a74aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrates", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMode")
    def hls_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsMode"))

    @hls_mode.setter
    def hls_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ba86e8b66cc32eab47c59423bc1da8538eafa164747dd96cf67151a0c443446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMode", value)

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrate")
    def hls_preferred_bitrate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsPreferredBitrate"))

    @hls_preferred_bitrate.setter
    def hls_preferred_bitrate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9b3a3f36db4faee50a9c4cb7130ef1ef31443a04c38a1d6d462607bff8262f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsPreferredBitrate", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabled")
    def hls_query_param_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsQueryParamEnabled"))

    @hls_query_param_enabled.setter
    def hls_query_param_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e4b2f156d2c9410a7c877536689600132ec2eaac87ce9b00bf29ca138cde7b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKey")
    def hls_query_param_secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamSecretKey"))

    @hls_query_param_secret_key.setter
    def hls_query_param_secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__476fe0f681e60c66890d55c9ac94a508d29269cbe86ad4dfee9396e1973111eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamSecretKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKey")
    def hls_query_param_transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamTransitionKey"))

    @hls_query_param_transition_key.setter
    def hls_query_param_transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ddfd18fcf3bff92dcc7bfd21f683194d59eda0e664394028ac6dc5bd2b47cc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamTransitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvanced")
    def hls_show_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsShowAdvanced"))

    @hls_show_advanced.setter
    def hls_show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc9e5edb908957eb3f0ebb08022bc384035d696a57f6fad7f0bae2ca28382312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsShowAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="hlsTitle")
    def hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsTitle"))

    @hls_title.setter
    def hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9cf5b862a78c14b9124d70f7b1dce82c4ba773571aee6bd10acd6fab271d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1911c8be972405d642b018139863e200c8e99521381c4283f3156c736224c67b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a557837d21dbcd7a7c65527b384b6d280ba6316e173964305dcc1ab1e503ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faef811bd9d02ecf619441f24bf88ba6436650265cbf2c0bb21c5afcc5668fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60f1e14857473e267186869a36778a2947cc2cf0c8a947f7b5e0a1e4b75dbdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "partner": "partner",
        "template_uuid": "templateUuid",
        "username": "username",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777ab789b12dd47a3cb18bb7ec9e2f2b83992c82a167f5f47b176ccc721f92ae)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument partner", value=partner, expected_type=type_hints["partner"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument username", value=username, expected_type=type_hints["username"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if partner is not None:
            self._values["partner"] = partner
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if username is not None:
            self._values["username"] = username
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner(self) -> typing.Optional[builtins.str]:
        '''Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        '''
        result = self._values.get("partner")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def username(self) -> typing.Optional[builtins.str]:
        '''The user name for your Adobe Primetime account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        '''
        result = self._values.get("username")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd14267d245c198fcc50efadee394948652ae08293c9f3ca70a891d59d68af5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPartner")
    def reset_partner(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartner", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsername")
    def reset_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsername", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerInput")
    def partner_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usernameInput")
    def username_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usernameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d777fb91d4d5b498d9231056a300381a3031c9793533a1edc8a2f99962d9dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="partner")
    def partner(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partner"))

    @partner.setter
    def partner(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaca209057915fbc5a549060b18e6b5ce189946d0e14db6dbe6a57669e3045df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partner", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158295462241f391c66610a0fd9e49fc5a39fab1317254bc03061d10625bc3d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="username")
    def username(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "username"))

    @username.setter
    def username(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e125712593b7dacb85745c8122f268bb1d18dac18f1c70cafa7cbc687174db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "username", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__190cc75a2add055b13b4d350ed1f2743cda46f7bcf9155f7998218afb4163c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8111b27d8113343ae340f44e1565f7c81b9dda886220ffa367cdb280aff7a5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "serverpushlist": "serverpushlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b15c9c2af7f0118fb37d5332a93456ba6530a27ca7c6ce1e20f2149d71f40be)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serverpushlist", value=serverpushlist, expected_type=type_hints["serverpushlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if serverpushlist is not None:
            self._values["serverpushlist"] = serverpushlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serverpushlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of objects to load into the client browser's cache over HTTP2.

        Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        '''
        result = self._values.get("serverpushlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2373b2d9420b0f83ff332f5a35a7b256dca6f92c3c9cb2db1c033b5acc2c0e2f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServerpushlist")
    def reset_serverpushlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerpushlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serverpushlistInput")
    def serverpushlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "serverpushlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d69fab239ed7db79ef54bc7640689ff69a13deab724bd192799c762c78780c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serverpushlist")
    def serverpushlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "serverpushlist"))

    @serverpushlist.setter
    def serverpushlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d33b5f36eb6a57e2e0ef5553d8ac61a46836eb30133e6901b150306d7b41f82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serverpushlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2fdc7691ad62f0cbfb0d2a5d0f2af4a5a200071f259e8d1d52c1f1bb5b0a815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da3eb085226f84a8c977a4a8d5587f3b8550ea99f5fb072d9fefa791bf224a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c872e74619f3fbaa1e2019e1e9d48618c21dfd6a4f8e035cf3ca06eb19f4c3a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285469c6f0f6ae1621bc76e1fd288503f13041db22e5829246200ccd39a2bd66)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Media Acceleration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9efdbab1c9c63c92c314198150d85f5ef5f36f71e56a11f1553aefc0862774)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f91022a5013beb86065eff0b36a2a04e0df9d8fb76d53f966d83b7b1a438f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e285790c41b4a9afdd089c8df981a00d9357d04c096eccddc88f926b913633b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5bac3f771d20be7a30876a4499976df096c84011258e1753ce6e7a57675c02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878ed489618c3563725bcd7fb3c1b1802ec00c56ce55973210aa89e61b2c5b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__114309fb4cc609f6d7cadb130cee4dad36b6d053ed82985903b41d4b9ac80f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "optout": "optout",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bf197a3dc8c6d74f4ff493dcf4a880006e0390b4b73b72d96b17e73d64aef32)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optout", value=optout, expected_type=type_hints["optout"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if optout is not None:
            self._values["optout"] = optout
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optout(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        '''
        result = self._values.get("optout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c5fe77c8ccf27d75afcf145e09c5f2e5d5c2e8bba59682bfa95d6c9d82205f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptout")
    def reset_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptout", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optoutInput")
    def optout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optoutInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43fed24c148612d8cd33b271722c91570eefb59a8d1e335528559b44961f62f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optout")
    def optout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optout"))

    @optout.setter
    def optout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115682f185a7a31d5660a87aa90474e6872057cb3100489e3ad98ca5b3c36b61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optout", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b8acfd86bef2cbcf17d6916e4b4072b17301f2223f7c82a7ff31c1114fcaf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ede138cdbca2a3d47eabf4ddb55786f1aecb60aba5a040806cc6ad9e9ec152e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37cd93656b8952d830d873d069545e2a846815cf5ff947d1819a4fd58e55307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_id": "beaconId",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_hybrid_http_udp": "useHybridHttpUdp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient:
    def __init__(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c171f50d0b23212b225d61672238a9fffb7f7ee0e41e2f3ebf6daab9d5a4e0c6)
            check_type(argname="argument beacon_id", value=beacon_id, expected_type=type_hints["beacon_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_hybrid_http_udp", value=use_hybrid_http_udp, expected_type=type_hints["use_hybrid_http_udp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_id is not None:
            self._values["beacon_id"] = beacon_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_hybrid_http_udp is not None:
            self._values["use_hybrid_http_udp"] = use_hybrid_http_udp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ID of data source's beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        '''
        result = self._values.get("beacon_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables client-side download analytics.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_hybrid_http_udp(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the hybrid HTTP/UDP protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        '''
        result = self._values.get("use_hybrid_http_udp")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2ee3b77a531227edf8941069dac29b7d4fcbb41b0a217b5049dc4d731fd61a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconId")
    def reset_beacon_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHybridHttpUdp")
    def reset_use_hybrid_http_udp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHybridHttpUdp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconIdInput")
    def beacon_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdpInput")
    def use_hybrid_http_udp_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHybridHttpUdpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconId")
    def beacon_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconId"))

    @beacon_id.setter
    def beacon_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0974b4ec55d23a733f355faeb7e7576f419b8dd4e2e0b6f59dcee7d35ae1fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbba63125e9ce5dc1e71a112782213b8b7f21e536fb3d4711e17f71415adebd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38f94d7a66dead8be73256d351e7a8db885fec9172502d73aeb30c94bc8eb743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702b282763ccdb217bff86036f0c3bd560518f2f5cf1cede000071f8c61071b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdp")
    def use_hybrid_http_udp(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHybridHttpUdp"))

    @use_hybrid_http_udp.setter
    def use_hybrid_http_udp(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__816ce57ef1f2bc94c2478351b0aa91ec637d607920dafa260ee9e0fa4ea5b270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHybridHttpUdp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff5b1fef753b0a68667dff8aa74920ee70ef767deaba413cea221c523b8d0d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44900de6a805d3ff6b9a928f619ba448def719c3e15bdfe618b44a951373ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d528fb18251d3e53c4af40dd2be978e2829f39cf7c8a089ca0093fa92ae78a8)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the partial-object caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628ed98599eb562e92781ef8d0bde56c1c74acdf5b0e6483d6ab9491e5ec1489)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ec6dca758997feea288ac5a94da862cc8bb9b44210ddbb35e8e3120b4a5862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__814099e208e480b47b3fba47e77e55595b9bc0ef08e28c1477c78db02a98d75a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77724b4683d5a27730e63aeb20984de7786d43743f50daecb1cdd031aa29ee81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c503af70aa9af86001e6abda626b7df3f90bb8f0961638afc32227ff9496fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d02103858c302063fffce84dff24e619cc57fa52da2ef8372b6031d297985bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover",
    jsii_struct_bases=[],
    name_mapping={
        "cache_error_response": "cacheErrorResponse",
        "cache_window": "cacheWindow",
        "client_response_code": "clientResponseCode",
        "detect_object_unavailable": "detectObjectUnavailable",
        "detect_object_unavailable_title": "detectObjectUnavailableTitle",
        "detect_origin_unavailable": "detectOriginUnavailable",
        "detect_origin_unavailable_title": "detectOriginUnavailableTitle",
        "detect_origin_unresponsive": "detectOriginUnresponsive",
        "detect_origin_unresponsive_title": "detectOriginUnresponsiveTitle",
        "locked": "locked",
        "object_unavailable_alternate_host": "objectUnavailableAlternateHost",
        "object_unavailable_backup_host": "objectUnavailableBackupHost",
        "object_unavailable_blacklist_origin_ip": "objectUnavailableBlacklistOriginIp",
        "object_unavailable_blacklist_window": "objectUnavailableBlacklistWindow",
        "object_unavailable_change_protocol": "objectUnavailableChangeProtocol",
        "object_unavailable_detection_level": "objectUnavailableDetectionLevel",
        "object_unavailable_include_query_string": "objectUnavailableIncludeQueryString",
        "object_unavailable_modified_path": "objectUnavailableModifiedPath",
        "object_unavailable_modify_request_path": "objectUnavailableModifyRequestPath",
        "object_unavailable_protocol": "objectUnavailableProtocol",
        "object_unavailable_recovery": "objectUnavailableRecovery",
        "object_unavailable_redirect_method": "objectUnavailableRedirectMethod",
        "object_unavailable_response_codes": "objectUnavailableResponseCodes",
        "object_unavailable_retry_limit": "objectUnavailableRetryLimit",
        "origin_unavailable_alternate_host": "originUnavailableAlternateHost",
        "origin_unavailable_backup_host": "originUnavailableBackupHost",
        "origin_unavailable_blacklist_origin_ip": "originUnavailableBlacklistOriginIp",
        "origin_unavailable_blacklist_window": "originUnavailableBlacklistWindow",
        "origin_unavailable_change_protocol": "originUnavailableChangeProtocol",
        "origin_unavailable_detection_level": "originUnavailableDetectionLevel",
        "origin_unavailable_include_query_string": "originUnavailableIncludeQueryString",
        "origin_unavailable_modified_path": "originUnavailableModifiedPath",
        "origin_unavailable_modify_request_path": "originUnavailableModifyRequestPath",
        "origin_unavailable_protocol": "originUnavailableProtocol",
        "origin_unavailable_recovery": "originUnavailableRecovery",
        "origin_unavailable_redirect_method": "originUnavailableRedirectMethod",
        "origin_unavailable_response_codes": "originUnavailableResponseCodes",
        "origin_unavailable_retry_limit": "originUnavailableRetryLimit",
        "origin_unresponsive_alternate_host": "originUnresponsiveAlternateHost",
        "origin_unresponsive_backup_host": "originUnresponsiveBackupHost",
        "origin_unresponsive_blacklist_origin_ip": "originUnresponsiveBlacklistOriginIp",
        "origin_unresponsive_blacklist_window": "originUnresponsiveBlacklistWindow",
        "origin_unresponsive_change_protocol": "originUnresponsiveChangeProtocol",
        "origin_unresponsive_detection_level": "originUnresponsiveDetectionLevel",
        "origin_unresponsive_include_query_string": "originUnresponsiveIncludeQueryString",
        "origin_unresponsive_modified_path": "originUnresponsiveModifiedPath",
        "origin_unresponsive_modify_request_path": "originUnresponsiveModifyRequestPath",
        "origin_unresponsive_protocol": "originUnresponsiveProtocol",
        "origin_unresponsive_recovery": "originUnresponsiveRecovery",
        "origin_unresponsive_redirect_method": "originUnresponsiveRedirectMethod",
        "origin_unresponsive_retry_limit": "originUnresponsiveRetryLimit",
        "other_options": "otherOptions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover:
    def __init__(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915177bd286f7309236bb79116c7589483930e79e800d2f4e343fdfd4fec17b1)
            check_type(argname="argument cache_error_response", value=cache_error_response, expected_type=type_hints["cache_error_response"])
            check_type(argname="argument cache_window", value=cache_window, expected_type=type_hints["cache_window"])
            check_type(argname="argument client_response_code", value=client_response_code, expected_type=type_hints["client_response_code"])
            check_type(argname="argument detect_object_unavailable", value=detect_object_unavailable, expected_type=type_hints["detect_object_unavailable"])
            check_type(argname="argument detect_object_unavailable_title", value=detect_object_unavailable_title, expected_type=type_hints["detect_object_unavailable_title"])
            check_type(argname="argument detect_origin_unavailable", value=detect_origin_unavailable, expected_type=type_hints["detect_origin_unavailable"])
            check_type(argname="argument detect_origin_unavailable_title", value=detect_origin_unavailable_title, expected_type=type_hints["detect_origin_unavailable_title"])
            check_type(argname="argument detect_origin_unresponsive", value=detect_origin_unresponsive, expected_type=type_hints["detect_origin_unresponsive"])
            check_type(argname="argument detect_origin_unresponsive_title", value=detect_origin_unresponsive_title, expected_type=type_hints["detect_origin_unresponsive_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_unavailable_alternate_host", value=object_unavailable_alternate_host, expected_type=type_hints["object_unavailable_alternate_host"])
            check_type(argname="argument object_unavailable_backup_host", value=object_unavailable_backup_host, expected_type=type_hints["object_unavailable_backup_host"])
            check_type(argname="argument object_unavailable_blacklist_origin_ip", value=object_unavailable_blacklist_origin_ip, expected_type=type_hints["object_unavailable_blacklist_origin_ip"])
            check_type(argname="argument object_unavailable_blacklist_window", value=object_unavailable_blacklist_window, expected_type=type_hints["object_unavailable_blacklist_window"])
            check_type(argname="argument object_unavailable_change_protocol", value=object_unavailable_change_protocol, expected_type=type_hints["object_unavailable_change_protocol"])
            check_type(argname="argument object_unavailable_detection_level", value=object_unavailable_detection_level, expected_type=type_hints["object_unavailable_detection_level"])
            check_type(argname="argument object_unavailable_include_query_string", value=object_unavailable_include_query_string, expected_type=type_hints["object_unavailable_include_query_string"])
            check_type(argname="argument object_unavailable_modified_path", value=object_unavailable_modified_path, expected_type=type_hints["object_unavailable_modified_path"])
            check_type(argname="argument object_unavailable_modify_request_path", value=object_unavailable_modify_request_path, expected_type=type_hints["object_unavailable_modify_request_path"])
            check_type(argname="argument object_unavailable_protocol", value=object_unavailable_protocol, expected_type=type_hints["object_unavailable_protocol"])
            check_type(argname="argument object_unavailable_recovery", value=object_unavailable_recovery, expected_type=type_hints["object_unavailable_recovery"])
            check_type(argname="argument object_unavailable_redirect_method", value=object_unavailable_redirect_method, expected_type=type_hints["object_unavailable_redirect_method"])
            check_type(argname="argument object_unavailable_response_codes", value=object_unavailable_response_codes, expected_type=type_hints["object_unavailable_response_codes"])
            check_type(argname="argument object_unavailable_retry_limit", value=object_unavailable_retry_limit, expected_type=type_hints["object_unavailable_retry_limit"])
            check_type(argname="argument origin_unavailable_alternate_host", value=origin_unavailable_alternate_host, expected_type=type_hints["origin_unavailable_alternate_host"])
            check_type(argname="argument origin_unavailable_backup_host", value=origin_unavailable_backup_host, expected_type=type_hints["origin_unavailable_backup_host"])
            check_type(argname="argument origin_unavailable_blacklist_origin_ip", value=origin_unavailable_blacklist_origin_ip, expected_type=type_hints["origin_unavailable_blacklist_origin_ip"])
            check_type(argname="argument origin_unavailable_blacklist_window", value=origin_unavailable_blacklist_window, expected_type=type_hints["origin_unavailable_blacklist_window"])
            check_type(argname="argument origin_unavailable_change_protocol", value=origin_unavailable_change_protocol, expected_type=type_hints["origin_unavailable_change_protocol"])
            check_type(argname="argument origin_unavailable_detection_level", value=origin_unavailable_detection_level, expected_type=type_hints["origin_unavailable_detection_level"])
            check_type(argname="argument origin_unavailable_include_query_string", value=origin_unavailable_include_query_string, expected_type=type_hints["origin_unavailable_include_query_string"])
            check_type(argname="argument origin_unavailable_modified_path", value=origin_unavailable_modified_path, expected_type=type_hints["origin_unavailable_modified_path"])
            check_type(argname="argument origin_unavailable_modify_request_path", value=origin_unavailable_modify_request_path, expected_type=type_hints["origin_unavailable_modify_request_path"])
            check_type(argname="argument origin_unavailable_protocol", value=origin_unavailable_protocol, expected_type=type_hints["origin_unavailable_protocol"])
            check_type(argname="argument origin_unavailable_recovery", value=origin_unavailable_recovery, expected_type=type_hints["origin_unavailable_recovery"])
            check_type(argname="argument origin_unavailable_redirect_method", value=origin_unavailable_redirect_method, expected_type=type_hints["origin_unavailable_redirect_method"])
            check_type(argname="argument origin_unavailable_response_codes", value=origin_unavailable_response_codes, expected_type=type_hints["origin_unavailable_response_codes"])
            check_type(argname="argument origin_unavailable_retry_limit", value=origin_unavailable_retry_limit, expected_type=type_hints["origin_unavailable_retry_limit"])
            check_type(argname="argument origin_unresponsive_alternate_host", value=origin_unresponsive_alternate_host, expected_type=type_hints["origin_unresponsive_alternate_host"])
            check_type(argname="argument origin_unresponsive_backup_host", value=origin_unresponsive_backup_host, expected_type=type_hints["origin_unresponsive_backup_host"])
            check_type(argname="argument origin_unresponsive_blacklist_origin_ip", value=origin_unresponsive_blacklist_origin_ip, expected_type=type_hints["origin_unresponsive_blacklist_origin_ip"])
            check_type(argname="argument origin_unresponsive_blacklist_window", value=origin_unresponsive_blacklist_window, expected_type=type_hints["origin_unresponsive_blacklist_window"])
            check_type(argname="argument origin_unresponsive_change_protocol", value=origin_unresponsive_change_protocol, expected_type=type_hints["origin_unresponsive_change_protocol"])
            check_type(argname="argument origin_unresponsive_detection_level", value=origin_unresponsive_detection_level, expected_type=type_hints["origin_unresponsive_detection_level"])
            check_type(argname="argument origin_unresponsive_include_query_string", value=origin_unresponsive_include_query_string, expected_type=type_hints["origin_unresponsive_include_query_string"])
            check_type(argname="argument origin_unresponsive_modified_path", value=origin_unresponsive_modified_path, expected_type=type_hints["origin_unresponsive_modified_path"])
            check_type(argname="argument origin_unresponsive_modify_request_path", value=origin_unresponsive_modify_request_path, expected_type=type_hints["origin_unresponsive_modify_request_path"])
            check_type(argname="argument origin_unresponsive_protocol", value=origin_unresponsive_protocol, expected_type=type_hints["origin_unresponsive_protocol"])
            check_type(argname="argument origin_unresponsive_recovery", value=origin_unresponsive_recovery, expected_type=type_hints["origin_unresponsive_recovery"])
            check_type(argname="argument origin_unresponsive_redirect_method", value=origin_unresponsive_redirect_method, expected_type=type_hints["origin_unresponsive_redirect_method"])
            check_type(argname="argument origin_unresponsive_retry_limit", value=origin_unresponsive_retry_limit, expected_type=type_hints["origin_unresponsive_retry_limit"])
            check_type(argname="argument other_options", value=other_options, expected_type=type_hints["other_options"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_error_response is not None:
            self._values["cache_error_response"] = cache_error_response
        if cache_window is not None:
            self._values["cache_window"] = cache_window
        if client_response_code is not None:
            self._values["client_response_code"] = client_response_code
        if detect_object_unavailable is not None:
            self._values["detect_object_unavailable"] = detect_object_unavailable
        if detect_object_unavailable_title is not None:
            self._values["detect_object_unavailable_title"] = detect_object_unavailable_title
        if detect_origin_unavailable is not None:
            self._values["detect_origin_unavailable"] = detect_origin_unavailable
        if detect_origin_unavailable_title is not None:
            self._values["detect_origin_unavailable_title"] = detect_origin_unavailable_title
        if detect_origin_unresponsive is not None:
            self._values["detect_origin_unresponsive"] = detect_origin_unresponsive
        if detect_origin_unresponsive_title is not None:
            self._values["detect_origin_unresponsive_title"] = detect_origin_unresponsive_title
        if locked is not None:
            self._values["locked"] = locked
        if object_unavailable_alternate_host is not None:
            self._values["object_unavailable_alternate_host"] = object_unavailable_alternate_host
        if object_unavailable_backup_host is not None:
            self._values["object_unavailable_backup_host"] = object_unavailable_backup_host
        if object_unavailable_blacklist_origin_ip is not None:
            self._values["object_unavailable_blacklist_origin_ip"] = object_unavailable_blacklist_origin_ip
        if object_unavailable_blacklist_window is not None:
            self._values["object_unavailable_blacklist_window"] = object_unavailable_blacklist_window
        if object_unavailable_change_protocol is not None:
            self._values["object_unavailable_change_protocol"] = object_unavailable_change_protocol
        if object_unavailable_detection_level is not None:
            self._values["object_unavailable_detection_level"] = object_unavailable_detection_level
        if object_unavailable_include_query_string is not None:
            self._values["object_unavailable_include_query_string"] = object_unavailable_include_query_string
        if object_unavailable_modified_path is not None:
            self._values["object_unavailable_modified_path"] = object_unavailable_modified_path
        if object_unavailable_modify_request_path is not None:
            self._values["object_unavailable_modify_request_path"] = object_unavailable_modify_request_path
        if object_unavailable_protocol is not None:
            self._values["object_unavailable_protocol"] = object_unavailable_protocol
        if object_unavailable_recovery is not None:
            self._values["object_unavailable_recovery"] = object_unavailable_recovery
        if object_unavailable_redirect_method is not None:
            self._values["object_unavailable_redirect_method"] = object_unavailable_redirect_method
        if object_unavailable_response_codes is not None:
            self._values["object_unavailable_response_codes"] = object_unavailable_response_codes
        if object_unavailable_retry_limit is not None:
            self._values["object_unavailable_retry_limit"] = object_unavailable_retry_limit
        if origin_unavailable_alternate_host is not None:
            self._values["origin_unavailable_alternate_host"] = origin_unavailable_alternate_host
        if origin_unavailable_backup_host is not None:
            self._values["origin_unavailable_backup_host"] = origin_unavailable_backup_host
        if origin_unavailable_blacklist_origin_ip is not None:
            self._values["origin_unavailable_blacklist_origin_ip"] = origin_unavailable_blacklist_origin_ip
        if origin_unavailable_blacklist_window is not None:
            self._values["origin_unavailable_blacklist_window"] = origin_unavailable_blacklist_window
        if origin_unavailable_change_protocol is not None:
            self._values["origin_unavailable_change_protocol"] = origin_unavailable_change_protocol
        if origin_unavailable_detection_level is not None:
            self._values["origin_unavailable_detection_level"] = origin_unavailable_detection_level
        if origin_unavailable_include_query_string is not None:
            self._values["origin_unavailable_include_query_string"] = origin_unavailable_include_query_string
        if origin_unavailable_modified_path is not None:
            self._values["origin_unavailable_modified_path"] = origin_unavailable_modified_path
        if origin_unavailable_modify_request_path is not None:
            self._values["origin_unavailable_modify_request_path"] = origin_unavailable_modify_request_path
        if origin_unavailable_protocol is not None:
            self._values["origin_unavailable_protocol"] = origin_unavailable_protocol
        if origin_unavailable_recovery is not None:
            self._values["origin_unavailable_recovery"] = origin_unavailable_recovery
        if origin_unavailable_redirect_method is not None:
            self._values["origin_unavailable_redirect_method"] = origin_unavailable_redirect_method
        if origin_unavailable_response_codes is not None:
            self._values["origin_unavailable_response_codes"] = origin_unavailable_response_codes
        if origin_unavailable_retry_limit is not None:
            self._values["origin_unavailable_retry_limit"] = origin_unavailable_retry_limit
        if origin_unresponsive_alternate_host is not None:
            self._values["origin_unresponsive_alternate_host"] = origin_unresponsive_alternate_host
        if origin_unresponsive_backup_host is not None:
            self._values["origin_unresponsive_backup_host"] = origin_unresponsive_backup_host
        if origin_unresponsive_blacklist_origin_ip is not None:
            self._values["origin_unresponsive_blacklist_origin_ip"] = origin_unresponsive_blacklist_origin_ip
        if origin_unresponsive_blacklist_window is not None:
            self._values["origin_unresponsive_blacklist_window"] = origin_unresponsive_blacklist_window
        if origin_unresponsive_change_protocol is not None:
            self._values["origin_unresponsive_change_protocol"] = origin_unresponsive_change_protocol
        if origin_unresponsive_detection_level is not None:
            self._values["origin_unresponsive_detection_level"] = origin_unresponsive_detection_level
        if origin_unresponsive_include_query_string is not None:
            self._values["origin_unresponsive_include_query_string"] = origin_unresponsive_include_query_string
        if origin_unresponsive_modified_path is not None:
            self._values["origin_unresponsive_modified_path"] = origin_unresponsive_modified_path
        if origin_unresponsive_modify_request_path is not None:
            self._values["origin_unresponsive_modify_request_path"] = origin_unresponsive_modify_request_path
        if origin_unresponsive_protocol is not None:
            self._values["origin_unresponsive_protocol"] = origin_unresponsive_protocol
        if origin_unresponsive_recovery is not None:
            self._values["origin_unresponsive_recovery"] = origin_unresponsive_recovery
        if origin_unresponsive_redirect_method is not None:
            self._values["origin_unresponsive_redirect_method"] = origin_unresponsive_redirect_method
        if origin_unresponsive_retry_limit is not None:
            self._values["origin_unresponsive_retry_limit"] = origin_unresponsive_retry_limit
        if other_options is not None:
            self._values["other_options"] = other_options
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cache_error_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches the error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        '''
        result = self._values.get("cache_error_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_window(self) -> typing.Optional[builtins.str]:
        '''This sets error response's TTL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        '''
        result = self._values.get("cache_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_response_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the response code served to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        '''
        result = self._values.get("client_response_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_object_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin has content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        '''
        result = self._values.get("detect_object_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_object_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        '''
        result = self._values.get("detect_object_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin server responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        '''
        result = self._values.get("detect_origin_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        '''
        result = self._values.get("detect_origin_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unresponsive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure what happens when the origin is unresponsive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        '''
        result = self._values.get("detect_origin_unresponsive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unresponsive_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        '''
        result = self._values.get("detect_origin_unresponsive_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        '''
        result = self._values.get("object_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        '''
        result = self._values.get("object_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("object_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        '''
        result = self._values.get("object_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Changes the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        '''
        result = self._values.get("object_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        '''
        result = self._values.get("object_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        '''
        result = self._values.get("object_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        '''
        result = self._values.get("object_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to modify the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        '''
        result = self._values.get("object_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        '''
        result = self._values.get("object_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        '''
        result = self._values.get("object_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        '''
        result = self._values.get("object_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def object_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when there are content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        '''
        result = self._values.get("object_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def object_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        '''
        result = self._values.get("object_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        '''
        result = self._values.get("origin_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        '''
        result = self._values.get("origin_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        '''
        result = self._values.get("origin_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        '''
        result = self._values.get("origin_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        '''
        result = self._values.get("origin_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        '''
        result = self._values.get("origin_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        '''
        result = self._values.get("origin_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        '''
        result = self._values.get("origin_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        '''
        result = self._values.get("origin_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        '''
        result = self._values.get("origin_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies either a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        '''
        result = self._values.get("origin_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when the origin responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        '''
        result = self._values.get("origin_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origin_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        '''
        result = self._values.get("origin_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        '''
        result = self._values.get("origin_unresponsive_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        '''
        result = self._values.get("origin_unresponsive_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unresponsive_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        '''
        result = self._values.get("origin_unresponsive_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This allows you to change the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        '''
        result = self._values.get("origin_unresponsive_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify the level of response to slow origin connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        '''
        result = self._values.get("origin_unresponsive_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        '''
        result = self._values.get("origin_unresponsive_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        '''
        result = self._values.get("origin_unresponsive_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        '''
        result = self._values.get("origin_unresponsive_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies which protocol to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        '''
        result = self._values.get("origin_unresponsive_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        '''
        result = self._values.get("origin_unresponsive_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        '''
        result = self._values.get("origin_unresponsive_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unresponsive_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        '''
        result = self._values.get("origin_unresponsive_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def other_options(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        '''
        result = self._values.get("other_options")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1d79e6d330a32f3a5fc7142dcc7898c56748a6a521d84c23b9e60d6097c21c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCacheErrorResponse")
    def reset_cache_error_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheErrorResponse", []))

    @jsii.member(jsii_name="resetCacheWindow")
    def reset_cache_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheWindow", []))

    @jsii.member(jsii_name="resetClientResponseCode")
    def reset_client_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientResponseCode", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailable")
    def reset_detect_object_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailable", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailableTitle")
    def reset_detect_object_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailable")
    def reset_detect_origin_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailable", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailableTitle")
    def reset_detect_origin_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsive")
    def reset_detect_origin_unresponsive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsive", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsiveTitle")
    def reset_detect_origin_unresponsive_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsiveTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectUnavailableAlternateHost")
    def reset_object_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBackupHost")
    def reset_object_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistOriginIp")
    def reset_object_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistWindow")
    def reset_object_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetObjectUnavailableChangeProtocol")
    def reset_object_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableDetectionLevel")
    def reset_object_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetObjectUnavailableIncludeQueryString")
    def reset_object_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifiedPath")
    def reset_object_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifyRequestPath")
    def reset_object_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableProtocol")
    def reset_object_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableRecovery")
    def reset_object_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRecovery", []))

    @jsii.member(jsii_name="resetObjectUnavailableRedirectMethod")
    def reset_object_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetObjectUnavailableResponseCodes")
    def reset_object_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetObjectUnavailableRetryLimit")
    def reset_object_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnavailableAlternateHost")
    def reset_origin_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBackupHost")
    def reset_origin_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistOriginIp")
    def reset_origin_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistWindow")
    def reset_origin_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnavailableChangeProtocol")
    def reset_origin_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableDetectionLevel")
    def reset_origin_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnavailableIncludeQueryString")
    def reset_origin_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifiedPath")
    def reset_origin_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifyRequestPath")
    def reset_origin_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableProtocol")
    def reset_origin_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableRecovery")
    def reset_origin_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRecovery", []))

    @jsii.member(jsii_name="resetOriginUnavailableRedirectMethod")
    def reset_origin_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnavailableResponseCodes")
    def reset_origin_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetOriginUnavailableRetryLimit")
    def reset_origin_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveAlternateHost")
    def reset_origin_unresponsive_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBackupHost")
    def reset_origin_unresponsive_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistOriginIp")
    def reset_origin_unresponsive_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistWindow")
    def reset_origin_unresponsive_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveChangeProtocol")
    def reset_origin_unresponsive_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveDetectionLevel")
    def reset_origin_unresponsive_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveIncludeQueryString")
    def reset_origin_unresponsive_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifiedPath")
    def reset_origin_unresponsive_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifyRequestPath")
    def reset_origin_unresponsive_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveProtocol")
    def reset_origin_unresponsive_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRecovery")
    def reset_origin_unresponsive_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRecovery", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRedirectMethod")
    def reset_origin_unresponsive_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRetryLimit")
    def reset_origin_unresponsive_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRetryLimit", []))

    @jsii.member(jsii_name="resetOtherOptions")
    def reset_other_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOtherOptions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponseInput")
    def cache_error_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheErrorResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheWindowInput")
    def cache_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="clientResponseCodeInput")
    def client_response_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableInput")
    def detect_object_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectObjectUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitleInput")
    def detect_object_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectObjectUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableInput")
    def detect_origin_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitleInput")
    def detect_origin_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveInput")
    def detect_origin_unresponsive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnresponsiveInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitleInput")
    def detect_origin_unresponsive_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnresponsiveTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHostInput")
    def object_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHostInput")
    def object_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIpInput")
    def object_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindowInput")
    def object_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocolInput")
    def object_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevelInput")
    def object_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryStringInput")
    def object_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPathInput")
    def object_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPathInput")
    def object_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocolInput")
    def object_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecoveryInput")
    def object_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethodInput")
    def object_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "objectUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodesInput")
    def object_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "objectUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimitInput")
    def object_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHostInput")
    def origin_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHostInput")
    def origin_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIpInput")
    def origin_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindowInput")
    def origin_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocolInput")
    def origin_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevelInput")
    def origin_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryStringInput")
    def origin_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPathInput")
    def origin_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPathInput")
    def origin_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocolInput")
    def origin_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecoveryInput")
    def origin_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethodInput")
    def origin_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodesInput")
    def origin_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimitInput")
    def origin_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHostInput")
    def origin_unresponsive_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHostInput")
    def origin_unresponsive_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIpInput")
    def origin_unresponsive_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindowInput")
    def origin_unresponsive_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocolInput")
    def origin_unresponsive_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevelInput")
    def origin_unresponsive_detection_level_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryStringInput")
    def origin_unresponsive_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPathInput")
    def origin_unresponsive_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPathInput")
    def origin_unresponsive_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocolInput")
    def origin_unresponsive_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecoveryInput")
    def origin_unresponsive_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethodInput")
    def origin_unresponsive_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnresponsiveRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimitInput")
    def origin_unresponsive_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="otherOptionsInput")
    def other_options_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "otherOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponse")
    def cache_error_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheErrorResponse"))

    @cache_error_response.setter
    def cache_error_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2e648eb2e2b016ad78a7625325e0d99443ee2ac360942d1880c7425482ba482)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheErrorResponse", value)

    @builtins.property
    @jsii.member(jsii_name="cacheWindow")
    def cache_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheWindow"))

    @cache_window.setter
    def cache_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7f0d9ac0ceedac37305c278024c14432c49b71f70f13112faf7029b34211531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheWindow", value)

    @builtins.property
    @jsii.member(jsii_name="clientResponseCode")
    def client_response_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientResponseCode"))

    @client_response_code.setter
    def client_response_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b2f9abd7b865eeae1511aefb25411bbec295d782074259816ac184b4357508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailable")
    def detect_object_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectObjectUnavailable"))

    @detect_object_unavailable.setter
    def detect_object_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a906b8492156167f40ce6ac53280f9019334ff171495e753055d3bce1ebbec39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitle")
    def detect_object_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectObjectUnavailableTitle"))

    @detect_object_unavailable_title.setter
    def detect_object_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e9f066eda64a19007248137d11477219ecdfeb73f2a7c1c01ec5312497a0c5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailable")
    def detect_origin_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnavailable"))

    @detect_origin_unavailable.setter
    def detect_origin_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aef57ea3482952b2cc45ade380edde58a0793fba03c487bd8e88045a2188a5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitle")
    def detect_origin_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnavailableTitle"))

    @detect_origin_unavailable_title.setter
    def detect_origin_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__018ad077a5c34a5d7a60e37eef570a7f52d06c89312b53ee9cd50b37f46e87e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsive")
    def detect_origin_unresponsive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnresponsive"))

    @detect_origin_unresponsive.setter
    def detect_origin_unresponsive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0fc16c52718b05c779d1f30475f0bc6689427aff2d7126071326584463d5e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsive", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitle")
    def detect_origin_unresponsive_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnresponsiveTitle"))

    @detect_origin_unresponsive_title.setter
    def detect_origin_unresponsive_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887c4ba8d26bb08b3871a4ec956adbbb53bebc579c994fcebd888ca1fe2df146)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsiveTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13e5f8e0fcf82815a544e9bba3887245b36dc30a9f587c231e26f49a098d18a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHost")
    def object_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableAlternateHost"))

    @object_unavailable_alternate_host.setter
    def object_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f4c7372c0a1771a4571da59f53db0721bbdf738c91c2ae630f20416ca5cc18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHost")
    def object_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBackupHost"))

    @object_unavailable_backup_host.setter
    def object_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b2bf9e8b6eff0d52f1d717d81d780498804b53f53e0edb7aad9fb094d4f7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIp")
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableBlacklistOriginIp"))

    @object_unavailable_blacklist_origin_ip.setter
    def object_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52cfaa867fa9fe66188d79db22cdfcf9d9f920f60507da8cf0d221306707a90b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindow")
    def object_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBlacklistWindow"))

    @object_unavailable_blacklist_window.setter
    def object_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a1fe04e1ab9f5ebd0a9dc5ec11aa128dc8a545a503aec8b1b625fe17f3ef46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocol")
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableChangeProtocol"))

    @object_unavailable_change_protocol.setter
    def object_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a35ed81bb136c215412d2b02cb6518836dfc65d940847b58147e55391193453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevel")
    def object_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableDetectionLevel"))

    @object_unavailable_detection_level.setter
    def object_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdfda4e317c7b6892404cc7393b02883fd208fece908c070c977dc067a55617c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryString")
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableIncludeQueryString"))

    @object_unavailable_include_query_string.setter
    def object_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__239d066b53cc3ad6fbbef34b1edffa2be2aaa2c007ff37a0e9c863d00fe52813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPath")
    def object_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableModifiedPath"))

    @object_unavailable_modified_path.setter
    def object_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e60166c7815d3df0dc316879383c5d76c73bfa30df79bda5d8b952ad454a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPath")
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableModifyRequestPath"))

    @object_unavailable_modify_request_path.setter
    def object_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f63898283c517496f791c39fc500a251fa714791d2b49b246a736657e1623cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocol")
    def object_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableProtocol"))

    @object_unavailable_protocol.setter
    def object_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060a994010a989771d71bca5a3f2b09f781b2f612c7d1172b2fe8f2fd747f7ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecovery")
    def object_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRecovery"))

    @object_unavailable_recovery.setter
    def object_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b56d429331ba567fbb79333ffd1fdf47505df59e7b19287c21cd415f550f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethod")
    def object_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "objectUnavailableRedirectMethod"))

    @object_unavailable_redirect_method.setter
    def object_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d59261b4a9471c7c2bd3bd937f9930f8c165040412e8c3ae6c9c6f9d7f783da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodes")
    def object_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "objectUnavailableResponseCodes"))

    @object_unavailable_response_codes.setter
    def object_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__441452a784d0d4b52f36acdd941bb80dfe64651ad7c3bd66563d33ca1ae4d361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimit")
    def object_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRetryLimit"))

    @object_unavailable_retry_limit.setter
    def object_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a36e052468339544492a97c03ebab6fd5b1254a8d6e71cf2ea081de4588c430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHost")
    def origin_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableAlternateHost"))

    @origin_unavailable_alternate_host.setter
    def origin_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b17a08e3c36573fbf1958c7b9e193461449e32ee246499a1952f7bbb357443b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHost")
    def origin_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBackupHost"))

    @origin_unavailable_backup_host.setter
    def origin_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3844aff9136d291e050dc71a5fe4aaf4dd13075e9750cead8ef379f74af60048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIp")
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableBlacklistOriginIp"))

    @origin_unavailable_blacklist_origin_ip.setter
    def origin_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893480873f3577996834b80558424100e4fdfe7201a0cd44332b5ed796e02790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindow")
    def origin_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBlacklistWindow"))

    @origin_unavailable_blacklist_window.setter
    def origin_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470a409b9d4f89832f48ae364ba4381c99c40aea3863c51c8a67c6dce2c42836)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocol")
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableChangeProtocol"))

    @origin_unavailable_change_protocol.setter
    def origin_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e232579f12715b2bc5c971d32a772eab325646b7a44c34ea9c2bf9e642e3217e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevel")
    def origin_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableDetectionLevel"))

    @origin_unavailable_detection_level.setter
    def origin_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8638aa80aa8d5336cc463e6bb7c355da0a62a6a277b3869e3be4d593ea3114e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryString")
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableIncludeQueryString"))

    @origin_unavailable_include_query_string.setter
    def origin_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ae82509a3111db24944133f7d8f328f4c0c812504267b7bf08da5b33b3a536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPath")
    def origin_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableModifiedPath"))

    @origin_unavailable_modified_path.setter
    def origin_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30947fc92ce96cdac902a6dac5e3f6d9e0b3e40f6ee5dc4ac81f518caf1563cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPath")
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableModifyRequestPath"))

    @origin_unavailable_modify_request_path.setter
    def origin_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d64219eb6a5f7c855eb04a7fd7b1fe243324e9acf5c4fccbc34aa80144721e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocol")
    def origin_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableProtocol"))

    @origin_unavailable_protocol.setter
    def origin_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28e6a1e560ebf0cbfd78083a93736bc2e0e71c53bad17b2ca3dc6c685bc9ac1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecovery")
    def origin_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRecovery"))

    @origin_unavailable_recovery.setter
    def origin_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b9fc88703d0cc1a579b083fbfa9176b102931226758238ffb008c25af988a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethod")
    def origin_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnavailableRedirectMethod"))

    @origin_unavailable_redirect_method.setter
    def origin_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0244d883bad9c23ed654240be8981b2d57406b5b39cc1bc2d12b4ad5ee0c530f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodes")
    def origin_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "originUnavailableResponseCodes"))

    @origin_unavailable_response_codes.setter
    def origin_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e5278d5feda7aa84ee9d386bcd8a6e890befaeffcac50ceddc288a3337fd012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimit")
    def origin_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRetryLimit"))

    @origin_unavailable_retry_limit.setter
    def origin_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a64bf3d560c1e99c11a456d8d5ba65599f7a35a95dce98ba5384d18dc80ba9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHost")
    def origin_unresponsive_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveAlternateHost"))

    @origin_unresponsive_alternate_host.setter
    def origin_unresponsive_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0faf88169ac6b27b1a872a476959a4e1102c09b806584903481fabb8dca7e0fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHost")
    def origin_unresponsive_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBackupHost"))

    @origin_unresponsive_backup_host.setter
    def origin_unresponsive_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33354371a72418442e0f9b20a0d31b85fa5598b296f02913b0a1815760e04a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIp")
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveBlacklistOriginIp"))

    @origin_unresponsive_blacklist_origin_ip.setter
    def origin_unresponsive_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec26a79aceb5c7343f329cc25c82b4efab58f38993abb0ed54c2b728abbefb5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindow")
    def origin_unresponsive_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBlacklistWindow"))

    @origin_unresponsive_blacklist_window.setter
    def origin_unresponsive_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540d8da475ee08bf36cc84838b17d76ae83d5035ad67459de202b0dc92240ac6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocol")
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveChangeProtocol"))

    @origin_unresponsive_change_protocol.setter
    def origin_unresponsive_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc60638c1278c4bce9a2dcb584bf51886ed0e24cc579d4b3c4f7e5db490da598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevel")
    def origin_unresponsive_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveDetectionLevel"))

    @origin_unresponsive_detection_level.setter
    def origin_unresponsive_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10dab612b37f3e4ffd29f936761047fac0cec4c8576d802fef7aecd26a27b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryString")
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveIncludeQueryString"))

    @origin_unresponsive_include_query_string.setter
    def origin_unresponsive_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf9ef117c1ff79db9e602136f27c1c71cbfb6d81c51f1ea411bda9d516d0a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPath")
    def origin_unresponsive_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveModifiedPath"))

    @origin_unresponsive_modified_path.setter
    def origin_unresponsive_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__572a5a855b2a48a573f054957c06f7f9e75646901b443c6f08d79bcdd2289fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPath")
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveModifyRequestPath"))

    @origin_unresponsive_modify_request_path.setter
    def origin_unresponsive_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d1a46c7a456b30fc29df6295dc09f5a3149ad6e2cb6b45bf29ec0d32a12fb72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocol")
    def origin_unresponsive_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveProtocol"))

    @origin_unresponsive_protocol.setter
    def origin_unresponsive_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85e45012528cc00851a15f636df2edc59a1c9199c029a80ee85dbcb1ae19f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecovery")
    def origin_unresponsive_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRecovery"))

    @origin_unresponsive_recovery.setter
    def origin_unresponsive_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c377916432b0e999261e787c91f8b0315187cd17cedb3eaaa32a0f4c971b3ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethod")
    def origin_unresponsive_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnresponsiveRedirectMethod"))

    @origin_unresponsive_redirect_method.setter
    def origin_unresponsive_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc3d8da30f16819f3ac717fc840dd347308faefbabfaa3cf5453570dc7e1aab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimit")
    def origin_unresponsive_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRetryLimit"))

    @origin_unresponsive_retry_limit.setter
    def origin_unresponsive_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f2d8cfe821e823b4ef8cb53e462fc62a7f7402e2903c075aebe8509dd6d814a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="otherOptions")
    def other_options(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "otherOptions"))

    @other_options.setter
    def other_options(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9372c3fb4b0948327aa5b0fdcaac8d3fc1591dc98620e3ed7bdfe2802ba9ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "otherOptions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01133d55c48705ec9dcb21d4b8f055c27f34ab78ff83992f9d119976e8223992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43925f93a1dacf7a6bc12ddee9ed08007f9b3ad1555582c74e22eb6fcdc13526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e694cbb5385d58f747ac5945486ed55d7ec560daabebe2fb07fa2de24411285f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e826bc062fd9783bbdcfac4fa23faa4ce225391ceabd28815a405925671bd1)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables metadata caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f06d8232a59cb5ccf0750c3ff6f065e96907dfb8b94d14c409ecee4cb4493d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc253fd08b0326f7fad41f3ebd76905b7370bda1df9ada6faf85ff36c311dbbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47fb30dd0e56fa73218a083363fdac9fd8bbf7114c4c96f0e5fcdf2f2fca76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6689100e1cc53a0f0faf889793d19fabb62586f703e6fb9076c53ef26363b07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f96d016f13a9c690090070f8d70f7dac02ffdbf852311e7e25626f5db5ce31d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bd65d03e032b034d7e65a22a93c2a1300024bd378cdca34990b9bd1d76d6943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "secondary_multipath_to_origin": "secondaryMultipathToOrigin",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf3ffa680a21221f8752b4eb0397f4434022ce9177689b554b6f7ea1c7211bad)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument secondary_multipath_to_origin", value=secondary_multipath_to_origin, expected_type=type_hints["secondary_multipath_to_origin"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if secondary_multipath_to_origin is not None:
            self._values["secondary_multipath_to_origin"] = secondary_multipath_to_origin
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Mobile App Performance SDK.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends secondary multi-path requests to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        '''
        result = self._values.get("secondary_multipath_to_origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b86fe481a201dc4fa76c0fd1e4332a5361875eea5716ffefa537a45fb1c0f868)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondaryMultipathToOrigin")
    def reset_secondary_multipath_to_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondaryMultipathToOrigin", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOriginInput")
    def secondary_multipath_to_origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondaryMultipathToOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be4f891e27d0848b17476f3610314d898525e8861fefe9a01d734ed1c4e4f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be007369f5540109a78181ba86dcb744cdd1a2f612e46fd5679631eb1c27e43d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOrigin")
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondaryMultipathToOrigin"))

    @secondary_multipath_to_origin.setter
    def secondary_multipath_to_origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83bd43fe16ffe3e38bc9b79f6a777d4c20c0642157506512f97c34a92279e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondaryMultipathToOrigin", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__579926a1c76b1eb7c0a5fdea50dcd71d3f92ff487f6be95d0d4e2f9f1498f59f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9662de27a8bdfffdd6a1d3be89bc532394e45bb46f57ea0e29ec4e017c03c829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d698c897ff3df65fb62e9e2d7669f07cc9a58d104bf4d65070cd41346d628ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1201fc4da69252384c22727793f582738db3e7f87be54553518d181de8a4ca15)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Supplies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8319ab64d90213ad5af85b3c8108c896b94e3423cc6adb6343ac5b7839a7d8d8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc0f9bd385a51bc0eb9bee84f51696b93acb6554ae3483a9dc8cb3878a232d79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf2f9bdd3fa20d44b72a0f0c378c99e72b528f4078855885977cf88da542acc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee2970ec058183b57b5492681e8dd6dc7fe4801ea15a7d50a73245bfb04219e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1c2415a726ba467567162ac800c429705999c5617020cbbffcf01c4521a314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b9f49542bc9235bdea91d59475da651d2aa3c8216817370805cdf9ae587bfd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0a192e152636deaded8385351cbf7a55212b80dbdd02cd0bfbb87b08949f86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f14d0df5ead1465f4be1d96b0db2d5cb76b9d708b5d9e9f8276b231d505724b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e4131da8045033ad5c2ce847210ef491b004fdce781a667587b77fd3c3ae67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__443e07b438c89caa29b6a7564f3e7cbae8359954c17404fc487b4cef0feda718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cabdf3876efa74fae10a850696434a7a70d7fec1854fb115d8e70e8bd61e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39d2f3fe152b87d519a4002ce5fd8ea844079053f447521f5bc74590955212f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ceaaba1d6c2bda25922e8aaff5fdd1872ec2a61ce4cbda9a6dc99f17d234c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee28fa2a2761d0a4379f86352c9ed028650ac01425e2309d085bd189784134ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d1756cc7d89fe4d4842bcb8925a751ee09ac328e761cac839555bf38d9cb00)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the header's new value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749940241e75205232edb2b34422afb643a50a8443db31261aa997c83ee2ec0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1af29beaa2f17a6ff4e93abd32c82eb10e54b030312422ea2de31703fa60b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61e87c161c8bdc8bc6988f639ed788c93e462ee06182d99e70250461dddce10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b253ec0978ca69974531a63a924becc79dd8542d630f345b6665c5491724dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15bcd15e2c1b2d0f425135092d0cc6957f4a8e3a401e45d6cd552d79492bb81d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ff6cb183be98dfc9d6393e45f0e8428d433504955e188e8867ce04c5a32751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d658a4b5f3fad283b66353e64423010de7b5569528eac280499ceadcf2f854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bea217c69718bc5afff0a6136ab8456357fc86408cc693c6f6c0ec55e00b4cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c5c4b2b67b97b8652ac74e6e7123dee19c1f51ed5cb69272f51b1064d6984a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070c4b1520f726148ee00a0406e257fe71db1eccb3e88320d97482fec5549118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec8e2887e5ac98b6b959db8cdbf01da391587084aee772f22e50677189b245a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff8f61128c33d81460c31e8bc7eef378747b7074efe0357c8a0e5a9788e1d46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70484dc2ba74dfb269474bfb696796d8b6dd807927ac4f3194a67ae65018e83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f136cd0ad9a444d035f277d921d21ec9b2cf6ec914e57741f4d3e45ebf7f03e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__671687e9c24927a697be7dad43a1d75abda9e857ecb501d7da0574f7ce8895ea)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8bcdc1d91c42419a603b06cff2447f798a60f3ed1b53d7dd780bbd4731d778)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3710e38c366f04b40e51b1afd84be3f4b560b8c9976c4d5e9d1831ccbb345a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff8b5b166081b0a9a1e67157f364d419b42a2169546f414b7b05a0d74181ed6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae830ff8b62ff03bcdd43ecf5586961bddb1b4bf8250c04ec628bb9b6ff7cb2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0894c134f2ee73a19fce8cb3d2a281968958ca0492adb39fe2758d5827abacfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f062429d2b304a7faced59f30e6ae4aec9b755ce7294c4b94f48a12a493407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3966b9f37c3331bb2cb853524ec4e468c288811e1173dcc2e238b03af2ca8aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ccbbfcf436c4207cccfec9744f24533573eb18be2efe863c034e4c46c681604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e42869c617262130c3131f5528ec3e1c5d40c0e0d5dc652b4766eac86b23f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495d574a51be66b3f57c23f1390734fe4c3c3ce61176c0d0eecb33d671a43d9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02461cc113aad5c50cae9abfcf46359415ebe2eeac35b5e2cd73570ed5648cdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf7e8b2cecabb6d96220228cd97f717e6403758cb2c957f6b934ca828df5c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c6e696e1ce5f8361c1b6411a4781b451413669784c8c08dc45f2abe8a2c382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981246d31af79dca6365cc489a97611bbd009ece0e2155bc3731779030630578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6fb9e5f48ffb0135ebfd4b99a0186be32bc8e48b05945c0d91bd05cfbcf45d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3410268a7fea9f313bb5981ae25bac8d099629b97949e3bbd27c79881f33a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40922182fb56b0b4a34db83c8b1da100012080dfcf32108fc7f6462d435ccaf)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the existing value of the header to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72469bc097baefbbb7bbd9922cc5599994ef86d9587979e467f8b48d0261d09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b516f201eea3a8721ee1a3852ce9f397b5435d8d7d36886f116d8a322e0a8184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__959c290739454f04e7a37cc74b132b9ef94c71cd3ccd3aac36e0842d160ba306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a41d1bf9cc3fc39f568fd51a5035f4a342763d92aff11d72d9ba058c063ed388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef79846cf7229655dd6a07980fcefbf3bb560e4feb25a196daf2c2ed61357087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7369dbb4070170f5d2210c15347fb1fe89e2c18e7685c00aff5c69f85ff1b729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2452d0fb9ab877e3453090838f3ed9d8c3061b7b5142b1838dfa834a678736b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b143d91a65489a868e8dfb611e6164315fddf5ed1ed8985ddde80edec47ba7c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3466951c5cc5273b9fc58d80146611694e887a944739106289ccbdcfac13625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf77b2811742bafe7aa959a1cb21f3dba8157e6a583a206a8a07a4c2f34e1dcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__931875e15361f879f17202fea3601b619247c720bf6ca9dbd094558032bd995a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47bf9e80ce9d0e7ea3f81bfde9e787a24a6690a01a9e17b53e65024e69357c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10fbab60282de6df1adfd3bbe982ba37a5d7ab3022f841d414de9649f8b1bdd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117ddfbf1857152ab697d62fa9923bf8844059300824b2181f58b3f43f84373b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16f702ac036aa4a81f81badbd7e00fd141c230b48f9dbb666d767b3f458b6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285852efe827e7c3b6af189e44297077f41d583fedbd0e89c3517e6c570f5151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "modification_option": "modificationOption",
        "rename_header_to": "renameHeaderTo",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93bac97601527d93865461393a66798de5b126077397c5aacb33060759204f1e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modification_option", value=modification_option, expected_type=type_hints["modification_option"])
            check_type(argname="argument rename_header_to", value=rename_header_to, expected_type=type_hints["rename_header_to"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modification_option is not None:
            self._values["modification_option"] = modification_option
        if rename_header_to is not None:
            self._values["rename_header_to"] = rename_header_to
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``Via`` header modifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modification_option(self) -> typing.Optional[builtins.str]:
        '''Specify how you want to handle the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        '''
        result = self._values.get("modification_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rename_header_to(self) -> typing.Optional[builtins.str]:
        '''Specifies a new name to replace the existing ``Via`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        '''
        result = self._values.get("rename_header_to")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eab7a0f382ee7cbf7a2316e0fca68bf1ac58b15bc71e6b385d99f001d661b13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModificationOption")
    def reset_modification_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModificationOption", []))

    @jsii.member(jsii_name="resetRenameHeaderTo")
    def reset_rename_header_to(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRenameHeaderTo", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modificationOptionInput")
    def modification_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "modificationOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="renameHeaderToInput")
    def rename_header_to_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "renameHeaderToInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a620471528486dcf068528ef4f092dcfa3a72df8ebc315781ad31b59521141b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12aafb45864f24b69b2b226800d6786ad3c8d590a075e69add98d2ad92514226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modificationOption")
    def modification_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "modificationOption"))

    @modification_option.setter
    def modification_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2df92b0ce929b08f2159f7c6172e1681d80624957b3078b107174a15c466ecea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modificationOption", value)

    @builtins.property
    @jsii.member(jsii_name="renameHeaderTo")
    def rename_header_to(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "renameHeaderTo"))

    @rename_header_to.setter
    def rename_header_to(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46f209cd0d4d26d4a2888fa045260a9c9c0bf82088a9e998781528277adbe835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "renameHeaderTo", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f99616b51daafdbee057b8c4eeff07248733e9680db9ceb209d0d5ebeedae6a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__561ed61f44d4906a7dc304a3fd438053b8b4feb67dd0978fd64df60a21aec750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909eba0c8af5a51bebd7b6f6da9aa3a0e2db51cb61727f4e2cd2f1b32300db1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cache_key_hostname": "cacheKeyHostname",
        "compress": "compress",
        "custom_certificate_authorities": "customCertificateAuthorities",
        "custom_certificates": "customCertificates",
        "custom_forward_host_header": "customForwardHostHeader",
        "custom_valid_cn_values": "customValidCnValues",
        "enable_true_client_ip": "enableTrueClientIp",
        "forward_host_header": "forwardHostHeader",
        "hostname": "hostname",
        "http_port": "httpPort",
        "https_port": "httpsPort",
        "ip_version": "ipVersion",
        "locked": "locked",
        "mslorigin": "mslorigin",
        "net_storage": "netStorage",
        "origin_certificate": "originCertificate",
        "origin_certs_to_honor": "originCertsToHonor",
        "origin_id": "originId",
        "origin_sni": "originSni",
        "origin_type": "originType",
        "ports": "ports",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "second_hostname": "secondHostname",
        "second_hostname_enabled": "secondHostnameEnabled",
        "standard_certificate_authorities": "standardCertificateAuthorities",
        "template_uuid": "templateUuid",
        "true_client_ip_client_setting": "trueClientIpClientSetting",
        "true_client_ip_header": "trueClientIpHeader",
        "use_unique_cache_key": "useUniqueCacheKey",
        "uuid": "uuid",
        "verification_mode": "verificationMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin:
    def __init__(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77af24cb69316c094f63187faea3d3cb86a1577a610bebcb190f25aa5630a9a)
            check_type(argname="argument cache_key_hostname", value=cache_key_hostname, expected_type=type_hints["cache_key_hostname"])
            check_type(argname="argument compress", value=compress, expected_type=type_hints["compress"])
            check_type(argname="argument custom_certificate_authorities", value=custom_certificate_authorities, expected_type=type_hints["custom_certificate_authorities"])
            check_type(argname="argument custom_certificates", value=custom_certificates, expected_type=type_hints["custom_certificates"])
            check_type(argname="argument custom_forward_host_header", value=custom_forward_host_header, expected_type=type_hints["custom_forward_host_header"])
            check_type(argname="argument custom_valid_cn_values", value=custom_valid_cn_values, expected_type=type_hints["custom_valid_cn_values"])
            check_type(argname="argument enable_true_client_ip", value=enable_true_client_ip, expected_type=type_hints["enable_true_client_ip"])
            check_type(argname="argument forward_host_header", value=forward_host_header, expected_type=type_hints["forward_host_header"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument http_port", value=http_port, expected_type=type_hints["http_port"])
            check_type(argname="argument https_port", value=https_port, expected_type=type_hints["https_port"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mslorigin", value=mslorigin, expected_type=type_hints["mslorigin"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument origin_certificate", value=origin_certificate, expected_type=type_hints["origin_certificate"])
            check_type(argname="argument origin_certs_to_honor", value=origin_certs_to_honor, expected_type=type_hints["origin_certs_to_honor"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument origin_sni", value=origin_sni, expected_type=type_hints["origin_sni"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument ports", value=ports, expected_type=type_hints["ports"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument second_hostname", value=second_hostname, expected_type=type_hints["second_hostname"])
            check_type(argname="argument second_hostname_enabled", value=second_hostname_enabled, expected_type=type_hints["second_hostname_enabled"])
            check_type(argname="argument standard_certificate_authorities", value=standard_certificate_authorities, expected_type=type_hints["standard_certificate_authorities"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument true_client_ip_client_setting", value=true_client_ip_client_setting, expected_type=type_hints["true_client_ip_client_setting"])
            check_type(argname="argument true_client_ip_header", value=true_client_ip_header, expected_type=type_hints["true_client_ip_header"])
            check_type(argname="argument use_unique_cache_key", value=use_unique_cache_key, expected_type=type_hints["use_unique_cache_key"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_mode", value=verification_mode, expected_type=type_hints["verification_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_key_hostname is not None:
            self._values["cache_key_hostname"] = cache_key_hostname
        if compress is not None:
            self._values["compress"] = compress
        if custom_certificate_authorities is not None:
            self._values["custom_certificate_authorities"] = custom_certificate_authorities
        if custom_certificates is not None:
            self._values["custom_certificates"] = custom_certificates
        if custom_forward_host_header is not None:
            self._values["custom_forward_host_header"] = custom_forward_host_header
        if custom_valid_cn_values is not None:
            self._values["custom_valid_cn_values"] = custom_valid_cn_values
        if enable_true_client_ip is not None:
            self._values["enable_true_client_ip"] = enable_true_client_ip
        if forward_host_header is not None:
            self._values["forward_host_header"] = forward_host_header
        if hostname is not None:
            self._values["hostname"] = hostname
        if http_port is not None:
            self._values["http_port"] = http_port
        if https_port is not None:
            self._values["https_port"] = https_port
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if locked is not None:
            self._values["locked"] = locked
        if mslorigin is not None:
            self._values["mslorigin"] = mslorigin
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if origin_certificate is not None:
            self._values["origin_certificate"] = origin_certificate
        if origin_certs_to_honor is not None:
            self._values["origin_certs_to_honor"] = origin_certs_to_honor
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if origin_sni is not None:
            self._values["origin_sni"] = origin_sni
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if ports is not None:
            self._values["ports"] = ports
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if second_hostname is not None:
            self._values["second_hostname"] = second_hostname
        if second_hostname_enabled is not None:
            self._values["second_hostname_enabled"] = second_hostname_enabled
        if standard_certificate_authorities is not None:
            self._values["standard_certificate_authorities"] = standard_certificate_authorities
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if true_client_ip_client_setting is not None:
            self._values["true_client_ip_client_setting"] = true_client_ip_client_setting
        if true_client_ip_header is not None:
            self._values["true_client_ip_header"] = true_client_ip_header
        if use_unique_cache_key is not None:
            self._values["use_unique_cache_key"] = use_unique_cache_key
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_mode is not None:
            self._values["verification_mode"] = verification_mode

    @builtins.property
    def cache_key_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to use when forming a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        '''
        result = self._values.get("cache_key_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compress(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``gzip`` compression for non-NetStorage origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        '''
        result = self._values.get("compress")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_certificate_authorities(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities"]]]:
        '''custom_certificate_authorities block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        '''
        result = self._values.get("custom_certificate_authorities")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities"]]], result)

    @builtins.property
    def custom_certificates(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates"]]]:
        '''custom_certificates block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        '''
        result = self._values.get("custom_certificates")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates"]]], result)

    @builtins.property
    def custom_forward_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the custom host header the edge server should pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        '''
        result = self._values.get("custom_forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_valid_cn_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields.

        Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        '''
        result = self._values.get("custom_valid_cn_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_true_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server.

        This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        '''
        result = self._values.get("enable_true_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_host_header(self) -> typing.Optional[builtins.str]:
        '''When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        '''
        result = self._values.get("forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        '''
        result = self._values.get("http_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def https_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``.

        This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        '''
        result = self._values.get("https_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP version to use when getting content from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mslorigin(self) -> typing.Optional[builtins.str]:
        '''This specifies the media's origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        '''
        result = self._values.get("mslorigin")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage"], result)

    @builtins.property
    def origin_certificate(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        '''
        result = self._values.get("origin_certificate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_certs_to_honor(self) -> typing.Optional[builtins.str]:
        '''Specifies which certificate to trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        '''
        result = self._values.get("origin_certs_to_honor")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the Edge Load Balancing origin.

        This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_sni(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value.

        See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        '''
        result = self._values.get("origin_sni")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Choose where your content is retrieved from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ports(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        '''
        result = self._values.get("ports")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies replacement text for what ``saasRegex`` matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static part of the SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of the request that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        '''
        result = self._values.get("second_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Available only for certain products. This specifies whether you want to use an additional origin server address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        '''
        result = self._values.get("second_hostname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def standard_certificate_authorities(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.'''
        result = self._values.get("standard_certificate_authorities")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def true_client_ip_client_setting(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin.

        Otherwise the edge server removes it and sets the value itself.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        '''
        result = self._values.get("true_client_ip_client_setting")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def true_client_ip_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        '''
        result = self._values.get("true_client_ip_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_unique_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        '''
        result = self._values.get("use_unique_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_mode(self) -> typing.Optional[builtins.str]:
        '''For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        result = self._values.get("verification_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "access_key_encrypted_storage": "accessKeyEncryptedStorage",
        "adc_title": "adcTitle",
        "authentication_method": "authenticationMethod",
        "authentication_method_title": "authenticationMethodTitle",
        "aws_access_key_id": "awsAccessKeyId",
        "aws_access_key_version_guid": "awsAccessKeyVersionGuid",
        "aws_ar_region": "awsArRegion",
        "aws_host": "awsHost",
        "aws_region": "awsRegion",
        "aws_secret_access_key": "awsSecretAccessKey",
        "aws_service": "awsService",
        "country": "country",
        "custom_sign_string": "customSignString",
        "direct_connect_geo": "directConnectGeo",
        "encoding_version": "encodingVersion",
        "end_point_service": "endPointService",
        "gcs_access_key_version_guid": "gcsAccessKeyVersionGuid",
        "gcs_hmac_key_access_id": "gcsHmacKeyAccessId",
        "gcs_hmac_key_secret": "gcsHmacKeySecret",
        "hostname_tag": "hostnameTag",
        "locked": "locked",
        "mslkey": "mslkey",
        "mslname": "mslname",
        "nonce": "nonce",
        "origin_location_title": "originLocationTitle",
        "property_id_tag": "propertyIdTag",
        "role_arn": "roleArn",
        "secret_key": "secretKey",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics:
    def __init__(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ac8d4a721cb210e053c0ecd5029f604585a488d5365cf7a61f820589929116e)
            check_type(argname="argument access_key_encrypted_storage", value=access_key_encrypted_storage, expected_type=type_hints["access_key_encrypted_storage"])
            check_type(argname="argument adc_title", value=adc_title, expected_type=type_hints["adc_title"])
            check_type(argname="argument authentication_method", value=authentication_method, expected_type=type_hints["authentication_method"])
            check_type(argname="argument authentication_method_title", value=authentication_method_title, expected_type=type_hints["authentication_method_title"])
            check_type(argname="argument aws_access_key_id", value=aws_access_key_id, expected_type=type_hints["aws_access_key_id"])
            check_type(argname="argument aws_access_key_version_guid", value=aws_access_key_version_guid, expected_type=type_hints["aws_access_key_version_guid"])
            check_type(argname="argument aws_ar_region", value=aws_ar_region, expected_type=type_hints["aws_ar_region"])
            check_type(argname="argument aws_host", value=aws_host, expected_type=type_hints["aws_host"])
            check_type(argname="argument aws_region", value=aws_region, expected_type=type_hints["aws_region"])
            check_type(argname="argument aws_secret_access_key", value=aws_secret_access_key, expected_type=type_hints["aws_secret_access_key"])
            check_type(argname="argument aws_service", value=aws_service, expected_type=type_hints["aws_service"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument direct_connect_geo", value=direct_connect_geo, expected_type=type_hints["direct_connect_geo"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument end_point_service", value=end_point_service, expected_type=type_hints["end_point_service"])
            check_type(argname="argument gcs_access_key_version_guid", value=gcs_access_key_version_guid, expected_type=type_hints["gcs_access_key_version_guid"])
            check_type(argname="argument gcs_hmac_key_access_id", value=gcs_hmac_key_access_id, expected_type=type_hints["gcs_hmac_key_access_id"])
            check_type(argname="argument gcs_hmac_key_secret", value=gcs_hmac_key_secret, expected_type=type_hints["gcs_hmac_key_secret"])
            check_type(argname="argument hostname_tag", value=hostname_tag, expected_type=type_hints["hostname_tag"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mslkey", value=mslkey, expected_type=type_hints["mslkey"])
            check_type(argname="argument mslname", value=mslname, expected_type=type_hints["mslname"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument origin_location_title", value=origin_location_title, expected_type=type_hints["origin_location_title"])
            check_type(argname="argument property_id_tag", value=property_id_tag, expected_type=type_hints["property_id_tag"])
            check_type(argname="argument role_arn", value=role_arn, expected_type=type_hints["role_arn"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_key_encrypted_storage is not None:
            self._values["access_key_encrypted_storage"] = access_key_encrypted_storage
        if adc_title is not None:
            self._values["adc_title"] = adc_title
        if authentication_method is not None:
            self._values["authentication_method"] = authentication_method
        if authentication_method_title is not None:
            self._values["authentication_method_title"] = authentication_method_title
        if aws_access_key_id is not None:
            self._values["aws_access_key_id"] = aws_access_key_id
        if aws_access_key_version_guid is not None:
            self._values["aws_access_key_version_guid"] = aws_access_key_version_guid
        if aws_ar_region is not None:
            self._values["aws_ar_region"] = aws_ar_region
        if aws_host is not None:
            self._values["aws_host"] = aws_host
        if aws_region is not None:
            self._values["aws_region"] = aws_region
        if aws_secret_access_key is not None:
            self._values["aws_secret_access_key"] = aws_secret_access_key
        if aws_service is not None:
            self._values["aws_service"] = aws_service
        if country is not None:
            self._values["country"] = country
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if direct_connect_geo is not None:
            self._values["direct_connect_geo"] = direct_connect_geo
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if end_point_service is not None:
            self._values["end_point_service"] = end_point_service
        if gcs_access_key_version_guid is not None:
            self._values["gcs_access_key_version_guid"] = gcs_access_key_version_guid
        if gcs_hmac_key_access_id is not None:
            self._values["gcs_hmac_key_access_id"] = gcs_hmac_key_access_id
        if gcs_hmac_key_secret is not None:
            self._values["gcs_hmac_key_secret"] = gcs_hmac_key_secret
        if hostname_tag is not None:
            self._values["hostname_tag"] = hostname_tag
        if locked is not None:
            self._values["locked"] = locked
        if mslkey is not None:
            self._values["mslkey"] = mslkey
        if mslname is not None:
            self._values["mslname"] = mslname
        if nonce is not None:
            self._values["nonce"] = nonce
        if origin_location_title is not None:
            self._values["origin_location_title"] = origin_location_title
        if property_id_tag is not None:
            self._values["property_id_tag"] = property_id_tag
        if role_arn is not None:
            self._values["role_arn"] = role_arn
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def access_key_encrypted_storage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables secure use of access keys defined in Cloud Access Manager.

        Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        '''
        result = self._values.get("access_key_encrypted_storage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def adc_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        '''
        result = self._values.get("adc_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the authentication method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        '''
        result = self._values.get("authentication_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        '''
        result = self._values.get("authentication_method_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_id(self) -> typing.Optional[builtins.str]:
        '''Specifies active access key ID linked to your AWS account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        '''
        result = self._values.get("aws_access_key_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        '''
        result = self._values.get("aws_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_ar_region(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.'''
        result = self._values.get("aws_ar_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes.

        If you leave this option empty, it inherits the hostname from the ``origin`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        '''
        result = self._values.get("aws_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_region(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS region code of the location where your bucket resides.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        '''
        result = self._values.get("aws_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_secret_access_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        '''
        result = self._values.get("aws_secret_access_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_service(self) -> typing.Optional[builtins.str]:
        '''This specifies the subdomain of your AWS service.

        It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        '''
        result = self._values.get("aws_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data to be encrypted as a series of enumerated variable names.

        See ``Built-in system variables`` for guidance on each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def direct_connect_geo(self) -> typing.Optional[builtins.str]:
        '''Provides a region used by Akamai Direct Connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        '''
        result = self._values.get("direct_connect_geo")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def end_point_service(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.'''
        result = self._values.get("end_point_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        '''
        result = self._values.get("gcs_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_access_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the active access ID linked to your Google account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        '''
        result = self._values.get("gcs_hmac_key_access_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_secret(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        '''
        result = self._values.get("gcs_hmac_key_secret")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.'''
        result = self._values.get("hostname_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mslkey(self) -> typing.Optional[builtins.str]:
        '''Specifies the access key provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        '''
        result = self._values.get("mslkey")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin name provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        '''
        result = self._values.get("mslname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the nonce.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_location_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        '''
        result = self._values.get("origin_location_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def property_id_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.'''
        result = self._values.get("property_id_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def role_arn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.'''
        result = self._values.get("role_arn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to customize your signed string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a5f477b49c70a5a39867cb83dfa88166b99881c5362ae8d31e0632c3e0f048)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessKeyEncryptedStorage")
    def reset_access_key_encrypted_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessKeyEncryptedStorage", []))

    @jsii.member(jsii_name="resetAdcTitle")
    def reset_adc_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdcTitle", []))

    @jsii.member(jsii_name="resetAuthenticationMethod")
    def reset_authentication_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethod", []))

    @jsii.member(jsii_name="resetAuthenticationMethodTitle")
    def reset_authentication_method_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethodTitle", []))

    @jsii.member(jsii_name="resetAwsAccessKeyId")
    def reset_aws_access_key_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyId", []))

    @jsii.member(jsii_name="resetAwsAccessKeyVersionGuid")
    def reset_aws_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetAwsArRegion")
    def reset_aws_ar_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsArRegion", []))

    @jsii.member(jsii_name="resetAwsHost")
    def reset_aws_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsHost", []))

    @jsii.member(jsii_name="resetAwsRegion")
    def reset_aws_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsRegion", []))

    @jsii.member(jsii_name="resetAwsSecretAccessKey")
    def reset_aws_secret_access_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsSecretAccessKey", []))

    @jsii.member(jsii_name="resetAwsService")
    def reset_aws_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsService", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDirectConnectGeo")
    def reset_direct_connect_geo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDirectConnectGeo", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetEndPointService")
    def reset_end_point_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndPointService", []))

    @jsii.member(jsii_name="resetGcsAccessKeyVersionGuid")
    def reset_gcs_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetGcsHmacKeyAccessId")
    def reset_gcs_hmac_key_access_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeyAccessId", []))

    @jsii.member(jsii_name="resetGcsHmacKeySecret")
    def reset_gcs_hmac_key_secret(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeySecret", []))

    @jsii.member(jsii_name="resetHostnameTag")
    def reset_hostname_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameTag", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMslkey")
    def reset_mslkey(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslkey", []))

    @jsii.member(jsii_name="resetMslname")
    def reset_mslname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslname", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetOriginLocationTitle")
    def reset_origin_location_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginLocationTitle", []))

    @jsii.member(jsii_name="resetPropertyIdTag")
    def reset_property_id_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPropertyIdTag", []))

    @jsii.member(jsii_name="resetRoleArn")
    def reset_role_arn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRoleArn", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorageInput")
    def access_key_encrypted_storage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessKeyEncryptedStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="adcTitleInput")
    def adc_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "adcTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodInput")
    def authentication_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitleInput")
    def authentication_method_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyIdInput")
    def aws_access_key_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyIdInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuidInput")
    def aws_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="awsArRegionInput")
    def aws_ar_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsArRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsHostInput")
    def aws_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsHostInput"))

    @builtins.property
    @jsii.member(jsii_name="awsRegionInput")
    def aws_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKeyInput")
    def aws_secret_access_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsSecretAccessKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="awsServiceInput")
    def aws_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="directConnectGeoInput")
    def direct_connect_geo_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "directConnectGeoInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="endPointServiceInput")
    def end_point_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endPointServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuidInput")
    def gcs_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessIdInput")
    def gcs_hmac_key_access_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeyAccessIdInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecretInput")
    def gcs_hmac_key_secret_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeySecretInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameTagInput")
    def hostname_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hostnameTagInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mslkeyInput")
    def mslkey_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslkeyInput"))

    @builtins.property
    @jsii.member(jsii_name="mslnameInput")
    def mslname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslnameInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="originLocationTitleInput")
    def origin_location_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originLocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="propertyIdTagInput")
    def property_id_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "propertyIdTagInput"))

    @builtins.property
    @jsii.member(jsii_name="roleArnInput")
    def role_arn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "roleArnInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorage")
    def access_key_encrypted_storage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessKeyEncryptedStorage"))

    @access_key_encrypted_storage.setter
    def access_key_encrypted_storage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938bc77a0221b611d66b46b12c617386b46ee4346eef0e54d66a30d3b6bc7a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessKeyEncryptedStorage", value)

    @builtins.property
    @jsii.member(jsii_name="adcTitle")
    def adc_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "adcTitle"))

    @adc_title.setter
    def adc_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6d9dfd59690f865cc3ef010abc46386d214d6a8063cf17d4db3ffc7ad48b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "adcTitle", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethod")
    def authentication_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethod"))

    @authentication_method.setter
    def authentication_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ada5dbc7ce017fd018fc7e6f7d02602d66771567c7d858af82590c9a5228a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethod", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitle")
    def authentication_method_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethodTitle"))

    @authentication_method_title.setter
    def authentication_method_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__994e435dcb922706ff43d324b0f8af2e2c4cf6a44c543c2f2e947ec4fe23f9d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethodTitle", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyId")
    def aws_access_key_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyId"))

    @aws_access_key_id.setter
    def aws_access_key_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd7b135b64a66cfe4d5c9037f55824ea2e9e45b765c662bac1f47ca1d4e59c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyId", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuid")
    def aws_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyVersionGuid"))

    @aws_access_key_version_guid.setter
    def aws_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93bdb36e690db791231ee4f47d196528ee77e621dcdf9241b5f96e3ab84fd523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="awsArRegion")
    def aws_ar_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsArRegion"))

    @aws_ar_region.setter
    def aws_ar_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a62ceb412e211a9d0d8123014ba5b7e2ae112b13e236f2807f977e1e6e009a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsArRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsHost")
    def aws_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsHost"))

    @aws_host.setter
    def aws_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3aac4056a257662e112cb0ff19d25cd313d1e50d8d898e5ad4eed93da7cf4881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsHost", value)

    @builtins.property
    @jsii.member(jsii_name="awsRegion")
    def aws_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsRegion"))

    @aws_region.setter
    def aws_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09436aee4efec1686762c2fcd327d38df90d7755553cfb59af49fb7ea9b8d13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKey")
    def aws_secret_access_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsSecretAccessKey"))

    @aws_secret_access_key.setter
    def aws_secret_access_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc71a193883d94eef4caee93f857b1025c463ed02cfbf7171e4670a5578a70c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsSecretAccessKey", value)

    @builtins.property
    @jsii.member(jsii_name="awsService")
    def aws_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsService"))

    @aws_service.setter
    def aws_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c236f682b1504235003ba68b30f0ea94a1857b8ef67b888f9696f9fce780c02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsService", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150ef22cc7d38b2a201c8970192fbd276ecb8402448f6b41f8bd41f8c968e8d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e1f154533ccd4139f3cbfc2d50c6d55c03c8315df0dc43ff0974170cd62f08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="directConnectGeo")
    def direct_connect_geo(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "directConnectGeo"))

    @direct_connect_geo.setter
    def direct_connect_geo(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0046cfd92b048e10ca7e5c9f5f08cbc8106c19cfef078e2481a5c4e2a9eafc85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "directConnectGeo", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488f0bd19ca43ddeecc8edb102ebaa1ad80647d574f97ebf142ed1d269fd215c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="endPointService")
    def end_point_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endPointService"))

    @end_point_service.setter
    def end_point_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335bbeacb1119db6b77d379c050d8128da7c13b7b46396932662d85139d5b849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endPointService", value)

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuid")
    def gcs_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsAccessKeyVersionGuid"))

    @gcs_access_key_version_guid.setter
    def gcs_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18fec29a57e9a2f264ee7451565ebf4a8e5e58782691e6f259715a765a761199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessId")
    def gcs_hmac_key_access_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeyAccessId"))

    @gcs_hmac_key_access_id.setter
    def gcs_hmac_key_access_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bdd865bff2406db95579770acb32d907bcb56e73b424d6559c8e1db636e45f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeyAccessId", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecret")
    def gcs_hmac_key_secret(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeySecret"))

    @gcs_hmac_key_secret.setter
    def gcs_hmac_key_secret(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__688d0cc31f167f59c098fcbd12894e6cab08abb75073c00ee05645ffbdbfa655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeySecret", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameTag")
    def hostname_tag(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hostnameTag"))

    @hostname_tag.setter
    def hostname_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b4115860bebb641cd0e33b91d8fc9e539f6a3ad22695654f70578f4665fac4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameTag", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509b10a9ad17639dfaad45f90699e7d91a386519eda92de6c2d37333dbad56b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mslkey")
    def mslkey(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslkey"))

    @mslkey.setter
    def mslkey(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b263e38d8832c9cbf103e3a45e39bf7635323a2642170966e15700fa0d20abc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslkey", value)

    @builtins.property
    @jsii.member(jsii_name="mslname")
    def mslname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslname"))

    @mslname.setter
    def mslname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d7abf61dd093f39cd7c1c06f890aae9275b023a10bcd78616731c4aebdeae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslname", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685de741fa262de732fc52326191bf84ad705d255855cd679d71cb98b53a5d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="originLocationTitle")
    def origin_location_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originLocationTitle"))

    @origin_location_title.setter
    def origin_location_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c959b021e50a444621ac06f6f98fa0f85860fcfd907685ea6399e73e24e96a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originLocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="propertyIdTag")
    def property_id_tag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "propertyIdTag"))

    @property_id_tag.setter
    def property_id_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b74cb9805bf6f42edcf5d1035cd30b5c844a68b4fa44519693794c419b89476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "propertyIdTag", value)

    @builtins.property
    @jsii.member(jsii_name="roleArn")
    def role_arn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "roleArn"))

    @role_arn.setter
    def role_arn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141180e9ffb71258bb31fb551ec6ee978da2332e654917c6c094e034c8433b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "roleArn", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a8a529617365dd041f0027e50d7ade6b61e695d32beb36f6b214242515c1897)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66f060919cc927067c302c6a9225fa9b6480e4d1a515a6a2ad1379a3eefb7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f31c47c82df635ef9c0a2c616b8c9ed1766f1c7ac289b2a77f136bb45cbdf6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8a87ddd717bf13d554f59cd7f0bd2f94ea628954f0e34a59b2cc2b786d808d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa4e08c434993f28c6b58acd9afa5eed8004940c2f9a5ee9f9a49fae4f3737fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origintype": "origintype",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3edc11135cc730e27b8b6ac0d6f12722744d92a07465b17c03fe32fdd88068)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origintype", value=origintype, expected_type=type_hints["origintype"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origintype is not None:
            self._values["origintype"] = origintype
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origintype(self) -> typing.Optional[builtins.str]:
        '''Specifies an origin type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        '''
        result = self._values.get("origintype")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c112620fd1afc7bba041082aa1e60dc1135f8e2e35dac8ea4b19b27d3ee041be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOrigintype")
    def reset_origintype(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigintype", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="origintypeInput")
    def origintype_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "origintypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0c85fcbaed0bb131a06de8519a768a9daf075f82d9fb085ac102e5e85eebe56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="origintype")
    def origintype(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "origintype"))

    @origintype.setter
    def origintype(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cfc86116a14cef962b7ac90f4abe752368a22ce661f2c07ef3cbdb1480cd68a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origintype", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b1c7f11115bc9608c460f9879ea32ef3553d4d3136ec5ece180c436a4a0d8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33edb721ad253376e09c4332e59bc9317a7eefc591eacfc015168a2436a9b450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cbb63a5ae8a8380eb15259d88b290c41f6fb250d4111353f8f8e5053f7692c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afe3a975621c5b5ff7052f21555f9330ec7f40f7f9398f5054a5a780f4caab2a)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c90054e4c38d88a246acb2be13419a970fc89e99dc34a0f4dd0106a2469172d)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49bb03e5771a8a1cd800e6610d1c3c09d986eeadd53ee0bb27e9971401e006a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5d3b13a2cf59d60d833a6c6407553d513236b51c6561e8db18260f090fc9f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__451389ff2f20ddee617b5fef164a12e443f468646bf5f7e5ff7b193dcfd6b46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0d14185e2238b7133b1f6baea1d2a2fd12485c73a0ee1fc8b7f3c9ea4376d83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f045d6c97091b43d5e543ecde12d264b6ab43682826bd44ab9c43f30be752353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853fbfd092fb3c6eac1228bddde09dc34bd1c53248bf47c9356b3d10fefcdb64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c2d04c1e030b9676cdf121e2b322a4c63b66b7d8e5a9993b8cd1462c638bd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328484e2ee27132dff97c5d55dd687d47bfd19317c53d0054e6db2c52573b53d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be30d0bc3cf6893ab5ee4197e56a998cb28dc83dc74c0624400253b772e316fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__435472e9e9d934b81b98ef58e841ca7586f874f9dc668b9f72e70841367892ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8161aac5698351737c61bcd113dc04a9a4881e012e8728b1517d51db0656d362)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4b0ac1e4a8583e7b299eb60267a1ee8014aab9c32b4e9ff1e5c9656e7a1f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f0331dcfcebfd4a253976ef529c45cef83221b336d6e0687b577485b09874d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11fed582c5d12dabdeb9917e22c5ac38b7092d2a5683d22c7e05665484f1e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d414fa2872742f43bb589f6ee05889bc8433174c1e623c6b7d2edd265c7db74a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f51958b7515b257e1ddd2dffadf363f090e2880f08ac5e56b12aa43eac20cb9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b66f1107f4be5bc3260eb222e2d952324b523eee613786e699be72a86eab04d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bdb7a1a1bc28ebe745ea8d7a12da356e9d6b1e77c0bfa5dfd4d204cea41afd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66bdb4658c0ca478041745e3981f7e76b754f94dcfdfd95e9034454ea7d9919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd2d6c4e99a82c606410537bccb54dd71db92d16624abe279163ecd82e916dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d828a65840028c054f06b992903eaad57dfff774bd6ae56dd622e3de378d3920)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8e714657114c0e69e5596e13a4edc3b13e290899dc60f3f3a7e976c0b5679e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd64068c35514c8f778b9505be525d7051e1170378bcb78c9a2663fd86c9bebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7f39794c421eebae92045eace30c6845f3214d0de89be234c20ec64cd84096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de625372d0914b170dae8503e36fdb56ce9cb10039ccdb7ba201911e9b87250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456df33205be0747af4cab1d9bdbf8238ba863901e0a107c72445e941975730f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d029bf18472f39cfc440c44211e8aac5bc8d522477875f9e13fb3297ad547e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__970606d4e7b8886bee02375b47a61cad4c2cd931d2ece0ac1599bdd22125ebf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661bf4ec937037cd9939a7a5aa31d04f69c70cad08429ae96e3c1df5e3d5253f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65850d3201b845f60abe5d2b59f7d52731d19500d4181eb7e7e81592c4c9267)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e6fc072bebcf3eec848d7576f3830e5cf4e46e9ac5e2326180d663d449825b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a20c8e5ebe2b3fa82ca17728cdae244774b2e8f5e0cd5c9271e9dd120af5303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c3cb001a3ff6764fb4a57bc24ebadc670d3b15788e5a235a5210b507bdebe33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fd1d994c5fae3f52df327742a77064671a8bbb4ee9fb2fbbca60a3f485c853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02bd4acbb68b393355b65b81c0d6844280ad91967ca7b32f85a987bfda80ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cfb1f2bd5a566eea636b249edd03db2fea8694e9ad0b31c643011ad198e6d4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad984dffe9830db9a42c08e5126e2d8c8b2d05611a7c710d67c298c159ce1548)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc965a01aa0c659f31031ed1e5c462c08dad2009fc1b2e6b9560d99d48096df0)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c088c9271c8d4d52fd0d6d0b886bb5c4cfa0e3c70d37d6a9de1e094b23b1f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__836d0253caf7dd15ae06f376936ec66ed8048bf01ed988d284ed4a0732e95ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c570f6150c2dd6549f5a09d217ccce9799a2d6cd08ba3c05aafe2b66f0b7b557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b5b7dc3485351b812a4b4ebf79cced6d4324bd4ae85e43857ab04d5d396b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e7b55c8a678dbf169bf591e8b09b33a0067885901974abeb82c86680d6280a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8b77841cdc81a5ea8752e483537d1c88e539ba7e22088edf72260dba478127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3195b3594b188981ece5fb27ed78c898b2bb9723cbf44410d35daafaf2108686)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3858426f88888287641c3020f3d47d06ddf82db3164f99eeac988d78b263bde5)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7fb8904ff4579bd12115a714b7de5e8b382b14a93d79659affc09134b04b1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0efda8984ea2e70f4cddfca7311864d403d0369308ea2a48deac192bb904f807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5efb46f8faf04b0cef188e3230256786eec47c18de85c388b93fbdc37192f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a230de3ac16bb80da937714f6d017b6c1fe7e6c52d7c9c933a456fcd97e1ed30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a204dd9f2c4e450dbbe251301f6bbc12d89808b7c5064670e9171271a1ba7e2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b8871ced677396a54b69d4b586a440fa5e2b1e0030c39e1c0ab298dd1dda4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128581efe0055d2746e2a2b626d9111ab4b2ffbac2aedf311068df3f322ca318)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfbe807890a7b0e0183fd9f5dfb0c81b94945c46563916b7e11f4949ea5babb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7d0b9d2d766298ed84fb6f351f48ce20addc7ff810fc27889ca56fb7816ded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e2bfea385083679b1f9e9326521eb671a148d5befff9adbac814779f68a6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204e886db0f5b512c93ac84e835d6c3e688a1c3b91beae9f2af4999249468fa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdfb9679b3a34b46f18c74e4ee912b8d53a818907df15492dc6eb5f24b0695f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac3dd40b9a0d7beee667187acc09110c57b61aa06097d98fd7b84042fbf6359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5538c2426e892754bf51d3e0c21c110df82a0aad448131826ca329e8c2d1fee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcb072640db3d754b8ddd1dab91ff33d5f4b8f336f7a2bf5b4b3864e86c2a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e8033d0214a28937cd29aaf932f2779a254734b0325d61fa4e7ccbcfbcc31a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51fbe82ac58303e351a61c48065f95fdac7058b2979c89efd3c173fbdd0349be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1040fa5a8f8cf75635525bf1c00a59e886112c3caee517764ae13e1e630b520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ccfcdc1f25aabbd2ad44929f7740359d0001d8dd307f8fcfd00f02555bde75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c67084deb245ff533921659c2b84e860e40f8f7dfe4a48e57fd5fee43b139a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64af38114be936ee3a9b3a20ec919b6b40668bd8e29115bb04c2466fda8736b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaefce1732b0988335d2a4905db88c732bd594fb8d21a4fad7860c30c2b58dfe)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6150318cd1cb385f9830522e6ce62fd3807ab753ff4745c24db1fef29236f2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6547bb0e9948df82604eb77087cc51b043b40bdafffda01ef17d29f90457bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fbe034b8498be95bccc4371222ec1fc8f9ea0c1d7b41a902dbe1026d2b56dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c158db3be187e9e888ab8fb96db231233402806063989eda1c3cde895deb55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d27790e3c4441187ab8c7a923d8463d6b1f15dbb663ddafaf7b900d49d582e71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e330eb5611aa64ef4ad8b81b6296f90a947d1b8242e17b0db5d74aee0f23d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod",
    jsii_struct_bases=[],
    name_mapping={
        "custom_status_code": "customStatusCode",
        "locked": "locked",
        "recovery_method": "recoveryMethod",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod:
    def __init__(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972038b996dbe073a685cdceb3b8812d7f363709edd3ac8c2cfb6650efb98c5a)
            check_type(argname="argument custom_status_code", value=custom_status_code, expected_type=type_hints["custom_status_code"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument recovery_method", value=recovery_method, expected_type=type_hints["recovery_method"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_status_code is not None:
            self._values["custom_status_code"] = custom_status_code
        if locked is not None:
            self._values["locked"] = locked
        if recovery_method is not None:
            self._values["recovery_method"] = recovery_method
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom status code to be sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        '''
        result = self._values.get("custom_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def recovery_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        '''
        result = self._values.get("recovery_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff70b7213bd59cc1fd5175721f4fbc920cd09997e682e949aa068445553b165)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomStatusCode")
    def reset_custom_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatusCode", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRecoveryMethod")
    def reset_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryMethod", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customStatusCodeInput")
    def custom_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryMethodInput")
    def recovery_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "recoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatusCode")
    def custom_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatusCode"))

    @custom_status_code.setter
    def custom_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45dafae06e2d02dc5b157acbcc42c4e8057b5e67b99f994131301332a95bf5e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4423d3af4e5412112236b6c0ccc28a0ce5619f007e0af8db227b0d62ea303e57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="recoveryMethod")
    def recovery_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "recoveryMethod"))

    @recovery_method.setter
    def recovery_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e52a7c8fc2ed726d2158d84dbeea6c1a1b2e8ee23f4a1aafb170dcb40f3ec15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "recoveryMethod", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d05e2f5ca188d3d1eff0b16e312e321c40183410af725b08dc698198973c81c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27da815b8de6e2a8dcfd9404a52e0075a914683ac080cdfec6eb721e7c63c576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f291da9faa85882a72f7318751481fd7684373cd6a5786e1d793cbfcb9e6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "binary_equivalent_content": "binaryEquivalentContent",
        "enabled": "enabled",
        "enable_ip_avoidance": "enableIpAvoidance",
        "ip_avoidance_error_threshold": "ipAvoidanceErrorThreshold",
        "ip_avoidance_retry_interval": "ipAvoidanceRetryInterval",
        "locked": "locked",
        "monitor_origin_responsiveness": "monitorOriginResponsiveness",
        "monitor_response_codes1": "monitorResponseCodes1",
        "monitor_response_codes2": "monitorResponseCodes2",
        "monitor_response_codes3": "monitorResponseCodes3",
        "monitor_status_codes1": "monitorStatusCodes1",
        "monitor_status_codes1_enable_recovery": "monitorStatusCodes1EnableRecovery",
        "monitor_status_codes1_enable_retry": "monitorStatusCodes1EnableRetry",
        "monitor_status_codes1_recovery_config_name": "monitorStatusCodes1RecoveryConfigName",
        "monitor_status_codes2": "monitorStatusCodes2",
        "monitor_status_codes2_enable_recovery": "monitorStatusCodes2EnableRecovery",
        "monitor_status_codes2_enable_retry": "monitorStatusCodes2EnableRetry",
        "monitor_status_codes2_recovery_config_name": "monitorStatusCodes2RecoveryConfigName",
        "monitor_status_codes3": "monitorStatusCodes3",
        "monitor_status_codes3_enable_recovery": "monitorStatusCodes3EnableRecovery",
        "monitor_status_codes3_enable_retry": "monitorStatusCodes3EnableRetry",
        "monitor_status_codes3_recovery_config_name": "monitorStatusCodes3RecoveryConfigName",
        "origin_responsiveness_custom_timeout": "originResponsivenessCustomTimeout",
        "origin_responsiveness_enable_recovery": "originResponsivenessEnableRecovery",
        "origin_responsiveness_enable_retry": "originResponsivenessEnableRetry",
        "origin_responsiveness_monitoring": "originResponsivenessMonitoring",
        "origin_responsiveness_recovery_config_name": "originResponsivenessRecoveryConfigName",
        "origin_responsiveness_timeout": "originResponsivenessTimeout",
        "status_code_monitoring1": "statusCodeMonitoring1",
        "status_code_monitoring2": "statusCodeMonitoring2",
        "status_code_monitoring3": "statusCodeMonitoring3",
        "template_uuid": "templateUuid",
        "tuning_parameters": "tuningParameters",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy:
    def __init__(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fa444fa1ffadeb330794b5afc8afbf944119c77264a7b3caab22c3ee0c26fa)
            check_type(argname="argument binary_equivalent_content", value=binary_equivalent_content, expected_type=type_hints["binary_equivalent_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_ip_avoidance", value=enable_ip_avoidance, expected_type=type_hints["enable_ip_avoidance"])
            check_type(argname="argument ip_avoidance_error_threshold", value=ip_avoidance_error_threshold, expected_type=type_hints["ip_avoidance_error_threshold"])
            check_type(argname="argument ip_avoidance_retry_interval", value=ip_avoidance_retry_interval, expected_type=type_hints["ip_avoidance_retry_interval"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument monitor_origin_responsiveness", value=monitor_origin_responsiveness, expected_type=type_hints["monitor_origin_responsiveness"])
            check_type(argname="argument monitor_response_codes1", value=monitor_response_codes1, expected_type=type_hints["monitor_response_codes1"])
            check_type(argname="argument monitor_response_codes2", value=monitor_response_codes2, expected_type=type_hints["monitor_response_codes2"])
            check_type(argname="argument monitor_response_codes3", value=monitor_response_codes3, expected_type=type_hints["monitor_response_codes3"])
            check_type(argname="argument monitor_status_codes1", value=monitor_status_codes1, expected_type=type_hints["monitor_status_codes1"])
            check_type(argname="argument monitor_status_codes1_enable_recovery", value=monitor_status_codes1_enable_recovery, expected_type=type_hints["monitor_status_codes1_enable_recovery"])
            check_type(argname="argument monitor_status_codes1_enable_retry", value=monitor_status_codes1_enable_retry, expected_type=type_hints["monitor_status_codes1_enable_retry"])
            check_type(argname="argument monitor_status_codes1_recovery_config_name", value=monitor_status_codes1_recovery_config_name, expected_type=type_hints["monitor_status_codes1_recovery_config_name"])
            check_type(argname="argument monitor_status_codes2", value=monitor_status_codes2, expected_type=type_hints["monitor_status_codes2"])
            check_type(argname="argument monitor_status_codes2_enable_recovery", value=monitor_status_codes2_enable_recovery, expected_type=type_hints["monitor_status_codes2_enable_recovery"])
            check_type(argname="argument monitor_status_codes2_enable_retry", value=monitor_status_codes2_enable_retry, expected_type=type_hints["monitor_status_codes2_enable_retry"])
            check_type(argname="argument monitor_status_codes2_recovery_config_name", value=monitor_status_codes2_recovery_config_name, expected_type=type_hints["monitor_status_codes2_recovery_config_name"])
            check_type(argname="argument monitor_status_codes3", value=monitor_status_codes3, expected_type=type_hints["monitor_status_codes3"])
            check_type(argname="argument monitor_status_codes3_enable_recovery", value=monitor_status_codes3_enable_recovery, expected_type=type_hints["monitor_status_codes3_enable_recovery"])
            check_type(argname="argument monitor_status_codes3_enable_retry", value=monitor_status_codes3_enable_retry, expected_type=type_hints["monitor_status_codes3_enable_retry"])
            check_type(argname="argument monitor_status_codes3_recovery_config_name", value=monitor_status_codes3_recovery_config_name, expected_type=type_hints["monitor_status_codes3_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_custom_timeout", value=origin_responsiveness_custom_timeout, expected_type=type_hints["origin_responsiveness_custom_timeout"])
            check_type(argname="argument origin_responsiveness_enable_recovery", value=origin_responsiveness_enable_recovery, expected_type=type_hints["origin_responsiveness_enable_recovery"])
            check_type(argname="argument origin_responsiveness_enable_retry", value=origin_responsiveness_enable_retry, expected_type=type_hints["origin_responsiveness_enable_retry"])
            check_type(argname="argument origin_responsiveness_monitoring", value=origin_responsiveness_monitoring, expected_type=type_hints["origin_responsiveness_monitoring"])
            check_type(argname="argument origin_responsiveness_recovery_config_name", value=origin_responsiveness_recovery_config_name, expected_type=type_hints["origin_responsiveness_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_timeout", value=origin_responsiveness_timeout, expected_type=type_hints["origin_responsiveness_timeout"])
            check_type(argname="argument status_code_monitoring1", value=status_code_monitoring1, expected_type=type_hints["status_code_monitoring1"])
            check_type(argname="argument status_code_monitoring2", value=status_code_monitoring2, expected_type=type_hints["status_code_monitoring2"])
            check_type(argname="argument status_code_monitoring3", value=status_code_monitoring3, expected_type=type_hints["status_code_monitoring3"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tuning_parameters", value=tuning_parameters, expected_type=type_hints["tuning_parameters"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if binary_equivalent_content is not None:
            self._values["binary_equivalent_content"] = binary_equivalent_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_ip_avoidance is not None:
            self._values["enable_ip_avoidance"] = enable_ip_avoidance
        if ip_avoidance_error_threshold is not None:
            self._values["ip_avoidance_error_threshold"] = ip_avoidance_error_threshold
        if ip_avoidance_retry_interval is not None:
            self._values["ip_avoidance_retry_interval"] = ip_avoidance_retry_interval
        if locked is not None:
            self._values["locked"] = locked
        if monitor_origin_responsiveness is not None:
            self._values["monitor_origin_responsiveness"] = monitor_origin_responsiveness
        if monitor_response_codes1 is not None:
            self._values["monitor_response_codes1"] = monitor_response_codes1
        if monitor_response_codes2 is not None:
            self._values["monitor_response_codes2"] = monitor_response_codes2
        if monitor_response_codes3 is not None:
            self._values["monitor_response_codes3"] = monitor_response_codes3
        if monitor_status_codes1 is not None:
            self._values["monitor_status_codes1"] = monitor_status_codes1
        if monitor_status_codes1_enable_recovery is not None:
            self._values["monitor_status_codes1_enable_recovery"] = monitor_status_codes1_enable_recovery
        if monitor_status_codes1_enable_retry is not None:
            self._values["monitor_status_codes1_enable_retry"] = monitor_status_codes1_enable_retry
        if monitor_status_codes1_recovery_config_name is not None:
            self._values["monitor_status_codes1_recovery_config_name"] = monitor_status_codes1_recovery_config_name
        if monitor_status_codes2 is not None:
            self._values["monitor_status_codes2"] = monitor_status_codes2
        if monitor_status_codes2_enable_recovery is not None:
            self._values["monitor_status_codes2_enable_recovery"] = monitor_status_codes2_enable_recovery
        if monitor_status_codes2_enable_retry is not None:
            self._values["monitor_status_codes2_enable_retry"] = monitor_status_codes2_enable_retry
        if monitor_status_codes2_recovery_config_name is not None:
            self._values["monitor_status_codes2_recovery_config_name"] = monitor_status_codes2_recovery_config_name
        if monitor_status_codes3 is not None:
            self._values["monitor_status_codes3"] = monitor_status_codes3
        if monitor_status_codes3_enable_recovery is not None:
            self._values["monitor_status_codes3_enable_recovery"] = monitor_status_codes3_enable_recovery
        if monitor_status_codes3_enable_retry is not None:
            self._values["monitor_status_codes3_enable_retry"] = monitor_status_codes3_enable_retry
        if monitor_status_codes3_recovery_config_name is not None:
            self._values["monitor_status_codes3_recovery_config_name"] = monitor_status_codes3_recovery_config_name
        if origin_responsiveness_custom_timeout is not None:
            self._values["origin_responsiveness_custom_timeout"] = origin_responsiveness_custom_timeout
        if origin_responsiveness_enable_recovery is not None:
            self._values["origin_responsiveness_enable_recovery"] = origin_responsiveness_enable_recovery
        if origin_responsiveness_enable_retry is not None:
            self._values["origin_responsiveness_enable_retry"] = origin_responsiveness_enable_retry
        if origin_responsiveness_monitoring is not None:
            self._values["origin_responsiveness_monitoring"] = origin_responsiveness_monitoring
        if origin_responsiveness_recovery_config_name is not None:
            self._values["origin_responsiveness_recovery_config_name"] = origin_responsiveness_recovery_config_name
        if origin_responsiveness_timeout is not None:
            self._values["origin_responsiveness_timeout"] = origin_responsiveness_timeout
        if status_code_monitoring1 is not None:
            self._values["status_code_monitoring1"] = status_code_monitoring1
        if status_code_monitoring2 is not None:
            self._values["status_code_monitoring2"] = status_code_monitoring2
        if status_code_monitoring3 is not None:
            self._values["status_code_monitoring3"] = status_code_monitoring3
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tuning_parameters is not None:
            self._values["tuning_parameters"] = tuning_parameters
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def binary_equivalent_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Synchronizes content between the primary and backup origins, byte for byte.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        '''
        result = self._values.get("binary_equivalent_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates and configures a recovery policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_avoidance(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Temporarily blocks an origin IP address that experienced a certain number of failures.

        When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        '''
        result = self._values.get("enable_ip_avoidance")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip_avoidance_error_threshold(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of failures that need to occur to an origin address before it's blocked.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        '''
        result = self._values.get("ip_avoidance_error_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_avoidance_retry_interval(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of seconds after which the IP address is removed from the blocklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        '''
        result = self._values.get("ip_avoidance_retry_interval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        '''
        result = self._values.get("monitor_origin_responsiveness")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_response_codes1(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        '''
        result = self._values.get("monitor_response_codes1")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes2(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        '''
        result = self._values.get("monitor_response_codes2")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes3(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here..

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        '''
        result = self._values.get("monitor_response_codes3")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_status_codes1(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        '''
        result = self._values.get("monitor_status_codes1")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes1_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        '''
        result = self._values.get("monitor_status_codes1_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes1_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes2(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        '''
        result = self._values.get("monitor_status_codes2")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes2_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        '''
        result = self._values.get("monitor_status_codes2_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes2_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes3(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        '''
        result = self._values.get("monitor_status_codes3")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes3_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        '''
        result = self._values.get("monitor_status_codes3_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes3_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_custom_timeout(self) -> typing.Optional[jsii.Number]:
        '''Specify a custom timeout, from 1 to 10 seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        '''
        result = self._values.get("origin_responsiveness_custom_timeout")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a recovery action for a specific failure condition.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        '''
        result = self._values.get("origin_responsiveness_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        '''
        result = self._values.get("origin_responsiveness_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_monitoring(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        '''
        result = self._values.get("origin_responsiveness_monitoring")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        '''
        result = self._values.get("origin_responsiveness_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_timeout(self) -> typing.Optional[builtins.str]:
        '''The timeout threshold that triggers a retry or recovery action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        '''
        result = self._values.get("origin_responsiveness_timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring1(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        '''
        result = self._values.get("status_code_monitoring1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring2(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        '''
        result = self._values.get("status_code_monitoring2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring3(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        '''
        result = self._values.get("status_code_monitoring3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tuning_parameters(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        '''
        result = self._values.get("tuning_parameters")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1c24ed3bfc470ae9f0080af8a2bc353ec9fc84364f774fbf44deb1996fe1be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBinaryEquivalentContent")
    def reset_binary_equivalent_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBinaryEquivalentContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableIpAvoidance")
    def reset_enable_ip_avoidance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpAvoidance", []))

    @jsii.member(jsii_name="resetIpAvoidanceErrorThreshold")
    def reset_ip_avoidance_error_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceErrorThreshold", []))

    @jsii.member(jsii_name="resetIpAvoidanceRetryInterval")
    def reset_ip_avoidance_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceRetryInterval", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMonitorOriginResponsiveness")
    def reset_monitor_origin_responsiveness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorOriginResponsiveness", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes1")
    def reset_monitor_response_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes1", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes2")
    def reset_monitor_response_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes2", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes3")
    def reset_monitor_response_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1")
    def reset_monitor_status_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRecovery")
    def reset_monitor_status_codes1_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRetry")
    def reset_monitor_status_codes1_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1RecoveryConfigName")
    def reset_monitor_status_codes1_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2")
    def reset_monitor_status_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRecovery")
    def reset_monitor_status_codes2_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRetry")
    def reset_monitor_status_codes2_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2RecoveryConfigName")
    def reset_monitor_status_codes2_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3")
    def reset_monitor_status_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRecovery")
    def reset_monitor_status_codes3_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRetry")
    def reset_monitor_status_codes3_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3RecoveryConfigName")
    def reset_monitor_status_codes3_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3RecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessCustomTimeout")
    def reset_origin_responsiveness_custom_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessCustomTimeout", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRecovery")
    def reset_origin_responsiveness_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRecovery", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRetry")
    def reset_origin_responsiveness_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRetry", []))

    @jsii.member(jsii_name="resetOriginResponsivenessMonitoring")
    def reset_origin_responsiveness_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessMonitoring", []))

    @jsii.member(jsii_name="resetOriginResponsivenessRecoveryConfigName")
    def reset_origin_responsiveness_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessRecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessTimeout")
    def reset_origin_responsiveness_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessTimeout", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring1")
    def reset_status_code_monitoring1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring1", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring2")
    def reset_status_code_monitoring2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring2", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring3")
    def reset_status_code_monitoring3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring3", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTuningParameters")
    def reset_tuning_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTuningParameters", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContentInput")
    def binary_equivalent_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "binaryEquivalentContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidanceInput")
    def enable_ip_avoidance_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpAvoidanceInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThresholdInput")
    def ip_avoidance_error_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceErrorThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryIntervalInput")
    def ip_avoidance_retry_interval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceRetryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsivenessInput")
    def monitor_origin_responsiveness_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorOriginResponsivenessInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1Input")
    def monitor_response_codes1_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2Input")
    def monitor_response_codes2_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3Input")
    def monitor_response_codes3_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecoveryInput")
    def monitor_status_codes1_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetryInput")
    def monitor_status_codes1_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1Input")
    def monitor_status_codes1_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigNameInput")
    def monitor_status_codes1_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes1RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecoveryInput")
    def monitor_status_codes2_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetryInput")
    def monitor_status_codes2_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2Input")
    def monitor_status_codes2_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigNameInput")
    def monitor_status_codes2_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes2RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecoveryInput")
    def monitor_status_codes3_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetryInput")
    def monitor_status_codes3_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3Input")
    def monitor_status_codes3_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigNameInput")
    def monitor_status_codes3_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes3RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeoutInput")
    def origin_responsiveness_custom_timeout_input(
        self,
    ) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originResponsivenessCustomTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecoveryInput")
    def origin_responsiveness_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetryInput")
    def origin_responsiveness_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoringInput")
    def origin_responsiveness_monitoring_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigNameInput")
    def origin_responsiveness_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessRecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeoutInput")
    def origin_responsiveness_timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1Input")
    def status_code_monitoring1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring1Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2Input")
    def status_code_monitoring2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring2Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3Input")
    def status_code_monitoring3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring3Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tuningParametersInput")
    def tuning_parameters_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tuningParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContent")
    def binary_equivalent_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "binaryEquivalentContent"))

    @binary_equivalent_content.setter
    def binary_equivalent_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68503136b7fdeb4b2c19674f4b89f3cdf8a1b608f32c81cfe3a3f4d2e82b6fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "binaryEquivalentContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8701f5a170e55d7e3aa24b37a2827b30a35b05b63a52e5f19aed79f392755142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidance")
    def enable_ip_avoidance(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpAvoidance"))

    @enable_ip_avoidance.setter
    def enable_ip_avoidance(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4be05f17635132f11d113f7466a2bc95957911d8e46aeab5f0e4748deaac95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpAvoidance", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThreshold")
    def ip_avoidance_error_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceErrorThreshold"))

    @ip_avoidance_error_threshold.setter
    def ip_avoidance_error_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c82e4e50b3c6a6c2d965c3f094109729134d63cdfd5a99fd4c26d42851dc947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceErrorThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryInterval")
    def ip_avoidance_retry_interval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceRetryInterval"))

    @ip_avoidance_retry_interval.setter
    def ip_avoidance_retry_interval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fe457223dec70e88ad8e913fe3414f1da8007a15676ca957d937f73cc15bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceRetryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22eb3c76613a8c0dba38a4a44b4bae5fcb9df5b0762095b718d9d55fccebb977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsiveness")
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorOriginResponsiveness"))

    @monitor_origin_responsiveness.setter
    def monitor_origin_responsiveness(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faf4ba3ad11a432f37076c435c5dd85011a3c72cb2b186d7ee98a9f7ad4ee59e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorOriginResponsiveness", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1")
    def monitor_response_codes1(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes1"))

    @monitor_response_codes1.setter
    def monitor_response_codes1(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba1b4f9b6ffc2b0b3858984f811f9adc2165b09f00013db58edd1161d260c509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2")
    def monitor_response_codes2(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes2"))

    @monitor_response_codes2.setter
    def monitor_response_codes2(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a098c30612f1e1454cb3f00cc29ccc5ade2871cf5a9244c941ffb0db11e6da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3")
    def monitor_response_codes3(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes3"))

    @monitor_response_codes3.setter
    def monitor_response_codes3(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae8567aedcdf7a46c6da6a74c76781a0e5d7a3447b8bc381ef1c9d794817cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1")
    def monitor_status_codes1(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1"))

    @monitor_status_codes1.setter
    def monitor_status_codes1(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276987b03a9e46baff6ccd077c2f1f576739766b1da4b64e67404abd1edf93b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecovery")
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRecovery"))

    @monitor_status_codes1_enable_recovery.setter
    def monitor_status_codes1_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2af520875fb92f5d8dda5ebb47853ff1d6b7624be62b15692d4dac0bdf8bf08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetry")
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRetry"))

    @monitor_status_codes1_enable_retry.setter
    def monitor_status_codes1_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9825a382aca9ce57ed57f0577379af038ad4208ddd1c25c8f1b0b91c418388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigName")
    def monitor_status_codes1_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes1RecoveryConfigName"))

    @monitor_status_codes1_recovery_config_name.setter
    def monitor_status_codes1_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee01a3ba2a0b6d7a255d37594bcde6b6d40a6150126911b28ec0c12504dd02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2")
    def monitor_status_codes2(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2"))

    @monitor_status_codes2.setter
    def monitor_status_codes2(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ed08dde0b0eb152ff7b84f0b497012d38d4319364a5712743795199e1b8366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecovery")
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRecovery"))

    @monitor_status_codes2_enable_recovery.setter
    def monitor_status_codes2_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea4ba567bcb2160b7505b78a4005c2f1317da4068852e64ab88ea92554b402f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetry")
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRetry"))

    @monitor_status_codes2_enable_retry.setter
    def monitor_status_codes2_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db88d87cea3bd0047711298f1f00426ec30e09ef3dcfd991660dc7858097ed27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigName")
    def monitor_status_codes2_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes2RecoveryConfigName"))

    @monitor_status_codes2_recovery_config_name.setter
    def monitor_status_codes2_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__803003175a3e14ebdb20cc76dc9919e82a4c571b7fcfb2012922c363468219cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3")
    def monitor_status_codes3(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3"))

    @monitor_status_codes3.setter
    def monitor_status_codes3(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c582621ef30ba630def1d3dccaf13aa02e234ee5b7ea687fdc906f53a5bc61a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecovery")
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRecovery"))

    @monitor_status_codes3_enable_recovery.setter
    def monitor_status_codes3_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76e46cfacb383d537b2f69850f143433b45327bb4d0f44c0f5f3372ab7ecdffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetry")
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRetry"))

    @monitor_status_codes3_enable_retry.setter
    def monitor_status_codes3_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d195f9795f28606b7c313758298ecfb53d1f2e470f1319fabd21ba877e4a26b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigName")
    def monitor_status_codes3_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes3RecoveryConfigName"))

    @monitor_status_codes3_recovery_config_name.setter
    def monitor_status_codes3_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11661048dfa0c54bfa48d81890f43dee0589a09eb9663a6bb371e92b9d0c8fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeout")
    def origin_responsiveness_custom_timeout(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originResponsivenessCustomTimeout"))

    @origin_responsiveness_custom_timeout.setter
    def origin_responsiveness_custom_timeout(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f7a94006fbed20ff75965bc7ecd1a1203a75efbae507e83ac2e90e4bf5b951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessCustomTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecovery")
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRecovery"))

    @origin_responsiveness_enable_recovery.setter
    def origin_responsiveness_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada223b490798df1f5a656f9c2de95dac40667b492dd9b97e885e5fd74acab55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetry")
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRetry"))

    @origin_responsiveness_enable_retry.setter
    def origin_responsiveness_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a5c8dedab6b6d81b2e868738dee12a4e7f9fd4434199477fc602d9832abef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoring")
    def origin_responsiveness_monitoring(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessMonitoring"))

    @origin_responsiveness_monitoring.setter
    def origin_responsiveness_monitoring(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65168919900e5f0dfb518e734d08ed4edd0c567cd08f916e37b8e604eff36129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigName")
    def origin_responsiveness_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessRecoveryConfigName"))

    @origin_responsiveness_recovery_config_name.setter
    def origin_responsiveness_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9219e77937df00fce4fd2af5889f444e810a29ed6d72d61968488d7475dcad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessRecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeout")
    def origin_responsiveness_timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessTimeout"))

    @origin_responsiveness_timeout.setter
    def origin_responsiveness_timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b86493a75cb11514462218615acb08e8e91c29dcae25498c7e9a7cfd1099e751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1")
    def status_code_monitoring1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring1"))

    @status_code_monitoring1.setter
    def status_code_monitoring1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb6a0fcd9298231bd84f5d8a24d394592162cc79a76ce4827c1155d9e4269a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring1", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2")
    def status_code_monitoring2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring2"))

    @status_code_monitoring2.setter
    def status_code_monitoring2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb8b08db6f128f35c2c3ccd7d9ddc0082c3b64af29b232ae94a398cbc402b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring2", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3")
    def status_code_monitoring3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring3"))

    @status_code_monitoring3.setter
    def status_code_monitoring3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d53924b21e5767f6b47a3d4a2cc0ad0b0cc76025e43db185b0576b84f3841949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring3", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a09a78aa83d17cd453371a39f25d6f88b822297b6a3ac24f08f4e8103a27e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tuningParameters")
    def tuning_parameters(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tuningParameters"))

    @tuning_parameters.setter
    def tuning_parameters(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ee6193b4d6e70189cc7cafdfb444d7813a52d71f18fff36b7241c66f78d14d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tuningParameters", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0be00f9ec21ccf41c280f4fd951f830d29d5d467c82e0ebe6bda362ff5b3fb29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adffd3aaae01be9b1d1d92f490ab7855badea72b00946680e7989b1cb65f9ca3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6cec4c7326a7b72dd0075ec0a78097e9a9b926f1f5d17050f5aae836e89880)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Origin IP Access Control List behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa113e0f7411bb22634773a482126a0dc0d578a83f6960bb1b414dbfc8125d64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e8b47acecd4bb0df4dbfd0cba1dec396883da0e964d2fa724ecbe7504af4a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebe29941a2d01960a83e2add6135700b857312882e9535c6843a87f3e0ae8bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24ae566eb4f57a0fa05215fe3dc8f33763a2d78dd1e6ffd48d977fa1c86c3ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdf4119463867c3f9a20449afbd37bdcc42b2a4466c58ca11d6906b545af2cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5254235c952c33c69660bd925dee34b8330c5b28f3e59d0494876333eba4acd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c979525f9034ff4c0730a126e8ff16f7c0504c1ae1176e7480e790e7b350c2)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02710684436c14a92883723bc82bca76e038539b52725f9e2e7359595b5045b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce7aaa95312b881e901c29dce55b2eb345e2d456101c51d743ebabcaf622734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f34dd0f5ca502800c11095ae1554ca45e50acd7fc873faa2f23b1910a5be755e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbeb4e1666b3c67817597b487fc91cdaa8455e23f5ace3b0cc5f1db594c5d466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e22f2280a91f79b29effbda553fb8f3f760eb91115435a719b7268a6ce8198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7093b76188ebb1627994d734fc50ba3322cb67f76f935d934891b94cbbce5ffb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCustomCertificateAuthorities")
    def put_custom_certificate_authorities(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50de080890db609a8b8f857f0c46db2bc6bf6c119472c174d930bce40ac90518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificateAuthorities", [value]))

    @jsii.member(jsii_name="putCustomCertificates")
    def put_custom_certificates(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50b0f9de11a797cae48cb89f1bd8221db910c163cb5449488d2caba4931dd4fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificates", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetCacheKeyHostname")
    def reset_cache_key_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyHostname", []))

    @jsii.member(jsii_name="resetCompress")
    def reset_compress(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompress", []))

    @jsii.member(jsii_name="resetCustomCertificateAuthorities")
    def reset_custom_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificateAuthorities", []))

    @jsii.member(jsii_name="resetCustomCertificates")
    def reset_custom_certificates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificates", []))

    @jsii.member(jsii_name="resetCustomForwardHostHeader")
    def reset_custom_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomForwardHostHeader", []))

    @jsii.member(jsii_name="resetCustomValidCnValues")
    def reset_custom_valid_cn_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValidCnValues", []))

    @jsii.member(jsii_name="resetEnableTrueClientIp")
    def reset_enable_true_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTrueClientIp", []))

    @jsii.member(jsii_name="resetForwardHostHeader")
    def reset_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHostHeader", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetHttpPort")
    def reset_http_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpPort", []))

    @jsii.member(jsii_name="resetHttpsPort")
    def reset_https_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpsPort", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMslorigin")
    def reset_mslorigin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslorigin", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetOriginCertificate")
    def reset_origin_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertificate", []))

    @jsii.member(jsii_name="resetOriginCertsToHonor")
    def reset_origin_certs_to_honor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertsToHonor", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetOriginSni")
    def reset_origin_sni(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSni", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetPorts")
    def reset_ports(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPorts", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetSecondHostname")
    def reset_second_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostname", []))

    @jsii.member(jsii_name="resetSecondHostnameEnabled")
    def reset_second_hostname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostnameEnabled", []))

    @jsii.member(jsii_name="resetStandardCertificateAuthorities")
    def reset_standard_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardCertificateAuthorities", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrueClientIpClientSetting")
    def reset_true_client_ip_client_setting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpClientSetting", []))

    @jsii.member(jsii_name="resetTrueClientIpHeader")
    def reset_true_client_ip_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpHeader", []))

    @jsii.member(jsii_name="resetUseUniqueCacheKey")
    def reset_use_unique_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseUniqueCacheKey", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationMode")
    def reset_verification_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationMode", []))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthorities")
    def custom_certificate_authorities(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesList, jsii.get(self, "customCertificateAuthorities"))

    @builtins.property
    @jsii.member(jsii_name="customCertificates")
    def custom_certificates(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesList, jsii.get(self, "customCertificates"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostnameInput")
    def cache_key_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheKeyHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="compressInput")
    def compress_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthoritiesInput")
    def custom_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "customCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificatesInput")
    def custom_certificates_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]]], jsii.get(self, "customCertificatesInput"))

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeaderInput")
    def custom_forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customForwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="customValidCnValuesInput")
    def custom_valid_cn_values_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customValidCnValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIpInput")
    def enable_true_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTrueClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeaderInput")
    def forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="httpPortInput")
    def http_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpPortInput"))

    @builtins.property
    @jsii.member(jsii_name="httpsPortInput")
    def https_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpsPortInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="msloriginInput")
    def mslorigin_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "msloriginInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertificateInput")
    def origin_certificate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonorInput")
    def origin_certs_to_honor_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertsToHonorInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="originSniInput")
    def origin_sni_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originSniInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="portsInput")
    def ports_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "portsInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabledInput")
    def second_hostname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondHostnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameInput")
    def second_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthoritiesInput")
    def standard_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "standardCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSettingInput")
    def true_client_ip_client_setting_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "trueClientIpClientSettingInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeaderInput")
    def true_client_ip_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trueClientIpHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKeyInput")
    def use_unique_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useUniqueCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationModeInput")
    def verification_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostname")
    def cache_key_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheKeyHostname"))

    @cache_key_hostname.setter
    def cache_key_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204ba395d5deba6901e5475589479d709d130e3a2b65a8954cd30c1f22f8170b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKeyHostname", value)

    @builtins.property
    @jsii.member(jsii_name="compress")
    def compress(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compress"))

    @compress.setter
    def compress(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89246af4b29e3baaa9485acf0fe22d482a80daa76b80645faef249a797fba6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compress", value)

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeader")
    def custom_forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customForwardHostHeader"))

    @custom_forward_host_header.setter
    def custom_forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc5557f34b65961e1f16b15beafa65d3cc12f47346a4df1e942f9ddab95f77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customForwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="customValidCnValues")
    def custom_valid_cn_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customValidCnValues"))

    @custom_valid_cn_values.setter
    def custom_valid_cn_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3f85919261aa8dbe87050711c5743a62a228705e96946e63e3bcf1b7dc5a07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValidCnValues", value)

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIp")
    def enable_true_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTrueClientIp"))

    @enable_true_client_ip.setter
    def enable_true_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f33eb922b969036a93985dba09173d3171394917f4d274e4bed7c6935a7409e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTrueClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeader")
    def forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardHostHeader"))

    @forward_host_header.setter
    def forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8efd62c5ce2cf754efa96bbc5e844c99e0a6a98c447b51490cf9129f9cd0c30b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4315ef28cfcbfa17e1c0545e1b1b43784d8f1159351826693c4576f25842e0ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="httpPort")
    def http_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpPort"))

    @http_port.setter
    def http_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b02008a733868c44e1d2027d725702f3a41c4371b4ff13c679e3d86007b4396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpPort", value)

    @builtins.property
    @jsii.member(jsii_name="httpsPort")
    def https_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpsPort"))

    @https_port.setter
    def https_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27488479070c2dc806f2264994a08d27c246d9c60bccaa6df1a13a915af01503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpsPort", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9e290a4345eafbd526ef0ad0c3ddb83898b187fc62db77e7171e63c7fdf25f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e0b3d398aa95b149bfbace11aad33fcaf27500fce2a4776bae515ee279dc59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mslorigin")
    def mslorigin(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslorigin"))

    @mslorigin.setter
    def mslorigin(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e59a8005befdf4874b4a31dd1ffaf22a606b67fea3d92d1a2241bfb838bdc30e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslorigin", value)

    @builtins.property
    @jsii.member(jsii_name="originCertificate")
    def origin_certificate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertificate"))

    @origin_certificate.setter
    def origin_certificate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e8ce9a623abe3cb1a545a6633ea0797d5f0f1c4d18320c1e302842d915f815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonor")
    def origin_certs_to_honor(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertsToHonor"))

    @origin_certs_to_honor.setter
    def origin_certs_to_honor(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7bf17166fca334e4a08eb708638ccca927405ef6526f0d856336f916b92ba37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertsToHonor", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca2b1494e6188d42f9a709d9acaf042830e1cad7e5caa246c1f323b81e543ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="originSni")
    def origin_sni(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originSni"))

    @origin_sni.setter
    def origin_sni(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56953bce52e52652fea1a068e184d93492b2816a6294904f5ab2272bf11eb244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSni", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674e4d5f93b4ef371f4a74c8530455f766af402eb336fc04fa5aacd3b3ab9359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="ports")
    def ports(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ports"))

    @ports.setter
    def ports(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2172dad83c8dd0a3c644fb8dc35eb1caa5a5d6cf597c271bedb72f9ebfea37d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ports", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a55d15062270abd071aa5544f6ce710401347aa75f697ef259118a64c6ca916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39a1093e055cc6ae2b68ff2687b0219687a557ccef663e54b23771894a2edcd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05716b5b1bf68f6eef77e731c6725a15651a1c13d69ae9e4facbfcc77722e073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6cbe30b5ec69cb6d0f23d10daaaa26f1e2c710b447e8bfffb1ac1cb49c2baa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196ddd1c59c17de195407a428fc89c7550558ae5ccf7dcb7ee78ecb4066ad62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab54050e7c96f3dc74082cacc55b8bb890acc1407a6ccdd4116bce589d704373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a29c5bf4e8b8e73d3c07f9a90feecbcfa081b6511efd9f6437511fe5615dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f1862f22075073065525fd3ed4662e4c6ffb76e36df3fa24c44d5b7b2510a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostname")
    def second_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondHostname"))

    @second_hostname.setter
    def second_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcf3b10d4fe9e46081d2d44323da2acb32f86bbe55eb66c64778fd36c9d5fb17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostname", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabled")
    def second_hostname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondHostnameEnabled"))

    @second_hostname_enabled.setter
    def second_hostname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3698f7c72fa528fddb0c359f9e3b1568ad6095a40324d354a815ac1141f70981)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthorities")
    def standard_certificate_authorities(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "standardCertificateAuthorities"))

    @standard_certificate_authorities.setter
    def standard_certificate_authorities(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84d5f74d2b23407587041567836032cb7233c0e3f3404a5ca122305e359e4284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardCertificateAuthorities", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67bb5e541d2e077671758e87c9f3dc7ec37f815e096416cbe434df50ed5718d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSetting")
    def true_client_ip_client_setting(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "trueClientIpClientSetting"))

    @true_client_ip_client_setting.setter
    def true_client_ip_client_setting(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01075376af0de27936cc882620bf3b0ac1746638d8f215d6e6eade5e3134e30d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpClientSetting", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeader")
    def true_client_ip_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trueClientIpHeader"))

    @true_client_ip_header.setter
    def true_client_ip_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e660a36530c0304100bb62cb3f85e140f7f73697a6fdd44298bb39f521fbc53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpHeader", value)

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKey")
    def use_unique_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useUniqueCacheKey"))

    @use_unique_cache_key.setter
    def use_unique_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fef52de8b78ea090918ee537861e28aa8a7b0204e9e2e84b4c9b1979647b5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useUniqueCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1ae1ca09ac5c31f46ac843b13e7ba182a1bfb9fa9b1c30ef46996e02369389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationMode")
    def verification_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationMode"))

    @verification_mode.setter
    def verification_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a84540915fc2556c1e674dc2f4a097e9ab91c10150f029446c1e1a77381e4fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ace381a000364f8fe7144cda353b9ea339ac46ad288d1f84b246a3c8df2f37b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a1b8fd6e36b504964a6df440d842ea68149203483593f4637926d14cd29f46a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdaptiveAcceleration")
    def put_adaptive_acceleration(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration(
            ab_logic=ab_logic,
            ab_testing=ab_testing,
            compression=compression,
            cookie_name=cookie_name,
            enable_brotli_compression=enable_brotli_compression,
            enable_for_noncacheable=enable_for_noncacheable,
            enable_preconnect=enable_preconnect,
            enable_push=enable_push,
            enable_ro=enable_ro,
            locked=locked,
            preload_enable=preload_enable,
            source=source,
            template_uuid=template_uuid,
            title_brotli=title_brotli,
            title_http2_server_push=title_http2_server_push,
            title_preconnect=title_preconnect,
            title_preload=title_preload,
            title_ro=title_ro,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveAcceleration", [value]))

    @jsii.member(jsii_name="putAdaptiveImageCompression")
    def put_adaptive_image_compression(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression(
            compress_mobile=compress_mobile,
            compress_standard=compress_standard,
            locked=locked,
            template_uuid=template_uuid,
            tier1_mobile_compression_method=tier1_mobile_compression_method,
            tier1_mobile_compression_value=tier1_mobile_compression_value,
            tier1_standard_compression_method=tier1_standard_compression_method,
            tier1_standard_compression_value=tier1_standard_compression_value,
            tier2_mobile_compression_method=tier2_mobile_compression_method,
            tier2_mobile_compression_value=tier2_mobile_compression_value,
            tier2_standard_compression_method=tier2_standard_compression_method,
            tier2_standard_compression_value=tier2_standard_compression_value,
            tier3_mobile_compression_method=tier3_mobile_compression_method,
            tier3_mobile_compression_value=tier3_mobile_compression_value,
            tier3_standard_compression_method=tier3_standard_compression_method,
            tier3_standard_compression_value=tier3_standard_compression_value,
            title_aic_mobile=title_aic_mobile,
            title_aic_nonmobile=title_aic_nonmobile,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveImageCompression", [value]))

    @jsii.member(jsii_name="putAdScalerCircuitBreaker")
    def put_ad_scaler_circuit_breaker(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker(
            fallback_action_response_code_based=fallback_action_response_code_based,
            locked=locked,
            response_code_based=response_code_based,
            response_codes=response_codes,
            response_delay_based=response_delay_based,
            response_delay_threshold=response_delay_threshold,
            return_error_response_code_based=return_error_response_code_based,
            specify_your_own_response_code_based=specify_your_own_response_code_based,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdScalerCircuitBreaker", [value]))

    @jsii.member(jsii_name="putAdvanced")
    def put_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvanced", [value]))

    @jsii.member(jsii_name="putAggregatedReporting")
    def put_aggregated_reporting(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting(
            attribute1=attribute1,
            attribute2=attribute2,
            attribute3=attribute3,
            attribute4=attribute4,
            attributes_count=attributes_count,
            enabled=enabled,
            locked=locked,
            report_name=report_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAggregatedReporting", [value]))

    @jsii.member(jsii_name="putAkamaizer")
    def put_akamaizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizer", [value]))

    @jsii.member(jsii_name="putAkamaizerTag")
    def put_akamaizer_tag(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag(
            include_tags_attribute=include_tags_attribute,
            locked=locked,
            match_hostname=match_hostname,
            replace_all=replace_all,
            replacement_hostname=replacement_hostname,
            scope=scope,
            tags_attribute=tags_attribute,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizerTag", [value]))

    @jsii.member(jsii_name="putAllHttpInCacheHierarchy")
    def put_all_http_in_cache_hierarchy(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllHttpInCacheHierarchy", [value]))

    @jsii.member(jsii_name="putAllowCloudletsOrigins")
    def put_allow_cloudlets_origins(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins(
            enabled=enabled,
            honor_base_directory=honor_base_directory,
            locked=locked,
            purge_origin_query_parameter=purge_origin_query_parameter,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowCloudletsOrigins", [value]))

    @jsii.member(jsii_name="putAllowDelete")
    def put_allow_delete(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete(
            allow_body=allow_body,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowDelete", [value]))

    @jsii.member(jsii_name="putAllowHttpsCacheKeySharing")
    def put_allow_https_cache_key_sharing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsCacheKeySharing", [value]))

    @jsii.member(jsii_name="putAllowHttpsDowngrade")
    def put_allow_https_downgrade(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsDowngrade", [value]))

    @jsii.member(jsii_name="putAllowOptions")
    def put_allow_options(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowOptions", [value]))

    @jsii.member(jsii_name="putAllowPatch")
    def put_allow_patch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPatch", [value]))

    @jsii.member(jsii_name="putAllowPost")
    def put_allow_post(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost(
            allow_without_content_length=allow_without_content_length,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPost", [value]))

    @jsii.member(jsii_name="putAllowPut")
    def put_allow_put(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPut", [value]))

    @jsii.member(jsii_name="putAllowTransferEncoding")
    def put_allow_transfer_encoding(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowTransferEncoding", [value]))

    @jsii.member(jsii_name="putAltSvcHeader")
    def put_alt_svc_header(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader(
            locked=locked, max_age=max_age, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAltSvcHeader", [value]))

    @jsii.member(jsii_name="putApiPrioritization")
    def put_api_prioritization(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization(
            alternate_response_cache_ttl=alternate_response_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            net_storage=net_storage,
            net_storage_path=net_storage_path,
            template_uuid=template_uuid,
            throttled_cp_code=throttled_cp_code,
            throttled_status_code=throttled_status_code,
            use_throttled_cp_code=use_throttled_cp_code,
            use_throttled_status_code=use_throttled_status_code,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApiPrioritization", [value]))

    @jsii.member(jsii_name="putApplicationLoadBalancer")
    def put_application_load_balancer(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer(
            all_down_net_storage=all_down_net_storage,
            all_down_net_storage_file=all_down_net_storage_file,
            all_down_status_code=all_down_status_code,
            all_down_title=all_down_title,
            allow_cache_prefresh=allow_cache_prefresh,
            cached_content_title=cached_content_title,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            failover_attempts_threshold=failover_attempts_threshold,
            failover_mode=failover_mode,
            failover_origin_map=failover_origin_map,
            failover_status_codes=failover_status_codes,
            failover_title=failover_title,
            label=label,
            locked=locked,
            origin_cookie_name=origin_cookie_name,
            specify_stickiness_cookie_domain=specify_stickiness_cookie_domain,
            stickiness_cookie_automatic_salt=stickiness_cookie_automatic_salt,
            stickiness_cookie_domain=stickiness_cookie_domain,
            stickiness_cookie_salt=stickiness_cookie_salt,
            stickiness_cookie_set_http_only_flag=stickiness_cookie_set_http_only_flag,
            stickiness_cookie_type=stickiness_cookie_type,
            stickiness_duration=stickiness_duration,
            stickiness_expiration_date=stickiness_expiration_date,
            stickiness_refresh=stickiness_refresh,
            stickiness_title=stickiness_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApplicationLoadBalancer", [value]))

    @jsii.member(jsii_name="putAudienceSegmentation")
    def put_audience_segmentation(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_automatic_salt=population_cookie_automatic_salt,
            population_cookie_domain=population_cookie_domain,
            population_cookie_include_rule_name=population_cookie_include_rule_name,
            population_cookie_salt=population_cookie_salt,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_refresh=population_refresh,
            population_title=population_title,
            segment_tracking_cookie_name=segment_tracking_cookie_name,
            segment_tracking_custom_header=segment_tracking_custom_header,
            segment_tracking_method=segment_tracking_method,
            segment_tracking_query_param=segment_tracking_query_param,
            segment_tracking_title=segment_tracking_title,
            specify_population_cookie_domain=specify_population_cookie_domain,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAudienceSegmentation", [value]))

    @jsii.member(jsii_name="putAutoDomainValidation")
    def put_auto_domain_validation(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation(
            autodv=autodv, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAutoDomainValidation", [value]))

    @jsii.member(jsii_name="putBaseDirectory")
    def put_base_directory(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putBaseDirectory", [value_]))

    @jsii.member(jsii_name="putBossBeaconing")
    def put_boss_beaconing(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing(
            conditional_error_pattern=conditional_error_pattern,
            conditional_http_status=conditional_http_status,
            conditional_sampling_frequency=conditional_sampling_frequency,
            cpcodes=cpcodes,
            enabled=enabled,
            forward_type=forward_type,
            locked=locked,
            request_type=request_type,
            sampling_frequency=sampling_frequency,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBossBeaconing", [value]))

    @jsii.member(jsii_name="putBreadcrumbs")
    def put_breadcrumbs(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs(
            enabled=enabled,
            locked=locked,
            logging_enabled=logging_enabled,
            opt_mode=opt_mode,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBreadcrumbs", [value]))

    @jsii.member(jsii_name="putBreakConnection")
    def put_break_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBreakConnection", [value]))

    @jsii.member(jsii_name="putBrotli")
    def put_brotli(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBrotli", [value]))

    @jsii.member(jsii_name="putCacheError")
    def put_cache_error(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError(
            enabled=enabled,
            locked=locked,
            preserve_stale=preserve_stale,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheError", [value]))

    @jsii.member(jsii_name="putCacheId")
    def put_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId(
            elements=elements,
            include_value=include_value,
            locked=locked,
            optional=optional,
            rule=rule,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheId", [value]))

    @jsii.member(jsii_name="putCacheKeyIgnoreCase")
    def put_cache_key_ignore_case(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyIgnoreCase", [value]))

    @jsii.member(jsii_name="putCacheKeyQueryParams")
    def put_cache_key_query_params(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams(
            behavior=behavior,
            exact_match=exact_match,
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyQueryParams", [value]))

    @jsii.member(jsii_name="putCacheKeyRewrite")
    def put_cache_key_rewrite(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite(
            locked=locked, purge_key=purge_key, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyRewrite", [value]))

    @jsii.member(jsii_name="putCachePost")
    def put_cache_post(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_body=use_body,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCachePost", [value]))

    @jsii.member(jsii_name="putCacheRedirect")
    def put_cache_redirect(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheRedirect", [value]))

    @jsii.member(jsii_name="putCacheTag")
    def put_cache_tag(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag(
            locked=locked, tag=tag, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTag", [value]))

    @jsii.member(jsii_name="putCacheTagVisible")
    def put_cache_tag_visible(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTagVisible", [value]))

    @jsii.member(jsii_name="putCaching")
    def put_caching(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching(
            behavior=behavior,
            cacheability_settings=cacheability_settings,
            cache_control_directives=cache_control_directives,
            default_ttl=default_ttl,
            enhanced_rfc_support=enhanced_rfc_support,
            expiration_settings=expiration_settings,
            honor_max_age=honor_max_age,
            honor_must_revalidate=honor_must_revalidate,
            honor_no_cache=honor_no_cache,
            honor_no_store=honor_no_store,
            honor_private=honor_private,
            honor_proxy_revalidate=honor_proxy_revalidate,
            honor_s_maxage=honor_s_maxage,
            locked=locked,
            must_revalidate=must_revalidate,
            revalidation_settings=revalidation_settings,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCaching", [value]))

    @jsii.member(jsii_name="putCentralAuthorization")
    def put_central_authorization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCentralAuthorization", [value]))

    @jsii.member(jsii_name="putChaseRedirects")
    def put_chase_redirects(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects(
            enabled=enabled,
            limit=limit,
            locked=locked,
            serve404=serve404,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChaseRedirects", [value]))

    @jsii.member(jsii_name="putClientCharacteristics")
    def put_client_characteristics(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics(
            country=country, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putClientCharacteristics", [value]))

    @jsii.member(jsii_name="putCloudInterconnects")
    def put_cloud_interconnects(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects(
            cloud_locations=cloud_locations,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudInterconnects", [value]))

    @jsii.member(jsii_name="putCloudWrapper")
    def put_cloud_wrapper(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper(
            enabled=enabled,
            location=location,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapper", [value]))

    @jsii.member(jsii_name="putCloudWrapperAdvanced")
    def put_cloud_wrapper_advanced(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced(
            custom_failover_map=custom_failover_map,
            enabled=enabled,
            failover_map=failover_map,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapperAdvanced", [value]))

    @jsii.member(jsii_name="putCommonMediaClientData")
    def put_common_media_client_data(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData(
            enable_cmcd_segment_prefetch=enable_cmcd_segment_prefetch,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCommonMediaClientData", [value]))

    @jsii.member(jsii_name="putConditionalOrigin")
    def put_conditional_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putConditionalOrigin", [value]))

    @jsii.member(jsii_name="putConstructResponse")
    def put_construct_response(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse(
            body=body,
            enabled=enabled,
            force_eviction=force_eviction,
            ignore_purge=ignore_purge,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putConstructResponse", [value]))

    @jsii.member(jsii_name="putContentCharacteristics")
    def put_content_characteristics(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristics", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsAmd")
    def put_content_characteristics_amd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_dash_custom=segment_duration_dash_custom,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hds_custom=segment_duration_hds_custom,
            segment_duration_hls=segment_duration_hls,
            segment_duration_hls_custom=segment_duration_hls_custom,
            segment_duration_smooth=segment_duration_smooth,
            segment_duration_smooth_custom=segment_duration_smooth_custom,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsAmd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsDd")
    def put_content_characteristics_dd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            optimize_option=optimize_option,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsDd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLargeFile")
    def put_content_characteristics_wsd_large_file(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLargeFile", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLive")
    def put_content_characteristics_wsd_live(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLive", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdVod")
    def put_content_characteristics_wsd_vod(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdVod", [value]))

    @jsii.member(jsii_name="putContentPrePosition")
    def put_content_pre_position(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition(
            enabled=enabled,
            first_location=first_location,
            locked=locked,
            second_location=second_location,
            source_type=source_type,
            targets=targets,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentPrePosition", [value]))

    @jsii.member(jsii_name="putContentTargetingProtection")
    def put_content_targeting_protection(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection(
            countries=countries,
            dmas=dmas,
            enabled=enabled,
            enable_geo_protection=enable_geo_protection,
            enable_geo_redirect_on_deny=enable_geo_redirect_on_deny,
            enable_ip_protection=enable_ip_protection,
            enable_ip_redirect_on_deny=enable_ip_redirect_on_deny,
            enable_referrer_protection=enable_referrer_protection,
            enable_referrer_redirect_on_deny=enable_referrer_redirect_on_deny,
            geo_protection_mode=geo_protection_mode,
            geo_protection_title=geo_protection_title,
            geo_redirect_url=geo_redirect_url,
            ip_addresses=ip_addresses,
            ip_protection_mode=ip_protection_mode,
            ip_protection_title=ip_protection_title,
            ip_redirect_url=ip_redirect_url,
            locked=locked,
            override_ip_addresses=override_ip_addresses,
            referrer_domains=referrer_domains,
            referrer_protection_mode=referrer_protection_mode,
            referrer_protection_title=referrer_protection_title,
            referrer_redirect_url=referrer_redirect_url,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentTargetingProtection", [value]))

    @jsii.member(jsii_name="putCorsSupport")
    def put_cors_support(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport(
            allow_credentials=allow_credentials,
            allow_headers=allow_headers,
            allow_origins=allow_origins,
            enabled=enabled,
            expose_headers=expose_headers,
            headers=headers,
            locked=locked,
            methods=methods,
            origins=origins,
            preflight_max_age=preflight_max_age,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCorsSupport", [value]))

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value_]))

    @jsii.member(jsii_name="putCustomBehavior")
    def put_custom_behavior(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior(
            behavior_id=behavior_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCustomBehavior", [value]))

    @jsii.member(jsii_name="putDatastream")
    def put_datastream(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream(
            beacon_stream_title=beacon_stream_title,
            collect_midgress_traffic=collect_midgress_traffic,
            datastream_ids=datastream_ids,
            enabled=enabled,
            locked=locked,
            log_enabled=log_enabled,
            log_stream_name=log_stream_name,
            log_stream_title=log_stream_title,
            sampling_percentage=sampling_percentage,
            stream_type=stream_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDatastream", [value]))

    @jsii.member(jsii_name="putDcp")
    def put_dcp(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp(
            anonymous=anonymous,
            enabled=enabled,
            gwenabled=gwenabled,
            locked=locked,
            namespace_id=namespace_id,
            template_uuid=template_uuid,
            tlsenabled=tlsenabled,
            uuid=uuid,
            wsenabled=wsenabled,
        )

        return typing.cast(None, jsii.invoke(self, "putDcp", [value]))

    @jsii.member(jsii_name="putDcpAuthHmacTransformation")
    def put_dcp_auth_hmac_transformation(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation(
            hash_conversion_algorithm=hash_conversion_algorithm,
            hash_conversion_key=hash_conversion_key,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthHmacTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthRegexTransformation")
    def put_dcp_auth_regex_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation(
            locked=locked,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthRegexTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthSubstringTransformation")
    def put_dcp_auth_substring_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation(
            locked=locked,
            substring_end=substring_end,
            substring_start=substring_start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthSubstringTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthVariableExtractor")
    def put_dcp_auth_variable_extractor(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor(
            certificate_field=certificate_field,
            dcp_mutual_auth_processing_variable_id=dcp_mutual_auth_processing_variable_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthVariableExtractor", [value]))

    @jsii.member(jsii_name="putDcpDefaultAuthzGroups")
    def put_dcp_default_authz_groups(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups(
            group_names=group_names,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDefaultAuthzGroups", [value]))

    @jsii.member(jsii_name="putDcpDevRelations")
    def put_dcp_dev_relations(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations(
            custom_values=custom_values,
            enabled=enabled,
            hostname=hostname,
            locked=locked,
            path=path,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDevRelations", [value]))

    @jsii.member(jsii_name="putDcpRealTimeAuth")
    def put_dcp_real_time_auth(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth(
            extract_hostname=extract_hostname,
            extract_jurisdiction=extract_jurisdiction,
            extract_namespace=extract_namespace,
            hostname_claim=hostname_claim,
            jurisdiction_claim=jurisdiction_claim,
            locked=locked,
            namespace_claim=namespace_claim,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpRealTimeAuth", [value]))

    @jsii.member(jsii_name="putDeliveryReceipt")
    def put_delivery_receipt(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeliveryReceipt", [value]))

    @jsii.member(jsii_name="putDenyAccess")
    def put_deny_access(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess(
            enabled=enabled,
            locked=locked,
            reason=reason,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDenyAccess", [value]))

    @jsii.member(jsii_name="putDenyDirectFailoverAccess")
    def put_deny_direct_failover_access(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDenyDirectFailoverAccess", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicCacheId")
    def put_device_characteristic_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicCacheId", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicHeader")
    def put_device_characteristic_header(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicHeader", [value]))

    @jsii.member(jsii_name="putDnsAsyncRefresh")
    def put_dns_async_refresh(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsAsyncRefresh", [value]))

    @jsii.member(jsii_name="putDnsPrefresh")
    def put_dns_prefresh(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh(
            delay=delay,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsPrefresh", [value]))

    @jsii.member(jsii_name="putDowngradeProtocol")
    def put_downgrade_protocol(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDowngradeProtocol", [value]))

    @jsii.member(jsii_name="putDownloadCompleteMarker")
    def put_download_complete_marker(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadCompleteMarker", [value]))

    @jsii.member(jsii_name="putDownloadNotification")
    def put_download_notification(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadNotification", [value]))

    @jsii.member(jsii_name="putDownstreamCache")
    def put_downstream_cache(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache(
            allow_behavior=allow_behavior,
            behavior=behavior,
            locked=locked,
            send_headers=send_headers,
            send_private=send_private,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDownstreamCache", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimization")
    def put_dynamic_throughtput_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimization", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimizationOverride")
    def put_dynamic_throughtput_optimization_override(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride(
            locked=locked,
            template_uuid=template_uuid,
            throughput=throughput,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimizationOverride", [value]))

    @jsii.member(jsii_name="putDynamicWebContent")
    def put_dynamic_web_content(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent(
            image_compression=image_compression,
            locked=locked,
            prefetch=prefetch,
            real_user_monitoring=real_user_monitoring,
            sure_route=sure_route,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicWebContent", [value]))

    @jsii.member(jsii_name="putEcmsBulkUpload")
    def put_ecms_bulk_upload(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsBulkUpload", [value]))

    @jsii.member(jsii_name="putEcmsDatabase")
    def put_ecms_database(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase(
            database=database,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDatabase", [value]))

    @jsii.member(jsii_name="putEcmsDataset")
    def put_ecms_dataset(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset(
            dataset=dataset,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDataset", [value]))

    @jsii.member(jsii_name="putEcmsObjectKey")
    def put_ecms_object_key(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey(
            locked=locked, regex=regex, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsObjectKey", [value]))

    @jsii.member(jsii_name="putEdgeConnect")
    def put_edge_connect(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect(
            aggregate_lines=aggregate_lines,
            aggregate_size=aggregate_size,
            aggregate_time=aggregate_time,
            api_connector=api_connector,
            api_data_elements=api_data_elements,
            destination_hostname=destination_hostname,
            destination_path=destination_path,
            enabled=enabled,
            locked=locked,
            override_aggregate_settings=override_aggregate_settings,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeConnect", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingAdvanced")
    def put_edge_load_balancing_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingAdvanced", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingDataCenter")
    def put_edge_load_balancing_data_center(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter(
            cookie_name=cookie_name,
            description=description,
            enable_failover=enable_failover,
            failover_rules=failover_rules,
            failover_title=failover_title,
            hostname=hostname,
            ip=ip,
            locked=locked,
            origin_id=origin_id,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingDataCenter", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingOrigin")
    def put_edge_load_balancing_origin(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin(
            cookie_name=cookie_name,
            description=description,
            enable_session_persistence=enable_session_persistence,
            hostname=hostname,
            id=id,
            locked=locked,
            session_persistence_title=session_persistence_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingOrigin", [value]))

    @jsii.member(jsii_name="putEdgeOriginAuthorization")
    def put_edge_origin_authorization(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization(
            cookie_name=cookie_name,
            domain=domain,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeOriginAuthorization", [value_]))

    @jsii.member(jsii_name="putEdgeRedirector")
    def put_edge_redirector(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeRedirector", [value]))

    @jsii.member(jsii_name="putEdgeScape")
    def put_edge_scape(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeScape", [value]))

    @jsii.member(jsii_name="putEdgeSideIncludes")
    def put_edge_side_includes(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes(
            detect_injection=detect_injection,
            enabled=enabled,
            enable_via_http=enable_via_http,
            i18_n_charset=i18_n_charset,
            i18_n_status=i18_n_status,
            locked=locked,
            pass_client_ip=pass_client_ip,
            pass_set_cookie=pass_set_cookie,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeSideIncludes", [value]))

    @jsii.member(jsii_name="putEdgeWorker")
    def put_edge_worker(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker(
            create_edge_worker=create_edge_worker,
            edge_worker_id=edge_worker_id,
            enabled=enabled,
            locked=locked,
            resource_tier=resource_tier,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorker", [value]))

    @jsii.member(jsii_name="putEnhancedAkamaiProtocol")
    def put_enhanced_akamai_protocol(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedAkamaiProtocol", [value]))

    @jsii.member(jsii_name="putEnhancedProxyDetection")
    def put_enhanced_proxy_detection(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection(
            anonymous_vpn=anonymous_vpn,
            best_practice_action=best_practice_action,
            best_practice_redirecturl=best_practice_redirecturl,
            detect_anonymous_vpn=detect_anonymous_vpn,
            detect_anonymous_vpn_action=detect_anonymous_vpn_action,
            detect_anonymous_vpn_redirecturl=detect_anonymous_vpn_redirecturl,
            detect_hosting_provider=detect_hosting_provider,
            detect_hosting_provider_action=detect_hosting_provider_action,
            detect_hosting_provider_redirecturl=detect_hosting_provider_redirecturl,
            detect_public_proxy=detect_public_proxy,
            detect_public_proxy_action=detect_public_proxy_action,
            detect_public_proxy_redirecturl=detect_public_proxy_redirecturl,
            detect_residential_proxy=detect_residential_proxy,
            detect_residential_proxy_action=detect_residential_proxy_action,
            detect_residential_proxy_redirecturl=detect_residential_proxy_redirecturl,
            detect_smart_dns_proxy=detect_smart_dns_proxy,
            detect_smart_dns_proxy_action=detect_smart_dns_proxy_action,
            detect_smart_dns_proxy_redirecturl=detect_smart_dns_proxy_redirecturl,
            detect_tor_exit_node=detect_tor_exit_node,
            detect_tor_exit_node_action=detect_tor_exit_node_action,
            detect_tor_exit_node_redirecturl=detect_tor_exit_node_redirecturl,
            detect_vpn_data_center=detect_vpn_data_center,
            detect_vpn_data_center_action=detect_vpn_data_center_action,
            detect_vpn_data_center_redirecturl=detect_vpn_data_center_redirecturl,
            enable_configuration_mode=enable_configuration_mode,
            enabled=enabled,
            forward_header_enrichment=forward_header_enrichment,
            hosting_provider=hosting_provider,
            locked=locked,
            public_proxy=public_proxy,
            residential_proxy=residential_proxy,
            smart_dns_proxy=smart_dns_proxy,
            template_uuid=template_uuid,
            tor_exit_node=tor_exit_node,
            uuid=uuid,
            vpn_data_center=vpn_data_center,
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedProxyDetection", [value]))

    @jsii.member(jsii_name="putEpdForwardHeaderEnrichment")
    def put_epd_forward_header_enrichment(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEpdForwardHeaderEnrichment", [value]))

    @jsii.member(jsii_name="putFailAction")
    def put_fail_action(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction(
            action_type=action_type,
            allow_fcm_parent_override=allow_fcm_parent_override,
            cex_custom_path=cex_custom_path,
            cex_hostname=cex_hostname,
            cex_path=cex_path,
            content_custom_path=content_custom_path,
            content_hostname=content_hostname,
            content_path=content_path,
            cp_code=cp_code,
            dynamic_custom_path=dynamic_custom_path,
            dynamic_method=dynamic_method,
            dynamic_path=dynamic_path,
            enabled=enabled,
            locked=locked,
            modify_protocol=modify_protocol,
            net_storage_hostname=net_storage_hostname,
            net_storage_path=net_storage_path,
            preserve_query_string=preserve_query_string,
            protocol=protocol,
            redirect_custom_path=redirect_custom_path,
            redirect_hostname=redirect_hostname,
            redirect_hostname_type=redirect_hostname_type,
            redirect_method=redirect_method,
            redirect_path=redirect_path,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailAction", [value]))

    @jsii.member(jsii_name="putFailoverBotManagerFeatureCompatibility")
    def put_failover_bot_manager_feature_compatibility(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility(
            compatibility=compatibility,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailoverBotManagerFeatureCompatibility", [value]))

    @jsii.member(jsii_name="putFastInvalidate")
    def put_fast_invalidate(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFastInvalidate", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketing")
    def put_first_party_marketing(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketing", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketingPlus")
    def put_first_party_marketing_plus(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketingPlus", [value]))

    @jsii.member(jsii_name="putForwardRewrite")
    def put_forward_rewrite(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putForwardRewrite", [value]))

    @jsii.member(jsii_name="putG2Oheader")
    def put_g2_oheader(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader(
            custom_sign_string=custom_sign_string,
            data_header=data_header,
            enabled=enabled,
            encoding_version=encoding_version,
            locked=locked,
            nonce=nonce,
            secret_key=secret_key,
            signed_header=signed_header,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putG2Oheader", [value]))

    @jsii.member(jsii_name="putGlobalRequestNumber")
    def put_global_request_number(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber(
            header_name=header_name,
            locked=locked,
            output_option=output_option,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putGlobalRequestNumber", [value]))

    @jsii.member(jsii_name="putGraphqlCaching")
    def put_graphql_caching(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching(
            advanced=advanced,
            cache_responses_with_errors=cache_responses_with_errors,
            enabled=enabled,
            locked=locked,
            operations_json_body_parameter_name=operations_json_body_parameter_name,
            operations_url_query_parameter_name=operations_url_query_parameter_name,
            post_request_processing_error_handling=post_request_processing_error_handling,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putGraphqlCaching", [value]))

    @jsii.member(jsii_name="putGzipResponse")
    def put_gzip_response(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putGzipResponse", [value]))

    @jsii.member(jsii_name="putHdDataAdvanced")
    def put_hd_data_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putHdDataAdvanced", [value]))

    @jsii.member(jsii_name="putHealthDetection")
    def put_health_detection(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection(
            locked=locked,
            maximum_reconnects=maximum_reconnects,
            retry_count=retry_count,
            retry_interval=retry_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHealthDetection", [value]))

    @jsii.member(jsii_name="putHsafEipBinding")
    def put_hsaf_eip_binding(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding(
            custom_extracted_serial=custom_extracted_serial,
            enabled=enabled,
            hash_max_value=hash_max_value,
            hash_min_value=hash_min_value,
            locked=locked,
            template_uuid=template_uuid,
            tier=tier,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHsafEipBinding", [value]))

    @jsii.member(jsii_name="putHttp2")
    def put_http2(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp2", [value]))

    @jsii.member(jsii_name="putHttp3")
    def put_http3(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp3", [value]))

    @jsii.member(jsii_name="putHttpStrictTransportSecurity")
    def put_http_strict_transport_security(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity(
            enable=enable,
            include_sub_domains=include_sub_domains,
            locked=locked,
            max_age=max_age,
            preload=preload,
            redirect=redirect,
            redirect_status_code=redirect_status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHttpStrictTransportSecurity", [value]))

    @jsii.member(jsii_name="putHttpToHttpsUpgrade")
    def put_http_to_https_upgrade(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade(
            locked=locked, template_uuid=template_uuid, upgrade=upgrade, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttpToHttpsUpgrade", [value]))

    @jsii.member(jsii_name="putImageAndVideoManager")
    def put_image_and_video_manager(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager(
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            image_set=image_set,
            locked=locked,
            policy_set_type=policy_set_type,
            resize=resize,
            template_uuid=template_uuid,
            uuid=uuid,
            video_set=video_set,
        )

        return typing.cast(None, jsii.invoke(self, "putImageAndVideoManager", [value]))

    @jsii.member(jsii_name="putImageManager")
    def put_image_manager(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManager", [value]))

    @jsii.member(jsii_name="putImageManagerVideo")
    def put_image_manager_video(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManagerVideo", [value]))

    @jsii.member(jsii_name="putImOverride")
    def put_im_override(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride(
            dpr=dpr,
            dprvar=dprvar,
            exclude_all_query_parameters=exclude_all_query_parameters,
            excluded_query_parameters=excluded_query_parameters,
            format=format,
            formatvar=formatvar,
            locked=locked,
            override=override,
            policy=policy,
            policyvar=policyvar,
            policyvar_i_mvar=policyvar_i_mvar,
            policyvar_name=policyvar_name,
            template_uuid=template_uuid,
            typesel=typesel,
            uuid=uuid,
            width=width,
            widthvar=widthvar,
        )

        return typing.cast(None, jsii.invoke(self, "putImOverride", [value]))

    @jsii.member(jsii_name="putInclude")
    def put_include(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude(
            id=id, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInclude", [value]))

    @jsii.member(jsii_name="putInstant")
    def put_instant(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant(
            custom_link_relations=custom_link_relations,
            locked=locked,
            prefetch_cacheable=prefetch_cacheable,
            prefetch_html=prefetch_html,
            prefetch_no_store=prefetch_no_store,
            prefetch_no_store_extensions=prefetch_no_store_extensions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putInstant", [value]))

    @jsii.member(jsii_name="putInstantConfig")
    def put_instant_config(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInstantConfig", [value]))

    @jsii.member(jsii_name="putLargeFileOptimization")
    def put_large_file_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization(
            enabled=enabled,
            enable_partial_object_caching=enable_partial_object_caching,
            locked=locked,
            maximum_size=maximum_size,
            minimum_size=minimum_size,
            template_uuid=template_uuid,
            use_versioning=use_versioning,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimization", [value]))

    @jsii.member(jsii_name="putLargeFileOptimizationAdvanced")
    def put_large_file_optimization_advanced(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced(
            enabled=enabled,
            fragment_size=fragment_size,
            locked=locked,
            object_size=object_size,
            prefetch_after_request=prefetch_after_request,
            prefetch_during_request=prefetch_during_request,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimizationAdvanced", [value]))

    @jsii.member(jsii_name="putLimitBitRate")
    def put_limit_bit_rate(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate(
            bitrate_table=bitrate_table,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            threshold_table=threshold_table,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLimitBitRate", [value]))

    @jsii.member(jsii_name="putLogCustom")
    def put_log_custom(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom(
            custom_log_field=custom_log_field,
            locked=locked,
            log_custom_log_field=log_custom_log_field,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLogCustom", [value]))

    @jsii.member(jsii_name="putManifestPersonalization")
    def put_manifest_personalization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization(
            enabled=enabled,
            hls_enabled=hls_enabled,
            hls_enable_debug_headers=hls_enable_debug_headers,
            hls_filter_in_bitrate_ranges=hls_filter_in_bitrate_ranges,
            hls_filter_in_bitrates=hls_filter_in_bitrates,
            hls_mode=hls_mode,
            hls_preferred_bitrate=hls_preferred_bitrate,
            hls_query_param_enabled=hls_query_param_enabled,
            hls_query_param_secret_key=hls_query_param_secret_key,
            hls_query_param_transition_key=hls_query_param_transition_key,
            hls_show_advanced=hls_show_advanced,
            hls_title=hls_title,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestPersonalization", [value]))

    @jsii.member(jsii_name="putManifestRerouting")
    def put_manifest_rerouting(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting(
            locked=locked,
            partner=partner,
            template_uuid=template_uuid,
            username=username,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestRerouting", [value]))

    @jsii.member(jsii_name="putManualServerPush")
    def put_manual_server_push(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush(
            locked=locked,
            serverpushlist=serverpushlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManualServerPush", [value]))

    @jsii.member(jsii_name="putMediaAcceleration")
    def put_media_acceleration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAcceleration", [value]))

    @jsii.member(jsii_name="putMediaAccelerationQuicOptout")
    def put_media_acceleration_quic_optout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout(
            locked=locked, optout=optout, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAccelerationQuicOptout", [value]))

    @jsii.member(jsii_name="putMediaClient")
    def put_media_client(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient(
            beacon_id=beacon_id,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_hybrid_http_udp=use_hybrid_http_udp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaClient", [value]))

    @jsii.member(jsii_name="putMediaFileRetrievalOptimization")
    def put_media_file_retrieval_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaFileRetrievalOptimization", [value]))

    @jsii.member(jsii_name="putMediaOriginFailover")
    def put_media_origin_failover(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover(
            cache_error_response=cache_error_response,
            cache_window=cache_window,
            client_response_code=client_response_code,
            detect_object_unavailable=detect_object_unavailable,
            detect_object_unavailable_title=detect_object_unavailable_title,
            detect_origin_unavailable=detect_origin_unavailable,
            detect_origin_unavailable_title=detect_origin_unavailable_title,
            detect_origin_unresponsive=detect_origin_unresponsive,
            detect_origin_unresponsive_title=detect_origin_unresponsive_title,
            locked=locked,
            object_unavailable_alternate_host=object_unavailable_alternate_host,
            object_unavailable_backup_host=object_unavailable_backup_host,
            object_unavailable_blacklist_origin_ip=object_unavailable_blacklist_origin_ip,
            object_unavailable_blacklist_window=object_unavailable_blacklist_window,
            object_unavailable_change_protocol=object_unavailable_change_protocol,
            object_unavailable_detection_level=object_unavailable_detection_level,
            object_unavailable_include_query_string=object_unavailable_include_query_string,
            object_unavailable_modified_path=object_unavailable_modified_path,
            object_unavailable_modify_request_path=object_unavailable_modify_request_path,
            object_unavailable_protocol=object_unavailable_protocol,
            object_unavailable_recovery=object_unavailable_recovery,
            object_unavailable_redirect_method=object_unavailable_redirect_method,
            object_unavailable_response_codes=object_unavailable_response_codes,
            object_unavailable_retry_limit=object_unavailable_retry_limit,
            origin_unavailable_alternate_host=origin_unavailable_alternate_host,
            origin_unavailable_backup_host=origin_unavailable_backup_host,
            origin_unavailable_blacklist_origin_ip=origin_unavailable_blacklist_origin_ip,
            origin_unavailable_blacklist_window=origin_unavailable_blacklist_window,
            origin_unavailable_change_protocol=origin_unavailable_change_protocol,
            origin_unavailable_detection_level=origin_unavailable_detection_level,
            origin_unavailable_include_query_string=origin_unavailable_include_query_string,
            origin_unavailable_modified_path=origin_unavailable_modified_path,
            origin_unavailable_modify_request_path=origin_unavailable_modify_request_path,
            origin_unavailable_protocol=origin_unavailable_protocol,
            origin_unavailable_recovery=origin_unavailable_recovery,
            origin_unavailable_redirect_method=origin_unavailable_redirect_method,
            origin_unavailable_response_codes=origin_unavailable_response_codes,
            origin_unavailable_retry_limit=origin_unavailable_retry_limit,
            origin_unresponsive_alternate_host=origin_unresponsive_alternate_host,
            origin_unresponsive_backup_host=origin_unresponsive_backup_host,
            origin_unresponsive_blacklist_origin_ip=origin_unresponsive_blacklist_origin_ip,
            origin_unresponsive_blacklist_window=origin_unresponsive_blacklist_window,
            origin_unresponsive_change_protocol=origin_unresponsive_change_protocol,
            origin_unresponsive_detection_level=origin_unresponsive_detection_level,
            origin_unresponsive_include_query_string=origin_unresponsive_include_query_string,
            origin_unresponsive_modified_path=origin_unresponsive_modified_path,
            origin_unresponsive_modify_request_path=origin_unresponsive_modify_request_path,
            origin_unresponsive_protocol=origin_unresponsive_protocol,
            origin_unresponsive_recovery=origin_unresponsive_recovery,
            origin_unresponsive_redirect_method=origin_unresponsive_redirect_method,
            origin_unresponsive_retry_limit=origin_unresponsive_retry_limit,
            other_options=other_options,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaOriginFailover", [value]))

    @jsii.member(jsii_name="putMetadataCaching")
    def put_metadata_caching(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataCaching", [value]))

    @jsii.member(jsii_name="putMobileSdkPerformance")
    def put_mobile_sdk_performance(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance(
            enabled=enabled,
            locked=locked,
            secondary_multipath_to_origin=secondary_multipath_to_origin,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMobileSdkPerformance", [value]))

    @jsii.member(jsii_name="putModifyIncomingRequestHeader")
    def put_modify_incoming_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyIncomingResponseHeader")
    def put_modify_incoming_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingRequestHeader")
    def put_modify_outgoing_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingResponseHeader")
    def put_modify_outgoing_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyViaHeader")
    def put_modify_via_header(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader(
            enabled=enabled,
            locked=locked,
            modification_option=modification_option,
            rename_header_to=rename_header_to,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyViaHeader", [value]))

    @jsii.member(jsii_name="putMPulse")
    def put_m_pulse(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse(
            api_key=api_key,
            buffer_size=buffer_size,
            config_override=config_override,
            enabled=enabled,
            loader_version=loader_version,
            locked=locked,
            require_pci=require_pci,
            template_uuid=template_uuid,
            title_optional=title_optional,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMPulse", [value]))

    @jsii.member(jsii_name="putOrigin")
    def put_origin(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin(
            cache_key_hostname=cache_key_hostname,
            compress=compress,
            custom_certificate_authorities=custom_certificate_authorities,
            custom_certificates=custom_certificates,
            custom_forward_host_header=custom_forward_host_header,
            custom_valid_cn_values=custom_valid_cn_values,
            enable_true_client_ip=enable_true_client_ip,
            forward_host_header=forward_host_header,
            hostname=hostname,
            http_port=http_port,
            https_port=https_port,
            ip_version=ip_version,
            locked=locked,
            mslorigin=mslorigin,
            net_storage=net_storage,
            origin_certificate=origin_certificate,
            origin_certs_to_honor=origin_certs_to_honor,
            origin_id=origin_id,
            origin_sni=origin_sni,
            origin_type=origin_type,
            ports=ports,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            second_hostname=second_hostname,
            second_hostname_enabled=second_hostname_enabled,
            standard_certificate_authorities=standard_certificate_authorities,
            template_uuid=template_uuid,
            true_client_ip_client_setting=true_client_ip_client_setting,
            true_client_ip_header=true_client_ip_header,
            use_unique_cache_key=use_unique_cache_key,
            uuid=uuid,
            verification_mode=verification_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putOrigin", [value]))

    @jsii.member(jsii_name="putOriginCharacteristics")
    def put_origin_characteristics(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics(
            access_key_encrypted_storage=access_key_encrypted_storage,
            adc_title=adc_title,
            authentication_method=authentication_method,
            authentication_method_title=authentication_method_title,
            aws_access_key_id=aws_access_key_id,
            aws_access_key_version_guid=aws_access_key_version_guid,
            aws_ar_region=aws_ar_region,
            aws_host=aws_host,
            aws_region=aws_region,
            aws_secret_access_key=aws_secret_access_key,
            aws_service=aws_service,
            country=country,
            custom_sign_string=custom_sign_string,
            direct_connect_geo=direct_connect_geo,
            encoding_version=encoding_version,
            end_point_service=end_point_service,
            gcs_access_key_version_guid=gcs_access_key_version_guid,
            gcs_hmac_key_access_id=gcs_hmac_key_access_id,
            gcs_hmac_key_secret=gcs_hmac_key_secret,
            hostname_tag=hostname_tag,
            locked=locked,
            mslkey=mslkey,
            mslname=mslname,
            nonce=nonce,
            origin_location_title=origin_location_title,
            property_id_tag=property_id_tag,
            role_arn=role_arn,
            secret_key=secret_key,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristics", [value]))

    @jsii.member(jsii_name="putOriginCharacteristicsWsd")
    def put_origin_characteristics_wsd(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd(
            locked=locked,
            origintype=origintype,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristicsWsd", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryMethod")
    def put_origin_failure_recovery_method(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod(
            custom_status_code=custom_status_code,
            locked=locked,
            recovery_method=recovery_method,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryMethod", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryPolicy")
    def put_origin_failure_recovery_policy(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy(
            binary_equivalent_content=binary_equivalent_content,
            enabled=enabled,
            enable_ip_avoidance=enable_ip_avoidance,
            ip_avoidance_error_threshold=ip_avoidance_error_threshold,
            ip_avoidance_retry_interval=ip_avoidance_retry_interval,
            locked=locked,
            monitor_origin_responsiveness=monitor_origin_responsiveness,
            monitor_response_codes1=monitor_response_codes1,
            monitor_response_codes2=monitor_response_codes2,
            monitor_response_codes3=monitor_response_codes3,
            monitor_status_codes1=monitor_status_codes1,
            monitor_status_codes1_enable_recovery=monitor_status_codes1_enable_recovery,
            monitor_status_codes1_enable_retry=monitor_status_codes1_enable_retry,
            monitor_status_codes1_recovery_config_name=monitor_status_codes1_recovery_config_name,
            monitor_status_codes2=monitor_status_codes2,
            monitor_status_codes2_enable_recovery=monitor_status_codes2_enable_recovery,
            monitor_status_codes2_enable_retry=monitor_status_codes2_enable_retry,
            monitor_status_codes2_recovery_config_name=monitor_status_codes2_recovery_config_name,
            monitor_status_codes3=monitor_status_codes3,
            monitor_status_codes3_enable_recovery=monitor_status_codes3_enable_recovery,
            monitor_status_codes3_enable_retry=monitor_status_codes3_enable_retry,
            monitor_status_codes3_recovery_config_name=monitor_status_codes3_recovery_config_name,
            origin_responsiveness_custom_timeout=origin_responsiveness_custom_timeout,
            origin_responsiveness_enable_recovery=origin_responsiveness_enable_recovery,
            origin_responsiveness_enable_retry=origin_responsiveness_enable_retry,
            origin_responsiveness_monitoring=origin_responsiveness_monitoring,
            origin_responsiveness_recovery_config_name=origin_responsiveness_recovery_config_name,
            origin_responsiveness_timeout=origin_responsiveness_timeout,
            status_code_monitoring1=status_code_monitoring1,
            status_code_monitoring2=status_code_monitoring2,
            status_code_monitoring3=status_code_monitoring3,
            template_uuid=template_uuid,
            tuning_parameters=tuning_parameters,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryPolicy", [value]))

    @jsii.member(jsii_name="putOriginIpAcl")
    def put_origin_ip_acl(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putOriginIpAcl", [value]))

    @jsii.member(jsii_name="putPersistentClientConnection")
    def put_persistent_client_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentClientConnection", [value]))

    @jsii.member(jsii_name="putPersistentConnection")
    def put_persistent_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentConnection", [value]))

    @jsii.member(jsii_name="putPersonallyIdentifiableInformation")
    def put_personally_identifiable_information(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPersonallyIdentifiableInformation", [value]))

    @jsii.member(jsii_name="putPhasedRelease")
    def put_phased_release(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            failover_duration=failover_duration,
            failover_enabled=failover_enabled,
            failover_response_code=failover_response_code,
            failover_title=failover_title,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_expiration_date=population_expiration_date,
            population_refresh=population_refresh,
            population_title=population_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPhasedRelease", [value]))

    @jsii.member(jsii_name="putPreconnect")
    def put_preconnect(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect(
            locked=locked,
            preconnectlist=preconnectlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPreconnect", [value]))

    @jsii.member(jsii_name="putPredictiveContentDelivery")
    def put_predictive_content_delivery(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPredictiveContentDelivery", [value]))

    @jsii.member(jsii_name="putPredictivePrefetching")
    def put_predictive_prefetching(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching(
            accuracy_target=accuracy_target,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPredictivePrefetching", [value]))

    @jsii.member(jsii_name="putPrefetch")
    def put_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetch", [value]))

    @jsii.member(jsii_name="putPrefetchable")
    def put_prefetchable(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetchable", [value]))

    @jsii.member(jsii_name="putPrefreshCache")
    def put_prefresh_cache(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache(
            enabled=enabled,
            locked=locked,
            prefreshval=prefreshval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPrefreshCache", [value]))

    @jsii.member(jsii_name="putQuality")
    def put_quality(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality(
            audience_settings=audience_settings,
            catalog_size=catalog_size,
            content_settings=content_settings,
            content_type=content_type,
            country=country,
            delivery_format=delivery_format,
            delivery_type=delivery_type,
            download_type=download_type,
            end_user_location=end_user_location,
            locked=locked,
            maximum_concurrent_users=maximum_concurrent_users,
            object_size=object_size,
            optimize_for=optimize_for,
            origin_settings=origin_settings,
            popularity_distribution=popularity_distribution,
            refresh_rate=refresh_rate,
            segment_duration=segment_duration,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuality", [value]))

    @jsii.member(jsii_name="putQuicBeta")
    def put_quic_beta(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta(
            enabled=enabled,
            locked=locked,
            quic_offer_percentage=quic_offer_percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuicBeta", [value]))

    @jsii.member(jsii_name="putRandomSeek")
    def put_random_seek(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek(
            flv=flv,
            locked=locked,
            maximum_size=maximum_size,
            mp4=mp4,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRandomSeek", [value]))

    @jsii.member(jsii_name="putRapid")
    def put_rapid(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRapid", [value]))

    @jsii.member(jsii_name="putReadTimeout")
    def put_read_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putReadTimeout", [value_]))

    @jsii.member(jsii_name="putRealTimeReporting")
    def put_real_time_reporting(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting(
            advanced=advanced,
            beacon_sampling_percentage=beacon_sampling_percentage,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRealTimeReporting", [value]))

    @jsii.member(jsii_name="putRealUserMonitoring")
    def put_real_user_monitoring(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRealUserMonitoring", [value]))

    @jsii.member(jsii_name="putRedirect")
    def put_redirect(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect(
            destination_hostname=destination_hostname,
            destination_hostname_other=destination_hostname_other,
            destination_hostname_sibling=destination_hostname_sibling,
            destination_hostname_subdomain=destination_hostname_subdomain,
            destination_path=destination_path,
            destination_path_other=destination_path_other,
            destination_path_prefix=destination_path_prefix,
            destination_path_suffix=destination_path_suffix,
            destination_path_suffix_status=destination_path_suffix_status,
            destination_protocol=destination_protocol,
            locked=locked,
            mobile_default_choice=mobile_default_choice,
            query_string=query_string,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirect", [value]))

    @jsii.member(jsii_name="putRedirectplus")
    def put_redirectplus(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus(
            destination=destination,
            enabled=enabled,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirectplus", [value]))

    @jsii.member(jsii_name="putRefererChecking")
    def put_referer_checking(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking(
            allow_children=allow_children,
            domains=domains,
            enabled=enabled,
            locked=locked,
            strict=strict,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRefererChecking", [value]))

    @jsii.member(jsii_name="putRemoveQueryParameter")
    def put_remove_query_parameter(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter(
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveQueryParameter", [value]))

    @jsii.member(jsii_name="putRemoveVary")
    def put_remove_vary(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveVary", [value]))

    @jsii.member(jsii_name="putReport")
    def put_report(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport(
            cookies=cookies,
            custom_log_field=custom_log_field,
            locked=locked,
            log_accept_language=log_accept_language,
            log_cookies=log_cookies,
            log_custom_log_field=log_custom_log_field,
            log_edge_ip=log_edge_ip,
            log_host=log_host,
            log_referer=log_referer,
            log_user_agent=log_user_agent,
            log_x_forwarded_for=log_x_forwarded_for,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReport", [value]))

    @jsii.member(jsii_name="putRequestControl")
    def put_request_control(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl(
            branded403_file=branded403_file,
            branded403_status_code=branded403_status_code,
            branded403_url=branded403_url,
            branded_deny_cache_ttl=branded_deny_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enable_branded403=enable_branded403,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            net_storage=net_storage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestControl", [value]))

    @jsii.member(jsii_name="putRequestTypeMarker")
    def put_request_type_marker(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker(
            locked=locked,
            request_type=request_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestTypeMarker", [value]))

    @jsii.member(jsii_name="putResourceOptimizer")
    def put_resource_optimizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizer", [value]))

    @jsii.member(jsii_name="putResourceOptimizerExtendedCompatibility")
    def put_resource_optimizer_extended_compatibility(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility(
            enable_all_features=enable_all_features,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizerExtendedCompatibility", [value]))

    @jsii.member(jsii_name="putResponseCode")
    def put_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode(
            locked=locked,
            override206=override206,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCode", [value]))

    @jsii.member(jsii_name="putResponseCookie")
    def put_response_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie(
            cookie_name=cookie_name,
            default_domain=default_domain,
            default_path=default_path,
            domain=domain,
            duration=duration,
            enabled=enabled,
            expiration_date=expiration_date,
            expires=expires,
            format=format,
            http_only=http_only,
            locked=locked,
            path=path,
            same_site=same_site,
            secure=secure,
            template_uuid=template_uuid,
            type=type,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCookie", [value_]))

    @jsii.member(jsii_name="putRestrictObjectCaching")
    def put_restrict_object_caching(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching(
            locked=locked,
            maximum_size=maximum_size,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRestrictObjectCaching", [value]))

    @jsii.member(jsii_name="putReturnCacheStatus")
    def put_return_cache_status(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus(
            locked=locked,
            response_header_name=response_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReturnCacheStatus", [value]))

    @jsii.member(jsii_name="putRewriteUrl")
    def put_rewrite_url(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl(
            behavior=behavior,
            keep_query_string=keep_query_string,
            locked=locked,
            match=match,
            match_multiple=match_multiple,
            match_regex=match_regex,
            target_path=target_path,
            target_path_prepend=target_path_prepend,
            target_regex=target_regex,
            target_url=target_url,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRewriteUrl", [value]))

    @jsii.member(jsii_name="putRumCustom")
    def put_rum_custom(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom(
            locked=locked,
            rum_group_name=rum_group_name,
            rum_sample_rate=rum_sample_rate,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRumCustom", [value]))

    @jsii.member(jsii_name="putSaasDefinitions")
    def put_saas_definitions(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions(
            application_action=application_action,
            application_cname_enabled=application_cname_enabled,
            application_cname_level=application_cname_level,
            application_cookie=application_cookie,
            application_query_string=application_query_string,
            application_regex=application_regex,
            application_replace=application_replace,
            application_title=application_title,
            customer_action=customer_action,
            customer_cname_enabled=customer_cname_enabled,
            customer_cname_level=customer_cname_level,
            customer_cookie=customer_cookie,
            customer_query_string=customer_query_string,
            customer_regex=customer_regex,
            customer_replace=customer_replace,
            customer_title=customer_title,
            locked=locked,
            template_uuid=template_uuid,
            users_action=users_action,
            users_cname_enabled=users_cname_enabled,
            users_cname_level=users_cname_level,
            users_cookie=users_cookie,
            users_query_string=users_query_string,
            users_regex=users_regex,
            users_replace=users_replace,
            users_title=users_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSaasDefinitions", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudClient")
    def put_sales_force_commerce_cloud_client(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient(
            allow_override_origin_cache_key=allow_override_origin_cache_key,
            connector_id=connector_id,
            enabled=enabled,
            locked=locked,
            origin_host_header=origin_host_header,
            origin_type=origin_type,
            sf3_c_origin_host=sf3_c_origin_host,
            sf3_c_origin_host_header=sf3_c_origin_host_header,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudClient", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProvider")
    def put_sales_force_commerce_cloud_provider(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProvider", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProviderHostHeader")
    def put_sales_force_commerce_cloud_provider_host_header(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader(
            host_header_source=host_header_source,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProviderHostHeader", [value]))

    @jsii.member(jsii_name="putSavePostDcaProcessing")
    def put_save_post_dca_processing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSavePostDcaProcessing", [value]))

    @jsii.member(jsii_name="putScheduleInvalidation")
    def put_schedule_invalidation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation(
            locked=locked,
            refresh_method=refresh_method,
            repeat=repeat,
            repeat_interval=repeat_interval,
            start=start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScheduleInvalidation", [value]))

    @jsii.member(jsii_name="putScriptManagement")
    def put_script_management(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement(
            enabled=enabled,
            locked=locked,
            serviceworker=serviceworker,
            template_uuid=template_uuid,
            timestamp=timestamp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScriptManagement", [value]))

    @jsii.member(jsii_name="putSegmentedContentProtection")
    def put_segmented_content_protection(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection(
            acl=acl,
            dash_media_encryption=dash_media_encryption,
            data_payload=data_payload,
            enabled=enabled,
            enable_token_in_uri=enable_token_in_uri,
            field_carry_over=field_carry_over,
            header_for_salt=header_for_salt,
            hls_master_manifest_files=hls_master_manifest_files,
            hls_media_encryption=hls_media_encryption,
            ip=ip,
            key=key,
            locked=locked,
            media_encryption_title=media_encryption_title,
            revoked_list_id=revoked_list_id,
            salt=salt,
            session_id=session_id,
            template_uuid=template_uuid,
            token_authentication_title=token_authentication_title,
            token_auth_hls_title=token_auth_hls_title,
            token_revocation_enabled=token_revocation_enabled,
            token_revocation_title=token_revocation_title,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedContentProtection", [value]))

    @jsii.member(jsii_name="putSegmentedMediaOptimization")
    def put_segmented_media_optimization(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization(
            behavior=behavior,
            dvr_type=dvr_type,
            dvr_window=dvr_window,
            enable_ull_streaming=enable_ull_streaming,
            end_time=end_time,
            live_type=live_type,
            locked=locked,
            show_advanced=show_advanced,
            start_time=start_time,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaOptimization", [value]))

    @jsii.member(jsii_name="putSegmentedMediaStreamingPrefetch")
    def put_segmented_media_streaming_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaStreamingPrefetch", [value]))

    @jsii.member(jsii_name="putSetVariable")
    def put_set_variable(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[builtins.str] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[builtins.str] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[builtins.str] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable(
            algorithm=algorithm,
            case_sensitive=case_sensitive,
            certificate_field_name=certificate_field_name,
            cookie_name=cookie_name,
            device_profile=device_profile,
            encryption_key=encryption_key,
            encryption_mode=encryption_mode,
            end_index=end_index,
            except_chars=except_chars,
            extract_location=extract_location,
            force_chars=force_chars,
            format_string=format_string,
            generator=generator,
            global_substitution=global_substitution,
            header_name=header_name,
            hmac_algorithm=hmac_algorithm,
            hmac_key=hmac_key,
            initialization_vector=initialization_vector,
            ipv4_prefix=ipv4_prefix,
            ipv6_prefix=ipv6_prefix,
            ip_version=ip_version,
            location_id=location_id,
            locked=locked,
            max=max,
            max_random_number=max_random_number,
            min=min,
            min_random_number=min_random_number,
            nonce=nonce,
            number_of_bytes=number_of_bytes,
            operand_one=operand_one,
            param_name=param_name,
            path_component_offset=path_component_offset,
            prepend_bytes=prepend_bytes,
            query_parameter_name=query_parameter_name,
            regex=regex,
            replacement=replacement,
            response_header_name=response_header_name,
            separator=separator,
            set_cookie_name=set_cookie_name,
            start_index=start_index,
            sub_string=sub_string,
            template_uuid=template_uuid,
            transform=transform,
            uuid=uuid,
            value_source=value_source,
            variable_name=variable_name,
            variable_value=variable_value,
        )

        return typing.cast(None, jsii.invoke(self, "putSetVariable", [value]))

    @jsii.member(jsii_name="putSimulateErrorCode")
    def put_simulate_error_code(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode(
            error_type=error_type,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSimulateErrorCode", [value]))

    @jsii.member(jsii_name="putSiteShield")
    def put_site_shield(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield(
            locked=locked,
            nossmap=nossmap,
            ssmap=ssmap,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSiteShield", [value]))

    @jsii.member(jsii_name="putStandardTlsMigration")
    def put_standard_tls_migration(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration(
            allow_https_downgrade=allow_https_downgrade,
            allow_https_upgrade=allow_https_upgrade,
            cache_sharing_duration=cache_sharing_duration,
            cache_sharing_start_time=cache_sharing_start_time,
            enabled=enabled,
            is_certificate_sni_only=is_certificate_sni_only,
            is_tiered_distribution_used=is_tiered_distribution_used,
            locked=locked,
            migration_duration=migration_duration,
            migration_from=migration_from,
            migration_start_time=migration_start_time,
            td_location=td_location,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigration", [value]))

    @jsii.member(jsii_name="putStandardTlsMigrationOverride")
    def put_standard_tls_migration_override(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride(
            info=info, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigrationOverride", [value]))

    @jsii.member(jsii_name="putStrictHeaderParsing")
    def put_strict_header_parsing(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing(
            locked=locked,
            strict_mode=strict_mode,
            template_uuid=template_uuid,
            uuid=uuid,
            valid_mode=valid_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putStrictHeaderParsing", [value]))

    @jsii.member(jsii_name="putSubCustomer")
    def put_sub_customer(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer(
            access_control=access_control,
            cache_key=cache_key,
            caching=caching,
            content_compressor=content_compressor,
            dynamic_web_content=dynamic_web_content,
            enabled=enabled,
            geo_location=geo_location,
            ip=ip,
            large_file_delivery=large_file_delivery,
            live_video_delivery=live_video_delivery,
            locked=locked,
            modify_path=modify_path,
            on_demand_video_delivery=on_demand_video_delivery,
            origin=origin,
            partner_domain_suffix=partner_domain_suffix,
            referrer=referrer,
            refresh_content=refresh_content,
            site_failover=site_failover,
            template_uuid=template_uuid,
            token_authorization=token_authorization,
            uuid=uuid,
            web_application_firewall=web_application_firewall,
        )

        return typing.cast(None, jsii.invoke(self, "putSubCustomer", [value]))

    @jsii.member(jsii_name="putSureRoute")
    def put_sure_route(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute(
            allow_fcm_parent_override=allow_fcm_parent_override,
            custom_map=custom_map,
            custom_stat_key=custom_stat_key,
            enable_custom_key=enable_custom_key,
            enabled=enabled,
            force_ssl_forward=force_ssl_forward,
            locked=locked,
            race_stat_ttl=race_stat_ttl,
            sr_download_link_title=sr_download_link_title,
            template_uuid=template_uuid,
            test_object_url=test_object_url,
            to_host=to_host,
            to_host_status=to_host_status,
            type=type,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSureRoute", [value]))

    @jsii.member(jsii_name="putTcpOptimization")
    def put_tcp_optimization(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putTcpOptimization", [value]))

    @jsii.member(jsii_name="putTeaLeaf")
    def put_tea_leaf(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf(
            enabled=enabled,
            ibm_customer_id=ibm_customer_id,
            limit_to_dynamic=limit_to_dynamic,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTeaLeaf", [value]))

    @jsii.member(jsii_name="putTieredDistribution")
    def put_tiered_distribution(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistribution", [value]))

    @jsii.member(jsii_name="putTieredDistributionAdvanced")
    def put_tiered_distribution_advanced(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced(
            allowall=allowall,
            enabled=enabled,
            locked=locked,
            method=method,
            policy=policy,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionAdvanced", [value]))

    @jsii.member(jsii_name="putTieredDistributionCustomization")
    def put_tiered_distribution_customization(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization(
            cloudwrapper_map_migration_title=cloudwrapper_map_migration_title,
            custom_map_enabled=custom_map_enabled,
            custom_map_name=custom_map_name,
            hash_algorithm=hash_algorithm,
            location=location,
            locked=locked,
            map_migration_enabled=map_migration_enabled,
            migration_end_date=migration_end_date,
            migration_start_date=migration_start_date,
            migration_within_cw_maps_enabled=migration_within_cw_maps_enabled,
            serial_end=serial_end,
            serial_start=serial_start,
            template_uuid=template_uuid,
            tier1_title=tier1_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionCustomization", [value]))

    @jsii.member(jsii_name="putTimeout")
    def put_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putTimeout", [value_]))

    @jsii.member(jsii_name="putUidConfiguration")
    def put_uid_configuration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration(
            enabled=enabled,
            extract_location=extract_location,
            header_name=header_name,
            legal_text=legal_text,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putUidConfiguration", [value]))

    @jsii.member(jsii_name="putValidateEntityTag")
    def put_validate_entity_tag(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putValidateEntityTag", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebToken")
    def put_verify_json_web_token(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken(
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_location=extract_location,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebToken", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebTokenForDcp")
    def put_verify_json_web_token_for_dcp(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp(
            authorizations=authorizations,
            client_id=client_id,
            custom_header=custom_header,
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_authorizations=extract_authorizations,
            extract_client_id=extract_client_id,
            extract_location=extract_location,
            extract_user_name=extract_user_name,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            primary_location=primary_location,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            user_name=user_name,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebTokenForDcp", [value]))

    @jsii.member(jsii_name="putVerifyTokenAuthorization")
    def put_verify_token_authorization(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization(
            algorithm=algorithm,
            escape_hmac_inputs=escape_hmac_inputs,
            failure_response=failure_response,
            ignore_query_string=ignore_query_string,
            key=key,
            location=location,
            location_id=location_id,
            locked=locked,
            salt=salt,
            template_uuid=template_uuid,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyTokenAuthorization", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoom")
    def put_virtual_waiting_room(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoom", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomWithEdgeWorkers")
    def put_virtual_waiting_room_with_edge_workers(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomWithEdgeWorkers", [value]))

    @jsii.member(jsii_name="putVisitorPrioritization")
    def put_visitor_prioritization(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization(
            allowed_user_cookie_advanced=allowed_user_cookie_advanced,
            allowed_user_cookie_automatic_salt=allowed_user_cookie_automatic_salt,
            allowed_user_cookie_domain=allowed_user_cookie_domain,
            allowed_user_cookie_domain_type=allowed_user_cookie_domain_type,
            allowed_user_cookie_duration=allowed_user_cookie_duration,
            allowed_user_cookie_enabled=allowed_user_cookie_enabled,
            allowed_user_cookie_http_only=allowed_user_cookie_http_only,
            allowed_user_cookie_label=allowed_user_cookie_label,
            allowed_user_cookie_management_title=allowed_user_cookie_management_title,
            allowed_user_cookie_refresh=allowed_user_cookie_refresh,
            allowed_user_cookie_salt=allowed_user_cookie_salt,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            user_identification_by_cookie=user_identification_by_cookie,
            user_identification_by_headers=user_identification_by_headers,
            user_identification_by_ip=user_identification_by_ip,
            user_identification_by_params=user_identification_by_params,
            user_identification_key_cookie=user_identification_key_cookie,
            user_identification_key_headers=user_identification_key_headers,
            user_identification_key_params=user_identification_key_params,
            user_identification_title=user_identification_title,
            uuid=uuid,
            waiting_room_cache_ttl=waiting_room_cache_ttl,
            waiting_room_cookie_advanced=waiting_room_cookie_advanced,
            waiting_room_cookie_automatic_salt=waiting_room_cookie_automatic_salt,
            waiting_room_cookie_domain=waiting_room_cookie_domain,
            waiting_room_cookie_domain_type=waiting_room_cookie_domain_type,
            waiting_room_cookie_duration=waiting_room_cookie_duration,
            waiting_room_cookie_enabled=waiting_room_cookie_enabled,
            waiting_room_cookie_http_only=waiting_room_cookie_http_only,
            waiting_room_cookie_label=waiting_room_cookie_label,
            waiting_room_cookie_management_title=waiting_room_cookie_management_title,
            waiting_room_cookie_salt=waiting_room_cookie_salt,
            waiting_room_cookie_share_label=waiting_room_cookie_share_label,
            waiting_room_cp_code=waiting_room_cp_code,
            waiting_room_directory=waiting_room_directory,
            waiting_room_management_title=waiting_room_management_title,
            waiting_room_net_storage=waiting_room_net_storage,
            waiting_room_status_code=waiting_room_status_code,
            waiting_room_use_cp_code=waiting_room_use_cp_code,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritization", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifo")
    def put_visitor_prioritization_fifo(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifo", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifoStandalone")
    def put_visitor_prioritization_fifo_standalone(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifoStandalone", [value]))

    @jsii.member(jsii_name="putWatermarking")
    def put_watermarking(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking(
            ab_variant_location=ab_variant_location,
            decryption_password1=decryption_password1,
            decryption_password2=decryption_password2,
            decryption_password_id1=decryption_password_id1,
            decryption_password_id2=decryption_password_id2,
            enable=enable,
            locked=locked,
            miscellaneous_settings_title=miscellaneous_settings_title,
            pattern_decryption_enable=pattern_decryption_enable,
            pattern_encryption_title=pattern_encryption_title,
            signature_verification_enable=signature_verification_enable,
            template_uuid=template_uuid,
            token_signing_title=token_signing_title,
            use_original_as_a=use_original_as_a,
            uuid=uuid,
            verification_key_id1=verification_key_id1,
            verification_key_id2=verification_key_id2,
            verification_public_key1=verification_public_key1,
            verification_public_key2=verification_public_key2,
        )

        return typing.cast(None, jsii.invoke(self, "putWatermarking", [value]))

    @jsii.member(jsii_name="putWebApplicationFirewall")
    def put_web_application_firewall(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall(
            firewall_configuration=firewall_configuration,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putWebApplicationFirewall", [value]))

    @jsii.member(jsii_name="putWebdav")
    def put_webdav(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebdav", [value]))

    @jsii.member(jsii_name="putWebSockets")
    def put_web_sockets(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebSockets", [value]))

    @jsii.member(jsii_name="resetAdaptiveAcceleration")
    def reset_adaptive_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveAcceleration", []))

    @jsii.member(jsii_name="resetAdaptiveImageCompression")
    def reset_adaptive_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveImageCompression", []))

    @jsii.member(jsii_name="resetAdScalerCircuitBreaker")
    def reset_ad_scaler_circuit_breaker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdScalerCircuitBreaker", []))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetAggregatedReporting")
    def reset_aggregated_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregatedReporting", []))

    @jsii.member(jsii_name="resetAkamaizer")
    def reset_akamaizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizer", []))

    @jsii.member(jsii_name="resetAkamaizerTag")
    def reset_akamaizer_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizerTag", []))

    @jsii.member(jsii_name="resetAllHttpInCacheHierarchy")
    def reset_all_http_in_cache_hierarchy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllHttpInCacheHierarchy", []))

    @jsii.member(jsii_name="resetAllowCloudletsOrigins")
    def reset_allow_cloudlets_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCloudletsOrigins", []))

    @jsii.member(jsii_name="resetAllowDelete")
    def reset_allow_delete(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowDelete", []))

    @jsii.member(jsii_name="resetAllowHttpsCacheKeySharing")
    def reset_allow_https_cache_key_sharing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsCacheKeySharing", []))

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowOptions")
    def reset_allow_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOptions", []))

    @jsii.member(jsii_name="resetAllowPatch")
    def reset_allow_patch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPatch", []))

    @jsii.member(jsii_name="resetAllowPost")
    def reset_allow_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPost", []))

    @jsii.member(jsii_name="resetAllowPut")
    def reset_allow_put(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPut", []))

    @jsii.member(jsii_name="resetAllowTransferEncoding")
    def reset_allow_transfer_encoding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowTransferEncoding", []))

    @jsii.member(jsii_name="resetAltSvcHeader")
    def reset_alt_svc_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAltSvcHeader", []))

    @jsii.member(jsii_name="resetApiPrioritization")
    def reset_api_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiPrioritization", []))

    @jsii.member(jsii_name="resetApplicationLoadBalancer")
    def reset_application_load_balancer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationLoadBalancer", []))

    @jsii.member(jsii_name="resetAudienceSegmentation")
    def reset_audience_segmentation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSegmentation", []))

    @jsii.member(jsii_name="resetAutoDomainValidation")
    def reset_auto_domain_validation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutoDomainValidation", []))

    @jsii.member(jsii_name="resetBaseDirectory")
    def reset_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBaseDirectory", []))

    @jsii.member(jsii_name="resetBossBeaconing")
    def reset_boss_beaconing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBossBeaconing", []))

    @jsii.member(jsii_name="resetBreadcrumbs")
    def reset_breadcrumbs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreadcrumbs", []))

    @jsii.member(jsii_name="resetBreakConnection")
    def reset_break_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreakConnection", []))

    @jsii.member(jsii_name="resetBrotli")
    def reset_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrotli", []))

    @jsii.member(jsii_name="resetCacheError")
    def reset_cache_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheError", []))

    @jsii.member(jsii_name="resetCacheId")
    def reset_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheId", []))

    @jsii.member(jsii_name="resetCacheKeyIgnoreCase")
    def reset_cache_key_ignore_case(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyIgnoreCase", []))

    @jsii.member(jsii_name="resetCacheKeyQueryParams")
    def reset_cache_key_query_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyQueryParams", []))

    @jsii.member(jsii_name="resetCacheKeyRewrite")
    def reset_cache_key_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyRewrite", []))

    @jsii.member(jsii_name="resetCachePost")
    def reset_cache_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachePost", []))

    @jsii.member(jsii_name="resetCacheRedirect")
    def reset_cache_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheRedirect", []))

    @jsii.member(jsii_name="resetCacheTag")
    def reset_cache_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTag", []))

    @jsii.member(jsii_name="resetCacheTagVisible")
    def reset_cache_tag_visible(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTagVisible", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetCentralAuthorization")
    def reset_central_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCentralAuthorization", []))

    @jsii.member(jsii_name="resetChaseRedirects")
    def reset_chase_redirects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaseRedirects", []))

    @jsii.member(jsii_name="resetClientCharacteristics")
    def reset_client_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCharacteristics", []))

    @jsii.member(jsii_name="resetCloudInterconnects")
    def reset_cloud_interconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudInterconnects", []))

    @jsii.member(jsii_name="resetCloudWrapper")
    def reset_cloud_wrapper(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapper", []))

    @jsii.member(jsii_name="resetCloudWrapperAdvanced")
    def reset_cloud_wrapper_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapperAdvanced", []))

    @jsii.member(jsii_name="resetCommonMediaClientData")
    def reset_common_media_client_data(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCommonMediaClientData", []))

    @jsii.member(jsii_name="resetConditionalOrigin")
    def reset_conditional_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalOrigin", []))

    @jsii.member(jsii_name="resetConstructResponse")
    def reset_construct_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConstructResponse", []))

    @jsii.member(jsii_name="resetContentCharacteristics")
    def reset_content_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristics", []))

    @jsii.member(jsii_name="resetContentCharacteristicsAmd")
    def reset_content_characteristics_amd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsAmd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsDd")
    def reset_content_characteristics_dd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsDd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLargeFile")
    def reset_content_characteristics_wsd_large_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLargeFile", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLive")
    def reset_content_characteristics_wsd_live(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLive", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdVod")
    def reset_content_characteristics_wsd_vod(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdVod", []))

    @jsii.member(jsii_name="resetContentPrePosition")
    def reset_content_pre_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPrePosition", []))

    @jsii.member(jsii_name="resetContentTargetingProtection")
    def reset_content_targeting_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentTargetingProtection", []))

    @jsii.member(jsii_name="resetCorsSupport")
    def reset_cors_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCorsSupport", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetCustomBehavior")
    def reset_custom_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomBehavior", []))

    @jsii.member(jsii_name="resetDatastream")
    def reset_datastream(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastream", []))

    @jsii.member(jsii_name="resetDcp")
    def reset_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcp", []))

    @jsii.member(jsii_name="resetDcpAuthHmacTransformation")
    def reset_dcp_auth_hmac_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthHmacTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthRegexTransformation")
    def reset_dcp_auth_regex_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthRegexTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthSubstringTransformation")
    def reset_dcp_auth_substring_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthSubstringTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthVariableExtractor")
    def reset_dcp_auth_variable_extractor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthVariableExtractor", []))

    @jsii.member(jsii_name="resetDcpDefaultAuthzGroups")
    def reset_dcp_default_authz_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDefaultAuthzGroups", []))

    @jsii.member(jsii_name="resetDcpDevRelations")
    def reset_dcp_dev_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDevRelations", []))

    @jsii.member(jsii_name="resetDcpRealTimeAuth")
    def reset_dcp_real_time_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpRealTimeAuth", []))

    @jsii.member(jsii_name="resetDeliveryReceipt")
    def reset_delivery_receipt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryReceipt", []))

    @jsii.member(jsii_name="resetDenyAccess")
    def reset_deny_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyAccess", []))

    @jsii.member(jsii_name="resetDenyDirectFailoverAccess")
    def reset_deny_direct_failover_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyDirectFailoverAccess", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicCacheId")
    def reset_device_characteristic_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicCacheId", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicHeader")
    def reset_device_characteristic_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicHeader", []))

    @jsii.member(jsii_name="resetDnsAsyncRefresh")
    def reset_dns_async_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsAsyncRefresh", []))

    @jsii.member(jsii_name="resetDnsPrefresh")
    def reset_dns_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsPrefresh", []))

    @jsii.member(jsii_name="resetDowngradeProtocol")
    def reset_downgrade_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDowngradeProtocol", []))

    @jsii.member(jsii_name="resetDownloadCompleteMarker")
    def reset_download_complete_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadCompleteMarker", []))

    @jsii.member(jsii_name="resetDownloadNotification")
    def reset_download_notification(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadNotification", []))

    @jsii.member(jsii_name="resetDownstreamCache")
    def reset_downstream_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownstreamCache", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimization")
    def reset_dynamic_throughtput_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimization", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimizationOverride")
    def reset_dynamic_throughtput_optimization_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimizationOverride", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEcmsBulkUpload")
    def reset_ecms_bulk_upload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsBulkUpload", []))

    @jsii.member(jsii_name="resetEcmsDatabase")
    def reset_ecms_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDatabase", []))

    @jsii.member(jsii_name="resetEcmsDataset")
    def reset_ecms_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDataset", []))

    @jsii.member(jsii_name="resetEcmsObjectKey")
    def reset_ecms_object_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsObjectKey", []))

    @jsii.member(jsii_name="resetEdgeConnect")
    def reset_edge_connect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeConnect", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingAdvanced")
    def reset_edge_load_balancing_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingAdvanced", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingDataCenter")
    def reset_edge_load_balancing_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingDataCenter", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingOrigin")
    def reset_edge_load_balancing_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingOrigin", []))

    @jsii.member(jsii_name="resetEdgeOriginAuthorization")
    def reset_edge_origin_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeOriginAuthorization", []))

    @jsii.member(jsii_name="resetEdgeRedirector")
    def reset_edge_redirector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeRedirector", []))

    @jsii.member(jsii_name="resetEdgeScape")
    def reset_edge_scape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeScape", []))

    @jsii.member(jsii_name="resetEdgeSideIncludes")
    def reset_edge_side_includes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeSideIncludes", []))

    @jsii.member(jsii_name="resetEdgeWorker")
    def reset_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorker", []))

    @jsii.member(jsii_name="resetEnhancedAkamaiProtocol")
    def reset_enhanced_akamai_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedAkamaiProtocol", []))

    @jsii.member(jsii_name="resetEnhancedProxyDetection")
    def reset_enhanced_proxy_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedProxyDetection", []))

    @jsii.member(jsii_name="resetEpdForwardHeaderEnrichment")
    def reset_epd_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEpdForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetFailAction")
    def reset_fail_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailAction", []))

    @jsii.member(jsii_name="resetFailoverBotManagerFeatureCompatibility")
    def reset_failover_bot_manager_feature_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverBotManagerFeatureCompatibility", []))

    @jsii.member(jsii_name="resetFastInvalidate")
    def reset_fast_invalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFastInvalidate", []))

    @jsii.member(jsii_name="resetFirstPartyMarketing")
    def reset_first_party_marketing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketing", []))

    @jsii.member(jsii_name="resetFirstPartyMarketingPlus")
    def reset_first_party_marketing_plus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketingPlus", []))

    @jsii.member(jsii_name="resetForwardRewrite")
    def reset_forward_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardRewrite", []))

    @jsii.member(jsii_name="resetG2Oheader")
    def reset_g2_oheader(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2Oheader", []))

    @jsii.member(jsii_name="resetGlobalRequestNumber")
    def reset_global_request_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalRequestNumber", []))

    @jsii.member(jsii_name="resetGraphqlCaching")
    def reset_graphql_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGraphqlCaching", []))

    @jsii.member(jsii_name="resetGzipResponse")
    def reset_gzip_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGzipResponse", []))

    @jsii.member(jsii_name="resetHdDataAdvanced")
    def reset_hd_data_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHdDataAdvanced", []))

    @jsii.member(jsii_name="resetHealthDetection")
    def reset_health_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHealthDetection", []))

    @jsii.member(jsii_name="resetHsafEipBinding")
    def reset_hsaf_eip_binding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsafEipBinding", []))

    @jsii.member(jsii_name="resetHttp2")
    def reset_http2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp2", []))

    @jsii.member(jsii_name="resetHttp3")
    def reset_http3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp3", []))

    @jsii.member(jsii_name="resetHttpStrictTransportSecurity")
    def reset_http_strict_transport_security(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpStrictTransportSecurity", []))

    @jsii.member(jsii_name="resetHttpToHttpsUpgrade")
    def reset_http_to_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpToHttpsUpgrade", []))

    @jsii.member(jsii_name="resetImageAndVideoManager")
    def reset_image_and_video_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageAndVideoManager", []))

    @jsii.member(jsii_name="resetImageManager")
    def reset_image_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManager", []))

    @jsii.member(jsii_name="resetImageManagerVideo")
    def reset_image_manager_video(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManagerVideo", []))

    @jsii.member(jsii_name="resetImOverride")
    def reset_im_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImOverride", []))

    @jsii.member(jsii_name="resetInclude")
    def reset_include(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInclude", []))

    @jsii.member(jsii_name="resetInstant")
    def reset_instant(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstant", []))

    @jsii.member(jsii_name="resetInstantConfig")
    def reset_instant_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstantConfig", []))

    @jsii.member(jsii_name="resetLargeFileOptimization")
    def reset_large_file_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimization", []))

    @jsii.member(jsii_name="resetLargeFileOptimizationAdvanced")
    def reset_large_file_optimization_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimizationAdvanced", []))

    @jsii.member(jsii_name="resetLimitBitRate")
    def reset_limit_bit_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitBitRate", []))

    @jsii.member(jsii_name="resetLogCustom")
    def reset_log_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustom", []))

    @jsii.member(jsii_name="resetManifestPersonalization")
    def reset_manifest_personalization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestPersonalization", []))

    @jsii.member(jsii_name="resetManifestRerouting")
    def reset_manifest_rerouting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestRerouting", []))

    @jsii.member(jsii_name="resetManualServerPush")
    def reset_manual_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManualServerPush", []))

    @jsii.member(jsii_name="resetMediaAcceleration")
    def reset_media_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAcceleration", []))

    @jsii.member(jsii_name="resetMediaAccelerationQuicOptout")
    def reset_media_acceleration_quic_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAccelerationQuicOptout", []))

    @jsii.member(jsii_name="resetMediaClient")
    def reset_media_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaClient", []))

    @jsii.member(jsii_name="resetMediaFileRetrievalOptimization")
    def reset_media_file_retrieval_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaFileRetrievalOptimization", []))

    @jsii.member(jsii_name="resetMediaOriginFailover")
    def reset_media_origin_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaOriginFailover", []))

    @jsii.member(jsii_name="resetMetadataCaching")
    def reset_metadata_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataCaching", []))

    @jsii.member(jsii_name="resetMobileSdkPerformance")
    def reset_mobile_sdk_performance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileSdkPerformance", []))

    @jsii.member(jsii_name="resetModifyIncomingRequestHeader")
    def reset_modify_incoming_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyIncomingResponseHeader")
    def reset_modify_incoming_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingRequestHeader")
    def reset_modify_outgoing_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingResponseHeader")
    def reset_modify_outgoing_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyViaHeader")
    def reset_modify_via_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyViaHeader", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetOriginCharacteristics")
    def reset_origin_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristics", []))

    @jsii.member(jsii_name="resetOriginCharacteristicsWsd")
    def reset_origin_characteristics_wsd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristicsWsd", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryMethod")
    def reset_origin_failure_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryMethod", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryPolicy")
    def reset_origin_failure_recovery_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryPolicy", []))

    @jsii.member(jsii_name="resetOriginIpAcl")
    def reset_origin_ip_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginIpAcl", []))

    @jsii.member(jsii_name="resetPersistentClientConnection")
    def reset_persistent_client_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentClientConnection", []))

    @jsii.member(jsii_name="resetPersistentConnection")
    def reset_persistent_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentConnection", []))

    @jsii.member(jsii_name="resetPersonallyIdentifiableInformation")
    def reset_personally_identifiable_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersonallyIdentifiableInformation", []))

    @jsii.member(jsii_name="resetPhasedRelease")
    def reset_phased_release(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPhasedRelease", []))

    @jsii.member(jsii_name="resetPreconnect")
    def reset_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnect", []))

    @jsii.member(jsii_name="resetPredictiveContentDelivery")
    def reset_predictive_content_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictiveContentDelivery", []))

    @jsii.member(jsii_name="resetPredictivePrefetching")
    def reset_predictive_prefetching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictivePrefetching", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetPrefetchable")
    def reset_prefetchable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchable", []))

    @jsii.member(jsii_name="resetPrefreshCache")
    def reset_prefresh_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshCache", []))

    @jsii.member(jsii_name="resetQuality")
    def reset_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuality", []))

    @jsii.member(jsii_name="resetQuicBeta")
    def reset_quic_beta(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicBeta", []))

    @jsii.member(jsii_name="resetRandomSeek")
    def reset_random_seek(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandomSeek", []))

    @jsii.member(jsii_name="resetRapid")
    def reset_rapid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRapid", []))

    @jsii.member(jsii_name="resetReadTimeout")
    def reset_read_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReadTimeout", []))

    @jsii.member(jsii_name="resetRealTimeReporting")
    def reset_real_time_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealTimeReporting", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectplus")
    def reset_redirectplus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectplus", []))

    @jsii.member(jsii_name="resetRefererChecking")
    def reset_referer_checking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefererChecking", []))

    @jsii.member(jsii_name="resetRemoveQueryParameter")
    def reset_remove_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveQueryParameter", []))

    @jsii.member(jsii_name="resetRemoveVary")
    def reset_remove_vary(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveVary", []))

    @jsii.member(jsii_name="resetReport")
    def reset_report(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReport", []))

    @jsii.member(jsii_name="resetRequestControl")
    def reset_request_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestControl", []))

    @jsii.member(jsii_name="resetRequestTypeMarker")
    def reset_request_type_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestTypeMarker", []))

    @jsii.member(jsii_name="resetResourceOptimizer")
    def reset_resource_optimizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizer", []))

    @jsii.member(jsii_name="resetResourceOptimizerExtendedCompatibility")
    def reset_resource_optimizer_extended_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizerExtendedCompatibility", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetResponseCookie")
    def reset_response_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCookie", []))

    @jsii.member(jsii_name="resetRestrictObjectCaching")
    def reset_restrict_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRestrictObjectCaching", []))

    @jsii.member(jsii_name="resetReturnCacheStatus")
    def reset_return_cache_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnCacheStatus", []))

    @jsii.member(jsii_name="resetRewriteUrl")
    def reset_rewrite_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRewriteUrl", []))

    @jsii.member(jsii_name="resetRumCustom")
    def reset_rum_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumCustom", []))

    @jsii.member(jsii_name="resetSaasDefinitions")
    def reset_saas_definitions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasDefinitions", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudClient")
    def reset_sales_force_commerce_cloud_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudClient", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProvider")
    def reset_sales_force_commerce_cloud_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProvider", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProviderHostHeader")
    def reset_sales_force_commerce_cloud_provider_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProviderHostHeader", []))

    @jsii.member(jsii_name="resetSavePostDcaProcessing")
    def reset_save_post_dca_processing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSavePostDcaProcessing", []))

    @jsii.member(jsii_name="resetScheduleInvalidation")
    def reset_schedule_invalidation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScheduleInvalidation", []))

    @jsii.member(jsii_name="resetScriptManagement")
    def reset_script_management(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScriptManagement", []))

    @jsii.member(jsii_name="resetSegmentedContentProtection")
    def reset_segmented_content_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedContentProtection", []))

    @jsii.member(jsii_name="resetSegmentedMediaOptimization")
    def reset_segmented_media_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaOptimization", []))

    @jsii.member(jsii_name="resetSegmentedMediaStreamingPrefetch")
    def reset_segmented_media_streaming_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaStreamingPrefetch", []))

    @jsii.member(jsii_name="resetSetVariable")
    def reset_set_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetVariable", []))

    @jsii.member(jsii_name="resetSimulateErrorCode")
    def reset_simulate_error_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSimulateErrorCode", []))

    @jsii.member(jsii_name="resetSiteShield")
    def reset_site_shield(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteShield", []))

    @jsii.member(jsii_name="resetStandardTlsMigration")
    def reset_standard_tls_migration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigration", []))

    @jsii.member(jsii_name="resetStandardTlsMigrationOverride")
    def reset_standard_tls_migration_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigrationOverride", []))

    @jsii.member(jsii_name="resetStrictHeaderParsing")
    def reset_strict_header_parsing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictHeaderParsing", []))

    @jsii.member(jsii_name="resetSubCustomer")
    def reset_sub_customer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubCustomer", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTcpOptimization")
    def reset_tcp_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTcpOptimization", []))

    @jsii.member(jsii_name="resetTeaLeaf")
    def reset_tea_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTeaLeaf", []))

    @jsii.member(jsii_name="resetTieredDistribution")
    def reset_tiered_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistribution", []))

    @jsii.member(jsii_name="resetTieredDistributionAdvanced")
    def reset_tiered_distribution_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionAdvanced", []))

    @jsii.member(jsii_name="resetTieredDistributionCustomization")
    def reset_tiered_distribution_customization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionCustomization", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUidConfiguration")
    def reset_uid_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUidConfiguration", []))

    @jsii.member(jsii_name="resetValidateEntityTag")
    def reset_validate_entity_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateEntityTag", []))

    @jsii.member(jsii_name="resetVerifyJsonWebToken")
    def reset_verify_json_web_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebToken", []))

    @jsii.member(jsii_name="resetVerifyJsonWebTokenForDcp")
    def reset_verify_json_web_token_for_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebTokenForDcp", []))

    @jsii.member(jsii_name="resetVerifyTokenAuthorization")
    def reset_verify_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyTokenAuthorization", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoom")
    def reset_virtual_waiting_room(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoom", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomWithEdgeWorkers")
    def reset_virtual_waiting_room_with_edge_workers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomWithEdgeWorkers", []))

    @jsii.member(jsii_name="resetVisitorPrioritization")
    def reset_visitor_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritization", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifo")
    def reset_visitor_prioritization_fifo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifo", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifoStandalone")
    def reset_visitor_prioritization_fifo_standalone(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifoStandalone", []))

    @jsii.member(jsii_name="resetWatermarking")
    def reset_watermarking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWatermarking", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @jsii.member(jsii_name="resetWebdav")
    def reset_webdav(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebdav", []))

    @jsii.member(jsii_name="resetWebSockets")
    def reset_web_sockets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebSockets", []))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAcceleration")
    def adaptive_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAccelerationOutputReference, jsii.get(self, "adaptiveAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompression")
    def adaptive_image_compression(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompressionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompressionOutputReference, jsii.get(self, "adaptiveImageCompression"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreaker")
    def ad_scaler_circuit_breaker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreakerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreakerOutputReference, jsii.get(self, "adScalerCircuitBreaker"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvancedOutputReference, jsii.get(self, "advanced"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReporting")
    def aggregated_reporting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReportingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReportingOutputReference, jsii.get(self, "aggregatedReporting"))

    @builtins.property
    @jsii.member(jsii_name="akamaizer")
    def akamaizer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerOutputReference, jsii.get(self, "akamaizer"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTag")
    def akamaizer_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTagOutputReference, jsii.get(self, "akamaizerTag"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchy")
    def all_http_in_cache_hierarchy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchyOutputReference, jsii.get(self, "allHttpInCacheHierarchy"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOrigins")
    def allow_cloudlets_origins(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOriginsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOriginsOutputReference, jsii.get(self, "allowCloudletsOrigins"))

    @builtins.property
    @jsii.member(jsii_name="allowDelete")
    def allow_delete(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDeleteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDeleteOutputReference, jsii.get(self, "allowDelete"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharing")
    def allow_https_cache_key_sharing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharingOutputReference, jsii.get(self, "allowHttpsCacheKeySharing"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngradeOutputReference, jsii.get(self, "allowHttpsDowngrade"))

    @builtins.property
    @jsii.member(jsii_name="allowOptions")
    def allow_options(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptionsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptionsOutputReference, jsii.get(self, "allowOptions"))

    @builtins.property
    @jsii.member(jsii_name="allowPatch")
    def allow_patch(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatchOutputReference, jsii.get(self, "allowPatch"))

    @builtins.property
    @jsii.member(jsii_name="allowPost")
    def allow_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPostOutputReference, jsii.get(self, "allowPost"))

    @builtins.property
    @jsii.member(jsii_name="allowPut")
    def allow_put(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPutOutputReference, jsii.get(self, "allowPut"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncoding")
    def allow_transfer_encoding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncodingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncodingOutputReference, jsii.get(self, "allowTransferEncoding"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeader")
    def alt_svc_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeaderOutputReference, jsii.get(self, "altSvcHeader"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritization")
    def api_prioritization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationOutputReference, jsii.get(self, "apiPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancer")
    def application_load_balancer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerOutputReference, jsii.get(self, "applicationLoadBalancer"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentation")
    def audience_segmentation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationOutputReference, jsii.get(self, "audienceSegmentation"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidation")
    def auto_domain_validation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidationOutputReference, jsii.get(self, "autoDomainValidation"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectory")
    def base_directory(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectoryOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectoryOutputReference, jsii.get(self, "baseDirectory"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconing")
    def boss_beaconing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconingOutputReference, jsii.get(self, "bossBeaconing"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbs")
    def breadcrumbs(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbsOutputReference, jsii.get(self, "breadcrumbs"))

    @builtins.property
    @jsii.member(jsii_name="breakConnection")
    def break_connection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnectionOutputReference, jsii.get(self, "breakConnection"))

    @builtins.property
    @jsii.member(jsii_name="brotli")
    def brotli(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotliOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotliOutputReference, jsii.get(self, "brotli"))

    @builtins.property
    @jsii.member(jsii_name="cacheError")
    def cache_error(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheErrorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheErrorOutputReference, jsii.get(self, "cacheError"))

    @builtins.property
    @jsii.member(jsii_name="cacheId")
    def cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheIdOutputReference, jsii.get(self, "cacheId"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCase")
    def cache_key_ignore_case(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCaseOutputReference, jsii.get(self, "cacheKeyIgnoreCase"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParams")
    def cache_key_query_params(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParamsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParamsOutputReference, jsii.get(self, "cacheKeyQueryParams"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewrite")
    def cache_key_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewriteOutputReference, jsii.get(self, "cacheKeyRewrite"))

    @builtins.property
    @jsii.member(jsii_name="cachePost")
    def cache_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePostOutputReference, jsii.get(self, "cachePost"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirect")
    def cache_redirect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirectOutputReference, jsii.get(self, "cacheRedirect"))

    @builtins.property
    @jsii.member(jsii_name="cacheTag")
    def cache_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagOutputReference, jsii.get(self, "cacheTag"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisible")
    def cache_tag_visible(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisibleOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisibleOutputReference, jsii.get(self, "cacheTagVisible"))

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachingOutputReference, jsii.get(self, "caching"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorization")
    def central_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorizationOutputReference, jsii.get(self, "centralAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirects")
    def chase_redirects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirectsOutputReference, jsii.get(self, "chaseRedirects"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristics")
    def client_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristicsOutputReference, jsii.get(self, "clientCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnects")
    def cloud_interconnects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnectsOutputReference, jsii.get(self, "cloudInterconnects"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapper")
    def cloud_wrapper(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperOutputReference, jsii.get(self, "cloudWrapper"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvanced")
    def cloud_wrapper_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvancedOutputReference, jsii.get(self, "cloudWrapperAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientData")
    def common_media_client_data(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientDataOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientDataOutputReference, jsii.get(self, "commonMediaClientData"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOrigin")
    def conditional_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOriginOutputReference, jsii.get(self, "conditionalOrigin"))

    @builtins.property
    @jsii.member(jsii_name="constructResponse")
    def construct_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponseOutputReference, jsii.get(self, "constructResponse"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristics")
    def content_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsOutputReference, jsii.get(self, "contentCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmd")
    def content_characteristics_amd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmdOutputReference, jsii.get(self, "contentCharacteristicsAmd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDd")
    def content_characteristics_dd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDdOutputReference, jsii.get(self, "contentCharacteristicsDd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFile")
    def content_characteristics_wsd_large_file(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFileOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFileOutputReference, jsii.get(self, "contentCharacteristicsWsdLargeFile"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLive")
    def content_characteristics_wsd_live(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLiveOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLiveOutputReference, jsii.get(self, "contentCharacteristicsWsdLive"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVod")
    def content_characteristics_wsd_vod(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVodOutputReference, jsii.get(self, "contentCharacteristicsWsdVod"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePosition")
    def content_pre_position(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePositionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePositionOutputReference, jsii.get(self, "contentPrePosition"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtection")
    def content_targeting_protection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtectionOutputReference, jsii.get(self, "contentTargetingProtection"))

    @builtins.property
    @jsii.member(jsii_name="corsSupport")
    def cors_support(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupportOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupportOutputReference, jsii.get(self, "corsSupport"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="customBehavior")
    def custom_behavior(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehaviorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehaviorOutputReference, jsii.get(self, "customBehavior"))

    @builtins.property
    @jsii.member(jsii_name="datastream")
    def datastream(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastreamOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastreamOutputReference, jsii.get(self, "datastream"))

    @builtins.property
    @jsii.member(jsii_name="dcp")
    def dcp(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpOutputReference, jsii.get(self, "dcp"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformation")
    def dcp_auth_hmac_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformationOutputReference, jsii.get(self, "dcpAuthHmacTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformation")
    def dcp_auth_regex_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformationOutputReference, jsii.get(self, "dcpAuthRegexTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformation")
    def dcp_auth_substring_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformationOutputReference, jsii.get(self, "dcpAuthSubstringTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractor")
    def dcp_auth_variable_extractor(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractorOutputReference, jsii.get(self, "dcpAuthVariableExtractor"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroups")
    def dcp_default_authz_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroupsOutputReference, jsii.get(self, "dcpDefaultAuthzGroups"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelations")
    def dcp_dev_relations(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelationsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelationsOutputReference, jsii.get(self, "dcpDevRelations"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuth")
    def dcp_real_time_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuthOutputReference, jsii.get(self, "dcpRealTimeAuth"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceipt")
    def delivery_receipt(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference, jsii.get(self, "deliveryReceipt"))

    @builtins.property
    @jsii.member(jsii_name="denyAccess")
    def deny_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference, jsii.get(self, "denyAccess"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccess")
    def deny_direct_failover_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference, jsii.get(self, "denyDirectFailoverAccess"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheId")
    def device_characteristic_cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference, jsii.get(self, "deviceCharacteristicCacheId"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeader")
    def device_characteristic_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference, jsii.get(self, "deviceCharacteristicHeader"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefresh")
    def dns_async_refresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference, jsii.get(self, "dnsAsyncRefresh"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefresh")
    def dns_prefresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference, jsii.get(self, "dnsPrefresh"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocol")
    def downgrade_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference, jsii.get(self, "downgradeProtocol"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarker")
    def download_complete_marker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference, jsii.get(self, "downloadCompleteMarker"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotification")
    def download_notification(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference, jsii.get(self, "downloadNotification"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCache")
    def downstream_cache(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference, jsii.get(self, "downstreamCache"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimization")
    def dynamic_throughtput_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference, jsii.get(self, "dynamicThroughtputOptimization"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverride")
    def dynamic_throughtput_optimization_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference, jsii.get(self, "dynamicThroughtputOptimizationOverride"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference, jsii.get(self, "dynamicWebContent"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUpload")
    def ecms_bulk_upload(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference, jsii.get(self, "ecmsBulkUpload"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabase")
    def ecms_database(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference, jsii.get(self, "ecmsDatabase"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDataset")
    def ecms_dataset(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference, jsii.get(self, "ecmsDataset"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKey")
    def ecms_object_key(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference, jsii.get(self, "ecmsObjectKey"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnect")
    def edge_connect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference, jsii.get(self, "edgeConnect"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvanced")
    def edge_load_balancing_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference, jsii.get(self, "edgeLoadBalancingAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenter")
    def edge_load_balancing_data_center(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference, jsii.get(self, "edgeLoadBalancingDataCenter"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOrigin")
    def edge_load_balancing_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference, jsii.get(self, "edgeLoadBalancingOrigin"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorization")
    def edge_origin_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference, jsii.get(self, "edgeOriginAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirector")
    def edge_redirector(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference, jsii.get(self, "edgeRedirector"))

    @builtins.property
    @jsii.member(jsii_name="edgeScape")
    def edge_scape(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference, jsii.get(self, "edgeScape"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludes")
    def edge_side_includes(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference, jsii.get(self, "edgeSideIncludes"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorker")
    def edge_worker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference, jsii.get(self, "edgeWorker"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocol")
    def enhanced_akamai_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference, jsii.get(self, "enhancedAkamaiProtocol"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetection")
    def enhanced_proxy_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference, jsii.get(self, "enhancedProxyDetection"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichment")
    def epd_forward_header_enrichment(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference, jsii.get(self, "epdForwardHeaderEnrichment"))

    @builtins.property
    @jsii.member(jsii_name="failAction")
    def fail_action(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference, jsii.get(self, "failAction"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibility")
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference, jsii.get(self, "failoverBotManagerFeatureCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidate")
    def fast_invalidate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference, jsii.get(self, "fastInvalidate"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketing")
    def first_party_marketing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference, jsii.get(self, "firstPartyMarketing"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlus")
    def first_party_marketing_plus(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference, jsii.get(self, "firstPartyMarketingPlus"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewrite")
    def forward_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference, jsii.get(self, "forwardRewrite"))

    @builtins.property
    @jsii.member(jsii_name="g2Oheader")
    def g2_oheader(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference, jsii.get(self, "g2Oheader"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumber")
    def global_request_number(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference, jsii.get(self, "globalRequestNumber"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCaching")
    def graphql_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference, jsii.get(self, "graphqlCaching"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponse")
    def gzip_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference, jsii.get(self, "gzipResponse"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvanced")
    def hd_data_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference, jsii.get(self, "hdDataAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="healthDetection")
    def health_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference, jsii.get(self, "healthDetection"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBinding")
    def hsaf_eip_binding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference, jsii.get(self, "hsafEipBinding"))

    @builtins.property
    @jsii.member(jsii_name="http2")
    def http2(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference, jsii.get(self, "http2"))

    @builtins.property
    @jsii.member(jsii_name="http3")
    def http3(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference, jsii.get(self, "http3"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurity")
    def http_strict_transport_security(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference, jsii.get(self, "httpStrictTransportSecurity"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgrade")
    def http_to_https_upgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference, jsii.get(self, "httpToHttpsUpgrade"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManager")
    def image_and_video_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference, jsii.get(self, "imageAndVideoManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManager")
    def image_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference, jsii.get(self, "imageManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideo")
    def image_manager_video(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference, jsii.get(self, "imageManagerVideo"))

    @builtins.property
    @jsii.member(jsii_name="imOverride")
    def im_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference, jsii.get(self, "imOverride"))

    @builtins.property
    @jsii.member(jsii_name="include")
    def include(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference, jsii.get(self, "include"))

    @builtins.property
    @jsii.member(jsii_name="instant")
    def instant(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference, jsii.get(self, "instant"))

    @builtins.property
    @jsii.member(jsii_name="instantConfig")
    def instant_config(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference, jsii.get(self, "instantConfig"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimization")
    def large_file_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference, jsii.get(self, "largeFileOptimization"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvanced")
    def large_file_optimization_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference, jsii.get(self, "largeFileOptimizationAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRate")
    def limit_bit_rate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference, jsii.get(self, "limitBitRate"))

    @builtins.property
    @jsii.member(jsii_name="logCustom")
    def log_custom(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference, jsii.get(self, "logCustom"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalization")
    def manifest_personalization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference, jsii.get(self, "manifestPersonalization"))

    @builtins.property
    @jsii.member(jsii_name="manifestRerouting")
    def manifest_rerouting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference, jsii.get(self, "manifestRerouting"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPush")
    def manual_server_push(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference, jsii.get(self, "manualServerPush"))

    @builtins.property
    @jsii.member(jsii_name="mediaAcceleration")
    def media_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference, jsii.get(self, "mediaAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptout")
    def media_acceleration_quic_optout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference, jsii.get(self, "mediaAccelerationQuicOptout"))

    @builtins.property
    @jsii.member(jsii_name="mediaClient")
    def media_client(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference, jsii.get(self, "mediaClient"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimization")
    def media_file_retrieval_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference, jsii.get(self, "mediaFileRetrievalOptimization"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailover")
    def media_origin_failover(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference, jsii.get(self, "mediaOriginFailover"))

    @builtins.property
    @jsii.member(jsii_name="metadataCaching")
    def metadata_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference, jsii.get(self, "metadataCaching"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformance")
    def mobile_sdk_performance(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference, jsii.get(self, "mobileSdkPerformance"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeader")
    def modify_incoming_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference, jsii.get(self, "modifyIncomingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeader")
    def modify_incoming_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference, jsii.get(self, "modifyIncomingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeader")
    def modify_outgoing_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference, jsii.get(self, "modifyOutgoingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeader")
    def modify_outgoing_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference, jsii.get(self, "modifyOutgoingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeader")
    def modify_via_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference, jsii.get(self, "modifyViaHeader"))

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference, jsii.get(self, "mPulse"))

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference, jsii.get(self, "origin"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristics")
    def origin_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference, jsii.get(self, "originCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsd")
    def origin_characteristics_wsd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference, jsii.get(self, "originCharacteristicsWsd"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethod")
    def origin_failure_recovery_method(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference, jsii.get(self, "originFailureRecoveryMethod"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicy")
    def origin_failure_recovery_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference, jsii.get(self, "originFailureRecoveryPolicy"))

    @builtins.property
    @jsii.member(jsii_name="originIpAcl")
    def origin_ip_acl(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference, jsii.get(self, "originIpAcl"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnection")
    def persistent_client_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference", jsii.get(self, "persistentClientConnection"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnection")
    def persistent_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference", jsii.get(self, "persistentConnection"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformation")
    def personally_identifiable_information(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference", jsii.get(self, "personallyIdentifiableInformation"))

    @builtins.property
    @jsii.member(jsii_name="phasedRelease")
    def phased_release(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference", jsii.get(self, "phasedRelease"))

    @builtins.property
    @jsii.member(jsii_name="preconnect")
    def preconnect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference", jsii.get(self, "preconnect"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDelivery")
    def predictive_content_delivery(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference", jsii.get(self, "predictiveContentDelivery"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetching")
    def predictive_prefetching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference", jsii.get(self, "predictivePrefetching"))

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference", jsii.get(self, "prefetch"))

    @builtins.property
    @jsii.member(jsii_name="prefetchable")
    def prefetchable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference", jsii.get(self, "prefetchable"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCache")
    def prefresh_cache(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference", jsii.get(self, "prefreshCache"))

    @builtins.property
    @jsii.member(jsii_name="quality")
    def quality(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference", jsii.get(self, "quality"))

    @builtins.property
    @jsii.member(jsii_name="quicBeta")
    def quic_beta(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference", jsii.get(self, "quicBeta"))

    @builtins.property
    @jsii.member(jsii_name="randomSeek")
    def random_seek(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference", jsii.get(self, "randomSeek"))

    @builtins.property
    @jsii.member(jsii_name="rapid")
    def rapid(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference", jsii.get(self, "rapid"))

    @builtins.property
    @jsii.member(jsii_name="readTimeout")
    def read_timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference", jsii.get(self, "readTimeout"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReporting")
    def real_time_reporting(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference", jsii.get(self, "realTimeReporting"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference", jsii.get(self, "realUserMonitoring"))

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference", jsii.get(self, "redirect"))

    @builtins.property
    @jsii.member(jsii_name="redirectplus")
    def redirectplus(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference", jsii.get(self, "redirectplus"))

    @builtins.property
    @jsii.member(jsii_name="refererChecking")
    def referer_checking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference", jsii.get(self, "refererChecking"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameter")
    def remove_query_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference", jsii.get(self, "removeQueryParameter"))

    @builtins.property
    @jsii.member(jsii_name="removeVary")
    def remove_vary(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVaryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVaryOutputReference", jsii.get(self, "removeVary"))

    @builtins.property
    @jsii.member(jsii_name="report")
    def report(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReportOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReportOutputReference", jsii.get(self, "report"))

    @builtins.property
    @jsii.member(jsii_name="requestControl")
    def request_control(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlOutputReference", jsii.get(self, "requestControl"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarker")
    def request_type_marker(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarkerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarkerOutputReference", jsii.get(self, "requestTypeMarker"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizer")
    def resource_optimizer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerOutputReference", jsii.get(self, "resourceOptimizer"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibility")
    def resource_optimizer_extended_compatibility(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibilityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibilityOutputReference", jsii.get(self, "resourceOptimizerExtendedCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCodeOutputReference", jsii.get(self, "responseCode"))

    @builtins.property
    @jsii.member(jsii_name="responseCookie")
    def response_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookieOutputReference", jsii.get(self, "responseCookie"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCaching")
    def restrict_object_caching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCachingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCachingOutputReference", jsii.get(self, "restrictObjectCaching"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatus")
    def return_cache_status(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatusOutputReference", jsii.get(self, "returnCacheStatus"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrl")
    def rewrite_url(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrlOutputReference", jsii.get(self, "rewriteUrl"))

    @builtins.property
    @jsii.member(jsii_name="rumCustom")
    def rum_custom(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustomOutputReference", jsii.get(self, "rumCustom"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitions")
    def saas_definitions(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitionsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitionsOutputReference", jsii.get(self, "saasDefinitions"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClient")
    def sales_force_commerce_cloud_client(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClientOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClientOutputReference", jsii.get(self, "salesForceCommerceCloudClient"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProvider")
    def sales_force_commerce_cloud_provider(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderOutputReference", jsii.get(self, "salesForceCommerceCloudProvider"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeader")
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference", jsii.get(self, "salesForceCommerceCloudProviderHostHeader"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessing")
    def save_post_dca_processing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessingOutputReference", jsii.get(self, "savePostDcaProcessing"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidation")
    def schedule_invalidation(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidationOutputReference", jsii.get(self, "scheduleInvalidation"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagement")
    def script_management(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagementOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagementOutputReference", jsii.get(self, "scriptManagement"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtection")
    def segmented_content_protection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtectionOutputReference", jsii.get(self, "segmentedContentProtection"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimization")
    def segmented_media_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimizationOutputReference", jsii.get(self, "segmentedMediaOptimization"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetch")
    def segmented_media_streaming_prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetchOutputReference", jsii.get(self, "segmentedMediaStreamingPrefetch"))

    @builtins.property
    @jsii.member(jsii_name="setVariable")
    def set_variable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariableOutputReference", jsii.get(self, "setVariable"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCode")
    def simulate_error_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCodeOutputReference", jsii.get(self, "simulateErrorCode"))

    @builtins.property
    @jsii.member(jsii_name="siteShield")
    def site_shield(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldOutputReference", jsii.get(self, "siteShield"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigration")
    def standard_tls_migration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOutputReference", jsii.get(self, "standardTlsMigration"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverride")
    def standard_tls_migration_override(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverrideOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverrideOutputReference", jsii.get(self, "standardTlsMigrationOverride"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsing")
    def strict_header_parsing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsingOutputReference", jsii.get(self, "strictHeaderParsing"))

    @builtins.property
    @jsii.member(jsii_name="subCustomer")
    def sub_customer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomerOutputReference", jsii.get(self, "subCustomer"))

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRouteOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRouteOutputReference", jsii.get(self, "sureRoute"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimization")
    def tcp_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimizationOutputReference", jsii.get(self, "tcpOptimization"))

    @builtins.property
    @jsii.member(jsii_name="teaLeaf")
    def tea_leaf(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeafOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeafOutputReference", jsii.get(self, "teaLeaf"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistribution")
    def tiered_distribution(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionOutputReference", jsii.get(self, "tieredDistribution"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvanced")
    def tiered_distribution_advanced(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvancedOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvancedOutputReference", jsii.get(self, "tieredDistributionAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomization")
    def tiered_distribution_customization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomizationOutputReference", jsii.get(self, "tieredDistributionCustomization"))

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeoutOutputReference", jsii.get(self, "timeout"))

    @builtins.property
    @jsii.member(jsii_name="uidConfiguration")
    def uid_configuration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfigurationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfigurationOutputReference", jsii.get(self, "uidConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTag")
    def validate_entity_tag(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTagOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTagOutputReference", jsii.get(self, "validateEntityTag"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebToken")
    def verify_json_web_token(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenOutputReference", jsii.get(self, "verifyJsonWebToken"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcp")
    def verify_json_web_token_for_dcp(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcpOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcpOutputReference", jsii.get(self, "verifyJsonWebTokenForDcp"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorization")
    def verify_token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorizationOutputReference", jsii.get(self, "verifyTokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoom")
    def virtual_waiting_room(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomOutputReference", jsii.get(self, "virtualWaitingRoom"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkers")
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference", jsii.get(self, "virtualWaitingRoomWithEdgeWorkers"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritization")
    def visitor_prioritization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationOutputReference", jsii.get(self, "visitorPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifo")
    def visitor_prioritization_fifo(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoOutputReference", jsii.get(self, "visitorPrioritizationFifo"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandalone")
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandaloneOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandaloneOutputReference", jsii.get(self, "visitorPrioritizationFifoStandalone"))

    @builtins.property
    @jsii.member(jsii_name="watermarking")
    def watermarking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarkingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarkingOutputReference", jsii.get(self, "watermarking"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallOutputReference", jsii.get(self, "webApplicationFirewall"))

    @builtins.property
    @jsii.member(jsii_name="webdav")
    def webdav(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdavOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdavOutputReference", jsii.get(self, "webdav"))

    @builtins.property
    @jsii.member(jsii_name="webSockets")
    def web_sockets(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSocketsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSocketsOutputReference", jsii.get(self, "webSockets"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAccelerationInput")
    def adaptive_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration], jsii.get(self, "adaptiveAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompressionInput")
    def adaptive_image_compression_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression], jsii.get(self, "adaptiveImageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreakerInput")
    def ad_scaler_circuit_breaker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker], jsii.get(self, "adScalerCircuitBreakerInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReportingInput")
    def aggregated_reporting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting], jsii.get(self, "aggregatedReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerInput")
    def akamaizer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer], jsii.get(self, "akamaizerInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTagInput")
    def akamaizer_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag], jsii.get(self, "akamaizerTagInput"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchyInput")
    def all_http_in_cache_hierarchy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy], jsii.get(self, "allHttpInCacheHierarchyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOriginsInput")
    def allow_cloudlets_origins_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins], jsii.get(self, "allowCloudletsOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowDeleteInput")
    def allow_delete_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete], jsii.get(self, "allowDeleteInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharingInput")
    def allow_https_cache_key_sharing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "allowHttpsCacheKeySharingInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOptionsInput")
    def allow_options_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions], jsii.get(self, "allowOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPatchInput")
    def allow_patch_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch], jsii.get(self, "allowPatchInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPostInput")
    def allow_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost], jsii.get(self, "allowPostInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPutInput")
    def allow_put_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut], jsii.get(self, "allowPutInput"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncodingInput")
    def allow_transfer_encoding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding], jsii.get(self, "allowTransferEncodingInput"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeaderInput")
    def alt_svc_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader], jsii.get(self, "altSvcHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritizationInput")
    def api_prioritization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization], jsii.get(self, "apiPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancerInput")
    def application_load_balancer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer], jsii.get(self, "applicationLoadBalancerInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentationInput")
    def audience_segmentation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation], jsii.get(self, "audienceSegmentationInput"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidationInput")
    def auto_domain_validation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation], jsii.get(self, "autoDomainValidationInput"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectoryInput")
    def base_directory_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory], jsii.get(self, "baseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconingInput")
    def boss_beaconing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing], jsii.get(self, "bossBeaconingInput"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbsInput")
    def breadcrumbs_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs], jsii.get(self, "breadcrumbsInput"))

    @builtins.property
    @jsii.member(jsii_name="breakConnectionInput")
    def break_connection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection], jsii.get(self, "breakConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="brotliInput")
    def brotli_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli], jsii.get(self, "brotliInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorInput")
    def cache_error_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError], jsii.get(self, "cacheErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheIdInput")
    def cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId], jsii.get(self, "cacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCaseInput")
    def cache_key_ignore_case_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase], jsii.get(self, "cacheKeyIgnoreCaseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParamsInput")
    def cache_key_query_params_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams], jsii.get(self, "cacheKeyQueryParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewriteInput")
    def cache_key_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite], jsii.get(self, "cacheKeyRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="cachePostInput")
    def cache_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost], jsii.get(self, "cachePostInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirectInput")
    def cache_redirect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect], jsii.get(self, "cacheRedirectInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagInput")
    def cache_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag], jsii.get(self, "cacheTagInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisibleInput")
    def cache_tag_visible_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible], jsii.get(self, "cacheTagVisibleInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorizationInput")
    def central_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization], jsii.get(self, "centralAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirectsInput")
    def chase_redirects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects], jsii.get(self, "chaseRedirectsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristicsInput")
    def client_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics], jsii.get(self, "clientCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnectsInput")
    def cloud_interconnects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects], jsii.get(self, "cloudInterconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvancedInput")
    def cloud_wrapper_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced], jsii.get(self, "cloudWrapperAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperInput")
    def cloud_wrapper_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper], jsii.get(self, "cloudWrapperInput"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientDataInput")
    def common_media_client_data_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData], jsii.get(self, "commonMediaClientDataInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOriginInput")
    def conditional_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin], jsii.get(self, "conditionalOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="constructResponseInput")
    def construct_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse], jsii.get(self, "constructResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmdInput")
    def content_characteristics_amd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd], jsii.get(self, "contentCharacteristicsAmdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDdInput")
    def content_characteristics_dd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd], jsii.get(self, "contentCharacteristicsDdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsInput")
    def content_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics], jsii.get(self, "contentCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFileInput")
    def content_characteristics_wsd_large_file_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "contentCharacteristicsWsdLargeFileInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLiveInput")
    def content_characteristics_wsd_live_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive], jsii.get(self, "contentCharacteristicsWsdLiveInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVodInput")
    def content_characteristics_wsd_vod_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod], jsii.get(self, "contentCharacteristicsWsdVodInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePositionInput")
    def content_pre_position_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition], jsii.get(self, "contentPrePositionInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtectionInput")
    def content_targeting_protection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection], jsii.get(self, "contentTargetingProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="corsSupportInput")
    def cors_support_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport], jsii.get(self, "corsSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="customBehaviorInput")
    def custom_behavior_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior], jsii.get(self, "customBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamInput")
    def datastream_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream], jsii.get(self, "datastreamInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformationInput")
    def dcp_auth_hmac_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation], jsii.get(self, "dcpAuthHmacTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformationInput")
    def dcp_auth_regex_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation], jsii.get(self, "dcpAuthRegexTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformationInput")
    def dcp_auth_substring_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation], jsii.get(self, "dcpAuthSubstringTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractorInput")
    def dcp_auth_variable_extractor_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor], jsii.get(self, "dcpAuthVariableExtractorInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroupsInput")
    def dcp_default_authz_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups], jsii.get(self, "dcpDefaultAuthzGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelationsInput")
    def dcp_dev_relations_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations], jsii.get(self, "dcpDevRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpInput")
    def dcp_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp], jsii.get(self, "dcpInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuthInput")
    def dcp_real_time_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth], jsii.get(self, "dcpRealTimeAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceiptInput")
    def delivery_receipt_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt], jsii.get(self, "deliveryReceiptInput"))

    @builtins.property
    @jsii.member(jsii_name="denyAccessInput")
    def deny_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess], jsii.get(self, "denyAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccessInput")
    def deny_direct_failover_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess], jsii.get(self, "denyDirectFailoverAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheIdInput")
    def device_characteristic_cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId], jsii.get(self, "deviceCharacteristicCacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeaderInput")
    def device_characteristic_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader], jsii.get(self, "deviceCharacteristicHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefreshInput")
    def dns_async_refresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh], jsii.get(self, "dnsAsyncRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefreshInput")
    def dns_prefresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh], jsii.get(self, "dnsPrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocolInput")
    def downgrade_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol], jsii.get(self, "downgradeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarkerInput")
    def download_complete_marker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker], jsii.get(self, "downloadCompleteMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotificationInput")
    def download_notification_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification], jsii.get(self, "downloadNotificationInput"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCacheInput")
    def downstream_cache_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache], jsii.get(self, "downstreamCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationInput")
    def dynamic_throughtput_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization], jsii.get(self, "dynamicThroughtputOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverrideInput")
    def dynamic_throughtput_optimization_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "dynamicThroughtputOptimizationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUploadInput")
    def ecms_bulk_upload_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload], jsii.get(self, "ecmsBulkUploadInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabaseInput")
    def ecms_database_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase], jsii.get(self, "ecmsDatabaseInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatasetInput")
    def ecms_dataset_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset], jsii.get(self, "ecmsDatasetInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKeyInput")
    def ecms_object_key_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey], jsii.get(self, "ecmsObjectKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnectInput")
    def edge_connect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect], jsii.get(self, "edgeConnectInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvancedInput")
    def edge_load_balancing_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "edgeLoadBalancingAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenterInput")
    def edge_load_balancing_data_center_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "edgeLoadBalancingDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOriginInput")
    def edge_load_balancing_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "edgeLoadBalancingOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorizationInput")
    def edge_origin_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization], jsii.get(self, "edgeOriginAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirectorInput")
    def edge_redirector_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector], jsii.get(self, "edgeRedirectorInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeScapeInput")
    def edge_scape_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape], jsii.get(self, "edgeScapeInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludesInput")
    def edge_side_includes_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes], jsii.get(self, "edgeSideIncludesInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerInput")
    def edge_worker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker], jsii.get(self, "edgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocolInput")
    def enhanced_akamai_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol], jsii.get(self, "enhancedAkamaiProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetectionInput")
    def enhanced_proxy_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection], jsii.get(self, "enhancedProxyDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichmentInput")
    def epd_forward_header_enrichment_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "epdForwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="failActionInput")
    def fail_action_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction], jsii.get(self, "failActionInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibilityInput")
    def failover_bot_manager_feature_compatibility_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "failoverBotManagerFeatureCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidateInput")
    def fast_invalidate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate], jsii.get(self, "fastInvalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingInput")
    def first_party_marketing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing], jsii.get(self, "firstPartyMarketingInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlusInput")
    def first_party_marketing_plus_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus], jsii.get(self, "firstPartyMarketingPlusInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewriteInput")
    def forward_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite], jsii.get(self, "forwardRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OheaderInput")
    def g2_oheader_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader], jsii.get(self, "g2OheaderInput"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumberInput")
    def global_request_number_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber], jsii.get(self, "globalRequestNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCachingInput")
    def graphql_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching], jsii.get(self, "graphqlCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponseInput")
    def gzip_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse], jsii.get(self, "gzipResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvancedInput")
    def hd_data_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced], jsii.get(self, "hdDataAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="healthDetectionInput")
    def health_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection], jsii.get(self, "healthDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBindingInput")
    def hsaf_eip_binding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding], jsii.get(self, "hsafEipBindingInput"))

    @builtins.property
    @jsii.member(jsii_name="http2Input")
    def http2_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2], jsii.get(self, "http2Input"))

    @builtins.property
    @jsii.member(jsii_name="http3Input")
    def http3_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3], jsii.get(self, "http3Input"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurityInput")
    def http_strict_transport_security_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity], jsii.get(self, "httpStrictTransportSecurityInput"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgradeInput")
    def http_to_https_upgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade], jsii.get(self, "httpToHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManagerInput")
    def image_and_video_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager], jsii.get(self, "imageAndVideoManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerInput")
    def image_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager], jsii.get(self, "imageManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideoInput")
    def image_manager_video_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo], jsii.get(self, "imageManagerVideoInput"))

    @builtins.property
    @jsii.member(jsii_name="imOverrideInput")
    def im_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride], jsii.get(self, "imOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="includeInput")
    def include_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude], jsii.get(self, "includeInput"))

    @builtins.property
    @jsii.member(jsii_name="instantConfigInput")
    def instant_config_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig], jsii.get(self, "instantConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="instantInput")
    def instant_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant], jsii.get(self, "instantInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvancedInput")
    def large_file_optimization_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "largeFileOptimizationAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationInput")
    def large_file_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization], jsii.get(self, "largeFileOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRateInput")
    def limit_bit_rate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate], jsii.get(self, "limitBitRateInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomInput")
    def log_custom_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom], jsii.get(self, "logCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalizationInput")
    def manifest_personalization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization], jsii.get(self, "manifestPersonalizationInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestReroutingInput")
    def manifest_rerouting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting], jsii.get(self, "manifestReroutingInput"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPushInput")
    def manual_server_push_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush], jsii.get(self, "manualServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationInput")
    def media_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration], jsii.get(self, "mediaAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptoutInput")
    def media_acceleration_quic_optout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout], jsii.get(self, "mediaAccelerationQuicOptoutInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaClientInput")
    def media_client_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient], jsii.get(self, "mediaClientInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimizationInput")
    def media_file_retrieval_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization], jsii.get(self, "mediaFileRetrievalOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailoverInput")
    def media_origin_failover_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover], jsii.get(self, "mediaOriginFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataCachingInput")
    def metadata_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching], jsii.get(self, "metadataCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformanceInput")
    def mobile_sdk_performance_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance], jsii.get(self, "mobileSdkPerformanceInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeaderInput")
    def modify_incoming_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader], jsii.get(self, "modifyIncomingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeaderInput")
    def modify_incoming_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader], jsii.get(self, "modifyIncomingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeaderInput")
    def modify_outgoing_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader], jsii.get(self, "modifyOutgoingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeaderInput")
    def modify_outgoing_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader], jsii.get(self, "modifyOutgoingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeaderInput")
    def modify_via_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader], jsii.get(self, "modifyViaHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsInput")
    def origin_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics], jsii.get(self, "originCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsdInput")
    def origin_characteristics_wsd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd], jsii.get(self, "originCharacteristicsWsdInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethodInput")
    def origin_failure_recovery_method_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod], jsii.get(self, "originFailureRecoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicyInput")
    def origin_failure_recovery_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "originFailureRecoveryPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="originIpAclInput")
    def origin_ip_acl_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl], jsii.get(self, "originIpAclInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnectionInput")
    def persistent_client_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection"], jsii.get(self, "persistentClientConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnectionInput")
    def persistent_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection"], jsii.get(self, "persistentConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformationInput")
    def personally_identifiable_information_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation"], jsii.get(self, "personallyIdentifiableInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="phasedReleaseInput")
    def phased_release_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease"], jsii.get(self, "phasedReleaseInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectInput")
    def preconnect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect"], jsii.get(self, "preconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDeliveryInput")
    def predictive_content_delivery_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery"], jsii.get(self, "predictiveContentDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetchingInput")
    def predictive_prefetching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching"], jsii.get(self, "predictivePrefetchingInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchableInput")
    def prefetchable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable"], jsii.get(self, "prefetchableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch"], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCacheInput")
    def prefresh_cache_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache"], jsii.get(self, "prefreshCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="qualityInput")
    def quality_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality"], jsii.get(self, "qualityInput"))

    @builtins.property
    @jsii.member(jsii_name="quicBetaInput")
    def quic_beta_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta"], jsii.get(self, "quicBetaInput"))

    @builtins.property
    @jsii.member(jsii_name="randomSeekInput")
    def random_seek_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek"], jsii.get(self, "randomSeekInput"))

    @builtins.property
    @jsii.member(jsii_name="rapidInput")
    def rapid_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid"], jsii.get(self, "rapidInput"))

    @builtins.property
    @jsii.member(jsii_name="readTimeoutInput")
    def read_timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout"], jsii.get(self, "readTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReportingInput")
    def real_time_reporting_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting"], jsii.get(self, "realTimeReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring"], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect"], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectplusInput")
    def redirectplus_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus"], jsii.get(self, "redirectplusInput"))

    @builtins.property
    @jsii.member(jsii_name="refererCheckingInput")
    def referer_checking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking"], jsii.get(self, "refererCheckingInput"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameterInput")
    def remove_query_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter"], jsii.get(self, "removeQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="removeVaryInput")
    def remove_vary_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary"], jsii.get(self, "removeVaryInput"))

    @builtins.property
    @jsii.member(jsii_name="reportInput")
    def report_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport"], jsii.get(self, "reportInput"))

    @builtins.property
    @jsii.member(jsii_name="requestControlInput")
    def request_control_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl"], jsii.get(self, "requestControlInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarkerInput")
    def request_type_marker_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker"], jsii.get(self, "requestTypeMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibilityInput")
    def resource_optimizer_extended_compatibility_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility"], jsii.get(self, "resourceOptimizerExtendedCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerInput")
    def resource_optimizer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer"], jsii.get(self, "resourceOptimizerInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode"], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCookieInput")
    def response_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie"], jsii.get(self, "responseCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCachingInput")
    def restrict_object_caching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching"], jsii.get(self, "restrictObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatusInput")
    def return_cache_status_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus"], jsii.get(self, "returnCacheStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrlInput")
    def rewrite_url_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl"], jsii.get(self, "rewriteUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="rumCustomInput")
    def rum_custom_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom"], jsii.get(self, "rumCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitionsInput")
    def saas_definitions_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions"], jsii.get(self, "saasDefinitionsInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClientInput")
    def sales_force_commerce_cloud_client_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient"], jsii.get(self, "salesForceCommerceCloudClientInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeaderInput")
    def sales_force_commerce_cloud_provider_host_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader"], jsii.get(self, "salesForceCommerceCloudProviderHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderInput")
    def sales_force_commerce_cloud_provider_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider"], jsii.get(self, "salesForceCommerceCloudProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessingInput")
    def save_post_dca_processing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing"], jsii.get(self, "savePostDcaProcessingInput"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidationInput")
    def schedule_invalidation_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation"], jsii.get(self, "scheduleInvalidationInput"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagementInput")
    def script_management_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement"], jsii.get(self, "scriptManagementInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtectionInput")
    def segmented_content_protection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection"], jsii.get(self, "segmentedContentProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimizationInput")
    def segmented_media_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization"], jsii.get(self, "segmentedMediaOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetchInput")
    def segmented_media_streaming_prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch"], jsii.get(self, "segmentedMediaStreamingPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="setVariableInput")
    def set_variable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable"], jsii.get(self, "setVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCodeInput")
    def simulate_error_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode"], jsii.get(self, "simulateErrorCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="siteShieldInput")
    def site_shield_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield"], jsii.get(self, "siteShieldInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationInput")
    def standard_tls_migration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration"], jsii.get(self, "standardTlsMigrationInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverrideInput")
    def standard_tls_migration_override_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride"], jsii.get(self, "standardTlsMigrationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsingInput")
    def strict_header_parsing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing"], jsii.get(self, "strictHeaderParsingInput"))

    @builtins.property
    @jsii.member(jsii_name="subCustomerInput")
    def sub_customer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer"], jsii.get(self, "subCustomerInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute"], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimizationInput")
    def tcp_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization"], jsii.get(self, "tcpOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="teaLeafInput")
    def tea_leaf_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf"], jsii.get(self, "teaLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvancedInput")
    def tiered_distribution_advanced_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced"], jsii.get(self, "tieredDistributionAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomizationInput")
    def tiered_distribution_customization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization"], jsii.get(self, "tieredDistributionCustomizationInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionInput")
    def tiered_distribution_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution"], jsii.get(self, "tieredDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout"], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uidConfigurationInput")
    def uid_configuration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration"], jsii.get(self, "uidConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTagInput")
    def validate_entity_tag_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag"], jsii.get(self, "validateEntityTagInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcpInput")
    def verify_json_web_token_for_dcp_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp"], jsii.get(self, "verifyJsonWebTokenForDcpInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenInput")
    def verify_json_web_token_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken"], jsii.get(self, "verifyJsonWebTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorizationInput")
    def verify_token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization"], jsii.get(self, "verifyTokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomInput")
    def virtual_waiting_room_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom"], jsii.get(self, "virtualWaitingRoomInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkersInput")
    def virtual_waiting_room_with_edge_workers_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers"], jsii.get(self, "virtualWaitingRoomWithEdgeWorkersInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoInput")
    def visitor_prioritization_fifo_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo"], jsii.get(self, "visitorPrioritizationFifoInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandaloneInput")
    def visitor_prioritization_fifo_standalone_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone"], jsii.get(self, "visitorPrioritizationFifoStandaloneInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationInput")
    def visitor_prioritization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization"], jsii.get(self, "visitorPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="watermarkingInput")
    def watermarking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking"], jsii.get(self, "watermarkingInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall"], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="webdavInput")
    def webdav_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav"], jsii.get(self, "webdavInput"))

    @builtins.property
    @jsii.member(jsii_name="webSocketsInput")
    def web_sockets_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets"], jsii.get(self, "webSocketsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84e1b33033ef2ec73e3e61523cab09e46c33cd24282be52eddd799354d604e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ae5c59e9334d0c0142164535d23254e128a84398472dcb1c7c49c7a7ddc9ef)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the persistent connections behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bddedb29bef04a8a32df9fa9afc7d3638df2b4b3b7be725dc13fbeab66e886f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f83115b8dd2006de484c6108a23f7b4634eec29f717558d6e5083c40fa297c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155aa9e1658c4eda7c4f4fc87900c01cf9f0d639aa5c533bea60ae797e2a4ef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bdd7a147ebba7e636ffe3887c1160e43ba90c207d356360ded8a7266926143f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234f2ae8b59a2cf6b09ece0cd5d4b29d00282db80403bbd552da7f84ed52259a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378d0a45db7ecbf1ae7484e478d65f9a5fbcaa08a030dd254230411eb5eb0adc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed07acbb45c759ad6d2bf25b837529c113539dd8c796e15d6ca4d4732ff0ce1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048176bd3a379f062f7f48065aa27d376c51bd9c87babb1f8642ee8235386703)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables persistent connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes a persistent connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdceb75f16b59ba0a5986a83480ceb06ec6d181aa8689e07684bce4455c8cc79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3092dd5761ca6f6beb9a66d4d1f5aa91023aaed753a82fd7eb18ddd4425016f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f27b456d9740c87f4a7851c74ee068c6153c0a1c51046ba4f21a90de2f2315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abc11e7fdaaae70be2d21f93493cb608728726a45d2bebeb73e97ebd07f75008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ef835f77834bf54f49211b487969ea0c1f3cec744757db59340126462b9b95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffa1f36acc9aa39ddec5a48c5918aa98b93f4cc3afc3e4b7ce1c49149a9de3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__466288174bf0b82b6a49d800e41e87cc513a199bd07d9499777f2c6ba4038baf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f767910ec48c0be44379b731a7a4ab3151491d915d2c653040b457963efa5b14)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, marks content as personally identifiable information (PII).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecfd0a745cee5c2a7db3edb49c461ba384485c66a3b2e402bfdf7755bfa14320)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c17be7505b662628bd5e072da55c64b24d1c81980c24694082ba4dec477434d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3cacdc457e3ca16deefc5a50736672b415141036ccec4f14ef3da9fbbbd95c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc0970f565b5d25759997d8793ba9cbbfc30ceb2055d2c8d743cf01e51591961)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fefaf3e707dfe8f0117c80e0b67eaef1d4028cfc6927b78fc1fcfdaeaf8c3c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495efb04e0ccc62afa9a8d6cef60167c493ed0b052415b31d569e29bea06ee40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "failover_duration": "failoverDuration",
        "failover_enabled": "failoverEnabled",
        "failover_response_code": "failoverResponseCode",
        "failover_title": "failoverTitle",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_expiration_date": "populationExpirationDate",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0489dba73eb47bc1dcac05ce31dc161d744774106f3ef92cca2c2f8fbba4faab)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_duration", value=failover_duration, expected_type=type_hints["failover_duration"])
            check_type(argname="argument failover_enabled", value=failover_enabled, expected_type=type_hints["failover_enabled"])
            check_type(argname="argument failover_response_code", value=failover_response_code, expected_type=type_hints["failover_response_code"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_expiration_date", value=population_expiration_date, expected_type=type_hints["population_expiration_date"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_duration is not None:
            self._values["failover_duration"] = failover_duration
        if failover_enabled is not None:
            self._values["failover_enabled"] = failover_enabled
        if failover_response_code is not None:
            self._values["failover_response_code"] = failover_response_code
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_expiration_date is not None:
            self._values["population_expiration_date"] = population_expiration_date
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Phased Release Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected.

        Set the value to ``0`` to immediately request the alternate origin upon failure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        '''
        result = self._values.get("failover_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        '''
        result = self._values.get("failover_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_response_code(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the set of failure codes that initiate the failover response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        '''
        result = self._values.get("failover_response_code")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Phased Release policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Select when to assign a cookie to the population of users the Cloudlet defines.

        If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies the date and time when membership expires, and the browser no longer sends the cookie.

        Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        '''
        result = self._values.get("population_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70f75436ba7d588983e373862046c774e48450b29b7e120b6a39bab09a6a86ac)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791b3fbef1dbb27f0c89f0daa3b91d915d05c01f696994695e7ccb8b70f4338b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bcc225a206dd0174b4e2148de41fcfd32e43840253885d8ecee1cc435209d7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbae01f619fc69634c89c6b0c696f9342d28810cabb41f1a0bda1b0e7eea1980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce03865db6b6d37da92fbefdb8ddf8a1fd0ac8d655cbda4bf97aff31b521beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220ee67f5e1ef916276b7d279285886a833bda14ab5aec71312c33eff48c3c49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverDuration")
    def reset_failover_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverDuration", []))

    @jsii.member(jsii_name="resetFailoverEnabled")
    def reset_failover_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverEnabled", []))

    @jsii.member(jsii_name="resetFailoverResponseCode")
    def reset_failover_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverResponseCode", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationExpirationDate")
    def reset_population_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationExpirationDate", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverDurationInput")
    def failover_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverEnabledInput")
    def failover_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failoverEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCodeInput")
    def failover_response_code_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDateInput")
    def population_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50cfbc27b1eb96f0f0bf1666e60a0752d7ae5fe433beb2c67ce23acfaff1601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02ae77039dbb9e3939607b4c1b091cd84dbb7e7b48a80b87cae357640eee3b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverDuration")
    def failover_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverDuration"))

    @failover_duration.setter
    def failover_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b567172fa87d0904b4ce506fd7b61ed191ac3d32ff51bc9f59df160323cade1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverDuration", value)

    @builtins.property
    @jsii.member(jsii_name="failoverEnabled")
    def failover_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failoverEnabled"))

    @failover_enabled.setter
    def failover_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12eeb43689b447fb51b66a42212321bb6d29a775b9036f1207c33f51eaf099e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCode")
    def failover_response_code(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverResponseCode"))

    @failover_response_code.setter
    def failover_response_code(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c31464b3d32702c61af627827ead49d5619ca8834f4541807b0b0b3432cb09db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4042afb2bda618fc9b15b7060e19f26712ba5d93aaec7a7aa97b6cbaa7d40f82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4549558fabc38318bc7af428b8110f11aad4845d9c9dfec61e85ef8b1caa7442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7f01d831a778d8a12a76231203f6cff6cf5cc413d5ac66c675d6424fa30bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fcc52cc1dcaee5cdd7a269847039be83b27ef104845abd5e4ed8e281fc40d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a22147b81c27307fc08c10a5b821d7eda18135425fdb3f10670e322c8d8e95c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d778fdf326d0502fc525a3e9c50ce057c53169ba951b7cc39681f968b6a78df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDate")
    def population_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationExpirationDate"))

    @population_expiration_date.setter
    def population_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03689bd4de3228059fce806863c84fe0c3f1268c539d79b086cd8680aad3323d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a694a529005de13a8cf44573932732d60504d45beb47fc8fc16d73f19e33ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c176ecdba8715142a577d0ca04d2324486c122837e4c88610acc97f270b768a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ea398a09c707da5b676468ed6374bb9245e23214cbebd6254c141f2c51baad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3472bb1e665cbf2b8e000f8f5aecb5a64c92e89fe3389a8633f2566f0bc618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f582af9a8bd3cb139ab29156a633b9ecaed186591e0dff9b0f7a39fdfaa732dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "preconnectlist": "preconnectlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e320b442f27f71ae46dbd0c0570e83d1bc299c83ed0ad0ea81eb03569c8704)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preconnectlist", value=preconnectlist, expected_type=type_hints["preconnectlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if preconnectlist is not None:
            self._values["preconnectlist"] = preconnectlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preconnectlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of hostnames to which to preconnect over HTTP2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        '''
        result = self._values.get("preconnectlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f512ef8eee3e9f0e5869f75829b4d0f2adfcb3fe86799e9f07da019ac87cbd7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreconnectlist")
    def reset_preconnectlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnectlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectlistInput")
    def preconnectlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "preconnectlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b0235493e6db727bb264cbb1cbd8eee7f3e5312ce381fed560930a816db7d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preconnectlist")
    def preconnectlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "preconnectlist"))

    @preconnectlist.setter
    def preconnectlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70605aefd8b3a5c6842f748cd9ed8eabe5ad2205868b0ac57f5b43dec7e10a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preconnectlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513402d7e62e9a02d4d4b378289697e3c5fcf58ee60cb162f96d0fcdeac15297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53fb422a143140f2a433cec3d13abb66aad690d023224663b3e72e2b04d441c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66747a40514be41f2ca7016d314a34ce9b911cdf78e33913f0a86bbc3c23af3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7ea4327920af5cc42607d6227ee377dcbbbeb84f791cbda07229c2a88b0141)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive content delivery behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f8549379ce085f3533ebddda4aeff49d9f216db277851c7e9908ace2eed2210)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a753c08466a9956f973e8a2967b419ba79fa9d33553535645a55f41e7ad869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c8936e45f9db58c5beccc76b0969406648ea7807c74b8632f5a6d8c299bd2b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d668972bb246ac4e06f0191f0ae34d887a56c44430b525a299e93a6fa3e12315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdfd2e0e34777ba6ae967c73408615938b1c63c643b866d5016bb5c677ea4bba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03d38de49d695134553d9731dbf901bc2060a74a8947c26e70facabf6f678824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching",
    jsii_struct_bases=[],
    name_mapping={
        "accuracy_target": "accuracyTarget",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching:
    def __init__(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3cf4e5142c82b647a54067dede69e7f218df71a8ed44e4457fe60963adc8c39)
            check_type(argname="argument accuracy_target", value=accuracy_target, expected_type=type_hints["accuracy_target"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accuracy_target is not None:
            self._values["accuracy_target"] = accuracy_target
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accuracy_target(self) -> typing.Optional[builtins.str]:
        '''The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        '''
        result = self._values.get("accuracy_target")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive prefetching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca487930e9f01054485ec0573589fa13f663d12b195142b8f138042ab05b0381)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccuracyTarget")
    def reset_accuracy_target(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccuracyTarget", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accuracyTargetInput")
    def accuracy_target_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accuracyTargetInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accuracyTarget")
    def accuracy_target(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accuracyTarget"))

    @accuracy_target.setter
    def accuracy_target(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0502d1004067fc928584ca351ac1c6ac9e88eb6766da712e572f5f1e8912125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accuracyTarget", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e72688e6967c43c62ba62c17edc1194967fab272c86be6650b07ec56db885d03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc16dc99e84786933a15ad5e2fd0f65f464e17ace506d5375904efdfdeb1dfaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2831af1fbec70b7ea8632df123de73fc06ad7f3d19902ef27066eef3f0507c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0715f5e5b64a0f028648f7913ff0999232a5ee695524e969a79cad8d2b85eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d567097f2299f2faf6dda164df98d7f2ccc1bc716ad90532199069352db0a22b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e883a7eb43424258f350b504200d524b7f2af16c8568f60e9ad430ab42f91b29)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies prefetching behavior when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775d6c1c47719e7501b9fd4eb65c1c8ed0ea5492a2e6c46d57f0bba269189106)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b8c8ca3cdf20e84cad4b276583cd8fcca37d45a299d50b0198115b104139e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba7be9cd2a6fe49b8dc0a3e02ba0734b55e1e719d737aa0ea71e08be5913cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087dbb2bd254cd970e5a0605397dab823e3053c3b164465d2dc6b2db2c0e112b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cce9dda6d81849d540ba016ef3c12e35267164668573d9054bb4c9f24e02317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e64e987fcdbcfb9086eb57ad59d0e399501b42c7718278a78f004682bbb8af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a866d480166f7656a4f58d95e57e33152ff85ffce92ee744157b640d0236c502)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows matching content to prefetch when referenced on a requested parent page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68432457f4f9e96e70e30aa83cb7c4e5ae8fbc2944df0326aabb282712140eee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b3fe570008a2701ff52e3e6ee4b0ff15494dc912c1b74c3ac9d8224a6adeb60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08c21e1e9417bc39b169d0d1654ff5c3f47b5c282bdbb14d64c25cbb60a4b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aa5fc09918317d68c6d51a60326c864c79c5b43accd20ae21aa3928e67841ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5113adee18f5d280d1ff2f3e38a22f3513d96faed267717af64c7a4c1a57d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__859bc62a298668bcc88a0277218c7d98b533c20680563319f67b978f5eee5ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "prefreshval": "prefreshval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658cc24d2b4ee82ee589ac053e731b30e1ddc7c6f030c497d34873c866a3bf9b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefreshval", value=prefreshval, expected_type=type_hints["prefreshval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if prefreshval is not None:
            self._values["prefreshval"] = prefreshval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cache prefreshing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefreshval(self) -> typing.Optional[jsii.Number]:
        '''Specifies when the prefresh occurs as a percentage of the TTL.

        For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        '''
        result = self._values.get("prefreshval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2576c27d219006049bf8682f65278f9712fa865126a14abc09b9ed33e93fba4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefreshval")
    def reset_prefreshval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshvalInput")
    def prefreshval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefreshvalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3183ac33f8f25cc0b99bea194c6b5604ca3dae1a49baead37c9d89392da5e028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d86d8b6d4c0339a1730779b25f4cd8c3d983b05167054c9542970fad1d311a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefreshval")
    def prefreshval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefreshval"))

    @prefreshval.setter
    def prefreshval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4f5c6f98eb4d53b7fc3a5b6e341220142193141538e48748cd0121b1e8194b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefreshval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425afe9bfa38a5affdf0e29ecbf069c527e023de5167098245379299ef75eec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4abfef293dd1521799961c7ae6c56a25fda076b61afdde8a3b2d20419f89421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0adabd11ef13e22b3c0bde3b6b11519741316a52c055fb9bf3a0c5a6c80d6b09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality",
    jsii_struct_bases=[],
    name_mapping={
        "audience_settings": "audienceSettings",
        "catalog_size": "catalogSize",
        "content_settings": "contentSettings",
        "content_type": "contentType",
        "country": "country",
        "delivery_format": "deliveryFormat",
        "delivery_type": "deliveryType",
        "download_type": "downloadType",
        "end_user_location": "endUserLocation",
        "locked": "locked",
        "maximum_concurrent_users": "maximumConcurrentUsers",
        "object_size": "objectSize",
        "optimize_for": "optimizeFor",
        "origin_settings": "originSettings",
        "popularity_distribution": "popularityDistribution",
        "refresh_rate": "refreshRate",
        "segment_duration": "segmentDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality:
    def __init__(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce3bd40437c893f031f605cf5a054ea7f848076793f6c433e16be9cf30fa081)
            check_type(argname="argument audience_settings", value=audience_settings, expected_type=type_hints["audience_settings"])
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_settings", value=content_settings, expected_type=type_hints["content_settings"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument delivery_format", value=delivery_format, expected_type=type_hints["delivery_format"])
            check_type(argname="argument delivery_type", value=delivery_type, expected_type=type_hints["delivery_type"])
            check_type(argname="argument download_type", value=download_type, expected_type=type_hints["download_type"])
            check_type(argname="argument end_user_location", value=end_user_location, expected_type=type_hints["end_user_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_concurrent_users", value=maximum_concurrent_users, expected_type=type_hints["maximum_concurrent_users"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_for", value=optimize_for, expected_type=type_hints["optimize_for"])
            check_type(argname="argument origin_settings", value=origin_settings, expected_type=type_hints["origin_settings"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument refresh_rate", value=refresh_rate, expected_type=type_hints["refresh_rate"])
            check_type(argname="argument segment_duration", value=segment_duration, expected_type=type_hints["segment_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if audience_settings is not None:
            self._values["audience_settings"] = audience_settings
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_settings is not None:
            self._values["content_settings"] = content_settings
        if content_type is not None:
            self._values["content_type"] = content_type
        if country is not None:
            self._values["country"] = country
        if delivery_format is not None:
            self._values["delivery_format"] = delivery_format
        if delivery_type is not None:
            self._values["delivery_type"] = delivery_type
        if download_type is not None:
            self._values["download_type"] = download_type
        if end_user_location is not None:
            self._values["end_user_location"] = end_user_location
        if locked is not None:
            self._values["locked"] = locked
        if maximum_concurrent_users is not None:
            self._values["maximum_concurrent_users"] = maximum_concurrent_users
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_for is not None:
            self._values["optimize_for"] = optimize_for
        if origin_settings is not None:
            self._values["origin_settings"] = origin_settings
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if refresh_rate is not None:
            self._values["refresh_rate"] = refresh_rate
        if segment_duration is not None:
            self._values["segment_duration"] = segment_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def audience_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        '''
        result = self._values.get("audience_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.'''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        '''
        result = self._values.get("content_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.'''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.'''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.'''
        result = self._values.get("delivery_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.'''
        result = self._values.get("delivery_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def download_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.'''
        result = self._values.get("download_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_user_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.'''
        result = self._values.get("end_user_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_concurrent_users(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.'''
        result = self._values.get("maximum_concurrent_users")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.'''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_for(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.'''
        result = self._values.get("optimize_for")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        '''
        result = self._values.get("origin_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.'''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def refresh_rate(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.'''
        result = self._values.get("refresh_rate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.'''
        result = self._values.get("segment_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de1a7f7ecbd7c7c902c87b25405e71439ce787e1c301df3d79628f885fea52e6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAudienceSettings")
    def reset_audience_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSettings", []))

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentSettings")
    def reset_content_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentSettings", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetDeliveryFormat")
    def reset_delivery_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryFormat", []))

    @jsii.member(jsii_name="resetDeliveryType")
    def reset_delivery_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryType", []))

    @jsii.member(jsii_name="resetDownloadType")
    def reset_download_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadType", []))

    @jsii.member(jsii_name="resetEndUserLocation")
    def reset_end_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndUserLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumConcurrentUsers")
    def reset_maximum_concurrent_users(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumConcurrentUsers", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeFor")
    def reset_optimize_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeFor", []))

    @jsii.member(jsii_name="resetOriginSettings")
    def reset_origin_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSettings", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetRefreshRate")
    def reset_refresh_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshRate", []))

    @jsii.member(jsii_name="resetSegmentDuration")
    def reset_segment_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="audienceSettingsInput")
    def audience_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "audienceSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentSettingsInput")
    def content_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryFormatInput")
    def delivery_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryTypeInput")
    def delivery_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadTypeInput")
    def download_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="endUserLocationInput")
    def end_user_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endUserLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsersInput")
    def maximum_concurrent_users_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumConcurrentUsersInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeForInput")
    def optimize_for_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optimizeForInput"))

    @builtins.property
    @jsii.member(jsii_name="originSettingsInput")
    def origin_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshRateInput")
    def refresh_rate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshRateInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationInput")
    def segment_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSettings")
    def audience_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "audienceSettings"))

    @audience_settings.setter
    def audience_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ec0f14794c6ad9ef66a92dbe5cab9368e6b78ea619c69217ac94136b163c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "audienceSettings", value)

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb3b49e1541e06d989a8c68052d745e68870f3d1362522053b49ff5bb1978320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentSettings")
    def content_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentSettings"))

    @content_settings.setter
    def content_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc13fe045ecb06253527938d33714ce4dbe49ae79ccdca300fb741986d13121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentSettings", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de35dedd917bd845541377c9b81cc5839d3de88f1c601d81390558dac3f4b0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547a4a79e873d05d40cb61a426735e519f86b882a80c2785e5c27e20a86fe71b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryFormat")
    def delivery_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryFormat"))

    @delivery_format.setter
    def delivery_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84d6fe70748ba2be10c652c84e62ac61bcd2ae21f107c47f2d6b1e767d7e516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryFormat", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryType")
    def delivery_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryType"))

    @delivery_type.setter
    def delivery_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91bcf8bab17b5c27c273a33bef964fe009d36dabac43356396434d27c2931ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryType", value)

    @builtins.property
    @jsii.member(jsii_name="downloadType")
    def download_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadType"))

    @download_type.setter
    def download_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd3a9eb4198d73ec6ea8d909e51f21331511afedf238ff58692db9cfdb9ad5eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadType", value)

    @builtins.property
    @jsii.member(jsii_name="endUserLocation")
    def end_user_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endUserLocation"))

    @end_user_location.setter
    def end_user_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3744730e24486b9accc8c59b5f9a0b8ecfb7113cb5472e91590868a7ca71cf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endUserLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d9ed343424bbb011dd5c176f4ee1659e138c9e47e38d62332dfc6ab591f236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsers")
    def maximum_concurrent_users(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumConcurrentUsers"))

    @maximum_concurrent_users.setter
    def maximum_concurrent_users(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cdb289db29f0957a5f186ba165f8cdc27352edea9217e5aefd30b4dbdc91209)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumConcurrentUsers", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d953f55afb8e583c3b2a8ddab3df3839a506d8a8b5e1e5d73c45be2927cdfd5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeFor")
    def optimize_for(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optimizeFor"))

    @optimize_for.setter
    def optimize_for(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f48cfbe563e82c478a0bde24058b4a9ce82fa4984857e4f7e36c2db1596e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeFor", value)

    @builtins.property
    @jsii.member(jsii_name="originSettings")
    def origin_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originSettings"))

    @origin_settings.setter
    def origin_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d343034d4ee65504a658c2f3e1f42f374b5c394ae435a6b93dc49e0c97389250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSettings", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb23a14c3bf17895853e425cc65047c38be06043e70972e83914176449356657)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="refreshRate")
    def refresh_rate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshRate"))

    @refresh_rate.setter
    def refresh_rate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cf53f6ee271d44941ef1d8123ef7bd0430ff4a8c8ea18bffc471c5a3ae7516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshRate", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDuration")
    def segment_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDuration"))

    @segment_duration.setter
    def segment_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a49f306a8d9158acd3a681abdaad4c22063f54e89cd9d33e76ef04bed2359924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dace6301cb0c3e8d516eca44a5daa9bce616bfbd3a0f114ab25e52a190ab0147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1715ad73b5e0df2478dbbf46ab42cb5cc3e5f70e6c8ae030386bf7b3ec87ffde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f741de7b68b85e6592b5612d44bd18cb8e9acf81a04f859cb50bcff177303af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "quic_offer_percentage": "quicOfferPercentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d504ebf651a8f4975de590fe674d43e659f3ca7ac1ddc796915a06d518eeaeb4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument quic_offer_percentage", value=quic_offer_percentage, expected_type=type_hints["quic_offer_percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if quic_offer_percentage is not None:
            self._values["quic_offer_percentage"] = quic_offer_percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables QUIC support.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def quic_offer_percentage(self) -> typing.Optional[jsii.Number]:
        '''The percentage of responses for which to allow QUIC sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        '''
        result = self._values.get("quic_offer_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f5057a5e43141ab48d13c203870ac62fd848b361aaca4c108ab6e34aa48599)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQuicOfferPercentage")
    def reset_quic_offer_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicOfferPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentageInput")
    def quic_offer_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "quicOfferPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ae88d53542e29c9e5b9704fc0bccb2fa7dae7a91759cdf2605ab745d015464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04109243b2917784609c6e4066920e2a53768eca972a9ad0684a14ed4f3d0ea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentage")
    def quic_offer_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "quicOfferPercentage"))

    @quic_offer_percentage.setter
    def quic_offer_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__032d971eebf24ae25d4b6299d5d5ed538a4c1f260e72193e3b84495ee944c33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "quicOfferPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035d4c6d4990a4339716ad794402e6f1a2fdba073143253392402126df7c1e36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21ac3bfdecb5efaca4d84262cb3e621955dd3316e05522c2bcab5e3dcafb32f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8abf52078ada2c7883cfe50a80d6fa7a13f34bf6a6c81b96bd28de513c27ce9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek",
    jsii_struct_bases=[],
    name_mapping={
        "flv": "flv",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "mp4": "mp4",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek:
    def __init__(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c217cedfb2bd6c4949839cea3258e1bc47dae00ed10704acf3aa77a8701f30a5)
            check_type(argname="argument flv", value=flv, expected_type=type_hints["flv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument mp4", value=mp4, expected_type=type_hints["mp4"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if flv is not None:
            self._values["flv"] = flv
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if mp4 is not None:
            self._values["mp4"] = mp4
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def flv(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in FLV files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        '''
        result = self._values.get("flv")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mp4(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in MP4 files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        '''
        result = self._values.get("mp4")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d63f3a291c1f2606dd6f3e71ad791df992cb11577dfb61af67b782dd36e32d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFlv")
    def reset_flv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFlv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMp4")
    def reset_mp4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMp4", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="flvInput")
    def flv_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "flvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="mp4Input")
    def mp4_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mp4Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="flv")
    def flv(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "flv"))

    @flv.setter
    def flv(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba3ff715823665becc50a724052c73dba0ab850cc4dbb129f13f085669bf0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "flv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb652c0943b376630f7e21fd405ed1929268bab1e045a578373ee8bc03655d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8ee079d5fced4e390a6d99ed642e889a80e88280da3f55953eedb427a3a26fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="mp4")
    def mp4(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mp4"))

    @mp4.setter
    def mp4(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b561cd9a4fffee07ffff4c8872f48033ae8e55a9f8a9608de2e64e828cb31eb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mp4", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685baf70016d5ad722cca0291943d9e7e61f44e98433982bf7a781ff6c54fbb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217b9aa44f6825a643308d814251bcd73f9c1d0d33ee4ea7377e3057e77f3c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d617c75a652db490d4311fa73b2dbe7cde77715315f2baea568e5ffa74115cdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb2129c6210e84431447d058c7b05804d75b8f6238c6e1736eef53a3ed8b7e4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables API Gateway for the current set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1655053df45db3d9729502fdf95ce2d50e53445661b7e1e4fb85817459d5e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bef0529c7c82f981936d3e56753245f9227782002f4b55b9185c1e887877701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b48e15bfac11591322b3319be86382fb3d87011f4ea837f06abb7b0c2d69f3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b46e4324d19daf721cd79ea2b48213ceaea094d98aa3f75082df6d66afd2509a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51969409e46db258afb08075af025447134d2a0bcfdcb9aaf2a31aeb4033c2b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3c7d5345519c0b3e8ae4078c5956bf25878a655173e3509bba1cf6ff3aac2ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8288353b4b00a31b0eb7043bf7de5310f89eeabeab3bbefc3378b2ad736c00b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271d7314521b64a0ab592312b58c5b1052adb1bc7ac353b806d41c2ff27b1c3e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d469316ea6be6f6b4270ba37a9ad2542560b6accec8f3d20651e66562f0bb997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7564516f39ba5c6bc20d234a40f0466476106e227a4c51fb62f21de02ee4841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab8e740b05a39e5e1ad8b788863a168adcc850ec3dbc2fd8f8f6eba41b27ddc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__537c4903b4b505c03b1add2163ffaf3d295c5cccfe76da65ec0861f3e69fc11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965c2e992702d3c43a0f4236a75890fc74141a83fa7bde101418f662b9cc2ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "beacon_sampling_percentage": "beaconSamplingPercentage",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93978c9f4adefa1ecc0cb2aff876f746732cbb98a047fd969079c0ad60a63234)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument beacon_sampling_percentage", value=beacon_sampling_percentage, expected_type=type_hints["beacon_sampling_percentage"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if beacon_sampling_percentage is not None:
            self._values["beacon_sampling_percentage"] = beacon_sampling_percentage
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables advanced options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def beacon_sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage for sampling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        '''
        result = self._values.get("beacon_sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables reports on delivery of cloud hosted content at near real-time latencies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b72f2933e01b1abb71d6a5ee7bd71b55a36808b0dd3e92cd4788848bd093027e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetBeaconSamplingPercentage")
    def reset_beacon_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconSamplingPercentage", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentageInput")
    def beacon_sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "beaconSamplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__321cd9cf93bfd4fbcae8b65d5abc1ab8d0d347a6471fb6a5f6f3ae97c9456ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentage")
    def beacon_sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "beaconSamplingPercentage"))

    @beacon_sampling_percentage.setter
    def beacon_sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__862322f2ece029aff1b2802fd4b6bd5713825e4f25764fb5d8313fe72cfbd9d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconSamplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c150ec04588b5409be125c5f2cbd3833d7ce47a69110ec7b447a53d233bf5cb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f83c3c79bab477618a5b0f3bc94af1f096f950eb0185ebc01ac34e81923027f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d65343e074dd5f35a5c75c812ec65c19f635caa269ef4309e29c6c4797c60ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7ae3f7a25c22ef1135e535d4297dd8a679d75f11d91f4b7a20e63c878dd5cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c4c3f0f38c6781f2334420e7962a06e5863d3bb00270ed41542996805fb745)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58d5aaa39679809d89c897e563c60a72484d257e2202adc1727f01675c75ece4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates real-use monitoring.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29af131aa2a6aa37a513dc18f5aba33cdaf8db7a6e56285c387b073dbdf81cbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea6a600b9a831dddd24187e7be3777979cead339fffbde29fb04ac80b2e70be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b20a4a060e6dc54c3ae558d035223d89dbc9761476de6ea16cc8e2027aaf3b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af84311e247910acd8ef20dc5f2f9ed646eab6c1d3d78ee8c23dfdd62e6178be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__505351715f5bfe0704c0f6a5bdd415d42819a822abb2a03c5222f8d5a121f56e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb54d88a7956f1d36cfc6b3ea75acac7a65d1d4ff13e992c8736a86d740d38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "destination_hostname": "destinationHostname",
        "destination_hostname_other": "destinationHostnameOther",
        "destination_hostname_sibling": "destinationHostnameSibling",
        "destination_hostname_subdomain": "destinationHostnameSubdomain",
        "destination_path": "destinationPath",
        "destination_path_other": "destinationPathOther",
        "destination_path_prefix": "destinationPathPrefix",
        "destination_path_suffix": "destinationPathSuffix",
        "destination_path_suffix_status": "destinationPathSuffixStatus",
        "destination_protocol": "destinationProtocol",
        "locked": "locked",
        "mobile_default_choice": "mobileDefaultChoice",
        "query_string": "queryString",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect:
    def __init__(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a939c3ea78d55310ec13d5d5cef8c5a9d8e5402fa6288226e4c87ceda9e5ffee)
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_hostname_other", value=destination_hostname_other, expected_type=type_hints["destination_hostname_other"])
            check_type(argname="argument destination_hostname_sibling", value=destination_hostname_sibling, expected_type=type_hints["destination_hostname_sibling"])
            check_type(argname="argument destination_hostname_subdomain", value=destination_hostname_subdomain, expected_type=type_hints["destination_hostname_subdomain"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument destination_path_other", value=destination_path_other, expected_type=type_hints["destination_path_other"])
            check_type(argname="argument destination_path_prefix", value=destination_path_prefix, expected_type=type_hints["destination_path_prefix"])
            check_type(argname="argument destination_path_suffix", value=destination_path_suffix, expected_type=type_hints["destination_path_suffix"])
            check_type(argname="argument destination_path_suffix_status", value=destination_path_suffix_status, expected_type=type_hints["destination_path_suffix_status"])
            check_type(argname="argument destination_protocol", value=destination_protocol, expected_type=type_hints["destination_protocol"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mobile_default_choice", value=mobile_default_choice, expected_type=type_hints["mobile_default_choice"])
            check_type(argname="argument query_string", value=query_string, expected_type=type_hints["query_string"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_hostname_other is not None:
            self._values["destination_hostname_other"] = destination_hostname_other
        if destination_hostname_sibling is not None:
            self._values["destination_hostname_sibling"] = destination_hostname_sibling
        if destination_hostname_subdomain is not None:
            self._values["destination_hostname_subdomain"] = destination_hostname_subdomain
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if destination_path_other is not None:
            self._values["destination_path_other"] = destination_path_other
        if destination_path_prefix is not None:
            self._values["destination_path_prefix"] = destination_path_prefix
        if destination_path_suffix is not None:
            self._values["destination_path_suffix"] = destination_path_suffix
        if destination_path_suffix_status is not None:
            self._values["destination_path_suffix_status"] = destination_path_suffix_status
        if destination_protocol is not None:
            self._values["destination_protocol"] = destination_protocol
        if locked is not None:
            self._values["locked"] = locked
        if mobile_default_choice is not None:
            self._values["mobile_default_choice"] = mobile_default_choice
        if query_string is not None:
            self._values["query_string"] = query_string
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested hostname, independently from the pathname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_other(self) -> typing.Optional[builtins.str]:
        '''Specifies the full hostname with which to replace the current hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        '''
        result = self._values.get("destination_hostname_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_sibling(self) -> typing.Optional[builtins.str]:
        '''Specifies the subdomain with which to replace to the current hostname's leftmost subdomain.

        For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        '''
        result = self._values.get("destination_hostname_sibling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_subdomain(self) -> typing.Optional[builtins.str]:
        '''Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        '''
        result = self._values.get("destination_hostname_subdomain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested pathname, independently from the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_other(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        '''
        result = self._values.get("destination_path_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_prefix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path.

        For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        '''
        result = self._values.get("destination_path_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        '''
        result = self._values.get("destination_path_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix_status(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        '''
        result = self._values.get("destination_path_suffix_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_protocol(self) -> typing.Optional[builtins.str]:
        '''Choose the protocol for the redirect URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        '''
        result = self._values.get("destination_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mobile_default_choice(self) -> typing.Optional[builtins.str]:
        '''Either specify a default response for mobile browsers, or customize your own.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        '''
        result = self._values.get("mobile_default_choice")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_string(self) -> typing.Optional[builtins.str]:
        '''When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL.

        Otherwise set this to ``IGNORE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        '''
        result = self._values.get("query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Specify the redirect's response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ac014147cb4b25995059e083af893a9a5d76fefb776db6f979005a9b6b856c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationHostnameOther")
    def reset_destination_hostname_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameOther", []))

    @jsii.member(jsii_name="resetDestinationHostnameSibling")
    def reset_destination_hostname_sibling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSibling", []))

    @jsii.member(jsii_name="resetDestinationHostnameSubdomain")
    def reset_destination_hostname_subdomain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSubdomain", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetDestinationPathOther")
    def reset_destination_path_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathOther", []))

    @jsii.member(jsii_name="resetDestinationPathPrefix")
    def reset_destination_path_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathPrefix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffix")
    def reset_destination_path_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffixStatus")
    def reset_destination_path_suffix_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffixStatus", []))

    @jsii.member(jsii_name="resetDestinationProtocol")
    def reset_destination_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationProtocol", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMobileDefaultChoice")
    def reset_mobile_default_choice(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileDefaultChoice", []))

    @jsii.member(jsii_name="resetQueryString")
    def reset_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryString", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOtherInput")
    def destination_hostname_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSiblingInput")
    def destination_hostname_sibling_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSiblingInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomainInput")
    def destination_hostname_subdomain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSubdomainInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathOtherInput")
    def destination_path_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefixInput")
    def destination_path_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixInput")
    def destination_path_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatusInput")
    def destination_path_suffix_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationProtocolInput")
    def destination_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoiceInput")
    def mobile_default_choice_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mobileDefaultChoiceInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringInput")
    def query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b371840cbe76336303b2a3b49ed90c3bc70c4d6e5494049d623f98920ca76b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOther")
    def destination_hostname_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameOther"))

    @destination_hostname_other.setter
    def destination_hostname_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd5d18653d02b54c3280475449158820a2d1a193a9e30c25d1795d99d4cc490b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSibling")
    def destination_hostname_sibling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSibling"))

    @destination_hostname_sibling.setter
    def destination_hostname_sibling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b88f05dda6cccfbcdbc328c12bf3e26608e121e124653f3f6ca5afb5dbe1465c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSibling", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomain")
    def destination_hostname_subdomain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSubdomain"))

    @destination_hostname_subdomain.setter
    def destination_hostname_subdomain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a4c2bd7284ef1dc18d390e12e2dffe8e52a1592a675d84920eb599bf00bb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSubdomain", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f9a4968de431aceb3b7f33fac71829f3e20f58ca92481e3444e1a8d25d6690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathOther")
    def destination_path_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathOther"))

    @destination_path_other.setter
    def destination_path_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2684e8ccb6e6c62e0f1b76bcfd69481126a58419cb82c42867caa0236dbc2e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefix")
    def destination_path_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathPrefix"))

    @destination_path_prefix.setter
    def destination_path_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__676fbf8a29a9864b10ed148e4d04c6ddf0f259253797a490bc6a2a030331630a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffix")
    def destination_path_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffix"))

    @destination_path_suffix.setter
    def destination_path_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef26bdce3b8706fbae8a377b2da1fde203db7149e5bf0442a47a182b0559a9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatus")
    def destination_path_suffix_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffixStatus"))

    @destination_path_suffix_status.setter
    def destination_path_suffix_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c473a97e32996032b2ef6b2bc6b723be9700b37904521602ec7b51f76cb804f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffixStatus", value)

    @builtins.property
    @jsii.member(jsii_name="destinationProtocol")
    def destination_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationProtocol"))

    @destination_protocol.setter
    def destination_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99537fa5c449b0f99a8b3e09a214dcfa44bf150c67e39fb15c247e7c61b6860c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd24b09126bafe34f86c48a9366f02e2493ec1fed938af67fb6097255337aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoice")
    def mobile_default_choice(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mobileDefaultChoice"))

    @mobile_default_choice.setter
    def mobile_default_choice(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cffd874f49465f8b88606c5481f6f15efec8b2dbcc9aaa80c0e58777343d16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mobileDefaultChoice", value)

    @builtins.property
    @jsii.member(jsii_name="queryString")
    def query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryString"))

    @query_string.setter
    def query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6c171c878578561d97ff6950b1335e05d9631d1dfa922ca76ab607b7dda038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryString", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4497b5e226befedfc13839a60e876442286dfb754bb38d85257ffcf7faf00e89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ba9aa3d524aa62072503c8abe342001020e28ad9a6916cfffc9948e02f107d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8001e2d4f23afcbcccb2f23d9e06d377502506e3b6eee60dcbb65ccf70c70b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2307210f88be5d361bc343b104b643e89eb00dd929a2a9d689b9885fd753401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus",
    jsii_struct_bases=[],
    name_mapping={
        "destination": "destination",
        "enabled": "enabled",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus:
    def __init__(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e5593d2885383c4ceb890975af92a72ff1f4b678127b5e9ed475ad227bdea6)
            check_type(argname="argument destination", value=destination, expected_type=type_hints["destination"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination is not None:
            self._values["destination"] = destination
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL.

        Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        '''
        result = self._values.get("destination")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the redirect feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns the status code for the redirect response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9342902bac2a654682cd11b9decb97eb9f1b62d6d912bbc7c755d855c6ada514)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestination")
    def reset_destination(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestination", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationInput")
    def destination_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destination")
    def destination(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destination"))

    @destination.setter
    def destination(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3e7510ea79510999a0fbc3e89342d6e86825dcb4c06ec2b20b6065dc88b4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destination", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183a5afeb1b981ab61c7455e107b1a9e0679d58f6a0bf3acf3dedcf8907c51b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c8c18c2680372c281b6d8e8ef3462f4399f454b8eacb67f02fdc94b01b3ff22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62938111c217979d30fb5550546313b8b2135b11e9208e2e10011a2151e1b78b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf425e01c57ff1e79ece5e1e9d75912271a89b9160555ded038f71cc1324ae4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe0ccf9144fa30f5c2948920eda11a5d07b52568dde870939e80fb165ce73e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__982fe456a634d65bdc2cd9a3f5ebb946259483caafad0c3da29ee4573e9c6429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking",
    jsii_struct_bases=[],
    name_mapping={
        "allow_children": "allowChildren",
        "domains": "domains",
        "enabled": "enabled",
        "locked": "locked",
        "strict": "strict",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking:
    def __init__(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e11fbf9a15f0af30927ba926df06438de263f597c7df87da8cca23afbb2e28b)
            check_type(argname="argument allow_children", value=allow_children, expected_type=type_hints["allow_children"])
            check_type(argname="argument domains", value=domains, expected_type=type_hints["domains"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict", value=strict, expected_type=type_hints["strict"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_children is not None:
            self._values["allow_children"] = allow_children
        if domains is not None:
            self._values["domains"] = domains
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if strict is not None:
            self._values["strict"] = strict
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_children(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        '''
        result = self._values.get("allow_children")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of allowed domains.

        With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        '''
        result = self._values.get("domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the referer-checking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``.

        When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        '''
        result = self._values.get("strict")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111e59d89922c4ed4606214d3ac86f72a2e33e9740521480b97c5049c0b63c1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowChildren")
    def reset_allow_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowChildren", []))

    @jsii.member(jsii_name="resetDomains")
    def reset_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomains", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrict")
    def reset_strict(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrict", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowChildrenInput")
    def allow_children_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowChildrenInput"))

    @builtins.property
    @jsii.member(jsii_name="domainsInput")
    def domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "domainsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictInput")
    def strict_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowChildren")
    def allow_children(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowChildren"))

    @allow_children.setter
    def allow_children(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf3923908c44ace92352958a3e92bae15db8268e5583cb845bee8566618163b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowChildren", value)

    @builtins.property
    @jsii.member(jsii_name="domains")
    def domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "domains"))

    @domains.setter
    def domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ae4af0d4b70b835d9fcdc6e4dcb43eb13bee43a46aa230fc30820691557c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domains", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723156ede1483113f2bb6dde6ff559929e54b41426fe923112c798aad9916368)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1067b7849bf97ccf15f5624a0f5beca9a2607ac47d32ca1f1c6685517961ddc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strict")
    def strict(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strict"))

    @strict.setter
    def strict(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7616f3398216142c08099f6aba193c1207796bb86e9059ff5e06a0cb8b43535a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strict", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da429c569aeab162289d2b988253c252db26e0610f752354cd746790460902f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8c489216ff4cbab411124c213acb813ec3e978788efbe4235f5be430d4f8415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94f8b1cfb27f3d8795860a6cabe57a2c42a7a5638559ee9f9449306fb379a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f92377430ef219ad686c9d220024c7d39834bfa0c28a50240c57fa4b87e2c3c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies parameters to remove from the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e505be14767bb5fa5956672ab547282a2d57e7667d8a023cd5c13c149263851b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900ea388962529079b77032738f9086d72e49339dbab315bcb459541065353d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af04dea5d81b28c60611633e0e007c64ebfbd6d1ebe9ac06d8d2995dce517ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__114ff049195d60805f60f5ae1da87e947f54fb86fc467b03531e731965ee7f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529b8550561a05b485131eb525e48341a42e52a08cc285976994c3a8bab757e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20847d13bf15fc81afc1b951d0b67a043ebd9ebe996eb8e0470279756651a212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feb905a3aaf7959c0a216aa1718e417fa5a33627350499108d5434330f26c091)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, removes the ``Vary`` header to ensure objects can be cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVaryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVaryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3500bc3b3b89f668472a446a9e31cfe0b6cefa63a4849efdf5bf5355d06d62f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55f74b9ac60eab1973df4f10f3267123079d3f26b58cbaa93410320e7226ac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc37b219b8348ed6934f4920453db4301949456531947725d6c1ec7f437248b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f13eca87d82a314da1b22cfb9c4e4ca69bcd0e2ed4e5b648b36030d826f2585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dced1b44cb86b1ba61b6363925931731ba85ddc6f483298f42ee779447d178c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3af6384cc9aca4878cce146a60a80b018f51f4ea9361f6dfe814c59c416cf047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport",
    jsii_struct_bases=[],
    name_mapping={
        "cookies": "cookies",
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_accept_language": "logAcceptLanguage",
        "log_cookies": "logCookies",
        "log_custom_log_field": "logCustomLogField",
        "log_edge_ip": "logEdgeIp",
        "log_host": "logHost",
        "log_referer": "logReferer",
        "log_user_agent": "logUserAgent",
        "log_x_forwarded_for": "logXForwardedFor",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport:
    def __init__(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3779f53340639f3d6c57de89f89848a5b2490a66ecda2d821e8d4354d9f9bfb6)
            check_type(argname="argument cookies", value=cookies, expected_type=type_hints["cookies"])
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_accept_language", value=log_accept_language, expected_type=type_hints["log_accept_language"])
            check_type(argname="argument log_cookies", value=log_cookies, expected_type=type_hints["log_cookies"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument log_edge_ip", value=log_edge_ip, expected_type=type_hints["log_edge_ip"])
            check_type(argname="argument log_host", value=log_host, expected_type=type_hints["log_host"])
            check_type(argname="argument log_referer", value=log_referer, expected_type=type_hints["log_referer"])
            check_type(argname="argument log_user_agent", value=log_user_agent, expected_type=type_hints["log_user_agent"])
            check_type(argname="argument log_x_forwarded_for", value=log_x_forwarded_for, expected_type=type_hints["log_x_forwarded_for"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookies is not None:
            self._values["cookies"] = cookies
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_accept_language is not None:
            self._values["log_accept_language"] = log_accept_language
        if log_cookies is not None:
            self._values["log_cookies"] = log_cookies
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if log_edge_ip is not None:
            self._values["log_edge_ip"] = log_edge_ip
        if log_host is not None:
            self._values["log_host"] = log_host
        if log_referer is not None:
            self._values["log_referer"] = log_referer
        if log_user_agent is not None:
            self._values["log_user_agent"] = log_user_agent
        if log_x_forwarded_for is not None:
            self._values["log_x_forwarded_for"] = log_x_forwarded_for
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookies(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the set of cookies names whose values you want to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        '''
        result = self._values.get("cookies")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_accept_language(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Accept-Language`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        '''
        result = self._values.get("log_accept_language")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_cookies(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of cookies to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        '''
        result = self._values.get("log_cookies")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_edge_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to log the IP address of the Akamai edge server that served the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        '''
        result = self._values.get("log_edge_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_host(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Host`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        '''
        result = self._values.get("log_host")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_referer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Referer`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        '''
        result = self._values.get("log_referer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_user_agent(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        '''
        result = self._values.get("log_user_agent")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log any ``X-Forwarded-For`` request header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        '''
        result = self._values.get("log_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9564d7e886b0032efbaa33c27005f733e5e8f5d6528e3a4a99b7bff98981bf6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookies")
    def reset_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookies", []))

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogAcceptLanguage")
    def reset_log_accept_language(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogAcceptLanguage", []))

    @jsii.member(jsii_name="resetLogCookies")
    def reset_log_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCookies", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetLogEdgeIp")
    def reset_log_edge_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEdgeIp", []))

    @jsii.member(jsii_name="resetLogHost")
    def reset_log_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogHost", []))

    @jsii.member(jsii_name="resetLogReferer")
    def reset_log_referer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogReferer", []))

    @jsii.member(jsii_name="resetLogUserAgent")
    def reset_log_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogUserAgent", []))

    @jsii.member(jsii_name="resetLogXForwardedFor")
    def reset_log_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogXForwardedFor", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookiesInput")
    def cookies_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguageInput")
    def log_accept_language_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logAcceptLanguageInput"))

    @builtins.property
    @jsii.member(jsii_name="logCookiesInput")
    def log_cookies_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logCookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="logEdgeIpInput")
    def log_edge_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEdgeIpInput"))

    @builtins.property
    @jsii.member(jsii_name="logHostInput")
    def log_host_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logHostInput"))

    @builtins.property
    @jsii.member(jsii_name="logRefererInput")
    def log_referer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logRefererInput"))

    @builtins.property
    @jsii.member(jsii_name="logUserAgentInput")
    def log_user_agent_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logUserAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="logXForwardedForInput")
    def log_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookies")
    def cookies(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cookies"))

    @cookies.setter
    def cookies(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e982b244b10178aac586ad077ee2754b69b27b7bdbb3aed91f847f523be20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookies", value)

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73da9f58121c2036795ed318cbcc2e70c440e5f42c8855f0099eb17c5af768f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb7686263cd0022b1f88cd9b8399ff4ea9fa5233708291c6769bed504bdc4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguage")
    def log_accept_language(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logAcceptLanguage"))

    @log_accept_language.setter
    def log_accept_language(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d3a1621f23c1515c2a746bc0dac136d22faa02b55ebb415ffae2953f4f18450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logAcceptLanguage", value)

    @builtins.property
    @jsii.member(jsii_name="logCookies")
    def log_cookies(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logCookies"))

    @log_cookies.setter
    def log_cookies(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c1db6df99b857fe8ed70b79bec9e5638ab19a50536f6aeab25029bcdcae519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCookies", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbaa2c32629a5649fc88d8434d47b21bc965b6e1c1a25cbc5170650470bfbb16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="logEdgeIp")
    def log_edge_ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEdgeIp"))

    @log_edge_ip.setter
    def log_edge_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cce86b0caa4dbf3fd14ce1ac31af4cbaf829a37aaeca00cda4fb58e20448347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEdgeIp", value)

    @builtins.property
    @jsii.member(jsii_name="logHost")
    def log_host(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logHost"))

    @log_host.setter
    def log_host(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf73cc98079423c29fb21f2d682886176cabc990e9602185fc3e169466d8dc6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logHost", value)

    @builtins.property
    @jsii.member(jsii_name="logReferer")
    def log_referer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logReferer"))

    @log_referer.setter
    def log_referer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63fb0848e59bcb85d25adad7917f9ded76cc1acf7b7a7fe344ca556d669355c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logReferer", value)

    @builtins.property
    @jsii.member(jsii_name="logUserAgent")
    def log_user_agent(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logUserAgent"))

    @log_user_agent.setter
    def log_user_agent(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1ec66c381ea4eedd004f94462114a8c8dc593c8a0fcbfba514b4e0d5a453cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logUserAgent", value)

    @builtins.property
    @jsii.member(jsii_name="logXForwardedFor")
    def log_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logXForwardedFor"))

    @log_x_forwarded_for.setter
    def log_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64dfa1876a74fc83f55cc8bd8a4e5aa6a984fd7ae43a4312b3edcabfedc5032d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcfcb51d2c0ca651c1ad86d4ec05b980800665169028556d1a5ee50bb25d3269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6255abef5ad73793d22e5d077a2442dbdcd88bb92655f07964f1b929e621fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8baaad8c3b08b39e725187659cf87e41c3c49313b710953375a9d6f37c73c0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl",
    jsii_struct_bases=[],
    name_mapping={
        "branded403_file": "branded403File",
        "branded403_status_code": "branded403StatusCode",
        "branded403_url": "branded403Url",
        "branded_deny_cache_ttl": "brandedDenyCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enable_branded403": "enableBranded403",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "net_storage": "netStorage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl:
    def __init__(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5476c9a2110b137bd44b0c8111ffc789166d19bcd2beda457738cc763bed930)
            check_type(argname="argument branded403_file", value=branded403_file, expected_type=type_hints["branded403_file"])
            check_type(argname="argument branded403_status_code", value=branded403_status_code, expected_type=type_hints["branded403_status_code"])
            check_type(argname="argument branded403_url", value=branded403_url, expected_type=type_hints["branded403_url"])
            check_type(argname="argument branded_deny_cache_ttl", value=branded_deny_cache_ttl, expected_type=type_hints["branded_deny_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enable_branded403", value=enable_branded403, expected_type=type_hints["enable_branded403"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if branded403_file is not None:
            self._values["branded403_file"] = branded403_file
        if branded403_status_code is not None:
            self._values["branded403_status_code"] = branded403_status_code
        if branded403_url is not None:
            self._values["branded403_url"] = branded403_url
        if branded_deny_cache_ttl is not None:
            self._values["branded_deny_cache_ttl"] = branded_deny_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enable_branded403 is not None:
            self._values["enable_branded403"] = enable_branded403
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def branded403_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        '''
        result = self._values.get("branded403_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded403_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response status code for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        '''
        result = self._values.get("branded403_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def branded403_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect URL for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        '''
        result = self._values.get("branded403_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded_deny_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the branded response page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        '''
        result = self._values.get("branded_deny_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enable_branded403(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, serves a branded 403 page for this Cloudlet instance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        '''
        result = self._values.get("enable_branded403")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Request Control Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f058691ecc70b6f27b1aff39cdf664926c03139adb486617bf25d14425dfcb)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63cb68f3b11e947e84eeb69570e1a3331c594841bd506aabe6d80b6e190aa27c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c185d05951d9886532750c7aa5f917998568e9454457ad7082386bdbf7e9a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8575537038948c2d98bd963d7173ebe35b62bcfe9064088c5754211a061f1f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06ab279417f91b1138d1146cf56c2564cd641d48e028ccaa59fde782e71e6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b928738f841eeee456be634e3504e47ce399b883fae58580f9ae91c52cb9dbd1)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea9c2de1a37fd37b87689a3bd4f6fbacfdb2eda882679207e7cb099063d8704)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9111a7c6086ca37e750d8d9ba366e278c402fa568a3cc8eece10ecc101171c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b4f4605a8b7b1506b0d5ecdfdf58d0e365ce1180a30a951bfd359a824d686a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e95e3e242658d5aefd084bc4255e75e54a0093249865658e48142a74833e07fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a646776aec97ee17ec211c4a4c4c4d89fdf7e2cc5a9f9225259fc9ec7e8660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791f715f6dd9226321744f4fec86f4757a034ed7c2a1cbb4d83a61226289ed21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetBranded403File")
    def reset_branded403_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403File", []))

    @jsii.member(jsii_name="resetBranded403StatusCode")
    def reset_branded403_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403StatusCode", []))

    @jsii.member(jsii_name="resetBranded403Url")
    def reset_branded403_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403Url", []))

    @jsii.member(jsii_name="resetBrandedDenyCacheTtl")
    def reset_branded_deny_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrandedDenyCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnableBranded403")
    def reset_enable_branded403(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBranded403", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="branded403FileInput")
    def branded403_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403FileInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCodeInput")
    def branded403_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "branded403StatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403UrlInput")
    def branded403_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403UrlInput"))

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtlInput")
    def branded_deny_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "brandedDenyCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBranded403Input")
    def enable_branded403_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBranded403Input"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403File")
    def branded403_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403File"))

    @branded403_file.setter
    def branded403_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd1d313ca6b0d76abf3a3a417d3135d25c5177c55d532bb818915e95643f0b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403File", value)

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCode")
    def branded403_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "branded403StatusCode"))

    @branded403_status_code.setter
    def branded403_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb1275b9c74f862a088547be483915bcad6aa5a2a3f6eaac2212240f468a6a6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403StatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="branded403Url")
    def branded403_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403Url"))

    @branded403_url.setter
    def branded403_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8195383945206006af5a72eef2243a09d579bf9982a9ef44332fa1c7458d153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403Url", value)

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtl")
    def branded_deny_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "brandedDenyCacheTtl"))

    @branded_deny_cache_ttl.setter
    def branded_deny_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1cbc85277c262619a37b2f14b1f4825b07a71178c43fe56ebf71582f1f8ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brandedDenyCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__793f37f680e7eba4419371639f1bdb73a8e7bdbcb594a24da2e724792d142630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enableBranded403")
    def enable_branded403(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBranded403"))

    @enable_branded403.setter
    def enable_branded403(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ddb97bd1296276d5a83219d57d90038244c52c9877e128306707954b226bcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBranded403", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18fe49ddc5f7490a642a6e6f1f9cb403d4c87930cb8d9fba936468aff6c25c7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86d4ef41e70e5061c1da3e6990ab18a049b4d217a18680b84162f6668f4ef6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517f0436b4f037207eadf8a29d0bf15593faca8f1da7190cad3888a927d88ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e792a67b78332c9225a29bd891030e750c840988f94ed611915e8111bcf7307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dace63d37fa837db41c4d9cde1c59473fafbb7cdea9118be726b9c3b3a92a24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4592be08e19bd185635eafee5972aab03dfe39ce223359c5420ff73a169e7893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "request_type": "requestType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017a5b795df565a832babf82594ec4aceded228530dc47d556da514c69858596)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a7f7a371459a013c543f3946f80b62398dac1e16cd996584826646e344db48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e141403ce89206f8761bf00d0758fcd1b161df7e46e5e4ef1075727b8114b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fed81294227d713c43e80ae9fb9b8cc0cd9aefef906d9defe55eb82884cb50e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a31ba99b0b7382c4286ed7cb286113bb78f96627f3f613273d6c83842f8b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5338dfaea70f839b655839f6826ed300dd09628cd1d57b13a107c0865894b0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c0f02e29998fc41e837902f0f40a0c5ab16f7f808d25fb64ce20645650480f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b96387b7a6446f3e26cd7ed97b2e46e4b5bf9180ceb5c7728cfa164ed57b91b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "enable_all_features": "enableAllFeatures",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility:
    def __init__(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361331e463d001b41789b3a5fc1f020dcd48a5bbbea4195da0042293e4119538)
            check_type(argname="argument enable_all_features", value=enable_all_features, expected_type=type_hints["enable_all_features"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_all_features is not None:
            self._values["enable_all_features"] = enable_all_features
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_all_features(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``additional support`` and error handling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        '''
        result = self._values.get("enable_all_features")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3933538e83f22da21ee5e778ff843aec229fd265ddb811e987411128be5b923)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableAllFeatures")
    def reset_enable_all_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAllFeatures", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeaturesInput")
    def enable_all_features_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAllFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeatures")
    def enable_all_features(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAllFeatures"))

    @enable_all_features.setter
    def enable_all_features(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e1fd97083057b0a59d8125e3846c8df7a07bb999798fc41e6799df4c848c0dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAllFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__934275390a6a8098b7f1e5f99d803dcedf4f6f0c04c0241692e38e5aabe9306a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11797ef78290a262898206a84551cf60cf7e111f60565a51ac595b7a242766c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a73eef015c80412e115acfbf0393dc968c7c3597dcded14b6551f6325286e51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88db433a3b41cd03f0c94ac7327cc921347713a075c8a30548216e87fb32f222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f15e960ea55653509d58cc3cf3fd30e535f5f140a9dc5e1478380a3664d4921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe933019191e869c06ab3732cf1c8a75797c1c55145faaeede250cb923e382ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a66ffb6076e1325a763bf29d1b3c3db11dfc82063faa307c7029c8b0ae18459b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab410cfdbfefe2a715f9c8b1d3025a74679bc5386b0cb35197bf7ab2d77c26b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8b1ce0a0dcfb02db9504b05fdcadfabe75c95fc3490a86995ecabde2edb61f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29204ffbac8a1296507fba8f2bf004d689c8047408712bfd6637fe5a0e40ec65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad12b6801bc5a365c088b2e10e2fb5e7eca930ac20f14f79a55e7a6cb47baae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "override206": "override206",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__876464bfd4608feaaa9c2e9029505790b933ff3cff32ed96f4941ed8e0e2491d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override206", value=override206, expected_type=type_hints["override206"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if override206 is not None:
            self._values["override206"] = override206
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override206(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        '''
        result = self._values.get("override206")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP status code to replace the existing one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8fe3ccba17a2d9a52e527c6d2cc2e009ae052b987120f3b7aeb379580c8a54)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride206")
    def reset_override206(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride206", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="override206Input")
    def override206_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "override206Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de497ffac385de094f57a55ccf53f3f5c37de4ea0596e48e8de7f066329b1fd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override206")
    def override206(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "override206"))

    @override206.setter
    def override206(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c13caf9e577797d7262b2b4fdcf519dc3b9a85b27a2c369e4948022a3881c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override206", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09ab1edae05e02e68c2ef67ef46261da9adf30e76000aa465783966e0bd14062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f9a1ab609738c196c031a81c3fe4b0c3b7681a697306dbbc01593b05d9fa2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2fdfb0771992866880167e7c595607e260ab50ee5e36c231d3f21ccf63c12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0253313b82f0d5eacff0c6b46736f0ebbf7af6861a8bd1c2fcb3669f7015e581)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "default_domain": "defaultDomain",
        "default_path": "defaultPath",
        "domain": "domain",
        "duration": "duration",
        "enabled": "enabled",
        "expiration_date": "expirationDate",
        "expires": "expires",
        "format": "format",
        "http_only": "httpOnly",
        "locked": "locked",
        "path": "path",
        "same_site": "sameSite",
        "secure": "secure",
        "template_uuid": "templateUuid",
        "type": "type",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__693a550a717abcf7b10910120f48255760a3bf350f77fd7871d5ddd771ec7474)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument default_domain", value=default_domain, expected_type=type_hints["default_domain"])
            check_type(argname="argument default_path", value=default_path, expected_type=type_hints["default_path"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument duration", value=duration, expected_type=type_hints["duration"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expiration_date", value=expiration_date, expected_type=type_hints["expiration_date"])
            check_type(argname="argument expires", value=expires, expected_type=type_hints["expires"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument http_only", value=http_only, expected_type=type_hints["http_only"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument same_site", value=same_site, expected_type=type_hints["same_site"])
            check_type(argname="argument secure", value=secure, expected_type=type_hints["secure"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if default_domain is not None:
            self._values["default_domain"] = default_domain
        if default_path is not None:
            self._values["default_path"] = default_path
        if domain is not None:
            self._values["domain"] = domain
        if duration is not None:
            self._values["duration"] = duration
        if enabled is not None:
            self._values["enabled"] = enabled
        if expiration_date is not None:
            self._values["expiration_date"] = expiration_date
        if expires is not None:
            self._values["expires"] = expires
        if format is not None:
            self._values["format"] = format
        if http_only is not None:
            self._values["http_only"] = http_only
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if same_site is not None:
            self._values["same_site"] = same_site
        if secure is not None:
            self._values["secure"] = secure
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie, which serves as a key to determine if the cookie is set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        '''
        result = self._values.get("default_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def default_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default path value, otherwise the set specified in the ``path`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        '''
        result = self._values.get("default_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid.

        For example, ``example.com`` makes the cookie valid for that hostname and all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def duration(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        '''
        result = self._values.get("duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set a response cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_date(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        '''
        result = self._values.get("expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def expires(self) -> typing.Optional[builtins.str]:
        '''Sets various ways to specify when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        '''
        result = self._values.get("expires")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        '''
        result = self._values.get("http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def same_site(self) -> typing.Optional[builtins.str]:
        '''This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        '''
        result = self._values.get("same_site")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        '''
        result = self._values.get("secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''What type of value to assign.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''If the cookie ``type`` is ``FIXED``, this specifies the cookie value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90adaecde95bc8ddf35d613f1a841bee4c0fde083e65695965416b02bc3f3a9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDefaultDomain")
    def reset_default_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultDomain", []))

    @jsii.member(jsii_name="resetDefaultPath")
    def reset_default_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultPath", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetDuration")
    def reset_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDuration", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExpirationDate")
    def reset_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationDate", []))

    @jsii.member(jsii_name="resetExpires")
    def reset_expires(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpires", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetHttpOnly")
    def reset_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpOnly", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetSameSite")
    def reset_same_site(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSameSite", []))

    @jsii.member(jsii_name="resetSecure")
    def reset_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecure", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultDomainInput")
    def default_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultPathInput")
    def default_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultPathInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="durationInput")
    def duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "durationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationDateInput")
    def expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="expiresInput")
    def expires_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expiresInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="httpOnlyInput")
    def http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "httpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="sameSiteInput")
    def same_site_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sameSiteInput"))

    @builtins.property
    @jsii.member(jsii_name="secureInput")
    def secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secureInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db6bccfff7e90a4e7f8819a719af36d036d258c454f3097b3c6344628409327b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="defaultDomain")
    def default_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultDomain"))

    @default_domain.setter
    def default_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2de68675ea9669de4a6a2c7f1978b1761b301c631854cf3a5eb8ce1a2b6ae50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultDomain", value)

    @builtins.property
    @jsii.member(jsii_name="defaultPath")
    def default_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultPath"))

    @default_path.setter
    def default_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7410109e335fc2369bd78d8415fafb990ac3096d0d07b4d20655d9dd3545d382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultPath", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db31a4e7224daf879d55c906fc2287f717b02a416d60c31c0608bc4c056bc2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="duration")
    def duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "duration"))

    @duration.setter
    def duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc82b3b3aeb2a895f10ed61c9915b5e7770ad83613ba7446dccdd617ed40a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "duration", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7793e4181331bf54f3ea8f0940fa39020aea89bb47be071271929a400e150372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="expirationDate")
    def expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationDate"))

    @expiration_date.setter
    def expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37bd71096c9fdd73cc53af3eec9093168d4b9dace82aa7af4ebd5de2e51926b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="expires")
    def expires(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expires"))

    @expires.setter
    def expires(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d803125444fdcbfca58cef7eecaa27ad9c21724adb29baa3d70b27969d396a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expires", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d646ecba862f350c05dfe9b4a99e877f49302dc134fb014eec4a4baf035f2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="httpOnly")
    def http_only(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "httpOnly"))

    @http_only.setter
    def http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11889ed5c8b5c67d1857a1b682bc8ff54de7547421844cc651d9f10c80affed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acd67b4181d9cd30aad93cd43f4d80dd67fb0da3b181979373c8bbcda773f976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc48ce435590054d309b1874cee56b43ed6dc5cbab0eb1a642eb285efdf28c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="sameSite")
    def same_site(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sameSite"))

    @same_site.setter
    def same_site(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097e9355516f402169185d61554767984c8067fec34fd382d88d360420333609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sameSite", value)

    @builtins.property
    @jsii.member(jsii_name="secure")
    def secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secure"))

    @secure.setter
    def secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8657fc4531e6650e6c2a548d70aae133fc08b0f2ce16206034874f1ef130a763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secure", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08eb569a322c29dd4dc93270eb45293e8038eaf69029a2939c9bb46e893cd246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd2d0ed5616c3ed5e645dda4462c0dfeeeec57f2a147fa63693ba4a5eddd9c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b8c43b494816dbba2714bf739681f76a4eea794342503cf26c3658db792ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a13a4e1ddd90717cbe0f5dde5926a1ccc347ca1dab2f8f7b2c5a67197b736da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a25a6d0ca786075ceddcc3aac1f5faa12f8b568671f01839abd0b6d53c590cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_size": "maximumSize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a241afae25b0619b663d5867e4244f41c5946b21aa11ce1f4cc055af425bcf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed maximum size of non-HTML content to cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a07922ce65e5d2672cd6c4afe9c73a236b077565fc933d5346f1376dd449b77)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56cb78a20927f655b93f1caa21796468245588f99a8b7c896a7301399e03b409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3a6a9ed2ba484bc7e5a4f1be128625723ad5a572544700a2bf4b7175f70cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0d1dfe5d3ab2d0ee3a8f305ee22d1381441c6f59da34147da69ac337be353c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fdebcd13cb8286f7e4f1eb4871d5f4a3b07452b08c6a62f6e1ef9414f4d1c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2033cc939318fe6552d456e9cefe62f12d823a0da4634b621df8957ffdd12476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "response_header_name": "responseHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31c987be0a0510bc919c9839ee4a282fdf93a2f99e063259962c86686c3cb022)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the HTTP header in which to report the cache status value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b13e220fd551379992faceb2592a0834a93bfad92347a9014a2213b74b0328)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a212cdac60571e0f18078b3904683f07a4554b6b59bf862ea1ee51323bf8c47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__796b0a6ab00f1466a587fc16901ab18b00745bd5a9c0cf3b1725131faffca9f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b528103dd7978d2fd8e40bf472893c5db4dfdf87d3cade0023b68831e7ad33d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f30fe2cc4680d8329f898a2928f22812bdba59bd5a6eac704b8bc8fa09d3a7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11b03aca484ac83f699e2fd91aaddfc84e8c92c39d675cb1b14f673771e2bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "keep_query_string": "keepQueryString",
        "locked": "locked",
        "match": "match",
        "match_multiple": "matchMultiple",
        "match_regex": "matchRegex",
        "target_path": "targetPath",
        "target_path_prepend": "targetPathPrepend",
        "target_regex": "targetRegex",
        "target_url": "targetUrl",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4319a0c0a0126fd2e72b08ad3a2c85db6b69a81090f171ba3a36121daea64ca4)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument keep_query_string", value=keep_query_string, expected_type=type_hints["keep_query_string"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match", value=match, expected_type=type_hints["match"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument match_regex", value=match_regex, expected_type=type_hints["match_regex"])
            check_type(argname="argument target_path", value=target_path, expected_type=type_hints["target_path"])
            check_type(argname="argument target_path_prepend", value=target_path_prepend, expected_type=type_hints["target_path_prepend"])
            check_type(argname="argument target_regex", value=target_regex, expected_type=type_hints["target_regex"])
            check_type(argname="argument target_url", value=target_url, expected_type=type_hints["target_url"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if keep_query_string is not None:
            self._values["keep_query_string"] = keep_query_string
        if locked is not None:
            self._values["locked"] = locked
        if match is not None:
            self._values["match"] = match
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if match_regex is not None:
            self._values["match_regex"] = match_regex
        if target_path is not None:
            self._values["target_path"] = target_path
        if target_path_prepend is not None:
            self._values["target_path_prepend"] = target_path_prepend
        if target_regex is not None:
            self._values["target_regex"] = target_regex
        if target_url is not None:
            self._values["target_url"] = target_url
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''The action to perform on the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def keep_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, retains the original path's query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        '''
        result = self._values.get("keep_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        '''
        result = self._values.get("match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, replaces all potential matches rather than only the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        '''
        result = self._values.get("match_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        '''
        result = self._values.get("target_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path_prepend(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        '''
        result = self._values.get("target_path_prepend")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        '''
        result = self._values.get("target_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_url(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        '''
        result = self._values.get("target_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cce27c5e35eb609c08e552444626fdb1f02d74dde08d1262207cc7cff1709c87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetKeepQueryString")
    def reset_keep_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKeepQueryString", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatch")
    def reset_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatch", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetMatchRegex")
    def reset_match_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchRegex", []))

    @jsii.member(jsii_name="resetTargetPath")
    def reset_target_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPath", []))

    @jsii.member(jsii_name="resetTargetPathPrepend")
    def reset_target_path_prepend(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPathPrepend", []))

    @jsii.member(jsii_name="resetTargetRegex")
    def reset_target_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetRegex", []))

    @jsii.member(jsii_name="resetTargetUrl")
    def reset_target_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetUrl", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="keepQueryStringInput")
    def keep_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "keepQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchInput")
    def match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="matchRegexInput")
    def match_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathInput")
    def target_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathPrependInput")
    def target_path_prepend_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathPrependInput"))

    @builtins.property
    @jsii.member(jsii_name="targetRegexInput")
    def target_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetUrlInput")
    def target_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__650aa8381cfa594932e5830a8bc6252b981ebb3a45123e08d0bbc94fe1cba666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="keepQueryString")
    def keep_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "keepQueryString"))

    @keep_query_string.setter
    def keep_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28ae47e8385378a5a77db4c57a5e6be7f0c13d6db5d0ea2db9657d882bf82e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "keepQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4ddddf42c9fda2a3fbcb1fd855b0a7d35418b08b6836d140518b454b7e86df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="match")
    def match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "match"))

    @match.setter
    def match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f177ea6108db9f5d319cc33a586d0a3a05d7b40517c9e30c3210ff27ed60967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "match", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0fc99ecec72cc8fbf6d01c55ed9e66c0a33beccfba3ceb954a890f75278c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="matchRegex")
    def match_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchRegex"))

    @match_regex.setter
    def match_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af81f8a6c5846bc833dee5c46300a379ba54e8425b2e4164699a7efd09eadefe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetPath")
    def target_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPath"))

    @target_path.setter
    def target_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de38a8e1459ecb3810c34778d4dbcd4f20df3deb6b23e990bd9549374c440079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPath", value)

    @builtins.property
    @jsii.member(jsii_name="targetPathPrepend")
    def target_path_prepend(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPathPrepend"))

    @target_path_prepend.setter
    def target_path_prepend(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b158ac1fae89f5465e1ecac0aed93a6c85d6366a2c41a26eff9c7408be0cdfd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPathPrepend", value)

    @builtins.property
    @jsii.member(jsii_name="targetRegex")
    def target_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetRegex"))

    @target_regex.setter
    def target_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f49b5dabc0ca84df268a0f3131622f2bc6e9a3afc4285019765f3c5ea0b832)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetUrl")
    def target_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetUrl"))

    @target_url.setter
    def target_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06748e9e59f0abe2d05b5e8c6f43d8a59739fff8e83504923bfe17b66a496af5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetUrl", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae4b033885a8088fce24ccc543781c113fb1c910422a8d30da68b519bf5a859)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04aac4676eb17960080603fc4a756a4314026f734fdeca89ad779a17093a9a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebb26abf653fc6247058126abb63c328542cab4174444f49af5b4682fd59ed8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "rum_group_name": "rumGroupName",
        "rum_sample_rate": "rumSampleRate",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed3f736246259bc87a7b58e41a83640073cdf33f5cfffa11334dadac33613bb)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument rum_group_name", value=rum_group_name, expected_type=type_hints["rum_group_name"])
            check_type(argname="argument rum_sample_rate", value=rum_sample_rate, expected_type=type_hints["rum_sample_rate"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if rum_group_name is not None:
            self._values["rum_group_name"] = rum_group_name
        if rum_sample_rate is not None:
            self._values["rum_sample_rate"] = rum_sample_rate
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rum_group_name(self) -> typing.Optional[builtins.str]:
        '''A deprecated option to specify an alternate name under which to batch this set of web traffic in your report.

        Do not use it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        '''
        result = self._values.get("rum_group_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rum_sample_rate(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of web traffic to include in your RUM report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        '''
        result = self._values.get("rum_sample_rate")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00706074c178ef5a65a58f9f0a64f959580b44e8277bfa7f82f172c4280cd8e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRumGroupName")
    def reset_rum_group_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumGroupName", []))

    @jsii.member(jsii_name="resetRumSampleRate")
    def reset_rum_sample_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumSampleRate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="rumGroupNameInput")
    def rum_group_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "rumGroupNameInput"))

    @builtins.property
    @jsii.member(jsii_name="rumSampleRateInput")
    def rum_sample_rate_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "rumSampleRateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b53c3d347058f8673952fc7b14dca89e487f24015c7baad02f5c7f9f1588c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="rumGroupName")
    def rum_group_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rumGroupName"))

    @rum_group_name.setter
    def rum_group_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b749bba3f832deedf63b46664191a2e3efddcbaa22f6e48dd136968d9f3e8515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumGroupName", value)

    @builtins.property
    @jsii.member(jsii_name="rumSampleRate")
    def rum_sample_rate(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "rumSampleRate"))

    @rum_sample_rate.setter
    def rum_sample_rate(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55e5487e4a73e2d61bc3115db192b156a3039050f70591515dc2843eba42abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumSampleRate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0007836f7182ee89ef5549f3adaa169104abe504ecdf9a9e5de6e3f3a805764e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610038a6c95d12a28fe07e1161de4851207e1dae525976c3085a984baeb3c61d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044330b14ac7e24f88558503b46f3e0bb92fd9c18408697b69e3ad4ef506dfcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions",
    jsii_struct_bases=[],
    name_mapping={
        "application_action": "applicationAction",
        "application_cname_enabled": "applicationCnameEnabled",
        "application_cname_level": "applicationCnameLevel",
        "application_cookie": "applicationCookie",
        "application_query_string": "applicationQueryString",
        "application_regex": "applicationRegex",
        "application_replace": "applicationReplace",
        "application_title": "applicationTitle",
        "customer_action": "customerAction",
        "customer_cname_enabled": "customerCnameEnabled",
        "customer_cname_level": "customerCnameLevel",
        "customer_cookie": "customerCookie",
        "customer_query_string": "customerQueryString",
        "customer_regex": "customerRegex",
        "customer_replace": "customerReplace",
        "customer_title": "customerTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "users_action": "usersAction",
        "users_cname_enabled": "usersCnameEnabled",
        "users_cname_level": "usersCnameLevel",
        "users_cookie": "usersCookie",
        "users_query_string": "usersQueryString",
        "users_regex": "usersRegex",
        "users_replace": "usersReplace",
        "users_title": "usersTitle",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions:
    def __init__(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a3d120ed42060314c67e6394d6d94e19516d0248eff1a356caabf608acda98b)
            check_type(argname="argument application_action", value=application_action, expected_type=type_hints["application_action"])
            check_type(argname="argument application_cname_enabled", value=application_cname_enabled, expected_type=type_hints["application_cname_enabled"])
            check_type(argname="argument application_cname_level", value=application_cname_level, expected_type=type_hints["application_cname_level"])
            check_type(argname="argument application_cookie", value=application_cookie, expected_type=type_hints["application_cookie"])
            check_type(argname="argument application_query_string", value=application_query_string, expected_type=type_hints["application_query_string"])
            check_type(argname="argument application_regex", value=application_regex, expected_type=type_hints["application_regex"])
            check_type(argname="argument application_replace", value=application_replace, expected_type=type_hints["application_replace"])
            check_type(argname="argument application_title", value=application_title, expected_type=type_hints["application_title"])
            check_type(argname="argument customer_action", value=customer_action, expected_type=type_hints["customer_action"])
            check_type(argname="argument customer_cname_enabled", value=customer_cname_enabled, expected_type=type_hints["customer_cname_enabled"])
            check_type(argname="argument customer_cname_level", value=customer_cname_level, expected_type=type_hints["customer_cname_level"])
            check_type(argname="argument customer_cookie", value=customer_cookie, expected_type=type_hints["customer_cookie"])
            check_type(argname="argument customer_query_string", value=customer_query_string, expected_type=type_hints["customer_query_string"])
            check_type(argname="argument customer_regex", value=customer_regex, expected_type=type_hints["customer_regex"])
            check_type(argname="argument customer_replace", value=customer_replace, expected_type=type_hints["customer_replace"])
            check_type(argname="argument customer_title", value=customer_title, expected_type=type_hints["customer_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument users_action", value=users_action, expected_type=type_hints["users_action"])
            check_type(argname="argument users_cname_enabled", value=users_cname_enabled, expected_type=type_hints["users_cname_enabled"])
            check_type(argname="argument users_cname_level", value=users_cname_level, expected_type=type_hints["users_cname_level"])
            check_type(argname="argument users_cookie", value=users_cookie, expected_type=type_hints["users_cookie"])
            check_type(argname="argument users_query_string", value=users_query_string, expected_type=type_hints["users_query_string"])
            check_type(argname="argument users_regex", value=users_regex, expected_type=type_hints["users_regex"])
            check_type(argname="argument users_replace", value=users_replace, expected_type=type_hints["users_replace"])
            check_type(argname="argument users_title", value=users_title, expected_type=type_hints["users_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if application_action is not None:
            self._values["application_action"] = application_action
        if application_cname_enabled is not None:
            self._values["application_cname_enabled"] = application_cname_enabled
        if application_cname_level is not None:
            self._values["application_cname_level"] = application_cname_level
        if application_cookie is not None:
            self._values["application_cookie"] = application_cookie
        if application_query_string is not None:
            self._values["application_query_string"] = application_query_string
        if application_regex is not None:
            self._values["application_regex"] = application_regex
        if application_replace is not None:
            self._values["application_replace"] = application_replace
        if application_title is not None:
            self._values["application_title"] = application_title
        if customer_action is not None:
            self._values["customer_action"] = customer_action
        if customer_cname_enabled is not None:
            self._values["customer_cname_enabled"] = customer_cname_enabled
        if customer_cname_level is not None:
            self._values["customer_cname_level"] = customer_cname_level
        if customer_cookie is not None:
            self._values["customer_cookie"] = customer_cookie
        if customer_query_string is not None:
            self._values["customer_query_string"] = customer_query_string
        if customer_regex is not None:
            self._values["customer_regex"] = customer_regex
        if customer_replace is not None:
            self._values["customer_replace"] = customer_replace
        if customer_title is not None:
            self._values["customer_title"] = customer_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if users_action is not None:
            self._values["users_action"] = users_action
        if users_cname_enabled is not None:
            self._values["users_cname_enabled"] = users_cname_enabled
        if users_cname_level is not None:
            self._values["users_cname_level"] = users_cname_level
        if users_cookie is not None:
            self._values["users_cookie"] = users_cookie
        if users_query_string is not None:
            self._values["users_query_string"] = users_query_string
        if users_regex is not None:
            self._values["users_regex"] = users_regex
        if users_replace is not None:
            self._values["users_replace"] = users_replace
        if users_title is not None:
            self._values["users_title"] = users_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def application_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        '''
        result = self._values.get("application_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        '''
        result = self._values.get("application_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def application_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        '''
        result = self._values.get("application_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def application_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        '''
        result = self._values.get("application_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        '''
        result = self._values.get("application_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's application ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        '''
        result = self._values.get("application_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's application ID matched by ``applicationRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        '''
        result = self._values.get("application_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        '''
        result = self._values.get("application_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        '''
        result = self._values.get("customer_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        '''
        result = self._values.get("customer_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def customer_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        '''
        result = self._values.get("customer_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def customer_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        '''
        result = self._values.get("customer_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        '''
        result = self._values.get("customer_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's customer ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        '''
        result = self._values.get("customer_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's customer ID matched by ``customerRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        '''
        result = self._values.get("customer_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        '''
        result = self._values.get("customer_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        '''
        result = self._values.get("users_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        '''
        result = self._values.get("users_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def users_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        '''
        result = self._values.get("users_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def users_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        '''
        result = self._values.get("users_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        '''
        result = self._values.get("users_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's user ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        '''
        result = self._values.get("users_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's user ID matched by ``usersRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        '''
        result = self._values.get("users_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        '''
        result = self._values.get("users_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdbaa2c407d0ca34022e26b1a8e9e4e3ab61af08af58c05a86b46fe5d519a591)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplicationAction")
    def reset_application_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationAction", []))

    @jsii.member(jsii_name="resetApplicationCnameEnabled")
    def reset_application_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameEnabled", []))

    @jsii.member(jsii_name="resetApplicationCnameLevel")
    def reset_application_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameLevel", []))

    @jsii.member(jsii_name="resetApplicationCookie")
    def reset_application_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCookie", []))

    @jsii.member(jsii_name="resetApplicationQueryString")
    def reset_application_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationQueryString", []))

    @jsii.member(jsii_name="resetApplicationRegex")
    def reset_application_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationRegex", []))

    @jsii.member(jsii_name="resetApplicationReplace")
    def reset_application_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationReplace", []))

    @jsii.member(jsii_name="resetApplicationTitle")
    def reset_application_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationTitle", []))

    @jsii.member(jsii_name="resetCustomerAction")
    def reset_customer_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerAction", []))

    @jsii.member(jsii_name="resetCustomerCnameEnabled")
    def reset_customer_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameEnabled", []))

    @jsii.member(jsii_name="resetCustomerCnameLevel")
    def reset_customer_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameLevel", []))

    @jsii.member(jsii_name="resetCustomerCookie")
    def reset_customer_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCookie", []))

    @jsii.member(jsii_name="resetCustomerQueryString")
    def reset_customer_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerQueryString", []))

    @jsii.member(jsii_name="resetCustomerRegex")
    def reset_customer_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerRegex", []))

    @jsii.member(jsii_name="resetCustomerReplace")
    def reset_customer_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerReplace", []))

    @jsii.member(jsii_name="resetCustomerTitle")
    def reset_customer_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsersAction")
    def reset_users_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersAction", []))

    @jsii.member(jsii_name="resetUsersCnameEnabled")
    def reset_users_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameEnabled", []))

    @jsii.member(jsii_name="resetUsersCnameLevel")
    def reset_users_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameLevel", []))

    @jsii.member(jsii_name="resetUsersCookie")
    def reset_users_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCookie", []))

    @jsii.member(jsii_name="resetUsersQueryString")
    def reset_users_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersQueryString", []))

    @jsii.member(jsii_name="resetUsersRegex")
    def reset_users_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersRegex", []))

    @jsii.member(jsii_name="resetUsersReplace")
    def reset_users_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersReplace", []))

    @jsii.member(jsii_name="resetUsersTitle")
    def reset_users_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applicationActionInput")
    def application_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationActionInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabledInput")
    def application_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applicationCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevelInput")
    def application_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "applicationCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCookieInput")
    def application_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationQueryStringInput")
    def application_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationRegexInput")
    def application_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationReplaceInput")
    def application_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationTitleInput")
    def application_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customerActionInput")
    def customer_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerActionInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabledInput")
    def customer_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customerCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevelInput")
    def customer_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "customerCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCookieInput")
    def customer_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="customerQueryStringInput")
    def customer_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="customerRegexInput")
    def customer_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="customerReplaceInput")
    def customer_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="customerTitleInput")
    def customer_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usersActionInput")
    def users_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersActionInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabledInput")
    def users_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "usersCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevelInput")
    def users_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "usersCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCookieInput")
    def users_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="usersQueryStringInput")
    def users_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="usersRegexInput")
    def users_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="usersReplaceInput")
    def users_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="usersTitleInput")
    def users_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationAction")
    def application_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationAction"))

    @application_action.setter
    def application_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56a3fe493e0ab02414f30abb0e14bccd881090d0990c8e3b361955511693f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationAction", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabled")
    def application_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applicationCnameEnabled"))

    @application_cname_enabled.setter
    def application_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__add50aa4ef3b6e91758d5be9c0a56ccca21c3f25f656f93dab36008a90359d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevel")
    def application_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "applicationCnameLevel"))

    @application_cname_level.setter
    def application_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5525c9c5586e50bb808cdb2540637bee5cda5b351c33189f0364fac3f79719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCookie")
    def application_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationCookie"))

    @application_cookie.setter
    def application_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e1d3c83842b48bdafca6fe00491e1ea5178a0f216cf8211707b8573c9a3e25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCookie", value)

    @builtins.property
    @jsii.member(jsii_name="applicationQueryString")
    def application_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationQueryString"))

    @application_query_string.setter
    def application_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e93ab9e0e95081a55504d2a2706dd2536c52f8b7fa9b765b2e77836faf214f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="applicationRegex")
    def application_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationRegex"))

    @application_regex.setter
    def application_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cda0478b4812ee649cbf738db3a3e82bb23e1cf379c66cc44d3edda20c2fba7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationRegex", value)

    @builtins.property
    @jsii.member(jsii_name="applicationReplace")
    def application_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationReplace"))

    @application_replace.setter
    def application_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265b35d54c969f579e3d8bfa5650822488cead190f9159293fab7b1929277091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationReplace", value)

    @builtins.property
    @jsii.member(jsii_name="applicationTitle")
    def application_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationTitle"))

    @application_title.setter
    def application_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec85b459b2d76a8518e4287d218a3ec81ebb2811b451d50ab87d2b6e89cd654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customerAction")
    def customer_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerAction"))

    @customer_action.setter
    def customer_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d69fb926a087bc415e182687860ae924abbaf94525f6b681fee2bae74496856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerAction", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabled")
    def customer_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customerCnameEnabled"))

    @customer_cname_enabled.setter
    def customer_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414d6f59e9b86bfd6748d5da7b9369a1e4cd5e866c2c6765a0f7fba346451936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevel")
    def customer_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "customerCnameLevel"))

    @customer_cname_level.setter
    def customer_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b70e340414c96674f41ce7d08749259bab3ae0d34156e1ff02fdcd2f398abe56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="customerCookie")
    def customer_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerCookie"))

    @customer_cookie.setter
    def customer_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93eb0020207d065889400502857f9723106dacbea60d8de2d814846501871b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCookie", value)

    @builtins.property
    @jsii.member(jsii_name="customerQueryString")
    def customer_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerQueryString"))

    @customer_query_string.setter
    def customer_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8bcb8789d3a2757a5f653fa0111203bae5c9a18fc4c3f90e6ad738c0cf45edb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="customerRegex")
    def customer_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerRegex"))

    @customer_regex.setter
    def customer_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0a3a95cbf94cf1c90ab4a991b9a25de7dc967289a877a52c008621a9228a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerRegex", value)

    @builtins.property
    @jsii.member(jsii_name="customerReplace")
    def customer_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerReplace"))

    @customer_replace.setter
    def customer_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c483d27b62ec7a66a75a7ad19227bdad9b6d5d9b2db5cb41b5bddbb098944a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerReplace", value)

    @builtins.property
    @jsii.member(jsii_name="customerTitle")
    def customer_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerTitle"))

    @customer_title.setter
    def customer_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cf2f199a9ffb9a9d3404d28bb78642301e71dfa8b6a839b49ceb0c1e5a689b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2264d24ed40dd4c61b588cd49bc3dfa5b68c51aff994ce26a8ccc64552a88f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8b3f94899b191e80a87a1b04a2a35bcb1693976a74f5e64d7292cdfed19ba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="usersAction")
    def users_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersAction"))

    @users_action.setter
    def users_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fdc703a4d61241175bd74ab05b638871674b592e2e8a331e9c94c39f40774d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersAction", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabled")
    def users_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "usersCnameEnabled"))

    @users_cname_enabled.setter
    def users_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3bed1cc29bfb1e9f710746ceab3196606b87f769578579a9383f58ba6ff4302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevel")
    def users_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "usersCnameLevel"))

    @users_cname_level.setter
    def users_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08ee93cd5f159c2e76198aaf7b7a22afcbce934995cb2335993383fcffc79f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="usersCookie")
    def users_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersCookie"))

    @users_cookie.setter
    def users_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0bda908f5d5ee8bf72fd2b3ff412aef6134862411905236edf48fa32ce815b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCookie", value)

    @builtins.property
    @jsii.member(jsii_name="usersQueryString")
    def users_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersQueryString"))

    @users_query_string.setter
    def users_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f71918535ca289835ab614aeb780fcc371f535fb53abbf77f13dc9f9a253dcfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="usersRegex")
    def users_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersRegex"))

    @users_regex.setter
    def users_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c23f575c51654b47c5a81ab2e3b06ca366a9df96e7e14502960b30d810b859b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersRegex", value)

    @builtins.property
    @jsii.member(jsii_name="usersReplace")
    def users_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersReplace"))

    @users_replace.setter
    def users_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe85ae934eaa7d2c73753eaf856c236faab183ff2eb3172638bb2486582fb53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersReplace", value)

    @builtins.property
    @jsii.member(jsii_name="usersTitle")
    def users_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersTitle"))

    @users_title.setter
    def users_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101aad4b7fa5c179b71f1b19f40bfa5c63d18c151bfd2dfc9de6186a8c329f05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9c267517e899934907d6f447e2d13231d01fae99e9d079a97267952a3c0c8d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123ab4775d169ddf7202f8f1b6f686c25617689b1a565028259d991187ac82e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient",
    jsii_struct_bases=[],
    name_mapping={
        "allow_override_origin_cache_key": "allowOverrideOriginCacheKey",
        "connector_id": "connectorId",
        "enabled": "enabled",
        "locked": "locked",
        "origin_host_header": "originHostHeader",
        "origin_type": "originType",
        "sf3_c_origin_host": "sf3COriginHost",
        "sf3_c_origin_host_header": "sf3COriginHostHeader",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient:
    def __init__(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81fb618dfa1b0d05449875864e7f23c4840865877bf9e40099bf7032a8ae52bf)
            check_type(argname="argument allow_override_origin_cache_key", value=allow_override_origin_cache_key, expected_type=type_hints["allow_override_origin_cache_key"])
            check_type(argname="argument connector_id", value=connector_id, expected_type=type_hints["connector_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_host_header", value=origin_host_header, expected_type=type_hints["origin_host_header"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument sf3_c_origin_host", value=sf3_c_origin_host, expected_type=type_hints["sf3_c_origin_host"])
            check_type(argname="argument sf3_c_origin_host_header", value=sf3_c_origin_host_header, expected_type=type_hints["sf3_c_origin_host_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_override_origin_cache_key is not None:
            self._values["allow_override_origin_cache_key"] = allow_override_origin_cache_key
        if connector_id is not None:
            self._values["connector_id"] = connector_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if origin_host_header is not None:
            self._values["origin_host_header"] = origin_host_header
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if sf3_c_origin_host is not None:
            self._values["sf3_c_origin_host"] = sf3_c_origin_host
        if sf3_c_origin_host_header is not None:
            self._values["sf3_c_origin_host_header"] = sf3_c_origin_host_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides the forwarding origin's cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        '''
        result = self._values.get("allow_override_origin_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def connector_id(self) -> typing.Optional[builtins.str]:
        '''An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud.

        Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud.  You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        '''
        result = self._values.get("connector_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamai Connector for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_host_header(self) -> typing.Optional[builtins.str]:
        '''Specifies where the ``Host`` header is defined.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        '''
        result = self._values.get("origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Specifies where the origin is.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        '''
        result = self._values.get("sf3_c_origin_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce host header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        '''
        result = self._values.get("sf3_c_origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bad2882c4b4c8866d97cd7d77fa5751b210920024fd136538384e37da724f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowOverrideOriginCacheKey")
    def reset_allow_override_origin_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOverrideOriginCacheKey", []))

    @jsii.member(jsii_name="resetConnectorId")
    def reset_connector_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConnectorId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginHostHeader")
    def reset_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginHostHeader", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetSf3COriginHost")
    def reset_sf3_c_origin_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHost", []))

    @jsii.member(jsii_name="resetSf3COriginHostHeader")
    def reset_sf3_c_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHostHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKeyInput")
    def allow_override_origin_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowOverrideOriginCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="connectorIdInput")
    def connector_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "connectorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originHostHeaderInput")
    def origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeaderInput")
    def sf3_c_origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostInput")
    def sf3_c_origin_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKey")
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowOverrideOriginCacheKey"))

    @allow_override_origin_cache_key.setter
    def allow_override_origin_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f278b6820e299486ecd208b2224e5d42b9f74b02a63561b94dbd01673c05f914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOverrideOriginCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="connectorId")
    def connector_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "connectorId"))

    @connector_id.setter
    def connector_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__818166031fab97fb183a521fe3817f5943d90ca71dff012b975b4fc9339c1389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "connectorId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b92c9435e544f16cab08bf29d66ad3f7f9ae8f4e5792a15faff9a353199e9617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888832aca796b1755beff04f281f8dae7bf0cf3ae85137a5376f23f5d7cb2ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originHostHeader")
    def origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originHostHeader"))

    @origin_host_header.setter
    def origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04c0298d3507c3f6c522167047362a42e2da75267cc2fbc7e0054e728ef95c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710faa1dda10be1fa69128c34bf6a5e768538e7d5bfaa438f3b449db89bf4b5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHost")
    def sf3_c_origin_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHost"))

    @sf3_c_origin_host.setter
    def sf3_c_origin_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22549a50b785299255cef9b7d17041e1e1df6d7f491a9d632d097254dc8b76e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHost", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeader")
    def sf3_c_origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHostHeader"))

    @sf3_c_origin_host_header.setter
    def sf3_c_origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d000e46374dff9cdabd89d01ff05e7edf30f66e96cfb8e918682d4eca4591bad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d24070db6ffac29c6aec24557a8fd2a2e634ec7a861d8d1ff4a19ab10ad3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4912dcb118f00b90c160050ed3d4eace6db4d2179a1b19135479a75802c054d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecb1bacefe6c1133238fa0cf107560bef53d3cafd359d29b3db8f5c8b9914e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__862f6aad2eae7e1316af1b19e6fd39cc83497cf260116845224993f4e4f6feea)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Akamai Provider for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader",
    jsii_struct_bases=[],
    name_mapping={
        "host_header_source": "hostHeaderSource",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader:
    def __init__(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad3a7222744874edc38ba8ba23700ff19ce800316818698df67af03d3e7f18d)
            check_type(argname="argument host_header_source", value=host_header_source, expected_type=type_hints["host_header_source"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if host_header_source is not None:
            self._values["host_header_source"] = host_header_source
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def host_header_source(self) -> typing.Optional[builtins.str]:
        '''Specify where the host header derives from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        '''
        result = self._values.get("host_header_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764a268999708aaf25ae9ff7ec9f93708f3a936e7aae25c123498b537e0ef52a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHostHeaderSource")
    def reset_host_header_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostHeaderSource", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSourceInput")
    def host_header_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostHeaderSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSource")
    def host_header_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostHeaderSource"))

    @host_header_source.setter
    def host_header_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68122eb95b2da9df237d989c6d54a6413d9909534799dcd487a2bc53ba57c3ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostHeaderSource", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b5eb26b6fa077d47e9bd77b8a02353d7f69dfef8fd8fa6e85dc10f675124339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c726eb363fbc59beddb5aa7c9c2a54244a70e34c071b8abdd10a8c79f929dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fbb6393e20cbbd8ef47c90c2f8fb74f0ea7d3ec76530870b78d77569fe2d7c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ca38fb8b61c95a7e30d71633853cf8c5e15d0de2d816a8111fc9f224ae6c4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6877ac9e5475cd91801914b194c8637c81068f4b99a6521d6d9f0f1c39b4f733)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dfd99d2e4e55820999d8a7081d7fc1782005e27024ea9151d8346778136f7c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57583fcea5edfe0e2a4d9943e9bf272fcdc5046fb98f321bfacea9405943f4c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33da3033e726f36048f90d05fa6a105a6df86c20cf6d1ef1ca5d81c2b7ce92cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e87bf4a472e9c38536af5b815bc3ea0a9300fdf7d77f90e2f779ed29204d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__173088b160c5f1ba7efd787b007ab1b491a4daa726b50284e9b1641c274a6c1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25bc24bdac2216d772b6d737a12f1d205c71f4b58ed5f33ebb5804bfcc2ba65)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables processing of POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33efe5bda261382eb1ef109c1788f620da0b0da0e7cc0040b3728fc3c6a0db42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e514acfa6e23f6dfb5fa3211a791c0f8cf5352b8cf31ec978c2e720a8204c081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f5145d8e784def750470d1fcd971fc4b3fdd9e347698be974af4c99b917a5d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed7c0cd3f70c101db715fd4921870c64b10ee314e0a098cd887aad05925694aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d437968052f28a68afa8810e912cc46c2fd683b4073bc76592aaeac05e5de9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8651834b3af76edc8d630454ae021ee01be99b2c0ee04b193d702bee691aeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "refresh_method": "refreshMethod",
        "repeat": "repeat",
        "repeat_interval": "repeatInterval",
        "start": "start",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f244ddac9baa8ba09bb578327b816aabefb5fed53363b3eda2c6b849a9637fe)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument refresh_method", value=refresh_method, expected_type=type_hints["refresh_method"])
            check_type(argname="argument repeat", value=repeat, expected_type=type_hints["repeat"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument start", value=start, expected_type=type_hints["start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if refresh_method is not None:
            self._values["refresh_method"] = refresh_method
        if repeat is not None:
            self._values["repeat"] = repeat
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if start is not None:
            self._values["start"] = start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_method(self) -> typing.Optional[builtins.str]:
        '''Specifies how to invalidate the content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        '''
        result = self._values.get("refresh_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        '''
        result = self._values.get("repeat")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies how often to invalidate content from the ``start`` time, expressed in seconds.

        For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day.  Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start(self) -> typing.Optional[builtins.str]:
        '''The UTC date and time when matching cached content is to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        '''
        result = self._values.get("start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5b54067e540a2a230fe565728e9713e1d20c302c3f0b49f3fa6471ef701667)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRefreshMethod")
    def reset_refresh_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshMethod", []))

    @jsii.member(jsii_name="resetRepeat")
    def reset_repeat(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeat", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetStart")
    def reset_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshMethodInput")
    def refresh_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatInput")
    def repeat_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "repeatInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="startInput")
    def start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b7881cb64d8b28d38b8686923b6e3c82d2588ffcae6e4d3666a735d85b9bb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="refreshMethod")
    def refresh_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshMethod"))

    @refresh_method.setter
    def refresh_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb34c6ef2fa3a09b7a484177d34933c8bbe2b03f10488e72125c384d156d7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshMethod", value)

    @builtins.property
    @jsii.member(jsii_name="repeat")
    def repeat(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "repeat"))

    @repeat.setter
    def repeat(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2595d4a6274d5a58063d684b1fdd46386c5c81c5363d90efdd827c28aede9757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeat", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a2cef5ca7f3876df6375ea2d8c11a0a83d36817ec439d5a73c875e6bda7a543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="start")
    def start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "start"))

    @start.setter
    def start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__687a7a5bd53d18a690f6f8bdd0e12fb47cde25f7c9a2846f8191b968fe2eecdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "start", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605977f8129b504dc7581b543a8d3282927ca3ca4ca05ee64b5358ea6b680b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb408e9a26a3a0bc03d5995b7b33190d88144d55557ff366ceaf80cbf4ea551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a234275982dd8f2d92e2a95dcb0af0f55f8d5183c1d9635c2fcc18c9b0877c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "serviceworker": "serviceworker",
        "template_uuid": "templateUuid",
        "timestamp": "timestamp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6152456172e09d56740970d6d7e238a212ed1fb3d03bf03f4674fd181cbb054a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serviceworker", value=serviceworker, expected_type=type_hints["serviceworker"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timestamp", value=timestamp, expected_type=type_hints["timestamp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if serviceworker is not None:
            self._values["serviceworker"] = serviceworker
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timestamp is not None:
            self._values["timestamp"] = timestamp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Script Management feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serviceworker(self) -> typing.Optional[builtins.str]:
        '''Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        '''
        result = self._values.get("serviceworker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timestamp(self) -> typing.Optional[jsii.Number]:
        '''A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        '''
        result = self._values.get("timestamp")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagementOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagementOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a98a3b40deef558b4a89c6ac8e5b2d80bb7c6cee95158a4c3d056e8c713696)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServiceworker")
    def reset_serviceworker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServiceworker", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimestamp")
    def reset_timestamp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimestamp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serviceworkerInput")
    def serviceworker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serviceworkerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timestampInput")
    def timestamp_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "timestampInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721d29410fa2b2f90ae5f27a689339d6abaf3c173cdf5f8853de6dc41bde63c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11238717b91c07e1531a27f7e4440c12892ab5af0cd6b11ebbac56023172bfd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serviceworker")
    def serviceworker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serviceworker"))

    @serviceworker.setter
    def serviceworker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12379e1ffc0230acc8b737913601a6a13aff1d0ef18ac556928f80a83905dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serviceworker", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fb1dd6d496ddd1e09499fcaeee4b8eb32435bf0c0777bd4c11fbcc238216910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timestamp")
    def timestamp(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "timestamp"))

    @timestamp.setter
    def timestamp(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a764ec5ffca0e7eff0f419dc0ea8782032c5c3d8c744dc08ef4033704a901258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timestamp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219d00c762bc3db5fa0816683bbb61a5a5ec631ca2806a9ea1ce50fc73db9895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55158c16754c9429d6c30d4b9568b8a6e255906eb896a7bc0dc60c487b725654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection",
    jsii_struct_bases=[],
    name_mapping={
        "acl": "acl",
        "dash_media_encryption": "dashMediaEncryption",
        "data_payload": "dataPayload",
        "enabled": "enabled",
        "enable_token_in_uri": "enableTokenInUri",
        "field_carry_over": "fieldCarryOver",
        "header_for_salt": "headerForSalt",
        "hls_master_manifest_files": "hlsMasterManifestFiles",
        "hls_media_encryption": "hlsMediaEncryption",
        "ip": "ip",
        "key": "key",
        "locked": "locked",
        "media_encryption_title": "mediaEncryptionTitle",
        "revoked_list_id": "revokedListId",
        "salt": "salt",
        "session_id": "sessionId",
        "template_uuid": "templateUuid",
        "token_authentication_title": "tokenAuthenticationTitle",
        "token_auth_hls_title": "tokenAuthHlsTitle",
        "token_revocation_enabled": "tokenRevocationEnabled",
        "token_revocation_title": "tokenRevocationTitle",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection:
    def __init__(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143da588b565e1c646f55ba3860562510af4becdf8c870303a8bc9e68f013403)
            check_type(argname="argument acl", value=acl, expected_type=type_hints["acl"])
            check_type(argname="argument dash_media_encryption", value=dash_media_encryption, expected_type=type_hints["dash_media_encryption"])
            check_type(argname="argument data_payload", value=data_payload, expected_type=type_hints["data_payload"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_token_in_uri", value=enable_token_in_uri, expected_type=type_hints["enable_token_in_uri"])
            check_type(argname="argument field_carry_over", value=field_carry_over, expected_type=type_hints["field_carry_over"])
            check_type(argname="argument header_for_salt", value=header_for_salt, expected_type=type_hints["header_for_salt"])
            check_type(argname="argument hls_master_manifest_files", value=hls_master_manifest_files, expected_type=type_hints["hls_master_manifest_files"])
            check_type(argname="argument hls_media_encryption", value=hls_media_encryption, expected_type=type_hints["hls_media_encryption"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_encryption_title", value=media_encryption_title, expected_type=type_hints["media_encryption_title"])
            check_type(argname="argument revoked_list_id", value=revoked_list_id, expected_type=type_hints["revoked_list_id"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument session_id", value=session_id, expected_type=type_hints["session_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authentication_title", value=token_authentication_title, expected_type=type_hints["token_authentication_title"])
            check_type(argname="argument token_auth_hls_title", value=token_auth_hls_title, expected_type=type_hints["token_auth_hls_title"])
            check_type(argname="argument token_revocation_enabled", value=token_revocation_enabled, expected_type=type_hints["token_revocation_enabled"])
            check_type(argname="argument token_revocation_title", value=token_revocation_title, expected_type=type_hints["token_revocation_title"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if acl is not None:
            self._values["acl"] = acl
        if dash_media_encryption is not None:
            self._values["dash_media_encryption"] = dash_media_encryption
        if data_payload is not None:
            self._values["data_payload"] = data_payload
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_token_in_uri is not None:
            self._values["enable_token_in_uri"] = enable_token_in_uri
        if field_carry_over is not None:
            self._values["field_carry_over"] = field_carry_over
        if header_for_salt is not None:
            self._values["header_for_salt"] = header_for_salt
        if hls_master_manifest_files is not None:
            self._values["hls_master_manifest_files"] = hls_master_manifest_files
        if hls_media_encryption is not None:
            self._values["hls_media_encryption"] = hls_media_encryption
        if ip is not None:
            self._values["ip"] = ip
        if key is not None:
            self._values["key"] = key
        if locked is not None:
            self._values["locked"] = locked
        if media_encryption_title is not None:
            self._values["media_encryption_title"] = media_encryption_title
        if revoked_list_id is not None:
            self._values["revoked_list_id"] = revoked_list_id
        if salt is not None:
            self._values["salt"] = salt
        if session_id is not None:
            self._values["session_id"] = session_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authentication_title is not None:
            self._values["token_authentication_title"] = token_authentication_title
        if token_auth_hls_title is not None:
            self._values["token_auth_hls_title"] = token_auth_hls_title
        if token_revocation_enabled is not None:
            self._values["token_revocation_enabled"] = token_revocation_enabled
        if token_revocation_title is not None:
            self._values["token_revocation_title"] = token_revocation_title
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def acl(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field.

        Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        '''
        result = self._values.get("acl")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dash_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to enable DASH Media Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        '''
        result = self._values.get("dash_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def data_payload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        '''
        result = self._values.get("data_payload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the segmented content protection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_token_in_uri(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        '''
        result = self._values.get("enable_token_in_uri")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def field_carry_over(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        '''
        result = self._values.get("field_carry_over")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_for_salt(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session.

        This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        '''
        result = self._values.get("header_for_salt")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_master_manifest_files(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of filenames that form HLS master manifest URLs.

        You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        '''
        result = self._values.get("hls_master_manifest_files")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HLS Segment Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        '''
        result = self._values.get("hls_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption key to use as a shared secret to validate tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        '''
        result = self._values.get("media_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def revoked_list_id(self) -> typing.Optional[jsii.Number]:
        '''Identifies the ``TokenAuth`` tokens to block from accessing your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        '''
        result = self._values.get("revoked_list_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt as input into the token for added security.

        This value needs to match the salt used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def session_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        '''
        result = self._values.get("session_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authentication_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        '''
        result = self._values.get("token_authentication_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_auth_hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        '''
        result = self._values.get("token_auth_hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_revocation_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        '''
        result = self._values.get("token_revocation_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def token_revocation_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        '''
        result = self._values.get("token_revocation_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify advanced ``transitionKey`` and ``salt`` options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a40d8c1175d5cb4459df221345b8a34a5aaa9b73f795e8230c6845a3ce0658b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcl")
    def reset_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcl", []))

    @jsii.member(jsii_name="resetDashMediaEncryption")
    def reset_dash_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDashMediaEncryption", []))

    @jsii.member(jsii_name="resetDataPayload")
    def reset_data_payload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataPayload", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableTokenInUri")
    def reset_enable_token_in_uri(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTokenInUri", []))

    @jsii.member(jsii_name="resetFieldCarryOver")
    def reset_field_carry_over(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFieldCarryOver", []))

    @jsii.member(jsii_name="resetHeaderForSalt")
    def reset_header_for_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderForSalt", []))

    @jsii.member(jsii_name="resetHlsMasterManifestFiles")
    def reset_hls_master_manifest_files(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMasterManifestFiles", []))

    @jsii.member(jsii_name="resetHlsMediaEncryption")
    def reset_hls_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMediaEncryption", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaEncryptionTitle")
    def reset_media_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaEncryptionTitle", []))

    @jsii.member(jsii_name="resetRevokedListId")
    def reset_revoked_list_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevokedListId", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetSessionId")
    def reset_session_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthenticationTitle")
    def reset_token_authentication_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthenticationTitle", []))

    @jsii.member(jsii_name="resetTokenAuthHlsTitle")
    def reset_token_auth_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthHlsTitle", []))

    @jsii.member(jsii_name="resetTokenRevocationEnabled")
    def reset_token_revocation_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationEnabled", []))

    @jsii.member(jsii_name="resetTokenRevocationTitle")
    def reset_token_revocation_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationTitle", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aclInput")
    def acl_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "aclInput"))

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryptionInput")
    def dash_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="dataPayloadInput")
    def data_payload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dataPayloadInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUriInput")
    def enable_token_in_uri_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTokenInUriInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOverInput")
    def field_carry_over_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldCarryOverInput"))

    @builtins.property
    @jsii.member(jsii_name="headerForSaltInput")
    def header_for_salt_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headerForSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFilesInput")
    def hls_master_manifest_files_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "hlsMasterManifestFilesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryptionInput")
    def hls_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitleInput")
    def media_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="revokedListIdInput")
    def revoked_list_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "revokedListIdInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionIdInput")
    def session_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitleInput")
    def token_authentication_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthenticationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitleInput")
    def token_auth_hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthHlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabledInput")
    def token_revocation_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenRevocationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitleInput")
    def token_revocation_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenRevocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acl")
    def acl(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "acl"))

    @acl.setter
    def acl(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__114b3f4442f3d091b51d2821634d6570c6901d6b4a0e7f0539f86fc93ecb0889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acl", value)

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryption")
    def dash_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dashMediaEncryption"))

    @dash_media_encryption.setter
    def dash_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a86752cc75ee93a89d90661fb6a6ab88c5c58c9098ccc1d117e0fb6404f3d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dashMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="dataPayload")
    def data_payload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dataPayload"))

    @data_payload.setter
    def data_payload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbc79fb5c365525883909c500dc4e15156c4fcf7a5d8919d8a7010a6aa1073c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataPayload", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10cdbc433176a559edc75656e355260bcb632ef45ca1a13ff2d64db149373b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUri")
    def enable_token_in_uri(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTokenInUri"))

    @enable_token_in_uri.setter
    def enable_token_in_uri(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbec7471660af05820e9e52a2e348d534f82024d34c84f0e0a28bedbccde86a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTokenInUri", value)

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOver")
    def field_carry_over(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fieldCarryOver"))

    @field_carry_over.setter
    def field_carry_over(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889de4de1f77e4759e93628c07175b87e7cee9d3a3c633aa1fcec77e474faf64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fieldCarryOver", value)

    @builtins.property
    @jsii.member(jsii_name="headerForSalt")
    def header_for_salt(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headerForSalt"))

    @header_for_salt.setter
    def header_for_salt(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111897d4a7c97e679861445d7bdb1032b707a9f193d2c671ba689a2c56da598d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerForSalt", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFiles")
    def hls_master_manifest_files(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "hlsMasterManifestFiles"))

    @hls_master_manifest_files.setter
    def hls_master_manifest_files(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c828b65c3c4deea84174c9e9ff9a4c71dad90ec7137e069d2c3741aabd336b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMasterManifestFiles", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryption")
    def hls_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsMediaEncryption"))

    @hls_media_encryption.setter
    def hls_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__956656e6ea2cd3b6d8fb71f542388e379e9ffab3e93d4c9bc6cd86968a5eff5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__735dd46ea01ac8f6ed9801991ab23085dea541c03fa44855babc1599ce0a0eae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34cde6d2f10101d0835f2136ffd4089acb96a345af7e4946c46ca0adb59f232a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ac4b4a856bf77c7f0b0a8f74d1aa2cc3ebe6a333521521e8f0ad78cc3b9c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitle")
    def media_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaEncryptionTitle"))

    @media_encryption_title.setter
    def media_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7668ad2384c5cf2a65216d14e9077b96e8f63dee480c7fcd7d73d8c651ac2193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="revokedListId")
    def revoked_list_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "revokedListId"))

    @revoked_list_id.setter
    def revoked_list_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a61cd9d8a6b72561bf632fd0ad085a706222dd9eb4308ba6ba15dc80ab2ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revokedListId", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70109b1ddc50f126b65a217fed248dc6246de6217f53ddabda0544b1b580e10e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="sessionId")
    def session_id(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionId"))

    @session_id.setter
    def session_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8daa3ee36169993ced924787860e9e4641e69c8d985d4e375d65a3bcdb4303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e336d636fde8111e65211b88866c9e849f050d4934d6e2387ce6e3049a3b58cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitle")
    def token_authentication_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthenticationTitle"))

    @token_authentication_title.setter
    def token_authentication_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965294fbeab8c399427dce7b9d33e49e1fd7100c68d995fc969dfbe3a23423fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthenticationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitle")
    def token_auth_hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthHlsTitle"))

    @token_auth_hls_title.setter
    def token_auth_hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1507c5f46f7eb2a40deb0236cbe1bd6c4d6d7c80668064cf5e30a5e97766b0da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthHlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabled")
    def token_revocation_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenRevocationEnabled"))

    @token_revocation_enabled.setter
    def token_revocation_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1386cb71fc7fbf1825a253472d24189cf3b5853a3fe63edb6198af28d81fc67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitle")
    def token_revocation_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenRevocationTitle"))

    @token_revocation_title.setter
    def token_revocation_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74dc61c892ca1d2252cc66ac5eda4aa516039301f844319972e2276d65ebd8d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f72c28c6f39dbd94ae90eae30b65b1895555acc0e3333910d8587eb934d8e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1c22953937a2dabce4efdb52ea736b55f7100e21a0e3d4266df04dba9ca9cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e636ab1b8fec1190bb88e34813973e728bd7d1065df9017bf11a0a9e116fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b1dc221260ed0f49f67a28bfe4a65ac3fd8d09090a37fea68052ee2c27559a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "dvr_type": "dvrType",
        "dvr_window": "dvrWindow",
        "enable_ull_streaming": "enableUllStreaming",
        "end_time": "endTime",
        "live_type": "liveType",
        "locked": "locked",
        "show_advanced": "showAdvanced",
        "start_time": "startTime",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8723991e2f0cf1a5101849707bf5783887b0f1b1fbd40370fb853fad419fae22)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument dvr_type", value=dvr_type, expected_type=type_hints["dvr_type"])
            check_type(argname="argument dvr_window", value=dvr_window, expected_type=type_hints["dvr_window"])
            check_type(argname="argument enable_ull_streaming", value=enable_ull_streaming, expected_type=type_hints["enable_ull_streaming"])
            check_type(argname="argument end_time", value=end_time, expected_type=type_hints["end_time"])
            check_type(argname="argument live_type", value=live_type, expected_type=type_hints["live_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument show_advanced", value=show_advanced, expected_type=type_hints["show_advanced"])
            check_type(argname="argument start_time", value=start_time, expected_type=type_hints["start_time"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if dvr_type is not None:
            self._values["dvr_type"] = dvr_type
        if dvr_window is not None:
            self._values["dvr_window"] = dvr_window
        if enable_ull_streaming is not None:
            self._values["enable_ull_streaming"] = enable_ull_streaming
        if end_time is not None:
            self._values["end_time"] = end_time
        if live_type is not None:
            self._values["live_type"] = live_type
        if locked is not None:
            self._values["locked"] = locked
        if show_advanced is not None:
            self._values["show_advanced"] = show_advanced
        if start_time is not None:
            self._values["start_time"] = start_time
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Sets the type of media content to optimize.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_type(self) -> typing.Optional[builtins.str]:
        '''The type of DVR.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        '''
        result = self._values.get("dvr_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_window(self) -> typing.Optional[builtins.str]:
        '''Set the duration for your media, or ``0m`` if a DVR is not required.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        '''
        result = self._values.get("dvr_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_ull_streaming(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        '''
        result = self._values.get("enable_ull_streaming")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def end_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event ends.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        '''
        result = self._values.get("end_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def live_type(self) -> typing.Optional[builtins.str]:
        '''The type of live media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        '''
        result = self._values.get("live_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced media options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        '''
        result = self._values.get("show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def start_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event begins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        '''
        result = self._values.get("start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c83778a2ef8f66c6ac5733e72be3a4d14ea0139681a71db456dcdc02d77909)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetDvrType")
    def reset_dvr_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrType", []))

    @jsii.member(jsii_name="resetDvrWindow")
    def reset_dvr_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrWindow", []))

    @jsii.member(jsii_name="resetEnableUllStreaming")
    def reset_enable_ull_streaming(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableUllStreaming", []))

    @jsii.member(jsii_name="resetEndTime")
    def reset_end_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndTime", []))

    @jsii.member(jsii_name="resetLiveType")
    def reset_live_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetShowAdvanced")
    def reset_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShowAdvanced", []))

    @jsii.member(jsii_name="resetStartTime")
    def reset_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartTime", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrTypeInput")
    def dvr_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrWindowInput")
    def dvr_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="enableUllStreamingInput")
    def enable_ull_streaming_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableUllStreamingInput"))

    @builtins.property
    @jsii.member(jsii_name="endTimeInput")
    def end_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="liveTypeInput")
    def live_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "liveTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="showAdvancedInput")
    def show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "showAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="startTimeInput")
    def start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ae48599df9dc3b71f48fb83e4205334bd85f50b90b368398a72c8b1d66e71b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="dvrType")
    def dvr_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrType"))

    @dvr_type.setter
    def dvr_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f5f56e6c1acb6feab52e4c5a4126a88572721b61cb5dc4700bbbf3b3690fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrType", value)

    @builtins.property
    @jsii.member(jsii_name="dvrWindow")
    def dvr_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrWindow"))

    @dvr_window.setter
    def dvr_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f3b0e78cad6465815df37bca7ad14b23eaf93c8dbd98b30e5437375330e669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrWindow", value)

    @builtins.property
    @jsii.member(jsii_name="enableUllStreaming")
    def enable_ull_streaming(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableUllStreaming"))

    @enable_ull_streaming.setter
    def enable_ull_streaming(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ace856b4d84a5bb793e379a15684a9acceae0bb37acdfa345fc7b40513fb9d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableUllStreaming", value)

    @builtins.property
    @jsii.member(jsii_name="endTime")
    def end_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endTime"))

    @end_time.setter
    def end_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fe1cb92dc35e929a015c890e06a28971d69ef636d21c76cb39c274504641063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endTime", value)

    @builtins.property
    @jsii.member(jsii_name="liveType")
    def live_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "liveType"))

    @live_type.setter
    def live_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f745ea79f762e797b0b20e949581270a0ba7f9aa2771848a27f3348d881a855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1321c7ebaae61e1365af466619e67f57163ca5a1575703e7740443c501bfa80a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="showAdvanced")
    def show_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "showAdvanced"))

    @show_advanced.setter
    def show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21f3be192a0d2cd935a2543417c49aa8e0fcb2d3597fbdeb2e5c03ca0c5e1de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "showAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="startTime")
    def start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "startTime"))

    @start_time.setter
    def start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894019181fe2e546704c16ae72644d32f722c76a64a100fb884bddef2f59ffd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startTime", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9afe54defa483f5e00cffb973ee780a91c80c6e8ce8c912fd201cf1abcab8b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024db49e2d20cf72fde6a7391889b044723775a39adc6f6fa5fd6f3a9b515878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5cce1581228782a970c28762e9334ead4fe66fe7aca15c2b1af3396de467d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6257bc32400c291eeca76de32a124b2a0bb572397aad53bd3608e4796f183ff9)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables media stream prefetching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f97a8f75f620d868babf173747afc5c710b70d3408d028366b0999efb72f3c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__522288e0abf101b49afb757257d0b0a0dd04134d790f2f95acbdeee0fc7d04cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30f5bd857ad65590f71dbcc2f13fd298465b14669a31c73ebc73c5d835600f18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3107d7fe625fd40e7e53468ae1956243bf57ce21966e245b80cd46706e80d2db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc795495a39a2996a90d382a9dd77862500c6ad9631a0b998d45f8c6cec40736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a35e83d4dd29efbde3f522e34711c91f181abff375d346ea0038c661da2b8dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "case_sensitive": "caseSensitive",
        "certificate_field_name": "certificateFieldName",
        "cookie_name": "cookieName",
        "device_profile": "deviceProfile",
        "encryption_key": "encryptionKey",
        "encryption_mode": "encryptionMode",
        "end_index": "endIndex",
        "except_chars": "exceptChars",
        "extract_location": "extractLocation",
        "force_chars": "forceChars",
        "format_string": "formatString",
        "generator": "generator",
        "global_substitution": "globalSubstitution",
        "header_name": "headerName",
        "hmac_algorithm": "hmacAlgorithm",
        "hmac_key": "hmacKey",
        "initialization_vector": "initializationVector",
        "ipv4_prefix": "ipv4Prefix",
        "ipv6_prefix": "ipv6Prefix",
        "ip_version": "ipVersion",
        "location_id": "locationId",
        "locked": "locked",
        "max": "max",
        "max_random_number": "maxRandomNumber",
        "min": "min",
        "min_random_number": "minRandomNumber",
        "nonce": "nonce",
        "number_of_bytes": "numberOfBytes",
        "operand_one": "operandOne",
        "param_name": "paramName",
        "path_component_offset": "pathComponentOffset",
        "prepend_bytes": "prependBytes",
        "query_parameter_name": "queryParameterName",
        "regex": "regex",
        "replacement": "replacement",
        "response_header_name": "responseHeaderName",
        "separator": "separator",
        "set_cookie_name": "setCookieName",
        "start_index": "startIndex",
        "sub_string": "subString",
        "template_uuid": "templateUuid",
        "transform": "transform",
        "uuid": "uuid",
        "value_source": "valueSource",
        "variable_name": "variableName",
        "variable_value": "variableValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[builtins.str] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[builtins.str] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[builtins.str] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3967cbe16238dfb55c32b445dd71adb561b577ece15c9065153f989c9fba2ce)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument certificate_field_name", value=certificate_field_name, expected_type=type_hints["certificate_field_name"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument device_profile", value=device_profile, expected_type=type_hints["device_profile"])
            check_type(argname="argument encryption_key", value=encryption_key, expected_type=type_hints["encryption_key"])
            check_type(argname="argument encryption_mode", value=encryption_mode, expected_type=type_hints["encryption_mode"])
            check_type(argname="argument end_index", value=end_index, expected_type=type_hints["end_index"])
            check_type(argname="argument except_chars", value=except_chars, expected_type=type_hints["except_chars"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument force_chars", value=force_chars, expected_type=type_hints["force_chars"])
            check_type(argname="argument format_string", value=format_string, expected_type=type_hints["format_string"])
            check_type(argname="argument generator", value=generator, expected_type=type_hints["generator"])
            check_type(argname="argument global_substitution", value=global_substitution, expected_type=type_hints["global_substitution"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument hmac_algorithm", value=hmac_algorithm, expected_type=type_hints["hmac_algorithm"])
            check_type(argname="argument hmac_key", value=hmac_key, expected_type=type_hints["hmac_key"])
            check_type(argname="argument initialization_vector", value=initialization_vector, expected_type=type_hints["initialization_vector"])
            check_type(argname="argument ipv4_prefix", value=ipv4_prefix, expected_type=type_hints["ipv4_prefix"])
            check_type(argname="argument ipv6_prefix", value=ipv6_prefix, expected_type=type_hints["ipv6_prefix"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max", value=max, expected_type=type_hints["max"])
            check_type(argname="argument max_random_number", value=max_random_number, expected_type=type_hints["max_random_number"])
            check_type(argname="argument min", value=min, expected_type=type_hints["min"])
            check_type(argname="argument min_random_number", value=min_random_number, expected_type=type_hints["min_random_number"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument number_of_bytes", value=number_of_bytes, expected_type=type_hints["number_of_bytes"])
            check_type(argname="argument operand_one", value=operand_one, expected_type=type_hints["operand_one"])
            check_type(argname="argument param_name", value=param_name, expected_type=type_hints["param_name"])
            check_type(argname="argument path_component_offset", value=path_component_offset, expected_type=type_hints["path_component_offset"])
            check_type(argname="argument prepend_bytes", value=prepend_bytes, expected_type=type_hints["prepend_bytes"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument replacement", value=replacement, expected_type=type_hints["replacement"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument separator", value=separator, expected_type=type_hints["separator"])
            check_type(argname="argument set_cookie_name", value=set_cookie_name, expected_type=type_hints["set_cookie_name"])
            check_type(argname="argument start_index", value=start_index, expected_type=type_hints["start_index"])
            check_type(argname="argument sub_string", value=sub_string, expected_type=type_hints["sub_string"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transform", value=transform, expected_type=type_hints["transform"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value_source", value=value_source, expected_type=type_hints["value_source"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_value", value=variable_value, expected_type=type_hints["variable_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if certificate_field_name is not None:
            self._values["certificate_field_name"] = certificate_field_name
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if device_profile is not None:
            self._values["device_profile"] = device_profile
        if encryption_key is not None:
            self._values["encryption_key"] = encryption_key
        if encryption_mode is not None:
            self._values["encryption_mode"] = encryption_mode
        if end_index is not None:
            self._values["end_index"] = end_index
        if except_chars is not None:
            self._values["except_chars"] = except_chars
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if force_chars is not None:
            self._values["force_chars"] = force_chars
        if format_string is not None:
            self._values["format_string"] = format_string
        if generator is not None:
            self._values["generator"] = generator
        if global_substitution is not None:
            self._values["global_substitution"] = global_substitution
        if header_name is not None:
            self._values["header_name"] = header_name
        if hmac_algorithm is not None:
            self._values["hmac_algorithm"] = hmac_algorithm
        if hmac_key is not None:
            self._values["hmac_key"] = hmac_key
        if initialization_vector is not None:
            self._values["initialization_vector"] = initialization_vector
        if ipv4_prefix is not None:
            self._values["ipv4_prefix"] = ipv4_prefix
        if ipv6_prefix is not None:
            self._values["ipv6_prefix"] = ipv6_prefix
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if max is not None:
            self._values["max"] = max
        if max_random_number is not None:
            self._values["max_random_number"] = max_random_number
        if min is not None:
            self._values["min"] = min
        if min_random_number is not None:
            self._values["min_random_number"] = min_random_number
        if nonce is not None:
            self._values["nonce"] = nonce
        if number_of_bytes is not None:
            self._values["number_of_bytes"] = number_of_bytes
        if operand_one is not None:
            self._values["operand_one"] = operand_one
        if param_name is not None:
            self._values["param_name"] = param_name
        if path_component_offset is not None:
            self._values["path_component_offset"] = path_component_offset
        if prepend_bytes is not None:
            self._values["prepend_bytes"] = prepend_bytes
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex is not None:
            self._values["regex"] = regex
        if replacement is not None:
            self._values["replacement"] = replacement
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if separator is not None:
            self._values["separator"] = separator
        if set_cookie_name is not None:
            self._values["set_cookie_name"] = set_cookie_name
        if start_index is not None:
            self._values["start_index"] = start_index
        if sub_string is not None:
            self._values["sub_string"] = sub_string
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transform is not None:
            self._values["transform"] = transform
        if uuid is not None:
            self._values["uuid"] = uuid
        if value_source is not None:
            self._values["value_source"] = value_source
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_value is not None:
            self._values["variable_value"] = variable_value

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this makes all matches case sensitive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def certificate_field_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the certificate's content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        '''
        result = self._values.get("certificate_field_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def device_profile(self) -> typing.Optional[builtins.str]:
        '''Specifies the client device attribute.

        Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        '''
        result = self._values.get("device_profile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption hex key.

        For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        '''
        result = self._values.get("encryption_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        '''
        result = self._values.get("encryption_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_index(self) -> typing.Optional[builtins.str]:
        '''Specifies the zero-based character offset at the end of the substring, without including the character at that index position.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        '''
        result = self._values.get("end_index")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def except_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters ``not`` to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        '''
        result = self._values.get("except_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''This specifies from where to get the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def force_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        '''
        result = self._values.get("force_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format_string(self) -> typing.Optional[builtins.str]:
        '''Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``.

        A blank value defaults to RFC-2616 format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        '''
        result = self._values.get("format_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def generator(self) -> typing.Optional[builtins.str]:
        '''This specifies the type of value to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        '''
        result = self._values.get("generator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def global_substitution(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches in the string, not just the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        '''
        result = self._values.get("global_substitution")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to use to generate the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        '''
        result = self._values.get("hmac_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret to use in generating the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        '''
        result = self._values.get("hmac_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def initialization_vector(self) -> typing.Optional[builtins.str]:
        '''Specifies a one-time number as an initialization vector.

        It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        '''
        result = self._values.get("initialization_vector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ipv4_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV4 address, a value between 0 and 32.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        '''
        result = self._values.get("ipv4_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ipv6_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV6 address, a value between 0 and 128.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        '''
        result = self._values.get("ipv6_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the IP version under which a subnet mask generates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``X-Akamai-Edgescape`` header's field name.

        Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max(self) -> typing.Optional[jsii.Number]:
        '''Specifies a maximum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        '''
        result = self._values.get("max")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def max_random_number(self) -> typing.Optional[builtins.str]:
        '''Specifies the upper bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        '''
        result = self._values.get("max_random_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min(self) -> typing.Optional[jsii.Number]:
        '''Specifies a minimum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        '''
        result = self._values.get("min")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min_random_number(self) -> typing.Optional[builtins.str]:
        '''Specifies the lower bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        '''
        result = self._values.get("min_random_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the one-time number used for encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def number_of_bytes(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of random hex bytes to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        '''
        result = self._values.get("number_of_bytes")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def operand_one(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        '''
        result = self._values.get("operand_one")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def param_name(self) -> typing.Optional[builtins.str]:
        '''Extracts the value for the specified parameter name from a string that contains key/value pairs.

        (Use ``separator`` below to parse them.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        '''
        result = self._values.get("param_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def path_component_offset(self) -> typing.Optional[builtins.str]:
        '''This specifies a portion of the path.

        The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        '''
        result = self._values.get("path_component_offset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prepend_bytes(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a number of random bytes to prepend to the key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        '''
        result = self._values.get("prepend_bytes")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression pattern (PCRE) to match the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replacement(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        '''
        result = self._values.get("replacement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def separator(self) -> typing.Optional[builtins.str]:
        '''Specifies the character that separates pairs of values within the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        '''
        result = self._values.get("separator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def set_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the origin's ``Set-Cookie`` response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        '''
        result = self._values.get("set_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start_index(self) -> typing.Optional[builtins.str]:
        '''Specifies the zero-based character offset at the start of the substring.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        '''
        result = self._values.get("start_index")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sub_string(self) -> typing.Optional[builtins.str]:
        '''Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        '''
        result = self._values.get("sub_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transform(self) -> typing.Optional[builtins.str]:
        '''Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        '''
        result = self._values.get("transform")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_source(self) -> typing.Optional[builtins.str]:
        '''Determines how you want to set the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        '''
        result = self._values.get("value_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the predeclared root name of the variable to modify.

        When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_value(self) -> typing.Optional[builtins.str]:
        '''This directly specifies the value to assign to the variable.

        The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        result = self._values.get("variable_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55c45cd3e7fc990bfb6bf59fd724ff9f8a758108245d6f9f886a608d135e21fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetCertificateFieldName")
    def reset_certificate_field_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateFieldName", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDeviceProfile")
    def reset_device_profile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceProfile", []))

    @jsii.member(jsii_name="resetEncryptionKey")
    def reset_encryption_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionKey", []))

    @jsii.member(jsii_name="resetEncryptionMode")
    def reset_encryption_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionMode", []))

    @jsii.member(jsii_name="resetEndIndex")
    def reset_end_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndIndex", []))

    @jsii.member(jsii_name="resetExceptChars")
    def reset_except_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExceptChars", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetForceChars")
    def reset_force_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceChars", []))

    @jsii.member(jsii_name="resetFormatString")
    def reset_format_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatString", []))

    @jsii.member(jsii_name="resetGenerator")
    def reset_generator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGenerator", []))

    @jsii.member(jsii_name="resetGlobalSubstitution")
    def reset_global_substitution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalSubstitution", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetHmacAlgorithm")
    def reset_hmac_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacAlgorithm", []))

    @jsii.member(jsii_name="resetHmacKey")
    def reset_hmac_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacKey", []))

    @jsii.member(jsii_name="resetInitializationVector")
    def reset_initialization_vector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInitializationVector", []))

    @jsii.member(jsii_name="resetIpv4Prefix")
    def reset_ipv4_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv4Prefix", []))

    @jsii.member(jsii_name="resetIpv6Prefix")
    def reset_ipv6_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv6Prefix", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMax")
    def reset_max(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMax", []))

    @jsii.member(jsii_name="resetMaxRandomNumber")
    def reset_max_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxRandomNumber", []))

    @jsii.member(jsii_name="resetMin")
    def reset_min(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMin", []))

    @jsii.member(jsii_name="resetMinRandomNumber")
    def reset_min_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinRandomNumber", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetNumberOfBytes")
    def reset_number_of_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumberOfBytes", []))

    @jsii.member(jsii_name="resetOperandOne")
    def reset_operand_one(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperandOne", []))

    @jsii.member(jsii_name="resetParamName")
    def reset_param_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParamName", []))

    @jsii.member(jsii_name="resetPathComponentOffset")
    def reset_path_component_offset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPathComponentOffset", []))

    @jsii.member(jsii_name="resetPrependBytes")
    def reset_prepend_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrependBytes", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetReplacement")
    def reset_replacement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacement", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetSeparator")
    def reset_separator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeparator", []))

    @jsii.member(jsii_name="resetSetCookieName")
    def reset_set_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetCookieName", []))

    @jsii.member(jsii_name="resetStartIndex")
    def reset_start_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartIndex", []))

    @jsii.member(jsii_name="resetSubString")
    def reset_sub_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubString", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransform")
    def reset_transform(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransform", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValueSource")
    def reset_value_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueSource", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValue")
    def reset_variable_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValue", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldNameInput")
    def certificate_field_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldNameInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceProfileInput")
    def device_profile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deviceProfileInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionKeyInput")
    def encryption_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionModeInput")
    def encryption_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="endIndexInput")
    def end_index_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="exceptCharsInput")
    def except_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "exceptCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="forceCharsInput")
    def force_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forceCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="formatStringInput")
    def format_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatStringInput"))

    @builtins.property
    @jsii.member(jsii_name="generatorInput")
    def generator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "generatorInput"))

    @builtins.property
    @jsii.member(jsii_name="globalSubstitutionInput")
    def global_substitution_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "globalSubstitutionInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithmInput")
    def hmac_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacKeyInput")
    def hmac_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="initializationVectorInput")
    def initialization_vector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "initializationVectorInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv4PrefixInput")
    def ipv4_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv4PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv6PrefixInput")
    def ipv6_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv6PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxInput")
    def max_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxInput"))

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumberInput")
    def max_random_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="minInput")
    def min_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minInput"))

    @builtins.property
    @jsii.member(jsii_name="minRandomNumberInput")
    def min_random_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="numberOfBytesInput")
    def number_of_bytes_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numberOfBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="operandOneInput")
    def operand_one_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operandOneInput"))

    @builtins.property
    @jsii.member(jsii_name="paramNameInput")
    def param_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paramNameInput"))

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffsetInput")
    def path_component_offset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathComponentOffsetInput"))

    @builtins.property
    @jsii.member(jsii_name="prependBytesInput")
    def prepend_bytes_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prependBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementInput")
    def replacement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="separatorInput")
    def separator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "separatorInput"))

    @builtins.property
    @jsii.member(jsii_name="setCookieNameInput")
    def set_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "setCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="startIndexInput")
    def start_index_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="subStringInput")
    def sub_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subStringInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transformInput")
    def transform_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transformInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueSourceInput")
    def value_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValueInput")
    def variable_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableValueInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99ab346f07f9a2815fc91ec4a6ba80fd13ac03eadfc7952369efa2482967a4b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__131fb6947ebba90daf6115279a307de9ca225e151e3629aa8e449f7703cab040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="certificateFieldName")
    def certificate_field_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateFieldName"))

    @certificate_field_name.setter
    def certificate_field_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c16be9fd3daec187ba82d19e2b9bcb30697fa7d29029c31877d850165903250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateFieldName", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__081f950d87afaa205ca8b40474ec2b1cd65ae785f80ad4013ee9518d174fa71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="deviceProfile")
    def device_profile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deviceProfile"))

    @device_profile.setter
    def device_profile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2516f779c6255f8b545a1d6217c380eae31a8f5cbe8eff63926a5bc1cb3401bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deviceProfile", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionKey")
    def encryption_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionKey"))

    @encryption_key.setter
    def encryption_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f805da7e324605396522793d89520b8fd1b7990223c7c70c9ee70105ca7fd901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionKey", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionMode")
    def encryption_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionMode"))

    @encryption_mode.setter
    def encryption_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8084795bc2e9f912e8786b51fa0a0bce73facca68e7f0e0f672531d45f559faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionMode", value)

    @builtins.property
    @jsii.member(jsii_name="endIndex")
    def end_index(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endIndex"))

    @end_index.setter
    def end_index(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98c102a33738982295805ab99cf0f69ea728368c2f7a384d92e1640e9d5002c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endIndex", value)

    @builtins.property
    @jsii.member(jsii_name="exceptChars")
    def except_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "exceptChars"))

    @except_chars.setter
    def except_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c2e4bac1777f6b068ecaed72830962e892a882b8652bdd46ee8c4cb39649e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exceptChars", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5172a9f321b60157c07fe6630c82aff6a7c7d87557617651c0325680b16462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="forceChars")
    def force_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forceChars"))

    @force_chars.setter
    def force_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30e53ef099c3bc297ad08adb7c3b6a4a7474b853aae9c80f15379d086438f6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceChars", value)

    @builtins.property
    @jsii.member(jsii_name="formatString")
    def format_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatString"))

    @format_string.setter
    def format_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95333a9e7647bdbd665f087186947ae9964dbf55a81cf9236f92210da7891431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatString", value)

    @builtins.property
    @jsii.member(jsii_name="generator")
    def generator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "generator"))

    @generator.setter
    def generator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e8b0b17b1f776e03c663aec4cc2dd9254d5af2fe185adf9a1c3fa86310e65b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "generator", value)

    @builtins.property
    @jsii.member(jsii_name="globalSubstitution")
    def global_substitution(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "globalSubstitution"))

    @global_substitution.setter
    def global_substitution(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea13ff7b78befb37e70c546e9d67d8c31da77a95f369e919ee442f6822e6e9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "globalSubstitution", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e6b19da70b45b3a92dbed9d94803d6fe12a8e26df93069890ff93faa9de717c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithm")
    def hmac_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacAlgorithm"))

    @hmac_algorithm.setter
    def hmac_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eb785ed333428310c80ecdc2d67eac0ae09a44d0a6505c74eae55fa24b1031c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hmacKey")
    def hmac_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacKey"))

    @hmac_key.setter
    def hmac_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666e041211f4d8c3249d1a7c17d3cf19bfee4faed056174f2b2cde049e45a78a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacKey", value)

    @builtins.property
    @jsii.member(jsii_name="initializationVector")
    def initialization_vector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "initializationVector"))

    @initialization_vector.setter
    def initialization_vector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a5c48242e771d512ea0243e182ea3e58d733109fdcc5a36ea9c3529fc2b3c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "initializationVector", value)

    @builtins.property
    @jsii.member(jsii_name="ipv4Prefix")
    def ipv4_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv4Prefix"))

    @ipv4_prefix.setter
    def ipv4_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a511fa0e2da237b33fd802d3e65a4f62f035acf49fb2b888d7cef6cbf2e501c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv4Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipv6Prefix")
    def ipv6_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv6Prefix"))

    @ipv6_prefix.setter
    def ipv6_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faff0d8ed2499abf5ebfdc45f98c62bc1f4679ca91761929a1ad4a0683ba17b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv6Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36a410774ac3bb35bb42fb4eecd092ea737177a3862f05b026018d9cae392ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30451418b180c771146f0970b67f3eaff20e20b7aed530553ad2695fea66d000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37c604cc78637dc61f12b209c83e2b461d643df570472f67ac584685e6817e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="max")
    def max(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "max"))

    @max.setter
    def max(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86e55e522d89809197af042f2818fd7f02c7296533ed55d291182f71a85a5ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "max", value)

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumber")
    def max_random_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxRandomNumber"))

    @max_random_number.setter
    def max_random_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338e584c4a2f4776546aefd02e0306ad2009d5440e28d7e0dcc05357bc73651a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="min")
    def min(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "min"))

    @min.setter
    def min(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85d0930e8ca30aaedd717dc2e11f9f22ddc01367d4b1c993a30ab3a7b60da6d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "min", value)

    @builtins.property
    @jsii.member(jsii_name="minRandomNumber")
    def min_random_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minRandomNumber"))

    @min_random_number.setter
    def min_random_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae9fcc7fb726e1c3b54d4888eb46663f0aaf2c2359cbcce02408d0b055399f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345434d4da05b1b51fd4d1998bf3dff099d142820f380f7700ce0809ee8e0d51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="numberOfBytes")
    def number_of_bytes(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numberOfBytes"))

    @number_of_bytes.setter
    def number_of_bytes(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67d04ae7fdff5361c6f5f9f66e182a2ee8b8cd7277444819ec9aa2becff1e168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numberOfBytes", value)

    @builtins.property
    @jsii.member(jsii_name="operandOne")
    def operand_one(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operandOne"))

    @operand_one.setter
    def operand_one(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f8ca9f133a12503ee253d6d238e1bb26b79abe290bcd39b6fecdbae2635f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operandOne", value)

    @builtins.property
    @jsii.member(jsii_name="paramName")
    def param_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paramName"))

    @param_name.setter
    def param_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7694e7e1bec3713cc3f0bf4f9b3d581fa30350a7906e886d4b030d0620ee55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paramName", value)

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffset")
    def path_component_offset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pathComponentOffset"))

    @path_component_offset.setter
    def path_component_offset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dfb8ab7cbc5032ccb78bc7aa5efc82ad64ecd38553a0e0769304764b0e87b25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pathComponentOffset", value)

    @builtins.property
    @jsii.member(jsii_name="prependBytes")
    def prepend_bytes(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prependBytes"))

    @prepend_bytes.setter
    def prepend_bytes(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abe586481b6fae357e45f464a04bab2081f01fdac7d7a515163bcda5914ae63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prependBytes", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566593102ca1f61158429cb841ec121c9a2d84f1855bd0642228c5bf1693a2e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d5e2112fcb1fc2d27bd660a78e3933e05ee33c488c6cdd0afbb8d1525413ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="replacement")
    def replacement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacement"))

    @replacement.setter
    def replacement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bdd1f8638ccbd0e77839c9852f1d598f27f4ab607587b62f2e6b21589f42e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacement", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493f2a0349428a43115888acde3ebae1ad8a8c8b3738873cdaebcf60017fc5e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="separator")
    def separator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "separator"))

    @separator.setter
    def separator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e56c8c495953c9ba99e8b5a0f3433fb748f45e86ab280fde6122bd2a0e16cc59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "separator", value)

    @builtins.property
    @jsii.member(jsii_name="setCookieName")
    def set_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "setCookieName"))

    @set_cookie_name.setter
    def set_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902ccd5ab983714ff102fe37a28d48edd9057fc3e46d80b466addfda50d2ae23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "setCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="startIndex")
    def start_index(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "startIndex"))

    @start_index.setter
    def start_index(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01046b0cefca632e091711361f7e76d5c9fc849a0c5062f56afb07fc575bd73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startIndex", value)

    @builtins.property
    @jsii.member(jsii_name="subString")
    def sub_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subString"))

    @sub_string.setter
    def sub_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c843d41cda011b2c429f599d75788b1b02b76c462cfdf75dde0f040873ff3c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subString", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a1b132f9626ce24245d56183c0746a302c555e24ea1279ef4de8a163e17907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transform")
    def transform(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transform"))

    @transform.setter
    def transform(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556919bee518fb261dee20f1ba4d01800203f1916773f6339d1fef9dc82ac544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transform", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347610296ca4a88f9ef5ada74b36f9742b752d98e81565a59c1d40f0b3416292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="valueSource")
    def value_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueSource"))

    @value_source.setter
    def value_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b2d526cdd207235521ac7a3cc4aca1a7119b39bec1f8201e47e197cbfd4052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueSource", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d41cb0d4a144e4ae017a5a952a6d554a048bbce529fdb0770e20b9b6d1b689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValue")
    def variable_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableValue"))

    @variable_value.setter
    def variable_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf55aa593e9d8fe804d8bf1be7fc0337343a0954cf60a9131a453efb59b618f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3a75d3810a8e19534af9c7ead9d5ec0eb532128c1d41d53333c607b7284f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode",
    jsii_struct_bases=[],
    name_mapping={
        "error_type": "errorType",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode:
    def __init__(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f05ff632bd0f2a5b3d17bac60a17b1803b037e62008cd2f32aeb105f356d865c)
            check_type(argname="argument error_type", value=error_type, expected_type=type_hints["error_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if error_type is not None:
            self._values["error_type"] = error_type
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def error_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        '''
        result = self._values.get("error_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b8d70db1f800fab4b2d05c2dd1c6931f42599c188556a8cf13ec3fe11f34a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetErrorType")
    def reset_error_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetErrorType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="errorTypeInput")
    def error_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "errorTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="errorType")
    def error_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "errorType"))

    @error_type.setter
    def error_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78199f3c18a1764cf076bd7bacb23a39744d36655413e3891e1c120ec7f2da14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "errorType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef7e7f62a088948922db87e6ab4f6b3e4019fcd23db10acfbe00e09663f3905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e19c517264454ca74850defef10a7a61bcf1cd3b1a20e800fc36c383496f216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6980e67e8d10a45f0f99be6b3baa36ebaabfdaf5fb35fc52eccd5288996962b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4185d5a0bca5d94c7ed36ec4bcc5e4bf6579d50c0526ad9e2d0af5b33f7ef215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692a850a215800e2e41ed5950f1b8cc68e75429cc25932a871e44fe5e3e7821c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "nossmap": "nossmap",
        "ssmap": "ssmap",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(ssmap, dict):
            ssmap = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap(**ssmap)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ace11d3d4a7e0e3ec2111eaa44e01a039deb42923d551453389bfd9d283b2e5)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nossmap", value=nossmap, expected_type=type_hints["nossmap"])
            check_type(argname="argument ssmap", value=ssmap, expected_type=type_hints["ssmap"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if nossmap is not None:
            self._values["nossmap"] = nossmap
        if ssmap is not None:
            self._values["ssmap"] = ssmap
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nossmap(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        '''
        result = self._values.get("nossmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ssmap(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap"]:
        '''ssmap block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        '''
        result = self._values.get("ssmap")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760d90693b4323b6d84ff262be77cbfa1ff17903edfbea8f5f4ae176082ecc4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putSsmap")
    def put_ssmap(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap(
            china_cdn_map=china_cdn_map,
            has_mixed_hosts=has_mixed_hosts,
            name=name,
            src=src,
            srmap=srmap,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putSsmap", [value_]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNossmap")
    def reset_nossmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNossmap", []))

    @jsii.member(jsii_name="resetSsmap")
    def reset_ssmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSsmap", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="ssmap")
    def ssmap(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmapOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmapOutputReference", jsii.get(self, "ssmap"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nossmapInput")
    def nossmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nossmapInput"))

    @builtins.property
    @jsii.member(jsii_name="ssmapInput")
    def ssmap_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap"], jsii.get(self, "ssmapInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91cc3559bd673328f1c00cae3598387ba0360210f7374abc1447383d910597b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nossmap")
    def nossmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nossmap"))

    @nossmap.setter
    def nossmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a362ce6c2e64947ea5a6716b8936ba5fe42ec71bc02f1bfd85c1e0343655432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nossmap", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a94b1869978997f3d875c868e4ca920797a2fde2885fcce733e7139777962804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4905e9a81148b7b3d771b9f90dbe7ad0b91e75f9c685c67649223817c659d560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f24ce7bb2ff225c1a16e6a73bedf5eb6ccd71c064e5f39629756b9dfdcf8983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap",
    jsii_struct_bases=[],
    name_mapping={
        "china_cdn_map": "chinaCdnMap",
        "has_mixed_hosts": "hasMixedHosts",
        "name": "name",
        "src": "src",
        "srmap": "srmap",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap:
    def __init__(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8febd03a3c8a49bf3e2fb6ef2088b03475cadaa14f10993c5939015519bb92)
            check_type(argname="argument china_cdn_map", value=china_cdn_map, expected_type=type_hints["china_cdn_map"])
            check_type(argname="argument has_mixed_hosts", value=has_mixed_hosts, expected_type=type_hints["has_mixed_hosts"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument src", value=src, expected_type=type_hints["src"])
            check_type(argname="argument srmap", value=srmap, expected_type=type_hints["srmap"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if china_cdn_map is not None:
            self._values["china_cdn_map"] = china_cdn_map
        if has_mixed_hosts is not None:
            self._values["has_mixed_hosts"] = has_mixed_hosts
        if name is not None:
            self._values["name"] = name
        if src is not None:
            self._values["src"] = src
        if srmap is not None:
            self._values["srmap"] = srmap
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def china_cdn_map(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.'''
        result = self._values.get("china_cdn_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def has_mixed_hosts(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.'''
        result = self._values.get("has_mixed_hosts")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def src(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.'''
        result = self._values.get("src")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def srmap(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.'''
        result = self._values.get("srmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75666701f6811177fd8ba1174bd66973295ee4587f6a5a8ee69929341f7d3f94)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetChinaCdnMap")
    def reset_china_cdn_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnMap", []))

    @jsii.member(jsii_name="resetHasMixedHosts")
    def reset_has_mixed_hosts(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHasMixedHosts", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetSrc")
    def reset_src(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrc", []))

    @jsii.member(jsii_name="resetSrmap")
    def reset_srmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrmap", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMapInput")
    def china_cdn_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chinaCdnMapInput"))

    @builtins.property
    @jsii.member(jsii_name="hasMixedHostsInput")
    def has_mixed_hosts_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hasMixedHostsInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="srcInput")
    def src_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srcInput"))

    @builtins.property
    @jsii.member(jsii_name="srmapInput")
    def srmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srmapInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMap")
    def china_cdn_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chinaCdnMap"))

    @china_cdn_map.setter
    def china_cdn_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7119ce53808561cce0a79a5854c90afcd137b4a1c69e03c4ebc2327a1d82abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chinaCdnMap", value)

    @builtins.property
    @jsii.member(jsii_name="hasMixedHosts")
    def has_mixed_hosts(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hasMixedHosts"))

    @has_mixed_hosts.setter
    def has_mixed_hosts(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e87a6adbdd27a290b454627c5204324fa26076c5c0ad2fe68655c12841925c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hasMixedHosts", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1ded1700023b612ed44ad54b6302cbfbf9f14f982db86311e7f6a6f553fef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="src")
    def src(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "src"))

    @src.setter
    def src(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c18abe8a8b4f0f19afda4bebe6f6c99017dfb02b8fb6a74df042b7f7a2abab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "src", value)

    @builtins.property
    @jsii.member(jsii_name="srmap")
    def srmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srmap"))

    @srmap.setter
    def srmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc6adacec50b994aad08cc9bb169a41d5b8445f89bba31844bc29d5369f1276e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srmap", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f140d799b8fb44e3646f3df76b32bcae26e2637941dde5217241d20f8d64ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2ec682da1210cbab9368d3af45e331ba54f78db2cd5881a46247a57d8f9bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration",
    jsii_struct_bases=[],
    name_mapping={
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_https_upgrade": "allowHttpsUpgrade",
        "cache_sharing_duration": "cacheSharingDuration",
        "cache_sharing_start_time": "cacheSharingStartTime",
        "enabled": "enabled",
        "is_certificate_sni_only": "isCertificateSniOnly",
        "is_tiered_distribution_used": "isTieredDistributionUsed",
        "locked": "locked",
        "migration_duration": "migrationDuration",
        "migration_from": "migrationFrom",
        "migration_start_time": "migrationStartTime",
        "td_location": "tdLocation",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration:
    def __init__(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f1dcc9a7865a0657747c8e56fdcaa5e1675ff90e3c6bfcb7f466f9d316bd69)
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_https_upgrade", value=allow_https_upgrade, expected_type=type_hints["allow_https_upgrade"])
            check_type(argname="argument cache_sharing_duration", value=cache_sharing_duration, expected_type=type_hints["cache_sharing_duration"])
            check_type(argname="argument cache_sharing_start_time", value=cache_sharing_start_time, expected_type=type_hints["cache_sharing_start_time"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_certificate_sni_only", value=is_certificate_sni_only, expected_type=type_hints["is_certificate_sni_only"])
            check_type(argname="argument is_tiered_distribution_used", value=is_tiered_distribution_used, expected_type=type_hints["is_tiered_distribution_used"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument migration_duration", value=migration_duration, expected_type=type_hints["migration_duration"])
            check_type(argname="argument migration_from", value=migration_from, expected_type=type_hints["migration_from"])
            check_type(argname="argument migration_start_time", value=migration_start_time, expected_type=type_hints["migration_start_time"])
            check_type(argname="argument td_location", value=td_location, expected_type=type_hints["td_location"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_https_upgrade is not None:
            self._values["allow_https_upgrade"] = allow_https_upgrade
        if cache_sharing_duration is not None:
            self._values["cache_sharing_duration"] = cache_sharing_duration
        if cache_sharing_start_time is not None:
            self._values["cache_sharing_start_time"] = cache_sharing_start_time
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_certificate_sni_only is not None:
            self._values["is_certificate_sni_only"] = is_certificate_sni_only
        if is_tiered_distribution_used is not None:
            self._values["is_tiered_distribution_used"] = is_tiered_distribution_used
        if locked is not None:
            self._values["locked"] = locked
        if migration_duration is not None:
            self._values["migration_duration"] = migration_duration
        if migration_from is not None:
            self._values["migration_from"] = migration_from
        if migration_start_time is not None:
            self._values["migration_start_time"] = migration_start_time
        if td_location is not None:
            self._values["td_location"] = td_location
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allow temporary downgrade of HTTPS traffic to HTTP.

        This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_https_upgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows temporary upgrade of HTTP traffic to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        '''
        result = self._values.get("allow_https_upgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_sharing_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number cache sharing days.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        '''
        result = self._values.get("cache_sharing_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cache_sharing_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start cache sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        '''
        result = self._values.get("cache_sharing_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows migration to Standard TLS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_sni_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether your new certificate is SNI-only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        '''
        result = self._values.get("is_certificate_sni_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_tiered_distribution_used(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to align traffic to various ``tieredDistribution`` areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        '''
        result = self._values.get("is_tiered_distribution_used")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of days to migrate the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        '''
        result = self._values.get("migration_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def migration_from(self) -> typing.Optional[builtins.str]:
        '''What kind of traffic you're migrating from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        '''
        result = self._values.get("migration_from")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        '''
        result = self._values.get("migration_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def td_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``tieredDistribution`` location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        '''
        result = self._values.get("td_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5f91cbb6c405c604be9b0bb494a909bfa517f998e9863d7b08add5d451e847)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowHttpsUpgrade")
    def reset_allow_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsUpgrade", []))

    @jsii.member(jsii_name="resetCacheSharingDuration")
    def reset_cache_sharing_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingDuration", []))

    @jsii.member(jsii_name="resetCacheSharingStartTime")
    def reset_cache_sharing_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingStartTime", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsCertificateSniOnly")
    def reset_is_certificate_sni_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateSniOnly", []))

    @jsii.member(jsii_name="resetIsTieredDistributionUsed")
    def reset_is_tiered_distribution_used(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsTieredDistributionUsed", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMigrationDuration")
    def reset_migration_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationDuration", []))

    @jsii.member(jsii_name="resetMigrationFrom")
    def reset_migration_from(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationFrom", []))

    @jsii.member(jsii_name="resetMigrationStartTime")
    def reset_migration_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartTime", []))

    @jsii.member(jsii_name="resetTdLocation")
    def reset_td_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTdLocation", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgradeInput")
    def allow_https_upgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDurationInput")
    def cache_sharing_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cacheSharingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTimeInput")
    def cache_sharing_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheSharingStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnlyInput")
    def is_certificate_sni_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificateSniOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsedInput")
    def is_tiered_distribution_used_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isTieredDistributionUsedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationDurationInput")
    def migration_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "migrationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationFromInput")
    def migration_from_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationFromInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartTimeInput")
    def migration_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="tdLocationInput")
    def td_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tdLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsDowngrade"))

    @allow_https_downgrade.setter
    def allow_https_downgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be68bdf5b57b1018c659018b9ee179a7f89323346ec1bf7e2f3b1c72871c35c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsDowngrade", value)

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgrade")
    def allow_https_upgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsUpgrade"))

    @allow_https_upgrade.setter
    def allow_https_upgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e12b5fdbdb591e70175af16b9fd20463949071493103a8392bd43a3c4e60d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsUpgrade", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDuration")
    def cache_sharing_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cacheSharingDuration"))

    @cache_sharing_duration.setter
    def cache_sharing_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6655d0312af8a040966622e2a59e32dd7e4501b1f66d04e70961fddce644af06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTime")
    def cache_sharing_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheSharingStartTime"))

    @cache_sharing_start_time.setter
    def cache_sharing_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3f90f576fd98a51b3e80de90960518fe7721972a506e048f61f3bcdc95a613)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb39cf1aa7d5bd41a328e447ec3863decd9fe568ba7068bb00833e936f121afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnly")
    def is_certificate_sni_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificateSniOnly"))

    @is_certificate_sni_only.setter
    def is_certificate_sni_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab05152a33234ed8fee55b2e74a1de98b5da710a117a156b2b86153d29d4b6da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateSniOnly", value)

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsed")
    def is_tiered_distribution_used(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isTieredDistributionUsed"))

    @is_tiered_distribution_used.setter
    def is_tiered_distribution_used(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98bc59b5a8ee09d94ba5fee29ff4d70a9411a23684ede67437c78b0e80328a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isTieredDistributionUsed", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d44c53214f8b9b61a552bbc62e1fb385f23bc922568a79bf91aee0f921dc0cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="migrationDuration")
    def migration_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "migrationDuration"))

    @migration_duration.setter
    def migration_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a76c1696d9633f6c273d0e961871e69592913a75f1e0fb2e6049eba086f6b1b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="migrationFrom")
    def migration_from(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationFrom"))

    @migration_from.setter
    def migration_from(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1bb77d10aa4cb47f1283525df998d54a1812ba5d6e922ce088189598b90864e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationFrom", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartTime")
    def migration_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartTime"))

    @migration_start_time.setter
    def migration_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffec8ec38d73d6739e8607a3a2f8957bf08e80420ecd44aa2b09ce23f153cade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="tdLocation")
    def td_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tdLocation"))

    @td_location.setter
    def td_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50c83db8b31e1d58c642188ee0fd694294cd26eeb0049a7f5f04256e492c16c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tdLocation", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196d1d9a93493676093b2deba3d3e26a63d537ac8e705c7b4afb36ee4c33b89e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f82e82a5764a68803d0e2a15bd730c5337d50ea2d9904d78768752cc7729af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e34d8888a2ec8023b573e9c50468132eab8b33822868c3d31b0515b39f62159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "info": "info",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride:
    def __init__(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e28b3fbe0016beea34f4db971a2305095ba10e677dcaf1a36ac5355538c9a524)
            check_type(argname="argument info", value=info, expected_type=type_hints["info"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if info is not None:
            self._values["info"] = info
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def info(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        '''
        result = self._values.get("info")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666d145bc6630f4ceefe1f97896d3c087eaf3fca88cf7840b478e22a63495f7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetInfo")
    def reset_info(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInfo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="infoInput")
    def info_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "infoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="info")
    def info(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "info"))

    @info.setter
    def info(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcea75d2c040a080e239673d5b710b462dd0ecf024a89678ec6b5f72e1f61367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "info", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba22ad781912deafb2f1f90e6b523e0084bc7f37d87d776d031f07f68e838bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1fc62349531b49faf370eb57e04005e396c03e0d0517b3c9c92651c0ea7f3a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17dbe55f8f7bae6e3a383ad372bcb3c0c4a02b265bc9a76b82d68edd1d99aff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0413f424eff518d368b7420a5d83f1c2419743346f90d6497e4f39ffbd2c0aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "strict_mode": "strictMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "valid_mode": "validMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5b1a768a5b0c76379c5c108ab117e72ac1895d9284e0e54ed9100d16b8d817)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict_mode", value=strict_mode, expected_type=type_hints["strict_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument valid_mode", value=valid_mode, expected_type=type_hints["valid_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if strict_mode is not None:
            self._values["strict_mode"] = strict_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if valid_mode is not None:
            self._values["valid_mode"] = valid_mode

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF.

        When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        '''
        result = self._values.get("strict_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def valid_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines.

        When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        result = self._values.get("valid_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a72be06bc391268ced5cb4a782c83436ebb32bdb4895c5a3a254b081a52a8f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrictMode")
    def reset_strict_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValidMode")
    def reset_valid_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidMode", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictModeInput")
    def strict_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="validModeInput")
    def valid_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "validModeInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60062839741101a4db7c785dca4e2f84e4eec097d97ba11dd5e2efd61d934e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strictMode")
    def strict_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strictMode"))

    @strict_mode.setter
    def strict_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d8180c9fefb4aac5155ccbc3665804279d19d0f1cb511067c5329cb966e168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strictMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0795467bb4ee01b29402ecdef7e37d34d43cbc647deabf08e6a32a7085f07942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b74041987d5cc30a795e0d59a9bc26c6ffc320d20e2ab01fc048c5023a429b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="validMode")
    def valid_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "validMode"))

    @valid_mode.setter
    def valid_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b0709149f3a3bb9ca0cc3234310a650e65fff283340736c13c16ecaea0e24f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e60ec3b821b7f6e17cb185cb94404b54b63e75041e04ff14d9f9bae2d48fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer",
    jsii_struct_bases=[],
    name_mapping={
        "access_control": "accessControl",
        "cache_key": "cacheKey",
        "caching": "caching",
        "content_compressor": "contentCompressor",
        "dynamic_web_content": "dynamicWebContent",
        "enabled": "enabled",
        "geo_location": "geoLocation",
        "ip": "ip",
        "large_file_delivery": "largeFileDelivery",
        "live_video_delivery": "liveVideoDelivery",
        "locked": "locked",
        "modify_path": "modifyPath",
        "on_demand_video_delivery": "onDemandVideoDelivery",
        "origin": "origin",
        "partner_domain_suffix": "partnerDomainSuffix",
        "referrer": "referrer",
        "refresh_content": "refreshContent",
        "site_failover": "siteFailover",
        "template_uuid": "templateUuid",
        "token_authorization": "tokenAuthorization",
        "uuid": "uuid",
        "web_application_firewall": "webApplicationFirewall",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer:
    def __init__(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57c0a8cdeb43e2f464daea4f3ad5846b3e81d110fba0882afd0efaa9fe5a507)
            check_type(argname="argument access_control", value=access_control, expected_type=type_hints["access_control"])
            check_type(argname="argument cache_key", value=cache_key, expected_type=type_hints["cache_key"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument content_compressor", value=content_compressor, expected_type=type_hints["content_compressor"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument geo_location", value=geo_location, expected_type=type_hints["geo_location"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument large_file_delivery", value=large_file_delivery, expected_type=type_hints["large_file_delivery"])
            check_type(argname="argument live_video_delivery", value=live_video_delivery, expected_type=type_hints["live_video_delivery"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_path", value=modify_path, expected_type=type_hints["modify_path"])
            check_type(argname="argument on_demand_video_delivery", value=on_demand_video_delivery, expected_type=type_hints["on_demand_video_delivery"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument partner_domain_suffix", value=partner_domain_suffix, expected_type=type_hints["partner_domain_suffix"])
            check_type(argname="argument referrer", value=referrer, expected_type=type_hints["referrer"])
            check_type(argname="argument refresh_content", value=refresh_content, expected_type=type_hints["refresh_content"])
            check_type(argname="argument site_failover", value=site_failover, expected_type=type_hints["site_failover"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_control is not None:
            self._values["access_control"] = access_control
        if cache_key is not None:
            self._values["cache_key"] = cache_key
        if caching is not None:
            self._values["caching"] = caching
        if content_compressor is not None:
            self._values["content_compressor"] = content_compressor
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if geo_location is not None:
            self._values["geo_location"] = geo_location
        if ip is not None:
            self._values["ip"] = ip
        if large_file_delivery is not None:
            self._values["large_file_delivery"] = large_file_delivery
        if live_video_delivery is not None:
            self._values["live_video_delivery"] = live_video_delivery
        if locked is not None:
            self._values["locked"] = locked
        if modify_path is not None:
            self._values["modify_path"] = modify_path
        if on_demand_video_delivery is not None:
            self._values["on_demand_video_delivery"] = on_demand_video_delivery
        if origin is not None:
            self._values["origin"] = origin
        if partner_domain_suffix is not None:
            self._values["partner_domain_suffix"] = partner_domain_suffix
        if referrer is not None:
            self._values["referrer"] = referrer
        if refresh_content is not None:
            self._values["refresh_content"] = refresh_content
        if site_failover is not None:
            self._values["site_failover"] = site_failover
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if uuid is not None:
            self._values["uuid"] = uuid
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall

    @builtins.property
    def access_control(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        '''
        result = self._values.get("access_control")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set which query parameters are included in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        '''
        result = self._values.get("cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies content caching rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_compressor(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows compression of subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        '''
        result = self._values.get("content_compressor")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Cloud Embed to dynamically modify your subcustomers' content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_location(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' location-based whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        '''
        result = self._values.get("geo_location")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' IP whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def large_file_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables large file delivery for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        '''
        result = self._values.get("large_file_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def live_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.'''
        result = self._values.get("live_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies a subcustomer's request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        '''
        result = self._values.get("modify_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def on_demand_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables delivery of media assets to subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        '''
        result = self._values.get("on_demand_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign origin hostnames for customers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner_domain_suffix(self) -> typing.Optional[builtins.str]:
        '''This specifies the appropriate domain suffix, which you should typically match with your property hostname.

        It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        '''
        result = self._values.get("partner_domain_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' referrer whitelists or blacklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        '''
        result = self._values.get("referrer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to reschedule when content validates for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        '''
        result = self._values.get("refresh_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def site_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure unique failover sites for each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        '''
        result = self._values.get("site_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content.

        Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic.

        Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f33bfcccb52833c33395b1ea89d92b08d070fc9b234aa71d38b386467f1dc316)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessControl")
    def reset_access_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessControl", []))

    @jsii.member(jsii_name="resetCacheKey")
    def reset_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKey", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetContentCompressor")
    def reset_content_compressor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCompressor", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGeoLocation")
    def reset_geo_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoLocation", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLargeFileDelivery")
    def reset_large_file_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileDelivery", []))

    @jsii.member(jsii_name="resetLiveVideoDelivery")
    def reset_live_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveVideoDelivery", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyPath")
    def reset_modify_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyPath", []))

    @jsii.member(jsii_name="resetOnDemandVideoDelivery")
    def reset_on_demand_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOnDemandVideoDelivery", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetPartnerDomainSuffix")
    def reset_partner_domain_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartnerDomainSuffix", []))

    @jsii.member(jsii_name="resetReferrer")
    def reset_referrer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrer", []))

    @jsii.member(jsii_name="resetRefreshContent")
    def reset_refresh_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshContent", []))

    @jsii.member(jsii_name="resetSiteFailover")
    def reset_site_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteFailover", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @builtins.property
    @jsii.member(jsii_name="accessControlInput")
    def access_control_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessControlInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyInput")
    def cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCompressorInput")
    def content_compressor_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCompressorInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="geoLocationInput")
    def geo_location_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "geoLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileDeliveryInput")
    def large_file_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "largeFileDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="liveVideoDeliveryInput")
    def live_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "liveVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyPathInput")
    def modify_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyPathInput"))

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDeliveryInput")
    def on_demand_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "onDemandVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffixInput")
    def partner_domain_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerDomainSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerInput")
    def referrer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "referrerInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshContentInput")
    def refresh_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "refreshContentInput"))

    @builtins.property
    @jsii.member(jsii_name="siteFailoverInput")
    def site_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "siteFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="accessControl")
    def access_control(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessControl"))

    @access_control.setter
    def access_control(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8934e22f9095a557bba9ab185f0671befc64af3c613ce10c4ff7dd2bc7dc5eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessControl", value)

    @builtins.property
    @jsii.member(jsii_name="cacheKey")
    def cache_key(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheKey"))

    @cache_key.setter
    def cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1feba5b2971afcd4c12b89f52539c2e924f23edac3fa5ae9620302aa59023daf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caching"))

    @caching.setter
    def caching(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__473a8c3213219531ffb88a62e7cab633800989110b55ee03aefddc267b57c1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caching", value)

    @builtins.property
    @jsii.member(jsii_name="contentCompressor")
    def content_compressor(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCompressor"))

    @content_compressor.setter
    def content_compressor(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd1f21b49fefb986caa035c713bc773c41a03259b00671a038d74b59c6996adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCompressor", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicWebContent"))

    @dynamic_web_content.setter
    def dynamic_web_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11fbcf3114d8c804a74aab7b2a8dafeee7a5f8f8444f2048c4506d1240ed5192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicWebContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da4e907b9c662716d72489623bb65ed18c6aec53e19e39a5cd29a797718f363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="geoLocation")
    def geo_location(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "geoLocation"))

    @geo_location.setter
    def geo_location(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53137bee079338fca7684b4665bc2456442bd45389c290e1e6dd5c4b623df710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoLocation", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a372e47e82b886fe142a32c127167473cf81bd310f4c8e8f642b8a1bc3b99a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="largeFileDelivery")
    def large_file_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "largeFileDelivery"))

    @large_file_delivery.setter
    def large_file_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57bf7ec7f0857aea62c8a760a23c5e695f9fcbead21c3752e1d11be8a7434d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "largeFileDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="liveVideoDelivery")
    def live_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "liveVideoDelivery"))

    @live_video_delivery.setter
    def live_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f3441ea9200b0b998fe0b1aa6c795be588ce3bcd6f4d096aa310de2f4699fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b943633f1fb3cceff3c953220d71bc154c09228646f3d4300a3d4133a63d38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyPath")
    def modify_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyPath"))

    @modify_path.setter
    def modify_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ea98bb2a021dd06b7bffe2cba7aa16ea7ceea45760832e9fd8d60eb16dc3d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyPath", value)

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDelivery")
    def on_demand_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "onDemandVideoDelivery"))

    @on_demand_video_delivery.setter
    def on_demand_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d3508e5ce11eb843ad16707ffda339af7319fb438c1169beb3c46f422f03bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "onDemandVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "origin"))

    @origin.setter
    def origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bfa2ade9e46ed89aabf88e81c80ec84f8cc1196fce04031ab6d50f90b82c319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origin", value)

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffix")
    def partner_domain_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partnerDomainSuffix"))

    @partner_domain_suffix.setter
    def partner_domain_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b601c6a026384e5f09b1f1118428ca70c0137d6927bbab8c6c500f6345b82c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partnerDomainSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="referrer")
    def referrer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "referrer"))

    @referrer.setter
    def referrer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86ebbf8bee720f2a5988215ef4c1f18bf7b1b2f96e41abd194531d20f062073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrer", value)

    @builtins.property
    @jsii.member(jsii_name="refreshContent")
    def refresh_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "refreshContent"))

    @refresh_content.setter
    def refresh_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba2b3903e09e43a7ce71111362920b82a3baad1cd315a51a63638728ac69f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshContent", value)

    @builtins.property
    @jsii.member(jsii_name="siteFailover")
    def site_failover(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "siteFailover"))

    @site_failover.setter
    def site_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca1724b04c0311c1cb73e149c595060ba82e45d5b8d7cd3464db05a831c7c40b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "siteFailover", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9fbdac6836bed5e857676eccef001b88170f9f95235d2c9984d11c764f0ba8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenAuthorization"))

    @token_authorization.setter
    def token_authorization(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8103416c8343d2f25b2408014dceaf60da055386333237c0d695b305f4a6c00c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthorization", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1dbc4b2d172b2f00b8bacc60d0dd091d18b675c66ffd4b6b949536704907c1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "webApplicationFirewall"))

    @web_application_firewall.setter
    def web_application_firewall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0982d9b5b9c0239c89fbcf9da52d06f97241d82ebb73819ac6be85bc9302899e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "webApplicationFirewall", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51e4588d0c33b37ad732dfa10ff30e396ddf258c266d9c5d3fc7a9c23eb45b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute",
    jsii_struct_bases=[],
    name_mapping={
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "custom_map": "customMap",
        "custom_stat_key": "customStatKey",
        "enable_custom_key": "enableCustomKey",
        "enabled": "enabled",
        "force_ssl_forward": "forceSslForward",
        "locked": "locked",
        "race_stat_ttl": "raceStatTtl",
        "sr_download_link_title": "srDownloadLinkTitle",
        "template_uuid": "templateUuid",
        "test_object_url": "testObjectUrl",
        "to_host": "toHost",
        "to_host_status": "toHostStatus",
        "type": "type",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute:
    def __init__(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbe0b529ed6ae243c06906d21363959872b628e7074cb9c5a876c596c2038be4)
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument custom_map", value=custom_map, expected_type=type_hints["custom_map"])
            check_type(argname="argument custom_stat_key", value=custom_stat_key, expected_type=type_hints["custom_stat_key"])
            check_type(argname="argument enable_custom_key", value=enable_custom_key, expected_type=type_hints["enable_custom_key"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_ssl_forward", value=force_ssl_forward, expected_type=type_hints["force_ssl_forward"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument race_stat_ttl", value=race_stat_ttl, expected_type=type_hints["race_stat_ttl"])
            check_type(argname="argument sr_download_link_title", value=sr_download_link_title, expected_type=type_hints["sr_download_link_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument test_object_url", value=test_object_url, expected_type=type_hints["test_object_url"])
            check_type(argname="argument to_host", value=to_host, expected_type=type_hints["to_host"])
            check_type(argname="argument to_host_status", value=to_host_status, expected_type=type_hints["to_host_status"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if custom_map is not None:
            self._values["custom_map"] = custom_map
        if custom_stat_key is not None:
            self._values["custom_stat_key"] = custom_stat_key
        if enable_custom_key is not None:
            self._values["enable_custom_key"] = enable_custom_key
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_ssl_forward is not None:
            self._values["force_ssl_forward"] = force_ssl_forward
        if locked is not None:
            self._values["locked"] = locked
        if race_stat_ttl is not None:
            self._values["race_stat_ttl"] = race_stat_ttl
        if sr_download_link_title is not None:
            self._values["sr_download_link_title"] = sr_download_link_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if test_object_url is not None:
            self._values["test_object_url"] = test_object_url
        if to_host is not None:
            self._values["to_host"] = to_host
        if to_host_status is not None:
            self._values["to_host_status"] = to_host_status
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map(self) -> typing.Optional[builtins.str]:
        '''If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        '''
        result = self._values.get("custom_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_stat_key(self) -> typing.Optional[builtins.str]:
        '''This specifies a hostname under which to cache race results.

        This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        '''
        result = self._values.get("custom_stat_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_custom_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        '''
        result = self._values.get("enable_custom_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the SureRoute behavior, to optimize delivery of non-cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_ssl_forward(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        '''
        result = self._values.get("force_ssl_forward")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def race_stat_ttl(self) -> typing.Optional[builtins.str]:
        '''Specifies the time-to-live to preserve SureRoute race results, typically ``30m``.

        If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        '''
        result = self._values.get("race_stat_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sr_download_link_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        '''
        result = self._values.get("sr_download_link_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def test_object_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the path and filename for your origin's test object to use in races to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        '''
        result = self._values.get("test_object_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host(self) -> typing.Optional[builtins.str]:
        '''If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        '''
        result = self._values.get("to_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host_status(self) -> typing.Optional[builtins.str]:
        '''Specifies which hostname to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        '''
        result = self._values.get("to_host_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of edge servers used to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRouteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRouteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b50709d47a612f744ba222c998b8f3da7b712e19f831cde373358f2aa30fa1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCustomMap")
    def reset_custom_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMap", []))

    @jsii.member(jsii_name="resetCustomStatKey")
    def reset_custom_stat_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatKey", []))

    @jsii.member(jsii_name="resetEnableCustomKey")
    def reset_enable_custom_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCustomKey", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceSslForward")
    def reset_force_ssl_forward(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceSslForward", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRaceStatTtl")
    def reset_race_stat_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRaceStatTtl", []))

    @jsii.member(jsii_name="resetSrDownloadLinkTitle")
    def reset_sr_download_link_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrDownloadLinkTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTestObjectUrl")
    def reset_test_object_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTestObjectUrl", []))

    @jsii.member(jsii_name="resetToHost")
    def reset_to_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHost", []))

    @jsii.member(jsii_name="resetToHostStatus")
    def reset_to_host_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHostStatus", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapInput")
    def custom_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatKeyInput")
    def custom_stat_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCustomKeyInput")
    def enable_custom_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCustomKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceSslForwardInput")
    def force_ssl_forward_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceSslForwardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="raceStatTtlInput")
    def race_stat_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "raceStatTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitleInput")
    def sr_download_link_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srDownloadLinkTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="testObjectUrlInput")
    def test_object_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "testObjectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostInput")
    def to_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostStatusInput")
    def to_host_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff1babf48bbd1849a8a182cc128e8a3eaa18037a17856255dfd3760bca8f81b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="customMap")
    def custom_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMap"))

    @custom_map.setter
    def custom_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327208dd6a2b054046109ede05f700b4ba3d341ef9a17b7bb2d4f7a336f5b274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMap", value)

    @builtins.property
    @jsii.member(jsii_name="customStatKey")
    def custom_stat_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatKey"))

    @custom_stat_key.setter
    def custom_stat_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4dfd3387681ba1870015d4a2d9abcc7a74423ce1c84e126b12ad1ae5c4e3455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatKey", value)

    @builtins.property
    @jsii.member(jsii_name="enableCustomKey")
    def enable_custom_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCustomKey"))

    @enable_custom_key.setter
    def enable_custom_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af081cc55ef87d72984190f40d9a853f8e40f5a1c2a0383bc8fa378d4944631d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCustomKey", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97b09de0497c902198601f2e66e29cd037886ac22cf80f4d0b85ab16d3cf62c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceSslForward")
    def force_ssl_forward(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceSslForward"))

    @force_ssl_forward.setter
    def force_ssl_forward(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b17474f84aab0fc6a02a3cf846cbbcdf3d083721aae8e3285aa5001e0a1f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceSslForward", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51dd1c384e365659e8613d6944ac8a9b816d1c264c6c8ba4a8f80273150f8fed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="raceStatTtl")
    def race_stat_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "raceStatTtl"))

    @race_stat_ttl.setter
    def race_stat_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a5532c003ee85acd545f4006019bc131015194d3fb865b8a60c709091e5583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "raceStatTtl", value)

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitle")
    def sr_download_link_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srDownloadLinkTitle"))

    @sr_download_link_title.setter
    def sr_download_link_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0471327d303d24869d44f653650444af03ac548276fea211ba84cf52518c2fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srDownloadLinkTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d346070656ea7e83fd3fa3c12d189c5342cd2df1653d700bffba7b804c8c43cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="testObjectUrl")
    def test_object_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "testObjectUrl"))

    @test_object_url.setter
    def test_object_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__386ac223abf268f2b64aa9fe38a7706ee5df3767db1dd75bdb8633569682a7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "testObjectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="toHost")
    def to_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHost"))

    @to_host.setter
    def to_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27c54efbd83b8c3e13915cf0ac23fc16a4b0ed91855d1eefe97c1e3328f0c273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHost", value)

    @builtins.property
    @jsii.member(jsii_name="toHostStatus")
    def to_host_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHostStatus"))

    @to_host_status.setter
    def to_host_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3dda6ea1e1755ce6e868521c39ff2f4abf366a038d44747792a47ae2b586a5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHostStatus", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94ca27a0f1726fe232f5e4feb28de868f22183458abfc1184590321bf670a12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfc8621eb04781d5d27eaae8d6c2e8d4cfe534b1f829dadc14eedf00b36726a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d305dbc23980ca8281419c47a73cd0069fc952c46c778410a73b1c910759ab9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77d47859c7ea72d41060f230a185175944d95ad38c059e94b15d92452a9fabd)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__089674c4fa7503c8768f4ed96883024ad3ffab0925addbd040a0b97f9f63ce18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77643a4fde538cb8c6f34dd6a89b551ef5c0cc1d3c1489564208364f302b0793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039c99846340081b24d6965143f3a7d6e0ff8bd5419eddd54e6ad006f24fd781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed2c3e58efa5964604cb46766ef39a7fc066f730478a85d8a8d965261e6369b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1865eefefc787e09639d73eb37713b34723d781afab229ea3eb1c7e4cf9ab0f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545cf8c86a7a8a96e1ed14b505acad2e5df883dee501d06f13cf98d2cb56fdcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "ibm_customer_id": "ibmCustomerId",
        "limit_to_dynamic": "limitToDynamic",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cdd59b98ac591a2b62328aaaceb756c77a68f2096b44ccfddb3d92b607fdb95)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument ibm_customer_id", value=ibm_customer_id, expected_type=type_hints["ibm_customer_id"])
            check_type(argname="argument limit_to_dynamic", value=limit_to_dynamic, expected_type=type_hints["limit_to_dynamic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if ibm_customer_id is not None:
            self._values["ibm_customer_id"] = ibm_customer_id
        if limit_to_dynamic is not None:
            self._values["limit_to_dynamic"] = limit_to_dynamic
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ibm_customer_id(self) -> typing.Optional[jsii.Number]:
        '''The integer identifier for the IBM Tealeaf Connector account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        '''
        result = self._values.get("ibm_customer_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_to_dynamic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Limit traffic to dynamic, uncached (``No-Store``) content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        '''
        result = self._values.get("limit_to_dynamic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeafOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeafOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef304883820ea59fab0b14ebf90129e98ff62456838e27d8820c9563a2e0f5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIbmCustomerId")
    def reset_ibm_customer_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIbmCustomerId", []))

    @jsii.member(jsii_name="resetLimitToDynamic")
    def reset_limit_to_dynamic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitToDynamic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerIdInput")
    def ibm_customer_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ibmCustomerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="limitToDynamicInput")
    def limit_to_dynamic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "limitToDynamicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b257a02ec5ee3ed0a9c9cd109192df5365fafe3ed7261096c885203fc722d9c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerId")
    def ibm_customer_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ibmCustomerId"))

    @ibm_customer_id.setter
    def ibm_customer_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a83a9e82af02a556b16da387f0e57575c9361a37e5cd651ba004cad2e2d6aec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ibmCustomerId", value)

    @builtins.property
    @jsii.member(jsii_name="limitToDynamic")
    def limit_to_dynamic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "limitToDynamic"))

    @limit_to_dynamic.setter
    def limit_to_dynamic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46a5a8f779be3abf83c5fd56a9fdbab09968b8d98c8d59c76c74fd8a549e3a58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitToDynamic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d9e09f91764a8f43dac5d74450ecbd743b78a76ed39040cf67de2ce5a39455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc403a63248d69b4fb6331150598ceeffa87749389752e93aea99008a88b9d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e24bbd5fe08bad1b62557ad9b08c208ee3ca4bc1eb38abbc270d2dda264a301f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64f22b65c1db2257d63761ab98834b45827a250e8917ef32c3175414667bbbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eedb209d143806193c2935e1ca3f282b285afb1ca00345cd94f0c1f2b24d630)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin.

        A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "allowall": "allowall",
        "enabled": "enabled",
        "locked": "locked",
        "method": "method",
        "policy": "policy",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced:
    def __init__(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b603c51b501089a7543f030f18b298d4c3990eb9cada5e3706555e2010f29b8c)
            check_type(argname="argument allowall", value=allowall, expected_type=type_hints["allowall"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument method", value=method, expected_type=type_hints["method"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowall is not None:
            self._values["allowall"] = allowall
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if method is not None:
            self._values["method"] = method
        if policy is not None:
            self._values["policy"] = policy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allowall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.'''
        result = self._values.get("allowall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def method(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.'''
        result = self._values.get("method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.'''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe;

        ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c230199c742293a1891722c9abd63f9c7954e880432d377d603e2bc3bb0c7623)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowall")
    def reset_allowall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowall", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethod")
    def reset_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethod", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowallInput")
    def allowall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowallInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodInput")
    def method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "methodInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowall")
    def allowall(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowall"))

    @allowall.setter
    def allowall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf73e6bb97b0182d713562880d1a9db84e3a9ec9665d9669e8210fcd3fad477f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowall", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ca82ce5b89f3276b42f3f331d19147694db9aa75880fe7d59277f31466ad79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52dfc84ef68f0ce3ece4befc543b2ad9d8d33bfee13f9e16c29247b8db28a743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="method")
    def method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "method"))

    @method.setter
    def method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b39ce05b7f84860d1770f60d88e4348db73a6a4c84f7ef6fa5acf896478e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "method", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1448b39bd7671c43c0e0919ebf9b5b372c5aa844cf2540e802035dacbc74d36f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f99aa5c656e8dcaa029c7cb53c5e36ba099471338f4b2c1408e7c2279e7c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d49f7aeac023888ed90aa68a89507a3c8a1ba24ba7ee8f2ca1c95145758bc61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__699dba8619d226f70a0d0f7a9e08bb6a8e4a292b77b1a5a5296ce4a576597f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1fbb563e3f2e85d71c92e70a50150cc1498ba90e504e0296132ab5dd7be4115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization",
    jsii_struct_bases=[],
    name_mapping={
        "cloudwrapper_map_migration_title": "cloudwrapperMapMigrationTitle",
        "custom_map_enabled": "customMapEnabled",
        "custom_map_name": "customMapName",
        "hash_algorithm": "hashAlgorithm",
        "location": "location",
        "locked": "locked",
        "map_migration_enabled": "mapMigrationEnabled",
        "migration_end_date": "migrationEndDate",
        "migration_start_date": "migrationStartDate",
        "migration_within_cw_maps_enabled": "migrationWithinCwMapsEnabled",
        "serial_end": "serialEnd",
        "serial_start": "serialStart",
        "template_uuid": "templateUuid",
        "tier1_title": "tier1Title",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization:
    def __init__(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a292b58f13498abd92c9a71baf5c179c9d942f55202a96f4433eca081888517)
            check_type(argname="argument cloudwrapper_map_migration_title", value=cloudwrapper_map_migration_title, expected_type=type_hints["cloudwrapper_map_migration_title"])
            check_type(argname="argument custom_map_enabled", value=custom_map_enabled, expected_type=type_hints["custom_map_enabled"])
            check_type(argname="argument custom_map_name", value=custom_map_name, expected_type=type_hints["custom_map_name"])
            check_type(argname="argument hash_algorithm", value=hash_algorithm, expected_type=type_hints["hash_algorithm"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument map_migration_enabled", value=map_migration_enabled, expected_type=type_hints["map_migration_enabled"])
            check_type(argname="argument migration_end_date", value=migration_end_date, expected_type=type_hints["migration_end_date"])
            check_type(argname="argument migration_start_date", value=migration_start_date, expected_type=type_hints["migration_start_date"])
            check_type(argname="argument migration_within_cw_maps_enabled", value=migration_within_cw_maps_enabled, expected_type=type_hints["migration_within_cw_maps_enabled"])
            check_type(argname="argument serial_end", value=serial_end, expected_type=type_hints["serial_end"])
            check_type(argname="argument serial_start", value=serial_start, expected_type=type_hints["serial_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_title", value=tier1_title, expected_type=type_hints["tier1_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudwrapper_map_migration_title is not None:
            self._values["cloudwrapper_map_migration_title"] = cloudwrapper_map_migration_title
        if custom_map_enabled is not None:
            self._values["custom_map_enabled"] = custom_map_enabled
        if custom_map_name is not None:
            self._values["custom_map_name"] = custom_map_name
        if hash_algorithm is not None:
            self._values["hash_algorithm"] = hash_algorithm
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if map_migration_enabled is not None:
            self._values["map_migration_enabled"] = map_migration_enabled
        if migration_end_date is not None:
            self._values["migration_end_date"] = migration_end_date
        if migration_start_date is not None:
            self._values["migration_start_date"] = migration_start_date
        if migration_within_cw_maps_enabled is not None:
            self._values["migration_within_cw_maps_enabled"] = migration_within_cw_maps_enabled
        if serial_end is not None:
            self._values["serial_end"] = serial_end
        if serial_start is not None:
            self._values["serial_start"] = serial_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_title is not None:
            self._values["tier1_title"] = tier1_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudwrapper_map_migration_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        '''
        result = self._values.get("cloudwrapper_map_migration_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_map_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables custom maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        '''
        result = self._values.get("custom_map_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom map name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        '''
        result = self._values.get("custom_map_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        '''
        result = self._values.get("hash_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Location from which Cloud Wrapper migration is performed.

        User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def map_migration_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration of the custom map to Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        '''
        result = self._values.get("map_migration_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_end_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the map migration should end.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        '''
        result = self._values.get("migration_end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the map.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        '''
        result = self._values.get("migration_start_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration within Cloud Wrapper maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        '''
        result = self._values.get("migration_within_cw_maps_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_end(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial end value.

        Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        '''
        result = self._values.get("serial_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def serial_start(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial start value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        '''
        result = self._values.get("serial_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        '''
        result = self._values.get("tier1_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__956b7ab28c9bcd8a4aa237a2633d1e9db99b482afb609e4b160da2e1f07432cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudwrapperMapMigrationTitle")
    def reset_cloudwrapper_map_migration_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudwrapperMapMigrationTitle", []))

    @jsii.member(jsii_name="resetCustomMapEnabled")
    def reset_custom_map_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapEnabled", []))

    @jsii.member(jsii_name="resetCustomMapName")
    def reset_custom_map_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapName", []))

    @jsii.member(jsii_name="resetHashAlgorithm")
    def reset_hash_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashAlgorithm", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMapMigrationEnabled")
    def reset_map_migration_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMapMigrationEnabled", []))

    @jsii.member(jsii_name="resetMigrationEndDate")
    def reset_migration_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationEndDate", []))

    @jsii.member(jsii_name="resetMigrationStartDate")
    def reset_migration_start_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartDate", []))

    @jsii.member(jsii_name="resetMigrationWithinCwMapsEnabled")
    def reset_migration_within_cw_maps_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationWithinCwMapsEnabled", []))

    @jsii.member(jsii_name="resetSerialEnd")
    def reset_serial_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialEnd", []))

    @jsii.member(jsii_name="resetSerialStart")
    def reset_serial_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1Title")
    def reset_tier1_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1Title", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitleInput")
    def cloudwrapper_map_migration_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cloudwrapperMapMigrationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapEnabledInput")
    def custom_map_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customMapEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapNameInput")
    def custom_map_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithmInput")
    def hash_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabledInput")
    def map_migration_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mapMigrationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationEndDateInput")
    def migration_end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationEndDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartDateInput")
    def migration_start_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabledInput")
    def migration_within_cw_maps_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "migrationWithinCwMapsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="serialEndInput")
    def serial_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialEndInput"))

    @builtins.property
    @jsii.member(jsii_name="serialStartInput")
    def serial_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1TitleInput")
    def tier1_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1TitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitle")
    def cloudwrapper_map_migration_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cloudwrapperMapMigrationTitle"))

    @cloudwrapper_map_migration_title.setter
    def cloudwrapper_map_migration_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd627ca17a073b0c28511cd7288b07adc3fd2e98d8a1e281c28c10b3edb11cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudwrapperMapMigrationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customMapEnabled")
    def custom_map_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customMapEnabled"))

    @custom_map_enabled.setter
    def custom_map_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c3b072febf0ea296211028e67f12d31fbbcb5f6ec49e241121d53bd33e3b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customMapName")
    def custom_map_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMapName"))

    @custom_map_name.setter
    def custom_map_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4349797644f91dab145d57bbce392c85ed98273937e8b7721669cfedb1b61985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapName", value)

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithm")
    def hash_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashAlgorithm"))

    @hash_algorithm.setter
    def hash_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57e59bd352b0f1763ce93d16d0d108b676594c2e6a00313c320f85639d70dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75fba2f77c73f7face12ee4e051e045908c582284fbb751c3e816cd72154cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43c0dd0db0cb1f2f66057eab126cf2880e9cdbdc325aeed0b9e7bd26d5cad4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabled")
    def map_migration_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mapMigrationEnabled"))

    @map_migration_enabled.setter
    def map_migration_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2d705f2bdbdabafda98f00f9f13bd0388a9d748dfeacbecdd35249bbd6d261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mapMigrationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="migrationEndDate")
    def migration_end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationEndDate"))

    @migration_end_date.setter
    def migration_end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de183d443ced01ad3b991915238d0e251396f502524778334732937d08caca51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationEndDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartDate")
    def migration_start_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartDate"))

    @migration_start_date.setter
    def migration_start_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13bca63669d50437e392e3464f43db83add4a5659dbfae997e17f792f5f66202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabled")
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "migrationWithinCwMapsEnabled"))

    @migration_within_cw_maps_enabled.setter
    def migration_within_cw_maps_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583bb6bbadb3aab1a8c0c3629322d70a4fb5696eba9d9c832aab8a164baa89b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationWithinCwMapsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="serialEnd")
    def serial_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialEnd"))

    @serial_end.setter
    def serial_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82dc9c25a6cfd44ad8b70d9f7e2436e77f4cea9b14145f8ea1232c4973e1e72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialEnd", value)

    @builtins.property
    @jsii.member(jsii_name="serialStart")
    def serial_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialStart"))

    @serial_start.setter
    def serial_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f58cf172023a360f93df51e2f10afb546f0691b51b741dc157df3725d13b2e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913e82dce24ee5a12b6b6d150b9a2b0d5d31c31eeaf052c481b51dd1600ccf4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1Title")
    def tier1_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1Title"))

    @tier1_title.setter
    def tier1_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0117c70148ff1883d3499374e5512467b17adf093bca9189802779d7ad78e5f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1Title", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dffe9a94e43291bfe1ce1537b8c7dd1c5f1eb3f8d69cfec008d8d222c97ef1d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13767dc0b4263066d5de37660d0d60ca40375ff6ee5d3bdbb5212d2718121ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192d3c8d7c381c7ae84bee3e03483e54c41761fa923c3a0a2f0de636218e4d56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2bdef48985ffdfc564f072fd71ead95b703f1b1d38a25d759df01560097bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a0b494521181754e916342309b42b70714e24f195ca414b20beec0a04639de4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f8174386799daffbc4832271546b798040c0b85b8560f299020af95da63d09e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53451abbf161ee9177c555ad756c9cecdcf7b5b741614ae3543f459a85643264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3ad6aa40b008a7890c85d8f51af87c434ee42f78a832384c664c06dc8820de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__941f0ad94b514ead3c812d98ffb50d3aba7aa09626312205197385d8f9c99c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cda8cafd59f5e1bd07869a4389d521c901e0a070c7cf160de9e656945fd4ec9)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout, for example ``10s``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9feefec19ff43be369dc44982ca4012ec859845108d611d1bae66865d10c7fba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5374912d8399dc9da6f5e78c20693130116f52c3ca2e9483e789577b95acd258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e026ceef5ad1dc4ca4cdb8aa97d704dee621c4ca85c6d1e8b9aab6dda758fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4662f9b75b4a9ef4d848aa2bb74cc25a51d7cb35b98c1b734a92bf94e3822887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b6503f862bcf9dbb1d14d1a9bacb32e2ea7b6c51767338bf2712fcd000041ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560ccdb052b7362166b28faceff348f45bf871f328eabdc5deba69d796dc76c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "legal_text": "legalText",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871b9ab481e2c99370a6b477074ec5efbc6922307b979b3f38e76e2d087408e1)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument legal_text", value=legal_text, expected_type=type_hints["legal_text"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if legal_text is not None:
            self._values["legal_text"] = legal_text
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract UIDs from client requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Where to extract the UID value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the HTTP header from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def legal_text(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        '''
        result = self._values.get("legal_text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the rule tree variable from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aebfbca50532e79bad917577647d5338fee213e2af80738ba2f3a0c45723f679)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLegalText")
    def reset_legal_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLegalText", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="legalTextInput")
    def legal_text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "legalTextInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d04c655c9fdb1776656df29790eb08880d3c6eaf9a7695d97448d6689fb73388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0369f6e2fceabbab7d58ce4b3959618eefa9b1a67f14daee5dbcd343df1d6c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bd643116852805d946d08c65b39a7720dfc100a29d7eb69edab23809190d4ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="legalText")
    def legal_text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "legalText"))

    @legal_text.setter
    def legal_text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24c98c81e9faa7dfac0872b83cbe4e5f0c1c069744d2e34666a78e657ab6174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "legalText", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e5acdff8d46bcdc957b4c8ca0890341f0957ed345c4f7a2df9cdfe658baeae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c6b0cd306a15c014f752a30a3c7c8933457dd3b2e36bd84520b00e7b67d58a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036b95055e6d21a6322a137eabd7187a847cef5463045ca79af2ded92859034d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae41c7966f5cbe45144eb3871b1c242cd5b4c8d2973285d88fa526eb4675020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00c4b3c1f16d3a7a5be9d2f1effe92caa4e72c407674a3c1828b7ed0f0cf7e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7731d70f9664ef5c2525b46d1f32179000d7c7d30ad58f7f7a44ef9454d7fc39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc94f9c58fffbe3c43495cfe0217882b4344eadf7b396783b45cc531a1178cc)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the ETag validation behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4862462fd07d6dc1adbe9b080116dfb52063e1bcdc6d0cde8854873f9439cd76)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2db278713d33def44d2c1cb721b3e9d5430057a1c0837827a3758d73c6696ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1062924bd752e58f6647dc426327b078ea77bf948ef7e018b147d21c8204a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70348f7021bca03f823796c68cd8e29387501f43b9fe98d56a4a239b63c4a196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cd99dc4feb39dcc3174dbf8608b507e2ebbe39990840d7ddb19b1d6f76b8f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e5b6681bf7e2091a9fa9e867dd6805e466721c08f0b870bd54637c6a839783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken",
    jsii_struct_bases=[],
    name_mapping={
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken:
    def __init__(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49ffaeae86e5198dd86ee234a686429f76d0e4e3a0ffac5948173dd7eb5e4d66)
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specify from where to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp",
    jsii_struct_bases=[],
    name_mapping={
        "authorizations": "authorizations",
        "client_id": "clientId",
        "custom_header": "customHeader",
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_authorizations": "extractAuthorizations",
        "extract_client_id": "extractClientId",
        "extract_location": "extractLocation",
        "extract_user_name": "extractUserName",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "primary_location": "primaryLocation",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "user_name": "userName",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp:
    def __init__(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8047c7f19b2cb0707494c360f30a0e5675daaa716233e20ef3fad48ae72ffe81)
            check_type(argname="argument authorizations", value=authorizations, expected_type=type_hints["authorizations"])
            check_type(argname="argument client_id", value=client_id, expected_type=type_hints["client_id"])
            check_type(argname="argument custom_header", value=custom_header, expected_type=type_hints["custom_header"])
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_authorizations", value=extract_authorizations, expected_type=type_hints["extract_authorizations"])
            check_type(argname="argument extract_client_id", value=extract_client_id, expected_type=type_hints["extract_client_id"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument extract_user_name", value=extract_user_name, expected_type=type_hints["extract_user_name"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument primary_location", value=primary_location, expected_type=type_hints["primary_location"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_name", value=user_name, expected_type=type_hints["user_name"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if authorizations is not None:
            self._values["authorizations"] = authorizations
        if client_id is not None:
            self._values["client_id"] = client_id
        if custom_header is not None:
            self._values["custom_header"] = custom_header
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_authorizations is not None:
            self._values["extract_authorizations"] = extract_authorizations
        if extract_client_id is not None:
            self._values["extract_client_id"] = extract_client_id
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if extract_user_name is not None:
            self._values["extract_user_name"] = extract_user_name
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if primary_location is not None:
            self._values["primary_location"] = primary_location
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_name is not None:
            self._values["user_name"] = user_name
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def authorizations(self) -> typing.Optional[builtins.str]:
        '''This specifies the authorization group name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        '''
        result = self._values.get("authorizations")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_id(self) -> typing.Optional[builtins.str]:
        '''This specifies the claim name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        '''
        result = self._values.get("client_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_header(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''The JWT value comes from the ``X-Akamai-DCP-Token`` header by default.

        Enabling this option allows you to extract it from another header name that you specify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        '''
        result = self._values.get("custom_header")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_authorizations(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the authorization groups stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        '''
        result = self._values.get("extract_authorizations")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_client_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the client ID claim name stored in JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        '''
        result = self._values.get("extract_client_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to get the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_user_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the user name stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        '''
        result = self._values.get("extract_user_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header to extract the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def primary_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the primary location to extract the JWT value from.

        If the specified option doesn't include the JWTs, the system checks the secondary one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        '''
        result = self._values.get("primary_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the user name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        '''
        result = self._values.get("user_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9900a3c66a27d0a8e03ee3e2c99dc614a4e5d10c433c9c9f50596e351f6ca2a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthorizations")
    def reset_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthorizations", []))

    @jsii.member(jsii_name="resetClientId")
    def reset_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientId", []))

    @jsii.member(jsii_name="resetCustomHeader")
    def reset_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeader", []))

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractAuthorizations")
    def reset_extract_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractAuthorizations", []))

    @jsii.member(jsii_name="resetExtractClientId")
    def reset_extract_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractClientId", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetExtractUserName")
    def reset_extract_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractUserName", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrimaryLocation")
    def reset_primary_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrimaryLocation", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserName")
    def reset_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserName", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authorizationsInput")
    def authorizations_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIdInput")
    def client_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderInput")
    def custom_header_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizationsInput")
    def extract_authorizations_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractAuthorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractClientIdInput")
    def extract_client_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractClientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="extractUserNameInput")
    def extract_user_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractUserNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="primaryLocationInput")
    def primary_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "primaryLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userNameInput")
    def user_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userNameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authorizations")
    def authorizations(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authorizations"))

    @authorizations.setter
    def authorizations(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf262bc785051521ee0a89547c0ceb7f2989bd418435023dc3c4b451e55704c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authorizations", value)

    @builtins.property
    @jsii.member(jsii_name="clientId")
    def client_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientId"))

    @client_id.setter
    def client_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56084858abe7c99eff7e42009997bf25440efb69ffc0f401ef169dbb43180b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientId", value)

    @builtins.property
    @jsii.member(jsii_name="customHeader")
    def custom_header(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customHeader"))

    @custom_header.setter
    def custom_header(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74f60b65c696a14a84136a9639b7fc8dafe6c17b86bbc08088c5b4da08c2ace4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__994f4661e4f73fec26324b1f471860a7048de0d3ffb76a2496353d9a7118bc44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__568ad13b1034ae65cbb0a787bf0adbc8917ceb3a904f77eddb01a327dfac8c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizations")
    def extract_authorizations(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractAuthorizations"))

    @extract_authorizations.setter
    def extract_authorizations(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__104487df7c239254d073b06b38d22a12c383eb4e0d3f4b823821874b00ba0fd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractAuthorizations", value)

    @builtins.property
    @jsii.member(jsii_name="extractClientId")
    def extract_client_id(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractClientId"))

    @extract_client_id.setter
    def extract_client_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30af568b605aa2aafaff0861aeab94fee34b3f0d7f3f60dc9791fd4671173ce5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractClientId", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162efc76e29eda3f90070730a2e5f4c9f1b67333915380569ab1af66febff74f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="extractUserName")
    def extract_user_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractUserName"))

    @extract_user_name.setter
    def extract_user_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02f089951585deb31c9f302046b74cd582e27aba9a57c039ef16ea69ce0fade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractUserName", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c65ae3b0bc7b9afe2721b4aeee04c9292345666fa913b8e5e17c2c6be77cee74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__682fada8769941f7564b42a20def2fe5818a41ba729025d00eb9bdcaf5342480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e1f0303a5e6747160510351290b2b6b42ecb250f1c443f28fc46120da73fc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="primaryLocation")
    def primary_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "primaryLocation"))

    @primary_location.setter
    def primary_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45e5111c40e7d0445df1db4f59e391fbc3e4b04bed9288223527851bc95282a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "primaryLocation", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54e2107ef1565b9c3b64ff842b46e050aa7df7ebbd1cd3ed8838b2d28c652e75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4ed0fda626668940a9bf8febff4e5e99370102959976d21089dbfe5742c4c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userName")
    def user_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userName"))

    @user_name.setter
    def user_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b928041ac4a7ce29f4d9457eca7ff60f8a981b83d6137063a10489f3de75faa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userName", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f40c8f6ba4f12717f82d2f74b22731d4af2e5895228f21c2473f88a6b321fe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55b3a32e5c5bd953750a938bd1b65f8e068e07166d1ba7be0e6089555a943157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3d0f315d84950e29b3999ef0e4763874720e233425ef67bf0905b4d449b5fb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaea8249fee50c4235dfac504b20dc660994023dc56670d7e27682a295c32fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6c3b188c184b5696bc1e99e5015ea6e41f459bcf24298bccd3e79d38fe2049e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0ee2e0611fe62760b5b54d2e43c0ed0604a4ecac4c0e7fe0c27f9b983e947e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587573844079a336ee07157aeb2484489976cf7be83a026a1096db5e2bdf64d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5b021d3c2299cd0348fa620c0260b472909ebec1957d431286bc534f826e67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a26cade7543a4e6fd79ae7585899ceedf3a7f7460a373889978e5a7c2400cce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1a4a16377c3c3a59edcbff1559953908733b85fb1c7b5bd67562b1e3d049f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8700e9cecde2f669eb93be546da37a44700c16f45b12c395508bfa96762e037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d6dabbf922d7758a7db83ce479a92a9cdf5cfbc50cc96299caf34c1a01c167)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275548be52c48a2d01e92546a38989adf312652549ed32a02598d5df3a6fe51a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "escape_hmac_inputs": "escapeHmacInputs",
        "failure_response": "failureResponse",
        "ignore_query_string": "ignoreQueryString",
        "key": "key",
        "location": "location",
        "location_id": "locationId",
        "locked": "locked",
        "salt": "salt",
        "template_uuid": "templateUuid",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0821eb4774b72f589b8d6f047df966b5e04cd7ba00765b50d0e75f4acebaff7)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument escape_hmac_inputs", value=escape_hmac_inputs, expected_type=type_hints["escape_hmac_inputs"])
            check_type(argname="argument failure_response", value=failure_response, expected_type=type_hints["failure_response"])
            check_type(argname="argument ignore_query_string", value=ignore_query_string, expected_type=type_hints["ignore_query_string"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if escape_hmac_inputs is not None:
            self._values["escape_hmac_inputs"] = escape_hmac_inputs
        if failure_response is not None:
            self._values["failure_response"] = failure_response
        if ignore_query_string is not None:
            self._values["ignore_query_string"] = ignore_query_string
        if key is not None:
            self._values["key"] = key
        if location is not None:
            self._values["location"] = location
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if salt is not None:
            self._values["salt"] = salt
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def escape_hmac_inputs(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''URL-escapes HMAC inputs passed in as query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        '''
        result = self._values.get("escape_hmac_inputs")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failure_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends an HTTP error when an authentication test fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        '''
        result = self._values.get("failure_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this removes the query string from the URL used to form an encryption key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        '''
        result = self._values.get("ignore_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''The shared secret used to validate tokens, which needs to match the key used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to find the token in the incoming request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a hex value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aba975b295b76c339c47e8f74c382b9793a2693611502b8d87edaefeb6b138e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetEscapeHmacInputs")
    def reset_escape_hmac_inputs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeHmacInputs", []))

    @jsii.member(jsii_name="resetFailureResponse")
    def reset_failure_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailureResponse", []))

    @jsii.member(jsii_name="resetIgnoreQueryString")
    def reset_ignore_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnoreQueryString", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputsInput")
    def escape_hmac_inputs_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeHmacInputsInput"))

    @builtins.property
    @jsii.member(jsii_name="failureResponseInput")
    def failure_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failureResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryStringInput")
    def ignore_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignoreQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__370200873006f571666b4f57a6bb07d2fa8556806da9667f0d2ac8e0c40efb29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputs")
    def escape_hmac_inputs(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeHmacInputs"))

    @escape_hmac_inputs.setter
    def escape_hmac_inputs(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c952adfd923daaf02bf5a8cdd1ab2a9adc640b8624c7235981bed9adbacba45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeHmacInputs", value)

    @builtins.property
    @jsii.member(jsii_name="failureResponse")
    def failure_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failureResponse"))

    @failure_response.setter
    def failure_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025efcaf1603518469e9b1bd5d93e01607c38a44f70b107657454e30f5a7e819)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failureResponse", value)

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryString")
    def ignore_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignoreQueryString"))

    @ignore_query_string.setter
    def ignore_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912aad4a86ff76586545c885df7150e6c86da06a18ab444d7087384bc9f651d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignoreQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8187af1679c4d0aacfddc6650fa5fccdbff50a536840e5fc32679c91b7cd6d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a48c00aaf69f780d83bdec85fe71f1e1b06221332e32aae72d34f8df769821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c13e4f8f61be8f16ac735952d3298da47912b60a80166cedde1ffaa22dc2ef2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec495fa634f91af45921f47d5e6c662d10dab364614ece87d84a68dab06f38b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5fd667eb6c74dd3344198e19b42d5ad9d48f44a33806f6279b2551e6615530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03b38c2d9a44f50154bc91e6a489dee43640f6293abb5393ed6b8b67edd3b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9265da44ccd18af0c262ef7be80f4d4fdcc1f2fee7053c1ed995a5beb6fbbe14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f638cca8f85a82133813cb23260560c9f9fbdf902125dcb775e72b33d9d934b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__950c588a48960c11272d6206aa3b2c214c37696bbb0acd26e4cac646705ee427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ce778481288bce4449fed62a19beea708ab5c1b69229d92affd0e267a53ac77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff0068fa596876d2a0f3f7c741e729e01f59ecfa65ba6fd5bf4e630add85612)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests.

        The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329246ec1484f2730c4a141a6f6f7a44306b8ee8b9fad95fe807a64fa4380cc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b6d91b2ffd9a550834156fc6ab527f9f16755324bc1d4204ddacb2922dbd67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef33244709cd593e9c42995695e35204640fb22e2963db9f4b95095cfb59292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70eff7722ce126853cd530d3954515f72600b9f725d2c5a2aea2d3f055a473da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c157f383e1c7fc3e4c085e88fc6d8a74d125422edd7a2d5e5ccf13fbc744cebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374756dedeac8489f54da3355db416074c561d114ddff7247da74fe81a64e051)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65065d8c13770234b75a39c4dfaab346365c2206c3daa3bdb7010b361e0cd9ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfa1a2fee3a5b04307f0c11f19b492aa28e77fdf180ca9fc8873efd0e814c21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5db599c669879e7b9eb115528ed04e4858e643e98b33b31e98a272d487be9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b924c1be8084a93dd73ff893d6d88ed15bfc3eb59a64dd89782eee979a3d184e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d126e3430621c1e1505fe955b893b6e6868d47b47ea3b5a84bc78ebdd3f8a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ac30fd25971c4f5911c909a9473f24d2b9a71b5275b728e9fa76ee4e114cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8eb8269d6f315a1091258678590b89353c56621eb2e7de00f9839ec2e57adf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39260a188563a8b95a73393e2332f7a84ea814a48f9cab463952f786f91e40e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c5abbf861117c48834c0dd71f98dacb05b886cb3128166a796bd44a3c6395f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6756e0a0617db8a557e0628612c5b42ed9be34970c98f5c34bfd70f2d78a04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afee1e075315fcfe722e0560c4ec262f4c03d7ad97f9a4516bd7079ec32fb29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999ee9defc8f10beeccbd673ef9afaeb36a8a0aa6b1aef9ec7a7d75e845227e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0340bf03530b50d636bd5e799f9e9c17cadce45f24d055c8fe0071c0914e509a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31875f31476a51c73fc81b2021c26b9e56b31e652a311e2dab77d405e86f0f10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_user_cookie_advanced": "allowedUserCookieAdvanced",
        "allowed_user_cookie_automatic_salt": "allowedUserCookieAutomaticSalt",
        "allowed_user_cookie_domain": "allowedUserCookieDomain",
        "allowed_user_cookie_domain_type": "allowedUserCookieDomainType",
        "allowed_user_cookie_duration": "allowedUserCookieDuration",
        "allowed_user_cookie_enabled": "allowedUserCookieEnabled",
        "allowed_user_cookie_http_only": "allowedUserCookieHttpOnly",
        "allowed_user_cookie_label": "allowedUserCookieLabel",
        "allowed_user_cookie_management_title": "allowedUserCookieManagementTitle",
        "allowed_user_cookie_refresh": "allowedUserCookieRefresh",
        "allowed_user_cookie_salt": "allowedUserCookieSalt",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "user_identification_by_cookie": "userIdentificationByCookie",
        "user_identification_by_headers": "userIdentificationByHeaders",
        "user_identification_by_ip": "userIdentificationByIp",
        "user_identification_by_params": "userIdentificationByParams",
        "user_identification_key_cookie": "userIdentificationKeyCookie",
        "user_identification_key_headers": "userIdentificationKeyHeaders",
        "user_identification_key_params": "userIdentificationKeyParams",
        "user_identification_title": "userIdentificationTitle",
        "uuid": "uuid",
        "waiting_room_cache_ttl": "waitingRoomCacheTtl",
        "waiting_room_cookie_advanced": "waitingRoomCookieAdvanced",
        "waiting_room_cookie_automatic_salt": "waitingRoomCookieAutomaticSalt",
        "waiting_room_cookie_domain": "waitingRoomCookieDomain",
        "waiting_room_cookie_domain_type": "waitingRoomCookieDomainType",
        "waiting_room_cookie_duration": "waitingRoomCookieDuration",
        "waiting_room_cookie_enabled": "waitingRoomCookieEnabled",
        "waiting_room_cookie_http_only": "waitingRoomCookieHttpOnly",
        "waiting_room_cookie_label": "waitingRoomCookieLabel",
        "waiting_room_cookie_management_title": "waitingRoomCookieManagementTitle",
        "waiting_room_cookie_salt": "waitingRoomCookieSalt",
        "waiting_room_cookie_share_label": "waitingRoomCookieShareLabel",
        "waiting_room_cp_code": "waitingRoomCpCode",
        "waiting_room_directory": "waitingRoomDirectory",
        "waiting_room_management_title": "waitingRoomManagementTitle",
        "waiting_room_net_storage": "waitingRoomNetStorage",
        "waiting_room_status_code": "waitingRoomStatusCode",
        "waiting_room_use_cp_code": "waitingRoomUseCpCode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization:
    def __init__(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(waiting_room_cp_code, dict):
            waiting_room_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode(**waiting_room_cp_code)
        if isinstance(waiting_room_net_storage, dict):
            waiting_room_net_storage = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage(**waiting_room_net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ff738da30e3a9d38f0bf1c8d851c75fdeb4b8bd8cd8b9669440da2b280dc27)
            check_type(argname="argument allowed_user_cookie_advanced", value=allowed_user_cookie_advanced, expected_type=type_hints["allowed_user_cookie_advanced"])
            check_type(argname="argument allowed_user_cookie_automatic_salt", value=allowed_user_cookie_automatic_salt, expected_type=type_hints["allowed_user_cookie_automatic_salt"])
            check_type(argname="argument allowed_user_cookie_domain", value=allowed_user_cookie_domain, expected_type=type_hints["allowed_user_cookie_domain"])
            check_type(argname="argument allowed_user_cookie_domain_type", value=allowed_user_cookie_domain_type, expected_type=type_hints["allowed_user_cookie_domain_type"])
            check_type(argname="argument allowed_user_cookie_duration", value=allowed_user_cookie_duration, expected_type=type_hints["allowed_user_cookie_duration"])
            check_type(argname="argument allowed_user_cookie_enabled", value=allowed_user_cookie_enabled, expected_type=type_hints["allowed_user_cookie_enabled"])
            check_type(argname="argument allowed_user_cookie_http_only", value=allowed_user_cookie_http_only, expected_type=type_hints["allowed_user_cookie_http_only"])
            check_type(argname="argument allowed_user_cookie_label", value=allowed_user_cookie_label, expected_type=type_hints["allowed_user_cookie_label"])
            check_type(argname="argument allowed_user_cookie_management_title", value=allowed_user_cookie_management_title, expected_type=type_hints["allowed_user_cookie_management_title"])
            check_type(argname="argument allowed_user_cookie_refresh", value=allowed_user_cookie_refresh, expected_type=type_hints["allowed_user_cookie_refresh"])
            check_type(argname="argument allowed_user_cookie_salt", value=allowed_user_cookie_salt, expected_type=type_hints["allowed_user_cookie_salt"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_identification_by_cookie", value=user_identification_by_cookie, expected_type=type_hints["user_identification_by_cookie"])
            check_type(argname="argument user_identification_by_headers", value=user_identification_by_headers, expected_type=type_hints["user_identification_by_headers"])
            check_type(argname="argument user_identification_by_ip", value=user_identification_by_ip, expected_type=type_hints["user_identification_by_ip"])
            check_type(argname="argument user_identification_by_params", value=user_identification_by_params, expected_type=type_hints["user_identification_by_params"])
            check_type(argname="argument user_identification_key_cookie", value=user_identification_key_cookie, expected_type=type_hints["user_identification_key_cookie"])
            check_type(argname="argument user_identification_key_headers", value=user_identification_key_headers, expected_type=type_hints["user_identification_key_headers"])
            check_type(argname="argument user_identification_key_params", value=user_identification_key_params, expected_type=type_hints["user_identification_key_params"])
            check_type(argname="argument user_identification_title", value=user_identification_title, expected_type=type_hints["user_identification_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_cache_ttl", value=waiting_room_cache_ttl, expected_type=type_hints["waiting_room_cache_ttl"])
            check_type(argname="argument waiting_room_cookie_advanced", value=waiting_room_cookie_advanced, expected_type=type_hints["waiting_room_cookie_advanced"])
            check_type(argname="argument waiting_room_cookie_automatic_salt", value=waiting_room_cookie_automatic_salt, expected_type=type_hints["waiting_room_cookie_automatic_salt"])
            check_type(argname="argument waiting_room_cookie_domain", value=waiting_room_cookie_domain, expected_type=type_hints["waiting_room_cookie_domain"])
            check_type(argname="argument waiting_room_cookie_domain_type", value=waiting_room_cookie_domain_type, expected_type=type_hints["waiting_room_cookie_domain_type"])
            check_type(argname="argument waiting_room_cookie_duration", value=waiting_room_cookie_duration, expected_type=type_hints["waiting_room_cookie_duration"])
            check_type(argname="argument waiting_room_cookie_enabled", value=waiting_room_cookie_enabled, expected_type=type_hints["waiting_room_cookie_enabled"])
            check_type(argname="argument waiting_room_cookie_http_only", value=waiting_room_cookie_http_only, expected_type=type_hints["waiting_room_cookie_http_only"])
            check_type(argname="argument waiting_room_cookie_label", value=waiting_room_cookie_label, expected_type=type_hints["waiting_room_cookie_label"])
            check_type(argname="argument waiting_room_cookie_management_title", value=waiting_room_cookie_management_title, expected_type=type_hints["waiting_room_cookie_management_title"])
            check_type(argname="argument waiting_room_cookie_salt", value=waiting_room_cookie_salt, expected_type=type_hints["waiting_room_cookie_salt"])
            check_type(argname="argument waiting_room_cookie_share_label", value=waiting_room_cookie_share_label, expected_type=type_hints["waiting_room_cookie_share_label"])
            check_type(argname="argument waiting_room_cp_code", value=waiting_room_cp_code, expected_type=type_hints["waiting_room_cp_code"])
            check_type(argname="argument waiting_room_directory", value=waiting_room_directory, expected_type=type_hints["waiting_room_directory"])
            check_type(argname="argument waiting_room_management_title", value=waiting_room_management_title, expected_type=type_hints["waiting_room_management_title"])
            check_type(argname="argument waiting_room_net_storage", value=waiting_room_net_storage, expected_type=type_hints["waiting_room_net_storage"])
            check_type(argname="argument waiting_room_status_code", value=waiting_room_status_code, expected_type=type_hints["waiting_room_status_code"])
            check_type(argname="argument waiting_room_use_cp_code", value=waiting_room_use_cp_code, expected_type=type_hints["waiting_room_use_cp_code"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowed_user_cookie_advanced is not None:
            self._values["allowed_user_cookie_advanced"] = allowed_user_cookie_advanced
        if allowed_user_cookie_automatic_salt is not None:
            self._values["allowed_user_cookie_automatic_salt"] = allowed_user_cookie_automatic_salt
        if allowed_user_cookie_domain is not None:
            self._values["allowed_user_cookie_domain"] = allowed_user_cookie_domain
        if allowed_user_cookie_domain_type is not None:
            self._values["allowed_user_cookie_domain_type"] = allowed_user_cookie_domain_type
        if allowed_user_cookie_duration is not None:
            self._values["allowed_user_cookie_duration"] = allowed_user_cookie_duration
        if allowed_user_cookie_enabled is not None:
            self._values["allowed_user_cookie_enabled"] = allowed_user_cookie_enabled
        if allowed_user_cookie_http_only is not None:
            self._values["allowed_user_cookie_http_only"] = allowed_user_cookie_http_only
        if allowed_user_cookie_label is not None:
            self._values["allowed_user_cookie_label"] = allowed_user_cookie_label
        if allowed_user_cookie_management_title is not None:
            self._values["allowed_user_cookie_management_title"] = allowed_user_cookie_management_title
        if allowed_user_cookie_refresh is not None:
            self._values["allowed_user_cookie_refresh"] = allowed_user_cookie_refresh
        if allowed_user_cookie_salt is not None:
            self._values["allowed_user_cookie_salt"] = allowed_user_cookie_salt
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_identification_by_cookie is not None:
            self._values["user_identification_by_cookie"] = user_identification_by_cookie
        if user_identification_by_headers is not None:
            self._values["user_identification_by_headers"] = user_identification_by_headers
        if user_identification_by_ip is not None:
            self._values["user_identification_by_ip"] = user_identification_by_ip
        if user_identification_by_params is not None:
            self._values["user_identification_by_params"] = user_identification_by_params
        if user_identification_key_cookie is not None:
            self._values["user_identification_key_cookie"] = user_identification_key_cookie
        if user_identification_key_headers is not None:
            self._values["user_identification_key_headers"] = user_identification_key_headers
        if user_identification_key_params is not None:
            self._values["user_identification_key_params"] = user_identification_key_params
        if user_identification_title is not None:
            self._values["user_identification_title"] = user_identification_title
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_cache_ttl is not None:
            self._values["waiting_room_cache_ttl"] = waiting_room_cache_ttl
        if waiting_room_cookie_advanced is not None:
            self._values["waiting_room_cookie_advanced"] = waiting_room_cookie_advanced
        if waiting_room_cookie_automatic_salt is not None:
            self._values["waiting_room_cookie_automatic_salt"] = waiting_room_cookie_automatic_salt
        if waiting_room_cookie_domain is not None:
            self._values["waiting_room_cookie_domain"] = waiting_room_cookie_domain
        if waiting_room_cookie_domain_type is not None:
            self._values["waiting_room_cookie_domain_type"] = waiting_room_cookie_domain_type
        if waiting_room_cookie_duration is not None:
            self._values["waiting_room_cookie_duration"] = waiting_room_cookie_duration
        if waiting_room_cookie_enabled is not None:
            self._values["waiting_room_cookie_enabled"] = waiting_room_cookie_enabled
        if waiting_room_cookie_http_only is not None:
            self._values["waiting_room_cookie_http_only"] = waiting_room_cookie_http_only
        if waiting_room_cookie_label is not None:
            self._values["waiting_room_cookie_label"] = waiting_room_cookie_label
        if waiting_room_cookie_management_title is not None:
            self._values["waiting_room_cookie_management_title"] = waiting_room_cookie_management_title
        if waiting_room_cookie_salt is not None:
            self._values["waiting_room_cookie_salt"] = waiting_room_cookie_salt
        if waiting_room_cookie_share_label is not None:
            self._values["waiting_room_cookie_share_label"] = waiting_room_cookie_share_label
        if waiting_room_cp_code is not None:
            self._values["waiting_room_cp_code"] = waiting_room_cp_code
        if waiting_room_directory is not None:
            self._values["waiting_room_directory"] = waiting_room_directory
        if waiting_room_management_title is not None:
            self._values["waiting_room_management_title"] = waiting_room_management_title
        if waiting_room_net_storage is not None:
            self._values["waiting_room_net_storage"] = waiting_room_net_storage
        if waiting_room_status_code is not None:
            self._values["waiting_room_status_code"] = waiting_room_status_code
        if waiting_room_use_cp_code is not None:
            self._values["waiting_room_use_cp_code"] = waiting_room_use_cp_code

    @builtins.property
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets advanced configuration options for the allowed user's cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        '''
        result = self._values.get("allowed_user_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        '''
        result = self._values.get("allowed_user_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for an allowed user cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        '''
        result = self._values.get("allowed_user_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``allowedUserCookieAdvanced`` enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        '''
        result = self._values.get("allowed_user_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for the allowed user's session once allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        '''
        result = self._values.get("allowed_user_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a cookie for users who have been allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        '''
        result = self._values.get("allowed_user_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        '''
        result = self._values.get("allowed_user_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this cookie for an allowed user from others.

        The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        '''
        result = self._values.get("allowed_user_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        '''
        result = self._values.get("allowed_user_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration.

        Do not enable this option if you want to set a fixed time for all users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        '''
        result = self._values.get("allowed_user_cookie_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        '''
        result = self._values.get("allowed_user_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Visitor Prioritization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_by_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the value of a cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        '''
        result = self._values.get("user_identification_by_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        '''
        result = self._values.get("user_identification_by_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows IP addresses to identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        '''
        result = self._values.get("user_identification_by_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_params(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        '''
        result = self._values.get("user_identification_by_params")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_key_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie whose value identifies users.

        To match a user, the value of the cookie needs to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        '''
        result = self._values.get("user_identification_key_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_key_headers(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request headers whose values identify users.

        To match a user, values for all the specified headers need to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        '''
        result = self._values.get("user_identification_key_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_key_params(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request parameters whose values identify users.

        To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        '''
        result = self._values.get("user_identification_key_params")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        '''
        result = self._values.get("user_identification_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the waiting room page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        '''
        result = self._values.get("waiting_room_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        '''
        result = self._values.get("waiting_room_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        '''
        result = self._values.get("waiting_room_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        '''
        result = self._values.get("waiting_room_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        '''
        result = self._values.get("waiting_room_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for which users remain in the waiting room.

        During this time, users who refresh the waiting room page remain there.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        '''
        result = self._values.get("waiting_room_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a cookie to track a waiting room assignment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        '''
        result = self._values.get("waiting_room_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        '''
        result = self._values.get("waiting_room_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this waiting room cookie from others.

        The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        '''
        result = self._values.get("waiting_room_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        '''
        result = self._values.get("waiting_room_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        '''
        result = self._values.get("waiting_room_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        '''
        result = self._values.get("waiting_room_cookie_share_label")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        '''waiting_room_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        '''
        result = self._values.get("waiting_room_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode"], result)

    @builtins.property
    def waiting_room_directory(self) -> typing.Optional[builtins.str]:
        '''Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        '''
        result = self._values.get("waiting_room_directory")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        '''
        result = self._values.get("waiting_room_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        '''waiting_room_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        '''
        result = self._values.get("waiting_room_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage"], result)

    @builtins.property
    def waiting_room_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response code for requests sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        '''
        result = self._values.get("waiting_room_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a different CP code that tracks any requests that are sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        result = self._values.get("waiting_room_use_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ff8e900c15d5fdf99727547a210311670ecc635eafe76e94319d47bb3f4b123)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0f9a1dd3714af70894ad0e869ca075e1c1d1ea16a1d39a7f979e42c24a8dfb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ba87954cb2c221724806fb0af245807254fac37a0fe63b39b9498c99b389d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d56a8da333ebbc4889748efef308c4cb2eb517bf195c0a4cf257f213a28256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7797225739cfaac5be9c9a944d653fdda140ddcd653c8d2bc80550adf9b2ccb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1260e87835040534bf124cfd2542c6e7b24ca43a27441cd14e79f2bfc9bceea1)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Prioritization FIFO shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies how to set the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests.

        The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d71c60627cc73204d7e44c9ea3f8bbaeefaa40825da7f68f48f695b26545835b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72fab99ace11caffc21b983c3996e1ec7b1bb3bc349a759025473a153381e33e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf81c853c50125fdef409db9e39947699597e6ffa87013fb1f75883a48991d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__410c49ef822e40703bb752beaae2b27c2ec16e9be58dfd487d7f96b00f8fca62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f9feb2600b8622c625e02e280e17516ca8b9351fed5e0e8ba39da69dd8d703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30370f06f0e3bb3e88a93df2975bc844e8f40c59805a15e8bbf23c35d9f1c2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c936239e1cbe2ed492b8b25425834b5d3ee27243b41f50252cbf8418659b534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb7e414e1ac40ce6d34210bdce0538a39e1c35320169884a2c81471edbb07031)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4bc3f3f493eaf430dd53b2625be83f3bfbe5802c4ff09e65aaa6d1cf158c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85c461fac7bc0dad0a7fea0847e3d943f74ec260d78430f1ff7462e246a3a16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c82eab21020812044688e020f1e65fb5c8b4d3daabfe287f0f74d2b87550650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf58fc549369e86ac2816fca830b229446fb06e58efa91b915f2b04a4b4ad16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a05311d38f679c10270acc51a4aa35eee1fcf621da69b4ea05ae3b1a9264b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8157d2821a31248f82c336d554fcdd958392b090ba449d31a4e537a67c30886a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98743bca380a0ac959b18ef49fa5c8b1addc01cd740e6c363a0083fbc849dc70)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandaloneOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e200bbc0880eb81832580d09e6f795edd4afe4442b774cab9694013b11883bae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab78913404342bad7c1a5324cb5366d24c88cab846b58b57dba19605f9df1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d068b90001721db62f8ce76d91a0019bf87eba7b2fdbc8a7185f085b83ab6ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe3b1ca392acd6ad4470359ec717be1edf14bb669542f87fbb8da569e77fb1c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32be3b9a5e6ea87dbf1642866790045ca11cdc3f5d29e178c79bf47233329617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422926523352a01465d8b5902baf95cbbd56509f2c4b5eafc57e5df3f0bbba5e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putWaitingRoomCpCode")
    def put_waiting_room_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomCpCode", [value]))

    @jsii.member(jsii_name="putWaitingRoomNetStorage")
    def put_waiting_room_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomNetStorage", [value]))

    @jsii.member(jsii_name="resetAllowedUserCookieAdvanced")
    def reset_allowed_user_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAdvanced", []))

    @jsii.member(jsii_name="resetAllowedUserCookieAutomaticSalt")
    def reset_allowed_user_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomain")
    def reset_allowed_user_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomain", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomainType")
    def reset_allowed_user_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomainType", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDuration")
    def reset_allowed_user_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDuration", []))

    @jsii.member(jsii_name="resetAllowedUserCookieEnabled")
    def reset_allowed_user_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieEnabled", []))

    @jsii.member(jsii_name="resetAllowedUserCookieHttpOnly")
    def reset_allowed_user_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieHttpOnly", []))

    @jsii.member(jsii_name="resetAllowedUserCookieLabel")
    def reset_allowed_user_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieLabel", []))

    @jsii.member(jsii_name="resetAllowedUserCookieManagementTitle")
    def reset_allowed_user_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieManagementTitle", []))

    @jsii.member(jsii_name="resetAllowedUserCookieRefresh")
    def reset_allowed_user_cookie_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieRefresh", []))

    @jsii.member(jsii_name="resetAllowedUserCookieSalt")
    def reset_allowed_user_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieSalt", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserIdentificationByCookie")
    def reset_user_identification_by_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationByHeaders")
    def reset_user_identification_by_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationByIp")
    def reset_user_identification_by_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByIp", []))

    @jsii.member(jsii_name="resetUserIdentificationByParams")
    def reset_user_identification_by_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByParams", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyCookie")
    def reset_user_identification_key_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyHeaders")
    def reset_user_identification_key_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyParams")
    def reset_user_identification_key_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyParams", []))

    @jsii.member(jsii_name="resetUserIdentificationTitle")
    def reset_user_identification_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomCacheTtl")
    def reset_waiting_room_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCacheTtl", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAdvanced")
    def reset_waiting_room_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAdvanced", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAutomaticSalt")
    def reset_waiting_room_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomain")
    def reset_waiting_room_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomain", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomainType")
    def reset_waiting_room_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomainType", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDuration")
    def reset_waiting_room_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDuration", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieEnabled")
    def reset_waiting_room_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieEnabled", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieHttpOnly")
    def reset_waiting_room_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieHttpOnly", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieLabel")
    def reset_waiting_room_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieManagementTitle")
    def reset_waiting_room_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieSalt")
    def reset_waiting_room_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieShareLabel")
    def reset_waiting_room_cookie_share_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieShareLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCpCode")
    def reset_waiting_room_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCpCode", []))

    @jsii.member(jsii_name="resetWaitingRoomDirectory")
    def reset_waiting_room_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomDirectory", []))

    @jsii.member(jsii_name="resetWaitingRoomManagementTitle")
    def reset_waiting_room_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomNetStorage")
    def reset_waiting_room_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomNetStorage", []))

    @jsii.member(jsii_name="resetWaitingRoomStatusCode")
    def reset_waiting_room_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomStatusCode", []))

    @jsii.member(jsii_name="resetWaitingRoomUseCpCode")
    def reset_waiting_room_use_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomUseCpCode", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCode")
    def waiting_room_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference", jsii.get(self, "waitingRoomCpCode"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorage")
    def waiting_room_net_storage(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference", jsii.get(self, "waitingRoomNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvancedInput")
    def allowed_user_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSaltInput")
    def allowed_user_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainInput")
    def allowed_user_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainTypeInput")
    def allowed_user_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDurationInput")
    def allowed_user_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "allowedUserCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabledInput")
    def allowed_user_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnlyInput")
    def allowed_user_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabelInput")
    def allowed_user_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitleInput")
    def allowed_user_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefreshInput")
    def allowed_user_cookie_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSaltInput")
    def allowed_user_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookieInput")
    def user_identification_by_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeadersInput")
    def user_identification_by_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIpInput")
    def user_identification_by_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByIpInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParamsInput")
    def user_identification_by_params_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookieInput")
    def user_identification_key_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationKeyCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeadersInput")
    def user_identification_key_headers_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParamsInput")
    def user_identification_key_params_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitleInput")
    def user_identification_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtlInput")
    def waiting_room_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvancedInput")
    def waiting_room_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSaltInput")
    def waiting_room_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainInput")
    def waiting_room_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainTypeInput")
    def waiting_room_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDurationInput")
    def waiting_room_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabledInput")
    def waiting_room_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnlyInput")
    def waiting_room_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabelInput")
    def waiting_room_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitleInput")
    def waiting_room_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSaltInput")
    def waiting_room_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabelInput")
    def waiting_room_cookie_share_label_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieShareLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCodeInput")
    def waiting_room_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode"], jsii.get(self, "waitingRoomCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectoryInput")
    def waiting_room_directory_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitleInput")
    def waiting_room_management_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorageInput")
    def waiting_room_net_storage_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage"], jsii.get(self, "waitingRoomNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCodeInput")
    def waiting_room_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCodeInput")
    def waiting_room_use_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomUseCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvanced")
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAdvanced"))

    @allowed_user_cookie_advanced.setter
    def allowed_user_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4106ce623abc4bb029a3ab91778bb7df8f4272bf915ebc3e4ed2c98681ebf570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSalt")
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAutomaticSalt"))

    @allowed_user_cookie_automatic_salt.setter
    def allowed_user_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce3a0689e72283ebdfc8dffc6d42be4683641e986dd65728691d06e5d4d8fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomain")
    def allowed_user_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomain"))

    @allowed_user_cookie_domain.setter
    def allowed_user_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a009f50444b68b725d64f599f023d6761d0592359a0a52be842b5c12a237c5e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainType")
    def allowed_user_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomainType"))

    @allowed_user_cookie_domain_type.setter
    def allowed_user_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e17c1a4149759767697fdb503041ec8b4d30dbd25f5d62de828783c536e29a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDuration")
    def allowed_user_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "allowedUserCookieDuration"))

    @allowed_user_cookie_duration.setter
    def allowed_user_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbaa56ceda2578d5bdc737b26f6d3f49b2d8ab2d240924e805ea13121a5d4cde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabled")
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieEnabled"))

    @allowed_user_cookie_enabled.setter
    def allowed_user_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bffc842dc494569fe8caa938a44f38b5a5caafe28648bbdd9d7f7c9de7507bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnly")
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieHttpOnly"))

    @allowed_user_cookie_http_only.setter
    def allowed_user_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f6f93d6379753ce59235f2c409f2783d165d812323b23033051efff0994cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabel")
    def allowed_user_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieLabel"))

    @allowed_user_cookie_label.setter
    def allowed_user_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ab26b1d5440d850b49dad56f465870ad93c1798e315f908ba1d35fd0a01d6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitle")
    def allowed_user_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieManagementTitle"))

    @allowed_user_cookie_management_title.setter
    def allowed_user_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1b244ce744510390b6d006262f2f9e9848209687b860b8dbfb078f746657cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefresh")
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieRefresh"))

    @allowed_user_cookie_refresh.setter
    def allowed_user_cookie_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a0174759bf85cde1cbf25f55316ee3dbd09a7761c2bfbf7b40ca2f221520a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSalt")
    def allowed_user_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieSalt"))

    @allowed_user_cookie_salt.setter
    def allowed_user_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78895a0433e8475a91114724f6ed0961bcbaaf9d8fc794af822307c2195a98ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d337626a6a94045e17c3727316e60908d5ef720474bc41a7bebffb61a7e6adf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__334c5917c882e2d8deea0fd559cd6a1f89495ea4eb93ccb6237c3f98fd2ee0ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d36aced04e27bcace909e83cb7c0cff650d1021b478bf16877a589004423a70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookie")
    def user_identification_by_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByCookie"))

    @user_identification_by_cookie.setter
    def user_identification_by_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8db925ecbc8cafe81075c1a6cdbbd4571767eadc7bb89ee277b799f5c6c52876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeaders")
    def user_identification_by_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByHeaders"))

    @user_identification_by_headers.setter
    def user_identification_by_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df851345accb4fa419d7a3be907ceb162cac9c042fe996cb730c92d818361046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIp")
    def user_identification_by_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByIp"))

    @user_identification_by_ip.setter
    def user_identification_by_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceecb73edbdd902cd78a23cf95b15c5a737e89de0df592596c8ceda47fef454b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByIp", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParams")
    def user_identification_by_params(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByParams"))

    @user_identification_by_params.setter
    def user_identification_by_params(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e963b3f064a4e3c97ab33731004daf5a68e987fec085c4c0f07cf79027defaa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookie")
    def user_identification_key_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationKeyCookie"))

    @user_identification_key_cookie.setter
    def user_identification_key_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25da72f3bfbe559ca32a9c777d9cfc3f2d3ab52e750fc808759a6419824a62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeaders")
    def user_identification_key_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyHeaders"))

    @user_identification_key_headers.setter
    def user_identification_key_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a5185d3af8917b24fca6946c58dc145bd1f088af1d1b04d7ef6af13734ed56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParams")
    def user_identification_key_params(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyParams"))

    @user_identification_key_params.setter
    def user_identification_key_params(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9112422a62471850a1552552052d9766699be1454bb16c646de53f8457691a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitle")
    def user_identification_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationTitle"))

    @user_identification_title.setter
    def user_identification_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de14f506e31c14009bf17dfe1bafd1a6db5dd4cc8b372f796994d8098a823db2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234073ee0f3b39607cc968974fd18bf56aee786069077d6971ce00b2dda2723e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtl")
    def waiting_room_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCacheTtl"))

    @waiting_room_cache_ttl.setter
    def waiting_room_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de77b8a818b56dba9855e57ae51b9506e56726406a81ae154386621a1805c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvanced")
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAdvanced"))

    @waiting_room_cookie_advanced.setter
    def waiting_room_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915eeba6b35bbf9f4481f51ca8f195d1b4ec3d0f667cddc213fa7e4e3c87a605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSalt")
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAutomaticSalt"))

    @waiting_room_cookie_automatic_salt.setter
    def waiting_room_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0a493dfae36503e1fa0e59288e4433650c106343bbc47e9d6e59a68dd1f366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomain")
    def waiting_room_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomain"))

    @waiting_room_cookie_domain.setter
    def waiting_room_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a4a46d8ecbd7cfb97e1d657c54abee636efde17be3d7d9289803e7a4848d44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainType")
    def waiting_room_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomainType"))

    @waiting_room_cookie_domain_type.setter
    def waiting_room_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d609c1dacbb82176f96b5aa2c55504b58f592ed793a9e040742110fb561e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDuration")
    def waiting_room_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCookieDuration"))

    @waiting_room_cookie_duration.setter
    def waiting_room_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__537a089e663edadcc3f3bc47100b7fa37bdc44d5a787335df48b4f4389f220bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabled")
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieEnabled"))

    @waiting_room_cookie_enabled.setter
    def waiting_room_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360019b5c94895dfda0749b3b3cf6db779fbbb1817ea163af8e107cb3d9d3880)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnly")
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieHttpOnly"))

    @waiting_room_cookie_http_only.setter
    def waiting_room_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c22ac64853c6a71dccdafea5ec7b841099d152c2d3082bf4cbe45ff8be73010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabel")
    def waiting_room_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieLabel"))

    @waiting_room_cookie_label.setter
    def waiting_room_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c3799fc3a1bc65352d5fa9134c90004cf3c27fc7ae324ea02e22d1f800c3708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitle")
    def waiting_room_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieManagementTitle"))

    @waiting_room_cookie_management_title.setter
    def waiting_room_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__707835cf703a68d648a556668cce288dcd4f949bec7e5011f391fc6339f35c95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSalt")
    def waiting_room_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieSalt"))

    @waiting_room_cookie_salt.setter
    def waiting_room_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c856be3e779b0252f04ce57e435cd424d366f168a2d1134b6e8d4af988bea75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabel")
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieShareLabel"))

    @waiting_room_cookie_share_label.setter
    def waiting_room_cookie_share_label(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7b4c32a8382d6f04e8861c51450cfbba278546da7aa7e79af0d02d26ee4a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieShareLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectory")
    def waiting_room_directory(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomDirectory"))

    @waiting_room_directory.setter
    def waiting_room_directory(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eead3004eaaea5c14d1e1d4a33409d6addf1cc170c6bab677f09f76eeb2d4940)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitle")
    def waiting_room_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomManagementTitle"))

    @waiting_room_management_title.setter
    def waiting_room_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00f258be07d413fc76cff98b28ca93c26888514241151368ae169416e5ab31a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCode")
    def waiting_room_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomStatusCode"))

    @waiting_room_status_code.setter
    def waiting_room_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd34001926e7e5ba5ddc4c386206300867f8dd3206f8a2879a65ef17bfed42f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCode")
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomUseCpCode"))

    @waiting_room_use_cp_code.setter
    def waiting_room_use_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae1413ef3181d38709a6969793594a25761974cf29f1c4eaf14cb640f6368a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomUseCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__223eecbac924ccc9fb211465ce38a1732f27b7dfb6962f5d44e5a2894ea95f49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f992b8d85c3f5bb9f56f7020bdfdfc483bcbff42e9992f1a87bd176718db0d72)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8730b50b9635938a704cfa35a265073875b1b8c234de167a6b768626dfa449f)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c5c0960d91effddc7260f1c86e7419575a3ad5773a294dc2cb32671c5bd444)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d4e6470ddce860eba43cdea3d681a4ec0e1aff0f88e29c2c3f275ab5e34dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04f11deb9d8bcede8732a484adec02775676dae3b1d469444d650cb82f8d9f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f0ea2166e21b2c11b3278d7582f4847c3bd4ce9ecef0cc7fe22154b986d03d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df66b24b919258e1a94ec6d2a35b5790aef984843238739e807325a36e4036d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3403e3dd1e6338d77f31f0a598accdb05bb88feb6792022f220280ec32ce0187)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7955a1f560abcb4d6efd14104af479f1a93de51e679668a8f9a6996e047f2cc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc72f5136e78f860f1b3299e7b4e74c77d361637c307802bda5af2c82cc2f3d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__968ee9a16b317d9ee8015f8eb827752c26c9c970470b24eeae7bf9bf3cdad837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab5ab46b5e6349d03bed563e8e2adfbd6cb46e66f4283b246de17c0eccff2de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d2b8e52981b9140cbdf61c01a5b821b020f50a5fe88c66fa3b54c822b3476a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab92ab76dcfb68c4d749d3e6249c59975cb766d7c1f1646fae87193c743d9aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2586100342ae5c5c6ca73b3dae95028692601d30a13c012b2b72478194ac0e27)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc9e8a934058a58a2e6e95f2998db3187c8e6911dbbb3c6985b24e07a9e4c395)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ad7c67e30a71fec7cd91c3aac51fef60d277221e94fca4d3659e0d25708a5f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f500506ed9e0707cc94fd71fb5fb0dbd7f1cc1dde4a20fc80d0f145161084e2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97eeb0c6679a8fd1b40a6f42d80a3a7698b7708e250df5ac50f1a84f69b9c758)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695f9c94d9881edc01fe1321a24e5ded2dae442c5ca5a07058738a720b0933e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking",
    jsii_struct_bases=[],
    name_mapping={
        "ab_variant_location": "abVariantLocation",
        "decryption_password1": "decryptionPassword1",
        "decryption_password2": "decryptionPassword2",
        "decryption_password_id1": "decryptionPasswordId1",
        "decryption_password_id2": "decryptionPasswordId2",
        "enable": "enable",
        "locked": "locked",
        "miscellaneous_settings_title": "miscellaneousSettingsTitle",
        "pattern_decryption_enable": "patternDecryptionEnable",
        "pattern_encryption_title": "patternEncryptionTitle",
        "signature_verification_enable": "signatureVerificationEnable",
        "template_uuid": "templateUuid",
        "token_signing_title": "tokenSigningTitle",
        "use_original_as_a": "useOriginalAsA",
        "uuid": "uuid",
        "verification_key_id1": "verificationKeyId1",
        "verification_key_id2": "verificationKeyId2",
        "verification_public_key1": "verificationPublicKey1",
        "verification_public_key2": "verificationPublicKey2",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking:
    def __init__(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba33c55718a86187f6932882111b5f1440f5bf5a46cbd0f1359b39a8ad52ba25)
            check_type(argname="argument ab_variant_location", value=ab_variant_location, expected_type=type_hints["ab_variant_location"])
            check_type(argname="argument decryption_password1", value=decryption_password1, expected_type=type_hints["decryption_password1"])
            check_type(argname="argument decryption_password2", value=decryption_password2, expected_type=type_hints["decryption_password2"])
            check_type(argname="argument decryption_password_id1", value=decryption_password_id1, expected_type=type_hints["decryption_password_id1"])
            check_type(argname="argument decryption_password_id2", value=decryption_password_id2, expected_type=type_hints["decryption_password_id2"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument miscellaneous_settings_title", value=miscellaneous_settings_title, expected_type=type_hints["miscellaneous_settings_title"])
            check_type(argname="argument pattern_decryption_enable", value=pattern_decryption_enable, expected_type=type_hints["pattern_decryption_enable"])
            check_type(argname="argument pattern_encryption_title", value=pattern_encryption_title, expected_type=type_hints["pattern_encryption_title"])
            check_type(argname="argument signature_verification_enable", value=signature_verification_enable, expected_type=type_hints["signature_verification_enable"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_signing_title", value=token_signing_title, expected_type=type_hints["token_signing_title"])
            check_type(argname="argument use_original_as_a", value=use_original_as_a, expected_type=type_hints["use_original_as_a"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_key_id1", value=verification_key_id1, expected_type=type_hints["verification_key_id1"])
            check_type(argname="argument verification_key_id2", value=verification_key_id2, expected_type=type_hints["verification_key_id2"])
            check_type(argname="argument verification_public_key1", value=verification_public_key1, expected_type=type_hints["verification_public_key1"])
            check_type(argname="argument verification_public_key2", value=verification_public_key2, expected_type=type_hints["verification_public_key2"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_variant_location is not None:
            self._values["ab_variant_location"] = ab_variant_location
        if decryption_password1 is not None:
            self._values["decryption_password1"] = decryption_password1
        if decryption_password2 is not None:
            self._values["decryption_password2"] = decryption_password2
        if decryption_password_id1 is not None:
            self._values["decryption_password_id1"] = decryption_password_id1
        if decryption_password_id2 is not None:
            self._values["decryption_password_id2"] = decryption_password_id2
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if miscellaneous_settings_title is not None:
            self._values["miscellaneous_settings_title"] = miscellaneous_settings_title
        if pattern_decryption_enable is not None:
            self._values["pattern_decryption_enable"] = pattern_decryption_enable
        if pattern_encryption_title is not None:
            self._values["pattern_encryption_title"] = pattern_encryption_title
        if signature_verification_enable is not None:
            self._values["signature_verification_enable"] = signature_verification_enable
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_signing_title is not None:
            self._values["token_signing_title"] = token_signing_title
        if use_original_as_a is not None:
            self._values["use_original_as_a"] = use_original_as_a
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_key_id1 is not None:
            self._values["verification_key_id1"] = verification_key_id1
        if verification_key_id2 is not None:
            self._values["verification_key_id2"] = verification_key_id2
        if verification_public_key1 is not None:
            self._values["verification_public_key1"] = verification_public_key1
        if verification_public_key2 is not None:
            self._values["verification_public_key2"] = verification_public_key2

    @builtins.property
    def ab_variant_location(self) -> typing.Optional[builtins.str]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        '''
        result = self._values.get("ab_variant_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password1(self) -> typing.Optional[builtins.str]:
        '''Provides the primary password used to encrypt patterns in your watermarking tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        '''
        result = self._values.get("decryption_password1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password2(self) -> typing.Optional[builtins.str]:
        '''Provides the secondary password you can use to rotate passwords.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        '''
        result = self._values.get("decryption_password2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a label that corresponds to the primary password.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        '''
        result = self._values.get("decryption_password_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        '''
        result = self._values.get("decryption_password_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the watermarking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def miscellaneous_settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        '''
        result = self._values.get("miscellaneous_settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def pattern_decryption_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        '''
        result = self._values.get("pattern_decryption_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pattern_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        '''
        result = self._values.get("pattern_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signature_verification_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can verify the signature in your watermarking token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        '''
        result = self._values.get("signature_verification_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_signing_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        '''
        result = self._values.get("token_signing_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_original_as_a(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        '''
        result = self._values.get("use_original_as_a")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the first public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        '''
        result = self._values.get("verification_key_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the optional second public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        '''
        result = self._values.get("verification_key_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key1(self) -> typing.Optional[builtins.str]:
        '''Specifies the first public key in its entirety.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        '''
        result = self._values.get("verification_public_key1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key2(self) -> typing.Optional[builtins.str]:
        '''Specifies the optional second public key in its entirety. Specify a second key to enable rotation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        result = self._values.get("verification_public_key2")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarkingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarkingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccc96c3090a0a32de5b7f1148d5b1a8601d29d2d1a39378888d1ab604cc2c73)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbVariantLocation")
    def reset_ab_variant_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbVariantLocation", []))

    @jsii.member(jsii_name="resetDecryptionPassword1")
    def reset_decryption_password1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword1", []))

    @jsii.member(jsii_name="resetDecryptionPassword2")
    def reset_decryption_password2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword2", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId1")
    def reset_decryption_password_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId1", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId2")
    def reset_decryption_password_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId2", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMiscellaneousSettingsTitle")
    def reset_miscellaneous_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMiscellaneousSettingsTitle", []))

    @jsii.member(jsii_name="resetPatternDecryptionEnable")
    def reset_pattern_decryption_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternDecryptionEnable", []))

    @jsii.member(jsii_name="resetPatternEncryptionTitle")
    def reset_pattern_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternEncryptionTitle", []))

    @jsii.member(jsii_name="resetSignatureVerificationEnable")
    def reset_signature_verification_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignatureVerificationEnable", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenSigningTitle")
    def reset_token_signing_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenSigningTitle", []))

    @jsii.member(jsii_name="resetUseOriginalAsA")
    def reset_use_original_as_a(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOriginalAsA", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationKeyId1")
    def reset_verification_key_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId1", []))

    @jsii.member(jsii_name="resetVerificationKeyId2")
    def reset_verification_key_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId2", []))

    @jsii.member(jsii_name="resetVerificationPublicKey1")
    def reset_verification_public_key1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey1", []))

    @jsii.member(jsii_name="resetVerificationPublicKey2")
    def reset_verification_public_key2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey2", []))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocationInput")
    def ab_variant_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abVariantLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1Input")
    def decryption_password1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2Input")
    def decryption_password2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword2Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1Input")
    def decryption_password_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2Input")
    def decryption_password_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId2Input"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitleInput")
    def miscellaneous_settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "miscellaneousSettingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnableInput")
    def pattern_decryption_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "patternDecryptionEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitleInput")
    def pattern_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "patternEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnableInput")
    def signature_verification_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "signatureVerificationEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitleInput")
    def token_signing_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenSigningTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsAInput")
    def use_original_as_a_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOriginalAsAInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1Input")
    def verification_key_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2Input")
    def verification_key_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId2Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1Input")
    def verification_public_key1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2Input")
    def verification_public_key2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey2Input"))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocation")
    def ab_variant_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abVariantLocation"))

    @ab_variant_location.setter
    def ab_variant_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5a906d19e03ee0fa08522c9f18e90acc0b04518ca0157993cc3a277f60dc8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abVariantLocation", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1")
    def decryption_password1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword1"))

    @decryption_password1.setter
    def decryption_password1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b42931fe85ea92ca4f304e5b9a3e097c813a685a746aaae56b490b22203f4eba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2")
    def decryption_password2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword2"))

    @decryption_password2.setter
    def decryption_password2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58e9c1d85cfa2700e070d73fb61682bcd57e4ae05e23c88343588b5c34002ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword2", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1")
    def decryption_password_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId1"))

    @decryption_password_id1.setter
    def decryption_password_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__001e69d405070642e535ac85f9c4210638f9982394ee59480770674d4cca3dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2")
    def decryption_password_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId2"))

    @decryption_password_id2.setter
    def decryption_password_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed2fec07e9d216fe64ea2826c048c203b7001366a21ae81d8cdd43cd0d30689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId2", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12996e8cdfafa18e3d375a7da0b482a6390a1f9f317aabb48539320f7e43c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6408f90c153b19b434c051f3c812063a5ceb723220cc2e90e300284f344d2a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitle")
    def miscellaneous_settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "miscellaneousSettingsTitle"))

    @miscellaneous_settings_title.setter
    def miscellaneous_settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088cba64eeb9e579cf6fd307cde664a99fcfd19653724899b987a29e26a017a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "miscellaneousSettingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnable")
    def pattern_decryption_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "patternDecryptionEnable"))

    @pattern_decryption_enable.setter
    def pattern_decryption_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5825df1f2bf07ead78035f2cdf13494905f2ff717770f329449620023419efe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternDecryptionEnable", value)

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitle")
    def pattern_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "patternEncryptionTitle"))

    @pattern_encryption_title.setter
    def pattern_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30d41b6186d639c2f98b5d5e864a02def74aab0da7a5359efd3a1c1e6b764b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnable")
    def signature_verification_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "signatureVerificationEnable"))

    @signature_verification_enable.setter
    def signature_verification_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76891314eb15e3caf1a4dc0a258681c4cf4d745e058d545ec9cb32efe925e592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signatureVerificationEnable", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b34cfe42450825cb42a460ce0e48ffc2a89c09051729e0c84290a50dee9e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitle")
    def token_signing_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenSigningTitle"))

    @token_signing_title.setter
    def token_signing_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49bb4128c4ba9357531533e46311e4a73fef800a1c77b6c032368c58e198c0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenSigningTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsA")
    def use_original_as_a(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOriginalAsA"))

    @use_original_as_a.setter
    def use_original_as_a(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7901220be005a086a48a7e9c791bd6836c3217431e390ae510396083e240e862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOriginalAsA", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06c24db3ca320c83fc5b772029a78058624cdfc23f5f8ed12b0a38ce6dc5f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1")
    def verification_key_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId1"))

    @verification_key_id1.setter
    def verification_key_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a14348cb8a9e189318e78706ad16b9b228a9cfa3d347f7a11cb2e3b7b0564431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2")
    def verification_key_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId2"))

    @verification_key_id2.setter
    def verification_key_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e662717626a93d30dd92893f2820cb521dfb96cc1a7bb177da29cb79552ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId2", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1")
    def verification_public_key1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey1"))

    @verification_public_key1.setter
    def verification_public_key1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d025d6bbcdcb5d884da0bb2b985d4e1bd223eaabbfe129082d41ca685042c699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2")
    def verification_public_key2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey2"))

    @verification_public_key2.setter
    def verification_public_key2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f1f2495dc7c73cc4377afdf5f35318bdd4576f5529482e787efe9df0bee82b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey2", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49b965aeef1ff163137ddd27dc3c55e25d9241ed0f5834e7eafd02ec26c4733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall",
    jsii_struct_bases=[],
    name_mapping={
        "firewall_configuration": "firewallConfiguration",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall:
    def __init__(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(firewall_configuration, dict):
            firewall_configuration = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration(**firewall_configuration)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb034f76b67e3864bae48e663cfac336a45aacb3b1c44bd9772f3999cafe768)
            check_type(argname="argument firewall_configuration", value=firewall_configuration, expected_type=type_hints["firewall_configuration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if firewall_configuration is not None:
            self._values["firewall_configuration"] = firewall_configuration
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def firewall_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration"]:
        '''firewall_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        '''
        result = self._values.get("firewall_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration"], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "config_id": "configId",
        "file_name": "fileName",
        "production_status": "productionStatus",
        "production_version": "productionVersion",
        "staging_status": "stagingStatus",
        "staging_version": "stagingVersion",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration:
    def __init__(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0122fdaeb7e8c529c7e23369c273fcb14914c9301c9b507cbd9ce1fd9600ee9e)
            check_type(argname="argument config_id", value=config_id, expected_type=type_hints["config_id"])
            check_type(argname="argument file_name", value=file_name, expected_type=type_hints["file_name"])
            check_type(argname="argument production_status", value=production_status, expected_type=type_hints["production_status"])
            check_type(argname="argument production_version", value=production_version, expected_type=type_hints["production_version"])
            check_type(argname="argument staging_status", value=staging_status, expected_type=type_hints["staging_status"])
            check_type(argname="argument staging_version", value=staging_version, expected_type=type_hints["staging_version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_id is not None:
            self._values["config_id"] = config_id
        if file_name is not None:
            self._values["file_name"] = file_name
        if production_status is not None:
            self._values["production_status"] = production_status
        if production_version is not None:
            self._values["production_version"] = production_version
        if staging_status is not None:
            self._values["staging_status"] = staging_status
        if staging_version is not None:
            self._values["staging_version"] = staging_version

    @builtins.property
    def config_id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.'''
        result = self._values.get("config_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def file_name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        '''
        result = self._values.get("file_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        '''
        result = self._values.get("production_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        '''
        result = self._values.get("production_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def staging_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        '''
        result = self._values.get("staging_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def staging_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        result = self._values.get("staging_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5f3e8b522133aceb3ef64ef1af2f513f9e019be6feec4cd8bce7cd77a11006)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigId")
    def reset_config_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigId", []))

    @jsii.member(jsii_name="resetFileName")
    def reset_file_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileName", []))

    @jsii.member(jsii_name="resetProductionStatus")
    def reset_production_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionStatus", []))

    @jsii.member(jsii_name="resetProductionVersion")
    def reset_production_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionVersion", []))

    @jsii.member(jsii_name="resetStagingStatus")
    def reset_staging_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingStatus", []))

    @jsii.member(jsii_name="resetStagingVersion")
    def reset_staging_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingVersion", []))

    @builtins.property
    @jsii.member(jsii_name="configIdInput")
    def config_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "configIdInput"))

    @builtins.property
    @jsii.member(jsii_name="fileNameInput")
    def file_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fileNameInput"))

    @builtins.property
    @jsii.member(jsii_name="productionStatusInput")
    def production_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "productionStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="productionVersionInput")
    def production_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "productionVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingStatusInput")
    def staging_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stagingStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingVersionInput")
    def staging_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "stagingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="configId")
    def config_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "configId"))

    @config_id.setter
    def config_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e885a449a3fdf0f322b73d7f96d4d3ae1fa4212670caa62fd484fb8fec2eaedf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configId", value)

    @builtins.property
    @jsii.member(jsii_name="fileName")
    def file_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fileName"))

    @file_name.setter
    def file_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d25586b7bbe8e74ed66896ca4d5d6173f7800c0aca9e3cd289a3f66cc85cbadb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fileName", value)

    @builtins.property
    @jsii.member(jsii_name="productionStatus")
    def production_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "productionStatus"))

    @production_status.setter
    def production_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4a446b7953eb520bb9bcf5bb654fe1a35f23241a4dfe37cbe49c0a7100927e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionStatus", value)

    @builtins.property
    @jsii.member(jsii_name="productionVersion")
    def production_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "productionVersion"))

    @production_version.setter
    def production_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779d66cb068d5f3f5d19cd5e81697820e4d611d4ce01f756a7ef76e0c9c89b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionVersion", value)

    @builtins.property
    @jsii.member(jsii_name="stagingStatus")
    def staging_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stagingStatus"))

    @staging_status.setter
    def staging_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dbd3981ba1e905cfe408210188b51fbce703c51eda6a52de32984354edeb4cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingStatus", value)

    @builtins.property
    @jsii.member(jsii_name="stagingVersion")
    def staging_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "stagingVersion"))

    @staging_version.setter
    def staging_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b56956d7cbe7c6a645d736f3bfd72d835a4952353c2333345ded1c8517eee752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7126b1b8c11172cee00453b5a6d5f4c9e6820b208bc35a25f63e265a4c2e119a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99627a0c75c9b23f52d55e59d1c5bf261777256dbd6258a59799e936ea88bb93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFirewallConfiguration")
    def put_firewall_configuration(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration(
            config_id=config_id,
            file_name=file_name,
            production_status=production_status,
            production_version=production_version,
            staging_status=staging_status,
            staging_version=staging_version,
        )

        return typing.cast(None, jsii.invoke(self, "putFirewallConfiguration", [value]))

    @jsii.member(jsii_name="resetFirewallConfiguration")
    def reset_firewall_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirewallConfiguration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="firewallConfiguration")
    def firewall_configuration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfigurationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfigurationOutputReference, jsii.get(self, "firewallConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="firewallConfigurationInput")
    def firewall_configuration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "firewallConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a702c0170c373f988af6d8317f361ca51e02e469f9fb427feb7dcd3f8b0cebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfbe63fe978c7427952691e03a682c35dc35ea42fcaf4ac2c77b835e14ed45a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7a3591247a1fa9722a0b4afcb2f2a26f8d6de015fff3e3c01e0542006edce23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19add992f4c6b20d25aee3762973fde9ba6fa37aac5d22bc78b55967cf055c71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2841f178463862ef6fecea33f5b52a04db84d3cba17590aef1da832eb24a8e06)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables WebSocket traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSocketsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSocketsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b64ace1b6bacca64e3f31327b9a16fa6c4c0fe3f97380f61d94233120660ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fd14e4c175147a202cf7b01a22ce1c1843d2e7f990f1001cde21f2cc418eb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810f64ab2c298ea81ada5efbb26a0299eb3802d146bbdf2ddfa001901cc12253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cfc86d22fe5131de67d1aa16ef71e28e1a95c04c69b0dbc8dd44ef3c3706ad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfe7c3f11ad412248a0cb1169a9657b55b3117d71e38a2aa83a2e72f3256ef79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344f95840fad8f4ab6e50a6dec690c0329c87eb65675061391393687030c6e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6db7c88f983270909b60a88eb21b0f8918bbd2e27ef889d6362ccf9fa17905f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the WebDAV behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdavOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdavOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67e7ae292050a6adc5b4a4f41926958cbe3857fa3cb37894dde9f52ff5f1a8b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f2ddada5a7fcaffc91869964c6dd97fec7bcdf2fdc4fe287de6dbd4bf25e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__981eeb5d1613b2b82b8e974f2e52829a35d3a6220e073389cff3e51dc90d6cc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae33b816341de90ce4b7daa0a8791cba46625d0b27802b43fffd30c2732f7e59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__271cfa327df7a77d6feec7f093f6c2af7a5074f8ee5e432685b786bbc3e69f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab89aeb68008af7c515ae8c00b9316122c900f3e56fb92301f87d7922fe1881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530Criterion",
    jsii_struct_bases=[],
    name_mapping={
        "advanced_im_match": "advancedImMatch",
        "bucket": "bucket",
        "cacheability": "cacheability",
        "china_cdn_region": "chinaCdnRegion",
        "client_certificate": "clientCertificate",
        "client_ip": "clientIp",
        "client_ip_version": "clientIpVersion",
        "cloudlets_origin": "cloudletsOrigin",
        "content_delivery_network": "contentDeliveryNetwork",
        "content_type": "contentType",
        "device_characteristic": "deviceCharacteristic",
        "ecmd_auth_groups": "ecmdAuthGroups",
        "ecmd_auth_scheme": "ecmdAuthScheme",
        "ecmd_is_authenticated": "ecmdIsAuthenticated",
        "ecmd_username": "ecmdUsername",
        "edge_workers_failure": "edgeWorkersFailure",
        "file_extension": "fileExtension",
        "filename": "filename",
        "hostname": "hostname",
        "match_advanced": "matchAdvanced",
        "match_cp_code": "matchCpCode",
        "match_response_code": "matchResponseCode",
        "match_variable": "matchVariable",
        "metadata_stage": "metadataStage",
        "origin_timeout": "originTimeout",
        "path": "path",
        "query_string_parameter": "queryStringParameter",
        "random": "random",
        "recovery_config": "recoveryConfig",
        "regular_expression": "regularExpression",
        "request_cookie": "requestCookie",
        "request_header": "requestHeader",
        "request_method": "requestMethod",
        "request_protocol": "requestProtocol",
        "request_type": "requestType",
        "response_header": "responseHeader",
        "server_location": "serverLocation",
        "time": "time",
        "token_authorization": "tokenAuthorization",
        "user_agent": "userAgent",
        "user_location": "userLocation",
        "user_network": "userNetwork",
        "variable_error": "variableError",
        "virtual_waiting_room_request": "virtualWaitingRoomRequest",
        "visitor_prioritization_request": "visitorPrioritizationRequest",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530Criterion:
    def __init__(
        self,
        *,
        advanced_im_match: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch", typing.Dict[builtins.str, typing.Any]]] = None,
        bucket: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket", typing.Dict[builtins.str, typing.Any]]] = None,
        cacheability: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability", typing.Dict[builtins.str, typing.Any]]] = None,
        china_cdn_region: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip_version: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlets_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        content_delivery_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        content_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_scheme: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_is_authenticated: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_username: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_workers_failure: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure", typing.Dict[builtins.str, typing.Any]]] = None,
        file_extension: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension", typing.Dict[builtins.str, typing.Any]]] = None,
        filename: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename", typing.Dict[builtins.str, typing.Any]]] = None,
        hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        match_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        match_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_stage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        path: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath", typing.Dict[builtins.str, typing.Any]]] = None,
        query_string_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        random: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom", typing.Dict[builtins.str, typing.Any]]] = None,
        recovery_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        regular_expression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression", typing.Dict[builtins.str, typing.Any]]] = None,
        request_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        request_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        request_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType", typing.Dict[builtins.str, typing.Any]]] = None,
        response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        server_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        time: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime", typing.Dict[builtins.str, typing.Any]]] = None,
        token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        user_agent: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent", typing.Dict[builtins.str, typing.Any]]] = None,
        user_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        user_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        variable_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param advanced_im_match: advanced_im_match block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        :param bucket: bucket block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param cacheability: cacheability block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        :param china_cdn_region: china_cdn_region block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        :param client_certificate: client_certificate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        :param client_ip: client_ip block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        :param client_ip_version: client_ip_version block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        :param cloudlets_origin: cloudlets_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        :param content_delivery_network: content_delivery_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        :param content_type: content_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param device_characteristic: device_characteristic block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        :param ecmd_auth_groups: ecmd_auth_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        :param ecmd_auth_scheme: ecmd_auth_scheme block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        :param ecmd_is_authenticated: ecmd_is_authenticated block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        :param ecmd_username: ecmd_username block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        :param edge_workers_failure: edge_workers_failure block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        :param file_extension: file_extension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        :param filename: filename block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        :param hostname: hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param match_advanced: match_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        :param match_cp_code: match_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        :param match_response_code: match_response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        :param match_variable: match_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        :param metadata_stage: metadata_stage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        :param origin_timeout: origin_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        :param path: path block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param query_string_parameter: query_string_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        :param random: random block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        :param recovery_config: recovery_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        :param regular_expression: regular_expression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        :param request_cookie: request_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        :param request_header: request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        :param request_method: request_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        :param request_protocol: request_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        :param request_type: request_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param response_header: response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        :param server_location: server_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        :param time: time block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        :param token_authorization: token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param user_agent: user_agent block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        :param user_location: user_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        :param user_network: user_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        :param variable_error: variable_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        :param virtual_waiting_room_request: virtual_waiting_room_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        :param visitor_prioritization_request: visitor_prioritization_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        if isinstance(advanced_im_match, dict):
            advanced_im_match = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch(**advanced_im_match)
        if isinstance(bucket, dict):
            bucket = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket(**bucket)
        if isinstance(cacheability, dict):
            cacheability = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability(**cacheability)
        if isinstance(china_cdn_region, dict):
            china_cdn_region = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion(**china_cdn_region)
        if isinstance(client_certificate, dict):
            client_certificate = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate(**client_certificate)
        if isinstance(client_ip, dict):
            client_ip = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp(**client_ip)
        if isinstance(client_ip_version, dict):
            client_ip_version = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion(**client_ip_version)
        if isinstance(cloudlets_origin, dict):
            cloudlets_origin = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin(**cloudlets_origin)
        if isinstance(content_delivery_network, dict):
            content_delivery_network = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork(**content_delivery_network)
        if isinstance(content_type, dict):
            content_type = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType(**content_type)
        if isinstance(device_characteristic, dict):
            device_characteristic = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic(**device_characteristic)
        if isinstance(ecmd_auth_groups, dict):
            ecmd_auth_groups = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups(**ecmd_auth_groups)
        if isinstance(ecmd_auth_scheme, dict):
            ecmd_auth_scheme = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme(**ecmd_auth_scheme)
        if isinstance(ecmd_is_authenticated, dict):
            ecmd_is_authenticated = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated(**ecmd_is_authenticated)
        if isinstance(ecmd_username, dict):
            ecmd_username = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername(**ecmd_username)
        if isinstance(edge_workers_failure, dict):
            edge_workers_failure = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure(**edge_workers_failure)
        if isinstance(file_extension, dict):
            file_extension = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension(**file_extension)
        if isinstance(filename, dict):
            filename = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename(**filename)
        if isinstance(hostname, dict):
            hostname = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname(**hostname)
        if isinstance(match_advanced, dict):
            match_advanced = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced(**match_advanced)
        if isinstance(match_cp_code, dict):
            match_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode(**match_cp_code)
        if isinstance(match_response_code, dict):
            match_response_code = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode(**match_response_code)
        if isinstance(match_variable, dict):
            match_variable = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable(**match_variable)
        if isinstance(metadata_stage, dict):
            metadata_stage = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage(**metadata_stage)
        if isinstance(origin_timeout, dict):
            origin_timeout = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout(**origin_timeout)
        if isinstance(path, dict):
            path = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath(**path)
        if isinstance(query_string_parameter, dict):
            query_string_parameter = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter(**query_string_parameter)
        if isinstance(random, dict):
            random = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom(**random)
        if isinstance(recovery_config, dict):
            recovery_config = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig(**recovery_config)
        if isinstance(regular_expression, dict):
            regular_expression = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression(**regular_expression)
        if isinstance(request_cookie, dict):
            request_cookie = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie(**request_cookie)
        if isinstance(request_header, dict):
            request_header = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader(**request_header)
        if isinstance(request_method, dict):
            request_method = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod(**request_method)
        if isinstance(request_protocol, dict):
            request_protocol = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol(**request_protocol)
        if isinstance(request_type, dict):
            request_type = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType(**request_type)
        if isinstance(response_header, dict):
            response_header = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader(**response_header)
        if isinstance(server_location, dict):
            server_location = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation(**server_location)
        if isinstance(time, dict):
            time = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime(**time)
        if isinstance(token_authorization, dict):
            token_authorization = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization(**token_authorization)
        if isinstance(user_agent, dict):
            user_agent = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent(**user_agent)
        if isinstance(user_location, dict):
            user_location = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation(**user_location)
        if isinstance(user_network, dict):
            user_network = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork(**user_network)
        if isinstance(variable_error, dict):
            variable_error = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError(**variable_error)
        if isinstance(virtual_waiting_room_request, dict):
            virtual_waiting_room_request = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest(**virtual_waiting_room_request)
        if isinstance(visitor_prioritization_request, dict):
            visitor_prioritization_request = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest(**visitor_prioritization_request)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__139f79072e9b94e0c39b102cd877c319e46b9f1f3b898674ff6ee0d8060e625e)
            check_type(argname="argument advanced_im_match", value=advanced_im_match, expected_type=type_hints["advanced_im_match"])
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument cacheability", value=cacheability, expected_type=type_hints["cacheability"])
            check_type(argname="argument china_cdn_region", value=china_cdn_region, expected_type=type_hints["china_cdn_region"])
            check_type(argname="argument client_certificate", value=client_certificate, expected_type=type_hints["client_certificate"])
            check_type(argname="argument client_ip", value=client_ip, expected_type=type_hints["client_ip"])
            check_type(argname="argument client_ip_version", value=client_ip_version, expected_type=type_hints["client_ip_version"])
            check_type(argname="argument cloudlets_origin", value=cloudlets_origin, expected_type=type_hints["cloudlets_origin"])
            check_type(argname="argument content_delivery_network", value=content_delivery_network, expected_type=type_hints["content_delivery_network"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument device_characteristic", value=device_characteristic, expected_type=type_hints["device_characteristic"])
            check_type(argname="argument ecmd_auth_groups", value=ecmd_auth_groups, expected_type=type_hints["ecmd_auth_groups"])
            check_type(argname="argument ecmd_auth_scheme", value=ecmd_auth_scheme, expected_type=type_hints["ecmd_auth_scheme"])
            check_type(argname="argument ecmd_is_authenticated", value=ecmd_is_authenticated, expected_type=type_hints["ecmd_is_authenticated"])
            check_type(argname="argument ecmd_username", value=ecmd_username, expected_type=type_hints["ecmd_username"])
            check_type(argname="argument edge_workers_failure", value=edge_workers_failure, expected_type=type_hints["edge_workers_failure"])
            check_type(argname="argument file_extension", value=file_extension, expected_type=type_hints["file_extension"])
            check_type(argname="argument filename", value=filename, expected_type=type_hints["filename"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument match_advanced", value=match_advanced, expected_type=type_hints["match_advanced"])
            check_type(argname="argument match_cp_code", value=match_cp_code, expected_type=type_hints["match_cp_code"])
            check_type(argname="argument match_response_code", value=match_response_code, expected_type=type_hints["match_response_code"])
            check_type(argname="argument match_variable", value=match_variable, expected_type=type_hints["match_variable"])
            check_type(argname="argument metadata_stage", value=metadata_stage, expected_type=type_hints["metadata_stage"])
            check_type(argname="argument origin_timeout", value=origin_timeout, expected_type=type_hints["origin_timeout"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument query_string_parameter", value=query_string_parameter, expected_type=type_hints["query_string_parameter"])
            check_type(argname="argument random", value=random, expected_type=type_hints["random"])
            check_type(argname="argument recovery_config", value=recovery_config, expected_type=type_hints["recovery_config"])
            check_type(argname="argument regular_expression", value=regular_expression, expected_type=type_hints["regular_expression"])
            check_type(argname="argument request_cookie", value=request_cookie, expected_type=type_hints["request_cookie"])
            check_type(argname="argument request_header", value=request_header, expected_type=type_hints["request_header"])
            check_type(argname="argument request_method", value=request_method, expected_type=type_hints["request_method"])
            check_type(argname="argument request_protocol", value=request_protocol, expected_type=type_hints["request_protocol"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument response_header", value=response_header, expected_type=type_hints["response_header"])
            check_type(argname="argument server_location", value=server_location, expected_type=type_hints["server_location"])
            check_type(argname="argument time", value=time, expected_type=type_hints["time"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument user_agent", value=user_agent, expected_type=type_hints["user_agent"])
            check_type(argname="argument user_location", value=user_location, expected_type=type_hints["user_location"])
            check_type(argname="argument user_network", value=user_network, expected_type=type_hints["user_network"])
            check_type(argname="argument variable_error", value=variable_error, expected_type=type_hints["variable_error"])
            check_type(argname="argument virtual_waiting_room_request", value=virtual_waiting_room_request, expected_type=type_hints["virtual_waiting_room_request"])
            check_type(argname="argument visitor_prioritization_request", value=visitor_prioritization_request, expected_type=type_hints["visitor_prioritization_request"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced_im_match is not None:
            self._values["advanced_im_match"] = advanced_im_match
        if bucket is not None:
            self._values["bucket"] = bucket
        if cacheability is not None:
            self._values["cacheability"] = cacheability
        if china_cdn_region is not None:
            self._values["china_cdn_region"] = china_cdn_region
        if client_certificate is not None:
            self._values["client_certificate"] = client_certificate
        if client_ip is not None:
            self._values["client_ip"] = client_ip
        if client_ip_version is not None:
            self._values["client_ip_version"] = client_ip_version
        if cloudlets_origin is not None:
            self._values["cloudlets_origin"] = cloudlets_origin
        if content_delivery_network is not None:
            self._values["content_delivery_network"] = content_delivery_network
        if content_type is not None:
            self._values["content_type"] = content_type
        if device_characteristic is not None:
            self._values["device_characteristic"] = device_characteristic
        if ecmd_auth_groups is not None:
            self._values["ecmd_auth_groups"] = ecmd_auth_groups
        if ecmd_auth_scheme is not None:
            self._values["ecmd_auth_scheme"] = ecmd_auth_scheme
        if ecmd_is_authenticated is not None:
            self._values["ecmd_is_authenticated"] = ecmd_is_authenticated
        if ecmd_username is not None:
            self._values["ecmd_username"] = ecmd_username
        if edge_workers_failure is not None:
            self._values["edge_workers_failure"] = edge_workers_failure
        if file_extension is not None:
            self._values["file_extension"] = file_extension
        if filename is not None:
            self._values["filename"] = filename
        if hostname is not None:
            self._values["hostname"] = hostname
        if match_advanced is not None:
            self._values["match_advanced"] = match_advanced
        if match_cp_code is not None:
            self._values["match_cp_code"] = match_cp_code
        if match_response_code is not None:
            self._values["match_response_code"] = match_response_code
        if match_variable is not None:
            self._values["match_variable"] = match_variable
        if metadata_stage is not None:
            self._values["metadata_stage"] = metadata_stage
        if origin_timeout is not None:
            self._values["origin_timeout"] = origin_timeout
        if path is not None:
            self._values["path"] = path
        if query_string_parameter is not None:
            self._values["query_string_parameter"] = query_string_parameter
        if random is not None:
            self._values["random"] = random
        if recovery_config is not None:
            self._values["recovery_config"] = recovery_config
        if regular_expression is not None:
            self._values["regular_expression"] = regular_expression
        if request_cookie is not None:
            self._values["request_cookie"] = request_cookie
        if request_header is not None:
            self._values["request_header"] = request_header
        if request_method is not None:
            self._values["request_method"] = request_method
        if request_protocol is not None:
            self._values["request_protocol"] = request_protocol
        if request_type is not None:
            self._values["request_type"] = request_type
        if response_header is not None:
            self._values["response_header"] = response_header
        if server_location is not None:
            self._values["server_location"] = server_location
        if time is not None:
            self._values["time"] = time
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if user_agent is not None:
            self._values["user_agent"] = user_agent
        if user_location is not None:
            self._values["user_location"] = user_location
        if user_network is not None:
            self._values["user_network"] = user_network
        if variable_error is not None:
            self._values["variable_error"] = variable_error
        if virtual_waiting_room_request is not None:
            self._values["virtual_waiting_room_request"] = virtual_waiting_room_request
        if visitor_prioritization_request is not None:
            self._values["visitor_prioritization_request"] = visitor_prioritization_request

    @builtins.property
    def advanced_im_match(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch"]:
        '''advanced_im_match block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        '''
        result = self._values.get("advanced_im_match")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch"], result)

    @builtins.property
    def bucket(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket"]:
        '''bucket block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket"], result)

    @builtins.property
    def cacheability(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability"]:
        '''cacheability block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        '''
        result = self._values.get("cacheability")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability"], result)

    @builtins.property
    def china_cdn_region(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion"]:
        '''china_cdn_region block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        '''
        result = self._values.get("china_cdn_region")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion"], result)

    @builtins.property
    def client_certificate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate"]:
        '''client_certificate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        '''
        result = self._values.get("client_certificate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate"], result)

    @builtins.property
    def client_ip(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp"]:
        '''client_ip block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        '''
        result = self._values.get("client_ip")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp"], result)

    @builtins.property
    def client_ip_version(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion"]:
        '''client_ip_version block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        '''
        result = self._values.get("client_ip_version")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion"], result)

    @builtins.property
    def cloudlets_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin"]:
        '''cloudlets_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        '''
        result = self._values.get("cloudlets_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin"], result)

    @builtins.property
    def content_delivery_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork"]:
        '''content_delivery_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        '''
        result = self._values.get("content_delivery_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork"], result)

    @builtins.property
    def content_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType"]:
        '''content_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType"], result)

    @builtins.property
    def device_characteristic(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic"]:
        '''device_characteristic block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        '''
        result = self._values.get("device_characteristic")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic"], result)

    @builtins.property
    def ecmd_auth_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups"]:
        '''ecmd_auth_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        '''
        result = self._values.get("ecmd_auth_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups"], result)

    @builtins.property
    def ecmd_auth_scheme(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme"]:
        '''ecmd_auth_scheme block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        '''
        result = self._values.get("ecmd_auth_scheme")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme"], result)

    @builtins.property
    def ecmd_is_authenticated(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated"]:
        '''ecmd_is_authenticated block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        '''
        result = self._values.get("ecmd_is_authenticated")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated"], result)

    @builtins.property
    def ecmd_username(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername"]:
        '''ecmd_username block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        '''
        result = self._values.get("ecmd_username")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername"], result)

    @builtins.property
    def edge_workers_failure(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure"]:
        '''edge_workers_failure block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        '''
        result = self._values.get("edge_workers_failure")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure"], result)

    @builtins.property
    def file_extension(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension"]:
        '''file_extension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        '''
        result = self._values.get("file_extension")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension"], result)

    @builtins.property
    def filename(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename"]:
        '''filename block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        '''
        result = self._values.get("filename")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename"], result)

    @builtins.property
    def hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname"]:
        '''hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname"], result)

    @builtins.property
    def match_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced"]:
        '''match_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        '''
        result = self._values.get("match_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced"], result)

    @builtins.property
    def match_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode"]:
        '''match_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        '''
        result = self._values.get("match_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode"], result)

    @builtins.property
    def match_response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode"]:
        '''match_response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        '''
        result = self._values.get("match_response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode"], result)

    @builtins.property
    def match_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable"]:
        '''match_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        '''
        result = self._values.get("match_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable"], result)

    @builtins.property
    def metadata_stage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage"]:
        '''metadata_stage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        '''
        result = self._values.get("metadata_stage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage"], result)

    @builtins.property
    def origin_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout"]:
        '''origin_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        '''
        result = self._values.get("origin_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout"], result)

    @builtins.property
    def path(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath"]:
        '''path block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath"], result)

    @builtins.property
    def query_string_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter"]:
        '''query_string_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        '''
        result = self._values.get("query_string_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter"], result)

    @builtins.property
    def random(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom"]:
        '''random block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        '''
        result = self._values.get("random")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom"], result)

    @builtins.property
    def recovery_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig"]:
        '''recovery_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        '''
        result = self._values.get("recovery_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig"], result)

    @builtins.property
    def regular_expression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression"]:
        '''regular_expression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        '''
        result = self._values.get("regular_expression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression"], result)

    @builtins.property
    def request_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie"]:
        '''request_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        '''
        result = self._values.get("request_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie"], result)

    @builtins.property
    def request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader"]:
        '''request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        '''
        result = self._values.get("request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader"], result)

    @builtins.property
    def request_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod"]:
        '''request_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        '''
        result = self._values.get("request_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod"], result)

    @builtins.property
    def request_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol"]:
        '''request_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        '''
        result = self._values.get("request_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol"], result)

    @builtins.property
    def request_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType"]:
        '''request_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType"], result)

    @builtins.property
    def response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader"]:
        '''response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        '''
        result = self._values.get("response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader"], result)

    @builtins.property
    def server_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation"]:
        '''server_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        '''
        result = self._values.get("server_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation"], result)

    @builtins.property
    def time(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime"]:
        '''time block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        '''
        result = self._values.get("time")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime"], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization"]:
        '''token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization"], result)

    @builtins.property
    def user_agent(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent"]:
        '''user_agent block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        '''
        result = self._values.get("user_agent")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent"], result)

    @builtins.property
    def user_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation"]:
        '''user_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        '''
        result = self._values.get("user_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation"], result)

    @builtins.property
    def user_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork"]:
        '''user_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        '''
        result = self._values.get("user_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork"], result)

    @builtins.property
    def variable_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError"]:
        '''variable_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        '''
        result = self._values.get("variable_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError"], result)

    @builtins.property
    def virtual_waiting_room_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest"]:
        '''virtual_waiting_room_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        '''
        result = self._values.get("virtual_waiting_room_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest"], result)

    @builtins.property
    def visitor_prioritization_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest"]:
        '''visitor_prioritization_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        result = self._values.get("visitor_prioritization_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530Criterion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844797949fe5996806d6b5581e7e3310def5fa6fabbb6e277b85f9334f9bda22)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__585f6fb201078750bf3a187f5161628b2b68ca597e5206a765e10146fb59b342)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39041d6770dfcd822de947b3003cec70e980a4d8a3c0578267c17c932978c73b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d77563bfe24464b6395b595fb433c943878f97c33ea144f832427e5ad829691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89105b15ba89a3b406092fa8f3a24e69e6224025ea95b37389e80251d05572b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d310ba4c92441966d0a30b76b29634bf29adcaced47e1f4b1f7a8ba5fa0e19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d31979ef043819d2f8cd546adff3abff7fbb029cc59cd5420097d05d96d87490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b0a8ea7d3685fd464d2334e6206ab7e904a71d687910b777156ea45983bae1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "percentage": "percentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__894f56581d9ec15d1a9ca3ec44cd149bb8cd067690cd239e1300038f667d5875)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument percentage", value=percentage, expected_type=type_hints["percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if percentage is not None:
            self._values["percentage"] = percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of requests to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        '''
        result = self._values.get("percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucketOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucketOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d935dfa1215a2616e78911a74b9b2bc04f94e91f0eacab0b0b50acec513dec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPercentage")
    def reset_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="percentageInput")
    def percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "percentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2dc4e1dac894f663e92506660ccc268663d31cc7524b671db2d97a0967f79ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="percentage")
    def percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "percentage"))

    @percentage.setter
    def percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134b0010ebf66adabe06e605796afc21b861d18b9b976ef2d70ac11578bc82b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "percentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d5d9ae772f883b44a6ae2de8857e3b8c343551f72dff04acb4031242ef9322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf8fa485361d6c8e4527cb22131a0122210fd8d6c482b0eefa2b97bbf2a8af3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a813c22ddbf44ec5b6970ee00803584d114b3257673364e4c00b1eb1ab97e911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d25086f34358c9742274c73b9fc7c11f05319fb530f2893a3eaac02313fe19c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheabilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheabilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4b6f8aa651a5b5af43c4fdd9069a40df0dce1775d4f47fe9b36a9bc3de7efe5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e12cc659f46b503118183eb0ee33c06fa568069d3fd06b65f4ff0f68b6af31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5787132f2e3c17582da0d82d0b4d64e370a65ef398982b2ea0f27d89a7cdad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a66a08ca7aa3d9de9a2dd4cdd56889537d0c2d6fc921de7252ceeba916785dfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ece03735921769055c2fa64b52806e1f546b74dc01178142fb14c2495663b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89347d33898fdbfa902f5138b80d511038e40b29029af1a9ed6e1e31ab8eea9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__128c9a5637a25f25a7fc26b03aea423fd9d9f2d53e5739978244b40ff0ad0f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5874c7107680c69a8c73bf0b1cbdf272d789c4e25c9b4fdaaceddbdca218181)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb4459c10c964798cdf52f96a65c0cb086cffd04cf6df027b0a42ba60ebb4432)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10aa509214e6a554adc81583de9228f6a81d2a2c7cf3661a204e4cd80d6004b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7468d09dd3cf2185ee8381517f6995ef1850dbd8464a04f990e631e415d34e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4234597055237e9fec60726422e00b20bf65b9900dde6e2cf1591205d5bb11f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb09b7264a685cde037c859b4d16c504b9ad18680b34c816e2f788f231c5150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd96d1297a96648ce41a309a863f47348cd2b28efb64b92bcaecb98b9d6fa511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate",
    jsii_struct_bases=[],
    name_mapping={
        "is_certificate_present": "isCertificatePresent",
        "is_certificate_valid": "isCertificateValid",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate:
    def __init__(
        self,
        *,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae5f5dcf7f5b45218f188b0e4db4d2c10e1c720c77b1870c900559c0be38c29)
            check_type(argname="argument is_certificate_present", value=is_certificate_present, expected_type=type_hints["is_certificate_present"])
            check_type(argname="argument is_certificate_valid", value=is_certificate_valid, expected_type=type_hints["is_certificate_valid"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if is_certificate_present is not None:
            self._values["is_certificate_present"] = is_certificate_present
        if is_certificate_valid is not None:
            self._values["is_certificate_valid"] = is_certificate_valid
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def is_certificate_present(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Executes rule behaviors only if a client certificate authenticates requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        '''
        result = self._values.get("is_certificate_present")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_valid(self) -> typing.Optional[builtins.str]:
        '''Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        '''
        result = self._values.get("is_certificate_valid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63a1cb486ab038829551f874561b426186bd2d5de6159ecb422dc232b34efc8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetIsCertificatePresent")
    def reset_is_certificate_present(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificatePresent", []))

    @jsii.member(jsii_name="resetIsCertificateValid")
    def reset_is_certificate_valid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateValid", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresentInput")
    def is_certificate_present_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificatePresentInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateValidInput")
    def is_certificate_valid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "isCertificateValidInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresent")
    def is_certificate_present(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificatePresent"))

    @is_certificate_present.setter
    def is_certificate_present(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a41f8a758a0bfc60dfac0d943713b186df0b5248dfd7ecfb3be25589295399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificatePresent", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateValid")
    def is_certificate_valid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "isCertificateValid"))

    @is_certificate_valid.setter
    def is_certificate_valid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af3cb10cf177cdc80fa67dc9c28255eb49a66a46cba5d1764807cc7f13afa4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateValid", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460513df14a82be5383bdf2dfe28946d98a6d024f68287b535301767e2ae2d32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46e8f1f5745dfc6a0917e47f83fcf0ca054e5d3290c6faf649a3a7165cd86a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dfecf5fa6e93163539208f02ed02e1396d71f6ca7c4afb4adcc976bebf547fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd236e362d11f4d1804bc9665a7241e07b8e9ef4ddf49676d0ca2af438da9f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "use_headers": "useHeaders",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__377e2e985f5947c22b9b0f90d0e6947fcd412810c26362dac3a6afa55b421f2b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_headers", value=use_headers, expected_type=type_hints["use_headers"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_headers is not None:
            self._values["use_headers"] = use_headers
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        '''
        result = self._values.get("use_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''IP or CIDR block, for example: ``71.92.0.0/14``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef2c0cf4f42dc65ddc04928a2ff214b794f00f2bf2dcf4aae10b8d059af9db9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHeaders")
    def reset_use_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHeaders", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHeadersInput")
    def use_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa71744b663eea018882862e5942642062f888f731c408602ed546cfdb8f83a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76aa3673dad9428853371b10a6ea9c1ad275389c5d327f8ace6fe65a10b72ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6526859e4404fdb83c7d7f380937032d778b8848ed91987fe572953c5b8f8ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHeaders")
    def use_headers(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHeaders"))

    @use_headers.setter
    def use_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba84f0d13ec75a5800dc44da0b56a1616d3d7ff52d314458e3819f79499c9b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61fa7e48ec63f476fd1c4ce209a98244b651e0c5c80d3c02424da1d5958b5c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5479f772c53f28754dbe43ec5d074e3d0db934cfe2d154f445434169da41ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba7abc5475931787f484416e40cbd9a723277637c461708a0b4fd44b322ea845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_x_forwarded_for": "useXForwardedFor",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9f525f83585957d2ae4cdf2d365c7da29bd9ccda51fa286469805bbf72dabe)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_x_forwarded_for", value=use_x_forwarded_for, expected_type=type_hints["use_x_forwarded_for"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_x_forwarded_for is not None:
            self._values["use_x_forwarded_for"] = use_x_forwarded_for
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        '''
        result = self._values.get("use_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The IP version of the client request, either ``IPV4`` or ``IPV6``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0908ef48bcb3064e447a30008aecf5457c84389821311d7566d0263098a0489)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseXForwardedFor")
    def reset_use_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseXForwardedFor", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useXForwardedForInput")
    def use_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab51cf37732292cdd3c73e2ff1c96925ff1107bb5660efa9c9abe5a5104cb912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51267092b5d3d3d23ef737680528d5cf3ea01bd3c2786e2c567fab9682dbae95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useXForwardedFor")
    def use_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useXForwardedFor"))

    @use_x_forwarded_for.setter
    def use_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8b38d6e45a0a11d79199384fd82163295230dda42405cb8ce8dffd064de4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cc1555437670ad4685ad52b6e17f74d774ce56a5aeee1ccb4ba274975e373be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e4943e7caac419e10a5877b3fb4e09c4efb025b96c24c2dbca8f7b5f1ac5a16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bd5f92deaa7ba58136b4f383e03ff1ec578c6c969d4872cd344ea6a3ed508c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853091b6e3c8bcd343dfaa23dfd6b5a0a72071084396ae2333a22d3a5898f349)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''The Cloudlets Origins identifier, limited to alphanumeric and underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6cef76ef4de4208fedee0ea887a3d82ac72df1a48d50c04797c19b38a92975c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62516f763513d0cd65a678086a28097636c0d2b21410124741ba5cb3748eaa1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacfaa99b0344f660c2cd8fc46604f332763d4f34a0b01e822cbc08bd1e8bb03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236780b8c8dec01d0c69d92813d597ceef00a720ea9e4893257b3f1c3aa2efce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30de4072845f28c9cea4a2c86f7b6d9ef3b6c1a7289cc46db8983d1bb277e6c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__394a15286f31d9773b4f7af202a628bb9382a4515b5b1906d0400303936dd26c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "network": "network",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8849e966919d3f2add519e70d1600f0300e6efc5a16e5bcd570039176581a53f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network", value=network, expected_type=type_hints["network"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network is not None:
            self._values["network"] = network
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network(self) -> typing.Optional[builtins.str]:
        '''Match the network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        '''
        result = self._values.get("network")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e9a4505306977fd800299c415a9f2c4838eaa32dafb08470ab51e14526d348)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetwork")
    def reset_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetwork", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkInput")
    def network_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "networkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cda6ecc58c1fc261451231efce49551c22619bab45798965c9b016ad61dd3be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b814a7ed865c5c31d677fd55a87baa5e33af05ff0166ab51d79c51f98ef1572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="network")
    def network(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "network"))

    @network.setter
    def network(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c63a22d761b0ed9f4397bd825a6d468fb40dad8db8eec6d4a9c31fab2b3a264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "network", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254ad0ad5df337dc2b2752cd9433332c6c969ac4feb9955f752070c27908a302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba75bc7236be0005965b96682af37d64a6dbb1a7559b94b1930db3f673898d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca995812f2cee764a316879af12f2dc12627c412bdfcf7cf241fcdccd17678a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__849e84ae10a6c70a913138d6b26a4a2fe2796d5ed7e2c88e0e7f754651728420)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for all ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''``Content-Type`` response header value, for example ``text/html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b145a727b8ca91a95e3ef29b799cb5e4ba196179c14bf639c17e0cb263c29196)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2a7ad5249431679d1373764b1dffe06dd017d1dd9d7cce13bd0dc90c46b4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3121af6814b186a31100746538dc37685e0fbd9106a48c01b6aecd242a4c0db9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98cd443c3c5885a19f8e2dd27fe8ea3bb7c9dfb7f9d5409d3b8c56ccd23c1629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27861021d340c8836fde7bf1cb76954e0335a2559bdecb51081f24e9eb7958cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae22004696112b781f44cd07cf1bf0a990797f4a55dd8a630c5c6ae6efcee56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a590761911af90e7fafbb23bafd555113b5eea1f4b3970341d09af0df9e6c0ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66ad47b0adacc19404794e9fbc47bc559d88c1993dad0bf436502b34abc3b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd2aadf4860c592f9990dfec46989a890db56e97f7a17187d29facbaff7329f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic",
    jsii_struct_bases=[],
    name_mapping={
        "boolean_value": "booleanValue",
        "characteristic": "characteristic",
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_wildcard": "matchWildcard",
        "numeric_match_operator": "numericMatchOperator",
        "numeric_value": "numericValue",
        "string_match_operator": "stringMatchOperator",
        "string_value": "stringValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "version_match_operator": "versionMatchOperator",
        "version_value": "versionValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic:
    def __init__(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77cdd04b684c3218719672a5dbc98c47b64961bbee97154a2e17465779faeb5b)
            check_type(argname="argument boolean_value", value=boolean_value, expected_type=type_hints["boolean_value"])
            check_type(argname="argument characteristic", value=characteristic, expected_type=type_hints["characteristic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument numeric_match_operator", value=numeric_match_operator, expected_type=type_hints["numeric_match_operator"])
            check_type(argname="argument numeric_value", value=numeric_value, expected_type=type_hints["numeric_value"])
            check_type(argname="argument string_match_operator", value=string_match_operator, expected_type=type_hints["string_match_operator"])
            check_type(argname="argument string_value", value=string_value, expected_type=type_hints["string_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument version_match_operator", value=version_match_operator, expected_type=type_hints["version_match_operator"])
            check_type(argname="argument version_value", value=version_value, expected_type=type_hints["version_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if boolean_value is not None:
            self._values["boolean_value"] = boolean_value
        if characteristic is not None:
            self._values["characteristic"] = characteristic
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if numeric_match_operator is not None:
            self._values["numeric_match_operator"] = numeric_match_operator
        if numeric_value is not None:
            self._values["numeric_value"] = numeric_value
        if string_match_operator is not None:
            self._values["string_match_operator"] = string_match_operator
        if string_value is not None:
            self._values["string_value"] = string_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if version_match_operator is not None:
            self._values["version_match_operator"] = version_match_operator
        if version_value is not None:
            self._values["version_value"] = version_value

    @builtins.property
    def boolean_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the ``characteristic`` expects a boolean value, this specifies the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        '''
        result = self._values.get("boolean_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def characteristic(self) -> typing.Optional[builtins.str]:
        '''Aspect of the device or browser to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        '''
        result = self._values.get("characteristic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``stringValue`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def numeric_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        '''
        result = self._values.get("numeric_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def numeric_value(self) -> typing.Optional[jsii.Number]:
        '''When the ``characteristic`` expects a numeric value, this specifies the number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        '''
        result = self._values.get("numeric_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def string_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        '''
        result = self._values.get("string_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def string_value(self) -> typing.Optional[typing.List[builtins.str]]:
        '''When the ``characteristic`` expects a string, this specifies the set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        '''
        result = self._values.get("string_value")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        '''
        result = self._values.get("version_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_value(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version number, this specifies it as a string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        result = self._values.get("version_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristicOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristicOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24b1782721c2833f1ea22788176bea5e70f8c4d91016928520f95179a2f67629)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBooleanValue")
    def reset_boolean_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBooleanValue", []))

    @jsii.member(jsii_name="resetCharacteristic")
    def reset_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCharacteristic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetNumericMatchOperator")
    def reset_numeric_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericMatchOperator", []))

    @jsii.member(jsii_name="resetNumericValue")
    def reset_numeric_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericValue", []))

    @jsii.member(jsii_name="resetStringMatchOperator")
    def reset_string_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringMatchOperator", []))

    @jsii.member(jsii_name="resetStringValue")
    def reset_string_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVersionMatchOperator")
    def reset_version_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionMatchOperator", []))

    @jsii.member(jsii_name="resetVersionValue")
    def reset_version_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionValue", []))

    @builtins.property
    @jsii.member(jsii_name="booleanValueInput")
    def boolean_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "booleanValueInput"))

    @builtins.property
    @jsii.member(jsii_name="characteristicInput")
    def characteristic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "characteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperatorInput")
    def numeric_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "numericMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="numericValueInput")
    def numeric_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numericValueInput"))

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperatorInput")
    def string_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stringMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="stringValueInput")
    def string_value_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "stringValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperatorInput")
    def version_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="versionValueInput")
    def version_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="booleanValue")
    def boolean_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "booleanValue"))

    @boolean_value.setter
    def boolean_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9adb58671ea98231308028695e1b0679025bcb0688f63f81c49e225b5ad349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "booleanValue", value)

    @builtins.property
    @jsii.member(jsii_name="characteristic")
    def characteristic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "characteristic"))

    @characteristic.setter
    def characteristic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__972618dba1e738ff4318e6f6f5a784b66528899995a63e92d9d40e86bcdd64fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "characteristic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a998b48d07acfbd211650f629eb842e3ba89d92c0d9ff3f3d26943b44285a432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73627663e791e997616e9f74f0fdb0d64fe09202c9317177b9f7a9ed1f68492b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab01eee2966a924206e0bc523885da632a366759a546d0bfac2e6926b668abab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperator")
    def numeric_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "numericMatchOperator"))

    @numeric_match_operator.setter
    def numeric_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52f091161b8fe0b09c55e93e6437e521ce24717ae701c9c681adb706798f4253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="numericValue")
    def numeric_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numericValue"))

    @numeric_value.setter
    def numeric_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bd24827f413396755df933133d23c795679d741dd2e0d4530c7bcb2043b372c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericValue", value)

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperator")
    def string_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stringMatchOperator"))

    @string_match_operator.setter
    def string_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9868fe430bcde9c3d5262cc5779134a4feeab8029dc38973915368a5d69375c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="stringValue")
    def string_value(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "stringValue"))

    @string_value.setter
    def string_value(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa8da374388b5c282dffb7911c8c2507d892acf4970c7d039992564a8741b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe829a21fffd86dd646f5db6286526d0da28b5fc7f24664491c58a72ce49afb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ebabd2d9398709f7b11502afe623ffffd91440097fb5575687b3e154bf31df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperator")
    def version_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionMatchOperator"))

    @version_match_operator.setter
    def version_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69a9eb7429120a7b1e4fbbbbfb2eceb23057c56524fc76fedf580f844b93ca7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="versionValue")
    def version_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionValue"))

    @version_value.setter
    def version_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__187c5d3d7b180031ae1304600e84f3cc6883e5fde5cf1a0c28195b3ca13590eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a853148f04b3a48dec59532ac214060db4b361667a40f76b9638ddd56d4f0587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6847073927431e13d983967f4dd635a417b82165f816a2ec5968688908b1ff4a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa87daa2cbe002dc6fa65673ad7d028313d475104cbe574a6522f7042f9aa9c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acff801dab3c6d744cd616a57af35e9d102c18bf710db411b1fe0da75839f933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4b27d855fef94ea4bdbeabfd65f34fa947f485bbc8bd621cf0b8fcae81f839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4de556d4a7ec013a8a01b3e0a7cffc9aa0cf7d5a96a859796d4fdff63224515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c87f41bf05b926eca7cbffeac244830c533c62d5c4c92d7b2078da1192afba62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e1e6c3845867eff006f465979dfa20187c4724bae96d7371d7d9da5160c687)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12fc54e2dc52bb23362750866dfe98f0dc4f30ab90c01a0a6a1e87bc1eb44f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme",
    jsii_struct_bases=[],
    name_mapping={
        "auth_scheme": "authScheme",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme:
    def __init__(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7905bb83f16483e8249d156e1b80bcb53c4b42928cfc43843d7ef1445b4d20)
            check_type(argname="argument auth_scheme", value=auth_scheme, expected_type=type_hints["auth_scheme"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if auth_scheme is not None:
            self._values["auth_scheme"] = auth_scheme
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def auth_scheme(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.'''
        result = self._values.get("auth_scheme")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthSchemeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthSchemeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bd458fbcb7b98e61b50b2bf67c62f33a7cf983f78d6ca9a1480811d4b6964e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthScheme")
    def reset_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthScheme", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authSchemeInput")
    def auth_scheme_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authScheme")
    def auth_scheme(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authScheme"))

    @auth_scheme.setter
    def auth_scheme(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80df74109b8ef2c59ad3e96562b446a31d368331250830d81f683b59ff3c6d0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authScheme", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b8c3f3a658803bd355d60d989dc1927e7002ae1a01fc876e29a843132adf97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__047e5786d81c9d797d660b508791ebdb85f0ad16c3604b5eb3e93d0e58e4e82a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb141c82b0c2ffd520f6713eefc9d7679fa1b6798a4e21504d30602a2f28f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba78434fbf433813c57f0b70ea44c8951b3ba162e9e1aa4adfb46a30c23a58bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc37c284ca5b31fc18ec8b086a60e0385f108060625c513d620da10770bac35)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticatedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticatedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c7c1d351c709ba6b442fada1124b0d72a23bf7d130824f10177d333f07f6dd1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f99980f2b8d796f49d076a05fca1d6df2a2a6335ae9357c6940d5b3210f0b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acfa0a56e842d1e3e6c2a8f54e583b31f33c3a84c9897d3265f59b2cf19f42b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da56f2305864a18db2904f8a7badc14fde58cae23cbecb02b2a0a93af56bd347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00b45987995e8eca664af22c6c1a462127204876b48c85e9de155153224bcce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7271992c2498e64ff9e01343bb1b0585a1f2000353a2e40988b6df18f11a611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername",
    jsii_struct_bases=[],
    name_mapping={
        "length": "length",
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername:
    def __init__(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc5e0feb2843045e2a6a640345e3bcbb6286396c67f90518f7169411fb709a17)
            check_type(argname="argument length", value=length, expected_type=type_hints["length"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if length is not None:
            self._values["length"] = length
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def length(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.'''
        result = self._values.get("length")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsernameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsernameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f14f412384854827a34773754504d9b7bbcaf172de529f9ef849910d3402bba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLength")
    def reset_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLength", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lengthInput")
    def length_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lengthInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="length")
    def length(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "length"))

    @length.setter
    def length(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730f1cd2628421516a54da6e5b162d9280a4481d982bfa2b0d52de87d15c5444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "length", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503448f22c142d36d364c7b8f74389f2c67d38ea5b56f8c9ca52edba9f706f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d5a36d59af8bd228cf91d6de44c8c60fddab3a5b4c6b8c3f1c542bdab007b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da3c7acf1eef64f266cca21052bed85dd6252324ce8cd817be452ac9cfbf9771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__560265d5d02bf2c52f89d3ceb8a7765c5cc06d206453d5ff60c2a5fa38f03f13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45e86fb2458b915b727691152dc0d856a34d0de4c325fbb21fefbaadcebe358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8976d4e9aa11d8cf87a8e2d573a0d9999da7b3a678fb713fc8796621aa1d4768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure",
    jsii_struct_bases=[],
    name_mapping={
        "exec_status": "execStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure:
    def __init__(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee65d53527426e1328f95a3cd6b83b963ebe2ebf7067aec44d1640ea0ebac39)
            check_type(argname="argument exec_status", value=exec_status, expected_type=type_hints["exec_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if exec_status is not None:
            self._values["exec_status"] = exec_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def exec_status(self) -> typing.Optional[builtins.str]:
        '''Specify execution status.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        '''
        result = self._values.get("exec_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailureOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailureOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0875d0c78c63ee7bc10cc55c16cb2554951215b09d79e3d567bf7a09a7ad71bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExecStatus")
    def reset_exec_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExecStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="execStatusInput")
    def exec_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "execStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="execStatus")
    def exec_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "execStatus"))

    @exec_status.setter
    def exec_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ccc32c39e9fbe504d4579f0f2b8c8aff7212a5be758a41eca4d15d1ec6dd1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "execStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00c9cdc8907065151a75ce591e540d32cdbba20360ece47bee3feee00785d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35b2af609ecd4ae6151bf58fd03711a1f98165cfc0abf23729488649b1e633c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a26c4ab7967bac88d00ba6d8bcd18fbd15f57940d7918b5d192f2da75a794b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d04141e2ea856e7e888d2a5b5f5b35e8a93c382a486037ef58896c88e2ceac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d914a93c68aa0ef6705649515479cbce06c01005e7ad95f42cfbe3816705b8b5)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fd0d707f17ce2ee1ac63aec5258771f9f89034e03caceed90cbb791bd567846)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84465ce9446aba5aa98cd8384b6944d57c2839799c4cdd9750032cae9185ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5a06d5fa50e683bb61e3b2bf95bebae9944d9d6810df81c20b6bb89b1568f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935838cc9a07c8cf09c549f9d38e174c1f78588c2f0b7de0f843db235c23845c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a39d3628c9190bbe59c54d3651a05fea065730a387fb4ff0fa99087cdf3bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32861f9d4f57506aa36c4fc1f3fa6b8e87734752389cf02d901fbd53a5d810da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6667b646ffd71897c90018a879df928e9514edb1ef43ee9cf9bdf18713d4b07d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a12718dfa47a93bd1f67e32090a30650d31f8a19609033c34718056ddbbf25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b785c1c11afd72337ca6d2a2f0708bf3917141c32900d312b8d68284546281)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``values`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``.

        If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the filename component of the request URL.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilenameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilenameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f7c52fb1d10f791c968e6f64e14f5226fdb300f84c60bcff8260d30a25d1f3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0dd60f89aae7f7947eaf33c1e3f0d1d21395039fc9ddfc913ef84ac261a03a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e15e5f710a17b68fc5bef32a5736c38d55518c79531bfbb34c8bcb73245bcb1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbeb539e1374fc4153758c4794923bf399efa99bb79eac3b3985ec5611eac79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e653603c827d71157b3a0ab35062f0b76f3710676b86c01f600fe1e055ba742)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8517ca9e1ac5d1d5fb5fe61dc6330ac04696c964fbaa526f94595b49e4a97c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3afbfaa404293e5fb189ec4b31c6e9b937d2caedb03dc449ac395229844cafe0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39cb9f42d8700f975d93fa319d5e5245e9f9f41d85873bf5bb6d2d1fbf2f1a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9151f15e68648e917d53bdc31f91710767eab485a84dd3fac6a7bb0ef956e921)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of hostnames.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a32839c3e3d14f30951167f42143ce37d700dfa2f949c8d2244755b014763aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6268af79ce74ef73c441805d1d5162b09a7277a2dcf74d05a3d2d787c45dc369)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086a94462a68b74e9690b186ef0bd7898b5c9363b48e7d535e855559c290fff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5547a9a35b7cc5fc0300fbcfe852b22668c6d803dca5ba2c3fa406e84f5dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a70ff268df1407cf4b76a1dd870836ff6f2f528ac2b1e407104761cb7f9f3384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d203ab65ae870e7fcf9a2943b507e600125bf9ed39cfc76b119d8ce9977f9a77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b263555f5c2c1ff7777b1a8598d4b636396ab9e1bd1ca3798d234741041f9f5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab5dffb35653db6e814b31a869d1bc3fa7bd15e16513bf7d1c07a05d4a5369cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce58eeb648d3613cb7e14a53000ca26a69dde3d473f35647e4739f6495826496)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80540bb4299290de5c1946091efe5c67246152328d4c161ee52bcdf353b90255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f862d1b6c175ae9d57191efbdbe448602e17d689fcb32f3429327ea0e5b13b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__874f064c2bd07c20b3f76a8211169e21762d5a67553a8e63fd4e1a1ce10320d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa8eb81b7434c2f2647f8e1e4200ba7bfdca860ef872d4b75b298d719182c0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "close_xml": "closeXml",
        "description": "description",
        "locked": "locked",
        "open_xml": "openXml",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced:
    def __init__(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152151d6a118248e488906bcfc6076b7cbd0c3107202d6ccc8bd8bc65af0ec26)
            check_type(argname="argument close_xml", value=close_xml, expected_type=type_hints["close_xml"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument open_xml", value=open_xml, expected_type=type_hints["open_xml"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if close_xml is not None:
            self._values["close_xml"] = close_xml
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if open_xml is not None:
            self._values["open_xml"] = open_xml
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def close_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that closes the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        '''
        result = self._values.get("close_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def open_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that opens the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        '''
        result = self._values.get("open_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d383dedcdf03b3ec5720d5b7c58a81233ea5d8b4faa61a5de4e3272390733c96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloseXml")
    def reset_close_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloseXml", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOpenXml")
    def reset_open_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpenXml", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="closeXmlInput")
    def close_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "closeXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="openXmlInput")
    def open_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "openXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="closeXml")
    def close_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "closeXml"))

    @close_xml.setter
    def close_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc786e33608644d88e92d5bda0ed40f4cfb67dc8bc77600964256090f07e148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "closeXml", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbaaa2f8f3451b5ef995f258b6a79f7ec123f9391dd8040455982af45cd431a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9181cb3d03823ba2df9658114555bfca2d3e4dbf1da2e9a41b37b935ecf6d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="openXml")
    def open_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "openXml"))

    @open_xml.setter
    def open_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eefeefefd7552e2d74b75f4edb4e5b2755c13e29c69ca97e55954a31214b63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "openXml", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7498c0713f588872da407caac3c9898a2b129b6f4381430eba5bcf45213f88da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba06fd17f61273ea27e8b86352ada93c4ad24d55746c00a91d143ea0e602bba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c54a8937e22d9f9ef74fb607080ab15c7b64da80d2f422719f2d000dc2faf54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f673ac9bbf169405686a3a7c5af594d56fdd37feb4304f0e1175374a35f8c550)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06a49788ef8a7c7550d528f4ffa9266ade95beb2ed953c2b7540c4b0ba8b1c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9afe5827b4a94a952813a1d84dddf414145f22a974782cd17633895ddfde1cfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19dba5d3fef737184d93d2758e0131ea2df8e7b40e9ee61f0f20b62a39a3ad0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e64b250e96ec43de2a3d42cc832c9dd982a9ed7b78cdae3316d872d3fd0f317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8b64cf75c18141901100027a17f15d22efe3eb32a4b4a7f0c77aa29a1803b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f560e225d6292a3fa678e532a54636cba3014e316176a2a20572f77e5c9dd9)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a196c9a3387210d217c75ef38b9397ea71b1ea178b63501521f8485b53a554b4)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e079bbf59ee52a98ac03e04272cd6556de73f67e868086a970b702e3306a23e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8eecd3d1cd83905ac5644b5af7979cd86f5b9cda22e228ebbffdc00cb16b132a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57f6f676cc4667c9d5844610f359cc404b3c65e872bb43351a76f600eeb9644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e578eee4dfbbda82538bec585878dcfe891e0a3e5b93153ab2e5f326348f797e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aeb45f2d58e9c1e3906f60f6e49b1e8da832bde7b96dd70f2595657b3f57336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750ce5039586d9bcabcf75525c46c231f8507f7f7af1be1e29ed713c58e19784)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c86ec548dc59e18b81596a77adcc4f50bf9f0f076f724ae1ef7d9444b0658d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda86763192c8a546d5e604859a7a7733bba71b9edc38144fe61a87ac85ea9d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45b2bb0e89a38d9590600543360304304e5c66599c793a6c1e7126b22b341664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1280d42201181a0e9a930533964fedbf3be82a64de347e5920dad63b0438bfc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980d96ef245ce6fc1c640db633ec352fb527c74481bfd796fe6819a89ef83f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89ecb5543603a323be18eec7210ae09f599146da6759007a1261d33f83e2262e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952ff19237948f11231d45bf08a694309ba4dc817b505401e5e18615916ec9f5)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches numeric range or a specified set of ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A set of response codes to match, for example ``["404","500"]``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6edc4fefc632ac0d119e78867b71054dc3d43f4a1675ed9001258415a8e8aa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d15fc36135087ca6a9b7c4b032012e6b7755ccabce7c26f84081f52daea23f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a7d79a55fb9d30ad67104ec0a105c33c0b32d9422dbe4857bcdb131893d3fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d0c6b668e51155f02ba1ce112ef34674e1ecbb4e6e36bb144d27173773fd6d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974764432e7f36e3fdf607da6bc98a772739bd645ade06a33a7b5ad8ad512220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26dd3939ed09756004fa8c4457488ef131479aaabfbd9bbb081ef4380d634b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766a7afd40ad5dec357b871698e5f3cb37eebc7e65dd698f8274a3bf66e32ba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a46edac9c1aa6afac1972dd99d03199031d5e99730cd823e2777bfa559717447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e0e0892a8d6e11272a3bace8d9475bb82341640d89c4513092f516658844bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "variable_expression": "variableExpression",
        "variable_name": "variableName",
        "variable_values": "variableValues",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824752e4142c70ea9063278f1b298a68bf689bbab47691909ae36d8c0c651438)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_expression", value=variable_expression, expected_type=type_hints["variable_expression"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_values", value=variable_values, expected_type=type_hints["variable_values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_expression is not None:
            self._values["variable_expression"] = variable_expression
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_values is not None:
            self._values["variable_values"] = variable_values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this performs a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''The type of match, based on which you use different options to specify the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_expression(self) -> typing.Optional[builtins.str]:
        '''Specifies a single matching string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        '''
        result = self._values.get("variable_expression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''The name of the variable to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies an array of matching strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        result = self._values.get("variable_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bef63fcf00c19a84cc903ad73c00a69f2a3cee85248d6b041b170363dbadbe8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableExpression")
    def reset_variable_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableExpression", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValues")
    def reset_variable_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableExpressionInput")
    def variable_expression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValuesInput")
    def variable_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b11da6ecf2c758e7565372abcad0d9e891bd8e2c36d0da4cd0ae2056fea24288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0833adaf638f919e77bf3b94424610431edd536f20853e3970ecacb4e30444af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02064985cdbf5c5fe36277dc57d7d2e7ece4677f3c3cd472ff08c9228bc300a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d885c8faa929271c87467ac1e1e05d4364037d6b2ed8ddc84d8a5426ccfb584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55efb172457b2a103df27ade2feed50c46c4d8f1f018cf71e8e012d5ca7867fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e5da96ad4ed32868e2d5d679aa3423d09c9937e7d182fec2c2f066673107970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa45a93056f3d27ba6fb9bbb048eb7a0fd102e0c4e61bd0f63d75acbc3eb8ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40512deec401ac64bd2209e78e48a9591429d549ada93a3c28a673252424d3de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableExpression")
    def variable_expression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableExpression"))

    @variable_expression.setter
    def variable_expression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca16b14497bd17cd6779154812adb74c6b642d1a4a591064e877a0e37f976b53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableExpression", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba24c07b7d56063bad525aaf0d6ba6ac090b03a4d249c9345ff25d7c933771e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValues")
    def variable_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableValues"))

    @variable_values.setter
    def variable_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff034deaaecd9e84fb7205c3a9ed1dca9857d22b1613f181eed21e7076157901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValues", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b757bebaf007e2fb7f28b151181704cb1f1969940cd7998d59fad92c939ec0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3539affb47a5deb0390c845db1ced29f9f03dbd220045dc692ec3a2c0ed79754)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Compares the current rule with the specified metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4316b3b6dde08060e509cba7748405389ebfabf1a622adeab279b3d53ace2fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f040d9c9e07197e36ddd645919011ea7a7b11f9c3959e835ab776b6f609535e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b5feba08f9cc9dc5859964d27cac632fbef0691ac1a3d3b90602242a623497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d5b5defb52316d8efeaa238f5be5064c091dd424143d40953f5cee7da95649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398672bada67d129cc38f4410cb85b25a06f9e50d40f85738a456974425db874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76bf809efd05f31be9b6cb77607bb0fc636d97ff73575a4eecd8f7107bb314ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fa0fbfe2f4c6597d3fbf5fe0384838a302c2a68d65ce53df602d2a2a399f523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f3258db8b1479dfbc4ff6b6003f48a6c54971b33020917ce8a34ffe09c5535)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies a single required ``ORIGIN_TIMED_OUT`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d582ae9cae467bcca1c2bbe20c96f0c6ebb5d4ecda84131676660800319c71f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0107aa087c4fe0edd0aed5107e3eba66bf5f8c52d89e73e537d85caceaa05a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a978f59fc44390a5457103e9a6e47bcdf39bdc3beb807d0f7639507846f29a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f08b4156fbf577e4e2193ce1bf287cf010723863c5bbb364530a55aa6ead3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09e02dd0f6ac38f847f5f01ebb49bee230d18e96830083874e467def1fb329f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f56c60a80a559df6e5844a9b802ed83604037b477e51cf2c2459d7fadbd76c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b82e131d351e1381181ea928a3f0e3159713273441cd6f864f6547f495c983f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdvancedImMatch")
    def put_advanced_im_match(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvancedImMatch", [value]))

    @jsii.member(jsii_name="putBucket")
    def put_bucket(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket(
            locked=locked,
            percentage=percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBucket", [value]))

    @jsii.member(jsii_name="putCacheability")
    def put_cacheability(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheability", [value_]))

    @jsii.member(jsii_name="putChinaCdnRegion")
    def put_china_cdn_region(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChinaCdnRegion", [value]))

    @jsii.member(jsii_name="putClientCertificate")
    def put_client_certificate(
        self,
        *,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate(
            is_certificate_present=is_certificate_present,
            is_certificate_valid=is_certificate_valid,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificate", [value]))

    @jsii.member(jsii_name="putClientIp")
    def put_client_ip(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            use_headers=use_headers,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIp", [value]))

    @jsii.member(jsii_name="putClientIpVersion")
    def put_client_ip_version(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion(
            locked=locked,
            template_uuid=template_uuid,
            use_x_forwarded_for=use_x_forwarded_for,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIpVersion", [value_]))

    @jsii.member(jsii_name="putCloudletsOrigin")
    def put_cloudlets_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletsOrigin", [value]))

    @jsii.member(jsii_name="putContentDeliveryNetwork")
    def put_content_delivery_network(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork(
            locked=locked,
            match_operator=match_operator,
            network=network,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentDeliveryNetwork", [value]))

    @jsii.member(jsii_name="putContentType")
    def put_content_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putContentType", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristic")
    def put_device_characteristic(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic(
            boolean_value=boolean_value,
            characteristic=characteristic,
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_wildcard=match_wildcard,
            numeric_match_operator=numeric_match_operator,
            numeric_value=numeric_value,
            string_match_operator=string_match_operator,
            string_value=string_value,
            template_uuid=template_uuid,
            uuid=uuid,
            version_match_operator=version_match_operator,
            version_value=version_value,
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristic", [value]))

    @jsii.member(jsii_name="putEcmdAuthGroups")
    def put_ecmd_auth_groups(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthGroups", [value_]))

    @jsii.member(jsii_name="putEcmdAuthScheme")
    def put_ecmd_auth_scheme(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme(
            auth_scheme=auth_scheme,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthScheme", [value]))

    @jsii.member(jsii_name="putEcmdIsAuthenticated")
    def put_ecmd_is_authenticated(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdIsAuthenticated", [value]))

    @jsii.member(jsii_name="putEcmdUsername")
    def put_ecmd_username(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername(
            length=length,
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdUsername", [value_]))

    @jsii.member(jsii_name="putEdgeWorkersFailure")
    def put_edge_workers_failure(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure(
            exec_status=exec_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorkersFailure", [value]))

    @jsii.member(jsii_name="putFileExtension")
    def put_file_extension(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFileExtension", [value]))

    @jsii.member(jsii_name="putFilename")
    def put_filename(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFilename", [value]))

    @jsii.member(jsii_name="putHostname")
    def put_hostname(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putHostname", [value]))

    @jsii.member(jsii_name="putMatchAdvanced")
    def put_match_advanced(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced(
            close_xml=close_xml,
            description=description,
            locked=locked,
            open_xml=open_xml,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchAdvanced", [value]))

    @jsii.member(jsii_name="putMatchCpCode")
    def put_match_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putMatchCpCode", [value_]))

    @jsii.member(jsii_name="putMatchResponseCode")
    def put_match_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode(
            locked=locked,
            lower_bound=lower_bound,
            match_operator=match_operator,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchResponseCode", [value]))

    @jsii.member(jsii_name="putMatchVariable")
    def put_match_variable(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable(
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            variable_expression=variable_expression,
            variable_name=variable_name,
            variable_values=variable_values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchVariable", [value]))

    @jsii.member(jsii_name="putMetadataStage")
    def put_metadata_stage(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataStage", [value_]))

    @jsii.member(jsii_name="putOriginTimeout")
    def put_origin_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginTimeout", [value]))

    @jsii.member(jsii_name="putPath")
    def put_path(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            normalize=normalize,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putPath", [value]))

    @jsii.member(jsii_name="putQueryStringParameter")
    def put_query_string_parameter(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter(
            escape_value=escape_value,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            parameter_name=parameter_name,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putQueryStringParameter", [value]))

    @jsii.member(jsii_name="putRandom")
    def put_random(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom(
            bucket=bucket, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRandom", [value]))

    @jsii.member(jsii_name="putRecoveryConfig")
    def put_recovery_config(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig(
            config_name=config_name,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRecoveryConfig", [value]))

    @jsii.member(jsii_name="putRegularExpression")
    def put_regular_expression(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression(
            case_sensitive=case_sensitive,
            locked=locked,
            match_string=match_string,
            regex=regex,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRegularExpression", [value]))

    @jsii.member(jsii_name="putRequestCookie")
    def put_request_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie(
            cookie_name=cookie_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestCookie", [value_]))

    @jsii.member(jsii_name="putRequestHeader")
    def put_request_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader(
            header_name=header_name,
            locked=locked,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestHeader", [value]))

    @jsii.member(jsii_name="putRequestMethod")
    def put_request_method(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestMethod", [value_]))

    @jsii.member(jsii_name="putRequestProtocol")
    def put_request_protocol(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putRequestProtocol", [value_]))

    @jsii.member(jsii_name="putRequestType")
    def put_request_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestType", [value_]))

    @jsii.member(jsii_name="putResponseHeader")
    def put_response_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader(
            header_name=header_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseHeader", [value]))

    @jsii.member(jsii_name="putServerLocation")
    def put_server_location(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation(
            continents=continents,
            countries=countries,
            location_type=location_type,
            locked=locked,
            match_operator=match_operator,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putServerLocation", [value]))

    @jsii.member(jsii_name="putTime")
    def put_time(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime(
            apply_daylight_savings_time=apply_daylight_savings_time,
            begin_date=begin_date,
            end_date=end_date,
            lasting_date=lasting_date,
            lasting_duration=lasting_duration,
            locked=locked,
            match_operator=match_operator,
            repeat_begin_date=repeat_begin_date,
            repeat_duration=repeat_duration,
            repeat_interval=repeat_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTime", [value]))

    @jsii.member(jsii_name="putTokenAuthorization")
    def put_token_authorization(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization(
            locked=locked,
            match_operator=match_operator,
            status_list=status_list,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTokenAuthorization", [value]))

    @jsii.member(jsii_name="putUserAgent")
    def put_user_agent(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putUserAgent", [value]))

    @jsii.member(jsii_name="putUserLocation")
    def put_user_location(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation(
            check_ips=check_ips,
            continent_values=continent_values,
            country_values=country_values,
            field=field,
            locked=locked,
            match_operator=match_operator,
            region_values=region_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserLocation", [value]))

    @jsii.member(jsii_name="putUserNetwork")
    def put_user_network(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork(
            bandwidth_values=bandwidth_values,
            check_ips=check_ips,
            field=field,
            locked=locked,
            match_operator=match_operator,
            network_type_values=network_type_values,
            network_values=network_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserNetwork", [value]))

    @jsii.member(jsii_name="putVariableError")
    def put_variable_error(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError(
            locked=locked,
            result=result,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_names=variable_names,
        )

        return typing.cast(None, jsii.invoke(self, "putVariableError", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomRequest")
    def put_virtual_waiting_room_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomRequest", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationRequest")
    def put_visitor_prioritization_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationRequest", [value]))

    @jsii.member(jsii_name="resetAdvancedImMatch")
    def reset_advanced_im_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedImMatch", []))

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetCacheability")
    def reset_cacheability(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheability", []))

    @jsii.member(jsii_name="resetChinaCdnRegion")
    def reset_china_cdn_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnRegion", []))

    @jsii.member(jsii_name="resetClientCertificate")
    def reset_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificate", []))

    @jsii.member(jsii_name="resetClientIp")
    def reset_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIp", []))

    @jsii.member(jsii_name="resetClientIpVersion")
    def reset_client_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIpVersion", []))

    @jsii.member(jsii_name="resetCloudletsOrigin")
    def reset_cloudlets_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletsOrigin", []))

    @jsii.member(jsii_name="resetContentDeliveryNetwork")
    def reset_content_delivery_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentDeliveryNetwork", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDeviceCharacteristic")
    def reset_device_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristic", []))

    @jsii.member(jsii_name="resetEcmdAuthGroups")
    def reset_ecmd_auth_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthGroups", []))

    @jsii.member(jsii_name="resetEcmdAuthScheme")
    def reset_ecmd_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthScheme", []))

    @jsii.member(jsii_name="resetEcmdIsAuthenticated")
    def reset_ecmd_is_authenticated(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdIsAuthenticated", []))

    @jsii.member(jsii_name="resetEcmdUsername")
    def reset_ecmd_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdUsername", []))

    @jsii.member(jsii_name="resetEdgeWorkersFailure")
    def reset_edge_workers_failure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkersFailure", []))

    @jsii.member(jsii_name="resetFileExtension")
    def reset_file_extension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileExtension", []))

    @jsii.member(jsii_name="resetFilename")
    def reset_filename(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFilename", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetMatchAdvanced")
    def reset_match_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchAdvanced", []))

    @jsii.member(jsii_name="resetMatchCpCode")
    def reset_match_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCpCode", []))

    @jsii.member(jsii_name="resetMatchResponseCode")
    def reset_match_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchResponseCode", []))

    @jsii.member(jsii_name="resetMatchVariable")
    def reset_match_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchVariable", []))

    @jsii.member(jsii_name="resetMetadataStage")
    def reset_metadata_stage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataStage", []))

    @jsii.member(jsii_name="resetOriginTimeout")
    def reset_origin_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginTimeout", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetQueryStringParameter")
    def reset_query_string_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryStringParameter", []))

    @jsii.member(jsii_name="resetRandom")
    def reset_random(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandom", []))

    @jsii.member(jsii_name="resetRecoveryConfig")
    def reset_recovery_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryConfig", []))

    @jsii.member(jsii_name="resetRegularExpression")
    def reset_regular_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegularExpression", []))

    @jsii.member(jsii_name="resetRequestCookie")
    def reset_request_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestCookie", []))

    @jsii.member(jsii_name="resetRequestHeader")
    def reset_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestHeader", []))

    @jsii.member(jsii_name="resetRequestMethod")
    def reset_request_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestMethod", []))

    @jsii.member(jsii_name="resetRequestProtocol")
    def reset_request_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestProtocol", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetResponseHeader")
    def reset_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeader", []))

    @jsii.member(jsii_name="resetServerLocation")
    def reset_server_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerLocation", []))

    @jsii.member(jsii_name="resetTime")
    def reset_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTime", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUserAgent")
    def reset_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserAgent", []))

    @jsii.member(jsii_name="resetUserLocation")
    def reset_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserLocation", []))

    @jsii.member(jsii_name="resetUserNetwork")
    def reset_user_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserNetwork", []))

    @jsii.member(jsii_name="resetVariableError")
    def reset_variable_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableError", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomRequest")
    def reset_virtual_waiting_room_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomRequest", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationRequest")
    def reset_visitor_prioritization_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationRequest", []))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatch")
    def advanced_im_match(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatchOutputReference, jsii.get(self, "advancedImMatch"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucketOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucketOutputReference, jsii.get(self, "bucket"))

    @builtins.property
    @jsii.member(jsii_name="cacheability")
    def cacheability(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheabilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheabilityOutputReference, jsii.get(self, "cacheability"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegion")
    def china_cdn_region(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegionOutputReference, jsii.get(self, "chinaCdnRegion"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificate")
    def client_certificate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificateOutputReference, jsii.get(self, "clientCertificate"))

    @builtins.property
    @jsii.member(jsii_name="clientIp")
    def client_ip(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpOutputReference, jsii.get(self, "clientIp"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersion")
    def client_ip_version(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersionOutputReference, jsii.get(self, "clientIpVersion"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOrigin")
    def cloudlets_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOriginOutputReference, jsii.get(self, "cloudletsOrigin"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetwork")
    def content_delivery_network(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetworkOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetworkOutputReference, jsii.get(self, "contentDeliveryNetwork"))

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentTypeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentTypeOutputReference, jsii.get(self, "contentType"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristic")
    def device_characteristic(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristicOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristicOutputReference, jsii.get(self, "deviceCharacteristic"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroups")
    def ecmd_auth_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroupsOutputReference, jsii.get(self, "ecmdAuthGroups"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthScheme")
    def ecmd_auth_scheme(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthSchemeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthSchemeOutputReference, jsii.get(self, "ecmdAuthScheme"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticated")
    def ecmd_is_authenticated(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticatedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticatedOutputReference, jsii.get(self, "ecmdIsAuthenticated"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsername")
    def ecmd_username(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsernameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsernameOutputReference, jsii.get(self, "ecmdUsername"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailure")
    def edge_workers_failure(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailureOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailureOutputReference, jsii.get(self, "edgeWorkersFailure"))

    @builtins.property
    @jsii.member(jsii_name="fileExtension")
    def file_extension(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtensionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtensionOutputReference, jsii.get(self, "fileExtension"))

    @builtins.property
    @jsii.member(jsii_name="filename")
    def filename(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilenameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilenameOutputReference, jsii.get(self, "filename"))

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostnameOutputReference, jsii.get(self, "hostname"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvanced")
    def match_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvancedOutputReference, jsii.get(self, "matchAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCode")
    def match_cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeOutputReference, jsii.get(self, "matchCpCode"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCode")
    def match_response_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCodeOutputReference, jsii.get(self, "matchResponseCode"))

    @builtins.property
    @jsii.member(jsii_name="matchVariable")
    def match_variable(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariableOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariableOutputReference, jsii.get(self, "matchVariable"))

    @builtins.property
    @jsii.member(jsii_name="metadataStage")
    def metadata_stage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStageOutputReference, jsii.get(self, "metadataStage"))

    @builtins.property
    @jsii.member(jsii_name="originTimeout")
    def origin_timeout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeoutOutputReference, jsii.get(self, "originTimeout"))

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPathOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPathOutputReference", jsii.get(self, "path"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameter")
    def query_string_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameterOutputReference", jsii.get(self, "queryStringParameter"))

    @builtins.property
    @jsii.member(jsii_name="random")
    def random(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandomOutputReference", jsii.get(self, "random"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfig")
    def recovery_config(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfigOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfigOutputReference", jsii.get(self, "recoveryConfig"))

    @builtins.property
    @jsii.member(jsii_name="regularExpression")
    def regular_expression(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpressionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpressionOutputReference", jsii.get(self, "regularExpression"))

    @builtins.property
    @jsii.member(jsii_name="requestCookie")
    def request_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookieOutputReference", jsii.get(self, "requestCookie"))

    @builtins.property
    @jsii.member(jsii_name="requestHeader")
    def request_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeaderOutputReference", jsii.get(self, "requestHeader"))

    @builtins.property
    @jsii.member(jsii_name="requestMethod")
    def request_method(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethodOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethodOutputReference", jsii.get(self, "requestMethod"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocol")
    def request_protocol(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocolOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocolOutputReference", jsii.get(self, "requestProtocol"))

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestTypeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestTypeOutputReference", jsii.get(self, "requestType"))

    @builtins.property
    @jsii.member(jsii_name="responseHeader")
    def response_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeaderOutputReference", jsii.get(self, "responseHeader"))

    @builtins.property
    @jsii.member(jsii_name="serverLocation")
    def server_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocationOutputReference", jsii.get(self, "serverLocation"))

    @builtins.property
    @jsii.member(jsii_name="time")
    def time(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTimeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTimeOutputReference", jsii.get(self, "time"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorizationOutputReference", jsii.get(self, "tokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="userAgent")
    def user_agent(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgentOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgentOutputReference", jsii.get(self, "userAgent"))

    @builtins.property
    @jsii.member(jsii_name="userLocation")
    def user_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocationOutputReference", jsii.get(self, "userLocation"))

    @builtins.property
    @jsii.member(jsii_name="userNetwork")
    def user_network(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetworkOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetworkOutputReference", jsii.get(self, "userNetwork"))

    @builtins.property
    @jsii.member(jsii_name="variableError")
    def variable_error(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableErrorOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableErrorOutputReference", jsii.get(self, "variableError"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequest")
    def virtual_waiting_room_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequestOutputReference", jsii.get(self, "virtualWaitingRoomRequest"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequest")
    def visitor_prioritization_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequestOutputReference", jsii.get(self, "visitorPrioritizationRequest"))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatchInput")
    def advanced_im_match_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch], jsii.get(self, "advancedImMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilityInput")
    def cacheability_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability], jsii.get(self, "cacheabilityInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegionInput")
    def china_cdn_region_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion], jsii.get(self, "chinaCdnRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateInput")
    def client_certificate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate], jsii.get(self, "clientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpInput")
    def client_ip_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp], jsii.get(self, "clientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersionInput")
    def client_ip_version_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion], jsii.get(self, "clientIpVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOriginInput")
    def cloudlets_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin], jsii.get(self, "cloudletsOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetworkInput")
    def content_delivery_network_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork], jsii.get(self, "contentDeliveryNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicInput")
    def device_characteristic_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic], jsii.get(self, "deviceCharacteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroupsInput")
    def ecmd_auth_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups], jsii.get(self, "ecmdAuthGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthSchemeInput")
    def ecmd_auth_scheme_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme], jsii.get(self, "ecmdAuthSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticatedInput")
    def ecmd_is_authenticated_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated], jsii.get(self, "ecmdIsAuthenticatedInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsernameInput")
    def ecmd_username_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername], jsii.get(self, "ecmdUsernameInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailureInput")
    def edge_workers_failure_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure], jsii.get(self, "edgeWorkersFailureInput"))

    @builtins.property
    @jsii.member(jsii_name="fileExtensionInput")
    def file_extension_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension], jsii.get(self, "fileExtensionInput"))

    @builtins.property
    @jsii.member(jsii_name="filenameInput")
    def filename_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename], jsii.get(self, "filenameInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvancedInput")
    def match_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced], jsii.get(self, "matchAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCodeInput")
    def match_cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode], jsii.get(self, "matchCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCodeInput")
    def match_response_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode], jsii.get(self, "matchResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchVariableInput")
    def match_variable_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable], jsii.get(self, "matchVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataStageInput")
    def metadata_stage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage], jsii.get(self, "metadataStageInput"))

    @builtins.property
    @jsii.member(jsii_name="originTimeoutInput")
    def origin_timeout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout], jsii.get(self, "originTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath"], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameterInput")
    def query_string_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter"], jsii.get(self, "queryStringParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="randomInput")
    def random_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom"], jsii.get(self, "randomInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfigInput")
    def recovery_config_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig"], jsii.get(self, "recoveryConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="regularExpressionInput")
    def regular_expression_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression"], jsii.get(self, "regularExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="requestCookieInput")
    def request_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie"], jsii.get(self, "requestCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="requestHeaderInput")
    def request_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader"], jsii.get(self, "requestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="requestMethodInput")
    def request_method_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod"], jsii.get(self, "requestMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocolInput")
    def request_protocol_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol"], jsii.get(self, "requestProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType"], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderInput")
    def response_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader"], jsii.get(self, "responseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="serverLocationInput")
    def server_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation"], jsii.get(self, "serverLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="timeInput")
    def time_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime"], jsii.get(self, "timeInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization"], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="userAgentInput")
    def user_agent_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent"], jsii.get(self, "userAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="userLocationInput")
    def user_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation"], jsii.get(self, "userLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="userNetworkInput")
    def user_network_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork"], jsii.get(self, "userNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="variableErrorInput")
    def variable_error_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError"], jsii.get(self, "variableErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequestInput")
    def virtual_waiting_room_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest"], jsii.get(self, "virtualWaitingRoomRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequestInput")
    def visitor_prioritization_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest"], jsii.get(self, "visitorPrioritizationRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a75753240edca6bc8afce349d9e1466453d05fc00800c032cdcd516b6210456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "normalize": "normalize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3aa85671702471e82d16884eb9718abe239adaecb12ce51d9116a6acccc03e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument normalize", value=normalize, expected_type=type_hints["normalize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if normalize is not None:
            self._values["normalize"] = normalize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of the ``values`` array.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def normalize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Transforms URLs before comparing them with the provided value.

        URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        '''
        result = self._values.get("normalize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the URL path, excluding leading hostname and trailing query parameters.

        The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}

        Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPathOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPathOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bda4b947c7558a089aea3bae1002caa2fd1849fb4c2d500666094995656a2d00)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNormalize")
    def reset_normalize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNormalize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="normalizeInput")
    def normalize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "normalizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154ce68cdede308711b7a74c0d161b2f681129854a3502eaae67d163c920375b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed6692978b88994769d1f0c4330ee7415f2b1bd5240356c5a2958dafb41b286)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895d3218488a6f7caf00e2d8b7ed8330978bec3ba756687a792f8891540a5346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="normalize")
    def normalize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "normalize"))

    @normalize.setter
    def normalize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7752f7b2f297f7dfeb8362cfeaf54d30949d2bee1aa608e206b7053eb9f615eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "normalize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db76dac0540b78646e65d2f896a10732916f2dd9584478d7f051fc0b7432f492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__515c87b152c667e732fb44fe5561b24a7c36390d47fe191fbfd2b21b4bd9eb3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72eca56536c69bef446065361205e6108332a6960bff143e87837f082c9bc8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a6a1e4f5ff825601568953b22538f07d45ff5e748ef7ed83e2a6038c3433bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter",
    jsii_struct_bases=[],
    name_mapping={
        "escape_value": "escapeValue",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "parameter_name": "parameterName",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter:
    def __init__(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b605a38c254e1aab2a017a75ec57c10f6224c7b7a2b469fe9d09a01182c0395)
            check_type(argname="argument escape_value", value=escape_value, expected_type=type_hints["escape_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument parameter_name", value=parameter_name, expected_type=type_hints["parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if escape_value is not None:
            self._values["escape_value"] = escape_value
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if parameter_name is not None:
            self._values["parameter_name"] = parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def escape_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches when the ``value`` is URL-escaped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        '''
        result = self._values.get("escape_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``parameterName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the query field, for example, ``q`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        '''
        result = self._values.get("parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The value of the query field, for example, ``string`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4dfc69bda699879bd8453b02d773f0b61b4555114d61e8cc774faa1925c1a22)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEscapeValue")
    def reset_escape_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetParameterName")
    def reset_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="escapeValueInput")
    def escape_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="parameterNameInput")
    def parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "parameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeValue")
    def escape_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeValue"))

    @escape_value.setter
    def escape_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141e98912c69ae38557ba48d0b418f67cd9508677c431b5b99154bae0ec4e3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7844060b5988c6eba23ad28815cfe01228ce2891bcda1046827222ac7023a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5055ccb1db7ff8cbcd7fe79d948d87c60bc3bd4b760d43b539a04ee550736b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3e752fe6039ad75f4c948eb89116a0185ec4e404f401dc7aef0a33b56c82e73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8983315eb12dc1c9ee269e0de1865f20179e041ebb76262de516fcc4d31c57e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f679bcfc20b714613ac6bcffdaf61cff729128b66dc0f62a2177ba34913b6cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f0237e8ada9ada8ab86c99cc343ee9b872f5df2b65e9515025fc28921e1846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b679c6da8de96cd34a61da38a1a92c61eb5cb22a46721449d2544c07d8efe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="parameterName")
    def parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "parameterName"))

    @parameter_name.setter
    def parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82a2a3e77ae7a44127c904f44c1df7ff31029c1e6c2b68e627ebf153f573bde2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725dcae88c44bd46788d63fc20be334ffea33a1072ef72aeb2ea07acdb1258f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e908a349fea80139e7bdd46dcea13bf98372672d1eaecc7978108b5de4a24f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea32499dfebf3f0fc50389ea76192eb99a71d1f6e6451b4918c992d1719ccd11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be371bd17dcb2c9c25ea78cb6bb460873239ecdb602558d2b545dc7bdb78575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d99ced43f175688615be719c881bdf9d0b8895e10ac980f273784963a005d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom",
    jsii_struct_bases=[],
    name_mapping={
        "bucket": "bucket",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom:
    def __init__(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6e82d0572e6e8e2fa1e1b9faa08cd6558385abdedfeb0f90feb4c9a9abe894a)
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bucket is not None:
            self._values["bucket"] = bucket
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bucket(self) -> typing.Optional[jsii.Number]:
        '''Specify a percentage of random requests to which to apply a behavior. Any remainders do not match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de97a91930901f80d6e295b5511462ad9c0f733916049ba692a750aba5ea97ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bucket"))

    @bucket.setter
    def bucket(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f35efaf9ce38747df381d1b16ac6f86a32cefc13a51512699ac427fa6ece334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bucket", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beeb7c574f72e7fa2b1c16e5592ad3a65540d3dd4171fb997d6aa633522f1ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7222cc74c88fea49d0dd6f3bd678680999f5efebf8c9751eb331d841cdfb770d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6ce590b3b725f99d7939338cddb1d6e74bbb7f68a782b3419aea4ac673fe7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446b9a97c1f80c1d19e3e3b838163c607c94dc62336c2ee5579075ef74a0003a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig",
    jsii_struct_bases=[],
    name_mapping={
        "config_name": "configName",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig:
    def __init__(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b8a58b87919cc43e2dd723eed44cf48ddc56c234fc774c032d5b7b8aaaad28)
            check_type(argname="argument config_name", value=config_name, expected_type=type_hints["config_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_name is not None:
            self._values["config_name"] = config_name
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def config_name(self) -> typing.Optional[builtins.str]:
        '''A unique identifier used for origin failure recovery configurations.

        This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        '''
        result = self._values.get("config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e1661f772fcc425968f571926b4f0d5ce720f9e453e0a2f85df8a0ecd6824e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigName")
    def reset_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="configNameInput")
    def config_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="configName")
    def config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configName"))

    @config_name.setter
    def config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1097e0463e0f208e31447a6d066dec409738017ba678ccce4ec38d6e0dd71fe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c6f01a8eef858cf957641264d9a24ab2badcfb996cfa7ccf53362f0c103e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5475bfed65c9a6065361da3b3471783f67ae06f8de86e5103aeded5b04d688cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4509bd811402f0135d10c20ff60c3a450e120fdf8af1d9a11cd31c9e7e4c57a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025c9d82cb5f7a0e74686d02534914ee5f64e7716f891401542a1044c08b75af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression",
    jsii_struct_bases=[],
    name_mapping={
        "case_sensitive": "caseSensitive",
        "locked": "locked",
        "match_string": "matchString",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression:
    def __init__(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4517b1f753656eea7ded3826bdcd792700a6500fbb8660937cd0b14fb724f53)
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_string", value=match_string, expected_type=type_hints["match_string"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if locked is not None:
            self._values["locked"] = locked
        if match_string is not None:
            self._values["match_string"] = match_string
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive regular expression match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_string(self) -> typing.Optional[builtins.str]:
        '''The string to match, typically the contents of a dynamic variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        '''
        result = self._values.get("match_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''The regular expression (PCRE) to match against the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c92cce8340c9cdc164000a4dc4b3c8a607e8d96716b45cc406e821071c8fa62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchString")
    def reset_match_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchString", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchStringInput")
    def match_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchStringInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecfc6954dccb720a8f7c05ed444610540b8a5ad5f03f68d40d9d58c3b458ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1faed3d888774b22bdde5bc46d3099c5f48eaa499b2d608960602f740083726e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchString")
    def match_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchString"))

    @match_string.setter
    def match_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__601d8c3e71d5ae058e4a79a1e3150b7f6d1c27d5ce759b3a21f237f93dc620d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchString", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__929b779f701ae3d3c79875b3741e5e967c1d9710354bfbc75a0cc262fcc643a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ecf636320f0817f481aecea03cf0b3f87384fc91a32e843c9b5b330f02cd661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa6eaa4d828d7123721f833ae21a354762b17fe0c312eb2c6bf4f989b5c0023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1a4325dff6f4df35891d00f72e4009d91870bca9390c52aa3ced3df0c34a0fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3990d412f5d0bc00d77a80b6fb5e614ad8e232f19b60fc9d44277d56bec86f)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''The name of the cookie, for example, ``visitor`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``cookieName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The cookie's value, for example, ``anon`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3358f80d40746cc649d261727731d8b46e05f54660261233b4ca0cf9ab8ceabe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72ae46a8bca1b96d439de075e0d2f909f46522c93ad68be3ab11bb359f359ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcc7b953af126482103def696ec12a4c982aa70fc57e4062005dd6ccefed166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e10ca598046381b787efe7ddf7b1404a6db86ab54075c38669797bc04def12bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4081590c596e71c09334a9e2b8dda31c286b7fd2b2447d15ffad41be69dc3e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30936626db623ba96e4a3e3c2b1ac124a948bb58365b1863afa0fb76df653c54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1587615811d7bc835d627706cf64228b947d361db79ba6d805d525aef5488f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e5a0e1389b7712195561d93a721f2335a0c95d67b0b1489efa071b96f42d90f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb18478c62bccffd1587d25855e5de70d06c2300b0272c3cdccabfd98ef91fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c277c4b434734e399041798bd24ee7c88c14b6f58b1dee07cbbd7a15791ebe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8735d209be98231accce05c86213e14b014404cd8290f77a88382602a960fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e195335660f3359c1df6d1279e91793f11f4da8ef83dee1f1b61a96863b7335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d098e2450169c73e9467fcec296b1720188367a52409697258704b19fca7b44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f834bb711eb9002779b6b5371cf5c15b4f8f76051b20a4f9f3eb3e1eeadc9d38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5def55d35a1c370aa9c26ba6dda552c378cb55227cef4d970c6f271c5150bc17)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the request header, for example ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb38696ed4f6516e8021d91670c08d12d9592aed80308517abd21d6b28b46d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3eb617f07ed4cc8a7afc470208a7b97fd3ce096630a8d7a2ca70bae5132f695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c875e3cdc76dbffd332b52c436169a1faa9add4b16e131e80add8e352de4f5ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26d7b2e84167e6220a3d34ecec54aa99a78df1fc60a0d0813a3f5df92b537cd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32c9375c66ea67f71b8eee87f2ab59cc9ee8b91e41ff120d0750a2b4459204b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766bfbe41be26670cffa70cf701a8a26b122cd66daeacfa3c02cb0dac8ea1237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9c2eaf901f4dd18b84b9c1d8ff6e94af6e795aecb52d8988572ccea4c0eea24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1b85a92bdd61ff48cd90f7f57569aa6d87ec2c64d933dcc935bc3ccc1575c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__347c5221cf5a6ad75b79bf8c07122d81e5c3ce9afda700f999f1469ffb5b8194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c011ea105a5fed6afef30341de3c55ef224ec7499b7d37b80b944c6652e283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d256ebab3ec4cf41284be4e0df5124e80fcddc81a8354c21b0babf2a6c820777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3e2115a2805ce6ba1acfd29111b349bc0b6077bbdcbd50247513000c4b645c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Any of these HTTP methods,  WebDAV methods, or Akamai operations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8544da3479d019e21a52aef9df885c71d305ac9c911eb2aa7848a368f982022)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45e9a2c21d25dca3fbbc9e7303113fdffe0253077ba40f395df58672063c64df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4656fbba43010ae3138845a14715171cfb33b8d839127c9b72792285666cf34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b0f1bf5bf20cd25f30212802e648626f8b55c30ffcd5a65ecdeb50b7f84912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0aa78b70fdd0af884ffefc5f3aa9cb8160d9df7343fce99e641a08e59394d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117b337a66d95756dc7b70c6ad1e94272fe6e0b1cdfd70f4c9935ef33dd4e49f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384136456b976f6d9348d62b9e078dad92b89ee1f2b1f5e56aa21e642dc58e77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6eaca51217a4ad102a76f53e4ab5d82b4822895fc2ee8951e54e723fc17cfb6)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02b8531e33616047fbf98af03d4550b9078ca59db9ee8a127336e552ea90a72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfe4bb256e194b5a46bb912a11a9ffa9a6e6671c70db95351150677370ee262)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c698b22b071f6500398d0eafdec6fa0e67f86687ca908400a6ce2bc885eb500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f180aa830c23a6dec801bf05c7e68e12e21c41dab3f5b31697ac525b62154f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b60358b9a5d42a7b7b72f7c6fc69880f90ed696e7a5eb6fb73db13d1f9acef2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d0d95815b91fed05adbe203f4d68ecc45a9b6cd2695f2ebaeac1eba8fd4fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b071224bf6bd0464507c09f49578071a54956b7f67f1b1cc7dc24e98237327)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b064fac32cc989e26e8bd166496fed5fbb896fafe779d6b85e1465719f91c8cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ab73419ad14256445794f2dee32f8063086d72015a604f4afd998e3b702ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1710b9e68e0a8a0ddb6c168d515bc66b34c9f84e9b7c38c3e104a512fa4d32cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6394e2301789d625d497788a7b549814a687f36aa756d91f045393e779fb7545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea91e8c5b2147c133048018202c8d0d8122f137ec97b4e5a1e4ae3d386d8861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f61c17bf0758898ed5a23c6bc2e8b1371f1412359c6e8c4468d30cfa6c6f0b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b609aff3e6d6f3095cb4e658bb857d7c46b7c6c1709f20c9c849c617f009f2a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52cdcc37520355c11e2e8a3f665d97eb1b572c4a96bb8b7a1ae6be92e8579816)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the response header, for example ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the match is case-sensitive for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match according to various criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf9e4c8b2a200b216ae2dd5687dd7366263e9cc8c0fdc0d743b8c835c897e0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9cc7631aafd8196000a78ae509eef8aa0b407e6b259b14575fa3409fe2f1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d34a691011dbab7b7f0baf05f76a82804f022f139bb8acfb6a97ae1f349c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3d56acb11e9fe45413d746b70229544adf438d2425d29c8c0b75d073e9e156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582cd87691647076113252a13f5cd1737c2ad3175e6fb3e025d9b70cb919196a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__351c27e682040576c03e4e59870eeea1b173ff82b7bfd87bde52ca12722de11b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1686de7563cbfab8c40c7ff1845c06f963e6cede690ae9fd434933b9d2038fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b96ce56b81d281a1b33c9eed7b66c69a4e35f639f1114977d6a1f493ca62757e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50500cc28f824f073627833f167bc49be262085a45cf9e67a4572fa40aeafe8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61edee3c7b4b10b46f1db0c8c7ef394662d8d782c4a2eab92527658993fafb41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67299ad66656422289710c1b5a650af881b10fc546a80e892a875d712add07a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53658eb993c503105cf5cc5522ff9fb5a5514ac1eca5f5384fd2de6f26f84e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca448f5b7c9283e3763d9bed7565bcd322950723fb68d27b66ab302cd750492d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation",
    jsii_struct_bases=[],
    name_mapping={
        "continents": "continents",
        "countries": "countries",
        "location_type": "locationType",
        "locked": "locked",
        "match_operator": "matchOperator",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation:
    def __init__(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c439befc9e9c8cef649ea52ca5bbc5ed4f704a815c1f08deb484fd61c873f18)
            check_type(argname="argument continents", value=continents, expected_type=type_hints["continents"])
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument location_type", value=location_type, expected_type=type_hints["location_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if continents is not None:
            self._values["continents"] = continents
        if countries is not None:
            self._values["countries"] = countries
        if location_type is not None:
            self._values["location_type"] = location_type
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def continents(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        '''
        result = self._values.get("continents")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def location_type(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        '''
        result = self._values.get("location_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a97136c5a37e8bc03b915a1fdd437a29124b741e3eb939d1e289c04ff07510a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetContinents")
    def reset_continents(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinents", []))

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetLocationType")
    def reset_location_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="continentsInput")
    def continents_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentsInput"))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="locationTypeInput")
    def location_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="continents")
    def continents(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continents"))

    @continents.setter
    def continents(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__122880419f558915b35e0238c9f7cee920c5ad90b1f3b0f028ef1d1ded58daff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continents", value)

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d603b13db4d1546fa5bf3ac068b38106380ffe768b9d93a0baa39457c022480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="locationType")
    def location_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationType"))

    @location_type.setter
    def location_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2ecd43d48e71a5c8843a4da59b7c9685b96c58b870615655a60ffe94ed8a68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__288a96490587121ddd1274c9a728bd1af260afc95a19a3a14d946139e95f97a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4816d90d8098cdcbf16acbce5165f31fe2f3adf137c228e36991e53150fde42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47bbd34d8eb3517b98035efd569a5f9de5db7713f0bc37e2773e0bb5606925d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed0678d30e138b2c03dc3178bc3dcef623ce6d15c7d55085ecbddee8ddedefb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abe6d37ce1e43a13c736702625fca2f66ca95a44e9f9d1bf3032382e40a94704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ebd0329301d0fe6d17d5e7f77a15013e144273bbb122e4f4b883c6164aae1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime",
    jsii_struct_bases=[],
    name_mapping={
        "apply_daylight_savings_time": "applyDaylightSavingsTime",
        "begin_date": "beginDate",
        "end_date": "endDate",
        "lasting_date": "lastingDate",
        "lasting_duration": "lastingDuration",
        "locked": "locked",
        "match_operator": "matchOperator",
        "repeat_begin_date": "repeatBeginDate",
        "repeat_duration": "repeatDuration",
        "repeat_interval": "repeatInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime:
    def __init__(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75419c24276e3f2aa2ef16a79bb0dc6aa35fda9a8bf34c9273b8def8be678a4a)
            check_type(argname="argument apply_daylight_savings_time", value=apply_daylight_savings_time, expected_type=type_hints["apply_daylight_savings_time"])
            check_type(argname="argument begin_date", value=begin_date, expected_type=type_hints["begin_date"])
            check_type(argname="argument end_date", value=end_date, expected_type=type_hints["end_date"])
            check_type(argname="argument lasting_date", value=lasting_date, expected_type=type_hints["lasting_date"])
            check_type(argname="argument lasting_duration", value=lasting_duration, expected_type=type_hints["lasting_duration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument repeat_begin_date", value=repeat_begin_date, expected_type=type_hints["repeat_begin_date"])
            check_type(argname="argument repeat_duration", value=repeat_duration, expected_type=type_hints["repeat_duration"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_daylight_savings_time is not None:
            self._values["apply_daylight_savings_time"] = apply_daylight_savings_time
        if begin_date is not None:
            self._values["begin_date"] = begin_date
        if end_date is not None:
            self._values["end_date"] = end_date
        if lasting_date is not None:
            self._values["lasting_date"] = lasting_date
        if lasting_duration is not None:
            self._values["lasting_duration"] = lasting_duration
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if repeat_begin_date is not None:
            self._values["repeat_begin_date"] = repeat_begin_date
        if repeat_duration is not None:
            self._values["repeat_duration"] = repeat_duration
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def apply_daylight_savings_time(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adjusts the start time plus repeat interval to account for daylight saving time.

        Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        '''
        result = self._values.get("apply_daylight_savings_time")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        '''
        result = self._values.get("begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_date(self) -> typing.Optional[builtins.str]:
        '''Sets the end of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        '''
        result = self._values.get("end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        '''
        result = self._values.get("lasting_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the end of a time period as a duration relative to the ``lastingDate``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        '''
        result = self._values.get("lasting_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies how to define the range of time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of the initial time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        '''
        result = self._values.get("repeat_begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of each repeating time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        '''
        result = self._values.get("repeat_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Sets the time between each repeating time period's starting points.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTimeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTimeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78019bce92fa43286e35e850e7197515961b1b56750fdd826090badd9f9ebdac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplyDaylightSavingsTime")
    def reset_apply_daylight_savings_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyDaylightSavingsTime", []))

    @jsii.member(jsii_name="resetBeginDate")
    def reset_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeginDate", []))

    @jsii.member(jsii_name="resetEndDate")
    def reset_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndDate", []))

    @jsii.member(jsii_name="resetLastingDate")
    def reset_lasting_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDate", []))

    @jsii.member(jsii_name="resetLastingDuration")
    def reset_lasting_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDuration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRepeatBeginDate")
    def reset_repeat_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatBeginDate", []))

    @jsii.member(jsii_name="resetRepeatDuration")
    def reset_repeat_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatDuration", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTimeInput")
    def apply_daylight_savings_time_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyDaylightSavingsTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="beginDateInput")
    def begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="endDateInput")
    def end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDateInput")
    def lasting_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDurationInput")
    def lasting_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDateInput")
    def repeat_begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatBeginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatDurationInput")
    def repeat_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTime")
    def apply_daylight_savings_time(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyDaylightSavingsTime"))

    @apply_daylight_savings_time.setter
    def apply_daylight_savings_time(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c98e58afeabfb64aa27870276c3fffb727ff930020b0de0b318f214151dd475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyDaylightSavingsTime", value)

    @builtins.property
    @jsii.member(jsii_name="beginDate")
    def begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beginDate"))

    @begin_date.setter
    def begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f001a82a164a1afdd597cc6c9d46f9c344f7dd5554fc3c4f43fd5879a30678d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beginDate", value)

    @builtins.property
    @jsii.member(jsii_name="endDate")
    def end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endDate"))

    @end_date.setter
    def end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6653b49d6dd068aa219907d86cb4a1665b2332117875bef67e1904d101e48ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDate")
    def lasting_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDate"))

    @lasting_date.setter
    def lasting_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae870c14ba8260fbe58384c27cb1b6713a8981bbccf2e8060e42bb630f0c4e62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDuration")
    def lasting_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDuration"))

    @lasting_duration.setter
    def lasting_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db405bc74fee9d33e28c2383ecbf4161b14e7851fb54772bfb38e352fee62de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e34e0b8ee7f2b325159039dcbfc1e0536bb461ba68e4ef552c5f05516962984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f487bcae1b997f730e25800b0fec353ac05f17a371575d1dc8f14b50f5a455aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDate")
    def repeat_begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatBeginDate"))

    @repeat_begin_date.setter
    def repeat_begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078946386ce6e50935183c5dcbf0bd9d52a0fc33a8a63977a580f59094e20483)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatBeginDate", value)

    @builtins.property
    @jsii.member(jsii_name="repeatDuration")
    def repeat_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatDuration"))

    @repeat_duration.setter
    def repeat_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15e859375e96e3e7d3b26781eb4bb5232be12b1fbac5a845862dc0103d9b9271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatDuration", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6689e5cb2d1b3399d618d7151533037601311b2167aa227cdffe1a34bf899f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd5a6d4f38e1a29df4b79d61ace0563b397a780403734d6ba922eaadd1df284)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc8714a05982c2b70665678c3fc40edff9a70dcd4eef8f45e5acb40a2442f2f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb396bef9dd4747db6edac4b9a0b1742dbd7e26bdb9e99b14aec40c0d806fef9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "status_list": "statusList",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b5254c5fd0556be47269fe86472d75032d2f48466090ab6cc9a684d0d46e261)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument status_list", value=status_list, expected_type=type_hints["status_list"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if status_list is not None:
            self._values["status_list"] = status_list
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Error match scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_list(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.'''
        result = self._values.get("status_list")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6499cb28a025c045cb9ccc5c780de133239a23625f8bd3de988e520a8bfd12)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetStatusList")
    def reset_status_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusList", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="statusListInput")
    def status_list_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "statusListInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd13a638718e7791a8efd519bd0994a9e0ee9a0333cbd6bdfc28059a3e3a424)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700d93b3834eb9e75020fcdb6f6510b2aa88ff1135cc1ed4d2af27a4cf2a1823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="statusList")
    def status_list(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "statusList"))

    @status_list.setter
    def status_list(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__671b6895e2dbe027e620368493fa4088785f26e2d5f1708711e4333db69c323a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusList", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f608049daac8953eed03eefdca945598dfc6d2ec4781f9073726b9846e5b63b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48c669080991a6a127cb365a3001d14dece9d2c74849f86218b8ab01691a8c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088c88b4c0438f93877399af4e77b827f5e9902c0c9811a6aa292be45169aeba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e3c21a94d106eae54f1361a61bbb23d4173a8610d8e908b6f886fc4cd4d2d47)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1826ad613f883c4e14e189385c4a9edfba1783c57df47fda90b5e9729bb18a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5fce99be8bfc3ab02ca14e7ec007d3277c1c57c3086acfb45c1d6e9500d81c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fd6bab79acd40287b4fc5090a077ca8bd8986c75a6526c157a4b55c9b1f894f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e0bedb8fcae891964a3e0798e610e0bb2fe100036402d197912e68855f0853e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3874a0cc8484ab66c49c75efeaa6aafdce784d844d8e6ccbbf3f7b6a07d4bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e355d05576d680c7f842abd005c42abbb3307c0b3faaaf342aaea92886a3c045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19fcb92b4b6d717c9dd2d54c0bd0f577814d8fe7cdcd8853d784bcab229cb0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e789b10e39a347e62fcfc24a6ae040470de27d92430132f7014fc1204f18f001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c71f42ab1caa4b12a1ce12f68c83348b09323c690fb718c7d4ed572d807d3fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation",
    jsii_struct_bases=[],
    name_mapping={
        "check_ips": "checkIps",
        "continent_values": "continentValues",
        "country_values": "countryValues",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "region_values": "regionValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation:
    def __init__(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280f3ea45ab9fa4a8eeb869aa8e9d146d3090fe4e27555e5c858eb56f0a0da43)
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument continent_values", value=continent_values, expected_type=type_hints["continent_values"])
            check_type(argname="argument country_values", value=country_values, expected_type=type_hints["country_values"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument region_values", value=region_values, expected_type=type_hints["region_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if continent_values is not None:
            self._values["continent_values"] = continent_values
        if country_values is not None:
            self._values["country_values"] = country_values
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if region_values is not None:
            self._values["region_values"] = region_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def continent_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        '''
        result = self._values.get("continent_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def country_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        '''
        result = self._values.get("country_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def region_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        '''
        result = self._values.get("region_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09727a248802b7e7eb3dcad47d6f2d0014e2fbe99867de27a0aa24ade9cac147)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetContinentValues")
    def reset_continent_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinentValues", []))

    @jsii.member(jsii_name="resetCountryValues")
    def reset_country_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountryValues", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegionValues")
    def reset_region_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="continentValuesInput")
    def continent_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="countryValuesInput")
    def country_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countryValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionValuesInput")
    def region_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9a0745f8f5161ae50569563da85356c342a9d3fa24858be1c87bf23b4e7661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="continentValues")
    def continent_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continentValues"))

    @continent_values.setter
    def continent_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40493f3590cc0bd948f57b5039837b214fd504e180e94f5e5fdca29dd45ffbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continentValues", value)

    @builtins.property
    @jsii.member(jsii_name="countryValues")
    def country_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countryValues"))

    @country_values.setter
    def country_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a1854d49f20301803ca5eb723a6f34236e58df39e37103c9bbe45bc3a4aee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countryValues", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acd1385500bbbaa703c7d29d65878e9f541f6f252f55ebdbaa98263340d2ebf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8817ef7cfd5174b8144e434dc38820c04374be094b9632f5eb9da339ce989d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9199b3ebf42dcbc3763ca72cf8c2003c6955cf49972c4712c7ed6fae061d281f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regionValues")
    def region_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regionValues"))

    @region_values.setter
    def region_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d27feea975d703fdf450eeae6ba84337501c75400515d54e70a726ea7dd2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regionValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__144399509c6d0142d28e06f15996138726a2a20ee1a8490438f66586240fc148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7065a13a96c829cec7748becde4e1d394a491e21f02f73bec80da6d38fe6ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1394064e95d2405c9106e5bc78b1c400d3bef99a22266f1be39e0322718509c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d547fdac513721df10808ddfd3a4d6bc85bad47fa6b641cb17ed0591dbb34066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "bandwidth_values": "bandwidthValues",
        "check_ips": "checkIps",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "network_type_values": "networkTypeValues",
        "network_values": "networkValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork:
    def __init__(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3fd4269d9864e3cffdf6e0dd9266146e1e2fae9196def8e4dfc902144cfe53c)
            check_type(argname="argument bandwidth_values", value=bandwidth_values, expected_type=type_hints["bandwidth_values"])
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network_type_values", value=network_type_values, expected_type=type_hints["network_type_values"])
            check_type(argname="argument network_values", value=network_values, expected_type=type_hints["network_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bandwidth_values is not None:
            self._values["bandwidth_values"] = bandwidth_values
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network_type_values is not None:
            self._values["network_type_values"] = network_type_values
        if network_values is not None:
            self._values["network_values"] = network_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bandwidth_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        '''
        result = self._values.get("bandwidth_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''The type of information to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network_type_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.'''
        result = self._values.get("network_type_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def network_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Any set of specific networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        '''
        result = self._values.get("network_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eee4e26f841c77ade82148238b1e3586fa94f2d95b5ae6cf74809347073df11)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBandwidthValues")
    def reset_bandwidth_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBandwidthValues", []))

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetworkTypeValues")
    def reset_network_type_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkTypeValues", []))

    @jsii.member(jsii_name="resetNetworkValues")
    def reset_network_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValuesInput")
    def bandwidth_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "bandwidthValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkTypeValuesInput")
    def network_type_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkTypeValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="networkValuesInput")
    def network_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValues")
    def bandwidth_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "bandwidthValues"))

    @bandwidth_values.setter
    def bandwidth_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6c26e878c34f57a5c5455952471a9d27ae3d2825c41f0bee0dc40de3036a3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bandwidthValues", value)

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b41b91d322578cca66c0f097d1b9fd54dd3d1b204e6b6b16b974ae58abe154)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9f9f2b1a1100dc355f0b06a1713809af5d4d675b53c52aaa22b320f0fa9eb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf2ae7d568a15f685ddcdb1f9a315d33cb2b2027d767155228736afecb2ccd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7425b76e641684e452903f07b57706305c61723c9cea5a4347642fc8d5074d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="networkTypeValues")
    def network_type_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkTypeValues"))

    @network_type_values.setter
    def network_type_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88eebcc50953ad6be3c658e7ae4bd7095a168c4e2d2b5713a3e0285fb4647d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkTypeValues", value)

    @builtins.property
    @jsii.member(jsii_name="networkValues")
    def network_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkValues"))

    @network_values.setter
    def network_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af78d6f81b831ce5222f4ff346c2199cfa9a11d6082b745770d8d614f2aff2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a995c21acb05c113a822fa2caf9924c377ee81ae8a422f70b4666d910bbe3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f6b2f076ab2ece56e3307c36c06ad9d9cfbbefa74b70f6125dd1f0bd0427a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e4597dc36e0cc7427d50c271a2cee1e908c31f992e037036224668fc2d0e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07cfabe83d7e0b524c7739e397b6c562c527fc8251d8870524c386a66b7f24fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "result": "result",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_names": "variableNames",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8bb8315ccea09e8f55dda640cdd25d9154e762051fc40e935e28d82ca09104e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument result", value=result, expected_type=type_hints["result"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_names", value=variable_names, expected_type=type_hints["variable_names"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if result is not None:
            self._values["result"] = result
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_names is not None:
            self._values["variable_names"] = variable_names

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def result(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        '''
        result = self._values.get("result")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name.

        Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        result = self._values.get("variable_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0833c12068f2d1b087c7c81b7bff7de1c23333333ac857b7de8ebad15320fd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResult")
    def reset_result(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResult", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableNames")
    def reset_variable_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableNames", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resultInput")
    def result_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resultInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNamesInput")
    def variable_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c40bbe7c58bb8503af8c985dd3b9d02d3a3e5f12a763a2b21e0ed991f6af61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="result")
    def result(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "result"))

    @result.setter
    def result(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcfb0efa1dc3191525e98fd746198e5f97bf3788d0397b928bffa983847abd20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "result", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89ae1de8c9c3d552766321a250c75f9ef75ae16ce2a28c0510efe163ca66e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f621ca40758501b238d53e4a03a386697acafc1fb24ba9608022437ff5962f77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableNames")
    def variable_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableNames"))

    @variable_names.setter
    def variable_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b79f0f6e88782a44e91f4ecc910368c9f5aea9ac38348a33cded4f812b2d7097)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableNames", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64db978770d6b19b3c2e02bc4d03a2e3bc95aa2b8daaf837f405659e254f6a9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__956e25767006e30fbdc1a43c05d0a7955f50fab2f4b4dcc5e0ca17238b83f968)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``virtualWaitingRoom`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27281eaffb4cb2700d1d5b6c11c47121cce46325a49e4c8b4f81306d647b489b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c288f2056ca4ccba0bb78a4f3f53e38a061c82481e784829ca9bf52d2062671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce21fed1706c691e4fadf2a69f281e3ebaab883c6db82dd2d153d608a6a7d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6591f6db69c1915dd17a7d01c8191e088e2496eb84bbfb84d179996505aa4793)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b08fd05a2a84abf62d1ff7fb0eec0b314b52a618677c1807ab0bbfb123498e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0789884e1c27e9eb3e65f931d85edcfda668ab09474e5ee01a258432a8c401c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a3964d8b8bc93e252adbc2446456eaad9723e6c6a35f22505aa85f4660b0193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b8c93645efada78fbeed697940524fd01050bdb0c2aaddade6bd1ca4edd77e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4dc206eada0bd28c6ab58fa135969ff55412465f0375cbbfda0dd12bc34223f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a8cc2b8450170cd5287d6184470adb3653f9ce2148deee0b6f25cbd6d1bdb44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745759557e9e51f8e9c66be5c721bda93ff31a28aee86f5551a4d16cbf9c1f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616aa8375fec77861a59ebef1ecb8952fe3384b0cdefcf5e526af01812ce9cfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf536ea49aa12693bd0b342308a3e9005dff00af30824b4bfcc9757fdab25a11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1230c4ca3d54cbf3f00cb5e944d573ff8bb31d8cdc2d1b84dab152e66a04d18b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a51bb9c1afd8b6f21a3333ec3f6206fffbfa16d4b4c722662a82035ab2faa279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride",
    jsii_struct_bases=[],
    name_mapping={"name": "name", "override_id": "overrideId"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride:
    def __init__(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67494a3bbb555a79ba730351f4b3417763478910d2f98f6eeac5b6eacd71af40)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument override_id", value=override_id, expected_type=type_hints["override_id"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if name is not None:
            self._values["name"] = name
        if override_id is not None:
            self._values["override_id"] = override_id

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''The name of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def override_id(self) -> typing.Optional[builtins.str]:
        '''The ID of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        result = self._values.get("override_id")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7b18b5c798b13c0bfd5648e47b0877e31b457fc9a777aca92d83eb211aa88ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetOverrideId")
    def reset_override_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideId", []))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIdInput")
    def override_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideIdInput"))

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c0790b2ede5ec910bd3b46916016195127c9813c748b7c849489e0dced6ece)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="overrideId")
    def override_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "overrideId"))

    @override_id.setter
    def override_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f5b6f00698fc78e7639c21c69fafb44862fe656caed0aefcf4a4bace80006d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideId", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51df01fb5ce76eb224aa51c7ce9a5bed1c43cbf203814cd1693ba0c9b31bd903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19e10ea36bdfc5f25c597c9eae64b2f2b2e3f1601ac837108723ae70047ca02b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBehavior")
    def put_behavior(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a3a4f33e1eb7db08043194457a2ad05bec602af9df4176fbe73b38298a3a905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBehavior", [value]))

    @jsii.member(jsii_name="putCriterion")
    def put_criterion(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d4dc1bd001ce13cb56469f6aed2a0bea2540da55a1605ffa2097f0d7af63f4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCriterion", [value]))

    @jsii.member(jsii_name="putCustomOverride")
    def put_custom_override(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride(
            name=name, override_id=override_id
        )

        return typing.cast(None, jsii.invoke(self, "putCustomOverride", [value]))

    @jsii.member(jsii_name="putVariable")
    def put_variable(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230530Variable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9545d272d588d7f64e687cf991043561e093392f217450453d18fd10766ce0e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putVariable", [value]))

    @jsii.member(jsii_name="resetAdvancedOverride")
    def reset_advanced_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedOverride", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetChildren")
    def reset_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChildren", []))

    @jsii.member(jsii_name="resetComments")
    def reset_comments(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComments", []))

    @jsii.member(jsii_name="resetCriteriaLocked")
    def reset_criteria_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaLocked", []))

    @jsii.member(jsii_name="resetCriteriaMustSatisfy")
    def reset_criteria_must_satisfy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaMustSatisfy", []))

    @jsii.member(jsii_name="resetCriterion")
    def reset_criterion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriterion", []))

    @jsii.member(jsii_name="resetCustomOverride")
    def reset_custom_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomOverride", []))

    @jsii.member(jsii_name="resetIsSecure")
    def reset_is_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSecure", []))

    @jsii.member(jsii_name="resetTemplateLink")
    def reset_template_link(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateLink", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariable")
    def reset_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariable", []))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorList, jsii.get(self, "behavior"))

    @builtins.property
    @jsii.member(jsii_name="criterion")
    def criterion(self) -> DataAkamaiPropertyRulesBuilderRulesV20230530CriterionList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CriterionList, jsii.get(self, "criterion"))

    @builtins.property
    @jsii.member(jsii_name="customOverride")
    def custom_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverrideOutputReference, jsii.get(self, "customOverride"))

    @builtins.property
    @jsii.member(jsii_name="variable")
    def variable(self) -> "DataAkamaiPropertyRulesBuilderRulesV20230530VariableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530VariableList", jsii.get(self, "variable"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverrideInput")
    def advanced_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]]], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="childrenInput")
    def children_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "childrenInput"))

    @builtins.property
    @jsii.member(jsii_name="commentsInput")
    def comments_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "commentsInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaLockedInput")
    def criteria_locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "criteriaLockedInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfyInput")
    def criteria_must_satisfy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "criteriaMustSatisfyInput"))

    @builtins.property
    @jsii.member(jsii_name="criterionInput")
    def criterion_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]]], jsii.get(self, "criterionInput"))

    @builtins.property
    @jsii.member(jsii_name="customOverrideInput")
    def custom_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride], jsii.get(self, "customOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="isSecureInput")
    def is_secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSecureInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateLinkInput")
    def template_link_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateLinkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableInput")
    def variable_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Variable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230530Variable"]]], jsii.get(self, "variableInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverride")
    def advanced_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advancedOverride"))

    @advanced_override.setter
    def advanced_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd1cc986daf84f222ab7ed0e5c0bb9497349f0186ca5f7583467bd8010870e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advancedOverride", value)

    @builtins.property
    @jsii.member(jsii_name="children")
    def children(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "children"))

    @children.setter
    def children(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60490ea3405304f07656f6e660fc1f7d060d2530d8711389d8bf2d11bdd68779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "children", value)

    @builtins.property
    @jsii.member(jsii_name="comments")
    def comments(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "comments"))

    @comments.setter
    def comments(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d7462df45dfa180d512bb82c7eb00f60fea1d5d6e5630c9c8db27ee4e4f22e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "comments", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaLocked")
    def criteria_locked(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "criteriaLocked"))

    @criteria_locked.setter
    def criteria_locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd6de92328177bfef59ed6fa0a971e420984e98c0b2354921890d2efab9c7c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaLocked", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfy")
    def criteria_must_satisfy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "criteriaMustSatisfy"))

    @criteria_must_satisfy.setter
    def criteria_must_satisfy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb89ac041b8a9757f30f0dabd0713ff150f34d1ce994b6c16fc7f28e02f669b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaMustSatisfy", value)

    @builtins.property
    @jsii.member(jsii_name="isSecure")
    def is_secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSecure"))

    @is_secure.setter
    def is_secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5429c841d435f170fe8b60bab3d0b4e4001a4c865cfdbfabc8e1d93082101a1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSecure", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1668d7ed5c245e50d7f132c7cba5e42a7d09f4ba13cb30c24166d1ddf61a04c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="templateLink")
    def template_link(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateLink"))

    @template_link.setter
    def template_link(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5428d0e827c7b49b53cfb94893789d6f2510a6e558b14a1fd6c0a8a936a92777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateLink", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48c9c97b579077feafa8a2c9fc706e2e52d553ba3b62ced23cc583c7019206e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc8868fdfa0eb7674b9d4fae5372767c8747212fc326890553a4f3f3486a45a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e0c91b98fc3906c1a23af7e8fd7d86e68707786135d95c49d1464edc2f2a726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530Variable",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "hidden": "hidden",
        "name": "name",
        "sensitive": "sensitive",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230530Variable:
    def __init__(
        self,
        *,
        description: builtins.str,
        hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        name: builtins.str,
        sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        value: builtins.str,
    ) -> None:
        '''
        :param description: The description for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param hidden: Whether a variable should be hidden. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        :param name: The name of a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param sensitive: States whether a variable contains sensitive information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        :param value: The value for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c3fdcff24803ec87a3d03b22c5bbf3dcea288b8b18b07c77556fd5ba9d5f32)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument hidden", value=hidden, expected_type=type_hints["hidden"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument sensitive", value=sensitive, expected_type=type_hints["sensitive"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "description": description,
            "hidden": hidden,
            "name": name,
            "sensitive": sensitive,
            "value": value,
        }

    @builtins.property
    def description(self) -> builtins.str:
        '''The description for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        assert result is not None, "Required property 'description' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''Whether a variable should be hidden.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        '''
        result = self._values.get("hidden")
        assert result is not None, "Required property 'hidden' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''States whether a variable contains sensitive information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        '''
        result = self._values.get("sensitive")
        assert result is not None, "Required property 'sensitive' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def value(self) -> builtins.str:
        '''The value for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        assert result is not None, "Required property 'value' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230530Variable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230530VariableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530VariableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644f54434171615990ba3256a94b6a68e91589f3983171b9dc27dd5a67778bb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230530VariableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1388c84b97a8cfef3e521e097baa4cea20edb1e625ccc0f565708927ad33db)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230530VariableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70070952e257e49470179dcf96572b5a87ba1c2177860c1f0b5903f79def2495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b123ca21e2e647a83be4e966f31cb49de153d0608bb01c90a1eb61e6286194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f4a68dcfa4229fb8cc3ef42253021f45dd173cab34d5bc88f90ba56474e105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Variable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Variable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Variable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__514735e15215fcd4fcc115c68c88509e3109f931271e497859a961bd93b407d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230530VariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230530VariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37462d2d5443407c44d0b1e6b697484a7a41ed6b82ac23cb0a0fe3bddeea15ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="hiddenInput")
    def hidden_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hiddenInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="sensitiveInput")
    def sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51d04f0a50d086de0defcfa2f52d765d58788e28348c6b2c4e4ab7148f551dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="hidden")
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hidden"))

    @hidden.setter
    def hidden(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51343a6534a9af8f6d63c31a874672f8645d0f8d0bd1a3d4e0fc978a0ffabb2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hidden", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9db3190c3575ad5921e1b9ad18fa8847d4e620308d326fb3a563b0ce2f0b7b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="sensitive")
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sensitive"))

    @sensitive.setter
    def sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c220bf988e815dce83b0a0f1fd8e34891e2f97f1d5e2e7cc0cf5d285f72027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sensitive", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d87f9c5319f7a0ef69f7091581af7cd7ed02a513f93f15647995ecc26c5d72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Variable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Variable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Variable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4950d577f9e13b8f33dfd195043477f97fe6e8e70fc884f767cd3a59874d9465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920",
    jsii_struct_bases=[],
    name_mapping={
        "name": "name",
        "advanced_override": "advancedOverride",
        "behavior": "behavior",
        "children": "children",
        "comments": "comments",
        "criteria_locked": "criteriaLocked",
        "criteria_must_satisfy": "criteriaMustSatisfy",
        "criterion": "criterion",
        "custom_override": "customOverride",
        "is_secure": "isSecure",
        "template_link": "templateLink",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable": "variable",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920:
    def __init__(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        if isinstance(custom_override, dict):
            custom_override = DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride(**custom_override)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4f1035a956264c98f89a72a77657914ba49eb15c7dc234366dcdf1e0073f0e2)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument advanced_override", value=advanced_override, expected_type=type_hints["advanced_override"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument children", value=children, expected_type=type_hints["children"])
            check_type(argname="argument comments", value=comments, expected_type=type_hints["comments"])
            check_type(argname="argument criteria_locked", value=criteria_locked, expected_type=type_hints["criteria_locked"])
            check_type(argname="argument criteria_must_satisfy", value=criteria_must_satisfy, expected_type=type_hints["criteria_must_satisfy"])
            check_type(argname="argument criterion", value=criterion, expected_type=type_hints["criterion"])
            check_type(argname="argument custom_override", value=custom_override, expected_type=type_hints["custom_override"])
            check_type(argname="argument is_secure", value=is_secure, expected_type=type_hints["is_secure"])
            check_type(argname="argument template_link", value=template_link, expected_type=type_hints["template_link"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable", value=variable, expected_type=type_hints["variable"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "name": name,
        }
        if advanced_override is not None:
            self._values["advanced_override"] = advanced_override
        if behavior is not None:
            self._values["behavior"] = behavior
        if children is not None:
            self._values["children"] = children
        if comments is not None:
            self._values["comments"] = comments
        if criteria_locked is not None:
            self._values["criteria_locked"] = criteria_locked
        if criteria_must_satisfy is not None:
            self._values["criteria_must_satisfy"] = criteria_must_satisfy
        if criterion is not None:
            self._values["criterion"] = criterion
        if custom_override is not None:
            self._values["custom_override"] = custom_override
        if is_secure is not None:
            self._values["is_secure"] = is_secure
        if template_link is not None:
            self._values["template_link"] = template_link
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable is not None:
            self._values["variable"] = variable

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def advanced_override(self) -> typing.Optional[builtins.str]:
        '''XML metadata of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        '''
        result = self._values.get("advanced_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Behavior"]]]:
        '''behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Behavior"]]], result)

    @builtins.property
    def children(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of child rules for a particular rule in JSON format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        '''
        result = self._values.get("children")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def comments(self) -> typing.Optional[builtins.str]:
        '''The comments for a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        '''
        result = self._values.get("comments")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criteria_locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether changes to 'criterion' objects are prohibited.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        '''
        result = self._values.get("criteria_locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def criteria_must_satisfy(self) -> typing.Optional[builtins.str]:
        '''States whether 'all' criteria need to match or 'any'.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        '''
        result = self._values.get("criteria_must_satisfy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criterion(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Criterion"]]]:
        '''criterion block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        '''
        result = self._values.get("criterion")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Criterion"]]], result)

    @builtins.property
    def custom_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride"]:
        '''custom_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        '''
        result = self._values.get("custom_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride"], result)

    @builtins.property
    def is_secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether a rule is secure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        '''
        result = self._values.get("is_secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_link(self) -> typing.Optional[builtins.str]:
        '''The template link for the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        '''
        result = self._values.get("template_link")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of a rule template.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Variable"]]]:
        '''variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        result = self._values.get("variable")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Variable"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920Behavior",
    jsii_struct_bases=[],
    name_mapping={
        "adaptive_acceleration": "adaptiveAcceleration",
        "adaptive_image_compression": "adaptiveImageCompression",
        "ad_scaler_circuit_breaker": "adScalerCircuitBreaker",
        "advanced": "advanced",
        "aggregated_reporting": "aggregatedReporting",
        "akamaizer": "akamaizer",
        "akamaizer_tag": "akamaizerTag",
        "all_http_in_cache_hierarchy": "allHttpInCacheHierarchy",
        "allow_cloudlets_origins": "allowCloudletsOrigins",
        "allow_delete": "allowDelete",
        "allow_https_cache_key_sharing": "allowHttpsCacheKeySharing",
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_options": "allowOptions",
        "allow_patch": "allowPatch",
        "allow_post": "allowPost",
        "allow_put": "allowPut",
        "allow_transfer_encoding": "allowTransferEncoding",
        "alt_svc_header": "altSvcHeader",
        "api_prioritization": "apiPrioritization",
        "application_load_balancer": "applicationLoadBalancer",
        "audience_segmentation": "audienceSegmentation",
        "auto_domain_validation": "autoDomainValidation",
        "base_directory": "baseDirectory",
        "boss_beaconing": "bossBeaconing",
        "breadcrumbs": "breadcrumbs",
        "break_connection": "breakConnection",
        "brotli": "brotli",
        "cache_error": "cacheError",
        "cache_id": "cacheId",
        "cache_key_ignore_case": "cacheKeyIgnoreCase",
        "cache_key_query_params": "cacheKeyQueryParams",
        "cache_key_rewrite": "cacheKeyRewrite",
        "cache_post": "cachePost",
        "cache_redirect": "cacheRedirect",
        "cache_tag": "cacheTag",
        "cache_tag_visible": "cacheTagVisible",
        "caching": "caching",
        "central_authorization": "centralAuthorization",
        "chase_redirects": "chaseRedirects",
        "client_certificate_auth": "clientCertificateAuth",
        "client_characteristics": "clientCharacteristics",
        "cloud_interconnects": "cloudInterconnects",
        "cloud_wrapper": "cloudWrapper",
        "cloud_wrapper_advanced": "cloudWrapperAdvanced",
        "common_media_client_data": "commonMediaClientData",
        "conditional_origin": "conditionalOrigin",
        "construct_response": "constructResponse",
        "content_characteristics": "contentCharacteristics",
        "content_characteristics_amd": "contentCharacteristicsAmd",
        "content_characteristics_dd": "contentCharacteristicsDd",
        "content_characteristics_wsd_large_file": "contentCharacteristicsWsdLargeFile",
        "content_characteristics_wsd_live": "contentCharacteristicsWsdLive",
        "content_characteristics_wsd_vod": "contentCharacteristicsWsdVod",
        "content_pre_position": "contentPrePosition",
        "content_targeting_protection": "contentTargetingProtection",
        "cors_support": "corsSupport",
        "cp_code": "cpCode",
        "custom_behavior": "customBehavior",
        "datastream": "datastream",
        "dcp": "dcp",
        "dcp_auth_hmac_transformation": "dcpAuthHmacTransformation",
        "dcp_auth_regex_transformation": "dcpAuthRegexTransformation",
        "dcp_auth_substring_transformation": "dcpAuthSubstringTransformation",
        "dcp_auth_variable_extractor": "dcpAuthVariableExtractor",
        "dcp_default_authz_groups": "dcpDefaultAuthzGroups",
        "dcp_dev_relations": "dcpDevRelations",
        "dcp_real_time_auth": "dcpRealTimeAuth",
        "delivery_receipt": "deliveryReceipt",
        "deny_access": "denyAccess",
        "deny_direct_failover_access": "denyDirectFailoverAccess",
        "device_characteristic_cache_id": "deviceCharacteristicCacheId",
        "device_characteristic_header": "deviceCharacteristicHeader",
        "dns_async_refresh": "dnsAsyncRefresh",
        "dns_prefresh": "dnsPrefresh",
        "downgrade_protocol": "downgradeProtocol",
        "download_complete_marker": "downloadCompleteMarker",
        "download_notification": "downloadNotification",
        "downstream_cache": "downstreamCache",
        "dynamic_throughtput_optimization": "dynamicThroughtputOptimization",
        "dynamic_throughtput_optimization_override": "dynamicThroughtputOptimizationOverride",
        "dynamic_web_content": "dynamicWebContent",
        "ecms_bulk_upload": "ecmsBulkUpload",
        "ecms_database": "ecmsDatabase",
        "ecms_dataset": "ecmsDataset",
        "ecms_object_key": "ecmsObjectKey",
        "edge_connect": "edgeConnect",
        "edge_load_balancing_advanced": "edgeLoadBalancingAdvanced",
        "edge_load_balancing_data_center": "edgeLoadBalancingDataCenter",
        "edge_load_balancing_origin": "edgeLoadBalancingOrigin",
        "edge_origin_authorization": "edgeOriginAuthorization",
        "edge_redirector": "edgeRedirector",
        "edge_scape": "edgeScape",
        "edge_side_includes": "edgeSideIncludes",
        "edge_worker": "edgeWorker",
        "enforce_mtls_settings": "enforceMtlsSettings",
        "enhanced_akamai_protocol": "enhancedAkamaiProtocol",
        "enhanced_proxy_detection": "enhancedProxyDetection",
        "epd_forward_header_enrichment": "epdForwardHeaderEnrichment",
        "fail_action": "failAction",
        "failover_bot_manager_feature_compatibility": "failoverBotManagerFeatureCompatibility",
        "fast_invalidate": "fastInvalidate",
        "fips": "fips",
        "first_party_marketing": "firstPartyMarketing",
        "first_party_marketing_plus": "firstPartyMarketingPlus",
        "forward_rewrite": "forwardRewrite",
        "g2_oheader": "g2Oheader",
        "global_request_number": "globalRequestNumber",
        "graphql_caching": "graphqlCaching",
        "gzip_response": "gzipResponse",
        "hd_data_advanced": "hdDataAdvanced",
        "health_detection": "healthDetection",
        "hsaf_eip_binding": "hsafEipBinding",
        "http2": "http2",
        "http3": "http3",
        "http_strict_transport_security": "httpStrictTransportSecurity",
        "http_to_https_upgrade": "httpToHttpsUpgrade",
        "image_and_video_manager": "imageAndVideoManager",
        "image_manager": "imageManager",
        "image_manager_video": "imageManagerVideo",
        "im_override": "imOverride",
        "include": "include",
        "instant": "instant",
        "instant_config": "instantConfig",
        "large_file_optimization": "largeFileOptimization",
        "large_file_optimization_advanced": "largeFileOptimizationAdvanced",
        "limit_bit_rate": "limitBitRate",
        "log_custom": "logCustom",
        "manifest_personalization": "manifestPersonalization",
        "manifest_rerouting": "manifestRerouting",
        "manual_server_push": "manualServerPush",
        "media_acceleration": "mediaAcceleration",
        "media_acceleration_quic_optout": "mediaAccelerationQuicOptout",
        "media_client": "mediaClient",
        "media_file_retrieval_optimization": "mediaFileRetrievalOptimization",
        "media_origin_failover": "mediaOriginFailover",
        "metadata_caching": "metadataCaching",
        "mobile_sdk_performance": "mobileSdkPerformance",
        "modify_incoming_request_header": "modifyIncomingRequestHeader",
        "modify_incoming_response_header": "modifyIncomingResponseHeader",
        "modify_outgoing_request_header": "modifyOutgoingRequestHeader",
        "modify_outgoing_response_header": "modifyOutgoingResponseHeader",
        "modify_via_header": "modifyViaHeader",
        "m_pulse": "mPulse",
        "origin": "origin",
        "origin_characteristics": "originCharacteristics",
        "origin_characteristics_wsd": "originCharacteristicsWsd",
        "origin_failure_recovery_method": "originFailureRecoveryMethod",
        "origin_failure_recovery_policy": "originFailureRecoveryPolicy",
        "origin_ip_acl": "originIpAcl",
        "permissions_policy": "permissionsPolicy",
        "persistent_client_connection": "persistentClientConnection",
        "persistent_connection": "persistentConnection",
        "personally_identifiable_information": "personallyIdentifiableInformation",
        "phased_release": "phasedRelease",
        "preconnect": "preconnect",
        "predictive_content_delivery": "predictiveContentDelivery",
        "predictive_prefetching": "predictivePrefetching",
        "prefetch": "prefetch",
        "prefetchable": "prefetchable",
        "prefresh_cache": "prefreshCache",
        "quality": "quality",
        "quic_beta": "quicBeta",
        "random_seek": "randomSeek",
        "rapid": "rapid",
        "read_timeout": "readTimeout",
        "real_time_reporting": "realTimeReporting",
        "real_user_monitoring": "realUserMonitoring",
        "redirect": "redirect",
        "redirectplus": "redirectplus",
        "referer_checking": "refererChecking",
        "remove_query_parameter": "removeQueryParameter",
        "remove_vary": "removeVary",
        "report": "report",
        "request_client_hints": "requestClientHints",
        "request_control": "requestControl",
        "request_type_marker": "requestTypeMarker",
        "resource_optimizer": "resourceOptimizer",
        "resource_optimizer_extended_compatibility": "resourceOptimizerExtendedCompatibility",
        "response_code": "responseCode",
        "response_cookie": "responseCookie",
        "restrict_object_caching": "restrictObjectCaching",
        "return_cache_status": "returnCacheStatus",
        "rewrite_url": "rewriteUrl",
        "rum_custom": "rumCustom",
        "saas_definitions": "saasDefinitions",
        "sales_force_commerce_cloud_client": "salesForceCommerceCloudClient",
        "sales_force_commerce_cloud_provider": "salesForceCommerceCloudProvider",
        "sales_force_commerce_cloud_provider_host_header": "salesForceCommerceCloudProviderHostHeader",
        "save_post_dca_processing": "savePostDcaProcessing",
        "schedule_invalidation": "scheduleInvalidation",
        "script_management": "scriptManagement",
        "segmented_content_protection": "segmentedContentProtection",
        "segmented_media_optimization": "segmentedMediaOptimization",
        "segmented_media_streaming_prefetch": "segmentedMediaStreamingPrefetch",
        "set_variable": "setVariable",
        "simulate_error_code": "simulateErrorCode",
        "site_shield": "siteShield",
        "standard_tls_migration": "standardTlsMigration",
        "standard_tls_migration_override": "standardTlsMigrationOverride",
        "strict_header_parsing": "strictHeaderParsing",
        "sub_customer": "subCustomer",
        "sure_route": "sureRoute",
        "tcp_optimization": "tcpOptimization",
        "tea_leaf": "teaLeaf",
        "tiered_distribution": "tieredDistribution",
        "tiered_distribution_advanced": "tieredDistributionAdvanced",
        "tiered_distribution_customization": "tieredDistributionCustomization",
        "timeout": "timeout",
        "uid_configuration": "uidConfiguration",
        "validate_entity_tag": "validateEntityTag",
        "verify_json_web_token": "verifyJsonWebToken",
        "verify_json_web_token_for_dcp": "verifyJsonWebTokenForDcp",
        "verify_token_authorization": "verifyTokenAuthorization",
        "virtual_waiting_room": "virtualWaitingRoom",
        "virtual_waiting_room_with_edge_workers": "virtualWaitingRoomWithEdgeWorkers",
        "visitor_prioritization": "visitorPrioritization",
        "visitor_prioritization_fifo": "visitorPrioritizationFifo",
        "visitor_prioritization_fifo_standalone": "visitorPrioritizationFifoStandalone",
        "watermarking": "watermarking",
        "web_application_firewall": "webApplicationFirewall",
        "webdav": "webdav",
        "web_sockets": "webSockets",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920Behavior:
    def __init__(
        self,
        *,
        adaptive_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        adaptive_image_compression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression", typing.Dict[builtins.str, typing.Any]]] = None,
        ad_scaler_circuit_breaker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker", typing.Dict[builtins.str, typing.Any]]] = None,
        advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        aggregated_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag", typing.Dict[builtins.str, typing.Any]]] = None,
        all_http_in_cache_hierarchy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_cloudlets_origins: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_delete: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_cache_key_sharing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_downgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_options: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_patch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_put: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_transfer_encoding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding", typing.Dict[builtins.str, typing.Any]]] = None,
        alt_svc_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        api_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        application_load_balancer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer", typing.Dict[builtins.str, typing.Any]]] = None,
        audience_segmentation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation", typing.Dict[builtins.str, typing.Any]]] = None,
        auto_domain_validation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation", typing.Dict[builtins.str, typing.Any]]] = None,
        base_directory: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory", typing.Dict[builtins.str, typing.Any]]] = None,
        boss_beaconing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing", typing.Dict[builtins.str, typing.Any]]] = None,
        breadcrumbs: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs", typing.Dict[builtins.str, typing.Any]]] = None,
        break_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        brotli: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_ignore_case: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_query_params: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag_visible: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible", typing.Dict[builtins.str, typing.Any]]] = None,
        caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        central_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        chase_redirects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        client_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_interconnects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        common_media_client_data: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData", typing.Dict[builtins.str, typing.Any]]] = None,
        conditional_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        construct_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_amd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_dd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_large_file: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_live: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_vod: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod", typing.Dict[builtins.str, typing.Any]]] = None,
        content_pre_position: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition", typing.Dict[builtins.str, typing.Any]]] = None,
        content_targeting_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        cors_support: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        custom_behavior: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior", typing.Dict[builtins.str, typing.Any]]] = None,
        datastream: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_hmac_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_regex_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_substring_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_variable_extractor: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_default_authz_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_dev_relations: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_real_time_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        delivery_receipt: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_direct_failover_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_async_refresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_prefresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        downgrade_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        download_complete_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        download_notification: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification", typing.Dict[builtins.str, typing.Any]]] = None,
        downstream_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_web_content: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_bulk_upload: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_database: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_dataset: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_object_key: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_connect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_data_center: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_origin_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_redirector: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_scape: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_side_includes: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_worker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker", typing.Dict[builtins.str, typing.Any]]] = None,
        enforce_mtls_settings: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_akamai_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_proxy_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        epd_forward_header_enrichment: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment", typing.Dict[builtins.str, typing.Any]]] = None,
        fail_action: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction", typing.Dict[builtins.str, typing.Any]]] = None,
        failover_bot_manager_feature_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        fast_invalidate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate", typing.Dict[builtins.str, typing.Any]]] = None,
        fips: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing_plus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus", typing.Dict[builtins.str, typing.Any]]] = None,
        forward_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        g2_oheader: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader", typing.Dict[builtins.str, typing.Any]]] = None,
        global_request_number: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber", typing.Dict[builtins.str, typing.Any]]] = None,
        graphql_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        gzip_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        hd_data_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        health_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        hsaf_eip_binding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding", typing.Dict[builtins.str, typing.Any]]] = None,
        http2: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2", typing.Dict[builtins.str, typing.Any]]] = None,
        http3: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3", typing.Dict[builtins.str, typing.Any]]] = None,
        http_strict_transport_security: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity", typing.Dict[builtins.str, typing.Any]]] = None,
        http_to_https_upgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade", typing.Dict[builtins.str, typing.Any]]] = None,
        image_and_video_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager_video: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo", typing.Dict[builtins.str, typing.Any]]] = None,
        im_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        include: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude", typing.Dict[builtins.str, typing.Any]]] = None,
        instant: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant", typing.Dict[builtins.str, typing.Any]]] = None,
        instant_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        limit_bit_rate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate", typing.Dict[builtins.str, typing.Any]]] = None,
        log_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_personalization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_rerouting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting", typing.Dict[builtins.str, typing.Any]]] = None,
        manual_server_push: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration_quic_optout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout", typing.Dict[builtins.str, typing.Any]]] = None,
        media_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient", typing.Dict[builtins.str, typing.Any]]] = None,
        media_file_retrieval_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        media_origin_failover: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        mobile_sdk_performance: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_via_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        m_pulse: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse", typing.Dict[builtins.str, typing.Any]]] = None,
        origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics_wsd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_ip_acl: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl", typing.Dict[builtins.str, typing.Any]]] = None,
        permissions_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_client_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        personally_identifiable_information: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation", typing.Dict[builtins.str, typing.Any]]] = None,
        phased_release: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease", typing.Dict[builtins.str, typing.Any]]] = None,
        preconnect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_content_delivery: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_prefetching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetchable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable", typing.Dict[builtins.str, typing.Any]]] = None,
        prefresh_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache", typing.Dict[builtins.str, typing.Any]]] = None,
        quality: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality", typing.Dict[builtins.str, typing.Any]]] = None,
        quic_beta: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta", typing.Dict[builtins.str, typing.Any]]] = None,
        random_seek: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek", typing.Dict[builtins.str, typing.Any]]] = None,
        rapid: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid", typing.Dict[builtins.str, typing.Any]]] = None,
        read_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        real_time_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        real_user_monitoring: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring", typing.Dict[builtins.str, typing.Any]]] = None,
        redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        redirectplus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus", typing.Dict[builtins.str, typing.Any]]] = None,
        referer_checking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_query_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_vary: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary", typing.Dict[builtins.str, typing.Any]]] = None,
        report: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport", typing.Dict[builtins.str, typing.Any]]] = None,
        request_client_hints: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints", typing.Dict[builtins.str, typing.Any]]] = None,
        request_control: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer_extended_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        response_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        restrict_object_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        return_cache_status: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus", typing.Dict[builtins.str, typing.Any]]] = None,
        rewrite_url: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl", typing.Dict[builtins.str, typing.Any]]] = None,
        rum_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        saas_definitions: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        save_post_dca_processing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing", typing.Dict[builtins.str, typing.Any]]] = None,
        schedule_invalidation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation", typing.Dict[builtins.str, typing.Any]]] = None,
        script_management: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_content_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_streaming_prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        set_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        simulate_error_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode", typing.Dict[builtins.str, typing.Any]]] = None,
        site_shield: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        strict_header_parsing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing", typing.Dict[builtins.str, typing.Any]]] = None,
        sub_customer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer", typing.Dict[builtins.str, typing.Any]]] = None,
        sure_route: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute", typing.Dict[builtins.str, typing.Any]]] = None,
        tcp_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        tea_leaf: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_customization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization", typing.Dict[builtins.str, typing.Any]]] = None,
        timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        uid_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        validate_entity_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token_for_dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo_standalone: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone", typing.Dict[builtins.str, typing.Any]]] = None,
        watermarking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking", typing.Dict[builtins.str, typing.Any]]] = None,
        web_application_firewall: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall", typing.Dict[builtins.str, typing.Any]]] = None,
        webdav: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav", typing.Dict[builtins.str, typing.Any]]] = None,
        web_sockets: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param adaptive_acceleration: adaptive_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        :param adaptive_image_compression: adaptive_image_compression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        :param ad_scaler_circuit_breaker: ad_scaler_circuit_breaker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        :param advanced: advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param aggregated_reporting: aggregated_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        :param akamaizer: akamaizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        :param akamaizer_tag: akamaizer_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        :param all_http_in_cache_hierarchy: all_http_in_cache_hierarchy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        :param allow_cloudlets_origins: allow_cloudlets_origins block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        :param allow_delete: allow_delete block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        :param allow_https_cache_key_sharing: allow_https_cache_key_sharing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        :param allow_https_downgrade: allow_https_downgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_options: allow_options block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        :param allow_patch: allow_patch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        :param allow_post: allow_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        :param allow_put: allow_put block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        :param allow_transfer_encoding: allow_transfer_encoding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        :param alt_svc_header: alt_svc_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        :param api_prioritization: api_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        :param application_load_balancer: application_load_balancer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        :param audience_segmentation: audience_segmentation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        :param auto_domain_validation: auto_domain_validation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        :param base_directory: base_directory block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        :param boss_beaconing: boss_beaconing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        :param breadcrumbs: breadcrumbs block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        :param break_connection: break_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        :param brotli: brotli block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        :param cache_error: cache_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        :param cache_id: cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        :param cache_key_ignore_case: cache_key_ignore_case block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        :param cache_key_query_params: cache_key_query_params block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        :param cache_key_rewrite: cache_key_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        :param cache_post: cache_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        :param cache_redirect: cache_redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        :param cache_tag: cache_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        :param cache_tag_visible: cache_tag_visible block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        :param caching: caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param central_authorization: central_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        :param chase_redirects: chase_redirects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        :param client_certificate_auth: client_certificate_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_auth DataAkamaiPropertyRulesBuilder#client_certificate_auth}
        :param client_characteristics: client_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        :param cloud_interconnects: cloud_interconnects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        :param cloud_wrapper: cloud_wrapper block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        :param cloud_wrapper_advanced: cloud_wrapper_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        :param common_media_client_data: common_media_client_data block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        :param conditional_origin: conditional_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        :param construct_response: construct_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        :param content_characteristics: content_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        :param content_characteristics_amd: content_characteristics_amd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        :param content_characteristics_dd: content_characteristics_dd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        :param content_characteristics_wsd_large_file: content_characteristics_wsd_large_file block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        :param content_characteristics_wsd_live: content_characteristics_wsd_live block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        :param content_characteristics_wsd_vod: content_characteristics_wsd_vod block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        :param content_pre_position: content_pre_position block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        :param content_targeting_protection: content_targeting_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        :param cors_support: cors_support block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param custom_behavior: custom_behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        :param datastream: datastream block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        :param dcp: dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        :param dcp_auth_hmac_transformation: dcp_auth_hmac_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        :param dcp_auth_regex_transformation: dcp_auth_regex_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        :param dcp_auth_substring_transformation: dcp_auth_substring_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        :param dcp_auth_variable_extractor: dcp_auth_variable_extractor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        :param dcp_default_authz_groups: dcp_default_authz_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        :param dcp_dev_relations: dcp_dev_relations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        :param dcp_real_time_auth: dcp_real_time_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        :param delivery_receipt: delivery_receipt block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        :param deny_access: deny_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        :param deny_direct_failover_access: deny_direct_failover_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        :param device_characteristic_cache_id: device_characteristic_cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        :param device_characteristic_header: device_characteristic_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        :param dns_async_refresh: dns_async_refresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        :param dns_prefresh: dns_prefresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        :param downgrade_protocol: downgrade_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        :param download_complete_marker: download_complete_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        :param download_notification: download_notification block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        :param downstream_cache: downstream_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        :param dynamic_throughtput_optimization: dynamic_throughtput_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        :param dynamic_throughtput_optimization_override: dynamic_throughtput_optimization_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        :param dynamic_web_content: dynamic_web_content block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param ecms_bulk_upload: ecms_bulk_upload block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        :param ecms_database: ecms_database block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        :param ecms_dataset: ecms_dataset block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        :param ecms_object_key: ecms_object_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        :param edge_connect: edge_connect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        :param edge_load_balancing_advanced: edge_load_balancing_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        :param edge_load_balancing_data_center: edge_load_balancing_data_center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        :param edge_load_balancing_origin: edge_load_balancing_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        :param edge_origin_authorization: edge_origin_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        :param edge_redirector: edge_redirector block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        :param edge_scape: edge_scape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        :param edge_side_includes: edge_side_includes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        :param edge_worker: edge_worker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        :param enforce_mtls_settings: enforce_mtls_settings block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls_settings DataAkamaiPropertyRulesBuilder#enforce_mtls_settings}
        :param enhanced_akamai_protocol: enhanced_akamai_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        :param enhanced_proxy_detection: enhanced_proxy_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        :param epd_forward_header_enrichment: epd_forward_header_enrichment block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        :param fail_action: fail_action block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        :param failover_bot_manager_feature_compatibility: failover_bot_manager_feature_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        :param fast_invalidate: fast_invalidate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        :param fips: fips block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fips DataAkamaiPropertyRulesBuilder#fips}
        :param first_party_marketing: first_party_marketing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        :param first_party_marketing_plus: first_party_marketing_plus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        :param forward_rewrite: forward_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        :param g2_oheader: g2oheader block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        :param global_request_number: global_request_number block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        :param graphql_caching: graphql_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        :param gzip_response: gzip_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        :param hd_data_advanced: hd_data_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        :param health_detection: health_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        :param hsaf_eip_binding: hsaf_eip_binding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        :param http2: http2 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        :param http3: http3 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        :param http_strict_transport_security: http_strict_transport_security block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        :param http_to_https_upgrade: http_to_https_upgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        :param image_and_video_manager: image_and_video_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        :param image_manager: image_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        :param image_manager_video: image_manager_video block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        :param im_override: im_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        :param include: include block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        :param instant: instant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        :param instant_config: instant_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        :param large_file_optimization: large_file_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        :param large_file_optimization_advanced: large_file_optimization_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        :param limit_bit_rate: limit_bit_rate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        :param log_custom: log_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        :param manifest_personalization: manifest_personalization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        :param manifest_rerouting: manifest_rerouting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        :param manual_server_push: manual_server_push block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        :param media_acceleration: media_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        :param media_acceleration_quic_optout: media_acceleration_quic_optout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        :param media_client: media_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        :param media_file_retrieval_optimization: media_file_retrieval_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        :param media_origin_failover: media_origin_failover block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        :param metadata_caching: metadata_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        :param mobile_sdk_performance: mobile_sdk_performance block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        :param modify_incoming_request_header: modify_incoming_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        :param modify_incoming_response_header: modify_incoming_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        :param modify_outgoing_request_header: modify_outgoing_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        :param modify_outgoing_response_header: modify_outgoing_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        :param modify_via_header: modify_via_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        :param m_pulse: m_pulse block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param origin: origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param origin_characteristics: origin_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        :param origin_characteristics_wsd: origin_characteristics_wsd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        :param origin_failure_recovery_method: origin_failure_recovery_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        :param origin_failure_recovery_policy: origin_failure_recovery_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        :param origin_ip_acl: origin_ip_acl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        :param permissions_policy: permissions_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy DataAkamaiPropertyRulesBuilder#permissions_policy}
        :param persistent_client_connection: persistent_client_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        :param persistent_connection: persistent_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        :param personally_identifiable_information: personally_identifiable_information block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        :param phased_release: phased_release block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        :param preconnect: preconnect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        :param predictive_content_delivery: predictive_content_delivery block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        :param predictive_prefetching: predictive_prefetching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        :param prefetch: prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param prefetchable: prefetchable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        :param prefresh_cache: prefresh_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        :param quality: quality block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        :param quic_beta: quic_beta block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        :param random_seek: random_seek block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        :param rapid: rapid block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        :param read_timeout: read_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        :param real_time_reporting: real_time_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        :param real_user_monitoring: real_user_monitoring block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param redirect: redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirectplus: redirectplus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        :param referer_checking: referer_checking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        :param remove_query_parameter: remove_query_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        :param remove_vary: remove_vary block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        :param report: report block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        :param request_client_hints: request_client_hints block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_client_hints DataAkamaiPropertyRulesBuilder#request_client_hints}
        :param request_control: request_control block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        :param request_type_marker: request_type_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        :param resource_optimizer: resource_optimizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        :param resource_optimizer_extended_compatibility: resource_optimizer_extended_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        :param response_code: response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param response_cookie: response_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        :param restrict_object_caching: restrict_object_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        :param return_cache_status: return_cache_status block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        :param rewrite_url: rewrite_url block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        :param rum_custom: rum_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        :param saas_definitions: saas_definitions block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        :param sales_force_commerce_cloud_client: sales_force_commerce_cloud_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        :param sales_force_commerce_cloud_provider: sales_force_commerce_cloud_provider block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        :param sales_force_commerce_cloud_provider_host_header: sales_force_commerce_cloud_provider_host_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        :param save_post_dca_processing: save_post_dca_processing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        :param schedule_invalidation: schedule_invalidation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        :param script_management: script_management block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        :param segmented_content_protection: segmented_content_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        :param segmented_media_optimization: segmented_media_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        :param segmented_media_streaming_prefetch: segmented_media_streaming_prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        :param set_variable: set_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        :param simulate_error_code: simulate_error_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        :param site_shield: site_shield block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        :param standard_tls_migration: standard_tls_migration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        :param standard_tls_migration_override: standard_tls_migration_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        :param strict_header_parsing: strict_header_parsing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        :param sub_customer: sub_customer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        :param sure_route: sure_route block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param tcp_optimization: tcp_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        :param tea_leaf: tea_leaf block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        :param tiered_distribution: tiered_distribution block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        :param tiered_distribution_advanced: tiered_distribution_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        :param tiered_distribution_customization: tiered_distribution_customization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        :param timeout: timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uid_configuration: uid_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        :param validate_entity_tag: validate_entity_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        :param verify_json_web_token: verify_json_web_token block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        :param verify_json_web_token_for_dcp: verify_json_web_token_for_dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        :param verify_token_authorization: verify_token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        :param virtual_waiting_room: virtual_waiting_room block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        :param virtual_waiting_room_with_edge_workers: virtual_waiting_room_with_edge_workers block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        :param visitor_prioritization: visitor_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        :param visitor_prioritization_fifo: visitor_prioritization_fifo block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        :param visitor_prioritization_fifo_standalone: visitor_prioritization_fifo_standalone block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        :param watermarking: watermarking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        :param web_application_firewall: web_application_firewall block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        :param webdav: webdav block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        :param web_sockets: web_sockets block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        if isinstance(adaptive_acceleration, dict):
            adaptive_acceleration = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration(**adaptive_acceleration)
        if isinstance(adaptive_image_compression, dict):
            adaptive_image_compression = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression(**adaptive_image_compression)
        if isinstance(ad_scaler_circuit_breaker, dict):
            ad_scaler_circuit_breaker = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker(**ad_scaler_circuit_breaker)
        if isinstance(advanced, dict):
            advanced = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced(**advanced)
        if isinstance(aggregated_reporting, dict):
            aggregated_reporting = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting(**aggregated_reporting)
        if isinstance(akamaizer, dict):
            akamaizer = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer(**akamaizer)
        if isinstance(akamaizer_tag, dict):
            akamaizer_tag = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag(**akamaizer_tag)
        if isinstance(all_http_in_cache_hierarchy, dict):
            all_http_in_cache_hierarchy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy(**all_http_in_cache_hierarchy)
        if isinstance(allow_cloudlets_origins, dict):
            allow_cloudlets_origins = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins(**allow_cloudlets_origins)
        if isinstance(allow_delete, dict):
            allow_delete = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete(**allow_delete)
        if isinstance(allow_https_cache_key_sharing, dict):
            allow_https_cache_key_sharing = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing(**allow_https_cache_key_sharing)
        if isinstance(allow_https_downgrade, dict):
            allow_https_downgrade = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade(**allow_https_downgrade)
        if isinstance(allow_options, dict):
            allow_options = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions(**allow_options)
        if isinstance(allow_patch, dict):
            allow_patch = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch(**allow_patch)
        if isinstance(allow_post, dict):
            allow_post = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost(**allow_post)
        if isinstance(allow_put, dict):
            allow_put = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut(**allow_put)
        if isinstance(allow_transfer_encoding, dict):
            allow_transfer_encoding = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding(**allow_transfer_encoding)
        if isinstance(alt_svc_header, dict):
            alt_svc_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader(**alt_svc_header)
        if isinstance(api_prioritization, dict):
            api_prioritization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization(**api_prioritization)
        if isinstance(application_load_balancer, dict):
            application_load_balancer = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer(**application_load_balancer)
        if isinstance(audience_segmentation, dict):
            audience_segmentation = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation(**audience_segmentation)
        if isinstance(auto_domain_validation, dict):
            auto_domain_validation = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation(**auto_domain_validation)
        if isinstance(base_directory, dict):
            base_directory = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory(**base_directory)
        if isinstance(boss_beaconing, dict):
            boss_beaconing = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing(**boss_beaconing)
        if isinstance(breadcrumbs, dict):
            breadcrumbs = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs(**breadcrumbs)
        if isinstance(break_connection, dict):
            break_connection = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection(**break_connection)
        if isinstance(brotli, dict):
            brotli = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli(**brotli)
        if isinstance(cache_error, dict):
            cache_error = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError(**cache_error)
        if isinstance(cache_id, dict):
            cache_id = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId(**cache_id)
        if isinstance(cache_key_ignore_case, dict):
            cache_key_ignore_case = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase(**cache_key_ignore_case)
        if isinstance(cache_key_query_params, dict):
            cache_key_query_params = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams(**cache_key_query_params)
        if isinstance(cache_key_rewrite, dict):
            cache_key_rewrite = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite(**cache_key_rewrite)
        if isinstance(cache_post, dict):
            cache_post = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost(**cache_post)
        if isinstance(cache_redirect, dict):
            cache_redirect = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect(**cache_redirect)
        if isinstance(cache_tag, dict):
            cache_tag = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag(**cache_tag)
        if isinstance(cache_tag_visible, dict):
            cache_tag_visible = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible(**cache_tag_visible)
        if isinstance(caching, dict):
            caching = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching(**caching)
        if isinstance(central_authorization, dict):
            central_authorization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization(**central_authorization)
        if isinstance(chase_redirects, dict):
            chase_redirects = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects(**chase_redirects)
        if isinstance(client_certificate_auth, dict):
            client_certificate_auth = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth(**client_certificate_auth)
        if isinstance(client_characteristics, dict):
            client_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics(**client_characteristics)
        if isinstance(cloud_interconnects, dict):
            cloud_interconnects = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects(**cloud_interconnects)
        if isinstance(cloud_wrapper, dict):
            cloud_wrapper = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper(**cloud_wrapper)
        if isinstance(cloud_wrapper_advanced, dict):
            cloud_wrapper_advanced = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced(**cloud_wrapper_advanced)
        if isinstance(common_media_client_data, dict):
            common_media_client_data = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData(**common_media_client_data)
        if isinstance(conditional_origin, dict):
            conditional_origin = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin(**conditional_origin)
        if isinstance(construct_response, dict):
            construct_response = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse(**construct_response)
        if isinstance(content_characteristics, dict):
            content_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics(**content_characteristics)
        if isinstance(content_characteristics_amd, dict):
            content_characteristics_amd = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd(**content_characteristics_amd)
        if isinstance(content_characteristics_dd, dict):
            content_characteristics_dd = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd(**content_characteristics_dd)
        if isinstance(content_characteristics_wsd_large_file, dict):
            content_characteristics_wsd_large_file = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile(**content_characteristics_wsd_large_file)
        if isinstance(content_characteristics_wsd_live, dict):
            content_characteristics_wsd_live = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive(**content_characteristics_wsd_live)
        if isinstance(content_characteristics_wsd_vod, dict):
            content_characteristics_wsd_vod = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod(**content_characteristics_wsd_vod)
        if isinstance(content_pre_position, dict):
            content_pre_position = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition(**content_pre_position)
        if isinstance(content_targeting_protection, dict):
            content_targeting_protection = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection(**content_targeting_protection)
        if isinstance(cors_support, dict):
            cors_support = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport(**cors_support)
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode(**cp_code)
        if isinstance(custom_behavior, dict):
            custom_behavior = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior(**custom_behavior)
        if isinstance(datastream, dict):
            datastream = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream(**datastream)
        if isinstance(dcp, dict):
            dcp = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp(**dcp)
        if isinstance(dcp_auth_hmac_transformation, dict):
            dcp_auth_hmac_transformation = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation(**dcp_auth_hmac_transformation)
        if isinstance(dcp_auth_regex_transformation, dict):
            dcp_auth_regex_transformation = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation(**dcp_auth_regex_transformation)
        if isinstance(dcp_auth_substring_transformation, dict):
            dcp_auth_substring_transformation = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation(**dcp_auth_substring_transformation)
        if isinstance(dcp_auth_variable_extractor, dict):
            dcp_auth_variable_extractor = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor(**dcp_auth_variable_extractor)
        if isinstance(dcp_default_authz_groups, dict):
            dcp_default_authz_groups = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups(**dcp_default_authz_groups)
        if isinstance(dcp_dev_relations, dict):
            dcp_dev_relations = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations(**dcp_dev_relations)
        if isinstance(dcp_real_time_auth, dict):
            dcp_real_time_auth = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth(**dcp_real_time_auth)
        if isinstance(delivery_receipt, dict):
            delivery_receipt = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt(**delivery_receipt)
        if isinstance(deny_access, dict):
            deny_access = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess(**deny_access)
        if isinstance(deny_direct_failover_access, dict):
            deny_direct_failover_access = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess(**deny_direct_failover_access)
        if isinstance(device_characteristic_cache_id, dict):
            device_characteristic_cache_id = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId(**device_characteristic_cache_id)
        if isinstance(device_characteristic_header, dict):
            device_characteristic_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader(**device_characteristic_header)
        if isinstance(dns_async_refresh, dict):
            dns_async_refresh = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh(**dns_async_refresh)
        if isinstance(dns_prefresh, dict):
            dns_prefresh = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh(**dns_prefresh)
        if isinstance(downgrade_protocol, dict):
            downgrade_protocol = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol(**downgrade_protocol)
        if isinstance(download_complete_marker, dict):
            download_complete_marker = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker(**download_complete_marker)
        if isinstance(download_notification, dict):
            download_notification = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification(**download_notification)
        if isinstance(downstream_cache, dict):
            downstream_cache = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache(**downstream_cache)
        if isinstance(dynamic_throughtput_optimization, dict):
            dynamic_throughtput_optimization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization(**dynamic_throughtput_optimization)
        if isinstance(dynamic_throughtput_optimization_override, dict):
            dynamic_throughtput_optimization_override = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride(**dynamic_throughtput_optimization_override)
        if isinstance(dynamic_web_content, dict):
            dynamic_web_content = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent(**dynamic_web_content)
        if isinstance(ecms_bulk_upload, dict):
            ecms_bulk_upload = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload(**ecms_bulk_upload)
        if isinstance(ecms_database, dict):
            ecms_database = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase(**ecms_database)
        if isinstance(ecms_dataset, dict):
            ecms_dataset = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset(**ecms_dataset)
        if isinstance(ecms_object_key, dict):
            ecms_object_key = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey(**ecms_object_key)
        if isinstance(edge_connect, dict):
            edge_connect = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect(**edge_connect)
        if isinstance(edge_load_balancing_advanced, dict):
            edge_load_balancing_advanced = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced(**edge_load_balancing_advanced)
        if isinstance(edge_load_balancing_data_center, dict):
            edge_load_balancing_data_center = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter(**edge_load_balancing_data_center)
        if isinstance(edge_load_balancing_origin, dict):
            edge_load_balancing_origin = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin(**edge_load_balancing_origin)
        if isinstance(edge_origin_authorization, dict):
            edge_origin_authorization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization(**edge_origin_authorization)
        if isinstance(edge_redirector, dict):
            edge_redirector = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector(**edge_redirector)
        if isinstance(edge_scape, dict):
            edge_scape = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape(**edge_scape)
        if isinstance(edge_side_includes, dict):
            edge_side_includes = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes(**edge_side_includes)
        if isinstance(edge_worker, dict):
            edge_worker = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker(**edge_worker)
        if isinstance(enforce_mtls_settings, dict):
            enforce_mtls_settings = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings(**enforce_mtls_settings)
        if isinstance(enhanced_akamai_protocol, dict):
            enhanced_akamai_protocol = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol(**enhanced_akamai_protocol)
        if isinstance(enhanced_proxy_detection, dict):
            enhanced_proxy_detection = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection(**enhanced_proxy_detection)
        if isinstance(epd_forward_header_enrichment, dict):
            epd_forward_header_enrichment = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment(**epd_forward_header_enrichment)
        if isinstance(fail_action, dict):
            fail_action = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction(**fail_action)
        if isinstance(failover_bot_manager_feature_compatibility, dict):
            failover_bot_manager_feature_compatibility = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility(**failover_bot_manager_feature_compatibility)
        if isinstance(fast_invalidate, dict):
            fast_invalidate = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate(**fast_invalidate)
        if isinstance(fips, dict):
            fips = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips(**fips)
        if isinstance(first_party_marketing, dict):
            first_party_marketing = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing(**first_party_marketing)
        if isinstance(first_party_marketing_plus, dict):
            first_party_marketing_plus = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus(**first_party_marketing_plus)
        if isinstance(forward_rewrite, dict):
            forward_rewrite = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite(**forward_rewrite)
        if isinstance(g2_oheader, dict):
            g2_oheader = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader(**g2_oheader)
        if isinstance(global_request_number, dict):
            global_request_number = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber(**global_request_number)
        if isinstance(graphql_caching, dict):
            graphql_caching = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching(**graphql_caching)
        if isinstance(gzip_response, dict):
            gzip_response = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse(**gzip_response)
        if isinstance(hd_data_advanced, dict):
            hd_data_advanced = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced(**hd_data_advanced)
        if isinstance(health_detection, dict):
            health_detection = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection(**health_detection)
        if isinstance(hsaf_eip_binding, dict):
            hsaf_eip_binding = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding(**hsaf_eip_binding)
        if isinstance(http2, dict):
            http2 = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2(**http2)
        if isinstance(http3, dict):
            http3 = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3(**http3)
        if isinstance(http_strict_transport_security, dict):
            http_strict_transport_security = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity(**http_strict_transport_security)
        if isinstance(http_to_https_upgrade, dict):
            http_to_https_upgrade = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade(**http_to_https_upgrade)
        if isinstance(image_and_video_manager, dict):
            image_and_video_manager = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager(**image_and_video_manager)
        if isinstance(image_manager, dict):
            image_manager = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager(**image_manager)
        if isinstance(image_manager_video, dict):
            image_manager_video = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo(**image_manager_video)
        if isinstance(im_override, dict):
            im_override = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride(**im_override)
        if isinstance(include, dict):
            include = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude(**include)
        if isinstance(instant, dict):
            instant = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant(**instant)
        if isinstance(instant_config, dict):
            instant_config = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig(**instant_config)
        if isinstance(large_file_optimization, dict):
            large_file_optimization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization(**large_file_optimization)
        if isinstance(large_file_optimization_advanced, dict):
            large_file_optimization_advanced = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced(**large_file_optimization_advanced)
        if isinstance(limit_bit_rate, dict):
            limit_bit_rate = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate(**limit_bit_rate)
        if isinstance(log_custom, dict):
            log_custom = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom(**log_custom)
        if isinstance(manifest_personalization, dict):
            manifest_personalization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization(**manifest_personalization)
        if isinstance(manifest_rerouting, dict):
            manifest_rerouting = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting(**manifest_rerouting)
        if isinstance(manual_server_push, dict):
            manual_server_push = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush(**manual_server_push)
        if isinstance(media_acceleration, dict):
            media_acceleration = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration(**media_acceleration)
        if isinstance(media_acceleration_quic_optout, dict):
            media_acceleration_quic_optout = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout(**media_acceleration_quic_optout)
        if isinstance(media_client, dict):
            media_client = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient(**media_client)
        if isinstance(media_file_retrieval_optimization, dict):
            media_file_retrieval_optimization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization(**media_file_retrieval_optimization)
        if isinstance(media_origin_failover, dict):
            media_origin_failover = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover(**media_origin_failover)
        if isinstance(metadata_caching, dict):
            metadata_caching = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching(**metadata_caching)
        if isinstance(mobile_sdk_performance, dict):
            mobile_sdk_performance = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance(**mobile_sdk_performance)
        if isinstance(modify_incoming_request_header, dict):
            modify_incoming_request_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader(**modify_incoming_request_header)
        if isinstance(modify_incoming_response_header, dict):
            modify_incoming_response_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader(**modify_incoming_response_header)
        if isinstance(modify_outgoing_request_header, dict):
            modify_outgoing_request_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader(**modify_outgoing_request_header)
        if isinstance(modify_outgoing_response_header, dict):
            modify_outgoing_response_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader(**modify_outgoing_response_header)
        if isinstance(modify_via_header, dict):
            modify_via_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader(**modify_via_header)
        if isinstance(m_pulse, dict):
            m_pulse = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse(**m_pulse)
        if isinstance(origin, dict):
            origin = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin(**origin)
        if isinstance(origin_characteristics, dict):
            origin_characteristics = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics(**origin_characteristics)
        if isinstance(origin_characteristics_wsd, dict):
            origin_characteristics_wsd = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd(**origin_characteristics_wsd)
        if isinstance(origin_failure_recovery_method, dict):
            origin_failure_recovery_method = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod(**origin_failure_recovery_method)
        if isinstance(origin_failure_recovery_policy, dict):
            origin_failure_recovery_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy(**origin_failure_recovery_policy)
        if isinstance(origin_ip_acl, dict):
            origin_ip_acl = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl(**origin_ip_acl)
        if isinstance(permissions_policy, dict):
            permissions_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy(**permissions_policy)
        if isinstance(persistent_client_connection, dict):
            persistent_client_connection = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection(**persistent_client_connection)
        if isinstance(persistent_connection, dict):
            persistent_connection = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection(**persistent_connection)
        if isinstance(personally_identifiable_information, dict):
            personally_identifiable_information = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation(**personally_identifiable_information)
        if isinstance(phased_release, dict):
            phased_release = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease(**phased_release)
        if isinstance(preconnect, dict):
            preconnect = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect(**preconnect)
        if isinstance(predictive_content_delivery, dict):
            predictive_content_delivery = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery(**predictive_content_delivery)
        if isinstance(predictive_prefetching, dict):
            predictive_prefetching = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching(**predictive_prefetching)
        if isinstance(prefetch, dict):
            prefetch = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch(**prefetch)
        if isinstance(prefetchable, dict):
            prefetchable = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable(**prefetchable)
        if isinstance(prefresh_cache, dict):
            prefresh_cache = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache(**prefresh_cache)
        if isinstance(quality, dict):
            quality = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality(**quality)
        if isinstance(quic_beta, dict):
            quic_beta = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta(**quic_beta)
        if isinstance(random_seek, dict):
            random_seek = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek(**random_seek)
        if isinstance(rapid, dict):
            rapid = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid(**rapid)
        if isinstance(read_timeout, dict):
            read_timeout = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout(**read_timeout)
        if isinstance(real_time_reporting, dict):
            real_time_reporting = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting(**real_time_reporting)
        if isinstance(real_user_monitoring, dict):
            real_user_monitoring = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring(**real_user_monitoring)
        if isinstance(redirect, dict):
            redirect = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect(**redirect)
        if isinstance(redirectplus, dict):
            redirectplus = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus(**redirectplus)
        if isinstance(referer_checking, dict):
            referer_checking = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking(**referer_checking)
        if isinstance(remove_query_parameter, dict):
            remove_query_parameter = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter(**remove_query_parameter)
        if isinstance(remove_vary, dict):
            remove_vary = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary(**remove_vary)
        if isinstance(report, dict):
            report = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport(**report)
        if isinstance(request_client_hints, dict):
            request_client_hints = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints(**request_client_hints)
        if isinstance(request_control, dict):
            request_control = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl(**request_control)
        if isinstance(request_type_marker, dict):
            request_type_marker = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker(**request_type_marker)
        if isinstance(resource_optimizer, dict):
            resource_optimizer = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer(**resource_optimizer)
        if isinstance(resource_optimizer_extended_compatibility, dict):
            resource_optimizer_extended_compatibility = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility(**resource_optimizer_extended_compatibility)
        if isinstance(response_code, dict):
            response_code = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode(**response_code)
        if isinstance(response_cookie, dict):
            response_cookie = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie(**response_cookie)
        if isinstance(restrict_object_caching, dict):
            restrict_object_caching = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching(**restrict_object_caching)
        if isinstance(return_cache_status, dict):
            return_cache_status = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus(**return_cache_status)
        if isinstance(rewrite_url, dict):
            rewrite_url = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl(**rewrite_url)
        if isinstance(rum_custom, dict):
            rum_custom = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom(**rum_custom)
        if isinstance(saas_definitions, dict):
            saas_definitions = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions(**saas_definitions)
        if isinstance(sales_force_commerce_cloud_client, dict):
            sales_force_commerce_cloud_client = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient(**sales_force_commerce_cloud_client)
        if isinstance(sales_force_commerce_cloud_provider, dict):
            sales_force_commerce_cloud_provider = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider(**sales_force_commerce_cloud_provider)
        if isinstance(sales_force_commerce_cloud_provider_host_header, dict):
            sales_force_commerce_cloud_provider_host_header = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader(**sales_force_commerce_cloud_provider_host_header)
        if isinstance(save_post_dca_processing, dict):
            save_post_dca_processing = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing(**save_post_dca_processing)
        if isinstance(schedule_invalidation, dict):
            schedule_invalidation = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation(**schedule_invalidation)
        if isinstance(script_management, dict):
            script_management = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement(**script_management)
        if isinstance(segmented_content_protection, dict):
            segmented_content_protection = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection(**segmented_content_protection)
        if isinstance(segmented_media_optimization, dict):
            segmented_media_optimization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization(**segmented_media_optimization)
        if isinstance(segmented_media_streaming_prefetch, dict):
            segmented_media_streaming_prefetch = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch(**segmented_media_streaming_prefetch)
        if isinstance(set_variable, dict):
            set_variable = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable(**set_variable)
        if isinstance(simulate_error_code, dict):
            simulate_error_code = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode(**simulate_error_code)
        if isinstance(site_shield, dict):
            site_shield = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield(**site_shield)
        if isinstance(standard_tls_migration, dict):
            standard_tls_migration = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration(**standard_tls_migration)
        if isinstance(standard_tls_migration_override, dict):
            standard_tls_migration_override = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride(**standard_tls_migration_override)
        if isinstance(strict_header_parsing, dict):
            strict_header_parsing = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing(**strict_header_parsing)
        if isinstance(sub_customer, dict):
            sub_customer = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer(**sub_customer)
        if isinstance(sure_route, dict):
            sure_route = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute(**sure_route)
        if isinstance(tcp_optimization, dict):
            tcp_optimization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization(**tcp_optimization)
        if isinstance(tea_leaf, dict):
            tea_leaf = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf(**tea_leaf)
        if isinstance(tiered_distribution, dict):
            tiered_distribution = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution(**tiered_distribution)
        if isinstance(tiered_distribution_advanced, dict):
            tiered_distribution_advanced = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced(**tiered_distribution_advanced)
        if isinstance(tiered_distribution_customization, dict):
            tiered_distribution_customization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization(**tiered_distribution_customization)
        if isinstance(timeout, dict):
            timeout = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout(**timeout)
        if isinstance(uid_configuration, dict):
            uid_configuration = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration(**uid_configuration)
        if isinstance(validate_entity_tag, dict):
            validate_entity_tag = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag(**validate_entity_tag)
        if isinstance(verify_json_web_token, dict):
            verify_json_web_token = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken(**verify_json_web_token)
        if isinstance(verify_json_web_token_for_dcp, dict):
            verify_json_web_token_for_dcp = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp(**verify_json_web_token_for_dcp)
        if isinstance(verify_token_authorization, dict):
            verify_token_authorization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization(**verify_token_authorization)
        if isinstance(virtual_waiting_room, dict):
            virtual_waiting_room = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom(**virtual_waiting_room)
        if isinstance(virtual_waiting_room_with_edge_workers, dict):
            virtual_waiting_room_with_edge_workers = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers(**virtual_waiting_room_with_edge_workers)
        if isinstance(visitor_prioritization, dict):
            visitor_prioritization = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization(**visitor_prioritization)
        if isinstance(visitor_prioritization_fifo, dict):
            visitor_prioritization_fifo = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo(**visitor_prioritization_fifo)
        if isinstance(visitor_prioritization_fifo_standalone, dict):
            visitor_prioritization_fifo_standalone = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone(**visitor_prioritization_fifo_standalone)
        if isinstance(watermarking, dict):
            watermarking = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking(**watermarking)
        if isinstance(web_application_firewall, dict):
            web_application_firewall = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall(**web_application_firewall)
        if isinstance(webdav, dict):
            webdav = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav(**webdav)
        if isinstance(web_sockets, dict):
            web_sockets = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets(**web_sockets)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c8b49b5fcba06c7e8d7f7a66f97e6e4fb0a1dba46eeb769b56d0ffc28f57c11)
            check_type(argname="argument adaptive_acceleration", value=adaptive_acceleration, expected_type=type_hints["adaptive_acceleration"])
            check_type(argname="argument adaptive_image_compression", value=adaptive_image_compression, expected_type=type_hints["adaptive_image_compression"])
            check_type(argname="argument ad_scaler_circuit_breaker", value=ad_scaler_circuit_breaker, expected_type=type_hints["ad_scaler_circuit_breaker"])
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument aggregated_reporting", value=aggregated_reporting, expected_type=type_hints["aggregated_reporting"])
            check_type(argname="argument akamaizer", value=akamaizer, expected_type=type_hints["akamaizer"])
            check_type(argname="argument akamaizer_tag", value=akamaizer_tag, expected_type=type_hints["akamaizer_tag"])
            check_type(argname="argument all_http_in_cache_hierarchy", value=all_http_in_cache_hierarchy, expected_type=type_hints["all_http_in_cache_hierarchy"])
            check_type(argname="argument allow_cloudlets_origins", value=allow_cloudlets_origins, expected_type=type_hints["allow_cloudlets_origins"])
            check_type(argname="argument allow_delete", value=allow_delete, expected_type=type_hints["allow_delete"])
            check_type(argname="argument allow_https_cache_key_sharing", value=allow_https_cache_key_sharing, expected_type=type_hints["allow_https_cache_key_sharing"])
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_options", value=allow_options, expected_type=type_hints["allow_options"])
            check_type(argname="argument allow_patch", value=allow_patch, expected_type=type_hints["allow_patch"])
            check_type(argname="argument allow_post", value=allow_post, expected_type=type_hints["allow_post"])
            check_type(argname="argument allow_put", value=allow_put, expected_type=type_hints["allow_put"])
            check_type(argname="argument allow_transfer_encoding", value=allow_transfer_encoding, expected_type=type_hints["allow_transfer_encoding"])
            check_type(argname="argument alt_svc_header", value=alt_svc_header, expected_type=type_hints["alt_svc_header"])
            check_type(argname="argument api_prioritization", value=api_prioritization, expected_type=type_hints["api_prioritization"])
            check_type(argname="argument application_load_balancer", value=application_load_balancer, expected_type=type_hints["application_load_balancer"])
            check_type(argname="argument audience_segmentation", value=audience_segmentation, expected_type=type_hints["audience_segmentation"])
            check_type(argname="argument auto_domain_validation", value=auto_domain_validation, expected_type=type_hints["auto_domain_validation"])
            check_type(argname="argument base_directory", value=base_directory, expected_type=type_hints["base_directory"])
            check_type(argname="argument boss_beaconing", value=boss_beaconing, expected_type=type_hints["boss_beaconing"])
            check_type(argname="argument breadcrumbs", value=breadcrumbs, expected_type=type_hints["breadcrumbs"])
            check_type(argname="argument break_connection", value=break_connection, expected_type=type_hints["break_connection"])
            check_type(argname="argument brotli", value=brotli, expected_type=type_hints["brotli"])
            check_type(argname="argument cache_error", value=cache_error, expected_type=type_hints["cache_error"])
            check_type(argname="argument cache_id", value=cache_id, expected_type=type_hints["cache_id"])
            check_type(argname="argument cache_key_ignore_case", value=cache_key_ignore_case, expected_type=type_hints["cache_key_ignore_case"])
            check_type(argname="argument cache_key_query_params", value=cache_key_query_params, expected_type=type_hints["cache_key_query_params"])
            check_type(argname="argument cache_key_rewrite", value=cache_key_rewrite, expected_type=type_hints["cache_key_rewrite"])
            check_type(argname="argument cache_post", value=cache_post, expected_type=type_hints["cache_post"])
            check_type(argname="argument cache_redirect", value=cache_redirect, expected_type=type_hints["cache_redirect"])
            check_type(argname="argument cache_tag", value=cache_tag, expected_type=type_hints["cache_tag"])
            check_type(argname="argument cache_tag_visible", value=cache_tag_visible, expected_type=type_hints["cache_tag_visible"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument central_authorization", value=central_authorization, expected_type=type_hints["central_authorization"])
            check_type(argname="argument chase_redirects", value=chase_redirects, expected_type=type_hints["chase_redirects"])
            check_type(argname="argument client_certificate_auth", value=client_certificate_auth, expected_type=type_hints["client_certificate_auth"])
            check_type(argname="argument client_characteristics", value=client_characteristics, expected_type=type_hints["client_characteristics"])
            check_type(argname="argument cloud_interconnects", value=cloud_interconnects, expected_type=type_hints["cloud_interconnects"])
            check_type(argname="argument cloud_wrapper", value=cloud_wrapper, expected_type=type_hints["cloud_wrapper"])
            check_type(argname="argument cloud_wrapper_advanced", value=cloud_wrapper_advanced, expected_type=type_hints["cloud_wrapper_advanced"])
            check_type(argname="argument common_media_client_data", value=common_media_client_data, expected_type=type_hints["common_media_client_data"])
            check_type(argname="argument conditional_origin", value=conditional_origin, expected_type=type_hints["conditional_origin"])
            check_type(argname="argument construct_response", value=construct_response, expected_type=type_hints["construct_response"])
            check_type(argname="argument content_characteristics", value=content_characteristics, expected_type=type_hints["content_characteristics"])
            check_type(argname="argument content_characteristics_amd", value=content_characteristics_amd, expected_type=type_hints["content_characteristics_amd"])
            check_type(argname="argument content_characteristics_dd", value=content_characteristics_dd, expected_type=type_hints["content_characteristics_dd"])
            check_type(argname="argument content_characteristics_wsd_large_file", value=content_characteristics_wsd_large_file, expected_type=type_hints["content_characteristics_wsd_large_file"])
            check_type(argname="argument content_characteristics_wsd_live", value=content_characteristics_wsd_live, expected_type=type_hints["content_characteristics_wsd_live"])
            check_type(argname="argument content_characteristics_wsd_vod", value=content_characteristics_wsd_vod, expected_type=type_hints["content_characteristics_wsd_vod"])
            check_type(argname="argument content_pre_position", value=content_pre_position, expected_type=type_hints["content_pre_position"])
            check_type(argname="argument content_targeting_protection", value=content_targeting_protection, expected_type=type_hints["content_targeting_protection"])
            check_type(argname="argument cors_support", value=cors_support, expected_type=type_hints["cors_support"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument custom_behavior", value=custom_behavior, expected_type=type_hints["custom_behavior"])
            check_type(argname="argument datastream", value=datastream, expected_type=type_hints["datastream"])
            check_type(argname="argument dcp", value=dcp, expected_type=type_hints["dcp"])
            check_type(argname="argument dcp_auth_hmac_transformation", value=dcp_auth_hmac_transformation, expected_type=type_hints["dcp_auth_hmac_transformation"])
            check_type(argname="argument dcp_auth_regex_transformation", value=dcp_auth_regex_transformation, expected_type=type_hints["dcp_auth_regex_transformation"])
            check_type(argname="argument dcp_auth_substring_transformation", value=dcp_auth_substring_transformation, expected_type=type_hints["dcp_auth_substring_transformation"])
            check_type(argname="argument dcp_auth_variable_extractor", value=dcp_auth_variable_extractor, expected_type=type_hints["dcp_auth_variable_extractor"])
            check_type(argname="argument dcp_default_authz_groups", value=dcp_default_authz_groups, expected_type=type_hints["dcp_default_authz_groups"])
            check_type(argname="argument dcp_dev_relations", value=dcp_dev_relations, expected_type=type_hints["dcp_dev_relations"])
            check_type(argname="argument dcp_real_time_auth", value=dcp_real_time_auth, expected_type=type_hints["dcp_real_time_auth"])
            check_type(argname="argument delivery_receipt", value=delivery_receipt, expected_type=type_hints["delivery_receipt"])
            check_type(argname="argument deny_access", value=deny_access, expected_type=type_hints["deny_access"])
            check_type(argname="argument deny_direct_failover_access", value=deny_direct_failover_access, expected_type=type_hints["deny_direct_failover_access"])
            check_type(argname="argument device_characteristic_cache_id", value=device_characteristic_cache_id, expected_type=type_hints["device_characteristic_cache_id"])
            check_type(argname="argument device_characteristic_header", value=device_characteristic_header, expected_type=type_hints["device_characteristic_header"])
            check_type(argname="argument dns_async_refresh", value=dns_async_refresh, expected_type=type_hints["dns_async_refresh"])
            check_type(argname="argument dns_prefresh", value=dns_prefresh, expected_type=type_hints["dns_prefresh"])
            check_type(argname="argument downgrade_protocol", value=downgrade_protocol, expected_type=type_hints["downgrade_protocol"])
            check_type(argname="argument download_complete_marker", value=download_complete_marker, expected_type=type_hints["download_complete_marker"])
            check_type(argname="argument download_notification", value=download_notification, expected_type=type_hints["download_notification"])
            check_type(argname="argument downstream_cache", value=downstream_cache, expected_type=type_hints["downstream_cache"])
            check_type(argname="argument dynamic_throughtput_optimization", value=dynamic_throughtput_optimization, expected_type=type_hints["dynamic_throughtput_optimization"])
            check_type(argname="argument dynamic_throughtput_optimization_override", value=dynamic_throughtput_optimization_override, expected_type=type_hints["dynamic_throughtput_optimization_override"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument ecms_bulk_upload", value=ecms_bulk_upload, expected_type=type_hints["ecms_bulk_upload"])
            check_type(argname="argument ecms_database", value=ecms_database, expected_type=type_hints["ecms_database"])
            check_type(argname="argument ecms_dataset", value=ecms_dataset, expected_type=type_hints["ecms_dataset"])
            check_type(argname="argument ecms_object_key", value=ecms_object_key, expected_type=type_hints["ecms_object_key"])
            check_type(argname="argument edge_connect", value=edge_connect, expected_type=type_hints["edge_connect"])
            check_type(argname="argument edge_load_balancing_advanced", value=edge_load_balancing_advanced, expected_type=type_hints["edge_load_balancing_advanced"])
            check_type(argname="argument edge_load_balancing_data_center", value=edge_load_balancing_data_center, expected_type=type_hints["edge_load_balancing_data_center"])
            check_type(argname="argument edge_load_balancing_origin", value=edge_load_balancing_origin, expected_type=type_hints["edge_load_balancing_origin"])
            check_type(argname="argument edge_origin_authorization", value=edge_origin_authorization, expected_type=type_hints["edge_origin_authorization"])
            check_type(argname="argument edge_redirector", value=edge_redirector, expected_type=type_hints["edge_redirector"])
            check_type(argname="argument edge_scape", value=edge_scape, expected_type=type_hints["edge_scape"])
            check_type(argname="argument edge_side_includes", value=edge_side_includes, expected_type=type_hints["edge_side_includes"])
            check_type(argname="argument edge_worker", value=edge_worker, expected_type=type_hints["edge_worker"])
            check_type(argname="argument enforce_mtls_settings", value=enforce_mtls_settings, expected_type=type_hints["enforce_mtls_settings"])
            check_type(argname="argument enhanced_akamai_protocol", value=enhanced_akamai_protocol, expected_type=type_hints["enhanced_akamai_protocol"])
            check_type(argname="argument enhanced_proxy_detection", value=enhanced_proxy_detection, expected_type=type_hints["enhanced_proxy_detection"])
            check_type(argname="argument epd_forward_header_enrichment", value=epd_forward_header_enrichment, expected_type=type_hints["epd_forward_header_enrichment"])
            check_type(argname="argument fail_action", value=fail_action, expected_type=type_hints["fail_action"])
            check_type(argname="argument failover_bot_manager_feature_compatibility", value=failover_bot_manager_feature_compatibility, expected_type=type_hints["failover_bot_manager_feature_compatibility"])
            check_type(argname="argument fast_invalidate", value=fast_invalidate, expected_type=type_hints["fast_invalidate"])
            check_type(argname="argument fips", value=fips, expected_type=type_hints["fips"])
            check_type(argname="argument first_party_marketing", value=first_party_marketing, expected_type=type_hints["first_party_marketing"])
            check_type(argname="argument first_party_marketing_plus", value=first_party_marketing_plus, expected_type=type_hints["first_party_marketing_plus"])
            check_type(argname="argument forward_rewrite", value=forward_rewrite, expected_type=type_hints["forward_rewrite"])
            check_type(argname="argument g2_oheader", value=g2_oheader, expected_type=type_hints["g2_oheader"])
            check_type(argname="argument global_request_number", value=global_request_number, expected_type=type_hints["global_request_number"])
            check_type(argname="argument graphql_caching", value=graphql_caching, expected_type=type_hints["graphql_caching"])
            check_type(argname="argument gzip_response", value=gzip_response, expected_type=type_hints["gzip_response"])
            check_type(argname="argument hd_data_advanced", value=hd_data_advanced, expected_type=type_hints["hd_data_advanced"])
            check_type(argname="argument health_detection", value=health_detection, expected_type=type_hints["health_detection"])
            check_type(argname="argument hsaf_eip_binding", value=hsaf_eip_binding, expected_type=type_hints["hsaf_eip_binding"])
            check_type(argname="argument http2", value=http2, expected_type=type_hints["http2"])
            check_type(argname="argument http3", value=http3, expected_type=type_hints["http3"])
            check_type(argname="argument http_strict_transport_security", value=http_strict_transport_security, expected_type=type_hints["http_strict_transport_security"])
            check_type(argname="argument http_to_https_upgrade", value=http_to_https_upgrade, expected_type=type_hints["http_to_https_upgrade"])
            check_type(argname="argument image_and_video_manager", value=image_and_video_manager, expected_type=type_hints["image_and_video_manager"])
            check_type(argname="argument image_manager", value=image_manager, expected_type=type_hints["image_manager"])
            check_type(argname="argument image_manager_video", value=image_manager_video, expected_type=type_hints["image_manager_video"])
            check_type(argname="argument im_override", value=im_override, expected_type=type_hints["im_override"])
            check_type(argname="argument include", value=include, expected_type=type_hints["include"])
            check_type(argname="argument instant", value=instant, expected_type=type_hints["instant"])
            check_type(argname="argument instant_config", value=instant_config, expected_type=type_hints["instant_config"])
            check_type(argname="argument large_file_optimization", value=large_file_optimization, expected_type=type_hints["large_file_optimization"])
            check_type(argname="argument large_file_optimization_advanced", value=large_file_optimization_advanced, expected_type=type_hints["large_file_optimization_advanced"])
            check_type(argname="argument limit_bit_rate", value=limit_bit_rate, expected_type=type_hints["limit_bit_rate"])
            check_type(argname="argument log_custom", value=log_custom, expected_type=type_hints["log_custom"])
            check_type(argname="argument manifest_personalization", value=manifest_personalization, expected_type=type_hints["manifest_personalization"])
            check_type(argname="argument manifest_rerouting", value=manifest_rerouting, expected_type=type_hints["manifest_rerouting"])
            check_type(argname="argument manual_server_push", value=manual_server_push, expected_type=type_hints["manual_server_push"])
            check_type(argname="argument media_acceleration", value=media_acceleration, expected_type=type_hints["media_acceleration"])
            check_type(argname="argument media_acceleration_quic_optout", value=media_acceleration_quic_optout, expected_type=type_hints["media_acceleration_quic_optout"])
            check_type(argname="argument media_client", value=media_client, expected_type=type_hints["media_client"])
            check_type(argname="argument media_file_retrieval_optimization", value=media_file_retrieval_optimization, expected_type=type_hints["media_file_retrieval_optimization"])
            check_type(argname="argument media_origin_failover", value=media_origin_failover, expected_type=type_hints["media_origin_failover"])
            check_type(argname="argument metadata_caching", value=metadata_caching, expected_type=type_hints["metadata_caching"])
            check_type(argname="argument mobile_sdk_performance", value=mobile_sdk_performance, expected_type=type_hints["mobile_sdk_performance"])
            check_type(argname="argument modify_incoming_request_header", value=modify_incoming_request_header, expected_type=type_hints["modify_incoming_request_header"])
            check_type(argname="argument modify_incoming_response_header", value=modify_incoming_response_header, expected_type=type_hints["modify_incoming_response_header"])
            check_type(argname="argument modify_outgoing_request_header", value=modify_outgoing_request_header, expected_type=type_hints["modify_outgoing_request_header"])
            check_type(argname="argument modify_outgoing_response_header", value=modify_outgoing_response_header, expected_type=type_hints["modify_outgoing_response_header"])
            check_type(argname="argument modify_via_header", value=modify_via_header, expected_type=type_hints["modify_via_header"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument origin_characteristics", value=origin_characteristics, expected_type=type_hints["origin_characteristics"])
            check_type(argname="argument origin_characteristics_wsd", value=origin_characteristics_wsd, expected_type=type_hints["origin_characteristics_wsd"])
            check_type(argname="argument origin_failure_recovery_method", value=origin_failure_recovery_method, expected_type=type_hints["origin_failure_recovery_method"])
            check_type(argname="argument origin_failure_recovery_policy", value=origin_failure_recovery_policy, expected_type=type_hints["origin_failure_recovery_policy"])
            check_type(argname="argument origin_ip_acl", value=origin_ip_acl, expected_type=type_hints["origin_ip_acl"])
            check_type(argname="argument permissions_policy", value=permissions_policy, expected_type=type_hints["permissions_policy"])
            check_type(argname="argument persistent_client_connection", value=persistent_client_connection, expected_type=type_hints["persistent_client_connection"])
            check_type(argname="argument persistent_connection", value=persistent_connection, expected_type=type_hints["persistent_connection"])
            check_type(argname="argument personally_identifiable_information", value=personally_identifiable_information, expected_type=type_hints["personally_identifiable_information"])
            check_type(argname="argument phased_release", value=phased_release, expected_type=type_hints["phased_release"])
            check_type(argname="argument preconnect", value=preconnect, expected_type=type_hints["preconnect"])
            check_type(argname="argument predictive_content_delivery", value=predictive_content_delivery, expected_type=type_hints["predictive_content_delivery"])
            check_type(argname="argument predictive_prefetching", value=predictive_prefetching, expected_type=type_hints["predictive_prefetching"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument prefetchable", value=prefetchable, expected_type=type_hints["prefetchable"])
            check_type(argname="argument prefresh_cache", value=prefresh_cache, expected_type=type_hints["prefresh_cache"])
            check_type(argname="argument quality", value=quality, expected_type=type_hints["quality"])
            check_type(argname="argument quic_beta", value=quic_beta, expected_type=type_hints["quic_beta"])
            check_type(argname="argument random_seek", value=random_seek, expected_type=type_hints["random_seek"])
            check_type(argname="argument rapid", value=rapid, expected_type=type_hints["rapid"])
            check_type(argname="argument read_timeout", value=read_timeout, expected_type=type_hints["read_timeout"])
            check_type(argname="argument real_time_reporting", value=real_time_reporting, expected_type=type_hints["real_time_reporting"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirectplus", value=redirectplus, expected_type=type_hints["redirectplus"])
            check_type(argname="argument referer_checking", value=referer_checking, expected_type=type_hints["referer_checking"])
            check_type(argname="argument remove_query_parameter", value=remove_query_parameter, expected_type=type_hints["remove_query_parameter"])
            check_type(argname="argument remove_vary", value=remove_vary, expected_type=type_hints["remove_vary"])
            check_type(argname="argument report", value=report, expected_type=type_hints["report"])
            check_type(argname="argument request_client_hints", value=request_client_hints, expected_type=type_hints["request_client_hints"])
            check_type(argname="argument request_control", value=request_control, expected_type=type_hints["request_control"])
            check_type(argname="argument request_type_marker", value=request_type_marker, expected_type=type_hints["request_type_marker"])
            check_type(argname="argument resource_optimizer", value=resource_optimizer, expected_type=type_hints["resource_optimizer"])
            check_type(argname="argument resource_optimizer_extended_compatibility", value=resource_optimizer_extended_compatibility, expected_type=type_hints["resource_optimizer_extended_compatibility"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument response_cookie", value=response_cookie, expected_type=type_hints["response_cookie"])
            check_type(argname="argument restrict_object_caching", value=restrict_object_caching, expected_type=type_hints["restrict_object_caching"])
            check_type(argname="argument return_cache_status", value=return_cache_status, expected_type=type_hints["return_cache_status"])
            check_type(argname="argument rewrite_url", value=rewrite_url, expected_type=type_hints["rewrite_url"])
            check_type(argname="argument rum_custom", value=rum_custom, expected_type=type_hints["rum_custom"])
            check_type(argname="argument saas_definitions", value=saas_definitions, expected_type=type_hints["saas_definitions"])
            check_type(argname="argument sales_force_commerce_cloud_client", value=sales_force_commerce_cloud_client, expected_type=type_hints["sales_force_commerce_cloud_client"])
            check_type(argname="argument sales_force_commerce_cloud_provider", value=sales_force_commerce_cloud_provider, expected_type=type_hints["sales_force_commerce_cloud_provider"])
            check_type(argname="argument sales_force_commerce_cloud_provider_host_header", value=sales_force_commerce_cloud_provider_host_header, expected_type=type_hints["sales_force_commerce_cloud_provider_host_header"])
            check_type(argname="argument save_post_dca_processing", value=save_post_dca_processing, expected_type=type_hints["save_post_dca_processing"])
            check_type(argname="argument schedule_invalidation", value=schedule_invalidation, expected_type=type_hints["schedule_invalidation"])
            check_type(argname="argument script_management", value=script_management, expected_type=type_hints["script_management"])
            check_type(argname="argument segmented_content_protection", value=segmented_content_protection, expected_type=type_hints["segmented_content_protection"])
            check_type(argname="argument segmented_media_optimization", value=segmented_media_optimization, expected_type=type_hints["segmented_media_optimization"])
            check_type(argname="argument segmented_media_streaming_prefetch", value=segmented_media_streaming_prefetch, expected_type=type_hints["segmented_media_streaming_prefetch"])
            check_type(argname="argument set_variable", value=set_variable, expected_type=type_hints["set_variable"])
            check_type(argname="argument simulate_error_code", value=simulate_error_code, expected_type=type_hints["simulate_error_code"])
            check_type(argname="argument site_shield", value=site_shield, expected_type=type_hints["site_shield"])
            check_type(argname="argument standard_tls_migration", value=standard_tls_migration, expected_type=type_hints["standard_tls_migration"])
            check_type(argname="argument standard_tls_migration_override", value=standard_tls_migration_override, expected_type=type_hints["standard_tls_migration_override"])
            check_type(argname="argument strict_header_parsing", value=strict_header_parsing, expected_type=type_hints["strict_header_parsing"])
            check_type(argname="argument sub_customer", value=sub_customer, expected_type=type_hints["sub_customer"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument tcp_optimization", value=tcp_optimization, expected_type=type_hints["tcp_optimization"])
            check_type(argname="argument tea_leaf", value=tea_leaf, expected_type=type_hints["tea_leaf"])
            check_type(argname="argument tiered_distribution", value=tiered_distribution, expected_type=type_hints["tiered_distribution"])
            check_type(argname="argument tiered_distribution_advanced", value=tiered_distribution_advanced, expected_type=type_hints["tiered_distribution_advanced"])
            check_type(argname="argument tiered_distribution_customization", value=tiered_distribution_customization, expected_type=type_hints["tiered_distribution_customization"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uid_configuration", value=uid_configuration, expected_type=type_hints["uid_configuration"])
            check_type(argname="argument validate_entity_tag", value=validate_entity_tag, expected_type=type_hints["validate_entity_tag"])
            check_type(argname="argument verify_json_web_token", value=verify_json_web_token, expected_type=type_hints["verify_json_web_token"])
            check_type(argname="argument verify_json_web_token_for_dcp", value=verify_json_web_token_for_dcp, expected_type=type_hints["verify_json_web_token_for_dcp"])
            check_type(argname="argument verify_token_authorization", value=verify_token_authorization, expected_type=type_hints["verify_token_authorization"])
            check_type(argname="argument virtual_waiting_room", value=virtual_waiting_room, expected_type=type_hints["virtual_waiting_room"])
            check_type(argname="argument virtual_waiting_room_with_edge_workers", value=virtual_waiting_room_with_edge_workers, expected_type=type_hints["virtual_waiting_room_with_edge_workers"])
            check_type(argname="argument visitor_prioritization", value=visitor_prioritization, expected_type=type_hints["visitor_prioritization"])
            check_type(argname="argument visitor_prioritization_fifo", value=visitor_prioritization_fifo, expected_type=type_hints["visitor_prioritization_fifo"])
            check_type(argname="argument visitor_prioritization_fifo_standalone", value=visitor_prioritization_fifo_standalone, expected_type=type_hints["visitor_prioritization_fifo_standalone"])
            check_type(argname="argument watermarking", value=watermarking, expected_type=type_hints["watermarking"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
            check_type(argname="argument webdav", value=webdav, expected_type=type_hints["webdav"])
            check_type(argname="argument web_sockets", value=web_sockets, expected_type=type_hints["web_sockets"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if adaptive_acceleration is not None:
            self._values["adaptive_acceleration"] = adaptive_acceleration
        if adaptive_image_compression is not None:
            self._values["adaptive_image_compression"] = adaptive_image_compression
        if ad_scaler_circuit_breaker is not None:
            self._values["ad_scaler_circuit_breaker"] = ad_scaler_circuit_breaker
        if advanced is not None:
            self._values["advanced"] = advanced
        if aggregated_reporting is not None:
            self._values["aggregated_reporting"] = aggregated_reporting
        if akamaizer is not None:
            self._values["akamaizer"] = akamaizer
        if akamaizer_tag is not None:
            self._values["akamaizer_tag"] = akamaizer_tag
        if all_http_in_cache_hierarchy is not None:
            self._values["all_http_in_cache_hierarchy"] = all_http_in_cache_hierarchy
        if allow_cloudlets_origins is not None:
            self._values["allow_cloudlets_origins"] = allow_cloudlets_origins
        if allow_delete is not None:
            self._values["allow_delete"] = allow_delete
        if allow_https_cache_key_sharing is not None:
            self._values["allow_https_cache_key_sharing"] = allow_https_cache_key_sharing
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_options is not None:
            self._values["allow_options"] = allow_options
        if allow_patch is not None:
            self._values["allow_patch"] = allow_patch
        if allow_post is not None:
            self._values["allow_post"] = allow_post
        if allow_put is not None:
            self._values["allow_put"] = allow_put
        if allow_transfer_encoding is not None:
            self._values["allow_transfer_encoding"] = allow_transfer_encoding
        if alt_svc_header is not None:
            self._values["alt_svc_header"] = alt_svc_header
        if api_prioritization is not None:
            self._values["api_prioritization"] = api_prioritization
        if application_load_balancer is not None:
            self._values["application_load_balancer"] = application_load_balancer
        if audience_segmentation is not None:
            self._values["audience_segmentation"] = audience_segmentation
        if auto_domain_validation is not None:
            self._values["auto_domain_validation"] = auto_domain_validation
        if base_directory is not None:
            self._values["base_directory"] = base_directory
        if boss_beaconing is not None:
            self._values["boss_beaconing"] = boss_beaconing
        if breadcrumbs is not None:
            self._values["breadcrumbs"] = breadcrumbs
        if break_connection is not None:
            self._values["break_connection"] = break_connection
        if brotli is not None:
            self._values["brotli"] = brotli
        if cache_error is not None:
            self._values["cache_error"] = cache_error
        if cache_id is not None:
            self._values["cache_id"] = cache_id
        if cache_key_ignore_case is not None:
            self._values["cache_key_ignore_case"] = cache_key_ignore_case
        if cache_key_query_params is not None:
            self._values["cache_key_query_params"] = cache_key_query_params
        if cache_key_rewrite is not None:
            self._values["cache_key_rewrite"] = cache_key_rewrite
        if cache_post is not None:
            self._values["cache_post"] = cache_post
        if cache_redirect is not None:
            self._values["cache_redirect"] = cache_redirect
        if cache_tag is not None:
            self._values["cache_tag"] = cache_tag
        if cache_tag_visible is not None:
            self._values["cache_tag_visible"] = cache_tag_visible
        if caching is not None:
            self._values["caching"] = caching
        if central_authorization is not None:
            self._values["central_authorization"] = central_authorization
        if chase_redirects is not None:
            self._values["chase_redirects"] = chase_redirects
        if client_certificate_auth is not None:
            self._values["client_certificate_auth"] = client_certificate_auth
        if client_characteristics is not None:
            self._values["client_characteristics"] = client_characteristics
        if cloud_interconnects is not None:
            self._values["cloud_interconnects"] = cloud_interconnects
        if cloud_wrapper is not None:
            self._values["cloud_wrapper"] = cloud_wrapper
        if cloud_wrapper_advanced is not None:
            self._values["cloud_wrapper_advanced"] = cloud_wrapper_advanced
        if common_media_client_data is not None:
            self._values["common_media_client_data"] = common_media_client_data
        if conditional_origin is not None:
            self._values["conditional_origin"] = conditional_origin
        if construct_response is not None:
            self._values["construct_response"] = construct_response
        if content_characteristics is not None:
            self._values["content_characteristics"] = content_characteristics
        if content_characteristics_amd is not None:
            self._values["content_characteristics_amd"] = content_characteristics_amd
        if content_characteristics_dd is not None:
            self._values["content_characteristics_dd"] = content_characteristics_dd
        if content_characteristics_wsd_large_file is not None:
            self._values["content_characteristics_wsd_large_file"] = content_characteristics_wsd_large_file
        if content_characteristics_wsd_live is not None:
            self._values["content_characteristics_wsd_live"] = content_characteristics_wsd_live
        if content_characteristics_wsd_vod is not None:
            self._values["content_characteristics_wsd_vod"] = content_characteristics_wsd_vod
        if content_pre_position is not None:
            self._values["content_pre_position"] = content_pre_position
        if content_targeting_protection is not None:
            self._values["content_targeting_protection"] = content_targeting_protection
        if cors_support is not None:
            self._values["cors_support"] = cors_support
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if custom_behavior is not None:
            self._values["custom_behavior"] = custom_behavior
        if datastream is not None:
            self._values["datastream"] = datastream
        if dcp is not None:
            self._values["dcp"] = dcp
        if dcp_auth_hmac_transformation is not None:
            self._values["dcp_auth_hmac_transformation"] = dcp_auth_hmac_transformation
        if dcp_auth_regex_transformation is not None:
            self._values["dcp_auth_regex_transformation"] = dcp_auth_regex_transformation
        if dcp_auth_substring_transformation is not None:
            self._values["dcp_auth_substring_transformation"] = dcp_auth_substring_transformation
        if dcp_auth_variable_extractor is not None:
            self._values["dcp_auth_variable_extractor"] = dcp_auth_variable_extractor
        if dcp_default_authz_groups is not None:
            self._values["dcp_default_authz_groups"] = dcp_default_authz_groups
        if dcp_dev_relations is not None:
            self._values["dcp_dev_relations"] = dcp_dev_relations
        if dcp_real_time_auth is not None:
            self._values["dcp_real_time_auth"] = dcp_real_time_auth
        if delivery_receipt is not None:
            self._values["delivery_receipt"] = delivery_receipt
        if deny_access is not None:
            self._values["deny_access"] = deny_access
        if deny_direct_failover_access is not None:
            self._values["deny_direct_failover_access"] = deny_direct_failover_access
        if device_characteristic_cache_id is not None:
            self._values["device_characteristic_cache_id"] = device_characteristic_cache_id
        if device_characteristic_header is not None:
            self._values["device_characteristic_header"] = device_characteristic_header
        if dns_async_refresh is not None:
            self._values["dns_async_refresh"] = dns_async_refresh
        if dns_prefresh is not None:
            self._values["dns_prefresh"] = dns_prefresh
        if downgrade_protocol is not None:
            self._values["downgrade_protocol"] = downgrade_protocol
        if download_complete_marker is not None:
            self._values["download_complete_marker"] = download_complete_marker
        if download_notification is not None:
            self._values["download_notification"] = download_notification
        if downstream_cache is not None:
            self._values["downstream_cache"] = downstream_cache
        if dynamic_throughtput_optimization is not None:
            self._values["dynamic_throughtput_optimization"] = dynamic_throughtput_optimization
        if dynamic_throughtput_optimization_override is not None:
            self._values["dynamic_throughtput_optimization_override"] = dynamic_throughtput_optimization_override
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if ecms_bulk_upload is not None:
            self._values["ecms_bulk_upload"] = ecms_bulk_upload
        if ecms_database is not None:
            self._values["ecms_database"] = ecms_database
        if ecms_dataset is not None:
            self._values["ecms_dataset"] = ecms_dataset
        if ecms_object_key is not None:
            self._values["ecms_object_key"] = ecms_object_key
        if edge_connect is not None:
            self._values["edge_connect"] = edge_connect
        if edge_load_balancing_advanced is not None:
            self._values["edge_load_balancing_advanced"] = edge_load_balancing_advanced
        if edge_load_balancing_data_center is not None:
            self._values["edge_load_balancing_data_center"] = edge_load_balancing_data_center
        if edge_load_balancing_origin is not None:
            self._values["edge_load_balancing_origin"] = edge_load_balancing_origin
        if edge_origin_authorization is not None:
            self._values["edge_origin_authorization"] = edge_origin_authorization
        if edge_redirector is not None:
            self._values["edge_redirector"] = edge_redirector
        if edge_scape is not None:
            self._values["edge_scape"] = edge_scape
        if edge_side_includes is not None:
            self._values["edge_side_includes"] = edge_side_includes
        if edge_worker is not None:
            self._values["edge_worker"] = edge_worker
        if enforce_mtls_settings is not None:
            self._values["enforce_mtls_settings"] = enforce_mtls_settings
        if enhanced_akamai_protocol is not None:
            self._values["enhanced_akamai_protocol"] = enhanced_akamai_protocol
        if enhanced_proxy_detection is not None:
            self._values["enhanced_proxy_detection"] = enhanced_proxy_detection
        if epd_forward_header_enrichment is not None:
            self._values["epd_forward_header_enrichment"] = epd_forward_header_enrichment
        if fail_action is not None:
            self._values["fail_action"] = fail_action
        if failover_bot_manager_feature_compatibility is not None:
            self._values["failover_bot_manager_feature_compatibility"] = failover_bot_manager_feature_compatibility
        if fast_invalidate is not None:
            self._values["fast_invalidate"] = fast_invalidate
        if fips is not None:
            self._values["fips"] = fips
        if first_party_marketing is not None:
            self._values["first_party_marketing"] = first_party_marketing
        if first_party_marketing_plus is not None:
            self._values["first_party_marketing_plus"] = first_party_marketing_plus
        if forward_rewrite is not None:
            self._values["forward_rewrite"] = forward_rewrite
        if g2_oheader is not None:
            self._values["g2_oheader"] = g2_oheader
        if global_request_number is not None:
            self._values["global_request_number"] = global_request_number
        if graphql_caching is not None:
            self._values["graphql_caching"] = graphql_caching
        if gzip_response is not None:
            self._values["gzip_response"] = gzip_response
        if hd_data_advanced is not None:
            self._values["hd_data_advanced"] = hd_data_advanced
        if health_detection is not None:
            self._values["health_detection"] = health_detection
        if hsaf_eip_binding is not None:
            self._values["hsaf_eip_binding"] = hsaf_eip_binding
        if http2 is not None:
            self._values["http2"] = http2
        if http3 is not None:
            self._values["http3"] = http3
        if http_strict_transport_security is not None:
            self._values["http_strict_transport_security"] = http_strict_transport_security
        if http_to_https_upgrade is not None:
            self._values["http_to_https_upgrade"] = http_to_https_upgrade
        if image_and_video_manager is not None:
            self._values["image_and_video_manager"] = image_and_video_manager
        if image_manager is not None:
            self._values["image_manager"] = image_manager
        if image_manager_video is not None:
            self._values["image_manager_video"] = image_manager_video
        if im_override is not None:
            self._values["im_override"] = im_override
        if include is not None:
            self._values["include"] = include
        if instant is not None:
            self._values["instant"] = instant
        if instant_config is not None:
            self._values["instant_config"] = instant_config
        if large_file_optimization is not None:
            self._values["large_file_optimization"] = large_file_optimization
        if large_file_optimization_advanced is not None:
            self._values["large_file_optimization_advanced"] = large_file_optimization_advanced
        if limit_bit_rate is not None:
            self._values["limit_bit_rate"] = limit_bit_rate
        if log_custom is not None:
            self._values["log_custom"] = log_custom
        if manifest_personalization is not None:
            self._values["manifest_personalization"] = manifest_personalization
        if manifest_rerouting is not None:
            self._values["manifest_rerouting"] = manifest_rerouting
        if manual_server_push is not None:
            self._values["manual_server_push"] = manual_server_push
        if media_acceleration is not None:
            self._values["media_acceleration"] = media_acceleration
        if media_acceleration_quic_optout is not None:
            self._values["media_acceleration_quic_optout"] = media_acceleration_quic_optout
        if media_client is not None:
            self._values["media_client"] = media_client
        if media_file_retrieval_optimization is not None:
            self._values["media_file_retrieval_optimization"] = media_file_retrieval_optimization
        if media_origin_failover is not None:
            self._values["media_origin_failover"] = media_origin_failover
        if metadata_caching is not None:
            self._values["metadata_caching"] = metadata_caching
        if mobile_sdk_performance is not None:
            self._values["mobile_sdk_performance"] = mobile_sdk_performance
        if modify_incoming_request_header is not None:
            self._values["modify_incoming_request_header"] = modify_incoming_request_header
        if modify_incoming_response_header is not None:
            self._values["modify_incoming_response_header"] = modify_incoming_response_header
        if modify_outgoing_request_header is not None:
            self._values["modify_outgoing_request_header"] = modify_outgoing_request_header
        if modify_outgoing_response_header is not None:
            self._values["modify_outgoing_response_header"] = modify_outgoing_response_header
        if modify_via_header is not None:
            self._values["modify_via_header"] = modify_via_header
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if origin is not None:
            self._values["origin"] = origin
        if origin_characteristics is not None:
            self._values["origin_characteristics"] = origin_characteristics
        if origin_characteristics_wsd is not None:
            self._values["origin_characteristics_wsd"] = origin_characteristics_wsd
        if origin_failure_recovery_method is not None:
            self._values["origin_failure_recovery_method"] = origin_failure_recovery_method
        if origin_failure_recovery_policy is not None:
            self._values["origin_failure_recovery_policy"] = origin_failure_recovery_policy
        if origin_ip_acl is not None:
            self._values["origin_ip_acl"] = origin_ip_acl
        if permissions_policy is not None:
            self._values["permissions_policy"] = permissions_policy
        if persistent_client_connection is not None:
            self._values["persistent_client_connection"] = persistent_client_connection
        if persistent_connection is not None:
            self._values["persistent_connection"] = persistent_connection
        if personally_identifiable_information is not None:
            self._values["personally_identifiable_information"] = personally_identifiable_information
        if phased_release is not None:
            self._values["phased_release"] = phased_release
        if preconnect is not None:
            self._values["preconnect"] = preconnect
        if predictive_content_delivery is not None:
            self._values["predictive_content_delivery"] = predictive_content_delivery
        if predictive_prefetching is not None:
            self._values["predictive_prefetching"] = predictive_prefetching
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if prefetchable is not None:
            self._values["prefetchable"] = prefetchable
        if prefresh_cache is not None:
            self._values["prefresh_cache"] = prefresh_cache
        if quality is not None:
            self._values["quality"] = quality
        if quic_beta is not None:
            self._values["quic_beta"] = quic_beta
        if random_seek is not None:
            self._values["random_seek"] = random_seek
        if rapid is not None:
            self._values["rapid"] = rapid
        if read_timeout is not None:
            self._values["read_timeout"] = read_timeout
        if real_time_reporting is not None:
            self._values["real_time_reporting"] = real_time_reporting
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirectplus is not None:
            self._values["redirectplus"] = redirectplus
        if referer_checking is not None:
            self._values["referer_checking"] = referer_checking
        if remove_query_parameter is not None:
            self._values["remove_query_parameter"] = remove_query_parameter
        if remove_vary is not None:
            self._values["remove_vary"] = remove_vary
        if report is not None:
            self._values["report"] = report
        if request_client_hints is not None:
            self._values["request_client_hints"] = request_client_hints
        if request_control is not None:
            self._values["request_control"] = request_control
        if request_type_marker is not None:
            self._values["request_type_marker"] = request_type_marker
        if resource_optimizer is not None:
            self._values["resource_optimizer"] = resource_optimizer
        if resource_optimizer_extended_compatibility is not None:
            self._values["resource_optimizer_extended_compatibility"] = resource_optimizer_extended_compatibility
        if response_code is not None:
            self._values["response_code"] = response_code
        if response_cookie is not None:
            self._values["response_cookie"] = response_cookie
        if restrict_object_caching is not None:
            self._values["restrict_object_caching"] = restrict_object_caching
        if return_cache_status is not None:
            self._values["return_cache_status"] = return_cache_status
        if rewrite_url is not None:
            self._values["rewrite_url"] = rewrite_url
        if rum_custom is not None:
            self._values["rum_custom"] = rum_custom
        if saas_definitions is not None:
            self._values["saas_definitions"] = saas_definitions
        if sales_force_commerce_cloud_client is not None:
            self._values["sales_force_commerce_cloud_client"] = sales_force_commerce_cloud_client
        if sales_force_commerce_cloud_provider is not None:
            self._values["sales_force_commerce_cloud_provider"] = sales_force_commerce_cloud_provider
        if sales_force_commerce_cloud_provider_host_header is not None:
            self._values["sales_force_commerce_cloud_provider_host_header"] = sales_force_commerce_cloud_provider_host_header
        if save_post_dca_processing is not None:
            self._values["save_post_dca_processing"] = save_post_dca_processing
        if schedule_invalidation is not None:
            self._values["schedule_invalidation"] = schedule_invalidation
        if script_management is not None:
            self._values["script_management"] = script_management
        if segmented_content_protection is not None:
            self._values["segmented_content_protection"] = segmented_content_protection
        if segmented_media_optimization is not None:
            self._values["segmented_media_optimization"] = segmented_media_optimization
        if segmented_media_streaming_prefetch is not None:
            self._values["segmented_media_streaming_prefetch"] = segmented_media_streaming_prefetch
        if set_variable is not None:
            self._values["set_variable"] = set_variable
        if simulate_error_code is not None:
            self._values["simulate_error_code"] = simulate_error_code
        if site_shield is not None:
            self._values["site_shield"] = site_shield
        if standard_tls_migration is not None:
            self._values["standard_tls_migration"] = standard_tls_migration
        if standard_tls_migration_override is not None:
            self._values["standard_tls_migration_override"] = standard_tls_migration_override
        if strict_header_parsing is not None:
            self._values["strict_header_parsing"] = strict_header_parsing
        if sub_customer is not None:
            self._values["sub_customer"] = sub_customer
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if tcp_optimization is not None:
            self._values["tcp_optimization"] = tcp_optimization
        if tea_leaf is not None:
            self._values["tea_leaf"] = tea_leaf
        if tiered_distribution is not None:
            self._values["tiered_distribution"] = tiered_distribution
        if tiered_distribution_advanced is not None:
            self._values["tiered_distribution_advanced"] = tiered_distribution_advanced
        if tiered_distribution_customization is not None:
            self._values["tiered_distribution_customization"] = tiered_distribution_customization
        if timeout is not None:
            self._values["timeout"] = timeout
        if uid_configuration is not None:
            self._values["uid_configuration"] = uid_configuration
        if validate_entity_tag is not None:
            self._values["validate_entity_tag"] = validate_entity_tag
        if verify_json_web_token is not None:
            self._values["verify_json_web_token"] = verify_json_web_token
        if verify_json_web_token_for_dcp is not None:
            self._values["verify_json_web_token_for_dcp"] = verify_json_web_token_for_dcp
        if verify_token_authorization is not None:
            self._values["verify_token_authorization"] = verify_token_authorization
        if virtual_waiting_room is not None:
            self._values["virtual_waiting_room"] = virtual_waiting_room
        if virtual_waiting_room_with_edge_workers is not None:
            self._values["virtual_waiting_room_with_edge_workers"] = virtual_waiting_room_with_edge_workers
        if visitor_prioritization is not None:
            self._values["visitor_prioritization"] = visitor_prioritization
        if visitor_prioritization_fifo is not None:
            self._values["visitor_prioritization_fifo"] = visitor_prioritization_fifo
        if visitor_prioritization_fifo_standalone is not None:
            self._values["visitor_prioritization_fifo_standalone"] = visitor_prioritization_fifo_standalone
        if watermarking is not None:
            self._values["watermarking"] = watermarking
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall
        if webdav is not None:
            self._values["webdav"] = webdav
        if web_sockets is not None:
            self._values["web_sockets"] = web_sockets

    @builtins.property
    def adaptive_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration"]:
        '''adaptive_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        '''
        result = self._values.get("adaptive_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration"], result)

    @builtins.property
    def adaptive_image_compression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression"]:
        '''adaptive_image_compression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        '''
        result = self._values.get("adaptive_image_compression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression"], result)

    @builtins.property
    def ad_scaler_circuit_breaker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker"]:
        '''ad_scaler_circuit_breaker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        '''
        result = self._values.get("ad_scaler_circuit_breaker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker"], result)

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced"]:
        '''advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced"], result)

    @builtins.property
    def aggregated_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting"]:
        '''aggregated_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        '''
        result = self._values.get("aggregated_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting"], result)

    @builtins.property
    def akamaizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer"]:
        '''akamaizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        '''
        result = self._values.get("akamaizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer"], result)

    @builtins.property
    def akamaizer_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag"]:
        '''akamaizer_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        '''
        result = self._values.get("akamaizer_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag"], result)

    @builtins.property
    def all_http_in_cache_hierarchy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy"]:
        '''all_http_in_cache_hierarchy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        '''
        result = self._values.get("all_http_in_cache_hierarchy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy"], result)

    @builtins.property
    def allow_cloudlets_origins(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins"]:
        '''allow_cloudlets_origins block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        '''
        result = self._values.get("allow_cloudlets_origins")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins"], result)

    @builtins.property
    def allow_delete(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete"]:
        '''allow_delete block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        '''
        result = self._values.get("allow_delete")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete"], result)

    @builtins.property
    def allow_https_cache_key_sharing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing"]:
        '''allow_https_cache_key_sharing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        '''
        result = self._values.get("allow_https_cache_key_sharing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing"], result)

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade"]:
        '''allow_https_downgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade"], result)

    @builtins.property
    def allow_options(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions"]:
        '''allow_options block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        '''
        result = self._values.get("allow_options")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions"], result)

    @builtins.property
    def allow_patch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch"]:
        '''allow_patch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        '''
        result = self._values.get("allow_patch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch"], result)

    @builtins.property
    def allow_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost"]:
        '''allow_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        '''
        result = self._values.get("allow_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost"], result)

    @builtins.property
    def allow_put(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut"]:
        '''allow_put block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        '''
        result = self._values.get("allow_put")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut"], result)

    @builtins.property
    def allow_transfer_encoding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding"]:
        '''allow_transfer_encoding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        '''
        result = self._values.get("allow_transfer_encoding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding"], result)

    @builtins.property
    def alt_svc_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader"]:
        '''alt_svc_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        '''
        result = self._values.get("alt_svc_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader"], result)

    @builtins.property
    def api_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization"]:
        '''api_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        '''
        result = self._values.get("api_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization"], result)

    @builtins.property
    def application_load_balancer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer"]:
        '''application_load_balancer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        '''
        result = self._values.get("application_load_balancer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer"], result)

    @builtins.property
    def audience_segmentation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation"]:
        '''audience_segmentation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        '''
        result = self._values.get("audience_segmentation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation"], result)

    @builtins.property
    def auto_domain_validation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation"]:
        '''auto_domain_validation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        '''
        result = self._values.get("auto_domain_validation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation"], result)

    @builtins.property
    def base_directory(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory"]:
        '''base_directory block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        '''
        result = self._values.get("base_directory")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory"], result)

    @builtins.property
    def boss_beaconing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing"]:
        '''boss_beaconing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        '''
        result = self._values.get("boss_beaconing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing"], result)

    @builtins.property
    def breadcrumbs(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs"]:
        '''breadcrumbs block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        '''
        result = self._values.get("breadcrumbs")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs"], result)

    @builtins.property
    def break_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection"]:
        '''break_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        '''
        result = self._values.get("break_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection"], result)

    @builtins.property
    def brotli(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli"]:
        '''brotli block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        '''
        result = self._values.get("brotli")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli"], result)

    @builtins.property
    def cache_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError"]:
        '''cache_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        '''
        result = self._values.get("cache_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError"], result)

    @builtins.property
    def cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId"]:
        '''cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        '''
        result = self._values.get("cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId"], result)

    @builtins.property
    def cache_key_ignore_case(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase"]:
        '''cache_key_ignore_case block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        '''
        result = self._values.get("cache_key_ignore_case")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase"], result)

    @builtins.property
    def cache_key_query_params(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams"]:
        '''cache_key_query_params block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        '''
        result = self._values.get("cache_key_query_params")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams"], result)

    @builtins.property
    def cache_key_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite"]:
        '''cache_key_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        '''
        result = self._values.get("cache_key_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite"], result)

    @builtins.property
    def cache_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost"]:
        '''cache_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        '''
        result = self._values.get("cache_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost"], result)

    @builtins.property
    def cache_redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect"]:
        '''cache_redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        '''
        result = self._values.get("cache_redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect"], result)

    @builtins.property
    def cache_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag"]:
        '''cache_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        '''
        result = self._values.get("cache_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag"], result)

    @builtins.property
    def cache_tag_visible(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible"]:
        '''cache_tag_visible block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        '''
        result = self._values.get("cache_tag_visible")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible"], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching"]:
        '''caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching"], result)

    @builtins.property
    def central_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization"]:
        '''central_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        '''
        result = self._values.get("central_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization"], result)

    @builtins.property
    def chase_redirects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects"]:
        '''chase_redirects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        '''
        result = self._values.get("chase_redirects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects"], result)

    @builtins.property
    def client_certificate_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth"]:
        '''client_certificate_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_auth DataAkamaiPropertyRulesBuilder#client_certificate_auth}
        '''
        result = self._values.get("client_certificate_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth"], result)

    @builtins.property
    def client_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics"]:
        '''client_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        '''
        result = self._values.get("client_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics"], result)

    @builtins.property
    def cloud_interconnects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects"]:
        '''cloud_interconnects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        '''
        result = self._values.get("cloud_interconnects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects"], result)

    @builtins.property
    def cloud_wrapper(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper"]:
        '''cloud_wrapper block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        '''
        result = self._values.get("cloud_wrapper")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper"], result)

    @builtins.property
    def cloud_wrapper_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced"]:
        '''cloud_wrapper_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        '''
        result = self._values.get("cloud_wrapper_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced"], result)

    @builtins.property
    def common_media_client_data(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData"]:
        '''common_media_client_data block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        '''
        result = self._values.get("common_media_client_data")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData"], result)

    @builtins.property
    def conditional_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin"]:
        '''conditional_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        '''
        result = self._values.get("conditional_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin"], result)

    @builtins.property
    def construct_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse"]:
        '''construct_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        '''
        result = self._values.get("construct_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse"], result)

    @builtins.property
    def content_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics"]:
        '''content_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        '''
        result = self._values.get("content_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics"], result)

    @builtins.property
    def content_characteristics_amd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd"]:
        '''content_characteristics_amd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        '''
        result = self._values.get("content_characteristics_amd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd"], result)

    @builtins.property
    def content_characteristics_dd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd"]:
        '''content_characteristics_dd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        '''
        result = self._values.get("content_characteristics_dd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd"], result)

    @builtins.property
    def content_characteristics_wsd_large_file(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile"]:
        '''content_characteristics_wsd_large_file block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        '''
        result = self._values.get("content_characteristics_wsd_large_file")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile"], result)

    @builtins.property
    def content_characteristics_wsd_live(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive"]:
        '''content_characteristics_wsd_live block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        '''
        result = self._values.get("content_characteristics_wsd_live")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive"], result)

    @builtins.property
    def content_characteristics_wsd_vod(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod"]:
        '''content_characteristics_wsd_vod block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        '''
        result = self._values.get("content_characteristics_wsd_vod")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod"], result)

    @builtins.property
    def content_pre_position(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition"]:
        '''content_pre_position block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        '''
        result = self._values.get("content_pre_position")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition"], result)

    @builtins.property
    def content_targeting_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection"]:
        '''content_targeting_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        '''
        result = self._values.get("content_targeting_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection"], result)

    @builtins.property
    def cors_support(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport"]:
        '''cors_support block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        '''
        result = self._values.get("cors_support")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport"], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode"], result)

    @builtins.property
    def custom_behavior(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior"]:
        '''custom_behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        '''
        result = self._values.get("custom_behavior")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior"], result)

    @builtins.property
    def datastream(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream"]:
        '''datastream block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        '''
        result = self._values.get("datastream")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream"], result)

    @builtins.property
    def dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp"]:
        '''dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        '''
        result = self._values.get("dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp"], result)

    @builtins.property
    def dcp_auth_hmac_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation"]:
        '''dcp_auth_hmac_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        '''
        result = self._values.get("dcp_auth_hmac_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation"], result)

    @builtins.property
    def dcp_auth_regex_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation"]:
        '''dcp_auth_regex_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        '''
        result = self._values.get("dcp_auth_regex_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation"], result)

    @builtins.property
    def dcp_auth_substring_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation"]:
        '''dcp_auth_substring_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        '''
        result = self._values.get("dcp_auth_substring_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation"], result)

    @builtins.property
    def dcp_auth_variable_extractor(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor"]:
        '''dcp_auth_variable_extractor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        '''
        result = self._values.get("dcp_auth_variable_extractor")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor"], result)

    @builtins.property
    def dcp_default_authz_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups"]:
        '''dcp_default_authz_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        '''
        result = self._values.get("dcp_default_authz_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups"], result)

    @builtins.property
    def dcp_dev_relations(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations"]:
        '''dcp_dev_relations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        '''
        result = self._values.get("dcp_dev_relations")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations"], result)

    @builtins.property
    def dcp_real_time_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth"]:
        '''dcp_real_time_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        '''
        result = self._values.get("dcp_real_time_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth"], result)

    @builtins.property
    def delivery_receipt(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt"]:
        '''delivery_receipt block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        '''
        result = self._values.get("delivery_receipt")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt"], result)

    @builtins.property
    def deny_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess"]:
        '''deny_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        '''
        result = self._values.get("deny_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess"], result)

    @builtins.property
    def deny_direct_failover_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess"]:
        '''deny_direct_failover_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        '''
        result = self._values.get("deny_direct_failover_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess"], result)

    @builtins.property
    def device_characteristic_cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId"]:
        '''device_characteristic_cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        '''
        result = self._values.get("device_characteristic_cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId"], result)

    @builtins.property
    def device_characteristic_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader"]:
        '''device_characteristic_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        '''
        result = self._values.get("device_characteristic_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader"], result)

    @builtins.property
    def dns_async_refresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh"]:
        '''dns_async_refresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        '''
        result = self._values.get("dns_async_refresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh"], result)

    @builtins.property
    def dns_prefresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh"]:
        '''dns_prefresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        '''
        result = self._values.get("dns_prefresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh"], result)

    @builtins.property
    def downgrade_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol"]:
        '''downgrade_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        '''
        result = self._values.get("downgrade_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol"], result)

    @builtins.property
    def download_complete_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker"]:
        '''download_complete_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        '''
        result = self._values.get("download_complete_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker"], result)

    @builtins.property
    def download_notification(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification"]:
        '''download_notification block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        '''
        result = self._values.get("download_notification")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification"], result)

    @builtins.property
    def downstream_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache"]:
        '''downstream_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        '''
        result = self._values.get("downstream_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache"], result)

    @builtins.property
    def dynamic_throughtput_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization"]:
        '''dynamic_throughtput_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        '''
        result = self._values.get("dynamic_throughtput_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization"], result)

    @builtins.property
    def dynamic_throughtput_optimization_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride"]:
        '''dynamic_throughtput_optimization_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        '''
        result = self._values.get("dynamic_throughtput_optimization_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride"], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent"]:
        '''dynamic_web_content block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent"], result)

    @builtins.property
    def ecms_bulk_upload(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload"]:
        '''ecms_bulk_upload block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        '''
        result = self._values.get("ecms_bulk_upload")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload"], result)

    @builtins.property
    def ecms_database(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase"]:
        '''ecms_database block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        '''
        result = self._values.get("ecms_database")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase"], result)

    @builtins.property
    def ecms_dataset(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset"]:
        '''ecms_dataset block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        '''
        result = self._values.get("ecms_dataset")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset"], result)

    @builtins.property
    def ecms_object_key(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey"]:
        '''ecms_object_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        '''
        result = self._values.get("ecms_object_key")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey"], result)

    @builtins.property
    def edge_connect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect"]:
        '''edge_connect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        '''
        result = self._values.get("edge_connect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect"], result)

    @builtins.property
    def edge_load_balancing_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced"]:
        '''edge_load_balancing_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        '''
        result = self._values.get("edge_load_balancing_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced"], result)

    @builtins.property
    def edge_load_balancing_data_center(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter"]:
        '''edge_load_balancing_data_center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        '''
        result = self._values.get("edge_load_balancing_data_center")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter"], result)

    @builtins.property
    def edge_load_balancing_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin"]:
        '''edge_load_balancing_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        '''
        result = self._values.get("edge_load_balancing_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin"], result)

    @builtins.property
    def edge_origin_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization"]:
        '''edge_origin_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        '''
        result = self._values.get("edge_origin_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization"], result)

    @builtins.property
    def edge_redirector(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector"]:
        '''edge_redirector block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        '''
        result = self._values.get("edge_redirector")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector"], result)

    @builtins.property
    def edge_scape(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape"]:
        '''edge_scape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        '''
        result = self._values.get("edge_scape")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape"], result)

    @builtins.property
    def edge_side_includes(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes"]:
        '''edge_side_includes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        '''
        result = self._values.get("edge_side_includes")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes"], result)

    @builtins.property
    def edge_worker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker"]:
        '''edge_worker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        '''
        result = self._values.get("edge_worker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker"], result)

    @builtins.property
    def enforce_mtls_settings(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings"]:
        '''enforce_mtls_settings block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls_settings DataAkamaiPropertyRulesBuilder#enforce_mtls_settings}
        '''
        result = self._values.get("enforce_mtls_settings")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings"], result)

    @builtins.property
    def enhanced_akamai_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol"]:
        '''enhanced_akamai_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        '''
        result = self._values.get("enhanced_akamai_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol"], result)

    @builtins.property
    def enhanced_proxy_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection"]:
        '''enhanced_proxy_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        '''
        result = self._values.get("enhanced_proxy_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection"], result)

    @builtins.property
    def epd_forward_header_enrichment(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment"]:
        '''epd_forward_header_enrichment block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        '''
        result = self._values.get("epd_forward_header_enrichment")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment"], result)

    @builtins.property
    def fail_action(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction"]:
        '''fail_action block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        '''
        result = self._values.get("fail_action")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction"], result)

    @builtins.property
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility"]:
        '''failover_bot_manager_feature_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        '''
        result = self._values.get("failover_bot_manager_feature_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility"], result)

    @builtins.property
    def fast_invalidate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate"]:
        '''fast_invalidate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        '''
        result = self._values.get("fast_invalidate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate"], result)

    @builtins.property
    def fips(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips"]:
        '''fips block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fips DataAkamaiPropertyRulesBuilder#fips}
        '''
        result = self._values.get("fips")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips"], result)

    @builtins.property
    def first_party_marketing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing"]:
        '''first_party_marketing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        '''
        result = self._values.get("first_party_marketing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing"], result)

    @builtins.property
    def first_party_marketing_plus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus"]:
        '''first_party_marketing_plus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        '''
        result = self._values.get("first_party_marketing_plus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus"], result)

    @builtins.property
    def forward_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite"]:
        '''forward_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        '''
        result = self._values.get("forward_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite"], result)

    @builtins.property
    def g2_oheader(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader"]:
        '''g2oheader block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        '''
        result = self._values.get("g2_oheader")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader"], result)

    @builtins.property
    def global_request_number(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber"]:
        '''global_request_number block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        '''
        result = self._values.get("global_request_number")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber"], result)

    @builtins.property
    def graphql_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching"]:
        '''graphql_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        '''
        result = self._values.get("graphql_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching"], result)

    @builtins.property
    def gzip_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse"]:
        '''gzip_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        '''
        result = self._values.get("gzip_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse"], result)

    @builtins.property
    def hd_data_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced"]:
        '''hd_data_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        '''
        result = self._values.get("hd_data_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced"], result)

    @builtins.property
    def health_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection"]:
        '''health_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        '''
        result = self._values.get("health_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection"], result)

    @builtins.property
    def hsaf_eip_binding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding"]:
        '''hsaf_eip_binding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        '''
        result = self._values.get("hsaf_eip_binding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding"], result)

    @builtins.property
    def http2(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2"]:
        '''http2 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        '''
        result = self._values.get("http2")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2"], result)

    @builtins.property
    def http3(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3"]:
        '''http3 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        '''
        result = self._values.get("http3")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3"], result)

    @builtins.property
    def http_strict_transport_security(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity"]:
        '''http_strict_transport_security block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        '''
        result = self._values.get("http_strict_transport_security")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity"], result)

    @builtins.property
    def http_to_https_upgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade"]:
        '''http_to_https_upgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        '''
        result = self._values.get("http_to_https_upgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade"], result)

    @builtins.property
    def image_and_video_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager"]:
        '''image_and_video_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        '''
        result = self._values.get("image_and_video_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager"], result)

    @builtins.property
    def image_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager"]:
        '''image_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        '''
        result = self._values.get("image_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager"], result)

    @builtins.property
    def image_manager_video(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo"]:
        '''image_manager_video block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        '''
        result = self._values.get("image_manager_video")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo"], result)

    @builtins.property
    def im_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride"]:
        '''im_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        '''
        result = self._values.get("im_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride"], result)

    @builtins.property
    def include(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude"]:
        '''include block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        '''
        result = self._values.get("include")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude"], result)

    @builtins.property
    def instant(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant"]:
        '''instant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        '''
        result = self._values.get("instant")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant"], result)

    @builtins.property
    def instant_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig"]:
        '''instant_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        '''
        result = self._values.get("instant_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig"], result)

    @builtins.property
    def large_file_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization"]:
        '''large_file_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        '''
        result = self._values.get("large_file_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization"], result)

    @builtins.property
    def large_file_optimization_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced"]:
        '''large_file_optimization_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        '''
        result = self._values.get("large_file_optimization_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced"], result)

    @builtins.property
    def limit_bit_rate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate"]:
        '''limit_bit_rate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        '''
        result = self._values.get("limit_bit_rate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate"], result)

    @builtins.property
    def log_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom"]:
        '''log_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        '''
        result = self._values.get("log_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom"], result)

    @builtins.property
    def manifest_personalization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization"]:
        '''manifest_personalization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        '''
        result = self._values.get("manifest_personalization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization"], result)

    @builtins.property
    def manifest_rerouting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting"]:
        '''manifest_rerouting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        '''
        result = self._values.get("manifest_rerouting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting"], result)

    @builtins.property
    def manual_server_push(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush"]:
        '''manual_server_push block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        '''
        result = self._values.get("manual_server_push")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush"], result)

    @builtins.property
    def media_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration"]:
        '''media_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        '''
        result = self._values.get("media_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration"], result)

    @builtins.property
    def media_acceleration_quic_optout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout"]:
        '''media_acceleration_quic_optout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        '''
        result = self._values.get("media_acceleration_quic_optout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout"], result)

    @builtins.property
    def media_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient"]:
        '''media_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        '''
        result = self._values.get("media_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient"], result)

    @builtins.property
    def media_file_retrieval_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization"]:
        '''media_file_retrieval_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        '''
        result = self._values.get("media_file_retrieval_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization"], result)

    @builtins.property
    def media_origin_failover(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover"]:
        '''media_origin_failover block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        '''
        result = self._values.get("media_origin_failover")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover"], result)

    @builtins.property
    def metadata_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching"]:
        '''metadata_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        '''
        result = self._values.get("metadata_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching"], result)

    @builtins.property
    def mobile_sdk_performance(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance"]:
        '''mobile_sdk_performance block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        '''
        result = self._values.get("mobile_sdk_performance")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance"], result)

    @builtins.property
    def modify_incoming_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader"]:
        '''modify_incoming_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        '''
        result = self._values.get("modify_incoming_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader"], result)

    @builtins.property
    def modify_incoming_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader"]:
        '''modify_incoming_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        '''
        result = self._values.get("modify_incoming_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader"], result)

    @builtins.property
    def modify_outgoing_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader"]:
        '''modify_outgoing_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        '''
        result = self._values.get("modify_outgoing_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader"], result)

    @builtins.property
    def modify_outgoing_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader"]:
        '''modify_outgoing_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        '''
        result = self._values.get("modify_outgoing_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader"], result)

    @builtins.property
    def modify_via_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader"]:
        '''modify_via_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        '''
        result = self._values.get("modify_via_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader"], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse"]:
        '''m_pulse block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse"], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin"]:
        '''origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin"], result)

    @builtins.property
    def origin_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics"]:
        '''origin_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        '''
        result = self._values.get("origin_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics"], result)

    @builtins.property
    def origin_characteristics_wsd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd"]:
        '''origin_characteristics_wsd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        '''
        result = self._values.get("origin_characteristics_wsd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd"], result)

    @builtins.property
    def origin_failure_recovery_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod"]:
        '''origin_failure_recovery_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        '''
        result = self._values.get("origin_failure_recovery_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod"], result)

    @builtins.property
    def origin_failure_recovery_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy"]:
        '''origin_failure_recovery_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        '''
        result = self._values.get("origin_failure_recovery_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy"], result)

    @builtins.property
    def origin_ip_acl(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl"]:
        '''origin_ip_acl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        '''
        result = self._values.get("origin_ip_acl")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl"], result)

    @builtins.property
    def permissions_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy"]:
        '''permissions_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy DataAkamaiPropertyRulesBuilder#permissions_policy}
        '''
        result = self._values.get("permissions_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy"], result)

    @builtins.property
    def persistent_client_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection"]:
        '''persistent_client_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        '''
        result = self._values.get("persistent_client_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection"], result)

    @builtins.property
    def persistent_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection"]:
        '''persistent_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        '''
        result = self._values.get("persistent_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection"], result)

    @builtins.property
    def personally_identifiable_information(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation"]:
        '''personally_identifiable_information block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        '''
        result = self._values.get("personally_identifiable_information")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation"], result)

    @builtins.property
    def phased_release(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease"]:
        '''phased_release block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        '''
        result = self._values.get("phased_release")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease"], result)

    @builtins.property
    def preconnect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect"]:
        '''preconnect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        '''
        result = self._values.get("preconnect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect"], result)

    @builtins.property
    def predictive_content_delivery(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery"]:
        '''predictive_content_delivery block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        '''
        result = self._values.get("predictive_content_delivery")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery"], result)

    @builtins.property
    def predictive_prefetching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching"]:
        '''predictive_prefetching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        '''
        result = self._values.get("predictive_prefetching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching"], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch"]:
        '''prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch"], result)

    @builtins.property
    def prefetchable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable"]:
        '''prefetchable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        '''
        result = self._values.get("prefetchable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable"], result)

    @builtins.property
    def prefresh_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache"]:
        '''prefresh_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        '''
        result = self._values.get("prefresh_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache"], result)

    @builtins.property
    def quality(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality"]:
        '''quality block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        '''
        result = self._values.get("quality")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality"], result)

    @builtins.property
    def quic_beta(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta"]:
        '''quic_beta block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        '''
        result = self._values.get("quic_beta")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta"], result)

    @builtins.property
    def random_seek(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek"]:
        '''random_seek block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        '''
        result = self._values.get("random_seek")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek"], result)

    @builtins.property
    def rapid(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid"]:
        '''rapid block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        '''
        result = self._values.get("rapid")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid"], result)

    @builtins.property
    def read_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout"]:
        '''read_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        '''
        result = self._values.get("read_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout"], result)

    @builtins.property
    def real_time_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting"]:
        '''real_time_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        '''
        result = self._values.get("real_time_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting"], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring"]:
        '''real_user_monitoring block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring"], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect"]:
        '''redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect"], result)

    @builtins.property
    def redirectplus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus"]:
        '''redirectplus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        '''
        result = self._values.get("redirectplus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus"], result)

    @builtins.property
    def referer_checking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking"]:
        '''referer_checking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        '''
        result = self._values.get("referer_checking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking"], result)

    @builtins.property
    def remove_query_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter"]:
        '''remove_query_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        '''
        result = self._values.get("remove_query_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter"], result)

    @builtins.property
    def remove_vary(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary"]:
        '''remove_vary block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        '''
        result = self._values.get("remove_vary")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary"], result)

    @builtins.property
    def report(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport"]:
        '''report block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        '''
        result = self._values.get("report")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport"], result)

    @builtins.property
    def request_client_hints(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints"]:
        '''request_client_hints block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_client_hints DataAkamaiPropertyRulesBuilder#request_client_hints}
        '''
        result = self._values.get("request_client_hints")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints"], result)

    @builtins.property
    def request_control(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl"]:
        '''request_control block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        '''
        result = self._values.get("request_control")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl"], result)

    @builtins.property
    def request_type_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker"]:
        '''request_type_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        '''
        result = self._values.get("request_type_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker"], result)

    @builtins.property
    def resource_optimizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer"]:
        '''resource_optimizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        '''
        result = self._values.get("resource_optimizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer"], result)

    @builtins.property
    def resource_optimizer_extended_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility"]:
        '''resource_optimizer_extended_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        '''
        result = self._values.get("resource_optimizer_extended_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility"], result)

    @builtins.property
    def response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode"]:
        '''response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode"], result)

    @builtins.property
    def response_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie"]:
        '''response_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        '''
        result = self._values.get("response_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie"], result)

    @builtins.property
    def restrict_object_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching"]:
        '''restrict_object_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        '''
        result = self._values.get("restrict_object_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching"], result)

    @builtins.property
    def return_cache_status(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus"]:
        '''return_cache_status block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        '''
        result = self._values.get("return_cache_status")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus"], result)

    @builtins.property
    def rewrite_url(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl"]:
        '''rewrite_url block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        '''
        result = self._values.get("rewrite_url")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl"], result)

    @builtins.property
    def rum_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom"]:
        '''rum_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        '''
        result = self._values.get("rum_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom"], result)

    @builtins.property
    def saas_definitions(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions"]:
        '''saas_definitions block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        '''
        result = self._values.get("saas_definitions")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions"], result)

    @builtins.property
    def sales_force_commerce_cloud_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient"]:
        '''sales_force_commerce_cloud_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        '''
        result = self._values.get("sales_force_commerce_cloud_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider"]:
        '''sales_force_commerce_cloud_provider block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        '''sales_force_commerce_cloud_provider_host_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider_host_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader"], result)

    @builtins.property
    def save_post_dca_processing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing"]:
        '''save_post_dca_processing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        '''
        result = self._values.get("save_post_dca_processing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing"], result)

    @builtins.property
    def schedule_invalidation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation"]:
        '''schedule_invalidation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        '''
        result = self._values.get("schedule_invalidation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation"], result)

    @builtins.property
    def script_management(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement"]:
        '''script_management block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        '''
        result = self._values.get("script_management")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement"], result)

    @builtins.property
    def segmented_content_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection"]:
        '''segmented_content_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        '''
        result = self._values.get("segmented_content_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection"], result)

    @builtins.property
    def segmented_media_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization"]:
        '''segmented_media_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        '''
        result = self._values.get("segmented_media_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization"], result)

    @builtins.property
    def segmented_media_streaming_prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch"]:
        '''segmented_media_streaming_prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        '''
        result = self._values.get("segmented_media_streaming_prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch"], result)

    @builtins.property
    def set_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable"]:
        '''set_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        '''
        result = self._values.get("set_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable"], result)

    @builtins.property
    def simulate_error_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode"]:
        '''simulate_error_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        '''
        result = self._values.get("simulate_error_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode"], result)

    @builtins.property
    def site_shield(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield"]:
        '''site_shield block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        '''
        result = self._values.get("site_shield")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield"], result)

    @builtins.property
    def standard_tls_migration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration"]:
        '''standard_tls_migration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        '''
        result = self._values.get("standard_tls_migration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration"], result)

    @builtins.property
    def standard_tls_migration_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride"]:
        '''standard_tls_migration_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        '''
        result = self._values.get("standard_tls_migration_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride"], result)

    @builtins.property
    def strict_header_parsing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing"]:
        '''strict_header_parsing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        '''
        result = self._values.get("strict_header_parsing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing"], result)

    @builtins.property
    def sub_customer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer"]:
        '''sub_customer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        '''
        result = self._values.get("sub_customer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer"], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute"]:
        '''sure_route block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute"], result)

    @builtins.property
    def tcp_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization"]:
        '''tcp_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        '''
        result = self._values.get("tcp_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization"], result)

    @builtins.property
    def tea_leaf(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf"]:
        '''tea_leaf block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        '''
        result = self._values.get("tea_leaf")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf"], result)

    @builtins.property
    def tiered_distribution(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution"]:
        '''tiered_distribution block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        '''
        result = self._values.get("tiered_distribution")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution"], result)

    @builtins.property
    def tiered_distribution_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced"]:
        '''tiered_distribution_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        '''
        result = self._values.get("tiered_distribution_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced"], result)

    @builtins.property
    def tiered_distribution_customization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization"]:
        '''tiered_distribution_customization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        '''
        result = self._values.get("tiered_distribution_customization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization"], result)

    @builtins.property
    def timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout"]:
        '''timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout"], result)

    @builtins.property
    def uid_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration"]:
        '''uid_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        '''
        result = self._values.get("uid_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration"], result)

    @builtins.property
    def validate_entity_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag"]:
        '''validate_entity_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        '''
        result = self._values.get("validate_entity_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag"], result)

    @builtins.property
    def verify_json_web_token(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken"]:
        '''verify_json_web_token block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        '''
        result = self._values.get("verify_json_web_token")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken"], result)

    @builtins.property
    def verify_json_web_token_for_dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp"]:
        '''verify_json_web_token_for_dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        '''
        result = self._values.get("verify_json_web_token_for_dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp"], result)

    @builtins.property
    def verify_token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization"]:
        '''verify_token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        '''
        result = self._values.get("verify_token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization"], result)

    @builtins.property
    def virtual_waiting_room(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom"]:
        '''virtual_waiting_room block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        '''
        result = self._values.get("virtual_waiting_room")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom"], result)

    @builtins.property
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        '''virtual_waiting_room_with_edge_workers block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        '''
        result = self._values.get("virtual_waiting_room_with_edge_workers")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers"], result)

    @builtins.property
    def visitor_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization"]:
        '''visitor_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        '''
        result = self._values.get("visitor_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization"], result)

    @builtins.property
    def visitor_prioritization_fifo(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo"]:
        '''visitor_prioritization_fifo block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        '''
        result = self._values.get("visitor_prioritization_fifo")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo"], result)

    @builtins.property
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone"]:
        '''visitor_prioritization_fifo_standalone block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        '''
        result = self._values.get("visitor_prioritization_fifo_standalone")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone"], result)

    @builtins.property
    def watermarking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking"]:
        '''watermarking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        '''
        result = self._values.get("watermarking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking"], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall"]:
        '''web_application_firewall block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall"], result)

    @builtins.property
    def webdav(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav"]:
        '''webdav block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        '''
        result = self._values.get("webdav")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav"], result)

    @builtins.property
    def web_sockets(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets"]:
        '''web_sockets block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        result = self._values.get("web_sockets")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920Behavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker",
    jsii_struct_bases=[],
    name_mapping={
        "fallback_action_response_code_based": "fallbackActionResponseCodeBased",
        "locked": "locked",
        "response_code_based": "responseCodeBased",
        "response_codes": "responseCodes",
        "response_delay_based": "responseDelayBased",
        "response_delay_threshold": "responseDelayThreshold",
        "return_error_response_code_based": "returnErrorResponseCodeBased",
        "specify_your_own_response_code_based": "specifyYourOwnResponseCodeBased",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker:
    def __init__(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e5373c83fc65b0f2a83743bc9e7047f229d9002912dc14330605cb0aabd9341)
            check_type(argname="argument fallback_action_response_code_based", value=fallback_action_response_code_based, expected_type=type_hints["fallback_action_response_code_based"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code_based", value=response_code_based, expected_type=type_hints["response_code_based"])
            check_type(argname="argument response_codes", value=response_codes, expected_type=type_hints["response_codes"])
            check_type(argname="argument response_delay_based", value=response_delay_based, expected_type=type_hints["response_delay_based"])
            check_type(argname="argument response_delay_threshold", value=response_delay_threshold, expected_type=type_hints["response_delay_threshold"])
            check_type(argname="argument return_error_response_code_based", value=return_error_response_code_based, expected_type=type_hints["return_error_response_code_based"])
            check_type(argname="argument specify_your_own_response_code_based", value=specify_your_own_response_code_based, expected_type=type_hints["specify_your_own_response_code_based"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fallback_action_response_code_based is not None:
            self._values["fallback_action_response_code_based"] = fallback_action_response_code_based
        if locked is not None:
            self._values["locked"] = locked
        if response_code_based is not None:
            self._values["response_code_based"] = response_code_based
        if response_codes is not None:
            self._values["response_codes"] = response_codes
        if response_delay_based is not None:
            self._values["response_delay_based"] = response_delay_based
        if response_delay_threshold is not None:
            self._values["response_delay_threshold"] = response_delay_threshold
        if return_error_response_code_based is not None:
            self._values["return_error_response_code_based"] = return_error_response_code_based
        if specify_your_own_response_code_based is not None:
            self._values["specify_your_own_response_code_based"] = specify_your_own_response_code_based
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def fallback_action_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        '''
        result = self._values.get("fallback_action_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the response code from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        '''
        result = self._values.get("response_code_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_codes(self) -> typing.Optional[builtins.str]:
        '''Specifies the codes in the partner's response that trigger the fallback action,  either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        '''
        result = self._values.get("response_codes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_delay_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the delayed response from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        '''
        result = self._values.get("response_delay_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_delay_threshold(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum response delay that, if exceeded, triggers the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        '''
        result = self._values.get("response_delay_threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def return_error_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the error to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        '''
        result = self._values.get("return_error_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_your_own_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Defines a custom error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        '''
        result = self._values.get("specify_your_own_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreakerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreakerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33cdfd70bc2431f54faf10720739b4fd26d3adab4c216f1dcf272c6a52cd30cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFallbackActionResponseCodeBased")
    def reset_fallback_action_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFallbackActionResponseCodeBased", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCodeBased")
    def reset_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodeBased", []))

    @jsii.member(jsii_name="resetResponseCodes")
    def reset_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodes", []))

    @jsii.member(jsii_name="resetResponseDelayBased")
    def reset_response_delay_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayBased", []))

    @jsii.member(jsii_name="resetResponseDelayThreshold")
    def reset_response_delay_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayThreshold", []))

    @jsii.member(jsii_name="resetReturnErrorResponseCodeBased")
    def reset_return_error_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnErrorResponseCodeBased", []))

    @jsii.member(jsii_name="resetSpecifyYourOwnResponseCodeBased")
    def reset_specify_your_own_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyYourOwnResponseCodeBased", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBasedInput")
    def fallback_action_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fallbackActionResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeBasedInput")
    def response_code_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodesInput")
    def response_codes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayBasedInput")
    def response_delay_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseDelayBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayThresholdInput")
    def response_delay_threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseDelayThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBasedInput")
    def return_error_response_code_based_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "returnErrorResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBasedInput")
    def specify_your_own_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "specifyYourOwnResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBased")
    def fallback_action_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fallbackActionResponseCodeBased"))

    @fallback_action_response_code_based.setter
    def fallback_action_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbb555f35e51a8ca39ba7fba70d0a6153f8d6c38c0ffbe1d43c0500fcd89a11c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fallbackActionResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87f1eb6c3289dc192f84ca2d16e75750a223a63e9ad8a4ba71b469ac32a83738)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodeBased")
    def response_code_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseCodeBased"))

    @response_code_based.setter
    def response_code_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00345dc097fcd1403154dc5827223efc4d27e29bc9e7d337d01c6bd3757048e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodes")
    def response_codes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseCodes"))

    @response_codes.setter
    def response_codes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c5bb566dfa17cd450aa8959376f7628ac8f03b21dff1a4a05de8812a2fd19b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayBased")
    def response_delay_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseDelayBased"))

    @response_delay_based.setter
    def response_delay_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11328230e0251ae49b4d2da804cb34cbd63c7722b4ceb4e4eef2462661ee8a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayThreshold")
    def response_delay_threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseDelayThreshold"))

    @response_delay_threshold.setter
    def response_delay_threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8381386f90c226e8a6325d3149825139db8684ed2dbea3d31233fc9ca6ab6eb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBased")
    def return_error_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "returnErrorResponseCodeBased"))

    @return_error_response_code_based.setter
    def return_error_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c4c8e0a8637eff8a7c16b41a7e1be8f8be2dc54de372beb1ac62f3e1323e4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "returnErrorResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBased")
    def specify_your_own_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "specifyYourOwnResponseCodeBased"))

    @specify_your_own_response_code_based.setter
    def specify_your_own_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad77164588a2002ea8d80a20c89afb9098fc2d12fba849da2910d30eae469c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyYourOwnResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af5b6c0607eef58c425c0c9cdd8c329cfe9dbd5c73ba874586bf0da31d8ab8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e50ab4cd50eb9db6089d0968034c432a5dda19bfdb9c5871ea201eba39ff4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4438b133b42b4a152b5f15e3fff636c81f235042ec0c07853848cac7e5901e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "ab_logic": "abLogic",
        "ab_testing": "abTesting",
        "compression": "compression",
        "cookie_name": "cookieName",
        "enable_brotli_compression": "enableBrotliCompression",
        "enable_for_noncacheable": "enableForNoncacheable",
        "enable_preconnect": "enablePreconnect",
        "enable_push": "enablePush",
        "enable_ro": "enableRo",
        "locked": "locked",
        "preload_enable": "preloadEnable",
        "source": "source",
        "template_uuid": "templateUuid",
        "title_brotli": "titleBrotli",
        "title_http2_server_push": "titleHttp2ServerPush",
        "title_preconnect": "titlePreconnect",
        "title_preload": "titlePreload",
        "title_ro": "titleRo",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration:
    def __init__(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03601407b056a1865d07dd5a723267e303cc17fca8d4c326014c1482eba3b12)
            check_type(argname="argument ab_logic", value=ab_logic, expected_type=type_hints["ab_logic"])
            check_type(argname="argument ab_testing", value=ab_testing, expected_type=type_hints["ab_testing"])
            check_type(argname="argument compression", value=compression, expected_type=type_hints["compression"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument enable_brotli_compression", value=enable_brotli_compression, expected_type=type_hints["enable_brotli_compression"])
            check_type(argname="argument enable_for_noncacheable", value=enable_for_noncacheable, expected_type=type_hints["enable_for_noncacheable"])
            check_type(argname="argument enable_preconnect", value=enable_preconnect, expected_type=type_hints["enable_preconnect"])
            check_type(argname="argument enable_push", value=enable_push, expected_type=type_hints["enable_push"])
            check_type(argname="argument enable_ro", value=enable_ro, expected_type=type_hints["enable_ro"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preload_enable", value=preload_enable, expected_type=type_hints["preload_enable"])
            check_type(argname="argument source", value=source, expected_type=type_hints["source"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_brotli", value=title_brotli, expected_type=type_hints["title_brotli"])
            check_type(argname="argument title_http2_server_push", value=title_http2_server_push, expected_type=type_hints["title_http2_server_push"])
            check_type(argname="argument title_preconnect", value=title_preconnect, expected_type=type_hints["title_preconnect"])
            check_type(argname="argument title_preload", value=title_preload, expected_type=type_hints["title_preload"])
            check_type(argname="argument title_ro", value=title_ro, expected_type=type_hints["title_ro"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_logic is not None:
            self._values["ab_logic"] = ab_logic
        if ab_testing is not None:
            self._values["ab_testing"] = ab_testing
        if compression is not None:
            self._values["compression"] = compression
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if enable_brotli_compression is not None:
            self._values["enable_brotli_compression"] = enable_brotli_compression
        if enable_for_noncacheable is not None:
            self._values["enable_for_noncacheable"] = enable_for_noncacheable
        if enable_preconnect is not None:
            self._values["enable_preconnect"] = enable_preconnect
        if enable_push is not None:
            self._values["enable_push"] = enable_push
        if enable_ro is not None:
            self._values["enable_ro"] = enable_ro
        if locked is not None:
            self._values["locked"] = locked
        if preload_enable is not None:
            self._values["preload_enable"] = preload_enable
        if source is not None:
            self._values["source"] = source
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_brotli is not None:
            self._values["title_brotli"] = title_brotli
        if title_http2_server_push is not None:
            self._values["title_http2_server_push"] = title_http2_server_push
        if title_preconnect is not None:
            self._values["title_preconnect"] = title_preconnect
        if title_preload is not None:
            self._values["title_preload"] = title_preload
        if title_ro is not None:
            self._values["title_ro"] = title_ro
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def ab_logic(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to use Adaptive Acceleration in an A/B testing environment.

        To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        '''
        result = self._values.get("ab_logic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ab_testing(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        '''
        result = self._values.get("ab_testing")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compression(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        '''
        result = self._values.get("compression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_brotli_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression, converting your origin content to cache on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        '''
        result = self._values.get("enable_brotli_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_for_noncacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression to non-cacheable content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        '''
        result = self._values.get("enable_for_noncacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_preconnect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time.

        See ``Automatic Preconnect`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        '''
        result = self._values.get("enable_preconnect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_push(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Recognizes resources like JavaScript, CSS, and images  based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app.

        See ``Automatic Server Push`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        '''
        result = self._values.get("enable_push")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ro(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        '''
        result = self._values.get("enable_ro")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preload_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to preload necessary fonts before they fetch and process other resources.

        See ``Automatic Font Preload`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        '''
        result = self._values.get("preload_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def source(self) -> typing.Optional[builtins.str]:
        '''The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``.

        The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        '''
        result = self._values.get("source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_brotli(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        '''
        result = self._values.get("title_brotli")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_http2_server_push(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        '''
        result = self._values.get("title_http2_server_push")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preconnect(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        '''
        result = self._values.get("title_preconnect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preload(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        '''
        result = self._values.get("title_preload")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_ro(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        '''
        result = self._values.get("title_ro")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e911a7bf40d5f6be1c362a10916cae5dda76debc494afe0129709b38f24b383)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbLogic")
    def reset_ab_logic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbLogic", []))

    @jsii.member(jsii_name="resetAbTesting")
    def reset_ab_testing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbTesting", []))

    @jsii.member(jsii_name="resetCompression")
    def reset_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompression", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetEnableBrotliCompression")
    def reset_enable_brotli_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBrotliCompression", []))

    @jsii.member(jsii_name="resetEnableForNoncacheable")
    def reset_enable_for_noncacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableForNoncacheable", []))

    @jsii.member(jsii_name="resetEnablePreconnect")
    def reset_enable_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePreconnect", []))

    @jsii.member(jsii_name="resetEnablePush")
    def reset_enable_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePush", []))

    @jsii.member(jsii_name="resetEnableRo")
    def reset_enable_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreloadEnable")
    def reset_preload_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreloadEnable", []))

    @jsii.member(jsii_name="resetSource")
    def reset_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSource", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleBrotli")
    def reset_title_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleBrotli", []))

    @jsii.member(jsii_name="resetTitleHttp2ServerPush")
    def reset_title_http2_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleHttp2ServerPush", []))

    @jsii.member(jsii_name="resetTitlePreconnect")
    def reset_title_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreconnect", []))

    @jsii.member(jsii_name="resetTitlePreload")
    def reset_title_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreload", []))

    @jsii.member(jsii_name="resetTitleRo")
    def reset_title_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleRo", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="abLogicInput")
    def ab_logic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abLogicInput"))

    @builtins.property
    @jsii.member(jsii_name="abTestingInput")
    def ab_testing_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abTestingInput"))

    @builtins.property
    @jsii.member(jsii_name="compressionInput")
    def compression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "compressionInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompressionInput")
    def enable_brotli_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBrotliCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheableInput")
    def enable_for_noncacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableForNoncacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePreconnectInput")
    def enable_preconnect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePushInput")
    def enable_push_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePushInput"))

    @builtins.property
    @jsii.member(jsii_name="enableRoInput")
    def enable_ro_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadEnableInput")
    def preload_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceInput")
    def source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleBrotliInput")
    def title_brotli_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleBrotliInput"))

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPushInput")
    def title_http2_server_push_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleHttp2ServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreconnectInput")
    def title_preconnect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreloadInput")
    def title_preload_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreloadInput"))

    @builtins.property
    @jsii.member(jsii_name="titleRoInput")
    def title_ro_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleRoInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="abLogic")
    def ab_logic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abLogic"))

    @ab_logic.setter
    def ab_logic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e05afa5267c9dc2280ccb3ab28c010adff4d7b1fde3360ea0b3bcd50625daaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abLogic", value)

    @builtins.property
    @jsii.member(jsii_name="abTesting")
    def ab_testing(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abTesting"))

    @ab_testing.setter
    def ab_testing(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6010752efcd2997d22b85fa646e3a1ff272a0d703c8d6dcf098a34a996e32ef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abTesting", value)

    @builtins.property
    @jsii.member(jsii_name="compression")
    def compression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "compression"))

    @compression.setter
    def compression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a566ae8d8eeed22eb569db3a17c4bc9dc82df5c2d115fadd701c02ae12f1ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compression", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c521b01fc470e7bdedab73adb9f0643f25cc1b517f40fa05d3c3bc018c7d4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompression")
    def enable_brotli_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBrotliCompression"))

    @enable_brotli_compression.setter
    def enable_brotli_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10bf505b721e178b51b80dbd654fa6743de20f2c187b130909eb7f5656fb15d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBrotliCompression", value)

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheable")
    def enable_for_noncacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableForNoncacheable"))

    @enable_for_noncacheable.setter
    def enable_for_noncacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36542b6b7b438fefc0bc91f965e55688691e13da4cec16aecf3433d9d31f8fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableForNoncacheable", value)

    @builtins.property
    @jsii.member(jsii_name="enablePreconnect")
    def enable_preconnect(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePreconnect"))

    @enable_preconnect.setter
    def enable_preconnect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6e770b972ba7aacfaad86e618ecab567e79ad1f95fcc3b5c8b52bc1a6f52061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="enablePush")
    def enable_push(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePush"))

    @enable_push.setter
    def enable_push(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f9bedfe639b360ae665c6d556bc5b2606d2a82597c1d588461ba6e16f5e155f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePush", value)

    @builtins.property
    @jsii.member(jsii_name="enableRo")
    def enable_ro(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRo"))

    @enable_ro.setter
    def enable_ro(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4c0a80e6aa1a656778c84ac8ac316c4467fa989766f55090f60a352d966680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRo", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67378a377c5441894ecb1c7de1e77eb7d15b6d5978e02e816ea973d25a8e79a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preloadEnable")
    def preload_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preloadEnable"))

    @preload_enable.setter
    def preload_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488c3788035191dc2d3c0c195d482ae809528eea582a0d86d8d5942b3e17a1c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preloadEnable", value)

    @builtins.property
    @jsii.member(jsii_name="source")
    def source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "source"))

    @source.setter
    def source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1502524740759791789081b1e40e06703c100273c1c10316a80f08267445adce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "source", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6363945d40f0496ba8b54ba9a098c5eabd55be6cab894e326cd8e85ad5fe963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleBrotli")
    def title_brotli(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleBrotli"))

    @title_brotli.setter
    def title_brotli(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c4bbafe35c13dfe62376d5da8c83a432cc51f72de2b8d5662f6a366a29262cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleBrotli", value)

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPush")
    def title_http2_server_push(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleHttp2ServerPush"))

    @title_http2_server_push.setter
    def title_http2_server_push(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc5004cae1cc3b5a803aeb76660689bdb214f8286bb1bddaedf388c7bd1394f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleHttp2ServerPush", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreconnect")
    def title_preconnect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreconnect"))

    @title_preconnect.setter
    def title_preconnect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96e7c1578815f4974bccc1289bf889ca22da425d4b4dd37f1b722a25a64c767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreload")
    def title_preload(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreload"))

    @title_preload.setter
    def title_preload(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__076075ad04f860b7d97986e3b338629abcb78be428d8559e99f88abc3d23fbf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreload", value)

    @builtins.property
    @jsii.member(jsii_name="titleRo")
    def title_ro(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleRo"))

    @title_ro.setter
    def title_ro(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1308e9a7ca4daba6b3bfb5f25b1bf21574303e9deb99f8ceae3d4a3216b9b377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleRo", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9bcf44116e7d140ee93cc2ffbc3a5eb76200c9a6a980f385dd80a30c730a090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__334b05075cf7f69d7cbaea88f0b5cae0037c642cbac9cde40df1ece891e68756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression",
    jsii_struct_bases=[],
    name_mapping={
        "compress_mobile": "compressMobile",
        "compress_standard": "compressStandard",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier1_mobile_compression_method": "tier1MobileCompressionMethod",
        "tier1_mobile_compression_value": "tier1MobileCompressionValue",
        "tier1_standard_compression_method": "tier1StandardCompressionMethod",
        "tier1_standard_compression_value": "tier1StandardCompressionValue",
        "tier2_mobile_compression_method": "tier2MobileCompressionMethod",
        "tier2_mobile_compression_value": "tier2MobileCompressionValue",
        "tier2_standard_compression_method": "tier2StandardCompressionMethod",
        "tier2_standard_compression_value": "tier2StandardCompressionValue",
        "tier3_mobile_compression_method": "tier3MobileCompressionMethod",
        "tier3_mobile_compression_value": "tier3MobileCompressionValue",
        "tier3_standard_compression_method": "tier3StandardCompressionMethod",
        "tier3_standard_compression_value": "tier3StandardCompressionValue",
        "title_aic_mobile": "titleAicMobile",
        "title_aic_nonmobile": "titleAicNonmobile",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression:
    def __init__(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cebf18d475f7c002f80c62c1901d7a2c04faa29b99c0a6ecbbc749b94e175baa)
            check_type(argname="argument compress_mobile", value=compress_mobile, expected_type=type_hints["compress_mobile"])
            check_type(argname="argument compress_standard", value=compress_standard, expected_type=type_hints["compress_standard"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_mobile_compression_method", value=tier1_mobile_compression_method, expected_type=type_hints["tier1_mobile_compression_method"])
            check_type(argname="argument tier1_mobile_compression_value", value=tier1_mobile_compression_value, expected_type=type_hints["tier1_mobile_compression_value"])
            check_type(argname="argument tier1_standard_compression_method", value=tier1_standard_compression_method, expected_type=type_hints["tier1_standard_compression_method"])
            check_type(argname="argument tier1_standard_compression_value", value=tier1_standard_compression_value, expected_type=type_hints["tier1_standard_compression_value"])
            check_type(argname="argument tier2_mobile_compression_method", value=tier2_mobile_compression_method, expected_type=type_hints["tier2_mobile_compression_method"])
            check_type(argname="argument tier2_mobile_compression_value", value=tier2_mobile_compression_value, expected_type=type_hints["tier2_mobile_compression_value"])
            check_type(argname="argument tier2_standard_compression_method", value=tier2_standard_compression_method, expected_type=type_hints["tier2_standard_compression_method"])
            check_type(argname="argument tier2_standard_compression_value", value=tier2_standard_compression_value, expected_type=type_hints["tier2_standard_compression_value"])
            check_type(argname="argument tier3_mobile_compression_method", value=tier3_mobile_compression_method, expected_type=type_hints["tier3_mobile_compression_method"])
            check_type(argname="argument tier3_mobile_compression_value", value=tier3_mobile_compression_value, expected_type=type_hints["tier3_mobile_compression_value"])
            check_type(argname="argument tier3_standard_compression_method", value=tier3_standard_compression_method, expected_type=type_hints["tier3_standard_compression_method"])
            check_type(argname="argument tier3_standard_compression_value", value=tier3_standard_compression_value, expected_type=type_hints["tier3_standard_compression_value"])
            check_type(argname="argument title_aic_mobile", value=title_aic_mobile, expected_type=type_hints["title_aic_mobile"])
            check_type(argname="argument title_aic_nonmobile", value=title_aic_nonmobile, expected_type=type_hints["title_aic_nonmobile"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compress_mobile is not None:
            self._values["compress_mobile"] = compress_mobile
        if compress_standard is not None:
            self._values["compress_standard"] = compress_standard
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_mobile_compression_method is not None:
            self._values["tier1_mobile_compression_method"] = tier1_mobile_compression_method
        if tier1_mobile_compression_value is not None:
            self._values["tier1_mobile_compression_value"] = tier1_mobile_compression_value
        if tier1_standard_compression_method is not None:
            self._values["tier1_standard_compression_method"] = tier1_standard_compression_method
        if tier1_standard_compression_value is not None:
            self._values["tier1_standard_compression_value"] = tier1_standard_compression_value
        if tier2_mobile_compression_method is not None:
            self._values["tier2_mobile_compression_method"] = tier2_mobile_compression_method
        if tier2_mobile_compression_value is not None:
            self._values["tier2_mobile_compression_value"] = tier2_mobile_compression_value
        if tier2_standard_compression_method is not None:
            self._values["tier2_standard_compression_method"] = tier2_standard_compression_method
        if tier2_standard_compression_value is not None:
            self._values["tier2_standard_compression_value"] = tier2_standard_compression_value
        if tier3_mobile_compression_method is not None:
            self._values["tier3_mobile_compression_method"] = tier3_mobile_compression_method
        if tier3_mobile_compression_value is not None:
            self._values["tier3_mobile_compression_value"] = tier3_mobile_compression_value
        if tier3_standard_compression_method is not None:
            self._values["tier3_standard_compression_method"] = tier3_standard_compression_method
        if tier3_standard_compression_value is not None:
            self._values["tier3_standard_compression_value"] = tier3_standard_compression_value
        if title_aic_mobile is not None:
            self._values["title_aic_mobile"] = title_aic_mobile
        if title_aic_nonmobile is not None:
            self._values["title_aic_nonmobile"] = title_aic_nonmobile
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compress_mobile(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over cellular mobile networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        '''
        result = self._values.get("compress_mobile")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def compress_standard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over non-cellular networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        '''
        result = self._values.get("compress_standard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        '''
        result = self._values.get("tier1_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        '''
        result = self._values.get("tier1_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier1_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        '''
        result = self._values.get("tier1_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        '''
        result = self._values.get("tier1_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        '''
        result = self._values.get("tier2_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        '''
        result = self._values.get("tier2_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        '''
        result = self._values.get("tier2_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        '''
        result = self._values.get("tier2_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        '''
        result = self._values.get("tier3_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        '''
        result = self._values.get("tier3_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        '''
        result = self._values.get("tier3_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        '''
        result = self._values.get("tier3_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def title_aic_mobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        '''
        result = self._values.get("title_aic_mobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_aic_nonmobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        '''
        result = self._values.get("title_aic_nonmobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da91c89a6409044a5c680b8d887775d941320f43c1663dca34ce74c4127342b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompressMobile")
    def reset_compress_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressMobile", []))

    @jsii.member(jsii_name="resetCompressStandard")
    def reset_compress_standard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressStandard", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionMethod")
    def reset_tier1_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionValue")
    def reset_tier1_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionMethod")
    def reset_tier1_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionValue")
    def reset_tier1_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionMethod")
    def reset_tier2_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionValue")
    def reset_tier2_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionMethod")
    def reset_tier2_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionValue")
    def reset_tier2_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionMethod")
    def reset_tier3_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionValue")
    def reset_tier3_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionMethod")
    def reset_tier3_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionValue")
    def reset_tier3_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTitleAicMobile")
    def reset_title_aic_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicMobile", []))

    @jsii.member(jsii_name="resetTitleAicNonmobile")
    def reset_title_aic_nonmobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicNonmobile", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compressMobileInput")
    def compress_mobile_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="compressStandardInput")
    def compress_standard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressStandardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethodInput")
    def tier1_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValueInput")
    def tier1_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethodInput")
    def tier1_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValueInput")
    def tier1_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethodInput")
    def tier2_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValueInput")
    def tier2_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethodInput")
    def tier2_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValueInput")
    def tier2_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethodInput")
    def tier3_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValueInput")
    def tier3_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethodInput")
    def tier3_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValueInput")
    def tier3_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicMobileInput")
    def title_aic_mobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobileInput")
    def title_aic_nonmobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicNonmobileInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compressMobile")
    def compress_mobile(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressMobile"))

    @compress_mobile.setter
    def compress_mobile(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__266c03a7ac3ff3e6a4e37c3e139080ce3207c243a54a7917d3fe36bf44e07098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressMobile", value)

    @builtins.property
    @jsii.member(jsii_name="compressStandard")
    def compress_standard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressStandard"))

    @compress_standard.setter
    def compress_standard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36a8e10c11ce995c3a49e5ff40798e3cf313a6c39a50e5c9114e5224f2b0ed7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressStandard", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127fbf22484b36523c27cfd7b514ff4298e39df94de2bedb0e154b7f1bc7361d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241a3f387365a107c6c0efb38865ed3ce4197ccb2e38dc56a94ce1a83cb0b596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethod")
    def tier1_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1MobileCompressionMethod"))

    @tier1_mobile_compression_method.setter
    def tier1_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42e97d158edcd0b59fae51f0016e6cda2f1707ca9306595b42969f8c118d1c04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValue")
    def tier1_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1MobileCompressionValue"))

    @tier1_mobile_compression_value.setter
    def tier1_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed6da36f5211bd5d705f74f99ad4aaef3e0c088deb2aba75885f4dcd522d62e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethod")
    def tier1_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1StandardCompressionMethod"))

    @tier1_standard_compression_method.setter
    def tier1_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbf5d97d42d39ad8deebaa4632401f8e5924870de7d9d9250d985d0e8b99c16d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValue")
    def tier1_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1StandardCompressionValue"))

    @tier1_standard_compression_value.setter
    def tier1_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9b375ef8b897fe41b77a2e134fbd67cd9f9296d8cd1f338783088aac043fb91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethod")
    def tier2_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2MobileCompressionMethod"))

    @tier2_mobile_compression_method.setter
    def tier2_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241759cd34e8ce0eb9bc198e0f45e9c7554492f4720e026f476f75c4a9a4b297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValue")
    def tier2_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2MobileCompressionValue"))

    @tier2_mobile_compression_value.setter
    def tier2_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6630aefc244400f8d71d44ae6739eaa258b38e54515831890159dafe0e49e12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethod")
    def tier2_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2StandardCompressionMethod"))

    @tier2_standard_compression_method.setter
    def tier2_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3cb3257374e20f27ab379e2c7c0b7fb1fb9dbcb029c2b86e3138575bd9f4dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValue")
    def tier2_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2StandardCompressionValue"))

    @tier2_standard_compression_value.setter
    def tier2_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd65545a72efe4ffae111af8c2420e8668bcc815d400e34109496f64b5e4304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethod")
    def tier3_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3MobileCompressionMethod"))

    @tier3_mobile_compression_method.setter
    def tier3_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a6f2589ba602093670a296e431026e5e10ef3a225e431e475f16b653d284bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValue")
    def tier3_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3MobileCompressionValue"))

    @tier3_mobile_compression_value.setter
    def tier3_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c82361e47b4c6b0484d5592b83cf2312e13b479b57892ba12cc2dfc0ca62c91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethod")
    def tier3_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3StandardCompressionMethod"))

    @tier3_standard_compression_method.setter
    def tier3_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1507501b7371b3b8aedc2742b93f3a9a4fdb433e6c5917c3c61123520585c7a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValue")
    def tier3_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3StandardCompressionValue"))

    @tier3_standard_compression_value.setter
    def tier3_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e02748b16ef4b940b37a29bcb1f06b61ea1da9674e2b7066c087b78d1981c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicMobile")
    def title_aic_mobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicMobile"))

    @title_aic_mobile.setter
    def title_aic_mobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be93ab37c6483bc7d2ab9f6ec56b00eb442e733fa4717d3b540947d0cfd1ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicMobile", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobile")
    def title_aic_nonmobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicNonmobile"))

    @title_aic_nonmobile.setter
    def title_aic_nonmobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed33de33184eb40a849e85c27b98d1d359e1a042e762a23ed671c6c4f3b18be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicNonmobile", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a67d935e747f0f04dbd63fdb9d91f1d17f7384cd59967a3f8f935b50305de4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2baa818758fc20d6651b4212a172d0523787371fa668219895223780fe8a7317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969be3e324a55275910b78a9f4af967838503dd827b894aafe263afd4d6cabf3)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d26fafbebc2c388f795e475d9634dd518a12773538b191cfedd3d1a24cea9a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8ccc2107a89ca7e9b96d52da43a31f4a6d046cfb64da841bf178f0dee24c09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9019cf6a5d0dc5a8c1faf1ab44464c84447f54a3a1edee1a0c2b6c3765c603a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3239109fc28a487da48f61796d06e26c2d7abd65e160e7bdfecbc5caf153f1cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa852049ac9d3016338c0189c0b60b7ca62ab9ca5a8f3cb4d2b6e21a051b5e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0f3f16fcf40e4d87d60171a516f4bc72d80f826bcd73caaacd4916cda08b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64b8172df0f8bb1ad7a4b142cddcedecd40e3aba635ba925a4e8f508d118e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting",
    jsii_struct_bases=[],
    name_mapping={
        "attribute1": "attribute1",
        "attribute2": "attribute2",
        "attribute3": "attribute3",
        "attribute4": "attribute4",
        "attributes_count": "attributesCount",
        "enabled": "enabled",
        "locked": "locked",
        "report_name": "reportName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting:
    def __init__(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df11c524af6c98992f9f1a929ca163fe9c1df1de23b95a5e62bdb7f5a3232e83)
            check_type(argname="argument attribute1", value=attribute1, expected_type=type_hints["attribute1"])
            check_type(argname="argument attribute2", value=attribute2, expected_type=type_hints["attribute2"])
            check_type(argname="argument attribute3", value=attribute3, expected_type=type_hints["attribute3"])
            check_type(argname="argument attribute4", value=attribute4, expected_type=type_hints["attribute4"])
            check_type(argname="argument attributes_count", value=attributes_count, expected_type=type_hints["attributes_count"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument report_name", value=report_name, expected_type=type_hints["report_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if attribute1 is not None:
            self._values["attribute1"] = attribute1
        if attribute2 is not None:
            self._values["attribute2"] = attribute2
        if attribute3 is not None:
            self._values["attribute3"] = attribute3
        if attribute4 is not None:
            self._values["attribute4"] = attribute4
        if attributes_count is not None:
            self._values["attributes_count"] = attributes_count
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if report_name is not None:
            self._values["report_name"] = report_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def attribute1(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        '''
        result = self._values.get("attribute1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute2(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        '''
        result = self._values.get("attribute2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute3(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        '''
        result = self._values.get("attribute3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute4(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        '''
        result = self._values.get("attribute4")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attributes_count(self) -> typing.Optional[jsii.Number]:
        '''The number of attributes to include in the report, ranging from 1 to 4.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        '''
        result = self._values.get("attributes_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables aggregated reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def report_name(self) -> typing.Optional[builtins.str]:
        '''The unique name of the aggregated report within the property.

        If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        '''
        result = self._values.get("report_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023f166189afb2984d7899c436028b34d3111c44b409022519309dd041da17a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAttribute1")
    def reset_attribute1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute1", []))

    @jsii.member(jsii_name="resetAttribute2")
    def reset_attribute2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute2", []))

    @jsii.member(jsii_name="resetAttribute3")
    def reset_attribute3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute3", []))

    @jsii.member(jsii_name="resetAttribute4")
    def reset_attribute4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute4", []))

    @jsii.member(jsii_name="resetAttributesCount")
    def reset_attributes_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttributesCount", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReportName")
    def reset_report_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReportName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="attribute1Input")
    def attribute1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute1Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute2Input")
    def attribute2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute2Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute3Input")
    def attribute3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute3Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute4Input")
    def attribute4_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute4Input"))

    @builtins.property
    @jsii.member(jsii_name="attributesCountInput")
    def attributes_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "attributesCountInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reportNameInput")
    def report_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reportNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="attribute1")
    def attribute1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute1"))

    @attribute1.setter
    def attribute1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3819c4ae8161c6bca4a2b19efbd827d9e45c30347468e81746a0674803a42867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute1", value)

    @builtins.property
    @jsii.member(jsii_name="attribute2")
    def attribute2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute2"))

    @attribute2.setter
    def attribute2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8482fa6d1782169c54828199f757c5eed3a5d9798d82930ac778590517f44aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute2", value)

    @builtins.property
    @jsii.member(jsii_name="attribute3")
    def attribute3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute3"))

    @attribute3.setter
    def attribute3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e19b015140278ff2fc7d0c2720336b1a47c5fc11c7b487fe44d1d33d91889d83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute3", value)

    @builtins.property
    @jsii.member(jsii_name="attribute4")
    def attribute4(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute4"))

    @attribute4.setter
    def attribute4(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e834c5929c40a82a1a037b6599a6a3c8a4e4421d66a8000a516be7db0f293e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute4", value)

    @builtins.property
    @jsii.member(jsii_name="attributesCount")
    def attributes_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "attributesCount"))

    @attributes_count.setter
    def attributes_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef927777e3030c5c41b43e7ca2c464bce588d4a368ace2ddf30bc070b8b1702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attributesCount", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df16c5c485b6f2dbc268fa3cfb35291831219f378522d4e607731ba2b05012dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be1c043322340aeb4b95102b8beac7940ee00cdc475a00df48a89e82df7579c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reportName")
    def report_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reportName"))

    @report_name.setter
    def report_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38a468e3c07e5ff879c956ee1fb288e1f80757e131d490f3fa34100decb8bde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reportName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b927de752dc263d584fd2243129c0fc1e5e1b38b285484cd675b35d0bbf6ecfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__874f91f7d1eac42f04b7d2481fb73aef35421132e96efe21edd57f2c91898477)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208191ae921f2781edeadce05475020857cb7b3e01d1fbcf397e6ac09340454e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7792f47ca844999a6349af91edd6a9aa756b4f93ae9b987ba183c12ff89e6389)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamaizer behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fed718b598ead6d1e523df8903128dfc56e87bb20755e8799089c3e1f77a0c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a69ec409d10139ced40fd870dfb8a8019ceaccaca9b43c5e1c37f87968a4bd90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0320db48303843799236539e110a125c27dfe902284d0d90b5ec5d084df1685b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beebfc94351e7d6c9ce130d601df08d13d5188666598a44aede78420f62f9044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def0aa5a67729e3a8643e4ed7078e40b9a967bb248d50892d2812b2d02afcf2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3883910e8721fe376ca9a6340f1c69b4021630f07421fe9bb03b177493aff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag",
    jsii_struct_bases=[],
    name_mapping={
        "include_tags_attribute": "includeTagsAttribute",
        "locked": "locked",
        "match_hostname": "matchHostname",
        "replace_all": "replaceAll",
        "replacement_hostname": "replacementHostname",
        "scope": "scope",
        "tags_attribute": "tagsAttribute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag:
    def __init__(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1610e29bed0758940426f9b07c5400da7a681a42ca64dcec10a4a101490b791a)
            check_type(argname="argument include_tags_attribute", value=include_tags_attribute, expected_type=type_hints["include_tags_attribute"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_hostname", value=match_hostname, expected_type=type_hints["match_hostname"])
            check_type(argname="argument replace_all", value=replace_all, expected_type=type_hints["replace_all"])
            check_type(argname="argument replacement_hostname", value=replacement_hostname, expected_type=type_hints["replacement_hostname"])
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument tags_attribute", value=tags_attribute, expected_type=type_hints["tags_attribute"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if include_tags_attribute is not None:
            self._values["include_tags_attribute"] = include_tags_attribute
        if locked is not None:
            self._values["locked"] = locked
        if match_hostname is not None:
            self._values["match_hostname"] = match_hostname
        if replace_all is not None:
            self._values["replace_all"] = replace_all
        if replacement_hostname is not None:
            self._values["replacement_hostname"] = replacement_hostname
        if scope is not None:
            self._values["scope"] = scope
        if tags_attribute is not None:
            self._values["tags_attribute"] = tags_attribute
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def include_tags_attribute(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the ``tagsAttribute`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        '''
        result = self._values.get("include_tags_attribute")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to match on as a Perl-compatible regular expression.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        '''
        result = self._values.get("match_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replace_all(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches when enabled, otherwise replaces only the first match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        '''
        result = self._values.get("replace_all")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def replacement_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement hostname for the tag to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        '''
        result = self._values.get("replacement_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scope(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of HTML content the ``tagsAttribute`` refers to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        '''
        result = self._values.get("scope")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tags_attribute(self) -> typing.Optional[builtins.str]:
        '''Specifies the tag or tag/attribute combination to operate on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        '''
        result = self._values.get("tags_attribute")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c3c0e10100a34b7ede4e4e5a2d6354e606a2e3928285f24bf2a4a8c0edb634)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetIncludeTagsAttribute")
    def reset_include_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeTagsAttribute", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchHostname")
    def reset_match_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchHostname", []))

    @jsii.member(jsii_name="resetReplaceAll")
    def reset_replace_all(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplaceAll", []))

    @jsii.member(jsii_name="resetReplacementHostname")
    def reset_replacement_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacementHostname", []))

    @jsii.member(jsii_name="resetScope")
    def reset_scope(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScope", []))

    @jsii.member(jsii_name="resetTagsAttribute")
    def reset_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTagsAttribute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttributeInput")
    def include_tags_attribute_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeTagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchHostnameInput")
    def match_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="replaceAllInput")
    def replace_all_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "replaceAllInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementHostnameInput")
    def replacement_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="scopeInput")
    def scope_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scopeInput"))

    @builtins.property
    @jsii.member(jsii_name="tagsAttributeInput")
    def tags_attribute_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttribute")
    def include_tags_attribute(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeTagsAttribute"))

    @include_tags_attribute.setter
    def include_tags_attribute(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd74ed4cbbce5761dbfff1d707156c5f62a5d8eabab3735f4a070a4be6045ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeTagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a48472aa4a645e7860853cde070b203b52f29f1763008f0293a17c51419f20c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchHostname")
    def match_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchHostname"))

    @match_hostname.setter
    def match_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a8f6d924e2ecaac10f0dbea7f22c046df3f5f62790aecb47fb782c5faaebc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchHostname", value)

    @builtins.property
    @jsii.member(jsii_name="replaceAll")
    def replace_all(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "replaceAll"))

    @replace_all.setter
    def replace_all(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0665cff6281c1f558f4f6eaecec4059573db855685f9ad2ee7995698ef90c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replaceAll", value)

    @builtins.property
    @jsii.member(jsii_name="replacementHostname")
    def replacement_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacementHostname"))

    @replacement_hostname.setter
    def replacement_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4193dfaf2d71bfe24d7cde7aed4cf44d15b60cac2d58ff1ea3baba280dfce4b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacementHostname", value)

    @builtins.property
    @jsii.member(jsii_name="scope")
    def scope(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scope"))

    @scope.setter
    def scope(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d666cc1d2d4239913ec88bcfe5859d21fc9bf16393f0d1515168109e859b04b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scope", value)

    @builtins.property
    @jsii.member(jsii_name="tagsAttribute")
    def tags_attribute(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tagsAttribute"))

    @tags_attribute.setter
    def tags_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23b06489b395756ae9afcca5a916aa811c1eb6e9e6996c6f10b96a8850d94be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efe4ba885a3e4c4cb086cd273ac1b3665aaaa4a328524ea2dd23141062a3557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c0815298db194d9d4fce8ef9449b89f763baf911e3b3766768f04c05c73fccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b1d96c0f0cf2b09ffdc90d637e1e60e5ed9e3e981b377e6637de2708206027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7ad3f9074f731a9aa4839441d04519e7061d6c43b2fbe39a3d0c463f829a979)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables all HTTP requests for parent servers in the cache hierarchy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed2e695d684c36d23b888c64a690012c3a0d7b217f9c483113bc7523ffd2f40)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7300e5e4192ee843c4b668028b55b86f42057944b84915b7ebbc02eaed7c3b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e5045bba833d05aee7813fe72e81aff84a29557331f4d2427f057541f61e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b16a9efafce966d6b59383a1452471739d14bf88cd1b549881a1c8c094ce5bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337347996b626654750b418f13e3498a97605c8fd0c8c93aeeee66d9dad35d14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__023e6d42250b1c280f2980e0571ba0a4f6ac240f25ba4699781263fad5e866d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "honor_base_directory": "honorBaseDirectory",
        "locked": "locked",
        "purge_origin_query_parameter": "purgeOriginQueryParameter",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db4dee9fa4053dadd519fc41967684d3b5820d7a9a5d1aebbed60c62b2a7c5e2)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument honor_base_directory", value=honor_base_directory, expected_type=type_hints["honor_base_directory"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_origin_query_parameter", value=purge_origin_query_parameter, expected_type=type_hints["purge_origin_query_parameter"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if honor_base_directory is not None:
            self._values["honor_base_directory"] = honor_base_directory
        if locked is not None:
            self._values["locked"] = locked
        if purge_origin_query_parameter is not None:
            self._values["purge_origin_query_parameter"] = purge_origin_query_parameter
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_base_directory(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior.

        If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        '''
        result = self._values.get("honor_base_directory")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_origin_query_parameter(self) -> typing.Optional[builtins.str]:
        '''When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge.

        Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        '''
        result = self._values.get("purge_origin_query_parameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOriginsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOriginsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__118a42e969f824320a4812fd7977560bf4ea5533bef4dd4f6a1cdfccd28fa46a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHonorBaseDirectory")
    def reset_honor_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorBaseDirectory", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeOriginQueryParameter")
    def reset_purge_origin_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeOriginQueryParameter", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectoryInput")
    def honor_base_directory_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorBaseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameterInput")
    def purge_origin_query_parameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeOriginQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c77de57815ae579be9c28093c21e35d3c72081a744c98c24de3b47bc105c584)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectory")
    def honor_base_directory(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorBaseDirectory"))

    @honor_base_directory.setter
    def honor_base_directory(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c10e85810e4915f88335f23658eedb7f0e9eeef534e1052d64a9daa5c765ca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorBaseDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af05c2798ca9f9b53814bceba14dc56131425f5eb4288f1d3b566a7e0a2f8397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameter")
    def purge_origin_query_parameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeOriginQueryParameter"))

    @purge_origin_query_parameter.setter
    def purge_origin_query_parameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1027503cc65facbf6027d92fbb6c94bd9b4da04a4cb2a901d15e4a93820dd69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeOriginQueryParameter", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dbf641a9b4c01cf534698ada7feb4afe0a3126666fcc20afc7b2e4966e1b26a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ddd61c14e0ee48510cbfbcb3c65782563a0fac628bfa8d84787e4e8a53398ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db61597af6f5c065a3ddab30ed7324a8fc89e246af580a343764504db7d53275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete",
    jsii_struct_bases=[],
    name_mapping={
        "allow_body": "allowBody",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete:
    def __init__(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de222f1e0f4292db569526df9c48a2e3616f7ec99302c11003610f8688b33c8)
            check_type(argname="argument allow_body", value=allow_body, expected_type=type_hints["allow_body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_body is not None:
            self._values["allow_body"] = allow_body
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_body(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows data in the body of the DELETE request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        '''
        result = self._values.get("allow_body")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows DELETE requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDeleteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDeleteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936e26052b2cb208d2b2c49cd3c02ccda3d62e6c68aa439fbea74b605662ac91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBody")
    def reset_allow_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBodyInput")
    def allow_body_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBody")
    def allow_body(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowBody"))

    @allow_body.setter
    def allow_body(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d481dbd022871ad8cb12b92750d5141fe6e93b9b82173a7e99637813b63c5a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBody", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd73dd4a474de5119672b7ebe922d6575f9e5a0357573efb0fd134edc084fd8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01911dfd2abf2d54d804c9ca6f3453c5dd2fc907ed0db92fa67122447fc6cfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__747fda052648b2d540b7f083c7313c6364319e44c86b82a18dfcbee57b65b505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59eefd4392a9cf39879b04bc78a426d906de79ee2bbc6a356a45cc9140f08076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49833cd1a50e3b52ed5ece355c68efffd6c8c80319a60d62ba5ab1589457d9a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__335114baf35d251c3d365cc70c0dac3c78ee04a4e61434fb2764c2145fd7646a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HTTPS cache key sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a8b1823067e45c027cb0b4dcd915ffe02d57b9c768aaee22c1f296adcc0792)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f23e54ec4dfd78bc22cb60b2f5468a1ef90f0d3ecc021de5303e53b0f305d05a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6140e2d8abb96c8ffe18caa76a4079fd5f7936b503ca6341b3b0ea001d21f1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c8dbd364e8e26308d911b9ce38c55569a229cfc921332e895d2512f6fb8a257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb0213dafaa9d7ba1aeb25d60311bff70023283653a00cc1d3a4e548892e083)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b58e7e9673ea0dded6069e46c4df006fb6b16f12ab183c22e58da682b377d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a48a0e83f95f0c7ca260e7badaa05e026b2d0949bba62a3c4539eb8644c33736)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Downgrades to HTTP protocol for the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ed03c8e5368dde30d1b60e084d3f7a08dea3e7452abba5866149ac8b3108fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15738793b5194c14c69b6a7762d246f17df40a4fbc19b251ff18de5b26c8832d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0275f9ab98f0b6b8d804abed312e6d1eb4b99cb67f73ca8c9423d58819a00d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426c7e6fc9c2c15d40a9d3587f642ebd088d94492e055056d1ee478adef597aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1373a24131e0fd90bee03c603c0355b1c49742ac8a80cc7b6813cb338bcea88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0466cb53e38ea37da6aa93e4b39d5405d6d85491d4b2b8822d153b3136d342be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__840dae6eb885601a149d8b9602dfe36332b0b9f75334fda471d9e08a99bc4fef)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response.

        Set this to ``false`` to deny OPTIONS requests and respond with a 501 error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728407044625c926d05582c69c935b90681bc71b504731fae21a0a0a2353731a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b587ad3087ec3803c1fc8d9c141289b714d3f1e8b7437519b91de07c7837f161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__030291359415a6ed93fc23da87a907255449f8a147602f73eb5d6b19773cb57c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eed07ebb4b7e61cf5f3d13595fc5bf7a5c24b7c63ecdee287df6e794d6214a67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090387589be191e85f21839e9b8744f58d105032ac416cd24493a0eba10cc76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8662dd953fd1f2b3af546f856efa3019f8fd41fb65c9546b8b57b1e99c487e14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14ec539aea7c20e063a9bf899459fc1cf91b9917b4ca3267bf313a1bfa19caf2)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PATCH requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b5f10395c0c302e94bf7c2ab6bb8d2e3aebd4a269822af42087701c97852aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ad846835982be5d4a7d5d8d78c8de6963c23b26d1befc375e02e8425d3a407)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e40a32c85b09ea3a3a2f274f2aa05a5ddd88b752f8add5eb64fd1f34354e4379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b60a5261d4dde7be86f4ea77af914e65df77060adf9b53d1f883b5a4cf7333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a1cc00c1702832dbeda11efa04fbc7b0881a199265556c6e2ce1468f66aca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234284ea468c17e99bbdb0f68e14f912801d28094895e1a79e8a5c03de5baf7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost",
    jsii_struct_bases=[],
    name_mapping={
        "allow_without_content_length": "allowWithoutContentLength",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost:
    def __init__(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3044c68a43f989f16266d5ed56062373db81c1e1d33a63c59a47af237af4747)
            check_type(argname="argument allow_without_content_length", value=allow_without_content_length, expected_type=type_hints["allow_without_content_length"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_without_content_length is not None:
            self._values["allow_without_content_length"] = allow_without_content_length
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_without_content_length(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error.

        With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        '''
        result = self._values.get("allow_without_content_length")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb90db7b8eb437a88ac05c794a5db9b33d13ed32515c3ddec653b7c6e5aac01d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowWithoutContentLength")
    def reset_allow_without_content_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowWithoutContentLength", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLengthInput")
    def allow_without_content_length_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowWithoutContentLengthInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLength")
    def allow_without_content_length(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowWithoutContentLength"))

    @allow_without_content_length.setter
    def allow_without_content_length(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c7d611721cd6a0b7aab1cbf4d62071bc8a1c871784de7dc00c13a57a9afc1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowWithoutContentLength", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aefdaafdadf5378e3aaf26ef0f550493bd0bca0aaf152ea1a0ac2892e6dc5c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361973cb78bd31a5fc2b6aa53100dc78288e6e2dc005fca7d36e2194c7c29a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17e62f193fec1af248f8827201c98d485d09bb0d89f480208213caab45ee5f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b54df05f2a66a22722b719efada68d50c39c33162a80fa81706818c5ce78ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d7d8f9bc2154a8fe7dc41d9446c23d638df1602c1fdf7772c5267e7001ecc08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3565981b331d4d35f76c14fa6677beba3a01277d6d8196777b37e04240d52f3a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PUT requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d4c3363ddb2f44d8537f9caaf78e102a3ee8c750cf504487e4d489d332ac20)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8051069463c60042c23d4a6ca6ac6ced122add7d07f59402250c2f1e6e29084c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b61898e8fb7aad56f2336d75376c6531aa4fb48349d5c79f1ff2f4328dc797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__630400080dd24350219d0b0e57674d9498730556df799206b9f1bdc351c85067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50438f34250a78581544aab5ca9494512987ba71374f6cb143b4873e7b0733eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bcbf1cdb663f69640aa0ca4afe2178dcf60c9342c33247127b8698f77b9eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1d9d2e74cb2e54b049922ff44987744faa9c9f7ea192494563b6d1e2dff110)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Chunked Transfer Encoding requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncodingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncodingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8172cb505082862e359e2f950e136846c9ef54864b238049cbf25afecc1538bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154755a462b6d25d6c44f06b128e0b33ed764269d6e93ec72f6817d9f0581481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75c06aec69d7f4aba78ee1fc7a4eac5f139836441c10af9c755d789db8fab3bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d721dbac9b9fc3b0b5416c76f5e668a324fc72a2d639d21d2a78a5ada2d6ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8e96ffd6023a75ad5b4d0f5ad10968c673b896f553e8317aa16bda9429bf51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a8ac0951405e3123631b1cbe651360393dc44bedeb9f6c2561fe6ffaff4f7bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "max_age": "maxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35fcb5690b9d7a8b7918fdfb9f620ef2145788734f15274b3c318d64d59c053)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[jsii.Number]:
        '''Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header.

        The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__868719e38a6349c2237fa53450cf6da724a51d3fac7399d2d07452bba9514c78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddcde37634ecddfcc7b0029bf1053f4b85ad2c94ab12c524779543cf3bb4484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c487c0386cc4fa4d798ca66a335c5fc13d2a1e00a5c21802c67b80fabf8c9392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db45e5eff8cadbf20153bb5d8a8e69a51f9cbfcd9e9d82f3ccabd7b868fd5151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88f70c83ff6e38ade7ca84956a4b65d4a63b1c016a8301f17e83bc866b1f4a7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd74121c1000f20f31378ea524157ff2bed5b2e1b695ebf57c6c5d42c79d468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "alternate_response_cache_ttl": "alternateResponseCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "net_storage": "netStorage",
        "net_storage_path": "netStoragePath",
        "template_uuid": "templateUuid",
        "throttled_cp_code": "throttledCpCode",
        "throttled_status_code": "throttledStatusCode",
        "use_throttled_cp_code": "useThrottledCpCode",
        "use_throttled_status_code": "useThrottledStatusCode",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization:
    def __init__(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage(**net_storage)
        if isinstance(throttled_cp_code, dict):
            throttled_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode(**throttled_cp_code)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d534cd11e3bff977f2fd760108d6b088f9253446f0b0e8eaee7ee7c3c9825669)
            check_type(argname="argument alternate_response_cache_ttl", value=alternate_response_cache_ttl, expected_type=type_hints["alternate_response_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throttled_cp_code", value=throttled_cp_code, expected_type=type_hints["throttled_cp_code"])
            check_type(argname="argument throttled_status_code", value=throttled_status_code, expected_type=type_hints["throttled_status_code"])
            check_type(argname="argument use_throttled_cp_code", value=use_throttled_cp_code, expected_type=type_hints["use_throttled_cp_code"])
            check_type(argname="argument use_throttled_status_code", value=use_throttled_status_code, expected_type=type_hints["use_throttled_status_code"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if alternate_response_cache_ttl is not None:
            self._values["alternate_response_cache_ttl"] = alternate_response_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throttled_cp_code is not None:
            self._values["throttled_cp_code"] = throttled_cp_code
        if throttled_status_code is not None:
            self._values["throttled_status_code"] = throttled_status_code
        if use_throttled_cp_code is not None:
            self._values["use_throttled_cp_code"] = use_throttled_cp_code
        if use_throttled_status_code is not None:
            self._values["use_throttled_status_code"] = use_throttled_status_code
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def alternate_response_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the alternate response's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        '''
        result = self._values.get("alternate_response_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the API Prioritization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this API Prioritization policy from any others in the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''Specify the full NetStorage path for the alternate response, including trailing file name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throttled_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode"]:
        '''throttled_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        '''
        result = self._values.get("throttled_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode"], result)

    @builtins.property
    def throttled_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code for requests that receive the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        '''
        result = self._values.get("throttled_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def use_throttled_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to apply an alternative CP code for requests served the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        '''
        result = self._values.get("use_throttled_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def use_throttled_status_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a specific HTTP response code to a throttled request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        '''
        result = self._values.get("use_throttled_status_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4070c66f0a617f05e665141b3181e8fa80c66d8858a9c7a1056f01668d5f3d6f)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294ee4fe1d91089ea8727225a060be46e5c2849fe0276669a0236560a6acae5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be4ba69c959ea536b6cd0aa5104c61d44b417df0939f6d1578beb17116d39227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b628e68980a14004e5bd4e841d20973970cfb54bc9d053c2e26823c3522fc50f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2103a8eaf7548cb78910fce4f23cd41180f59304f261a81d1c9981c8e33c3017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9742d9c86a284c32454cbb2e62da65d61b0372502e2e619444526b2fc5ad65)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e343ef79b5e0fc77a7bf4ea9a3a5db06443f0cae9841152de9ee7758876a503d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__776787ed6acd819cef9c03cc7d72f92aa401040e27d02334ad030ce1c0787296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cedd902b57a42d60f58d0f5efbe3ad15e426d112d018e52ee6acc8c4b5d4575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fccece3647b047f4cad52555e37c6c71b8f741d8a6bfb49bf687c720bd1e3fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a7cc571e53fb5d1ef57693e1ab45f258298e233bc8d8897f7af3b3ce7c9e648)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd51f14966e6dc76ea36fe48f4f2bf4849fac7770e18d76096db0f81f4020593)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="putThrottledCpCode")
    def put_throttled_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putThrottledCpCode", [value]))

    @jsii.member(jsii_name="resetAlternateResponseCacheTtl")
    def reset_alternate_response_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlternateResponseCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThrottledCpCode")
    def reset_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledCpCode", []))

    @jsii.member(jsii_name="resetThrottledStatusCode")
    def reset_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUseThrottledCpCode")
    def reset_use_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledCpCode", []))

    @jsii.member(jsii_name="resetUseThrottledStatusCode")
    def reset_use_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCode")
    def throttled_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeOutputReference", jsii.get(self, "throttledCpCode"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtlInput")
    def alternate_response_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "alternateResponseCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCodeInput")
    def throttled_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode"], jsii.get(self, "throttledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCodeInput")
    def throttled_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "throttledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCodeInput")
    def use_throttled_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCodeInput")
    def use_throttled_status_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtl")
    def alternate_response_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "alternateResponseCacheTtl"))

    @alternate_response_cache_ttl.setter
    def alternate_response_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55b3beb1ae3ff1356f9816db6e36fe89b87ddaec56a5b2035446e87e037973ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "alternateResponseCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffdbe970de44282411cfe71bbb6fbbd05e0f2c8e7555dba9dc596c3e18595ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b7a7a410326bef015dbc146486f931bbd53b32a3528d61591f254dbfa01ff34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ede6ebe0e1c55fc007f6398f283174191a035a0c585fbe6c30e9c83fa6abd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0566e06c44a226cfddab3c00eaa6167f92f1926abc002f6d00971a13f948cabd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468b59062fa8d2a4b6f27ba6680b31c0e86226fb3f7467fb9e68f78df4da6dc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ea54cafa4e26c6ef931c7e1956f16bfbb3794cb889e2b0aa4aad477076ec79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__568fcc8d65cb8fead5206842faecbf9b80c9de509e62e7dc1860da0a09fbe20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCode")
    def throttled_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "throttledStatusCode"))

    @throttled_status_code.setter
    def throttled_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411a3efccbeae49e9a430efa6b8cf91c7daf6bad6aba6f85e0ec7bab90c99910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throttledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCode")
    def use_throttled_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledCpCode"))

    @use_throttled_cp_code.setter
    def use_throttled_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__146146c1b5a2fe2e3eebc733558dbfe7521cdea6152474f2418431c2cdeeae38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCode")
    def use_throttled_status_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledStatusCode"))

    @use_throttled_status_code.setter
    def use_throttled_status_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f2977c1301651398a1d68b5669857a4617e343da5aac13669f861d784367c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e12f4bdfd299ed77892d5a8834e9b5e65165548e8318b361a05d7b7151fdee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4e7b93b8ab0cb33a4dbc911e309baa565aa036fae8040a53e5c708c4e24eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186c944451d8af309ce50a1a2b7f8ac6782f1286585e9dea93c45816d0d60c70)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efab04957d8ab57a46ef4a39d3ffede6ca0f45381f841d0ab8c1230ce8ac2fa)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ee1a6d0cff17689535841145841eb69fdf7de44afcaaa91a9f610292fdf127)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c9b834448469407fb353fc06752994773ec51bf76cc766f5e00f80af0c43c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d90bb0594d7be2ff97d4d89df12bff7411ab057425b6d338d5e779fbdb04b95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__594df214aa12ebd0f8370d4755d302b48e93d55fcf46737edc23aaa8dddfa982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8234918835ca6aecb50d852d4d41464648fa6ca5e1b66613c6eeec490008bf06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877b43bba2f82e072a3c12dd55cc7ca19d48044197c28adacd0709d8ec30dd4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7df5b285229483d36db618e813ce79921e3a4665b4dd4dd23a9614fcf7c149e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ef9ca177f9871ef6a0920fc66755431b6dd9d82004ec9e14629f2b7b3c7919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f956cae1cdc91e1bc5759d68b6d3a8c6042efc43a105bd9e58290008b7cb31b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__873cd21138524d90a4def163f9c87c9075060b268bfd26938bef22d621797b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6040d81d2e869e1f69053863cd076a20b41333fcacd7f1f1a9a1fc0a907124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9670e726aa1a302a64d7d5c8c294f73f7c30f29f2a09bd8a3cb55e2959ccbd72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer",
    jsii_struct_bases=[],
    name_mapping={
        "all_down_net_storage": "allDownNetStorage",
        "all_down_net_storage_file": "allDownNetStorageFile",
        "all_down_status_code": "allDownStatusCode",
        "all_down_title": "allDownTitle",
        "allow_cache_prefresh": "allowCachePrefresh",
        "cached_content_title": "cachedContentTitle",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "failover_attempts_threshold": "failoverAttemptsThreshold",
        "failover_mode": "failoverMode",
        "failover_origin_map": "failoverOriginMap",
        "failover_status_codes": "failoverStatusCodes",
        "failover_title": "failoverTitle",
        "label": "label",
        "locked": "locked",
        "origin_cookie_name": "originCookieName",
        "specify_stickiness_cookie_domain": "specifyStickinessCookieDomain",
        "stickiness_cookie_automatic_salt": "stickinessCookieAutomaticSalt",
        "stickiness_cookie_domain": "stickinessCookieDomain",
        "stickiness_cookie_salt": "stickinessCookieSalt",
        "stickiness_cookie_set_http_only_flag": "stickinessCookieSetHttpOnlyFlag",
        "stickiness_cookie_type": "stickinessCookieType",
        "stickiness_duration": "stickinessDuration",
        "stickiness_expiration_date": "stickinessExpirationDate",
        "stickiness_refresh": "stickinessRefresh",
        "stickiness_title": "stickinessTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer:
    def __init__(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(all_down_net_storage, dict):
            all_down_net_storage = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage(**all_down_net_storage)
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28fd0a648c1fde1821a7fc5be70e8a387a7c5133540970ea580aead871f089b)
            check_type(argname="argument all_down_net_storage", value=all_down_net_storage, expected_type=type_hints["all_down_net_storage"])
            check_type(argname="argument all_down_net_storage_file", value=all_down_net_storage_file, expected_type=type_hints["all_down_net_storage_file"])
            check_type(argname="argument all_down_status_code", value=all_down_status_code, expected_type=type_hints["all_down_status_code"])
            check_type(argname="argument all_down_title", value=all_down_title, expected_type=type_hints["all_down_title"])
            check_type(argname="argument allow_cache_prefresh", value=allow_cache_prefresh, expected_type=type_hints["allow_cache_prefresh"])
            check_type(argname="argument cached_content_title", value=cached_content_title, expected_type=type_hints["cached_content_title"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_attempts_threshold", value=failover_attempts_threshold, expected_type=type_hints["failover_attempts_threshold"])
            check_type(argname="argument failover_mode", value=failover_mode, expected_type=type_hints["failover_mode"])
            check_type(argname="argument failover_origin_map", value=failover_origin_map, expected_type=type_hints["failover_origin_map"])
            check_type(argname="argument failover_status_codes", value=failover_status_codes, expected_type=type_hints["failover_status_codes"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_cookie_name", value=origin_cookie_name, expected_type=type_hints["origin_cookie_name"])
            check_type(argname="argument specify_stickiness_cookie_domain", value=specify_stickiness_cookie_domain, expected_type=type_hints["specify_stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_automatic_salt", value=stickiness_cookie_automatic_salt, expected_type=type_hints["stickiness_cookie_automatic_salt"])
            check_type(argname="argument stickiness_cookie_domain", value=stickiness_cookie_domain, expected_type=type_hints["stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_salt", value=stickiness_cookie_salt, expected_type=type_hints["stickiness_cookie_salt"])
            check_type(argname="argument stickiness_cookie_set_http_only_flag", value=stickiness_cookie_set_http_only_flag, expected_type=type_hints["stickiness_cookie_set_http_only_flag"])
            check_type(argname="argument stickiness_cookie_type", value=stickiness_cookie_type, expected_type=type_hints["stickiness_cookie_type"])
            check_type(argname="argument stickiness_duration", value=stickiness_duration, expected_type=type_hints["stickiness_duration"])
            check_type(argname="argument stickiness_expiration_date", value=stickiness_expiration_date, expected_type=type_hints["stickiness_expiration_date"])
            check_type(argname="argument stickiness_refresh", value=stickiness_refresh, expected_type=type_hints["stickiness_refresh"])
            check_type(argname="argument stickiness_title", value=stickiness_title, expected_type=type_hints["stickiness_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if all_down_net_storage is not None:
            self._values["all_down_net_storage"] = all_down_net_storage
        if all_down_net_storage_file is not None:
            self._values["all_down_net_storage_file"] = all_down_net_storage_file
        if all_down_status_code is not None:
            self._values["all_down_status_code"] = all_down_status_code
        if all_down_title is not None:
            self._values["all_down_title"] = all_down_title
        if allow_cache_prefresh is not None:
            self._values["allow_cache_prefresh"] = allow_cache_prefresh
        if cached_content_title is not None:
            self._values["cached_content_title"] = cached_content_title
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_attempts_threshold is not None:
            self._values["failover_attempts_threshold"] = failover_attempts_threshold
        if failover_mode is not None:
            self._values["failover_mode"] = failover_mode
        if failover_origin_map is not None:
            self._values["failover_origin_map"] = failover_origin_map
        if failover_status_codes is not None:
            self._values["failover_status_codes"] = failover_status_codes
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if origin_cookie_name is not None:
            self._values["origin_cookie_name"] = origin_cookie_name
        if specify_stickiness_cookie_domain is not None:
            self._values["specify_stickiness_cookie_domain"] = specify_stickiness_cookie_domain
        if stickiness_cookie_automatic_salt is not None:
            self._values["stickiness_cookie_automatic_salt"] = stickiness_cookie_automatic_salt
        if stickiness_cookie_domain is not None:
            self._values["stickiness_cookie_domain"] = stickiness_cookie_domain
        if stickiness_cookie_salt is not None:
            self._values["stickiness_cookie_salt"] = stickiness_cookie_salt
        if stickiness_cookie_set_http_only_flag is not None:
            self._values["stickiness_cookie_set_http_only_flag"] = stickiness_cookie_set_http_only_flag
        if stickiness_cookie_type is not None:
            self._values["stickiness_cookie_type"] = stickiness_cookie_type
        if stickiness_duration is not None:
            self._values["stickiness_duration"] = stickiness_duration
        if stickiness_expiration_date is not None:
            self._values["stickiness_expiration_date"] = stickiness_expiration_date
        if stickiness_refresh is not None:
            self._values["stickiness_refresh"] = stickiness_refresh
        if stickiness_title is not None:
            self._values["stickiness_title"] = stickiness_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def all_down_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage"]:
        '''all_down_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        '''
        result = self._values.get("all_down_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage"], result)

    @builtins.property
    def all_down_net_storage_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        '''
        result = self._values.get("all_down_net_storage_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP response code when all load-balancing origins are unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        '''
        result = self._values.get("all_down_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        '''
        result = self._values.get("all_down_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_cache_prefresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows the cache to prefresh.  Only appropriate if all origins serve the same content for the same URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        '''
        result = self._values.get("allow_cache_prefresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cached_content_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        '''
        result = self._values.get("cached_content_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the Application Load Balancer Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_attempts_threshold(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of failed requests that would trigger the failover process.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        '''
        result = self._values.get("failover_attempts_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_mode(self) -> typing.Optional[builtins.str]:
        '''Determines what to do if an origin fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        '''
        result = self._values.get("failover_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_origin_map(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap"]]]:
        '''failover_origin_map block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        '''
        result = self._values.get("failover_origin_map")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap"]]], result)

    @builtins.property
    def failover_status_codes(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        '''
        result = self._values.get("failover_status_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Application Load Balancer policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name for your session cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        '''
        result = self._values.get("origin_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        '''
        result = self._values.get("specify_stickiness_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable this if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        '''
        result = self._values.get("stickiness_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the stickiness cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        '''
        result = self._values.get("stickiness_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        '''
        result = self._values.get("stickiness_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ensures the cookie is transmitted only over HTTP.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        '''
        result = self._values.get("stickiness_cookie_set_http_only_flag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Determines how a cookie persistently associates the client with a load-balanced origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        '''
        result = self._values.get("stickiness_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_duration(self) -> typing.Optional[builtins.str]:
        '''Sets how long it is before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        '''
        result = self._values.get("stickiness_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        '''
        result = self._values.get("stickiness_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extends the duration of the cookie with each new request.

        When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        '''
        result = self._values.get("stickiness_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        '''
        result = self._values.get("stickiness_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e4529b230c04b38d299fa322b36984c7130e2dd7c8f17417f1fb4aeddfc595f)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16329aced88b4e2d9df50e0d1082dc164a1f5be646503465ccd31e5279096bb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4911f567cbfec33b0bf42a25eb5eaa7f71a231837e494b5f1226cb87fc75d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b043c173dc55cd5b2b24bedd19807575ddc987cdf5caf620ba874bb797a37c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efddf52a522b2cb933756a02c7a0ac66ebca2a6e419f6dc72cdc53f45b214b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7f3fa3ac0783f7a22859d62fd515322f30ea8ac1c9e924fa33730e09143d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067dea485177cd04b3478bc5bde94a74ccce9587857a2760292a4d8ba2e539a0)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c14d5ccbc61e968f6423af849caadc60992a1426f46446f7853c725318c8377)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9bb590c23ea69391a7d04f0444d1462f2aedd3be24eb19bf2d12772a9dde2ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90cb7080bc743e8dc22c2ac4ef5a4d26804f8109424dee6fa914b9bf163f65b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__100818b6c8c82fdc472ec2ac7ec7330d2607a30b2d0d1db76f4fd0c56c2922f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap",
    jsii_struct_bases=[],
    name_mapping={"from_origin_id": "fromOriginId", "to_origin_ids": "toOriginIds"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap:
    def __init__(
        self,
        *,
        from_origin_id: typing.Optional[builtins.str] = None,
        to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param from_origin_id: Specifies the origin whose failure triggers the mapping rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        :param to_origin_ids: Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069b99e631b2bcadd4e5a4949b2524f879de989fcb8b196dac6324893e83de4e)
            check_type(argname="argument from_origin_id", value=from_origin_id, expected_type=type_hints["from_origin_id"])
            check_type(argname="argument to_origin_ids", value=to_origin_ids, expected_type=type_hints["to_origin_ids"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if from_origin_id is not None:
            self._values["from_origin_id"] = from_origin_id
        if to_origin_ids is not None:
            self._values["to_origin_ids"] = to_origin_ids

    @builtins.property
    def from_origin_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin whose failure triggers the mapping rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        '''
        result = self._values.get("from_origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_origin_ids(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        result = self._values.get("to_origin_ids")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f628617775f5ad5f1b56468df454eeb6fad449b8836fbf4ff7eb654106d60cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a0a2ee407e4d8b62ef8bd52d66c22d6c91f0f7cc109c0062f2cda0f64a37ed)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9098116fae2d35a87b9c56786d1898485700570ef10be32954adb33ab6bbd2d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fe96ce31828e4f74ccca3284c3678e9a5b509a484e16071182bde8134d0b0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a80f62e40319cf1b7d54f6237125d41d026f654f601897b117cee92be70b248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81edc50c5bbdb346396f58d96c0e82ccf608595afa74a6690913817fc6094d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b1a81dfbcad24021cbfb70070a2f9fd0fcf2b54cd7a3b59f28de39f8b891d58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFromOriginId")
    def reset_from_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFromOriginId", []))

    @jsii.member(jsii_name="resetToOriginIds")
    def reset_to_origin_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToOriginIds", []))

    @builtins.property
    @jsii.member(jsii_name="fromOriginIdInput")
    def from_origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fromOriginIdInput"))

    @builtins.property
    @jsii.member(jsii_name="toOriginIdsInput")
    def to_origin_ids_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "toOriginIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="fromOriginId")
    def from_origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fromOriginId"))

    @from_origin_id.setter
    def from_origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05742617cade4d3d3d5a65cbd404eeb078ef5559b21c8289a3e1f6bc539c4ba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fromOriginId", value)

    @builtins.property
    @jsii.member(jsii_name="toOriginIds")
    def to_origin_ids(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "toOriginIds"))

    @to_origin_ids.setter
    def to_origin_ids(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6e7a871cc47f7da7f27e3d93832290ef0b49fac2cc5becca354462e769d18f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toOriginIds", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e70d543fb5804092d7f912eea23783d3b19e4c7641b856231056793f0a253316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f720d7bd52979d967b57da0cba59febd95d3a901dba7cc6de9b2337fb7156ae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAllDownNetStorage")
    def put_all_down_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putAllDownNetStorage", [value]))

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putFailoverOriginMap")
    def put_failover_origin_map(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129eef7cd40213f09330655f6978c7f7cbbfc216f1bb8a42f6a9bad2392fe7d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverOriginMap", [value]))

    @jsii.member(jsii_name="resetAllDownNetStorage")
    def reset_all_down_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorage", []))

    @jsii.member(jsii_name="resetAllDownNetStorageFile")
    def reset_all_down_net_storage_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorageFile", []))

    @jsii.member(jsii_name="resetAllDownStatusCode")
    def reset_all_down_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownStatusCode", []))

    @jsii.member(jsii_name="resetAllDownTitle")
    def reset_all_down_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownTitle", []))

    @jsii.member(jsii_name="resetAllowCachePrefresh")
    def reset_allow_cache_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCachePrefresh", []))

    @jsii.member(jsii_name="resetCachedContentTitle")
    def reset_cached_content_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachedContentTitle", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverAttemptsThreshold")
    def reset_failover_attempts_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverAttemptsThreshold", []))

    @jsii.member(jsii_name="resetFailoverMode")
    def reset_failover_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMode", []))

    @jsii.member(jsii_name="resetFailoverOriginMap")
    def reset_failover_origin_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverOriginMap", []))

    @jsii.member(jsii_name="resetFailoverStatusCodes")
    def reset_failover_status_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverStatusCodes", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginCookieName")
    def reset_origin_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCookieName", []))

    @jsii.member(jsii_name="resetSpecifyStickinessCookieDomain")
    def reset_specify_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieAutomaticSalt")
    def reset_stickiness_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieDomain")
    def reset_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieSalt")
    def reset_stickiness_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieSetHttpOnlyFlag")
    def reset_stickiness_cookie_set_http_only_flag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSetHttpOnlyFlag", []))

    @jsii.member(jsii_name="resetStickinessCookieType")
    def reset_stickiness_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieType", []))

    @jsii.member(jsii_name="resetStickinessDuration")
    def reset_stickiness_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessDuration", []))

    @jsii.member(jsii_name="resetStickinessExpirationDate")
    def reset_stickiness_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessExpirationDate", []))

    @jsii.member(jsii_name="resetStickinessRefresh")
    def reset_stickiness_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessRefresh", []))

    @jsii.member(jsii_name="resetStickinessTitle")
    def reset_stickiness_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorage")
    def all_down_net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference, jsii.get(self, "allDownNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMap")
    def failover_origin_map(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapList, jsii.get(self, "failoverOriginMap"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFileInput")
    def all_down_net_storage_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownNetStorageFileInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageInput")
    def all_down_net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "allDownNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCodeInput")
    def all_down_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownTitleInput")
    def all_down_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefreshInput")
    def allow_cache_prefresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCachePrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitleInput")
    def cached_content_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cachedContentTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThresholdInput")
    def failover_attempts_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverAttemptsThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverModeInput")
    def failover_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverModeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMapInput")
    def failover_origin_map_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "failoverOriginMapInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodesInput")
    def failover_status_codes_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverStatusCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originCookieNameInput")
    def origin_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomainInput")
    def specify_stickiness_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyStickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSaltInput")
    def stickiness_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomainInput")
    def stickiness_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSaltInput")
    def stickiness_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlagInput")
    def stickiness_cookie_set_http_only_flag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieSetHttpOnlyFlagInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieTypeInput")
    def stickiness_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessDurationInput")
    def stickiness_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDateInput")
    def stickiness_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessRefreshInput")
    def stickiness_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessTitleInput")
    def stickiness_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFile")
    def all_down_net_storage_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownNetStorageFile"))

    @all_down_net_storage_file.setter
    def all_down_net_storage_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__967f3291e49f7b6ec11698450838210482c18a6d12fc45d91863cb785e9cec90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownNetStorageFile", value)

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCode")
    def all_down_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownStatusCode"))

    @all_down_status_code.setter
    def all_down_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b93a2f4c8a93ca86ba1dfd25e6823b29d82f192a1af8e2198deae1b27f087c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="allDownTitle")
    def all_down_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownTitle"))

    @all_down_title.setter
    def all_down_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4582733f7675964a3de9f6c7935c5c0a10752ca6ade13c37d1896576981b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefresh")
    def allow_cache_prefresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCachePrefresh"))

    @allow_cache_prefresh.setter
    def allow_cache_prefresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeef2518af2b2a79e7179475f1a26137faf1ff8aecd6a8fbddc7821ad5a47870)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCachePrefresh", value)

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitle")
    def cached_content_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cachedContentTitle"))

    @cached_content_title.setter
    def cached_content_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8605573bb4dae9c1586f070d77bb433147b6c62d8c7d080139d3d6e4433c9fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cachedContentTitle", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d2bf0b5d63782eb4a24b6a2504723c749b1804315a99dfd445eafb07375ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThreshold")
    def failover_attempts_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverAttemptsThreshold"))

    @failover_attempts_threshold.setter
    def failover_attempts_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e553a6571b324ead71d5f8373391b9a21f004d2bd51e2f5c0f7c4998c67c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverAttemptsThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMode")
    def failover_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMode"))

    @failover_mode.setter
    def failover_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa1c7041989b248b023ea3dc6d887b922b947485221b4f8bde83ddd60336378)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodes")
    def failover_status_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverStatusCodes"))

    @failover_status_codes.setter
    def failover_status_codes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c14cbc8aa6ab37bce76796cac6afaa589e0c596a8500c0c09029391e9bc2bee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverStatusCodes", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fe6f4aef13ef2f75add87803aa25f2c4719f09cd8aee04a62cc728be945fb77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaee08770eb9bcf6899096cae0aea714ad20fca68a8a844773e83289b8cc2c49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e9be3bcd6d0bb80642d3d895ee178c3f9439749765f08e4e5d1aa2ae0eb50a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originCookieName")
    def origin_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCookieName"))

    @origin_cookie_name.setter
    def origin_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e5b743bdee50fe38170678c9e2b77b9d25a8d1b495e2dfc0c79bca6b25e1ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomain")
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyStickinessCookieDomain"))

    @specify_stickiness_cookie_domain.setter
    def specify_stickiness_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85f5ea753ba382c4abc635e2a6339425c886e61296fbbcb565561d69c466bff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyStickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSalt")
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieAutomaticSalt"))

    @stickiness_cookie_automatic_salt.setter
    def stickiness_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb95ba48f18b2031d5568eff4a7cc1d9fad74a5251d73f8cc2eb6545fc36c97e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomain")
    def stickiness_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieDomain"))

    @stickiness_cookie_domain.setter
    def stickiness_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700ee9687e9d90d4822b4e8b72c26d19038c5d6503a5bea738e27c8ab1862f60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSalt")
    def stickiness_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieSalt"))

    @stickiness_cookie_salt.setter
    def stickiness_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__278fa41cd4963ec6d00b11beb2f85b7d1ce2289d3fafa9d864554339642c09b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlag")
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieSetHttpOnlyFlag"))

    @stickiness_cookie_set_http_only_flag.setter
    def stickiness_cookie_set_http_only_flag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa752b4b40543f3af32d50f0d4228f92a24ff49e0bb42001999d89780a0992d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSetHttpOnlyFlag", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieType")
    def stickiness_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieType"))

    @stickiness_cookie_type.setter
    def stickiness_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec123d2b593454d7d88c0a9175181e1ba62f790b8e3af29574ecc7b7504e970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessDuration")
    def stickiness_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessDuration"))

    @stickiness_duration.setter
    def stickiness_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6fc0b2e33cb9be7568219456e2ff933c7c00e76fd142eae3c7c1ffe5c211c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessDuration", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDate")
    def stickiness_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessExpirationDate"))

    @stickiness_expiration_date.setter
    def stickiness_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__627ada9b90c4471816396ec7d5a828c0ac839768edb293ab3330d1df583b6bd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessRefresh")
    def stickiness_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessRefresh"))

    @stickiness_refresh.setter
    def stickiness_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53f2378566e65068fc48fbcff447c9c30c6a2055aebd53e9300240fe26823fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessTitle")
    def stickiness_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessTitle"))

    @stickiness_title.setter
    def stickiness_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c3746be4d37dda71d390ddd1c306cef68eee0a5aabd960d89d448bd39afbc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dfb76f44a9b40c115abdb51c598c473d4705167b8654b991d7f1e1da72abdc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93392807817c3569920054a9192eb74299655bc8765bc2b17f9672e991c9384a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf6f07923c9018bc00785577a7ba22959f59d694f2c30fd93fbd302b22c91557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_automatic_salt": "populationCookieAutomaticSalt",
        "population_cookie_domain": "populationCookieDomain",
        "population_cookie_include_rule_name": "populationCookieIncludeRuleName",
        "population_cookie_salt": "populationCookieSalt",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "segment_tracking_cookie_name": "segmentTrackingCookieName",
        "segment_tracking_custom_header": "segmentTrackingCustomHeader",
        "segment_tracking_method": "segmentTrackingMethod",
        "segment_tracking_query_param": "segmentTrackingQueryParam",
        "segment_tracking_title": "segmentTrackingTitle",
        "specify_population_cookie_domain": "specifyPopulationCookieDomain",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24442b7d7ff3e1625d2e67d723936a7402f18175e282cb77b4300da2f5a50a10)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_automatic_salt", value=population_cookie_automatic_salt, expected_type=type_hints["population_cookie_automatic_salt"])
            check_type(argname="argument population_cookie_domain", value=population_cookie_domain, expected_type=type_hints["population_cookie_domain"])
            check_type(argname="argument population_cookie_include_rule_name", value=population_cookie_include_rule_name, expected_type=type_hints["population_cookie_include_rule_name"])
            check_type(argname="argument population_cookie_salt", value=population_cookie_salt, expected_type=type_hints["population_cookie_salt"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument segment_tracking_cookie_name", value=segment_tracking_cookie_name, expected_type=type_hints["segment_tracking_cookie_name"])
            check_type(argname="argument segment_tracking_custom_header", value=segment_tracking_custom_header, expected_type=type_hints["segment_tracking_custom_header"])
            check_type(argname="argument segment_tracking_method", value=segment_tracking_method, expected_type=type_hints["segment_tracking_method"])
            check_type(argname="argument segment_tracking_query_param", value=segment_tracking_query_param, expected_type=type_hints["segment_tracking_query_param"])
            check_type(argname="argument segment_tracking_title", value=segment_tracking_title, expected_type=type_hints["segment_tracking_title"])
            check_type(argname="argument specify_population_cookie_domain", value=specify_population_cookie_domain, expected_type=type_hints["specify_population_cookie_domain"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_automatic_salt is not None:
            self._values["population_cookie_automatic_salt"] = population_cookie_automatic_salt
        if population_cookie_domain is not None:
            self._values["population_cookie_domain"] = population_cookie_domain
        if population_cookie_include_rule_name is not None:
            self._values["population_cookie_include_rule_name"] = population_cookie_include_rule_name
        if population_cookie_salt is not None:
            self._values["population_cookie_salt"] = population_cookie_salt
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if segment_tracking_cookie_name is not None:
            self._values["segment_tracking_cookie_name"] = segment_tracking_cookie_name
        if segment_tracking_custom_header is not None:
            self._values["segment_tracking_custom_header"] = segment_tracking_custom_header
        if segment_tracking_method is not None:
            self._values["segment_tracking_method"] = segment_tracking_method
        if segment_tracking_query_param is not None:
            self._values["segment_tracking_query_param"] = segment_tracking_query_param
        if segment_tracking_title is not None:
            self._values["segment_tracking_title"] = segment_tracking_title
        if specify_population_cookie_domain is not None:
            self._values["specify_population_cookie_domain"] = specify_population_cookie_domain
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Audience Segmentation cloudlet feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''Specifies a suffix to append to the cookie name.

        This helps distinguish this audience segmentation policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        '''
        result = self._values.get("population_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the population cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        '''
        result = self._values.get("population_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes in the session cookie the name of the rule in which this behavior appears.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        '''
        result = self._values.get("population_cookie_include_rule_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        '''
        result = self._values.get("population_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Specifies when the segmentation cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the lifetime of the segmentation cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If disabled, sets the expiration time only if the cookie is not yet present in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_cookie_name(self) -> typing.Optional[builtins.str]:
        '''This cookie name specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        '''
        result = self._values.get("segment_tracking_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_custom_header(self) -> typing.Optional[builtins.str]:
        '''This custom HTTP header specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        '''
        result = self._values.get("segment_tracking_custom_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the method to pass segment information to the origin.

        The Cloudlet passes the rule applied to a given request location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        '''
        result = self._values.get("segment_tracking_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_query_param(self) -> typing.Optional[builtins.str]:
        '''This query parameter specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        '''
        result = self._values.get("segment_tracking_query_param")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        '''
        result = self._values.get("segment_tracking_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_population_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to specify a cookie domain with the population cookie.

        It tells the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        '''
        result = self._values.get("specify_population_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd299f039d6f9b18b4ff79870aeeb26fe82c4ee79bc2f6ce119b01bc18f0250)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fd10bef5b28c9842fdb75b0bf99f38de685e1e8610e1a41d2e87870f61e6d47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__317739cf38acc9646b7cfec7e66f13d09b35903666d840248e5736c34bfd96cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd867bc1f5134098a998ba19561b757445ecfe8ad0b6db5604a984b5c940db7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f936a9e1e7b43bfbdf48889c6b550b77ac3a95d7d6ca85fdb87e0a66ce3300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25417598eada961d93f50a1a795673457cea764b3deee5a4e47eb41c146b7024)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieAutomaticSalt")
    def reset_population_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieDomain")
    def reset_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetPopulationCookieIncludeRuleName")
    def reset_population_cookie_include_rule_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieIncludeRuleName", []))

    @jsii.member(jsii_name="resetPopulationCookieSalt")
    def reset_population_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetSegmentTrackingCookieName")
    def reset_segment_tracking_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCookieName", []))

    @jsii.member(jsii_name="resetSegmentTrackingCustomHeader")
    def reset_segment_tracking_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCustomHeader", []))

    @jsii.member(jsii_name="resetSegmentTrackingMethod")
    def reset_segment_tracking_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingMethod", []))

    @jsii.member(jsii_name="resetSegmentTrackingQueryParam")
    def reset_segment_tracking_query_param(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingQueryParam", []))

    @jsii.member(jsii_name="resetSegmentTrackingTitle")
    def reset_segment_tracking_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingTitle", []))

    @jsii.member(jsii_name="resetSpecifyPopulationCookieDomain")
    def reset_specify_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSaltInput")
    def population_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomainInput")
    def population_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleNameInput")
    def population_cookie_include_rule_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieIncludeRuleNameInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieSaltInput")
    def population_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieNameInput")
    def segment_tracking_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeaderInput")
    def segment_tracking_custom_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCustomHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethodInput")
    def segment_tracking_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParamInput")
    def segment_tracking_query_param_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingQueryParamInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitleInput")
    def segment_tracking_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomainInput")
    def specify_population_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyPopulationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2293010b35a26a7ae19ae6d7198dbfc6aa6ea300618899a4900778e86b8528b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a212b979472a40751277d19189653e037cc798662fc6ba9b0c6e737cb48b31f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22bd860290ce76241c798c5314c2d924636b0d4a2e01cced26d97bbb29a1262c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e1c67991c26c3a632ea89e4348cfec94fb7e84faeef1d1dc2cbcb8f4b30672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08dd14774ba72b1497688901080623b6c3d164857134a7cb3ef38748d49f9f3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSalt")
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieAutomaticSalt"))

    @population_cookie_automatic_salt.setter
    def population_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b99839c1b34b2d873e4550e7dec23a654c2c6d99639d00696d98aaf9dab9110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomain")
    def population_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieDomain"))

    @population_cookie_domain.setter
    def population_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5389e61e925b6bf4187b91bf1326478a8fdd55eba7ce3d111e14e366ac603930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleName")
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieIncludeRuleName"))

    @population_cookie_include_rule_name.setter
    def population_cookie_include_rule_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69dc45ec81adcbf7c66c7616759447ad76898e44f17341a774dfc089b0a15ac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieIncludeRuleName", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieSalt")
    def population_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieSalt"))

    @population_cookie_salt.setter
    def population_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e96eef9699422465bd6196e8a949a8a8a28d6e35c01a339b3e686a44e332abef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9cd890b3bb6cc4cdcb5e2611e5b866175a134aec9e9e64b1ab2cef299ec288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5058aa9f2babdc0eb3707e8fb2d7356665d8a6851cfc57e94720c6a46f823a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba38573fb08d1376bc03a4df54f0c8d7f8f34cce1caa34918eb6c1363834858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e9fc9bbe14039b81a4f40237a71bc4c203c51c3c62232570b841a678da8fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieName")
    def segment_tracking_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCookieName"))

    @segment_tracking_cookie_name.setter
    def segment_tracking_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f561f7c1c22094fdfa1a4a86cc34dd09b5ebcb4891f473fb271aacf2004d01e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeader")
    def segment_tracking_custom_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCustomHeader"))

    @segment_tracking_custom_header.setter
    def segment_tracking_custom_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024436b5d69f39889dad4a4338ac78e16a6af5763bac9fe3af7de92fb4fbdaff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCustomHeader", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethod")
    def segment_tracking_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingMethod"))

    @segment_tracking_method.setter
    def segment_tracking_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d93bab10cef1622ad99baeebb5633401bd1c8b41c6bfc6977f579c8dce9cd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingMethod", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParam")
    def segment_tracking_query_param(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingQueryParam"))

    @segment_tracking_query_param.setter
    def segment_tracking_query_param(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02a350866d2b93a26fed66402c370f6bfea4e64de0ec038a686beb31f5af6ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingQueryParam", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitle")
    def segment_tracking_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingTitle"))

    @segment_tracking_title.setter
    def segment_tracking_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b5f3c201c5a1e2d886a6d563223bc1392a2a1819ded09c3c9bfd178e2bc1a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingTitle", value)

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomain")
    def specify_population_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyPopulationCookieDomain"))

    @specify_population_cookie_domain.setter
    def specify_population_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__befb0dd81dc01c2579c1f8dc10813a23a3c203af6aa05654d4d8f2941aa9be0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyPopulationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9bb8e655c24ad227fc899aa72e95cb286fbf2a5e8e1fad295546ef4bfdf90f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df35526a537e0cd58cff097d839cdc719e6feed0808f99acd686d0614ba36c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c467a0178fc50ebaf48b22e404a3d5a042aa1ed7cd6095aaca910e6b8d7149a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation",
    jsii_struct_bases=[],
    name_mapping={
        "autodv": "autodv",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation:
    def __init__(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcee55b0d676391315d761c6282774571fa420b56c819d556148c62a975a634d)
            check_type(argname="argument autodv", value=autodv, expected_type=type_hints["autodv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if autodv is not None:
            self._values["autodv"] = autodv
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def autodv(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        '''
        result = self._values.get("autodv")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368b1c756b80f81479d5a062e63b9e4dfaa9fbd4a75a2673f6defa9406cce362)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAutodv")
    def reset_autodv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutodv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="autodvInput")
    def autodv_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "autodvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="autodv")
    def autodv(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "autodv"))

    @autodv.setter
    def autodv(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe237b2b35c5ebb551c1c26dfa0951e2c01189fe2e4fe65d9c17e9cc525155bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "autodv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232d5497084e198b9aba83b02c9dab0b1a3504c62bed0653020ba4acc1a2ed1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bdbc3eb86654e0a13313ff00e9cdb289a028136932c0610446b45edcb1691c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ae0436032bfe31e253f72a7c4a6e61c3863a8a50270a586115186c93aa4bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca1b1dc128198d76224b342ba6fb1c78b4e2c6d62c5ef6500332bdffd1f4e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d23c77a865de5f486849d46ab37b71c9a1e42b736cf4ea5b3e7ee1792c65ee4)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the base path of content on your origin server.

        The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2aad0e7ec9804fae281cce988586d37198f9535a36acfadc575f0642c1a662)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a932b62d913cdbb07cf46bb4c9357def73a1735e92840621ea93011089942c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5db6347561d33342d34d04bf1fdf82cc644924760ed360438f57abeda815726b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c4cb04074b699e1ad9546d1052c8040c9f586a80e4f672128f4bc946dce2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d039ee1be427c501d73f89420871aeadc7cf1f269b18558b67140f36ac6b7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07fa0cc889c89f27b10f4b4761271aa129adeeb5c242578967918f4c6ec6e28d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing",
    jsii_struct_bases=[],
    name_mapping={
        "conditional_error_pattern": "conditionalErrorPattern",
        "conditional_http_status": "conditionalHttpStatus",
        "conditional_sampling_frequency": "conditionalSamplingFrequency",
        "cpcodes": "cpcodes",
        "enabled": "enabled",
        "forward_type": "forwardType",
        "locked": "locked",
        "request_type": "requestType",
        "sampling_frequency": "samplingFrequency",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing:
    def __init__(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f87053f107a218bcd9700d8e627f3a2fb71674732967fd7bd3df1dfc76a65b8)
            check_type(argname="argument conditional_error_pattern", value=conditional_error_pattern, expected_type=type_hints["conditional_error_pattern"])
            check_type(argname="argument conditional_http_status", value=conditional_http_status, expected_type=type_hints["conditional_http_status"])
            check_type(argname="argument conditional_sampling_frequency", value=conditional_sampling_frequency, expected_type=type_hints["conditional_sampling_frequency"])
            check_type(argname="argument cpcodes", value=cpcodes, expected_type=type_hints["cpcodes"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_type", value=forward_type, expected_type=type_hints["forward_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument sampling_frequency", value=sampling_frequency, expected_type=type_hints["sampling_frequency"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if conditional_error_pattern is not None:
            self._values["conditional_error_pattern"] = conditional_error_pattern
        if conditional_http_status is not None:
            self._values["conditional_http_status"] = conditional_http_status
        if conditional_sampling_frequency is not None:
            self._values["conditional_sampling_frequency"] = conditional_sampling_frequency
        if cpcodes is not None:
            self._values["cpcodes"] = cpcodes
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_type is not None:
            self._values["forward_type"] = forward_type
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if sampling_frequency is not None:
            self._values["sampling_frequency"] = sampling_frequency
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def conditional_error_pattern(self) -> typing.Optional[builtins.str]:
        '''A space-separated set of error patterns that trigger beacons to conditional feeds.

        Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        '''
        result = self._values.get("conditional_error_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def conditional_http_status(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response status codes or ranges that trigger the beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        '''
        result = self._values.get("conditional_http_status")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def conditional_sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a conditional sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        '''
        result = self._values.get("conditional_sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cpcodes(self) -> typing.Optional[builtins.str]:
        '''The space-separated list of CP codes that trigger the beacons.

        You need to specify the same set of CP codes within BOSS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        '''
        result = self._values.get("cpcodes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable diagnostic data beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        '''
        result = self._values.get("forward_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        '''
        result = self._values.get("sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c130c0d0c56a462b2a6d89e5bdc5422f320f3b3b10b71dc24e840edc7296d934)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConditionalErrorPattern")
    def reset_conditional_error_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalErrorPattern", []))

    @jsii.member(jsii_name="resetConditionalHttpStatus")
    def reset_conditional_http_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalHttpStatus", []))

    @jsii.member(jsii_name="resetConditionalSamplingFrequency")
    def reset_conditional_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalSamplingFrequency", []))

    @jsii.member(jsii_name="resetCpcodes")
    def reset_cpcodes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpcodes", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardType")
    def reset_forward_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetSamplingFrequency")
    def reset_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingFrequency", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPatternInput")
    def conditional_error_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalErrorPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatusInput")
    def conditional_http_status_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "conditionalHttpStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequencyInput")
    def conditional_sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalSamplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="cpcodesInput")
    def cpcodes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cpcodesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardTypeInput")
    def forward_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingFrequencyInput")
    def sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "samplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPattern")
    def conditional_error_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalErrorPattern"))

    @conditional_error_pattern.setter
    def conditional_error_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d24b54173ee63546df0ffcc5933f0475d0b20653b2f5b93172772325537f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalErrorPattern", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatus")
    def conditional_http_status(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "conditionalHttpStatus"))

    @conditional_http_status.setter
    def conditional_http_status(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d5f35a925ccaea4cb0b9b4f52ab6397d359bf8bab3b7c7d687248437e9e72f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalHttpStatus", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequency")
    def conditional_sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalSamplingFrequency"))

    @conditional_sampling_frequency.setter
    def conditional_sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be7514694be215f0cdd5967bd21dfee3b11412149e03ea88e0da67759d50cca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalSamplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="cpcodes")
    def cpcodes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cpcodes"))

    @cpcodes.setter
    def cpcodes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6655c65e239df2d124f045293427229f0eb762defe826d14d0e99ea1551a0445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpcodes", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5febc94a176f2c8788abe7d44a073cc3b61c416018ac27adffa35d123146311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardType")
    def forward_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardType"))

    @forward_type.setter
    def forward_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2018b86791dbb0254aed5213dd4955cab7785c19df2e2f9fd384361907853da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6296cd7c3b87bddafda1c2ce95c0a2a21383e7612e90ed9048abbe9862e190ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6500be5c123e8d5c1803c48d72597232d141a0c47d4228ed51f986f2656916b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="samplingFrequency")
    def sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "samplingFrequency"))

    @sampling_frequency.setter
    def sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588b6fb010b23f0f43112bf9afdf73ffda5b4f8f4d1ca56583c5b44b0f48b609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33f722261ce095f1f408b0ffd4b7166d92f721d671dbcfb063eb14c31292f25d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6b1fd749d9105c10d71f2b0e3ce4b494aa572fde6b8e7f522aaf146a160d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b4333e88e7ba3557ecfff4550d669d94f36b770e055cb5d10e8cfec212d600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "logging_enabled": "loggingEnabled",
        "opt_mode": "optMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de88a784a200eca16189c0b549447259de999f841bcd0c7e18a9c9dd43643d0e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument logging_enabled", value=logging_enabled, expected_type=type_hints["logging_enabled"])
            check_type(argname="argument opt_mode", value=opt_mode, expected_type=type_hints["opt_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if logging_enabled is not None:
            self._values["logging_enabled"] = logging_enabled
        if opt_mode is not None:
            self._values["opt_mode"] = opt_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Breadcrumbs feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def logging_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client.

        This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        '''
        result = self._values.get("logging_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def opt_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to include Breadcrumbs data in the response header.

        To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        '''
        result = self._values.get("opt_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c53c9f70ffc0ef764efbe497a2a97a71afc92f27a2fa59813505cc7d2f4990a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLoggingEnabled")
    def reset_logging_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoggingEnabled", []))

    @jsii.member(jsii_name="resetOptMode")
    def reset_opt_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="loggingEnabledInput")
    def logging_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "loggingEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="optModeInput")
    def opt_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd6e3b778bee8647462f4c43f500d95b30bf2659baa1cb185c5514a18f081c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03126268ae0b8f425271d2b545c1ba8ccb672d881f146daabde5e978e330db42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="loggingEnabled")
    def logging_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "loggingEnabled"))

    @logging_enabled.setter
    def logging_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a227bef5bdf38d9645167c94d8a5668ada6a1d880bec3fcd442dbef94a15a469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loggingEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="optMode")
    def opt_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optMode"))

    @opt_mode.setter
    def opt_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfd8967466847ac2333d4105ae1fe48299ab6a263f81d999b48f14ad7d62c170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82c54f15cb2178a7a68a710e1c0fe77aaa859bc140b22343cbfc6673ce1a7cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b82b128024b181ad6c59cf438bc08942e8250b6dfcf39758fe795a20666cc57e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cde9686234bda8f0059ce25937614b146becabdb1933e25a71e601f7b4b9514e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161fc9e9e9668b68d8c81553ae860cc214180f83fd5274983e6ad070dd814cda)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the break connection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66c9f9e981722302a508d7335b5b39480b1a7c29d30b7d44e61106a988fe463)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1871ea41d9b7a7875dea7eb1ba9c04d4cce36478a02d76ed694caaef59685143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df73e5dd0b0392111ec1855255bc6bdc62676e62b3cbc6a651252d15ee24c41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eec6c1b1e598899c937c9e7300070933528c92fee335aff28bd7afaf1969229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07b61a216684240761e9376e04b425aa3d05587bda3345b0aec065dbf69e12cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6082bf4d8a6ec4ace5c43ec676498b5d7d51cbe7be4808b611d68bfd7ad5432)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f938238cf77b798285eab4000e74e0aa2ec851eb220671a3112f75c8cbeecff)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Fetches Brotli-compressed assets from your origin and caches them on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d975d42d82d481392883a832585ab301d61986eca7c0b0458b4f90f357f83ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f4afd1da2a3e7a3ddc04c392da35167f0ff07bf4bbd440840ffe320b67d070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c0d5eafbf780c2c6897a9e719102de99b4298f9ddb3224aa7644f8686fe027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe737ef92e2903421334e372aed927bdc31f3cc6cd4585d6444b97133bc9a9c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f705f2384d9a369173d8210e9ca05e958bfce7ff9efc68188aa94105c52bd522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69ad59259b173c77d11fd8447aee4355fa0bd2abc9832e68833557b21209a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "preserve_stale": "preserveStale",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5deee8fa00607b6acdd7a4f301bfb6f65b31234ae8c5ffc38ea9fc88b9d02a68)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preserve_stale", value=preserve_stale, expected_type=type_hints["preserve_stale"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if preserve_stale is not None:
            self._values["preserve_stale"] = preserve_stale
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the error-caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preserve_stale(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes.

        This avoids re-fetching and re-caching content after transient errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        '''
        result = self._values.get("preserve_stale")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Overrides the default caching duration of ``10s``.

        Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a5221c68c0e0097c88d161f41a96f94e4ba4af764a5c62d7ac0eb654e918c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreserveStale")
    def reset_preserve_stale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveStale", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveStaleInput")
    def preserve_stale_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveStaleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e72b73bf460010a65d91872949db32a350595fa5db2bedaba6cbe0ad9ca46441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba2330576d76365f574c86a8f557544e4cbfeaf5e4a9127e8b2cc852b99f3f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preserveStale")
    def preserve_stale(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveStale"))

    @preserve_stale.setter
    def preserve_stale(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9337433b740e3968a27513754e831a1ecccb69c5113335a16bb44b8f9b7e777c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveStale", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3b1b59dbb192c7396e4452d2c1bbfdcc44c77bcad20c39ab0dc02cd5297c7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913096d8e3b9c1874b3bc5abf53a27040624eb1ca7915d440b6559ae39a99f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3624f76ecec6a098372a3b13e5d485d9022ab4d44f9ef86e6f019827950c40e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626c7239fdb23387cc8bb72a2799491aa17327757fe6f91243debd060704d486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "include_value": "includeValue",
        "locked": "locked",
        "optional": "optional",
        "rule": "rule",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__736814c758ff54dfe0745c97dff8d827a0bf08553f5accf26e6d18ef05ac05dc)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument include_value", value=include_value, expected_type=type_hints["include_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optional", value=optional, expected_type=type_hints["optional"])
            check_type(argname="argument rule", value=rule, expected_type=type_hints["rule"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if include_value is not None:
            self._values["include_value"] = include_value
        if locked is not None:
            self._values["locked"] = locked
        if optional is not None:
            self._values["optional"] = optional
        if rule is not None:
            self._values["rule"] = rule
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def include_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes the value of the specified elements in the cache ID. Otherwise only their names are included.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        '''
        result = self._values.get("include_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optional(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Requires the behavior's specified elements to be present for content to cache.

        When disabled, requests that lack the specified elements are still cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        '''
        result = self._values.get("optional")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rule(self) -> typing.Optional[builtins.str]:
        '''Specifies how to modify the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        '''
        result = self._values.get("rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the variable you want to include in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129d0b817066a160a1c97a3779c51ae3053ef5bebd764ea0fb2aa5e6dd7c552e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetIncludeValue")
    def reset_include_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptional")
    def reset_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptional", []))

    @jsii.member(jsii_name="resetRule")
    def reset_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRule", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="includeValueInput")
    def include_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optionalInput")
    def optional_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optionalInput"))

    @builtins.property
    @jsii.member(jsii_name="ruleInput")
    def rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ruleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8055782a391114094b3049c410c479642e8b499f124f2bea63ef9b345245366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="includeValue")
    def include_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeValue"))

    @include_value.setter
    def include_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb7c81f3462dbfcdde2aeaab194a2cf1a5de55f56e5340a56f1fb6c3afa6f1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8060391a80580747c86b16d1d70488a9df9d593f59faed42b97087d43bb4768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optional")
    def optional(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optional"))

    @optional.setter
    def optional(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25c8e63831c1c512ecdad2e48ed7534d35358b2773d8bd375705562a06625373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optional", value)

    @builtins.property
    @jsii.member(jsii_name="rule")
    def rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rule"))

    @rule.setter
    def rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__634350cf990cf130e02ede0c3db5b7411fe98e5af01b420d8513a21334e84246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rule", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69eacb6e5a22c1bca633c713cc8e97e64a8aa34d27e7cd836d29d24ef9e1196f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40bbb0e4d6879fa14e710c73a7ad85a61a8f3d7bee01f4df9ec9bc106c3ce73d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5496074ff163dd1bac95571e00c84c112302b0f94adde04c6183ae26e913693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f39ee6c4804d865cfdb34e9b9fb6864f30784d119b96f8e589c9c94b236437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c889c51d3229f97262b3044d3860dac51b139580a71fc9794593b6fc739d0ad)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ignores case when forming cache keys.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd04fc66c151c191f4e1bb8b9a8b33d333f7ac2698e52b23317641adc203a185)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6783a159c2b39fec67408ded0ff38fae792a26e119fb1193bba52f35892850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa7190368f488c3c29200a6163bfdc70438d941e40c8bcb10d0313601c1804f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cee1c7f6295ec6c67dbd4f1d01444a360398cfa8d82288628622fa103055c2c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ce7e93bbf9af0f9483a9189a270fc5fc01e5aa5ee670d77633f1eb3582d6118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3b4c994e4c83a6371ce0664e5a321d273c7d4ddfe0307dc8902aae223bcfc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "exact_match": "exactMatch",
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d706e397c74dbd9549848a6a8397052976d39811baf0743323779b9fa9d48d21)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument exact_match", value=exact_match, expected_type=type_hints["exact_match"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if exact_match is not None:
            self._values["exact_match"] = exact_match
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Configures how sets of query string parameters translate to cache keys.

        Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exact_match(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        '''
        result = self._values.get("exact_match")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of parameter field names to include in or exclude from the cache key.

        By default, these match the field names as string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d38daf133adb44b4ec5d965e45a21da9e0347e8292a4b1b57f98631c5d6c80e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetExactMatch")
    def reset_exact_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExactMatch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="exactMatchInput")
    def exact_match_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "exactMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edf2765d0885466984e9960047acc86bcf80e7e4d5a510e8b59c54abfdf90c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="exactMatch")
    def exact_match(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "exactMatch"))

    @exact_match.setter
    def exact_match(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba91a36c49f1694f9878fefbebd100cccbb13c089199bbda34d26f5088f907e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exactMatch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef3ad62985056f4ba78855da6888a914188e63156e5b9ca2abfd7869bf263279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e39a207b4af636e91a09cbf3e7576c51128da9045404f65993b5f2dcf0b6fae4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff0ecbd70c5eeb609c89fc882a38232dcf9f55ad9da82cc10fe24b9250ce6f1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b65b503f241df60d60ef51166deecc7695af1ea9ee4255eeaf332133ee7ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38a4faa95fed8da6ee06529cda34d663036bc98e2b4ac6a1de6f8d5023fded5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "purge_key": "purgeKey",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e9ab9b8de290cf30135c7c3c91bf7f8305e853c3e5b8dd51fe50794825583e3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_key", value=purge_key, expected_type=type_hints["purge_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if purge_key is not None:
            self._values["purge_key"] = purge_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the new cache key path as an alphanumeric value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        '''
        result = self._values.get("purge_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__720dd4298f199b1da977b5dd66f8b31eb8394de2cb1bfdbfe594f4c8453d431e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeKey")
    def reset_purge_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeKeyInput")
    def purge_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9486f46f02e4aa50bebf3d34d86b19a70f244404b2893bc805079344c45079e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeKey")
    def purge_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeKey"))

    @purge_key.setter
    def purge_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2608fcdfd4b38220330768f4b53336dca9fc4199d7f6048761adaaed1d532d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__314c3c7f52d515c2c516f952f57faca65065301ec8ed75219185f42d02740f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e102ff36a17e46c81345b59b03eb0e7e5d992fe7a1c3fe6eb844f3698e642a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915ed9b37d1cf021509ddc15728b716442b21acd1a8c38fab05c2732ce37361a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_body": "useBody",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6007de02aa5ebee4f70ba117cce8bdc9ff67bb7ca6d8b98899fde594026ef5cd)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_body", value=use_body, expected_type=type_hints["use_body"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_body is not None:
            self._values["use_body"] = use_body
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables caching of POST responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_body(self) -> typing.Optional[builtins.str]:
        '''Define how and whether to use the POST message body as a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        '''
        result = self._values.get("use_body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2243dcf3effac09d53be41831dc9e13db01e00a56c6ecfc81bb78e36dfe4919d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseBody")
    def reset_use_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseBody", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useBodyInput")
    def use_body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "useBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a79b66355ecd8d4ddf1560a2e35f1f091d361016e8d9964576ed37a515902d10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__345caad7c3d79f66c878c6d9d1afe8536268743e103a554881eb94ecfd6dd849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdd60c3de4fd8be50dd7c9950784273700ca41d060dbf6773310070b751f5b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useBody")
    def use_body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "useBody"))

    @use_body.setter
    def use_body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8800740de94c0bb067d757ace960de697115f0f7dd8bf3dc8981f640ed9bdf6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useBody", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52b4f5520cb699585b3c27d0f5fb2f061239aaff34af0f6057b827d219d135e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28265e89c871fe578d69904a57d71664b5360d2fe10e00424dcf10a1db856d50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce53acdcd92c3e4a6a758c2efb3dff289e09dd623686bd6f3ca475100ff702c7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the redirect caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ddbd2a8f413e5a574761497e4f7994628d98a073602a98ace64ce60ff6671cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f038b45482ec417242ee3600fa1b066f5da024e2d069b36529d394ee12af236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd730b9349312b0b50d789d949f3c6a7255a7d994f49d0582ef478c0af2652d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abff1a6fe7b2675fb84ea5299e5c32b74bdd02ed0e88437eaef2d07b97cce992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d0350b853cd840ad185f4a555f832b788aa621f52a3a0800bbdbff2040bd66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3ce75828d3cef99b2cc79ce8776580f1aaa6c43f8c6cefddfce04b12729082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "tag": "tag",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b7c72439ab9a655e7bfe45b83e3acc5aa8861a554a12a2500c7f550649a450)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument tag", value=tag, expected_type=type_hints["tag"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if tag is not None:
            self._values["tag"] = tag
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tag(self) -> typing.Optional[builtins.str]:
        '''Specifies the cache tag you want to add to your cached content.

        A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_``|~-]`

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        '''
        result = self._values.get("tag")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a8a6a67c3c1268534924453ba3890343cc2ac06ff1a3c109118d141a501400)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTag")
    def reset_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTag", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="tagInput")
    def tag_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3aebb8724bddc4104b7805e2c648b8b26c69e35bdb3e2d1c6af3f192c925b54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="tag")
    def tag(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tag"))

    @tag.setter
    def tag(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61472ae17c69d231b1f01526c995b329bad94c668014710659615b10e7a47b7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tag", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f771de21b31db87ea129343aea1e839c5820cbfb51304c6c0b22f2d2185bae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33ece048b4ace7c2b8152ea683832576a7898d51d8c3555de19f363b7f3dd197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb30c8282a947375881cc43c96d127076e74ec737a44db7d697d3b148c4a649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a511ebe14c2850be83e13937807b66ccc66ef1c7b9300f5ac490dd2d64a17f5e)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specifies when to include the ``Edge-Cache-Tag`` in responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b493b68d8b35782adcccebb868a46d5218fc603bf7da103a52778afce6c5de5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093ba54a86788cd1dc14d36fe8a93721d03355ccc6c87d354877e83cc6159902)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8cfa1eadda21182524e6903beb46ca265a359653df28e15706806c8300cf27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50f533e16580be50c52c0515501850f01fd58e0313afd6a2484334245a9ab27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c0a555565e1367e14e082867f974041d8530c341c10794c8cea6a8faa05c3ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77d13671c7d14d21958edd085088088e70f4eff09043f40b0533f2e3126caf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "cacheability_settings": "cacheabilitySettings",
        "cache_control_directives": "cacheControlDirectives",
        "default_ttl": "defaultTtl",
        "enhanced_rfc_support": "enhancedRfcSupport",
        "expiration_settings": "expirationSettings",
        "honor_max_age": "honorMaxAge",
        "honor_must_revalidate": "honorMustRevalidate",
        "honor_no_cache": "honorNoCache",
        "honor_no_store": "honorNoStore",
        "honor_private": "honorPrivate",
        "honor_proxy_revalidate": "honorProxyRevalidate",
        "honor_s_maxage": "honorSMaxage",
        "locked": "locked",
        "must_revalidate": "mustRevalidate",
        "revalidation_settings": "revalidationSettings",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb83b2f07d33f0a2b94e6465259d6298dd251bfec76eed19da08474d8f85fd7)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument cacheability_settings", value=cacheability_settings, expected_type=type_hints["cacheability_settings"])
            check_type(argname="argument cache_control_directives", value=cache_control_directives, expected_type=type_hints["cache_control_directives"])
            check_type(argname="argument default_ttl", value=default_ttl, expected_type=type_hints["default_ttl"])
            check_type(argname="argument enhanced_rfc_support", value=enhanced_rfc_support, expected_type=type_hints["enhanced_rfc_support"])
            check_type(argname="argument expiration_settings", value=expiration_settings, expected_type=type_hints["expiration_settings"])
            check_type(argname="argument honor_max_age", value=honor_max_age, expected_type=type_hints["honor_max_age"])
            check_type(argname="argument honor_must_revalidate", value=honor_must_revalidate, expected_type=type_hints["honor_must_revalidate"])
            check_type(argname="argument honor_no_cache", value=honor_no_cache, expected_type=type_hints["honor_no_cache"])
            check_type(argname="argument honor_no_store", value=honor_no_store, expected_type=type_hints["honor_no_store"])
            check_type(argname="argument honor_private", value=honor_private, expected_type=type_hints["honor_private"])
            check_type(argname="argument honor_proxy_revalidate", value=honor_proxy_revalidate, expected_type=type_hints["honor_proxy_revalidate"])
            check_type(argname="argument honor_s_maxage", value=honor_s_maxage, expected_type=type_hints["honor_s_maxage"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument must_revalidate", value=must_revalidate, expected_type=type_hints["must_revalidate"])
            check_type(argname="argument revalidation_settings", value=revalidation_settings, expected_type=type_hints["revalidation_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if cacheability_settings is not None:
            self._values["cacheability_settings"] = cacheability_settings
        if cache_control_directives is not None:
            self._values["cache_control_directives"] = cache_control_directives
        if default_ttl is not None:
            self._values["default_ttl"] = default_ttl
        if enhanced_rfc_support is not None:
            self._values["enhanced_rfc_support"] = enhanced_rfc_support
        if expiration_settings is not None:
            self._values["expiration_settings"] = expiration_settings
        if honor_max_age is not None:
            self._values["honor_max_age"] = honor_max_age
        if honor_must_revalidate is not None:
            self._values["honor_must_revalidate"] = honor_must_revalidate
        if honor_no_cache is not None:
            self._values["honor_no_cache"] = honor_no_cache
        if honor_no_store is not None:
            self._values["honor_no_store"] = honor_no_store
        if honor_private is not None:
            self._values["honor_private"] = honor_private
        if honor_proxy_revalidate is not None:
            self._values["honor_proxy_revalidate"] = honor_proxy_revalidate
        if honor_s_maxage is not None:
            self._values["honor_s_maxage"] = honor_s_maxage
        if locked is not None:
            self._values["locked"] = locked
        if must_revalidate is not None:
            self._values["must_revalidate"] = must_revalidate
        if revalidation_settings is not None:
            self._values["revalidation_settings"] = revalidation_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cacheability_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        '''
        result = self._values.get("cacheability_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_control_directives(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        '''
        result = self._values.get("cache_control_directives")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_ttl(self) -> typing.Optional[builtins.str]:
        '''Set the ``MAX_AGE`` header for the cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        '''
        result = self._values.get("default_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enhanced_rfc_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        '''
        result = self._values.get("enhanced_rfc_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        '''
        result = self._values.get("expiration_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def honor_max_age(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        '''
        result = self._values.get("honor_max_age")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        '''
        result = self._values.get("honor_must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_cache(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request.

        Effectively, set the time to live ``ttl`` to zero seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        '''
        result = self._values.get("honor_no_cache")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        '''
        result = self._values.get("honor_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``private`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        '''
        result = self._values.get("honor_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_proxy_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        '''
        result = self._values.get("honor_proxy_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_s_maxage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        '''
        result = self._values.get("honor_s_maxage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin.

        If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        '''
        result = self._values.get("must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def revalidation_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        '''
        result = self._values.get("revalidation_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''The maximum time content may remain cached.

        Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a9dba1344658d56f582fae3af65f077a5e3f6e6443dee98abe2e7264a8a876)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetCacheabilitySettings")
    def reset_cacheability_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheabilitySettings", []))

    @jsii.member(jsii_name="resetCacheControlDirectives")
    def reset_cache_control_directives(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheControlDirectives", []))

    @jsii.member(jsii_name="resetDefaultTtl")
    def reset_default_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultTtl", []))

    @jsii.member(jsii_name="resetEnhancedRfcSupport")
    def reset_enhanced_rfc_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedRfcSupport", []))

    @jsii.member(jsii_name="resetExpirationSettings")
    def reset_expiration_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationSettings", []))

    @jsii.member(jsii_name="resetHonorMaxAge")
    def reset_honor_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMaxAge", []))

    @jsii.member(jsii_name="resetHonorMustRevalidate")
    def reset_honor_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMustRevalidate", []))

    @jsii.member(jsii_name="resetHonorNoCache")
    def reset_honor_no_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoCache", []))

    @jsii.member(jsii_name="resetHonorNoStore")
    def reset_honor_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoStore", []))

    @jsii.member(jsii_name="resetHonorPrivate")
    def reset_honor_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorPrivate", []))

    @jsii.member(jsii_name="resetHonorProxyRevalidate")
    def reset_honor_proxy_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorProxyRevalidate", []))

    @jsii.member(jsii_name="resetHonorSMaxage")
    def reset_honor_s_maxage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorSMaxage", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMustRevalidate")
    def reset_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMustRevalidate", []))

    @jsii.member(jsii_name="resetRevalidationSettings")
    def reset_revalidation_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevalidationSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettingsInput")
    def cacheability_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheabilitySettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectivesInput")
    def cache_control_directives_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheControlDirectivesInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultTtlInput")
    def default_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "defaultTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupportInput")
    def enhanced_rfc_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enhancedRfcSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationSettingsInput")
    def expiration_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMaxAgeInput")
    def honor_max_age_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidateInput")
    def honor_must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoCacheInput")
    def honor_no_cache_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoStoreInput")
    def honor_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="honorPrivateInput")
    def honor_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidateInput")
    def honor_proxy_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorProxyRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorSMaxageInput")
    def honor_s_maxage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorSMaxageInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mustRevalidateInput")
    def must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="revalidationSettingsInput")
    def revalidation_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "revalidationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6137af0dc094771b4f648de6605090bbff65ee1484984980a2f588f430ca811a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettings")
    def cacheability_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheabilitySettings"))

    @cacheability_settings.setter
    def cacheability_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa8b3e264626713a073602208b1ef28c8e920042350d13e226f39e73343a298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheabilitySettings", value)

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectives")
    def cache_control_directives(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheControlDirectives"))

    @cache_control_directives.setter
    def cache_control_directives(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a63c2a0989c90c899e2cd3a497eb87bd651021cfca60b759079e17fd913930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheControlDirectives", value)

    @builtins.property
    @jsii.member(jsii_name="defaultTtl")
    def default_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "defaultTtl"))

    @default_ttl.setter
    def default_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d105165b7f2597c63bf6dc6dc80c968b6e43128c5ea72ff31fa166e74b1c6ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultTtl", value)

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupport")
    def enhanced_rfc_support(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enhancedRfcSupport"))

    @enhanced_rfc_support.setter
    def enhanced_rfc_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f27dc95ab044b2c058a7925f0bfeeaae0c4ad9b6acd4022c7cb47f42c027ff82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enhancedRfcSupport", value)

    @builtins.property
    @jsii.member(jsii_name="expirationSettings")
    def expiration_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationSettings"))

    @expiration_settings.setter
    def expiration_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__822e9397d5c9db273e4698597f91001aed1cff476941f68ad99d37d5a0de4fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="honorMaxAge")
    def honor_max_age(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMaxAge"))

    @honor_max_age.setter
    def honor_max_age(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae4c862bb37d3b27d64150c680dd2d01df324080bdfdc1b6f83804abbedf7c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidate")
    def honor_must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMustRevalidate"))

    @honor_must_revalidate.setter
    def honor_must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89d41f971c8ccc1e05b628b432b43533f13367eef3fe9aac36c2a54c3658a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoCache")
    def honor_no_cache(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoCache"))

    @honor_no_cache.setter
    def honor_no_cache(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b824dfc5cfe77478b27635c56b44e425be75c4f813ec9c2e6eb6fd9c5dc418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoCache", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoStore")
    def honor_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoStore"))

    @honor_no_store.setter
    def honor_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c002f02a1c512ce8c81604520b34f3c365c48efc3e6580c36d9cc2dc18a760cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="honorPrivate")
    def honor_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorPrivate"))

    @honor_private.setter
    def honor_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__070125d7c77294b290b4ab617afd385a4e53d2f28e5b351fc1eb556bf3de9d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidate")
    def honor_proxy_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorProxyRevalidate"))

    @honor_proxy_revalidate.setter
    def honor_proxy_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c336c284c5bb97c399fe09f2f326d74da283ea4c958f29f199f637ee714948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorProxyRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorSMaxage")
    def honor_s_maxage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorSMaxage"))

    @honor_s_maxage.setter
    def honor_s_maxage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765e3927a930ff1a1fb6aa0b28d5ea5940004deb71d2626b382fa8ed1763e913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorSMaxage", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b66b9367ce64954690a3549f0da91a2710d5923b7f8bdaeb2740a8b289066d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mustRevalidate")
    def must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mustRevalidate"))

    @must_revalidate.setter
    def must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0ef4db07bb63caab4f04eb780bc80c56b6623d792c8e90f6d3fafae0998b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="revalidationSettings")
    def revalidation_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "revalidationSettings"))

    @revalidation_settings.setter
    def revalidation_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e029dcba9bc5911f01ba922f11feb1414b693dbbff604862b8938f31e26c0965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revalidationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b080f85ff5de009fb78e9cdf04a3d85db8b37a583115f98506b36e09c890264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217acaca0c4b25dd2c16947410381d35635d23022fe6a0f27465a52065064b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe6c485f8164530608f64abd6ef6716677f31700e0bdcaeda49757022b4a9953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00d6da8caf54cfecfb7e34315e5ce353fa0aa4df3d69c9a6c29ca71870d2045e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2c5579f17bd4da6c9a97cf11eb671ceb058b7a1be4086070987468af9826df)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the centralized authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7cd9df80a550bc61167c4730080393bfe2d8603aa9265d4be9972d396d1e89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f8886d0af0c8bd5708fc9d5e4b017450915b2eef4224a797ff50fcea58e694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a1c78f444885708efe003b8a12d125e2e23e27e30a6deb3d03bcb5dcb0fe37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad5333262411cf0994dd8efbd7e6e7efc27514600f64c743ad2463c3edb1c72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381dac8aad3a910b1473385bf394a7283e5b69f3580a725de1dc1a6e4a32b467)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d916fa4064a91476cdb6dff5e330c66bd219eef0a61883c73f114f7901856eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "limit": "limit",
        "locked": "locked",
        "serve404": "serve404",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f73bea692d2abec5a0658df06d0148363e37f88b46b6e7483257ac05d1dbc41)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serve404", value=serve404, expected_type=type_hints["serve404"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if limit is not None:
            self._values["limit"] = limit
        if locked is not None:
            self._values["locked"] = locked
        if serve404 is not None:
            self._values["serve404"] = serve404
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to chase redirects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def limit(self) -> typing.Optional[builtins.str]:
        '''Specifies, as a string, the maximum number of redirects to follow.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serve404(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        '''
        result = self._values.get("serve404")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1714fa8a63d74c88fb007ba47c36cd09948c2ecd8527312d62d2b1fcedd952f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServe404")
    def reset_serve404(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServe404", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serve404Input")
    def serve404_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "serve404Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1020c6fb67e948fc5f260238f5bc518eeb96fecb932e87ecb57537df839d002b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e25ee0a24ffb9f7b506781cc6569db178eb4a35c272bac9dc60b8db52aba1ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__992ebf8c9e2cc89c74dd5c6d7b8a3b0d38245826bf065adc864e618ce46e5310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serve404")
    def serve404(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "serve404"))

    @serve404.setter
    def serve404(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc130dcd2e5519b7e03548cb279244f7b787b882ecacec83158de3ff2a7fc94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serve404", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c594200ece4bf497815be5736d36fc049615099df5b41b4fa45d96f75f00702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29584678e10e98078b0afbf922ebf1d3ac2b8b309d539124aaafd0daaacd156c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fd1d64752bd37caff2b03ba903018a56f7d2af04b21e85901c589486dac4ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth",
    jsii_struct_bases=[],
    name_mapping={
        "client_certificate_attributes": "clientCertificateAttributes",
        "enable": "enable",
        "enable_client_certificate_validation_status": "enableClientCertificateValidationStatus",
        "enable_complete_client_certificate": "enableCompleteClientCertificate",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth:
    def __init__(
        self,
        *,
        client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param client_certificate_attributes: Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        :param enable: Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param enable_client_certificate_validation_status: Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        :param enable_complete_client_certificate: Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5cd5b608e207d9758a2cea4eb88f03068025e54f073383a7662af353fbcd4f3)
            check_type(argname="argument client_certificate_attributes", value=client_certificate_attributes, expected_type=type_hints["client_certificate_attributes"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument enable_client_certificate_validation_status", value=enable_client_certificate_validation_status, expected_type=type_hints["enable_client_certificate_validation_status"])
            check_type(argname="argument enable_complete_client_certificate", value=enable_complete_client_certificate, expected_type=type_hints["enable_complete_client_certificate"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if client_certificate_attributes is not None:
            self._values["client_certificate_attributes"] = client_certificate_attributes
        if enable is not None:
            self._values["enable"] = enable
        if enable_client_certificate_validation_status is not None:
            self._values["enable_client_certificate_validation_status"] = enable_client_certificate_validation_status
        if enable_complete_client_certificate is not None:
            self._values["enable_complete_client_certificate"] = enable_complete_client_certificate
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def client_certificate_attributes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        '''
        result = self._values.get("client_certificate_attributes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin.

        You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_client_certificate_validation_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header.

        This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        '''
        result = self._values.get("enable_client_certificate_validation_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_complete_client_certificate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the complete client certificate in the header, in its binary (DER) format.

        DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        '''
        result = self._values.get("enable_complete_client_certificate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7c880f447be6353c61ff2f80c3c10984dbabfdd5a3c4d3443d3877d99cc391)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetClientCertificateAttributes")
    def reset_client_certificate_attributes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificateAttributes", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetEnableClientCertificateValidationStatus")
    def reset_enable_client_certificate_validation_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableClientCertificateValidationStatus", []))

    @jsii.member(jsii_name="resetEnableCompleteClientCertificate")
    def reset_enable_complete_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCompleteClientCertificate", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAttributesInput")
    def client_certificate_attributes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "clientCertificateAttributesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableClientCertificateValidationStatusInput")
    def enable_client_certificate_validation_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableClientCertificateValidationStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCompleteClientCertificateInput")
    def enable_complete_client_certificate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCompleteClientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAttributes")
    def client_certificate_attributes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "clientCertificateAttributes"))

    @client_certificate_attributes.setter
    def client_certificate_attributes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc6c964a3a694d24dd7474e37623b2e56dbf67e7cfb292668c74c26a58a675d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientCertificateAttributes", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5440587d57fcd8974068c3338b1b952a05bf0ae74ec8cc8d705b7e4014d8bd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="enableClientCertificateValidationStatus")
    def enable_client_certificate_validation_status(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableClientCertificateValidationStatus"))

    @enable_client_certificate_validation_status.setter
    def enable_client_certificate_validation_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ecb49c9fc33d113d71b9561a81ee01461bf62b68396a066b0f3b1fa9f54c72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableClientCertificateValidationStatus", value)

    @builtins.property
    @jsii.member(jsii_name="enableCompleteClientCertificate")
    def enable_complete_client_certificate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCompleteClientCertificate"))

    @enable_complete_client_certificate.setter
    def enable_complete_client_certificate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42d9309f754160c2901ae953dccf077c568a4fa867548e359d3cf59dc3965add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCompleteClientCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2379bb2257bf83cb9414f079c9449f913d283a94ce2ec6aa08697633ce4492e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ae6772d4613bef748451f8ee6e9cf2e418cd25b21c7cebae4f0c9bafdab672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e41b8ad69919ec9513299f61cc3077e5d094901ada4a67d7304bb7acfc97041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a29d21a500187277b076cab6ca3e7eec0f0297772e36fc73610fa81ed89074fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "country": "country",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics:
    def __init__(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90821190b7b8c84c636b6b2cc9ae0e5b1eae3ffeae718481f09e3ee36ee6e041)
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if country is not None:
            self._values["country"] = country
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the client request's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4044160449165354aef1e8072e5ba566cf97787cd9c32689a723bbec0a6301)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13a84f322e584c32808bdc83c844b803bb903c095ea62b27b49cd14d7acf6b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e8ee6f8352e30c9f01bece543bf181d0c56db8780bcb78925d7f0ebe27b04e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0606951a714b0ec73b11875e37c6843e295766f6d79e660b6ac4b76b0d788922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581bedc98091b07ed05bd3a49dd87af927aafe2c6d8cead4237a13178b11be63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd6ce83fbf28b6f143e1df00ead8f59b5cf3a18d61a7d957e81571f638500eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects",
    jsii_struct_bases=[],
    name_mapping={
        "cloud_locations": "cloudLocations",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects:
    def __init__(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59f5a83012bf715276503c3ba7645150fae09b1c7ba2c605884d316db451ffe7)
            check_type(argname="argument cloud_locations", value=cloud_locations, expected_type=type_hints["cloud_locations"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloud_locations is not None:
            self._values["cloud_locations"] = cloud_locations
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloud_locations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the geographical locations of your cloud origin.

        You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        '''
        result = self._values.get("cloud_locations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Channels the traffic to maximize the egress discount at the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4514b594ade0d73dace0d957408d782cac4f60d83af95a01b4917c893421f7cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudLocations")
    def reset_cloud_locations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudLocations", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudLocationsInput")
    def cloud_locations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cloudLocationsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudLocations")
    def cloud_locations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cloudLocations"))

    @cloud_locations.setter
    def cloud_locations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66eb18c3ee7f732685b3446206b8d15b5a6d9e4d7ca27ac8d1892b06de2175eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudLocations", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a41aa850322a6ac03a7a8120287bf4f4fc7a549ec39c768ed1a008b6e26b0359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8135d218309ec9f9b6a49767fdfbffa880d49f56650fa42a49ed64f2e30ead6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a438693242ccaf2a5efa4b3dab2eb804da89c791e0fcd166d8f6a0bfb32a97a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9396f4c6bef9786d8d29846f686cfd7ea292f47e688561496981d8ec9c184d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e930769cb03fd4ba0d8dd530438cedc1e95c199f71a1d3dfb0a3479c3dd5357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "location": "location",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c53275099c23e972aa9d2c7e8c1c7030dc2563facf87b3828049ed3f1b3a37f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Wrapper behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''The location you want to distribute your Cloud Wrapper cache space to.

        This behavior allows all locations configured in your Cloud Wrapper configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "custom_failover_map": "customFailoverMap",
        "enabled": "enabled",
        "failover_map": "failoverMap",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced:
    def __init__(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ea466918f456deb165dafd1332ff6095782053b8a1a7582e3c5a0da0eea973e)
            check_type(argname="argument custom_failover_map", value=custom_failover_map, expected_type=type_hints["custom_failover_map"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_map", value=failover_map, expected_type=type_hints["failover_map"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_failover_map is not None:
            self._values["custom_failover_map"] = custom_failover_map
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_map is not None:
            self._values["failover_map"] = failover_map
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        '''
        result = self._values.get("custom_failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables failover for Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        '''
        result = self._values.get("failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a1e488b967746bfa43423968ef51fad2bea7a286ce04c2490be080a87d3a28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomFailoverMap")
    def reset_custom_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomFailoverMap", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverMap")
    def reset_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMap", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMapInput")
    def custom_failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customFailoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverMapInput")
    def failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMap")
    def custom_failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customFailoverMap"))

    @custom_failover_map.setter
    def custom_failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03746afee9450b281517b69a83611502ddef0433ef1836c76da506dd0c65bf54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customFailoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c281d00c24147102d798c9476d94b96ffc3564e0cf859ccfdba69d2690b6a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMap")
    def failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMap"))

    @failover_map.setter
    def failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc3fcc5b345244690185683cbd64f6748136e5876698683ab0e48042dedc7cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1cddd27e04a0306f0afe4aed38d1480a59c631cecef4faf5e479084daf0098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f753503b882a2e6e428024e59903861ed03c97ae23515af1833151b54292038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8efe03ac25b5a7b132e1e3e4746923a2fab130ef9adf5fd1358c4a4a01ff517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b531e37123d23c0fd679666cac1dd052dfb8c025961c8093ad28c234e6bdce1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ea7e1d3a18f1b408f937fab406ee1229b58bb1c091185a9aaf1f89c9754875)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f71bef977acc21cdf31c5bea15399a604039d78a5d2ecb581252d57cc1e3a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64dc23f7878b6644ca5fee52932f43f238bb3e859c3f2cf96cd3debbc71a3f5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2a9eae30a483d5f3245ebb6d85e2ec2a7be2408c3077bf7ac3f257bb6f782c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a4599afdd79efd9dd9dd2fed0bc3d85cc999762136b46aa648feb1c97a3309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c577ae2dccdab3029007344d30f020a995af008cc5edce54e90adc79a37a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3675e39540250b02a35334a6ae568275a99eebf2adb7c2d783026ed4d2a5abf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData",
    jsii_struct_bases=[],
    name_mapping={
        "enable_cmcd_segment_prefetch": "enableCmcdSegmentPrefetch",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData:
    def __init__(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c719a988f1955650dae5cd1b6d37b8a245af462e955d55d1c918417bb8fc0787)
            check_type(argname="argument enable_cmcd_segment_prefetch", value=enable_cmcd_segment_prefetch, expected_type=type_hints["enable_cmcd_segment_prefetch"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_cmcd_segment_prefetch is not None:
            self._values["enable_cmcd_segment_prefetch"] = enable_cmcd_segment_prefetch
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        '''
        result = self._values.get("enable_cmcd_segment_prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7adddc1b76b061eb8e17484a131d3ff746d417ede3c300678e63eff13ce8d20d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableCmcdSegmentPrefetch")
    def reset_enable_cmcd_segment_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCmcdSegmentPrefetch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetchInput")
    def enable_cmcd_segment_prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCmcdSegmentPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetch")
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCmcdSegmentPrefetch"))

    @enable_cmcd_segment_prefetch.setter
    def enable_cmcd_segment_prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6496129b651737fbabf1c710cf7bbc439842a4b1d8ef99badfd47c61d3c14aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCmcdSegmentPrefetch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6968ad95d9405146bf9755a79b12d360c97e5f893bcce1100819bbd88d626b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d13c6b048e5ef257b70b729a4c35f7f3ae419951618fe92df2586ce5f293cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc39c4cd17017241c7bde65604196dc62cd68f2e35f39824352ae721d321ac65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b70490ce21486b8aeb50e55176c3d7e283050ff90f87c2d8fcc77915861960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__511415bf5e896f9f9ad85ed14d09d1bbdd9be0a4e31e2b74bd2bbc2e110a5688)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.'''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b375191b0255805dcc713d22f15578cb1b6ace6d1f42b81ae680401d3234aff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc60dd97522209de7a55eb1bae7975503b175a09f364a1d753aaf93416113a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3868f967814c97858c1385126908d9c1732584c829051cf853cc7469df31aaf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c183dd1d0d56a41eb2008359fff976c7e2c302d8101e912e39a26ebddff0fba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024e580a52e5d2139d6e889a3fc2052719435e663217fbc5eced9fc86c04f49b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9cfa2267242ebd86536c2c290641736d9f3bf2a947a4e130d4c2c2a4afccd5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse",
    jsii_struct_bases=[],
    name_mapping={
        "body": "body",
        "enabled": "enabled",
        "force_eviction": "forceEviction",
        "ignore_purge": "ignorePurge",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse:
    def __init__(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d1b496f4f199d7d9b74ef897619ef6171b0d281c2f8a2bb21097f329294452)
            check_type(argname="argument body", value=body, expected_type=type_hints["body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_eviction", value=force_eviction, expected_type=type_hints["force_eviction"])
            check_type(argname="argument ignore_purge", value=ignore_purge, expected_type=type_hints["ignore_purge"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if body is not None:
            self._values["body"] = body
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_eviction is not None:
            self._values["force_eviction"] = force_eviction
        if ignore_purge is not None:
            self._values["ignore_purge"] = ignore_purge
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def body(self) -> typing.Optional[builtins.str]:
        '''HTML response of up to 2000 characters to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        '''
        result = self._values.get("body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Serves the custom response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_eviction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        '''
        result = self._values.get("force_eviction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_purge(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to ignore the custom response when purging.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        '''
        result = self._values.get("ignore_purge")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP response code to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa4d47d5cba0d5fee30f235edbc607f37c419b53cc53200e3e82d532c101452)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBody")
    def reset_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceEviction")
    def reset_force_eviction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceEviction", []))

    @jsii.member(jsii_name="resetIgnorePurge")
    def reset_ignore_purge(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnorePurge", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bodyInput")
    def body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceEvictionInput")
    def force_eviction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceEvictionInput"))

    @builtins.property
    @jsii.member(jsii_name="ignorePurgeInput")
    def ignore_purge_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignorePurgeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="body")
    def body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "body"))

    @body.setter
    def body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a1a9ce5d5cf11f97e13ed6439566badd013c01e54bd1ef849c5d74af32fdb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "body", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7c11bd72f4d49d84299d813ac43768097efa39932a06a4c5ba69e6783fd079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceEviction")
    def force_eviction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceEviction"))

    @force_eviction.setter
    def force_eviction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bfcf386fa5890892c764ad27e87494a8ea0181594211e7fc353e92a20bd12c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceEviction", value)

    @builtins.property
    @jsii.member(jsii_name="ignorePurge")
    def ignore_purge(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignorePurge"))

    @ignore_purge.setter
    def ignore_purge(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588a1a0e7ff3b6571be22a3ade7d104b66edeedaa1ab86dcae5bbd0cef52437f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignorePurge", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e74cb4fea97de2892ac255b7d5099406d84910a2c8c2066fdc871c98e5558d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99cc493c073850bb0a290aa26f867edcf01197658b9a971b7e8de63ba3764e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452e449d9a20695f779af0f15b588543c50ffdda518f85066b72f7fd59dca050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a9c398a39e21de127ac61719326d89135a573c4f4b4af7b9cb9577e6539394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0e2cd507bbb1402a6eabe80c557f6305207a85670c00491defdb97cc421bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4cfb8ba81ad84edcd02b9a257953f458e50dcdc3d16d2b75583fe55bb0c665)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_dash_custom": "segmentDurationDashCustom",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hds_custom": "segmentDurationHdsCustom",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_hls_custom": "segmentDurationHlsCustom",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_duration_smooth_custom": "segmentDurationSmoothCustom",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946d50e59917d14cb9451dc29e4701cf80e498ede8e7c2f0622f43593ff0123b)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_dash_custom", value=segment_duration_dash_custom, expected_type=type_hints["segment_duration_dash_custom"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hds_custom", value=segment_duration_hds_custom, expected_type=type_hints["segment_duration_hds_custom"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_hls_custom", value=segment_duration_hls_custom, expected_type=type_hints["segment_duration_hls_custom"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_duration_smooth_custom", value=segment_duration_smooth_custom, expected_type=type_hints["segment_duration_smooth_custom"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_dash_custom is not None:
            self._values["segment_duration_dash_custom"] = segment_duration_dash_custom
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hds_custom is not None:
            self._values["segment_duration_hds_custom"] = segment_duration_hds_custom
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_hls_custom is not None:
            self._values["segment_duration_hls_custom"] = segment_duration_hls_custom
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_duration_smooth_custom is not None:
            self._values["segment_duration_smooth_custom"] = segment_duration_smooth_custom
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        '''
        result = self._values.get("segment_duration_dash_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        '''
        result = self._values.get("segment_duration_hds_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        '''
        result = self._values.get("segment_duration_hls_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        '''
        result = self._values.get("segment_duration_smooth_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a45e71d3be38107309b33fc7acb0cacaee47bc66e4c8c0178bb54ba7e386653)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationDashCustom")
    def reset_segment_duration_dash_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDashCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHdsCustom")
    def reset_segment_duration_hds_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHdsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationHlsCustom")
    def reset_segment_duration_hls_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHlsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentDurationSmoothCustom")
    def reset_segment_duration_smooth_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmoothCustom", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustomInput")
    def segment_duration_dash_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationDashCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustomInput")
    def segment_duration_hds_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHdsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustomInput")
    def segment_duration_hls_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHlsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustomInput")
    def segment_duration_smooth_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationSmoothCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2741098ea3c71655ea58cc17cf065dad2b16899997b16d7d68a5d4e9e31af698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__358272ece740f64ebfd142e668d6d7b01fdb3f000b460c83752cf005ad971637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb60ee94519f505a26922902e929645c87a0dca9db388c32dd997e0c4df58af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc408c2fa575d46938f471f948729de686b9fcd7948f4eb5f3b85bb4ae6e818a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503263674e723d27169b7ab72fabbf1909ec15a332bfe2288bee71c1ffb8c9aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6e8c0898a74f70605ea61bd7fcdd672d4311a696e248953a09c54a1e7de2052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d092b6d88100f9d24aecd9429e410d7db97d32806bf85ad1195e7d25bf42ad00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89fbe1d9e08c2299aa066aa7eb311a57a16094f51f87ff27ee620cb929c29681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustom")
    def segment_duration_dash_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationDashCustom"))

    @segment_duration_dash_custom.setter
    def segment_duration_dash_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e6a0fe4d97772c488c1f7a04c75d2768bb62899bb58471530b2edaab0817572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDashCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519ea25c9ed8d7cf9be9ee145098681d3b2e07d514a5d33974983eab1fa83a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustom")
    def segment_duration_hds_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHdsCustom"))

    @segment_duration_hds_custom.setter
    def segment_duration_hds_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0167ee0b4224d541982af58a527f862853e054bf6acd6eeda3fd9a445e922df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHdsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__971ea5684f520dad469ae5f8e4388f246dd1b7571a960cde89e7d7299a23c77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustom")
    def segment_duration_hls_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHlsCustom"))

    @segment_duration_hls_custom.setter
    def segment_duration_hls_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0f818b89836eaf5048027b9ec2db0cf9712e89dce4e7375f56cf892141fa2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHlsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f26a9eb6d54967772dc8ba315f06b54a9f21a98b245cece249f159b760b3664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustom")
    def segment_duration_smooth_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationSmoothCustom"))

    @segment_duration_smooth_custom.setter
    def segment_duration_smooth_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7629c050a5f428ca7358eed4747a8617a5bdea10e6e02c38522758d986c89c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmoothCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339e3c296bc7227aef6f6b1b05e327cac45746fee10a99d403e605d29930a351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27533313779fa8044d60e6300d7e4745a3feba5f2a663a720430bec890267c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51855c0c148860d16e56261d1ead406d86fd29efd96d3aeaf5214060cafc405a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c472940ea34eefce1084f169ed80f21d32cc8447426000542be597e16d8dd30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28144b1b54e9122ebc61e8385a3338f431d0cc13c4fc02f2adf510e8860bee25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d141df8bc8f1e7e223bc95d19677e8c496238cecc6ecc3ee0032ad8da14a5070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ee48bd6a9896ae74889adbf9bde5ba9b473f4ccc441c6a16945fae12d2e4f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52fb1d27e81df046f8e6e5374121bfb9bdc2581357466525f522e09fa5319877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "optimize_option": "optimizeOption",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16f0cbaf7f6dba8e291f2b72092be807966027c95602921d06a3561df497487d)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_option", value=optimize_option, expected_type=type_hints["optimize_option"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_option is not None:
            self._values["optimize_option"] = optimize_option
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_option(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes the delivery throughput and download times for large files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        '''
        result = self._values.get("optimize_option")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__142d2f71963da2cdb4e1f66a2f5e78ae986a442f753da111faddd9ef7f3580d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeOption")
    def reset_optimize_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeOption", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeOptionInput")
    def optimize_option_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optimizeOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b19293515f50c872e6ef16d5a6de488110d0f38f691ec29a6612385f5e37c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cde7bc9793a2224832ffd4b948d061b6445169ec4b346ae02320c8b8a3097a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27d56c45681f5c3d3f2507bbf7f09111f64686fe30425cd4f4d975a81e74206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e445ab7df77064004a722debef7b07cd4b71f08a54e982bd1213352491178507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeOption")
    def optimize_option(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optimizeOption"))

    @optimize_option.setter
    def optimize_option(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed8ae8acf8598ddeda58f4bc312c75ea0232d39f85f4e9fb734e4aaee2ace52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeOption", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec36af443211a72dcfe88ea15e75fbdf69ffb4621c931a308131b031a1cc5a97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a5a165644ce5efcaee838c542c8337ec6a8966d79ce707accfbbd79ac2b75e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f160e1ec8edf32586c483472e5e50a9c9b323b9fa59074e7ae13b0e28ba20e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30c7605395ec1169f38e86f661026a630321fc9f67ace1841cc7a2d9c2f191c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89451788b484f417bd45f32fb3ea081724728733dfef286d0dd77e9283f443f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701ec6f20e1209e77326c676836954c28a5535c6d0784a53007b71d823dd6564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a9d3ea501b992d8d4722b0d983eacbc95870a750a123ea89df2096a766b6ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470f358e2f5d34bcb11d6c8cbde99a53fe5b6b2f719fe99ea01257f1391b7598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb0a04e515a63d0b5f6d09400a7b89782130df82f68c28ac927aa1cec8d5287d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ad25c268674e96e233416af416161a20946b98571625e1b62b8f87fb96c4a7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a26af17a5304395b0618a582e871e0f4c71fb0a565bff67f5273a9777f51475)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97a939e8ba4cab1172ad53b9d7df4a8bc07e008b9de6dcc66ab097bf3d63a3c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1e1b792595a51088de61f70a05913c90c89437e3feae2bc24b4fdc8b3b66d0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cae1acf5897fd19692ea106f5c7cb8164835d681feab63594c5cf24bd50c2fd9)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a6b473379757779806b0b34deb63c97d0eedc045e30f7f57a448ed41a9940e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c972d770989b1f1dca1e15849387df4ca7b5a7dad98f31122cc47187cedefe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23814f6af6ee07e7b72aff46d34c13df9c9d11b05e23294d0fa7c8b6bd651a94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07d15442ba1880478b8283ce612136720b26fc223263f2ca458323b10cb2e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6445b626e59b92752321bc9db43df35802cc99e6127638c1eece4253d721d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c740f69ef10e40367e07c63bb7f895b69e93586e630c930a73df8844c5de611e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d595ac8364326611ad90c4c24d7e3b65b3d0c553dee67272715cd603669a47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f33e7ea48dbff68173b236d9f0c5ece56c518b7ce3c84e61722f79bebf702817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12cdac2395468fe7b578fda0bc180189337353a38ac3ff92715ba0f0197d1c20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bee2d3f6d21839fe1fe04a7293ce69608772f5485b67a545bf86412ce4bc31b)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853baf05a7627b72f712377567c528bd0e9dad21f8408608ed6e441de9f89288)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2bf0204aebedaa28cc795ca75202fd45f308e12dca2885ab8e37d7c74445195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e6e5acaaab4f26576d63120e74c76c6d4cc2934123abd84b58a3127c355ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0327157ca8caaa47a27211ab88a114c9e751e6d520b882c6aadb6b9ae2e1323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158e8dfe89f7bf2dbd692cf8f120d4f465c30877b1f3f4195446d9b435610964)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36230845cb4c75253262be3cb3cd024bc0e92867833d84613e479b7ab8213720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9672f7a8d34198d6a1d18cc713431b2219288350391cf2f25eeb5e3ae0cca09f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1896929cd68166dbf4b4d7f93922e3da4236c9bb9772ccb29db32b758b4a733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5846680d7e35e20a4107975149050e31db6e8e67428db116fb59969d34dfd3d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__243895e6a308a7b1c4db7b337df47a25060f50471b0f71f88a6b047b61517259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9a616e5be66394aedad0adb5922cfbc4a134b733421b5943a164c6db3d488b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a62c7a971069cd26a528137a5503aadecf40da16f9a7dc1aacb9a089d51d9e64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e7db0c5d397d72170f873e9ba260b201ca7492e38d6eb93a4c2f531889c3ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c997d5f108013b8567f3e7874f74c93338c1b38cd96381e27f4358db1bbc2703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d835773ccca0f1468cb10c3d63c9bcfedcb8b2e504b9740e62ac7e89aaa3cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9700cc021f6731713df408b0be909fc0520229442d1e6411d30e0142c5d70429)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e733bcaaaa7d71668f3f196727fdec490f7a6f2f0e988938717ff273d18f2a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df826e9131df0ea72202b5f7092d273b3661222aee4ee07e51c64f9e8f08a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d891938c0a020d160b8253ee8ef26fb3f02b3de567b8fd0417f0d41124dd0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540149df4107f8e200ea5961b68b9b92a41a7b67aeeb0d1bf76573deeb30f7e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f170dba585d9159b52e8af2aa698bd671012c916ddc45847b03c5c9b58cbfb)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e62a30d8e874dbf85cb9f72017c9f5e6e70d6ed987c00d295cb9afcf242ccb8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924439986851a3076e9f11fcd0c8b38ce52df39cca4f538c0063db67ea1553b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d82e975fcebb746fb983783eb416f1023364e183aa693d380ad11c39b85ebaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb436949b78d5c98d47467a8d3e2e33dfd7da96da7e4d52c3a3ddfbc0437dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6a988d646f0390fc7d1ba76e195224f4746457aa1da05b6043b55ae5a8143a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2632891f416f455f0610d0d0f9c55e9045cd38da21e5c2e23d47e66abc2a00da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8c64aa79c862c77e407a838cba413317f3c19e470e672d97951a6ae38989f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f49727e50e4fcf7e981328addbb34c412c205ab0e1dba170ec9b3823ade124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d3ac6d74c7428e03e640f5d7ea57538cd387537adce8b0e1db72fcb523445b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f775e115b364faae65053767abb7a345fbbb2236520ffaefe4ca47b176feeb4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1eb5a7cf21cd35194780a1fc594669055e4ce8ac4ca25aba4be5aec503f1a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a15693214152d366e3b230c2e7f93a714d3fd540c4f462a071a1fa1b28c654c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde2ef44900f835dd8bcb2abaf42e81ac857104164bbba451c2dbfd0ff522ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00ab84e3ffe26c04f1963e2890f220fb4792cdb2c3b3fdbea390d771d948e6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a3c71b496f53de9f271163beed86ab3a6732141965e85913ba31fc2301d7b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f9cc46af07ccaac41c39935c9bb965591fa9ffd93838997af6d7123d4e7fd42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c8e281b3b15dc000e77e1b61c28fd99745d9931cb86fa8f4ee947d3119f9d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3632838b3db67ae02a8bfb3f2b551f4893598f0ff658ef1abe6178dcabf03c80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9e1127540d31f2e6bfde2c0b89fdad7282f7718293f705084aab0e6bb74001)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbba81eac5c6fb7fe51c1f08a65248e843e42908f68d0d0e3f39d38e57c4208d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "first_location": "firstLocation",
        "locked": "locked",
        "second_location": "secondLocation",
        "source_type": "sourceType",
        "targets": "targets",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20bd0b317599f96da3c4528d931015f2e92b6f96d2d68e72e05adc1bed551637)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument first_location", value=first_location, expected_type=type_hints["first_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument second_location", value=second_location, expected_type=type_hints["second_location"])
            check_type(argname="argument source_type", value=source_type, expected_type=type_hints["source_type"])
            check_type(argname="argument targets", value=targets, expected_type=type_hints["targets"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if first_location is not None:
            self._values["first_location"] = first_location
        if locked is not None:
            self._values["locked"] = locked
        if second_location is not None:
            self._values["second_location"] = second_location
        if source_type is not None:
            self._values["source_type"] = source_type
        if targets is not None:
            self._values["targets"] = targets
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content PrePosition behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def first_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.'''
        result = self._values.get("first_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def second_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.'''
        result = self._values.get("second_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def source_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.'''
        result = self._values.get("source_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def targets(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.'''
        result = self._values.get("targets")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0284a1b0b9f4dd9f4136396a7358e55a2981842f849a9a74125e2e32d723b6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFirstLocation")
    def reset_first_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondLocation")
    def reset_second_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondLocation", []))

    @jsii.member(jsii_name="resetSourceType")
    def reset_source_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSourceType", []))

    @jsii.member(jsii_name="resetTargets")
    def reset_targets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargets", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="firstLocationInput")
    def first_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "firstLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondLocationInput")
    def second_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceTypeInput")
    def source_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="targetsInput")
    def targets_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8738dd1af6317d12e11c6cd07d1bf8fef9cfa64879cafac1980f5e897c8f84a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="firstLocation")
    def first_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "firstLocation"))

    @first_location.setter
    def first_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306751a993a5896fdb53f01030832cf7694c6e01dfe2ce87c2ac2f28350ce54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "firstLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c18b4966edf77232ef6345737df6b78f8a19eca1497a8b20be3d094c476309)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondLocation")
    def second_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondLocation"))

    @second_location.setter
    def second_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cc135fd0a7771346291d068e42fe244617dc0d6b85145bd7088c070a34df25e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondLocation", value)

    @builtins.property
    @jsii.member(jsii_name="sourceType")
    def source_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sourceType"))

    @source_type.setter
    def source_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc05abd4b9cd41323606f31a31f7e189ebfa475a254ef6ef70ca0e8e91dd282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sourceType", value)

    @builtins.property
    @jsii.member(jsii_name="targets")
    def targets(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targets"))

    @targets.setter
    def targets(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bbd00206b8f1cf597d73fb26e4ab7853203a7a783e9e1fcf0faf220bdd917a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targets", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9393da94f4398d1d9461216c156bbedc2d919532adf015091c5865a949e5907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__369cd23d23862efb00444eec5be86b2efac3db6ec94365b62036555e2f91b68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4016d49b1f53489d55fdd10bbfb443b72bb16e10246beee2071954835ffd4b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection",
    jsii_struct_bases=[],
    name_mapping={
        "countries": "countries",
        "dmas": "dmas",
        "enabled": "enabled",
        "enable_geo_protection": "enableGeoProtection",
        "enable_geo_redirect_on_deny": "enableGeoRedirectOnDeny",
        "enable_ip_protection": "enableIpProtection",
        "enable_ip_redirect_on_deny": "enableIpRedirectOnDeny",
        "enable_referrer_protection": "enableReferrerProtection",
        "enable_referrer_redirect_on_deny": "enableReferrerRedirectOnDeny",
        "geo_protection_mode": "geoProtectionMode",
        "geo_protection_title": "geoProtectionTitle",
        "geo_redirect_url": "geoRedirectUrl",
        "ip_addresses": "ipAddresses",
        "ip_protection_mode": "ipProtectionMode",
        "ip_protection_title": "ipProtectionTitle",
        "ip_redirect_url": "ipRedirectUrl",
        "locked": "locked",
        "override_ip_addresses": "overrideIpAddresses",
        "referrer_domains": "referrerDomains",
        "referrer_protection_mode": "referrerProtectionMode",
        "referrer_protection_title": "referrerProtectionTitle",
        "referrer_redirect_url": "referrerRedirectUrl",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection:
    def __init__(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__353f9ba7404e877c9590c1bf323c62ea1ccc08f25d1decd27debf75ae4e612e9)
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument dmas", value=dmas, expected_type=type_hints["dmas"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_geo_protection", value=enable_geo_protection, expected_type=type_hints["enable_geo_protection"])
            check_type(argname="argument enable_geo_redirect_on_deny", value=enable_geo_redirect_on_deny, expected_type=type_hints["enable_geo_redirect_on_deny"])
            check_type(argname="argument enable_ip_protection", value=enable_ip_protection, expected_type=type_hints["enable_ip_protection"])
            check_type(argname="argument enable_ip_redirect_on_deny", value=enable_ip_redirect_on_deny, expected_type=type_hints["enable_ip_redirect_on_deny"])
            check_type(argname="argument enable_referrer_protection", value=enable_referrer_protection, expected_type=type_hints["enable_referrer_protection"])
            check_type(argname="argument enable_referrer_redirect_on_deny", value=enable_referrer_redirect_on_deny, expected_type=type_hints["enable_referrer_redirect_on_deny"])
            check_type(argname="argument geo_protection_mode", value=geo_protection_mode, expected_type=type_hints["geo_protection_mode"])
            check_type(argname="argument geo_protection_title", value=geo_protection_title, expected_type=type_hints["geo_protection_title"])
            check_type(argname="argument geo_redirect_url", value=geo_redirect_url, expected_type=type_hints["geo_redirect_url"])
            check_type(argname="argument ip_addresses", value=ip_addresses, expected_type=type_hints["ip_addresses"])
            check_type(argname="argument ip_protection_mode", value=ip_protection_mode, expected_type=type_hints["ip_protection_mode"])
            check_type(argname="argument ip_protection_title", value=ip_protection_title, expected_type=type_hints["ip_protection_title"])
            check_type(argname="argument ip_redirect_url", value=ip_redirect_url, expected_type=type_hints["ip_redirect_url"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_ip_addresses", value=override_ip_addresses, expected_type=type_hints["override_ip_addresses"])
            check_type(argname="argument referrer_domains", value=referrer_domains, expected_type=type_hints["referrer_domains"])
            check_type(argname="argument referrer_protection_mode", value=referrer_protection_mode, expected_type=type_hints["referrer_protection_mode"])
            check_type(argname="argument referrer_protection_title", value=referrer_protection_title, expected_type=type_hints["referrer_protection_title"])
            check_type(argname="argument referrer_redirect_url", value=referrer_redirect_url, expected_type=type_hints["referrer_redirect_url"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if countries is not None:
            self._values["countries"] = countries
        if dmas is not None:
            self._values["dmas"] = dmas
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_geo_protection is not None:
            self._values["enable_geo_protection"] = enable_geo_protection
        if enable_geo_redirect_on_deny is not None:
            self._values["enable_geo_redirect_on_deny"] = enable_geo_redirect_on_deny
        if enable_ip_protection is not None:
            self._values["enable_ip_protection"] = enable_ip_protection
        if enable_ip_redirect_on_deny is not None:
            self._values["enable_ip_redirect_on_deny"] = enable_ip_redirect_on_deny
        if enable_referrer_protection is not None:
            self._values["enable_referrer_protection"] = enable_referrer_protection
        if enable_referrer_redirect_on_deny is not None:
            self._values["enable_referrer_redirect_on_deny"] = enable_referrer_redirect_on_deny
        if geo_protection_mode is not None:
            self._values["geo_protection_mode"] = geo_protection_mode
        if geo_protection_title is not None:
            self._values["geo_protection_title"] = geo_protection_title
        if geo_redirect_url is not None:
            self._values["geo_redirect_url"] = geo_redirect_url
        if ip_addresses is not None:
            self._values["ip_addresses"] = ip_addresses
        if ip_protection_mode is not None:
            self._values["ip_protection_mode"] = ip_protection_mode
        if ip_protection_title is not None:
            self._values["ip_protection_title"] = ip_protection_title
        if ip_redirect_url is not None:
            self._values["ip_redirect_url"] = ip_redirect_url
        if locked is not None:
            self._values["locked"] = locked
        if override_ip_addresses is not None:
            self._values["override_ip_addresses"] = override_ip_addresses
        if referrer_domains is not None:
            self._values["referrer_domains"] = referrer_domains
        if referrer_protection_mode is not None:
            self._values["referrer_protection_mode"] = referrer_protection_mode
        if referrer_protection_title is not None:
            self._values["referrer_protection_title"] = referrer_protection_title
        if referrer_redirect_url is not None:
            self._values["referrer_redirect_url"] = referrer_redirect_url
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def dmas(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of Designated Market Area codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        '''
        result = self._values.get("dmas")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content Targeting feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, verifies IP addresses are unique to specific geographic regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        '''
        result = self._values.get("enable_geo_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        '''
        result = self._values.get("enable_geo_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to control access to your content from specific sets of IP addresses and CIDR blocks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        '''
        result = self._values.get("enable_ip_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        '''
        result = self._values.get("enable_ip_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        '''
        result = self._values.get("enable_referrer_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        '''
        result = self._values.get("enable_referrer_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        '''
        result = self._values.get("geo_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        '''
        result = self._values.get("geo_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        '''
        result = self._values.get("geo_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks to allow or deny.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        '''
        result = self._values.get("ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def ip_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        '''
        result = self._values.get("ip_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        '''
        result = self._values.get("ip_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        '''
        result = self._values.get("ip_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        '''
        result = self._values.get("override_ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of domains from which to allow or deny traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        '''
        result = self._values.get("referrer_domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specify the action to take.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        '''
        result = self._values.get("referrer_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        '''
        result = self._values.get("referrer_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        '''
        result = self._values.get("referrer_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77feaffc8a9c4d9a60704e0d70d5c0ebeeb601b8bd9beaf3bf88c7ff75a8e7a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetDmas")
    def reset_dmas(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDmas", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableGeoProtection")
    def reset_enable_geo_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoProtection", []))

    @jsii.member(jsii_name="resetEnableGeoRedirectOnDeny")
    def reset_enable_geo_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableIpProtection")
    def reset_enable_ip_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpProtection", []))

    @jsii.member(jsii_name="resetEnableIpRedirectOnDeny")
    def reset_enable_ip_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableReferrerProtection")
    def reset_enable_referrer_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerProtection", []))

    @jsii.member(jsii_name="resetEnableReferrerRedirectOnDeny")
    def reset_enable_referrer_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerRedirectOnDeny", []))

    @jsii.member(jsii_name="resetGeoProtectionMode")
    def reset_geo_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionMode", []))

    @jsii.member(jsii_name="resetGeoProtectionTitle")
    def reset_geo_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionTitle", []))

    @jsii.member(jsii_name="resetGeoRedirectUrl")
    def reset_geo_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoRedirectUrl", []))

    @jsii.member(jsii_name="resetIpAddresses")
    def reset_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAddresses", []))

    @jsii.member(jsii_name="resetIpProtectionMode")
    def reset_ip_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionMode", []))

    @jsii.member(jsii_name="resetIpProtectionTitle")
    def reset_ip_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionTitle", []))

    @jsii.member(jsii_name="resetIpRedirectUrl")
    def reset_ip_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpRedirectUrl", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideIpAddresses")
    def reset_override_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideIpAddresses", []))

    @jsii.member(jsii_name="resetReferrerDomains")
    def reset_referrer_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerDomains", []))

    @jsii.member(jsii_name="resetReferrerProtectionMode")
    def reset_referrer_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionMode", []))

    @jsii.member(jsii_name="resetReferrerProtectionTitle")
    def reset_referrer_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionTitle", []))

    @jsii.member(jsii_name="resetReferrerRedirectUrl")
    def reset_referrer_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerRedirectUrl", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="dmasInput")
    def dmas_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "dmasInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtectionInput")
    def enable_geo_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDenyInput")
    def enable_geo_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpProtectionInput")
    def enable_ip_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDenyInput")
    def enable_ip_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtectionInput")
    def enable_referrer_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDenyInput")
    def enable_referrer_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionModeInput")
    def geo_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitleInput")
    def geo_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrlInput")
    def geo_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAddressesInput")
    def ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "ipAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionModeInput")
    def ip_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitleInput")
    def ip_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrlInput")
    def ip_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddressesInput")
    def override_ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "overrideIpAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerDomainsInput")
    def referrer_domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "referrerDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionModeInput")
    def referrer_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitleInput")
    def referrer_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrlInput")
    def referrer_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c728ba44b02016bca4b9a7ff62ec53736c9b6096e6888a82c02fdec0375e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="dmas")
    def dmas(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "dmas"))

    @dmas.setter
    def dmas(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98733924dd46af409b95ab2d39e400c093c3b9fef6be476d81580dd037984c4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dmas", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a264e5ba2b8a0710a852435adc1b5b8a5c5cec1b9ed7e5727b3c43edde0b4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtection")
    def enable_geo_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoProtection"))

    @enable_geo_protection.setter
    def enable_geo_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74693f243eb3b9bcf14789d9e987c8f1d5594bcd348f4c4c547657178e98321d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDeny")
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoRedirectOnDeny"))

    @enable_geo_redirect_on_deny.setter
    def enable_geo_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a50be17259ae753d449c5cc68f75b823de0180036919c48de545440af16d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpProtection")
    def enable_ip_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpProtection"))

    @enable_ip_protection.setter
    def enable_ip_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c4ae8bc4573aca09134876653c0e7dd509135fb891240c3395790b290856f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDeny")
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpRedirectOnDeny"))

    @enable_ip_redirect_on_deny.setter
    def enable_ip_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a25c1ff708d87791380fa242e3a43b2411de8ae2c2769cf31f0ada76ac24cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtection")
    def enable_referrer_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerProtection"))

    @enable_referrer_protection.setter
    def enable_referrer_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7796063ce0af782696322f957bf940d1be52040db3cba0dbf4de6e9cc33a2eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDeny")
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerRedirectOnDeny"))

    @enable_referrer_redirect_on_deny.setter
    def enable_referrer_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e2412260e6013c2362a4f9f7ec486ad30c1cac33d9243ce73a784c03b9005b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionMode")
    def geo_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionMode"))

    @geo_protection_mode.setter
    def geo_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961da10b51bfdf81fa7f7212689a7d957655da2763aa06b08d88572a57d831db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitle")
    def geo_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionTitle"))

    @geo_protection_title.setter
    def geo_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a4091ad290716bb8cdb6b08d857d8b2e89b66e6a7c6278077e3b97790d6adc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrl")
    def geo_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoRedirectUrl"))

    @geo_redirect_url.setter
    def geo_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ec8f4b5db52d52a027f6d32121a0494d74371d881c665e95d1d284dae7aa40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="ipAddresses")
    def ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "ipAddresses"))

    @ip_addresses.setter
    def ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8f1e4b54c404dd19d54d8943fa567c2ccd08d1f4bb8499ec95e782ffe8bc85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionMode")
    def ip_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionMode"))

    @ip_protection_mode.setter
    def ip_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84cfa06adab0856e80bab2f9ba489787b31c22fcbabce733aa4b82e7c72098ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitle")
    def ip_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionTitle"))

    @ip_protection_title.setter
    def ip_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__411fb1e5775306075fc1746b93f93f522366f83086ba4de13de41bcebd8c8123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrl")
    def ip_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipRedirectUrl"))

    @ip_redirect_url.setter
    def ip_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4a0e116fa322d53299009c506a17bda16c9abf5ce7b359c902d109b4316848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1086ae5d241d6f0921c16445babcad4d826d7ab601aeaae332df1a986065be7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddresses")
    def override_ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "overrideIpAddresses"))

    @override_ip_addresses.setter
    def override_ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65f989b0c3e282649d9e51d063d6ea12ad40611fcc07831b5a94700619ee0f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideIpAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="referrerDomains")
    def referrer_domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "referrerDomains"))

    @referrer_domains.setter
    def referrer_domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdb1a3af60e80c143affc26e820557ea98d3b113041f4b623c4f6605efcf512c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerDomains", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionMode")
    def referrer_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionMode"))

    @referrer_protection_mode.setter
    def referrer_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__962c4aaf5e7f6c750b608ce7c8a3e3b2d30e1108f80e00f2c944c32d98da7615)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitle")
    def referrer_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionTitle"))

    @referrer_protection_title.setter
    def referrer_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3764c62a0c62a82951a7566c0af340fd4dcde22bee525f4a491dc752ee993e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrl")
    def referrer_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerRedirectUrl"))

    @referrer_redirect_url.setter
    def referrer_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e01b759a72d93ee32be9ec9858416579c0f8fdbefed94b419ca768bff4383b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c51395edc2c9e0d8c6bd5f785d6a78ef719406b85626f73e49f09408055222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9597aa9e18955a3d688414f7a03be8724368a33b009a5d17848e7f2ac124b94b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af23a0ddc054c509539829a289e70caf41325edbfaa11797f3eb0bd28cce857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b919127d232031f7e9baf8e52e62c09155bb98cf74b181bdca1c432e2c93a2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport",
    jsii_struct_bases=[],
    name_mapping={
        "allow_credentials": "allowCredentials",
        "allow_headers": "allowHeaders",
        "allow_origins": "allowOrigins",
        "enabled": "enabled",
        "expose_headers": "exposeHeaders",
        "headers": "headers",
        "locked": "locked",
        "methods": "methods",
        "origins": "origins",
        "preflight_max_age": "preflightMaxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport:
    def __init__(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec8d333c15664a9467b87acff04a3a8beb9503c306287252f644f2c6eefbe83)
            check_type(argname="argument allow_credentials", value=allow_credentials, expected_type=type_hints["allow_credentials"])
            check_type(argname="argument allow_headers", value=allow_headers, expected_type=type_hints["allow_headers"])
            check_type(argname="argument allow_origins", value=allow_origins, expected_type=type_hints["allow_origins"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expose_headers", value=expose_headers, expected_type=type_hints["expose_headers"])
            check_type(argname="argument headers", value=headers, expected_type=type_hints["headers"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument methods", value=methods, expected_type=type_hints["methods"])
            check_type(argname="argument origins", value=origins, expected_type=type_hints["origins"])
            check_type(argname="argument preflight_max_age", value=preflight_max_age, expected_type=type_hints["preflight_max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_credentials is not None:
            self._values["allow_credentials"] = allow_credentials
        if allow_headers is not None:
            self._values["allow_headers"] = allow_headers
        if allow_origins is not None:
            self._values["allow_origins"] = allow_origins
        if enabled is not None:
            self._values["enabled"] = enabled
        if expose_headers is not None:
            self._values["expose_headers"] = expose_headers
        if headers is not None:
            self._values["headers"] = headers
        if locked is not None:
            self._values["locked"] = locked
        if methods is not None:
            self._values["methods"] = methods
        if origins is not None:
            self._values["origins"] = origins
        if preflight_max_age is not None:
            self._values["preflight_max_age"] = preflight_max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_credentials(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Accepts requests made using credentials, like cookies or TLS client certificates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        '''
        result = self._values.get("allow_credentials")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_headers(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, defines which headers to allow when making the actual request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        '''
        result = self._values.get("allow_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_origins(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, sets which origin hostnames to accept requests from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        '''
        result = self._values.get("allow_origins")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables CORS feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expose_headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''In responses to preflight requests, lists names of headers that clients can access.

        By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        '''
        result = self._values.get("expose_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the supported request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        '''
        result = self._values.get("headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def methods(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        '''
        result = self._values.get("methods")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origins(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin hostnames to accept requests from.

        The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        '''
        result = self._values.get("origins")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def preflight_max_age(self) -> typing.Optional[builtins.str]:
        '''Defines the number of seconds that the browser should cache the response to a preflight request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        '''
        result = self._values.get("preflight_max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__725bd1a3a8175fae42a616d9ac6023e2fbfc98fddb4283a0c6e9d59a2405b86c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowCredentials")
    def reset_allow_credentials(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCredentials", []))

    @jsii.member(jsii_name="resetAllowHeaders")
    def reset_allow_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHeaders", []))

    @jsii.member(jsii_name="resetAllowOrigins")
    def reset_allow_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOrigins", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExposeHeaders")
    def reset_expose_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExposeHeaders", []))

    @jsii.member(jsii_name="resetHeaders")
    def reset_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaders", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethods")
    def reset_methods(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethods", []))

    @jsii.member(jsii_name="resetOrigins")
    def reset_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigins", []))

    @jsii.member(jsii_name="resetPreflightMaxAge")
    def reset_preflight_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreflightMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowCredentialsInput")
    def allow_credentials_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCredentialsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHeadersInput")
    def allow_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOriginsInput")
    def allow_origins_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="exposeHeadersInput")
    def expose_headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "exposeHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="headersInput")
    def headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headersInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodsInput")
    def methods_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "methodsInput"))

    @builtins.property
    @jsii.member(jsii_name="originsInput")
    def origins_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originsInput"))

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAgeInput")
    def preflight_max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preflightMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCredentials")
    def allow_credentials(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCredentials"))

    @allow_credentials.setter
    def allow_credentials(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d8ea2fcc2ce5823346cdbb083f6f6cc880570b6aa9eed50f61870abfc2a298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCredentials", value)

    @builtins.property
    @jsii.member(jsii_name="allowHeaders")
    def allow_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowHeaders"))

    @allow_headers.setter
    def allow_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f8889a0ca98dec06f8e236ff6dabb7801c41ea0871384c381a400a51f5633e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="allowOrigins")
    def allow_origins(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowOrigins"))

    @allow_origins.setter
    def allow_origins(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3373a9375d3644b3ceda04132818d4c24e400ef325c5e17874337bc3a64b1d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOrigins", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f3e7d1e6188d6fd0e79d250759c83cb803fd99e8783fc6f6f1bb258b36362d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="exposeHeaders")
    def expose_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "exposeHeaders"))

    @expose_headers.setter
    def expose_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1930cfa082dc3f8c91980d1f84a889b9c898f908bba4cdbf52b5790d3bb369e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exposeHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="headers")
    def headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headers"))

    @headers.setter
    def headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83641b2c3b429e273fe28376eb42c93274d8553b94f8594ba9da0337e24d828e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headers", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e8b057c1b2c166ff4818167d4e663a35c43f2687deb43338f7498dd7ac4e697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="methods")
    def methods(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "methods"))

    @methods.setter
    def methods(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__085868938046635772f8d38cbf0f013e6db23f717652e590187098669041016c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "methods", value)

    @builtins.property
    @jsii.member(jsii_name="origins")
    def origins(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "origins"))

    @origins.setter
    def origins(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4781de9c0b233dc457b2af87a9d39eb672f20bd59a719f3fb709073e688708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origins", value)

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAge")
    def preflight_max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preflightMaxAge"))

    @preflight_max_age.setter
    def preflight_max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905719fc05cc65a1bb52ce00f162f0f5eb65cc8ceedf0345fa7ab91ab29077e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preflightMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c2ead48cee5315acf073ea5df6a4280112c2979eb9b14e7ae0bcedcec6c1cd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__396d6cbb23a180f890b1c53d2b37cbeacdb329cad839695cf6fceed874dc6554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab9e5cb6800518509de5ff470721aea4c9ad7ce907f1345b0a4af397b39ccf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38fdbd698953029b7410305c4c65502e4c6742872f41284a7649837cc2d1a00e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f3cb2243177fc7fb98b645721444b1b4a24d97832f3d43c558b67b7b181d74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afdcd158abf88e642d08c09e73f030c954531f934ff93f045e094fc4af7d9328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__522b3e5c6b3053929ce7632e696204b750f20ffceedf694b296a7cc3d29e0624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14ca64c45a2e12bfd096a8887597d6cdd881874bc6bffbd9643bcf1e310244ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24fe712c565bf23a93533ea7fccb99c04e6ff7261f53710a4bc21aa36d391d59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc25e4cd1f66782679bae16a99aa3052ee07c9b1211f0e4cbd595a343614600)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a0b788b057bcdc620a3684d3954ed5b2cbea7ee761055e048d9916d8cbeee4)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b87efa2dd53f8cb33da057b11e6c64909e7f9c80ef36be752042aac706bc70b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26cd74040f7734fb7b791920fc9bdf2e698cc2b44a701b42939c0599caf6e877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2600054c4f41ae8721a8511971b7565230c0de39d175be5a26c7d2d40f259be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9f80f505e166ad5b13a5b3ca17ba8a30f2d099df86ac57c4abb8a007171748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6103ef62a382662bdc336a75e2e458e269eb01699e64a2367c3becf68a03a304)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa1ccb7e789945a45f6583013d294a3f4364418c54b8ff76c9601dde047a9be8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c546f2fae0f24d3ccf8ceb6e97b182f247f53083e01e44e13329cb26e332eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1d9a22728b3ab59337737d551eb17bb65eeeb8c7d786b4079a66e61c16f4b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb68b517c07150bbb4d4d4b48da9168883c6e00bf318b670ecec6d0115c237b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__480f16841e66f0836c617194be9b50eb39df8acd26f9f1d99b44776b01817d47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ee84a0dfc59ddfea35841c53bc3069f88caa22d419f1f4deb6e6ccd8d58caf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c462b8b78aea2788680dd29587f1c4f03de4e6e51ca011b062ba5ae7c945fd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior",
    jsii_struct_bases=[],
    name_mapping={
        "behavior_id": "behaviorId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior:
    def __init__(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054724f53e90d7b80dbec40dd8afb0e447f5b7eba345b3dd08089d68842804b5)
            check_type(argname="argument behavior_id", value=behavior_id, expected_type=type_hints["behavior_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior_id is not None:
            self._values["behavior_id"] = behavior_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior_id(self) -> typing.Optional[builtins.str]:
        '''The unique identifier for the predefined custom behavior you want to insert into the current rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        '''
        result = self._values.get("behavior_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0050aecfd0e2777086ba81d22b0d25d19b3a917aa6f96c597e7fdba55e76b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehaviorId")
    def reset_behavior_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehaviorId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorIdInput")
    def behavior_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorId")
    def behavior_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behaviorId"))

    @behavior_id.setter
    def behavior_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c9feb41204e6aab140af4af9fba9b7ac78a41a8f45c2545a5d88dee50d0817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behaviorId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690b1c4fa765ce1417fe011bec1856a58898367ba604cc8c1a495f614b8c73c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc3351d9ba4e4f622a6649a700b66015b4253266b9e66311e6c9cd232a32799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f23f96e3e0e363148f484fa12582a67e7b75ae6da56fd53c8354deed0ff409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dee52808890b961dd7875049aa914b8599800793ad1ec8df478ea032c1cb98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_stream_title": "beaconStreamTitle",
        "collect_midgress_traffic": "collectMidgressTraffic",
        "datastream_ids": "datastreamIds",
        "enabled": "enabled",
        "locked": "locked",
        "log_enabled": "logEnabled",
        "log_stream_name": "logStreamName",
        "log_stream_title": "logStreamTitle",
        "sampling_percentage": "samplingPercentage",
        "stream_type": "streamType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream:
    def __init__(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19c3c211a13fa2e8eef996622c848509a489a70ca82908c32e8b648c33c2c7d)
            check_type(argname="argument beacon_stream_title", value=beacon_stream_title, expected_type=type_hints["beacon_stream_title"])
            check_type(argname="argument collect_midgress_traffic", value=collect_midgress_traffic, expected_type=type_hints["collect_midgress_traffic"])
            check_type(argname="argument datastream_ids", value=datastream_ids, expected_type=type_hints["datastream_ids"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_enabled", value=log_enabled, expected_type=type_hints["log_enabled"])
            check_type(argname="argument log_stream_name", value=log_stream_name, expected_type=type_hints["log_stream_name"])
            check_type(argname="argument log_stream_title", value=log_stream_title, expected_type=type_hints["log_stream_title"])
            check_type(argname="argument sampling_percentage", value=sampling_percentage, expected_type=type_hints["sampling_percentage"])
            check_type(argname="argument stream_type", value=stream_type, expected_type=type_hints["stream_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_stream_title is not None:
            self._values["beacon_stream_title"] = beacon_stream_title
        if collect_midgress_traffic is not None:
            self._values["collect_midgress_traffic"] = collect_midgress_traffic
        if datastream_ids is not None:
            self._values["datastream_ids"] = datastream_ids
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if log_enabled is not None:
            self._values["log_enabled"] = log_enabled
        if log_stream_name is not None:
            self._values["log_stream_name"] = log_stream_name
        if log_stream_title is not None:
            self._values["log_stream_title"] = log_stream_title
        if sampling_percentage is not None:
            self._values["sampling_percentage"] = sampling_percentage
        if stream_type is not None:
            self._values["stream_type"] = stream_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        '''
        result = self._values.get("beacon_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def collect_midgress_traffic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        '''
        result = self._values.get("collect_midgress_traffic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def datastream_ids(self) -> typing.Optional[builtins.str]:
        '''A set of dash-separated DataStream ID values to limit the scope of reported data.

        By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        '''
        result = self._values.get("datastream_ids")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables DataStream reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables log collection for the property by associating it with DataStream configurations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        '''
        result = self._values.get("log_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_stream_name(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the unique IDs of streams configured for the property.

        For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        '''
        result = self._values.get("log_stream_name")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def log_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        '''
        result = self._values.get("log_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of log data you want to collect for this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        '''
        result = self._values.get("sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def stream_type(self) -> typing.Optional[builtins.str]:
        '''Specify the DataStream type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        '''
        result = self._values.get("stream_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d0488be62c1af8a51f318ea29c869f0c4caacc1aa2a97958722951188a676f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconStreamTitle")
    def reset_beacon_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconStreamTitle", []))

    @jsii.member(jsii_name="resetCollectMidgressTraffic")
    def reset_collect_midgress_traffic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCollectMidgressTraffic", []))

    @jsii.member(jsii_name="resetDatastreamIds")
    def reset_datastream_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastreamIds", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogEnabled")
    def reset_log_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEnabled", []))

    @jsii.member(jsii_name="resetLogStreamName")
    def reset_log_stream_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamName", []))

    @jsii.member(jsii_name="resetLogStreamTitle")
    def reset_log_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamTitle", []))

    @jsii.member(jsii_name="resetSamplingPercentage")
    def reset_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingPercentage", []))

    @jsii.member(jsii_name="resetStreamType")
    def reset_stream_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStreamType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitleInput")
    def beacon_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTrafficInput")
    def collect_midgress_traffic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "collectMidgressTrafficInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamIdsInput")
    def datastream_ids_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datastreamIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logEnabledInput")
    def log_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamNameInput")
    def log_stream_name_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "logStreamNameInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamTitleInput")
    def log_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingPercentageInput")
    def sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "samplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="streamTypeInput")
    def stream_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "streamTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitle")
    def beacon_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconStreamTitle"))

    @beacon_stream_title.setter
    def beacon_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ccad41480e8bde9f2f62b383c29e7243d5de0780fa5723c8f895a0af3033e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTraffic")
    def collect_midgress_traffic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "collectMidgressTraffic"))

    @collect_midgress_traffic.setter
    def collect_midgress_traffic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6252d1cb471167be96aace54d166feccc83aec5827cf53dc763fd6a487501d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "collectMidgressTraffic", value)

    @builtins.property
    @jsii.member(jsii_name="datastreamIds")
    def datastream_ids(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "datastreamIds"))

    @datastream_ids.setter
    def datastream_ids(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4800380e3f7914fda37e71568a29c24ba4721985c3b8f85d739f78de7e9f610d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "datastreamIds", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17041b73aa9ad9b372618d15954514edde0f34cfa05b01e7f6eb2471e6e8239a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6a10283ba74b1d2da26a82513767a5cf066f4c9cd2480cc53dd8db83ba78b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logEnabled")
    def log_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEnabled"))

    @log_enabled.setter
    def log_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c6eb26ff8e8a1bc44fb9290e9daadd905484031a78435f4d6b7e71a86c2c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamName")
    def log_stream_name(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "logStreamName"))

    @log_stream_name.setter
    def log_stream_name(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f319db234d386e16347838ac3e5b9bc5eeb32d6e35123066d52efc2000a380db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamName", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamTitle")
    def log_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logStreamTitle"))

    @log_stream_title.setter
    def log_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a93678df72658bad0d78a0d285d0add43fc5a35896825a08c4fd9fb8b88ddb5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="samplingPercentage")
    def sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "samplingPercentage"))

    @sampling_percentage.setter
    def sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987040a2e738cc8d62596e63e7b45ad22a5a767753a2f22c794f21cc57c9c826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="streamType")
    def stream_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "streamType"))

    @stream_type.setter
    def stream_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3188460a0b58c4579239d014991b6d97be4d45e02649f038df00a38cb87905a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "streamType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__230cfe96c33df018c7840ad0feb409899616e11ca42987d1208ce073ee9d9505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6dfb4db09b3288e901969113da98d4bec56ba170c4608a3aee2b20e5804c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277af4439df1ed91955af010848491c48b102b8c569a5236f25c0f851ae960f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous": "anonymous",
        "enabled": "enabled",
        "gwenabled": "gwenabled",
        "locked": "locked",
        "namespace_id": "namespaceId",
        "template_uuid": "templateUuid",
        "tlsenabled": "tlsenabled",
        "uuid": "uuid",
        "wsenabled": "wsenabled",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp:
    def __init__(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6022b1f0e3f781acb251970f33314260c137ade67167c33b0c3d2f08e62a61c2)
            check_type(argname="argument anonymous", value=anonymous, expected_type=type_hints["anonymous"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument gwenabled", value=gwenabled, expected_type=type_hints["gwenabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_id", value=namespace_id, expected_type=type_hints["namespace_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tlsenabled", value=tlsenabled, expected_type=type_hints["tlsenabled"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument wsenabled", value=wsenabled, expected_type=type_hints["wsenabled"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous is not None:
            self._values["anonymous"] = anonymous
        if enabled is not None:
            self._values["enabled"] = enabled
        if gwenabled is not None:
            self._values["gwenabled"] = gwenabled
        if locked is not None:
            self._values["locked"] = locked
        if namespace_id is not None:
            self._values["namespace_id"] = namespace_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tlsenabled is not None:
            self._values["tlsenabled"] = tlsenabled
        if uuid is not None:
            self._values["uuid"] = uuid
        if wsenabled is not None:
            self._values["wsenabled"] = wsenabled

    @builtins.property
    def anonymous(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        '''
        result = self._values.get("anonymous")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables IoT Edge Connect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def gwenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured HTTP connection on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        '''
        result = self._values.get("gwenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the globally reserved name for a specific configuration.

        It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration.  You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        '''
        result = self._values.get("namespace_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tlsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured MQTT connection on port 8883.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        '''
        result = self._values.get("tlsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def wsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        result = self._values.get("wsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "hash_conversion_algorithm": "hashConversionAlgorithm",
        "hash_conversion_key": "hashConversionKey",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation:
    def __init__(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a776e5863519a99ef15a030a02c40260ee0828b75961c11647f2dc44879f59ab)
            check_type(argname="argument hash_conversion_algorithm", value=hash_conversion_algorithm, expected_type=type_hints["hash_conversion_algorithm"])
            check_type(argname="argument hash_conversion_key", value=hash_conversion_key, expected_type=type_hints["hash_conversion_key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hash_conversion_algorithm is not None:
            self._values["hash_conversion_algorithm"] = hash_conversion_algorithm
        if hash_conversion_key is not None:
            self._values["hash_conversion_key"] = hash_conversion_key
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def hash_conversion_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        '''
        result = self._values.get("hash_conversion_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_conversion_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the key to generate the hash, ideally a long random string to ensure adequate security.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        '''
        result = self._values.get("hash_conversion_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3b3f815f23bf1a55d393da34c2512a66b388850c684c833915968f5b13ff1ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHashConversionAlgorithm")
    def reset_hash_conversion_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionAlgorithm", []))

    @jsii.member(jsii_name="resetHashConversionKey")
    def reset_hash_conversion_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithmInput")
    def hash_conversion_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionKeyInput")
    def hash_conversion_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithm")
    def hash_conversion_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionAlgorithm"))

    @hash_conversion_algorithm.setter
    def hash_conversion_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c7c4f5a38469797412c1f2f84d7271daff157d8404ca29bc62a67929a1472a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hashConversionKey")
    def hash_conversion_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionKey"))

    @hash_conversion_key.setter
    def hash_conversion_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aefdc867b06ef851b63e184f1f01603cd3964c9bacae7cc4cb679f68eb876ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionKey", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d67865c1ebbb9f95ab545ec9a247882e06f036253a26ed805386df0142b1283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3696ec0e4838bdc569c381d568487504d833d29ef55f339a5e79f6f3ba15360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2914e99b286164a8e26b65da6be8514eeb7b2a3a7da931532d544aa7450c88fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__343ac6ff832b11de2430f9581d5fb88de43aa2a1b43496d76534467c23e4b270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51001fd96a8e896698e50429bfd7b0f71df2a22f73f30a05e6ba50338a091bbb)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with a single grouping to capture the text.

        For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36c75722521142e793d5962876e8ac2b8fe0181e855bfd4c6d3b6ea8fa4ba880)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f69ac82ae854792e2ed83fc0579717cfea8d8128ab02f8e960efc3c638c3044)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__641acacc41d7457df035d91aadd0a8639ff075efc120380daf8543d8c8d70d3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7480a7d2665ecaa2a1892ce19c0bd66c91eb23a839ad8cd8ad63d619a07469b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde4ff4e2c772c9d57cb5b0321732a97e959f78998932577271c291fbdba3218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd346cd87066a11c8620c570cc106cf81de7bf8d65391255fa0307e6973eeb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "substring_end": "substringEnd",
        "substring_start": "substringStart",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de43370e232f7954987d62926ffb817293193348b7aab62b268bb830e852ab23)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument substring_end", value=substring_end, expected_type=type_hints["substring_end"])
            check_type(argname="argument substring_start", value=substring_start, expected_type=type_hints["substring_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if substring_end is not None:
            self._values["substring_end"] = substring_end
        if substring_start is not None:
            self._values["substring_start"] = substring_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def substring_end(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        '''
        result = self._values.get("substring_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def substring_start(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the first character to extract.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        '''
        result = self._values.get("substring_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81d9ed31d0bbfd78d504ab2789c4e7dd3fca1b2f674135412f9be230c831227)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSubstringEnd")
    def reset_substring_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringEnd", []))

    @jsii.member(jsii_name="resetSubstringStart")
    def reset_substring_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="substringEndInput")
    def substring_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringEndInput"))

    @builtins.property
    @jsii.member(jsii_name="substringStartInput")
    def substring_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0493f028602328507f680e357a0d29ef10b8a6b83723b0858bec598b11ed6017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="substringEnd")
    def substring_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringEnd"))

    @substring_end.setter
    def substring_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__459daf6c4f658ad8f08c92a24cba8ebf07bdd640b6f8b9d94d08dcf58b51eb9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringEnd", value)

    @builtins.property
    @jsii.member(jsii_name="substringStart")
    def substring_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringStart"))

    @substring_start.setter
    def substring_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b72786e67384b3e6471d8bd40e30901688eb6c90637b6a02e1ad66cbcc4a430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ecd2a385ffd0fa93f77df7846010bea061a5dc76a9d1f53c6187a48155504f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892b06e17a61c7fbff7a63aab091d38190e90559863566dd90205252eca2ba37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ed3c295b2533963d7168bcb95bc72205b59112bc4784c2310cfb58122cab729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_field": "certificateField",
        "dcp_mutual_auth_processing_variable_id": "dcpMutualAuthProcessingVariableId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor:
    def __init__(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b8fca992290c8eee46879befd4c121e616a2a4a0d0e9c598e674958a0da35b)
            check_type(argname="argument certificate_field", value=certificate_field, expected_type=type_hints["certificate_field"])
            check_type(argname="argument dcp_mutual_auth_processing_variable_id", value=dcp_mutual_auth_processing_variable_id, expected_type=type_hints["dcp_mutual_auth_processing_variable_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_field is not None:
            self._values["certificate_field"] = certificate_field
        if dcp_mutual_auth_processing_variable_id is not None:
            self._values["dcp_mutual_auth_processing_variable_id"] = dcp_mutual_auth_processing_variable_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_field(self) -> typing.Optional[builtins.str]:
        '''Specifies the field in the client certificate to extract the variable from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        '''
        result = self._values.get("certificate_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dcp_mutual_auth_processing_variable_id(self) -> typing.Optional[builtins.str]:
        '''Where to store the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        '''
        result = self._values.get("dcp_mutual_auth_processing_variable_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dbc6469cd560d2e56172463628e053c801f74e0702bb54c543d5201d655e523)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateField")
    def reset_certificate_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateField", []))

    @jsii.member(jsii_name="resetDcpMutualAuthProcessingVariableId")
    def reset_dcp_mutual_auth_processing_variable_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpMutualAuthProcessingVariableId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldInput")
    def certificate_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableIdInput")
    def dcp_mutual_auth_processing_variable_id_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dcpMutualAuthProcessingVariableIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateField")
    def certificate_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateField"))

    @certificate_field.setter
    def certificate_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe1da66cb257a949aa61087fb6182e3b5c5873da2852de2d888bb8b3ce5571b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateField", value)

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableId")
    def dcp_mutual_auth_processing_variable_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dcpMutualAuthProcessingVariableId"))

    @dcp_mutual_auth_processing_variable_id.setter
    def dcp_mutual_auth_processing_variable_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__825d234a422582248f370b738a55455249ba711ae1fbe018ba38326977240b4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dcpMutualAuthProcessingVariableId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb02548858b772f0fa584c1cf5657d6f7abe44fb2620f5917bc9545ee09b7553)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0ac72a01c60096e98dcf00cfea210460ddfbda65f6d783d4d60e9af0ce6166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59614874bc166e2a194a261b4579df69edccbc71c0598034147957e3e15555e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f321babce504fe5b3255dc81c1466df3e28521d0a7d2a7e42139f994cbc1230f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups",
    jsii_struct_bases=[],
    name_mapping={
        "group_names": "groupNames",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups:
    def __init__(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f0c4f748d1de7b49a6242f5056e20466384fa8738c918013a63aeb68f62bf6)
            check_type(argname="argument group_names", value=group_names, expected_type=type_hints["group_names"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if group_names is not None:
            self._values["group_names"] = group_names
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def group_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of authorization groups to assign to all connecting devices.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        '''
        result = self._values.get("group_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6273501e9fcaab66df59ee8f1b3c9722440fed8bab59016ef39caf6c2f41705e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetGroupNames")
    def reset_group_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGroupNames", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="groupNamesInput")
    def group_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "groupNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="groupNames")
    def group_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "groupNames"))

    @group_names.setter
    def group_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38d5d6d98defe34ab5513a82054c309dec6ee567d32f86ac5288b7232a8a2a91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "groupNames", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f33813f0be932e7d9fd0d2857f587b87554362c8a8df221da7e612ea1cb58ce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e38a13dbc8d882fdc6dc40a1aa4bff6e47dcf6aa284ede861f0806d1029d17d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246e3779be44fe98666861372edc9c7109848d48dd7dcd805b8c7cd08453df7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af536e21886c06ea67e58f939e3e1fa7e01c7c3c6e2d18a233bc3146839fba80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations",
    jsii_struct_bases=[],
    name_mapping={
        "custom_values": "customValues",
        "enabled": "enabled",
        "hostname": "hostname",
        "locked": "locked",
        "path": "path",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations:
    def __init__(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6580fe0ec3ec6bd2735cb857938fae244bd1c9e516960dba29fb09b9ebee160)
            check_type(argname="argument custom_values", value=custom_values, expected_type=type_hints["custom_values"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_values is not None:
            self._values["custom_values"] = custom_values
        if enabled is not None:
            self._values["enabled"] = enabled
        if hostname is not None:
            self._values["hostname"] = hostname
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_values(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify custom JWT server connection values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        '''
        result = self._values.get("custom_values")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the default JWT server and sets the authentication endpoint to a default path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the JWT server's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff72be4713313f75cd18641996955dfe82780e83f202e3d6bfaf71f95fb74a2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomValues")
    def reset_custom_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValues", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customValuesInput")
    def custom_values_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customValues")
    def custom_values(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customValues"))

    @custom_values.setter
    def custom_values(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547a0c06a657e2009148f84a33b194b70a63caf9e7dbc9e0a5f4b84036c776dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValues", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32496e849197052b5d636ece969b8e2a162f2bf37866074ee7761e85bffee886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d9c5076496191bae92ce216ebeba362890f5d8f6f8947d3db788c95f31130f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5452c9341c928233289488253070d4f83d8b8572e848dc20b3c2e161b742e703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3751b4890624c327746770e2953afb1b00065346ec525f733fcd198a6d12166e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b10e83272d1a1551c94c37bea5d07fd331e713e51a1b9aa7d866618be96a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47626ac4aafac37a7b1d6e320ab48b2d687640f1fff6b84ede086c20367134da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3524b117047bc0244f0f43e89c365438751e97f1ea03e7636c9d64c5890c711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89b694bac501038827fc2319e032dc39731d99909a61c54c39c160786ffb140)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymous")
    def reset_anonymous(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymous", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGwenabled")
    def reset_gwenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGwenabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceId")
    def reset_namespace_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTlsenabled")
    def reset_tlsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsenabled", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWsenabled")
    def reset_wsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWsenabled", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousInput")
    def anonymous_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "anonymousInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="gwenabledInput")
    def gwenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "gwenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceIdInput")
    def namespace_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsenabledInput")
    def tlsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tlsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="wsenabledInput")
    def wsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "wsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymous")
    def anonymous(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "anonymous"))

    @anonymous.setter
    def anonymous(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4646f124927a21baabcb3d09331b4111aaf9113979a1130312568d5e88722ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymous", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eef02a2b860fd75d19aadedf1d070b4fc02a43359eecdeebbec93732a16c456)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="gwenabled")
    def gwenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "gwenabled"))

    @gwenabled.setter
    def gwenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b2a58cecee27eaa16314ddab6b7b09aade401e65fa99cef58b672afc610805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gwenabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae04a9b0ca962c32e71cb931db0579bc83c420aac949679cfa60e53de1524a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceId")
    def namespace_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceId"))

    @namespace_id.setter
    def namespace_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dff55995b3cf3ec4d35f4938092429733260982eaf101acfa59dc9b980a1f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e233f117c849c00244e3c540c04dfd2146b9beabe1402121f35130464e16c9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tlsenabled")
    def tlsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tlsenabled"))

    @tlsenabled.setter
    def tlsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f122f8f8fc3e572764c886d2313c19df179d8155b1990be1ab90eee6c9399e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4087ca725b2a012a5ef9497330b87378974697e02ce88592dd2151c710497b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="wsenabled")
    def wsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "wsenabled"))

    @wsenabled.setter
    def wsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6bb262977c6918031db7d994fb5ddc36f0729c0cf3bd6a96670d4fc799fbc65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2924928cfcf8f661954aa11344e8fd1b3f5e74b423be9202ef3852264072e80c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth",
    jsii_struct_bases=[],
    name_mapping={
        "extract_hostname": "extractHostname",
        "extract_jurisdiction": "extractJurisdiction",
        "extract_namespace": "extractNamespace",
        "hostname_claim": "hostnameClaim",
        "jurisdiction_claim": "jurisdictionClaim",
        "locked": "locked",
        "namespace_claim": "namespaceClaim",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth:
    def __init__(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd0f635a679a19c64627c8fd4a8f13e16f313177f26bb16157f0f3b4e387cae)
            check_type(argname="argument extract_hostname", value=extract_hostname, expected_type=type_hints["extract_hostname"])
            check_type(argname="argument extract_jurisdiction", value=extract_jurisdiction, expected_type=type_hints["extract_jurisdiction"])
            check_type(argname="argument extract_namespace", value=extract_namespace, expected_type=type_hints["extract_namespace"])
            check_type(argname="argument hostname_claim", value=hostname_claim, expected_type=type_hints["hostname_claim"])
            check_type(argname="argument jurisdiction_claim", value=jurisdiction_claim, expected_type=type_hints["jurisdiction_claim"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_claim", value=namespace_claim, expected_type=type_hints["namespace_claim"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if extract_hostname is not None:
            self._values["extract_hostname"] = extract_hostname
        if extract_jurisdiction is not None:
            self._values["extract_jurisdiction"] = extract_jurisdiction
        if extract_namespace is not None:
            self._values["extract_namespace"] = extract_namespace
        if hostname_claim is not None:
            self._values["hostname_claim"] = hostname_claim
        if jurisdiction_claim is not None:
            self._values["jurisdiction_claim"] = jurisdiction_claim
        if locked is not None:
            self._values["locked"] = locked
        if namespace_claim is not None:
            self._values["namespace_claim"] = namespace_claim
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def extract_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a hostname from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        '''
        result = self._values.get("extract_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_jurisdiction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a jurisdiction that defines a geographically distributed set of servers from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        '''
        result = self._values.get("extract_jurisdiction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_namespace(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a namespace from JSON web tokens (JWT).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        '''
        result = self._values.get("extract_namespace")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the hostname from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        '''
        result = self._values.get("hostname_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jurisdiction_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the jurisdiction from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        '''
        result = self._values.get("jurisdiction_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the namespace from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        '''
        result = self._values.get("namespace_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa22038e667742f72ddb209c1f7dca3f77d5ac49fd2a7749e11e90a1d1b79df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExtractHostname")
    def reset_extract_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractHostname", []))

    @jsii.member(jsii_name="resetExtractJurisdiction")
    def reset_extract_jurisdiction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractJurisdiction", []))

    @jsii.member(jsii_name="resetExtractNamespace")
    def reset_extract_namespace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractNamespace", []))

    @jsii.member(jsii_name="resetHostnameClaim")
    def reset_hostname_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameClaim", []))

    @jsii.member(jsii_name="resetJurisdictionClaim")
    def reset_jurisdiction_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJurisdictionClaim", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceClaim")
    def reset_namespace_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceClaim", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="extractHostnameInput")
    def extract_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="extractJurisdictionInput")
    def extract_jurisdiction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractJurisdictionInput"))

    @builtins.property
    @jsii.member(jsii_name="extractNamespaceInput")
    def extract_namespace_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractNamespaceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameClaimInput")
    def hostname_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaimInput")
    def jurisdiction_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jurisdictionClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceClaimInput")
    def namespace_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="extractHostname")
    def extract_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractHostname"))

    @extract_hostname.setter
    def extract_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45e805a50a6aac885ce77d9bd6d6873d8ec92dfe4e37cb2c186ebca1e3b1533b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractHostname", value)

    @builtins.property
    @jsii.member(jsii_name="extractJurisdiction")
    def extract_jurisdiction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractJurisdiction"))

    @extract_jurisdiction.setter
    def extract_jurisdiction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e432fedcd47ac811e0f233a9216e9b8e2d53d7738200ff265a0a82de7103f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractJurisdiction", value)

    @builtins.property
    @jsii.member(jsii_name="extractNamespace")
    def extract_namespace(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractNamespace"))

    @extract_namespace.setter
    def extract_namespace(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b21d6510a0e9c261d20bb655c2663c5f501d215a49baa9cd15efa79519566af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractNamespace", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameClaim")
    def hostname_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostnameClaim"))

    @hostname_claim.setter
    def hostname_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a043b2bbc5338f211815dd642c91eb8065fa71e4580cce51b392c835aa231a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameClaim", value)

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaim")
    def jurisdiction_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jurisdictionClaim"))

    @jurisdiction_claim.setter
    def jurisdiction_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e03398618c85ee82df65837f9a8cab30f4f903e9a78f42271791878bd3c067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jurisdictionClaim", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e200b2c7be27bdf2f047174f84acb073526a8943ce5ca6054357f1a118abc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceClaim")
    def namespace_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceClaim"))

    @namespace_claim.setter
    def namespace_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aabeb1ad6861014cce02f9d6efe43eb9e98421639d60838d06dc28d76ecbab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceClaim", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a7ee71c6421142b00326a650bf672fb3a72d512a381a9c929ad39b122b65785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c887133368bd72372f11595a616a90c45ff1f8e5d574cb3020ae8dc69fe8bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda0bfd1e70cf96d6ad05984362c600d2d8cf0e1f89b772c0519f629c3ce52a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__363c8162ae2244a0172a5e41f9346c845c7253ec26298df712651ac881ce8bc0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e3035e64fb0173bf94f3e9b0fa03a8fbd04267b438fffd8637a6b57a3ac9f9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d036141fa0a148d4ffeb196365ed91e0e25e7a45c5c251fc67cb9f35ed59bc3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71cb7aff8d8a874f9bdb91d1caf9879c172b5a57d26f0517cf2f9a04faba7151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a259b440335ed3b1ed77d1e4143aa6a9ca4698fc5321b2c36fdbef9ea02b773c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edadc395b919832b9d3846f3083babd9305f31fb4d5f7deb4de94d7d15d2ed90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a3dca5d12e161f80fa93c0ab210baeea50bb512dccbfa1b167ed0e62070024b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "reason": "reason",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fd81b827f52ce6c398d85a83a72ac62a0c720fcf6c26a07b5874781f47b7dc)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reason", value=reason, expected_type=type_hints["reason"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if reason is not None:
            self._values["reason"] = reason
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies access when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reason(self) -> typing.Optional[builtins.str]:
        '''Text message that keys why access is denied.

        Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        '''
        result = self._values.get("reason")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04335ad9178643dafbc1a0a6edcb4970ad05d608863d86efdae67777fe3d0d1e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReason")
    def reset_reason(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReason", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reasonInput")
    def reason_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reasonInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1675450ca054aa1c52d0f5da1d7babeeb5ca9773e741b9e862fcede273afe5db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8aa905a5ebee7a1a1f3d060fce277c8e989d7802bd7347257f70f885448a8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reason")
    def reason(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reason"))

    @reason.setter
    def reason(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e26fc59a2d5f6a4ec9fb10717b14f2f982c67015da655c6f01c6548f9d79fc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reason", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8704798cba0e644cbe2e912944c7117ac0262b3976fd784b8c0cc241ad9bc33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d57ea695b99705fdd62869069358dc6b44fe9594b72b044fad84e8a7bf6c681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__772d268944298378f2dd13a3afc75becf6a76697b785a1f09c12eb2b9455c49b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813f4b01b71a35657960358a5bae639b603e0f996c3fb4d350bd40bbc08339b0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa1274178bcabbfa08f3dad12dee42bb585fd95b3ca96cd46699b7a1a367d6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e45deae751617d8812428ed36d5d9f46861452491e514df3da5b03c5682ff0a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__144fc0d46cb520c246733862dc31df45d9da056ca7f929615d8fa2972569e0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84979d4450eed018949cc76074a28fc5c9901317fad458c2e021d565c95c48e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a8afff55d0f213742cbc4712a9a123203fb62327bd403a4f847818bfe01ea36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5fcfbdf0461dfe6e83e30db79856a1795ecb12738f2eacf5cccb939089330e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead7398cf3a1feaaf8586e0e2bab2572d77c5e3680a732c148dae775d1157f24)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of information about the device with which to generate a separate cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4316c7f8b59e29de5ce646c39ba41cf243cd69f6ae08df78a584125404d856cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b1c3b3a2dd4b1993526e79e156d4df19f9bea74dd3b17a12d740f0285ef992a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9b965a3f9898207c5e6bd28f31d3cc23232987a8f5f6e189548686327818ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88649f89481f5cd373d96b1dc148402a939da4ad159d2ea2b9d31dc40af19cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2691473102a55e3c2f0246be1643774e48b694abde86db7971734fd53ab40d59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db131c95336496d50868d0e3b6edd9121ed10ab2ca6a2f3604df71d608c4d680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dacd416a415f09a764a64e84ae973f053f0e38017e132666aa73d287f1092456)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of information about the requesting device to send to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5a1ff77ca7761664b20dc64c6c00413fe97e931cf02ef5400197252099400c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5238a612be3fbda46694b0ff2d5478a241c9060bad4c0f808204bec3e775ec7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36e5466e050fd8dc91006a8891ae3469db1a7a60345b36207f9b6bd309dac84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35a3c82d4aaaf1e82efe172cc681a22fc62e4a51569917954dec239d76034aee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b44111e883ca08276c0a5da4105808c57f237c868cf80748c2146cb0c9ceff05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40a4d62722555de8ef3041be4c7ed0af43a043ff381ad2ad802bebde63e74ac1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c5407f75ccd9b48b73314763ca2bf68c39b448366924a673c69c04139153a65)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh an expired DNS record after serving content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Set the maximum allowed time an expired DNS record may be active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffcbf5169e21140c261fabf1b3433117f73baa5adc722d545ac7af1bfde7143)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64d2395c374084e08386618ffb304778d1bde5afeec35ed7f1c194d6b69c814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d62cbe78d38406a1268f9fbb3a86b99cb1ad0332082b452fe178dc9286636991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ac27874b22dc9581e47fc9535b772ef18df05556b3c357b138171c390d3014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8ad80fabef66dd83cd4a847e492c7129a18f543447b5422d3d0b93bd36a878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7043f5593e9e12ad4129d287aafc0312053f055c19af4a922c48647b21ff204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3762df64492577436744b95630dbdcaa47c39765907a8ae46fec5e26a16ecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh",
    jsii_struct_bases=[],
    name_mapping={
        "delay": "delay",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh:
    def __init__(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4652d91a2c3c97f7a691ae43e25ad75a8382a2ddad6055d2b66ee4d7569b041)
            check_type(argname="argument delay", value=delay, expected_type=type_hints["delay"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if delay is not None:
            self._values["delay"] = delay
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def delay(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        '''
        result = self._values.get("delay")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh DNS records before they expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd8f47ab3e54b213f9de00eee7ba83205e8b8a793985d36d03c69b3124f1713)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDelay")
    def reset_delay(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDelay", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="delayInput")
    def delay_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "delayInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="delay")
    def delay(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "delay"))

    @delay.setter
    def delay(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__773aa35aa450b8e4a071d029ed1c848736ab703936f98ca345db8ce271062010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "delay", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a3149794f61f109b585258819eb3b9a96b37a06e1300047ec56d82e2ed484ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd3c0fe53736b1c5dc6765c218ecff878ae1488b6a92983d89b8a586581a30f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a189123a35124c94c5c7e54be915e64d3b63a5ee0fc43bacf5bf978a8a2a3d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88efd04d79222314383e7f2295d83fe5b25f1fe3ee3b214999a1016d7f59555c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__043049f43319fb9c3db233fff8efc7041cf14bdd444b0963f8a2082de36b225b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6156840876ba31f416d48060fd5e0f626d6a231fae9b5eacce53531ac125c450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__874f6949c7720a52002ab720a35ecaac519e9fb9c96c6bbdf30c23856d4a1898)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the protocol downgrading behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17678450ff49751ba8b2604d00483f74918bc3678c240058a5972523420ccec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785dee918ba047b224a5421468ab2e024318b19b1f4e5918809c73ac28e80f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8466b94d7830e98227cd7dbeeb70977748d2e2586e18910ab656c72ea71c0c19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd947f802ed92ba251e4ccbf2674529a2ff1b006be37fba67df2dab2669e1212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d9681821ac0cd8d9b39ffe23af2b7c5af9f827338bb2a52decabae37f99fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1916764d6af92c56a3277713d043a0913da7dc1f476a930b6ed1d5783283c38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bedc30b8cda364e6df362043c1d06ad5030fd800382c0fd20269715afbe773e7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38482b26f5bb98c2b01764f5684f07d74c12d303151ac6382ea8c05828949726)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c89fd4e45f030218a5d1440ad71428a20b7733f2d9403c6ff0af860be5e42d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb7266b276b45912e8f50a157fba194c7a2a106bcf4734857997aa09df52c573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1cb88bafe244e0cafc120d00d82de4a47000a661e29848ca49192c6517f7317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a919fc1aeef9877edb274aa0e0cb23dcbed5f8543b3a79259dec45ad963e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b17a23cc8c29e5ca8c60b104a6141d31eeb3d7d296b9f9db29163c81d00a8d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac238b4064e0ad0edfc07fe7c79eceadf2a7e03fd6ebe2da53a8ea3a78d9b89e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22c460afcba7aae1ef716c2cbe392efb4ec05e1b7063faba5ed7e24eed29d0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0d6c370445365487796aecd7439790c646fe686f407d5386a306daa97a7642f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b354d5775487df23934ca9cde538a45d59cdd33cc58d1392df68e7acc6a2649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b773d6eb9fa44af5eedd37b58c2c52d5724513c28f3f436bfdb68039eb9756f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60150b0e907c2d685d30798071d36aac41f316aedfb0f51d2a45847d153cfe95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ddd3bb046219c13abad250a212adb1740221319596a9d7c687e67a027c19a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache",
    jsii_struct_bases=[],
    name_mapping={
        "allow_behavior": "allowBehavior",
        "behavior": "behavior",
        "locked": "locked",
        "send_headers": "sendHeaders",
        "send_private": "sendPrivate",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache:
    def __init__(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b211f342e3a5fd607f2700e134177ecd0520bc3b40d0df0945d250559bcf0c)
            check_type(argname="argument allow_behavior", value=allow_behavior, expected_type=type_hints["allow_behavior"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument send_headers", value=send_headers, expected_type=type_hints["send_headers"])
            check_type(argname="argument send_private", value=send_private, expected_type=type_hints["send_private"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_behavior is not None:
            self._values["allow_behavior"] = allow_behavior
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if send_headers is not None:
            self._values["send_headers"] = send_headers
        if send_private is not None:
            self._values["send_private"] = send_private
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_behavior(self) -> typing.Optional[builtins.str]:
        '''Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        '''
        result = self._values.get("allow_behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching instructions the edge server sends to the end user's client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def send_headers(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP headers to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        '''
        result = self._values.get("send_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def send_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        '''
        result = self._values.get("send_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd753a74cf64b110ec790d8b97fca22de6d14830f58b2aa0aacedae4a97cc93b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBehavior")
    def reset_allow_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBehavior", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSendHeaders")
    def reset_send_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendHeaders", []))

    @jsii.member(jsii_name="resetSendPrivate")
    def reset_send_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendPrivate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBehaviorInput")
    def allow_behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sendHeadersInput")
    def send_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sendHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="sendPrivateInput")
    def send_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sendPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBehavior")
    def allow_behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowBehavior"))

    @allow_behavior.setter
    def allow_behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36e51159837531708008f16038a50a2e9c0dbe15b3083220ff1044eadb8bd1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBehavior", value)

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4405499622489f71ff9ed96cb8dd798dd546e9d77cac958a209dd7192b3023f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c6fb4843daba8f6afad6c9a947a0e98600dbda697527875019edd67d0077b56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sendHeaders")
    def send_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sendHeaders"))

    @send_headers.setter
    def send_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b504788ac6f34fe738ea72899a41feac4c5d08501f92081a3e4cddfb4098c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="sendPrivate")
    def send_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sendPrivate"))

    @send_private.setter
    def send_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c3a211634941cad2792a0c725a24e21bec8acc3d1f8c4e1a221e154d433d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56a9c529c61067e3802779ef0603c2eb527d6285ca47d2814b0c142767b76dea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecda227f06d33116f5814b9eaf7cea82ac262dfc18ca4f928d139c54a6941dde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84bfc1253857c538ce00a6cdf714489c5f1e9327db3d921729960def86fe3af7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f7ce064ba778c64799d5c961b8fe8f8526908cd439cea4d315b86fbad801d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad79a65d17423e452ea3f252a5f7381c2b67003a78c567cb6515e3ef0b95b46)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the quick retry feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93a35e2d90bf6c27434ab15d01fa705542924fb4c1bc02bdac95c1228f7987a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c82866e1716b4ff8c9c9825d56c5ecc2d50b77184a1c276d60f17310582d71d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d644174ab292f0bd5a517a9cc5942698bc1cada7656a2b5f896edf379e3ac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2634074cac65b3dc3cff380c21c666fac04e2df509a478a0df35cd6e68b2abcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b05b0ec20a05db029b90924a73c8188a5e8fa2dec051c6fad031aebd0ce9aeb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7466989bdf4ecb508b61d469772743462f12dff024d4b333de17150f79896ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "throughput": "throughput",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6ebd37a17cedb720b4b79c70adfb792a6055f35e346c5741ad71d4622bd9cf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throughput", value=throughput, expected_type=type_hints["throughput"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throughput is not None:
            self._values["throughput"] = throughput
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throughput(self) -> typing.Optional[builtins.str]:
        '''Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps.

        If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        '''
        result = self._values.get("throughput")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8c23caded697b9240e9865a979e3b228d0a11a5dab7fb9462cdf2d10862451)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThroughput")
    def reset_throughput(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThroughput", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throughputInput")
    def throughput_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "throughputInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84c27ce4c78644b0807f6026f5004d67be63888e534f863f3fdb7840529b2f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce77f9fc13350bf20ce2d3558fed5e147aac00b2da86970fe914cd6427ca548b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throughput")
    def throughput(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "throughput"))

    @throughput.setter
    def throughput(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4659b19e6130974ced27e2a57ce5f2183e0bc8f8b0b459e7451a4d1be9028cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throughput", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaec34f3d4df4ccb410fa5d552589dfda084377aadb964cac990ab2eb121c10d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478ef49de76bedf663bdaa17619db02cd49039eac9f5841d336153ff4cdffe16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent",
    jsii_struct_bases=[],
    name_mapping={
        "image_compression": "imageCompression",
        "locked": "locked",
        "prefetch": "prefetch",
        "real_user_monitoring": "realUserMonitoring",
        "sure_route": "sureRoute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent:
    def __init__(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4c31b7f1ed97ea9a541da9f84674b5867efe54068df0e485cb2ca14f79a84e)
            check_type(argname="argument image_compression", value=image_compression, expected_type=type_hints["image_compression"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if image_compression is not None:
            self._values["image_compression"] = image_compression
        if locked is not None:
            self._values["locked"] = locked
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def image_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables image compression for subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        '''
        result = self._values.get("image_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows subcustomer content to prefetch over HTTP/2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes how subcustomer traffic routes from origin to edge servers.  See the ``sureRoute`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339caf41e31e57addc0b90c41c65a76edb4535466209589b265c497bc4c65965)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetImageCompression")
    def reset_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageCompression", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="imageCompressionInput")
    def image_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "imageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="imageCompression")
    def image_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "imageCompression"))

    @image_compression.setter
    def image_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93a26cd10c17e272fb2f10c33c2056f5fe716e1e4d62464cac99cc9e5d18c0d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageCompression", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9947c5050bf951566e5c41e192be52cf2180bce623c9d1271e202ab0a4d4e9d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetch"))

    @prefetch.setter
    def prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50a342960115c945f0055969ee46a28f074484bc38c48cec5a743df704227d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetch", value)

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "realUserMonitoring"))

    @real_user_monitoring.setter
    def real_user_monitoring(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86837ad02771c7f45a237c5b7553ecfc318e4c91332746a4eb1d902d7095e910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "realUserMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sureRoute"))

    @sure_route.setter
    def sure_route(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f6b0a3059816e66af29fd8338c66300f65b870a456379448dbd94b43005dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sureRoute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b94db6f6392a18fc252549a127f224fe905f552b206c02b09136c3f2e4fe6043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c5637c64306ca5432fa9dfbd646dc6d4fa24474174843c02e95841848b6d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472720b865c5064f5f8c9bf758efb30bd5b1aa48127fa477cfc37140d4646868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2ac25d1c8b27d8b54b14e3a6310ecb36d53390e29f35b0cb9aef4ac20174fd)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables sending a compressed archive file with objects.

        Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33259d2dba06e63aa80e11128e219fd0521b120e96295cbdbfc3731a3d598c75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__072ba721093d850324fc6ac836607e6bbcc42cde47d16dd2bb173ae07be4bfbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a9abbcea922fc23fb525ae391da6aa655b6b02172b3259d40a6536d63cbcc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3194f2211cbc48e725a266ff9fecb64d0244a001318387114769bb4a0bef9aa8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac8adec45476980e2afe551234ff6cba00c524dfdef379780f62be62f3e98e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2b32d2e5a4452c2d293c70c0f132f58843b6f2b1f7486061446e0591ab0188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase",
    jsii_struct_bases=[],
    name_mapping={
        "database": "database",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase:
    def __init__(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c84624904b6c3d1c8c8356219a73cfc09971789bed872b1be0dd2e32168514)
            check_type(argname="argument database", value=database, expected_type=type_hints["database"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if database is not None:
            self._values["database"] = database
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def database(self) -> typing.Optional[builtins.str]:
        '''Specifies a default database for this property.

        If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        '''
        result = self._values.get("database")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a database name in requests.

        If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the database name. By default, it points to ``database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the database name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b2e25d4ef98bcd103f27cb174ebb13f22d1b7b9e66c2af02103e0cb14c5742)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDatabase")
    def reset_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatabase", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="databaseInput")
    def database_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "databaseInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="database")
    def database(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "database"))

    @database.setter
    def database(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aef6037bc30e988cf3e7059ab6b062ca87fd26b42c933f3371823f349c6fbb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "database", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4646fcf259313ac8f5c7c0ba3351481842ee056e941dbe2172fe6fd2b774e70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ceffef4708fd9f13f0e0ed3438537a678a625f234bbb8e025e73c7a026ea0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad687c8b113b885545c7976ffe5ffbd9bbab7571719775737991b197b9f04854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72839329811378eadc0752a89a7e6351fc82cda2bb88a2d8f098fc4a16ca9d86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eac0f7ec24fc3ff91cb1bd2a901c7d2ad56100bf082cb1212455a1825cd05807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98aa33aeb9989f5ad4080e2d8c909ca515b6566e60843d3d55821bf993ac17e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b755294b47e310bdc38fb129c72f2f89e37d8fda705ecf04d176a4397a8fa8c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06b5e35c2e8875522f5df1ccfb9b43d5d1c53f1d3d0b7b58d36a7e0b42acc373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset",
    jsii_struct_bases=[],
    name_mapping={
        "dataset": "dataset",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset:
    def __init__(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4747936aff440514aef6c7766fb2ec9e4f447bf5ed5cfcf400a6f1b97fa901a4)
            check_type(argname="argument dataset", value=dataset, expected_type=type_hints["dataset"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dataset is not None:
            self._values["dataset"] = dataset
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def dataset(self) -> typing.Optional[builtins.str]:
        '''Specifies a default data set for this property.

        If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        '''
        result = self._values.get("dataset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a data set name in requests.

        If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the data set name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ffb8cd213cf30e36f80de59f9b8553a3c9645047e1563d92d38d41cbd4f203b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDataset")
    def reset_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataset", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="datasetInput")
    def dataset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datasetInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="dataset")
    def dataset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataset"))

    @dataset.setter
    def dataset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59c23449deaa8a5ffad6a8b0b484b068694f0697933ed75cfed1ecdcda19b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataset", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78f71cabddd081692aa61677384fadec65b94990a46a61e6208f40aa8d043ffa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842b25c5648192c6491464d37c958008e0cdbb800f7cf31adad821b2bf8f49c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5abb81651a47c77665a343d9171a14a6d0d82156113abe65f0c7892a6ca4e79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1d0f603ab91c35a1df327186ed92183a47160888eac3905455429c83899675e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1deb4e9fae646db626265883509cb1abaf31556737b8967bd775e19e88a554e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b74a9e4854e82816a8e105f840ff0b0d37ae42f8072b95e948a1cb5544b3d343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b6fa1aa659b67fcf1ce47eb8cd10be5bf2bab287a2eec9fcaadba7e8c1da398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f825ce837638dbf389726fd34f65fa359a9bc20b8d52349ad06e8bc90c9bd24b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e4bf02dbeee458fb5a862bc80c6b255223b79c1fe4d248e1e8ea3d4725e63f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e27ccea938f77442a8f8aa258b0047ae0d82c9de6f0591c44b938d0b3f849b53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff585c2f457a330640cdac6ad5dbc70ce409d599d40bd6f4337a873c29196da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76a55302da79b4309720d0ff9e390bc97670f6723c60d5c9cf5f6db05475fdad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d363502d60e0baa354d29e2faa39c43a4cfd954e8b71de1d1192c8f0504e5d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6018cf61582e57f8c0e32077ca681cf645f6c2d73f66b32a58b480ea4f53337e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0d4b22608722fad75c41ce4fb6388900a51e0e17c5c0e16601602d2de422ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect",
    jsii_struct_bases=[],
    name_mapping={
        "aggregate_lines": "aggregateLines",
        "aggregate_size": "aggregateSize",
        "aggregate_time": "aggregateTime",
        "api_connector": "apiConnector",
        "api_data_elements": "apiDataElements",
        "destination_hostname": "destinationHostname",
        "destination_path": "destinationPath",
        "enabled": "enabled",
        "locked": "locked",
        "override_aggregate_settings": "overrideAggregateSettings",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect:
    def __init__(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb478ea22be61a7a67d8079e2cf29729cd0e0c236c5b62f2aa9e0b76f958ebb)
            check_type(argname="argument aggregate_lines", value=aggregate_lines, expected_type=type_hints["aggregate_lines"])
            check_type(argname="argument aggregate_size", value=aggregate_size, expected_type=type_hints["aggregate_size"])
            check_type(argname="argument aggregate_time", value=aggregate_time, expected_type=type_hints["aggregate_time"])
            check_type(argname="argument api_connector", value=api_connector, expected_type=type_hints["api_connector"])
            check_type(argname="argument api_data_elements", value=api_data_elements, expected_type=type_hints["api_data_elements"])
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_aggregate_settings", value=override_aggregate_settings, expected_type=type_hints["override_aggregate_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aggregate_lines is not None:
            self._values["aggregate_lines"] = aggregate_lines
        if aggregate_size is not None:
            self._values["aggregate_size"] = aggregate_size
        if aggregate_time is not None:
            self._values["aggregate_time"] = aggregate_time
        if api_connector is not None:
            self._values["api_connector"] = api_connector
        if api_data_elements is not None:
            self._values["api_data_elements"] = api_data_elements
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if override_aggregate_settings is not None:
            self._values["override_aggregate_settings"] = override_aggregate_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def aggregate_lines(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum number of lines to include in each log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        '''
        result = self._values.get("aggregate_lines")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the log's maximum size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        '''
        result = self._values.get("aggregate_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_time(self) -> typing.Optional[builtins.str]:
        '''Specifies how often logs are generated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        '''
        result = self._values.get("aggregate_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_connector(self) -> typing.Optional[builtins.str]:
        '''Describes the API connector type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        '''
        result = self._values.get("api_connector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_data_elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data set to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        '''
        result = self._values.get("api_data_elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the target hostname accepting push API requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the push API's endpoint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Monitor's log-publishing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_aggregate_settings(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides default log settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        '''
        result = self._values.get("override_aggregate_settings")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__679a74581143e7dc93138c9b5a41578b3d6626fa1aa817749d70e51d35da1ae9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAggregateLines")
    def reset_aggregate_lines(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateLines", []))

    @jsii.member(jsii_name="resetAggregateSize")
    def reset_aggregate_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateSize", []))

    @jsii.member(jsii_name="resetAggregateTime")
    def reset_aggregate_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateTime", []))

    @jsii.member(jsii_name="resetApiConnector")
    def reset_api_connector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiConnector", []))

    @jsii.member(jsii_name="resetApiDataElements")
    def reset_api_data_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiDataElements", []))

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideAggregateSettings")
    def reset_override_aggregate_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideAggregateSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aggregateLinesInput")
    def aggregate_lines_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateLinesInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateSizeInput")
    def aggregate_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateTimeInput")
    def aggregate_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="apiConnectorInput")
    def api_connector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiConnectorInput"))

    @builtins.property
    @jsii.member(jsii_name="apiDataElementsInput")
    def api_data_elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "apiDataElementsInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettingsInput")
    def override_aggregate_settings_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideAggregateSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateLines")
    def aggregate_lines(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateLines"))

    @aggregate_lines.setter
    def aggregate_lines(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0469edde61b695889b5995e1515f30c212a0bdfbc5623392c177bcd0f54482f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateLines", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateSize")
    def aggregate_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateSize"))

    @aggregate_size.setter
    def aggregate_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df3f1e901f9c25c9a6ddb8a098a2c5c0768c7ba972405d8d886fecbf91217937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateSize", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateTime")
    def aggregate_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateTime"))

    @aggregate_time.setter
    def aggregate_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf23b3e9e133948f82ca13ca9e31889f803dde77506d6bb657b99c6ecb187c34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateTime", value)

    @builtins.property
    @jsii.member(jsii_name="apiConnector")
    def api_connector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiConnector"))

    @api_connector.setter
    def api_connector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ddb0ffd779252bb638b6ed2635453e7e3c80837ce634bda15d0c3a80d11eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiConnector", value)

    @builtins.property
    @jsii.member(jsii_name="apiDataElements")
    def api_data_elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "apiDataElements"))

    @api_data_elements.setter
    def api_data_elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__645cb0cc854541010351259da96e9bee3078a7ef36856492d0f7a1af78e59d37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiDataElements", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e622dd1a9ed9da1abdcc057b1ce3402e93cbda5c2e0485122feee60995ad22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f5bc4f0d32706901081f0120a3e9261a3c06db57aeb1361e1e625b1d07f1e26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3905c14d998a1884330e0d7e096156531e8a1597164256048faa49131a67db12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80bb9ec21e8077309d92ebf843a59bd15af56f3febd1c60f418e983d4bf585ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettings")
    def override_aggregate_settings(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideAggregateSettings"))

    @override_aggregate_settings.setter
    def override_aggregate_settings(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2b03ef81df85153f4c98543a93ec95cf539ad0727ae25e840b5aece31b5ac9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideAggregateSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84af00185a4f3929d4b4bd560c6d578975b72a89a7223046c478cbd08c4db36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__021c90a423f1a516c2081e6fec57f4cb65c94489ed38a9f8a08543b44b908be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16b663777fcd7a5e734b55279b4b98aec4a58f4a0b4a1461306af0132e3b7b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7bf502d5374e51872166fe680b26203dd4f8d2f9200cdc2c3335a58ccc9f90f)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A description of what the ``xml`` block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eab98155000015b978850ec32a8d0306f6bc0e353cbaedfff0d9562cf7a5aaca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c233855abb7030b3e53b267701e92004604e3961848d0ff37f9b36af2e937c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5728aa5e120dcf011d2530b190a8c99e23cbfab1a5872039166e2e56ad637092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77e02e04768e41073cd79739f4721eba73df15a1c833ab466a768eb85f912e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e23cfc8453576b837cde03a24f8cdd0b434242be0c26a852b71bf7b8bf1f37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa84f7105330a69a46f3372089360795c164cd666a100c0a57fdc97b051025c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8043e3bccfbde61a5aa8eaf3ba4bc079d0e833f596203657914ecf4bf62d038b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_failover": "enableFailover",
        "failover_rules": "failoverRules",
        "failover_title": "failoverTitle",
        "hostname": "hostname",
        "ip": "ip",
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6942cd8aa154099528fb04c3a1f3c4407cfcb911e1b5886d1e8b6559629466ed)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_failover", value=enable_failover, expected_type=type_hints["enable_failover"])
            check_type(argname="argument failover_rules", value=failover_rules, expected_type=type_hints["failover_rules"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_failover is not None:
            self._values["enable_failover"] = enable_failover
        if failover_rules is not None:
            self._values["failover_rules"] = failover_rules
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if hostname is not None:
            self._values["hostname"] = hostname
        if ip is not None:
            self._values["ip"] = ip
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB data center, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify failover rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        '''
        result = self._values.get("enable_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_rules(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]]:
        '''failover_rules block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        '''
        result = self._values.get("failover_rules")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the data center's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip(self) -> typing.Optional[builtins.str]:
        '''Specifies this data center's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    jsii_struct_bases=[],
    name_mapping={
        "absolute_path": "absolutePath",
        "context_root": "contextRoot",
        "failover_hostname": "failoverHostname",
        "modify_request": "modifyRequest",
        "override_hostname": "overrideHostname",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules:
    def __init__(
        self,
        *,
        absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        context_root: typing.Optional[builtins.str] = None,
        failover_hostname: typing.Optional[builtins.str] = None,
        modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param absolute_path: When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        :param context_root: Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        :param failover_hostname: The hostname of the data center to fail over to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        :param modify_request: Allows you to modify the request's hostname or path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        :param override_hostname: Overrides the request's hostname with the ``failover_hostname``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9dd3665de23095d98d257f49567babeed12e725a2b7ba8432babcf7c97ca82)
            check_type(argname="argument absolute_path", value=absolute_path, expected_type=type_hints["absolute_path"])
            check_type(argname="argument context_root", value=context_root, expected_type=type_hints["context_root"])
            check_type(argname="argument failover_hostname", value=failover_hostname, expected_type=type_hints["failover_hostname"])
            check_type(argname="argument modify_request", value=modify_request, expected_type=type_hints["modify_request"])
            check_type(argname="argument override_hostname", value=override_hostname, expected_type=type_hints["override_hostname"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if absolute_path is not None:
            self._values["absolute_path"] = absolute_path
        if context_root is not None:
            self._values["context_root"] = context_root
        if failover_hostname is not None:
            self._values["failover_hostname"] = failover_hostname
        if modify_request is not None:
            self._values["modify_request"] = modify_request
        if override_hostname is not None:
            self._values["override_hostname"] = override_hostname

    @builtins.property
    def absolute_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page.

        Otherwise when disabled, the path is appended to the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        '''
        result = self._values.get("absolute_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def context_root(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        '''
        result = self._values.get("context_root")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_hostname(self) -> typing.Optional[builtins.str]:
        '''The hostname of the data center to fail over to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        '''
        result = self._values.get("failover_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def modify_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the request's hostname or path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        '''
        result = self._values.get("modify_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Overrides the request's hostname with the ``failover_hostname``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        result = self._values.get("override_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5710f6a7e8f7994aaaa444b3655df41f4a558b243dbaf8717d0223ed6f916426)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ead3eaa10f8e5733f882296307c433af6e9200cbeb0b2adcf3f9084f986fdf6)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa56a6c4fd019318ad07f9a036d9fa3cee63725fe09b39a53835fd672d24c59a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__555495d9d4ab58f8362c965381b30c58d1d5ea8d79f5fd8e7050ee64ddd1af6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47ccb96302da2c6c0619569dcb74d6aea0be782035be939c8f47b0c2afc11c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd0caebb7ffe43edc69bb919d7cf79ad535e7ba93f4020089324ba819de8afd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8f7043033f22b402d1725f3b7df7a075e4b2289744a8cc9b7dcec4ad28d055c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAbsolutePath")
    def reset_absolute_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbsolutePath", []))

    @jsii.member(jsii_name="resetContextRoot")
    def reset_context_root(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContextRoot", []))

    @jsii.member(jsii_name="resetFailoverHostname")
    def reset_failover_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverHostname", []))

    @jsii.member(jsii_name="resetModifyRequest")
    def reset_modify_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyRequest", []))

    @jsii.member(jsii_name="resetOverrideHostname")
    def reset_override_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideHostname", []))

    @builtins.property
    @jsii.member(jsii_name="absolutePathInput")
    def absolute_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "absolutePathInput"))

    @builtins.property
    @jsii.member(jsii_name="contextRootInput")
    def context_root_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contextRootInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverHostnameInput")
    def failover_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyRequestInput")
    def modify_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideHostnameInput")
    def override_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="absolutePath")
    def absolute_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "absolutePath"))

    @absolute_path.setter
    def absolute_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d8eb3d70854f94171574a1e9f993e72fba5db10c39bf8f566c6c61356a2f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "absolutePath", value)

    @builtins.property
    @jsii.member(jsii_name="contextRoot")
    def context_root(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contextRoot"))

    @context_root.setter
    def context_root(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__499485d35457e242bcc641c5ba1ee150cb94926ce5252c4e1989cd73f4022a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contextRoot", value)

    @builtins.property
    @jsii.member(jsii_name="failoverHostname")
    def failover_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverHostname"))

    @failover_hostname.setter
    def failover_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cafee8f8e81e3376e36ed1adc4e4d27e69f72a39577df760ee5935f4d8a7a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverHostname", value)

    @builtins.property
    @jsii.member(jsii_name="modifyRequest")
    def modify_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyRequest"))

    @modify_request.setter
    def modify_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__773e18acc9bd95cd1065cfed685c46a5398bc7578bde96dcdedb099343dad668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="overrideHostname")
    def override_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideHostname"))

    @override_hostname.setter
    def override_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c6080c1e89ef2f26dcba7bcb8d92186d646ef414b9899138de113a231df11d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideHostname", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7923a74c935e33451e1b9399a897d1f2b92afdf2f1556cb970a4fb6c65ba111f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052ddc00b29bff38398d045bc49b58420afa6cb82dfda75770ca3c892a30fe4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFailoverRules")
    def put_failover_rules(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__699ee1a8660ed9a7d107eff0d8d725aa2a965e041a381ad4da8efd8354f13fb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverRules", [value]))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableFailover")
    def reset_enable_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableFailover", []))

    @jsii.member(jsii_name="resetFailoverRules")
    def reset_failover_rules(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverRules", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="failoverRules")
    def failover_rules(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesList, jsii.get(self, "failoverRules"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableFailoverInput")
    def enable_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverRulesInput")
    def failover_rules_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "failoverRulesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4792c078576b64e167b34bef78098358fc314df3a66ab8dbf0846e22a7c68e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19cfe9887cad84d4dc1a55f7504e965f146c4a658c7ac110b815566a175629c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableFailover")
    def enable_failover(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableFailover"))

    @enable_failover.setter
    def enable_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__609580e4e21dc17d3c8f6f3354fcd166704982340d4c92f1cf5f9eb4c74ccec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableFailover", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dafe4ff911c6f9b8a5bece315b8a496343117f1643a566b6838405dc40f85da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5875dd0b856bcecb3c7f5227649b9783f16bd2e63b416065e0fd041dbf4a8746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ip"))

    @ip.setter
    def ip(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcad6b193e6d6ccaac6dcde329358b5c4943efc16a609e25fe723bf694084e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28b87294eab6d3b8dabccb46fbbba799126cb076eaf0591660f259a1982366e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12bec11930273ff0cb6ec6cb36cdcce3eaa2e4d7290dbe48a8c9878fb16f77b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17060c28d051c60d901ad0e4e717045bfa4deb784a0530c5a80deda8216e7b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4cb57fcd36d4a916f6270bb62a0f9db20b02a1429748ae267bdde3c9dd4b62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da63ae833c064f1bea93a6d15bb3ee92a143167b366994c519f861f73ea3e0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_session_persistence": "enableSessionPersistence",
        "hostname": "hostname",
        "id": "id",
        "locked": "locked",
        "session_persistence_title": "sessionPersistenceTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f0a8c481b065e5fee007c590de944ac96a8a8f21cd860b4182491daa41c1b5b)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_session_persistence", value=enable_session_persistence, expected_type=type_hints["enable_session_persistence"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_persistence_title", value=session_persistence_title, expected_type=type_hints["session_persistence_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_session_persistence is not None:
            self._values["enable_session_persistence"] = enable_session_persistence
        if hostname is not None:
            self._values["hostname"] = hostname
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if session_persistence_title is not None:
            self._values["session_persistence_title"] = session_persistence_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that marks users' persistent sessions.

        The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB origin, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_session_persistence(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify a cookie to pin the user's browser session to one data center.

        When disabled, ELB's default load balancing may send users to various data centers within the same session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        '''
        result = self._values.get("enable_session_persistence")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname associated with the ELB rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique descriptive string for this ELB origin.

        The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_persistence_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        '''
        result = self._values.get("session_persistence_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e7282a08c55439404190422d05391c9aa5e258e05118ecd7d0791242fb2d0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableSessionPersistence")
    def reset_enable_session_persistence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableSessionPersistence", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionPersistenceTitle")
    def reset_session_persistence_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionPersistenceTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistenceInput")
    def enable_session_persistence_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableSessionPersistenceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitleInput")
    def session_persistence_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sessionPersistenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab08fd742c4969aef6f626f81bffd2902156208e22069e88abf597213da001d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fc67268bda442db235a93c695d1a297c5b349cc33f91577967d93e06818be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistence")
    def enable_session_persistence(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableSessionPersistence"))

    @enable_session_persistence.setter
    def enable_session_persistence(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c2d4187163cbb613f102eafefe3b60995d2ea554f62a8a7da0fe303ff069ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableSessionPersistence", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d75441433f8673b2ce480f6a3132beaba9b0db7c67e62bb1a1fe57ccd553fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b401acbc4c01dd8b74d80335c18e353b47ff66b0719b87e860a250cf28f979d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7c8269d6d6e8c351f1cb68ca651f3dabf4a417b88c82e515b36e7b921355566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitle")
    def session_persistence_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sessionPersistenceTitle"))

    @session_persistence_title.setter
    def session_persistence_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3501340bbaec91ed465b67674bdef646e8bb116ff62fab54dd4604a23bd7bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionPersistenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__143ad10085439dbb3d357e7b6713f8859f5c8f781b6bfeef6c5584ec23d02cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c405796b69977030f7d418d28c2d85c84b582401d8f5839451d4cb458a83eaa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a82d8891916b64d569b49069b1c4f6f29b0af904b9504a0f2ba3ef4d7f96b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "domain": "domain",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46a05ef9d376721f5d8be3933e16eec3a79289580bfdb9c5925189a79c0030d)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if domain is not None:
            self._values["domain"] = domain
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to use for authorization.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cookie-authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the value of the authorization cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ffd6580c87e8f6263c5671c024f6c93c1de5b12ca7c1129f7132c95695b0fea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b08ea04b6888675e00691dcaf1f64ff06f118dbc0eba495f9dccb8b7535d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3b758b706bfa361a79c4865e2ed5debd4aaf418a6669e748b7f974204d5b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7bab29e7623221ccb587a3c7116c2b3321dc9754323fa732565b5026f560183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ffdf9ada8443711e0381424d0c68cae961006ab89b59b7f9e30934301b1c7c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6dd1e7ac4682c958536202d9cc18c5a0e4bcc5702620e4543fbf66c0ba91d1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__066f17aa29c75b167505076a746b0bb4efb326330b636bc8493f06beefb71f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ebf67ee118624e2d5afeabc6fe41c0df617a809b980a71199e3bd2a732a1578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665b152b863add924ddd31f1a4e94f8d673fd23f2c78bc93c14549c8b8d5d7b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dedffc4168a2ce6c596181af27579d99494cffa4a63d9e4853cecdfca578ac49)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Edge Redirector Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca9d1703d5374aa90938e97a83e575110026f45d274ad2d6ce8d44b578886a2)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ed08d100af0b97a595a6e8e88ec08fc109bc7aa1d1b3714b3b90ffbe536b16b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ffaa577b01b66a4f1f05bb9995300ec973d52a6ebb2acacd93dd385bf9e9add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e57ba02c554737b7378719852ab7bd0b9fc4b0998e8a656228d6ba937828c609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3dff3dfd27a9ee06489faa5d5bd24b2285ce1a4e1164cfc432dd8afd97bf465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1929d24b46f43dc19e31d6a7dbb7b266f0d7d281fd1f1e6ccf9b936677d6f2b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7146d768db2a2b3da0497b99d177c156d0b9e8dc110b7f0f1a1d398c97f9b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f553e16c55247ff2298e3b977a6d0d4fd7000cc9e38727b8f0646f547234b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a156d197c392c9029016e6af23f2138539d59cd4ea4f7467a5d85707d334c285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f580872dac7396b8d885d85b5398253644ed459e0c8c98f4ab3f855586bfac73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5806b10401b327b3006e39af1037d2305b0cd13a760d29eb5e3b3e6910ef39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0154259811bd5f1487d7e466f7e0c777a8ab20c56975a7a25957466b1b028cbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ac6572ad216425a7740600dbc610641c2f809023337115598c1ec6d50a6bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1deb216bcd09cc0f29c8e03a3162c68ec8c66bd4d59276de7014efbb440484)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a5b2eb0fbbb2d4a02061c9ffb24de3f32ac894ed0c28ac36a84a8a662aaa21)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02bbd86787a05d9f5bcd8f8d07626ae4246292382b5736467c1450ff22b8ff2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4704ad3d16074da4ff22e7fd9aa5e7e4cac5704652ea980222f1d647ed3cb479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf0b2e9e0d4c617ba5b7ef52c29db1e5333ba5c7e5d677035de55fe8d0f71a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c8b19ea6b7c4e8a2815d7b3e0aa48fe92d68e0dde485b5b57a7b8d5fcef77f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f500e77d08d98cd7ed0ce083a794a5046b251d4b901f32338a61be8b7c2ebe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes",
    jsii_struct_bases=[],
    name_mapping={
        "detect_injection": "detectInjection",
        "enabled": "enabled",
        "enable_via_http": "enableViaHttp",
        "i18_n_charset": "i18NCharset",
        "i18_n_status": "i18NStatus",
        "locked": "locked",
        "pass_client_ip": "passClientIp",
        "pass_set_cookie": "passSetCookie",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes:
    def __init__(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7d6e4e3ec39bf91c8677cb682c9ae3b504cd204742137c4ff1955599c69a72)
            check_type(argname="argument detect_injection", value=detect_injection, expected_type=type_hints["detect_injection"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_via_http", value=enable_via_http, expected_type=type_hints["enable_via_http"])
            check_type(argname="argument i18_n_charset", value=i18_n_charset, expected_type=type_hints["i18_n_charset"])
            check_type(argname="argument i18_n_status", value=i18_n_status, expected_type=type_hints["i18_n_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument pass_client_ip", value=pass_client_ip, expected_type=type_hints["pass_client_ip"])
            check_type(argname="argument pass_set_cookie", value=pass_set_cookie, expected_type=type_hints["pass_set_cookie"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if detect_injection is not None:
            self._values["detect_injection"] = detect_injection
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_via_http is not None:
            self._values["enable_via_http"] = enable_via_http
        if i18_n_charset is not None:
            self._values["i18_n_charset"] = i18_n_charset
        if i18_n_status is not None:
            self._values["i18_n_status"] = i18_n_status
        if locked is not None:
            self._values["locked"] = locked
        if pass_client_ip is not None:
            self._values["pass_client_ip"] = pass_client_ip
        if pass_set_cookie is not None:
            self._values["pass_set_cookie"] = pass_set_cookie
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def detect_injection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies attempts to inject ESI code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        '''
        result = self._values.get("detect_injection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ESI processing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_via_http(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        '''
        result = self._values.get("enable_via_http")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def i18_n_charset(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        '''
        result = self._values.get("i18_n_charset")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def i18_n_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Provides internationalization support for ESI.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        '''
        result = self._values.get("i18_n_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass the client IP header to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        '''
        result = self._values.get("pass_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_set_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass your origin server's cookies to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        '''
        result = self._values.get("pass_set_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f406ad43570392798fa949c646b109e0809b48c00298486ecf6a3030e964dbe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDetectInjection")
    def reset_detect_injection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectInjection", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableViaHttp")
    def reset_enable_via_http(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableViaHttp", []))

    @jsii.member(jsii_name="resetI18NCharset")
    def reset_i18_n_charset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NCharset", []))

    @jsii.member(jsii_name="resetI18NStatus")
    def reset_i18_n_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPassClientIp")
    def reset_pass_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassClientIp", []))

    @jsii.member(jsii_name="resetPassSetCookie")
    def reset_pass_set_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassSetCookie", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="detectInjectionInput")
    def detect_injection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectInjectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableViaHttpInput")
    def enable_via_http_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableViaHttpInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NCharsetInput")
    def i18_n_charset_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "i18NCharsetInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NStatusInput")
    def i18_n_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "i18NStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="passClientIpInput")
    def pass_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="passSetCookieInput")
    def pass_set_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passSetCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="detectInjection")
    def detect_injection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectInjection"))

    @detect_injection.setter
    def detect_injection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d830bceda6d1acf9a3e947653721f69924c1404122579b3c8899364dc3138c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectInjection", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e844d43a71bd4d873fdad5e2cecb3330d13bee1d971da9dd4b7826287010987f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableViaHttp")
    def enable_via_http(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableViaHttp"))

    @enable_via_http.setter
    def enable_via_http(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9af91a918860bd3f54e2a59065ae3e32e1f2d80eb235b74d773cc2f4069229d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableViaHttp", value)

    @builtins.property
    @jsii.member(jsii_name="i18NCharset")
    def i18_n_charset(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "i18NCharset"))

    @i18_n_charset.setter
    def i18_n_charset(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c689472a737ca6994e547ff01d8ff8dcf2895349a2b7ba7c645e019eeb28e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NCharset", value)

    @builtins.property
    @jsii.member(jsii_name="i18NStatus")
    def i18_n_status(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "i18NStatus"))

    @i18_n_status.setter
    def i18_n_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838640802d4f4b67404562a8d1209d6b276b2a0ce9ba0c024443fffbfa91d400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f3d78a0b667047c8a5e8d58b35233f1917db8a87f545ff00af9113bf9f1007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="passClientIp")
    def pass_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passClientIp"))

    @pass_client_ip.setter
    def pass_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b408f90c0021116ec95e72468876ebbcc12a1b8ed862d8cf400eb6bdb5f5ec0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="passSetCookie")
    def pass_set_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passSetCookie"))

    @pass_set_cookie.setter
    def pass_set_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a70ab8fceaa1b9453a70dc2e703e4f0875f8b815eff9d26cd5e846b20229c2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passSetCookie", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab00386f2c9308f11c713f279903004a0d3dca38ebe55f31b8144e3a6b1f7ff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2316d85ce204af2cf2f04d97e5f835bf3eb2793aa85af33b9d536a950460e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd72cee467ecc020ad517be78efa3d3cf4204e33994311c17965aa83467e6437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker",
    jsii_struct_bases=[],
    name_mapping={
        "create_edge_worker": "createEdgeWorker",
        "edge_worker_id": "edgeWorkerId",
        "enabled": "enabled",
        "locked": "locked",
        "m_pulse": "mPulse",
        "m_pulse_information": "mPulseInformation",
        "resource_tier": "resourceTier",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker:
    def __init__(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse_information: typing.Optional[builtins.str] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param m_pulse: Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see ``Integrate mPulse reports with EdgeWorkers``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param m_pulse_information: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b3c17cfceb46522a1b1eb3abe7444eb4acb458d497b9aabb6c728a159c3b51)
            check_type(argname="argument create_edge_worker", value=create_edge_worker, expected_type=type_hints["create_edge_worker"])
            check_type(argname="argument edge_worker_id", value=edge_worker_id, expected_type=type_hints["edge_worker_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument m_pulse_information", value=m_pulse_information, expected_type=type_hints["m_pulse_information"])
            check_type(argname="argument resource_tier", value=resource_tier, expected_type=type_hints["resource_tier"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if create_edge_worker is not None:
            self._values["create_edge_worker"] = create_edge_worker
        if edge_worker_id is not None:
            self._values["edge_worker_id"] = edge_worker_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if m_pulse_information is not None:
            self._values["m_pulse_information"] = m_pulse_information
        if resource_tier is not None:
            self._values["resource_tier"] = resource_tier
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def create_edge_worker(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        '''
        result = self._values.get("create_edge_worker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def edge_worker_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the EdgeWorker application to apply to this rule's web traffic.

        You can use the ``EdgeWorkers API`` to get this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        '''
        result = self._values.get("edge_worker_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies specified EdgeWorker functionality to this rule's web traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors.

        For more details, see ``Integrate mPulse reports with EdgeWorkers``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def m_pulse_information(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        '''
        result = self._values.get("m_pulse_information")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resource_tier(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        '''
        result = self._values.get("resource_tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be068696be0417a03fcf2810c7d28c3f1a44e78544f925b126b2b315ac03dbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCreateEdgeWorker")
    def reset_create_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreateEdgeWorker", []))

    @jsii.member(jsii_name="resetEdgeWorkerId")
    def reset_edge_worker_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkerId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetMPulseInformation")
    def reset_m_pulse_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulseInformation", []))

    @jsii.member(jsii_name="resetResourceTier")
    def reset_resource_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceTier", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorkerInput")
    def create_edge_worker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "createEdgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerIdInput")
    def edge_worker_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "edgeWorkerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInformationInput")
    def m_pulse_information_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mPulseInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceTierInput")
    def resource_tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "resourceTierInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorker")
    def create_edge_worker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "createEdgeWorker"))

    @create_edge_worker.setter
    def create_edge_worker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__994b49dd306371f546d68dff35fb7a7c49d20a8c23f8a04ab85d59d973076ffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createEdgeWorker", value)

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerId")
    def edge_worker_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "edgeWorkerId"))

    @edge_worker_id.setter
    def edge_worker_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ec758d67e3dba77957e4398717e76d59e1464ce5bf16110d87e9bd7113ede6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "edgeWorkerId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a20bb644b0b993a1468c67d029aef9d8a20b047dc23af0c3d9ecfc2c9880fc08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5ef4f55d4e4572e982567093fc5d4c6c76dc77bc922ec3d3079b2fe4810e674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mPulse"))

    @m_pulse.setter
    def m_pulse(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacf2e055263f3bacb4ea9a8d0e9b306dcdf00937c62f5ec4ac6d96a0db6cd52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mPulse", value)

    @builtins.property
    @jsii.member(jsii_name="mPulseInformation")
    def m_pulse_information(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mPulseInformation"))

    @m_pulse_information.setter
    def m_pulse_information(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70420d85902f83317353c37a2ded76ada705a67f4276c2c324142ffad5d96acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mPulseInformation", value)

    @builtins.property
    @jsii.member(jsii_name="resourceTier")
    def resource_tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "resourceTier"))

    @resource_tier.setter
    def resource_tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b2263596a06e8f4b35468a61f77e64b12dea371ad2577acd52408c2d0e8a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resourceTier", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__844f47317b1e129731d58dd07d81b6e285822e6bc256b38b59ee5420acc9d497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4449d252455407803aa95ca317ef51cfa570bd99e2eb78de6d246db330ab628e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bbed9d057b58b22e4b9b16ecc199edd423d0ad66a1e8277c3ebfcd91835550c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_authority_set": "certificateAuthoritySet",
        "enable_auth_set": "enableAuthSet",
        "enable_deny_request": "enableDenyRequest",
        "enable_ocsp_status": "enableOcspStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings:
    def __init__(
        self,
        *,
        certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_authority_set: Specify the client certificate authority (CA) sets you want to support in client requests. Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        :param enable_auth_set: Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        :param enable_deny_request: This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        :param enable_ocsp_status: Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62276160005b7d153e6ddd81af5a941776d05e509a408783caa7f5b2b199ee9b)
            check_type(argname="argument certificate_authority_set", value=certificate_authority_set, expected_type=type_hints["certificate_authority_set"])
            check_type(argname="argument enable_auth_set", value=enable_auth_set, expected_type=type_hints["enable_auth_set"])
            check_type(argname="argument enable_deny_request", value=enable_deny_request, expected_type=type_hints["enable_deny_request"])
            check_type(argname="argument enable_ocsp_status", value=enable_ocsp_status, expected_type=type_hints["enable_ocsp_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_authority_set is not None:
            self._values["certificate_authority_set"] = certificate_authority_set
        if enable_auth_set is not None:
            self._values["enable_auth_set"] = enable_auth_set
        if enable_deny_request is not None:
            self._values["enable_deny_request"] = enable_deny_request
        if enable_ocsp_status is not None:
            self._values["enable_ocsp_status"] = enable_ocsp_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_authority_set(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify the client certificate authority (CA) sets you want to support in client requests.

        Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        '''
        result = self._values.get("certificate_authority_set")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_auth_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        '''
        result = self._values.get("enable_auth_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_deny_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This denies a request from a client that doesn't match what you've set for the options in this behavior.

        When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        '''
        result = self._values.get("enable_deny_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ocsp_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP).

        OCSP can determine the x.509 certificate revocation status during the TLS handshake.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        '''
        result = self._values.get("enable_ocsp_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40a6786eb3c13bc894c0a188efb95e0de93880435bd903b3c41bd9e568a71e8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateAuthoritySet")
    def reset_certificate_authority_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateAuthoritySet", []))

    @jsii.member(jsii_name="resetEnableAuthSet")
    def reset_enable_auth_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAuthSet", []))

    @jsii.member(jsii_name="resetEnableDenyRequest")
    def reset_enable_deny_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableDenyRequest", []))

    @jsii.member(jsii_name="resetEnableOcspStatus")
    def reset_enable_ocsp_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableOcspStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateAuthoritySetInput")
    def certificate_authority_set_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "certificateAuthoritySetInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAuthSetInput")
    def enable_auth_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAuthSetInput"))

    @builtins.property
    @jsii.member(jsii_name="enableDenyRequestInput")
    def enable_deny_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableDenyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="enableOcspStatusInput")
    def enable_ocsp_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableOcspStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateAuthoritySet")
    def certificate_authority_set(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "certificateAuthoritySet"))

    @certificate_authority_set.setter
    def certificate_authority_set(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0afef3feace8621bf80c0a6cde18303e948ec14068656d7d835b04bc9ff502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateAuthoritySet", value)

    @builtins.property
    @jsii.member(jsii_name="enableAuthSet")
    def enable_auth_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAuthSet"))

    @enable_auth_set.setter
    def enable_auth_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8c3102f647a7f259db61e1bd432b821b09fd3f5f4c2e47fdefb4b91e47b7ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAuthSet", value)

    @builtins.property
    @jsii.member(jsii_name="enableDenyRequest")
    def enable_deny_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableDenyRequest"))

    @enable_deny_request.setter
    def enable_deny_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed124e3c383d7416f27b4fb3c2091cf879a37e96d4921cf5a2b72a5fd39fe087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableDenyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="enableOcspStatus")
    def enable_ocsp_status(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableOcspStatus"))

    @enable_ocsp_status.setter
    def enable_ocsp_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0be12832dc9a4e9b31cb3b7ee3f9b4da900439f0502c98b45b8ff6f851a70ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableOcspStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884998326116fb8a82aa38ac231c42698f5315710304faa37201ca0ba08fdf55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87fd3214933bc4db18687f263ff8868274d905a942724954c01f406f995f64fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5fc421e6c3077a4ccf1ed0104a9cbd4ea2c31cd905e69f86d81bc82d6fa4b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa625270a57850308b8f1c51665e5aa2d6405850cb674906a00dde9d25c9c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e7352441b734ec55c1805a2a86639c313719f6d8d6bcacf1a8e0ae41fa2f7fe)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7a53f699441eb7f3614c4e6b1a42822171bbef9572ccd6ae7a09ba0c54ff94f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ec84addf90d32195424ef2605184c426a26e8d0f344312a8bccc394f432418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e88ab326a334d932809e93addf8a48d63ca18cc2e146b4c6efe7a41c72f44c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__990843715bed5f764ed3568e666c86d41b56a6b01ffe03647ef0b5c91f7dec86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b865f8d9950b332bf1156a7cbd3d43c5d8042f50ead1b6060072e9aa893e2c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa1b097ba4aa96032545c0ba947689f86405beb3000cfb39461848484e742e2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous_vpn": "anonymousVpn",
        "best_practice_action": "bestPracticeAction",
        "best_practice_redirecturl": "bestPracticeRedirecturl",
        "detect_anonymous_vpn": "detectAnonymousVpn",
        "detect_anonymous_vpn_action": "detectAnonymousVpnAction",
        "detect_anonymous_vpn_redirecturl": "detectAnonymousVpnRedirecturl",
        "detect_hosting_provider": "detectHostingProvider",
        "detect_hosting_provider_action": "detectHostingProviderAction",
        "detect_hosting_provider_redirecturl": "detectHostingProviderRedirecturl",
        "detect_public_proxy": "detectPublicProxy",
        "detect_public_proxy_action": "detectPublicProxyAction",
        "detect_public_proxy_redirecturl": "detectPublicProxyRedirecturl",
        "detect_residential_proxy": "detectResidentialProxy",
        "detect_residential_proxy_action": "detectResidentialProxyAction",
        "detect_residential_proxy_redirecturl": "detectResidentialProxyRedirecturl",
        "detect_smart_dns_proxy": "detectSmartDnsProxy",
        "detect_smart_dns_proxy_action": "detectSmartDnsProxyAction",
        "detect_smart_dns_proxy_redirecturl": "detectSmartDnsProxyRedirecturl",
        "detect_tor_exit_node": "detectTorExitNode",
        "detect_tor_exit_node_action": "detectTorExitNodeAction",
        "detect_tor_exit_node_redirecturl": "detectTorExitNodeRedirecturl",
        "detect_vpn_data_center": "detectVpnDataCenter",
        "detect_vpn_data_center_action": "detectVpnDataCenterAction",
        "detect_vpn_data_center_redirecturl": "detectVpnDataCenterRedirecturl",
        "enable_configuration_mode": "enableConfigurationMode",
        "enabled": "enabled",
        "forward_header_enrichment": "forwardHeaderEnrichment",
        "hosting_provider": "hostingProvider",
        "locked": "locked",
        "public_proxy": "publicProxy",
        "residential_proxy": "residentialProxy",
        "smart_dns_proxy": "smartDnsProxy",
        "template_uuid": "templateUuid",
        "tor_exit_node": "torExitNode",
        "uuid": "uuid",
        "vpn_data_center": "vpnDataCenter",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection:
    def __init__(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78aacab00b796e56abfd335db49f94be22396fb99d9220295651f4e6eac0a7fb)
            check_type(argname="argument anonymous_vpn", value=anonymous_vpn, expected_type=type_hints["anonymous_vpn"])
            check_type(argname="argument best_practice_action", value=best_practice_action, expected_type=type_hints["best_practice_action"])
            check_type(argname="argument best_practice_redirecturl", value=best_practice_redirecturl, expected_type=type_hints["best_practice_redirecturl"])
            check_type(argname="argument detect_anonymous_vpn", value=detect_anonymous_vpn, expected_type=type_hints["detect_anonymous_vpn"])
            check_type(argname="argument detect_anonymous_vpn_action", value=detect_anonymous_vpn_action, expected_type=type_hints["detect_anonymous_vpn_action"])
            check_type(argname="argument detect_anonymous_vpn_redirecturl", value=detect_anonymous_vpn_redirecturl, expected_type=type_hints["detect_anonymous_vpn_redirecturl"])
            check_type(argname="argument detect_hosting_provider", value=detect_hosting_provider, expected_type=type_hints["detect_hosting_provider"])
            check_type(argname="argument detect_hosting_provider_action", value=detect_hosting_provider_action, expected_type=type_hints["detect_hosting_provider_action"])
            check_type(argname="argument detect_hosting_provider_redirecturl", value=detect_hosting_provider_redirecturl, expected_type=type_hints["detect_hosting_provider_redirecturl"])
            check_type(argname="argument detect_public_proxy", value=detect_public_proxy, expected_type=type_hints["detect_public_proxy"])
            check_type(argname="argument detect_public_proxy_action", value=detect_public_proxy_action, expected_type=type_hints["detect_public_proxy_action"])
            check_type(argname="argument detect_public_proxy_redirecturl", value=detect_public_proxy_redirecturl, expected_type=type_hints["detect_public_proxy_redirecturl"])
            check_type(argname="argument detect_residential_proxy", value=detect_residential_proxy, expected_type=type_hints["detect_residential_proxy"])
            check_type(argname="argument detect_residential_proxy_action", value=detect_residential_proxy_action, expected_type=type_hints["detect_residential_proxy_action"])
            check_type(argname="argument detect_residential_proxy_redirecturl", value=detect_residential_proxy_redirecturl, expected_type=type_hints["detect_residential_proxy_redirecturl"])
            check_type(argname="argument detect_smart_dns_proxy", value=detect_smart_dns_proxy, expected_type=type_hints["detect_smart_dns_proxy"])
            check_type(argname="argument detect_smart_dns_proxy_action", value=detect_smart_dns_proxy_action, expected_type=type_hints["detect_smart_dns_proxy_action"])
            check_type(argname="argument detect_smart_dns_proxy_redirecturl", value=detect_smart_dns_proxy_redirecturl, expected_type=type_hints["detect_smart_dns_proxy_redirecturl"])
            check_type(argname="argument detect_tor_exit_node", value=detect_tor_exit_node, expected_type=type_hints["detect_tor_exit_node"])
            check_type(argname="argument detect_tor_exit_node_action", value=detect_tor_exit_node_action, expected_type=type_hints["detect_tor_exit_node_action"])
            check_type(argname="argument detect_tor_exit_node_redirecturl", value=detect_tor_exit_node_redirecturl, expected_type=type_hints["detect_tor_exit_node_redirecturl"])
            check_type(argname="argument detect_vpn_data_center", value=detect_vpn_data_center, expected_type=type_hints["detect_vpn_data_center"])
            check_type(argname="argument detect_vpn_data_center_action", value=detect_vpn_data_center_action, expected_type=type_hints["detect_vpn_data_center_action"])
            check_type(argname="argument detect_vpn_data_center_redirecturl", value=detect_vpn_data_center_redirecturl, expected_type=type_hints["detect_vpn_data_center_redirecturl"])
            check_type(argname="argument enable_configuration_mode", value=enable_configuration_mode, expected_type=type_hints["enable_configuration_mode"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_header_enrichment", value=forward_header_enrichment, expected_type=type_hints["forward_header_enrichment"])
            check_type(argname="argument hosting_provider", value=hosting_provider, expected_type=type_hints["hosting_provider"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument public_proxy", value=public_proxy, expected_type=type_hints["public_proxy"])
            check_type(argname="argument residential_proxy", value=residential_proxy, expected_type=type_hints["residential_proxy"])
            check_type(argname="argument smart_dns_proxy", value=smart_dns_proxy, expected_type=type_hints["smart_dns_proxy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tor_exit_node", value=tor_exit_node, expected_type=type_hints["tor_exit_node"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument vpn_data_center", value=vpn_data_center, expected_type=type_hints["vpn_data_center"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous_vpn is not None:
            self._values["anonymous_vpn"] = anonymous_vpn
        if best_practice_action is not None:
            self._values["best_practice_action"] = best_practice_action
        if best_practice_redirecturl is not None:
            self._values["best_practice_redirecturl"] = best_practice_redirecturl
        if detect_anonymous_vpn is not None:
            self._values["detect_anonymous_vpn"] = detect_anonymous_vpn
        if detect_anonymous_vpn_action is not None:
            self._values["detect_anonymous_vpn_action"] = detect_anonymous_vpn_action
        if detect_anonymous_vpn_redirecturl is not None:
            self._values["detect_anonymous_vpn_redirecturl"] = detect_anonymous_vpn_redirecturl
        if detect_hosting_provider is not None:
            self._values["detect_hosting_provider"] = detect_hosting_provider
        if detect_hosting_provider_action is not None:
            self._values["detect_hosting_provider_action"] = detect_hosting_provider_action
        if detect_hosting_provider_redirecturl is not None:
            self._values["detect_hosting_provider_redirecturl"] = detect_hosting_provider_redirecturl
        if detect_public_proxy is not None:
            self._values["detect_public_proxy"] = detect_public_proxy
        if detect_public_proxy_action is not None:
            self._values["detect_public_proxy_action"] = detect_public_proxy_action
        if detect_public_proxy_redirecturl is not None:
            self._values["detect_public_proxy_redirecturl"] = detect_public_proxy_redirecturl
        if detect_residential_proxy is not None:
            self._values["detect_residential_proxy"] = detect_residential_proxy
        if detect_residential_proxy_action is not None:
            self._values["detect_residential_proxy_action"] = detect_residential_proxy_action
        if detect_residential_proxy_redirecturl is not None:
            self._values["detect_residential_proxy_redirecturl"] = detect_residential_proxy_redirecturl
        if detect_smart_dns_proxy is not None:
            self._values["detect_smart_dns_proxy"] = detect_smart_dns_proxy
        if detect_smart_dns_proxy_action is not None:
            self._values["detect_smart_dns_proxy_action"] = detect_smart_dns_proxy_action
        if detect_smart_dns_proxy_redirecturl is not None:
            self._values["detect_smart_dns_proxy_redirecturl"] = detect_smart_dns_proxy_redirecturl
        if detect_tor_exit_node is not None:
            self._values["detect_tor_exit_node"] = detect_tor_exit_node
        if detect_tor_exit_node_action is not None:
            self._values["detect_tor_exit_node_action"] = detect_tor_exit_node_action
        if detect_tor_exit_node_redirecturl is not None:
            self._values["detect_tor_exit_node_redirecturl"] = detect_tor_exit_node_redirecturl
        if detect_vpn_data_center is not None:
            self._values["detect_vpn_data_center"] = detect_vpn_data_center
        if detect_vpn_data_center_action is not None:
            self._values["detect_vpn_data_center_action"] = detect_vpn_data_center_action
        if detect_vpn_data_center_redirecturl is not None:
            self._values["detect_vpn_data_center_redirecturl"] = detect_vpn_data_center_redirecturl
        if enable_configuration_mode is not None:
            self._values["enable_configuration_mode"] = enable_configuration_mode
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_header_enrichment is not None:
            self._values["forward_header_enrichment"] = forward_header_enrichment
        if hosting_provider is not None:
            self._values["hosting_provider"] = hosting_provider
        if locked is not None:
            self._values["locked"] = locked
        if public_proxy is not None:
            self._values["public_proxy"] = public_proxy
        if residential_proxy is not None:
            self._values["residential_proxy"] = residential_proxy
        if smart_dns_proxy is not None:
            self._values["smart_dns_proxy"] = smart_dns_proxy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tor_exit_node is not None:
            self._values["tor_exit_node"] = tor_exit_node
        if uuid is not None:
            self._values["uuid"] = uuid
        if vpn_data_center is not None:
            self._values["vpn_data_center"] = vpn_data_center

    @builtins.property
    def anonymous_vpn(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        '''
        result = self._values.get("anonymous_vpn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        '''
        result = self._values.get("best_practice_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        '''
        result = self._values.get("best_practice_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from anonymous VPNs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        '''
        result = self._values.get("detect_anonymous_vpn")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_anonymous_vpn_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        '''
        result = self._values.get("detect_anonymous_vpn_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        '''
        result = self._values.get("detect_anonymous_vpn_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This detects requests from a hosting provider.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        '''
        result = self._values.get("detect_hosting_provider")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_hosting_provider_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        '''
        result = self._values.get("detect_hosting_provider_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the absolute URL to which to redirect requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        '''
        result = self._values.get("detect_hosting_provider_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from public proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        '''
        result = self._values.get("detect_public_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_public_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        '''
        result = self._values.get("detect_public_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        '''
        result = self._values.get("detect_public_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from a residential proxy.

        See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        '''
        result = self._values.get("detect_residential_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_residential_proxy_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        '''
        result = self._values.get("detect_residential_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        '''
        result = self._values.get("detect_residential_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from smart DNS proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        '''
        result = self._values.get("detect_smart_dns_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_smart_dns_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        '''
        result = self._values.get("detect_smart_dns_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        '''
        result = self._values.get("detect_smart_dns_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        '''
        result = self._values.get("detect_tor_exit_node")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_tor_exit_node_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        '''
        result = self._values.get("detect_tor_exit_node_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        '''
        result = self._values.get("detect_tor_exit_node_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        '''
        result = self._values.get("detect_vpn_data_center")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_vpn_data_center_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        '''
        result = self._values.get("detect_vpn_data_center_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        '''
        result = self._values.get("detect_vpn_data_center_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_configuration_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        '''
        result = self._values.get("enable_configuration_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies GeoGuard proxy detection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_header_enrichment(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation.

        See the ``epdForwardHeaderEnrichment`` behavior for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        '''
        result = self._values.get("forward_header_enrichment")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hosting_provider(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        '''
        result = self._values.get("hosting_provider")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def public_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        '''
        result = self._values.get("public_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def residential_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        '''
        result = self._values.get("residential_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smart_dns_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        '''
        result = self._values.get("smart_dns_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tor_exit_node(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        '''
        result = self._values.get("tor_exit_node")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vpn_data_center(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        result = self._values.get("vpn_data_center")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a790537fe6f1be1e6a902f261003dde8258987fbdd6f13ac48812257bfd328ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymousVpn")
    def reset_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymousVpn", []))

    @jsii.member(jsii_name="resetBestPracticeAction")
    def reset_best_practice_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeAction", []))

    @jsii.member(jsii_name="resetBestPracticeRedirecturl")
    def reset_best_practice_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpn")
    def reset_detect_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpn", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnAction")
    def reset_detect_anonymous_vpn_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnAction", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnRedirecturl")
    def reset_detect_anonymous_vpn_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnRedirecturl", []))

    @jsii.member(jsii_name="resetDetectHostingProvider")
    def reset_detect_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProvider", []))

    @jsii.member(jsii_name="resetDetectHostingProviderAction")
    def reset_detect_hosting_provider_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderAction", []))

    @jsii.member(jsii_name="resetDetectHostingProviderRedirecturl")
    def reset_detect_hosting_provider_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderRedirecturl", []))

    @jsii.member(jsii_name="resetDetectPublicProxy")
    def reset_detect_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxy", []))

    @jsii.member(jsii_name="resetDetectPublicProxyAction")
    def reset_detect_public_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyAction", []))

    @jsii.member(jsii_name="resetDetectPublicProxyRedirecturl")
    def reset_detect_public_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectResidentialProxy")
    def reset_detect_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxy", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyAction")
    def reset_detect_residential_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyAction", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyRedirecturl")
    def reset_detect_residential_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxy")
    def reset_detect_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxy", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyAction")
    def reset_detect_smart_dns_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyAction", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyRedirecturl")
    def reset_detect_smart_dns_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectTorExitNode")
    def reset_detect_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNode", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeAction")
    def reset_detect_tor_exit_node_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeAction", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeRedirecturl")
    def reset_detect_tor_exit_node_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenter")
    def reset_detect_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenter", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterAction")
    def reset_detect_vpn_data_center_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterAction", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterRedirecturl")
    def reset_detect_vpn_data_center_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterRedirecturl", []))

    @jsii.member(jsii_name="resetEnableConfigurationMode")
    def reset_enable_configuration_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableConfigurationMode", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardHeaderEnrichment")
    def reset_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetHostingProvider")
    def reset_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostingProvider", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPublicProxy")
    def reset_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicProxy", []))

    @jsii.member(jsii_name="resetResidentialProxy")
    def reset_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResidentialProxy", []))

    @jsii.member(jsii_name="resetSmartDnsProxy")
    def reset_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmartDnsProxy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTorExitNode")
    def reset_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTorExitNode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVpnDataCenter")
    def reset_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVpnDataCenter", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpnInput")
    def anonymous_vpn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "anonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeActionInput")
    def best_practice_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturlInput")
    def best_practice_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnActionInput")
    def detect_anonymous_vpn_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnInput")
    def detect_anonymous_vpn_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectAnonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturlInput")
    def detect_anonymous_vpn_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderActionInput")
    def detect_hosting_provider_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderInput")
    def detect_hosting_provider_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectHostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturlInput")
    def detect_hosting_provider_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyActionInput")
    def detect_public_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyInput")
    def detect_public_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectPublicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturlInput")
    def detect_public_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyActionInput")
    def detect_residential_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyInput")
    def detect_residential_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectResidentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturlInput")
    def detect_residential_proxy_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyActionInput")
    def detect_smart_dns_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyInput")
    def detect_smart_dns_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectSmartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturlInput")
    def detect_smart_dns_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeActionInput")
    def detect_tor_exit_node_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeInput")
    def detect_tor_exit_node_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectTorExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturlInput")
    def detect_tor_exit_node_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterActionInput")
    def detect_vpn_data_center_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterInput")
    def detect_vpn_data_center_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectVpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturlInput")
    def detect_vpn_data_center_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationModeInput")
    def enable_configuration_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enableConfigurationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichmentInput")
    def forward_header_enrichment_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="hostingProviderInput")
    def hosting_provider_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="publicProxyInput")
    def public_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="residentialProxyInput")
    def residential_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "residentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxyInput")
    def smart_dns_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "smartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="torExitNodeInput")
    def tor_exit_node_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "torExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenterInput")
    def vpn_data_center_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "vpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpn")
    def anonymous_vpn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "anonymousVpn"))

    @anonymous_vpn.setter
    def anonymous_vpn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a8349074dc871a35900fe4e64f8b768538f0800c1a4ae96d71bc1df56a6df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeAction")
    def best_practice_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeAction"))

    @best_practice_action.setter
    def best_practice_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42be15746dc7fe72e2323ef3e2ae3ae3631a84ab46bab81a4861418ef9ea359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeAction", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturl")
    def best_practice_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeRedirecturl"))

    @best_practice_redirecturl.setter
    def best_practice_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36fd9fec2d79117358b2319711ad3acc5ce369be610301b2201e70e8728880a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpn")
    def detect_anonymous_vpn(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectAnonymousVpn"))

    @detect_anonymous_vpn.setter
    def detect_anonymous_vpn(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210446837c3505e661d8b77d199595509713586be047da22d50a4a9d382e177c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnAction")
    def detect_anonymous_vpn_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnAction"))

    @detect_anonymous_vpn_action.setter
    def detect_anonymous_vpn_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6747f409ae076234f85c8672e520046c43443546be335a398654734fb7c455e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturl")
    def detect_anonymous_vpn_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnRedirecturl"))

    @detect_anonymous_vpn_redirecturl.setter
    def detect_anonymous_vpn_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf4900195dc19e0f7878b4614a80ae2b38848844bb924b74e272731b4c6931e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProvider")
    def detect_hosting_provider(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectHostingProvider"))

    @detect_hosting_provider.setter
    def detect_hosting_provider(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f861dda54397a3ad91bed60ead5f4d7c30873634cae4f675d4e412e094f241f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderAction")
    def detect_hosting_provider_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderAction"))

    @detect_hosting_provider_action.setter
    def detect_hosting_provider_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16a81290188e4f583988b0b4dca9f6ed62df2a38c5028245985897e3f4c51bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturl")
    def detect_hosting_provider_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderRedirecturl"))

    @detect_hosting_provider_redirecturl.setter
    def detect_hosting_provider_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07218f5d0fbc9ef8ffda0aad36ade395b29c474642bc1d53fc81007f5bb8e16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxy")
    def detect_public_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectPublicProxy"))

    @detect_public_proxy.setter
    def detect_public_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9b7ae8c6802ca43404a5fe8c6b92fb48f2faf2d5aa1f858880fa87654d5651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyAction")
    def detect_public_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyAction"))

    @detect_public_proxy_action.setter
    def detect_public_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9601f766e2b8497cfcb0a24116cfb147062427b05d1731422bd6c2ba4934858b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturl")
    def detect_public_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyRedirecturl"))

    @detect_public_proxy_redirecturl.setter
    def detect_public_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c02e639e79b87b80a9967ade053e40466c0eea0e3e0a7b24430257280b90726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxy")
    def detect_residential_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectResidentialProxy"))

    @detect_residential_proxy.setter
    def detect_residential_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc33514ffb758e4a226c55162e57b73d10290e91a9ecba4ca5509235cacfed40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyAction")
    def detect_residential_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyAction"))

    @detect_residential_proxy_action.setter
    def detect_residential_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fd1b3f94262bbe2ae8d339b8f831b07fe0b63253b158b764cd105015f1124bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturl")
    def detect_residential_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyRedirecturl"))

    @detect_residential_proxy_redirecturl.setter
    def detect_residential_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae8a3cd2009035e73fc5b7e319d3fcbf01b1e8479a75429d438818b0f17416b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxy")
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectSmartDnsProxy"))

    @detect_smart_dns_proxy.setter
    def detect_smart_dns_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626f0ecedb70abe2aabb063861d8dcf0d1460856e88ab080f0ca550f598b4a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyAction")
    def detect_smart_dns_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyAction"))

    @detect_smart_dns_proxy_action.setter
    def detect_smart_dns_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__939ddeefcb09633d0ff62b735e7c0f493d8ba39988d8df1166b16884af821e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturl")
    def detect_smart_dns_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyRedirecturl"))

    @detect_smart_dns_proxy_redirecturl.setter
    def detect_smart_dns_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8de439871637f8563f592bd8bdbe882665541e84a059a832a3e4006fd1917b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNode")
    def detect_tor_exit_node(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectTorExitNode"))

    @detect_tor_exit_node.setter
    def detect_tor_exit_node(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf2da0f645756b8e316ef9c61bfe7fe01ab35fbbb2ba88fa16d3a5c2ce212fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeAction")
    def detect_tor_exit_node_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeAction"))

    @detect_tor_exit_node_action.setter
    def detect_tor_exit_node_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1344b10f31b065a606738ff01f84136d8b2b866e3c775a871bf8c6f67324539f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturl")
    def detect_tor_exit_node_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeRedirecturl"))

    @detect_tor_exit_node_redirecturl.setter
    def detect_tor_exit_node_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fa55e48972e79e3d8576f581352689f581e973e3b0ff1e48f1392f955450b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenter")
    def detect_vpn_data_center(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectVpnDataCenter"))

    @detect_vpn_data_center.setter
    def detect_vpn_data_center(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4009959f02924899c33a4172cd6f2dd1ea167b5cea214c32c459ee2e141df7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterAction")
    def detect_vpn_data_center_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterAction"))

    @detect_vpn_data_center_action.setter
    def detect_vpn_data_center_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f3d99b97016d39dde1d862de6e5039df07f56cf7196690bb63442b1eda9d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturl")
    def detect_vpn_data_center_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterRedirecturl"))

    @detect_vpn_data_center_redirecturl.setter
    def detect_vpn_data_center_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c3cd8f6f6f8cde9a4464ed1eebb96a5ba86d429987c3482d8111c4e1a487ca2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationMode")
    def enable_configuration_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enableConfigurationMode"))

    @enable_configuration_mode.setter
    def enable_configuration_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b29b381863084116b9ef1077b4c434486b6dcbfe867e53fc991b845b596247c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableConfigurationMode", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbe54f917e105f43929cfc23a06638cebd8397284e211b944d3ca5809ece598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichment")
    def forward_header_enrichment(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forwardHeaderEnrichment"))

    @forward_header_enrichment.setter
    def forward_header_enrichment(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0ba41450cc5adbc8bf1305adeae7b63b98d5b7b91c5ee43851923ea6fc258a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHeaderEnrichment", value)

    @builtins.property
    @jsii.member(jsii_name="hostingProvider")
    def hosting_provider(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostingProvider"))

    @hosting_provider.setter
    def hosting_provider(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb2f55f434cf7fcfeb1c0a3b75e5e38dab190ee44ade2d6fb160db7d0d73c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0e20b7775a2ac04be3922dc0d3830aaf1cc085bfd80565ec1e178a880ac351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="publicProxy")
    def public_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicProxy"))

    @public_proxy.setter
    def public_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657283a4c4258c8e5f8c8f48a52435538cd1f7c9b978620b5f47bbddcb721b31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="residentialProxy")
    def residential_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "residentialProxy"))

    @residential_proxy.setter
    def residential_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e3ddc51ed5757c183129488fc2dffb753b62f9eac16e461b200eb20d75a140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "residentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxy")
    def smart_dns_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "smartDnsProxy"))

    @smart_dns_proxy.setter
    def smart_dns_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d13ef623fd4806fdd293c444abaf444d4864f326c9b70d55e3334211b09b7fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef89746c1c6497fa244a48f2c6b8248b703a5d892b0d1a4fdba6ac97bdefca80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="torExitNode")
    def tor_exit_node(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "torExitNode"))

    @tor_exit_node.setter
    def tor_exit_node(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02ffa94fa9db61876bdf2cf932a25503b820496042256a46f30d6eb9ca07e021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "torExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8394e393c45d8ffd5e365d4afab5afbc33cc27e55321145c1d04c0ab49412619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenter")
    def vpn_data_center(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vpnDataCenter"))

    @vpn_data_center.setter
    def vpn_data_center(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e0e11e0f60898eabca3d65bb7963ea621c7df90c8d163e08cbfb1a220eb75b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c825ae2db172079bc796e2ddca86145ca99694299bca57387c3a4c31ccfd8867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d54624903716d65c6f21761e69570e475466bb03f773dcf53a8d87964ee204a7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy.

        The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dfadf66cc54ee72ea8265a72eec897e4613c5d200d946d6b0cc967dc76a4065)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b710f0258133607ed2fe06150b7492daffede44ac31e139e2889ec068d2d210d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdec431717b731b4f96a9250b45d2d18dfb44c92048277c035f6ba1feeaf8087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57fc0d2404c84582f774087cf9e864a2c1c7d6b9f7d549af210c82ad46e1a81c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7c7c272a83b4c51e9e3360e59995dcd14dafe759ea22c8fcf4485e0cb7d204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f61d9cffcb2338c97c1b2fc0145280a8233545efb7d815877ebf09d3f7980a35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction",
    jsii_struct_bases=[],
    name_mapping={
        "action_type": "actionType",
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "cex_custom_path": "cexCustomPath",
        "cex_hostname": "cexHostname",
        "cex_path": "cexPath",
        "content_custom_path": "contentCustomPath",
        "content_hostname": "contentHostname",
        "content_path": "contentPath",
        "cp_code": "cpCode",
        "dynamic_custom_path": "dynamicCustomPath",
        "dynamic_method": "dynamicMethod",
        "dynamic_path": "dynamicPath",
        "enabled": "enabled",
        "locked": "locked",
        "modify_protocol": "modifyProtocol",
        "net_storage_hostname": "netStorageHostname",
        "net_storage_path": "netStoragePath",
        "preserve_query_string": "preserveQueryString",
        "protocol": "protocol",
        "redirect_custom_path": "redirectCustomPath",
        "redirect_hostname": "redirectHostname",
        "redirect_hostname_type": "redirectHostnameType",
        "redirect_method": "redirectMethod",
        "redirect_path": "redirectPath",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction:
    def __init__(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode(**cp_code)
        if isinstance(net_storage_hostname, dict):
            net_storage_hostname = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname(**net_storage_hostname)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__449548d308c9e33b81bf09f839ac8cb61de7065fb00df477440a7c497f4a3757)
            check_type(argname="argument action_type", value=action_type, expected_type=type_hints["action_type"])
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument cex_custom_path", value=cex_custom_path, expected_type=type_hints["cex_custom_path"])
            check_type(argname="argument cex_hostname", value=cex_hostname, expected_type=type_hints["cex_hostname"])
            check_type(argname="argument cex_path", value=cex_path, expected_type=type_hints["cex_path"])
            check_type(argname="argument content_custom_path", value=content_custom_path, expected_type=type_hints["content_custom_path"])
            check_type(argname="argument content_hostname", value=content_hostname, expected_type=type_hints["content_hostname"])
            check_type(argname="argument content_path", value=content_path, expected_type=type_hints["content_path"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument dynamic_custom_path", value=dynamic_custom_path, expected_type=type_hints["dynamic_custom_path"])
            check_type(argname="argument dynamic_method", value=dynamic_method, expected_type=type_hints["dynamic_method"])
            check_type(argname="argument dynamic_path", value=dynamic_path, expected_type=type_hints["dynamic_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_protocol", value=modify_protocol, expected_type=type_hints["modify_protocol"])
            check_type(argname="argument net_storage_hostname", value=net_storage_hostname, expected_type=type_hints["net_storage_hostname"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument preserve_query_string", value=preserve_query_string, expected_type=type_hints["preserve_query_string"])
            check_type(argname="argument protocol", value=protocol, expected_type=type_hints["protocol"])
            check_type(argname="argument redirect_custom_path", value=redirect_custom_path, expected_type=type_hints["redirect_custom_path"])
            check_type(argname="argument redirect_hostname", value=redirect_hostname, expected_type=type_hints["redirect_hostname"])
            check_type(argname="argument redirect_hostname_type", value=redirect_hostname_type, expected_type=type_hints["redirect_hostname_type"])
            check_type(argname="argument redirect_method", value=redirect_method, expected_type=type_hints["redirect_method"])
            check_type(argname="argument redirect_path", value=redirect_path, expected_type=type_hints["redirect_path"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action_type is not None:
            self._values["action_type"] = action_type
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if cex_custom_path is not None:
            self._values["cex_custom_path"] = cex_custom_path
        if cex_hostname is not None:
            self._values["cex_hostname"] = cex_hostname
        if cex_path is not None:
            self._values["cex_path"] = cex_path
        if content_custom_path is not None:
            self._values["content_custom_path"] = content_custom_path
        if content_hostname is not None:
            self._values["content_hostname"] = content_hostname
        if content_path is not None:
            self._values["content_path"] = content_path
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if dynamic_custom_path is not None:
            self._values["dynamic_custom_path"] = dynamic_custom_path
        if dynamic_method is not None:
            self._values["dynamic_method"] = dynamic_method
        if dynamic_path is not None:
            self._values["dynamic_path"] = dynamic_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modify_protocol is not None:
            self._values["modify_protocol"] = modify_protocol
        if net_storage_hostname is not None:
            self._values["net_storage_hostname"] = net_storage_hostname
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if preserve_query_string is not None:
            self._values["preserve_query_string"] = preserve_query_string
        if protocol is not None:
            self._values["protocol"] = protocol
        if redirect_custom_path is not None:
            self._values["redirect_custom_path"] = redirect_custom_path
        if redirect_hostname is not None:
            self._values["redirect_hostname"] = redirect_hostname
        if redirect_hostname_type is not None:
            self._values["redirect_hostname_type"] = redirect_hostname_type
        if redirect_method is not None:
            self._values["redirect_method"] = redirect_method
        if redirect_path is not None:
            self._values["redirect_path"] = redirect_path
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the basic action to take when there is a failure to contact the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        '''
        result = self._values.get("action_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        '''
        result = self._values.get("cex_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies a hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        '''
        result = self._values.get("cex_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cex_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        '''
        result = self._values.get("cex_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        '''
        result = self._values.get("content_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the static hostname for the alternate redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        '''
        result = self._values.get("content_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        '''
        result = self._values.get("content_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode"], result)

    @builtins.property
    def dynamic_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the original requested path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        '''
        result = self._values.get("dynamic_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        '''
        result = self._values.get("dynamic_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dynamic_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        '''
        result = self._values.get("dynamic_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled in case of a failure to contact the origin, the current behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the redirect's protocol using the value of the ``protocol`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        '''
        result = self._values.get("modify_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage_hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname"]:
        '''net_storage_hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        '''
        result = self._values.get("net_storage_hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        '''
        result = self._values.get("preserve_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def protocol(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        '''
        result = self._values.get("protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses the ``redirectPath`` to customize a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        '''
        result = self._values.get("redirect_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_hostname(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        '''
        result = self._values.get("redirect_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_hostname_type(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve or customize the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        '''
        result = self._values.get("redirect_hostname_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        '''
        result = self._values.get("redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def redirect_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        '''
        result = self._values.get("redirect_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement pattern that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static portion of the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Identifies the component of the request that identifies the SaaS dynamic fail action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns a new HTTP status code to the failure response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def2d452c59ecbb330ebd6be7c2cf96643678ab05b3711e8780d6ed05e608769)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fadddfde6b69b8c40aadb738d1103a60bd55ab5f3c5d7427cb418d3e2e83d98)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8e788f8354f915767ce85887d8475dc9d26a12ed87272c5ab62bda0cfcbaec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328b5ddc1bdf1723679fd45d264ac2cd2dc5f0b5e46176f6696206ccaa27523a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33240f8502e25898079b09349b437c53c400b926730c28de6d6bbd01455e7ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20dd468cd6a360ea6ef0fcb61921bcb476f32acd899cbefe75c6e8f8eaf7a33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__101011ebf0ac5978caf664432ce4a94cec9fc1328e81561072f045852dd61b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815488d5e81b6fc60b31e97af06680bee33ba13e3d44e34fa286892a0f7627a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556e0920efeac432a09dde6bcca3d649032b1287d9d3f2cda8faa84967703244)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa70aae68c06a5d5f9200c5fb907dbf048a6aa1ef77fbe187cc489443e085bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c04bddac96ada259050a5ef1bed99b72f22bb1c7ce565fd4056612f7839fa2a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06bbfbb1ebeb46afdc9657f95cc11c72e8ff761a9302b5f030a14e6cccb4aa6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc94c034dcf0fa71c231446ec69f466b6d1e3b1e52ca736e25a100400538c34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3e5b04fc684958aeafaf049e16d350aada968526591962105f8d7af015ea53f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fdcda56c49277466266f8bf50f06768c14f09b3eb8585aaba4c629a0a21323f)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae6fcc6bd9b31d2d6b92f04e8db1e5572755bccacce4d87f1f41964d89019ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887a1c65b9a113ee575e1558e477e5ce42fad7128adcfb7d05ff6f6eb497a428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a23472c5b451d824001688fad3993da2969a641f0d39cc9fdad847d1641f0086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77750fa8112953e99f5e02252e6db93dfabdc91dc76149a8d9b58dee68168442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3668373af10746c9e4b3b0dc1f6b7bbd3ac1006e1766a136154bf50af20fea82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b61f2de2b3dd0328f4267efb367771210b86d7d96e5565a5c2cc11720945f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value]))

    @jsii.member(jsii_name="putNetStorageHostname")
    def put_net_storage_hostname(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorageHostname", [value]))

    @jsii.member(jsii_name="resetActionType")
    def reset_action_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetActionType", []))

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCexCustomPath")
    def reset_cex_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexCustomPath", []))

    @jsii.member(jsii_name="resetCexHostname")
    def reset_cex_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexHostname", []))

    @jsii.member(jsii_name="resetCexPath")
    def reset_cex_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexPath", []))

    @jsii.member(jsii_name="resetContentCustomPath")
    def reset_content_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCustomPath", []))

    @jsii.member(jsii_name="resetContentHostname")
    def reset_content_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentHostname", []))

    @jsii.member(jsii_name="resetContentPath")
    def reset_content_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPath", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDynamicCustomPath")
    def reset_dynamic_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicCustomPath", []))

    @jsii.member(jsii_name="resetDynamicMethod")
    def reset_dynamic_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicMethod", []))

    @jsii.member(jsii_name="resetDynamicPath")
    def reset_dynamic_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyProtocol")
    def reset_modify_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyProtocol", []))

    @jsii.member(jsii_name="resetNetStorageHostname")
    def reset_net_storage_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorageHostname", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetPreserveQueryString")
    def reset_preserve_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveQueryString", []))

    @jsii.member(jsii_name="resetProtocol")
    def reset_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProtocol", []))

    @jsii.member(jsii_name="resetRedirectCustomPath")
    def reset_redirect_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectCustomPath", []))

    @jsii.member(jsii_name="resetRedirectHostname")
    def reset_redirect_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostname", []))

    @jsii.member(jsii_name="resetRedirectHostnameType")
    def reset_redirect_hostname_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostnameType", []))

    @jsii.member(jsii_name="resetRedirectMethod")
    def reset_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectMethod", []))

    @jsii.member(jsii_name="resetRedirectPath")
    def reset_redirect_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectPath", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostname")
    def net_storage_hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference, jsii.get(self, "netStorageHostname"))

    @builtins.property
    @jsii.member(jsii_name="actionTypeInput")
    def action_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="cexCustomPathInput")
    def cex_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cexCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cexHostnameInput")
    def cex_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="cexPathInput")
    def cex_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCustomPathInput")
    def content_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentHostnameInput")
    def content_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPathInput")
    def content_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPathInput")
    def dynamic_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicMethodInput")
    def dynamic_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicPathInput")
    def dynamic_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyProtocolInput")
    def modify_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostnameInput")
    def net_storage_hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname], jsii.get(self, "netStorageHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveQueryStringInput")
    def preserve_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="protocolInput")
    def protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "protocolInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPathInput")
    def redirect_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameInput")
    def redirect_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameTypeInput")
    def redirect_hostname_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectMethodInput")
    def redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectPathInput")
    def redirect_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectPathInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="actionType")
    def action_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "actionType"))

    @action_type.setter
    def action_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea32208173db9f7a22f34e5d025f9165951b3d6ab1cca7f0159f1ab254a25deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "actionType", value)

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f108523255f9ebfe868e00fa9cd37ca188834d9c1fdc2c1b9578d42156296711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="cexCustomPath")
    def cex_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cexCustomPath"))

    @cex_custom_path.setter
    def cex_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a219b03c2942ec555e9a2f45b0b242f441048dfa9409adbaaf3ed5c710d5f2d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="cexHostname")
    def cex_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexHostname"))

    @cex_hostname.setter
    def cex_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8b34fc06e2fd1b8a7101bb4a33bd1530174443cab7a1c5ac0c9ed0a9ab0ebf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexHostname", value)

    @builtins.property
    @jsii.member(jsii_name="cexPath")
    def cex_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexPath"))

    @cex_path.setter
    def cex_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6146c87f8d53f1ae51e7b4abd3d2d00a3148208539d370666130eced00dfd6d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentCustomPath")
    def content_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCustomPath"))

    @content_custom_path.setter
    def content_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14a3993d880c206e5eac31890ec5aee32ce8ec6ea5a2b805c0e0e9b311c3ffcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentHostname")
    def content_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentHostname"))

    @content_hostname.setter
    def content_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046611047eb9915b84b6df1f521479c253b94232e265281bb9e87dd366380123)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentHostname", value)

    @builtins.property
    @jsii.member(jsii_name="contentPath")
    def content_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentPath"))

    @content_path.setter
    def content_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62e31c94de894236e78b840d768337c296d7d6f9fac58faf52772b27c1c4b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPath")
    def dynamic_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicCustomPath"))

    @dynamic_custom_path.setter
    def dynamic_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__202a43539cf780a234dc557b76cecdc50ebfd07d3da83faab50a0955fff7d712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicMethod")
    def dynamic_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicMethod"))

    @dynamic_method.setter
    def dynamic_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa75caba44bc627f8f5995593ebc5e7c09339988d783114c5509f9f2e392cda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicMethod", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicPath")
    def dynamic_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicPath"))

    @dynamic_path.setter
    def dynamic_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d847066546a28696fc786886afb7fc03acf8d8ef6b9bbd5f6efe68ccd1819454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a912190b39d4bd930e7ca4aec47e6fa220b89f102e3644af33503f58e95c905d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783231e49f9d2fffe0095f75ce49b88cdf74fca6973f5ef91239e15f238e2e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyProtocol")
    def modify_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyProtocol"))

    @modify_protocol.setter
    def modify_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f0f711f8e7647102057e53150420a45730e5818b1c2ab11ce46223c81a0faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf3ce86d0bb8cc031dea9cb18cc06e5b6299a0e7038cfb8c2ffd4e2a81f3a737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="preserveQueryString")
    def preserve_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveQueryString"))

    @preserve_query_string.setter
    def preserve_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a06ae525e7c0e41a307e39eb4bf09b32bbe2c0701d6520604df54b0a10f990fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="protocol")
    def protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "protocol"))

    @protocol.setter
    def protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a927ba15bd8e0319ab227c502be6cf27572ce978dbf2d264c598ad531489852e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "protocol", value)

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPath")
    def redirect_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirectCustomPath"))

    @redirect_custom_path.setter
    def redirect_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60cc979bc19b7cf38afae6e86afa0f31c81a8ea73c71ecd6e15bb74991ab68e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostname")
    def redirect_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostname"))

    @redirect_hostname.setter
    def redirect_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b2892dfb57131f70cf38f16f5e58d0198c10408382a61093a38d86af6eb1827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostname", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameType")
    def redirect_hostname_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostnameType"))

    @redirect_hostname_type.setter
    def redirect_hostname_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f3ff6670d9a185635eb2167e4cbbebe4ebbd7ba94a502d265d08d9e78bb01a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostnameType", value)

    @builtins.property
    @jsii.member(jsii_name="redirectMethod")
    def redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectMethod"))

    @redirect_method.setter
    def redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f229fd5cc059e201b2b10b99c4ccd0f748dae82bced3f63cae0eaff90599862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="redirectPath")
    def redirect_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectPath"))

    @redirect_path.setter
    def redirect_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9077db22c3ee1a0fff2c13f44781270e6daa6bbab8270484fa291308bf52bcb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectPath", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d9f08ff4b1091de10bd47ef3344f55b45265f4d8e49f73dcb32b70486e9034)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa7b3cb9222c6da80bedd87938220b2a242ecd237dc147362b22b0898acb8bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6492c1ca94e617348ee2fef50f45bc7addefbad7157351623bcf6411db716308)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db83463bfe82579d23216442c9ba002189a534e17aaec7fcaa42c697ccbd2521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__167040f73d0b6c65d09aa395f506d771b857459f99418d7ac0776c9194b83527)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b931ea682e2f4ae2bd79449da7cd11113113ac3f7730a47210150be72e1757e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b8cd1ba89525916399c62fb0ce7e71f42a965a886cffa4a2bfd37538f221113)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d4bb4f14646f67f74e5124f48787f21eff9548e901105f5ec2f77077f2e434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3002546ca149d4a187299931e73a7e47715925918a32d64759003ac2ec334e0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2748d25993f293cc321ed8e09a5cd57a7950d859f1cf355c273f3450ddacdfc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557768202f7733a19cadc8ae018c81450b1e9f92b96baa4d171cdf1182f67ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a04a94a2dd2ad0b960da7367476682db85c81ed72c8eaf26dc0a79c1dab616a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "compatibility": "compatibility",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility:
    def __init__(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1edae69d560babb21c7fb17dcf8f9b9bf3ff858b68cea289bc07ec42a82e303)
            check_type(argname="argument compatibility", value=compatibility, expected_type=type_hints["compatibility"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compatibility is not None:
            self._values["compatibility"] = compatibility
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compatibility(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This behavior does not include any options. Specifying the behavior itself enables it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        '''
        result = self._values.get("compatibility")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff290ccc01a6a9559ce64eeb111bb1ffe5754e3776f82632ef75c3c112e9f477)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompatibility")
    def reset_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompatibility", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compatibilityInput")
    def compatibility_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compatibility")
    def compatibility(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compatibility"))

    @compatibility.setter
    def compatibility(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a863f03fab2bdaff73ebde432fe0489c31cb97297e4efd632161073e952f7d08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compatibility", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1eba181d6778981a5cebb99aca866a8dba6809bc3c178f3d855df83bde4ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5771c49b9ff5059fcfc7d79ec475bdad631d82fe366c5b29773a083ce2550f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a3b6d72decdd42baeec8e778a7422e517771b3f01354894487377ce29fcb695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa12b543c4b585074f3b6c490b9112b58ce813c5f06431389cd8cfc28f63c7ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91df1b66eb3f7fe2de4d330b1c7feed30b05bda1b08c1b691d6f18a9490f4b1e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, forces a validation test for all edge content to which the behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7dffaef76900c6145811499c7636c82d66c4995d7330b4adac91ed3305eecb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb70194a9e99602a32e2b09cc8d8668e6da47864a16abed267ced2cfdf69fd1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490731fd30f8d794747a3fac6f07bdee50ae1e15835290101e1ec38a56dd8d7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d87c8274927e441725f233032862026030522d3205b377a2b5e0e5db41083901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657376fcf9c446b29070f1fb25734cffd4b0a22fd61be58475cf063ecab934b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fca29c8c011ed25d73815e465863a24935292b315b2c9501ab855346bc4bdd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8edbf75d10a268c7b631fb87d9d4526bbe0814bce957b3cd2b9a6ae94fc69afc)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892113fb598964261e2e2f0120e6adc6b24b20716a1af4f149ecb4ddb23e48ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f48df7a91a47b049e0817d9f03fc35529ef064067a10153abd0d9fdbd7251fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7aeef377f47d2c246a77f9ba4efacff2fbc188e65f5d3c275370cc94c01eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3027bc4e9914e319b2724ded5933f102a7662daaa68276e3a93fa888d210a566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__579067a0a17f495736d9068b1f55b7128a1ef502f52961f5764a9e97c557b21b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ae3716d24a8271a03e61b3e4a041fb8e3afc156886569dc281218b8c180fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8bb3819f293611fe376d431b5d8a76eadf03b931d93d33f31a9eb4ad591709e)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464ac3ca81dbeaeaaadcd9361fd3197be7edc7d1afaac556189927bdd152d7ef)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbfc018334fbd5c04db39d45cff4ad1dd5c556ac5b7c0f40feaa9a928d971538)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1efb9f9672208a0a93557794b171fc3ffe8d36ab2736a6360cceea92d45c8838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edfcc32f2a4e41c1342e2027ee0ac5e5ba5e2d2b6eb58359f894a13ef189d0ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ab2ef344c2979cef8cff3a06fea90657fff42f61b730ad8ec19d1f43ecfa87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c2e067c3f0d536ac8b69db342330785ee0376a60929d6b7217002b79da2822)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d42a6208652d1a2aac6829d3cb38be707eeeb358e1dd43a6697b92440f04adc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11fb4ac1e14d49c6c8696d67172c903cd136f4fbba23426a8ec1da4a5bbfbda0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c6bde77344a17b63b092b6d4e3c0e8bf2eea5fb389b04c0b37e123c971c9b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294632948c6a504bf5616583371fea54f44e8784fd2e4abde597385fb3a14163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6b78d898f4344ff079a41c55f3b3ad9f539e82fc90577ff837b6773cdc82800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1c263f91fbffc4d0b3140850ccd2809e4eb44d565352f0eb2b921e4b30c849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec381cab561a19cac184d8ace1f0ed637c21aba74194117646269a59364f388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2dcd3ec285fb5de6feee7add5551d18e96d8f58c12e11eddfd29b334b487b8)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Plus Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eba86cf80beec2c64dca241969a5ff1143fdb359c14eafbf0c5644590190d13e)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b534ecaabf4a4ca79c9763f278d4435a7dc15e28c9ac9c56277bcb71aa9bff6c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f0b6324f3f4476fb79579c742df198684c7a0aca2c07c7812ab3fdad831bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2afb578793ae8911e32db3f8620ff7c8118dbb252699831ee78709eb912331c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__267c67a23ca4955fe2e5758d662d1dad4347f075522688ea3b63a58f76c96ae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a4515f0f073f2943a8c10713444e9970a0a140109e7430c47e23207aca4e70)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0910e7680550ca5c8ae4c3d08d46a883b2ea53c179f865dfe580599e9cfc82ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f04faf410dcf3b07d1e04053573a82eeb510b341b33779fd332400c5c5fc220e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff577fa1d66e90c2dcf5dce7e617401ec73bacf6c13417866d011d40d540efa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f40b5dd57717fde40b14806e437e784d4ac6999bf1b4c1fcf4d0907f9936910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7327c6a95b56cbc9efa41c21361bd1ae8bfe38fefaa19fd1c1ba7856a7f8e151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55539a6d68e46028d82687fd38382b058880a2f7f9b1ccbdd376c69b342701f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d212dc69b381980f3aaff0cd4d3d4a90a43058096bbe6bcb75f70b620ea15246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__221c92a6ece3aa41d19c6975320ac61153961ec335a64fa76d97191aed8aa8f7)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Forward Rewrite Cloudlet behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc2fd872684ed33129b95022643108d686a846dc5938496a1279b7a6f7ed5cf)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65934efe87c72963c726476e4392d73e5b97601448c3dbf08a9144245abb7f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25671441adff16aa9d069d353bd0fd82ede13562743953c9f7b2a7308f17000e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1a504dd7739b5fd1bb19ef6addd84a7704a2dcf768bae1a8f2ec154dc5a442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e2df7570c0df817f6c12e02f0439b3b932249bbfb79c9555a4334306d9822bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54174898e3c109dcf7fb005b96c6f900d3f3e26a35e9f61493f77b810769b936)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9dd522afa2de34c8bd670a69d67aada5add518291e114acf04cff9a265c3a56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d12804bd672a70bcfe917785872bdfcf3aa991949463c9f64ee31514efa37fc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3058046006b30be9a1014ce57c66038d23db76af4cd06e067d407a2680f366f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21135b8396f28ff72fb7dfdb350e57037eee6299ffe310aa11e37fe85ab37034)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db8369e61088bb96bc9deb07325f48484164f45cea919d43e82168df479bd50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff14f51130fb532576299fe806f32a2c556ea226a36a3481535696b51b0299a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cdb3c981f48f1573949b712225fb2cd698da25b2f840bf199b9961debd860db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader",
    jsii_struct_bases=[],
    name_mapping={
        "custom_sign_string": "customSignString",
        "data_header": "dataHeader",
        "enabled": "enabled",
        "encoding_version": "encodingVersion",
        "locked": "locked",
        "nonce": "nonce",
        "secret_key": "secretKey",
        "signed_header": "signedHeader",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader:
    def __init__(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe2fedd98892344f8b09618dc8b3a78ed4c4b7253f5698d03ed86bb18775143)
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument data_header", value=data_header, expected_type=type_hints["data_header"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument signed_header", value=signed_header, expected_type=type_hints["signed_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if data_header is not None:
            self._values["data_header"] = data_header
        if enabled is not None:
            self._values["enabled"] = enabled
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if locked is not None:
            self._values["locked"] = locked
        if nonce is not None:
            self._values["nonce"] = nonce
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if signed_header is not None:
            self._values["signed_header"] = signed_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of data to be encrypted as a combination of concatenated strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def data_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header that contains the request data that needs to be encrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        '''
        result = self._values.get("data_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the g2o verification behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the cryptographic ``nonce`` string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signed_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header containing encrypted request data.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        '''
        result = self._values.get("signed_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, the encrypted string is based on the forwarded URL.

        If enabled, you can use ``customSignString`` to customize the set of data to encrypt.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12d8aab925f54abd2a1fe1649a1d8febf20f052eebaf934aa7a88be34cdf4ebb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDataHeader")
    def reset_data_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataHeader", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetSignedHeader")
    def reset_signed_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignedHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="dataHeaderInput")
    def data_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dataHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="signedHeaderInput")
    def signed_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "signedHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be7455a43def4ddef11c2575ef63294eecf3eae61d9063febd60b7e36fa34237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="dataHeader")
    def data_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataHeader"))

    @data_header.setter
    def data_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0a5784035fc8b52ddbd377ca5231053381703451f39ff69440104ea7ad779d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76112f3f705aafd0ff4a471824bcf6df6a2fbe47e630c08d461bd7dabea0c6b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e105e068b13b7d498ea5f69dabe496c27d952b48e3c4579c2bca3ee73deb00f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e8ed25483ae454564aa5a8a7d87582571a6ff8c5abb002a28e6724d9759319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d725e1c530701ee94ff920739ce892adc58f504484e90cd30144c6e5798056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b9903047f496661504bc02c01883bfc11f792a0a691709c3de5caee84daaf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="signedHeader")
    def signed_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "signedHeader"))

    @signed_header.setter
    def signed_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8b4f56f2c629fbadfda65d14a323eeb60ea333e21774c5590e6f9c6d986092)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signedHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeba86ab701264510a716480b848cf77a98528cb7871ac6b1bfbd97a804ce16b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d43238752131204b002d301092cd7bc88590fd537db251af57134373c8807730)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdcca72d8fc21f84e9341a5764268c6074f2511a7f7767c034e5d86127a00026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9e3cba22ddbf882f2eca5f7ae8ff25b65a87adac64fa71f7fcd54b767a2b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "output_option": "outputOption",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a93a714a2348aa5042adee41ff0768db643c8c0ace930c2910bbb7a9458a2b)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument output_option", value=output_option, expected_type=type_hints["output_option"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if output_option is not None:
            self._values["output_option"] = output_option
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def output_option(self) -> typing.Optional[builtins.str]:
        '''Specifies how to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        '''
        result = self._values.get("output_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the variable to assign the GRN value to.

        You need to pre-declare any ``variable`` you specify within the rule tree.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47427f12000caa59c28272b32450192befcf8b913835d9b48641c0794695757)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOutputOption")
    def reset_output_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOutputOption", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="outputOptionInput")
    def output_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "outputOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5c3c630369b042be55a4339c0e33d24bc56ec66ca73ae81782bfae4cb31748)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667fa8601065c2d72cd57307013866845c70210e9cb89189b6977801247da4c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="outputOption")
    def output_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "outputOption"))

    @output_option.setter
    def output_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f77717455f0962db55b29aadacb3e28061495ab65d33dbd056d6219b75a198a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "outputOption", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0b7602c8bbb2a1207867d052520c7abd5ce79e200c5a09ea88a83de44fded2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c96e5762fe74c82f0554bf829a1fa8fd81ecf728cf8aaa35f195bcf5f10f45b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba3fe02b0f03cb57d5fed5542b8de5ff1624f87f2b9c88b7f3746466f2d27444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2b6255999ed23135e2e7959dd4ba2f56e50ffda381fd856000aa509bb59bc3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "cache_responses_with_errors": "cacheResponsesWithErrors",
        "enabled": "enabled",
        "locked": "locked",
        "operations_json_body_parameter_name": "operationsJsonBodyParameterName",
        "operations_url_query_parameter_name": "operationsUrlQueryParameterName",
        "post_request_processing_error_handling": "postRequestProcessingErrorHandling",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching:
    def __init__(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2e9bdd51085cbdbc848f8061f7ae135a2fb973ca96367876b4efb13659c2514)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument cache_responses_with_errors", value=cache_responses_with_errors, expected_type=type_hints["cache_responses_with_errors"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument operations_json_body_parameter_name", value=operations_json_body_parameter_name, expected_type=type_hints["operations_json_body_parameter_name"])
            check_type(argname="argument operations_url_query_parameter_name", value=operations_url_query_parameter_name, expected_type=type_hints["operations_url_query_parameter_name"])
            check_type(argname="argument post_request_processing_error_handling", value=post_request_processing_error_handling, expected_type=type_hints["post_request_processing_error_handling"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if cache_responses_with_errors is not None:
            self._values["cache_responses_with_errors"] = cache_responses_with_errors
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if operations_json_body_parameter_name is not None:
            self._values["operations_json_body_parameter_name"] = operations_json_body_parameter_name
        if operations_url_query_parameter_name is not None:
            self._values["operations_url_query_parameter_name"] = operations_url_query_parameter_name
        if post_request_processing_error_handling is not None:
            self._values["post_request_processing_error_handling"] = post_request_processing_error_handling
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_responses_with_errors(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches responses that include an ``error`` field at the top of the response body object.

        Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        '''
        result = self._values.get("cache_responses_with_errors")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables GraphQL caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def operations_json_body_parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the JSON body parameter that identifies GraphQL POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        '''
        result = self._values.get("operations_json_body_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def operations_url_query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of a query parameter that identifies requests as GraphQL queries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        '''
        result = self._values.get("operations_url_query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def post_request_processing_error_handling(self) -> typing.Optional[builtins.str]:
        '''Specify what happens if GraphQL query processing fails on POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        '''
        result = self._values.get("post_request_processing_error_handling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccff98162eefa80ec0a296a81c629d98eabae8c926f5a1b69db696240586b830)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetCacheResponsesWithErrors")
    def reset_cache_responses_with_errors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheResponsesWithErrors", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOperationsJsonBodyParameterName")
    def reset_operations_json_body_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsJsonBodyParameterName", []))

    @jsii.member(jsii_name="resetOperationsUrlQueryParameterName")
    def reset_operations_url_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsUrlQueryParameterName", []))

    @jsii.member(jsii_name="resetPostRequestProcessingErrorHandling")
    def reset_post_request_processing_error_handling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPostRequestProcessingErrorHandling", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrorsInput")
    def cache_responses_with_errors_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheResponsesWithErrorsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterNameInput")
    def operations_json_body_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsJsonBodyParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterNameInput")
    def operations_url_query_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsUrlQueryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandlingInput")
    def post_request_processing_error_handling_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "postRequestProcessingErrorHandlingInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdccdf5a1d0c7faeb467b2d58729aaa57480126080df593300e6c9e4cda77e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrors")
    def cache_responses_with_errors(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheResponsesWithErrors"))

    @cache_responses_with_errors.setter
    def cache_responses_with_errors(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a52dff2cc984842cc0eec1b45745ea82bbea7ee06f2b706ef5370fa4deeaff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheResponsesWithErrors", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02be935ad2643fba1cb5136f7967f82364fcd800392f6ef889553b22554d5394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f733397d86aa9fd6dd9b2cfc1d0a8a0c8f729ade42fea45115c4bfea3815357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterName")
    def operations_json_body_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsJsonBodyParameterName"))

    @operations_json_body_parameter_name.setter
    def operations_json_body_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19f01393387bd042c4d17728f459b6e81bbbb3715c526c82c5dfd7a70a3f5c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsJsonBodyParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterName")
    def operations_url_query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsUrlQueryParameterName"))

    @operations_url_query_parameter_name.setter
    def operations_url_query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135fbf1cd270a17857ecefa01d2541b273a6c79d843ce95b76e393cab3a14438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsUrlQueryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandling")
    def post_request_processing_error_handling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "postRequestProcessingErrorHandling"))

    @post_request_processing_error_handling.setter
    def post_request_processing_error_handling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3a00a5f9ada7c2ded976ae4bc0da0c0d9951f8661dc90b64eaa13533081d93e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "postRequestProcessingErrorHandling", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913c98b7616b7fa72a33a6da197bbb86b883e3d4596b942c8d828e1e2124f345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ad2f8a809de1c14d7fd5469b26d7fced6532e49b872790ce1f88dde77f61eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ada4648e712f0de2c0422f6b653141b8707550b0942fb2b1a60914f4f64819d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e1828441f30615786fbb99cc430165309c43a9974a4145fa6eba1cebcca125)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify when to compress responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91677b864320b0ef43cf0573ec953ee46be36c2cc67c0539e4aa3990c2f2491a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abd0f7ed5dbc269b72d1c2a4d244040db37b641f5aed44f5822eee9f317f2ce9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff30a92c874ecf43d90dae71d36f63bb05a770cddf5c02f2b09f92a2a05dc63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa583a3a86000ae222518e5aef401fa806ac80705115818d997eb33f8424850)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92334f4507a43c9b602d5218950679b4f8142450e2392642220a1107dc572c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32e8640904c33960ba52c18cb96c50a155b851b9c08a891775195f679e3225a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45a6f0e921b28411b392a0e7c76ea484f0b29b5337ccf421cb732ce533fffa4)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b647e7ec633b4e103d434f28fd7bb19a7ad0076dfb03733f44abefbdb32d2b81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e49d83ff50a3ac0c84cb70d767d7b48e61adb13042ea10317b588bbde411bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b07d32aed253b26317e8d704b9657c537668c849b6de9675525a6110344d11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e153b25fe216cf94a11d8edb682c245c8a9600673e206ea9b4ef91a61393f946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584e2a9127165b3393c59d744248e2879302a14a91802f8cc0142b875e451027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6570062a3a42395b42f7773bac5807ced2146b3e0ba18ba914954431683e4bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc0dc0ac46d08b2fde28c95d01bceeeb38df6b69984871f6ae76654e6245458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_reconnects": "maximumReconnects",
        "retry_count": "retryCount",
        "retry_interval": "retryInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39008d63c4138cf7c0c8d46b6105d4b3cd0e0a8e359e45c75ce2c9fd5f28a47b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_reconnects", value=maximum_reconnects, expected_type=type_hints["maximum_reconnects"])
            check_type(argname="argument retry_count", value=retry_count, expected_type=type_hints["retry_count"])
            check_type(argname="argument retry_interval", value=retry_interval, expected_type=type_hints["retry_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_reconnects is not None:
            self._values["maximum_reconnects"] = maximum_reconnects
        if retry_count is not None:
            self._values["retry_count"] = retry_count
        if retry_interval is not None:
            self._values["retry_interval"] = retry_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_reconnects(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum number of times the edge server will contact your origin server.

        If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        '''
        result = self._values.get("maximum_reconnects")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_count(self) -> typing.Optional[jsii.Number]:
        '''The number of consecutive connection failures that mark an IP address as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        '''
        result = self._values.get("retry_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        '''
        result = self._values.get("retry_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e5c0bec0fa8ed4c0c4b9a1b8c6379cdac474ae68b7f5ff49502e08a765b2e4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumReconnects")
    def reset_maximum_reconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumReconnects", []))

    @jsii.member(jsii_name="resetRetryCount")
    def reset_retry_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryCount", []))

    @jsii.member(jsii_name="resetRetryInterval")
    def reset_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumReconnectsInput")
    def maximum_reconnects_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maximumReconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="retryCountInput")
    def retry_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "retryCountInput"))

    @builtins.property
    @jsii.member(jsii_name="retryIntervalInput")
    def retry_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "retryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a624b8cb97f25b1752203c6bb83e0f055a91111d59817d1ae925a2d91414a15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumReconnects")
    def maximum_reconnects(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maximumReconnects"))

    @maximum_reconnects.setter
    def maximum_reconnects(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__200d0033010fe3bd4bc170a960ba4d259ccc16fe47785dab9de9830508c89fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumReconnects", value)

    @builtins.property
    @jsii.member(jsii_name="retryCount")
    def retry_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "retryCount"))

    @retry_count.setter
    def retry_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a949a69078f62b2e69c52e55cb812e811a06c778c00f4aa10b153c01abd971d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryCount", value)

    @builtins.property
    @jsii.member(jsii_name="retryInterval")
    def retry_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "retryInterval"))

    @retry_interval.setter
    def retry_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255fcd19d1a917277403b0b44de95b45f2538f3bae235de6a6d9036ef6909a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c35bde4477d0d8c1e9e694f855296b8fb0673e257ce9c5ed95c52170695fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e9984737508152361a40c4b05bf1f86e511f45dbbeae64135eeab47edc05f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c551ddbac96fac653674990b2d4fa81d4e4dd1c2401324cf8d7f33fed95710b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding",
    jsii_struct_bases=[],
    name_mapping={
        "custom_extracted_serial": "customExtractedSerial",
        "enabled": "enabled",
        "hash_max_value": "hashMaxValue",
        "hash_min_value": "hashMinValue",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier": "tier",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding:
    def __init__(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d2a0ffda8ce847756b97d96875487ff53969bfdb5f82c3df6b0a189d22e7f5e)
            check_type(argname="argument custom_extracted_serial", value=custom_extracted_serial, expected_type=type_hints["custom_extracted_serial"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hash_max_value", value=hash_max_value, expected_type=type_hints["hash_max_value"])
            check_type(argname="argument hash_min_value", value=hash_min_value, expected_type=type_hints["hash_min_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier", value=tier, expected_type=type_hints["tier"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_extracted_serial is not None:
            self._values["custom_extracted_serial"] = custom_extracted_serial
        if enabled is not None:
            self._values["enabled"] = enabled
        if hash_max_value is not None:
            self._values["hash_max_value"] = hash_max_value
        if hash_min_value is not None:
            self._values["hash_min_value"] = hash_min_value
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier is not None:
            self._values["tier"] = tier
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_extracted_serial(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to pull the serial number from the variable value set in the ``advanced`` behavior.

        Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        '''
        result = self._values.get("custom_extracted_serial")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HSAF for Edge IP Binding customers with a large footprint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hash_max_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        '''
        result = self._values.get("hash_max_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def hash_min_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the minimum value for the HSAF hash range, from 2 through 2045.

        This needs to be lower than ``hashMaxValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        '''
        result = self._values.get("hash_min_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier(self) -> typing.Optional[builtins.str]:
        '''Specifies where the behavior is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        '''
        result = self._values.get("tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc2023ceb9282121d40f451b715a10c519e3bfd94a5d3c54d7d0b3cdec70b7cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomExtractedSerial")
    def reset_custom_extracted_serial(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomExtractedSerial", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHashMaxValue")
    def reset_hash_max_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMaxValue", []))

    @jsii.member(jsii_name="resetHashMinValue")
    def reset_hash_min_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMinValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier")
    def reset_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerialInput")
    def custom_extracted_serial_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customExtractedSerialInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMaxValueInput")
    def hash_max_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMaxValueInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMinValueInput")
    def hash_min_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMinValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tierInput")
    def tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tierInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerial")
    def custom_extracted_serial(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customExtractedSerial"))

    @custom_extracted_serial.setter
    def custom_extracted_serial(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02b9f121f9eadfed491d09215a26425f84969d3bffb01de5354a34717e8fe61e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customExtractedSerial", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08edf3526ad38d72b80caed82bd6a4a0d5d2dbf1ea385c43d3e7316a1f0df01d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hashMaxValue")
    def hash_max_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMaxValue"))

    @hash_max_value.setter
    def hash_max_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3578f27e78de831a6f03fd2680b0e8986831e9ebe65f6e28d47894e7d03ce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMaxValue", value)

    @builtins.property
    @jsii.member(jsii_name="hashMinValue")
    def hash_min_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMinValue"))

    @hash_min_value.setter
    def hash_min_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d534002366f5898df8f65b4ca62477c61f6e1e471c9deab06df05cc8d6bf61d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMinValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f26d3862c1d9ed8062e4680e3fc10655dcd8040ed2940788a4c51c9f920ff23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__742a20b8bb54ecd17f1f522a93078150dae21988d2fd247c1a986302c23b57e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier")
    def tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier"))

    @tier.setter
    def tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71a0dc9345c14b07df581ee87bd7d981100cdcc48c8342dff3c06293734732e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ebb048d35f0a949454c2fe3da99861f056a18d06604549210b708cd6c89275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2f467f882384c0e0aaa79eefc550bd0debad30657747a705e0c9a8ffdc0435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01f708a0d81124a9d9a8d8d5350396d14cc1a46ecbb076ec23ef21c5189312f9)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11cde966cc5e5b2b0a7ec9ceda3cca002b97330342c8b6f0e9e82c0f5e135b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8e702771aee86446edae2123b0b887d2f21f58c62bd440047979cbd8dbc4a5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb7c26a03de89f69b8a59ecb13d0e5c47f5d8eea4b46734212a7903832fd71cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46aa2500cd55c90757d550f29ea953a38f4a111ef72592fac4b2f0977ca741ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059d5a9be6b9b417ed2316a4d611529d13f330be4dd244b03c23333637d1fedc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b80000978e1078dcc31e99a881b76860d5f8fb63f1d293dcbbcb9c8ea4cdf227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f640c417579654d4922713eb4a19946bace1a9f44be4c6c467464a783f4d77e)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables HTTP/3 connections between requesting clients and Akamai edge servers.

        You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b7f2ac27e43bd546b7772a7592c761a9e16c54d9c32c7a68aff9cf709ba75b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c93a144f8bc4c1682d4ce9d3014a60ab213549531c9b52a80947add5bf8ae0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca99436acd39d362b5672f9b4d32cce40a4e5d32105fb18a78afbb87f4c7f8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93cfb1f26b4ba8b07ffa8cab7ab8d290a251daa1c989c75b136a52d0c6177e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263f51994c2939518cfea287e288c1269f4689a0ed095cd4942ecfef115026a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e99cc72ef0047e5d6dad3ba21ad0012ee28b87b679b272af05dbe989fedbcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "include_sub_domains": "includeSubDomains",
        "locked": "locked",
        "max_age": "maxAge",
        "preload": "preload",
        "redirect": "redirect",
        "redirect_status_code": "redirectStatusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac58f1654aaf7a52cc1990e25892e925a33672abbc544f5537c49d020d436e8a)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument include_sub_domains", value=include_sub_domains, expected_type=type_hints["include_sub_domains"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument preload", value=preload, expected_type=type_hints["preload"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirect_status_code", value=redirect_status_code, expected_type=type_hints["redirect_status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if include_sub_domains is not None:
            self._values["include_sub_domains"] = include_sub_domains
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if preload is not None:
            self._values["preload"] = preload
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirect_status_code is not None:
            self._values["redirect_status_code"] = redirect_status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies HSTS to this set of requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def include_sub_domains(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies HSTS to all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        '''
        result = self._values.get("include_sub_domains")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration for which to apply HSTS for new browser connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        '''
        result = self._values.get("preload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects all HTTP requests to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies a response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        '''
        result = self._values.get("redirect_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89fe865761d43d29d45deafb78120339ed290f45e63b801d44801c179198eb09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetIncludeSubDomains")
    def reset_include_sub_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeSubDomains", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetPreload")
    def reset_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreload", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectStatusCode")
    def reset_redirect_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="includeSubDomainsInput")
    def include_sub_domains_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeSubDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadInput")
    def preload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCodeInput")
    def redirect_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37216c3e2f53baedc48ad1444441f036ce4187ba5e64b65c439351056e5c87bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="includeSubDomains")
    def include_sub_domains(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeSubDomains"))

    @include_sub_domains.setter
    def include_sub_domains(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca2b841712c70b38080657491217f05daa5db6a97ddbbede24d13afc4a980c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeSubDomains", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4be88beb6e13476513b3edfff71c226bdcc65d42decaef3fa5be91c8a6a1579b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd99ed32c68d7b93273170b3dd4b52a0d3cc1eca835a41669e2216674f46d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="preload")
    def preload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preload"))

    @preload.setter
    def preload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234936e44f9182af784ed00c8c26f98ac51d3427233c877486dc379381e69bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preload", value)

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirect"))

    @redirect.setter
    def redirect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce88fd31a860d5f957ac32e412accf42e1763705fe0624ffc49c3898f5115b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirect", value)

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCode")
    def redirect_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectStatusCode"))

    @redirect_status_code.setter
    def redirect_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c86c14122d24583a0e6a910e4e1f32670d60774c165c14879b2c8e777c1f063a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3888a2c3f08df0163221a887c83bea369b20831e9b2360b7af6ee39c35f54be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e099c7861edf981aca7c28b967346efb6034172c9cbeb9455678b466f4721f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f11be44a2c0ccddb0cfcc96f7388a8a1ef9ccf34cd0216fb0861a626768022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "upgrade": "upgrade",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1557bedea2a015cd48edb0d9e743768bc92a2b07f0eca82408ebbd1c753b722c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upgrade", value=upgrade, expected_type=type_hints["upgrade"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upgrade is not None:
            self._values["upgrade"] = upgrade
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upgrade(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        '''
        result = self._values.get("upgrade")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33b41763e73c707aa8a4d53c8ef3af687e26ed59d1cf887e877f84485032142)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpgrade")
    def reset_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpgrade", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upgradeInput")
    def upgrade_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3853b58fd865f1536cab9103e4cdc141d4adad5de1ef3abccf306cd804707faa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8909fb8f575bcf54ced04f941b8330f1f89bbad710a72b862c97b652170ad2db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upgrade")
    def upgrade(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upgrade"))

    @upgrade.setter
    def upgrade(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b79d3b0986232289ba7960f35d3b17be10c66f58f03a79ae17019b5918465d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upgrade", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__618cedb2c5e7a4421dfcba23723b0288112ab921aa19ff06370184d55bfe6aa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9866546225ed78c3028dbf19f69942fdff28edc51cbba2a16d8a48b9325670a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride",
    jsii_struct_bases=[],
    name_mapping={
        "dpr": "dpr",
        "dprvar": "dprvar",
        "exclude_all_query_parameters": "excludeAllQueryParameters",
        "excluded_query_parameters": "excludedQueryParameters",
        "format": "format",
        "formatvar": "formatvar",
        "locked": "locked",
        "override": "override",
        "policy": "policy",
        "policyvar": "policyvar",
        "policyvar_i_mvar": "policyvarIMvar",
        "policyvar_name": "policyvarName",
        "template_uuid": "templateUuid",
        "typesel": "typesel",
        "uuid": "uuid",
        "width": "width",
        "widthvar": "widthvar",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride:
    def __init__(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb65c879030a9e3c9dc9946d685f74918c9bd8d3fc58c16107625169ed0c30b3)
            check_type(argname="argument dpr", value=dpr, expected_type=type_hints["dpr"])
            check_type(argname="argument dprvar", value=dprvar, expected_type=type_hints["dprvar"])
            check_type(argname="argument exclude_all_query_parameters", value=exclude_all_query_parameters, expected_type=type_hints["exclude_all_query_parameters"])
            check_type(argname="argument excluded_query_parameters", value=excluded_query_parameters, expected_type=type_hints["excluded_query_parameters"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument formatvar", value=formatvar, expected_type=type_hints["formatvar"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override", value=override, expected_type=type_hints["override"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument policyvar", value=policyvar, expected_type=type_hints["policyvar"])
            check_type(argname="argument policyvar_i_mvar", value=policyvar_i_mvar, expected_type=type_hints["policyvar_i_mvar"])
            check_type(argname="argument policyvar_name", value=policyvar_name, expected_type=type_hints["policyvar_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument typesel", value=typesel, expected_type=type_hints["typesel"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument widthvar", value=widthvar, expected_type=type_hints["widthvar"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dpr is not None:
            self._values["dpr"] = dpr
        if dprvar is not None:
            self._values["dprvar"] = dprvar
        if exclude_all_query_parameters is not None:
            self._values["exclude_all_query_parameters"] = exclude_all_query_parameters
        if excluded_query_parameters is not None:
            self._values["excluded_query_parameters"] = excluded_query_parameters
        if format is not None:
            self._values["format"] = format
        if formatvar is not None:
            self._values["formatvar"] = formatvar
        if locked is not None:
            self._values["locked"] = locked
        if override is not None:
            self._values["override"] = override
        if policy is not None:
            self._values["policy"] = policy
        if policyvar is not None:
            self._values["policyvar"] = policyvar
        if policyvar_i_mvar is not None:
            self._values["policyvar_i_mvar"] = policyvar_i_mvar
        if policyvar_name is not None:
            self._values["policyvar_name"] = policyvar_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if typesel is not None:
            self._values["typesel"] = typesel
        if uuid is not None:
            self._values["uuid"] = uuid
        if width is not None:
            self._values["width"] = width
        if widthvar is not None:
            self._values["widthvar"] = widthvar

    @builtins.property
    def dpr(self) -> typing.Optional[jsii.Number]:
        '''Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        '''
        result = self._values.get("dpr")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def dprvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired pixel density.

        The variable specifies the same type of data as the ``dpr`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        '''
        result = self._values.get("dprvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exclude_all_query_parameters(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to exclude all query parameters from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        '''
        result = self._values.get("exclude_all_query_parameters")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def excluded_query_parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies individual query parameters to exclude from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        '''
        result = self._values.get("excluded_query_parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def formatvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the name of the browser you want to optimize images for.

        The variable specifies the same type of data as the ``format`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        '''
        result = self._values.get("formatvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override(self) -> typing.Optional[builtins.str]:
        '''Selects the type of query parameter you want to set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        '''
        result = self._values.get("override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''This selects the desired Image and Video Manager policy name directly.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        '''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired Image and Video Manager policy name to apply to image requests.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        '''
        result = self._values.get("policyvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_i_mvar(self) -> typing.Optional[builtins.str]:
        '''This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        '''
        result = self._values.get("policyvar_i_mvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_name(self) -> typing.Optional[builtins.str]:
        '''This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        '''
        result = self._values.get("policyvar_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typesel(self) -> typing.Optional[builtins.str]:
        '''Specifies how to set a query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        '''
        result = self._values.get("typesel")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[jsii.Number]:
        '''Sets the image's desired pixel width directly.

        If the Image Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def widthvar(self) -> typing.Optional[builtins.str]:
        '''Selects the variable with the desired width.

        If the Image and Video Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        result = self._values.get("widthvar")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47e218209c644462b2c5c5902ef63fe6a6aa73425bf20dbc4b5622d226a10491)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDpr")
    def reset_dpr(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDpr", []))

    @jsii.member(jsii_name="resetDprvar")
    def reset_dprvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDprvar", []))

    @jsii.member(jsii_name="resetExcludeAllQueryParameters")
    def reset_exclude_all_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludeAllQueryParameters", []))

    @jsii.member(jsii_name="resetExcludedQueryParameters")
    def reset_excluded_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludedQueryParameters", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetFormatvar")
    def reset_formatvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatvar", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride")
    def reset_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetPolicyvar")
    def reset_policyvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvar", []))

    @jsii.member(jsii_name="resetPolicyvarIMvar")
    def reset_policyvar_i_mvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarIMvar", []))

    @jsii.member(jsii_name="resetPolicyvarName")
    def reset_policyvar_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTypesel")
    def reset_typesel(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypesel", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthvar")
    def reset_widthvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthvar", []))

    @builtins.property
    @jsii.member(jsii_name="dprInput")
    def dpr_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "dprInput"))

    @builtins.property
    @jsii.member(jsii_name="dprvarInput")
    def dprvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dprvarInput"))

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParametersInput")
    def exclude_all_query_parameters_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "excludeAllQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParametersInput")
    def excluded_query_parameters_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "excludedQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="formatvarInput")
    def formatvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatvarInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideInput")
    def override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvarInput")
    def policyvar_i_mvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarIMvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarInput")
    def policyvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarNameInput")
    def policyvar_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeselInput")
    def typesel_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeselInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthvarInput")
    def widthvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthvarInput"))

    @builtins.property
    @jsii.member(jsii_name="dpr")
    def dpr(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "dpr"))

    @dpr.setter
    def dpr(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a133a60cddcfb6f2aeceb0da8bbb52c327d30a771c44aad6dd52e8a184cff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dpr", value)

    @builtins.property
    @jsii.member(jsii_name="dprvar")
    def dprvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dprvar"))

    @dprvar.setter
    def dprvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae541ee89cd1e6141db6fdec3e9d9f6a390e939c13407db6db5e4ed7d1c7fb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dprvar", value)

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParameters")
    def exclude_all_query_parameters(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "excludeAllQueryParameters"))

    @exclude_all_query_parameters.setter
    def exclude_all_query_parameters(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e753359e9dc57bb9786467a150d5b6cb78c8a8dac0ed58522d5e7fbb777e9622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludeAllQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParameters")
    def excluded_query_parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "excludedQueryParameters"))

    @excluded_query_parameters.setter
    def excluded_query_parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2b633fb7cde2236d53dc8f292e22bd69c270b7974c813ca91aead77b99abf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludedQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36fa67295433f89d7581c2d410e70746306755e058859fef4e5fccb258eb0bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="formatvar")
    def formatvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatvar"))

    @formatvar.setter
    def formatvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dc2a73b902af2522789d51d7958240d423bf42f7448907e654fa1ec218d2cef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatvar", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456b884a25c7d9f1933487c085105ad88a9ad678876155d241f4de50b14b5799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override")
    def override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "override"))

    @override.setter
    def override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85eebb00e078dfb10344a9065b68b0a8ee921d096e43bbd234c489a6a99553e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45a92f4988186a2b5ea9e159c4298d77392c80961713696059cb90f9a0dec248)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="policyvar")
    def policyvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvar"))

    @policyvar.setter
    def policyvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4daf275bfef7f2066096472b90a7fcadc6b309b275bca19424bf56449b8476f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvar")
    def policyvar_i_mvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarIMvar"))

    @policyvar_i_mvar.setter
    def policyvar_i_mvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ce2b2a0c359bca73c576ec00a2861a2062427feeaf141506953729b02e2aed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarIMvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarName")
    def policyvar_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarName"))

    @policyvar_name.setter
    def policyvar_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68ae6434f394eba75d038410d82c46661c1c9af87b1b2fccd375bf8cf5c64fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec7a4b5673ff264b900d6b61b1662fdd09e84b5e4bf6286902929f1643a39d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="typesel")
    def typesel(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typesel"))

    @typesel.setter
    def typesel(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7baf40fbec4e2886ed9593577947367fbca61b34b3fc177a13a518e845cfef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typesel", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3793d79160c280d2f59fc14707eff1d0ffb2b54e7f79c381562e4c61507aa02d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "width"))

    @width.setter
    def width(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d11ae28d045e002d1f6f4445324056241465c19cc7862269f268c49a8cb2a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthvar")
    def widthvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthvar"))

    @widthvar.setter
    def widthvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32944a39249c326c8bd008f10299ac387d3e77ac8997b5a7b4d21a0451c7fb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthvar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b6915639da100142f325261306cd116907fe76a1073b4182c2a8c1d4cb2a07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager",
    jsii_struct_bases=[],
    name_mapping={
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "image_set": "imageSet",
        "locked": "locked",
        "policy_set_type": "policySetType",
        "resize": "resize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "video_set": "videoSet",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager:
    def __init__(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2c921644fd51bbcb5862f7eae667b24f7a481729d6fa6703452bb2c1c783031)
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument image_set", value=image_set, expected_type=type_hints["image_set"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set_type", value=policy_set_type, expected_type=type_hints["policy_set_type"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument video_set", value=video_set, expected_type=type_hints["video_set"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if image_set is not None:
            self._values["image_set"] = image_set
        if locked is not None:
            self._values["locked"] = locked
        if policy_set_type is not None:
            self._values["policy_set_type"] = policy_set_type
        if resize is not None:
            self._values["resize"] = resize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if video_set is not None:
            self._values["video_set"] = video_set

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.'''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.'''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def image_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.'''
        result = self._values.get("image_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.'''
        result = self._values.get("policy_set_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.'''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def video_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.'''
        result = self._values.get("video_set")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef396eedca828f436d28dd8cd420a9c67477c9f037d25097f29b35cb426f713)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a75909b0547433ae9963c149dd126e644eda91b20ae609bc831e730c220410)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__189fabca3978189c10f215c2658eb7a64d44dacb8354d497fd032446f7079bae)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1447fda7e28d49ee0502c93b9200ca51eaff88e0000e94ffe04cbb170d1578b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af89fcf0e83ca42472544ea09714a9e6ecaaf7c6c89432979efd5acef9f8b80a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ed67f115ee9ced82590c10fc37c69a115683d82ada77fd2b0a1e623e01e69e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea8aa49659ba095905db58121957092caefb9aa511d4ccc11ed4eb9f10595ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469a5e12e3fd7453f84310c512ee121a13b48d011200d2ba13a39f9bca25a908)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c5a7a0c7a0653aa1cef4a9ed36367610c0602cfea1282772f7bc1973e69d0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b0b5c4879cb281dc2acebde099ee04236ffbd78ddaf36ac330ca23750f9e78c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f08e9de4ecb0636149dad059c7429177d4df00dc54d9ada578e7f04a46a59d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f93ca17bdf2f2198c5ec5c75ce25897368367121f3dcc68b880eea7eac41157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eb2a2b32dc3e7854a60eb88fa9d09cd5a761e80aef845f136c14c74604672cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f546fc066df4cc38bbeacd444e19db1631a9a676d48724b5bdb5403fed8da4d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2f2c07bad8959a739d094a484cddf27659298102d04470da1f0b5156f88fe6)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4ba84782b392c249f79d8048183845a53b0009a38bf612bd77d24f6d5c5cfd)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__928ffda6d175842af095dd7f9ee8453250bc620d48740c93209dbc8e7a2f36fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dafa4739ceceb1dba4408d84669349389a326668842619985ab3fbd0a5e82acf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d02c72029f6cdbb2bcced6552a8aea2a341a4542021f0115f84fc5ddb967df8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8df7eac756b610930bd5cbe9a8c83d234e4bdd0c5c630e2f4565c6b307c0d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3173256b837d54379d2aaa62a977bbd11a06eaaea616d21d25d9280b712da2df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9397198b2da6b5fa3b3fe6ae18047102f83dddad9c75de4038e6d1d5f4e5e4c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__668b0128c96ca6fbaeffc17c9925a236b4325bf1f58782acbfeb0fb7f7fd9b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca8c4b027cb02fc370ab6a63e4021753e8b23926b5242f92b7790df771aa425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277914729fb806a41bcb1a318a0446f56292ee0f5b99176ea76ab9834c806edd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94331993aa1ddb87f8a9626481d003625eeebbbdf85a7fc309dfaf93353790f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8b9317da9016426fe8a628e7c12b7e8562e3acfdc98af8657c7835a131a427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13334ba03a092e728b754fe0ca225c97f4f30f563c9a5e075f856b18334ec655)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a91434286942f91bc01e810210afc5325101a4c386b7f879a8053f972477902)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetImageSet")
    def reset_image_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageSet", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySetType")
    def reset_policy_set_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySetType", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVideoSet")
    def reset_video_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVideoSet", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="imageSetInput")
    def image_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "imageSetInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetTypeInput")
    def policy_set_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="videoSetInput")
    def video_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "videoSetInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2339415d06fe84b9efd7b3c0cae8ee7d3b280a03f7dd982f3d231b58f06b8c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e99d213866744f5172b9aa1f1336a737a602eaf1ee54c52e9f2c14d7e6d411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="imageSet")
    def image_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "imageSet"))

    @image_set.setter
    def image_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdea67a7cc42dbbb31c127fcf1d58ebd2880eab2ec79e4a31f41b479cbf6f46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageSet", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0700b43d4fd82a6a41669eeaf9d79d1342e534cd898abea7d31952f97998f141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySetType")
    def policy_set_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySetType"))

    @policy_set_type.setter
    def policy_set_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff6a9cd39d99a434a812e2ba3865c46ac3ab1bc8a6cfbd15a1062100780b836f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySetType", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eddaa2182e3fee7f4a83ea113294263dfb57c3cef7896e1bcfcca8741ef9f4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c9fa0bd589878685228fd88415aa2e651ca241b2a54609ee37baf3334b593c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0783901532ed9a3aebbae555ac0fc6360bed81d76b0e9fc7b2d9beba564765b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="videoSet")
    def video_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "videoSet"))

    @video_set.setter
    def video_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c00722795249fdf6f315ca5379d9004228f4b841b7655cb8cb4f402fd06e171)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "videoSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5be03fc788653a2835485087d3b289770140329b8bab8953b4cb166456df6460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790592956708ff8762e31933ea2d7252253a4af48580a5283e299130924cebd1)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images.

        The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file.

        This produces the smallest file size possible that retains image quality.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable image management capabilities and generate a corresponding API token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters.

        If you don't specify a label, ``default`` becomes the prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        The ``advanced`` option needs to be inactive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.

        Note that enabling this may affect screen layout in unexpected ways.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0492c4cf24b27453723419362dddd382ee6384c36da16898b8309cd3d4e033e0)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bdb85c3b20b61f4d64d6c277684c9bdbcf49160a49ea23c3e22e27c9022703c)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc198fe9cfda20d3997baae7bdf8bf0cee83abcec033c750fd25fa7a97acb60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c0fe2a3bd4160dc98eadd8a4ca7f66a4d0bcd8e9acb376aada668e83be54e4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a172c0f34a5538c3aa6a6cd666757a7958ca6799daedb22b0641fb528825764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1d30934e09f15374d8eee98f19c17c122f24f34cc28f89aa5d59a420b1ba320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c027e56e87bed2980161fd21d5e5b56dc560a8dae56a76de456fac174e570ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9874ae621502929c1ecf28578498cbcf130384e4d22f81eeb8408408ea45d3fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7409484feb5abae8633d51ccb8da9c112f7d206926c90f7348bb667fb5b12572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39d29fd8190e5ea5658ecb6527eee148810725115903ef919a8b941102194735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1426afcac38a62ed98fc2679d52a5509fcaf8533e28ca320f76dabee83c46ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c138cc618459fabff31c5104441af7d827427c7d503ab78d56f180963866422d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd8c363611466b2ed8c89a69530e4ccafed2c34ee86e394855f370c51c1b1af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d50f09761f36023b4328a2c9878a65f010a29826c71bdb1ab3f3a2db06af1dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a8501f52668110bcc3db9707fc292970111f1168851f74911856e1f308e181c)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf54d6ce4428ff93849383939a2082bcd0bd19b3763248c3fb7ea86157a3e1f)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a42041fdb4b4f97df2267ba19629bed32818c8ce470b5ad24c7ab873ee33119)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d9e2d4fbfad1020fdbd4bef71ae2b19d0d9cfd1a05dfc56ef0164b66f88434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3032adceb8051e5d65176350fe59c4c6704abbd763ebb6d5553aa7770b4097f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bca86f935f9c176296e077905fe3feb0d213a8f9d972c909c255805b0fe16093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16fb2411bc54b9524bf915c430bfae178b9460b777cad72749779f0b0696ebf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f41bd85370d69e65237ffe3e923dde952af0ba4af207fa760f3d103e4ffe088)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02e7c992adc1f0b0e4b57b77af2bd08904b4dae20dbe53d29af8f6cae5ee479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7cd10aeeba548040b38b3e6b6535604472d879df65aa0f9ea9f365eae025d78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b59069106b1ada114f04b49ffa4c75e973d7cd0f7cb08ce9e703d24322d0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183f84300f0f74f3ae99f2f5bb16cee0d3bc8eaec846931579510023aa7d6fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6736f41db99d39fcd1b344bd29b313a034bfa6d7b9f58e5ff35c78eb7fe0e735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722a2b50bfb7133fbeeb9f97788d0782569b811eaa0d032a0e313cebbb533f42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234bc1240222b491c6ae29961c28a57c345ca7f67a461d736e72b4eb17cac8a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7aebbed8fd30b812c93b4afe0da9a6aa6f6975b503b897d341627b2c75122e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72bca83d064c1fcefe0f19edf6a2d20313eca93ae3806d3c43a814499c32a194)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75074fba16bbccf16c5ccf2403e6e75434437b2a4e1844fb4d5c6bc7a28563b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67461b3c454f35b9bdc69638ba805cf509dbdb80d7c7aea5cf7566c8d55a54a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980bca11fb67be17ca8a30f4eec879801c52101e32e8e1983a5e95c0b44dcdf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e8309848703f110c28a6ccf8d9929513141af37e89c51f97606e40c520534c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7b5abe0385f0ea6faa5f1568637cb265276b8381b9958fd0da2c2c73d5eaf75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632518f8eccf03b3fd9c5ea09ae6900a6fa93e17452b92628244db3bc36c5b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8154590c892c6c1715fff2e8034f183287ffecd7ba7038f15242f4f59d20a271)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a050dbc4c61d42718273a73ae75eb080b318b4f239749420c0abce20ac132cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a64a46a98faf7af8a287f0e6485f26f46d54033489c5105b783b6eb68f03e227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e10124fb63701869cedba82475481884c3c7aa6bb034fa0c3a71dda2476f10b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1478baf599c7272230d7acad9780a37e238af33c5bccf5a4d28bf733cdcaf595)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bb0bdcb500668d7799543a6356aea30ad6689aac113dad6b19463ef4b3211c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea40c7b65cbb2a3001b92e93e680ba4b65aa91845116bfd5493b7567f7ac48e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6eaf00fc4c89573b6652e99025b9c6848bca9639e0ac57a7b9ffa9fdcf93e5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f73c890bf75f7cb5b981380d2fb778ed2727cfcb1a30cbf591d015becfca93)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, applies a single standard policy based on your property name.

        Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, automatically converts videos to the best file type for the requesting device.

        This produces the smallest file size that retains image quality, based on the user agent and the initial image file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Image and Video Manager's video optimization to the current content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``.

        The policy name can include up to 64 alphanumeric, dash, or underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''To optimize caching, assign a region close to your site's heaviest traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e520a78cba38a98e709996ba151ced32c61d3b1e35ec29ac2a0866a6496a12e)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b76ab4e0343a8d89970a362df7d871e438c6b777b365ffc2b6464ee5b177444)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f36bc55a4569d1250ee26f3c236a0aacb3f61c2f2a5f59bcf46e6ea8a168a35)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__273f7c994c49de4bf995c5a5e4d34e88ed753556ecc2b436bd9d59a17833ee56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a57c3ab4ac01e1a90c4e5e83fec30f65471026c007a9a338facc6b1786926fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d5a96e011e2391197e38e5fdfa60a2b4e00c4d6ab3ad7e6ae17c771a580c25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8e32f09e78a1830c7afff1d17ae3bc1b98fdaf7a599c110f396440159acbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f284f305f319808ae04ef97152dbb490312ddde14760663e6e47e5da3059e7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c13ad0ea36b8f96a0aea34e6b34ffa20b051143f63f973eca2e5e7c8d3215a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeee8d8298fc49a6c780313ddc7a6331e9df6b99287b81c126af747b2271e1db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40e4bb3b8a406cd72f392866f191954b05df7b4c62d8bcbf15a39abd03b2b5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f2dc2cc738d77ca394d0893848db4c8ad83e7ce3a5fa58bfe7d151529bf5229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0906e387ee9bc77c4e7996d1bafe30b28e544cc8d5d00cdf4e6c0a7f211fe62f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea065bad3bdc4346e2253a4f9cafe125fc3c9a06e9f196b45674875cbc826727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f82bc818125b2b2db226f024c6c0b8f5d579b80537b1415b5ab40a3df805848)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8520be6f41004ee29d0fc5da72ce973d5f3ad76874716b8942199e9a30a6b1d3)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a4fabbcf81a4674e2e25df83967723b9e6e5d1592fabbdba83c5ca74068753)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44333e846a4c0d4898439de22e487145caab9dd15fd6b648597a221dc0f4af80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eeb84763c83c1202ec197ca32fad1a82ce53f7732d7cf3ab1e385aa784c7007)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de0b2ac3ccabcfd5771be6d61e7e4be84c169329089a834676485cf6ff3a0582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260ada835f716eef3153240184628ae118a9d399b214b1a0af626466f1823951)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5c7091f2ac925387424c339a16dd9f0e3e36bf103158fc0f1bc382f7b871bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09cd08af7616f9d59f07f770b45d751e713a7b8536f86c66433269e307902423)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36baf6340b4eada98d38fb1fa9f3dc47f541b49d22e788a41b1ca80c65ff1c82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e6e37ebb3a6ebfe70cefe3ec495682ef9e00a3076bb94eb3bcf5f4547d36bd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6d40af1de33f87eb3adb2c61b673ce4b279fdbfe2f7a759bc624eeb5e12aaea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60bb63648a544991ce5e815e6a3bee438aa23ec1e59b8ca3412cb3674fed8199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3107323b0fe9c1d7c70cbaaba444a94e59a00d7a450b5444eb4bc7bf2936ebb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be65ab923038d53ffd94402631f42dbb1ce4e1b7f4e644b78639576baad0603)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__939ca7afef057c1393ac3eff2322fe6cb7edc91928a9cf4d6f9b32179869d7bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52650e22b4dcd26a681f96bc1490c853a0966ad2fe756d9f2de75eac0b285a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15fc2ded8017d825ec50a26e06e30fed412d9f73f9900b57fa825df52243f11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50e3d1a5790a3e2ae827dd39868bb7cafb91136f2809b4e09f410845a50953eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20145c308871151d376be32f9047acce11ff9536a14f86baba72c6cb79765415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58a19568661a177ac07c5021df88242fa81ed94e7337ca013cabb11483699c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17a04be189165d1b8dc3819078421cfadaa22dd8b80dbea534f7790dc324cf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993913d8771048794df4e94f273869f7e6dfac63445cd14df55c888b3019d809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f991ef3a8a3703934a6c9ff9cf7e9430ea91748293bfe7643b37ed3d9f5546e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218b75d5b347997581e8bf3ec585b1c91cb51e4c0cacd05a87fb487aca248587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffb5919db995aba4351c6caf0c0259793c2fbf4b916afb0649dcdb1a08862747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7cbf9b134d1ae888e68d4801a1562b5e49aad66d707e624a855784559891fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2e98f76a51799bb8ede5e24fbb62d345f9c6a0810cef860abd237d9c8d7c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75ea6f8a92415ba765c44cfb64cad4f4b7e80f23b17412f0e04ae8608a77b396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6705654db0d66a512be4055a37177bbdbeeac2cb9f6d44c55878a4b6f1fdaf35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb507ccdb8ed91fe3c34040e56307f6db8e3025dbd05d0d33a0fcbf4b59de8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude",
    jsii_struct_bases=[],
    name_mapping={
        "id": "id",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude:
    def __init__(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64e6fe6aefcf3572219559cb400d058344602284a25406114d2ce19e18a1ab6d)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Identifies the include you want to add to your rule tree.

        You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e65310b44e1ec82734f3cf5142f64c11172389115e5496702da63e45b7bd22f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc560d3842bdebe651e1e322c0f23ca453394a0d7982f78c14a8f4eaa4ad866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3611297c756dc67d7b5c61871b7a9e5b918be64a72f88f39115ae5b94659f18d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c243b61946a931c88d07642a558160119edf5d69245c5286d1807dbaa47384fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0d5e97988fb59a3103683ed1916ae81e3db66a250ff56a91323ec0bc291ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09f2050e1e82d9e1ea02607117287ed913903e6be70683a133380fe132ba2617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant",
    jsii_struct_bases=[],
    name_mapping={
        "custom_link_relations": "customLinkRelations",
        "locked": "locked",
        "prefetch_cacheable": "prefetchCacheable",
        "prefetch_html": "prefetchHtml",
        "prefetch_no_store": "prefetchNoStore",
        "prefetch_no_store_extensions": "prefetchNoStoreExtensions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant:
    def __init__(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e6ddfa48409870416ffa48b2c367d36c7d21a17340e8e61d0b73b69f91360c7)
            check_type(argname="argument custom_link_relations", value=custom_link_relations, expected_type=type_hints["custom_link_relations"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch_cacheable", value=prefetch_cacheable, expected_type=type_hints["prefetch_cacheable"])
            check_type(argname="argument prefetch_html", value=prefetch_html, expected_type=type_hints["prefetch_html"])
            check_type(argname="argument prefetch_no_store", value=prefetch_no_store, expected_type=type_hints["prefetch_no_store"])
            check_type(argname="argument prefetch_no_store_extensions", value=prefetch_no_store_extensions, expected_type=type_hints["prefetch_no_store_extensions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_link_relations is not None:
            self._values["custom_link_relations"] = custom_link_relations
        if locked is not None:
            self._values["locked"] = locked
        if prefetch_cacheable is not None:
            self._values["prefetch_cacheable"] = prefetch_cacheable
        if prefetch_html is not None:
            self._values["prefetch_html"] = prefetch_html
        if prefetch_no_store is not None:
            self._values["prefetch_no_store"] = prefetch_no_store
        if prefetch_no_store_extensions is not None:
            self._values["prefetch_no_store_extensions"] = prefetch_no_store_extensions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_link_relations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify link relation values that activate the prefetching behavior.

        For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        '''
        result = self._values.get("custom_link_relations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_cacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior.

        Only applies to content with the ``tieredDistribution`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        '''
        result = self._values.get("prefetch_cacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_html(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered.

        This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        '''
        result = self._values.get("prefetch_html")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option.

        Only applies to content with the ``sureRoute`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        '''
        result = self._values.get("prefetch_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store_extensions(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        '''
        result = self._values.get("prefetch_no_store_extensions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbb255811a4c91a82153b44814a05114aaa292bdb91b01af611475e2a956c18)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the InstantConfig behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9742823fb846259f08c8de77c2d148c9b738aad71aefaa7d93bde8f4765db4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c473d3fa92934ae445c88c1e1ddd3510a4ab5af9df51c89d8ad3d17fb2648af4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6beacebaaa1b178115f4dc31009e930990432411f2bdc46f3d53e48bd30d6ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c37743e046b125cd3956b55b7dc48cc3f17ee523a2f6d21187224dba36da9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61336892c00c7c81b6c4d4d4cffb07342f8172e011c02d8de601639273e735fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8044d382e7b83f4897b1f30ddd2db4e1bd6adb59bfea5b7b9b33b060218acd0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f5377a0ca65afb01f413824dd29c26e53d63dda53a4cef4c873eb8b6334e3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLinkRelations")
    def reset_custom_link_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLinkRelations", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetchCacheable")
    def reset_prefetch_cacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchCacheable", []))

    @jsii.member(jsii_name="resetPrefetchHtml")
    def reset_prefetch_html(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchHtml", []))

    @jsii.member(jsii_name="resetPrefetchNoStore")
    def reset_prefetch_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStore", []))

    @jsii.member(jsii_name="resetPrefetchNoStoreExtensions")
    def reset_prefetch_no_store_extensions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStoreExtensions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelationsInput")
    def custom_link_relations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customLinkRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheableInput")
    def prefetch_cacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchCacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchHtmlInput")
    def prefetch_html_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchHtmlInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensionsInput")
    def prefetch_no_store_extensions_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "prefetchNoStoreExtensionsInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreInput")
    def prefetch_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelations")
    def custom_link_relations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customLinkRelations"))

    @custom_link_relations.setter
    def custom_link_relations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06c521521e7d9d1c9d65d0bce152db07476979a6bb54b6ddb812845937da59c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLinkRelations", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd065ae6ce33f56149f57ba8d19064a1dd2b8245f4093f8867b71416171fff61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheable")
    def prefetch_cacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchCacheable"))

    @prefetch_cacheable.setter
    def prefetch_cacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fb7db00af7b7e3b1bcf174251dd15d3b28767550ac59c138119acde24b75ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchCacheable", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchHtml")
    def prefetch_html(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchHtml"))

    @prefetch_html.setter
    def prefetch_html(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ed4dc6d6f6e91e04c0166eae5a6285dce19cbf82e24794eccb06eda42d8ad38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchHtml", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStore")
    def prefetch_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchNoStore"))

    @prefetch_no_store.setter
    def prefetch_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeff06e0b5a75657fdd8985342a09ca0534ee3832b65059df77157241097392a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensions")
    def prefetch_no_store_extensions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "prefetchNoStoreExtensions"))

    @prefetch_no_store_extensions.setter
    def prefetch_no_store_extensions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff75554a0f673742e2c3f5a6f3c9d914d8b9af3767a115147e4e190392ec47f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStoreExtensions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f781fa1dd1d7082b6a0f6575ab4613d15454936c1a38a20171f4cd73eb88ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98f3b5e3b0f2a83b6fdabf4226205e39b23dbb8e69236055958b615fdad2ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1ac4d20866760d8fda4820a25fa8030a8fb03bcc6982fee45c78adbdc24851d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "enable_partial_object_caching": "enablePartialObjectCaching",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "minimum_size": "minimumSize",
        "template_uuid": "templateUuid",
        "use_versioning": "useVersioning",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e690185ec787b6eb3b39bbfbf086aefcfd275b01039d034b4bee9a406e69508)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_partial_object_caching", value=enable_partial_object_caching, expected_type=type_hints["enable_partial_object_caching"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument minimum_size", value=minimum_size, expected_type=type_hints["minimum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_versioning", value=use_versioning, expected_type=type_hints["use_versioning"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_partial_object_caching is not None:
            self._values["enable_partial_object_caching"] = enable_partial_object_caching
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if minimum_size is not None:
            self._values["minimum_size"] = minimum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_versioning is not None:
            self._values["use_versioning"] = use_versioning
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_partial_object_caching(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to cache partial objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        '''
        result = self._values.get("enable_partial_object_caching")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def minimum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        '''
        result = self._values.get("minimum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_versioning(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        '''
        result = self._values.get("use_versioning")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "fragment_size": "fragmentSize",
        "locked": "locked",
        "object_size": "objectSize",
        "prefetch_after_request": "prefetchAfterRequest",
        "prefetch_during_request": "prefetchDuringRequest",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11096604ef826f5d0be05b0b65ec7647de1a6ebd241a0e917f799076cee1a90b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument fragment_size", value=fragment_size, expected_type=type_hints["fragment_size"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument prefetch_after_request", value=prefetch_after_request, expected_type=type_hints["prefetch_after_request"])
            check_type(argname="argument prefetch_during_request", value=prefetch_during_request, expected_type=type_hints["prefetch_during_request"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if fragment_size is not None:
            self._values["fragment_size"] = fragment_size
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if prefetch_after_request is not None:
            self._values["prefetch_after_request"] = prefetch_after_request
        if prefetch_during_request is not None:
            self._values["prefetch_during_request"] = prefetch_during_request
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def fragment_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of each fragment used for partial object caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        '''
        result = self._values.get("fragment_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the file at which point to apply partial object (POC) caching.

        Append a numeric value with a ``MB`` or ``GB`` suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prefetch_after_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch after the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        '''
        result = self._values.get("prefetch_after_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def prefetch_during_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch during the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        '''
        result = self._values.get("prefetch_during_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac26c34801216203f26f3f242b90192b58f92bce4a5126dab8fe65f4d59efce8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFragmentSize")
    def reset_fragment_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFragmentSize", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPrefetchAfterRequest")
    def reset_prefetch_after_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchAfterRequest", []))

    @jsii.member(jsii_name="resetPrefetchDuringRequest")
    def reset_prefetch_during_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchDuringRequest", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="fragmentSizeInput")
    def fragment_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fragmentSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequestInput")
    def prefetch_after_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchAfterRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequestInput")
    def prefetch_during_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchDuringRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b757fea0b9936162f0c7eca2d4ca8d4ca4b778cb8f9221da2f0ad111f244ac5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="fragmentSize")
    def fragment_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fragmentSize"))

    @fragment_size.setter
    def fragment_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__736e70a6071c1ee53b0eb665e578c234ebcdfc99108dc0a36db5bbfcf2797675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fragmentSize", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbbdcfbff26935790b67c2ce23c0738cf2f7d3812a646bc19c1fb98c3f9f514f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc33b9c530827c8837665333dc8eda81ba401b833759b125b9353dc642ea9fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequest")
    def prefetch_after_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchAfterRequest"))

    @prefetch_after_request.setter
    def prefetch_after_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade508f3403c0b6a5da126f1856f0b5f13dce7c0594b0d94e3f50012e6077222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchAfterRequest", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequest")
    def prefetch_during_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchDuringRequest"))

    @prefetch_during_request.setter
    def prefetch_during_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05bf7b2d4abe5e6388c64b097c4219721e333dc5f1e1ba135014c7ddda4677ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchDuringRequest", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ca94b6765219d1741e9bb276f95819d3a60447a9cb70a7dcf890adc40ff5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d12d8d54f3474a50c8a59edc181bb6b865cb9bf3befcb284d1fd35f80f8d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e676b83e8813fa8ceb1494f4209b921eb93c04bcda1d2c4baf0421dc0cf32e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138280b0ca85ad1a6249b7202c30dea8081a2401c590bc331a1ed6bab2ee4fd0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnablePartialObjectCaching")
    def reset_enable_partial_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePartialObjectCaching", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMinimumSize")
    def reset_minimum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinimumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseVersioning")
    def reset_use_versioning(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseVersioning", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCachingInput")
    def enable_partial_object_caching_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enablePartialObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="minimumSizeInput")
    def minimum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minimumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useVersioningInput")
    def use_versioning_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useVersioningInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e29f85adef6de2d9ece250ffa6129bbf21c6daf813f89fddc39e20acfc92e2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCaching")
    def enable_partial_object_caching(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enablePartialObjectCaching"))

    @enable_partial_object_caching.setter
    def enable_partial_object_caching(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da40697630064a5661ef0b9b015e5921891d0bed57e2134eb5cb9f03918b1dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePartialObjectCaching", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46469807078f670599f4413a82e29e578a239873638184b44700a6fb9160eb38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d10a14d73571081662d6f0a5226116087fc2b90ee839fac38ae854e9ac76cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="minimumSize")
    def minimum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minimumSize"))

    @minimum_size.setter
    def minimum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192ccfe34899ee6717fd8a6d1e3ceb7335781ba06270736692f5f80aed7ee1b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minimumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9009a309717d452da5c5f9553743cc090d6d69229cb1d7e600a89147ee7410ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useVersioning")
    def use_versioning(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useVersioning"))

    @use_versioning.setter
    def use_versioning(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__befcb2569fdb334345b73ff054c68444599c76e7924f2f2329cf0a18300a7f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useVersioning", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98aa129899471e323d2df14838eb38033d8a8e0963753ecbc315552ec435f574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89ae7093c9ad36c1673a8cd75feff6848a5263ba30f3a2182a6b5a757e5e83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate",
    jsii_struct_bases=[],
    name_mapping={
        "bitrate_table": "bitrateTable",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "threshold_table": "thresholdTable",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate:
    def __init__(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a042698fbd07e167b2fba3d184f46e98ed454d6a8dc58f78d64d459689b4325)
            check_type(argname="argument bitrate_table", value=bitrate_table, expected_type=type_hints["bitrate_table"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument threshold_table", value=threshold_table, expected_type=type_hints["threshold_table"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_table is not None:
            self._values["bitrate_table"] = bitrate_table
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if threshold_table is not None:
            self._values["threshold_table"] = threshold_table
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bitrate_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable"]]]:
        '''bitrate_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        '''
        result = self._values.get("bitrate_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable"]]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates the bit rate limiting behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable"]]]:
        '''threshold_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        '''
        result = self._values.get("threshold_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable"]]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable",
    jsii_struct_bases=[],
    name_mapping={"bitrate_unit": "bitrateUnit", "bitrate_value": "bitrateValue"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable:
    def __init__(
        self,
        *,
        bitrate_unit: typing.Optional[builtins.str] = None,
        bitrate_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param bitrate_unit: The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        :param bitrate_value: The numeric indicator of the download rate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e017af0c14085b327846924cbe8d32b56765a37408ffe08ad1b49f84b8f7253)
            check_type(argname="argument bitrate_unit", value=bitrate_unit, expected_type=type_hints["bitrate_unit"])
            check_type(argname="argument bitrate_value", value=bitrate_value, expected_type=type_hints["bitrate_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_unit is not None:
            self._values["bitrate_unit"] = bitrate_unit
        if bitrate_value is not None:
            self._values["bitrate_value"] = bitrate_value

    @builtins.property
    def bitrate_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        '''
        result = self._values.get("bitrate_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def bitrate_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the download rate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        result = self._values.get("bitrate_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6779df0faeae9e1d304a74192f3a5c53484f21c2e87a843f0eca1f0b8348ff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1d870dc4b28bfd0b9b0b499feca7587555f618f636c12ff9487faff6dd77e8)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f697b433515fb0c70d2c684e803e12535be9d39784a364dc3bb831024adda4d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ce51766eaba37a0a8970f404f58ceef4caa9dc45938882ebcb1443703e6d458)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e248b0d96d222a9538099a8bcbd48e5218cb545bf846d57bf91e112a460d2618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20028080038a15ea05ae41e1c023dfcc731a86386393393f9486bbfd2c88521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b05197ec4dd1a4a43645db478fa8059d71fc10d18ff0cedd9be3f97b63ea1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBitrateUnit")
    def reset_bitrate_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateUnit", []))

    @jsii.member(jsii_name="resetBitrateValue")
    def reset_bitrate_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateValue", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnitInput")
    def bitrate_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bitrateUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateValueInput")
    def bitrate_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bitrateValueInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnit")
    def bitrate_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bitrateUnit"))

    @bitrate_unit.setter
    def bitrate_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204e66b3d2e62d0ff2d89f9bd4bf24f5f9fe8ad817f583f1b54d49e219eadadf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateUnit", value)

    @builtins.property
    @jsii.member(jsii_name="bitrateValue")
    def bitrate_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bitrateValue"))

    @bitrate_value.setter
    def bitrate_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead7dd52ced22d38da1fe8fbf4720e2297b8c5e31ebf2cc71756470eb231c78e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__061d7952e2f6120030aee79dfcbfb7d9063cf272e266d44392bc1dae0ec7d365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__543b360472477d90633da527c80292873ea9d3f31ced36324cfd53199b81dff9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBitrateTable")
    def put_bitrate_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__214ce65d6c195ca424cc029cf9f2dde1d1344d56433123b47853f053a9378c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBitrateTable", [value]))

    @jsii.member(jsii_name="putThresholdTable")
    def put_threshold_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10971cd7dbbfd2857ec2afa263c91e6a759e4fe82c72f46e8276c6ad7edbac55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putThresholdTable", [value]))

    @jsii.member(jsii_name="resetBitrateTable")
    def reset_bitrate_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateTable", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThresholdTable")
    def reset_threshold_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdTable", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateTable")
    def bitrate_table(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableList, jsii.get(self, "bitrateTable"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTable")
    def threshold_table(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableList", jsii.get(self, "thresholdTable"))

    @builtins.property
    @jsii.member(jsii_name="bitrateTableInput")
    def bitrate_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "bitrateTableInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTableInput")
    def threshold_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable"]]], jsii.get(self, "thresholdTableInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__945ef7d6a9ddbcfef8fb864a2192d9ace958f7a7e11a370cfc3c47a5c7055ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89d64fd39a26a5e701d99bc11d737d7d3f58ba5e8d64d57b85d34d960c6fc451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c7d00ccba14ba16177576d78ab2f5c2f6d10dfa1fdda72acbe65ac7c2e29bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73db432ffcab591b667f9729198b474589bd9687518b1f568e858fb07bc5fcb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5509225036777b79fcaf252cd3e89cae688be198193c1eb7a8efa338c3f0e23a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable",
    jsii_struct_bases=[],
    name_mapping={
        "threshold_unit": "thresholdUnit",
        "threshold_value": "thresholdValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable:
    def __init__(
        self,
        *,
        threshold_unit: typing.Optional[builtins.str] = None,
        threshold_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param threshold_unit: The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        :param threshold_value: The numeric indicator of the minimum file size or elapsed download time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f399b4e0481cce749cd1bce4b5b4f9c8a7ddadf8b6caea8ba76bfb6c54893e4)
            check_type(argname="argument threshold_unit", value=threshold_unit, expected_type=type_hints["threshold_unit"])
            check_type(argname="argument threshold_value", value=threshold_value, expected_type=type_hints["threshold_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if threshold_unit is not None:
            self._values["threshold_unit"] = threshold_unit
        if threshold_value is not None:
            self._values["threshold_value"] = threshold_value

    @builtins.property
    def threshold_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        '''
        result = self._values.get("threshold_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the minimum file size or elapsed download time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        result = self._values.get("threshold_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9278aca55d4cd779cb8985029cda42d66a9aa359510677359f566227b438125f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d14f068394f812327d0f55173a3b2012946852568fda7ef58087a3845e97e3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff405af4be5c5d1492ee24d00e9d617dca15287c3af09e5f8e22875b56dffb93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d99219485b5c5650a555fe80fd277e1ac99c3128183851bf925a7ed34c41a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bbf877fb5a4cf87213a1adb64020df01e3b0d9b83565d3259e1f128aefb5331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f7a2459cc497f0088962dc55b84bf7345f6eecea2b8a1b08f21a9c143698de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d43f40ddfd600d9adcca3946f4b183b5afe6894bdd3f4ec301baec1fb8979c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetThresholdUnit")
    def reset_threshold_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdUnit", []))

    @jsii.member(jsii_name="resetThresholdValue")
    def reset_threshold_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdValue", []))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnitInput")
    def threshold_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdValueInput")
    def threshold_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "thresholdValueInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnit")
    def threshold_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdUnit"))

    @threshold_unit.setter
    def threshold_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ab2db4ebc685eee092aae5e59c364f84ced6fb2bb46aa5c2f1398b088d678f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdUnit", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdValue")
    def threshold_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "thresholdValue"))

    @threshold_value.setter
    def threshold_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16858e0afcda12b9e7629c3d55c34e5611ac87b5a934af51420fc40520fbd7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe0a50993177ea4c521ec7945cebd6f11106f4b9d85c86ed0daf558f054239e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67221e0a7757eebd8c4828e8adedd20a43676198ee93687c78c0e189d9a4bac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7648f742e78dfa8b0fffdf7bc8a57fe76a79e22fa848f3b10b4765662db238a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73ed481e70c5e0e4786e7a28003f9814e3811fced4010824896ecc9243429ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c8ed262070bd868b62f072293a1324c23577f76401a4da28dc003f56c2cedde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d4024b8213c3921c6dd014888830f8e69af6ed98d0ba6c9838d68905d1e899)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0af756e2bc148f252103abe85ed07e06c2d262d1046ed14b2ef315043fa1c616)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom",
    jsii_struct_bases=[],
    name_mapping={
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_custom_log_field": "logCustomLogField",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom:
    def __init__(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3691a06aadea2ed3a10b44e82dc79ba9111803c1061ab261fa62c9f9c889a605)
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722982a06bd0660e8b5182349a05837de7489b7477d279788a90bf9451269fed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0f295487deff1f199072f20ab4111fca8db24457e43048d4aa563c64e83706)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb9fcc20e2093dfecdd28ff4b1d7e36b73fa7417a165e3d1436db0fda91e8a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__450b152b68bde560b505c10763dfe2ba6022e3f89ed0aec4e057ff673e286f29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f1271448d9b0757a569e558503cb3db66303fd93d706d831ac6af6a3894702)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff0a8124ef4251f8a14284703740e41ecb115cb9af596ab2e17a409651a0696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__102dac8da968f8df48887fe2e75603017b0f7254346dec7ac8803bf1ecf57b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse",
    jsii_struct_bases=[],
    name_mapping={
        "api_key": "apiKey",
        "buffer_size": "bufferSize",
        "config_override": "configOverride",
        "enabled": "enabled",
        "loader_version": "loaderVersion",
        "locked": "locked",
        "require_pci": "requirePci",
        "template_uuid": "templateUuid",
        "title_optional": "titleOptional",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse:
    def __init__(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef7878718fba4aeac19d0c2424b95505d6fa826af21c0f3967a00c7c5d3c304)
            check_type(argname="argument api_key", value=api_key, expected_type=type_hints["api_key"])
            check_type(argname="argument buffer_size", value=buffer_size, expected_type=type_hints["buffer_size"])
            check_type(argname="argument config_override", value=config_override, expected_type=type_hints["config_override"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument loader_version", value=loader_version, expected_type=type_hints["loader_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument require_pci", value=require_pci, expected_type=type_hints["require_pci"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_optional", value=title_optional, expected_type=type_hints["title_optional"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if api_key is not None:
            self._values["api_key"] = api_key
        if buffer_size is not None:
            self._values["buffer_size"] = buffer_size
        if config_override is not None:
            self._values["config_override"] = config_override
        if enabled is not None:
            self._values["enabled"] = enabled
        if loader_version is not None:
            self._values["loader_version"] = loader_version
        if locked is not None:
            self._values["locked"] = locked
        if require_pci is not None:
            self._values["require_pci"] = require_pci
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_optional is not None:
            self._values["title_optional"] = title_optional
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def api_key(self) -> typing.Optional[builtins.str]:
        '''This generated value uniquely identifies sections of your website for you to analyze independently.

        To access this value, see ``Enable mPulse in Property Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        '''
        result = self._values.get("api_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def buffer_size(self) -> typing.Optional[builtins.str]:
        '''Allows you to override the browser's default (150) maximum number of reported performance timeline entries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        '''
        result = self._values.get("buffer_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def config_override(self) -> typing.Optional[builtins.str]:
        '''A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs.

        It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``.  See ``Configuration Overrides`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        '''
        result = self._values.get("config_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies performance monitoring to this behavior's set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def loader_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        '''
        result = self._values.get("loader_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def require_pci(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        '''
        result = self._values.get("require_pci")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_optional(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        '''
        result = self._values.get("title_optional")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc1e309e0f078985e245016b7f18a7b7f4c6cda6607efa47ce2d11a1b871a70b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApiKey")
    def reset_api_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiKey", []))

    @jsii.member(jsii_name="resetBufferSize")
    def reset_buffer_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBufferSize", []))

    @jsii.member(jsii_name="resetConfigOverride")
    def reset_config_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigOverride", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLoaderVersion")
    def reset_loader_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoaderVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequirePci")
    def reset_require_pci(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequirePci", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleOptional")
    def reset_title_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleOptional", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="apiKeyInput")
    def api_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="bufferSizeInput")
    def buffer_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bufferSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="configOverrideInput")
    def config_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="loaderVersionInput")
    def loader_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "loaderVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requirePciInput")
    def require_pci_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "requirePciInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleOptionalInput")
    def title_optional_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleOptionalInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="apiKey")
    def api_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiKey"))

    @api_key.setter
    def api_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265dc2870fece30b896ec1f709f8c8f60a9e032f8264b649652839760c72600f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiKey", value)

    @builtins.property
    @jsii.member(jsii_name="bufferSize")
    def buffer_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bufferSize"))

    @buffer_size.setter
    def buffer_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8522256b8fae7639bd9a6f79bfa771912a60033c09a003feca4ba33466d2da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bufferSize", value)

    @builtins.property
    @jsii.member(jsii_name="configOverride")
    def config_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configOverride"))

    @config_override.setter
    def config_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e07df93975c5d96e073e0d7fb954dcdc50a6c05a0dd330518c86a8bcc6106d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configOverride", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285b3f12472772a79c4aa1a93926bebc9aff3a709de053ad8108a920855d045c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="loaderVersion")
    def loader_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "loaderVersion"))

    @loader_version.setter
    def loader_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e453e51418cc7cdbdeca3c12cf03955ae753980b4515a80d26ece10c0f649022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loaderVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36793d074b2257e09ad23cda997a73faeb3be66d14618f91fdb0b109f6d1788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requirePci")
    def require_pci(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "requirePci"))

    @require_pci.setter
    def require_pci(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66009b7e91dd71a82e6823aee4c4183745a2f010cc3dd46cc3c58ad745756854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requirePci", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891bcac7337a18fea475cd41f8c17cf6de0dd26734136e2f575fa237d9aaf587)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleOptional")
    def title_optional(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleOptional"))

    @title_optional.setter
    def title_optional(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0048646c4a578d4605f1ff20b8befd7adcb01d8fd0fc7242efcdc478846767a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleOptional", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507141fd4b99da788bb829cdcfd14d168349b56df6aab55c698344730a13287e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac28ebc53de04e67e31312a606c5d83bbcd1112f78515c8a1d0b16f000963624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "hls_enabled": "hlsEnabled",
        "hls_enable_debug_headers": "hlsEnableDebugHeaders",
        "hls_filter_in_bitrate_ranges": "hlsFilterInBitrateRanges",
        "hls_filter_in_bitrates": "hlsFilterInBitrates",
        "hls_mode": "hlsMode",
        "hls_preferred_bitrate": "hlsPreferredBitrate",
        "hls_query_param_enabled": "hlsQueryParamEnabled",
        "hls_query_param_secret_key": "hlsQueryParamSecretKey",
        "hls_query_param_transition_key": "hlsQueryParamTransitionKey",
        "hls_show_advanced": "hlsShowAdvanced",
        "hls_title": "hlsTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0ba42d9d43189051c9af1bcff4cf93b00431593a57419cf676749bf03b5716)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hls_enabled", value=hls_enabled, expected_type=type_hints["hls_enabled"])
            check_type(argname="argument hls_enable_debug_headers", value=hls_enable_debug_headers, expected_type=type_hints["hls_enable_debug_headers"])
            check_type(argname="argument hls_filter_in_bitrate_ranges", value=hls_filter_in_bitrate_ranges, expected_type=type_hints["hls_filter_in_bitrate_ranges"])
            check_type(argname="argument hls_filter_in_bitrates", value=hls_filter_in_bitrates, expected_type=type_hints["hls_filter_in_bitrates"])
            check_type(argname="argument hls_mode", value=hls_mode, expected_type=type_hints["hls_mode"])
            check_type(argname="argument hls_preferred_bitrate", value=hls_preferred_bitrate, expected_type=type_hints["hls_preferred_bitrate"])
            check_type(argname="argument hls_query_param_enabled", value=hls_query_param_enabled, expected_type=type_hints["hls_query_param_enabled"])
            check_type(argname="argument hls_query_param_secret_key", value=hls_query_param_secret_key, expected_type=type_hints["hls_query_param_secret_key"])
            check_type(argname="argument hls_query_param_transition_key", value=hls_query_param_transition_key, expected_type=type_hints["hls_query_param_transition_key"])
            check_type(argname="argument hls_show_advanced", value=hls_show_advanced, expected_type=type_hints["hls_show_advanced"])
            check_type(argname="argument hls_title", value=hls_title, expected_type=type_hints["hls_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if hls_enabled is not None:
            self._values["hls_enabled"] = hls_enabled
        if hls_enable_debug_headers is not None:
            self._values["hls_enable_debug_headers"] = hls_enable_debug_headers
        if hls_filter_in_bitrate_ranges is not None:
            self._values["hls_filter_in_bitrate_ranges"] = hls_filter_in_bitrate_ranges
        if hls_filter_in_bitrates is not None:
            self._values["hls_filter_in_bitrates"] = hls_filter_in_bitrates
        if hls_mode is not None:
            self._values["hls_mode"] = hls_mode
        if hls_preferred_bitrate is not None:
            self._values["hls_preferred_bitrate"] = hls_preferred_bitrate
        if hls_query_param_enabled is not None:
            self._values["hls_query_param_enabled"] = hls_query_param_enabled
        if hls_query_param_secret_key is not None:
            self._values["hls_query_param_secret_key"] = hls_query_param_secret_key
        if hls_query_param_transition_key is not None:
            self._values["hls_query_param_transition_key"] = hls_query_param_transition_key
        if hls_show_advanced is not None:
            self._values["hls_show_advanced"] = hls_show_advanced
        if hls_title is not None:
            self._values["hls_title"] = hls_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Manifest Personalization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to customize the HLS master manifest that's sent to the requesting client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        '''
        result = self._values.get("hls_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enable_debug_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        '''
        result = self._values.get("hls_enable_debug_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_filter_in_bitrate_ranges(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        '''
        result = self._values.get("hls_filter_in_bitrate_ranges")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_filter_in_bitrates(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        '''
        result = self._values.get("hls_filter_in_bitrates")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_mode(self) -> typing.Optional[builtins.str]:
        '''Applies with ``hlsEnabled`` on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        '''
        result = self._values.get("hls_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_preferred_bitrate(self) -> typing.Optional[builtins.str]:
        '''Sets the preferred bit rate in Kbps.

        This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        '''
        result = self._values.get("hls_preferred_bitrate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies query parameters for the HLS master manifest to customize the manifest's content.

        Any settings specified in the query string override those already configured in Property Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        '''
        result = self._values.get("hls_query_param_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_query_param_secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a primary key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        '''
        result = self._values.get("hls_query_param_secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        '''
        result = self._values.get("hls_query_param_transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        '''
        result = self._values.get("hls_show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        '''
        result = self._values.get("hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f301c05db555d6705db2fa4c3dd3dbf7f1c2bd34dbc7be270de61a7d6707170)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHlsEnabled")
    def reset_hls_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnabled", []))

    @jsii.member(jsii_name="resetHlsEnableDebugHeaders")
    def reset_hls_enable_debug_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnableDebugHeaders", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrateRanges")
    def reset_hls_filter_in_bitrate_ranges(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrateRanges", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrates")
    def reset_hls_filter_in_bitrates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrates", []))

    @jsii.member(jsii_name="resetHlsMode")
    def reset_hls_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMode", []))

    @jsii.member(jsii_name="resetHlsPreferredBitrate")
    def reset_hls_preferred_bitrate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsPreferredBitrate", []))

    @jsii.member(jsii_name="resetHlsQueryParamEnabled")
    def reset_hls_query_param_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamEnabled", []))

    @jsii.member(jsii_name="resetHlsQueryParamSecretKey")
    def reset_hls_query_param_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamSecretKey", []))

    @jsii.member(jsii_name="resetHlsQueryParamTransitionKey")
    def reset_hls_query_param_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamTransitionKey", []))

    @jsii.member(jsii_name="resetHlsShowAdvanced")
    def reset_hls_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsShowAdvanced", []))

    @jsii.member(jsii_name="resetHlsTitle")
    def reset_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeadersInput")
    def hls_enable_debug_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnableDebugHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnabledInput")
    def hls_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRangesInput")
    def hls_filter_in_bitrate_ranges_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitrateRangesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitratesInput")
    def hls_filter_in_bitrates_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitratesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsModeInput")
    def hls_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsModeInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrateInput")
    def hls_preferred_bitrate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsPreferredBitrateInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabledInput")
    def hls_query_param_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsQueryParamEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKeyInput")
    def hls_query_param_secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamSecretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKeyInput")
    def hls_query_param_transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamTransitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvancedInput")
    def hls_show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsShowAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsTitleInput")
    def hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52475c0ace561de2f8910ada0e201285715031163c2342e5268fac481d8382b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnabled")
    def hls_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnabled"))

    @hls_enabled.setter
    def hls_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6e58dc6261f389c136919a0b7682ae955e63ac12d24bd2defcfcc89dc5fb3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeaders")
    def hls_enable_debug_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnableDebugHeaders"))

    @hls_enable_debug_headers.setter
    def hls_enable_debug_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1949c56b1468a6d389927af0bc1c1fedaad3a056f307944f3a24599f3880713c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnableDebugHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRanges")
    def hls_filter_in_bitrate_ranges(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrateRanges"))

    @hls_filter_in_bitrate_ranges.setter
    def hls_filter_in_bitrate_ranges(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4606c8608fe3bab5bd3eeee6b510668d6e40a0db3f0a4e1cfeed0de3ad7b4d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrateRanges", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrates")
    def hls_filter_in_bitrates(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrates"))

    @hls_filter_in_bitrates.setter
    def hls_filter_in_bitrates(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f8b4692ec00398e90f08ff943a4d9b190671cc99c13ac1dffd2476865824205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrates", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMode")
    def hls_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsMode"))

    @hls_mode.setter
    def hls_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ea1abdf0f776479986bf91df7cfab225c57d500d8078ae94c960def0ed871c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMode", value)

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrate")
    def hls_preferred_bitrate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsPreferredBitrate"))

    @hls_preferred_bitrate.setter
    def hls_preferred_bitrate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7babbdbc1b4a73cb0d982b34749b509d110d92755b8933f73d3fea4621078ebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsPreferredBitrate", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabled")
    def hls_query_param_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsQueryParamEnabled"))

    @hls_query_param_enabled.setter
    def hls_query_param_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ad24b4946a28b9a9bd9ff66af4faed64773c6e91428107aa216be42d396948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKey")
    def hls_query_param_secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamSecretKey"))

    @hls_query_param_secret_key.setter
    def hls_query_param_secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f883d5aae90427fb9643a976499f486853a460f61f92a52853e195e7903de68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamSecretKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKey")
    def hls_query_param_transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamTransitionKey"))

    @hls_query_param_transition_key.setter
    def hls_query_param_transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb59c54251965d431bdd7602cb26338951565cc465950e1aebe11628ebb1543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamTransitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvanced")
    def hls_show_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsShowAdvanced"))

    @hls_show_advanced.setter
    def hls_show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59677c10faae45bfdec3f85623b4e4974495b2e15780af065942bbd8573591dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsShowAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="hlsTitle")
    def hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsTitle"))

    @hls_title.setter
    def hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d215e0f4c2ca5e66622c1747e7046917a43c3127bf3152de8c78247b38c9cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b2b07901e3073c2d94df658cc97e768a6aad73a65baca615e7efc2ff4c2ff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae0525580f846ba3640578c0543655d972bd6172251cfd0e3e20f9f37cef50d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4cfb22ad9d9eaaafd5dda0e4aa716855ec6ea986aa54b059562d2506fc9a51e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af85efa4639348f12b7257e0d182d4d5bf8d405fcc8781fb12ed9b639a8a567c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "partner": "partner",
        "template_uuid": "templateUuid",
        "username": "username",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d5392488b1d253abf45dbc9916ba90b2eb773649c5d3c4f9c5c7a6e65d3689)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument partner", value=partner, expected_type=type_hints["partner"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument username", value=username, expected_type=type_hints["username"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if partner is not None:
            self._values["partner"] = partner
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if username is not None:
            self._values["username"] = username
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner(self) -> typing.Optional[builtins.str]:
        '''Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        '''
        result = self._values.get("partner")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def username(self) -> typing.Optional[builtins.str]:
        '''The user name for your Adobe Primetime account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        '''
        result = self._values.get("username")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestReroutingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestReroutingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__038c2c6eda439d29f57a688e61b537b4ba34cc89e2fcb4021db4f48d7a31f910)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPartner")
    def reset_partner(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartner", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsername")
    def reset_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsername", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerInput")
    def partner_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usernameInput")
    def username_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usernameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa25ea5289465ded08b9bae0abf2199fe05062593547b9b5370736293c03ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="partner")
    def partner(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partner"))

    @partner.setter
    def partner(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fda2b4470619b4ec308e8aeb0c665d2cd6cb1e67a3ed63b1e15679ed173a7d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partner", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2f5bb4fd72afbf37227ed4633cdb707019842016592abf79a80568281338873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="username")
    def username(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "username"))

    @username.setter
    def username(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6634b647744d37fe7e72a722952474ef76ceab3f92b6696076c4ad187d2402b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "username", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c7c6bb36990e8b63ae42631578f9c303c2432d739db9052f22ab5c8505a1f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__732a271a53cd231fe54ee2d127af6fefdbfe2a0b101cc44a017deeea4e1f197e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "serverpushlist": "serverpushlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a83f98f4a30b63593e3a8bb95741bdb13c3d3af993d2fee379ce130662a5fc8)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serverpushlist", value=serverpushlist, expected_type=type_hints["serverpushlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if serverpushlist is not None:
            self._values["serverpushlist"] = serverpushlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serverpushlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of objects to load into the client browser's cache over HTTP2.

        Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        '''
        result = self._values.get("serverpushlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPushOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPushOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12effe8da5814950e0367041045d70971cba2548f5b484ddad33879510b52172)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServerpushlist")
    def reset_serverpushlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerpushlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serverpushlistInput")
    def serverpushlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "serverpushlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d7315bf6f916fc19c0f882a974804cc4995038f88a5f282c7f219306705711)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serverpushlist")
    def serverpushlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "serverpushlist"))

    @serverpushlist.setter
    def serverpushlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00df26d201be73648a78f70bead0da4d9beaf84545f11129291e36a4d2b8df6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serverpushlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c64738be526774608cc58721ba0310c26799cdcda1fb040f17abd6a1ab7501d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d1a909a9cb18961309941ac3353b13ce9a463c08699803d508494c9029854cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb777f07184d175d218be106afdfa28bf8cae7347f4cb63c90f95164a21bf40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b72173f2692e7cbe61a94c98bc0db11d3b16512651de8c444a39b1a4bbf9a9f0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Media Acceleration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c4141c40c809a4008ea284907df8e5a0ed3dcba77d0f8b3a1e67c4cfccd3e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ceb69c3900e12e6518ba747d74432cf5ea7ebbe3e8bd162eb1a1d74fe6e9eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__908bd5ae2aa5f5c1f5fc984be110a9b7d1bc81b79c4d500a949409a959ca9eb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab44c36459a7b8f17738e503929ad0a8a26400be4e58715318938db0d6b25fc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f1551130fa05a20830ebb364a3716dcc53867d33c006e698ee1391ec9be5cd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95fd8d2b201e98401eab91cd1519cb79fe578f41faa025237688e04a3411f4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "optout": "optout",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__332f136457fec7b582879765684e6f2960c2e38032e67de12abecc43df7ee94b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optout", value=optout, expected_type=type_hints["optout"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if optout is not None:
            self._values["optout"] = optout
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optout(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        '''
        result = self._values.get("optout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4512fc76a175bc4ec39b9013ce1771a8caf2382f5a25520975e34fe98b8f27d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptout")
    def reset_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptout", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optoutInput")
    def optout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optoutInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97fdc0773d999e72722e8d079e1c4080accbe09914d00b3ea42e9e8ceba761f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optout")
    def optout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optout"))

    @optout.setter
    def optout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ed8a6c1f3f4e3bd3e1b0c746ee3384df9f939d32e076a14fcd2823f0e20e980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optout", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8613256745af6c5a194e99b6fad9d311049cc251a05764a06704df52465a0fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad496988c7ab6b74aab4c7f06fa5eca61b770bc3ca1830fe5a52dbb1d53ad37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4ee634417fe7acd9d510efb112ae7c4629e1afb3315537ef1dc0548d9e35ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_id": "beaconId",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_hybrid_http_udp": "useHybridHttpUdp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient:
    def __init__(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93986021a3cd5fed327d9a0969b074f3e3892086cdecc5a4dceb75df57b42890)
            check_type(argname="argument beacon_id", value=beacon_id, expected_type=type_hints["beacon_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_hybrid_http_udp", value=use_hybrid_http_udp, expected_type=type_hints["use_hybrid_http_udp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_id is not None:
            self._values["beacon_id"] = beacon_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_hybrid_http_udp is not None:
            self._values["use_hybrid_http_udp"] = use_hybrid_http_udp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ID of data source's beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        '''
        result = self._values.get("beacon_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables client-side download analytics.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_hybrid_http_udp(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the hybrid HTTP/UDP protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        '''
        result = self._values.get("use_hybrid_http_udp")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999c4ed44b5767eebf2e762150706c1c38dcb3995771defb93f23bbb3adf5ab1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconId")
    def reset_beacon_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHybridHttpUdp")
    def reset_use_hybrid_http_udp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHybridHttpUdp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconIdInput")
    def beacon_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdpInput")
    def use_hybrid_http_udp_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHybridHttpUdpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconId")
    def beacon_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconId"))

    @beacon_id.setter
    def beacon_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00dead95dfaad0b75f118d41d643bf74ecb104177b8797849003c18c5231dce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a3e2fdc8f88c942459fc386fe6f81677664729c8e4f6ef86c24181f9389df1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__156929294c05f238ae85bca3e6e3619e4ff9325ec094128d0fdbf0753813c00e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__975aa11bb2cfba91703b48df2b207db69402e0ddb608a6c4988a2aada59640e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdp")
    def use_hybrid_http_udp(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHybridHttpUdp"))

    @use_hybrid_http_udp.setter
    def use_hybrid_http_udp(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8da504dbb7ec85ee556aad8a68556b1944b83a83b8c63f87a2ae88bde3b12c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHybridHttpUdp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56d7144f6ddc79578f90d53002f2e09fdef5bf44f25bfb3b859ce47665160345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dacb3d00388c8fe5ee3c198978b41942250d35b4b428f7fa18b26f865adf158f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf07f54aa34b7dfebcc3924486a090a167165b54fca84df061d7b74e3193974)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the partial-object caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589fab1838631180ec321c8c0db14a3abe45cc4efef46bdb7a7365892f06f5c7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__093bbc24c8cea082aaa879eb602886acfa3fc5f89443126e68fb83f2123bfee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e3839766b01a4d2895442b7120d7f248338418b5a1ebb48aa04fe05d1123cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c81d94e97acaa34e2edc5bc370c550d572f0c10b56ecf13ed37c27b8b0aea24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__502962d7750a3a118a146af1f7f2b0703f0960f295898a149be9c866e4761833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8e15debfd48b34cfbc1d090c0dea49b7322cc2deb95c42eb0b290c76765e6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover",
    jsii_struct_bases=[],
    name_mapping={
        "cache_error_response": "cacheErrorResponse",
        "cache_window": "cacheWindow",
        "client_response_code": "clientResponseCode",
        "detect_object_unavailable": "detectObjectUnavailable",
        "detect_object_unavailable_title": "detectObjectUnavailableTitle",
        "detect_origin_unavailable": "detectOriginUnavailable",
        "detect_origin_unavailable_title": "detectOriginUnavailableTitle",
        "detect_origin_unresponsive": "detectOriginUnresponsive",
        "detect_origin_unresponsive_title": "detectOriginUnresponsiveTitle",
        "locked": "locked",
        "object_unavailable_alternate_host": "objectUnavailableAlternateHost",
        "object_unavailable_backup_host": "objectUnavailableBackupHost",
        "object_unavailable_blacklist_origin_ip": "objectUnavailableBlacklistOriginIp",
        "object_unavailable_blacklist_window": "objectUnavailableBlacklistWindow",
        "object_unavailable_change_protocol": "objectUnavailableChangeProtocol",
        "object_unavailable_detection_level": "objectUnavailableDetectionLevel",
        "object_unavailable_include_query_string": "objectUnavailableIncludeQueryString",
        "object_unavailable_modified_path": "objectUnavailableModifiedPath",
        "object_unavailable_modify_request_path": "objectUnavailableModifyRequestPath",
        "object_unavailable_protocol": "objectUnavailableProtocol",
        "object_unavailable_recovery": "objectUnavailableRecovery",
        "object_unavailable_redirect_method": "objectUnavailableRedirectMethod",
        "object_unavailable_response_codes": "objectUnavailableResponseCodes",
        "object_unavailable_retry_limit": "objectUnavailableRetryLimit",
        "origin_unavailable_alternate_host": "originUnavailableAlternateHost",
        "origin_unavailable_backup_host": "originUnavailableBackupHost",
        "origin_unavailable_blacklist_origin_ip": "originUnavailableBlacklistOriginIp",
        "origin_unavailable_blacklist_window": "originUnavailableBlacklistWindow",
        "origin_unavailable_change_protocol": "originUnavailableChangeProtocol",
        "origin_unavailable_detection_level": "originUnavailableDetectionLevel",
        "origin_unavailable_include_query_string": "originUnavailableIncludeQueryString",
        "origin_unavailable_modified_path": "originUnavailableModifiedPath",
        "origin_unavailable_modify_request_path": "originUnavailableModifyRequestPath",
        "origin_unavailable_protocol": "originUnavailableProtocol",
        "origin_unavailable_recovery": "originUnavailableRecovery",
        "origin_unavailable_redirect_method": "originUnavailableRedirectMethod",
        "origin_unavailable_response_codes": "originUnavailableResponseCodes",
        "origin_unavailable_retry_limit": "originUnavailableRetryLimit",
        "origin_unresponsive_alternate_host": "originUnresponsiveAlternateHost",
        "origin_unresponsive_backup_host": "originUnresponsiveBackupHost",
        "origin_unresponsive_blacklist_origin_ip": "originUnresponsiveBlacklistOriginIp",
        "origin_unresponsive_blacklist_window": "originUnresponsiveBlacklistWindow",
        "origin_unresponsive_change_protocol": "originUnresponsiveChangeProtocol",
        "origin_unresponsive_detection_level": "originUnresponsiveDetectionLevel",
        "origin_unresponsive_include_query_string": "originUnresponsiveIncludeQueryString",
        "origin_unresponsive_modified_path": "originUnresponsiveModifiedPath",
        "origin_unresponsive_modify_request_path": "originUnresponsiveModifyRequestPath",
        "origin_unresponsive_protocol": "originUnresponsiveProtocol",
        "origin_unresponsive_recovery": "originUnresponsiveRecovery",
        "origin_unresponsive_redirect_method": "originUnresponsiveRedirectMethod",
        "origin_unresponsive_retry_limit": "originUnresponsiveRetryLimit",
        "other_options": "otherOptions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover:
    def __init__(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96a1f30599c2cd4c76102a1077d922b57be58dcc0cea61c10f1f9a458eb520a)
            check_type(argname="argument cache_error_response", value=cache_error_response, expected_type=type_hints["cache_error_response"])
            check_type(argname="argument cache_window", value=cache_window, expected_type=type_hints["cache_window"])
            check_type(argname="argument client_response_code", value=client_response_code, expected_type=type_hints["client_response_code"])
            check_type(argname="argument detect_object_unavailable", value=detect_object_unavailable, expected_type=type_hints["detect_object_unavailable"])
            check_type(argname="argument detect_object_unavailable_title", value=detect_object_unavailable_title, expected_type=type_hints["detect_object_unavailable_title"])
            check_type(argname="argument detect_origin_unavailable", value=detect_origin_unavailable, expected_type=type_hints["detect_origin_unavailable"])
            check_type(argname="argument detect_origin_unavailable_title", value=detect_origin_unavailable_title, expected_type=type_hints["detect_origin_unavailable_title"])
            check_type(argname="argument detect_origin_unresponsive", value=detect_origin_unresponsive, expected_type=type_hints["detect_origin_unresponsive"])
            check_type(argname="argument detect_origin_unresponsive_title", value=detect_origin_unresponsive_title, expected_type=type_hints["detect_origin_unresponsive_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_unavailable_alternate_host", value=object_unavailable_alternate_host, expected_type=type_hints["object_unavailable_alternate_host"])
            check_type(argname="argument object_unavailable_backup_host", value=object_unavailable_backup_host, expected_type=type_hints["object_unavailable_backup_host"])
            check_type(argname="argument object_unavailable_blacklist_origin_ip", value=object_unavailable_blacklist_origin_ip, expected_type=type_hints["object_unavailable_blacklist_origin_ip"])
            check_type(argname="argument object_unavailable_blacklist_window", value=object_unavailable_blacklist_window, expected_type=type_hints["object_unavailable_blacklist_window"])
            check_type(argname="argument object_unavailable_change_protocol", value=object_unavailable_change_protocol, expected_type=type_hints["object_unavailable_change_protocol"])
            check_type(argname="argument object_unavailable_detection_level", value=object_unavailable_detection_level, expected_type=type_hints["object_unavailable_detection_level"])
            check_type(argname="argument object_unavailable_include_query_string", value=object_unavailable_include_query_string, expected_type=type_hints["object_unavailable_include_query_string"])
            check_type(argname="argument object_unavailable_modified_path", value=object_unavailable_modified_path, expected_type=type_hints["object_unavailable_modified_path"])
            check_type(argname="argument object_unavailable_modify_request_path", value=object_unavailable_modify_request_path, expected_type=type_hints["object_unavailable_modify_request_path"])
            check_type(argname="argument object_unavailable_protocol", value=object_unavailable_protocol, expected_type=type_hints["object_unavailable_protocol"])
            check_type(argname="argument object_unavailable_recovery", value=object_unavailable_recovery, expected_type=type_hints["object_unavailable_recovery"])
            check_type(argname="argument object_unavailable_redirect_method", value=object_unavailable_redirect_method, expected_type=type_hints["object_unavailable_redirect_method"])
            check_type(argname="argument object_unavailable_response_codes", value=object_unavailable_response_codes, expected_type=type_hints["object_unavailable_response_codes"])
            check_type(argname="argument object_unavailable_retry_limit", value=object_unavailable_retry_limit, expected_type=type_hints["object_unavailable_retry_limit"])
            check_type(argname="argument origin_unavailable_alternate_host", value=origin_unavailable_alternate_host, expected_type=type_hints["origin_unavailable_alternate_host"])
            check_type(argname="argument origin_unavailable_backup_host", value=origin_unavailable_backup_host, expected_type=type_hints["origin_unavailable_backup_host"])
            check_type(argname="argument origin_unavailable_blacklist_origin_ip", value=origin_unavailable_blacklist_origin_ip, expected_type=type_hints["origin_unavailable_blacklist_origin_ip"])
            check_type(argname="argument origin_unavailable_blacklist_window", value=origin_unavailable_blacklist_window, expected_type=type_hints["origin_unavailable_blacklist_window"])
            check_type(argname="argument origin_unavailable_change_protocol", value=origin_unavailable_change_protocol, expected_type=type_hints["origin_unavailable_change_protocol"])
            check_type(argname="argument origin_unavailable_detection_level", value=origin_unavailable_detection_level, expected_type=type_hints["origin_unavailable_detection_level"])
            check_type(argname="argument origin_unavailable_include_query_string", value=origin_unavailable_include_query_string, expected_type=type_hints["origin_unavailable_include_query_string"])
            check_type(argname="argument origin_unavailable_modified_path", value=origin_unavailable_modified_path, expected_type=type_hints["origin_unavailable_modified_path"])
            check_type(argname="argument origin_unavailable_modify_request_path", value=origin_unavailable_modify_request_path, expected_type=type_hints["origin_unavailable_modify_request_path"])
            check_type(argname="argument origin_unavailable_protocol", value=origin_unavailable_protocol, expected_type=type_hints["origin_unavailable_protocol"])
            check_type(argname="argument origin_unavailable_recovery", value=origin_unavailable_recovery, expected_type=type_hints["origin_unavailable_recovery"])
            check_type(argname="argument origin_unavailable_redirect_method", value=origin_unavailable_redirect_method, expected_type=type_hints["origin_unavailable_redirect_method"])
            check_type(argname="argument origin_unavailable_response_codes", value=origin_unavailable_response_codes, expected_type=type_hints["origin_unavailable_response_codes"])
            check_type(argname="argument origin_unavailable_retry_limit", value=origin_unavailable_retry_limit, expected_type=type_hints["origin_unavailable_retry_limit"])
            check_type(argname="argument origin_unresponsive_alternate_host", value=origin_unresponsive_alternate_host, expected_type=type_hints["origin_unresponsive_alternate_host"])
            check_type(argname="argument origin_unresponsive_backup_host", value=origin_unresponsive_backup_host, expected_type=type_hints["origin_unresponsive_backup_host"])
            check_type(argname="argument origin_unresponsive_blacklist_origin_ip", value=origin_unresponsive_blacklist_origin_ip, expected_type=type_hints["origin_unresponsive_blacklist_origin_ip"])
            check_type(argname="argument origin_unresponsive_blacklist_window", value=origin_unresponsive_blacklist_window, expected_type=type_hints["origin_unresponsive_blacklist_window"])
            check_type(argname="argument origin_unresponsive_change_protocol", value=origin_unresponsive_change_protocol, expected_type=type_hints["origin_unresponsive_change_protocol"])
            check_type(argname="argument origin_unresponsive_detection_level", value=origin_unresponsive_detection_level, expected_type=type_hints["origin_unresponsive_detection_level"])
            check_type(argname="argument origin_unresponsive_include_query_string", value=origin_unresponsive_include_query_string, expected_type=type_hints["origin_unresponsive_include_query_string"])
            check_type(argname="argument origin_unresponsive_modified_path", value=origin_unresponsive_modified_path, expected_type=type_hints["origin_unresponsive_modified_path"])
            check_type(argname="argument origin_unresponsive_modify_request_path", value=origin_unresponsive_modify_request_path, expected_type=type_hints["origin_unresponsive_modify_request_path"])
            check_type(argname="argument origin_unresponsive_protocol", value=origin_unresponsive_protocol, expected_type=type_hints["origin_unresponsive_protocol"])
            check_type(argname="argument origin_unresponsive_recovery", value=origin_unresponsive_recovery, expected_type=type_hints["origin_unresponsive_recovery"])
            check_type(argname="argument origin_unresponsive_redirect_method", value=origin_unresponsive_redirect_method, expected_type=type_hints["origin_unresponsive_redirect_method"])
            check_type(argname="argument origin_unresponsive_retry_limit", value=origin_unresponsive_retry_limit, expected_type=type_hints["origin_unresponsive_retry_limit"])
            check_type(argname="argument other_options", value=other_options, expected_type=type_hints["other_options"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_error_response is not None:
            self._values["cache_error_response"] = cache_error_response
        if cache_window is not None:
            self._values["cache_window"] = cache_window
        if client_response_code is not None:
            self._values["client_response_code"] = client_response_code
        if detect_object_unavailable is not None:
            self._values["detect_object_unavailable"] = detect_object_unavailable
        if detect_object_unavailable_title is not None:
            self._values["detect_object_unavailable_title"] = detect_object_unavailable_title
        if detect_origin_unavailable is not None:
            self._values["detect_origin_unavailable"] = detect_origin_unavailable
        if detect_origin_unavailable_title is not None:
            self._values["detect_origin_unavailable_title"] = detect_origin_unavailable_title
        if detect_origin_unresponsive is not None:
            self._values["detect_origin_unresponsive"] = detect_origin_unresponsive
        if detect_origin_unresponsive_title is not None:
            self._values["detect_origin_unresponsive_title"] = detect_origin_unresponsive_title
        if locked is not None:
            self._values["locked"] = locked
        if object_unavailable_alternate_host is not None:
            self._values["object_unavailable_alternate_host"] = object_unavailable_alternate_host
        if object_unavailable_backup_host is not None:
            self._values["object_unavailable_backup_host"] = object_unavailable_backup_host
        if object_unavailable_blacklist_origin_ip is not None:
            self._values["object_unavailable_blacklist_origin_ip"] = object_unavailable_blacklist_origin_ip
        if object_unavailable_blacklist_window is not None:
            self._values["object_unavailable_blacklist_window"] = object_unavailable_blacklist_window
        if object_unavailable_change_protocol is not None:
            self._values["object_unavailable_change_protocol"] = object_unavailable_change_protocol
        if object_unavailable_detection_level is not None:
            self._values["object_unavailable_detection_level"] = object_unavailable_detection_level
        if object_unavailable_include_query_string is not None:
            self._values["object_unavailable_include_query_string"] = object_unavailable_include_query_string
        if object_unavailable_modified_path is not None:
            self._values["object_unavailable_modified_path"] = object_unavailable_modified_path
        if object_unavailable_modify_request_path is not None:
            self._values["object_unavailable_modify_request_path"] = object_unavailable_modify_request_path
        if object_unavailable_protocol is not None:
            self._values["object_unavailable_protocol"] = object_unavailable_protocol
        if object_unavailable_recovery is not None:
            self._values["object_unavailable_recovery"] = object_unavailable_recovery
        if object_unavailable_redirect_method is not None:
            self._values["object_unavailable_redirect_method"] = object_unavailable_redirect_method
        if object_unavailable_response_codes is not None:
            self._values["object_unavailable_response_codes"] = object_unavailable_response_codes
        if object_unavailable_retry_limit is not None:
            self._values["object_unavailable_retry_limit"] = object_unavailable_retry_limit
        if origin_unavailable_alternate_host is not None:
            self._values["origin_unavailable_alternate_host"] = origin_unavailable_alternate_host
        if origin_unavailable_backup_host is not None:
            self._values["origin_unavailable_backup_host"] = origin_unavailable_backup_host
        if origin_unavailable_blacklist_origin_ip is not None:
            self._values["origin_unavailable_blacklist_origin_ip"] = origin_unavailable_blacklist_origin_ip
        if origin_unavailable_blacklist_window is not None:
            self._values["origin_unavailable_blacklist_window"] = origin_unavailable_blacklist_window
        if origin_unavailable_change_protocol is not None:
            self._values["origin_unavailable_change_protocol"] = origin_unavailable_change_protocol
        if origin_unavailable_detection_level is not None:
            self._values["origin_unavailable_detection_level"] = origin_unavailable_detection_level
        if origin_unavailable_include_query_string is not None:
            self._values["origin_unavailable_include_query_string"] = origin_unavailable_include_query_string
        if origin_unavailable_modified_path is not None:
            self._values["origin_unavailable_modified_path"] = origin_unavailable_modified_path
        if origin_unavailable_modify_request_path is not None:
            self._values["origin_unavailable_modify_request_path"] = origin_unavailable_modify_request_path
        if origin_unavailable_protocol is not None:
            self._values["origin_unavailable_protocol"] = origin_unavailable_protocol
        if origin_unavailable_recovery is not None:
            self._values["origin_unavailable_recovery"] = origin_unavailable_recovery
        if origin_unavailable_redirect_method is not None:
            self._values["origin_unavailable_redirect_method"] = origin_unavailable_redirect_method
        if origin_unavailable_response_codes is not None:
            self._values["origin_unavailable_response_codes"] = origin_unavailable_response_codes
        if origin_unavailable_retry_limit is not None:
            self._values["origin_unavailable_retry_limit"] = origin_unavailable_retry_limit
        if origin_unresponsive_alternate_host is not None:
            self._values["origin_unresponsive_alternate_host"] = origin_unresponsive_alternate_host
        if origin_unresponsive_backup_host is not None:
            self._values["origin_unresponsive_backup_host"] = origin_unresponsive_backup_host
        if origin_unresponsive_blacklist_origin_ip is not None:
            self._values["origin_unresponsive_blacklist_origin_ip"] = origin_unresponsive_blacklist_origin_ip
        if origin_unresponsive_blacklist_window is not None:
            self._values["origin_unresponsive_blacklist_window"] = origin_unresponsive_blacklist_window
        if origin_unresponsive_change_protocol is not None:
            self._values["origin_unresponsive_change_protocol"] = origin_unresponsive_change_protocol
        if origin_unresponsive_detection_level is not None:
            self._values["origin_unresponsive_detection_level"] = origin_unresponsive_detection_level
        if origin_unresponsive_include_query_string is not None:
            self._values["origin_unresponsive_include_query_string"] = origin_unresponsive_include_query_string
        if origin_unresponsive_modified_path is not None:
            self._values["origin_unresponsive_modified_path"] = origin_unresponsive_modified_path
        if origin_unresponsive_modify_request_path is not None:
            self._values["origin_unresponsive_modify_request_path"] = origin_unresponsive_modify_request_path
        if origin_unresponsive_protocol is not None:
            self._values["origin_unresponsive_protocol"] = origin_unresponsive_protocol
        if origin_unresponsive_recovery is not None:
            self._values["origin_unresponsive_recovery"] = origin_unresponsive_recovery
        if origin_unresponsive_redirect_method is not None:
            self._values["origin_unresponsive_redirect_method"] = origin_unresponsive_redirect_method
        if origin_unresponsive_retry_limit is not None:
            self._values["origin_unresponsive_retry_limit"] = origin_unresponsive_retry_limit
        if other_options is not None:
            self._values["other_options"] = other_options
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cache_error_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches the error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        '''
        result = self._values.get("cache_error_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_window(self) -> typing.Optional[builtins.str]:
        '''This sets error response's TTL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        '''
        result = self._values.get("cache_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_response_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the response code served to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        '''
        result = self._values.get("client_response_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_object_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin has content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        '''
        result = self._values.get("detect_object_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_object_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        '''
        result = self._values.get("detect_object_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin server responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        '''
        result = self._values.get("detect_origin_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        '''
        result = self._values.get("detect_origin_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unresponsive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure what happens when the origin is unresponsive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        '''
        result = self._values.get("detect_origin_unresponsive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unresponsive_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        '''
        result = self._values.get("detect_origin_unresponsive_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        '''
        result = self._values.get("object_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        '''
        result = self._values.get("object_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("object_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        '''
        result = self._values.get("object_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Changes the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        '''
        result = self._values.get("object_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        '''
        result = self._values.get("object_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        '''
        result = self._values.get("object_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        '''
        result = self._values.get("object_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to modify the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        '''
        result = self._values.get("object_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        '''
        result = self._values.get("object_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        '''
        result = self._values.get("object_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        '''
        result = self._values.get("object_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def object_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when there are content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        '''
        result = self._values.get("object_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def object_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        '''
        result = self._values.get("object_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        '''
        result = self._values.get("origin_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        '''
        result = self._values.get("origin_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        '''
        result = self._values.get("origin_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        '''
        result = self._values.get("origin_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        '''
        result = self._values.get("origin_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        '''
        result = self._values.get("origin_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        '''
        result = self._values.get("origin_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        '''
        result = self._values.get("origin_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        '''
        result = self._values.get("origin_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        '''
        result = self._values.get("origin_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies either a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        '''
        result = self._values.get("origin_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when the origin responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        '''
        result = self._values.get("origin_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origin_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        '''
        result = self._values.get("origin_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        '''
        result = self._values.get("origin_unresponsive_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        '''
        result = self._values.get("origin_unresponsive_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unresponsive_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        '''
        result = self._values.get("origin_unresponsive_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This allows you to change the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        '''
        result = self._values.get("origin_unresponsive_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify the level of response to slow origin connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        '''
        result = self._values.get("origin_unresponsive_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        '''
        result = self._values.get("origin_unresponsive_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        '''
        result = self._values.get("origin_unresponsive_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        '''
        result = self._values.get("origin_unresponsive_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies which protocol to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        '''
        result = self._values.get("origin_unresponsive_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        '''
        result = self._values.get("origin_unresponsive_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        '''
        result = self._values.get("origin_unresponsive_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unresponsive_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        '''
        result = self._values.get("origin_unresponsive_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def other_options(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        '''
        result = self._values.get("other_options")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailoverOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailoverOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c99586870ab09a2759f6e518d6726198ce3937ab8978c93bd1fe29e3d23650c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCacheErrorResponse")
    def reset_cache_error_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheErrorResponse", []))

    @jsii.member(jsii_name="resetCacheWindow")
    def reset_cache_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheWindow", []))

    @jsii.member(jsii_name="resetClientResponseCode")
    def reset_client_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientResponseCode", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailable")
    def reset_detect_object_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailable", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailableTitle")
    def reset_detect_object_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailable")
    def reset_detect_origin_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailable", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailableTitle")
    def reset_detect_origin_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsive")
    def reset_detect_origin_unresponsive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsive", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsiveTitle")
    def reset_detect_origin_unresponsive_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsiveTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectUnavailableAlternateHost")
    def reset_object_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBackupHost")
    def reset_object_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistOriginIp")
    def reset_object_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistWindow")
    def reset_object_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetObjectUnavailableChangeProtocol")
    def reset_object_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableDetectionLevel")
    def reset_object_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetObjectUnavailableIncludeQueryString")
    def reset_object_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifiedPath")
    def reset_object_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifyRequestPath")
    def reset_object_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableProtocol")
    def reset_object_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableRecovery")
    def reset_object_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRecovery", []))

    @jsii.member(jsii_name="resetObjectUnavailableRedirectMethod")
    def reset_object_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetObjectUnavailableResponseCodes")
    def reset_object_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetObjectUnavailableRetryLimit")
    def reset_object_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnavailableAlternateHost")
    def reset_origin_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBackupHost")
    def reset_origin_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistOriginIp")
    def reset_origin_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistWindow")
    def reset_origin_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnavailableChangeProtocol")
    def reset_origin_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableDetectionLevel")
    def reset_origin_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnavailableIncludeQueryString")
    def reset_origin_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifiedPath")
    def reset_origin_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifyRequestPath")
    def reset_origin_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableProtocol")
    def reset_origin_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableRecovery")
    def reset_origin_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRecovery", []))

    @jsii.member(jsii_name="resetOriginUnavailableRedirectMethod")
    def reset_origin_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnavailableResponseCodes")
    def reset_origin_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetOriginUnavailableRetryLimit")
    def reset_origin_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveAlternateHost")
    def reset_origin_unresponsive_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBackupHost")
    def reset_origin_unresponsive_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistOriginIp")
    def reset_origin_unresponsive_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistWindow")
    def reset_origin_unresponsive_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveChangeProtocol")
    def reset_origin_unresponsive_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveDetectionLevel")
    def reset_origin_unresponsive_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveIncludeQueryString")
    def reset_origin_unresponsive_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifiedPath")
    def reset_origin_unresponsive_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifyRequestPath")
    def reset_origin_unresponsive_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveProtocol")
    def reset_origin_unresponsive_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRecovery")
    def reset_origin_unresponsive_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRecovery", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRedirectMethod")
    def reset_origin_unresponsive_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRetryLimit")
    def reset_origin_unresponsive_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRetryLimit", []))

    @jsii.member(jsii_name="resetOtherOptions")
    def reset_other_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOtherOptions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponseInput")
    def cache_error_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheErrorResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheWindowInput")
    def cache_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="clientResponseCodeInput")
    def client_response_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableInput")
    def detect_object_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectObjectUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitleInput")
    def detect_object_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectObjectUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableInput")
    def detect_origin_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitleInput")
    def detect_origin_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveInput")
    def detect_origin_unresponsive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnresponsiveInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitleInput")
    def detect_origin_unresponsive_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnresponsiveTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHostInput")
    def object_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHostInput")
    def object_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIpInput")
    def object_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindowInput")
    def object_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocolInput")
    def object_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevelInput")
    def object_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryStringInput")
    def object_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPathInput")
    def object_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPathInput")
    def object_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocolInput")
    def object_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecoveryInput")
    def object_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethodInput")
    def object_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "objectUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodesInput")
    def object_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "objectUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimitInput")
    def object_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHostInput")
    def origin_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHostInput")
    def origin_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIpInput")
    def origin_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindowInput")
    def origin_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocolInput")
    def origin_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevelInput")
    def origin_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryStringInput")
    def origin_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPathInput")
    def origin_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPathInput")
    def origin_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocolInput")
    def origin_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecoveryInput")
    def origin_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethodInput")
    def origin_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodesInput")
    def origin_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimitInput")
    def origin_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHostInput")
    def origin_unresponsive_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHostInput")
    def origin_unresponsive_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIpInput")
    def origin_unresponsive_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindowInput")
    def origin_unresponsive_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocolInput")
    def origin_unresponsive_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevelInput")
    def origin_unresponsive_detection_level_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryStringInput")
    def origin_unresponsive_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPathInput")
    def origin_unresponsive_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPathInput")
    def origin_unresponsive_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocolInput")
    def origin_unresponsive_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecoveryInput")
    def origin_unresponsive_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethodInput")
    def origin_unresponsive_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnresponsiveRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimitInput")
    def origin_unresponsive_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="otherOptionsInput")
    def other_options_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "otherOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponse")
    def cache_error_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheErrorResponse"))

    @cache_error_response.setter
    def cache_error_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16b545e9f2a9876ce98ac0be7631a9db4b0aa6f4f021b8e88db224cdd439578e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheErrorResponse", value)

    @builtins.property
    @jsii.member(jsii_name="cacheWindow")
    def cache_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheWindow"))

    @cache_window.setter
    def cache_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa727352b702cb62cd17499251b83bdaa56fb26d8e82110a1147a95fa1b3ed38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheWindow", value)

    @builtins.property
    @jsii.member(jsii_name="clientResponseCode")
    def client_response_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientResponseCode"))

    @client_response_code.setter
    def client_response_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7434e25528af5c794d8b25c0e7024ff8a2a1c3dbead2d13bb299c111bf13f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailable")
    def detect_object_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectObjectUnavailable"))

    @detect_object_unavailable.setter
    def detect_object_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47d885a3e7ebbcbf8c212a650d24cda923dbf31263029fe1830ba119161d708c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitle")
    def detect_object_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectObjectUnavailableTitle"))

    @detect_object_unavailable_title.setter
    def detect_object_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c3e9ad69921905ec34a687a1cc0a004bc839f8867a01c48405ee8e4d8940740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailable")
    def detect_origin_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnavailable"))

    @detect_origin_unavailable.setter
    def detect_origin_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cba23a7008a362f270bf02acb6b53d540295b4ba11c952f56e4babc02fbb0d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitle")
    def detect_origin_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnavailableTitle"))

    @detect_origin_unavailable_title.setter
    def detect_origin_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d30555590e6b1d31199e7818a723a2a3871323bef76b71f7fef9784883250a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsive")
    def detect_origin_unresponsive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnresponsive"))

    @detect_origin_unresponsive.setter
    def detect_origin_unresponsive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dcd738c29176adb5ff250c6e5b7c9bbd93423682113754ffe62e7d7da02d66a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsive", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitle")
    def detect_origin_unresponsive_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnresponsiveTitle"))

    @detect_origin_unresponsive_title.setter
    def detect_origin_unresponsive_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e342380abe772c8e7a0a4592f4556180e8ce5b9e0b7a393dd77b4bcc080001b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsiveTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c54d89ff539d74c7d366e974d772aac25f8bc65c38cd4ec728132bc7695300b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHost")
    def object_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableAlternateHost"))

    @object_unavailable_alternate_host.setter
    def object_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf22ee2483d49d01f894959886b714505ec362c47728e39aa01c07a9a18a69fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHost")
    def object_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBackupHost"))

    @object_unavailable_backup_host.setter
    def object_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573909fb85ff7138041bcaebf727eb6a02f91a6182ae1442c1b5d36e2074494b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIp")
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableBlacklistOriginIp"))

    @object_unavailable_blacklist_origin_ip.setter
    def object_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892ff1760d88adb1212e20e3270cd436a7e9cd9615c0bd116466886b34229599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindow")
    def object_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBlacklistWindow"))

    @object_unavailable_blacklist_window.setter
    def object_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c04f6d9f855ea242de47a696b93aaf7f714b16e875f4c4d32c5ad63b3d70661)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocol")
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableChangeProtocol"))

    @object_unavailable_change_protocol.setter
    def object_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a2181d9461b97d77992e0ab2f4f19fa2a3fa679179b3b84143cda0a5cc866f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevel")
    def object_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableDetectionLevel"))

    @object_unavailable_detection_level.setter
    def object_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efbd546584ed3aa85a78868acbe3919d719e715f8a4c6e9c33abbda872adbccf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryString")
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableIncludeQueryString"))

    @object_unavailable_include_query_string.setter
    def object_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea094bcfb9c2b133e57537f97875bb837afc9ca159fa11b8abf46c75ad0a8c9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPath")
    def object_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableModifiedPath"))

    @object_unavailable_modified_path.setter
    def object_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2fc0b89c539d217e251a579f97b2ec4042ddd94ef4bbe92f0a526d19f24ed4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPath")
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableModifyRequestPath"))

    @object_unavailable_modify_request_path.setter
    def object_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82036cb67847b5fa9b2e675a64a345e6c80d60e7b3e1ab30ee34778ffc070b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocol")
    def object_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableProtocol"))

    @object_unavailable_protocol.setter
    def object_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033da2fc6d37f7b3dc36506b727f46fca693466e2b54cff009e9c7d667840bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecovery")
    def object_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRecovery"))

    @object_unavailable_recovery.setter
    def object_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40ed6cf0921d5f68381f33e8dbc4d22f01d57407a3bd1f7ac8d854a87d3407c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethod")
    def object_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "objectUnavailableRedirectMethod"))

    @object_unavailable_redirect_method.setter
    def object_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b47472cd03eee24a3715c7831bbbda6ad47193f131124dc394f3e4b78d756826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodes")
    def object_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "objectUnavailableResponseCodes"))

    @object_unavailable_response_codes.setter
    def object_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03cf277621e35d94a91ecf12e6827d394175cd516838213c7023940bda435359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimit")
    def object_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRetryLimit"))

    @object_unavailable_retry_limit.setter
    def object_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66739edba63d1c87d345383562e9d3f1468792665422c00bcdfa9815293567dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHost")
    def origin_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableAlternateHost"))

    @origin_unavailable_alternate_host.setter
    def origin_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54a471f080009ef684e703bde34a1720495ab24e22a12dba0633f44e2486d575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHost")
    def origin_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBackupHost"))

    @origin_unavailable_backup_host.setter
    def origin_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e76d67470a4aa5d7d531e77998e3894939f07bd81486d2853dabb990f50e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIp")
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableBlacklistOriginIp"))

    @origin_unavailable_blacklist_origin_ip.setter
    def origin_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d472d5f3c3b069f29b9755e806ab32c4edd960d947671f4ac7d9f7dee141f508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindow")
    def origin_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBlacklistWindow"))

    @origin_unavailable_blacklist_window.setter
    def origin_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc6476ed210e0748dec2c0663769188ca5b1d4dfb90894fcb01b80dc9b07606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocol")
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableChangeProtocol"))

    @origin_unavailable_change_protocol.setter
    def origin_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1647ad79191b34ebdabc9b1d92c88f45c1fe0c070cbd53b01eff84701925f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevel")
    def origin_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableDetectionLevel"))

    @origin_unavailable_detection_level.setter
    def origin_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157308fece2a223a3cef7e0566cd0ebb35ece758d0418805666f5cdcda31e62d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryString")
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableIncludeQueryString"))

    @origin_unavailable_include_query_string.setter
    def origin_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78d2ed918d0e4c8c9a71c755a8917137c34ada91afd13b93b221de65e24e5371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPath")
    def origin_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableModifiedPath"))

    @origin_unavailable_modified_path.setter
    def origin_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f726498442f048464806b035a7e3501a8e9679654d59a0ed381a4026ca59b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPath")
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableModifyRequestPath"))

    @origin_unavailable_modify_request_path.setter
    def origin_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9ff287e5a296720bb9a2a14aa80213285e182aac08bff47854300169de78e6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocol")
    def origin_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableProtocol"))

    @origin_unavailable_protocol.setter
    def origin_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b29fc13ed15c4760b9f60b55549d5fa61a0112dd3757eeb5914177a1cb0c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecovery")
    def origin_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRecovery"))

    @origin_unavailable_recovery.setter
    def origin_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdaea6328d357e8572140b4a4d34851955e62c529862db7ef6918148881e840b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethod")
    def origin_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnavailableRedirectMethod"))

    @origin_unavailable_redirect_method.setter
    def origin_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82ab5965ca139ad4c7ab91b77a66e125bbb89ecefe5ed3b4f433cedb808668bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodes")
    def origin_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "originUnavailableResponseCodes"))

    @origin_unavailable_response_codes.setter
    def origin_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a2f86796bc5151d1eb7ba11c15d5e6ab5204e05c764311d8c8f7b471006b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimit")
    def origin_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRetryLimit"))

    @origin_unavailable_retry_limit.setter
    def origin_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21146806943e8c97f373e7a6faa2f0c7618ce47f51ca98be1b8858e8d7e39122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHost")
    def origin_unresponsive_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveAlternateHost"))

    @origin_unresponsive_alternate_host.setter
    def origin_unresponsive_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c3928d71ad8af8ed6ea18a1436a3db5ad86c90ec247a9990ca10da71c3cb0f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHost")
    def origin_unresponsive_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBackupHost"))

    @origin_unresponsive_backup_host.setter
    def origin_unresponsive_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d649c8d57c6e7cf1eaed6aa66e94e3716d95c7de5977ec0cc3dcd3c248e3b5bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIp")
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveBlacklistOriginIp"))

    @origin_unresponsive_blacklist_origin_ip.setter
    def origin_unresponsive_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa30921e39249883343696cc69e1bf3f8251ef7d5610fa46c7efa407a030e6d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindow")
    def origin_unresponsive_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBlacklistWindow"))

    @origin_unresponsive_blacklist_window.setter
    def origin_unresponsive_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba999fb039846f49d35fb1869145217f0e735541ca01c0cca7d1b3f2f30795df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocol")
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveChangeProtocol"))

    @origin_unresponsive_change_protocol.setter
    def origin_unresponsive_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__194696ac230f61f68149d3e68f0359ec9c7d9b8498ef8125e61ad0be656b09ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevel")
    def origin_unresponsive_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveDetectionLevel"))

    @origin_unresponsive_detection_level.setter
    def origin_unresponsive_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06966946d3ed524b051c7bb798a257af41ec5d1a616809793be02f6ffcec7a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryString")
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveIncludeQueryString"))

    @origin_unresponsive_include_query_string.setter
    def origin_unresponsive_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e76b8a2f3f6194071f6fd2e38e8c02945939c47a6c4a084e3377b86930f715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPath")
    def origin_unresponsive_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveModifiedPath"))

    @origin_unresponsive_modified_path.setter
    def origin_unresponsive_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4194860f9478625455cbd7226bf84a69721d6301f61795550d167936409a0dff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPath")
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveModifyRequestPath"))

    @origin_unresponsive_modify_request_path.setter
    def origin_unresponsive_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838b1318cdb4b3de1378972e6ae5629ab063448091a2fd2d3379756aeea6d6dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocol")
    def origin_unresponsive_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveProtocol"))

    @origin_unresponsive_protocol.setter
    def origin_unresponsive_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1f06740b76fb95a0a09d696c0d3f0ba7c1ab2f3907a513777fffdd2b8d4e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecovery")
    def origin_unresponsive_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRecovery"))

    @origin_unresponsive_recovery.setter
    def origin_unresponsive_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2b50b4addb60fd82be3cd0595458a52554122db4d38d0cd01ec3fb6b66f106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethod")
    def origin_unresponsive_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnresponsiveRedirectMethod"))

    @origin_unresponsive_redirect_method.setter
    def origin_unresponsive_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07688192917f84c35ebdb37cb9b35cce7aadbf7f25cf7c8a66ba680d0250e383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimit")
    def origin_unresponsive_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRetryLimit"))

    @origin_unresponsive_retry_limit.setter
    def origin_unresponsive_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1fe2b704c31ae8988df8f562fb65d5f3697be1bd91e81e53f39b194c6c040aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="otherOptions")
    def other_options(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "otherOptions"))

    @other_options.setter
    def other_options(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6092c1d8a382a5c12b1ab4300bc76ab092944544d780cd41d367ae85b4c649d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "otherOptions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04104295dc235eb3d288399ef051b4d6269a9f109a641b81e3e021fe572302f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d394d87fe51ef8ccaa51b206b7733f518af90ade0e755fa7b8df27085feddc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95b7ecf49fd9739682013ac0b746a067bdb4431a118bf46ca4d36687461ef6fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2cbb6f1e7365cb51118aea15d44bb8f59e8a2b9a761ca3031fd9251a215c22d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables metadata caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab6973f337543bab51c588d1fbace3eaadebc66cba7085e28eb167a2dc17f25f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e32d299e089abc2bee1d7b6ddf636d85740f2e38e7e1ba36b5ffb20cca87258)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df35c4fd97821d81bcac3dc1c7450c08588aa6d9e1adca2d1f5efb021966fd91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92dfe37ff947e1dd96b76f0e015d3258b3952e32dc746c4abebdb4ef8e9e1f97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b55f4b41ec5ddf69c718f48270df99f61edb7418f90beb554c90f815a6256c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3f69da11ced849efd1e430abe68996809a071bc2cba13790605b48c62a7323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "secondary_multipath_to_origin": "secondaryMultipathToOrigin",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744e476839cac2561c1f7ace5241e684effab73de5a15d596134b0ae877dd5ed)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument secondary_multipath_to_origin", value=secondary_multipath_to_origin, expected_type=type_hints["secondary_multipath_to_origin"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if secondary_multipath_to_origin is not None:
            self._values["secondary_multipath_to_origin"] = secondary_multipath_to_origin
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Mobile App Performance SDK.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends secondary multi-path requests to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        '''
        result = self._values.get("secondary_multipath_to_origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformanceOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformanceOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1557f7f34f84f44f2f46758b8f52510312d7a49b1241d38319dd5f0a75047f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondaryMultipathToOrigin")
    def reset_secondary_multipath_to_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondaryMultipathToOrigin", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOriginInput")
    def secondary_multipath_to_origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondaryMultipathToOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a1f43c5908c96b7b336b03c714a4be0288123bf0bc5149d4fcb479d50a21196)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8074a02a2cd1c778c8a3d07aead3c8be1c8979fa8531de62aef370360b8fab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOrigin")
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondaryMultipathToOrigin"))

    @secondary_multipath_to_origin.setter
    def secondary_multipath_to_origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12da03989c2a96bee0bebb734a79375bdd9353589a2456e68a15584fcd2e25cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondaryMultipathToOrigin", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abddaf4778066f6774a84b835e26f000e6bfd6a91dad5419ec08e2726845cf76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba820733e8d3472d389171f52f685303c57ac03ccfc562856bea8c71c1330d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621b49783009af8c84a452669ead86aaecf4737d8fcbf102dcefb9f14fb90fb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e472e8745790d2cabf524938c3926bef8eafae06c9781948f8028f0b8d35ccce)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Supplies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0b7d0eb0cffbf54862545f01f682ab9288a7317c4f59ecedd8b16821b7d9fa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f727ea70fe0536e27fe9fdd781d0f4007ec9f6fc2ec3dd170b5bcb27f1f0965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3588a38f6f94af6eacb43a66bd694ba90552b9bbf2698cf3af15ce8e365c7d4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5457c41947dc52fb8fc367ea4fe560053a03c6c30f6ab60867ff92323bffa61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e2f1615062efe9c9db0111845b58b38a3ceb101db26f8b0dcbb2480e58af864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4eb3000545e92d1ced3b677c48b1debe2a28f8dbd09b0a4739301cbd13ff3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__218af5ff2ebacd3cc2605517267c88956041ba4622713964530c3a361a37f752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4bb4838a315922318fd778ccd71f1427f035fb140ad166f25884417cd3bbe29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__175e10fc5031421158551dbbd89d07aafe213c33765d1165d14d5b0dc368cdb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__333aad70e449e4c258e9cea9ed44555931f2dd0c4a8d21d8f9cd1e5a569b3c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091dcce9bd7a221d0bf851fcd3c4754de6379e44a0bca2187557dc9cc5e63155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27d171b89c205cf6d877b92919c1dcc9bcce752cc0b86e11bf93a84d7835d35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d173b593c72db40bca740edb5ff46fb8ced7cb76e538ef426e102da7df50fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d857d03c66e8cef633d6173c4536dfb18cbc3682ce927eb18f5f3cf46db78366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edc3943a50a905523191e97ce8afe7dbfab7e1df613925c6815393175fc838fc)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the header's new value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__567d114d13c7e3af82e61b817f03757aab920a880c33e27202bebe6d5f3ff7a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63166d696e1b7213508eb7f039fb33abdde94535add90ae2ca347f5fd5a2b222)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c7ee94cb99c0788f96244ef826d75e9c322b491e0d90be936cc73e2de6d697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3db06952624513eff47edb15e802c9fe22277560b1347fa3e9e47f833311f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a4ddbe7b37d58356f9d7861cc0a5b3063576666c4ccc7a89b350c28c2f777bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cebdbff394f9ea37146b087a0f52eacb77a4b59e2422887f7178fae84a590eb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb02db3bc2b3c278256d59b96e154bba837a660f41b2300686fc586958248977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a99d8d0d48af48cae70b70d8e5507077a16cef161a87045d81ae4a0a82bca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8874077e9f7ce4927be81fdf6b44a993a1872dbdcd8a8c4229973b837fc07a41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb804a7f6ee29de424fdfd9354226c0797457da0a57517c1d011ac4be483e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7471f279a9e2aa9fad53f2f6c88cc5bb5980f7466c3af312a0e7e5b6703963a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd69444bf662f3062fcec74f1af805be81b918538ff98ea8e464a0914921919d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60809e89e0f38ec0ba0f5866ed2c82aa4180d951e47deb5096888633910c2347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b1b251307e7b5606ee06af90b3e01b8664e8fef2824589dc8c85f76fc09d24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca65477d9b97a49b3db020ef04a2ec8c5cdcd72b38129bd5378c0ea775c126b0)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f36c22b460d7faa665b45544e09aaa562afe49c8c757e61d1d9cc64607ce1f37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f2c461743215d704445c169af1a34597e090f33642378b66435655879612134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0b570820fd65706df276cf47ea0f67e784d8cbe8a27dcded5537282c3d0e358)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8139d4be81a41e2c46c88f64fe2013418214dbf56512f4896475720f98848dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a35baa06db79c38678138279cae9ac574fb5bd9b06da5a74274ed619a1ea1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e88324b1dc8fdc657e3c02ba0d1687e72dc99634c2803bb6767cca18b95b46e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__520cdb4fd1c81f9efe81abafecbb5ddd04831cf13b3b1fa10ee19af8962c2d6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5596b67799c6ac19dd6c393fa98241ddb37bd70da87b23d5b0cd86d76f8229d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23c60dca885ad96a50aefa34405447aababa033af3be21d66b306fdc9e63a033)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbce5079a63c99396744261464e0dc9adf31cc52f08bee9f12120247c3171f43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c02571b543d1a93794b09ce245a84037173af16374a340a004734537609d7471)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ef3d39a5171cf97a293d69cc7c5b99714e651bd53652f8f0b8ebd939a9bab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3297627ded301d1e0d41a766a1b07742fefa4585379b4b4b843be5ee5bda4276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__142556a54b4eda5e16a7674d3e16b90d9001cf33a737cf8979cf12c1a9ad05d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a0a245cebd02c5820d20606eef49f4b63e3595e79c431897e75b74a48cecf42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a6456f2d7cb82c2d0425ccbeee7cdedbbc448163477792730862cc679bd642)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cad1ef99ad3dbc3a25c7d6fbce353887591070b201b5bbc7dfe08274c6c5cc81)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the existing value of the header to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c7b6fa4e5a84944460ffc5d3456eea00bf44b5e81b152293b2e4ed27a6a125a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012939652518b7fc62c30969d2734e3a773ffee501f89f522eef8f3b54ebe144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4281d4ca95fd6d59b9e8342d69ddadcb68330b1eef4ac56ef9d08d6f3c7e1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e50a2d9c47a0987326e6a476ae6617a57d4f01e888a74ebddf084e61c97ab1bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4975b0563ca94242276234ee9694668d01dc4ac33c40c6b7cd93bb26a73ddb16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b0ee4016b6e53482c1bf7e77e6ed809eeb24c4f95be6e4a80c0087f46e07e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b4da28a7019d7577bd083389b25f3f0c11a9c6cb11af851f2af2d94abc5d1f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b4809bb3be75e3c3b1d05b28f3875955283772e46ccf58e56aed21ecd7b897c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37af5747afdaf3abc996a1419f1281460a9d209749666ad8fdbfe6fbb5210f1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06899ee0b2210b74b9f5731b2e66e10b3fe9a918c95b75aa7dbcef57dfa9afae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518f728c949f8ad0f2e78c67e704c8e332cb14c6d043993a5d0d051f5fa88288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3bf19007acf3ca048908901f5df1d597412b9f139950c0ebd95ca1b72d8a2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df90174b32ae668b49c2d10f5962e1ccb35aef6404014809de80e1b5012c170c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83116e8215480adda2aeff194ebe8c120abea6a0410780b230f2bce7f55a6dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9a27bff90080076356ff4f33249e39dbd1a4c82705c8c912b84e3638e2eda3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5579c6a00187698e822ee9ab3a9d7033f0966bc434cd2aec041b32cb785b71c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "modification_option": "modificationOption",
        "rename_header_to": "renameHeaderTo",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292358d1f057a2fa7dfc40bf5e7494728fb346fad14ccfefae97aa59639bc2b2)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modification_option", value=modification_option, expected_type=type_hints["modification_option"])
            check_type(argname="argument rename_header_to", value=rename_header_to, expected_type=type_hints["rename_header_to"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modification_option is not None:
            self._values["modification_option"] = modification_option
        if rename_header_to is not None:
            self._values["rename_header_to"] = rename_header_to
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``Via`` header modifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modification_option(self) -> typing.Optional[builtins.str]:
        '''Specify how you want to handle the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        '''
        result = self._values.get("modification_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rename_header_to(self) -> typing.Optional[builtins.str]:
        '''Specifies a new name to replace the existing ``Via`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        '''
        result = self._values.get("rename_header_to")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc3edfe2c37ffcf8dca2d307c408b4b9303eb34224e69749224ff28c2239b9ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModificationOption")
    def reset_modification_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModificationOption", []))

    @jsii.member(jsii_name="resetRenameHeaderTo")
    def reset_rename_header_to(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRenameHeaderTo", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modificationOptionInput")
    def modification_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "modificationOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="renameHeaderToInput")
    def rename_header_to_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "renameHeaderToInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a308ecb8b65e13165da5ebe739d049081f9094b0a7f2d73e4d44c57361fd56f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55d6305b531628a74e7fea95cd43623b1b631f9c728ea440dc4e7bd6d9f44fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modificationOption")
    def modification_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "modificationOption"))

    @modification_option.setter
    def modification_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe66af5774426696232438fc109b31ba5c37a5a7d6aa41ea097121d024e23620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modificationOption", value)

    @builtins.property
    @jsii.member(jsii_name="renameHeaderTo")
    def rename_header_to(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "renameHeaderTo"))

    @rename_header_to.setter
    def rename_header_to(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__116ccbd022c00d7af9427c3b11a0d71f15cec7793abddb478d53dcb375054999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "renameHeaderTo", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbad4c653e751a2fb3be0625a139cfdefc29b0d4a217d0df71e82f563d89635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998651e3694c828d8154bfdf8bb99dacc55d2960353176534b6f071b6244732e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6bd6c8a20dfd1d2eb7cbce0a445b90623a9824201822652b3383d64c995b45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cache_key_hostname": "cacheKeyHostname",
        "compress": "compress",
        "custom_certificate_authorities": "customCertificateAuthorities",
        "custom_certificates": "customCertificates",
        "custom_forward_host_header": "customForwardHostHeader",
        "custom_valid_cn_values": "customValidCnValues",
        "enable_true_client_ip": "enableTrueClientIp",
        "forward_host_header": "forwardHostHeader",
        "hostname": "hostname",
        "http_port": "httpPort",
        "https_port": "httpsPort",
        "ip_version": "ipVersion",
        "locked": "locked",
        "max_tls_version": "maxTlsVersion",
        "min_tls_version": "minTlsVersion",
        "mslorigin": "mslorigin",
        "net_storage": "netStorage",
        "origin_certificate": "originCertificate",
        "origin_certs_to_honor": "originCertsToHonor",
        "origin_id": "originId",
        "origin_sni": "originSni",
        "origin_type": "originType",
        "ports": "ports",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "second_hostname": "secondHostname",
        "second_hostname_enabled": "secondHostnameEnabled",
        "standard_certificate_authorities": "standardCertificateAuthorities",
        "template_uuid": "templateUuid",
        "tls13_support": "tls13Support",
        "tls_version_title": "tlsVersionTitle",
        "true_client_ip_client_setting": "trueClientIpClientSetting",
        "true_client_ip_header": "trueClientIpHeader",
        "use_unique_cache_key": "useUniqueCacheKey",
        "uuid": "uuid",
        "verification_mode": "verificationMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin:
    def __init__(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_tls_version: typing.Optional[builtins.str] = None,
        min_tls_version: typing.Optional[builtins.str] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tls_version_title: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_tls_version: Specifies the maximum TLS version to use for connections to your origin server. As best practice, use ``DYNAMIC`` to automatically apply the latest supported version. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        :param min_tls_version: Specifies the minimum TLS version to use for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tls13_support: Enables transport layer security (TLS) version 1.3 for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        :param tls_version_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__762899253835660b48cfd81938bdc0362574459f2a824e019d93fbedf5ab9b00)
            check_type(argname="argument cache_key_hostname", value=cache_key_hostname, expected_type=type_hints["cache_key_hostname"])
            check_type(argname="argument compress", value=compress, expected_type=type_hints["compress"])
            check_type(argname="argument custom_certificate_authorities", value=custom_certificate_authorities, expected_type=type_hints["custom_certificate_authorities"])
            check_type(argname="argument custom_certificates", value=custom_certificates, expected_type=type_hints["custom_certificates"])
            check_type(argname="argument custom_forward_host_header", value=custom_forward_host_header, expected_type=type_hints["custom_forward_host_header"])
            check_type(argname="argument custom_valid_cn_values", value=custom_valid_cn_values, expected_type=type_hints["custom_valid_cn_values"])
            check_type(argname="argument enable_true_client_ip", value=enable_true_client_ip, expected_type=type_hints["enable_true_client_ip"])
            check_type(argname="argument forward_host_header", value=forward_host_header, expected_type=type_hints["forward_host_header"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument http_port", value=http_port, expected_type=type_hints["http_port"])
            check_type(argname="argument https_port", value=https_port, expected_type=type_hints["https_port"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_tls_version", value=max_tls_version, expected_type=type_hints["max_tls_version"])
            check_type(argname="argument min_tls_version", value=min_tls_version, expected_type=type_hints["min_tls_version"])
            check_type(argname="argument mslorigin", value=mslorigin, expected_type=type_hints["mslorigin"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument origin_certificate", value=origin_certificate, expected_type=type_hints["origin_certificate"])
            check_type(argname="argument origin_certs_to_honor", value=origin_certs_to_honor, expected_type=type_hints["origin_certs_to_honor"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument origin_sni", value=origin_sni, expected_type=type_hints["origin_sni"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument ports", value=ports, expected_type=type_hints["ports"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument second_hostname", value=second_hostname, expected_type=type_hints["second_hostname"])
            check_type(argname="argument second_hostname_enabled", value=second_hostname_enabled, expected_type=type_hints["second_hostname_enabled"])
            check_type(argname="argument standard_certificate_authorities", value=standard_certificate_authorities, expected_type=type_hints["standard_certificate_authorities"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tls13_support", value=tls13_support, expected_type=type_hints["tls13_support"])
            check_type(argname="argument tls_version_title", value=tls_version_title, expected_type=type_hints["tls_version_title"])
            check_type(argname="argument true_client_ip_client_setting", value=true_client_ip_client_setting, expected_type=type_hints["true_client_ip_client_setting"])
            check_type(argname="argument true_client_ip_header", value=true_client_ip_header, expected_type=type_hints["true_client_ip_header"])
            check_type(argname="argument use_unique_cache_key", value=use_unique_cache_key, expected_type=type_hints["use_unique_cache_key"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_mode", value=verification_mode, expected_type=type_hints["verification_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_key_hostname is not None:
            self._values["cache_key_hostname"] = cache_key_hostname
        if compress is not None:
            self._values["compress"] = compress
        if custom_certificate_authorities is not None:
            self._values["custom_certificate_authorities"] = custom_certificate_authorities
        if custom_certificates is not None:
            self._values["custom_certificates"] = custom_certificates
        if custom_forward_host_header is not None:
            self._values["custom_forward_host_header"] = custom_forward_host_header
        if custom_valid_cn_values is not None:
            self._values["custom_valid_cn_values"] = custom_valid_cn_values
        if enable_true_client_ip is not None:
            self._values["enable_true_client_ip"] = enable_true_client_ip
        if forward_host_header is not None:
            self._values["forward_host_header"] = forward_host_header
        if hostname is not None:
            self._values["hostname"] = hostname
        if http_port is not None:
            self._values["http_port"] = http_port
        if https_port is not None:
            self._values["https_port"] = https_port
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if locked is not None:
            self._values["locked"] = locked
        if max_tls_version is not None:
            self._values["max_tls_version"] = max_tls_version
        if min_tls_version is not None:
            self._values["min_tls_version"] = min_tls_version
        if mslorigin is not None:
            self._values["mslorigin"] = mslorigin
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if origin_certificate is not None:
            self._values["origin_certificate"] = origin_certificate
        if origin_certs_to_honor is not None:
            self._values["origin_certs_to_honor"] = origin_certs_to_honor
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if origin_sni is not None:
            self._values["origin_sni"] = origin_sni
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if ports is not None:
            self._values["ports"] = ports
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if second_hostname is not None:
            self._values["second_hostname"] = second_hostname
        if second_hostname_enabled is not None:
            self._values["second_hostname_enabled"] = second_hostname_enabled
        if standard_certificate_authorities is not None:
            self._values["standard_certificate_authorities"] = standard_certificate_authorities
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tls13_support is not None:
            self._values["tls13_support"] = tls13_support
        if tls_version_title is not None:
            self._values["tls_version_title"] = tls_version_title
        if true_client_ip_client_setting is not None:
            self._values["true_client_ip_client_setting"] = true_client_ip_client_setting
        if true_client_ip_header is not None:
            self._values["true_client_ip_header"] = true_client_ip_header
        if use_unique_cache_key is not None:
            self._values["use_unique_cache_key"] = use_unique_cache_key
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_mode is not None:
            self._values["verification_mode"] = verification_mode

    @builtins.property
    def cache_key_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to use when forming a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        '''
        result = self._values.get("cache_key_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compress(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``gzip`` compression for non-NetStorage origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        '''
        result = self._values.get("compress")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_certificate_authorities(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities"]]]:
        '''custom_certificate_authorities block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        '''
        result = self._values.get("custom_certificate_authorities")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities"]]], result)

    @builtins.property
    def custom_certificates(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates"]]]:
        '''custom_certificates block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        '''
        result = self._values.get("custom_certificates")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates"]]], result)

    @builtins.property
    def custom_forward_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the custom host header the edge server should pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        '''
        result = self._values.get("custom_forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_valid_cn_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields.

        Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        '''
        result = self._values.get("custom_valid_cn_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_true_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server.

        This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        '''
        result = self._values.get("enable_true_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_host_header(self) -> typing.Optional[builtins.str]:
        '''When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        '''
        result = self._values.get("forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        '''
        result = self._values.get("http_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def https_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``.

        This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        '''
        result = self._values.get("https_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP version to use when getting content from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_tls_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum TLS version to use for connections to your origin server.

        As best practice, use ``DYNAMIC`` to automatically apply the latest supported version.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        '''
        result = self._values.get("max_tls_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_tls_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the minimum TLS version to use for connections to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        '''
        result = self._values.get("min_tls_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslorigin(self) -> typing.Optional[builtins.str]:
        '''This specifies the media's origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        '''
        result = self._values.get("mslorigin")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage"], result)

    @builtins.property
    def origin_certificate(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        '''
        result = self._values.get("origin_certificate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_certs_to_honor(self) -> typing.Optional[builtins.str]:
        '''Specifies which certificate to trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        '''
        result = self._values.get("origin_certs_to_honor")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the Edge Load Balancing origin.

        This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_sni(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value.

        See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        '''
        result = self._values.get("origin_sni")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Choose where your content is retrieved from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ports(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        '''
        result = self._values.get("ports")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies replacement text for what ``saasRegex`` matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static part of the SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of the request that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        '''
        result = self._values.get("second_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Available only for certain products. This specifies whether you want to use an additional origin server address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        '''
        result = self._values.get("second_hostname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def standard_certificate_authorities(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.'''
        result = self._values.get("standard_certificate_authorities")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tls13_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables transport layer security (TLS) version 1.3 for connections to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        '''
        result = self._values.get("tls13_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tls_version_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        '''
        result = self._values.get("tls_version_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def true_client_ip_client_setting(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin.

        Otherwise the edge server removes it and sets the value itself.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        '''
        result = self._values.get("true_client_ip_client_setting")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def true_client_ip_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        '''
        result = self._values.get("true_client_ip_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_unique_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        '''
        result = self._values.get("use_unique_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_mode(self) -> typing.Optional[builtins.str]:
        '''For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        result = self._values.get("verification_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "access_key_encrypted_storage": "accessKeyEncryptedStorage",
        "adc_title": "adcTitle",
        "authentication_method": "authenticationMethod",
        "authentication_method_title": "authenticationMethodTitle",
        "aws_access_key_id": "awsAccessKeyId",
        "aws_access_key_version_guid": "awsAccessKeyVersionGuid",
        "aws_ar_region": "awsArRegion",
        "aws_host": "awsHost",
        "aws_region": "awsRegion",
        "aws_secret_access_key": "awsSecretAccessKey",
        "aws_service": "awsService",
        "country": "country",
        "custom_sign_string": "customSignString",
        "direct_connect_geo": "directConnectGeo",
        "encoding_version": "encodingVersion",
        "end_point_service": "endPointService",
        "gcs_access_key_version_guid": "gcsAccessKeyVersionGuid",
        "gcs_hmac_key_access_id": "gcsHmacKeyAccessId",
        "gcs_hmac_key_secret": "gcsHmacKeySecret",
        "hostname_tag": "hostnameTag",
        "locked": "locked",
        "mslkey": "mslkey",
        "mslname": "mslname",
        "nonce": "nonce",
        "origin_location_title": "originLocationTitle",
        "property_id_tag": "propertyIdTag",
        "role_arn": "roleArn",
        "secret_key": "secretKey",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics:
    def __init__(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a836cc749658abd87b6d0574af1b7fc1165c8efe315aafdda8f1d502be43c582)
            check_type(argname="argument access_key_encrypted_storage", value=access_key_encrypted_storage, expected_type=type_hints["access_key_encrypted_storage"])
            check_type(argname="argument adc_title", value=adc_title, expected_type=type_hints["adc_title"])
            check_type(argname="argument authentication_method", value=authentication_method, expected_type=type_hints["authentication_method"])
            check_type(argname="argument authentication_method_title", value=authentication_method_title, expected_type=type_hints["authentication_method_title"])
            check_type(argname="argument aws_access_key_id", value=aws_access_key_id, expected_type=type_hints["aws_access_key_id"])
            check_type(argname="argument aws_access_key_version_guid", value=aws_access_key_version_guid, expected_type=type_hints["aws_access_key_version_guid"])
            check_type(argname="argument aws_ar_region", value=aws_ar_region, expected_type=type_hints["aws_ar_region"])
            check_type(argname="argument aws_host", value=aws_host, expected_type=type_hints["aws_host"])
            check_type(argname="argument aws_region", value=aws_region, expected_type=type_hints["aws_region"])
            check_type(argname="argument aws_secret_access_key", value=aws_secret_access_key, expected_type=type_hints["aws_secret_access_key"])
            check_type(argname="argument aws_service", value=aws_service, expected_type=type_hints["aws_service"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument direct_connect_geo", value=direct_connect_geo, expected_type=type_hints["direct_connect_geo"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument end_point_service", value=end_point_service, expected_type=type_hints["end_point_service"])
            check_type(argname="argument gcs_access_key_version_guid", value=gcs_access_key_version_guid, expected_type=type_hints["gcs_access_key_version_guid"])
            check_type(argname="argument gcs_hmac_key_access_id", value=gcs_hmac_key_access_id, expected_type=type_hints["gcs_hmac_key_access_id"])
            check_type(argname="argument gcs_hmac_key_secret", value=gcs_hmac_key_secret, expected_type=type_hints["gcs_hmac_key_secret"])
            check_type(argname="argument hostname_tag", value=hostname_tag, expected_type=type_hints["hostname_tag"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mslkey", value=mslkey, expected_type=type_hints["mslkey"])
            check_type(argname="argument mslname", value=mslname, expected_type=type_hints["mslname"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument origin_location_title", value=origin_location_title, expected_type=type_hints["origin_location_title"])
            check_type(argname="argument property_id_tag", value=property_id_tag, expected_type=type_hints["property_id_tag"])
            check_type(argname="argument role_arn", value=role_arn, expected_type=type_hints["role_arn"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_key_encrypted_storage is not None:
            self._values["access_key_encrypted_storage"] = access_key_encrypted_storage
        if adc_title is not None:
            self._values["adc_title"] = adc_title
        if authentication_method is not None:
            self._values["authentication_method"] = authentication_method
        if authentication_method_title is not None:
            self._values["authentication_method_title"] = authentication_method_title
        if aws_access_key_id is not None:
            self._values["aws_access_key_id"] = aws_access_key_id
        if aws_access_key_version_guid is not None:
            self._values["aws_access_key_version_guid"] = aws_access_key_version_guid
        if aws_ar_region is not None:
            self._values["aws_ar_region"] = aws_ar_region
        if aws_host is not None:
            self._values["aws_host"] = aws_host
        if aws_region is not None:
            self._values["aws_region"] = aws_region
        if aws_secret_access_key is not None:
            self._values["aws_secret_access_key"] = aws_secret_access_key
        if aws_service is not None:
            self._values["aws_service"] = aws_service
        if country is not None:
            self._values["country"] = country
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if direct_connect_geo is not None:
            self._values["direct_connect_geo"] = direct_connect_geo
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if end_point_service is not None:
            self._values["end_point_service"] = end_point_service
        if gcs_access_key_version_guid is not None:
            self._values["gcs_access_key_version_guid"] = gcs_access_key_version_guid
        if gcs_hmac_key_access_id is not None:
            self._values["gcs_hmac_key_access_id"] = gcs_hmac_key_access_id
        if gcs_hmac_key_secret is not None:
            self._values["gcs_hmac_key_secret"] = gcs_hmac_key_secret
        if hostname_tag is not None:
            self._values["hostname_tag"] = hostname_tag
        if locked is not None:
            self._values["locked"] = locked
        if mslkey is not None:
            self._values["mslkey"] = mslkey
        if mslname is not None:
            self._values["mslname"] = mslname
        if nonce is not None:
            self._values["nonce"] = nonce
        if origin_location_title is not None:
            self._values["origin_location_title"] = origin_location_title
        if property_id_tag is not None:
            self._values["property_id_tag"] = property_id_tag
        if role_arn is not None:
            self._values["role_arn"] = role_arn
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def access_key_encrypted_storage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables secure use of access keys defined in Cloud Access Manager.

        Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        '''
        result = self._values.get("access_key_encrypted_storage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def adc_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        '''
        result = self._values.get("adc_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the authentication method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        '''
        result = self._values.get("authentication_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        '''
        result = self._values.get("authentication_method_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_id(self) -> typing.Optional[builtins.str]:
        '''Specifies active access key ID linked to your AWS account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        '''
        result = self._values.get("aws_access_key_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        '''
        result = self._values.get("aws_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_ar_region(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.'''
        result = self._values.get("aws_ar_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes.

        If you leave this option empty, it inherits the hostname from the ``origin`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        '''
        result = self._values.get("aws_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_region(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS region code of the location where your bucket resides.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        '''
        result = self._values.get("aws_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_secret_access_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        '''
        result = self._values.get("aws_secret_access_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_service(self) -> typing.Optional[builtins.str]:
        '''This specifies the subdomain of your AWS service.

        It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        '''
        result = self._values.get("aws_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data to be encrypted as a series of enumerated variable names.

        See ``Built-in system variables`` for guidance on each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def direct_connect_geo(self) -> typing.Optional[builtins.str]:
        '''Provides a region used by Akamai Direct Connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        '''
        result = self._values.get("direct_connect_geo")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def end_point_service(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.'''
        result = self._values.get("end_point_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        '''
        result = self._values.get("gcs_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_access_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the active access ID linked to your Google account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        '''
        result = self._values.get("gcs_hmac_key_access_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_secret(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        '''
        result = self._values.get("gcs_hmac_key_secret")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.'''
        result = self._values.get("hostname_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mslkey(self) -> typing.Optional[builtins.str]:
        '''Specifies the access key provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        '''
        result = self._values.get("mslkey")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin name provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        '''
        result = self._values.get("mslname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the nonce.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_location_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        '''
        result = self._values.get("origin_location_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def property_id_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.'''
        result = self._values.get("property_id_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def role_arn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.'''
        result = self._values.get("role_arn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to customize your signed string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9440c2736afe675eabf2733be3ad49cd2d89dbad7826a28ef329174cf0ac569)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessKeyEncryptedStorage")
    def reset_access_key_encrypted_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessKeyEncryptedStorage", []))

    @jsii.member(jsii_name="resetAdcTitle")
    def reset_adc_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdcTitle", []))

    @jsii.member(jsii_name="resetAuthenticationMethod")
    def reset_authentication_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethod", []))

    @jsii.member(jsii_name="resetAuthenticationMethodTitle")
    def reset_authentication_method_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethodTitle", []))

    @jsii.member(jsii_name="resetAwsAccessKeyId")
    def reset_aws_access_key_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyId", []))

    @jsii.member(jsii_name="resetAwsAccessKeyVersionGuid")
    def reset_aws_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetAwsArRegion")
    def reset_aws_ar_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsArRegion", []))

    @jsii.member(jsii_name="resetAwsHost")
    def reset_aws_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsHost", []))

    @jsii.member(jsii_name="resetAwsRegion")
    def reset_aws_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsRegion", []))

    @jsii.member(jsii_name="resetAwsSecretAccessKey")
    def reset_aws_secret_access_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsSecretAccessKey", []))

    @jsii.member(jsii_name="resetAwsService")
    def reset_aws_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsService", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDirectConnectGeo")
    def reset_direct_connect_geo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDirectConnectGeo", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetEndPointService")
    def reset_end_point_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndPointService", []))

    @jsii.member(jsii_name="resetGcsAccessKeyVersionGuid")
    def reset_gcs_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetGcsHmacKeyAccessId")
    def reset_gcs_hmac_key_access_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeyAccessId", []))

    @jsii.member(jsii_name="resetGcsHmacKeySecret")
    def reset_gcs_hmac_key_secret(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeySecret", []))

    @jsii.member(jsii_name="resetHostnameTag")
    def reset_hostname_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameTag", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMslkey")
    def reset_mslkey(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslkey", []))

    @jsii.member(jsii_name="resetMslname")
    def reset_mslname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslname", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetOriginLocationTitle")
    def reset_origin_location_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginLocationTitle", []))

    @jsii.member(jsii_name="resetPropertyIdTag")
    def reset_property_id_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPropertyIdTag", []))

    @jsii.member(jsii_name="resetRoleArn")
    def reset_role_arn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRoleArn", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorageInput")
    def access_key_encrypted_storage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessKeyEncryptedStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="adcTitleInput")
    def adc_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "adcTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodInput")
    def authentication_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitleInput")
    def authentication_method_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyIdInput")
    def aws_access_key_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyIdInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuidInput")
    def aws_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="awsArRegionInput")
    def aws_ar_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsArRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsHostInput")
    def aws_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsHostInput"))

    @builtins.property
    @jsii.member(jsii_name="awsRegionInput")
    def aws_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKeyInput")
    def aws_secret_access_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsSecretAccessKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="awsServiceInput")
    def aws_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="directConnectGeoInput")
    def direct_connect_geo_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "directConnectGeoInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="endPointServiceInput")
    def end_point_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endPointServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuidInput")
    def gcs_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessIdInput")
    def gcs_hmac_key_access_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeyAccessIdInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecretInput")
    def gcs_hmac_key_secret_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeySecretInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameTagInput")
    def hostname_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hostnameTagInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mslkeyInput")
    def mslkey_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslkeyInput"))

    @builtins.property
    @jsii.member(jsii_name="mslnameInput")
    def mslname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslnameInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="originLocationTitleInput")
    def origin_location_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originLocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="propertyIdTagInput")
    def property_id_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "propertyIdTagInput"))

    @builtins.property
    @jsii.member(jsii_name="roleArnInput")
    def role_arn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "roleArnInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorage")
    def access_key_encrypted_storage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessKeyEncryptedStorage"))

    @access_key_encrypted_storage.setter
    def access_key_encrypted_storage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef0b65387c53044e5a017de9a3fa026727feca3b6ba41e9c0f44c3a8ce86d62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessKeyEncryptedStorage", value)

    @builtins.property
    @jsii.member(jsii_name="adcTitle")
    def adc_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "adcTitle"))

    @adc_title.setter
    def adc_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68289552d6c9dc0056ba14efd67f3a228a0a629270d2f3154ad55f2ef9a30699)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "adcTitle", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethod")
    def authentication_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethod"))

    @authentication_method.setter
    def authentication_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98d60355fa7a2824dc48d4c97d5ac12468fc675f21591816144f63395fe52eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethod", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitle")
    def authentication_method_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethodTitle"))

    @authentication_method_title.setter
    def authentication_method_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c8622c409683ca4674d57e3ff92fb2eceedfc3fccd6c4c917e5c6ef4a6d185d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethodTitle", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyId")
    def aws_access_key_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyId"))

    @aws_access_key_id.setter
    def aws_access_key_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35735da0f8cd73d0420ed8bdf56e81eba680b3b81be218a0d6976d2e3322528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyId", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuid")
    def aws_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyVersionGuid"))

    @aws_access_key_version_guid.setter
    def aws_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca1fd14c66091d428de23d49b572729076565028f149c34a5706bd6146cc3cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="awsArRegion")
    def aws_ar_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsArRegion"))

    @aws_ar_region.setter
    def aws_ar_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06a3895d7eb30a13f429515e2a9e354fe109653236e05671364f266495e7f0f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsArRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsHost")
    def aws_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsHost"))

    @aws_host.setter
    def aws_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__282878aaa2e8133c49cf0e0ee342698be8ae8f126c24d772911cefbf7bcc6fcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsHost", value)

    @builtins.property
    @jsii.member(jsii_name="awsRegion")
    def aws_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsRegion"))

    @aws_region.setter
    def aws_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e4394a419842fa580863b53449091b480ea8f92d119018c461c0fee266b5bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKey")
    def aws_secret_access_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsSecretAccessKey"))

    @aws_secret_access_key.setter
    def aws_secret_access_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8801a7fac274b7215a707c77c143df4bcc4f8e1a59d52e5825ad38134294551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsSecretAccessKey", value)

    @builtins.property
    @jsii.member(jsii_name="awsService")
    def aws_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsService"))

    @aws_service.setter
    def aws_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e468db41fed5c4d232112d6563a7be076d134c19f3ea51928fb3d804e1d4d49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsService", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db77bcb5aab276c519267d326bee4de6ef1e559a2af57c931be470467c157f0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d314eaeaf0ac39a708492cab4c2b372bd2853e242c0a6373e2f5d561e35b9a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="directConnectGeo")
    def direct_connect_geo(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "directConnectGeo"))

    @direct_connect_geo.setter
    def direct_connect_geo(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8561d28772dbc4356f75aeec8dd30f47d662c05fa907332e0c859a37d86b6855)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "directConnectGeo", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55034f5be2654df3c258f1eefdac9c548c8aad6c1cbd4e60bd50655344ff8d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="endPointService")
    def end_point_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endPointService"))

    @end_point_service.setter
    def end_point_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067ae22da91257e542101182086b7bbb0f48e60c0ecd8eb12450c816ed05fffd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endPointService", value)

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuid")
    def gcs_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsAccessKeyVersionGuid"))

    @gcs_access_key_version_guid.setter
    def gcs_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e88224a25ba759d1bc3387a8d8f357001b4387f729c0c66313737cabf6c1550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessId")
    def gcs_hmac_key_access_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeyAccessId"))

    @gcs_hmac_key_access_id.setter
    def gcs_hmac_key_access_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1994618e37cc9de983e78252ff2e89e33e077d98a4d7a25452ce63e915dd8af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeyAccessId", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecret")
    def gcs_hmac_key_secret(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeySecret"))

    @gcs_hmac_key_secret.setter
    def gcs_hmac_key_secret(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d626a80136195da11be3e4de61f2b0cdd52156fff909174db2e71f773667bd4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeySecret", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameTag")
    def hostname_tag(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hostnameTag"))

    @hostname_tag.setter
    def hostname_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e5f416d13826601a4b1bdb0b34cec305fd422d062a31a14bbe0233f3b56915d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameTag", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5104fdeeb6e7b5b71fa4c85c20895c7518c6aed8e398dce1e6a64f0899827afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mslkey")
    def mslkey(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslkey"))

    @mslkey.setter
    def mslkey(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2308bec53ad19448a298da42fbf45decc47cbe850e79788f218ce2b01d192d5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslkey", value)

    @builtins.property
    @jsii.member(jsii_name="mslname")
    def mslname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslname"))

    @mslname.setter
    def mslname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__028e2b101c31f4a407a1e549cf122710536c17b08220792f785ebc71045a3bc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslname", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4035067242683c45545c821dbb8aae844b5abcf0648bf8fb2739e5c869bd454)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="originLocationTitle")
    def origin_location_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originLocationTitle"))

    @origin_location_title.setter
    def origin_location_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3564b766f4d4e11f25e49c5fa1ab3ffa62fb1606cce25ab21c7fbd5a13525900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originLocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="propertyIdTag")
    def property_id_tag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "propertyIdTag"))

    @property_id_tag.setter
    def property_id_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d57e9240291464710694da2e272300a745563b843168f4a90154715f774a0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "propertyIdTag", value)

    @builtins.property
    @jsii.member(jsii_name="roleArn")
    def role_arn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "roleArn"))

    @role_arn.setter
    def role_arn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e58a154c1ad68d31e7eec339e7aa0a4fec667e7e76e2e1d9e14767470f8886d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "roleArn", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__353ded4fbf40bbbad9dd3685c69cdfd6de2860e3da4a803398eec0386d3bd153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f96dbfe77aff84410ea2d1f244712bcf56e55dcdf1802d885fd64fa33408b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5bc1ea64a0afbd35225e99b7e0da9400cc1096a85a888daf5a79f374d5c1a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2da5106d81c4f2b2379eeee73a8bcb34c70937e263136d6c477afe81cd7420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24130f714d9a9b9695222beb393a728fa88b39069509b9a19b53dfc5aaad7457)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origintype": "origintype",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91a1cd8eae77bab234f037c75dff578a29e00d3f230729570e5aa9c817b722ac)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origintype", value=origintype, expected_type=type_hints["origintype"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origintype is not None:
            self._values["origintype"] = origintype
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origintype(self) -> typing.Optional[builtins.str]:
        '''Specifies an origin type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        '''
        result = self._values.get("origintype")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa18a4a07e6688b0bceec0112a8082fa705d056ec93c328651efb6a995c9753)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOrigintype")
    def reset_origintype(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigintype", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="origintypeInput")
    def origintype_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "origintypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec49cfb6145dd5d16e5319b925ceb86086128707b2efbf9cfb25ded7d40e83ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="origintype")
    def origintype(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "origintype"))

    @origintype.setter
    def origintype(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8507ae823be16286d21084c58857fb628595526d1690bdbffc94cbf8bf610b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origintype", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913c09f0ee197a707acd853cee474f35ed02b6ed68fbc6ce9e9262f9d1bace00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ca24cc088ae22fac6f130f938d1af37b11fc69cad6f3f169594226048498cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604fdb7838b8199b01406e67eb408f50fd072e3ff66b88c44b220ba3c2792e47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417112bf9e9ef5e92627a874fe5a438a0ae545b5042b7bc78a30440ccd8c0b20)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174fefe32eb11c1795ff6cbe68043eb03f0c00f1bd7ba2088890f3f97205fdc1)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46cc475ca706c60819387eb77d4fa362b074ea42b61856d6f5e725ae6d884fd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5da096617001da536717db8d8e900171e0ec3345a2425da5a1a499f171cb830b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__919a85132cb7024e70e4bf13dca9b844c61c2cec63f77470fe515aca3ef0b87b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a551db8cba5c7095c80bd3f49d70865521fb0f2662d80438a8611fbbe76fb805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a34c06af366eca8bab59c605b4fec0b58729b4571b078b41fa422d7c06156cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cb5b32db8fd53f57ca625477d2c50c96b774595ed0652be21dc6de14a8575fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aacece7fa58a7db8b7de5695da794f648db9b965efda44b349414766380e0de4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec34129702f04252aa2eed631583507f94cfdbdcc8f3c6c1b113247883c33af3)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3f650670bfc821578077f0d03757068ff42f1a9f55acccfee6b213e6c3f07cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c6845b1d011754d20c6b25e0646138ff2cf744d00fe9ce5df090fae12efc29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b4043f49bcc90980ad901a2372f8ca8261212f6705e50274a1864cc782c7cf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a09a745d581b8e2093ddbb2f1714a27540ae07efbcb8b122006d289cf751e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5190afddc3ee0df1611aa1f2597d3dcaa7ebe9af5ca17e46463fe5f72f249d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc6616745b90eaeac0f773744c1323e6caf191b6f703fdf0e01ff3809343b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9a32562fbcc2811f7f3ffeacbc6dd76ec080ee926b7dc121f27d68113983eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a1dbd07deba2d8df02f7c90af6d141eeed59296c7aa99f560bab9bb1724e3e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__053c807b2a0fbd8d0a0fd42e170cad465521eedefefc42c8e3241057133a0afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72620982c4ab2b7017aa507be084513204de9b14510a5c573c1be04efb53ddb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605a8105d6ad66704b2a4281c83f5cb01cd16b1f0018fd72531f7847641a8139)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d6c6dfb0c20c283c45090e868c108f61ecd0d8d14a4ca7dc5bf9766e96bd2b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581c139d172957192b843edb1ed8c6df873ba5012e53087e5d84d249a680554a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a180d5e24024e0baa5c0312d770e9d4bccbff8cfd556c306ab00baf6d3cd52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2002094aa4759223e2a53dd09f1d35bf57e39f7ae5e335a1f84746b63d0a1db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85365b2c1f89da64b3c96c64b6b4cd2ad52d4df76f414b6c481dd2765bfb361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be58c5a4627f5a9b9aa20a5a1b3203606efb0bdc455222a3e435e8006c2c397d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01dc4ce92b0b1ea2e3d89b0b6449273dbd55a515bfe9ed2e24db9544194fd9b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f39d8e0e14e5802e4db217567bbef1b858e35a60db058700cb30fbf119de94b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5438b10c6401eca243bf33f5a914c5ef4bc95a1bdacff62a3d9c7cea5175e6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d17045272d67f8f3782cc78de592af2e283f432b300b5ef80ebad5fa4fe217d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87cf0ef03b4c0c6d6c779ed47f9ccbb41463eb2ebbd889fd28ef633fc00dce69)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5219bd7a55ab9055e36167e2e1ce5ff80b1ca50efa7dba581eccd0d72e9f3eca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88fc6961e226d5a4388a89270594d5dd627506425dada72cb12a1dd1c7b906e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52669f8609530bb3649886543eafc224e08d2f739b9990ca2104f4320bfb6ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb920de63010bee348d84656f5708f6678f553531f48afd58f116c09f764a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2353033f6484386bb00cb3a5c6b7cec2c8ff3c66ee9119c0413c4d2da06350ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7ee998e6872e6a2a7600cd69e90dd76d720924e5eb42c4c99300447442fb22a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5a18329b20e169bd0c6762a23b4a9926e4bf9a0c04a919ef818ea470343f4a)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43143124127b73db8db764d4a5bc7356f2da153b5268d88867dd4319a4c954df)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b675a967ceabf5c605f5517f0c8edbd6f09599535c935c9bd062974ac75b83f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a55fa71379cdb0e67acf2d58444bd0395588e988688bd30776b69c2926a1f5af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f9bc8daea2962b8dcd9bb1a4e9938cdc679f7d80b756f3892f431ed55bed9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f2afb10147ea9f60dd18cc5ac9387b7832df2309784fd2297e7a5efc4679b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd6c37f4f804c676f42f703c9cd79d29e8e5148f204770ffd7cf09b7a44bad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097c01aa02614304e71f2b276c27c2ac8b84219756a8ce28053cd02f61bcf8ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2405488f652f142523bf28686f5f01a14ef2783f3c7b6629d2b41b87b7e86dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50dc3d10a85882a874285072c9e67bae0bd16446801805ec902066b26935bd8c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fa970c61f5572635d4ccfe0bb6aae65ba6599a1d33af31cd585f82b48903db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bca7cc9fed840ae2745e181a430f5d95a113401428087b586e957f542cc3da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97db26b2f293aba49b77d4f9f8a46661326b3115d22545fd0a397a28b07f3e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bc72c097dd7f8bdab425a1387823a496880239df29d53d02867ed6ea6fa173e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2aa133bbff72de7479ee98a11e16979d271c551ea4d5263ed3b4d3fdcf3c735)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3531b3cce257893744473c88967a811f66b7cc99e8df444577761ecbbffe9764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e22dfb9c9eadebb06dc9a2c785d42d64863473683104c70d248da9f6a7ed843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a37f89e97fafaa10b7e6ec828b483ec5044bb984b3fce9df91983df441d4930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__778e583b0139e7a094770b0650ac2f7d1e4e18221c39150f39bbb4fbaf06b2d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6fbd97c013d5aa3abca1da36ef5b7ef9267e3069108ee769761a675807022c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__914a2dad4a843a87523c55fe77be8eb7be0a49ae4ff0cad79c03ae8e5cc411e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8f5f96df8df88969cf2d930a045af09cf55e96a7a40d2008507313add9a47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c49b28a3a7069fd78857039f1f2c2d81396d1cf33e07639200cf3ac9754184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42cc0709acf33a1da9355e9b5fab40cba4dbaa3cdf1b54c9b5db556359556f18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1ed8c9e4887f86167a0ddc2e2b8844110b9e182243bb84de20428197195144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e24d2163d519de255e501163467a762478f7400c694070c4a0e768801f2276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3e232c06ac8e80d398bbc2b9fbcad6d9d543e63908ce6facf3de1765469ec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37b2a87ec50138779a4113def07b4ffa79455d4707842e621b1f30e32b4da92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44f8acd9f74abcb0b7425939d836673105d33e467f7f23d62640bc8c8300bca0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a2bea5f3df57face16278eaf291fcb95102e1c639b0a8e85313820dba5b3592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa30dbfd11b3fbea26df502248a70ffdbf24de38e31f6b70ae5c4d072e44178a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701987b8cf8b302a9162751ee23b21443a11afe8bcd8cbe8a5bb18b8507cc78a)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3638df956b6eb5cc26ef9ddccf1dde7bcbc5d941e845a65a9c7b56951a3f7b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a244b60d7f5c49aeb32c6b0344c1a526748dd67a09a6896a7dc03ac2172fe54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e685aefb5533a01545a3591964382d0f76b4525209aa608cf9367df05dc640d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e918daabc43ad29a78144304408e3a7a526195d7f77e5e598934de84660795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d680221374c488d033bdd0aac66adca0a1d21f38e29cf9eadd10f7bff880fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5f2ee8d507b0decb784961d3751c7619e628c4ae28b35c1ae3624974b291f6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod",
    jsii_struct_bases=[],
    name_mapping={
        "custom_status_code": "customStatusCode",
        "locked": "locked",
        "recovery_method": "recoveryMethod",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod:
    def __init__(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ca9cd5bbc1fb4f851b5c596d2eea0cddffbe3cd2820c495faac829bbb9c73c)
            check_type(argname="argument custom_status_code", value=custom_status_code, expected_type=type_hints["custom_status_code"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument recovery_method", value=recovery_method, expected_type=type_hints["recovery_method"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_status_code is not None:
            self._values["custom_status_code"] = custom_status_code
        if locked is not None:
            self._values["locked"] = locked
        if recovery_method is not None:
            self._values["recovery_method"] = recovery_method
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom status code to be sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        '''
        result = self._values.get("custom_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def recovery_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        '''
        result = self._values.get("recovery_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a9d92a0c1401e4b557b553cd86e1fb33e253a82b95addaf1340341454bd2d57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomStatusCode")
    def reset_custom_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatusCode", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRecoveryMethod")
    def reset_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryMethod", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customStatusCodeInput")
    def custom_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryMethodInput")
    def recovery_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "recoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatusCode")
    def custom_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatusCode"))

    @custom_status_code.setter
    def custom_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28b3b848153ef2284c6f05039713e8b0a6c0bc72e8b941fcea8126de0f4cb6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e831a4c591683577ab86c38d8e6b0cd03bf53251e605017d512dcd40456820cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="recoveryMethod")
    def recovery_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "recoveryMethod"))

    @recovery_method.setter
    def recovery_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040eba71b60df90b8902a93fa985b1c76d97b1247e19dab232d4234366105bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "recoveryMethod", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66c33e99f95e5f5507ee50120dd0a410ac8ab4b4fe35abe1bd36145b930be208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b0206cc32deac4b2a9b3e27ed3d71662d4c3beae216e6062e752eb058f6984)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da5794173681db8e4de98aeb739cf5b9104b86eb977bcffb3aa03e2f680555a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "binary_equivalent_content": "binaryEquivalentContent",
        "enabled": "enabled",
        "enable_ip_avoidance": "enableIpAvoidance",
        "ip_avoidance_error_threshold": "ipAvoidanceErrorThreshold",
        "ip_avoidance_retry_interval": "ipAvoidanceRetryInterval",
        "locked": "locked",
        "monitor_origin_responsiveness": "monitorOriginResponsiveness",
        "monitor_response_codes1": "monitorResponseCodes1",
        "monitor_response_codes2": "monitorResponseCodes2",
        "monitor_response_codes3": "monitorResponseCodes3",
        "monitor_status_codes1": "monitorStatusCodes1",
        "monitor_status_codes1_enable_recovery": "monitorStatusCodes1EnableRecovery",
        "monitor_status_codes1_enable_retry": "monitorStatusCodes1EnableRetry",
        "monitor_status_codes1_recovery_config_name": "monitorStatusCodes1RecoveryConfigName",
        "monitor_status_codes2": "monitorStatusCodes2",
        "monitor_status_codes2_enable_recovery": "monitorStatusCodes2EnableRecovery",
        "monitor_status_codes2_enable_retry": "monitorStatusCodes2EnableRetry",
        "monitor_status_codes2_recovery_config_name": "monitorStatusCodes2RecoveryConfigName",
        "monitor_status_codes3": "monitorStatusCodes3",
        "monitor_status_codes3_enable_recovery": "monitorStatusCodes3EnableRecovery",
        "monitor_status_codes3_enable_retry": "monitorStatusCodes3EnableRetry",
        "monitor_status_codes3_recovery_config_name": "monitorStatusCodes3RecoveryConfigName",
        "origin_responsiveness_custom_timeout": "originResponsivenessCustomTimeout",
        "origin_responsiveness_enable_recovery": "originResponsivenessEnableRecovery",
        "origin_responsiveness_enable_retry": "originResponsivenessEnableRetry",
        "origin_responsiveness_monitoring": "originResponsivenessMonitoring",
        "origin_responsiveness_recovery_config_name": "originResponsivenessRecoveryConfigName",
        "origin_responsiveness_timeout": "originResponsivenessTimeout",
        "status_code_monitoring1": "statusCodeMonitoring1",
        "status_code_monitoring2": "statusCodeMonitoring2",
        "status_code_monitoring3": "statusCodeMonitoring3",
        "template_uuid": "templateUuid",
        "tuning_parameters": "tuningParameters",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy:
    def __init__(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1912e6773b3dff7c063dccd3cc5cc82dc88ae8afb5346647baad012b6f788d2)
            check_type(argname="argument binary_equivalent_content", value=binary_equivalent_content, expected_type=type_hints["binary_equivalent_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_ip_avoidance", value=enable_ip_avoidance, expected_type=type_hints["enable_ip_avoidance"])
            check_type(argname="argument ip_avoidance_error_threshold", value=ip_avoidance_error_threshold, expected_type=type_hints["ip_avoidance_error_threshold"])
            check_type(argname="argument ip_avoidance_retry_interval", value=ip_avoidance_retry_interval, expected_type=type_hints["ip_avoidance_retry_interval"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument monitor_origin_responsiveness", value=monitor_origin_responsiveness, expected_type=type_hints["monitor_origin_responsiveness"])
            check_type(argname="argument monitor_response_codes1", value=monitor_response_codes1, expected_type=type_hints["monitor_response_codes1"])
            check_type(argname="argument monitor_response_codes2", value=monitor_response_codes2, expected_type=type_hints["monitor_response_codes2"])
            check_type(argname="argument monitor_response_codes3", value=monitor_response_codes3, expected_type=type_hints["monitor_response_codes3"])
            check_type(argname="argument monitor_status_codes1", value=monitor_status_codes1, expected_type=type_hints["monitor_status_codes1"])
            check_type(argname="argument monitor_status_codes1_enable_recovery", value=monitor_status_codes1_enable_recovery, expected_type=type_hints["monitor_status_codes1_enable_recovery"])
            check_type(argname="argument monitor_status_codes1_enable_retry", value=monitor_status_codes1_enable_retry, expected_type=type_hints["monitor_status_codes1_enable_retry"])
            check_type(argname="argument monitor_status_codes1_recovery_config_name", value=monitor_status_codes1_recovery_config_name, expected_type=type_hints["monitor_status_codes1_recovery_config_name"])
            check_type(argname="argument monitor_status_codes2", value=monitor_status_codes2, expected_type=type_hints["monitor_status_codes2"])
            check_type(argname="argument monitor_status_codes2_enable_recovery", value=monitor_status_codes2_enable_recovery, expected_type=type_hints["monitor_status_codes2_enable_recovery"])
            check_type(argname="argument monitor_status_codes2_enable_retry", value=monitor_status_codes2_enable_retry, expected_type=type_hints["monitor_status_codes2_enable_retry"])
            check_type(argname="argument monitor_status_codes2_recovery_config_name", value=monitor_status_codes2_recovery_config_name, expected_type=type_hints["monitor_status_codes2_recovery_config_name"])
            check_type(argname="argument monitor_status_codes3", value=monitor_status_codes3, expected_type=type_hints["monitor_status_codes3"])
            check_type(argname="argument monitor_status_codes3_enable_recovery", value=monitor_status_codes3_enable_recovery, expected_type=type_hints["monitor_status_codes3_enable_recovery"])
            check_type(argname="argument monitor_status_codes3_enable_retry", value=monitor_status_codes3_enable_retry, expected_type=type_hints["monitor_status_codes3_enable_retry"])
            check_type(argname="argument monitor_status_codes3_recovery_config_name", value=monitor_status_codes3_recovery_config_name, expected_type=type_hints["monitor_status_codes3_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_custom_timeout", value=origin_responsiveness_custom_timeout, expected_type=type_hints["origin_responsiveness_custom_timeout"])
            check_type(argname="argument origin_responsiveness_enable_recovery", value=origin_responsiveness_enable_recovery, expected_type=type_hints["origin_responsiveness_enable_recovery"])
            check_type(argname="argument origin_responsiveness_enable_retry", value=origin_responsiveness_enable_retry, expected_type=type_hints["origin_responsiveness_enable_retry"])
            check_type(argname="argument origin_responsiveness_monitoring", value=origin_responsiveness_monitoring, expected_type=type_hints["origin_responsiveness_monitoring"])
            check_type(argname="argument origin_responsiveness_recovery_config_name", value=origin_responsiveness_recovery_config_name, expected_type=type_hints["origin_responsiveness_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_timeout", value=origin_responsiveness_timeout, expected_type=type_hints["origin_responsiveness_timeout"])
            check_type(argname="argument status_code_monitoring1", value=status_code_monitoring1, expected_type=type_hints["status_code_monitoring1"])
            check_type(argname="argument status_code_monitoring2", value=status_code_monitoring2, expected_type=type_hints["status_code_monitoring2"])
            check_type(argname="argument status_code_monitoring3", value=status_code_monitoring3, expected_type=type_hints["status_code_monitoring3"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tuning_parameters", value=tuning_parameters, expected_type=type_hints["tuning_parameters"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if binary_equivalent_content is not None:
            self._values["binary_equivalent_content"] = binary_equivalent_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_ip_avoidance is not None:
            self._values["enable_ip_avoidance"] = enable_ip_avoidance
        if ip_avoidance_error_threshold is not None:
            self._values["ip_avoidance_error_threshold"] = ip_avoidance_error_threshold
        if ip_avoidance_retry_interval is not None:
            self._values["ip_avoidance_retry_interval"] = ip_avoidance_retry_interval
        if locked is not None:
            self._values["locked"] = locked
        if monitor_origin_responsiveness is not None:
            self._values["monitor_origin_responsiveness"] = monitor_origin_responsiveness
        if monitor_response_codes1 is not None:
            self._values["monitor_response_codes1"] = monitor_response_codes1
        if monitor_response_codes2 is not None:
            self._values["monitor_response_codes2"] = monitor_response_codes2
        if monitor_response_codes3 is not None:
            self._values["monitor_response_codes3"] = monitor_response_codes3
        if monitor_status_codes1 is not None:
            self._values["monitor_status_codes1"] = monitor_status_codes1
        if monitor_status_codes1_enable_recovery is not None:
            self._values["monitor_status_codes1_enable_recovery"] = monitor_status_codes1_enable_recovery
        if monitor_status_codes1_enable_retry is not None:
            self._values["monitor_status_codes1_enable_retry"] = monitor_status_codes1_enable_retry
        if monitor_status_codes1_recovery_config_name is not None:
            self._values["monitor_status_codes1_recovery_config_name"] = monitor_status_codes1_recovery_config_name
        if monitor_status_codes2 is not None:
            self._values["monitor_status_codes2"] = monitor_status_codes2
        if monitor_status_codes2_enable_recovery is not None:
            self._values["monitor_status_codes2_enable_recovery"] = monitor_status_codes2_enable_recovery
        if monitor_status_codes2_enable_retry is not None:
            self._values["monitor_status_codes2_enable_retry"] = monitor_status_codes2_enable_retry
        if monitor_status_codes2_recovery_config_name is not None:
            self._values["monitor_status_codes2_recovery_config_name"] = monitor_status_codes2_recovery_config_name
        if monitor_status_codes3 is not None:
            self._values["monitor_status_codes3"] = monitor_status_codes3
        if monitor_status_codes3_enable_recovery is not None:
            self._values["monitor_status_codes3_enable_recovery"] = monitor_status_codes3_enable_recovery
        if monitor_status_codes3_enable_retry is not None:
            self._values["monitor_status_codes3_enable_retry"] = monitor_status_codes3_enable_retry
        if monitor_status_codes3_recovery_config_name is not None:
            self._values["monitor_status_codes3_recovery_config_name"] = monitor_status_codes3_recovery_config_name
        if origin_responsiveness_custom_timeout is not None:
            self._values["origin_responsiveness_custom_timeout"] = origin_responsiveness_custom_timeout
        if origin_responsiveness_enable_recovery is not None:
            self._values["origin_responsiveness_enable_recovery"] = origin_responsiveness_enable_recovery
        if origin_responsiveness_enable_retry is not None:
            self._values["origin_responsiveness_enable_retry"] = origin_responsiveness_enable_retry
        if origin_responsiveness_monitoring is not None:
            self._values["origin_responsiveness_monitoring"] = origin_responsiveness_monitoring
        if origin_responsiveness_recovery_config_name is not None:
            self._values["origin_responsiveness_recovery_config_name"] = origin_responsiveness_recovery_config_name
        if origin_responsiveness_timeout is not None:
            self._values["origin_responsiveness_timeout"] = origin_responsiveness_timeout
        if status_code_monitoring1 is not None:
            self._values["status_code_monitoring1"] = status_code_monitoring1
        if status_code_monitoring2 is not None:
            self._values["status_code_monitoring2"] = status_code_monitoring2
        if status_code_monitoring3 is not None:
            self._values["status_code_monitoring3"] = status_code_monitoring3
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tuning_parameters is not None:
            self._values["tuning_parameters"] = tuning_parameters
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def binary_equivalent_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Synchronizes content between the primary and backup origins, byte for byte.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        '''
        result = self._values.get("binary_equivalent_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates and configures a recovery policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_avoidance(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Temporarily blocks an origin IP address that experienced a certain number of failures.

        When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        '''
        result = self._values.get("enable_ip_avoidance")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip_avoidance_error_threshold(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of failures that need to occur to an origin address before it's blocked.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        '''
        result = self._values.get("ip_avoidance_error_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_avoidance_retry_interval(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of seconds after which the IP address is removed from the blocklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        '''
        result = self._values.get("ip_avoidance_retry_interval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        '''
        result = self._values.get("monitor_origin_responsiveness")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_response_codes1(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        '''
        result = self._values.get("monitor_response_codes1")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes2(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        '''
        result = self._values.get("monitor_response_codes2")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes3(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here..

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        '''
        result = self._values.get("monitor_response_codes3")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_status_codes1(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        '''
        result = self._values.get("monitor_status_codes1")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes1_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        '''
        result = self._values.get("monitor_status_codes1_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes1_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes2(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        '''
        result = self._values.get("monitor_status_codes2")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes2_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        '''
        result = self._values.get("monitor_status_codes2_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes2_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes3(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        '''
        result = self._values.get("monitor_status_codes3")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes3_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        '''
        result = self._values.get("monitor_status_codes3_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes3_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_custom_timeout(self) -> typing.Optional[jsii.Number]:
        '''Specify a custom timeout, from 1 to 10 seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        '''
        result = self._values.get("origin_responsiveness_custom_timeout")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a recovery action for a specific failure condition.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        '''
        result = self._values.get("origin_responsiveness_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        '''
        result = self._values.get("origin_responsiveness_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_monitoring(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        '''
        result = self._values.get("origin_responsiveness_monitoring")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        '''
        result = self._values.get("origin_responsiveness_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_timeout(self) -> typing.Optional[builtins.str]:
        '''The timeout threshold that triggers a retry or recovery action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        '''
        result = self._values.get("origin_responsiveness_timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring1(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        '''
        result = self._values.get("status_code_monitoring1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring2(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        '''
        result = self._values.get("status_code_monitoring2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring3(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        '''
        result = self._values.get("status_code_monitoring3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tuning_parameters(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        '''
        result = self._values.get("tuning_parameters")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a62fabf6b0ebac610d79695c149ad89da1289606656075d40194618c2764fc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBinaryEquivalentContent")
    def reset_binary_equivalent_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBinaryEquivalentContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableIpAvoidance")
    def reset_enable_ip_avoidance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpAvoidance", []))

    @jsii.member(jsii_name="resetIpAvoidanceErrorThreshold")
    def reset_ip_avoidance_error_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceErrorThreshold", []))

    @jsii.member(jsii_name="resetIpAvoidanceRetryInterval")
    def reset_ip_avoidance_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceRetryInterval", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMonitorOriginResponsiveness")
    def reset_monitor_origin_responsiveness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorOriginResponsiveness", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes1")
    def reset_monitor_response_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes1", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes2")
    def reset_monitor_response_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes2", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes3")
    def reset_monitor_response_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1")
    def reset_monitor_status_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRecovery")
    def reset_monitor_status_codes1_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRetry")
    def reset_monitor_status_codes1_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1RecoveryConfigName")
    def reset_monitor_status_codes1_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2")
    def reset_monitor_status_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRecovery")
    def reset_monitor_status_codes2_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRetry")
    def reset_monitor_status_codes2_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2RecoveryConfigName")
    def reset_monitor_status_codes2_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3")
    def reset_monitor_status_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRecovery")
    def reset_monitor_status_codes3_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRetry")
    def reset_monitor_status_codes3_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3RecoveryConfigName")
    def reset_monitor_status_codes3_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3RecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessCustomTimeout")
    def reset_origin_responsiveness_custom_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessCustomTimeout", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRecovery")
    def reset_origin_responsiveness_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRecovery", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRetry")
    def reset_origin_responsiveness_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRetry", []))

    @jsii.member(jsii_name="resetOriginResponsivenessMonitoring")
    def reset_origin_responsiveness_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessMonitoring", []))

    @jsii.member(jsii_name="resetOriginResponsivenessRecoveryConfigName")
    def reset_origin_responsiveness_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessRecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessTimeout")
    def reset_origin_responsiveness_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessTimeout", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring1")
    def reset_status_code_monitoring1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring1", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring2")
    def reset_status_code_monitoring2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring2", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring3")
    def reset_status_code_monitoring3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring3", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTuningParameters")
    def reset_tuning_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTuningParameters", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContentInput")
    def binary_equivalent_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "binaryEquivalentContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidanceInput")
    def enable_ip_avoidance_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpAvoidanceInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThresholdInput")
    def ip_avoidance_error_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceErrorThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryIntervalInput")
    def ip_avoidance_retry_interval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceRetryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsivenessInput")
    def monitor_origin_responsiveness_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorOriginResponsivenessInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1Input")
    def monitor_response_codes1_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2Input")
    def monitor_response_codes2_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3Input")
    def monitor_response_codes3_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecoveryInput")
    def monitor_status_codes1_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetryInput")
    def monitor_status_codes1_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1Input")
    def monitor_status_codes1_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigNameInput")
    def monitor_status_codes1_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes1RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecoveryInput")
    def monitor_status_codes2_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetryInput")
    def monitor_status_codes2_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2Input")
    def monitor_status_codes2_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigNameInput")
    def monitor_status_codes2_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes2RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecoveryInput")
    def monitor_status_codes3_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetryInput")
    def monitor_status_codes3_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3Input")
    def monitor_status_codes3_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigNameInput")
    def monitor_status_codes3_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes3RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeoutInput")
    def origin_responsiveness_custom_timeout_input(
        self,
    ) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originResponsivenessCustomTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecoveryInput")
    def origin_responsiveness_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetryInput")
    def origin_responsiveness_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoringInput")
    def origin_responsiveness_monitoring_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigNameInput")
    def origin_responsiveness_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessRecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeoutInput")
    def origin_responsiveness_timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1Input")
    def status_code_monitoring1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring1Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2Input")
    def status_code_monitoring2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring2Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3Input")
    def status_code_monitoring3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring3Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tuningParametersInput")
    def tuning_parameters_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tuningParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContent")
    def binary_equivalent_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "binaryEquivalentContent"))

    @binary_equivalent_content.setter
    def binary_equivalent_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cb231fe1321c91d39a2ad4e6985fa782876cb202e4bde9fdb9725b481af2df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "binaryEquivalentContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb9b910243df2a05615b955d530a1d9ebc8b984bcbb44fe90f621babdfdd1d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidance")
    def enable_ip_avoidance(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpAvoidance"))

    @enable_ip_avoidance.setter
    def enable_ip_avoidance(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5699763c5b2712423500e2a3157d70fb6eb2e8ae23fc794ad3f0a7974c98d763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpAvoidance", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThreshold")
    def ip_avoidance_error_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceErrorThreshold"))

    @ip_avoidance_error_threshold.setter
    def ip_avoidance_error_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a7811a30067071ea6943eda6279f7292b7a0bd6eaf16eb64da6e5b720b07388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceErrorThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryInterval")
    def ip_avoidance_retry_interval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceRetryInterval"))

    @ip_avoidance_retry_interval.setter
    def ip_avoidance_retry_interval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce94db2513719a2855fa66c9932e68420f3bc59bd9f17260569e58a67d0bbc59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceRetryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f4910783214ab1325bf7bbb2d7aefe0985f3de9149ccd37be1dceb065fdd55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsiveness")
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorOriginResponsiveness"))

    @monitor_origin_responsiveness.setter
    def monitor_origin_responsiveness(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6067b4a44be0c2975fa6dcc585907ab639557a3c0cd4945858e90a2089779ac3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorOriginResponsiveness", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1")
    def monitor_response_codes1(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes1"))

    @monitor_response_codes1.setter
    def monitor_response_codes1(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef4c9888325972c6e98d5c669e830c744e69cc8322dec75a6cd25c7be37b99d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2")
    def monitor_response_codes2(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes2"))

    @monitor_response_codes2.setter
    def monitor_response_codes2(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4caf7e1fe3ed2b390bc313e0cb2e6e08805a937ee68014f615a9573c778ba992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3")
    def monitor_response_codes3(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes3"))

    @monitor_response_codes3.setter
    def monitor_response_codes3(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f609e23cd06e2251c02eb0715d4a2e39019f8212a2f0530eae547eac6a11be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1")
    def monitor_status_codes1(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1"))

    @monitor_status_codes1.setter
    def monitor_status_codes1(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311161cdcfaabd41e4b25041acdcb5d169f4a8bddd2cdec69af0dc6aa55089ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecovery")
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRecovery"))

    @monitor_status_codes1_enable_recovery.setter
    def monitor_status_codes1_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a361fbd610b5396d9a187617de0e0d09fbbc985655bf64becb272df502f498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetry")
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRetry"))

    @monitor_status_codes1_enable_retry.setter
    def monitor_status_codes1_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade84d1c71e8fa8368a75224e54d16bb3d6d8e48c7f491cbfd97709315660d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigName")
    def monitor_status_codes1_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes1RecoveryConfigName"))

    @monitor_status_codes1_recovery_config_name.setter
    def monitor_status_codes1_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c73bd7561cc108d55991fb06397dcb029dc3ad6290a8cf2ee4cfb1b3c76afb63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2")
    def monitor_status_codes2(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2"))

    @monitor_status_codes2.setter
    def monitor_status_codes2(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f849edde0c7958d0ec80313bc7c9dc4387b7e3aab1e956582d3958858c48d47c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecovery")
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRecovery"))

    @monitor_status_codes2_enable_recovery.setter
    def monitor_status_codes2_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e055eb9f1377230bbe90a7b58a7c302e679c2b40a7ee196325a8aeb54f92d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetry")
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRetry"))

    @monitor_status_codes2_enable_retry.setter
    def monitor_status_codes2_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ff95dffe2361ffa83fc6986440ced130ee35d11c56e082a585c1f1ab8ee4b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigName")
    def monitor_status_codes2_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes2RecoveryConfigName"))

    @monitor_status_codes2_recovery_config_name.setter
    def monitor_status_codes2_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13a1a1ed3077e0c16eab2ee938911970f467738314416f46f91ce7a30123a3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3")
    def monitor_status_codes3(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3"))

    @monitor_status_codes3.setter
    def monitor_status_codes3(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a41de9102f00a5912e0286dcd534001d45c7f8523817b46fa5c37484a30876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecovery")
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRecovery"))

    @monitor_status_codes3_enable_recovery.setter
    def monitor_status_codes3_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a46982d47c67210e96197c9c92682cccdf05c606f1d758fea20d9b445dbc109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetry")
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRetry"))

    @monitor_status_codes3_enable_retry.setter
    def monitor_status_codes3_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33dbcfe5a6579bfe6d0f8e130bf0918b8d2ec363eb1873d5972e5ceefd3a7764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigName")
    def monitor_status_codes3_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes3RecoveryConfigName"))

    @monitor_status_codes3_recovery_config_name.setter
    def monitor_status_codes3_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56d4f0adabc5d3c1fd8f4fab15f8c1f95980e74f6f906229874257a0ab8ba83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeout")
    def origin_responsiveness_custom_timeout(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originResponsivenessCustomTimeout"))

    @origin_responsiveness_custom_timeout.setter
    def origin_responsiveness_custom_timeout(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9425b430b4bde7d75c8f5499c49e6d39f4baee7b716943333df58951a9319739)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessCustomTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecovery")
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRecovery"))

    @origin_responsiveness_enable_recovery.setter
    def origin_responsiveness_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e534d2a0c2b56e344f906d80b3e4d4dcf02b93e54cfc4967fe886d5235ca7b65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetry")
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRetry"))

    @origin_responsiveness_enable_retry.setter
    def origin_responsiveness_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663a00b319e9f24a2dced4dd245d9268306fe7f926fbe63690553bf82ec79061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoring")
    def origin_responsiveness_monitoring(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessMonitoring"))

    @origin_responsiveness_monitoring.setter
    def origin_responsiveness_monitoring(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397bf0fc8d11cab79ef215be8f55ea6fc63c291ca35c3434dda9650906b6682e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigName")
    def origin_responsiveness_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessRecoveryConfigName"))

    @origin_responsiveness_recovery_config_name.setter
    def origin_responsiveness_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abe35cece8a6957d2f7ac59d614f4160081a6f401ba56592fbd20ffe69ab6e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessRecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeout")
    def origin_responsiveness_timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessTimeout"))

    @origin_responsiveness_timeout.setter
    def origin_responsiveness_timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d380166c6a813a2da85ca43502a9b5d628333ef0de3fc55ea7bbdfd50a584f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1")
    def status_code_monitoring1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring1"))

    @status_code_monitoring1.setter
    def status_code_monitoring1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__790ce1d8b3b6eb0701537abf11178eee52da2d910a05d030eb8af4f260557fb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring1", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2")
    def status_code_monitoring2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring2"))

    @status_code_monitoring2.setter
    def status_code_monitoring2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab6e3b9ee861787842b6b50c671cc490817f9956bd322bbdda4211f42ce04a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring2", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3")
    def status_code_monitoring3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring3"))

    @status_code_monitoring3.setter
    def status_code_monitoring3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d08cb49da472fcac9c62dc95ffa865eaadb5a8ba2c45d91cf609a547d00e97c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring3", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28025517199c39cbe4380e4ea49a78bde2c3b827ebbc91bd61fa52ae7494a2d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tuningParameters")
    def tuning_parameters(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tuningParameters"))

    @tuning_parameters.setter
    def tuning_parameters(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d19b8da21bbeb11310f9b8687569340ab97b586ca6dffcd037eddfbfcdcd651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tuningParameters", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32365a4376167b5e140b7b613ca18c0f89fbed5c1c5a9abb765be8de1bc28b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78364f959a32cb19987e1f24c061386b0fc145c773a78d2ae989b7f3460126ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9124639f64c1c1c1faae8aaca7f7e5153c14b92f89d8ce6d6412b8131a89289e)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Origin IP Access Control List behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAclOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAclOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f3a54df5ad8f8c3666562c7ede463558132ac29bf89a405606c26c5d0e8d24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208a3064bc1687fc0870dd8ace58305c575a62574428c482370969a7baee8b54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2638ad3a2aff84c02b02d3ad484350080c0258ea0cd0902ceff7b5e989be28e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ed926fcb24ab9b54fef111ccfb2ec8d1385d3b27016583ed8262e673dc2d7a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ec529fa691d6e3daad5e817eee6a842d3c55887f58b34cea526e9e64d00492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__424310c62aea3c605e5d72c839e46442491ffbf3cf1f451b56680d3aed32f803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72448256e4a84c56333ef48f2e6468570054f4e7b1b4393c1fb3b99d48f25a9d)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d9a6fde1d030f5d8e8ddb3f699bc517dbc8277ec9edb5b5f3642adb90673035)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d7b66120ce44e088d9b91963a8f6162213093abd038f3c3e860d18d59e2d45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150c3b36e2e2e730b82185666943316dce685c443cbe9219699fcb665091959c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38f64cf583a89e89f354e74d84f1f25bc13f2e0a68598c6a61d0113f3291ade)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9246c7c1d0c2a639c36715cd3caf778c8f852114092c7f5fc20d44213a33781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f108fcf508bf35b4b5f7af88774c486882b7e6e3bdd80c8132396bd89747530)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCustomCertificateAuthorities")
    def put_custom_certificate_authorities(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046966f7612f4599e11a0b0d0dfdfbbabf209815c0e71738af9dd2a94373e23e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificateAuthorities", [value]))

    @jsii.member(jsii_name="putCustomCertificates")
    def put_custom_certificates(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910dec8f6425c846d7a04d192fc8fd4184e6839fc33092945d50cb96959752c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificates", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetCacheKeyHostname")
    def reset_cache_key_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyHostname", []))

    @jsii.member(jsii_name="resetCompress")
    def reset_compress(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompress", []))

    @jsii.member(jsii_name="resetCustomCertificateAuthorities")
    def reset_custom_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificateAuthorities", []))

    @jsii.member(jsii_name="resetCustomCertificates")
    def reset_custom_certificates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificates", []))

    @jsii.member(jsii_name="resetCustomForwardHostHeader")
    def reset_custom_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomForwardHostHeader", []))

    @jsii.member(jsii_name="resetCustomValidCnValues")
    def reset_custom_valid_cn_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValidCnValues", []))

    @jsii.member(jsii_name="resetEnableTrueClientIp")
    def reset_enable_true_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTrueClientIp", []))

    @jsii.member(jsii_name="resetForwardHostHeader")
    def reset_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHostHeader", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetHttpPort")
    def reset_http_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpPort", []))

    @jsii.member(jsii_name="resetHttpsPort")
    def reset_https_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpsPort", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxTlsVersion")
    def reset_max_tls_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxTlsVersion", []))

    @jsii.member(jsii_name="resetMinTlsVersion")
    def reset_min_tls_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinTlsVersion", []))

    @jsii.member(jsii_name="resetMslorigin")
    def reset_mslorigin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslorigin", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetOriginCertificate")
    def reset_origin_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertificate", []))

    @jsii.member(jsii_name="resetOriginCertsToHonor")
    def reset_origin_certs_to_honor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertsToHonor", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetOriginSni")
    def reset_origin_sni(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSni", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetPorts")
    def reset_ports(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPorts", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetSecondHostname")
    def reset_second_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostname", []))

    @jsii.member(jsii_name="resetSecondHostnameEnabled")
    def reset_second_hostname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostnameEnabled", []))

    @jsii.member(jsii_name="resetStandardCertificateAuthorities")
    def reset_standard_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardCertificateAuthorities", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTls13Support")
    def reset_tls13_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTls13Support", []))

    @jsii.member(jsii_name="resetTlsVersionTitle")
    def reset_tls_version_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsVersionTitle", []))

    @jsii.member(jsii_name="resetTrueClientIpClientSetting")
    def reset_true_client_ip_client_setting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpClientSetting", []))

    @jsii.member(jsii_name="resetTrueClientIpHeader")
    def reset_true_client_ip_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpHeader", []))

    @jsii.member(jsii_name="resetUseUniqueCacheKey")
    def reset_use_unique_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseUniqueCacheKey", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationMode")
    def reset_verification_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationMode", []))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthorities")
    def custom_certificate_authorities(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesList, jsii.get(self, "customCertificateAuthorities"))

    @builtins.property
    @jsii.member(jsii_name="customCertificates")
    def custom_certificates(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesList, jsii.get(self, "customCertificates"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostnameInput")
    def cache_key_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheKeyHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="compressInput")
    def compress_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthoritiesInput")
    def custom_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "customCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificatesInput")
    def custom_certificates_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]]], jsii.get(self, "customCertificatesInput"))

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeaderInput")
    def custom_forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customForwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="customValidCnValuesInput")
    def custom_valid_cn_values_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customValidCnValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIpInput")
    def enable_true_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTrueClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeaderInput")
    def forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="httpPortInput")
    def http_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpPortInput"))

    @builtins.property
    @jsii.member(jsii_name="httpsPortInput")
    def https_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpsPortInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxTlsVersionInput")
    def max_tls_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxTlsVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="minTlsVersionInput")
    def min_tls_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minTlsVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="msloriginInput")
    def mslorigin_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "msloriginInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertificateInput")
    def origin_certificate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonorInput")
    def origin_certs_to_honor_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertsToHonorInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="originSniInput")
    def origin_sni_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originSniInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="portsInput")
    def ports_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "portsInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabledInput")
    def second_hostname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondHostnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameInput")
    def second_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthoritiesInput")
    def standard_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "standardCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tls13SupportInput")
    def tls13_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tls13SupportInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsVersionTitleInput")
    def tls_version_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tlsVersionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSettingInput")
    def true_client_ip_client_setting_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "trueClientIpClientSettingInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeaderInput")
    def true_client_ip_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trueClientIpHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKeyInput")
    def use_unique_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useUniqueCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationModeInput")
    def verification_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostname")
    def cache_key_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheKeyHostname"))

    @cache_key_hostname.setter
    def cache_key_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd3bde8499101aa5ff7ca3922d5198260d2a7f6d70c1fedce97d0dcdf9bf98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKeyHostname", value)

    @builtins.property
    @jsii.member(jsii_name="compress")
    def compress(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compress"))

    @compress.setter
    def compress(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ad4f8b6497338a8a0fb8ae09bb73cbc5c1ed33e3818950ae2a92db5a919dd4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compress", value)

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeader")
    def custom_forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customForwardHostHeader"))

    @custom_forward_host_header.setter
    def custom_forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2542d2262d4bc3aa576be5798e39c759b3b0f86a2bef6d488e0bee6a62ed25ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customForwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="customValidCnValues")
    def custom_valid_cn_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customValidCnValues"))

    @custom_valid_cn_values.setter
    def custom_valid_cn_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6fc1806b5b885c6151daed434ef3f1ddc4374fcea63e8cd53aabbd5f073753c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValidCnValues", value)

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIp")
    def enable_true_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTrueClientIp"))

    @enable_true_client_ip.setter
    def enable_true_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4777f3f3e5e58db069fd25b28e56b9084c2be57d64cad3031b29805f21169a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTrueClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeader")
    def forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardHostHeader"))

    @forward_host_header.setter
    def forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cae096c52e30e395f34c4373a6c1d54d1637f982cc5fcdbf472e7b54d93d671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0541c8a6c3cae14683646e75a7d2e56b17189b5d4359f8c8bbf0dac5cd12ce4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="httpPort")
    def http_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpPort"))

    @http_port.setter
    def http_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da73ee38e49eb9029ae8a40a151e04c057f3fcd9f5ddf8c31abcaeeb11e38534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpPort", value)

    @builtins.property
    @jsii.member(jsii_name="httpsPort")
    def https_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpsPort"))

    @https_port.setter
    def https_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654ad1b6e7ea5fa7d9f2096d87bc333d7b35fff5dd6c11f8f5b4eaa494e1f916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpsPort", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93608280ec5b09f2cb2bb0de9d5d7840fc5b335c347c0719cead68cf7b830db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78b0b6355a9672ca4a66b0aaed23aca40aa697f8add2d310658f996c2e32944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxTlsVersion")
    def max_tls_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxTlsVersion"))

    @max_tls_version.setter
    def max_tls_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3f5ec6b38dc49d19d63bc2663237d50964b4a842530ecddb52be4c3bf63290)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxTlsVersion", value)

    @builtins.property
    @jsii.member(jsii_name="minTlsVersion")
    def min_tls_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minTlsVersion"))

    @min_tls_version.setter
    def min_tls_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__511df80424d18f0571a8033427ceb154c5d2dc8173e2a0a5809e86971d512563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minTlsVersion", value)

    @builtins.property
    @jsii.member(jsii_name="mslorigin")
    def mslorigin(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslorigin"))

    @mslorigin.setter
    def mslorigin(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8393fd69229f19e310983ebdebf5ff5df4c67acdbefe1ae2c8b2af884c674d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslorigin", value)

    @builtins.property
    @jsii.member(jsii_name="originCertificate")
    def origin_certificate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertificate"))

    @origin_certificate.setter
    def origin_certificate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff650f6bc4923e187ee629b7a93dae40e08da45825e360d0c808f3ef9527b169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonor")
    def origin_certs_to_honor(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertsToHonor"))

    @origin_certs_to_honor.setter
    def origin_certs_to_honor(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d68ab9b036ac43eba83974efdebf937a8e858ea6fedcef23136c7a4b2c2a219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertsToHonor", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1de6310a6a95b7778b23cc2b9b23e79f3f7c1a1e0b5d6b85202b63bb94ca4adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="originSni")
    def origin_sni(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originSni"))

    @origin_sni.setter
    def origin_sni(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b7c2148acbd106dc3097f8576a23bfae39b20e362ed5ecaf5404d0c3fba917)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSni", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efb8ca01345d353b1ecbe58f0e502daf010a930933b558352bb98ee5d4bced9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="ports")
    def ports(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ports"))

    @ports.setter
    def ports(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408215ddc295da428e5e4ba0675a5704b6127d5cb72aedde8c3d3fa89ffcec8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ports", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73a61fb6d4202ffbf61a714bac76916be1cf9b3a955b9260f2fdfa48d0a4d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c034ee03d0b4e03ae2959d7d4e5c20132c9e9d75dd0f43c15be78644df079fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf4a123577efac58d8b690d1c211a0ffae75dc785d32fd3b5eb127ea2c84350)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab313077e72cfef5567b3e092e8c837e31e9ed2045d84a6033c18c76fd6723a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__751057d3f9a46b9a454f6e294227b1c36c95dc9ed74fbaa24d49d8bba6788ab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648e00e12c0b004af0b515fb4c5b31dda8cf795faf3ebf4bd5a5df1fb1d8a95b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c5d332a14f1e7b4dbceaf1e2e7e4b42ae58155fd53b9082ca0ded33d7bd91a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb8ce8a7541fe49918e99c8e3007ab3f275588deb77d4797e24035366ca78cd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostname")
    def second_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondHostname"))

    @second_hostname.setter
    def second_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1df8c8d5da936548fc5371e1de0a5418575145724f93ba9965d52ef3b781eff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostname", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabled")
    def second_hostname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondHostnameEnabled"))

    @second_hostname_enabled.setter
    def second_hostname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__007842b47c7f1e3792f5923f95086483be8f077aa0b21cf1445cb1484fe83a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthorities")
    def standard_certificate_authorities(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "standardCertificateAuthorities"))

    @standard_certificate_authorities.setter
    def standard_certificate_authorities(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f70e66001f70b212c5f67b345813aea43b02a274369efaeb86a96dbbd87769ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardCertificateAuthorities", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253b6aa8a5b7d4e7e4ae5d5d24f55b3c222bcbf7fcbf5b71ff96b17484e55beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tls13Support")
    def tls13_support(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tls13Support"))

    @tls13_support.setter
    def tls13_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ed2888af9db63d87393e0886239fad82fe7e0219f48864ded38daa737996866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tls13Support", value)

    @builtins.property
    @jsii.member(jsii_name="tlsVersionTitle")
    def tls_version_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tlsVersionTitle"))

    @tls_version_title.setter
    def tls_version_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__009912b94d4d2d33e8389eaf35657524e770e91c58bca1282d04e7d158244dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsVersionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSetting")
    def true_client_ip_client_setting(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "trueClientIpClientSetting"))

    @true_client_ip_client_setting.setter
    def true_client_ip_client_setting(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b4d0dbf66740f02667ea591dab9394c95e8f6797debae78c3be0a73de3f201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpClientSetting", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeader")
    def true_client_ip_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trueClientIpHeader"))

    @true_client_ip_header.setter
    def true_client_ip_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da56324fc9a7d935fb9daedb5120cd4062018ae01f0e50137980218bf9430e1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpHeader", value)

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKey")
    def use_unique_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useUniqueCacheKey"))

    @use_unique_cache_key.setter
    def use_unique_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59293b2513e3d4ee507268c04e883acdaee6b4a3f5380cdf2a7dd46942e1da46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useUniqueCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e60e58b5f930c942cac26d5be5547ef7cee894f69c20b5f86ad3a66e86f74d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationMode")
    def verification_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationMode"))

    @verification_mode.setter
    def verification_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88324a9c7b5efd72a945d87335a1466e2d88651a1d2d07c154a1293dfe02ef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ca38e76a6eed889ce304892c64dfad9aa2a6af46cd4d76d2453f131e6d9115)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32757a4d8fc8487fa3fce0b0910fafc77282c68eac9774b6bf261caa11eef98d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdaptiveAcceleration")
    def put_adaptive_acceleration(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration(
            ab_logic=ab_logic,
            ab_testing=ab_testing,
            compression=compression,
            cookie_name=cookie_name,
            enable_brotli_compression=enable_brotli_compression,
            enable_for_noncacheable=enable_for_noncacheable,
            enable_preconnect=enable_preconnect,
            enable_push=enable_push,
            enable_ro=enable_ro,
            locked=locked,
            preload_enable=preload_enable,
            source=source,
            template_uuid=template_uuid,
            title_brotli=title_brotli,
            title_http2_server_push=title_http2_server_push,
            title_preconnect=title_preconnect,
            title_preload=title_preload,
            title_ro=title_ro,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveAcceleration", [value]))

    @jsii.member(jsii_name="putAdaptiveImageCompression")
    def put_adaptive_image_compression(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression(
            compress_mobile=compress_mobile,
            compress_standard=compress_standard,
            locked=locked,
            template_uuid=template_uuid,
            tier1_mobile_compression_method=tier1_mobile_compression_method,
            tier1_mobile_compression_value=tier1_mobile_compression_value,
            tier1_standard_compression_method=tier1_standard_compression_method,
            tier1_standard_compression_value=tier1_standard_compression_value,
            tier2_mobile_compression_method=tier2_mobile_compression_method,
            tier2_mobile_compression_value=tier2_mobile_compression_value,
            tier2_standard_compression_method=tier2_standard_compression_method,
            tier2_standard_compression_value=tier2_standard_compression_value,
            tier3_mobile_compression_method=tier3_mobile_compression_method,
            tier3_mobile_compression_value=tier3_mobile_compression_value,
            tier3_standard_compression_method=tier3_standard_compression_method,
            tier3_standard_compression_value=tier3_standard_compression_value,
            title_aic_mobile=title_aic_mobile,
            title_aic_nonmobile=title_aic_nonmobile,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveImageCompression", [value]))

    @jsii.member(jsii_name="putAdScalerCircuitBreaker")
    def put_ad_scaler_circuit_breaker(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker(
            fallback_action_response_code_based=fallback_action_response_code_based,
            locked=locked,
            response_code_based=response_code_based,
            response_codes=response_codes,
            response_delay_based=response_delay_based,
            response_delay_threshold=response_delay_threshold,
            return_error_response_code_based=return_error_response_code_based,
            specify_your_own_response_code_based=specify_your_own_response_code_based,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdScalerCircuitBreaker", [value]))

    @jsii.member(jsii_name="putAdvanced")
    def put_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvanced", [value]))

    @jsii.member(jsii_name="putAggregatedReporting")
    def put_aggregated_reporting(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting(
            attribute1=attribute1,
            attribute2=attribute2,
            attribute3=attribute3,
            attribute4=attribute4,
            attributes_count=attributes_count,
            enabled=enabled,
            locked=locked,
            report_name=report_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAggregatedReporting", [value]))

    @jsii.member(jsii_name="putAkamaizer")
    def put_akamaizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizer", [value]))

    @jsii.member(jsii_name="putAkamaizerTag")
    def put_akamaizer_tag(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag(
            include_tags_attribute=include_tags_attribute,
            locked=locked,
            match_hostname=match_hostname,
            replace_all=replace_all,
            replacement_hostname=replacement_hostname,
            scope=scope,
            tags_attribute=tags_attribute,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizerTag", [value]))

    @jsii.member(jsii_name="putAllHttpInCacheHierarchy")
    def put_all_http_in_cache_hierarchy(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllHttpInCacheHierarchy", [value]))

    @jsii.member(jsii_name="putAllowCloudletsOrigins")
    def put_allow_cloudlets_origins(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins(
            enabled=enabled,
            honor_base_directory=honor_base_directory,
            locked=locked,
            purge_origin_query_parameter=purge_origin_query_parameter,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowCloudletsOrigins", [value]))

    @jsii.member(jsii_name="putAllowDelete")
    def put_allow_delete(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete(
            allow_body=allow_body,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowDelete", [value]))

    @jsii.member(jsii_name="putAllowHttpsCacheKeySharing")
    def put_allow_https_cache_key_sharing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsCacheKeySharing", [value]))

    @jsii.member(jsii_name="putAllowHttpsDowngrade")
    def put_allow_https_downgrade(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsDowngrade", [value]))

    @jsii.member(jsii_name="putAllowOptions")
    def put_allow_options(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowOptions", [value]))

    @jsii.member(jsii_name="putAllowPatch")
    def put_allow_patch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPatch", [value]))

    @jsii.member(jsii_name="putAllowPost")
    def put_allow_post(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost(
            allow_without_content_length=allow_without_content_length,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPost", [value]))

    @jsii.member(jsii_name="putAllowPut")
    def put_allow_put(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPut", [value]))

    @jsii.member(jsii_name="putAllowTransferEncoding")
    def put_allow_transfer_encoding(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowTransferEncoding", [value]))

    @jsii.member(jsii_name="putAltSvcHeader")
    def put_alt_svc_header(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader(
            locked=locked, max_age=max_age, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAltSvcHeader", [value]))

    @jsii.member(jsii_name="putApiPrioritization")
    def put_api_prioritization(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization(
            alternate_response_cache_ttl=alternate_response_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            net_storage=net_storage,
            net_storage_path=net_storage_path,
            template_uuid=template_uuid,
            throttled_cp_code=throttled_cp_code,
            throttled_status_code=throttled_status_code,
            use_throttled_cp_code=use_throttled_cp_code,
            use_throttled_status_code=use_throttled_status_code,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApiPrioritization", [value]))

    @jsii.member(jsii_name="putApplicationLoadBalancer")
    def put_application_load_balancer(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer(
            all_down_net_storage=all_down_net_storage,
            all_down_net_storage_file=all_down_net_storage_file,
            all_down_status_code=all_down_status_code,
            all_down_title=all_down_title,
            allow_cache_prefresh=allow_cache_prefresh,
            cached_content_title=cached_content_title,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            failover_attempts_threshold=failover_attempts_threshold,
            failover_mode=failover_mode,
            failover_origin_map=failover_origin_map,
            failover_status_codes=failover_status_codes,
            failover_title=failover_title,
            label=label,
            locked=locked,
            origin_cookie_name=origin_cookie_name,
            specify_stickiness_cookie_domain=specify_stickiness_cookie_domain,
            stickiness_cookie_automatic_salt=stickiness_cookie_automatic_salt,
            stickiness_cookie_domain=stickiness_cookie_domain,
            stickiness_cookie_salt=stickiness_cookie_salt,
            stickiness_cookie_set_http_only_flag=stickiness_cookie_set_http_only_flag,
            stickiness_cookie_type=stickiness_cookie_type,
            stickiness_duration=stickiness_duration,
            stickiness_expiration_date=stickiness_expiration_date,
            stickiness_refresh=stickiness_refresh,
            stickiness_title=stickiness_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApplicationLoadBalancer", [value]))

    @jsii.member(jsii_name="putAudienceSegmentation")
    def put_audience_segmentation(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_automatic_salt=population_cookie_automatic_salt,
            population_cookie_domain=population_cookie_domain,
            population_cookie_include_rule_name=population_cookie_include_rule_name,
            population_cookie_salt=population_cookie_salt,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_refresh=population_refresh,
            population_title=population_title,
            segment_tracking_cookie_name=segment_tracking_cookie_name,
            segment_tracking_custom_header=segment_tracking_custom_header,
            segment_tracking_method=segment_tracking_method,
            segment_tracking_query_param=segment_tracking_query_param,
            segment_tracking_title=segment_tracking_title,
            specify_population_cookie_domain=specify_population_cookie_domain,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAudienceSegmentation", [value]))

    @jsii.member(jsii_name="putAutoDomainValidation")
    def put_auto_domain_validation(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation(
            autodv=autodv, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAutoDomainValidation", [value]))

    @jsii.member(jsii_name="putBaseDirectory")
    def put_base_directory(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putBaseDirectory", [value_]))

    @jsii.member(jsii_name="putBossBeaconing")
    def put_boss_beaconing(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing(
            conditional_error_pattern=conditional_error_pattern,
            conditional_http_status=conditional_http_status,
            conditional_sampling_frequency=conditional_sampling_frequency,
            cpcodes=cpcodes,
            enabled=enabled,
            forward_type=forward_type,
            locked=locked,
            request_type=request_type,
            sampling_frequency=sampling_frequency,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBossBeaconing", [value]))

    @jsii.member(jsii_name="putBreadcrumbs")
    def put_breadcrumbs(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs(
            enabled=enabled,
            locked=locked,
            logging_enabled=logging_enabled,
            opt_mode=opt_mode,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBreadcrumbs", [value]))

    @jsii.member(jsii_name="putBreakConnection")
    def put_break_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBreakConnection", [value]))

    @jsii.member(jsii_name="putBrotli")
    def put_brotli(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBrotli", [value]))

    @jsii.member(jsii_name="putCacheError")
    def put_cache_error(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError(
            enabled=enabled,
            locked=locked,
            preserve_stale=preserve_stale,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheError", [value]))

    @jsii.member(jsii_name="putCacheId")
    def put_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId(
            elements=elements,
            include_value=include_value,
            locked=locked,
            optional=optional,
            rule=rule,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheId", [value]))

    @jsii.member(jsii_name="putCacheKeyIgnoreCase")
    def put_cache_key_ignore_case(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyIgnoreCase", [value]))

    @jsii.member(jsii_name="putCacheKeyQueryParams")
    def put_cache_key_query_params(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams(
            behavior=behavior,
            exact_match=exact_match,
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyQueryParams", [value]))

    @jsii.member(jsii_name="putCacheKeyRewrite")
    def put_cache_key_rewrite(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite(
            locked=locked, purge_key=purge_key, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyRewrite", [value]))

    @jsii.member(jsii_name="putCachePost")
    def put_cache_post(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_body=use_body,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCachePost", [value]))

    @jsii.member(jsii_name="putCacheRedirect")
    def put_cache_redirect(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheRedirect", [value]))

    @jsii.member(jsii_name="putCacheTag")
    def put_cache_tag(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag(
            locked=locked, tag=tag, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTag", [value]))

    @jsii.member(jsii_name="putCacheTagVisible")
    def put_cache_tag_visible(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTagVisible", [value]))

    @jsii.member(jsii_name="putCaching")
    def put_caching(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching(
            behavior=behavior,
            cacheability_settings=cacheability_settings,
            cache_control_directives=cache_control_directives,
            default_ttl=default_ttl,
            enhanced_rfc_support=enhanced_rfc_support,
            expiration_settings=expiration_settings,
            honor_max_age=honor_max_age,
            honor_must_revalidate=honor_must_revalidate,
            honor_no_cache=honor_no_cache,
            honor_no_store=honor_no_store,
            honor_private=honor_private,
            honor_proxy_revalidate=honor_proxy_revalidate,
            honor_s_maxage=honor_s_maxage,
            locked=locked,
            must_revalidate=must_revalidate,
            revalidation_settings=revalidation_settings,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCaching", [value]))

    @jsii.member(jsii_name="putCentralAuthorization")
    def put_central_authorization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCentralAuthorization", [value]))

    @jsii.member(jsii_name="putChaseRedirects")
    def put_chase_redirects(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects(
            enabled=enabled,
            limit=limit,
            locked=locked,
            serve404=serve404,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChaseRedirects", [value]))

    @jsii.member(jsii_name="putClientCertificateAuth")
    def put_client_certificate_auth(
        self,
        *,
        client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param client_certificate_attributes: Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        :param enable: Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param enable_client_certificate_validation_status: Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        :param enable_complete_client_certificate: Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth(
            client_certificate_attributes=client_certificate_attributes,
            enable=enable,
            enable_client_certificate_validation_status=enable_client_certificate_validation_status,
            enable_complete_client_certificate=enable_complete_client_certificate,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificateAuth", [value]))

    @jsii.member(jsii_name="putClientCharacteristics")
    def put_client_characteristics(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics(
            country=country, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putClientCharacteristics", [value]))

    @jsii.member(jsii_name="putCloudInterconnects")
    def put_cloud_interconnects(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects(
            cloud_locations=cloud_locations,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudInterconnects", [value]))

    @jsii.member(jsii_name="putCloudWrapper")
    def put_cloud_wrapper(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper(
            enabled=enabled,
            location=location,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapper", [value]))

    @jsii.member(jsii_name="putCloudWrapperAdvanced")
    def put_cloud_wrapper_advanced(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced(
            custom_failover_map=custom_failover_map,
            enabled=enabled,
            failover_map=failover_map,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapperAdvanced", [value]))

    @jsii.member(jsii_name="putCommonMediaClientData")
    def put_common_media_client_data(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData(
            enable_cmcd_segment_prefetch=enable_cmcd_segment_prefetch,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCommonMediaClientData", [value]))

    @jsii.member(jsii_name="putConditionalOrigin")
    def put_conditional_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putConditionalOrigin", [value]))

    @jsii.member(jsii_name="putConstructResponse")
    def put_construct_response(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse(
            body=body,
            enabled=enabled,
            force_eviction=force_eviction,
            ignore_purge=ignore_purge,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putConstructResponse", [value]))

    @jsii.member(jsii_name="putContentCharacteristics")
    def put_content_characteristics(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristics", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsAmd")
    def put_content_characteristics_amd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_dash_custom=segment_duration_dash_custom,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hds_custom=segment_duration_hds_custom,
            segment_duration_hls=segment_duration_hls,
            segment_duration_hls_custom=segment_duration_hls_custom,
            segment_duration_smooth=segment_duration_smooth,
            segment_duration_smooth_custom=segment_duration_smooth_custom,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsAmd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsDd")
    def put_content_characteristics_dd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            optimize_option=optimize_option,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsDd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLargeFile")
    def put_content_characteristics_wsd_large_file(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLargeFile", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLive")
    def put_content_characteristics_wsd_live(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLive", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdVod")
    def put_content_characteristics_wsd_vod(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdVod", [value]))

    @jsii.member(jsii_name="putContentPrePosition")
    def put_content_pre_position(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition(
            enabled=enabled,
            first_location=first_location,
            locked=locked,
            second_location=second_location,
            source_type=source_type,
            targets=targets,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentPrePosition", [value]))

    @jsii.member(jsii_name="putContentTargetingProtection")
    def put_content_targeting_protection(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection(
            countries=countries,
            dmas=dmas,
            enabled=enabled,
            enable_geo_protection=enable_geo_protection,
            enable_geo_redirect_on_deny=enable_geo_redirect_on_deny,
            enable_ip_protection=enable_ip_protection,
            enable_ip_redirect_on_deny=enable_ip_redirect_on_deny,
            enable_referrer_protection=enable_referrer_protection,
            enable_referrer_redirect_on_deny=enable_referrer_redirect_on_deny,
            geo_protection_mode=geo_protection_mode,
            geo_protection_title=geo_protection_title,
            geo_redirect_url=geo_redirect_url,
            ip_addresses=ip_addresses,
            ip_protection_mode=ip_protection_mode,
            ip_protection_title=ip_protection_title,
            ip_redirect_url=ip_redirect_url,
            locked=locked,
            override_ip_addresses=override_ip_addresses,
            referrer_domains=referrer_domains,
            referrer_protection_mode=referrer_protection_mode,
            referrer_protection_title=referrer_protection_title,
            referrer_redirect_url=referrer_redirect_url,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentTargetingProtection", [value]))

    @jsii.member(jsii_name="putCorsSupport")
    def put_cors_support(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport(
            allow_credentials=allow_credentials,
            allow_headers=allow_headers,
            allow_origins=allow_origins,
            enabled=enabled,
            expose_headers=expose_headers,
            headers=headers,
            locked=locked,
            methods=methods,
            origins=origins,
            preflight_max_age=preflight_max_age,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCorsSupport", [value]))

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value_]))

    @jsii.member(jsii_name="putCustomBehavior")
    def put_custom_behavior(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior(
            behavior_id=behavior_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCustomBehavior", [value]))

    @jsii.member(jsii_name="putDatastream")
    def put_datastream(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream(
            beacon_stream_title=beacon_stream_title,
            collect_midgress_traffic=collect_midgress_traffic,
            datastream_ids=datastream_ids,
            enabled=enabled,
            locked=locked,
            log_enabled=log_enabled,
            log_stream_name=log_stream_name,
            log_stream_title=log_stream_title,
            sampling_percentage=sampling_percentage,
            stream_type=stream_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDatastream", [value]))

    @jsii.member(jsii_name="putDcp")
    def put_dcp(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp(
            anonymous=anonymous,
            enabled=enabled,
            gwenabled=gwenabled,
            locked=locked,
            namespace_id=namespace_id,
            template_uuid=template_uuid,
            tlsenabled=tlsenabled,
            uuid=uuid,
            wsenabled=wsenabled,
        )

        return typing.cast(None, jsii.invoke(self, "putDcp", [value]))

    @jsii.member(jsii_name="putDcpAuthHmacTransformation")
    def put_dcp_auth_hmac_transformation(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation(
            hash_conversion_algorithm=hash_conversion_algorithm,
            hash_conversion_key=hash_conversion_key,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthHmacTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthRegexTransformation")
    def put_dcp_auth_regex_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation(
            locked=locked,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthRegexTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthSubstringTransformation")
    def put_dcp_auth_substring_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation(
            locked=locked,
            substring_end=substring_end,
            substring_start=substring_start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthSubstringTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthVariableExtractor")
    def put_dcp_auth_variable_extractor(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor(
            certificate_field=certificate_field,
            dcp_mutual_auth_processing_variable_id=dcp_mutual_auth_processing_variable_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthVariableExtractor", [value]))

    @jsii.member(jsii_name="putDcpDefaultAuthzGroups")
    def put_dcp_default_authz_groups(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups(
            group_names=group_names,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDefaultAuthzGroups", [value]))

    @jsii.member(jsii_name="putDcpDevRelations")
    def put_dcp_dev_relations(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations(
            custom_values=custom_values,
            enabled=enabled,
            hostname=hostname,
            locked=locked,
            path=path,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDevRelations", [value]))

    @jsii.member(jsii_name="putDcpRealTimeAuth")
    def put_dcp_real_time_auth(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth(
            extract_hostname=extract_hostname,
            extract_jurisdiction=extract_jurisdiction,
            extract_namespace=extract_namespace,
            hostname_claim=hostname_claim,
            jurisdiction_claim=jurisdiction_claim,
            locked=locked,
            namespace_claim=namespace_claim,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpRealTimeAuth", [value]))

    @jsii.member(jsii_name="putDeliveryReceipt")
    def put_delivery_receipt(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeliveryReceipt", [value]))

    @jsii.member(jsii_name="putDenyAccess")
    def put_deny_access(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess(
            enabled=enabled,
            locked=locked,
            reason=reason,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDenyAccess", [value]))

    @jsii.member(jsii_name="putDenyDirectFailoverAccess")
    def put_deny_direct_failover_access(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDenyDirectFailoverAccess", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicCacheId")
    def put_device_characteristic_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicCacheId", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicHeader")
    def put_device_characteristic_header(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicHeader", [value]))

    @jsii.member(jsii_name="putDnsAsyncRefresh")
    def put_dns_async_refresh(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsAsyncRefresh", [value]))

    @jsii.member(jsii_name="putDnsPrefresh")
    def put_dns_prefresh(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh(
            delay=delay,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsPrefresh", [value]))

    @jsii.member(jsii_name="putDowngradeProtocol")
    def put_downgrade_protocol(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDowngradeProtocol", [value]))

    @jsii.member(jsii_name="putDownloadCompleteMarker")
    def put_download_complete_marker(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadCompleteMarker", [value]))

    @jsii.member(jsii_name="putDownloadNotification")
    def put_download_notification(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadNotification", [value]))

    @jsii.member(jsii_name="putDownstreamCache")
    def put_downstream_cache(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache(
            allow_behavior=allow_behavior,
            behavior=behavior,
            locked=locked,
            send_headers=send_headers,
            send_private=send_private,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDownstreamCache", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimization")
    def put_dynamic_throughtput_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimization", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimizationOverride")
    def put_dynamic_throughtput_optimization_override(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride(
            locked=locked,
            template_uuid=template_uuid,
            throughput=throughput,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimizationOverride", [value]))

    @jsii.member(jsii_name="putDynamicWebContent")
    def put_dynamic_web_content(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent(
            image_compression=image_compression,
            locked=locked,
            prefetch=prefetch,
            real_user_monitoring=real_user_monitoring,
            sure_route=sure_route,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicWebContent", [value]))

    @jsii.member(jsii_name="putEcmsBulkUpload")
    def put_ecms_bulk_upload(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsBulkUpload", [value]))

    @jsii.member(jsii_name="putEcmsDatabase")
    def put_ecms_database(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase(
            database=database,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDatabase", [value]))

    @jsii.member(jsii_name="putEcmsDataset")
    def put_ecms_dataset(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset(
            dataset=dataset,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDataset", [value]))

    @jsii.member(jsii_name="putEcmsObjectKey")
    def put_ecms_object_key(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey(
            locked=locked, regex=regex, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsObjectKey", [value]))

    @jsii.member(jsii_name="putEdgeConnect")
    def put_edge_connect(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect(
            aggregate_lines=aggregate_lines,
            aggregate_size=aggregate_size,
            aggregate_time=aggregate_time,
            api_connector=api_connector,
            api_data_elements=api_data_elements,
            destination_hostname=destination_hostname,
            destination_path=destination_path,
            enabled=enabled,
            locked=locked,
            override_aggregate_settings=override_aggregate_settings,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeConnect", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingAdvanced")
    def put_edge_load_balancing_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingAdvanced", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingDataCenter")
    def put_edge_load_balancing_data_center(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter(
            cookie_name=cookie_name,
            description=description,
            enable_failover=enable_failover,
            failover_rules=failover_rules,
            failover_title=failover_title,
            hostname=hostname,
            ip=ip,
            locked=locked,
            origin_id=origin_id,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingDataCenter", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingOrigin")
    def put_edge_load_balancing_origin(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin(
            cookie_name=cookie_name,
            description=description,
            enable_session_persistence=enable_session_persistence,
            hostname=hostname,
            id=id,
            locked=locked,
            session_persistence_title=session_persistence_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingOrigin", [value]))

    @jsii.member(jsii_name="putEdgeOriginAuthorization")
    def put_edge_origin_authorization(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization(
            cookie_name=cookie_name,
            domain=domain,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeOriginAuthorization", [value_]))

    @jsii.member(jsii_name="putEdgeRedirector")
    def put_edge_redirector(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeRedirector", [value]))

    @jsii.member(jsii_name="putEdgeScape")
    def put_edge_scape(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeScape", [value]))

    @jsii.member(jsii_name="putEdgeSideIncludes")
    def put_edge_side_includes(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes(
            detect_injection=detect_injection,
            enabled=enabled,
            enable_via_http=enable_via_http,
            i18_n_charset=i18_n_charset,
            i18_n_status=i18_n_status,
            locked=locked,
            pass_client_ip=pass_client_ip,
            pass_set_cookie=pass_set_cookie,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeSideIncludes", [value]))

    @jsii.member(jsii_name="putEdgeWorker")
    def put_edge_worker(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse_information: typing.Optional[builtins.str] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param m_pulse: Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see ``Integrate mPulse reports with EdgeWorkers``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param m_pulse_information: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker(
            create_edge_worker=create_edge_worker,
            edge_worker_id=edge_worker_id,
            enabled=enabled,
            locked=locked,
            m_pulse=m_pulse,
            m_pulse_information=m_pulse_information,
            resource_tier=resource_tier,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorker", [value]))

    @jsii.member(jsii_name="putEnforceMtlsSettings")
    def put_enforce_mtls_settings(
        self,
        *,
        certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_authority_set: Specify the client certificate authority (CA) sets you want to support in client requests. Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        :param enable_auth_set: Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        :param enable_deny_request: This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        :param enable_ocsp_status: Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings(
            certificate_authority_set=certificate_authority_set,
            enable_auth_set=enable_auth_set,
            enable_deny_request=enable_deny_request,
            enable_ocsp_status=enable_ocsp_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEnforceMtlsSettings", [value]))

    @jsii.member(jsii_name="putEnhancedAkamaiProtocol")
    def put_enhanced_akamai_protocol(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedAkamaiProtocol", [value]))

    @jsii.member(jsii_name="putEnhancedProxyDetection")
    def put_enhanced_proxy_detection(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection(
            anonymous_vpn=anonymous_vpn,
            best_practice_action=best_practice_action,
            best_practice_redirecturl=best_practice_redirecturl,
            detect_anonymous_vpn=detect_anonymous_vpn,
            detect_anonymous_vpn_action=detect_anonymous_vpn_action,
            detect_anonymous_vpn_redirecturl=detect_anonymous_vpn_redirecturl,
            detect_hosting_provider=detect_hosting_provider,
            detect_hosting_provider_action=detect_hosting_provider_action,
            detect_hosting_provider_redirecturl=detect_hosting_provider_redirecturl,
            detect_public_proxy=detect_public_proxy,
            detect_public_proxy_action=detect_public_proxy_action,
            detect_public_proxy_redirecturl=detect_public_proxy_redirecturl,
            detect_residential_proxy=detect_residential_proxy,
            detect_residential_proxy_action=detect_residential_proxy_action,
            detect_residential_proxy_redirecturl=detect_residential_proxy_redirecturl,
            detect_smart_dns_proxy=detect_smart_dns_proxy,
            detect_smart_dns_proxy_action=detect_smart_dns_proxy_action,
            detect_smart_dns_proxy_redirecturl=detect_smart_dns_proxy_redirecturl,
            detect_tor_exit_node=detect_tor_exit_node,
            detect_tor_exit_node_action=detect_tor_exit_node_action,
            detect_tor_exit_node_redirecturl=detect_tor_exit_node_redirecturl,
            detect_vpn_data_center=detect_vpn_data_center,
            detect_vpn_data_center_action=detect_vpn_data_center_action,
            detect_vpn_data_center_redirecturl=detect_vpn_data_center_redirecturl,
            enable_configuration_mode=enable_configuration_mode,
            enabled=enabled,
            forward_header_enrichment=forward_header_enrichment,
            hosting_provider=hosting_provider,
            locked=locked,
            public_proxy=public_proxy,
            residential_proxy=residential_proxy,
            smart_dns_proxy=smart_dns_proxy,
            template_uuid=template_uuid,
            tor_exit_node=tor_exit_node,
            uuid=uuid,
            vpn_data_center=vpn_data_center,
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedProxyDetection", [value]))

    @jsii.member(jsii_name="putEpdForwardHeaderEnrichment")
    def put_epd_forward_header_enrichment(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEpdForwardHeaderEnrichment", [value]))

    @jsii.member(jsii_name="putFailAction")
    def put_fail_action(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction(
            action_type=action_type,
            allow_fcm_parent_override=allow_fcm_parent_override,
            cex_custom_path=cex_custom_path,
            cex_hostname=cex_hostname,
            cex_path=cex_path,
            content_custom_path=content_custom_path,
            content_hostname=content_hostname,
            content_path=content_path,
            cp_code=cp_code,
            dynamic_custom_path=dynamic_custom_path,
            dynamic_method=dynamic_method,
            dynamic_path=dynamic_path,
            enabled=enabled,
            locked=locked,
            modify_protocol=modify_protocol,
            net_storage_hostname=net_storage_hostname,
            net_storage_path=net_storage_path,
            preserve_query_string=preserve_query_string,
            protocol=protocol,
            redirect_custom_path=redirect_custom_path,
            redirect_hostname=redirect_hostname,
            redirect_hostname_type=redirect_hostname_type,
            redirect_method=redirect_method,
            redirect_path=redirect_path,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailAction", [value]))

    @jsii.member(jsii_name="putFailoverBotManagerFeatureCompatibility")
    def put_failover_bot_manager_feature_compatibility(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility(
            compatibility=compatibility,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailoverBotManagerFeatureCompatibility", [value]))

    @jsii.member(jsii_name="putFastInvalidate")
    def put_fast_invalidate(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFastInvalidate", [value]))

    @jsii.member(jsii_name="putFips")
    def put_fips(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFips", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketing")
    def put_first_party_marketing(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketing", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketingPlus")
    def put_first_party_marketing_plus(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketingPlus", [value]))

    @jsii.member(jsii_name="putForwardRewrite")
    def put_forward_rewrite(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putForwardRewrite", [value]))

    @jsii.member(jsii_name="putG2Oheader")
    def put_g2_oheader(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader(
            custom_sign_string=custom_sign_string,
            data_header=data_header,
            enabled=enabled,
            encoding_version=encoding_version,
            locked=locked,
            nonce=nonce,
            secret_key=secret_key,
            signed_header=signed_header,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putG2Oheader", [value]))

    @jsii.member(jsii_name="putGlobalRequestNumber")
    def put_global_request_number(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber(
            header_name=header_name,
            locked=locked,
            output_option=output_option,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putGlobalRequestNumber", [value]))

    @jsii.member(jsii_name="putGraphqlCaching")
    def put_graphql_caching(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching(
            advanced=advanced,
            cache_responses_with_errors=cache_responses_with_errors,
            enabled=enabled,
            locked=locked,
            operations_json_body_parameter_name=operations_json_body_parameter_name,
            operations_url_query_parameter_name=operations_url_query_parameter_name,
            post_request_processing_error_handling=post_request_processing_error_handling,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putGraphqlCaching", [value]))

    @jsii.member(jsii_name="putGzipResponse")
    def put_gzip_response(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putGzipResponse", [value]))

    @jsii.member(jsii_name="putHdDataAdvanced")
    def put_hd_data_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putHdDataAdvanced", [value]))

    @jsii.member(jsii_name="putHealthDetection")
    def put_health_detection(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection(
            locked=locked,
            maximum_reconnects=maximum_reconnects,
            retry_count=retry_count,
            retry_interval=retry_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHealthDetection", [value]))

    @jsii.member(jsii_name="putHsafEipBinding")
    def put_hsaf_eip_binding(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding(
            custom_extracted_serial=custom_extracted_serial,
            enabled=enabled,
            hash_max_value=hash_max_value,
            hash_min_value=hash_min_value,
            locked=locked,
            template_uuid=template_uuid,
            tier=tier,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHsafEipBinding", [value]))

    @jsii.member(jsii_name="putHttp2")
    def put_http2(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp2", [value]))

    @jsii.member(jsii_name="putHttp3")
    def put_http3(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp3", [value]))

    @jsii.member(jsii_name="putHttpStrictTransportSecurity")
    def put_http_strict_transport_security(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity(
            enable=enable,
            include_sub_domains=include_sub_domains,
            locked=locked,
            max_age=max_age,
            preload=preload,
            redirect=redirect,
            redirect_status_code=redirect_status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHttpStrictTransportSecurity", [value]))

    @jsii.member(jsii_name="putHttpToHttpsUpgrade")
    def put_http_to_https_upgrade(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade(
            locked=locked, template_uuid=template_uuid, upgrade=upgrade, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttpToHttpsUpgrade", [value]))

    @jsii.member(jsii_name="putImageAndVideoManager")
    def put_image_and_video_manager(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager(
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            image_set=image_set,
            locked=locked,
            policy_set_type=policy_set_type,
            resize=resize,
            template_uuid=template_uuid,
            uuid=uuid,
            video_set=video_set,
        )

        return typing.cast(None, jsii.invoke(self, "putImageAndVideoManager", [value]))

    @jsii.member(jsii_name="putImageManager")
    def put_image_manager(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManager", [value]))

    @jsii.member(jsii_name="putImageManagerVideo")
    def put_image_manager_video(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManagerVideo", [value]))

    @jsii.member(jsii_name="putImOverride")
    def put_im_override(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride(
            dpr=dpr,
            dprvar=dprvar,
            exclude_all_query_parameters=exclude_all_query_parameters,
            excluded_query_parameters=excluded_query_parameters,
            format=format,
            formatvar=formatvar,
            locked=locked,
            override=override,
            policy=policy,
            policyvar=policyvar,
            policyvar_i_mvar=policyvar_i_mvar,
            policyvar_name=policyvar_name,
            template_uuid=template_uuid,
            typesel=typesel,
            uuid=uuid,
            width=width,
            widthvar=widthvar,
        )

        return typing.cast(None, jsii.invoke(self, "putImOverride", [value]))

    @jsii.member(jsii_name="putInclude")
    def put_include(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude(
            id=id, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInclude", [value]))

    @jsii.member(jsii_name="putInstant")
    def put_instant(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant(
            custom_link_relations=custom_link_relations,
            locked=locked,
            prefetch_cacheable=prefetch_cacheable,
            prefetch_html=prefetch_html,
            prefetch_no_store=prefetch_no_store,
            prefetch_no_store_extensions=prefetch_no_store_extensions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putInstant", [value]))

    @jsii.member(jsii_name="putInstantConfig")
    def put_instant_config(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInstantConfig", [value]))

    @jsii.member(jsii_name="putLargeFileOptimization")
    def put_large_file_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization(
            enabled=enabled,
            enable_partial_object_caching=enable_partial_object_caching,
            locked=locked,
            maximum_size=maximum_size,
            minimum_size=minimum_size,
            template_uuid=template_uuid,
            use_versioning=use_versioning,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimization", [value]))

    @jsii.member(jsii_name="putLargeFileOptimizationAdvanced")
    def put_large_file_optimization_advanced(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced(
            enabled=enabled,
            fragment_size=fragment_size,
            locked=locked,
            object_size=object_size,
            prefetch_after_request=prefetch_after_request,
            prefetch_during_request=prefetch_during_request,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimizationAdvanced", [value]))

    @jsii.member(jsii_name="putLimitBitRate")
    def put_limit_bit_rate(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate(
            bitrate_table=bitrate_table,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            threshold_table=threshold_table,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLimitBitRate", [value]))

    @jsii.member(jsii_name="putLogCustom")
    def put_log_custom(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom(
            custom_log_field=custom_log_field,
            locked=locked,
            log_custom_log_field=log_custom_log_field,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLogCustom", [value]))

    @jsii.member(jsii_name="putManifestPersonalization")
    def put_manifest_personalization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization(
            enabled=enabled,
            hls_enabled=hls_enabled,
            hls_enable_debug_headers=hls_enable_debug_headers,
            hls_filter_in_bitrate_ranges=hls_filter_in_bitrate_ranges,
            hls_filter_in_bitrates=hls_filter_in_bitrates,
            hls_mode=hls_mode,
            hls_preferred_bitrate=hls_preferred_bitrate,
            hls_query_param_enabled=hls_query_param_enabled,
            hls_query_param_secret_key=hls_query_param_secret_key,
            hls_query_param_transition_key=hls_query_param_transition_key,
            hls_show_advanced=hls_show_advanced,
            hls_title=hls_title,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestPersonalization", [value]))

    @jsii.member(jsii_name="putManifestRerouting")
    def put_manifest_rerouting(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting(
            locked=locked,
            partner=partner,
            template_uuid=template_uuid,
            username=username,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestRerouting", [value]))

    @jsii.member(jsii_name="putManualServerPush")
    def put_manual_server_push(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush(
            locked=locked,
            serverpushlist=serverpushlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManualServerPush", [value]))

    @jsii.member(jsii_name="putMediaAcceleration")
    def put_media_acceleration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAcceleration", [value]))

    @jsii.member(jsii_name="putMediaAccelerationQuicOptout")
    def put_media_acceleration_quic_optout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout(
            locked=locked, optout=optout, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAccelerationQuicOptout", [value]))

    @jsii.member(jsii_name="putMediaClient")
    def put_media_client(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient(
            beacon_id=beacon_id,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_hybrid_http_udp=use_hybrid_http_udp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaClient", [value]))

    @jsii.member(jsii_name="putMediaFileRetrievalOptimization")
    def put_media_file_retrieval_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaFileRetrievalOptimization", [value]))

    @jsii.member(jsii_name="putMediaOriginFailover")
    def put_media_origin_failover(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover(
            cache_error_response=cache_error_response,
            cache_window=cache_window,
            client_response_code=client_response_code,
            detect_object_unavailable=detect_object_unavailable,
            detect_object_unavailable_title=detect_object_unavailable_title,
            detect_origin_unavailable=detect_origin_unavailable,
            detect_origin_unavailable_title=detect_origin_unavailable_title,
            detect_origin_unresponsive=detect_origin_unresponsive,
            detect_origin_unresponsive_title=detect_origin_unresponsive_title,
            locked=locked,
            object_unavailable_alternate_host=object_unavailable_alternate_host,
            object_unavailable_backup_host=object_unavailable_backup_host,
            object_unavailable_blacklist_origin_ip=object_unavailable_blacklist_origin_ip,
            object_unavailable_blacklist_window=object_unavailable_blacklist_window,
            object_unavailable_change_protocol=object_unavailable_change_protocol,
            object_unavailable_detection_level=object_unavailable_detection_level,
            object_unavailable_include_query_string=object_unavailable_include_query_string,
            object_unavailable_modified_path=object_unavailable_modified_path,
            object_unavailable_modify_request_path=object_unavailable_modify_request_path,
            object_unavailable_protocol=object_unavailable_protocol,
            object_unavailable_recovery=object_unavailable_recovery,
            object_unavailable_redirect_method=object_unavailable_redirect_method,
            object_unavailable_response_codes=object_unavailable_response_codes,
            object_unavailable_retry_limit=object_unavailable_retry_limit,
            origin_unavailable_alternate_host=origin_unavailable_alternate_host,
            origin_unavailable_backup_host=origin_unavailable_backup_host,
            origin_unavailable_blacklist_origin_ip=origin_unavailable_blacklist_origin_ip,
            origin_unavailable_blacklist_window=origin_unavailable_blacklist_window,
            origin_unavailable_change_protocol=origin_unavailable_change_protocol,
            origin_unavailable_detection_level=origin_unavailable_detection_level,
            origin_unavailable_include_query_string=origin_unavailable_include_query_string,
            origin_unavailable_modified_path=origin_unavailable_modified_path,
            origin_unavailable_modify_request_path=origin_unavailable_modify_request_path,
            origin_unavailable_protocol=origin_unavailable_protocol,
            origin_unavailable_recovery=origin_unavailable_recovery,
            origin_unavailable_redirect_method=origin_unavailable_redirect_method,
            origin_unavailable_response_codes=origin_unavailable_response_codes,
            origin_unavailable_retry_limit=origin_unavailable_retry_limit,
            origin_unresponsive_alternate_host=origin_unresponsive_alternate_host,
            origin_unresponsive_backup_host=origin_unresponsive_backup_host,
            origin_unresponsive_blacklist_origin_ip=origin_unresponsive_blacklist_origin_ip,
            origin_unresponsive_blacklist_window=origin_unresponsive_blacklist_window,
            origin_unresponsive_change_protocol=origin_unresponsive_change_protocol,
            origin_unresponsive_detection_level=origin_unresponsive_detection_level,
            origin_unresponsive_include_query_string=origin_unresponsive_include_query_string,
            origin_unresponsive_modified_path=origin_unresponsive_modified_path,
            origin_unresponsive_modify_request_path=origin_unresponsive_modify_request_path,
            origin_unresponsive_protocol=origin_unresponsive_protocol,
            origin_unresponsive_recovery=origin_unresponsive_recovery,
            origin_unresponsive_redirect_method=origin_unresponsive_redirect_method,
            origin_unresponsive_retry_limit=origin_unresponsive_retry_limit,
            other_options=other_options,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaOriginFailover", [value]))

    @jsii.member(jsii_name="putMetadataCaching")
    def put_metadata_caching(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataCaching", [value]))

    @jsii.member(jsii_name="putMobileSdkPerformance")
    def put_mobile_sdk_performance(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance(
            enabled=enabled,
            locked=locked,
            secondary_multipath_to_origin=secondary_multipath_to_origin,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMobileSdkPerformance", [value]))

    @jsii.member(jsii_name="putModifyIncomingRequestHeader")
    def put_modify_incoming_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyIncomingResponseHeader")
    def put_modify_incoming_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingRequestHeader")
    def put_modify_outgoing_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingResponseHeader")
    def put_modify_outgoing_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyViaHeader")
    def put_modify_via_header(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader(
            enabled=enabled,
            locked=locked,
            modification_option=modification_option,
            rename_header_to=rename_header_to,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyViaHeader", [value]))

    @jsii.member(jsii_name="putMPulse")
    def put_m_pulse(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse(
            api_key=api_key,
            buffer_size=buffer_size,
            config_override=config_override,
            enabled=enabled,
            loader_version=loader_version,
            locked=locked,
            require_pci=require_pci,
            template_uuid=template_uuid,
            title_optional=title_optional,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMPulse", [value]))

    @jsii.member(jsii_name="putOrigin")
    def put_origin(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_tls_version: typing.Optional[builtins.str] = None,
        min_tls_version: typing.Optional[builtins.str] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tls_version_title: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_tls_version: Specifies the maximum TLS version to use for connections to your origin server. As best practice, use ``DYNAMIC`` to automatically apply the latest supported version. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        :param min_tls_version: Specifies the minimum TLS version to use for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tls13_support: Enables transport layer security (TLS) version 1.3 for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        :param tls_version_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin(
            cache_key_hostname=cache_key_hostname,
            compress=compress,
            custom_certificate_authorities=custom_certificate_authorities,
            custom_certificates=custom_certificates,
            custom_forward_host_header=custom_forward_host_header,
            custom_valid_cn_values=custom_valid_cn_values,
            enable_true_client_ip=enable_true_client_ip,
            forward_host_header=forward_host_header,
            hostname=hostname,
            http_port=http_port,
            https_port=https_port,
            ip_version=ip_version,
            locked=locked,
            max_tls_version=max_tls_version,
            min_tls_version=min_tls_version,
            mslorigin=mslorigin,
            net_storage=net_storage,
            origin_certificate=origin_certificate,
            origin_certs_to_honor=origin_certs_to_honor,
            origin_id=origin_id,
            origin_sni=origin_sni,
            origin_type=origin_type,
            ports=ports,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            second_hostname=second_hostname,
            second_hostname_enabled=second_hostname_enabled,
            standard_certificate_authorities=standard_certificate_authorities,
            template_uuid=template_uuid,
            tls13_support=tls13_support,
            tls_version_title=tls_version_title,
            true_client_ip_client_setting=true_client_ip_client_setting,
            true_client_ip_header=true_client_ip_header,
            use_unique_cache_key=use_unique_cache_key,
            uuid=uuid,
            verification_mode=verification_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putOrigin", [value]))

    @jsii.member(jsii_name="putOriginCharacteristics")
    def put_origin_characteristics(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics(
            access_key_encrypted_storage=access_key_encrypted_storage,
            adc_title=adc_title,
            authentication_method=authentication_method,
            authentication_method_title=authentication_method_title,
            aws_access_key_id=aws_access_key_id,
            aws_access_key_version_guid=aws_access_key_version_guid,
            aws_ar_region=aws_ar_region,
            aws_host=aws_host,
            aws_region=aws_region,
            aws_secret_access_key=aws_secret_access_key,
            aws_service=aws_service,
            country=country,
            custom_sign_string=custom_sign_string,
            direct_connect_geo=direct_connect_geo,
            encoding_version=encoding_version,
            end_point_service=end_point_service,
            gcs_access_key_version_guid=gcs_access_key_version_guid,
            gcs_hmac_key_access_id=gcs_hmac_key_access_id,
            gcs_hmac_key_secret=gcs_hmac_key_secret,
            hostname_tag=hostname_tag,
            locked=locked,
            mslkey=mslkey,
            mslname=mslname,
            nonce=nonce,
            origin_location_title=origin_location_title,
            property_id_tag=property_id_tag,
            role_arn=role_arn,
            secret_key=secret_key,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristics", [value]))

    @jsii.member(jsii_name="putOriginCharacteristicsWsd")
    def put_origin_characteristics_wsd(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd(
            locked=locked,
            origintype=origintype,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristicsWsd", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryMethod")
    def put_origin_failure_recovery_method(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod(
            custom_status_code=custom_status_code,
            locked=locked,
            recovery_method=recovery_method,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryMethod", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryPolicy")
    def put_origin_failure_recovery_policy(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy(
            binary_equivalent_content=binary_equivalent_content,
            enabled=enabled,
            enable_ip_avoidance=enable_ip_avoidance,
            ip_avoidance_error_threshold=ip_avoidance_error_threshold,
            ip_avoidance_retry_interval=ip_avoidance_retry_interval,
            locked=locked,
            monitor_origin_responsiveness=monitor_origin_responsiveness,
            monitor_response_codes1=monitor_response_codes1,
            monitor_response_codes2=monitor_response_codes2,
            monitor_response_codes3=monitor_response_codes3,
            monitor_status_codes1=monitor_status_codes1,
            monitor_status_codes1_enable_recovery=monitor_status_codes1_enable_recovery,
            monitor_status_codes1_enable_retry=monitor_status_codes1_enable_retry,
            monitor_status_codes1_recovery_config_name=monitor_status_codes1_recovery_config_name,
            monitor_status_codes2=monitor_status_codes2,
            monitor_status_codes2_enable_recovery=monitor_status_codes2_enable_recovery,
            monitor_status_codes2_enable_retry=monitor_status_codes2_enable_retry,
            monitor_status_codes2_recovery_config_name=monitor_status_codes2_recovery_config_name,
            monitor_status_codes3=monitor_status_codes3,
            monitor_status_codes3_enable_recovery=monitor_status_codes3_enable_recovery,
            monitor_status_codes3_enable_retry=monitor_status_codes3_enable_retry,
            monitor_status_codes3_recovery_config_name=monitor_status_codes3_recovery_config_name,
            origin_responsiveness_custom_timeout=origin_responsiveness_custom_timeout,
            origin_responsiveness_enable_recovery=origin_responsiveness_enable_recovery,
            origin_responsiveness_enable_retry=origin_responsiveness_enable_retry,
            origin_responsiveness_monitoring=origin_responsiveness_monitoring,
            origin_responsiveness_recovery_config_name=origin_responsiveness_recovery_config_name,
            origin_responsiveness_timeout=origin_responsiveness_timeout,
            status_code_monitoring1=status_code_monitoring1,
            status_code_monitoring2=status_code_monitoring2,
            status_code_monitoring3=status_code_monitoring3,
            template_uuid=template_uuid,
            tuning_parameters=tuning_parameters,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryPolicy", [value]))

    @jsii.member(jsii_name="putOriginIpAcl")
    def put_origin_ip_acl(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putOriginIpAcl", [value]))

    @jsii.member(jsii_name="putPermissionsPolicy")
    def put_permissions_policy(
        self,
        *,
        allow_list: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_list: The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here. They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param permissions_policy_directive: Each directive represents a browser feature. Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy(
            allow_list=allow_list,
            locked=locked,
            permissions_policy_directive=permissions_policy_directive,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPermissionsPolicy", [value]))

    @jsii.member(jsii_name="putPersistentClientConnection")
    def put_persistent_client_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentClientConnection", [value]))

    @jsii.member(jsii_name="putPersistentConnection")
    def put_persistent_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentConnection", [value]))

    @jsii.member(jsii_name="putPersonallyIdentifiableInformation")
    def put_personally_identifiable_information(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPersonallyIdentifiableInformation", [value]))

    @jsii.member(jsii_name="putPhasedRelease")
    def put_phased_release(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            failover_duration=failover_duration,
            failover_enabled=failover_enabled,
            failover_response_code=failover_response_code,
            failover_title=failover_title,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_expiration_date=population_expiration_date,
            population_refresh=population_refresh,
            population_title=population_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPhasedRelease", [value]))

    @jsii.member(jsii_name="putPreconnect")
    def put_preconnect(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect(
            locked=locked,
            preconnectlist=preconnectlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPreconnect", [value]))

    @jsii.member(jsii_name="putPredictiveContentDelivery")
    def put_predictive_content_delivery(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPredictiveContentDelivery", [value]))

    @jsii.member(jsii_name="putPredictivePrefetching")
    def put_predictive_prefetching(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching(
            accuracy_target=accuracy_target,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPredictivePrefetching", [value]))

    @jsii.member(jsii_name="putPrefetch")
    def put_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetch", [value]))

    @jsii.member(jsii_name="putPrefetchable")
    def put_prefetchable(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetchable", [value]))

    @jsii.member(jsii_name="putPrefreshCache")
    def put_prefresh_cache(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache(
            enabled=enabled,
            locked=locked,
            prefreshval=prefreshval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPrefreshCache", [value]))

    @jsii.member(jsii_name="putQuality")
    def put_quality(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality(
            audience_settings=audience_settings,
            catalog_size=catalog_size,
            content_settings=content_settings,
            content_type=content_type,
            country=country,
            delivery_format=delivery_format,
            delivery_type=delivery_type,
            download_type=download_type,
            end_user_location=end_user_location,
            locked=locked,
            maximum_concurrent_users=maximum_concurrent_users,
            object_size=object_size,
            optimize_for=optimize_for,
            origin_settings=origin_settings,
            popularity_distribution=popularity_distribution,
            refresh_rate=refresh_rate,
            segment_duration=segment_duration,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuality", [value]))

    @jsii.member(jsii_name="putQuicBeta")
    def put_quic_beta(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta(
            enabled=enabled,
            locked=locked,
            quic_offer_percentage=quic_offer_percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuicBeta", [value]))

    @jsii.member(jsii_name="putRandomSeek")
    def put_random_seek(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek(
            flv=flv,
            locked=locked,
            maximum_size=maximum_size,
            mp4=mp4,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRandomSeek", [value]))

    @jsii.member(jsii_name="putRapid")
    def put_rapid(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRapid", [value]))

    @jsii.member(jsii_name="putReadTimeout")
    def put_read_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putReadTimeout", [value_]))

    @jsii.member(jsii_name="putRealTimeReporting")
    def put_real_time_reporting(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting(
            advanced=advanced,
            beacon_sampling_percentage=beacon_sampling_percentage,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRealTimeReporting", [value]))

    @jsii.member(jsii_name="putRealUserMonitoring")
    def put_real_user_monitoring(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRealUserMonitoring", [value]))

    @jsii.member(jsii_name="putRedirect")
    def put_redirect(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect(
            destination_hostname=destination_hostname,
            destination_hostname_other=destination_hostname_other,
            destination_hostname_sibling=destination_hostname_sibling,
            destination_hostname_subdomain=destination_hostname_subdomain,
            destination_path=destination_path,
            destination_path_other=destination_path_other,
            destination_path_prefix=destination_path_prefix,
            destination_path_suffix=destination_path_suffix,
            destination_path_suffix_status=destination_path_suffix_status,
            destination_protocol=destination_protocol,
            locked=locked,
            mobile_default_choice=mobile_default_choice,
            query_string=query_string,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirect", [value]))

    @jsii.member(jsii_name="putRedirectplus")
    def put_redirectplus(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus(
            destination=destination,
            enabled=enabled,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirectplus", [value]))

    @jsii.member(jsii_name="putRefererChecking")
    def put_referer_checking(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking(
            allow_children=allow_children,
            domains=domains,
            enabled=enabled,
            locked=locked,
            strict=strict,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRefererChecking", [value]))

    @jsii.member(jsii_name="putRemoveQueryParameter")
    def put_remove_query_parameter(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter(
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveQueryParameter", [value]))

    @jsii.member(jsii_name="putRemoveVary")
    def put_remove_vary(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveVary", [value]))

    @jsii.member(jsii_name="putReport")
    def put_report(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport(
            cookies=cookies,
            custom_log_field=custom_log_field,
            locked=locked,
            log_accept_language=log_accept_language,
            log_cookies=log_cookies,
            log_custom_log_field=log_custom_log_field,
            log_edge_ip=log_edge_ip,
            log_host=log_host,
            log_referer=log_referer,
            log_user_agent=log_user_agent,
            log_x_forwarded_for=log_x_forwarded_for,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReport", [value]))

    @jsii.member(jsii_name="putRequestClientHints")
    def put_request_client_hints(
        self,
        *,
        accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accept_ch: The client hint data objects you want to receive from the browser. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        :param accept_critical_ch: The critical client hint data objects you want to receive from the browser. The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reset: This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser. This empty header doesn't get merged with other objects sent from your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints(
            accept_ch=accept_ch,
            accept_critical_ch=accept_critical_ch,
            locked=locked,
            reset=reset,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestClientHints", [value]))

    @jsii.member(jsii_name="putRequestControl")
    def put_request_control(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl(
            branded403_file=branded403_file,
            branded403_status_code=branded403_status_code,
            branded403_url=branded403_url,
            branded_deny_cache_ttl=branded_deny_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enable_branded403=enable_branded403,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            net_storage=net_storage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestControl", [value]))

    @jsii.member(jsii_name="putRequestTypeMarker")
    def put_request_type_marker(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker(
            locked=locked,
            request_type=request_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestTypeMarker", [value]))

    @jsii.member(jsii_name="putResourceOptimizer")
    def put_resource_optimizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizer", [value]))

    @jsii.member(jsii_name="putResourceOptimizerExtendedCompatibility")
    def put_resource_optimizer_extended_compatibility(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility(
            enable_all_features=enable_all_features,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizerExtendedCompatibility", [value]))

    @jsii.member(jsii_name="putResponseCode")
    def put_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode(
            locked=locked,
            override206=override206,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCode", [value]))

    @jsii.member(jsii_name="putResponseCookie")
    def put_response_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie(
            cookie_name=cookie_name,
            default_domain=default_domain,
            default_path=default_path,
            domain=domain,
            duration=duration,
            enabled=enabled,
            expiration_date=expiration_date,
            expires=expires,
            format=format,
            http_only=http_only,
            locked=locked,
            path=path,
            same_site=same_site,
            secure=secure,
            template_uuid=template_uuid,
            type=type,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCookie", [value_]))

    @jsii.member(jsii_name="putRestrictObjectCaching")
    def put_restrict_object_caching(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching(
            locked=locked,
            maximum_size=maximum_size,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRestrictObjectCaching", [value]))

    @jsii.member(jsii_name="putReturnCacheStatus")
    def put_return_cache_status(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus(
            locked=locked,
            response_header_name=response_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReturnCacheStatus", [value]))

    @jsii.member(jsii_name="putRewriteUrl")
    def put_rewrite_url(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl(
            behavior=behavior,
            keep_query_string=keep_query_string,
            locked=locked,
            match=match,
            match_multiple=match_multiple,
            match_regex=match_regex,
            target_path=target_path,
            target_path_prepend=target_path_prepend,
            target_regex=target_regex,
            target_url=target_url,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRewriteUrl", [value]))

    @jsii.member(jsii_name="putRumCustom")
    def put_rum_custom(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom(
            locked=locked,
            rum_group_name=rum_group_name,
            rum_sample_rate=rum_sample_rate,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRumCustom", [value]))

    @jsii.member(jsii_name="putSaasDefinitions")
    def put_saas_definitions(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions(
            application_action=application_action,
            application_cname_enabled=application_cname_enabled,
            application_cname_level=application_cname_level,
            application_cookie=application_cookie,
            application_query_string=application_query_string,
            application_regex=application_regex,
            application_replace=application_replace,
            application_title=application_title,
            customer_action=customer_action,
            customer_cname_enabled=customer_cname_enabled,
            customer_cname_level=customer_cname_level,
            customer_cookie=customer_cookie,
            customer_query_string=customer_query_string,
            customer_regex=customer_regex,
            customer_replace=customer_replace,
            customer_title=customer_title,
            locked=locked,
            template_uuid=template_uuid,
            users_action=users_action,
            users_cname_enabled=users_cname_enabled,
            users_cname_level=users_cname_level,
            users_cookie=users_cookie,
            users_query_string=users_query_string,
            users_regex=users_regex,
            users_replace=users_replace,
            users_title=users_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSaasDefinitions", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudClient")
    def put_sales_force_commerce_cloud_client(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient(
            allow_override_origin_cache_key=allow_override_origin_cache_key,
            connector_id=connector_id,
            enabled=enabled,
            locked=locked,
            origin_host_header=origin_host_header,
            origin_type=origin_type,
            sf3_c_origin_host=sf3_c_origin_host,
            sf3_c_origin_host_header=sf3_c_origin_host_header,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudClient", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProvider")
    def put_sales_force_commerce_cloud_provider(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProvider", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProviderHostHeader")
    def put_sales_force_commerce_cloud_provider_host_header(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader(
            host_header_source=host_header_source,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProviderHostHeader", [value]))

    @jsii.member(jsii_name="putSavePostDcaProcessing")
    def put_save_post_dca_processing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSavePostDcaProcessing", [value]))

    @jsii.member(jsii_name="putScheduleInvalidation")
    def put_schedule_invalidation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation(
            locked=locked,
            refresh_method=refresh_method,
            repeat=repeat,
            repeat_interval=repeat_interval,
            start=start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScheduleInvalidation", [value]))

    @jsii.member(jsii_name="putScriptManagement")
    def put_script_management(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement(
            enabled=enabled,
            locked=locked,
            serviceworker=serviceworker,
            template_uuid=template_uuid,
            timestamp=timestamp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScriptManagement", [value]))

    @jsii.member(jsii_name="putSegmentedContentProtection")
    def put_segmented_content_protection(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection(
            acl=acl,
            dash_media_encryption=dash_media_encryption,
            data_payload=data_payload,
            enabled=enabled,
            enable_token_in_uri=enable_token_in_uri,
            field_carry_over=field_carry_over,
            header_for_salt=header_for_salt,
            hls_master_manifest_files=hls_master_manifest_files,
            hls_media_encryption=hls_media_encryption,
            ip=ip,
            key=key,
            locked=locked,
            media_encryption_title=media_encryption_title,
            revoked_list_id=revoked_list_id,
            salt=salt,
            session_id=session_id,
            template_uuid=template_uuid,
            token_authentication_title=token_authentication_title,
            token_auth_hls_title=token_auth_hls_title,
            token_revocation_enabled=token_revocation_enabled,
            token_revocation_title=token_revocation_title,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedContentProtection", [value]))

    @jsii.member(jsii_name="putSegmentedMediaOptimization")
    def put_segmented_media_optimization(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization(
            behavior=behavior,
            dvr_type=dvr_type,
            dvr_window=dvr_window,
            enable_ull_streaming=enable_ull_streaming,
            end_time=end_time,
            live_type=live_type,
            locked=locked,
            show_advanced=show_advanced,
            start_time=start_time,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaOptimization", [value]))

    @jsii.member(jsii_name="putSegmentedMediaStreamingPrefetch")
    def put_segmented_media_streaming_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaStreamingPrefetch", [value]))

    @jsii.member(jsii_name="putSetVariable")
    def put_set_variable(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[jsii.Number] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[jsii.Number] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[jsii.Number] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[jsii.Number] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable(
            algorithm=algorithm,
            case_sensitive=case_sensitive,
            certificate_field_name=certificate_field_name,
            cookie_name=cookie_name,
            device_profile=device_profile,
            encryption_key=encryption_key,
            encryption_mode=encryption_mode,
            end_index=end_index,
            except_chars=except_chars,
            extract_location=extract_location,
            force_chars=force_chars,
            format_string=format_string,
            generator=generator,
            global_substitution=global_substitution,
            header_name=header_name,
            hmac_algorithm=hmac_algorithm,
            hmac_key=hmac_key,
            initialization_vector=initialization_vector,
            ipv4_prefix=ipv4_prefix,
            ipv6_prefix=ipv6_prefix,
            ip_version=ip_version,
            location_id=location_id,
            locked=locked,
            max=max,
            max_random_number=max_random_number,
            min=min,
            min_random_number=min_random_number,
            nonce=nonce,
            number_of_bytes=number_of_bytes,
            operand_one=operand_one,
            param_name=param_name,
            path_component_offset=path_component_offset,
            prepend_bytes=prepend_bytes,
            query_parameter_name=query_parameter_name,
            regex=regex,
            replacement=replacement,
            response_header_name=response_header_name,
            separator=separator,
            set_cookie_name=set_cookie_name,
            start_index=start_index,
            sub_string=sub_string,
            template_uuid=template_uuid,
            transform=transform,
            uuid=uuid,
            value_source=value_source,
            variable_name=variable_name,
            variable_value=variable_value,
        )

        return typing.cast(None, jsii.invoke(self, "putSetVariable", [value]))

    @jsii.member(jsii_name="putSimulateErrorCode")
    def put_simulate_error_code(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode(
            error_type=error_type,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSimulateErrorCode", [value]))

    @jsii.member(jsii_name="putSiteShield")
    def put_site_shield(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield(
            locked=locked,
            nossmap=nossmap,
            ssmap=ssmap,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSiteShield", [value]))

    @jsii.member(jsii_name="putStandardTlsMigration")
    def put_standard_tls_migration(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration(
            allow_https_downgrade=allow_https_downgrade,
            allow_https_upgrade=allow_https_upgrade,
            cache_sharing_duration=cache_sharing_duration,
            cache_sharing_start_time=cache_sharing_start_time,
            enabled=enabled,
            is_certificate_sni_only=is_certificate_sni_only,
            is_tiered_distribution_used=is_tiered_distribution_used,
            locked=locked,
            migration_duration=migration_duration,
            migration_from=migration_from,
            migration_start_time=migration_start_time,
            td_location=td_location,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigration", [value]))

    @jsii.member(jsii_name="putStandardTlsMigrationOverride")
    def put_standard_tls_migration_override(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride(
            info=info, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigrationOverride", [value]))

    @jsii.member(jsii_name="putStrictHeaderParsing")
    def put_strict_header_parsing(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing(
            locked=locked,
            strict_mode=strict_mode,
            template_uuid=template_uuid,
            uuid=uuid,
            valid_mode=valid_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putStrictHeaderParsing", [value]))

    @jsii.member(jsii_name="putSubCustomer")
    def put_sub_customer(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer(
            access_control=access_control,
            cache_key=cache_key,
            caching=caching,
            content_compressor=content_compressor,
            dynamic_web_content=dynamic_web_content,
            enabled=enabled,
            geo_location=geo_location,
            ip=ip,
            large_file_delivery=large_file_delivery,
            live_video_delivery=live_video_delivery,
            locked=locked,
            modify_path=modify_path,
            on_demand_video_delivery=on_demand_video_delivery,
            origin=origin,
            partner_domain_suffix=partner_domain_suffix,
            referrer=referrer,
            refresh_content=refresh_content,
            site_failover=site_failover,
            template_uuid=template_uuid,
            token_authorization=token_authorization,
            uuid=uuid,
            web_application_firewall=web_application_firewall,
        )

        return typing.cast(None, jsii.invoke(self, "putSubCustomer", [value]))

    @jsii.member(jsii_name="putSureRoute")
    def put_sure_route(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute(
            allow_fcm_parent_override=allow_fcm_parent_override,
            custom_map=custom_map,
            custom_stat_key=custom_stat_key,
            enable_custom_key=enable_custom_key,
            enabled=enabled,
            force_ssl_forward=force_ssl_forward,
            locked=locked,
            race_stat_ttl=race_stat_ttl,
            sr_download_link_title=sr_download_link_title,
            template_uuid=template_uuid,
            test_object_url=test_object_url,
            to_host=to_host,
            to_host_status=to_host_status,
            type=type,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSureRoute", [value]))

    @jsii.member(jsii_name="putTcpOptimization")
    def put_tcp_optimization(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putTcpOptimization", [value]))

    @jsii.member(jsii_name="putTeaLeaf")
    def put_tea_leaf(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf(
            enabled=enabled,
            ibm_customer_id=ibm_customer_id,
            limit_to_dynamic=limit_to_dynamic,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTeaLeaf", [value]))

    @jsii.member(jsii_name="putTieredDistribution")
    def put_tiered_distribution(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistribution", [value]))

    @jsii.member(jsii_name="putTieredDistributionAdvanced")
    def put_tiered_distribution_advanced(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced(
            allowall=allowall,
            enabled=enabled,
            locked=locked,
            method=method,
            policy=policy,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionAdvanced", [value]))

    @jsii.member(jsii_name="putTieredDistributionCustomization")
    def put_tiered_distribution_customization(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization(
            cloudwrapper_map_migration_title=cloudwrapper_map_migration_title,
            custom_map_enabled=custom_map_enabled,
            custom_map_name=custom_map_name,
            hash_algorithm=hash_algorithm,
            location=location,
            locked=locked,
            map_migration_enabled=map_migration_enabled,
            migration_end_date=migration_end_date,
            migration_start_date=migration_start_date,
            migration_within_cw_maps_enabled=migration_within_cw_maps_enabled,
            serial_end=serial_end,
            serial_start=serial_start,
            template_uuid=template_uuid,
            tier1_title=tier1_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionCustomization", [value]))

    @jsii.member(jsii_name="putTimeout")
    def put_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putTimeout", [value_]))

    @jsii.member(jsii_name="putUidConfiguration")
    def put_uid_configuration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration(
            enabled=enabled,
            extract_location=extract_location,
            header_name=header_name,
            legal_text=legal_text,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putUidConfiguration", [value]))

    @jsii.member(jsii_name="putValidateEntityTag")
    def put_validate_entity_tag(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putValidateEntityTag", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebToken")
    def put_verify_json_web_token(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken(
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_location=extract_location,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebToken", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebTokenForDcp")
    def put_verify_json_web_token_for_dcp(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp(
            authorizations=authorizations,
            client_id=client_id,
            custom_header=custom_header,
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_authorizations=extract_authorizations,
            extract_client_id=extract_client_id,
            extract_location=extract_location,
            extract_user_name=extract_user_name,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            primary_location=primary_location,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            user_name=user_name,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebTokenForDcp", [value]))

    @jsii.member(jsii_name="putVerifyTokenAuthorization")
    def put_verify_token_authorization(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization(
            algorithm=algorithm,
            escape_hmac_inputs=escape_hmac_inputs,
            failure_response=failure_response,
            ignore_query_string=ignore_query_string,
            key=key,
            location=location,
            location_id=location_id,
            locked=locked,
            salt=salt,
            template_uuid=template_uuid,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyTokenAuthorization", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoom")
    def put_virtual_waiting_room(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoom", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomWithEdgeWorkers")
    def put_virtual_waiting_room_with_edge_workers(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomWithEdgeWorkers", [value]))

    @jsii.member(jsii_name="putVisitorPrioritization")
    def put_visitor_prioritization(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization(
            allowed_user_cookie_advanced=allowed_user_cookie_advanced,
            allowed_user_cookie_automatic_salt=allowed_user_cookie_automatic_salt,
            allowed_user_cookie_domain=allowed_user_cookie_domain,
            allowed_user_cookie_domain_type=allowed_user_cookie_domain_type,
            allowed_user_cookie_duration=allowed_user_cookie_duration,
            allowed_user_cookie_enabled=allowed_user_cookie_enabled,
            allowed_user_cookie_http_only=allowed_user_cookie_http_only,
            allowed_user_cookie_label=allowed_user_cookie_label,
            allowed_user_cookie_management_title=allowed_user_cookie_management_title,
            allowed_user_cookie_refresh=allowed_user_cookie_refresh,
            allowed_user_cookie_salt=allowed_user_cookie_salt,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            user_identification_by_cookie=user_identification_by_cookie,
            user_identification_by_headers=user_identification_by_headers,
            user_identification_by_ip=user_identification_by_ip,
            user_identification_by_params=user_identification_by_params,
            user_identification_key_cookie=user_identification_key_cookie,
            user_identification_key_headers=user_identification_key_headers,
            user_identification_key_params=user_identification_key_params,
            user_identification_title=user_identification_title,
            uuid=uuid,
            waiting_room_cache_ttl=waiting_room_cache_ttl,
            waiting_room_cookie_advanced=waiting_room_cookie_advanced,
            waiting_room_cookie_automatic_salt=waiting_room_cookie_automatic_salt,
            waiting_room_cookie_domain=waiting_room_cookie_domain,
            waiting_room_cookie_domain_type=waiting_room_cookie_domain_type,
            waiting_room_cookie_duration=waiting_room_cookie_duration,
            waiting_room_cookie_enabled=waiting_room_cookie_enabled,
            waiting_room_cookie_http_only=waiting_room_cookie_http_only,
            waiting_room_cookie_label=waiting_room_cookie_label,
            waiting_room_cookie_management_title=waiting_room_cookie_management_title,
            waiting_room_cookie_salt=waiting_room_cookie_salt,
            waiting_room_cookie_share_label=waiting_room_cookie_share_label,
            waiting_room_cp_code=waiting_room_cp_code,
            waiting_room_directory=waiting_room_directory,
            waiting_room_management_title=waiting_room_management_title,
            waiting_room_net_storage=waiting_room_net_storage,
            waiting_room_status_code=waiting_room_status_code,
            waiting_room_use_cp_code=waiting_room_use_cp_code,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritization", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifo")
    def put_visitor_prioritization_fifo(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifo", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifoStandalone")
    def put_visitor_prioritization_fifo_standalone(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifoStandalone", [value]))

    @jsii.member(jsii_name="putWatermarking")
    def put_watermarking(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking(
            ab_variant_location=ab_variant_location,
            decryption_password1=decryption_password1,
            decryption_password2=decryption_password2,
            decryption_password_id1=decryption_password_id1,
            decryption_password_id2=decryption_password_id2,
            enable=enable,
            locked=locked,
            miscellaneous_settings_title=miscellaneous_settings_title,
            pattern_decryption_enable=pattern_decryption_enable,
            pattern_encryption_title=pattern_encryption_title,
            signature_verification_enable=signature_verification_enable,
            template_uuid=template_uuid,
            token_signing_title=token_signing_title,
            use_original_as_a=use_original_as_a,
            uuid=uuid,
            verification_key_id1=verification_key_id1,
            verification_key_id2=verification_key_id2,
            verification_public_key1=verification_public_key1,
            verification_public_key2=verification_public_key2,
        )

        return typing.cast(None, jsii.invoke(self, "putWatermarking", [value]))

    @jsii.member(jsii_name="putWebApplicationFirewall")
    def put_web_application_firewall(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall(
            firewall_configuration=firewall_configuration,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putWebApplicationFirewall", [value]))

    @jsii.member(jsii_name="putWebdav")
    def put_webdav(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebdav", [value]))

    @jsii.member(jsii_name="putWebSockets")
    def put_web_sockets(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebSockets", [value]))

    @jsii.member(jsii_name="resetAdaptiveAcceleration")
    def reset_adaptive_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveAcceleration", []))

    @jsii.member(jsii_name="resetAdaptiveImageCompression")
    def reset_adaptive_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveImageCompression", []))

    @jsii.member(jsii_name="resetAdScalerCircuitBreaker")
    def reset_ad_scaler_circuit_breaker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdScalerCircuitBreaker", []))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetAggregatedReporting")
    def reset_aggregated_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregatedReporting", []))

    @jsii.member(jsii_name="resetAkamaizer")
    def reset_akamaizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizer", []))

    @jsii.member(jsii_name="resetAkamaizerTag")
    def reset_akamaizer_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizerTag", []))

    @jsii.member(jsii_name="resetAllHttpInCacheHierarchy")
    def reset_all_http_in_cache_hierarchy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllHttpInCacheHierarchy", []))

    @jsii.member(jsii_name="resetAllowCloudletsOrigins")
    def reset_allow_cloudlets_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCloudletsOrigins", []))

    @jsii.member(jsii_name="resetAllowDelete")
    def reset_allow_delete(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowDelete", []))

    @jsii.member(jsii_name="resetAllowHttpsCacheKeySharing")
    def reset_allow_https_cache_key_sharing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsCacheKeySharing", []))

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowOptions")
    def reset_allow_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOptions", []))

    @jsii.member(jsii_name="resetAllowPatch")
    def reset_allow_patch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPatch", []))

    @jsii.member(jsii_name="resetAllowPost")
    def reset_allow_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPost", []))

    @jsii.member(jsii_name="resetAllowPut")
    def reset_allow_put(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPut", []))

    @jsii.member(jsii_name="resetAllowTransferEncoding")
    def reset_allow_transfer_encoding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowTransferEncoding", []))

    @jsii.member(jsii_name="resetAltSvcHeader")
    def reset_alt_svc_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAltSvcHeader", []))

    @jsii.member(jsii_name="resetApiPrioritization")
    def reset_api_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiPrioritization", []))

    @jsii.member(jsii_name="resetApplicationLoadBalancer")
    def reset_application_load_balancer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationLoadBalancer", []))

    @jsii.member(jsii_name="resetAudienceSegmentation")
    def reset_audience_segmentation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSegmentation", []))

    @jsii.member(jsii_name="resetAutoDomainValidation")
    def reset_auto_domain_validation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutoDomainValidation", []))

    @jsii.member(jsii_name="resetBaseDirectory")
    def reset_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBaseDirectory", []))

    @jsii.member(jsii_name="resetBossBeaconing")
    def reset_boss_beaconing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBossBeaconing", []))

    @jsii.member(jsii_name="resetBreadcrumbs")
    def reset_breadcrumbs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreadcrumbs", []))

    @jsii.member(jsii_name="resetBreakConnection")
    def reset_break_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreakConnection", []))

    @jsii.member(jsii_name="resetBrotli")
    def reset_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrotli", []))

    @jsii.member(jsii_name="resetCacheError")
    def reset_cache_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheError", []))

    @jsii.member(jsii_name="resetCacheId")
    def reset_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheId", []))

    @jsii.member(jsii_name="resetCacheKeyIgnoreCase")
    def reset_cache_key_ignore_case(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyIgnoreCase", []))

    @jsii.member(jsii_name="resetCacheKeyQueryParams")
    def reset_cache_key_query_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyQueryParams", []))

    @jsii.member(jsii_name="resetCacheKeyRewrite")
    def reset_cache_key_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyRewrite", []))

    @jsii.member(jsii_name="resetCachePost")
    def reset_cache_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachePost", []))

    @jsii.member(jsii_name="resetCacheRedirect")
    def reset_cache_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheRedirect", []))

    @jsii.member(jsii_name="resetCacheTag")
    def reset_cache_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTag", []))

    @jsii.member(jsii_name="resetCacheTagVisible")
    def reset_cache_tag_visible(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTagVisible", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetCentralAuthorization")
    def reset_central_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCentralAuthorization", []))

    @jsii.member(jsii_name="resetChaseRedirects")
    def reset_chase_redirects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaseRedirects", []))

    @jsii.member(jsii_name="resetClientCertificateAuth")
    def reset_client_certificate_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificateAuth", []))

    @jsii.member(jsii_name="resetClientCharacteristics")
    def reset_client_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCharacteristics", []))

    @jsii.member(jsii_name="resetCloudInterconnects")
    def reset_cloud_interconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudInterconnects", []))

    @jsii.member(jsii_name="resetCloudWrapper")
    def reset_cloud_wrapper(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapper", []))

    @jsii.member(jsii_name="resetCloudWrapperAdvanced")
    def reset_cloud_wrapper_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapperAdvanced", []))

    @jsii.member(jsii_name="resetCommonMediaClientData")
    def reset_common_media_client_data(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCommonMediaClientData", []))

    @jsii.member(jsii_name="resetConditionalOrigin")
    def reset_conditional_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalOrigin", []))

    @jsii.member(jsii_name="resetConstructResponse")
    def reset_construct_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConstructResponse", []))

    @jsii.member(jsii_name="resetContentCharacteristics")
    def reset_content_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristics", []))

    @jsii.member(jsii_name="resetContentCharacteristicsAmd")
    def reset_content_characteristics_amd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsAmd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsDd")
    def reset_content_characteristics_dd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsDd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLargeFile")
    def reset_content_characteristics_wsd_large_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLargeFile", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLive")
    def reset_content_characteristics_wsd_live(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLive", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdVod")
    def reset_content_characteristics_wsd_vod(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdVod", []))

    @jsii.member(jsii_name="resetContentPrePosition")
    def reset_content_pre_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPrePosition", []))

    @jsii.member(jsii_name="resetContentTargetingProtection")
    def reset_content_targeting_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentTargetingProtection", []))

    @jsii.member(jsii_name="resetCorsSupport")
    def reset_cors_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCorsSupport", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetCustomBehavior")
    def reset_custom_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomBehavior", []))

    @jsii.member(jsii_name="resetDatastream")
    def reset_datastream(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastream", []))

    @jsii.member(jsii_name="resetDcp")
    def reset_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcp", []))

    @jsii.member(jsii_name="resetDcpAuthHmacTransformation")
    def reset_dcp_auth_hmac_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthHmacTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthRegexTransformation")
    def reset_dcp_auth_regex_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthRegexTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthSubstringTransformation")
    def reset_dcp_auth_substring_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthSubstringTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthVariableExtractor")
    def reset_dcp_auth_variable_extractor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthVariableExtractor", []))

    @jsii.member(jsii_name="resetDcpDefaultAuthzGroups")
    def reset_dcp_default_authz_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDefaultAuthzGroups", []))

    @jsii.member(jsii_name="resetDcpDevRelations")
    def reset_dcp_dev_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDevRelations", []))

    @jsii.member(jsii_name="resetDcpRealTimeAuth")
    def reset_dcp_real_time_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpRealTimeAuth", []))

    @jsii.member(jsii_name="resetDeliveryReceipt")
    def reset_delivery_receipt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryReceipt", []))

    @jsii.member(jsii_name="resetDenyAccess")
    def reset_deny_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyAccess", []))

    @jsii.member(jsii_name="resetDenyDirectFailoverAccess")
    def reset_deny_direct_failover_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyDirectFailoverAccess", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicCacheId")
    def reset_device_characteristic_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicCacheId", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicHeader")
    def reset_device_characteristic_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicHeader", []))

    @jsii.member(jsii_name="resetDnsAsyncRefresh")
    def reset_dns_async_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsAsyncRefresh", []))

    @jsii.member(jsii_name="resetDnsPrefresh")
    def reset_dns_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsPrefresh", []))

    @jsii.member(jsii_name="resetDowngradeProtocol")
    def reset_downgrade_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDowngradeProtocol", []))

    @jsii.member(jsii_name="resetDownloadCompleteMarker")
    def reset_download_complete_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadCompleteMarker", []))

    @jsii.member(jsii_name="resetDownloadNotification")
    def reset_download_notification(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadNotification", []))

    @jsii.member(jsii_name="resetDownstreamCache")
    def reset_downstream_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownstreamCache", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimization")
    def reset_dynamic_throughtput_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimization", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimizationOverride")
    def reset_dynamic_throughtput_optimization_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimizationOverride", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEcmsBulkUpload")
    def reset_ecms_bulk_upload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsBulkUpload", []))

    @jsii.member(jsii_name="resetEcmsDatabase")
    def reset_ecms_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDatabase", []))

    @jsii.member(jsii_name="resetEcmsDataset")
    def reset_ecms_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDataset", []))

    @jsii.member(jsii_name="resetEcmsObjectKey")
    def reset_ecms_object_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsObjectKey", []))

    @jsii.member(jsii_name="resetEdgeConnect")
    def reset_edge_connect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeConnect", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingAdvanced")
    def reset_edge_load_balancing_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingAdvanced", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingDataCenter")
    def reset_edge_load_balancing_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingDataCenter", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingOrigin")
    def reset_edge_load_balancing_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingOrigin", []))

    @jsii.member(jsii_name="resetEdgeOriginAuthorization")
    def reset_edge_origin_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeOriginAuthorization", []))

    @jsii.member(jsii_name="resetEdgeRedirector")
    def reset_edge_redirector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeRedirector", []))

    @jsii.member(jsii_name="resetEdgeScape")
    def reset_edge_scape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeScape", []))

    @jsii.member(jsii_name="resetEdgeSideIncludes")
    def reset_edge_side_includes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeSideIncludes", []))

    @jsii.member(jsii_name="resetEdgeWorker")
    def reset_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorker", []))

    @jsii.member(jsii_name="resetEnforceMtlsSettings")
    def reset_enforce_mtls_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnforceMtlsSettings", []))

    @jsii.member(jsii_name="resetEnhancedAkamaiProtocol")
    def reset_enhanced_akamai_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedAkamaiProtocol", []))

    @jsii.member(jsii_name="resetEnhancedProxyDetection")
    def reset_enhanced_proxy_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedProxyDetection", []))

    @jsii.member(jsii_name="resetEpdForwardHeaderEnrichment")
    def reset_epd_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEpdForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetFailAction")
    def reset_fail_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailAction", []))

    @jsii.member(jsii_name="resetFailoverBotManagerFeatureCompatibility")
    def reset_failover_bot_manager_feature_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverBotManagerFeatureCompatibility", []))

    @jsii.member(jsii_name="resetFastInvalidate")
    def reset_fast_invalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFastInvalidate", []))

    @jsii.member(jsii_name="resetFips")
    def reset_fips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFips", []))

    @jsii.member(jsii_name="resetFirstPartyMarketing")
    def reset_first_party_marketing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketing", []))

    @jsii.member(jsii_name="resetFirstPartyMarketingPlus")
    def reset_first_party_marketing_plus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketingPlus", []))

    @jsii.member(jsii_name="resetForwardRewrite")
    def reset_forward_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardRewrite", []))

    @jsii.member(jsii_name="resetG2Oheader")
    def reset_g2_oheader(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2Oheader", []))

    @jsii.member(jsii_name="resetGlobalRequestNumber")
    def reset_global_request_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalRequestNumber", []))

    @jsii.member(jsii_name="resetGraphqlCaching")
    def reset_graphql_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGraphqlCaching", []))

    @jsii.member(jsii_name="resetGzipResponse")
    def reset_gzip_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGzipResponse", []))

    @jsii.member(jsii_name="resetHdDataAdvanced")
    def reset_hd_data_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHdDataAdvanced", []))

    @jsii.member(jsii_name="resetHealthDetection")
    def reset_health_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHealthDetection", []))

    @jsii.member(jsii_name="resetHsafEipBinding")
    def reset_hsaf_eip_binding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsafEipBinding", []))

    @jsii.member(jsii_name="resetHttp2")
    def reset_http2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp2", []))

    @jsii.member(jsii_name="resetHttp3")
    def reset_http3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp3", []))

    @jsii.member(jsii_name="resetHttpStrictTransportSecurity")
    def reset_http_strict_transport_security(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpStrictTransportSecurity", []))

    @jsii.member(jsii_name="resetHttpToHttpsUpgrade")
    def reset_http_to_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpToHttpsUpgrade", []))

    @jsii.member(jsii_name="resetImageAndVideoManager")
    def reset_image_and_video_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageAndVideoManager", []))

    @jsii.member(jsii_name="resetImageManager")
    def reset_image_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManager", []))

    @jsii.member(jsii_name="resetImageManagerVideo")
    def reset_image_manager_video(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManagerVideo", []))

    @jsii.member(jsii_name="resetImOverride")
    def reset_im_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImOverride", []))

    @jsii.member(jsii_name="resetInclude")
    def reset_include(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInclude", []))

    @jsii.member(jsii_name="resetInstant")
    def reset_instant(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstant", []))

    @jsii.member(jsii_name="resetInstantConfig")
    def reset_instant_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstantConfig", []))

    @jsii.member(jsii_name="resetLargeFileOptimization")
    def reset_large_file_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimization", []))

    @jsii.member(jsii_name="resetLargeFileOptimizationAdvanced")
    def reset_large_file_optimization_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimizationAdvanced", []))

    @jsii.member(jsii_name="resetLimitBitRate")
    def reset_limit_bit_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitBitRate", []))

    @jsii.member(jsii_name="resetLogCustom")
    def reset_log_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustom", []))

    @jsii.member(jsii_name="resetManifestPersonalization")
    def reset_manifest_personalization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestPersonalization", []))

    @jsii.member(jsii_name="resetManifestRerouting")
    def reset_manifest_rerouting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestRerouting", []))

    @jsii.member(jsii_name="resetManualServerPush")
    def reset_manual_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManualServerPush", []))

    @jsii.member(jsii_name="resetMediaAcceleration")
    def reset_media_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAcceleration", []))

    @jsii.member(jsii_name="resetMediaAccelerationQuicOptout")
    def reset_media_acceleration_quic_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAccelerationQuicOptout", []))

    @jsii.member(jsii_name="resetMediaClient")
    def reset_media_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaClient", []))

    @jsii.member(jsii_name="resetMediaFileRetrievalOptimization")
    def reset_media_file_retrieval_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaFileRetrievalOptimization", []))

    @jsii.member(jsii_name="resetMediaOriginFailover")
    def reset_media_origin_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaOriginFailover", []))

    @jsii.member(jsii_name="resetMetadataCaching")
    def reset_metadata_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataCaching", []))

    @jsii.member(jsii_name="resetMobileSdkPerformance")
    def reset_mobile_sdk_performance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileSdkPerformance", []))

    @jsii.member(jsii_name="resetModifyIncomingRequestHeader")
    def reset_modify_incoming_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyIncomingResponseHeader")
    def reset_modify_incoming_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingRequestHeader")
    def reset_modify_outgoing_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingResponseHeader")
    def reset_modify_outgoing_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyViaHeader")
    def reset_modify_via_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyViaHeader", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetOriginCharacteristics")
    def reset_origin_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristics", []))

    @jsii.member(jsii_name="resetOriginCharacteristicsWsd")
    def reset_origin_characteristics_wsd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristicsWsd", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryMethod")
    def reset_origin_failure_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryMethod", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryPolicy")
    def reset_origin_failure_recovery_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryPolicy", []))

    @jsii.member(jsii_name="resetOriginIpAcl")
    def reset_origin_ip_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginIpAcl", []))

    @jsii.member(jsii_name="resetPermissionsPolicy")
    def reset_permissions_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPermissionsPolicy", []))

    @jsii.member(jsii_name="resetPersistentClientConnection")
    def reset_persistent_client_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentClientConnection", []))

    @jsii.member(jsii_name="resetPersistentConnection")
    def reset_persistent_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentConnection", []))

    @jsii.member(jsii_name="resetPersonallyIdentifiableInformation")
    def reset_personally_identifiable_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersonallyIdentifiableInformation", []))

    @jsii.member(jsii_name="resetPhasedRelease")
    def reset_phased_release(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPhasedRelease", []))

    @jsii.member(jsii_name="resetPreconnect")
    def reset_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnect", []))

    @jsii.member(jsii_name="resetPredictiveContentDelivery")
    def reset_predictive_content_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictiveContentDelivery", []))

    @jsii.member(jsii_name="resetPredictivePrefetching")
    def reset_predictive_prefetching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictivePrefetching", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetPrefetchable")
    def reset_prefetchable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchable", []))

    @jsii.member(jsii_name="resetPrefreshCache")
    def reset_prefresh_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshCache", []))

    @jsii.member(jsii_name="resetQuality")
    def reset_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuality", []))

    @jsii.member(jsii_name="resetQuicBeta")
    def reset_quic_beta(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicBeta", []))

    @jsii.member(jsii_name="resetRandomSeek")
    def reset_random_seek(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandomSeek", []))

    @jsii.member(jsii_name="resetRapid")
    def reset_rapid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRapid", []))

    @jsii.member(jsii_name="resetReadTimeout")
    def reset_read_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReadTimeout", []))

    @jsii.member(jsii_name="resetRealTimeReporting")
    def reset_real_time_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealTimeReporting", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectplus")
    def reset_redirectplus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectplus", []))

    @jsii.member(jsii_name="resetRefererChecking")
    def reset_referer_checking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefererChecking", []))

    @jsii.member(jsii_name="resetRemoveQueryParameter")
    def reset_remove_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveQueryParameter", []))

    @jsii.member(jsii_name="resetRemoveVary")
    def reset_remove_vary(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveVary", []))

    @jsii.member(jsii_name="resetReport")
    def reset_report(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReport", []))

    @jsii.member(jsii_name="resetRequestClientHints")
    def reset_request_client_hints(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestClientHints", []))

    @jsii.member(jsii_name="resetRequestControl")
    def reset_request_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestControl", []))

    @jsii.member(jsii_name="resetRequestTypeMarker")
    def reset_request_type_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestTypeMarker", []))

    @jsii.member(jsii_name="resetResourceOptimizer")
    def reset_resource_optimizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizer", []))

    @jsii.member(jsii_name="resetResourceOptimizerExtendedCompatibility")
    def reset_resource_optimizer_extended_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizerExtendedCompatibility", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetResponseCookie")
    def reset_response_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCookie", []))

    @jsii.member(jsii_name="resetRestrictObjectCaching")
    def reset_restrict_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRestrictObjectCaching", []))

    @jsii.member(jsii_name="resetReturnCacheStatus")
    def reset_return_cache_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnCacheStatus", []))

    @jsii.member(jsii_name="resetRewriteUrl")
    def reset_rewrite_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRewriteUrl", []))

    @jsii.member(jsii_name="resetRumCustom")
    def reset_rum_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumCustom", []))

    @jsii.member(jsii_name="resetSaasDefinitions")
    def reset_saas_definitions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasDefinitions", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudClient")
    def reset_sales_force_commerce_cloud_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudClient", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProvider")
    def reset_sales_force_commerce_cloud_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProvider", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProviderHostHeader")
    def reset_sales_force_commerce_cloud_provider_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProviderHostHeader", []))

    @jsii.member(jsii_name="resetSavePostDcaProcessing")
    def reset_save_post_dca_processing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSavePostDcaProcessing", []))

    @jsii.member(jsii_name="resetScheduleInvalidation")
    def reset_schedule_invalidation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScheduleInvalidation", []))

    @jsii.member(jsii_name="resetScriptManagement")
    def reset_script_management(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScriptManagement", []))

    @jsii.member(jsii_name="resetSegmentedContentProtection")
    def reset_segmented_content_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedContentProtection", []))

    @jsii.member(jsii_name="resetSegmentedMediaOptimization")
    def reset_segmented_media_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaOptimization", []))

    @jsii.member(jsii_name="resetSegmentedMediaStreamingPrefetch")
    def reset_segmented_media_streaming_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaStreamingPrefetch", []))

    @jsii.member(jsii_name="resetSetVariable")
    def reset_set_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetVariable", []))

    @jsii.member(jsii_name="resetSimulateErrorCode")
    def reset_simulate_error_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSimulateErrorCode", []))

    @jsii.member(jsii_name="resetSiteShield")
    def reset_site_shield(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteShield", []))

    @jsii.member(jsii_name="resetStandardTlsMigration")
    def reset_standard_tls_migration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigration", []))

    @jsii.member(jsii_name="resetStandardTlsMigrationOverride")
    def reset_standard_tls_migration_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigrationOverride", []))

    @jsii.member(jsii_name="resetStrictHeaderParsing")
    def reset_strict_header_parsing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictHeaderParsing", []))

    @jsii.member(jsii_name="resetSubCustomer")
    def reset_sub_customer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubCustomer", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTcpOptimization")
    def reset_tcp_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTcpOptimization", []))

    @jsii.member(jsii_name="resetTeaLeaf")
    def reset_tea_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTeaLeaf", []))

    @jsii.member(jsii_name="resetTieredDistribution")
    def reset_tiered_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistribution", []))

    @jsii.member(jsii_name="resetTieredDistributionAdvanced")
    def reset_tiered_distribution_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionAdvanced", []))

    @jsii.member(jsii_name="resetTieredDistributionCustomization")
    def reset_tiered_distribution_customization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionCustomization", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUidConfiguration")
    def reset_uid_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUidConfiguration", []))

    @jsii.member(jsii_name="resetValidateEntityTag")
    def reset_validate_entity_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateEntityTag", []))

    @jsii.member(jsii_name="resetVerifyJsonWebToken")
    def reset_verify_json_web_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebToken", []))

    @jsii.member(jsii_name="resetVerifyJsonWebTokenForDcp")
    def reset_verify_json_web_token_for_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebTokenForDcp", []))

    @jsii.member(jsii_name="resetVerifyTokenAuthorization")
    def reset_verify_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyTokenAuthorization", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoom")
    def reset_virtual_waiting_room(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoom", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomWithEdgeWorkers")
    def reset_virtual_waiting_room_with_edge_workers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomWithEdgeWorkers", []))

    @jsii.member(jsii_name="resetVisitorPrioritization")
    def reset_visitor_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritization", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifo")
    def reset_visitor_prioritization_fifo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifo", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifoStandalone")
    def reset_visitor_prioritization_fifo_standalone(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifoStandalone", []))

    @jsii.member(jsii_name="resetWatermarking")
    def reset_watermarking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWatermarking", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @jsii.member(jsii_name="resetWebdav")
    def reset_webdav(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebdav", []))

    @jsii.member(jsii_name="resetWebSockets")
    def reset_web_sockets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebSockets", []))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAcceleration")
    def adaptive_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAccelerationOutputReference, jsii.get(self, "adaptiveAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompression")
    def adaptive_image_compression(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompressionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompressionOutputReference, jsii.get(self, "adaptiveImageCompression"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreaker")
    def ad_scaler_circuit_breaker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreakerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreakerOutputReference, jsii.get(self, "adScalerCircuitBreaker"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvancedOutputReference, jsii.get(self, "advanced"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReporting")
    def aggregated_reporting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReportingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReportingOutputReference, jsii.get(self, "aggregatedReporting"))

    @builtins.property
    @jsii.member(jsii_name="akamaizer")
    def akamaizer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerOutputReference, jsii.get(self, "akamaizer"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTag")
    def akamaizer_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTagOutputReference, jsii.get(self, "akamaizerTag"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchy")
    def all_http_in_cache_hierarchy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchyOutputReference, jsii.get(self, "allHttpInCacheHierarchy"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOrigins")
    def allow_cloudlets_origins(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOriginsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOriginsOutputReference, jsii.get(self, "allowCloudletsOrigins"))

    @builtins.property
    @jsii.member(jsii_name="allowDelete")
    def allow_delete(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDeleteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDeleteOutputReference, jsii.get(self, "allowDelete"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharing")
    def allow_https_cache_key_sharing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharingOutputReference, jsii.get(self, "allowHttpsCacheKeySharing"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngradeOutputReference, jsii.get(self, "allowHttpsDowngrade"))

    @builtins.property
    @jsii.member(jsii_name="allowOptions")
    def allow_options(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptionsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptionsOutputReference, jsii.get(self, "allowOptions"))

    @builtins.property
    @jsii.member(jsii_name="allowPatch")
    def allow_patch(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatchOutputReference, jsii.get(self, "allowPatch"))

    @builtins.property
    @jsii.member(jsii_name="allowPost")
    def allow_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPostOutputReference, jsii.get(self, "allowPost"))

    @builtins.property
    @jsii.member(jsii_name="allowPut")
    def allow_put(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPutOutputReference, jsii.get(self, "allowPut"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncoding")
    def allow_transfer_encoding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncodingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncodingOutputReference, jsii.get(self, "allowTransferEncoding"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeader")
    def alt_svc_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeaderOutputReference, jsii.get(self, "altSvcHeader"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritization")
    def api_prioritization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference, jsii.get(self, "apiPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancer")
    def application_load_balancer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference, jsii.get(self, "applicationLoadBalancer"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentation")
    def audience_segmentation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference, jsii.get(self, "audienceSegmentation"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidation")
    def auto_domain_validation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference, jsii.get(self, "autoDomainValidation"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectory")
    def base_directory(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference, jsii.get(self, "baseDirectory"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconing")
    def boss_beaconing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference, jsii.get(self, "bossBeaconing"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbs")
    def breadcrumbs(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference, jsii.get(self, "breadcrumbs"))

    @builtins.property
    @jsii.member(jsii_name="breakConnection")
    def break_connection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference, jsii.get(self, "breakConnection"))

    @builtins.property
    @jsii.member(jsii_name="brotli")
    def brotli(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference, jsii.get(self, "brotli"))

    @builtins.property
    @jsii.member(jsii_name="cacheError")
    def cache_error(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference, jsii.get(self, "cacheError"))

    @builtins.property
    @jsii.member(jsii_name="cacheId")
    def cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference, jsii.get(self, "cacheId"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCase")
    def cache_key_ignore_case(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference, jsii.get(self, "cacheKeyIgnoreCase"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParams")
    def cache_key_query_params(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference, jsii.get(self, "cacheKeyQueryParams"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewrite")
    def cache_key_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference, jsii.get(self, "cacheKeyRewrite"))

    @builtins.property
    @jsii.member(jsii_name="cachePost")
    def cache_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference, jsii.get(self, "cachePost"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirect")
    def cache_redirect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference, jsii.get(self, "cacheRedirect"))

    @builtins.property
    @jsii.member(jsii_name="cacheTag")
    def cache_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference, jsii.get(self, "cacheTag"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisible")
    def cache_tag_visible(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference, jsii.get(self, "cacheTagVisible"))

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference, jsii.get(self, "caching"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorization")
    def central_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference, jsii.get(self, "centralAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirects")
    def chase_redirects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference, jsii.get(self, "chaseRedirects"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAuth")
    def client_certificate_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference, jsii.get(self, "clientCertificateAuth"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristics")
    def client_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference, jsii.get(self, "clientCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnects")
    def cloud_interconnects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference, jsii.get(self, "cloudInterconnects"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapper")
    def cloud_wrapper(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference, jsii.get(self, "cloudWrapper"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvanced")
    def cloud_wrapper_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference, jsii.get(self, "cloudWrapperAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientData")
    def common_media_client_data(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference, jsii.get(self, "commonMediaClientData"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOrigin")
    def conditional_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference, jsii.get(self, "conditionalOrigin"))

    @builtins.property
    @jsii.member(jsii_name="constructResponse")
    def construct_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference, jsii.get(self, "constructResponse"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristics")
    def content_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference, jsii.get(self, "contentCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmd")
    def content_characteristics_amd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference, jsii.get(self, "contentCharacteristicsAmd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDd")
    def content_characteristics_dd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference, jsii.get(self, "contentCharacteristicsDd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFile")
    def content_characteristics_wsd_large_file(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference, jsii.get(self, "contentCharacteristicsWsdLargeFile"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLive")
    def content_characteristics_wsd_live(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference, jsii.get(self, "contentCharacteristicsWsdLive"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVod")
    def content_characteristics_wsd_vod(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference, jsii.get(self, "contentCharacteristicsWsdVod"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePosition")
    def content_pre_position(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference, jsii.get(self, "contentPrePosition"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtection")
    def content_targeting_protection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference, jsii.get(self, "contentTargetingProtection"))

    @builtins.property
    @jsii.member(jsii_name="corsSupport")
    def cors_support(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference, jsii.get(self, "corsSupport"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="customBehavior")
    def custom_behavior(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference, jsii.get(self, "customBehavior"))

    @builtins.property
    @jsii.member(jsii_name="datastream")
    def datastream(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference, jsii.get(self, "datastream"))

    @builtins.property
    @jsii.member(jsii_name="dcp")
    def dcp(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference, jsii.get(self, "dcp"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformation")
    def dcp_auth_hmac_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference, jsii.get(self, "dcpAuthHmacTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformation")
    def dcp_auth_regex_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference, jsii.get(self, "dcpAuthRegexTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformation")
    def dcp_auth_substring_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference, jsii.get(self, "dcpAuthSubstringTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractor")
    def dcp_auth_variable_extractor(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference, jsii.get(self, "dcpAuthVariableExtractor"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroups")
    def dcp_default_authz_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference, jsii.get(self, "dcpDefaultAuthzGroups"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelations")
    def dcp_dev_relations(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference, jsii.get(self, "dcpDevRelations"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuth")
    def dcp_real_time_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference, jsii.get(self, "dcpRealTimeAuth"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceipt")
    def delivery_receipt(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference, jsii.get(self, "deliveryReceipt"))

    @builtins.property
    @jsii.member(jsii_name="denyAccess")
    def deny_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference, jsii.get(self, "denyAccess"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccess")
    def deny_direct_failover_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference, jsii.get(self, "denyDirectFailoverAccess"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheId")
    def device_characteristic_cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference, jsii.get(self, "deviceCharacteristicCacheId"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeader")
    def device_characteristic_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference, jsii.get(self, "deviceCharacteristicHeader"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefresh")
    def dns_async_refresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference, jsii.get(self, "dnsAsyncRefresh"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefresh")
    def dns_prefresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference, jsii.get(self, "dnsPrefresh"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocol")
    def downgrade_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference, jsii.get(self, "downgradeProtocol"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarker")
    def download_complete_marker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference, jsii.get(self, "downloadCompleteMarker"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotification")
    def download_notification(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference, jsii.get(self, "downloadNotification"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCache")
    def downstream_cache(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference, jsii.get(self, "downstreamCache"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimization")
    def dynamic_throughtput_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference, jsii.get(self, "dynamicThroughtputOptimization"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverride")
    def dynamic_throughtput_optimization_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference, jsii.get(self, "dynamicThroughtputOptimizationOverride"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference, jsii.get(self, "dynamicWebContent"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUpload")
    def ecms_bulk_upload(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference, jsii.get(self, "ecmsBulkUpload"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabase")
    def ecms_database(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference, jsii.get(self, "ecmsDatabase"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDataset")
    def ecms_dataset(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference, jsii.get(self, "ecmsDataset"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKey")
    def ecms_object_key(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference, jsii.get(self, "ecmsObjectKey"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnect")
    def edge_connect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference, jsii.get(self, "edgeConnect"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvanced")
    def edge_load_balancing_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference, jsii.get(self, "edgeLoadBalancingAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenter")
    def edge_load_balancing_data_center(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference, jsii.get(self, "edgeLoadBalancingDataCenter"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOrigin")
    def edge_load_balancing_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference, jsii.get(self, "edgeLoadBalancingOrigin"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorization")
    def edge_origin_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference, jsii.get(self, "edgeOriginAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirector")
    def edge_redirector(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference, jsii.get(self, "edgeRedirector"))

    @builtins.property
    @jsii.member(jsii_name="edgeScape")
    def edge_scape(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference, jsii.get(self, "edgeScape"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludes")
    def edge_side_includes(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference, jsii.get(self, "edgeSideIncludes"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorker")
    def edge_worker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference, jsii.get(self, "edgeWorker"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsSettings")
    def enforce_mtls_settings(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference, jsii.get(self, "enforceMtlsSettings"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocol")
    def enhanced_akamai_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference, jsii.get(self, "enhancedAkamaiProtocol"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetection")
    def enhanced_proxy_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference, jsii.get(self, "enhancedProxyDetection"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichment")
    def epd_forward_header_enrichment(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference, jsii.get(self, "epdForwardHeaderEnrichment"))

    @builtins.property
    @jsii.member(jsii_name="failAction")
    def fail_action(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference, jsii.get(self, "failAction"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibility")
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference, jsii.get(self, "failoverBotManagerFeatureCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidate")
    def fast_invalidate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference, jsii.get(self, "fastInvalidate"))

    @builtins.property
    @jsii.member(jsii_name="fips")
    def fips(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference, jsii.get(self, "fips"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketing")
    def first_party_marketing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference, jsii.get(self, "firstPartyMarketing"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlus")
    def first_party_marketing_plus(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference, jsii.get(self, "firstPartyMarketingPlus"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewrite")
    def forward_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference, jsii.get(self, "forwardRewrite"))

    @builtins.property
    @jsii.member(jsii_name="g2Oheader")
    def g2_oheader(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference, jsii.get(self, "g2Oheader"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumber")
    def global_request_number(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference, jsii.get(self, "globalRequestNumber"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCaching")
    def graphql_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference, jsii.get(self, "graphqlCaching"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponse")
    def gzip_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference, jsii.get(self, "gzipResponse"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvanced")
    def hd_data_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference, jsii.get(self, "hdDataAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="healthDetection")
    def health_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference, jsii.get(self, "healthDetection"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBinding")
    def hsaf_eip_binding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference, jsii.get(self, "hsafEipBinding"))

    @builtins.property
    @jsii.member(jsii_name="http2")
    def http2(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference, jsii.get(self, "http2"))

    @builtins.property
    @jsii.member(jsii_name="http3")
    def http3(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference, jsii.get(self, "http3"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurity")
    def http_strict_transport_security(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference, jsii.get(self, "httpStrictTransportSecurity"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgrade")
    def http_to_https_upgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference, jsii.get(self, "httpToHttpsUpgrade"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManager")
    def image_and_video_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference, jsii.get(self, "imageAndVideoManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManager")
    def image_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference, jsii.get(self, "imageManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideo")
    def image_manager_video(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference, jsii.get(self, "imageManagerVideo"))

    @builtins.property
    @jsii.member(jsii_name="imOverride")
    def im_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference, jsii.get(self, "imOverride"))

    @builtins.property
    @jsii.member(jsii_name="include")
    def include(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference, jsii.get(self, "include"))

    @builtins.property
    @jsii.member(jsii_name="instant")
    def instant(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference, jsii.get(self, "instant"))

    @builtins.property
    @jsii.member(jsii_name="instantConfig")
    def instant_config(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference, jsii.get(self, "instantConfig"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimization")
    def large_file_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference, jsii.get(self, "largeFileOptimization"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvanced")
    def large_file_optimization_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvancedOutputReference, jsii.get(self, "largeFileOptimizationAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRate")
    def limit_bit_rate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateOutputReference, jsii.get(self, "limitBitRate"))

    @builtins.property
    @jsii.member(jsii_name="logCustom")
    def log_custom(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustomOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustomOutputReference, jsii.get(self, "logCustom"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalization")
    def manifest_personalization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalizationOutputReference, jsii.get(self, "manifestPersonalization"))

    @builtins.property
    @jsii.member(jsii_name="manifestRerouting")
    def manifest_rerouting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestReroutingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestReroutingOutputReference, jsii.get(self, "manifestRerouting"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPush")
    def manual_server_push(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPushOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPushOutputReference, jsii.get(self, "manualServerPush"))

    @builtins.property
    @jsii.member(jsii_name="mediaAcceleration")
    def media_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationOutputReference, jsii.get(self, "mediaAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptout")
    def media_acceleration_quic_optout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptoutOutputReference, jsii.get(self, "mediaAccelerationQuicOptout"))

    @builtins.property
    @jsii.member(jsii_name="mediaClient")
    def media_client(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClientOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClientOutputReference, jsii.get(self, "mediaClient"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimization")
    def media_file_retrieval_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimizationOutputReference, jsii.get(self, "mediaFileRetrievalOptimization"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailover")
    def media_origin_failover(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailoverOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailoverOutputReference, jsii.get(self, "mediaOriginFailover"))

    @builtins.property
    @jsii.member(jsii_name="metadataCaching")
    def metadata_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCachingOutputReference, jsii.get(self, "metadataCaching"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformance")
    def mobile_sdk_performance(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformanceOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformanceOutputReference, jsii.get(self, "mobileSdkPerformance"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeader")
    def modify_incoming_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeaderOutputReference, jsii.get(self, "modifyIncomingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeader")
    def modify_incoming_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeaderOutputReference, jsii.get(self, "modifyIncomingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeader")
    def modify_outgoing_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeaderOutputReference, jsii.get(self, "modifyOutgoingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeader")
    def modify_outgoing_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeaderOutputReference, jsii.get(self, "modifyOutgoingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeader")
    def modify_via_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeaderOutputReference, jsii.get(self, "modifyViaHeader"))

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulseOutputReference, jsii.get(self, "mPulse"))

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginOutputReference, jsii.get(self, "origin"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristics")
    def origin_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsOutputReference, jsii.get(self, "originCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsd")
    def origin_characteristics_wsd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsdOutputReference, jsii.get(self, "originCharacteristicsWsd"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethod")
    def origin_failure_recovery_method(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethodOutputReference, jsii.get(self, "originFailureRecoveryMethod"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicy")
    def origin_failure_recovery_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicyOutputReference, jsii.get(self, "originFailureRecoveryPolicy"))

    @builtins.property
    @jsii.member(jsii_name="originIpAcl")
    def origin_ip_acl(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAclOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAclOutputReference, jsii.get(self, "originIpAcl"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicy")
    def permissions_policy(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicyOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicyOutputReference", jsii.get(self, "permissionsPolicy"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnection")
    def persistent_client_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnectionOutputReference", jsii.get(self, "persistentClientConnection"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnection")
    def persistent_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnectionOutputReference", jsii.get(self, "persistentConnection"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformation")
    def personally_identifiable_information(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformationOutputReference", jsii.get(self, "personallyIdentifiableInformation"))

    @builtins.property
    @jsii.member(jsii_name="phasedRelease")
    def phased_release(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseOutputReference", jsii.get(self, "phasedRelease"))

    @builtins.property
    @jsii.member(jsii_name="preconnect")
    def preconnect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnectOutputReference", jsii.get(self, "preconnect"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDelivery")
    def predictive_content_delivery(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDeliveryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDeliveryOutputReference", jsii.get(self, "predictiveContentDelivery"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetching")
    def predictive_prefetching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetchingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetchingOutputReference", jsii.get(self, "predictivePrefetching"))

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchOutputReference", jsii.get(self, "prefetch"))

    @builtins.property
    @jsii.member(jsii_name="prefetchable")
    def prefetchable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchableOutputReference", jsii.get(self, "prefetchable"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCache")
    def prefresh_cache(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCacheOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCacheOutputReference", jsii.get(self, "prefreshCache"))

    @builtins.property
    @jsii.member(jsii_name="quality")
    def quality(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQualityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQualityOutputReference", jsii.get(self, "quality"))

    @builtins.property
    @jsii.member(jsii_name="quicBeta")
    def quic_beta(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBetaOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBetaOutputReference", jsii.get(self, "quicBeta"))

    @builtins.property
    @jsii.member(jsii_name="randomSeek")
    def random_seek(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeekOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeekOutputReference", jsii.get(self, "randomSeek"))

    @builtins.property
    @jsii.member(jsii_name="rapid")
    def rapid(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapidOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapidOutputReference", jsii.get(self, "rapid"))

    @builtins.property
    @jsii.member(jsii_name="readTimeout")
    def read_timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeoutOutputReference", jsii.get(self, "readTimeout"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReporting")
    def real_time_reporting(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReportingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReportingOutputReference", jsii.get(self, "realTimeReporting"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoringOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoringOutputReference", jsii.get(self, "realUserMonitoring"))

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectOutputReference", jsii.get(self, "redirect"))

    @builtins.property
    @jsii.member(jsii_name="redirectplus")
    def redirectplus(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplusOutputReference", jsii.get(self, "redirectplus"))

    @builtins.property
    @jsii.member(jsii_name="refererChecking")
    def referer_checking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererCheckingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererCheckingOutputReference", jsii.get(self, "refererChecking"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameter")
    def remove_query_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameterOutputReference", jsii.get(self, "removeQueryParameter"))

    @builtins.property
    @jsii.member(jsii_name="removeVary")
    def remove_vary(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVaryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVaryOutputReference", jsii.get(self, "removeVary"))

    @builtins.property
    @jsii.member(jsii_name="report")
    def report(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReportOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReportOutputReference", jsii.get(self, "report"))

    @builtins.property
    @jsii.member(jsii_name="requestClientHints")
    def request_client_hints(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHintsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHintsOutputReference", jsii.get(self, "requestClientHints"))

    @builtins.property
    @jsii.member(jsii_name="requestControl")
    def request_control(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlOutputReference", jsii.get(self, "requestControl"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarker")
    def request_type_marker(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarkerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarkerOutputReference", jsii.get(self, "requestTypeMarker"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizer")
    def resource_optimizer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerOutputReference", jsii.get(self, "resourceOptimizer"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibility")
    def resource_optimizer_extended_compatibility(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibilityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibilityOutputReference", jsii.get(self, "resourceOptimizerExtendedCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCodeOutputReference", jsii.get(self, "responseCode"))

    @builtins.property
    @jsii.member(jsii_name="responseCookie")
    def response_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookieOutputReference", jsii.get(self, "responseCookie"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCaching")
    def restrict_object_caching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCachingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCachingOutputReference", jsii.get(self, "restrictObjectCaching"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatus")
    def return_cache_status(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatusOutputReference", jsii.get(self, "returnCacheStatus"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrl")
    def rewrite_url(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrlOutputReference", jsii.get(self, "rewriteUrl"))

    @builtins.property
    @jsii.member(jsii_name="rumCustom")
    def rum_custom(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustomOutputReference", jsii.get(self, "rumCustom"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitions")
    def saas_definitions(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitionsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitionsOutputReference", jsii.get(self, "saasDefinitions"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClient")
    def sales_force_commerce_cloud_client(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClientOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClientOutputReference", jsii.get(self, "salesForceCommerceCloudClient"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProvider")
    def sales_force_commerce_cloud_provider(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderOutputReference", jsii.get(self, "salesForceCommerceCloudProvider"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeader")
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference", jsii.get(self, "salesForceCommerceCloudProviderHostHeader"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessing")
    def save_post_dca_processing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessingOutputReference", jsii.get(self, "savePostDcaProcessing"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidation")
    def schedule_invalidation(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidationOutputReference", jsii.get(self, "scheduleInvalidation"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagement")
    def script_management(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagementOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagementOutputReference", jsii.get(self, "scriptManagement"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtection")
    def segmented_content_protection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtectionOutputReference", jsii.get(self, "segmentedContentProtection"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimization")
    def segmented_media_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimizationOutputReference", jsii.get(self, "segmentedMediaOptimization"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetch")
    def segmented_media_streaming_prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetchOutputReference", jsii.get(self, "segmentedMediaStreamingPrefetch"))

    @builtins.property
    @jsii.member(jsii_name="setVariable")
    def set_variable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariableOutputReference", jsii.get(self, "setVariable"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCode")
    def simulate_error_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCodeOutputReference", jsii.get(self, "simulateErrorCode"))

    @builtins.property
    @jsii.member(jsii_name="siteShield")
    def site_shield(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldOutputReference", jsii.get(self, "siteShield"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigration")
    def standard_tls_migration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOutputReference", jsii.get(self, "standardTlsMigration"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverride")
    def standard_tls_migration_override(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverrideOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverrideOutputReference", jsii.get(self, "standardTlsMigrationOverride"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsing")
    def strict_header_parsing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsingOutputReference", jsii.get(self, "strictHeaderParsing"))

    @builtins.property
    @jsii.member(jsii_name="subCustomer")
    def sub_customer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomerOutputReference", jsii.get(self, "subCustomer"))

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRouteOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRouteOutputReference", jsii.get(self, "sureRoute"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimization")
    def tcp_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimizationOutputReference", jsii.get(self, "tcpOptimization"))

    @builtins.property
    @jsii.member(jsii_name="teaLeaf")
    def tea_leaf(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeafOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeafOutputReference", jsii.get(self, "teaLeaf"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistribution")
    def tiered_distribution(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionOutputReference", jsii.get(self, "tieredDistribution"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvanced")
    def tiered_distribution_advanced(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvancedOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvancedOutputReference", jsii.get(self, "tieredDistributionAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomization")
    def tiered_distribution_customization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomizationOutputReference", jsii.get(self, "tieredDistributionCustomization"))

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeoutOutputReference", jsii.get(self, "timeout"))

    @builtins.property
    @jsii.member(jsii_name="uidConfiguration")
    def uid_configuration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfigurationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfigurationOutputReference", jsii.get(self, "uidConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTag")
    def validate_entity_tag(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTagOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTagOutputReference", jsii.get(self, "validateEntityTag"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebToken")
    def verify_json_web_token(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenOutputReference", jsii.get(self, "verifyJsonWebToken"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcp")
    def verify_json_web_token_for_dcp(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcpOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcpOutputReference", jsii.get(self, "verifyJsonWebTokenForDcp"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorization")
    def verify_token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorizationOutputReference", jsii.get(self, "verifyTokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoom")
    def virtual_waiting_room(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomOutputReference", jsii.get(self, "virtualWaitingRoom"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkers")
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference", jsii.get(self, "virtualWaitingRoomWithEdgeWorkers"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritization")
    def visitor_prioritization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationOutputReference", jsii.get(self, "visitorPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifo")
    def visitor_prioritization_fifo(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoOutputReference", jsii.get(self, "visitorPrioritizationFifo"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandalone")
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandaloneOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandaloneOutputReference", jsii.get(self, "visitorPrioritizationFifoStandalone"))

    @builtins.property
    @jsii.member(jsii_name="watermarking")
    def watermarking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarkingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarkingOutputReference", jsii.get(self, "watermarking"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallOutputReference", jsii.get(self, "webApplicationFirewall"))

    @builtins.property
    @jsii.member(jsii_name="webdav")
    def webdav(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdavOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdavOutputReference", jsii.get(self, "webdav"))

    @builtins.property
    @jsii.member(jsii_name="webSockets")
    def web_sockets(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSocketsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSocketsOutputReference", jsii.get(self, "webSockets"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAccelerationInput")
    def adaptive_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration], jsii.get(self, "adaptiveAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompressionInput")
    def adaptive_image_compression_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression], jsii.get(self, "adaptiveImageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreakerInput")
    def ad_scaler_circuit_breaker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker], jsii.get(self, "adScalerCircuitBreakerInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReportingInput")
    def aggregated_reporting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting], jsii.get(self, "aggregatedReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerInput")
    def akamaizer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer], jsii.get(self, "akamaizerInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTagInput")
    def akamaizer_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag], jsii.get(self, "akamaizerTagInput"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchyInput")
    def all_http_in_cache_hierarchy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy], jsii.get(self, "allHttpInCacheHierarchyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOriginsInput")
    def allow_cloudlets_origins_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins], jsii.get(self, "allowCloudletsOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowDeleteInput")
    def allow_delete_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete], jsii.get(self, "allowDeleteInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharingInput")
    def allow_https_cache_key_sharing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "allowHttpsCacheKeySharingInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOptionsInput")
    def allow_options_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions], jsii.get(self, "allowOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPatchInput")
    def allow_patch_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch], jsii.get(self, "allowPatchInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPostInput")
    def allow_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost], jsii.get(self, "allowPostInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPutInput")
    def allow_put_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut], jsii.get(self, "allowPutInput"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncodingInput")
    def allow_transfer_encoding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding], jsii.get(self, "allowTransferEncodingInput"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeaderInput")
    def alt_svc_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader], jsii.get(self, "altSvcHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritizationInput")
    def api_prioritization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization], jsii.get(self, "apiPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancerInput")
    def application_load_balancer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer], jsii.get(self, "applicationLoadBalancerInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentationInput")
    def audience_segmentation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation], jsii.get(self, "audienceSegmentationInput"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidationInput")
    def auto_domain_validation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation], jsii.get(self, "autoDomainValidationInput"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectoryInput")
    def base_directory_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory], jsii.get(self, "baseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconingInput")
    def boss_beaconing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing], jsii.get(self, "bossBeaconingInput"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbsInput")
    def breadcrumbs_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs], jsii.get(self, "breadcrumbsInput"))

    @builtins.property
    @jsii.member(jsii_name="breakConnectionInput")
    def break_connection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection], jsii.get(self, "breakConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="brotliInput")
    def brotli_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli], jsii.get(self, "brotliInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorInput")
    def cache_error_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError], jsii.get(self, "cacheErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheIdInput")
    def cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId], jsii.get(self, "cacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCaseInput")
    def cache_key_ignore_case_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase], jsii.get(self, "cacheKeyIgnoreCaseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParamsInput")
    def cache_key_query_params_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams], jsii.get(self, "cacheKeyQueryParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewriteInput")
    def cache_key_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite], jsii.get(self, "cacheKeyRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="cachePostInput")
    def cache_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost], jsii.get(self, "cachePostInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirectInput")
    def cache_redirect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect], jsii.get(self, "cacheRedirectInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagInput")
    def cache_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag], jsii.get(self, "cacheTagInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisibleInput")
    def cache_tag_visible_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible], jsii.get(self, "cacheTagVisibleInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorizationInput")
    def central_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization], jsii.get(self, "centralAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirectsInput")
    def chase_redirects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects], jsii.get(self, "chaseRedirectsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAuthInput")
    def client_certificate_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth], jsii.get(self, "clientCertificateAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristicsInput")
    def client_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics], jsii.get(self, "clientCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnectsInput")
    def cloud_interconnects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects], jsii.get(self, "cloudInterconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvancedInput")
    def cloud_wrapper_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced], jsii.get(self, "cloudWrapperAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperInput")
    def cloud_wrapper_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper], jsii.get(self, "cloudWrapperInput"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientDataInput")
    def common_media_client_data_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData], jsii.get(self, "commonMediaClientDataInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOriginInput")
    def conditional_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin], jsii.get(self, "conditionalOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="constructResponseInput")
    def construct_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse], jsii.get(self, "constructResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmdInput")
    def content_characteristics_amd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd], jsii.get(self, "contentCharacteristicsAmdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDdInput")
    def content_characteristics_dd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd], jsii.get(self, "contentCharacteristicsDdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsInput")
    def content_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics], jsii.get(self, "contentCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFileInput")
    def content_characteristics_wsd_large_file_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "contentCharacteristicsWsdLargeFileInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLiveInput")
    def content_characteristics_wsd_live_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive], jsii.get(self, "contentCharacteristicsWsdLiveInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVodInput")
    def content_characteristics_wsd_vod_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod], jsii.get(self, "contentCharacteristicsWsdVodInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePositionInput")
    def content_pre_position_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition], jsii.get(self, "contentPrePositionInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtectionInput")
    def content_targeting_protection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection], jsii.get(self, "contentTargetingProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="corsSupportInput")
    def cors_support_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport], jsii.get(self, "corsSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="customBehaviorInput")
    def custom_behavior_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior], jsii.get(self, "customBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamInput")
    def datastream_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream], jsii.get(self, "datastreamInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformationInput")
    def dcp_auth_hmac_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation], jsii.get(self, "dcpAuthHmacTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformationInput")
    def dcp_auth_regex_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation], jsii.get(self, "dcpAuthRegexTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformationInput")
    def dcp_auth_substring_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation], jsii.get(self, "dcpAuthSubstringTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractorInput")
    def dcp_auth_variable_extractor_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor], jsii.get(self, "dcpAuthVariableExtractorInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroupsInput")
    def dcp_default_authz_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups], jsii.get(self, "dcpDefaultAuthzGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelationsInput")
    def dcp_dev_relations_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations], jsii.get(self, "dcpDevRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpInput")
    def dcp_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp], jsii.get(self, "dcpInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuthInput")
    def dcp_real_time_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth], jsii.get(self, "dcpRealTimeAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceiptInput")
    def delivery_receipt_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt], jsii.get(self, "deliveryReceiptInput"))

    @builtins.property
    @jsii.member(jsii_name="denyAccessInput")
    def deny_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess], jsii.get(self, "denyAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccessInput")
    def deny_direct_failover_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess], jsii.get(self, "denyDirectFailoverAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheIdInput")
    def device_characteristic_cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId], jsii.get(self, "deviceCharacteristicCacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeaderInput")
    def device_characteristic_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader], jsii.get(self, "deviceCharacteristicHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefreshInput")
    def dns_async_refresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh], jsii.get(self, "dnsAsyncRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefreshInput")
    def dns_prefresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh], jsii.get(self, "dnsPrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocolInput")
    def downgrade_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol], jsii.get(self, "downgradeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarkerInput")
    def download_complete_marker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker], jsii.get(self, "downloadCompleteMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotificationInput")
    def download_notification_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification], jsii.get(self, "downloadNotificationInput"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCacheInput")
    def downstream_cache_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache], jsii.get(self, "downstreamCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationInput")
    def dynamic_throughtput_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization], jsii.get(self, "dynamicThroughtputOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverrideInput")
    def dynamic_throughtput_optimization_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "dynamicThroughtputOptimizationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUploadInput")
    def ecms_bulk_upload_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload], jsii.get(self, "ecmsBulkUploadInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabaseInput")
    def ecms_database_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase], jsii.get(self, "ecmsDatabaseInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatasetInput")
    def ecms_dataset_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset], jsii.get(self, "ecmsDatasetInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKeyInput")
    def ecms_object_key_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey], jsii.get(self, "ecmsObjectKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnectInput")
    def edge_connect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect], jsii.get(self, "edgeConnectInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvancedInput")
    def edge_load_balancing_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "edgeLoadBalancingAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenterInput")
    def edge_load_balancing_data_center_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "edgeLoadBalancingDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOriginInput")
    def edge_load_balancing_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "edgeLoadBalancingOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorizationInput")
    def edge_origin_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization], jsii.get(self, "edgeOriginAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirectorInput")
    def edge_redirector_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector], jsii.get(self, "edgeRedirectorInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeScapeInput")
    def edge_scape_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape], jsii.get(self, "edgeScapeInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludesInput")
    def edge_side_includes_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes], jsii.get(self, "edgeSideIncludesInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerInput")
    def edge_worker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker], jsii.get(self, "edgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsSettingsInput")
    def enforce_mtls_settings_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings], jsii.get(self, "enforceMtlsSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocolInput")
    def enhanced_akamai_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol], jsii.get(self, "enhancedAkamaiProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetectionInput")
    def enhanced_proxy_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection], jsii.get(self, "enhancedProxyDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichmentInput")
    def epd_forward_header_enrichment_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "epdForwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="failActionInput")
    def fail_action_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction], jsii.get(self, "failActionInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibilityInput")
    def failover_bot_manager_feature_compatibility_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "failoverBotManagerFeatureCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidateInput")
    def fast_invalidate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate], jsii.get(self, "fastInvalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="fipsInput")
    def fips_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips], jsii.get(self, "fipsInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingInput")
    def first_party_marketing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing], jsii.get(self, "firstPartyMarketingInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlusInput")
    def first_party_marketing_plus_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus], jsii.get(self, "firstPartyMarketingPlusInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewriteInput")
    def forward_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite], jsii.get(self, "forwardRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OheaderInput")
    def g2_oheader_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader], jsii.get(self, "g2OheaderInput"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumberInput")
    def global_request_number_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber], jsii.get(self, "globalRequestNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCachingInput")
    def graphql_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching], jsii.get(self, "graphqlCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponseInput")
    def gzip_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse], jsii.get(self, "gzipResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvancedInput")
    def hd_data_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced], jsii.get(self, "hdDataAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="healthDetectionInput")
    def health_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection], jsii.get(self, "healthDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBindingInput")
    def hsaf_eip_binding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding], jsii.get(self, "hsafEipBindingInput"))

    @builtins.property
    @jsii.member(jsii_name="http2Input")
    def http2_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2], jsii.get(self, "http2Input"))

    @builtins.property
    @jsii.member(jsii_name="http3Input")
    def http3_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3], jsii.get(self, "http3Input"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurityInput")
    def http_strict_transport_security_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity], jsii.get(self, "httpStrictTransportSecurityInput"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgradeInput")
    def http_to_https_upgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade], jsii.get(self, "httpToHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManagerInput")
    def image_and_video_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager], jsii.get(self, "imageAndVideoManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerInput")
    def image_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager], jsii.get(self, "imageManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideoInput")
    def image_manager_video_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo], jsii.get(self, "imageManagerVideoInput"))

    @builtins.property
    @jsii.member(jsii_name="imOverrideInput")
    def im_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride], jsii.get(self, "imOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="includeInput")
    def include_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude], jsii.get(self, "includeInput"))

    @builtins.property
    @jsii.member(jsii_name="instantConfigInput")
    def instant_config_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig], jsii.get(self, "instantConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="instantInput")
    def instant_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant], jsii.get(self, "instantInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvancedInput")
    def large_file_optimization_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "largeFileOptimizationAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationInput")
    def large_file_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization], jsii.get(self, "largeFileOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRateInput")
    def limit_bit_rate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate], jsii.get(self, "limitBitRateInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomInput")
    def log_custom_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom], jsii.get(self, "logCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalizationInput")
    def manifest_personalization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization], jsii.get(self, "manifestPersonalizationInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestReroutingInput")
    def manifest_rerouting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting], jsii.get(self, "manifestReroutingInput"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPushInput")
    def manual_server_push_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush], jsii.get(self, "manualServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationInput")
    def media_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration], jsii.get(self, "mediaAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptoutInput")
    def media_acceleration_quic_optout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout], jsii.get(self, "mediaAccelerationQuicOptoutInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaClientInput")
    def media_client_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient], jsii.get(self, "mediaClientInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimizationInput")
    def media_file_retrieval_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization], jsii.get(self, "mediaFileRetrievalOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailoverInput")
    def media_origin_failover_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover], jsii.get(self, "mediaOriginFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataCachingInput")
    def metadata_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching], jsii.get(self, "metadataCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformanceInput")
    def mobile_sdk_performance_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance], jsii.get(self, "mobileSdkPerformanceInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeaderInput")
    def modify_incoming_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader], jsii.get(self, "modifyIncomingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeaderInput")
    def modify_incoming_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader], jsii.get(self, "modifyIncomingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeaderInput")
    def modify_outgoing_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader], jsii.get(self, "modifyOutgoingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeaderInput")
    def modify_outgoing_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader], jsii.get(self, "modifyOutgoingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeaderInput")
    def modify_via_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader], jsii.get(self, "modifyViaHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsInput")
    def origin_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics], jsii.get(self, "originCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsdInput")
    def origin_characteristics_wsd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd], jsii.get(self, "originCharacteristicsWsdInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethodInput")
    def origin_failure_recovery_method_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod], jsii.get(self, "originFailureRecoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicyInput")
    def origin_failure_recovery_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "originFailureRecoveryPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="originIpAclInput")
    def origin_ip_acl_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl], jsii.get(self, "originIpAclInput"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyInput")
    def permissions_policy_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy"], jsii.get(self, "permissionsPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnectionInput")
    def persistent_client_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection"], jsii.get(self, "persistentClientConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnectionInput")
    def persistent_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection"], jsii.get(self, "persistentConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformationInput")
    def personally_identifiable_information_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation"], jsii.get(self, "personallyIdentifiableInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="phasedReleaseInput")
    def phased_release_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease"], jsii.get(self, "phasedReleaseInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectInput")
    def preconnect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect"], jsii.get(self, "preconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDeliveryInput")
    def predictive_content_delivery_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery"], jsii.get(self, "predictiveContentDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetchingInput")
    def predictive_prefetching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching"], jsii.get(self, "predictivePrefetchingInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchableInput")
    def prefetchable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable"], jsii.get(self, "prefetchableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch"], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCacheInput")
    def prefresh_cache_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache"], jsii.get(self, "prefreshCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="qualityInput")
    def quality_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality"], jsii.get(self, "qualityInput"))

    @builtins.property
    @jsii.member(jsii_name="quicBetaInput")
    def quic_beta_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta"], jsii.get(self, "quicBetaInput"))

    @builtins.property
    @jsii.member(jsii_name="randomSeekInput")
    def random_seek_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek"], jsii.get(self, "randomSeekInput"))

    @builtins.property
    @jsii.member(jsii_name="rapidInput")
    def rapid_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid"], jsii.get(self, "rapidInput"))

    @builtins.property
    @jsii.member(jsii_name="readTimeoutInput")
    def read_timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout"], jsii.get(self, "readTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReportingInput")
    def real_time_reporting_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting"], jsii.get(self, "realTimeReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring"], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect"], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectplusInput")
    def redirectplus_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus"], jsii.get(self, "redirectplusInput"))

    @builtins.property
    @jsii.member(jsii_name="refererCheckingInput")
    def referer_checking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking"], jsii.get(self, "refererCheckingInput"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameterInput")
    def remove_query_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter"], jsii.get(self, "removeQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="removeVaryInput")
    def remove_vary_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary"], jsii.get(self, "removeVaryInput"))

    @builtins.property
    @jsii.member(jsii_name="reportInput")
    def report_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport"], jsii.get(self, "reportInput"))

    @builtins.property
    @jsii.member(jsii_name="requestClientHintsInput")
    def request_client_hints_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints"], jsii.get(self, "requestClientHintsInput"))

    @builtins.property
    @jsii.member(jsii_name="requestControlInput")
    def request_control_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl"], jsii.get(self, "requestControlInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarkerInput")
    def request_type_marker_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker"], jsii.get(self, "requestTypeMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibilityInput")
    def resource_optimizer_extended_compatibility_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility"], jsii.get(self, "resourceOptimizerExtendedCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerInput")
    def resource_optimizer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer"], jsii.get(self, "resourceOptimizerInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode"], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCookieInput")
    def response_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie"], jsii.get(self, "responseCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCachingInput")
    def restrict_object_caching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching"], jsii.get(self, "restrictObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatusInput")
    def return_cache_status_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus"], jsii.get(self, "returnCacheStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrlInput")
    def rewrite_url_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl"], jsii.get(self, "rewriteUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="rumCustomInput")
    def rum_custom_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom"], jsii.get(self, "rumCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitionsInput")
    def saas_definitions_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions"], jsii.get(self, "saasDefinitionsInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClientInput")
    def sales_force_commerce_cloud_client_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient"], jsii.get(self, "salesForceCommerceCloudClientInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeaderInput")
    def sales_force_commerce_cloud_provider_host_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader"], jsii.get(self, "salesForceCommerceCloudProviderHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderInput")
    def sales_force_commerce_cloud_provider_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider"], jsii.get(self, "salesForceCommerceCloudProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessingInput")
    def save_post_dca_processing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing"], jsii.get(self, "savePostDcaProcessingInput"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidationInput")
    def schedule_invalidation_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation"], jsii.get(self, "scheduleInvalidationInput"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagementInput")
    def script_management_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement"], jsii.get(self, "scriptManagementInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtectionInput")
    def segmented_content_protection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection"], jsii.get(self, "segmentedContentProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimizationInput")
    def segmented_media_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization"], jsii.get(self, "segmentedMediaOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetchInput")
    def segmented_media_streaming_prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch"], jsii.get(self, "segmentedMediaStreamingPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="setVariableInput")
    def set_variable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable"], jsii.get(self, "setVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCodeInput")
    def simulate_error_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode"], jsii.get(self, "simulateErrorCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="siteShieldInput")
    def site_shield_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield"], jsii.get(self, "siteShieldInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationInput")
    def standard_tls_migration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration"], jsii.get(self, "standardTlsMigrationInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverrideInput")
    def standard_tls_migration_override_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride"], jsii.get(self, "standardTlsMigrationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsingInput")
    def strict_header_parsing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing"], jsii.get(self, "strictHeaderParsingInput"))

    @builtins.property
    @jsii.member(jsii_name="subCustomerInput")
    def sub_customer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer"], jsii.get(self, "subCustomerInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute"], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimizationInput")
    def tcp_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization"], jsii.get(self, "tcpOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="teaLeafInput")
    def tea_leaf_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf"], jsii.get(self, "teaLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvancedInput")
    def tiered_distribution_advanced_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced"], jsii.get(self, "tieredDistributionAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomizationInput")
    def tiered_distribution_customization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization"], jsii.get(self, "tieredDistributionCustomizationInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionInput")
    def tiered_distribution_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution"], jsii.get(self, "tieredDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout"], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uidConfigurationInput")
    def uid_configuration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration"], jsii.get(self, "uidConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTagInput")
    def validate_entity_tag_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag"], jsii.get(self, "validateEntityTagInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcpInput")
    def verify_json_web_token_for_dcp_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp"], jsii.get(self, "verifyJsonWebTokenForDcpInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenInput")
    def verify_json_web_token_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken"], jsii.get(self, "verifyJsonWebTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorizationInput")
    def verify_token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization"], jsii.get(self, "verifyTokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomInput")
    def virtual_waiting_room_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom"], jsii.get(self, "virtualWaitingRoomInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkersInput")
    def virtual_waiting_room_with_edge_workers_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers"], jsii.get(self, "virtualWaitingRoomWithEdgeWorkersInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoInput")
    def visitor_prioritization_fifo_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo"], jsii.get(self, "visitorPrioritizationFifoInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandaloneInput")
    def visitor_prioritization_fifo_standalone_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone"], jsii.get(self, "visitorPrioritizationFifoStandaloneInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationInput")
    def visitor_prioritization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization"], jsii.get(self, "visitorPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="watermarkingInput")
    def watermarking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking"], jsii.get(self, "watermarkingInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall"], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="webdavInput")
    def webdav_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav"], jsii.get(self, "webdavInput"))

    @builtins.property
    @jsii.member(jsii_name="webSocketsInput")
    def web_sockets_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets"], jsii.get(self, "webSocketsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67a923f7edab8e1f4a4d4d26e9bb16babf8be403bb57207593510e95d725881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "allow_list": "allowList",
        "locked": "locked",
        "permissions_policy_directive": "permissionsPolicyDirective",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy:
    def __init__(
        self,
        *,
        allow_list: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_list: The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here. They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param permissions_policy_directive: Each directive represents a browser feature. Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744d06dccca44310a4531557687bdf4ea09dfd4a3bc6b4ee24c3066774119cd6)
            check_type(argname="argument allow_list", value=allow_list, expected_type=type_hints["allow_list"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument permissions_policy_directive", value=permissions_policy_directive, expected_type=type_hints["permissions_policy_directive"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_list is not None:
            self._values["allow_list"] = allow_list
        if locked is not None:
            self._values["locked"] = locked
        if permissions_policy_directive is not None:
            self._values["permissions_policy_directive"] = permissions_policy_directive
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_list(self) -> typing.Optional[builtins.str]:
        '''The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here.

        They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        '''
        result = self._values.get("allow_list")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def permissions_policy_directive(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Each directive represents a browser feature.

        Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        '''
        result = self._values.get("permissions_policy_directive")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517eb640e94d12c1490ff10260bbb0592718995a7214752561291fb35750f0be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowList")
    def reset_allow_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowList", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPermissionsPolicyDirective")
    def reset_permissions_policy_directive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPermissionsPolicyDirective", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowListInput")
    def allow_list_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowListInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyDirectiveInput")
    def permissions_policy_directive_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "permissionsPolicyDirectiveInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowList")
    def allow_list(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowList"))

    @allow_list.setter
    def allow_list(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cf8b7778d102d4a68915f6a04217dcc14cb8d80b5b49470da1d4736512eee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowList", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c7a50a80d840b45544244d319f3ad6ab93b01e4e710b1a987c0664c85c6bd4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyDirective")
    def permissions_policy_directive(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "permissionsPolicyDirective"))

    @permissions_policy_directive.setter
    def permissions_policy_directive(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1906afd1531efc2c3c55829aeb2d2f6e1bb56f504c5fefa83bd99236a584caa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "permissionsPolicyDirective", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a35b12ea093201af089f63de8c34e6c59ac9be14d050b439341f1fd24417b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4781fbbe8bd6f92d86cd41181b177c7dfec43d7baee93777391b6997dac9cd9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c65efa5f11f26c8a1f1f57ada98df4c9f56f5001965f2e265f76e6e6b289fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea8f2ba9dc555368b9ac39fc8abd1532d958c3349ad22573faf234316cba795)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the persistent connections behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27825b24f8f05855f8a108f00f88f93eeeb03c2d725e21e8da92adb45d251361)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c5ee88f87a41fdea7ecf7d08040b004d75f1f7eaefae8a347d45e9c55c885c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53ae562b687e0d495eb9ee7c7e80bf99e8010f7e1cef61a38d05983e58c983f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2900e01f78259f26474ec8d7fcabb0e58fad7f85008888fe9f80fbc9f57b9a0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444ce0f37c7d7a1e807ddaad080fda8eff865d39ca1cd38f98ffc7b033f81072)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9fc8c26393265c326b0d2d4b7f03cee6cdb855426c17ce5a290b2b5accb692e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11a9bbc036f331e35ec8efcb8ea861c76e227283f0f326e2f4fab363adb50491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab96dd6a6cce25d08535747ced70ab66d829c698125b4f69410ef6c6b42d88a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables persistent connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes a persistent connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c41297cc8c065930cf244bf13f1610119d11d7b805cff8e415eb15096fb2117)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192c989f8e960b1b0ff48f1dd24d2c8f870ff1aa71ffd59a887a184973d18274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84b06b40cff9c99a212966e4241eb3ee78d23932e2597f7ec6cb6532ccdbb76d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fea587af2f6f4919703ef90718c6464a204f448d596d1ca450a192d09b423a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db28a745112038ddb4a45ce88cbd51b1513b77c6038225fceb6849983fab71ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba78decbfb6094eebeb0b868c0ee7caba76e9f6b58aa973ad5a44f52f7ed7967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfcc21e4c8c46f921f45986d50bad5934516d41060131285121c3e656e04f45d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fea85440ab8279a89194cfae1c29eabd8c96e3cf9f62b706bed193b3f914551)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, marks content as personally identifiable information (PII).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045a2b7e370965414bb2bd931b889dc48f6b838160d04bdf939eb60d9b5d660f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acc274b1f84aa26622cb8c97b56c28f95c9dccef01328b4e07257db22b2be90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00e3c4fd623bfda8e4a2a6f53bfe5009f925a1922df67bd6d657e6500fbb4a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111e1f44acc4d891d07d65eb81c8d2b973e47c659ca1a7c5309c554a91f883c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b94508ee6e21028b5b97e24d2e98c5b478cb5d99af1bfa2683ccbca0f545f96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e2724f5b131562b44b1e35fefadb7788655e514c1ef55b923061a605e096bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "failover_duration": "failoverDuration",
        "failover_enabled": "failoverEnabled",
        "failover_response_code": "failoverResponseCode",
        "failover_title": "failoverTitle",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_expiration_date": "populationExpirationDate",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9627ebc167a096387d9d6c1182a229e35862b4e11f57dcd4924de551e528925d)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_duration", value=failover_duration, expected_type=type_hints["failover_duration"])
            check_type(argname="argument failover_enabled", value=failover_enabled, expected_type=type_hints["failover_enabled"])
            check_type(argname="argument failover_response_code", value=failover_response_code, expected_type=type_hints["failover_response_code"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_expiration_date", value=population_expiration_date, expected_type=type_hints["population_expiration_date"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_duration is not None:
            self._values["failover_duration"] = failover_duration
        if failover_enabled is not None:
            self._values["failover_enabled"] = failover_enabled
        if failover_response_code is not None:
            self._values["failover_response_code"] = failover_response_code
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_expiration_date is not None:
            self._values["population_expiration_date"] = population_expiration_date
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Phased Release Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected.

        Set the value to ``0`` to immediately request the alternate origin upon failure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        '''
        result = self._values.get("failover_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        '''
        result = self._values.get("failover_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_response_code(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the set of failure codes that initiate the failover response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        '''
        result = self._values.get("failover_response_code")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Phased Release policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Select when to assign a cookie to the population of users the Cloudlet defines.

        If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies the date and time when membership expires, and the browser no longer sends the cookie.

        Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        '''
        result = self._values.get("population_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1006fc3da3e3b299903bf27f812d1746b76ee0488c46d20cb1088d4371400615)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d4643015c7f075417a077a0a66a403a46d4eb678b0d9ba16be07778c30ae88f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0975e03b056515516c5360b01b14b674a566bf5a4afbd93262cd1aa42ee9988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a6128017e53e908d70f1558775b067a678b71da8db713f526aed1587e5a1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d61059e1a04966a0e72080c45dcd859f61b305284c558177d11697d66a07515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6089b78665516ab6a2d71c12c69794633e5f26ba4abf7106e9284e7c680a855c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverDuration")
    def reset_failover_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverDuration", []))

    @jsii.member(jsii_name="resetFailoverEnabled")
    def reset_failover_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverEnabled", []))

    @jsii.member(jsii_name="resetFailoverResponseCode")
    def reset_failover_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverResponseCode", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationExpirationDate")
    def reset_population_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationExpirationDate", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverDurationInput")
    def failover_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverEnabledInput")
    def failover_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failoverEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCodeInput")
    def failover_response_code_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDateInput")
    def population_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__196db62b43e15523983d4331efdf66216db1dbdfe328673d641107908e9529a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24bf6b8a751b513f264ba4f4a62acf2ce8e50b468f66ef3f45b1e9a3f9857ce6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverDuration")
    def failover_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverDuration"))

    @failover_duration.setter
    def failover_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e9c5677eadffe1f722f1149d4c5fcd78de7fdfe765a81334d8dc59500e5214e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverDuration", value)

    @builtins.property
    @jsii.member(jsii_name="failoverEnabled")
    def failover_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failoverEnabled"))

    @failover_enabled.setter
    def failover_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105e3c11b76addd0fbcc41a287e705bef45bfa04ddc03afe5246d1056c2d6b5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCode")
    def failover_response_code(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverResponseCode"))

    @failover_response_code.setter
    def failover_response_code(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eaa8139eb0e5b440f378f09e8bf9d8ee7dfa2d2655c9a2debea1cc36788c4f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ff64f232f03cc94abe03fc30b75e85687cc7094591264618fddaae7aaf5b07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20eaf8a6b34cc2b87ea82871375a2985dc0ed494ca8c61c5f6e987c8f3656d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82afca395b72223eae17951343efd1e6beb7a114fd0e3a72e7e5bc7d8cb00fc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61808415dc7454175354d898c470a4f94ddbe21879d0c5baae45cb745caef25c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e70dbb323ced654d92ceb983d0543cd2bea7999d412168c05857028c408508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85cb41ce02e29022f4f12d836f1401919fbb6812dbecb405c5265b717b78b1fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDate")
    def population_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationExpirationDate"))

    @population_expiration_date.setter
    def population_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca2df9a6ab5194d0e1ee7a411068f4a9df85ea104d94042cd09aff262215b1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d895702c4b2c1a740f41e5a6c91313aee68ec830c0e909d622af45385b01a410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__750c5be501890c328aef9c7bf419ab22557d2d9d825668f57d0f1a7db1796e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48810fb698b7d0f89049deb86fc118d164cd2aa2e52690daf19d5dd4c525815d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67af0b72242bfcc67d7c517931a514014cb162ee22686b6a750950b22ae6e434)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fda54207e4cd049a0c3855bb7d5bf72ce480ce2b49f42b3c89ff3e3ab6b495f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "preconnectlist": "preconnectlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4005f37b6353d438b6cf98ad2fc1f799a5bdd7bccedc15a8bd81f18078fe9232)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preconnectlist", value=preconnectlist, expected_type=type_hints["preconnectlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if preconnectlist is not None:
            self._values["preconnectlist"] = preconnectlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preconnectlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of hostnames to which to preconnect over HTTP2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        '''
        result = self._values.get("preconnectlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c616706b1fa2da12f8ec463f4f24df558cc9960f93772f50e4898474916ada19)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreconnectlist")
    def reset_preconnectlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnectlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectlistInput")
    def preconnectlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "preconnectlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b5e9a93382e6d8ced5c700aad214999f8f16b770b5f39b877ef75ca6bc2d6a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preconnectlist")
    def preconnectlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "preconnectlist"))

    @preconnectlist.setter
    def preconnectlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0635e840f36d74f710b7f956e6bd6d5eb3df92437cdb5b00084d0266c928cea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preconnectlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d7037a5cffb333c16f535cd044ef8da53b65fb82d50035998b74fe5494efc4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dced88225579d89f5b38a5dec87837f1cd9264f3d5d09dc834bffbea5d87b20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301ce6d3147971d5ad082036186c227233fef278e4883e69d0d48482fbeef98c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5161fd46c694bd081e9ca17307b10dbce70d212ebe20836f6ba9acd07559eeb)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive content delivery behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDeliveryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDeliveryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ecd3cb83463406cb82cc3357c3ff2ca676192ecfc3f581023fb58f454c26c4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa611e67424124b64c5cc9a4dab3e7c610df34644a23f7048c0314b83c35ffad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d80f9aef203c1d827dfb8c0fa9ee7a3536e0716ad53d68776236072e7a65d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f72cf55dee73a624aa5dac43207e6bf2d3a05cc524a43be6545b8bdf3d5221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d06bd7952300d4d0da79f03c1b1d5a4674757ed8d34bf05774fa8fcce4368b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aec16d2fe6c6fa62dc9ce8bc42ccba697f4a7e98e8d541b6ad690078696bdc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching",
    jsii_struct_bases=[],
    name_mapping={
        "accuracy_target": "accuracyTarget",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching:
    def __init__(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__907b4bfad115df2765d348790b9311ea356d4070d3d338edcf6d4a50c158d096)
            check_type(argname="argument accuracy_target", value=accuracy_target, expected_type=type_hints["accuracy_target"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accuracy_target is not None:
            self._values["accuracy_target"] = accuracy_target
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accuracy_target(self) -> typing.Optional[builtins.str]:
        '''The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        '''
        result = self._values.get("accuracy_target")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive prefetching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetchingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetchingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf91015c0b8bae20c497f36f4c2ec5c2adc5010360713018041696ef8d9e2ea9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccuracyTarget")
    def reset_accuracy_target(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccuracyTarget", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accuracyTargetInput")
    def accuracy_target_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accuracyTargetInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accuracyTarget")
    def accuracy_target(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accuracyTarget"))

    @accuracy_target.setter
    def accuracy_target(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da72ef7d54499cc30cd52e65fa71796d25318a93b7efe6f6ce391b6c4ab50b25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accuracyTarget", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3acafb85854bf8d0fa67f8391ad71e8b77a7fe24e3327e47fd2eb7bb0e2712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31dd6f9b4f6fd9ea200b8fee19a43a9fc0e9fc7dbf6cd9a1482b429ba0f37e3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad3150718903f343a0a16f39372d5b8eb28bf4f0c7fb41aa551805ed3fdbf65e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23edf117534d39fda86440700a393a30d607b6a7052438359e4ebc0728bf2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6a1f73e8c82fa418e78c4173af176118ff7183141769e537772c4a2a02fdbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99b9c94227042250161601a60a1af59733d10712866f6845f2fe0e2ef620fe6d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies prefetching behavior when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__068e1bee56e3af5ac9a90fbe2de50b7fd455eddf708cd5e2ddf32cf07fa77063)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__713e72250a9bf411cad205f66f39316205863873eeaad5932409ed76b2c2a604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a0f4fe9a9513a9ef23b78cacd3f3c7388af0eba570bc8f5eb455f3c241b8989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fe468a0a14a8c19f94117e72aeb04a1c38ec5ab2f53adb76b9b78fcfe1e7d2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__badce0fc3f8abdd892b2eeb61491a9c9bde03b7d8c0c35eac38eab3d3678ba6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f228a0572dad76a27252e356be0adaf8f4350a8d8cdb5c3fcad5779006eb18c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c11a8c97e7197e842e33e8a01eaeaa9f75b3758ba6a30716be7961bbdfb661)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows matching content to prefetch when referenced on a requested parent page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df63c8b7f4b31fed2c96b797c2f0c5751c4692045f89d88d3726e9b4f40d250)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bed51a6097456f859d62e453c1e33dd877328d41a664fa0dc8dd3cd37ef4703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80fc4506973f0b858901a93191a4c867bf5d8d42dad507270e12a11be643a8fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81be27e47014d2706bd7a6de65142bcc26c6428c69a3de9e1b26b8e3d5496c62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f2ad13f4ba07f94239a64de9361e3d19827d2e5581513c8dad7593846b156f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa3d31a7b061f276601224ef38d8b2a13ea9a04cd572d4c23200f416d48f784b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "prefreshval": "prefreshval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de895cd01de496e2ada223e911b001ce31530150c6aeb0c975a96e57c10db2f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefreshval", value=prefreshval, expected_type=type_hints["prefreshval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if prefreshval is not None:
            self._values["prefreshval"] = prefreshval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cache prefreshing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefreshval(self) -> typing.Optional[jsii.Number]:
        '''Specifies when the prefresh occurs as a percentage of the TTL.

        For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        '''
        result = self._values.get("prefreshval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa17e9b933a7d7e8ff8bb24e3a05885753c548fe1d288c23d98e50c1d21143c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefreshval")
    def reset_prefreshval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshvalInput")
    def prefreshval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefreshvalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d222e0a34099d9af82bd44c4fa05b854d27a4c5ce9ee27afbac06b57a5511eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5819b11eac652b4f2e035835a10c913ad594393d63d6d0326c6e970ea85a0ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefreshval")
    def prefreshval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefreshval"))

    @prefreshval.setter
    def prefreshval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bd0d439d53559e4ade74e838d0b98d48f54f340c7f3aa47da4b6751023da93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefreshval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b8622397ccb668935ce3cc2fa9bba6eb052700ac3542814a2045377bbbc58b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c5625620b3e1a9fd42360044405995ddcceebe9052f2fb54757afb5006cc86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c07205600cda07d218ae0992c702790abf8d37fbf5da1e5b37a5f49d3284c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality",
    jsii_struct_bases=[],
    name_mapping={
        "audience_settings": "audienceSettings",
        "catalog_size": "catalogSize",
        "content_settings": "contentSettings",
        "content_type": "contentType",
        "country": "country",
        "delivery_format": "deliveryFormat",
        "delivery_type": "deliveryType",
        "download_type": "downloadType",
        "end_user_location": "endUserLocation",
        "locked": "locked",
        "maximum_concurrent_users": "maximumConcurrentUsers",
        "object_size": "objectSize",
        "optimize_for": "optimizeFor",
        "origin_settings": "originSettings",
        "popularity_distribution": "popularityDistribution",
        "refresh_rate": "refreshRate",
        "segment_duration": "segmentDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality:
    def __init__(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8977b6069046858d2db834d927402398cc6a5747af7bece60f4f263642c3628)
            check_type(argname="argument audience_settings", value=audience_settings, expected_type=type_hints["audience_settings"])
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_settings", value=content_settings, expected_type=type_hints["content_settings"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument delivery_format", value=delivery_format, expected_type=type_hints["delivery_format"])
            check_type(argname="argument delivery_type", value=delivery_type, expected_type=type_hints["delivery_type"])
            check_type(argname="argument download_type", value=download_type, expected_type=type_hints["download_type"])
            check_type(argname="argument end_user_location", value=end_user_location, expected_type=type_hints["end_user_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_concurrent_users", value=maximum_concurrent_users, expected_type=type_hints["maximum_concurrent_users"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_for", value=optimize_for, expected_type=type_hints["optimize_for"])
            check_type(argname="argument origin_settings", value=origin_settings, expected_type=type_hints["origin_settings"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument refresh_rate", value=refresh_rate, expected_type=type_hints["refresh_rate"])
            check_type(argname="argument segment_duration", value=segment_duration, expected_type=type_hints["segment_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if audience_settings is not None:
            self._values["audience_settings"] = audience_settings
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_settings is not None:
            self._values["content_settings"] = content_settings
        if content_type is not None:
            self._values["content_type"] = content_type
        if country is not None:
            self._values["country"] = country
        if delivery_format is not None:
            self._values["delivery_format"] = delivery_format
        if delivery_type is not None:
            self._values["delivery_type"] = delivery_type
        if download_type is not None:
            self._values["download_type"] = download_type
        if end_user_location is not None:
            self._values["end_user_location"] = end_user_location
        if locked is not None:
            self._values["locked"] = locked
        if maximum_concurrent_users is not None:
            self._values["maximum_concurrent_users"] = maximum_concurrent_users
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_for is not None:
            self._values["optimize_for"] = optimize_for
        if origin_settings is not None:
            self._values["origin_settings"] = origin_settings
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if refresh_rate is not None:
            self._values["refresh_rate"] = refresh_rate
        if segment_duration is not None:
            self._values["segment_duration"] = segment_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def audience_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        '''
        result = self._values.get("audience_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.'''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        '''
        result = self._values.get("content_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.'''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.'''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.'''
        result = self._values.get("delivery_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.'''
        result = self._values.get("delivery_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def download_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.'''
        result = self._values.get("download_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_user_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.'''
        result = self._values.get("end_user_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_concurrent_users(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.'''
        result = self._values.get("maximum_concurrent_users")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.'''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_for(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.'''
        result = self._values.get("optimize_for")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        '''
        result = self._values.get("origin_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.'''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def refresh_rate(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.'''
        result = self._values.get("refresh_rate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.'''
        result = self._values.get("segment_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQualityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQualityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47b0fd282a30895470cfb7f62f94eb81029d2dddfeeb93f51a88811b5696c3df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAudienceSettings")
    def reset_audience_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSettings", []))

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentSettings")
    def reset_content_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentSettings", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetDeliveryFormat")
    def reset_delivery_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryFormat", []))

    @jsii.member(jsii_name="resetDeliveryType")
    def reset_delivery_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryType", []))

    @jsii.member(jsii_name="resetDownloadType")
    def reset_download_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadType", []))

    @jsii.member(jsii_name="resetEndUserLocation")
    def reset_end_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndUserLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumConcurrentUsers")
    def reset_maximum_concurrent_users(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumConcurrentUsers", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeFor")
    def reset_optimize_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeFor", []))

    @jsii.member(jsii_name="resetOriginSettings")
    def reset_origin_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSettings", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetRefreshRate")
    def reset_refresh_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshRate", []))

    @jsii.member(jsii_name="resetSegmentDuration")
    def reset_segment_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="audienceSettingsInput")
    def audience_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "audienceSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentSettingsInput")
    def content_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryFormatInput")
    def delivery_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryTypeInput")
    def delivery_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadTypeInput")
    def download_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="endUserLocationInput")
    def end_user_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endUserLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsersInput")
    def maximum_concurrent_users_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumConcurrentUsersInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeForInput")
    def optimize_for_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optimizeForInput"))

    @builtins.property
    @jsii.member(jsii_name="originSettingsInput")
    def origin_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshRateInput")
    def refresh_rate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshRateInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationInput")
    def segment_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSettings")
    def audience_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "audienceSettings"))

    @audience_settings.setter
    def audience_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6471b74687f0469e0f5e53d963588a5e4cf7098d20ca2b7e73ce3e1dbc48bfaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "audienceSettings", value)

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d129ceaab0449bf8f2994be86d601dc348450c0a3ab6a278bd26b386fbe220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentSettings")
    def content_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentSettings"))

    @content_settings.setter
    def content_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93616e4c3821772a88a58863dabb1bf372a5860e90bf87f649fc0c2169afd19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentSettings", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f967d3cce8166534f8e3c0b1774df1b3c3a14925384d878c7ab1b0dccc6b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf13d267298f81ac85d5ce1d410322531b6b9dc878e6b10d0431f1e877e0bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryFormat")
    def delivery_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryFormat"))

    @delivery_format.setter
    def delivery_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1093a41e1db3f27863ab13dc36414ff2857af5ddf3a0edfdeac0a75390964671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryFormat", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryType")
    def delivery_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryType"))

    @delivery_type.setter
    def delivery_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e78fe7b494dae65024b2322a3f0ae51a1747c8b69f28d5f5a0884537a7dbebff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryType", value)

    @builtins.property
    @jsii.member(jsii_name="downloadType")
    def download_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadType"))

    @download_type.setter
    def download_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceaec63b8d4a447e04928a8b2f144b40332f4aa19187da46e57836a2f140bc17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadType", value)

    @builtins.property
    @jsii.member(jsii_name="endUserLocation")
    def end_user_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endUserLocation"))

    @end_user_location.setter
    def end_user_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__205d6657c73532c268a82162ac00e1142584797e3a7ee4422a6b9fe48b84271c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endUserLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3c11fca811b0582a71985952f0306ecb370f4efb32cc0eae0a1058ffbb0c1be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsers")
    def maximum_concurrent_users(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumConcurrentUsers"))

    @maximum_concurrent_users.setter
    def maximum_concurrent_users(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65c8212df39d775543172d66443f218b5e4daa3ca86455d02d5a1c751f37220b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumConcurrentUsers", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff835db4ded7c3a4613ba7e533a1e99fa2c5db695af33b9f5655100694c87ab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeFor")
    def optimize_for(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optimizeFor"))

    @optimize_for.setter
    def optimize_for(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee5ffd603248513ebb72497fe3b6ea068d7146cb1c0e6a148b40e9d247767d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeFor", value)

    @builtins.property
    @jsii.member(jsii_name="originSettings")
    def origin_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originSettings"))

    @origin_settings.setter
    def origin_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90859b522bf6200883d017d768cfeb0254a3112c6ce1eca011f29ba5ad71ea3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSettings", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e56a35f6b2925b3eb2c6ae2cc68e9d8e292b21fa58fcfc61c129738236784e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="refreshRate")
    def refresh_rate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshRate"))

    @refresh_rate.setter
    def refresh_rate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d492df178d2a68e1898fb766b826182ae0a4fd50d54a03be4f5bc35c42620600)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshRate", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDuration")
    def segment_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDuration"))

    @segment_duration.setter
    def segment_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da461a2d981419f5a7fe39bcfbafe74726dc7f66bbffd43a7fa3ac6520401403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb64556ced7af466c5ece1a87e343a4acdeee8c6c182d2954bb714292c1c606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9020db7eb6714b3b44912d1fca733bfe778a07b68a32a70f36c41b07b0b0b2e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a179136494c6e7ddbcef1271b2a53cc477d184b14b5d082bb206b23987364b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "quic_offer_percentage": "quicOfferPercentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc7023bd29dacd4a32c2aaf2d043097b1606d8a01082d5a9fe698b6d3bf2b96c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument quic_offer_percentage", value=quic_offer_percentage, expected_type=type_hints["quic_offer_percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if quic_offer_percentage is not None:
            self._values["quic_offer_percentage"] = quic_offer_percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables QUIC support.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def quic_offer_percentage(self) -> typing.Optional[jsii.Number]:
        '''The percentage of responses for which to allow QUIC sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        '''
        result = self._values.get("quic_offer_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBetaOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBetaOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d9f8953b8d4a1c4f596d92c944fdb926cc2af61f2a6c1b51b5b4e9aa52e423)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQuicOfferPercentage")
    def reset_quic_offer_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicOfferPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentageInput")
    def quic_offer_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "quicOfferPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34232b2c13f9d39183541333aa1ce5da0c126a71486632561f823ef0a0e75eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95a231a582600950c41e9442ebf4b9d8b183f3a0719d03c9281f9d2279c7ec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentage")
    def quic_offer_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "quicOfferPercentage"))

    @quic_offer_percentage.setter
    def quic_offer_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90271e274a7c4ac7aa26f9c888c114e754663dcbcab73053fa34569d77896ea6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "quicOfferPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0147a0e09079f3b23720ed6eb8e49630683c6908413f089f275d19b85f1f84dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7a5ef944fc585fb04932a6c524cdf0cebe5396cc31e416ebf1f71949ab745a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__915858668c207f656c65f172dd923132f6f5b4b909ef157287b186d466e7fc58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek",
    jsii_struct_bases=[],
    name_mapping={
        "flv": "flv",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "mp4": "mp4",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek:
    def __init__(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a47a0e60b06895c00a88f8f3aa39bfc989641cc30c27caccfe3c09a4c2786dcd)
            check_type(argname="argument flv", value=flv, expected_type=type_hints["flv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument mp4", value=mp4, expected_type=type_hints["mp4"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if flv is not None:
            self._values["flv"] = flv
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if mp4 is not None:
            self._values["mp4"] = mp4
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def flv(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in FLV files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        '''
        result = self._values.get("flv")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mp4(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in MP4 files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        '''
        result = self._values.get("mp4")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeekOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeekOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5c7ea9e9233d7b1254e8e0e3591d9dc19751461c58d95f7d1d3ea7d86fbf232)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFlv")
    def reset_flv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFlv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMp4")
    def reset_mp4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMp4", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="flvInput")
    def flv_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "flvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="mp4Input")
    def mp4_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mp4Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="flv")
    def flv(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "flv"))

    @flv.setter
    def flv(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01af38ef762a63d954013ee1992d18dc7010bf36c4f0d1a02baa6d43aacd3d5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "flv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257363931b83f64b3a0c9befceb3416b2dedea6f7d88627dcf1f78297ca9a787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__657046f51bd0f5cf2e44cab0cb4f189579e95b64312dc8559dc41003b906aabf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="mp4")
    def mp4(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mp4"))

    @mp4.setter
    def mp4(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251c6f8807611270e6bd0f2526f782170010ef22d2bbaab7694edd976894ed5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mp4", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86f1daa02a5fb710d927c7e5cada8cd645352cae3b15b039db82441111a5d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce1849b3ba7fd8947caabe41f46ac58f897aece3efc9b89b4399a6920a037764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4deb3c44abf048ceb642f73ee4ea2fa8510b383e5daa8442db90f64dd582dd0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c65914b2ecce91d9f0af5ced0bb32f4032ca04fa7a7d6a7a1c479ab1edc880ec)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables API Gateway for the current set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapidOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapidOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f2fa7960b41e7bb8677616892bc728f7ec15746113f695fe2e475bdd26912c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c0ff835ec82314e03b2a4df490af3d4205c05ef5dea018218ab5009b7fe208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ed1f368242551633209d93e84fe76d72bf1c0281631c58077b6bd3505a37db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a034ddd80a740f123a2881af0c9ac47aad61f5ed66a38da06850217f18b208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab60d7969ffc8b9584f2aaf17961f72738b374aff56ea54551719831fd6835db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b726fbe3ba80b08e6f606664b42f13768b04a8c76163170183150df91ad1f05d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5002c0947b53b131f2ad0bd12a17156bc3ee1fe429eb813de77d14016f7256fa)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f82dc9a45e26399b3f2fc81a8154172a75555ffa2981711961270c44e7db8d43)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9254d89ab84d14391183d31a7bc2c78b0a8aae3caaacb237f1d2c9297b2b173b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4882c52f19e3fdd4aee9bd3db37e280c823395afa5b20bbe150287b1beae2a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96655f3cab4bbf61397bb6975b28f9c06dd14ee62a97ff469cc857939c44cd5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292633c9cbbc21de8046938f2f2d5dd40c58db52abe57d884ced52bba0178b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82cf2c77b77bb2285e1386ae942c63d9a67e29dd71cf0f0be4d2bd61f44f0499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "beacon_sampling_percentage": "beaconSamplingPercentage",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5629ba6efda115d099c2e8d032254cf98c6419af5e1a853c4848326ecdc75e46)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument beacon_sampling_percentage", value=beacon_sampling_percentage, expected_type=type_hints["beacon_sampling_percentage"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if beacon_sampling_percentage is not None:
            self._values["beacon_sampling_percentage"] = beacon_sampling_percentage
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables advanced options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def beacon_sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage for sampling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        '''
        result = self._values.get("beacon_sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables reports on delivery of cloud hosted content at near real-time latencies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51eba33871094627ba7d9edd3e6a317cfd1a50f4230564b10166dc91b9fc7a1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetBeaconSamplingPercentage")
    def reset_beacon_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconSamplingPercentage", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentageInput")
    def beacon_sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "beaconSamplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__466e3eaf93563ef3ce2738e467fde3a7e389c147f9243fcdf9f073895f570cb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentage")
    def beacon_sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "beaconSamplingPercentage"))

    @beacon_sampling_percentage.setter
    def beacon_sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcbe74589e9bb6d7e774733cc3657ff332e1d775615b698c364d1a012440e04f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconSamplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc491ebf3402505b954e0602f2d61ed613db878071076c27b22c1dc75e250377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb9cef91b6edf7c7c4d5f350b22214b88e10fe49c2f7db685f2a5348c41caf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9510588a8f9fe8c388c7f948a6827e80ce447f8e063aeb2834fa17e170a5c37d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3315cd661b33c4b51a46a7ef08010d30b859d0ec062dd12530e309331fa29b1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfbb2e3f012449672c9f67a509043d8dd50015f1dadee3cb17fc85ff0514b6ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe6d30a936a552c9d4877894e7d068eb94e787ffd481edd0e6f9526d0ca22b0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates real-use monitoring.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoringOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoringOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993dd3f8ee138ebdc16fd80c990d2819c099b5f92f1272959149d09a39df28c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3293aa065877f01b4096fd8459f4ccc516edd8b85acd5e8b411ed5471d9b274)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f3499cf72863e20bdc717dacd1eb7a804a10662a7997981fbdb62d22ed54ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52427fb2c9d8c2c8ecd99c3885180df436c543fe18db0202717cddc9665babf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf21e3c22e3ea4928d2d7f4c58312c83a1ac937e2b08b98588fb36dd979ab51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea3596610f984f1b312237d631a4141a5d7d5dab6380c954080e72a7e2e181f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "destination_hostname": "destinationHostname",
        "destination_hostname_other": "destinationHostnameOther",
        "destination_hostname_sibling": "destinationHostnameSibling",
        "destination_hostname_subdomain": "destinationHostnameSubdomain",
        "destination_path": "destinationPath",
        "destination_path_other": "destinationPathOther",
        "destination_path_prefix": "destinationPathPrefix",
        "destination_path_suffix": "destinationPathSuffix",
        "destination_path_suffix_status": "destinationPathSuffixStatus",
        "destination_protocol": "destinationProtocol",
        "locked": "locked",
        "mobile_default_choice": "mobileDefaultChoice",
        "query_string": "queryString",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect:
    def __init__(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544ffd584082e78e13402152705258190b975942692801fe28370269d9591f6f)
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_hostname_other", value=destination_hostname_other, expected_type=type_hints["destination_hostname_other"])
            check_type(argname="argument destination_hostname_sibling", value=destination_hostname_sibling, expected_type=type_hints["destination_hostname_sibling"])
            check_type(argname="argument destination_hostname_subdomain", value=destination_hostname_subdomain, expected_type=type_hints["destination_hostname_subdomain"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument destination_path_other", value=destination_path_other, expected_type=type_hints["destination_path_other"])
            check_type(argname="argument destination_path_prefix", value=destination_path_prefix, expected_type=type_hints["destination_path_prefix"])
            check_type(argname="argument destination_path_suffix", value=destination_path_suffix, expected_type=type_hints["destination_path_suffix"])
            check_type(argname="argument destination_path_suffix_status", value=destination_path_suffix_status, expected_type=type_hints["destination_path_suffix_status"])
            check_type(argname="argument destination_protocol", value=destination_protocol, expected_type=type_hints["destination_protocol"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mobile_default_choice", value=mobile_default_choice, expected_type=type_hints["mobile_default_choice"])
            check_type(argname="argument query_string", value=query_string, expected_type=type_hints["query_string"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_hostname_other is not None:
            self._values["destination_hostname_other"] = destination_hostname_other
        if destination_hostname_sibling is not None:
            self._values["destination_hostname_sibling"] = destination_hostname_sibling
        if destination_hostname_subdomain is not None:
            self._values["destination_hostname_subdomain"] = destination_hostname_subdomain
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if destination_path_other is not None:
            self._values["destination_path_other"] = destination_path_other
        if destination_path_prefix is not None:
            self._values["destination_path_prefix"] = destination_path_prefix
        if destination_path_suffix is not None:
            self._values["destination_path_suffix"] = destination_path_suffix
        if destination_path_suffix_status is not None:
            self._values["destination_path_suffix_status"] = destination_path_suffix_status
        if destination_protocol is not None:
            self._values["destination_protocol"] = destination_protocol
        if locked is not None:
            self._values["locked"] = locked
        if mobile_default_choice is not None:
            self._values["mobile_default_choice"] = mobile_default_choice
        if query_string is not None:
            self._values["query_string"] = query_string
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested hostname, independently from the pathname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_other(self) -> typing.Optional[builtins.str]:
        '''Specifies the full hostname with which to replace the current hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        '''
        result = self._values.get("destination_hostname_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_sibling(self) -> typing.Optional[builtins.str]:
        '''Specifies the subdomain with which to replace to the current hostname's leftmost subdomain.

        For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        '''
        result = self._values.get("destination_hostname_sibling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_subdomain(self) -> typing.Optional[builtins.str]:
        '''Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        '''
        result = self._values.get("destination_hostname_subdomain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested pathname, independently from the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_other(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        '''
        result = self._values.get("destination_path_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_prefix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path.

        For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        '''
        result = self._values.get("destination_path_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        '''
        result = self._values.get("destination_path_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix_status(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        '''
        result = self._values.get("destination_path_suffix_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_protocol(self) -> typing.Optional[builtins.str]:
        '''Choose the protocol for the redirect URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        '''
        result = self._values.get("destination_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mobile_default_choice(self) -> typing.Optional[builtins.str]:
        '''Either specify a default response for mobile browsers, or customize your own.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        '''
        result = self._values.get("mobile_default_choice")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_string(self) -> typing.Optional[builtins.str]:
        '''When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL.

        Otherwise set this to ``IGNORE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        '''
        result = self._values.get("query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Specify the redirect's response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a57e5483c867668b845127c3b7b2d5509e8412c1bc2b468a8b421dfe12a64fe7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationHostnameOther")
    def reset_destination_hostname_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameOther", []))

    @jsii.member(jsii_name="resetDestinationHostnameSibling")
    def reset_destination_hostname_sibling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSibling", []))

    @jsii.member(jsii_name="resetDestinationHostnameSubdomain")
    def reset_destination_hostname_subdomain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSubdomain", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetDestinationPathOther")
    def reset_destination_path_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathOther", []))

    @jsii.member(jsii_name="resetDestinationPathPrefix")
    def reset_destination_path_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathPrefix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffix")
    def reset_destination_path_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffixStatus")
    def reset_destination_path_suffix_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffixStatus", []))

    @jsii.member(jsii_name="resetDestinationProtocol")
    def reset_destination_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationProtocol", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMobileDefaultChoice")
    def reset_mobile_default_choice(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileDefaultChoice", []))

    @jsii.member(jsii_name="resetQueryString")
    def reset_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryString", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOtherInput")
    def destination_hostname_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSiblingInput")
    def destination_hostname_sibling_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSiblingInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomainInput")
    def destination_hostname_subdomain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSubdomainInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathOtherInput")
    def destination_path_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefixInput")
    def destination_path_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixInput")
    def destination_path_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatusInput")
    def destination_path_suffix_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationProtocolInput")
    def destination_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoiceInput")
    def mobile_default_choice_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mobileDefaultChoiceInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringInput")
    def query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__494dc97d706fe055b2ff58a849e290edde8ff1e51993d5e4bed5379a9af073ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOther")
    def destination_hostname_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameOther"))

    @destination_hostname_other.setter
    def destination_hostname_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8831955a458370430aef91402dc9e8cab451c4079dca44ed4d6f8efa8f5ff572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSibling")
    def destination_hostname_sibling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSibling"))

    @destination_hostname_sibling.setter
    def destination_hostname_sibling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6bb7de1bde40634307c723c91c03af007a21def16f8a76282dec46cba25e2d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSibling", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomain")
    def destination_hostname_subdomain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSubdomain"))

    @destination_hostname_subdomain.setter
    def destination_hostname_subdomain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069875f75101ad60b4dafd2d9f2e60882b94e11c28bd914b607213274789ee4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSubdomain", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4522689c854f839ea6ff954ac106a9bbc358ddce42fbce81688f822b67a66c1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathOther")
    def destination_path_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathOther"))

    @destination_path_other.setter
    def destination_path_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83da2d647f0c0ae62cb7f951888fa76fcb8023aec8d4c9b748d575d2b23c67e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefix")
    def destination_path_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathPrefix"))

    @destination_path_prefix.setter
    def destination_path_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c021726def3f33f328e566e65d7ef3b0c54db0fa88b3fbdb88971b499db04f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffix")
    def destination_path_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffix"))

    @destination_path_suffix.setter
    def destination_path_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2b167aeb5b8f39809d2182c569b68b392fa7ff2c302d1d5e75371395f1f04ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatus")
    def destination_path_suffix_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffixStatus"))

    @destination_path_suffix_status.setter
    def destination_path_suffix_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f12c3274927cbd7019512d77717864f9a3f5d979f20c7e26bf40f7e51ca3b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffixStatus", value)

    @builtins.property
    @jsii.member(jsii_name="destinationProtocol")
    def destination_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationProtocol"))

    @destination_protocol.setter
    def destination_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f60f9e4dd6480e9a136082701e2651e438639c3e3c15f1ab3854505adf13c10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__690f535854929e8eb2c7e9387cfb30e175de2e663864e9b68abd829871ce98c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoice")
    def mobile_default_choice(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mobileDefaultChoice"))

    @mobile_default_choice.setter
    def mobile_default_choice(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc7938f1c71c2c943604f98f762097a83c5c72b173b4ce0012d9b2eb9b60c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mobileDefaultChoice", value)

    @builtins.property
    @jsii.member(jsii_name="queryString")
    def query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryString"))

    @query_string.setter
    def query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d4f785ab7624a5b3515fca75199761e786cbd634911ad3a65ca6d03c2bd22e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryString", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4391906ed4326561b80f6177946cb847aa67ea54447b6a6a7b0994bf189697ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c13ab55eb62398ae0422da292f974260dde367880ac4b2e6eb32137e20f2dd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86d39913acdc0fc12c6dc573ed743304b165bfe89eee361b862ce2e9abd2bc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d263348f66e99eb442644177b493e34da885ffb6ff2a12292b8d849323a1315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus",
    jsii_struct_bases=[],
    name_mapping={
        "destination": "destination",
        "enabled": "enabled",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus:
    def __init__(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fdb094dcf3f595e13fe04fdb82909985352464eac54afa61a23d3d8daea3239)
            check_type(argname="argument destination", value=destination, expected_type=type_hints["destination"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination is not None:
            self._values["destination"] = destination
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL.

        Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        '''
        result = self._values.get("destination")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the redirect feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns the status code for the redirect response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__665f64eba5a1c0d8357f5f30dc872c221f5f1897695a88be3801c1c6af58eeb3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestination")
    def reset_destination(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestination", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationInput")
    def destination_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destination")
    def destination(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destination"))

    @destination.setter
    def destination(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95af89233ac1153d9a24a2b88801ef718fdf06b0414089fe571b3bdf929beae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destination", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c81e5ccf752fea9e8391d675a1fe647f7dda7c47c74bf6421fc0e292808b684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45c02585f210131b8d068d7a34e4586ccecd2907eee2e600efe6da4483fa23dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bdc273051dad445bf596a41042797138345323a666393905382159790667e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694c5d397fb63203129ae47dc14c2d3a52ec325bf51f3624c49b6c02abde9de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cdb3f2ab2e3b04e71c813660ccf08f7de7f3c403b0efa08c1569b09bc77cafe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723c9a73bcdd86fc70e47c2a5a2e85ce7a17b1cca8b697c01fd202d0bd39d166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking",
    jsii_struct_bases=[],
    name_mapping={
        "allow_children": "allowChildren",
        "domains": "domains",
        "enabled": "enabled",
        "locked": "locked",
        "strict": "strict",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking:
    def __init__(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25d1517418606cf40e985932bc2b3a9535aa588532c0f4d53362232ad40ca8d)
            check_type(argname="argument allow_children", value=allow_children, expected_type=type_hints["allow_children"])
            check_type(argname="argument domains", value=domains, expected_type=type_hints["domains"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict", value=strict, expected_type=type_hints["strict"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_children is not None:
            self._values["allow_children"] = allow_children
        if domains is not None:
            self._values["domains"] = domains
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if strict is not None:
            self._values["strict"] = strict
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_children(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        '''
        result = self._values.get("allow_children")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of allowed domains.

        With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        '''
        result = self._values.get("domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the referer-checking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``.

        When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        '''
        result = self._values.get("strict")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererCheckingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererCheckingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234e9ba1c1e030f759521d8fb1ccfd2d74a027e518a6b7742a67c24e2d37fb4e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowChildren")
    def reset_allow_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowChildren", []))

    @jsii.member(jsii_name="resetDomains")
    def reset_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomains", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrict")
    def reset_strict(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrict", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowChildrenInput")
    def allow_children_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowChildrenInput"))

    @builtins.property
    @jsii.member(jsii_name="domainsInput")
    def domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "domainsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictInput")
    def strict_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowChildren")
    def allow_children(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowChildren"))

    @allow_children.setter
    def allow_children(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f739713f69b41399407d25cf582e14d4d83db9cd012a783a50917e3fcd1a0cbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowChildren", value)

    @builtins.property
    @jsii.member(jsii_name="domains")
    def domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "domains"))

    @domains.setter
    def domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23893311a5d14f21ded2369f2d1317a86fe84731bad5bb8a242bb543ae3a1d30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domains", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e63de4f63b3c1707991608450340247a92ed76423693fb9b6d5d14be4290c3d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a182a70b22e9d6b1535da1a5853c98ad1f5ba85afdb796bc7920c8d9c4fc3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strict")
    def strict(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strict"))

    @strict.setter
    def strict(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7ff1d5c4e499a54636d3d523d6596902b67f05dc418fa507fadc9e5f9e1962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strict", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19d8800119d45b2d394b350c7a95f182c87958d41436422cbffb439028ebee36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ecaeb5eac79ca94a791defbfd0048c20a23d4ddb35c23a1627864778a25bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d392e9b564b85dd4b25207fccb3a2b000da9695e27d8b216d84d657f02ecdb44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__331f746c8eb0c3c719f3f7e71ec66046a0864563ed878add567af2e2dc02f9d2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies parameters to remove from the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b5b2f054eb040678c26cb9eef7073efcf3e1118919a1db6dbcea0fe01074cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c7f8674b1ba33c827b6106b584cbf68d1815b046a111ae774abc581446a6b81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd1f6a0d305a207050df8e8cd8bad73ab8fab04458b1190e4d0f2cf20e673e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c810a293439021859f6f21bd094738c961968865dbee861852ebb2ffa42bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f6e372f5bf94751a4b7ee3699221de2019d8495bd62f6ef32b50aef2136da38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf9da9655890a35355a48db9c48072a99223e76108e72b0a282b541c85e40f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8269e063303530262356c0713c9c909527cec66c10e905dee1fc0a4f7deda7ab)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, removes the ``Vary`` header to ensure objects can be cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVaryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVaryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__737a7494e3b2312012f38514773bffee40008801e2fe97d7019e1aace7f1639f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a2a60d0452b7f1c53520e2730773553035b874dc70bc1ca3df157b3dd4abe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb20da395fb854de62a208c4d57ba80dbcc641d5e959e94458a2a18f7b1cb833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e7e8270995049d366851a1f33b1ae063e2d093d3366f43142eca283f58e5ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__373ca0f3d2276728c09e61e35fc9d28c9c50bacbc632328cda376c0311635a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a2bfb6de9cd2d744454948bd081931f1a557a60b9950f5e3d0e69da908f216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport",
    jsii_struct_bases=[],
    name_mapping={
        "cookies": "cookies",
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_accept_language": "logAcceptLanguage",
        "log_cookies": "logCookies",
        "log_custom_log_field": "logCustomLogField",
        "log_edge_ip": "logEdgeIp",
        "log_host": "logHost",
        "log_referer": "logReferer",
        "log_user_agent": "logUserAgent",
        "log_x_forwarded_for": "logXForwardedFor",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport:
    def __init__(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b66ce6d619e916682d8b88f3f6f1f5e5109a783c38521feb9f6931bc4583bb)
            check_type(argname="argument cookies", value=cookies, expected_type=type_hints["cookies"])
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_accept_language", value=log_accept_language, expected_type=type_hints["log_accept_language"])
            check_type(argname="argument log_cookies", value=log_cookies, expected_type=type_hints["log_cookies"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument log_edge_ip", value=log_edge_ip, expected_type=type_hints["log_edge_ip"])
            check_type(argname="argument log_host", value=log_host, expected_type=type_hints["log_host"])
            check_type(argname="argument log_referer", value=log_referer, expected_type=type_hints["log_referer"])
            check_type(argname="argument log_user_agent", value=log_user_agent, expected_type=type_hints["log_user_agent"])
            check_type(argname="argument log_x_forwarded_for", value=log_x_forwarded_for, expected_type=type_hints["log_x_forwarded_for"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookies is not None:
            self._values["cookies"] = cookies
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_accept_language is not None:
            self._values["log_accept_language"] = log_accept_language
        if log_cookies is not None:
            self._values["log_cookies"] = log_cookies
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if log_edge_ip is not None:
            self._values["log_edge_ip"] = log_edge_ip
        if log_host is not None:
            self._values["log_host"] = log_host
        if log_referer is not None:
            self._values["log_referer"] = log_referer
        if log_user_agent is not None:
            self._values["log_user_agent"] = log_user_agent
        if log_x_forwarded_for is not None:
            self._values["log_x_forwarded_for"] = log_x_forwarded_for
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookies(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the set of cookies names whose values you want to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        '''
        result = self._values.get("cookies")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_accept_language(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Accept-Language`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        '''
        result = self._values.get("log_accept_language")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_cookies(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of cookies to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        '''
        result = self._values.get("log_cookies")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_edge_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to log the IP address of the Akamai edge server that served the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        '''
        result = self._values.get("log_edge_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_host(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Host`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        '''
        result = self._values.get("log_host")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_referer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Referer`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        '''
        result = self._values.get("log_referer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_user_agent(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        '''
        result = self._values.get("log_user_agent")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log any ``X-Forwarded-For`` request header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        '''
        result = self._values.get("log_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa79b3feed4253c9dc48138fb96d63de6e4e563ce584d240dbe1f30ba76d930f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookies")
    def reset_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookies", []))

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogAcceptLanguage")
    def reset_log_accept_language(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogAcceptLanguage", []))

    @jsii.member(jsii_name="resetLogCookies")
    def reset_log_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCookies", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetLogEdgeIp")
    def reset_log_edge_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEdgeIp", []))

    @jsii.member(jsii_name="resetLogHost")
    def reset_log_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogHost", []))

    @jsii.member(jsii_name="resetLogReferer")
    def reset_log_referer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogReferer", []))

    @jsii.member(jsii_name="resetLogUserAgent")
    def reset_log_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogUserAgent", []))

    @jsii.member(jsii_name="resetLogXForwardedFor")
    def reset_log_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogXForwardedFor", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookiesInput")
    def cookies_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguageInput")
    def log_accept_language_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logAcceptLanguageInput"))

    @builtins.property
    @jsii.member(jsii_name="logCookiesInput")
    def log_cookies_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logCookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="logEdgeIpInput")
    def log_edge_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEdgeIpInput"))

    @builtins.property
    @jsii.member(jsii_name="logHostInput")
    def log_host_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logHostInput"))

    @builtins.property
    @jsii.member(jsii_name="logRefererInput")
    def log_referer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logRefererInput"))

    @builtins.property
    @jsii.member(jsii_name="logUserAgentInput")
    def log_user_agent_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logUserAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="logXForwardedForInput")
    def log_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookies")
    def cookies(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cookies"))

    @cookies.setter
    def cookies(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73270d30fc29f690791bd8a9fae5819dc3a94b6bf8d211329429843a6b32f53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookies", value)

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7ebc4026a14ab76feb909acab8575561015eba959756a925f7d5509f523f707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bedf2c96f18c7f31012957ee548f36922e1c3888937e4a446e3fbd2a81be1e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguage")
    def log_accept_language(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logAcceptLanguage"))

    @log_accept_language.setter
    def log_accept_language(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__724dd634e8dde43fb31aa762cf96715c1e0e6f808b8bf5c6b97e66b09a5acfae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logAcceptLanguage", value)

    @builtins.property
    @jsii.member(jsii_name="logCookies")
    def log_cookies(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logCookies"))

    @log_cookies.setter
    def log_cookies(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5312bb3098f3e468d9e59d8c237a114b7bea90d6091b8b42bbd2f158b10eff64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCookies", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa7d7dc9e94ee63779f65d835c6485e7714860945bde1ef65eabe24a0f8732a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="logEdgeIp")
    def log_edge_ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEdgeIp"))

    @log_edge_ip.setter
    def log_edge_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98bb6ece7027509de09c38f818e41b9a8e3b8584d3ab1feb13fb053be43015d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEdgeIp", value)

    @builtins.property
    @jsii.member(jsii_name="logHost")
    def log_host(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logHost"))

    @log_host.setter
    def log_host(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa36c41f1a0f3bc4e3b34dc159eb150d66e5d3a6ba77e825d0a706916724d0ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logHost", value)

    @builtins.property
    @jsii.member(jsii_name="logReferer")
    def log_referer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logReferer"))

    @log_referer.setter
    def log_referer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6dccb971ee8f0037f16fb695bc40f40bcce99ce6246905bc73b7060ba95854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logReferer", value)

    @builtins.property
    @jsii.member(jsii_name="logUserAgent")
    def log_user_agent(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logUserAgent"))

    @log_user_agent.setter
    def log_user_agent(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71b2c17ca2d9721d4d1730d9cf6eb76bdc7aac9941c7614d112690f5585621b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logUserAgent", value)

    @builtins.property
    @jsii.member(jsii_name="logXForwardedFor")
    def log_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logXForwardedFor"))

    @log_x_forwarded_for.setter
    def log_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24190eb92d7da5c494ea9d4a5964e42551f894b317a12e9a920bb2acd681182)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bee8cda3df10a6819ba8922962793158fc916411a800a211270ebe04345a298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a3e21251ed6dcda58ffb2cd7bf5a27e723b2492388680d2b2c94db5fa9a7068)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2b60b5f5015e3670915723f6b38973f58c1330c5c296b9d5cbb54591e8d47cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints",
    jsii_struct_bases=[],
    name_mapping={
        "accept_ch": "acceptCh",
        "accept_critical_ch": "acceptCriticalCh",
        "locked": "locked",
        "reset": "reset",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints:
    def __init__(
        self,
        *,
        accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accept_ch: The client hint data objects you want to receive from the browser. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        :param accept_critical_ch: The critical client hint data objects you want to receive from the browser. The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reset: This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser. This empty header doesn't get merged with other objects sent from your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac0bc1f4e51ee7f908a9fede27f2644719a92e63f63788532865496cca51a388)
            check_type(argname="argument accept_ch", value=accept_ch, expected_type=type_hints["accept_ch"])
            check_type(argname="argument accept_critical_ch", value=accept_critical_ch, expected_type=type_hints["accept_critical_ch"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reset", value=reset, expected_type=type_hints["reset"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accept_ch is not None:
            self._values["accept_ch"] = accept_ch
        if accept_critical_ch is not None:
            self._values["accept_critical_ch"] = accept_critical_ch
        if locked is not None:
            self._values["locked"] = locked
        if reset is not None:
            self._values["reset"] = reset
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accept_ch(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The client hint data objects you want to receive from the browser.

        You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        '''
        result = self._values.get("accept_ch")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def accept_critical_ch(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The critical client hint data objects you want to receive from the browser.

        The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        '''
        result = self._values.get("accept_critical_ch")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reset(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser.

        This empty header doesn't get merged with other objects sent from your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        '''
        result = self._values.get("reset")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHintsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHintsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed762296b3284b7c360752baa86e0b2cf5a0a4accef098a2b8d3bd4d1de75496)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcceptCh")
    def reset_accept_ch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcceptCh", []))

    @jsii.member(jsii_name="resetAcceptCriticalCh")
    def reset_accept_critical_ch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcceptCriticalCh", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReset")
    def reset_reset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReset", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="acceptChInput")
    def accept_ch_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "acceptChInput"))

    @builtins.property
    @jsii.member(jsii_name="acceptCriticalChInput")
    def accept_critical_ch_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "acceptCriticalChInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resetInput")
    def reset_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resetInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acceptCh")
    def accept_ch(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "acceptCh"))

    @accept_ch.setter
    def accept_ch(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b656d0dcee36d0b75b27bbf34a339b99c4e4d02a90e6ed6de8231f0af972f060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acceptCh", value)

    @builtins.property
    @jsii.member(jsii_name="acceptCriticalCh")
    def accept_critical_ch(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "acceptCriticalCh"))

    @accept_critical_ch.setter
    def accept_critical_ch(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd37f11ba9fee990841271db20c7a68ce758eca5ea44abed62e4f8a010c52112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acceptCriticalCh", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5ff66ced899f105a34e89b8b9c3840667b814953fc78b55d8e9db87f6c2f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reset")
    def reset(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "reset"))

    @reset.setter
    def reset(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f3a3e2a880966e02184c3e88d4ffcb383bd79feb23d8e3fa96defb713b0a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reset", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10bf16ec3a8a2822be81a34c30013d4c642512db200d3c60e464e6817826762b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53135b362cff5531955024d2131d18fd64f57571184ade18d0526fe57594acc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43909fdada20800209009f0c408c63dfec6c2f686b9985250d5d417b0fab06cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl",
    jsii_struct_bases=[],
    name_mapping={
        "branded403_file": "branded403File",
        "branded403_status_code": "branded403StatusCode",
        "branded403_url": "branded403Url",
        "branded_deny_cache_ttl": "brandedDenyCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enable_branded403": "enableBranded403",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "net_storage": "netStorage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl:
    def __init__(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50739defaacbfd3cddcacb2f3249c892640d3ee4c179349d29b3192f35001de)
            check_type(argname="argument branded403_file", value=branded403_file, expected_type=type_hints["branded403_file"])
            check_type(argname="argument branded403_status_code", value=branded403_status_code, expected_type=type_hints["branded403_status_code"])
            check_type(argname="argument branded403_url", value=branded403_url, expected_type=type_hints["branded403_url"])
            check_type(argname="argument branded_deny_cache_ttl", value=branded_deny_cache_ttl, expected_type=type_hints["branded_deny_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enable_branded403", value=enable_branded403, expected_type=type_hints["enable_branded403"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if branded403_file is not None:
            self._values["branded403_file"] = branded403_file
        if branded403_status_code is not None:
            self._values["branded403_status_code"] = branded403_status_code
        if branded403_url is not None:
            self._values["branded403_url"] = branded403_url
        if branded_deny_cache_ttl is not None:
            self._values["branded_deny_cache_ttl"] = branded_deny_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enable_branded403 is not None:
            self._values["enable_branded403"] = enable_branded403
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def branded403_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        '''
        result = self._values.get("branded403_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded403_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response status code for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        '''
        result = self._values.get("branded403_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def branded403_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect URL for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        '''
        result = self._values.get("branded403_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded_deny_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the branded response page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        '''
        result = self._values.get("branded_deny_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enable_branded403(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, serves a branded 403 page for this Cloudlet instance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        '''
        result = self._values.get("enable_branded403")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Request Control Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b16b16d2c762552eddbc2de0a60a7c9c0f4e0a419a260f538f1a09fa5753b44)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abf7429609bcfb0a8a67ce5c85a88eac7dfda7adf051ba0b0cd4ccd061dcab5b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212a90d25887963c3cd83959df43dbbf3ef39121ed3f03d7b2906b289a3e82ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63092909d4a493222d889099e70cf9b7752c1b2224f49c30dba3f29fe65f89db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88fe3e5855d377a5bda6cd40a74ab0c1367073767565f0886d520a6e46678225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5229babc32f53903f00e7f95f490498db0be0c9d70684f67252ed77aeb69f39)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2215e481d96f5ba63830dd029969b9c0f3665b26b31fd463918672dad97ef49a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f1290dc5a407123af5ed6949b3db4fa4362496ddb3bb9ddeca67f8748fc6d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f755a1f988784e80f105c720d6e0e5ff996b2c2abde1babd1851bc9a5749965)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d223b294ba38f58ca8cef5330254e68c2cf710f4a60f28c23deecd6ad73dd20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0e488784e9ce3a54818e8cb6c816445427aa725ab8df34f0601e68c1a7de46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41c775581132e7022982cdc95f226902392b9fd4a7af82c8bc562cb4cd7158c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetBranded403File")
    def reset_branded403_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403File", []))

    @jsii.member(jsii_name="resetBranded403StatusCode")
    def reset_branded403_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403StatusCode", []))

    @jsii.member(jsii_name="resetBranded403Url")
    def reset_branded403_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403Url", []))

    @jsii.member(jsii_name="resetBrandedDenyCacheTtl")
    def reset_branded_deny_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrandedDenyCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnableBranded403")
    def reset_enable_branded403(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBranded403", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="branded403FileInput")
    def branded403_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403FileInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCodeInput")
    def branded403_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "branded403StatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403UrlInput")
    def branded403_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403UrlInput"))

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtlInput")
    def branded_deny_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "brandedDenyCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBranded403Input")
    def enable_branded403_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBranded403Input"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403File")
    def branded403_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403File"))

    @branded403_file.setter
    def branded403_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5f1742fac0dc6d57d0be9e996064846a7eb68c50a1e2ceea36d9f5b0df563c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403File", value)

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCode")
    def branded403_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "branded403StatusCode"))

    @branded403_status_code.setter
    def branded403_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885d4f47c05a4ca7af6dd02646dac78a9aef5a41bed2be464417019ea883fd36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403StatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="branded403Url")
    def branded403_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403Url"))

    @branded403_url.setter
    def branded403_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5e770d9f831cffec4ea80de2d4fbeb9ecf4d2a418e9009c41718f6f1c1dbab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403Url", value)

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtl")
    def branded_deny_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "brandedDenyCacheTtl"))

    @branded_deny_cache_ttl.setter
    def branded_deny_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83e4d456df9d85f1db54d4cf9eff7b3735ead572f6d1f728aef4889c3f59d5d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brandedDenyCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49bdc759b13f4cfb8314f856bef77bf81b0d5f7c98043a13eec27bd103057e9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enableBranded403")
    def enable_branded403(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBranded403"))

    @enable_branded403.setter
    def enable_branded403(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961164042c022e68c139cfd662315d5d8dc3274ba2207b0cd4b16e13e81384d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBranded403", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1e2e8052d0d62893cbb68272d2f3963343c7409ec41b4206671a86545bbb9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46024f5d18ceaa3904e18e3f51589a64d58becdaf03221c906f288519e7ebbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32ca06209979895519c4de7c818cb4d964f28147224b12cb371f74342a179009)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8103f1abf6c61974fc00ae56095d3bea782618bf97ad03e64473c90e236d73a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56299e4ab93115217a58dae6dbc0c9dc7b715fa11a042cf3f86850dea690ea88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512aa9bd1663b6c1d26b7e887c4fb2f0b119fe94b896216962e7ceb197e5c281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "request_type": "requestType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152a38152e57e1f422d6f3f4094f28a100a88be25ebaa2cd1cbc40c4de75fab1)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d977918f93a3e7ef531535b2c4c346be7c7ed161832f87df5c6b2bef5dbcc30b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76ccc1b77468be5545011f8a3ff8e78e3bc1d40f5092e203fbde3869f594588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b46f79b344c1186cf17e8206328b50cf198341113303533b93b7ef49c97f68a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01087172333cd9a6d8d1d8e0d81e21e29401393418c4e41833f4dd969f75c3d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145226f0c74eb1173769e018c0839c781039b4b4fde441ce4680dc80b2cdeafb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b1531f1340b632441072d55019373343ca7ded454eebca6382d910d0e3aaf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258ed320724cddc8d882123841c8f4db9d313729b0ae3cb0fe5abc0baa95f4fd)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "enable_all_features": "enableAllFeatures",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility:
    def __init__(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c7217f5776b5b415d70d9b89d7acdb1aedb29e87d4ba59d45be0c72ec92e06)
            check_type(argname="argument enable_all_features", value=enable_all_features, expected_type=type_hints["enable_all_features"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_all_features is not None:
            self._values["enable_all_features"] = enable_all_features
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_all_features(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``additional support`` and error handling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        '''
        result = self._values.get("enable_all_features")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43fd76662019d175bc04dbeb14f013c82dee32f45e1eaf0860b9459be2be0b24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableAllFeatures")
    def reset_enable_all_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAllFeatures", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeaturesInput")
    def enable_all_features_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAllFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeatures")
    def enable_all_features(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAllFeatures"))

    @enable_all_features.setter
    def enable_all_features(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd6233f899f0d5cb718acddc913bec42e35b4bc8113dd5832db93199266b7e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAllFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d0b83f85dc0fc0b3285aaf33c1e9168997c7b2811de92e4501721f92e4cf450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e30639dc2677936560f178d12168e71117ba0fade6104164e0df43635c9b191)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32bb4448bbf4fa96899096d01e242ad7384b85c68bfd0fd6e3f287a17da35689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d880c9dc8f4a45d99ce597b5e8e277e24f866767e06c112cf0148b17eefcb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33422d5567a6f3af933eb90d28d2bfe18cb7c9a6601903351f8c27cc79f4c815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df695c6cf589406f6b2b263f883aa81391c785d9feef8856b042908e8e5fd374)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8646b36af93c8dd1d5fa56b2d6356775a09b3461425f9486b7a44bff0ed759eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ad2620ae7b22ad57f72fa36a523ce36006600a9dbc7c098b88530d8a62954c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d00b97bde55f4032419f1a12f6d35fb533dbf074212730a21da74b7f02f6502)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6a0f4e4fb863a24f1de2efea5306cc2ca3b95db67eefc08f33c0eb5fcfbe41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__476506310c8f91b06bbaed0d99d22d6ab75cbb74eab2c1fe8c4dfb9a90c14f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "override206": "override206",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52fdc93a30ded2667ea34e118e942efb335fc7a1cc79fc8ce55968f128996d3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override206", value=override206, expected_type=type_hints["override206"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if override206 is not None:
            self._values["override206"] = override206
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override206(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        '''
        result = self._values.get("override206")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP status code to replace the existing one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbfb668d986dabcaf9d6ca97eb5381ff277c119cf51dee694eda34b0219a157)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride206")
    def reset_override206(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride206", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="override206Input")
    def override206_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "override206Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8f5178e9fcf64c10eb5731f0e950939f696724f541f7fa5fb61936392b4fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override206")
    def override206(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "override206"))

    @override206.setter
    def override206(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03ef821a975790c1d893243c3616ea6c454c35169f6be75a9de0df62c3efed0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override206", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983967ed5e62ae3612df659f6c1c151a957aac72d159464d114c7386b8183474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e6c6f81cf10f84a5d671fcfcaa605073de3c1bde5711c74fbe3bf701b2364be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba95be9b83068424632dbea2d45b532a67457bfd5c646c1acaebd4d14da4b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e33837af4cd12b315d73221a23edf7b261736adb45b1800a89465c68cb2cdf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "default_domain": "defaultDomain",
        "default_path": "defaultPath",
        "domain": "domain",
        "duration": "duration",
        "enabled": "enabled",
        "expiration_date": "expirationDate",
        "expires": "expires",
        "format": "format",
        "http_only": "httpOnly",
        "locked": "locked",
        "path": "path",
        "same_site": "sameSite",
        "secure": "secure",
        "template_uuid": "templateUuid",
        "type": "type",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__897b8834ae324174992969f138f32d8bafe4a6de081532e953dd9887bef07d0a)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument default_domain", value=default_domain, expected_type=type_hints["default_domain"])
            check_type(argname="argument default_path", value=default_path, expected_type=type_hints["default_path"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument duration", value=duration, expected_type=type_hints["duration"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expiration_date", value=expiration_date, expected_type=type_hints["expiration_date"])
            check_type(argname="argument expires", value=expires, expected_type=type_hints["expires"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument http_only", value=http_only, expected_type=type_hints["http_only"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument same_site", value=same_site, expected_type=type_hints["same_site"])
            check_type(argname="argument secure", value=secure, expected_type=type_hints["secure"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if default_domain is not None:
            self._values["default_domain"] = default_domain
        if default_path is not None:
            self._values["default_path"] = default_path
        if domain is not None:
            self._values["domain"] = domain
        if duration is not None:
            self._values["duration"] = duration
        if enabled is not None:
            self._values["enabled"] = enabled
        if expiration_date is not None:
            self._values["expiration_date"] = expiration_date
        if expires is not None:
            self._values["expires"] = expires
        if format is not None:
            self._values["format"] = format
        if http_only is not None:
            self._values["http_only"] = http_only
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if same_site is not None:
            self._values["same_site"] = same_site
        if secure is not None:
            self._values["secure"] = secure
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie, which serves as a key to determine if the cookie is set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        '''
        result = self._values.get("default_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def default_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default path value, otherwise the set specified in the ``path`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        '''
        result = self._values.get("default_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid.

        For example, ``example.com`` makes the cookie valid for that hostname and all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def duration(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        '''
        result = self._values.get("duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set a response cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_date(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        '''
        result = self._values.get("expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def expires(self) -> typing.Optional[builtins.str]:
        '''Sets various ways to specify when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        '''
        result = self._values.get("expires")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        '''
        result = self._values.get("http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def same_site(self) -> typing.Optional[builtins.str]:
        '''This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        '''
        result = self._values.get("same_site")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        '''
        result = self._values.get("secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''What type of value to assign.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''If the cookie ``type`` is ``FIXED``, this specifies the cookie value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a8a8f4092e03504c9e3f6d07657b3a5fa6c24a43a20cc15b9f48c45e7733931)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDefaultDomain")
    def reset_default_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultDomain", []))

    @jsii.member(jsii_name="resetDefaultPath")
    def reset_default_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultPath", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetDuration")
    def reset_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDuration", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExpirationDate")
    def reset_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationDate", []))

    @jsii.member(jsii_name="resetExpires")
    def reset_expires(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpires", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetHttpOnly")
    def reset_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpOnly", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetSameSite")
    def reset_same_site(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSameSite", []))

    @jsii.member(jsii_name="resetSecure")
    def reset_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecure", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultDomainInput")
    def default_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultPathInput")
    def default_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultPathInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="durationInput")
    def duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "durationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationDateInput")
    def expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="expiresInput")
    def expires_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expiresInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="httpOnlyInput")
    def http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "httpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="sameSiteInput")
    def same_site_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sameSiteInput"))

    @builtins.property
    @jsii.member(jsii_name="secureInput")
    def secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secureInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826f02bf3e3490e710fdc327c4d2fda710fea774caaa78b2af0e1c82e42ea53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="defaultDomain")
    def default_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultDomain"))

    @default_domain.setter
    def default_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5250b0ff750363784a3fa9931800e9301414a5fcb84182f61dd2d54860d9d83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultDomain", value)

    @builtins.property
    @jsii.member(jsii_name="defaultPath")
    def default_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultPath"))

    @default_path.setter
    def default_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af24f57243062247c87c5510d63865fd8f35b9f22a0aa4e40d8a003433d5e2cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultPath", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bea9d30b16f51044355436c4f0c4df8604f3511dea5546a78ba44c65a458ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="duration")
    def duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "duration"))

    @duration.setter
    def duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b4bef7ddd1c01af9b9ae64aee6e8326f1ed1360e6bc878c99d8866bebe46e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "duration", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcb52da1b3eef2259fd2a35e049485c62a19e3d201b327ee53dee1ac1da812ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="expirationDate")
    def expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationDate"))

    @expiration_date.setter
    def expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__839ba82f706a3b878b918007720bcfae1617f6fa6ddccf44ccd528cd37ba40f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="expires")
    def expires(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expires"))

    @expires.setter
    def expires(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84eff6dbd3b327685d3b10989bb73ced9a19904d1fb743428c8ff09ff9c59e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expires", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34cc4ec3cb9a4d4905a89aa77b2e7f7623fb98de999dcfe8ae20b303bd9dcb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="httpOnly")
    def http_only(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "httpOnly"))

    @http_only.setter
    def http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5daa14abf6c6220494fba54209699b6326b460fc68bfa0e8e105841c6826b51e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95720596eeff8acf79909febcf3e9a7abd5b2c837d2ae5e764d276d47cd3a45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ca10448565a0c3b090c477a2e12170aeea32cf629a9643b588cdb0f04fe82c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="sameSite")
    def same_site(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sameSite"))

    @same_site.setter
    def same_site(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60b23bae2b587c1ff814f8314450bc24b4bdaab20178122d8de611eda845f07b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sameSite", value)

    @builtins.property
    @jsii.member(jsii_name="secure")
    def secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secure"))

    @secure.setter
    def secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6a809437115af6620da28828d65ffe3fc0bc091615d1b02757f6ffa5f5a758a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secure", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__388e7b17576af0c21035dbcf32fa4f46020bcfab07df376fe9f211a0f7726e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6f9afd924029bad669219b1d43a4028bc362198a803f1752ed92e7b17ac1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd107af1b3514e5a1a2f1de0f6c9937c2cf870fce181db233b7e4ef029ca2ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73e0e0ca6c7cdc8dd4278d08c8fa64fa7c8bd202c47feeb7891466882decacc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd15f4ecef5e05e5b7812b86557fa867c0d9f62c68ec5a26defc6908b69f03e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_size": "maximumSize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f448ccdbc963e348d4fdc98b9a07abfae3d94f704ef54732bc75984d00b0a34a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed maximum size of non-HTML content to cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811c2965d733dd19c2c0cd03baaefbc933248ecbf933d630e8c63c8d149588e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6582ea7526aa04d397da44e0e5bc37adab99bd42d85e25cf22adadaafd159acb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ecc1869b7b7254c649ccf2eb363a9abd8c9108d47faec98572a62bbad4d83d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01190bb9f1d14f301bcd3ed19387cd73fd5bdbc10bc3677fb53f75a8a7eea73c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96dbe23525b3e993ea49f99aacc64b72eb2b95f18827e06b09376a5497234b07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a0e7d9cbbace1a3ce8718f527ab4064b73a0da80465fe532af9d00bb98d68f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "response_header_name": "responseHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3ed0922f3b743485d5ddd2b5ca529f3f888efaff8bf0973679f1c550da5069)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the HTTP header in which to report the cache status value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d04206206d807bcf5d6b28e2278483ed737fc2828e1c7ebbb24af3d56e0dc2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0712002118f822c07f1da742c0916d6e77262b8eb4e02d35a54974be8b9200bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f380f18d7f70ab42329d00e869b9564d0a5d37cc0b4e7ee2f1fff0755f3b6ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b0efb6e21362da1df5ec67097190061490e7df637bb8bb9454c2139d51ed88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837bc5001d62b203951e225bbc61b0ff56be1698acf5a1b9292945d67c7512e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7ef3cbe6c8657aecbf17ef0fe11c1841087dc92f803e871f090ca3019083b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "keep_query_string": "keepQueryString",
        "locked": "locked",
        "match": "match",
        "match_multiple": "matchMultiple",
        "match_regex": "matchRegex",
        "target_path": "targetPath",
        "target_path_prepend": "targetPathPrepend",
        "target_regex": "targetRegex",
        "target_url": "targetUrl",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a18c9d608a5f33ba9e017e7d4332c7fff4c3572d2be0b4000817080dd1604b77)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument keep_query_string", value=keep_query_string, expected_type=type_hints["keep_query_string"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match", value=match, expected_type=type_hints["match"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument match_regex", value=match_regex, expected_type=type_hints["match_regex"])
            check_type(argname="argument target_path", value=target_path, expected_type=type_hints["target_path"])
            check_type(argname="argument target_path_prepend", value=target_path_prepend, expected_type=type_hints["target_path_prepend"])
            check_type(argname="argument target_regex", value=target_regex, expected_type=type_hints["target_regex"])
            check_type(argname="argument target_url", value=target_url, expected_type=type_hints["target_url"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if keep_query_string is not None:
            self._values["keep_query_string"] = keep_query_string
        if locked is not None:
            self._values["locked"] = locked
        if match is not None:
            self._values["match"] = match
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if match_regex is not None:
            self._values["match_regex"] = match_regex
        if target_path is not None:
            self._values["target_path"] = target_path
        if target_path_prepend is not None:
            self._values["target_path_prepend"] = target_path_prepend
        if target_regex is not None:
            self._values["target_regex"] = target_regex
        if target_url is not None:
            self._values["target_url"] = target_url
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''The action to perform on the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def keep_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, retains the original path's query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        '''
        result = self._values.get("keep_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        '''
        result = self._values.get("match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, replaces all potential matches rather than only the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        '''
        result = self._values.get("match_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        '''
        result = self._values.get("target_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path_prepend(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        '''
        result = self._values.get("target_path_prepend")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        '''
        result = self._values.get("target_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_url(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        '''
        result = self._values.get("target_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9fc08b6296575736f182714a5ad503a492c2d16aed46253897f806d86f4f676)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetKeepQueryString")
    def reset_keep_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKeepQueryString", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatch")
    def reset_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatch", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetMatchRegex")
    def reset_match_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchRegex", []))

    @jsii.member(jsii_name="resetTargetPath")
    def reset_target_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPath", []))

    @jsii.member(jsii_name="resetTargetPathPrepend")
    def reset_target_path_prepend(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPathPrepend", []))

    @jsii.member(jsii_name="resetTargetRegex")
    def reset_target_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetRegex", []))

    @jsii.member(jsii_name="resetTargetUrl")
    def reset_target_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetUrl", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="keepQueryStringInput")
    def keep_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "keepQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchInput")
    def match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="matchRegexInput")
    def match_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathInput")
    def target_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathPrependInput")
    def target_path_prepend_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathPrependInput"))

    @builtins.property
    @jsii.member(jsii_name="targetRegexInput")
    def target_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetUrlInput")
    def target_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd3ab3278f136d1c11db408236d7a02a821d5be8cd2a45bf7342be135176770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="keepQueryString")
    def keep_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "keepQueryString"))

    @keep_query_string.setter
    def keep_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eadfcd7482117e1ffa48737805e546f9e10a21ab96e577bb0f41f1b441ddbbbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "keepQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a460ac08cae33a0afd9c5d87dc8d413e3f0c0c1f748a6a79c073aed2b24b0f9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="match")
    def match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "match"))

    @match.setter
    def match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__637c99acdee69552a799776fd1441e26d84073fbac371e2a9b05b30f4449f15a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "match", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9892d4d477dbb161dd4fc348aca6e55e808372d8a0fd0adfccb30bab03751b33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="matchRegex")
    def match_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchRegex"))

    @match_regex.setter
    def match_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9914f640894ae71d957d5aa5d5e8787c83e58ca31efce23790ebf6036fa7d5a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetPath")
    def target_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPath"))

    @target_path.setter
    def target_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64ccf78322095cad8ccec2d8bcabc00e853999f867216af875f756729b9b47dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPath", value)

    @builtins.property
    @jsii.member(jsii_name="targetPathPrepend")
    def target_path_prepend(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPathPrepend"))

    @target_path_prepend.setter
    def target_path_prepend(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6cecd842770f8dcbae0117ea60a6792cd81967d31977d647cfc30f3624c5d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPathPrepend", value)

    @builtins.property
    @jsii.member(jsii_name="targetRegex")
    def target_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetRegex"))

    @target_regex.setter
    def target_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10b117517c7d0dc5d8c63b84d44c458b5e595bb30aace2ffc40cb94216eeac1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetUrl")
    def target_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetUrl"))

    @target_url.setter
    def target_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ff0b829845f97f344e1ff555626d9789844b73a56dee492b5b053be2dc4ea16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetUrl", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c5837f23c599595b060fd294caedf8804d1c2d4f93a99a444f759836c77a4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91b474c5e986dcf729a9d43c7ec64eefa3013f22995478d60541532dc98dd6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77c6515f69df0f06fe4269539119efbb286161bc60fce86aa109d4c88ec0870a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "rum_group_name": "rumGroupName",
        "rum_sample_rate": "rumSampleRate",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fbfd2547a74e44648b3f0edc22803cc171729d19244f259b585ccd0c31ef00)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument rum_group_name", value=rum_group_name, expected_type=type_hints["rum_group_name"])
            check_type(argname="argument rum_sample_rate", value=rum_sample_rate, expected_type=type_hints["rum_sample_rate"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if rum_group_name is not None:
            self._values["rum_group_name"] = rum_group_name
        if rum_sample_rate is not None:
            self._values["rum_sample_rate"] = rum_sample_rate
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rum_group_name(self) -> typing.Optional[builtins.str]:
        '''A deprecated option to specify an alternate name under which to batch this set of web traffic in your report.

        Do not use it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        '''
        result = self._values.get("rum_group_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rum_sample_rate(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of web traffic to include in your RUM report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        '''
        result = self._values.get("rum_sample_rate")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__282c7b0a3c7e198b22682b2d1a9b4b2854ddb7f64cf8246d60138ddc1a4c3695)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRumGroupName")
    def reset_rum_group_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumGroupName", []))

    @jsii.member(jsii_name="resetRumSampleRate")
    def reset_rum_sample_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumSampleRate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="rumGroupNameInput")
    def rum_group_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "rumGroupNameInput"))

    @builtins.property
    @jsii.member(jsii_name="rumSampleRateInput")
    def rum_sample_rate_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "rumSampleRateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__964bf0bd7a2452448117c19e4d1dcadf04579308aa00763fe58977256efc14ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="rumGroupName")
    def rum_group_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rumGroupName"))

    @rum_group_name.setter
    def rum_group_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d378528b323fc15b42ef3e5fa571aa1d018c930461985943cd319e10e6ea5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumGroupName", value)

    @builtins.property
    @jsii.member(jsii_name="rumSampleRate")
    def rum_sample_rate(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "rumSampleRate"))

    @rum_sample_rate.setter
    def rum_sample_rate(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b849502cd2f15abe287579f317321517ac2ce5e627e7ced314e8f422e10a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumSampleRate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aabfb72cb24439065346fb2424d1ae414f71d601211f61586290e05545663cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35dbdc19c47a4e799535ba5f1ac162c98cf67441aac3a9f1738466fde3763220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__001722a336a0d8f0197a2daf45f5c5271b58906faa2127ae8430962ee1369a53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions",
    jsii_struct_bases=[],
    name_mapping={
        "application_action": "applicationAction",
        "application_cname_enabled": "applicationCnameEnabled",
        "application_cname_level": "applicationCnameLevel",
        "application_cookie": "applicationCookie",
        "application_query_string": "applicationQueryString",
        "application_regex": "applicationRegex",
        "application_replace": "applicationReplace",
        "application_title": "applicationTitle",
        "customer_action": "customerAction",
        "customer_cname_enabled": "customerCnameEnabled",
        "customer_cname_level": "customerCnameLevel",
        "customer_cookie": "customerCookie",
        "customer_query_string": "customerQueryString",
        "customer_regex": "customerRegex",
        "customer_replace": "customerReplace",
        "customer_title": "customerTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "users_action": "usersAction",
        "users_cname_enabled": "usersCnameEnabled",
        "users_cname_level": "usersCnameLevel",
        "users_cookie": "usersCookie",
        "users_query_string": "usersQueryString",
        "users_regex": "usersRegex",
        "users_replace": "usersReplace",
        "users_title": "usersTitle",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions:
    def __init__(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__809eec6d81eb92a31da1f5cbf3222e843050f92e2e40f00d258598d0195959f6)
            check_type(argname="argument application_action", value=application_action, expected_type=type_hints["application_action"])
            check_type(argname="argument application_cname_enabled", value=application_cname_enabled, expected_type=type_hints["application_cname_enabled"])
            check_type(argname="argument application_cname_level", value=application_cname_level, expected_type=type_hints["application_cname_level"])
            check_type(argname="argument application_cookie", value=application_cookie, expected_type=type_hints["application_cookie"])
            check_type(argname="argument application_query_string", value=application_query_string, expected_type=type_hints["application_query_string"])
            check_type(argname="argument application_regex", value=application_regex, expected_type=type_hints["application_regex"])
            check_type(argname="argument application_replace", value=application_replace, expected_type=type_hints["application_replace"])
            check_type(argname="argument application_title", value=application_title, expected_type=type_hints["application_title"])
            check_type(argname="argument customer_action", value=customer_action, expected_type=type_hints["customer_action"])
            check_type(argname="argument customer_cname_enabled", value=customer_cname_enabled, expected_type=type_hints["customer_cname_enabled"])
            check_type(argname="argument customer_cname_level", value=customer_cname_level, expected_type=type_hints["customer_cname_level"])
            check_type(argname="argument customer_cookie", value=customer_cookie, expected_type=type_hints["customer_cookie"])
            check_type(argname="argument customer_query_string", value=customer_query_string, expected_type=type_hints["customer_query_string"])
            check_type(argname="argument customer_regex", value=customer_regex, expected_type=type_hints["customer_regex"])
            check_type(argname="argument customer_replace", value=customer_replace, expected_type=type_hints["customer_replace"])
            check_type(argname="argument customer_title", value=customer_title, expected_type=type_hints["customer_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument users_action", value=users_action, expected_type=type_hints["users_action"])
            check_type(argname="argument users_cname_enabled", value=users_cname_enabled, expected_type=type_hints["users_cname_enabled"])
            check_type(argname="argument users_cname_level", value=users_cname_level, expected_type=type_hints["users_cname_level"])
            check_type(argname="argument users_cookie", value=users_cookie, expected_type=type_hints["users_cookie"])
            check_type(argname="argument users_query_string", value=users_query_string, expected_type=type_hints["users_query_string"])
            check_type(argname="argument users_regex", value=users_regex, expected_type=type_hints["users_regex"])
            check_type(argname="argument users_replace", value=users_replace, expected_type=type_hints["users_replace"])
            check_type(argname="argument users_title", value=users_title, expected_type=type_hints["users_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if application_action is not None:
            self._values["application_action"] = application_action
        if application_cname_enabled is not None:
            self._values["application_cname_enabled"] = application_cname_enabled
        if application_cname_level is not None:
            self._values["application_cname_level"] = application_cname_level
        if application_cookie is not None:
            self._values["application_cookie"] = application_cookie
        if application_query_string is not None:
            self._values["application_query_string"] = application_query_string
        if application_regex is not None:
            self._values["application_regex"] = application_regex
        if application_replace is not None:
            self._values["application_replace"] = application_replace
        if application_title is not None:
            self._values["application_title"] = application_title
        if customer_action is not None:
            self._values["customer_action"] = customer_action
        if customer_cname_enabled is not None:
            self._values["customer_cname_enabled"] = customer_cname_enabled
        if customer_cname_level is not None:
            self._values["customer_cname_level"] = customer_cname_level
        if customer_cookie is not None:
            self._values["customer_cookie"] = customer_cookie
        if customer_query_string is not None:
            self._values["customer_query_string"] = customer_query_string
        if customer_regex is not None:
            self._values["customer_regex"] = customer_regex
        if customer_replace is not None:
            self._values["customer_replace"] = customer_replace
        if customer_title is not None:
            self._values["customer_title"] = customer_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if users_action is not None:
            self._values["users_action"] = users_action
        if users_cname_enabled is not None:
            self._values["users_cname_enabled"] = users_cname_enabled
        if users_cname_level is not None:
            self._values["users_cname_level"] = users_cname_level
        if users_cookie is not None:
            self._values["users_cookie"] = users_cookie
        if users_query_string is not None:
            self._values["users_query_string"] = users_query_string
        if users_regex is not None:
            self._values["users_regex"] = users_regex
        if users_replace is not None:
            self._values["users_replace"] = users_replace
        if users_title is not None:
            self._values["users_title"] = users_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def application_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        '''
        result = self._values.get("application_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        '''
        result = self._values.get("application_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def application_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        '''
        result = self._values.get("application_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def application_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        '''
        result = self._values.get("application_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        '''
        result = self._values.get("application_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's application ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        '''
        result = self._values.get("application_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's application ID matched by ``applicationRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        '''
        result = self._values.get("application_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        '''
        result = self._values.get("application_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        '''
        result = self._values.get("customer_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        '''
        result = self._values.get("customer_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def customer_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        '''
        result = self._values.get("customer_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def customer_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        '''
        result = self._values.get("customer_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        '''
        result = self._values.get("customer_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's customer ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        '''
        result = self._values.get("customer_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's customer ID matched by ``customerRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        '''
        result = self._values.get("customer_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        '''
        result = self._values.get("customer_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        '''
        result = self._values.get("users_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        '''
        result = self._values.get("users_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def users_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        '''
        result = self._values.get("users_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def users_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        '''
        result = self._values.get("users_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        '''
        result = self._values.get("users_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's user ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        '''
        result = self._values.get("users_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's user ID matched by ``usersRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        '''
        result = self._values.get("users_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        '''
        result = self._values.get("users_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e936508106e50e0a97385a31129d5ab0befa7b70109b0aecdea3e1a0f12af50e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplicationAction")
    def reset_application_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationAction", []))

    @jsii.member(jsii_name="resetApplicationCnameEnabled")
    def reset_application_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameEnabled", []))

    @jsii.member(jsii_name="resetApplicationCnameLevel")
    def reset_application_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameLevel", []))

    @jsii.member(jsii_name="resetApplicationCookie")
    def reset_application_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCookie", []))

    @jsii.member(jsii_name="resetApplicationQueryString")
    def reset_application_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationQueryString", []))

    @jsii.member(jsii_name="resetApplicationRegex")
    def reset_application_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationRegex", []))

    @jsii.member(jsii_name="resetApplicationReplace")
    def reset_application_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationReplace", []))

    @jsii.member(jsii_name="resetApplicationTitle")
    def reset_application_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationTitle", []))

    @jsii.member(jsii_name="resetCustomerAction")
    def reset_customer_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerAction", []))

    @jsii.member(jsii_name="resetCustomerCnameEnabled")
    def reset_customer_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameEnabled", []))

    @jsii.member(jsii_name="resetCustomerCnameLevel")
    def reset_customer_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameLevel", []))

    @jsii.member(jsii_name="resetCustomerCookie")
    def reset_customer_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCookie", []))

    @jsii.member(jsii_name="resetCustomerQueryString")
    def reset_customer_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerQueryString", []))

    @jsii.member(jsii_name="resetCustomerRegex")
    def reset_customer_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerRegex", []))

    @jsii.member(jsii_name="resetCustomerReplace")
    def reset_customer_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerReplace", []))

    @jsii.member(jsii_name="resetCustomerTitle")
    def reset_customer_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsersAction")
    def reset_users_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersAction", []))

    @jsii.member(jsii_name="resetUsersCnameEnabled")
    def reset_users_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameEnabled", []))

    @jsii.member(jsii_name="resetUsersCnameLevel")
    def reset_users_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameLevel", []))

    @jsii.member(jsii_name="resetUsersCookie")
    def reset_users_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCookie", []))

    @jsii.member(jsii_name="resetUsersQueryString")
    def reset_users_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersQueryString", []))

    @jsii.member(jsii_name="resetUsersRegex")
    def reset_users_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersRegex", []))

    @jsii.member(jsii_name="resetUsersReplace")
    def reset_users_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersReplace", []))

    @jsii.member(jsii_name="resetUsersTitle")
    def reset_users_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applicationActionInput")
    def application_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationActionInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabledInput")
    def application_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applicationCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevelInput")
    def application_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "applicationCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCookieInput")
    def application_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationQueryStringInput")
    def application_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationRegexInput")
    def application_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationReplaceInput")
    def application_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationTitleInput")
    def application_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customerActionInput")
    def customer_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerActionInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabledInput")
    def customer_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customerCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevelInput")
    def customer_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "customerCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCookieInput")
    def customer_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="customerQueryStringInput")
    def customer_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="customerRegexInput")
    def customer_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="customerReplaceInput")
    def customer_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="customerTitleInput")
    def customer_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usersActionInput")
    def users_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersActionInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabledInput")
    def users_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "usersCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevelInput")
    def users_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "usersCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCookieInput")
    def users_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="usersQueryStringInput")
    def users_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="usersRegexInput")
    def users_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="usersReplaceInput")
    def users_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="usersTitleInput")
    def users_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationAction")
    def application_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationAction"))

    @application_action.setter
    def application_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18754565146bfdfdb1163583d58edab85dbae8ed53b22c915fc058f61c6e8e1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationAction", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabled")
    def application_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applicationCnameEnabled"))

    @application_cname_enabled.setter
    def application_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36f38b79f978b6cb788f159ea8b45b718c5fc8b81ace2b6e37909a17ea30a72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevel")
    def application_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "applicationCnameLevel"))

    @application_cname_level.setter
    def application_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__053338ffb86b7ade7e35717057eae2503306b567bbe4a5bfa80264a76777ff0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCookie")
    def application_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationCookie"))

    @application_cookie.setter
    def application_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd58c933bdb4d08964ed6b4d8e834018ed3a413a600eee4d2726a8e11ae39a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCookie", value)

    @builtins.property
    @jsii.member(jsii_name="applicationQueryString")
    def application_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationQueryString"))

    @application_query_string.setter
    def application_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1376687183af5979865bfc0ce07c5b40ceedf4e2ac07bb0460387b230a8caff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="applicationRegex")
    def application_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationRegex"))

    @application_regex.setter
    def application_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffe1686ac1f82a3f12cf53c8d1e6456e0bc7f9255883cd3e8c517ce1671d47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationRegex", value)

    @builtins.property
    @jsii.member(jsii_name="applicationReplace")
    def application_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationReplace"))

    @application_replace.setter
    def application_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27c2697b70cc5df512a94e61574a8a6ec483d22bc55f9702d1f2cc9fb8b0cf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationReplace", value)

    @builtins.property
    @jsii.member(jsii_name="applicationTitle")
    def application_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationTitle"))

    @application_title.setter
    def application_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2531473cd049ed3032cfddb5494467c7bc9f40a8197908d9739a2b9b0ee4a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customerAction")
    def customer_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerAction"))

    @customer_action.setter
    def customer_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5afdb231b991d3c585d2a490ad74d4af4e11cf9fd9797ed882ff167cfb4b630)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerAction", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabled")
    def customer_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customerCnameEnabled"))

    @customer_cname_enabled.setter
    def customer_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c30bf5e0f465846efc398be0dc26d59b94dfdbc0e6ead35cca674dbd6a2f7f66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevel")
    def customer_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "customerCnameLevel"))

    @customer_cname_level.setter
    def customer_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4cec5c4348f06e9927db27ae461b6cdee5f41916539758a0d18b9e8c480a27d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="customerCookie")
    def customer_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerCookie"))

    @customer_cookie.setter
    def customer_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0736e157ba7f154195bd087e1a0d7b302efb6a74fc341e986288281a0764d472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCookie", value)

    @builtins.property
    @jsii.member(jsii_name="customerQueryString")
    def customer_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerQueryString"))

    @customer_query_string.setter
    def customer_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ff450d81a0a00b84ade13d70cba7f08a132e6ddc35f2177ea80614c56212c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="customerRegex")
    def customer_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerRegex"))

    @customer_regex.setter
    def customer_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44eb31947124ef7f7fcd47bd8200848f3d764519a89f1bb44fe2f16bc5fc55c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerRegex", value)

    @builtins.property
    @jsii.member(jsii_name="customerReplace")
    def customer_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerReplace"))

    @customer_replace.setter
    def customer_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da106f785b328efd588dda25cfaf008cd758377aadfd94d4916eba2b359ecccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerReplace", value)

    @builtins.property
    @jsii.member(jsii_name="customerTitle")
    def customer_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerTitle"))

    @customer_title.setter
    def customer_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0e38bf1bacd0fc77b17b6fdcfc29929bbb4c8757074b9d8c4b0166f4fb9eeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed46390befddb1ee71d378a73ad296e28643481b3efb5dab23e17d6fcdca76a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12e399ce894df4e86d145cdbe898359823cda35bbe894859bfa8dff7736edf98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="usersAction")
    def users_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersAction"))

    @users_action.setter
    def users_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8750ccc63c8b692744d68906d3cd58053c02dde359da71ec23a85285818e76f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersAction", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabled")
    def users_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "usersCnameEnabled"))

    @users_cname_enabled.setter
    def users_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd51428e2d9968537d2fcf0310398918bfff7b10420fe66c13e5d84191185e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevel")
    def users_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "usersCnameLevel"))

    @users_cname_level.setter
    def users_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed813a6f6da27322ae25af3fe8076c0edef98c8c0e45cfee7449f58ad28183b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="usersCookie")
    def users_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersCookie"))

    @users_cookie.setter
    def users_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__592c4ff2198bf37e27390497c2d2771878ee55fd617f6762ecf826e9dc049da1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCookie", value)

    @builtins.property
    @jsii.member(jsii_name="usersQueryString")
    def users_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersQueryString"))

    @users_query_string.setter
    def users_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6ed856ef30b820efce8a82740e2d26d6166d40225cc1ba742dee24879f2773f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="usersRegex")
    def users_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersRegex"))

    @users_regex.setter
    def users_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddee341519cc735fad060371499bbe07bcfb27c75a7863288dd3945a9fb7d59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersRegex", value)

    @builtins.property
    @jsii.member(jsii_name="usersReplace")
    def users_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersReplace"))

    @users_replace.setter
    def users_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__274dd9b651f7e1e4e3359d4f94cc67b370830ff55115695a4ad75abed770900b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersReplace", value)

    @builtins.property
    @jsii.member(jsii_name="usersTitle")
    def users_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersTitle"))

    @users_title.setter
    def users_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa761a262f4aa8178631aeb10161144e7e93a144c4fa59bcbbed6f888cfa841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f70ed2ec5d2dfdd204e43572541a4a48a88402c85c2eb8d7df14d0bcec31ee7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c68bd7ebe2675189bf43a1250951242b66c3e7c3bbb2050b21fb8ddfce2b2ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient",
    jsii_struct_bases=[],
    name_mapping={
        "allow_override_origin_cache_key": "allowOverrideOriginCacheKey",
        "connector_id": "connectorId",
        "enabled": "enabled",
        "locked": "locked",
        "origin_host_header": "originHostHeader",
        "origin_type": "originType",
        "sf3_c_origin_host": "sf3COriginHost",
        "sf3_c_origin_host_header": "sf3COriginHostHeader",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient:
    def __init__(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c721f96f2bd12929d34fea373aa4c577dd7b49574810e9d5ed61b718605c44f5)
            check_type(argname="argument allow_override_origin_cache_key", value=allow_override_origin_cache_key, expected_type=type_hints["allow_override_origin_cache_key"])
            check_type(argname="argument connector_id", value=connector_id, expected_type=type_hints["connector_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_host_header", value=origin_host_header, expected_type=type_hints["origin_host_header"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument sf3_c_origin_host", value=sf3_c_origin_host, expected_type=type_hints["sf3_c_origin_host"])
            check_type(argname="argument sf3_c_origin_host_header", value=sf3_c_origin_host_header, expected_type=type_hints["sf3_c_origin_host_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_override_origin_cache_key is not None:
            self._values["allow_override_origin_cache_key"] = allow_override_origin_cache_key
        if connector_id is not None:
            self._values["connector_id"] = connector_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if origin_host_header is not None:
            self._values["origin_host_header"] = origin_host_header
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if sf3_c_origin_host is not None:
            self._values["sf3_c_origin_host"] = sf3_c_origin_host
        if sf3_c_origin_host_header is not None:
            self._values["sf3_c_origin_host_header"] = sf3_c_origin_host_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides the forwarding origin's cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        '''
        result = self._values.get("allow_override_origin_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def connector_id(self) -> typing.Optional[builtins.str]:
        '''An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud.

        Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud.  You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        '''
        result = self._values.get("connector_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamai Connector for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_host_header(self) -> typing.Optional[builtins.str]:
        '''Specifies where the ``Host`` header is defined.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        '''
        result = self._values.get("origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Specifies where the origin is.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        '''
        result = self._values.get("sf3_c_origin_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce host header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        '''
        result = self._values.get("sf3_c_origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e1adeb1823b7d6230319519cf74cac31d2f9530669e2b398d88dba5167144a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowOverrideOriginCacheKey")
    def reset_allow_override_origin_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOverrideOriginCacheKey", []))

    @jsii.member(jsii_name="resetConnectorId")
    def reset_connector_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConnectorId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginHostHeader")
    def reset_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginHostHeader", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetSf3COriginHost")
    def reset_sf3_c_origin_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHost", []))

    @jsii.member(jsii_name="resetSf3COriginHostHeader")
    def reset_sf3_c_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHostHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKeyInput")
    def allow_override_origin_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowOverrideOriginCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="connectorIdInput")
    def connector_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "connectorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originHostHeaderInput")
    def origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeaderInput")
    def sf3_c_origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostInput")
    def sf3_c_origin_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKey")
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowOverrideOriginCacheKey"))

    @allow_override_origin_cache_key.setter
    def allow_override_origin_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edaac8de3efad799ac44b0dd45e1157dcd89622aa55762e98439a5099e3f87d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOverrideOriginCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="connectorId")
    def connector_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "connectorId"))

    @connector_id.setter
    def connector_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee66074d0682fb7c49c9b585d8ce480d24a2120a200c6512a72cde3833ec4ba1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "connectorId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ca8ea13f7ddc8bc2b62eec7fdfc98326ebd9952bb0227db8e9d4b86858c4785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7985289a1e16b965e1e87de110ab5516b9277718d15c78f9db16118889fda77f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originHostHeader")
    def origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originHostHeader"))

    @origin_host_header.setter
    def origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e007c9b615b61dfc6aef94c16eb9967d77af9cc00f4a390c8377af31c055bc13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8fdabea5f1e53b7d6ae01e90bf730f132944d9832955ec2b9ba67ff67d04bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHost")
    def sf3_c_origin_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHost"))

    @sf3_c_origin_host.setter
    def sf3_c_origin_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb902549535b203eb01e006dbe8f0a2f75b61eb026f4d40f2e9e954586206b38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHost", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeader")
    def sf3_c_origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHostHeader"))

    @sf3_c_origin_host_header.setter
    def sf3_c_origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f8d9568489b4688c36c43ff5a57700682a50aa56d6ee41e417cb3ecc63af95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c21cda4ae2d22d39c298f58bd2687c943be3968ef3636b871956f3e403c770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80bbd4289d563e98b41c2d8b6ddc5829e141790fc738e72d2dc29b1d77832754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5b69ac95be43db14b264edbb3aa1b3c3ef8edc7c9ec69d7dfe20475e41253c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba90bfe8d920338e4045e51ee832ad70557e956195bf16f5b2955f921526433)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Akamai Provider for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader",
    jsii_struct_bases=[],
    name_mapping={
        "host_header_source": "hostHeaderSource",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader:
    def __init__(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__309eb1fa66ddc457021149ce42e93a43e451aaaefd680429b0413c6f3ac56f74)
            check_type(argname="argument host_header_source", value=host_header_source, expected_type=type_hints["host_header_source"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if host_header_source is not None:
            self._values["host_header_source"] = host_header_source
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def host_header_source(self) -> typing.Optional[builtins.str]:
        '''Specify where the host header derives from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        '''
        result = self._values.get("host_header_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cadcf56da94d5db738f99fa9d6f862329923154fe81ad6797c4ab6959ba55c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHostHeaderSource")
    def reset_host_header_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostHeaderSource", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSourceInput")
    def host_header_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostHeaderSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSource")
    def host_header_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostHeaderSource"))

    @host_header_source.setter
    def host_header_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08848f46f96cae2ddbef276e491a9de2b5d699a29d3b5cf25903756231b42fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostHeaderSource", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fbd681a7b449ed38594639a76257f8cc12169f0977d65c5aca191f0152c5320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c17830667d3af21672e2fde3c52b8dabe28436fd34370a242f97548696d1c0d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25967a62ae203b01cf27725a7140ec8715d52635108eb754467449681bbf6041)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daed83d82c547dbb5992822691f88e60f3b5359ae3c0dc1016542c668e542af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b568246ad5de2d68f6f1ade6393b1847d35779075df366f03983b9231a8705c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__817bc637b83c65f2d0caf9152632940698af2a460141de50efeba31baf7b95db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1835e37f150b737884f1c8bcffce8ab5600d01285a9730f0da3b5ff71880dab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b08a57f87b61eb9e0b3d506041c00378c629e064464c4727ac4f137b4cb1e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__085da73ab1c3e119e6f33690293d7b35218735e917a7da2b4d2ff085c89b41fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c43b882247b282ae4db137f00f611fb074e5014a339aab9bcfcae035bd009f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf4c222c4c73d44d1266822fb5ab74fe90e55d4c9e2da8c781b9fb007e0d4a7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables processing of POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2a409f44fd0df8bbbd4f59c0644b4a23e3663a1998e02dd2609b3f915e1e8c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b100572317c15b0a250f24d4a147d9d3a6d910dcf55780bfaaf716b499f3a2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__525608390316a641fc6a3650d07aff9d6be854b3ac86048d0484a5c5f66c1aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce714977b5014ce8ea39f1949f4dd321fe02cc8cd0d79bf653620a29041f9426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__660d346c2e67b0a436823192ab6819bf3506a2c846195be7ca64f9512cd32b72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c848a724ed583ec11f4de2614af7bab4d4b928a354567a10023020c94161d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "refresh_method": "refreshMethod",
        "repeat": "repeat",
        "repeat_interval": "repeatInterval",
        "start": "start",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c35c6687d233cd3bce132f7408073d5d427d49799e6dcfca2fc6ca9f262c56)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument refresh_method", value=refresh_method, expected_type=type_hints["refresh_method"])
            check_type(argname="argument repeat", value=repeat, expected_type=type_hints["repeat"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument start", value=start, expected_type=type_hints["start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if refresh_method is not None:
            self._values["refresh_method"] = refresh_method
        if repeat is not None:
            self._values["repeat"] = repeat
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if start is not None:
            self._values["start"] = start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_method(self) -> typing.Optional[builtins.str]:
        '''Specifies how to invalidate the content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        '''
        result = self._values.get("refresh_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        '''
        result = self._values.get("repeat")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies how often to invalidate content from the ``start`` time, expressed in seconds.

        For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day.  Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start(self) -> typing.Optional[builtins.str]:
        '''The UTC date and time when matching cached content is to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        '''
        result = self._values.get("start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387fb924522e90059f2b38cdccf73e68fb2f7a3cdc6f11929bc53106ca675695)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRefreshMethod")
    def reset_refresh_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshMethod", []))

    @jsii.member(jsii_name="resetRepeat")
    def reset_repeat(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeat", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetStart")
    def reset_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshMethodInput")
    def refresh_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatInput")
    def repeat_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "repeatInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="startInput")
    def start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0729fd4d2c9a445a5ef1b750f013c21c2be0bf2a6fd9ad0ba26532a9fec8477f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="refreshMethod")
    def refresh_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshMethod"))

    @refresh_method.setter
    def refresh_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de3a15e8de49757e066999c893845827dd43da173dee83d5e5ce8c8356b663c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshMethod", value)

    @builtins.property
    @jsii.member(jsii_name="repeat")
    def repeat(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "repeat"))

    @repeat.setter
    def repeat(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1788de1e4c5997add8aee9ab3945ba730b944e9f0dfacef35ce315ca960dcc55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeat", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e08a1bebaa8861474633f90598e61a6331c3a4a8c86a5b9e9f8bf57f3ad8568)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="start")
    def start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "start"))

    @start.setter
    def start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a18315153bb48e67ec4e9d6300b479a9a50ce911039d5ac3dcad71da5a9eb18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "start", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf4de377641d99f3e071b29108ecbe8041af00c2df3a3fafd7c373b30631b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5035cd7dce489ea0d90944af8a1666f6ebf0f763b84b9ca624d3385ad15b1bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa7bbb9a841a627d0812c73cfebd5559e5bf0ee17d2784b505bcdf8decb61e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "serviceworker": "serviceworker",
        "template_uuid": "templateUuid",
        "timestamp": "timestamp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d9027db28ecc3298db5de078f09fc08d00bde9a1df961cef38293f317607f27)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serviceworker", value=serviceworker, expected_type=type_hints["serviceworker"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timestamp", value=timestamp, expected_type=type_hints["timestamp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if serviceworker is not None:
            self._values["serviceworker"] = serviceworker
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timestamp is not None:
            self._values["timestamp"] = timestamp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Script Management feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serviceworker(self) -> typing.Optional[builtins.str]:
        '''Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        '''
        result = self._values.get("serviceworker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timestamp(self) -> typing.Optional[jsii.Number]:
        '''A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        '''
        result = self._values.get("timestamp")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagementOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagementOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f663765827ce76a611e9269dcf62153d59c6f690d43836b9fd063b056a0ac49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServiceworker")
    def reset_serviceworker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServiceworker", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimestamp")
    def reset_timestamp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimestamp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serviceworkerInput")
    def serviceworker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serviceworkerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timestampInput")
    def timestamp_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "timestampInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1460d1456394707d191598b798f31dd80adeeb551ab005ced6a4fdd3e31b21e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e94b1219eef70638d88b98775fcb44f2541ce1c85e5210aac845fc1ea691fbf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serviceworker")
    def serviceworker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serviceworker"))

    @serviceworker.setter
    def serviceworker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f48f630830178f4d8d00412b5eac577989029a75e59211a7725f010a0be2c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serviceworker", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f4037c0c41e1c57e7b61bc4c7b540663bda38ad777930efd8b5c03eddcef86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timestamp")
    def timestamp(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "timestamp"))

    @timestamp.setter
    def timestamp(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c8f620e2b84b5212224c68a26b7fd71f0dd2429300e6987f39b417f96883a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timestamp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61cde84e7dd8b41d9d040f9a5a35b01b39ca9b75f79430a55ecbf1dd6ca3f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae0e73bedfb54d3338b341efcd0a256b9134390e417d6e8bc412efa382eebbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection",
    jsii_struct_bases=[],
    name_mapping={
        "acl": "acl",
        "dash_media_encryption": "dashMediaEncryption",
        "data_payload": "dataPayload",
        "enabled": "enabled",
        "enable_token_in_uri": "enableTokenInUri",
        "field_carry_over": "fieldCarryOver",
        "header_for_salt": "headerForSalt",
        "hls_master_manifest_files": "hlsMasterManifestFiles",
        "hls_media_encryption": "hlsMediaEncryption",
        "ip": "ip",
        "key": "key",
        "locked": "locked",
        "media_encryption_title": "mediaEncryptionTitle",
        "revoked_list_id": "revokedListId",
        "salt": "salt",
        "session_id": "sessionId",
        "template_uuid": "templateUuid",
        "token_authentication_title": "tokenAuthenticationTitle",
        "token_auth_hls_title": "tokenAuthHlsTitle",
        "token_revocation_enabled": "tokenRevocationEnabled",
        "token_revocation_title": "tokenRevocationTitle",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection:
    def __init__(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__634e955d4c81a4c74040008b2027a791104767a5700ad940066eee8989782a7a)
            check_type(argname="argument acl", value=acl, expected_type=type_hints["acl"])
            check_type(argname="argument dash_media_encryption", value=dash_media_encryption, expected_type=type_hints["dash_media_encryption"])
            check_type(argname="argument data_payload", value=data_payload, expected_type=type_hints["data_payload"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_token_in_uri", value=enable_token_in_uri, expected_type=type_hints["enable_token_in_uri"])
            check_type(argname="argument field_carry_over", value=field_carry_over, expected_type=type_hints["field_carry_over"])
            check_type(argname="argument header_for_salt", value=header_for_salt, expected_type=type_hints["header_for_salt"])
            check_type(argname="argument hls_master_manifest_files", value=hls_master_manifest_files, expected_type=type_hints["hls_master_manifest_files"])
            check_type(argname="argument hls_media_encryption", value=hls_media_encryption, expected_type=type_hints["hls_media_encryption"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_encryption_title", value=media_encryption_title, expected_type=type_hints["media_encryption_title"])
            check_type(argname="argument revoked_list_id", value=revoked_list_id, expected_type=type_hints["revoked_list_id"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument session_id", value=session_id, expected_type=type_hints["session_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authentication_title", value=token_authentication_title, expected_type=type_hints["token_authentication_title"])
            check_type(argname="argument token_auth_hls_title", value=token_auth_hls_title, expected_type=type_hints["token_auth_hls_title"])
            check_type(argname="argument token_revocation_enabled", value=token_revocation_enabled, expected_type=type_hints["token_revocation_enabled"])
            check_type(argname="argument token_revocation_title", value=token_revocation_title, expected_type=type_hints["token_revocation_title"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if acl is not None:
            self._values["acl"] = acl
        if dash_media_encryption is not None:
            self._values["dash_media_encryption"] = dash_media_encryption
        if data_payload is not None:
            self._values["data_payload"] = data_payload
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_token_in_uri is not None:
            self._values["enable_token_in_uri"] = enable_token_in_uri
        if field_carry_over is not None:
            self._values["field_carry_over"] = field_carry_over
        if header_for_salt is not None:
            self._values["header_for_salt"] = header_for_salt
        if hls_master_manifest_files is not None:
            self._values["hls_master_manifest_files"] = hls_master_manifest_files
        if hls_media_encryption is not None:
            self._values["hls_media_encryption"] = hls_media_encryption
        if ip is not None:
            self._values["ip"] = ip
        if key is not None:
            self._values["key"] = key
        if locked is not None:
            self._values["locked"] = locked
        if media_encryption_title is not None:
            self._values["media_encryption_title"] = media_encryption_title
        if revoked_list_id is not None:
            self._values["revoked_list_id"] = revoked_list_id
        if salt is not None:
            self._values["salt"] = salt
        if session_id is not None:
            self._values["session_id"] = session_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authentication_title is not None:
            self._values["token_authentication_title"] = token_authentication_title
        if token_auth_hls_title is not None:
            self._values["token_auth_hls_title"] = token_auth_hls_title
        if token_revocation_enabled is not None:
            self._values["token_revocation_enabled"] = token_revocation_enabled
        if token_revocation_title is not None:
            self._values["token_revocation_title"] = token_revocation_title
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def acl(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field.

        Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        '''
        result = self._values.get("acl")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dash_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to enable DASH Media Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        '''
        result = self._values.get("dash_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def data_payload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        '''
        result = self._values.get("data_payload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the segmented content protection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_token_in_uri(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        '''
        result = self._values.get("enable_token_in_uri")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def field_carry_over(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        '''
        result = self._values.get("field_carry_over")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_for_salt(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session.

        This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        '''
        result = self._values.get("header_for_salt")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_master_manifest_files(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of filenames that form HLS master manifest URLs.

        You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        '''
        result = self._values.get("hls_master_manifest_files")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HLS Segment Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        '''
        result = self._values.get("hls_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption key to use as a shared secret to validate tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        '''
        result = self._values.get("media_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def revoked_list_id(self) -> typing.Optional[jsii.Number]:
        '''Identifies the ``TokenAuth`` tokens to block from accessing your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        '''
        result = self._values.get("revoked_list_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt as input into the token for added security.

        This value needs to match the salt used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def session_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        '''
        result = self._values.get("session_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authentication_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        '''
        result = self._values.get("token_authentication_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_auth_hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        '''
        result = self._values.get("token_auth_hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_revocation_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        '''
        result = self._values.get("token_revocation_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def token_revocation_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        '''
        result = self._values.get("token_revocation_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify advanced ``transitionKey`` and ``salt`` options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfbdfe97a168de7f215bba44c9f704fdc666224127752a4c224c354085d10470)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcl")
    def reset_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcl", []))

    @jsii.member(jsii_name="resetDashMediaEncryption")
    def reset_dash_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDashMediaEncryption", []))

    @jsii.member(jsii_name="resetDataPayload")
    def reset_data_payload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataPayload", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableTokenInUri")
    def reset_enable_token_in_uri(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTokenInUri", []))

    @jsii.member(jsii_name="resetFieldCarryOver")
    def reset_field_carry_over(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFieldCarryOver", []))

    @jsii.member(jsii_name="resetHeaderForSalt")
    def reset_header_for_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderForSalt", []))

    @jsii.member(jsii_name="resetHlsMasterManifestFiles")
    def reset_hls_master_manifest_files(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMasterManifestFiles", []))

    @jsii.member(jsii_name="resetHlsMediaEncryption")
    def reset_hls_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMediaEncryption", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaEncryptionTitle")
    def reset_media_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaEncryptionTitle", []))

    @jsii.member(jsii_name="resetRevokedListId")
    def reset_revoked_list_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevokedListId", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetSessionId")
    def reset_session_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthenticationTitle")
    def reset_token_authentication_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthenticationTitle", []))

    @jsii.member(jsii_name="resetTokenAuthHlsTitle")
    def reset_token_auth_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthHlsTitle", []))

    @jsii.member(jsii_name="resetTokenRevocationEnabled")
    def reset_token_revocation_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationEnabled", []))

    @jsii.member(jsii_name="resetTokenRevocationTitle")
    def reset_token_revocation_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationTitle", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aclInput")
    def acl_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "aclInput"))

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryptionInput")
    def dash_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="dataPayloadInput")
    def data_payload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dataPayloadInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUriInput")
    def enable_token_in_uri_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTokenInUriInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOverInput")
    def field_carry_over_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldCarryOverInput"))

    @builtins.property
    @jsii.member(jsii_name="headerForSaltInput")
    def header_for_salt_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headerForSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFilesInput")
    def hls_master_manifest_files_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "hlsMasterManifestFilesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryptionInput")
    def hls_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitleInput")
    def media_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="revokedListIdInput")
    def revoked_list_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "revokedListIdInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionIdInput")
    def session_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitleInput")
    def token_authentication_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthenticationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitleInput")
    def token_auth_hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthHlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabledInput")
    def token_revocation_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenRevocationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitleInput")
    def token_revocation_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenRevocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acl")
    def acl(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "acl"))

    @acl.setter
    def acl(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45ed18fb7109e3ac843bdcae401236e8ae6d7784f24e9e108aab73262b1db30d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acl", value)

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryption")
    def dash_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dashMediaEncryption"))

    @dash_media_encryption.setter
    def dash_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1beee27568659ff9225f5683d70c008651402918c789f5066b01deed88c1b16f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dashMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="dataPayload")
    def data_payload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dataPayload"))

    @data_payload.setter
    def data_payload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48de9a9d9421db443064693db360edfcd00a0d30ebc51343ee6f1b3dd9d34bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataPayload", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19beae5f59ee39eb1ff94e9b93d645b4fb75424557c1647b48b9308ec6542254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUri")
    def enable_token_in_uri(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTokenInUri"))

    @enable_token_in_uri.setter
    def enable_token_in_uri(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff6c6f30a133ffc154a643b46fe27527ced39e7d24018ab771ab3f7e81f99878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTokenInUri", value)

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOver")
    def field_carry_over(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fieldCarryOver"))

    @field_carry_over.setter
    def field_carry_over(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1f38e4cb087520e706553125230ea12654b2d5f62e0a9f793613fd030f16287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fieldCarryOver", value)

    @builtins.property
    @jsii.member(jsii_name="headerForSalt")
    def header_for_salt(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headerForSalt"))

    @header_for_salt.setter
    def header_for_salt(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce40d7819034af8f905813da05b4b58cf6c7040fabd0f9b1cb891da09c910d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerForSalt", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFiles")
    def hls_master_manifest_files(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "hlsMasterManifestFiles"))

    @hls_master_manifest_files.setter
    def hls_master_manifest_files(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35107e3e37e6bb472686035f36f93de9b07dd670baf99eb2e7cb0a0afa6dca06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMasterManifestFiles", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryption")
    def hls_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsMediaEncryption"))

    @hls_media_encryption.setter
    def hls_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__430a6c7fd6cd0ac35e114a291eded880beb70de0571c8435239340d78ed04020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__906ee100a76d9fd3088ee173247c67a7f2328a8473bc678270cba87bab5116c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fad395c98bfd4c396606b8e976c41c0d279edacc85ab67f730817948f190eca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044cd188eb7cda6fc2b17fb61d84846e1aeacb3dc18180bf39abb22018852b18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitle")
    def media_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaEncryptionTitle"))

    @media_encryption_title.setter
    def media_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64a6a03dfd4264d301c6d8484337288dc9c59adbf33cdba728064f8430d3795c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="revokedListId")
    def revoked_list_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "revokedListId"))

    @revoked_list_id.setter
    def revoked_list_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6deb1bfe1a317aa8c1b29f5aefe9f69e2a0604f69417a45e047c255779ed89cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revokedListId", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e280392250008da255c4c412ada1e4370da02c26027bcb1d288d6132725967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="sessionId")
    def session_id(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionId"))

    @session_id.setter
    def session_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efd061d9351396961d9fcd3f267e4d1584798bf37cb22e80a5fa785295cca77a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5759c029885e642afba3f16f1ac19a6f405ad89e874f4c008118b5321592d347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitle")
    def token_authentication_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthenticationTitle"))

    @token_authentication_title.setter
    def token_authentication_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa9622c3ed5e53270eaf3ba48c7f8353617246f2d794a5fce6d6dd8d0e00e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthenticationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitle")
    def token_auth_hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthHlsTitle"))

    @token_auth_hls_title.setter
    def token_auth_hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7137edf0e74289f8da52856309592a242f68f2ee456f52e7c0c1a109142512db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthHlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabled")
    def token_revocation_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenRevocationEnabled"))

    @token_revocation_enabled.setter
    def token_revocation_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a807cca0a42b385a0a9dd5383ebc31374075e66167283d3ab6a473e071791d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitle")
    def token_revocation_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenRevocationTitle"))

    @token_revocation_title.setter
    def token_revocation_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fb60d4e749a96c3bf8917251d54923954fc8edfc861dc38fbf116dbaacc0ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fefa12095eb4e6a21225f7dc52820ffdb9fd765c9ed55261088b0321c0d2a674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3eaf2efe172fe168311c0c9d3b4e22e3e0e700349a58c8f249797bfbf1343d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0151a6fa07e9191dcea59b8883a4cc83cfeca8f38c556187887e1525bb755e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa0880dede9bb4032003c079eeffb50c4dbeffe4e9719afa7535988a725116a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "dvr_type": "dvrType",
        "dvr_window": "dvrWindow",
        "enable_ull_streaming": "enableUllStreaming",
        "end_time": "endTime",
        "live_type": "liveType",
        "locked": "locked",
        "show_advanced": "showAdvanced",
        "start_time": "startTime",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c30d51c78c478f64b7cdb8ce78da4788db142bbe9e2d96aedf44aefe717090)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument dvr_type", value=dvr_type, expected_type=type_hints["dvr_type"])
            check_type(argname="argument dvr_window", value=dvr_window, expected_type=type_hints["dvr_window"])
            check_type(argname="argument enable_ull_streaming", value=enable_ull_streaming, expected_type=type_hints["enable_ull_streaming"])
            check_type(argname="argument end_time", value=end_time, expected_type=type_hints["end_time"])
            check_type(argname="argument live_type", value=live_type, expected_type=type_hints["live_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument show_advanced", value=show_advanced, expected_type=type_hints["show_advanced"])
            check_type(argname="argument start_time", value=start_time, expected_type=type_hints["start_time"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if dvr_type is not None:
            self._values["dvr_type"] = dvr_type
        if dvr_window is not None:
            self._values["dvr_window"] = dvr_window
        if enable_ull_streaming is not None:
            self._values["enable_ull_streaming"] = enable_ull_streaming
        if end_time is not None:
            self._values["end_time"] = end_time
        if live_type is not None:
            self._values["live_type"] = live_type
        if locked is not None:
            self._values["locked"] = locked
        if show_advanced is not None:
            self._values["show_advanced"] = show_advanced
        if start_time is not None:
            self._values["start_time"] = start_time
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Sets the type of media content to optimize.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_type(self) -> typing.Optional[builtins.str]:
        '''The type of DVR.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        '''
        result = self._values.get("dvr_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_window(self) -> typing.Optional[builtins.str]:
        '''Set the duration for your media, or ``0m`` if a DVR is not required.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        '''
        result = self._values.get("dvr_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_ull_streaming(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        '''
        result = self._values.get("enable_ull_streaming")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def end_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event ends.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        '''
        result = self._values.get("end_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def live_type(self) -> typing.Optional[builtins.str]:
        '''The type of live media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        '''
        result = self._values.get("live_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced media options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        '''
        result = self._values.get("show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def start_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event begins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        '''
        result = self._values.get("start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15590360108d585c3d91e6fbaa5c5c1ce252d0728fe5ff529a3fc40d6542939a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetDvrType")
    def reset_dvr_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrType", []))

    @jsii.member(jsii_name="resetDvrWindow")
    def reset_dvr_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrWindow", []))

    @jsii.member(jsii_name="resetEnableUllStreaming")
    def reset_enable_ull_streaming(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableUllStreaming", []))

    @jsii.member(jsii_name="resetEndTime")
    def reset_end_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndTime", []))

    @jsii.member(jsii_name="resetLiveType")
    def reset_live_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetShowAdvanced")
    def reset_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShowAdvanced", []))

    @jsii.member(jsii_name="resetStartTime")
    def reset_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartTime", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrTypeInput")
    def dvr_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrWindowInput")
    def dvr_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="enableUllStreamingInput")
    def enable_ull_streaming_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableUllStreamingInput"))

    @builtins.property
    @jsii.member(jsii_name="endTimeInput")
    def end_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="liveTypeInput")
    def live_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "liveTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="showAdvancedInput")
    def show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "showAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="startTimeInput")
    def start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eab7ad5343a7c47c57e3635d32c067009478dd8bbb304e09ece9607b76bf119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="dvrType")
    def dvr_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrType"))

    @dvr_type.setter
    def dvr_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6089e732e2ffab8f042b5990ab8125f7992e25a9ab28d9c39c1112af85f5a833)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrType", value)

    @builtins.property
    @jsii.member(jsii_name="dvrWindow")
    def dvr_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrWindow"))

    @dvr_window.setter
    def dvr_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a44f6bb252f5619b3b96c7e2e0a63dc4a4786d25e3a049e2e0f0f16b552d36e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrWindow", value)

    @builtins.property
    @jsii.member(jsii_name="enableUllStreaming")
    def enable_ull_streaming(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableUllStreaming"))

    @enable_ull_streaming.setter
    def enable_ull_streaming(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d81bc1a74fe856551843501a0417c86f955b28d09b3e48e34b216b80c9e497f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableUllStreaming", value)

    @builtins.property
    @jsii.member(jsii_name="endTime")
    def end_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endTime"))

    @end_time.setter
    def end_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ee51f223c3f9d9722b16bbf8b49f875e27031fd212ff587d87ee2ece7766c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endTime", value)

    @builtins.property
    @jsii.member(jsii_name="liveType")
    def live_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "liveType"))

    @live_type.setter
    def live_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1cfb190fbc3e90cc1a934e0db25f67660026f75fe777aaab3e9f1ba4f2f083c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37dbfe414997eb10959c608746ab1ca3bac4246c1cad21731d4d0ebbdd3c0f62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="showAdvanced")
    def show_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "showAdvanced"))

    @show_advanced.setter
    def show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f47a7e8e7ae0201e738b574d5495616c97ae23f9d01f338cad8dbc8c219f8de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "showAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="startTime")
    def start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "startTime"))

    @start_time.setter
    def start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a7e5fa217dbf63db6bbc94fb06c7acd0cdf8d0798d2afdc4158b0a5f12765fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startTime", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df38a33ecf91ceba8dba1fda0c320851aee84c02ec4940e11d910d2cce2beae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4a3b87f7ab0ea33fd1f79f52bed808a2daa2760ca51e48f8f247ef4f81a71c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19d2b818f0fc4fc08fb05f281222449da5265dcf9e472a61b4dc0df8b241b0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901d4d46c4e368e726ebffc130ffebd0af0506ccd536a3808e16ac95d2a688f2)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables media stream prefetching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48b679e8023808c91a1bfbcc9fb2d4497097bbab1fb9a0dbb99b0ec9f888927)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad83700aa42febdce311465eec76ad644e62038b8d09f44db70975780e9e34c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f59edcf52213fff610df2828aa4b1d1ecf89642a9f097f389cd801f226d3eb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1444ef0bc506c6c9d8626c3089710258febe82a09bea1920a3e3baf22ff6ff32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f74516f388117e6473eedd3ca6aef60344bba147f288cbc0512a496b450d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9da82bef43cc43adbfa3f6898ba9f87ddf1055e263240bdbf25d0a29d6fc6bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "case_sensitive": "caseSensitive",
        "certificate_field_name": "certificateFieldName",
        "cookie_name": "cookieName",
        "device_profile": "deviceProfile",
        "encryption_key": "encryptionKey",
        "encryption_mode": "encryptionMode",
        "end_index": "endIndex",
        "except_chars": "exceptChars",
        "extract_location": "extractLocation",
        "force_chars": "forceChars",
        "format_string": "formatString",
        "generator": "generator",
        "global_substitution": "globalSubstitution",
        "header_name": "headerName",
        "hmac_algorithm": "hmacAlgorithm",
        "hmac_key": "hmacKey",
        "initialization_vector": "initializationVector",
        "ipv4_prefix": "ipv4Prefix",
        "ipv6_prefix": "ipv6Prefix",
        "ip_version": "ipVersion",
        "location_id": "locationId",
        "locked": "locked",
        "max": "max",
        "max_random_number": "maxRandomNumber",
        "min": "min",
        "min_random_number": "minRandomNumber",
        "nonce": "nonce",
        "number_of_bytes": "numberOfBytes",
        "operand_one": "operandOne",
        "param_name": "paramName",
        "path_component_offset": "pathComponentOffset",
        "prepend_bytes": "prependBytes",
        "query_parameter_name": "queryParameterName",
        "regex": "regex",
        "replacement": "replacement",
        "response_header_name": "responseHeaderName",
        "separator": "separator",
        "set_cookie_name": "setCookieName",
        "start_index": "startIndex",
        "sub_string": "subString",
        "template_uuid": "templateUuid",
        "transform": "transform",
        "uuid": "uuid",
        "value_source": "valueSource",
        "variable_name": "variableName",
        "variable_value": "variableValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[jsii.Number] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[jsii.Number] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[jsii.Number] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[jsii.Number] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f61746d998cd3e097704ad0a8a70dbeec083e336b53e3142ee9c90765bb5b8a6)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument certificate_field_name", value=certificate_field_name, expected_type=type_hints["certificate_field_name"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument device_profile", value=device_profile, expected_type=type_hints["device_profile"])
            check_type(argname="argument encryption_key", value=encryption_key, expected_type=type_hints["encryption_key"])
            check_type(argname="argument encryption_mode", value=encryption_mode, expected_type=type_hints["encryption_mode"])
            check_type(argname="argument end_index", value=end_index, expected_type=type_hints["end_index"])
            check_type(argname="argument except_chars", value=except_chars, expected_type=type_hints["except_chars"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument force_chars", value=force_chars, expected_type=type_hints["force_chars"])
            check_type(argname="argument format_string", value=format_string, expected_type=type_hints["format_string"])
            check_type(argname="argument generator", value=generator, expected_type=type_hints["generator"])
            check_type(argname="argument global_substitution", value=global_substitution, expected_type=type_hints["global_substitution"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument hmac_algorithm", value=hmac_algorithm, expected_type=type_hints["hmac_algorithm"])
            check_type(argname="argument hmac_key", value=hmac_key, expected_type=type_hints["hmac_key"])
            check_type(argname="argument initialization_vector", value=initialization_vector, expected_type=type_hints["initialization_vector"])
            check_type(argname="argument ipv4_prefix", value=ipv4_prefix, expected_type=type_hints["ipv4_prefix"])
            check_type(argname="argument ipv6_prefix", value=ipv6_prefix, expected_type=type_hints["ipv6_prefix"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max", value=max, expected_type=type_hints["max"])
            check_type(argname="argument max_random_number", value=max_random_number, expected_type=type_hints["max_random_number"])
            check_type(argname="argument min", value=min, expected_type=type_hints["min"])
            check_type(argname="argument min_random_number", value=min_random_number, expected_type=type_hints["min_random_number"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument number_of_bytes", value=number_of_bytes, expected_type=type_hints["number_of_bytes"])
            check_type(argname="argument operand_one", value=operand_one, expected_type=type_hints["operand_one"])
            check_type(argname="argument param_name", value=param_name, expected_type=type_hints["param_name"])
            check_type(argname="argument path_component_offset", value=path_component_offset, expected_type=type_hints["path_component_offset"])
            check_type(argname="argument prepend_bytes", value=prepend_bytes, expected_type=type_hints["prepend_bytes"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument replacement", value=replacement, expected_type=type_hints["replacement"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument separator", value=separator, expected_type=type_hints["separator"])
            check_type(argname="argument set_cookie_name", value=set_cookie_name, expected_type=type_hints["set_cookie_name"])
            check_type(argname="argument start_index", value=start_index, expected_type=type_hints["start_index"])
            check_type(argname="argument sub_string", value=sub_string, expected_type=type_hints["sub_string"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transform", value=transform, expected_type=type_hints["transform"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value_source", value=value_source, expected_type=type_hints["value_source"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_value", value=variable_value, expected_type=type_hints["variable_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if certificate_field_name is not None:
            self._values["certificate_field_name"] = certificate_field_name
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if device_profile is not None:
            self._values["device_profile"] = device_profile
        if encryption_key is not None:
            self._values["encryption_key"] = encryption_key
        if encryption_mode is not None:
            self._values["encryption_mode"] = encryption_mode
        if end_index is not None:
            self._values["end_index"] = end_index
        if except_chars is not None:
            self._values["except_chars"] = except_chars
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if force_chars is not None:
            self._values["force_chars"] = force_chars
        if format_string is not None:
            self._values["format_string"] = format_string
        if generator is not None:
            self._values["generator"] = generator
        if global_substitution is not None:
            self._values["global_substitution"] = global_substitution
        if header_name is not None:
            self._values["header_name"] = header_name
        if hmac_algorithm is not None:
            self._values["hmac_algorithm"] = hmac_algorithm
        if hmac_key is not None:
            self._values["hmac_key"] = hmac_key
        if initialization_vector is not None:
            self._values["initialization_vector"] = initialization_vector
        if ipv4_prefix is not None:
            self._values["ipv4_prefix"] = ipv4_prefix
        if ipv6_prefix is not None:
            self._values["ipv6_prefix"] = ipv6_prefix
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if max is not None:
            self._values["max"] = max
        if max_random_number is not None:
            self._values["max_random_number"] = max_random_number
        if min is not None:
            self._values["min"] = min
        if min_random_number is not None:
            self._values["min_random_number"] = min_random_number
        if nonce is not None:
            self._values["nonce"] = nonce
        if number_of_bytes is not None:
            self._values["number_of_bytes"] = number_of_bytes
        if operand_one is not None:
            self._values["operand_one"] = operand_one
        if param_name is not None:
            self._values["param_name"] = param_name
        if path_component_offset is not None:
            self._values["path_component_offset"] = path_component_offset
        if prepend_bytes is not None:
            self._values["prepend_bytes"] = prepend_bytes
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex is not None:
            self._values["regex"] = regex
        if replacement is not None:
            self._values["replacement"] = replacement
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if separator is not None:
            self._values["separator"] = separator
        if set_cookie_name is not None:
            self._values["set_cookie_name"] = set_cookie_name
        if start_index is not None:
            self._values["start_index"] = start_index
        if sub_string is not None:
            self._values["sub_string"] = sub_string
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transform is not None:
            self._values["transform"] = transform
        if uuid is not None:
            self._values["uuid"] = uuid
        if value_source is not None:
            self._values["value_source"] = value_source
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_value is not None:
            self._values["variable_value"] = variable_value

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this makes all matches case sensitive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def certificate_field_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the certificate's content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        '''
        result = self._values.get("certificate_field_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def device_profile(self) -> typing.Optional[builtins.str]:
        '''Specifies the client device attribute.

        Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        '''
        result = self._values.get("device_profile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption hex key.

        For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        '''
        result = self._values.get("encryption_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        '''
        result = self._values.get("encryption_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_index(self) -> typing.Optional[jsii.Number]:
        '''Specifies the zero-based character offset at the end of the substring, without including the character at that index position.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        '''
        result = self._values.get("end_index")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def except_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters ``not`` to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        '''
        result = self._values.get("except_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''This specifies from where to get the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def force_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        '''
        result = self._values.get("force_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format_string(self) -> typing.Optional[builtins.str]:
        '''Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``.

        A blank value defaults to RFC-2616 format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        '''
        result = self._values.get("format_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def generator(self) -> typing.Optional[builtins.str]:
        '''This specifies the type of value to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        '''
        result = self._values.get("generator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def global_substitution(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches in the string, not just the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        '''
        result = self._values.get("global_substitution")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to use to generate the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        '''
        result = self._values.get("hmac_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret to use in generating the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        '''
        result = self._values.get("hmac_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def initialization_vector(self) -> typing.Optional[builtins.str]:
        '''Specifies a one-time number as an initialization vector.

        It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        '''
        result = self._values.get("initialization_vector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ipv4_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV4 address, a value between 0 and 32.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        '''
        result = self._values.get("ipv4_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ipv6_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV6 address, a value between 0 and 128.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        '''
        result = self._values.get("ipv6_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the IP version under which a subnet mask generates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``X-Akamai-Edgescape`` header's field name.

        Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max(self) -> typing.Optional[jsii.Number]:
        '''Specifies a maximum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        '''
        result = self._values.get("max")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def max_random_number(self) -> typing.Optional[jsii.Number]:
        '''Specifies the upper bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        '''
        result = self._values.get("max_random_number")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min(self) -> typing.Optional[jsii.Number]:
        '''Specifies a minimum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        '''
        result = self._values.get("min")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min_random_number(self) -> typing.Optional[jsii.Number]:
        '''Specifies the lower bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        '''
        result = self._values.get("min_random_number")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the one-time number used for encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def number_of_bytes(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of random hex bytes to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        '''
        result = self._values.get("number_of_bytes")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def operand_one(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        '''
        result = self._values.get("operand_one")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def param_name(self) -> typing.Optional[builtins.str]:
        '''Extracts the value for the specified parameter name from a string that contains key/value pairs.

        (Use ``separator`` below to parse them.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        '''
        result = self._values.get("param_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def path_component_offset(self) -> typing.Optional[builtins.str]:
        '''This specifies a portion of the path.

        The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        '''
        result = self._values.get("path_component_offset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prepend_bytes(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a number of random bytes to prepend to the key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        '''
        result = self._values.get("prepend_bytes")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression pattern (PCRE) to match the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replacement(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        '''
        result = self._values.get("replacement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def separator(self) -> typing.Optional[builtins.str]:
        '''Specifies the character that separates pairs of values within the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        '''
        result = self._values.get("separator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def set_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the origin's ``Set-Cookie`` response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        '''
        result = self._values.get("set_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start_index(self) -> typing.Optional[jsii.Number]:
        '''Specifies the zero-based character offset at the start of the substring.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        '''
        result = self._values.get("start_index")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def sub_string(self) -> typing.Optional[builtins.str]:
        '''Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        '''
        result = self._values.get("sub_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transform(self) -> typing.Optional[builtins.str]:
        '''Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        '''
        result = self._values.get("transform")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_source(self) -> typing.Optional[builtins.str]:
        '''Determines how you want to set the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        '''
        result = self._values.get("value_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the predeclared root name of the variable to modify.

        When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_value(self) -> typing.Optional[builtins.str]:
        '''This directly specifies the value to assign to the variable.

        The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        result = self._values.get("variable_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__204bb95b83dd843766d86f669821be0c16aa7d3758efd4cdd710392f03f9b5f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetCertificateFieldName")
    def reset_certificate_field_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateFieldName", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDeviceProfile")
    def reset_device_profile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceProfile", []))

    @jsii.member(jsii_name="resetEncryptionKey")
    def reset_encryption_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionKey", []))

    @jsii.member(jsii_name="resetEncryptionMode")
    def reset_encryption_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionMode", []))

    @jsii.member(jsii_name="resetEndIndex")
    def reset_end_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndIndex", []))

    @jsii.member(jsii_name="resetExceptChars")
    def reset_except_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExceptChars", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetForceChars")
    def reset_force_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceChars", []))

    @jsii.member(jsii_name="resetFormatString")
    def reset_format_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatString", []))

    @jsii.member(jsii_name="resetGenerator")
    def reset_generator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGenerator", []))

    @jsii.member(jsii_name="resetGlobalSubstitution")
    def reset_global_substitution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalSubstitution", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetHmacAlgorithm")
    def reset_hmac_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacAlgorithm", []))

    @jsii.member(jsii_name="resetHmacKey")
    def reset_hmac_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacKey", []))

    @jsii.member(jsii_name="resetInitializationVector")
    def reset_initialization_vector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInitializationVector", []))

    @jsii.member(jsii_name="resetIpv4Prefix")
    def reset_ipv4_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv4Prefix", []))

    @jsii.member(jsii_name="resetIpv6Prefix")
    def reset_ipv6_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv6Prefix", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMax")
    def reset_max(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMax", []))

    @jsii.member(jsii_name="resetMaxRandomNumber")
    def reset_max_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxRandomNumber", []))

    @jsii.member(jsii_name="resetMin")
    def reset_min(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMin", []))

    @jsii.member(jsii_name="resetMinRandomNumber")
    def reset_min_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinRandomNumber", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetNumberOfBytes")
    def reset_number_of_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumberOfBytes", []))

    @jsii.member(jsii_name="resetOperandOne")
    def reset_operand_one(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperandOne", []))

    @jsii.member(jsii_name="resetParamName")
    def reset_param_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParamName", []))

    @jsii.member(jsii_name="resetPathComponentOffset")
    def reset_path_component_offset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPathComponentOffset", []))

    @jsii.member(jsii_name="resetPrependBytes")
    def reset_prepend_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrependBytes", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetReplacement")
    def reset_replacement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacement", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetSeparator")
    def reset_separator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeparator", []))

    @jsii.member(jsii_name="resetSetCookieName")
    def reset_set_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetCookieName", []))

    @jsii.member(jsii_name="resetStartIndex")
    def reset_start_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartIndex", []))

    @jsii.member(jsii_name="resetSubString")
    def reset_sub_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubString", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransform")
    def reset_transform(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransform", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValueSource")
    def reset_value_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueSource", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValue")
    def reset_variable_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValue", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldNameInput")
    def certificate_field_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldNameInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceProfileInput")
    def device_profile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deviceProfileInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionKeyInput")
    def encryption_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionModeInput")
    def encryption_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="endIndexInput")
    def end_index_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "endIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="exceptCharsInput")
    def except_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "exceptCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="forceCharsInput")
    def force_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forceCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="formatStringInput")
    def format_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatStringInput"))

    @builtins.property
    @jsii.member(jsii_name="generatorInput")
    def generator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "generatorInput"))

    @builtins.property
    @jsii.member(jsii_name="globalSubstitutionInput")
    def global_substitution_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "globalSubstitutionInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithmInput")
    def hmac_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacKeyInput")
    def hmac_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="initializationVectorInput")
    def initialization_vector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "initializationVectorInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv4PrefixInput")
    def ipv4_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv4PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv6PrefixInput")
    def ipv6_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv6PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxInput")
    def max_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxInput"))

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumberInput")
    def max_random_number_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="minInput")
    def min_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minInput"))

    @builtins.property
    @jsii.member(jsii_name="minRandomNumberInput")
    def min_random_number_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="numberOfBytesInput")
    def number_of_bytes_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numberOfBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="operandOneInput")
    def operand_one_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operandOneInput"))

    @builtins.property
    @jsii.member(jsii_name="paramNameInput")
    def param_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paramNameInput"))

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffsetInput")
    def path_component_offset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathComponentOffsetInput"))

    @builtins.property
    @jsii.member(jsii_name="prependBytesInput")
    def prepend_bytes_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prependBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementInput")
    def replacement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="separatorInput")
    def separator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "separatorInput"))

    @builtins.property
    @jsii.member(jsii_name="setCookieNameInput")
    def set_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "setCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="startIndexInput")
    def start_index_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "startIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="subStringInput")
    def sub_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subStringInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transformInput")
    def transform_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transformInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueSourceInput")
    def value_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValueInput")
    def variable_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableValueInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d56f612c376d6079ed9c7b8a0f8fec35bdc34d41aa05aafd2e3135099fbb545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40140fbac7c0d9a21a01970de5f85d712ecb6b95395c86147a440339b209b9cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="certificateFieldName")
    def certificate_field_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateFieldName"))

    @certificate_field_name.setter
    def certificate_field_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88559e1a444fd187132b2d30c2697367536ed9068a174fbed6d3a033eea8fbc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateFieldName", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927fc37512098de3f1de936becbfbc34c96b68e6b98c7831a07527ffe9210368)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="deviceProfile")
    def device_profile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deviceProfile"))

    @device_profile.setter
    def device_profile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960b2529c015768c8a2210d944be547fc2e78c0fd11bbbee5d800a02ac3741df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deviceProfile", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionKey")
    def encryption_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionKey"))

    @encryption_key.setter
    def encryption_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__859213ba9c7571aa07b0866b9a2e24dff652773d987bcb411e69a80231ad476a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionKey", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionMode")
    def encryption_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionMode"))

    @encryption_mode.setter
    def encryption_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8077093f2ebd09cf88a9edae3e152df6cd2fd0274418a7faa2a73595d60e240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionMode", value)

    @builtins.property
    @jsii.member(jsii_name="endIndex")
    def end_index(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "endIndex"))

    @end_index.setter
    def end_index(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb923dd07c058831a5ffbd7fb924488d960ed1c37dfb6d1d9be314d23bf519e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endIndex", value)

    @builtins.property
    @jsii.member(jsii_name="exceptChars")
    def except_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "exceptChars"))

    @except_chars.setter
    def except_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4077b904b8b27e329b889d2ccd6c3b97fd49894ea39004d28fc9e835b86600dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exceptChars", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fee78290817117d4c6eb0de4b5d5d154e6a1352762fe018847ce433049200a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="forceChars")
    def force_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forceChars"))

    @force_chars.setter
    def force_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311505003ea973c4ecb20d1a0c0a13ae6a783ead50b3ebd4fb715da4cd29ffe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceChars", value)

    @builtins.property
    @jsii.member(jsii_name="formatString")
    def format_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatString"))

    @format_string.setter
    def format_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a53bd95e94faa0c9443369504ae766aad944f531550b607f4ab30b5be6d8be87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatString", value)

    @builtins.property
    @jsii.member(jsii_name="generator")
    def generator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "generator"))

    @generator.setter
    def generator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a7456faa83978793a3a7df38d63fe2d4f9878c259ab108b1fec31b52c09b70d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "generator", value)

    @builtins.property
    @jsii.member(jsii_name="globalSubstitution")
    def global_substitution(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "globalSubstitution"))

    @global_substitution.setter
    def global_substitution(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecf8b4284bc94852603ff0aac168e92fb18e42173bfe208f41dd30c6c584ef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "globalSubstitution", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59194295f8bc1169523d986fe708f2bc466b143a4cb72b45b1702dbec2c6e5b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithm")
    def hmac_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacAlgorithm"))

    @hmac_algorithm.setter
    def hmac_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485f48d7199b9a7391dc2490abc4eb0e8eb09ddd516af95d311743995fef5b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hmacKey")
    def hmac_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacKey"))

    @hmac_key.setter
    def hmac_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc8c6b79ef2c4409246dd06a06bf5505236df2ac8b5c69e131c63c0f154e60e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacKey", value)

    @builtins.property
    @jsii.member(jsii_name="initializationVector")
    def initialization_vector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "initializationVector"))

    @initialization_vector.setter
    def initialization_vector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b816e71fd0fbf06cb289f1fd26342a494af05ddaf69e3a5857e7d83375a0a320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "initializationVector", value)

    @builtins.property
    @jsii.member(jsii_name="ipv4Prefix")
    def ipv4_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv4Prefix"))

    @ipv4_prefix.setter
    def ipv4_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b02071821b9e3d2f8f9539ec2e1e014643259d26098e3aeba524b5978b1a6fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv4Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipv6Prefix")
    def ipv6_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv6Prefix"))

    @ipv6_prefix.setter
    def ipv6_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71e49d636242e03257a6b431f989bdb325134cc07ca63cae7f0d9fdb375c5656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv6Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__921e16c85d7ebd45a56a19c816e388ce6457c2a60a6ee2b607e98b04050952b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e0f60f67efdfab359764670250411486c63dc3f9e5b901433188302419921f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a6cfead14c93be37468ceaf87a85b332b921e4547cfd2ff666e6c904a68ca29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="max")
    def max(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "max"))

    @max.setter
    def max(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5534e41d101b83641bc99266a82c1bd063f743deb0543f212982e3ea87454d73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "max", value)

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumber")
    def max_random_number(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxRandomNumber"))

    @max_random_number.setter
    def max_random_number(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7998fddb646be6689635881c2efe1a46851309c1ce6608121f40cb80e15ef4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="min")
    def min(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "min"))

    @min.setter
    def min(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e890c11670a44b881f3f4fa7e5e5b0a3ca87cdf7355099b7fd9882bd239225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "min", value)

    @builtins.property
    @jsii.member(jsii_name="minRandomNumber")
    def min_random_number(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "minRandomNumber"))

    @min_random_number.setter
    def min_random_number(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__353b55cb8df7149a7a2147b322be8120843133ab44303e0a28d363d888c0b103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261ed0c5f0eb5f8c392e3332fcb0fc2acd83946fdb24bceee7cc2f327574b401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="numberOfBytes")
    def number_of_bytes(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numberOfBytes"))

    @number_of_bytes.setter
    def number_of_bytes(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85dadba8803f99b94a72aef651020698303af29155604e624e30db7f313b1f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numberOfBytes", value)

    @builtins.property
    @jsii.member(jsii_name="operandOne")
    def operand_one(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operandOne"))

    @operand_one.setter
    def operand_one(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dff07736300ac1b330a2a4161065aab0d9f5d14b80f7bd1d885aaf4d112fac4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operandOne", value)

    @builtins.property
    @jsii.member(jsii_name="paramName")
    def param_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paramName"))

    @param_name.setter
    def param_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32e87340bb27f18bfc4fc1967485f9f47f2b43d6c55aa74845d7a5eeffc0fdb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paramName", value)

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffset")
    def path_component_offset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pathComponentOffset"))

    @path_component_offset.setter
    def path_component_offset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fbbef5bcb8f8950bde45476e9bfc6ca73acf1fd4fde47501c5a774a8847707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pathComponentOffset", value)

    @builtins.property
    @jsii.member(jsii_name="prependBytes")
    def prepend_bytes(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prependBytes"))

    @prepend_bytes.setter
    def prepend_bytes(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37ccb2c23a84f7e3e5234c7a522fdb1d645bd8efcfded73d7d7c864b0637ee34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prependBytes", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bd0ac42dc20537120dea8729aaa1b81085c1e0700a5bdbd509333d2d087e01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__671344acc2a188a1d7e5e4a6622ec2acd65721469ae32adc046caf6df6cc8b49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="replacement")
    def replacement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacement"))

    @replacement.setter
    def replacement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1604636b1cdb0c0176c7967490961b109b1f65712933ea5374ba3c0bd94dca39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacement", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac4d55314d858236ff8d57c97ae7c40b17fcd7a165d3ac00dddfa6363b07dd86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="separator")
    def separator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "separator"))

    @separator.setter
    def separator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c46f65c1984124e8298a7869366a2104ac0efc1ba2f0570e48554f5bf1fb0142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "separator", value)

    @builtins.property
    @jsii.member(jsii_name="setCookieName")
    def set_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "setCookieName"))

    @set_cookie_name.setter
    def set_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f88eeb084a05e15482ffc12d8c4871b741bae10b291c632b4dbcb3895a6a45b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "setCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="startIndex")
    def start_index(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "startIndex"))

    @start_index.setter
    def start_index(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__724fdcfc8831babbd254d33c1cb28711e6f324932bd371197f5e64899d9d9701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startIndex", value)

    @builtins.property
    @jsii.member(jsii_name="subString")
    def sub_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subString"))

    @sub_string.setter
    def sub_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e4eb0acf4b9924f4ae4a4da2670718cba772233710b9aa5d3bcd537bf6e389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subString", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1533a6561b8507f3f4fa4c77f573fe3e334be6b521dad4b00179797bd1b83b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transform")
    def transform(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transform"))

    @transform.setter
    def transform(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac437fa5fbda4ed956910337a02f09b12bb20c08443ffc85b9b2f47e4834a2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transform", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2794ea29dffd7a6a6f91cc4033bb891861ffafe42349559a084a19775f7e4ac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="valueSource")
    def value_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueSource"))

    @value_source.setter
    def value_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac2d2e4f214517e2b174f7d2cc0b77c7465f798c8058f53314ad185367421da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueSource", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f877cfa344494a97cf702eb5a7bd36ae7da5685696284c133e9f7820eadccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValue")
    def variable_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableValue"))

    @variable_value.setter
    def variable_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8081a29b7e7ab53700dc168a9171476250d5cf6d9fa47bf18552236f0f9452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3fcbbaf8abcd76f42fde2b80b6c558b8b5a6bbdbd12b41ec0e61c85c1ce7234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode",
    jsii_struct_bases=[],
    name_mapping={
        "error_type": "errorType",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode:
    def __init__(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3258ce02e523c55666756a5b625efd7588c9ff6056ee6060143fc8054ce44b78)
            check_type(argname="argument error_type", value=error_type, expected_type=type_hints["error_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if error_type is not None:
            self._values["error_type"] = error_type
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def error_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        '''
        result = self._values.get("error_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a9a63d210b43f5a23f40ba2ccbfecf0248e2539cff2e5ef71f695aa9a03e09)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetErrorType")
    def reset_error_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetErrorType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="errorTypeInput")
    def error_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "errorTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="errorType")
    def error_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "errorType"))

    @error_type.setter
    def error_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8546957e0a161f822c12cbcd75c835a9f24e3012a8ad0693c7ef0305a28aea61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "errorType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fad659df39435c783f7dd6e034e5ea17221c0e784eb75bd7862d6af6adc07f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59305cd51741cc2baad74366ed89fe8acfc360234c12d0ca73bbda9c6baaf866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cad00458dce07f03b86a284d8c1bddf9dac571d6e89dea1517a2bee9b43180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7459c517723a54b398af1b98415e8e3571b6e1f4de41745920738bf248d42667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c50f8b35e6b44bfc4d7d7e570905b9e3b0d3b96dbf146b2235d605138043513e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "nossmap": "nossmap",
        "ssmap": "ssmap",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(ssmap, dict):
            ssmap = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap(**ssmap)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee542c864db784d099072c9d747cf43289f9299af1a1086fecdb689756cfb7e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nossmap", value=nossmap, expected_type=type_hints["nossmap"])
            check_type(argname="argument ssmap", value=ssmap, expected_type=type_hints["ssmap"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if nossmap is not None:
            self._values["nossmap"] = nossmap
        if ssmap is not None:
            self._values["ssmap"] = ssmap
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nossmap(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        '''
        result = self._values.get("nossmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ssmap(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap"]:
        '''ssmap block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        '''
        result = self._values.get("ssmap")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692deb50af9825141f9893f89ae4e484774782e67901e816b4ca1c51b99868e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putSsmap")
    def put_ssmap(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap(
            china_cdn_map=china_cdn_map,
            has_mixed_hosts=has_mixed_hosts,
            name=name,
            src=src,
            srmap=srmap,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putSsmap", [value_]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNossmap")
    def reset_nossmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNossmap", []))

    @jsii.member(jsii_name="resetSsmap")
    def reset_ssmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSsmap", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="ssmap")
    def ssmap(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmapOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmapOutputReference", jsii.get(self, "ssmap"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nossmapInput")
    def nossmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nossmapInput"))

    @builtins.property
    @jsii.member(jsii_name="ssmapInput")
    def ssmap_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap"], jsii.get(self, "ssmapInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249e908f044e77b9a37ebdb9c938a7aca9e95859b2a4b26fff61d1e8340ca47c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nossmap")
    def nossmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nossmap"))

    @nossmap.setter
    def nossmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89e56f0cc638e4a670d1c2ecb889dcb20fd407257ede571f16a877a0039f8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nossmap", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe576a43384798807b8b99860fd273af3ed591ff6a701a1f629a9a47d2452cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76e46964865d8dbef59c067b658928eaadce92a8b197d291c086a723625e979f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4670b587c9892a509c90e1b91d9bdcf116a7d0e0f91cf60c7823b782017c29e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap",
    jsii_struct_bases=[],
    name_mapping={
        "china_cdn_map": "chinaCdnMap",
        "has_mixed_hosts": "hasMixedHosts",
        "name": "name",
        "src": "src",
        "srmap": "srmap",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap:
    def __init__(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfd87f28f45ba659603307f5a1ebb16141b281f3b0f6356d2aab8fbf094b425e)
            check_type(argname="argument china_cdn_map", value=china_cdn_map, expected_type=type_hints["china_cdn_map"])
            check_type(argname="argument has_mixed_hosts", value=has_mixed_hosts, expected_type=type_hints["has_mixed_hosts"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument src", value=src, expected_type=type_hints["src"])
            check_type(argname="argument srmap", value=srmap, expected_type=type_hints["srmap"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if china_cdn_map is not None:
            self._values["china_cdn_map"] = china_cdn_map
        if has_mixed_hosts is not None:
            self._values["has_mixed_hosts"] = has_mixed_hosts
        if name is not None:
            self._values["name"] = name
        if src is not None:
            self._values["src"] = src
        if srmap is not None:
            self._values["srmap"] = srmap
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def china_cdn_map(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.'''
        result = self._values.get("china_cdn_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def has_mixed_hosts(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.'''
        result = self._values.get("has_mixed_hosts")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def src(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.'''
        result = self._values.get("src")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def srmap(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.'''
        result = self._values.get("srmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8739797512738b9c30f1d749dda81425115bf1ccd4a1ea0bd758d91aced629e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetChinaCdnMap")
    def reset_china_cdn_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnMap", []))

    @jsii.member(jsii_name="resetHasMixedHosts")
    def reset_has_mixed_hosts(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHasMixedHosts", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetSrc")
    def reset_src(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrc", []))

    @jsii.member(jsii_name="resetSrmap")
    def reset_srmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrmap", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMapInput")
    def china_cdn_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chinaCdnMapInput"))

    @builtins.property
    @jsii.member(jsii_name="hasMixedHostsInput")
    def has_mixed_hosts_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hasMixedHostsInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="srcInput")
    def src_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srcInput"))

    @builtins.property
    @jsii.member(jsii_name="srmapInput")
    def srmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srmapInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMap")
    def china_cdn_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chinaCdnMap"))

    @china_cdn_map.setter
    def china_cdn_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__398634040002fd4b8efcadb6706f090aae8afa9d76ee2e281193d0ec949183f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chinaCdnMap", value)

    @builtins.property
    @jsii.member(jsii_name="hasMixedHosts")
    def has_mixed_hosts(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hasMixedHosts"))

    @has_mixed_hosts.setter
    def has_mixed_hosts(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dfb1bb9bdb17c03d339c2047bca202b98ccb0a94ae3232727b12fd09f4afeca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hasMixedHosts", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__febb9a3ef5c0a3a5120de0e0f9976bca062a5fb786ca30039a9e4f78c2176002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="src")
    def src(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "src"))

    @src.setter
    def src(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1459a185712f7b4302da7b88614afc5f3cc9aa43ea41af4713aff4f6ded374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "src", value)

    @builtins.property
    @jsii.member(jsii_name="srmap")
    def srmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srmap"))

    @srmap.setter
    def srmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8577a2ec26aa7e09f10e3f8852d735df8669f7f93fb3f2c1625a9372f9d5d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srmap", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14b5320e1470053b26c8b7eec1462cb8ee69c0eda28af257e751385fa6128d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7472cf006360ad6027b68272609381dc6fbb8f601461ae448f84267532bdfec9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration",
    jsii_struct_bases=[],
    name_mapping={
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_https_upgrade": "allowHttpsUpgrade",
        "cache_sharing_duration": "cacheSharingDuration",
        "cache_sharing_start_time": "cacheSharingStartTime",
        "enabled": "enabled",
        "is_certificate_sni_only": "isCertificateSniOnly",
        "is_tiered_distribution_used": "isTieredDistributionUsed",
        "locked": "locked",
        "migration_duration": "migrationDuration",
        "migration_from": "migrationFrom",
        "migration_start_time": "migrationStartTime",
        "td_location": "tdLocation",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration:
    def __init__(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb870a6c794be1bff1158a90011e3e3e80b5a472563aa28cc3eadb625e4d6a21)
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_https_upgrade", value=allow_https_upgrade, expected_type=type_hints["allow_https_upgrade"])
            check_type(argname="argument cache_sharing_duration", value=cache_sharing_duration, expected_type=type_hints["cache_sharing_duration"])
            check_type(argname="argument cache_sharing_start_time", value=cache_sharing_start_time, expected_type=type_hints["cache_sharing_start_time"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_certificate_sni_only", value=is_certificate_sni_only, expected_type=type_hints["is_certificate_sni_only"])
            check_type(argname="argument is_tiered_distribution_used", value=is_tiered_distribution_used, expected_type=type_hints["is_tiered_distribution_used"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument migration_duration", value=migration_duration, expected_type=type_hints["migration_duration"])
            check_type(argname="argument migration_from", value=migration_from, expected_type=type_hints["migration_from"])
            check_type(argname="argument migration_start_time", value=migration_start_time, expected_type=type_hints["migration_start_time"])
            check_type(argname="argument td_location", value=td_location, expected_type=type_hints["td_location"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_https_upgrade is not None:
            self._values["allow_https_upgrade"] = allow_https_upgrade
        if cache_sharing_duration is not None:
            self._values["cache_sharing_duration"] = cache_sharing_duration
        if cache_sharing_start_time is not None:
            self._values["cache_sharing_start_time"] = cache_sharing_start_time
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_certificate_sni_only is not None:
            self._values["is_certificate_sni_only"] = is_certificate_sni_only
        if is_tiered_distribution_used is not None:
            self._values["is_tiered_distribution_used"] = is_tiered_distribution_used
        if locked is not None:
            self._values["locked"] = locked
        if migration_duration is not None:
            self._values["migration_duration"] = migration_duration
        if migration_from is not None:
            self._values["migration_from"] = migration_from
        if migration_start_time is not None:
            self._values["migration_start_time"] = migration_start_time
        if td_location is not None:
            self._values["td_location"] = td_location
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allow temporary downgrade of HTTPS traffic to HTTP.

        This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_https_upgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows temporary upgrade of HTTP traffic to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        '''
        result = self._values.get("allow_https_upgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_sharing_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number cache sharing days.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        '''
        result = self._values.get("cache_sharing_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cache_sharing_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start cache sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        '''
        result = self._values.get("cache_sharing_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows migration to Standard TLS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_sni_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether your new certificate is SNI-only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        '''
        result = self._values.get("is_certificate_sni_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_tiered_distribution_used(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to align traffic to various ``tieredDistribution`` areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        '''
        result = self._values.get("is_tiered_distribution_used")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of days to migrate the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        '''
        result = self._values.get("migration_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def migration_from(self) -> typing.Optional[builtins.str]:
        '''What kind of traffic you're migrating from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        '''
        result = self._values.get("migration_from")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        '''
        result = self._values.get("migration_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def td_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``tieredDistribution`` location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        '''
        result = self._values.get("td_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6332fbbe5144a49655c2e9eb0443145f4119e5a180b2f55b86ddc2bd1e1574ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowHttpsUpgrade")
    def reset_allow_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsUpgrade", []))

    @jsii.member(jsii_name="resetCacheSharingDuration")
    def reset_cache_sharing_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingDuration", []))

    @jsii.member(jsii_name="resetCacheSharingStartTime")
    def reset_cache_sharing_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingStartTime", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsCertificateSniOnly")
    def reset_is_certificate_sni_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateSniOnly", []))

    @jsii.member(jsii_name="resetIsTieredDistributionUsed")
    def reset_is_tiered_distribution_used(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsTieredDistributionUsed", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMigrationDuration")
    def reset_migration_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationDuration", []))

    @jsii.member(jsii_name="resetMigrationFrom")
    def reset_migration_from(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationFrom", []))

    @jsii.member(jsii_name="resetMigrationStartTime")
    def reset_migration_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartTime", []))

    @jsii.member(jsii_name="resetTdLocation")
    def reset_td_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTdLocation", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgradeInput")
    def allow_https_upgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDurationInput")
    def cache_sharing_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cacheSharingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTimeInput")
    def cache_sharing_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheSharingStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnlyInput")
    def is_certificate_sni_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificateSniOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsedInput")
    def is_tiered_distribution_used_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isTieredDistributionUsedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationDurationInput")
    def migration_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "migrationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationFromInput")
    def migration_from_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationFromInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartTimeInput")
    def migration_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="tdLocationInput")
    def td_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tdLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsDowngrade"))

    @allow_https_downgrade.setter
    def allow_https_downgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa2fa9dfb677ebabb4162805274af886605ed64f54d7b58d48787f6a0404638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsDowngrade", value)

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgrade")
    def allow_https_upgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsUpgrade"))

    @allow_https_upgrade.setter
    def allow_https_upgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f099539db8c1b2b2fa5985c763d1139449fcfd1b794ffda359c919c48025816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsUpgrade", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDuration")
    def cache_sharing_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cacheSharingDuration"))

    @cache_sharing_duration.setter
    def cache_sharing_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67448a83f8dcb121640bb84f91d45e008f112cab85afa8930162ce76162f14f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTime")
    def cache_sharing_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheSharingStartTime"))

    @cache_sharing_start_time.setter
    def cache_sharing_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c109ceb30cedbc0a75b9ac6b33c2dd706a178a7d85fa99f555d9dbf923e9cafb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b96592614c4f9cab9021c90144fc069a11fdd60e1f5f0b7840f871cf2fb4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnly")
    def is_certificate_sni_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificateSniOnly"))

    @is_certificate_sni_only.setter
    def is_certificate_sni_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b5aafa853faab3142aba5b20f1284a308d5e5e16ac1bc4be626b4b39f77aaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateSniOnly", value)

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsed")
    def is_tiered_distribution_used(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isTieredDistributionUsed"))

    @is_tiered_distribution_used.setter
    def is_tiered_distribution_used(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df21b39f1e2c00191a41d49da630937ec7bd267fed65a6deda0085efe83ef6fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isTieredDistributionUsed", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a78c7ff6902c8a691e1f064274fe79224ce0e05b13f4944ab1fea0111bfaca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="migrationDuration")
    def migration_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "migrationDuration"))

    @migration_duration.setter
    def migration_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a177c16593aa1ae9aa9cfadb94440e6e89d1621444f4740ef7395a25f73d058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="migrationFrom")
    def migration_from(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationFrom"))

    @migration_from.setter
    def migration_from(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003e4329d2919a8047257629158f966e014fc20d74dccecdabbe24c1a549558b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationFrom", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartTime")
    def migration_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartTime"))

    @migration_start_time.setter
    def migration_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a5886809367a3903aebf9f59b77518d3953820dc4385986fa3a189700e6aad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="tdLocation")
    def td_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tdLocation"))

    @td_location.setter
    def td_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12a027bb894fdbe8e4c2b4444b0eee56395226e4e1a0408d7321c350b2ff6aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tdLocation", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46e457a98b4b39798d53116fcf9b9c13e8530c291b2307c40510701cc158427)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf7137d3723d862c00982bd33bf77dbd8f7a49dde76c0afa7123b324ad90b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2367085ff5f4c7c3182b7d525721ad199eba5e5117dbdb3d8daa7f8015add43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "info": "info",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride:
    def __init__(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7197417a7468b10f349a49fd4cf7f88c6fe34a77a6a23e87c554d722cd83857)
            check_type(argname="argument info", value=info, expected_type=type_hints["info"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if info is not None:
            self._values["info"] = info
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def info(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        '''
        result = self._values.get("info")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fc983a5890ac26257f8c7e947946a33ac89d059a6f8699571f79ac6627ddf7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetInfo")
    def reset_info(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInfo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="infoInput")
    def info_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "infoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="info")
    def info(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "info"))

    @info.setter
    def info(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29997da27a9bad524a3e5f4fc0bfa173d097ccc3ff9f2d7105aa63d6f5097cf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "info", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d29ff046aa4367c7198ab7a3989d6e4806524c0851e7c139fe1ad89b95fefa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa5745c01cc32f26d444744782b941478f5b64ce59b2ee5778f47625cf5ef94b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275c0d77c6da2970af36cde63a2d44c7f046ee252eeb46374fc2e05bc0fada39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b8bdb537d1376d39c059320f79db075445d141c6de18ba2340940ef18374af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "strict_mode": "strictMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "valid_mode": "validMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38385d9ea995c69c1c3e916666dd0ee7b8d9c588bcf8bc12def339edcc7a4e86)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict_mode", value=strict_mode, expected_type=type_hints["strict_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument valid_mode", value=valid_mode, expected_type=type_hints["valid_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if strict_mode is not None:
            self._values["strict_mode"] = strict_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if valid_mode is not None:
            self._values["valid_mode"] = valid_mode

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF.

        When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        '''
        result = self._values.get("strict_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def valid_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines.

        When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        result = self._values.get("valid_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab4d5a39e42a386c2b057fcee0a48ca3af902d34d9bd0533a8372d154ff3579)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrictMode")
    def reset_strict_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValidMode")
    def reset_valid_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidMode", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictModeInput")
    def strict_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="validModeInput")
    def valid_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "validModeInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098768cc38eaf365f9fe1a499bc7db988a464973de9b38f325febfcb44028032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strictMode")
    def strict_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strictMode"))

    @strict_mode.setter
    def strict_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9594d702cd6e2e604d12994ce9c53976d0e43efbe4205af3ec794790f52c2f9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strictMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4f9384051451e7464bcba9b829af780347fada916e8176d5115294ab50a3d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c723cccf3076977ab996c30360df47afc285287dac521f3861075d60402a5c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="validMode")
    def valid_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "validMode"))

    @valid_mode.setter
    def valid_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311a7bf49238cab701f395492fc40f95af642bfeb1437e444af265636209f137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61488947b25d1240a5d61bb9813fd485cd0624bc4bc215340fd4990238fe867f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer",
    jsii_struct_bases=[],
    name_mapping={
        "access_control": "accessControl",
        "cache_key": "cacheKey",
        "caching": "caching",
        "content_compressor": "contentCompressor",
        "dynamic_web_content": "dynamicWebContent",
        "enabled": "enabled",
        "geo_location": "geoLocation",
        "ip": "ip",
        "large_file_delivery": "largeFileDelivery",
        "live_video_delivery": "liveVideoDelivery",
        "locked": "locked",
        "modify_path": "modifyPath",
        "on_demand_video_delivery": "onDemandVideoDelivery",
        "origin": "origin",
        "partner_domain_suffix": "partnerDomainSuffix",
        "referrer": "referrer",
        "refresh_content": "refreshContent",
        "site_failover": "siteFailover",
        "template_uuid": "templateUuid",
        "token_authorization": "tokenAuthorization",
        "uuid": "uuid",
        "web_application_firewall": "webApplicationFirewall",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer:
    def __init__(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f57c8e09d2542c51d7c6178dff8d18be1a2b3cac629eb748fb22ef019e6baa0d)
            check_type(argname="argument access_control", value=access_control, expected_type=type_hints["access_control"])
            check_type(argname="argument cache_key", value=cache_key, expected_type=type_hints["cache_key"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument content_compressor", value=content_compressor, expected_type=type_hints["content_compressor"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument geo_location", value=geo_location, expected_type=type_hints["geo_location"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument large_file_delivery", value=large_file_delivery, expected_type=type_hints["large_file_delivery"])
            check_type(argname="argument live_video_delivery", value=live_video_delivery, expected_type=type_hints["live_video_delivery"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_path", value=modify_path, expected_type=type_hints["modify_path"])
            check_type(argname="argument on_demand_video_delivery", value=on_demand_video_delivery, expected_type=type_hints["on_demand_video_delivery"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument partner_domain_suffix", value=partner_domain_suffix, expected_type=type_hints["partner_domain_suffix"])
            check_type(argname="argument referrer", value=referrer, expected_type=type_hints["referrer"])
            check_type(argname="argument refresh_content", value=refresh_content, expected_type=type_hints["refresh_content"])
            check_type(argname="argument site_failover", value=site_failover, expected_type=type_hints["site_failover"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_control is not None:
            self._values["access_control"] = access_control
        if cache_key is not None:
            self._values["cache_key"] = cache_key
        if caching is not None:
            self._values["caching"] = caching
        if content_compressor is not None:
            self._values["content_compressor"] = content_compressor
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if geo_location is not None:
            self._values["geo_location"] = geo_location
        if ip is not None:
            self._values["ip"] = ip
        if large_file_delivery is not None:
            self._values["large_file_delivery"] = large_file_delivery
        if live_video_delivery is not None:
            self._values["live_video_delivery"] = live_video_delivery
        if locked is not None:
            self._values["locked"] = locked
        if modify_path is not None:
            self._values["modify_path"] = modify_path
        if on_demand_video_delivery is not None:
            self._values["on_demand_video_delivery"] = on_demand_video_delivery
        if origin is not None:
            self._values["origin"] = origin
        if partner_domain_suffix is not None:
            self._values["partner_domain_suffix"] = partner_domain_suffix
        if referrer is not None:
            self._values["referrer"] = referrer
        if refresh_content is not None:
            self._values["refresh_content"] = refresh_content
        if site_failover is not None:
            self._values["site_failover"] = site_failover
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if uuid is not None:
            self._values["uuid"] = uuid
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall

    @builtins.property
    def access_control(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        '''
        result = self._values.get("access_control")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set which query parameters are included in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        '''
        result = self._values.get("cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies content caching rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_compressor(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows compression of subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        '''
        result = self._values.get("content_compressor")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Cloud Embed to dynamically modify your subcustomers' content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_location(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' location-based whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        '''
        result = self._values.get("geo_location")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' IP whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def large_file_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables large file delivery for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        '''
        result = self._values.get("large_file_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def live_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.'''
        result = self._values.get("live_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies a subcustomer's request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        '''
        result = self._values.get("modify_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def on_demand_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables delivery of media assets to subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        '''
        result = self._values.get("on_demand_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign origin hostnames for customers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner_domain_suffix(self) -> typing.Optional[builtins.str]:
        '''This specifies the appropriate domain suffix, which you should typically match with your property hostname.

        It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        '''
        result = self._values.get("partner_domain_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' referrer whitelists or blacklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        '''
        result = self._values.get("referrer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to reschedule when content validates for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        '''
        result = self._values.get("refresh_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def site_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure unique failover sites for each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        '''
        result = self._values.get("site_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content.

        Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic.

        Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f8a3a911df2c61750cc21cb1ddb9a22e1f267c2bb56a5d4c221b3743e2b605)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessControl")
    def reset_access_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessControl", []))

    @jsii.member(jsii_name="resetCacheKey")
    def reset_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKey", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetContentCompressor")
    def reset_content_compressor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCompressor", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGeoLocation")
    def reset_geo_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoLocation", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLargeFileDelivery")
    def reset_large_file_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileDelivery", []))

    @jsii.member(jsii_name="resetLiveVideoDelivery")
    def reset_live_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveVideoDelivery", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyPath")
    def reset_modify_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyPath", []))

    @jsii.member(jsii_name="resetOnDemandVideoDelivery")
    def reset_on_demand_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOnDemandVideoDelivery", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetPartnerDomainSuffix")
    def reset_partner_domain_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartnerDomainSuffix", []))

    @jsii.member(jsii_name="resetReferrer")
    def reset_referrer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrer", []))

    @jsii.member(jsii_name="resetRefreshContent")
    def reset_refresh_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshContent", []))

    @jsii.member(jsii_name="resetSiteFailover")
    def reset_site_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteFailover", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @builtins.property
    @jsii.member(jsii_name="accessControlInput")
    def access_control_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessControlInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyInput")
    def cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCompressorInput")
    def content_compressor_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCompressorInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="geoLocationInput")
    def geo_location_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "geoLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileDeliveryInput")
    def large_file_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "largeFileDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="liveVideoDeliveryInput")
    def live_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "liveVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyPathInput")
    def modify_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyPathInput"))

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDeliveryInput")
    def on_demand_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "onDemandVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffixInput")
    def partner_domain_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerDomainSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerInput")
    def referrer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "referrerInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshContentInput")
    def refresh_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "refreshContentInput"))

    @builtins.property
    @jsii.member(jsii_name="siteFailoverInput")
    def site_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "siteFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="accessControl")
    def access_control(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessControl"))

    @access_control.setter
    def access_control(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0637460ce6503397b0b0d1e956ce0f89cfa44a099c4078fe473b43e9ff9e0295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessControl", value)

    @builtins.property
    @jsii.member(jsii_name="cacheKey")
    def cache_key(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheKey"))

    @cache_key.setter
    def cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e39bdf298889e2a552a9a497a0c6b51b0d1b3a80f0d9d77ce129ed9563519db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caching"))

    @caching.setter
    def caching(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af63ab6c419918512d5ac681dd1c592168e9ed4654b2a54928868829d87f627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caching", value)

    @builtins.property
    @jsii.member(jsii_name="contentCompressor")
    def content_compressor(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCompressor"))

    @content_compressor.setter
    def content_compressor(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__878ea4e84ecf392cf23c79abbaa4a4cfd9874d57166be0074c97a5c6f547c98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCompressor", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicWebContent"))

    @dynamic_web_content.setter
    def dynamic_web_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74dd96fd9d40782e16ee7e1f0645c8b5bddbd8bca28c55741a046cabd0f9122f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicWebContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6aab41eb7ee71b1f4e588f6efc8331b47523197d8265acb13e188713b09ad42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="geoLocation")
    def geo_location(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "geoLocation"))

    @geo_location.setter
    def geo_location(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e6b0470c36f8cd96d23466bd9373ada8c555427af6fcda7caff860a62dd2b05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoLocation", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d802aee2579054a815870332ac381d415ec3af11289ed8aaa9f0b96d835109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="largeFileDelivery")
    def large_file_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "largeFileDelivery"))

    @large_file_delivery.setter
    def large_file_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af51aed762652017517cf3fa514e45e1cd06e1c58d64976a97a761242fda1666)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "largeFileDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="liveVideoDelivery")
    def live_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "liveVideoDelivery"))

    @live_video_delivery.setter
    def live_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__297ecaf2c540ad0bfdc5dabc1776fcc669e621b23a1af4e7a72d7583b31d0f65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb49a96fbab395dc266ef29f08d94133b2bd9141f008878e3cbf45af638e63cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyPath")
    def modify_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyPath"))

    @modify_path.setter
    def modify_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd6a50dc7ad462a174eee6309cf147302600da35ced1aa87c26172456e4c7fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyPath", value)

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDelivery")
    def on_demand_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "onDemandVideoDelivery"))

    @on_demand_video_delivery.setter
    def on_demand_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea6d382a90267bd54d63c3ce96431effe82848edd44399071936a0ab5299d8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "onDemandVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "origin"))

    @origin.setter
    def origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90ea3e4fde09838d9b4b6131ff9df6a58125ad4d93904ce74c2a5c7b839f6abe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origin", value)

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffix")
    def partner_domain_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partnerDomainSuffix"))

    @partner_domain_suffix.setter
    def partner_domain_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f5564f709d3d9ea0950307ec48a2ad083be5cd1495f953dc11c324376b9868)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partnerDomainSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="referrer")
    def referrer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "referrer"))

    @referrer.setter
    def referrer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663d4f9145c355a873324a8cea9097dab04cf88569f6d33c4983972feb21a1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrer", value)

    @builtins.property
    @jsii.member(jsii_name="refreshContent")
    def refresh_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "refreshContent"))

    @refresh_content.setter
    def refresh_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93f8f3e0e0a0db5a22ccee46e169b9c3ac4e926ede88410864debd76f04d7f88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshContent", value)

    @builtins.property
    @jsii.member(jsii_name="siteFailover")
    def site_failover(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "siteFailover"))

    @site_failover.setter
    def site_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd736bb21379be50aba5e569220eff47ebf69f8084579d3cd18893a87f18bda4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "siteFailover", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be9f5f1f2f39e849cc7fd3b1ab2de0980358a17ca3f3eb60cfd7721585590f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenAuthorization"))

    @token_authorization.setter
    def token_authorization(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c913c6a1ec3d0907cfef75ec883858edce61672f2865dcd7a6d6e0bff9cc6518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthorization", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30a99e87e136e2cded6db4f29f503e5f20c49b66c4f30df22eaedf56881821e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "webApplicationFirewall"))

    @web_application_firewall.setter
    def web_application_firewall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2354d4e47d651a9fb8a17a6e713e989bde72f4322decab54adcbc3698487cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "webApplicationFirewall", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3288cc20d9cd042a5b91994337bec0d0da804ecf37ecd5c04fce218e3abfe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute",
    jsii_struct_bases=[],
    name_mapping={
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "custom_map": "customMap",
        "custom_stat_key": "customStatKey",
        "enable_custom_key": "enableCustomKey",
        "enabled": "enabled",
        "force_ssl_forward": "forceSslForward",
        "locked": "locked",
        "race_stat_ttl": "raceStatTtl",
        "sr_download_link_title": "srDownloadLinkTitle",
        "template_uuid": "templateUuid",
        "test_object_url": "testObjectUrl",
        "to_host": "toHost",
        "to_host_status": "toHostStatus",
        "type": "type",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute:
    def __init__(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8192231a86860a9db80e92831d942e451d852357c122e378dfd81ab3b6840229)
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument custom_map", value=custom_map, expected_type=type_hints["custom_map"])
            check_type(argname="argument custom_stat_key", value=custom_stat_key, expected_type=type_hints["custom_stat_key"])
            check_type(argname="argument enable_custom_key", value=enable_custom_key, expected_type=type_hints["enable_custom_key"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_ssl_forward", value=force_ssl_forward, expected_type=type_hints["force_ssl_forward"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument race_stat_ttl", value=race_stat_ttl, expected_type=type_hints["race_stat_ttl"])
            check_type(argname="argument sr_download_link_title", value=sr_download_link_title, expected_type=type_hints["sr_download_link_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument test_object_url", value=test_object_url, expected_type=type_hints["test_object_url"])
            check_type(argname="argument to_host", value=to_host, expected_type=type_hints["to_host"])
            check_type(argname="argument to_host_status", value=to_host_status, expected_type=type_hints["to_host_status"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if custom_map is not None:
            self._values["custom_map"] = custom_map
        if custom_stat_key is not None:
            self._values["custom_stat_key"] = custom_stat_key
        if enable_custom_key is not None:
            self._values["enable_custom_key"] = enable_custom_key
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_ssl_forward is not None:
            self._values["force_ssl_forward"] = force_ssl_forward
        if locked is not None:
            self._values["locked"] = locked
        if race_stat_ttl is not None:
            self._values["race_stat_ttl"] = race_stat_ttl
        if sr_download_link_title is not None:
            self._values["sr_download_link_title"] = sr_download_link_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if test_object_url is not None:
            self._values["test_object_url"] = test_object_url
        if to_host is not None:
            self._values["to_host"] = to_host
        if to_host_status is not None:
            self._values["to_host_status"] = to_host_status
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map(self) -> typing.Optional[builtins.str]:
        '''If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        '''
        result = self._values.get("custom_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_stat_key(self) -> typing.Optional[builtins.str]:
        '''This specifies a hostname under which to cache race results.

        This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        '''
        result = self._values.get("custom_stat_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_custom_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        '''
        result = self._values.get("enable_custom_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the SureRoute behavior, to optimize delivery of non-cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_ssl_forward(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        '''
        result = self._values.get("force_ssl_forward")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def race_stat_ttl(self) -> typing.Optional[builtins.str]:
        '''Specifies the time-to-live to preserve SureRoute race results, typically ``30m``.

        If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        '''
        result = self._values.get("race_stat_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sr_download_link_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        '''
        result = self._values.get("sr_download_link_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def test_object_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the path and filename for your origin's test object to use in races to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        '''
        result = self._values.get("test_object_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host(self) -> typing.Optional[builtins.str]:
        '''If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        '''
        result = self._values.get("to_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host_status(self) -> typing.Optional[builtins.str]:
        '''Specifies which hostname to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        '''
        result = self._values.get("to_host_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of edge servers used to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRouteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRouteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16fcc1de7ceeaa24a343931574875e2562de2385b09d76edb914a3adb5f01c14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCustomMap")
    def reset_custom_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMap", []))

    @jsii.member(jsii_name="resetCustomStatKey")
    def reset_custom_stat_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatKey", []))

    @jsii.member(jsii_name="resetEnableCustomKey")
    def reset_enable_custom_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCustomKey", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceSslForward")
    def reset_force_ssl_forward(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceSslForward", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRaceStatTtl")
    def reset_race_stat_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRaceStatTtl", []))

    @jsii.member(jsii_name="resetSrDownloadLinkTitle")
    def reset_sr_download_link_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrDownloadLinkTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTestObjectUrl")
    def reset_test_object_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTestObjectUrl", []))

    @jsii.member(jsii_name="resetToHost")
    def reset_to_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHost", []))

    @jsii.member(jsii_name="resetToHostStatus")
    def reset_to_host_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHostStatus", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapInput")
    def custom_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatKeyInput")
    def custom_stat_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCustomKeyInput")
    def enable_custom_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCustomKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceSslForwardInput")
    def force_ssl_forward_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceSslForwardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="raceStatTtlInput")
    def race_stat_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "raceStatTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitleInput")
    def sr_download_link_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srDownloadLinkTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="testObjectUrlInput")
    def test_object_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "testObjectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostInput")
    def to_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostStatusInput")
    def to_host_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b56c9afb07a8f0d623212f370a4a8cf9e961304cc5e613b734b7d35319e5ed21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="customMap")
    def custom_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMap"))

    @custom_map.setter
    def custom_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f8cdff092d3d1e70c93190a9058055e0ee8c6de4fc37c393e7aad871643199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMap", value)

    @builtins.property
    @jsii.member(jsii_name="customStatKey")
    def custom_stat_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatKey"))

    @custom_stat_key.setter
    def custom_stat_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e14db805b9f75c9c8668d242a2a62d33eff958bed0f6a04816616968b3edd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatKey", value)

    @builtins.property
    @jsii.member(jsii_name="enableCustomKey")
    def enable_custom_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCustomKey"))

    @enable_custom_key.setter
    def enable_custom_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcd55275377c8c025096e021979dc1d86fe82d941a184980ce18c8d71c4b37c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCustomKey", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3721d464495002e63f1af7943df3efe64b1cf78d961a1d98dd2998eb1bf33f90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceSslForward")
    def force_ssl_forward(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceSslForward"))

    @force_ssl_forward.setter
    def force_ssl_forward(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbb1ef467e73f1fc2a891d0117fb7f989c8716ba44f2552d9e02efe3faa3c9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceSslForward", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c598fc91e1a3b3d7ef674d005772dc1115ead38bb8a3d433c8c05f448b4a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="raceStatTtl")
    def race_stat_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "raceStatTtl"))

    @race_stat_ttl.setter
    def race_stat_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee07777771dd7810e7daff85a6d6f8203d36b18fe2a3e13e3bfb6dc465c8e91b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "raceStatTtl", value)

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitle")
    def sr_download_link_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srDownloadLinkTitle"))

    @sr_download_link_title.setter
    def sr_download_link_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b2d37ef3bdde14ee08ecb3bf879762f0e0b932c1a1d21b140f1cebb786d058)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srDownloadLinkTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b268d3cbd810d842619d41befa7f09c76562c66df9c47c5729d30714241c11d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="testObjectUrl")
    def test_object_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "testObjectUrl"))

    @test_object_url.setter
    def test_object_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df61c3ce9c95be990ce17d8b244322eb24f7396716715946e3b160e72a09fd31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "testObjectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="toHost")
    def to_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHost"))

    @to_host.setter
    def to_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3fe27cd968c539671a3ace083c4da97d020f7c8401dcec9359330d562c7f303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHost", value)

    @builtins.property
    @jsii.member(jsii_name="toHostStatus")
    def to_host_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHostStatus"))

    @to_host_status.setter
    def to_host_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f22b7af576a1569b415b99c48ae8de78793556e0e1b7273eb73f879eb1d6e9c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHostStatus", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec90dcac200acdd2a4f7ec1926d065734e67350dad4b100b6eb3fc5d735cf6fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__067ca6edfee4f18bcd145ca21aeac7fe764ef093dc0954ec6ebb587d4c6c693f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460879bd456f3360acf865d25c4c36b2ddec235b79207b29fd74ddd9276e1087)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c025a63cf0ba59ebcb8928d448fac533c93e9f7ae6ab851761dd17e6927093)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b932240b78297f192e272b3180372e68d7a5a7089428b4d6983823add379656)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d17f4cb2811e199691bc64ad9767ebe6b81808f31c006330785ad56cb5ea5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6637914db18f5b151f23d2f8fff8ec063fa3bcf02a097a699202e2a0e1384ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cf8d8ab06976c5291ac3fee5b85ded4ae71238bbebbad005b73261b9c136d50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e0468eb4b80c1ef24ed0e81c5f704548c6102e06c0ffdecb17620ee491ad0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93283bd9694b47025ed3bbd8111c71dd2c2767b1b017342ba389f171da77b313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "ibm_customer_id": "ibmCustomerId",
        "limit_to_dynamic": "limitToDynamic",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ac2c3c72e7fa4e473f2447e1bf8acecb3ed8b8ad54aa6277a957ce1f10330a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument ibm_customer_id", value=ibm_customer_id, expected_type=type_hints["ibm_customer_id"])
            check_type(argname="argument limit_to_dynamic", value=limit_to_dynamic, expected_type=type_hints["limit_to_dynamic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if ibm_customer_id is not None:
            self._values["ibm_customer_id"] = ibm_customer_id
        if limit_to_dynamic is not None:
            self._values["limit_to_dynamic"] = limit_to_dynamic
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ibm_customer_id(self) -> typing.Optional[jsii.Number]:
        '''The integer identifier for the IBM Tealeaf Connector account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        '''
        result = self._values.get("ibm_customer_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_to_dynamic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Limit traffic to dynamic, uncached (``No-Store``) content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        '''
        result = self._values.get("limit_to_dynamic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeafOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeafOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f349fae839aff5f8c8c4e0bd85056702c769963282bd8ddbd96f504692ee400b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIbmCustomerId")
    def reset_ibm_customer_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIbmCustomerId", []))

    @jsii.member(jsii_name="resetLimitToDynamic")
    def reset_limit_to_dynamic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitToDynamic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerIdInput")
    def ibm_customer_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ibmCustomerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="limitToDynamicInput")
    def limit_to_dynamic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "limitToDynamicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53c6985c39777d8752c1095043e693fce7f6ed1d4ee5363c2c89e90c2f389cf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerId")
    def ibm_customer_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ibmCustomerId"))

    @ibm_customer_id.setter
    def ibm_customer_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f2766086aa9f566def0868c99ce5f39c51c34b551b75e2d1bf4948d659b6fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ibmCustomerId", value)

    @builtins.property
    @jsii.member(jsii_name="limitToDynamic")
    def limit_to_dynamic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "limitToDynamic"))

    @limit_to_dynamic.setter
    def limit_to_dynamic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3212a3e0471e4ddf3f4afa2433f1d09c21ab4823d79b3b3c7ed9a1f1794a2e38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitToDynamic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195a626dab76d7dd210b6ea2daa5bb40699ca5df1d87401004c0369f68b95ded)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a1fb588f7294aacc029d2d5c595744e89e8ba96af95e9035626bbf003d53ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c23df74506541f81a2708dd48727e5c57ec68b653e62ba1409103926016344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a02ef09459f168d7e32202c8e44ff0a080ff2fc9c1bcb7f9cfed7d6a2ebe5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85b67e2c5cdd2affa944f99ce6684066575ac94286bdf51abff8cf1e7cc93c66)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin.

        A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "allowall": "allowall",
        "enabled": "enabled",
        "locked": "locked",
        "method": "method",
        "policy": "policy",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced:
    def __init__(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715fcb3a741bc008f5750ae001b3e3dab3ce1859a10e3d3a8770e3cf454f472e)
            check_type(argname="argument allowall", value=allowall, expected_type=type_hints["allowall"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument method", value=method, expected_type=type_hints["method"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowall is not None:
            self._values["allowall"] = allowall
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if method is not None:
            self._values["method"] = method
        if policy is not None:
            self._values["policy"] = policy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allowall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.'''
        result = self._values.get("allowall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def method(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.'''
        result = self._values.get("method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.'''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe;

        ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b72710349340f8ca0f805adcec67747e2c300268fdc25c13bf0529b56e9862)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowall")
    def reset_allowall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowall", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethod")
    def reset_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethod", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowallInput")
    def allowall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowallInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodInput")
    def method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "methodInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowall")
    def allowall(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowall"))

    @allowall.setter
    def allowall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d58f8f91879502dfa9de966f20c62106be29526e1d8e7da73e5a48a1289e5a30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowall", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead99e9d697558e02ba5ba7a21f87a9203444ac0460744bd84c883088c1df636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d6fd789b0f129a0d9aba58a5231cb1dbefc8bf8d5eac58e1d2f0a09688ce81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="method")
    def method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "method"))

    @method.setter
    def method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024eb724f03472d374c4541ae8f563c57d71e21bcd3ac90a146930824096dd04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "method", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a0d5dbcb33faf16de092c75ca4779be6ed2df039d7a778f8f17ac9fa31ebae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab57dad524e5bd0204c1ae11f499fcc585bd995ffd475f6ec4347918ef5bfde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1f83a8671a6acd440cb39a1ee9030bb7281417be1c442571d7d6c972a6e9d14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4315fb6f3435bee1d9c258ddc29f9172573194d2bc29ad2679339ea053a1fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__971b9d32a7e15eae61343e8e89096380140d8b9f1c4062358432dd2912158d76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization",
    jsii_struct_bases=[],
    name_mapping={
        "cloudwrapper_map_migration_title": "cloudwrapperMapMigrationTitle",
        "custom_map_enabled": "customMapEnabled",
        "custom_map_name": "customMapName",
        "hash_algorithm": "hashAlgorithm",
        "location": "location",
        "locked": "locked",
        "map_migration_enabled": "mapMigrationEnabled",
        "migration_end_date": "migrationEndDate",
        "migration_start_date": "migrationStartDate",
        "migration_within_cw_maps_enabled": "migrationWithinCwMapsEnabled",
        "serial_end": "serialEnd",
        "serial_start": "serialStart",
        "template_uuid": "templateUuid",
        "tier1_title": "tier1Title",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization:
    def __init__(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73c7a4306dea71b109d3011d61de55d43f7cddd5fb9656f8396e972e30f3fe6b)
            check_type(argname="argument cloudwrapper_map_migration_title", value=cloudwrapper_map_migration_title, expected_type=type_hints["cloudwrapper_map_migration_title"])
            check_type(argname="argument custom_map_enabled", value=custom_map_enabled, expected_type=type_hints["custom_map_enabled"])
            check_type(argname="argument custom_map_name", value=custom_map_name, expected_type=type_hints["custom_map_name"])
            check_type(argname="argument hash_algorithm", value=hash_algorithm, expected_type=type_hints["hash_algorithm"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument map_migration_enabled", value=map_migration_enabled, expected_type=type_hints["map_migration_enabled"])
            check_type(argname="argument migration_end_date", value=migration_end_date, expected_type=type_hints["migration_end_date"])
            check_type(argname="argument migration_start_date", value=migration_start_date, expected_type=type_hints["migration_start_date"])
            check_type(argname="argument migration_within_cw_maps_enabled", value=migration_within_cw_maps_enabled, expected_type=type_hints["migration_within_cw_maps_enabled"])
            check_type(argname="argument serial_end", value=serial_end, expected_type=type_hints["serial_end"])
            check_type(argname="argument serial_start", value=serial_start, expected_type=type_hints["serial_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_title", value=tier1_title, expected_type=type_hints["tier1_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudwrapper_map_migration_title is not None:
            self._values["cloudwrapper_map_migration_title"] = cloudwrapper_map_migration_title
        if custom_map_enabled is not None:
            self._values["custom_map_enabled"] = custom_map_enabled
        if custom_map_name is not None:
            self._values["custom_map_name"] = custom_map_name
        if hash_algorithm is not None:
            self._values["hash_algorithm"] = hash_algorithm
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if map_migration_enabled is not None:
            self._values["map_migration_enabled"] = map_migration_enabled
        if migration_end_date is not None:
            self._values["migration_end_date"] = migration_end_date
        if migration_start_date is not None:
            self._values["migration_start_date"] = migration_start_date
        if migration_within_cw_maps_enabled is not None:
            self._values["migration_within_cw_maps_enabled"] = migration_within_cw_maps_enabled
        if serial_end is not None:
            self._values["serial_end"] = serial_end
        if serial_start is not None:
            self._values["serial_start"] = serial_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_title is not None:
            self._values["tier1_title"] = tier1_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudwrapper_map_migration_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        '''
        result = self._values.get("cloudwrapper_map_migration_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_map_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables custom maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        '''
        result = self._values.get("custom_map_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom map name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        '''
        result = self._values.get("custom_map_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        '''
        result = self._values.get("hash_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Location from which Cloud Wrapper migration is performed.

        User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def map_migration_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration of the custom map to Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        '''
        result = self._values.get("map_migration_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_end_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the map migration should end.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        '''
        result = self._values.get("migration_end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the map.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        '''
        result = self._values.get("migration_start_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration within Cloud Wrapper maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        '''
        result = self._values.get("migration_within_cw_maps_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_end(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial end value.

        Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        '''
        result = self._values.get("serial_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def serial_start(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial start value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        '''
        result = self._values.get("serial_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        '''
        result = self._values.get("tier1_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ecc5bd433cb614a405ddc8d1c6c44d4651e2316bb3c5bc0c40d1a17fe1eaccf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudwrapperMapMigrationTitle")
    def reset_cloudwrapper_map_migration_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudwrapperMapMigrationTitle", []))

    @jsii.member(jsii_name="resetCustomMapEnabled")
    def reset_custom_map_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapEnabled", []))

    @jsii.member(jsii_name="resetCustomMapName")
    def reset_custom_map_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapName", []))

    @jsii.member(jsii_name="resetHashAlgorithm")
    def reset_hash_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashAlgorithm", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMapMigrationEnabled")
    def reset_map_migration_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMapMigrationEnabled", []))

    @jsii.member(jsii_name="resetMigrationEndDate")
    def reset_migration_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationEndDate", []))

    @jsii.member(jsii_name="resetMigrationStartDate")
    def reset_migration_start_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartDate", []))

    @jsii.member(jsii_name="resetMigrationWithinCwMapsEnabled")
    def reset_migration_within_cw_maps_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationWithinCwMapsEnabled", []))

    @jsii.member(jsii_name="resetSerialEnd")
    def reset_serial_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialEnd", []))

    @jsii.member(jsii_name="resetSerialStart")
    def reset_serial_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1Title")
    def reset_tier1_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1Title", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitleInput")
    def cloudwrapper_map_migration_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cloudwrapperMapMigrationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapEnabledInput")
    def custom_map_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customMapEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapNameInput")
    def custom_map_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithmInput")
    def hash_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabledInput")
    def map_migration_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mapMigrationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationEndDateInput")
    def migration_end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationEndDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartDateInput")
    def migration_start_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabledInput")
    def migration_within_cw_maps_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "migrationWithinCwMapsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="serialEndInput")
    def serial_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialEndInput"))

    @builtins.property
    @jsii.member(jsii_name="serialStartInput")
    def serial_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1TitleInput")
    def tier1_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1TitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitle")
    def cloudwrapper_map_migration_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cloudwrapperMapMigrationTitle"))

    @cloudwrapper_map_migration_title.setter
    def cloudwrapper_map_migration_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc57030236a4cd3d049f34071a1f9204b0df954c48b0d887c4c44a097a1d5c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudwrapperMapMigrationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customMapEnabled")
    def custom_map_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customMapEnabled"))

    @custom_map_enabled.setter
    def custom_map_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a139140ca1288e803b1d48c153c6720a13ef9295c367b3f7f89f5196e21d6340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customMapName")
    def custom_map_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMapName"))

    @custom_map_name.setter
    def custom_map_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76db7c49ef0767332a5835dbf3000fb1e14bd6f6d9a7154531af95cbf2a7991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapName", value)

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithm")
    def hash_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashAlgorithm"))

    @hash_algorithm.setter
    def hash_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__153d34212805ca233023cc052f69f6ac129e47228e6730588b7a8756bbe0a0b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee4ee0cc4e9a895ae7df9a9a8932af7290feb217b93b96a937a8a524848e841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc425f79f88861e2bf5c645fe31eb9fc1bee445fff02360b8d092d9ba455f9c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabled")
    def map_migration_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mapMigrationEnabled"))

    @map_migration_enabled.setter
    def map_migration_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2505de756617c76a1f8314b02b13f9c19fbc77303ad3fbd6cce7602ac425f261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mapMigrationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="migrationEndDate")
    def migration_end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationEndDate"))

    @migration_end_date.setter
    def migration_end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a8c035774451048d0b20ab865d750128f634d2a3c0f3365b1755109955ee0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationEndDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartDate")
    def migration_start_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartDate"))

    @migration_start_date.setter
    def migration_start_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15dc1325860ce5b88f54ab91eef9a0756ce2161dea4c421526d4e8aeb4fd1b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabled")
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "migrationWithinCwMapsEnabled"))

    @migration_within_cw_maps_enabled.setter
    def migration_within_cw_maps_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45b89f3f6fe3c1a47ce3c6024bb9d44ae65ec3c6b86b138a71b7f512786c9fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationWithinCwMapsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="serialEnd")
    def serial_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialEnd"))

    @serial_end.setter
    def serial_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04eb88c4e536b563d14138766d1c56e1afc084b710954b0e2e597aaaf5c7097b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialEnd", value)

    @builtins.property
    @jsii.member(jsii_name="serialStart")
    def serial_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialStart"))

    @serial_start.setter
    def serial_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23d5beeb8989c5d26664aed752aa42153e0059bcaec5ac6d8f1b589d9c2bd12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3273dbfbdd344be99b02ed67043f3a6ed5a9b07e488685090af24af0debbb275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1Title")
    def tier1_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1Title"))

    @tier1_title.setter
    def tier1_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25eae0da334438b0da807c3d6c57e8be824376c67ff016cfeb1f3660d7383612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1Title", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06bfdeb6e3d1375fa52442400b6987e6f2025a5bb169840dca71746eb374cf70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6668def44e0c641b910aa3244a78b79e106a42ad66d2bf6481e73d4253eb5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dde9098bfd4324c2500089f3e19b02809190389b2d172ed3284b15dca0543e44)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cae13b97c9ab7524d82f335c6c944ff031fed73b96292b19b111ab3c8ffcdcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83b5a44d1cba838552954b108171164707c8d6a2ed2f56ee74c27776d18ee2af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48df585de58f8de55ae9cd6506f714539a452727a427c6bbe4b082f5dd089b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98cdfef6571ee16573b9ac68abe5493b18f49d5c53fb75a36d872154286a84b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fb9145d52a30c3c0d1e693c5d67a7c10c6c1a63fa96aec15d435a64d271a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ecc7634d922293fb4f6defba80ba2c53cb67e8eca7efff1355f232a25e6c81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7165a3fb1c490fb05de3880dd15a01ed7502d203bec5b41c503620b62d84146b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout, for example ``10s``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d59104d53d1696a2b81579d048bc307a7de569c456870580b7acf213e5c045ba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__804f61aa35b74be3630f61c31e0a16d432b9ca30084b8d0d14682e688c0c15c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1896fed375867e5cc86991acd20dfb904a1a1281b862c920149e71aa1ffd7158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c318fe2ebc16c2d88e963d3d3ca3f72df7022a49e84772af9210d59083da4be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5486a1270494a3739b226b9b42c217758bf314b4adc000a3a54fd92de57bf1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f5cbafcf531f70daefbadb81892d6abc28adb2f73a39d1b384e5b5a749a52d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "legal_text": "legalText",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d6e893a22171b4a16f067572b5455487b690eb8f7761a95746da9209b39971)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument legal_text", value=legal_text, expected_type=type_hints["legal_text"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if legal_text is not None:
            self._values["legal_text"] = legal_text
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract UIDs from client requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Where to extract the UID value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the HTTP header from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def legal_text(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        '''
        result = self._values.get("legal_text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the rule tree variable from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20ce0bac14009a8e216488d56c3d62c1b220185575eac48553f917969bf5c13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLegalText")
    def reset_legal_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLegalText", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="legalTextInput")
    def legal_text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "legalTextInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81e796c1e496d2c8d242b501327fd7c44177cd167b50ee8e9a45ee35b9ced5cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba8dd4fac3125e4732db19483a58a8e4c6a8ae1eaad4e26b5b6649e8effc435f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723dc2df4c859afe485924ae7b91c29e4c3db1be26dc3bea5471cbef4c3c02f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="legalText")
    def legal_text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "legalText"))

    @legal_text.setter
    def legal_text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f0715f453a0fe30ba64c2eaabec0667a6b7cc0eabb6c8ab5acc0d3f11eac4d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "legalText", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f6d7ed22cf59485450aaaf66a2eafe46ee57885668c3c7db61283395a3b375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3742af81c7138824af115425648e74298a38c7e200c507762768ac227e3f7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b850019fd2a3e5b8d032ec8bf079e3e45844d7042a543754137ebade02b456d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd9075c87d976ec4826cb48a582687ab3674635317ed6992c89a8aabb4799726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9112cf77fdeb55e380d1d6b8cae38f084dd9dcc0239b2ec415f4f67f7bb6ccef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__838ff2993489f1c9f3b804bb310030de26e3c35d414c27d9636924b95225fa0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19fbd3b5d17220065bbbec57fbefb9237a6645b8694324869c149262180a96c3)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the ETag validation behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3c1c60118e42f97e974f18a453d23a79085d8a28b6e9ce9d88dd9c79c787a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fce93319499cfdc5b1c7f4130cb331c65d31d40073ff669a5334d332f41ae63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f98ff2c6f6b3ce222af120620ee5941c74e335a2128fe2be6da9ee16e0aec5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cccb239e1b64103955e4704adf23eb993f6f99f2f1ce86188a9a111541a770a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ec7129a5b95410f6458b86ac3752bb294ea044b16bd130f8393997f03a3386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9740893bcf4ecb4b3041a2f5ff109debdc3f0637e4edbea020b0bc62aad826fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken",
    jsii_struct_bases=[],
    name_mapping={
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken:
    def __init__(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5886327dc41854536fe174c5e9ccd9a1c3af3a48ceedfbf486577763e8f3d4b)
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specify from where to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp",
    jsii_struct_bases=[],
    name_mapping={
        "authorizations": "authorizations",
        "client_id": "clientId",
        "custom_header": "customHeader",
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_authorizations": "extractAuthorizations",
        "extract_client_id": "extractClientId",
        "extract_location": "extractLocation",
        "extract_user_name": "extractUserName",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "primary_location": "primaryLocation",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "user_name": "userName",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp:
    def __init__(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195dd0a723767d52a3c214897e46ac2a848c79dc1ccae07617a540fb28f34d59)
            check_type(argname="argument authorizations", value=authorizations, expected_type=type_hints["authorizations"])
            check_type(argname="argument client_id", value=client_id, expected_type=type_hints["client_id"])
            check_type(argname="argument custom_header", value=custom_header, expected_type=type_hints["custom_header"])
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_authorizations", value=extract_authorizations, expected_type=type_hints["extract_authorizations"])
            check_type(argname="argument extract_client_id", value=extract_client_id, expected_type=type_hints["extract_client_id"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument extract_user_name", value=extract_user_name, expected_type=type_hints["extract_user_name"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument primary_location", value=primary_location, expected_type=type_hints["primary_location"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_name", value=user_name, expected_type=type_hints["user_name"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if authorizations is not None:
            self._values["authorizations"] = authorizations
        if client_id is not None:
            self._values["client_id"] = client_id
        if custom_header is not None:
            self._values["custom_header"] = custom_header
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_authorizations is not None:
            self._values["extract_authorizations"] = extract_authorizations
        if extract_client_id is not None:
            self._values["extract_client_id"] = extract_client_id
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if extract_user_name is not None:
            self._values["extract_user_name"] = extract_user_name
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if primary_location is not None:
            self._values["primary_location"] = primary_location
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_name is not None:
            self._values["user_name"] = user_name
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def authorizations(self) -> typing.Optional[builtins.str]:
        '''This specifies the authorization group name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        '''
        result = self._values.get("authorizations")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_id(self) -> typing.Optional[builtins.str]:
        '''This specifies the claim name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        '''
        result = self._values.get("client_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_header(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''The JWT value comes from the ``X-Akamai-DCP-Token`` header by default.

        Enabling this option allows you to extract it from another header name that you specify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        '''
        result = self._values.get("custom_header")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_authorizations(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the authorization groups stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        '''
        result = self._values.get("extract_authorizations")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_client_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the client ID claim name stored in JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        '''
        result = self._values.get("extract_client_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to get the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_user_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the user name stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        '''
        result = self._values.get("extract_user_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header to extract the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def primary_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the primary location to extract the JWT value from.

        If the specified option doesn't include the JWTs, the system checks the secondary one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        '''
        result = self._values.get("primary_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the user name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        '''
        result = self._values.get("user_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2580e4fadc4c94001a195b649d6da7a8cb71fb837a187eb9d3d1a3a66a2ff48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthorizations")
    def reset_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthorizations", []))

    @jsii.member(jsii_name="resetClientId")
    def reset_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientId", []))

    @jsii.member(jsii_name="resetCustomHeader")
    def reset_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeader", []))

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractAuthorizations")
    def reset_extract_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractAuthorizations", []))

    @jsii.member(jsii_name="resetExtractClientId")
    def reset_extract_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractClientId", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetExtractUserName")
    def reset_extract_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractUserName", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrimaryLocation")
    def reset_primary_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrimaryLocation", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserName")
    def reset_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserName", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authorizationsInput")
    def authorizations_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIdInput")
    def client_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderInput")
    def custom_header_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizationsInput")
    def extract_authorizations_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractAuthorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractClientIdInput")
    def extract_client_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractClientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="extractUserNameInput")
    def extract_user_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractUserNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="primaryLocationInput")
    def primary_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "primaryLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userNameInput")
    def user_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userNameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authorizations")
    def authorizations(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authorizations"))

    @authorizations.setter
    def authorizations(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e863a498b52679d0631c4ef8b45d98dc286a7ad2746f7a7580c8197272fa3c90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authorizations", value)

    @builtins.property
    @jsii.member(jsii_name="clientId")
    def client_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientId"))

    @client_id.setter
    def client_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1424068e0badfaf117f5e6cbd08b45c9f0adfcb4866c5e743c0d5b5245e120)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientId", value)

    @builtins.property
    @jsii.member(jsii_name="customHeader")
    def custom_header(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customHeader"))

    @custom_header.setter
    def custom_header(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3afca5e15279fe4e202b5334aaedb1fb96574fa874e39071b949675190ca1803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__954aadbff1fd7285ea1678421a41a4a69e6cd905c978431d31fc817dd30fa418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4823c15163b9c44778e9eb226b3d6be0c941f296d8157dd0677eace7489d4941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizations")
    def extract_authorizations(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractAuthorizations"))

    @extract_authorizations.setter
    def extract_authorizations(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23fdf3a08c206272e8c7d30a56baa8769b2618b87f0a040a1ef73500e2a76fea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractAuthorizations", value)

    @builtins.property
    @jsii.member(jsii_name="extractClientId")
    def extract_client_id(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractClientId"))

    @extract_client_id.setter
    def extract_client_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7beb890ae5144ef8d995c55e1041de33e081cdf4386842a214481c8432cbe034)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractClientId", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e66dcd3d178237b1c2edb25b0ede3429d0a711f8059d454b90905145e1174b01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="extractUserName")
    def extract_user_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractUserName"))

    @extract_user_name.setter
    def extract_user_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff0873926f14c021655c2ceb30c273d8ddac79976afad9b4b6d47dacb56723d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractUserName", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21d3a55c13752339b18085dd250278b7cef2986eb90d31cee6172ff89d48476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5b9ebbaa0b6a3834129ddd77a6e683a2a11637c585d14d1bb69eee9e6f88a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57319d7efa171a7dabf3a3338743d8dff64b9aeb8ab20bdb976a1fcf16967579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="primaryLocation")
    def primary_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "primaryLocation"))

    @primary_location.setter
    def primary_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4c7df424394eacbb2266e98cef07c7f769bab3397b6314bcd0cb1ddc2083b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "primaryLocation", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da44b7a65dbd3f06cb7914d8d06d90f990898a355acd2aba57ca1cdf0627bd51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97074f2125a9422474817a38e946e18f9a5428d83580fd8f4f35d320f9d37ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userName")
    def user_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userName"))

    @user_name.setter
    def user_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cef1f6ef6837e2fab190819645d8a2b049bacc1230e2d18f5d155ca92eba697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userName", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49dcce69379e8fdde643b7419d64d0db5b56c11612b97ee385ae1a793e7ecce8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dde3ce4a9b71e14a6d4d168fdf77f460493c6a7488a5bfc86569b17192a6c88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16754e66ccae063b671591825b7eb86a96e4f7cea53627e90c1cf5aea932c3e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312c47bd51c3d7c2c31769fdd9eb3f6e473f839bfb3836717f1dabe6fe141e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6fc3ae80c00fba6755fd58ef66af5e9460806ce3e68e9067995717b6a69c028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bca7aabe1ded43be35a04a0c765380832510994a76c717118ed3054251c540a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20f983a9d55ba32c3b413942b33d1daaad5ab8a2919011b2b9f43610849b4b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ffe04211a976fe5843f9cd221bd6b07fc4a804470e93da17d56ed659ffa4775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b231282acb28a38004f3086814a7b5385028fc4ad6d85ddd2509c1e4693c4f01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__882137dade7eaebe679d5845e66aa355e427c1b2a2e72180b6872f618aa16ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71db06dadad364590b06b44219dab24475824abe0557e5dd730ca80dee8cf9bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7f68167ab341f88f40e00a67a225b46558fff7bd552ca9aaf6c6d0dfb9d56bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb8e5936e7ff659cec3a31b51003b110c26de2929283ee1f30708e37149be949)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "escape_hmac_inputs": "escapeHmacInputs",
        "failure_response": "failureResponse",
        "ignore_query_string": "ignoreQueryString",
        "key": "key",
        "location": "location",
        "location_id": "locationId",
        "locked": "locked",
        "salt": "salt",
        "template_uuid": "templateUuid",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4776fc180944e024e7588cce9829cfa52374cd13d39f320893fa2503c7a91433)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument escape_hmac_inputs", value=escape_hmac_inputs, expected_type=type_hints["escape_hmac_inputs"])
            check_type(argname="argument failure_response", value=failure_response, expected_type=type_hints["failure_response"])
            check_type(argname="argument ignore_query_string", value=ignore_query_string, expected_type=type_hints["ignore_query_string"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if escape_hmac_inputs is not None:
            self._values["escape_hmac_inputs"] = escape_hmac_inputs
        if failure_response is not None:
            self._values["failure_response"] = failure_response
        if ignore_query_string is not None:
            self._values["ignore_query_string"] = ignore_query_string
        if key is not None:
            self._values["key"] = key
        if location is not None:
            self._values["location"] = location
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if salt is not None:
            self._values["salt"] = salt
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def escape_hmac_inputs(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''URL-escapes HMAC inputs passed in as query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        '''
        result = self._values.get("escape_hmac_inputs")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failure_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends an HTTP error when an authentication test fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        '''
        result = self._values.get("failure_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this removes the query string from the URL used to form an encryption key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        '''
        result = self._values.get("ignore_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''The shared secret used to validate tokens, which needs to match the key used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to find the token in the incoming request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a hex value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e98bd1f0b678031b5432daf7388bc37736d9d2749d90c8e16e75f3faff4d243)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetEscapeHmacInputs")
    def reset_escape_hmac_inputs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeHmacInputs", []))

    @jsii.member(jsii_name="resetFailureResponse")
    def reset_failure_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailureResponse", []))

    @jsii.member(jsii_name="resetIgnoreQueryString")
    def reset_ignore_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnoreQueryString", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputsInput")
    def escape_hmac_inputs_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeHmacInputsInput"))

    @builtins.property
    @jsii.member(jsii_name="failureResponseInput")
    def failure_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failureResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryStringInput")
    def ignore_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignoreQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765e07d4c72af9b80dc6ec5ded65cd84e7f002144208a54b93cac8d338a13ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputs")
    def escape_hmac_inputs(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeHmacInputs"))

    @escape_hmac_inputs.setter
    def escape_hmac_inputs(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e1962eb1f2441d509cf2930fac8f908eeb381397bfc8bf45e6f32398e8ec439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeHmacInputs", value)

    @builtins.property
    @jsii.member(jsii_name="failureResponse")
    def failure_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failureResponse"))

    @failure_response.setter
    def failure_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91d05c0bff959a741cb7816b175fa9e19ee1f5a713a2e628c965560228a08472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failureResponse", value)

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryString")
    def ignore_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignoreQueryString"))

    @ignore_query_string.setter
    def ignore_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bf96d96cb61313da327979d68bdc528df2be07e0148323ade9379dc4a37526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignoreQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c81f88296d2c79d56aa7386ccf02b1720c5798183b8e8af00ce872a43d5b978e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78012871b1a4398815ccaa92dd5e133bfc0ac9202b595fd5130daf026ab8ca23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d02dac2ae199731f3cf97dc0178924ce27652eb3aee9574ed6e38e447c4e31c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eace29472b4a5a467c7a50610c7d079c000b69880b5d4fd2cd9dbe23493514ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7789ae3d80ebe8e37dc0db9bcf612c6fa4aef235f4decc0b82235d40906bc3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3911cbc48cd6c6bdc4643f851de1dacd508328db7c4ea74a450c0810f2cc4ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a83c714e18453258a4a4764f607b6870987ae4850324c001c7771bff221b5a9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270cece1acc501679ab0068105d581ccc7dab8715c100704d638389ccdcf2fe9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5549e93da4849bf629e8399879b8404fbd750d9d33d328b3b072039ffe0de6e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e21f4d5e027710b9090ae88617a48569658feec0c34346a584a417699be5192c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__837458543db15625fa04c1ba89e4b32484723c1ec5706c5fd62848a2b7e771c2)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests.

        The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04673403034c6dbab99c1373b3c951c6fc9518a79f09b6802f414745fd1c3447)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfc3449e9513291707f22752ae9b51b457f2dca1e8fdc955bb9726b5f3606a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a5f343e96b1299eec883b1dc2bd2f040b801dbe121d20de2e6d80a1d14ce7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8137140003b364ef00befd11520bf0aeefb4d5b4670ef440cd80e1f466a6a35b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad3ecaba5157b69dd48d7c660c640a8597b667601ec3ebc0fd332a426119df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dee3200f4927d5ead199ebe06c17c9f01e4168a40ec2acb955366b5e6ae2db84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__187ce4be3533d0d6a896735e7c706718d936146d2acb974808cc36914844e026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b8ff0126c3d14facfd4c5197423913e21bf9d497589ca8ab7645547624418a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef6992ab13a75bbb22332b520bb48aaaa750538f278a574f03525f6c0f5c8d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30dd031a51eb047e43cc8394eea758e144633e53a2ad63ed76f1d3edcf9e6813)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c01f79ef43d7fdecc8d4aedcfbb8f97338642391f1156cd57918a48102615890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef5ba9caaa0ca97ef2fe6f09b6641a63d3380ec24f433aa5e748d5d8fbef31e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd200a98d7cb80de8406ccbd66ab2786b029405d0f8f3c881a9c66978f436bee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4126e6cf5e97816d118c75bdc06edf61140ebedc0d0d949ae450df98d57bc635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b01a6a2c5306c3cc8a41f13551e95978c851822474ea92b84fb95f640c64b3cf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be075302057f61ac07c56f61b73c670e477aafa47f8d3cd3020c7940bbfd86a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0d9fd9068eb630b91053cfeb732df369ce4a9140112d1ef5001fc4733f548c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fb6cca90abd4e0eeba5c2733d36e7f8b30a814bed054b80b69f04d58f4e556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b0affcb4eeff03d8c054e0f429cfd17880dbeaf085aedd6b864a04b429de4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151a41884e5bf4a850db936869d2cebd5b793efea5f63cf48311049c734171bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_user_cookie_advanced": "allowedUserCookieAdvanced",
        "allowed_user_cookie_automatic_salt": "allowedUserCookieAutomaticSalt",
        "allowed_user_cookie_domain": "allowedUserCookieDomain",
        "allowed_user_cookie_domain_type": "allowedUserCookieDomainType",
        "allowed_user_cookie_duration": "allowedUserCookieDuration",
        "allowed_user_cookie_enabled": "allowedUserCookieEnabled",
        "allowed_user_cookie_http_only": "allowedUserCookieHttpOnly",
        "allowed_user_cookie_label": "allowedUserCookieLabel",
        "allowed_user_cookie_management_title": "allowedUserCookieManagementTitle",
        "allowed_user_cookie_refresh": "allowedUserCookieRefresh",
        "allowed_user_cookie_salt": "allowedUserCookieSalt",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "user_identification_by_cookie": "userIdentificationByCookie",
        "user_identification_by_headers": "userIdentificationByHeaders",
        "user_identification_by_ip": "userIdentificationByIp",
        "user_identification_by_params": "userIdentificationByParams",
        "user_identification_key_cookie": "userIdentificationKeyCookie",
        "user_identification_key_headers": "userIdentificationKeyHeaders",
        "user_identification_key_params": "userIdentificationKeyParams",
        "user_identification_title": "userIdentificationTitle",
        "uuid": "uuid",
        "waiting_room_cache_ttl": "waitingRoomCacheTtl",
        "waiting_room_cookie_advanced": "waitingRoomCookieAdvanced",
        "waiting_room_cookie_automatic_salt": "waitingRoomCookieAutomaticSalt",
        "waiting_room_cookie_domain": "waitingRoomCookieDomain",
        "waiting_room_cookie_domain_type": "waitingRoomCookieDomainType",
        "waiting_room_cookie_duration": "waitingRoomCookieDuration",
        "waiting_room_cookie_enabled": "waitingRoomCookieEnabled",
        "waiting_room_cookie_http_only": "waitingRoomCookieHttpOnly",
        "waiting_room_cookie_label": "waitingRoomCookieLabel",
        "waiting_room_cookie_management_title": "waitingRoomCookieManagementTitle",
        "waiting_room_cookie_salt": "waitingRoomCookieSalt",
        "waiting_room_cookie_share_label": "waitingRoomCookieShareLabel",
        "waiting_room_cp_code": "waitingRoomCpCode",
        "waiting_room_directory": "waitingRoomDirectory",
        "waiting_room_management_title": "waitingRoomManagementTitle",
        "waiting_room_net_storage": "waitingRoomNetStorage",
        "waiting_room_status_code": "waitingRoomStatusCode",
        "waiting_room_use_cp_code": "waitingRoomUseCpCode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization:
    def __init__(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(waiting_room_cp_code, dict):
            waiting_room_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode(**waiting_room_cp_code)
        if isinstance(waiting_room_net_storage, dict):
            waiting_room_net_storage = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage(**waiting_room_net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5620aa8d0766edca6ab1089b52398955849857569591ec857cd0d42d4eb518)
            check_type(argname="argument allowed_user_cookie_advanced", value=allowed_user_cookie_advanced, expected_type=type_hints["allowed_user_cookie_advanced"])
            check_type(argname="argument allowed_user_cookie_automatic_salt", value=allowed_user_cookie_automatic_salt, expected_type=type_hints["allowed_user_cookie_automatic_salt"])
            check_type(argname="argument allowed_user_cookie_domain", value=allowed_user_cookie_domain, expected_type=type_hints["allowed_user_cookie_domain"])
            check_type(argname="argument allowed_user_cookie_domain_type", value=allowed_user_cookie_domain_type, expected_type=type_hints["allowed_user_cookie_domain_type"])
            check_type(argname="argument allowed_user_cookie_duration", value=allowed_user_cookie_duration, expected_type=type_hints["allowed_user_cookie_duration"])
            check_type(argname="argument allowed_user_cookie_enabled", value=allowed_user_cookie_enabled, expected_type=type_hints["allowed_user_cookie_enabled"])
            check_type(argname="argument allowed_user_cookie_http_only", value=allowed_user_cookie_http_only, expected_type=type_hints["allowed_user_cookie_http_only"])
            check_type(argname="argument allowed_user_cookie_label", value=allowed_user_cookie_label, expected_type=type_hints["allowed_user_cookie_label"])
            check_type(argname="argument allowed_user_cookie_management_title", value=allowed_user_cookie_management_title, expected_type=type_hints["allowed_user_cookie_management_title"])
            check_type(argname="argument allowed_user_cookie_refresh", value=allowed_user_cookie_refresh, expected_type=type_hints["allowed_user_cookie_refresh"])
            check_type(argname="argument allowed_user_cookie_salt", value=allowed_user_cookie_salt, expected_type=type_hints["allowed_user_cookie_salt"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_identification_by_cookie", value=user_identification_by_cookie, expected_type=type_hints["user_identification_by_cookie"])
            check_type(argname="argument user_identification_by_headers", value=user_identification_by_headers, expected_type=type_hints["user_identification_by_headers"])
            check_type(argname="argument user_identification_by_ip", value=user_identification_by_ip, expected_type=type_hints["user_identification_by_ip"])
            check_type(argname="argument user_identification_by_params", value=user_identification_by_params, expected_type=type_hints["user_identification_by_params"])
            check_type(argname="argument user_identification_key_cookie", value=user_identification_key_cookie, expected_type=type_hints["user_identification_key_cookie"])
            check_type(argname="argument user_identification_key_headers", value=user_identification_key_headers, expected_type=type_hints["user_identification_key_headers"])
            check_type(argname="argument user_identification_key_params", value=user_identification_key_params, expected_type=type_hints["user_identification_key_params"])
            check_type(argname="argument user_identification_title", value=user_identification_title, expected_type=type_hints["user_identification_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_cache_ttl", value=waiting_room_cache_ttl, expected_type=type_hints["waiting_room_cache_ttl"])
            check_type(argname="argument waiting_room_cookie_advanced", value=waiting_room_cookie_advanced, expected_type=type_hints["waiting_room_cookie_advanced"])
            check_type(argname="argument waiting_room_cookie_automatic_salt", value=waiting_room_cookie_automatic_salt, expected_type=type_hints["waiting_room_cookie_automatic_salt"])
            check_type(argname="argument waiting_room_cookie_domain", value=waiting_room_cookie_domain, expected_type=type_hints["waiting_room_cookie_domain"])
            check_type(argname="argument waiting_room_cookie_domain_type", value=waiting_room_cookie_domain_type, expected_type=type_hints["waiting_room_cookie_domain_type"])
            check_type(argname="argument waiting_room_cookie_duration", value=waiting_room_cookie_duration, expected_type=type_hints["waiting_room_cookie_duration"])
            check_type(argname="argument waiting_room_cookie_enabled", value=waiting_room_cookie_enabled, expected_type=type_hints["waiting_room_cookie_enabled"])
            check_type(argname="argument waiting_room_cookie_http_only", value=waiting_room_cookie_http_only, expected_type=type_hints["waiting_room_cookie_http_only"])
            check_type(argname="argument waiting_room_cookie_label", value=waiting_room_cookie_label, expected_type=type_hints["waiting_room_cookie_label"])
            check_type(argname="argument waiting_room_cookie_management_title", value=waiting_room_cookie_management_title, expected_type=type_hints["waiting_room_cookie_management_title"])
            check_type(argname="argument waiting_room_cookie_salt", value=waiting_room_cookie_salt, expected_type=type_hints["waiting_room_cookie_salt"])
            check_type(argname="argument waiting_room_cookie_share_label", value=waiting_room_cookie_share_label, expected_type=type_hints["waiting_room_cookie_share_label"])
            check_type(argname="argument waiting_room_cp_code", value=waiting_room_cp_code, expected_type=type_hints["waiting_room_cp_code"])
            check_type(argname="argument waiting_room_directory", value=waiting_room_directory, expected_type=type_hints["waiting_room_directory"])
            check_type(argname="argument waiting_room_management_title", value=waiting_room_management_title, expected_type=type_hints["waiting_room_management_title"])
            check_type(argname="argument waiting_room_net_storage", value=waiting_room_net_storage, expected_type=type_hints["waiting_room_net_storage"])
            check_type(argname="argument waiting_room_status_code", value=waiting_room_status_code, expected_type=type_hints["waiting_room_status_code"])
            check_type(argname="argument waiting_room_use_cp_code", value=waiting_room_use_cp_code, expected_type=type_hints["waiting_room_use_cp_code"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowed_user_cookie_advanced is not None:
            self._values["allowed_user_cookie_advanced"] = allowed_user_cookie_advanced
        if allowed_user_cookie_automatic_salt is not None:
            self._values["allowed_user_cookie_automatic_salt"] = allowed_user_cookie_automatic_salt
        if allowed_user_cookie_domain is not None:
            self._values["allowed_user_cookie_domain"] = allowed_user_cookie_domain
        if allowed_user_cookie_domain_type is not None:
            self._values["allowed_user_cookie_domain_type"] = allowed_user_cookie_domain_type
        if allowed_user_cookie_duration is not None:
            self._values["allowed_user_cookie_duration"] = allowed_user_cookie_duration
        if allowed_user_cookie_enabled is not None:
            self._values["allowed_user_cookie_enabled"] = allowed_user_cookie_enabled
        if allowed_user_cookie_http_only is not None:
            self._values["allowed_user_cookie_http_only"] = allowed_user_cookie_http_only
        if allowed_user_cookie_label is not None:
            self._values["allowed_user_cookie_label"] = allowed_user_cookie_label
        if allowed_user_cookie_management_title is not None:
            self._values["allowed_user_cookie_management_title"] = allowed_user_cookie_management_title
        if allowed_user_cookie_refresh is not None:
            self._values["allowed_user_cookie_refresh"] = allowed_user_cookie_refresh
        if allowed_user_cookie_salt is not None:
            self._values["allowed_user_cookie_salt"] = allowed_user_cookie_salt
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_identification_by_cookie is not None:
            self._values["user_identification_by_cookie"] = user_identification_by_cookie
        if user_identification_by_headers is not None:
            self._values["user_identification_by_headers"] = user_identification_by_headers
        if user_identification_by_ip is not None:
            self._values["user_identification_by_ip"] = user_identification_by_ip
        if user_identification_by_params is not None:
            self._values["user_identification_by_params"] = user_identification_by_params
        if user_identification_key_cookie is not None:
            self._values["user_identification_key_cookie"] = user_identification_key_cookie
        if user_identification_key_headers is not None:
            self._values["user_identification_key_headers"] = user_identification_key_headers
        if user_identification_key_params is not None:
            self._values["user_identification_key_params"] = user_identification_key_params
        if user_identification_title is not None:
            self._values["user_identification_title"] = user_identification_title
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_cache_ttl is not None:
            self._values["waiting_room_cache_ttl"] = waiting_room_cache_ttl
        if waiting_room_cookie_advanced is not None:
            self._values["waiting_room_cookie_advanced"] = waiting_room_cookie_advanced
        if waiting_room_cookie_automatic_salt is not None:
            self._values["waiting_room_cookie_automatic_salt"] = waiting_room_cookie_automatic_salt
        if waiting_room_cookie_domain is not None:
            self._values["waiting_room_cookie_domain"] = waiting_room_cookie_domain
        if waiting_room_cookie_domain_type is not None:
            self._values["waiting_room_cookie_domain_type"] = waiting_room_cookie_domain_type
        if waiting_room_cookie_duration is not None:
            self._values["waiting_room_cookie_duration"] = waiting_room_cookie_duration
        if waiting_room_cookie_enabled is not None:
            self._values["waiting_room_cookie_enabled"] = waiting_room_cookie_enabled
        if waiting_room_cookie_http_only is not None:
            self._values["waiting_room_cookie_http_only"] = waiting_room_cookie_http_only
        if waiting_room_cookie_label is not None:
            self._values["waiting_room_cookie_label"] = waiting_room_cookie_label
        if waiting_room_cookie_management_title is not None:
            self._values["waiting_room_cookie_management_title"] = waiting_room_cookie_management_title
        if waiting_room_cookie_salt is not None:
            self._values["waiting_room_cookie_salt"] = waiting_room_cookie_salt
        if waiting_room_cookie_share_label is not None:
            self._values["waiting_room_cookie_share_label"] = waiting_room_cookie_share_label
        if waiting_room_cp_code is not None:
            self._values["waiting_room_cp_code"] = waiting_room_cp_code
        if waiting_room_directory is not None:
            self._values["waiting_room_directory"] = waiting_room_directory
        if waiting_room_management_title is not None:
            self._values["waiting_room_management_title"] = waiting_room_management_title
        if waiting_room_net_storage is not None:
            self._values["waiting_room_net_storage"] = waiting_room_net_storage
        if waiting_room_status_code is not None:
            self._values["waiting_room_status_code"] = waiting_room_status_code
        if waiting_room_use_cp_code is not None:
            self._values["waiting_room_use_cp_code"] = waiting_room_use_cp_code

    @builtins.property
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets advanced configuration options for the allowed user's cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        '''
        result = self._values.get("allowed_user_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        '''
        result = self._values.get("allowed_user_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for an allowed user cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        '''
        result = self._values.get("allowed_user_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``allowedUserCookieAdvanced`` enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        '''
        result = self._values.get("allowed_user_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for the allowed user's session once allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        '''
        result = self._values.get("allowed_user_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a cookie for users who have been allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        '''
        result = self._values.get("allowed_user_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        '''
        result = self._values.get("allowed_user_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this cookie for an allowed user from others.

        The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        '''
        result = self._values.get("allowed_user_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        '''
        result = self._values.get("allowed_user_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration.

        Do not enable this option if you want to set a fixed time for all users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        '''
        result = self._values.get("allowed_user_cookie_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        '''
        result = self._values.get("allowed_user_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Visitor Prioritization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_by_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the value of a cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        '''
        result = self._values.get("user_identification_by_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        '''
        result = self._values.get("user_identification_by_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows IP addresses to identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        '''
        result = self._values.get("user_identification_by_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_params(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        '''
        result = self._values.get("user_identification_by_params")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_key_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie whose value identifies users.

        To match a user, the value of the cookie needs to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        '''
        result = self._values.get("user_identification_key_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_key_headers(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request headers whose values identify users.

        To match a user, values for all the specified headers need to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        '''
        result = self._values.get("user_identification_key_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_key_params(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request parameters whose values identify users.

        To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        '''
        result = self._values.get("user_identification_key_params")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        '''
        result = self._values.get("user_identification_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the waiting room page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        '''
        result = self._values.get("waiting_room_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        '''
        result = self._values.get("waiting_room_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        '''
        result = self._values.get("waiting_room_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        '''
        result = self._values.get("waiting_room_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        '''
        result = self._values.get("waiting_room_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for which users remain in the waiting room.

        During this time, users who refresh the waiting room page remain there.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        '''
        result = self._values.get("waiting_room_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a cookie to track a waiting room assignment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        '''
        result = self._values.get("waiting_room_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        '''
        result = self._values.get("waiting_room_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this waiting room cookie from others.

        The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        '''
        result = self._values.get("waiting_room_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        '''
        result = self._values.get("waiting_room_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        '''
        result = self._values.get("waiting_room_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        '''
        result = self._values.get("waiting_room_cookie_share_label")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        '''waiting_room_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        '''
        result = self._values.get("waiting_room_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode"], result)

    @builtins.property
    def waiting_room_directory(self) -> typing.Optional[builtins.str]:
        '''Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        '''
        result = self._values.get("waiting_room_directory")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        '''
        result = self._values.get("waiting_room_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        '''waiting_room_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        '''
        result = self._values.get("waiting_room_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage"], result)

    @builtins.property
    def waiting_room_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response code for requests sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        '''
        result = self._values.get("waiting_room_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a different CP code that tracks any requests that are sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        result = self._values.get("waiting_room_use_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38377db9da84031e56c6d2aa22e50801046f14ffc0209bc57981d5bee967eac9)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6491e2d03d7644060c3853c050727dc28fbad2d585073594f683deab608b41ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8361ed2e21c23be8a37a142f9daa8d0c61778dfc87d3e76e7ad86b41640cf1bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa9b0c8f1bf8ddc29c0d4e0d682b41177ca00b71f5c99c0b93caabb9f15b400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53fd31800e1eeeb7926297b00eeed835ff0b84823e15ff28e94617fdc4e020c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90c79ce4833345cb239c5847bc46aa14e0280e608c3169e928f2db1feec3f862)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Prioritization FIFO shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies how to set the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests.

        The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e31fe494841bbe7226322dd2515b9a121d83a8e2ead675cb27abb65c59cb238)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa08865107f0b58dc4d1bc50c3069dbffcc19bbb0f8e34e7a73e6820e6983c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f8896cfb0b6ad731df24b5becf05f657da66bd33398277d5b78c6d537e4324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e32fc87648dcdf36a586215246a47ee312ec64594226f3d92134edeff4fec4e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__121730847811e949be18f29b001be74cebd58059fc76d4b883ebae5ae24151a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afb25fdf4930eb2d4cc8421eae0225ca5cd171720695da9508b5cae4e301687a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd97bb80f5136cefa753a1c3ca554a239bb157eefe8d65981d4c0758d079fa05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95c425624c580f5751ac12348dd1d92b8f64aa1b823c8acef2bfb4f3c36a7c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b11323144255945dfda4972572859d6b2fa00d1dc4df5995bf9fda4f67c05d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48efa5dc6e3a24a1dfc5e44d052fcb0b6e2d1c9c78ff91d506d7c4f38c9814e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c698f79675bc5abfc444e2a20ba5e2d9d872ca7acedac658240599333543a506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa5f3d16ac4442d80145f05133c6c7fef4a30ba250b9b4c8f07195028bc4c3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdcdffe3a21d36f6d109e1c4f2a92c067aa2a6c80d815e6a89a6be81fb6567a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb10da5ef5ab6031972ae311199e01688d8b9dd2f292bad37cf6f1df59b846e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf41700e55575b5b508915b7058bf3b563d42e311ace10962f65548783d25dbf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandaloneOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54a828336b9d3335d2439505748b3cd1f489112f06eb55d3c8fae691c3ec4465)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7d6ee9e6ac6b9b3de4dc5753ac2116406f10218a5d8e5c584db0a3a220fedd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78349f9d62b57524bd1bb7929c951b58477e79c85c5376a143fe6824cccd18e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__864b24e5668b34d9e15f1a496e623ec1b5526f7ddff7eac71ee477800138c4d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65db1c7852c03446a1221a25af2fec460cb88ab861e4c71c853ca39f2684ca69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe27a3e969da8df88bc5352f6743f9a427375f9c04282cef4f9d247bdad7013)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putWaitingRoomCpCode")
    def put_waiting_room_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomCpCode", [value]))

    @jsii.member(jsii_name="putWaitingRoomNetStorage")
    def put_waiting_room_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomNetStorage", [value]))

    @jsii.member(jsii_name="resetAllowedUserCookieAdvanced")
    def reset_allowed_user_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAdvanced", []))

    @jsii.member(jsii_name="resetAllowedUserCookieAutomaticSalt")
    def reset_allowed_user_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomain")
    def reset_allowed_user_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomain", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomainType")
    def reset_allowed_user_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomainType", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDuration")
    def reset_allowed_user_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDuration", []))

    @jsii.member(jsii_name="resetAllowedUserCookieEnabled")
    def reset_allowed_user_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieEnabled", []))

    @jsii.member(jsii_name="resetAllowedUserCookieHttpOnly")
    def reset_allowed_user_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieHttpOnly", []))

    @jsii.member(jsii_name="resetAllowedUserCookieLabel")
    def reset_allowed_user_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieLabel", []))

    @jsii.member(jsii_name="resetAllowedUserCookieManagementTitle")
    def reset_allowed_user_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieManagementTitle", []))

    @jsii.member(jsii_name="resetAllowedUserCookieRefresh")
    def reset_allowed_user_cookie_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieRefresh", []))

    @jsii.member(jsii_name="resetAllowedUserCookieSalt")
    def reset_allowed_user_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieSalt", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserIdentificationByCookie")
    def reset_user_identification_by_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationByHeaders")
    def reset_user_identification_by_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationByIp")
    def reset_user_identification_by_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByIp", []))

    @jsii.member(jsii_name="resetUserIdentificationByParams")
    def reset_user_identification_by_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByParams", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyCookie")
    def reset_user_identification_key_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyHeaders")
    def reset_user_identification_key_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyParams")
    def reset_user_identification_key_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyParams", []))

    @jsii.member(jsii_name="resetUserIdentificationTitle")
    def reset_user_identification_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomCacheTtl")
    def reset_waiting_room_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCacheTtl", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAdvanced")
    def reset_waiting_room_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAdvanced", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAutomaticSalt")
    def reset_waiting_room_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomain")
    def reset_waiting_room_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomain", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomainType")
    def reset_waiting_room_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomainType", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDuration")
    def reset_waiting_room_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDuration", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieEnabled")
    def reset_waiting_room_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieEnabled", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieHttpOnly")
    def reset_waiting_room_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieHttpOnly", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieLabel")
    def reset_waiting_room_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieManagementTitle")
    def reset_waiting_room_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieSalt")
    def reset_waiting_room_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieShareLabel")
    def reset_waiting_room_cookie_share_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieShareLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCpCode")
    def reset_waiting_room_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCpCode", []))

    @jsii.member(jsii_name="resetWaitingRoomDirectory")
    def reset_waiting_room_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomDirectory", []))

    @jsii.member(jsii_name="resetWaitingRoomManagementTitle")
    def reset_waiting_room_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomNetStorage")
    def reset_waiting_room_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomNetStorage", []))

    @jsii.member(jsii_name="resetWaitingRoomStatusCode")
    def reset_waiting_room_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomStatusCode", []))

    @jsii.member(jsii_name="resetWaitingRoomUseCpCode")
    def reset_waiting_room_use_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomUseCpCode", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCode")
    def waiting_room_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference", jsii.get(self, "waitingRoomCpCode"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorage")
    def waiting_room_net_storage(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference", jsii.get(self, "waitingRoomNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvancedInput")
    def allowed_user_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSaltInput")
    def allowed_user_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainInput")
    def allowed_user_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainTypeInput")
    def allowed_user_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDurationInput")
    def allowed_user_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "allowedUserCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabledInput")
    def allowed_user_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnlyInput")
    def allowed_user_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabelInput")
    def allowed_user_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitleInput")
    def allowed_user_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefreshInput")
    def allowed_user_cookie_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSaltInput")
    def allowed_user_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookieInput")
    def user_identification_by_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeadersInput")
    def user_identification_by_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIpInput")
    def user_identification_by_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByIpInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParamsInput")
    def user_identification_by_params_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookieInput")
    def user_identification_key_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationKeyCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeadersInput")
    def user_identification_key_headers_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParamsInput")
    def user_identification_key_params_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitleInput")
    def user_identification_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtlInput")
    def waiting_room_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvancedInput")
    def waiting_room_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSaltInput")
    def waiting_room_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainInput")
    def waiting_room_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainTypeInput")
    def waiting_room_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDurationInput")
    def waiting_room_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabledInput")
    def waiting_room_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnlyInput")
    def waiting_room_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabelInput")
    def waiting_room_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitleInput")
    def waiting_room_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSaltInput")
    def waiting_room_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabelInput")
    def waiting_room_cookie_share_label_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieShareLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCodeInput")
    def waiting_room_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode"], jsii.get(self, "waitingRoomCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectoryInput")
    def waiting_room_directory_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitleInput")
    def waiting_room_management_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorageInput")
    def waiting_room_net_storage_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage"], jsii.get(self, "waitingRoomNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCodeInput")
    def waiting_room_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCodeInput")
    def waiting_room_use_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomUseCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvanced")
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAdvanced"))

    @allowed_user_cookie_advanced.setter
    def allowed_user_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a812d37d053b2a503ee9655b581b2d15b4e8b39b6b7a3da60ef44417e0501175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSalt")
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAutomaticSalt"))

    @allowed_user_cookie_automatic_salt.setter
    def allowed_user_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d556ec943f2cebe5b5cbec00dcfe3978a8ddf78cb0d7713c07e050a8a10a805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomain")
    def allowed_user_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomain"))

    @allowed_user_cookie_domain.setter
    def allowed_user_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6311af3d5a7e8e94a2057a0f4e1146fb0e27a1e529e98be646617ebd6d48194e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainType")
    def allowed_user_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomainType"))

    @allowed_user_cookie_domain_type.setter
    def allowed_user_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c1dbcf6419ccdace8d9c8b630a1903a7f6a0690e4ed3c1fced77924171d47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDuration")
    def allowed_user_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "allowedUserCookieDuration"))

    @allowed_user_cookie_duration.setter
    def allowed_user_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fe07432e2b548e1c5b76bc36974b57a8098666fac17d78c3a80a032f88b695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabled")
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieEnabled"))

    @allowed_user_cookie_enabled.setter
    def allowed_user_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a35c493d4814121633a99673f1df842eb358403966d2da077ffb93976e076f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnly")
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieHttpOnly"))

    @allowed_user_cookie_http_only.setter
    def allowed_user_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d0a9da0582c0c67f3438ead12bdba1c6215a52fc446999e98aa85a31b919f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabel")
    def allowed_user_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieLabel"))

    @allowed_user_cookie_label.setter
    def allowed_user_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3908d47a24b28cecfb61d8f8ebf7601b0ecfbd25553d0989bbcfe1a2e05322b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitle")
    def allowed_user_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieManagementTitle"))

    @allowed_user_cookie_management_title.setter
    def allowed_user_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ef654ec5dabb6b664aa077cda1d813344c1ccd2b3501795fc13bcf309b2b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefresh")
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieRefresh"))

    @allowed_user_cookie_refresh.setter
    def allowed_user_cookie_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8816bd8f77e9de91c1b6c2adff93d06fcdb29a7e6ca23367755e8955309f4bea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSalt")
    def allowed_user_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieSalt"))

    @allowed_user_cookie_salt.setter
    def allowed_user_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ba1d3ea5f1ef826ff127d70b54bc53a85963a9739d4d2a97d0ad0835f2f0096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1aa5fe703eb0550a5418496d17b93cc3b9ffea38b471aee03bd0cfc66d6db92f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fceceec4a770969895a71ecd7211da9669563a37afaa619cdf13d7461268400c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68645fc8982f6d676fdfe71ed9a231102eafadf1527c60cb2516b19ee7711f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookie")
    def user_identification_by_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByCookie"))

    @user_identification_by_cookie.setter
    def user_identification_by_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a064a1dbc9e08052bffded6fed76cd2e25c444a5173e0ac073c152ba6825420b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeaders")
    def user_identification_by_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByHeaders"))

    @user_identification_by_headers.setter
    def user_identification_by_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__159468e8f7a12c18523c015f4cee45434f9f8a364c4c0ae4d320b953c9ac443a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIp")
    def user_identification_by_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByIp"))

    @user_identification_by_ip.setter
    def user_identification_by_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe0e76778f3d699b54f071c9297b1101e40f4a43faf2dc12523f9517a2be198c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByIp", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParams")
    def user_identification_by_params(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByParams"))

    @user_identification_by_params.setter
    def user_identification_by_params(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f86f0f2d64c6568e86336fa2b5879e1227fe6e60d6b3ef91efd77090f59dc34f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookie")
    def user_identification_key_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationKeyCookie"))

    @user_identification_key_cookie.setter
    def user_identification_key_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7b31710c7de8cf3b80e43efea54b9df0072b93aaa6bb978ab5f7fc8fff5492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeaders")
    def user_identification_key_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyHeaders"))

    @user_identification_key_headers.setter
    def user_identification_key_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13710d0c62e274688f9d987bd075cb497ee0b68d2c14999558f9980ac399609)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParams")
    def user_identification_key_params(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyParams"))

    @user_identification_key_params.setter
    def user_identification_key_params(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88baa5cb8f57df3538e592575df79710f93add268269792a4c33c3848033e2a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitle")
    def user_identification_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationTitle"))

    @user_identification_title.setter
    def user_identification_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd6ae4ffcb6d367c11f537f3705f0944cf991a724dc30a230b0a2501a04e346a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9cc1dc7cf19d2c50778f9c1c072c4608eac961a54c67659148d30aa13ccfb70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtl")
    def waiting_room_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCacheTtl"))

    @waiting_room_cache_ttl.setter
    def waiting_room_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aefb250fb2e8f3d5e1fd85ccf891687131f8eb24b6f7a8cfdebd935268fddf62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvanced")
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAdvanced"))

    @waiting_room_cookie_advanced.setter
    def waiting_room_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f31b4f60597f9986ec6f1d919fe5538d8fb4ade3a6d41434e43a5728e7569131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSalt")
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAutomaticSalt"))

    @waiting_room_cookie_automatic_salt.setter
    def waiting_room_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbd2bb4ed69e0580e6b499cc62bf058ba2748c4dbbd076481a44ccc8d277ea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomain")
    def waiting_room_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomain"))

    @waiting_room_cookie_domain.setter
    def waiting_room_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b793895e01cd1472eb40f627bd9e012cce8d3f7c1bb42ae1d10541c872f31a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainType")
    def waiting_room_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomainType"))

    @waiting_room_cookie_domain_type.setter
    def waiting_room_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a887d99eb9c4a653c89f4ed7a050c8141391d6f9a245b00aeefa9602f5495ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDuration")
    def waiting_room_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCookieDuration"))

    @waiting_room_cookie_duration.setter
    def waiting_room_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d19cea20a374438e030cd28aaccfa524670f082045846ef67d9c402ba853c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabled")
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieEnabled"))

    @waiting_room_cookie_enabled.setter
    def waiting_room_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0eac455f70dddf3dafdd1042123116dbe90fa161a8bf8e367570d1b7224e83f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnly")
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieHttpOnly"))

    @waiting_room_cookie_http_only.setter
    def waiting_room_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f5a485c731cbeeddb728e6c9c21e82d41ca96788a986ac98d09fb0d036e182d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabel")
    def waiting_room_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieLabel"))

    @waiting_room_cookie_label.setter
    def waiting_room_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc8ae54473b57795caaad465ecdfc05de7ea1fc5265816312876caab210dd73b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitle")
    def waiting_room_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieManagementTitle"))

    @waiting_room_cookie_management_title.setter
    def waiting_room_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0925789ac67ad9a5e56e3eb4e50de09ad31587fbe2154480cf3d08327f2f455)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSalt")
    def waiting_room_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieSalt"))

    @waiting_room_cookie_salt.setter
    def waiting_room_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d9b45e2305f1d22ef32bf756b293d1b1fef5d8b9e7258bf20c6717a11c21bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabel")
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieShareLabel"))

    @waiting_room_cookie_share_label.setter
    def waiting_room_cookie_share_label(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115e88eeeab91559771e8de3b71b8c3bc135f26dc63aa2eb67c37df4b5ccc69d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieShareLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectory")
    def waiting_room_directory(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomDirectory"))

    @waiting_room_directory.setter
    def waiting_room_directory(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5718dbb03b8bc1d5397512c2e0c598b9d15c556a72b395f5dd3a52e95302d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitle")
    def waiting_room_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomManagementTitle"))

    @waiting_room_management_title.setter
    def waiting_room_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__482882dac8e011155fedc2b6d115ac491ef4ca0ef992ea67fd5f364e05956560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCode")
    def waiting_room_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomStatusCode"))

    @waiting_room_status_code.setter
    def waiting_room_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b2e4d412e084e670797e6f78cfd8d2152e0f4e0b7853d9841a74710be895e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCode")
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomUseCpCode"))

    @waiting_room_use_cp_code.setter
    def waiting_room_use_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc349c09b244a8a2d60274e741de164d3b4fa78b0c850b03c2039c1b2dffa4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomUseCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33b0f9b06d562c89a96e19d0043934ce679eeb2a8d0a5fd4439b8f6353dbbc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fdff03d05ff3be4fd4981339d2df414283690fadc60c31ad22879883e70190f)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3205f1fc06b9de9235188b5df027696b7a8a98b2099993291545e0b8e2eeb1c)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e34059e6ec4015d1468c4252e3878c7436a0bbf2c23bbdf337351e8f9d8d4d8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9ad0dd56cf4e38a7c207e89ccfb77048d397e02af354c320900395859d69877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de5d4b5e9b041afd41fc4bb1fc67c57490161280b9c98d1ccd265eac6c421367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea793832866d5e03f8340fa88ee1e2b497b64040aa392333e57f52be63f0a75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6830d0dad6140f9ed892511fc32c61d181b36b1e24be75eddd29bac4dfaaa1ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb355e837454d20dba31eacb7c8ced527b64ea0c512f02f7ec7fbdd7d5e5e89b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ab08106d72d21e1459d6d37f8af3d00a8ebda986efc21e07e2ccc9806709fa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311ae3aa13a92234049531d568ea20f957782b71626a266335def66303d0509a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebd38bff7930176d695b73810b52b4caa96a8c3c5bb65671dea3216ab84cef76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d0bf242af3fe5e1a52a682f5735514c1e51beaa7f7a52497fae252041ea238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4931dce43b1472d01569048a93cb801a1cb31f9ed3c57a2c7a5372d60b3507f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4845a57bd1865a31b7a9e14d6c50deb935410577684f99a3729e83adf86961ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c48e2fa5e144bb1f22f0b7c6ea75baa1d98dbe2d3bdaae09201751bf9bf668)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ba7c6ca42c3904e6eb5cca514bb0d36b5e075297d6a857f4e902fda1c0600e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bdd98e09e33e5c26caed433823f88fa30121b7e1ba0337074f0fc379192675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__825ac40c7ec4c52d3c304592245b946c9c6bf956024c25882eeedc3c79b964c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f18daabfe035d1ef2ad796075f1d7b99490ca0468558d42398300c71169f8cf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__393e6ad53493c625f25591ed3ec3ace1a3fadbab056e1d440898b25db4ae72d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking",
    jsii_struct_bases=[],
    name_mapping={
        "ab_variant_location": "abVariantLocation",
        "decryption_password1": "decryptionPassword1",
        "decryption_password2": "decryptionPassword2",
        "decryption_password_id1": "decryptionPasswordId1",
        "decryption_password_id2": "decryptionPasswordId2",
        "enable": "enable",
        "locked": "locked",
        "miscellaneous_settings_title": "miscellaneousSettingsTitle",
        "pattern_decryption_enable": "patternDecryptionEnable",
        "pattern_encryption_title": "patternEncryptionTitle",
        "signature_verification_enable": "signatureVerificationEnable",
        "template_uuid": "templateUuid",
        "token_signing_title": "tokenSigningTitle",
        "use_original_as_a": "useOriginalAsA",
        "uuid": "uuid",
        "verification_key_id1": "verificationKeyId1",
        "verification_key_id2": "verificationKeyId2",
        "verification_public_key1": "verificationPublicKey1",
        "verification_public_key2": "verificationPublicKey2",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking:
    def __init__(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7052a5c646c59faf16c66a86d546095216a7852c12839d80dcea4f4b952e1cca)
            check_type(argname="argument ab_variant_location", value=ab_variant_location, expected_type=type_hints["ab_variant_location"])
            check_type(argname="argument decryption_password1", value=decryption_password1, expected_type=type_hints["decryption_password1"])
            check_type(argname="argument decryption_password2", value=decryption_password2, expected_type=type_hints["decryption_password2"])
            check_type(argname="argument decryption_password_id1", value=decryption_password_id1, expected_type=type_hints["decryption_password_id1"])
            check_type(argname="argument decryption_password_id2", value=decryption_password_id2, expected_type=type_hints["decryption_password_id2"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument miscellaneous_settings_title", value=miscellaneous_settings_title, expected_type=type_hints["miscellaneous_settings_title"])
            check_type(argname="argument pattern_decryption_enable", value=pattern_decryption_enable, expected_type=type_hints["pattern_decryption_enable"])
            check_type(argname="argument pattern_encryption_title", value=pattern_encryption_title, expected_type=type_hints["pattern_encryption_title"])
            check_type(argname="argument signature_verification_enable", value=signature_verification_enable, expected_type=type_hints["signature_verification_enable"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_signing_title", value=token_signing_title, expected_type=type_hints["token_signing_title"])
            check_type(argname="argument use_original_as_a", value=use_original_as_a, expected_type=type_hints["use_original_as_a"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_key_id1", value=verification_key_id1, expected_type=type_hints["verification_key_id1"])
            check_type(argname="argument verification_key_id2", value=verification_key_id2, expected_type=type_hints["verification_key_id2"])
            check_type(argname="argument verification_public_key1", value=verification_public_key1, expected_type=type_hints["verification_public_key1"])
            check_type(argname="argument verification_public_key2", value=verification_public_key2, expected_type=type_hints["verification_public_key2"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_variant_location is not None:
            self._values["ab_variant_location"] = ab_variant_location
        if decryption_password1 is not None:
            self._values["decryption_password1"] = decryption_password1
        if decryption_password2 is not None:
            self._values["decryption_password2"] = decryption_password2
        if decryption_password_id1 is not None:
            self._values["decryption_password_id1"] = decryption_password_id1
        if decryption_password_id2 is not None:
            self._values["decryption_password_id2"] = decryption_password_id2
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if miscellaneous_settings_title is not None:
            self._values["miscellaneous_settings_title"] = miscellaneous_settings_title
        if pattern_decryption_enable is not None:
            self._values["pattern_decryption_enable"] = pattern_decryption_enable
        if pattern_encryption_title is not None:
            self._values["pattern_encryption_title"] = pattern_encryption_title
        if signature_verification_enable is not None:
            self._values["signature_verification_enable"] = signature_verification_enable
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_signing_title is not None:
            self._values["token_signing_title"] = token_signing_title
        if use_original_as_a is not None:
            self._values["use_original_as_a"] = use_original_as_a
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_key_id1 is not None:
            self._values["verification_key_id1"] = verification_key_id1
        if verification_key_id2 is not None:
            self._values["verification_key_id2"] = verification_key_id2
        if verification_public_key1 is not None:
            self._values["verification_public_key1"] = verification_public_key1
        if verification_public_key2 is not None:
            self._values["verification_public_key2"] = verification_public_key2

    @builtins.property
    def ab_variant_location(self) -> typing.Optional[builtins.str]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        '''
        result = self._values.get("ab_variant_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password1(self) -> typing.Optional[builtins.str]:
        '''Provides the primary password used to encrypt patterns in your watermarking tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        '''
        result = self._values.get("decryption_password1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password2(self) -> typing.Optional[builtins.str]:
        '''Provides the secondary password you can use to rotate passwords.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        '''
        result = self._values.get("decryption_password2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a label that corresponds to the primary password.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        '''
        result = self._values.get("decryption_password_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        '''
        result = self._values.get("decryption_password_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the watermarking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def miscellaneous_settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        '''
        result = self._values.get("miscellaneous_settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def pattern_decryption_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        '''
        result = self._values.get("pattern_decryption_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pattern_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        '''
        result = self._values.get("pattern_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signature_verification_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can verify the signature in your watermarking token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        '''
        result = self._values.get("signature_verification_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_signing_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        '''
        result = self._values.get("token_signing_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_original_as_a(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        '''
        result = self._values.get("use_original_as_a")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the first public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        '''
        result = self._values.get("verification_key_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the optional second public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        '''
        result = self._values.get("verification_key_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key1(self) -> typing.Optional[builtins.str]:
        '''Specifies the first public key in its entirety.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        '''
        result = self._values.get("verification_public_key1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key2(self) -> typing.Optional[builtins.str]:
        '''Specifies the optional second public key in its entirety. Specify a second key to enable rotation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        result = self._values.get("verification_public_key2")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarkingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarkingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ffef741049b8e04ec8a60501724c92b3b563ddb1d355d740307a67726cb7e34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbVariantLocation")
    def reset_ab_variant_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbVariantLocation", []))

    @jsii.member(jsii_name="resetDecryptionPassword1")
    def reset_decryption_password1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword1", []))

    @jsii.member(jsii_name="resetDecryptionPassword2")
    def reset_decryption_password2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword2", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId1")
    def reset_decryption_password_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId1", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId2")
    def reset_decryption_password_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId2", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMiscellaneousSettingsTitle")
    def reset_miscellaneous_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMiscellaneousSettingsTitle", []))

    @jsii.member(jsii_name="resetPatternDecryptionEnable")
    def reset_pattern_decryption_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternDecryptionEnable", []))

    @jsii.member(jsii_name="resetPatternEncryptionTitle")
    def reset_pattern_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternEncryptionTitle", []))

    @jsii.member(jsii_name="resetSignatureVerificationEnable")
    def reset_signature_verification_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignatureVerificationEnable", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenSigningTitle")
    def reset_token_signing_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenSigningTitle", []))

    @jsii.member(jsii_name="resetUseOriginalAsA")
    def reset_use_original_as_a(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOriginalAsA", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationKeyId1")
    def reset_verification_key_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId1", []))

    @jsii.member(jsii_name="resetVerificationKeyId2")
    def reset_verification_key_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId2", []))

    @jsii.member(jsii_name="resetVerificationPublicKey1")
    def reset_verification_public_key1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey1", []))

    @jsii.member(jsii_name="resetVerificationPublicKey2")
    def reset_verification_public_key2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey2", []))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocationInput")
    def ab_variant_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abVariantLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1Input")
    def decryption_password1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2Input")
    def decryption_password2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword2Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1Input")
    def decryption_password_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2Input")
    def decryption_password_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId2Input"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitleInput")
    def miscellaneous_settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "miscellaneousSettingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnableInput")
    def pattern_decryption_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "patternDecryptionEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitleInput")
    def pattern_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "patternEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnableInput")
    def signature_verification_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "signatureVerificationEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitleInput")
    def token_signing_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenSigningTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsAInput")
    def use_original_as_a_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOriginalAsAInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1Input")
    def verification_key_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2Input")
    def verification_key_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId2Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1Input")
    def verification_public_key1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2Input")
    def verification_public_key2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey2Input"))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocation")
    def ab_variant_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abVariantLocation"))

    @ab_variant_location.setter
    def ab_variant_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7417cbf5724969d7682ed0b37051773b24177c6b6f88cde1cbbe84ba56ff6e6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abVariantLocation", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1")
    def decryption_password1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword1"))

    @decryption_password1.setter
    def decryption_password1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e3f5d807e967d7375062b1ad5b72b3fd4d8b7c4d5ae470d14a2f29e97744773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2")
    def decryption_password2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword2"))

    @decryption_password2.setter
    def decryption_password2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb0472fd646a541183558777dbf17bbd3dbcef4e79cded35ee0743d13c37dbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword2", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1")
    def decryption_password_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId1"))

    @decryption_password_id1.setter
    def decryption_password_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e9b07dd9d2b4080b306fe8a09c7bcee78796e65b8cfb271f93d2a1fc3e0962)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2")
    def decryption_password_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId2"))

    @decryption_password_id2.setter
    def decryption_password_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b39f0f92d2b22dbaeabd27ea5402a8f6082b136b3e99621c657cb769999cfb7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId2", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9042a502b5becb6bca48950c04b339efbfa6aa7930b9d68fb9acdb0b95db00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67da7b9f98b99b0834f1c6e8d8229ee707c7b83fed8a720b077e50e57f49765e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitle")
    def miscellaneous_settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "miscellaneousSettingsTitle"))

    @miscellaneous_settings_title.setter
    def miscellaneous_settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6a4a8470a9696c23fc01b655724f47d08bae92302b4eabc33e01208f503ab4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "miscellaneousSettingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnable")
    def pattern_decryption_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "patternDecryptionEnable"))

    @pattern_decryption_enable.setter
    def pattern_decryption_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a48e69557d95183f82ae81cf520ce09562eb2c6346cce808bb5f6efcf470c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternDecryptionEnable", value)

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitle")
    def pattern_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "patternEncryptionTitle"))

    @pattern_encryption_title.setter
    def pattern_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f088b308a44693be225a4be56e53e9f02a9d9d8cec041b41b93c8d1250c67672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnable")
    def signature_verification_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "signatureVerificationEnable"))

    @signature_verification_enable.setter
    def signature_verification_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b88e0c4840ad2e349fdd46061426957757beaf9f62ec0e171f056c5f951a755b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signatureVerificationEnable", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__556afe4042262ef88ba7a90bfe04f4eebd5e4c35236861a0e4e6bb65d3e45476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitle")
    def token_signing_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenSigningTitle"))

    @token_signing_title.setter
    def token_signing_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8591f9b20df883dee93f97743168fdffc7d407039adaaec4747136cd03edfadb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenSigningTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsA")
    def use_original_as_a(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOriginalAsA"))

    @use_original_as_a.setter
    def use_original_as_a(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127284337914672be7578a824986fb47e3dd3427bc56b84db7a656551ea817c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOriginalAsA", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8430bdc8dc52bdf209d48e592e4355de5884630d0e2b403a17299c24379621c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1")
    def verification_key_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId1"))

    @verification_key_id1.setter
    def verification_key_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5afaf5c90fc0226f0515701e06f821fddeacf76033f561b19afdfacc152f1d2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2")
    def verification_key_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId2"))

    @verification_key_id2.setter
    def verification_key_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4550bed47490f8b08a1052487b9300e15a21104265a1e7815de838959a1c39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId2", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1")
    def verification_public_key1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey1"))

    @verification_public_key1.setter
    def verification_public_key1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96b87cb9a04fa6039d2f61fbf0e0e9ca67894c1f44678d6165b362f4efb6ff63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2")
    def verification_public_key2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey2"))

    @verification_public_key2.setter
    def verification_public_key2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7544a150a55421d7bb7b01cf01cf99486f4338b4add738fc0e72fff763cae11e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey2", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc04241a0b935f1fee2fe1669cd27b1d9834302ceecfdfeca99506e508b138f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall",
    jsii_struct_bases=[],
    name_mapping={
        "firewall_configuration": "firewallConfiguration",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall:
    def __init__(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(firewall_configuration, dict):
            firewall_configuration = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration(**firewall_configuration)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4810141d3ba351a8f757265d6485aacb1460dc0a687ac6f7af145f871f5c422)
            check_type(argname="argument firewall_configuration", value=firewall_configuration, expected_type=type_hints["firewall_configuration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if firewall_configuration is not None:
            self._values["firewall_configuration"] = firewall_configuration
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def firewall_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration"]:
        '''firewall_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        '''
        result = self._values.get("firewall_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration"], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "config_id": "configId",
        "file_name": "fileName",
        "production_status": "productionStatus",
        "production_version": "productionVersion",
        "staging_status": "stagingStatus",
        "staging_version": "stagingVersion",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration:
    def __init__(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452c889ee3e03fbafe28f990b5ed47e725f4af8bd83b15976409ec3968612464)
            check_type(argname="argument config_id", value=config_id, expected_type=type_hints["config_id"])
            check_type(argname="argument file_name", value=file_name, expected_type=type_hints["file_name"])
            check_type(argname="argument production_status", value=production_status, expected_type=type_hints["production_status"])
            check_type(argname="argument production_version", value=production_version, expected_type=type_hints["production_version"])
            check_type(argname="argument staging_status", value=staging_status, expected_type=type_hints["staging_status"])
            check_type(argname="argument staging_version", value=staging_version, expected_type=type_hints["staging_version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_id is not None:
            self._values["config_id"] = config_id
        if file_name is not None:
            self._values["file_name"] = file_name
        if production_status is not None:
            self._values["production_status"] = production_status
        if production_version is not None:
            self._values["production_version"] = production_version
        if staging_status is not None:
            self._values["staging_status"] = staging_status
        if staging_version is not None:
            self._values["staging_version"] = staging_version

    @builtins.property
    def config_id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.'''
        result = self._values.get("config_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def file_name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        '''
        result = self._values.get("file_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        '''
        result = self._values.get("production_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        '''
        result = self._values.get("production_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def staging_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        '''
        result = self._values.get("staging_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def staging_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        result = self._values.get("staging_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cb350062609b052fd2026a33ddc52a640bd84a15c25cb3a41a6e4db21ada12c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigId")
    def reset_config_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigId", []))

    @jsii.member(jsii_name="resetFileName")
    def reset_file_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileName", []))

    @jsii.member(jsii_name="resetProductionStatus")
    def reset_production_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionStatus", []))

    @jsii.member(jsii_name="resetProductionVersion")
    def reset_production_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionVersion", []))

    @jsii.member(jsii_name="resetStagingStatus")
    def reset_staging_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingStatus", []))

    @jsii.member(jsii_name="resetStagingVersion")
    def reset_staging_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingVersion", []))

    @builtins.property
    @jsii.member(jsii_name="configIdInput")
    def config_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "configIdInput"))

    @builtins.property
    @jsii.member(jsii_name="fileNameInput")
    def file_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fileNameInput"))

    @builtins.property
    @jsii.member(jsii_name="productionStatusInput")
    def production_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "productionStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="productionVersionInput")
    def production_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "productionVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingStatusInput")
    def staging_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stagingStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingVersionInput")
    def staging_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "stagingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="configId")
    def config_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "configId"))

    @config_id.setter
    def config_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0812ed43b95c335963c6c91f762cc8cb9732bb256a827ff08afa750f42b43140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configId", value)

    @builtins.property
    @jsii.member(jsii_name="fileName")
    def file_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fileName"))

    @file_name.setter
    def file_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26ef442da99ffdffab8e1b7e15a3a796584fd475075b55f9e90eba370ecc1753)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fileName", value)

    @builtins.property
    @jsii.member(jsii_name="productionStatus")
    def production_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "productionStatus"))

    @production_status.setter
    def production_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__800d382b40c7e769ac4a5127bc205942a7d281e42c5010b00e5ed508e100c67f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionStatus", value)

    @builtins.property
    @jsii.member(jsii_name="productionVersion")
    def production_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "productionVersion"))

    @production_version.setter
    def production_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef5f73abc8622ca1e16669fbaa395182d7874049c8b00c459b63dd8b413ca5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionVersion", value)

    @builtins.property
    @jsii.member(jsii_name="stagingStatus")
    def staging_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stagingStatus"))

    @staging_status.setter
    def staging_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b53535d7f8a5aad4ddef7a7762273c13ea001e28466c116e53dec4901e8e21e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingStatus", value)

    @builtins.property
    @jsii.member(jsii_name="stagingVersion")
    def staging_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "stagingVersion"))

    @staging_version.setter
    def staging_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__958f428f23f95eaec3892945249340b88d4ce4b5c438aca5f18a6f263f16a5ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b58bc2b7a9128f19ff12b89c2addaa60253d67b462ab0a29f2cd1cffa77d20aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__717aacdbf2c48e9308a096b3dc2a14405c1e2c4fd322a997a3d5e0565d725b84)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFirewallConfiguration")
    def put_firewall_configuration(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration(
            config_id=config_id,
            file_name=file_name,
            production_status=production_status,
            production_version=production_version,
            staging_status=staging_status,
            staging_version=staging_version,
        )

        return typing.cast(None, jsii.invoke(self, "putFirewallConfiguration", [value]))

    @jsii.member(jsii_name="resetFirewallConfiguration")
    def reset_firewall_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirewallConfiguration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="firewallConfiguration")
    def firewall_configuration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfigurationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfigurationOutputReference, jsii.get(self, "firewallConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="firewallConfigurationInput")
    def firewall_configuration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "firewallConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b826d9e843d95c0be148755d2b090925d7b9c80f6cf591840616a6031234f462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298d64fbb49218b4265775556588efde743d216b55bcfb1c70dc738a4cb9f3ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4163510764201400397a1387ca9f2c6f6f439f0ff777d9ae58e219d98a23915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306021c5aa14ad371d88c564d3ebf58e81c6dc5239e61b9a6d8a637f02b0b0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73cdaf116858d34dc0f82e5ad9e31402aae5cb54afbd043083f91c9c9da3e9c0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables WebSocket traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSocketsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSocketsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da5a407982a267a5b42c825da1c7517de22e9c4b3e600f9532be6e4b120cc94d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5247ba358a9e8ef0c7164549a29beb33307d9b1586cf28d21c02fa28c762f8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__065517fecd3dbfac592decaf958a2314e7ac2cda93518fc4eb06a38b2ba9163d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a42ea8e8a20249c2751ef7dc23b6f81ecce9d26365036eb419228b4812cf40cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ef004885a2691fac85eb97712433b625c08987643e26e48856a1e960f762e24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29eb0925d5808e7e17cd63afd6d804a0a43394bbb2d8df2f8e26f344dbb589ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d340d11be8b2192981c0b1519ddd78b27f4b019c7802b01e351ce27f4d731b7d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the WebDAV behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdavOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdavOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b9014c8b051323c410890b29f065df2c81de32ce4e8395a56bcb33602113819)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2713d36d80fc532a85604d08899a34ebfaa2a854cbd51a39d6737f8f7f2368fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a0646be30ce83cb19006a0db2da878385745c1fb046df4653cd1c99b183a90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0784a2f14ab142a96853b3f5d1eebeb8006810fc75df3c596ac49d11370084fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0304c9338b6c483b2c9c4774ca1d03fbc83c83bc9c79d495823f6f2f3d5b4c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38cd636866d915829f509abb3ebb8ac479a9a3056c6715f860ea860da22f5f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920Criterion",
    jsii_struct_bases=[],
    name_mapping={
        "advanced_im_match": "advancedImMatch",
        "bucket": "bucket",
        "cacheability": "cacheability",
        "china_cdn_region": "chinaCdnRegion",
        "client_certificate": "clientCertificate",
        "client_ip": "clientIp",
        "client_ip_version": "clientIpVersion",
        "cloudlets_origin": "cloudletsOrigin",
        "content_delivery_network": "contentDeliveryNetwork",
        "content_type": "contentType",
        "device_characteristic": "deviceCharacteristic",
        "ecmd_auth_groups": "ecmdAuthGroups",
        "ecmd_auth_scheme": "ecmdAuthScheme",
        "ecmd_is_authenticated": "ecmdIsAuthenticated",
        "ecmd_username": "ecmdUsername",
        "edge_workers_failure": "edgeWorkersFailure",
        "file_extension": "fileExtension",
        "filename": "filename",
        "hostname": "hostname",
        "match_advanced": "matchAdvanced",
        "match_cp_code": "matchCpCode",
        "match_response_code": "matchResponseCode",
        "match_variable": "matchVariable",
        "metadata_stage": "metadataStage",
        "origin_timeout": "originTimeout",
        "path": "path",
        "query_string_parameter": "queryStringParameter",
        "random": "random",
        "recovery_config": "recoveryConfig",
        "regular_expression": "regularExpression",
        "request_cookie": "requestCookie",
        "request_header": "requestHeader",
        "request_method": "requestMethod",
        "request_protocol": "requestProtocol",
        "request_type": "requestType",
        "response_header": "responseHeader",
        "server_location": "serverLocation",
        "time": "time",
        "token_authorization": "tokenAuthorization",
        "user_agent": "userAgent",
        "user_location": "userLocation",
        "user_network": "userNetwork",
        "variable_error": "variableError",
        "virtual_waiting_room_request": "virtualWaitingRoomRequest",
        "visitor_prioritization_request": "visitorPrioritizationRequest",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920Criterion:
    def __init__(
        self,
        *,
        advanced_im_match: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch", typing.Dict[builtins.str, typing.Any]]] = None,
        bucket: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket", typing.Dict[builtins.str, typing.Any]]] = None,
        cacheability: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability", typing.Dict[builtins.str, typing.Any]]] = None,
        china_cdn_region: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip_version: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlets_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        content_delivery_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        content_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_scheme: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_is_authenticated: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_username: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_workers_failure: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure", typing.Dict[builtins.str, typing.Any]]] = None,
        file_extension: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension", typing.Dict[builtins.str, typing.Any]]] = None,
        filename: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename", typing.Dict[builtins.str, typing.Any]]] = None,
        hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        match_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        match_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_stage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        path: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath", typing.Dict[builtins.str, typing.Any]]] = None,
        query_string_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        random: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom", typing.Dict[builtins.str, typing.Any]]] = None,
        recovery_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        regular_expression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression", typing.Dict[builtins.str, typing.Any]]] = None,
        request_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        request_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        request_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType", typing.Dict[builtins.str, typing.Any]]] = None,
        response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        server_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        time: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime", typing.Dict[builtins.str, typing.Any]]] = None,
        token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        user_agent: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent", typing.Dict[builtins.str, typing.Any]]] = None,
        user_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        user_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        variable_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param advanced_im_match: advanced_im_match block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        :param bucket: bucket block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param cacheability: cacheability block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        :param china_cdn_region: china_cdn_region block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        :param client_certificate: client_certificate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        :param client_ip: client_ip block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        :param client_ip_version: client_ip_version block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        :param cloudlets_origin: cloudlets_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        :param content_delivery_network: content_delivery_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        :param content_type: content_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param device_characteristic: device_characteristic block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        :param ecmd_auth_groups: ecmd_auth_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        :param ecmd_auth_scheme: ecmd_auth_scheme block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        :param ecmd_is_authenticated: ecmd_is_authenticated block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        :param ecmd_username: ecmd_username block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        :param edge_workers_failure: edge_workers_failure block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        :param file_extension: file_extension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        :param filename: filename block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        :param hostname: hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param match_advanced: match_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        :param match_cp_code: match_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        :param match_response_code: match_response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        :param match_variable: match_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        :param metadata_stage: metadata_stage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        :param origin_timeout: origin_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        :param path: path block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param query_string_parameter: query_string_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        :param random: random block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        :param recovery_config: recovery_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        :param regular_expression: regular_expression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        :param request_cookie: request_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        :param request_header: request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        :param request_method: request_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        :param request_protocol: request_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        :param request_type: request_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param response_header: response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        :param server_location: server_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        :param time: time block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        :param token_authorization: token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param user_agent: user_agent block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        :param user_location: user_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        :param user_network: user_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        :param variable_error: variable_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        :param virtual_waiting_room_request: virtual_waiting_room_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        :param visitor_prioritization_request: visitor_prioritization_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        if isinstance(advanced_im_match, dict):
            advanced_im_match = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch(**advanced_im_match)
        if isinstance(bucket, dict):
            bucket = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket(**bucket)
        if isinstance(cacheability, dict):
            cacheability = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability(**cacheability)
        if isinstance(china_cdn_region, dict):
            china_cdn_region = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion(**china_cdn_region)
        if isinstance(client_certificate, dict):
            client_certificate = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate(**client_certificate)
        if isinstance(client_ip, dict):
            client_ip = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp(**client_ip)
        if isinstance(client_ip_version, dict):
            client_ip_version = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion(**client_ip_version)
        if isinstance(cloudlets_origin, dict):
            cloudlets_origin = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin(**cloudlets_origin)
        if isinstance(content_delivery_network, dict):
            content_delivery_network = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork(**content_delivery_network)
        if isinstance(content_type, dict):
            content_type = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType(**content_type)
        if isinstance(device_characteristic, dict):
            device_characteristic = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic(**device_characteristic)
        if isinstance(ecmd_auth_groups, dict):
            ecmd_auth_groups = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups(**ecmd_auth_groups)
        if isinstance(ecmd_auth_scheme, dict):
            ecmd_auth_scheme = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme(**ecmd_auth_scheme)
        if isinstance(ecmd_is_authenticated, dict):
            ecmd_is_authenticated = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated(**ecmd_is_authenticated)
        if isinstance(ecmd_username, dict):
            ecmd_username = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername(**ecmd_username)
        if isinstance(edge_workers_failure, dict):
            edge_workers_failure = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure(**edge_workers_failure)
        if isinstance(file_extension, dict):
            file_extension = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension(**file_extension)
        if isinstance(filename, dict):
            filename = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename(**filename)
        if isinstance(hostname, dict):
            hostname = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname(**hostname)
        if isinstance(match_advanced, dict):
            match_advanced = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced(**match_advanced)
        if isinstance(match_cp_code, dict):
            match_cp_code = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode(**match_cp_code)
        if isinstance(match_response_code, dict):
            match_response_code = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode(**match_response_code)
        if isinstance(match_variable, dict):
            match_variable = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable(**match_variable)
        if isinstance(metadata_stage, dict):
            metadata_stage = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage(**metadata_stage)
        if isinstance(origin_timeout, dict):
            origin_timeout = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout(**origin_timeout)
        if isinstance(path, dict):
            path = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath(**path)
        if isinstance(query_string_parameter, dict):
            query_string_parameter = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter(**query_string_parameter)
        if isinstance(random, dict):
            random = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom(**random)
        if isinstance(recovery_config, dict):
            recovery_config = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig(**recovery_config)
        if isinstance(regular_expression, dict):
            regular_expression = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression(**regular_expression)
        if isinstance(request_cookie, dict):
            request_cookie = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie(**request_cookie)
        if isinstance(request_header, dict):
            request_header = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader(**request_header)
        if isinstance(request_method, dict):
            request_method = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod(**request_method)
        if isinstance(request_protocol, dict):
            request_protocol = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol(**request_protocol)
        if isinstance(request_type, dict):
            request_type = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType(**request_type)
        if isinstance(response_header, dict):
            response_header = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader(**response_header)
        if isinstance(server_location, dict):
            server_location = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation(**server_location)
        if isinstance(time, dict):
            time = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime(**time)
        if isinstance(token_authorization, dict):
            token_authorization = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization(**token_authorization)
        if isinstance(user_agent, dict):
            user_agent = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent(**user_agent)
        if isinstance(user_location, dict):
            user_location = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation(**user_location)
        if isinstance(user_network, dict):
            user_network = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork(**user_network)
        if isinstance(variable_error, dict):
            variable_error = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError(**variable_error)
        if isinstance(virtual_waiting_room_request, dict):
            virtual_waiting_room_request = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest(**virtual_waiting_room_request)
        if isinstance(visitor_prioritization_request, dict):
            visitor_prioritization_request = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest(**visitor_prioritization_request)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f87361bad8986c3e22169b89615d0d2d21c65bf99de4a32a82096ead4d5861d4)
            check_type(argname="argument advanced_im_match", value=advanced_im_match, expected_type=type_hints["advanced_im_match"])
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument cacheability", value=cacheability, expected_type=type_hints["cacheability"])
            check_type(argname="argument china_cdn_region", value=china_cdn_region, expected_type=type_hints["china_cdn_region"])
            check_type(argname="argument client_certificate", value=client_certificate, expected_type=type_hints["client_certificate"])
            check_type(argname="argument client_ip", value=client_ip, expected_type=type_hints["client_ip"])
            check_type(argname="argument client_ip_version", value=client_ip_version, expected_type=type_hints["client_ip_version"])
            check_type(argname="argument cloudlets_origin", value=cloudlets_origin, expected_type=type_hints["cloudlets_origin"])
            check_type(argname="argument content_delivery_network", value=content_delivery_network, expected_type=type_hints["content_delivery_network"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument device_characteristic", value=device_characteristic, expected_type=type_hints["device_characteristic"])
            check_type(argname="argument ecmd_auth_groups", value=ecmd_auth_groups, expected_type=type_hints["ecmd_auth_groups"])
            check_type(argname="argument ecmd_auth_scheme", value=ecmd_auth_scheme, expected_type=type_hints["ecmd_auth_scheme"])
            check_type(argname="argument ecmd_is_authenticated", value=ecmd_is_authenticated, expected_type=type_hints["ecmd_is_authenticated"])
            check_type(argname="argument ecmd_username", value=ecmd_username, expected_type=type_hints["ecmd_username"])
            check_type(argname="argument edge_workers_failure", value=edge_workers_failure, expected_type=type_hints["edge_workers_failure"])
            check_type(argname="argument file_extension", value=file_extension, expected_type=type_hints["file_extension"])
            check_type(argname="argument filename", value=filename, expected_type=type_hints["filename"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument match_advanced", value=match_advanced, expected_type=type_hints["match_advanced"])
            check_type(argname="argument match_cp_code", value=match_cp_code, expected_type=type_hints["match_cp_code"])
            check_type(argname="argument match_response_code", value=match_response_code, expected_type=type_hints["match_response_code"])
            check_type(argname="argument match_variable", value=match_variable, expected_type=type_hints["match_variable"])
            check_type(argname="argument metadata_stage", value=metadata_stage, expected_type=type_hints["metadata_stage"])
            check_type(argname="argument origin_timeout", value=origin_timeout, expected_type=type_hints["origin_timeout"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument query_string_parameter", value=query_string_parameter, expected_type=type_hints["query_string_parameter"])
            check_type(argname="argument random", value=random, expected_type=type_hints["random"])
            check_type(argname="argument recovery_config", value=recovery_config, expected_type=type_hints["recovery_config"])
            check_type(argname="argument regular_expression", value=regular_expression, expected_type=type_hints["regular_expression"])
            check_type(argname="argument request_cookie", value=request_cookie, expected_type=type_hints["request_cookie"])
            check_type(argname="argument request_header", value=request_header, expected_type=type_hints["request_header"])
            check_type(argname="argument request_method", value=request_method, expected_type=type_hints["request_method"])
            check_type(argname="argument request_protocol", value=request_protocol, expected_type=type_hints["request_protocol"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument response_header", value=response_header, expected_type=type_hints["response_header"])
            check_type(argname="argument server_location", value=server_location, expected_type=type_hints["server_location"])
            check_type(argname="argument time", value=time, expected_type=type_hints["time"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument user_agent", value=user_agent, expected_type=type_hints["user_agent"])
            check_type(argname="argument user_location", value=user_location, expected_type=type_hints["user_location"])
            check_type(argname="argument user_network", value=user_network, expected_type=type_hints["user_network"])
            check_type(argname="argument variable_error", value=variable_error, expected_type=type_hints["variable_error"])
            check_type(argname="argument virtual_waiting_room_request", value=virtual_waiting_room_request, expected_type=type_hints["virtual_waiting_room_request"])
            check_type(argname="argument visitor_prioritization_request", value=visitor_prioritization_request, expected_type=type_hints["visitor_prioritization_request"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced_im_match is not None:
            self._values["advanced_im_match"] = advanced_im_match
        if bucket is not None:
            self._values["bucket"] = bucket
        if cacheability is not None:
            self._values["cacheability"] = cacheability
        if china_cdn_region is not None:
            self._values["china_cdn_region"] = china_cdn_region
        if client_certificate is not None:
            self._values["client_certificate"] = client_certificate
        if client_ip is not None:
            self._values["client_ip"] = client_ip
        if client_ip_version is not None:
            self._values["client_ip_version"] = client_ip_version
        if cloudlets_origin is not None:
            self._values["cloudlets_origin"] = cloudlets_origin
        if content_delivery_network is not None:
            self._values["content_delivery_network"] = content_delivery_network
        if content_type is not None:
            self._values["content_type"] = content_type
        if device_characteristic is not None:
            self._values["device_characteristic"] = device_characteristic
        if ecmd_auth_groups is not None:
            self._values["ecmd_auth_groups"] = ecmd_auth_groups
        if ecmd_auth_scheme is not None:
            self._values["ecmd_auth_scheme"] = ecmd_auth_scheme
        if ecmd_is_authenticated is not None:
            self._values["ecmd_is_authenticated"] = ecmd_is_authenticated
        if ecmd_username is not None:
            self._values["ecmd_username"] = ecmd_username
        if edge_workers_failure is not None:
            self._values["edge_workers_failure"] = edge_workers_failure
        if file_extension is not None:
            self._values["file_extension"] = file_extension
        if filename is not None:
            self._values["filename"] = filename
        if hostname is not None:
            self._values["hostname"] = hostname
        if match_advanced is not None:
            self._values["match_advanced"] = match_advanced
        if match_cp_code is not None:
            self._values["match_cp_code"] = match_cp_code
        if match_response_code is not None:
            self._values["match_response_code"] = match_response_code
        if match_variable is not None:
            self._values["match_variable"] = match_variable
        if metadata_stage is not None:
            self._values["metadata_stage"] = metadata_stage
        if origin_timeout is not None:
            self._values["origin_timeout"] = origin_timeout
        if path is not None:
            self._values["path"] = path
        if query_string_parameter is not None:
            self._values["query_string_parameter"] = query_string_parameter
        if random is not None:
            self._values["random"] = random
        if recovery_config is not None:
            self._values["recovery_config"] = recovery_config
        if regular_expression is not None:
            self._values["regular_expression"] = regular_expression
        if request_cookie is not None:
            self._values["request_cookie"] = request_cookie
        if request_header is not None:
            self._values["request_header"] = request_header
        if request_method is not None:
            self._values["request_method"] = request_method
        if request_protocol is not None:
            self._values["request_protocol"] = request_protocol
        if request_type is not None:
            self._values["request_type"] = request_type
        if response_header is not None:
            self._values["response_header"] = response_header
        if server_location is not None:
            self._values["server_location"] = server_location
        if time is not None:
            self._values["time"] = time
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if user_agent is not None:
            self._values["user_agent"] = user_agent
        if user_location is not None:
            self._values["user_location"] = user_location
        if user_network is not None:
            self._values["user_network"] = user_network
        if variable_error is not None:
            self._values["variable_error"] = variable_error
        if virtual_waiting_room_request is not None:
            self._values["virtual_waiting_room_request"] = virtual_waiting_room_request
        if visitor_prioritization_request is not None:
            self._values["visitor_prioritization_request"] = visitor_prioritization_request

    @builtins.property
    def advanced_im_match(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch"]:
        '''advanced_im_match block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        '''
        result = self._values.get("advanced_im_match")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch"], result)

    @builtins.property
    def bucket(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket"]:
        '''bucket block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket"], result)

    @builtins.property
    def cacheability(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability"]:
        '''cacheability block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        '''
        result = self._values.get("cacheability")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability"], result)

    @builtins.property
    def china_cdn_region(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion"]:
        '''china_cdn_region block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        '''
        result = self._values.get("china_cdn_region")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion"], result)

    @builtins.property
    def client_certificate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate"]:
        '''client_certificate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        '''
        result = self._values.get("client_certificate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate"], result)

    @builtins.property
    def client_ip(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp"]:
        '''client_ip block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        '''
        result = self._values.get("client_ip")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp"], result)

    @builtins.property
    def client_ip_version(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion"]:
        '''client_ip_version block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        '''
        result = self._values.get("client_ip_version")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion"], result)

    @builtins.property
    def cloudlets_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin"]:
        '''cloudlets_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        '''
        result = self._values.get("cloudlets_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin"], result)

    @builtins.property
    def content_delivery_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork"]:
        '''content_delivery_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        '''
        result = self._values.get("content_delivery_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork"], result)

    @builtins.property
    def content_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType"]:
        '''content_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType"], result)

    @builtins.property
    def device_characteristic(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic"]:
        '''device_characteristic block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        '''
        result = self._values.get("device_characteristic")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic"], result)

    @builtins.property
    def ecmd_auth_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups"]:
        '''ecmd_auth_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        '''
        result = self._values.get("ecmd_auth_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups"], result)

    @builtins.property
    def ecmd_auth_scheme(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme"]:
        '''ecmd_auth_scheme block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        '''
        result = self._values.get("ecmd_auth_scheme")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme"], result)

    @builtins.property
    def ecmd_is_authenticated(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated"]:
        '''ecmd_is_authenticated block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        '''
        result = self._values.get("ecmd_is_authenticated")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated"], result)

    @builtins.property
    def ecmd_username(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername"]:
        '''ecmd_username block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        '''
        result = self._values.get("ecmd_username")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername"], result)

    @builtins.property
    def edge_workers_failure(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure"]:
        '''edge_workers_failure block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        '''
        result = self._values.get("edge_workers_failure")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure"], result)

    @builtins.property
    def file_extension(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension"]:
        '''file_extension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        '''
        result = self._values.get("file_extension")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension"], result)

    @builtins.property
    def filename(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename"]:
        '''filename block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        '''
        result = self._values.get("filename")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename"], result)

    @builtins.property
    def hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname"]:
        '''hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname"], result)

    @builtins.property
    def match_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced"]:
        '''match_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        '''
        result = self._values.get("match_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced"], result)

    @builtins.property
    def match_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode"]:
        '''match_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        '''
        result = self._values.get("match_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode"], result)

    @builtins.property
    def match_response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode"]:
        '''match_response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        '''
        result = self._values.get("match_response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode"], result)

    @builtins.property
    def match_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable"]:
        '''match_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        '''
        result = self._values.get("match_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable"], result)

    @builtins.property
    def metadata_stage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage"]:
        '''metadata_stage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        '''
        result = self._values.get("metadata_stage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage"], result)

    @builtins.property
    def origin_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout"]:
        '''origin_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        '''
        result = self._values.get("origin_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout"], result)

    @builtins.property
    def path(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath"]:
        '''path block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath"], result)

    @builtins.property
    def query_string_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter"]:
        '''query_string_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        '''
        result = self._values.get("query_string_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter"], result)

    @builtins.property
    def random(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom"]:
        '''random block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        '''
        result = self._values.get("random")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom"], result)

    @builtins.property
    def recovery_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig"]:
        '''recovery_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        '''
        result = self._values.get("recovery_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig"], result)

    @builtins.property
    def regular_expression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression"]:
        '''regular_expression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        '''
        result = self._values.get("regular_expression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression"], result)

    @builtins.property
    def request_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie"]:
        '''request_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        '''
        result = self._values.get("request_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie"], result)

    @builtins.property
    def request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader"]:
        '''request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        '''
        result = self._values.get("request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader"], result)

    @builtins.property
    def request_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod"]:
        '''request_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        '''
        result = self._values.get("request_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod"], result)

    @builtins.property
    def request_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol"]:
        '''request_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        '''
        result = self._values.get("request_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol"], result)

    @builtins.property
    def request_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType"]:
        '''request_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType"], result)

    @builtins.property
    def response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader"]:
        '''response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        '''
        result = self._values.get("response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader"], result)

    @builtins.property
    def server_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation"]:
        '''server_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        '''
        result = self._values.get("server_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation"], result)

    @builtins.property
    def time(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime"]:
        '''time block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        '''
        result = self._values.get("time")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime"], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization"]:
        '''token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization"], result)

    @builtins.property
    def user_agent(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent"]:
        '''user_agent block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        '''
        result = self._values.get("user_agent")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent"], result)

    @builtins.property
    def user_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation"]:
        '''user_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        '''
        result = self._values.get("user_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation"], result)

    @builtins.property
    def user_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork"]:
        '''user_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        '''
        result = self._values.get("user_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork"], result)

    @builtins.property
    def variable_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError"]:
        '''variable_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        '''
        result = self._values.get("variable_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError"], result)

    @builtins.property
    def virtual_waiting_room_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest"]:
        '''virtual_waiting_room_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        '''
        result = self._values.get("virtual_waiting_room_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest"], result)

    @builtins.property
    def visitor_prioritization_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest"]:
        '''visitor_prioritization_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        result = self._values.get("visitor_prioritization_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920Criterion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c759c5dedfa5443672371933da6d9a1008090c643e92bae10df3f659e5c11cb)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe5d0bc8f1e08030883e5cd7d826005536f904cd92a26eafd68eaf69f12d2c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31856f3caba2d069b5d6aafecd4feaf2b62c1b8c2425042e32b3c2d20008673f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__407032591b4e47e6c472d657a1668bb441e2a0848c570da0788079d6256f51be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e93d7a5a99cec15c9fdf4ca4890bdcd65c494b4fd64503a4bf662cb0de2c771)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c49ff5865b8e9c038b1f65af2ebcf4b41584cdbba7f83bd1b742a473e87acb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be09e29560fba32627a79295d7713baa28ba52b94b6eef41143e5e134d2f118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a825fa58a8af65b9bd8602a2b9079c046ed06ff7b128f7209a8236127a114a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "percentage": "percentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b1bbe3b85725c2f965e3655cd09ded1c46fcbdd021d6b7afc465ae8eb8af3b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument percentage", value=percentage, expected_type=type_hints["percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if percentage is not None:
            self._values["percentage"] = percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of requests to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        '''
        result = self._values.get("percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucketOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucketOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__359ab49c148b2bd27734fc6b26d2b9c5a6e420ca106ddf0800108aacd846d170)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPercentage")
    def reset_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="percentageInput")
    def percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "percentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e185eba613349cbd2e8b4b5f82518e296e062b1e261d7fe277cbd77e9d00c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="percentage")
    def percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "percentage"))

    @percentage.setter
    def percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1afcfdab18b35f9a3ce408127789949073d89846c745e41c7079d55fc126703b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "percentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a4b2f0ea8d4802a499728a9916cf03c041be97d4994aef592bc25d188243e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5af28b11063499bfd95a48cf158a024536310ce6fda8097785605a67123f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed017026172157e4f98e5abf4a5c580d5c6624aa8d964fbc06acd2d2f3690413)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87dd95ee9a49aaf2d7c44fa751c579dabc62f945a967e2316788386866f2ec67)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheabilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheabilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__046f64858826d1534e002ea28e650eea8b26fb81b5aae4b32aa16928c1b63921)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f53d55b3339fe4b6c582d807863c336928f16c54b1d19d2e786fb525df93f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157ba6dd80b90856e349285ac0b434d035668730c759db35223a0b2da87228a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9c55a87e4fc10ea2f9c93af47471dcf50a0c03f645822547c85160de1ef26a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e845e228d709bf5821adad20d814cb775ee988a055af7917e0baab8e3a26510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bab652a70f1452d40baedc96b98a43b5c8c05072532c624170f1b030f7191576)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aabadc121498a37a632e4d7a58ae158c471af6ddf640d515d2297d51d5a8c48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b7c2f30233e61c3c154cbf4ec906ccd0fadb98f6efeb9cfc9fdc9eb069cd5e2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547959e7bf98884b09f4143a411830bedaa27f8e405ed4d23c5a97058b13af87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d739895533a7bf7cf2354923c1c1b86b477b85f9a8c76fecf59e1b87886a91c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4204d774f051454030341e74b2a6adb22aa73d4160702833c9b2e10ea5cb8605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a56a4a1576c0000b955df73e0ded1efde57b0d04883da32c720969838ca24a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2edceb3d6022ff89be0bebf478ab3df70bcd9a61fe3717a143b49ee07a8e4ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf1d81f0f87d1f1b64d66a1787380f5aaf7a970ffe7499003f83bf02914b8b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate",
    jsii_struct_bases=[],
    name_mapping={
        "enforce_mtls": "enforceMtls",
        "is_certificate_present": "isCertificatePresent",
        "is_certificate_valid": "isCertificateValid",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate:
    def __init__(
        self,
        *,
        enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enforce_mtls: Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail. Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0057270461e2a00e8f1fccdaf33b5e1fc6d49e98c0ae5de1b85678b08f31d5b)
            check_type(argname="argument enforce_mtls", value=enforce_mtls, expected_type=type_hints["enforce_mtls"])
            check_type(argname="argument is_certificate_present", value=is_certificate_present, expected_type=type_hints["is_certificate_present"])
            check_type(argname="argument is_certificate_valid", value=is_certificate_valid, expected_type=type_hints["is_certificate_valid"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enforce_mtls is not None:
            self._values["enforce_mtls"] = enforce_mtls
        if is_certificate_present is not None:
            self._values["is_certificate_present"] = is_certificate_present
        if is_certificate_valid is not None:
            self._values["is_certificate_valid"] = is_certificate_valid
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enforce_mtls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail.

        Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        '''
        result = self._values.get("enforce_mtls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_present(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Executes rule behaviors only if a client certificate authenticates requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        '''
        result = self._values.get("is_certificate_present")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_valid(self) -> typing.Optional[builtins.str]:
        '''Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        '''
        result = self._values.get("is_certificate_valid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b89ba0076ed14f727e4a4923d4335dbcc051e872d65167e3f7f0199aafb35d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnforceMtls")
    def reset_enforce_mtls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnforceMtls", []))

    @jsii.member(jsii_name="resetIsCertificatePresent")
    def reset_is_certificate_present(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificatePresent", []))

    @jsii.member(jsii_name="resetIsCertificateValid")
    def reset_is_certificate_valid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateValid", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsInput")
    def enforce_mtls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enforceMtlsInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresentInput")
    def is_certificate_present_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificatePresentInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateValidInput")
    def is_certificate_valid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "isCertificateValidInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtls")
    def enforce_mtls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enforceMtls"))

    @enforce_mtls.setter
    def enforce_mtls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e2973821e5e98023ea33fe8793d4b67f223268711c570dc24c0efac804a0f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enforceMtls", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresent")
    def is_certificate_present(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificatePresent"))

    @is_certificate_present.setter
    def is_certificate_present(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b1475a2eeb3cbd088b65a342a5033cfaa5463f6d4fc4adfc3c0aa87b3fb2b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificatePresent", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateValid")
    def is_certificate_valid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "isCertificateValid"))

    @is_certificate_valid.setter
    def is_certificate_valid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7acb503afee983d885e377e9851106d564f78858bfacc92be21741d8682cc840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateValid", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07ee3f0fdc645b8e83966e87cecd997786a119dd4783e3f6002ac8b17dd3adf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6118ef156f0505ed1ac4830f321284badb5ffbb90c1095cc4ca47aba16d9afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cbd7f63c9a9176e016e0461c0053a4001447acbc489937f303c1f7d5ffd30e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ed2e483ede6ca0f70d9c2a7c9ae275cea0365141854ad1d1be86b65736aad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "use_headers": "useHeaders",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bf6c171c164c79ff4d9ac3e4845a07008edb95f019c65cff8c21ef4171b5bdc)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_headers", value=use_headers, expected_type=type_hints["use_headers"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_headers is not None:
            self._values["use_headers"] = use_headers
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        '''
        result = self._values.get("use_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''IP or CIDR block, for example: ``71.92.0.0/14``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69f20df0b9b6fe004db589bf2185d6634187589552e474f490a6b0af1dd542ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHeaders")
    def reset_use_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHeaders", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHeadersInput")
    def use_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36018b3d310a71fbb62fa8d8821e73d5e5f8824416d8800c91f8ff2badab6059)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32a9b4b8b0cff64db4d7d0dea47c21fccb8835c6395451c5d80849d9e56210a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82efd7f5fdb5ba1bde00d116145e230eca4ea56c1f5936c963c2587af8f99ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHeaders")
    def use_headers(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHeaders"))

    @use_headers.setter
    def use_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37746ec8bbc9f855d7817784a862eac3c84ca115c4facd13f2958e938f3cbf66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72db14d3f3b311389113ee03039ce54f3d689411cb3e203c22ac65c8c757bf5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c3f1393aff3250b08e570eb0db99cef61bf3c4f4c22bd142a5cf67f0fb0944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__830d53f03b3cf397590a3851373dff3b4672d0423446420bd71d698c6446fb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_x_forwarded_for": "useXForwardedFor",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44240cc73350c39f307f853f10e9bdb7b1d6aef8d7e96fcc87dc8ec4845a4d2e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_x_forwarded_for", value=use_x_forwarded_for, expected_type=type_hints["use_x_forwarded_for"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_x_forwarded_for is not None:
            self._values["use_x_forwarded_for"] = use_x_forwarded_for
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        '''
        result = self._values.get("use_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The IP version of the client request, either ``IPV4`` or ``IPV6``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9ecc776283f602ceb0e8d391ed88286f9b0032c663083f4a8b5ed9ee07d256b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseXForwardedFor")
    def reset_use_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseXForwardedFor", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useXForwardedForInput")
    def use_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619d422c4a99cc2285212238ba0faa491b55af9c5c7d1fb62882dba0591b5e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2af6506828a0e7b97e204aa5477440047d750a143edb80ff63ecb00e5291d635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useXForwardedFor")
    def use_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useXForwardedFor"))

    @use_x_forwarded_for.setter
    def use_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1bc63cf8aadf5fd75edcad4a1eb308a1434e1712a121afb7ab1ef93561d34f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0758bd8c78be7ae1b0417765c236c15e80cec0f5030e71fbf4f09892f49a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a896bbf5fb2a4e1a3ee256ac15c8ac54b823f745e6ed46e3cdc44f5fcd8eeb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cfc4a72bda8e41f7012f1afc5bcd2e761cb14b3e54697abc90a9f7454c0d0c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63152df2b279f6b9da895cdb4f2082e4a0a6a1f73d84d35593cc7e789793b9e4)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''The Cloudlets Origins identifier, limited to alphanumeric and underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d79c584eb86ad3f1b388a8a60ec382bac303c38b639ef6fac1ff9c1fa5e48b9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b6878f241a6e324517d737687d26cd0602e5a95d8372d3be8863209bdc35875)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2280e1009bf182fd1e158ad6110b1ee5af749623ede7d7020e5828a0231ab47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c286db70ef07c4219967d352a65cf510d1bbbff9edafa10540166f31c4abb25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01182f4722aeadadb70c02a536f718e2b20fbbd578bfa77f7db4be1091fc0d26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__456d13394b74958ede726f5a6377df141a63d362c8b1d3cfe5bf508a09b8a409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "network": "network",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61aa07c0d0707acaea4e68096aa2daf049c8aa0d5dfbe1f52105092b81cd3776)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network", value=network, expected_type=type_hints["network"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network is not None:
            self._values["network"] = network
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network(self) -> typing.Optional[builtins.str]:
        '''Match the network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        '''
        result = self._values.get("network")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7905364f47745649c83872a68d2248ba120433d9e14ca9eb0e5a7fd0ff6043)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetwork")
    def reset_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetwork", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkInput")
    def network_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "networkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3742d99f622346edd7b886d288d77959e636f12a24afd92cd76151444c190086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bc2e8da2628d68c0d082d9d89dfefa37cbc715f57781f55b1256791e5baf995)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="network")
    def network(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "network"))

    @network.setter
    def network(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a652d23349d348ea7bb846a12ba1c9742bf3161cefbfe5d0de84742f6dd94a5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "network", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5305bf727169d175d52826ddac5cebe33588a6fffe83388283d92e16752ea7d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4df805c1768d1b5065879dd3bd4bddb7daa643417a50b1a833d05c02141d294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7631057fb675a9acff03b0ba536b2bf74913e3dfdc355af5cd1c7e0bf0d51ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91c9ab0c30fa1c2f5ec46159f1e1eea71bff4b8fd8e36059dd236a3db9df33c1)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for all ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''``Content-Type`` response header value, for example ``text/html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd3c6671d66c0da3ad195574c57e25a9445fc95fa15f4efb61e0460caadada3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__705e1c399f92f0745b760201c6b58eeef94c1b2b2a541febfd3abcaaafb2dd33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de002ceb390598ca9900e7ccf3bcffcb826fae0bcc1636e5d0cb0c36a407965a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c26eb77f02e9362cbc1167fb78a8929a21f6ba19079c21ab62e2c92340c8d94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b98e1bdc14fd90ea38850fc77616de619a380c0ca6c61ef9eb4da9cc040d2181)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dba4b657ff636e5de5bf4e025720ad93c04ff3112609ec8dc65e85651d37a8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60422b685e4b65f587d8381bc1089b902ba50225c4c1d14d7a3693bccd55bafc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ef710c933686b161dba9969dc486950d3d1e3e06c2e3068e60f316977cdcfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ea6e360ccc39a85f1740054c69ae54e66c1bbe3762c0a168052c098eccd5d28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic",
    jsii_struct_bases=[],
    name_mapping={
        "boolean_value": "booleanValue",
        "characteristic": "characteristic",
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_wildcard": "matchWildcard",
        "numeric_match_operator": "numericMatchOperator",
        "numeric_value": "numericValue",
        "string_match_operator": "stringMatchOperator",
        "string_value": "stringValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "version_match_operator": "versionMatchOperator",
        "version_value": "versionValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic:
    def __init__(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2726d52043e7230eac5883277ebf126383a1db0ce7b144170d67862bf399d02b)
            check_type(argname="argument boolean_value", value=boolean_value, expected_type=type_hints["boolean_value"])
            check_type(argname="argument characteristic", value=characteristic, expected_type=type_hints["characteristic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument numeric_match_operator", value=numeric_match_operator, expected_type=type_hints["numeric_match_operator"])
            check_type(argname="argument numeric_value", value=numeric_value, expected_type=type_hints["numeric_value"])
            check_type(argname="argument string_match_operator", value=string_match_operator, expected_type=type_hints["string_match_operator"])
            check_type(argname="argument string_value", value=string_value, expected_type=type_hints["string_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument version_match_operator", value=version_match_operator, expected_type=type_hints["version_match_operator"])
            check_type(argname="argument version_value", value=version_value, expected_type=type_hints["version_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if boolean_value is not None:
            self._values["boolean_value"] = boolean_value
        if characteristic is not None:
            self._values["characteristic"] = characteristic
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if numeric_match_operator is not None:
            self._values["numeric_match_operator"] = numeric_match_operator
        if numeric_value is not None:
            self._values["numeric_value"] = numeric_value
        if string_match_operator is not None:
            self._values["string_match_operator"] = string_match_operator
        if string_value is not None:
            self._values["string_value"] = string_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if version_match_operator is not None:
            self._values["version_match_operator"] = version_match_operator
        if version_value is not None:
            self._values["version_value"] = version_value

    @builtins.property
    def boolean_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the ``characteristic`` expects a boolean value, this specifies the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        '''
        result = self._values.get("boolean_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def characteristic(self) -> typing.Optional[builtins.str]:
        '''Aspect of the device or browser to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        '''
        result = self._values.get("characteristic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``stringValue`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def numeric_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        '''
        result = self._values.get("numeric_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def numeric_value(self) -> typing.Optional[jsii.Number]:
        '''When the ``characteristic`` expects a numeric value, this specifies the number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        '''
        result = self._values.get("numeric_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def string_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        '''
        result = self._values.get("string_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def string_value(self) -> typing.Optional[typing.List[builtins.str]]:
        '''When the ``characteristic`` expects a string, this specifies the set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        '''
        result = self._values.get("string_value")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        '''
        result = self._values.get("version_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_value(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version number, this specifies it as a string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        result = self._values.get("version_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristicOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristicOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab34c971efbb9d893733ae3b64adc1bbc90b773772c7643b36d63d25953f2c4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBooleanValue")
    def reset_boolean_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBooleanValue", []))

    @jsii.member(jsii_name="resetCharacteristic")
    def reset_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCharacteristic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetNumericMatchOperator")
    def reset_numeric_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericMatchOperator", []))

    @jsii.member(jsii_name="resetNumericValue")
    def reset_numeric_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericValue", []))

    @jsii.member(jsii_name="resetStringMatchOperator")
    def reset_string_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringMatchOperator", []))

    @jsii.member(jsii_name="resetStringValue")
    def reset_string_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVersionMatchOperator")
    def reset_version_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionMatchOperator", []))

    @jsii.member(jsii_name="resetVersionValue")
    def reset_version_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionValue", []))

    @builtins.property
    @jsii.member(jsii_name="booleanValueInput")
    def boolean_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "booleanValueInput"))

    @builtins.property
    @jsii.member(jsii_name="characteristicInput")
    def characteristic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "characteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperatorInput")
    def numeric_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "numericMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="numericValueInput")
    def numeric_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numericValueInput"))

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperatorInput")
    def string_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stringMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="stringValueInput")
    def string_value_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "stringValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperatorInput")
    def version_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="versionValueInput")
    def version_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="booleanValue")
    def boolean_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "booleanValue"))

    @boolean_value.setter
    def boolean_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0f991c4f222637e06733185c16ef603b62121165cd4346999450972affc7e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "booleanValue", value)

    @builtins.property
    @jsii.member(jsii_name="characteristic")
    def characteristic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "characteristic"))

    @characteristic.setter
    def characteristic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d35867e75b610ab910145c1b3e5a5a1478411b6448019093a7ec4273efcb5dbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "characteristic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db0f7b9c27ef54df65aa919458dc6885c222b308186814c043aa9de4408f509c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c2d736211619afa814a6f749353ee4843fb7129c676229c35738fc945ce043)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0605557d8579653f0899af3e546671bc508d5a136ea1d8f17888d9e7d2aa54fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperator")
    def numeric_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "numericMatchOperator"))

    @numeric_match_operator.setter
    def numeric_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfabaadc76c673c6f3be86274434544dc55851c1a67efc7433a0b12e6ee2168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="numericValue")
    def numeric_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numericValue"))

    @numeric_value.setter
    def numeric_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c37557a6e22f94cb5d46fce2e03f22ca80d28100008fb05cd9db4f3a469539c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericValue", value)

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperator")
    def string_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stringMatchOperator"))

    @string_match_operator.setter
    def string_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a65483d8f0edbfe36d6d9508558487734aad6ce479f897f7eb715474caf7840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="stringValue")
    def string_value(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "stringValue"))

    @string_value.setter
    def string_value(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3edeaa09485fef1329a444f88e32dc4381616ae883fedf9598456cce705bd12b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4538c1d7eeac9c197407753ec49e1cd45d5c2e7dd6d291716396ba26b7dd2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9c1000683aae53ca3dd5d9a83926f1865d8eccd403b475dc986464aaf8bcc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperator")
    def version_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionMatchOperator"))

    @version_match_operator.setter
    def version_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afd89ebf8dbfc2b1f0e96873f0706ada67d3cf491996879c29ba66eed058c6e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="versionValue")
    def version_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionValue"))

    @version_value.setter
    def version_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0e30638cf1414141ffa59726c3a1ffd54e48af5c29b37e6721cca8227e44159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29c6fded740da2daa25ab595aefdcc70bd8e59c20d7f69f781af333ee6b248b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f90ac0bc69d06bcce4904d00031f05913df75f8ff3243802ba67a7498c759e91)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb2add0b37ffc6434607478109d20f82d0df9be222cac0d33c0deedc6b04cd18)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9190d4d638370702072f3619e3773bbdbc8ffa931b170fdde7a68c7eb1cd506e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4022c51f623d6454552df09afedfe4c9177bd35d048610b73d4abdffb6b070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa7cdc01f805593ca5fa06c6967273dea2d1bd1d303fdefb4d912b2a06585601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__543a0c064561c88f777737d9f48d3bcef2bda3bc9982f456ecab3ed7ef1ac691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a2e9e9214ea50bb2c3db9448bcdc94245a2b3ce6d9a1779508220c47616585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf409b28475cb953ab332b0a97fe3c21fe199a3b6238438d5726ac7093c7928)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme",
    jsii_struct_bases=[],
    name_mapping={
        "auth_scheme": "authScheme",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme:
    def __init__(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb9565fb1b0afad36244042c8ffd4fc72cff333276837bca8c1d07c68b8e998d)
            check_type(argname="argument auth_scheme", value=auth_scheme, expected_type=type_hints["auth_scheme"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if auth_scheme is not None:
            self._values["auth_scheme"] = auth_scheme
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def auth_scheme(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.'''
        result = self._values.get("auth_scheme")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthSchemeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthSchemeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1335758d04825d187b562166a0924dd15aafccbd650a4b0de83437775ea648bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthScheme")
    def reset_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthScheme", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authSchemeInput")
    def auth_scheme_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authScheme")
    def auth_scheme(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authScheme"))

    @auth_scheme.setter
    def auth_scheme(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73b57903633d4d093aba377c53e13ccddf6ef90f8dca539d91c1b724062128f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authScheme", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7761693208fc92b0655956223165ace2036c9d6fba5e5eec4fb05bed1f72283e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a092a6315823a0ddefa70919040ea15d298bca249ee9b571d223c3929e7fc5b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7003414c9f4fc451438f7783b4cb2a3f1d6881ad87ce9c607f201385e42ebf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdf49527ec185699bcb9fd51df3ef4014ded765776c576c22718e84b8760b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13681fa134b1f1f2af66a9c163a1b0d72fa522e5f1edfe8612ccb6a84bd2cce1)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticatedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticatedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b402a2352227315bf1f4c65fe03663035ede8ba5dd8c0fdb11123a85bee7f6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc2e4f18c41096b98d5e5ef842832729941e4fbb5e45acad0cc4bf6cb8104ed3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8951cca75685e8f2417a290068fa1d15557f7ce1277ab36959355a341365bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ea3035df7989f9331b094dab5b6d7241e5066166ba89dbc17bc3bc294f3e62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b2cd0b6ae00c2020e6f7150927c72f904042d5d556c37c75073791b76fecce9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9ee857d09202040136e5a23a8a8e953d0d6f4754a98862d88bcfd899682324)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername",
    jsii_struct_bases=[],
    name_mapping={
        "length": "length",
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername:
    def __init__(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec6143a18f125f021929047ad6b09422fab2388ac7d30aecc31fa2a0905c4f53)
            check_type(argname="argument length", value=length, expected_type=type_hints["length"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if length is not None:
            self._values["length"] = length
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def length(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.'''
        result = self._values.get("length")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsernameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsernameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a9c5ee1769bfd7339375316d933a9ed96d6f90d3e31bf176071afb0c5015bd3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLength")
    def reset_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLength", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lengthInput")
    def length_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lengthInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="length")
    def length(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "length"))

    @length.setter
    def length(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e0a2029dbdaaab8e0930952732301cb2526f33377be158e267e8fbff17b01a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "length", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6040db7d1054e158e4339eb115322859206d5a1e73f9bf0671a8899051febad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2620c49ca8c6797564e74a3808ddca76d17d2ea48ee2e14ad1ea2b8d01cad7dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab7804a718a6fa30077d061e1aae36e8170dbc81efe8ffa05350a326ff8ade71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52e3126475d0054bed13be16d6af8658f83cbbf75557a7cbc9a306ef18bd3eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ba4cf4fc2b5f3d42c435a3a3ee236b0f3d0079edda9214f3965d78644b4100f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f710f2207ba48f2ca98711a6b3937e2c0c69d0d86bbe495b76f7db0266e314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure",
    jsii_struct_bases=[],
    name_mapping={
        "exec_status": "execStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure:
    def __init__(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a58346228b5318bdd0f8abec4f5df6c930f9d46352d63d1c05d31c69a480e39)
            check_type(argname="argument exec_status", value=exec_status, expected_type=type_hints["exec_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if exec_status is not None:
            self._values["exec_status"] = exec_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def exec_status(self) -> typing.Optional[builtins.str]:
        '''Specify execution status.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        '''
        result = self._values.get("exec_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailureOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailureOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__433135b98818c304fb2da0d561cc16e1ba62249e5f58de28ecc1dc6c0cf648bd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExecStatus")
    def reset_exec_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExecStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="execStatusInput")
    def exec_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "execStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="execStatus")
    def exec_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "execStatus"))

    @exec_status.setter
    def exec_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0437c66467670c2b7f8c27ed27de71760eafa71843d95fb8013d25432ee100d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "execStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438598b3c68bf1f15501d2b4f95bc040670d3ada8c51506a8ce27460741bfb80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11ab77c533352d319983b591fca4148d2294e5eddea757be47f5814eb8479a68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f47a221119c614a0bb1cf894dc502ea4ef806f67b275866753c57fcd7c3e704)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30c0a9fdfd0ac986ece4ce5b65ff2af711a5c7d9d8f1000397161d73cc475c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3223c5e17274c1710524915dc3f001c57d9ce6511ce8a6fc0fb61c04fa248ba0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c539403ac226a4bda83cbb06b2258e2f8feed905e7ad88845d96f85d4081c6af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38e21371e75d1a80c0ff8d6092d3e0b6605e8c34bf695070255054c437bc1e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51840a85792172b946eced2cb79b9ebfb6d27a6d9cf252bc76d125c9740d27b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9fad485b1039262175a4c6092b4723a8abeaea75593c1b4fb8f5aa0ff7f2741)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c771b41e6b6674527b24ddcc79b46f6ef80cba6a24957997eb2a0a639ecf0f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__815ee64131392dbf81716e15f5560a308e90be2a601cf31141419c97f2b8da77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7da99ca0491778ac00ff5e44a380d923731c7cf04ad819c5a9f104a496860f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1a988b2eb4290b5da61aff017679af6a71ebe30b66b4ad418a459b9f138dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365203d2e3bed6bc59a1e06f488fa266f4c0d758d7e26c2696beb7eb47fc086f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``values`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``.

        If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the filename component of the request URL.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilenameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilenameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b941882eaa381eeabc8cd998cef3f5eb86846a215ef6601224613c9fbce242)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7a527c3199a68ecc22e5808ac188ef16971ee2a2e4f6779583298e82ddb663)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7d108def5574678c73cf4a0c03e449d61581c2e436517076d5111452d4aba8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4121f34de72a1899b0105e136440beb0f0f8106cdaf250c760b9ceadf89bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95cf1a74c3c415dc2f4f56b9272aa5aa0329a8ab5e49b3544b734e9879fcd6a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc0a662350facc8596d99f42b7b3314c821c0e80ed6205bb019fc0e8b6e468e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e148a604e5dd918ec41db2bfcaed644191a93cce23b22194300d43ca0c8c453e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ae1116e930ed091fdd4d1934c2f2bed4fd34a4d472f22625b10c6cb730572b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee40bbc14ec27538808b3f26482dc0fdddc4adb26b7a0d2fc1ca175772a04155)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of hostnames.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__037872220dc68c32baa1da88f09c2cba354455581896046198b7cf4741833d79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee5b60188c229929efd7df1167ec083d63e941d7a8d16c5329595bf6c6323e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39598b86974dbc7c077df68f2f8064076e34388809b279fc6443a1c8f1f1f08b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087766389c387a14c1192a390fdce8ecedf063caf92faec9edde9e0ef8387027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd0904c0b6cf232d79f986bce6ee0885d78352b9d923281a7bb04fefd551e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b029ae6f9684f5c3138b1133dd9d4576891c49f7a7e2a6cf064b78ea98aa593a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7539de4800fa82e3ff247d803b6be06fc09c518257e509fb434233337f592c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93986e8d721270f2119d16610edbd09bfb4bac440dda819d2f3a4a6dcab4d5f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a1ce9346b148bb225fa4e94600435d08fe2a80024766deb1ee0dba41d1af07)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddff05f192779013ae2b0fc555dfb902050f0d9eddabb5b11ecd19a7fd7a7bba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca1f0e3b3e66f45e97cde3931059a6a1ff60344631f619b6cf33901756171d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1b5d005a6c614b0f4192fb1ecc577ca36f322d29a1caae6f21b8e88b960f675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02241dfff6145a9e4114db028a2a3a06def4af69125e0178ff8cc140c1703603)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "close_xml": "closeXml",
        "description": "description",
        "locked": "locked",
        "open_xml": "openXml",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced:
    def __init__(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b45ec667ed3c2e970b19c22527e779599f40f4915fb4fd48cf2f622a65a00ebc)
            check_type(argname="argument close_xml", value=close_xml, expected_type=type_hints["close_xml"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument open_xml", value=open_xml, expected_type=type_hints["open_xml"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if close_xml is not None:
            self._values["close_xml"] = close_xml
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if open_xml is not None:
            self._values["open_xml"] = open_xml
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def close_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that closes the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        '''
        result = self._values.get("close_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def open_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that opens the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        '''
        result = self._values.get("open_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb43d043c3d0e200fa21a20c0684bc283f59d0b6111417419693b7cf2b797f7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloseXml")
    def reset_close_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloseXml", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOpenXml")
    def reset_open_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpenXml", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="closeXmlInput")
    def close_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "closeXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="openXmlInput")
    def open_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "openXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="closeXml")
    def close_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "closeXml"))

    @close_xml.setter
    def close_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef39118d074d73396a7b507fb6e64df71750d9dd83a1e4b6763f7295038d1b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "closeXml", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcdd981486fda6de790f8479f98875891ec56f76d0a90041ba6cf519e3d72374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c729daf3404ff314684fcf2d655fe13c2585e23b6a0eecb90a0cb82dc0b24326)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="openXml")
    def open_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "openXml"))

    @open_xml.setter
    def open_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7416ef2a8ac10d58702437ae4e6c3013db3e45a575f48f01459afdba4762ea9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "openXml", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36277fe020eb3d5d44058c92256ddc9a717e15e397961b3224aaceaf8d7d1f2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b701d766eec65af3b24f152313f925182851595afa629471589e1f89c63873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab70450095646837985daed46559eb570dbcd7d4f521709f59f3f29489b9e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44648a7683c710076bb526af44636310d8059f44aa5215912ffe0a2e4d79c4c0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__824341202351834e9067085f8d704e8b6c69e80e6709dc02826ff0586c434bbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4714f7c6e048e42fb04df27adeddc47c0ac83fe2879dba6e13c38c87bb443b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__234bbbae3de75bac45eb49d1060fd24c35b0f03c5fbfa1642ec07d53cbe8bc11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14951db883006c758b41bad0c5905c95f78d11dd6b7977f483da4b709f6b0cb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b20f719ee1f56a49da403f4a01695f78e7b62161ec1a8dd5a931fd3422af682)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38989703191440b6f14dde57d8ac2aa44c4e7daaf92a096982bcb152b18bfdb)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ca2c9c056aa5fe6d3db6ee19bfb0145e8b81cb649f541cb3a1f7dc6490b0541)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43e60c10a69ca9e0c2da19849c9c27e5a76208a773ec365a11967e21b2a74fbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e7588b4482739175188a92096c318875426639a5605f7a4a26fddc3a6c41c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0570bc4db73b975e4967724b69c88815f1668d8e43dcab39709a89b164c9bb53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc122f06876c47d0419773f0dbc359a91e7e53450617a3c883d23ee28f033f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbf531cf4a4ac9c4d2b3a48bda94d0fefc09861b9988cfef96206c7c98559970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27372efe83abece1014fa821da1d88f529f330e57a1849cf8d78630461c01018)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa120012ef95d55ab7f0b9a59ebeba248dd319b3f1fa7b56e2e31511970d0556)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e75aec55d9244b6ac88df07b634134799c40f52413767ff9ea8716315a72937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__279e8ae628a4098678b81e1d3ba7d9dcac88efa7f99ab8b63ab77b015b632149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b660ce52a641828068e5d987b135d98e80297096ab44e4a1e22df8d79528294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6503a134333c1ab573ad2c3859dbfe25618d4752707e0d93677d626c45d6248f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a50eeb21269db302f8f46a068592e1772f940ddbe24e66fb0df62609ece010a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62dc2ba40ae67b36e36cdf8582a040a9e875a9abf2e3fb51fe2fb00aed11d659)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches numeric range or a specified set of ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A set of response codes to match, for example ``["404","500"]``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff904c88a742cf01b8a55df7ad3d672916bff61aef3514705e77a6778641f66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aa18eb8c2e2ab50ca9e8a22b3ff6de51cd1b72420c0d3278e5e8571a6f7f707)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff92ee9643f392c8de6e02cf01d0a0ab48065948133f3f218528862c0cff36ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1cfc1d7edcc471d83ff0c72d29a9de8a6c11cb176abd0fa90f107f7a6b8a4aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6ae7cb57868afd3f6c91be72cb91e1a390c1c51621d505bfcff6d59a00222e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a7dde36b9211e18673bfe028991a213139bdf1b7161c710a66c49ffc590731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b16e3d0406f8022e4c9d2bf23ec549ee55c9f9a7373a548cccb84c2d48bb5250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4b6f261e13753c7bbf183b5064a123c1beafdcd7dbf1be5fcb240c8572d9ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e915434320adec6b191046631928cd4ffe23c4169e655325421bd428f06b08b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "variable_expression": "variableExpression",
        "variable_name": "variableName",
        "variable_values": "variableValues",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41355c96137fc0bdcda9f399742cd12be520a86e5e719607e5c69c9c1911313d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_expression", value=variable_expression, expected_type=type_hints["variable_expression"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_values", value=variable_values, expected_type=type_hints["variable_values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_expression is not None:
            self._values["variable_expression"] = variable_expression
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_values is not None:
            self._values["variable_values"] = variable_values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this performs a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''The type of match, based on which you use different options to specify the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_expression(self) -> typing.Optional[builtins.str]:
        '''Specifies a single matching string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        '''
        result = self._values.get("variable_expression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''The name of the variable to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies an array of matching strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        result = self._values.get("variable_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdba272b50fcc60467d57d5249a1e0faa662c51334fb293facedd01cf26a19ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableExpression")
    def reset_variable_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableExpression", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValues")
    def reset_variable_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableExpressionInput")
    def variable_expression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValuesInput")
    def variable_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5370a74dfe1846eac6fb1a73d9dcd8938206162a4f2a640caaab6a1c1f7448eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49de9ca9282a819071708b272677c0e25cab44bb8569b65bc0b087922f06348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a7d5786f317cc9149a10d0c13f25b55ae82d1f045051f1942e83f829d594562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f69bb35e6a01d1e0f55d473c2c9275402a4c90a556d50db87388d22cea300d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28f2c6bb4a0bdf78cba84fa0b0ac1d63a4594b4fb2a2aeebc9e85b21b9696bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e6b36b575b7c3c44de2a4a5ed73c92ee0d3779dba887d17b11b8643cbad48cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9046150b7bfbddd30d739d2892f3a7d9402fe15e323d1b35fc77d4c88dcdaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88fa0551616f5bb429737c4b3838523b85f0446c9466c42ca784bd30e7a8ed05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableExpression")
    def variable_expression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableExpression"))

    @variable_expression.setter
    def variable_expression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd68aee251dcfbe696af98bed64c7aabd3b4a1caa494d2d26000ff7cb88d8545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableExpression", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3320a3b9ed31501cb6df43d065ed119befd45e73a758ccff3b56484a56be075f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValues")
    def variable_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableValues"))

    @variable_values.setter
    def variable_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26f99eba44b2939f006df8d84e9e1c947c5149dbc1645e76559f53c7a15887a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValues", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da3b64bc22e5f84bf2d9c06a59b49a213f6932aed780867b1296c4f605b60a48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c30d62f7ec466bc0cd9999739fb749fcda142d15b480dd3442edc78c6011c9a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Compares the current rule with the specified metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85b73442bca6f0153695bce4e960de788d64bae1d309f125b79537e25c8b566)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40cdeee2c77682c224b34aea77e642ca4ff47f5819a1b8de79700c4da2961174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14ecdd2b4575c9cef3faa9ef55663256fc7c217fae90cdf00e2dd75844d3d67b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2637eb4751442a3a6f5fa71248d7ff075b98ddfb9c0e11c001a96d3467ea895f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088507632c8bb17e28f7bc500715a5afe9c96d54f4a75abdd4434b1e5ac354bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7239583fa05df13bbe8a08cf2dc5d5139bf2bcb74a4097ee356bdfa0f78e161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f231fa33377216fddb35103a975972462593733a050651a0da90b803c7f6fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c926d1e71e131a800d19b12950ce4d05a0481f9023867dddf5726702457cc0f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies a single required ``ORIGIN_TIMED_OUT`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ec880a9e9872d5a9a4afd07bf885626424eeb7115d0fa9f8733ddd98898413)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e757ca09b296b6e1d1319c013d52997eb1b1ee86d678bef5d9672291162693e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7170d97606f67edd72784d6636ee13e2a7f94d0908cb0a49bc95b0dc464a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f3c0606a3adf201d650c96ac7a7843adf6132a396524143a7b2c275b2dc10f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b30b0b0945bab723fa18cd9fcf4a24f6cc62d4cd131c4c6839ce0e9942b21e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2099e55299918e87dcd7bb2dee2b11aff87194ead0470ebb53eaa01dd6474703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee77ffc5eb04b4b4cc646f05d48954749df56f07bea03b2a91b0ccf24766b59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdvancedImMatch")
    def put_advanced_im_match(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvancedImMatch", [value]))

    @jsii.member(jsii_name="putBucket")
    def put_bucket(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket(
            locked=locked,
            percentage=percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBucket", [value]))

    @jsii.member(jsii_name="putCacheability")
    def put_cacheability(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheability", [value_]))

    @jsii.member(jsii_name="putChinaCdnRegion")
    def put_china_cdn_region(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChinaCdnRegion", [value]))

    @jsii.member(jsii_name="putClientCertificate")
    def put_client_certificate(
        self,
        *,
        enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enforce_mtls: Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail. Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate(
            enforce_mtls=enforce_mtls,
            is_certificate_present=is_certificate_present,
            is_certificate_valid=is_certificate_valid,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificate", [value]))

    @jsii.member(jsii_name="putClientIp")
    def put_client_ip(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            use_headers=use_headers,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIp", [value]))

    @jsii.member(jsii_name="putClientIpVersion")
    def put_client_ip_version(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion(
            locked=locked,
            template_uuid=template_uuid,
            use_x_forwarded_for=use_x_forwarded_for,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIpVersion", [value_]))

    @jsii.member(jsii_name="putCloudletsOrigin")
    def put_cloudlets_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletsOrigin", [value]))

    @jsii.member(jsii_name="putContentDeliveryNetwork")
    def put_content_delivery_network(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork(
            locked=locked,
            match_operator=match_operator,
            network=network,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentDeliveryNetwork", [value]))

    @jsii.member(jsii_name="putContentType")
    def put_content_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putContentType", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristic")
    def put_device_characteristic(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic(
            boolean_value=boolean_value,
            characteristic=characteristic,
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_wildcard=match_wildcard,
            numeric_match_operator=numeric_match_operator,
            numeric_value=numeric_value,
            string_match_operator=string_match_operator,
            string_value=string_value,
            template_uuid=template_uuid,
            uuid=uuid,
            version_match_operator=version_match_operator,
            version_value=version_value,
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristic", [value]))

    @jsii.member(jsii_name="putEcmdAuthGroups")
    def put_ecmd_auth_groups(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthGroups", [value_]))

    @jsii.member(jsii_name="putEcmdAuthScheme")
    def put_ecmd_auth_scheme(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme(
            auth_scheme=auth_scheme,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthScheme", [value]))

    @jsii.member(jsii_name="putEcmdIsAuthenticated")
    def put_ecmd_is_authenticated(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdIsAuthenticated", [value]))

    @jsii.member(jsii_name="putEcmdUsername")
    def put_ecmd_username(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername(
            length=length,
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdUsername", [value_]))

    @jsii.member(jsii_name="putEdgeWorkersFailure")
    def put_edge_workers_failure(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure(
            exec_status=exec_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorkersFailure", [value]))

    @jsii.member(jsii_name="putFileExtension")
    def put_file_extension(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFileExtension", [value]))

    @jsii.member(jsii_name="putFilename")
    def put_filename(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFilename", [value]))

    @jsii.member(jsii_name="putHostname")
    def put_hostname(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putHostname", [value]))

    @jsii.member(jsii_name="putMatchAdvanced")
    def put_match_advanced(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced(
            close_xml=close_xml,
            description=description,
            locked=locked,
            open_xml=open_xml,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchAdvanced", [value]))

    @jsii.member(jsii_name="putMatchCpCode")
    def put_match_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putMatchCpCode", [value_]))

    @jsii.member(jsii_name="putMatchResponseCode")
    def put_match_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode(
            locked=locked,
            lower_bound=lower_bound,
            match_operator=match_operator,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchResponseCode", [value]))

    @jsii.member(jsii_name="putMatchVariable")
    def put_match_variable(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable(
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            variable_expression=variable_expression,
            variable_name=variable_name,
            variable_values=variable_values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchVariable", [value]))

    @jsii.member(jsii_name="putMetadataStage")
    def put_metadata_stage(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataStage", [value_]))

    @jsii.member(jsii_name="putOriginTimeout")
    def put_origin_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginTimeout", [value]))

    @jsii.member(jsii_name="putPath")
    def put_path(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            normalize=normalize,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putPath", [value]))

    @jsii.member(jsii_name="putQueryStringParameter")
    def put_query_string_parameter(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter(
            escape_value=escape_value,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            parameter_name=parameter_name,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putQueryStringParameter", [value]))

    @jsii.member(jsii_name="putRandom")
    def put_random(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom(
            bucket=bucket, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRandom", [value]))

    @jsii.member(jsii_name="putRecoveryConfig")
    def put_recovery_config(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig(
            config_name=config_name,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRecoveryConfig", [value]))

    @jsii.member(jsii_name="putRegularExpression")
    def put_regular_expression(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression(
            case_sensitive=case_sensitive,
            locked=locked,
            match_string=match_string,
            regex=regex,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRegularExpression", [value]))

    @jsii.member(jsii_name="putRequestCookie")
    def put_request_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie(
            cookie_name=cookie_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestCookie", [value_]))

    @jsii.member(jsii_name="putRequestHeader")
    def put_request_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader(
            header_name=header_name,
            locked=locked,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestHeader", [value]))

    @jsii.member(jsii_name="putRequestMethod")
    def put_request_method(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestMethod", [value_]))

    @jsii.member(jsii_name="putRequestProtocol")
    def put_request_protocol(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putRequestProtocol", [value_]))

    @jsii.member(jsii_name="putRequestType")
    def put_request_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestType", [value_]))

    @jsii.member(jsii_name="putResponseHeader")
    def put_response_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader(
            header_name=header_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseHeader", [value]))

    @jsii.member(jsii_name="putServerLocation")
    def put_server_location(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation(
            continents=continents,
            countries=countries,
            location_type=location_type,
            locked=locked,
            match_operator=match_operator,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putServerLocation", [value]))

    @jsii.member(jsii_name="putTime")
    def put_time(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime(
            apply_daylight_savings_time=apply_daylight_savings_time,
            begin_date=begin_date,
            end_date=end_date,
            lasting_date=lasting_date,
            lasting_duration=lasting_duration,
            locked=locked,
            match_operator=match_operator,
            repeat_begin_date=repeat_begin_date,
            repeat_duration=repeat_duration,
            repeat_interval=repeat_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTime", [value]))

    @jsii.member(jsii_name="putTokenAuthorization")
    def put_token_authorization(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization(
            locked=locked,
            match_operator=match_operator,
            status_list=status_list,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTokenAuthorization", [value]))

    @jsii.member(jsii_name="putUserAgent")
    def put_user_agent(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putUserAgent", [value]))

    @jsii.member(jsii_name="putUserLocation")
    def put_user_location(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation(
            check_ips=check_ips,
            continent_values=continent_values,
            country_values=country_values,
            field=field,
            locked=locked,
            match_operator=match_operator,
            region_values=region_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserLocation", [value]))

    @jsii.member(jsii_name="putUserNetwork")
    def put_user_network(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork(
            bandwidth_values=bandwidth_values,
            check_ips=check_ips,
            field=field,
            locked=locked,
            match_operator=match_operator,
            network_type_values=network_type_values,
            network_values=network_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserNetwork", [value]))

    @jsii.member(jsii_name="putVariableError")
    def put_variable_error(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError(
            locked=locked,
            result=result,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_names=variable_names,
        )

        return typing.cast(None, jsii.invoke(self, "putVariableError", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomRequest")
    def put_virtual_waiting_room_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomRequest", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationRequest")
    def put_visitor_prioritization_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationRequest", [value]))

    @jsii.member(jsii_name="resetAdvancedImMatch")
    def reset_advanced_im_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedImMatch", []))

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetCacheability")
    def reset_cacheability(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheability", []))

    @jsii.member(jsii_name="resetChinaCdnRegion")
    def reset_china_cdn_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnRegion", []))

    @jsii.member(jsii_name="resetClientCertificate")
    def reset_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificate", []))

    @jsii.member(jsii_name="resetClientIp")
    def reset_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIp", []))

    @jsii.member(jsii_name="resetClientIpVersion")
    def reset_client_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIpVersion", []))

    @jsii.member(jsii_name="resetCloudletsOrigin")
    def reset_cloudlets_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletsOrigin", []))

    @jsii.member(jsii_name="resetContentDeliveryNetwork")
    def reset_content_delivery_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentDeliveryNetwork", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDeviceCharacteristic")
    def reset_device_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristic", []))

    @jsii.member(jsii_name="resetEcmdAuthGroups")
    def reset_ecmd_auth_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthGroups", []))

    @jsii.member(jsii_name="resetEcmdAuthScheme")
    def reset_ecmd_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthScheme", []))

    @jsii.member(jsii_name="resetEcmdIsAuthenticated")
    def reset_ecmd_is_authenticated(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdIsAuthenticated", []))

    @jsii.member(jsii_name="resetEcmdUsername")
    def reset_ecmd_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdUsername", []))

    @jsii.member(jsii_name="resetEdgeWorkersFailure")
    def reset_edge_workers_failure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkersFailure", []))

    @jsii.member(jsii_name="resetFileExtension")
    def reset_file_extension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileExtension", []))

    @jsii.member(jsii_name="resetFilename")
    def reset_filename(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFilename", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetMatchAdvanced")
    def reset_match_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchAdvanced", []))

    @jsii.member(jsii_name="resetMatchCpCode")
    def reset_match_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCpCode", []))

    @jsii.member(jsii_name="resetMatchResponseCode")
    def reset_match_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchResponseCode", []))

    @jsii.member(jsii_name="resetMatchVariable")
    def reset_match_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchVariable", []))

    @jsii.member(jsii_name="resetMetadataStage")
    def reset_metadata_stage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataStage", []))

    @jsii.member(jsii_name="resetOriginTimeout")
    def reset_origin_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginTimeout", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetQueryStringParameter")
    def reset_query_string_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryStringParameter", []))

    @jsii.member(jsii_name="resetRandom")
    def reset_random(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandom", []))

    @jsii.member(jsii_name="resetRecoveryConfig")
    def reset_recovery_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryConfig", []))

    @jsii.member(jsii_name="resetRegularExpression")
    def reset_regular_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegularExpression", []))

    @jsii.member(jsii_name="resetRequestCookie")
    def reset_request_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestCookie", []))

    @jsii.member(jsii_name="resetRequestHeader")
    def reset_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestHeader", []))

    @jsii.member(jsii_name="resetRequestMethod")
    def reset_request_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestMethod", []))

    @jsii.member(jsii_name="resetRequestProtocol")
    def reset_request_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestProtocol", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetResponseHeader")
    def reset_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeader", []))

    @jsii.member(jsii_name="resetServerLocation")
    def reset_server_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerLocation", []))

    @jsii.member(jsii_name="resetTime")
    def reset_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTime", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUserAgent")
    def reset_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserAgent", []))

    @jsii.member(jsii_name="resetUserLocation")
    def reset_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserLocation", []))

    @jsii.member(jsii_name="resetUserNetwork")
    def reset_user_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserNetwork", []))

    @jsii.member(jsii_name="resetVariableError")
    def reset_variable_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableError", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomRequest")
    def reset_virtual_waiting_room_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomRequest", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationRequest")
    def reset_visitor_prioritization_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationRequest", []))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatch")
    def advanced_im_match(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatchOutputReference, jsii.get(self, "advancedImMatch"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucketOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucketOutputReference, jsii.get(self, "bucket"))

    @builtins.property
    @jsii.member(jsii_name="cacheability")
    def cacheability(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheabilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheabilityOutputReference, jsii.get(self, "cacheability"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegion")
    def china_cdn_region(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegionOutputReference, jsii.get(self, "chinaCdnRegion"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificate")
    def client_certificate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificateOutputReference, jsii.get(self, "clientCertificate"))

    @builtins.property
    @jsii.member(jsii_name="clientIp")
    def client_ip(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpOutputReference, jsii.get(self, "clientIp"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersion")
    def client_ip_version(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersionOutputReference, jsii.get(self, "clientIpVersion"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOrigin")
    def cloudlets_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOriginOutputReference, jsii.get(self, "cloudletsOrigin"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetwork")
    def content_delivery_network(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetworkOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetworkOutputReference, jsii.get(self, "contentDeliveryNetwork"))

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentTypeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentTypeOutputReference, jsii.get(self, "contentType"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristic")
    def device_characteristic(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristicOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristicOutputReference, jsii.get(self, "deviceCharacteristic"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroups")
    def ecmd_auth_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroupsOutputReference, jsii.get(self, "ecmdAuthGroups"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthScheme")
    def ecmd_auth_scheme(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthSchemeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthSchemeOutputReference, jsii.get(self, "ecmdAuthScheme"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticated")
    def ecmd_is_authenticated(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticatedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticatedOutputReference, jsii.get(self, "ecmdIsAuthenticated"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsername")
    def ecmd_username(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsernameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsernameOutputReference, jsii.get(self, "ecmdUsername"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailure")
    def edge_workers_failure(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailureOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailureOutputReference, jsii.get(self, "edgeWorkersFailure"))

    @builtins.property
    @jsii.member(jsii_name="fileExtension")
    def file_extension(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtensionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtensionOutputReference, jsii.get(self, "fileExtension"))

    @builtins.property
    @jsii.member(jsii_name="filename")
    def filename(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilenameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilenameOutputReference, jsii.get(self, "filename"))

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostnameOutputReference, jsii.get(self, "hostname"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvanced")
    def match_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvancedOutputReference, jsii.get(self, "matchAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCode")
    def match_cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeOutputReference, jsii.get(self, "matchCpCode"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCode")
    def match_response_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCodeOutputReference, jsii.get(self, "matchResponseCode"))

    @builtins.property
    @jsii.member(jsii_name="matchVariable")
    def match_variable(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariableOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariableOutputReference, jsii.get(self, "matchVariable"))

    @builtins.property
    @jsii.member(jsii_name="metadataStage")
    def metadata_stage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStageOutputReference, jsii.get(self, "metadataStage"))

    @builtins.property
    @jsii.member(jsii_name="originTimeout")
    def origin_timeout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeoutOutputReference, jsii.get(self, "originTimeout"))

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPathOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPathOutputReference", jsii.get(self, "path"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameter")
    def query_string_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameterOutputReference", jsii.get(self, "queryStringParameter"))

    @builtins.property
    @jsii.member(jsii_name="random")
    def random(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandomOutputReference", jsii.get(self, "random"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfig")
    def recovery_config(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfigOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfigOutputReference", jsii.get(self, "recoveryConfig"))

    @builtins.property
    @jsii.member(jsii_name="regularExpression")
    def regular_expression(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpressionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpressionOutputReference", jsii.get(self, "regularExpression"))

    @builtins.property
    @jsii.member(jsii_name="requestCookie")
    def request_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookieOutputReference", jsii.get(self, "requestCookie"))

    @builtins.property
    @jsii.member(jsii_name="requestHeader")
    def request_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeaderOutputReference", jsii.get(self, "requestHeader"))

    @builtins.property
    @jsii.member(jsii_name="requestMethod")
    def request_method(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethodOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethodOutputReference", jsii.get(self, "requestMethod"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocol")
    def request_protocol(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocolOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocolOutputReference", jsii.get(self, "requestProtocol"))

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestTypeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestTypeOutputReference", jsii.get(self, "requestType"))

    @builtins.property
    @jsii.member(jsii_name="responseHeader")
    def response_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeaderOutputReference", jsii.get(self, "responseHeader"))

    @builtins.property
    @jsii.member(jsii_name="serverLocation")
    def server_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocationOutputReference", jsii.get(self, "serverLocation"))

    @builtins.property
    @jsii.member(jsii_name="time")
    def time(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTimeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTimeOutputReference", jsii.get(self, "time"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorizationOutputReference", jsii.get(self, "tokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="userAgent")
    def user_agent(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgentOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgentOutputReference", jsii.get(self, "userAgent"))

    @builtins.property
    @jsii.member(jsii_name="userLocation")
    def user_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocationOutputReference", jsii.get(self, "userLocation"))

    @builtins.property
    @jsii.member(jsii_name="userNetwork")
    def user_network(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetworkOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetworkOutputReference", jsii.get(self, "userNetwork"))

    @builtins.property
    @jsii.member(jsii_name="variableError")
    def variable_error(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableErrorOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableErrorOutputReference", jsii.get(self, "variableError"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequest")
    def virtual_waiting_room_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequestOutputReference", jsii.get(self, "virtualWaitingRoomRequest"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequest")
    def visitor_prioritization_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequestOutputReference", jsii.get(self, "visitorPrioritizationRequest"))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatchInput")
    def advanced_im_match_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch], jsii.get(self, "advancedImMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilityInput")
    def cacheability_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability], jsii.get(self, "cacheabilityInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegionInput")
    def china_cdn_region_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion], jsii.get(self, "chinaCdnRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateInput")
    def client_certificate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate], jsii.get(self, "clientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpInput")
    def client_ip_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp], jsii.get(self, "clientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersionInput")
    def client_ip_version_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion], jsii.get(self, "clientIpVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOriginInput")
    def cloudlets_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin], jsii.get(self, "cloudletsOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetworkInput")
    def content_delivery_network_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork], jsii.get(self, "contentDeliveryNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicInput")
    def device_characteristic_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic], jsii.get(self, "deviceCharacteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroupsInput")
    def ecmd_auth_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups], jsii.get(self, "ecmdAuthGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthSchemeInput")
    def ecmd_auth_scheme_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme], jsii.get(self, "ecmdAuthSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticatedInput")
    def ecmd_is_authenticated_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated], jsii.get(self, "ecmdIsAuthenticatedInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsernameInput")
    def ecmd_username_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername], jsii.get(self, "ecmdUsernameInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailureInput")
    def edge_workers_failure_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure], jsii.get(self, "edgeWorkersFailureInput"))

    @builtins.property
    @jsii.member(jsii_name="fileExtensionInput")
    def file_extension_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension], jsii.get(self, "fileExtensionInput"))

    @builtins.property
    @jsii.member(jsii_name="filenameInput")
    def filename_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename], jsii.get(self, "filenameInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvancedInput")
    def match_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced], jsii.get(self, "matchAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCodeInput")
    def match_cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode], jsii.get(self, "matchCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCodeInput")
    def match_response_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode], jsii.get(self, "matchResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchVariableInput")
    def match_variable_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable], jsii.get(self, "matchVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataStageInput")
    def metadata_stage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage], jsii.get(self, "metadataStageInput"))

    @builtins.property
    @jsii.member(jsii_name="originTimeoutInput")
    def origin_timeout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout], jsii.get(self, "originTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath"], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameterInput")
    def query_string_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter"], jsii.get(self, "queryStringParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="randomInput")
    def random_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom"], jsii.get(self, "randomInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfigInput")
    def recovery_config_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig"], jsii.get(self, "recoveryConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="regularExpressionInput")
    def regular_expression_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression"], jsii.get(self, "regularExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="requestCookieInput")
    def request_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie"], jsii.get(self, "requestCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="requestHeaderInput")
    def request_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader"], jsii.get(self, "requestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="requestMethodInput")
    def request_method_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod"], jsii.get(self, "requestMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocolInput")
    def request_protocol_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol"], jsii.get(self, "requestProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType"], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderInput")
    def response_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader"], jsii.get(self, "responseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="serverLocationInput")
    def server_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation"], jsii.get(self, "serverLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="timeInput")
    def time_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime"], jsii.get(self, "timeInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization"], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="userAgentInput")
    def user_agent_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent"], jsii.get(self, "userAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="userLocationInput")
    def user_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation"], jsii.get(self, "userLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="userNetworkInput")
    def user_network_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork"], jsii.get(self, "userNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="variableErrorInput")
    def variable_error_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError"], jsii.get(self, "variableErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequestInput")
    def virtual_waiting_room_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest"], jsii.get(self, "virtualWaitingRoomRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequestInput")
    def visitor_prioritization_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest"], jsii.get(self, "visitorPrioritizationRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaad3e54046b17eca4de0a296444235afcf52ed974eccdbcace0ad0d7e86ee29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "normalize": "normalize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dcfad776d1c9c31b97e2dff6a6f845206de6010765600f8630a5e3ed419deeb)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument normalize", value=normalize, expected_type=type_hints["normalize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if normalize is not None:
            self._values["normalize"] = normalize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of the ``values`` array.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def normalize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Transforms URLs before comparing them with the provided value.

        URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        '''
        result = self._values.get("normalize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the URL path, excluding leading hostname and trailing query parameters.

        The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}

        Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPathOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPathOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9acfdeb370618e9482f10a2821b26f88a9fb028783d40141562b62e638be6ddf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNormalize")
    def reset_normalize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNormalize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="normalizeInput")
    def normalize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "normalizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8079a63bb2cb2b1e44ce0c6de9f56b2ae0dfc733fd1788210ae662a4973914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cb2da081db8ff8a1b10fa4305809ef7fa1e1a3da40d861115ed39f910fa8957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d05455aa9fbf4d6cf331ae77d13b94e6af3665a3ebbf542b54e81c73c059438e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="normalize")
    def normalize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "normalize"))

    @normalize.setter
    def normalize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e0a2c6b8199e9e0e4f6c06460ea15c88849f3999bb987639ddc093f4ff72c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "normalize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0c91c20ab58f98add4a2ad569635299bb7dedab3ee7ad991df3bacccc99dd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__836bd84b1d72e2ca37615d2a860e9505b0e32450b9795de721e9c302dff888d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4ee4c82eb0208b2a4bc901e839607866359c04345b9904686547f1256a271c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58a03623a60b9e7eb781e106cd740b6aeb31807889d95340e288c79916c69530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter",
    jsii_struct_bases=[],
    name_mapping={
        "escape_value": "escapeValue",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "parameter_name": "parameterName",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter:
    def __init__(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abefeb638b4fa20159da4304a7883db82ae6027f8355f02910482c1222e1379b)
            check_type(argname="argument escape_value", value=escape_value, expected_type=type_hints["escape_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument parameter_name", value=parameter_name, expected_type=type_hints["parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if escape_value is not None:
            self._values["escape_value"] = escape_value
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if parameter_name is not None:
            self._values["parameter_name"] = parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def escape_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches when the ``value`` is URL-escaped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        '''
        result = self._values.get("escape_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``parameterName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the query field, for example, ``q`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        '''
        result = self._values.get("parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The value of the query field, for example, ``string`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b910049cc1a0fe041680931cee03f08aba5946ce57a6c2daf7beb11967c24fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEscapeValue")
    def reset_escape_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetParameterName")
    def reset_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="escapeValueInput")
    def escape_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="parameterNameInput")
    def parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "parameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeValue")
    def escape_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeValue"))

    @escape_value.setter
    def escape_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071b3b8fda1cafac894876327b8934b37b5a67d5bd39f4972a422420c0ba478c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854d54ad93f5ead9ed6d875ec628f226d82e9bda641d3c03e6a03981eae44be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448f67d0c2e04500efbe9fdb00e77b02323720c5b3bb831c4d74953451d47f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a346a0ecac42db01b4051711ca93b8bbf22026145577491c15f325ab32643ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93ead9e02d7017021b7142b37e0c9a562a59bec53f3f4248f2346c193beec876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7c1e9a70f63a903947ff68169ec024e1bc03070ddde91a3c31863d633f468e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4656277434e64371771ead96cbc9bb8ddf39547e6ad0d777e1cf028cb27a96ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fe868e62951e9b3c9df798286c3806ba91383d2899d5b0ad0e4b5f015735913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="parameterName")
    def parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "parameterName"))

    @parameter_name.setter
    def parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd688bcf41a3a8445824c4202f20e64910f3de34466c81781e33d5dff45a933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86c4f298775c14a26a94c3f1eb02f2874a33f0cbe7d3eb5d930c4c2e9cdc80a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59e05e02f4629d3092d66b86030b0011aa9525c04cf7113acad0ff9bf195b371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22273e215724f63adacc3d58c18929c173d4b24a123df4659d0f07e7ffd73ac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49b59fb224cd62b72aae205c33e2a5bb9c14dae4ab4ca734b1a0164c9ad66a3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b276d10fe53f2b304df824c8ffdab5d47f23109f7e9462c98c94010cff9dfd7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom",
    jsii_struct_bases=[],
    name_mapping={
        "bucket": "bucket",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom:
    def __init__(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43204be239efded693a0964fc3b11632f025fd968fa64a3659ddfba5511232a2)
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bucket is not None:
            self._values["bucket"] = bucket
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bucket(self) -> typing.Optional[jsii.Number]:
        '''Specify a percentage of random requests to which to apply a behavior. Any remainders do not match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__027d75376abd59c741036f0982be806bfd638312d1355916ddec7f138eb2ead8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bucket"))

    @bucket.setter
    def bucket(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5738d2ebe6096ccafe9197af649b33a0962b357defb16237f89cefe110491e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bucket", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2f64132f44d1098e40387fd3104bb40b2dc96e9fe07dcc82fe4103563370982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d76fe02a69b413bc4ed67c233a904faf4f9b39849a431864653ae525578314d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c07e04311ab3df126a833b8504b37c1cdc97bbc3ce5e467f24e96e6799787f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7d7ab34b7468ffe8f8de89449223742e08e82b0eb4d6fd6891bfa1a22dda827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig",
    jsii_struct_bases=[],
    name_mapping={
        "config_name": "configName",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig:
    def __init__(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3113043db64192ecc602e2b3482bf6af0e6f7a179104ac561f6b3cf530f294e)
            check_type(argname="argument config_name", value=config_name, expected_type=type_hints["config_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_name is not None:
            self._values["config_name"] = config_name
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def config_name(self) -> typing.Optional[builtins.str]:
        '''A unique identifier used for origin failure recovery configurations.

        This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        '''
        result = self._values.get("config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de8161c12947aa5eabc24e64220e2a91cf04a1ec91cc533038cd9a37848a595e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigName")
    def reset_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="configNameInput")
    def config_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="configName")
    def config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configName"))

    @config_name.setter
    def config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49de1320929f3638c0208e70b5dcf256b8a4b47bf106be99b32799862e741047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e922cf8ecc93aad1b0e0ce76a6f35e71037bd46d10f79af89e88811aa2e20f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d33e9e1581d438318b28491a7de5892d21c911782cb99dd3a4b33e80c8c43aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38c623521e1c55f153c6546bab9ed5602d6719f03deb487d991d1e1634582597)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4cbd899b44781f431a725af8fe9485a95e3b2332a25c39f629b914a263a9f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression",
    jsii_struct_bases=[],
    name_mapping={
        "case_sensitive": "caseSensitive",
        "locked": "locked",
        "match_string": "matchString",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression:
    def __init__(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0930640cba4842ba895c0a34c705a0a918b66ff3e1b57a88c0afe927aaf89381)
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_string", value=match_string, expected_type=type_hints["match_string"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if locked is not None:
            self._values["locked"] = locked
        if match_string is not None:
            self._values["match_string"] = match_string
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive regular expression match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_string(self) -> typing.Optional[builtins.str]:
        '''The string to match, typically the contents of a dynamic variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        '''
        result = self._values.get("match_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''The regular expression (PCRE) to match against the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__090f42021a88ec2cd0b9d03a4672218714d5cf3bad86aff40fdd3ba2272d0428)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchString")
    def reset_match_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchString", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchStringInput")
    def match_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchStringInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6d211d5413253acdb555a212e0298def2e8ab633a6d45f4bc2f133d4ff295a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8744d8a4ec1380a448ad31f85f118fa5303f1c6b52f02a29630e64ca77f30c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchString")
    def match_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchString"))

    @match_string.setter
    def match_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30db26d778e154181fc37a9eff60718c1911aee9c82e6a784840226e9b07cf8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchString", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4240ea4a7d458b23d2bd26d28fc12597980d4d32893f68a42a75a7cbd82312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ccc0745d82a24b2d1da3e875a6e987d024b08f369b0b5e7c004e501589c72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca1968a8dabcd8b24df63e440ee6d9327498f805a68753d4a7a80437b866144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c07f3d199d05f5c60a409a0cdc63677767c9beddb0137542f0d0a930cc87db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fcaab576a1ca55e18aa4942dbabb5ffb21b1d52e86e3802248dbdc8ba9e14e9)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''The name of the cookie, for example, ``visitor`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``cookieName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The cookie's value, for example, ``anon`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c274c663b77d08a0cf44d2019b3cf114de77dc1b708d86f8f93111bd083c7e13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c71896c6f4c3e8e1943b161db863233ee822dcdae3afa11d34303282087751e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e902cfa01699a0752a79c5eb3b101bec0c26eda237626e9a8aa244478cfed75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc56dc0d28b1b01ff12df8eb5994bded3c041bada1c692732a1b85acbf26494e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__484ce593e98bf9457e338d66b14fac482687896c33580f4a8c04f705469d8012)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c2d19615c2765554a9ac07008b8a674b3e4f33c378d176adc2608dfe0da7be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5bc49a6b3e3bee51cf37473cc5ba007229309bd465d2d3330ce2787914d686a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2469b834eda71cc28064429edb47d6e8647a2a98df00b1cd49e8b02323423c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2afbb81b1dc79727d052920340630ae0bfcd43d0755d32ed4a191e8b89a81e81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1c17a238b482635722050bae2e85439840429c7582243605666f4da960e5d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05a9b0f44762a7b69ca57665d373899190f27c7dfec31648ae86d59b8f5ae4ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9957d8b2f4cfc05a1130e1d90ca2b4b6c95c5447a4ebf233a65f4c0ff0581a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bcf4fce72bc7e6da0fca94c2e7c24deb6c25295bbc16d6bda557d04de284cf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c29df4930034e169fe57f017dd3f841563833ec8199387e17942276be5d2726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54e006ade5fb3d9b2f3b56bfb20b2e267293d391b769eae18c55d7cda3a9bfdf)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the request header, for example ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d740611e44ab0bd8ebee37479b7e5931d4119c78b273f0369739fdb259984f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66acf236bbb17b5d9c1198d36d5683b0aab0b6aad2eed7080d484a1d79168eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f5c5de4da78e0963afcf5c5c3087a5f4a357f8188a49886fd9ff3834cb460d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5337d9fcbe7994e4dd8e450d141c9bdbcd014f16991bd0591868dd8e8ef2c73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7236670185b229399e97d61bab07d68a4b56dfb83863c1eb1b34fd86600890)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3d29d0ce8c16426a0db9dba863b8e84ffa49f61febfb9b7accbc8c25517b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d504d279b273bfb02351562135bb65fa027be2f196d704b15769cdb40021dd70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__302ea95b67b13af0c2782e3e425df14cee24e18e0dcb0d8a5230c480672a5650)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d51bed0d11374a0d46b82bf0a112e4b29eac2de6fcd7e59cfc0615b457be445)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9228a29947e3a2a4151ce92c01a154a711a561c2cd251ba0ac8a26cb6453e13c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ce1908c7b6e163817b852c4d448e5fa0b9f609bb4e6c5122ebba81ad8d7006)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7759e35b7558f32e5295a9ebc97807f1d70db5b71174efaa3027cf8a0ad7ea89)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Any of these HTTP methods,  WebDAV methods, or Akamai operations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e13f5b69bb6e701550e44bc8cf49b97a8966a8c960b3308ca940aabbfa66c890)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f65519df239c7e13fa16932230fede9f3f1f0ed054c99800cc831b2e3d51229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94bd39f704cddb7c313618ca1af314727f5677c0abaa44aa5ebf7cb208cd46f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa88b8c05f7e65c6074e551b89ce611be32292f02ab226d4fe65ec3d4f3c61a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fd15d8a182b600f746034262818776521adc36892fe71c3d360ebbe0bb1a39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9158e78d8a1d51608d4ecd6bfc08eb4852001770fb937c652850c3136dc2447a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb2602a01b28d5a5fc4b6f19e6fe67198c5b89e7f42ecc8d46e92a3b6ace341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e686e47911ed469df4563b045e264967b0ee5d4a6b66c678f4a38e9efc14f7ec)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ddd895ffcdd615763f6e49563f7555c509732be4ae672bdda94f4ec5be5ba5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45f439f055e11f7a22ed03d2729db6602a5a18d1a819972d63f9f02dc4d58af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c9d150aea2b741b79fdb406bf173f40b29de33d78d7b67523721976ebb99d29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2360f7e625b93168046dc9e5c2cf4e31a93389b41f0d6139e747e37187a9be2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e276b915d087f37c4788cb16dcde4433bf25dec026f0166052c343a130dd3ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26609f0a2da5fa5ef4e869b954d482b87bdd680288962c828388885d84286c6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdca5be28c0a38aaf20de6e4a86afb220197abf333da7f11c44f3b28aacb14b4)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e532b694dd0f1d5945517558d542b5dba5d72ca8f62f3252c59802100c1c0cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eadf11cc9ea1d963ca8278b977df788912f0c8f157f2c7a1400baad3d8992a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479894a6c8da90f74e3c847ea433a642c16a414f870b71db441ff68939490b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2761dc648d5389bb8f6581aed646a49b37850e23f5cc38fe92ac333285b1a022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d86f011dbb30a5acac3674f4d0358ed13f84b88bc1882379e8dbce38578bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ddefd728a65a9c91fc92b01b73cb60596f2e34cf7dd2980adb59773a37a141)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9f5e5268d75e0fefa0fa0f61ed4d13c3cfdae9ad45228a029985d0acff6e71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f78191782e5c2f46460f20572831a34980e3423ce1b57c23af700c564c4366)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the response header, for example ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the match is case-sensitive for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match according to various criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c40c56ed3cba22bd20c8cbf2f03491f2314a01d39b8d1763ffb0dc63dc6e2fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3c5133b8f34c8fd7cef771b8dc001a829ececaa8d150b52dbb6182ea685798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a904f6fb3f7084e4cbf6fb4de0b6124b7de7efad65ed6c4e657209d186c9820)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c269b4b7d05431c3c07281b5861f5c4036e09d9fbc9dbd9c2f186ce4a50751)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b24666ff36e6d0a8d590f8658a614bfc06bf3bb03e2ac224537cb013d8b7bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a589077bcadd3999fe5ca27945ea677325d9b7eee729e64d1086e12b2a7611f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7042c1fa0c609844a13976e41af2d54b74530530d51cd89f90714d78366008e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f2cb1c3ab34543bd70c84160a57c40ecb0a86a4bd853c3427961107ad78404c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a36d66b52b81c5e4805eb6e9342bcc84ecaa20aa07655faa2445e91e3c02b80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5331b4237f8ad4ee492e25034552791fdd34f5d34523d9310ded8affad09b1d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15924f0bfc304087fc4bef40a1cf17b22585a5afefd9675ea56dd69566e66453)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c75ed9db6bb9ade3097216580112a92c64ea5ffbe7dad8621d666d89637fa7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af1a398941e0d0f6192e310000c7cbe2a1f6099e8d6638b51c50f5f466e584c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation",
    jsii_struct_bases=[],
    name_mapping={
        "continents": "continents",
        "countries": "countries",
        "location_type": "locationType",
        "locked": "locked",
        "match_operator": "matchOperator",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation:
    def __init__(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e23a9734fd924c885ef281a6fc8d1080d0600d28791a2485b81e6321e14ee2)
            check_type(argname="argument continents", value=continents, expected_type=type_hints["continents"])
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument location_type", value=location_type, expected_type=type_hints["location_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if continents is not None:
            self._values["continents"] = continents
        if countries is not None:
            self._values["countries"] = countries
        if location_type is not None:
            self._values["location_type"] = location_type
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def continents(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        '''
        result = self._values.get("continents")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def location_type(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        '''
        result = self._values.get("location_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aff9204fdb5ced838838bed1c08e6674862215d9e21eb8b69cde64848dcc6acf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetContinents")
    def reset_continents(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinents", []))

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetLocationType")
    def reset_location_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="continentsInput")
    def continents_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentsInput"))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="locationTypeInput")
    def location_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="continents")
    def continents(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continents"))

    @continents.setter
    def continents(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7738ab82c7c92255c9f2d69b0b3f093686458cb47db5a7f356bf0db98ab8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continents", value)

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5de60aada533ba60531777b3d803100b5a0a8320c2f2a84ea3dc5f77f696d893)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="locationType")
    def location_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationType"))

    @location_type.setter
    def location_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cd95d2526fd1693df4f3222dfc08fac4144a75a27b0f1a76739e1fe7f8a08cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b7e428851126bf8fe492ba5ada0a0150fd327daf2674031e54802adc9a4fd90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de456f7f49507423e6bc1baa0f5162a7835b107af47452a7b6a539a8e1a4c8bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82589ed316e0e2469fbd5df9a841956116998f3a71eec59c4dc35602e4b70228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b512d4f3cd037f4853b06c2efcf501d1519bc7bd12cc3b63d72e3a1f9f39326c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__936065b5b059eca2179b3f1ef885555da861208b34e8ca52b18115e52580eabc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a45f5daa6da60230deae897d64b4d8ce7b3a03721c44e43df4a781fc8e91186a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime",
    jsii_struct_bases=[],
    name_mapping={
        "apply_daylight_savings_time": "applyDaylightSavingsTime",
        "begin_date": "beginDate",
        "end_date": "endDate",
        "lasting_date": "lastingDate",
        "lasting_duration": "lastingDuration",
        "locked": "locked",
        "match_operator": "matchOperator",
        "repeat_begin_date": "repeatBeginDate",
        "repeat_duration": "repeatDuration",
        "repeat_interval": "repeatInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime:
    def __init__(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec3ccf741a28edd928fe12595c1bb84d4ba9a027b8e842e9582c545ce1778e1d)
            check_type(argname="argument apply_daylight_savings_time", value=apply_daylight_savings_time, expected_type=type_hints["apply_daylight_savings_time"])
            check_type(argname="argument begin_date", value=begin_date, expected_type=type_hints["begin_date"])
            check_type(argname="argument end_date", value=end_date, expected_type=type_hints["end_date"])
            check_type(argname="argument lasting_date", value=lasting_date, expected_type=type_hints["lasting_date"])
            check_type(argname="argument lasting_duration", value=lasting_duration, expected_type=type_hints["lasting_duration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument repeat_begin_date", value=repeat_begin_date, expected_type=type_hints["repeat_begin_date"])
            check_type(argname="argument repeat_duration", value=repeat_duration, expected_type=type_hints["repeat_duration"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_daylight_savings_time is not None:
            self._values["apply_daylight_savings_time"] = apply_daylight_savings_time
        if begin_date is not None:
            self._values["begin_date"] = begin_date
        if end_date is not None:
            self._values["end_date"] = end_date
        if lasting_date is not None:
            self._values["lasting_date"] = lasting_date
        if lasting_duration is not None:
            self._values["lasting_duration"] = lasting_duration
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if repeat_begin_date is not None:
            self._values["repeat_begin_date"] = repeat_begin_date
        if repeat_duration is not None:
            self._values["repeat_duration"] = repeat_duration
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def apply_daylight_savings_time(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adjusts the start time plus repeat interval to account for daylight saving time.

        Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        '''
        result = self._values.get("apply_daylight_savings_time")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        '''
        result = self._values.get("begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_date(self) -> typing.Optional[builtins.str]:
        '''Sets the end of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        '''
        result = self._values.get("end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        '''
        result = self._values.get("lasting_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the end of a time period as a duration relative to the ``lastingDate``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        '''
        result = self._values.get("lasting_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies how to define the range of time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of the initial time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        '''
        result = self._values.get("repeat_begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of each repeating time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        '''
        result = self._values.get("repeat_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Sets the time between each repeating time period's starting points.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTimeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTimeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1228b7cc5ec1ba8331145901e2fd97245644b390ece23ae0bf3c0e5ffa7239d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplyDaylightSavingsTime")
    def reset_apply_daylight_savings_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyDaylightSavingsTime", []))

    @jsii.member(jsii_name="resetBeginDate")
    def reset_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeginDate", []))

    @jsii.member(jsii_name="resetEndDate")
    def reset_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndDate", []))

    @jsii.member(jsii_name="resetLastingDate")
    def reset_lasting_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDate", []))

    @jsii.member(jsii_name="resetLastingDuration")
    def reset_lasting_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDuration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRepeatBeginDate")
    def reset_repeat_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatBeginDate", []))

    @jsii.member(jsii_name="resetRepeatDuration")
    def reset_repeat_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatDuration", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTimeInput")
    def apply_daylight_savings_time_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyDaylightSavingsTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="beginDateInput")
    def begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="endDateInput")
    def end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDateInput")
    def lasting_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDurationInput")
    def lasting_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDateInput")
    def repeat_begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatBeginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatDurationInput")
    def repeat_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTime")
    def apply_daylight_savings_time(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyDaylightSavingsTime"))

    @apply_daylight_savings_time.setter
    def apply_daylight_savings_time(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6a2af7eecf1d3e305f614245843e9f8c99a1c6e5ae3f2062f03621fd9f350a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyDaylightSavingsTime", value)

    @builtins.property
    @jsii.member(jsii_name="beginDate")
    def begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beginDate"))

    @begin_date.setter
    def begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c0c07d861d447b0182ae5e8dc5cf728edd886c6b5f6ccb3b1c55c77746af64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beginDate", value)

    @builtins.property
    @jsii.member(jsii_name="endDate")
    def end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endDate"))

    @end_date.setter
    def end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eec38241d2463dc297c94e01af1cf433f08edb1080f876a97815bee49af6edc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDate")
    def lasting_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDate"))

    @lasting_date.setter
    def lasting_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2def321d5a2d1310f7c46d966f6973b07c03f50f6bd55d0a033d7fcbffb7ddb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDuration")
    def lasting_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDuration"))

    @lasting_duration.setter
    def lasting_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd246460f97a7b9ff15cb63ce5a85000fb5ef25d7d329d745e624c9f88f957e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20201278ebdbefbb04e1ff7cbc179c06e7f7f0714f633f3863007ea0fce6ac38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f558e85dcacd07025ebd09064b81dc80ca5103c06b612ae633d214d175d252f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDate")
    def repeat_begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatBeginDate"))

    @repeat_begin_date.setter
    def repeat_begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86e6b44c7b518646220d8c31ee7c2b87bc06b6496e5ea49c7305fed63ae0a40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatBeginDate", value)

    @builtins.property
    @jsii.member(jsii_name="repeatDuration")
    def repeat_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatDuration"))

    @repeat_duration.setter
    def repeat_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b20d2acf75eea1831140f3df157ea9870835a40c518add8fb09a7a9d12af44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatDuration", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e3d05e1769e09a7de804115b66d6c4962956d064c67fd9549665b894548d5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00298052a832025d6703f52f99e748b3916cf83a7b7dd1188b314f03328c23ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57dd90be50eb1009c9f7f5a94a2183b2606d6ee4353b96d23450c2825b905e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3548f2066ed6201c1b35d68e49246011417aed867e816e8e2fc63cef79b017)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "status_list": "statusList",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd22162a1c4fea32bde06dd9284f4a8dc52d8c29f6ac04add08991db856c6bd3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument status_list", value=status_list, expected_type=type_hints["status_list"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if status_list is not None:
            self._values["status_list"] = status_list
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Error match scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_list(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.'''
        result = self._values.get("status_list")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55eea89d05ee55ed586f9e821a3be341a64f087f194170f67b841933a81ee5f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetStatusList")
    def reset_status_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusList", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="statusListInput")
    def status_list_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "statusListInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__390b12a8853a41978c8b2a22304b95ee3a5c5f929600417c125978a7659f2404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4afda8342590e0af3be81a766ba61a15428c91b203699b07fabb6e10d60a3f90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="statusList")
    def status_list(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "statusList"))

    @status_list.setter
    def status_list(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f743999439f16a9f02a5064453fe3a8ada56f218e377212ba75225b75236f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusList", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595d43c5ecfa11179edbfe3cab4fdf0fa3c4ec1337b3505b5e749fff50532564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c308aeb6285dc25a92f0dd856a130d4913e8356038708e3a39b7880682cae804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a04e4efe44ab6ffd30bc3097c2354749036e19a833a1d84efbe1a2b20eb66b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a61265d35647758dd9c8ef22c18a7dd8d0f252e6aa0fef3d4596cd1e6d4d171)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d21160e4f35e1ca442d2d4686bcab1f6cfbcef531c859ac5d30f3c37501b1b64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f79036f550658fac60bb8f749783a5da1252c63f3299ed128ceba1079066543f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51dc4b543ace02edde351b2ce150af390f4d00791b62e85b197a1c74d1ab3df8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d65b816aa7e998edc8eac903ea463058bae8290b6f0220f17c60b88018fef1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc63feab28574135a1354b0a96d316fc7f1449622cd18c460e365eec534647ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503903690e59f38897f0223bac5efbbf1234caa6c53242333de806a6c9cb9217)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810635ba002c8e2361d2647165edd934ecad795fcc27572fb3aa132f23f7fb7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a7370ad4a40f0b41f0ae2280332094748e13fb7c7ca4f1dcf4c2ab9af9e83c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4bb088d30eac67993a68b47746240e4efae7e36b639756dd3b523ad4c3c563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation",
    jsii_struct_bases=[],
    name_mapping={
        "check_ips": "checkIps",
        "continent_values": "continentValues",
        "country_values": "countryValues",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "region_values": "regionValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation:
    def __init__(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__851a69fa52b59b7d9024979348c927594c8e0ab97a54e29731055bff73c115fb)
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument continent_values", value=continent_values, expected_type=type_hints["continent_values"])
            check_type(argname="argument country_values", value=country_values, expected_type=type_hints["country_values"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument region_values", value=region_values, expected_type=type_hints["region_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if continent_values is not None:
            self._values["continent_values"] = continent_values
        if country_values is not None:
            self._values["country_values"] = country_values
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if region_values is not None:
            self._values["region_values"] = region_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def continent_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        '''
        result = self._values.get("continent_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def country_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        '''
        result = self._values.get("country_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def region_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        '''
        result = self._values.get("region_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4839458b45b028fd7d4f59aa86f3f37d6c73afcee67f3972d9618a790221851b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetContinentValues")
    def reset_continent_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinentValues", []))

    @jsii.member(jsii_name="resetCountryValues")
    def reset_country_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountryValues", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegionValues")
    def reset_region_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="continentValuesInput")
    def continent_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="countryValuesInput")
    def country_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countryValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionValuesInput")
    def region_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c354818956ab5a5caddbc20dbdb4c7731712d17fb5196cd62562b4ce44ddc119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="continentValues")
    def continent_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continentValues"))

    @continent_values.setter
    def continent_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4554fb4b557344e6eb125096ef351e6f2977c8166c2cff81bfa533be30353b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continentValues", value)

    @builtins.property
    @jsii.member(jsii_name="countryValues")
    def country_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countryValues"))

    @country_values.setter
    def country_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44224206808122a7b331e38b68a527934d985f0aa3594c79d37eb811759bf226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countryValues", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be6eccd425e2ddf5d0c680736b51fc235bcae0c5f498e6aac3e5384f826133e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b303193d31ddebfe49ae716b5ea768abda0fb613606f487e60d269fad978c6f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced4a3a2785285632e47d1de80e45e7714cc32c13597e4ed5aefd2ff159cf07b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regionValues")
    def region_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regionValues"))

    @region_values.setter
    def region_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac52c6a1a9d70c12704bc1d9d62a71991af9db79ef26dfeb7fe5867443effae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regionValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a63773d89edbc00d1184ca03b98b7454db5466fee66a4f5a0f850078e90d13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2492976d4732a38c12d361c5f1d629096eda42a80561a95e6b3b7585db848572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37e5da16149469d73c8305aa4d7616ac9b7e958715cd8a70bd40f9269a9b85c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee8d6ceea729cfe8b0784beedd2a2157565e33cd9723956ffac71a6ee6c731ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "bandwidth_values": "bandwidthValues",
        "check_ips": "checkIps",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "network_type_values": "networkTypeValues",
        "network_values": "networkValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork:
    def __init__(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4147eb4a9a5239494d2e20be8c4bbb27e53a23c35c0aeed7304b30f47600d03)
            check_type(argname="argument bandwidth_values", value=bandwidth_values, expected_type=type_hints["bandwidth_values"])
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network_type_values", value=network_type_values, expected_type=type_hints["network_type_values"])
            check_type(argname="argument network_values", value=network_values, expected_type=type_hints["network_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bandwidth_values is not None:
            self._values["bandwidth_values"] = bandwidth_values
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network_type_values is not None:
            self._values["network_type_values"] = network_type_values
        if network_values is not None:
            self._values["network_values"] = network_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bandwidth_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        '''
        result = self._values.get("bandwidth_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''The type of information to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network_type_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.'''
        result = self._values.get("network_type_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def network_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Any set of specific networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        '''
        result = self._values.get("network_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19f4f2bd5688b8b71c7c6e0fbbc674d0e99877b95e139ae71e7f306398e9630)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBandwidthValues")
    def reset_bandwidth_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBandwidthValues", []))

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetworkTypeValues")
    def reset_network_type_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkTypeValues", []))

    @jsii.member(jsii_name="resetNetworkValues")
    def reset_network_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValuesInput")
    def bandwidth_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "bandwidthValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkTypeValuesInput")
    def network_type_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkTypeValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="networkValuesInput")
    def network_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValues")
    def bandwidth_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "bandwidthValues"))

    @bandwidth_values.setter
    def bandwidth_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df30f7fc707ac9f7ea080ebbf4b96b8fd505da7a170635089bc6cbb067e38190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bandwidthValues", value)

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780364880f924acc09838a3b3d173a80e5dd1ef51f51b9013dfea39a4720a1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f016e266a1d5a7f1508a01ff4f220701c49e8fb18e30c297bc056ec9a049582)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d62f29a1e71486a8b606e89ada4396155a62c586bce875a555b5e3afd7faada8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f3b2b43c500e0224be886728b3b33782f64e975fdd4604c71310788de6b9466)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="networkTypeValues")
    def network_type_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkTypeValues"))

    @network_type_values.setter
    def network_type_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b21809eed2bdeb434294207ca0a5882d7bcc60aeba268639098cb5800a00cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkTypeValues", value)

    @builtins.property
    @jsii.member(jsii_name="networkValues")
    def network_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkValues"))

    @network_values.setter
    def network_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710d36928ded37f4e4b59c1f93cea7cf6cdd3ee4a1ae708f37cba96585c8bf73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3224ceefb622535a63fc9a4dc164c702a97d8c1097e6db1fa600d4b549a40057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea3e506cfde9e6307a269110a001c6bebd327c6f3d28fa363794f245495d49d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e4138da55a3f94ca8d6cf265dd273671e742826227955525248e4fcd4fc877)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c66e11a34f3e01df8b3c6cb716d9b7281289dc5d315f0ff381fef57e2b759b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "result": "result",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_names": "variableNames",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c35e300b5adcb802ee68ef90d556d30fad9963616d1f16b5b89c2d128c48d35)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument result", value=result, expected_type=type_hints["result"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_names", value=variable_names, expected_type=type_hints["variable_names"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if result is not None:
            self._values["result"] = result
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_names is not None:
            self._values["variable_names"] = variable_names

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def result(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        '''
        result = self._values.get("result")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name.

        Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        result = self._values.get("variable_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce356f284022fe028498e9318f30bf6295a794d63bf30deae36750474ca390d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResult")
    def reset_result(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResult", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableNames")
    def reset_variable_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableNames", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resultInput")
    def result_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resultInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNamesInput")
    def variable_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c57e7a8bc04f95311107e16717d8884746c0c63efcfd25820ae3218779500be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="result")
    def result(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "result"))

    @result.setter
    def result(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c91586f643a8b1421916dcc99a0a36336a416b2a13e2728dc5d0f65328eb4f54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "result", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2999a80198218d06b5589c8eed4736b88261fa4b28eeec269f9a6a76cdafe205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__701b1ee4889dd7b5704f5fea2d6472514b1c90ba0061e31e7d458c6f73428f90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableNames")
    def variable_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableNames"))

    @variable_names.setter
    def variable_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0089ea88d8e72cf6052ee42f464b327d09523277446ac496ee5c8d7d978dc857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableNames", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ad57953c53c7fc05492d551fd1dd8182b03d72e0a9a64664b7756d38c3f4ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d21a0d9c7258ebbf6ba754ba5ff62913530f1f77b58f83c60f5f87d881e65882)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``virtualWaitingRoom`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5bb9f8f3216b0ee0e97d10c027332fe3821f358bb2a96f3c189eb420e717128)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232ec2d50d0fa390589c90a94da1422980b056870d549b76e3113b32a522add3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b940e48900533d4f6c10e1b06f18907270ab26af25638fc3445a32346490ec9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66020d0ea48b87343e7dfe1257e31f978da7adfc229449a16ca99fc0b9c8841e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e43a35e08ea18b31954f0d42cbe08b5a87622df2a5733783e0f3a30c5cb3e7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b43ad24caf345ac3ab7d5f09825d6de2654bab005e39846d67ec666e1f0734e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f00404a7806fe2f4afdfd855163c0399649ad0f9306433d7f3c1323b13b6b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26ece697e873c706307c7916f587686132018ddd58eaa5807c069b815757b90b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ebb7c34ae35286608060d58c74b55beacb499c3c46f031f646b32bb9197bc3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c20c4c1505fcbb1004cdd86674a5a4342fce774e82a262ee054599f34c856e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d880119342e91c5c0149ae4bf190ddc46049ef62368f177ab83b77758e06d1e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0c8eb9e640bc3297e09ac8cfdd5c6a8e8838532a34420ac838e0acdd2fcaaa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db26a1669de6a90f683a43c0319895654407eae2c784fa8f47bd66b177e860f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c793acdc55e4199ce55ef36278a74ae0cb5184b4afd8b553797f3338c2aed95f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__405b5db98e7ee2b0649db7f656bedda19407c7376decc31b8d3499dc6f7b3409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride",
    jsii_struct_bases=[],
    name_mapping={"name": "name", "override_id": "overrideId"},
)
class DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride:
    def __init__(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59305e96f688eae3550755c2cc94a2e994943335704903966d37840fb346a9f9)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument override_id", value=override_id, expected_type=type_hints["override_id"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if name is not None:
            self._values["name"] = name
        if override_id is not None:
            self._values["override_id"] = override_id

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''The name of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def override_id(self) -> typing.Optional[builtins.str]:
        '''The ID of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        result = self._values.get("override_id")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8059dc97fa88e1e096d62d06b600c7331ee3f2523fa909dce5f4592ad25127a7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetOverrideId")
    def reset_override_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideId", []))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIdInput")
    def override_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideIdInput"))

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ddecab2e844abfecf069b399019f0db4f2fa450e3e1c34800414371ce39963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="overrideId")
    def override_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "overrideId"))

    @override_id.setter
    def override_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba136a876997b0261417249088bd50cef073d823d517dca61fb9b4bcf48baaed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideId", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f22a9580aeb56717fffe91686769bcfcfd7c9fba2f69e299613d0f6119370236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac923e3b9a4b53417222dd06368f360c9d387860e76fc5742132b0f8c2b9fd6a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBehavior")
    def put_behavior(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3d2b63c351a75a7072bfb05b0788fa8971b979131eff2c2d98d28216e83e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBehavior", [value]))

    @jsii.member(jsii_name="putCriterion")
    def put_criterion(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd07f4f67656309e9a4ddf04bce737a041842ce9a7a67282f656db363923915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCriterion", [value]))

    @jsii.member(jsii_name="putCustomOverride")
    def put_custom_override(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride(
            name=name, override_id=override_id
        )

        return typing.cast(None, jsii.invoke(self, "putCustomOverride", [value]))

    @jsii.member(jsii_name="putVariable")
    def put_variable(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20230920Variable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e53b42881bf067ae4ece224c714e3950915303194d0d70ee505c4f6c0ac6fc79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putVariable", [value]))

    @jsii.member(jsii_name="resetAdvancedOverride")
    def reset_advanced_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedOverride", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetChildren")
    def reset_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChildren", []))

    @jsii.member(jsii_name="resetComments")
    def reset_comments(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComments", []))

    @jsii.member(jsii_name="resetCriteriaLocked")
    def reset_criteria_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaLocked", []))

    @jsii.member(jsii_name="resetCriteriaMustSatisfy")
    def reset_criteria_must_satisfy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaMustSatisfy", []))

    @jsii.member(jsii_name="resetCriterion")
    def reset_criterion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriterion", []))

    @jsii.member(jsii_name="resetCustomOverride")
    def reset_custom_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomOverride", []))

    @jsii.member(jsii_name="resetIsSecure")
    def reset_is_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSecure", []))

    @jsii.member(jsii_name="resetTemplateLink")
    def reset_template_link(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateLink", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariable")
    def reset_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariable", []))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorList, jsii.get(self, "behavior"))

    @builtins.property
    @jsii.member(jsii_name="criterion")
    def criterion(self) -> DataAkamaiPropertyRulesBuilderRulesV20230920CriterionList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CriterionList, jsii.get(self, "criterion"))

    @builtins.property
    @jsii.member(jsii_name="customOverride")
    def custom_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverrideOutputReference, jsii.get(self, "customOverride"))

    @builtins.property
    @jsii.member(jsii_name="variable")
    def variable(self) -> "DataAkamaiPropertyRulesBuilderRulesV20230920VariableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920VariableList", jsii.get(self, "variable"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverrideInput")
    def advanced_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]]], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="childrenInput")
    def children_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "childrenInput"))

    @builtins.property
    @jsii.member(jsii_name="commentsInput")
    def comments_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "commentsInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaLockedInput")
    def criteria_locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "criteriaLockedInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfyInput")
    def criteria_must_satisfy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "criteriaMustSatisfyInput"))

    @builtins.property
    @jsii.member(jsii_name="criterionInput")
    def criterion_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]]], jsii.get(self, "criterionInput"))

    @builtins.property
    @jsii.member(jsii_name="customOverrideInput")
    def custom_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride], jsii.get(self, "customOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="isSecureInput")
    def is_secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSecureInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateLinkInput")
    def template_link_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateLinkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableInput")
    def variable_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Variable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20230920Variable"]]], jsii.get(self, "variableInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverride")
    def advanced_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advancedOverride"))

    @advanced_override.setter
    def advanced_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__355f18469459e46882c6781304a8309a5ccf4a69e1b7c974a7dfe3aa0a740b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advancedOverride", value)

    @builtins.property
    @jsii.member(jsii_name="children")
    def children(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "children"))

    @children.setter
    def children(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b61b2ec042a707fceae66f35bd07c5cc9a24c3e16e73dc488a3f985be2ca7c06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "children", value)

    @builtins.property
    @jsii.member(jsii_name="comments")
    def comments(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "comments"))

    @comments.setter
    def comments(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d12cb5f458244351ecd850f4884ad31fb0fce75fea3ff5ec6872433b1ec9d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "comments", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaLocked")
    def criteria_locked(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "criteriaLocked"))

    @criteria_locked.setter
    def criteria_locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ed60ccc8d005f5321b5d8c6c7c84217e84544366eec6234beb542ab4660b07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaLocked", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfy")
    def criteria_must_satisfy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "criteriaMustSatisfy"))

    @criteria_must_satisfy.setter
    def criteria_must_satisfy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d10e7af5153d8af3fe020d1fe289acd8fee6a580a1bf9899102af7ada011bbbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaMustSatisfy", value)

    @builtins.property
    @jsii.member(jsii_name="isSecure")
    def is_secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSecure"))

    @is_secure.setter
    def is_secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1669190c3313fd50e412780a687fb9247f1b1a94c43856a3bc8a46f0b509e7f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSecure", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ee01b4a6be7ddca93eb3f1d22155284bcda1acb355f09abf5a0cac66039907)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="templateLink")
    def template_link(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateLink"))

    @template_link.setter
    def template_link(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b8f6d1327313f32cab219d0b8e247ff0a3e8a01e794fe9a9ad49ce36b17cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateLink", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f28aa9ac9db79e0cdd5629ab25f6d88ba96ead3ebb989c9fcd896acac4ed38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__633eff46f8a3d2fccb5122a9dc5eea2ddb8da22bb88933f197475af1d26f322f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daf745fd637075965bd4fce8f8dae3db7f6a2b221717bdac94c741685348c04d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920Variable",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "hidden": "hidden",
        "name": "name",
        "sensitive": "sensitive",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20230920Variable:
    def __init__(
        self,
        *,
        description: builtins.str,
        hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        name: builtins.str,
        sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        value: builtins.str,
    ) -> None:
        '''
        :param description: The description for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param hidden: Whether a variable should be hidden. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        :param name: The name of a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param sensitive: States whether a variable contains sensitive information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        :param value: The value for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1343e67cbf9c4bb1bcea1f1f4367b14a918f3c300d3271ea43018891933e4714)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument hidden", value=hidden, expected_type=type_hints["hidden"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument sensitive", value=sensitive, expected_type=type_hints["sensitive"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "description": description,
            "hidden": hidden,
            "name": name,
            "sensitive": sensitive,
            "value": value,
        }

    @builtins.property
    def description(self) -> builtins.str:
        '''The description for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        assert result is not None, "Required property 'description' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''Whether a variable should be hidden.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        '''
        result = self._values.get("hidden")
        assert result is not None, "Required property 'hidden' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''States whether a variable contains sensitive information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        '''
        result = self._values.get("sensitive")
        assert result is not None, "Required property 'sensitive' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def value(self) -> builtins.str:
        '''The value for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        assert result is not None, "Required property 'value' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20230920Variable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20230920VariableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920VariableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7315664288a75cb0e3db8f37d0f4a86939c5eec920ec492105612b5568235e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20230920VariableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8cd1ba1d0412fee9ec922401fd07960a704f119dffcf6e25884fa5b0d2bef5b)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20230920VariableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6c6718fb3a2d49252bc529305dbe6a8a2812009472fc0e7c8d852bdcf37bb2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8625aac0bde3761354bc4fe55612ae99631d0c8314131e9252fe831ff117ac6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__148d42c5bc14d9baa4c148415a74c74a5bd2b8410dfe8764ca2211b8b91311f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Variable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Variable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Variable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb242462183b9d7fb82ed1cccdc009d3a18834099dc5305f7394ad3ca40fa232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20230920VariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20230920VariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8bf658fb53d1a92e950b8e931e4a1d52b462b9264b6331709f4084a37a4ead)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="hiddenInput")
    def hidden_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hiddenInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="sensitiveInput")
    def sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465bfef6b7731d4bf0d021a4773072c3a06bec93c40be12b82f7f7b8709cb402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="hidden")
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hidden"))

    @hidden.setter
    def hidden(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e40497a93c8f92f2bf22f0851b0b6c3376832313fba1f6e963c1457de31a9cff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hidden", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e824e948990d5d91dfeb5cc50edcad63e2b9c7ccb9828c81ff68463395110a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="sensitive")
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sensitive"))

    @sensitive.setter
    def sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ebe83a6054c24b0ee3447e00ffef57f068f5501354220ca1ff3dc6b0965506)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sensitive", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adfcb020e60b8188186132687e685ce8f856e816e4ed90007579e05530004569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Variable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Variable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Variable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af8113c142451918f7df49edae9a5e23413b1a4f7bad90518c395e5fca2042b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030",
    jsii_struct_bases=[],
    name_mapping={
        "name": "name",
        "advanced_override": "advancedOverride",
        "behavior": "behavior",
        "children": "children",
        "comments": "comments",
        "criteria_locked": "criteriaLocked",
        "criteria_must_satisfy": "criteriaMustSatisfy",
        "criterion": "criterion",
        "custom_override": "customOverride",
        "is_secure": "isSecure",
        "template_link": "templateLink",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable": "variable",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030:
    def __init__(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        if isinstance(custom_override, dict):
            custom_override = DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride(**custom_override)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4daed88e35767fc6da1ff666a02b4c20f683bf501a821f8a1957d13bb7ee65b)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument advanced_override", value=advanced_override, expected_type=type_hints["advanced_override"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument children", value=children, expected_type=type_hints["children"])
            check_type(argname="argument comments", value=comments, expected_type=type_hints["comments"])
            check_type(argname="argument criteria_locked", value=criteria_locked, expected_type=type_hints["criteria_locked"])
            check_type(argname="argument criteria_must_satisfy", value=criteria_must_satisfy, expected_type=type_hints["criteria_must_satisfy"])
            check_type(argname="argument criterion", value=criterion, expected_type=type_hints["criterion"])
            check_type(argname="argument custom_override", value=custom_override, expected_type=type_hints["custom_override"])
            check_type(argname="argument is_secure", value=is_secure, expected_type=type_hints["is_secure"])
            check_type(argname="argument template_link", value=template_link, expected_type=type_hints["template_link"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable", value=variable, expected_type=type_hints["variable"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "name": name,
        }
        if advanced_override is not None:
            self._values["advanced_override"] = advanced_override
        if behavior is not None:
            self._values["behavior"] = behavior
        if children is not None:
            self._values["children"] = children
        if comments is not None:
            self._values["comments"] = comments
        if criteria_locked is not None:
            self._values["criteria_locked"] = criteria_locked
        if criteria_must_satisfy is not None:
            self._values["criteria_must_satisfy"] = criteria_must_satisfy
        if criterion is not None:
            self._values["criterion"] = criterion
        if custom_override is not None:
            self._values["custom_override"] = custom_override
        if is_secure is not None:
            self._values["is_secure"] = is_secure
        if template_link is not None:
            self._values["template_link"] = template_link
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable is not None:
            self._values["variable"] = variable

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def advanced_override(self) -> typing.Optional[builtins.str]:
        '''XML metadata of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        '''
        result = self._values.get("advanced_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Behavior"]]]:
        '''behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Behavior"]]], result)

    @builtins.property
    def children(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of child rules for a particular rule in JSON format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        '''
        result = self._values.get("children")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def comments(self) -> typing.Optional[builtins.str]:
        '''The comments for a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        '''
        result = self._values.get("comments")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criteria_locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether changes to 'criterion' objects are prohibited.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        '''
        result = self._values.get("criteria_locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def criteria_must_satisfy(self) -> typing.Optional[builtins.str]:
        '''States whether 'all' criteria need to match or 'any'.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        '''
        result = self._values.get("criteria_must_satisfy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criterion(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Criterion"]]]:
        '''criterion block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        '''
        result = self._values.get("criterion")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Criterion"]]], result)

    @builtins.property
    def custom_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride"]:
        '''custom_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        '''
        result = self._values.get("custom_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride"], result)

    @builtins.property
    def is_secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether a rule is secure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        '''
        result = self._values.get("is_secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_link(self) -> typing.Optional[builtins.str]:
        '''The template link for the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        '''
        result = self._values.get("template_link")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of a rule template.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Variable"]]]:
        '''variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        result = self._values.get("variable")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Variable"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030Behavior",
    jsii_struct_bases=[],
    name_mapping={
        "adaptive_acceleration": "adaptiveAcceleration",
        "adaptive_image_compression": "adaptiveImageCompression",
        "ad_scaler_circuit_breaker": "adScalerCircuitBreaker",
        "advanced": "advanced",
        "aggregated_reporting": "aggregatedReporting",
        "akamaizer": "akamaizer",
        "akamaizer_tag": "akamaizerTag",
        "all_http_in_cache_hierarchy": "allHttpInCacheHierarchy",
        "allow_cloudlets_origins": "allowCloudletsOrigins",
        "allow_delete": "allowDelete",
        "allow_https_cache_key_sharing": "allowHttpsCacheKeySharing",
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_options": "allowOptions",
        "allow_patch": "allowPatch",
        "allow_post": "allowPost",
        "allow_put": "allowPut",
        "allow_transfer_encoding": "allowTransferEncoding",
        "alt_svc_header": "altSvcHeader",
        "api_prioritization": "apiPrioritization",
        "application_load_balancer": "applicationLoadBalancer",
        "audience_segmentation": "audienceSegmentation",
        "auto_domain_validation": "autoDomainValidation",
        "base_directory": "baseDirectory",
        "boss_beaconing": "bossBeaconing",
        "breadcrumbs": "breadcrumbs",
        "break_connection": "breakConnection",
        "brotli": "brotli",
        "cache_error": "cacheError",
        "cache_id": "cacheId",
        "cache_key_ignore_case": "cacheKeyIgnoreCase",
        "cache_key_query_params": "cacheKeyQueryParams",
        "cache_key_rewrite": "cacheKeyRewrite",
        "cache_post": "cachePost",
        "cache_redirect": "cacheRedirect",
        "cache_tag": "cacheTag",
        "cache_tag_visible": "cacheTagVisible",
        "caching": "caching",
        "central_authorization": "centralAuthorization",
        "chase_redirects": "chaseRedirects",
        "client_certificate_auth": "clientCertificateAuth",
        "client_characteristics": "clientCharacteristics",
        "cloud_interconnects": "cloudInterconnects",
        "cloud_wrapper": "cloudWrapper",
        "cloud_wrapper_advanced": "cloudWrapperAdvanced",
        "common_media_client_data": "commonMediaClientData",
        "conditional_origin": "conditionalOrigin",
        "construct_response": "constructResponse",
        "content_characteristics": "contentCharacteristics",
        "content_characteristics_amd": "contentCharacteristicsAmd",
        "content_characteristics_dd": "contentCharacteristicsDd",
        "content_characteristics_wsd_large_file": "contentCharacteristicsWsdLargeFile",
        "content_characteristics_wsd_live": "contentCharacteristicsWsdLive",
        "content_characteristics_wsd_vod": "contentCharacteristicsWsdVod",
        "content_pre_position": "contentPrePosition",
        "content_targeting_protection": "contentTargetingProtection",
        "cors_support": "corsSupport",
        "cp_code": "cpCode",
        "custom_behavior": "customBehavior",
        "datastream": "datastream",
        "dcp": "dcp",
        "dcp_auth_hmac_transformation": "dcpAuthHmacTransformation",
        "dcp_auth_regex_transformation": "dcpAuthRegexTransformation",
        "dcp_auth_substring_transformation": "dcpAuthSubstringTransformation",
        "dcp_auth_variable_extractor": "dcpAuthVariableExtractor",
        "dcp_default_authz_groups": "dcpDefaultAuthzGroups",
        "dcp_dev_relations": "dcpDevRelations",
        "dcp_real_time_auth": "dcpRealTimeAuth",
        "delivery_receipt": "deliveryReceipt",
        "deny_access": "denyAccess",
        "deny_direct_failover_access": "denyDirectFailoverAccess",
        "device_characteristic_cache_id": "deviceCharacteristicCacheId",
        "device_characteristic_header": "deviceCharacteristicHeader",
        "dns_async_refresh": "dnsAsyncRefresh",
        "dns_prefresh": "dnsPrefresh",
        "downgrade_protocol": "downgradeProtocol",
        "download_complete_marker": "downloadCompleteMarker",
        "download_notification": "downloadNotification",
        "downstream_cache": "downstreamCache",
        "dynamic_throughtput_optimization": "dynamicThroughtputOptimization",
        "dynamic_throughtput_optimization_override": "dynamicThroughtputOptimizationOverride",
        "dynamic_web_content": "dynamicWebContent",
        "ecms_bulk_upload": "ecmsBulkUpload",
        "ecms_database": "ecmsDatabase",
        "ecms_dataset": "ecmsDataset",
        "ecms_object_key": "ecmsObjectKey",
        "edge_connect": "edgeConnect",
        "edge_load_balancing_advanced": "edgeLoadBalancingAdvanced",
        "edge_load_balancing_data_center": "edgeLoadBalancingDataCenter",
        "edge_load_balancing_origin": "edgeLoadBalancingOrigin",
        "edge_origin_authorization": "edgeOriginAuthorization",
        "edge_redirector": "edgeRedirector",
        "edge_scape": "edgeScape",
        "edge_side_includes": "edgeSideIncludes",
        "edge_worker": "edgeWorker",
        "enforce_mtls_settings": "enforceMtlsSettings",
        "enhanced_akamai_protocol": "enhancedAkamaiProtocol",
        "enhanced_proxy_detection": "enhancedProxyDetection",
        "epd_forward_header_enrichment": "epdForwardHeaderEnrichment",
        "fail_action": "failAction",
        "failover_bot_manager_feature_compatibility": "failoverBotManagerFeatureCompatibility",
        "fast_invalidate": "fastInvalidate",
        "fips": "fips",
        "first_party_marketing": "firstPartyMarketing",
        "first_party_marketing_plus": "firstPartyMarketingPlus",
        "forward_rewrite": "forwardRewrite",
        "g2_oheader": "g2Oheader",
        "global_request_number": "globalRequestNumber",
        "graphql_caching": "graphqlCaching",
        "gzip_response": "gzipResponse",
        "hd_data_advanced": "hdDataAdvanced",
        "health_detection": "healthDetection",
        "hsaf_eip_binding": "hsafEipBinding",
        "http2": "http2",
        "http3": "http3",
        "http_strict_transport_security": "httpStrictTransportSecurity",
        "http_to_https_upgrade": "httpToHttpsUpgrade",
        "image_and_video_manager": "imageAndVideoManager",
        "image_manager": "imageManager",
        "image_manager_video": "imageManagerVideo",
        "im_override": "imOverride",
        "include": "include",
        "instant": "instant",
        "instant_config": "instantConfig",
        "large_file_optimization": "largeFileOptimization",
        "large_file_optimization_advanced": "largeFileOptimizationAdvanced",
        "limit_bit_rate": "limitBitRate",
        "log_custom": "logCustom",
        "manifest_personalization": "manifestPersonalization",
        "manifest_rerouting": "manifestRerouting",
        "manual_server_push": "manualServerPush",
        "media_acceleration": "mediaAcceleration",
        "media_acceleration_quic_optout": "mediaAccelerationQuicOptout",
        "media_client": "mediaClient",
        "media_file_retrieval_optimization": "mediaFileRetrievalOptimization",
        "media_origin_failover": "mediaOriginFailover",
        "metadata_caching": "metadataCaching",
        "mobile_sdk_performance": "mobileSdkPerformance",
        "modify_incoming_request_header": "modifyIncomingRequestHeader",
        "modify_incoming_response_header": "modifyIncomingResponseHeader",
        "modify_outgoing_request_header": "modifyOutgoingRequestHeader",
        "modify_outgoing_response_header": "modifyOutgoingResponseHeader",
        "modify_via_header": "modifyViaHeader",
        "m_pulse": "mPulse",
        "origin": "origin",
        "origin_characteristics": "originCharacteristics",
        "origin_characteristics_wsd": "originCharacteristicsWsd",
        "origin_failure_recovery_method": "originFailureRecoveryMethod",
        "origin_failure_recovery_policy": "originFailureRecoveryPolicy",
        "origin_ip_acl": "originIpAcl",
        "permissions_policy": "permissionsPolicy",
        "persistent_client_connection": "persistentClientConnection",
        "persistent_connection": "persistentConnection",
        "personally_identifiable_information": "personallyIdentifiableInformation",
        "phased_release": "phasedRelease",
        "preconnect": "preconnect",
        "predictive_content_delivery": "predictiveContentDelivery",
        "predictive_prefetching": "predictivePrefetching",
        "prefetch": "prefetch",
        "prefetchable": "prefetchable",
        "prefresh_cache": "prefreshCache",
        "quality": "quality",
        "quic_beta": "quicBeta",
        "random_seek": "randomSeek",
        "rapid": "rapid",
        "read_timeout": "readTimeout",
        "real_time_reporting": "realTimeReporting",
        "real_user_monitoring": "realUserMonitoring",
        "redirect": "redirect",
        "redirectplus": "redirectplus",
        "referer_checking": "refererChecking",
        "remove_query_parameter": "removeQueryParameter",
        "remove_vary": "removeVary",
        "report": "report",
        "request_client_hints": "requestClientHints",
        "request_control": "requestControl",
        "request_type_marker": "requestTypeMarker",
        "resource_optimizer": "resourceOptimizer",
        "resource_optimizer_extended_compatibility": "resourceOptimizerExtendedCompatibility",
        "response_code": "responseCode",
        "response_cookie": "responseCookie",
        "restrict_object_caching": "restrictObjectCaching",
        "return_cache_status": "returnCacheStatus",
        "rewrite_url": "rewriteUrl",
        "rum_custom": "rumCustom",
        "saas_definitions": "saasDefinitions",
        "sales_force_commerce_cloud_client": "salesForceCommerceCloudClient",
        "sales_force_commerce_cloud_provider": "salesForceCommerceCloudProvider",
        "sales_force_commerce_cloud_provider_host_header": "salesForceCommerceCloudProviderHostHeader",
        "save_post_dca_processing": "savePostDcaProcessing",
        "schedule_invalidation": "scheduleInvalidation",
        "script_management": "scriptManagement",
        "segmented_content_protection": "segmentedContentProtection",
        "segmented_media_optimization": "segmentedMediaOptimization",
        "segmented_media_streaming_prefetch": "segmentedMediaStreamingPrefetch",
        "set_variable": "setVariable",
        "simulate_error_code": "simulateErrorCode",
        "site_shield": "siteShield",
        "standard_tls_migration": "standardTlsMigration",
        "standard_tls_migration_override": "standardTlsMigrationOverride",
        "strict_header_parsing": "strictHeaderParsing",
        "sub_customer": "subCustomer",
        "sure_route": "sureRoute",
        "tcp_optimization": "tcpOptimization",
        "tea_leaf": "teaLeaf",
        "tiered_distribution": "tieredDistribution",
        "tiered_distribution_advanced": "tieredDistributionAdvanced",
        "tiered_distribution_customization": "tieredDistributionCustomization",
        "timeout": "timeout",
        "uid_configuration": "uidConfiguration",
        "validate_entity_tag": "validateEntityTag",
        "verify_json_web_token": "verifyJsonWebToken",
        "verify_json_web_token_for_dcp": "verifyJsonWebTokenForDcp",
        "verify_token_authorization": "verifyTokenAuthorization",
        "virtual_waiting_room": "virtualWaitingRoom",
        "virtual_waiting_room_with_edge_workers": "virtualWaitingRoomWithEdgeWorkers",
        "visitor_prioritization": "visitorPrioritization",
        "visitor_prioritization_fifo": "visitorPrioritizationFifo",
        "visitor_prioritization_fifo_standalone": "visitorPrioritizationFifoStandalone",
        "watermarking": "watermarking",
        "web_application_firewall": "webApplicationFirewall",
        "webdav": "webdav",
        "web_sockets": "webSockets",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030Behavior:
    def __init__(
        self,
        *,
        adaptive_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        adaptive_image_compression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression", typing.Dict[builtins.str, typing.Any]]] = None,
        ad_scaler_circuit_breaker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker", typing.Dict[builtins.str, typing.Any]]] = None,
        advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        aggregated_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag", typing.Dict[builtins.str, typing.Any]]] = None,
        all_http_in_cache_hierarchy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_cloudlets_origins: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_delete: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_cache_key_sharing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_downgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_options: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_patch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_put: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_transfer_encoding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding", typing.Dict[builtins.str, typing.Any]]] = None,
        alt_svc_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        api_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        application_load_balancer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer", typing.Dict[builtins.str, typing.Any]]] = None,
        audience_segmentation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation", typing.Dict[builtins.str, typing.Any]]] = None,
        auto_domain_validation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation", typing.Dict[builtins.str, typing.Any]]] = None,
        base_directory: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory", typing.Dict[builtins.str, typing.Any]]] = None,
        boss_beaconing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing", typing.Dict[builtins.str, typing.Any]]] = None,
        breadcrumbs: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs", typing.Dict[builtins.str, typing.Any]]] = None,
        break_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        brotli: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_ignore_case: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_query_params: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag_visible: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible", typing.Dict[builtins.str, typing.Any]]] = None,
        caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        central_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        chase_redirects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        client_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_interconnects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        common_media_client_data: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData", typing.Dict[builtins.str, typing.Any]]] = None,
        conditional_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        construct_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_amd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_dd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_large_file: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_live: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_vod: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod", typing.Dict[builtins.str, typing.Any]]] = None,
        content_pre_position: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition", typing.Dict[builtins.str, typing.Any]]] = None,
        content_targeting_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        cors_support: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        custom_behavior: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior", typing.Dict[builtins.str, typing.Any]]] = None,
        datastream: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_hmac_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_regex_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_substring_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_variable_extractor: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_default_authz_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_dev_relations: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_real_time_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        delivery_receipt: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_direct_failover_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_async_refresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_prefresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        downgrade_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        download_complete_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        download_notification: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification", typing.Dict[builtins.str, typing.Any]]] = None,
        downstream_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_web_content: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_bulk_upload: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_database: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_dataset: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_object_key: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_connect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_data_center: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_origin_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_redirector: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_scape: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_side_includes: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_worker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker", typing.Dict[builtins.str, typing.Any]]] = None,
        enforce_mtls_settings: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_akamai_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_proxy_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        epd_forward_header_enrichment: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment", typing.Dict[builtins.str, typing.Any]]] = None,
        fail_action: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction", typing.Dict[builtins.str, typing.Any]]] = None,
        failover_bot_manager_feature_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        fast_invalidate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate", typing.Dict[builtins.str, typing.Any]]] = None,
        fips: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing_plus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus", typing.Dict[builtins.str, typing.Any]]] = None,
        forward_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        g2_oheader: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader", typing.Dict[builtins.str, typing.Any]]] = None,
        global_request_number: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber", typing.Dict[builtins.str, typing.Any]]] = None,
        graphql_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        gzip_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        hd_data_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        health_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        hsaf_eip_binding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding", typing.Dict[builtins.str, typing.Any]]] = None,
        http2: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2", typing.Dict[builtins.str, typing.Any]]] = None,
        http3: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3", typing.Dict[builtins.str, typing.Any]]] = None,
        http_strict_transport_security: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity", typing.Dict[builtins.str, typing.Any]]] = None,
        http_to_https_upgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade", typing.Dict[builtins.str, typing.Any]]] = None,
        image_and_video_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager_video: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo", typing.Dict[builtins.str, typing.Any]]] = None,
        im_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        include: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude", typing.Dict[builtins.str, typing.Any]]] = None,
        instant: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant", typing.Dict[builtins.str, typing.Any]]] = None,
        instant_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        limit_bit_rate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate", typing.Dict[builtins.str, typing.Any]]] = None,
        log_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_personalization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_rerouting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting", typing.Dict[builtins.str, typing.Any]]] = None,
        manual_server_push: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration_quic_optout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout", typing.Dict[builtins.str, typing.Any]]] = None,
        media_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient", typing.Dict[builtins.str, typing.Any]]] = None,
        media_file_retrieval_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        media_origin_failover: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        mobile_sdk_performance: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_via_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        m_pulse: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse", typing.Dict[builtins.str, typing.Any]]] = None,
        origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics_wsd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_ip_acl: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl", typing.Dict[builtins.str, typing.Any]]] = None,
        permissions_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_client_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        personally_identifiable_information: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation", typing.Dict[builtins.str, typing.Any]]] = None,
        phased_release: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease", typing.Dict[builtins.str, typing.Any]]] = None,
        preconnect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_content_delivery: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_prefetching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetchable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable", typing.Dict[builtins.str, typing.Any]]] = None,
        prefresh_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache", typing.Dict[builtins.str, typing.Any]]] = None,
        quality: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality", typing.Dict[builtins.str, typing.Any]]] = None,
        quic_beta: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta", typing.Dict[builtins.str, typing.Any]]] = None,
        random_seek: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek", typing.Dict[builtins.str, typing.Any]]] = None,
        rapid: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid", typing.Dict[builtins.str, typing.Any]]] = None,
        read_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        real_time_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        real_user_monitoring: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring", typing.Dict[builtins.str, typing.Any]]] = None,
        redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        redirectplus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus", typing.Dict[builtins.str, typing.Any]]] = None,
        referer_checking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_query_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_vary: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary", typing.Dict[builtins.str, typing.Any]]] = None,
        report: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport", typing.Dict[builtins.str, typing.Any]]] = None,
        request_client_hints: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints", typing.Dict[builtins.str, typing.Any]]] = None,
        request_control: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer_extended_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        response_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        restrict_object_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        return_cache_status: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus", typing.Dict[builtins.str, typing.Any]]] = None,
        rewrite_url: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl", typing.Dict[builtins.str, typing.Any]]] = None,
        rum_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        saas_definitions: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        save_post_dca_processing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing", typing.Dict[builtins.str, typing.Any]]] = None,
        schedule_invalidation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation", typing.Dict[builtins.str, typing.Any]]] = None,
        script_management: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_content_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_streaming_prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        set_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        simulate_error_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode", typing.Dict[builtins.str, typing.Any]]] = None,
        site_shield: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        strict_header_parsing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing", typing.Dict[builtins.str, typing.Any]]] = None,
        sub_customer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer", typing.Dict[builtins.str, typing.Any]]] = None,
        sure_route: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute", typing.Dict[builtins.str, typing.Any]]] = None,
        tcp_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        tea_leaf: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_customization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization", typing.Dict[builtins.str, typing.Any]]] = None,
        timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        uid_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        validate_entity_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token_for_dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo_standalone: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone", typing.Dict[builtins.str, typing.Any]]] = None,
        watermarking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking", typing.Dict[builtins.str, typing.Any]]] = None,
        web_application_firewall: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall", typing.Dict[builtins.str, typing.Any]]] = None,
        webdav: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav", typing.Dict[builtins.str, typing.Any]]] = None,
        web_sockets: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param adaptive_acceleration: adaptive_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        :param adaptive_image_compression: adaptive_image_compression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        :param ad_scaler_circuit_breaker: ad_scaler_circuit_breaker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        :param advanced: advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param aggregated_reporting: aggregated_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        :param akamaizer: akamaizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        :param akamaizer_tag: akamaizer_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        :param all_http_in_cache_hierarchy: all_http_in_cache_hierarchy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        :param allow_cloudlets_origins: allow_cloudlets_origins block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        :param allow_delete: allow_delete block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        :param allow_https_cache_key_sharing: allow_https_cache_key_sharing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        :param allow_https_downgrade: allow_https_downgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_options: allow_options block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        :param allow_patch: allow_patch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        :param allow_post: allow_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        :param allow_put: allow_put block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        :param allow_transfer_encoding: allow_transfer_encoding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        :param alt_svc_header: alt_svc_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        :param api_prioritization: api_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        :param application_load_balancer: application_load_balancer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        :param audience_segmentation: audience_segmentation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        :param auto_domain_validation: auto_domain_validation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        :param base_directory: base_directory block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        :param boss_beaconing: boss_beaconing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        :param breadcrumbs: breadcrumbs block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        :param break_connection: break_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        :param brotli: brotli block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        :param cache_error: cache_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        :param cache_id: cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        :param cache_key_ignore_case: cache_key_ignore_case block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        :param cache_key_query_params: cache_key_query_params block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        :param cache_key_rewrite: cache_key_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        :param cache_post: cache_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        :param cache_redirect: cache_redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        :param cache_tag: cache_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        :param cache_tag_visible: cache_tag_visible block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        :param caching: caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param central_authorization: central_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        :param chase_redirects: chase_redirects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        :param client_certificate_auth: client_certificate_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_auth DataAkamaiPropertyRulesBuilder#client_certificate_auth}
        :param client_characteristics: client_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        :param cloud_interconnects: cloud_interconnects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        :param cloud_wrapper: cloud_wrapper block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        :param cloud_wrapper_advanced: cloud_wrapper_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        :param common_media_client_data: common_media_client_data block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        :param conditional_origin: conditional_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        :param construct_response: construct_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        :param content_characteristics: content_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        :param content_characteristics_amd: content_characteristics_amd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        :param content_characteristics_dd: content_characteristics_dd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        :param content_characteristics_wsd_large_file: content_characteristics_wsd_large_file block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        :param content_characteristics_wsd_live: content_characteristics_wsd_live block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        :param content_characteristics_wsd_vod: content_characteristics_wsd_vod block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        :param content_pre_position: content_pre_position block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        :param content_targeting_protection: content_targeting_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        :param cors_support: cors_support block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param custom_behavior: custom_behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        :param datastream: datastream block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        :param dcp: dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        :param dcp_auth_hmac_transformation: dcp_auth_hmac_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        :param dcp_auth_regex_transformation: dcp_auth_regex_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        :param dcp_auth_substring_transformation: dcp_auth_substring_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        :param dcp_auth_variable_extractor: dcp_auth_variable_extractor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        :param dcp_default_authz_groups: dcp_default_authz_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        :param dcp_dev_relations: dcp_dev_relations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        :param dcp_real_time_auth: dcp_real_time_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        :param delivery_receipt: delivery_receipt block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        :param deny_access: deny_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        :param deny_direct_failover_access: deny_direct_failover_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        :param device_characteristic_cache_id: device_characteristic_cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        :param device_characteristic_header: device_characteristic_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        :param dns_async_refresh: dns_async_refresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        :param dns_prefresh: dns_prefresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        :param downgrade_protocol: downgrade_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        :param download_complete_marker: download_complete_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        :param download_notification: download_notification block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        :param downstream_cache: downstream_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        :param dynamic_throughtput_optimization: dynamic_throughtput_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        :param dynamic_throughtput_optimization_override: dynamic_throughtput_optimization_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        :param dynamic_web_content: dynamic_web_content block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param ecms_bulk_upload: ecms_bulk_upload block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        :param ecms_database: ecms_database block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        :param ecms_dataset: ecms_dataset block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        :param ecms_object_key: ecms_object_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        :param edge_connect: edge_connect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        :param edge_load_balancing_advanced: edge_load_balancing_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        :param edge_load_balancing_data_center: edge_load_balancing_data_center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        :param edge_load_balancing_origin: edge_load_balancing_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        :param edge_origin_authorization: edge_origin_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        :param edge_redirector: edge_redirector block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        :param edge_scape: edge_scape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        :param edge_side_includes: edge_side_includes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        :param edge_worker: edge_worker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        :param enforce_mtls_settings: enforce_mtls_settings block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls_settings DataAkamaiPropertyRulesBuilder#enforce_mtls_settings}
        :param enhanced_akamai_protocol: enhanced_akamai_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        :param enhanced_proxy_detection: enhanced_proxy_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        :param epd_forward_header_enrichment: epd_forward_header_enrichment block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        :param fail_action: fail_action block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        :param failover_bot_manager_feature_compatibility: failover_bot_manager_feature_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        :param fast_invalidate: fast_invalidate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        :param fips: fips block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fips DataAkamaiPropertyRulesBuilder#fips}
        :param first_party_marketing: first_party_marketing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        :param first_party_marketing_plus: first_party_marketing_plus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        :param forward_rewrite: forward_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        :param g2_oheader: g2oheader block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        :param global_request_number: global_request_number block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        :param graphql_caching: graphql_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        :param gzip_response: gzip_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        :param hd_data_advanced: hd_data_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        :param health_detection: health_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        :param hsaf_eip_binding: hsaf_eip_binding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        :param http2: http2 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        :param http3: http3 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        :param http_strict_transport_security: http_strict_transport_security block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        :param http_to_https_upgrade: http_to_https_upgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        :param image_and_video_manager: image_and_video_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        :param image_manager: image_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        :param image_manager_video: image_manager_video block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        :param im_override: im_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        :param include: include block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        :param instant: instant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        :param instant_config: instant_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        :param large_file_optimization: large_file_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        :param large_file_optimization_advanced: large_file_optimization_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        :param limit_bit_rate: limit_bit_rate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        :param log_custom: log_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        :param manifest_personalization: manifest_personalization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        :param manifest_rerouting: manifest_rerouting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        :param manual_server_push: manual_server_push block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        :param media_acceleration: media_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        :param media_acceleration_quic_optout: media_acceleration_quic_optout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        :param media_client: media_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        :param media_file_retrieval_optimization: media_file_retrieval_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        :param media_origin_failover: media_origin_failover block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        :param metadata_caching: metadata_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        :param mobile_sdk_performance: mobile_sdk_performance block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        :param modify_incoming_request_header: modify_incoming_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        :param modify_incoming_response_header: modify_incoming_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        :param modify_outgoing_request_header: modify_outgoing_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        :param modify_outgoing_response_header: modify_outgoing_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        :param modify_via_header: modify_via_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        :param m_pulse: m_pulse block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param origin: origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param origin_characteristics: origin_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        :param origin_characteristics_wsd: origin_characteristics_wsd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        :param origin_failure_recovery_method: origin_failure_recovery_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        :param origin_failure_recovery_policy: origin_failure_recovery_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        :param origin_ip_acl: origin_ip_acl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        :param permissions_policy: permissions_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy DataAkamaiPropertyRulesBuilder#permissions_policy}
        :param persistent_client_connection: persistent_client_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        :param persistent_connection: persistent_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        :param personally_identifiable_information: personally_identifiable_information block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        :param phased_release: phased_release block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        :param preconnect: preconnect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        :param predictive_content_delivery: predictive_content_delivery block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        :param predictive_prefetching: predictive_prefetching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        :param prefetch: prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param prefetchable: prefetchable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        :param prefresh_cache: prefresh_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        :param quality: quality block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        :param quic_beta: quic_beta block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        :param random_seek: random_seek block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        :param rapid: rapid block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        :param read_timeout: read_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        :param real_time_reporting: real_time_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        :param real_user_monitoring: real_user_monitoring block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param redirect: redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirectplus: redirectplus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        :param referer_checking: referer_checking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        :param remove_query_parameter: remove_query_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        :param remove_vary: remove_vary block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        :param report: report block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        :param request_client_hints: request_client_hints block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_client_hints DataAkamaiPropertyRulesBuilder#request_client_hints}
        :param request_control: request_control block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        :param request_type_marker: request_type_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        :param resource_optimizer: resource_optimizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        :param resource_optimizer_extended_compatibility: resource_optimizer_extended_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        :param response_code: response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param response_cookie: response_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        :param restrict_object_caching: restrict_object_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        :param return_cache_status: return_cache_status block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        :param rewrite_url: rewrite_url block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        :param rum_custom: rum_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        :param saas_definitions: saas_definitions block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        :param sales_force_commerce_cloud_client: sales_force_commerce_cloud_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        :param sales_force_commerce_cloud_provider: sales_force_commerce_cloud_provider block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        :param sales_force_commerce_cloud_provider_host_header: sales_force_commerce_cloud_provider_host_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        :param save_post_dca_processing: save_post_dca_processing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        :param schedule_invalidation: schedule_invalidation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        :param script_management: script_management block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        :param segmented_content_protection: segmented_content_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        :param segmented_media_optimization: segmented_media_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        :param segmented_media_streaming_prefetch: segmented_media_streaming_prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        :param set_variable: set_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        :param simulate_error_code: simulate_error_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        :param site_shield: site_shield block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        :param standard_tls_migration: standard_tls_migration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        :param standard_tls_migration_override: standard_tls_migration_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        :param strict_header_parsing: strict_header_parsing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        :param sub_customer: sub_customer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        :param sure_route: sure_route block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param tcp_optimization: tcp_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        :param tea_leaf: tea_leaf block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        :param tiered_distribution: tiered_distribution block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        :param tiered_distribution_advanced: tiered_distribution_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        :param tiered_distribution_customization: tiered_distribution_customization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        :param timeout: timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uid_configuration: uid_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        :param validate_entity_tag: validate_entity_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        :param verify_json_web_token: verify_json_web_token block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        :param verify_json_web_token_for_dcp: verify_json_web_token_for_dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        :param verify_token_authorization: verify_token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        :param virtual_waiting_room: virtual_waiting_room block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        :param virtual_waiting_room_with_edge_workers: virtual_waiting_room_with_edge_workers block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        :param visitor_prioritization: visitor_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        :param visitor_prioritization_fifo: visitor_prioritization_fifo block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        :param visitor_prioritization_fifo_standalone: visitor_prioritization_fifo_standalone block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        :param watermarking: watermarking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        :param web_application_firewall: web_application_firewall block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        :param webdav: webdav block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        :param web_sockets: web_sockets block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        if isinstance(adaptive_acceleration, dict):
            adaptive_acceleration = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration(**adaptive_acceleration)
        if isinstance(adaptive_image_compression, dict):
            adaptive_image_compression = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression(**adaptive_image_compression)
        if isinstance(ad_scaler_circuit_breaker, dict):
            ad_scaler_circuit_breaker = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker(**ad_scaler_circuit_breaker)
        if isinstance(advanced, dict):
            advanced = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced(**advanced)
        if isinstance(aggregated_reporting, dict):
            aggregated_reporting = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting(**aggregated_reporting)
        if isinstance(akamaizer, dict):
            akamaizer = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer(**akamaizer)
        if isinstance(akamaizer_tag, dict):
            akamaizer_tag = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag(**akamaizer_tag)
        if isinstance(all_http_in_cache_hierarchy, dict):
            all_http_in_cache_hierarchy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy(**all_http_in_cache_hierarchy)
        if isinstance(allow_cloudlets_origins, dict):
            allow_cloudlets_origins = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins(**allow_cloudlets_origins)
        if isinstance(allow_delete, dict):
            allow_delete = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete(**allow_delete)
        if isinstance(allow_https_cache_key_sharing, dict):
            allow_https_cache_key_sharing = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing(**allow_https_cache_key_sharing)
        if isinstance(allow_https_downgrade, dict):
            allow_https_downgrade = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade(**allow_https_downgrade)
        if isinstance(allow_options, dict):
            allow_options = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions(**allow_options)
        if isinstance(allow_patch, dict):
            allow_patch = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch(**allow_patch)
        if isinstance(allow_post, dict):
            allow_post = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost(**allow_post)
        if isinstance(allow_put, dict):
            allow_put = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut(**allow_put)
        if isinstance(allow_transfer_encoding, dict):
            allow_transfer_encoding = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding(**allow_transfer_encoding)
        if isinstance(alt_svc_header, dict):
            alt_svc_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader(**alt_svc_header)
        if isinstance(api_prioritization, dict):
            api_prioritization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization(**api_prioritization)
        if isinstance(application_load_balancer, dict):
            application_load_balancer = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer(**application_load_balancer)
        if isinstance(audience_segmentation, dict):
            audience_segmentation = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation(**audience_segmentation)
        if isinstance(auto_domain_validation, dict):
            auto_domain_validation = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation(**auto_domain_validation)
        if isinstance(base_directory, dict):
            base_directory = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory(**base_directory)
        if isinstance(boss_beaconing, dict):
            boss_beaconing = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing(**boss_beaconing)
        if isinstance(breadcrumbs, dict):
            breadcrumbs = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs(**breadcrumbs)
        if isinstance(break_connection, dict):
            break_connection = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection(**break_connection)
        if isinstance(brotli, dict):
            brotli = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli(**brotli)
        if isinstance(cache_error, dict):
            cache_error = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError(**cache_error)
        if isinstance(cache_id, dict):
            cache_id = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId(**cache_id)
        if isinstance(cache_key_ignore_case, dict):
            cache_key_ignore_case = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase(**cache_key_ignore_case)
        if isinstance(cache_key_query_params, dict):
            cache_key_query_params = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams(**cache_key_query_params)
        if isinstance(cache_key_rewrite, dict):
            cache_key_rewrite = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite(**cache_key_rewrite)
        if isinstance(cache_post, dict):
            cache_post = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost(**cache_post)
        if isinstance(cache_redirect, dict):
            cache_redirect = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect(**cache_redirect)
        if isinstance(cache_tag, dict):
            cache_tag = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag(**cache_tag)
        if isinstance(cache_tag_visible, dict):
            cache_tag_visible = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible(**cache_tag_visible)
        if isinstance(caching, dict):
            caching = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching(**caching)
        if isinstance(central_authorization, dict):
            central_authorization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization(**central_authorization)
        if isinstance(chase_redirects, dict):
            chase_redirects = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects(**chase_redirects)
        if isinstance(client_certificate_auth, dict):
            client_certificate_auth = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth(**client_certificate_auth)
        if isinstance(client_characteristics, dict):
            client_characteristics = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics(**client_characteristics)
        if isinstance(cloud_interconnects, dict):
            cloud_interconnects = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects(**cloud_interconnects)
        if isinstance(cloud_wrapper, dict):
            cloud_wrapper = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper(**cloud_wrapper)
        if isinstance(cloud_wrapper_advanced, dict):
            cloud_wrapper_advanced = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced(**cloud_wrapper_advanced)
        if isinstance(common_media_client_data, dict):
            common_media_client_data = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData(**common_media_client_data)
        if isinstance(conditional_origin, dict):
            conditional_origin = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin(**conditional_origin)
        if isinstance(construct_response, dict):
            construct_response = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse(**construct_response)
        if isinstance(content_characteristics, dict):
            content_characteristics = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics(**content_characteristics)
        if isinstance(content_characteristics_amd, dict):
            content_characteristics_amd = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd(**content_characteristics_amd)
        if isinstance(content_characteristics_dd, dict):
            content_characteristics_dd = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd(**content_characteristics_dd)
        if isinstance(content_characteristics_wsd_large_file, dict):
            content_characteristics_wsd_large_file = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile(**content_characteristics_wsd_large_file)
        if isinstance(content_characteristics_wsd_live, dict):
            content_characteristics_wsd_live = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive(**content_characteristics_wsd_live)
        if isinstance(content_characteristics_wsd_vod, dict):
            content_characteristics_wsd_vod = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod(**content_characteristics_wsd_vod)
        if isinstance(content_pre_position, dict):
            content_pre_position = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition(**content_pre_position)
        if isinstance(content_targeting_protection, dict):
            content_targeting_protection = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection(**content_targeting_protection)
        if isinstance(cors_support, dict):
            cors_support = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport(**cors_support)
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode(**cp_code)
        if isinstance(custom_behavior, dict):
            custom_behavior = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior(**custom_behavior)
        if isinstance(datastream, dict):
            datastream = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream(**datastream)
        if isinstance(dcp, dict):
            dcp = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp(**dcp)
        if isinstance(dcp_auth_hmac_transformation, dict):
            dcp_auth_hmac_transformation = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation(**dcp_auth_hmac_transformation)
        if isinstance(dcp_auth_regex_transformation, dict):
            dcp_auth_regex_transformation = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation(**dcp_auth_regex_transformation)
        if isinstance(dcp_auth_substring_transformation, dict):
            dcp_auth_substring_transformation = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation(**dcp_auth_substring_transformation)
        if isinstance(dcp_auth_variable_extractor, dict):
            dcp_auth_variable_extractor = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor(**dcp_auth_variable_extractor)
        if isinstance(dcp_default_authz_groups, dict):
            dcp_default_authz_groups = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups(**dcp_default_authz_groups)
        if isinstance(dcp_dev_relations, dict):
            dcp_dev_relations = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations(**dcp_dev_relations)
        if isinstance(dcp_real_time_auth, dict):
            dcp_real_time_auth = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth(**dcp_real_time_auth)
        if isinstance(delivery_receipt, dict):
            delivery_receipt = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt(**delivery_receipt)
        if isinstance(deny_access, dict):
            deny_access = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess(**deny_access)
        if isinstance(deny_direct_failover_access, dict):
            deny_direct_failover_access = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess(**deny_direct_failover_access)
        if isinstance(device_characteristic_cache_id, dict):
            device_characteristic_cache_id = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId(**device_characteristic_cache_id)
        if isinstance(device_characteristic_header, dict):
            device_characteristic_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader(**device_characteristic_header)
        if isinstance(dns_async_refresh, dict):
            dns_async_refresh = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh(**dns_async_refresh)
        if isinstance(dns_prefresh, dict):
            dns_prefresh = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh(**dns_prefresh)
        if isinstance(downgrade_protocol, dict):
            downgrade_protocol = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol(**downgrade_protocol)
        if isinstance(download_complete_marker, dict):
            download_complete_marker = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker(**download_complete_marker)
        if isinstance(download_notification, dict):
            download_notification = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification(**download_notification)
        if isinstance(downstream_cache, dict):
            downstream_cache = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache(**downstream_cache)
        if isinstance(dynamic_throughtput_optimization, dict):
            dynamic_throughtput_optimization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization(**dynamic_throughtput_optimization)
        if isinstance(dynamic_throughtput_optimization_override, dict):
            dynamic_throughtput_optimization_override = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride(**dynamic_throughtput_optimization_override)
        if isinstance(dynamic_web_content, dict):
            dynamic_web_content = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent(**dynamic_web_content)
        if isinstance(ecms_bulk_upload, dict):
            ecms_bulk_upload = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload(**ecms_bulk_upload)
        if isinstance(ecms_database, dict):
            ecms_database = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase(**ecms_database)
        if isinstance(ecms_dataset, dict):
            ecms_dataset = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset(**ecms_dataset)
        if isinstance(ecms_object_key, dict):
            ecms_object_key = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey(**ecms_object_key)
        if isinstance(edge_connect, dict):
            edge_connect = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect(**edge_connect)
        if isinstance(edge_load_balancing_advanced, dict):
            edge_load_balancing_advanced = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced(**edge_load_balancing_advanced)
        if isinstance(edge_load_balancing_data_center, dict):
            edge_load_balancing_data_center = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter(**edge_load_balancing_data_center)
        if isinstance(edge_load_balancing_origin, dict):
            edge_load_balancing_origin = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin(**edge_load_balancing_origin)
        if isinstance(edge_origin_authorization, dict):
            edge_origin_authorization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization(**edge_origin_authorization)
        if isinstance(edge_redirector, dict):
            edge_redirector = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector(**edge_redirector)
        if isinstance(edge_scape, dict):
            edge_scape = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape(**edge_scape)
        if isinstance(edge_side_includes, dict):
            edge_side_includes = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes(**edge_side_includes)
        if isinstance(edge_worker, dict):
            edge_worker = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker(**edge_worker)
        if isinstance(enforce_mtls_settings, dict):
            enforce_mtls_settings = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings(**enforce_mtls_settings)
        if isinstance(enhanced_akamai_protocol, dict):
            enhanced_akamai_protocol = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol(**enhanced_akamai_protocol)
        if isinstance(enhanced_proxy_detection, dict):
            enhanced_proxy_detection = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection(**enhanced_proxy_detection)
        if isinstance(epd_forward_header_enrichment, dict):
            epd_forward_header_enrichment = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment(**epd_forward_header_enrichment)
        if isinstance(fail_action, dict):
            fail_action = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction(**fail_action)
        if isinstance(failover_bot_manager_feature_compatibility, dict):
            failover_bot_manager_feature_compatibility = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility(**failover_bot_manager_feature_compatibility)
        if isinstance(fast_invalidate, dict):
            fast_invalidate = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate(**fast_invalidate)
        if isinstance(fips, dict):
            fips = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips(**fips)
        if isinstance(first_party_marketing, dict):
            first_party_marketing = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing(**first_party_marketing)
        if isinstance(first_party_marketing_plus, dict):
            first_party_marketing_plus = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus(**first_party_marketing_plus)
        if isinstance(forward_rewrite, dict):
            forward_rewrite = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite(**forward_rewrite)
        if isinstance(g2_oheader, dict):
            g2_oheader = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader(**g2_oheader)
        if isinstance(global_request_number, dict):
            global_request_number = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber(**global_request_number)
        if isinstance(graphql_caching, dict):
            graphql_caching = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching(**graphql_caching)
        if isinstance(gzip_response, dict):
            gzip_response = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse(**gzip_response)
        if isinstance(hd_data_advanced, dict):
            hd_data_advanced = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced(**hd_data_advanced)
        if isinstance(health_detection, dict):
            health_detection = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection(**health_detection)
        if isinstance(hsaf_eip_binding, dict):
            hsaf_eip_binding = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding(**hsaf_eip_binding)
        if isinstance(http2, dict):
            http2 = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2(**http2)
        if isinstance(http3, dict):
            http3 = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3(**http3)
        if isinstance(http_strict_transport_security, dict):
            http_strict_transport_security = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity(**http_strict_transport_security)
        if isinstance(http_to_https_upgrade, dict):
            http_to_https_upgrade = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade(**http_to_https_upgrade)
        if isinstance(image_and_video_manager, dict):
            image_and_video_manager = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager(**image_and_video_manager)
        if isinstance(image_manager, dict):
            image_manager = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager(**image_manager)
        if isinstance(image_manager_video, dict):
            image_manager_video = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo(**image_manager_video)
        if isinstance(im_override, dict):
            im_override = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride(**im_override)
        if isinstance(include, dict):
            include = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude(**include)
        if isinstance(instant, dict):
            instant = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant(**instant)
        if isinstance(instant_config, dict):
            instant_config = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig(**instant_config)
        if isinstance(large_file_optimization, dict):
            large_file_optimization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization(**large_file_optimization)
        if isinstance(large_file_optimization_advanced, dict):
            large_file_optimization_advanced = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced(**large_file_optimization_advanced)
        if isinstance(limit_bit_rate, dict):
            limit_bit_rate = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate(**limit_bit_rate)
        if isinstance(log_custom, dict):
            log_custom = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom(**log_custom)
        if isinstance(manifest_personalization, dict):
            manifest_personalization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization(**manifest_personalization)
        if isinstance(manifest_rerouting, dict):
            manifest_rerouting = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting(**manifest_rerouting)
        if isinstance(manual_server_push, dict):
            manual_server_push = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush(**manual_server_push)
        if isinstance(media_acceleration, dict):
            media_acceleration = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration(**media_acceleration)
        if isinstance(media_acceleration_quic_optout, dict):
            media_acceleration_quic_optout = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout(**media_acceleration_quic_optout)
        if isinstance(media_client, dict):
            media_client = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient(**media_client)
        if isinstance(media_file_retrieval_optimization, dict):
            media_file_retrieval_optimization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization(**media_file_retrieval_optimization)
        if isinstance(media_origin_failover, dict):
            media_origin_failover = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover(**media_origin_failover)
        if isinstance(metadata_caching, dict):
            metadata_caching = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching(**metadata_caching)
        if isinstance(mobile_sdk_performance, dict):
            mobile_sdk_performance = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance(**mobile_sdk_performance)
        if isinstance(modify_incoming_request_header, dict):
            modify_incoming_request_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader(**modify_incoming_request_header)
        if isinstance(modify_incoming_response_header, dict):
            modify_incoming_response_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader(**modify_incoming_response_header)
        if isinstance(modify_outgoing_request_header, dict):
            modify_outgoing_request_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader(**modify_outgoing_request_header)
        if isinstance(modify_outgoing_response_header, dict):
            modify_outgoing_response_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader(**modify_outgoing_response_header)
        if isinstance(modify_via_header, dict):
            modify_via_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader(**modify_via_header)
        if isinstance(m_pulse, dict):
            m_pulse = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse(**m_pulse)
        if isinstance(origin, dict):
            origin = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin(**origin)
        if isinstance(origin_characteristics, dict):
            origin_characteristics = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics(**origin_characteristics)
        if isinstance(origin_characteristics_wsd, dict):
            origin_characteristics_wsd = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd(**origin_characteristics_wsd)
        if isinstance(origin_failure_recovery_method, dict):
            origin_failure_recovery_method = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod(**origin_failure_recovery_method)
        if isinstance(origin_failure_recovery_policy, dict):
            origin_failure_recovery_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy(**origin_failure_recovery_policy)
        if isinstance(origin_ip_acl, dict):
            origin_ip_acl = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl(**origin_ip_acl)
        if isinstance(permissions_policy, dict):
            permissions_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy(**permissions_policy)
        if isinstance(persistent_client_connection, dict):
            persistent_client_connection = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection(**persistent_client_connection)
        if isinstance(persistent_connection, dict):
            persistent_connection = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection(**persistent_connection)
        if isinstance(personally_identifiable_information, dict):
            personally_identifiable_information = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation(**personally_identifiable_information)
        if isinstance(phased_release, dict):
            phased_release = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease(**phased_release)
        if isinstance(preconnect, dict):
            preconnect = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect(**preconnect)
        if isinstance(predictive_content_delivery, dict):
            predictive_content_delivery = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery(**predictive_content_delivery)
        if isinstance(predictive_prefetching, dict):
            predictive_prefetching = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching(**predictive_prefetching)
        if isinstance(prefetch, dict):
            prefetch = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch(**prefetch)
        if isinstance(prefetchable, dict):
            prefetchable = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable(**prefetchable)
        if isinstance(prefresh_cache, dict):
            prefresh_cache = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache(**prefresh_cache)
        if isinstance(quality, dict):
            quality = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality(**quality)
        if isinstance(quic_beta, dict):
            quic_beta = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta(**quic_beta)
        if isinstance(random_seek, dict):
            random_seek = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek(**random_seek)
        if isinstance(rapid, dict):
            rapid = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid(**rapid)
        if isinstance(read_timeout, dict):
            read_timeout = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout(**read_timeout)
        if isinstance(real_time_reporting, dict):
            real_time_reporting = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting(**real_time_reporting)
        if isinstance(real_user_monitoring, dict):
            real_user_monitoring = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring(**real_user_monitoring)
        if isinstance(redirect, dict):
            redirect = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect(**redirect)
        if isinstance(redirectplus, dict):
            redirectplus = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus(**redirectplus)
        if isinstance(referer_checking, dict):
            referer_checking = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking(**referer_checking)
        if isinstance(remove_query_parameter, dict):
            remove_query_parameter = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter(**remove_query_parameter)
        if isinstance(remove_vary, dict):
            remove_vary = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary(**remove_vary)
        if isinstance(report, dict):
            report = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport(**report)
        if isinstance(request_client_hints, dict):
            request_client_hints = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints(**request_client_hints)
        if isinstance(request_control, dict):
            request_control = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl(**request_control)
        if isinstance(request_type_marker, dict):
            request_type_marker = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker(**request_type_marker)
        if isinstance(resource_optimizer, dict):
            resource_optimizer = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer(**resource_optimizer)
        if isinstance(resource_optimizer_extended_compatibility, dict):
            resource_optimizer_extended_compatibility = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility(**resource_optimizer_extended_compatibility)
        if isinstance(response_code, dict):
            response_code = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode(**response_code)
        if isinstance(response_cookie, dict):
            response_cookie = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie(**response_cookie)
        if isinstance(restrict_object_caching, dict):
            restrict_object_caching = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching(**restrict_object_caching)
        if isinstance(return_cache_status, dict):
            return_cache_status = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus(**return_cache_status)
        if isinstance(rewrite_url, dict):
            rewrite_url = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl(**rewrite_url)
        if isinstance(rum_custom, dict):
            rum_custom = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom(**rum_custom)
        if isinstance(saas_definitions, dict):
            saas_definitions = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions(**saas_definitions)
        if isinstance(sales_force_commerce_cloud_client, dict):
            sales_force_commerce_cloud_client = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient(**sales_force_commerce_cloud_client)
        if isinstance(sales_force_commerce_cloud_provider, dict):
            sales_force_commerce_cloud_provider = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider(**sales_force_commerce_cloud_provider)
        if isinstance(sales_force_commerce_cloud_provider_host_header, dict):
            sales_force_commerce_cloud_provider_host_header = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader(**sales_force_commerce_cloud_provider_host_header)
        if isinstance(save_post_dca_processing, dict):
            save_post_dca_processing = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing(**save_post_dca_processing)
        if isinstance(schedule_invalidation, dict):
            schedule_invalidation = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation(**schedule_invalidation)
        if isinstance(script_management, dict):
            script_management = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement(**script_management)
        if isinstance(segmented_content_protection, dict):
            segmented_content_protection = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection(**segmented_content_protection)
        if isinstance(segmented_media_optimization, dict):
            segmented_media_optimization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization(**segmented_media_optimization)
        if isinstance(segmented_media_streaming_prefetch, dict):
            segmented_media_streaming_prefetch = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch(**segmented_media_streaming_prefetch)
        if isinstance(set_variable, dict):
            set_variable = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable(**set_variable)
        if isinstance(simulate_error_code, dict):
            simulate_error_code = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode(**simulate_error_code)
        if isinstance(site_shield, dict):
            site_shield = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield(**site_shield)
        if isinstance(standard_tls_migration, dict):
            standard_tls_migration = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration(**standard_tls_migration)
        if isinstance(standard_tls_migration_override, dict):
            standard_tls_migration_override = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride(**standard_tls_migration_override)
        if isinstance(strict_header_parsing, dict):
            strict_header_parsing = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing(**strict_header_parsing)
        if isinstance(sub_customer, dict):
            sub_customer = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer(**sub_customer)
        if isinstance(sure_route, dict):
            sure_route = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute(**sure_route)
        if isinstance(tcp_optimization, dict):
            tcp_optimization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization(**tcp_optimization)
        if isinstance(tea_leaf, dict):
            tea_leaf = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf(**tea_leaf)
        if isinstance(tiered_distribution, dict):
            tiered_distribution = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution(**tiered_distribution)
        if isinstance(tiered_distribution_advanced, dict):
            tiered_distribution_advanced = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced(**tiered_distribution_advanced)
        if isinstance(tiered_distribution_customization, dict):
            tiered_distribution_customization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization(**tiered_distribution_customization)
        if isinstance(timeout, dict):
            timeout = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout(**timeout)
        if isinstance(uid_configuration, dict):
            uid_configuration = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration(**uid_configuration)
        if isinstance(validate_entity_tag, dict):
            validate_entity_tag = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag(**validate_entity_tag)
        if isinstance(verify_json_web_token, dict):
            verify_json_web_token = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken(**verify_json_web_token)
        if isinstance(verify_json_web_token_for_dcp, dict):
            verify_json_web_token_for_dcp = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp(**verify_json_web_token_for_dcp)
        if isinstance(verify_token_authorization, dict):
            verify_token_authorization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization(**verify_token_authorization)
        if isinstance(virtual_waiting_room, dict):
            virtual_waiting_room = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom(**virtual_waiting_room)
        if isinstance(virtual_waiting_room_with_edge_workers, dict):
            virtual_waiting_room_with_edge_workers = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers(**virtual_waiting_room_with_edge_workers)
        if isinstance(visitor_prioritization, dict):
            visitor_prioritization = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization(**visitor_prioritization)
        if isinstance(visitor_prioritization_fifo, dict):
            visitor_prioritization_fifo = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo(**visitor_prioritization_fifo)
        if isinstance(visitor_prioritization_fifo_standalone, dict):
            visitor_prioritization_fifo_standalone = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone(**visitor_prioritization_fifo_standalone)
        if isinstance(watermarking, dict):
            watermarking = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking(**watermarking)
        if isinstance(web_application_firewall, dict):
            web_application_firewall = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall(**web_application_firewall)
        if isinstance(webdav, dict):
            webdav = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav(**webdav)
        if isinstance(web_sockets, dict):
            web_sockets = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets(**web_sockets)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8742c5d9d50c43e43359fe4934fc34fb1e92e23b157e9391a62a8f0e1d3a6ee)
            check_type(argname="argument adaptive_acceleration", value=adaptive_acceleration, expected_type=type_hints["adaptive_acceleration"])
            check_type(argname="argument adaptive_image_compression", value=adaptive_image_compression, expected_type=type_hints["adaptive_image_compression"])
            check_type(argname="argument ad_scaler_circuit_breaker", value=ad_scaler_circuit_breaker, expected_type=type_hints["ad_scaler_circuit_breaker"])
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument aggregated_reporting", value=aggregated_reporting, expected_type=type_hints["aggregated_reporting"])
            check_type(argname="argument akamaizer", value=akamaizer, expected_type=type_hints["akamaizer"])
            check_type(argname="argument akamaizer_tag", value=akamaizer_tag, expected_type=type_hints["akamaizer_tag"])
            check_type(argname="argument all_http_in_cache_hierarchy", value=all_http_in_cache_hierarchy, expected_type=type_hints["all_http_in_cache_hierarchy"])
            check_type(argname="argument allow_cloudlets_origins", value=allow_cloudlets_origins, expected_type=type_hints["allow_cloudlets_origins"])
            check_type(argname="argument allow_delete", value=allow_delete, expected_type=type_hints["allow_delete"])
            check_type(argname="argument allow_https_cache_key_sharing", value=allow_https_cache_key_sharing, expected_type=type_hints["allow_https_cache_key_sharing"])
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_options", value=allow_options, expected_type=type_hints["allow_options"])
            check_type(argname="argument allow_patch", value=allow_patch, expected_type=type_hints["allow_patch"])
            check_type(argname="argument allow_post", value=allow_post, expected_type=type_hints["allow_post"])
            check_type(argname="argument allow_put", value=allow_put, expected_type=type_hints["allow_put"])
            check_type(argname="argument allow_transfer_encoding", value=allow_transfer_encoding, expected_type=type_hints["allow_transfer_encoding"])
            check_type(argname="argument alt_svc_header", value=alt_svc_header, expected_type=type_hints["alt_svc_header"])
            check_type(argname="argument api_prioritization", value=api_prioritization, expected_type=type_hints["api_prioritization"])
            check_type(argname="argument application_load_balancer", value=application_load_balancer, expected_type=type_hints["application_load_balancer"])
            check_type(argname="argument audience_segmentation", value=audience_segmentation, expected_type=type_hints["audience_segmentation"])
            check_type(argname="argument auto_domain_validation", value=auto_domain_validation, expected_type=type_hints["auto_domain_validation"])
            check_type(argname="argument base_directory", value=base_directory, expected_type=type_hints["base_directory"])
            check_type(argname="argument boss_beaconing", value=boss_beaconing, expected_type=type_hints["boss_beaconing"])
            check_type(argname="argument breadcrumbs", value=breadcrumbs, expected_type=type_hints["breadcrumbs"])
            check_type(argname="argument break_connection", value=break_connection, expected_type=type_hints["break_connection"])
            check_type(argname="argument brotli", value=brotli, expected_type=type_hints["brotli"])
            check_type(argname="argument cache_error", value=cache_error, expected_type=type_hints["cache_error"])
            check_type(argname="argument cache_id", value=cache_id, expected_type=type_hints["cache_id"])
            check_type(argname="argument cache_key_ignore_case", value=cache_key_ignore_case, expected_type=type_hints["cache_key_ignore_case"])
            check_type(argname="argument cache_key_query_params", value=cache_key_query_params, expected_type=type_hints["cache_key_query_params"])
            check_type(argname="argument cache_key_rewrite", value=cache_key_rewrite, expected_type=type_hints["cache_key_rewrite"])
            check_type(argname="argument cache_post", value=cache_post, expected_type=type_hints["cache_post"])
            check_type(argname="argument cache_redirect", value=cache_redirect, expected_type=type_hints["cache_redirect"])
            check_type(argname="argument cache_tag", value=cache_tag, expected_type=type_hints["cache_tag"])
            check_type(argname="argument cache_tag_visible", value=cache_tag_visible, expected_type=type_hints["cache_tag_visible"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument central_authorization", value=central_authorization, expected_type=type_hints["central_authorization"])
            check_type(argname="argument chase_redirects", value=chase_redirects, expected_type=type_hints["chase_redirects"])
            check_type(argname="argument client_certificate_auth", value=client_certificate_auth, expected_type=type_hints["client_certificate_auth"])
            check_type(argname="argument client_characteristics", value=client_characteristics, expected_type=type_hints["client_characteristics"])
            check_type(argname="argument cloud_interconnects", value=cloud_interconnects, expected_type=type_hints["cloud_interconnects"])
            check_type(argname="argument cloud_wrapper", value=cloud_wrapper, expected_type=type_hints["cloud_wrapper"])
            check_type(argname="argument cloud_wrapper_advanced", value=cloud_wrapper_advanced, expected_type=type_hints["cloud_wrapper_advanced"])
            check_type(argname="argument common_media_client_data", value=common_media_client_data, expected_type=type_hints["common_media_client_data"])
            check_type(argname="argument conditional_origin", value=conditional_origin, expected_type=type_hints["conditional_origin"])
            check_type(argname="argument construct_response", value=construct_response, expected_type=type_hints["construct_response"])
            check_type(argname="argument content_characteristics", value=content_characteristics, expected_type=type_hints["content_characteristics"])
            check_type(argname="argument content_characteristics_amd", value=content_characteristics_amd, expected_type=type_hints["content_characteristics_amd"])
            check_type(argname="argument content_characteristics_dd", value=content_characteristics_dd, expected_type=type_hints["content_characteristics_dd"])
            check_type(argname="argument content_characteristics_wsd_large_file", value=content_characteristics_wsd_large_file, expected_type=type_hints["content_characteristics_wsd_large_file"])
            check_type(argname="argument content_characteristics_wsd_live", value=content_characteristics_wsd_live, expected_type=type_hints["content_characteristics_wsd_live"])
            check_type(argname="argument content_characteristics_wsd_vod", value=content_characteristics_wsd_vod, expected_type=type_hints["content_characteristics_wsd_vod"])
            check_type(argname="argument content_pre_position", value=content_pre_position, expected_type=type_hints["content_pre_position"])
            check_type(argname="argument content_targeting_protection", value=content_targeting_protection, expected_type=type_hints["content_targeting_protection"])
            check_type(argname="argument cors_support", value=cors_support, expected_type=type_hints["cors_support"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument custom_behavior", value=custom_behavior, expected_type=type_hints["custom_behavior"])
            check_type(argname="argument datastream", value=datastream, expected_type=type_hints["datastream"])
            check_type(argname="argument dcp", value=dcp, expected_type=type_hints["dcp"])
            check_type(argname="argument dcp_auth_hmac_transformation", value=dcp_auth_hmac_transformation, expected_type=type_hints["dcp_auth_hmac_transformation"])
            check_type(argname="argument dcp_auth_regex_transformation", value=dcp_auth_regex_transformation, expected_type=type_hints["dcp_auth_regex_transformation"])
            check_type(argname="argument dcp_auth_substring_transformation", value=dcp_auth_substring_transformation, expected_type=type_hints["dcp_auth_substring_transformation"])
            check_type(argname="argument dcp_auth_variable_extractor", value=dcp_auth_variable_extractor, expected_type=type_hints["dcp_auth_variable_extractor"])
            check_type(argname="argument dcp_default_authz_groups", value=dcp_default_authz_groups, expected_type=type_hints["dcp_default_authz_groups"])
            check_type(argname="argument dcp_dev_relations", value=dcp_dev_relations, expected_type=type_hints["dcp_dev_relations"])
            check_type(argname="argument dcp_real_time_auth", value=dcp_real_time_auth, expected_type=type_hints["dcp_real_time_auth"])
            check_type(argname="argument delivery_receipt", value=delivery_receipt, expected_type=type_hints["delivery_receipt"])
            check_type(argname="argument deny_access", value=deny_access, expected_type=type_hints["deny_access"])
            check_type(argname="argument deny_direct_failover_access", value=deny_direct_failover_access, expected_type=type_hints["deny_direct_failover_access"])
            check_type(argname="argument device_characteristic_cache_id", value=device_characteristic_cache_id, expected_type=type_hints["device_characteristic_cache_id"])
            check_type(argname="argument device_characteristic_header", value=device_characteristic_header, expected_type=type_hints["device_characteristic_header"])
            check_type(argname="argument dns_async_refresh", value=dns_async_refresh, expected_type=type_hints["dns_async_refresh"])
            check_type(argname="argument dns_prefresh", value=dns_prefresh, expected_type=type_hints["dns_prefresh"])
            check_type(argname="argument downgrade_protocol", value=downgrade_protocol, expected_type=type_hints["downgrade_protocol"])
            check_type(argname="argument download_complete_marker", value=download_complete_marker, expected_type=type_hints["download_complete_marker"])
            check_type(argname="argument download_notification", value=download_notification, expected_type=type_hints["download_notification"])
            check_type(argname="argument downstream_cache", value=downstream_cache, expected_type=type_hints["downstream_cache"])
            check_type(argname="argument dynamic_throughtput_optimization", value=dynamic_throughtput_optimization, expected_type=type_hints["dynamic_throughtput_optimization"])
            check_type(argname="argument dynamic_throughtput_optimization_override", value=dynamic_throughtput_optimization_override, expected_type=type_hints["dynamic_throughtput_optimization_override"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument ecms_bulk_upload", value=ecms_bulk_upload, expected_type=type_hints["ecms_bulk_upload"])
            check_type(argname="argument ecms_database", value=ecms_database, expected_type=type_hints["ecms_database"])
            check_type(argname="argument ecms_dataset", value=ecms_dataset, expected_type=type_hints["ecms_dataset"])
            check_type(argname="argument ecms_object_key", value=ecms_object_key, expected_type=type_hints["ecms_object_key"])
            check_type(argname="argument edge_connect", value=edge_connect, expected_type=type_hints["edge_connect"])
            check_type(argname="argument edge_load_balancing_advanced", value=edge_load_balancing_advanced, expected_type=type_hints["edge_load_balancing_advanced"])
            check_type(argname="argument edge_load_balancing_data_center", value=edge_load_balancing_data_center, expected_type=type_hints["edge_load_balancing_data_center"])
            check_type(argname="argument edge_load_balancing_origin", value=edge_load_balancing_origin, expected_type=type_hints["edge_load_balancing_origin"])
            check_type(argname="argument edge_origin_authorization", value=edge_origin_authorization, expected_type=type_hints["edge_origin_authorization"])
            check_type(argname="argument edge_redirector", value=edge_redirector, expected_type=type_hints["edge_redirector"])
            check_type(argname="argument edge_scape", value=edge_scape, expected_type=type_hints["edge_scape"])
            check_type(argname="argument edge_side_includes", value=edge_side_includes, expected_type=type_hints["edge_side_includes"])
            check_type(argname="argument edge_worker", value=edge_worker, expected_type=type_hints["edge_worker"])
            check_type(argname="argument enforce_mtls_settings", value=enforce_mtls_settings, expected_type=type_hints["enforce_mtls_settings"])
            check_type(argname="argument enhanced_akamai_protocol", value=enhanced_akamai_protocol, expected_type=type_hints["enhanced_akamai_protocol"])
            check_type(argname="argument enhanced_proxy_detection", value=enhanced_proxy_detection, expected_type=type_hints["enhanced_proxy_detection"])
            check_type(argname="argument epd_forward_header_enrichment", value=epd_forward_header_enrichment, expected_type=type_hints["epd_forward_header_enrichment"])
            check_type(argname="argument fail_action", value=fail_action, expected_type=type_hints["fail_action"])
            check_type(argname="argument failover_bot_manager_feature_compatibility", value=failover_bot_manager_feature_compatibility, expected_type=type_hints["failover_bot_manager_feature_compatibility"])
            check_type(argname="argument fast_invalidate", value=fast_invalidate, expected_type=type_hints["fast_invalidate"])
            check_type(argname="argument fips", value=fips, expected_type=type_hints["fips"])
            check_type(argname="argument first_party_marketing", value=first_party_marketing, expected_type=type_hints["first_party_marketing"])
            check_type(argname="argument first_party_marketing_plus", value=first_party_marketing_plus, expected_type=type_hints["first_party_marketing_plus"])
            check_type(argname="argument forward_rewrite", value=forward_rewrite, expected_type=type_hints["forward_rewrite"])
            check_type(argname="argument g2_oheader", value=g2_oheader, expected_type=type_hints["g2_oheader"])
            check_type(argname="argument global_request_number", value=global_request_number, expected_type=type_hints["global_request_number"])
            check_type(argname="argument graphql_caching", value=graphql_caching, expected_type=type_hints["graphql_caching"])
            check_type(argname="argument gzip_response", value=gzip_response, expected_type=type_hints["gzip_response"])
            check_type(argname="argument hd_data_advanced", value=hd_data_advanced, expected_type=type_hints["hd_data_advanced"])
            check_type(argname="argument health_detection", value=health_detection, expected_type=type_hints["health_detection"])
            check_type(argname="argument hsaf_eip_binding", value=hsaf_eip_binding, expected_type=type_hints["hsaf_eip_binding"])
            check_type(argname="argument http2", value=http2, expected_type=type_hints["http2"])
            check_type(argname="argument http3", value=http3, expected_type=type_hints["http3"])
            check_type(argname="argument http_strict_transport_security", value=http_strict_transport_security, expected_type=type_hints["http_strict_transport_security"])
            check_type(argname="argument http_to_https_upgrade", value=http_to_https_upgrade, expected_type=type_hints["http_to_https_upgrade"])
            check_type(argname="argument image_and_video_manager", value=image_and_video_manager, expected_type=type_hints["image_and_video_manager"])
            check_type(argname="argument image_manager", value=image_manager, expected_type=type_hints["image_manager"])
            check_type(argname="argument image_manager_video", value=image_manager_video, expected_type=type_hints["image_manager_video"])
            check_type(argname="argument im_override", value=im_override, expected_type=type_hints["im_override"])
            check_type(argname="argument include", value=include, expected_type=type_hints["include"])
            check_type(argname="argument instant", value=instant, expected_type=type_hints["instant"])
            check_type(argname="argument instant_config", value=instant_config, expected_type=type_hints["instant_config"])
            check_type(argname="argument large_file_optimization", value=large_file_optimization, expected_type=type_hints["large_file_optimization"])
            check_type(argname="argument large_file_optimization_advanced", value=large_file_optimization_advanced, expected_type=type_hints["large_file_optimization_advanced"])
            check_type(argname="argument limit_bit_rate", value=limit_bit_rate, expected_type=type_hints["limit_bit_rate"])
            check_type(argname="argument log_custom", value=log_custom, expected_type=type_hints["log_custom"])
            check_type(argname="argument manifest_personalization", value=manifest_personalization, expected_type=type_hints["manifest_personalization"])
            check_type(argname="argument manifest_rerouting", value=manifest_rerouting, expected_type=type_hints["manifest_rerouting"])
            check_type(argname="argument manual_server_push", value=manual_server_push, expected_type=type_hints["manual_server_push"])
            check_type(argname="argument media_acceleration", value=media_acceleration, expected_type=type_hints["media_acceleration"])
            check_type(argname="argument media_acceleration_quic_optout", value=media_acceleration_quic_optout, expected_type=type_hints["media_acceleration_quic_optout"])
            check_type(argname="argument media_client", value=media_client, expected_type=type_hints["media_client"])
            check_type(argname="argument media_file_retrieval_optimization", value=media_file_retrieval_optimization, expected_type=type_hints["media_file_retrieval_optimization"])
            check_type(argname="argument media_origin_failover", value=media_origin_failover, expected_type=type_hints["media_origin_failover"])
            check_type(argname="argument metadata_caching", value=metadata_caching, expected_type=type_hints["metadata_caching"])
            check_type(argname="argument mobile_sdk_performance", value=mobile_sdk_performance, expected_type=type_hints["mobile_sdk_performance"])
            check_type(argname="argument modify_incoming_request_header", value=modify_incoming_request_header, expected_type=type_hints["modify_incoming_request_header"])
            check_type(argname="argument modify_incoming_response_header", value=modify_incoming_response_header, expected_type=type_hints["modify_incoming_response_header"])
            check_type(argname="argument modify_outgoing_request_header", value=modify_outgoing_request_header, expected_type=type_hints["modify_outgoing_request_header"])
            check_type(argname="argument modify_outgoing_response_header", value=modify_outgoing_response_header, expected_type=type_hints["modify_outgoing_response_header"])
            check_type(argname="argument modify_via_header", value=modify_via_header, expected_type=type_hints["modify_via_header"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument origin_characteristics", value=origin_characteristics, expected_type=type_hints["origin_characteristics"])
            check_type(argname="argument origin_characteristics_wsd", value=origin_characteristics_wsd, expected_type=type_hints["origin_characteristics_wsd"])
            check_type(argname="argument origin_failure_recovery_method", value=origin_failure_recovery_method, expected_type=type_hints["origin_failure_recovery_method"])
            check_type(argname="argument origin_failure_recovery_policy", value=origin_failure_recovery_policy, expected_type=type_hints["origin_failure_recovery_policy"])
            check_type(argname="argument origin_ip_acl", value=origin_ip_acl, expected_type=type_hints["origin_ip_acl"])
            check_type(argname="argument permissions_policy", value=permissions_policy, expected_type=type_hints["permissions_policy"])
            check_type(argname="argument persistent_client_connection", value=persistent_client_connection, expected_type=type_hints["persistent_client_connection"])
            check_type(argname="argument persistent_connection", value=persistent_connection, expected_type=type_hints["persistent_connection"])
            check_type(argname="argument personally_identifiable_information", value=personally_identifiable_information, expected_type=type_hints["personally_identifiable_information"])
            check_type(argname="argument phased_release", value=phased_release, expected_type=type_hints["phased_release"])
            check_type(argname="argument preconnect", value=preconnect, expected_type=type_hints["preconnect"])
            check_type(argname="argument predictive_content_delivery", value=predictive_content_delivery, expected_type=type_hints["predictive_content_delivery"])
            check_type(argname="argument predictive_prefetching", value=predictive_prefetching, expected_type=type_hints["predictive_prefetching"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument prefetchable", value=prefetchable, expected_type=type_hints["prefetchable"])
            check_type(argname="argument prefresh_cache", value=prefresh_cache, expected_type=type_hints["prefresh_cache"])
            check_type(argname="argument quality", value=quality, expected_type=type_hints["quality"])
            check_type(argname="argument quic_beta", value=quic_beta, expected_type=type_hints["quic_beta"])
            check_type(argname="argument random_seek", value=random_seek, expected_type=type_hints["random_seek"])
            check_type(argname="argument rapid", value=rapid, expected_type=type_hints["rapid"])
            check_type(argname="argument read_timeout", value=read_timeout, expected_type=type_hints["read_timeout"])
            check_type(argname="argument real_time_reporting", value=real_time_reporting, expected_type=type_hints["real_time_reporting"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirectplus", value=redirectplus, expected_type=type_hints["redirectplus"])
            check_type(argname="argument referer_checking", value=referer_checking, expected_type=type_hints["referer_checking"])
            check_type(argname="argument remove_query_parameter", value=remove_query_parameter, expected_type=type_hints["remove_query_parameter"])
            check_type(argname="argument remove_vary", value=remove_vary, expected_type=type_hints["remove_vary"])
            check_type(argname="argument report", value=report, expected_type=type_hints["report"])
            check_type(argname="argument request_client_hints", value=request_client_hints, expected_type=type_hints["request_client_hints"])
            check_type(argname="argument request_control", value=request_control, expected_type=type_hints["request_control"])
            check_type(argname="argument request_type_marker", value=request_type_marker, expected_type=type_hints["request_type_marker"])
            check_type(argname="argument resource_optimizer", value=resource_optimizer, expected_type=type_hints["resource_optimizer"])
            check_type(argname="argument resource_optimizer_extended_compatibility", value=resource_optimizer_extended_compatibility, expected_type=type_hints["resource_optimizer_extended_compatibility"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument response_cookie", value=response_cookie, expected_type=type_hints["response_cookie"])
            check_type(argname="argument restrict_object_caching", value=restrict_object_caching, expected_type=type_hints["restrict_object_caching"])
            check_type(argname="argument return_cache_status", value=return_cache_status, expected_type=type_hints["return_cache_status"])
            check_type(argname="argument rewrite_url", value=rewrite_url, expected_type=type_hints["rewrite_url"])
            check_type(argname="argument rum_custom", value=rum_custom, expected_type=type_hints["rum_custom"])
            check_type(argname="argument saas_definitions", value=saas_definitions, expected_type=type_hints["saas_definitions"])
            check_type(argname="argument sales_force_commerce_cloud_client", value=sales_force_commerce_cloud_client, expected_type=type_hints["sales_force_commerce_cloud_client"])
            check_type(argname="argument sales_force_commerce_cloud_provider", value=sales_force_commerce_cloud_provider, expected_type=type_hints["sales_force_commerce_cloud_provider"])
            check_type(argname="argument sales_force_commerce_cloud_provider_host_header", value=sales_force_commerce_cloud_provider_host_header, expected_type=type_hints["sales_force_commerce_cloud_provider_host_header"])
            check_type(argname="argument save_post_dca_processing", value=save_post_dca_processing, expected_type=type_hints["save_post_dca_processing"])
            check_type(argname="argument schedule_invalidation", value=schedule_invalidation, expected_type=type_hints["schedule_invalidation"])
            check_type(argname="argument script_management", value=script_management, expected_type=type_hints["script_management"])
            check_type(argname="argument segmented_content_protection", value=segmented_content_protection, expected_type=type_hints["segmented_content_protection"])
            check_type(argname="argument segmented_media_optimization", value=segmented_media_optimization, expected_type=type_hints["segmented_media_optimization"])
            check_type(argname="argument segmented_media_streaming_prefetch", value=segmented_media_streaming_prefetch, expected_type=type_hints["segmented_media_streaming_prefetch"])
            check_type(argname="argument set_variable", value=set_variable, expected_type=type_hints["set_variable"])
            check_type(argname="argument simulate_error_code", value=simulate_error_code, expected_type=type_hints["simulate_error_code"])
            check_type(argname="argument site_shield", value=site_shield, expected_type=type_hints["site_shield"])
            check_type(argname="argument standard_tls_migration", value=standard_tls_migration, expected_type=type_hints["standard_tls_migration"])
            check_type(argname="argument standard_tls_migration_override", value=standard_tls_migration_override, expected_type=type_hints["standard_tls_migration_override"])
            check_type(argname="argument strict_header_parsing", value=strict_header_parsing, expected_type=type_hints["strict_header_parsing"])
            check_type(argname="argument sub_customer", value=sub_customer, expected_type=type_hints["sub_customer"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument tcp_optimization", value=tcp_optimization, expected_type=type_hints["tcp_optimization"])
            check_type(argname="argument tea_leaf", value=tea_leaf, expected_type=type_hints["tea_leaf"])
            check_type(argname="argument tiered_distribution", value=tiered_distribution, expected_type=type_hints["tiered_distribution"])
            check_type(argname="argument tiered_distribution_advanced", value=tiered_distribution_advanced, expected_type=type_hints["tiered_distribution_advanced"])
            check_type(argname="argument tiered_distribution_customization", value=tiered_distribution_customization, expected_type=type_hints["tiered_distribution_customization"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uid_configuration", value=uid_configuration, expected_type=type_hints["uid_configuration"])
            check_type(argname="argument validate_entity_tag", value=validate_entity_tag, expected_type=type_hints["validate_entity_tag"])
            check_type(argname="argument verify_json_web_token", value=verify_json_web_token, expected_type=type_hints["verify_json_web_token"])
            check_type(argname="argument verify_json_web_token_for_dcp", value=verify_json_web_token_for_dcp, expected_type=type_hints["verify_json_web_token_for_dcp"])
            check_type(argname="argument verify_token_authorization", value=verify_token_authorization, expected_type=type_hints["verify_token_authorization"])
            check_type(argname="argument virtual_waiting_room", value=virtual_waiting_room, expected_type=type_hints["virtual_waiting_room"])
            check_type(argname="argument virtual_waiting_room_with_edge_workers", value=virtual_waiting_room_with_edge_workers, expected_type=type_hints["virtual_waiting_room_with_edge_workers"])
            check_type(argname="argument visitor_prioritization", value=visitor_prioritization, expected_type=type_hints["visitor_prioritization"])
            check_type(argname="argument visitor_prioritization_fifo", value=visitor_prioritization_fifo, expected_type=type_hints["visitor_prioritization_fifo"])
            check_type(argname="argument visitor_prioritization_fifo_standalone", value=visitor_prioritization_fifo_standalone, expected_type=type_hints["visitor_prioritization_fifo_standalone"])
            check_type(argname="argument watermarking", value=watermarking, expected_type=type_hints["watermarking"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
            check_type(argname="argument webdav", value=webdav, expected_type=type_hints["webdav"])
            check_type(argname="argument web_sockets", value=web_sockets, expected_type=type_hints["web_sockets"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if adaptive_acceleration is not None:
            self._values["adaptive_acceleration"] = adaptive_acceleration
        if adaptive_image_compression is not None:
            self._values["adaptive_image_compression"] = adaptive_image_compression
        if ad_scaler_circuit_breaker is not None:
            self._values["ad_scaler_circuit_breaker"] = ad_scaler_circuit_breaker
        if advanced is not None:
            self._values["advanced"] = advanced
        if aggregated_reporting is not None:
            self._values["aggregated_reporting"] = aggregated_reporting
        if akamaizer is not None:
            self._values["akamaizer"] = akamaizer
        if akamaizer_tag is not None:
            self._values["akamaizer_tag"] = akamaizer_tag
        if all_http_in_cache_hierarchy is not None:
            self._values["all_http_in_cache_hierarchy"] = all_http_in_cache_hierarchy
        if allow_cloudlets_origins is not None:
            self._values["allow_cloudlets_origins"] = allow_cloudlets_origins
        if allow_delete is not None:
            self._values["allow_delete"] = allow_delete
        if allow_https_cache_key_sharing is not None:
            self._values["allow_https_cache_key_sharing"] = allow_https_cache_key_sharing
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_options is not None:
            self._values["allow_options"] = allow_options
        if allow_patch is not None:
            self._values["allow_patch"] = allow_patch
        if allow_post is not None:
            self._values["allow_post"] = allow_post
        if allow_put is not None:
            self._values["allow_put"] = allow_put
        if allow_transfer_encoding is not None:
            self._values["allow_transfer_encoding"] = allow_transfer_encoding
        if alt_svc_header is not None:
            self._values["alt_svc_header"] = alt_svc_header
        if api_prioritization is not None:
            self._values["api_prioritization"] = api_prioritization
        if application_load_balancer is not None:
            self._values["application_load_balancer"] = application_load_balancer
        if audience_segmentation is not None:
            self._values["audience_segmentation"] = audience_segmentation
        if auto_domain_validation is not None:
            self._values["auto_domain_validation"] = auto_domain_validation
        if base_directory is not None:
            self._values["base_directory"] = base_directory
        if boss_beaconing is not None:
            self._values["boss_beaconing"] = boss_beaconing
        if breadcrumbs is not None:
            self._values["breadcrumbs"] = breadcrumbs
        if break_connection is not None:
            self._values["break_connection"] = break_connection
        if brotli is not None:
            self._values["brotli"] = brotli
        if cache_error is not None:
            self._values["cache_error"] = cache_error
        if cache_id is not None:
            self._values["cache_id"] = cache_id
        if cache_key_ignore_case is not None:
            self._values["cache_key_ignore_case"] = cache_key_ignore_case
        if cache_key_query_params is not None:
            self._values["cache_key_query_params"] = cache_key_query_params
        if cache_key_rewrite is not None:
            self._values["cache_key_rewrite"] = cache_key_rewrite
        if cache_post is not None:
            self._values["cache_post"] = cache_post
        if cache_redirect is not None:
            self._values["cache_redirect"] = cache_redirect
        if cache_tag is not None:
            self._values["cache_tag"] = cache_tag
        if cache_tag_visible is not None:
            self._values["cache_tag_visible"] = cache_tag_visible
        if caching is not None:
            self._values["caching"] = caching
        if central_authorization is not None:
            self._values["central_authorization"] = central_authorization
        if chase_redirects is not None:
            self._values["chase_redirects"] = chase_redirects
        if client_certificate_auth is not None:
            self._values["client_certificate_auth"] = client_certificate_auth
        if client_characteristics is not None:
            self._values["client_characteristics"] = client_characteristics
        if cloud_interconnects is not None:
            self._values["cloud_interconnects"] = cloud_interconnects
        if cloud_wrapper is not None:
            self._values["cloud_wrapper"] = cloud_wrapper
        if cloud_wrapper_advanced is not None:
            self._values["cloud_wrapper_advanced"] = cloud_wrapper_advanced
        if common_media_client_data is not None:
            self._values["common_media_client_data"] = common_media_client_data
        if conditional_origin is not None:
            self._values["conditional_origin"] = conditional_origin
        if construct_response is not None:
            self._values["construct_response"] = construct_response
        if content_characteristics is not None:
            self._values["content_characteristics"] = content_characteristics
        if content_characteristics_amd is not None:
            self._values["content_characteristics_amd"] = content_characteristics_amd
        if content_characteristics_dd is not None:
            self._values["content_characteristics_dd"] = content_characteristics_dd
        if content_characteristics_wsd_large_file is not None:
            self._values["content_characteristics_wsd_large_file"] = content_characteristics_wsd_large_file
        if content_characteristics_wsd_live is not None:
            self._values["content_characteristics_wsd_live"] = content_characteristics_wsd_live
        if content_characteristics_wsd_vod is not None:
            self._values["content_characteristics_wsd_vod"] = content_characteristics_wsd_vod
        if content_pre_position is not None:
            self._values["content_pre_position"] = content_pre_position
        if content_targeting_protection is not None:
            self._values["content_targeting_protection"] = content_targeting_protection
        if cors_support is not None:
            self._values["cors_support"] = cors_support
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if custom_behavior is not None:
            self._values["custom_behavior"] = custom_behavior
        if datastream is not None:
            self._values["datastream"] = datastream
        if dcp is not None:
            self._values["dcp"] = dcp
        if dcp_auth_hmac_transformation is not None:
            self._values["dcp_auth_hmac_transformation"] = dcp_auth_hmac_transformation
        if dcp_auth_regex_transformation is not None:
            self._values["dcp_auth_regex_transformation"] = dcp_auth_regex_transformation
        if dcp_auth_substring_transformation is not None:
            self._values["dcp_auth_substring_transformation"] = dcp_auth_substring_transformation
        if dcp_auth_variable_extractor is not None:
            self._values["dcp_auth_variable_extractor"] = dcp_auth_variable_extractor
        if dcp_default_authz_groups is not None:
            self._values["dcp_default_authz_groups"] = dcp_default_authz_groups
        if dcp_dev_relations is not None:
            self._values["dcp_dev_relations"] = dcp_dev_relations
        if dcp_real_time_auth is not None:
            self._values["dcp_real_time_auth"] = dcp_real_time_auth
        if delivery_receipt is not None:
            self._values["delivery_receipt"] = delivery_receipt
        if deny_access is not None:
            self._values["deny_access"] = deny_access
        if deny_direct_failover_access is not None:
            self._values["deny_direct_failover_access"] = deny_direct_failover_access
        if device_characteristic_cache_id is not None:
            self._values["device_characteristic_cache_id"] = device_characteristic_cache_id
        if device_characteristic_header is not None:
            self._values["device_characteristic_header"] = device_characteristic_header
        if dns_async_refresh is not None:
            self._values["dns_async_refresh"] = dns_async_refresh
        if dns_prefresh is not None:
            self._values["dns_prefresh"] = dns_prefresh
        if downgrade_protocol is not None:
            self._values["downgrade_protocol"] = downgrade_protocol
        if download_complete_marker is not None:
            self._values["download_complete_marker"] = download_complete_marker
        if download_notification is not None:
            self._values["download_notification"] = download_notification
        if downstream_cache is not None:
            self._values["downstream_cache"] = downstream_cache
        if dynamic_throughtput_optimization is not None:
            self._values["dynamic_throughtput_optimization"] = dynamic_throughtput_optimization
        if dynamic_throughtput_optimization_override is not None:
            self._values["dynamic_throughtput_optimization_override"] = dynamic_throughtput_optimization_override
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if ecms_bulk_upload is not None:
            self._values["ecms_bulk_upload"] = ecms_bulk_upload
        if ecms_database is not None:
            self._values["ecms_database"] = ecms_database
        if ecms_dataset is not None:
            self._values["ecms_dataset"] = ecms_dataset
        if ecms_object_key is not None:
            self._values["ecms_object_key"] = ecms_object_key
        if edge_connect is not None:
            self._values["edge_connect"] = edge_connect
        if edge_load_balancing_advanced is not None:
            self._values["edge_load_balancing_advanced"] = edge_load_balancing_advanced
        if edge_load_balancing_data_center is not None:
            self._values["edge_load_balancing_data_center"] = edge_load_balancing_data_center
        if edge_load_balancing_origin is not None:
            self._values["edge_load_balancing_origin"] = edge_load_balancing_origin
        if edge_origin_authorization is not None:
            self._values["edge_origin_authorization"] = edge_origin_authorization
        if edge_redirector is not None:
            self._values["edge_redirector"] = edge_redirector
        if edge_scape is not None:
            self._values["edge_scape"] = edge_scape
        if edge_side_includes is not None:
            self._values["edge_side_includes"] = edge_side_includes
        if edge_worker is not None:
            self._values["edge_worker"] = edge_worker
        if enforce_mtls_settings is not None:
            self._values["enforce_mtls_settings"] = enforce_mtls_settings
        if enhanced_akamai_protocol is not None:
            self._values["enhanced_akamai_protocol"] = enhanced_akamai_protocol
        if enhanced_proxy_detection is not None:
            self._values["enhanced_proxy_detection"] = enhanced_proxy_detection
        if epd_forward_header_enrichment is not None:
            self._values["epd_forward_header_enrichment"] = epd_forward_header_enrichment
        if fail_action is not None:
            self._values["fail_action"] = fail_action
        if failover_bot_manager_feature_compatibility is not None:
            self._values["failover_bot_manager_feature_compatibility"] = failover_bot_manager_feature_compatibility
        if fast_invalidate is not None:
            self._values["fast_invalidate"] = fast_invalidate
        if fips is not None:
            self._values["fips"] = fips
        if first_party_marketing is not None:
            self._values["first_party_marketing"] = first_party_marketing
        if first_party_marketing_plus is not None:
            self._values["first_party_marketing_plus"] = first_party_marketing_plus
        if forward_rewrite is not None:
            self._values["forward_rewrite"] = forward_rewrite
        if g2_oheader is not None:
            self._values["g2_oheader"] = g2_oheader
        if global_request_number is not None:
            self._values["global_request_number"] = global_request_number
        if graphql_caching is not None:
            self._values["graphql_caching"] = graphql_caching
        if gzip_response is not None:
            self._values["gzip_response"] = gzip_response
        if hd_data_advanced is not None:
            self._values["hd_data_advanced"] = hd_data_advanced
        if health_detection is not None:
            self._values["health_detection"] = health_detection
        if hsaf_eip_binding is not None:
            self._values["hsaf_eip_binding"] = hsaf_eip_binding
        if http2 is not None:
            self._values["http2"] = http2
        if http3 is not None:
            self._values["http3"] = http3
        if http_strict_transport_security is not None:
            self._values["http_strict_transport_security"] = http_strict_transport_security
        if http_to_https_upgrade is not None:
            self._values["http_to_https_upgrade"] = http_to_https_upgrade
        if image_and_video_manager is not None:
            self._values["image_and_video_manager"] = image_and_video_manager
        if image_manager is not None:
            self._values["image_manager"] = image_manager
        if image_manager_video is not None:
            self._values["image_manager_video"] = image_manager_video
        if im_override is not None:
            self._values["im_override"] = im_override
        if include is not None:
            self._values["include"] = include
        if instant is not None:
            self._values["instant"] = instant
        if instant_config is not None:
            self._values["instant_config"] = instant_config
        if large_file_optimization is not None:
            self._values["large_file_optimization"] = large_file_optimization
        if large_file_optimization_advanced is not None:
            self._values["large_file_optimization_advanced"] = large_file_optimization_advanced
        if limit_bit_rate is not None:
            self._values["limit_bit_rate"] = limit_bit_rate
        if log_custom is not None:
            self._values["log_custom"] = log_custom
        if manifest_personalization is not None:
            self._values["manifest_personalization"] = manifest_personalization
        if manifest_rerouting is not None:
            self._values["manifest_rerouting"] = manifest_rerouting
        if manual_server_push is not None:
            self._values["manual_server_push"] = manual_server_push
        if media_acceleration is not None:
            self._values["media_acceleration"] = media_acceleration
        if media_acceleration_quic_optout is not None:
            self._values["media_acceleration_quic_optout"] = media_acceleration_quic_optout
        if media_client is not None:
            self._values["media_client"] = media_client
        if media_file_retrieval_optimization is not None:
            self._values["media_file_retrieval_optimization"] = media_file_retrieval_optimization
        if media_origin_failover is not None:
            self._values["media_origin_failover"] = media_origin_failover
        if metadata_caching is not None:
            self._values["metadata_caching"] = metadata_caching
        if mobile_sdk_performance is not None:
            self._values["mobile_sdk_performance"] = mobile_sdk_performance
        if modify_incoming_request_header is not None:
            self._values["modify_incoming_request_header"] = modify_incoming_request_header
        if modify_incoming_response_header is not None:
            self._values["modify_incoming_response_header"] = modify_incoming_response_header
        if modify_outgoing_request_header is not None:
            self._values["modify_outgoing_request_header"] = modify_outgoing_request_header
        if modify_outgoing_response_header is not None:
            self._values["modify_outgoing_response_header"] = modify_outgoing_response_header
        if modify_via_header is not None:
            self._values["modify_via_header"] = modify_via_header
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if origin is not None:
            self._values["origin"] = origin
        if origin_characteristics is not None:
            self._values["origin_characteristics"] = origin_characteristics
        if origin_characteristics_wsd is not None:
            self._values["origin_characteristics_wsd"] = origin_characteristics_wsd
        if origin_failure_recovery_method is not None:
            self._values["origin_failure_recovery_method"] = origin_failure_recovery_method
        if origin_failure_recovery_policy is not None:
            self._values["origin_failure_recovery_policy"] = origin_failure_recovery_policy
        if origin_ip_acl is not None:
            self._values["origin_ip_acl"] = origin_ip_acl
        if permissions_policy is not None:
            self._values["permissions_policy"] = permissions_policy
        if persistent_client_connection is not None:
            self._values["persistent_client_connection"] = persistent_client_connection
        if persistent_connection is not None:
            self._values["persistent_connection"] = persistent_connection
        if personally_identifiable_information is not None:
            self._values["personally_identifiable_information"] = personally_identifiable_information
        if phased_release is not None:
            self._values["phased_release"] = phased_release
        if preconnect is not None:
            self._values["preconnect"] = preconnect
        if predictive_content_delivery is not None:
            self._values["predictive_content_delivery"] = predictive_content_delivery
        if predictive_prefetching is not None:
            self._values["predictive_prefetching"] = predictive_prefetching
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if prefetchable is not None:
            self._values["prefetchable"] = prefetchable
        if prefresh_cache is not None:
            self._values["prefresh_cache"] = prefresh_cache
        if quality is not None:
            self._values["quality"] = quality
        if quic_beta is not None:
            self._values["quic_beta"] = quic_beta
        if random_seek is not None:
            self._values["random_seek"] = random_seek
        if rapid is not None:
            self._values["rapid"] = rapid
        if read_timeout is not None:
            self._values["read_timeout"] = read_timeout
        if real_time_reporting is not None:
            self._values["real_time_reporting"] = real_time_reporting
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirectplus is not None:
            self._values["redirectplus"] = redirectplus
        if referer_checking is not None:
            self._values["referer_checking"] = referer_checking
        if remove_query_parameter is not None:
            self._values["remove_query_parameter"] = remove_query_parameter
        if remove_vary is not None:
            self._values["remove_vary"] = remove_vary
        if report is not None:
            self._values["report"] = report
        if request_client_hints is not None:
            self._values["request_client_hints"] = request_client_hints
        if request_control is not None:
            self._values["request_control"] = request_control
        if request_type_marker is not None:
            self._values["request_type_marker"] = request_type_marker
        if resource_optimizer is not None:
            self._values["resource_optimizer"] = resource_optimizer
        if resource_optimizer_extended_compatibility is not None:
            self._values["resource_optimizer_extended_compatibility"] = resource_optimizer_extended_compatibility
        if response_code is not None:
            self._values["response_code"] = response_code
        if response_cookie is not None:
            self._values["response_cookie"] = response_cookie
        if restrict_object_caching is not None:
            self._values["restrict_object_caching"] = restrict_object_caching
        if return_cache_status is not None:
            self._values["return_cache_status"] = return_cache_status
        if rewrite_url is not None:
            self._values["rewrite_url"] = rewrite_url
        if rum_custom is not None:
            self._values["rum_custom"] = rum_custom
        if saas_definitions is not None:
            self._values["saas_definitions"] = saas_definitions
        if sales_force_commerce_cloud_client is not None:
            self._values["sales_force_commerce_cloud_client"] = sales_force_commerce_cloud_client
        if sales_force_commerce_cloud_provider is not None:
            self._values["sales_force_commerce_cloud_provider"] = sales_force_commerce_cloud_provider
        if sales_force_commerce_cloud_provider_host_header is not None:
            self._values["sales_force_commerce_cloud_provider_host_header"] = sales_force_commerce_cloud_provider_host_header
        if save_post_dca_processing is not None:
            self._values["save_post_dca_processing"] = save_post_dca_processing
        if schedule_invalidation is not None:
            self._values["schedule_invalidation"] = schedule_invalidation
        if script_management is not None:
            self._values["script_management"] = script_management
        if segmented_content_protection is not None:
            self._values["segmented_content_protection"] = segmented_content_protection
        if segmented_media_optimization is not None:
            self._values["segmented_media_optimization"] = segmented_media_optimization
        if segmented_media_streaming_prefetch is not None:
            self._values["segmented_media_streaming_prefetch"] = segmented_media_streaming_prefetch
        if set_variable is not None:
            self._values["set_variable"] = set_variable
        if simulate_error_code is not None:
            self._values["simulate_error_code"] = simulate_error_code
        if site_shield is not None:
            self._values["site_shield"] = site_shield
        if standard_tls_migration is not None:
            self._values["standard_tls_migration"] = standard_tls_migration
        if standard_tls_migration_override is not None:
            self._values["standard_tls_migration_override"] = standard_tls_migration_override
        if strict_header_parsing is not None:
            self._values["strict_header_parsing"] = strict_header_parsing
        if sub_customer is not None:
            self._values["sub_customer"] = sub_customer
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if tcp_optimization is not None:
            self._values["tcp_optimization"] = tcp_optimization
        if tea_leaf is not None:
            self._values["tea_leaf"] = tea_leaf
        if tiered_distribution is not None:
            self._values["tiered_distribution"] = tiered_distribution
        if tiered_distribution_advanced is not None:
            self._values["tiered_distribution_advanced"] = tiered_distribution_advanced
        if tiered_distribution_customization is not None:
            self._values["tiered_distribution_customization"] = tiered_distribution_customization
        if timeout is not None:
            self._values["timeout"] = timeout
        if uid_configuration is not None:
            self._values["uid_configuration"] = uid_configuration
        if validate_entity_tag is not None:
            self._values["validate_entity_tag"] = validate_entity_tag
        if verify_json_web_token is not None:
            self._values["verify_json_web_token"] = verify_json_web_token
        if verify_json_web_token_for_dcp is not None:
            self._values["verify_json_web_token_for_dcp"] = verify_json_web_token_for_dcp
        if verify_token_authorization is not None:
            self._values["verify_token_authorization"] = verify_token_authorization
        if virtual_waiting_room is not None:
            self._values["virtual_waiting_room"] = virtual_waiting_room
        if virtual_waiting_room_with_edge_workers is not None:
            self._values["virtual_waiting_room_with_edge_workers"] = virtual_waiting_room_with_edge_workers
        if visitor_prioritization is not None:
            self._values["visitor_prioritization"] = visitor_prioritization
        if visitor_prioritization_fifo is not None:
            self._values["visitor_prioritization_fifo"] = visitor_prioritization_fifo
        if visitor_prioritization_fifo_standalone is not None:
            self._values["visitor_prioritization_fifo_standalone"] = visitor_prioritization_fifo_standalone
        if watermarking is not None:
            self._values["watermarking"] = watermarking
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall
        if webdav is not None:
            self._values["webdav"] = webdav
        if web_sockets is not None:
            self._values["web_sockets"] = web_sockets

    @builtins.property
    def adaptive_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration"]:
        '''adaptive_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        '''
        result = self._values.get("adaptive_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration"], result)

    @builtins.property
    def adaptive_image_compression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression"]:
        '''adaptive_image_compression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        '''
        result = self._values.get("adaptive_image_compression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression"], result)

    @builtins.property
    def ad_scaler_circuit_breaker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker"]:
        '''ad_scaler_circuit_breaker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        '''
        result = self._values.get("ad_scaler_circuit_breaker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker"], result)

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced"]:
        '''advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced"], result)

    @builtins.property
    def aggregated_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting"]:
        '''aggregated_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        '''
        result = self._values.get("aggregated_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting"], result)

    @builtins.property
    def akamaizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer"]:
        '''akamaizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        '''
        result = self._values.get("akamaizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer"], result)

    @builtins.property
    def akamaizer_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag"]:
        '''akamaizer_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        '''
        result = self._values.get("akamaizer_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag"], result)

    @builtins.property
    def all_http_in_cache_hierarchy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy"]:
        '''all_http_in_cache_hierarchy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        '''
        result = self._values.get("all_http_in_cache_hierarchy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy"], result)

    @builtins.property
    def allow_cloudlets_origins(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins"]:
        '''allow_cloudlets_origins block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        '''
        result = self._values.get("allow_cloudlets_origins")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins"], result)

    @builtins.property
    def allow_delete(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete"]:
        '''allow_delete block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        '''
        result = self._values.get("allow_delete")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete"], result)

    @builtins.property
    def allow_https_cache_key_sharing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing"]:
        '''allow_https_cache_key_sharing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        '''
        result = self._values.get("allow_https_cache_key_sharing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing"], result)

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade"]:
        '''allow_https_downgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade"], result)

    @builtins.property
    def allow_options(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions"]:
        '''allow_options block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        '''
        result = self._values.get("allow_options")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions"], result)

    @builtins.property
    def allow_patch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch"]:
        '''allow_patch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        '''
        result = self._values.get("allow_patch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch"], result)

    @builtins.property
    def allow_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost"]:
        '''allow_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        '''
        result = self._values.get("allow_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost"], result)

    @builtins.property
    def allow_put(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut"]:
        '''allow_put block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        '''
        result = self._values.get("allow_put")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut"], result)

    @builtins.property
    def allow_transfer_encoding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding"]:
        '''allow_transfer_encoding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        '''
        result = self._values.get("allow_transfer_encoding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding"], result)

    @builtins.property
    def alt_svc_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader"]:
        '''alt_svc_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        '''
        result = self._values.get("alt_svc_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader"], result)

    @builtins.property
    def api_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization"]:
        '''api_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        '''
        result = self._values.get("api_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization"], result)

    @builtins.property
    def application_load_balancer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer"]:
        '''application_load_balancer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        '''
        result = self._values.get("application_load_balancer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer"], result)

    @builtins.property
    def audience_segmentation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation"]:
        '''audience_segmentation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        '''
        result = self._values.get("audience_segmentation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation"], result)

    @builtins.property
    def auto_domain_validation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation"]:
        '''auto_domain_validation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        '''
        result = self._values.get("auto_domain_validation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation"], result)

    @builtins.property
    def base_directory(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory"]:
        '''base_directory block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        '''
        result = self._values.get("base_directory")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory"], result)

    @builtins.property
    def boss_beaconing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing"]:
        '''boss_beaconing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        '''
        result = self._values.get("boss_beaconing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing"], result)

    @builtins.property
    def breadcrumbs(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs"]:
        '''breadcrumbs block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        '''
        result = self._values.get("breadcrumbs")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs"], result)

    @builtins.property
    def break_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection"]:
        '''break_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        '''
        result = self._values.get("break_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection"], result)

    @builtins.property
    def brotli(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli"]:
        '''brotli block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        '''
        result = self._values.get("brotli")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli"], result)

    @builtins.property
    def cache_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError"]:
        '''cache_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        '''
        result = self._values.get("cache_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError"], result)

    @builtins.property
    def cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId"]:
        '''cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        '''
        result = self._values.get("cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId"], result)

    @builtins.property
    def cache_key_ignore_case(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase"]:
        '''cache_key_ignore_case block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        '''
        result = self._values.get("cache_key_ignore_case")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase"], result)

    @builtins.property
    def cache_key_query_params(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams"]:
        '''cache_key_query_params block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        '''
        result = self._values.get("cache_key_query_params")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams"], result)

    @builtins.property
    def cache_key_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite"]:
        '''cache_key_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        '''
        result = self._values.get("cache_key_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite"], result)

    @builtins.property
    def cache_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost"]:
        '''cache_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        '''
        result = self._values.get("cache_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost"], result)

    @builtins.property
    def cache_redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect"]:
        '''cache_redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        '''
        result = self._values.get("cache_redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect"], result)

    @builtins.property
    def cache_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag"]:
        '''cache_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        '''
        result = self._values.get("cache_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag"], result)

    @builtins.property
    def cache_tag_visible(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible"]:
        '''cache_tag_visible block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        '''
        result = self._values.get("cache_tag_visible")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible"], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching"]:
        '''caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching"], result)

    @builtins.property
    def central_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization"]:
        '''central_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        '''
        result = self._values.get("central_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization"], result)

    @builtins.property
    def chase_redirects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects"]:
        '''chase_redirects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        '''
        result = self._values.get("chase_redirects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects"], result)

    @builtins.property
    def client_certificate_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth"]:
        '''client_certificate_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_auth DataAkamaiPropertyRulesBuilder#client_certificate_auth}
        '''
        result = self._values.get("client_certificate_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth"], result)

    @builtins.property
    def client_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics"]:
        '''client_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        '''
        result = self._values.get("client_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics"], result)

    @builtins.property
    def cloud_interconnects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects"]:
        '''cloud_interconnects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        '''
        result = self._values.get("cloud_interconnects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects"], result)

    @builtins.property
    def cloud_wrapper(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper"]:
        '''cloud_wrapper block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        '''
        result = self._values.get("cloud_wrapper")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper"], result)

    @builtins.property
    def cloud_wrapper_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced"]:
        '''cloud_wrapper_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        '''
        result = self._values.get("cloud_wrapper_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced"], result)

    @builtins.property
    def common_media_client_data(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData"]:
        '''common_media_client_data block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        '''
        result = self._values.get("common_media_client_data")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData"], result)

    @builtins.property
    def conditional_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin"]:
        '''conditional_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        '''
        result = self._values.get("conditional_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin"], result)

    @builtins.property
    def construct_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse"]:
        '''construct_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        '''
        result = self._values.get("construct_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse"], result)

    @builtins.property
    def content_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics"]:
        '''content_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        '''
        result = self._values.get("content_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics"], result)

    @builtins.property
    def content_characteristics_amd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd"]:
        '''content_characteristics_amd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        '''
        result = self._values.get("content_characteristics_amd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd"], result)

    @builtins.property
    def content_characteristics_dd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd"]:
        '''content_characteristics_dd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        '''
        result = self._values.get("content_characteristics_dd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd"], result)

    @builtins.property
    def content_characteristics_wsd_large_file(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile"]:
        '''content_characteristics_wsd_large_file block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        '''
        result = self._values.get("content_characteristics_wsd_large_file")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile"], result)

    @builtins.property
    def content_characteristics_wsd_live(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive"]:
        '''content_characteristics_wsd_live block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        '''
        result = self._values.get("content_characteristics_wsd_live")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive"], result)

    @builtins.property
    def content_characteristics_wsd_vod(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod"]:
        '''content_characteristics_wsd_vod block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        '''
        result = self._values.get("content_characteristics_wsd_vod")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod"], result)

    @builtins.property
    def content_pre_position(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition"]:
        '''content_pre_position block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        '''
        result = self._values.get("content_pre_position")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition"], result)

    @builtins.property
    def content_targeting_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection"]:
        '''content_targeting_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        '''
        result = self._values.get("content_targeting_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection"], result)

    @builtins.property
    def cors_support(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport"]:
        '''cors_support block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        '''
        result = self._values.get("cors_support")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport"], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode"], result)

    @builtins.property
    def custom_behavior(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior"]:
        '''custom_behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        '''
        result = self._values.get("custom_behavior")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior"], result)

    @builtins.property
    def datastream(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream"]:
        '''datastream block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        '''
        result = self._values.get("datastream")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream"], result)

    @builtins.property
    def dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp"]:
        '''dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        '''
        result = self._values.get("dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp"], result)

    @builtins.property
    def dcp_auth_hmac_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation"]:
        '''dcp_auth_hmac_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        '''
        result = self._values.get("dcp_auth_hmac_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation"], result)

    @builtins.property
    def dcp_auth_regex_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation"]:
        '''dcp_auth_regex_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        '''
        result = self._values.get("dcp_auth_regex_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation"], result)

    @builtins.property
    def dcp_auth_substring_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation"]:
        '''dcp_auth_substring_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        '''
        result = self._values.get("dcp_auth_substring_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation"], result)

    @builtins.property
    def dcp_auth_variable_extractor(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor"]:
        '''dcp_auth_variable_extractor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        '''
        result = self._values.get("dcp_auth_variable_extractor")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor"], result)

    @builtins.property
    def dcp_default_authz_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups"]:
        '''dcp_default_authz_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        '''
        result = self._values.get("dcp_default_authz_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups"], result)

    @builtins.property
    def dcp_dev_relations(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations"]:
        '''dcp_dev_relations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        '''
        result = self._values.get("dcp_dev_relations")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations"], result)

    @builtins.property
    def dcp_real_time_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth"]:
        '''dcp_real_time_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        '''
        result = self._values.get("dcp_real_time_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth"], result)

    @builtins.property
    def delivery_receipt(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt"]:
        '''delivery_receipt block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        '''
        result = self._values.get("delivery_receipt")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt"], result)

    @builtins.property
    def deny_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess"]:
        '''deny_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        '''
        result = self._values.get("deny_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess"], result)

    @builtins.property
    def deny_direct_failover_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess"]:
        '''deny_direct_failover_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        '''
        result = self._values.get("deny_direct_failover_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess"], result)

    @builtins.property
    def device_characteristic_cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId"]:
        '''device_characteristic_cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        '''
        result = self._values.get("device_characteristic_cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId"], result)

    @builtins.property
    def device_characteristic_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader"]:
        '''device_characteristic_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        '''
        result = self._values.get("device_characteristic_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader"], result)

    @builtins.property
    def dns_async_refresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh"]:
        '''dns_async_refresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        '''
        result = self._values.get("dns_async_refresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh"], result)

    @builtins.property
    def dns_prefresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh"]:
        '''dns_prefresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        '''
        result = self._values.get("dns_prefresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh"], result)

    @builtins.property
    def downgrade_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol"]:
        '''downgrade_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        '''
        result = self._values.get("downgrade_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol"], result)

    @builtins.property
    def download_complete_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker"]:
        '''download_complete_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        '''
        result = self._values.get("download_complete_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker"], result)

    @builtins.property
    def download_notification(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification"]:
        '''download_notification block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        '''
        result = self._values.get("download_notification")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification"], result)

    @builtins.property
    def downstream_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache"]:
        '''downstream_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        '''
        result = self._values.get("downstream_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache"], result)

    @builtins.property
    def dynamic_throughtput_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization"]:
        '''dynamic_throughtput_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        '''
        result = self._values.get("dynamic_throughtput_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization"], result)

    @builtins.property
    def dynamic_throughtput_optimization_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride"]:
        '''dynamic_throughtput_optimization_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        '''
        result = self._values.get("dynamic_throughtput_optimization_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride"], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent"]:
        '''dynamic_web_content block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent"], result)

    @builtins.property
    def ecms_bulk_upload(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload"]:
        '''ecms_bulk_upload block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        '''
        result = self._values.get("ecms_bulk_upload")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload"], result)

    @builtins.property
    def ecms_database(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase"]:
        '''ecms_database block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        '''
        result = self._values.get("ecms_database")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase"], result)

    @builtins.property
    def ecms_dataset(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset"]:
        '''ecms_dataset block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        '''
        result = self._values.get("ecms_dataset")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset"], result)

    @builtins.property
    def ecms_object_key(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey"]:
        '''ecms_object_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        '''
        result = self._values.get("ecms_object_key")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey"], result)

    @builtins.property
    def edge_connect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect"]:
        '''edge_connect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        '''
        result = self._values.get("edge_connect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect"], result)

    @builtins.property
    def edge_load_balancing_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced"]:
        '''edge_load_balancing_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        '''
        result = self._values.get("edge_load_balancing_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced"], result)

    @builtins.property
    def edge_load_balancing_data_center(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter"]:
        '''edge_load_balancing_data_center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        '''
        result = self._values.get("edge_load_balancing_data_center")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter"], result)

    @builtins.property
    def edge_load_balancing_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin"]:
        '''edge_load_balancing_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        '''
        result = self._values.get("edge_load_balancing_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin"], result)

    @builtins.property
    def edge_origin_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization"]:
        '''edge_origin_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        '''
        result = self._values.get("edge_origin_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization"], result)

    @builtins.property
    def edge_redirector(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector"]:
        '''edge_redirector block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        '''
        result = self._values.get("edge_redirector")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector"], result)

    @builtins.property
    def edge_scape(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape"]:
        '''edge_scape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        '''
        result = self._values.get("edge_scape")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape"], result)

    @builtins.property
    def edge_side_includes(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes"]:
        '''edge_side_includes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        '''
        result = self._values.get("edge_side_includes")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes"], result)

    @builtins.property
    def edge_worker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker"]:
        '''edge_worker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        '''
        result = self._values.get("edge_worker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker"], result)

    @builtins.property
    def enforce_mtls_settings(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings"]:
        '''enforce_mtls_settings block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls_settings DataAkamaiPropertyRulesBuilder#enforce_mtls_settings}
        '''
        result = self._values.get("enforce_mtls_settings")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings"], result)

    @builtins.property
    def enhanced_akamai_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol"]:
        '''enhanced_akamai_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        '''
        result = self._values.get("enhanced_akamai_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol"], result)

    @builtins.property
    def enhanced_proxy_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection"]:
        '''enhanced_proxy_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        '''
        result = self._values.get("enhanced_proxy_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection"], result)

    @builtins.property
    def epd_forward_header_enrichment(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment"]:
        '''epd_forward_header_enrichment block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        '''
        result = self._values.get("epd_forward_header_enrichment")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment"], result)

    @builtins.property
    def fail_action(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction"]:
        '''fail_action block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        '''
        result = self._values.get("fail_action")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction"], result)

    @builtins.property
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility"]:
        '''failover_bot_manager_feature_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        '''
        result = self._values.get("failover_bot_manager_feature_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility"], result)

    @builtins.property
    def fast_invalidate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate"]:
        '''fast_invalidate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        '''
        result = self._values.get("fast_invalidate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate"], result)

    @builtins.property
    def fips(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips"]:
        '''fips block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fips DataAkamaiPropertyRulesBuilder#fips}
        '''
        result = self._values.get("fips")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips"], result)

    @builtins.property
    def first_party_marketing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing"]:
        '''first_party_marketing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        '''
        result = self._values.get("first_party_marketing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing"], result)

    @builtins.property
    def first_party_marketing_plus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus"]:
        '''first_party_marketing_plus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        '''
        result = self._values.get("first_party_marketing_plus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus"], result)

    @builtins.property
    def forward_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite"]:
        '''forward_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        '''
        result = self._values.get("forward_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite"], result)

    @builtins.property
    def g2_oheader(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader"]:
        '''g2oheader block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        '''
        result = self._values.get("g2_oheader")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader"], result)

    @builtins.property
    def global_request_number(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber"]:
        '''global_request_number block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        '''
        result = self._values.get("global_request_number")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber"], result)

    @builtins.property
    def graphql_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching"]:
        '''graphql_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        '''
        result = self._values.get("graphql_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching"], result)

    @builtins.property
    def gzip_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse"]:
        '''gzip_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        '''
        result = self._values.get("gzip_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse"], result)

    @builtins.property
    def hd_data_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced"]:
        '''hd_data_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        '''
        result = self._values.get("hd_data_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced"], result)

    @builtins.property
    def health_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection"]:
        '''health_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        '''
        result = self._values.get("health_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection"], result)

    @builtins.property
    def hsaf_eip_binding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding"]:
        '''hsaf_eip_binding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        '''
        result = self._values.get("hsaf_eip_binding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding"], result)

    @builtins.property
    def http2(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2"]:
        '''http2 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        '''
        result = self._values.get("http2")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2"], result)

    @builtins.property
    def http3(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3"]:
        '''http3 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        '''
        result = self._values.get("http3")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3"], result)

    @builtins.property
    def http_strict_transport_security(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity"]:
        '''http_strict_transport_security block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        '''
        result = self._values.get("http_strict_transport_security")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity"], result)

    @builtins.property
    def http_to_https_upgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade"]:
        '''http_to_https_upgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        '''
        result = self._values.get("http_to_https_upgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade"], result)

    @builtins.property
    def image_and_video_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager"]:
        '''image_and_video_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        '''
        result = self._values.get("image_and_video_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager"], result)

    @builtins.property
    def image_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager"]:
        '''image_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        '''
        result = self._values.get("image_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager"], result)

    @builtins.property
    def image_manager_video(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo"]:
        '''image_manager_video block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        '''
        result = self._values.get("image_manager_video")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo"], result)

    @builtins.property
    def im_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride"]:
        '''im_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        '''
        result = self._values.get("im_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride"], result)

    @builtins.property
    def include(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude"]:
        '''include block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        '''
        result = self._values.get("include")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude"], result)

    @builtins.property
    def instant(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant"]:
        '''instant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        '''
        result = self._values.get("instant")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant"], result)

    @builtins.property
    def instant_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig"]:
        '''instant_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        '''
        result = self._values.get("instant_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig"], result)

    @builtins.property
    def large_file_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization"]:
        '''large_file_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        '''
        result = self._values.get("large_file_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization"], result)

    @builtins.property
    def large_file_optimization_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced"]:
        '''large_file_optimization_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        '''
        result = self._values.get("large_file_optimization_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced"], result)

    @builtins.property
    def limit_bit_rate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate"]:
        '''limit_bit_rate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        '''
        result = self._values.get("limit_bit_rate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate"], result)

    @builtins.property
    def log_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom"]:
        '''log_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        '''
        result = self._values.get("log_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom"], result)

    @builtins.property
    def manifest_personalization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization"]:
        '''manifest_personalization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        '''
        result = self._values.get("manifest_personalization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization"], result)

    @builtins.property
    def manifest_rerouting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting"]:
        '''manifest_rerouting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        '''
        result = self._values.get("manifest_rerouting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting"], result)

    @builtins.property
    def manual_server_push(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush"]:
        '''manual_server_push block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        '''
        result = self._values.get("manual_server_push")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush"], result)

    @builtins.property
    def media_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration"]:
        '''media_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        '''
        result = self._values.get("media_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration"], result)

    @builtins.property
    def media_acceleration_quic_optout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout"]:
        '''media_acceleration_quic_optout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        '''
        result = self._values.get("media_acceleration_quic_optout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout"], result)

    @builtins.property
    def media_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient"]:
        '''media_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        '''
        result = self._values.get("media_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient"], result)

    @builtins.property
    def media_file_retrieval_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization"]:
        '''media_file_retrieval_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        '''
        result = self._values.get("media_file_retrieval_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization"], result)

    @builtins.property
    def media_origin_failover(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover"]:
        '''media_origin_failover block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        '''
        result = self._values.get("media_origin_failover")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover"], result)

    @builtins.property
    def metadata_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching"]:
        '''metadata_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        '''
        result = self._values.get("metadata_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching"], result)

    @builtins.property
    def mobile_sdk_performance(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance"]:
        '''mobile_sdk_performance block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        '''
        result = self._values.get("mobile_sdk_performance")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance"], result)

    @builtins.property
    def modify_incoming_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader"]:
        '''modify_incoming_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        '''
        result = self._values.get("modify_incoming_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader"], result)

    @builtins.property
    def modify_incoming_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader"]:
        '''modify_incoming_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        '''
        result = self._values.get("modify_incoming_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader"], result)

    @builtins.property
    def modify_outgoing_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader"]:
        '''modify_outgoing_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        '''
        result = self._values.get("modify_outgoing_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader"], result)

    @builtins.property
    def modify_outgoing_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader"]:
        '''modify_outgoing_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        '''
        result = self._values.get("modify_outgoing_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader"], result)

    @builtins.property
    def modify_via_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader"]:
        '''modify_via_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        '''
        result = self._values.get("modify_via_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader"], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse"]:
        '''m_pulse block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse"], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin"]:
        '''origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin"], result)

    @builtins.property
    def origin_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics"]:
        '''origin_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        '''
        result = self._values.get("origin_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics"], result)

    @builtins.property
    def origin_characteristics_wsd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd"]:
        '''origin_characteristics_wsd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        '''
        result = self._values.get("origin_characteristics_wsd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd"], result)

    @builtins.property
    def origin_failure_recovery_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod"]:
        '''origin_failure_recovery_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        '''
        result = self._values.get("origin_failure_recovery_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod"], result)

    @builtins.property
    def origin_failure_recovery_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy"]:
        '''origin_failure_recovery_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        '''
        result = self._values.get("origin_failure_recovery_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy"], result)

    @builtins.property
    def origin_ip_acl(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl"]:
        '''origin_ip_acl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        '''
        result = self._values.get("origin_ip_acl")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl"], result)

    @builtins.property
    def permissions_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy"]:
        '''permissions_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy DataAkamaiPropertyRulesBuilder#permissions_policy}
        '''
        result = self._values.get("permissions_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy"], result)

    @builtins.property
    def persistent_client_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection"]:
        '''persistent_client_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        '''
        result = self._values.get("persistent_client_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection"], result)

    @builtins.property
    def persistent_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection"]:
        '''persistent_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        '''
        result = self._values.get("persistent_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection"], result)

    @builtins.property
    def personally_identifiable_information(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation"]:
        '''personally_identifiable_information block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        '''
        result = self._values.get("personally_identifiable_information")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation"], result)

    @builtins.property
    def phased_release(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease"]:
        '''phased_release block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        '''
        result = self._values.get("phased_release")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease"], result)

    @builtins.property
    def preconnect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect"]:
        '''preconnect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        '''
        result = self._values.get("preconnect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect"], result)

    @builtins.property
    def predictive_content_delivery(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery"]:
        '''predictive_content_delivery block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        '''
        result = self._values.get("predictive_content_delivery")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery"], result)

    @builtins.property
    def predictive_prefetching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching"]:
        '''predictive_prefetching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        '''
        result = self._values.get("predictive_prefetching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching"], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch"]:
        '''prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch"], result)

    @builtins.property
    def prefetchable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable"]:
        '''prefetchable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        '''
        result = self._values.get("prefetchable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable"], result)

    @builtins.property
    def prefresh_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache"]:
        '''prefresh_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        '''
        result = self._values.get("prefresh_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache"], result)

    @builtins.property
    def quality(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality"]:
        '''quality block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        '''
        result = self._values.get("quality")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality"], result)

    @builtins.property
    def quic_beta(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta"]:
        '''quic_beta block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        '''
        result = self._values.get("quic_beta")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta"], result)

    @builtins.property
    def random_seek(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek"]:
        '''random_seek block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        '''
        result = self._values.get("random_seek")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek"], result)

    @builtins.property
    def rapid(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid"]:
        '''rapid block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        '''
        result = self._values.get("rapid")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid"], result)

    @builtins.property
    def read_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout"]:
        '''read_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        '''
        result = self._values.get("read_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout"], result)

    @builtins.property
    def real_time_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting"]:
        '''real_time_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        '''
        result = self._values.get("real_time_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting"], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring"]:
        '''real_user_monitoring block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring"], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect"]:
        '''redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect"], result)

    @builtins.property
    def redirectplus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus"]:
        '''redirectplus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        '''
        result = self._values.get("redirectplus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus"], result)

    @builtins.property
    def referer_checking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking"]:
        '''referer_checking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        '''
        result = self._values.get("referer_checking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking"], result)

    @builtins.property
    def remove_query_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter"]:
        '''remove_query_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        '''
        result = self._values.get("remove_query_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter"], result)

    @builtins.property
    def remove_vary(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary"]:
        '''remove_vary block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        '''
        result = self._values.get("remove_vary")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary"], result)

    @builtins.property
    def report(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport"]:
        '''report block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        '''
        result = self._values.get("report")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport"], result)

    @builtins.property
    def request_client_hints(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints"]:
        '''request_client_hints block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_client_hints DataAkamaiPropertyRulesBuilder#request_client_hints}
        '''
        result = self._values.get("request_client_hints")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints"], result)

    @builtins.property
    def request_control(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl"]:
        '''request_control block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        '''
        result = self._values.get("request_control")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl"], result)

    @builtins.property
    def request_type_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker"]:
        '''request_type_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        '''
        result = self._values.get("request_type_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker"], result)

    @builtins.property
    def resource_optimizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer"]:
        '''resource_optimizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        '''
        result = self._values.get("resource_optimizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer"], result)

    @builtins.property
    def resource_optimizer_extended_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility"]:
        '''resource_optimizer_extended_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        '''
        result = self._values.get("resource_optimizer_extended_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility"], result)

    @builtins.property
    def response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode"]:
        '''response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode"], result)

    @builtins.property
    def response_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie"]:
        '''response_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        '''
        result = self._values.get("response_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie"], result)

    @builtins.property
    def restrict_object_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching"]:
        '''restrict_object_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        '''
        result = self._values.get("restrict_object_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching"], result)

    @builtins.property
    def return_cache_status(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus"]:
        '''return_cache_status block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        '''
        result = self._values.get("return_cache_status")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus"], result)

    @builtins.property
    def rewrite_url(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl"]:
        '''rewrite_url block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        '''
        result = self._values.get("rewrite_url")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl"], result)

    @builtins.property
    def rum_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom"]:
        '''rum_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        '''
        result = self._values.get("rum_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom"], result)

    @builtins.property
    def saas_definitions(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions"]:
        '''saas_definitions block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        '''
        result = self._values.get("saas_definitions")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions"], result)

    @builtins.property
    def sales_force_commerce_cloud_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient"]:
        '''sales_force_commerce_cloud_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        '''
        result = self._values.get("sales_force_commerce_cloud_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider"]:
        '''sales_force_commerce_cloud_provider block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        '''sales_force_commerce_cloud_provider_host_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider_host_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader"], result)

    @builtins.property
    def save_post_dca_processing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing"]:
        '''save_post_dca_processing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        '''
        result = self._values.get("save_post_dca_processing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing"], result)

    @builtins.property
    def schedule_invalidation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation"]:
        '''schedule_invalidation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        '''
        result = self._values.get("schedule_invalidation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation"], result)

    @builtins.property
    def script_management(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement"]:
        '''script_management block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        '''
        result = self._values.get("script_management")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement"], result)

    @builtins.property
    def segmented_content_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection"]:
        '''segmented_content_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        '''
        result = self._values.get("segmented_content_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection"], result)

    @builtins.property
    def segmented_media_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization"]:
        '''segmented_media_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        '''
        result = self._values.get("segmented_media_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization"], result)

    @builtins.property
    def segmented_media_streaming_prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch"]:
        '''segmented_media_streaming_prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        '''
        result = self._values.get("segmented_media_streaming_prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch"], result)

    @builtins.property
    def set_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable"]:
        '''set_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        '''
        result = self._values.get("set_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable"], result)

    @builtins.property
    def simulate_error_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode"]:
        '''simulate_error_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        '''
        result = self._values.get("simulate_error_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode"], result)

    @builtins.property
    def site_shield(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield"]:
        '''site_shield block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        '''
        result = self._values.get("site_shield")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield"], result)

    @builtins.property
    def standard_tls_migration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration"]:
        '''standard_tls_migration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        '''
        result = self._values.get("standard_tls_migration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration"], result)

    @builtins.property
    def standard_tls_migration_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride"]:
        '''standard_tls_migration_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        '''
        result = self._values.get("standard_tls_migration_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride"], result)

    @builtins.property
    def strict_header_parsing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing"]:
        '''strict_header_parsing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        '''
        result = self._values.get("strict_header_parsing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing"], result)

    @builtins.property
    def sub_customer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer"]:
        '''sub_customer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        '''
        result = self._values.get("sub_customer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer"], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute"]:
        '''sure_route block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute"], result)

    @builtins.property
    def tcp_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization"]:
        '''tcp_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        '''
        result = self._values.get("tcp_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization"], result)

    @builtins.property
    def tea_leaf(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf"]:
        '''tea_leaf block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        '''
        result = self._values.get("tea_leaf")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf"], result)

    @builtins.property
    def tiered_distribution(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution"]:
        '''tiered_distribution block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        '''
        result = self._values.get("tiered_distribution")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution"], result)

    @builtins.property
    def tiered_distribution_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced"]:
        '''tiered_distribution_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        '''
        result = self._values.get("tiered_distribution_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced"], result)

    @builtins.property
    def tiered_distribution_customization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization"]:
        '''tiered_distribution_customization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        '''
        result = self._values.get("tiered_distribution_customization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization"], result)

    @builtins.property
    def timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout"]:
        '''timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout"], result)

    @builtins.property
    def uid_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration"]:
        '''uid_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        '''
        result = self._values.get("uid_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration"], result)

    @builtins.property
    def validate_entity_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag"]:
        '''validate_entity_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        '''
        result = self._values.get("validate_entity_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag"], result)

    @builtins.property
    def verify_json_web_token(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken"]:
        '''verify_json_web_token block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        '''
        result = self._values.get("verify_json_web_token")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken"], result)

    @builtins.property
    def verify_json_web_token_for_dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp"]:
        '''verify_json_web_token_for_dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        '''
        result = self._values.get("verify_json_web_token_for_dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp"], result)

    @builtins.property
    def verify_token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization"]:
        '''verify_token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        '''
        result = self._values.get("verify_token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization"], result)

    @builtins.property
    def virtual_waiting_room(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom"]:
        '''virtual_waiting_room block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        '''
        result = self._values.get("virtual_waiting_room")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom"], result)

    @builtins.property
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        '''virtual_waiting_room_with_edge_workers block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        '''
        result = self._values.get("virtual_waiting_room_with_edge_workers")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers"], result)

    @builtins.property
    def visitor_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization"]:
        '''visitor_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        '''
        result = self._values.get("visitor_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization"], result)

    @builtins.property
    def visitor_prioritization_fifo(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo"]:
        '''visitor_prioritization_fifo block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        '''
        result = self._values.get("visitor_prioritization_fifo")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo"], result)

    @builtins.property
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone"]:
        '''visitor_prioritization_fifo_standalone block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        '''
        result = self._values.get("visitor_prioritization_fifo_standalone")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone"], result)

    @builtins.property
    def watermarking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking"]:
        '''watermarking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        '''
        result = self._values.get("watermarking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking"], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall"]:
        '''web_application_firewall block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall"], result)

    @builtins.property
    def webdav(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav"]:
        '''webdav block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        '''
        result = self._values.get("webdav")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav"], result)

    @builtins.property
    def web_sockets(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets"]:
        '''web_sockets block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        result = self._values.get("web_sockets")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030Behavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker",
    jsii_struct_bases=[],
    name_mapping={
        "fallback_action_response_code_based": "fallbackActionResponseCodeBased",
        "locked": "locked",
        "response_code_based": "responseCodeBased",
        "response_codes": "responseCodes",
        "response_delay_based": "responseDelayBased",
        "response_delay_threshold": "responseDelayThreshold",
        "return_error_response_code_based": "returnErrorResponseCodeBased",
        "specify_your_own_response_code_based": "specifyYourOwnResponseCodeBased",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker:
    def __init__(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f26a6cef6b3de75eedc143f335b2936322cd38b2553975437b5f4f07edec18c)
            check_type(argname="argument fallback_action_response_code_based", value=fallback_action_response_code_based, expected_type=type_hints["fallback_action_response_code_based"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code_based", value=response_code_based, expected_type=type_hints["response_code_based"])
            check_type(argname="argument response_codes", value=response_codes, expected_type=type_hints["response_codes"])
            check_type(argname="argument response_delay_based", value=response_delay_based, expected_type=type_hints["response_delay_based"])
            check_type(argname="argument response_delay_threshold", value=response_delay_threshold, expected_type=type_hints["response_delay_threshold"])
            check_type(argname="argument return_error_response_code_based", value=return_error_response_code_based, expected_type=type_hints["return_error_response_code_based"])
            check_type(argname="argument specify_your_own_response_code_based", value=specify_your_own_response_code_based, expected_type=type_hints["specify_your_own_response_code_based"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fallback_action_response_code_based is not None:
            self._values["fallback_action_response_code_based"] = fallback_action_response_code_based
        if locked is not None:
            self._values["locked"] = locked
        if response_code_based is not None:
            self._values["response_code_based"] = response_code_based
        if response_codes is not None:
            self._values["response_codes"] = response_codes
        if response_delay_based is not None:
            self._values["response_delay_based"] = response_delay_based
        if response_delay_threshold is not None:
            self._values["response_delay_threshold"] = response_delay_threshold
        if return_error_response_code_based is not None:
            self._values["return_error_response_code_based"] = return_error_response_code_based
        if specify_your_own_response_code_based is not None:
            self._values["specify_your_own_response_code_based"] = specify_your_own_response_code_based
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def fallback_action_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        '''
        result = self._values.get("fallback_action_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the response code from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        '''
        result = self._values.get("response_code_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_codes(self) -> typing.Optional[builtins.str]:
        '''Specifies the codes in the partner's response that trigger the fallback action,  either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        '''
        result = self._values.get("response_codes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_delay_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the delayed response from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        '''
        result = self._values.get("response_delay_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_delay_threshold(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum response delay that, if exceeded, triggers the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        '''
        result = self._values.get("response_delay_threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def return_error_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the error to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        '''
        result = self._values.get("return_error_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_your_own_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Defines a custom error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        '''
        result = self._values.get("specify_your_own_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreakerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreakerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccfa4c6691a094289f1e30de935836a8b7c3af5f9265001cef58ceeb9974dd0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFallbackActionResponseCodeBased")
    def reset_fallback_action_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFallbackActionResponseCodeBased", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCodeBased")
    def reset_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodeBased", []))

    @jsii.member(jsii_name="resetResponseCodes")
    def reset_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodes", []))

    @jsii.member(jsii_name="resetResponseDelayBased")
    def reset_response_delay_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayBased", []))

    @jsii.member(jsii_name="resetResponseDelayThreshold")
    def reset_response_delay_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayThreshold", []))

    @jsii.member(jsii_name="resetReturnErrorResponseCodeBased")
    def reset_return_error_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnErrorResponseCodeBased", []))

    @jsii.member(jsii_name="resetSpecifyYourOwnResponseCodeBased")
    def reset_specify_your_own_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyYourOwnResponseCodeBased", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBasedInput")
    def fallback_action_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fallbackActionResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeBasedInput")
    def response_code_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodesInput")
    def response_codes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayBasedInput")
    def response_delay_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseDelayBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayThresholdInput")
    def response_delay_threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseDelayThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBasedInput")
    def return_error_response_code_based_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "returnErrorResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBasedInput")
    def specify_your_own_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "specifyYourOwnResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBased")
    def fallback_action_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fallbackActionResponseCodeBased"))

    @fallback_action_response_code_based.setter
    def fallback_action_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__293421fa67e3a9f452c58bdffc24843b58cc28854b8c6331c5ba512a2915c6f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fallbackActionResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb306f2ac5674f8949895b15dab3349e17ddc136a48810788750f0d8f7257a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodeBased")
    def response_code_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseCodeBased"))

    @response_code_based.setter
    def response_code_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c1ff241bad1252dd5fed419333357b759663eef904ac677d650b2cc38a0e4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodes")
    def response_codes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseCodes"))

    @response_codes.setter
    def response_codes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__405a6fa7fd82d03cd6baf8cfa13c52341c00ec845ebffb07c3f1e86be358b1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayBased")
    def response_delay_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseDelayBased"))

    @response_delay_based.setter
    def response_delay_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8643dc38102748f7be9434037348c01f614539d5fdbe8a17e3ffaf879e5cce0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayThreshold")
    def response_delay_threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseDelayThreshold"))

    @response_delay_threshold.setter
    def response_delay_threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a06c27547d8cadd1ad1a297fe9c28e181a5499ff27addb56167d202971e370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBased")
    def return_error_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "returnErrorResponseCodeBased"))

    @return_error_response_code_based.setter
    def return_error_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c33d4a0ea60f2f8baef5f3679f5d069973cca34a311202d9e23d7634b750295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "returnErrorResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBased")
    def specify_your_own_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "specifyYourOwnResponseCodeBased"))

    @specify_your_own_response_code_based.setter
    def specify_your_own_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312ab6dd9d844fe8493b2d6208a888aede29203f44fd3d88994a1c67748ccfbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyYourOwnResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a692a21f64e6b0a923b5795aa11fbfb429a4c7e8aa69a66890f1b25286f7fd97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8084402be6dc2f50a1fb61aa63a9ee4b64a73d68cd0baa9cf17b8b1c362f58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecdf01817becd38aed4b6b73305b2387fad00c67971f39886bf589ecff8b6736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "ab_logic": "abLogic",
        "ab_testing": "abTesting",
        "compression": "compression",
        "cookie_name": "cookieName",
        "enable_brotli_compression": "enableBrotliCompression",
        "enable_for_noncacheable": "enableForNoncacheable",
        "enable_preconnect": "enablePreconnect",
        "enable_push": "enablePush",
        "enable_ro": "enableRo",
        "locked": "locked",
        "preload_enable": "preloadEnable",
        "source": "source",
        "template_uuid": "templateUuid",
        "title_brotli": "titleBrotli",
        "title_http2_server_push": "titleHttp2ServerPush",
        "title_preconnect": "titlePreconnect",
        "title_preload": "titlePreload",
        "title_ro": "titleRo",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration:
    def __init__(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f86e2240a2b92204d3bccf27823272a2558089025c7ef182d920ae88dc62978)
            check_type(argname="argument ab_logic", value=ab_logic, expected_type=type_hints["ab_logic"])
            check_type(argname="argument ab_testing", value=ab_testing, expected_type=type_hints["ab_testing"])
            check_type(argname="argument compression", value=compression, expected_type=type_hints["compression"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument enable_brotli_compression", value=enable_brotli_compression, expected_type=type_hints["enable_brotli_compression"])
            check_type(argname="argument enable_for_noncacheable", value=enable_for_noncacheable, expected_type=type_hints["enable_for_noncacheable"])
            check_type(argname="argument enable_preconnect", value=enable_preconnect, expected_type=type_hints["enable_preconnect"])
            check_type(argname="argument enable_push", value=enable_push, expected_type=type_hints["enable_push"])
            check_type(argname="argument enable_ro", value=enable_ro, expected_type=type_hints["enable_ro"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preload_enable", value=preload_enable, expected_type=type_hints["preload_enable"])
            check_type(argname="argument source", value=source, expected_type=type_hints["source"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_brotli", value=title_brotli, expected_type=type_hints["title_brotli"])
            check_type(argname="argument title_http2_server_push", value=title_http2_server_push, expected_type=type_hints["title_http2_server_push"])
            check_type(argname="argument title_preconnect", value=title_preconnect, expected_type=type_hints["title_preconnect"])
            check_type(argname="argument title_preload", value=title_preload, expected_type=type_hints["title_preload"])
            check_type(argname="argument title_ro", value=title_ro, expected_type=type_hints["title_ro"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_logic is not None:
            self._values["ab_logic"] = ab_logic
        if ab_testing is not None:
            self._values["ab_testing"] = ab_testing
        if compression is not None:
            self._values["compression"] = compression
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if enable_brotli_compression is not None:
            self._values["enable_brotli_compression"] = enable_brotli_compression
        if enable_for_noncacheable is not None:
            self._values["enable_for_noncacheable"] = enable_for_noncacheable
        if enable_preconnect is not None:
            self._values["enable_preconnect"] = enable_preconnect
        if enable_push is not None:
            self._values["enable_push"] = enable_push
        if enable_ro is not None:
            self._values["enable_ro"] = enable_ro
        if locked is not None:
            self._values["locked"] = locked
        if preload_enable is not None:
            self._values["preload_enable"] = preload_enable
        if source is not None:
            self._values["source"] = source
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_brotli is not None:
            self._values["title_brotli"] = title_brotli
        if title_http2_server_push is not None:
            self._values["title_http2_server_push"] = title_http2_server_push
        if title_preconnect is not None:
            self._values["title_preconnect"] = title_preconnect
        if title_preload is not None:
            self._values["title_preload"] = title_preload
        if title_ro is not None:
            self._values["title_ro"] = title_ro
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def ab_logic(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to use Adaptive Acceleration in an A/B testing environment.

        To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        '''
        result = self._values.get("ab_logic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ab_testing(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        '''
        result = self._values.get("ab_testing")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compression(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        '''
        result = self._values.get("compression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_brotli_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression, converting your origin content to cache on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        '''
        result = self._values.get("enable_brotli_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_for_noncacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression to non-cacheable content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        '''
        result = self._values.get("enable_for_noncacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_preconnect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time.

        See ``Automatic Preconnect`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        '''
        result = self._values.get("enable_preconnect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_push(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Recognizes resources like JavaScript, CSS, and images  based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app.

        See ``Automatic Server Push`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        '''
        result = self._values.get("enable_push")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ro(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        '''
        result = self._values.get("enable_ro")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preload_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to preload necessary fonts before they fetch and process other resources.

        See ``Automatic Font Preload`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        '''
        result = self._values.get("preload_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def source(self) -> typing.Optional[builtins.str]:
        '''The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``.

        The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        '''
        result = self._values.get("source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_brotli(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        '''
        result = self._values.get("title_brotli")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_http2_server_push(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        '''
        result = self._values.get("title_http2_server_push")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preconnect(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        '''
        result = self._values.get("title_preconnect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preload(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        '''
        result = self._values.get("title_preload")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_ro(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        '''
        result = self._values.get("title_ro")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d18edce92e300c58d5edfb8cba50ff667e3139012cccba5ac58aca8a9c06edf1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbLogic")
    def reset_ab_logic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbLogic", []))

    @jsii.member(jsii_name="resetAbTesting")
    def reset_ab_testing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbTesting", []))

    @jsii.member(jsii_name="resetCompression")
    def reset_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompression", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetEnableBrotliCompression")
    def reset_enable_brotli_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBrotliCompression", []))

    @jsii.member(jsii_name="resetEnableForNoncacheable")
    def reset_enable_for_noncacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableForNoncacheable", []))

    @jsii.member(jsii_name="resetEnablePreconnect")
    def reset_enable_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePreconnect", []))

    @jsii.member(jsii_name="resetEnablePush")
    def reset_enable_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePush", []))

    @jsii.member(jsii_name="resetEnableRo")
    def reset_enable_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreloadEnable")
    def reset_preload_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreloadEnable", []))

    @jsii.member(jsii_name="resetSource")
    def reset_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSource", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleBrotli")
    def reset_title_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleBrotli", []))

    @jsii.member(jsii_name="resetTitleHttp2ServerPush")
    def reset_title_http2_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleHttp2ServerPush", []))

    @jsii.member(jsii_name="resetTitlePreconnect")
    def reset_title_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreconnect", []))

    @jsii.member(jsii_name="resetTitlePreload")
    def reset_title_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreload", []))

    @jsii.member(jsii_name="resetTitleRo")
    def reset_title_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleRo", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="abLogicInput")
    def ab_logic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abLogicInput"))

    @builtins.property
    @jsii.member(jsii_name="abTestingInput")
    def ab_testing_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abTestingInput"))

    @builtins.property
    @jsii.member(jsii_name="compressionInput")
    def compression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "compressionInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompressionInput")
    def enable_brotli_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBrotliCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheableInput")
    def enable_for_noncacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableForNoncacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePreconnectInput")
    def enable_preconnect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePushInput")
    def enable_push_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePushInput"))

    @builtins.property
    @jsii.member(jsii_name="enableRoInput")
    def enable_ro_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadEnableInput")
    def preload_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceInput")
    def source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleBrotliInput")
    def title_brotli_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleBrotliInput"))

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPushInput")
    def title_http2_server_push_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleHttp2ServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreconnectInput")
    def title_preconnect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreloadInput")
    def title_preload_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreloadInput"))

    @builtins.property
    @jsii.member(jsii_name="titleRoInput")
    def title_ro_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleRoInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="abLogic")
    def ab_logic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abLogic"))

    @ab_logic.setter
    def ab_logic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e60dcd65bac733d531e43a784998bd2333b38fb0f31cb31acfc5c4a1e43ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abLogic", value)

    @builtins.property
    @jsii.member(jsii_name="abTesting")
    def ab_testing(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abTesting"))

    @ab_testing.setter
    def ab_testing(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb609b5e8f8de101e1854940dd268f50435be27bcceb2288e1af16278c3f2605)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abTesting", value)

    @builtins.property
    @jsii.member(jsii_name="compression")
    def compression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "compression"))

    @compression.setter
    def compression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0094bc3b2f06613e7d0dee8e5f755138be480c595135b7377f6cbe7f6f1bf9ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compression", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f57f9c598a37ea75952358b7b3349069a9bdd5f2f8aad555059eb0b00b05ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompression")
    def enable_brotli_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBrotliCompression"))

    @enable_brotli_compression.setter
    def enable_brotli_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85ab9e9f0dd3c8edc268f6cad1e1819ef5630b01650378d79871cf8d78d53f70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBrotliCompression", value)

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheable")
    def enable_for_noncacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableForNoncacheable"))

    @enable_for_noncacheable.setter
    def enable_for_noncacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffe35ac9de0f9c54649edba9278bd45fae783bf7ca0c589b2b9183070df5b638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableForNoncacheable", value)

    @builtins.property
    @jsii.member(jsii_name="enablePreconnect")
    def enable_preconnect(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePreconnect"))

    @enable_preconnect.setter
    def enable_preconnect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1a9df73e51e233cde46c03124cd6ddee856cbcfb30c9dbe30d663dc4695625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="enablePush")
    def enable_push(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePush"))

    @enable_push.setter
    def enable_push(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa16f748548d30fc7fc0ef4923a84fd19dadc035476f78689abea7bbaa3941b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePush", value)

    @builtins.property
    @jsii.member(jsii_name="enableRo")
    def enable_ro(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRo"))

    @enable_ro.setter
    def enable_ro(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c68137575e35c29c8a21a900d35208e10f6d995c12d8b82231fc55b558618dfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRo", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fda7de0ab64e64fcbcfcf8fbb334dc9a6faeabb76b9863d244a3cea5c8ca3c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preloadEnable")
    def preload_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preloadEnable"))

    @preload_enable.setter
    def preload_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0907dce32b283c1adef66f025f860b28c082789ce46a1b4896c2fe07587aa6c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preloadEnable", value)

    @builtins.property
    @jsii.member(jsii_name="source")
    def source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "source"))

    @source.setter
    def source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b380eb7096c01e3fab7531a24a1948f467e8c458225ec9050a7e43851897b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "source", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__912e8eeb09e0900a749aaa416576e919f406cc31315d28b199ed6828192f8e85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleBrotli")
    def title_brotli(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleBrotli"))

    @title_brotli.setter
    def title_brotli(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13cd113e45f2d3822dddc6f5cd47a8da71e0f4686ddb77917ca2ad1b1bc2affb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleBrotli", value)

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPush")
    def title_http2_server_push(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleHttp2ServerPush"))

    @title_http2_server_push.setter
    def title_http2_server_push(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef540f3a55564d5c9b8a8faf17ee92a323afa00dd8931f154e37abba36cc8aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleHttp2ServerPush", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreconnect")
    def title_preconnect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreconnect"))

    @title_preconnect.setter
    def title_preconnect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c40ec9ca88ab48a3c49d41e0984fe6572040c792a25f61f927af13a33de8f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreload")
    def title_preload(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreload"))

    @title_preload.setter
    def title_preload(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5b9a84794bb547d29fefbded39dab970cd502abd937ddf3bcb4df62217c1946)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreload", value)

    @builtins.property
    @jsii.member(jsii_name="titleRo")
    def title_ro(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleRo"))

    @title_ro.setter
    def title_ro(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a299ae352cd4eabcd6fe0213c09eb8e8bf6392f1f9bc684438270a3448e410a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleRo", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c07007f6fbe293b4e23abc1e4bcebf21c5e6e1d06aa581c33154dbb432f0c0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb158d874281c31d3b02df0755a76f0ec2434b2c4ec3a8a61a48bd08add498d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression",
    jsii_struct_bases=[],
    name_mapping={
        "compress_mobile": "compressMobile",
        "compress_standard": "compressStandard",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier1_mobile_compression_method": "tier1MobileCompressionMethod",
        "tier1_mobile_compression_value": "tier1MobileCompressionValue",
        "tier1_standard_compression_method": "tier1StandardCompressionMethod",
        "tier1_standard_compression_value": "tier1StandardCompressionValue",
        "tier2_mobile_compression_method": "tier2MobileCompressionMethod",
        "tier2_mobile_compression_value": "tier2MobileCompressionValue",
        "tier2_standard_compression_method": "tier2StandardCompressionMethod",
        "tier2_standard_compression_value": "tier2StandardCompressionValue",
        "tier3_mobile_compression_method": "tier3MobileCompressionMethod",
        "tier3_mobile_compression_value": "tier3MobileCompressionValue",
        "tier3_standard_compression_method": "tier3StandardCompressionMethod",
        "tier3_standard_compression_value": "tier3StandardCompressionValue",
        "title_aic_mobile": "titleAicMobile",
        "title_aic_nonmobile": "titleAicNonmobile",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression:
    def __init__(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1ab27123b375134dce62fec2cbbab364b0997c5f645db977a98f6d1f30356bc)
            check_type(argname="argument compress_mobile", value=compress_mobile, expected_type=type_hints["compress_mobile"])
            check_type(argname="argument compress_standard", value=compress_standard, expected_type=type_hints["compress_standard"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_mobile_compression_method", value=tier1_mobile_compression_method, expected_type=type_hints["tier1_mobile_compression_method"])
            check_type(argname="argument tier1_mobile_compression_value", value=tier1_mobile_compression_value, expected_type=type_hints["tier1_mobile_compression_value"])
            check_type(argname="argument tier1_standard_compression_method", value=tier1_standard_compression_method, expected_type=type_hints["tier1_standard_compression_method"])
            check_type(argname="argument tier1_standard_compression_value", value=tier1_standard_compression_value, expected_type=type_hints["tier1_standard_compression_value"])
            check_type(argname="argument tier2_mobile_compression_method", value=tier2_mobile_compression_method, expected_type=type_hints["tier2_mobile_compression_method"])
            check_type(argname="argument tier2_mobile_compression_value", value=tier2_mobile_compression_value, expected_type=type_hints["tier2_mobile_compression_value"])
            check_type(argname="argument tier2_standard_compression_method", value=tier2_standard_compression_method, expected_type=type_hints["tier2_standard_compression_method"])
            check_type(argname="argument tier2_standard_compression_value", value=tier2_standard_compression_value, expected_type=type_hints["tier2_standard_compression_value"])
            check_type(argname="argument tier3_mobile_compression_method", value=tier3_mobile_compression_method, expected_type=type_hints["tier3_mobile_compression_method"])
            check_type(argname="argument tier3_mobile_compression_value", value=tier3_mobile_compression_value, expected_type=type_hints["tier3_mobile_compression_value"])
            check_type(argname="argument tier3_standard_compression_method", value=tier3_standard_compression_method, expected_type=type_hints["tier3_standard_compression_method"])
            check_type(argname="argument tier3_standard_compression_value", value=tier3_standard_compression_value, expected_type=type_hints["tier3_standard_compression_value"])
            check_type(argname="argument title_aic_mobile", value=title_aic_mobile, expected_type=type_hints["title_aic_mobile"])
            check_type(argname="argument title_aic_nonmobile", value=title_aic_nonmobile, expected_type=type_hints["title_aic_nonmobile"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compress_mobile is not None:
            self._values["compress_mobile"] = compress_mobile
        if compress_standard is not None:
            self._values["compress_standard"] = compress_standard
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_mobile_compression_method is not None:
            self._values["tier1_mobile_compression_method"] = tier1_mobile_compression_method
        if tier1_mobile_compression_value is not None:
            self._values["tier1_mobile_compression_value"] = tier1_mobile_compression_value
        if tier1_standard_compression_method is not None:
            self._values["tier1_standard_compression_method"] = tier1_standard_compression_method
        if tier1_standard_compression_value is not None:
            self._values["tier1_standard_compression_value"] = tier1_standard_compression_value
        if tier2_mobile_compression_method is not None:
            self._values["tier2_mobile_compression_method"] = tier2_mobile_compression_method
        if tier2_mobile_compression_value is not None:
            self._values["tier2_mobile_compression_value"] = tier2_mobile_compression_value
        if tier2_standard_compression_method is not None:
            self._values["tier2_standard_compression_method"] = tier2_standard_compression_method
        if tier2_standard_compression_value is not None:
            self._values["tier2_standard_compression_value"] = tier2_standard_compression_value
        if tier3_mobile_compression_method is not None:
            self._values["tier3_mobile_compression_method"] = tier3_mobile_compression_method
        if tier3_mobile_compression_value is not None:
            self._values["tier3_mobile_compression_value"] = tier3_mobile_compression_value
        if tier3_standard_compression_method is not None:
            self._values["tier3_standard_compression_method"] = tier3_standard_compression_method
        if tier3_standard_compression_value is not None:
            self._values["tier3_standard_compression_value"] = tier3_standard_compression_value
        if title_aic_mobile is not None:
            self._values["title_aic_mobile"] = title_aic_mobile
        if title_aic_nonmobile is not None:
            self._values["title_aic_nonmobile"] = title_aic_nonmobile
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compress_mobile(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over cellular mobile networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        '''
        result = self._values.get("compress_mobile")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def compress_standard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over non-cellular networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        '''
        result = self._values.get("compress_standard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        '''
        result = self._values.get("tier1_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        '''
        result = self._values.get("tier1_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier1_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        '''
        result = self._values.get("tier1_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        '''
        result = self._values.get("tier1_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        '''
        result = self._values.get("tier2_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        '''
        result = self._values.get("tier2_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        '''
        result = self._values.get("tier2_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        '''
        result = self._values.get("tier2_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        '''
        result = self._values.get("tier3_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        '''
        result = self._values.get("tier3_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        '''
        result = self._values.get("tier3_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        '''
        result = self._values.get("tier3_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def title_aic_mobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        '''
        result = self._values.get("title_aic_mobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_aic_nonmobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        '''
        result = self._values.get("title_aic_nonmobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18fd0a4bd54a29b7b44b43ac0cad0c899e323381cdef42f403d4212ff1e57d71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompressMobile")
    def reset_compress_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressMobile", []))

    @jsii.member(jsii_name="resetCompressStandard")
    def reset_compress_standard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressStandard", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionMethod")
    def reset_tier1_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionValue")
    def reset_tier1_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionMethod")
    def reset_tier1_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionValue")
    def reset_tier1_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionMethod")
    def reset_tier2_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionValue")
    def reset_tier2_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionMethod")
    def reset_tier2_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionValue")
    def reset_tier2_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionMethod")
    def reset_tier3_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionValue")
    def reset_tier3_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionMethod")
    def reset_tier3_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionValue")
    def reset_tier3_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTitleAicMobile")
    def reset_title_aic_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicMobile", []))

    @jsii.member(jsii_name="resetTitleAicNonmobile")
    def reset_title_aic_nonmobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicNonmobile", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compressMobileInput")
    def compress_mobile_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="compressStandardInput")
    def compress_standard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressStandardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethodInput")
    def tier1_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValueInput")
    def tier1_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethodInput")
    def tier1_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValueInput")
    def tier1_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethodInput")
    def tier2_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValueInput")
    def tier2_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethodInput")
    def tier2_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValueInput")
    def tier2_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethodInput")
    def tier3_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValueInput")
    def tier3_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethodInput")
    def tier3_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValueInput")
    def tier3_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicMobileInput")
    def title_aic_mobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobileInput")
    def title_aic_nonmobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicNonmobileInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compressMobile")
    def compress_mobile(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressMobile"))

    @compress_mobile.setter
    def compress_mobile(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02347451de4dd0b7d60dd4d55d5288a918ce9df049acb96f339465418ff18ee3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressMobile", value)

    @builtins.property
    @jsii.member(jsii_name="compressStandard")
    def compress_standard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressStandard"))

    @compress_standard.setter
    def compress_standard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d41a28039a0967617ebbd6d933b14680df59e795c77d7e6d2ee0c727ae9afd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressStandard", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e53f6bb2e80e318885c043ce5101e6cda0b916bd60cbb82abb6aed5416312544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c60764e8b7c9469f2aacc7874e39d558c51e5133a839764677d1b8e73d02090f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethod")
    def tier1_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1MobileCompressionMethod"))

    @tier1_mobile_compression_method.setter
    def tier1_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1eaa4d2afd88d7ffc65771b76bcae6975f17764f89300086166f26a18c2810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValue")
    def tier1_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1MobileCompressionValue"))

    @tier1_mobile_compression_value.setter
    def tier1_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23620b22815bf1d01923781d0d16a8d63f72a8f83a2d868ac8eb3f404b979f90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethod")
    def tier1_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1StandardCompressionMethod"))

    @tier1_standard_compression_method.setter
    def tier1_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee83f8cd599bde6ca89faa3c6c7283f86460537a420ace7030441fc6408b2eb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValue")
    def tier1_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1StandardCompressionValue"))

    @tier1_standard_compression_value.setter
    def tier1_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed04104a83b3775351b61254d493e1e8d68ec00e544d1ccccea3800244e69fe2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethod")
    def tier2_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2MobileCompressionMethod"))

    @tier2_mobile_compression_method.setter
    def tier2_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d46fbdd4a9dbfc9a4b37309b401aff77e9e5763e300c5346b6d5d64a0062c25f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValue")
    def tier2_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2MobileCompressionValue"))

    @tier2_mobile_compression_value.setter
    def tier2_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e7789b67d44bdb3fc5d5045aecae9cacecdec44be13d64986e586922d644d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethod")
    def tier2_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2StandardCompressionMethod"))

    @tier2_standard_compression_method.setter
    def tier2_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62f7e7d4cfac2f1f1449334b4cacae028e4508c492380359a44748b5c41d374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValue")
    def tier2_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2StandardCompressionValue"))

    @tier2_standard_compression_value.setter
    def tier2_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3058454aee17859a3c763b46553608921ced014e73a894b3e9cf3c441bd45114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethod")
    def tier3_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3MobileCompressionMethod"))

    @tier3_mobile_compression_method.setter
    def tier3_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a49f335d575744450fb2d8f5ab97d8bd2ebed84f0d47743b69253ec79105d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValue")
    def tier3_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3MobileCompressionValue"))

    @tier3_mobile_compression_value.setter
    def tier3_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a40c2a4f67ee36d2044d4d1bf3a42bc59a443df2a21c3bd503e6d2af9bbe73d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethod")
    def tier3_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3StandardCompressionMethod"))

    @tier3_standard_compression_method.setter
    def tier3_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f8aa9e09c248ab6943e63911d442461c066ca60e879669850debd45ef55b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValue")
    def tier3_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3StandardCompressionValue"))

    @tier3_standard_compression_value.setter
    def tier3_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed32729bb5fe24babf156d9d9935bfeee94775908b2c689ee4d88fcbc3cd2365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicMobile")
    def title_aic_mobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicMobile"))

    @title_aic_mobile.setter
    def title_aic_mobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4243e96550b5a86fcb41e11711558f65cf5dbffc8c7786f0e13fc6ed9df1f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicMobile", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobile")
    def title_aic_nonmobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicNonmobile"))

    @title_aic_nonmobile.setter
    def title_aic_nonmobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23aad0bc71039bbdda1ec71123a2534c5fd32d7e1b9b0ef61c8e4047f848693e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicNonmobile", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55efecf2f909249c5527d218f41686cfc011369f4ab644a01d24456782810124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32c1e349ac835b7e8368640df856348064738cc1744975ca811103d9f266a85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04422e6f71f1eefed8611f8a78ada829eac556d256a1e8cc91ebfbd828c172c1)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4301deb2e3703d2d334463775fe7353e16d8f875ac4906d6d6857ad6a27bb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b29b8867448315174b0c8568d281cff23b3939a9b299cb06118813f513c8874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__362e9d67acc2610654460ce429ae3ca8a45ce3d2eea54448b61297c7c6e102e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__796201c0576c896b6fa1a77ffe9f2b98a658c7e9d38ad01b3f948a0edf3e5272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ca9c107e4634f00e77bf991369f050a5ea4b98b2974a52d9d243520f2b7462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52b77e78b072a9aab8a174b3b19cb66736abe949a54ef9493e1c7477e8f5d4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62a2d9e6507e3df061a613a013682d57f7a4b497b9b59abc4a702fba86ba9b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting",
    jsii_struct_bases=[],
    name_mapping={
        "attribute1": "attribute1",
        "attribute2": "attribute2",
        "attribute3": "attribute3",
        "attribute4": "attribute4",
        "attributes_count": "attributesCount",
        "enabled": "enabled",
        "locked": "locked",
        "report_name": "reportName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting:
    def __init__(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99cf3bc28b9c6673050800452339e2417b3f7dea204a1261b4d5ddbb2347efea)
            check_type(argname="argument attribute1", value=attribute1, expected_type=type_hints["attribute1"])
            check_type(argname="argument attribute2", value=attribute2, expected_type=type_hints["attribute2"])
            check_type(argname="argument attribute3", value=attribute3, expected_type=type_hints["attribute3"])
            check_type(argname="argument attribute4", value=attribute4, expected_type=type_hints["attribute4"])
            check_type(argname="argument attributes_count", value=attributes_count, expected_type=type_hints["attributes_count"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument report_name", value=report_name, expected_type=type_hints["report_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if attribute1 is not None:
            self._values["attribute1"] = attribute1
        if attribute2 is not None:
            self._values["attribute2"] = attribute2
        if attribute3 is not None:
            self._values["attribute3"] = attribute3
        if attribute4 is not None:
            self._values["attribute4"] = attribute4
        if attributes_count is not None:
            self._values["attributes_count"] = attributes_count
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if report_name is not None:
            self._values["report_name"] = report_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def attribute1(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        '''
        result = self._values.get("attribute1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute2(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        '''
        result = self._values.get("attribute2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute3(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        '''
        result = self._values.get("attribute3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute4(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        '''
        result = self._values.get("attribute4")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attributes_count(self) -> typing.Optional[jsii.Number]:
        '''The number of attributes to include in the report, ranging from 1 to 4.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        '''
        result = self._values.get("attributes_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables aggregated reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def report_name(self) -> typing.Optional[builtins.str]:
        '''The unique name of the aggregated report within the property.

        If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        '''
        result = self._values.get("report_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9d4e7c9dd4b1b130cfd132a7f1f7b129c4ac35f5fbcf1611d7df00b6c580b07)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAttribute1")
    def reset_attribute1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute1", []))

    @jsii.member(jsii_name="resetAttribute2")
    def reset_attribute2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute2", []))

    @jsii.member(jsii_name="resetAttribute3")
    def reset_attribute3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute3", []))

    @jsii.member(jsii_name="resetAttribute4")
    def reset_attribute4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute4", []))

    @jsii.member(jsii_name="resetAttributesCount")
    def reset_attributes_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttributesCount", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReportName")
    def reset_report_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReportName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="attribute1Input")
    def attribute1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute1Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute2Input")
    def attribute2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute2Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute3Input")
    def attribute3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute3Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute4Input")
    def attribute4_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute4Input"))

    @builtins.property
    @jsii.member(jsii_name="attributesCountInput")
    def attributes_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "attributesCountInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reportNameInput")
    def report_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reportNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="attribute1")
    def attribute1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute1"))

    @attribute1.setter
    def attribute1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30f35e121b78a4b68f50bda101514056fc3c948624feb67bb1ea65dbc344199c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute1", value)

    @builtins.property
    @jsii.member(jsii_name="attribute2")
    def attribute2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute2"))

    @attribute2.setter
    def attribute2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0735db994535304f7d498b07d899677bd4e9d0e46baf8f26af88d8106deded09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute2", value)

    @builtins.property
    @jsii.member(jsii_name="attribute3")
    def attribute3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute3"))

    @attribute3.setter
    def attribute3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fd407ba0f1467754e9c6f27e34d04ac523fffa68190445dc049610d3c0c9393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute3", value)

    @builtins.property
    @jsii.member(jsii_name="attribute4")
    def attribute4(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute4"))

    @attribute4.setter
    def attribute4(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac9b5e904c3ca70ea98c771985a37c413da3e83a6360a7a9cacb89008c9bf5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute4", value)

    @builtins.property
    @jsii.member(jsii_name="attributesCount")
    def attributes_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "attributesCount"))

    @attributes_count.setter
    def attributes_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb61eecf2a6b88a71852f12a406fd9fc4fbd2ea418c209be813e46f26a7b321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attributesCount", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9eecbd8b43798cd5631c630567bd84dfdc69a2b28d6708c08ef759f0d07bad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca0838c3d94e454f8a942c4075a2a4afbea9d1be3844896df78d9698242ab719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reportName")
    def report_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reportName"))

    @report_name.setter
    def report_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3146595f7ca839bf6485fb2adae7726363ba89c2e095109df6b895ba14c31796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reportName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079b1f746338f4d2c20e32c471ee54a9bd99a29a629c8c9527f04ab57cbdc629)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa717fcbf1b88eb3dfc84180975b684abd01156d79ef6bca637ec8b79a62eed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef807e826d2a389b6a2ef35941eb6a43a3b16e73bd16200c7f06e5cf206e283)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7dfee5ae5392cefeaa95afa3ba4b1e883aa1419a882390751770435dd2946dc)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamaizer behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f98f458c109cdd50c665596bf2d4f2fa7c55401551fed8f539edf7a2e2878f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fe74121df81d7c7adfb706245b8f025b6739b6c1ff89306d71fed668b8ed866)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__142cca7226a5a1cd7f5582782db8216ebcb78ea7432ab3e0c1bf50451ca116b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884b0774899b12c9d5a3456edd662bdc309ac347cc36bb9b034d76542bf44d87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25539e441800c936da7d842e0dc2cfdae962a1af589491ab2c469b9a15471ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1716b5dc2ea478d2a553f563f43a4227b7fa801f7a98b6ab873b026acd798ebd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag",
    jsii_struct_bases=[],
    name_mapping={
        "include_tags_attribute": "includeTagsAttribute",
        "locked": "locked",
        "match_hostname": "matchHostname",
        "replace_all": "replaceAll",
        "replacement_hostname": "replacementHostname",
        "scope": "scope",
        "tags_attribute": "tagsAttribute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag:
    def __init__(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ce3cbbe48508930f178711b9f8a67008fca5a659440dee84cd5e81f1725863)
            check_type(argname="argument include_tags_attribute", value=include_tags_attribute, expected_type=type_hints["include_tags_attribute"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_hostname", value=match_hostname, expected_type=type_hints["match_hostname"])
            check_type(argname="argument replace_all", value=replace_all, expected_type=type_hints["replace_all"])
            check_type(argname="argument replacement_hostname", value=replacement_hostname, expected_type=type_hints["replacement_hostname"])
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument tags_attribute", value=tags_attribute, expected_type=type_hints["tags_attribute"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if include_tags_attribute is not None:
            self._values["include_tags_attribute"] = include_tags_attribute
        if locked is not None:
            self._values["locked"] = locked
        if match_hostname is not None:
            self._values["match_hostname"] = match_hostname
        if replace_all is not None:
            self._values["replace_all"] = replace_all
        if replacement_hostname is not None:
            self._values["replacement_hostname"] = replacement_hostname
        if scope is not None:
            self._values["scope"] = scope
        if tags_attribute is not None:
            self._values["tags_attribute"] = tags_attribute
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def include_tags_attribute(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the ``tagsAttribute`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        '''
        result = self._values.get("include_tags_attribute")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to match on as a Perl-compatible regular expression.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        '''
        result = self._values.get("match_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replace_all(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches when enabled, otherwise replaces only the first match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        '''
        result = self._values.get("replace_all")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def replacement_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement hostname for the tag to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        '''
        result = self._values.get("replacement_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scope(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of HTML content the ``tagsAttribute`` refers to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        '''
        result = self._values.get("scope")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tags_attribute(self) -> typing.Optional[builtins.str]:
        '''Specifies the tag or tag/attribute combination to operate on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        '''
        result = self._values.get("tags_attribute")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bc320c35a725c5ac0d448817a31e96e15eae05a92b1b3d6f4dee6e4ebc11e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetIncludeTagsAttribute")
    def reset_include_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeTagsAttribute", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchHostname")
    def reset_match_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchHostname", []))

    @jsii.member(jsii_name="resetReplaceAll")
    def reset_replace_all(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplaceAll", []))

    @jsii.member(jsii_name="resetReplacementHostname")
    def reset_replacement_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacementHostname", []))

    @jsii.member(jsii_name="resetScope")
    def reset_scope(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScope", []))

    @jsii.member(jsii_name="resetTagsAttribute")
    def reset_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTagsAttribute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttributeInput")
    def include_tags_attribute_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeTagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchHostnameInput")
    def match_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="replaceAllInput")
    def replace_all_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "replaceAllInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementHostnameInput")
    def replacement_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="scopeInput")
    def scope_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scopeInput"))

    @builtins.property
    @jsii.member(jsii_name="tagsAttributeInput")
    def tags_attribute_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttribute")
    def include_tags_attribute(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeTagsAttribute"))

    @include_tags_attribute.setter
    def include_tags_attribute(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77b45f0a5371233e5ab21b4f3237efd879017cb3f3a5aeb6635545c142582a6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeTagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d66e593b7af3eccbd35fea30d409d29199fdce581002fc66a04e9bfad7da752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchHostname")
    def match_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchHostname"))

    @match_hostname.setter
    def match_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__678aa88deb661a8dd2a358098d1d913974310bce10b364f8b114ca6fef046d1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchHostname", value)

    @builtins.property
    @jsii.member(jsii_name="replaceAll")
    def replace_all(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "replaceAll"))

    @replace_all.setter
    def replace_all(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f47b40172767368e3fc4fd840a97528eaaeb4efb2d4ca00544954ae59b9e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replaceAll", value)

    @builtins.property
    @jsii.member(jsii_name="replacementHostname")
    def replacement_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacementHostname"))

    @replacement_hostname.setter
    def replacement_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b7a8b85922fab6c815ffd32eb399456505446533339ab025690b58f1713996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacementHostname", value)

    @builtins.property
    @jsii.member(jsii_name="scope")
    def scope(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scope"))

    @scope.setter
    def scope(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2e5e0da3aa66b3ef3ff6b5126ba4b7b75c695658ed58ed6fa785c24fac9ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scope", value)

    @builtins.property
    @jsii.member(jsii_name="tagsAttribute")
    def tags_attribute(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tagsAttribute"))

    @tags_attribute.setter
    def tags_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1f5e61ae086f1b8a66f0452ea2fd01cc4d75960b1c91818e9fa9f55853cb7cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceeb334937cd6f57601fe960e9531f2d1a107c3c33aeda27f6831d8bca9ff62b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__752b31c5f00f324bce017134f41b86dc7e59d06b97148a8b1a67f7df67116251)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1186cd7a7341ac66efda90a9c5956a021c132b4e7f35ecb0d628fd19d10c87d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab28b9466b4de1a1c5dadf0d9a57275966f2c29d3fc4ed5318c8f7cecc3a8adb)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables all HTTP requests for parent servers in the cache hierarchy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b555b9c07bc9de947e5e6ba7feb3d0db0ce65f7b16e47092948037554e5f70ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc2c7b27d66594f221929f9a3e713c3d46d09a9aa0850241debee0d2388d572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b38a24c6817788517b4345a351ebc5d9c62dd4557ccad7848a77fb7c803a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b25f844f868fb8e93a598478875775023166e23247b0b007432fae3ef786c0f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8dc02fcd91a7fef97624c560868adda92f333d893f3c25c07d8ca2cdfc60e03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84384819c6ca5f1c126825b44746a12f8d6aa5e9969077bdcc2bff14f3eb709a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "honor_base_directory": "honorBaseDirectory",
        "locked": "locked",
        "purge_origin_query_parameter": "purgeOriginQueryParameter",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d086f45e6377a96a8f33ecc199ac14efdbb4105f0c30bd1248819b35da914215)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument honor_base_directory", value=honor_base_directory, expected_type=type_hints["honor_base_directory"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_origin_query_parameter", value=purge_origin_query_parameter, expected_type=type_hints["purge_origin_query_parameter"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if honor_base_directory is not None:
            self._values["honor_base_directory"] = honor_base_directory
        if locked is not None:
            self._values["locked"] = locked
        if purge_origin_query_parameter is not None:
            self._values["purge_origin_query_parameter"] = purge_origin_query_parameter
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_base_directory(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior.

        If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        '''
        result = self._values.get("honor_base_directory")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_origin_query_parameter(self) -> typing.Optional[builtins.str]:
        '''When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge.

        Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        '''
        result = self._values.get("purge_origin_query_parameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOriginsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOriginsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1d03bf5afa8511f31ec5b2ca9743224a26afc53999d92ae57b44e74c7ccb913)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHonorBaseDirectory")
    def reset_honor_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorBaseDirectory", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeOriginQueryParameter")
    def reset_purge_origin_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeOriginQueryParameter", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectoryInput")
    def honor_base_directory_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorBaseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameterInput")
    def purge_origin_query_parameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeOriginQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4859845f4e240aeb85f5b64a1ed8014d494b89266876191d25c15fd8824a83b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectory")
    def honor_base_directory(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorBaseDirectory"))

    @honor_base_directory.setter
    def honor_base_directory(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__207eb18e325a89824a2a4bce63c79a8a409bb0b6443d5c3a5a91fdf371b46227)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorBaseDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07bb0a64138f9306eb91f0c300b2ee4d6f791c4d19b9bd375fc37c6fa450171b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameter")
    def purge_origin_query_parameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeOriginQueryParameter"))

    @purge_origin_query_parameter.setter
    def purge_origin_query_parameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6813be728bb42c254b5fab2c0cf3bc0872ada7b5fc2d48e7d54585f14c9b0f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeOriginQueryParameter", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e40d0f74b78397f3d18a1082608ee354385409969bdf5919207748a5b40f95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903896768a2311b4c1c256b403d61435df2f0cfb494bee2e0fa68c8395c1abe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0810646fc37f3842a4e7a303a58f11e55c6f3f8d635eefebb0933f0e53bd5e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete",
    jsii_struct_bases=[],
    name_mapping={
        "allow_body": "allowBody",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete:
    def __init__(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1d5b58cf589b72d0e3870dff2aeee9dd92c903858ad4a8a3724c348fa6338d)
            check_type(argname="argument allow_body", value=allow_body, expected_type=type_hints["allow_body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_body is not None:
            self._values["allow_body"] = allow_body
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_body(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows data in the body of the DELETE request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        '''
        result = self._values.get("allow_body")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows DELETE requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDeleteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDeleteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d1c8819dc4f1e4ada98b2624086a8ed673d0e419ad179501634bb136820f10a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBody")
    def reset_allow_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBodyInput")
    def allow_body_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBody")
    def allow_body(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowBody"))

    @allow_body.setter
    def allow_body(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__842b66352efe3d152e8e263e9bf2f5656faa1397d134bab2bd77d2ca30cf6ab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBody", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc8eaacc933af216b3e9ff2c74d8b1e5134b5939e01ce1f94754a56381c28ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f3f5b186533dd13be79ae935060e093f396bf860b6cdf4e96105b564d394ca4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d286acdf7a9507712e61e3737cdf21ff1ac969a1cc41d7a34ebc27262d9b5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208a61bf7b255aa6c4259c6f76f1f56303e399e963b9cec287934301f977c75c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e12b5f13080796960360eee32fbc4760caae4bfa4c0ccfd6af66d54c44492f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe984fef3a9e6734e1d3c28f95f6e3dfa07489203c1f823454926ef09908e282)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HTTPS cache key sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8f2d17cca8efafb13459aba88dcf95a31b5eaa5b063e049c83e58beb3a83c0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590979185fa0e0c2cae3c1884d42b3241b78fad9d001a3a0faeb2aa4af6b0579)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a0d212b91f622601559c007faeffd9aa5ebe9e352a2ece381aa2b3a930d2ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f237249f170a806aff750873d5fb89b4ac54badc8862b4b7b7ece78cbdc5d662)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__654bec9d28acd72cdecbc396690f8f7e43f2baf03aad96ab8830e614b57dc75e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b0ff326817b5560a8424a3474f85c4607966e09957d946c17488a3cf71db979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7d10b555eb4d5662e166a1e500c71037ab4ec7d1369da1d171bc4baf9622965)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Downgrades to HTTP protocol for the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9738dc507c418a143b6bf65ac03c3eb94545e4d51e0444804c3353de3774572)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6cd06b8dc08b6496242a1e2df98ab92c2a3a03b07c3d349e74e8c2e3d4140f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b263e8ec27ba9e71cedf9c3e00efc457d08504bc8185cebea9e5d7664a09ccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__049bd9dbae8852d1bae11f54e3d82cd38247433be1c86368021730a8af9b40b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a16ed4358383561772d45e13904bdaba817d144157ae2889dfaaa83e1aa254c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a11624c2b33fd3748b9d204294032d007e8c13dc82383f21d6ff91dd841e010)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a51135023333dd363b4d07504c73c6b4ae07e6ce5496d2f140c62c6f76518f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response.

        Set this to ``false`` to deny OPTIONS requests and respond with a 501 error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5101e571d04600870b1521095c545a0dd74d3cd5e2c0875b401dd81cf0d50f57)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db93b8664fc0d67f3d85a20fe58a7b474982eaeff265995dcdf5b2bc2a2f3093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85057fd098501b8daacc7d2032bc36299301885dfe0079f16e8e174c9fde72ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1075babd217e78cecd63f7c8adf24a2580ff79d2bf671f89ad22c800f3b8c491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c1ffbffc0a13b6467a69c746e1499be3584cc8a96332a719a7b5dedd5b7b485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8aafd711e5198a2e454620004c3a9822598653723ea935cea0f274370f35f62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9d6f58ca72c05c0e9e25f3cbaaf7f8f5ccdc1be542300e09d66e76672c8c20)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PATCH requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f18e03d95f268a220af5779173c4cd4be9b775f826fa44d26abbdc455a553b93)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe7738c8d5e995e4e83ef383b74a7cb7ad06b73ac17197c12c2994be2ed8af7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4daae92d669b9119336bc3b521840d95ad9daf66697c43354481900d875aa4ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baceced04f5f10288e3cb8e5e2045936274d74b09d04ad21fb153c92e017cfda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3364b1e9f7718f7399150e87944e4539a0042d4a65ac64ffb4fb354c7cc58cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4d8002e7817c5e18a10d76f33043f86ee23531745a22560270f36786644384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost",
    jsii_struct_bases=[],
    name_mapping={
        "allow_without_content_length": "allowWithoutContentLength",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost:
    def __init__(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6a765cbc56e9ffa7ba968e5966e8bb646d584abdc7cfdbb63b0ed7bf92497ad)
            check_type(argname="argument allow_without_content_length", value=allow_without_content_length, expected_type=type_hints["allow_without_content_length"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_without_content_length is not None:
            self._values["allow_without_content_length"] = allow_without_content_length
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_without_content_length(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error.

        With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        '''
        result = self._values.get("allow_without_content_length")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a14bd8d348b4903bc4077bd079c40ff0d634d55dbe5c48e10c6e84dd229136f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowWithoutContentLength")
    def reset_allow_without_content_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowWithoutContentLength", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLengthInput")
    def allow_without_content_length_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowWithoutContentLengthInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLength")
    def allow_without_content_length(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowWithoutContentLength"))

    @allow_without_content_length.setter
    def allow_without_content_length(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf2adff7ab6f33d319787e7b1e69c079cd3a1e78ea2225c0d7addf6a470d7d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowWithoutContentLength", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82fd476482b9751c843d61a6895bdf4312930192deabe85406c297ea64abc59d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446e577bb5de05b0418168808faff789bb8f7e35c126e043cada4a6e347a0322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__889624f71d21b9151ad086a8bea0b7ad81b545c28a5594eccca2dbaec4689525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c3f7d6d1cca5ab48347c1d3707fd80b26d3f6654944d3bee29c5c46f07db63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec1e3e8965a4251cfc5d3a202243a0d39052025af91b2fb215c517d8bb59388f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19b4582e4d0f22a87be9769bc8c4b8bf63979cc224233b04c426dbe694a073f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PUT requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee286d79e9f2e4e0eab6db3c5518075e79e1547111375b12b0cb6318a97c5639)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b4b3aebb38b31f59755429013d8c40da2183ad8b59723ee8383e5d2cd667e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9a622ab905e323330634f9fc418a66798932477a441c2279314ca5ec1c08f7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a6327556b1683bb746e2a4e059a97f873c38fe9d6b173c180e4f570ec23f9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c75be5c8a7c4403d8c93bc2605d2454b6ac80de6edc8fef1dd3e5967dd079a84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b188b20c57f24104919e7a03f284e1aedd4e292a9a5ec199e173bed56ef523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbdfba31d87aa06fc5a3a8cec07e4e26a388f980b4d92412012a44a972635fdb)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Chunked Transfer Encoding requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncodingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncodingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652146d7d3bffb497800d5f9a4f42bdb9685838734a96a1c67802955c0d3bbbf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dabf623d2f45c677e78c2a89f1169de8fd6ba87ca2251da2df4a906030ee936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5b1ca1b9d77a1ad591697c9b5a5b3450e19c3749d790c2d9e15d7170211a32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4d3b0257e972f6b6014b3f5b644bf33084a0ff0e0f24bfa76d993d066f8a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224bd6c3b328843911f7291e95c3fdba599953cd37fa16e3cedad09fec797ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01dc73b4d7e6741a5fd1003680d05d290a9fc6dc55900aabc57012e2cd0bb0d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "max_age": "maxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ada1ea4f62631663ad73f309c6bf2ce9b6fc3271b8a78771f1ca4555e25090ee)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[jsii.Number]:
        '''Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header.

        The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c078dd94a6e3b80e7b4d7386933a87a50fd21c61329c0033615507062faa01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca1445cd11743d2a7901fb27800bc3113f00f9e77358a0a199553a4716344b1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f11330ccd73d068b2aa5be832bbfde42dd8e8d473e9ae926a1883bb4f68fc7b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a74c9d9c8ac3cd651904d8ce2475c353471d8413dd23761c959d57db1061c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d20f535ac45179cfccb98fabd2e09a87b70236cf543425c86025a0cd1bb86da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82267d273a765e28e9c5abaa8f57c5e1e15ed254f964e063d849c41234080c26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "alternate_response_cache_ttl": "alternateResponseCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "net_storage": "netStorage",
        "net_storage_path": "netStoragePath",
        "template_uuid": "templateUuid",
        "throttled_cp_code": "throttledCpCode",
        "throttled_status_code": "throttledStatusCode",
        "use_throttled_cp_code": "useThrottledCpCode",
        "use_throttled_status_code": "useThrottledStatusCode",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization:
    def __init__(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage(**net_storage)
        if isinstance(throttled_cp_code, dict):
            throttled_cp_code = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode(**throttled_cp_code)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4578d1c0b22daf46c49ff9cef630b05b7d72632737cd980cf9591db7de9851)
            check_type(argname="argument alternate_response_cache_ttl", value=alternate_response_cache_ttl, expected_type=type_hints["alternate_response_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throttled_cp_code", value=throttled_cp_code, expected_type=type_hints["throttled_cp_code"])
            check_type(argname="argument throttled_status_code", value=throttled_status_code, expected_type=type_hints["throttled_status_code"])
            check_type(argname="argument use_throttled_cp_code", value=use_throttled_cp_code, expected_type=type_hints["use_throttled_cp_code"])
            check_type(argname="argument use_throttled_status_code", value=use_throttled_status_code, expected_type=type_hints["use_throttled_status_code"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if alternate_response_cache_ttl is not None:
            self._values["alternate_response_cache_ttl"] = alternate_response_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throttled_cp_code is not None:
            self._values["throttled_cp_code"] = throttled_cp_code
        if throttled_status_code is not None:
            self._values["throttled_status_code"] = throttled_status_code
        if use_throttled_cp_code is not None:
            self._values["use_throttled_cp_code"] = use_throttled_cp_code
        if use_throttled_status_code is not None:
            self._values["use_throttled_status_code"] = use_throttled_status_code
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def alternate_response_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the alternate response's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        '''
        result = self._values.get("alternate_response_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the API Prioritization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this API Prioritization policy from any others in the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''Specify the full NetStorage path for the alternate response, including trailing file name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throttled_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode"]:
        '''throttled_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        '''
        result = self._values.get("throttled_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode"], result)

    @builtins.property
    def throttled_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code for requests that receive the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        '''
        result = self._values.get("throttled_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def use_throttled_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to apply an alternative CP code for requests served the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        '''
        result = self._values.get("use_throttled_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def use_throttled_status_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a specific HTTP response code to a throttled request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        '''
        result = self._values.get("use_throttled_status_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3adc872aa9acf1e60fa41d4b136b837e22913cc86316773881e1f0ffcaa46b97)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28903236c5b0a6a697cea4611330a1d7c4b23f4d69b6487a7d680087eefa8d62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bee7778e29686388ef3446affdc92a7c8a373da91d2715635712c5c0ab2373c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afaf5d27640646255b68d307044f4b1ea6c304d9fe3c117315404134eb292f41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74fca4b29c06a0e3cacca35cab0d7ca1feebb9677b3dc23f01befaa34d1b5e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98339dda1ff2b7c5ba94b6ed7dedb0d2246c275e6932dea97a68f1a9e47b308e)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac86ca052ac6c702b7ac3bf825c5494048ca9406a5c19675433b7163cfb7383)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a49c23d69713aa52e9cca54fa4616b5bacd9fc829625ef9db327854d604560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b7d46da0f74f3ce644aac70844527d05a9602b4dd13932f875475e15f50a3f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a3b2b45a584fe0b7161651116a71ccae2f8ca59abc155c1fe43a3b9561557c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4c93ed79595316edc117241c0316a8cc3dac75d485d865afb9b92dcf97ddd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f7fd1376983ea7a27050b2c557c08f401e6ba3862ff28338b8860f719f2d62)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="putThrottledCpCode")
    def put_throttled_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putThrottledCpCode", [value]))

    @jsii.member(jsii_name="resetAlternateResponseCacheTtl")
    def reset_alternate_response_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlternateResponseCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThrottledCpCode")
    def reset_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledCpCode", []))

    @jsii.member(jsii_name="resetThrottledStatusCode")
    def reset_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUseThrottledCpCode")
    def reset_use_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledCpCode", []))

    @jsii.member(jsii_name="resetUseThrottledStatusCode")
    def reset_use_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCode")
    def throttled_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeOutputReference", jsii.get(self, "throttledCpCode"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtlInput")
    def alternate_response_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "alternateResponseCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCodeInput")
    def throttled_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode"], jsii.get(self, "throttledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCodeInput")
    def throttled_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "throttledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCodeInput")
    def use_throttled_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCodeInput")
    def use_throttled_status_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtl")
    def alternate_response_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "alternateResponseCacheTtl"))

    @alternate_response_cache_ttl.setter
    def alternate_response_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85aca0388fa4ecdebc1fd11e0b1901055452def717d80d4cd9dd352292a2cab3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "alternateResponseCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc48117209554c6f8e50a915f28bae7a3e22d8f84e8df3a8d06415a4e70d8c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08210ff0e15722a062ee4a16d1efd4bc497ab1bdfb7625b93f4da2084f58b29c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098d0269a1e41f7d919ffc62a7f91b4ce08965f1d1005f65ea9738ac079408a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e555045b73be2fbfa1ca4fbf2c44b604ddfe19887c474073f553c8fa5922f00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f7a4da600ef636026c123f2ad4002d84bf905345d5b49618c1860a3f9ffb349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee789903b6b56e81a1f5a1d85db11f46b62b8c3336367ad9eaea792c1651769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e380fea5a1bd0d62e83d52113087219e63f346615c47a1a28b959f0cd3f5e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCode")
    def throttled_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "throttledStatusCode"))

    @throttled_status_code.setter
    def throttled_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c078a177e887f3a400be4fbfb2ee33bf72d45b95157f8df1f701d90e428ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throttledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCode")
    def use_throttled_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledCpCode"))

    @use_throttled_cp_code.setter
    def use_throttled_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf61f14f0cdea34e41312276c5be0686d7c80f1e47a8deb7f07eda34ce2a632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCode")
    def use_throttled_status_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledStatusCode"))

    @use_throttled_status_code.setter
    def use_throttled_status_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d91d40f39b587e10be2ccfd8c50c81627e876f17c14191b650fb3f01907c0863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be78a2f9324d2ce1315d34dc0b8dc369bbfac36a16803919069da62a4a37207e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03293df6d554579035cbe897d2f0af050057fa444d6dc75b7ffc00b21584d34e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf985e8cebeef021c2278f57e26459baca3d0fccb7479c350220529c5bc41fff)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365c0f3a587afe2f0f09c907d2e5a04a0b88527d172b71aee66d6e9501517258)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__154a42bc21e121911a510162168a31a27f1a7a46d00d9e839502b50ed70377cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71de2418d462527222e01d728a3dca054678391777e5d1f2574cbcdafbf90ea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21a6da21ae485c734aa485d8122fdfae971168c9d93997756768a47f8b61bad2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__682160ab6f5fcd4a4e7e9fed86ee9457c7abab7bb29d2868790e39509d612a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b9ee71e3a805571777ff71906efe04d8941cc0cd7baae21f7022b28d1df1ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__452589a3c8eaea7fda2493a106bc8087af573d7458456942a494b69cf272a78c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658c3f572e1f27283d1329f7357663ffeceb968af911b771202bfb4ae68bb305)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__027c4a527b44c15547e2e791d45c95ad9e8359600b4c512ba0490ba577d1f046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc37e09265c51eb8caa4dac74d3afdad2aede3d5786b8506e8d0fee592d0181a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f4bcc87abe4b81b99cf128f44e56c5cb083f415dcf470b8c079c120214ea937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ba7f92449431b6e9544240478a8a9d94eb87e2a7e6ab5c2df617edcc12feda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4de8d0df7fc07aebee6b87ab41bf7472895f3045be02714a873859aca38b637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer",
    jsii_struct_bases=[],
    name_mapping={
        "all_down_net_storage": "allDownNetStorage",
        "all_down_net_storage_file": "allDownNetStorageFile",
        "all_down_status_code": "allDownStatusCode",
        "all_down_title": "allDownTitle",
        "allow_cache_prefresh": "allowCachePrefresh",
        "cached_content_title": "cachedContentTitle",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "failover_attempts_threshold": "failoverAttemptsThreshold",
        "failover_mode": "failoverMode",
        "failover_origin_map": "failoverOriginMap",
        "failover_status_codes": "failoverStatusCodes",
        "failover_title": "failoverTitle",
        "label": "label",
        "locked": "locked",
        "origin_cookie_name": "originCookieName",
        "specify_stickiness_cookie_domain": "specifyStickinessCookieDomain",
        "stickiness_cookie_automatic_salt": "stickinessCookieAutomaticSalt",
        "stickiness_cookie_domain": "stickinessCookieDomain",
        "stickiness_cookie_salt": "stickinessCookieSalt",
        "stickiness_cookie_set_http_only_flag": "stickinessCookieSetHttpOnlyFlag",
        "stickiness_cookie_type": "stickinessCookieType",
        "stickiness_duration": "stickinessDuration",
        "stickiness_expiration_date": "stickinessExpirationDate",
        "stickiness_refresh": "stickinessRefresh",
        "stickiness_title": "stickinessTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer:
    def __init__(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(all_down_net_storage, dict):
            all_down_net_storage = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage(**all_down_net_storage)
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a9447695a7a2ea6357c197749f16fc8b7b33f50134775f04bea4f6388c02db)
            check_type(argname="argument all_down_net_storage", value=all_down_net_storage, expected_type=type_hints["all_down_net_storage"])
            check_type(argname="argument all_down_net_storage_file", value=all_down_net_storage_file, expected_type=type_hints["all_down_net_storage_file"])
            check_type(argname="argument all_down_status_code", value=all_down_status_code, expected_type=type_hints["all_down_status_code"])
            check_type(argname="argument all_down_title", value=all_down_title, expected_type=type_hints["all_down_title"])
            check_type(argname="argument allow_cache_prefresh", value=allow_cache_prefresh, expected_type=type_hints["allow_cache_prefresh"])
            check_type(argname="argument cached_content_title", value=cached_content_title, expected_type=type_hints["cached_content_title"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_attempts_threshold", value=failover_attempts_threshold, expected_type=type_hints["failover_attempts_threshold"])
            check_type(argname="argument failover_mode", value=failover_mode, expected_type=type_hints["failover_mode"])
            check_type(argname="argument failover_origin_map", value=failover_origin_map, expected_type=type_hints["failover_origin_map"])
            check_type(argname="argument failover_status_codes", value=failover_status_codes, expected_type=type_hints["failover_status_codes"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_cookie_name", value=origin_cookie_name, expected_type=type_hints["origin_cookie_name"])
            check_type(argname="argument specify_stickiness_cookie_domain", value=specify_stickiness_cookie_domain, expected_type=type_hints["specify_stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_automatic_salt", value=stickiness_cookie_automatic_salt, expected_type=type_hints["stickiness_cookie_automatic_salt"])
            check_type(argname="argument stickiness_cookie_domain", value=stickiness_cookie_domain, expected_type=type_hints["stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_salt", value=stickiness_cookie_salt, expected_type=type_hints["stickiness_cookie_salt"])
            check_type(argname="argument stickiness_cookie_set_http_only_flag", value=stickiness_cookie_set_http_only_flag, expected_type=type_hints["stickiness_cookie_set_http_only_flag"])
            check_type(argname="argument stickiness_cookie_type", value=stickiness_cookie_type, expected_type=type_hints["stickiness_cookie_type"])
            check_type(argname="argument stickiness_duration", value=stickiness_duration, expected_type=type_hints["stickiness_duration"])
            check_type(argname="argument stickiness_expiration_date", value=stickiness_expiration_date, expected_type=type_hints["stickiness_expiration_date"])
            check_type(argname="argument stickiness_refresh", value=stickiness_refresh, expected_type=type_hints["stickiness_refresh"])
            check_type(argname="argument stickiness_title", value=stickiness_title, expected_type=type_hints["stickiness_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if all_down_net_storage is not None:
            self._values["all_down_net_storage"] = all_down_net_storage
        if all_down_net_storage_file is not None:
            self._values["all_down_net_storage_file"] = all_down_net_storage_file
        if all_down_status_code is not None:
            self._values["all_down_status_code"] = all_down_status_code
        if all_down_title is not None:
            self._values["all_down_title"] = all_down_title
        if allow_cache_prefresh is not None:
            self._values["allow_cache_prefresh"] = allow_cache_prefresh
        if cached_content_title is not None:
            self._values["cached_content_title"] = cached_content_title
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_attempts_threshold is not None:
            self._values["failover_attempts_threshold"] = failover_attempts_threshold
        if failover_mode is not None:
            self._values["failover_mode"] = failover_mode
        if failover_origin_map is not None:
            self._values["failover_origin_map"] = failover_origin_map
        if failover_status_codes is not None:
            self._values["failover_status_codes"] = failover_status_codes
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if origin_cookie_name is not None:
            self._values["origin_cookie_name"] = origin_cookie_name
        if specify_stickiness_cookie_domain is not None:
            self._values["specify_stickiness_cookie_domain"] = specify_stickiness_cookie_domain
        if stickiness_cookie_automatic_salt is not None:
            self._values["stickiness_cookie_automatic_salt"] = stickiness_cookie_automatic_salt
        if stickiness_cookie_domain is not None:
            self._values["stickiness_cookie_domain"] = stickiness_cookie_domain
        if stickiness_cookie_salt is not None:
            self._values["stickiness_cookie_salt"] = stickiness_cookie_salt
        if stickiness_cookie_set_http_only_flag is not None:
            self._values["stickiness_cookie_set_http_only_flag"] = stickiness_cookie_set_http_only_flag
        if stickiness_cookie_type is not None:
            self._values["stickiness_cookie_type"] = stickiness_cookie_type
        if stickiness_duration is not None:
            self._values["stickiness_duration"] = stickiness_duration
        if stickiness_expiration_date is not None:
            self._values["stickiness_expiration_date"] = stickiness_expiration_date
        if stickiness_refresh is not None:
            self._values["stickiness_refresh"] = stickiness_refresh
        if stickiness_title is not None:
            self._values["stickiness_title"] = stickiness_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def all_down_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage"]:
        '''all_down_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        '''
        result = self._values.get("all_down_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage"], result)

    @builtins.property
    def all_down_net_storage_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        '''
        result = self._values.get("all_down_net_storage_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP response code when all load-balancing origins are unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        '''
        result = self._values.get("all_down_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        '''
        result = self._values.get("all_down_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_cache_prefresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows the cache to prefresh.  Only appropriate if all origins serve the same content for the same URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        '''
        result = self._values.get("allow_cache_prefresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cached_content_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        '''
        result = self._values.get("cached_content_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the Application Load Balancer Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_attempts_threshold(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of failed requests that would trigger the failover process.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        '''
        result = self._values.get("failover_attempts_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_mode(self) -> typing.Optional[builtins.str]:
        '''Determines what to do if an origin fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        '''
        result = self._values.get("failover_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_origin_map(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap"]]]:
        '''failover_origin_map block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        '''
        result = self._values.get("failover_origin_map")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap"]]], result)

    @builtins.property
    def failover_status_codes(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        '''
        result = self._values.get("failover_status_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Application Load Balancer policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name for your session cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        '''
        result = self._values.get("origin_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        '''
        result = self._values.get("specify_stickiness_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable this if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        '''
        result = self._values.get("stickiness_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the stickiness cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        '''
        result = self._values.get("stickiness_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        '''
        result = self._values.get("stickiness_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ensures the cookie is transmitted only over HTTP.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        '''
        result = self._values.get("stickiness_cookie_set_http_only_flag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Determines how a cookie persistently associates the client with a load-balanced origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        '''
        result = self._values.get("stickiness_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_duration(self) -> typing.Optional[builtins.str]:
        '''Sets how long it is before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        '''
        result = self._values.get("stickiness_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        '''
        result = self._values.get("stickiness_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extends the duration of the cookie with each new request.

        When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        '''
        result = self._values.get("stickiness_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        '''
        result = self._values.get("stickiness_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc919700881f815a41badd97784e3e6886d15bb7043c0e30704b8f73cd95bc6)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a5e1b12a7f302ccbd3f6974711641f1224d9537885a8093942d71d47d2602e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d553042ffce0dd8f0cf4d99f7c26bf69113002d6fee0417076b51c4d835943a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055fcfa307fc6a1290916572f0698337694125b14257cbae3cf1556b951b5ef2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccccc3ba2714d63dffab5f408652786b8e3cb6734d6f2f238e6c47ef9fd1f6d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91111e5b172362bf214900a68c0003c9f0fe784a2483a8f3a02374fdb4f10da5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72dbc7c60bd950f4abd0aca5623c8e846bb397f76f59dce384267e83abc6ffe1)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c71c7f9359027f63619121de64405dc531f31e63971f283a81c0de469c11f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc39c5eabd69ae02a2a3fee59d0d5175199bf3a1d0ebce5fadcc45b703a2dfe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a4fa94fef63b040943dfe216feeca209b7b14a8658b187497a1bc40a6bd026)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59326c473925ad444e8057fdbbc668c844e3673fec7c410969325eb2a2ec181a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap",
    jsii_struct_bases=[],
    name_mapping={"from_origin_id": "fromOriginId", "to_origin_ids": "toOriginIds"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap:
    def __init__(
        self,
        *,
        from_origin_id: typing.Optional[builtins.str] = None,
        to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param from_origin_id: Specifies the origin whose failure triggers the mapping rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        :param to_origin_ids: Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__359dd69b360ed0e6f32697e7b9c74734d9595af6853b3156b8931e133319329e)
            check_type(argname="argument from_origin_id", value=from_origin_id, expected_type=type_hints["from_origin_id"])
            check_type(argname="argument to_origin_ids", value=to_origin_ids, expected_type=type_hints["to_origin_ids"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if from_origin_id is not None:
            self._values["from_origin_id"] = from_origin_id
        if to_origin_ids is not None:
            self._values["to_origin_ids"] = to_origin_ids

    @builtins.property
    def from_origin_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin whose failure triggers the mapping rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        '''
        result = self._values.get("from_origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_origin_ids(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        result = self._values.get("to_origin_ids")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249922910232b1287277b14cdba0193813c3d30c3ce7cd69d0fb96e63aa0970e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b297fddfe3e69c8938a0a2c924b658057307bd7be29728ae43d443fcbff7094f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666441e5de62c5100ebf46fd415ae341234776026c4ae05c7edf2dc8a1709c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a72157ef8992c8313cb36ff33999b236adc8e3de13d54eea2ee6c43ddb532b71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2857769909063fd23b6a7a56c4f8c9d6dbe6e353b45c57c26f61b220a5ee108f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7721ad323a05b3d575c3163392dfc34491fa98576b4ee230eec4ace35c0965d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0385594838701f053dc1a22bac3a184d35ea88a0807c573022e724f0f9cbe10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFromOriginId")
    def reset_from_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFromOriginId", []))

    @jsii.member(jsii_name="resetToOriginIds")
    def reset_to_origin_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToOriginIds", []))

    @builtins.property
    @jsii.member(jsii_name="fromOriginIdInput")
    def from_origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fromOriginIdInput"))

    @builtins.property
    @jsii.member(jsii_name="toOriginIdsInput")
    def to_origin_ids_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "toOriginIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="fromOriginId")
    def from_origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fromOriginId"))

    @from_origin_id.setter
    def from_origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65da923dce9931f996a2734a46ac7937d6a06c774f8e59244e36658c3633791e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fromOriginId", value)

    @builtins.property
    @jsii.member(jsii_name="toOriginIds")
    def to_origin_ids(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "toOriginIds"))

    @to_origin_ids.setter
    def to_origin_ids(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa750144bf15858553200a49adb48d815244e2bd17dac6e45d26a5291459697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toOriginIds", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84683f5e53bac11d58470721b229dac30d90d566147c0a0db7e2123e791bf63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__121b636723c7c6aa10c7690244d95abe40ffc73de1ed1c8709afc9a27336eb59)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAllDownNetStorage")
    def put_all_down_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putAllDownNetStorage", [value]))

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putFailoverOriginMap")
    def put_failover_origin_map(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__986bfbee059ab1fcfc7fc9c067f99c75fa26ea2d89dafd0154b7a6354102d8ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverOriginMap", [value]))

    @jsii.member(jsii_name="resetAllDownNetStorage")
    def reset_all_down_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorage", []))

    @jsii.member(jsii_name="resetAllDownNetStorageFile")
    def reset_all_down_net_storage_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorageFile", []))

    @jsii.member(jsii_name="resetAllDownStatusCode")
    def reset_all_down_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownStatusCode", []))

    @jsii.member(jsii_name="resetAllDownTitle")
    def reset_all_down_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownTitle", []))

    @jsii.member(jsii_name="resetAllowCachePrefresh")
    def reset_allow_cache_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCachePrefresh", []))

    @jsii.member(jsii_name="resetCachedContentTitle")
    def reset_cached_content_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachedContentTitle", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverAttemptsThreshold")
    def reset_failover_attempts_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverAttemptsThreshold", []))

    @jsii.member(jsii_name="resetFailoverMode")
    def reset_failover_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMode", []))

    @jsii.member(jsii_name="resetFailoverOriginMap")
    def reset_failover_origin_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverOriginMap", []))

    @jsii.member(jsii_name="resetFailoverStatusCodes")
    def reset_failover_status_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverStatusCodes", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginCookieName")
    def reset_origin_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCookieName", []))

    @jsii.member(jsii_name="resetSpecifyStickinessCookieDomain")
    def reset_specify_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieAutomaticSalt")
    def reset_stickiness_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieDomain")
    def reset_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieSalt")
    def reset_stickiness_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieSetHttpOnlyFlag")
    def reset_stickiness_cookie_set_http_only_flag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSetHttpOnlyFlag", []))

    @jsii.member(jsii_name="resetStickinessCookieType")
    def reset_stickiness_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieType", []))

    @jsii.member(jsii_name="resetStickinessDuration")
    def reset_stickiness_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessDuration", []))

    @jsii.member(jsii_name="resetStickinessExpirationDate")
    def reset_stickiness_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessExpirationDate", []))

    @jsii.member(jsii_name="resetStickinessRefresh")
    def reset_stickiness_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessRefresh", []))

    @jsii.member(jsii_name="resetStickinessTitle")
    def reset_stickiness_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorage")
    def all_down_net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference, jsii.get(self, "allDownNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMap")
    def failover_origin_map(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapList, jsii.get(self, "failoverOriginMap"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFileInput")
    def all_down_net_storage_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownNetStorageFileInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageInput")
    def all_down_net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "allDownNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCodeInput")
    def all_down_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownTitleInput")
    def all_down_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefreshInput")
    def allow_cache_prefresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCachePrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitleInput")
    def cached_content_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cachedContentTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThresholdInput")
    def failover_attempts_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverAttemptsThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverModeInput")
    def failover_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverModeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMapInput")
    def failover_origin_map_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "failoverOriginMapInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodesInput")
    def failover_status_codes_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverStatusCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originCookieNameInput")
    def origin_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomainInput")
    def specify_stickiness_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyStickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSaltInput")
    def stickiness_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomainInput")
    def stickiness_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSaltInput")
    def stickiness_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlagInput")
    def stickiness_cookie_set_http_only_flag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieSetHttpOnlyFlagInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieTypeInput")
    def stickiness_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessDurationInput")
    def stickiness_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDateInput")
    def stickiness_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessRefreshInput")
    def stickiness_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessTitleInput")
    def stickiness_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFile")
    def all_down_net_storage_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownNetStorageFile"))

    @all_down_net_storage_file.setter
    def all_down_net_storage_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9d3fd30e60c6f95a26eafdfe3585d19fa1b88b0a418d90b812bfeba34c69f70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownNetStorageFile", value)

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCode")
    def all_down_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownStatusCode"))

    @all_down_status_code.setter
    def all_down_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34311377e3d83046de22b6c44d627db9ba6a6b63d16281c06ca7a9c89a5855f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="allDownTitle")
    def all_down_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownTitle"))

    @all_down_title.setter
    def all_down_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a91d04aa4363a200c496b7c4f62cb177b1b542fb3cf745710c35c2aca2b913)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefresh")
    def allow_cache_prefresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCachePrefresh"))

    @allow_cache_prefresh.setter
    def allow_cache_prefresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01570c0fc341392365dc46f93d60edce89173360a51bde1cee764641bc9767be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCachePrefresh", value)

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitle")
    def cached_content_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cachedContentTitle"))

    @cached_content_title.setter
    def cached_content_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44fb99f22716d1b6e5db0c1cc0b32121d61542da65b0b571e977af94b9a5fb5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cachedContentTitle", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a641b89ed70a14ed81507f55f253199c3f3db3335c1ace66767d7ad2de083b35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThreshold")
    def failover_attempts_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverAttemptsThreshold"))

    @failover_attempts_threshold.setter
    def failover_attempts_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec06ec5b7cf666e506b53476d5214b9a95049b4d948562adcb8b1b3df88ec765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverAttemptsThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMode")
    def failover_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMode"))

    @failover_mode.setter
    def failover_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb651408c566d17b8a7dbfe0af8c1c9d9c61e3aea5dc1bfabee4266b11f701e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodes")
    def failover_status_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverStatusCodes"))

    @failover_status_codes.setter
    def failover_status_codes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae36559422cfb4fb0fc6594ada01c37e58a83875363a1e9c403f54e18d4b1469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverStatusCodes", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ce6f6595a31ca0c1278ace59c243383dd1564e041358370794e5bc69d8112f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04ce29b4e577b37d5a4f77fef15c6ee591e5831d4b7bb18a0a12b48620591aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ad63765c1e059541080b6f8b8a8a7020017ebc3d59d4365e5ebcaa77b3a38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originCookieName")
    def origin_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCookieName"))

    @origin_cookie_name.setter
    def origin_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beaedc80ca25a4e72cba1187b2462e6401ef37da6d782bd9c7f0e22f74241f6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomain")
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyStickinessCookieDomain"))

    @specify_stickiness_cookie_domain.setter
    def specify_stickiness_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c0a90aa99f8d4a61b54e59b271fa65adc46b1542a8a91c395ea8a4bf5529d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyStickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSalt")
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieAutomaticSalt"))

    @stickiness_cookie_automatic_salt.setter
    def stickiness_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bf3179a6130a8d8efcbeee58d4418426917788bdf4cb815ba3ee076380ec645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomain")
    def stickiness_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieDomain"))

    @stickiness_cookie_domain.setter
    def stickiness_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4fa5cd3f3f6e65573c2fceda4a595096d606b2943ab8b51f8997fad877e57b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSalt")
    def stickiness_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieSalt"))

    @stickiness_cookie_salt.setter
    def stickiness_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeed74968420a2a136a965cd09a64d15e7ee0dd4a683e194d00a23af64cef5d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlag")
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieSetHttpOnlyFlag"))

    @stickiness_cookie_set_http_only_flag.setter
    def stickiness_cookie_set_http_only_flag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf61de1f4b7ff1747403ca852ff833475d9ea232a6f44a666432b1f4f94e4b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSetHttpOnlyFlag", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieType")
    def stickiness_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieType"))

    @stickiness_cookie_type.setter
    def stickiness_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f60b456269b72892ed10599c37f8b0dcf6f0a01cc8ddba36f4aec76fdb295a34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessDuration")
    def stickiness_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessDuration"))

    @stickiness_duration.setter
    def stickiness_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e3ade4204ae5a936212f68b089a4700cea12119287cb47da0deb83ad120717)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessDuration", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDate")
    def stickiness_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessExpirationDate"))

    @stickiness_expiration_date.setter
    def stickiness_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ee2da1d0014b2863e0207ffaeb858995ca0ba4db434c92f33347efb954ddbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessRefresh")
    def stickiness_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessRefresh"))

    @stickiness_refresh.setter
    def stickiness_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0592cac50906021b7f664709ab68724e7a313ded7f83c37395114f83f0dc0b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessTitle")
    def stickiness_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessTitle"))

    @stickiness_title.setter
    def stickiness_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1830976c92d3eae475a75e1af4a6eb0ebf3eac5fb9051d0974b9959c6844526b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47682b76c2ff5ae95b1ce9766d3624a290c2223a6cb964ace99ce87db28ec510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c780b5c6f82d8c07cac586c980e90af36add558c62c6e18cd2e9c1f83a09997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__480f1979e331d576612df120e1d0413200756715dcc5dd43b0bccb99c74bf80d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_automatic_salt": "populationCookieAutomaticSalt",
        "population_cookie_domain": "populationCookieDomain",
        "population_cookie_include_rule_name": "populationCookieIncludeRuleName",
        "population_cookie_salt": "populationCookieSalt",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "segment_tracking_cookie_name": "segmentTrackingCookieName",
        "segment_tracking_custom_header": "segmentTrackingCustomHeader",
        "segment_tracking_method": "segmentTrackingMethod",
        "segment_tracking_query_param": "segmentTrackingQueryParam",
        "segment_tracking_title": "segmentTrackingTitle",
        "specify_population_cookie_domain": "specifyPopulationCookieDomain",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37299cf58d77cc31c6c2f71182b0a92a086904ec022a8fec7e2ed6a0f5dce9fd)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_automatic_salt", value=population_cookie_automatic_salt, expected_type=type_hints["population_cookie_automatic_salt"])
            check_type(argname="argument population_cookie_domain", value=population_cookie_domain, expected_type=type_hints["population_cookie_domain"])
            check_type(argname="argument population_cookie_include_rule_name", value=population_cookie_include_rule_name, expected_type=type_hints["population_cookie_include_rule_name"])
            check_type(argname="argument population_cookie_salt", value=population_cookie_salt, expected_type=type_hints["population_cookie_salt"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument segment_tracking_cookie_name", value=segment_tracking_cookie_name, expected_type=type_hints["segment_tracking_cookie_name"])
            check_type(argname="argument segment_tracking_custom_header", value=segment_tracking_custom_header, expected_type=type_hints["segment_tracking_custom_header"])
            check_type(argname="argument segment_tracking_method", value=segment_tracking_method, expected_type=type_hints["segment_tracking_method"])
            check_type(argname="argument segment_tracking_query_param", value=segment_tracking_query_param, expected_type=type_hints["segment_tracking_query_param"])
            check_type(argname="argument segment_tracking_title", value=segment_tracking_title, expected_type=type_hints["segment_tracking_title"])
            check_type(argname="argument specify_population_cookie_domain", value=specify_population_cookie_domain, expected_type=type_hints["specify_population_cookie_domain"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_automatic_salt is not None:
            self._values["population_cookie_automatic_salt"] = population_cookie_automatic_salt
        if population_cookie_domain is not None:
            self._values["population_cookie_domain"] = population_cookie_domain
        if population_cookie_include_rule_name is not None:
            self._values["population_cookie_include_rule_name"] = population_cookie_include_rule_name
        if population_cookie_salt is not None:
            self._values["population_cookie_salt"] = population_cookie_salt
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if segment_tracking_cookie_name is not None:
            self._values["segment_tracking_cookie_name"] = segment_tracking_cookie_name
        if segment_tracking_custom_header is not None:
            self._values["segment_tracking_custom_header"] = segment_tracking_custom_header
        if segment_tracking_method is not None:
            self._values["segment_tracking_method"] = segment_tracking_method
        if segment_tracking_query_param is not None:
            self._values["segment_tracking_query_param"] = segment_tracking_query_param
        if segment_tracking_title is not None:
            self._values["segment_tracking_title"] = segment_tracking_title
        if specify_population_cookie_domain is not None:
            self._values["specify_population_cookie_domain"] = specify_population_cookie_domain
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Audience Segmentation cloudlet feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''Specifies a suffix to append to the cookie name.

        This helps distinguish this audience segmentation policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        '''
        result = self._values.get("population_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the population cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        '''
        result = self._values.get("population_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes in the session cookie the name of the rule in which this behavior appears.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        '''
        result = self._values.get("population_cookie_include_rule_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        '''
        result = self._values.get("population_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Specifies when the segmentation cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the lifetime of the segmentation cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If disabled, sets the expiration time only if the cookie is not yet present in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_cookie_name(self) -> typing.Optional[builtins.str]:
        '''This cookie name specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        '''
        result = self._values.get("segment_tracking_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_custom_header(self) -> typing.Optional[builtins.str]:
        '''This custom HTTP header specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        '''
        result = self._values.get("segment_tracking_custom_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the method to pass segment information to the origin.

        The Cloudlet passes the rule applied to a given request location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        '''
        result = self._values.get("segment_tracking_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_query_param(self) -> typing.Optional[builtins.str]:
        '''This query parameter specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        '''
        result = self._values.get("segment_tracking_query_param")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        '''
        result = self._values.get("segment_tracking_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_population_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to specify a cookie domain with the population cookie.

        It tells the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        '''
        result = self._values.get("specify_population_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75549364b40a600301c14f083a615eeac5a2864c9a4d865646c3e2137030d53d)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6091c9dfc5f2e34a3d2f4e5f254f071d2401eb415d9f66e5077872700f6aa6b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d285aae15e11a7e424f98dbe4c8108263c357730d48d716d37942b938e990f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d32af900e2e657ba654748cf96773e25101032af8489cc2d9c4ad5be85156cbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63b7e6636966fe0e335bd03a3d2b09002c368b091fdc90485fe2db729f7fa70c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__460884a1135e57bbad136714e5f46016c2900b3d5986ac526410eeb4c74ac40c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieAutomaticSalt")
    def reset_population_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieDomain")
    def reset_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetPopulationCookieIncludeRuleName")
    def reset_population_cookie_include_rule_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieIncludeRuleName", []))

    @jsii.member(jsii_name="resetPopulationCookieSalt")
    def reset_population_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetSegmentTrackingCookieName")
    def reset_segment_tracking_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCookieName", []))

    @jsii.member(jsii_name="resetSegmentTrackingCustomHeader")
    def reset_segment_tracking_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCustomHeader", []))

    @jsii.member(jsii_name="resetSegmentTrackingMethod")
    def reset_segment_tracking_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingMethod", []))

    @jsii.member(jsii_name="resetSegmentTrackingQueryParam")
    def reset_segment_tracking_query_param(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingQueryParam", []))

    @jsii.member(jsii_name="resetSegmentTrackingTitle")
    def reset_segment_tracking_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingTitle", []))

    @jsii.member(jsii_name="resetSpecifyPopulationCookieDomain")
    def reset_specify_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSaltInput")
    def population_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomainInput")
    def population_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleNameInput")
    def population_cookie_include_rule_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieIncludeRuleNameInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieSaltInput")
    def population_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieNameInput")
    def segment_tracking_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeaderInput")
    def segment_tracking_custom_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCustomHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethodInput")
    def segment_tracking_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParamInput")
    def segment_tracking_query_param_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingQueryParamInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitleInput")
    def segment_tracking_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomainInput")
    def specify_population_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyPopulationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33054186012d24626997e0394eb272c442dd3fc9656a6ff86a96e428efa113d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3994d143d731eee29d54e2ef4bc8e037f65ce68d098997ee28388ec248a64a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf78bdf8a1f046a0b116df245d422ff8ae556b6a67a8d2483046c6bd211f7b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4012b8148e3f9899487279ef884022883c5c5cedbf2e79b2b1c898001e301c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9d84fe1e0c8acebb5f55f8768fd8a355374545eea484724b5e2bf4ed6bc0c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSalt")
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieAutomaticSalt"))

    @population_cookie_automatic_salt.setter
    def population_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e825e667ec0abb806b80fd51143483b612464424702b10342a21c306ce551f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomain")
    def population_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieDomain"))

    @population_cookie_domain.setter
    def population_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae6b988bcf54b26179edb55a4e4e3e723f41f38cf2fec014acb013baec9b7446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleName")
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieIncludeRuleName"))

    @population_cookie_include_rule_name.setter
    def population_cookie_include_rule_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8051bb121189e42a530cb6003cea50ba0b43d1bbc1b930e4ca25ff9a6b243a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieIncludeRuleName", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieSalt")
    def population_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieSalt"))

    @population_cookie_salt.setter
    def population_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb14bae707a8942215b2497a38aa408d9b8d37c285f0ae281806780fe76df7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76ae2ecaa476b488e9ca2b3ecbada1f8e359a47fbd3b07d5865637a2d41363d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4648b149f746c5b59e10713878b2b304f8c2dd8935f299461067a9b31302e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a9424288198e90636a9bf07497f05db3911b3df53561835c47f2ab70b7969e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f004c3e7fb559cbd1c3f9b03b204f4008307b04f77757c579e49461c2f53c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieName")
    def segment_tracking_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCookieName"))

    @segment_tracking_cookie_name.setter
    def segment_tracking_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150ba122f1da24f5e378cdcc07868828c441d9face177c0b17c8c79a9454162f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeader")
    def segment_tracking_custom_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCustomHeader"))

    @segment_tracking_custom_header.setter
    def segment_tracking_custom_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e485aa2731126df070be0ec15aa5602745eb916a1c581aae241e5391905702b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCustomHeader", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethod")
    def segment_tracking_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingMethod"))

    @segment_tracking_method.setter
    def segment_tracking_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad11dd08a5faa276495e27762b2e092a3fa3da5ae2ae0b6bfc63b22159559f4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingMethod", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParam")
    def segment_tracking_query_param(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingQueryParam"))

    @segment_tracking_query_param.setter
    def segment_tracking_query_param(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f00a1b0dafc18621c0b98926a5e0a9ffb4d8ea2a2b6c9f2217e97a3387ac690e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingQueryParam", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitle")
    def segment_tracking_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingTitle"))

    @segment_tracking_title.setter
    def segment_tracking_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc5d0e8ae472e885a5b7d792d0db16fc8b86626be0a86c52b9e039f80c07cc81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingTitle", value)

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomain")
    def specify_population_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyPopulationCookieDomain"))

    @specify_population_cookie_domain.setter
    def specify_population_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbbc84f41b3e1d6b336ffbb25d7b1ec1f22582e1b0c9fc5fde2d12565dc8abc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyPopulationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f86373f974428185ccbde34b594e9538dc2d8ee86699e9a70c8606f6647b351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f1325f1478344674b7286792ecfb45fff7a67c46bf93bc64a7b11aefaf8809)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b26b6f3593a1210608c59e875d6bcd65a4a613b80547b0d107147daed165060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation",
    jsii_struct_bases=[],
    name_mapping={
        "autodv": "autodv",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation:
    def __init__(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea4e6ece0a13ac799533dd022b2797e782eb59c1a9b13414af3592bfe85737f3)
            check_type(argname="argument autodv", value=autodv, expected_type=type_hints["autodv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if autodv is not None:
            self._values["autodv"] = autodv
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def autodv(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        '''
        result = self._values.get("autodv")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728225d5070907ad0f1ba1c2b85c39b39429f4a83ab2ef13138459c142dc0302)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAutodv")
    def reset_autodv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutodv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="autodvInput")
    def autodv_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "autodvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="autodv")
    def autodv(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "autodv"))

    @autodv.setter
    def autodv(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dd46f6150934ad1fb7cfdabd1cc2b799f71d4f6514c37c2715f7464856cb9fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "autodv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1384ae68b86053bf7691d91a0ec09024bfeedb5cfc388cb00e6489290d82b40c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e913f0efe60c047d06a846b67b167dd3e2d2c0a9cb0b3a511d9bc9664a715e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2385852473fa2ea3da6d7fda99fce963a8576dc038eb37ccba01124eaf525c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b5e58f3da59814195704e7c945df512446e8f74b89e68d2565f64939f8616c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3032473b026fd68eac55b7468ffbdb610a1088cce7a48d648d1662dc4a6c778)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the base path of content on your origin server.

        The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectoryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectoryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631738e0f9294bd1f367af7ff08915e97ad94be374ef00a0207f189eea6cb2f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5edd3aa16260574e900135d13d83a8d500a555ef991881d203aa42c1df8aace7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb6014a5c9c0b5c0dfbcfcfb86080563008ffc949e55f1b4f020da25a4ad9296)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a536c78c0be9f17375b71050bbfcd8b7128a302841793fe70f16e546534971)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6ac352551d386da1f4602266aa0c13e4b0c93e54a7622f130adb5106c2d482d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71713d9b3dc7c0aa3c40ef006559e5e529db3e13e71f0692ae044a718add9f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing",
    jsii_struct_bases=[],
    name_mapping={
        "conditional_error_pattern": "conditionalErrorPattern",
        "conditional_http_status": "conditionalHttpStatus",
        "conditional_sampling_frequency": "conditionalSamplingFrequency",
        "cpcodes": "cpcodes",
        "enabled": "enabled",
        "forward_type": "forwardType",
        "locked": "locked",
        "request_type": "requestType",
        "sampling_frequency": "samplingFrequency",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing:
    def __init__(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9288e8b9832eda416ecb020d298980d00a3e10149c0bc0eaaaff3c5197c28ea7)
            check_type(argname="argument conditional_error_pattern", value=conditional_error_pattern, expected_type=type_hints["conditional_error_pattern"])
            check_type(argname="argument conditional_http_status", value=conditional_http_status, expected_type=type_hints["conditional_http_status"])
            check_type(argname="argument conditional_sampling_frequency", value=conditional_sampling_frequency, expected_type=type_hints["conditional_sampling_frequency"])
            check_type(argname="argument cpcodes", value=cpcodes, expected_type=type_hints["cpcodes"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_type", value=forward_type, expected_type=type_hints["forward_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument sampling_frequency", value=sampling_frequency, expected_type=type_hints["sampling_frequency"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if conditional_error_pattern is not None:
            self._values["conditional_error_pattern"] = conditional_error_pattern
        if conditional_http_status is not None:
            self._values["conditional_http_status"] = conditional_http_status
        if conditional_sampling_frequency is not None:
            self._values["conditional_sampling_frequency"] = conditional_sampling_frequency
        if cpcodes is not None:
            self._values["cpcodes"] = cpcodes
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_type is not None:
            self._values["forward_type"] = forward_type
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if sampling_frequency is not None:
            self._values["sampling_frequency"] = sampling_frequency
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def conditional_error_pattern(self) -> typing.Optional[builtins.str]:
        '''A space-separated set of error patterns that trigger beacons to conditional feeds.

        Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        '''
        result = self._values.get("conditional_error_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def conditional_http_status(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response status codes or ranges that trigger the beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        '''
        result = self._values.get("conditional_http_status")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def conditional_sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a conditional sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        '''
        result = self._values.get("conditional_sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cpcodes(self) -> typing.Optional[builtins.str]:
        '''The space-separated list of CP codes that trigger the beacons.

        You need to specify the same set of CP codes within BOSS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        '''
        result = self._values.get("cpcodes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable diagnostic data beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        '''
        result = self._values.get("forward_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        '''
        result = self._values.get("sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e77aec49fb5d0c4539ef74effa2faf2a6cf024e2e3dc5c91c337533b70a5bb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConditionalErrorPattern")
    def reset_conditional_error_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalErrorPattern", []))

    @jsii.member(jsii_name="resetConditionalHttpStatus")
    def reset_conditional_http_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalHttpStatus", []))

    @jsii.member(jsii_name="resetConditionalSamplingFrequency")
    def reset_conditional_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalSamplingFrequency", []))

    @jsii.member(jsii_name="resetCpcodes")
    def reset_cpcodes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpcodes", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardType")
    def reset_forward_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetSamplingFrequency")
    def reset_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingFrequency", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPatternInput")
    def conditional_error_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalErrorPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatusInput")
    def conditional_http_status_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "conditionalHttpStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequencyInput")
    def conditional_sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalSamplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="cpcodesInput")
    def cpcodes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cpcodesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardTypeInput")
    def forward_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingFrequencyInput")
    def sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "samplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPattern")
    def conditional_error_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalErrorPattern"))

    @conditional_error_pattern.setter
    def conditional_error_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee48dfe71b2c02c317db30d1db5144a99bcef8dd94465e1cf0e57e8b74bb169a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalErrorPattern", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatus")
    def conditional_http_status(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "conditionalHttpStatus"))

    @conditional_http_status.setter
    def conditional_http_status(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdb404004a1152a2a92fb8653a7c0513a7eab28968363d696e24191852a3af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalHttpStatus", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequency")
    def conditional_sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalSamplingFrequency"))

    @conditional_sampling_frequency.setter
    def conditional_sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2034fce04e3107026243b25835998e101f0bf4d55ca088043ae28f24f8297db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalSamplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="cpcodes")
    def cpcodes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cpcodes"))

    @cpcodes.setter
    def cpcodes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87a7191ccf9f72843b6a6c0f1547419034d73e31be9106714dd21b4d08ec5bda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpcodes", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d379729cf8a2655cd53373df978315b74b2b2c68ba211b649faa9ae56156bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardType")
    def forward_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardType"))

    @forward_type.setter
    def forward_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4a4d0154e034a0a917fe84e287a88457ed3a6c7e842c816d1508f822f61bab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254b02d5342c0a0a54ba93975fe52a8bc1e2aa3de5c6cbd9ad3f9dd858e8f1a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__381d15bd330bfbb884080780131dbdb3b1924570b12a56d1a7a300d8dc133fb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="samplingFrequency")
    def sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "samplingFrequency"))

    @sampling_frequency.setter
    def sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576f39386e4d247ee9656ed613cac3b33ef157b913e29c64611002fc5119aa24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe4e2af411a55762034f96e8daf323fdd86b2d78f6eb41bce9a6e22f51e9b49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20e80eb46eeea5e967a579f67adddfc290db933a9a163e7ffeeb262198c0b9a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac8f03f26cfa72ef56a21c6f33246b38c2f83f69e0fea204b8de4279b23184a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "logging_enabled": "loggingEnabled",
        "opt_mode": "optMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__241bb19eaddfd80863ea1656b9970e230525ebae5c13d9ae17cae852f6ee2e3b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument logging_enabled", value=logging_enabled, expected_type=type_hints["logging_enabled"])
            check_type(argname="argument opt_mode", value=opt_mode, expected_type=type_hints["opt_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if logging_enabled is not None:
            self._values["logging_enabled"] = logging_enabled
        if opt_mode is not None:
            self._values["opt_mode"] = opt_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Breadcrumbs feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def logging_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client.

        This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        '''
        result = self._values.get("logging_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def opt_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to include Breadcrumbs data in the response header.

        To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        '''
        result = self._values.get("opt_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c062259fa22aaf8ff28f61021248c6d97d23723f104dd162a10920850388fdc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLoggingEnabled")
    def reset_logging_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoggingEnabled", []))

    @jsii.member(jsii_name="resetOptMode")
    def reset_opt_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="loggingEnabledInput")
    def logging_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "loggingEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="optModeInput")
    def opt_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3af18863597214be4a282503111c6eede6ccd748a52df9ef24dd5bffaaff4e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b0cc28aa441c3587b8edf3af9913f813780f52f2357be43c550ae9c02d6f795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="loggingEnabled")
    def logging_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "loggingEnabled"))

    @logging_enabled.setter
    def logging_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9c77e79aeda540b33b4407f751f0f6bd0fb20229a4fa422a2134167b1608c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loggingEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="optMode")
    def opt_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optMode"))

    @opt_mode.setter
    def opt_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397b100b3d1c3338b0340b92d53caf87a0437a42048ebbfca0863b59f8e4ade2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6a372732c7a1334e57ea2374db654a52ab41a1ed2a2dd27d8dc654ee2b75bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b0cfe2e6ab7f15d4b7f4f7b9bdfd6b6f7da6dbb68c94c9ea04d39e60111b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1615a30cff15389cc6175e16ec60849aadd20ad877de1174910e0a92b8504770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11ac5cb191ef9486e15bfa431927bc41503c8e549350853f225211312e20838)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the break connection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8dd477b02343fa27f16105280770db95cc469f18233fecacceb734032905028)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e2a77ad3859ed7fddfecb19623bc9c380bba9d7dcc41ad039171baa828625d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ee53a9e958b1a0df5e1f0e77e69ec2ef91e19c8a9ee9ea68a14bd87f1d5604e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b22edeedd9ecd7e4a5227b56ca7978d923e8ef3a5085e635460ee8a403f45206)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ff946b722965ec89d52b29a65b92990ff71f16bf7b6efde91e9cb9a10980c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8089b5c70abaed165d0c4a2357db0f51e889728f2c6ecb5b937f5a8a2e557b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__060cd0fe58f6c7cdba8574826db708b618aa9eb563935774704fa27098adfecf)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Fetches Brotli-compressed assets from your origin and caches them on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotliOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotliOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d4e9312a7097dd7178c692cc78bb12768c72dd62024ec3f46ec064f95e3126f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae65b1234b4d997338ebe7fe8f016a3a982a8e8eb1080ee6b5bf9696e51b7ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cee2afe1b9342901e6c2f382d8bc00087eb56c6bcc48f1cb82c6bfc9261b883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56fb42b10125e358fa218e0ef2d6a8abca1cb56d049913091428cdca766d07a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cfad3e74abe6dd8e39ca89eae9937d4a79e0cf9524defd92ad8e56ed66ad0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dec8a7a643f2ca193ed6913403c5281a0aaea3fcbf43ebc6364f03b921daccd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "preserve_stale": "preserveStale",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00f97b4321322661dd0c75bce323eab3d80207b98615b910c83bd5d31c129ef)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preserve_stale", value=preserve_stale, expected_type=type_hints["preserve_stale"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if preserve_stale is not None:
            self._values["preserve_stale"] = preserve_stale
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the error-caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preserve_stale(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes.

        This avoids re-fetching and re-caching content after transient errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        '''
        result = self._values.get("preserve_stale")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Overrides the default caching duration of ``10s``.

        Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59f08db54a006739e070a089be3097a7ca170547269a4f426a3a5160905441f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreserveStale")
    def reset_preserve_stale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveStale", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveStaleInput")
    def preserve_stale_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveStaleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b5b25bbde26daee05d4c740fc0a4ceeb99011653592b1c7c94de51e98dc3d42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa23f0b91b82c04d7628e03713ec2ad7e4c2eca127925fc6fb479608c873d43a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preserveStale")
    def preserve_stale(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveStale"))

    @preserve_stale.setter
    def preserve_stale(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891e9f4ae11e48f3be4918c8afd0b467bde677b803586f31c44c685a0ed0bc32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveStale", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a240be7915ea6fa8aea660ab918cf2ce041836c1cf5a317609b696a884f3118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fbe42c2e4c86f89f17389aae82a91071b66b80b8cb3b5f2eac7ac0b32eff39f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf5c320f06d8c3759fac04f1e81eb3e85440d8d8b372089f1bfd3b0e247eb91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc96453fa807dee3a6a15b22193dcd63573f66c40b9c66a3bb89f93c621302f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "include_value": "includeValue",
        "locked": "locked",
        "optional": "optional",
        "rule": "rule",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b722a5db4a8a6f7177e07d10b31e4cd755ece93e40cd8595f141178d359ecf61)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument include_value", value=include_value, expected_type=type_hints["include_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optional", value=optional, expected_type=type_hints["optional"])
            check_type(argname="argument rule", value=rule, expected_type=type_hints["rule"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if include_value is not None:
            self._values["include_value"] = include_value
        if locked is not None:
            self._values["locked"] = locked
        if optional is not None:
            self._values["optional"] = optional
        if rule is not None:
            self._values["rule"] = rule
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def include_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes the value of the specified elements in the cache ID. Otherwise only their names are included.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        '''
        result = self._values.get("include_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optional(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Requires the behavior's specified elements to be present for content to cache.

        When disabled, requests that lack the specified elements are still cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        '''
        result = self._values.get("optional")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rule(self) -> typing.Optional[builtins.str]:
        '''Specifies how to modify the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        '''
        result = self._values.get("rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the variable you want to include in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0f07e0677b512aad2a0bb1e769652db68c2621a37a5483a87fd626a78f9189)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetIncludeValue")
    def reset_include_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptional")
    def reset_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptional", []))

    @jsii.member(jsii_name="resetRule")
    def reset_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRule", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="includeValueInput")
    def include_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optionalInput")
    def optional_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optionalInput"))

    @builtins.property
    @jsii.member(jsii_name="ruleInput")
    def rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ruleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a995b52d78a5e933661882bbe6b0301d085dcf46ac2a1d17b2a1a4da13a411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="includeValue")
    def include_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeValue"))

    @include_value.setter
    def include_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b28d00f5e18581901de38ce0101ceac2a76d9d7eb9257f75e702187a58fa44fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb52d9aa1c62d50a6c699a0ed1041b70bd219f5bcb627ebeeb29c3796a587c7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optional")
    def optional(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optional"))

    @optional.setter
    def optional(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ab06826588802e3d02b7908e92d5b6a34a4d5cebf53d3507c2113315866d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optional", value)

    @builtins.property
    @jsii.member(jsii_name="rule")
    def rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rule"))

    @rule.setter
    def rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6268b25aafa7177b7c528c29dd4a7b09da9fcc305428dc779dfdb9eba1cc42da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rule", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45f4f7e1394206ece933b8c6984604e1ebabf237c0344879e8f7b39c9813eb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21794962e4265551adfa8bd62caa1ad5607a69a4ea1c49461530da49d86c1774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da55665770a42c1260b9612e93cbe6202b7ca5b0d2aab4747b77024a38d128a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__113646076a0ab9e1debef350fab719e86278cf6b73b9c69bf33a56c398b039db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae5f0049e2398bb6a08a62d5e9f8b0fc4dbef53c9c17a8b537d0bde8ef17b61)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ignores case when forming cache keys.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5cb863b1f3ff4bc77237d73bc8d716f7647f507c977b33f8956f02ed04a22dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f364daeb9289dea7e83fd9e69b7baa805ac5a38aa7cb8f66041b768a1b212e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2540f0581723dd3db243d94038e4bb94cb2e3b40cb2f4f3b66c825e7cd221afc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__528ad8bbe8cda1401056456c2be46ea5a5fe9b071d859e71ebb7c19c1ca676ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__635b33b4a3974f0c621557c21bc5dbd17b39ea5a8ce6933826e642e60e87f652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aefce9af1ab7ebb34f22bcd41c023a73819795c0aeadacd0182a7e67f75054f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "exact_match": "exactMatch",
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b94a9011314fe081347e180fc89f60f0404daf4e40033571e6dcb64e52087f)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument exact_match", value=exact_match, expected_type=type_hints["exact_match"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if exact_match is not None:
            self._values["exact_match"] = exact_match
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Configures how sets of query string parameters translate to cache keys.

        Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exact_match(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        '''
        result = self._values.get("exact_match")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of parameter field names to include in or exclude from the cache key.

        By default, these match the field names as string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParamsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParamsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d280211ca4b718cd1055dd95ac5a6eef230e4a68ec5e2c847b9da0ac9ea07e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetExactMatch")
    def reset_exact_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExactMatch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="exactMatchInput")
    def exact_match_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "exactMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b5dfa810ee3136efe7062f23138660ce3cc62304a0b2a0d51b03e63cab552c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="exactMatch")
    def exact_match(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "exactMatch"))

    @exact_match.setter
    def exact_match(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14f06f6b059b01fb72afb41028e5bc9e1d3c2444a265cfedd8e2b21fdcdf086)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exactMatch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107934d33202cf9641fb0ddff657c9094b8ad46a8749e93877be0c85903d03a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0b407dcdc593e4206142e819052bf1fd5157bfea1d40ef818fc8e928f03b0b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__488d27c7bc37ae4dbbf185d56dae31b2edffc81a504045589ac3f913d3f7ce53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932218c1d198b51be47c47482b3182290db12a98252848a32123f80d6e9763e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b03b944298847e04506a6ed0559a87f6134cdb54f078fc545244b530be39e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "purge_key": "purgeKey",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7707559e5fd34e9d1d1d19ad91c03f345f70616c7a8aa0ee036fed5fdb8101)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_key", value=purge_key, expected_type=type_hints["purge_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if purge_key is not None:
            self._values["purge_key"] = purge_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the new cache key path as an alphanumeric value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        '''
        result = self._values.get("purge_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d34f968ce18e74efc0ea240bcaff99294054bfd6280100cfb243e033580af2a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeKey")
    def reset_purge_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeKeyInput")
    def purge_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b3ccc580c3908042d90851720ed6fe728fdb4ff800ac9f5604f02df6ae6e64e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeKey")
    def purge_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeKey"))

    @purge_key.setter
    def purge_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7648455e1dd5f71bfbb6c52a0f9a9097e7f82d83ce15f855da663d4ae67a37bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d55d3dc82bf2eef7a83ba1fb173534112fa69c325c7cf5ea6b60277ce16646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d385133fc420f61dff333b15ae3c8c7299846259045080dbfc3fb54ced4dee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e166be4985e4470f9ea2781e0236d319423d0470703cf342b7c665020e363f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_body": "useBody",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7cf9d4e349cff7e2d8ffa27aa6379ba62c56060cec62705248903d7a9f481a4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_body", value=use_body, expected_type=type_hints["use_body"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_body is not None:
            self._values["use_body"] = use_body
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables caching of POST responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_body(self) -> typing.Optional[builtins.str]:
        '''Define how and whether to use the POST message body as a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        '''
        result = self._values.get("use_body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2513a77e5e86c3fbebb556803bf7bb78a735a9be7e5158b32640889ac0103329)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseBody")
    def reset_use_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseBody", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useBodyInput")
    def use_body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "useBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7825be03dbbdf30b643d053cfe993cea9a6c87c699af85a19af6d209e5cf58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cec897759b23e1df30bbb1356a6be6eff3c57be52dce2cc503930178f52ec96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f175f42112e1311c470bdc008a6f679c2914ebca59edfae04558188df132fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useBody")
    def use_body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "useBody"))

    @use_body.setter
    def use_body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2141cf814283b0b2bce34fc63eeb0c78ad459322e4ab3d159ac08eea31fce5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useBody", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6affccc41b593d885ceee4d94302340f3cb54a20aac46da31471ee5e821066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e390153d2f5095c70fb6a421b02697d1046cb1e89f88ee6904fd410e6efd0779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6417bf53ee60c2f321c1c3a73db23876811f8a0c2c90e3f303dfc882ff9786e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the redirect caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5458fad8f26a16a96ff9c3f18726445e92507ffd4a39244e0e4252015f40b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6099bc773f0833a0601ee3aebac5dae83fdf305d2003a7eb6c96ad088472cc9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12218e4381c9dcbcd5008536ba8c40b997ba01578e2c4b2e3f24fccc9ce03e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fdd2dc290b68f05c6d8f51a23750bd02b8c92769f31341e1d1da96203e87bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb6faabc091a5b016b5e44305f660604b02dc5453ab5bc6fe2d9c866f9b8c36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7bdf9bdd6b706c509244aca4e379d0b22dbe3152aba66e1674e1be956a234c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "tag": "tag",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281b097e441d27b8b26ef0fb07bd8ed246c175f9b0bff31640d2336f1571ab24)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument tag", value=tag, expected_type=type_hints["tag"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if tag is not None:
            self._values["tag"] = tag
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tag(self) -> typing.Optional[builtins.str]:
        '''Specifies the cache tag you want to add to your cached content.

        A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_``|~-]`

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        '''
        result = self._values.get("tag")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fe063a09c591b8410f41780480e2e48ee4df373c6cbbf319bc8eaa02dc0013)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTag")
    def reset_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTag", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="tagInput")
    def tag_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dac71b658c6d5dfe238c486a9ad144d6fd98f97190cec9d2d827b2521ebc7ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="tag")
    def tag(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tag"))

    @tag.setter
    def tag(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6622252e8c6f480260b3cf59d5b34fbc2975ddc4e64e35307c4ec187002d7db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tag", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f245ab0533e9a4a76f095cb7ad70c9adbeeed32f6219e9072d29d975c7b5253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0e60830fc2643e4a15d1060504b0f23e8bd4b022922203540ea2da28c30232)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b3d0ec05c0a3aaadd172c2efbef3e8d7ba4551ede82e77e70905fcaa36ca4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d26247d2ea43777682fe8bcfe00781c6ca57cc3c5090628d43413837cceaa9)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specifies when to include the ``Edge-Cache-Tag`` in responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisibleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisibleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__538d21170b4c7a9e220b0e87d0758061145dae4cae4f03532920f17b9d8ccc72)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa665a68c61172550a1f3414a1321d93072f32053e4f3455e43eb90e133d0da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5637aca978237cd030b4e639e71b6b5c72da8bd4316f140590ee3573bc64d1ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2e3e7d1ca896f0eb10c0397c00992467b4a2d8a0943e59bfce75c2ec3212b30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fde0f2f3ea5c728ae0bca6b43e5fb02f7729f819c4b8e30dcc371133141491c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503f0b52751f9c01c8a9f0385025111e7a901ed1c6711dc7155b206ffa645a61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "cacheability_settings": "cacheabilitySettings",
        "cache_control_directives": "cacheControlDirectives",
        "default_ttl": "defaultTtl",
        "enhanced_rfc_support": "enhancedRfcSupport",
        "expiration_settings": "expirationSettings",
        "honor_max_age": "honorMaxAge",
        "honor_must_revalidate": "honorMustRevalidate",
        "honor_no_cache": "honorNoCache",
        "honor_no_store": "honorNoStore",
        "honor_private": "honorPrivate",
        "honor_proxy_revalidate": "honorProxyRevalidate",
        "honor_s_maxage": "honorSMaxage",
        "locked": "locked",
        "must_revalidate": "mustRevalidate",
        "revalidation_settings": "revalidationSettings",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78bad0d7247657de0aff531d907ed7ce1096cbd0c45b24d74950042bf5b00598)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument cacheability_settings", value=cacheability_settings, expected_type=type_hints["cacheability_settings"])
            check_type(argname="argument cache_control_directives", value=cache_control_directives, expected_type=type_hints["cache_control_directives"])
            check_type(argname="argument default_ttl", value=default_ttl, expected_type=type_hints["default_ttl"])
            check_type(argname="argument enhanced_rfc_support", value=enhanced_rfc_support, expected_type=type_hints["enhanced_rfc_support"])
            check_type(argname="argument expiration_settings", value=expiration_settings, expected_type=type_hints["expiration_settings"])
            check_type(argname="argument honor_max_age", value=honor_max_age, expected_type=type_hints["honor_max_age"])
            check_type(argname="argument honor_must_revalidate", value=honor_must_revalidate, expected_type=type_hints["honor_must_revalidate"])
            check_type(argname="argument honor_no_cache", value=honor_no_cache, expected_type=type_hints["honor_no_cache"])
            check_type(argname="argument honor_no_store", value=honor_no_store, expected_type=type_hints["honor_no_store"])
            check_type(argname="argument honor_private", value=honor_private, expected_type=type_hints["honor_private"])
            check_type(argname="argument honor_proxy_revalidate", value=honor_proxy_revalidate, expected_type=type_hints["honor_proxy_revalidate"])
            check_type(argname="argument honor_s_maxage", value=honor_s_maxage, expected_type=type_hints["honor_s_maxage"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument must_revalidate", value=must_revalidate, expected_type=type_hints["must_revalidate"])
            check_type(argname="argument revalidation_settings", value=revalidation_settings, expected_type=type_hints["revalidation_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if cacheability_settings is not None:
            self._values["cacheability_settings"] = cacheability_settings
        if cache_control_directives is not None:
            self._values["cache_control_directives"] = cache_control_directives
        if default_ttl is not None:
            self._values["default_ttl"] = default_ttl
        if enhanced_rfc_support is not None:
            self._values["enhanced_rfc_support"] = enhanced_rfc_support
        if expiration_settings is not None:
            self._values["expiration_settings"] = expiration_settings
        if honor_max_age is not None:
            self._values["honor_max_age"] = honor_max_age
        if honor_must_revalidate is not None:
            self._values["honor_must_revalidate"] = honor_must_revalidate
        if honor_no_cache is not None:
            self._values["honor_no_cache"] = honor_no_cache
        if honor_no_store is not None:
            self._values["honor_no_store"] = honor_no_store
        if honor_private is not None:
            self._values["honor_private"] = honor_private
        if honor_proxy_revalidate is not None:
            self._values["honor_proxy_revalidate"] = honor_proxy_revalidate
        if honor_s_maxage is not None:
            self._values["honor_s_maxage"] = honor_s_maxage
        if locked is not None:
            self._values["locked"] = locked
        if must_revalidate is not None:
            self._values["must_revalidate"] = must_revalidate
        if revalidation_settings is not None:
            self._values["revalidation_settings"] = revalidation_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cacheability_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        '''
        result = self._values.get("cacheability_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_control_directives(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        '''
        result = self._values.get("cache_control_directives")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_ttl(self) -> typing.Optional[builtins.str]:
        '''Set the ``MAX_AGE`` header for the cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        '''
        result = self._values.get("default_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enhanced_rfc_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        '''
        result = self._values.get("enhanced_rfc_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        '''
        result = self._values.get("expiration_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def honor_max_age(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        '''
        result = self._values.get("honor_max_age")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        '''
        result = self._values.get("honor_must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_cache(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request.

        Effectively, set the time to live ``ttl`` to zero seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        '''
        result = self._values.get("honor_no_cache")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        '''
        result = self._values.get("honor_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``private`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        '''
        result = self._values.get("honor_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_proxy_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        '''
        result = self._values.get("honor_proxy_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_s_maxage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        '''
        result = self._values.get("honor_s_maxage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin.

        If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        '''
        result = self._values.get("must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def revalidation_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        '''
        result = self._values.get("revalidation_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''The maximum time content may remain cached.

        Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93eda11f09e542bab09d15b75d05039dc6b1e1b746ea32a449cb2157aade370)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetCacheabilitySettings")
    def reset_cacheability_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheabilitySettings", []))

    @jsii.member(jsii_name="resetCacheControlDirectives")
    def reset_cache_control_directives(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheControlDirectives", []))

    @jsii.member(jsii_name="resetDefaultTtl")
    def reset_default_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultTtl", []))

    @jsii.member(jsii_name="resetEnhancedRfcSupport")
    def reset_enhanced_rfc_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedRfcSupport", []))

    @jsii.member(jsii_name="resetExpirationSettings")
    def reset_expiration_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationSettings", []))

    @jsii.member(jsii_name="resetHonorMaxAge")
    def reset_honor_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMaxAge", []))

    @jsii.member(jsii_name="resetHonorMustRevalidate")
    def reset_honor_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMustRevalidate", []))

    @jsii.member(jsii_name="resetHonorNoCache")
    def reset_honor_no_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoCache", []))

    @jsii.member(jsii_name="resetHonorNoStore")
    def reset_honor_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoStore", []))

    @jsii.member(jsii_name="resetHonorPrivate")
    def reset_honor_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorPrivate", []))

    @jsii.member(jsii_name="resetHonorProxyRevalidate")
    def reset_honor_proxy_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorProxyRevalidate", []))

    @jsii.member(jsii_name="resetHonorSMaxage")
    def reset_honor_s_maxage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorSMaxage", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMustRevalidate")
    def reset_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMustRevalidate", []))

    @jsii.member(jsii_name="resetRevalidationSettings")
    def reset_revalidation_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevalidationSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettingsInput")
    def cacheability_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheabilitySettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectivesInput")
    def cache_control_directives_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheControlDirectivesInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultTtlInput")
    def default_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "defaultTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupportInput")
    def enhanced_rfc_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enhancedRfcSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationSettingsInput")
    def expiration_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMaxAgeInput")
    def honor_max_age_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidateInput")
    def honor_must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoCacheInput")
    def honor_no_cache_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoStoreInput")
    def honor_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="honorPrivateInput")
    def honor_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidateInput")
    def honor_proxy_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorProxyRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorSMaxageInput")
    def honor_s_maxage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorSMaxageInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mustRevalidateInput")
    def must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="revalidationSettingsInput")
    def revalidation_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "revalidationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c17b65619e897de2a09fb5a18b87488dfc4a76df62641838c315a0c468bc4bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettings")
    def cacheability_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheabilitySettings"))

    @cacheability_settings.setter
    def cacheability_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ad05f8be0a4d456cc9a27ec0146ca71fb249679627a43adb8739d823ff72d70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheabilitySettings", value)

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectives")
    def cache_control_directives(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheControlDirectives"))

    @cache_control_directives.setter
    def cache_control_directives(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ceffcfaba5600f5264be09a8c813918bb0a35fe6e6c1935de95b9dd24936023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheControlDirectives", value)

    @builtins.property
    @jsii.member(jsii_name="defaultTtl")
    def default_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "defaultTtl"))

    @default_ttl.setter
    def default_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97d03980370ebbc9b9ce8365ac5b9efe8c672ee08bf01406bce1d0dfda71679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultTtl", value)

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupport")
    def enhanced_rfc_support(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enhancedRfcSupport"))

    @enhanced_rfc_support.setter
    def enhanced_rfc_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c9e2af945b92a5f2229815da1a02125da7e4f9513b73c9bda0e58604922d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enhancedRfcSupport", value)

    @builtins.property
    @jsii.member(jsii_name="expirationSettings")
    def expiration_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationSettings"))

    @expiration_settings.setter
    def expiration_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c4e5ff9dd3b25139ca3db4bd7f724e33c612adb3dd99c696ede631c55f00aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="honorMaxAge")
    def honor_max_age(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMaxAge"))

    @honor_max_age.setter
    def honor_max_age(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c76a07873470d48dccf7705d5b43fccc6a35adea898d1aa2f51c2960d511fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidate")
    def honor_must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMustRevalidate"))

    @honor_must_revalidate.setter
    def honor_must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b7a2871db555a3d630b63a789a9f74cce371caa90be30c0fe9da54a471ee3ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoCache")
    def honor_no_cache(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoCache"))

    @honor_no_cache.setter
    def honor_no_cache(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dbf2142ed95edd8917e695176b88f4586ce6dc31a82ba481acd2c3624ee881f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoCache", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoStore")
    def honor_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoStore"))

    @honor_no_store.setter
    def honor_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95de59bddca89318fd53f77705e143875eaa128d7a8b227e5718431834e3b1cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="honorPrivate")
    def honor_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorPrivate"))

    @honor_private.setter
    def honor_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2084fd7ce53c5657ae5734ce690ee9b89e64878f9290867311ddde71b58da93c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidate")
    def honor_proxy_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorProxyRevalidate"))

    @honor_proxy_revalidate.setter
    def honor_proxy_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ffe5a11ded1cb4fac9a270e08c0e6c300c630eea2e54487a681e4a97566fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorProxyRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorSMaxage")
    def honor_s_maxage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorSMaxage"))

    @honor_s_maxage.setter
    def honor_s_maxage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082648f4d1a646f736a154b1b5081c1ec29d0b216c9b89de80cba7cf53025b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorSMaxage", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbbb262504a6edbcb096fdb2263d3d840433685fe6ee46287acd7aadd2800ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mustRevalidate")
    def must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mustRevalidate"))

    @must_revalidate.setter
    def must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4f4d2eabae5bfa0b2886e0061f6c213eb3fd7c087cf11e6600e5a27d2a8215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="revalidationSettings")
    def revalidation_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "revalidationSettings"))

    @revalidation_settings.setter
    def revalidation_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c82ec42137e037d603ab52d7d6799c2d156dec2437f7859cf5cb79a2359d5da7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revalidationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6231f248d3be704af373b8a28f81ad49ae583e11380c03e39088bffb43f3b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4094513c64db173eeb5c370505ea851eceb5e167a47a5274a07d4f5c4b1433e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a4f2d185313dead9a3e2a81e6abc7d0c8f31c22c64ed455945efa1e36f14f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c820ec555fa8db3f36e331584b0f36f2afa717930f3f7c4d6e86b174fca8ba41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a60149a976f5fe83f4c10c33808238a6adf8ff1a0c5cc430ff384053c8ac82a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the centralized authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1febcbc901f389ee36cdb4d7daf76034ff786a5e0f19e7a56abb5a53f84484)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef2fab65e4f5cb59a04f186089702323e494b55e6da30921e2f06d2123e8bb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba9cae44a8b3e4a4562e3c6b494b2628ee0c8e102fb4ff38d25f059de3f78fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e521254d8be4428874348f902f3b980de3d19abf85acdb8228cdf6a3baa86e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8227b8b683349be60de8ac754afa196082b12dfe97f24eef66cf490345e8ac22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3572f19f30117992c431a0891de36b81dc70d0db5578740f8d3b5dd72e0c2158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "limit": "limit",
        "locked": "locked",
        "serve404": "serve404",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2151d15bc3ce6fb972f8086ba802b01b16d1af51fd91012d451eab179bc55285)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serve404", value=serve404, expected_type=type_hints["serve404"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if limit is not None:
            self._values["limit"] = limit
        if locked is not None:
            self._values["locked"] = locked
        if serve404 is not None:
            self._values["serve404"] = serve404
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to chase redirects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def limit(self) -> typing.Optional[builtins.str]:
        '''Specifies, as a string, the maximum number of redirects to follow.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serve404(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        '''
        result = self._values.get("serve404")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865db6063b080061d1689a88ab5eca9e061aae59fdfef93a0b218c8bbdbfdced)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServe404")
    def reset_serve404(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServe404", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serve404Input")
    def serve404_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "serve404Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344b2a43031983b8e383c355e786148b088e6eb6957346913d8772e7a74206f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766652c2d2758f13ce89be0829ca67c6eea71cce08ab8620a77514c73e1f111e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b40c5e641498a87a7db4c6efe3188a2ae7bd07c619414a970fb6cc8d570bd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serve404")
    def serve404(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "serve404"))

    @serve404.setter
    def serve404(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899bb4804ff5a91bce6c733ab68cae28740da7a6b3b755bf611b491c0e205808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serve404", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162792d741c4131c0c501d9c44d033ec2d3a05673f2803272c3de09d638bbd8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c77040a99eb524927ccef24d3b763b2778039fbcafcc13de95f3f5f9f8481e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a6952f9d0427a6bd3680249a5aed496debfc1535d83d0cb9045dbce3263655d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth",
    jsii_struct_bases=[],
    name_mapping={
        "client_certificate_attributes": "clientCertificateAttributes",
        "enable": "enable",
        "enable_client_certificate_validation_status": "enableClientCertificateValidationStatus",
        "enable_complete_client_certificate": "enableCompleteClientCertificate",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth:
    def __init__(
        self,
        *,
        client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param client_certificate_attributes: Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        :param enable: Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param enable_client_certificate_validation_status: Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        :param enable_complete_client_certificate: Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a56a79b0b00f720cd9c14d980e164e50712495d9b60d2478c51ed308db43f2d6)
            check_type(argname="argument client_certificate_attributes", value=client_certificate_attributes, expected_type=type_hints["client_certificate_attributes"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument enable_client_certificate_validation_status", value=enable_client_certificate_validation_status, expected_type=type_hints["enable_client_certificate_validation_status"])
            check_type(argname="argument enable_complete_client_certificate", value=enable_complete_client_certificate, expected_type=type_hints["enable_complete_client_certificate"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if client_certificate_attributes is not None:
            self._values["client_certificate_attributes"] = client_certificate_attributes
        if enable is not None:
            self._values["enable"] = enable
        if enable_client_certificate_validation_status is not None:
            self._values["enable_client_certificate_validation_status"] = enable_client_certificate_validation_status
        if enable_complete_client_certificate is not None:
            self._values["enable_complete_client_certificate"] = enable_complete_client_certificate
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def client_certificate_attributes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        '''
        result = self._values.get("client_certificate_attributes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin.

        You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_client_certificate_validation_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header.

        This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        '''
        result = self._values.get("enable_client_certificate_validation_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_complete_client_certificate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the complete client certificate in the header, in its binary (DER) format.

        DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        '''
        result = self._values.get("enable_complete_client_certificate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36caf20ea6af778ba04b5e434b60448c8e0beed8303e8d7f18a35a80308ee44e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetClientCertificateAttributes")
    def reset_client_certificate_attributes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificateAttributes", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetEnableClientCertificateValidationStatus")
    def reset_enable_client_certificate_validation_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableClientCertificateValidationStatus", []))

    @jsii.member(jsii_name="resetEnableCompleteClientCertificate")
    def reset_enable_complete_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCompleteClientCertificate", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAttributesInput")
    def client_certificate_attributes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "clientCertificateAttributesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableClientCertificateValidationStatusInput")
    def enable_client_certificate_validation_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableClientCertificateValidationStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCompleteClientCertificateInput")
    def enable_complete_client_certificate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCompleteClientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAttributes")
    def client_certificate_attributes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "clientCertificateAttributes"))

    @client_certificate_attributes.setter
    def client_certificate_attributes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9c738b72f9ad087845155b456895bcd94f72993d409b3f667e50e7f1fc804a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientCertificateAttributes", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e338121d12356ec94a68f486ce8eb7ca8c0070da4b7cc6d7ac8dd537a7d8b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="enableClientCertificateValidationStatus")
    def enable_client_certificate_validation_status(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableClientCertificateValidationStatus"))

    @enable_client_certificate_validation_status.setter
    def enable_client_certificate_validation_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b8df0101ab49fe5607a3bd63b83ee61dbb43040e310e47f800e09c0a7eda22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableClientCertificateValidationStatus", value)

    @builtins.property
    @jsii.member(jsii_name="enableCompleteClientCertificate")
    def enable_complete_client_certificate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCompleteClientCertificate"))

    @enable_complete_client_certificate.setter
    def enable_complete_client_certificate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406be6b5c34e089dfdefa89418bee1f398b4b0435294cc081d1fbefbea675472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCompleteClientCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cac67b8e3fe39a0054262803ea01ddc41859f5f155adcf21c049b1fdc397c261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1d951f4aa82ed5ca4874a5853a43fb1afb50d393592d9a43a407c4b4faad6ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bbe7704d6a1c6f7018f1367f88ca0f63b9a0457384c4ea9ff9a95f41882b8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__884138edb9643734cd82133d771b526b7b332296836cae3bcd56944bb6d3f4dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "country": "country",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics:
    def __init__(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c032e4e43ef9107e1e7bc11573adc859713817ea1af77b8d0ddb40e9b7fad3e)
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if country is not None:
            self._values["country"] = country
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the client request's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1cdeebcde7d98b9469677cf43bb166206201ed706920b8ddd1144c314511be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c0ce1bbada4e41b36645e6f147ac0c515ae040d32133b069a7e54190df71ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__285e2ad548a3ee3e04921427706b82271d1401c7ff9be0c263565769e234fe23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b19141e35b8c120432f6aea3e3a7da7d7bf51445124b596b4e6826d183227e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455d43a2060565ba457a2421838a16337a865de705792db8dc847ac574922592)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4e8511629ae28564073bcedcc6377c4844100af15a92e5c35f9c9eff79bc197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects",
    jsii_struct_bases=[],
    name_mapping={
        "cloud_locations": "cloudLocations",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects:
    def __init__(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a398fcf50f4df48effa80d28175acb7658d3eab288616821234e0980eb075bb)
            check_type(argname="argument cloud_locations", value=cloud_locations, expected_type=type_hints["cloud_locations"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloud_locations is not None:
            self._values["cloud_locations"] = cloud_locations
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloud_locations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the geographical locations of your cloud origin.

        You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        '''
        result = self._values.get("cloud_locations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Channels the traffic to maximize the egress discount at the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900a34f13e53f5d4f066b25e11874cf380c24b82c8b577eef7c5a7bb172c9999)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudLocations")
    def reset_cloud_locations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudLocations", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudLocationsInput")
    def cloud_locations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cloudLocationsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudLocations")
    def cloud_locations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cloudLocations"))

    @cloud_locations.setter
    def cloud_locations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d88a2eca48ab648cff32d62eba44418bd26278f02a4e7d67a4a73fc1642062da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudLocations", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4a29ea161ec1079a91720e4fe56ac63140052e7cb488e1d21aa24fd8e11011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257df3c5f891c451dc11e1525c64b6185e694aa5bcc5144f34db315195f89203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475c7a08579085b6db317bc7a38b94d0569ce0777cd82b9ee2f8ef4ba28b7b88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd472a437b09be658ac2320fed734dcb9cd8d026019175de63a22c4b04d440e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8d84d20186717f13f5d11be7f502944744671f5788a5f75f77a0a5d8441ac72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "location": "location",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f52443d734b5f55eb1e7ca32e979196dbce8d2d0f0cf32db3821990e2b20f17)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Wrapper behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''The location you want to distribute your Cloud Wrapper cache space to.

        This behavior allows all locations configured in your Cloud Wrapper configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "custom_failover_map": "customFailoverMap",
        "enabled": "enabled",
        "failover_map": "failoverMap",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced:
    def __init__(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721e8d17cc944b3a781fc7f3241bc463a11190146f1587a42fd13392811178e7)
            check_type(argname="argument custom_failover_map", value=custom_failover_map, expected_type=type_hints["custom_failover_map"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_map", value=failover_map, expected_type=type_hints["failover_map"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_failover_map is not None:
            self._values["custom_failover_map"] = custom_failover_map
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_map is not None:
            self._values["failover_map"] = failover_map
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        '''
        result = self._values.get("custom_failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables failover for Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        '''
        result = self._values.get("failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530371cf566b55b9f958d162ed376dfe20addb3f9a9cc7a9173802aa5770b511)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomFailoverMap")
    def reset_custom_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomFailoverMap", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverMap")
    def reset_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMap", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMapInput")
    def custom_failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customFailoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverMapInput")
    def failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMap")
    def custom_failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customFailoverMap"))

    @custom_failover_map.setter
    def custom_failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b5d68faca9e23a9af231d8d8e6f3869448a9beae0b2a84e9178f65b8ed3d02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customFailoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e01f75208a853e586064ca0076e8b86ddd78d66b0371de9da4d4de7594231d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMap")
    def failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMap"))

    @failover_map.setter
    def failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f064a2b94d9609d0d2d53f51f2987cd652f57b578129c893c240e435939137b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5132b67cfad9cb65ec94a61b9332d01d80e5625245f3c0274a5846241f21b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dcc2671844ed600b7ae602c4e244d124d714c22e7e4e0f3c87a016c5835d43b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a3087cb2db066b3ad1c4b8401a71c700af325208956c7ff714be486614977b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__384305faecf9f6880d2180e60d4834422bbe0daf73ba71898e11d410ef70929f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d0273086882a88b81c45d7dc43c2ccaa270ee724a17e5c52056ed32b4fd87c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e09f0922b966113a57a28274aba1e167c4f1941582046c528067924b0af92c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55a5afa9f37c238a4734b0d987fe5871ced1a5acef4ede822ed61002ab42f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27b6cbd8fbc18dd4d11805bc2209596d575361ee1913216021795d7b99c7575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80869f4f700e51728eb7c10fddca8e29c40e4bccdc06a573bd50da17864c34f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f45077f92b5d8479ee0abee85102f4a9161b19757a97d471f3052943f35ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ea4f0f73e66bb5562a809dc8d23702ee69978ecbac1fc166ea0f7501bddbf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData",
    jsii_struct_bases=[],
    name_mapping={
        "enable_cmcd_segment_prefetch": "enableCmcdSegmentPrefetch",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData:
    def __init__(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270087c20660b9f333ee67622b5543aa6c3c1413b01a5f73df552a00b2d037a1)
            check_type(argname="argument enable_cmcd_segment_prefetch", value=enable_cmcd_segment_prefetch, expected_type=type_hints["enable_cmcd_segment_prefetch"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_cmcd_segment_prefetch is not None:
            self._values["enable_cmcd_segment_prefetch"] = enable_cmcd_segment_prefetch
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        '''
        result = self._values.get("enable_cmcd_segment_prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientDataOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientDataOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cf7f9f181ef7bca40da02b7b992429b206fdb5f876d21e0defca9ec158705ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableCmcdSegmentPrefetch")
    def reset_enable_cmcd_segment_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCmcdSegmentPrefetch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetchInput")
    def enable_cmcd_segment_prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCmcdSegmentPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetch")
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCmcdSegmentPrefetch"))

    @enable_cmcd_segment_prefetch.setter
    def enable_cmcd_segment_prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4da28ea1809ac6196dd8a1572375597628b1320c0adf359cb796e494be6b34ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCmcdSegmentPrefetch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c831879ed2fc968161228392a2995e9d31ab23929f8c994a89888e438e94d028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a7f4a30f21325b3cb818bbad6b37d26bc6706499a8063d0f27410de68e319d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1544b2463af228e5900ed7e0aeb2da0940fa340e97f96e497e0e9d8be6b45ef7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8596ce816b5d57d81e6515e86a82b432b7f70038d0aa98a8299d774387174f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f1701bcb13b30286440ae50569a70ca8b27533eefbbf5e4701a9d0ae176dc3c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.'''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e01772fc9f443f85f8887475aa3fa7837dfc28c413c30814149af6c4339fb35a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fbb4ac9be3a4397ff9a02335abc742982ecb94228d749ec1ce668d9dc966ff0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b57b115a1dc8df4d6dcfe4e9381d4acc879c1978c36f5ecc2da40a344b801e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246b8e9ec46b0ca72b92d412aef9134ee5caaf99019c22f089e3a6cd837151d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0053523e5a1b814738daa9018035f2aa033da6bc036cc481e09adc86973f6ae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__960479f717e1ab8ebf900c613b81ba6f28e55474b43300a8c9f195aec87fdc8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse",
    jsii_struct_bases=[],
    name_mapping={
        "body": "body",
        "enabled": "enabled",
        "force_eviction": "forceEviction",
        "ignore_purge": "ignorePurge",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse:
    def __init__(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cccb9b3139530b901296f27943f4480d326384cbe8d37e124bea0f63e8f29e1f)
            check_type(argname="argument body", value=body, expected_type=type_hints["body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_eviction", value=force_eviction, expected_type=type_hints["force_eviction"])
            check_type(argname="argument ignore_purge", value=ignore_purge, expected_type=type_hints["ignore_purge"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if body is not None:
            self._values["body"] = body
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_eviction is not None:
            self._values["force_eviction"] = force_eviction
        if ignore_purge is not None:
            self._values["ignore_purge"] = ignore_purge
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def body(self) -> typing.Optional[builtins.str]:
        '''HTML response of up to 2000 characters to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        '''
        result = self._values.get("body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Serves the custom response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_eviction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        '''
        result = self._values.get("force_eviction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_purge(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to ignore the custom response when purging.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        '''
        result = self._values.get("ignore_purge")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP response code to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__650884d181519ab3385f0eb614e6385d776fd0f0e16ca66bd4bc29d5b2890c4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBody")
    def reset_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceEviction")
    def reset_force_eviction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceEviction", []))

    @jsii.member(jsii_name="resetIgnorePurge")
    def reset_ignore_purge(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnorePurge", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bodyInput")
    def body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceEvictionInput")
    def force_eviction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceEvictionInput"))

    @builtins.property
    @jsii.member(jsii_name="ignorePurgeInput")
    def ignore_purge_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignorePurgeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="body")
    def body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "body"))

    @body.setter
    def body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0110a3ae468bb52a69b0dce9cae558c5b8a04133f6c49a060313709735776498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "body", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0417756705ab3f2374b61313475841a63852c1641aa3afc7ca8d287fdd57e760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceEviction")
    def force_eviction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceEviction"))

    @force_eviction.setter
    def force_eviction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0789361ac9e1f2e80d2c268992643d89cbeb0bde05e25752445913a3cd75d0de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceEviction", value)

    @builtins.property
    @jsii.member(jsii_name="ignorePurge")
    def ignore_purge(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignorePurge"))

    @ignore_purge.setter
    def ignore_purge(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662a0fd44d0bb84d350d8b69689ed68ba5c4e1c3b25882245470e434e44fd289)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignorePurge", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c11dda646aa7895565f7440e52fe17bf69997f728f9bcd560a30d47865c24ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1633fe61841c57954ddcc3aaa047e0282ae909766cb38c3dce760ce48dfdc404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e35c9d633d0e550a29cd563d793d7125d8d040dd6b1f007ec5c9a7d1f262a7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e68bc930c358c5f11e0d5d7d16dc38385cd6457d61521d2afa5721a7583ebe42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb9f492e06bb44d022a70720c7e581cfb46d32af6f59c223626d9c74c69a195)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d037c811f2205d70c3b107cd22dfd2c58b4de5cd82dee63efc78ed709a50bbc)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_dash_custom": "segmentDurationDashCustom",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hds_custom": "segmentDurationHdsCustom",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_hls_custom": "segmentDurationHlsCustom",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_duration_smooth_custom": "segmentDurationSmoothCustom",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d76a77784112a8d40ae4b0e09afec99482b1a406ca90ba03b7532a007581fa63)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_dash_custom", value=segment_duration_dash_custom, expected_type=type_hints["segment_duration_dash_custom"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hds_custom", value=segment_duration_hds_custom, expected_type=type_hints["segment_duration_hds_custom"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_hls_custom", value=segment_duration_hls_custom, expected_type=type_hints["segment_duration_hls_custom"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_duration_smooth_custom", value=segment_duration_smooth_custom, expected_type=type_hints["segment_duration_smooth_custom"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_dash_custom is not None:
            self._values["segment_duration_dash_custom"] = segment_duration_dash_custom
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hds_custom is not None:
            self._values["segment_duration_hds_custom"] = segment_duration_hds_custom
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_hls_custom is not None:
            self._values["segment_duration_hls_custom"] = segment_duration_hls_custom
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_duration_smooth_custom is not None:
            self._values["segment_duration_smooth_custom"] = segment_duration_smooth_custom
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        '''
        result = self._values.get("segment_duration_dash_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        '''
        result = self._values.get("segment_duration_hds_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        '''
        result = self._values.get("segment_duration_hls_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        '''
        result = self._values.get("segment_duration_smooth_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123137483c93f99dfccc46fd56b0028792fc2811573e3f5b769fec9d8a5b1ad9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationDashCustom")
    def reset_segment_duration_dash_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDashCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHdsCustom")
    def reset_segment_duration_hds_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHdsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationHlsCustom")
    def reset_segment_duration_hls_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHlsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentDurationSmoothCustom")
    def reset_segment_duration_smooth_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmoothCustom", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustomInput")
    def segment_duration_dash_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationDashCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustomInput")
    def segment_duration_hds_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHdsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustomInput")
    def segment_duration_hls_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHlsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustomInput")
    def segment_duration_smooth_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationSmoothCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c720ac00fa9414a437e223d5c12f9bad61a057a64804a3421a076c5b4b904789)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c1becd2143caf387a5a8e6d8e0591cbc80d54cbae46af6cfa25628319aae92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a88f83b980906335d23fdecfea793b36bd8ee70015d15bd4d98ca2c419d37f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__696b9c4c58fca8330add69f123feeeacc33adf9af524b0e813155de74149490e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caacdaafce3798bc67c2e7d58ca2a8848b4b862280f615db3440a81fd57ecd73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13f870ab04d52d0aab6f37d865fc8051e98f25f3d814160332891a3787fc7586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f41be4867444fe8e76581c1ac49a773ed9cec3668c7d6fab456cf599af7e2ed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe564902b997b5db9e5786294716e85bb280af23c6b7ae5976b72612773b5c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustom")
    def segment_duration_dash_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationDashCustom"))

    @segment_duration_dash_custom.setter
    def segment_duration_dash_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753dc13a0e94a1dd8b33cc777bedda77728ea4d25529b8062543c4a924fd0462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDashCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d13e841646bd460ec6c5968598d8b12c8e3583d4c7851854f3bac72e76ad7e5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustom")
    def segment_duration_hds_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHdsCustom"))

    @segment_duration_hds_custom.setter
    def segment_duration_hds_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60a2e8ae750adc2a45d979f69ff3270eddb05aded49eb7d075668f090c9d44da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHdsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902ed1b8832070495dbd9934440916fdf7ddc89b33b3cc24b29b25ad3b6cb869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustom")
    def segment_duration_hls_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHlsCustom"))

    @segment_duration_hls_custom.setter
    def segment_duration_hls_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78562adfbf4ebf56a9fd42e8fd8dc2cf6de5577032d649dd0ef079a0e0dfd28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHlsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9605b53c10fe947a01e605546738ef802c93c21d8e6635504ccd6bd7ec7be5f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustom")
    def segment_duration_smooth_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationSmoothCustom"))

    @segment_duration_smooth_custom.setter
    def segment_duration_smooth_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1aaedcf8477cc4e49c0f258b0bf6bd44caf192ae5b0abc46091315b66d9151f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmoothCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abe2acef2ad7849362511a74844ebccd9f6019cff76414a373f41d7375927b03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff383f3bab7863249d1332bbf4934c156696c1dfddc1f704f524fce7f1f13169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c753e056fe427a7ef51c7f423e750c0a094bb511feb6e6e39cd6f0455f0d8be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f418c62ea949289434dccc3883e948c61c983b67e8ea2830ca2dcdb58d8d98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7014ec57d9e4fd56f953ad93bbf22d46b731ad3824fd7440530727fa5d208b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50bd4ccd5fb861d00e5eea92e052be1aee6e63b4f162f552c8f38b367790087f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b25581e84ddf8443a6d3df0ab5de9130e300322664028d2aa5e7e5aaecc05ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4be55bf46e3d318f6599823dc7193fd80397e7c9b24ccd28784f328f37c43e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "optimize_option": "optimizeOption",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f462987cd04f48c61058ad7ff9573e42ea95192668a5c367d9538da0cbc2a760)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_option", value=optimize_option, expected_type=type_hints["optimize_option"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_option is not None:
            self._values["optimize_option"] = optimize_option
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_option(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes the delivery throughput and download times for large files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        '''
        result = self._values.get("optimize_option")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71bf47c78be8a5770cb25b70efd7deafcadd4a33d70583cdfac4ce6f184d440c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeOption")
    def reset_optimize_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeOption", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeOptionInput")
    def optimize_option_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optimizeOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66cc7e0819b652a4e977f84b897c0c51a04b6a06781428a4364adf727a11fbec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a47f219f6e3cd9b5d47b8510222bfcd26a6c58269768b5b3156e6dbf9412bfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff444261cdbfe2491e8b306a9c0a0cba2f12a281469e886a662fc507677f436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b93eda8c5354b46dd9a994f5fff916d0d98c159a710cd187c10eed2ccd8f7030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeOption")
    def optimize_option(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optimizeOption"))

    @optimize_option.setter
    def optimize_option(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db267b3921ebc81c517d061a675ba0ea8127e592e703a78037883220868f357d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeOption", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4d641928f8d6c46212dc822e3bd1fd32ef42675c9ac977d3c1081d58c7e4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2946b678e29866ce4b23334c1876faa5c12359c3b0e9a39cc4ccf2ce8bf089b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__152af1970659e8e2b5d8b5d985017d47384591680c317c306f5166ce64cec840)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3619d1881c05e8d70cd0916b7585a7d0090dcb464bfbf0a0b7a337de1d36743c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980c8027111766bd1158f43b23266b65c4b53fc21225041fadd7a67c19ec976d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99aa1161fe67980ea177c19e1e114255c711608e2d7b357ca340714681f8d1f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5237b9b33a6d2a84bda68a4ff8aedf8559d2781d29bc472b21367880ec460100)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebcd0c8baf5990f421d47d4cb5806536752570b8225cdb8dc5c6777a12c8aa26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3757e75a0156ee3918611e00b9409b84a1156ea545ad992771111a9c48079e89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9f796662c3c153bdce546d33166cc35144d0c013d69b53e7c041e21483ea25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674fac49b06c3ef0f8d38a178c7efc2516c1dddc3902a1daa52f347738664e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99a381610236207eef61684ef2117c33a51f73ce02e1147ec2d983859aa78b0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__744e3f9c37fe552fc41f214fce30d57219998bff635d9b2c1a86140c18ba268c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5a1b382c256ba93766dddb99fd13e02f5d0a295894b485184e67d3610a0a7b5)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFileOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFileOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1831fb716f961950943c6ab4a19f8208c54cf2f4a02012406dd283d84f56222e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303cd0820e0d58d8ce03d9d5b99e43b848e4b3409ef393b70f03f1c6668c0652)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8691804dc7da37745b4df9f8abc51946c59a5717ebaa6cd4c7a8f313ed2e0a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fdad3adb9f86b78e7a71f0788d10ecce8ccf9d135846eef5ec129a6444e01bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f145e2c14d0a77fca55b4e1ab209a5a278e42e25640df99253ef02715912c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__659a9042b8d9252f06130cc3f1a9028e95b24afbb429cae63962e1dfea25cce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76fa1f3dc4c9666e32a856744d140462aa38f0c12d5c992c0757119752f104f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071e3e2ec1b9be8803c6b810adbe0ef0d085e5ad36a9696caf5822659fe39b4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9342b870a89bc6c6490d8b8496b0a1ae5929f683a98f89bfaca456158672402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44fb82059656a86973dc719e16d8a52846d14550ad9daeb6fd2f0ebfc9e01cd4)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLiveOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLiveOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c4e978172e4908f6dc302323604a6ce3287150f189d77742482e83ba72153db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e60fa28046feda32de8664e2d068508defcf6a2661cff4ec174d3f5d699bee6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f25fe92cfcd8b74af837946b85bd099c284f995215b001029857b4554551ad28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6981782cee3ad6120731de1cb4789c5f3a49676746b8bb19117627435e13b9a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d059703c431efe3e6054e9f3c33af69c7f419d399a3406ad9b079badb07530f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d50408dfcc07f57dab49951a66df60265e9b30d5e7ac7ed42deb4fc80c587f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b37f6e849176f89a5c834a7a6119a409f58d6b1bc5943cedfcef0808ae7a6f52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69184091e94aec1643321d71647ef5fa95b747f8465cad6367076ef6da4f4aae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cace39cb275974f6c3551bf35939888a143c65c2a4614a928adacb227e0abf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaffc01cd30852a7cdeadc62b2287442d8993726da18387cf432b1db2ca410aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26412c4fff9adba6c12156956d9fa28b3ca99c070a2f21daaac24df27bdd0b2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68ed08bc42bb7cbbf7c3f1b47e0f46ab3d0adc4ab554607cb360f181d7334077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9da4bdac58f7bb89daf646428fd02ffad838580e13e337f29ae920bef1c6199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eaf717e44a50c169b01d152e8bbde792d646a120b741e52804da4db1e89d079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2824c7fccc82f244a0c0107fbc6b021b39839eb4bc392f906a41d747dff0fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7ad661ea91a61ff08c41a09dd8c352e09585a6e0749c3d27f16b7015170cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7ca0ac561a1fc6c878fbe7945a5e2338d99fa96735b345d3a09701019c8570)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1fae5253f13bab11d758faf50c133aa06bd78a4127f606536f39fd93a30ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b935e65286584afa332afd989a9cac64ca0f9ced7f8774e548199f344e6db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9087410bec061a6390508c13a85b8e03771f5ea0b7b7f30ff85baa0b9f7f0a9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc60c7c53ba1512330c8021ea9c2f29cab37147e6c9f4c922c9a8afe0ab05d61)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55247d5d0b87cedde9d96bb8072845dc540011dd3d97238b85f4e85167651b65)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd731943c262554355330eb864cbd80b5f99f27b5a45d79932890efa31909bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c94848ce688a29c0706c011568f99ecdb04cb1a3fa0e1655c567319c0b45cdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96855a92ac3675f21c47378698c97781c58da0b31415d212e6e3cdee259afa42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9ab8377f4814a4f993c927e009f58da78d3727ba39c03edd5a7a9efc824677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff8ff2bd8bf214a1b548fcba92d70c7f34dc0f94d01304c602a8458f95cdd76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f64531893e4843154ad57516e89b4bdd4d62f29bbacb702e2da014d3743e8e5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69fe48dad623840131a92601a5ad5bd95efe43f0b5e299a70794bc173edb9077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd26a3f37be9060d20858a50be5cda565a7186426a9630888d96057f5fa10b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b17985a1c040664ed5bd5daaeee39e38e133ec3221eef08d1c2b7dadc7dfcbfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b428a136c79fd6fc1a6c536926d6663e7800f6167d73064eb3aa2a972036b59a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a48039ea00eed205cfc5acf7c108a278f03c73abae2b732052a450eaab3bc6de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99d0193385c4c3f7f7f962adb35669fb0df4607dbe10a4db381c63355d1ec7af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a7b04d0a68e5efedd93839cd83e1cf3a419d8dee8f35d82cc5b411828f4ff6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2919e65b1d1114d2eb3aef148292d2bd76c240adf633757cc90ab4087bcc808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__854abd49dc299e547c98a031eec92ffdf2f810602aa05458acc7f1a2feff08de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6e65fbe4228099a5cf553c6c9efe2d6f794ba86913aaaea50b1ff692a8c25c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf9727223d0d9dfd7667edbeae8b938ea34f7afd336da40dc45e8aaaf7700ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9b46b265aebf2102dbe870b480a2fc81d1adcd20b7c413ed4b24d1507675fce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__802a50ba88e78187961fa4a55e7f124f804e82a1860ff511fe6dd5ab1fe2260f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "first_location": "firstLocation",
        "locked": "locked",
        "second_location": "secondLocation",
        "source_type": "sourceType",
        "targets": "targets",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb27cf4112dd306e6ca2ddc9959baa1f6c076e54fb1c60c4615d0c624e567be0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument first_location", value=first_location, expected_type=type_hints["first_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument second_location", value=second_location, expected_type=type_hints["second_location"])
            check_type(argname="argument source_type", value=source_type, expected_type=type_hints["source_type"])
            check_type(argname="argument targets", value=targets, expected_type=type_hints["targets"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if first_location is not None:
            self._values["first_location"] = first_location
        if locked is not None:
            self._values["locked"] = locked
        if second_location is not None:
            self._values["second_location"] = second_location
        if source_type is not None:
            self._values["source_type"] = source_type
        if targets is not None:
            self._values["targets"] = targets
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content PrePosition behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def first_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.'''
        result = self._values.get("first_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def second_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.'''
        result = self._values.get("second_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def source_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.'''
        result = self._values.get("source_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def targets(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.'''
        result = self._values.get("targets")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePositionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePositionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71732527b9d280dba3d59a81a3096fc6c4bee1026abed12046c8c2aa0e8cf8af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFirstLocation")
    def reset_first_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondLocation")
    def reset_second_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondLocation", []))

    @jsii.member(jsii_name="resetSourceType")
    def reset_source_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSourceType", []))

    @jsii.member(jsii_name="resetTargets")
    def reset_targets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargets", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="firstLocationInput")
    def first_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "firstLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondLocationInput")
    def second_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceTypeInput")
    def source_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="targetsInput")
    def targets_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4926e317ba91c4a98a928ba7cc08bf206ee9d2d4d522635870ca1956f4e8ccd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="firstLocation")
    def first_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "firstLocation"))

    @first_location.setter
    def first_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__753096abb1465aa1e28b76e9e431a7fd27ca7e66498f7a67bd46f8a82ec9a92d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "firstLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a86e3242ab286c30ce08bc2ceb849f49c66d66c5d8c66be5bd14a1da78ac645e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondLocation")
    def second_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondLocation"))

    @second_location.setter
    def second_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba86c7c1ad84daf484f5385ee3a80737d45a0497d4dd0edd0ee113be442c483f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondLocation", value)

    @builtins.property
    @jsii.member(jsii_name="sourceType")
    def source_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sourceType"))

    @source_type.setter
    def source_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be179966e7225ef7a4c0d014962b23af52ea7cfccdb0561815ba4a83cba604f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sourceType", value)

    @builtins.property
    @jsii.member(jsii_name="targets")
    def targets(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targets"))

    @targets.setter
    def targets(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c37c93ed8d7957246c5ec8ec8a67aa2e83f79ce5e3f4ceb3dd58dbac257d5860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targets", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73184937b22e539c20303422d8608fcbfb8cf1033f3e0a4b119bd02c54293452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0be1fa36f4e0ec52a6bc2b0de48f23658712733a5676f2882d93be13422d740)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37296f7418f8d7fc07c3aca12377906c6cab80b9d3670359085aca9697092a3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection",
    jsii_struct_bases=[],
    name_mapping={
        "countries": "countries",
        "dmas": "dmas",
        "enabled": "enabled",
        "enable_geo_protection": "enableGeoProtection",
        "enable_geo_redirect_on_deny": "enableGeoRedirectOnDeny",
        "enable_ip_protection": "enableIpProtection",
        "enable_ip_redirect_on_deny": "enableIpRedirectOnDeny",
        "enable_referrer_protection": "enableReferrerProtection",
        "enable_referrer_redirect_on_deny": "enableReferrerRedirectOnDeny",
        "geo_protection_mode": "geoProtectionMode",
        "geo_protection_title": "geoProtectionTitle",
        "geo_redirect_url": "geoRedirectUrl",
        "ip_addresses": "ipAddresses",
        "ip_protection_mode": "ipProtectionMode",
        "ip_protection_title": "ipProtectionTitle",
        "ip_redirect_url": "ipRedirectUrl",
        "locked": "locked",
        "override_ip_addresses": "overrideIpAddresses",
        "referrer_domains": "referrerDomains",
        "referrer_protection_mode": "referrerProtectionMode",
        "referrer_protection_title": "referrerProtectionTitle",
        "referrer_redirect_url": "referrerRedirectUrl",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection:
    def __init__(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dcccb7d95fbe3c15a60aabc4b3835b01a6bffcafc0afaabc54323d179127765)
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument dmas", value=dmas, expected_type=type_hints["dmas"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_geo_protection", value=enable_geo_protection, expected_type=type_hints["enable_geo_protection"])
            check_type(argname="argument enable_geo_redirect_on_deny", value=enable_geo_redirect_on_deny, expected_type=type_hints["enable_geo_redirect_on_deny"])
            check_type(argname="argument enable_ip_protection", value=enable_ip_protection, expected_type=type_hints["enable_ip_protection"])
            check_type(argname="argument enable_ip_redirect_on_deny", value=enable_ip_redirect_on_deny, expected_type=type_hints["enable_ip_redirect_on_deny"])
            check_type(argname="argument enable_referrer_protection", value=enable_referrer_protection, expected_type=type_hints["enable_referrer_protection"])
            check_type(argname="argument enable_referrer_redirect_on_deny", value=enable_referrer_redirect_on_deny, expected_type=type_hints["enable_referrer_redirect_on_deny"])
            check_type(argname="argument geo_protection_mode", value=geo_protection_mode, expected_type=type_hints["geo_protection_mode"])
            check_type(argname="argument geo_protection_title", value=geo_protection_title, expected_type=type_hints["geo_protection_title"])
            check_type(argname="argument geo_redirect_url", value=geo_redirect_url, expected_type=type_hints["geo_redirect_url"])
            check_type(argname="argument ip_addresses", value=ip_addresses, expected_type=type_hints["ip_addresses"])
            check_type(argname="argument ip_protection_mode", value=ip_protection_mode, expected_type=type_hints["ip_protection_mode"])
            check_type(argname="argument ip_protection_title", value=ip_protection_title, expected_type=type_hints["ip_protection_title"])
            check_type(argname="argument ip_redirect_url", value=ip_redirect_url, expected_type=type_hints["ip_redirect_url"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_ip_addresses", value=override_ip_addresses, expected_type=type_hints["override_ip_addresses"])
            check_type(argname="argument referrer_domains", value=referrer_domains, expected_type=type_hints["referrer_domains"])
            check_type(argname="argument referrer_protection_mode", value=referrer_protection_mode, expected_type=type_hints["referrer_protection_mode"])
            check_type(argname="argument referrer_protection_title", value=referrer_protection_title, expected_type=type_hints["referrer_protection_title"])
            check_type(argname="argument referrer_redirect_url", value=referrer_redirect_url, expected_type=type_hints["referrer_redirect_url"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if countries is not None:
            self._values["countries"] = countries
        if dmas is not None:
            self._values["dmas"] = dmas
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_geo_protection is not None:
            self._values["enable_geo_protection"] = enable_geo_protection
        if enable_geo_redirect_on_deny is not None:
            self._values["enable_geo_redirect_on_deny"] = enable_geo_redirect_on_deny
        if enable_ip_protection is not None:
            self._values["enable_ip_protection"] = enable_ip_protection
        if enable_ip_redirect_on_deny is not None:
            self._values["enable_ip_redirect_on_deny"] = enable_ip_redirect_on_deny
        if enable_referrer_protection is not None:
            self._values["enable_referrer_protection"] = enable_referrer_protection
        if enable_referrer_redirect_on_deny is not None:
            self._values["enable_referrer_redirect_on_deny"] = enable_referrer_redirect_on_deny
        if geo_protection_mode is not None:
            self._values["geo_protection_mode"] = geo_protection_mode
        if geo_protection_title is not None:
            self._values["geo_protection_title"] = geo_protection_title
        if geo_redirect_url is not None:
            self._values["geo_redirect_url"] = geo_redirect_url
        if ip_addresses is not None:
            self._values["ip_addresses"] = ip_addresses
        if ip_protection_mode is not None:
            self._values["ip_protection_mode"] = ip_protection_mode
        if ip_protection_title is not None:
            self._values["ip_protection_title"] = ip_protection_title
        if ip_redirect_url is not None:
            self._values["ip_redirect_url"] = ip_redirect_url
        if locked is not None:
            self._values["locked"] = locked
        if override_ip_addresses is not None:
            self._values["override_ip_addresses"] = override_ip_addresses
        if referrer_domains is not None:
            self._values["referrer_domains"] = referrer_domains
        if referrer_protection_mode is not None:
            self._values["referrer_protection_mode"] = referrer_protection_mode
        if referrer_protection_title is not None:
            self._values["referrer_protection_title"] = referrer_protection_title
        if referrer_redirect_url is not None:
            self._values["referrer_redirect_url"] = referrer_redirect_url
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def dmas(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of Designated Market Area codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        '''
        result = self._values.get("dmas")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content Targeting feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, verifies IP addresses are unique to specific geographic regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        '''
        result = self._values.get("enable_geo_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        '''
        result = self._values.get("enable_geo_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to control access to your content from specific sets of IP addresses and CIDR blocks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        '''
        result = self._values.get("enable_ip_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        '''
        result = self._values.get("enable_ip_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        '''
        result = self._values.get("enable_referrer_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        '''
        result = self._values.get("enable_referrer_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        '''
        result = self._values.get("geo_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        '''
        result = self._values.get("geo_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        '''
        result = self._values.get("geo_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks to allow or deny.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        '''
        result = self._values.get("ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def ip_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        '''
        result = self._values.get("ip_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        '''
        result = self._values.get("ip_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        '''
        result = self._values.get("ip_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        '''
        result = self._values.get("override_ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of domains from which to allow or deny traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        '''
        result = self._values.get("referrer_domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specify the action to take.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        '''
        result = self._values.get("referrer_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        '''
        result = self._values.get("referrer_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        '''
        result = self._values.get("referrer_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1559ed8dded8b82d36536ca0f6de0b6197570b599aa2e09ed349d14004bc2e0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetDmas")
    def reset_dmas(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDmas", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableGeoProtection")
    def reset_enable_geo_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoProtection", []))

    @jsii.member(jsii_name="resetEnableGeoRedirectOnDeny")
    def reset_enable_geo_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableIpProtection")
    def reset_enable_ip_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpProtection", []))

    @jsii.member(jsii_name="resetEnableIpRedirectOnDeny")
    def reset_enable_ip_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableReferrerProtection")
    def reset_enable_referrer_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerProtection", []))

    @jsii.member(jsii_name="resetEnableReferrerRedirectOnDeny")
    def reset_enable_referrer_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerRedirectOnDeny", []))

    @jsii.member(jsii_name="resetGeoProtectionMode")
    def reset_geo_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionMode", []))

    @jsii.member(jsii_name="resetGeoProtectionTitle")
    def reset_geo_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionTitle", []))

    @jsii.member(jsii_name="resetGeoRedirectUrl")
    def reset_geo_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoRedirectUrl", []))

    @jsii.member(jsii_name="resetIpAddresses")
    def reset_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAddresses", []))

    @jsii.member(jsii_name="resetIpProtectionMode")
    def reset_ip_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionMode", []))

    @jsii.member(jsii_name="resetIpProtectionTitle")
    def reset_ip_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionTitle", []))

    @jsii.member(jsii_name="resetIpRedirectUrl")
    def reset_ip_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpRedirectUrl", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideIpAddresses")
    def reset_override_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideIpAddresses", []))

    @jsii.member(jsii_name="resetReferrerDomains")
    def reset_referrer_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerDomains", []))

    @jsii.member(jsii_name="resetReferrerProtectionMode")
    def reset_referrer_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionMode", []))

    @jsii.member(jsii_name="resetReferrerProtectionTitle")
    def reset_referrer_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionTitle", []))

    @jsii.member(jsii_name="resetReferrerRedirectUrl")
    def reset_referrer_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerRedirectUrl", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="dmasInput")
    def dmas_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "dmasInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtectionInput")
    def enable_geo_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDenyInput")
    def enable_geo_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpProtectionInput")
    def enable_ip_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDenyInput")
    def enable_ip_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtectionInput")
    def enable_referrer_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDenyInput")
    def enable_referrer_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionModeInput")
    def geo_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitleInput")
    def geo_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrlInput")
    def geo_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAddressesInput")
    def ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "ipAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionModeInput")
    def ip_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitleInput")
    def ip_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrlInput")
    def ip_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddressesInput")
    def override_ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "overrideIpAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerDomainsInput")
    def referrer_domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "referrerDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionModeInput")
    def referrer_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitleInput")
    def referrer_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrlInput")
    def referrer_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ebd11120aa232a6fec8d9ff5eb086353a33e8f3ab98d2944b47e22f22dda193)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="dmas")
    def dmas(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "dmas"))

    @dmas.setter
    def dmas(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd5ab7c6313f881e8150c4847b93d5d6a3e8ed331eab8fc64256b373da0c21d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dmas", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1085f4c03b154d0ed8511234ea5f86b083d711b1d4bbfb7b7da5fe62ae9275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtection")
    def enable_geo_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoProtection"))

    @enable_geo_protection.setter
    def enable_geo_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6430f5e866fe9f271893cb3d9f11a28207257f25bfe6a7c8d98ab65d26512aab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDeny")
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoRedirectOnDeny"))

    @enable_geo_redirect_on_deny.setter
    def enable_geo_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__349c264b0e07acfdffba03e1520a33352cf9a032044220227a3aaa7dc073d190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpProtection")
    def enable_ip_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpProtection"))

    @enable_ip_protection.setter
    def enable_ip_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91b9d052801e84b29f7bffc7deb5eeca7147c310f6e0a6f7164189b42882e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDeny")
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpRedirectOnDeny"))

    @enable_ip_redirect_on_deny.setter
    def enable_ip_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f09753d9fb1dc260ca9476cddf22b5546c6bf883056b853c7c9730310c8a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtection")
    def enable_referrer_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerProtection"))

    @enable_referrer_protection.setter
    def enable_referrer_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ec8e6457337266f4ea393330465419cbd40cae9ed0fb57e8f099d3a10cfafe7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDeny")
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerRedirectOnDeny"))

    @enable_referrer_redirect_on_deny.setter
    def enable_referrer_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d091a5a956d9d385c1598a07e7d9de324e8b359f5dbd92178ff4de066f137fab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionMode")
    def geo_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionMode"))

    @geo_protection_mode.setter
    def geo_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f4ad92420f167850ca3042e6c0a9b2411e05dca2f0daf4f35682f1eb18eb58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitle")
    def geo_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionTitle"))

    @geo_protection_title.setter
    def geo_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68b6299d2c68897c817f911c7edcad085a0814e43febed8f94ca32378cadcca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrl")
    def geo_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoRedirectUrl"))

    @geo_redirect_url.setter
    def geo_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__224d63c6340da183b691d14640422529d797d9abdbbddb01d74bd92e7d5f0927)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="ipAddresses")
    def ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "ipAddresses"))

    @ip_addresses.setter
    def ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f973c0a0864ac83ea4402e60e2790147b942ca6c7b9c94591d8c7147633ffd20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionMode")
    def ip_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionMode"))

    @ip_protection_mode.setter
    def ip_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac05f29b46b7a0657f7deb2674b7df5894214547f14286a4c8e239bc13f4ecb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitle")
    def ip_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionTitle"))

    @ip_protection_title.setter
    def ip_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32675e0204f31cbb22a24ea1aa516aca55a892aa0071974bfde8e0f01ac05cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrl")
    def ip_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipRedirectUrl"))

    @ip_redirect_url.setter
    def ip_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0f39e0e8eb19d03a4235c747d9d37c73386b53324b797cf6a2ec436d7cbe901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35f59c2345795fc68aa3ac87c96be18c19906eab53c2a7c28f30dbb1dcd52240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddresses")
    def override_ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "overrideIpAddresses"))

    @override_ip_addresses.setter
    def override_ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b873801ae2f3de70dd1d106b72b87a7a59b6b825a9fbb362fdf702990fdd503a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideIpAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="referrerDomains")
    def referrer_domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "referrerDomains"))

    @referrer_domains.setter
    def referrer_domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36a26d4b4d6d70a9bd72cb66abde6cf863f2b7cda8636538312de2387bbc120a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerDomains", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionMode")
    def referrer_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionMode"))

    @referrer_protection_mode.setter
    def referrer_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b5eeea1f86f8f23e699da90312e6643d8c8066a02486fbd0253c5f5b4c43fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitle")
    def referrer_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionTitle"))

    @referrer_protection_title.setter
    def referrer_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d45e0d2347829e4eaec4cb033f75b2a411f20d1c2ed85e2a9945a0545db3f58f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrl")
    def referrer_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerRedirectUrl"))

    @referrer_redirect_url.setter
    def referrer_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd4972794b19bf1590c8e805e93416f1d89e98cd4cdb7b610dd9ce45c0b659e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bba129ee7d8a27042eba8eb1770236b725dd23d92463431371e1d214abbbf37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f15bf91619b83edabcdd1eabf29463d5811a93718adca44aae30131fd89909)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__734425712e784aa055326a8cc8c5c5f347ab195e7b9bcde3c9b8a8c558d003f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84807a39ba1b324259828dab5c200b108d594361681d26932f6bb94f3a98262)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport",
    jsii_struct_bases=[],
    name_mapping={
        "allow_credentials": "allowCredentials",
        "allow_headers": "allowHeaders",
        "allow_origins": "allowOrigins",
        "enabled": "enabled",
        "expose_headers": "exposeHeaders",
        "headers": "headers",
        "locked": "locked",
        "methods": "methods",
        "origins": "origins",
        "preflight_max_age": "preflightMaxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport:
    def __init__(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6056aa3a00bced75ebab76911fe6d38cb3335dbf7e24f33de6b7228bf75ae44)
            check_type(argname="argument allow_credentials", value=allow_credentials, expected_type=type_hints["allow_credentials"])
            check_type(argname="argument allow_headers", value=allow_headers, expected_type=type_hints["allow_headers"])
            check_type(argname="argument allow_origins", value=allow_origins, expected_type=type_hints["allow_origins"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expose_headers", value=expose_headers, expected_type=type_hints["expose_headers"])
            check_type(argname="argument headers", value=headers, expected_type=type_hints["headers"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument methods", value=methods, expected_type=type_hints["methods"])
            check_type(argname="argument origins", value=origins, expected_type=type_hints["origins"])
            check_type(argname="argument preflight_max_age", value=preflight_max_age, expected_type=type_hints["preflight_max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_credentials is not None:
            self._values["allow_credentials"] = allow_credentials
        if allow_headers is not None:
            self._values["allow_headers"] = allow_headers
        if allow_origins is not None:
            self._values["allow_origins"] = allow_origins
        if enabled is not None:
            self._values["enabled"] = enabled
        if expose_headers is not None:
            self._values["expose_headers"] = expose_headers
        if headers is not None:
            self._values["headers"] = headers
        if locked is not None:
            self._values["locked"] = locked
        if methods is not None:
            self._values["methods"] = methods
        if origins is not None:
            self._values["origins"] = origins
        if preflight_max_age is not None:
            self._values["preflight_max_age"] = preflight_max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_credentials(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Accepts requests made using credentials, like cookies or TLS client certificates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        '''
        result = self._values.get("allow_credentials")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_headers(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, defines which headers to allow when making the actual request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        '''
        result = self._values.get("allow_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_origins(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, sets which origin hostnames to accept requests from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        '''
        result = self._values.get("allow_origins")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables CORS feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expose_headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''In responses to preflight requests, lists names of headers that clients can access.

        By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        '''
        result = self._values.get("expose_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the supported request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        '''
        result = self._values.get("headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def methods(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        '''
        result = self._values.get("methods")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origins(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin hostnames to accept requests from.

        The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        '''
        result = self._values.get("origins")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def preflight_max_age(self) -> typing.Optional[builtins.str]:
        '''Defines the number of seconds that the browser should cache the response to a preflight request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        '''
        result = self._values.get("preflight_max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef0c013e73529124568658f053f82c9fbe8b3975fc08b3e0aa842205545c31b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowCredentials")
    def reset_allow_credentials(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCredentials", []))

    @jsii.member(jsii_name="resetAllowHeaders")
    def reset_allow_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHeaders", []))

    @jsii.member(jsii_name="resetAllowOrigins")
    def reset_allow_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOrigins", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExposeHeaders")
    def reset_expose_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExposeHeaders", []))

    @jsii.member(jsii_name="resetHeaders")
    def reset_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaders", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethods")
    def reset_methods(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethods", []))

    @jsii.member(jsii_name="resetOrigins")
    def reset_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigins", []))

    @jsii.member(jsii_name="resetPreflightMaxAge")
    def reset_preflight_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreflightMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowCredentialsInput")
    def allow_credentials_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCredentialsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHeadersInput")
    def allow_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOriginsInput")
    def allow_origins_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="exposeHeadersInput")
    def expose_headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "exposeHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="headersInput")
    def headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headersInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodsInput")
    def methods_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "methodsInput"))

    @builtins.property
    @jsii.member(jsii_name="originsInput")
    def origins_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originsInput"))

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAgeInput")
    def preflight_max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preflightMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCredentials")
    def allow_credentials(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCredentials"))

    @allow_credentials.setter
    def allow_credentials(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef192028814608e9b3f56089c7cb6a3bdca19d7fffd1c4e3aac3a1c28b628cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCredentials", value)

    @builtins.property
    @jsii.member(jsii_name="allowHeaders")
    def allow_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowHeaders"))

    @allow_headers.setter
    def allow_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d95e5113e15a4d841e0ba45daea952f152c18214d4f701d63a49e5b3e476ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="allowOrigins")
    def allow_origins(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowOrigins"))

    @allow_origins.setter
    def allow_origins(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b653a4538a5e96bba9d7a4662b623a11389a056b36199eb21220a65e4fedd921)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOrigins", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed26a8e0c0bb91c630d3a4c61a777328e42353286969754e3b4447788b3120a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="exposeHeaders")
    def expose_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "exposeHeaders"))

    @expose_headers.setter
    def expose_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc666566cc2e486079274b8aa6e4e8090fb6220e6b4aff0f0e65659585637c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exposeHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="headers")
    def headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headers"))

    @headers.setter
    def headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1099b6c390afc06e727467a39a3269ad76b0af398ea1adb369d00473548363db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headers", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d119679f0b3b77cd738afa13f8436bad0357a85c424113ee990187f29ad963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="methods")
    def methods(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "methods"))

    @methods.setter
    def methods(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145c18f9137b646fa3f0fc4e5ea017626b49028d049dfdc587cd41c51a878953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "methods", value)

    @builtins.property
    @jsii.member(jsii_name="origins")
    def origins(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "origins"))

    @origins.setter
    def origins(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecf032da9a011e6ad8bb251d81addcd0065ce5a8a59ad18849a55306cf953871)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origins", value)

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAge")
    def preflight_max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preflightMaxAge"))

    @preflight_max_age.setter
    def preflight_max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078a19a276b9e16fe8f806166522aac485fd89f531857e8ec11ff58f5c4ededb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preflightMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6206ac25d1bffd61c4f5119cb119060f6ea15ad8accb8496cdd5db08935696b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb6851c93123c64cd1aac2f84b78df98e2137137b77c75350be727649790935)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e5293db71d7a0e656330022f16157c722ff89b212045352f98af2da310bfe4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9234012dd196dfc16b9a9840faf618ad1da1d5ce0ff6daad6ff65796ef9b9aa0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae3e5ba5788a6d932ef5c97ae3afd7a8fb7513b8c8581466ef63c4bec22c711e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d19dd2c982174499728cce5a13ab2344ef1270b5f67c582db35c04b00b8c96c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b49ce215a2b095a9fcdb417dcbaa234ede5ab09c5464bf6ebeb935836b59e9b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62fee12165d1e082bade911e3631b26ef409a98a1136d9034d3b53c5f4341812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d63e6a78c89d9c71ed55b40312cce7fb56d05637a4a2745660c810a0975dd5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019a63cbb4c8ac4a1dc94441c21262839d4bd2c69b45e5d31b320015d26c3370)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145ca88b1533b9647190006fc41483e8c87d9b42ded0e586c7f985fdac4ba9fe)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59574bcd307c8967dea9144f3b4eaef3ba99ad6653e59cf6c9f49360efc83053)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cbca6e7bcfd684a696a14b065bf6cb2c6fa215b7fce951e914763b95239cb05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43568d80689116f491bd8f5f6f25ef851085a6b84d9768d105c9a990ca856854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3fcf8eb9ce21b7d62a404602d1f046f7b7300b3c3e21221e921d762e5cd5b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd43f366dc22e277c963f4b1ea3c165ba5d3d792c38557397c87451ed2a40000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a3d9181dc5eba8efeca41a2398ceffb52d8157662e935f6114b19aa0e46135f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e62d7eaeb5aefa953e7e5ba9f2cf283d7d7a019046b982535e1f0545713cce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6be96babb072fa2419af5dfc4f335112af30795854d198e48abe6a6791e078f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d687d86c88d97e812072aa7aa2dae17b8f175267e453fad1b1444813db76ed26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02072dee650ec854b4b4312207ad64eb00195a77a0d8047135271638a5631805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f46587c3bf5458c77ee2ccb59199fcabbad9b651772085e01b378709874cc5d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb4a99d6cb6ea11e0fca08896cda89f2455fc54157ca20f4b2944f5d30f7ede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior",
    jsii_struct_bases=[],
    name_mapping={
        "behavior_id": "behaviorId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior:
    def __init__(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b952ee7b7136f20157d55ae321607351e7ccf11ae33885b16853edbd5f8b5764)
            check_type(argname="argument behavior_id", value=behavior_id, expected_type=type_hints["behavior_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior_id is not None:
            self._values["behavior_id"] = behavior_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior_id(self) -> typing.Optional[builtins.str]:
        '''The unique identifier for the predefined custom behavior you want to insert into the current rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        '''
        result = self._values.get("behavior_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0380e256f9f630b67a261bbe2f602398afb28a2f6cffef156fa7263a02578fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehaviorId")
    def reset_behavior_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehaviorId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorIdInput")
    def behavior_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorId")
    def behavior_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behaviorId"))

    @behavior_id.setter
    def behavior_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de83fcba1c29b35b156d80c84b8c546b2d00062bbe3745246aa900b33bb5d42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behaviorId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b929c0fb48bc9d2f9f1a86ea1078e07205703d399fd43619ff907c8840cb440b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5d2e5e6047fd1bba5d0d53af49eb7085b0b9d367bd24d49a986d186ebc4794a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__258b8a7ff9418f7b8725a172581652c34e5d50b638f08a6ebcf8fe3002647abc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a054c76bc842b94893669953b31196aaaa6301b9b70c1801fce956424c349f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_stream_title": "beaconStreamTitle",
        "collect_midgress_traffic": "collectMidgressTraffic",
        "datastream_ids": "datastreamIds",
        "enabled": "enabled",
        "locked": "locked",
        "log_enabled": "logEnabled",
        "log_stream_name": "logStreamName",
        "log_stream_title": "logStreamTitle",
        "sampling_percentage": "samplingPercentage",
        "stream_type": "streamType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream:
    def __init__(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e3fb3f73d8aa353a543195e3647a0c5b641aa56f39cf722635f55e2f3ea87d)
            check_type(argname="argument beacon_stream_title", value=beacon_stream_title, expected_type=type_hints["beacon_stream_title"])
            check_type(argname="argument collect_midgress_traffic", value=collect_midgress_traffic, expected_type=type_hints["collect_midgress_traffic"])
            check_type(argname="argument datastream_ids", value=datastream_ids, expected_type=type_hints["datastream_ids"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_enabled", value=log_enabled, expected_type=type_hints["log_enabled"])
            check_type(argname="argument log_stream_name", value=log_stream_name, expected_type=type_hints["log_stream_name"])
            check_type(argname="argument log_stream_title", value=log_stream_title, expected_type=type_hints["log_stream_title"])
            check_type(argname="argument sampling_percentage", value=sampling_percentage, expected_type=type_hints["sampling_percentage"])
            check_type(argname="argument stream_type", value=stream_type, expected_type=type_hints["stream_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_stream_title is not None:
            self._values["beacon_stream_title"] = beacon_stream_title
        if collect_midgress_traffic is not None:
            self._values["collect_midgress_traffic"] = collect_midgress_traffic
        if datastream_ids is not None:
            self._values["datastream_ids"] = datastream_ids
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if log_enabled is not None:
            self._values["log_enabled"] = log_enabled
        if log_stream_name is not None:
            self._values["log_stream_name"] = log_stream_name
        if log_stream_title is not None:
            self._values["log_stream_title"] = log_stream_title
        if sampling_percentage is not None:
            self._values["sampling_percentage"] = sampling_percentage
        if stream_type is not None:
            self._values["stream_type"] = stream_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        '''
        result = self._values.get("beacon_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def collect_midgress_traffic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        '''
        result = self._values.get("collect_midgress_traffic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def datastream_ids(self) -> typing.Optional[builtins.str]:
        '''A set of dash-separated DataStream ID values to limit the scope of reported data.

        By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        '''
        result = self._values.get("datastream_ids")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables DataStream reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables log collection for the property by associating it with DataStream configurations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        '''
        result = self._values.get("log_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_stream_name(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the unique IDs of streams configured for the property.

        For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        '''
        result = self._values.get("log_stream_name")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def log_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        '''
        result = self._values.get("log_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of log data you want to collect for this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        '''
        result = self._values.get("sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def stream_type(self) -> typing.Optional[builtins.str]:
        '''Specify the DataStream type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        '''
        result = self._values.get("stream_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastreamOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastreamOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__910dc7c4c36e201f1db3b4c900773b54bfb95c99ea2a3e10906cd1b3132a838a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconStreamTitle")
    def reset_beacon_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconStreamTitle", []))

    @jsii.member(jsii_name="resetCollectMidgressTraffic")
    def reset_collect_midgress_traffic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCollectMidgressTraffic", []))

    @jsii.member(jsii_name="resetDatastreamIds")
    def reset_datastream_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastreamIds", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogEnabled")
    def reset_log_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEnabled", []))

    @jsii.member(jsii_name="resetLogStreamName")
    def reset_log_stream_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamName", []))

    @jsii.member(jsii_name="resetLogStreamTitle")
    def reset_log_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamTitle", []))

    @jsii.member(jsii_name="resetSamplingPercentage")
    def reset_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingPercentage", []))

    @jsii.member(jsii_name="resetStreamType")
    def reset_stream_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStreamType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitleInput")
    def beacon_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTrafficInput")
    def collect_midgress_traffic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "collectMidgressTrafficInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamIdsInput")
    def datastream_ids_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datastreamIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logEnabledInput")
    def log_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamNameInput")
    def log_stream_name_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "logStreamNameInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamTitleInput")
    def log_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingPercentageInput")
    def sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "samplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="streamTypeInput")
    def stream_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "streamTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitle")
    def beacon_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconStreamTitle"))

    @beacon_stream_title.setter
    def beacon_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5af5d829ad78ef08ab44d1bd251c08d89510ddda1f421f06458fbd7418d89229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTraffic")
    def collect_midgress_traffic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "collectMidgressTraffic"))

    @collect_midgress_traffic.setter
    def collect_midgress_traffic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc6f2ce7b5b6dd8c1ac483bee9a385831d4cb06b47b1e6d71964a6d85142abd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "collectMidgressTraffic", value)

    @builtins.property
    @jsii.member(jsii_name="datastreamIds")
    def datastream_ids(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "datastreamIds"))

    @datastream_ids.setter
    def datastream_ids(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c77618df36e145d2f8eb3805192b8c8ff3ceeecd15e88b020705e6f0075c22d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "datastreamIds", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc41da7ce43fb0d25ffce7710220c3524bf4e89eff03cba58e4b529035f3d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32f8bd9813099fead66afe20d97290fb545d491ffa885141dbb24dc527201fbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logEnabled")
    def log_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEnabled"))

    @log_enabled.setter
    def log_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72f72a3a43f6cd29d76167d6c89d0764e8246a8c9ef1993eab11b32c634a626f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamName")
    def log_stream_name(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "logStreamName"))

    @log_stream_name.setter
    def log_stream_name(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__158ba65380abc4a876d0264de2f96b38efc90b5f8fc14ade52c0ff6c9e031da8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamName", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamTitle")
    def log_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logStreamTitle"))

    @log_stream_title.setter
    def log_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7f965fcdb1644b9e076490f3309bd0453b44cfe9191acf319144ef965437bd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="samplingPercentage")
    def sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "samplingPercentage"))

    @sampling_percentage.setter
    def sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8556770c7ae91745b824b89812134317945720b8ab7947bae0011b4c65746848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="streamType")
    def stream_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "streamType"))

    @stream_type.setter
    def stream_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee1e7971c9d6838aa6c070bee307b93a84abbdbe56ca83441ce57ede373404bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "streamType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71bc269a20d90c35dd09083491e811cb671b8cecaf6d3858899e83856c92475f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fb157c0ca3af93c2ae8c0dfcf5a91d9c9aba5b9e73ef197a036fa6071fc2d9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__229485799a3c8cbb2b7ec5d48f510960370a52b9dff115674e22c86b87e93b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous": "anonymous",
        "enabled": "enabled",
        "gwenabled": "gwenabled",
        "locked": "locked",
        "namespace_id": "namespaceId",
        "template_uuid": "templateUuid",
        "tlsenabled": "tlsenabled",
        "uuid": "uuid",
        "wsenabled": "wsenabled",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp:
    def __init__(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aa425cddd10b82b1ef14f194c393af0352fddaa76f08cb8fbb04372155a93cc)
            check_type(argname="argument anonymous", value=anonymous, expected_type=type_hints["anonymous"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument gwenabled", value=gwenabled, expected_type=type_hints["gwenabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_id", value=namespace_id, expected_type=type_hints["namespace_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tlsenabled", value=tlsenabled, expected_type=type_hints["tlsenabled"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument wsenabled", value=wsenabled, expected_type=type_hints["wsenabled"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous is not None:
            self._values["anonymous"] = anonymous
        if enabled is not None:
            self._values["enabled"] = enabled
        if gwenabled is not None:
            self._values["gwenabled"] = gwenabled
        if locked is not None:
            self._values["locked"] = locked
        if namespace_id is not None:
            self._values["namespace_id"] = namespace_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tlsenabled is not None:
            self._values["tlsenabled"] = tlsenabled
        if uuid is not None:
            self._values["uuid"] = uuid
        if wsenabled is not None:
            self._values["wsenabled"] = wsenabled

    @builtins.property
    def anonymous(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        '''
        result = self._values.get("anonymous")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables IoT Edge Connect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def gwenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured HTTP connection on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        '''
        result = self._values.get("gwenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the globally reserved name for a specific configuration.

        It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration.  You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        '''
        result = self._values.get("namespace_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tlsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured MQTT connection on port 8883.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        '''
        result = self._values.get("tlsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def wsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        result = self._values.get("wsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "hash_conversion_algorithm": "hashConversionAlgorithm",
        "hash_conversion_key": "hashConversionKey",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation:
    def __init__(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b740c6f4660e363fdb365a51bcad0c0a9263b959c980c62ef6a37be0c66c8551)
            check_type(argname="argument hash_conversion_algorithm", value=hash_conversion_algorithm, expected_type=type_hints["hash_conversion_algorithm"])
            check_type(argname="argument hash_conversion_key", value=hash_conversion_key, expected_type=type_hints["hash_conversion_key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hash_conversion_algorithm is not None:
            self._values["hash_conversion_algorithm"] = hash_conversion_algorithm
        if hash_conversion_key is not None:
            self._values["hash_conversion_key"] = hash_conversion_key
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def hash_conversion_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        '''
        result = self._values.get("hash_conversion_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_conversion_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the key to generate the hash, ideally a long random string to ensure adequate security.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        '''
        result = self._values.get("hash_conversion_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c553271bee1728c52832bdf636d581cc3ac88fbc8decbc53057764a4a47b4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHashConversionAlgorithm")
    def reset_hash_conversion_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionAlgorithm", []))

    @jsii.member(jsii_name="resetHashConversionKey")
    def reset_hash_conversion_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithmInput")
    def hash_conversion_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionKeyInput")
    def hash_conversion_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithm")
    def hash_conversion_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionAlgorithm"))

    @hash_conversion_algorithm.setter
    def hash_conversion_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4850e33c4600b312a9146cca0485a2fac8eabf9f04dd0ea1aa28bdf3a6af8ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hashConversionKey")
    def hash_conversion_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionKey"))

    @hash_conversion_key.setter
    def hash_conversion_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__942cd30c30e83cd436d37a9faea27a4201750c3f9547ba5cbdc04c98e04c62fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionKey", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478a3793f72ccbb6bc3fbf8443fd2ebc530d6268c7484d0a05e1b34a9b7f25d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa284cf1e6ccc60b53768927ce5e8a23600ccb007e2dfd0546e36934fbc4b7ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99de1b538e34a91f323cb7b2aa7674ce9efbdb7d001845a9ea17d90a635a0e68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3250651cf48f9f08b32b4baae665644cd7ba1b370a1b19be8806dcc88af41c7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa25a22181cd37a44508e6c292551566f54c7106f056f71ab91eb84f56b5f889)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with a single grouping to capture the text.

        For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bf592519c1a5103122cacc0c44d294e8ec131ff5efab4894caf44986e80c0dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab24c599401d5fb7f5d7c5a7b6dbd46c2f802eb36a55bf33bac89fae3d0c4236)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__211f55b2f6de9b3e0fb49c8ca613f8581677c4fa818d33cca2de5f755decb0c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65d3b885f308310f162ae6eba1cd2306a8634d078df776ab590f555eb984ee7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a9a17098f0641bab883a89a05f063dca7dec87c320531e1b0d6f6ecb1398ac9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f7e80ccdef5f43756fb3603f1efa279a801cbee73fcac6f20c2a69b744a42c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "substring_end": "substringEnd",
        "substring_start": "substringStart",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08b95d8a66110eed4e296171562e126dd4f2a2849d18f635ed875dde9fc7bca)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument substring_end", value=substring_end, expected_type=type_hints["substring_end"])
            check_type(argname="argument substring_start", value=substring_start, expected_type=type_hints["substring_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if substring_end is not None:
            self._values["substring_end"] = substring_end
        if substring_start is not None:
            self._values["substring_start"] = substring_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def substring_end(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        '''
        result = self._values.get("substring_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def substring_start(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the first character to extract.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        '''
        result = self._values.get("substring_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c6266d13abc821077133b1849cc767cf051ab4bcb2388daa0b4d67259d1f6d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSubstringEnd")
    def reset_substring_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringEnd", []))

    @jsii.member(jsii_name="resetSubstringStart")
    def reset_substring_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="substringEndInput")
    def substring_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringEndInput"))

    @builtins.property
    @jsii.member(jsii_name="substringStartInput")
    def substring_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27176e6688789ca6340a101c4b92b46fefc74534908bc4f9b6ccb340897ea764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="substringEnd")
    def substring_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringEnd"))

    @substring_end.setter
    def substring_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db2a55dce5b16efe13a7d68d1b4d0eb0c8c2abb61c81823c6527719927b933b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringEnd", value)

    @builtins.property
    @jsii.member(jsii_name="substringStart")
    def substring_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringStart"))

    @substring_start.setter
    def substring_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fca49fd13529dbec052c152e08a4a4d578cd607ee188f58f784818255e24d4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__594b12a8e2afd8d35b01caecc3664b26c0b686487946d31110c11595e7637e56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f5a3aa06c22db08df1fd96a848a5bab8d5378e50d04b7225ad5fca56cba8ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f73741d6ee27f69984b4be4c6538d891753a3b7799e015ad0c1214910cbc0e3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_field": "certificateField",
        "dcp_mutual_auth_processing_variable_id": "dcpMutualAuthProcessingVariableId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor:
    def __init__(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9ae2a1f060a9d3587a4c96f8fe0cdc043c34f993a6f12169104ae8d75a54dba)
            check_type(argname="argument certificate_field", value=certificate_field, expected_type=type_hints["certificate_field"])
            check_type(argname="argument dcp_mutual_auth_processing_variable_id", value=dcp_mutual_auth_processing_variable_id, expected_type=type_hints["dcp_mutual_auth_processing_variable_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_field is not None:
            self._values["certificate_field"] = certificate_field
        if dcp_mutual_auth_processing_variable_id is not None:
            self._values["dcp_mutual_auth_processing_variable_id"] = dcp_mutual_auth_processing_variable_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_field(self) -> typing.Optional[builtins.str]:
        '''Specifies the field in the client certificate to extract the variable from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        '''
        result = self._values.get("certificate_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dcp_mutual_auth_processing_variable_id(self) -> typing.Optional[builtins.str]:
        '''Where to store the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        '''
        result = self._values.get("dcp_mutual_auth_processing_variable_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eaf8dfd7fcd1ca15419946ecdb896f5eba8733609a41b4dac88db573782396c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateField")
    def reset_certificate_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateField", []))

    @jsii.member(jsii_name="resetDcpMutualAuthProcessingVariableId")
    def reset_dcp_mutual_auth_processing_variable_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpMutualAuthProcessingVariableId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldInput")
    def certificate_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableIdInput")
    def dcp_mutual_auth_processing_variable_id_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dcpMutualAuthProcessingVariableIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateField")
    def certificate_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateField"))

    @certificate_field.setter
    def certificate_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebec69a8cd6f6f1ebca8164647e6df4e77f1d938106547fd5beb9fd550ce2983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateField", value)

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableId")
    def dcp_mutual_auth_processing_variable_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dcpMutualAuthProcessingVariableId"))

    @dcp_mutual_auth_processing_variable_id.setter
    def dcp_mutual_auth_processing_variable_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b08bcf59ae6870edf28a37ac7d7aceed1206711e21b82ba43787cd8ddefa4c50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dcpMutualAuthProcessingVariableId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d034c94f65b0259057158f28666be0062813cdaabe5209d1b93cddf233e10384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c236a4d132154fa8f5ca2d061d330bc0197655ec8215dce77fbf6e0345644b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a108c6c583e566a41d84e595a837776a7412645addfbc4b67ca0e0ec8c0b2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__474649c55012f8a04178a2c0bf81a6ad8d1b5cefe284e4c6ee2aac5c8e43d27d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups",
    jsii_struct_bases=[],
    name_mapping={
        "group_names": "groupNames",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups:
    def __init__(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf59977e2f85b5b30b316fef992c9aaca8964ec7ad86681c2bca95e87d7bd954)
            check_type(argname="argument group_names", value=group_names, expected_type=type_hints["group_names"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if group_names is not None:
            self._values["group_names"] = group_names
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def group_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of authorization groups to assign to all connecting devices.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        '''
        result = self._values.get("group_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581b59951f630aaec7e8c99bca84a9ce558315375d8eb5f784346513d791b6f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetGroupNames")
    def reset_group_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGroupNames", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="groupNamesInput")
    def group_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "groupNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="groupNames")
    def group_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "groupNames"))

    @group_names.setter
    def group_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c5463bbdcdfcf89f85570347066135a66237cca0a5d5f64989d4de041966201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "groupNames", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__537cc63f10d272c23106b93e2791028ff7f2b45b8500b6f3482cd9e42b2e6c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1520ad7074167d49a78c4ea3a2cd1418ad86e894fa412d7ca6b3c1ee3405411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fecbd82019cbd790bcc57ea03a48e0312a787d1b432c861107ca15d3ab7df395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac35ff099c2738cb0706eb33a4e9eaf1268a54af8e1de70a6ea906291db4c49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations",
    jsii_struct_bases=[],
    name_mapping={
        "custom_values": "customValues",
        "enabled": "enabled",
        "hostname": "hostname",
        "locked": "locked",
        "path": "path",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations:
    def __init__(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3856d19ee64eb381c86b7cae86e6c8c6aa40a95420a59359139c3ded678f5d5c)
            check_type(argname="argument custom_values", value=custom_values, expected_type=type_hints["custom_values"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_values is not None:
            self._values["custom_values"] = custom_values
        if enabled is not None:
            self._values["enabled"] = enabled
        if hostname is not None:
            self._values["hostname"] = hostname
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_values(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify custom JWT server connection values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        '''
        result = self._values.get("custom_values")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the default JWT server and sets the authentication endpoint to a default path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the JWT server's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abfe9b69e51450b626fcfafcd115877d3c89da2523c83515cd1adc78ab68e885)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomValues")
    def reset_custom_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValues", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customValuesInput")
    def custom_values_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customValues")
    def custom_values(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customValues"))

    @custom_values.setter
    def custom_values(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd530ee392da22730e6bdb3b5ae967e4d5d1b0ec9982177786b1d386f550970b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValues", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95c829cd7544c78be600fba27d76c070abee46b178142befdac1a56809453e61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d2e60b1f28be7f9e555a081d5829ce713cc5ebaf4d1adef3fdc1da2bc56c53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__349542191ef8105560abce028c16d11b93d27ac9f0f7010cc59d4564ec6d9032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69cc7a261696247c60edd6eefdd235c07bfb63871c8873e34789efbaa4d307fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb418b82da172e3a3cc23f0d88b3d7e55f78a7c28bb5054370d26698f9ea0d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c88c5d508a88475cdd258ddd0863bf5e569fd3cfd117fe28e6508e785e3f9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7860a0d2912581f1897237c633b9ea2851700c6e6f9b06966df76b875ac90815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__702f7af04ca211de1d44f871831fd2ddc6b71ac237042a27461ee1b0cd8118dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymous")
    def reset_anonymous(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymous", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGwenabled")
    def reset_gwenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGwenabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceId")
    def reset_namespace_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTlsenabled")
    def reset_tlsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsenabled", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWsenabled")
    def reset_wsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWsenabled", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousInput")
    def anonymous_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "anonymousInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="gwenabledInput")
    def gwenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "gwenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceIdInput")
    def namespace_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsenabledInput")
    def tlsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tlsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="wsenabledInput")
    def wsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "wsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymous")
    def anonymous(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "anonymous"))

    @anonymous.setter
    def anonymous(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b3db42554d94512caecf3ccab18a42cdd8d0da143b4f6bf3516a713be93b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymous", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b9f3164b32ca3aa876f3652e9a11177f57ec7dfe69ea8e02a18f027c607b5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="gwenabled")
    def gwenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "gwenabled"))

    @gwenabled.setter
    def gwenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4c03c2e0bd15bcd2cd4c5b28379ee40b54f9b3cda44a0a7dd932b75dcc9224e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gwenabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02be6f730531a33488965de6d0bd2fc05515a5bec1379da9f6f926e5992bc403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceId")
    def namespace_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceId"))

    @namespace_id.setter
    def namespace_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebabaf704f3068bb9ee3f0371e675a87e29468aaa5ea198961dd7c31550c92a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10a22deb0168ca5cab84aaae2c767c54304fc0d630e38ea8d36a08dc3ea6033a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tlsenabled")
    def tlsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tlsenabled"))

    @tlsenabled.setter
    def tlsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1071516280099a720ae519abe23ef7421421a1ad6aa9d0392920db90197ac050)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b3ac970d9155e278032d78ba25042625d4672d1fcb9c31383f79a127fb8316d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="wsenabled")
    def wsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "wsenabled"))

    @wsenabled.setter
    def wsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f7cb9e0a0aac62d1c67bdcbabb6ec6571a28eabe6fb96d9659df1a27313dfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b50163c7bd80666f28a6abc197a4345099dd30072d3ce3e371608b738aca3b0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth",
    jsii_struct_bases=[],
    name_mapping={
        "extract_hostname": "extractHostname",
        "extract_jurisdiction": "extractJurisdiction",
        "extract_namespace": "extractNamespace",
        "hostname_claim": "hostnameClaim",
        "jurisdiction_claim": "jurisdictionClaim",
        "locked": "locked",
        "namespace_claim": "namespaceClaim",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth:
    def __init__(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__587ce5ff542c94b9be8911556928c9a9d8d2051b1decc05b971c4d87ebd2b742)
            check_type(argname="argument extract_hostname", value=extract_hostname, expected_type=type_hints["extract_hostname"])
            check_type(argname="argument extract_jurisdiction", value=extract_jurisdiction, expected_type=type_hints["extract_jurisdiction"])
            check_type(argname="argument extract_namespace", value=extract_namespace, expected_type=type_hints["extract_namespace"])
            check_type(argname="argument hostname_claim", value=hostname_claim, expected_type=type_hints["hostname_claim"])
            check_type(argname="argument jurisdiction_claim", value=jurisdiction_claim, expected_type=type_hints["jurisdiction_claim"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_claim", value=namespace_claim, expected_type=type_hints["namespace_claim"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if extract_hostname is not None:
            self._values["extract_hostname"] = extract_hostname
        if extract_jurisdiction is not None:
            self._values["extract_jurisdiction"] = extract_jurisdiction
        if extract_namespace is not None:
            self._values["extract_namespace"] = extract_namespace
        if hostname_claim is not None:
            self._values["hostname_claim"] = hostname_claim
        if jurisdiction_claim is not None:
            self._values["jurisdiction_claim"] = jurisdiction_claim
        if locked is not None:
            self._values["locked"] = locked
        if namespace_claim is not None:
            self._values["namespace_claim"] = namespace_claim
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def extract_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a hostname from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        '''
        result = self._values.get("extract_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_jurisdiction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a jurisdiction that defines a geographically distributed set of servers from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        '''
        result = self._values.get("extract_jurisdiction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_namespace(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a namespace from JSON web tokens (JWT).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        '''
        result = self._values.get("extract_namespace")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the hostname from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        '''
        result = self._values.get("hostname_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jurisdiction_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the jurisdiction from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        '''
        result = self._values.get("jurisdiction_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the namespace from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        '''
        result = self._values.get("namespace_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41823fd67eb3079fbe4ac252a1374f4155f353e85c40552333a024fbb5927e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExtractHostname")
    def reset_extract_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractHostname", []))

    @jsii.member(jsii_name="resetExtractJurisdiction")
    def reset_extract_jurisdiction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractJurisdiction", []))

    @jsii.member(jsii_name="resetExtractNamespace")
    def reset_extract_namespace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractNamespace", []))

    @jsii.member(jsii_name="resetHostnameClaim")
    def reset_hostname_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameClaim", []))

    @jsii.member(jsii_name="resetJurisdictionClaim")
    def reset_jurisdiction_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJurisdictionClaim", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceClaim")
    def reset_namespace_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceClaim", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="extractHostnameInput")
    def extract_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="extractJurisdictionInput")
    def extract_jurisdiction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractJurisdictionInput"))

    @builtins.property
    @jsii.member(jsii_name="extractNamespaceInput")
    def extract_namespace_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractNamespaceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameClaimInput")
    def hostname_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaimInput")
    def jurisdiction_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jurisdictionClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceClaimInput")
    def namespace_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="extractHostname")
    def extract_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractHostname"))

    @extract_hostname.setter
    def extract_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__902645121a0566cd8bd801a00bb54dd822d041356bccb80fa07db55186deb6c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractHostname", value)

    @builtins.property
    @jsii.member(jsii_name="extractJurisdiction")
    def extract_jurisdiction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractJurisdiction"))

    @extract_jurisdiction.setter
    def extract_jurisdiction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd5b9ee412d070818b5644f3c6db60faa613238d7765be82e5ba6031265657e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractJurisdiction", value)

    @builtins.property
    @jsii.member(jsii_name="extractNamespace")
    def extract_namespace(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractNamespace"))

    @extract_namespace.setter
    def extract_namespace(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073f1ad345131d6d6460432c24c967807096ef54827a28e540fa88fa8da92f39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractNamespace", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameClaim")
    def hostname_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostnameClaim"))

    @hostname_claim.setter
    def hostname_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584a950dc7b77189b23e57800cfd0c4cd156e0f588e470a31010b37194ccf3c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameClaim", value)

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaim")
    def jurisdiction_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jurisdictionClaim"))

    @jurisdiction_claim.setter
    def jurisdiction_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5757dfd5de78d77ffbe311155d11478b7ad9ea324e0db509cf22c2abf43d2f6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jurisdictionClaim", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85eefc198a26ab948db37a9d67bcda4ebfe6ab2ca9316b5f238fa53bec41e40e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceClaim")
    def namespace_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceClaim"))

    @namespace_claim.setter
    def namespace_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d894e1cabdafab9456c520692527a03b37fc9fdfb325d9187ecb2a23a37864d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceClaim", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b20292d7c6a5cac7c84eb635e63886434e97521e835a31be6e30ead87b3dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd71bac0df2a9bd2fdd8ff1c6561cfe2e4b61da36cbe16a94ed99a704178dd1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__610d2d56efb9ed557191d6115766cdce06e49ff13bfd92552b698b5ca6db4710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abac3e1e8ea3bdc281c6c5daf57b47abdabb579b79b990f1011c40ae23a41792)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceiptOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceiptOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dbcc9c5d718327642f854e7b845cfa716465c0b1deb995d00e594678e6af12c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2efcee8910ed61c7a8893cbad8e3d1710381536681de852f9b0b99225aca8918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287caf002382261563924ff15810a8dd9c5ba55d856305bc5632c187bfd0b6c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ece90571d0fa4a494b3f26428fa2efaf59b523682d34e5eb90054def3a2436e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835773033c43ff755d2c18d0c09709907d3da09ad19217a3eb808bafc675a72e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2ac2de2d3ddbd6c7ebce934d2095e1a9042895e9fa04802133b8e37fb4628a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "reason": "reason",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__400106aedd5fdeb788f14aeb3e7a4da51587ad24ac29dc0a231e86d243e0eb1a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reason", value=reason, expected_type=type_hints["reason"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if reason is not None:
            self._values["reason"] = reason
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies access when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reason(self) -> typing.Optional[builtins.str]:
        '''Text message that keys why access is denied.

        Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        '''
        result = self._values.get("reason")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc767867bcf3fa0c3921618033a8ca034725130ef2374d70efe94228c42e8fe0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReason")
    def reset_reason(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReason", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reasonInput")
    def reason_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reasonInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c45eaf3da7e3f8a4ec6a95b6f736da0fdfaea65da228686a29f5a3cafd8f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d72985878b1193ff4f0531a3911bff30cbfc10fc40c467b8e3c32a3ab3412f2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reason")
    def reason(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reason"))

    @reason.setter
    def reason(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a634e0db31b8bd307845189102b3b8582a664c6b5d5aeef6992cfaf88babf23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reason", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4cec80795035b52bebe41c9c97f261c6388b1231a3d3053e146e9f83cfce5d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a860105da1b1005a81cd0c3343d72556351c08d4861e96675af9859670e385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4bc05cc3c65d8cdd595e99459f906fba6996fab4c643fce067d15640505c4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f92ca12bbb0a8d65d2269fe2e8adfaaf22eff71bdb9c230e6f1e1305ba6b917)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ddebfbb8c07166be961d1e6048479013798fc15801bbdec5a397bdcab97e9a4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43b62769289836093f36915a3af0de175862fdedd929e48a64bb0ca34d15b5d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86383aa5127a5ab68d22276423b10fcbb14928fa61233cb4546bcb5ba51dd020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13693b246db0caf879355b72ea34e36699b3c0df7f0d35acacdaee06e7203db0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7162ba4d20e7fb7c4d1fe4cf45a844f57f70ae43e2dc1c5b9c091e21e1c9ff3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__202af06bcc33dc84ac293778d2d218f92f0e24f96d3e99f17cfa3ac3dd74278a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d7f136eaac87fefb4274a1abfde424dc105d9aa59a5daf1d48ba8a5bd6e435c)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of information about the device with which to generate a separate cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16736ebdfcbed453f77126e2c20a97bb15d8d7760877aa60fac93410202db486)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0d270c6359345df4df9743e9e594070e529e26fb35c258e77f52edeb64ffd51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40906c622ba0d2dfc40861513c744736be168660804a5546946dfb266e214074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a2e2189269194d6f8076b0c04e2c906cd7ea25be1150071810b8cb030329b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29bea9c5dd8fc6107e5d3243377f59588336e94035745c313ba9ef874748f65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87739636bd519d1f008d7fae6defe436536f087caa9b233bb39f275196052bca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448f30545894863b50700e1d180ad79172e9aba765f13e794611d08d6630f691)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of information about the requesting device to send to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00345cab493ecc25587a3c9388462d860ffb97282053d64b311d44eda67aac03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f46222b34a07effed2636cecdec1e6db9ab70e9ea44c6bfb28437ba37e2f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddab8eed8107fd4c9ebe462d18d013b33e8d33dbd13cf0072ead137b6fe01858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094308d826086b00653e432b4a8b28398dc07d34957d07399999ecfd2eb90bf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0d1d179c41117cac0efd1fc4439ef922943f1459edb029868de5c251f6cb4fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd8953129e1609b296e380408e5e8cd1c8fceb4d67d1c7f5b677c2d695135254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b47e395ff0ced2320d7d0d4d69476aec9c242fbf1e183d9a1e6e999d6d4db07)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh an expired DNS record after serving content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Set the maximum allowed time an expired DNS record may be active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0f9ed122df64f705ad8094e3c0c3156a8d39cca5361b06577c4ab6843331fb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74f702c2137b8c517d1f90eb60dad8644538baa1ca662e2746b5b659bc83ede)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd24b489a6bb7496794ef4994080408b14becb50a9fcf652a67699a27d24b671)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46bd0ad6dd08797256abc1b541bd719494c4d54339f8df3c3f4072c18fa4d43e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8913d74265d49730bee052b31565a1189053f8f1a86135d20fbce2312c00735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6ac1b11891e61a9e3b16a2aefea84b1863e53fe5129f76bead736f9f8052d39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c47b195bd63a00f9d8762ee7f00f68b16ea9b559ac9f4fac1ba2757d56d5d6e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh",
    jsii_struct_bases=[],
    name_mapping={
        "delay": "delay",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh:
    def __init__(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfd78373fc5e519d6e715fa38cc754f7d32384f7297b6647171b49a69eadd63b)
            check_type(argname="argument delay", value=delay, expected_type=type_hints["delay"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if delay is not None:
            self._values["delay"] = delay
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def delay(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        '''
        result = self._values.get("delay")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh DNS records before they expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc2a042a52e7bf0bf71d84d959ecf2bb5537f28ae8122e4a853e6ce9f3c8169)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDelay")
    def reset_delay(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDelay", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="delayInput")
    def delay_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "delayInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="delay")
    def delay(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "delay"))

    @delay.setter
    def delay(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63e7a0ef0a65631afa32746e938dfe7c9c96acaa0ab9e3382aeb72362030cd06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "delay", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08132ec5de6c7d24780e267ea81fd86e7766a2f2ffbc259df0504c696b07189d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01dee227f5b8f140b46bb1bad232ef492bab9632e51e470e97a296c3c38363a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d7690a54c6f6725b06ff72196a22107b2353e4c805fb525a3ae4f68b2b1583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf0de76c0926b533dce486a249a391effb4b244e7f05796a61bb21bcbc231370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26475a3ea5e96d3b7789310b9e78a4833ecb94f71852737106a09da368a7abf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df49f5a12a1c022296cf12b77b70b569fee4d1557115cb9edf649b0e9b7eb87d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd41025202278a0a0ca56fc75c8472d9c2e0b07bc35e6064ab5355f5720a4ef)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the protocol downgrading behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059373bb09676754f44077a0fd689280003cf10f5d09a10728d20ba75f9873f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc887e2c0477adda397fa039872e485f9d6b3af7cf5752e443ada0dd5e38788a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd16aa091b09e94e9cece6bc2fff5017f30897dae255f3a98d60b7f3e57d8391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5927697845ef69ad36cc6faeec9c9b4839f10f087da966a4bca7feb8de65e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684fe32f99d7910c7b9818270ee25ee15520729731547d82acf1d2215827483d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e36170c76a5e8f5f0ed83637a6a3fffe80d1d1c028a4ea167861d669b8c8a187)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd0fcad3b8cdd3c0720e83152ff471ca13e83bdea39366e3378e3bccf09ecb12)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c8b08b6f071e93c8c9ed0f286596bac3dc96263624a20cc0739eb4d1a2ebb4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0620a57e7237b5133f8a1af1faac2dcf912e139c222e18cebeffdbcf998640fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e148e46696f398324c1461cf7f74b962ffea500ead71df18707493119c74fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097d93514d3e88e2533d34bd869df2d27968455e536cc4971fe697450c5ecb69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__191fd7e7ebeb3bdf7e2778bd990f1d4c34b1da50057db2947605b145bc16609f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de60d8b44670da19fcf3036c5e14b1e6f51dfa8d32d4c17a854bed37a96c690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3671b24b1385c6634b927a1f61fb355b642151d1d7e5dab44430c1abb89bbc94)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotificationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotificationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900bde751419d6c881b9a333840d49c582b5db27a035593b9d016b64621f54e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a2800e9a2019246dbc82be6e36c361762eaf0d64f2792cafb2aaa6d17a7f6c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49539a070291829c60ae7f0cb7c796d83a4ce3a51c3615cd37792974d3e4d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf59272bb881b913e4c42b0a0bf9936c0adf76435fe049dfb220707b5b5a5805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf4264dfc0668a1494bd6c98d0ccc0525d8d709d14d2b542a577296a0913cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5b6b089ca388e6f62d38b49cf782f6d85960d8ad3dcb55c619308f7fb9efc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache",
    jsii_struct_bases=[],
    name_mapping={
        "allow_behavior": "allowBehavior",
        "behavior": "behavior",
        "locked": "locked",
        "send_headers": "sendHeaders",
        "send_private": "sendPrivate",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache:
    def __init__(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b84601ddd27b4fe1d0111339edcc9fc3c699eae625be89bf039af9bb8098e069)
            check_type(argname="argument allow_behavior", value=allow_behavior, expected_type=type_hints["allow_behavior"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument send_headers", value=send_headers, expected_type=type_hints["send_headers"])
            check_type(argname="argument send_private", value=send_private, expected_type=type_hints["send_private"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_behavior is not None:
            self._values["allow_behavior"] = allow_behavior
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if send_headers is not None:
            self._values["send_headers"] = send_headers
        if send_private is not None:
            self._values["send_private"] = send_private
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_behavior(self) -> typing.Optional[builtins.str]:
        '''Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        '''
        result = self._values.get("allow_behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching instructions the edge server sends to the end user's client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def send_headers(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP headers to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        '''
        result = self._values.get("send_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def send_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        '''
        result = self._values.get("send_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f2b920430a01fd0ad677153927d1b59c540b064d25765df6656694089ecd7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBehavior")
    def reset_allow_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBehavior", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSendHeaders")
    def reset_send_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendHeaders", []))

    @jsii.member(jsii_name="resetSendPrivate")
    def reset_send_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendPrivate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBehaviorInput")
    def allow_behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sendHeadersInput")
    def send_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sendHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="sendPrivateInput")
    def send_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sendPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBehavior")
    def allow_behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowBehavior"))

    @allow_behavior.setter
    def allow_behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be5cd9feb867cd240d80a2a3567128fa653866d45fc5ffab41d115eb939e75bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBehavior", value)

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c92a28ecca8be1a3d189e69438ac858f06e81c71f4bec7372803f9126b9b810)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7791f01ca344695580a59f9041d891449f008686a03a7d3805534ce294405c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sendHeaders")
    def send_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sendHeaders"))

    @send_headers.setter
    def send_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bfe551631cec0748e19b48d1071565fccf1cf9dff7a20621c9d67ca66a5ae9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="sendPrivate")
    def send_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sendPrivate"))

    @send_private.setter
    def send_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ce8fecd2a0a50b7cd2da0aea217a715792a029ce86b8e214e8ce4f1d8f5cc95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f29ed00e85cd203e9c12ea93e386971f90d4a9891850b53ebdb26d6e2a1a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__017a74522e6a3d551d44bda2ee00aa406840e028d03cf1fd77e5587070fafeab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1345e4b8e1fd89153084fd51f6c4f1aa93d396e505f04b7cf6c3281fe8eed16b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf85ad07fa00111f16cb4b1500f7f8cf50e574762c03c57c0600b8df32f07685)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae494af626cc336643ab0cd2a952ffb514a0609bcd22f7162246de3379ba208d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the quick retry feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67277578b8a4ce5503e0a1fb9e4047fa175ff1a3a809535211bb21da49b9afc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbc1e3c13d53d9e1f4dc95d4f1338afd0738d689dfda9fd698c5ce18ce7fa2e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95f34a2920ebbb771ddff8caae6467e878075c7dd17dac0e5ab7572365eb9c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5295cf58bcb3de3bd45f9d096b00d2adf730d49b715ce0101a20ebbf2d16e541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6caff9e191c95afde32db3269077afc2db677df28f02c50ffdfd97fd6a784c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68bf77328c5f390ed35face72b393bcd61e04e339f61ccac646671e47ef0ff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "throughput": "throughput",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a960ab6c2857ca44dffa3060ed766311c238c2735f6ddab15ef91253f5d118)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throughput", value=throughput, expected_type=type_hints["throughput"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throughput is not None:
            self._values["throughput"] = throughput
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throughput(self) -> typing.Optional[builtins.str]:
        '''Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps.

        If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        '''
        result = self._values.get("throughput")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebf78069bb230d8875bb16b7173b9c82413df8b076375c802b07778107c28648)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThroughput")
    def reset_throughput(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThroughput", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throughputInput")
    def throughput_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "throughputInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3996d8ab616612d0f94ac27b6040b0e1e95d5aa2b16fe63edd5fd498350c1d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73cff791103d1757b1266c89c391690122bb3e17a77c2ee5b6ac3388db617d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throughput")
    def throughput(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "throughput"))

    @throughput.setter
    def throughput(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef362fddf1580439d204a882fa9d0d0a1abb753fe27fa344820b19ce8fb00ff5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throughput", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0d60a46571b369db950a9a6e08888bbb12f12c06f9982ac75d3d5197eab2a78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5769ea00c1dfb10c249dc810095ab0ce0499e901f011399bcab112d060ffb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent",
    jsii_struct_bases=[],
    name_mapping={
        "image_compression": "imageCompression",
        "locked": "locked",
        "prefetch": "prefetch",
        "real_user_monitoring": "realUserMonitoring",
        "sure_route": "sureRoute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent:
    def __init__(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42a5fbb28e8cabc2f86cd8c135380f741a2baa535020a996eb4b86bee59fa919)
            check_type(argname="argument image_compression", value=image_compression, expected_type=type_hints["image_compression"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if image_compression is not None:
            self._values["image_compression"] = image_compression
        if locked is not None:
            self._values["locked"] = locked
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def image_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables image compression for subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        '''
        result = self._values.get("image_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows subcustomer content to prefetch over HTTP/2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes how subcustomer traffic routes from origin to edge servers.  See the ``sureRoute`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0697f8803f2b3971ab2cc28f1e82e0063eca5c46d39b32fcfa2c54f79f8e5165)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetImageCompression")
    def reset_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageCompression", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="imageCompressionInput")
    def image_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "imageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="imageCompression")
    def image_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "imageCompression"))

    @image_compression.setter
    def image_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26606f47e2cb1be95a3eaa14e58c8219b6b021e70998006ee0873df6d84b7bf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageCompression", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba6ac027e864a9e97525d3653db3ab27de10023a770921e33c55476f9cef44c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetch"))

    @prefetch.setter
    def prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a9fd15ca2a9b17e1a5b65d18793624bc7f463e3372013e55a3a1870a4baf8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetch", value)

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "realUserMonitoring"))

    @real_user_monitoring.setter
    def real_user_monitoring(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d107d3116ba7ce481abf6b4858a41e52fb938face9a7814df13c44a61d25ffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "realUserMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sureRoute"))

    @sure_route.setter
    def sure_route(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef0c67e77e5f641d49b2e9f453a6df405dd2fc33d8c44641706e0182c2646632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sureRoute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b823cf59ce0a4e7e6c0917062109276c4fcea84640a0bbe66757a0788ed31ae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd943ee9550ac1fa19c0dcf2980d4a6a3971bbeb897b0667d7fb2a8d4046376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2a5215fc56e6e8df4080252ab8e7be95a002eb4ad4606d04fb2226d4c4eb75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9fbd3e9926b1e0ca2db80a341d7a9ee369dd9d6a7933c0644dfbe577bd6264a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables sending a compressed archive file with objects.

        Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUploadOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUploadOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddf07866b1bef50a48f3c49b4869b9c6823f0a6bfda19693aaa95878331d9e9a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d21d8866bc824690586339aeac1d2f4423bc78eb8c4dbe3619e867fd7af54b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b46f280bfb20ca90d1165ec161d63626838dc503966b66edd50ad1edebfc38c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b418e90594fceef965ca66e9b6f1ccd7733405fb806c98ad95e17744fde9fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b6582010bcce2a39225c870a33214b8376863c97bec1fd62002322d764e109)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e323db1c51a39e465e80191a8c15f5fb78d112d7a6d4dce9ba649cae365ce3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase",
    jsii_struct_bases=[],
    name_mapping={
        "database": "database",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase:
    def __init__(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5826fc9e5a75df55b5b7fb0214ce713740cdc49130e5a4e2dfa9095894fb5bf3)
            check_type(argname="argument database", value=database, expected_type=type_hints["database"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if database is not None:
            self._values["database"] = database
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def database(self) -> typing.Optional[builtins.str]:
        '''Specifies a default database for this property.

        If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        '''
        result = self._values.get("database")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a database name in requests.

        If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the database name. By default, it points to ``database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the database name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a9fa7fb4a72650690d053532c24a8fdb5d0bfa7cd588d8d4661ee6aa5596e30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDatabase")
    def reset_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatabase", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="databaseInput")
    def database_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "databaseInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="database")
    def database(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "database"))

    @database.setter
    def database(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216b8e8213ac98e7035fa152ef988e949777e724cf37aace9b091b904444a690)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "database", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1a87cf7f74109f4fa52428bf5c1d50f5f68ace2346e4c9ad7c5608d8dda03d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a05e7efc08630989a040df7a49b4534931ac1aa546c89aedba7e8ab7a00860)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e051df7a78865915d83253363f597cca07002e6c7ac1125cac19c803e9414a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__127a5606f7e2889102454b093a61d1758fd66f76a904e3345a001e93331e4b6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32c216781c1879e404718a5ef0b053d5aa76910e9979d6fb4dc87ce1adea3e3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9f21f92a8971df66f1d2c78513ab0b8c4e6b9b13812dc62a307ea0af8f6ec2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b0f7e6991b39b2d33abfb4d5682ea083e66b51758ce5263430913acdfd6735e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a45f51a3abfb93878a100be2c679d79759fdb03f6a15baf4aa4079deb7eeb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset",
    jsii_struct_bases=[],
    name_mapping={
        "dataset": "dataset",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset:
    def __init__(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37385c32ae666fb42728a6eb73412da6a54482302b940c7f7e659b9ea14e3748)
            check_type(argname="argument dataset", value=dataset, expected_type=type_hints["dataset"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dataset is not None:
            self._values["dataset"] = dataset
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def dataset(self) -> typing.Optional[builtins.str]:
        '''Specifies a default data set for this property.

        If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        '''
        result = self._values.get("dataset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a data set name in requests.

        If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the data set name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatasetOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatasetOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc7803a9f72a3a9380c31ad5a76cd33e2b56f3465c1e52c6d993e91e112da8e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDataset")
    def reset_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataset", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="datasetInput")
    def dataset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datasetInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="dataset")
    def dataset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataset"))

    @dataset.setter
    def dataset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b437c4e79358a7609a392df2a931b82f9e78ffa5a1a195183c3b432c944b62a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataset", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04b6a77743b736cf180ec86de5fbd9831354913351f54512e31f7e705cbc61ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4126882c0d9fbe47a2fbcacc2955b2ed7dfd97a9d052d75ac8ea44fa2f5c517)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__899c998589177af6ec780d2211dea96832b15f95c2af4edf6736decbc0c3d8c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9f997a36f52f0b1ddd9235ad22111f7abf0d4764c8de7e910e159c5c0d7818b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44a5bddf797e317c4e654dece09e47d8352016dfe1db3511da0b833beb5b796b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__867b4070fb1ec3f0106e421f446e10584a9268409a458cca20f49015bee90315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee7a80f3180af496ebabfbcb570b799415aef865e6445c4d345466ec9d49ebb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c83ad5b702f7a08b4061e9aa10626dd5b2aa3dffea46396d60589c8bcf24b573)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f348435e0074b26aaae5249ae18ff87b6d1160c73ca097318f80735a864704ef)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374de470345dbe512a603cc1fa99eb33dc225b8632356eeacce03cc13c562098)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8317069f4a624d9aed976a91d53db613c45385e5ebe8631a4d968c0cec1e3ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b35e98b33887a3f631d70cd06304ade92e82719d6e470f15f2571d30d710a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b19bbf7bb56cf141663b4972125e8993c8415e475be03bacc9d06bc19b31ac6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ce0144f03f31fc8a59520aa56a2580e7aa355befa4f63f2b18d19bdf99f4ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af4b0ed3091b031088bb3a139364bfa03e76f85f53b5998dec1d8048c2e71460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect",
    jsii_struct_bases=[],
    name_mapping={
        "aggregate_lines": "aggregateLines",
        "aggregate_size": "aggregateSize",
        "aggregate_time": "aggregateTime",
        "api_connector": "apiConnector",
        "api_data_elements": "apiDataElements",
        "destination_hostname": "destinationHostname",
        "destination_path": "destinationPath",
        "enabled": "enabled",
        "locked": "locked",
        "override_aggregate_settings": "overrideAggregateSettings",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect:
    def __init__(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8458099356f9644c3d3d4557ed2fcf65b3e2099df95171c725e5a2db5dc43160)
            check_type(argname="argument aggregate_lines", value=aggregate_lines, expected_type=type_hints["aggregate_lines"])
            check_type(argname="argument aggregate_size", value=aggregate_size, expected_type=type_hints["aggregate_size"])
            check_type(argname="argument aggregate_time", value=aggregate_time, expected_type=type_hints["aggregate_time"])
            check_type(argname="argument api_connector", value=api_connector, expected_type=type_hints["api_connector"])
            check_type(argname="argument api_data_elements", value=api_data_elements, expected_type=type_hints["api_data_elements"])
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_aggregate_settings", value=override_aggregate_settings, expected_type=type_hints["override_aggregate_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aggregate_lines is not None:
            self._values["aggregate_lines"] = aggregate_lines
        if aggregate_size is not None:
            self._values["aggregate_size"] = aggregate_size
        if aggregate_time is not None:
            self._values["aggregate_time"] = aggregate_time
        if api_connector is not None:
            self._values["api_connector"] = api_connector
        if api_data_elements is not None:
            self._values["api_data_elements"] = api_data_elements
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if override_aggregate_settings is not None:
            self._values["override_aggregate_settings"] = override_aggregate_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def aggregate_lines(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum number of lines to include in each log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        '''
        result = self._values.get("aggregate_lines")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the log's maximum size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        '''
        result = self._values.get("aggregate_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_time(self) -> typing.Optional[builtins.str]:
        '''Specifies how often logs are generated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        '''
        result = self._values.get("aggregate_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_connector(self) -> typing.Optional[builtins.str]:
        '''Describes the API connector type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        '''
        result = self._values.get("api_connector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_data_elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data set to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        '''
        result = self._values.get("api_data_elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the target hostname accepting push API requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the push API's endpoint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Monitor's log-publishing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_aggregate_settings(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides default log settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        '''
        result = self._values.get("override_aggregate_settings")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b99794d7c4574a61e291c920d2662392b3601252d07abc2a51156b707f476b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAggregateLines")
    def reset_aggregate_lines(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateLines", []))

    @jsii.member(jsii_name="resetAggregateSize")
    def reset_aggregate_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateSize", []))

    @jsii.member(jsii_name="resetAggregateTime")
    def reset_aggregate_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateTime", []))

    @jsii.member(jsii_name="resetApiConnector")
    def reset_api_connector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiConnector", []))

    @jsii.member(jsii_name="resetApiDataElements")
    def reset_api_data_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiDataElements", []))

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideAggregateSettings")
    def reset_override_aggregate_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideAggregateSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aggregateLinesInput")
    def aggregate_lines_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateLinesInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateSizeInput")
    def aggregate_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateTimeInput")
    def aggregate_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="apiConnectorInput")
    def api_connector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiConnectorInput"))

    @builtins.property
    @jsii.member(jsii_name="apiDataElementsInput")
    def api_data_elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "apiDataElementsInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettingsInput")
    def override_aggregate_settings_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideAggregateSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateLines")
    def aggregate_lines(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateLines"))

    @aggregate_lines.setter
    def aggregate_lines(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89080b7fa763727a45c2f8c1eb13ab1e8891d9d4227c7a6c80431f605ba2228f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateLines", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateSize")
    def aggregate_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateSize"))

    @aggregate_size.setter
    def aggregate_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34a0cde06be9ba879837ca1f342799fdf420dfe83290bb0bf615604259670691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateSize", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateTime")
    def aggregate_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateTime"))

    @aggregate_time.setter
    def aggregate_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69b817dc5c520f8ebd64302b8ec770230981e3fd63e5fe81c2185c350508218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateTime", value)

    @builtins.property
    @jsii.member(jsii_name="apiConnector")
    def api_connector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiConnector"))

    @api_connector.setter
    def api_connector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea9bb78870d5efb939ae13e1f7022e347a99b21a79fc9dd8736a76dddebd7ebf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiConnector", value)

    @builtins.property
    @jsii.member(jsii_name="apiDataElements")
    def api_data_elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "apiDataElements"))

    @api_data_elements.setter
    def api_data_elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79400185df641a8e2a95d583f7a5d3fe9c8c90c955692dd66bd01b09bf3b2521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiDataElements", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83451340bd03f8d5a0b90c148f0a8482b1d17bc66c9e29cf3af88080a2c1493e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b5458eb9ed10ed66a14f6cb76053b6b791e29f35beebf952c4ded2f022fe9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf7efd2753be4d1c4ba8b6302d9fe03bdcc089cd9c49617eb341e9623bd2c526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f730fda7a6e30987dc0c30f8c13ad37d7439ee79389e872f13f7328daa45933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettings")
    def override_aggregate_settings(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideAggregateSettings"))

    @override_aggregate_settings.setter
    def override_aggregate_settings(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37c57f2d7ce1317f92aed99bad88a339b99d9811092a2183cd8d1e69e812574c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideAggregateSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501076b72857d0cfbd18d8896609dda27a22e8b1ecbba3198f75abc6e47d7ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54308907c3135eb9e4470915fae9423afc0ce48c0f93e87b04ba7170d626e16d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a612b0bbd597ae6007466fbc3146e9ac238f868244da4fadd8961a577e7eddd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7864bf3665f0c5beb1ec557cfb5667b8e60be7c0e08e7acafd00d9dcea6719f1)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A description of what the ``xml`` block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2ea9de5a4cf9acc8c4d6e25004371e54b803260ab00c847f4e77bd416993417)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf69f04a381b9282bb01c5db673708e8cb4ae97e77638dbc79486eb77988c56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00aa010fea57754ff3e18a1861c99df745160324b18dec174cae40c3a7755da3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc396899ebfda5887a015c0531e921004b4eddb4b546e5e609ce10f6134a8040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a528b00216445ce1c5758abf5f8bff76a4657599c6711686bb5ad1e63c11de1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b543b2aaf0c8dbbff8d036bd47d3d655bd6371c0fa09e8e66df03baf5d700fbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d82249abc51e14194b3b897b5b91b9336e29d96686ba967ee7dca920e9e8f985)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_failover": "enableFailover",
        "failover_rules": "failoverRules",
        "failover_title": "failoverTitle",
        "hostname": "hostname",
        "ip": "ip",
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e259a2fc91c55aad66e99032ae211f3b9ce206f22354010152a6416efe5621d8)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_failover", value=enable_failover, expected_type=type_hints["enable_failover"])
            check_type(argname="argument failover_rules", value=failover_rules, expected_type=type_hints["failover_rules"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_failover is not None:
            self._values["enable_failover"] = enable_failover
        if failover_rules is not None:
            self._values["failover_rules"] = failover_rules
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if hostname is not None:
            self._values["hostname"] = hostname
        if ip is not None:
            self._values["ip"] = ip
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB data center, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify failover rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        '''
        result = self._values.get("enable_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_rules(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]]:
        '''failover_rules block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        '''
        result = self._values.get("failover_rules")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the data center's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip(self) -> typing.Optional[builtins.str]:
        '''Specifies this data center's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    jsii_struct_bases=[],
    name_mapping={
        "absolute_path": "absolutePath",
        "context_root": "contextRoot",
        "failover_hostname": "failoverHostname",
        "modify_request": "modifyRequest",
        "override_hostname": "overrideHostname",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules:
    def __init__(
        self,
        *,
        absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        context_root: typing.Optional[builtins.str] = None,
        failover_hostname: typing.Optional[builtins.str] = None,
        modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param absolute_path: When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        :param context_root: Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        :param failover_hostname: The hostname of the data center to fail over to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        :param modify_request: Allows you to modify the request's hostname or path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        :param override_hostname: Overrides the request's hostname with the ``failover_hostname``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b32c426999290d7242f0c7b32e4569f906a8111837eea1097b3adae21cc6d157)
            check_type(argname="argument absolute_path", value=absolute_path, expected_type=type_hints["absolute_path"])
            check_type(argname="argument context_root", value=context_root, expected_type=type_hints["context_root"])
            check_type(argname="argument failover_hostname", value=failover_hostname, expected_type=type_hints["failover_hostname"])
            check_type(argname="argument modify_request", value=modify_request, expected_type=type_hints["modify_request"])
            check_type(argname="argument override_hostname", value=override_hostname, expected_type=type_hints["override_hostname"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if absolute_path is not None:
            self._values["absolute_path"] = absolute_path
        if context_root is not None:
            self._values["context_root"] = context_root
        if failover_hostname is not None:
            self._values["failover_hostname"] = failover_hostname
        if modify_request is not None:
            self._values["modify_request"] = modify_request
        if override_hostname is not None:
            self._values["override_hostname"] = override_hostname

    @builtins.property
    def absolute_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page.

        Otherwise when disabled, the path is appended to the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        '''
        result = self._values.get("absolute_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def context_root(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        '''
        result = self._values.get("context_root")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_hostname(self) -> typing.Optional[builtins.str]:
        '''The hostname of the data center to fail over to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        '''
        result = self._values.get("failover_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def modify_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the request's hostname or path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        '''
        result = self._values.get("modify_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Overrides the request's hostname with the ``failover_hostname``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        result = self._values.get("override_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bf709f810b3032a8744b0635792c13ba03bd7b263cdeb380cd1b3fe8001e497)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088abb6dc495a64ae6dbdccccf3cd2cbeae2afd2a759b56a2f835f7bbe6e40b0)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e57521043dc9d92b864854e8b41ef332982a0a9132fa41a3159a0c2f0b32eef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02ccddea24925fd96060c8142a5cc37e363f34015dd2420f4bf1e7156b934ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3061d92f78192eab95797eac928c467572fd43c90b6f5dec85ab82725be4bb5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8b3fe3dcc889b4592258997c3a33fc4374cc02de2f37f1a7f3834b734f83779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055f21bb08d7bcbcc297ae3098ecad86d227a3fe89436e43a94c818b4c332e14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAbsolutePath")
    def reset_absolute_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbsolutePath", []))

    @jsii.member(jsii_name="resetContextRoot")
    def reset_context_root(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContextRoot", []))

    @jsii.member(jsii_name="resetFailoverHostname")
    def reset_failover_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverHostname", []))

    @jsii.member(jsii_name="resetModifyRequest")
    def reset_modify_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyRequest", []))

    @jsii.member(jsii_name="resetOverrideHostname")
    def reset_override_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideHostname", []))

    @builtins.property
    @jsii.member(jsii_name="absolutePathInput")
    def absolute_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "absolutePathInput"))

    @builtins.property
    @jsii.member(jsii_name="contextRootInput")
    def context_root_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contextRootInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverHostnameInput")
    def failover_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyRequestInput")
    def modify_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideHostnameInput")
    def override_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="absolutePath")
    def absolute_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "absolutePath"))

    @absolute_path.setter
    def absolute_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21fe2bc4654c704f4ad84cedfc9f316c5d66db7678f411b309f3936a3d316363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "absolutePath", value)

    @builtins.property
    @jsii.member(jsii_name="contextRoot")
    def context_root(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contextRoot"))

    @context_root.setter
    def context_root(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96619dd7a55545efc17e00a504849146ca3451b97a00597a91d758ce3901af26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contextRoot", value)

    @builtins.property
    @jsii.member(jsii_name="failoverHostname")
    def failover_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverHostname"))

    @failover_hostname.setter
    def failover_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb81a40717e9312df45b5fcf777691661db1d810d7904a2806ebbb202ec741fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverHostname", value)

    @builtins.property
    @jsii.member(jsii_name="modifyRequest")
    def modify_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyRequest"))

    @modify_request.setter
    def modify_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__510f88166bb5cbeab17ae903ea04066d5789d6cc6d3b8f49c5bb7e9992eeda87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="overrideHostname")
    def override_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideHostname"))

    @override_hostname.setter
    def override_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549c01c9746d9daad7994fc2e7cdbda17f4af20bbf937d41ce24596560119934)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideHostname", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f132c610832bd5abd56cde961e01b93cc485594b58e2c82b4aed9b0730e25e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3db9043610fdb2f15f42ee62391a259c313d45e416c5d0dc2bd1a971a7f801f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFailoverRules")
    def put_failover_rules(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d25fa9e4b3343d9634b3f7adb85b2d9070f2ec14799d8d46fecdaa68b760022)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverRules", [value]))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableFailover")
    def reset_enable_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableFailover", []))

    @jsii.member(jsii_name="resetFailoverRules")
    def reset_failover_rules(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverRules", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="failoverRules")
    def failover_rules(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesList, jsii.get(self, "failoverRules"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableFailoverInput")
    def enable_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverRulesInput")
    def failover_rules_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "failoverRulesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161d6a5f57a2781609a0dc947368aca70d3e4ddb583cea2395f8d3e3a7618f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6419b1327f93f555eb4eeda04de831401a8c46ab720ec9e2189d3c0e06425e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableFailover")
    def enable_failover(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableFailover"))

    @enable_failover.setter
    def enable_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17432ad10aebabd11d7f973373207f8e9f6c3121dedd1732d0026fa34e32d97b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableFailover", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6557c61e3f889912f68735a4a72dbaa497acc72155364145398aa75feadb7049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__523852360fcbfa8ac1c00001ee854a50c103f5a9978b8c0783fc3623607ca056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ip"))

    @ip.setter
    def ip(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f35f4e6e57b5a6760212d7ac95dcfd9731e356f7e7f8c955621a01462b530a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf23813ff0aa6922db418d0aa6ee518f0882b6be430fe51491ed06430c6b7ec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6188b4dac1d8c9560d7d47f1cb60458aab1d6eba45a183a76a23244bb1af7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e1023a7c5a507aee470c9527f2a4a40a5f69a181c99eb5a60f9c6898e09df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6c0bafbdffa286d34b2ba17f543b83ac6624bbe643f8deb07c8eddb13aa694)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a95e15286d2922ba0ec3579a8f844fc219e120d3c5930376f232b9dd237f11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_session_persistence": "enableSessionPersistence",
        "hostname": "hostname",
        "id": "id",
        "locked": "locked",
        "session_persistence_title": "sessionPersistenceTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf5a88de65b5dfc5aa6bbdd2ba4b0fb7a8d84e3311cd28150662cca26ff1f7f7)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_session_persistence", value=enable_session_persistence, expected_type=type_hints["enable_session_persistence"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_persistence_title", value=session_persistence_title, expected_type=type_hints["session_persistence_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_session_persistence is not None:
            self._values["enable_session_persistence"] = enable_session_persistence
        if hostname is not None:
            self._values["hostname"] = hostname
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if session_persistence_title is not None:
            self._values["session_persistence_title"] = session_persistence_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that marks users' persistent sessions.

        The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB origin, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_session_persistence(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify a cookie to pin the user's browser session to one data center.

        When disabled, ELB's default load balancing may send users to various data centers within the same session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        '''
        result = self._values.get("enable_session_persistence")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname associated with the ELB rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique descriptive string for this ELB origin.

        The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_persistence_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        '''
        result = self._values.get("session_persistence_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1c2c7c24774961ab2eeb3dd67cb9fbd314f2a918f07ad43b9408e401abb6d0e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableSessionPersistence")
    def reset_enable_session_persistence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableSessionPersistence", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionPersistenceTitle")
    def reset_session_persistence_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionPersistenceTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistenceInput")
    def enable_session_persistence_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableSessionPersistenceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitleInput")
    def session_persistence_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sessionPersistenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__544201b4859df17d66c0c718fc4dfa49ece2c9fa74c4bf3e22e99bb2689c05e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e229020c3853419a9703801e2ace2d2ce6ec7f9a2c5916bca1a49d37f4879f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistence")
    def enable_session_persistence(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableSessionPersistence"))

    @enable_session_persistence.setter
    def enable_session_persistence(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad504d777141dea506385e96e011639f4c2ec19606d232cff90da7b35ad5ef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableSessionPersistence", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8887b45e5f1bcb2f0a9bcfcfca8690a963691b0487566194154b3aaf6fd094c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__213830989408a9a236b5a5c9e21bf5b0ac978efdbec47e261ece83564c0238c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42af38b1144285bce5a0af51785247ab54ac46fc4547d51bfcb85c9162b42085)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitle")
    def session_persistence_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sessionPersistenceTitle"))

    @session_persistence_title.setter
    def session_persistence_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__206069db0ddc367adf8a4805c628390786bc73a15fe9b8f7d080aee8e7769021)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionPersistenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa17059a661eff9c3606f1fa7c75ecce02d6f11330c6eff3d11cf912cb2927a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fdc8ac4cbfb2f12f1eb588c44885fa76d2bd46bd17f1c0dddfc4ec747df5980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b760cf3436ee2674a7e340bae9e6850f96eee5fac628244ed26cfe3ddfcbbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "domain": "domain",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b10f610c56b312990d3876e3c8d3d1a4c66267a5343f1c80f1c01f1baac561)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if domain is not None:
            self._values["domain"] = domain
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to use for authorization.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cookie-authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the value of the authorization cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c439b48d7df7a9e4b48f79553317e4c489a07f16b6284182812bdc97b6b39964)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02922206f3306c3252d0d5b65d93e5f95130cb668776c2067a664084a1235dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d39e71fa71aa7f9c0564a8983dabce5cb71d931bd02745a9d61c5cd72dcfa28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66c89a13cef37d1d9a43177fc3f6816583c3a456b403421d223f341ed281e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4da30fd8056a7ff09077646270766304fe7f87f41aef153f7a7fe7c5db7ec4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326b2328cf2ed1cb4a43071757407251f8474cfed741985020b3be3c7e2a3c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc117da78e29dbc951162b64976e6c2dd875333fd862828355e5be6ca0a000cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed91a77c2141b79193c3ca80dc13150decab41b1b21dbcc45d9d0baecbc91634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8c7d2f13f95837312cfe02de7528cc05ccc1d7591d41422380626f5fead65e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd6a82b6513abdd3ca09f4bde7ca6238b2a203f09a32749dcb148655786691eb)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Edge Redirector Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd6c8fa195cb4f619a8496edc770a8cb9fa4d7a5eceb72c659814785db4e15cd)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129100756f677d26c63762ab5ef443b562ed305d023905024dbadfb97ee07d4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__039a1d105cb67b99bd20a029d6491f2ae9e2f7c30754a79d39e6d9babe205048)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a10b780c1ed4e0d4d02fca7c0cd49570a396f5d9a01476c2c3adc0f5f42faac6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d88c5a5be1793214932ed412096ec6b250f8b5b49b7205bd7d9a18bc6178811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7362a4a75b6197c7a06b955cdb7eb2afa61c3b34215a467668c0333391787ed6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7248753ff70acaed1b262ca1626ed64793a67165da31cce68d637f16f373e81a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fdb86e6137bc6b46c5beeb64e3da2f3061ca1fbe55b11e8e396c06940c022e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a31c6d1ae91b1572375ae26e5bc4ead0cfa63f84e5b5d0fdf181e40f9d0766)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00398c231bd3e72f08a21b6dccb497f576992bc6f6309e772adf80c4c61f20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215b3e36547febb8a6a6f3eb662cd80719371253623e902967f49c1050d87b0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__306f1ccb81def0a3bf8160b2acfe14c4b7be8f904ac2c295bee203692c041254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492cea13ee3eb47af257dd913cdd8dec075d9fcc906a395b4ef5f57cdc207dc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8267955331128f8a2dcfd7376c66346ce6c3ceabec5ada3355f10f84860fb1c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__598c3c21aa8da3fbab197b623b35d2c9fb98e9b4f8c54efb4d40e2d0dbd0ad6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f044b4067e5d3f1c928837f35fc9c3cd53c7bf167b89698c42d08111939e498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4163b1bdc06496cf0268e8a797c0994d383ee5ce86e30b8b5b285f2b014a7ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31df6cb3d35677107b9ff303712ec3daa95eb5c5113ba0bce18c100b3824f310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714eec22509ccd6f8452a01e07c1fceffe1de7b7746f9f2b9d6a7e37980fce78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2827bbd7d8b7b716f62659c0700a20f2afa4ffd5cbe7e5d18138450fa6428cd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes",
    jsii_struct_bases=[],
    name_mapping={
        "detect_injection": "detectInjection",
        "enabled": "enabled",
        "enable_via_http": "enableViaHttp",
        "i18_n_charset": "i18NCharset",
        "i18_n_status": "i18NStatus",
        "locked": "locked",
        "pass_client_ip": "passClientIp",
        "pass_set_cookie": "passSetCookie",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes:
    def __init__(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b59a7c1bdfe109cbdbf0c9423d5e7b83b52da6f7210aea3268afe0fd1b7d25)
            check_type(argname="argument detect_injection", value=detect_injection, expected_type=type_hints["detect_injection"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_via_http", value=enable_via_http, expected_type=type_hints["enable_via_http"])
            check_type(argname="argument i18_n_charset", value=i18_n_charset, expected_type=type_hints["i18_n_charset"])
            check_type(argname="argument i18_n_status", value=i18_n_status, expected_type=type_hints["i18_n_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument pass_client_ip", value=pass_client_ip, expected_type=type_hints["pass_client_ip"])
            check_type(argname="argument pass_set_cookie", value=pass_set_cookie, expected_type=type_hints["pass_set_cookie"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if detect_injection is not None:
            self._values["detect_injection"] = detect_injection
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_via_http is not None:
            self._values["enable_via_http"] = enable_via_http
        if i18_n_charset is not None:
            self._values["i18_n_charset"] = i18_n_charset
        if i18_n_status is not None:
            self._values["i18_n_status"] = i18_n_status
        if locked is not None:
            self._values["locked"] = locked
        if pass_client_ip is not None:
            self._values["pass_client_ip"] = pass_client_ip
        if pass_set_cookie is not None:
            self._values["pass_set_cookie"] = pass_set_cookie
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def detect_injection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies attempts to inject ESI code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        '''
        result = self._values.get("detect_injection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ESI processing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_via_http(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        '''
        result = self._values.get("enable_via_http")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def i18_n_charset(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        '''
        result = self._values.get("i18_n_charset")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def i18_n_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Provides internationalization support for ESI.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        '''
        result = self._values.get("i18_n_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass the client IP header to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        '''
        result = self._values.get("pass_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_set_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass your origin server's cookies to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        '''
        result = self._values.get("pass_set_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9bb1937cd73c6ae7107642f6151e945b0c885a1ad6717cf13c48db68e92007)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDetectInjection")
    def reset_detect_injection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectInjection", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableViaHttp")
    def reset_enable_via_http(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableViaHttp", []))

    @jsii.member(jsii_name="resetI18NCharset")
    def reset_i18_n_charset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NCharset", []))

    @jsii.member(jsii_name="resetI18NStatus")
    def reset_i18_n_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPassClientIp")
    def reset_pass_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassClientIp", []))

    @jsii.member(jsii_name="resetPassSetCookie")
    def reset_pass_set_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassSetCookie", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="detectInjectionInput")
    def detect_injection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectInjectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableViaHttpInput")
    def enable_via_http_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableViaHttpInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NCharsetInput")
    def i18_n_charset_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "i18NCharsetInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NStatusInput")
    def i18_n_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "i18NStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="passClientIpInput")
    def pass_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="passSetCookieInput")
    def pass_set_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passSetCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="detectInjection")
    def detect_injection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectInjection"))

    @detect_injection.setter
    def detect_injection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e0203c9b2315cbb57b75a3537b158421cd450ea76148215f953be4fcc67423e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectInjection", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a97fe6f2274a0a720608ca9f8f023a4e0b456c50ed483c2bdd0648f8e89bb27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableViaHttp")
    def enable_via_http(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableViaHttp"))

    @enable_via_http.setter
    def enable_via_http(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67711c7c980395888da27fa445f7130f5eb234e8dd366747397cab1d7ceaec5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableViaHttp", value)

    @builtins.property
    @jsii.member(jsii_name="i18NCharset")
    def i18_n_charset(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "i18NCharset"))

    @i18_n_charset.setter
    def i18_n_charset(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa03fc134b2227a220bb8db42b84754a0282cf8e20da9496c72f915bc5b75cce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NCharset", value)

    @builtins.property
    @jsii.member(jsii_name="i18NStatus")
    def i18_n_status(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "i18NStatus"))

    @i18_n_status.setter
    def i18_n_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40ca64b9e803a64e9bffb02ec9a06eca5beae5651d606bfa9efbc33ac486c2b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80749c85f9aebd0d3d0f42eca37312d4b4efa26a70d2135eedb069120f36983)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="passClientIp")
    def pass_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passClientIp"))

    @pass_client_ip.setter
    def pass_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2626a03b0373557de0f97fcbbfb04c5052a95e5f0581238c45ba69dd89345c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="passSetCookie")
    def pass_set_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passSetCookie"))

    @pass_set_cookie.setter
    def pass_set_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f11d50fc80d349ef70c0d60dfee2e9cb9af3c2420c6d3e815369703236da9cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passSetCookie", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f24521ff9065e3b31bcb8dcdaffb281cc215bebb65f772105eb8cd92b7997b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42135965537c9eb8d2a63e68a8847f128e00cae740150970f5be0923b36091dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78eac90a3da074c90c3421697533c903861bc58c41d8b86c1cc1517fa5ef0d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker",
    jsii_struct_bases=[],
    name_mapping={
        "create_edge_worker": "createEdgeWorker",
        "edge_worker_id": "edgeWorkerId",
        "enabled": "enabled",
        "locked": "locked",
        "m_pulse": "mPulse",
        "m_pulse_information": "mPulseInformation",
        "resource_tier": "resourceTier",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker:
    def __init__(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse_information: typing.Optional[builtins.str] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param m_pulse: Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see ``Integrate mPulse reports with EdgeWorkers``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param m_pulse_information: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e408162cb7797b816ebb4c2d06af714275645ceda4f58b33aa417bfbeede9930)
            check_type(argname="argument create_edge_worker", value=create_edge_worker, expected_type=type_hints["create_edge_worker"])
            check_type(argname="argument edge_worker_id", value=edge_worker_id, expected_type=type_hints["edge_worker_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument m_pulse_information", value=m_pulse_information, expected_type=type_hints["m_pulse_information"])
            check_type(argname="argument resource_tier", value=resource_tier, expected_type=type_hints["resource_tier"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if create_edge_worker is not None:
            self._values["create_edge_worker"] = create_edge_worker
        if edge_worker_id is not None:
            self._values["edge_worker_id"] = edge_worker_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if m_pulse_information is not None:
            self._values["m_pulse_information"] = m_pulse_information
        if resource_tier is not None:
            self._values["resource_tier"] = resource_tier
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def create_edge_worker(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        '''
        result = self._values.get("create_edge_worker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def edge_worker_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the EdgeWorker application to apply to this rule's web traffic.

        You can use the ``EdgeWorkers API`` to get this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        '''
        result = self._values.get("edge_worker_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies specified EdgeWorker functionality to this rule's web traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors.

        For more details, see ``Integrate mPulse reports with EdgeWorkers``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def m_pulse_information(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        '''
        result = self._values.get("m_pulse_information")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resource_tier(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        '''
        result = self._values.get("resource_tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d912b2223fcaba9b494cec6564d73e6c10d91ec2b8d992886c543e020c1d7c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCreateEdgeWorker")
    def reset_create_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreateEdgeWorker", []))

    @jsii.member(jsii_name="resetEdgeWorkerId")
    def reset_edge_worker_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkerId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetMPulseInformation")
    def reset_m_pulse_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulseInformation", []))

    @jsii.member(jsii_name="resetResourceTier")
    def reset_resource_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceTier", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorkerInput")
    def create_edge_worker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "createEdgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerIdInput")
    def edge_worker_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "edgeWorkerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInformationInput")
    def m_pulse_information_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mPulseInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceTierInput")
    def resource_tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "resourceTierInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorker")
    def create_edge_worker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "createEdgeWorker"))

    @create_edge_worker.setter
    def create_edge_worker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf6f47b3bc0dbc46c833a237af9ac57f948bf73f79a238c7df1d293bc3cec72f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createEdgeWorker", value)

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerId")
    def edge_worker_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "edgeWorkerId"))

    @edge_worker_id.setter
    def edge_worker_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc8108265bc6e73e2e2c6f861042acc3e7a5f1a20e48c2d5b6f8e2c7a1c8795a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "edgeWorkerId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c7ef69b8424fa0e25987dc7dc3feb471f8b55e86bd80f83764f59ad82ea5441)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d9884e3e1b2addbc6318ce622a4916eb1cd445308d54bef15ff4dcfe1ee2d34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mPulse"))

    @m_pulse.setter
    def m_pulse(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c61a5c3c78bb3b9e00b0d1476d782e754411957e70feb800355bc5d001dd9ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mPulse", value)

    @builtins.property
    @jsii.member(jsii_name="mPulseInformation")
    def m_pulse_information(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mPulseInformation"))

    @m_pulse_information.setter
    def m_pulse_information(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f009685528001419ff65809e9a648b05679dfdc75fc88ef089bba471d2975602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mPulseInformation", value)

    @builtins.property
    @jsii.member(jsii_name="resourceTier")
    def resource_tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "resourceTier"))

    @resource_tier.setter
    def resource_tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97ead9da3ed58d6ad3478ae279b6c3aeb1d9665e81747bc7d55e8fd45a10238)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resourceTier", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d97a9f0ad8c05e496b5a68cb6910f33875a495f3171fc670f27d292df0f894e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026abf369f38f822f78f36ec6d87330d17b8d644ef414c592cd4e306ee9cd728)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b461fb0d862983a591c5564495ffbdf19ad09ebae3fb8b95bb5909568c35dbab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_authority_set": "certificateAuthoritySet",
        "enable_auth_set": "enableAuthSet",
        "enable_deny_request": "enableDenyRequest",
        "enable_ocsp_status": "enableOcspStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings:
    def __init__(
        self,
        *,
        certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_authority_set: Specify the client certificate authority (CA) sets you want to support in client requests. Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        :param enable_auth_set: Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        :param enable_deny_request: This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        :param enable_ocsp_status: Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab3c61937beef34362c849a4157235ca08e594aa6c6fced27738de4d02410a9)
            check_type(argname="argument certificate_authority_set", value=certificate_authority_set, expected_type=type_hints["certificate_authority_set"])
            check_type(argname="argument enable_auth_set", value=enable_auth_set, expected_type=type_hints["enable_auth_set"])
            check_type(argname="argument enable_deny_request", value=enable_deny_request, expected_type=type_hints["enable_deny_request"])
            check_type(argname="argument enable_ocsp_status", value=enable_ocsp_status, expected_type=type_hints["enable_ocsp_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_authority_set is not None:
            self._values["certificate_authority_set"] = certificate_authority_set
        if enable_auth_set is not None:
            self._values["enable_auth_set"] = enable_auth_set
        if enable_deny_request is not None:
            self._values["enable_deny_request"] = enable_deny_request
        if enable_ocsp_status is not None:
            self._values["enable_ocsp_status"] = enable_ocsp_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_authority_set(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify the client certificate authority (CA) sets you want to support in client requests.

        Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        '''
        result = self._values.get("certificate_authority_set")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_auth_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        '''
        result = self._values.get("enable_auth_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_deny_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This denies a request from a client that doesn't match what you've set for the options in this behavior.

        When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        '''
        result = self._values.get("enable_deny_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ocsp_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP).

        OCSP can determine the x.509 certificate revocation status during the TLS handshake.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        '''
        result = self._values.get("enable_ocsp_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786eee57da3f99b0dbcdf9754fd986264896fe552b62e535820d2109a445ae2c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateAuthoritySet")
    def reset_certificate_authority_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateAuthoritySet", []))

    @jsii.member(jsii_name="resetEnableAuthSet")
    def reset_enable_auth_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAuthSet", []))

    @jsii.member(jsii_name="resetEnableDenyRequest")
    def reset_enable_deny_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableDenyRequest", []))

    @jsii.member(jsii_name="resetEnableOcspStatus")
    def reset_enable_ocsp_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableOcspStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateAuthoritySetInput")
    def certificate_authority_set_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "certificateAuthoritySetInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAuthSetInput")
    def enable_auth_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAuthSetInput"))

    @builtins.property
    @jsii.member(jsii_name="enableDenyRequestInput")
    def enable_deny_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableDenyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="enableOcspStatusInput")
    def enable_ocsp_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableOcspStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateAuthoritySet")
    def certificate_authority_set(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "certificateAuthoritySet"))

    @certificate_authority_set.setter
    def certificate_authority_set(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774ed4fbd56b2b7b734efd2deb1c51c077765afefd2b695e9ce82421bc2677a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateAuthoritySet", value)

    @builtins.property
    @jsii.member(jsii_name="enableAuthSet")
    def enable_auth_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAuthSet"))

    @enable_auth_set.setter
    def enable_auth_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79896765075e204ab88797f39a090c65c47961d5873e415638590d65dd38e6fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAuthSet", value)

    @builtins.property
    @jsii.member(jsii_name="enableDenyRequest")
    def enable_deny_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableDenyRequest"))

    @enable_deny_request.setter
    def enable_deny_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1437a6eac12191d28615bc36af48aaf8b7c0e0eb1ba02901a20966aff3f8cfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableDenyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="enableOcspStatus")
    def enable_ocsp_status(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableOcspStatus"))

    @enable_ocsp_status.setter
    def enable_ocsp_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__557e163b113dc93b852fe872dde1f268bc5ba4b156592114e37d888f1dc5fc01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableOcspStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39425083064bf314e69f5516c6a4799f1a943dcc989682ad37efd7770cf3340d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9934223606e38dcee45a8658cb85de833feea0378f247483fcc57c95efe7ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f55ef1ea045cb9a83854e16bb4dd9a449d02f9a21d1ebfee1d2406bbc8527431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8fdf86a5ef7918f47afc532c2a3b1408f47837f533fa19e7fd816776f1dac2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c70f15bef530f9272d78d46bf83611e2cd8da4bc1429b25a1f1dfd1ce6a406)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__963460d5aa068259dbd9489285fa4277b7edb0ad81c1bf74f00c638d1865fad3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7562d41ef732aa00ed60fe4466be9fb931b5643b16c7ee75b261a553451ba39a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aff0d38352d4b05fe780b0b81ded1aa3c378c620d61aed7e4a312862bc1986b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eacc33aa8ba50eba977e432c6e3273b023ac4f3f7396b4dd7ebffb9aeebc538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15357abd8a0b16e4607a8409fc6a54e0e37cc5a4c7caea3f29a178005c8120f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea65f3b62fa387071badfa4149e9c17159a2f4887a0a925a0f1ffbc025e9cc0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous_vpn": "anonymousVpn",
        "best_practice_action": "bestPracticeAction",
        "best_practice_redirecturl": "bestPracticeRedirecturl",
        "detect_anonymous_vpn": "detectAnonymousVpn",
        "detect_anonymous_vpn_action": "detectAnonymousVpnAction",
        "detect_anonymous_vpn_redirecturl": "detectAnonymousVpnRedirecturl",
        "detect_hosting_provider": "detectHostingProvider",
        "detect_hosting_provider_action": "detectHostingProviderAction",
        "detect_hosting_provider_redirecturl": "detectHostingProviderRedirecturl",
        "detect_public_proxy": "detectPublicProxy",
        "detect_public_proxy_action": "detectPublicProxyAction",
        "detect_public_proxy_redirecturl": "detectPublicProxyRedirecturl",
        "detect_residential_proxy": "detectResidentialProxy",
        "detect_residential_proxy_action": "detectResidentialProxyAction",
        "detect_residential_proxy_redirecturl": "detectResidentialProxyRedirecturl",
        "detect_smart_dns_proxy": "detectSmartDnsProxy",
        "detect_smart_dns_proxy_action": "detectSmartDnsProxyAction",
        "detect_smart_dns_proxy_redirecturl": "detectSmartDnsProxyRedirecturl",
        "detect_tor_exit_node": "detectTorExitNode",
        "detect_tor_exit_node_action": "detectTorExitNodeAction",
        "detect_tor_exit_node_redirecturl": "detectTorExitNodeRedirecturl",
        "detect_vpn_data_center": "detectVpnDataCenter",
        "detect_vpn_data_center_action": "detectVpnDataCenterAction",
        "detect_vpn_data_center_redirecturl": "detectVpnDataCenterRedirecturl",
        "enable_configuration_mode": "enableConfigurationMode",
        "enabled": "enabled",
        "forward_header_enrichment": "forwardHeaderEnrichment",
        "hosting_provider": "hostingProvider",
        "locked": "locked",
        "public_proxy": "publicProxy",
        "residential_proxy": "residentialProxy",
        "smart_dns_proxy": "smartDnsProxy",
        "template_uuid": "templateUuid",
        "tor_exit_node": "torExitNode",
        "uuid": "uuid",
        "vpn_data_center": "vpnDataCenter",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection:
    def __init__(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eeba1edc659378f5bb012ed4d1735eb48df456f88b88f3c1c947bbd10980e02)
            check_type(argname="argument anonymous_vpn", value=anonymous_vpn, expected_type=type_hints["anonymous_vpn"])
            check_type(argname="argument best_practice_action", value=best_practice_action, expected_type=type_hints["best_practice_action"])
            check_type(argname="argument best_practice_redirecturl", value=best_practice_redirecturl, expected_type=type_hints["best_practice_redirecturl"])
            check_type(argname="argument detect_anonymous_vpn", value=detect_anonymous_vpn, expected_type=type_hints["detect_anonymous_vpn"])
            check_type(argname="argument detect_anonymous_vpn_action", value=detect_anonymous_vpn_action, expected_type=type_hints["detect_anonymous_vpn_action"])
            check_type(argname="argument detect_anonymous_vpn_redirecturl", value=detect_anonymous_vpn_redirecturl, expected_type=type_hints["detect_anonymous_vpn_redirecturl"])
            check_type(argname="argument detect_hosting_provider", value=detect_hosting_provider, expected_type=type_hints["detect_hosting_provider"])
            check_type(argname="argument detect_hosting_provider_action", value=detect_hosting_provider_action, expected_type=type_hints["detect_hosting_provider_action"])
            check_type(argname="argument detect_hosting_provider_redirecturl", value=detect_hosting_provider_redirecturl, expected_type=type_hints["detect_hosting_provider_redirecturl"])
            check_type(argname="argument detect_public_proxy", value=detect_public_proxy, expected_type=type_hints["detect_public_proxy"])
            check_type(argname="argument detect_public_proxy_action", value=detect_public_proxy_action, expected_type=type_hints["detect_public_proxy_action"])
            check_type(argname="argument detect_public_proxy_redirecturl", value=detect_public_proxy_redirecturl, expected_type=type_hints["detect_public_proxy_redirecturl"])
            check_type(argname="argument detect_residential_proxy", value=detect_residential_proxy, expected_type=type_hints["detect_residential_proxy"])
            check_type(argname="argument detect_residential_proxy_action", value=detect_residential_proxy_action, expected_type=type_hints["detect_residential_proxy_action"])
            check_type(argname="argument detect_residential_proxy_redirecturl", value=detect_residential_proxy_redirecturl, expected_type=type_hints["detect_residential_proxy_redirecturl"])
            check_type(argname="argument detect_smart_dns_proxy", value=detect_smart_dns_proxy, expected_type=type_hints["detect_smart_dns_proxy"])
            check_type(argname="argument detect_smart_dns_proxy_action", value=detect_smart_dns_proxy_action, expected_type=type_hints["detect_smart_dns_proxy_action"])
            check_type(argname="argument detect_smart_dns_proxy_redirecturl", value=detect_smart_dns_proxy_redirecturl, expected_type=type_hints["detect_smart_dns_proxy_redirecturl"])
            check_type(argname="argument detect_tor_exit_node", value=detect_tor_exit_node, expected_type=type_hints["detect_tor_exit_node"])
            check_type(argname="argument detect_tor_exit_node_action", value=detect_tor_exit_node_action, expected_type=type_hints["detect_tor_exit_node_action"])
            check_type(argname="argument detect_tor_exit_node_redirecturl", value=detect_tor_exit_node_redirecturl, expected_type=type_hints["detect_tor_exit_node_redirecturl"])
            check_type(argname="argument detect_vpn_data_center", value=detect_vpn_data_center, expected_type=type_hints["detect_vpn_data_center"])
            check_type(argname="argument detect_vpn_data_center_action", value=detect_vpn_data_center_action, expected_type=type_hints["detect_vpn_data_center_action"])
            check_type(argname="argument detect_vpn_data_center_redirecturl", value=detect_vpn_data_center_redirecturl, expected_type=type_hints["detect_vpn_data_center_redirecturl"])
            check_type(argname="argument enable_configuration_mode", value=enable_configuration_mode, expected_type=type_hints["enable_configuration_mode"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_header_enrichment", value=forward_header_enrichment, expected_type=type_hints["forward_header_enrichment"])
            check_type(argname="argument hosting_provider", value=hosting_provider, expected_type=type_hints["hosting_provider"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument public_proxy", value=public_proxy, expected_type=type_hints["public_proxy"])
            check_type(argname="argument residential_proxy", value=residential_proxy, expected_type=type_hints["residential_proxy"])
            check_type(argname="argument smart_dns_proxy", value=smart_dns_proxy, expected_type=type_hints["smart_dns_proxy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tor_exit_node", value=tor_exit_node, expected_type=type_hints["tor_exit_node"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument vpn_data_center", value=vpn_data_center, expected_type=type_hints["vpn_data_center"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous_vpn is not None:
            self._values["anonymous_vpn"] = anonymous_vpn
        if best_practice_action is not None:
            self._values["best_practice_action"] = best_practice_action
        if best_practice_redirecturl is not None:
            self._values["best_practice_redirecturl"] = best_practice_redirecturl
        if detect_anonymous_vpn is not None:
            self._values["detect_anonymous_vpn"] = detect_anonymous_vpn
        if detect_anonymous_vpn_action is not None:
            self._values["detect_anonymous_vpn_action"] = detect_anonymous_vpn_action
        if detect_anonymous_vpn_redirecturl is not None:
            self._values["detect_anonymous_vpn_redirecturl"] = detect_anonymous_vpn_redirecturl
        if detect_hosting_provider is not None:
            self._values["detect_hosting_provider"] = detect_hosting_provider
        if detect_hosting_provider_action is not None:
            self._values["detect_hosting_provider_action"] = detect_hosting_provider_action
        if detect_hosting_provider_redirecturl is not None:
            self._values["detect_hosting_provider_redirecturl"] = detect_hosting_provider_redirecturl
        if detect_public_proxy is not None:
            self._values["detect_public_proxy"] = detect_public_proxy
        if detect_public_proxy_action is not None:
            self._values["detect_public_proxy_action"] = detect_public_proxy_action
        if detect_public_proxy_redirecturl is not None:
            self._values["detect_public_proxy_redirecturl"] = detect_public_proxy_redirecturl
        if detect_residential_proxy is not None:
            self._values["detect_residential_proxy"] = detect_residential_proxy
        if detect_residential_proxy_action is not None:
            self._values["detect_residential_proxy_action"] = detect_residential_proxy_action
        if detect_residential_proxy_redirecturl is not None:
            self._values["detect_residential_proxy_redirecturl"] = detect_residential_proxy_redirecturl
        if detect_smart_dns_proxy is not None:
            self._values["detect_smart_dns_proxy"] = detect_smart_dns_proxy
        if detect_smart_dns_proxy_action is not None:
            self._values["detect_smart_dns_proxy_action"] = detect_smart_dns_proxy_action
        if detect_smart_dns_proxy_redirecturl is not None:
            self._values["detect_smart_dns_proxy_redirecturl"] = detect_smart_dns_proxy_redirecturl
        if detect_tor_exit_node is not None:
            self._values["detect_tor_exit_node"] = detect_tor_exit_node
        if detect_tor_exit_node_action is not None:
            self._values["detect_tor_exit_node_action"] = detect_tor_exit_node_action
        if detect_tor_exit_node_redirecturl is not None:
            self._values["detect_tor_exit_node_redirecturl"] = detect_tor_exit_node_redirecturl
        if detect_vpn_data_center is not None:
            self._values["detect_vpn_data_center"] = detect_vpn_data_center
        if detect_vpn_data_center_action is not None:
            self._values["detect_vpn_data_center_action"] = detect_vpn_data_center_action
        if detect_vpn_data_center_redirecturl is not None:
            self._values["detect_vpn_data_center_redirecturl"] = detect_vpn_data_center_redirecturl
        if enable_configuration_mode is not None:
            self._values["enable_configuration_mode"] = enable_configuration_mode
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_header_enrichment is not None:
            self._values["forward_header_enrichment"] = forward_header_enrichment
        if hosting_provider is not None:
            self._values["hosting_provider"] = hosting_provider
        if locked is not None:
            self._values["locked"] = locked
        if public_proxy is not None:
            self._values["public_proxy"] = public_proxy
        if residential_proxy is not None:
            self._values["residential_proxy"] = residential_proxy
        if smart_dns_proxy is not None:
            self._values["smart_dns_proxy"] = smart_dns_proxy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tor_exit_node is not None:
            self._values["tor_exit_node"] = tor_exit_node
        if uuid is not None:
            self._values["uuid"] = uuid
        if vpn_data_center is not None:
            self._values["vpn_data_center"] = vpn_data_center

    @builtins.property
    def anonymous_vpn(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        '''
        result = self._values.get("anonymous_vpn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        '''
        result = self._values.get("best_practice_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        '''
        result = self._values.get("best_practice_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from anonymous VPNs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        '''
        result = self._values.get("detect_anonymous_vpn")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_anonymous_vpn_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        '''
        result = self._values.get("detect_anonymous_vpn_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        '''
        result = self._values.get("detect_anonymous_vpn_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This detects requests from a hosting provider.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        '''
        result = self._values.get("detect_hosting_provider")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_hosting_provider_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        '''
        result = self._values.get("detect_hosting_provider_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the absolute URL to which to redirect requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        '''
        result = self._values.get("detect_hosting_provider_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from public proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        '''
        result = self._values.get("detect_public_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_public_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        '''
        result = self._values.get("detect_public_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        '''
        result = self._values.get("detect_public_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from a residential proxy.

        See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        '''
        result = self._values.get("detect_residential_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_residential_proxy_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        '''
        result = self._values.get("detect_residential_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        '''
        result = self._values.get("detect_residential_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from smart DNS proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        '''
        result = self._values.get("detect_smart_dns_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_smart_dns_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        '''
        result = self._values.get("detect_smart_dns_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        '''
        result = self._values.get("detect_smart_dns_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        '''
        result = self._values.get("detect_tor_exit_node")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_tor_exit_node_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        '''
        result = self._values.get("detect_tor_exit_node_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        '''
        result = self._values.get("detect_tor_exit_node_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        '''
        result = self._values.get("detect_vpn_data_center")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_vpn_data_center_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        '''
        result = self._values.get("detect_vpn_data_center_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        '''
        result = self._values.get("detect_vpn_data_center_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_configuration_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        '''
        result = self._values.get("enable_configuration_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies GeoGuard proxy detection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_header_enrichment(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation.

        See the ``epdForwardHeaderEnrichment`` behavior for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        '''
        result = self._values.get("forward_header_enrichment")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hosting_provider(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        '''
        result = self._values.get("hosting_provider")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def public_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        '''
        result = self._values.get("public_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def residential_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        '''
        result = self._values.get("residential_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smart_dns_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        '''
        result = self._values.get("smart_dns_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tor_exit_node(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        '''
        result = self._values.get("tor_exit_node")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vpn_data_center(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        result = self._values.get("vpn_data_center")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b62bc6a9c1cfe6de0782a16628f0f82795a43121dd135eb1ae43a6505b430d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymousVpn")
    def reset_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymousVpn", []))

    @jsii.member(jsii_name="resetBestPracticeAction")
    def reset_best_practice_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeAction", []))

    @jsii.member(jsii_name="resetBestPracticeRedirecturl")
    def reset_best_practice_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpn")
    def reset_detect_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpn", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnAction")
    def reset_detect_anonymous_vpn_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnAction", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnRedirecturl")
    def reset_detect_anonymous_vpn_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnRedirecturl", []))

    @jsii.member(jsii_name="resetDetectHostingProvider")
    def reset_detect_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProvider", []))

    @jsii.member(jsii_name="resetDetectHostingProviderAction")
    def reset_detect_hosting_provider_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderAction", []))

    @jsii.member(jsii_name="resetDetectHostingProviderRedirecturl")
    def reset_detect_hosting_provider_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderRedirecturl", []))

    @jsii.member(jsii_name="resetDetectPublicProxy")
    def reset_detect_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxy", []))

    @jsii.member(jsii_name="resetDetectPublicProxyAction")
    def reset_detect_public_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyAction", []))

    @jsii.member(jsii_name="resetDetectPublicProxyRedirecturl")
    def reset_detect_public_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectResidentialProxy")
    def reset_detect_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxy", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyAction")
    def reset_detect_residential_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyAction", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyRedirecturl")
    def reset_detect_residential_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxy")
    def reset_detect_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxy", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyAction")
    def reset_detect_smart_dns_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyAction", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyRedirecturl")
    def reset_detect_smart_dns_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectTorExitNode")
    def reset_detect_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNode", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeAction")
    def reset_detect_tor_exit_node_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeAction", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeRedirecturl")
    def reset_detect_tor_exit_node_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenter")
    def reset_detect_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenter", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterAction")
    def reset_detect_vpn_data_center_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterAction", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterRedirecturl")
    def reset_detect_vpn_data_center_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterRedirecturl", []))

    @jsii.member(jsii_name="resetEnableConfigurationMode")
    def reset_enable_configuration_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableConfigurationMode", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardHeaderEnrichment")
    def reset_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetHostingProvider")
    def reset_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostingProvider", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPublicProxy")
    def reset_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicProxy", []))

    @jsii.member(jsii_name="resetResidentialProxy")
    def reset_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResidentialProxy", []))

    @jsii.member(jsii_name="resetSmartDnsProxy")
    def reset_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmartDnsProxy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTorExitNode")
    def reset_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTorExitNode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVpnDataCenter")
    def reset_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVpnDataCenter", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpnInput")
    def anonymous_vpn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "anonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeActionInput")
    def best_practice_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturlInput")
    def best_practice_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnActionInput")
    def detect_anonymous_vpn_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnInput")
    def detect_anonymous_vpn_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectAnonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturlInput")
    def detect_anonymous_vpn_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderActionInput")
    def detect_hosting_provider_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderInput")
    def detect_hosting_provider_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectHostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturlInput")
    def detect_hosting_provider_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyActionInput")
    def detect_public_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyInput")
    def detect_public_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectPublicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturlInput")
    def detect_public_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyActionInput")
    def detect_residential_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyInput")
    def detect_residential_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectResidentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturlInput")
    def detect_residential_proxy_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyActionInput")
    def detect_smart_dns_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyInput")
    def detect_smart_dns_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectSmartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturlInput")
    def detect_smart_dns_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeActionInput")
    def detect_tor_exit_node_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeInput")
    def detect_tor_exit_node_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectTorExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturlInput")
    def detect_tor_exit_node_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterActionInput")
    def detect_vpn_data_center_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterInput")
    def detect_vpn_data_center_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectVpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturlInput")
    def detect_vpn_data_center_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationModeInput")
    def enable_configuration_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enableConfigurationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichmentInput")
    def forward_header_enrichment_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="hostingProviderInput")
    def hosting_provider_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="publicProxyInput")
    def public_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="residentialProxyInput")
    def residential_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "residentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxyInput")
    def smart_dns_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "smartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="torExitNodeInput")
    def tor_exit_node_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "torExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenterInput")
    def vpn_data_center_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "vpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpn")
    def anonymous_vpn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "anonymousVpn"))

    @anonymous_vpn.setter
    def anonymous_vpn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323f73d5a0bb9b0d66f3afb997efe53e36a1268b9027de4df39c8dfd607752d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeAction")
    def best_practice_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeAction"))

    @best_practice_action.setter
    def best_practice_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280a2a0b6e6b0a15015f0f783ac5d26c55783d50798015374f40e279d3f77be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeAction", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturl")
    def best_practice_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeRedirecturl"))

    @best_practice_redirecturl.setter
    def best_practice_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f27954554afb0bb31135139813b9738325c8acaac66e80050daf2c29f257c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpn")
    def detect_anonymous_vpn(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectAnonymousVpn"))

    @detect_anonymous_vpn.setter
    def detect_anonymous_vpn(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16398dfbf452ff91adcfc885a677d3a4f6ac324426d6da3a572f0d85affceaac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnAction")
    def detect_anonymous_vpn_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnAction"))

    @detect_anonymous_vpn_action.setter
    def detect_anonymous_vpn_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d8c6751ce3e0a9ba9462b468a42401cd1cbd8c9f32e93fecd4206b1a8b5db29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturl")
    def detect_anonymous_vpn_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnRedirecturl"))

    @detect_anonymous_vpn_redirecturl.setter
    def detect_anonymous_vpn_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__692e0f197f7e3229343e9d7870cc6cc85970d86d96049d4f32915dd0acf7a0bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProvider")
    def detect_hosting_provider(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectHostingProvider"))

    @detect_hosting_provider.setter
    def detect_hosting_provider(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb142f8f834297f3a9fce0b7049ad27f8e9442644b97737948411d2dd49e961e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderAction")
    def detect_hosting_provider_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderAction"))

    @detect_hosting_provider_action.setter
    def detect_hosting_provider_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf8b7b80017391e055fd62a8beafe0181b494e12b2bfe1378248480e039ef79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturl")
    def detect_hosting_provider_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderRedirecturl"))

    @detect_hosting_provider_redirecturl.setter
    def detect_hosting_provider_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed6346b0f03aba1f4f54f6054d7b050a7d549f790a65d6fd5078f8ee8f73f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxy")
    def detect_public_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectPublicProxy"))

    @detect_public_proxy.setter
    def detect_public_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ed43a784343d2d4f820ad9b1c408590ab45fc918e6c6fe5ca9591af6892bc31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyAction")
    def detect_public_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyAction"))

    @detect_public_proxy_action.setter
    def detect_public_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c0796d7add38b9f253121c571f0d8a0a349ed88c81bd1c2575d7d24578a486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturl")
    def detect_public_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyRedirecturl"))

    @detect_public_proxy_redirecturl.setter
    def detect_public_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__892e445940bab34f8c61a5ca91a75da4996390f1b8b35d241c6a20cd3c17ba1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxy")
    def detect_residential_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectResidentialProxy"))

    @detect_residential_proxy.setter
    def detect_residential_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9d6476d7a8e4261662749574f5f1686d8eba7fbbe92d63384ac40d741812f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyAction")
    def detect_residential_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyAction"))

    @detect_residential_proxy_action.setter
    def detect_residential_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0c1d7ba0252a1d270fa7621292013097118da18d6c58843464484004e4afee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturl")
    def detect_residential_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyRedirecturl"))

    @detect_residential_proxy_redirecturl.setter
    def detect_residential_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270a49c72153d5f63cca887c93f912a69f93959414c6f5b158edf7369730d3a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxy")
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectSmartDnsProxy"))

    @detect_smart_dns_proxy.setter
    def detect_smart_dns_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d95f5281237e2b1fcb64ce786b5dc9ed8347bc66521fe625484306cb13e95c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyAction")
    def detect_smart_dns_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyAction"))

    @detect_smart_dns_proxy_action.setter
    def detect_smart_dns_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81785a3bdbbbb907a4539cf513f0999e89bf6e6d09d3eb46b71e6e0de341b184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturl")
    def detect_smart_dns_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyRedirecturl"))

    @detect_smart_dns_proxy_redirecturl.setter
    def detect_smart_dns_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4dfe6f863e1681bcc35fdba9a951be7de42441a300f46ddf8a7dba606f480f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNode")
    def detect_tor_exit_node(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectTorExitNode"))

    @detect_tor_exit_node.setter
    def detect_tor_exit_node(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe29eb934617a87a1f599488173e9fdd0a0ef84f26b1dbfbf8b272a838915d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeAction")
    def detect_tor_exit_node_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeAction"))

    @detect_tor_exit_node_action.setter
    def detect_tor_exit_node_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__371a3c1f3b95604c373276ba98198401ba31126f466dd55e26e0a0d79bda23db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturl")
    def detect_tor_exit_node_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeRedirecturl"))

    @detect_tor_exit_node_redirecturl.setter
    def detect_tor_exit_node_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b695a8b5655536fef767a7531fbc0a00a247b958173d304502baa428adff791d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenter")
    def detect_vpn_data_center(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectVpnDataCenter"))

    @detect_vpn_data_center.setter
    def detect_vpn_data_center(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dee3e78d09fd1e09e275bbf3b2be0bc71e820b5b3983a2f53748d8ade1dffbeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterAction")
    def detect_vpn_data_center_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterAction"))

    @detect_vpn_data_center_action.setter
    def detect_vpn_data_center_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d2544276652f6cbf19592fb1e4563d2c520e9c78dd374871ff2d5fb0600dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturl")
    def detect_vpn_data_center_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterRedirecturl"))

    @detect_vpn_data_center_redirecturl.setter
    def detect_vpn_data_center_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2df56d790f92e4e72ac2b782303740c2cf53a46f7476aa14f77f3702e52616d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationMode")
    def enable_configuration_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enableConfigurationMode"))

    @enable_configuration_mode.setter
    def enable_configuration_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b596c71447e1f90d14b0205c41bef1904a0cb4b34e7c90e37a76d676481bdc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableConfigurationMode", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2aba021f673372a55ea2f3295097e9dc7dc24b112701afd658f833bcb75d9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichment")
    def forward_header_enrichment(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forwardHeaderEnrichment"))

    @forward_header_enrichment.setter
    def forward_header_enrichment(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__533287e5dbf8d0adb09900dffc9a00cd1ba311728710a4cebebba726f43b1a1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHeaderEnrichment", value)

    @builtins.property
    @jsii.member(jsii_name="hostingProvider")
    def hosting_provider(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostingProvider"))

    @hosting_provider.setter
    def hosting_provider(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a62310185f98e42e834dfa9a9af5c9034433b8339a7bd3ed1c343c7f1857856a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__177a9b18ef382d8449285909cb49cc62e5e63313eb5305f60360ab849d8a9d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="publicProxy")
    def public_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicProxy"))

    @public_proxy.setter
    def public_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74222b121bc25841556194c66f0182e4cb77d110de3d69d733b467c3f67224dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="residentialProxy")
    def residential_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "residentialProxy"))

    @residential_proxy.setter
    def residential_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5270515955d5c8ec63e3d8c7f9f21e2c857882d512f60fe0272c4599b0d68e71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "residentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxy")
    def smart_dns_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "smartDnsProxy"))

    @smart_dns_proxy.setter
    def smart_dns_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f19fe1a19a9922e5e50b57a24acae217e56b9fca56372112c71d5d2c6e252da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f9c671c043a783ce7e818ea83befe6dfeb137f00d575c8967385e24c5066015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="torExitNode")
    def tor_exit_node(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "torExitNode"))

    @tor_exit_node.setter
    def tor_exit_node(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91e2142bb090bfb84eea4e19a332a6206c73de112ac1ebcacd4d64dff1685942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "torExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a86e55f4e928dd513b9bd9dc315b0af0df77db5eb301f5355b9bd4165307ebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenter")
    def vpn_data_center(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vpnDataCenter"))

    @vpn_data_center.setter
    def vpn_data_center(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78886045f80ed9271a70b43a621e3775b7677d79de1f5a54ca103365f2b13591)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f6b8dfcfff234bf354d3af7c945011ef8f72064d5807883b7b3a6dbb0dd5eb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e7f4863fbde395c3ee13956120873c563ba944030403961fcba396bf44a396f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy.

        The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac23e4fbf8cac48c093733e208525590921e7200832077925781214e461758a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e1aee87917e2a47a65a6624902a6cd0d1f4ecdcc6ef66052f584b00a51b242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1f3a0f15f370333b44ecabd2fc6a3d2b94226003530587c3e6a969aedf13ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0353dd20fc122857c130934594b84206ae2a0c58d5f61582f0e439a26b0661f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5da146891f626e554b192b901a7b9854a712f244357dffa60c2826ae454d4d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2a19ef83a01f89674f607d2d1dccd98be3bca74a15567d0efc3691891f3e6f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction",
    jsii_struct_bases=[],
    name_mapping={
        "action_type": "actionType",
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "cex_custom_path": "cexCustomPath",
        "cex_hostname": "cexHostname",
        "cex_path": "cexPath",
        "content_custom_path": "contentCustomPath",
        "content_hostname": "contentHostname",
        "content_path": "contentPath",
        "cp_code": "cpCode",
        "dynamic_custom_path": "dynamicCustomPath",
        "dynamic_method": "dynamicMethod",
        "dynamic_path": "dynamicPath",
        "enabled": "enabled",
        "locked": "locked",
        "modify_protocol": "modifyProtocol",
        "net_storage_hostname": "netStorageHostname",
        "net_storage_path": "netStoragePath",
        "preserve_query_string": "preserveQueryString",
        "protocol": "protocol",
        "redirect_custom_path": "redirectCustomPath",
        "redirect_hostname": "redirectHostname",
        "redirect_hostname_type": "redirectHostnameType",
        "redirect_method": "redirectMethod",
        "redirect_path": "redirectPath",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction:
    def __init__(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode(**cp_code)
        if isinstance(net_storage_hostname, dict):
            net_storage_hostname = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname(**net_storage_hostname)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec07b54fae3de0961443ad0e673c4b0ebd3f8d56ec4aae370dba56f6d6cabb8e)
            check_type(argname="argument action_type", value=action_type, expected_type=type_hints["action_type"])
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument cex_custom_path", value=cex_custom_path, expected_type=type_hints["cex_custom_path"])
            check_type(argname="argument cex_hostname", value=cex_hostname, expected_type=type_hints["cex_hostname"])
            check_type(argname="argument cex_path", value=cex_path, expected_type=type_hints["cex_path"])
            check_type(argname="argument content_custom_path", value=content_custom_path, expected_type=type_hints["content_custom_path"])
            check_type(argname="argument content_hostname", value=content_hostname, expected_type=type_hints["content_hostname"])
            check_type(argname="argument content_path", value=content_path, expected_type=type_hints["content_path"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument dynamic_custom_path", value=dynamic_custom_path, expected_type=type_hints["dynamic_custom_path"])
            check_type(argname="argument dynamic_method", value=dynamic_method, expected_type=type_hints["dynamic_method"])
            check_type(argname="argument dynamic_path", value=dynamic_path, expected_type=type_hints["dynamic_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_protocol", value=modify_protocol, expected_type=type_hints["modify_protocol"])
            check_type(argname="argument net_storage_hostname", value=net_storage_hostname, expected_type=type_hints["net_storage_hostname"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument preserve_query_string", value=preserve_query_string, expected_type=type_hints["preserve_query_string"])
            check_type(argname="argument protocol", value=protocol, expected_type=type_hints["protocol"])
            check_type(argname="argument redirect_custom_path", value=redirect_custom_path, expected_type=type_hints["redirect_custom_path"])
            check_type(argname="argument redirect_hostname", value=redirect_hostname, expected_type=type_hints["redirect_hostname"])
            check_type(argname="argument redirect_hostname_type", value=redirect_hostname_type, expected_type=type_hints["redirect_hostname_type"])
            check_type(argname="argument redirect_method", value=redirect_method, expected_type=type_hints["redirect_method"])
            check_type(argname="argument redirect_path", value=redirect_path, expected_type=type_hints["redirect_path"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action_type is not None:
            self._values["action_type"] = action_type
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if cex_custom_path is not None:
            self._values["cex_custom_path"] = cex_custom_path
        if cex_hostname is not None:
            self._values["cex_hostname"] = cex_hostname
        if cex_path is not None:
            self._values["cex_path"] = cex_path
        if content_custom_path is not None:
            self._values["content_custom_path"] = content_custom_path
        if content_hostname is not None:
            self._values["content_hostname"] = content_hostname
        if content_path is not None:
            self._values["content_path"] = content_path
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if dynamic_custom_path is not None:
            self._values["dynamic_custom_path"] = dynamic_custom_path
        if dynamic_method is not None:
            self._values["dynamic_method"] = dynamic_method
        if dynamic_path is not None:
            self._values["dynamic_path"] = dynamic_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modify_protocol is not None:
            self._values["modify_protocol"] = modify_protocol
        if net_storage_hostname is not None:
            self._values["net_storage_hostname"] = net_storage_hostname
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if preserve_query_string is not None:
            self._values["preserve_query_string"] = preserve_query_string
        if protocol is not None:
            self._values["protocol"] = protocol
        if redirect_custom_path is not None:
            self._values["redirect_custom_path"] = redirect_custom_path
        if redirect_hostname is not None:
            self._values["redirect_hostname"] = redirect_hostname
        if redirect_hostname_type is not None:
            self._values["redirect_hostname_type"] = redirect_hostname_type
        if redirect_method is not None:
            self._values["redirect_method"] = redirect_method
        if redirect_path is not None:
            self._values["redirect_path"] = redirect_path
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the basic action to take when there is a failure to contact the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        '''
        result = self._values.get("action_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        '''
        result = self._values.get("cex_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies a hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        '''
        result = self._values.get("cex_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cex_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        '''
        result = self._values.get("cex_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        '''
        result = self._values.get("content_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the static hostname for the alternate redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        '''
        result = self._values.get("content_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        '''
        result = self._values.get("content_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode"], result)

    @builtins.property
    def dynamic_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the original requested path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        '''
        result = self._values.get("dynamic_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        '''
        result = self._values.get("dynamic_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dynamic_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        '''
        result = self._values.get("dynamic_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled in case of a failure to contact the origin, the current behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the redirect's protocol using the value of the ``protocol`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        '''
        result = self._values.get("modify_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage_hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname"]:
        '''net_storage_hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        '''
        result = self._values.get("net_storage_hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        '''
        result = self._values.get("preserve_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def protocol(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        '''
        result = self._values.get("protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses the ``redirectPath`` to customize a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        '''
        result = self._values.get("redirect_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_hostname(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        '''
        result = self._values.get("redirect_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_hostname_type(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve or customize the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        '''
        result = self._values.get("redirect_hostname_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        '''
        result = self._values.get("redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def redirect_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        '''
        result = self._values.get("redirect_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement pattern that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static portion of the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Identifies the component of the request that identifies the SaaS dynamic fail action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns a new HTTP status code to the failure response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3cf49af5c81c880288ebe12703d433a311e5c0de36dea0a2f374dfde4740708)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cbac125e43b45b3e4b9a502de7608e047fd8717b080798c69c9b454c5016690)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0166faa07f0ee0ec71b7eff39aaa4b5761d8a01835ccd9f274634546a3c686f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8549fee92810dae86c23365d7622e38037b4ee2148fe7bbd9086f0789dae2cc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303eb2bcd41ceb098b421d7e97f1e69cb7eaa81cb56d7ff4948d7e8d0a7701e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef6fe6745cfaa1f4210473f33392a6be001f4fd49d8ced2bd8746c577645460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23a70a1da45d3d91570af982858432638d4f23a53fdf5a3010acb2b2624a5160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4438f9562a555010af1516c6608976c855c32d0b04d6ae284392bb4eba31019)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93df6c6087137bd1fec424797a849d69f5a5172aa838b983bef9be8e3a85229d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60c6ff4cc3b41d3beaa088f5fa0c0796af234e9e5ef16a66bdf319353f849b5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7dc20b1e1ab2745cdb12054d5fda77a0836402667c9ca88d70a748c22ea451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__408fc5d41e3513b347df3cc6364b28d8c9dca1f342b184401ec51d91e9e73574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55575fa784ce13098bb1d363b58172599c0b2e874ee17573fe5a8e82f04b9f0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e1462d228a4fb2523ed836108004b47b25714ff904644d630001e4c1370547d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472cee32aa3b77deec8294c0e6cf0f98fc71120aad09cd29ce5db2db826bac40)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd787a7c64a6c65614cf0fb0ed34f1642a37d123f970c0bf6495804c73d5d88)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__825a7138bc5348c92b39962092d4d4cc3b25db146684f98747801e10b261b02a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__957f699d5318a829f94fb1073af4c11a0d78cd48a3d6235572eb5d9077529b3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__755c92072e1b788df5b5f91684da90cdaa63dbc02a63f2f6be0fef83d25755c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__781aea4641b7f08ba89388c67cc3fc1063d458f755ff8d3ac4c2d5adbd4eb6fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10ea7d8bf99d468106f3902a534fbc40cf56e7a5809143fae386a91442a667a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value]))

    @jsii.member(jsii_name="putNetStorageHostname")
    def put_net_storage_hostname(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorageHostname", [value]))

    @jsii.member(jsii_name="resetActionType")
    def reset_action_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetActionType", []))

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCexCustomPath")
    def reset_cex_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexCustomPath", []))

    @jsii.member(jsii_name="resetCexHostname")
    def reset_cex_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexHostname", []))

    @jsii.member(jsii_name="resetCexPath")
    def reset_cex_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexPath", []))

    @jsii.member(jsii_name="resetContentCustomPath")
    def reset_content_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCustomPath", []))

    @jsii.member(jsii_name="resetContentHostname")
    def reset_content_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentHostname", []))

    @jsii.member(jsii_name="resetContentPath")
    def reset_content_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPath", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDynamicCustomPath")
    def reset_dynamic_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicCustomPath", []))

    @jsii.member(jsii_name="resetDynamicMethod")
    def reset_dynamic_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicMethod", []))

    @jsii.member(jsii_name="resetDynamicPath")
    def reset_dynamic_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyProtocol")
    def reset_modify_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyProtocol", []))

    @jsii.member(jsii_name="resetNetStorageHostname")
    def reset_net_storage_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorageHostname", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetPreserveQueryString")
    def reset_preserve_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveQueryString", []))

    @jsii.member(jsii_name="resetProtocol")
    def reset_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProtocol", []))

    @jsii.member(jsii_name="resetRedirectCustomPath")
    def reset_redirect_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectCustomPath", []))

    @jsii.member(jsii_name="resetRedirectHostname")
    def reset_redirect_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostname", []))

    @jsii.member(jsii_name="resetRedirectHostnameType")
    def reset_redirect_hostname_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostnameType", []))

    @jsii.member(jsii_name="resetRedirectMethod")
    def reset_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectMethod", []))

    @jsii.member(jsii_name="resetRedirectPath")
    def reset_redirect_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectPath", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostname")
    def net_storage_hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference, jsii.get(self, "netStorageHostname"))

    @builtins.property
    @jsii.member(jsii_name="actionTypeInput")
    def action_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="cexCustomPathInput")
    def cex_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cexCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cexHostnameInput")
    def cex_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="cexPathInput")
    def cex_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCustomPathInput")
    def content_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentHostnameInput")
    def content_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPathInput")
    def content_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPathInput")
    def dynamic_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicMethodInput")
    def dynamic_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicPathInput")
    def dynamic_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyProtocolInput")
    def modify_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostnameInput")
    def net_storage_hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname], jsii.get(self, "netStorageHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveQueryStringInput")
    def preserve_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="protocolInput")
    def protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "protocolInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPathInput")
    def redirect_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameInput")
    def redirect_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameTypeInput")
    def redirect_hostname_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectMethodInput")
    def redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectPathInput")
    def redirect_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectPathInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="actionType")
    def action_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "actionType"))

    @action_type.setter
    def action_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdefc0218053ab78d5aae1a8ae0017e557609949d565638dc339b14dd34504a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "actionType", value)

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd7960ee8cb8ce4e199cbb44048f7e98b001be26b012bfab534145ac032758f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="cexCustomPath")
    def cex_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cexCustomPath"))

    @cex_custom_path.setter
    def cex_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d5f05cacf67d95ddb631ce27077fbe844e8c17052d16cfbc7fce6768a1272b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="cexHostname")
    def cex_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexHostname"))

    @cex_hostname.setter
    def cex_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd058b52361cd21a0d986b9a94d1e23c1d138ba6bd945cb57cc1036b34fc5f73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexHostname", value)

    @builtins.property
    @jsii.member(jsii_name="cexPath")
    def cex_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexPath"))

    @cex_path.setter
    def cex_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f52af28820cf864365e4fd0e129ff9ea396a4b347eb7df42f1d260bd92e97ab7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentCustomPath")
    def content_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCustomPath"))

    @content_custom_path.setter
    def content_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b9c7d34d8bdc71ae58255cd429a90deb32349cf613bf824c7c8fcc6f7acafc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentHostname")
    def content_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentHostname"))

    @content_hostname.setter
    def content_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb547ab1d4e78268eb20176d911f0433e2dbb89fff4bb3d0dad858926d8d021b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentHostname", value)

    @builtins.property
    @jsii.member(jsii_name="contentPath")
    def content_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentPath"))

    @content_path.setter
    def content_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ca70001b82cc2615a91240bf7f3c5c0ac0e1d0c2453bdc2e20bec5b3e69764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPath")
    def dynamic_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicCustomPath"))

    @dynamic_custom_path.setter
    def dynamic_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6431b9482363cfb1d0e2cee953c12d7d27db36701cfc1a915760c2cef669895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicMethod")
    def dynamic_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicMethod"))

    @dynamic_method.setter
    def dynamic_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d0e253ae51335bb06b237ef1b0f9cdbac993ad29f5d09a07d0286931bf2837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicMethod", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicPath")
    def dynamic_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicPath"))

    @dynamic_path.setter
    def dynamic_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15820788c5bdd3dc4c45dc3a48d654e7e1a9d203752bcb101641a2732ad52327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1ec4b767f7026acc66167ca510d10d6ad417ea72e091e953b57c29d0fef955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4308d8b52c17461b7b7024c4cb52c18117c21ebe6f8456eabd198795e3f0d60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyProtocol")
    def modify_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyProtocol"))

    @modify_protocol.setter
    def modify_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd00de987fcad2274e82b328693a589c91e54cf6d54cced4d8362750b1b07677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30932cd9c1fcd94d345c0029d5d313d4cca6484a9620abc71f818cb3fc14e5fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="preserveQueryString")
    def preserve_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveQueryString"))

    @preserve_query_string.setter
    def preserve_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2350df6e5af19b7ed9077b315331bca0d20b49440894277247c6e60f7ac8e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="protocol")
    def protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "protocol"))

    @protocol.setter
    def protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034f836a95ba01077a2216a6ff1fca4e18fd8e312e13bea2e8736b2849aaa737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "protocol", value)

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPath")
    def redirect_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirectCustomPath"))

    @redirect_custom_path.setter
    def redirect_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6515417c00879079916f41320738f95d8e4c682d58d4ba956bf509346363aab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostname")
    def redirect_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostname"))

    @redirect_hostname.setter
    def redirect_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057303ed075d205bab3171ed90a521d9055aed99a336af2eeea97eccfe5dc267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostname", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameType")
    def redirect_hostname_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostnameType"))

    @redirect_hostname_type.setter
    def redirect_hostname_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b9784c4cc9d025109b9850c6474f95cd547f4a62cac70a8fde942845ab48bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostnameType", value)

    @builtins.property
    @jsii.member(jsii_name="redirectMethod")
    def redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectMethod"))

    @redirect_method.setter
    def redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8270961106d9354ce276fe4724bf27450928c08d07c061c65330d34ce7b50e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="redirectPath")
    def redirect_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectPath"))

    @redirect_path.setter
    def redirect_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f35f83f8bb4340deb60cb68724681a83482d83f306736e5b3c6108387dc57a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectPath", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__359b5a2ca67474cd894f398769bdb3690a30f9cf8f35491633d682a320cf4c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0371ac1cbdc46779d11c53a92c4a7c8e514e023798dc4c54c4d1a0fee9e79d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ffa8681433d03eeb83de56fa8c142e423ff36b6a558742f65c2d2eaa5be9f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04adbe1c6829822f41abb382920d1852243276046b386281cdc40b98666ee35b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d230f0db77cfe08857560aa797ac064f48f546a25096f17c730d9281600ed5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ed33db45f332c71889c9782c2927cbd8a080d5a3f04079398a70f0121d2434a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c096f90c56bf50796ac6a731e87ec93b609d870bf00cbcce13c8d802362ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a79e27c36c14f5b22f988a983fc5d4ad711f36ffa0fd6523267b71da8ffd8f88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__012d388a4ec2840b1165e24fef3e702b9c4ac7dc107435f46bcc20018a74707f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616b5bc22aa37e019e91b3a46f926d7de4c0386e257bb399f62d4a9e0d4474a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__368807d2e3d2f3fc82e4194ed403bede480c7dc329e15839428402256205d2bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57029ed5665b40930bb35968ec46a1e21fc4c39f371a231e54f638506d7155a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "compatibility": "compatibility",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility:
    def __init__(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4086a89cfe51441860e32111af3294261339f054891f01db2cc22f9f844a250)
            check_type(argname="argument compatibility", value=compatibility, expected_type=type_hints["compatibility"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compatibility is not None:
            self._values["compatibility"] = compatibility
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compatibility(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This behavior does not include any options. Specifying the behavior itself enables it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        '''
        result = self._values.get("compatibility")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036f1a9acdcfab2204db1c9188ae2c86db387ee90987ff7e07e5e32726a6e453)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompatibility")
    def reset_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompatibility", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compatibilityInput")
    def compatibility_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compatibility")
    def compatibility(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compatibility"))

    @compatibility.setter
    def compatibility(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da9954f7959ba6a9465b2bde2ddbc29363abcd85813d1de4133c2bed4944ae25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compatibility", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9da7f29603e52b75525e5486fc5aa932804577c4a5fd4987ab27cbee4deaa5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d130f5fc8fe5ed909366ce85336a7f1fc919e23713577f4e6b01299789a38939)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a684e03e2371879f069eb6ac26da9625835c8ad4c5840f987932e51c705b49e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01ad6cb9db6ebe96e47a584584abe7b6f22d24ab018ec638e3665a49553d3b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e598a1b891bd3492e64fb7446fbab73297a36ccb7b90faacde66d5dae018ea85)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, forces a validation test for all edge content to which the behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdc05e70f7b58edc4923aa9da044ce07db7d639c04d440431ab485df1f07829c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3fdcfec4407b8cfd8e54850509e47dea8ab741402f7d14e66a228b81ed84ba0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d96960c7a66440ae34f124df8e93259a0e2b3d8d04dcee8307e386ff2a6e53c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9660670e862db779e01ed1023c66bd40a7a11cc6ae90e7cd367a9ce984ecfbca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1471954f695ba4b5b969a7e67eb27d8b5281ead752842a27378f639be7b1f3db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a384c092f04a7f1635aee2b8a951a9cf890f0d137f279dd40f6f00b2d03cb08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dad026a398ae8be7e33750f7b01b75a6601b8e141e3cf3c8cc5f6b0c4bc2879b)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a862724b9021436917b0afb84c34b47e53b3a328ed8fb195c79b85e84ad4fd74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e40de2196c1469f988d31dbb7600466fb62a9cf90328bd9f6636020e68d2669f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5e4a5be4a93d820f85e008bb882c8fd93f87bb62f4ddaa6524ea6184d2556a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cba4426350bd841c89be2c651da1c879408dd7c83f81ff038fc288cfe8ea9a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d4025537121c4a9d2cd0533a00da16175c3f3fbe372d085d60809f68ce6e72f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd06b3c9a96612181b5d34d63655d7405cfb2dc1165b4b2a2028a443e0e5d925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4389177200494a552e89cdece835654b93372f466291dbce72d5d93ba32a9001)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a84ebcaf902ac021afa519b06e4a6c936e5cedd39963d1f8ab6434d36531755e)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23729a0b2c507e02fbdf6c2a04f6ca738ef04d2df68a205011d6b5d1e28eb6d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13bafb9f61ce0b58bced9231e915065a20b0d368805328338cac6cf42d90be55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c81b493ab6e8b00f3036784adc5a5dd6269faf3cf089e8db70ffe7c1cec4d63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc00f132202c0568c8cb129a5837d78519044f62689070728a0d09e1b24ea884)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2300a8282f4decad0a1b8057c00d70a170410d745f28db8519f19dcbd625939d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0bcc7b83787181de9622d263e8375fa2716170c0bf307ced45aac2b064d6ae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1124026634a0899e40d4eaf6abfc5c159a41981234d6f5ba6aa21410f6b8b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3392d603b53554980add634499ab2d5e58c6ae7f22396eab6b9608acee26d5fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d8e7b87c8cf84e6a8231ee08936251af6fd44f6652489af0fcb5e6194d32a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d5f24cb635bad1d107a9af864cdd7fba35bcbd00a239eac6c60a992ed0491dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a183f87feff7510c52a9140d5565f6febc603f88d8a23b8a871590be9659f400)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9486c4c0589f5336b3fc965eaa39de21c869bd080ea53222f5e7b10329e4ecf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07d088941ced6cece814b59211e30539f773fe88b4f0e140008242742db70eb)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Plus Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f052f04e98bd68b7be17f8b4eb89a7e65a106c701e2c31ec7d3483d41bc1442a)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7523c11e423be969b17694249c38d8e103beb60d45d931eb7abd13995b67377f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__366bad8b3474b283ea6b7b62f18d695d7caae7c1be10d9dc17825206125cddfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba2a429d856a04ae6542fecad01a1bab524ccb8f989523091934086e426235d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322ec68468cc973250b356bf8dbe746655a802706e3aa2711a1d514eebb42470)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3768448ceb1ee64f7b73df83e98480e89f4479888522405fe2e7ac7ee6ca30e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0621834526308d2ce5ed4562c78d7a3b78c50092f42439f7d0c309a48454ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34ec8ef7f07ecf37d6ea6ec9bd51729425511e561ae65ab2ff7df67da07c94c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9651e05edf07f7fa4ecf4c74f40b85723620f8bde58bcecc3b28ed7899d5898)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de7a362260420027dadd5b9b77144ef922f52ff5ba665be7e090b3757f12c44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ae9ab1d623faf640a3740d55bd26e887fc6ac677087e2668c64c249ae3ab20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965a9acc48755588b9e025e64f566a2a879656a58d7fe9d877254a86807ac38e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__961a7b3b2ed20f4663509b4697c9b3a69efa8874406aa19927ee916aea5aaf4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e7e5a67685ddcd4f76eb309f240af0214e8e383cdbc2e32468fa3c90783d4e8)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Forward Rewrite Cloudlet behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce41404ae220bb52ee33bc463ba6818756d1293f8a663b793bb73d649ad29fb4)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cea8b73cc43c90192753d7ea55c2a410564d07965dea673925d499698c04ec6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__413e71f45f6d63f4c344ab09c127346d5be3ba7c29d225b1fb156bc3fe3b19a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c950600a70f7d3c1b0a42476dfdc72e047f3b8c015633eae3f251bd6e7edaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6fcfea5c593145023a6a69236f7d142534ba4306cae7f49ce69aa55a4227901)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4fa99485faed47a38ad3b9545097fd26529b91699a942dfffc38f473a967494)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e485a7ae61b8d3634a4dcf0e4a50b210f280e22ad09c09063f576d90cd1a8f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44d0ef1ad204e8a7e2c797b09b6fbb11db04509914fab2a45b7b4b9a75e3c1dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82480e60bd18d2e1faebf0e9ba761aad1c246f05bae6d4c0750c58091ec65e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd3f9e09246a36c75cce6b97b2015b6186dffa84dae0b1671c58369383e7d3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__554b7f602603e8cdc07f7e232868fb2246f39a06e6a2768765b654b1a6134bff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dddcd1a4f75568a62b5b26e1648a26ecfae0fc29f5cd34809c1d834a09fffb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95434d4e52b2b9f5fe2a2687e7ba0f2ec3572f60c67d145f14fdd9e98c82603d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader",
    jsii_struct_bases=[],
    name_mapping={
        "custom_sign_string": "customSignString",
        "data_header": "dataHeader",
        "enabled": "enabled",
        "encoding_version": "encodingVersion",
        "locked": "locked",
        "nonce": "nonce",
        "secret_key": "secretKey",
        "signed_header": "signedHeader",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader:
    def __init__(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86778b6e82abc6c170110ed26208f336c6a318108877eb5b056b5d516ed2dec8)
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument data_header", value=data_header, expected_type=type_hints["data_header"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument signed_header", value=signed_header, expected_type=type_hints["signed_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if data_header is not None:
            self._values["data_header"] = data_header
        if enabled is not None:
            self._values["enabled"] = enabled
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if locked is not None:
            self._values["locked"] = locked
        if nonce is not None:
            self._values["nonce"] = nonce
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if signed_header is not None:
            self._values["signed_header"] = signed_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of data to be encrypted as a combination of concatenated strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def data_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header that contains the request data that needs to be encrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        '''
        result = self._values.get("data_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the g2o verification behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the cryptographic ``nonce`` string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signed_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header containing encrypted request data.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        '''
        result = self._values.get("signed_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, the encrypted string is based on the forwarded URL.

        If enabled, you can use ``customSignString`` to customize the set of data to encrypt.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d62cab4ade3df5a08c06f04f83e09afee96b092a415e18628c9f2641289631)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDataHeader")
    def reset_data_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataHeader", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetSignedHeader")
    def reset_signed_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignedHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="dataHeaderInput")
    def data_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dataHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="signedHeaderInput")
    def signed_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "signedHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2dc96c4dce780ed07aa88705f9e66e393952773740806f7f6b1091858d65bbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="dataHeader")
    def data_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataHeader"))

    @data_header.setter
    def data_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a876c5716b48125f7ad4f672edd9d178ad94ab35e88504a91c171de18d65ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cebed31010eafaa9520477aa17fe932fc500f7641a97805e66cd934fb3041f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4258b59a332db3fe208ab620065ad6e2824956ce83a02b561225bc62da6accaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__340b67f5e742a9a05161439b665a90c0327bce30a6ed9b13d372693cef94cec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10198541e5106d72016484bf5cf4fb26cfda287e25359575ed1b51f68720fc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1403f551a6994cae8f7bd897096d466789eab084ceba9fadb6f05cecfebdfb91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="signedHeader")
    def signed_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "signedHeader"))

    @signed_header.setter
    def signed_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__435b60b6cbdea23b6014ea4ec85ccc04325ca5ad6acb41ac0d68daf1d50df5f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signedHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa29a2b30ec54a04ea263dd1a465ccd328071171d918722a22716e5f76c1f32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f522ab8fef6bcfc7a8dac76dd9c3a9b7d2b9e28d3f07e573e38e4b12f4c933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6b83aab786f3e8c11ca89ddbb407f99752f97d4c856f7395202e1858c0f2dfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45bb784390ddd61ce83e36799480f8471304d6491abd3028feeab35c81415437)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "output_option": "outputOption",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9040728db864bf5e1d79d443fa4c8802e52af1dc9135c1cd59a404557c2dad)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument output_option", value=output_option, expected_type=type_hints["output_option"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if output_option is not None:
            self._values["output_option"] = output_option
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def output_option(self) -> typing.Optional[builtins.str]:
        '''Specifies how to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        '''
        result = self._values.get("output_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the variable to assign the GRN value to.

        You need to pre-declare any ``variable`` you specify within the rule tree.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9da606372fcd6853a492937548185a76339861a2dcd91266a8d38b6c94208720)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOutputOption")
    def reset_output_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOutputOption", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="outputOptionInput")
    def output_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "outputOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2cb47fadcb5dc1f732d158a7607147840f7d6582680a352e16d3c75817d155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6b341b194e2060aa91701af0084967b0b226e8b558f67ef730721bc77e9bae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="outputOption")
    def output_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "outputOption"))

    @output_option.setter
    def output_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e00f75514de54d31cbde45406408aae7325b739de21fd5f8429021aae7f54cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "outputOption", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d735fdba934d3e11b79d2375f96e4406fb47b69d4b4f42abdffb2ca4a7c2ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ea45560c474a1a63270fdabbfe30a1774cbe2b67b7856d18cf3597eb068cd54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4631f5729196bbc6ad523f4a2aef71c47c4135d8b73d416c08585628d93fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88e8d88ed70aeb5198183d864b1f6ecfff8db03fbba79f52d01ebeda6a772a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "cache_responses_with_errors": "cacheResponsesWithErrors",
        "enabled": "enabled",
        "locked": "locked",
        "operations_json_body_parameter_name": "operationsJsonBodyParameterName",
        "operations_url_query_parameter_name": "operationsUrlQueryParameterName",
        "post_request_processing_error_handling": "postRequestProcessingErrorHandling",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching:
    def __init__(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134ccaf9b7fae144b42c97097f372b4ed8f3e42e8b18acde7cea085ca24f8e73)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument cache_responses_with_errors", value=cache_responses_with_errors, expected_type=type_hints["cache_responses_with_errors"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument operations_json_body_parameter_name", value=operations_json_body_parameter_name, expected_type=type_hints["operations_json_body_parameter_name"])
            check_type(argname="argument operations_url_query_parameter_name", value=operations_url_query_parameter_name, expected_type=type_hints["operations_url_query_parameter_name"])
            check_type(argname="argument post_request_processing_error_handling", value=post_request_processing_error_handling, expected_type=type_hints["post_request_processing_error_handling"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if cache_responses_with_errors is not None:
            self._values["cache_responses_with_errors"] = cache_responses_with_errors
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if operations_json_body_parameter_name is not None:
            self._values["operations_json_body_parameter_name"] = operations_json_body_parameter_name
        if operations_url_query_parameter_name is not None:
            self._values["operations_url_query_parameter_name"] = operations_url_query_parameter_name
        if post_request_processing_error_handling is not None:
            self._values["post_request_processing_error_handling"] = post_request_processing_error_handling
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_responses_with_errors(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches responses that include an ``error`` field at the top of the response body object.

        Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        '''
        result = self._values.get("cache_responses_with_errors")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables GraphQL caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def operations_json_body_parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the JSON body parameter that identifies GraphQL POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        '''
        result = self._values.get("operations_json_body_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def operations_url_query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of a query parameter that identifies requests as GraphQL queries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        '''
        result = self._values.get("operations_url_query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def post_request_processing_error_handling(self) -> typing.Optional[builtins.str]:
        '''Specify what happens if GraphQL query processing fails on POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        '''
        result = self._values.get("post_request_processing_error_handling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a575e919826506cc7de01078543cee7abb1c45436bc3e90a9b4f2bb4c3495443)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetCacheResponsesWithErrors")
    def reset_cache_responses_with_errors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheResponsesWithErrors", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOperationsJsonBodyParameterName")
    def reset_operations_json_body_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsJsonBodyParameterName", []))

    @jsii.member(jsii_name="resetOperationsUrlQueryParameterName")
    def reset_operations_url_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsUrlQueryParameterName", []))

    @jsii.member(jsii_name="resetPostRequestProcessingErrorHandling")
    def reset_post_request_processing_error_handling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPostRequestProcessingErrorHandling", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrorsInput")
    def cache_responses_with_errors_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheResponsesWithErrorsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterNameInput")
    def operations_json_body_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsJsonBodyParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterNameInput")
    def operations_url_query_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsUrlQueryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandlingInput")
    def post_request_processing_error_handling_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "postRequestProcessingErrorHandlingInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b4d9f822413f6b18ef054bf52dff7fd4f41a8a67ac4d0acdef048380395340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrors")
    def cache_responses_with_errors(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheResponsesWithErrors"))

    @cache_responses_with_errors.setter
    def cache_responses_with_errors(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7c09154a5878445d8bff16c86003d0cafdcf32053a906817ad34c5e1e14ee2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheResponsesWithErrors", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8154fba94d882e0eba409c5626ca5c32a3676db27e361da959a747ba47a6f2c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467ca70f2db60c91f2b1f2855a68a99b4210d56b974e47df886cc058d82f0ae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterName")
    def operations_json_body_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsJsonBodyParameterName"))

    @operations_json_body_parameter_name.setter
    def operations_json_body_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce0368006431c4e06d54a01d99549f20193778ae1d1c5796bb25ef447d9c3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsJsonBodyParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterName")
    def operations_url_query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsUrlQueryParameterName"))

    @operations_url_query_parameter_name.setter
    def operations_url_query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84768266df50c70449e53e6a1afde62864fb2c20f7dd12bccdb078be9a9c410d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsUrlQueryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandling")
    def post_request_processing_error_handling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "postRequestProcessingErrorHandling"))

    @post_request_processing_error_handling.setter
    def post_request_processing_error_handling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d72ad0cb80bc8f439d47ee93c75a3b47b1443d95b2716ebe53c00d59b6b48a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "postRequestProcessingErrorHandling", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4974f158be8e00f887c80908855c5e5edf61e53f480a153412e3c7875efbbcfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09342f5111d825f4aead0d040b19a385637f99977bc520d6a2277dd59c6f18f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa37c7802b13e5dbcb8ec9ea54bebd33d00ceb75951d4e7eea1fd8df8eaf5166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254943865bc426ec75ee3313623fb287dec45c723d5bbc74b6261efdc92b0912)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify when to compress responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff61f5d0aeedb52a55e79cb1b7ce9e566579234a5a89d8d1665d35a1364741b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79b20bc97f68bc2f528ab189e1ba1ce276d70389e923133bced83692bc73020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc9b60b4e9341ed353b5ec15b229395f6c447a063045a5e3f325c413bf735b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__782248962718664d4fabe8ddff2f44c21c89d59bda1e13b2d1615c797b27fe7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15296bc74812f69d0449b4cbb26b237e5459c28f73baa6ee2890f98b19aefd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e42a5ea5ba0ea1651a93314c9db7d60381357d16164e54cf7f297b45a78f1814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e70a3994ccf8f0b80b22e07b434de28c69001b3e123be3ed061c0948bc24928)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa6a6bc98980e024b62f31c7124d5e7c1639db35e1586d926d994a2be1d0bcec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beadb61e5bef1e13ce060aba1d9bd763bb156d20d5e2600a38d12a1ee69adf1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39dc30a25fa4ca0979e40c7faf39f28989cb705c993ff1b05f7c863d80431ce7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c33a7f20dc9fecc2c1ee85aa5098d27d7962d90e5d86846c67e090fb140585e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a42f7fa38b3a4de0137cab2f61dd491ed925f2fb43598763e0512d9e6bd4f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ffc7d7f486ad0b6a27e405cc635ebd23c2b28279cd3857a8fd7d9b031d30060)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01bd98f473085833b91b8cd46de6b706ef0de6ea7f293887d4795f3114c67575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_reconnects": "maximumReconnects",
        "retry_count": "retryCount",
        "retry_interval": "retryInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e01ded3e773d68bd0b434a279a5b9501b9ca63c1c5faed4d8991cccce51fd3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_reconnects", value=maximum_reconnects, expected_type=type_hints["maximum_reconnects"])
            check_type(argname="argument retry_count", value=retry_count, expected_type=type_hints["retry_count"])
            check_type(argname="argument retry_interval", value=retry_interval, expected_type=type_hints["retry_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_reconnects is not None:
            self._values["maximum_reconnects"] = maximum_reconnects
        if retry_count is not None:
            self._values["retry_count"] = retry_count
        if retry_interval is not None:
            self._values["retry_interval"] = retry_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_reconnects(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum number of times the edge server will contact your origin server.

        If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        '''
        result = self._values.get("maximum_reconnects")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_count(self) -> typing.Optional[jsii.Number]:
        '''The number of consecutive connection failures that mark an IP address as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        '''
        result = self._values.get("retry_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        '''
        result = self._values.get("retry_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e99b876279d4d5e40bbce721761777fb03af61183306676d347444d86c3c7571)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumReconnects")
    def reset_maximum_reconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumReconnects", []))

    @jsii.member(jsii_name="resetRetryCount")
    def reset_retry_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryCount", []))

    @jsii.member(jsii_name="resetRetryInterval")
    def reset_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumReconnectsInput")
    def maximum_reconnects_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maximumReconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="retryCountInput")
    def retry_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "retryCountInput"))

    @builtins.property
    @jsii.member(jsii_name="retryIntervalInput")
    def retry_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "retryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86d33be055229b06fb27279aea570cb86f3b8fe03b2f0221e3626bd63ee616d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumReconnects")
    def maximum_reconnects(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maximumReconnects"))

    @maximum_reconnects.setter
    def maximum_reconnects(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e94dc1c2483c670a427c295467232b65375229e1d836fd7b4a59097c58dc6bf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumReconnects", value)

    @builtins.property
    @jsii.member(jsii_name="retryCount")
    def retry_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "retryCount"))

    @retry_count.setter
    def retry_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf308b5a8b9d1dfc14a43153769db368cc6b3d24148aa9f3c3b8a52cdfcfd5f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryCount", value)

    @builtins.property
    @jsii.member(jsii_name="retryInterval")
    def retry_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "retryInterval"))

    @retry_interval.setter
    def retry_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__574a5b71cd80e2004eb36b8424a7d826a61a11ac9a0756ce49648d07072a38d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b74c7b6e02af49d1c1f57f7f1b300aaa893cb84ce72390f8ce655839233726a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4f4bb700ed231a34f240683237adaf915744e64a5e375af6a0c2625a7b653b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbc357f5569c3e107b8a082579a6d217cfd1535da5fcb03be631240c15ae0180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding",
    jsii_struct_bases=[],
    name_mapping={
        "custom_extracted_serial": "customExtractedSerial",
        "enabled": "enabled",
        "hash_max_value": "hashMaxValue",
        "hash_min_value": "hashMinValue",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier": "tier",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding:
    def __init__(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1bd8fae5dac3f149c3f20398aabe07b257a483ddcd9acd1ce4b7b4ab5121bd1)
            check_type(argname="argument custom_extracted_serial", value=custom_extracted_serial, expected_type=type_hints["custom_extracted_serial"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hash_max_value", value=hash_max_value, expected_type=type_hints["hash_max_value"])
            check_type(argname="argument hash_min_value", value=hash_min_value, expected_type=type_hints["hash_min_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier", value=tier, expected_type=type_hints["tier"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_extracted_serial is not None:
            self._values["custom_extracted_serial"] = custom_extracted_serial
        if enabled is not None:
            self._values["enabled"] = enabled
        if hash_max_value is not None:
            self._values["hash_max_value"] = hash_max_value
        if hash_min_value is not None:
            self._values["hash_min_value"] = hash_min_value
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier is not None:
            self._values["tier"] = tier
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_extracted_serial(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to pull the serial number from the variable value set in the ``advanced`` behavior.

        Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        '''
        result = self._values.get("custom_extracted_serial")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HSAF for Edge IP Binding customers with a large footprint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hash_max_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        '''
        result = self._values.get("hash_max_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def hash_min_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the minimum value for the HSAF hash range, from 2 through 2045.

        This needs to be lower than ``hashMaxValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        '''
        result = self._values.get("hash_min_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier(self) -> typing.Optional[builtins.str]:
        '''Specifies where the behavior is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        '''
        result = self._values.get("tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d27589ab9844222b5a674a06c376f3ff20adbe7f92f5a24d221c7994d20ce27)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomExtractedSerial")
    def reset_custom_extracted_serial(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomExtractedSerial", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHashMaxValue")
    def reset_hash_max_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMaxValue", []))

    @jsii.member(jsii_name="resetHashMinValue")
    def reset_hash_min_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMinValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier")
    def reset_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerialInput")
    def custom_extracted_serial_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customExtractedSerialInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMaxValueInput")
    def hash_max_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMaxValueInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMinValueInput")
    def hash_min_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMinValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tierInput")
    def tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tierInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerial")
    def custom_extracted_serial(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customExtractedSerial"))

    @custom_extracted_serial.setter
    def custom_extracted_serial(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75d452baf6a5eecf86a93b475de25659b50709c837da013f83da47c4711f60f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customExtractedSerial", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082025cccb742fed472216895755e21d5b946f97e9d715fc82ebb3bfdd447253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hashMaxValue")
    def hash_max_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMaxValue"))

    @hash_max_value.setter
    def hash_max_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bd54eef81e895de78808ff7c4f8faa4e21b87e3d915ef61a05bbb0986f31d0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMaxValue", value)

    @builtins.property
    @jsii.member(jsii_name="hashMinValue")
    def hash_min_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMinValue"))

    @hash_min_value.setter
    def hash_min_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33e6cfd7de2586e204eaa41adee372e30a9eb27e0d57453f9affc5bfaa2e2e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMinValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b85a755b00402a9380b122078d0ef14ab98e858908c9f8360f76500b9ce39e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c36b4cbc43824714603083bf54f4d0d826f303e096c24b9612c17506be4a31fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier")
    def tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier"))

    @tier.setter
    def tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6948f6025ca41dbe83216603f66542cbf3186caefffc16b0bc97747842fbb500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66f5ae815534fef33680ec1b98a99098189fc2150637b5cac4497e8eb24ead80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33284e6d3dbc470e9e4650db8e956950e509c1dda04c5f6e6c9c2239f1d8b2f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f877873f0555d235ef859a42b1e2684b623c9e4ffb4a64fdb8ae3467eb2a4924)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab725ec8ff630d306a1085b99ebaa189df6b2db7d859cbd41b5d884358889356)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__911448b40c745b18e0252f6116e840e7cd7f65b6d2f56e3bb7eab98dd2a3108d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d538566858d6e09b05e7f57f5a680b3832f7e86b88e2f6374699dbb8af5c4725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cfda00f09f65dd40f7069a1d15db66fe16b2b8b3c1caf1afe6f8276155800a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a5efc475bc13e06bafa33e95d9ac5968ef1b05065b2c68384bf100d2e528e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__865575ba69bd98919cc0e83051a5a2bff5330f7e1492835d6717a506c327dc01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c5edc7a468e271eb465199653c81248870f1e9bffdd4adb72c96cde055783d5)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables HTTP/3 connections between requesting clients and Akamai edge servers.

        You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5ee0246b132be84b606d9fa1e55ad45273baf1904fb55efa2d8e4e9a840e0f4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85cb5d67b56f897641d0e8c1980f7502c8fea1d237120abe8f2c15231efb1b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__775311f8513c9a92b629bbf21200f8e8bb4955b11d260432efff35e5ea7dd362)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3cb5b16f63ab506b9bb467917b83ccb27cae6be220b4db190a0b226ea49b8a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3013448ec2c1a7701787bcd5c733a260e967ce429f074abf6b421c923557ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff5659a2493d0670bd2950f963ff4d125e2eedc56b2e1775c1320134f22a94e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "include_sub_domains": "includeSubDomains",
        "locked": "locked",
        "max_age": "maxAge",
        "preload": "preload",
        "redirect": "redirect",
        "redirect_status_code": "redirectStatusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7b17ff3746333c993ae2b125b8c38560fadfb5a43af86ec85c9e59b751e0ef)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument include_sub_domains", value=include_sub_domains, expected_type=type_hints["include_sub_domains"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument preload", value=preload, expected_type=type_hints["preload"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirect_status_code", value=redirect_status_code, expected_type=type_hints["redirect_status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if include_sub_domains is not None:
            self._values["include_sub_domains"] = include_sub_domains
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if preload is not None:
            self._values["preload"] = preload
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirect_status_code is not None:
            self._values["redirect_status_code"] = redirect_status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies HSTS to this set of requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def include_sub_domains(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies HSTS to all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        '''
        result = self._values.get("include_sub_domains")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration for which to apply HSTS for new browser connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        '''
        result = self._values.get("preload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects all HTTP requests to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies a response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        '''
        result = self._values.get("redirect_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea004a4a811d73622c8eb88425d141d5b9e9b53fd51908eef15fe3ad124a2d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetIncludeSubDomains")
    def reset_include_sub_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeSubDomains", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetPreload")
    def reset_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreload", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectStatusCode")
    def reset_redirect_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="includeSubDomainsInput")
    def include_sub_domains_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeSubDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadInput")
    def preload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCodeInput")
    def redirect_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db4110c26b3e88ab5f2013a279883ee904fa105359a99a2178fd6244655b683e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="includeSubDomains")
    def include_sub_domains(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeSubDomains"))

    @include_sub_domains.setter
    def include_sub_domains(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95acd8a957aaf798daf2233d414285618fb8fb2e516abfbf86db713221c3cb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeSubDomains", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5524bfd6d9c7c13e8fc92effd0c55b14f2989932e26eea9d26a5c8842e82e73b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3536d901734ba2cf35214f73e4d323e1da76c698066bdb8e90c8762ea85ec70f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="preload")
    def preload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preload"))

    @preload.setter
    def preload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eeb6fec0142ba670cf01610abe4e564b7e71a13813495aa2437547b2c79f537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preload", value)

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirect"))

    @redirect.setter
    def redirect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85df66287bc7b7daeade847ac0f1c6eb171df85a0b7bae7afc5cd874453c17bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirect", value)

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCode")
    def redirect_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectStatusCode"))

    @redirect_status_code.setter
    def redirect_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a809821b27d24ea2a0620579cc9445babb65392193d5bc44b9458d503c63e9cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b29776a46bfc4756a912d920d7de32adb19cc1f45acc7852525bf384b54a56d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5bb7b265f11b568994b1c6d472255b67656a01fb7671dac4a04b0d7f19358aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f865491d4e7e3517d4613ab48a737fd105ae3f0ea99053a5a78088ea7b6edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "upgrade": "upgrade",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c29810247f811084720503d7ec9d3d4a410b1d7057ff82f0a9326afb1d3ae0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upgrade", value=upgrade, expected_type=type_hints["upgrade"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upgrade is not None:
            self._values["upgrade"] = upgrade
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upgrade(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        '''
        result = self._values.get("upgrade")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a6caf2cc949ee01c285d3b45f0dd94008ca582ec3a31063296aa75ff435182)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpgrade")
    def reset_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpgrade", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upgradeInput")
    def upgrade_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af3593a0d182a2d0e3713967372d11fecf488ba510591ca878c0af8d157f94ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a65faa35a834b8778a606a1816933c796e01dbf3112afb51de73b4b5ce7457d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upgrade")
    def upgrade(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upgrade"))

    @upgrade.setter
    def upgrade(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c5d46a5445b7e3498a624d0ccbd656393a2ffb44372682d6729bad8f48fc91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upgrade", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da7c0413a6ac86c8ba13d19e650eade41b2a9913c6fc8680b3a5d1a25286f5db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3524627a98be9129865e9592f7fe62695661ddbd09f69214a4abda68118b3b5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride",
    jsii_struct_bases=[],
    name_mapping={
        "dpr": "dpr",
        "dprvar": "dprvar",
        "exclude_all_query_parameters": "excludeAllQueryParameters",
        "excluded_query_parameters": "excludedQueryParameters",
        "format": "format",
        "formatvar": "formatvar",
        "locked": "locked",
        "override": "override",
        "policy": "policy",
        "policyvar": "policyvar",
        "policyvar_i_mvar": "policyvarIMvar",
        "policyvar_name": "policyvarName",
        "template_uuid": "templateUuid",
        "typesel": "typesel",
        "uuid": "uuid",
        "width": "width",
        "widthvar": "widthvar",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride:
    def __init__(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__553b39bb16d8d1740ab8111e3f9a56affd245490002d7b4c48a7f2ba8c249432)
            check_type(argname="argument dpr", value=dpr, expected_type=type_hints["dpr"])
            check_type(argname="argument dprvar", value=dprvar, expected_type=type_hints["dprvar"])
            check_type(argname="argument exclude_all_query_parameters", value=exclude_all_query_parameters, expected_type=type_hints["exclude_all_query_parameters"])
            check_type(argname="argument excluded_query_parameters", value=excluded_query_parameters, expected_type=type_hints["excluded_query_parameters"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument formatvar", value=formatvar, expected_type=type_hints["formatvar"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override", value=override, expected_type=type_hints["override"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument policyvar", value=policyvar, expected_type=type_hints["policyvar"])
            check_type(argname="argument policyvar_i_mvar", value=policyvar_i_mvar, expected_type=type_hints["policyvar_i_mvar"])
            check_type(argname="argument policyvar_name", value=policyvar_name, expected_type=type_hints["policyvar_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument typesel", value=typesel, expected_type=type_hints["typesel"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument widthvar", value=widthvar, expected_type=type_hints["widthvar"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dpr is not None:
            self._values["dpr"] = dpr
        if dprvar is not None:
            self._values["dprvar"] = dprvar
        if exclude_all_query_parameters is not None:
            self._values["exclude_all_query_parameters"] = exclude_all_query_parameters
        if excluded_query_parameters is not None:
            self._values["excluded_query_parameters"] = excluded_query_parameters
        if format is not None:
            self._values["format"] = format
        if formatvar is not None:
            self._values["formatvar"] = formatvar
        if locked is not None:
            self._values["locked"] = locked
        if override is not None:
            self._values["override"] = override
        if policy is not None:
            self._values["policy"] = policy
        if policyvar is not None:
            self._values["policyvar"] = policyvar
        if policyvar_i_mvar is not None:
            self._values["policyvar_i_mvar"] = policyvar_i_mvar
        if policyvar_name is not None:
            self._values["policyvar_name"] = policyvar_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if typesel is not None:
            self._values["typesel"] = typesel
        if uuid is not None:
            self._values["uuid"] = uuid
        if width is not None:
            self._values["width"] = width
        if widthvar is not None:
            self._values["widthvar"] = widthvar

    @builtins.property
    def dpr(self) -> typing.Optional[jsii.Number]:
        '''Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        '''
        result = self._values.get("dpr")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def dprvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired pixel density.

        The variable specifies the same type of data as the ``dpr`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        '''
        result = self._values.get("dprvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exclude_all_query_parameters(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to exclude all query parameters from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        '''
        result = self._values.get("exclude_all_query_parameters")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def excluded_query_parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies individual query parameters to exclude from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        '''
        result = self._values.get("excluded_query_parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def formatvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the name of the browser you want to optimize images for.

        The variable specifies the same type of data as the ``format`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        '''
        result = self._values.get("formatvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override(self) -> typing.Optional[builtins.str]:
        '''Selects the type of query parameter you want to set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        '''
        result = self._values.get("override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''This selects the desired Image and Video Manager policy name directly.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        '''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired Image and Video Manager policy name to apply to image requests.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        '''
        result = self._values.get("policyvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_i_mvar(self) -> typing.Optional[builtins.str]:
        '''This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        '''
        result = self._values.get("policyvar_i_mvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_name(self) -> typing.Optional[builtins.str]:
        '''This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        '''
        result = self._values.get("policyvar_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typesel(self) -> typing.Optional[builtins.str]:
        '''Specifies how to set a query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        '''
        result = self._values.get("typesel")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[jsii.Number]:
        '''Sets the image's desired pixel width directly.

        If the Image Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def widthvar(self) -> typing.Optional[builtins.str]:
        '''Selects the variable with the desired width.

        If the Image and Video Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        result = self._values.get("widthvar")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a222066cfe6d9cea40bb298afdf6ea9b3ddfd85bf1dc4b517e3c75d7f2504d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDpr")
    def reset_dpr(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDpr", []))

    @jsii.member(jsii_name="resetDprvar")
    def reset_dprvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDprvar", []))

    @jsii.member(jsii_name="resetExcludeAllQueryParameters")
    def reset_exclude_all_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludeAllQueryParameters", []))

    @jsii.member(jsii_name="resetExcludedQueryParameters")
    def reset_excluded_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludedQueryParameters", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetFormatvar")
    def reset_formatvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatvar", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride")
    def reset_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetPolicyvar")
    def reset_policyvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvar", []))

    @jsii.member(jsii_name="resetPolicyvarIMvar")
    def reset_policyvar_i_mvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarIMvar", []))

    @jsii.member(jsii_name="resetPolicyvarName")
    def reset_policyvar_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTypesel")
    def reset_typesel(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypesel", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthvar")
    def reset_widthvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthvar", []))

    @builtins.property
    @jsii.member(jsii_name="dprInput")
    def dpr_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "dprInput"))

    @builtins.property
    @jsii.member(jsii_name="dprvarInput")
    def dprvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dprvarInput"))

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParametersInput")
    def exclude_all_query_parameters_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "excludeAllQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParametersInput")
    def excluded_query_parameters_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "excludedQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="formatvarInput")
    def formatvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatvarInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideInput")
    def override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvarInput")
    def policyvar_i_mvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarIMvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarInput")
    def policyvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarNameInput")
    def policyvar_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeselInput")
    def typesel_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeselInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthvarInput")
    def widthvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthvarInput"))

    @builtins.property
    @jsii.member(jsii_name="dpr")
    def dpr(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "dpr"))

    @dpr.setter
    def dpr(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c1b592b3476842ffc42c6a82bc270fed93f4d8f2535c9c7e3ad3d9e467f1e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dpr", value)

    @builtins.property
    @jsii.member(jsii_name="dprvar")
    def dprvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dprvar"))

    @dprvar.setter
    def dprvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48d7da2e359163195e16daeced94760e4ba2bc5f4a08bbddf4f751d8c647eb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dprvar", value)

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParameters")
    def exclude_all_query_parameters(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "excludeAllQueryParameters"))

    @exclude_all_query_parameters.setter
    def exclude_all_query_parameters(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d85dd560eee4a7b3b78fc17d0831772a7f6c1ad069dcc7af2eed2704ee2a77c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludeAllQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParameters")
    def excluded_query_parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "excludedQueryParameters"))

    @excluded_query_parameters.setter
    def excluded_query_parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a2eae352c62e1dd137edecccc85feaf3094d8320d144c0f81543f6543bfca7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludedQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed43f331f4977f2b6cd08d12759eb4b92e90f365bd8c24c2c47bab3844de78ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="formatvar")
    def formatvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatvar"))

    @formatvar.setter
    def formatvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f363f3a5b36ecafb92b6305e49533de4e99fcec668b65e372df126153cd7093)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatvar", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d6715e574db2a885df1eec26cd4b9eeaf0613372a769647b4bc65ef24326d2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override")
    def override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "override"))

    @override.setter
    def override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9703a6eb2bf89ef4e1146f748a2844d8a87ddd272f07c584dfbce60eaffc99f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1f5a2ffa044f7759342bedff63f4f1df95c1a1164f70cc4cb406b4ab01c8e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="policyvar")
    def policyvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvar"))

    @policyvar.setter
    def policyvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49100767878e9c2fbae180d365cb4a4b83a85ca1595c8b2389ee987bdd5e1e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvar")
    def policyvar_i_mvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarIMvar"))

    @policyvar_i_mvar.setter
    def policyvar_i_mvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9504f5a0fd2fd10cbf3cf9b60fda80f0e5a8d2efc8d62daa314d3f2e00d838a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarIMvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarName")
    def policyvar_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarName"))

    @policyvar_name.setter
    def policyvar_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__579ebe9e338b7a7e1892a688cfdd6c5cc46d908137b83de9ec04872e2fb48f71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e157b7148b0dffd9d065f89823f7a13ce8c090df53c7bcef5ece4284f7a7d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="typesel")
    def typesel(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typesel"))

    @typesel.setter
    def typesel(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a07f219318f1148b5625a12e5d5213b7ccb16b0c9710e377273b4f89a5c5c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typesel", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb81569e7e4d1fe98bc5feca93a04e27f3ab463eeffcb0e223b72587dd9ac54e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "width"))

    @width.setter
    def width(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83abbf3d7c13e667e6bcc9fede1fa94f1057bda5b93bfd8adb58eae6bcd3e8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthvar")
    def widthvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthvar"))

    @widthvar.setter
    def widthvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3083226c8f0b5b5514a703400e6e201db1ee3b26ff12b464ca9d97a0f29f5dd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthvar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a9f31c506f4ee5d83a40828a8d15f9f4950c5eb084c8205f6b6ea612bc8cc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager",
    jsii_struct_bases=[],
    name_mapping={
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "image_set": "imageSet",
        "locked": "locked",
        "policy_set_type": "policySetType",
        "resize": "resize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "video_set": "videoSet",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager:
    def __init__(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed6362ce9e63a5d539e7073e2eba14b59e27a7943b2866e3cda191e772cd108c)
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument image_set", value=image_set, expected_type=type_hints["image_set"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set_type", value=policy_set_type, expected_type=type_hints["policy_set_type"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument video_set", value=video_set, expected_type=type_hints["video_set"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if image_set is not None:
            self._values["image_set"] = image_set
        if locked is not None:
            self._values["locked"] = locked
        if policy_set_type is not None:
            self._values["policy_set_type"] = policy_set_type
        if resize is not None:
            self._values["resize"] = resize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if video_set is not None:
            self._values["video_set"] = video_set

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.'''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.'''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def image_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.'''
        result = self._values.get("image_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.'''
        result = self._values.get("policy_set_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.'''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def video_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.'''
        result = self._values.get("video_set")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999a4728a727133948dde42e760db834cacdbb1789a36e8bdb72917ec15ae71c)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d95899cd34b813d03730f8c2ec01e08f31d3a48de0225d6364f8d63138c1cab)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b486dfabd27e274fb71e066d3ce2265b35af261f5f267706fd050e477075038c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7b7ac86f85925d4fb2ef731f5cc8ca8b52c60c8ce75881b83420e174c5dfd20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0dd091327e8f2cee2ad1b5659fca124d381d99cb027ca415ad4b667574dfd2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__350e259b5f5378e2e589f0ac2f4570e75f8ad842c378b12aed85e4ff1461f8ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f552fd4119e906b7cc1b455f7b20a20ef0c6820b93f36f2d64c5a81e53dd6fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__052cbeffea074de872ee3e9ab9151fe05fe6ff31e3a2b7b0698774635fcff85b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5034fc0c6d5e0dd3d372c84fc2e48579896f2ba017fc824b06f56f3b8c70baa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf9bf17eb46b9f1c2ad517851f63e9e09a317c16200584510a642f25e069e045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3776b2c5bf953ccecd3ac0595e1667e67312861efc497560de55bc2c09b3b106)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c2186e68ea4363a71d83d0f19e915dce9522c405317b54027a08b4c88706936)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35191ef9e3f1ae8fafa127fb31d5e415f529f548c07933051f4836a81fbe381a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e6300abe5dc12bcb708e80d43534721df0e8133d4159d8c25576d4f775d35c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c7cd344351d29f967908f224b4f68feb2fd8e46e159a3c9cc4b1d93204590cf)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9961ac163957e6db5e02e0b762f1745cff520e155c8221ead993a664f3fb13be)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fb338b10db3570479e6226be3de521059c3f73d4d7841804686172d06af98eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ad3553458b7328f7d90d2015452513a8f664d284bcd810fff71bfbc049869cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77fc9c570749b8c2e162ca222ded7fe1d5be1b5732c97cd1801b2a078d65af55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de041d2919fcc08e1ba61054a7807a62d34a388dcdafc28118d6cbc60cad33ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee483ab9d293f3e9ad9bb9c50b673eb52259928b4e0ea724d3da630417b940c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38de15e9cbc978d54b66cc81f6e535e6ab999bce5ad033a929b2f1858e98bad7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13c14988d7dcd73cd6d7ef21bc737e238ee5d55e3575dcda982db1df557239a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6ad2eee2d4205f6c19734d14fd62372c994d683d4e63c75057f7cb222e6ba5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73d63a664247d425358c926549c981202f65baffafbc2e4136baddaa72784e26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2f4b95bae983d0e7e01b4257373fd806c5fffa0e2cbd45c0071a0864d4eb71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abb033bb96d6bac3ae67e3112c462ec422c66c74b9fe611584bf2b7e30417397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f78aa6667e976a109a2db894c3161b8539752ce9125d0b7b1b143e89447cc2b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b52268bc2afaba10b7820b3988dfa391dc20b27493dca9dd12a126de6bf27bbd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetImageSet")
    def reset_image_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageSet", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySetType")
    def reset_policy_set_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySetType", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVideoSet")
    def reset_video_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVideoSet", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="imageSetInput")
    def image_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "imageSetInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetTypeInput")
    def policy_set_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="videoSetInput")
    def video_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "videoSetInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c91fc9e93939706080fc45853dbc1c7f898aef981461e04a778677c51ea4581)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ebe6f9ff943afb94c6abc790fdca83866e0d7ea110fa8a173e5c36c5407998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="imageSet")
    def image_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "imageSet"))

    @image_set.setter
    def image_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73767ad375615a53ee8418657c403accd2876cf547ae9ee263b01e187dedf7a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageSet", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52ab04478470d82a8b401db8ce8a347c2c41aab31df57a7f4ae4f79541019e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySetType")
    def policy_set_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySetType"))

    @policy_set_type.setter
    def policy_set_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2540da24e82121ad2cdf4c1a5648f1fd94fa05fce253a6331aea9c5db9bc6449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySetType", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6dd2ca410327c35b244f7cda86f64509f99a3db59ca3719c9ff4ea4c6d0ed2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea4848817d3a8bf8ca67f8561fb69f493205acfbce5dd1bd2676e91acd954ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda8636b02e1d73508469105657b866cbb1eb41dff94f4b2eb54a54b698454f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="videoSet")
    def video_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "videoSet"))

    @video_set.setter
    def video_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf95a013cd27cf222584862bee03db796fc76207eb261f5e8590af6dce1f8f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "videoSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc89d3e2fd687d149c1a3b1bba8dcbd7a72dfa9a26c1c6a3cfe8b735e618c404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22ab9e86a598b78ffd8d162fdb2d47c23b4f9f9cbc62b33a101270cffef53d74)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images.

        The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file.

        This produces the smallest file size possible that retains image quality.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable image management capabilities and generate a corresponding API token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters.

        If you don't specify a label, ``default`` becomes the prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        The ``advanced`` option needs to be inactive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.

        Note that enabling this may affect screen layout in unexpected ways.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57d6602f7363efac075a71cc9f858873473ff832d25de496c2edae547709a922)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74a140f4c50847601bab61260fc35d7acefd223edbbc8cbee267cfd00f2526ed)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be87c8e3f14e24a36ba1df26ba562140704636f998e204070def74990133b232)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519fe6fbba59945c52e5fbf601bf800cd36015ab8d14ed5a9a6e55f3082d3e64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f9950aff38afeb922be7496cccae66e91b773c5eb84eaa797cc8132fdb5a6b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb18ac33409262fff873848b6ad958bafcebe7b31b42fec01bbc5b871a281c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed57113b589aea491ab531e538130baabace1929acf1f81abc77754b574156d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c5307d701d3072cfcae3ec4f7b3af2697648d6abffc26729d51b3bd852ce03d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cb21b96681b45467ec76c849f0c518ce05fceeada217057fb2f4c83f68c5e1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1e496b7013226a7210a6f599035bda61c1ebde687bcfb33290fe24d2b4aac7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bdcfb3bbf309830ef25078541bc608666a717e1b98189a020d4473e84456192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a11dd2a0044a414715f8e0124d5994f288dad3b69b737d075e8ffebe1a79219)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a2943931f30b1b07822c452262403fe804f1d1fc0c013120eb43eb0c9aa6403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ce753ed0a3b665337ddcf20781d067176e9f3a8601895f364253ad1f2918f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac38c69cd658049098449f4c44a417299348202511f0f378039e6c9da8791f84)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__765fa4f24f06bf248ce723359220565f1faa418992c114dca9d00ddfb70e1ccb)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f166108115d710a82160e6208b51a3c9b0c33c4db591d40578e13c5b9e7d78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f791927de986a030cd79acbd2b66ecc3ba6cca8438b4abb90686b8c2718182c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5283cfe2fe2d7e1d9e210da548f772542f4231e5a3e4203cc76d296976a49f71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d76bb943b073581833c06377af6139dff795c2e8c05babeeeaf9cdb4874343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4730f6ba93ad385356672872d1ac8db4d6efc4af473bc9d86b52de0820e7e66d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b458e4c6fa58cd47dde455b144b7e17a43f3f03e27bf54aec4e1e182cacd8aac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9526be76e48356e9c9e013ac6fa39d752c0be38cce954b37381f8fc9372b1151)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40587345d9434b454f4afa4d041d7fdda383c442e34879a36c8ced533adf39c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0beaa349af3a70ce150efa736ad6d49d98027422f9eb40ea94d5b5c3e30be3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c54e0d33282b9c80288093148424306edffcdd3e0f5dbf26d9275a6808b669b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406e626a74ac8eafa21a6cbb4462dbaf38bee564c7eb3c907ad51ba5830e129c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aea7aa1e06e549fe77d0904ad53fa3f5ec16575ea2bd7520ed6c397a83cafe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0b40e6acc9b7c6d556bed3b0ca0e48c6e7cb4d1a9a8bd164f461ead24b1e883)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03a79569c2372bec4cb6aff1db015ae03d8a253fd0cc40028a179c34baca80a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1946356275b4b0d6f122a222d14ac8925e3e0965940724616ad9da17f76db029)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eeb809de90fb8412a7b0e7461f25c093b2bba42264112ee544b4c53de9cb98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48a66b70a33c50bc96ec7af760ad633367cfde804be77364ae6639a17342bc28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a23bd7f96c63f80accbc90ef5ada7c12d0c4f58132057a890bcc348d11c781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909acd9e1903609fa5fcbb92dcb51c13e75f20d7370c5dfdecd6ab6e486e3c78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f1b75c89961020e2f5867a03a19cb4422f5cdcdda1d7714d1eeb719aecb612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86277a27a84d8d0faa7b7f8324d6c6681531456eafd8c01e3eb1ac90a45f92ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ad01ac14514caaba21964dd6b2dfc95962e95722e4b05210d17165da76c397f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be46cbf748f88e8f83fb1425e555774647075178c5f41a4b38f0b5aacadf9090)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b24f62704a225e9ab7bf3414743ab60a4bb40f282711080907543a45e4190bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666bce842471b063ac3826e46cbe91466a0d67784897c5d72046c4d41b82a494)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa927a837254dcab1c0e3b94c149a5d4938c82c472418b908e2941c17715f0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045cda94f359db1b7112c670875a105adda4eebb8fce18dc929fca311b49e8fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eef314b1cfb20e3ea578ec9c0c0453b9161aa9f4413bdd26d68f8ce059335e77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e4d91b7897beb8ac51512bcd587b2d985b255ec96e861c62d9f5583458eed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c113af8fb4941a92c2dc37457ffd29d9d6f534f984c43730f4140989349362)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, applies a single standard policy based on your property name.

        Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, automatically converts videos to the best file type for the requesting device.

        This produces the smallest file size that retains image quality, based on the user agent and the initial image file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Image and Video Manager's video optimization to the current content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``.

        The policy name can include up to 64 alphanumeric, dash, or underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''To optimize caching, assign a region close to your site's heaviest traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00fe840284fa1b3d742ab064e209ffd532cf35e041039549d0a1c0a6e876b181)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__164c0e532fb833936026e18b0d8651b60525a4ec0716340a021b5f823ecc6512)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4842d64d4a744097e2f8bc87594e44f9bb17395e68dfaee21573e8b1b2329b55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9869cc14e82341664187168aedd508d7b7e7285503689946e5dfd909e9792737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c821c30f1a21c49959b23a0ab34357d313711badd2710f6a973fb72fbc13efb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be1c20447660297c1add7c983fe2b2e7c45d8cf675492d7e63569a7263cbb367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72956961a65143f83ecc6c3d63b18af247229c83852c32bf5e11290803161c31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e61d032d2a05526fd678c9d5d86f1cfcb0ca51db971d19ee92a263388e7ce5d1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce5626ceba77c4b8783815f2b45a375f72f77e2a092f7705b52bda2d62f5c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12f21907967e1d725dbe07fbf50f08269368d1c3090ab2852173635c7c75d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b840002f51c01977ef29024b11a3393c56daecdb144c8201905d6202b1792a0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29bfb39093881bc5c40caa1af9f618653bfbfc679783859f042b1d8906bb6977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e570fa38efb6fa9824b31384d973ccf8bee4ab852641bcfe172e085ca6cc0376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c751981bba89d7cd07726f1d22391818d5d9c033b937d557ae94e752282032e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e7293bf5b3be5917830321880298eca6a3714a9658967d31413bdf56c78a51a)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eb0fb190772e9a935707be6e4a873ef26be532dbb32667f8ee2710e8fbfe6d6)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17597b5d0bd4cc5e181fe8cd326bbc85da9d9c8425cb42e443df18adf3ec75f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdf696c75d9ac7963e1483cb46d6e8e9c1608ec64a690582339e075794a6166d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d869038c96509ad7df4f3327587ba52503dbe68bc4da409c86516975dd97c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41a046a3f9768a91e2b8b7cb09479bd9ad0555af4712d48d85d2597923a44f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12a973e0ba74837d73fd032e16d0b53f314d609e8766f205312461211d1c1ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a66cd9be3151829a1960f85fdd2613c10134154f3b5947a8fe4e67dbf5c8e9c2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1045a53ede8dd9556e21f6da66d32393273fe564e9ae19feb65bdbe7f3e07db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61c85331d994e01331c503f66b58141a539f5452c3a18c256594fc945ccad73d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__839e3007e181dca82c7aaa231b301bd2b0fe5dfe3f6a2b9e5267fb0f651bfb0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8060379860b5f822da9068cd01dc8de28168faba97d7c316180b26401ec95de6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e583d4d0c8c52c8cf68d48efc18cbc3e954cf2ca21b4d27b1fb4836d9f03ea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4da261a6b74b95957566f0da00282572436dcc305cf07db4e6452b8b3c4efcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475bd14699c10008f8a3b7b4a77b5f0227a0f401d630d63519cb50497418be0f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__826cbbe8aca09c799f935a93d4d164aee7d132800c8882c0294ae9203f16649a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85b243bce4ed5d04edd1683cecc45c096135b45c262183d3f82a1e4d9af3dfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17625b03935864986761088b149f717a3044f32d9c03dbe283a0c07b2313cda3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c59587e681590f8b45b6394bf677d2ee470779740a2656a2776c8b415661957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84985b6e9c6e85ee766521c56ee6bbc0f5687d2c88af6ad41194daef59504ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__715140934235a0fea31e76599a3b11bebba68c9d9d5110c77967192a45ea6867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf67e0a226825034edb9e02b282098e57639f76e3371fae89d9deb3d94d696f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e658d63ee4d468bb48188d5afdbb29e4bf2f5e154666b6294fc93cd6b5736fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fa605ea9146cb7d5780049a045eb925ec3a0b0105fd1fea305fe799b39b864)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23657fe55b9f116f4871473cde82f9c8cc29ca942a643ed9d3d2ed8c48cd47ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca13471f34b741a8d4b8c717b6155171eaf4f56f7c3fb30d900cf8b293f170b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8840aa0fe746b1d37ef598de1358cc23207b49b549f629a8e6d180465a03a75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca3ed2c59bccaeae1275bda5c062ecc8da6163648924f56457261c9ec91309a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__249e8402649ca84869c410005b4b9d846116e7635b41ee517bc77c3be136a1b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f92cdf6d4ea857d9778b0bdeb0d35684948c84a1c796f16fe1563e800d95e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__611b12c767e7018809b246e61152beebb5cd343dd8b95518f4b96d3233bee065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude",
    jsii_struct_bases=[],
    name_mapping={
        "id": "id",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude:
    def __init__(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a4829afd1eb8362cf6db5ce25a60100550474000820d6ff30549994781e124a)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Identifies the include you want to add to your rule tree.

        You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be74a2d144eaea08edd399de3ac410a4324bd2854ff8fa5a7a38dcd60cdff10c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7391c19492acfe9c6ef291b52e6ee2c4179b3b79b3981ba641e37cd16a1e230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca74b04a2d5cbb4677d1ee780439b3dd607061d09f1a9986973305a0e917dc65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9cb933ee9b647b22821b99efeb6c4bd08ed5333dd7733a98a0f2383c8c910e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f66d32d7d52b0b8d3a092b2ccf4d175b519297eece07d9cdd10e3d9c41f90d40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c334a98502deeeb7e27aad3991380b705952535312ff9cef639cb7fd8337232d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant",
    jsii_struct_bases=[],
    name_mapping={
        "custom_link_relations": "customLinkRelations",
        "locked": "locked",
        "prefetch_cacheable": "prefetchCacheable",
        "prefetch_html": "prefetchHtml",
        "prefetch_no_store": "prefetchNoStore",
        "prefetch_no_store_extensions": "prefetchNoStoreExtensions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant:
    def __init__(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcfd2465b9f9f687cb86c52b5fae26606153540c41b590cf192bba712c6a836a)
            check_type(argname="argument custom_link_relations", value=custom_link_relations, expected_type=type_hints["custom_link_relations"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch_cacheable", value=prefetch_cacheable, expected_type=type_hints["prefetch_cacheable"])
            check_type(argname="argument prefetch_html", value=prefetch_html, expected_type=type_hints["prefetch_html"])
            check_type(argname="argument prefetch_no_store", value=prefetch_no_store, expected_type=type_hints["prefetch_no_store"])
            check_type(argname="argument prefetch_no_store_extensions", value=prefetch_no_store_extensions, expected_type=type_hints["prefetch_no_store_extensions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_link_relations is not None:
            self._values["custom_link_relations"] = custom_link_relations
        if locked is not None:
            self._values["locked"] = locked
        if prefetch_cacheable is not None:
            self._values["prefetch_cacheable"] = prefetch_cacheable
        if prefetch_html is not None:
            self._values["prefetch_html"] = prefetch_html
        if prefetch_no_store is not None:
            self._values["prefetch_no_store"] = prefetch_no_store
        if prefetch_no_store_extensions is not None:
            self._values["prefetch_no_store_extensions"] = prefetch_no_store_extensions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_link_relations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify link relation values that activate the prefetching behavior.

        For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        '''
        result = self._values.get("custom_link_relations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_cacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior.

        Only applies to content with the ``tieredDistribution`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        '''
        result = self._values.get("prefetch_cacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_html(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered.

        This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        '''
        result = self._values.get("prefetch_html")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option.

        Only applies to content with the ``sureRoute`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        '''
        result = self._values.get("prefetch_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store_extensions(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        '''
        result = self._values.get("prefetch_no_store_extensions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee2089c8fef595d66f2ba3f45707335f19c6712fa4799d0e9fa43d480e0d30c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the InstantConfig behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010c6b9196be860915936a846bdb877f5264b8279eec6bb2d1c519ed1ad28dd4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5172a55aa44a4b0062b904ba0517a001136ddcf5eb19b45f4ebbbf4f62a6e97a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca5c8e58200f00bc8a7cd0c517c956bd1c147b088ebb16f30add5bf0d1c2ada0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8ca7d59d42862f2895752c1e21bd69340522bd437f9053fb01a0fb10206894)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7072d967d6be240aa3b9961dac8b9ac918a9eb22786857797dcfbe0210a0ef08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a47cd35ea49f8ef9807b087519f5b8e2f0f933cb10980e82e2d3cc2593d6805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f02ccda066eb762d00ad78f410550732c656e18e12b2c1318fe2fbc5c5c5314)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLinkRelations")
    def reset_custom_link_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLinkRelations", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetchCacheable")
    def reset_prefetch_cacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchCacheable", []))

    @jsii.member(jsii_name="resetPrefetchHtml")
    def reset_prefetch_html(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchHtml", []))

    @jsii.member(jsii_name="resetPrefetchNoStore")
    def reset_prefetch_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStore", []))

    @jsii.member(jsii_name="resetPrefetchNoStoreExtensions")
    def reset_prefetch_no_store_extensions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStoreExtensions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelationsInput")
    def custom_link_relations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customLinkRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheableInput")
    def prefetch_cacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchCacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchHtmlInput")
    def prefetch_html_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchHtmlInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensionsInput")
    def prefetch_no_store_extensions_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "prefetchNoStoreExtensionsInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreInput")
    def prefetch_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelations")
    def custom_link_relations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customLinkRelations"))

    @custom_link_relations.setter
    def custom_link_relations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c33f1f39ce49d7a4857a4c031d8f8416fd983efc73fa283336904505d56de1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLinkRelations", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__126e682dd46fe5c6640b289c410650e6203aaecf87c3656c6958b572df004c30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheable")
    def prefetch_cacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchCacheable"))

    @prefetch_cacheable.setter
    def prefetch_cacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb99c3435b11354489026f3f7669a4d5bbfea8e2c8c47d533e54efc2cd2881bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchCacheable", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchHtml")
    def prefetch_html(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchHtml"))

    @prefetch_html.setter
    def prefetch_html(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eca64075c66ec6e5993e0837647637bdb396c402fb4bfff8aab388cb515b7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchHtml", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStore")
    def prefetch_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchNoStore"))

    @prefetch_no_store.setter
    def prefetch_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb0e6c38ec7a72221b3681b426527f9cbc63dfa07685cb70493c597f2eb481d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensions")
    def prefetch_no_store_extensions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "prefetchNoStoreExtensions"))

    @prefetch_no_store_extensions.setter
    def prefetch_no_store_extensions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8992ff29c2d97a0b791d464b3d03b51add115773f67c2b7b11102435ee98f4d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStoreExtensions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff201a2e5aa8200e871149d81e87b452f6774b6477e2f85baa34e9d08cf8c42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ddad4deb62dca28e9bea58317d50c3547cc63c3577bb812713bbf904795721e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e419d090620c04c2eaf200fb88dd967be33c335e83bedc22c1bcd2b9dbeb4497)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "enable_partial_object_caching": "enablePartialObjectCaching",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "minimum_size": "minimumSize",
        "template_uuid": "templateUuid",
        "use_versioning": "useVersioning",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8f07ad6bf4230431c603444953133689846b7d404df943456145b79701a9bbe)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_partial_object_caching", value=enable_partial_object_caching, expected_type=type_hints["enable_partial_object_caching"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument minimum_size", value=minimum_size, expected_type=type_hints["minimum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_versioning", value=use_versioning, expected_type=type_hints["use_versioning"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_partial_object_caching is not None:
            self._values["enable_partial_object_caching"] = enable_partial_object_caching
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if minimum_size is not None:
            self._values["minimum_size"] = minimum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_versioning is not None:
            self._values["use_versioning"] = use_versioning
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_partial_object_caching(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to cache partial objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        '''
        result = self._values.get("enable_partial_object_caching")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def minimum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        '''
        result = self._values.get("minimum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_versioning(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        '''
        result = self._values.get("use_versioning")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "fragment_size": "fragmentSize",
        "locked": "locked",
        "object_size": "objectSize",
        "prefetch_after_request": "prefetchAfterRequest",
        "prefetch_during_request": "prefetchDuringRequest",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ee92039359def77ceec149598b1ca2046cc3544d61d5f8212a458ca8a95613)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument fragment_size", value=fragment_size, expected_type=type_hints["fragment_size"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument prefetch_after_request", value=prefetch_after_request, expected_type=type_hints["prefetch_after_request"])
            check_type(argname="argument prefetch_during_request", value=prefetch_during_request, expected_type=type_hints["prefetch_during_request"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if fragment_size is not None:
            self._values["fragment_size"] = fragment_size
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if prefetch_after_request is not None:
            self._values["prefetch_after_request"] = prefetch_after_request
        if prefetch_during_request is not None:
            self._values["prefetch_during_request"] = prefetch_during_request
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def fragment_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of each fragment used for partial object caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        '''
        result = self._values.get("fragment_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the file at which point to apply partial object (POC) caching.

        Append a numeric value with a ``MB`` or ``GB`` suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prefetch_after_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch after the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        '''
        result = self._values.get("prefetch_after_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def prefetch_during_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch during the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        '''
        result = self._values.get("prefetch_during_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffd8adb2f073c8e89a4b477e5610780f4350c9584f6ad477580aacec6be3898)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFragmentSize")
    def reset_fragment_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFragmentSize", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPrefetchAfterRequest")
    def reset_prefetch_after_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchAfterRequest", []))

    @jsii.member(jsii_name="resetPrefetchDuringRequest")
    def reset_prefetch_during_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchDuringRequest", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="fragmentSizeInput")
    def fragment_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fragmentSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequestInput")
    def prefetch_after_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchAfterRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequestInput")
    def prefetch_during_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchDuringRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f4e8c9ca8bbc7c829cce3f1d65fc128143a2d5b5fa8522049005b4a470628f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="fragmentSize")
    def fragment_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fragmentSize"))

    @fragment_size.setter
    def fragment_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bccf352b167a1b75035d837d70e1e7f2c5ba126eff7371cf4e275aaa80278c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fragmentSize", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4efaa36309b599dbf11993ad566acd8ca0a3de0330cbad8a007de804e20ebe8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe17cbc161a022caa8266d3444c7f6cd5520fd87f22b2545deae159c3e4ea574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequest")
    def prefetch_after_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchAfterRequest"))

    @prefetch_after_request.setter
    def prefetch_after_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd3f1f029eb0f5f03eaea31c7728eb0e355b12b8b1fd50192906ef337730a079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchAfterRequest", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequest")
    def prefetch_during_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchDuringRequest"))

    @prefetch_during_request.setter
    def prefetch_during_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0deca674b5a8a1576050ef662253d335fb85aee14f4a1026983da8b38fe6566)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchDuringRequest", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6730765565aadbc274c2d51727b5e377fcdd06ecd6dafdb22f91278240e383bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b7f8abb68d90eb5e96d7c0ca9a645e8472df8e9466e27013fed9e56ffd44a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc21662e0b3389b6efce94606391941e00e73348e38c1c5e12db19f2e789f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0fa99a3f43dcfa9893a75b19ca219af9edf5ec34be5ffbe44f8d5b8ec9454dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnablePartialObjectCaching")
    def reset_enable_partial_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePartialObjectCaching", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMinimumSize")
    def reset_minimum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinimumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseVersioning")
    def reset_use_versioning(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseVersioning", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCachingInput")
    def enable_partial_object_caching_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enablePartialObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="minimumSizeInput")
    def minimum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minimumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useVersioningInput")
    def use_versioning_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useVersioningInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__593e96eebf7d5cff763afcbfab437a0a7d7db80c0ce75d0898f98d660e853d9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCaching")
    def enable_partial_object_caching(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enablePartialObjectCaching"))

    @enable_partial_object_caching.setter
    def enable_partial_object_caching(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbe7145ae0559d7a89d03da9c70a8ab0d3fdf0c16fca3f66591862070c2ff94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePartialObjectCaching", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52ce2c97781dc901b14954db675a735693c4cb1797d41e8073f402d4ef297cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b3821469471d2d065ad56a69c231c6b955f64e5a608d5a351a80c46a3c00474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="minimumSize")
    def minimum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minimumSize"))

    @minimum_size.setter
    def minimum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__406aeff3ace64cd2780c0273a338b3cb9fd73c51c3bec5390929d3b2b93b77be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minimumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f35cdf86929d33eb870bc9ced706e7d406a8ce4ae737bf69bd5e6fa5492054dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useVersioning")
    def use_versioning(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useVersioning"))

    @use_versioning.setter
    def use_versioning(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2862c3e9b5973852de4e8f1b9fc4d8290d69c8e7f9c9f8f2c730cc0d35b7e19b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useVersioning", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc65c2b1eaa6334242d205c0c4f2ba1d71b30667e4fceb5dac25ba2d0dcf5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36286e3c47c3e5c1f5d3df6fd774bdfa9ed299af33db360ebca41f31e0038d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate",
    jsii_struct_bases=[],
    name_mapping={
        "bitrate_table": "bitrateTable",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "threshold_table": "thresholdTable",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate:
    def __init__(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00c06a83f9cf94da2f15e42fe4bf6a49c2f1d912f832f155a1d2719f32352969)
            check_type(argname="argument bitrate_table", value=bitrate_table, expected_type=type_hints["bitrate_table"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument threshold_table", value=threshold_table, expected_type=type_hints["threshold_table"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_table is not None:
            self._values["bitrate_table"] = bitrate_table
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if threshold_table is not None:
            self._values["threshold_table"] = threshold_table
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bitrate_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable"]]]:
        '''bitrate_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        '''
        result = self._values.get("bitrate_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable"]]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates the bit rate limiting behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable"]]]:
        '''threshold_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        '''
        result = self._values.get("threshold_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable"]]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable",
    jsii_struct_bases=[],
    name_mapping={"bitrate_unit": "bitrateUnit", "bitrate_value": "bitrateValue"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable:
    def __init__(
        self,
        *,
        bitrate_unit: typing.Optional[builtins.str] = None,
        bitrate_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param bitrate_unit: The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        :param bitrate_value: The numeric indicator of the download rate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086d4e758a7b00e45f14d1e07c0c6e0b291becc3ce2d50ce15512b8d615bbbcc)
            check_type(argname="argument bitrate_unit", value=bitrate_unit, expected_type=type_hints["bitrate_unit"])
            check_type(argname="argument bitrate_value", value=bitrate_value, expected_type=type_hints["bitrate_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_unit is not None:
            self._values["bitrate_unit"] = bitrate_unit
        if bitrate_value is not None:
            self._values["bitrate_value"] = bitrate_value

    @builtins.property
    def bitrate_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        '''
        result = self._values.get("bitrate_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def bitrate_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the download rate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        result = self._values.get("bitrate_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1364466b2626900bff1a1079aefbdede9fdbc23052d38d32865013807dbaeb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca51cf4ca2bb4c5c2d2397cc3154f2fb684ac9caaa26583f50943a08bb9256a9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc3675bf9d0cc43929091b18f86640e961d7a5dc9ba48174429e0e71c6f9777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3517add0c8dfb7f77b255db15188d9ca659708db16e5d839d3addb2e62aed5d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d44317fcfe295676a713de412d91cbce8e903ee9f444368db36c26e7c2f30ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36413b54b51c22cb57f060b753dabe2c70a9f701954d2a2b3a37f077afd2a42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3eb944c3ef3a0133ce1156d7ba22b4a920b4c1dfe48f21e96c74b3e0173bf0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBitrateUnit")
    def reset_bitrate_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateUnit", []))

    @jsii.member(jsii_name="resetBitrateValue")
    def reset_bitrate_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateValue", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnitInput")
    def bitrate_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bitrateUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateValueInput")
    def bitrate_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bitrateValueInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnit")
    def bitrate_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bitrateUnit"))

    @bitrate_unit.setter
    def bitrate_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ba31f1d487b458ed4a3a329a4bda265f67d21b9c8cd2d71693ca103934a0f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateUnit", value)

    @builtins.property
    @jsii.member(jsii_name="bitrateValue")
    def bitrate_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bitrateValue"))

    @bitrate_value.setter
    def bitrate_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c93786469d4a399e7dc6f99369eb20702fc67f07a9cbd56baf358a67f4baf8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc5d5f2f8063ed875837514e401d6a55e92e8ceccf1c1090106fac25af5354b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22f3f5117234d0ea376073ffe15c50a2510d978ca5dc3a9ae545ae3e44acfba)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBitrateTable")
    def put_bitrate_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5b1bc4d3baf0e4dcac01f378c67061897fab85434274a37387a62cfb248768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBitrateTable", [value]))

    @jsii.member(jsii_name="putThresholdTable")
    def put_threshold_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea96c3d437c8025f39dd3ac052e0431606090aac78539a42e8ea8bfd7f00103f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putThresholdTable", [value]))

    @jsii.member(jsii_name="resetBitrateTable")
    def reset_bitrate_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateTable", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThresholdTable")
    def reset_threshold_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdTable", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateTable")
    def bitrate_table(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableList, jsii.get(self, "bitrateTable"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTable")
    def threshold_table(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableList", jsii.get(self, "thresholdTable"))

    @builtins.property
    @jsii.member(jsii_name="bitrateTableInput")
    def bitrate_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "bitrateTableInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTableInput")
    def threshold_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable"]]], jsii.get(self, "thresholdTableInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fdbaf76a4f57ebe0cb90bbccc6a04a035dc5d57fe2ed03c0c490a1777164275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caaa07519fa4cfc6fbb144fc909e8722e5854041dd8cfb0a8c3c81b99db60307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee9070780c4ad4226dda743ee3253ae875c5591e655da33ae59d6c5f61aaed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f9583ad52bf5403738790db35254410cdc7af979ca1979a512b662523638c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f8a2ba0f343c6f462e891c975e2064f124c42b725b7f819347c1cfb456c6d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable",
    jsii_struct_bases=[],
    name_mapping={
        "threshold_unit": "thresholdUnit",
        "threshold_value": "thresholdValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable:
    def __init__(
        self,
        *,
        threshold_unit: typing.Optional[builtins.str] = None,
        threshold_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param threshold_unit: The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        :param threshold_value: The numeric indicator of the minimum file size or elapsed download time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c18bbbcd6de340dbee4d70717b934310992dca611e2a66eb15bc07303709b62)
            check_type(argname="argument threshold_unit", value=threshold_unit, expected_type=type_hints["threshold_unit"])
            check_type(argname="argument threshold_value", value=threshold_value, expected_type=type_hints["threshold_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if threshold_unit is not None:
            self._values["threshold_unit"] = threshold_unit
        if threshold_value is not None:
            self._values["threshold_value"] = threshold_value

    @builtins.property
    def threshold_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        '''
        result = self._values.get("threshold_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the minimum file size or elapsed download time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        result = self._values.get("threshold_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5661c565275eb262f21a9bf32d7c701c47a7136f3bbfe8afe4b43e2088440221)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__862a88a0935cdf3c030a7c04687cb0539fdae18df1fbe511574a340a5e2db783)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15f9120bb91c49975da634e8cfceb8bac6844d33c450aff736bde5f77440e460)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e40363cc72723e4e6558e743ec3ccafbfc89ee0d8aa48b0ea63a33e2512a096a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa25553f2a210d87ca0dc9e0f287e608c3f24e017fa06fe2c8c52bea842ca88f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f12eab2c8b544a29e5753e0e019c0dbaf4bd58f92d5bc068ba5239a8fc5ea47d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24205584c714e857764e33d4ac80fb7abade2ea52208f2eb2b46a863f5002017)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetThresholdUnit")
    def reset_threshold_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdUnit", []))

    @jsii.member(jsii_name="resetThresholdValue")
    def reset_threshold_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdValue", []))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnitInput")
    def threshold_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdValueInput")
    def threshold_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "thresholdValueInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnit")
    def threshold_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdUnit"))

    @threshold_unit.setter
    def threshold_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bca8e16fb1bceabfa937be3f09bf9e68a2939757d73fe0cc1445e0c653e1c0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdUnit", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdValue")
    def threshold_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "thresholdValue"))

    @threshold_value.setter
    def threshold_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7714415375335dc52a7874ca67a0de3051311d63638016cabc07ab969946dfd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c278ccae29d50c52e26cb312f57d028efd9f79569ecc052dfb8c72bb9d02734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14078fbccca60c1b30db048b5935c7cac7531bbb58fcf3892aa9842a88b9110e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7f58b639700790bcc8ca5e5dd2ab9852e45c09df17af6341f7ad31a8b752038)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f25321ace0afc002a20960c8699b9081a9e4f8ff0538394b682343bb2f8410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab86fb5d64fc05c3b6ecaa56df370ceb5630a62477f3c3343a398aff55d725b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abd55ee52b5e9f6bbd7256531e338c83a21d7c3f16108d19132acd5d90ebc1dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d0a9a011f72eeca32e2cb73dbdbcb3182eb5a9d8f97266cb4a3c392fd15a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom",
    jsii_struct_bases=[],
    name_mapping={
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_custom_log_field": "logCustomLogField",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom:
    def __init__(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43993f4844de7b7a3ce2808d25aa82cd242ae9097cb98b2953235a8de43a8a0d)
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19e969151f64e876797ebc2a451c7f1d1314e89da38e9ed891a8a5fa26c1c3c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f72b6eab1948f72f1dba63734d09a9475cfd78b5b94daa061c6bf38ef60c2aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bf3d0aa3f5c4ee05f62f903a7256d0ec1db25ed1f37fcf57b7393adc24c55be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40861e44fa5b6a04ebbe53d220a3645065606c1a10cbe1696e749d0bb529688a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe807730519090af265c9fd1a25a430de26dac41363401d373140aeb0744ed0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f7490f8a45db72e037ee1bb73a131ab52b04aba60bbcaff7dedcb841e9dd505)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199440026df2258d0f2f98afe71e39d81fa82e89b51c3fdec803c3652d583560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse",
    jsii_struct_bases=[],
    name_mapping={
        "api_key": "apiKey",
        "buffer_size": "bufferSize",
        "config_override": "configOverride",
        "enabled": "enabled",
        "loader_version": "loaderVersion",
        "locked": "locked",
        "require_pci": "requirePci",
        "template_uuid": "templateUuid",
        "title_optional": "titleOptional",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse:
    def __init__(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4b435e57437c1e3cdce2c0391c00e816606693051395f0a7ea20d580577722d)
            check_type(argname="argument api_key", value=api_key, expected_type=type_hints["api_key"])
            check_type(argname="argument buffer_size", value=buffer_size, expected_type=type_hints["buffer_size"])
            check_type(argname="argument config_override", value=config_override, expected_type=type_hints["config_override"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument loader_version", value=loader_version, expected_type=type_hints["loader_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument require_pci", value=require_pci, expected_type=type_hints["require_pci"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_optional", value=title_optional, expected_type=type_hints["title_optional"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if api_key is not None:
            self._values["api_key"] = api_key
        if buffer_size is not None:
            self._values["buffer_size"] = buffer_size
        if config_override is not None:
            self._values["config_override"] = config_override
        if enabled is not None:
            self._values["enabled"] = enabled
        if loader_version is not None:
            self._values["loader_version"] = loader_version
        if locked is not None:
            self._values["locked"] = locked
        if require_pci is not None:
            self._values["require_pci"] = require_pci
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_optional is not None:
            self._values["title_optional"] = title_optional
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def api_key(self) -> typing.Optional[builtins.str]:
        '''This generated value uniquely identifies sections of your website for you to analyze independently.

        To access this value, see ``Enable mPulse in Property Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        '''
        result = self._values.get("api_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def buffer_size(self) -> typing.Optional[builtins.str]:
        '''Allows you to override the browser's default (150) maximum number of reported performance timeline entries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        '''
        result = self._values.get("buffer_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def config_override(self) -> typing.Optional[builtins.str]:
        '''A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs.

        It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``.  See ``Configuration Overrides`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        '''
        result = self._values.get("config_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies performance monitoring to this behavior's set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def loader_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        '''
        result = self._values.get("loader_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def require_pci(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        '''
        result = self._values.get("require_pci")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_optional(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        '''
        result = self._values.get("title_optional")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f4cbe90a9648a7c6892f3dcd27a4d103990ea2a36e5ddd45fea415f7e4c564)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApiKey")
    def reset_api_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiKey", []))

    @jsii.member(jsii_name="resetBufferSize")
    def reset_buffer_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBufferSize", []))

    @jsii.member(jsii_name="resetConfigOverride")
    def reset_config_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigOverride", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLoaderVersion")
    def reset_loader_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoaderVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequirePci")
    def reset_require_pci(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequirePci", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleOptional")
    def reset_title_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleOptional", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="apiKeyInput")
    def api_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="bufferSizeInput")
    def buffer_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bufferSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="configOverrideInput")
    def config_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="loaderVersionInput")
    def loader_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "loaderVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requirePciInput")
    def require_pci_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "requirePciInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleOptionalInput")
    def title_optional_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleOptionalInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="apiKey")
    def api_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiKey"))

    @api_key.setter
    def api_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba540401bfda7678583bac7cc27fe59ae5fdc708fd0d226b0ef15b6f51351e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiKey", value)

    @builtins.property
    @jsii.member(jsii_name="bufferSize")
    def buffer_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bufferSize"))

    @buffer_size.setter
    def buffer_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b08484f82cd2dd3bebfd084e6a51c4db79328088359ddccf629e816382e885e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bufferSize", value)

    @builtins.property
    @jsii.member(jsii_name="configOverride")
    def config_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configOverride"))

    @config_override.setter
    def config_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4953c7e8e281087ce1f13b0740a3530db96f235a06284c8c4e7ac7fe19ab32a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configOverride", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a30f5f94b5914e1929ba31d405d20d553154c2d8219788ad68c9b3ce462676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="loaderVersion")
    def loader_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "loaderVersion"))

    @loader_version.setter
    def loader_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__611d87f564cc9c359985afcb847e2b0fc1e6ab700298bfea4f80dcca635a486e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loaderVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f56808d1fc99d96e68e79a02cebc060b9ee7e3d91b2cf91981d3f68688c87e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requirePci")
    def require_pci(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "requirePci"))

    @require_pci.setter
    def require_pci(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38eda03603c64114514227554f30d16a13a5657914bd94178c7a09e9a8cc6d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requirePci", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e08b6f81a95608c7dae0e6c0d760b20c178ead9851dd381af01221369281f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleOptional")
    def title_optional(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleOptional"))

    @title_optional.setter
    def title_optional(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39f6f922f41c7d88a7279be9996b89bfb09995d5563b18c2dfa4c659ec83b0a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleOptional", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9cf31d887f75b851ab069fda661a4e3467fa92ee749d445f38dbf49dae3f8c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aaff37835463e0f88d30820ee10c130f27d18e74baf52f6d55b449d8ddd96df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "hls_enabled": "hlsEnabled",
        "hls_enable_debug_headers": "hlsEnableDebugHeaders",
        "hls_filter_in_bitrate_ranges": "hlsFilterInBitrateRanges",
        "hls_filter_in_bitrates": "hlsFilterInBitrates",
        "hls_mode": "hlsMode",
        "hls_preferred_bitrate": "hlsPreferredBitrate",
        "hls_query_param_enabled": "hlsQueryParamEnabled",
        "hls_query_param_secret_key": "hlsQueryParamSecretKey",
        "hls_query_param_transition_key": "hlsQueryParamTransitionKey",
        "hls_show_advanced": "hlsShowAdvanced",
        "hls_title": "hlsTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6469973e9780b6a22ba058cb7be863d39ec37db15fb44b82aa1101b1698091)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hls_enabled", value=hls_enabled, expected_type=type_hints["hls_enabled"])
            check_type(argname="argument hls_enable_debug_headers", value=hls_enable_debug_headers, expected_type=type_hints["hls_enable_debug_headers"])
            check_type(argname="argument hls_filter_in_bitrate_ranges", value=hls_filter_in_bitrate_ranges, expected_type=type_hints["hls_filter_in_bitrate_ranges"])
            check_type(argname="argument hls_filter_in_bitrates", value=hls_filter_in_bitrates, expected_type=type_hints["hls_filter_in_bitrates"])
            check_type(argname="argument hls_mode", value=hls_mode, expected_type=type_hints["hls_mode"])
            check_type(argname="argument hls_preferred_bitrate", value=hls_preferred_bitrate, expected_type=type_hints["hls_preferred_bitrate"])
            check_type(argname="argument hls_query_param_enabled", value=hls_query_param_enabled, expected_type=type_hints["hls_query_param_enabled"])
            check_type(argname="argument hls_query_param_secret_key", value=hls_query_param_secret_key, expected_type=type_hints["hls_query_param_secret_key"])
            check_type(argname="argument hls_query_param_transition_key", value=hls_query_param_transition_key, expected_type=type_hints["hls_query_param_transition_key"])
            check_type(argname="argument hls_show_advanced", value=hls_show_advanced, expected_type=type_hints["hls_show_advanced"])
            check_type(argname="argument hls_title", value=hls_title, expected_type=type_hints["hls_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if hls_enabled is not None:
            self._values["hls_enabled"] = hls_enabled
        if hls_enable_debug_headers is not None:
            self._values["hls_enable_debug_headers"] = hls_enable_debug_headers
        if hls_filter_in_bitrate_ranges is not None:
            self._values["hls_filter_in_bitrate_ranges"] = hls_filter_in_bitrate_ranges
        if hls_filter_in_bitrates is not None:
            self._values["hls_filter_in_bitrates"] = hls_filter_in_bitrates
        if hls_mode is not None:
            self._values["hls_mode"] = hls_mode
        if hls_preferred_bitrate is not None:
            self._values["hls_preferred_bitrate"] = hls_preferred_bitrate
        if hls_query_param_enabled is not None:
            self._values["hls_query_param_enabled"] = hls_query_param_enabled
        if hls_query_param_secret_key is not None:
            self._values["hls_query_param_secret_key"] = hls_query_param_secret_key
        if hls_query_param_transition_key is not None:
            self._values["hls_query_param_transition_key"] = hls_query_param_transition_key
        if hls_show_advanced is not None:
            self._values["hls_show_advanced"] = hls_show_advanced
        if hls_title is not None:
            self._values["hls_title"] = hls_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Manifest Personalization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to customize the HLS master manifest that's sent to the requesting client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        '''
        result = self._values.get("hls_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enable_debug_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        '''
        result = self._values.get("hls_enable_debug_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_filter_in_bitrate_ranges(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        '''
        result = self._values.get("hls_filter_in_bitrate_ranges")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_filter_in_bitrates(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        '''
        result = self._values.get("hls_filter_in_bitrates")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_mode(self) -> typing.Optional[builtins.str]:
        '''Applies with ``hlsEnabled`` on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        '''
        result = self._values.get("hls_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_preferred_bitrate(self) -> typing.Optional[builtins.str]:
        '''Sets the preferred bit rate in Kbps.

        This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        '''
        result = self._values.get("hls_preferred_bitrate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies query parameters for the HLS master manifest to customize the manifest's content.

        Any settings specified in the query string override those already configured in Property Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        '''
        result = self._values.get("hls_query_param_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_query_param_secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a primary key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        '''
        result = self._values.get("hls_query_param_secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        '''
        result = self._values.get("hls_query_param_transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        '''
        result = self._values.get("hls_show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        '''
        result = self._values.get("hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e99fb9f866bc4dcd1967b0479fa0b6adf497a7b4fc8ab21d72b51a9a8609b0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHlsEnabled")
    def reset_hls_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnabled", []))

    @jsii.member(jsii_name="resetHlsEnableDebugHeaders")
    def reset_hls_enable_debug_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnableDebugHeaders", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrateRanges")
    def reset_hls_filter_in_bitrate_ranges(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrateRanges", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrates")
    def reset_hls_filter_in_bitrates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrates", []))

    @jsii.member(jsii_name="resetHlsMode")
    def reset_hls_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMode", []))

    @jsii.member(jsii_name="resetHlsPreferredBitrate")
    def reset_hls_preferred_bitrate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsPreferredBitrate", []))

    @jsii.member(jsii_name="resetHlsQueryParamEnabled")
    def reset_hls_query_param_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamEnabled", []))

    @jsii.member(jsii_name="resetHlsQueryParamSecretKey")
    def reset_hls_query_param_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamSecretKey", []))

    @jsii.member(jsii_name="resetHlsQueryParamTransitionKey")
    def reset_hls_query_param_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamTransitionKey", []))

    @jsii.member(jsii_name="resetHlsShowAdvanced")
    def reset_hls_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsShowAdvanced", []))

    @jsii.member(jsii_name="resetHlsTitle")
    def reset_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeadersInput")
    def hls_enable_debug_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnableDebugHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnabledInput")
    def hls_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRangesInput")
    def hls_filter_in_bitrate_ranges_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitrateRangesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitratesInput")
    def hls_filter_in_bitrates_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitratesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsModeInput")
    def hls_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsModeInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrateInput")
    def hls_preferred_bitrate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsPreferredBitrateInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabledInput")
    def hls_query_param_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsQueryParamEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKeyInput")
    def hls_query_param_secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamSecretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKeyInput")
    def hls_query_param_transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamTransitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvancedInput")
    def hls_show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsShowAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsTitleInput")
    def hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ef2b4a9ffabbece0da4a98c83dc5c4919fad9e94adbe13eebd9927453193e66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnabled")
    def hls_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnabled"))

    @hls_enabled.setter
    def hls_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94be0392558db501eb01cb8ed5f8ae1ac270a8444fa114d672381f2c92de75a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeaders")
    def hls_enable_debug_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnableDebugHeaders"))

    @hls_enable_debug_headers.setter
    def hls_enable_debug_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dfa7616178a3e01e8addc97e0e55b036125dc142d67ddd04c673f479e4d22a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnableDebugHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRanges")
    def hls_filter_in_bitrate_ranges(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrateRanges"))

    @hls_filter_in_bitrate_ranges.setter
    def hls_filter_in_bitrate_ranges(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccf21840184707055861c1b6e3ff57fd096c07e6a20dda3e43d58fe885f305e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrateRanges", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrates")
    def hls_filter_in_bitrates(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrates"))

    @hls_filter_in_bitrates.setter
    def hls_filter_in_bitrates(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d9e1cf8924d653b4fab5eaffbab093fa7ada43db747ba98355eec6d84b56a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrates", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMode")
    def hls_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsMode"))

    @hls_mode.setter
    def hls_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc4d33b96f5ea7758afe2e385ed49271f4debf9c58abddab50edf82d4eecd0d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMode", value)

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrate")
    def hls_preferred_bitrate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsPreferredBitrate"))

    @hls_preferred_bitrate.setter
    def hls_preferred_bitrate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900ed75623c2a88311503b1d6fa61aec16d80c574b1dc8c78934546397ec2c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsPreferredBitrate", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabled")
    def hls_query_param_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsQueryParamEnabled"))

    @hls_query_param_enabled.setter
    def hls_query_param_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6e9ee10462558cf30e684145c13c9536ecb39a9ecba779fbcfd6c09975b7cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKey")
    def hls_query_param_secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamSecretKey"))

    @hls_query_param_secret_key.setter
    def hls_query_param_secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e543a136102ce8d319b16c0106e397c1dd617d3eb3043161adf13b32e42beeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamSecretKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKey")
    def hls_query_param_transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamTransitionKey"))

    @hls_query_param_transition_key.setter
    def hls_query_param_transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb7eead3c6d87b32bdb8b734fc3e109e017162087845b160f2521035386f105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamTransitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvanced")
    def hls_show_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsShowAdvanced"))

    @hls_show_advanced.setter
    def hls_show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__762561d11433e482309f8109b94dda8134fbd7bdf0bdb30f6ef1fd036b6dea68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsShowAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="hlsTitle")
    def hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsTitle"))

    @hls_title.setter
    def hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25714b993f798317d109cd81f578c99536c08e4253575b640707286e7b6e9c14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98b6b5c1952bed0e16fac810a3c5402049b6fc7ef4bcb53bc0bba446a9e22a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50760f423ba55f42a582079e0f1029b9dc82f594830a9b86726d839adc8dcc40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f3aa95449d650c09280adea696ae78f8df486b784c1db7b9625e3effd42828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c25cafdb37062c59c748c5d86d17c1f13b7b5fbfb2b8bff310f9dc67607ddf04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "partner": "partner",
        "template_uuid": "templateUuid",
        "username": "username",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a130a2cc0ae281c8a25dbd921196fdbd35a474a39bbb974b42b9a94e6489468)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument partner", value=partner, expected_type=type_hints["partner"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument username", value=username, expected_type=type_hints["username"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if partner is not None:
            self._values["partner"] = partner
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if username is not None:
            self._values["username"] = username
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner(self) -> typing.Optional[builtins.str]:
        '''Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        '''
        result = self._values.get("partner")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def username(self) -> typing.Optional[builtins.str]:
        '''The user name for your Adobe Primetime account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        '''
        result = self._values.get("username")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7bd468b3865e2b0874603596a87238dce32bfaf026d51d5892d4f0f55ef639)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPartner")
    def reset_partner(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartner", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsername")
    def reset_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsername", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerInput")
    def partner_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usernameInput")
    def username_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usernameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc1dafc6e7ce421c08bc41ba6d29e4c447a53990de1a44d25534c3d6c5bacde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="partner")
    def partner(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partner"))

    @partner.setter
    def partner(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f43e5fa449d43cd18360f8bb9cf0a9601432543554e8c1fd9c15a4c750ee97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partner", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__175c3a48bc6d5da5232ad7b15abeb214ca4fe012a4f8a3b62636f299fd53dabc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="username")
    def username(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "username"))

    @username.setter
    def username(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7542edef3bc46ec56b0d5ff6ceea7a25f59e1820e94fd659025004805b7c433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "username", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bae67faa8dd91a8fd934249135fdf0a13293b69993249ae5fce36693072480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b1e8ea6d76c0313a771f635a8b68de56306b5ad5a5ca02c8d38a8aa3a9259b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "serverpushlist": "serverpushlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6caadb9f53c44e0d0ac4ae7f87d121b6487f431c017b2a8bece659c6f1cb545)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serverpushlist", value=serverpushlist, expected_type=type_hints["serverpushlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if serverpushlist is not None:
            self._values["serverpushlist"] = serverpushlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serverpushlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of objects to load into the client browser's cache over HTTP2.

        Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        '''
        result = self._values.get("serverpushlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a7bf8d9ade368df1c644b7d773042348fdac8acb4fb2faf16dcf877a6864433)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServerpushlist")
    def reset_serverpushlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerpushlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serverpushlistInput")
    def serverpushlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "serverpushlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07c289912b89d53b7cfad33d3fd9a3f7f306693dbe01b27abc89236735f525cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serverpushlist")
    def serverpushlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "serverpushlist"))

    @serverpushlist.setter
    def serverpushlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f15326719b05158bdd1423be394af80a4fb415596a43a5ab215e5263263b1ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serverpushlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b54d6d17ba89797646733b572faf9f793788848019ff6c9872b9d15512af8fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d14f9ce42a1a25aa15d0f8ca800b2ecd8d92ab177e8eb705ec28b3d18a7b5c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bfedf47f022cdd5e010c1bea6c961e47b8936e471e9dcdfd29f49a9ebfcbd4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce5b5ece3990409ce5b684430a27bcce395a2bdd82ac9771abca7f0f421970b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Media Acceleration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c988acefac7b62cb3ed19107053cc100f4eb025f302b3e794daa97fd49635394)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebfce4681b2677766878b3bf01ae4d36a33d694d00b3ecaec6e202655e7cbced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7352a8c231a12fa2a95fdf20580166466e7d223f740beaeed61d80bdb9d6da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9db59ee695e12e6df06a038622335820c05bbdf7d40ad2b1161c366cfdc01fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d51dbcc2a7db22695e6f93af9f98dc8038e95caa1bc1bb6c5a1eedc9b0e82e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df6ba1a4bc41b3d3bbd70b79538a010888e407659f93897cfd843ae9a88e06b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "optout": "optout",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48b5ec9066803cbe4577e9f0c8869cc8896f24c2949427303d2b13952fe81f9a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optout", value=optout, expected_type=type_hints["optout"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if optout is not None:
            self._values["optout"] = optout
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optout(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        '''
        result = self._values.get("optout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8967d74c2ef3a9ebf53c56825eb843a7bb9bdb7abe312c475f4404a91f1e77f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptout")
    def reset_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptout", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optoutInput")
    def optout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optoutInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0a71944f8ba1f866b951b5f83349d19b18ce1c5511cd165da5a14fa64cbc0fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optout")
    def optout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optout"))

    @optout.setter
    def optout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ec859b36508b048e51e0db12c632059ff0fff3aa7ceed719fff87b941a4dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optout", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4a20fbc453ab57a6eb61c82b5529fae5253c9993ba64ac9c3497e6ec9f96c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0363a57223ae9b363cdab06bf396127625147f73dfa58490836232587f51602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__274f368b8e76cfca0bcb92a6a6cc652b7419375d29c41fa80dfd67c5adaeb1e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_id": "beaconId",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_hybrid_http_udp": "useHybridHttpUdp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient:
    def __init__(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a789544e8e715749307052b1cdeb0123c07012609ed9a60a8fc56d8eaec764fc)
            check_type(argname="argument beacon_id", value=beacon_id, expected_type=type_hints["beacon_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_hybrid_http_udp", value=use_hybrid_http_udp, expected_type=type_hints["use_hybrid_http_udp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_id is not None:
            self._values["beacon_id"] = beacon_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_hybrid_http_udp is not None:
            self._values["use_hybrid_http_udp"] = use_hybrid_http_udp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ID of data source's beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        '''
        result = self._values.get("beacon_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables client-side download analytics.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_hybrid_http_udp(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the hybrid HTTP/UDP protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        '''
        result = self._values.get("use_hybrid_http_udp")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ad778f85ef8817859059220e052f7dcd7e6412efbc04463e435edd46a987c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconId")
    def reset_beacon_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHybridHttpUdp")
    def reset_use_hybrid_http_udp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHybridHttpUdp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconIdInput")
    def beacon_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdpInput")
    def use_hybrid_http_udp_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHybridHttpUdpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconId")
    def beacon_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconId"))

    @beacon_id.setter
    def beacon_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4f929a9a37a60ab2e1843b54ea1a9785704fc8e681e704ff5354e5ecc6cd62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a92e8c8355efa4c64a92925f8ca177629392c16bc59eee7399eefc2c0ed230e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81286db65e3dad0880626f6788af090361402895c36e97932c4354224a11842d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891fc5608cc12ece68b5f7aad5e64ee61da2de59ff7319cddefb7245c762e1c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdp")
    def use_hybrid_http_udp(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHybridHttpUdp"))

    @use_hybrid_http_udp.setter
    def use_hybrid_http_udp(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8caaabe6b23c41ab92b11a51cf97e30216c87114498531fb5c19d7bb1d80f04b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHybridHttpUdp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66ebcc95307ffdaf6338df28d9e0d99abd972513f0319cbb10287a8a0e9b390d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f99de19595d4f2265599bb994c1c7e208e332b1a13675638b3d88c3b07bd8c49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18f246113cdd1d08832a99db1f9b088bad973307cb589e448f0ba7c1dc830a0c)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the partial-object caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f406a0910e6fe2825b0cbcf34f6a61025af471bf378c5c0ca38e138e1e13a9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd141bbfa4d6c29aa9994371328be7e9800dc019e1b48e47d51a988c6d65b563)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc53f3726cb065f283e8056b599ea7c4044ed3b590911e8d8ad062ab444ff14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffab7ff4e691496c4d3574516c0eb4adc2f245f1ac384c9dcb154f88e22f6c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7e5b957e446c276782ee80f61354ce09c7c49851cf4cf0cc2b7290f5d17332c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85fc14982573cca302449f03bd61b5e08ef694ccfeb5666a09fc4497c06a0ef4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover",
    jsii_struct_bases=[],
    name_mapping={
        "cache_error_response": "cacheErrorResponse",
        "cache_window": "cacheWindow",
        "client_response_code": "clientResponseCode",
        "detect_object_unavailable": "detectObjectUnavailable",
        "detect_object_unavailable_title": "detectObjectUnavailableTitle",
        "detect_origin_unavailable": "detectOriginUnavailable",
        "detect_origin_unavailable_title": "detectOriginUnavailableTitle",
        "detect_origin_unresponsive": "detectOriginUnresponsive",
        "detect_origin_unresponsive_title": "detectOriginUnresponsiveTitle",
        "locked": "locked",
        "object_unavailable_alternate_host": "objectUnavailableAlternateHost",
        "object_unavailable_backup_host": "objectUnavailableBackupHost",
        "object_unavailable_blacklist_origin_ip": "objectUnavailableBlacklistOriginIp",
        "object_unavailable_blacklist_window": "objectUnavailableBlacklistWindow",
        "object_unavailable_change_protocol": "objectUnavailableChangeProtocol",
        "object_unavailable_detection_level": "objectUnavailableDetectionLevel",
        "object_unavailable_include_query_string": "objectUnavailableIncludeQueryString",
        "object_unavailable_modified_path": "objectUnavailableModifiedPath",
        "object_unavailable_modify_request_path": "objectUnavailableModifyRequestPath",
        "object_unavailable_protocol": "objectUnavailableProtocol",
        "object_unavailable_recovery": "objectUnavailableRecovery",
        "object_unavailable_redirect_method": "objectUnavailableRedirectMethod",
        "object_unavailable_response_codes": "objectUnavailableResponseCodes",
        "object_unavailable_retry_limit": "objectUnavailableRetryLimit",
        "origin_unavailable_alternate_host": "originUnavailableAlternateHost",
        "origin_unavailable_backup_host": "originUnavailableBackupHost",
        "origin_unavailable_blacklist_origin_ip": "originUnavailableBlacklistOriginIp",
        "origin_unavailable_blacklist_window": "originUnavailableBlacklistWindow",
        "origin_unavailable_change_protocol": "originUnavailableChangeProtocol",
        "origin_unavailable_detection_level": "originUnavailableDetectionLevel",
        "origin_unavailable_include_query_string": "originUnavailableIncludeQueryString",
        "origin_unavailable_modified_path": "originUnavailableModifiedPath",
        "origin_unavailable_modify_request_path": "originUnavailableModifyRequestPath",
        "origin_unavailable_protocol": "originUnavailableProtocol",
        "origin_unavailable_recovery": "originUnavailableRecovery",
        "origin_unavailable_redirect_method": "originUnavailableRedirectMethod",
        "origin_unavailable_response_codes": "originUnavailableResponseCodes",
        "origin_unavailable_retry_limit": "originUnavailableRetryLimit",
        "origin_unresponsive_alternate_host": "originUnresponsiveAlternateHost",
        "origin_unresponsive_backup_host": "originUnresponsiveBackupHost",
        "origin_unresponsive_blacklist_origin_ip": "originUnresponsiveBlacklistOriginIp",
        "origin_unresponsive_blacklist_window": "originUnresponsiveBlacklistWindow",
        "origin_unresponsive_change_protocol": "originUnresponsiveChangeProtocol",
        "origin_unresponsive_detection_level": "originUnresponsiveDetectionLevel",
        "origin_unresponsive_include_query_string": "originUnresponsiveIncludeQueryString",
        "origin_unresponsive_modified_path": "originUnresponsiveModifiedPath",
        "origin_unresponsive_modify_request_path": "originUnresponsiveModifyRequestPath",
        "origin_unresponsive_protocol": "originUnresponsiveProtocol",
        "origin_unresponsive_recovery": "originUnresponsiveRecovery",
        "origin_unresponsive_redirect_method": "originUnresponsiveRedirectMethod",
        "origin_unresponsive_retry_limit": "originUnresponsiveRetryLimit",
        "other_options": "otherOptions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover:
    def __init__(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9a281fa131e167774d9ecec251dd22f81c35e45edad2a8eaa93a5a949265069)
            check_type(argname="argument cache_error_response", value=cache_error_response, expected_type=type_hints["cache_error_response"])
            check_type(argname="argument cache_window", value=cache_window, expected_type=type_hints["cache_window"])
            check_type(argname="argument client_response_code", value=client_response_code, expected_type=type_hints["client_response_code"])
            check_type(argname="argument detect_object_unavailable", value=detect_object_unavailable, expected_type=type_hints["detect_object_unavailable"])
            check_type(argname="argument detect_object_unavailable_title", value=detect_object_unavailable_title, expected_type=type_hints["detect_object_unavailable_title"])
            check_type(argname="argument detect_origin_unavailable", value=detect_origin_unavailable, expected_type=type_hints["detect_origin_unavailable"])
            check_type(argname="argument detect_origin_unavailable_title", value=detect_origin_unavailable_title, expected_type=type_hints["detect_origin_unavailable_title"])
            check_type(argname="argument detect_origin_unresponsive", value=detect_origin_unresponsive, expected_type=type_hints["detect_origin_unresponsive"])
            check_type(argname="argument detect_origin_unresponsive_title", value=detect_origin_unresponsive_title, expected_type=type_hints["detect_origin_unresponsive_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_unavailable_alternate_host", value=object_unavailable_alternate_host, expected_type=type_hints["object_unavailable_alternate_host"])
            check_type(argname="argument object_unavailable_backup_host", value=object_unavailable_backup_host, expected_type=type_hints["object_unavailable_backup_host"])
            check_type(argname="argument object_unavailable_blacklist_origin_ip", value=object_unavailable_blacklist_origin_ip, expected_type=type_hints["object_unavailable_blacklist_origin_ip"])
            check_type(argname="argument object_unavailable_blacklist_window", value=object_unavailable_blacklist_window, expected_type=type_hints["object_unavailable_blacklist_window"])
            check_type(argname="argument object_unavailable_change_protocol", value=object_unavailable_change_protocol, expected_type=type_hints["object_unavailable_change_protocol"])
            check_type(argname="argument object_unavailable_detection_level", value=object_unavailable_detection_level, expected_type=type_hints["object_unavailable_detection_level"])
            check_type(argname="argument object_unavailable_include_query_string", value=object_unavailable_include_query_string, expected_type=type_hints["object_unavailable_include_query_string"])
            check_type(argname="argument object_unavailable_modified_path", value=object_unavailable_modified_path, expected_type=type_hints["object_unavailable_modified_path"])
            check_type(argname="argument object_unavailable_modify_request_path", value=object_unavailable_modify_request_path, expected_type=type_hints["object_unavailable_modify_request_path"])
            check_type(argname="argument object_unavailable_protocol", value=object_unavailable_protocol, expected_type=type_hints["object_unavailable_protocol"])
            check_type(argname="argument object_unavailable_recovery", value=object_unavailable_recovery, expected_type=type_hints["object_unavailable_recovery"])
            check_type(argname="argument object_unavailable_redirect_method", value=object_unavailable_redirect_method, expected_type=type_hints["object_unavailable_redirect_method"])
            check_type(argname="argument object_unavailable_response_codes", value=object_unavailable_response_codes, expected_type=type_hints["object_unavailable_response_codes"])
            check_type(argname="argument object_unavailable_retry_limit", value=object_unavailable_retry_limit, expected_type=type_hints["object_unavailable_retry_limit"])
            check_type(argname="argument origin_unavailable_alternate_host", value=origin_unavailable_alternate_host, expected_type=type_hints["origin_unavailable_alternate_host"])
            check_type(argname="argument origin_unavailable_backup_host", value=origin_unavailable_backup_host, expected_type=type_hints["origin_unavailable_backup_host"])
            check_type(argname="argument origin_unavailable_blacklist_origin_ip", value=origin_unavailable_blacklist_origin_ip, expected_type=type_hints["origin_unavailable_blacklist_origin_ip"])
            check_type(argname="argument origin_unavailable_blacklist_window", value=origin_unavailable_blacklist_window, expected_type=type_hints["origin_unavailable_blacklist_window"])
            check_type(argname="argument origin_unavailable_change_protocol", value=origin_unavailable_change_protocol, expected_type=type_hints["origin_unavailable_change_protocol"])
            check_type(argname="argument origin_unavailable_detection_level", value=origin_unavailable_detection_level, expected_type=type_hints["origin_unavailable_detection_level"])
            check_type(argname="argument origin_unavailable_include_query_string", value=origin_unavailable_include_query_string, expected_type=type_hints["origin_unavailable_include_query_string"])
            check_type(argname="argument origin_unavailable_modified_path", value=origin_unavailable_modified_path, expected_type=type_hints["origin_unavailable_modified_path"])
            check_type(argname="argument origin_unavailable_modify_request_path", value=origin_unavailable_modify_request_path, expected_type=type_hints["origin_unavailable_modify_request_path"])
            check_type(argname="argument origin_unavailable_protocol", value=origin_unavailable_protocol, expected_type=type_hints["origin_unavailable_protocol"])
            check_type(argname="argument origin_unavailable_recovery", value=origin_unavailable_recovery, expected_type=type_hints["origin_unavailable_recovery"])
            check_type(argname="argument origin_unavailable_redirect_method", value=origin_unavailable_redirect_method, expected_type=type_hints["origin_unavailable_redirect_method"])
            check_type(argname="argument origin_unavailable_response_codes", value=origin_unavailable_response_codes, expected_type=type_hints["origin_unavailable_response_codes"])
            check_type(argname="argument origin_unavailable_retry_limit", value=origin_unavailable_retry_limit, expected_type=type_hints["origin_unavailable_retry_limit"])
            check_type(argname="argument origin_unresponsive_alternate_host", value=origin_unresponsive_alternate_host, expected_type=type_hints["origin_unresponsive_alternate_host"])
            check_type(argname="argument origin_unresponsive_backup_host", value=origin_unresponsive_backup_host, expected_type=type_hints["origin_unresponsive_backup_host"])
            check_type(argname="argument origin_unresponsive_blacklist_origin_ip", value=origin_unresponsive_blacklist_origin_ip, expected_type=type_hints["origin_unresponsive_blacklist_origin_ip"])
            check_type(argname="argument origin_unresponsive_blacklist_window", value=origin_unresponsive_blacklist_window, expected_type=type_hints["origin_unresponsive_blacklist_window"])
            check_type(argname="argument origin_unresponsive_change_protocol", value=origin_unresponsive_change_protocol, expected_type=type_hints["origin_unresponsive_change_protocol"])
            check_type(argname="argument origin_unresponsive_detection_level", value=origin_unresponsive_detection_level, expected_type=type_hints["origin_unresponsive_detection_level"])
            check_type(argname="argument origin_unresponsive_include_query_string", value=origin_unresponsive_include_query_string, expected_type=type_hints["origin_unresponsive_include_query_string"])
            check_type(argname="argument origin_unresponsive_modified_path", value=origin_unresponsive_modified_path, expected_type=type_hints["origin_unresponsive_modified_path"])
            check_type(argname="argument origin_unresponsive_modify_request_path", value=origin_unresponsive_modify_request_path, expected_type=type_hints["origin_unresponsive_modify_request_path"])
            check_type(argname="argument origin_unresponsive_protocol", value=origin_unresponsive_protocol, expected_type=type_hints["origin_unresponsive_protocol"])
            check_type(argname="argument origin_unresponsive_recovery", value=origin_unresponsive_recovery, expected_type=type_hints["origin_unresponsive_recovery"])
            check_type(argname="argument origin_unresponsive_redirect_method", value=origin_unresponsive_redirect_method, expected_type=type_hints["origin_unresponsive_redirect_method"])
            check_type(argname="argument origin_unresponsive_retry_limit", value=origin_unresponsive_retry_limit, expected_type=type_hints["origin_unresponsive_retry_limit"])
            check_type(argname="argument other_options", value=other_options, expected_type=type_hints["other_options"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_error_response is not None:
            self._values["cache_error_response"] = cache_error_response
        if cache_window is not None:
            self._values["cache_window"] = cache_window
        if client_response_code is not None:
            self._values["client_response_code"] = client_response_code
        if detect_object_unavailable is not None:
            self._values["detect_object_unavailable"] = detect_object_unavailable
        if detect_object_unavailable_title is not None:
            self._values["detect_object_unavailable_title"] = detect_object_unavailable_title
        if detect_origin_unavailable is not None:
            self._values["detect_origin_unavailable"] = detect_origin_unavailable
        if detect_origin_unavailable_title is not None:
            self._values["detect_origin_unavailable_title"] = detect_origin_unavailable_title
        if detect_origin_unresponsive is not None:
            self._values["detect_origin_unresponsive"] = detect_origin_unresponsive
        if detect_origin_unresponsive_title is not None:
            self._values["detect_origin_unresponsive_title"] = detect_origin_unresponsive_title
        if locked is not None:
            self._values["locked"] = locked
        if object_unavailable_alternate_host is not None:
            self._values["object_unavailable_alternate_host"] = object_unavailable_alternate_host
        if object_unavailable_backup_host is not None:
            self._values["object_unavailable_backup_host"] = object_unavailable_backup_host
        if object_unavailable_blacklist_origin_ip is not None:
            self._values["object_unavailable_blacklist_origin_ip"] = object_unavailable_blacklist_origin_ip
        if object_unavailable_blacklist_window is not None:
            self._values["object_unavailable_blacklist_window"] = object_unavailable_blacklist_window
        if object_unavailable_change_protocol is not None:
            self._values["object_unavailable_change_protocol"] = object_unavailable_change_protocol
        if object_unavailable_detection_level is not None:
            self._values["object_unavailable_detection_level"] = object_unavailable_detection_level
        if object_unavailable_include_query_string is not None:
            self._values["object_unavailable_include_query_string"] = object_unavailable_include_query_string
        if object_unavailable_modified_path is not None:
            self._values["object_unavailable_modified_path"] = object_unavailable_modified_path
        if object_unavailable_modify_request_path is not None:
            self._values["object_unavailable_modify_request_path"] = object_unavailable_modify_request_path
        if object_unavailable_protocol is not None:
            self._values["object_unavailable_protocol"] = object_unavailable_protocol
        if object_unavailable_recovery is not None:
            self._values["object_unavailable_recovery"] = object_unavailable_recovery
        if object_unavailable_redirect_method is not None:
            self._values["object_unavailable_redirect_method"] = object_unavailable_redirect_method
        if object_unavailable_response_codes is not None:
            self._values["object_unavailable_response_codes"] = object_unavailable_response_codes
        if object_unavailable_retry_limit is not None:
            self._values["object_unavailable_retry_limit"] = object_unavailable_retry_limit
        if origin_unavailable_alternate_host is not None:
            self._values["origin_unavailable_alternate_host"] = origin_unavailable_alternate_host
        if origin_unavailable_backup_host is not None:
            self._values["origin_unavailable_backup_host"] = origin_unavailable_backup_host
        if origin_unavailable_blacklist_origin_ip is not None:
            self._values["origin_unavailable_blacklist_origin_ip"] = origin_unavailable_blacklist_origin_ip
        if origin_unavailable_blacklist_window is not None:
            self._values["origin_unavailable_blacklist_window"] = origin_unavailable_blacklist_window
        if origin_unavailable_change_protocol is not None:
            self._values["origin_unavailable_change_protocol"] = origin_unavailable_change_protocol
        if origin_unavailable_detection_level is not None:
            self._values["origin_unavailable_detection_level"] = origin_unavailable_detection_level
        if origin_unavailable_include_query_string is not None:
            self._values["origin_unavailable_include_query_string"] = origin_unavailable_include_query_string
        if origin_unavailable_modified_path is not None:
            self._values["origin_unavailable_modified_path"] = origin_unavailable_modified_path
        if origin_unavailable_modify_request_path is not None:
            self._values["origin_unavailable_modify_request_path"] = origin_unavailable_modify_request_path
        if origin_unavailable_protocol is not None:
            self._values["origin_unavailable_protocol"] = origin_unavailable_protocol
        if origin_unavailable_recovery is not None:
            self._values["origin_unavailable_recovery"] = origin_unavailable_recovery
        if origin_unavailable_redirect_method is not None:
            self._values["origin_unavailable_redirect_method"] = origin_unavailable_redirect_method
        if origin_unavailable_response_codes is not None:
            self._values["origin_unavailable_response_codes"] = origin_unavailable_response_codes
        if origin_unavailable_retry_limit is not None:
            self._values["origin_unavailable_retry_limit"] = origin_unavailable_retry_limit
        if origin_unresponsive_alternate_host is not None:
            self._values["origin_unresponsive_alternate_host"] = origin_unresponsive_alternate_host
        if origin_unresponsive_backup_host is not None:
            self._values["origin_unresponsive_backup_host"] = origin_unresponsive_backup_host
        if origin_unresponsive_blacklist_origin_ip is not None:
            self._values["origin_unresponsive_blacklist_origin_ip"] = origin_unresponsive_blacklist_origin_ip
        if origin_unresponsive_blacklist_window is not None:
            self._values["origin_unresponsive_blacklist_window"] = origin_unresponsive_blacklist_window
        if origin_unresponsive_change_protocol is not None:
            self._values["origin_unresponsive_change_protocol"] = origin_unresponsive_change_protocol
        if origin_unresponsive_detection_level is not None:
            self._values["origin_unresponsive_detection_level"] = origin_unresponsive_detection_level
        if origin_unresponsive_include_query_string is not None:
            self._values["origin_unresponsive_include_query_string"] = origin_unresponsive_include_query_string
        if origin_unresponsive_modified_path is not None:
            self._values["origin_unresponsive_modified_path"] = origin_unresponsive_modified_path
        if origin_unresponsive_modify_request_path is not None:
            self._values["origin_unresponsive_modify_request_path"] = origin_unresponsive_modify_request_path
        if origin_unresponsive_protocol is not None:
            self._values["origin_unresponsive_protocol"] = origin_unresponsive_protocol
        if origin_unresponsive_recovery is not None:
            self._values["origin_unresponsive_recovery"] = origin_unresponsive_recovery
        if origin_unresponsive_redirect_method is not None:
            self._values["origin_unresponsive_redirect_method"] = origin_unresponsive_redirect_method
        if origin_unresponsive_retry_limit is not None:
            self._values["origin_unresponsive_retry_limit"] = origin_unresponsive_retry_limit
        if other_options is not None:
            self._values["other_options"] = other_options
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cache_error_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches the error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        '''
        result = self._values.get("cache_error_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_window(self) -> typing.Optional[builtins.str]:
        '''This sets error response's TTL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        '''
        result = self._values.get("cache_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_response_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the response code served to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        '''
        result = self._values.get("client_response_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_object_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin has content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        '''
        result = self._values.get("detect_object_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_object_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        '''
        result = self._values.get("detect_object_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin server responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        '''
        result = self._values.get("detect_origin_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        '''
        result = self._values.get("detect_origin_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unresponsive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure what happens when the origin is unresponsive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        '''
        result = self._values.get("detect_origin_unresponsive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unresponsive_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        '''
        result = self._values.get("detect_origin_unresponsive_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        '''
        result = self._values.get("object_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        '''
        result = self._values.get("object_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("object_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        '''
        result = self._values.get("object_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Changes the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        '''
        result = self._values.get("object_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        '''
        result = self._values.get("object_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        '''
        result = self._values.get("object_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        '''
        result = self._values.get("object_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to modify the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        '''
        result = self._values.get("object_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        '''
        result = self._values.get("object_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        '''
        result = self._values.get("object_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        '''
        result = self._values.get("object_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def object_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when there are content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        '''
        result = self._values.get("object_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def object_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        '''
        result = self._values.get("object_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        '''
        result = self._values.get("origin_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        '''
        result = self._values.get("origin_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        '''
        result = self._values.get("origin_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        '''
        result = self._values.get("origin_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        '''
        result = self._values.get("origin_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        '''
        result = self._values.get("origin_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        '''
        result = self._values.get("origin_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        '''
        result = self._values.get("origin_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        '''
        result = self._values.get("origin_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        '''
        result = self._values.get("origin_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies either a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        '''
        result = self._values.get("origin_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when the origin responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        '''
        result = self._values.get("origin_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origin_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        '''
        result = self._values.get("origin_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        '''
        result = self._values.get("origin_unresponsive_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        '''
        result = self._values.get("origin_unresponsive_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unresponsive_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        '''
        result = self._values.get("origin_unresponsive_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This allows you to change the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        '''
        result = self._values.get("origin_unresponsive_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify the level of response to slow origin connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        '''
        result = self._values.get("origin_unresponsive_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        '''
        result = self._values.get("origin_unresponsive_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        '''
        result = self._values.get("origin_unresponsive_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        '''
        result = self._values.get("origin_unresponsive_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies which protocol to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        '''
        result = self._values.get("origin_unresponsive_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        '''
        result = self._values.get("origin_unresponsive_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        '''
        result = self._values.get("origin_unresponsive_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unresponsive_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        '''
        result = self._values.get("origin_unresponsive_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def other_options(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        '''
        result = self._values.get("other_options")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf82e1cb438e3c16b434d882bba78ea07ce2e898fe8dec3eb79314117ff47a23)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCacheErrorResponse")
    def reset_cache_error_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheErrorResponse", []))

    @jsii.member(jsii_name="resetCacheWindow")
    def reset_cache_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheWindow", []))

    @jsii.member(jsii_name="resetClientResponseCode")
    def reset_client_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientResponseCode", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailable")
    def reset_detect_object_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailable", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailableTitle")
    def reset_detect_object_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailable")
    def reset_detect_origin_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailable", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailableTitle")
    def reset_detect_origin_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsive")
    def reset_detect_origin_unresponsive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsive", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsiveTitle")
    def reset_detect_origin_unresponsive_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsiveTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectUnavailableAlternateHost")
    def reset_object_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBackupHost")
    def reset_object_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistOriginIp")
    def reset_object_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistWindow")
    def reset_object_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetObjectUnavailableChangeProtocol")
    def reset_object_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableDetectionLevel")
    def reset_object_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetObjectUnavailableIncludeQueryString")
    def reset_object_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifiedPath")
    def reset_object_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifyRequestPath")
    def reset_object_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableProtocol")
    def reset_object_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableRecovery")
    def reset_object_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRecovery", []))

    @jsii.member(jsii_name="resetObjectUnavailableRedirectMethod")
    def reset_object_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetObjectUnavailableResponseCodes")
    def reset_object_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetObjectUnavailableRetryLimit")
    def reset_object_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnavailableAlternateHost")
    def reset_origin_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBackupHost")
    def reset_origin_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistOriginIp")
    def reset_origin_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistWindow")
    def reset_origin_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnavailableChangeProtocol")
    def reset_origin_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableDetectionLevel")
    def reset_origin_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnavailableIncludeQueryString")
    def reset_origin_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifiedPath")
    def reset_origin_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifyRequestPath")
    def reset_origin_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableProtocol")
    def reset_origin_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableRecovery")
    def reset_origin_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRecovery", []))

    @jsii.member(jsii_name="resetOriginUnavailableRedirectMethod")
    def reset_origin_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnavailableResponseCodes")
    def reset_origin_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetOriginUnavailableRetryLimit")
    def reset_origin_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveAlternateHost")
    def reset_origin_unresponsive_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBackupHost")
    def reset_origin_unresponsive_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistOriginIp")
    def reset_origin_unresponsive_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistWindow")
    def reset_origin_unresponsive_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveChangeProtocol")
    def reset_origin_unresponsive_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveDetectionLevel")
    def reset_origin_unresponsive_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveIncludeQueryString")
    def reset_origin_unresponsive_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifiedPath")
    def reset_origin_unresponsive_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifyRequestPath")
    def reset_origin_unresponsive_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveProtocol")
    def reset_origin_unresponsive_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRecovery")
    def reset_origin_unresponsive_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRecovery", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRedirectMethod")
    def reset_origin_unresponsive_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRetryLimit")
    def reset_origin_unresponsive_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRetryLimit", []))

    @jsii.member(jsii_name="resetOtherOptions")
    def reset_other_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOtherOptions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponseInput")
    def cache_error_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheErrorResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheWindowInput")
    def cache_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="clientResponseCodeInput")
    def client_response_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableInput")
    def detect_object_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectObjectUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitleInput")
    def detect_object_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectObjectUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableInput")
    def detect_origin_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitleInput")
    def detect_origin_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveInput")
    def detect_origin_unresponsive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnresponsiveInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitleInput")
    def detect_origin_unresponsive_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnresponsiveTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHostInput")
    def object_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHostInput")
    def object_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIpInput")
    def object_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindowInput")
    def object_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocolInput")
    def object_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevelInput")
    def object_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryStringInput")
    def object_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPathInput")
    def object_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPathInput")
    def object_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocolInput")
    def object_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecoveryInput")
    def object_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethodInput")
    def object_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "objectUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodesInput")
    def object_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "objectUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimitInput")
    def object_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHostInput")
    def origin_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHostInput")
    def origin_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIpInput")
    def origin_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindowInput")
    def origin_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocolInput")
    def origin_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevelInput")
    def origin_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryStringInput")
    def origin_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPathInput")
    def origin_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPathInput")
    def origin_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocolInput")
    def origin_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecoveryInput")
    def origin_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethodInput")
    def origin_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodesInput")
    def origin_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimitInput")
    def origin_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHostInput")
    def origin_unresponsive_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHostInput")
    def origin_unresponsive_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIpInput")
    def origin_unresponsive_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindowInput")
    def origin_unresponsive_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocolInput")
    def origin_unresponsive_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevelInput")
    def origin_unresponsive_detection_level_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryStringInput")
    def origin_unresponsive_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPathInput")
    def origin_unresponsive_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPathInput")
    def origin_unresponsive_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocolInput")
    def origin_unresponsive_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecoveryInput")
    def origin_unresponsive_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethodInput")
    def origin_unresponsive_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnresponsiveRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimitInput")
    def origin_unresponsive_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="otherOptionsInput")
    def other_options_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "otherOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponse")
    def cache_error_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheErrorResponse"))

    @cache_error_response.setter
    def cache_error_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2517a80b0de02f1a22b0df5f98dcd50490261acd3ef84a4aaab1857c38d08dde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheErrorResponse", value)

    @builtins.property
    @jsii.member(jsii_name="cacheWindow")
    def cache_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheWindow"))

    @cache_window.setter
    def cache_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc662c53008e3d944a9e76e2d1a209945a190dfac59ce80733e7f974e054650e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheWindow", value)

    @builtins.property
    @jsii.member(jsii_name="clientResponseCode")
    def client_response_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientResponseCode"))

    @client_response_code.setter
    def client_response_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe8029f55e485aa1de882ecc3d7e259d3f0cfcf4c481e577b739f4b5cabc392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailable")
    def detect_object_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectObjectUnavailable"))

    @detect_object_unavailable.setter
    def detect_object_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd6eb435f8a160b4c3722f5eb0b507388cef15eb5423416bd1cb13c2f5cedc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitle")
    def detect_object_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectObjectUnavailableTitle"))

    @detect_object_unavailable_title.setter
    def detect_object_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfe785d8f1d40a72d0ec61a9ff57c0a6956dd8b261c51ebe10846e8ddd42d9ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailable")
    def detect_origin_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnavailable"))

    @detect_origin_unavailable.setter
    def detect_origin_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd0171e8502d78fa91c35f3b94f2a25e7d97303aef7382ff236cf5b21a4166d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitle")
    def detect_origin_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnavailableTitle"))

    @detect_origin_unavailable_title.setter
    def detect_origin_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__941acb9297d881f8edfea59086a146912c24912c15a30f68f03b80dce286caf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsive")
    def detect_origin_unresponsive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnresponsive"))

    @detect_origin_unresponsive.setter
    def detect_origin_unresponsive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f9d3bf689be7fc9d83d70606c955dc893ab7fc0cdab02912c87894ba4b9596c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsive", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitle")
    def detect_origin_unresponsive_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnresponsiveTitle"))

    @detect_origin_unresponsive_title.setter
    def detect_origin_unresponsive_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d7659788c30bc0572000597533f305b15619a520b66021eb13ce88d28ad079)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsiveTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec8551aec868a7ca5bcb017a402b9a73de10e5adf5420cf86892d05a8698339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHost")
    def object_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableAlternateHost"))

    @object_unavailable_alternate_host.setter
    def object_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ff371217412c4664df7693ca0ec8113675c364f3f231e7a2a3627c9ce7a7c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHost")
    def object_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBackupHost"))

    @object_unavailable_backup_host.setter
    def object_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78728ecf7427fe7d143dd6feff7900c2d8588f06b494a5cf45402a49d580359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIp")
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableBlacklistOriginIp"))

    @object_unavailable_blacklist_origin_ip.setter
    def object_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__298a54899783dd3bc07f538316815e491f6c84985131a60083e1f0d717f91b55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindow")
    def object_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBlacklistWindow"))

    @object_unavailable_blacklist_window.setter
    def object_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70b2a52e76194a97695a2dc84c7ea5b572091b815c41b5378dff0526ca746149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocol")
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableChangeProtocol"))

    @object_unavailable_change_protocol.setter
    def object_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c98d044e7ff11b098548423ae70ff41041281078cf8cb7db7a63ac0cd44fb1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevel")
    def object_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableDetectionLevel"))

    @object_unavailable_detection_level.setter
    def object_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bde42a605500f14487c40d60c0e2f47346faefbdcb4fcc36b0ea44f453c93d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryString")
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableIncludeQueryString"))

    @object_unavailable_include_query_string.setter
    def object_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57959af9b0bf58ce330064100f476101a7a9855812b6f9b0318ce257b89ee6e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPath")
    def object_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableModifiedPath"))

    @object_unavailable_modified_path.setter
    def object_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2a6156c4a319a232ac3d999a36078529994c279ea5d58fe454053d97520a0e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPath")
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableModifyRequestPath"))

    @object_unavailable_modify_request_path.setter
    def object_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c813357b9aafe5eb5d263e5f442d6d001adb82e717bab7a2f23ea42690b1ce9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocol")
    def object_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableProtocol"))

    @object_unavailable_protocol.setter
    def object_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bf3eea8348846350a86ffa6615ba0a6abf49a32544ad4dd4eb1d4243ce60e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecovery")
    def object_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRecovery"))

    @object_unavailable_recovery.setter
    def object_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c863def4b9333b22956f5d51b57570e9fff7b52ca8f23dab4ef407f6ad1a72bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethod")
    def object_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "objectUnavailableRedirectMethod"))

    @object_unavailable_redirect_method.setter
    def object_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ab9424636260774dd7d9300db3b394e9ea8072d37c13308d2fc113f83585eee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodes")
    def object_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "objectUnavailableResponseCodes"))

    @object_unavailable_response_codes.setter
    def object_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1acb31464711a36b0fbf1c207f3ff7c0d3e5893547adfcbd9d3a68d506cb23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimit")
    def object_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRetryLimit"))

    @object_unavailable_retry_limit.setter
    def object_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20ed8e3abf4b36a2a9170c33b22a6cd4bbb9c6467787d0458d13f9de6196e62e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHost")
    def origin_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableAlternateHost"))

    @origin_unavailable_alternate_host.setter
    def origin_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd33ff6463f56c2d5682bdf84ca392d196141d96d175341a963d19eda450a881)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHost")
    def origin_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBackupHost"))

    @origin_unavailable_backup_host.setter
    def origin_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84cb3ec4c244db5974c2a3f7a796906cc754ccd6a0aebaedfdfa0b2e6a3f98c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIp")
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableBlacklistOriginIp"))

    @origin_unavailable_blacklist_origin_ip.setter
    def origin_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8562c3446a3cffd6973eab830388bfbd82e124ed8d9e85ecae33a2e0aeee6c49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindow")
    def origin_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBlacklistWindow"))

    @origin_unavailable_blacklist_window.setter
    def origin_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785929bdef3f6e51b921796b6f45e417b05278f904f54560b4a9c755cb1fdf7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocol")
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableChangeProtocol"))

    @origin_unavailable_change_protocol.setter
    def origin_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81c99cf88bfeaa4d7ae4ac442b9a20499f0f37551fbcba2fe336efc11107ffcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevel")
    def origin_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableDetectionLevel"))

    @origin_unavailable_detection_level.setter
    def origin_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d472d756680a5dee6b1748e346a2b8032b3322d21f849dd86a1947e997b5b6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryString")
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableIncludeQueryString"))

    @origin_unavailable_include_query_string.setter
    def origin_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07770bac3f1c63165feac796a655e324271148333861c0fc28e351898d8bdcb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPath")
    def origin_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableModifiedPath"))

    @origin_unavailable_modified_path.setter
    def origin_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4206874196b1691fc8520c0ff5bf2067b1eff4cd330b7629843db751f0fe110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPath")
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableModifyRequestPath"))

    @origin_unavailable_modify_request_path.setter
    def origin_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a167b8b718869d2527417a3be01b87cfc79d44a24d07af9f706ad9aa3100c6c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocol")
    def origin_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableProtocol"))

    @origin_unavailable_protocol.setter
    def origin_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcc7c8303ecce8284abb4b36c3e048be961f5793fb21198db27893e20c1a01af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecovery")
    def origin_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRecovery"))

    @origin_unavailable_recovery.setter
    def origin_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e1c0c402c5b387ecaa532340938592530bd7698ad72e943a0016a90f80e2cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethod")
    def origin_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnavailableRedirectMethod"))

    @origin_unavailable_redirect_method.setter
    def origin_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4bafc87ee4fded34e254d7158b786341a18fdf4207f0060d29d24adeb6b07d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodes")
    def origin_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "originUnavailableResponseCodes"))

    @origin_unavailable_response_codes.setter
    def origin_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d313861137ce13ef592ed1bbc65b92d0fc5525215ec49739d944b1ba82f91297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimit")
    def origin_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRetryLimit"))

    @origin_unavailable_retry_limit.setter
    def origin_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8c59649cbdd2c21464c2548f18a64981378a2ecd57d0406ec24019b567c09e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHost")
    def origin_unresponsive_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveAlternateHost"))

    @origin_unresponsive_alternate_host.setter
    def origin_unresponsive_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43181138cb3a49644d5d9d7a71568dddd91e06a55945b0b17c7ff9fd9d5ad256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHost")
    def origin_unresponsive_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBackupHost"))

    @origin_unresponsive_backup_host.setter
    def origin_unresponsive_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a88041ca01478c93fd8e96ca73fcdf9f7dae8bf257d6f6b701f02e931df12905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIp")
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveBlacklistOriginIp"))

    @origin_unresponsive_blacklist_origin_ip.setter
    def origin_unresponsive_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43fffb189aba4b87742bc6da903fd61a7d9cd60148302ac7c0681febead41d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindow")
    def origin_unresponsive_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBlacklistWindow"))

    @origin_unresponsive_blacklist_window.setter
    def origin_unresponsive_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7ef2378a5da93a541e78e34f4e75297a974a8ff69d79de80672fe0ee390c2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocol")
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveChangeProtocol"))

    @origin_unresponsive_change_protocol.setter
    def origin_unresponsive_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e159be7b00dd612c9c0b31a7d3426c489828e96ca8aa69ac9a017f4bb71165)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevel")
    def origin_unresponsive_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveDetectionLevel"))

    @origin_unresponsive_detection_level.setter
    def origin_unresponsive_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b81ad213fcacd63419a03cbaa972f851ffe79105b358587e7e91a0b2acec120)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryString")
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveIncludeQueryString"))

    @origin_unresponsive_include_query_string.setter
    def origin_unresponsive_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5129d9cb125d4cd9b82db149637dd2ba7b5f10165ae0dbbe7ae946d8ec79d49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPath")
    def origin_unresponsive_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveModifiedPath"))

    @origin_unresponsive_modified_path.setter
    def origin_unresponsive_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d0748877d10807064dc4c2d7dc716fdbf2c2c6d40c5dd6105c898e76914974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPath")
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveModifyRequestPath"))

    @origin_unresponsive_modify_request_path.setter
    def origin_unresponsive_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64022d24ca72ca7ccb9902ae5621e13de8cfdcc878ae323932378f32299b0bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocol")
    def origin_unresponsive_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveProtocol"))

    @origin_unresponsive_protocol.setter
    def origin_unresponsive_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0742831e0b5378f3b053b0f0071aaa3a64cd3657f6150ce2061b7858fd397f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecovery")
    def origin_unresponsive_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRecovery"))

    @origin_unresponsive_recovery.setter
    def origin_unresponsive_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47c6860b4217e5ef0e852b287c4b88d69350c227292d1f1d5abae6fd6a699b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethod")
    def origin_unresponsive_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnresponsiveRedirectMethod"))

    @origin_unresponsive_redirect_method.setter
    def origin_unresponsive_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6166aa33cc1afa93acd7c99cdd2a58bef4c2236b75f9f70aac360741cc15edd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimit")
    def origin_unresponsive_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRetryLimit"))

    @origin_unresponsive_retry_limit.setter
    def origin_unresponsive_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545f151f0fa26846043c5f18557c3edcc1fe40b5f4d8614f3ef6d63ac21f0e18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="otherOptions")
    def other_options(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "otherOptions"))

    @other_options.setter
    def other_options(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6685cb0460f76c92229fafc49b6ad56dfebe483f29e15487a44287d713256bd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "otherOptions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0d52c2f3d88dc4cb68a1dd467cf16b394ed2f4c12d7e25445b149bc6d264da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__080207005b88749a416d6084b900d2f9850f372048f26a46d4a32bdfc31320f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__927fcda28696fb4c11358ce227a14858debaf80452e5b1baccdb48489d2661d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1d3f94a44919029f0e9c9cd44696e69bf41748b14503f8fa654ea4df09bab5)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables metadata caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__265c4f18c8a70ffd8db84c05784dd1f11ac4218336700008ab2982076c1a1e45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b01e07c05062f1d653747611b4ed68917ed490a425bc13ab8041df51d7c2341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516393845c65d413a68e2d392bc88d343f1c51a85fa6692ad300c9a35ea4427b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__175811ac37ca675508dfaf69abf32b59ad3e0e40178e99366f9ad72369b8d541)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1041a62e813f7f3baa9dfb28d12433fa51136baf910bafbd4c67bd2dc93d035d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__226304654cee7578bc270179fdf1c4b6cf6f0ab0c8718a79e731c4bdfddbdf7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "secondary_multipath_to_origin": "secondaryMultipathToOrigin",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d38f3ffe91fb9e57d1ce26aa8b4a4fb24ab85f33521612b2c9ee71e00b20214f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument secondary_multipath_to_origin", value=secondary_multipath_to_origin, expected_type=type_hints["secondary_multipath_to_origin"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if secondary_multipath_to_origin is not None:
            self._values["secondary_multipath_to_origin"] = secondary_multipath_to_origin
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Mobile App Performance SDK.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends secondary multi-path requests to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        '''
        result = self._values.get("secondary_multipath_to_origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34ceb9de2c1c10e03ded83f2f78a1fc03bd36870392d66731324c53806668c01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondaryMultipathToOrigin")
    def reset_secondary_multipath_to_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondaryMultipathToOrigin", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOriginInput")
    def secondary_multipath_to_origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondaryMultipathToOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376bbdc06e8eec220d022798abce48181b6ff4ac2b6e7b5c5e0e850d44f74f99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f3c9b358de27494c9119491088f2e4f87dde7bc5e8ae7b908d7d3761e16f237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOrigin")
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondaryMultipathToOrigin"))

    @secondary_multipath_to_origin.setter
    def secondary_multipath_to_origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea4fd7aeb2508b011673a70de237d9e146ba6f3fb8312d0b49312f0f24ca3cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondaryMultipathToOrigin", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb99e6acc1bbbd7d4f378ed0c824cc8207eb8b0fc53cc4ff2f53404206a72ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5833c26bba24642e123049bdac9c35e0bbb362d31a0b0d277e6ac504896a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20927e8ea181eeae347bfa2e92c40e91b0975ebbe81e390ddba3259f22cb4891)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7c6c4a4e1cea87c8a7d2181dd347baee54d6e0336cf167d9628f22b1246f9c)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Supplies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba732315f05f38f50539f9a12d377a0321cafbb67b61025d932e69dd70cfd1a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a20569b33a60c29cb2322a9a2064054855caa3f6f5b5e294c905ab99b28411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c315e693e2df9ed9f4055d70335b59f7ccf6048b1ac39d7417f9087478d6eee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53163cadfd69e2bbdc573231a3329ce9582a771e64004c9d3be4fa57cb6cf99a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e5df798987babd3bcd8b7ba1a02fd1ecb31c2ce700706cc1f49053ac44a9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a746c1622c2d8c6990f687b984f3d76f4bf55f5b9c523b35cff40078bc9774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afc2d5952ca9245261dec47025810aacc41dc6b926a674f3aa655a7a27231402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a818a5e2bf8bdfa56918852e1b2cb590569adb8e36c89328e94bff9a883933e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813b616b37b25ea7f67cc5c3cdfa15f360aefa2f9924c72d86a06342f9e3833f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5964213cf6d00406591d50632980a8b3ef90ff39108993aaecbd959cbc65da03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d3c160631af20f504bc67afb548a9b641b32abac0e4ab8c4f108b7062f26e9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0114a9c78e973be328c636ca8264d32222b2dde66c665a33ab42302253292bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d8c3a27b381b6c383b374389e7d79703c2a24e8240ba0a1aaa322aaa29cc00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70afe285798d012788221c52ebb7e94f1dc5abac23219fc22e4a569248a22f19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5586a2303862547431f4ece2815bc0e43b5508828187c450b9c778404a99468)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the header's new value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64421f6d5b2480676b8e3d879666f3d2eb2cd22cfaea6a248d040673a51acd89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9976bb81e076727767ead3ff6cc23290cbef68b5d0e65906425182a3ba72c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e373f9f8df1314c894d89bd3f98508ec15e83d2c43c2bc486146f1b6b03dfe8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b099405fea982875bde7c2dcde647b691cb3c446b9034af3470fa494ff68f2da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdd85d8c61291f389d75bdaec8df37071e15a3eb1f39204b8c517034ef5dd2b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94cca1947735b24f616f6b64af7f539f9d383d2bc9314d34743e5e4b61cd7818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__358b7de1f8915537fc10a368ab68493d2e737bc8791a32be9c91f7cb9b0954dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__255c8d50bd65e202dc95194bddfc4bfd87c49c356d403fec8b067e417701cea7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5fc015b65022294914035bd7246c4fa71d4d043e4cb9fb8de3d2467160a48ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d3c2ce60ea378193fbc41c7b622b2ea027a71ce7af618e21eb451281b0ef2c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c4d5909a1aaf570442033d065ae9f9f4840c68b89ab4e91490d74e1c20297f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae8132cd81dbf2bcf581afb8326415bdb3cf3b3547eaf64dd0108022b024ea1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b77b781b1185cc8cc2e407d622afb22773ac881dabc49923480d88280a61765)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b5fdeb2fa34bd5f6dedf125ef61183399ef222562aa7da3df3e01c98002e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd447222f7bcc5abc114d2445669e377c93fed3cc684fcbb3e5577f4f9bf89c)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e686ba6e6fea80b7de19766d90314aeed451e9077efb424d115599216ae7f34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2137b858bc6cfe79d8a6ff1185cf29d9ebc49bec78e8ca3f5248825a19e85b2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d6859724592df85977800dfdec1becb8b9aa55b509b4f2c9da369ae2c8c4cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9f061a61a69b9f741c4260c08f9ea8ecc7b3e419bd7f5b0014062398a3e2b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d6662c4bb4ad47a0fab03629be08b22a45a720fa1bd045c7b4688ba28de5656)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1510111a4030599eea769c2fcd438901f8424bf9c9f8111f5b7311d99efba152)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__858d3899368ec9f46c5892078f2c4f8996937474f66077aca6a4240b64a0669a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfa0e150295c9dcee8f2b9faaad1275555fd07971e687bde82ef88aef16086f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c427d3e2feacdff3d585382693542b369e782127e5c2b5d8b9cd54f38cfe634)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c731a291db3e5629699fd87a6767f93b13df98de0a12e46784dd407f0e6f62d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a3f7b1c2722f9f0a3ccc6229f446bbddb769791f34b5f9dfa2dd94a69b1c999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de75c693dcc99ebc7d37d484972437fa4e515b4e671c6677c0c65de0990922e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b7d22df20b9d8cf78f6d8e4cdc266db27ec864512bacd418a65d2f80ce284c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbaaea4fe76759e1395eb033b686e8d274827aee38e9b0c5bbc350e3b8c04802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33fc638bddbaa29abdb1604a57b6ccde695f740258e65b8d7b797ab5498721d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca5058dd9c5e90ce93e69a2243e9e534201933d3011152e1b76d9b22d226a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2203f4131d818c027cd6a6d09c25f65777e3c1eb32bd8006d5370ca1296c058)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the existing value of the header to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa511c8f34f10baca1a6e3510c7dfc1b654c35ba980bb4228a10a8f1802170a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81603c42a5a747ecef35febc39bf9e79e0de6e4bc67ed9e39d33441df0058259)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b4bae1f68c480f381fbefaaadb5ad3d4398ec668541d207c34f917b85a8b594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f11a1411c8c61483144698bfbdd2a75ed4eb914624ea54faaae75c48f11faba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a639b0235feb21ccb1fa488a6a862649df926953ff5df9b2c81a1a0a4f85ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc9e407f7bfe7fdaceb3254207b2fe105ca7825a740b1290b8a8ab277c14df68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46fc0f84e8356c58436a09d232080d2ec352cce69aa2d8568be75dd96ef82ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512f7538f24e2b8d064bf55197fb00fab810d9a3fe226ecc76fa8b41b6743bce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de14b6cb730802fd3baa73182b1b0e02bee1d4db749ec444cc12c36f7712327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb375ff2d84fc3a9d5e94792e6f0951e898f27a66a3c1373fb3b544e9da8970d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45db17ccfe2dde18aa5be63025d9e0216c88dd4ae922c2383065474159519131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90b8975a631fdf3075d9675f2b54eb5e85d2851a37bb1121be55f2227e7cbb24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c18528bbf3d13c379afc7387b75af592555649cfe01e19e0056a47eebd72509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a44820d65b1b8ff13affdc067c6354428790fc2a601949526a2a064778226f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4a86056d5a6aa7b656e20cfe607cc167fda4fb127322bb3ddc87849ae28a066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__650f1c2cbf401f7a21bc2565e6ccda77c360b06c096e3ef4dcf4c153423d3cdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "modification_option": "modificationOption",
        "rename_header_to": "renameHeaderTo",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23bba040a5eae712244e4ab509f1653bb614f57853f621e96c34645e728d4806)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modification_option", value=modification_option, expected_type=type_hints["modification_option"])
            check_type(argname="argument rename_header_to", value=rename_header_to, expected_type=type_hints["rename_header_to"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modification_option is not None:
            self._values["modification_option"] = modification_option
        if rename_header_to is not None:
            self._values["rename_header_to"] = rename_header_to
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``Via`` header modifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modification_option(self) -> typing.Optional[builtins.str]:
        '''Specify how you want to handle the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        '''
        result = self._values.get("modification_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rename_header_to(self) -> typing.Optional[builtins.str]:
        '''Specifies a new name to replace the existing ``Via`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        '''
        result = self._values.get("rename_header_to")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a3a1e7175e11dffedc631d1bf491032b903b97ea66ea2612d2667f204bcd833)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModificationOption")
    def reset_modification_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModificationOption", []))

    @jsii.member(jsii_name="resetRenameHeaderTo")
    def reset_rename_header_to(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRenameHeaderTo", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modificationOptionInput")
    def modification_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "modificationOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="renameHeaderToInput")
    def rename_header_to_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "renameHeaderToInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4c371d2c53d9ba60e380d9440e52509fb413faaffaad88dd6e90bcff8d5a12b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b90c9d5b2ce72ee6eb5b6ed622d7c1fb1ac8bad4cf93d6333dd308283af3b394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modificationOption")
    def modification_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "modificationOption"))

    @modification_option.setter
    def modification_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d31ae7484592d4c5382ef9bd09addfad0e1e6a51dc9c88e596d9e891d8437ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modificationOption", value)

    @builtins.property
    @jsii.member(jsii_name="renameHeaderTo")
    def rename_header_to(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "renameHeaderTo"))

    @rename_header_to.setter
    def rename_header_to(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0804c56fefa7803231c48150ac96adf2c84f3834544f575d558ccb453677f6f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "renameHeaderTo", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc1e2a8e1b9176c7d491f27786cc67c5c749265905570b2601d4dc48b5e1b693)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffc3e024e1329650ce3c74b0290e5b00e230e20eaa70c2c4c4e3e27a36873076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8025b019b33795739826807b030ce7504837eecb946d16ffc6273bac48df1843)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cache_key_hostname": "cacheKeyHostname",
        "compress": "compress",
        "custom_certificate_authorities": "customCertificateAuthorities",
        "custom_certificates": "customCertificates",
        "custom_forward_host_header": "customForwardHostHeader",
        "custom_valid_cn_values": "customValidCnValues",
        "enable_true_client_ip": "enableTrueClientIp",
        "forward_host_header": "forwardHostHeader",
        "hostname": "hostname",
        "http_port": "httpPort",
        "https_port": "httpsPort",
        "ip_version": "ipVersion",
        "locked": "locked",
        "max_tls_version": "maxTlsVersion",
        "min_tls_version": "minTlsVersion",
        "mslorigin": "mslorigin",
        "net_storage": "netStorage",
        "origin_certificate": "originCertificate",
        "origin_certs_to_honor": "originCertsToHonor",
        "origin_id": "originId",
        "origin_sni": "originSni",
        "origin_type": "originType",
        "ports": "ports",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "second_hostname": "secondHostname",
        "second_hostname_enabled": "secondHostnameEnabled",
        "standard_certificate_authorities": "standardCertificateAuthorities",
        "template_uuid": "templateUuid",
        "tls13_support": "tls13Support",
        "tls_version_title": "tlsVersionTitle",
        "true_client_ip_client_setting": "trueClientIpClientSetting",
        "true_client_ip_header": "trueClientIpHeader",
        "use_unique_cache_key": "useUniqueCacheKey",
        "uuid": "uuid",
        "verification_mode": "verificationMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin:
    def __init__(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_tls_version: typing.Optional[builtins.str] = None,
        min_tls_version: typing.Optional[builtins.str] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tls_version_title: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_tls_version: Specifies the maximum TLS version to use for connections to your origin server. As best practice, use ``DYNAMIC`` to automatically apply the latest supported version. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        :param min_tls_version: Specifies the minimum TLS version to use for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tls13_support: Enables transport layer security (TLS) version 1.3 for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        :param tls_version_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf5ae4c439391e6b0b5cd3ac1edb43bf465598d66a9920e76f31441c04e94e9)
            check_type(argname="argument cache_key_hostname", value=cache_key_hostname, expected_type=type_hints["cache_key_hostname"])
            check_type(argname="argument compress", value=compress, expected_type=type_hints["compress"])
            check_type(argname="argument custom_certificate_authorities", value=custom_certificate_authorities, expected_type=type_hints["custom_certificate_authorities"])
            check_type(argname="argument custom_certificates", value=custom_certificates, expected_type=type_hints["custom_certificates"])
            check_type(argname="argument custom_forward_host_header", value=custom_forward_host_header, expected_type=type_hints["custom_forward_host_header"])
            check_type(argname="argument custom_valid_cn_values", value=custom_valid_cn_values, expected_type=type_hints["custom_valid_cn_values"])
            check_type(argname="argument enable_true_client_ip", value=enable_true_client_ip, expected_type=type_hints["enable_true_client_ip"])
            check_type(argname="argument forward_host_header", value=forward_host_header, expected_type=type_hints["forward_host_header"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument http_port", value=http_port, expected_type=type_hints["http_port"])
            check_type(argname="argument https_port", value=https_port, expected_type=type_hints["https_port"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_tls_version", value=max_tls_version, expected_type=type_hints["max_tls_version"])
            check_type(argname="argument min_tls_version", value=min_tls_version, expected_type=type_hints["min_tls_version"])
            check_type(argname="argument mslorigin", value=mslorigin, expected_type=type_hints["mslorigin"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument origin_certificate", value=origin_certificate, expected_type=type_hints["origin_certificate"])
            check_type(argname="argument origin_certs_to_honor", value=origin_certs_to_honor, expected_type=type_hints["origin_certs_to_honor"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument origin_sni", value=origin_sni, expected_type=type_hints["origin_sni"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument ports", value=ports, expected_type=type_hints["ports"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument second_hostname", value=second_hostname, expected_type=type_hints["second_hostname"])
            check_type(argname="argument second_hostname_enabled", value=second_hostname_enabled, expected_type=type_hints["second_hostname_enabled"])
            check_type(argname="argument standard_certificate_authorities", value=standard_certificate_authorities, expected_type=type_hints["standard_certificate_authorities"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tls13_support", value=tls13_support, expected_type=type_hints["tls13_support"])
            check_type(argname="argument tls_version_title", value=tls_version_title, expected_type=type_hints["tls_version_title"])
            check_type(argname="argument true_client_ip_client_setting", value=true_client_ip_client_setting, expected_type=type_hints["true_client_ip_client_setting"])
            check_type(argname="argument true_client_ip_header", value=true_client_ip_header, expected_type=type_hints["true_client_ip_header"])
            check_type(argname="argument use_unique_cache_key", value=use_unique_cache_key, expected_type=type_hints["use_unique_cache_key"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_mode", value=verification_mode, expected_type=type_hints["verification_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_key_hostname is not None:
            self._values["cache_key_hostname"] = cache_key_hostname
        if compress is not None:
            self._values["compress"] = compress
        if custom_certificate_authorities is not None:
            self._values["custom_certificate_authorities"] = custom_certificate_authorities
        if custom_certificates is not None:
            self._values["custom_certificates"] = custom_certificates
        if custom_forward_host_header is not None:
            self._values["custom_forward_host_header"] = custom_forward_host_header
        if custom_valid_cn_values is not None:
            self._values["custom_valid_cn_values"] = custom_valid_cn_values
        if enable_true_client_ip is not None:
            self._values["enable_true_client_ip"] = enable_true_client_ip
        if forward_host_header is not None:
            self._values["forward_host_header"] = forward_host_header
        if hostname is not None:
            self._values["hostname"] = hostname
        if http_port is not None:
            self._values["http_port"] = http_port
        if https_port is not None:
            self._values["https_port"] = https_port
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if locked is not None:
            self._values["locked"] = locked
        if max_tls_version is not None:
            self._values["max_tls_version"] = max_tls_version
        if min_tls_version is not None:
            self._values["min_tls_version"] = min_tls_version
        if mslorigin is not None:
            self._values["mslorigin"] = mslorigin
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if origin_certificate is not None:
            self._values["origin_certificate"] = origin_certificate
        if origin_certs_to_honor is not None:
            self._values["origin_certs_to_honor"] = origin_certs_to_honor
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if origin_sni is not None:
            self._values["origin_sni"] = origin_sni
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if ports is not None:
            self._values["ports"] = ports
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if second_hostname is not None:
            self._values["second_hostname"] = second_hostname
        if second_hostname_enabled is not None:
            self._values["second_hostname_enabled"] = second_hostname_enabled
        if standard_certificate_authorities is not None:
            self._values["standard_certificate_authorities"] = standard_certificate_authorities
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tls13_support is not None:
            self._values["tls13_support"] = tls13_support
        if tls_version_title is not None:
            self._values["tls_version_title"] = tls_version_title
        if true_client_ip_client_setting is not None:
            self._values["true_client_ip_client_setting"] = true_client_ip_client_setting
        if true_client_ip_header is not None:
            self._values["true_client_ip_header"] = true_client_ip_header
        if use_unique_cache_key is not None:
            self._values["use_unique_cache_key"] = use_unique_cache_key
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_mode is not None:
            self._values["verification_mode"] = verification_mode

    @builtins.property
    def cache_key_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to use when forming a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        '''
        result = self._values.get("cache_key_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compress(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``gzip`` compression for non-NetStorage origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        '''
        result = self._values.get("compress")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_certificate_authorities(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities"]]]:
        '''custom_certificate_authorities block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        '''
        result = self._values.get("custom_certificate_authorities")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities"]]], result)

    @builtins.property
    def custom_certificates(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates"]]]:
        '''custom_certificates block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        '''
        result = self._values.get("custom_certificates")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates"]]], result)

    @builtins.property
    def custom_forward_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the custom host header the edge server should pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        '''
        result = self._values.get("custom_forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_valid_cn_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields.

        Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        '''
        result = self._values.get("custom_valid_cn_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_true_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server.

        This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        '''
        result = self._values.get("enable_true_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_host_header(self) -> typing.Optional[builtins.str]:
        '''When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        '''
        result = self._values.get("forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        '''
        result = self._values.get("http_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def https_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``.

        This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        '''
        result = self._values.get("https_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP version to use when getting content from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_tls_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum TLS version to use for connections to your origin server.

        As best practice, use ``DYNAMIC`` to automatically apply the latest supported version.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        '''
        result = self._values.get("max_tls_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_tls_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the minimum TLS version to use for connections to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        '''
        result = self._values.get("min_tls_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslorigin(self) -> typing.Optional[builtins.str]:
        '''This specifies the media's origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        '''
        result = self._values.get("mslorigin")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage"], result)

    @builtins.property
    def origin_certificate(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        '''
        result = self._values.get("origin_certificate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_certs_to_honor(self) -> typing.Optional[builtins.str]:
        '''Specifies which certificate to trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        '''
        result = self._values.get("origin_certs_to_honor")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the Edge Load Balancing origin.

        This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_sni(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value.

        See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        '''
        result = self._values.get("origin_sni")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Choose where your content is retrieved from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ports(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        '''
        result = self._values.get("ports")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies replacement text for what ``saasRegex`` matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static part of the SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of the request that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        '''
        result = self._values.get("second_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Available only for certain products. This specifies whether you want to use an additional origin server address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        '''
        result = self._values.get("second_hostname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def standard_certificate_authorities(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.'''
        result = self._values.get("standard_certificate_authorities")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tls13_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables transport layer security (TLS) version 1.3 for connections to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        '''
        result = self._values.get("tls13_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tls_version_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        '''
        result = self._values.get("tls_version_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def true_client_ip_client_setting(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin.

        Otherwise the edge server removes it and sets the value itself.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        '''
        result = self._values.get("true_client_ip_client_setting")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def true_client_ip_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        '''
        result = self._values.get("true_client_ip_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_unique_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        '''
        result = self._values.get("use_unique_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_mode(self) -> typing.Optional[builtins.str]:
        '''For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        result = self._values.get("verification_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "access_key_encrypted_storage": "accessKeyEncryptedStorage",
        "adc_title": "adcTitle",
        "authentication_method": "authenticationMethod",
        "authentication_method_title": "authenticationMethodTitle",
        "aws_access_key_id": "awsAccessKeyId",
        "aws_access_key_version_guid": "awsAccessKeyVersionGuid",
        "aws_ar_region": "awsArRegion",
        "aws_host": "awsHost",
        "aws_region": "awsRegion",
        "aws_secret_access_key": "awsSecretAccessKey",
        "aws_service": "awsService",
        "country": "country",
        "custom_sign_string": "customSignString",
        "direct_connect_geo": "directConnectGeo",
        "encoding_version": "encodingVersion",
        "end_point_service": "endPointService",
        "gcs_access_key_version_guid": "gcsAccessKeyVersionGuid",
        "gcs_hmac_key_access_id": "gcsHmacKeyAccessId",
        "gcs_hmac_key_secret": "gcsHmacKeySecret",
        "hostname_tag": "hostnameTag",
        "locked": "locked",
        "mslkey": "mslkey",
        "mslname": "mslname",
        "nonce": "nonce",
        "origin_location_title": "originLocationTitle",
        "property_id_tag": "propertyIdTag",
        "role_arn": "roleArn",
        "secret_key": "secretKey",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics:
    def __init__(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3ca5c5a51fd2e8c36988532ff5c083ce6be625655a918983d4c31980af8e38)
            check_type(argname="argument access_key_encrypted_storage", value=access_key_encrypted_storage, expected_type=type_hints["access_key_encrypted_storage"])
            check_type(argname="argument adc_title", value=adc_title, expected_type=type_hints["adc_title"])
            check_type(argname="argument authentication_method", value=authentication_method, expected_type=type_hints["authentication_method"])
            check_type(argname="argument authentication_method_title", value=authentication_method_title, expected_type=type_hints["authentication_method_title"])
            check_type(argname="argument aws_access_key_id", value=aws_access_key_id, expected_type=type_hints["aws_access_key_id"])
            check_type(argname="argument aws_access_key_version_guid", value=aws_access_key_version_guid, expected_type=type_hints["aws_access_key_version_guid"])
            check_type(argname="argument aws_ar_region", value=aws_ar_region, expected_type=type_hints["aws_ar_region"])
            check_type(argname="argument aws_host", value=aws_host, expected_type=type_hints["aws_host"])
            check_type(argname="argument aws_region", value=aws_region, expected_type=type_hints["aws_region"])
            check_type(argname="argument aws_secret_access_key", value=aws_secret_access_key, expected_type=type_hints["aws_secret_access_key"])
            check_type(argname="argument aws_service", value=aws_service, expected_type=type_hints["aws_service"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument direct_connect_geo", value=direct_connect_geo, expected_type=type_hints["direct_connect_geo"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument end_point_service", value=end_point_service, expected_type=type_hints["end_point_service"])
            check_type(argname="argument gcs_access_key_version_guid", value=gcs_access_key_version_guid, expected_type=type_hints["gcs_access_key_version_guid"])
            check_type(argname="argument gcs_hmac_key_access_id", value=gcs_hmac_key_access_id, expected_type=type_hints["gcs_hmac_key_access_id"])
            check_type(argname="argument gcs_hmac_key_secret", value=gcs_hmac_key_secret, expected_type=type_hints["gcs_hmac_key_secret"])
            check_type(argname="argument hostname_tag", value=hostname_tag, expected_type=type_hints["hostname_tag"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mslkey", value=mslkey, expected_type=type_hints["mslkey"])
            check_type(argname="argument mslname", value=mslname, expected_type=type_hints["mslname"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument origin_location_title", value=origin_location_title, expected_type=type_hints["origin_location_title"])
            check_type(argname="argument property_id_tag", value=property_id_tag, expected_type=type_hints["property_id_tag"])
            check_type(argname="argument role_arn", value=role_arn, expected_type=type_hints["role_arn"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_key_encrypted_storage is not None:
            self._values["access_key_encrypted_storage"] = access_key_encrypted_storage
        if adc_title is not None:
            self._values["adc_title"] = adc_title
        if authentication_method is not None:
            self._values["authentication_method"] = authentication_method
        if authentication_method_title is not None:
            self._values["authentication_method_title"] = authentication_method_title
        if aws_access_key_id is not None:
            self._values["aws_access_key_id"] = aws_access_key_id
        if aws_access_key_version_guid is not None:
            self._values["aws_access_key_version_guid"] = aws_access_key_version_guid
        if aws_ar_region is not None:
            self._values["aws_ar_region"] = aws_ar_region
        if aws_host is not None:
            self._values["aws_host"] = aws_host
        if aws_region is not None:
            self._values["aws_region"] = aws_region
        if aws_secret_access_key is not None:
            self._values["aws_secret_access_key"] = aws_secret_access_key
        if aws_service is not None:
            self._values["aws_service"] = aws_service
        if country is not None:
            self._values["country"] = country
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if direct_connect_geo is not None:
            self._values["direct_connect_geo"] = direct_connect_geo
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if end_point_service is not None:
            self._values["end_point_service"] = end_point_service
        if gcs_access_key_version_guid is not None:
            self._values["gcs_access_key_version_guid"] = gcs_access_key_version_guid
        if gcs_hmac_key_access_id is not None:
            self._values["gcs_hmac_key_access_id"] = gcs_hmac_key_access_id
        if gcs_hmac_key_secret is not None:
            self._values["gcs_hmac_key_secret"] = gcs_hmac_key_secret
        if hostname_tag is not None:
            self._values["hostname_tag"] = hostname_tag
        if locked is not None:
            self._values["locked"] = locked
        if mslkey is not None:
            self._values["mslkey"] = mslkey
        if mslname is not None:
            self._values["mslname"] = mslname
        if nonce is not None:
            self._values["nonce"] = nonce
        if origin_location_title is not None:
            self._values["origin_location_title"] = origin_location_title
        if property_id_tag is not None:
            self._values["property_id_tag"] = property_id_tag
        if role_arn is not None:
            self._values["role_arn"] = role_arn
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def access_key_encrypted_storage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables secure use of access keys defined in Cloud Access Manager.

        Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        '''
        result = self._values.get("access_key_encrypted_storage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def adc_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        '''
        result = self._values.get("adc_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the authentication method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        '''
        result = self._values.get("authentication_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        '''
        result = self._values.get("authentication_method_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_id(self) -> typing.Optional[builtins.str]:
        '''Specifies active access key ID linked to your AWS account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        '''
        result = self._values.get("aws_access_key_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        '''
        result = self._values.get("aws_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_ar_region(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.'''
        result = self._values.get("aws_ar_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes.

        If you leave this option empty, it inherits the hostname from the ``origin`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        '''
        result = self._values.get("aws_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_region(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS region code of the location where your bucket resides.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        '''
        result = self._values.get("aws_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_secret_access_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        '''
        result = self._values.get("aws_secret_access_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_service(self) -> typing.Optional[builtins.str]:
        '''This specifies the subdomain of your AWS service.

        It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        '''
        result = self._values.get("aws_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data to be encrypted as a series of enumerated variable names.

        See ``Built-in system variables`` for guidance on each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def direct_connect_geo(self) -> typing.Optional[builtins.str]:
        '''Provides a region used by Akamai Direct Connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        '''
        result = self._values.get("direct_connect_geo")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def end_point_service(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.'''
        result = self._values.get("end_point_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        '''
        result = self._values.get("gcs_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_access_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the active access ID linked to your Google account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        '''
        result = self._values.get("gcs_hmac_key_access_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_secret(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        '''
        result = self._values.get("gcs_hmac_key_secret")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.'''
        result = self._values.get("hostname_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mslkey(self) -> typing.Optional[builtins.str]:
        '''Specifies the access key provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        '''
        result = self._values.get("mslkey")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin name provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        '''
        result = self._values.get("mslname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the nonce.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_location_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        '''
        result = self._values.get("origin_location_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def property_id_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.'''
        result = self._values.get("property_id_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def role_arn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.'''
        result = self._values.get("role_arn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to customize your signed string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6427248fe7f71165c6db4b323102411b7faf058bea426b3ab60d6616a8914a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessKeyEncryptedStorage")
    def reset_access_key_encrypted_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessKeyEncryptedStorage", []))

    @jsii.member(jsii_name="resetAdcTitle")
    def reset_adc_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdcTitle", []))

    @jsii.member(jsii_name="resetAuthenticationMethod")
    def reset_authentication_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethod", []))

    @jsii.member(jsii_name="resetAuthenticationMethodTitle")
    def reset_authentication_method_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethodTitle", []))

    @jsii.member(jsii_name="resetAwsAccessKeyId")
    def reset_aws_access_key_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyId", []))

    @jsii.member(jsii_name="resetAwsAccessKeyVersionGuid")
    def reset_aws_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetAwsArRegion")
    def reset_aws_ar_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsArRegion", []))

    @jsii.member(jsii_name="resetAwsHost")
    def reset_aws_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsHost", []))

    @jsii.member(jsii_name="resetAwsRegion")
    def reset_aws_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsRegion", []))

    @jsii.member(jsii_name="resetAwsSecretAccessKey")
    def reset_aws_secret_access_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsSecretAccessKey", []))

    @jsii.member(jsii_name="resetAwsService")
    def reset_aws_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsService", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDirectConnectGeo")
    def reset_direct_connect_geo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDirectConnectGeo", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetEndPointService")
    def reset_end_point_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndPointService", []))

    @jsii.member(jsii_name="resetGcsAccessKeyVersionGuid")
    def reset_gcs_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetGcsHmacKeyAccessId")
    def reset_gcs_hmac_key_access_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeyAccessId", []))

    @jsii.member(jsii_name="resetGcsHmacKeySecret")
    def reset_gcs_hmac_key_secret(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeySecret", []))

    @jsii.member(jsii_name="resetHostnameTag")
    def reset_hostname_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameTag", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMslkey")
    def reset_mslkey(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslkey", []))

    @jsii.member(jsii_name="resetMslname")
    def reset_mslname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslname", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetOriginLocationTitle")
    def reset_origin_location_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginLocationTitle", []))

    @jsii.member(jsii_name="resetPropertyIdTag")
    def reset_property_id_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPropertyIdTag", []))

    @jsii.member(jsii_name="resetRoleArn")
    def reset_role_arn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRoleArn", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorageInput")
    def access_key_encrypted_storage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessKeyEncryptedStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="adcTitleInput")
    def adc_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "adcTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodInput")
    def authentication_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitleInput")
    def authentication_method_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyIdInput")
    def aws_access_key_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyIdInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuidInput")
    def aws_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="awsArRegionInput")
    def aws_ar_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsArRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsHostInput")
    def aws_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsHostInput"))

    @builtins.property
    @jsii.member(jsii_name="awsRegionInput")
    def aws_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKeyInput")
    def aws_secret_access_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsSecretAccessKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="awsServiceInput")
    def aws_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="directConnectGeoInput")
    def direct_connect_geo_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "directConnectGeoInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="endPointServiceInput")
    def end_point_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endPointServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuidInput")
    def gcs_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessIdInput")
    def gcs_hmac_key_access_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeyAccessIdInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecretInput")
    def gcs_hmac_key_secret_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeySecretInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameTagInput")
    def hostname_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hostnameTagInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mslkeyInput")
    def mslkey_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslkeyInput"))

    @builtins.property
    @jsii.member(jsii_name="mslnameInput")
    def mslname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslnameInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="originLocationTitleInput")
    def origin_location_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originLocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="propertyIdTagInput")
    def property_id_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "propertyIdTagInput"))

    @builtins.property
    @jsii.member(jsii_name="roleArnInput")
    def role_arn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "roleArnInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorage")
    def access_key_encrypted_storage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessKeyEncryptedStorage"))

    @access_key_encrypted_storage.setter
    def access_key_encrypted_storage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8df62630089a528f8d6ba30b3f1cf4df4975fa658f95d981d9dfe0bc20426dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessKeyEncryptedStorage", value)

    @builtins.property
    @jsii.member(jsii_name="adcTitle")
    def adc_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "adcTitle"))

    @adc_title.setter
    def adc_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129f43916f0c442d843cedbdb92944f09c83c631d1779f1cfd1f60531d3ff63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "adcTitle", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethod")
    def authentication_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethod"))

    @authentication_method.setter
    def authentication_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b953e96b81f65c33785b9b956f03fff968d998a5401c75bea968e3a712ebc89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethod", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitle")
    def authentication_method_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethodTitle"))

    @authentication_method_title.setter
    def authentication_method_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e81ceb7c863317fb94fa674b77671e1d7e2d4fef8fcec477a4551eea8d48b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethodTitle", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyId")
    def aws_access_key_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyId"))

    @aws_access_key_id.setter
    def aws_access_key_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4666734bba271c0d8031a04ab2ab1c4d0351c6f24eb344fc8d69d83fbb2daf29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyId", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuid")
    def aws_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyVersionGuid"))

    @aws_access_key_version_guid.setter
    def aws_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__140273347ecd6c3b4b4960905041054d697cbed6059f28bd6da4b9090e9862ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="awsArRegion")
    def aws_ar_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsArRegion"))

    @aws_ar_region.setter
    def aws_ar_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20b8662478f6e3e3b9297c62d7c465afd665a109273c35aa81ded655982723db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsArRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsHost")
    def aws_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsHost"))

    @aws_host.setter
    def aws_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a41d6a641aa5a0dd5bc03841c2cf77089b12c230e1ba1569c24587621eb8dd64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsHost", value)

    @builtins.property
    @jsii.member(jsii_name="awsRegion")
    def aws_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsRegion"))

    @aws_region.setter
    def aws_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32444c796822dfa455d47fb9f04944a65fb30873f6891cedc394992f43563b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKey")
    def aws_secret_access_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsSecretAccessKey"))

    @aws_secret_access_key.setter
    def aws_secret_access_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973ce47aa563eb8e571ea445f819f0b3b4545ed8f86bee1dc75277c6104fac72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsSecretAccessKey", value)

    @builtins.property
    @jsii.member(jsii_name="awsService")
    def aws_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsService"))

    @aws_service.setter
    def aws_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1714e1929569a955641995d83e7529da9b3602f62188011ee7da82b1b82a3a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsService", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20c31db82b4609992ea59ecc9d22b9774e170cf496c93f4b096d42a30c09eb47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__579e9af71bb1454ed56739380efe9c5c3044034bfe0563aca02bd015edf9116d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="directConnectGeo")
    def direct_connect_geo(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "directConnectGeo"))

    @direct_connect_geo.setter
    def direct_connect_geo(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4f0a0ea5a564586bf41fcc0d02a7e678059565a0acc7b2ec9ea35c0adb6613f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "directConnectGeo", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__104562f36ceddbbf9823b563f434a2cf2c1399acbcca5b9b7b71d504d03630f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="endPointService")
    def end_point_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endPointService"))

    @end_point_service.setter
    def end_point_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3136fe67229d3701f7f30cac75eece0f1607261f248104bcb50f4874c0d373ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endPointService", value)

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuid")
    def gcs_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsAccessKeyVersionGuid"))

    @gcs_access_key_version_guid.setter
    def gcs_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ef7df8b2e958d2cad5bca7ab2c2ba7fcb105a67bf8f8ccfb0afe811219d650a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessId")
    def gcs_hmac_key_access_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeyAccessId"))

    @gcs_hmac_key_access_id.setter
    def gcs_hmac_key_access_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4393ffaede0ac46459ed25378da0b37557e96d4d12854f931f42a8cfb252d2a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeyAccessId", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecret")
    def gcs_hmac_key_secret(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeySecret"))

    @gcs_hmac_key_secret.setter
    def gcs_hmac_key_secret(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346a1ffe4a5f10dca7071f2cd9976904b2c60b440ba0f7bde32ecf7be66964c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeySecret", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameTag")
    def hostname_tag(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hostnameTag"))

    @hostname_tag.setter
    def hostname_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76fb036a182938d7b7a12d990cfe4f4854557f42d673052666f51c0c3e952c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameTag", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b14a03bc38cd15038958548550631faf4a00524abab237c77d2c7bfa5353355e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mslkey")
    def mslkey(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslkey"))

    @mslkey.setter
    def mslkey(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c202138e578755a3dc727094725a5435a043da96d8edc0f7f021fc74a499a11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslkey", value)

    @builtins.property
    @jsii.member(jsii_name="mslname")
    def mslname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslname"))

    @mslname.setter
    def mslname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0e6567f23649c49fff7065cb924d0f3fb2478d0f0d060eba8b1e71a1fad7d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslname", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7504a7d74a4137e1303e73b3452d80966d027773ac22b863979ba77c97264bb7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="originLocationTitle")
    def origin_location_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originLocationTitle"))

    @origin_location_title.setter
    def origin_location_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c22487183c33d3eab3f8bf0f8b9525e6cd51d745f4ed18bd1d70c77456c75448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originLocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="propertyIdTag")
    def property_id_tag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "propertyIdTag"))

    @property_id_tag.setter
    def property_id_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c70a26c89c64b21057abe1b3c95e71f827e44abef1113a1427a9c20e5b2e31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "propertyIdTag", value)

    @builtins.property
    @jsii.member(jsii_name="roleArn")
    def role_arn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "roleArn"))

    @role_arn.setter
    def role_arn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d026c95c82c242c132ca35fa0c91e412906846d5345dcb69ee5c3b13adb776d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "roleArn", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__717c3240a9165ad7205d14850708426c25aeb4bf61253ca7489fb74d9667338c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fec921e5135386eed7f39b45570b7adf2af118cc0bf8cb64b139b66fb510420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c00ccd88704112305b19580acaf00f1f099c3e0831e9b9980f106fa49e15a346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9121b9ab5a19643d251ed4edcee6c40b4c076403e621532eafbc2c7689d2dee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__528ec21cd14d3f58ea63163b275bee6d024f1bd2c756f5dbfe94441b5967a6e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origintype": "origintype",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3da44bdf30c562c4136dccc6e2bc012142ec06f1dfdf23e04bc3a999a8758be5)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origintype", value=origintype, expected_type=type_hints["origintype"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origintype is not None:
            self._values["origintype"] = origintype
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origintype(self) -> typing.Optional[builtins.str]:
        '''Specifies an origin type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        '''
        result = self._values.get("origintype")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a4de26196eabd57612322d48bf5523f3cf84359f3c5af14acf7b7c805176a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOrigintype")
    def reset_origintype(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigintype", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="origintypeInput")
    def origintype_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "origintypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83930ff41386397eb348d6a9153ff5c3694f2cdd1afaf33686684597b9916a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="origintype")
    def origintype(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "origintype"))

    @origintype.setter
    def origintype(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e8e7466de1e6f4c1f260eeac030afa2fc93d3c85a364601fe38741a3f86c024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origintype", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99ed7c55b249e1e8bf869cf9129d68e80caf489e1e091d42968c5f5968dfbb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44011cb42abb3384cd364372dc49f5ada15671dab4983916160414c35a784dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7d390e17b3355b71d6fdb0028eeffa94a07f55755be31c3fe4aeb46c280ef66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__683c481495cd290d132b7413469b4da86b9467046172c06ed3378fa6dbb352a0)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5eff24faf237a47be0d580241c8f58a8e4ff8ddbadddf61096897926d4c4061)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcbd314aef2e14c752a80b7d364b8f747ebb9fc6a1c07f5961bf99712c127e13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13163121c0297bd3312e3add74f223d5c765f6d0331f69c1e5c4d16f96d010fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879b8558ba23a2db5a6a1a2c5715fd6e12f751416180b5f3d1aecbd1abbd89bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2807400c8e044f0eb8b4343cb3bb7ad12350c7c973a06ee951695fe3e4c341b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__472dc09ada317ac43c94ada47a6835ef299b066b0949f44fdd5ddf2d6bfabbef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__785038d2e48f413e588b81b60ec873b39808cf4d5976ac01a0797c8839035d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aed3b08eb2ffe1cd895d174f699d57ba5c9011ae68237d9d4be03f54bd40f42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__153ff391c74e1592339f8c7aab3dcc33767ae89411c03949018e574ef3c575de)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a37aebf98397c22b0d60324ad6a76a6b24681e712b76c361a617c87f9459d023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8042f95afbad87037f8fb66df134be2845e5a3dc4f325da598591ff95aeb1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b05009f4894886af0b0b523ced0ad2990cd7e603b92775a0d9f69e438233166)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11f13b1efc737913ac47aaaa0780378003326ab1a63d7586f93424f31093386)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d70f4e721229cc91a76691620914492453b9d3bea57320375c0e48293e1451)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ca1174d5560204c04fe65d112d94de1d5b0cd6cfa743bdb3de524e7d78d0733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603fdc1c5fe6e8d362c8c59cda75bc8644b59786d89d90e6fe8b56bc6e1bbd6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36615b55f78ccbbfa1fea349dbd9d28b9737d6b8d4cfbea9bce90696f9cc2fe3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd52a1d0ad9a13b402d6386dbfc2cc0b8ee3f8f27b4213c98d2e24a4fa4508fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68120ff6ab3e19ac9954ef1bd1060db41e087388b430554f8b532f92cf092fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8797db748493aee641b38b270e98fac0bf8eda8aba4737794806057020eaefd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f92712eb7dca9f4f1a355777b32088d9d8c95820900e7d736ca52c7280c9c52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1894c5ca3d58549b736b854f1443260be90fba0a80b1998a3cb2e70e44dce1e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__766eee13e6e984fe74477a03cefe512e78e60232b7e12021810e3ed42faa4895)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78038fb57b9c0bde72cd3068386018152f40f44adee01534d7e644fcf5488340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba15569e44ed2165f287f7a40899ff5003883df3bc794fff64a7c37a519ca50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e101628e1f76c42d3d4cfaa469dcaff496ee5ce607e11cadb4710348740bac4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e3333c9895609482daf03cb3deac4197255c42aa335bfb88296863454d2efea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1305704926db9fa412e9b77b9a2914e1385765b90f4b3b006239cadfd14905a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37d51bf549ceb6aeeb92da54643832cb3908a34ef570abfc8b912e68a735965b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a85f77ab87f447bb340b25ffd487bad6b893d095fc7470ba20debdccf8e8bfe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf8ce42a98a112e5bbe3c3f2282a2d4a55b16394a78565040cc8fb158525481)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d886711f21c9f41409e1a0ab3fedb6bd2a174434ac5f4b364401b7cd66fc772a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b55cb80b880d3dbfd0825b313f8a491742a0cc2c20f9788acdab7c678b65c52e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f20b69d076940bd82d7022d4b6ae44f20a480b535821228a69eeec361c709fe1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83da465bfef418170fb9092b2d5c1b0503c3780342a2187dc0e70612d69318e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00fbfabf16bdb466391aee32783e84a04cdbc61d156762b779150553fd30e4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff17d1dc7a23f6fc283866b990714d31a6d5435f4caf9974d3c9ae0aacbb1cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f4dbab780c04afc413e837c1ed332a3df1e95326a620620f5f446b04e590b93)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d264e5051f8c6bf93d2f0ea6f16815a9c171e5a794f8099251c3d87a9b39c6)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f112ab7e6124fe31121820712cd2e8e8cf1f1f7c8ad7f87c24156249691fd268)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d258f5948b94c54bbc5be50713a74dc38599d0540e46ea0a8124a05e457bc10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9a84941210e83a0ae95ec5cde9f44fc8fa7bab58b7ee5986d79b0c16fc860c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ede463fe9aeddbdc55c0e45b7564d6f08c209d6fae8a902ee44e8be4c2210fa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4cc8bd2620d605dac0d954a8c57f25b8d3320701ae24323f00f4295ff1ac735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e6587a4e3e624cbcaf54b05d3d410afbedaa1fc42e402ec44d7f083ed7fd04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0157ef900d02d6defeb0c486d562c7ab73f27be36b4a74be9530eb432a6a74a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c6d47e03f69607e39835a1a909f5f26727a1139dd0164059df6b1724214a6d)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11841a9ca8f63c0b853ebab2fb8ba1fd4a7d3f5431b847e673936f3237ef95a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9931f4f035a78a2e3c87f2ec9616282e635d4449297a6e6670e1ea9121d730c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73a40c2f9f6b26765ce47790fd29b10e4de16bba46d73fbb51adea1cad0bf559)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4afc784490392c6f151549d784b8c1465cd4a95b58c9c2f6ae523e7ef525bf51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d9b4c71a448a7024b93de9162abda97c1856f1e8f35387f59b5243f171e9d7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__449206dc0f235a07740b7b900103015a01ed981468c61a3cfdb159c75e4bd4a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8d0201946418ef5271b9fa2a52b50659b301941ca124c8ad2a807a6e6e37c75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0269e7eb00204603bd1dd3dc2aab5e5abd4d0382c69335b7280867960c33f673)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a783326e3a89079fa9597b4751faf534a9422346c393ed9cc6e1e81dfbe0a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01a71ade99ef954af12edcdad5586251d340f19578f94188f6887b7ec3bb494d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f532e834541c602c68a604d91c8a6c71883b2e5b50ace38955c2f9d0d38d3b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613905d42eec45b6d93d465f462f1e78dfa824fe239fadcf20a60f234f9e92b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe284d3c597aa88eb89e2b0bb2d2a0c717fce9d3ebf0e98eb68df79451ad4212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a2011af13ec47a37adf2a65bf76a4f6f00a49254c342a47423324181983486)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__901cc3bcf40da3e5c1525461cac859d6c0b876fb1bbd40a97a1102cdd396b264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c091f11c2d35ec392f7afc17b3a8942a914e3ca00671ceee1fb2b24e853f7368)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__228c488b32e11310aa676333b38dd4f188ab977d3f5bd15b5616ac61eb7fd3aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879bc5383beec1f9b4d7a2a05c55a2ad05c704c05a231f37a47e149ccdaededf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd81a5612a7c6b023d824196fd2c65cec2cb2909771ffc04b45c7083dc6bb8b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3b0afff4b4f907c23fbca1f058f82059ef8ba56f343bec9ca22c7309ca36b56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276f6829e2a133fc112a91b202b45b289e9331b54c182ff3ff89f69cb4822459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7a386d45ca062619bebe750b5f3f766c8fdd852350ddfbef79416dad4c869b3)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d4dbf126b8b9a1cbb05ead561c374c2c829faba31390570e9235e52cd570b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0eecea784cd44caf9f2825ea7c9527333a999923732c2181249eb47a57b712c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7babd662279e6b37661e554b4a3e4e6d0e0266e581f585fdb4b25cf83a9addda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__160023eaff2be9ad012a9fe49cf86343ec53d270318ba0e497b83b4e4c006544)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3feb2960d97216a7003ddcc238f8e2f88891762d79c5955f261d0dd61f36d42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5f8b224a4bd82ac0a5533df5beb4b2b71b92751e78d45a5543e27c24b38725)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod",
    jsii_struct_bases=[],
    name_mapping={
        "custom_status_code": "customStatusCode",
        "locked": "locked",
        "recovery_method": "recoveryMethod",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod:
    def __init__(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6251e842494e5b8e09aa2e461caccfd118149d2f0c4ffe1d6b5c9d733e985b9)
            check_type(argname="argument custom_status_code", value=custom_status_code, expected_type=type_hints["custom_status_code"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument recovery_method", value=recovery_method, expected_type=type_hints["recovery_method"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_status_code is not None:
            self._values["custom_status_code"] = custom_status_code
        if locked is not None:
            self._values["locked"] = locked
        if recovery_method is not None:
            self._values["recovery_method"] = recovery_method
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom status code to be sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        '''
        result = self._values.get("custom_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def recovery_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        '''
        result = self._values.get("recovery_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1d944e0153c763c5b6d93c316c3acbb56f10dafe0ad5dc0c70694a200bf66f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomStatusCode")
    def reset_custom_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatusCode", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRecoveryMethod")
    def reset_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryMethod", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customStatusCodeInput")
    def custom_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryMethodInput")
    def recovery_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "recoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatusCode")
    def custom_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatusCode"))

    @custom_status_code.setter
    def custom_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df9d9d8bcd368296ffad56b8be9cd3b1f032af0fff7cb1dab375132dcd6715ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__590d02cc66b785080ce4cb5c9c710f3f8332c26880b0f2d65bd7a913f2796e4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="recoveryMethod")
    def recovery_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "recoveryMethod"))

    @recovery_method.setter
    def recovery_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3769d3bc523e1c980134c8b925ca8f4e205a2c13ae8092b7023089cb45c9b31b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "recoveryMethod", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000fbde3e91d6accfe6a6f4d16fd9ae68affc2c8dfcd56efd4eff024324d8a49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0055054661e37acae2eddbe919c14f50c33bf223a959d933fa1c79c2fee0cf0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28d82f711b422a59c3ab56a0d8bce68a76f64532be97586d81b72ab150c346e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "binary_equivalent_content": "binaryEquivalentContent",
        "enabled": "enabled",
        "enable_ip_avoidance": "enableIpAvoidance",
        "ip_avoidance_error_threshold": "ipAvoidanceErrorThreshold",
        "ip_avoidance_retry_interval": "ipAvoidanceRetryInterval",
        "locked": "locked",
        "monitor_origin_responsiveness": "monitorOriginResponsiveness",
        "monitor_response_codes1": "monitorResponseCodes1",
        "monitor_response_codes2": "monitorResponseCodes2",
        "monitor_response_codes3": "monitorResponseCodes3",
        "monitor_status_codes1": "monitorStatusCodes1",
        "monitor_status_codes1_enable_recovery": "monitorStatusCodes1EnableRecovery",
        "monitor_status_codes1_enable_retry": "monitorStatusCodes1EnableRetry",
        "monitor_status_codes1_recovery_config_name": "monitorStatusCodes1RecoveryConfigName",
        "monitor_status_codes2": "monitorStatusCodes2",
        "monitor_status_codes2_enable_recovery": "monitorStatusCodes2EnableRecovery",
        "monitor_status_codes2_enable_retry": "monitorStatusCodes2EnableRetry",
        "monitor_status_codes2_recovery_config_name": "monitorStatusCodes2RecoveryConfigName",
        "monitor_status_codes3": "monitorStatusCodes3",
        "monitor_status_codes3_enable_recovery": "monitorStatusCodes3EnableRecovery",
        "monitor_status_codes3_enable_retry": "monitorStatusCodes3EnableRetry",
        "monitor_status_codes3_recovery_config_name": "monitorStatusCodes3RecoveryConfigName",
        "origin_responsiveness_custom_timeout": "originResponsivenessCustomTimeout",
        "origin_responsiveness_enable_recovery": "originResponsivenessEnableRecovery",
        "origin_responsiveness_enable_retry": "originResponsivenessEnableRetry",
        "origin_responsiveness_monitoring": "originResponsivenessMonitoring",
        "origin_responsiveness_recovery_config_name": "originResponsivenessRecoveryConfigName",
        "origin_responsiveness_timeout": "originResponsivenessTimeout",
        "status_code_monitoring1": "statusCodeMonitoring1",
        "status_code_monitoring2": "statusCodeMonitoring2",
        "status_code_monitoring3": "statusCodeMonitoring3",
        "template_uuid": "templateUuid",
        "tuning_parameters": "tuningParameters",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy:
    def __init__(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f50b088a1b24bc8f5b91608934887b26c06e90c7f4018e7c6856da73c8447960)
            check_type(argname="argument binary_equivalent_content", value=binary_equivalent_content, expected_type=type_hints["binary_equivalent_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_ip_avoidance", value=enable_ip_avoidance, expected_type=type_hints["enable_ip_avoidance"])
            check_type(argname="argument ip_avoidance_error_threshold", value=ip_avoidance_error_threshold, expected_type=type_hints["ip_avoidance_error_threshold"])
            check_type(argname="argument ip_avoidance_retry_interval", value=ip_avoidance_retry_interval, expected_type=type_hints["ip_avoidance_retry_interval"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument monitor_origin_responsiveness", value=monitor_origin_responsiveness, expected_type=type_hints["monitor_origin_responsiveness"])
            check_type(argname="argument monitor_response_codes1", value=monitor_response_codes1, expected_type=type_hints["monitor_response_codes1"])
            check_type(argname="argument monitor_response_codes2", value=monitor_response_codes2, expected_type=type_hints["monitor_response_codes2"])
            check_type(argname="argument monitor_response_codes3", value=monitor_response_codes3, expected_type=type_hints["monitor_response_codes3"])
            check_type(argname="argument monitor_status_codes1", value=monitor_status_codes1, expected_type=type_hints["monitor_status_codes1"])
            check_type(argname="argument monitor_status_codes1_enable_recovery", value=monitor_status_codes1_enable_recovery, expected_type=type_hints["monitor_status_codes1_enable_recovery"])
            check_type(argname="argument monitor_status_codes1_enable_retry", value=monitor_status_codes1_enable_retry, expected_type=type_hints["monitor_status_codes1_enable_retry"])
            check_type(argname="argument monitor_status_codes1_recovery_config_name", value=monitor_status_codes1_recovery_config_name, expected_type=type_hints["monitor_status_codes1_recovery_config_name"])
            check_type(argname="argument monitor_status_codes2", value=monitor_status_codes2, expected_type=type_hints["monitor_status_codes2"])
            check_type(argname="argument monitor_status_codes2_enable_recovery", value=monitor_status_codes2_enable_recovery, expected_type=type_hints["monitor_status_codes2_enable_recovery"])
            check_type(argname="argument monitor_status_codes2_enable_retry", value=monitor_status_codes2_enable_retry, expected_type=type_hints["monitor_status_codes2_enable_retry"])
            check_type(argname="argument monitor_status_codes2_recovery_config_name", value=monitor_status_codes2_recovery_config_name, expected_type=type_hints["monitor_status_codes2_recovery_config_name"])
            check_type(argname="argument monitor_status_codes3", value=monitor_status_codes3, expected_type=type_hints["monitor_status_codes3"])
            check_type(argname="argument monitor_status_codes3_enable_recovery", value=monitor_status_codes3_enable_recovery, expected_type=type_hints["monitor_status_codes3_enable_recovery"])
            check_type(argname="argument monitor_status_codes3_enable_retry", value=monitor_status_codes3_enable_retry, expected_type=type_hints["monitor_status_codes3_enable_retry"])
            check_type(argname="argument monitor_status_codes3_recovery_config_name", value=monitor_status_codes3_recovery_config_name, expected_type=type_hints["monitor_status_codes3_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_custom_timeout", value=origin_responsiveness_custom_timeout, expected_type=type_hints["origin_responsiveness_custom_timeout"])
            check_type(argname="argument origin_responsiveness_enable_recovery", value=origin_responsiveness_enable_recovery, expected_type=type_hints["origin_responsiveness_enable_recovery"])
            check_type(argname="argument origin_responsiveness_enable_retry", value=origin_responsiveness_enable_retry, expected_type=type_hints["origin_responsiveness_enable_retry"])
            check_type(argname="argument origin_responsiveness_monitoring", value=origin_responsiveness_monitoring, expected_type=type_hints["origin_responsiveness_monitoring"])
            check_type(argname="argument origin_responsiveness_recovery_config_name", value=origin_responsiveness_recovery_config_name, expected_type=type_hints["origin_responsiveness_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_timeout", value=origin_responsiveness_timeout, expected_type=type_hints["origin_responsiveness_timeout"])
            check_type(argname="argument status_code_monitoring1", value=status_code_monitoring1, expected_type=type_hints["status_code_monitoring1"])
            check_type(argname="argument status_code_monitoring2", value=status_code_monitoring2, expected_type=type_hints["status_code_monitoring2"])
            check_type(argname="argument status_code_monitoring3", value=status_code_monitoring3, expected_type=type_hints["status_code_monitoring3"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tuning_parameters", value=tuning_parameters, expected_type=type_hints["tuning_parameters"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if binary_equivalent_content is not None:
            self._values["binary_equivalent_content"] = binary_equivalent_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_ip_avoidance is not None:
            self._values["enable_ip_avoidance"] = enable_ip_avoidance
        if ip_avoidance_error_threshold is not None:
            self._values["ip_avoidance_error_threshold"] = ip_avoidance_error_threshold
        if ip_avoidance_retry_interval is not None:
            self._values["ip_avoidance_retry_interval"] = ip_avoidance_retry_interval
        if locked is not None:
            self._values["locked"] = locked
        if monitor_origin_responsiveness is not None:
            self._values["monitor_origin_responsiveness"] = monitor_origin_responsiveness
        if monitor_response_codes1 is not None:
            self._values["monitor_response_codes1"] = monitor_response_codes1
        if monitor_response_codes2 is not None:
            self._values["monitor_response_codes2"] = monitor_response_codes2
        if monitor_response_codes3 is not None:
            self._values["monitor_response_codes3"] = monitor_response_codes3
        if monitor_status_codes1 is not None:
            self._values["monitor_status_codes1"] = monitor_status_codes1
        if monitor_status_codes1_enable_recovery is not None:
            self._values["monitor_status_codes1_enable_recovery"] = monitor_status_codes1_enable_recovery
        if monitor_status_codes1_enable_retry is not None:
            self._values["monitor_status_codes1_enable_retry"] = monitor_status_codes1_enable_retry
        if monitor_status_codes1_recovery_config_name is not None:
            self._values["monitor_status_codes1_recovery_config_name"] = monitor_status_codes1_recovery_config_name
        if monitor_status_codes2 is not None:
            self._values["monitor_status_codes2"] = monitor_status_codes2
        if monitor_status_codes2_enable_recovery is not None:
            self._values["monitor_status_codes2_enable_recovery"] = monitor_status_codes2_enable_recovery
        if monitor_status_codes2_enable_retry is not None:
            self._values["monitor_status_codes2_enable_retry"] = monitor_status_codes2_enable_retry
        if monitor_status_codes2_recovery_config_name is not None:
            self._values["monitor_status_codes2_recovery_config_name"] = monitor_status_codes2_recovery_config_name
        if monitor_status_codes3 is not None:
            self._values["monitor_status_codes3"] = monitor_status_codes3
        if monitor_status_codes3_enable_recovery is not None:
            self._values["monitor_status_codes3_enable_recovery"] = monitor_status_codes3_enable_recovery
        if monitor_status_codes3_enable_retry is not None:
            self._values["monitor_status_codes3_enable_retry"] = monitor_status_codes3_enable_retry
        if monitor_status_codes3_recovery_config_name is not None:
            self._values["monitor_status_codes3_recovery_config_name"] = monitor_status_codes3_recovery_config_name
        if origin_responsiveness_custom_timeout is not None:
            self._values["origin_responsiveness_custom_timeout"] = origin_responsiveness_custom_timeout
        if origin_responsiveness_enable_recovery is not None:
            self._values["origin_responsiveness_enable_recovery"] = origin_responsiveness_enable_recovery
        if origin_responsiveness_enable_retry is not None:
            self._values["origin_responsiveness_enable_retry"] = origin_responsiveness_enable_retry
        if origin_responsiveness_monitoring is not None:
            self._values["origin_responsiveness_monitoring"] = origin_responsiveness_monitoring
        if origin_responsiveness_recovery_config_name is not None:
            self._values["origin_responsiveness_recovery_config_name"] = origin_responsiveness_recovery_config_name
        if origin_responsiveness_timeout is not None:
            self._values["origin_responsiveness_timeout"] = origin_responsiveness_timeout
        if status_code_monitoring1 is not None:
            self._values["status_code_monitoring1"] = status_code_monitoring1
        if status_code_monitoring2 is not None:
            self._values["status_code_monitoring2"] = status_code_monitoring2
        if status_code_monitoring3 is not None:
            self._values["status_code_monitoring3"] = status_code_monitoring3
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tuning_parameters is not None:
            self._values["tuning_parameters"] = tuning_parameters
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def binary_equivalent_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Synchronizes content between the primary and backup origins, byte for byte.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        '''
        result = self._values.get("binary_equivalent_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates and configures a recovery policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_avoidance(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Temporarily blocks an origin IP address that experienced a certain number of failures.

        When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        '''
        result = self._values.get("enable_ip_avoidance")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip_avoidance_error_threshold(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of failures that need to occur to an origin address before it's blocked.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        '''
        result = self._values.get("ip_avoidance_error_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_avoidance_retry_interval(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of seconds after which the IP address is removed from the blocklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        '''
        result = self._values.get("ip_avoidance_retry_interval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        '''
        result = self._values.get("monitor_origin_responsiveness")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_response_codes1(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        '''
        result = self._values.get("monitor_response_codes1")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes2(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        '''
        result = self._values.get("monitor_response_codes2")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes3(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here..

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        '''
        result = self._values.get("monitor_response_codes3")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_status_codes1(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        '''
        result = self._values.get("monitor_status_codes1")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes1_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        '''
        result = self._values.get("monitor_status_codes1_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes1_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes2(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        '''
        result = self._values.get("monitor_status_codes2")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes2_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        '''
        result = self._values.get("monitor_status_codes2_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes2_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes3(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        '''
        result = self._values.get("monitor_status_codes3")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes3_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        '''
        result = self._values.get("monitor_status_codes3_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes3_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_custom_timeout(self) -> typing.Optional[jsii.Number]:
        '''Specify a custom timeout, from 1 to 10 seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        '''
        result = self._values.get("origin_responsiveness_custom_timeout")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a recovery action for a specific failure condition.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        '''
        result = self._values.get("origin_responsiveness_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        '''
        result = self._values.get("origin_responsiveness_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_monitoring(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        '''
        result = self._values.get("origin_responsiveness_monitoring")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        '''
        result = self._values.get("origin_responsiveness_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_timeout(self) -> typing.Optional[builtins.str]:
        '''The timeout threshold that triggers a retry or recovery action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        '''
        result = self._values.get("origin_responsiveness_timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring1(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        '''
        result = self._values.get("status_code_monitoring1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring2(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        '''
        result = self._values.get("status_code_monitoring2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring3(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        '''
        result = self._values.get("status_code_monitoring3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tuning_parameters(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        '''
        result = self._values.get("tuning_parameters")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41deec78dfcba73056c294f3689bc27601ac5138457830bd074b4c3e268f2cfc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBinaryEquivalentContent")
    def reset_binary_equivalent_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBinaryEquivalentContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableIpAvoidance")
    def reset_enable_ip_avoidance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpAvoidance", []))

    @jsii.member(jsii_name="resetIpAvoidanceErrorThreshold")
    def reset_ip_avoidance_error_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceErrorThreshold", []))

    @jsii.member(jsii_name="resetIpAvoidanceRetryInterval")
    def reset_ip_avoidance_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceRetryInterval", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMonitorOriginResponsiveness")
    def reset_monitor_origin_responsiveness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorOriginResponsiveness", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes1")
    def reset_monitor_response_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes1", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes2")
    def reset_monitor_response_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes2", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes3")
    def reset_monitor_response_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1")
    def reset_monitor_status_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRecovery")
    def reset_monitor_status_codes1_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRetry")
    def reset_monitor_status_codes1_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1RecoveryConfigName")
    def reset_monitor_status_codes1_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2")
    def reset_monitor_status_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRecovery")
    def reset_monitor_status_codes2_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRetry")
    def reset_monitor_status_codes2_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2RecoveryConfigName")
    def reset_monitor_status_codes2_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3")
    def reset_monitor_status_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRecovery")
    def reset_monitor_status_codes3_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRetry")
    def reset_monitor_status_codes3_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3RecoveryConfigName")
    def reset_monitor_status_codes3_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3RecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessCustomTimeout")
    def reset_origin_responsiveness_custom_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessCustomTimeout", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRecovery")
    def reset_origin_responsiveness_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRecovery", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRetry")
    def reset_origin_responsiveness_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRetry", []))

    @jsii.member(jsii_name="resetOriginResponsivenessMonitoring")
    def reset_origin_responsiveness_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessMonitoring", []))

    @jsii.member(jsii_name="resetOriginResponsivenessRecoveryConfigName")
    def reset_origin_responsiveness_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessRecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessTimeout")
    def reset_origin_responsiveness_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessTimeout", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring1")
    def reset_status_code_monitoring1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring1", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring2")
    def reset_status_code_monitoring2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring2", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring3")
    def reset_status_code_monitoring3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring3", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTuningParameters")
    def reset_tuning_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTuningParameters", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContentInput")
    def binary_equivalent_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "binaryEquivalentContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidanceInput")
    def enable_ip_avoidance_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpAvoidanceInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThresholdInput")
    def ip_avoidance_error_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceErrorThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryIntervalInput")
    def ip_avoidance_retry_interval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceRetryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsivenessInput")
    def monitor_origin_responsiveness_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorOriginResponsivenessInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1Input")
    def monitor_response_codes1_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2Input")
    def monitor_response_codes2_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3Input")
    def monitor_response_codes3_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecoveryInput")
    def monitor_status_codes1_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetryInput")
    def monitor_status_codes1_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1Input")
    def monitor_status_codes1_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigNameInput")
    def monitor_status_codes1_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes1RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecoveryInput")
    def monitor_status_codes2_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetryInput")
    def monitor_status_codes2_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2Input")
    def monitor_status_codes2_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigNameInput")
    def monitor_status_codes2_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes2RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecoveryInput")
    def monitor_status_codes3_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetryInput")
    def monitor_status_codes3_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3Input")
    def monitor_status_codes3_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigNameInput")
    def monitor_status_codes3_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes3RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeoutInput")
    def origin_responsiveness_custom_timeout_input(
        self,
    ) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originResponsivenessCustomTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecoveryInput")
    def origin_responsiveness_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetryInput")
    def origin_responsiveness_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoringInput")
    def origin_responsiveness_monitoring_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigNameInput")
    def origin_responsiveness_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessRecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeoutInput")
    def origin_responsiveness_timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1Input")
    def status_code_monitoring1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring1Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2Input")
    def status_code_monitoring2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring2Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3Input")
    def status_code_monitoring3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring3Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tuningParametersInput")
    def tuning_parameters_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tuningParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContent")
    def binary_equivalent_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "binaryEquivalentContent"))

    @binary_equivalent_content.setter
    def binary_equivalent_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d89bd81425db42266f796d657b7a2d656b11563e5f40923edafc820113d47fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "binaryEquivalentContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f6af48d95eec8aee186a38df1a6c833f85511d101d5118af138ee1c159e86e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidance")
    def enable_ip_avoidance(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpAvoidance"))

    @enable_ip_avoidance.setter
    def enable_ip_avoidance(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9af25ba31392604bcf16d59a95e987218bff054540ae37e612199c307feb72a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpAvoidance", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThreshold")
    def ip_avoidance_error_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceErrorThreshold"))

    @ip_avoidance_error_threshold.setter
    def ip_avoidance_error_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de6ed639276de8eff3e0963151ba20e3bc6d9f30d9c3c9d30235c01b5c6447c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceErrorThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryInterval")
    def ip_avoidance_retry_interval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceRetryInterval"))

    @ip_avoidance_retry_interval.setter
    def ip_avoidance_retry_interval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0fb9ecc1d3c2f503239e390c32f67f20f21e50ab18267abf7ca0191c69ca145)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceRetryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3fe2dcbe843152abaf9f36a2c5f6898f5162f721a185431f5434224959bb52d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsiveness")
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorOriginResponsiveness"))

    @monitor_origin_responsiveness.setter
    def monitor_origin_responsiveness(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4826f8e463a1b2650cdb5e7368b33b8fe2ebbbcbc69a187102fb6767939fd9af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorOriginResponsiveness", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1")
    def monitor_response_codes1(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes1"))

    @monitor_response_codes1.setter
    def monitor_response_codes1(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b5b216599474fcb718a353fcb5faca359b046cc4da3e8443ea70d05fecf462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2")
    def monitor_response_codes2(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes2"))

    @monitor_response_codes2.setter
    def monitor_response_codes2(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a4ce3349a5e6a948a02aecf52d5e165c6497f1b9a14987a6bacfe4f4593aa6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3")
    def monitor_response_codes3(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes3"))

    @monitor_response_codes3.setter
    def monitor_response_codes3(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e15463364ea3a17614abc715a36932f849eee9ee5a54e0f272c1f1318b42ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1")
    def monitor_status_codes1(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1"))

    @monitor_status_codes1.setter
    def monitor_status_codes1(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616512c93afdeb5ea6d1a8a2ef79d1dcc3246831a791027a8b37800731e35684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecovery")
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRecovery"))

    @monitor_status_codes1_enable_recovery.setter
    def monitor_status_codes1_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbd44d60f2aad868c88e67dea19ef77f1965250e3ef35dc05325da002ef0b528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetry")
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRetry"))

    @monitor_status_codes1_enable_retry.setter
    def monitor_status_codes1_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bbe719048054b483d2f076d444a8290ff2e9cff7f7b76ebeb3f05400094efac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigName")
    def monitor_status_codes1_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes1RecoveryConfigName"))

    @monitor_status_codes1_recovery_config_name.setter
    def monitor_status_codes1_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__276d8864f18fd39f0de886860c687549fee190a39f5794b25f54755829fdcfba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2")
    def monitor_status_codes2(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2"))

    @monitor_status_codes2.setter
    def monitor_status_codes2(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__783d38d1ecc6530bc83af52938009e534c23c41d633c13be1b86666143361362)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecovery")
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRecovery"))

    @monitor_status_codes2_enable_recovery.setter
    def monitor_status_codes2_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a81ba9c2248013669fd8ba7134028dc985978b0e3c2c86fad2e5f4f70c51b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetry")
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRetry"))

    @monitor_status_codes2_enable_retry.setter
    def monitor_status_codes2_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e30b527fbb5b23aeb1351bd66196e26dd8ec4e08e67a40b0f4b043a191a7336)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigName")
    def monitor_status_codes2_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes2RecoveryConfigName"))

    @monitor_status_codes2_recovery_config_name.setter
    def monitor_status_codes2_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__199f7f2c735258cea01dd184756316fdb2ce48d9162fe77c9853d36fa187a224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3")
    def monitor_status_codes3(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3"))

    @monitor_status_codes3.setter
    def monitor_status_codes3(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09393acce9ed25741f6e1132f4b155b1f8e9173d6a9bf4677a64ebc44c2e667b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecovery")
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRecovery"))

    @monitor_status_codes3_enable_recovery.setter
    def monitor_status_codes3_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d64cbb438f06502e0ce4bb695a6834f10ade106c43d87c4b840b37b487b27b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetry")
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRetry"))

    @monitor_status_codes3_enable_retry.setter
    def monitor_status_codes3_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2912c56935b6a4ba12f1a7d92b7f2f7530d86c309f233d26beba40909730566d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigName")
    def monitor_status_codes3_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes3RecoveryConfigName"))

    @monitor_status_codes3_recovery_config_name.setter
    def monitor_status_codes3_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376a6aae223bc92eee2bb54a98018635f9cf51113b9e082514dbcb004259e438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeout")
    def origin_responsiveness_custom_timeout(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originResponsivenessCustomTimeout"))

    @origin_responsiveness_custom_timeout.setter
    def origin_responsiveness_custom_timeout(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3582d8b8923d456a3d7daac00d08959df39cf01d6e9e540fa0bc9efe19085f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessCustomTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecovery")
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRecovery"))

    @origin_responsiveness_enable_recovery.setter
    def origin_responsiveness_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d4a8db219bce32969f77573d694e0138da260c44883e995daca5ccab5fbb873)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetry")
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRetry"))

    @origin_responsiveness_enable_retry.setter
    def origin_responsiveness_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f905e7b11644c9ba7997ee011ecaf2a27fdd0e026aeab9ffeb6d08f230e7ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoring")
    def origin_responsiveness_monitoring(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessMonitoring"))

    @origin_responsiveness_monitoring.setter
    def origin_responsiveness_monitoring(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa517ea36d7ef7d07b278125d642ff1951b3eb639b67fbfb600f181d8da7c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigName")
    def origin_responsiveness_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessRecoveryConfigName"))

    @origin_responsiveness_recovery_config_name.setter
    def origin_responsiveness_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dbe601031aa2e63be7d7ce4654cad5814c2c215891666aabd9d9d06908df0a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessRecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeout")
    def origin_responsiveness_timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessTimeout"))

    @origin_responsiveness_timeout.setter
    def origin_responsiveness_timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ea72a1914010b7d83bfaed87200662be7204992168d4563f68f610ab3434b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1")
    def status_code_monitoring1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring1"))

    @status_code_monitoring1.setter
    def status_code_monitoring1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3ad35cfdacfb104d016d622b7b54953f9729f9036822c921d1c2bb894bea200)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring1", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2")
    def status_code_monitoring2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring2"))

    @status_code_monitoring2.setter
    def status_code_monitoring2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db6bdfe111c0125c101b474c8be2c4068aa4b6be4d8e3ceb056653c4e1c5a83a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring2", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3")
    def status_code_monitoring3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring3"))

    @status_code_monitoring3.setter
    def status_code_monitoring3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b36e075b4c31e7efaae9b46bf6b3e734c4e1c035f0980ca3e81d5869b9c0e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring3", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecbf91cd94f280aeb470297ac76e68de3e5405e462d2751c12e9b73eb2130337)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tuningParameters")
    def tuning_parameters(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tuningParameters"))

    @tuning_parameters.setter
    def tuning_parameters(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a852525c370867be6c7b3537f384642ac9d73fa7fa7680c88a56c161234aa56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tuningParameters", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c5258ab5d6baf19634786a582c82625ec87a14e1390ff51ffde8362a8991cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__669b104169153c200536e28e46c2d143cd486fc9d998c50b4bc88efd62fd4257)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4ece89991942ab1e63e32877085705b76f7600409aa44e6a2bf4092155d7df)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Origin IP Access Control List behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7484a152122ff6e32386357b712b598e489866b11c25ec3fc72ceba13d83372)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d315b024c76a92144a322b236015ba539be0583ced321ea42fbbe42a6b1f80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78640c8676006ba8b24969067d337cd3b1ddc08ff3b49fb350d8ba3e3501f85e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fef420da23d9300a696f9df40065683419187a814f32f6918bac24e0907ac65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f5537c53319b5a500e267b98d10c8906a4428d9309ee326a0cbed30576a110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd020b1d4d494312473f86d3fde21ba703ee30454ced40e11c1191e6332da7c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3124b5c415f2ebbcbdbf684bb10defc738c1ef3a29e1029cda2a7e8e341714c)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__662785237fcd5b2995d52f36a37a98e60e33eac7750150097a686e8db3cea376)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e41a89f2bf730f15418e30a225bad880fdd81f371864ff7bc216b29e5516b2c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da069ab269071f069b091c79a72a2a63963ee350c175743cda2ecddbe329cd14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__492b84512c510412a2edc053399ffbbee716152438d3c65d6c5a7f0b41ea2caa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc0e234de18395ddcbcced1c2c7e96902bd745f22e2f5dc8ce384e8e53dc0f34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c240c3581ecdd6a5f93a6c6ee10cd2d421adeb30aca16b2c9a1c82957ee0cd6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCustomCertificateAuthorities")
    def put_custom_certificate_authorities(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b177137e97a325bf5b63a4735b47b4ffd0498b6d485a49beeabdd3b77f39c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificateAuthorities", [value]))

    @jsii.member(jsii_name="putCustomCertificates")
    def put_custom_certificates(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9f80952ffb072fa8b5070207e8ae177c36e2e07f48df782268c72a0d46ae20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificates", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetCacheKeyHostname")
    def reset_cache_key_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyHostname", []))

    @jsii.member(jsii_name="resetCompress")
    def reset_compress(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompress", []))

    @jsii.member(jsii_name="resetCustomCertificateAuthorities")
    def reset_custom_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificateAuthorities", []))

    @jsii.member(jsii_name="resetCustomCertificates")
    def reset_custom_certificates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificates", []))

    @jsii.member(jsii_name="resetCustomForwardHostHeader")
    def reset_custom_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomForwardHostHeader", []))

    @jsii.member(jsii_name="resetCustomValidCnValues")
    def reset_custom_valid_cn_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValidCnValues", []))

    @jsii.member(jsii_name="resetEnableTrueClientIp")
    def reset_enable_true_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTrueClientIp", []))

    @jsii.member(jsii_name="resetForwardHostHeader")
    def reset_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHostHeader", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetHttpPort")
    def reset_http_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpPort", []))

    @jsii.member(jsii_name="resetHttpsPort")
    def reset_https_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpsPort", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxTlsVersion")
    def reset_max_tls_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxTlsVersion", []))

    @jsii.member(jsii_name="resetMinTlsVersion")
    def reset_min_tls_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinTlsVersion", []))

    @jsii.member(jsii_name="resetMslorigin")
    def reset_mslorigin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslorigin", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetOriginCertificate")
    def reset_origin_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertificate", []))

    @jsii.member(jsii_name="resetOriginCertsToHonor")
    def reset_origin_certs_to_honor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertsToHonor", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetOriginSni")
    def reset_origin_sni(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSni", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetPorts")
    def reset_ports(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPorts", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetSecondHostname")
    def reset_second_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostname", []))

    @jsii.member(jsii_name="resetSecondHostnameEnabled")
    def reset_second_hostname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostnameEnabled", []))

    @jsii.member(jsii_name="resetStandardCertificateAuthorities")
    def reset_standard_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardCertificateAuthorities", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTls13Support")
    def reset_tls13_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTls13Support", []))

    @jsii.member(jsii_name="resetTlsVersionTitle")
    def reset_tls_version_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsVersionTitle", []))

    @jsii.member(jsii_name="resetTrueClientIpClientSetting")
    def reset_true_client_ip_client_setting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpClientSetting", []))

    @jsii.member(jsii_name="resetTrueClientIpHeader")
    def reset_true_client_ip_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpHeader", []))

    @jsii.member(jsii_name="resetUseUniqueCacheKey")
    def reset_use_unique_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseUniqueCacheKey", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationMode")
    def reset_verification_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationMode", []))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthorities")
    def custom_certificate_authorities(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesList, jsii.get(self, "customCertificateAuthorities"))

    @builtins.property
    @jsii.member(jsii_name="customCertificates")
    def custom_certificates(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesList, jsii.get(self, "customCertificates"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostnameInput")
    def cache_key_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheKeyHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="compressInput")
    def compress_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthoritiesInput")
    def custom_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "customCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificatesInput")
    def custom_certificates_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]]], jsii.get(self, "customCertificatesInput"))

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeaderInput")
    def custom_forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customForwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="customValidCnValuesInput")
    def custom_valid_cn_values_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customValidCnValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIpInput")
    def enable_true_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTrueClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeaderInput")
    def forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="httpPortInput")
    def http_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpPortInput"))

    @builtins.property
    @jsii.member(jsii_name="httpsPortInput")
    def https_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpsPortInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxTlsVersionInput")
    def max_tls_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxTlsVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="minTlsVersionInput")
    def min_tls_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minTlsVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="msloriginInput")
    def mslorigin_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "msloriginInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertificateInput")
    def origin_certificate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonorInput")
    def origin_certs_to_honor_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertsToHonorInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="originSniInput")
    def origin_sni_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originSniInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="portsInput")
    def ports_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "portsInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabledInput")
    def second_hostname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondHostnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameInput")
    def second_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthoritiesInput")
    def standard_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "standardCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tls13SupportInput")
    def tls13_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tls13SupportInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsVersionTitleInput")
    def tls_version_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tlsVersionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSettingInput")
    def true_client_ip_client_setting_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "trueClientIpClientSettingInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeaderInput")
    def true_client_ip_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trueClientIpHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKeyInput")
    def use_unique_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useUniqueCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationModeInput")
    def verification_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostname")
    def cache_key_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheKeyHostname"))

    @cache_key_hostname.setter
    def cache_key_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06d7653462d7aa4af8c1a3821c506f97ea79d214a9a81665d48601186ae99d92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKeyHostname", value)

    @builtins.property
    @jsii.member(jsii_name="compress")
    def compress(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compress"))

    @compress.setter
    def compress(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e98941358a04686629b6b7a3dc6f33cfca086c2d6e29a8463c3ed7140991e7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compress", value)

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeader")
    def custom_forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customForwardHostHeader"))

    @custom_forward_host_header.setter
    def custom_forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ed6b756fe8f45ddf0c0b056a797e83760eac0cece31341b2e89006cfeb16af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customForwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="customValidCnValues")
    def custom_valid_cn_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customValidCnValues"))

    @custom_valid_cn_values.setter
    def custom_valid_cn_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d319acc0ce07365844ff223a99177c9b388d0cf3b0be9a6214fe1673daa228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValidCnValues", value)

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIp")
    def enable_true_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTrueClientIp"))

    @enable_true_client_ip.setter
    def enable_true_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f09d681c1528546fc179f6b44a0e80d52b79186e3e09bc71fb11e2d34273097a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTrueClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeader")
    def forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardHostHeader"))

    @forward_host_header.setter
    def forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81116cc0306adb370ba78c2b08b6b294368f9774b86bc6fa162c7e9db93a459f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9230eb2ed62efb03bea86517d24938e8caa2e46bc314411784701f403b9a292a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="httpPort")
    def http_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpPort"))

    @http_port.setter
    def http_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a770f3f021481bc7b74adf73424339e70418684c1cb694d7dfd573e8d5b1e1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpPort", value)

    @builtins.property
    @jsii.member(jsii_name="httpsPort")
    def https_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpsPort"))

    @https_port.setter
    def https_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10188f528bc4a07a443a3ec8ddfa44d9e8d476f15ffa026f1eb7c8c82c1dbbcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpsPort", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c789c7e81abae84ba23556b1590bbca064545bf0379634e20f4d108b1f3395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6422ef0661049bc8101c8dc29cd5df919d5254d443a1af758984af043b319496)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxTlsVersion")
    def max_tls_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxTlsVersion"))

    @max_tls_version.setter
    def max_tls_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e55840fd5c4835fd13463e0a5332b46a8965d73e7406d47652846ca715956945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxTlsVersion", value)

    @builtins.property
    @jsii.member(jsii_name="minTlsVersion")
    def min_tls_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minTlsVersion"))

    @min_tls_version.setter
    def min_tls_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1713d593d1c8c0bfa8eaac3dc5b4db0553b57652ce3c4a7382a7ac485ce618dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minTlsVersion", value)

    @builtins.property
    @jsii.member(jsii_name="mslorigin")
    def mslorigin(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslorigin"))

    @mslorigin.setter
    def mslorigin(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29045787436005206c8e9bc6dac907b8042c48d5b62434749ac226eadf8368a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslorigin", value)

    @builtins.property
    @jsii.member(jsii_name="originCertificate")
    def origin_certificate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertificate"))

    @origin_certificate.setter
    def origin_certificate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fff18e2a377cd5d3c15335a0aa54af944c522596af648365b997779613baaae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonor")
    def origin_certs_to_honor(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertsToHonor"))

    @origin_certs_to_honor.setter
    def origin_certs_to_honor(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d939483a812d14bd0726b0659922b70d30254a2a48fa5972e4b7adc354ef1ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertsToHonor", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8bb3c9d93ced1c7155f9ec9eb1163ba1fae2ddedd7e766d39f880af63c3f853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="originSni")
    def origin_sni(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originSni"))

    @origin_sni.setter
    def origin_sni(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de175b19b057f7f84e075f72cb13c333f9443281f8cdaaff46439d45634061ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSni", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc88311cd351d4f02578388325f3a69544dfa6d5e382a3416201a38bc4a397dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="ports")
    def ports(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ports"))

    @ports.setter
    def ports(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6016c20275296a2c18b1ceaeca5a438c3c24a97d86fd6cde002ecefdbff4b982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ports", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f45fa0051b6c7c8856e3ef81affbe55a5dc864d59e057be37d31d0908761c5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c6f053198af90a65351f44b2cd0f551d6b0463307d6afaf7dcd351342b372c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1281bfcc70fded9dedb55b3979b99c9c4e3a501bc3a187bf0e0fb9aebfbe6d4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d148f62be069a0abd5e762066eac4e50337c1f290ac7fb4ed3cd4bdf32b27970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c60f644860b1324edc58f81c679bb5a5566f2f34a7d4867a32547decc5b9dee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e610af51d2c597630afa8cbe8073da0c0f5de0c23b9777ea629a72a965cad1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6eb3cd4be8e2d4f6bfda5ebdf3a236038508d02f67527c44c72474144e5260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c406ca16f60643555cc091179ea413f6ffa144fe234cc3afc703885013b9359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostname")
    def second_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondHostname"))

    @second_hostname.setter
    def second_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98106bb1f75aa73a2728a054f2362dba005a53d4889e2bb9e657fc5a3ec55d8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostname", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabled")
    def second_hostname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondHostnameEnabled"))

    @second_hostname_enabled.setter
    def second_hostname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c131dc7b6910f42d938d33cb6c7a50b416d9d1b8242074b0a6290f3476e0c344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthorities")
    def standard_certificate_authorities(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "standardCertificateAuthorities"))

    @standard_certificate_authorities.setter
    def standard_certificate_authorities(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f636297ed8910e1d1f0678355b63adda7499b0234994e1fbc9c7f2ace9a50c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardCertificateAuthorities", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d47909c1da82dcbec4153a83d4b289fcb63f1bcf123c37c80b0640f114edcd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tls13Support")
    def tls13_support(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tls13Support"))

    @tls13_support.setter
    def tls13_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31188dc477e00a7202603777f05d9cba2e775ca16074f9eccf3363e6383d7dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tls13Support", value)

    @builtins.property
    @jsii.member(jsii_name="tlsVersionTitle")
    def tls_version_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tlsVersionTitle"))

    @tls_version_title.setter
    def tls_version_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9396265a3fc6337f9309b053ef5c6e5013adb1f2c74cd7f36d691f6d882e1263)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsVersionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSetting")
    def true_client_ip_client_setting(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "trueClientIpClientSetting"))

    @true_client_ip_client_setting.setter
    def true_client_ip_client_setting(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ee76fed98ec95f7b7b9ac4b6b0bfc5f39203f923d285ea840185d1f96f02360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpClientSetting", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeader")
    def true_client_ip_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trueClientIpHeader"))

    @true_client_ip_header.setter
    def true_client_ip_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b69d29e766fa4202e281e4704cbeaeb1041fa9717269f2b97bb332fa1e7311b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpHeader", value)

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKey")
    def use_unique_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useUniqueCacheKey"))

    @use_unique_cache_key.setter
    def use_unique_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e06cebbb7b6872284684b6584bb8abb7092cf82e56835c294ce1dda93eb79bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useUniqueCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ca1e5fccc50247077f0ce1c69770a8b0455df0e915a666b1f925b30dc11b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationMode")
    def verification_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationMode"))

    @verification_mode.setter
    def verification_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8959621f99816350318c26622bcad05c12e8b1b01b0aa670a0d70df60e8698ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56c399c4fcd226957e921f0f2eadb46c59ced694985d838a3bba345153d109f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3a9e86931f30bcfff3e767abd8bdad574a763118e18fbf233850ed5fe04b5e8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdaptiveAcceleration")
    def put_adaptive_acceleration(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration(
            ab_logic=ab_logic,
            ab_testing=ab_testing,
            compression=compression,
            cookie_name=cookie_name,
            enable_brotli_compression=enable_brotli_compression,
            enable_for_noncacheable=enable_for_noncacheable,
            enable_preconnect=enable_preconnect,
            enable_push=enable_push,
            enable_ro=enable_ro,
            locked=locked,
            preload_enable=preload_enable,
            source=source,
            template_uuid=template_uuid,
            title_brotli=title_brotli,
            title_http2_server_push=title_http2_server_push,
            title_preconnect=title_preconnect,
            title_preload=title_preload,
            title_ro=title_ro,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveAcceleration", [value]))

    @jsii.member(jsii_name="putAdaptiveImageCompression")
    def put_adaptive_image_compression(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression(
            compress_mobile=compress_mobile,
            compress_standard=compress_standard,
            locked=locked,
            template_uuid=template_uuid,
            tier1_mobile_compression_method=tier1_mobile_compression_method,
            tier1_mobile_compression_value=tier1_mobile_compression_value,
            tier1_standard_compression_method=tier1_standard_compression_method,
            tier1_standard_compression_value=tier1_standard_compression_value,
            tier2_mobile_compression_method=tier2_mobile_compression_method,
            tier2_mobile_compression_value=tier2_mobile_compression_value,
            tier2_standard_compression_method=tier2_standard_compression_method,
            tier2_standard_compression_value=tier2_standard_compression_value,
            tier3_mobile_compression_method=tier3_mobile_compression_method,
            tier3_mobile_compression_value=tier3_mobile_compression_value,
            tier3_standard_compression_method=tier3_standard_compression_method,
            tier3_standard_compression_value=tier3_standard_compression_value,
            title_aic_mobile=title_aic_mobile,
            title_aic_nonmobile=title_aic_nonmobile,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveImageCompression", [value]))

    @jsii.member(jsii_name="putAdScalerCircuitBreaker")
    def put_ad_scaler_circuit_breaker(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker(
            fallback_action_response_code_based=fallback_action_response_code_based,
            locked=locked,
            response_code_based=response_code_based,
            response_codes=response_codes,
            response_delay_based=response_delay_based,
            response_delay_threshold=response_delay_threshold,
            return_error_response_code_based=return_error_response_code_based,
            specify_your_own_response_code_based=specify_your_own_response_code_based,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdScalerCircuitBreaker", [value]))

    @jsii.member(jsii_name="putAdvanced")
    def put_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvanced", [value]))

    @jsii.member(jsii_name="putAggregatedReporting")
    def put_aggregated_reporting(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting(
            attribute1=attribute1,
            attribute2=attribute2,
            attribute3=attribute3,
            attribute4=attribute4,
            attributes_count=attributes_count,
            enabled=enabled,
            locked=locked,
            report_name=report_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAggregatedReporting", [value]))

    @jsii.member(jsii_name="putAkamaizer")
    def put_akamaizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizer", [value]))

    @jsii.member(jsii_name="putAkamaizerTag")
    def put_akamaizer_tag(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag(
            include_tags_attribute=include_tags_attribute,
            locked=locked,
            match_hostname=match_hostname,
            replace_all=replace_all,
            replacement_hostname=replacement_hostname,
            scope=scope,
            tags_attribute=tags_attribute,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizerTag", [value]))

    @jsii.member(jsii_name="putAllHttpInCacheHierarchy")
    def put_all_http_in_cache_hierarchy(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllHttpInCacheHierarchy", [value]))

    @jsii.member(jsii_name="putAllowCloudletsOrigins")
    def put_allow_cloudlets_origins(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins(
            enabled=enabled,
            honor_base_directory=honor_base_directory,
            locked=locked,
            purge_origin_query_parameter=purge_origin_query_parameter,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowCloudletsOrigins", [value]))

    @jsii.member(jsii_name="putAllowDelete")
    def put_allow_delete(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete(
            allow_body=allow_body,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowDelete", [value]))

    @jsii.member(jsii_name="putAllowHttpsCacheKeySharing")
    def put_allow_https_cache_key_sharing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsCacheKeySharing", [value]))

    @jsii.member(jsii_name="putAllowHttpsDowngrade")
    def put_allow_https_downgrade(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsDowngrade", [value]))

    @jsii.member(jsii_name="putAllowOptions")
    def put_allow_options(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowOptions", [value]))

    @jsii.member(jsii_name="putAllowPatch")
    def put_allow_patch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPatch", [value]))

    @jsii.member(jsii_name="putAllowPost")
    def put_allow_post(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost(
            allow_without_content_length=allow_without_content_length,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPost", [value]))

    @jsii.member(jsii_name="putAllowPut")
    def put_allow_put(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPut", [value]))

    @jsii.member(jsii_name="putAllowTransferEncoding")
    def put_allow_transfer_encoding(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowTransferEncoding", [value]))

    @jsii.member(jsii_name="putAltSvcHeader")
    def put_alt_svc_header(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader(
            locked=locked, max_age=max_age, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAltSvcHeader", [value]))

    @jsii.member(jsii_name="putApiPrioritization")
    def put_api_prioritization(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization(
            alternate_response_cache_ttl=alternate_response_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            net_storage=net_storage,
            net_storage_path=net_storage_path,
            template_uuid=template_uuid,
            throttled_cp_code=throttled_cp_code,
            throttled_status_code=throttled_status_code,
            use_throttled_cp_code=use_throttled_cp_code,
            use_throttled_status_code=use_throttled_status_code,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApiPrioritization", [value]))

    @jsii.member(jsii_name="putApplicationLoadBalancer")
    def put_application_load_balancer(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer(
            all_down_net_storage=all_down_net_storage,
            all_down_net_storage_file=all_down_net_storage_file,
            all_down_status_code=all_down_status_code,
            all_down_title=all_down_title,
            allow_cache_prefresh=allow_cache_prefresh,
            cached_content_title=cached_content_title,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            failover_attempts_threshold=failover_attempts_threshold,
            failover_mode=failover_mode,
            failover_origin_map=failover_origin_map,
            failover_status_codes=failover_status_codes,
            failover_title=failover_title,
            label=label,
            locked=locked,
            origin_cookie_name=origin_cookie_name,
            specify_stickiness_cookie_domain=specify_stickiness_cookie_domain,
            stickiness_cookie_automatic_salt=stickiness_cookie_automatic_salt,
            stickiness_cookie_domain=stickiness_cookie_domain,
            stickiness_cookie_salt=stickiness_cookie_salt,
            stickiness_cookie_set_http_only_flag=stickiness_cookie_set_http_only_flag,
            stickiness_cookie_type=stickiness_cookie_type,
            stickiness_duration=stickiness_duration,
            stickiness_expiration_date=stickiness_expiration_date,
            stickiness_refresh=stickiness_refresh,
            stickiness_title=stickiness_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApplicationLoadBalancer", [value]))

    @jsii.member(jsii_name="putAudienceSegmentation")
    def put_audience_segmentation(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_automatic_salt=population_cookie_automatic_salt,
            population_cookie_domain=population_cookie_domain,
            population_cookie_include_rule_name=population_cookie_include_rule_name,
            population_cookie_salt=population_cookie_salt,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_refresh=population_refresh,
            population_title=population_title,
            segment_tracking_cookie_name=segment_tracking_cookie_name,
            segment_tracking_custom_header=segment_tracking_custom_header,
            segment_tracking_method=segment_tracking_method,
            segment_tracking_query_param=segment_tracking_query_param,
            segment_tracking_title=segment_tracking_title,
            specify_population_cookie_domain=specify_population_cookie_domain,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAudienceSegmentation", [value]))

    @jsii.member(jsii_name="putAutoDomainValidation")
    def put_auto_domain_validation(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation(
            autodv=autodv, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAutoDomainValidation", [value]))

    @jsii.member(jsii_name="putBaseDirectory")
    def put_base_directory(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putBaseDirectory", [value_]))

    @jsii.member(jsii_name="putBossBeaconing")
    def put_boss_beaconing(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing(
            conditional_error_pattern=conditional_error_pattern,
            conditional_http_status=conditional_http_status,
            conditional_sampling_frequency=conditional_sampling_frequency,
            cpcodes=cpcodes,
            enabled=enabled,
            forward_type=forward_type,
            locked=locked,
            request_type=request_type,
            sampling_frequency=sampling_frequency,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBossBeaconing", [value]))

    @jsii.member(jsii_name="putBreadcrumbs")
    def put_breadcrumbs(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs(
            enabled=enabled,
            locked=locked,
            logging_enabled=logging_enabled,
            opt_mode=opt_mode,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBreadcrumbs", [value]))

    @jsii.member(jsii_name="putBreakConnection")
    def put_break_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBreakConnection", [value]))

    @jsii.member(jsii_name="putBrotli")
    def put_brotli(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBrotli", [value]))

    @jsii.member(jsii_name="putCacheError")
    def put_cache_error(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError(
            enabled=enabled,
            locked=locked,
            preserve_stale=preserve_stale,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheError", [value]))

    @jsii.member(jsii_name="putCacheId")
    def put_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId(
            elements=elements,
            include_value=include_value,
            locked=locked,
            optional=optional,
            rule=rule,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheId", [value]))

    @jsii.member(jsii_name="putCacheKeyIgnoreCase")
    def put_cache_key_ignore_case(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyIgnoreCase", [value]))

    @jsii.member(jsii_name="putCacheKeyQueryParams")
    def put_cache_key_query_params(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams(
            behavior=behavior,
            exact_match=exact_match,
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyQueryParams", [value]))

    @jsii.member(jsii_name="putCacheKeyRewrite")
    def put_cache_key_rewrite(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite(
            locked=locked, purge_key=purge_key, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyRewrite", [value]))

    @jsii.member(jsii_name="putCachePost")
    def put_cache_post(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_body=use_body,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCachePost", [value]))

    @jsii.member(jsii_name="putCacheRedirect")
    def put_cache_redirect(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheRedirect", [value]))

    @jsii.member(jsii_name="putCacheTag")
    def put_cache_tag(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag(
            locked=locked, tag=tag, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTag", [value]))

    @jsii.member(jsii_name="putCacheTagVisible")
    def put_cache_tag_visible(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTagVisible", [value]))

    @jsii.member(jsii_name="putCaching")
    def put_caching(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching(
            behavior=behavior,
            cacheability_settings=cacheability_settings,
            cache_control_directives=cache_control_directives,
            default_ttl=default_ttl,
            enhanced_rfc_support=enhanced_rfc_support,
            expiration_settings=expiration_settings,
            honor_max_age=honor_max_age,
            honor_must_revalidate=honor_must_revalidate,
            honor_no_cache=honor_no_cache,
            honor_no_store=honor_no_store,
            honor_private=honor_private,
            honor_proxy_revalidate=honor_proxy_revalidate,
            honor_s_maxage=honor_s_maxage,
            locked=locked,
            must_revalidate=must_revalidate,
            revalidation_settings=revalidation_settings,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCaching", [value]))

    @jsii.member(jsii_name="putCentralAuthorization")
    def put_central_authorization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCentralAuthorization", [value]))

    @jsii.member(jsii_name="putChaseRedirects")
    def put_chase_redirects(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects(
            enabled=enabled,
            limit=limit,
            locked=locked,
            serve404=serve404,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChaseRedirects", [value]))

    @jsii.member(jsii_name="putClientCertificateAuth")
    def put_client_certificate_auth(
        self,
        *,
        client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param client_certificate_attributes: Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        :param enable: Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param enable_client_certificate_validation_status: Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        :param enable_complete_client_certificate: Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth(
            client_certificate_attributes=client_certificate_attributes,
            enable=enable,
            enable_client_certificate_validation_status=enable_client_certificate_validation_status,
            enable_complete_client_certificate=enable_complete_client_certificate,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificateAuth", [value]))

    @jsii.member(jsii_name="putClientCharacteristics")
    def put_client_characteristics(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics(
            country=country, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putClientCharacteristics", [value]))

    @jsii.member(jsii_name="putCloudInterconnects")
    def put_cloud_interconnects(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects(
            cloud_locations=cloud_locations,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudInterconnects", [value]))

    @jsii.member(jsii_name="putCloudWrapper")
    def put_cloud_wrapper(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper(
            enabled=enabled,
            location=location,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapper", [value]))

    @jsii.member(jsii_name="putCloudWrapperAdvanced")
    def put_cloud_wrapper_advanced(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced(
            custom_failover_map=custom_failover_map,
            enabled=enabled,
            failover_map=failover_map,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapperAdvanced", [value]))

    @jsii.member(jsii_name="putCommonMediaClientData")
    def put_common_media_client_data(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData(
            enable_cmcd_segment_prefetch=enable_cmcd_segment_prefetch,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCommonMediaClientData", [value]))

    @jsii.member(jsii_name="putConditionalOrigin")
    def put_conditional_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putConditionalOrigin", [value]))

    @jsii.member(jsii_name="putConstructResponse")
    def put_construct_response(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse(
            body=body,
            enabled=enabled,
            force_eviction=force_eviction,
            ignore_purge=ignore_purge,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putConstructResponse", [value]))

    @jsii.member(jsii_name="putContentCharacteristics")
    def put_content_characteristics(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristics", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsAmd")
    def put_content_characteristics_amd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_dash_custom=segment_duration_dash_custom,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hds_custom=segment_duration_hds_custom,
            segment_duration_hls=segment_duration_hls,
            segment_duration_hls_custom=segment_duration_hls_custom,
            segment_duration_smooth=segment_duration_smooth,
            segment_duration_smooth_custom=segment_duration_smooth_custom,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsAmd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsDd")
    def put_content_characteristics_dd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            optimize_option=optimize_option,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsDd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLargeFile")
    def put_content_characteristics_wsd_large_file(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLargeFile", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLive")
    def put_content_characteristics_wsd_live(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLive", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdVod")
    def put_content_characteristics_wsd_vod(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdVod", [value]))

    @jsii.member(jsii_name="putContentPrePosition")
    def put_content_pre_position(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition(
            enabled=enabled,
            first_location=first_location,
            locked=locked,
            second_location=second_location,
            source_type=source_type,
            targets=targets,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentPrePosition", [value]))

    @jsii.member(jsii_name="putContentTargetingProtection")
    def put_content_targeting_protection(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection(
            countries=countries,
            dmas=dmas,
            enabled=enabled,
            enable_geo_protection=enable_geo_protection,
            enable_geo_redirect_on_deny=enable_geo_redirect_on_deny,
            enable_ip_protection=enable_ip_protection,
            enable_ip_redirect_on_deny=enable_ip_redirect_on_deny,
            enable_referrer_protection=enable_referrer_protection,
            enable_referrer_redirect_on_deny=enable_referrer_redirect_on_deny,
            geo_protection_mode=geo_protection_mode,
            geo_protection_title=geo_protection_title,
            geo_redirect_url=geo_redirect_url,
            ip_addresses=ip_addresses,
            ip_protection_mode=ip_protection_mode,
            ip_protection_title=ip_protection_title,
            ip_redirect_url=ip_redirect_url,
            locked=locked,
            override_ip_addresses=override_ip_addresses,
            referrer_domains=referrer_domains,
            referrer_protection_mode=referrer_protection_mode,
            referrer_protection_title=referrer_protection_title,
            referrer_redirect_url=referrer_redirect_url,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentTargetingProtection", [value]))

    @jsii.member(jsii_name="putCorsSupport")
    def put_cors_support(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport(
            allow_credentials=allow_credentials,
            allow_headers=allow_headers,
            allow_origins=allow_origins,
            enabled=enabled,
            expose_headers=expose_headers,
            headers=headers,
            locked=locked,
            methods=methods,
            origins=origins,
            preflight_max_age=preflight_max_age,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCorsSupport", [value]))

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value_]))

    @jsii.member(jsii_name="putCustomBehavior")
    def put_custom_behavior(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior(
            behavior_id=behavior_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCustomBehavior", [value]))

    @jsii.member(jsii_name="putDatastream")
    def put_datastream(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream(
            beacon_stream_title=beacon_stream_title,
            collect_midgress_traffic=collect_midgress_traffic,
            datastream_ids=datastream_ids,
            enabled=enabled,
            locked=locked,
            log_enabled=log_enabled,
            log_stream_name=log_stream_name,
            log_stream_title=log_stream_title,
            sampling_percentage=sampling_percentage,
            stream_type=stream_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDatastream", [value]))

    @jsii.member(jsii_name="putDcp")
    def put_dcp(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp(
            anonymous=anonymous,
            enabled=enabled,
            gwenabled=gwenabled,
            locked=locked,
            namespace_id=namespace_id,
            template_uuid=template_uuid,
            tlsenabled=tlsenabled,
            uuid=uuid,
            wsenabled=wsenabled,
        )

        return typing.cast(None, jsii.invoke(self, "putDcp", [value]))

    @jsii.member(jsii_name="putDcpAuthHmacTransformation")
    def put_dcp_auth_hmac_transformation(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation(
            hash_conversion_algorithm=hash_conversion_algorithm,
            hash_conversion_key=hash_conversion_key,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthHmacTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthRegexTransformation")
    def put_dcp_auth_regex_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation(
            locked=locked,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthRegexTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthSubstringTransformation")
    def put_dcp_auth_substring_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation(
            locked=locked,
            substring_end=substring_end,
            substring_start=substring_start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthSubstringTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthVariableExtractor")
    def put_dcp_auth_variable_extractor(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor(
            certificate_field=certificate_field,
            dcp_mutual_auth_processing_variable_id=dcp_mutual_auth_processing_variable_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthVariableExtractor", [value]))

    @jsii.member(jsii_name="putDcpDefaultAuthzGroups")
    def put_dcp_default_authz_groups(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups(
            group_names=group_names,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDefaultAuthzGroups", [value]))

    @jsii.member(jsii_name="putDcpDevRelations")
    def put_dcp_dev_relations(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations(
            custom_values=custom_values,
            enabled=enabled,
            hostname=hostname,
            locked=locked,
            path=path,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDevRelations", [value]))

    @jsii.member(jsii_name="putDcpRealTimeAuth")
    def put_dcp_real_time_auth(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth(
            extract_hostname=extract_hostname,
            extract_jurisdiction=extract_jurisdiction,
            extract_namespace=extract_namespace,
            hostname_claim=hostname_claim,
            jurisdiction_claim=jurisdiction_claim,
            locked=locked,
            namespace_claim=namespace_claim,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpRealTimeAuth", [value]))

    @jsii.member(jsii_name="putDeliveryReceipt")
    def put_delivery_receipt(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeliveryReceipt", [value]))

    @jsii.member(jsii_name="putDenyAccess")
    def put_deny_access(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess(
            enabled=enabled,
            locked=locked,
            reason=reason,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDenyAccess", [value]))

    @jsii.member(jsii_name="putDenyDirectFailoverAccess")
    def put_deny_direct_failover_access(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDenyDirectFailoverAccess", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicCacheId")
    def put_device_characteristic_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicCacheId", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicHeader")
    def put_device_characteristic_header(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicHeader", [value]))

    @jsii.member(jsii_name="putDnsAsyncRefresh")
    def put_dns_async_refresh(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsAsyncRefresh", [value]))

    @jsii.member(jsii_name="putDnsPrefresh")
    def put_dns_prefresh(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh(
            delay=delay,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsPrefresh", [value]))

    @jsii.member(jsii_name="putDowngradeProtocol")
    def put_downgrade_protocol(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDowngradeProtocol", [value]))

    @jsii.member(jsii_name="putDownloadCompleteMarker")
    def put_download_complete_marker(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadCompleteMarker", [value]))

    @jsii.member(jsii_name="putDownloadNotification")
    def put_download_notification(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadNotification", [value]))

    @jsii.member(jsii_name="putDownstreamCache")
    def put_downstream_cache(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache(
            allow_behavior=allow_behavior,
            behavior=behavior,
            locked=locked,
            send_headers=send_headers,
            send_private=send_private,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDownstreamCache", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimization")
    def put_dynamic_throughtput_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimization", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimizationOverride")
    def put_dynamic_throughtput_optimization_override(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride(
            locked=locked,
            template_uuid=template_uuid,
            throughput=throughput,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimizationOverride", [value]))

    @jsii.member(jsii_name="putDynamicWebContent")
    def put_dynamic_web_content(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent(
            image_compression=image_compression,
            locked=locked,
            prefetch=prefetch,
            real_user_monitoring=real_user_monitoring,
            sure_route=sure_route,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicWebContent", [value]))

    @jsii.member(jsii_name="putEcmsBulkUpload")
    def put_ecms_bulk_upload(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsBulkUpload", [value]))

    @jsii.member(jsii_name="putEcmsDatabase")
    def put_ecms_database(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase(
            database=database,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDatabase", [value]))

    @jsii.member(jsii_name="putEcmsDataset")
    def put_ecms_dataset(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset(
            dataset=dataset,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDataset", [value]))

    @jsii.member(jsii_name="putEcmsObjectKey")
    def put_ecms_object_key(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey(
            locked=locked, regex=regex, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsObjectKey", [value]))

    @jsii.member(jsii_name="putEdgeConnect")
    def put_edge_connect(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect(
            aggregate_lines=aggregate_lines,
            aggregate_size=aggregate_size,
            aggregate_time=aggregate_time,
            api_connector=api_connector,
            api_data_elements=api_data_elements,
            destination_hostname=destination_hostname,
            destination_path=destination_path,
            enabled=enabled,
            locked=locked,
            override_aggregate_settings=override_aggregate_settings,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeConnect", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingAdvanced")
    def put_edge_load_balancing_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingAdvanced", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingDataCenter")
    def put_edge_load_balancing_data_center(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter(
            cookie_name=cookie_name,
            description=description,
            enable_failover=enable_failover,
            failover_rules=failover_rules,
            failover_title=failover_title,
            hostname=hostname,
            ip=ip,
            locked=locked,
            origin_id=origin_id,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingDataCenter", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingOrigin")
    def put_edge_load_balancing_origin(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin(
            cookie_name=cookie_name,
            description=description,
            enable_session_persistence=enable_session_persistence,
            hostname=hostname,
            id=id,
            locked=locked,
            session_persistence_title=session_persistence_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingOrigin", [value]))

    @jsii.member(jsii_name="putEdgeOriginAuthorization")
    def put_edge_origin_authorization(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization(
            cookie_name=cookie_name,
            domain=domain,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeOriginAuthorization", [value_]))

    @jsii.member(jsii_name="putEdgeRedirector")
    def put_edge_redirector(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeRedirector", [value]))

    @jsii.member(jsii_name="putEdgeScape")
    def put_edge_scape(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeScape", [value]))

    @jsii.member(jsii_name="putEdgeSideIncludes")
    def put_edge_side_includes(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes(
            detect_injection=detect_injection,
            enabled=enabled,
            enable_via_http=enable_via_http,
            i18_n_charset=i18_n_charset,
            i18_n_status=i18_n_status,
            locked=locked,
            pass_client_ip=pass_client_ip,
            pass_set_cookie=pass_set_cookie,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeSideIncludes", [value]))

    @jsii.member(jsii_name="putEdgeWorker")
    def put_edge_worker(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse_information: typing.Optional[builtins.str] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param m_pulse: Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see ``Integrate mPulse reports with EdgeWorkers``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param m_pulse_information: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker(
            create_edge_worker=create_edge_worker,
            edge_worker_id=edge_worker_id,
            enabled=enabled,
            locked=locked,
            m_pulse=m_pulse,
            m_pulse_information=m_pulse_information,
            resource_tier=resource_tier,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorker", [value]))

    @jsii.member(jsii_name="putEnforceMtlsSettings")
    def put_enforce_mtls_settings(
        self,
        *,
        certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_authority_set: Specify the client certificate authority (CA) sets you want to support in client requests. Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        :param enable_auth_set: Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        :param enable_deny_request: This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        :param enable_ocsp_status: Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings(
            certificate_authority_set=certificate_authority_set,
            enable_auth_set=enable_auth_set,
            enable_deny_request=enable_deny_request,
            enable_ocsp_status=enable_ocsp_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEnforceMtlsSettings", [value]))

    @jsii.member(jsii_name="putEnhancedAkamaiProtocol")
    def put_enhanced_akamai_protocol(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedAkamaiProtocol", [value]))

    @jsii.member(jsii_name="putEnhancedProxyDetection")
    def put_enhanced_proxy_detection(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection(
            anonymous_vpn=anonymous_vpn,
            best_practice_action=best_practice_action,
            best_practice_redirecturl=best_practice_redirecturl,
            detect_anonymous_vpn=detect_anonymous_vpn,
            detect_anonymous_vpn_action=detect_anonymous_vpn_action,
            detect_anonymous_vpn_redirecturl=detect_anonymous_vpn_redirecturl,
            detect_hosting_provider=detect_hosting_provider,
            detect_hosting_provider_action=detect_hosting_provider_action,
            detect_hosting_provider_redirecturl=detect_hosting_provider_redirecturl,
            detect_public_proxy=detect_public_proxy,
            detect_public_proxy_action=detect_public_proxy_action,
            detect_public_proxy_redirecturl=detect_public_proxy_redirecturl,
            detect_residential_proxy=detect_residential_proxy,
            detect_residential_proxy_action=detect_residential_proxy_action,
            detect_residential_proxy_redirecturl=detect_residential_proxy_redirecturl,
            detect_smart_dns_proxy=detect_smart_dns_proxy,
            detect_smart_dns_proxy_action=detect_smart_dns_proxy_action,
            detect_smart_dns_proxy_redirecturl=detect_smart_dns_proxy_redirecturl,
            detect_tor_exit_node=detect_tor_exit_node,
            detect_tor_exit_node_action=detect_tor_exit_node_action,
            detect_tor_exit_node_redirecturl=detect_tor_exit_node_redirecturl,
            detect_vpn_data_center=detect_vpn_data_center,
            detect_vpn_data_center_action=detect_vpn_data_center_action,
            detect_vpn_data_center_redirecturl=detect_vpn_data_center_redirecturl,
            enable_configuration_mode=enable_configuration_mode,
            enabled=enabled,
            forward_header_enrichment=forward_header_enrichment,
            hosting_provider=hosting_provider,
            locked=locked,
            public_proxy=public_proxy,
            residential_proxy=residential_proxy,
            smart_dns_proxy=smart_dns_proxy,
            template_uuid=template_uuid,
            tor_exit_node=tor_exit_node,
            uuid=uuid,
            vpn_data_center=vpn_data_center,
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedProxyDetection", [value]))

    @jsii.member(jsii_name="putEpdForwardHeaderEnrichment")
    def put_epd_forward_header_enrichment(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEpdForwardHeaderEnrichment", [value]))

    @jsii.member(jsii_name="putFailAction")
    def put_fail_action(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction(
            action_type=action_type,
            allow_fcm_parent_override=allow_fcm_parent_override,
            cex_custom_path=cex_custom_path,
            cex_hostname=cex_hostname,
            cex_path=cex_path,
            content_custom_path=content_custom_path,
            content_hostname=content_hostname,
            content_path=content_path,
            cp_code=cp_code,
            dynamic_custom_path=dynamic_custom_path,
            dynamic_method=dynamic_method,
            dynamic_path=dynamic_path,
            enabled=enabled,
            locked=locked,
            modify_protocol=modify_protocol,
            net_storage_hostname=net_storage_hostname,
            net_storage_path=net_storage_path,
            preserve_query_string=preserve_query_string,
            protocol=protocol,
            redirect_custom_path=redirect_custom_path,
            redirect_hostname=redirect_hostname,
            redirect_hostname_type=redirect_hostname_type,
            redirect_method=redirect_method,
            redirect_path=redirect_path,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailAction", [value]))

    @jsii.member(jsii_name="putFailoverBotManagerFeatureCompatibility")
    def put_failover_bot_manager_feature_compatibility(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility(
            compatibility=compatibility,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailoverBotManagerFeatureCompatibility", [value]))

    @jsii.member(jsii_name="putFastInvalidate")
    def put_fast_invalidate(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFastInvalidate", [value]))

    @jsii.member(jsii_name="putFips")
    def put_fips(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFips", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketing")
    def put_first_party_marketing(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketing", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketingPlus")
    def put_first_party_marketing_plus(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketingPlus", [value]))

    @jsii.member(jsii_name="putForwardRewrite")
    def put_forward_rewrite(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putForwardRewrite", [value]))

    @jsii.member(jsii_name="putG2Oheader")
    def put_g2_oheader(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader(
            custom_sign_string=custom_sign_string,
            data_header=data_header,
            enabled=enabled,
            encoding_version=encoding_version,
            locked=locked,
            nonce=nonce,
            secret_key=secret_key,
            signed_header=signed_header,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putG2Oheader", [value]))

    @jsii.member(jsii_name="putGlobalRequestNumber")
    def put_global_request_number(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber(
            header_name=header_name,
            locked=locked,
            output_option=output_option,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putGlobalRequestNumber", [value]))

    @jsii.member(jsii_name="putGraphqlCaching")
    def put_graphql_caching(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching(
            advanced=advanced,
            cache_responses_with_errors=cache_responses_with_errors,
            enabled=enabled,
            locked=locked,
            operations_json_body_parameter_name=operations_json_body_parameter_name,
            operations_url_query_parameter_name=operations_url_query_parameter_name,
            post_request_processing_error_handling=post_request_processing_error_handling,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putGraphqlCaching", [value]))

    @jsii.member(jsii_name="putGzipResponse")
    def put_gzip_response(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putGzipResponse", [value]))

    @jsii.member(jsii_name="putHdDataAdvanced")
    def put_hd_data_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putHdDataAdvanced", [value]))

    @jsii.member(jsii_name="putHealthDetection")
    def put_health_detection(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection(
            locked=locked,
            maximum_reconnects=maximum_reconnects,
            retry_count=retry_count,
            retry_interval=retry_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHealthDetection", [value]))

    @jsii.member(jsii_name="putHsafEipBinding")
    def put_hsaf_eip_binding(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding(
            custom_extracted_serial=custom_extracted_serial,
            enabled=enabled,
            hash_max_value=hash_max_value,
            hash_min_value=hash_min_value,
            locked=locked,
            template_uuid=template_uuid,
            tier=tier,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHsafEipBinding", [value]))

    @jsii.member(jsii_name="putHttp2")
    def put_http2(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp2", [value]))

    @jsii.member(jsii_name="putHttp3")
    def put_http3(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp3", [value]))

    @jsii.member(jsii_name="putHttpStrictTransportSecurity")
    def put_http_strict_transport_security(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity(
            enable=enable,
            include_sub_domains=include_sub_domains,
            locked=locked,
            max_age=max_age,
            preload=preload,
            redirect=redirect,
            redirect_status_code=redirect_status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHttpStrictTransportSecurity", [value]))

    @jsii.member(jsii_name="putHttpToHttpsUpgrade")
    def put_http_to_https_upgrade(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade(
            locked=locked, template_uuid=template_uuid, upgrade=upgrade, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttpToHttpsUpgrade", [value]))

    @jsii.member(jsii_name="putImageAndVideoManager")
    def put_image_and_video_manager(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager(
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            image_set=image_set,
            locked=locked,
            policy_set_type=policy_set_type,
            resize=resize,
            template_uuid=template_uuid,
            uuid=uuid,
            video_set=video_set,
        )

        return typing.cast(None, jsii.invoke(self, "putImageAndVideoManager", [value]))

    @jsii.member(jsii_name="putImageManager")
    def put_image_manager(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManager", [value]))

    @jsii.member(jsii_name="putImageManagerVideo")
    def put_image_manager_video(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManagerVideo", [value]))

    @jsii.member(jsii_name="putImOverride")
    def put_im_override(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride(
            dpr=dpr,
            dprvar=dprvar,
            exclude_all_query_parameters=exclude_all_query_parameters,
            excluded_query_parameters=excluded_query_parameters,
            format=format,
            formatvar=formatvar,
            locked=locked,
            override=override,
            policy=policy,
            policyvar=policyvar,
            policyvar_i_mvar=policyvar_i_mvar,
            policyvar_name=policyvar_name,
            template_uuid=template_uuid,
            typesel=typesel,
            uuid=uuid,
            width=width,
            widthvar=widthvar,
        )

        return typing.cast(None, jsii.invoke(self, "putImOverride", [value]))

    @jsii.member(jsii_name="putInclude")
    def put_include(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude(
            id=id, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInclude", [value]))

    @jsii.member(jsii_name="putInstant")
    def put_instant(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant(
            custom_link_relations=custom_link_relations,
            locked=locked,
            prefetch_cacheable=prefetch_cacheable,
            prefetch_html=prefetch_html,
            prefetch_no_store=prefetch_no_store,
            prefetch_no_store_extensions=prefetch_no_store_extensions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putInstant", [value]))

    @jsii.member(jsii_name="putInstantConfig")
    def put_instant_config(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInstantConfig", [value]))

    @jsii.member(jsii_name="putLargeFileOptimization")
    def put_large_file_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization(
            enabled=enabled,
            enable_partial_object_caching=enable_partial_object_caching,
            locked=locked,
            maximum_size=maximum_size,
            minimum_size=minimum_size,
            template_uuid=template_uuid,
            use_versioning=use_versioning,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimization", [value]))

    @jsii.member(jsii_name="putLargeFileOptimizationAdvanced")
    def put_large_file_optimization_advanced(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced(
            enabled=enabled,
            fragment_size=fragment_size,
            locked=locked,
            object_size=object_size,
            prefetch_after_request=prefetch_after_request,
            prefetch_during_request=prefetch_during_request,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimizationAdvanced", [value]))

    @jsii.member(jsii_name="putLimitBitRate")
    def put_limit_bit_rate(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate(
            bitrate_table=bitrate_table,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            threshold_table=threshold_table,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLimitBitRate", [value]))

    @jsii.member(jsii_name="putLogCustom")
    def put_log_custom(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom(
            custom_log_field=custom_log_field,
            locked=locked,
            log_custom_log_field=log_custom_log_field,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLogCustom", [value]))

    @jsii.member(jsii_name="putManifestPersonalization")
    def put_manifest_personalization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization(
            enabled=enabled,
            hls_enabled=hls_enabled,
            hls_enable_debug_headers=hls_enable_debug_headers,
            hls_filter_in_bitrate_ranges=hls_filter_in_bitrate_ranges,
            hls_filter_in_bitrates=hls_filter_in_bitrates,
            hls_mode=hls_mode,
            hls_preferred_bitrate=hls_preferred_bitrate,
            hls_query_param_enabled=hls_query_param_enabled,
            hls_query_param_secret_key=hls_query_param_secret_key,
            hls_query_param_transition_key=hls_query_param_transition_key,
            hls_show_advanced=hls_show_advanced,
            hls_title=hls_title,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestPersonalization", [value]))

    @jsii.member(jsii_name="putManifestRerouting")
    def put_manifest_rerouting(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting(
            locked=locked,
            partner=partner,
            template_uuid=template_uuid,
            username=username,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestRerouting", [value]))

    @jsii.member(jsii_name="putManualServerPush")
    def put_manual_server_push(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush(
            locked=locked,
            serverpushlist=serverpushlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManualServerPush", [value]))

    @jsii.member(jsii_name="putMediaAcceleration")
    def put_media_acceleration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAcceleration", [value]))

    @jsii.member(jsii_name="putMediaAccelerationQuicOptout")
    def put_media_acceleration_quic_optout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout(
            locked=locked, optout=optout, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAccelerationQuicOptout", [value]))

    @jsii.member(jsii_name="putMediaClient")
    def put_media_client(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient(
            beacon_id=beacon_id,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_hybrid_http_udp=use_hybrid_http_udp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaClient", [value]))

    @jsii.member(jsii_name="putMediaFileRetrievalOptimization")
    def put_media_file_retrieval_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaFileRetrievalOptimization", [value]))

    @jsii.member(jsii_name="putMediaOriginFailover")
    def put_media_origin_failover(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover(
            cache_error_response=cache_error_response,
            cache_window=cache_window,
            client_response_code=client_response_code,
            detect_object_unavailable=detect_object_unavailable,
            detect_object_unavailable_title=detect_object_unavailable_title,
            detect_origin_unavailable=detect_origin_unavailable,
            detect_origin_unavailable_title=detect_origin_unavailable_title,
            detect_origin_unresponsive=detect_origin_unresponsive,
            detect_origin_unresponsive_title=detect_origin_unresponsive_title,
            locked=locked,
            object_unavailable_alternate_host=object_unavailable_alternate_host,
            object_unavailable_backup_host=object_unavailable_backup_host,
            object_unavailable_blacklist_origin_ip=object_unavailable_blacklist_origin_ip,
            object_unavailable_blacklist_window=object_unavailable_blacklist_window,
            object_unavailable_change_protocol=object_unavailable_change_protocol,
            object_unavailable_detection_level=object_unavailable_detection_level,
            object_unavailable_include_query_string=object_unavailable_include_query_string,
            object_unavailable_modified_path=object_unavailable_modified_path,
            object_unavailable_modify_request_path=object_unavailable_modify_request_path,
            object_unavailable_protocol=object_unavailable_protocol,
            object_unavailable_recovery=object_unavailable_recovery,
            object_unavailable_redirect_method=object_unavailable_redirect_method,
            object_unavailable_response_codes=object_unavailable_response_codes,
            object_unavailable_retry_limit=object_unavailable_retry_limit,
            origin_unavailable_alternate_host=origin_unavailable_alternate_host,
            origin_unavailable_backup_host=origin_unavailable_backup_host,
            origin_unavailable_blacklist_origin_ip=origin_unavailable_blacklist_origin_ip,
            origin_unavailable_blacklist_window=origin_unavailable_blacklist_window,
            origin_unavailable_change_protocol=origin_unavailable_change_protocol,
            origin_unavailable_detection_level=origin_unavailable_detection_level,
            origin_unavailable_include_query_string=origin_unavailable_include_query_string,
            origin_unavailable_modified_path=origin_unavailable_modified_path,
            origin_unavailable_modify_request_path=origin_unavailable_modify_request_path,
            origin_unavailable_protocol=origin_unavailable_protocol,
            origin_unavailable_recovery=origin_unavailable_recovery,
            origin_unavailable_redirect_method=origin_unavailable_redirect_method,
            origin_unavailable_response_codes=origin_unavailable_response_codes,
            origin_unavailable_retry_limit=origin_unavailable_retry_limit,
            origin_unresponsive_alternate_host=origin_unresponsive_alternate_host,
            origin_unresponsive_backup_host=origin_unresponsive_backup_host,
            origin_unresponsive_blacklist_origin_ip=origin_unresponsive_blacklist_origin_ip,
            origin_unresponsive_blacklist_window=origin_unresponsive_blacklist_window,
            origin_unresponsive_change_protocol=origin_unresponsive_change_protocol,
            origin_unresponsive_detection_level=origin_unresponsive_detection_level,
            origin_unresponsive_include_query_string=origin_unresponsive_include_query_string,
            origin_unresponsive_modified_path=origin_unresponsive_modified_path,
            origin_unresponsive_modify_request_path=origin_unresponsive_modify_request_path,
            origin_unresponsive_protocol=origin_unresponsive_protocol,
            origin_unresponsive_recovery=origin_unresponsive_recovery,
            origin_unresponsive_redirect_method=origin_unresponsive_redirect_method,
            origin_unresponsive_retry_limit=origin_unresponsive_retry_limit,
            other_options=other_options,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaOriginFailover", [value]))

    @jsii.member(jsii_name="putMetadataCaching")
    def put_metadata_caching(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataCaching", [value]))

    @jsii.member(jsii_name="putMobileSdkPerformance")
    def put_mobile_sdk_performance(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance(
            enabled=enabled,
            locked=locked,
            secondary_multipath_to_origin=secondary_multipath_to_origin,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMobileSdkPerformance", [value]))

    @jsii.member(jsii_name="putModifyIncomingRequestHeader")
    def put_modify_incoming_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyIncomingResponseHeader")
    def put_modify_incoming_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingRequestHeader")
    def put_modify_outgoing_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingResponseHeader")
    def put_modify_outgoing_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyViaHeader")
    def put_modify_via_header(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader(
            enabled=enabled,
            locked=locked,
            modification_option=modification_option,
            rename_header_to=rename_header_to,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyViaHeader", [value]))

    @jsii.member(jsii_name="putMPulse")
    def put_m_pulse(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse(
            api_key=api_key,
            buffer_size=buffer_size,
            config_override=config_override,
            enabled=enabled,
            loader_version=loader_version,
            locked=locked,
            require_pci=require_pci,
            template_uuid=template_uuid,
            title_optional=title_optional,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMPulse", [value]))

    @jsii.member(jsii_name="putOrigin")
    def put_origin(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_tls_version: typing.Optional[builtins.str] = None,
        min_tls_version: typing.Optional[builtins.str] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tls_version_title: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_tls_version: Specifies the maximum TLS version to use for connections to your origin server. As best practice, use ``DYNAMIC`` to automatically apply the latest supported version. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        :param min_tls_version: Specifies the minimum TLS version to use for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tls13_support: Enables transport layer security (TLS) version 1.3 for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        :param tls_version_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin(
            cache_key_hostname=cache_key_hostname,
            compress=compress,
            custom_certificate_authorities=custom_certificate_authorities,
            custom_certificates=custom_certificates,
            custom_forward_host_header=custom_forward_host_header,
            custom_valid_cn_values=custom_valid_cn_values,
            enable_true_client_ip=enable_true_client_ip,
            forward_host_header=forward_host_header,
            hostname=hostname,
            http_port=http_port,
            https_port=https_port,
            ip_version=ip_version,
            locked=locked,
            max_tls_version=max_tls_version,
            min_tls_version=min_tls_version,
            mslorigin=mslorigin,
            net_storage=net_storage,
            origin_certificate=origin_certificate,
            origin_certs_to_honor=origin_certs_to_honor,
            origin_id=origin_id,
            origin_sni=origin_sni,
            origin_type=origin_type,
            ports=ports,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            second_hostname=second_hostname,
            second_hostname_enabled=second_hostname_enabled,
            standard_certificate_authorities=standard_certificate_authorities,
            template_uuid=template_uuid,
            tls13_support=tls13_support,
            tls_version_title=tls_version_title,
            true_client_ip_client_setting=true_client_ip_client_setting,
            true_client_ip_header=true_client_ip_header,
            use_unique_cache_key=use_unique_cache_key,
            uuid=uuid,
            verification_mode=verification_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putOrigin", [value]))

    @jsii.member(jsii_name="putOriginCharacteristics")
    def put_origin_characteristics(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics(
            access_key_encrypted_storage=access_key_encrypted_storage,
            adc_title=adc_title,
            authentication_method=authentication_method,
            authentication_method_title=authentication_method_title,
            aws_access_key_id=aws_access_key_id,
            aws_access_key_version_guid=aws_access_key_version_guid,
            aws_ar_region=aws_ar_region,
            aws_host=aws_host,
            aws_region=aws_region,
            aws_secret_access_key=aws_secret_access_key,
            aws_service=aws_service,
            country=country,
            custom_sign_string=custom_sign_string,
            direct_connect_geo=direct_connect_geo,
            encoding_version=encoding_version,
            end_point_service=end_point_service,
            gcs_access_key_version_guid=gcs_access_key_version_guid,
            gcs_hmac_key_access_id=gcs_hmac_key_access_id,
            gcs_hmac_key_secret=gcs_hmac_key_secret,
            hostname_tag=hostname_tag,
            locked=locked,
            mslkey=mslkey,
            mslname=mslname,
            nonce=nonce,
            origin_location_title=origin_location_title,
            property_id_tag=property_id_tag,
            role_arn=role_arn,
            secret_key=secret_key,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristics", [value]))

    @jsii.member(jsii_name="putOriginCharacteristicsWsd")
    def put_origin_characteristics_wsd(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd(
            locked=locked,
            origintype=origintype,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristicsWsd", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryMethod")
    def put_origin_failure_recovery_method(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod(
            custom_status_code=custom_status_code,
            locked=locked,
            recovery_method=recovery_method,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryMethod", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryPolicy")
    def put_origin_failure_recovery_policy(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy(
            binary_equivalent_content=binary_equivalent_content,
            enabled=enabled,
            enable_ip_avoidance=enable_ip_avoidance,
            ip_avoidance_error_threshold=ip_avoidance_error_threshold,
            ip_avoidance_retry_interval=ip_avoidance_retry_interval,
            locked=locked,
            monitor_origin_responsiveness=monitor_origin_responsiveness,
            monitor_response_codes1=monitor_response_codes1,
            monitor_response_codes2=monitor_response_codes2,
            monitor_response_codes3=monitor_response_codes3,
            monitor_status_codes1=monitor_status_codes1,
            monitor_status_codes1_enable_recovery=monitor_status_codes1_enable_recovery,
            monitor_status_codes1_enable_retry=monitor_status_codes1_enable_retry,
            monitor_status_codes1_recovery_config_name=monitor_status_codes1_recovery_config_name,
            monitor_status_codes2=monitor_status_codes2,
            monitor_status_codes2_enable_recovery=monitor_status_codes2_enable_recovery,
            monitor_status_codes2_enable_retry=monitor_status_codes2_enable_retry,
            monitor_status_codes2_recovery_config_name=monitor_status_codes2_recovery_config_name,
            monitor_status_codes3=monitor_status_codes3,
            monitor_status_codes3_enable_recovery=monitor_status_codes3_enable_recovery,
            monitor_status_codes3_enable_retry=monitor_status_codes3_enable_retry,
            monitor_status_codes3_recovery_config_name=monitor_status_codes3_recovery_config_name,
            origin_responsiveness_custom_timeout=origin_responsiveness_custom_timeout,
            origin_responsiveness_enable_recovery=origin_responsiveness_enable_recovery,
            origin_responsiveness_enable_retry=origin_responsiveness_enable_retry,
            origin_responsiveness_monitoring=origin_responsiveness_monitoring,
            origin_responsiveness_recovery_config_name=origin_responsiveness_recovery_config_name,
            origin_responsiveness_timeout=origin_responsiveness_timeout,
            status_code_monitoring1=status_code_monitoring1,
            status_code_monitoring2=status_code_monitoring2,
            status_code_monitoring3=status_code_monitoring3,
            template_uuid=template_uuid,
            tuning_parameters=tuning_parameters,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryPolicy", [value]))

    @jsii.member(jsii_name="putOriginIpAcl")
    def put_origin_ip_acl(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putOriginIpAcl", [value]))

    @jsii.member(jsii_name="putPermissionsPolicy")
    def put_permissions_policy(
        self,
        *,
        allow_list: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_list: The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here. They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param permissions_policy_directive: Each directive represents a browser feature. Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy(
            allow_list=allow_list,
            locked=locked,
            permissions_policy_directive=permissions_policy_directive,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPermissionsPolicy", [value]))

    @jsii.member(jsii_name="putPersistentClientConnection")
    def put_persistent_client_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentClientConnection", [value]))

    @jsii.member(jsii_name="putPersistentConnection")
    def put_persistent_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentConnection", [value]))

    @jsii.member(jsii_name="putPersonallyIdentifiableInformation")
    def put_personally_identifiable_information(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPersonallyIdentifiableInformation", [value]))

    @jsii.member(jsii_name="putPhasedRelease")
    def put_phased_release(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            failover_duration=failover_duration,
            failover_enabled=failover_enabled,
            failover_response_code=failover_response_code,
            failover_title=failover_title,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_expiration_date=population_expiration_date,
            population_refresh=population_refresh,
            population_title=population_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPhasedRelease", [value]))

    @jsii.member(jsii_name="putPreconnect")
    def put_preconnect(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect(
            locked=locked,
            preconnectlist=preconnectlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPreconnect", [value]))

    @jsii.member(jsii_name="putPredictiveContentDelivery")
    def put_predictive_content_delivery(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPredictiveContentDelivery", [value]))

    @jsii.member(jsii_name="putPredictivePrefetching")
    def put_predictive_prefetching(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching(
            accuracy_target=accuracy_target,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPredictivePrefetching", [value]))

    @jsii.member(jsii_name="putPrefetch")
    def put_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetch", [value]))

    @jsii.member(jsii_name="putPrefetchable")
    def put_prefetchable(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetchable", [value]))

    @jsii.member(jsii_name="putPrefreshCache")
    def put_prefresh_cache(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache(
            enabled=enabled,
            locked=locked,
            prefreshval=prefreshval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPrefreshCache", [value]))

    @jsii.member(jsii_name="putQuality")
    def put_quality(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality(
            audience_settings=audience_settings,
            catalog_size=catalog_size,
            content_settings=content_settings,
            content_type=content_type,
            country=country,
            delivery_format=delivery_format,
            delivery_type=delivery_type,
            download_type=download_type,
            end_user_location=end_user_location,
            locked=locked,
            maximum_concurrent_users=maximum_concurrent_users,
            object_size=object_size,
            optimize_for=optimize_for,
            origin_settings=origin_settings,
            popularity_distribution=popularity_distribution,
            refresh_rate=refresh_rate,
            segment_duration=segment_duration,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuality", [value]))

    @jsii.member(jsii_name="putQuicBeta")
    def put_quic_beta(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta(
            enabled=enabled,
            locked=locked,
            quic_offer_percentage=quic_offer_percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuicBeta", [value]))

    @jsii.member(jsii_name="putRandomSeek")
    def put_random_seek(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek(
            flv=flv,
            locked=locked,
            maximum_size=maximum_size,
            mp4=mp4,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRandomSeek", [value]))

    @jsii.member(jsii_name="putRapid")
    def put_rapid(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRapid", [value]))

    @jsii.member(jsii_name="putReadTimeout")
    def put_read_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putReadTimeout", [value_]))

    @jsii.member(jsii_name="putRealTimeReporting")
    def put_real_time_reporting(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting(
            advanced=advanced,
            beacon_sampling_percentage=beacon_sampling_percentage,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRealTimeReporting", [value]))

    @jsii.member(jsii_name="putRealUserMonitoring")
    def put_real_user_monitoring(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRealUserMonitoring", [value]))

    @jsii.member(jsii_name="putRedirect")
    def put_redirect(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect(
            destination_hostname=destination_hostname,
            destination_hostname_other=destination_hostname_other,
            destination_hostname_sibling=destination_hostname_sibling,
            destination_hostname_subdomain=destination_hostname_subdomain,
            destination_path=destination_path,
            destination_path_other=destination_path_other,
            destination_path_prefix=destination_path_prefix,
            destination_path_suffix=destination_path_suffix,
            destination_path_suffix_status=destination_path_suffix_status,
            destination_protocol=destination_protocol,
            locked=locked,
            mobile_default_choice=mobile_default_choice,
            query_string=query_string,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirect", [value]))

    @jsii.member(jsii_name="putRedirectplus")
    def put_redirectplus(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus(
            destination=destination,
            enabled=enabled,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirectplus", [value]))

    @jsii.member(jsii_name="putRefererChecking")
    def put_referer_checking(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking(
            allow_children=allow_children,
            domains=domains,
            enabled=enabled,
            locked=locked,
            strict=strict,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRefererChecking", [value]))

    @jsii.member(jsii_name="putRemoveQueryParameter")
    def put_remove_query_parameter(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter(
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveQueryParameter", [value]))

    @jsii.member(jsii_name="putRemoveVary")
    def put_remove_vary(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveVary", [value]))

    @jsii.member(jsii_name="putReport")
    def put_report(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport(
            cookies=cookies,
            custom_log_field=custom_log_field,
            locked=locked,
            log_accept_language=log_accept_language,
            log_cookies=log_cookies,
            log_custom_log_field=log_custom_log_field,
            log_edge_ip=log_edge_ip,
            log_host=log_host,
            log_referer=log_referer,
            log_user_agent=log_user_agent,
            log_x_forwarded_for=log_x_forwarded_for,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReport", [value]))

    @jsii.member(jsii_name="putRequestClientHints")
    def put_request_client_hints(
        self,
        *,
        accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accept_ch: The client hint data objects you want to receive from the browser. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        :param accept_critical_ch: The critical client hint data objects you want to receive from the browser. The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reset: This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser. This empty header doesn't get merged with other objects sent from your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints(
            accept_ch=accept_ch,
            accept_critical_ch=accept_critical_ch,
            locked=locked,
            reset=reset,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestClientHints", [value]))

    @jsii.member(jsii_name="putRequestControl")
    def put_request_control(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl(
            branded403_file=branded403_file,
            branded403_status_code=branded403_status_code,
            branded403_url=branded403_url,
            branded_deny_cache_ttl=branded_deny_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enable_branded403=enable_branded403,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            net_storage=net_storage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestControl", [value]))

    @jsii.member(jsii_name="putRequestTypeMarker")
    def put_request_type_marker(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker(
            locked=locked,
            request_type=request_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestTypeMarker", [value]))

    @jsii.member(jsii_name="putResourceOptimizer")
    def put_resource_optimizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizer", [value]))

    @jsii.member(jsii_name="putResourceOptimizerExtendedCompatibility")
    def put_resource_optimizer_extended_compatibility(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility(
            enable_all_features=enable_all_features,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizerExtendedCompatibility", [value]))

    @jsii.member(jsii_name="putResponseCode")
    def put_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode(
            locked=locked,
            override206=override206,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCode", [value]))

    @jsii.member(jsii_name="putResponseCookie")
    def put_response_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie(
            cookie_name=cookie_name,
            default_domain=default_domain,
            default_path=default_path,
            domain=domain,
            duration=duration,
            enabled=enabled,
            expiration_date=expiration_date,
            expires=expires,
            format=format,
            http_only=http_only,
            locked=locked,
            path=path,
            same_site=same_site,
            secure=secure,
            template_uuid=template_uuid,
            type=type,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCookie", [value_]))

    @jsii.member(jsii_name="putRestrictObjectCaching")
    def put_restrict_object_caching(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching(
            locked=locked,
            maximum_size=maximum_size,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRestrictObjectCaching", [value]))

    @jsii.member(jsii_name="putReturnCacheStatus")
    def put_return_cache_status(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus(
            locked=locked,
            response_header_name=response_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReturnCacheStatus", [value]))

    @jsii.member(jsii_name="putRewriteUrl")
    def put_rewrite_url(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl(
            behavior=behavior,
            keep_query_string=keep_query_string,
            locked=locked,
            match=match,
            match_multiple=match_multiple,
            match_regex=match_regex,
            target_path=target_path,
            target_path_prepend=target_path_prepend,
            target_regex=target_regex,
            target_url=target_url,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRewriteUrl", [value]))

    @jsii.member(jsii_name="putRumCustom")
    def put_rum_custom(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom(
            locked=locked,
            rum_group_name=rum_group_name,
            rum_sample_rate=rum_sample_rate,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRumCustom", [value]))

    @jsii.member(jsii_name="putSaasDefinitions")
    def put_saas_definitions(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions(
            application_action=application_action,
            application_cname_enabled=application_cname_enabled,
            application_cname_level=application_cname_level,
            application_cookie=application_cookie,
            application_query_string=application_query_string,
            application_regex=application_regex,
            application_replace=application_replace,
            application_title=application_title,
            customer_action=customer_action,
            customer_cname_enabled=customer_cname_enabled,
            customer_cname_level=customer_cname_level,
            customer_cookie=customer_cookie,
            customer_query_string=customer_query_string,
            customer_regex=customer_regex,
            customer_replace=customer_replace,
            customer_title=customer_title,
            locked=locked,
            template_uuid=template_uuid,
            users_action=users_action,
            users_cname_enabled=users_cname_enabled,
            users_cname_level=users_cname_level,
            users_cookie=users_cookie,
            users_query_string=users_query_string,
            users_regex=users_regex,
            users_replace=users_replace,
            users_title=users_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSaasDefinitions", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudClient")
    def put_sales_force_commerce_cloud_client(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient(
            allow_override_origin_cache_key=allow_override_origin_cache_key,
            connector_id=connector_id,
            enabled=enabled,
            locked=locked,
            origin_host_header=origin_host_header,
            origin_type=origin_type,
            sf3_c_origin_host=sf3_c_origin_host,
            sf3_c_origin_host_header=sf3_c_origin_host_header,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudClient", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProvider")
    def put_sales_force_commerce_cloud_provider(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProvider", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProviderHostHeader")
    def put_sales_force_commerce_cloud_provider_host_header(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader(
            host_header_source=host_header_source,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProviderHostHeader", [value]))

    @jsii.member(jsii_name="putSavePostDcaProcessing")
    def put_save_post_dca_processing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSavePostDcaProcessing", [value]))

    @jsii.member(jsii_name="putScheduleInvalidation")
    def put_schedule_invalidation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation(
            locked=locked,
            refresh_method=refresh_method,
            repeat=repeat,
            repeat_interval=repeat_interval,
            start=start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScheduleInvalidation", [value]))

    @jsii.member(jsii_name="putScriptManagement")
    def put_script_management(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement(
            enabled=enabled,
            locked=locked,
            serviceworker=serviceworker,
            template_uuid=template_uuid,
            timestamp=timestamp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScriptManagement", [value]))

    @jsii.member(jsii_name="putSegmentedContentProtection")
    def put_segmented_content_protection(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection(
            acl=acl,
            dash_media_encryption=dash_media_encryption,
            data_payload=data_payload,
            enabled=enabled,
            enable_token_in_uri=enable_token_in_uri,
            field_carry_over=field_carry_over,
            header_for_salt=header_for_salt,
            hls_master_manifest_files=hls_master_manifest_files,
            hls_media_encryption=hls_media_encryption,
            ip=ip,
            key=key,
            locked=locked,
            media_encryption_title=media_encryption_title,
            revoked_list_id=revoked_list_id,
            salt=salt,
            session_id=session_id,
            template_uuid=template_uuid,
            token_authentication_title=token_authentication_title,
            token_auth_hls_title=token_auth_hls_title,
            token_revocation_enabled=token_revocation_enabled,
            token_revocation_title=token_revocation_title,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedContentProtection", [value]))

    @jsii.member(jsii_name="putSegmentedMediaOptimization")
    def put_segmented_media_optimization(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization(
            behavior=behavior,
            dvr_type=dvr_type,
            dvr_window=dvr_window,
            enable_ull_streaming=enable_ull_streaming,
            end_time=end_time,
            live_type=live_type,
            locked=locked,
            show_advanced=show_advanced,
            start_time=start_time,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaOptimization", [value]))

    @jsii.member(jsii_name="putSegmentedMediaStreamingPrefetch")
    def put_segmented_media_streaming_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaStreamingPrefetch", [value]))

    @jsii.member(jsii_name="putSetVariable")
    def put_set_variable(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[jsii.Number] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[jsii.Number] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[jsii.Number] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[jsii.Number] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable(
            algorithm=algorithm,
            case_sensitive=case_sensitive,
            certificate_field_name=certificate_field_name,
            cookie_name=cookie_name,
            device_profile=device_profile,
            encryption_key=encryption_key,
            encryption_mode=encryption_mode,
            end_index=end_index,
            except_chars=except_chars,
            extract_location=extract_location,
            force_chars=force_chars,
            format_string=format_string,
            generator=generator,
            global_substitution=global_substitution,
            header_name=header_name,
            hmac_algorithm=hmac_algorithm,
            hmac_key=hmac_key,
            initialization_vector=initialization_vector,
            ipv4_prefix=ipv4_prefix,
            ipv6_prefix=ipv6_prefix,
            ip_version=ip_version,
            location_id=location_id,
            locked=locked,
            max=max,
            max_random_number=max_random_number,
            min=min,
            min_random_number=min_random_number,
            nonce=nonce,
            number_of_bytes=number_of_bytes,
            operand_one=operand_one,
            param_name=param_name,
            path_component_offset=path_component_offset,
            prepend_bytes=prepend_bytes,
            query_parameter_name=query_parameter_name,
            regex=regex,
            replacement=replacement,
            response_header_name=response_header_name,
            separator=separator,
            set_cookie_name=set_cookie_name,
            start_index=start_index,
            sub_string=sub_string,
            template_uuid=template_uuid,
            transform=transform,
            uuid=uuid,
            value_source=value_source,
            variable_name=variable_name,
            variable_value=variable_value,
        )

        return typing.cast(None, jsii.invoke(self, "putSetVariable", [value]))

    @jsii.member(jsii_name="putSimulateErrorCode")
    def put_simulate_error_code(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode(
            error_type=error_type,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSimulateErrorCode", [value]))

    @jsii.member(jsii_name="putSiteShield")
    def put_site_shield(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield(
            locked=locked,
            nossmap=nossmap,
            ssmap=ssmap,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSiteShield", [value]))

    @jsii.member(jsii_name="putStandardTlsMigration")
    def put_standard_tls_migration(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration(
            allow_https_downgrade=allow_https_downgrade,
            allow_https_upgrade=allow_https_upgrade,
            cache_sharing_duration=cache_sharing_duration,
            cache_sharing_start_time=cache_sharing_start_time,
            enabled=enabled,
            is_certificate_sni_only=is_certificate_sni_only,
            is_tiered_distribution_used=is_tiered_distribution_used,
            locked=locked,
            migration_duration=migration_duration,
            migration_from=migration_from,
            migration_start_time=migration_start_time,
            td_location=td_location,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigration", [value]))

    @jsii.member(jsii_name="putStandardTlsMigrationOverride")
    def put_standard_tls_migration_override(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride(
            info=info, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigrationOverride", [value]))

    @jsii.member(jsii_name="putStrictHeaderParsing")
    def put_strict_header_parsing(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing(
            locked=locked,
            strict_mode=strict_mode,
            template_uuid=template_uuid,
            uuid=uuid,
            valid_mode=valid_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putStrictHeaderParsing", [value]))

    @jsii.member(jsii_name="putSubCustomer")
    def put_sub_customer(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer(
            access_control=access_control,
            cache_key=cache_key,
            caching=caching,
            content_compressor=content_compressor,
            dynamic_web_content=dynamic_web_content,
            enabled=enabled,
            geo_location=geo_location,
            ip=ip,
            large_file_delivery=large_file_delivery,
            live_video_delivery=live_video_delivery,
            locked=locked,
            modify_path=modify_path,
            on_demand_video_delivery=on_demand_video_delivery,
            origin=origin,
            partner_domain_suffix=partner_domain_suffix,
            referrer=referrer,
            refresh_content=refresh_content,
            site_failover=site_failover,
            template_uuid=template_uuid,
            token_authorization=token_authorization,
            uuid=uuid,
            web_application_firewall=web_application_firewall,
        )

        return typing.cast(None, jsii.invoke(self, "putSubCustomer", [value]))

    @jsii.member(jsii_name="putSureRoute")
    def put_sure_route(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute(
            allow_fcm_parent_override=allow_fcm_parent_override,
            custom_map=custom_map,
            custom_stat_key=custom_stat_key,
            enable_custom_key=enable_custom_key,
            enabled=enabled,
            force_ssl_forward=force_ssl_forward,
            locked=locked,
            race_stat_ttl=race_stat_ttl,
            sr_download_link_title=sr_download_link_title,
            template_uuid=template_uuid,
            test_object_url=test_object_url,
            to_host=to_host,
            to_host_status=to_host_status,
            type=type,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSureRoute", [value]))

    @jsii.member(jsii_name="putTcpOptimization")
    def put_tcp_optimization(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putTcpOptimization", [value]))

    @jsii.member(jsii_name="putTeaLeaf")
    def put_tea_leaf(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf(
            enabled=enabled,
            ibm_customer_id=ibm_customer_id,
            limit_to_dynamic=limit_to_dynamic,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTeaLeaf", [value]))

    @jsii.member(jsii_name="putTieredDistribution")
    def put_tiered_distribution(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistribution", [value]))

    @jsii.member(jsii_name="putTieredDistributionAdvanced")
    def put_tiered_distribution_advanced(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced(
            allowall=allowall,
            enabled=enabled,
            locked=locked,
            method=method,
            policy=policy,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionAdvanced", [value]))

    @jsii.member(jsii_name="putTieredDistributionCustomization")
    def put_tiered_distribution_customization(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization(
            cloudwrapper_map_migration_title=cloudwrapper_map_migration_title,
            custom_map_enabled=custom_map_enabled,
            custom_map_name=custom_map_name,
            hash_algorithm=hash_algorithm,
            location=location,
            locked=locked,
            map_migration_enabled=map_migration_enabled,
            migration_end_date=migration_end_date,
            migration_start_date=migration_start_date,
            migration_within_cw_maps_enabled=migration_within_cw_maps_enabled,
            serial_end=serial_end,
            serial_start=serial_start,
            template_uuid=template_uuid,
            tier1_title=tier1_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionCustomization", [value]))

    @jsii.member(jsii_name="putTimeout")
    def put_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putTimeout", [value_]))

    @jsii.member(jsii_name="putUidConfiguration")
    def put_uid_configuration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration(
            enabled=enabled,
            extract_location=extract_location,
            header_name=header_name,
            legal_text=legal_text,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putUidConfiguration", [value]))

    @jsii.member(jsii_name="putValidateEntityTag")
    def put_validate_entity_tag(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putValidateEntityTag", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebToken")
    def put_verify_json_web_token(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken(
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_location=extract_location,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebToken", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebTokenForDcp")
    def put_verify_json_web_token_for_dcp(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp(
            authorizations=authorizations,
            client_id=client_id,
            custom_header=custom_header,
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_authorizations=extract_authorizations,
            extract_client_id=extract_client_id,
            extract_location=extract_location,
            extract_user_name=extract_user_name,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            primary_location=primary_location,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            user_name=user_name,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebTokenForDcp", [value]))

    @jsii.member(jsii_name="putVerifyTokenAuthorization")
    def put_verify_token_authorization(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization(
            algorithm=algorithm,
            escape_hmac_inputs=escape_hmac_inputs,
            failure_response=failure_response,
            ignore_query_string=ignore_query_string,
            key=key,
            location=location,
            location_id=location_id,
            locked=locked,
            salt=salt,
            template_uuid=template_uuid,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyTokenAuthorization", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoom")
    def put_virtual_waiting_room(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoom", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomWithEdgeWorkers")
    def put_virtual_waiting_room_with_edge_workers(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomWithEdgeWorkers", [value]))

    @jsii.member(jsii_name="putVisitorPrioritization")
    def put_visitor_prioritization(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization(
            allowed_user_cookie_advanced=allowed_user_cookie_advanced,
            allowed_user_cookie_automatic_salt=allowed_user_cookie_automatic_salt,
            allowed_user_cookie_domain=allowed_user_cookie_domain,
            allowed_user_cookie_domain_type=allowed_user_cookie_domain_type,
            allowed_user_cookie_duration=allowed_user_cookie_duration,
            allowed_user_cookie_enabled=allowed_user_cookie_enabled,
            allowed_user_cookie_http_only=allowed_user_cookie_http_only,
            allowed_user_cookie_label=allowed_user_cookie_label,
            allowed_user_cookie_management_title=allowed_user_cookie_management_title,
            allowed_user_cookie_refresh=allowed_user_cookie_refresh,
            allowed_user_cookie_salt=allowed_user_cookie_salt,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            user_identification_by_cookie=user_identification_by_cookie,
            user_identification_by_headers=user_identification_by_headers,
            user_identification_by_ip=user_identification_by_ip,
            user_identification_by_params=user_identification_by_params,
            user_identification_key_cookie=user_identification_key_cookie,
            user_identification_key_headers=user_identification_key_headers,
            user_identification_key_params=user_identification_key_params,
            user_identification_title=user_identification_title,
            uuid=uuid,
            waiting_room_cache_ttl=waiting_room_cache_ttl,
            waiting_room_cookie_advanced=waiting_room_cookie_advanced,
            waiting_room_cookie_automatic_salt=waiting_room_cookie_automatic_salt,
            waiting_room_cookie_domain=waiting_room_cookie_domain,
            waiting_room_cookie_domain_type=waiting_room_cookie_domain_type,
            waiting_room_cookie_duration=waiting_room_cookie_duration,
            waiting_room_cookie_enabled=waiting_room_cookie_enabled,
            waiting_room_cookie_http_only=waiting_room_cookie_http_only,
            waiting_room_cookie_label=waiting_room_cookie_label,
            waiting_room_cookie_management_title=waiting_room_cookie_management_title,
            waiting_room_cookie_salt=waiting_room_cookie_salt,
            waiting_room_cookie_share_label=waiting_room_cookie_share_label,
            waiting_room_cp_code=waiting_room_cp_code,
            waiting_room_directory=waiting_room_directory,
            waiting_room_management_title=waiting_room_management_title,
            waiting_room_net_storage=waiting_room_net_storage,
            waiting_room_status_code=waiting_room_status_code,
            waiting_room_use_cp_code=waiting_room_use_cp_code,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritization", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifo")
    def put_visitor_prioritization_fifo(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifo", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifoStandalone")
    def put_visitor_prioritization_fifo_standalone(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifoStandalone", [value]))

    @jsii.member(jsii_name="putWatermarking")
    def put_watermarking(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking(
            ab_variant_location=ab_variant_location,
            decryption_password1=decryption_password1,
            decryption_password2=decryption_password2,
            decryption_password_id1=decryption_password_id1,
            decryption_password_id2=decryption_password_id2,
            enable=enable,
            locked=locked,
            miscellaneous_settings_title=miscellaneous_settings_title,
            pattern_decryption_enable=pattern_decryption_enable,
            pattern_encryption_title=pattern_encryption_title,
            signature_verification_enable=signature_verification_enable,
            template_uuid=template_uuid,
            token_signing_title=token_signing_title,
            use_original_as_a=use_original_as_a,
            uuid=uuid,
            verification_key_id1=verification_key_id1,
            verification_key_id2=verification_key_id2,
            verification_public_key1=verification_public_key1,
            verification_public_key2=verification_public_key2,
        )

        return typing.cast(None, jsii.invoke(self, "putWatermarking", [value]))

    @jsii.member(jsii_name="putWebApplicationFirewall")
    def put_web_application_firewall(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall(
            firewall_configuration=firewall_configuration,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putWebApplicationFirewall", [value]))

    @jsii.member(jsii_name="putWebdav")
    def put_webdav(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebdav", [value]))

    @jsii.member(jsii_name="putWebSockets")
    def put_web_sockets(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebSockets", [value]))

    @jsii.member(jsii_name="resetAdaptiveAcceleration")
    def reset_adaptive_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveAcceleration", []))

    @jsii.member(jsii_name="resetAdaptiveImageCompression")
    def reset_adaptive_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveImageCompression", []))

    @jsii.member(jsii_name="resetAdScalerCircuitBreaker")
    def reset_ad_scaler_circuit_breaker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdScalerCircuitBreaker", []))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetAggregatedReporting")
    def reset_aggregated_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregatedReporting", []))

    @jsii.member(jsii_name="resetAkamaizer")
    def reset_akamaizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizer", []))

    @jsii.member(jsii_name="resetAkamaizerTag")
    def reset_akamaizer_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizerTag", []))

    @jsii.member(jsii_name="resetAllHttpInCacheHierarchy")
    def reset_all_http_in_cache_hierarchy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllHttpInCacheHierarchy", []))

    @jsii.member(jsii_name="resetAllowCloudletsOrigins")
    def reset_allow_cloudlets_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCloudletsOrigins", []))

    @jsii.member(jsii_name="resetAllowDelete")
    def reset_allow_delete(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowDelete", []))

    @jsii.member(jsii_name="resetAllowHttpsCacheKeySharing")
    def reset_allow_https_cache_key_sharing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsCacheKeySharing", []))

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowOptions")
    def reset_allow_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOptions", []))

    @jsii.member(jsii_name="resetAllowPatch")
    def reset_allow_patch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPatch", []))

    @jsii.member(jsii_name="resetAllowPost")
    def reset_allow_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPost", []))

    @jsii.member(jsii_name="resetAllowPut")
    def reset_allow_put(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPut", []))

    @jsii.member(jsii_name="resetAllowTransferEncoding")
    def reset_allow_transfer_encoding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowTransferEncoding", []))

    @jsii.member(jsii_name="resetAltSvcHeader")
    def reset_alt_svc_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAltSvcHeader", []))

    @jsii.member(jsii_name="resetApiPrioritization")
    def reset_api_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiPrioritization", []))

    @jsii.member(jsii_name="resetApplicationLoadBalancer")
    def reset_application_load_balancer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationLoadBalancer", []))

    @jsii.member(jsii_name="resetAudienceSegmentation")
    def reset_audience_segmentation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSegmentation", []))

    @jsii.member(jsii_name="resetAutoDomainValidation")
    def reset_auto_domain_validation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutoDomainValidation", []))

    @jsii.member(jsii_name="resetBaseDirectory")
    def reset_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBaseDirectory", []))

    @jsii.member(jsii_name="resetBossBeaconing")
    def reset_boss_beaconing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBossBeaconing", []))

    @jsii.member(jsii_name="resetBreadcrumbs")
    def reset_breadcrumbs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreadcrumbs", []))

    @jsii.member(jsii_name="resetBreakConnection")
    def reset_break_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreakConnection", []))

    @jsii.member(jsii_name="resetBrotli")
    def reset_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrotli", []))

    @jsii.member(jsii_name="resetCacheError")
    def reset_cache_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheError", []))

    @jsii.member(jsii_name="resetCacheId")
    def reset_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheId", []))

    @jsii.member(jsii_name="resetCacheKeyIgnoreCase")
    def reset_cache_key_ignore_case(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyIgnoreCase", []))

    @jsii.member(jsii_name="resetCacheKeyQueryParams")
    def reset_cache_key_query_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyQueryParams", []))

    @jsii.member(jsii_name="resetCacheKeyRewrite")
    def reset_cache_key_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyRewrite", []))

    @jsii.member(jsii_name="resetCachePost")
    def reset_cache_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachePost", []))

    @jsii.member(jsii_name="resetCacheRedirect")
    def reset_cache_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheRedirect", []))

    @jsii.member(jsii_name="resetCacheTag")
    def reset_cache_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTag", []))

    @jsii.member(jsii_name="resetCacheTagVisible")
    def reset_cache_tag_visible(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTagVisible", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetCentralAuthorization")
    def reset_central_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCentralAuthorization", []))

    @jsii.member(jsii_name="resetChaseRedirects")
    def reset_chase_redirects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaseRedirects", []))

    @jsii.member(jsii_name="resetClientCertificateAuth")
    def reset_client_certificate_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificateAuth", []))

    @jsii.member(jsii_name="resetClientCharacteristics")
    def reset_client_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCharacteristics", []))

    @jsii.member(jsii_name="resetCloudInterconnects")
    def reset_cloud_interconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudInterconnects", []))

    @jsii.member(jsii_name="resetCloudWrapper")
    def reset_cloud_wrapper(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapper", []))

    @jsii.member(jsii_name="resetCloudWrapperAdvanced")
    def reset_cloud_wrapper_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapperAdvanced", []))

    @jsii.member(jsii_name="resetCommonMediaClientData")
    def reset_common_media_client_data(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCommonMediaClientData", []))

    @jsii.member(jsii_name="resetConditionalOrigin")
    def reset_conditional_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalOrigin", []))

    @jsii.member(jsii_name="resetConstructResponse")
    def reset_construct_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConstructResponse", []))

    @jsii.member(jsii_name="resetContentCharacteristics")
    def reset_content_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristics", []))

    @jsii.member(jsii_name="resetContentCharacteristicsAmd")
    def reset_content_characteristics_amd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsAmd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsDd")
    def reset_content_characteristics_dd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsDd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLargeFile")
    def reset_content_characteristics_wsd_large_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLargeFile", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLive")
    def reset_content_characteristics_wsd_live(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLive", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdVod")
    def reset_content_characteristics_wsd_vod(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdVod", []))

    @jsii.member(jsii_name="resetContentPrePosition")
    def reset_content_pre_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPrePosition", []))

    @jsii.member(jsii_name="resetContentTargetingProtection")
    def reset_content_targeting_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentTargetingProtection", []))

    @jsii.member(jsii_name="resetCorsSupport")
    def reset_cors_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCorsSupport", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetCustomBehavior")
    def reset_custom_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomBehavior", []))

    @jsii.member(jsii_name="resetDatastream")
    def reset_datastream(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastream", []))

    @jsii.member(jsii_name="resetDcp")
    def reset_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcp", []))

    @jsii.member(jsii_name="resetDcpAuthHmacTransformation")
    def reset_dcp_auth_hmac_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthHmacTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthRegexTransformation")
    def reset_dcp_auth_regex_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthRegexTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthSubstringTransformation")
    def reset_dcp_auth_substring_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthSubstringTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthVariableExtractor")
    def reset_dcp_auth_variable_extractor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthVariableExtractor", []))

    @jsii.member(jsii_name="resetDcpDefaultAuthzGroups")
    def reset_dcp_default_authz_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDefaultAuthzGroups", []))

    @jsii.member(jsii_name="resetDcpDevRelations")
    def reset_dcp_dev_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDevRelations", []))

    @jsii.member(jsii_name="resetDcpRealTimeAuth")
    def reset_dcp_real_time_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpRealTimeAuth", []))

    @jsii.member(jsii_name="resetDeliveryReceipt")
    def reset_delivery_receipt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryReceipt", []))

    @jsii.member(jsii_name="resetDenyAccess")
    def reset_deny_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyAccess", []))

    @jsii.member(jsii_name="resetDenyDirectFailoverAccess")
    def reset_deny_direct_failover_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyDirectFailoverAccess", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicCacheId")
    def reset_device_characteristic_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicCacheId", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicHeader")
    def reset_device_characteristic_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicHeader", []))

    @jsii.member(jsii_name="resetDnsAsyncRefresh")
    def reset_dns_async_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsAsyncRefresh", []))

    @jsii.member(jsii_name="resetDnsPrefresh")
    def reset_dns_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsPrefresh", []))

    @jsii.member(jsii_name="resetDowngradeProtocol")
    def reset_downgrade_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDowngradeProtocol", []))

    @jsii.member(jsii_name="resetDownloadCompleteMarker")
    def reset_download_complete_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadCompleteMarker", []))

    @jsii.member(jsii_name="resetDownloadNotification")
    def reset_download_notification(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadNotification", []))

    @jsii.member(jsii_name="resetDownstreamCache")
    def reset_downstream_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownstreamCache", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimization")
    def reset_dynamic_throughtput_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimization", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimizationOverride")
    def reset_dynamic_throughtput_optimization_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimizationOverride", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEcmsBulkUpload")
    def reset_ecms_bulk_upload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsBulkUpload", []))

    @jsii.member(jsii_name="resetEcmsDatabase")
    def reset_ecms_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDatabase", []))

    @jsii.member(jsii_name="resetEcmsDataset")
    def reset_ecms_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDataset", []))

    @jsii.member(jsii_name="resetEcmsObjectKey")
    def reset_ecms_object_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsObjectKey", []))

    @jsii.member(jsii_name="resetEdgeConnect")
    def reset_edge_connect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeConnect", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingAdvanced")
    def reset_edge_load_balancing_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingAdvanced", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingDataCenter")
    def reset_edge_load_balancing_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingDataCenter", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingOrigin")
    def reset_edge_load_balancing_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingOrigin", []))

    @jsii.member(jsii_name="resetEdgeOriginAuthorization")
    def reset_edge_origin_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeOriginAuthorization", []))

    @jsii.member(jsii_name="resetEdgeRedirector")
    def reset_edge_redirector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeRedirector", []))

    @jsii.member(jsii_name="resetEdgeScape")
    def reset_edge_scape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeScape", []))

    @jsii.member(jsii_name="resetEdgeSideIncludes")
    def reset_edge_side_includes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeSideIncludes", []))

    @jsii.member(jsii_name="resetEdgeWorker")
    def reset_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorker", []))

    @jsii.member(jsii_name="resetEnforceMtlsSettings")
    def reset_enforce_mtls_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnforceMtlsSettings", []))

    @jsii.member(jsii_name="resetEnhancedAkamaiProtocol")
    def reset_enhanced_akamai_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedAkamaiProtocol", []))

    @jsii.member(jsii_name="resetEnhancedProxyDetection")
    def reset_enhanced_proxy_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedProxyDetection", []))

    @jsii.member(jsii_name="resetEpdForwardHeaderEnrichment")
    def reset_epd_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEpdForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetFailAction")
    def reset_fail_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailAction", []))

    @jsii.member(jsii_name="resetFailoverBotManagerFeatureCompatibility")
    def reset_failover_bot_manager_feature_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverBotManagerFeatureCompatibility", []))

    @jsii.member(jsii_name="resetFastInvalidate")
    def reset_fast_invalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFastInvalidate", []))

    @jsii.member(jsii_name="resetFips")
    def reset_fips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFips", []))

    @jsii.member(jsii_name="resetFirstPartyMarketing")
    def reset_first_party_marketing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketing", []))

    @jsii.member(jsii_name="resetFirstPartyMarketingPlus")
    def reset_first_party_marketing_plus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketingPlus", []))

    @jsii.member(jsii_name="resetForwardRewrite")
    def reset_forward_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardRewrite", []))

    @jsii.member(jsii_name="resetG2Oheader")
    def reset_g2_oheader(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2Oheader", []))

    @jsii.member(jsii_name="resetGlobalRequestNumber")
    def reset_global_request_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalRequestNumber", []))

    @jsii.member(jsii_name="resetGraphqlCaching")
    def reset_graphql_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGraphqlCaching", []))

    @jsii.member(jsii_name="resetGzipResponse")
    def reset_gzip_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGzipResponse", []))

    @jsii.member(jsii_name="resetHdDataAdvanced")
    def reset_hd_data_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHdDataAdvanced", []))

    @jsii.member(jsii_name="resetHealthDetection")
    def reset_health_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHealthDetection", []))

    @jsii.member(jsii_name="resetHsafEipBinding")
    def reset_hsaf_eip_binding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsafEipBinding", []))

    @jsii.member(jsii_name="resetHttp2")
    def reset_http2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp2", []))

    @jsii.member(jsii_name="resetHttp3")
    def reset_http3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp3", []))

    @jsii.member(jsii_name="resetHttpStrictTransportSecurity")
    def reset_http_strict_transport_security(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpStrictTransportSecurity", []))

    @jsii.member(jsii_name="resetHttpToHttpsUpgrade")
    def reset_http_to_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpToHttpsUpgrade", []))

    @jsii.member(jsii_name="resetImageAndVideoManager")
    def reset_image_and_video_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageAndVideoManager", []))

    @jsii.member(jsii_name="resetImageManager")
    def reset_image_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManager", []))

    @jsii.member(jsii_name="resetImageManagerVideo")
    def reset_image_manager_video(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManagerVideo", []))

    @jsii.member(jsii_name="resetImOverride")
    def reset_im_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImOverride", []))

    @jsii.member(jsii_name="resetInclude")
    def reset_include(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInclude", []))

    @jsii.member(jsii_name="resetInstant")
    def reset_instant(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstant", []))

    @jsii.member(jsii_name="resetInstantConfig")
    def reset_instant_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstantConfig", []))

    @jsii.member(jsii_name="resetLargeFileOptimization")
    def reset_large_file_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimization", []))

    @jsii.member(jsii_name="resetLargeFileOptimizationAdvanced")
    def reset_large_file_optimization_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimizationAdvanced", []))

    @jsii.member(jsii_name="resetLimitBitRate")
    def reset_limit_bit_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitBitRate", []))

    @jsii.member(jsii_name="resetLogCustom")
    def reset_log_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustom", []))

    @jsii.member(jsii_name="resetManifestPersonalization")
    def reset_manifest_personalization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestPersonalization", []))

    @jsii.member(jsii_name="resetManifestRerouting")
    def reset_manifest_rerouting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestRerouting", []))

    @jsii.member(jsii_name="resetManualServerPush")
    def reset_manual_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManualServerPush", []))

    @jsii.member(jsii_name="resetMediaAcceleration")
    def reset_media_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAcceleration", []))

    @jsii.member(jsii_name="resetMediaAccelerationQuicOptout")
    def reset_media_acceleration_quic_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAccelerationQuicOptout", []))

    @jsii.member(jsii_name="resetMediaClient")
    def reset_media_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaClient", []))

    @jsii.member(jsii_name="resetMediaFileRetrievalOptimization")
    def reset_media_file_retrieval_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaFileRetrievalOptimization", []))

    @jsii.member(jsii_name="resetMediaOriginFailover")
    def reset_media_origin_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaOriginFailover", []))

    @jsii.member(jsii_name="resetMetadataCaching")
    def reset_metadata_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataCaching", []))

    @jsii.member(jsii_name="resetMobileSdkPerformance")
    def reset_mobile_sdk_performance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileSdkPerformance", []))

    @jsii.member(jsii_name="resetModifyIncomingRequestHeader")
    def reset_modify_incoming_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyIncomingResponseHeader")
    def reset_modify_incoming_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingRequestHeader")
    def reset_modify_outgoing_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingResponseHeader")
    def reset_modify_outgoing_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyViaHeader")
    def reset_modify_via_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyViaHeader", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetOriginCharacteristics")
    def reset_origin_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristics", []))

    @jsii.member(jsii_name="resetOriginCharacteristicsWsd")
    def reset_origin_characteristics_wsd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristicsWsd", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryMethod")
    def reset_origin_failure_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryMethod", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryPolicy")
    def reset_origin_failure_recovery_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryPolicy", []))

    @jsii.member(jsii_name="resetOriginIpAcl")
    def reset_origin_ip_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginIpAcl", []))

    @jsii.member(jsii_name="resetPermissionsPolicy")
    def reset_permissions_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPermissionsPolicy", []))

    @jsii.member(jsii_name="resetPersistentClientConnection")
    def reset_persistent_client_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentClientConnection", []))

    @jsii.member(jsii_name="resetPersistentConnection")
    def reset_persistent_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentConnection", []))

    @jsii.member(jsii_name="resetPersonallyIdentifiableInformation")
    def reset_personally_identifiable_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersonallyIdentifiableInformation", []))

    @jsii.member(jsii_name="resetPhasedRelease")
    def reset_phased_release(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPhasedRelease", []))

    @jsii.member(jsii_name="resetPreconnect")
    def reset_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnect", []))

    @jsii.member(jsii_name="resetPredictiveContentDelivery")
    def reset_predictive_content_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictiveContentDelivery", []))

    @jsii.member(jsii_name="resetPredictivePrefetching")
    def reset_predictive_prefetching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictivePrefetching", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetPrefetchable")
    def reset_prefetchable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchable", []))

    @jsii.member(jsii_name="resetPrefreshCache")
    def reset_prefresh_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshCache", []))

    @jsii.member(jsii_name="resetQuality")
    def reset_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuality", []))

    @jsii.member(jsii_name="resetQuicBeta")
    def reset_quic_beta(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicBeta", []))

    @jsii.member(jsii_name="resetRandomSeek")
    def reset_random_seek(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandomSeek", []))

    @jsii.member(jsii_name="resetRapid")
    def reset_rapid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRapid", []))

    @jsii.member(jsii_name="resetReadTimeout")
    def reset_read_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReadTimeout", []))

    @jsii.member(jsii_name="resetRealTimeReporting")
    def reset_real_time_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealTimeReporting", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectplus")
    def reset_redirectplus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectplus", []))

    @jsii.member(jsii_name="resetRefererChecking")
    def reset_referer_checking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefererChecking", []))

    @jsii.member(jsii_name="resetRemoveQueryParameter")
    def reset_remove_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveQueryParameter", []))

    @jsii.member(jsii_name="resetRemoveVary")
    def reset_remove_vary(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveVary", []))

    @jsii.member(jsii_name="resetReport")
    def reset_report(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReport", []))

    @jsii.member(jsii_name="resetRequestClientHints")
    def reset_request_client_hints(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestClientHints", []))

    @jsii.member(jsii_name="resetRequestControl")
    def reset_request_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestControl", []))

    @jsii.member(jsii_name="resetRequestTypeMarker")
    def reset_request_type_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestTypeMarker", []))

    @jsii.member(jsii_name="resetResourceOptimizer")
    def reset_resource_optimizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizer", []))

    @jsii.member(jsii_name="resetResourceOptimizerExtendedCompatibility")
    def reset_resource_optimizer_extended_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizerExtendedCompatibility", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetResponseCookie")
    def reset_response_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCookie", []))

    @jsii.member(jsii_name="resetRestrictObjectCaching")
    def reset_restrict_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRestrictObjectCaching", []))

    @jsii.member(jsii_name="resetReturnCacheStatus")
    def reset_return_cache_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnCacheStatus", []))

    @jsii.member(jsii_name="resetRewriteUrl")
    def reset_rewrite_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRewriteUrl", []))

    @jsii.member(jsii_name="resetRumCustom")
    def reset_rum_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumCustom", []))

    @jsii.member(jsii_name="resetSaasDefinitions")
    def reset_saas_definitions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasDefinitions", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudClient")
    def reset_sales_force_commerce_cloud_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudClient", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProvider")
    def reset_sales_force_commerce_cloud_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProvider", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProviderHostHeader")
    def reset_sales_force_commerce_cloud_provider_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProviderHostHeader", []))

    @jsii.member(jsii_name="resetSavePostDcaProcessing")
    def reset_save_post_dca_processing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSavePostDcaProcessing", []))

    @jsii.member(jsii_name="resetScheduleInvalidation")
    def reset_schedule_invalidation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScheduleInvalidation", []))

    @jsii.member(jsii_name="resetScriptManagement")
    def reset_script_management(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScriptManagement", []))

    @jsii.member(jsii_name="resetSegmentedContentProtection")
    def reset_segmented_content_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedContentProtection", []))

    @jsii.member(jsii_name="resetSegmentedMediaOptimization")
    def reset_segmented_media_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaOptimization", []))

    @jsii.member(jsii_name="resetSegmentedMediaStreamingPrefetch")
    def reset_segmented_media_streaming_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaStreamingPrefetch", []))

    @jsii.member(jsii_name="resetSetVariable")
    def reset_set_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetVariable", []))

    @jsii.member(jsii_name="resetSimulateErrorCode")
    def reset_simulate_error_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSimulateErrorCode", []))

    @jsii.member(jsii_name="resetSiteShield")
    def reset_site_shield(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteShield", []))

    @jsii.member(jsii_name="resetStandardTlsMigration")
    def reset_standard_tls_migration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigration", []))

    @jsii.member(jsii_name="resetStandardTlsMigrationOverride")
    def reset_standard_tls_migration_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigrationOverride", []))

    @jsii.member(jsii_name="resetStrictHeaderParsing")
    def reset_strict_header_parsing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictHeaderParsing", []))

    @jsii.member(jsii_name="resetSubCustomer")
    def reset_sub_customer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubCustomer", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTcpOptimization")
    def reset_tcp_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTcpOptimization", []))

    @jsii.member(jsii_name="resetTeaLeaf")
    def reset_tea_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTeaLeaf", []))

    @jsii.member(jsii_name="resetTieredDistribution")
    def reset_tiered_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistribution", []))

    @jsii.member(jsii_name="resetTieredDistributionAdvanced")
    def reset_tiered_distribution_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionAdvanced", []))

    @jsii.member(jsii_name="resetTieredDistributionCustomization")
    def reset_tiered_distribution_customization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionCustomization", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUidConfiguration")
    def reset_uid_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUidConfiguration", []))

    @jsii.member(jsii_name="resetValidateEntityTag")
    def reset_validate_entity_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateEntityTag", []))

    @jsii.member(jsii_name="resetVerifyJsonWebToken")
    def reset_verify_json_web_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebToken", []))

    @jsii.member(jsii_name="resetVerifyJsonWebTokenForDcp")
    def reset_verify_json_web_token_for_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebTokenForDcp", []))

    @jsii.member(jsii_name="resetVerifyTokenAuthorization")
    def reset_verify_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyTokenAuthorization", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoom")
    def reset_virtual_waiting_room(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoom", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomWithEdgeWorkers")
    def reset_virtual_waiting_room_with_edge_workers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomWithEdgeWorkers", []))

    @jsii.member(jsii_name="resetVisitorPrioritization")
    def reset_visitor_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritization", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifo")
    def reset_visitor_prioritization_fifo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifo", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifoStandalone")
    def reset_visitor_prioritization_fifo_standalone(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifoStandalone", []))

    @jsii.member(jsii_name="resetWatermarking")
    def reset_watermarking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWatermarking", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @jsii.member(jsii_name="resetWebdav")
    def reset_webdav(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebdav", []))

    @jsii.member(jsii_name="resetWebSockets")
    def reset_web_sockets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebSockets", []))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAcceleration")
    def adaptive_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAccelerationOutputReference, jsii.get(self, "adaptiveAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompression")
    def adaptive_image_compression(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompressionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompressionOutputReference, jsii.get(self, "adaptiveImageCompression"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreaker")
    def ad_scaler_circuit_breaker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreakerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreakerOutputReference, jsii.get(self, "adScalerCircuitBreaker"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvancedOutputReference, jsii.get(self, "advanced"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReporting")
    def aggregated_reporting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReportingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReportingOutputReference, jsii.get(self, "aggregatedReporting"))

    @builtins.property
    @jsii.member(jsii_name="akamaizer")
    def akamaizer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerOutputReference, jsii.get(self, "akamaizer"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTag")
    def akamaizer_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTagOutputReference, jsii.get(self, "akamaizerTag"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchy")
    def all_http_in_cache_hierarchy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchyOutputReference, jsii.get(self, "allHttpInCacheHierarchy"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOrigins")
    def allow_cloudlets_origins(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOriginsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOriginsOutputReference, jsii.get(self, "allowCloudletsOrigins"))

    @builtins.property
    @jsii.member(jsii_name="allowDelete")
    def allow_delete(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDeleteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDeleteOutputReference, jsii.get(self, "allowDelete"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharing")
    def allow_https_cache_key_sharing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharingOutputReference, jsii.get(self, "allowHttpsCacheKeySharing"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngradeOutputReference, jsii.get(self, "allowHttpsDowngrade"))

    @builtins.property
    @jsii.member(jsii_name="allowOptions")
    def allow_options(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptionsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptionsOutputReference, jsii.get(self, "allowOptions"))

    @builtins.property
    @jsii.member(jsii_name="allowPatch")
    def allow_patch(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatchOutputReference, jsii.get(self, "allowPatch"))

    @builtins.property
    @jsii.member(jsii_name="allowPost")
    def allow_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPostOutputReference, jsii.get(self, "allowPost"))

    @builtins.property
    @jsii.member(jsii_name="allowPut")
    def allow_put(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPutOutputReference, jsii.get(self, "allowPut"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncoding")
    def allow_transfer_encoding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncodingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncodingOutputReference, jsii.get(self, "allowTransferEncoding"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeader")
    def alt_svc_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeaderOutputReference, jsii.get(self, "altSvcHeader"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritization")
    def api_prioritization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationOutputReference, jsii.get(self, "apiPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancer")
    def application_load_balancer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerOutputReference, jsii.get(self, "applicationLoadBalancer"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentation")
    def audience_segmentation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationOutputReference, jsii.get(self, "audienceSegmentation"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidation")
    def auto_domain_validation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidationOutputReference, jsii.get(self, "autoDomainValidation"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectory")
    def base_directory(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectoryOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectoryOutputReference, jsii.get(self, "baseDirectory"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconing")
    def boss_beaconing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconingOutputReference, jsii.get(self, "bossBeaconing"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbs")
    def breadcrumbs(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbsOutputReference, jsii.get(self, "breadcrumbs"))

    @builtins.property
    @jsii.member(jsii_name="breakConnection")
    def break_connection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnectionOutputReference, jsii.get(self, "breakConnection"))

    @builtins.property
    @jsii.member(jsii_name="brotli")
    def brotli(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotliOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotliOutputReference, jsii.get(self, "brotli"))

    @builtins.property
    @jsii.member(jsii_name="cacheError")
    def cache_error(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheErrorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheErrorOutputReference, jsii.get(self, "cacheError"))

    @builtins.property
    @jsii.member(jsii_name="cacheId")
    def cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheIdOutputReference, jsii.get(self, "cacheId"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCase")
    def cache_key_ignore_case(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCaseOutputReference, jsii.get(self, "cacheKeyIgnoreCase"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParams")
    def cache_key_query_params(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParamsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParamsOutputReference, jsii.get(self, "cacheKeyQueryParams"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewrite")
    def cache_key_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewriteOutputReference, jsii.get(self, "cacheKeyRewrite"))

    @builtins.property
    @jsii.member(jsii_name="cachePost")
    def cache_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePostOutputReference, jsii.get(self, "cachePost"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirect")
    def cache_redirect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirectOutputReference, jsii.get(self, "cacheRedirect"))

    @builtins.property
    @jsii.member(jsii_name="cacheTag")
    def cache_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagOutputReference, jsii.get(self, "cacheTag"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisible")
    def cache_tag_visible(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisibleOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisibleOutputReference, jsii.get(self, "cacheTagVisible"))

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachingOutputReference, jsii.get(self, "caching"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorization")
    def central_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorizationOutputReference, jsii.get(self, "centralAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirects")
    def chase_redirects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirectsOutputReference, jsii.get(self, "chaseRedirects"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAuth")
    def client_certificate_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuthOutputReference, jsii.get(self, "clientCertificateAuth"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristics")
    def client_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristicsOutputReference, jsii.get(self, "clientCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnects")
    def cloud_interconnects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnectsOutputReference, jsii.get(self, "cloudInterconnects"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapper")
    def cloud_wrapper(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperOutputReference, jsii.get(self, "cloudWrapper"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvanced")
    def cloud_wrapper_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvancedOutputReference, jsii.get(self, "cloudWrapperAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientData")
    def common_media_client_data(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientDataOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientDataOutputReference, jsii.get(self, "commonMediaClientData"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOrigin")
    def conditional_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOriginOutputReference, jsii.get(self, "conditionalOrigin"))

    @builtins.property
    @jsii.member(jsii_name="constructResponse")
    def construct_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponseOutputReference, jsii.get(self, "constructResponse"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristics")
    def content_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsOutputReference, jsii.get(self, "contentCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmd")
    def content_characteristics_amd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmdOutputReference, jsii.get(self, "contentCharacteristicsAmd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDd")
    def content_characteristics_dd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDdOutputReference, jsii.get(self, "contentCharacteristicsDd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFile")
    def content_characteristics_wsd_large_file(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFileOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFileOutputReference, jsii.get(self, "contentCharacteristicsWsdLargeFile"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLive")
    def content_characteristics_wsd_live(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLiveOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLiveOutputReference, jsii.get(self, "contentCharacteristicsWsdLive"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVod")
    def content_characteristics_wsd_vod(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVodOutputReference, jsii.get(self, "contentCharacteristicsWsdVod"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePosition")
    def content_pre_position(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePositionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePositionOutputReference, jsii.get(self, "contentPrePosition"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtection")
    def content_targeting_protection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtectionOutputReference, jsii.get(self, "contentTargetingProtection"))

    @builtins.property
    @jsii.member(jsii_name="corsSupport")
    def cors_support(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupportOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupportOutputReference, jsii.get(self, "corsSupport"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="customBehavior")
    def custom_behavior(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehaviorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehaviorOutputReference, jsii.get(self, "customBehavior"))

    @builtins.property
    @jsii.member(jsii_name="datastream")
    def datastream(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastreamOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastreamOutputReference, jsii.get(self, "datastream"))

    @builtins.property
    @jsii.member(jsii_name="dcp")
    def dcp(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpOutputReference, jsii.get(self, "dcp"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformation")
    def dcp_auth_hmac_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformationOutputReference, jsii.get(self, "dcpAuthHmacTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformation")
    def dcp_auth_regex_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformationOutputReference, jsii.get(self, "dcpAuthRegexTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformation")
    def dcp_auth_substring_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformationOutputReference, jsii.get(self, "dcpAuthSubstringTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractor")
    def dcp_auth_variable_extractor(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractorOutputReference, jsii.get(self, "dcpAuthVariableExtractor"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroups")
    def dcp_default_authz_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroupsOutputReference, jsii.get(self, "dcpDefaultAuthzGroups"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelations")
    def dcp_dev_relations(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelationsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelationsOutputReference, jsii.get(self, "dcpDevRelations"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuth")
    def dcp_real_time_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuthOutputReference, jsii.get(self, "dcpRealTimeAuth"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceipt")
    def delivery_receipt(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceiptOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceiptOutputReference, jsii.get(self, "deliveryReceipt"))

    @builtins.property
    @jsii.member(jsii_name="denyAccess")
    def deny_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccessOutputReference, jsii.get(self, "denyAccess"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccess")
    def deny_direct_failover_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccessOutputReference, jsii.get(self, "denyDirectFailoverAccess"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheId")
    def device_characteristic_cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheIdOutputReference, jsii.get(self, "deviceCharacteristicCacheId"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeader")
    def device_characteristic_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeaderOutputReference, jsii.get(self, "deviceCharacteristicHeader"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefresh")
    def dns_async_refresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefreshOutputReference, jsii.get(self, "dnsAsyncRefresh"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefresh")
    def dns_prefresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefreshOutputReference, jsii.get(self, "dnsPrefresh"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocol")
    def downgrade_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocolOutputReference, jsii.get(self, "downgradeProtocol"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarker")
    def download_complete_marker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarkerOutputReference, jsii.get(self, "downloadCompleteMarker"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotification")
    def download_notification(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotificationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotificationOutputReference, jsii.get(self, "downloadNotification"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCache")
    def downstream_cache(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCacheOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCacheOutputReference, jsii.get(self, "downstreamCache"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimization")
    def dynamic_throughtput_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOutputReference, jsii.get(self, "dynamicThroughtputOptimization"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverride")
    def dynamic_throughtput_optimization_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverrideOutputReference, jsii.get(self, "dynamicThroughtputOptimizationOverride"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContentOutputReference, jsii.get(self, "dynamicWebContent"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUpload")
    def ecms_bulk_upload(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUploadOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUploadOutputReference, jsii.get(self, "ecmsBulkUpload"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabase")
    def ecms_database(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabaseOutputReference, jsii.get(self, "ecmsDatabase"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDataset")
    def ecms_dataset(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatasetOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatasetOutputReference, jsii.get(self, "ecmsDataset"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKey")
    def ecms_object_key(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKeyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKeyOutputReference, jsii.get(self, "ecmsObjectKey"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnect")
    def edge_connect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference, jsii.get(self, "edgeConnect"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvanced")
    def edge_load_balancing_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference, jsii.get(self, "edgeLoadBalancingAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenter")
    def edge_load_balancing_data_center(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference, jsii.get(self, "edgeLoadBalancingDataCenter"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOrigin")
    def edge_load_balancing_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference, jsii.get(self, "edgeLoadBalancingOrigin"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorization")
    def edge_origin_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference, jsii.get(self, "edgeOriginAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirector")
    def edge_redirector(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference, jsii.get(self, "edgeRedirector"))

    @builtins.property
    @jsii.member(jsii_name="edgeScape")
    def edge_scape(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference, jsii.get(self, "edgeScape"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludes")
    def edge_side_includes(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference, jsii.get(self, "edgeSideIncludes"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorker")
    def edge_worker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference, jsii.get(self, "edgeWorker"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsSettings")
    def enforce_mtls_settings(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference, jsii.get(self, "enforceMtlsSettings"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocol")
    def enhanced_akamai_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference, jsii.get(self, "enhancedAkamaiProtocol"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetection")
    def enhanced_proxy_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference, jsii.get(self, "enhancedProxyDetection"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichment")
    def epd_forward_header_enrichment(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference, jsii.get(self, "epdForwardHeaderEnrichment"))

    @builtins.property
    @jsii.member(jsii_name="failAction")
    def fail_action(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference, jsii.get(self, "failAction"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibility")
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference, jsii.get(self, "failoverBotManagerFeatureCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidate")
    def fast_invalidate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference, jsii.get(self, "fastInvalidate"))

    @builtins.property
    @jsii.member(jsii_name="fips")
    def fips(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference, jsii.get(self, "fips"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketing")
    def first_party_marketing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference, jsii.get(self, "firstPartyMarketing"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlus")
    def first_party_marketing_plus(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference, jsii.get(self, "firstPartyMarketingPlus"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewrite")
    def forward_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference, jsii.get(self, "forwardRewrite"))

    @builtins.property
    @jsii.member(jsii_name="g2Oheader")
    def g2_oheader(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference, jsii.get(self, "g2Oheader"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumber")
    def global_request_number(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference, jsii.get(self, "globalRequestNumber"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCaching")
    def graphql_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference, jsii.get(self, "graphqlCaching"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponse")
    def gzip_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference, jsii.get(self, "gzipResponse"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvanced")
    def hd_data_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference, jsii.get(self, "hdDataAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="healthDetection")
    def health_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference, jsii.get(self, "healthDetection"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBinding")
    def hsaf_eip_binding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference, jsii.get(self, "hsafEipBinding"))

    @builtins.property
    @jsii.member(jsii_name="http2")
    def http2(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference, jsii.get(self, "http2"))

    @builtins.property
    @jsii.member(jsii_name="http3")
    def http3(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference, jsii.get(self, "http3"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurity")
    def http_strict_transport_security(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference, jsii.get(self, "httpStrictTransportSecurity"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgrade")
    def http_to_https_upgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference, jsii.get(self, "httpToHttpsUpgrade"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManager")
    def image_and_video_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference, jsii.get(self, "imageAndVideoManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManager")
    def image_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference, jsii.get(self, "imageManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideo")
    def image_manager_video(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference, jsii.get(self, "imageManagerVideo"))

    @builtins.property
    @jsii.member(jsii_name="imOverride")
    def im_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference, jsii.get(self, "imOverride"))

    @builtins.property
    @jsii.member(jsii_name="include")
    def include(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference, jsii.get(self, "include"))

    @builtins.property
    @jsii.member(jsii_name="instant")
    def instant(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference, jsii.get(self, "instant"))

    @builtins.property
    @jsii.member(jsii_name="instantConfig")
    def instant_config(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference, jsii.get(self, "instantConfig"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimization")
    def large_file_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference, jsii.get(self, "largeFileOptimization"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvanced")
    def large_file_optimization_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference, jsii.get(self, "largeFileOptimizationAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRate")
    def limit_bit_rate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference, jsii.get(self, "limitBitRate"))

    @builtins.property
    @jsii.member(jsii_name="logCustom")
    def log_custom(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference, jsii.get(self, "logCustom"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalization")
    def manifest_personalization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference, jsii.get(self, "manifestPersonalization"))

    @builtins.property
    @jsii.member(jsii_name="manifestRerouting")
    def manifest_rerouting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference, jsii.get(self, "manifestRerouting"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPush")
    def manual_server_push(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference, jsii.get(self, "manualServerPush"))

    @builtins.property
    @jsii.member(jsii_name="mediaAcceleration")
    def media_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference, jsii.get(self, "mediaAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptout")
    def media_acceleration_quic_optout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference, jsii.get(self, "mediaAccelerationQuicOptout"))

    @builtins.property
    @jsii.member(jsii_name="mediaClient")
    def media_client(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference, jsii.get(self, "mediaClient"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimization")
    def media_file_retrieval_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference, jsii.get(self, "mediaFileRetrievalOptimization"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailover")
    def media_origin_failover(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference, jsii.get(self, "mediaOriginFailover"))

    @builtins.property
    @jsii.member(jsii_name="metadataCaching")
    def metadata_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference, jsii.get(self, "metadataCaching"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformance")
    def mobile_sdk_performance(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference, jsii.get(self, "mobileSdkPerformance"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeader")
    def modify_incoming_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference, jsii.get(self, "modifyIncomingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeader")
    def modify_incoming_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference, jsii.get(self, "modifyIncomingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeader")
    def modify_outgoing_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference, jsii.get(self, "modifyOutgoingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeader")
    def modify_outgoing_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference, jsii.get(self, "modifyOutgoingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeader")
    def modify_via_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference, jsii.get(self, "modifyViaHeader"))

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference, jsii.get(self, "mPulse"))

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference, jsii.get(self, "origin"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristics")
    def origin_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference, jsii.get(self, "originCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsd")
    def origin_characteristics_wsd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference, jsii.get(self, "originCharacteristicsWsd"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethod")
    def origin_failure_recovery_method(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference, jsii.get(self, "originFailureRecoveryMethod"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicy")
    def origin_failure_recovery_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference, jsii.get(self, "originFailureRecoveryPolicy"))

    @builtins.property
    @jsii.member(jsii_name="originIpAcl")
    def origin_ip_acl(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference, jsii.get(self, "originIpAcl"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicy")
    def permissions_policy(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference", jsii.get(self, "permissionsPolicy"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnection")
    def persistent_client_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference", jsii.get(self, "persistentClientConnection"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnection")
    def persistent_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference", jsii.get(self, "persistentConnection"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformation")
    def personally_identifiable_information(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference", jsii.get(self, "personallyIdentifiableInformation"))

    @builtins.property
    @jsii.member(jsii_name="phasedRelease")
    def phased_release(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference", jsii.get(self, "phasedRelease"))

    @builtins.property
    @jsii.member(jsii_name="preconnect")
    def preconnect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference", jsii.get(self, "preconnect"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDelivery")
    def predictive_content_delivery(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference", jsii.get(self, "predictiveContentDelivery"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetching")
    def predictive_prefetching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference", jsii.get(self, "predictivePrefetching"))

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference", jsii.get(self, "prefetch"))

    @builtins.property
    @jsii.member(jsii_name="prefetchable")
    def prefetchable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference", jsii.get(self, "prefetchable"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCache")
    def prefresh_cache(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference", jsii.get(self, "prefreshCache"))

    @builtins.property
    @jsii.member(jsii_name="quality")
    def quality(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference", jsii.get(self, "quality"))

    @builtins.property
    @jsii.member(jsii_name="quicBeta")
    def quic_beta(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference", jsii.get(self, "quicBeta"))

    @builtins.property
    @jsii.member(jsii_name="randomSeek")
    def random_seek(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference", jsii.get(self, "randomSeek"))

    @builtins.property
    @jsii.member(jsii_name="rapid")
    def rapid(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference", jsii.get(self, "rapid"))

    @builtins.property
    @jsii.member(jsii_name="readTimeout")
    def read_timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference", jsii.get(self, "readTimeout"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReporting")
    def real_time_reporting(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference", jsii.get(self, "realTimeReporting"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference", jsii.get(self, "realUserMonitoring"))

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference", jsii.get(self, "redirect"))

    @builtins.property
    @jsii.member(jsii_name="redirectplus")
    def redirectplus(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference", jsii.get(self, "redirectplus"))

    @builtins.property
    @jsii.member(jsii_name="refererChecking")
    def referer_checking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference", jsii.get(self, "refererChecking"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameter")
    def remove_query_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference", jsii.get(self, "removeQueryParameter"))

    @builtins.property
    @jsii.member(jsii_name="removeVary")
    def remove_vary(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference", jsii.get(self, "removeVary"))

    @builtins.property
    @jsii.member(jsii_name="report")
    def report(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference", jsii.get(self, "report"))

    @builtins.property
    @jsii.member(jsii_name="requestClientHints")
    def request_client_hints(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference", jsii.get(self, "requestClientHints"))

    @builtins.property
    @jsii.member(jsii_name="requestControl")
    def request_control(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference", jsii.get(self, "requestControl"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarker")
    def request_type_marker(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference", jsii.get(self, "requestTypeMarker"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizer")
    def resource_optimizer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference", jsii.get(self, "resourceOptimizer"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibility")
    def resource_optimizer_extended_compatibility(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference", jsii.get(self, "resourceOptimizerExtendedCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference", jsii.get(self, "responseCode"))

    @builtins.property
    @jsii.member(jsii_name="responseCookie")
    def response_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference", jsii.get(self, "responseCookie"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCaching")
    def restrict_object_caching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference", jsii.get(self, "restrictObjectCaching"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatus")
    def return_cache_status(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference", jsii.get(self, "returnCacheStatus"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrl")
    def rewrite_url(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference", jsii.get(self, "rewriteUrl"))

    @builtins.property
    @jsii.member(jsii_name="rumCustom")
    def rum_custom(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference", jsii.get(self, "rumCustom"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitions")
    def saas_definitions(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitionsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitionsOutputReference", jsii.get(self, "saasDefinitions"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClient")
    def sales_force_commerce_cloud_client(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClientOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClientOutputReference", jsii.get(self, "salesForceCommerceCloudClient"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProvider")
    def sales_force_commerce_cloud_provider(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderOutputReference", jsii.get(self, "salesForceCommerceCloudProvider"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeader")
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference", jsii.get(self, "salesForceCommerceCloudProviderHostHeader"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessing")
    def save_post_dca_processing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessingOutputReference", jsii.get(self, "savePostDcaProcessing"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidation")
    def schedule_invalidation(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidationOutputReference", jsii.get(self, "scheduleInvalidation"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagement")
    def script_management(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagementOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagementOutputReference", jsii.get(self, "scriptManagement"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtection")
    def segmented_content_protection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtectionOutputReference", jsii.get(self, "segmentedContentProtection"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimization")
    def segmented_media_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimizationOutputReference", jsii.get(self, "segmentedMediaOptimization"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetch")
    def segmented_media_streaming_prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetchOutputReference", jsii.get(self, "segmentedMediaStreamingPrefetch"))

    @builtins.property
    @jsii.member(jsii_name="setVariable")
    def set_variable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariableOutputReference", jsii.get(self, "setVariable"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCode")
    def simulate_error_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCodeOutputReference", jsii.get(self, "simulateErrorCode"))

    @builtins.property
    @jsii.member(jsii_name="siteShield")
    def site_shield(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldOutputReference", jsii.get(self, "siteShield"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigration")
    def standard_tls_migration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOutputReference", jsii.get(self, "standardTlsMigration"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverride")
    def standard_tls_migration_override(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverrideOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverrideOutputReference", jsii.get(self, "standardTlsMigrationOverride"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsing")
    def strict_header_parsing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsingOutputReference", jsii.get(self, "strictHeaderParsing"))

    @builtins.property
    @jsii.member(jsii_name="subCustomer")
    def sub_customer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomerOutputReference", jsii.get(self, "subCustomer"))

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRouteOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRouteOutputReference", jsii.get(self, "sureRoute"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimization")
    def tcp_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimizationOutputReference", jsii.get(self, "tcpOptimization"))

    @builtins.property
    @jsii.member(jsii_name="teaLeaf")
    def tea_leaf(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeafOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeafOutputReference", jsii.get(self, "teaLeaf"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistribution")
    def tiered_distribution(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionOutputReference", jsii.get(self, "tieredDistribution"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvanced")
    def tiered_distribution_advanced(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvancedOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvancedOutputReference", jsii.get(self, "tieredDistributionAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomization")
    def tiered_distribution_customization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomizationOutputReference", jsii.get(self, "tieredDistributionCustomization"))

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeoutOutputReference", jsii.get(self, "timeout"))

    @builtins.property
    @jsii.member(jsii_name="uidConfiguration")
    def uid_configuration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfigurationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfigurationOutputReference", jsii.get(self, "uidConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTag")
    def validate_entity_tag(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTagOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTagOutputReference", jsii.get(self, "validateEntityTag"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebToken")
    def verify_json_web_token(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenOutputReference", jsii.get(self, "verifyJsonWebToken"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcp")
    def verify_json_web_token_for_dcp(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcpOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcpOutputReference", jsii.get(self, "verifyJsonWebTokenForDcp"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorization")
    def verify_token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorizationOutputReference", jsii.get(self, "verifyTokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoom")
    def virtual_waiting_room(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomOutputReference", jsii.get(self, "virtualWaitingRoom"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkers")
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference", jsii.get(self, "virtualWaitingRoomWithEdgeWorkers"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritization")
    def visitor_prioritization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationOutputReference", jsii.get(self, "visitorPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifo")
    def visitor_prioritization_fifo(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoOutputReference", jsii.get(self, "visitorPrioritizationFifo"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandalone")
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandaloneOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandaloneOutputReference", jsii.get(self, "visitorPrioritizationFifoStandalone"))

    @builtins.property
    @jsii.member(jsii_name="watermarking")
    def watermarking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarkingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarkingOutputReference", jsii.get(self, "watermarking"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallOutputReference", jsii.get(self, "webApplicationFirewall"))

    @builtins.property
    @jsii.member(jsii_name="webdav")
    def webdav(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdavOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdavOutputReference", jsii.get(self, "webdav"))

    @builtins.property
    @jsii.member(jsii_name="webSockets")
    def web_sockets(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSocketsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSocketsOutputReference", jsii.get(self, "webSockets"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAccelerationInput")
    def adaptive_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration], jsii.get(self, "adaptiveAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompressionInput")
    def adaptive_image_compression_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression], jsii.get(self, "adaptiveImageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreakerInput")
    def ad_scaler_circuit_breaker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker], jsii.get(self, "adScalerCircuitBreakerInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReportingInput")
    def aggregated_reporting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting], jsii.get(self, "aggregatedReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerInput")
    def akamaizer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer], jsii.get(self, "akamaizerInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTagInput")
    def akamaizer_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag], jsii.get(self, "akamaizerTagInput"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchyInput")
    def all_http_in_cache_hierarchy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy], jsii.get(self, "allHttpInCacheHierarchyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOriginsInput")
    def allow_cloudlets_origins_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins], jsii.get(self, "allowCloudletsOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowDeleteInput")
    def allow_delete_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete], jsii.get(self, "allowDeleteInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharingInput")
    def allow_https_cache_key_sharing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "allowHttpsCacheKeySharingInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOptionsInput")
    def allow_options_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions], jsii.get(self, "allowOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPatchInput")
    def allow_patch_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch], jsii.get(self, "allowPatchInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPostInput")
    def allow_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost], jsii.get(self, "allowPostInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPutInput")
    def allow_put_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut], jsii.get(self, "allowPutInput"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncodingInput")
    def allow_transfer_encoding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding], jsii.get(self, "allowTransferEncodingInput"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeaderInput")
    def alt_svc_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader], jsii.get(self, "altSvcHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritizationInput")
    def api_prioritization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization], jsii.get(self, "apiPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancerInput")
    def application_load_balancer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer], jsii.get(self, "applicationLoadBalancerInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentationInput")
    def audience_segmentation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation], jsii.get(self, "audienceSegmentationInput"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidationInput")
    def auto_domain_validation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation], jsii.get(self, "autoDomainValidationInput"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectoryInput")
    def base_directory_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory], jsii.get(self, "baseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconingInput")
    def boss_beaconing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing], jsii.get(self, "bossBeaconingInput"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbsInput")
    def breadcrumbs_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs], jsii.get(self, "breadcrumbsInput"))

    @builtins.property
    @jsii.member(jsii_name="breakConnectionInput")
    def break_connection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection], jsii.get(self, "breakConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="brotliInput")
    def brotli_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli], jsii.get(self, "brotliInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorInput")
    def cache_error_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError], jsii.get(self, "cacheErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheIdInput")
    def cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId], jsii.get(self, "cacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCaseInput")
    def cache_key_ignore_case_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase], jsii.get(self, "cacheKeyIgnoreCaseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParamsInput")
    def cache_key_query_params_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams], jsii.get(self, "cacheKeyQueryParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewriteInput")
    def cache_key_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite], jsii.get(self, "cacheKeyRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="cachePostInput")
    def cache_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost], jsii.get(self, "cachePostInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirectInput")
    def cache_redirect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect], jsii.get(self, "cacheRedirectInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagInput")
    def cache_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag], jsii.get(self, "cacheTagInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisibleInput")
    def cache_tag_visible_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible], jsii.get(self, "cacheTagVisibleInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorizationInput")
    def central_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization], jsii.get(self, "centralAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirectsInput")
    def chase_redirects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects], jsii.get(self, "chaseRedirectsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAuthInput")
    def client_certificate_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth], jsii.get(self, "clientCertificateAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristicsInput")
    def client_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics], jsii.get(self, "clientCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnectsInput")
    def cloud_interconnects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects], jsii.get(self, "cloudInterconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvancedInput")
    def cloud_wrapper_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced], jsii.get(self, "cloudWrapperAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperInput")
    def cloud_wrapper_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper], jsii.get(self, "cloudWrapperInput"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientDataInput")
    def common_media_client_data_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData], jsii.get(self, "commonMediaClientDataInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOriginInput")
    def conditional_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin], jsii.get(self, "conditionalOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="constructResponseInput")
    def construct_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse], jsii.get(self, "constructResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmdInput")
    def content_characteristics_amd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd], jsii.get(self, "contentCharacteristicsAmdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDdInput")
    def content_characteristics_dd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd], jsii.get(self, "contentCharacteristicsDdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsInput")
    def content_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics], jsii.get(self, "contentCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFileInput")
    def content_characteristics_wsd_large_file_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "contentCharacteristicsWsdLargeFileInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLiveInput")
    def content_characteristics_wsd_live_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive], jsii.get(self, "contentCharacteristicsWsdLiveInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVodInput")
    def content_characteristics_wsd_vod_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod], jsii.get(self, "contentCharacteristicsWsdVodInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePositionInput")
    def content_pre_position_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition], jsii.get(self, "contentPrePositionInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtectionInput")
    def content_targeting_protection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection], jsii.get(self, "contentTargetingProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="corsSupportInput")
    def cors_support_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport], jsii.get(self, "corsSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="customBehaviorInput")
    def custom_behavior_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior], jsii.get(self, "customBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamInput")
    def datastream_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream], jsii.get(self, "datastreamInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformationInput")
    def dcp_auth_hmac_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation], jsii.get(self, "dcpAuthHmacTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformationInput")
    def dcp_auth_regex_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation], jsii.get(self, "dcpAuthRegexTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformationInput")
    def dcp_auth_substring_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation], jsii.get(self, "dcpAuthSubstringTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractorInput")
    def dcp_auth_variable_extractor_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor], jsii.get(self, "dcpAuthVariableExtractorInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroupsInput")
    def dcp_default_authz_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups], jsii.get(self, "dcpDefaultAuthzGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelationsInput")
    def dcp_dev_relations_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations], jsii.get(self, "dcpDevRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpInput")
    def dcp_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp], jsii.get(self, "dcpInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuthInput")
    def dcp_real_time_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth], jsii.get(self, "dcpRealTimeAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceiptInput")
    def delivery_receipt_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt], jsii.get(self, "deliveryReceiptInput"))

    @builtins.property
    @jsii.member(jsii_name="denyAccessInput")
    def deny_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess], jsii.get(self, "denyAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccessInput")
    def deny_direct_failover_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess], jsii.get(self, "denyDirectFailoverAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheIdInput")
    def device_characteristic_cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId], jsii.get(self, "deviceCharacteristicCacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeaderInput")
    def device_characteristic_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader], jsii.get(self, "deviceCharacteristicHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefreshInput")
    def dns_async_refresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh], jsii.get(self, "dnsAsyncRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefreshInput")
    def dns_prefresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh], jsii.get(self, "dnsPrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocolInput")
    def downgrade_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol], jsii.get(self, "downgradeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarkerInput")
    def download_complete_marker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker], jsii.get(self, "downloadCompleteMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotificationInput")
    def download_notification_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification], jsii.get(self, "downloadNotificationInput"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCacheInput")
    def downstream_cache_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache], jsii.get(self, "downstreamCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationInput")
    def dynamic_throughtput_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization], jsii.get(self, "dynamicThroughtputOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverrideInput")
    def dynamic_throughtput_optimization_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "dynamicThroughtputOptimizationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUploadInput")
    def ecms_bulk_upload_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload], jsii.get(self, "ecmsBulkUploadInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabaseInput")
    def ecms_database_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase], jsii.get(self, "ecmsDatabaseInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatasetInput")
    def ecms_dataset_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset], jsii.get(self, "ecmsDatasetInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKeyInput")
    def ecms_object_key_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey], jsii.get(self, "ecmsObjectKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnectInput")
    def edge_connect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect], jsii.get(self, "edgeConnectInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvancedInput")
    def edge_load_balancing_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "edgeLoadBalancingAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenterInput")
    def edge_load_balancing_data_center_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "edgeLoadBalancingDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOriginInput")
    def edge_load_balancing_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "edgeLoadBalancingOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorizationInput")
    def edge_origin_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization], jsii.get(self, "edgeOriginAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirectorInput")
    def edge_redirector_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector], jsii.get(self, "edgeRedirectorInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeScapeInput")
    def edge_scape_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape], jsii.get(self, "edgeScapeInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludesInput")
    def edge_side_includes_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes], jsii.get(self, "edgeSideIncludesInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerInput")
    def edge_worker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker], jsii.get(self, "edgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsSettingsInput")
    def enforce_mtls_settings_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings], jsii.get(self, "enforceMtlsSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocolInput")
    def enhanced_akamai_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol], jsii.get(self, "enhancedAkamaiProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetectionInput")
    def enhanced_proxy_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection], jsii.get(self, "enhancedProxyDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichmentInput")
    def epd_forward_header_enrichment_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "epdForwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="failActionInput")
    def fail_action_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction], jsii.get(self, "failActionInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibilityInput")
    def failover_bot_manager_feature_compatibility_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "failoverBotManagerFeatureCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidateInput")
    def fast_invalidate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate], jsii.get(self, "fastInvalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="fipsInput")
    def fips_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips], jsii.get(self, "fipsInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingInput")
    def first_party_marketing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing], jsii.get(self, "firstPartyMarketingInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlusInput")
    def first_party_marketing_plus_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus], jsii.get(self, "firstPartyMarketingPlusInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewriteInput")
    def forward_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite], jsii.get(self, "forwardRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OheaderInput")
    def g2_oheader_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader], jsii.get(self, "g2OheaderInput"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumberInput")
    def global_request_number_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber], jsii.get(self, "globalRequestNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCachingInput")
    def graphql_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching], jsii.get(self, "graphqlCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponseInput")
    def gzip_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse], jsii.get(self, "gzipResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvancedInput")
    def hd_data_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced], jsii.get(self, "hdDataAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="healthDetectionInput")
    def health_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection], jsii.get(self, "healthDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBindingInput")
    def hsaf_eip_binding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding], jsii.get(self, "hsafEipBindingInput"))

    @builtins.property
    @jsii.member(jsii_name="http2Input")
    def http2_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2], jsii.get(self, "http2Input"))

    @builtins.property
    @jsii.member(jsii_name="http3Input")
    def http3_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3], jsii.get(self, "http3Input"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurityInput")
    def http_strict_transport_security_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity], jsii.get(self, "httpStrictTransportSecurityInput"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgradeInput")
    def http_to_https_upgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade], jsii.get(self, "httpToHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManagerInput")
    def image_and_video_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager], jsii.get(self, "imageAndVideoManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerInput")
    def image_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager], jsii.get(self, "imageManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideoInput")
    def image_manager_video_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo], jsii.get(self, "imageManagerVideoInput"))

    @builtins.property
    @jsii.member(jsii_name="imOverrideInput")
    def im_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride], jsii.get(self, "imOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="includeInput")
    def include_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude], jsii.get(self, "includeInput"))

    @builtins.property
    @jsii.member(jsii_name="instantConfigInput")
    def instant_config_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig], jsii.get(self, "instantConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="instantInput")
    def instant_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant], jsii.get(self, "instantInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvancedInput")
    def large_file_optimization_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "largeFileOptimizationAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationInput")
    def large_file_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization], jsii.get(self, "largeFileOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRateInput")
    def limit_bit_rate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate], jsii.get(self, "limitBitRateInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomInput")
    def log_custom_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom], jsii.get(self, "logCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalizationInput")
    def manifest_personalization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization], jsii.get(self, "manifestPersonalizationInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestReroutingInput")
    def manifest_rerouting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting], jsii.get(self, "manifestReroutingInput"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPushInput")
    def manual_server_push_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush], jsii.get(self, "manualServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationInput")
    def media_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration], jsii.get(self, "mediaAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptoutInput")
    def media_acceleration_quic_optout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout], jsii.get(self, "mediaAccelerationQuicOptoutInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaClientInput")
    def media_client_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient], jsii.get(self, "mediaClientInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimizationInput")
    def media_file_retrieval_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization], jsii.get(self, "mediaFileRetrievalOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailoverInput")
    def media_origin_failover_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover], jsii.get(self, "mediaOriginFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataCachingInput")
    def metadata_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching], jsii.get(self, "metadataCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformanceInput")
    def mobile_sdk_performance_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance], jsii.get(self, "mobileSdkPerformanceInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeaderInput")
    def modify_incoming_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader], jsii.get(self, "modifyIncomingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeaderInput")
    def modify_incoming_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader], jsii.get(self, "modifyIncomingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeaderInput")
    def modify_outgoing_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader], jsii.get(self, "modifyOutgoingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeaderInput")
    def modify_outgoing_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader], jsii.get(self, "modifyOutgoingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeaderInput")
    def modify_via_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader], jsii.get(self, "modifyViaHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsInput")
    def origin_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics], jsii.get(self, "originCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsdInput")
    def origin_characteristics_wsd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd], jsii.get(self, "originCharacteristicsWsdInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethodInput")
    def origin_failure_recovery_method_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod], jsii.get(self, "originFailureRecoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicyInput")
    def origin_failure_recovery_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "originFailureRecoveryPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="originIpAclInput")
    def origin_ip_acl_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl], jsii.get(self, "originIpAclInput"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyInput")
    def permissions_policy_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy"], jsii.get(self, "permissionsPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnectionInput")
    def persistent_client_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection"], jsii.get(self, "persistentClientConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnectionInput")
    def persistent_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection"], jsii.get(self, "persistentConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformationInput")
    def personally_identifiable_information_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation"], jsii.get(self, "personallyIdentifiableInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="phasedReleaseInput")
    def phased_release_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease"], jsii.get(self, "phasedReleaseInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectInput")
    def preconnect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect"], jsii.get(self, "preconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDeliveryInput")
    def predictive_content_delivery_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery"], jsii.get(self, "predictiveContentDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetchingInput")
    def predictive_prefetching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching"], jsii.get(self, "predictivePrefetchingInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchableInput")
    def prefetchable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable"], jsii.get(self, "prefetchableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch"], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCacheInput")
    def prefresh_cache_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache"], jsii.get(self, "prefreshCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="qualityInput")
    def quality_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality"], jsii.get(self, "qualityInput"))

    @builtins.property
    @jsii.member(jsii_name="quicBetaInput")
    def quic_beta_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta"], jsii.get(self, "quicBetaInput"))

    @builtins.property
    @jsii.member(jsii_name="randomSeekInput")
    def random_seek_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek"], jsii.get(self, "randomSeekInput"))

    @builtins.property
    @jsii.member(jsii_name="rapidInput")
    def rapid_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid"], jsii.get(self, "rapidInput"))

    @builtins.property
    @jsii.member(jsii_name="readTimeoutInput")
    def read_timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout"], jsii.get(self, "readTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReportingInput")
    def real_time_reporting_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting"], jsii.get(self, "realTimeReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring"], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect"], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectplusInput")
    def redirectplus_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus"], jsii.get(self, "redirectplusInput"))

    @builtins.property
    @jsii.member(jsii_name="refererCheckingInput")
    def referer_checking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking"], jsii.get(self, "refererCheckingInput"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameterInput")
    def remove_query_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter"], jsii.get(self, "removeQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="removeVaryInput")
    def remove_vary_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary"], jsii.get(self, "removeVaryInput"))

    @builtins.property
    @jsii.member(jsii_name="reportInput")
    def report_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport"], jsii.get(self, "reportInput"))

    @builtins.property
    @jsii.member(jsii_name="requestClientHintsInput")
    def request_client_hints_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints"], jsii.get(self, "requestClientHintsInput"))

    @builtins.property
    @jsii.member(jsii_name="requestControlInput")
    def request_control_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl"], jsii.get(self, "requestControlInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarkerInput")
    def request_type_marker_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker"], jsii.get(self, "requestTypeMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibilityInput")
    def resource_optimizer_extended_compatibility_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility"], jsii.get(self, "resourceOptimizerExtendedCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerInput")
    def resource_optimizer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer"], jsii.get(self, "resourceOptimizerInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode"], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCookieInput")
    def response_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie"], jsii.get(self, "responseCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCachingInput")
    def restrict_object_caching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching"], jsii.get(self, "restrictObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatusInput")
    def return_cache_status_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus"], jsii.get(self, "returnCacheStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrlInput")
    def rewrite_url_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl"], jsii.get(self, "rewriteUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="rumCustomInput")
    def rum_custom_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom"], jsii.get(self, "rumCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitionsInput")
    def saas_definitions_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions"], jsii.get(self, "saasDefinitionsInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClientInput")
    def sales_force_commerce_cloud_client_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient"], jsii.get(self, "salesForceCommerceCloudClientInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeaderInput")
    def sales_force_commerce_cloud_provider_host_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader"], jsii.get(self, "salesForceCommerceCloudProviderHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderInput")
    def sales_force_commerce_cloud_provider_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider"], jsii.get(self, "salesForceCommerceCloudProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessingInput")
    def save_post_dca_processing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing"], jsii.get(self, "savePostDcaProcessingInput"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidationInput")
    def schedule_invalidation_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation"], jsii.get(self, "scheduleInvalidationInput"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagementInput")
    def script_management_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement"], jsii.get(self, "scriptManagementInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtectionInput")
    def segmented_content_protection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection"], jsii.get(self, "segmentedContentProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimizationInput")
    def segmented_media_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization"], jsii.get(self, "segmentedMediaOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetchInput")
    def segmented_media_streaming_prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch"], jsii.get(self, "segmentedMediaStreamingPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="setVariableInput")
    def set_variable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable"], jsii.get(self, "setVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCodeInput")
    def simulate_error_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode"], jsii.get(self, "simulateErrorCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="siteShieldInput")
    def site_shield_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield"], jsii.get(self, "siteShieldInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationInput")
    def standard_tls_migration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration"], jsii.get(self, "standardTlsMigrationInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverrideInput")
    def standard_tls_migration_override_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride"], jsii.get(self, "standardTlsMigrationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsingInput")
    def strict_header_parsing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing"], jsii.get(self, "strictHeaderParsingInput"))

    @builtins.property
    @jsii.member(jsii_name="subCustomerInput")
    def sub_customer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer"], jsii.get(self, "subCustomerInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute"], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimizationInput")
    def tcp_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization"], jsii.get(self, "tcpOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="teaLeafInput")
    def tea_leaf_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf"], jsii.get(self, "teaLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvancedInput")
    def tiered_distribution_advanced_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced"], jsii.get(self, "tieredDistributionAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomizationInput")
    def tiered_distribution_customization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization"], jsii.get(self, "tieredDistributionCustomizationInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionInput")
    def tiered_distribution_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution"], jsii.get(self, "tieredDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout"], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uidConfigurationInput")
    def uid_configuration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration"], jsii.get(self, "uidConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTagInput")
    def validate_entity_tag_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag"], jsii.get(self, "validateEntityTagInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcpInput")
    def verify_json_web_token_for_dcp_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp"], jsii.get(self, "verifyJsonWebTokenForDcpInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenInput")
    def verify_json_web_token_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken"], jsii.get(self, "verifyJsonWebTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorizationInput")
    def verify_token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization"], jsii.get(self, "verifyTokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomInput")
    def virtual_waiting_room_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom"], jsii.get(self, "virtualWaitingRoomInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkersInput")
    def virtual_waiting_room_with_edge_workers_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers"], jsii.get(self, "virtualWaitingRoomWithEdgeWorkersInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoInput")
    def visitor_prioritization_fifo_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo"], jsii.get(self, "visitorPrioritizationFifoInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandaloneInput")
    def visitor_prioritization_fifo_standalone_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone"], jsii.get(self, "visitorPrioritizationFifoStandaloneInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationInput")
    def visitor_prioritization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization"], jsii.get(self, "visitorPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="watermarkingInput")
    def watermarking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking"], jsii.get(self, "watermarkingInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall"], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="webdavInput")
    def webdav_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav"], jsii.get(self, "webdavInput"))

    @builtins.property
    @jsii.member(jsii_name="webSocketsInput")
    def web_sockets_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets"], jsii.get(self, "webSocketsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a1e5e9e5357c901f5e65b7337851ad6e850eaf8ae95f068e1eb5a7019a2dbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "allow_list": "allowList",
        "locked": "locked",
        "permissions_policy_directive": "permissionsPolicyDirective",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy:
    def __init__(
        self,
        *,
        allow_list: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_list: The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here. They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param permissions_policy_directive: Each directive represents a browser feature. Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7091a42f8be2744ce275baa24aab780a59fa71ecc9c66f85d87e4f740a834a40)
            check_type(argname="argument allow_list", value=allow_list, expected_type=type_hints["allow_list"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument permissions_policy_directive", value=permissions_policy_directive, expected_type=type_hints["permissions_policy_directive"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_list is not None:
            self._values["allow_list"] = allow_list
        if locked is not None:
            self._values["locked"] = locked
        if permissions_policy_directive is not None:
            self._values["permissions_policy_directive"] = permissions_policy_directive
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_list(self) -> typing.Optional[builtins.str]:
        '''The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here.

        They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        '''
        result = self._values.get("allow_list")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def permissions_policy_directive(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Each directive represents a browser feature.

        Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        '''
        result = self._values.get("permissions_policy_directive")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c869ae57346ffff128c9fbca826aa2d3c8b9d583006e19021cb8ffbff6beec1f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowList")
    def reset_allow_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowList", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPermissionsPolicyDirective")
    def reset_permissions_policy_directive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPermissionsPolicyDirective", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowListInput")
    def allow_list_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowListInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyDirectiveInput")
    def permissions_policy_directive_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "permissionsPolicyDirectiveInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowList")
    def allow_list(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowList"))

    @allow_list.setter
    def allow_list(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bfdcfaa6bf3d87d6b912bd48a1fe53f3ce5786888b00890edd4bd6efaf66b04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowList", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3757ec85d6ec0e9a035ed7c4b8c76b0116ddec8ef674e068dd141985c07f15e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyDirective")
    def permissions_policy_directive(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "permissionsPolicyDirective"))

    @permissions_policy_directive.setter
    def permissions_policy_directive(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb79686106ce553df2acef6899e1a460a5d15a14b175f187610538d9acbe156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "permissionsPolicyDirective", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4184d42b798a5a7fd4730d0708feb4c699a68d99c7249e87f645773d642efc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7309c6d7de0767003366bfc231d98973bb71d5d13d5576f6769c30c3a9620a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ad59ff7a58844ef8c0aba11a97e66f708de74672ee8b1affad611ed1bf9a38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a844444b9ae2ef1b7adf9eb163ea3faa424795f08f62cc60017169d3145dec)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the persistent connections behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__789b1496b02623a91086bf871837e98ccfa2f6c67ce1815c8d160547b7a4e91f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d594821377d3f2c4a64cac6b53d9b0b02f2ab40a2b6cfe80c9b42ad87e5ddae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98419358dcc94d4ea0fd72b7b54a08e5698e31a8b7e24403a1b2718f82a55d67)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__259ccedc34ddcb36fd4fa9c2f91c7e003f8923eeab056b289822865fb9b0f22f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c06543b4d0f9e28574af9d930e180366822ff56be00c3c52ae848943e19bccff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__708dcd55ea4b56c7d3e7771772185e3a0e689d25ff329a6e32bd8324048945ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0888a579fb495abf7ce8246884dcc3b84fda6f1a0931a955063943ce197d58d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__767efe347942bb0bcb55362375a85c88172d92c5d34b181149b762e33f1768fc)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables persistent connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes a persistent connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e098b4e6203486067761b47a72d41456d015666fb9bb793f93cb7fe10793d4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c1d27b3bb2715e01a06e505becc08074f963316673970d91e87cc3bfb2013d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__500c89edd8f6c54fcf1be845d0b40a2abb696deb07503f10c98e099ad37be698)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc5d00f1bbcb14d846f0f28756e0112317a87b95a9c6dcba2e1ee355ff79398)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a1bbe8d4cf80eb03f3202cdebd3b6a486aa4acffbd9733ff5f0d45d30f3fc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3fe9a81a087568e50dace00a7c19934b543a7b4367b557a977eac883007d3a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b91e8dad02e98086acb60bc1038fa305cdd1fc0ef7e0a30e5de3391f8a66c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9489cba1eabf1630658db2d66a67e2feb7a84933bf2f8b94a42ca3251effd589)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, marks content as personally identifiable information (PII).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e60d0663665b22fdd06dd558828a8100cc05f4f8e0d069464d2781e6c4c119)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eecca8a2384891110e78a17dd5c26c01d495bab38cd61ae555ab0a80ea218fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3d1c5968f18b214e23704701156b68e9a77f6ad0d6fda4440a9d5ad3740acb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b7225eeed0c82a7eaa026c693115e91cee7f494fa8d334a20102d7f893a8b3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086ddda370620d06d9ab131f1e2b69714f1533d70010c5d49566d0cb11d44eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__551623aba53fb477671612011895ff57c1cccade5054b84973da90574a7fa0f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "failover_duration": "failoverDuration",
        "failover_enabled": "failoverEnabled",
        "failover_response_code": "failoverResponseCode",
        "failover_title": "failoverTitle",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_expiration_date": "populationExpirationDate",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41361c34db4f625597ae1fcfe588e010f6f8bee2ba2093e76ea507e8919c8227)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_duration", value=failover_duration, expected_type=type_hints["failover_duration"])
            check_type(argname="argument failover_enabled", value=failover_enabled, expected_type=type_hints["failover_enabled"])
            check_type(argname="argument failover_response_code", value=failover_response_code, expected_type=type_hints["failover_response_code"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_expiration_date", value=population_expiration_date, expected_type=type_hints["population_expiration_date"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_duration is not None:
            self._values["failover_duration"] = failover_duration
        if failover_enabled is not None:
            self._values["failover_enabled"] = failover_enabled
        if failover_response_code is not None:
            self._values["failover_response_code"] = failover_response_code
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_expiration_date is not None:
            self._values["population_expiration_date"] = population_expiration_date
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Phased Release Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected.

        Set the value to ``0`` to immediately request the alternate origin upon failure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        '''
        result = self._values.get("failover_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        '''
        result = self._values.get("failover_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_response_code(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the set of failure codes that initiate the failover response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        '''
        result = self._values.get("failover_response_code")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Phased Release policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Select when to assign a cookie to the population of users the Cloudlet defines.

        If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies the date and time when membership expires, and the browser no longer sends the cookie.

        Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        '''
        result = self._values.get("population_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c13fa95efa45ffcdb76664c64a4a7dfd9f14f145170464c99b87504edcfea4)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7060da6bfbccbb454dcddcd6050c47a81586bba722238e81e11fe2d1972e6f5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a56d78905541c766edb2f3e063d4d08b3e32f6313042749c2d72faa9257455d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2ea3ee2edcf6a645843b3f7e9d86265dcc1f07abdc0c69eb572f6c96ae95239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7dfd123ddf42ad7d17fddb76e9686d2bf3e53c4f9cbdc6d173c8fa835586db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d58f2312afe0029746e3c0ef2a5b92cf80f995d4eaddde40d84de4557e6aa7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverDuration")
    def reset_failover_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverDuration", []))

    @jsii.member(jsii_name="resetFailoverEnabled")
    def reset_failover_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverEnabled", []))

    @jsii.member(jsii_name="resetFailoverResponseCode")
    def reset_failover_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverResponseCode", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationExpirationDate")
    def reset_population_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationExpirationDate", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverDurationInput")
    def failover_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverEnabledInput")
    def failover_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failoverEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCodeInput")
    def failover_response_code_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDateInput")
    def population_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aa4f0f0ae7f9db4d18eaec91f0ebb894913c46d63f4b67210f456743648e3a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a72570dc1114933f94879799e3c8bc84fa7a1180fd5bada1cf62a877af727ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverDuration")
    def failover_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverDuration"))

    @failover_duration.setter
    def failover_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e684d3b9c4a59e2e9f08cfb5d5682d127ad668dd97b803959e37a7aecce376a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverDuration", value)

    @builtins.property
    @jsii.member(jsii_name="failoverEnabled")
    def failover_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failoverEnabled"))

    @failover_enabled.setter
    def failover_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a415423eeb490129e730d23642e1d1a93ea210bee48e4c7f059c49165f8168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCode")
    def failover_response_code(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverResponseCode"))

    @failover_response_code.setter
    def failover_response_code(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27df57201cec801adcde237b6ca89d719805c92ea015646baa0998e900e1fd55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d560c32ab72d949da67d5dd9c9957b0b8d6bb7696987343ef9d14e595d13d3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57c1c94c9c87949876c00fc578552202f5c01196d9a83f45c6f5de008cbf1a8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9664b862a91ac63b7374a908270bc3c5f02ba9c50fb83293aa58602cdd8fe2ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ade9a849f7f671fee8ab8cd9eeac9c7017d0c7c57cd96cc1b1519c56941d226)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5918fdfca882b5940dbae5bdb96edc511ce8bf197f5a3a81935d9b579a66d533)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4d30a67bd0cc84ed654bff9d38c89202ade10b541f3e0701bd1676b43c37a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDate")
    def population_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationExpirationDate"))

    @population_expiration_date.setter
    def population_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f284f9af6e403cc1c450e4504ac34476fca73fb1f9b64ffd8687133f57ec9e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5fef91eaa9453f341078407c417a2ae46ea0bf3ef8a7e64c2db7c32578b24fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39156ec7cef6f3c27bcfbf80ae3be09d7c9f2694daa656f0fb92bfdaf813bc47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7acd58aef6d974a4ed7732cd1ef572aa84fc422cf651dc6da9df5804d850d71f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb5094f8c0ef56301fc26841f02785231774b0b34d4eed6ad75a26cd6633cff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a82b9d473a156163fc0d94f14eac17b18e79520808511c0627d6cf01a92e7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "preconnectlist": "preconnectlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d641ec93235a501410dd6c67efc338453018907d985c21276ec9510c3c0f1d52)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preconnectlist", value=preconnectlist, expected_type=type_hints["preconnectlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if preconnectlist is not None:
            self._values["preconnectlist"] = preconnectlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preconnectlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of hostnames to which to preconnect over HTTP2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        '''
        result = self._values.get("preconnectlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5c1ec12ab25e15ca1780c436d47fd15c11221397a52a72dcd2271d7596ae76f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreconnectlist")
    def reset_preconnectlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnectlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectlistInput")
    def preconnectlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "preconnectlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97eacd2e0a0fa7f35f143af77a001bc7a7d7bd28112a1d85c5cf84ea0928c557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preconnectlist")
    def preconnectlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "preconnectlist"))

    @preconnectlist.setter
    def preconnectlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__644dc317022ea07261dc9f581b43e4ed1c039dfbaafb67945b851f6d759766f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preconnectlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab4a47534302bee06acf9b66cfcaaacfa29700cb0d4a02c415d23b1a29f758db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b355d096176ee8080a530c2b2e06276700ae8b262b76c358a0d6b1073405a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__880727e20120d90a0deb33f2552cad9ceab185ed90394245a4b81280abe95099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acaeb4fd2ffbe23fbb6da26923ccff06801e3081b5936f66c37e60a6ea34cbf8)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive content delivery behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4533f7691b86d09d1f25d5d1e95337217fbe39a47854368b2f824f4f8288e0f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75e0514163af5918a921936aa45247a8cf9352b5c8e8ade8b58a931b798653c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a0396ae1cc99a49e6a204937fdce6caadcae0502db2d1e798b351e626d6e45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c7c459bfa47d0955d2e9add3d33a53ded16fd47c668c084e58b88e465b0fad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__307859cab62e595dc94ef9dc139cbeb5a71f7d6232358ba2fe154001328c1ccc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb357f24e3ca7c958b34a6d613cd5bbd32a58c0bb276135a6de027204b45d72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching",
    jsii_struct_bases=[],
    name_mapping={
        "accuracy_target": "accuracyTarget",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching:
    def __init__(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e577b7e43fa544c7b5b4e8c990183a856a301cdcc0d3ece6c45e0d21ba3f92)
            check_type(argname="argument accuracy_target", value=accuracy_target, expected_type=type_hints["accuracy_target"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accuracy_target is not None:
            self._values["accuracy_target"] = accuracy_target
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accuracy_target(self) -> typing.Optional[builtins.str]:
        '''The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        '''
        result = self._values.get("accuracy_target")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive prefetching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b72ab2ddf5dd55ef25ff0cd3e57d01b122b20c42670fde1f057184bdf89683e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccuracyTarget")
    def reset_accuracy_target(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccuracyTarget", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accuracyTargetInput")
    def accuracy_target_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accuracyTargetInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accuracyTarget")
    def accuracy_target(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accuracyTarget"))

    @accuracy_target.setter
    def accuracy_target(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e7bf6fa054a6e19d0f55f64ae8eb3a0873ef1fe4e04ed12b352dba2869fc7c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accuracyTarget", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fed03ee3d691027749b8913d726d7f4ce133819e707fbe644a7e21c91087a09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a26726e8e9d5a43fa53d006eeee510c5d4a37bf81bd5a1b5bac34756d1b23718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4f277d79c5c69d6dee7ca0780a1d788dc2946c3c179d6b2a6dcceee6a458f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7fa7634399f62721d660a37f8b071c48d40ac26a880000bb39d7df98953d697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b3678137d372b0f924a912ee638187a46dd9e12a9290757a4529c7a84ead19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10f3f3096aa3f24fda4fc1c2d2b08fabb7ae56a20ec0e05d9a7ae7bfbe9b93a7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies prefetching behavior when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__013a454bd9e01a789cc34d1b431d34046f68405b7cb7f5dc1ed9e4bb2d3020be)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d773784cc4448ddef033d44e5b5faff8972c8a37a1e186767ac1b75a04abc545)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a1ca48559594137d5a76a47ff69a855cd910e0f36a524b98fea55641ea07636)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48dc52adc7470d3dae6c3392620c719b7fba62759ef914b0967ea284a231b8a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a92fae0dcb9370b7c5a95742bfeae8250e3e40ee4a4785fbd48961927dac386c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45db2584085222f775df4de053c4f1bbbe64aa028bd7996e646d767a37f8c01a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b035848acc4ea0ebc022a2af1c20b45064d30c564b83b35e8a3d47a1a439e0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows matching content to prefetch when referenced on a requested parent page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62ceb9a398ff89ba54b7ccbfe27e166076fcacc3c8139d30ebe69cd58476d0c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21caf1d234e0b05cfa776bea9aae54936e580d407844c659e5d611491038e57e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1081ef0d81b0dffb1139ef0fe9c71a5bce8b574bdab74d4d5fddc9cf608b2301)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27b076440fc59cddd49e4a0c81b07eef8b268d56ad0095dbe49ab3d89b9f36aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2214cff0d5d923800e393e80c8693d9067c61572894082e4ac0e28842bb7846d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7458dc3d3c3c127bb671774bafbd434d3634ec83df19cfb8287619502efcb8c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "prefreshval": "prefreshval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b7f28827ff670c9132005613ec86fc081625f997a0b152b5582ab96b7d5c24)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefreshval", value=prefreshval, expected_type=type_hints["prefreshval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if prefreshval is not None:
            self._values["prefreshval"] = prefreshval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cache prefreshing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefreshval(self) -> typing.Optional[jsii.Number]:
        '''Specifies when the prefresh occurs as a percentage of the TTL.

        For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        '''
        result = self._values.get("prefreshval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f637848654ac62ff5cb3da7db1df2bd653934220e91234c5cbdde60fcf9e2dbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefreshval")
    def reset_prefreshval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshvalInput")
    def prefreshval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefreshvalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7e6431101f9c8dc19e5ce551ef3cdc64e4b98b0eb18796fa14e0ebcc7928e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__344b2f33f8a95d105405c27dd8643d119b76c276b59d5c93e6f1e23391a9d705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefreshval")
    def prefreshval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefreshval"))

    @prefreshval.setter
    def prefreshval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b515b788cf1173e804e8927937cc14007e1910ca04e443ee89d5b729d0b1b6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefreshval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5a71113af6114c4e28700df8370dcfb64a0570420f61105fcf6d520703c4712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2fceb7559667960878c5437fa14ac5c571ef4ca98f9a2097c0c1cd8bb374d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24127acf66c7bfd101fa5605ca7f26077c1fd43105e5939680b5b02fe890431c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality",
    jsii_struct_bases=[],
    name_mapping={
        "audience_settings": "audienceSettings",
        "catalog_size": "catalogSize",
        "content_settings": "contentSettings",
        "content_type": "contentType",
        "country": "country",
        "delivery_format": "deliveryFormat",
        "delivery_type": "deliveryType",
        "download_type": "downloadType",
        "end_user_location": "endUserLocation",
        "locked": "locked",
        "maximum_concurrent_users": "maximumConcurrentUsers",
        "object_size": "objectSize",
        "optimize_for": "optimizeFor",
        "origin_settings": "originSettings",
        "popularity_distribution": "popularityDistribution",
        "refresh_rate": "refreshRate",
        "segment_duration": "segmentDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality:
    def __init__(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27d1bd73d296d2d91a1da39976ed167da28e4dbce280f00a8b6262cb9bed2d4c)
            check_type(argname="argument audience_settings", value=audience_settings, expected_type=type_hints["audience_settings"])
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_settings", value=content_settings, expected_type=type_hints["content_settings"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument delivery_format", value=delivery_format, expected_type=type_hints["delivery_format"])
            check_type(argname="argument delivery_type", value=delivery_type, expected_type=type_hints["delivery_type"])
            check_type(argname="argument download_type", value=download_type, expected_type=type_hints["download_type"])
            check_type(argname="argument end_user_location", value=end_user_location, expected_type=type_hints["end_user_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_concurrent_users", value=maximum_concurrent_users, expected_type=type_hints["maximum_concurrent_users"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_for", value=optimize_for, expected_type=type_hints["optimize_for"])
            check_type(argname="argument origin_settings", value=origin_settings, expected_type=type_hints["origin_settings"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument refresh_rate", value=refresh_rate, expected_type=type_hints["refresh_rate"])
            check_type(argname="argument segment_duration", value=segment_duration, expected_type=type_hints["segment_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if audience_settings is not None:
            self._values["audience_settings"] = audience_settings
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_settings is not None:
            self._values["content_settings"] = content_settings
        if content_type is not None:
            self._values["content_type"] = content_type
        if country is not None:
            self._values["country"] = country
        if delivery_format is not None:
            self._values["delivery_format"] = delivery_format
        if delivery_type is not None:
            self._values["delivery_type"] = delivery_type
        if download_type is not None:
            self._values["download_type"] = download_type
        if end_user_location is not None:
            self._values["end_user_location"] = end_user_location
        if locked is not None:
            self._values["locked"] = locked
        if maximum_concurrent_users is not None:
            self._values["maximum_concurrent_users"] = maximum_concurrent_users
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_for is not None:
            self._values["optimize_for"] = optimize_for
        if origin_settings is not None:
            self._values["origin_settings"] = origin_settings
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if refresh_rate is not None:
            self._values["refresh_rate"] = refresh_rate
        if segment_duration is not None:
            self._values["segment_duration"] = segment_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def audience_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        '''
        result = self._values.get("audience_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.'''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        '''
        result = self._values.get("content_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.'''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.'''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.'''
        result = self._values.get("delivery_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.'''
        result = self._values.get("delivery_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def download_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.'''
        result = self._values.get("download_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_user_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.'''
        result = self._values.get("end_user_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_concurrent_users(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.'''
        result = self._values.get("maximum_concurrent_users")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.'''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_for(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.'''
        result = self._values.get("optimize_for")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        '''
        result = self._values.get("origin_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.'''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def refresh_rate(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.'''
        result = self._values.get("refresh_rate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.'''
        result = self._values.get("segment_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d057617276ec067dfb65bf4b95a66ab5b3c07978c4f1f5612471a12c46c7ed6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAudienceSettings")
    def reset_audience_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSettings", []))

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentSettings")
    def reset_content_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentSettings", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetDeliveryFormat")
    def reset_delivery_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryFormat", []))

    @jsii.member(jsii_name="resetDeliveryType")
    def reset_delivery_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryType", []))

    @jsii.member(jsii_name="resetDownloadType")
    def reset_download_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadType", []))

    @jsii.member(jsii_name="resetEndUserLocation")
    def reset_end_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndUserLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumConcurrentUsers")
    def reset_maximum_concurrent_users(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumConcurrentUsers", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeFor")
    def reset_optimize_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeFor", []))

    @jsii.member(jsii_name="resetOriginSettings")
    def reset_origin_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSettings", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetRefreshRate")
    def reset_refresh_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshRate", []))

    @jsii.member(jsii_name="resetSegmentDuration")
    def reset_segment_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="audienceSettingsInput")
    def audience_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "audienceSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentSettingsInput")
    def content_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryFormatInput")
    def delivery_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryTypeInput")
    def delivery_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadTypeInput")
    def download_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="endUserLocationInput")
    def end_user_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endUserLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsersInput")
    def maximum_concurrent_users_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumConcurrentUsersInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeForInput")
    def optimize_for_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optimizeForInput"))

    @builtins.property
    @jsii.member(jsii_name="originSettingsInput")
    def origin_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshRateInput")
    def refresh_rate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshRateInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationInput")
    def segment_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSettings")
    def audience_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "audienceSettings"))

    @audience_settings.setter
    def audience_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c6c727df368c87cc1b6fb6e1662d8c5feea54f174f2a5279455c42314f01dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "audienceSettings", value)

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58f142d74a8c9491b79e1b8356e51fa745f07cfedc3d4d387c15739793941612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentSettings")
    def content_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentSettings"))

    @content_settings.setter
    def content_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31f754fc7ec2583b0711336d59d7f9a37381e1a8bbc5f738b2310826891d7522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentSettings", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76845ab13106a0d4b7767284279fee639258f232c8dc49f4c6145a6d6223df9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69bc1298051ff01e8b3958531d3a4b6c20010135b2d8088fe656601db7a8cf88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryFormat")
    def delivery_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryFormat"))

    @delivery_format.setter
    def delivery_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99770e704f81b6d626889a4aae65af5aec03f0b31a173756ab0d2ac83452ffc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryFormat", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryType")
    def delivery_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryType"))

    @delivery_type.setter
    def delivery_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d64a05590a6c5bb81ddbbe691c696992bfd91e866fd0222b3e775f641f5bf05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryType", value)

    @builtins.property
    @jsii.member(jsii_name="downloadType")
    def download_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadType"))

    @download_type.setter
    def download_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b030cf773f1565b0783693eec3ad6ab69782fc9f8e84e3659f77d69d298b09b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadType", value)

    @builtins.property
    @jsii.member(jsii_name="endUserLocation")
    def end_user_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endUserLocation"))

    @end_user_location.setter
    def end_user_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__597aeea36c0c5fcdb99b266a1b83c26f05ae16df17057f7feeb94a1913c8d1a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endUserLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eab63d412f395371423cba36f3b4bbbf0e0853eab0605fe4ce71cd4fd2d7721b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsers")
    def maximum_concurrent_users(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumConcurrentUsers"))

    @maximum_concurrent_users.setter
    def maximum_concurrent_users(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f91ba844db6e8ffc1808e6dd765ddac5566e49cf2b120cc76cf5091c7e5c6a21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumConcurrentUsers", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5bd104dc2f8502aa3b151b0eb7a1c0f839b5cd79963f2e4818749eb87698f94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeFor")
    def optimize_for(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optimizeFor"))

    @optimize_for.setter
    def optimize_for(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95851a32c7aeffb975b46b61412f34d28674d9603ded346573c1c71d1ef9c135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeFor", value)

    @builtins.property
    @jsii.member(jsii_name="originSettings")
    def origin_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originSettings"))

    @origin_settings.setter
    def origin_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ff69946cdd074000984bc8c945c4d30af3d55d3bd441f0aae98b8726f0a9449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSettings", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f8d624a800e17eabe1419b12b73f894428dab9440cae2de8d6308de2b032a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="refreshRate")
    def refresh_rate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshRate"))

    @refresh_rate.setter
    def refresh_rate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e725958adb55da9084927bd561ca6875657b4036815261010b69d4aaddc4b97a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshRate", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDuration")
    def segment_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDuration"))

    @segment_duration.setter
    def segment_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cc383b0dc4297103ad44bbf85370db8ee8f51a922a6878b9e2e6a94e7f9069a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fd7dbeb2d1693be25921209c8c88f7ba18b12c340261d4c45d20f04eb280795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c540a83b19cbc9a176dd137edb5f5333a7699011b3fd54aa99539ba8d555c38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec0ead812748bf89238991531b174f737a15eb86a6d5b6386322a4e422bf7e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "quic_offer_percentage": "quicOfferPercentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a43ba58a3adc60d15bf57373db149414d7b26674f5235d28e59ba21c38fdb0dc)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument quic_offer_percentage", value=quic_offer_percentage, expected_type=type_hints["quic_offer_percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if quic_offer_percentage is not None:
            self._values["quic_offer_percentage"] = quic_offer_percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables QUIC support.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def quic_offer_percentage(self) -> typing.Optional[jsii.Number]:
        '''The percentage of responses for which to allow QUIC sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        '''
        result = self._values.get("quic_offer_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253bdca8576b6ede4e79dc0ea47b4b531e819699d6f49655ba5e48307ad1915b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQuicOfferPercentage")
    def reset_quic_offer_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicOfferPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentageInput")
    def quic_offer_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "quicOfferPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ca9fd6f639b7a476b5fc5a03d6fc9e908e2901157dee6538ed9e56bd033a125)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71dac56e54b400dfbcd14adff9a2fce05933188dae53093133a6c654d3a1431c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentage")
    def quic_offer_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "quicOfferPercentage"))

    @quic_offer_percentage.setter
    def quic_offer_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48cdcebb1cacacd54a36d3daeafecf21f527f9c435b01b463d6ddfa488f1d815)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "quicOfferPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78da5ae0cf9da33602f3fcc7b4d709211d28e66bef1e8b812a6de9412b52ccb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60e05198d5cc364a60f8cffb50615a3ca77d822a5d0261dca0e45ee722ff855f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7a89e08d69471d335511da2c1b9c80a21463b7e504aed466c13fa915ef1207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek",
    jsii_struct_bases=[],
    name_mapping={
        "flv": "flv",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "mp4": "mp4",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek:
    def __init__(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5970346df3002977e9deb0953e61504b4d5abaee163f3bdc67d06849ea782d2b)
            check_type(argname="argument flv", value=flv, expected_type=type_hints["flv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument mp4", value=mp4, expected_type=type_hints["mp4"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if flv is not None:
            self._values["flv"] = flv
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if mp4 is not None:
            self._values["mp4"] = mp4
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def flv(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in FLV files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        '''
        result = self._values.get("flv")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mp4(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in MP4 files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        '''
        result = self._values.get("mp4")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__055d04980750e4261c59ef7bfb2761b10f63fa2c168ad7133c7517f0670eb6d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFlv")
    def reset_flv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFlv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMp4")
    def reset_mp4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMp4", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="flvInput")
    def flv_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "flvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="mp4Input")
    def mp4_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mp4Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="flv")
    def flv(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "flv"))

    @flv.setter
    def flv(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__174e93ed3ee196be557ef005dd2f3acd240c7fe3dfeab416902fd25fff973a2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "flv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0513416aa8b1021355a4816608bc1f9912c88f73169aa1d7d961c6ef1294beac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39423145ec24e4b328fae731a5db24143467c6cb26d43fd17be8ed7ff61b8f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="mp4")
    def mp4(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mp4"))

    @mp4.setter
    def mp4(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67d4a065d5a17e5856c79be58d6bb36c2e25aa77baac2092a33fc789e0d3f930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mp4", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa0cd353d9ac6ca5f9d7b01027e85caab1f946c249830d3e66f571398aee7ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9fd9fa51bdceec7bf0b6d120f9335361cd9f75a0ecbb36d45c0569d89fed604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f926af6e2a13b8875c69cd97183e95c64c1c1d7ddf963a65c487caecda692ceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2cb451f7189d6542fc104005f5359c826547513375a2514e505fbbd30adedc7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables API Gateway for the current set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6fb5ff6b4787392387a5469172a344fa4bb4b97fa3d6831623035e87050c6dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4ae8122a2c35c52e2e60ad084e28e1d7e221d10afe5b18597b866bedc80854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4e69a4de55b2fff4321a33015666add85998c76d932b7beaab86f81c354b3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__364a0257d4deb11d189a8d32fdecc152b2ed703edc2bb3316890988168b4dae7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7835dfa4769271147e229eaa19a1415bc5165c4e4a8f9689f77d7410540532b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2cfc2072fc6f8c70b3d867eaa0da77ed385ee058d24825f035bc26422025ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fe50d4a82ca62e1fb4ac7d0b891d307f2a0049dba9ce236e605af1f69facf14)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b55dc2ffce737f8bcd340bab3048ee86e2bb57c93d984130da7efef55aaaf61)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf3b4712b3b1bdd7494f6b00394d83f76789f4a394f5147a42ffe74802a5430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__286cb0eafcfb3894a40a6b7a60d01986abdcf049113a59673647fa3bb0106e41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa145f977f9276bb2a982cf647618e512e92eb81d25af654b36d53288eff7bb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15419091fc6f4ba99669312da26cad0bc69c1c48199376633e3f928bddda6f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36640e0c813dcf959e6a36c8c28882e1a7745acae046fa3c22e42c3e7b830ee5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "beacon_sampling_percentage": "beaconSamplingPercentage",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34805d27f44bbe6c02477e00ad3933f42d18ef69571d90498f7bcf2b83053ce2)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument beacon_sampling_percentage", value=beacon_sampling_percentage, expected_type=type_hints["beacon_sampling_percentage"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if beacon_sampling_percentage is not None:
            self._values["beacon_sampling_percentage"] = beacon_sampling_percentage
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables advanced options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def beacon_sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage for sampling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        '''
        result = self._values.get("beacon_sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables reports on delivery of cloud hosted content at near real-time latencies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd204ecdad3838133d817957b3dbef3781f2e11210aaf11706fe51c51cb48ebd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetBeaconSamplingPercentage")
    def reset_beacon_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconSamplingPercentage", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentageInput")
    def beacon_sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "beaconSamplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef659bcad549eae4691c8eff5df824da5270bf4ebd868180cced2b833f34c5f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentage")
    def beacon_sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "beaconSamplingPercentage"))

    @beacon_sampling_percentage.setter
    def beacon_sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfc510bee70e2a08d9e9caa32ac563b1629e0493065848189000c9dd7a35954f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconSamplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9290662611f7715af534b0467fd016808d83ebef36a5c4ca7e8e8de4cd3522ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f71f087ecbab52743b321fb712a0e982559e3d3837ada1568540fc9011a34807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f66efa8a0d1b4e30adecf5da51ca815bf4652a0d25c2cf6257bcc1b7a92b78a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20db63cdeb8425344716569a2bed3d2065d2c6331aa5e0ac57e26ccd0e1eedf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cff37fed091a37ca7e72bd4231fdfb95ce95dee43d10d8a3eb5fb8a28770688d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0eb58ea0f9c0177de90a9e14f65df403cf9cfb0dc87e45334833db55a30211)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates real-use monitoring.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52795ea15deed02e42c2c25ade7b9b2febcf947f5643114fe144f76a10108e4a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67e593849ea20ad73772fd59f8787459d4757bb7ef6832bd3e03c7bec1b31fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85dc006cfa3b302d96e632087ef7157e6400b052994a63099ccde4b8b69f2391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab1f0a49875cb2c9311364a9f58bded6363c4263267fe17b0af0994d8105da01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ea4025e26e5636c3291c2a1f4698da35b4c13e3e89cfd6b7e39eb5978e974e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dab28de30c4f83b398a1f2c316d9e10fd2abbb0ae058dddface68eb57ecd240a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "destination_hostname": "destinationHostname",
        "destination_hostname_other": "destinationHostnameOther",
        "destination_hostname_sibling": "destinationHostnameSibling",
        "destination_hostname_subdomain": "destinationHostnameSubdomain",
        "destination_path": "destinationPath",
        "destination_path_other": "destinationPathOther",
        "destination_path_prefix": "destinationPathPrefix",
        "destination_path_suffix": "destinationPathSuffix",
        "destination_path_suffix_status": "destinationPathSuffixStatus",
        "destination_protocol": "destinationProtocol",
        "locked": "locked",
        "mobile_default_choice": "mobileDefaultChoice",
        "query_string": "queryString",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect:
    def __init__(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e89015165069709e41d58f87ebd9064d1fe4947942973562829d99ae22749cc5)
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_hostname_other", value=destination_hostname_other, expected_type=type_hints["destination_hostname_other"])
            check_type(argname="argument destination_hostname_sibling", value=destination_hostname_sibling, expected_type=type_hints["destination_hostname_sibling"])
            check_type(argname="argument destination_hostname_subdomain", value=destination_hostname_subdomain, expected_type=type_hints["destination_hostname_subdomain"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument destination_path_other", value=destination_path_other, expected_type=type_hints["destination_path_other"])
            check_type(argname="argument destination_path_prefix", value=destination_path_prefix, expected_type=type_hints["destination_path_prefix"])
            check_type(argname="argument destination_path_suffix", value=destination_path_suffix, expected_type=type_hints["destination_path_suffix"])
            check_type(argname="argument destination_path_suffix_status", value=destination_path_suffix_status, expected_type=type_hints["destination_path_suffix_status"])
            check_type(argname="argument destination_protocol", value=destination_protocol, expected_type=type_hints["destination_protocol"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mobile_default_choice", value=mobile_default_choice, expected_type=type_hints["mobile_default_choice"])
            check_type(argname="argument query_string", value=query_string, expected_type=type_hints["query_string"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_hostname_other is not None:
            self._values["destination_hostname_other"] = destination_hostname_other
        if destination_hostname_sibling is not None:
            self._values["destination_hostname_sibling"] = destination_hostname_sibling
        if destination_hostname_subdomain is not None:
            self._values["destination_hostname_subdomain"] = destination_hostname_subdomain
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if destination_path_other is not None:
            self._values["destination_path_other"] = destination_path_other
        if destination_path_prefix is not None:
            self._values["destination_path_prefix"] = destination_path_prefix
        if destination_path_suffix is not None:
            self._values["destination_path_suffix"] = destination_path_suffix
        if destination_path_suffix_status is not None:
            self._values["destination_path_suffix_status"] = destination_path_suffix_status
        if destination_protocol is not None:
            self._values["destination_protocol"] = destination_protocol
        if locked is not None:
            self._values["locked"] = locked
        if mobile_default_choice is not None:
            self._values["mobile_default_choice"] = mobile_default_choice
        if query_string is not None:
            self._values["query_string"] = query_string
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested hostname, independently from the pathname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_other(self) -> typing.Optional[builtins.str]:
        '''Specifies the full hostname with which to replace the current hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        '''
        result = self._values.get("destination_hostname_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_sibling(self) -> typing.Optional[builtins.str]:
        '''Specifies the subdomain with which to replace to the current hostname's leftmost subdomain.

        For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        '''
        result = self._values.get("destination_hostname_sibling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_subdomain(self) -> typing.Optional[builtins.str]:
        '''Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        '''
        result = self._values.get("destination_hostname_subdomain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested pathname, independently from the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_other(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        '''
        result = self._values.get("destination_path_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_prefix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path.

        For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        '''
        result = self._values.get("destination_path_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        '''
        result = self._values.get("destination_path_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix_status(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        '''
        result = self._values.get("destination_path_suffix_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_protocol(self) -> typing.Optional[builtins.str]:
        '''Choose the protocol for the redirect URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        '''
        result = self._values.get("destination_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mobile_default_choice(self) -> typing.Optional[builtins.str]:
        '''Either specify a default response for mobile browsers, or customize your own.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        '''
        result = self._values.get("mobile_default_choice")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_string(self) -> typing.Optional[builtins.str]:
        '''When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL.

        Otherwise set this to ``IGNORE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        '''
        result = self._values.get("query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Specify the redirect's response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9699fc8fce939ead677e17a40f9798f16cdac0de461e0498135378a0049ec1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationHostnameOther")
    def reset_destination_hostname_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameOther", []))

    @jsii.member(jsii_name="resetDestinationHostnameSibling")
    def reset_destination_hostname_sibling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSibling", []))

    @jsii.member(jsii_name="resetDestinationHostnameSubdomain")
    def reset_destination_hostname_subdomain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSubdomain", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetDestinationPathOther")
    def reset_destination_path_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathOther", []))

    @jsii.member(jsii_name="resetDestinationPathPrefix")
    def reset_destination_path_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathPrefix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffix")
    def reset_destination_path_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffixStatus")
    def reset_destination_path_suffix_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffixStatus", []))

    @jsii.member(jsii_name="resetDestinationProtocol")
    def reset_destination_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationProtocol", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMobileDefaultChoice")
    def reset_mobile_default_choice(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileDefaultChoice", []))

    @jsii.member(jsii_name="resetQueryString")
    def reset_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryString", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOtherInput")
    def destination_hostname_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSiblingInput")
    def destination_hostname_sibling_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSiblingInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomainInput")
    def destination_hostname_subdomain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSubdomainInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathOtherInput")
    def destination_path_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefixInput")
    def destination_path_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixInput")
    def destination_path_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatusInput")
    def destination_path_suffix_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationProtocolInput")
    def destination_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoiceInput")
    def mobile_default_choice_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mobileDefaultChoiceInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringInput")
    def query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96de42c906ed9d210552c1ea32373c108328dc74507c1236d5a5696bfa70b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOther")
    def destination_hostname_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameOther"))

    @destination_hostname_other.setter
    def destination_hostname_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f81e53a48e400f149d358b6457b2f7bb39827b3f5fc893bd8d899081e830c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSibling")
    def destination_hostname_sibling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSibling"))

    @destination_hostname_sibling.setter
    def destination_hostname_sibling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f2193e9f99b8fc2fdf793dbb5c62256fa6677b46439785ca1408a7f2dd9e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSibling", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomain")
    def destination_hostname_subdomain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSubdomain"))

    @destination_hostname_subdomain.setter
    def destination_hostname_subdomain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcd70b51f216aedbee5448eeee8f3549b3fee1fe0bad87fbc9ffe051aa4b9c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSubdomain", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40c4f4bc100141a468a9c1263e4bea67d62386b1dcb0d99f4637b8a3dfa051e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathOther")
    def destination_path_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathOther"))

    @destination_path_other.setter
    def destination_path_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7c1c3982ef563cbc0325c1dc5473856542456f22c74fb9a9d3a5ea6e2b414df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefix")
    def destination_path_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathPrefix"))

    @destination_path_prefix.setter
    def destination_path_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00787d1e0843923601690ebb32da76a3c9c01399f7b7d7994c892f02eba18b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffix")
    def destination_path_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffix"))

    @destination_path_suffix.setter
    def destination_path_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c0344bdd4066ceb370393bb2e710652f16e4c0d3195473037fd8bd9ee46ce56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatus")
    def destination_path_suffix_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffixStatus"))

    @destination_path_suffix_status.setter
    def destination_path_suffix_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7640aab0d4afe8a12c9b82585efb2f7ea5acbc426d67cffb80521003c29a7562)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffixStatus", value)

    @builtins.property
    @jsii.member(jsii_name="destinationProtocol")
    def destination_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationProtocol"))

    @destination_protocol.setter
    def destination_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a706eae53c702762215c8b96a5a9eaeea37cab03ecdcb349447173a5dbfe2c96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__111683bc4e660a0244c5d385d02acb50f545329b179b8e87cd8ed3e973db639f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoice")
    def mobile_default_choice(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mobileDefaultChoice"))

    @mobile_default_choice.setter
    def mobile_default_choice(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c46c1a90dca93a85d76348f2df96b2ee787fef45f313dd13d702918aa5533f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mobileDefaultChoice", value)

    @builtins.property
    @jsii.member(jsii_name="queryString")
    def query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryString"))

    @query_string.setter
    def query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06886a03ada5beab922e0b7c4f8c58eefb1ad19d8c50c2c7d41667dfad65c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryString", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21f02b557fcafce492de6cca8dc264508530f84d80602d57fea6eee154cee77b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c36098460ffbfc4bae81f5286032b61e24ca63beb5604e428c0f15c74899cb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5497fadfc928419ac48ccbc94fc25f2d36bf8a0e0e9a1a65ce4cf3abe0b01fdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc14f1eeab1cb30cfd7d2f482769718c5d2d425327a5c466091c96ce22ba0fbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus",
    jsii_struct_bases=[],
    name_mapping={
        "destination": "destination",
        "enabled": "enabled",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus:
    def __init__(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad2b504cba13d44490b1d228e5e921a7459d9c489b2084959dfc87c42f70196f)
            check_type(argname="argument destination", value=destination, expected_type=type_hints["destination"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination is not None:
            self._values["destination"] = destination
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL.

        Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        '''
        result = self._values.get("destination")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the redirect feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns the status code for the redirect response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6352848e0e7cd2f79f46b3b3e05801ce2c11a8e3001dadd32f9ace9626a4e261)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestination")
    def reset_destination(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestination", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationInput")
    def destination_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destination")
    def destination(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destination"))

    @destination.setter
    def destination(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2590523d37d736b1f33a685408e36bcbca774c2f790fcdad202bcff35fccdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destination", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e227058b8a92fb57c1fee7d4e749fe69480f419c8c74a477349c3b85da70d7e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a872c33fc67ad1f2bbc55ba4b734e9e91a9885653daa8fe18660eef7b86cf5e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a98c54b1b3232a720734e6d0be408c9fa7d5f4f5009b5b511593c4f0e91c18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72a7633ad267bc4b7baab23ea677afc7549803f6ad1a137cf47bc6c118d3599)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7560b038e60a6df1773e29c1ba347d0fb06a6e0dfec5c94b91861c9dd0708297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__138034cce83fff03e9bee512a1a10506c6b43c7bdac37fe7934c186cf6cac892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking",
    jsii_struct_bases=[],
    name_mapping={
        "allow_children": "allowChildren",
        "domains": "domains",
        "enabled": "enabled",
        "locked": "locked",
        "strict": "strict",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking:
    def __init__(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a91ad232928ce7accc0ed262c4b0bdfdbb66c8bac8c016345d8f71fd210163b)
            check_type(argname="argument allow_children", value=allow_children, expected_type=type_hints["allow_children"])
            check_type(argname="argument domains", value=domains, expected_type=type_hints["domains"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict", value=strict, expected_type=type_hints["strict"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_children is not None:
            self._values["allow_children"] = allow_children
        if domains is not None:
            self._values["domains"] = domains
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if strict is not None:
            self._values["strict"] = strict
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_children(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        '''
        result = self._values.get("allow_children")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of allowed domains.

        With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        '''
        result = self._values.get("domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the referer-checking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``.

        When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        '''
        result = self._values.get("strict")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978e9c7963752932e0a02be1d353d36a023c241f93d653160fa80a51e14ddd05)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowChildren")
    def reset_allow_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowChildren", []))

    @jsii.member(jsii_name="resetDomains")
    def reset_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomains", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrict")
    def reset_strict(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrict", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowChildrenInput")
    def allow_children_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowChildrenInput"))

    @builtins.property
    @jsii.member(jsii_name="domainsInput")
    def domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "domainsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictInput")
    def strict_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowChildren")
    def allow_children(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowChildren"))

    @allow_children.setter
    def allow_children(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ef61ae8e5ce92ba775a301550b3e911aac89f84378bfdd8de26fdeb6591c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowChildren", value)

    @builtins.property
    @jsii.member(jsii_name="domains")
    def domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "domains"))

    @domains.setter
    def domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7a45188d02d6c69c2837ca9412a0b984741402906bc30b75c63700936b98744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domains", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdf74fb90f6d1d13897cd7d3db07aeeca6441ce54de764cdde56d55a174dcc90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e646d7634d6d7ba4b68ae6c2602b8c079c5e37bff53ec67e02101e59c26a046)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strict")
    def strict(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strict"))

    @strict.setter
    def strict(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f66963e31857340808a39629d4527c638c1e7894dc79052d17fab06cd830485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strict", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dd3c357d63af8d5b47b6ebade02903b6725a3e2ec93dc07847a12eef697ce1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b083130296f701bfba5989536ffa4da19948e9a2c4cf6376599a3cb6fddc269)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e112061194d881af261718355e185af8cf61f2142e2a8077ae316a9bdba3029d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a19656bcf69ca894c432c12e4f1ff2cbb446fef7dc8f788cebbf5a30c94aad0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies parameters to remove from the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075e2c8c9a07d659e2b6f8714a2c5f6556242a2f7bb94de79d966b7fc0e62f37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53911107c8b966d4b54564785ab0929ce1aa4b4f204e580d9ee6f223b68e3c5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978227919f7746a3a178bb075d6feee3566c0f31ce4f8f81e4e10580401c983f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f281339b09c88a10e9aa414fcee3279b16b5ea9b67898698ac5617b7c7a86b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4f58992e40c8d3b5375430f7b6c0a8c67934f0ff0170ad61d26abddb1e5c9bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d4e81a35a2989fce0ee254812259b16d9403b3d2e28fddd9293cecbfe310ce9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32725dc750e8444d1d6eb8973571b9b72f9daf65d0d3b7336e2eb378cd94199a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, removes the ``Vary`` header to ensure objects can be cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59d435502e5293d2881dc5a972ad2abd082fc1ab7ab3e3bd982c50633fd20f83)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32650ca1ebd51ceb5ccc64c8825a08ec8b7e8b4d2d12f3813f5d07734d8c20c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71fbae4e380d92262a950844e39146322c2da6a62ff9dcc1f70739d347efaa33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f985b20649c2ab50f08097a6df049bc04c770e1ebb728582270c39b393a1ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6acde44ef63ee04a55bd4fe908fc62ff16d4853350e4dc656b3f85ec5bf3fdaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5b84b861e4b8e440431532fd045999c7cb35a74c347055b968fe26d96ad005b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport",
    jsii_struct_bases=[],
    name_mapping={
        "cookies": "cookies",
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_accept_language": "logAcceptLanguage",
        "log_cookies": "logCookies",
        "log_custom_log_field": "logCustomLogField",
        "log_edge_ip": "logEdgeIp",
        "log_host": "logHost",
        "log_referer": "logReferer",
        "log_user_agent": "logUserAgent",
        "log_x_forwarded_for": "logXForwardedFor",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport:
    def __init__(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05408dc37e2b2348b4ecc67fe390dbd0331ea4d426dfe4aec5b6c70caeda314f)
            check_type(argname="argument cookies", value=cookies, expected_type=type_hints["cookies"])
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_accept_language", value=log_accept_language, expected_type=type_hints["log_accept_language"])
            check_type(argname="argument log_cookies", value=log_cookies, expected_type=type_hints["log_cookies"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument log_edge_ip", value=log_edge_ip, expected_type=type_hints["log_edge_ip"])
            check_type(argname="argument log_host", value=log_host, expected_type=type_hints["log_host"])
            check_type(argname="argument log_referer", value=log_referer, expected_type=type_hints["log_referer"])
            check_type(argname="argument log_user_agent", value=log_user_agent, expected_type=type_hints["log_user_agent"])
            check_type(argname="argument log_x_forwarded_for", value=log_x_forwarded_for, expected_type=type_hints["log_x_forwarded_for"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookies is not None:
            self._values["cookies"] = cookies
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_accept_language is not None:
            self._values["log_accept_language"] = log_accept_language
        if log_cookies is not None:
            self._values["log_cookies"] = log_cookies
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if log_edge_ip is not None:
            self._values["log_edge_ip"] = log_edge_ip
        if log_host is not None:
            self._values["log_host"] = log_host
        if log_referer is not None:
            self._values["log_referer"] = log_referer
        if log_user_agent is not None:
            self._values["log_user_agent"] = log_user_agent
        if log_x_forwarded_for is not None:
            self._values["log_x_forwarded_for"] = log_x_forwarded_for
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookies(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the set of cookies names whose values you want to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        '''
        result = self._values.get("cookies")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_accept_language(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Accept-Language`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        '''
        result = self._values.get("log_accept_language")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_cookies(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of cookies to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        '''
        result = self._values.get("log_cookies")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_edge_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to log the IP address of the Akamai edge server that served the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        '''
        result = self._values.get("log_edge_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_host(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Host`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        '''
        result = self._values.get("log_host")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_referer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Referer`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        '''
        result = self._values.get("log_referer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_user_agent(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        '''
        result = self._values.get("log_user_agent")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log any ``X-Forwarded-For`` request header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        '''
        result = self._values.get("log_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de4b59891a3dc8b7d980abf516643a38d96d5991cf687ba5183611758fb4caa7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookies")
    def reset_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookies", []))

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogAcceptLanguage")
    def reset_log_accept_language(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogAcceptLanguage", []))

    @jsii.member(jsii_name="resetLogCookies")
    def reset_log_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCookies", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetLogEdgeIp")
    def reset_log_edge_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEdgeIp", []))

    @jsii.member(jsii_name="resetLogHost")
    def reset_log_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogHost", []))

    @jsii.member(jsii_name="resetLogReferer")
    def reset_log_referer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogReferer", []))

    @jsii.member(jsii_name="resetLogUserAgent")
    def reset_log_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogUserAgent", []))

    @jsii.member(jsii_name="resetLogXForwardedFor")
    def reset_log_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogXForwardedFor", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookiesInput")
    def cookies_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguageInput")
    def log_accept_language_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logAcceptLanguageInput"))

    @builtins.property
    @jsii.member(jsii_name="logCookiesInput")
    def log_cookies_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logCookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="logEdgeIpInput")
    def log_edge_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEdgeIpInput"))

    @builtins.property
    @jsii.member(jsii_name="logHostInput")
    def log_host_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logHostInput"))

    @builtins.property
    @jsii.member(jsii_name="logRefererInput")
    def log_referer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logRefererInput"))

    @builtins.property
    @jsii.member(jsii_name="logUserAgentInput")
    def log_user_agent_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logUserAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="logXForwardedForInput")
    def log_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookies")
    def cookies(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cookies"))

    @cookies.setter
    def cookies(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e7c4bc6aadb89868f5a80a1ecb15bf76bdc9f12bf486082cdbcc66c2335e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookies", value)

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dba8dab9be50c49629f1c90fcb0cca5d45d4ccc428e8bc13363bd7f5cb8619cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__622b3d522a875461f809c60d246b45e362fd20ec1c140a1260a80250dd311faf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguage")
    def log_accept_language(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logAcceptLanguage"))

    @log_accept_language.setter
    def log_accept_language(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c6da8251a1521d3a94b8aa4d50d675714bf62493a233af06ef18c07089c7130)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logAcceptLanguage", value)

    @builtins.property
    @jsii.member(jsii_name="logCookies")
    def log_cookies(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logCookies"))

    @log_cookies.setter
    def log_cookies(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1e2facb192e38f14357a789eb05f113e2868df7908cd3e1c1678c99beff9a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCookies", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48d47087d0d4b6d5222368e7bd73f7082d6ed592dcbb1e10d55351ff88635a2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="logEdgeIp")
    def log_edge_ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEdgeIp"))

    @log_edge_ip.setter
    def log_edge_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9ff7cdf33e59081218fbb48e9e57951155a4f7f119211466021adb8ffff2df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEdgeIp", value)

    @builtins.property
    @jsii.member(jsii_name="logHost")
    def log_host(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logHost"))

    @log_host.setter
    def log_host(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbb1f52672edbd3bcfcdbcf5bbaaa135f3fc62441b172d625f4d492b7ef4c5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logHost", value)

    @builtins.property
    @jsii.member(jsii_name="logReferer")
    def log_referer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logReferer"))

    @log_referer.setter
    def log_referer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08c352f680a99e4e60687cefee6c0e29861810ffad48f42a20d867d51bfd90d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logReferer", value)

    @builtins.property
    @jsii.member(jsii_name="logUserAgent")
    def log_user_agent(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logUserAgent"))

    @log_user_agent.setter
    def log_user_agent(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21c42a1e7ebe91269cd1a2120b9bc01bd06836c40fb6493e6b6cd0b8b541c04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logUserAgent", value)

    @builtins.property
    @jsii.member(jsii_name="logXForwardedFor")
    def log_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logXForwardedFor"))

    @log_x_forwarded_for.setter
    def log_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e8fe1ae936f5e9f4b701d3ea7498e8fb3999357fb661b140bc44082e754a8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02d33641eb08fed8cc7cbf19940d86554de05805bd2c38c6242988fb006d0677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a8539b74c7a33079d4f82ad3be03946715d9a810385daddb4d85c42f53cd658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__face5bc7f98c99339927b066ae406c5bc0a92cd709308cf92fda6b49957e836e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints",
    jsii_struct_bases=[],
    name_mapping={
        "accept_ch": "acceptCh",
        "accept_critical_ch": "acceptCriticalCh",
        "locked": "locked",
        "reset": "reset",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints:
    def __init__(
        self,
        *,
        accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accept_ch: The client hint data objects you want to receive from the browser. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        :param accept_critical_ch: The critical client hint data objects you want to receive from the browser. The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reset: This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser. This empty header doesn't get merged with other objects sent from your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aef215cc128417aebd7cd711cb9b8d09faf2ce0832133c7e353b9d49dc4a4ed)
            check_type(argname="argument accept_ch", value=accept_ch, expected_type=type_hints["accept_ch"])
            check_type(argname="argument accept_critical_ch", value=accept_critical_ch, expected_type=type_hints["accept_critical_ch"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reset", value=reset, expected_type=type_hints["reset"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accept_ch is not None:
            self._values["accept_ch"] = accept_ch
        if accept_critical_ch is not None:
            self._values["accept_critical_ch"] = accept_critical_ch
        if locked is not None:
            self._values["locked"] = locked
        if reset is not None:
            self._values["reset"] = reset
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accept_ch(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The client hint data objects you want to receive from the browser.

        You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        '''
        result = self._values.get("accept_ch")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def accept_critical_ch(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The critical client hint data objects you want to receive from the browser.

        The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        '''
        result = self._values.get("accept_critical_ch")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reset(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser.

        This empty header doesn't get merged with other objects sent from your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        '''
        result = self._values.get("reset")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df100268cc7d8c5b9f83b9178eeda2a857d4c7eb4fe89f52651888447af87ff6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcceptCh")
    def reset_accept_ch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcceptCh", []))

    @jsii.member(jsii_name="resetAcceptCriticalCh")
    def reset_accept_critical_ch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcceptCriticalCh", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReset")
    def reset_reset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReset", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="acceptChInput")
    def accept_ch_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "acceptChInput"))

    @builtins.property
    @jsii.member(jsii_name="acceptCriticalChInput")
    def accept_critical_ch_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "acceptCriticalChInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resetInput")
    def reset_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resetInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acceptCh")
    def accept_ch(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "acceptCh"))

    @accept_ch.setter
    def accept_ch(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea1ac81767a29686e023f6fe078f3700880cdaf75d4aee7af887d2e80cbb555f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acceptCh", value)

    @builtins.property
    @jsii.member(jsii_name="acceptCriticalCh")
    def accept_critical_ch(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "acceptCriticalCh"))

    @accept_critical_ch.setter
    def accept_critical_ch(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65850d71525471d295e3adbd46e4189e470b74cc0fb9c6cd793eef815e4db8b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acceptCriticalCh", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5735f0119bc02114bebafe62c1bf42f1dee489f04edcce4db8999231e7bf9405)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reset")
    def reset(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "reset"))

    @reset.setter
    def reset(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6aeab13f562978e4745bb93fbcff32f89f63c8571a7884b841222aed781cf180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reset", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c8812ea263dec7ca3654cc07e8321ccdf522c545de5b63dd3aad1f1c1544357)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfa314954689707563e5554b2916fcb660d8e9a7bbf0eedf82e4237fc8ad6a02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a4382c6865cee73b76760d4b122fea33160d766d2ace5bf2afc682a72494b22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl",
    jsii_struct_bases=[],
    name_mapping={
        "branded403_file": "branded403File",
        "branded403_status_code": "branded403StatusCode",
        "branded403_url": "branded403Url",
        "branded_deny_cache_ttl": "brandedDenyCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enable_branded403": "enableBranded403",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "net_storage": "netStorage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl:
    def __init__(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff21a2e821755480c92683ef66ed8b224eb33e77faa7a3fdaec995c7df0cd210)
            check_type(argname="argument branded403_file", value=branded403_file, expected_type=type_hints["branded403_file"])
            check_type(argname="argument branded403_status_code", value=branded403_status_code, expected_type=type_hints["branded403_status_code"])
            check_type(argname="argument branded403_url", value=branded403_url, expected_type=type_hints["branded403_url"])
            check_type(argname="argument branded_deny_cache_ttl", value=branded_deny_cache_ttl, expected_type=type_hints["branded_deny_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enable_branded403", value=enable_branded403, expected_type=type_hints["enable_branded403"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if branded403_file is not None:
            self._values["branded403_file"] = branded403_file
        if branded403_status_code is not None:
            self._values["branded403_status_code"] = branded403_status_code
        if branded403_url is not None:
            self._values["branded403_url"] = branded403_url
        if branded_deny_cache_ttl is not None:
            self._values["branded_deny_cache_ttl"] = branded_deny_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enable_branded403 is not None:
            self._values["enable_branded403"] = enable_branded403
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def branded403_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        '''
        result = self._values.get("branded403_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded403_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response status code for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        '''
        result = self._values.get("branded403_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def branded403_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect URL for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        '''
        result = self._values.get("branded403_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded_deny_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the branded response page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        '''
        result = self._values.get("branded_deny_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enable_branded403(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, serves a branded 403 page for this Cloudlet instance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        '''
        result = self._values.get("enable_branded403")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Request Control Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bef3e6745f875f93d1a6942861a4dc7f3b1daefc702d65490a17af24dfe9240b)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dfac7c84b05f31faba11436fe6654842097eabd374b1405f59a855df2b2ecde)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1083c42ee5db54bbd1e02fd504f9bc4c3f09a8bc8c8dda4533e763130a9a6abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dba51d1058c6fdca13157c0502cd981a9bdef5e43452a13282799e70ba619d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66a2f991de1d2a170bbbabe71984d283236b957420598fe6076a68ab6cf9eb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9abf7dff97e5d5fb21240bcea0569213205cc0dfc3758c1989245a81de113e5d)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a52e082fa85472fcd8252dc987b25bae4d1a09f0af7780f48932c6b9283faa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c4b791e46909bd5a7d8e6029cec5d3a886f17bdff958776430cdc7d4c461a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__501ceca46ee26ff7a62fc9feb527338e4ae4b2c604e5f87fdecb19ea419006d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be04b60a0e0cb3a991890bb2660fbca0611cbf9224fab06e82fba6922253b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fefb003333846d754397ee72fed3e117cf55fffd7109d6585a4975fc70b7857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d8fa59a13a79b97e58c686e6705bd7eb3aac0ee720db7d494dc7ee877f7ff87)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetBranded403File")
    def reset_branded403_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403File", []))

    @jsii.member(jsii_name="resetBranded403StatusCode")
    def reset_branded403_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403StatusCode", []))

    @jsii.member(jsii_name="resetBranded403Url")
    def reset_branded403_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403Url", []))

    @jsii.member(jsii_name="resetBrandedDenyCacheTtl")
    def reset_branded_deny_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrandedDenyCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnableBranded403")
    def reset_enable_branded403(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBranded403", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="branded403FileInput")
    def branded403_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403FileInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCodeInput")
    def branded403_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "branded403StatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403UrlInput")
    def branded403_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403UrlInput"))

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtlInput")
    def branded_deny_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "brandedDenyCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBranded403Input")
    def enable_branded403_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBranded403Input"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403File")
    def branded403_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403File"))

    @branded403_file.setter
    def branded403_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__280d49d4f5a6083e98e3e2166b621eb34cf74b8d4405f42aa13b64c3edd81947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403File", value)

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCode")
    def branded403_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "branded403StatusCode"))

    @branded403_status_code.setter
    def branded403_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e22ae2a22c5e8d1ed898187e1c7641765f610c741d4f4108588480b603f567)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403StatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="branded403Url")
    def branded403_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403Url"))

    @branded403_url.setter
    def branded403_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5554c73d034be579c998aa5d398f1a8d33af8804169ba858cce13649ab90a30c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403Url", value)

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtl")
    def branded_deny_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "brandedDenyCacheTtl"))

    @branded_deny_cache_ttl.setter
    def branded_deny_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c535720804aa2001f4fa153878a08dbb2123bca14257b2f9d965b597f20342d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brandedDenyCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60ab5c8778f667f4bc941368284fab4253f3e560a09be989ea86bff759c1d70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enableBranded403")
    def enable_branded403(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBranded403"))

    @enable_branded403.setter
    def enable_branded403(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4bca17a3f6aa40081da1c122e48100801c335ef64f71e31230de0e3bc83b823)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBranded403", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4166b42d5f4c5ab8008f7967b6d48db347fb41b08a70255c01518ef5d7368516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b153eb0e9e43c5230106a3acbe24e730a037df543ab244dda876a8a82caae52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d383e6867d169931e8419cb49ba9c6366f32f8b4088158212df16e37ee88d27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1027617f8155e40386b243d52fda56cf16f5061e445b50f7ca9f4136abd97f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a34de7a6e03c0be8bda6b4be4ff18d02f135633782a97f307f199fe00767464)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3482658bd4db4a6aa7d75f083a3816e3a34f7479f4c86a7078bd64d204a2c063)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "request_type": "requestType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db61fbd827ee77deed75bce82ef4192cb67e8b5fa7648e9c8ad3c368fdb46d03)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef99b38ab6777c7cd78bfeab49b929ec0b4f4cd8757c5c11229694ea64ddbe99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__717db94e1f326abdb1f4cc32b9134bff00422758b28811e17183be6c0d892991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d293a2e2875439853a920def469b226f4ecdaa88dae549ffe6011625a2948a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e86071753a1285dab6f7d8adb2c0b28058f24a01f9335508536545acd1891242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e567beaeaa4a5b79326fa8525798244dc86077cb3a9b47ef6e7a5c51d9c0200a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5caec69174ec919fcc28aba92334d9067e3a28f571869bbe240f305a58c2649)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc6fb116bc16eaa944e013b0afbcef4d31ccd3d868480bc43e3ade1e44b7892)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "enable_all_features": "enableAllFeatures",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility:
    def __init__(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3946bee8fafaa0e890673a11a32a78e6d34304dcaa3e704205b0eb691dab1c6e)
            check_type(argname="argument enable_all_features", value=enable_all_features, expected_type=type_hints["enable_all_features"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_all_features is not None:
            self._values["enable_all_features"] = enable_all_features
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_all_features(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``additional support`` and error handling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        '''
        result = self._values.get("enable_all_features")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__107310ef75e80dff2c0b221c4b3d536e10bb61095575b501c903592a0a789092)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableAllFeatures")
    def reset_enable_all_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAllFeatures", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeaturesInput")
    def enable_all_features_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAllFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeatures")
    def enable_all_features(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAllFeatures"))

    @enable_all_features.setter
    def enable_all_features(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c9f9e2ee9db88612ce49b62f46340fcd0ef6a745a44a10fc3d4320a9325b078)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAllFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79f97bf971887b6e571f484381eae22fdd7b0efa1a8c42c587decbfd480a7e89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79bdd207441cc230d78e7aa7146f03528fd68927ff807dc6688e4a69741d11d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057b080bb87cdcbe85586fad1f128e35e6f1d62073f89f0ceb24e9f47bba333c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bad09ddd5cb63af6531ba75151c251a0dcbde284f5aece9431c8f777210e1cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14f87046a5ba565031a072ccd6a79facbca9e348b9f3d1c8494c838b639c8310)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79ee5e3d2b6814293e6eaaf64f62ef34098882ae1441d6d085b747eb52da91b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92d89e2dc7b725da0ad8758c5f60f5e3933560ce54745aca3ebd50646e7b9a84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70221af6f801681b4be1f297fa858030a276999a1c14c6fc7e910e1add87adb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04369245a574a1238619a72b39a32579a8b504533bec9d46c5783311e01dfb48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbf9338c45d8ad2f4ff4117db07dfe0bedad3c99290ec5d8317d8e15612e1643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db5b270b7078263ee4ece230b3cc1067ca32dd783cdea62a228594b25d10e4c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "override206": "override206",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__468241f686cbdf332520abecb990f4c08dd9a3badc5c0afca33cb5a83acff5a9)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override206", value=override206, expected_type=type_hints["override206"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if override206 is not None:
            self._values["override206"] = override206
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override206(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        '''
        result = self._values.get("override206")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP status code to replace the existing one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b054c4e6d106fc5d716976123d5a9e548b9b154d1a20ec9779ce45cc619b71)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride206")
    def reset_override206(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride206", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="override206Input")
    def override206_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "override206Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2f9a6ae4ef7fa60de6ffa6af9c10390ef0eb12a075585ed04bbfcf144b3dccd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override206")
    def override206(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "override206"))

    @override206.setter
    def override206(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ca34e82e764671025e2e26b07f8cf0574a75bac366dace0a12e706804d20994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override206", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d464e8882cea8733b7b097ad87faa8d6366034fdbd636d3295ebb960882e6aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__371fd9ce88f6c81b4b9c1daac71412b85df440534dabae5d220c7ff80f2a9474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99950ef9e2d6641c6db5b7d0741ad5db0c79ae7865fb51113f540409fdc513e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1eb7b6f0a65c1516aefaf2d896543068a1408b23ef3ccd17497c8c14c54b727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "default_domain": "defaultDomain",
        "default_path": "defaultPath",
        "domain": "domain",
        "duration": "duration",
        "enabled": "enabled",
        "expiration_date": "expirationDate",
        "expires": "expires",
        "format": "format",
        "http_only": "httpOnly",
        "locked": "locked",
        "path": "path",
        "same_site": "sameSite",
        "secure": "secure",
        "template_uuid": "templateUuid",
        "type": "type",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a667d4216330b2673acac720d8b61527c808d5b20dad4b8098b28c56385c23ac)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument default_domain", value=default_domain, expected_type=type_hints["default_domain"])
            check_type(argname="argument default_path", value=default_path, expected_type=type_hints["default_path"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument duration", value=duration, expected_type=type_hints["duration"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expiration_date", value=expiration_date, expected_type=type_hints["expiration_date"])
            check_type(argname="argument expires", value=expires, expected_type=type_hints["expires"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument http_only", value=http_only, expected_type=type_hints["http_only"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument same_site", value=same_site, expected_type=type_hints["same_site"])
            check_type(argname="argument secure", value=secure, expected_type=type_hints["secure"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if default_domain is not None:
            self._values["default_domain"] = default_domain
        if default_path is not None:
            self._values["default_path"] = default_path
        if domain is not None:
            self._values["domain"] = domain
        if duration is not None:
            self._values["duration"] = duration
        if enabled is not None:
            self._values["enabled"] = enabled
        if expiration_date is not None:
            self._values["expiration_date"] = expiration_date
        if expires is not None:
            self._values["expires"] = expires
        if format is not None:
            self._values["format"] = format
        if http_only is not None:
            self._values["http_only"] = http_only
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if same_site is not None:
            self._values["same_site"] = same_site
        if secure is not None:
            self._values["secure"] = secure
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie, which serves as a key to determine if the cookie is set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        '''
        result = self._values.get("default_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def default_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default path value, otherwise the set specified in the ``path`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        '''
        result = self._values.get("default_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid.

        For example, ``example.com`` makes the cookie valid for that hostname and all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def duration(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        '''
        result = self._values.get("duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set a response cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_date(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        '''
        result = self._values.get("expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def expires(self) -> typing.Optional[builtins.str]:
        '''Sets various ways to specify when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        '''
        result = self._values.get("expires")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        '''
        result = self._values.get("http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def same_site(self) -> typing.Optional[builtins.str]:
        '''This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        '''
        result = self._values.get("same_site")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        '''
        result = self._values.get("secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''What type of value to assign.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''If the cookie ``type`` is ``FIXED``, this specifies the cookie value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d042acb4ba57079379b7a1636257928e64d8c0bc1784cca3b97814de2243f9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDefaultDomain")
    def reset_default_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultDomain", []))

    @jsii.member(jsii_name="resetDefaultPath")
    def reset_default_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultPath", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetDuration")
    def reset_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDuration", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExpirationDate")
    def reset_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationDate", []))

    @jsii.member(jsii_name="resetExpires")
    def reset_expires(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpires", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetHttpOnly")
    def reset_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpOnly", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetSameSite")
    def reset_same_site(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSameSite", []))

    @jsii.member(jsii_name="resetSecure")
    def reset_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecure", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultDomainInput")
    def default_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultPathInput")
    def default_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultPathInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="durationInput")
    def duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "durationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationDateInput")
    def expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="expiresInput")
    def expires_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expiresInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="httpOnlyInput")
    def http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "httpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="sameSiteInput")
    def same_site_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sameSiteInput"))

    @builtins.property
    @jsii.member(jsii_name="secureInput")
    def secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secureInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__092f1a3400c81581eca56e0e602f0bbad4f63629c6e4b5508f33bbb40ecf2959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="defaultDomain")
    def default_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultDomain"))

    @default_domain.setter
    def default_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7847fb7c4d7f2a4f121829d779983399d47e8bd0f44970c52decf03b9fc365)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultDomain", value)

    @builtins.property
    @jsii.member(jsii_name="defaultPath")
    def default_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultPath"))

    @default_path.setter
    def default_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0b9a36c8522ab32aae46eba3b28f3730a64a999c479a882c25d5b681112c5ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultPath", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc942efcd6676985acd743060bfade57c50f549f67beade17b22a0ffa81ef87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="duration")
    def duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "duration"))

    @duration.setter
    def duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8303f961658b3c38a7d5c349b2accd0fcbdbbf281a8879fbb1aa9596b1dd5e27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "duration", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02fc217086704ebd096bd31eb44967451bddcc99466dc44810f0a120f56f8dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="expirationDate")
    def expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationDate"))

    @expiration_date.setter
    def expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca014fb4547ff4412b8551bb05062d9e9c287799e58d084f8342751782bc021c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="expires")
    def expires(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expires"))

    @expires.setter
    def expires(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea42c2eaeb0d9688514848ebf46d43f2016b741d8a14f4122fcba01c158a107e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expires", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091606eaeca6f24c3d1ba6b2c6db7029a18e9838bc67e70940db6d3cf38a55c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="httpOnly")
    def http_only(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "httpOnly"))

    @http_only.setter
    def http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322303ae879018264baa1979d812404ffb1c569366ce2d537a725523ae516f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41857b73fbe0176b691e575b51703389cbab76815ea827dcd51ea5d4e9504c2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3871adac1817ede9db5d3d09e9e76f63ec45512bbc38eeba26a205b1dc311606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="sameSite")
    def same_site(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sameSite"))

    @same_site.setter
    def same_site(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2df544c31a5467267fcb7e92533b90dabe3c4250ee11db1f23133726cf03f1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sameSite", value)

    @builtins.property
    @jsii.member(jsii_name="secure")
    def secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secure"))

    @secure.setter
    def secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a1f978ed6e6eb4369ef4899c66ecc60cb2c5fc356fcda81d4f736655925817)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secure", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a98142302408226a553fb7e5f174d6642bad72a0c4b8ad403595bea7ea5cbbad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d087af0cb03fe5d3ab3d7dd4ca209f521c3f8505aa46119c4aa9a3a5edecaacc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f77164b0aa505844faa40c75b065cc8c896e2fc309e737f8fc05a4086d0a5b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f793de34f0c69adcf2caea262dd374a288c5ffb739f002d9dfdaf6944de3afda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8e4e0d642e4e6946578e5a7e9fceb8a28134710bee137926d6bc9e0a6a20bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_size": "maximumSize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28bd00a4062316b77d68b4497649c988a7f6fc996be0c0884cbb58b30b09d61f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed maximum size of non-HTML content to cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07bb6d36d7988837e9246ca95b6ada5273c10522ed971eb1bdaf78ba3e5e1838)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dd98acaecda518ee721996291da613037f122f20c9c4b738a95591d2bd6156a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6accbc18ad0cd23eed06e7f1aebeef95e1ccad1e74004a610de2c472067ae65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0d583dd3ab0b1d0a6ffbe0c3689dd547e324b60b90fbf9fcefda46d142fe510)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b200a932c8b0bb66b0702e6a9fb7e7e075be71f35f058fcb65785b4751f0464c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae81b5f8080cc3c5aa97d89d53c8065e7eac248532821f441293500c839a17f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "response_header_name": "responseHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56ef508d67c9627e9e015f7f3f0c090c755647478f36f482d8dbb74d7651af2d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the HTTP header in which to report the cache status value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c89da2bcc4bc74f0e0fc7997a59b275a4d8346ca306c8bfe14cae4f6792f9cd8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e6a185bac2954e485efe9a0af3e8a6f672a35d5f070bb4c78fb740d216210bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4e0d24a66aef996a317d99d428684ac008ce94694fa29f8cdf052958fca1a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1582d187f6381fda798552bfeb9f333a491433b1a63f7762dd49e167af88e2f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648436b21632ac0618b0947eae7aab17dc5d25cdefc36c8e283fa22ef9b1179e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37de7b839ba05da5a56c4e1b500c4d58c373976107be754f1f7861bf7a9deed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "keep_query_string": "keepQueryString",
        "locked": "locked",
        "match": "match",
        "match_multiple": "matchMultiple",
        "match_regex": "matchRegex",
        "target_path": "targetPath",
        "target_path_prepend": "targetPathPrepend",
        "target_regex": "targetRegex",
        "target_url": "targetUrl",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e00eceeae2d45051a0e436fed4de599154df0c6b08d9f69a6312ae98e67eb0d)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument keep_query_string", value=keep_query_string, expected_type=type_hints["keep_query_string"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match", value=match, expected_type=type_hints["match"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument match_regex", value=match_regex, expected_type=type_hints["match_regex"])
            check_type(argname="argument target_path", value=target_path, expected_type=type_hints["target_path"])
            check_type(argname="argument target_path_prepend", value=target_path_prepend, expected_type=type_hints["target_path_prepend"])
            check_type(argname="argument target_regex", value=target_regex, expected_type=type_hints["target_regex"])
            check_type(argname="argument target_url", value=target_url, expected_type=type_hints["target_url"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if keep_query_string is not None:
            self._values["keep_query_string"] = keep_query_string
        if locked is not None:
            self._values["locked"] = locked
        if match is not None:
            self._values["match"] = match
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if match_regex is not None:
            self._values["match_regex"] = match_regex
        if target_path is not None:
            self._values["target_path"] = target_path
        if target_path_prepend is not None:
            self._values["target_path_prepend"] = target_path_prepend
        if target_regex is not None:
            self._values["target_regex"] = target_regex
        if target_url is not None:
            self._values["target_url"] = target_url
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''The action to perform on the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def keep_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, retains the original path's query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        '''
        result = self._values.get("keep_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        '''
        result = self._values.get("match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, replaces all potential matches rather than only the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        '''
        result = self._values.get("match_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        '''
        result = self._values.get("target_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path_prepend(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        '''
        result = self._values.get("target_path_prepend")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        '''
        result = self._values.get("target_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_url(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        '''
        result = self._values.get("target_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a30a47fe2a9c31f67314ec74a444b3f46e893088ade7d0b6c0586be4e79108)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetKeepQueryString")
    def reset_keep_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKeepQueryString", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatch")
    def reset_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatch", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetMatchRegex")
    def reset_match_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchRegex", []))

    @jsii.member(jsii_name="resetTargetPath")
    def reset_target_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPath", []))

    @jsii.member(jsii_name="resetTargetPathPrepend")
    def reset_target_path_prepend(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPathPrepend", []))

    @jsii.member(jsii_name="resetTargetRegex")
    def reset_target_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetRegex", []))

    @jsii.member(jsii_name="resetTargetUrl")
    def reset_target_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetUrl", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="keepQueryStringInput")
    def keep_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "keepQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchInput")
    def match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="matchRegexInput")
    def match_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathInput")
    def target_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathPrependInput")
    def target_path_prepend_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathPrependInput"))

    @builtins.property
    @jsii.member(jsii_name="targetRegexInput")
    def target_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetUrlInput")
    def target_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d112ec7b35930826495436ff02bd069c06f80db7bf65fb932f12ed12ac7e6af6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="keepQueryString")
    def keep_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "keepQueryString"))

    @keep_query_string.setter
    def keep_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1484c29323bae38ddf5953656d50aa2087c3a1675c00035286e23e32058c8802)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "keepQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6de6a280a88ce9741e662882acf5848fbe9c8d28c5bc252b79bfec82a6f892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="match")
    def match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "match"))

    @match.setter
    def match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88548e786b0c034806927c9923eb7200cfd01e1f1cef87189d348650cb3b26ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "match", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c479a9a7c875b183f5688755d009afb9a805c73c8c3d66117b0281f61677a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="matchRegex")
    def match_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchRegex"))

    @match_regex.setter
    def match_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb6b2a5f84232ad6c07b6ea55e98d3a5a5fb6e02ce00ca04770f75809c858ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetPath")
    def target_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPath"))

    @target_path.setter
    def target_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723958ee9a45dd3cc2c6a7cd42c97a0f9c1cc61ba536b37be4e090603837e31f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPath", value)

    @builtins.property
    @jsii.member(jsii_name="targetPathPrepend")
    def target_path_prepend(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPathPrepend"))

    @target_path_prepend.setter
    def target_path_prepend(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df999ca0fcbababd786f40815a5c6f23727f4a3a64024058153be2984a283911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPathPrepend", value)

    @builtins.property
    @jsii.member(jsii_name="targetRegex")
    def target_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetRegex"))

    @target_regex.setter
    def target_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4204d5ea15bad0e4a1194083d11cbb66673db2668c1b3f7c0314d87c8178b02b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetUrl")
    def target_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetUrl"))

    @target_url.setter
    def target_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec5646e6e935ae8528e2ec156467ca790d3982f4a47cf7b76820a371883f8de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetUrl", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f5f4889ffcd3fc83957e28e8b25c6b0264abaacc90287cc18720e63fec1348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e89fa953f1a8720667578949f3a6853c971b77d91f9e7b7fd1d975ba18c7516)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f5a9dfcdab4d25fbcf8312c98ff9665f0c2d0e465f4f9584fe376327b743d96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "rum_group_name": "rumGroupName",
        "rum_sample_rate": "rumSampleRate",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a63127a0f6c6aaa21c4161eab7fea30e3b41cb9848500d032a1149e04b0243b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument rum_group_name", value=rum_group_name, expected_type=type_hints["rum_group_name"])
            check_type(argname="argument rum_sample_rate", value=rum_sample_rate, expected_type=type_hints["rum_sample_rate"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if rum_group_name is not None:
            self._values["rum_group_name"] = rum_group_name
        if rum_sample_rate is not None:
            self._values["rum_sample_rate"] = rum_sample_rate
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rum_group_name(self) -> typing.Optional[builtins.str]:
        '''A deprecated option to specify an alternate name under which to batch this set of web traffic in your report.

        Do not use it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        '''
        result = self._values.get("rum_group_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rum_sample_rate(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of web traffic to include in your RUM report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        '''
        result = self._values.get("rum_sample_rate")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ae9d424f5cb6521a15b87f78a74cdc2f72bd50c1335b59d3fb1822726575de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRumGroupName")
    def reset_rum_group_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumGroupName", []))

    @jsii.member(jsii_name="resetRumSampleRate")
    def reset_rum_sample_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumSampleRate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="rumGroupNameInput")
    def rum_group_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "rumGroupNameInput"))

    @builtins.property
    @jsii.member(jsii_name="rumSampleRateInput")
    def rum_sample_rate_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "rumSampleRateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103b1029f8692212c90536658872e3b350a4fd7c480b35835c3822211f567dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="rumGroupName")
    def rum_group_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rumGroupName"))

    @rum_group_name.setter
    def rum_group_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ec90d76da5951146017b15de6ed5fe00a41ba6f63ba52580af653de1b71b621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumGroupName", value)

    @builtins.property
    @jsii.member(jsii_name="rumSampleRate")
    def rum_sample_rate(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "rumSampleRate"))

    @rum_sample_rate.setter
    def rum_sample_rate(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__745ac8f5cbfd80920df88c9a677ae19dd44e5cb8f9164c481d524a1fbdb4006b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumSampleRate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d489c58a9ff69fcf50d31decf329d22d9c70f19e740a2a9aee8e2da9c8f0af9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db121d7b319611a20e2499f526b32043cb536dbd6411eee62649858fe538e5a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__419a2d08671c2e02e001e840e4133f34fcab8852b2fc53f16cffd5ba2912867d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions",
    jsii_struct_bases=[],
    name_mapping={
        "application_action": "applicationAction",
        "application_cname_enabled": "applicationCnameEnabled",
        "application_cname_level": "applicationCnameLevel",
        "application_cookie": "applicationCookie",
        "application_query_string": "applicationQueryString",
        "application_regex": "applicationRegex",
        "application_replace": "applicationReplace",
        "application_title": "applicationTitle",
        "customer_action": "customerAction",
        "customer_cname_enabled": "customerCnameEnabled",
        "customer_cname_level": "customerCnameLevel",
        "customer_cookie": "customerCookie",
        "customer_query_string": "customerQueryString",
        "customer_regex": "customerRegex",
        "customer_replace": "customerReplace",
        "customer_title": "customerTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "users_action": "usersAction",
        "users_cname_enabled": "usersCnameEnabled",
        "users_cname_level": "usersCnameLevel",
        "users_cookie": "usersCookie",
        "users_query_string": "usersQueryString",
        "users_regex": "usersRegex",
        "users_replace": "usersReplace",
        "users_title": "usersTitle",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions:
    def __init__(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f12fafc22eee57055d7a3e90253359385193a35a2f530bc134abc4b5303b7b6a)
            check_type(argname="argument application_action", value=application_action, expected_type=type_hints["application_action"])
            check_type(argname="argument application_cname_enabled", value=application_cname_enabled, expected_type=type_hints["application_cname_enabled"])
            check_type(argname="argument application_cname_level", value=application_cname_level, expected_type=type_hints["application_cname_level"])
            check_type(argname="argument application_cookie", value=application_cookie, expected_type=type_hints["application_cookie"])
            check_type(argname="argument application_query_string", value=application_query_string, expected_type=type_hints["application_query_string"])
            check_type(argname="argument application_regex", value=application_regex, expected_type=type_hints["application_regex"])
            check_type(argname="argument application_replace", value=application_replace, expected_type=type_hints["application_replace"])
            check_type(argname="argument application_title", value=application_title, expected_type=type_hints["application_title"])
            check_type(argname="argument customer_action", value=customer_action, expected_type=type_hints["customer_action"])
            check_type(argname="argument customer_cname_enabled", value=customer_cname_enabled, expected_type=type_hints["customer_cname_enabled"])
            check_type(argname="argument customer_cname_level", value=customer_cname_level, expected_type=type_hints["customer_cname_level"])
            check_type(argname="argument customer_cookie", value=customer_cookie, expected_type=type_hints["customer_cookie"])
            check_type(argname="argument customer_query_string", value=customer_query_string, expected_type=type_hints["customer_query_string"])
            check_type(argname="argument customer_regex", value=customer_regex, expected_type=type_hints["customer_regex"])
            check_type(argname="argument customer_replace", value=customer_replace, expected_type=type_hints["customer_replace"])
            check_type(argname="argument customer_title", value=customer_title, expected_type=type_hints["customer_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument users_action", value=users_action, expected_type=type_hints["users_action"])
            check_type(argname="argument users_cname_enabled", value=users_cname_enabled, expected_type=type_hints["users_cname_enabled"])
            check_type(argname="argument users_cname_level", value=users_cname_level, expected_type=type_hints["users_cname_level"])
            check_type(argname="argument users_cookie", value=users_cookie, expected_type=type_hints["users_cookie"])
            check_type(argname="argument users_query_string", value=users_query_string, expected_type=type_hints["users_query_string"])
            check_type(argname="argument users_regex", value=users_regex, expected_type=type_hints["users_regex"])
            check_type(argname="argument users_replace", value=users_replace, expected_type=type_hints["users_replace"])
            check_type(argname="argument users_title", value=users_title, expected_type=type_hints["users_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if application_action is not None:
            self._values["application_action"] = application_action
        if application_cname_enabled is not None:
            self._values["application_cname_enabled"] = application_cname_enabled
        if application_cname_level is not None:
            self._values["application_cname_level"] = application_cname_level
        if application_cookie is not None:
            self._values["application_cookie"] = application_cookie
        if application_query_string is not None:
            self._values["application_query_string"] = application_query_string
        if application_regex is not None:
            self._values["application_regex"] = application_regex
        if application_replace is not None:
            self._values["application_replace"] = application_replace
        if application_title is not None:
            self._values["application_title"] = application_title
        if customer_action is not None:
            self._values["customer_action"] = customer_action
        if customer_cname_enabled is not None:
            self._values["customer_cname_enabled"] = customer_cname_enabled
        if customer_cname_level is not None:
            self._values["customer_cname_level"] = customer_cname_level
        if customer_cookie is not None:
            self._values["customer_cookie"] = customer_cookie
        if customer_query_string is not None:
            self._values["customer_query_string"] = customer_query_string
        if customer_regex is not None:
            self._values["customer_regex"] = customer_regex
        if customer_replace is not None:
            self._values["customer_replace"] = customer_replace
        if customer_title is not None:
            self._values["customer_title"] = customer_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if users_action is not None:
            self._values["users_action"] = users_action
        if users_cname_enabled is not None:
            self._values["users_cname_enabled"] = users_cname_enabled
        if users_cname_level is not None:
            self._values["users_cname_level"] = users_cname_level
        if users_cookie is not None:
            self._values["users_cookie"] = users_cookie
        if users_query_string is not None:
            self._values["users_query_string"] = users_query_string
        if users_regex is not None:
            self._values["users_regex"] = users_regex
        if users_replace is not None:
            self._values["users_replace"] = users_replace
        if users_title is not None:
            self._values["users_title"] = users_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def application_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        '''
        result = self._values.get("application_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        '''
        result = self._values.get("application_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def application_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        '''
        result = self._values.get("application_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def application_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        '''
        result = self._values.get("application_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        '''
        result = self._values.get("application_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's application ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        '''
        result = self._values.get("application_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's application ID matched by ``applicationRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        '''
        result = self._values.get("application_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        '''
        result = self._values.get("application_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        '''
        result = self._values.get("customer_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        '''
        result = self._values.get("customer_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def customer_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        '''
        result = self._values.get("customer_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def customer_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        '''
        result = self._values.get("customer_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        '''
        result = self._values.get("customer_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's customer ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        '''
        result = self._values.get("customer_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's customer ID matched by ``customerRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        '''
        result = self._values.get("customer_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        '''
        result = self._values.get("customer_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        '''
        result = self._values.get("users_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        '''
        result = self._values.get("users_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def users_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        '''
        result = self._values.get("users_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def users_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        '''
        result = self._values.get("users_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        '''
        result = self._values.get("users_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's user ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        '''
        result = self._values.get("users_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's user ID matched by ``usersRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        '''
        result = self._values.get("users_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        '''
        result = self._values.get("users_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad82c7cd42f542298bbac93b02d641d5411a24da3e6a0a048346431f1f00a520)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplicationAction")
    def reset_application_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationAction", []))

    @jsii.member(jsii_name="resetApplicationCnameEnabled")
    def reset_application_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameEnabled", []))

    @jsii.member(jsii_name="resetApplicationCnameLevel")
    def reset_application_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameLevel", []))

    @jsii.member(jsii_name="resetApplicationCookie")
    def reset_application_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCookie", []))

    @jsii.member(jsii_name="resetApplicationQueryString")
    def reset_application_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationQueryString", []))

    @jsii.member(jsii_name="resetApplicationRegex")
    def reset_application_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationRegex", []))

    @jsii.member(jsii_name="resetApplicationReplace")
    def reset_application_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationReplace", []))

    @jsii.member(jsii_name="resetApplicationTitle")
    def reset_application_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationTitle", []))

    @jsii.member(jsii_name="resetCustomerAction")
    def reset_customer_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerAction", []))

    @jsii.member(jsii_name="resetCustomerCnameEnabled")
    def reset_customer_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameEnabled", []))

    @jsii.member(jsii_name="resetCustomerCnameLevel")
    def reset_customer_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameLevel", []))

    @jsii.member(jsii_name="resetCustomerCookie")
    def reset_customer_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCookie", []))

    @jsii.member(jsii_name="resetCustomerQueryString")
    def reset_customer_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerQueryString", []))

    @jsii.member(jsii_name="resetCustomerRegex")
    def reset_customer_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerRegex", []))

    @jsii.member(jsii_name="resetCustomerReplace")
    def reset_customer_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerReplace", []))

    @jsii.member(jsii_name="resetCustomerTitle")
    def reset_customer_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsersAction")
    def reset_users_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersAction", []))

    @jsii.member(jsii_name="resetUsersCnameEnabled")
    def reset_users_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameEnabled", []))

    @jsii.member(jsii_name="resetUsersCnameLevel")
    def reset_users_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameLevel", []))

    @jsii.member(jsii_name="resetUsersCookie")
    def reset_users_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCookie", []))

    @jsii.member(jsii_name="resetUsersQueryString")
    def reset_users_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersQueryString", []))

    @jsii.member(jsii_name="resetUsersRegex")
    def reset_users_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersRegex", []))

    @jsii.member(jsii_name="resetUsersReplace")
    def reset_users_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersReplace", []))

    @jsii.member(jsii_name="resetUsersTitle")
    def reset_users_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applicationActionInput")
    def application_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationActionInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabledInput")
    def application_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applicationCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevelInput")
    def application_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "applicationCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCookieInput")
    def application_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationQueryStringInput")
    def application_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationRegexInput")
    def application_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationReplaceInput")
    def application_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationTitleInput")
    def application_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customerActionInput")
    def customer_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerActionInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabledInput")
    def customer_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customerCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevelInput")
    def customer_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "customerCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCookieInput")
    def customer_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="customerQueryStringInput")
    def customer_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="customerRegexInput")
    def customer_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="customerReplaceInput")
    def customer_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="customerTitleInput")
    def customer_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usersActionInput")
    def users_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersActionInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabledInput")
    def users_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "usersCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevelInput")
    def users_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "usersCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCookieInput")
    def users_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="usersQueryStringInput")
    def users_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="usersRegexInput")
    def users_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="usersReplaceInput")
    def users_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="usersTitleInput")
    def users_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationAction")
    def application_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationAction"))

    @application_action.setter
    def application_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c01567d232b1fa8512d15a5d09c7dc79818676c5390e33bcfd9aa32b725a2a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationAction", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabled")
    def application_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applicationCnameEnabled"))

    @application_cname_enabled.setter
    def application_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3b1b5ca0be837b14d8466c08d663a1369050356936e70c47f5db4490490e20e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevel")
    def application_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "applicationCnameLevel"))

    @application_cname_level.setter
    def application_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__faac54d78db1dc464f0c3a3a59f3185a893acfdcf8a7378fac0ba91a752921d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCookie")
    def application_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationCookie"))

    @application_cookie.setter
    def application_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5ac720d4732110afcc4fbf6122e2469c2a43c81d6ea69597ce3eef1bda269a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCookie", value)

    @builtins.property
    @jsii.member(jsii_name="applicationQueryString")
    def application_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationQueryString"))

    @application_query_string.setter
    def application_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd43ece7b29fecb286f2d8ee571a0c1787c7f5c1e7357e69527042b099dcd02f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="applicationRegex")
    def application_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationRegex"))

    @application_regex.setter
    def application_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a654452f448abbfda1891be607907b36d971e44101aab63f031b2e85e3bbe33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationRegex", value)

    @builtins.property
    @jsii.member(jsii_name="applicationReplace")
    def application_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationReplace"))

    @application_replace.setter
    def application_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4121cea52c16b17d86c3e5eaa57c9e307c2848f70da2091493e8fe42fcc9835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationReplace", value)

    @builtins.property
    @jsii.member(jsii_name="applicationTitle")
    def application_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationTitle"))

    @application_title.setter
    def application_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924e89ec3982371599b7e54fdd67eb631083e1ba49953243be2f9a975a0486c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customerAction")
    def customer_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerAction"))

    @customer_action.setter
    def customer_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbcbc83c41322f665ed43a45ab1d5584da7139a0a94bf6c0eddb6ba8f16e9265)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerAction", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabled")
    def customer_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customerCnameEnabled"))

    @customer_cname_enabled.setter
    def customer_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b125f3b79a6190473acccde424003d72a6a9b9adcb3ba7e37932f6f3688df1ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevel")
    def customer_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "customerCnameLevel"))

    @customer_cname_level.setter
    def customer_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae132aea7bb6075a073b9085071286c267c835434dc650d2c30dcb29c64c9df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="customerCookie")
    def customer_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerCookie"))

    @customer_cookie.setter
    def customer_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898ceeb6739e4bf04c5cd3ba3e44640e2bd755579231fb50bc5ea6192ce43186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCookie", value)

    @builtins.property
    @jsii.member(jsii_name="customerQueryString")
    def customer_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerQueryString"))

    @customer_query_string.setter
    def customer_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae4a6d869a400a6c92b2067d66e07c0cf31d5adbc2781261d8c8d28465ff1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="customerRegex")
    def customer_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerRegex"))

    @customer_regex.setter
    def customer_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13303a9977c79cd80bc842a4b3890993f5a29e9f80fa50432c66b7ad887f594e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerRegex", value)

    @builtins.property
    @jsii.member(jsii_name="customerReplace")
    def customer_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerReplace"))

    @customer_replace.setter
    def customer_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e0f3a0dab1a88d9c16606524dfef8455bb44c7007554c00b09f1dade7bdcb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerReplace", value)

    @builtins.property
    @jsii.member(jsii_name="customerTitle")
    def customer_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerTitle"))

    @customer_title.setter
    def customer_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f56e3d119ad6cf6492dcb63c7977fa3a59647a06aefe0fe1280673a16cdd41f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff04ad2e7e478658ca0020b434783e84c6613c757f05a980fd428a4c4813f862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbbabc0eebc043c0215ba2d62863569e937ca7ac6d977e00acdcbd071ba805f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="usersAction")
    def users_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersAction"))

    @users_action.setter
    def users_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e634ca46b5bc1d0308bb28bb43f19b830aa9406edb6e00e3035043bd3613331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersAction", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabled")
    def users_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "usersCnameEnabled"))

    @users_cname_enabled.setter
    def users_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82d996df45d0cc39403c4bb5ff4b860a218b7b9a40793a9bca2e5701d143b73c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevel")
    def users_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "usersCnameLevel"))

    @users_cname_level.setter
    def users_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c185df0128a4532f13c5223fd79f47fede2c40f1a804232f35c9f2782b46b5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="usersCookie")
    def users_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersCookie"))

    @users_cookie.setter
    def users_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c410410972cc2bb6c99353361e8c53c012e51cc9db00a83d87b2b910cf251a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCookie", value)

    @builtins.property
    @jsii.member(jsii_name="usersQueryString")
    def users_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersQueryString"))

    @users_query_string.setter
    def users_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2090b9ab06e1d2a98c4b28f8a867354764ced99f9757ec56dff69ee18ec0819d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="usersRegex")
    def users_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersRegex"))

    @users_regex.setter
    def users_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12b921e52444420e24ac3e7d5d722651ea2e675f8fd1cba6335226b778997fbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersRegex", value)

    @builtins.property
    @jsii.member(jsii_name="usersReplace")
    def users_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersReplace"))

    @users_replace.setter
    def users_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3f8f929a2cab055587526dd5b285c690ef5074e4e189fd02a6eec422675e440)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersReplace", value)

    @builtins.property
    @jsii.member(jsii_name="usersTitle")
    def users_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersTitle"))

    @users_title.setter
    def users_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5357ad698847c8d8c4129b7fea5d2c0b6ce16b9bc46e1b27cee1b88f1cc2eb0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21ff44b54249eabd90438eac2f7d7dca7728f5bf3e898e4d41b6f200fb56eba2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df277961291e85435ab5eec8877cb5c69d417cd2b59ac531bf139fb97a3ebb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient",
    jsii_struct_bases=[],
    name_mapping={
        "allow_override_origin_cache_key": "allowOverrideOriginCacheKey",
        "connector_id": "connectorId",
        "enabled": "enabled",
        "locked": "locked",
        "origin_host_header": "originHostHeader",
        "origin_type": "originType",
        "sf3_c_origin_host": "sf3COriginHost",
        "sf3_c_origin_host_header": "sf3COriginHostHeader",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient:
    def __init__(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85c8ce73d3c176a8d77509bbf33effd713bdb05d4460f4850f2d484b57c231a)
            check_type(argname="argument allow_override_origin_cache_key", value=allow_override_origin_cache_key, expected_type=type_hints["allow_override_origin_cache_key"])
            check_type(argname="argument connector_id", value=connector_id, expected_type=type_hints["connector_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_host_header", value=origin_host_header, expected_type=type_hints["origin_host_header"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument sf3_c_origin_host", value=sf3_c_origin_host, expected_type=type_hints["sf3_c_origin_host"])
            check_type(argname="argument sf3_c_origin_host_header", value=sf3_c_origin_host_header, expected_type=type_hints["sf3_c_origin_host_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_override_origin_cache_key is not None:
            self._values["allow_override_origin_cache_key"] = allow_override_origin_cache_key
        if connector_id is not None:
            self._values["connector_id"] = connector_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if origin_host_header is not None:
            self._values["origin_host_header"] = origin_host_header
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if sf3_c_origin_host is not None:
            self._values["sf3_c_origin_host"] = sf3_c_origin_host
        if sf3_c_origin_host_header is not None:
            self._values["sf3_c_origin_host_header"] = sf3_c_origin_host_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides the forwarding origin's cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        '''
        result = self._values.get("allow_override_origin_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def connector_id(self) -> typing.Optional[builtins.str]:
        '''An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud.

        Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud.  You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        '''
        result = self._values.get("connector_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamai Connector for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_host_header(self) -> typing.Optional[builtins.str]:
        '''Specifies where the ``Host`` header is defined.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        '''
        result = self._values.get("origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Specifies where the origin is.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        '''
        result = self._values.get("sf3_c_origin_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce host header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        '''
        result = self._values.get("sf3_c_origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e9f01c106aa493591616ad6bf6757eee63e88114e8621e8b96b6c5c1431773)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowOverrideOriginCacheKey")
    def reset_allow_override_origin_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOverrideOriginCacheKey", []))

    @jsii.member(jsii_name="resetConnectorId")
    def reset_connector_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConnectorId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginHostHeader")
    def reset_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginHostHeader", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetSf3COriginHost")
    def reset_sf3_c_origin_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHost", []))

    @jsii.member(jsii_name="resetSf3COriginHostHeader")
    def reset_sf3_c_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHostHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKeyInput")
    def allow_override_origin_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowOverrideOriginCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="connectorIdInput")
    def connector_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "connectorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originHostHeaderInput")
    def origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeaderInput")
    def sf3_c_origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostInput")
    def sf3_c_origin_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKey")
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowOverrideOriginCacheKey"))

    @allow_override_origin_cache_key.setter
    def allow_override_origin_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8641fc1028aec149c7b6a2bd4abd036b2a5c2cf083d3c562fb51cbedb586158)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOverrideOriginCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="connectorId")
    def connector_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "connectorId"))

    @connector_id.setter
    def connector_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b2bf2568ed2830c5de7f2fbea337fe53aedeca993c1fc468c2ee2edb777947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "connectorId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf68b5e3db1a36a04b27eb1934271eab1ef6ade37c40ef144dc6715f0df6e1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18dda5c92da89afaa8b56e7bdbb960105a538bf6b7b17bc66efc3ea36d53a8c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originHostHeader")
    def origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originHostHeader"))

    @origin_host_header.setter
    def origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acccf8a18b4157d64ba5d421838fa4f71e3c7d4fc95fa3de610acd9a1ae4e162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9340ef0256a6ea8533030e72afc6cee11d0efaeb25bb2d0a6482478c44c170dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHost")
    def sf3_c_origin_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHost"))

    @sf3_c_origin_host.setter
    def sf3_c_origin_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdd9cce99b74d6925e537e6a4690556fdc9bbcb06ced2d7e58822997fa2a1784)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHost", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeader")
    def sf3_c_origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHostHeader"))

    @sf3_c_origin_host_header.setter
    def sf3_c_origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d56289d4fb1db6ab0d5ce0b594e0a0efa6449de65577a318f078cdc4ec13e499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d09987de12865c6c76ec6da13b91d8e0c1be0045a41f24e6bcb9d5b76f55d363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__129bb99bce76e3ca739cd943d7176afb7104ebf5f6e4ba3fa3414d542c624a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7bcfbb1567bb960e25510edfc1671088a1a172f72690506d84e912845051160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda85b5c8f3d90c420f5e1119b390f3d58b3bd9c47942c46edfea79c55633cbf)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Akamai Provider for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader",
    jsii_struct_bases=[],
    name_mapping={
        "host_header_source": "hostHeaderSource",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader:
    def __init__(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1741cc9921c9619510d9b499206b9627a2323efc8e61f13a3ced1e58e2562cf5)
            check_type(argname="argument host_header_source", value=host_header_source, expected_type=type_hints["host_header_source"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if host_header_source is not None:
            self._values["host_header_source"] = host_header_source
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def host_header_source(self) -> typing.Optional[builtins.str]:
        '''Specify where the host header derives from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        '''
        result = self._values.get("host_header_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ab4868add2c83da7626ecbcc319d8bb82046e018eb6acbeb61710a951fc166)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHostHeaderSource")
    def reset_host_header_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostHeaderSource", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSourceInput")
    def host_header_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostHeaderSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSource")
    def host_header_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostHeaderSource"))

    @host_header_source.setter
    def host_header_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6533584d78fa991ae03675f2ef43e8b75c0c6e7c8a37e1d4bac0c59fb5ebb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostHeaderSource", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f27b17689cee7cf4caf08fe7c2a9af3310004c502592dc388786e944f5af501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1781b5da0a9dd34b4a86a2a9c06497d353cf210a23fb311575a4d97a6b9fce0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6f72a6816e3681c76c3cbf26b6c2e1670f203ec884c8e3b58745fa5d31f96a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbfcb6bb76bc4a61e69514e6f1f561c3bd7232ec86ae79df74db3e8502032261)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34fc3d4e0cd61e92f5c43ac6a3e6a5a6a3942ada65370c074c884288520be91b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef40151456c8a472c9408151c03c4d519db56e43bf2b7e2de36ce086a97a5d8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fa85183a5ece2ec25bd6eed4fdc306cf638168a87f1333dd6cb0d3709fea463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__220fd9ff1ead9244bfb182873b62674f7e57f90e502554bde1f3e0cbfc72dcac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9842a344d9048ae13f19bc544ce96c174131ebd7e151ac843b4e9c9a327504f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fbc5a27ed8607c89d1a1e205eb004c4b8cbe1532354c4365ce27941eb63994c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3844a02efe7cae47df3335a6984f968bc8577cecef70a8167e785bfa62d4b56b)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables processing of POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9bc33c6bf2d36a2a573284c629e47e947acd1865d121a3bb468ee0cf3cf883f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0361f8c7305f0188b6de8d30b458fee0adbea1dcc28f57229eeb7d5b7de169e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d5ca90f1d152c1d929bd26089077687c8d99edc02f31229f8c3e3ba1b49092a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1e42fcdaa6556a223d4e763890e02c6c968e5ee84a6526645280ab7bb7aec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01d2b686a6d86e5ae2db7259fcea3ebdd4e5c82d3a4467fea24e73ee580befa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853be8f57e21b7e41a17522080a6d77c6c4924fa6b5dd0b7059317933a6343dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "refresh_method": "refreshMethod",
        "repeat": "repeat",
        "repeat_interval": "repeatInterval",
        "start": "start",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a483402adec7ed7c08526b0d8242d6633d128fbe76055d2a299bfd26fde12526)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument refresh_method", value=refresh_method, expected_type=type_hints["refresh_method"])
            check_type(argname="argument repeat", value=repeat, expected_type=type_hints["repeat"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument start", value=start, expected_type=type_hints["start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if refresh_method is not None:
            self._values["refresh_method"] = refresh_method
        if repeat is not None:
            self._values["repeat"] = repeat
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if start is not None:
            self._values["start"] = start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_method(self) -> typing.Optional[builtins.str]:
        '''Specifies how to invalidate the content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        '''
        result = self._values.get("refresh_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        '''
        result = self._values.get("repeat")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies how often to invalidate content from the ``start`` time, expressed in seconds.

        For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day.  Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start(self) -> typing.Optional[builtins.str]:
        '''The UTC date and time when matching cached content is to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        '''
        result = self._values.get("start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9249425409b450b10391f255f1f8c02c1c0527735ad4b9ec4e117f86f83deaaf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRefreshMethod")
    def reset_refresh_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshMethod", []))

    @jsii.member(jsii_name="resetRepeat")
    def reset_repeat(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeat", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetStart")
    def reset_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshMethodInput")
    def refresh_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatInput")
    def repeat_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "repeatInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="startInput")
    def start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f8ce0ff6d374c65fc9d0c3f4b2aa723dce2a333c49e251b23fb5421c835799)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="refreshMethod")
    def refresh_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshMethod"))

    @refresh_method.setter
    def refresh_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e815a1d45a5cdf6e1f23fef77e9e76808eba7be9f8749531e9587e7319bcc1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshMethod", value)

    @builtins.property
    @jsii.member(jsii_name="repeat")
    def repeat(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "repeat"))

    @repeat.setter
    def repeat(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2bae7ef94330523ffcb05b9a5283436ac0f5ee06897066efc3276b72cfa01f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeat", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74ed0037d6b440869fbd9544396c3599641e411e8d6d4fa607f7559c3242eefc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="start")
    def start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "start"))

    @start.setter
    def start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fddbfaa62667e04d9e2d634b69d6d0def89a63f8b379623c9f6e533370c62f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "start", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f982f2e41cc95316f7b3a70829df7e8abf9c7ed40b1a23afb5c715f4cf3360d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5097ae0c8c432f67d8af189822e4d5fdbfef75b9ba391a3db38c986ef49f039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988e038521dc4997191ecfb31f41e2ef0c4c7abf47aad33d706a913ac9a777fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "serviceworker": "serviceworker",
        "template_uuid": "templateUuid",
        "timestamp": "timestamp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc543f02948b8d8e804fc15c112a979371bb5a29cbec23a0d3f5c755ca15cb34)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serviceworker", value=serviceworker, expected_type=type_hints["serviceworker"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timestamp", value=timestamp, expected_type=type_hints["timestamp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if serviceworker is not None:
            self._values["serviceworker"] = serviceworker
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timestamp is not None:
            self._values["timestamp"] = timestamp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Script Management feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serviceworker(self) -> typing.Optional[builtins.str]:
        '''Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        '''
        result = self._values.get("serviceworker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timestamp(self) -> typing.Optional[jsii.Number]:
        '''A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        '''
        result = self._values.get("timestamp")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagementOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagementOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000e0713cf7b139869b71d6f40879767155da59ae9e64cb185201ffa72dac214)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServiceworker")
    def reset_serviceworker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServiceworker", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimestamp")
    def reset_timestamp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimestamp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serviceworkerInput")
    def serviceworker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serviceworkerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timestampInput")
    def timestamp_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "timestampInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52ca09040b819e61e6f4452aa8e354af622e34a3bf3cdab16686b94970ddac8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0356ff8d63d0c19ec7d461f5364afa95c308d737c47e97f9f6bc0d5db7aa3233)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serviceworker")
    def serviceworker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serviceworker"))

    @serviceworker.setter
    def serviceworker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b334f6c9461b5670b910f48640a89c7c656cc2444626f4fb5e0ce3583168e534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serviceworker", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02ce24cf94a31e34c6703ad3eee4bb538b78bd636cb3ad078ce43d5d5174c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timestamp")
    def timestamp(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "timestamp"))

    @timestamp.setter
    def timestamp(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c77d6a93c70332cbb60ad6386c749af1757cf006383bec0b8a28de435954306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timestamp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28a4541a1941c36c6e19eeb90f18eeb94ebf12e22ff7dae23cc23ba6e91e8c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__116e440209f9c42aa82bf45751cd5693424827b852d659eb14693cde09ec177f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection",
    jsii_struct_bases=[],
    name_mapping={
        "acl": "acl",
        "dash_media_encryption": "dashMediaEncryption",
        "data_payload": "dataPayload",
        "enabled": "enabled",
        "enable_token_in_uri": "enableTokenInUri",
        "field_carry_over": "fieldCarryOver",
        "header_for_salt": "headerForSalt",
        "hls_master_manifest_files": "hlsMasterManifestFiles",
        "hls_media_encryption": "hlsMediaEncryption",
        "ip": "ip",
        "key": "key",
        "locked": "locked",
        "media_encryption_title": "mediaEncryptionTitle",
        "revoked_list_id": "revokedListId",
        "salt": "salt",
        "session_id": "sessionId",
        "template_uuid": "templateUuid",
        "token_authentication_title": "tokenAuthenticationTitle",
        "token_auth_hls_title": "tokenAuthHlsTitle",
        "token_revocation_enabled": "tokenRevocationEnabled",
        "token_revocation_title": "tokenRevocationTitle",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection:
    def __init__(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c448c13ac8a440d71e26e7416419c4e6879f0497a7dc73c73cf84a79a7c484e1)
            check_type(argname="argument acl", value=acl, expected_type=type_hints["acl"])
            check_type(argname="argument dash_media_encryption", value=dash_media_encryption, expected_type=type_hints["dash_media_encryption"])
            check_type(argname="argument data_payload", value=data_payload, expected_type=type_hints["data_payload"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_token_in_uri", value=enable_token_in_uri, expected_type=type_hints["enable_token_in_uri"])
            check_type(argname="argument field_carry_over", value=field_carry_over, expected_type=type_hints["field_carry_over"])
            check_type(argname="argument header_for_salt", value=header_for_salt, expected_type=type_hints["header_for_salt"])
            check_type(argname="argument hls_master_manifest_files", value=hls_master_manifest_files, expected_type=type_hints["hls_master_manifest_files"])
            check_type(argname="argument hls_media_encryption", value=hls_media_encryption, expected_type=type_hints["hls_media_encryption"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_encryption_title", value=media_encryption_title, expected_type=type_hints["media_encryption_title"])
            check_type(argname="argument revoked_list_id", value=revoked_list_id, expected_type=type_hints["revoked_list_id"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument session_id", value=session_id, expected_type=type_hints["session_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authentication_title", value=token_authentication_title, expected_type=type_hints["token_authentication_title"])
            check_type(argname="argument token_auth_hls_title", value=token_auth_hls_title, expected_type=type_hints["token_auth_hls_title"])
            check_type(argname="argument token_revocation_enabled", value=token_revocation_enabled, expected_type=type_hints["token_revocation_enabled"])
            check_type(argname="argument token_revocation_title", value=token_revocation_title, expected_type=type_hints["token_revocation_title"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if acl is not None:
            self._values["acl"] = acl
        if dash_media_encryption is not None:
            self._values["dash_media_encryption"] = dash_media_encryption
        if data_payload is not None:
            self._values["data_payload"] = data_payload
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_token_in_uri is not None:
            self._values["enable_token_in_uri"] = enable_token_in_uri
        if field_carry_over is not None:
            self._values["field_carry_over"] = field_carry_over
        if header_for_salt is not None:
            self._values["header_for_salt"] = header_for_salt
        if hls_master_manifest_files is not None:
            self._values["hls_master_manifest_files"] = hls_master_manifest_files
        if hls_media_encryption is not None:
            self._values["hls_media_encryption"] = hls_media_encryption
        if ip is not None:
            self._values["ip"] = ip
        if key is not None:
            self._values["key"] = key
        if locked is not None:
            self._values["locked"] = locked
        if media_encryption_title is not None:
            self._values["media_encryption_title"] = media_encryption_title
        if revoked_list_id is not None:
            self._values["revoked_list_id"] = revoked_list_id
        if salt is not None:
            self._values["salt"] = salt
        if session_id is not None:
            self._values["session_id"] = session_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authentication_title is not None:
            self._values["token_authentication_title"] = token_authentication_title
        if token_auth_hls_title is not None:
            self._values["token_auth_hls_title"] = token_auth_hls_title
        if token_revocation_enabled is not None:
            self._values["token_revocation_enabled"] = token_revocation_enabled
        if token_revocation_title is not None:
            self._values["token_revocation_title"] = token_revocation_title
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def acl(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field.

        Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        '''
        result = self._values.get("acl")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dash_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to enable DASH Media Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        '''
        result = self._values.get("dash_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def data_payload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        '''
        result = self._values.get("data_payload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the segmented content protection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_token_in_uri(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        '''
        result = self._values.get("enable_token_in_uri")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def field_carry_over(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        '''
        result = self._values.get("field_carry_over")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_for_salt(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session.

        This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        '''
        result = self._values.get("header_for_salt")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_master_manifest_files(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of filenames that form HLS master manifest URLs.

        You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        '''
        result = self._values.get("hls_master_manifest_files")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HLS Segment Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        '''
        result = self._values.get("hls_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption key to use as a shared secret to validate tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        '''
        result = self._values.get("media_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def revoked_list_id(self) -> typing.Optional[jsii.Number]:
        '''Identifies the ``TokenAuth`` tokens to block from accessing your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        '''
        result = self._values.get("revoked_list_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt as input into the token for added security.

        This value needs to match the salt used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def session_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        '''
        result = self._values.get("session_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authentication_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        '''
        result = self._values.get("token_authentication_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_auth_hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        '''
        result = self._values.get("token_auth_hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_revocation_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        '''
        result = self._values.get("token_revocation_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def token_revocation_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        '''
        result = self._values.get("token_revocation_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify advanced ``transitionKey`` and ``salt`` options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b4b3fe0580ce127839a3b13feea663de96ecaa7f6670a66ba4a1dc3d9d73499)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcl")
    def reset_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcl", []))

    @jsii.member(jsii_name="resetDashMediaEncryption")
    def reset_dash_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDashMediaEncryption", []))

    @jsii.member(jsii_name="resetDataPayload")
    def reset_data_payload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataPayload", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableTokenInUri")
    def reset_enable_token_in_uri(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTokenInUri", []))

    @jsii.member(jsii_name="resetFieldCarryOver")
    def reset_field_carry_over(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFieldCarryOver", []))

    @jsii.member(jsii_name="resetHeaderForSalt")
    def reset_header_for_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderForSalt", []))

    @jsii.member(jsii_name="resetHlsMasterManifestFiles")
    def reset_hls_master_manifest_files(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMasterManifestFiles", []))

    @jsii.member(jsii_name="resetHlsMediaEncryption")
    def reset_hls_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMediaEncryption", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaEncryptionTitle")
    def reset_media_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaEncryptionTitle", []))

    @jsii.member(jsii_name="resetRevokedListId")
    def reset_revoked_list_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevokedListId", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetSessionId")
    def reset_session_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthenticationTitle")
    def reset_token_authentication_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthenticationTitle", []))

    @jsii.member(jsii_name="resetTokenAuthHlsTitle")
    def reset_token_auth_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthHlsTitle", []))

    @jsii.member(jsii_name="resetTokenRevocationEnabled")
    def reset_token_revocation_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationEnabled", []))

    @jsii.member(jsii_name="resetTokenRevocationTitle")
    def reset_token_revocation_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationTitle", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aclInput")
    def acl_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "aclInput"))

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryptionInput")
    def dash_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="dataPayloadInput")
    def data_payload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dataPayloadInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUriInput")
    def enable_token_in_uri_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTokenInUriInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOverInput")
    def field_carry_over_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldCarryOverInput"))

    @builtins.property
    @jsii.member(jsii_name="headerForSaltInput")
    def header_for_salt_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headerForSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFilesInput")
    def hls_master_manifest_files_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "hlsMasterManifestFilesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryptionInput")
    def hls_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitleInput")
    def media_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="revokedListIdInput")
    def revoked_list_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "revokedListIdInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionIdInput")
    def session_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitleInput")
    def token_authentication_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthenticationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitleInput")
    def token_auth_hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthHlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabledInput")
    def token_revocation_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenRevocationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitleInput")
    def token_revocation_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenRevocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acl")
    def acl(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "acl"))

    @acl.setter
    def acl(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8fb4dbd00f71db469a8f699c2831d2bc3c55033c3d409d1d97f55174b1761a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acl", value)

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryption")
    def dash_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dashMediaEncryption"))

    @dash_media_encryption.setter
    def dash_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dbfbe5b45a855d1f82c2330fc2c666899f571881a933ea0ce07c5f438faca64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dashMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="dataPayload")
    def data_payload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dataPayload"))

    @data_payload.setter
    def data_payload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__098622e2ec2a1508ad47f4aff0d23b127f3311a60a65aadbb980f25121bfae8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataPayload", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce73b8d79472fbe9cb43ed41a8ed7fe134595d4a0d0f848c29be01623696c94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUri")
    def enable_token_in_uri(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTokenInUri"))

    @enable_token_in_uri.setter
    def enable_token_in_uri(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5eb1fe0ac8334f61f889e48ed43da06912d13f07452b9747eed4bb7eb05590a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTokenInUri", value)

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOver")
    def field_carry_over(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fieldCarryOver"))

    @field_carry_over.setter
    def field_carry_over(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913e0951d274a346525b9d0b2e53d5fc6639cd36ec2e065002e6756e1588f5ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fieldCarryOver", value)

    @builtins.property
    @jsii.member(jsii_name="headerForSalt")
    def header_for_salt(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headerForSalt"))

    @header_for_salt.setter
    def header_for_salt(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8022c12474a6e5f9332ad21b16e4779bad036be1dc17afffcd2e561cf1d9ec49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerForSalt", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFiles")
    def hls_master_manifest_files(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "hlsMasterManifestFiles"))

    @hls_master_manifest_files.setter
    def hls_master_manifest_files(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49410c3eb192208a39caf5180acfc440619cece859ec46219bd99d072f8786a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMasterManifestFiles", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryption")
    def hls_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsMediaEncryption"))

    @hls_media_encryption.setter
    def hls_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4e2ebd445f6a12ce756d8bfeec00095f5d6189ce04616c2f9df7a4d743bb90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d4bb97e57b84286cae29f2e158ae3d741f6c0a7dcc9d2b265090c9335686028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2498cc63df18d4e3325d36e6683b5a19fde808280eee41bf785123133296966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30671d5483e5657b1b6bb57f5f6bb0baa4f6c5034e25e3b597e32a51e4f5e8c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitle")
    def media_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaEncryptionTitle"))

    @media_encryption_title.setter
    def media_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9168a4991c183ad95357673b8feb90a74863ec0929eea1d2d011a0077af910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="revokedListId")
    def revoked_list_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "revokedListId"))

    @revoked_list_id.setter
    def revoked_list_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65923845437edf4e613d0ec251dd4fcb9aaf1ab800f0f1f2483d1121e28ff781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revokedListId", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbde30a8b2facff07472dbf6ba1e76788357e99a407eb5ea668ff0cc8f683264)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="sessionId")
    def session_id(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionId"))

    @session_id.setter
    def session_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a8b7e8ab6928c299b188b0493e7b9cfb71c558d2080d9283ed3c2068ba9e34c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0662b326476031362db07793b107cbf5f93280e6ea3b6d3dc7577a00d115942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitle")
    def token_authentication_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthenticationTitle"))

    @token_authentication_title.setter
    def token_authentication_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034faeb74cd7eadd0d4c8af5bb5f0995ecd2de8e037358be26c9ffe600ed4f47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthenticationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitle")
    def token_auth_hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthHlsTitle"))

    @token_auth_hls_title.setter
    def token_auth_hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85513724a1431467ca9cea693ab974d3a9808c9d6ed53a74c04eaba7f6229d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthHlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabled")
    def token_revocation_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenRevocationEnabled"))

    @token_revocation_enabled.setter
    def token_revocation_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd053c542e38584e1dd86249c6fa6957673a0619f4db29d485144d11048805f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitle")
    def token_revocation_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenRevocationTitle"))

    @token_revocation_title.setter
    def token_revocation_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d7d4b9c6145f2bdebfc6f9e37309ee1c0f0a64214aec1fd34d55f4d49427d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72b62e5001cd3c754ef43ceda1965f82d26abe743191d6f25634ad09e168ff45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc48d9d19e0554ed7fbf4806416f2a971af963778ba1928ec05825dda7bdc19e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa99c2f68dcaa2939adf138528f9778f4f5adeb9025eaae178452e585b96596b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea4d19b61a56da29438599767045bb37cf06a7cd90caa73f4738a4f77977b11f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "dvr_type": "dvrType",
        "dvr_window": "dvrWindow",
        "enable_ull_streaming": "enableUllStreaming",
        "end_time": "endTime",
        "live_type": "liveType",
        "locked": "locked",
        "show_advanced": "showAdvanced",
        "start_time": "startTime",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f67614461e3b2e63293626fc8e5f44cc1f04476c73028cb9073ef72244a52552)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument dvr_type", value=dvr_type, expected_type=type_hints["dvr_type"])
            check_type(argname="argument dvr_window", value=dvr_window, expected_type=type_hints["dvr_window"])
            check_type(argname="argument enable_ull_streaming", value=enable_ull_streaming, expected_type=type_hints["enable_ull_streaming"])
            check_type(argname="argument end_time", value=end_time, expected_type=type_hints["end_time"])
            check_type(argname="argument live_type", value=live_type, expected_type=type_hints["live_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument show_advanced", value=show_advanced, expected_type=type_hints["show_advanced"])
            check_type(argname="argument start_time", value=start_time, expected_type=type_hints["start_time"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if dvr_type is not None:
            self._values["dvr_type"] = dvr_type
        if dvr_window is not None:
            self._values["dvr_window"] = dvr_window
        if enable_ull_streaming is not None:
            self._values["enable_ull_streaming"] = enable_ull_streaming
        if end_time is not None:
            self._values["end_time"] = end_time
        if live_type is not None:
            self._values["live_type"] = live_type
        if locked is not None:
            self._values["locked"] = locked
        if show_advanced is not None:
            self._values["show_advanced"] = show_advanced
        if start_time is not None:
            self._values["start_time"] = start_time
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Sets the type of media content to optimize.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_type(self) -> typing.Optional[builtins.str]:
        '''The type of DVR.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        '''
        result = self._values.get("dvr_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_window(self) -> typing.Optional[builtins.str]:
        '''Set the duration for your media, or ``0m`` if a DVR is not required.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        '''
        result = self._values.get("dvr_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_ull_streaming(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        '''
        result = self._values.get("enable_ull_streaming")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def end_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event ends.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        '''
        result = self._values.get("end_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def live_type(self) -> typing.Optional[builtins.str]:
        '''The type of live media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        '''
        result = self._values.get("live_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced media options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        '''
        result = self._values.get("show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def start_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event begins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        '''
        result = self._values.get("start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1da4d0e36c37477afd45d371d33c3b102a57d74e357cfd8cdd8ef2eb9600a501)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetDvrType")
    def reset_dvr_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrType", []))

    @jsii.member(jsii_name="resetDvrWindow")
    def reset_dvr_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrWindow", []))

    @jsii.member(jsii_name="resetEnableUllStreaming")
    def reset_enable_ull_streaming(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableUllStreaming", []))

    @jsii.member(jsii_name="resetEndTime")
    def reset_end_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndTime", []))

    @jsii.member(jsii_name="resetLiveType")
    def reset_live_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetShowAdvanced")
    def reset_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShowAdvanced", []))

    @jsii.member(jsii_name="resetStartTime")
    def reset_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartTime", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrTypeInput")
    def dvr_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrWindowInput")
    def dvr_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="enableUllStreamingInput")
    def enable_ull_streaming_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableUllStreamingInput"))

    @builtins.property
    @jsii.member(jsii_name="endTimeInput")
    def end_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="liveTypeInput")
    def live_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "liveTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="showAdvancedInput")
    def show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "showAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="startTimeInput")
    def start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c98e6d7b5c473878edcb42b773277d4c19bf784169f573280b5e5e1c159507)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="dvrType")
    def dvr_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrType"))

    @dvr_type.setter
    def dvr_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ab21bc8984707359931d22cc7cf50ca1fad15221bea81acd4313ade73316deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrType", value)

    @builtins.property
    @jsii.member(jsii_name="dvrWindow")
    def dvr_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrWindow"))

    @dvr_window.setter
    def dvr_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2d9709519c198c83129b3f55ee4c5a429bf887843bac79377c631092693ad7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrWindow", value)

    @builtins.property
    @jsii.member(jsii_name="enableUllStreaming")
    def enable_ull_streaming(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableUllStreaming"))

    @enable_ull_streaming.setter
    def enable_ull_streaming(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__026db6c956ec4a552b84b309796e1fffbd3ae5633f8c6a68983e83219ac7641c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableUllStreaming", value)

    @builtins.property
    @jsii.member(jsii_name="endTime")
    def end_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endTime"))

    @end_time.setter
    def end_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dad120297b58b39be86151ece3c9fc51ba56ef3d82223c68121ca79e7ffa62e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endTime", value)

    @builtins.property
    @jsii.member(jsii_name="liveType")
    def live_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "liveType"))

    @live_type.setter
    def live_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4817b2d39d496fe27386ecc8e9cd53f5280db1b8f68ed5ab6d1316101d9ab61e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32cd7263c24e2b6fade8cecf27b55691807f90b6a89904fb208b37381bc2159e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="showAdvanced")
    def show_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "showAdvanced"))

    @show_advanced.setter
    def show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb1923745efb325871c565b8c71fad21b968ea94b2d0307b652b45c28a6283ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "showAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="startTime")
    def start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "startTime"))

    @start_time.setter
    def start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429aa05e4b5357f00d233375521b819c11be6a888a19815dd68740a6e21f7f0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startTime", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628d3098bb24dc37bc43971812b8c3197c5c8024f6673e707bd950a500167168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc3350272855bd94835da3fbaf5486ffb96ee79943d87f426c53988afa2c156)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44ce3f4dea6a049432f01ff97701b04fb888e86d7f1e0605eb930c47277467d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac4f750e0ca4a4c73423f80a727a6786fc6b15931bce5449f687f7eebd472c7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables media stream prefetching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ca1a1363cc67f5c7737cc1835ba27f1cf5a35ad53090b984249ebb10de19a01)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4fd36630ca5164c99f07377bf354b8b3da99a3d023f1bc539d5aad098111a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a60c69478266438e982843c4535813e91258a72c6aac9e1ee7c6a28daf154b3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d894da5330dc1d81a378cf73114b107f1b65205e9a8aee171f8d8beb696a5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5641856f239bf895fe7c4f731cc732aa60b993e740f626f45ebedb655d8cf777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de5bf2818de470ddd1238acb792f1af9d4b94fc6bb084cddd954a1f377ba99cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "case_sensitive": "caseSensitive",
        "certificate_field_name": "certificateFieldName",
        "cookie_name": "cookieName",
        "device_profile": "deviceProfile",
        "encryption_key": "encryptionKey",
        "encryption_mode": "encryptionMode",
        "end_index": "endIndex",
        "except_chars": "exceptChars",
        "extract_location": "extractLocation",
        "force_chars": "forceChars",
        "format_string": "formatString",
        "generator": "generator",
        "global_substitution": "globalSubstitution",
        "header_name": "headerName",
        "hmac_algorithm": "hmacAlgorithm",
        "hmac_key": "hmacKey",
        "initialization_vector": "initializationVector",
        "ipv4_prefix": "ipv4Prefix",
        "ipv6_prefix": "ipv6Prefix",
        "ip_version": "ipVersion",
        "location_id": "locationId",
        "locked": "locked",
        "max": "max",
        "max_random_number": "maxRandomNumber",
        "min": "min",
        "min_random_number": "minRandomNumber",
        "nonce": "nonce",
        "number_of_bytes": "numberOfBytes",
        "operand_one": "operandOne",
        "param_name": "paramName",
        "path_component_offset": "pathComponentOffset",
        "prepend_bytes": "prependBytes",
        "query_parameter_name": "queryParameterName",
        "regex": "regex",
        "replacement": "replacement",
        "response_header_name": "responseHeaderName",
        "separator": "separator",
        "set_cookie_name": "setCookieName",
        "start_index": "startIndex",
        "sub_string": "subString",
        "template_uuid": "templateUuid",
        "transform": "transform",
        "uuid": "uuid",
        "value_source": "valueSource",
        "variable_name": "variableName",
        "variable_value": "variableValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[jsii.Number] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[jsii.Number] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[jsii.Number] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[jsii.Number] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65711c41efd53ac2331a2d2c7f364aaf440eb6582f5bb7966f337b3d9bc8515)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument certificate_field_name", value=certificate_field_name, expected_type=type_hints["certificate_field_name"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument device_profile", value=device_profile, expected_type=type_hints["device_profile"])
            check_type(argname="argument encryption_key", value=encryption_key, expected_type=type_hints["encryption_key"])
            check_type(argname="argument encryption_mode", value=encryption_mode, expected_type=type_hints["encryption_mode"])
            check_type(argname="argument end_index", value=end_index, expected_type=type_hints["end_index"])
            check_type(argname="argument except_chars", value=except_chars, expected_type=type_hints["except_chars"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument force_chars", value=force_chars, expected_type=type_hints["force_chars"])
            check_type(argname="argument format_string", value=format_string, expected_type=type_hints["format_string"])
            check_type(argname="argument generator", value=generator, expected_type=type_hints["generator"])
            check_type(argname="argument global_substitution", value=global_substitution, expected_type=type_hints["global_substitution"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument hmac_algorithm", value=hmac_algorithm, expected_type=type_hints["hmac_algorithm"])
            check_type(argname="argument hmac_key", value=hmac_key, expected_type=type_hints["hmac_key"])
            check_type(argname="argument initialization_vector", value=initialization_vector, expected_type=type_hints["initialization_vector"])
            check_type(argname="argument ipv4_prefix", value=ipv4_prefix, expected_type=type_hints["ipv4_prefix"])
            check_type(argname="argument ipv6_prefix", value=ipv6_prefix, expected_type=type_hints["ipv6_prefix"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max", value=max, expected_type=type_hints["max"])
            check_type(argname="argument max_random_number", value=max_random_number, expected_type=type_hints["max_random_number"])
            check_type(argname="argument min", value=min, expected_type=type_hints["min"])
            check_type(argname="argument min_random_number", value=min_random_number, expected_type=type_hints["min_random_number"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument number_of_bytes", value=number_of_bytes, expected_type=type_hints["number_of_bytes"])
            check_type(argname="argument operand_one", value=operand_one, expected_type=type_hints["operand_one"])
            check_type(argname="argument param_name", value=param_name, expected_type=type_hints["param_name"])
            check_type(argname="argument path_component_offset", value=path_component_offset, expected_type=type_hints["path_component_offset"])
            check_type(argname="argument prepend_bytes", value=prepend_bytes, expected_type=type_hints["prepend_bytes"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument replacement", value=replacement, expected_type=type_hints["replacement"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument separator", value=separator, expected_type=type_hints["separator"])
            check_type(argname="argument set_cookie_name", value=set_cookie_name, expected_type=type_hints["set_cookie_name"])
            check_type(argname="argument start_index", value=start_index, expected_type=type_hints["start_index"])
            check_type(argname="argument sub_string", value=sub_string, expected_type=type_hints["sub_string"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transform", value=transform, expected_type=type_hints["transform"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value_source", value=value_source, expected_type=type_hints["value_source"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_value", value=variable_value, expected_type=type_hints["variable_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if certificate_field_name is not None:
            self._values["certificate_field_name"] = certificate_field_name
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if device_profile is not None:
            self._values["device_profile"] = device_profile
        if encryption_key is not None:
            self._values["encryption_key"] = encryption_key
        if encryption_mode is not None:
            self._values["encryption_mode"] = encryption_mode
        if end_index is not None:
            self._values["end_index"] = end_index
        if except_chars is not None:
            self._values["except_chars"] = except_chars
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if force_chars is not None:
            self._values["force_chars"] = force_chars
        if format_string is not None:
            self._values["format_string"] = format_string
        if generator is not None:
            self._values["generator"] = generator
        if global_substitution is not None:
            self._values["global_substitution"] = global_substitution
        if header_name is not None:
            self._values["header_name"] = header_name
        if hmac_algorithm is not None:
            self._values["hmac_algorithm"] = hmac_algorithm
        if hmac_key is not None:
            self._values["hmac_key"] = hmac_key
        if initialization_vector is not None:
            self._values["initialization_vector"] = initialization_vector
        if ipv4_prefix is not None:
            self._values["ipv4_prefix"] = ipv4_prefix
        if ipv6_prefix is not None:
            self._values["ipv6_prefix"] = ipv6_prefix
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if max is not None:
            self._values["max"] = max
        if max_random_number is not None:
            self._values["max_random_number"] = max_random_number
        if min is not None:
            self._values["min"] = min
        if min_random_number is not None:
            self._values["min_random_number"] = min_random_number
        if nonce is not None:
            self._values["nonce"] = nonce
        if number_of_bytes is not None:
            self._values["number_of_bytes"] = number_of_bytes
        if operand_one is not None:
            self._values["operand_one"] = operand_one
        if param_name is not None:
            self._values["param_name"] = param_name
        if path_component_offset is not None:
            self._values["path_component_offset"] = path_component_offset
        if prepend_bytes is not None:
            self._values["prepend_bytes"] = prepend_bytes
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex is not None:
            self._values["regex"] = regex
        if replacement is not None:
            self._values["replacement"] = replacement
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if separator is not None:
            self._values["separator"] = separator
        if set_cookie_name is not None:
            self._values["set_cookie_name"] = set_cookie_name
        if start_index is not None:
            self._values["start_index"] = start_index
        if sub_string is not None:
            self._values["sub_string"] = sub_string
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transform is not None:
            self._values["transform"] = transform
        if uuid is not None:
            self._values["uuid"] = uuid
        if value_source is not None:
            self._values["value_source"] = value_source
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_value is not None:
            self._values["variable_value"] = variable_value

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this makes all matches case sensitive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def certificate_field_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the certificate's content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        '''
        result = self._values.get("certificate_field_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def device_profile(self) -> typing.Optional[builtins.str]:
        '''Specifies the client device attribute.

        Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        '''
        result = self._values.get("device_profile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption hex key.

        For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        '''
        result = self._values.get("encryption_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        '''
        result = self._values.get("encryption_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_index(self) -> typing.Optional[jsii.Number]:
        '''Specifies the zero-based character offset at the end of the substring, without including the character at that index position.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        '''
        result = self._values.get("end_index")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def except_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters ``not`` to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        '''
        result = self._values.get("except_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''This specifies from where to get the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def force_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        '''
        result = self._values.get("force_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format_string(self) -> typing.Optional[builtins.str]:
        '''Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``.

        A blank value defaults to RFC-2616 format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        '''
        result = self._values.get("format_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def generator(self) -> typing.Optional[builtins.str]:
        '''This specifies the type of value to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        '''
        result = self._values.get("generator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def global_substitution(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches in the string, not just the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        '''
        result = self._values.get("global_substitution")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to use to generate the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        '''
        result = self._values.get("hmac_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret to use in generating the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        '''
        result = self._values.get("hmac_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def initialization_vector(self) -> typing.Optional[builtins.str]:
        '''Specifies a one-time number as an initialization vector.

        It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        '''
        result = self._values.get("initialization_vector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ipv4_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV4 address, a value between 0 and 32.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        '''
        result = self._values.get("ipv4_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ipv6_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV6 address, a value between 0 and 128.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        '''
        result = self._values.get("ipv6_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the IP version under which a subnet mask generates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``X-Akamai-Edgescape`` header's field name.

        Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max(self) -> typing.Optional[jsii.Number]:
        '''Specifies a maximum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        '''
        result = self._values.get("max")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def max_random_number(self) -> typing.Optional[jsii.Number]:
        '''Specifies the upper bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        '''
        result = self._values.get("max_random_number")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min(self) -> typing.Optional[jsii.Number]:
        '''Specifies a minimum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        '''
        result = self._values.get("min")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min_random_number(self) -> typing.Optional[jsii.Number]:
        '''Specifies the lower bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        '''
        result = self._values.get("min_random_number")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the one-time number used for encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def number_of_bytes(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of random hex bytes to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        '''
        result = self._values.get("number_of_bytes")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def operand_one(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        '''
        result = self._values.get("operand_one")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def param_name(self) -> typing.Optional[builtins.str]:
        '''Extracts the value for the specified parameter name from a string that contains key/value pairs.

        (Use ``separator`` below to parse them.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        '''
        result = self._values.get("param_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def path_component_offset(self) -> typing.Optional[builtins.str]:
        '''This specifies a portion of the path.

        The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        '''
        result = self._values.get("path_component_offset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prepend_bytes(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a number of random bytes to prepend to the key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        '''
        result = self._values.get("prepend_bytes")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression pattern (PCRE) to match the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replacement(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        '''
        result = self._values.get("replacement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def separator(self) -> typing.Optional[builtins.str]:
        '''Specifies the character that separates pairs of values within the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        '''
        result = self._values.get("separator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def set_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the origin's ``Set-Cookie`` response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        '''
        result = self._values.get("set_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start_index(self) -> typing.Optional[jsii.Number]:
        '''Specifies the zero-based character offset at the start of the substring.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        '''
        result = self._values.get("start_index")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def sub_string(self) -> typing.Optional[builtins.str]:
        '''Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        '''
        result = self._values.get("sub_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transform(self) -> typing.Optional[builtins.str]:
        '''Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        '''
        result = self._values.get("transform")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_source(self) -> typing.Optional[builtins.str]:
        '''Determines how you want to set the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        '''
        result = self._values.get("value_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the predeclared root name of the variable to modify.

        When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_value(self) -> typing.Optional[builtins.str]:
        '''This directly specifies the value to assign to the variable.

        The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        result = self._values.get("variable_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__086cec89abe5800acf896d7f83c3ac5bb13528e1c0bd38af4edc15b901f92f58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetCertificateFieldName")
    def reset_certificate_field_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateFieldName", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDeviceProfile")
    def reset_device_profile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceProfile", []))

    @jsii.member(jsii_name="resetEncryptionKey")
    def reset_encryption_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionKey", []))

    @jsii.member(jsii_name="resetEncryptionMode")
    def reset_encryption_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionMode", []))

    @jsii.member(jsii_name="resetEndIndex")
    def reset_end_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndIndex", []))

    @jsii.member(jsii_name="resetExceptChars")
    def reset_except_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExceptChars", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetForceChars")
    def reset_force_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceChars", []))

    @jsii.member(jsii_name="resetFormatString")
    def reset_format_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatString", []))

    @jsii.member(jsii_name="resetGenerator")
    def reset_generator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGenerator", []))

    @jsii.member(jsii_name="resetGlobalSubstitution")
    def reset_global_substitution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalSubstitution", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetHmacAlgorithm")
    def reset_hmac_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacAlgorithm", []))

    @jsii.member(jsii_name="resetHmacKey")
    def reset_hmac_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacKey", []))

    @jsii.member(jsii_name="resetInitializationVector")
    def reset_initialization_vector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInitializationVector", []))

    @jsii.member(jsii_name="resetIpv4Prefix")
    def reset_ipv4_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv4Prefix", []))

    @jsii.member(jsii_name="resetIpv6Prefix")
    def reset_ipv6_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv6Prefix", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMax")
    def reset_max(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMax", []))

    @jsii.member(jsii_name="resetMaxRandomNumber")
    def reset_max_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxRandomNumber", []))

    @jsii.member(jsii_name="resetMin")
    def reset_min(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMin", []))

    @jsii.member(jsii_name="resetMinRandomNumber")
    def reset_min_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinRandomNumber", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetNumberOfBytes")
    def reset_number_of_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumberOfBytes", []))

    @jsii.member(jsii_name="resetOperandOne")
    def reset_operand_one(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperandOne", []))

    @jsii.member(jsii_name="resetParamName")
    def reset_param_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParamName", []))

    @jsii.member(jsii_name="resetPathComponentOffset")
    def reset_path_component_offset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPathComponentOffset", []))

    @jsii.member(jsii_name="resetPrependBytes")
    def reset_prepend_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrependBytes", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetReplacement")
    def reset_replacement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacement", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetSeparator")
    def reset_separator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeparator", []))

    @jsii.member(jsii_name="resetSetCookieName")
    def reset_set_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetCookieName", []))

    @jsii.member(jsii_name="resetStartIndex")
    def reset_start_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartIndex", []))

    @jsii.member(jsii_name="resetSubString")
    def reset_sub_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubString", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransform")
    def reset_transform(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransform", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValueSource")
    def reset_value_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueSource", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValue")
    def reset_variable_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValue", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldNameInput")
    def certificate_field_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldNameInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceProfileInput")
    def device_profile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deviceProfileInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionKeyInput")
    def encryption_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionModeInput")
    def encryption_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="endIndexInput")
    def end_index_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "endIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="exceptCharsInput")
    def except_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "exceptCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="forceCharsInput")
    def force_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forceCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="formatStringInput")
    def format_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatStringInput"))

    @builtins.property
    @jsii.member(jsii_name="generatorInput")
    def generator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "generatorInput"))

    @builtins.property
    @jsii.member(jsii_name="globalSubstitutionInput")
    def global_substitution_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "globalSubstitutionInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithmInput")
    def hmac_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacKeyInput")
    def hmac_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="initializationVectorInput")
    def initialization_vector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "initializationVectorInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv4PrefixInput")
    def ipv4_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv4PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv6PrefixInput")
    def ipv6_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv6PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxInput")
    def max_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxInput"))

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumberInput")
    def max_random_number_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="minInput")
    def min_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minInput"))

    @builtins.property
    @jsii.member(jsii_name="minRandomNumberInput")
    def min_random_number_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="numberOfBytesInput")
    def number_of_bytes_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numberOfBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="operandOneInput")
    def operand_one_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operandOneInput"))

    @builtins.property
    @jsii.member(jsii_name="paramNameInput")
    def param_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paramNameInput"))

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffsetInput")
    def path_component_offset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathComponentOffsetInput"))

    @builtins.property
    @jsii.member(jsii_name="prependBytesInput")
    def prepend_bytes_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prependBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementInput")
    def replacement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="separatorInput")
    def separator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "separatorInput"))

    @builtins.property
    @jsii.member(jsii_name="setCookieNameInput")
    def set_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "setCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="startIndexInput")
    def start_index_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "startIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="subStringInput")
    def sub_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subStringInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transformInput")
    def transform_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transformInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueSourceInput")
    def value_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValueInput")
    def variable_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableValueInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f245d00232e859941b52b33b80c643545621cca55e5e7557b39274765ca3b29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831059dffce0b5ff0edd90e16d6c2c602207bee9ca7c31f11a8ad0942e075e35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="certificateFieldName")
    def certificate_field_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateFieldName"))

    @certificate_field_name.setter
    def certificate_field_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de399fa70db889a9b8e1f7788db74339897ddc829ddbb4e43604563cef3896de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateFieldName", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c880dcfa9b9066b2beaab69674ea775545f2686e4ba4e92e48ca9911eab94737)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="deviceProfile")
    def device_profile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deviceProfile"))

    @device_profile.setter
    def device_profile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__033f20b7e852e9d19ce166ca1d2e890ed6b829b3f4dcce6d34cda425f5b7f20f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deviceProfile", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionKey")
    def encryption_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionKey"))

    @encryption_key.setter
    def encryption_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04523169d8a37e9c380f06fc17cad961dda3cdcb4164c544b67204b4ae9f6a16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionKey", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionMode")
    def encryption_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionMode"))

    @encryption_mode.setter
    def encryption_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef1c6cbd3c4ffab2f16a60b8d1050e646b5f0114b0bf98e1fec7cbfdb50778f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionMode", value)

    @builtins.property
    @jsii.member(jsii_name="endIndex")
    def end_index(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "endIndex"))

    @end_index.setter
    def end_index(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b05db9801c49fd8210434ff78e10e7de0cf9512781a6eca733174fdc9b9339)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endIndex", value)

    @builtins.property
    @jsii.member(jsii_name="exceptChars")
    def except_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "exceptChars"))

    @except_chars.setter
    def except_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f3459da2fcde72f2e0233401fbe37ca61db47d00a0420efd00f1d2a0c86379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exceptChars", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02897a75d7a81edd35b3d8d13fabd67e15d8d8b382048940dc29d072f84aa59d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="forceChars")
    def force_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forceChars"))

    @force_chars.setter
    def force_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2358522442f4d941ce19addbf7174f830c34a25a4274bd521a05ac146443d240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceChars", value)

    @builtins.property
    @jsii.member(jsii_name="formatString")
    def format_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatString"))

    @format_string.setter
    def format_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40813d88565527965ece7cb4ab5ca9d84870cb047af88dbd42bc2bf26470a94e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatString", value)

    @builtins.property
    @jsii.member(jsii_name="generator")
    def generator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "generator"))

    @generator.setter
    def generator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73b91e8059105535d985f6b4c73ee976faddd0b7a7f7f12f5908bb2094e77d1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "generator", value)

    @builtins.property
    @jsii.member(jsii_name="globalSubstitution")
    def global_substitution(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "globalSubstitution"))

    @global_substitution.setter
    def global_substitution(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e319bd43c14dc875278ea8f0af2bf9169d9bdc5bb66cb2d27b009eed724a9da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "globalSubstitution", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecde1147636d6f2a932476d307227dd09599a7ba5547f7b19c36691bc2312b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithm")
    def hmac_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacAlgorithm"))

    @hmac_algorithm.setter
    def hmac_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__546ac32204cd426013b42335e77ed53a8b44abb038434519f3ec90fc46133a14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hmacKey")
    def hmac_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacKey"))

    @hmac_key.setter
    def hmac_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7125c3b9693cc99b587d1292aa3b112b79aed7ceed63437dc08a0302cb5438c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacKey", value)

    @builtins.property
    @jsii.member(jsii_name="initializationVector")
    def initialization_vector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "initializationVector"))

    @initialization_vector.setter
    def initialization_vector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__244e5cf73cb513648d269358049519431d71bc3f2b841c37e8571f14f6ee841b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "initializationVector", value)

    @builtins.property
    @jsii.member(jsii_name="ipv4Prefix")
    def ipv4_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv4Prefix"))

    @ipv4_prefix.setter
    def ipv4_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb11ee58a4705869d45a4c5390b54004c0d65e947bbde285684d3f9804f79fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv4Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipv6Prefix")
    def ipv6_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv6Prefix"))

    @ipv6_prefix.setter
    def ipv6_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a4a251a469818508a7b77de05d391bc3848d4f3c1ec8bef43337a234bf2a1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv6Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfd1f812f2f41d4c0af37867274b3e07e0b93c4c7153f2a132d885abf0bc7112)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67056c6dbecacd355a357ae20abfc030d1e06a5c4efdad8f728bac4e428ed1ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e4d05665cb272d1d9cad69fa9cf481c0590f9328561db8d4e57ad0a6ee1cc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="max")
    def max(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "max"))

    @max.setter
    def max(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e7d0e6522d9157b05b01dcfd3d2d00a83a0942bea7ef32900e27a0d41c77925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "max", value)

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumber")
    def max_random_number(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxRandomNumber"))

    @max_random_number.setter
    def max_random_number(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b02101c36e795a55db032ba1ee0f5b2bc01460f15509351e6db63f6e53e8ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="min")
    def min(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "min"))

    @min.setter
    def min(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5577f510acce19b0fa899cc8963da5f4a2f09fd391e09a4f5b1068e247663c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "min", value)

    @builtins.property
    @jsii.member(jsii_name="minRandomNumber")
    def min_random_number(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "minRandomNumber"))

    @min_random_number.setter
    def min_random_number(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c949e51f02675ee4a487780d9d8780e4e691c800bbaebe1d68103dc6f493e9ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fcee9d0c89c23f7462908bd69c1d5ebc87721d032e0bfad88b9c762b996dc1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="numberOfBytes")
    def number_of_bytes(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numberOfBytes"))

    @number_of_bytes.setter
    def number_of_bytes(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c73d71f1d36e3215cc40bf5a6d628e2259d45c839885f63ea16eacaf9d6daa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numberOfBytes", value)

    @builtins.property
    @jsii.member(jsii_name="operandOne")
    def operand_one(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operandOne"))

    @operand_one.setter
    def operand_one(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29ec0acfaad0f3ae957685b50a083649489024d7006b81ec236732e8c25d9eaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operandOne", value)

    @builtins.property
    @jsii.member(jsii_name="paramName")
    def param_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paramName"))

    @param_name.setter
    def param_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123725cde29e563e046415f40b9d7ded7a320558d40b12c7a518fa87ea3b05e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paramName", value)

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffset")
    def path_component_offset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pathComponentOffset"))

    @path_component_offset.setter
    def path_component_offset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd98d0bdcbf51f7a5cf5f9877651265282d9ee4f83f56b7caee8dfb9962664e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pathComponentOffset", value)

    @builtins.property
    @jsii.member(jsii_name="prependBytes")
    def prepend_bytes(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prependBytes"))

    @prepend_bytes.setter
    def prepend_bytes(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710955f296e99df4fbe4f20694df1fceca490236e5da73e1b77fce99f9b87410)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prependBytes", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__516d25f4a812f4258c36b9a8fa469438be59f2dc4e5676a442e1369b83032e00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63445617cdc7dcd4ded0cfb44b0e2aaaad7fa9236e137f868eecf6d6f1d5bf99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="replacement")
    def replacement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacement"))

    @replacement.setter
    def replacement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33aa0964a8c43b8519c617482de67917473f3635cd25a007dda2fc9750431645)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacement", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acbe7c39a34d43031bf57e6bd127db54ac2fb5371089d81b516cfc56d8eb7b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="separator")
    def separator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "separator"))

    @separator.setter
    def separator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f30a2dc15e11e959ff9899ed86ae14ec652f579b1359548fcd5b469fe94ce75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "separator", value)

    @builtins.property
    @jsii.member(jsii_name="setCookieName")
    def set_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "setCookieName"))

    @set_cookie_name.setter
    def set_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb11bcd5839f431f0d76a618400fecce9784c29ea1348ebc0e620731bbda206a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "setCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="startIndex")
    def start_index(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "startIndex"))

    @start_index.setter
    def start_index(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0931ee17533be2067cc34492bae8e7d6ac18dbe6ca224e2eb9be843279945490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startIndex", value)

    @builtins.property
    @jsii.member(jsii_name="subString")
    def sub_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subString"))

    @sub_string.setter
    def sub_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60fa7c85c90341b99d1675e4d0aa6b09f555a8412d43aba274f1fd92153abaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subString", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a6041b76a10ddec4ab6ec4fd2ef2db6bb599396b55e54870f522765b8aa3ec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transform")
    def transform(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transform"))

    @transform.setter
    def transform(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d16a1e751d1520ea93b93cbe5896a64bf6e4755f628a4c83e4b440350aea4dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transform", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9419b085d75c2d6554ca1827d7004f6e76f91c234b7e57bf83a8d866c5d37bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="valueSource")
    def value_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueSource"))

    @value_source.setter
    def value_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b950d84cc979604119fcbf40fe5296556e005fe00df7187a2ec615c174c1ab3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueSource", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5667650624f4f63531751ecf321a754dc5a428abc7dbc29380ac602ea71065b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValue")
    def variable_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableValue"))

    @variable_value.setter
    def variable_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6eec0d7c60cd0c7e69a97550360451e45925e856551c78d31cc183404f4324f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64f2cbcd04154840a117422e06a5eaed0532948d91e08ee1d79440984f298d9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode",
    jsii_struct_bases=[],
    name_mapping={
        "error_type": "errorType",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode:
    def __init__(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8d6794f6da9a773df91fe98e193806e02587e553e0c99b150f1f604ab2eae27)
            check_type(argname="argument error_type", value=error_type, expected_type=type_hints["error_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if error_type is not None:
            self._values["error_type"] = error_type
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def error_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        '''
        result = self._values.get("error_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6687528252b8049975f5a90a0f004e383a6de0f66963b85e2b9373c1b76d2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetErrorType")
    def reset_error_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetErrorType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="errorTypeInput")
    def error_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "errorTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="errorType")
    def error_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "errorType"))

    @error_type.setter
    def error_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff6705e626bfc2a262589a75aad523eef788b054ded022460aa43ff2b1d5854)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "errorType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__500b970ad2088210d0bc17ed58889ce830981fde89d912d2edb6912cc47e8c6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79cf28fd000d138e1774cabf786ffbd156870635a4fb0346f248fa59d3494e0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63be88dd07e87ed57c111b175c544ca983f58654b6413854e4117669baad5b8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21bc70bc2ec88c430e80d52a0839ce72493132912ff4de18fff46f792f14e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7047246b95f2801c829198f1330abbd2165098f4feee9d33e75dc0b0456782b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "nossmap": "nossmap",
        "ssmap": "ssmap",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(ssmap, dict):
            ssmap = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap(**ssmap)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab82a66683c7d2e20d8c4d2436cdce04e3bdd8e709b7378c3eb1f0a2efa4b98b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nossmap", value=nossmap, expected_type=type_hints["nossmap"])
            check_type(argname="argument ssmap", value=ssmap, expected_type=type_hints["ssmap"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if nossmap is not None:
            self._values["nossmap"] = nossmap
        if ssmap is not None:
            self._values["ssmap"] = ssmap
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nossmap(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        '''
        result = self._values.get("nossmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ssmap(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap"]:
        '''ssmap block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        '''
        result = self._values.get("ssmap")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af2258765ca111e32b512a46f992a11b00f87fa44ece9e3943959786af02535f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putSsmap")
    def put_ssmap(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap(
            china_cdn_map=china_cdn_map,
            has_mixed_hosts=has_mixed_hosts,
            name=name,
            src=src,
            srmap=srmap,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putSsmap", [value_]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNossmap")
    def reset_nossmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNossmap", []))

    @jsii.member(jsii_name="resetSsmap")
    def reset_ssmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSsmap", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="ssmap")
    def ssmap(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmapOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmapOutputReference", jsii.get(self, "ssmap"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nossmapInput")
    def nossmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nossmapInput"))

    @builtins.property
    @jsii.member(jsii_name="ssmapInput")
    def ssmap_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap"], jsii.get(self, "ssmapInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73bc63f1d5397631fd1154ce3afe63ce06ccf82aace300299213fc247fd19037)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nossmap")
    def nossmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nossmap"))

    @nossmap.setter
    def nossmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ecc2abf80e3e2e1a618a1d4bccf11da2db8974196351ba726d26b79723a3a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nossmap", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e17d4fe51a93165e2ce987f205b8838d2306993eef8dd82670cc6484ddc127)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba90c8420059cad98338ebb5befdd79c14bce4753c18a7bbcc51f2f76b80250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37eaae85838bef46538601efa2a5ea83f87face1d70d57f47f979a922573246)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap",
    jsii_struct_bases=[],
    name_mapping={
        "china_cdn_map": "chinaCdnMap",
        "has_mixed_hosts": "hasMixedHosts",
        "name": "name",
        "src": "src",
        "srmap": "srmap",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap:
    def __init__(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6cb239b855d501a929de9c0eceb246e6c9b24bec33b72d19e0f7724cf60cbf)
            check_type(argname="argument china_cdn_map", value=china_cdn_map, expected_type=type_hints["china_cdn_map"])
            check_type(argname="argument has_mixed_hosts", value=has_mixed_hosts, expected_type=type_hints["has_mixed_hosts"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument src", value=src, expected_type=type_hints["src"])
            check_type(argname="argument srmap", value=srmap, expected_type=type_hints["srmap"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if china_cdn_map is not None:
            self._values["china_cdn_map"] = china_cdn_map
        if has_mixed_hosts is not None:
            self._values["has_mixed_hosts"] = has_mixed_hosts
        if name is not None:
            self._values["name"] = name
        if src is not None:
            self._values["src"] = src
        if srmap is not None:
            self._values["srmap"] = srmap
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def china_cdn_map(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.'''
        result = self._values.get("china_cdn_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def has_mixed_hosts(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.'''
        result = self._values.get("has_mixed_hosts")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def src(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.'''
        result = self._values.get("src")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def srmap(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.'''
        result = self._values.get("srmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8a847f585b500c7ee714186d6442d7581f34ef5d28199921624c656557e904a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetChinaCdnMap")
    def reset_china_cdn_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnMap", []))

    @jsii.member(jsii_name="resetHasMixedHosts")
    def reset_has_mixed_hosts(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHasMixedHosts", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetSrc")
    def reset_src(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrc", []))

    @jsii.member(jsii_name="resetSrmap")
    def reset_srmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrmap", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMapInput")
    def china_cdn_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chinaCdnMapInput"))

    @builtins.property
    @jsii.member(jsii_name="hasMixedHostsInput")
    def has_mixed_hosts_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hasMixedHostsInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="srcInput")
    def src_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srcInput"))

    @builtins.property
    @jsii.member(jsii_name="srmapInput")
    def srmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srmapInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMap")
    def china_cdn_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chinaCdnMap"))

    @china_cdn_map.setter
    def china_cdn_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71d00e3410522a50dac851943543f196821d09f173913d1a534fe81220e21a64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chinaCdnMap", value)

    @builtins.property
    @jsii.member(jsii_name="hasMixedHosts")
    def has_mixed_hosts(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hasMixedHosts"))

    @has_mixed_hosts.setter
    def has_mixed_hosts(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fc01d0feefe6837a8c661d9468ac001d6a30849cc626672b928b2d9fb7dbf85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hasMixedHosts", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66361f40004a262346d02584903d66308732c83c43468a06f9b2608435ee79c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="src")
    def src(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "src"))

    @src.setter
    def src(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__509797a1bac90e33632af9cfe1a580ed2f969b672fe235ce514ca44442c5ac80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "src", value)

    @builtins.property
    @jsii.member(jsii_name="srmap")
    def srmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srmap"))

    @srmap.setter
    def srmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c6154fadd2cf3831286ca053e0177205b35b701a2a8b70dbe561c274918a96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srmap", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55114b40d86c773288c6bbacb96a9b06203bc6b267461007d38f42c6c3548782)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dda4378ab0f3228a192a6703c823026ea3871ec30277b1c022dbdf2e63d0ee22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration",
    jsii_struct_bases=[],
    name_mapping={
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_https_upgrade": "allowHttpsUpgrade",
        "cache_sharing_duration": "cacheSharingDuration",
        "cache_sharing_start_time": "cacheSharingStartTime",
        "enabled": "enabled",
        "is_certificate_sni_only": "isCertificateSniOnly",
        "is_tiered_distribution_used": "isTieredDistributionUsed",
        "locked": "locked",
        "migration_duration": "migrationDuration",
        "migration_from": "migrationFrom",
        "migration_start_time": "migrationStartTime",
        "td_location": "tdLocation",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration:
    def __init__(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f185586c39551f3a9050bcdbc9adb673a4d5fb91503eb261b28de6ef157f8ccb)
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_https_upgrade", value=allow_https_upgrade, expected_type=type_hints["allow_https_upgrade"])
            check_type(argname="argument cache_sharing_duration", value=cache_sharing_duration, expected_type=type_hints["cache_sharing_duration"])
            check_type(argname="argument cache_sharing_start_time", value=cache_sharing_start_time, expected_type=type_hints["cache_sharing_start_time"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_certificate_sni_only", value=is_certificate_sni_only, expected_type=type_hints["is_certificate_sni_only"])
            check_type(argname="argument is_tiered_distribution_used", value=is_tiered_distribution_used, expected_type=type_hints["is_tiered_distribution_used"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument migration_duration", value=migration_duration, expected_type=type_hints["migration_duration"])
            check_type(argname="argument migration_from", value=migration_from, expected_type=type_hints["migration_from"])
            check_type(argname="argument migration_start_time", value=migration_start_time, expected_type=type_hints["migration_start_time"])
            check_type(argname="argument td_location", value=td_location, expected_type=type_hints["td_location"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_https_upgrade is not None:
            self._values["allow_https_upgrade"] = allow_https_upgrade
        if cache_sharing_duration is not None:
            self._values["cache_sharing_duration"] = cache_sharing_duration
        if cache_sharing_start_time is not None:
            self._values["cache_sharing_start_time"] = cache_sharing_start_time
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_certificate_sni_only is not None:
            self._values["is_certificate_sni_only"] = is_certificate_sni_only
        if is_tiered_distribution_used is not None:
            self._values["is_tiered_distribution_used"] = is_tiered_distribution_used
        if locked is not None:
            self._values["locked"] = locked
        if migration_duration is not None:
            self._values["migration_duration"] = migration_duration
        if migration_from is not None:
            self._values["migration_from"] = migration_from
        if migration_start_time is not None:
            self._values["migration_start_time"] = migration_start_time
        if td_location is not None:
            self._values["td_location"] = td_location
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allow temporary downgrade of HTTPS traffic to HTTP.

        This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_https_upgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows temporary upgrade of HTTP traffic to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        '''
        result = self._values.get("allow_https_upgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_sharing_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number cache sharing days.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        '''
        result = self._values.get("cache_sharing_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cache_sharing_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start cache sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        '''
        result = self._values.get("cache_sharing_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows migration to Standard TLS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_sni_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether your new certificate is SNI-only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        '''
        result = self._values.get("is_certificate_sni_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_tiered_distribution_used(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to align traffic to various ``tieredDistribution`` areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        '''
        result = self._values.get("is_tiered_distribution_used")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of days to migrate the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        '''
        result = self._values.get("migration_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def migration_from(self) -> typing.Optional[builtins.str]:
        '''What kind of traffic you're migrating from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        '''
        result = self._values.get("migration_from")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        '''
        result = self._values.get("migration_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def td_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``tieredDistribution`` location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        '''
        result = self._values.get("td_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eb005b6e82cf3758add61f27ecdbd535192cff22e89ad66dbfff3fc34ceef8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowHttpsUpgrade")
    def reset_allow_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsUpgrade", []))

    @jsii.member(jsii_name="resetCacheSharingDuration")
    def reset_cache_sharing_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingDuration", []))

    @jsii.member(jsii_name="resetCacheSharingStartTime")
    def reset_cache_sharing_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingStartTime", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsCertificateSniOnly")
    def reset_is_certificate_sni_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateSniOnly", []))

    @jsii.member(jsii_name="resetIsTieredDistributionUsed")
    def reset_is_tiered_distribution_used(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsTieredDistributionUsed", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMigrationDuration")
    def reset_migration_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationDuration", []))

    @jsii.member(jsii_name="resetMigrationFrom")
    def reset_migration_from(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationFrom", []))

    @jsii.member(jsii_name="resetMigrationStartTime")
    def reset_migration_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartTime", []))

    @jsii.member(jsii_name="resetTdLocation")
    def reset_td_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTdLocation", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgradeInput")
    def allow_https_upgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDurationInput")
    def cache_sharing_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cacheSharingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTimeInput")
    def cache_sharing_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheSharingStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnlyInput")
    def is_certificate_sni_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificateSniOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsedInput")
    def is_tiered_distribution_used_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isTieredDistributionUsedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationDurationInput")
    def migration_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "migrationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationFromInput")
    def migration_from_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationFromInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartTimeInput")
    def migration_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="tdLocationInput")
    def td_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tdLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsDowngrade"))

    @allow_https_downgrade.setter
    def allow_https_downgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c1af43a288a93376d61333a37b492a844d8aec7b9c8564fb1f307238f2efbb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsDowngrade", value)

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgrade")
    def allow_https_upgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsUpgrade"))

    @allow_https_upgrade.setter
    def allow_https_upgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__480138b065ea02edb8a4715f74dc1dc4e4d5c5220bd17325fa183824b5c61cdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsUpgrade", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDuration")
    def cache_sharing_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cacheSharingDuration"))

    @cache_sharing_duration.setter
    def cache_sharing_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9c520726ca7f48cc31ffeefb613b614b6095931cbda08d87b225688d08f2fb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTime")
    def cache_sharing_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheSharingStartTime"))

    @cache_sharing_start_time.setter
    def cache_sharing_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86c26de49d74f3aa33f4a2a42fb09f898ae07cab596c9ce1f9d0e67918711ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__478a70902154404f227c8e8b77c163d601c78f408c42f00329f679523ec5cc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnly")
    def is_certificate_sni_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificateSniOnly"))

    @is_certificate_sni_only.setter
    def is_certificate_sni_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__071d04ae549479fc9011f57cd09f0ddbdd9a6cf011426597d2d9350d4f985f0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateSniOnly", value)

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsed")
    def is_tiered_distribution_used(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isTieredDistributionUsed"))

    @is_tiered_distribution_used.setter
    def is_tiered_distribution_used(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197f52939bfe9f557af3ae93c370a391344cb8f4b5c5a59080c6075cebe68db9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isTieredDistributionUsed", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036e5b91a151d3e1af51b03e32e54be5ef2acd936c600a976c0596d35adde114)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="migrationDuration")
    def migration_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "migrationDuration"))

    @migration_duration.setter
    def migration_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f4524282ade998fcc0e9f02b575b08f43fb7ba220d0a5cdfadebc596a79d2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="migrationFrom")
    def migration_from(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationFrom"))

    @migration_from.setter
    def migration_from(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f72022b497d66447125d6d130efbd52d779edb02f78396307616428d4e767ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationFrom", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartTime")
    def migration_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartTime"))

    @migration_start_time.setter
    def migration_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91ac214679b37aaa2c2208db0f7449b25d95caa3122ec0f73697afd75221f067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="tdLocation")
    def td_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tdLocation"))

    @td_location.setter
    def td_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16daa9cf26e5e8e9dd1aa3a1749c9b55e729848232b031173ac4d43cf7c0d8e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tdLocation", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__464acde94188cb17a8e5ad4b265dbc7081b17567935cab5be6718683810ff098)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80380653eec673b949722d7c709bd0d4b0a79af02b7690bde2d9771709ed1d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352cbdbba965220a8df7b75dcb6e0d57d3ec681e5790bf9adaf76625d8d10f68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "info": "info",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride:
    def __init__(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce51bda3d26d99c71337be8677cfa9a7823c2b6c50d03d3e072814ee71099f70)
            check_type(argname="argument info", value=info, expected_type=type_hints["info"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if info is not None:
            self._values["info"] = info
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def info(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        '''
        result = self._values.get("info")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3872499fcf249f51e6cc42f853b5707d14096330e7046ee4ad29876bc0fccd7d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetInfo")
    def reset_info(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInfo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="infoInput")
    def info_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "infoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="info")
    def info(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "info"))

    @info.setter
    def info(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edf91654c27e1071b1fb0544d5c83d5116940f603a6daf85985b69db52c86220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "info", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37c37e297a981744a639f271518a00828af1e5bfda0b06a6acad4824a9a30f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079400b0d44d3ca4d22e8a98d72c07a11610c90fc11fe2db548c84e78c3837e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1abad9119689eb6783c25241d71d4c44534c86f4ecef3e0e86426784981e0fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a6f102d923dcf1f7a76d4adc6cc6f43ffa279038f2eaa132ba0d83e15300945)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "strict_mode": "strictMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "valid_mode": "validMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92bbd636d86cacf23e7a05d5c729a41a75d3b59a14623a35ede7e954b10e07f3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict_mode", value=strict_mode, expected_type=type_hints["strict_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument valid_mode", value=valid_mode, expected_type=type_hints["valid_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if strict_mode is not None:
            self._values["strict_mode"] = strict_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if valid_mode is not None:
            self._values["valid_mode"] = valid_mode

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF.

        When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        '''
        result = self._values.get("strict_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def valid_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines.

        When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        result = self._values.get("valid_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85eff117de2d6d65a1129c1184d0332c671149d41c2d489fab2294f0ca9ff28b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrictMode")
    def reset_strict_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValidMode")
    def reset_valid_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidMode", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictModeInput")
    def strict_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="validModeInput")
    def valid_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "validModeInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee789461cb93ee82d970b3528e08ccaa640c687725ce42add4cfd8d565122dc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strictMode")
    def strict_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strictMode"))

    @strict_mode.setter
    def strict_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__417cc1873685301028645becb7ad4694a102149a5cae7b71d32a5a4438cae38a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strictMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45436ef0143077654997a29d6f072081c03e90668d3adc6c694178829cf54b47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b4755cc5a015d976bf6d0fcd6085426c45d3cbe1402eb207e23c6e7cb73eb79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="validMode")
    def valid_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "validMode"))

    @valid_mode.setter
    def valid_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6931fe030115e2dcd6dc6b354406a75bbaf89259cbdb1f9e5695ee1f0cc3b996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddeba2b41950a24cd8ed52e45830fbac659e4a4a77fa8760953e2544be46f46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer",
    jsii_struct_bases=[],
    name_mapping={
        "access_control": "accessControl",
        "cache_key": "cacheKey",
        "caching": "caching",
        "content_compressor": "contentCompressor",
        "dynamic_web_content": "dynamicWebContent",
        "enabled": "enabled",
        "geo_location": "geoLocation",
        "ip": "ip",
        "large_file_delivery": "largeFileDelivery",
        "live_video_delivery": "liveVideoDelivery",
        "locked": "locked",
        "modify_path": "modifyPath",
        "on_demand_video_delivery": "onDemandVideoDelivery",
        "origin": "origin",
        "partner_domain_suffix": "partnerDomainSuffix",
        "referrer": "referrer",
        "refresh_content": "refreshContent",
        "site_failover": "siteFailover",
        "template_uuid": "templateUuid",
        "token_authorization": "tokenAuthorization",
        "uuid": "uuid",
        "web_application_firewall": "webApplicationFirewall",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer:
    def __init__(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024681286cda2662c2c6ffb6ed0f853dbddb8b5801ff87c2f7f92ce3b7773ee7)
            check_type(argname="argument access_control", value=access_control, expected_type=type_hints["access_control"])
            check_type(argname="argument cache_key", value=cache_key, expected_type=type_hints["cache_key"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument content_compressor", value=content_compressor, expected_type=type_hints["content_compressor"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument geo_location", value=geo_location, expected_type=type_hints["geo_location"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument large_file_delivery", value=large_file_delivery, expected_type=type_hints["large_file_delivery"])
            check_type(argname="argument live_video_delivery", value=live_video_delivery, expected_type=type_hints["live_video_delivery"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_path", value=modify_path, expected_type=type_hints["modify_path"])
            check_type(argname="argument on_demand_video_delivery", value=on_demand_video_delivery, expected_type=type_hints["on_demand_video_delivery"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument partner_domain_suffix", value=partner_domain_suffix, expected_type=type_hints["partner_domain_suffix"])
            check_type(argname="argument referrer", value=referrer, expected_type=type_hints["referrer"])
            check_type(argname="argument refresh_content", value=refresh_content, expected_type=type_hints["refresh_content"])
            check_type(argname="argument site_failover", value=site_failover, expected_type=type_hints["site_failover"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_control is not None:
            self._values["access_control"] = access_control
        if cache_key is not None:
            self._values["cache_key"] = cache_key
        if caching is not None:
            self._values["caching"] = caching
        if content_compressor is not None:
            self._values["content_compressor"] = content_compressor
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if geo_location is not None:
            self._values["geo_location"] = geo_location
        if ip is not None:
            self._values["ip"] = ip
        if large_file_delivery is not None:
            self._values["large_file_delivery"] = large_file_delivery
        if live_video_delivery is not None:
            self._values["live_video_delivery"] = live_video_delivery
        if locked is not None:
            self._values["locked"] = locked
        if modify_path is not None:
            self._values["modify_path"] = modify_path
        if on_demand_video_delivery is not None:
            self._values["on_demand_video_delivery"] = on_demand_video_delivery
        if origin is not None:
            self._values["origin"] = origin
        if partner_domain_suffix is not None:
            self._values["partner_domain_suffix"] = partner_domain_suffix
        if referrer is not None:
            self._values["referrer"] = referrer
        if refresh_content is not None:
            self._values["refresh_content"] = refresh_content
        if site_failover is not None:
            self._values["site_failover"] = site_failover
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if uuid is not None:
            self._values["uuid"] = uuid
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall

    @builtins.property
    def access_control(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        '''
        result = self._values.get("access_control")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set which query parameters are included in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        '''
        result = self._values.get("cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies content caching rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_compressor(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows compression of subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        '''
        result = self._values.get("content_compressor")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Cloud Embed to dynamically modify your subcustomers' content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_location(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' location-based whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        '''
        result = self._values.get("geo_location")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' IP whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def large_file_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables large file delivery for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        '''
        result = self._values.get("large_file_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def live_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.'''
        result = self._values.get("live_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies a subcustomer's request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        '''
        result = self._values.get("modify_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def on_demand_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables delivery of media assets to subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        '''
        result = self._values.get("on_demand_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign origin hostnames for customers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner_domain_suffix(self) -> typing.Optional[builtins.str]:
        '''This specifies the appropriate domain suffix, which you should typically match with your property hostname.

        It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        '''
        result = self._values.get("partner_domain_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' referrer whitelists or blacklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        '''
        result = self._values.get("referrer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to reschedule when content validates for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        '''
        result = self._values.get("refresh_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def site_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure unique failover sites for each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        '''
        result = self._values.get("site_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content.

        Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic.

        Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd253432dda4097fb503179245b85aed3e7b3b447c8f0351b536a0236acb1571)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessControl")
    def reset_access_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessControl", []))

    @jsii.member(jsii_name="resetCacheKey")
    def reset_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKey", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetContentCompressor")
    def reset_content_compressor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCompressor", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGeoLocation")
    def reset_geo_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoLocation", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLargeFileDelivery")
    def reset_large_file_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileDelivery", []))

    @jsii.member(jsii_name="resetLiveVideoDelivery")
    def reset_live_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveVideoDelivery", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyPath")
    def reset_modify_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyPath", []))

    @jsii.member(jsii_name="resetOnDemandVideoDelivery")
    def reset_on_demand_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOnDemandVideoDelivery", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetPartnerDomainSuffix")
    def reset_partner_domain_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartnerDomainSuffix", []))

    @jsii.member(jsii_name="resetReferrer")
    def reset_referrer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrer", []))

    @jsii.member(jsii_name="resetRefreshContent")
    def reset_refresh_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshContent", []))

    @jsii.member(jsii_name="resetSiteFailover")
    def reset_site_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteFailover", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @builtins.property
    @jsii.member(jsii_name="accessControlInput")
    def access_control_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessControlInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyInput")
    def cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCompressorInput")
    def content_compressor_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCompressorInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="geoLocationInput")
    def geo_location_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "geoLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileDeliveryInput")
    def large_file_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "largeFileDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="liveVideoDeliveryInput")
    def live_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "liveVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyPathInput")
    def modify_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyPathInput"))

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDeliveryInput")
    def on_demand_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "onDemandVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffixInput")
    def partner_domain_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerDomainSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerInput")
    def referrer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "referrerInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshContentInput")
    def refresh_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "refreshContentInput"))

    @builtins.property
    @jsii.member(jsii_name="siteFailoverInput")
    def site_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "siteFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="accessControl")
    def access_control(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessControl"))

    @access_control.setter
    def access_control(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fead867a2cb14ebe246b9c8c0b46ff11be827c4bf93239e766bf5042e0f32dec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessControl", value)

    @builtins.property
    @jsii.member(jsii_name="cacheKey")
    def cache_key(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheKey"))

    @cache_key.setter
    def cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4567c3621ba6a6936310213469d76d6e7f49b28b980dba5948f4023e68b9911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caching"))

    @caching.setter
    def caching(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fb8153862e5bf736a7232d288e632d40733ce012154a032e89a62759304e93f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caching", value)

    @builtins.property
    @jsii.member(jsii_name="contentCompressor")
    def content_compressor(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCompressor"))

    @content_compressor.setter
    def content_compressor(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4d2d635513992fc0b1cd629a93b6e4ff65612d3c5c4c6c6d18cceb5c9a7585)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCompressor", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicWebContent"))

    @dynamic_web_content.setter
    def dynamic_web_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ba05a2ea9986d4d28c8cee3b5d8dc66ebe4f47428b5ec7de6eb4a8ecdea19ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicWebContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f06ba1c09da9e7ec8ea3a4bb0bc3824f3c8ccdd479a7d222b8b9ad717dfb4ef8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="geoLocation")
    def geo_location(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "geoLocation"))

    @geo_location.setter
    def geo_location(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3e8163484359d2bc0ae284a7172db5bf45ba17724bb8f876b8d101c11ec974)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoLocation", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c5a67fc50bb466da92dbb57dde07b14de08cc2f1a0052c623bff8f06f11b719)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="largeFileDelivery")
    def large_file_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "largeFileDelivery"))

    @large_file_delivery.setter
    def large_file_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485e2567c27c794e560bb44a3f1ac3508cc7cbfa25d85dae32f348fe4b2c11de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "largeFileDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="liveVideoDelivery")
    def live_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "liveVideoDelivery"))

    @live_video_delivery.setter
    def live_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a534697bbec949eb7387c5d3928ec7ac9e6a21a9c389d71c8929edb3bc3d228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828bc9353f79f74b55f5138037c3e624c9d560e9a8b0a464c1dc9335eaac04d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyPath")
    def modify_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyPath"))

    @modify_path.setter
    def modify_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__352121de04e4abe6e2fe1d1347ce97f57745cc8aa1a730f1d74a720edd77f0d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyPath", value)

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDelivery")
    def on_demand_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "onDemandVideoDelivery"))

    @on_demand_video_delivery.setter
    def on_demand_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d687134a8f2a46d60b5ef3161252c22cfd357695e0e13de5c9d0c0b581258b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "onDemandVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "origin"))

    @origin.setter
    def origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5474dcdafa3b3900969997054906ad868ec812efc1ec488ef546ed51b2ba1747)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origin", value)

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffix")
    def partner_domain_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partnerDomainSuffix"))

    @partner_domain_suffix.setter
    def partner_domain_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7235003bdac4d0b91d6528a141c2344db350dba8c8a234f3bf156c985a0525f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partnerDomainSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="referrer")
    def referrer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "referrer"))

    @referrer.setter
    def referrer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54c4517d3461f4396d335794e8f40b199062ae459424a5acf0b053e42c79b0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrer", value)

    @builtins.property
    @jsii.member(jsii_name="refreshContent")
    def refresh_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "refreshContent"))

    @refresh_content.setter
    def refresh_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3560c251fba946f1687dbf2f48609c2801736a6a292fc0ba5b44d55303921028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshContent", value)

    @builtins.property
    @jsii.member(jsii_name="siteFailover")
    def site_failover(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "siteFailover"))

    @site_failover.setter
    def site_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbb74e53ba15e9f8a386bd799ce9aa719c165e70fd781b1ae19efea020a5a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "siteFailover", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dea13e4bc41513c9ca84c89e5ab40a3f2ec3412a58611fee5e5712b3096d608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenAuthorization"))

    @token_authorization.setter
    def token_authorization(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c62cd9d29a4f0be84c8748d5c425198311cb36b71f83ced744c1d55b97c88df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthorization", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a422cfd433a7a1b358c34c7f5e849164bf631eeb5eacfd0414c56ddc81dcef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "webApplicationFirewall"))

    @web_application_firewall.setter
    def web_application_firewall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccc3be53e2e6dce9b724b936f391d7afbd725a840f73a741bd2808808f885490)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "webApplicationFirewall", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475318e2149652e96c051f9ce938dd6eb7c9da03a4677858092a428ea39ad6ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute",
    jsii_struct_bases=[],
    name_mapping={
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "custom_map": "customMap",
        "custom_stat_key": "customStatKey",
        "enable_custom_key": "enableCustomKey",
        "enabled": "enabled",
        "force_ssl_forward": "forceSslForward",
        "locked": "locked",
        "race_stat_ttl": "raceStatTtl",
        "sr_download_link_title": "srDownloadLinkTitle",
        "template_uuid": "templateUuid",
        "test_object_url": "testObjectUrl",
        "to_host": "toHost",
        "to_host_status": "toHostStatus",
        "type": "type",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute:
    def __init__(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ade1e3a7527f0de48aba8509a74bed1b7f0cb9f086fa902645d77e9772a01e94)
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument custom_map", value=custom_map, expected_type=type_hints["custom_map"])
            check_type(argname="argument custom_stat_key", value=custom_stat_key, expected_type=type_hints["custom_stat_key"])
            check_type(argname="argument enable_custom_key", value=enable_custom_key, expected_type=type_hints["enable_custom_key"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_ssl_forward", value=force_ssl_forward, expected_type=type_hints["force_ssl_forward"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument race_stat_ttl", value=race_stat_ttl, expected_type=type_hints["race_stat_ttl"])
            check_type(argname="argument sr_download_link_title", value=sr_download_link_title, expected_type=type_hints["sr_download_link_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument test_object_url", value=test_object_url, expected_type=type_hints["test_object_url"])
            check_type(argname="argument to_host", value=to_host, expected_type=type_hints["to_host"])
            check_type(argname="argument to_host_status", value=to_host_status, expected_type=type_hints["to_host_status"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if custom_map is not None:
            self._values["custom_map"] = custom_map
        if custom_stat_key is not None:
            self._values["custom_stat_key"] = custom_stat_key
        if enable_custom_key is not None:
            self._values["enable_custom_key"] = enable_custom_key
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_ssl_forward is not None:
            self._values["force_ssl_forward"] = force_ssl_forward
        if locked is not None:
            self._values["locked"] = locked
        if race_stat_ttl is not None:
            self._values["race_stat_ttl"] = race_stat_ttl
        if sr_download_link_title is not None:
            self._values["sr_download_link_title"] = sr_download_link_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if test_object_url is not None:
            self._values["test_object_url"] = test_object_url
        if to_host is not None:
            self._values["to_host"] = to_host
        if to_host_status is not None:
            self._values["to_host_status"] = to_host_status
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map(self) -> typing.Optional[builtins.str]:
        '''If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        '''
        result = self._values.get("custom_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_stat_key(self) -> typing.Optional[builtins.str]:
        '''This specifies a hostname under which to cache race results.

        This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        '''
        result = self._values.get("custom_stat_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_custom_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        '''
        result = self._values.get("enable_custom_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the SureRoute behavior, to optimize delivery of non-cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_ssl_forward(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        '''
        result = self._values.get("force_ssl_forward")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def race_stat_ttl(self) -> typing.Optional[builtins.str]:
        '''Specifies the time-to-live to preserve SureRoute race results, typically ``30m``.

        If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        '''
        result = self._values.get("race_stat_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sr_download_link_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        '''
        result = self._values.get("sr_download_link_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def test_object_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the path and filename for your origin's test object to use in races to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        '''
        result = self._values.get("test_object_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host(self) -> typing.Optional[builtins.str]:
        '''If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        '''
        result = self._values.get("to_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host_status(self) -> typing.Optional[builtins.str]:
        '''Specifies which hostname to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        '''
        result = self._values.get("to_host_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of edge servers used to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRouteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRouteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abbeb965fcbc62faae85211f9f1a2ad06bfc4a9d644a123e5ad164f6043e0c56)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCustomMap")
    def reset_custom_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMap", []))

    @jsii.member(jsii_name="resetCustomStatKey")
    def reset_custom_stat_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatKey", []))

    @jsii.member(jsii_name="resetEnableCustomKey")
    def reset_enable_custom_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCustomKey", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceSslForward")
    def reset_force_ssl_forward(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceSslForward", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRaceStatTtl")
    def reset_race_stat_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRaceStatTtl", []))

    @jsii.member(jsii_name="resetSrDownloadLinkTitle")
    def reset_sr_download_link_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrDownloadLinkTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTestObjectUrl")
    def reset_test_object_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTestObjectUrl", []))

    @jsii.member(jsii_name="resetToHost")
    def reset_to_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHost", []))

    @jsii.member(jsii_name="resetToHostStatus")
    def reset_to_host_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHostStatus", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapInput")
    def custom_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatKeyInput")
    def custom_stat_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCustomKeyInput")
    def enable_custom_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCustomKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceSslForwardInput")
    def force_ssl_forward_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceSslForwardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="raceStatTtlInput")
    def race_stat_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "raceStatTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitleInput")
    def sr_download_link_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srDownloadLinkTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="testObjectUrlInput")
    def test_object_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "testObjectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostInput")
    def to_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostStatusInput")
    def to_host_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98fbc2d605ac28917a845fefd438007701b7ae060ab47c5c9caffb5e1d7556dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="customMap")
    def custom_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMap"))

    @custom_map.setter
    def custom_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__757d8c4c815854122df17fe61550a39ce7518b481fa68c61358c2cbab35a5057)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMap", value)

    @builtins.property
    @jsii.member(jsii_name="customStatKey")
    def custom_stat_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatKey"))

    @custom_stat_key.setter
    def custom_stat_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0445f818dba498608e5fc1e978f450fc8a3b69e6e9592e319006cec38341761a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatKey", value)

    @builtins.property
    @jsii.member(jsii_name="enableCustomKey")
    def enable_custom_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCustomKey"))

    @enable_custom_key.setter
    def enable_custom_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f9a70d418907737092dd990bd4a26873a5e75d0d8f8d8e82590fc3fd341b578)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCustomKey", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6dbcf763470a4af9e5950ecf9a5e7f8e6a1d5528bc3474f2fe18f5c42d458af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceSslForward")
    def force_ssl_forward(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceSslForward"))

    @force_ssl_forward.setter
    def force_ssl_forward(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a413be2004dc9d21503095f09c0112cbb85ff69b92ca26111116505869178f36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceSslForward", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ced0023ab1c835659ad1cbed0fea62e814a9200dfc2e79c0080b9e1bf0d308c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="raceStatTtl")
    def race_stat_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "raceStatTtl"))

    @race_stat_ttl.setter
    def race_stat_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3977aad82d406aa4a0274f283ef74b280218727392e416f99ac9b75e2122d4bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "raceStatTtl", value)

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitle")
    def sr_download_link_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srDownloadLinkTitle"))

    @sr_download_link_title.setter
    def sr_download_link_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fd9f59f4ea0640c24f035562796e22d5d2024a11ab283ab9270b1232039782f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srDownloadLinkTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__444647e292143cb6e90a99c850d5c7264be990fa44b878406a1c8a737844e374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="testObjectUrl")
    def test_object_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "testObjectUrl"))

    @test_object_url.setter
    def test_object_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604851990b106b0ce5fb16534e027434f62f75cfa6fcdfaae1555edcaa7c2183)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "testObjectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="toHost")
    def to_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHost"))

    @to_host.setter
    def to_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3672a7f33e2fa6e6517965c1212ec09789f4b49b45658df90ac9db427de8109e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHost", value)

    @builtins.property
    @jsii.member(jsii_name="toHostStatus")
    def to_host_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHostStatus"))

    @to_host_status.setter
    def to_host_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a986f4cd7f421263f917548d8a8a3937caea3edabef64904797aaee39101c2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHostStatus", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__458912aea8c602165ae4d7c2b4d5f6e8179b02efbc26aa1cd8a897a482f6f8e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d515b3a3380ffde453570ed3e91f365bff39b34c86f0cded39379982041f611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5370367f04a529d6cdfdd87710bb6b2ab5bb4698eb16177db6aed7109d7ff9f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f144b8a820491bda7acbf53ae19256d251174a4c0ad276d2c850026712b25972)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d58a5b4d5ea02a7454c680112015ff7a12e6a1556b694ec78b8d79f57a49ce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b1ff4e1ec5ac759d4d300ece4a322a4ad49720405cc2f96353a0c6da8ba48a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8957215cdd5f25e6f7364fd714ecac4e192f2c280e6acecf70cf6a61b685ed53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3935a2f51d290532ab2ebb4e9c70cd6dbf7ad3bb6fab8182e257e57c7b37a620)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67fa88c608b8da2d984ff09ff431df48da52a8afd417e0accacd25fc7e184b12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dd9429f6a80eae4ddf6f99ceef534629ea7eda16537d54ed8c3ce166f2918d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "ibm_customer_id": "ibmCustomerId",
        "limit_to_dynamic": "limitToDynamic",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a4cf81df081f2cb0f7b3c111af2d0143288fe78418e5d49c18fed0e5339af15)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument ibm_customer_id", value=ibm_customer_id, expected_type=type_hints["ibm_customer_id"])
            check_type(argname="argument limit_to_dynamic", value=limit_to_dynamic, expected_type=type_hints["limit_to_dynamic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if ibm_customer_id is not None:
            self._values["ibm_customer_id"] = ibm_customer_id
        if limit_to_dynamic is not None:
            self._values["limit_to_dynamic"] = limit_to_dynamic
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ibm_customer_id(self) -> typing.Optional[jsii.Number]:
        '''The integer identifier for the IBM Tealeaf Connector account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        '''
        result = self._values.get("ibm_customer_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_to_dynamic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Limit traffic to dynamic, uncached (``No-Store``) content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        '''
        result = self._values.get("limit_to_dynamic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeafOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeafOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f186ef88916503eee48b1d5cbd7e30eb634a04553878f77acf89d84db3ad0c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIbmCustomerId")
    def reset_ibm_customer_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIbmCustomerId", []))

    @jsii.member(jsii_name="resetLimitToDynamic")
    def reset_limit_to_dynamic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitToDynamic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerIdInput")
    def ibm_customer_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ibmCustomerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="limitToDynamicInput")
    def limit_to_dynamic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "limitToDynamicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea02d52e67d5e090530588693e2a546c738da25fafbc87cd9c3c220768167a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerId")
    def ibm_customer_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ibmCustomerId"))

    @ibm_customer_id.setter
    def ibm_customer_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef971903cf1c47259c2aadeb4a79c608d19751f5e4e89c55fc4d0ae86a701a8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ibmCustomerId", value)

    @builtins.property
    @jsii.member(jsii_name="limitToDynamic")
    def limit_to_dynamic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "limitToDynamic"))

    @limit_to_dynamic.setter
    def limit_to_dynamic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054c34fb48cb7ce086b9f30e77b3fdd6b80abb2de3a1e0057045a5130e8728ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitToDynamic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67bbd5d2f6747852258a7652c87ce2b4a319e34a17cb85d607b660913cb80559)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4826aa5ce519e8fb478edd8389ba83eaa6bf136d4e98e7c2aa0118dadb9bf287)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613ec5b5fb11b044dfbcb6118458376330f841b9328e164f7cf3d6edc46fb5c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566378c3cc58982c8ee70267412095ce7c8e2f9ae3bce04d4fe9dca9ff8a76d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79074f83ceecfd1da7f3d494b77d5715ac31b944fca554eefa15b79052e11eba)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin.

        A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "allowall": "allowall",
        "enabled": "enabled",
        "locked": "locked",
        "method": "method",
        "policy": "policy",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced:
    def __init__(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b523919918ba7077bea608bb7fdfa3790e9948f6bd05341e36c72540fee03951)
            check_type(argname="argument allowall", value=allowall, expected_type=type_hints["allowall"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument method", value=method, expected_type=type_hints["method"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowall is not None:
            self._values["allowall"] = allowall
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if method is not None:
            self._values["method"] = method
        if policy is not None:
            self._values["policy"] = policy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allowall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.'''
        result = self._values.get("allowall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def method(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.'''
        result = self._values.get("method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.'''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe;

        ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__114b3e2a10a7d7018a52eea89ead2f5d884a843601be7fa5a5a75bd620c7c100)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowall")
    def reset_allowall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowall", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethod")
    def reset_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethod", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowallInput")
    def allowall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowallInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodInput")
    def method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "methodInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowall")
    def allowall(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowall"))

    @allowall.setter
    def allowall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef4361463fe961e411c20111ab451698202dad85aec6eef15781269f06081915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowall", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1ee98cdfda8d6b3ab94d1d19425c0d1a4235edc04edcd72c532e3d581ba861)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddcaa123ce4d08754a8253fcc7785fa9fe3d458cd8d579fc3b5fb1667f61a4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="method")
    def method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "method"))

    @method.setter
    def method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f58eb10a3aff01b39635c5d5e728d265f346e722499940dc4ab204aa99a8430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "method", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd64efa761c4a10fff310b892449e3888d79083e113a816e232d463ba99d264b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__709e4fdf2f4c36b545d015990b61d03682e7ff82c69de3287a780b70d1a163e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3befdccfb127cf7ed192d2e3a6fd077c989d8e46b3d20abf050dce163bb395c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68eab8a3cc6fa6263090aaacd277ee346f374ec892830dd216143e004de6f18e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6f460a80b1c453ce98ef94b712a58dca22345bbe114592f932d81d4e003d322)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization",
    jsii_struct_bases=[],
    name_mapping={
        "cloudwrapper_map_migration_title": "cloudwrapperMapMigrationTitle",
        "custom_map_enabled": "customMapEnabled",
        "custom_map_name": "customMapName",
        "hash_algorithm": "hashAlgorithm",
        "location": "location",
        "locked": "locked",
        "map_migration_enabled": "mapMigrationEnabled",
        "migration_end_date": "migrationEndDate",
        "migration_start_date": "migrationStartDate",
        "migration_within_cw_maps_enabled": "migrationWithinCwMapsEnabled",
        "serial_end": "serialEnd",
        "serial_start": "serialStart",
        "template_uuid": "templateUuid",
        "tier1_title": "tier1Title",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization:
    def __init__(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2634062bb2a0ac951c186185b71d1c423888589bf592b0f7a64d69af4e7e3550)
            check_type(argname="argument cloudwrapper_map_migration_title", value=cloudwrapper_map_migration_title, expected_type=type_hints["cloudwrapper_map_migration_title"])
            check_type(argname="argument custom_map_enabled", value=custom_map_enabled, expected_type=type_hints["custom_map_enabled"])
            check_type(argname="argument custom_map_name", value=custom_map_name, expected_type=type_hints["custom_map_name"])
            check_type(argname="argument hash_algorithm", value=hash_algorithm, expected_type=type_hints["hash_algorithm"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument map_migration_enabled", value=map_migration_enabled, expected_type=type_hints["map_migration_enabled"])
            check_type(argname="argument migration_end_date", value=migration_end_date, expected_type=type_hints["migration_end_date"])
            check_type(argname="argument migration_start_date", value=migration_start_date, expected_type=type_hints["migration_start_date"])
            check_type(argname="argument migration_within_cw_maps_enabled", value=migration_within_cw_maps_enabled, expected_type=type_hints["migration_within_cw_maps_enabled"])
            check_type(argname="argument serial_end", value=serial_end, expected_type=type_hints["serial_end"])
            check_type(argname="argument serial_start", value=serial_start, expected_type=type_hints["serial_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_title", value=tier1_title, expected_type=type_hints["tier1_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudwrapper_map_migration_title is not None:
            self._values["cloudwrapper_map_migration_title"] = cloudwrapper_map_migration_title
        if custom_map_enabled is not None:
            self._values["custom_map_enabled"] = custom_map_enabled
        if custom_map_name is not None:
            self._values["custom_map_name"] = custom_map_name
        if hash_algorithm is not None:
            self._values["hash_algorithm"] = hash_algorithm
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if map_migration_enabled is not None:
            self._values["map_migration_enabled"] = map_migration_enabled
        if migration_end_date is not None:
            self._values["migration_end_date"] = migration_end_date
        if migration_start_date is not None:
            self._values["migration_start_date"] = migration_start_date
        if migration_within_cw_maps_enabled is not None:
            self._values["migration_within_cw_maps_enabled"] = migration_within_cw_maps_enabled
        if serial_end is not None:
            self._values["serial_end"] = serial_end
        if serial_start is not None:
            self._values["serial_start"] = serial_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_title is not None:
            self._values["tier1_title"] = tier1_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudwrapper_map_migration_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        '''
        result = self._values.get("cloudwrapper_map_migration_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_map_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables custom maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        '''
        result = self._values.get("custom_map_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom map name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        '''
        result = self._values.get("custom_map_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        '''
        result = self._values.get("hash_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Location from which Cloud Wrapper migration is performed.

        User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def map_migration_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration of the custom map to Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        '''
        result = self._values.get("map_migration_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_end_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the map migration should end.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        '''
        result = self._values.get("migration_end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the map.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        '''
        result = self._values.get("migration_start_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration within Cloud Wrapper maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        '''
        result = self._values.get("migration_within_cw_maps_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_end(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial end value.

        Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        '''
        result = self._values.get("serial_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def serial_start(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial start value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        '''
        result = self._values.get("serial_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        '''
        result = self._values.get("tier1_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a385433eb06ab0322b0a8ff9fd53fc54a56876b266cba0c5a470461d5a170f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudwrapperMapMigrationTitle")
    def reset_cloudwrapper_map_migration_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudwrapperMapMigrationTitle", []))

    @jsii.member(jsii_name="resetCustomMapEnabled")
    def reset_custom_map_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapEnabled", []))

    @jsii.member(jsii_name="resetCustomMapName")
    def reset_custom_map_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapName", []))

    @jsii.member(jsii_name="resetHashAlgorithm")
    def reset_hash_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashAlgorithm", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMapMigrationEnabled")
    def reset_map_migration_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMapMigrationEnabled", []))

    @jsii.member(jsii_name="resetMigrationEndDate")
    def reset_migration_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationEndDate", []))

    @jsii.member(jsii_name="resetMigrationStartDate")
    def reset_migration_start_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartDate", []))

    @jsii.member(jsii_name="resetMigrationWithinCwMapsEnabled")
    def reset_migration_within_cw_maps_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationWithinCwMapsEnabled", []))

    @jsii.member(jsii_name="resetSerialEnd")
    def reset_serial_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialEnd", []))

    @jsii.member(jsii_name="resetSerialStart")
    def reset_serial_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1Title")
    def reset_tier1_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1Title", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitleInput")
    def cloudwrapper_map_migration_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cloudwrapperMapMigrationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapEnabledInput")
    def custom_map_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customMapEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapNameInput")
    def custom_map_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithmInput")
    def hash_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabledInput")
    def map_migration_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mapMigrationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationEndDateInput")
    def migration_end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationEndDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartDateInput")
    def migration_start_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabledInput")
    def migration_within_cw_maps_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "migrationWithinCwMapsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="serialEndInput")
    def serial_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialEndInput"))

    @builtins.property
    @jsii.member(jsii_name="serialStartInput")
    def serial_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1TitleInput")
    def tier1_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1TitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitle")
    def cloudwrapper_map_migration_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cloudwrapperMapMigrationTitle"))

    @cloudwrapper_map_migration_title.setter
    def cloudwrapper_map_migration_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0d7047c6f1ddddede1d02ad0b22e44c18f9519edaffce2bdbbf09ed758b7ee0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudwrapperMapMigrationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customMapEnabled")
    def custom_map_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customMapEnabled"))

    @custom_map_enabled.setter
    def custom_map_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__205b100163e5a957a17438e0a6393a7fcf75435eeba281181c0aa5a6160b7c8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customMapName")
    def custom_map_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMapName"))

    @custom_map_name.setter
    def custom_map_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15ab3d165973ec7e028456dc80626fd2b3b64c502b898ff048597cb170a4f86a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapName", value)

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithm")
    def hash_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashAlgorithm"))

    @hash_algorithm.setter
    def hash_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c462ed9dee5d6c5837db1e585e3469dc2006c6d9a31fd72a67e194370689129c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7054b06e2ece531d367cd76ad2548e157f44484c0918e12661cc4676773bc74d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c703288e68a9bc27b02fca4e41206681a97edffd3f09e2f2b300efc1fdec1adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabled")
    def map_migration_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mapMigrationEnabled"))

    @map_migration_enabled.setter
    def map_migration_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e325f64f1cacf27b7988a6cb6de14809260ba73afa2c1e12262ff26b1e3caf52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mapMigrationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="migrationEndDate")
    def migration_end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationEndDate"))

    @migration_end_date.setter
    def migration_end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd71dd7fe642417a162ea29e954bef058f22a4459bf514a949637f0af184b19f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationEndDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartDate")
    def migration_start_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartDate"))

    @migration_start_date.setter
    def migration_start_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35bfb4ae9e157c2d45249b5cf6b74d0e88a77d2891f0bc35f38372e7c138ab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabled")
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "migrationWithinCwMapsEnabled"))

    @migration_within_cw_maps_enabled.setter
    def migration_within_cw_maps_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ceffb77cafd5f35f35fe7af8d3e3787a9de8f1b73bd3aa11deabf4d1dc87edd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationWithinCwMapsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="serialEnd")
    def serial_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialEnd"))

    @serial_end.setter
    def serial_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__530db3e6ca2611332b525eac7fd205452749c155829a34e42946bea044a5a24d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialEnd", value)

    @builtins.property
    @jsii.member(jsii_name="serialStart")
    def serial_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialStart"))

    @serial_start.setter
    def serial_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88cb3722d2c5e548421cc0d84f96114904324d807d2f2b38f8e62da1ea360ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57a29ed9399d2c3e4b3d280a5cf7ccc37a18b97681fb08c9264b7f496d9f9b9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1Title")
    def tier1_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1Title"))

    @tier1_title.setter
    def tier1_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18a5a98029de0560ae4d303176492331cc12482eda9e5336bdffe0c1f2031a26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1Title", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cea0ddc253e9f17e6e995b255fe5106a8c4d6ed129c5608508583be79055225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__951228f161d60afc7645a7c125213fc07ac3966b59376c0530933dd90e324c65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d116c852754256d4d220935080303340a0059e8db083ddad1d2262d42c3949c8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03433413c3e16a91ba0c823e3b820705917df3080be9dffce4c45e44983f123d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1caa60c6c0b13df82d5d4ab84ed31f8578e5b53df32d3f91c31bd14b5994b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3ba1554314dc75213fb7a0d0099688b6bf5c42c879e255c09aa357b546d7c3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__465cd6ea981a9e5030777242749c22da05bb9915f5e65d6feb73cd3f6779f1b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d6a942d72614c5566efe0582af01e59c1f628f4d5b70eb0a0cb5dc80ea6cc64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__deb62236e29101c7df1545471a6625080c6e3d0eb1424fa98cb95373f5900518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c65c6592b775298400fdf6f4e724be571a3fa18292437fc1a73cf8efacbae7)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout, for example ``10s``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6cf7663368250b5c87966d897cc0cf0f91b6fbdc7711a7d5237d43a6b4c886d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb84b16f2481f11d122b6469f38a2690da57fcbd5285e78f0b94dab413633e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0fe040f8e5804b2c58536a13df67646e725f75a27e0f8dcc982a2b9f2776c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e3c2415e3b170111ad3007d33013c1899bf830bdd6772ef9e90debfd5d89cd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd55be0f51e2e75d6ede83add0d0429b14b7fbbd1c227887a7a87c4193e9a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d9f7310d47aca5a375834531bbfa8fe45c5357b1c4e27a758f18b8bf3a34a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "legal_text": "legalText",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f103a4bb7f69b3e5c60cfb7a4e953d9996d7dd354906fe17e2b3e988d6d8ee0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument legal_text", value=legal_text, expected_type=type_hints["legal_text"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if legal_text is not None:
            self._values["legal_text"] = legal_text
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract UIDs from client requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Where to extract the UID value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the HTTP header from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def legal_text(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        '''
        result = self._values.get("legal_text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the rule tree variable from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30cf170f7738400a1f1bd423fc7551f19a25d111a4afe6e34281e515522b5b74)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLegalText")
    def reset_legal_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLegalText", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="legalTextInput")
    def legal_text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "legalTextInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd062750e425e88ceda943a62c98ea883645030abc761152539f85840b28788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__895fd31aed69e14bf2640883ee3fc98e1f7e29597d1ada89a8f4fbbd5af48d85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20929267d8f37df8db24c249077bad19609912ac0fe35534ad749bcf04f8459b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="legalText")
    def legal_text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "legalText"))

    @legal_text.setter
    def legal_text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd0820116afba9f9ddc3ede724e06319b461eca9d685af844096399a09188e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "legalText", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d49ec0ba4c05bcd27933ce31aadf00d05debec3559ea768cd8439a2efca760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6042445b6fa1f5d0a4afd0369f829fbe13d1cd8e76682a02011ec07ef78d0ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32484873ba26e4a2dd97d30eb30924959def49730d81b27171e767207feb6c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07955b57b74ea3d908bc64a27c2bdc044439649bd03a5d587a2d53aff4eb25d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48f297c600fdbdb64c29a4f0a39ea32fcda2ac4e67dad4fd41fafc959186f2a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b3baa4d1eca0b8ed59b24bf425f0885032d76880df686fc9588018efc243eac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c263b03d98de17c98374d14e99e0fad5855fedc5115a4da5ddb40292f717097a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the ETag validation behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d60050c257084503da50c64308cc83d6cfa85dd96787b9bb38b51ceb67c62e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bfcd9d9d83b9261acb64254ae90c49975e17262ed6c8fe0f3d2359108374eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f1a45537ea15ab40320af3dd5bc5909c47411c84067e4e0ff6d0e17fb49f34a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__808854d1fa22cce25bf1b3ae39b2baad2d0dae4cece690a05752259abee074bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b657cb2176d1c6b4a89b4907a5b1dfeef11bdba689f4b9a5e26059df9e1fb92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0ad42b196d07a62169baa49899a45afefccdeed1c3e1122638036e14cbef882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken",
    jsii_struct_bases=[],
    name_mapping={
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken:
    def __init__(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4a02108f1b7d6a68df9874578842dc62713b0aa887c5dbf91d23f411236b0ca)
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specify from where to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp",
    jsii_struct_bases=[],
    name_mapping={
        "authorizations": "authorizations",
        "client_id": "clientId",
        "custom_header": "customHeader",
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_authorizations": "extractAuthorizations",
        "extract_client_id": "extractClientId",
        "extract_location": "extractLocation",
        "extract_user_name": "extractUserName",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "primary_location": "primaryLocation",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "user_name": "userName",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp:
    def __init__(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f2f312c48543b7417994ab1484a71defb9507678fe708c1b69b0aadac2daccb)
            check_type(argname="argument authorizations", value=authorizations, expected_type=type_hints["authorizations"])
            check_type(argname="argument client_id", value=client_id, expected_type=type_hints["client_id"])
            check_type(argname="argument custom_header", value=custom_header, expected_type=type_hints["custom_header"])
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_authorizations", value=extract_authorizations, expected_type=type_hints["extract_authorizations"])
            check_type(argname="argument extract_client_id", value=extract_client_id, expected_type=type_hints["extract_client_id"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument extract_user_name", value=extract_user_name, expected_type=type_hints["extract_user_name"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument primary_location", value=primary_location, expected_type=type_hints["primary_location"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_name", value=user_name, expected_type=type_hints["user_name"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if authorizations is not None:
            self._values["authorizations"] = authorizations
        if client_id is not None:
            self._values["client_id"] = client_id
        if custom_header is not None:
            self._values["custom_header"] = custom_header
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_authorizations is not None:
            self._values["extract_authorizations"] = extract_authorizations
        if extract_client_id is not None:
            self._values["extract_client_id"] = extract_client_id
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if extract_user_name is not None:
            self._values["extract_user_name"] = extract_user_name
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if primary_location is not None:
            self._values["primary_location"] = primary_location
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_name is not None:
            self._values["user_name"] = user_name
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def authorizations(self) -> typing.Optional[builtins.str]:
        '''This specifies the authorization group name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        '''
        result = self._values.get("authorizations")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_id(self) -> typing.Optional[builtins.str]:
        '''This specifies the claim name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        '''
        result = self._values.get("client_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_header(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''The JWT value comes from the ``X-Akamai-DCP-Token`` header by default.

        Enabling this option allows you to extract it from another header name that you specify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        '''
        result = self._values.get("custom_header")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_authorizations(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the authorization groups stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        '''
        result = self._values.get("extract_authorizations")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_client_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the client ID claim name stored in JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        '''
        result = self._values.get("extract_client_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to get the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_user_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the user name stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        '''
        result = self._values.get("extract_user_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header to extract the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def primary_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the primary location to extract the JWT value from.

        If the specified option doesn't include the JWTs, the system checks the secondary one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        '''
        result = self._values.get("primary_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the user name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        '''
        result = self._values.get("user_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be2b8d7c100779b8d180665acbb8cf7edb0adfc3ab8e0cc62c862f6280e651df)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthorizations")
    def reset_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthorizations", []))

    @jsii.member(jsii_name="resetClientId")
    def reset_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientId", []))

    @jsii.member(jsii_name="resetCustomHeader")
    def reset_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeader", []))

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractAuthorizations")
    def reset_extract_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractAuthorizations", []))

    @jsii.member(jsii_name="resetExtractClientId")
    def reset_extract_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractClientId", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetExtractUserName")
    def reset_extract_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractUserName", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrimaryLocation")
    def reset_primary_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrimaryLocation", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserName")
    def reset_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserName", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authorizationsInput")
    def authorizations_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIdInput")
    def client_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderInput")
    def custom_header_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizationsInput")
    def extract_authorizations_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractAuthorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractClientIdInput")
    def extract_client_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractClientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="extractUserNameInput")
    def extract_user_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractUserNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="primaryLocationInput")
    def primary_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "primaryLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userNameInput")
    def user_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userNameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authorizations")
    def authorizations(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authorizations"))

    @authorizations.setter
    def authorizations(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28cbedd34a6c8e52ce78b29d4e9dc9adcfbedf19b9c90576ffd8b47b453940c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authorizations", value)

    @builtins.property
    @jsii.member(jsii_name="clientId")
    def client_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientId"))

    @client_id.setter
    def client_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfabff380189002c8085e6cecf385220353f0192b7382a68248ff24818c21c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientId", value)

    @builtins.property
    @jsii.member(jsii_name="customHeader")
    def custom_header(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customHeader"))

    @custom_header.setter
    def custom_header(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656adab768b18a103222971f0ca4e353c0ea84a8e409d95113aa3368c7d4553e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9648321eee89e400831a42a7e6476aa1642eb6d0dc5f6ec9376c5a99924b6a80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__115e6c3c9bb3c901cb768cc302b8560aee4a2e0e575eb905700c99b1fb6b02cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizations")
    def extract_authorizations(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractAuthorizations"))

    @extract_authorizations.setter
    def extract_authorizations(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1d4a336e3c71e5159e58258ae8284978f5dbcf48f5660a61010ad013c1fbf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractAuthorizations", value)

    @builtins.property
    @jsii.member(jsii_name="extractClientId")
    def extract_client_id(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractClientId"))

    @extract_client_id.setter
    def extract_client_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c7857b59d741c64ef7d899e310a75cac4b0e0d252a41464258547b77ea8de40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractClientId", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7293023d35c7d782275bc323d52d8dedc457f250bb20cfcbf691062075a8c074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="extractUserName")
    def extract_user_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractUserName"))

    @extract_user_name.setter
    def extract_user_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed1eb782737d45f8a83f7e548300434df5c8db948307258afa8d3b613c7a450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractUserName", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__633e4cfb7b6c1621ac635e862b483ad087b414dc83ef7c489df8e18c5ef278b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1d1bff4df1127230d86a6ad33760be6022aa995dc37beac794a10ae8b2c616b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a0c37e525c755107537fa35aeda2407efa025d8b58a4de3e8231d8f5d1ce531)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="primaryLocation")
    def primary_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "primaryLocation"))

    @primary_location.setter
    def primary_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2def9bbda2c876272db87cb654ff7c53af432545f5de327694d7cea3e12027dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "primaryLocation", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97f68c42d97ff5fd1875c5385a78d2e6d43889721458452710fc67b5a5bd9762)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fcce352acf31606d3ebe086121477faa068ee5e28b2b1d812d459b0b08e8827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userName")
    def user_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userName"))

    @user_name.setter
    def user_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc08995ac53bad8c6b7f6cbc7e6d637605499958bddcc9deabf4c059bf2e2a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userName", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__caf31afbc9928271d6d295731ae5bc5af86fe0ce23dce74f5c6742805a391155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8c170d960f8b3f39e7700a2b4cbac22c7debf123ccbd2a005e3005bfd38cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b3a5a84ff39ca28bb4a5acf8e0e5da0e5cfb575907c0e86104f52076e3b36b5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50d56b2e261822d32b8d13a5ede796545ac6c6902286ea51186663eb3fb4a976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a01f711c2473cc9a38b08b39163c0f4aaeccbe9d998cff76daca6946fa58a131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8bad24457371395c4b7997be0e431134ca22e52099f41ec548331ace49eea80)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9e7fe0d7450cd2227b9b0a02ff923e6f1352bcc9340406cbff144a92b66c0f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7609ed8eab47cedb7d903ddae9b77b06710aabb3d96ba5fea759df839a964fd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3316fadff5aa5af4d01022cc6229f8f6df3a0abdcdd24be1627042871f7ffa9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e67ad408bdd51c362236caa5cf6c9aeb7a119684b1a4e98b9bba26ebd36d5659)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03768227bca912082509c7a0127422bfda0efae25182c13e5976c7d227ba5689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3afaecb92043c9e41c6d9b55dd97b952cb5f67f9205bbd5f1a57e471532457b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6055935a2e7324fcbc830546c8a4ed2f2c49fe48cc623e2ccdcbe4fc39e0225d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "escape_hmac_inputs": "escapeHmacInputs",
        "failure_response": "failureResponse",
        "ignore_query_string": "ignoreQueryString",
        "key": "key",
        "location": "location",
        "location_id": "locationId",
        "locked": "locked",
        "salt": "salt",
        "template_uuid": "templateUuid",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40c14dea366f5114824698905ec239bbf6a7bdef0d26a25fe707e1c8d7d9ecc)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument escape_hmac_inputs", value=escape_hmac_inputs, expected_type=type_hints["escape_hmac_inputs"])
            check_type(argname="argument failure_response", value=failure_response, expected_type=type_hints["failure_response"])
            check_type(argname="argument ignore_query_string", value=ignore_query_string, expected_type=type_hints["ignore_query_string"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if escape_hmac_inputs is not None:
            self._values["escape_hmac_inputs"] = escape_hmac_inputs
        if failure_response is not None:
            self._values["failure_response"] = failure_response
        if ignore_query_string is not None:
            self._values["ignore_query_string"] = ignore_query_string
        if key is not None:
            self._values["key"] = key
        if location is not None:
            self._values["location"] = location
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if salt is not None:
            self._values["salt"] = salt
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def escape_hmac_inputs(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''URL-escapes HMAC inputs passed in as query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        '''
        result = self._values.get("escape_hmac_inputs")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failure_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends an HTTP error when an authentication test fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        '''
        result = self._values.get("failure_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this removes the query string from the URL used to form an encryption key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        '''
        result = self._values.get("ignore_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''The shared secret used to validate tokens, which needs to match the key used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to find the token in the incoming request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a hex value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9c1bfa5b8459ecb0aafd01b9c6f1a6335766a97327d46d467fe59048505206e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetEscapeHmacInputs")
    def reset_escape_hmac_inputs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeHmacInputs", []))

    @jsii.member(jsii_name="resetFailureResponse")
    def reset_failure_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailureResponse", []))

    @jsii.member(jsii_name="resetIgnoreQueryString")
    def reset_ignore_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnoreQueryString", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputsInput")
    def escape_hmac_inputs_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeHmacInputsInput"))

    @builtins.property
    @jsii.member(jsii_name="failureResponseInput")
    def failure_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failureResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryStringInput")
    def ignore_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignoreQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c1ca4e257858765ee5fc4eb08fff39de6e2bcf91d2863fee2e3b8c6e50b824c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputs")
    def escape_hmac_inputs(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeHmacInputs"))

    @escape_hmac_inputs.setter
    def escape_hmac_inputs(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__277f3eab81e2a3cfa4ea9a7bda9303364f688e5f1fed6e32790907579a3a8d99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeHmacInputs", value)

    @builtins.property
    @jsii.member(jsii_name="failureResponse")
    def failure_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failureResponse"))

    @failure_response.setter
    def failure_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc3910a6ad1dc2edaa87647431855dd661a026efd4ca2bb1f0d75ea2a54dcb8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failureResponse", value)

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryString")
    def ignore_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignoreQueryString"))

    @ignore_query_string.setter
    def ignore_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf31f15a5cc8172ffeabcd37bbb959e4e77712e3631a10d79c63361a4a8ef68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignoreQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69c53a9707e72e4c72939e7a1e26aebcffa17f0d75f58181fd02bf8587d64438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafe06bedb2c4c2336f9ae25c856378119c0ec4ac4c9c45bb991310689a5ff01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41dc91218b760c31c352387924dad22f342117b23910b61d998e8e7d90135184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f519c16086a5b7b5886475597b5c00fa07bde48b1698cae4e2fa4343f686d6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d04bca09674d2c1635a7bd8b1bf91444bd02456a8f50ffb5ced61f0d3d07a7ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a06b3fd75eccdd0853898565d9deb01f6545a8db7a0260dfe286a9b9920f4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5331424dbbf096fb81d426df58fe87822fc774cefa92dd77cf53d5c98e4da5a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76f62f30e6bcc16b7f2c1765db1374c5c705408db56870d046092bda03e46b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4487de1450019bc3e2c8b91851e6cb5c1a439fee465736005d267fc3068d8990)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81604337fbc8b1c7c98e2070fd053d0ad155273b3d49bde5378371a4424bd987)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed300f8598ecc0aca6243db28e0ce50f858b6783420dd43823942ccf37344233)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests.

        The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba3da47215b0b763afae60ff0a508e340b77d12bb1c250d9729b77d11a491e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e38a4f4e8a6db6c341a2dba2db6e8a83ee9edfd0f7ea4a2b7e03d72aa0246e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f67f63550531625e2501bf501ef3e29cc154ddf787cc81d10d856d7a0d81ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b263c457a16084f0d285fd5c0160b15883367858fef8434b226a3345906a44e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b1f9613ba6fda740c859ddf8a7c51fef5e93b18ca42f092ab5e6073af6ad2a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac492078e9a200e8be085fa78042e87bb08cc7ef0c31636c0dfdd6e2a3bf382)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d2c07b24caf9c54f1ea93342fe5de41e47e50f09abd6f0cc302589299d8c680)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd999a90da46f0c8fbd08ea14496a3c1e08c4ba81477faf8b731162fa6b4ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23868aa6106eb5b225e06e803e4cd30a5b95a03447c494796b259ab30c4a0018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04d31f97717e286692dc77b93648ed2868786616419a6daf1e95345412df3f12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6795537bfedfc2ba18a5470e1fcde0614d177dd4235263d1a297cee48f781256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c85a325f24e2a4c735a8103a0dfd75b14ed2fb8dbc381de00d1f4be797b45d4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80466bfec6a602cea2c382fd388a8d7ed4e833fcb6d1a6038a05c626783abc94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33712f53ff1d298786ce0a29445c079eacdd41a9bc5627e313734b5bde0dbf01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5aa86b72075713206a8dd3def6292841eab4efc6b77a78b20eff461363506ab)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3991895cc4bf03d59304b53eb97ba18e8aed8ec067ea21415641739ab581d4d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ed9d90fb7f564769829fd143a5e2f6d49919d6df280eb9763fedee4dc8f006c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75eb3480505fbc77ec959011d528360f23982c75a6fc8ea61164d74bf9e03b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8cc9e1deea1c142650ce2512e2a1e679ab219a332576896c2041527d570d000)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d49dc10d0073b87f20d8d0159c0a3968ffdd5f154ce3265ea10c2a038300c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_user_cookie_advanced": "allowedUserCookieAdvanced",
        "allowed_user_cookie_automatic_salt": "allowedUserCookieAutomaticSalt",
        "allowed_user_cookie_domain": "allowedUserCookieDomain",
        "allowed_user_cookie_domain_type": "allowedUserCookieDomainType",
        "allowed_user_cookie_duration": "allowedUserCookieDuration",
        "allowed_user_cookie_enabled": "allowedUserCookieEnabled",
        "allowed_user_cookie_http_only": "allowedUserCookieHttpOnly",
        "allowed_user_cookie_label": "allowedUserCookieLabel",
        "allowed_user_cookie_management_title": "allowedUserCookieManagementTitle",
        "allowed_user_cookie_refresh": "allowedUserCookieRefresh",
        "allowed_user_cookie_salt": "allowedUserCookieSalt",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "user_identification_by_cookie": "userIdentificationByCookie",
        "user_identification_by_headers": "userIdentificationByHeaders",
        "user_identification_by_ip": "userIdentificationByIp",
        "user_identification_by_params": "userIdentificationByParams",
        "user_identification_key_cookie": "userIdentificationKeyCookie",
        "user_identification_key_headers": "userIdentificationKeyHeaders",
        "user_identification_key_params": "userIdentificationKeyParams",
        "user_identification_title": "userIdentificationTitle",
        "uuid": "uuid",
        "waiting_room_cache_ttl": "waitingRoomCacheTtl",
        "waiting_room_cookie_advanced": "waitingRoomCookieAdvanced",
        "waiting_room_cookie_automatic_salt": "waitingRoomCookieAutomaticSalt",
        "waiting_room_cookie_domain": "waitingRoomCookieDomain",
        "waiting_room_cookie_domain_type": "waitingRoomCookieDomainType",
        "waiting_room_cookie_duration": "waitingRoomCookieDuration",
        "waiting_room_cookie_enabled": "waitingRoomCookieEnabled",
        "waiting_room_cookie_http_only": "waitingRoomCookieHttpOnly",
        "waiting_room_cookie_label": "waitingRoomCookieLabel",
        "waiting_room_cookie_management_title": "waitingRoomCookieManagementTitle",
        "waiting_room_cookie_salt": "waitingRoomCookieSalt",
        "waiting_room_cookie_share_label": "waitingRoomCookieShareLabel",
        "waiting_room_cp_code": "waitingRoomCpCode",
        "waiting_room_directory": "waitingRoomDirectory",
        "waiting_room_management_title": "waitingRoomManagementTitle",
        "waiting_room_net_storage": "waitingRoomNetStorage",
        "waiting_room_status_code": "waitingRoomStatusCode",
        "waiting_room_use_cp_code": "waitingRoomUseCpCode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization:
    def __init__(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(waiting_room_cp_code, dict):
            waiting_room_cp_code = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode(**waiting_room_cp_code)
        if isinstance(waiting_room_net_storage, dict):
            waiting_room_net_storage = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage(**waiting_room_net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd01794780a27f8484ffbf7aefe0d3ac0cc23bce5bacaffbe2586fd651198ec6)
            check_type(argname="argument allowed_user_cookie_advanced", value=allowed_user_cookie_advanced, expected_type=type_hints["allowed_user_cookie_advanced"])
            check_type(argname="argument allowed_user_cookie_automatic_salt", value=allowed_user_cookie_automatic_salt, expected_type=type_hints["allowed_user_cookie_automatic_salt"])
            check_type(argname="argument allowed_user_cookie_domain", value=allowed_user_cookie_domain, expected_type=type_hints["allowed_user_cookie_domain"])
            check_type(argname="argument allowed_user_cookie_domain_type", value=allowed_user_cookie_domain_type, expected_type=type_hints["allowed_user_cookie_domain_type"])
            check_type(argname="argument allowed_user_cookie_duration", value=allowed_user_cookie_duration, expected_type=type_hints["allowed_user_cookie_duration"])
            check_type(argname="argument allowed_user_cookie_enabled", value=allowed_user_cookie_enabled, expected_type=type_hints["allowed_user_cookie_enabled"])
            check_type(argname="argument allowed_user_cookie_http_only", value=allowed_user_cookie_http_only, expected_type=type_hints["allowed_user_cookie_http_only"])
            check_type(argname="argument allowed_user_cookie_label", value=allowed_user_cookie_label, expected_type=type_hints["allowed_user_cookie_label"])
            check_type(argname="argument allowed_user_cookie_management_title", value=allowed_user_cookie_management_title, expected_type=type_hints["allowed_user_cookie_management_title"])
            check_type(argname="argument allowed_user_cookie_refresh", value=allowed_user_cookie_refresh, expected_type=type_hints["allowed_user_cookie_refresh"])
            check_type(argname="argument allowed_user_cookie_salt", value=allowed_user_cookie_salt, expected_type=type_hints["allowed_user_cookie_salt"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_identification_by_cookie", value=user_identification_by_cookie, expected_type=type_hints["user_identification_by_cookie"])
            check_type(argname="argument user_identification_by_headers", value=user_identification_by_headers, expected_type=type_hints["user_identification_by_headers"])
            check_type(argname="argument user_identification_by_ip", value=user_identification_by_ip, expected_type=type_hints["user_identification_by_ip"])
            check_type(argname="argument user_identification_by_params", value=user_identification_by_params, expected_type=type_hints["user_identification_by_params"])
            check_type(argname="argument user_identification_key_cookie", value=user_identification_key_cookie, expected_type=type_hints["user_identification_key_cookie"])
            check_type(argname="argument user_identification_key_headers", value=user_identification_key_headers, expected_type=type_hints["user_identification_key_headers"])
            check_type(argname="argument user_identification_key_params", value=user_identification_key_params, expected_type=type_hints["user_identification_key_params"])
            check_type(argname="argument user_identification_title", value=user_identification_title, expected_type=type_hints["user_identification_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_cache_ttl", value=waiting_room_cache_ttl, expected_type=type_hints["waiting_room_cache_ttl"])
            check_type(argname="argument waiting_room_cookie_advanced", value=waiting_room_cookie_advanced, expected_type=type_hints["waiting_room_cookie_advanced"])
            check_type(argname="argument waiting_room_cookie_automatic_salt", value=waiting_room_cookie_automatic_salt, expected_type=type_hints["waiting_room_cookie_automatic_salt"])
            check_type(argname="argument waiting_room_cookie_domain", value=waiting_room_cookie_domain, expected_type=type_hints["waiting_room_cookie_domain"])
            check_type(argname="argument waiting_room_cookie_domain_type", value=waiting_room_cookie_domain_type, expected_type=type_hints["waiting_room_cookie_domain_type"])
            check_type(argname="argument waiting_room_cookie_duration", value=waiting_room_cookie_duration, expected_type=type_hints["waiting_room_cookie_duration"])
            check_type(argname="argument waiting_room_cookie_enabled", value=waiting_room_cookie_enabled, expected_type=type_hints["waiting_room_cookie_enabled"])
            check_type(argname="argument waiting_room_cookie_http_only", value=waiting_room_cookie_http_only, expected_type=type_hints["waiting_room_cookie_http_only"])
            check_type(argname="argument waiting_room_cookie_label", value=waiting_room_cookie_label, expected_type=type_hints["waiting_room_cookie_label"])
            check_type(argname="argument waiting_room_cookie_management_title", value=waiting_room_cookie_management_title, expected_type=type_hints["waiting_room_cookie_management_title"])
            check_type(argname="argument waiting_room_cookie_salt", value=waiting_room_cookie_salt, expected_type=type_hints["waiting_room_cookie_salt"])
            check_type(argname="argument waiting_room_cookie_share_label", value=waiting_room_cookie_share_label, expected_type=type_hints["waiting_room_cookie_share_label"])
            check_type(argname="argument waiting_room_cp_code", value=waiting_room_cp_code, expected_type=type_hints["waiting_room_cp_code"])
            check_type(argname="argument waiting_room_directory", value=waiting_room_directory, expected_type=type_hints["waiting_room_directory"])
            check_type(argname="argument waiting_room_management_title", value=waiting_room_management_title, expected_type=type_hints["waiting_room_management_title"])
            check_type(argname="argument waiting_room_net_storage", value=waiting_room_net_storage, expected_type=type_hints["waiting_room_net_storage"])
            check_type(argname="argument waiting_room_status_code", value=waiting_room_status_code, expected_type=type_hints["waiting_room_status_code"])
            check_type(argname="argument waiting_room_use_cp_code", value=waiting_room_use_cp_code, expected_type=type_hints["waiting_room_use_cp_code"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowed_user_cookie_advanced is not None:
            self._values["allowed_user_cookie_advanced"] = allowed_user_cookie_advanced
        if allowed_user_cookie_automatic_salt is not None:
            self._values["allowed_user_cookie_automatic_salt"] = allowed_user_cookie_automatic_salt
        if allowed_user_cookie_domain is not None:
            self._values["allowed_user_cookie_domain"] = allowed_user_cookie_domain
        if allowed_user_cookie_domain_type is not None:
            self._values["allowed_user_cookie_domain_type"] = allowed_user_cookie_domain_type
        if allowed_user_cookie_duration is not None:
            self._values["allowed_user_cookie_duration"] = allowed_user_cookie_duration
        if allowed_user_cookie_enabled is not None:
            self._values["allowed_user_cookie_enabled"] = allowed_user_cookie_enabled
        if allowed_user_cookie_http_only is not None:
            self._values["allowed_user_cookie_http_only"] = allowed_user_cookie_http_only
        if allowed_user_cookie_label is not None:
            self._values["allowed_user_cookie_label"] = allowed_user_cookie_label
        if allowed_user_cookie_management_title is not None:
            self._values["allowed_user_cookie_management_title"] = allowed_user_cookie_management_title
        if allowed_user_cookie_refresh is not None:
            self._values["allowed_user_cookie_refresh"] = allowed_user_cookie_refresh
        if allowed_user_cookie_salt is not None:
            self._values["allowed_user_cookie_salt"] = allowed_user_cookie_salt
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_identification_by_cookie is not None:
            self._values["user_identification_by_cookie"] = user_identification_by_cookie
        if user_identification_by_headers is not None:
            self._values["user_identification_by_headers"] = user_identification_by_headers
        if user_identification_by_ip is not None:
            self._values["user_identification_by_ip"] = user_identification_by_ip
        if user_identification_by_params is not None:
            self._values["user_identification_by_params"] = user_identification_by_params
        if user_identification_key_cookie is not None:
            self._values["user_identification_key_cookie"] = user_identification_key_cookie
        if user_identification_key_headers is not None:
            self._values["user_identification_key_headers"] = user_identification_key_headers
        if user_identification_key_params is not None:
            self._values["user_identification_key_params"] = user_identification_key_params
        if user_identification_title is not None:
            self._values["user_identification_title"] = user_identification_title
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_cache_ttl is not None:
            self._values["waiting_room_cache_ttl"] = waiting_room_cache_ttl
        if waiting_room_cookie_advanced is not None:
            self._values["waiting_room_cookie_advanced"] = waiting_room_cookie_advanced
        if waiting_room_cookie_automatic_salt is not None:
            self._values["waiting_room_cookie_automatic_salt"] = waiting_room_cookie_automatic_salt
        if waiting_room_cookie_domain is not None:
            self._values["waiting_room_cookie_domain"] = waiting_room_cookie_domain
        if waiting_room_cookie_domain_type is not None:
            self._values["waiting_room_cookie_domain_type"] = waiting_room_cookie_domain_type
        if waiting_room_cookie_duration is not None:
            self._values["waiting_room_cookie_duration"] = waiting_room_cookie_duration
        if waiting_room_cookie_enabled is not None:
            self._values["waiting_room_cookie_enabled"] = waiting_room_cookie_enabled
        if waiting_room_cookie_http_only is not None:
            self._values["waiting_room_cookie_http_only"] = waiting_room_cookie_http_only
        if waiting_room_cookie_label is not None:
            self._values["waiting_room_cookie_label"] = waiting_room_cookie_label
        if waiting_room_cookie_management_title is not None:
            self._values["waiting_room_cookie_management_title"] = waiting_room_cookie_management_title
        if waiting_room_cookie_salt is not None:
            self._values["waiting_room_cookie_salt"] = waiting_room_cookie_salt
        if waiting_room_cookie_share_label is not None:
            self._values["waiting_room_cookie_share_label"] = waiting_room_cookie_share_label
        if waiting_room_cp_code is not None:
            self._values["waiting_room_cp_code"] = waiting_room_cp_code
        if waiting_room_directory is not None:
            self._values["waiting_room_directory"] = waiting_room_directory
        if waiting_room_management_title is not None:
            self._values["waiting_room_management_title"] = waiting_room_management_title
        if waiting_room_net_storage is not None:
            self._values["waiting_room_net_storage"] = waiting_room_net_storage
        if waiting_room_status_code is not None:
            self._values["waiting_room_status_code"] = waiting_room_status_code
        if waiting_room_use_cp_code is not None:
            self._values["waiting_room_use_cp_code"] = waiting_room_use_cp_code

    @builtins.property
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets advanced configuration options for the allowed user's cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        '''
        result = self._values.get("allowed_user_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        '''
        result = self._values.get("allowed_user_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for an allowed user cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        '''
        result = self._values.get("allowed_user_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``allowedUserCookieAdvanced`` enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        '''
        result = self._values.get("allowed_user_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for the allowed user's session once allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        '''
        result = self._values.get("allowed_user_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a cookie for users who have been allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        '''
        result = self._values.get("allowed_user_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        '''
        result = self._values.get("allowed_user_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this cookie for an allowed user from others.

        The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        '''
        result = self._values.get("allowed_user_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        '''
        result = self._values.get("allowed_user_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration.

        Do not enable this option if you want to set a fixed time for all users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        '''
        result = self._values.get("allowed_user_cookie_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        '''
        result = self._values.get("allowed_user_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Visitor Prioritization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_by_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the value of a cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        '''
        result = self._values.get("user_identification_by_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        '''
        result = self._values.get("user_identification_by_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows IP addresses to identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        '''
        result = self._values.get("user_identification_by_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_params(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        '''
        result = self._values.get("user_identification_by_params")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_key_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie whose value identifies users.

        To match a user, the value of the cookie needs to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        '''
        result = self._values.get("user_identification_key_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_key_headers(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request headers whose values identify users.

        To match a user, values for all the specified headers need to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        '''
        result = self._values.get("user_identification_key_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_key_params(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request parameters whose values identify users.

        To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        '''
        result = self._values.get("user_identification_key_params")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        '''
        result = self._values.get("user_identification_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the waiting room page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        '''
        result = self._values.get("waiting_room_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        '''
        result = self._values.get("waiting_room_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        '''
        result = self._values.get("waiting_room_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        '''
        result = self._values.get("waiting_room_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        '''
        result = self._values.get("waiting_room_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for which users remain in the waiting room.

        During this time, users who refresh the waiting room page remain there.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        '''
        result = self._values.get("waiting_room_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a cookie to track a waiting room assignment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        '''
        result = self._values.get("waiting_room_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        '''
        result = self._values.get("waiting_room_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this waiting room cookie from others.

        The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        '''
        result = self._values.get("waiting_room_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        '''
        result = self._values.get("waiting_room_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        '''
        result = self._values.get("waiting_room_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        '''
        result = self._values.get("waiting_room_cookie_share_label")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        '''waiting_room_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        '''
        result = self._values.get("waiting_room_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode"], result)

    @builtins.property
    def waiting_room_directory(self) -> typing.Optional[builtins.str]:
        '''Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        '''
        result = self._values.get("waiting_room_directory")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        '''
        result = self._values.get("waiting_room_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        '''waiting_room_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        '''
        result = self._values.get("waiting_room_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage"], result)

    @builtins.property
    def waiting_room_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response code for requests sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        '''
        result = self._values.get("waiting_room_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a different CP code that tracks any requests that are sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        result = self._values.get("waiting_room_use_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68a0f3cd6f799bdfa63195fd2110bdcb32d2c6a996b745bf15f5119a34ef583f)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91743e1f543ff1d5f7509182c5066f4c41b19750534f77a45442ca7905d8b9d3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d486aed565e53953c8b1dbd01681569965ddfd48f7f8dce798ce2e331a2a39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11d1962afb176efa9cd60cff2de80f6dd572e12fbfed5bed7518bd7e4c84be6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0761e33de56bd2d3d2ded7967732b35723eeda79ab05958551a6b131ff62a4f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46c093000b7866e29a56a8a42c5afdab412b07932d573cf24c8e2b91bb812f34)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Prioritization FIFO shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies how to set the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests.

        The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__132b5a2a78c019f4ae2145f5fd2c88e916f5fcb180995e9809621ce7178dd1f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bfb2bf7023e30fe0011e4c4eea7911ac575328f3379273a3264fe5a31957fcad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7016cd5359b9c2caada4f3b7a5c1507b98c9ed12a903aed1b93ab00eb6991ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1101494a0da51bcf20d46b1b1ef07700a18d6c7e8e36618a66e30191df967b34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__005daacf0b2135dcc34031ce32dbe6b46a53a1f043b5b4efe46eb2db711e0de2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56062b667576d568277cdadeef0c9b739d39a554d23f6fae620a23f59b463d32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e048e2ddb85d2d101527c2acc0705476bc3e21ba4c48848a4708f2d622b33f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41d723efcaa2a1ca2350da13ab8f22645651336fb178518141fb8f63b4c7fc5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0658aaa680fa4534f42897c5ba23d648e60ca892c8919dc483046df65fb2f0a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__036cd7ed8698b4e577dceb487ff0ec1401e428c66d8e903ca09082a0ca440316)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43f29a3c8a1f8bd62e896c4a558d648b1d49dda9421fd8f38fc32df93798845b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d915d79087d3bea663662d7494edd0bcb13a8c49785b0e997a812bff3dd6e9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30dc8dd0c2ebb7327551e6adb98bedd66728d2526816f9c4761947ce46470e4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f00864cda7438fa76260927f7795849bb10c6291bd99690eb77573ca8b3ff6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791e43e9cc5383e99e76bcd674d728b6c7b5c5914d5b6afd0a5396a899636cea)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandaloneOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe9f7e3c89107069d8a00e2dc60f28ac3c5c9ddc2f503e5d144dc1feac9f22b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4feb38d712ddcdb0fcf98a79efe887ee00963f0e055dd584e7071971818d2be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416be8445b446d57304bb309478a9dfd375443b8249e5396921ceb074627af26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7804b474d2b49ae48acfa96607183e6f19dbacc25cb9f02e9a2c822cfac9b1e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__312c1285f4bef593f0b8900ebfa778e64ff16b9d265946c55da9ef1ba74616a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42b9655921efdfb002529f077dda9515d269a0b90b3438f0e721fea1df3c4e0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putWaitingRoomCpCode")
    def put_waiting_room_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomCpCode", [value]))

    @jsii.member(jsii_name="putWaitingRoomNetStorage")
    def put_waiting_room_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomNetStorage", [value]))

    @jsii.member(jsii_name="resetAllowedUserCookieAdvanced")
    def reset_allowed_user_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAdvanced", []))

    @jsii.member(jsii_name="resetAllowedUserCookieAutomaticSalt")
    def reset_allowed_user_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomain")
    def reset_allowed_user_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomain", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomainType")
    def reset_allowed_user_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomainType", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDuration")
    def reset_allowed_user_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDuration", []))

    @jsii.member(jsii_name="resetAllowedUserCookieEnabled")
    def reset_allowed_user_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieEnabled", []))

    @jsii.member(jsii_name="resetAllowedUserCookieHttpOnly")
    def reset_allowed_user_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieHttpOnly", []))

    @jsii.member(jsii_name="resetAllowedUserCookieLabel")
    def reset_allowed_user_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieLabel", []))

    @jsii.member(jsii_name="resetAllowedUserCookieManagementTitle")
    def reset_allowed_user_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieManagementTitle", []))

    @jsii.member(jsii_name="resetAllowedUserCookieRefresh")
    def reset_allowed_user_cookie_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieRefresh", []))

    @jsii.member(jsii_name="resetAllowedUserCookieSalt")
    def reset_allowed_user_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieSalt", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserIdentificationByCookie")
    def reset_user_identification_by_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationByHeaders")
    def reset_user_identification_by_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationByIp")
    def reset_user_identification_by_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByIp", []))

    @jsii.member(jsii_name="resetUserIdentificationByParams")
    def reset_user_identification_by_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByParams", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyCookie")
    def reset_user_identification_key_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyHeaders")
    def reset_user_identification_key_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyParams")
    def reset_user_identification_key_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyParams", []))

    @jsii.member(jsii_name="resetUserIdentificationTitle")
    def reset_user_identification_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomCacheTtl")
    def reset_waiting_room_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCacheTtl", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAdvanced")
    def reset_waiting_room_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAdvanced", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAutomaticSalt")
    def reset_waiting_room_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomain")
    def reset_waiting_room_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomain", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomainType")
    def reset_waiting_room_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomainType", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDuration")
    def reset_waiting_room_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDuration", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieEnabled")
    def reset_waiting_room_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieEnabled", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieHttpOnly")
    def reset_waiting_room_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieHttpOnly", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieLabel")
    def reset_waiting_room_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieManagementTitle")
    def reset_waiting_room_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieSalt")
    def reset_waiting_room_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieShareLabel")
    def reset_waiting_room_cookie_share_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieShareLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCpCode")
    def reset_waiting_room_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCpCode", []))

    @jsii.member(jsii_name="resetWaitingRoomDirectory")
    def reset_waiting_room_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomDirectory", []))

    @jsii.member(jsii_name="resetWaitingRoomManagementTitle")
    def reset_waiting_room_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomNetStorage")
    def reset_waiting_room_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomNetStorage", []))

    @jsii.member(jsii_name="resetWaitingRoomStatusCode")
    def reset_waiting_room_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomStatusCode", []))

    @jsii.member(jsii_name="resetWaitingRoomUseCpCode")
    def reset_waiting_room_use_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomUseCpCode", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCode")
    def waiting_room_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference", jsii.get(self, "waitingRoomCpCode"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorage")
    def waiting_room_net_storage(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference", jsii.get(self, "waitingRoomNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvancedInput")
    def allowed_user_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSaltInput")
    def allowed_user_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainInput")
    def allowed_user_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainTypeInput")
    def allowed_user_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDurationInput")
    def allowed_user_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "allowedUserCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabledInput")
    def allowed_user_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnlyInput")
    def allowed_user_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabelInput")
    def allowed_user_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitleInput")
    def allowed_user_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefreshInput")
    def allowed_user_cookie_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSaltInput")
    def allowed_user_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookieInput")
    def user_identification_by_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeadersInput")
    def user_identification_by_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIpInput")
    def user_identification_by_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByIpInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParamsInput")
    def user_identification_by_params_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookieInput")
    def user_identification_key_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationKeyCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeadersInput")
    def user_identification_key_headers_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParamsInput")
    def user_identification_key_params_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitleInput")
    def user_identification_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtlInput")
    def waiting_room_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvancedInput")
    def waiting_room_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSaltInput")
    def waiting_room_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainInput")
    def waiting_room_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainTypeInput")
    def waiting_room_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDurationInput")
    def waiting_room_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabledInput")
    def waiting_room_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnlyInput")
    def waiting_room_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabelInput")
    def waiting_room_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitleInput")
    def waiting_room_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSaltInput")
    def waiting_room_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabelInput")
    def waiting_room_cookie_share_label_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieShareLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCodeInput")
    def waiting_room_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode"], jsii.get(self, "waitingRoomCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectoryInput")
    def waiting_room_directory_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitleInput")
    def waiting_room_management_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorageInput")
    def waiting_room_net_storage_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage"], jsii.get(self, "waitingRoomNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCodeInput")
    def waiting_room_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCodeInput")
    def waiting_room_use_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomUseCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvanced")
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAdvanced"))

    @allowed_user_cookie_advanced.setter
    def allowed_user_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__959951bb927d94c97f64f2a20a416bd0f94422a3fea167d31ef69e259b8d9e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSalt")
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAutomaticSalt"))

    @allowed_user_cookie_automatic_salt.setter
    def allowed_user_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70c23950d69b84d1c5d7478eafadc8706e3cfaf09a30f78bdacd386132e22de9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomain")
    def allowed_user_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomain"))

    @allowed_user_cookie_domain.setter
    def allowed_user_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f4c54874c54e474ca34dfec1f9b940f08cf71948f643c417820a099821f952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainType")
    def allowed_user_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomainType"))

    @allowed_user_cookie_domain_type.setter
    def allowed_user_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bca70f5a0b060ac42b3afeb20c055df1cb5bbcc67fb937e12834cae55054fd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDuration")
    def allowed_user_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "allowedUserCookieDuration"))

    @allowed_user_cookie_duration.setter
    def allowed_user_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fc9d9903196ddd57cd5b2a1aba1b48c6e43703d31633f8a8566393a500a1e5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabled")
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieEnabled"))

    @allowed_user_cookie_enabled.setter
    def allowed_user_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb9f65a4a12aab523a42dd8665c6cb22a81398e3c9b223cc145764463e99e0ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnly")
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieHttpOnly"))

    @allowed_user_cookie_http_only.setter
    def allowed_user_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8335474582f75b3b755ac83be460da20b1db2ac70eece8deb712ab0c2394e66b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabel")
    def allowed_user_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieLabel"))

    @allowed_user_cookie_label.setter
    def allowed_user_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51a86a9fc9c8cef8d903aee579754073290a2eef2de98e9a995e95de4b318ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitle")
    def allowed_user_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieManagementTitle"))

    @allowed_user_cookie_management_title.setter
    def allowed_user_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ec5312d610a8fd5f650cb422860b1737b27b8fa27eb83917f38d595b7f0bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefresh")
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieRefresh"))

    @allowed_user_cookie_refresh.setter
    def allowed_user_cookie_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__693affdeb07e62ddd6b7c70759602d069726295653f6796b4b3b35bdb8cbc8b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSalt")
    def allowed_user_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieSalt"))

    @allowed_user_cookie_salt.setter
    def allowed_user_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__933c43bd324a670feafdb1e9a1cf85fddafdd29c2e45c34e15c505a77fe26088)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb383e75714d6e9afab63ef290fa667967a69efa82ed99dca3d1e03957330a8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20d9907f204467a5f5672d19a16f6cb689089f6d5c39d437d77e9ac0727a9a95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11af8b3f59efcd4242041365ea00b052c6cb0a7d85927c90d5aabadafdae20c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookie")
    def user_identification_by_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByCookie"))

    @user_identification_by_cookie.setter
    def user_identification_by_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f3a037951bcd21117cedfe7cfc9ec40ca1093f248c566ae2e26bc1e9cb72a05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeaders")
    def user_identification_by_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByHeaders"))

    @user_identification_by_headers.setter
    def user_identification_by_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540dc7d39e9001cb05e539ab22f0fc51700fdbbb67ad91302af66ba88f7ca684)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIp")
    def user_identification_by_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByIp"))

    @user_identification_by_ip.setter
    def user_identification_by_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cd60671973408ec09b2309c85dde3571e84b80073b47a2a4709806fcdc66b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByIp", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParams")
    def user_identification_by_params(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByParams"))

    @user_identification_by_params.setter
    def user_identification_by_params(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e3c50de26ca94591feb327713e3ace35865a10b6ea0b780a2cbbdf432effc8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookie")
    def user_identification_key_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationKeyCookie"))

    @user_identification_key_cookie.setter
    def user_identification_key_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82f7ec02256e49ef6ee98e322c172b51dc7df9d35bc23c6093948a9ddfe1e3c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeaders")
    def user_identification_key_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyHeaders"))

    @user_identification_key_headers.setter
    def user_identification_key_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4901163700cf457ad49bd91134da749b8b753947f000269640003621f147070c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParams")
    def user_identification_key_params(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyParams"))

    @user_identification_key_params.setter
    def user_identification_key_params(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d03bf9c73475260d971ea5ba2cfc58a52a2fe55acf91873c08f517bc2e04c876)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitle")
    def user_identification_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationTitle"))

    @user_identification_title.setter
    def user_identification_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__900a8e3176188337258ce346f2063809227f3d81ad00190de3216a74466ef5f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c6d0513a971dc940f8afc25b6b87267f0c962b39df425317413b2050c9a3e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtl")
    def waiting_room_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCacheTtl"))

    @waiting_room_cache_ttl.setter
    def waiting_room_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3b35d2f120b2e1f31c268acd80f5cd84dfd447a036dcaecdd7cf9fa5a269cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvanced")
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAdvanced"))

    @waiting_room_cookie_advanced.setter
    def waiting_room_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c267e7d01d821deed078f2e90c3a901ec3f12d0e39349071d0f4b8e2803fef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSalt")
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAutomaticSalt"))

    @waiting_room_cookie_automatic_salt.setter
    def waiting_room_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4997d9094af209ba54e7b16c26bf2b2013c2c2c479f174bd384735b6a0df57d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomain")
    def waiting_room_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomain"))

    @waiting_room_cookie_domain.setter
    def waiting_room_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef880e115865dd822e293d1c827df31538f162c2e27e3bbdeba16745cfa01a03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainType")
    def waiting_room_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomainType"))

    @waiting_room_cookie_domain_type.setter
    def waiting_room_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04467210c7c6f186311eecf592cd55bebac35405304353408521fc609bb64aba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDuration")
    def waiting_room_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCookieDuration"))

    @waiting_room_cookie_duration.setter
    def waiting_room_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d6efd592437535ae777ccada27ebd3448192059d158c6e977d282080d86f9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabled")
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieEnabled"))

    @waiting_room_cookie_enabled.setter
    def waiting_room_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b5c0c47a8a65e6b9b3b5886445c323104e63b940606dcf05dc6e93fdc8dfd8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnly")
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieHttpOnly"))

    @waiting_room_cookie_http_only.setter
    def waiting_room_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5e067c49e5a442cdb05ed2c2322d94b5b66ee7a42d66ca251da2076eb2ab0e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabel")
    def waiting_room_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieLabel"))

    @waiting_room_cookie_label.setter
    def waiting_room_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2945f2c883245d49989324603295ea4775f7745b71cc74080f6f36008857e911)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitle")
    def waiting_room_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieManagementTitle"))

    @waiting_room_cookie_management_title.setter
    def waiting_room_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311102ec4f55a86043f5af2d42e71c194a79e7ee7bfd066d36e20b8697f86dd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSalt")
    def waiting_room_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieSalt"))

    @waiting_room_cookie_salt.setter
    def waiting_room_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d0fde8007b4049027d43521282f772377d6c45c416432edbfa0f1dd4e1cd0aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabel")
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieShareLabel"))

    @waiting_room_cookie_share_label.setter
    def waiting_room_cookie_share_label(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cd13555b7146359bc13cfd2bac563c7fd43b66b5bce1f0ef791eb652a9c41a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieShareLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectory")
    def waiting_room_directory(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomDirectory"))

    @waiting_room_directory.setter
    def waiting_room_directory(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8f3c7d97b08583ad53533fa596a98873f65ab6d8190c6cd38c1ef2706b9f8bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitle")
    def waiting_room_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomManagementTitle"))

    @waiting_room_management_title.setter
    def waiting_room_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d41d9cf7cf9697cd0473ea6d19d485b548b3b21895e22fe3c32217731ae4833b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCode")
    def waiting_room_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomStatusCode"))

    @waiting_room_status_code.setter
    def waiting_room_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2bea504b7a0f7a3a754b9c7a974eca34a9194895353bce055d5ccacd2d2b1e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCode")
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomUseCpCode"))

    @waiting_room_use_cp_code.setter
    def waiting_room_use_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cfd14650b82cd665a28f818ab72bb4ebf758c6d94b48028f07cc2dd86341e40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomUseCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6d96f6f529dfbbaef6ad88572c0e74e62ab530c6edc125c9a6f0a00c06ab52a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__209430458b2c3ae209193043f98025dfd89c1db54101083299a094115f15c68b)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3599a106947e26c85856ac6bedf19819a4c50aa141b7a879399c317b8841bca3)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__974a027a1ab3c4ba2fb54cdb34bc80e2d7b9c50f77d87bfd86ee69b9e7e8bd0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7076cbed679cd1f4d10369eb177eea574845960547c9d2866c2988826d9fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d6c0e6089da2769f5486d6b422bbbb8e8a079b9d00b0ddc10ac5dfa6d44eed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54ca5772e788fb03e6839faa63c474292652431b5933e43bb1bd41ac31f5fe27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7707366a777520b34eb796460e56e0ef9515ae8c6423d868b90da42c2257b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b07a23edda11023bdc6e1162d62caabde02ca322420a14359e3de70fd09bf476)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d54defce0ab63b2014e683f8fb94c97ba05e79c4b85afee769997518d49c0480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6b947509b52fe8cdcfb30df659045dfd307f12da4d14aa48a7bd6151603640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08979f6fd10e47c57b1eaac8d8e8514024d4dbd334dafb8ea9797c591ec42149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777106a25377d743edcb7f833495d2ecb791aca87db7b4f97c2c30ded9c3f374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f9eaedf042b08eada12cd57ae1885f2e00f25c69f63541bf6b639df9fde511b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e4b79832be9eda98a40dcd0263ed9babf0e0807318f27c875e4c4e1b791018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27ff3cdb5bf196ac3f2f039ebfd494ac8e3fc11059cbc38a9aa88ded168a0560)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7358f54a733fd07490e586b1bfba6ba5b1ba5a18c176fb7e5017b15e438edee5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6366c0bc0e1418bfd338b45589f2a14fea058d12446b3537788216706eb2384e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c15ed454b1c4fd106214e5fbfa6332213447a7ccfa9df17df35a5fa8393cc81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88b721a625d1ad0df5bb0abdb9b0d39f03fa078ae55da48e50ccc43651d463d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__122c75d53cd7e16ce5847298eee0daa3e9804bf83e9a810e53aa3d932a763b36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking",
    jsii_struct_bases=[],
    name_mapping={
        "ab_variant_location": "abVariantLocation",
        "decryption_password1": "decryptionPassword1",
        "decryption_password2": "decryptionPassword2",
        "decryption_password_id1": "decryptionPasswordId1",
        "decryption_password_id2": "decryptionPasswordId2",
        "enable": "enable",
        "locked": "locked",
        "miscellaneous_settings_title": "miscellaneousSettingsTitle",
        "pattern_decryption_enable": "patternDecryptionEnable",
        "pattern_encryption_title": "patternEncryptionTitle",
        "signature_verification_enable": "signatureVerificationEnable",
        "template_uuid": "templateUuid",
        "token_signing_title": "tokenSigningTitle",
        "use_original_as_a": "useOriginalAsA",
        "uuid": "uuid",
        "verification_key_id1": "verificationKeyId1",
        "verification_key_id2": "verificationKeyId2",
        "verification_public_key1": "verificationPublicKey1",
        "verification_public_key2": "verificationPublicKey2",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking:
    def __init__(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6623180ba4364196ce694d959c6348d0177f07eecf291e91ef917e2f14401715)
            check_type(argname="argument ab_variant_location", value=ab_variant_location, expected_type=type_hints["ab_variant_location"])
            check_type(argname="argument decryption_password1", value=decryption_password1, expected_type=type_hints["decryption_password1"])
            check_type(argname="argument decryption_password2", value=decryption_password2, expected_type=type_hints["decryption_password2"])
            check_type(argname="argument decryption_password_id1", value=decryption_password_id1, expected_type=type_hints["decryption_password_id1"])
            check_type(argname="argument decryption_password_id2", value=decryption_password_id2, expected_type=type_hints["decryption_password_id2"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument miscellaneous_settings_title", value=miscellaneous_settings_title, expected_type=type_hints["miscellaneous_settings_title"])
            check_type(argname="argument pattern_decryption_enable", value=pattern_decryption_enable, expected_type=type_hints["pattern_decryption_enable"])
            check_type(argname="argument pattern_encryption_title", value=pattern_encryption_title, expected_type=type_hints["pattern_encryption_title"])
            check_type(argname="argument signature_verification_enable", value=signature_verification_enable, expected_type=type_hints["signature_verification_enable"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_signing_title", value=token_signing_title, expected_type=type_hints["token_signing_title"])
            check_type(argname="argument use_original_as_a", value=use_original_as_a, expected_type=type_hints["use_original_as_a"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_key_id1", value=verification_key_id1, expected_type=type_hints["verification_key_id1"])
            check_type(argname="argument verification_key_id2", value=verification_key_id2, expected_type=type_hints["verification_key_id2"])
            check_type(argname="argument verification_public_key1", value=verification_public_key1, expected_type=type_hints["verification_public_key1"])
            check_type(argname="argument verification_public_key2", value=verification_public_key2, expected_type=type_hints["verification_public_key2"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_variant_location is not None:
            self._values["ab_variant_location"] = ab_variant_location
        if decryption_password1 is not None:
            self._values["decryption_password1"] = decryption_password1
        if decryption_password2 is not None:
            self._values["decryption_password2"] = decryption_password2
        if decryption_password_id1 is not None:
            self._values["decryption_password_id1"] = decryption_password_id1
        if decryption_password_id2 is not None:
            self._values["decryption_password_id2"] = decryption_password_id2
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if miscellaneous_settings_title is not None:
            self._values["miscellaneous_settings_title"] = miscellaneous_settings_title
        if pattern_decryption_enable is not None:
            self._values["pattern_decryption_enable"] = pattern_decryption_enable
        if pattern_encryption_title is not None:
            self._values["pattern_encryption_title"] = pattern_encryption_title
        if signature_verification_enable is not None:
            self._values["signature_verification_enable"] = signature_verification_enable
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_signing_title is not None:
            self._values["token_signing_title"] = token_signing_title
        if use_original_as_a is not None:
            self._values["use_original_as_a"] = use_original_as_a
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_key_id1 is not None:
            self._values["verification_key_id1"] = verification_key_id1
        if verification_key_id2 is not None:
            self._values["verification_key_id2"] = verification_key_id2
        if verification_public_key1 is not None:
            self._values["verification_public_key1"] = verification_public_key1
        if verification_public_key2 is not None:
            self._values["verification_public_key2"] = verification_public_key2

    @builtins.property
    def ab_variant_location(self) -> typing.Optional[builtins.str]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        '''
        result = self._values.get("ab_variant_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password1(self) -> typing.Optional[builtins.str]:
        '''Provides the primary password used to encrypt patterns in your watermarking tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        '''
        result = self._values.get("decryption_password1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password2(self) -> typing.Optional[builtins.str]:
        '''Provides the secondary password you can use to rotate passwords.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        '''
        result = self._values.get("decryption_password2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a label that corresponds to the primary password.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        '''
        result = self._values.get("decryption_password_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        '''
        result = self._values.get("decryption_password_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the watermarking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def miscellaneous_settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        '''
        result = self._values.get("miscellaneous_settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def pattern_decryption_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        '''
        result = self._values.get("pattern_decryption_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pattern_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        '''
        result = self._values.get("pattern_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signature_verification_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can verify the signature in your watermarking token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        '''
        result = self._values.get("signature_verification_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_signing_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        '''
        result = self._values.get("token_signing_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_original_as_a(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        '''
        result = self._values.get("use_original_as_a")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the first public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        '''
        result = self._values.get("verification_key_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the optional second public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        '''
        result = self._values.get("verification_key_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key1(self) -> typing.Optional[builtins.str]:
        '''Specifies the first public key in its entirety.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        '''
        result = self._values.get("verification_public_key1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key2(self) -> typing.Optional[builtins.str]:
        '''Specifies the optional second public key in its entirety. Specify a second key to enable rotation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        result = self._values.get("verification_public_key2")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarkingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarkingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dda8a6fe9db90819dc15df9c39fb1acd5156a1287f00ed9fe8ee6bf4abb8227)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbVariantLocation")
    def reset_ab_variant_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbVariantLocation", []))

    @jsii.member(jsii_name="resetDecryptionPassword1")
    def reset_decryption_password1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword1", []))

    @jsii.member(jsii_name="resetDecryptionPassword2")
    def reset_decryption_password2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword2", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId1")
    def reset_decryption_password_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId1", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId2")
    def reset_decryption_password_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId2", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMiscellaneousSettingsTitle")
    def reset_miscellaneous_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMiscellaneousSettingsTitle", []))

    @jsii.member(jsii_name="resetPatternDecryptionEnable")
    def reset_pattern_decryption_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternDecryptionEnable", []))

    @jsii.member(jsii_name="resetPatternEncryptionTitle")
    def reset_pattern_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternEncryptionTitle", []))

    @jsii.member(jsii_name="resetSignatureVerificationEnable")
    def reset_signature_verification_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignatureVerificationEnable", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenSigningTitle")
    def reset_token_signing_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenSigningTitle", []))

    @jsii.member(jsii_name="resetUseOriginalAsA")
    def reset_use_original_as_a(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOriginalAsA", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationKeyId1")
    def reset_verification_key_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId1", []))

    @jsii.member(jsii_name="resetVerificationKeyId2")
    def reset_verification_key_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId2", []))

    @jsii.member(jsii_name="resetVerificationPublicKey1")
    def reset_verification_public_key1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey1", []))

    @jsii.member(jsii_name="resetVerificationPublicKey2")
    def reset_verification_public_key2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey2", []))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocationInput")
    def ab_variant_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abVariantLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1Input")
    def decryption_password1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2Input")
    def decryption_password2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword2Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1Input")
    def decryption_password_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2Input")
    def decryption_password_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId2Input"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitleInput")
    def miscellaneous_settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "miscellaneousSettingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnableInput")
    def pattern_decryption_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "patternDecryptionEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitleInput")
    def pattern_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "patternEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnableInput")
    def signature_verification_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "signatureVerificationEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitleInput")
    def token_signing_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenSigningTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsAInput")
    def use_original_as_a_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOriginalAsAInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1Input")
    def verification_key_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2Input")
    def verification_key_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId2Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1Input")
    def verification_public_key1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2Input")
    def verification_public_key2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey2Input"))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocation")
    def ab_variant_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abVariantLocation"))

    @ab_variant_location.setter
    def ab_variant_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__932f04ac4fe7fb6afd057d524ed2c9882cca7db1956d74a476699a201cce3b1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abVariantLocation", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1")
    def decryption_password1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword1"))

    @decryption_password1.setter
    def decryption_password1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83802d09f948c26bee5f195c0651c4cd71541ff9ae8cfa0b8c5c1514807f702b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2")
    def decryption_password2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword2"))

    @decryption_password2.setter
    def decryption_password2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7dd54ae6bbaa2d994581f507ebbdebd3f00ca465b934cf9708087f89daf3ee9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword2", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1")
    def decryption_password_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId1"))

    @decryption_password_id1.setter
    def decryption_password_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e061059db4c00224eab08647a85de939b0c7e48240e68edad1c17cb527e9587b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2")
    def decryption_password_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId2"))

    @decryption_password_id2.setter
    def decryption_password_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71082dfd2072b82945167ab2c874d73a9889ade78b11abb5e54613f27276ce6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId2", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f27384512f8d8332dbf6e3f169a2bb8b3ff0742839846e0a817a97f3246f57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11ba3fd4e4cabc219c1e02264b65d5d94f10f008a99d2630b682bf5450dd1b17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitle")
    def miscellaneous_settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "miscellaneousSettingsTitle"))

    @miscellaneous_settings_title.setter
    def miscellaneous_settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f3b0ced78f718978ac2fc2d765077be1912807af84b700c7b1a47774c15729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "miscellaneousSettingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnable")
    def pattern_decryption_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "patternDecryptionEnable"))

    @pattern_decryption_enable.setter
    def pattern_decryption_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec90debf7d35107946c052b5a1a4b8b5425b3e4cc9415aef9d78a2f19cc5676a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternDecryptionEnable", value)

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitle")
    def pattern_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "patternEncryptionTitle"))

    @pattern_encryption_title.setter
    def pattern_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba8474e1bbdd72af4c2459ad9d937f040c73ae183f8c4f54614121ef5d670c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnable")
    def signature_verification_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "signatureVerificationEnable"))

    @signature_verification_enable.setter
    def signature_verification_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__576514081fc34cf246853c47fc1e1e3489c33908ae313f866d18d19e26ec7462)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signatureVerificationEnable", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2b3069f4f73d3c605522578b68bc1668bfb5afaa6d54818c7d5e442ead3675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitle")
    def token_signing_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenSigningTitle"))

    @token_signing_title.setter
    def token_signing_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11becf5ae25be3015289cfb4654b68e985ce2dee5a2d4677a3924847d56025cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenSigningTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsA")
    def use_original_as_a(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOriginalAsA"))

    @use_original_as_a.setter
    def use_original_as_a(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be0b4b1c9748d62293c1864863f92f34c90e7bea6f543f94d3f4ad7da05f9c9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOriginalAsA", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48492aa40f4b75869e30b965f95da0e17a852dacc1ed415dd5f7ed225487a2b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1")
    def verification_key_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId1"))

    @verification_key_id1.setter
    def verification_key_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db6dac6d879647bdf214e9644884293aebc26b2d67860fd68f906fc2e9c1dfa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2")
    def verification_key_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId2"))

    @verification_key_id2.setter
    def verification_key_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ded6ad55a5ff4e3d5f884457887cf816548d93cb6d1e7d8423c4f9611a64543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId2", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1")
    def verification_public_key1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey1"))

    @verification_public_key1.setter
    def verification_public_key1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c085f939d5bc22fc8efe9d296562bbba4a063793161fe777ec009aad2ec814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2")
    def verification_public_key2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey2"))

    @verification_public_key2.setter
    def verification_public_key2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e807c53e3e3b72e75567b78105c301ca3e267f20f3533a39dcf127d6aec475e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey2", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4968346afad9206eeb53a372ece1d6a57a7730c9d307c0d8f0e430d73db1fa9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall",
    jsii_struct_bases=[],
    name_mapping={
        "firewall_configuration": "firewallConfiguration",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall:
    def __init__(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(firewall_configuration, dict):
            firewall_configuration = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration(**firewall_configuration)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89705212f4459c78121dbbe22f2b0aa79ab966517c91e69c7ee6da26eb073a50)
            check_type(argname="argument firewall_configuration", value=firewall_configuration, expected_type=type_hints["firewall_configuration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if firewall_configuration is not None:
            self._values["firewall_configuration"] = firewall_configuration
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def firewall_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration"]:
        '''firewall_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        '''
        result = self._values.get("firewall_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration"], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "config_id": "configId",
        "file_name": "fileName",
        "production_status": "productionStatus",
        "production_version": "productionVersion",
        "staging_status": "stagingStatus",
        "staging_version": "stagingVersion",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration:
    def __init__(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d82aa26353133fc46752931c309982c52ca060b4562c507067139e4c1dbde2b7)
            check_type(argname="argument config_id", value=config_id, expected_type=type_hints["config_id"])
            check_type(argname="argument file_name", value=file_name, expected_type=type_hints["file_name"])
            check_type(argname="argument production_status", value=production_status, expected_type=type_hints["production_status"])
            check_type(argname="argument production_version", value=production_version, expected_type=type_hints["production_version"])
            check_type(argname="argument staging_status", value=staging_status, expected_type=type_hints["staging_status"])
            check_type(argname="argument staging_version", value=staging_version, expected_type=type_hints["staging_version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_id is not None:
            self._values["config_id"] = config_id
        if file_name is not None:
            self._values["file_name"] = file_name
        if production_status is not None:
            self._values["production_status"] = production_status
        if production_version is not None:
            self._values["production_version"] = production_version
        if staging_status is not None:
            self._values["staging_status"] = staging_status
        if staging_version is not None:
            self._values["staging_version"] = staging_version

    @builtins.property
    def config_id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.'''
        result = self._values.get("config_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def file_name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        '''
        result = self._values.get("file_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        '''
        result = self._values.get("production_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        '''
        result = self._values.get("production_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def staging_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        '''
        result = self._values.get("staging_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def staging_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        result = self._values.get("staging_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa9e942520e3b0f9c14e27505fd227cd8ebb993a1cdeabf8c3d2b7400d929b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigId")
    def reset_config_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigId", []))

    @jsii.member(jsii_name="resetFileName")
    def reset_file_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileName", []))

    @jsii.member(jsii_name="resetProductionStatus")
    def reset_production_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionStatus", []))

    @jsii.member(jsii_name="resetProductionVersion")
    def reset_production_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionVersion", []))

    @jsii.member(jsii_name="resetStagingStatus")
    def reset_staging_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingStatus", []))

    @jsii.member(jsii_name="resetStagingVersion")
    def reset_staging_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingVersion", []))

    @builtins.property
    @jsii.member(jsii_name="configIdInput")
    def config_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "configIdInput"))

    @builtins.property
    @jsii.member(jsii_name="fileNameInput")
    def file_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fileNameInput"))

    @builtins.property
    @jsii.member(jsii_name="productionStatusInput")
    def production_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "productionStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="productionVersionInput")
    def production_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "productionVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingStatusInput")
    def staging_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stagingStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingVersionInput")
    def staging_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "stagingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="configId")
    def config_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "configId"))

    @config_id.setter
    def config_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27e9330930e8d28c07ff732d2dd18cf2ac349daa8de04e89b50cd5ff05e9989a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configId", value)

    @builtins.property
    @jsii.member(jsii_name="fileName")
    def file_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fileName"))

    @file_name.setter
    def file_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__944aba386f1e5a0abef1bbef186f0ae2b03da77e2b3c3c610b6de908621c5590)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fileName", value)

    @builtins.property
    @jsii.member(jsii_name="productionStatus")
    def production_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "productionStatus"))

    @production_status.setter
    def production_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef42aef1196a374a9b6dd3ff2a2497ea691b1418c73364c1cdaa174186392ae3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionStatus", value)

    @builtins.property
    @jsii.member(jsii_name="productionVersion")
    def production_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "productionVersion"))

    @production_version.setter
    def production_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfca760a505689880fc4d3fbf0e6f862d87fbf6ac38c6150e6a9bfca4f5f78e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionVersion", value)

    @builtins.property
    @jsii.member(jsii_name="stagingStatus")
    def staging_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stagingStatus"))

    @staging_status.setter
    def staging_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5caa5f8cd28c30fcdf1317e220e43bbd42d767f80f3b7493ed6eaeefaf4665a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingStatus", value)

    @builtins.property
    @jsii.member(jsii_name="stagingVersion")
    def staging_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "stagingVersion"))

    @staging_version.setter
    def staging_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c7db73850b0ef6c6356f6b3afe548f0bebecd3411b89e6406986ff5eecd469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaf18b4a2f3d6c905ed4fe4ed6d76baaa4caa3a8de798cd23852ccf52d5da518)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b403c7d3010865be7201f5baa9ee5612f31387c4edc1a56b25cef7b29a98dcc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFirewallConfiguration")
    def put_firewall_configuration(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration(
            config_id=config_id,
            file_name=file_name,
            production_status=production_status,
            production_version=production_version,
            staging_status=staging_status,
            staging_version=staging_version,
        )

        return typing.cast(None, jsii.invoke(self, "putFirewallConfiguration", [value]))

    @jsii.member(jsii_name="resetFirewallConfiguration")
    def reset_firewall_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirewallConfiguration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="firewallConfiguration")
    def firewall_configuration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfigurationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfigurationOutputReference, jsii.get(self, "firewallConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="firewallConfigurationInput")
    def firewall_configuration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "firewallConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a172160b1695aeb9e56d8d2782aa42684a1ace1d731f030c3adbbdc47b8ee3c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89add191a511c736b222a7da3de869838fcacca0a9587c118128d80cd863de0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edb7554d7b15d2ec0451510c0d5fb9155f05a54eb4f9992eec98fb7f11871718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae381a423cfdfa834d300e8688c160f6029c34cc177cbdc703c72fd1f6117cad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a292ce8ea85665511d64d1e9c1772ee6fa48fe618d0942c628dd496ee009c565)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables WebSocket traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSocketsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSocketsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c9e9908e861bc890897e421088d1f3c986781b385d316f209ac94fa860a181)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0ec04de100486eb858d4e81e680cfdcdaed68ea2f79d038710e5182b4394332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__647805858db91146960ee9377178cdc2ca04889180016f84e42123de7d11f383)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ba67efd04c11f09635376b85a54b2ac454bf764151458fc0e3fe7cca5fe853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa9469856e6b8960aae39f10ef525db4a71768d4e6a491d722c27c1d602c8ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4dd0590fcf4a1a45a410a03f298e60c5fd85d3812082740fc7bcb31ba5885e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3aab2398b8b7fdb54ed51799909d96efcf70f79f5ad80745b16c478eada1afd)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the WebDAV behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdavOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdavOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb643adedb472520dec5dbbcf4c00c01fb542ccb70d6af7cbcbc4984358b0c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3473c9a0fc6cc572626b417ec1a796597cbf98458e6d613810cf672f4bea878)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3552ba39b0f2fc3b65c062f1dee516e79018cd7ae0927a3937f22c7e5e4205df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f22e25e664af32173fa6451b48b1d7233b80b1a4bed9c028f38dfea0bf914e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5e21fee0386f07807f67e4a04a59561330f917737f17ae82cc68ea5b406ac45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141146e80b58a75392fd1981d6534d524640b85dbb320021f8008aff5c0faa68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030Criterion",
    jsii_struct_bases=[],
    name_mapping={
        "advanced_im_match": "advancedImMatch",
        "bucket": "bucket",
        "cacheability": "cacheability",
        "china_cdn_region": "chinaCdnRegion",
        "client_certificate": "clientCertificate",
        "client_ip": "clientIp",
        "client_ip_version": "clientIpVersion",
        "cloudlets_origin": "cloudletsOrigin",
        "content_delivery_network": "contentDeliveryNetwork",
        "content_type": "contentType",
        "device_characteristic": "deviceCharacteristic",
        "ecmd_auth_groups": "ecmdAuthGroups",
        "ecmd_auth_scheme": "ecmdAuthScheme",
        "ecmd_is_authenticated": "ecmdIsAuthenticated",
        "ecmd_username": "ecmdUsername",
        "edge_workers_failure": "edgeWorkersFailure",
        "file_extension": "fileExtension",
        "filename": "filename",
        "hostname": "hostname",
        "match_advanced": "matchAdvanced",
        "match_cp_code": "matchCpCode",
        "match_response_code": "matchResponseCode",
        "match_variable": "matchVariable",
        "metadata_stage": "metadataStage",
        "origin_timeout": "originTimeout",
        "path": "path",
        "query_string_parameter": "queryStringParameter",
        "random": "random",
        "recovery_config": "recoveryConfig",
        "regular_expression": "regularExpression",
        "request_cookie": "requestCookie",
        "request_header": "requestHeader",
        "request_method": "requestMethod",
        "request_protocol": "requestProtocol",
        "request_type": "requestType",
        "response_header": "responseHeader",
        "server_location": "serverLocation",
        "time": "time",
        "token_authorization": "tokenAuthorization",
        "user_agent": "userAgent",
        "user_location": "userLocation",
        "user_network": "userNetwork",
        "variable_error": "variableError",
        "virtual_waiting_room_request": "virtualWaitingRoomRequest",
        "visitor_prioritization_request": "visitorPrioritizationRequest",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030Criterion:
    def __init__(
        self,
        *,
        advanced_im_match: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch", typing.Dict[builtins.str, typing.Any]]] = None,
        bucket: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket", typing.Dict[builtins.str, typing.Any]]] = None,
        cacheability: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability", typing.Dict[builtins.str, typing.Any]]] = None,
        china_cdn_region: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip_version: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlets_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        content_delivery_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        content_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_scheme: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_is_authenticated: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_username: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_workers_failure: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure", typing.Dict[builtins.str, typing.Any]]] = None,
        file_extension: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension", typing.Dict[builtins.str, typing.Any]]] = None,
        filename: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename", typing.Dict[builtins.str, typing.Any]]] = None,
        hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        match_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        match_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_stage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        path: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath", typing.Dict[builtins.str, typing.Any]]] = None,
        query_string_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        random: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom", typing.Dict[builtins.str, typing.Any]]] = None,
        recovery_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        regular_expression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression", typing.Dict[builtins.str, typing.Any]]] = None,
        request_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        request_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        request_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType", typing.Dict[builtins.str, typing.Any]]] = None,
        response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        server_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        time: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime", typing.Dict[builtins.str, typing.Any]]] = None,
        token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        user_agent: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent", typing.Dict[builtins.str, typing.Any]]] = None,
        user_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        user_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        variable_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param advanced_im_match: advanced_im_match block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        :param bucket: bucket block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param cacheability: cacheability block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        :param china_cdn_region: china_cdn_region block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        :param client_certificate: client_certificate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        :param client_ip: client_ip block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        :param client_ip_version: client_ip_version block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        :param cloudlets_origin: cloudlets_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        :param content_delivery_network: content_delivery_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        :param content_type: content_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param device_characteristic: device_characteristic block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        :param ecmd_auth_groups: ecmd_auth_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        :param ecmd_auth_scheme: ecmd_auth_scheme block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        :param ecmd_is_authenticated: ecmd_is_authenticated block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        :param ecmd_username: ecmd_username block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        :param edge_workers_failure: edge_workers_failure block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        :param file_extension: file_extension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        :param filename: filename block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        :param hostname: hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param match_advanced: match_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        :param match_cp_code: match_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        :param match_response_code: match_response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        :param match_variable: match_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        :param metadata_stage: metadata_stage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        :param origin_timeout: origin_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        :param path: path block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param query_string_parameter: query_string_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        :param random: random block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        :param recovery_config: recovery_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        :param regular_expression: regular_expression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        :param request_cookie: request_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        :param request_header: request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        :param request_method: request_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        :param request_protocol: request_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        :param request_type: request_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param response_header: response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        :param server_location: server_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        :param time: time block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        :param token_authorization: token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param user_agent: user_agent block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        :param user_location: user_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        :param user_network: user_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        :param variable_error: variable_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        :param virtual_waiting_room_request: virtual_waiting_room_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        :param visitor_prioritization_request: visitor_prioritization_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        if isinstance(advanced_im_match, dict):
            advanced_im_match = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch(**advanced_im_match)
        if isinstance(bucket, dict):
            bucket = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket(**bucket)
        if isinstance(cacheability, dict):
            cacheability = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability(**cacheability)
        if isinstance(china_cdn_region, dict):
            china_cdn_region = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion(**china_cdn_region)
        if isinstance(client_certificate, dict):
            client_certificate = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate(**client_certificate)
        if isinstance(client_ip, dict):
            client_ip = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp(**client_ip)
        if isinstance(client_ip_version, dict):
            client_ip_version = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion(**client_ip_version)
        if isinstance(cloudlets_origin, dict):
            cloudlets_origin = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin(**cloudlets_origin)
        if isinstance(content_delivery_network, dict):
            content_delivery_network = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork(**content_delivery_network)
        if isinstance(content_type, dict):
            content_type = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType(**content_type)
        if isinstance(device_characteristic, dict):
            device_characteristic = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic(**device_characteristic)
        if isinstance(ecmd_auth_groups, dict):
            ecmd_auth_groups = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups(**ecmd_auth_groups)
        if isinstance(ecmd_auth_scheme, dict):
            ecmd_auth_scheme = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme(**ecmd_auth_scheme)
        if isinstance(ecmd_is_authenticated, dict):
            ecmd_is_authenticated = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated(**ecmd_is_authenticated)
        if isinstance(ecmd_username, dict):
            ecmd_username = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername(**ecmd_username)
        if isinstance(edge_workers_failure, dict):
            edge_workers_failure = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure(**edge_workers_failure)
        if isinstance(file_extension, dict):
            file_extension = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension(**file_extension)
        if isinstance(filename, dict):
            filename = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename(**filename)
        if isinstance(hostname, dict):
            hostname = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname(**hostname)
        if isinstance(match_advanced, dict):
            match_advanced = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced(**match_advanced)
        if isinstance(match_cp_code, dict):
            match_cp_code = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode(**match_cp_code)
        if isinstance(match_response_code, dict):
            match_response_code = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode(**match_response_code)
        if isinstance(match_variable, dict):
            match_variable = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable(**match_variable)
        if isinstance(metadata_stage, dict):
            metadata_stage = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage(**metadata_stage)
        if isinstance(origin_timeout, dict):
            origin_timeout = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout(**origin_timeout)
        if isinstance(path, dict):
            path = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath(**path)
        if isinstance(query_string_parameter, dict):
            query_string_parameter = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter(**query_string_parameter)
        if isinstance(random, dict):
            random = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom(**random)
        if isinstance(recovery_config, dict):
            recovery_config = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig(**recovery_config)
        if isinstance(regular_expression, dict):
            regular_expression = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression(**regular_expression)
        if isinstance(request_cookie, dict):
            request_cookie = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie(**request_cookie)
        if isinstance(request_header, dict):
            request_header = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader(**request_header)
        if isinstance(request_method, dict):
            request_method = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod(**request_method)
        if isinstance(request_protocol, dict):
            request_protocol = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol(**request_protocol)
        if isinstance(request_type, dict):
            request_type = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType(**request_type)
        if isinstance(response_header, dict):
            response_header = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader(**response_header)
        if isinstance(server_location, dict):
            server_location = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation(**server_location)
        if isinstance(time, dict):
            time = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime(**time)
        if isinstance(token_authorization, dict):
            token_authorization = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization(**token_authorization)
        if isinstance(user_agent, dict):
            user_agent = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent(**user_agent)
        if isinstance(user_location, dict):
            user_location = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation(**user_location)
        if isinstance(user_network, dict):
            user_network = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork(**user_network)
        if isinstance(variable_error, dict):
            variable_error = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError(**variable_error)
        if isinstance(virtual_waiting_room_request, dict):
            virtual_waiting_room_request = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest(**virtual_waiting_room_request)
        if isinstance(visitor_prioritization_request, dict):
            visitor_prioritization_request = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest(**visitor_prioritization_request)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d490beb6f5b26f7246ef9285a90c6838f5f61608138dc10735803b02ff902dc2)
            check_type(argname="argument advanced_im_match", value=advanced_im_match, expected_type=type_hints["advanced_im_match"])
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument cacheability", value=cacheability, expected_type=type_hints["cacheability"])
            check_type(argname="argument china_cdn_region", value=china_cdn_region, expected_type=type_hints["china_cdn_region"])
            check_type(argname="argument client_certificate", value=client_certificate, expected_type=type_hints["client_certificate"])
            check_type(argname="argument client_ip", value=client_ip, expected_type=type_hints["client_ip"])
            check_type(argname="argument client_ip_version", value=client_ip_version, expected_type=type_hints["client_ip_version"])
            check_type(argname="argument cloudlets_origin", value=cloudlets_origin, expected_type=type_hints["cloudlets_origin"])
            check_type(argname="argument content_delivery_network", value=content_delivery_network, expected_type=type_hints["content_delivery_network"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument device_characteristic", value=device_characteristic, expected_type=type_hints["device_characteristic"])
            check_type(argname="argument ecmd_auth_groups", value=ecmd_auth_groups, expected_type=type_hints["ecmd_auth_groups"])
            check_type(argname="argument ecmd_auth_scheme", value=ecmd_auth_scheme, expected_type=type_hints["ecmd_auth_scheme"])
            check_type(argname="argument ecmd_is_authenticated", value=ecmd_is_authenticated, expected_type=type_hints["ecmd_is_authenticated"])
            check_type(argname="argument ecmd_username", value=ecmd_username, expected_type=type_hints["ecmd_username"])
            check_type(argname="argument edge_workers_failure", value=edge_workers_failure, expected_type=type_hints["edge_workers_failure"])
            check_type(argname="argument file_extension", value=file_extension, expected_type=type_hints["file_extension"])
            check_type(argname="argument filename", value=filename, expected_type=type_hints["filename"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument match_advanced", value=match_advanced, expected_type=type_hints["match_advanced"])
            check_type(argname="argument match_cp_code", value=match_cp_code, expected_type=type_hints["match_cp_code"])
            check_type(argname="argument match_response_code", value=match_response_code, expected_type=type_hints["match_response_code"])
            check_type(argname="argument match_variable", value=match_variable, expected_type=type_hints["match_variable"])
            check_type(argname="argument metadata_stage", value=metadata_stage, expected_type=type_hints["metadata_stage"])
            check_type(argname="argument origin_timeout", value=origin_timeout, expected_type=type_hints["origin_timeout"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument query_string_parameter", value=query_string_parameter, expected_type=type_hints["query_string_parameter"])
            check_type(argname="argument random", value=random, expected_type=type_hints["random"])
            check_type(argname="argument recovery_config", value=recovery_config, expected_type=type_hints["recovery_config"])
            check_type(argname="argument regular_expression", value=regular_expression, expected_type=type_hints["regular_expression"])
            check_type(argname="argument request_cookie", value=request_cookie, expected_type=type_hints["request_cookie"])
            check_type(argname="argument request_header", value=request_header, expected_type=type_hints["request_header"])
            check_type(argname="argument request_method", value=request_method, expected_type=type_hints["request_method"])
            check_type(argname="argument request_protocol", value=request_protocol, expected_type=type_hints["request_protocol"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument response_header", value=response_header, expected_type=type_hints["response_header"])
            check_type(argname="argument server_location", value=server_location, expected_type=type_hints["server_location"])
            check_type(argname="argument time", value=time, expected_type=type_hints["time"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument user_agent", value=user_agent, expected_type=type_hints["user_agent"])
            check_type(argname="argument user_location", value=user_location, expected_type=type_hints["user_location"])
            check_type(argname="argument user_network", value=user_network, expected_type=type_hints["user_network"])
            check_type(argname="argument variable_error", value=variable_error, expected_type=type_hints["variable_error"])
            check_type(argname="argument virtual_waiting_room_request", value=virtual_waiting_room_request, expected_type=type_hints["virtual_waiting_room_request"])
            check_type(argname="argument visitor_prioritization_request", value=visitor_prioritization_request, expected_type=type_hints["visitor_prioritization_request"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced_im_match is not None:
            self._values["advanced_im_match"] = advanced_im_match
        if bucket is not None:
            self._values["bucket"] = bucket
        if cacheability is not None:
            self._values["cacheability"] = cacheability
        if china_cdn_region is not None:
            self._values["china_cdn_region"] = china_cdn_region
        if client_certificate is not None:
            self._values["client_certificate"] = client_certificate
        if client_ip is not None:
            self._values["client_ip"] = client_ip
        if client_ip_version is not None:
            self._values["client_ip_version"] = client_ip_version
        if cloudlets_origin is not None:
            self._values["cloudlets_origin"] = cloudlets_origin
        if content_delivery_network is not None:
            self._values["content_delivery_network"] = content_delivery_network
        if content_type is not None:
            self._values["content_type"] = content_type
        if device_characteristic is not None:
            self._values["device_characteristic"] = device_characteristic
        if ecmd_auth_groups is not None:
            self._values["ecmd_auth_groups"] = ecmd_auth_groups
        if ecmd_auth_scheme is not None:
            self._values["ecmd_auth_scheme"] = ecmd_auth_scheme
        if ecmd_is_authenticated is not None:
            self._values["ecmd_is_authenticated"] = ecmd_is_authenticated
        if ecmd_username is not None:
            self._values["ecmd_username"] = ecmd_username
        if edge_workers_failure is not None:
            self._values["edge_workers_failure"] = edge_workers_failure
        if file_extension is not None:
            self._values["file_extension"] = file_extension
        if filename is not None:
            self._values["filename"] = filename
        if hostname is not None:
            self._values["hostname"] = hostname
        if match_advanced is not None:
            self._values["match_advanced"] = match_advanced
        if match_cp_code is not None:
            self._values["match_cp_code"] = match_cp_code
        if match_response_code is not None:
            self._values["match_response_code"] = match_response_code
        if match_variable is not None:
            self._values["match_variable"] = match_variable
        if metadata_stage is not None:
            self._values["metadata_stage"] = metadata_stage
        if origin_timeout is not None:
            self._values["origin_timeout"] = origin_timeout
        if path is not None:
            self._values["path"] = path
        if query_string_parameter is not None:
            self._values["query_string_parameter"] = query_string_parameter
        if random is not None:
            self._values["random"] = random
        if recovery_config is not None:
            self._values["recovery_config"] = recovery_config
        if regular_expression is not None:
            self._values["regular_expression"] = regular_expression
        if request_cookie is not None:
            self._values["request_cookie"] = request_cookie
        if request_header is not None:
            self._values["request_header"] = request_header
        if request_method is not None:
            self._values["request_method"] = request_method
        if request_protocol is not None:
            self._values["request_protocol"] = request_protocol
        if request_type is not None:
            self._values["request_type"] = request_type
        if response_header is not None:
            self._values["response_header"] = response_header
        if server_location is not None:
            self._values["server_location"] = server_location
        if time is not None:
            self._values["time"] = time
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if user_agent is not None:
            self._values["user_agent"] = user_agent
        if user_location is not None:
            self._values["user_location"] = user_location
        if user_network is not None:
            self._values["user_network"] = user_network
        if variable_error is not None:
            self._values["variable_error"] = variable_error
        if virtual_waiting_room_request is not None:
            self._values["virtual_waiting_room_request"] = virtual_waiting_room_request
        if visitor_prioritization_request is not None:
            self._values["visitor_prioritization_request"] = visitor_prioritization_request

    @builtins.property
    def advanced_im_match(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch"]:
        '''advanced_im_match block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        '''
        result = self._values.get("advanced_im_match")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch"], result)

    @builtins.property
    def bucket(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket"]:
        '''bucket block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket"], result)

    @builtins.property
    def cacheability(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability"]:
        '''cacheability block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        '''
        result = self._values.get("cacheability")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability"], result)

    @builtins.property
    def china_cdn_region(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion"]:
        '''china_cdn_region block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        '''
        result = self._values.get("china_cdn_region")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion"], result)

    @builtins.property
    def client_certificate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate"]:
        '''client_certificate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        '''
        result = self._values.get("client_certificate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate"], result)

    @builtins.property
    def client_ip(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp"]:
        '''client_ip block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        '''
        result = self._values.get("client_ip")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp"], result)

    @builtins.property
    def client_ip_version(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion"]:
        '''client_ip_version block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        '''
        result = self._values.get("client_ip_version")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion"], result)

    @builtins.property
    def cloudlets_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin"]:
        '''cloudlets_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        '''
        result = self._values.get("cloudlets_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin"], result)

    @builtins.property
    def content_delivery_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork"]:
        '''content_delivery_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        '''
        result = self._values.get("content_delivery_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork"], result)

    @builtins.property
    def content_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType"]:
        '''content_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType"], result)

    @builtins.property
    def device_characteristic(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic"]:
        '''device_characteristic block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        '''
        result = self._values.get("device_characteristic")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic"], result)

    @builtins.property
    def ecmd_auth_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups"]:
        '''ecmd_auth_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        '''
        result = self._values.get("ecmd_auth_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups"], result)

    @builtins.property
    def ecmd_auth_scheme(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme"]:
        '''ecmd_auth_scheme block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        '''
        result = self._values.get("ecmd_auth_scheme")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme"], result)

    @builtins.property
    def ecmd_is_authenticated(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated"]:
        '''ecmd_is_authenticated block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        '''
        result = self._values.get("ecmd_is_authenticated")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated"], result)

    @builtins.property
    def ecmd_username(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername"]:
        '''ecmd_username block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        '''
        result = self._values.get("ecmd_username")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername"], result)

    @builtins.property
    def edge_workers_failure(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure"]:
        '''edge_workers_failure block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        '''
        result = self._values.get("edge_workers_failure")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure"], result)

    @builtins.property
    def file_extension(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension"]:
        '''file_extension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        '''
        result = self._values.get("file_extension")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension"], result)

    @builtins.property
    def filename(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename"]:
        '''filename block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        '''
        result = self._values.get("filename")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename"], result)

    @builtins.property
    def hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname"]:
        '''hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname"], result)

    @builtins.property
    def match_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced"]:
        '''match_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        '''
        result = self._values.get("match_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced"], result)

    @builtins.property
    def match_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode"]:
        '''match_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        '''
        result = self._values.get("match_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode"], result)

    @builtins.property
    def match_response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode"]:
        '''match_response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        '''
        result = self._values.get("match_response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode"], result)

    @builtins.property
    def match_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable"]:
        '''match_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        '''
        result = self._values.get("match_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable"], result)

    @builtins.property
    def metadata_stage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage"]:
        '''metadata_stage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        '''
        result = self._values.get("metadata_stage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage"], result)

    @builtins.property
    def origin_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout"]:
        '''origin_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        '''
        result = self._values.get("origin_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout"], result)

    @builtins.property
    def path(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath"]:
        '''path block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath"], result)

    @builtins.property
    def query_string_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter"]:
        '''query_string_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        '''
        result = self._values.get("query_string_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter"], result)

    @builtins.property
    def random(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom"]:
        '''random block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        '''
        result = self._values.get("random")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom"], result)

    @builtins.property
    def recovery_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig"]:
        '''recovery_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        '''
        result = self._values.get("recovery_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig"], result)

    @builtins.property
    def regular_expression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression"]:
        '''regular_expression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        '''
        result = self._values.get("regular_expression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression"], result)

    @builtins.property
    def request_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie"]:
        '''request_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        '''
        result = self._values.get("request_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie"], result)

    @builtins.property
    def request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader"]:
        '''request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        '''
        result = self._values.get("request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader"], result)

    @builtins.property
    def request_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod"]:
        '''request_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        '''
        result = self._values.get("request_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod"], result)

    @builtins.property
    def request_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol"]:
        '''request_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        '''
        result = self._values.get("request_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol"], result)

    @builtins.property
    def request_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType"]:
        '''request_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType"], result)

    @builtins.property
    def response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader"]:
        '''response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        '''
        result = self._values.get("response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader"], result)

    @builtins.property
    def server_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation"]:
        '''server_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        '''
        result = self._values.get("server_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation"], result)

    @builtins.property
    def time(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime"]:
        '''time block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        '''
        result = self._values.get("time")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime"], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization"]:
        '''token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization"], result)

    @builtins.property
    def user_agent(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent"]:
        '''user_agent block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        '''
        result = self._values.get("user_agent")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent"], result)

    @builtins.property
    def user_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation"]:
        '''user_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        '''
        result = self._values.get("user_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation"], result)

    @builtins.property
    def user_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork"]:
        '''user_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        '''
        result = self._values.get("user_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork"], result)

    @builtins.property
    def variable_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError"]:
        '''variable_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        '''
        result = self._values.get("variable_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError"], result)

    @builtins.property
    def virtual_waiting_room_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest"]:
        '''virtual_waiting_room_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        '''
        result = self._values.get("virtual_waiting_room_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest"], result)

    @builtins.property
    def visitor_prioritization_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest"]:
        '''visitor_prioritization_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        result = self._values.get("visitor_prioritization_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030Criterion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a31033154711b2cf13f66c426cebcc637fe5e0ef7ddfc4adfa22741232117f8)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8104279d864683163cd10286745d97d6e2f769dea6a4ba2bbd8811e33a3062f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4efd15f82c86c8cf6177420c6199fbcb902863922e3c5492d39cf7ae73bcb7c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd1fdee66d57b135297178689616a2d015a8060c6245e0eb88e951608cb6105c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb102aa2a0f55d741efa5e84143e4875322ba78e0b0f991a80fbb214490297bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3157ff50248fbbc5bb419161eac7f9033d62430a0d03ad8b2de0fd1def753335)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14b0099df8ba6f160e1e9f8c1c4442d001898bf33e7fcfb8b709356308493e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b89fd7b44b555bcecdc64c7ec89bd1eab887f12da01af57e35aad7c833e4ed18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "percentage": "percentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ca7b25da5c9673d935c222f4df940571a0bf9cb3da65286a446152bfcb6bda)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument percentage", value=percentage, expected_type=type_hints["percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if percentage is not None:
            self._values["percentage"] = percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of requests to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        '''
        result = self._values.get("percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucketOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucketOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd6535018e260cc25d72b73edb8156e20447cfe6d9c190d5e3d05df72510ffa5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPercentage")
    def reset_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="percentageInput")
    def percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "percentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7483952e45536a6b6096b9bc1b9c10357c4ac454b52baa9fb9b787776e2e64a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="percentage")
    def percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "percentage"))

    @percentage.setter
    def percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b75b8d7645fbb06bd2408d83f0023376e71670338174341c020b07b0dae8ab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "percentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3fe4094241ca466094aad373ca6d487059b37ae2e7e31a7e840728c5ddcfbde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c725d73b38d636b6ec298a8bc97b013c02aac7ac359da76944e1f1469e1e5a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8faefc9056614236ea712f809712f0e7cd2594a32e4d7a6915b6e2226787d1e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4abb18381b1f3f9ef6b70e3dbcb4b75f1b2b207227b678263fe5b8d996ccdf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheabilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheabilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d282e4deaf89f7f0bfc1cc20871922d8d20c100640d6dd6b8216d6c6df9fcbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd23afbdfbf9bc2e6a7db276794b490194b32d022e984e72d78b0aacafa08644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e284b2cd3968753d934004557d082eccf6b3d3cad0796617c6aaa5189201157b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68785ad3b8a4cf2767dbb8388dcac4c512ccc57034fed6c4ed839785c7c2e7cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba7ff5077806bd8e834a0445cb42135bb3b05cc801e41ad21ac6903fb4f3223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d25c3ad033d4e0e17887f5605dd4d483b71cbf60f69694a93409ebfad8e65e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d1aae957fdf9178d4c3def3c1842b4945e0bb1923ef9d852184079c70143869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a108e11c047791f9cded70770a9fc245e47c3cfb538ebe1a302119529a0abe4)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf88a358207672845a8b3a0909889040e0385a52ca1a7b9d641c4e8549a2f721)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__848064746fc3d9c56826833025e503229c7df371ca8b546614774bed199f5f02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c8064690d61a3334c89247ab0dd2ee2ad38dea7c665e44646b5941d5f9ee2af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f02408bad03af7f1c3383c2de51fd6f023c4f086ce834e44b6778ecafee8a32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ded68bce45082eb6812b4f27d7e827c5ccc8fa6ad30b67d57cda4a1154cc8841)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc9b63a89edd878dfaedd4acce6885aab11fd078c72a26c0567e38532753822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate",
    jsii_struct_bases=[],
    name_mapping={
        "enforce_mtls": "enforceMtls",
        "is_certificate_present": "isCertificatePresent",
        "is_certificate_valid": "isCertificateValid",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate:
    def __init__(
        self,
        *,
        enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enforce_mtls: Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail. Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fc2017f73615f99e490f54b636f531c279f1e3556e86d5979ab5d9517185f87)
            check_type(argname="argument enforce_mtls", value=enforce_mtls, expected_type=type_hints["enforce_mtls"])
            check_type(argname="argument is_certificate_present", value=is_certificate_present, expected_type=type_hints["is_certificate_present"])
            check_type(argname="argument is_certificate_valid", value=is_certificate_valid, expected_type=type_hints["is_certificate_valid"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enforce_mtls is not None:
            self._values["enforce_mtls"] = enforce_mtls
        if is_certificate_present is not None:
            self._values["is_certificate_present"] = is_certificate_present
        if is_certificate_valid is not None:
            self._values["is_certificate_valid"] = is_certificate_valid
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enforce_mtls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail.

        Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        '''
        result = self._values.get("enforce_mtls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_present(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Executes rule behaviors only if a client certificate authenticates requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        '''
        result = self._values.get("is_certificate_present")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_valid(self) -> typing.Optional[builtins.str]:
        '''Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        '''
        result = self._values.get("is_certificate_valid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__666416996629ebad04e3202b99c687def77661702a0802832d0eddf33263d04f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnforceMtls")
    def reset_enforce_mtls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnforceMtls", []))

    @jsii.member(jsii_name="resetIsCertificatePresent")
    def reset_is_certificate_present(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificatePresent", []))

    @jsii.member(jsii_name="resetIsCertificateValid")
    def reset_is_certificate_valid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateValid", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsInput")
    def enforce_mtls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enforceMtlsInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresentInput")
    def is_certificate_present_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificatePresentInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateValidInput")
    def is_certificate_valid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "isCertificateValidInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtls")
    def enforce_mtls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enforceMtls"))

    @enforce_mtls.setter
    def enforce_mtls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8ef36157e69e96b560b676df6e1512f0a1d43746e6e20c916de0dc770d683da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enforceMtls", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresent")
    def is_certificate_present(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificatePresent"))

    @is_certificate_present.setter
    def is_certificate_present(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b26c1942d8c4d364f599ca6ac3deb22a69c41cfd792dc191d8accc148d663b9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificatePresent", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateValid")
    def is_certificate_valid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "isCertificateValid"))

    @is_certificate_valid.setter
    def is_certificate_valid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac2a82f3d78345bc5ab1c512cbab70ea36296f606ce117f5221e867c7ba2932)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateValid", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a82b515e1f8f4df7e9361d419a16bac83458cba9ab19b746bc7d4c4f780f3a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59138c79fbec30cf2dbcafa494fe477ec1e52299f006ee1d5ed8723e1f2c5f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b15daee425c2bff3237fa1c99856227e61a83739629e42a02fcc24d269e91543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42a76d2700c986811da3b386144ed79fc61d0051e0bc9d9694e04c071a4f53b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "use_headers": "useHeaders",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2724189a38b144f7204e2f5924d882067758787fd38fa3fc87203d2663ed4f16)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_headers", value=use_headers, expected_type=type_hints["use_headers"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_headers is not None:
            self._values["use_headers"] = use_headers
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        '''
        result = self._values.get("use_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''IP or CIDR block, for example: ``71.92.0.0/14``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6920212ecc1ced508db64d13a2b22ccf4e1883ad744877fb870da2cd8378e26)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHeaders")
    def reset_use_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHeaders", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHeadersInput")
    def use_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__123800315608a59cc6da6103fb0baac2fab5121dd0f2088a1b1a07691a813925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3d59be4ce53bbb52597df4ba6a1a8011e41953bf8d42736e39822e199b0c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ab9d37d6af18cecc70bd59baad544d3c61e0a1785117209769b8a9d581fa05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHeaders")
    def use_headers(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHeaders"))

    @use_headers.setter
    def use_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d89fdfa3ad00ccea0dcab60902de2d5ebccd03c3673eb851091a980024052add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d182f3bb59f30bfa01f346e0f45b3bc557a916019007611ccc0364121dee9a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d713cb867b186568680fa98342adddc5b460b124fd427c72ee34efe9e08c4393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cca9476be7de375aaf31b3c39aad351e990688a6c6638f8a2d6f6e82d175c71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_x_forwarded_for": "useXForwardedFor",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0cabe36408ac23d4248eaaad31ca3d4ca9752e54a57e59a6603480f03740124)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_x_forwarded_for", value=use_x_forwarded_for, expected_type=type_hints["use_x_forwarded_for"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_x_forwarded_for is not None:
            self._values["use_x_forwarded_for"] = use_x_forwarded_for
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        '''
        result = self._values.get("use_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The IP version of the client request, either ``IPV4`` or ``IPV6``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47f394d2fc787751d942300fbf483838f55448f634ff3ee8befbf8bd0c79c4d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseXForwardedFor")
    def reset_use_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseXForwardedFor", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useXForwardedForInput")
    def use_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__385e93e45810fa090253ff440b7f0584b80f2d18f7dad35bab8fee80fa4c71a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588091535501667244b7327e453c4246ef9e67dbfe6c4604e88a2a69d64f7049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useXForwardedFor")
    def use_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useXForwardedFor"))

    @use_x_forwarded_for.setter
    def use_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36309b1fdb868a1208a94a6479bee65622ad368b5fd5f9d95f43dff73e73743a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3159f2892108fe48fda9e533ca16b090f7f20c0bbb0f470982b90f801ee282)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48323869985b42d04eec957c1e0872fad05c8e88b01c8e010197fd8e5b95686a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff841a92f4331428a227f376e49dbf3468793a1d3f7aa5ea53856c13887665c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5455aef6c1a1ab7641c6bf03ea9777292ca80e085083a72b7abaafcac1a578f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''The Cloudlets Origins identifier, limited to alphanumeric and underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79c9306160c2d581b206ba509ed4c5157570b2a0eef6eaddc46aca3cb53f0fcd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6daa2f430fddb3da3fbe4b96537be7047fb6276d664fb1f8fae8de80c52ba9e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4b149b70bb2792bf7d42935eaa3042acf533306df687134260d61cf2134c61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb5633ee882abf54f7cce056684b6c88bef394baa697c33bb303bbe362ff9654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9edb1b3a027bfb162b973b5e14ff20e3947510359dddeba3dbd1bff474479240)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__261e8c492c07758f2e9693b9249d199986904024940d22aecfc9f592bbd03b64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "network": "network",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff2cee1c3df8410c32bf463e40af6b5e461d2b75f8843c5a25f9ec98d5813a34)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network", value=network, expected_type=type_hints["network"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network is not None:
            self._values["network"] = network
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network(self) -> typing.Optional[builtins.str]:
        '''Match the network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        '''
        result = self._values.get("network")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__940cfd10d635de2477a28f0c64df6a1975a2cf459932ddf536ab71e11045635b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetwork")
    def reset_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetwork", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkInput")
    def network_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "networkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbea5c519f2ee40c477b3d7f6fd7d3d4cd7783c8e68e916449dd502c6854a45a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeb458f43a4a3451592318353ad009040b021cc6bbf3edf2be90de3ecc7c3708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="network")
    def network(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "network"))

    @network.setter
    def network(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57401acca269eb2a3035d3857d1a2f5a992ce61003dfa8ec8bd38a84d4916612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "network", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ba3094f90e7f0e921c12ecdb3ad850f5395a39ccc480ec8987157b06cc2a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7c276d69aa4213bdb0ec09e109e9fa3e5632f29a387d4a2542ae36b422dbe09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf20b9e5704b5ea90184e7519b6412ee5383bb81ae336f5e40f43e5fd8b65bd6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409720cdc1fea0cc6987a414d0b4c4c90e60c071e91df2eb7ccec41744ebcc03)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for all ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''``Content-Type`` response header value, for example ``text/html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcfa33164874f028586238efcf3b07cd245bfc24cb65499bc80afcac25858446)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ef1c2f212110d5f63dce9d3dad825bcea9147668a8ce1068f44e2c42dacb4cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__378d86d11438e7802a8f6395e6b31dbc05db1267adb4194ff7140259214d3118)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0dd96c8c7f68d6e39a07457ff0311823604a6d49670ea208f7a9331a8152e70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d215e02119e871b3fe893ae065271a1d4a03d74e63722fe61d505a6b0ec281)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d423084e345a6871d8249605605648cba52672004b64cbad2588919a8bc2343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bbfc4a404fa226ab558505978591f61fc1a3b636f21851e7949b5b8f106f996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4398a226773cc02d863fb192f63e0096f74a8d0e2176a03d40dfc2cfcae200c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86f39909b628b277b35fd4b0049d5ed3e8822f8848d5c55d3c1439bf4476ab63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic",
    jsii_struct_bases=[],
    name_mapping={
        "boolean_value": "booleanValue",
        "characteristic": "characteristic",
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_wildcard": "matchWildcard",
        "numeric_match_operator": "numericMatchOperator",
        "numeric_value": "numericValue",
        "string_match_operator": "stringMatchOperator",
        "string_value": "stringValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "version_match_operator": "versionMatchOperator",
        "version_value": "versionValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic:
    def __init__(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f0830d1ec098c813ab23b4909f0565f565add7640bb8d0660f768d4f05b253a)
            check_type(argname="argument boolean_value", value=boolean_value, expected_type=type_hints["boolean_value"])
            check_type(argname="argument characteristic", value=characteristic, expected_type=type_hints["characteristic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument numeric_match_operator", value=numeric_match_operator, expected_type=type_hints["numeric_match_operator"])
            check_type(argname="argument numeric_value", value=numeric_value, expected_type=type_hints["numeric_value"])
            check_type(argname="argument string_match_operator", value=string_match_operator, expected_type=type_hints["string_match_operator"])
            check_type(argname="argument string_value", value=string_value, expected_type=type_hints["string_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument version_match_operator", value=version_match_operator, expected_type=type_hints["version_match_operator"])
            check_type(argname="argument version_value", value=version_value, expected_type=type_hints["version_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if boolean_value is not None:
            self._values["boolean_value"] = boolean_value
        if characteristic is not None:
            self._values["characteristic"] = characteristic
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if numeric_match_operator is not None:
            self._values["numeric_match_operator"] = numeric_match_operator
        if numeric_value is not None:
            self._values["numeric_value"] = numeric_value
        if string_match_operator is not None:
            self._values["string_match_operator"] = string_match_operator
        if string_value is not None:
            self._values["string_value"] = string_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if version_match_operator is not None:
            self._values["version_match_operator"] = version_match_operator
        if version_value is not None:
            self._values["version_value"] = version_value

    @builtins.property
    def boolean_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the ``characteristic`` expects a boolean value, this specifies the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        '''
        result = self._values.get("boolean_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def characteristic(self) -> typing.Optional[builtins.str]:
        '''Aspect of the device or browser to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        '''
        result = self._values.get("characteristic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``stringValue`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def numeric_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        '''
        result = self._values.get("numeric_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def numeric_value(self) -> typing.Optional[jsii.Number]:
        '''When the ``characteristic`` expects a numeric value, this specifies the number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        '''
        result = self._values.get("numeric_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def string_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        '''
        result = self._values.get("string_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def string_value(self) -> typing.Optional[typing.List[builtins.str]]:
        '''When the ``characteristic`` expects a string, this specifies the set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        '''
        result = self._values.get("string_value")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        '''
        result = self._values.get("version_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_value(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version number, this specifies it as a string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        result = self._values.get("version_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristicOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristicOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a898b0995710cb35d29253b6510e74d62ab62d6d46807d3f4b0cfc2679433b97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBooleanValue")
    def reset_boolean_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBooleanValue", []))

    @jsii.member(jsii_name="resetCharacteristic")
    def reset_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCharacteristic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetNumericMatchOperator")
    def reset_numeric_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericMatchOperator", []))

    @jsii.member(jsii_name="resetNumericValue")
    def reset_numeric_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericValue", []))

    @jsii.member(jsii_name="resetStringMatchOperator")
    def reset_string_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringMatchOperator", []))

    @jsii.member(jsii_name="resetStringValue")
    def reset_string_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVersionMatchOperator")
    def reset_version_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionMatchOperator", []))

    @jsii.member(jsii_name="resetVersionValue")
    def reset_version_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionValue", []))

    @builtins.property
    @jsii.member(jsii_name="booleanValueInput")
    def boolean_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "booleanValueInput"))

    @builtins.property
    @jsii.member(jsii_name="characteristicInput")
    def characteristic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "characteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperatorInput")
    def numeric_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "numericMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="numericValueInput")
    def numeric_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numericValueInput"))

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperatorInput")
    def string_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stringMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="stringValueInput")
    def string_value_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "stringValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperatorInput")
    def version_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="versionValueInput")
    def version_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="booleanValue")
    def boolean_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "booleanValue"))

    @boolean_value.setter
    def boolean_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e37607c23d10cdcb27a43d3e2f5c60a8f8c85e6d25b22164b23d0756936d74b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "booleanValue", value)

    @builtins.property
    @jsii.member(jsii_name="characteristic")
    def characteristic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "characteristic"))

    @characteristic.setter
    def characteristic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb504d4cdd5f1d74c1db596c0b4e6d8cd78d109c0bdb9eaff1958a7cd249be9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "characteristic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c965deee401443b1236830a011d0fb1526847657f1a05e20d5432fdd70aae89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48f2b59a023e23c2c8340695064682adb0b7f4bc1a1b39085e4547aa183a5fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f860f6daf8d5ad864558fc82a54d601e4be2b0e1a68bec6ce8cd260968bbe16b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperator")
    def numeric_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "numericMatchOperator"))

    @numeric_match_operator.setter
    def numeric_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65337c833b4a569f7fd1c60245a6049e2bfe6a7844e230542fd0fa65b3b6d22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="numericValue")
    def numeric_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numericValue"))

    @numeric_value.setter
    def numeric_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a14a2b03af3243bc58815cea167f18147cee28b742b79e73eb32ef30b55d45c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericValue", value)

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperator")
    def string_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stringMatchOperator"))

    @string_match_operator.setter
    def string_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95ab861a491e6d57ef61b4871c81157e61ea96e2f70112e66630d3ceca39e1d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="stringValue")
    def string_value(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "stringValue"))

    @string_value.setter
    def string_value(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ed43c7645b612637b5b311cf341ad413fd9de61bcea8a942a2b5f538c1bb09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4627c2701f28988b9ca43f18ac677b15dae9d06f84287ac0a09077db04d551b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe0ecfe66071c2e4ff78ac03f745f2c20cbf1abeab997bf104d49103d2a3e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperator")
    def version_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionMatchOperator"))

    @version_match_operator.setter
    def version_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01cbc78818cc8aaed7c55420ab93f71c15641ac82ee3d3dc2b2d1979f2c24543)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="versionValue")
    def version_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionValue"))

    @version_value.setter
    def version_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339523c41fbecf8831456e0ca1d73e90fc24469602c2b7c27eebdce46346f5ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12dab9e8791069f49bb7a0d3c64ad38c17f1aab2bb3db1fa32254eda08f9b1c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10e4de296cd95fa18a76b0b27dc635af1a3e1f086ae286a2e8e7cbf2a12c78de)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65aba7366ac38c917ee73e64eb9339f1958f1eae1c5362689b6d005260e3dd97)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88544094444bd39768dd0d64a7068d388ed8d9fe30d1e5c9ab3780329be61a83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fda06e775c1daa8390dfcb204b587800fb9d32363e8aa8c750cb63199ec5917)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d468d725b9879084ac9ccae2ef12c053918b8973810dfe594e89de45370c1b75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__685f316cd9f61a6fe28c4502ebbf3df318e6cdeb3ab388d6e85a7eff09d07942)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__828afe4e35700215f265edd07b8c9e2c72462149734c9c652d22f015986fce97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70523bc79af0b998eed3fa0105f93883973ca537a6b1120eb5c42548c4e86720)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme",
    jsii_struct_bases=[],
    name_mapping={
        "auth_scheme": "authScheme",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme:
    def __init__(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1dc5262f25f0fc7544cfa081837fa543d9c8052b65b8babcaa946e81885717a)
            check_type(argname="argument auth_scheme", value=auth_scheme, expected_type=type_hints["auth_scheme"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if auth_scheme is not None:
            self._values["auth_scheme"] = auth_scheme
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def auth_scheme(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.'''
        result = self._values.get("auth_scheme")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthSchemeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthSchemeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feec42c0abd371abe390501294233a0642feab5fa51be1c8a03f806d26b0a754)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthScheme")
    def reset_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthScheme", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authSchemeInput")
    def auth_scheme_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authScheme")
    def auth_scheme(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authScheme"))

    @auth_scheme.setter
    def auth_scheme(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19e2c28d33afe02faac3d8bee1c3441a3fbb9fecf256d78b176847271d5f030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authScheme", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f59c6f45710a40c39487a5295a894658612452d5f6f51fd5f5e7e56e8714e41d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc4455bf6d41f4b9bf6bf37ffdfa953d5f65d4e0a29a6856971355a4def92e22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e6cd93160b6132f00468b1dc69716fecbc8ac0c5c507310b9de74c1ddd880d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dec6b479c774591c66ba6694a210485fc92e3bbeef573b2b2417208193b698c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f658f388d6722a20524e8a7469603e81cbe9a86fc441329d11e85b58e7c30050)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticatedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticatedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f465754401d4550be594326af3f940050f2a3b2d466ca2e788f1f2944f098e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c58bb8f3fc54a6ac810374f62fe94b1d3eb1fa2b38413ef192ec494132600914)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d488a64f7ea4f6588fa862576fc39e4116a8a5ff739592dcf828e4f89578675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4910bb96a8cd8294ca0f394655fbf414972413855cac944c61e6824cdeff4e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b36c5a9663fb5cebd4bde6a98e47a57e81d9f1e5f6af6191909b33493c9292ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56723c8607a920104f96e924f694289f4f7d734307be35ce99b674da4c2d1ff1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername",
    jsii_struct_bases=[],
    name_mapping={
        "length": "length",
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername:
    def __init__(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b40fc986456f7398e89da3f6249d864b908c637dd17aca3fded6d3a73fe7646)
            check_type(argname="argument length", value=length, expected_type=type_hints["length"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if length is not None:
            self._values["length"] = length
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def length(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.'''
        result = self._values.get("length")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsernameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsernameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e0079212a20a17b8581fa9bdfb94327ca2fb7769710903ad492bfb28bb1ce67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLength")
    def reset_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLength", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lengthInput")
    def length_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lengthInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="length")
    def length(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "length"))

    @length.setter
    def length(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e48ef8362ff4aa24075ce1b7b916a22c1777d455ebf77e8ede43c20663b7927)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "length", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581ea090fa8f5e17ad997d3220f21dfd675dc167bf0689daf772c889151992b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75308557daf5a34bd79f2fc62e5fdeb91b1e52cfff5f9402fc4ec7d8326fc53a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54248e6d706908bf77ef518bf206341eba2ae3f249982071a4c3e2c04a71682e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63541d4199afa135c50459281229ebda26c6e303832ccf7478dc60848a17eb72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__440894acd935ed934e6aa77007aa73bbac60bcef4836fdd149eedcf419d20fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa2f45002a067331381e7f460e5d8bcec5acda26c907f3f14cc28abf83c86abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure",
    jsii_struct_bases=[],
    name_mapping={
        "exec_status": "execStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure:
    def __init__(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bf216b3d3fa09b493dae1d6b3dcd8b609e6e8b1b8b92cd10650031e89d2abdd)
            check_type(argname="argument exec_status", value=exec_status, expected_type=type_hints["exec_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if exec_status is not None:
            self._values["exec_status"] = exec_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def exec_status(self) -> typing.Optional[builtins.str]:
        '''Specify execution status.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        '''
        result = self._values.get("exec_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailureOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailureOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04e1fc696a5d1be6a987edb59ba2de10c3935f351c364c2352b077e29ca48d99)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExecStatus")
    def reset_exec_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExecStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="execStatusInput")
    def exec_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "execStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="execStatus")
    def exec_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "execStatus"))

    @exec_status.setter
    def exec_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__059a19b58ff58fabd8edf2c82e26227208e9c6ed116723f20cb1aad7996fa474)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "execStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef814f7b8ce52d19647361d4fb6fd5a2bdb46f0c267a27b9242fd79f2959c6f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19a3072d745d7939a364b791ed6038aab2cdaca1e5304be85e49401b37a74f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2eb2a851f754107b6056d2efb016bf1171cf47387a85522d35ca6b014f17ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca7fb5a4cdb15fae250bacfb5bba85ddc8aa27d050b2d4c94d90041cf022783)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0368031b4cd2f241525f944e63affd2e8d94d1719766743d75fb5456fa998ab0)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9de0c9045f93e0346e62d69e72349120f635fdc5c913185f78475b6a3ec303b2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b43cfd102bfb953406edba9f96514b0538fa0d17dced6410b6f6d602b00f7c52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af607c5b4ef431f1ad2669a898ed309fefa139ed19d05f222091b0a7730aebb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af733c4b7b6daab47a74ea1c3df83100a51465718867c3b491aab823c4323acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34c0c0d9ad994801af0ea648368946bdaca614508e6e9c84f23ef3ed5cdd4ca9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddc98d86db8e17669472257fc79b16129e7cfe789e3f9d6a1ae5737b1fc14135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d76aae7aa9cca072ad243e4443d55bf9e065d00630780838e4f9186c45fbe1cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bf72271964c74b67be951e0b4a9ad4af4402d6f1fc42c62c6e5d0067c535e77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eee3f394ab1b1567036bfd9656d7ac368e871be49bcc3b17b64491c7721af1d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``values`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``.

        If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the filename component of the request URL.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilenameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilenameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7465e1354f44478de130bd90bb14a808388ea2a0318f32d19137278c8f33ae4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab016cfcb510916f21b4fe922def2ee7aadbc4878e4a7db169a318849cd7fc9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e87b512a139c80b69bcd8c105971d4f1b28576ae0a171afd0c30c83861dcfa89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79418b5741798f3afc7a881718e76dbc6a23c1beab183143f1ebfe1f75296c01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff85ffe64db2b64418eb92c2b730541a29c60e1cc4adc7810304a053796c28b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e503215476d195df8a92ffce977bda44c3f5677bf49f19e158ed779225361e25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3a1b73ababe87824a1783942f6e60c99c3e432e055f8ec293596952e3043f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dcd4f2c06bd41d6afb96e3bcf6f2689f55c043de874b5b0cfd4800f5c54a71c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a8c495e1ac7952907064904277676201014d559278cd795abb3a6c0fc33997)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of hostnames.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53744a98a067e4beeb2c50c59c43c3dff672ce2f0b4c1f01cf9da356fe5dcf81)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0536dc85d6501647f3ec5c49497c444580a58920b84aa84578b301701b940eab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__924e52d08328a7f2b7f6d706e0b28c71b6800de49564b32d357d056dfb856da9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ce11b13a92f6cdf301f8c1587e052018d4d62ad0b3f75118c2acb4e17632812)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f2cdc94daf57d861ce4cd1294c59e758080b76ee847a9999183cecb3552a279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0748ed0d1029777b51725f792fb4cf49b8fedc11c1ddb9c9ec8dfd859e09923)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694c993ae0c89a97f50a91f0193afb8a2f3adf6a835e8f09e78eee4c0850f91b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be517c40e95a21e6928a218430f8d69aa666280a29aedfb1cbe2b75186f02ed1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f269ca18d8559bcfc89b4734e8a61c40351e5dfec61650570272b9641cb1cc9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__409b09f020598cd5644f1821918b584ea22997ba2fe3fa0d3d75e9aa6891fe16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56d0866e13c4bed7d07388090cb71a73278bccafca111144121dcb38b898bd3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5361e44bb6b505137d0915d0008a5f3d1573fc9a9d8eb5a8d95c7a780419255e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4cebc5a6e71cc22aa952fe4d799638c2bb7567d978968c777407266a6e75d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "close_xml": "closeXml",
        "description": "description",
        "locked": "locked",
        "open_xml": "openXml",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced:
    def __init__(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25862cc717afcba9c152cc268d60440c506445d3cb62b523718f0b5dbe3d779f)
            check_type(argname="argument close_xml", value=close_xml, expected_type=type_hints["close_xml"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument open_xml", value=open_xml, expected_type=type_hints["open_xml"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if close_xml is not None:
            self._values["close_xml"] = close_xml
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if open_xml is not None:
            self._values["open_xml"] = open_xml
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def close_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that closes the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        '''
        result = self._values.get("close_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def open_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that opens the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        '''
        result = self._values.get("open_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e44e1bbdc1a77c0961e02d490bfbc4157649f40b894c3519f84c62e4b26b37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloseXml")
    def reset_close_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloseXml", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOpenXml")
    def reset_open_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpenXml", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="closeXmlInput")
    def close_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "closeXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="openXmlInput")
    def open_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "openXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="closeXml")
    def close_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "closeXml"))

    @close_xml.setter
    def close_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1fed18191b2e9fa83ac35514af0a5c168b3178b9cbf58c020d3e63396ab1712)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "closeXml", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c69078240146a2732fc5572c8820daae0a53e8d4f3b0a1ab821187b7ca156d21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fdf9946888b9a82e99039d7cddb92cfe09c0c07d8db066a7500bc1f680d1394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="openXml")
    def open_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "openXml"))

    @open_xml.setter
    def open_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7109123d464780a15854fa4b9fec8dca0f43aafa7926138326d7d4ade64dfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "openXml", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__106e47701610f2a4c34a5cefbf5e678f5e2a0a60f88d5e0af3b743fecde1ae78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0fbf9de2f390b957507a2d077818a5238ea3a091bb5745fc8f17135ea49a0dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37cd1b2f2ff51bb348462a9b367214bb702ad5af39839458572b8048b9179fe5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf32692952e2ca33a001f7f42dafadd38f683201803fa6f4697a544a72f9243f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea05d52be1e70da6eee030b53783e2da6996084d36666609947c8d9c7bfb25f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30896d336a53f9460b7434c70bf96293fa299cb6ae8257f2c748500a0fe0e44a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e1117751d5f773c45ff22aa47cfd54bffd0f338593681c6b4ab878de4d3c97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eff1553b99fe43019a248b253039bc6c41d38ad8e48a4a8b04ac28657fb44c63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb3e7ad94d6c906b20586cac7d902d7f2cbb49be96eeb16df3c1eca35d64ff75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078fcf3807e899f95b42c84733f187641dd59aaaf4296e2dbbe3d4987200b004)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__194d9e78d85815212b85047f72131d6add60c436e77f41caaeec1dd9a78589c4)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d291e52833b18df7fede5ac5e9e94f657fc9c4f84343ba68bd4fe274c8504cb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a9040502c2eeecc100b77cb68b1382b20e7c21487016fde0d2cacd24ae8d5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fc4991b2a535d2410ab58ca58da855415ef8d62015d78322e2025c8e703b619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c170a8dbb488d13b4d6532599978b5060f4074539bca2e4b1dd5fd3b3cf3a3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64c806bfe3fb0f81ab0f87d3248024617955f69529df3f85f4dc2049fe7fa306)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3eaa08ea04f270754c03a5e1cd1b4abc15c3a51c02d29065ad8d1c1b2536f06)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bacb0bc0cae1264efa5966ca746a938f41a46f40f9ddc251903924b6968e8e63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40aaf6117c1ac454a7bc3b3621bd4b8d13bb0e2ef15f8e8dedace0c511051826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f4a50330b903ee22151ce538a5dd15d6257957de06b4d7b46d76527eb2fa49e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba9b9c6c35572e0e7fa11997f4b9d97882a6fc081263f1d7b60db0c104d4c0f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__580bef27afac82e8ce3455bb9bf753ae83f3c1b41fb2f31cfca366f4c274be62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a297cf355865e245ed94dec91ae240f2bdfaaf609cde7a626dcb4ef1fd5b80b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__729c3bf967f84055bfe22f9deb13ec89420fca7d4a41f6bcefa7d2d494cc2d62)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches numeric range or a specified set of ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A set of response codes to match, for example ``["404","500"]``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b2ae90f3646d49ae93fa6823ad06c5c0ad3ebe978e02e35a165cdee53f51e6e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80f6d6ec4a062fd9b338da23ef2ea6ef6eef9215ad604c640cb4eeef7c0d6acf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e64f2a67ee388db05db8755c0c6a21246d6f1f70742d915d2fd0f71cc463f049)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed67ff2b627c5c3e39a2c4069bcc2019e36358da16e8f0bb5be9cf3e21f57ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8c2a599e871906b4f47daf5bb50c641e4c1d6ac4b2d3ee5391308dafeda5f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9745b448709c94172fcb77e3bb619a42746f13633d6d47a634043d45abc03c00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef09751008fe93cfa5ae31e0215120a0422746f899f999063c49958856d0e300)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a68256bbde83007316be7f1d83d144b04195a881b332985ed41e6c54db870066)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12c6d8e1a945510661018c0fa2b5d77a0f53b4c221bc004ec07a51e9984f229)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "variable_expression": "variableExpression",
        "variable_name": "variableName",
        "variable_values": "variableValues",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b7a498ac52590de7fa9883f9230456c519ad335eba826daba31f32a2ade6ec)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_expression", value=variable_expression, expected_type=type_hints["variable_expression"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_values", value=variable_values, expected_type=type_hints["variable_values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_expression is not None:
            self._values["variable_expression"] = variable_expression
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_values is not None:
            self._values["variable_values"] = variable_values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this performs a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''The type of match, based on which you use different options to specify the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_expression(self) -> typing.Optional[builtins.str]:
        '''Specifies a single matching string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        '''
        result = self._values.get("variable_expression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''The name of the variable to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies an array of matching strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        result = self._values.get("variable_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e098548c77d94226c3969536776219c3f1e10307d11ad4417c78a18f409005)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableExpression")
    def reset_variable_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableExpression", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValues")
    def reset_variable_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableExpressionInput")
    def variable_expression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValuesInput")
    def variable_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12345b8150b6a768df2a35d322d93478328b0b29fc3295134fe7fec99923cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc563eeabde8a83d29d99c8a1d4832f0b43dd4321cafdeb605ada707b6eb12f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e2952bfd07377ec434a6089ad1763832f82e640c9e57e829768156e1abed6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccd4c7b1887b8df4027cf25c883385acfce17aaba0ff7e13cfa179a372f8073)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6003470c8838ac9662ca2ea63bb80411c3c915650e75fb2dc44b2dd9ac3190ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c35822ec12f778443fcf2d28d44366778654399fb2d6508ade0b0a0e479607a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__497c19c0d262897fd96fa847db5f62df92692264c0b10fbfe27ddb64a18f0710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b358cf69bfa1a85218ba6cb98c925fd0945f318d3ae3d6b679a0473127cfc27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableExpression")
    def variable_expression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableExpression"))

    @variable_expression.setter
    def variable_expression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__136ac2037a45f2557741af0e9eadb08294b6dcc2e6e4d202bad6a68cfbb4e60a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableExpression", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adac5d983501264d6112e62fcb05c8c8b085d20b81f7e543e711c0e4a3e3901d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValues")
    def variable_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableValues"))

    @variable_values.setter
    def variable_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76779e0d09627116b29fd5251c1a5421ad2d25b88f5de089eb9eabbacd50efb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValues", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d5f09c89dc0139e44904b9a41b127b7fc5f10e85e098b883b69414baaf9278f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f6abc02efc576cb741cb5f6082d553a82fb44e86a78ef14b11bdae429917388)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Compares the current rule with the specified metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b09db7e7a6fc66994c41fd81dedc12ab97811efa5374f789eb6fdfd65a4ef17)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9b76239b5aabec477dd9aea889709ec0e69701685964cc5960011dbf6bc0906)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88a4d32df5ce04eac7354183338e470fe7bf6de1590dabb82d871014fefe825f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f732cdc4ec82c305476a47301539cfe8f0196f51a271ee1fe62cb9803bd9bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f9ca4686777b4e07fe52680b4c59e84435a666d7de867458eda55ab669b57d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e3b6f8b0c0532c228ab492bd89893df3ca3ee67d555b9dfc7375c7b7cb8067)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e8d83aa78c48c7fdd8190097a5e5f514a5926716ef571aeb47f8211c4aea5d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c97e6f51646da5bc0aa0da935efc02ef64006d39e1c433aff6563674f7d099d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies a single required ``ORIGIN_TIMED_OUT`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e50d307080e300ab97ba68a414311839d334366ee0b2571662c9a50207089b9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f30480bd835733f31bde584fbb63f715fddb4b2eb93c4131b0f7a7e434c72e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7cf61088d72891094bfa5639d7dabdca01090101c89b7837068a749b1d35142)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__937e10f75b13894ecde556eb2cf2f8018a7eb7bfcbc908ec50c316589958fe93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b94c36746985da55bfc7e8faed8c87af6c71457bee2666b2cd9ac48d3f75746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff968ff362540b5004652c32f6a472a3359bcdcd6f2a4030fd191143f1fa4eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efe0d264f52c8bc762e2f4420b1fbe97e3fed158aa3954493585ebf09df174a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdvancedImMatch")
    def put_advanced_im_match(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvancedImMatch", [value]))

    @jsii.member(jsii_name="putBucket")
    def put_bucket(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket(
            locked=locked,
            percentage=percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBucket", [value]))

    @jsii.member(jsii_name="putCacheability")
    def put_cacheability(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheability", [value_]))

    @jsii.member(jsii_name="putChinaCdnRegion")
    def put_china_cdn_region(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChinaCdnRegion", [value]))

    @jsii.member(jsii_name="putClientCertificate")
    def put_client_certificate(
        self,
        *,
        enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enforce_mtls: Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail. Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate(
            enforce_mtls=enforce_mtls,
            is_certificate_present=is_certificate_present,
            is_certificate_valid=is_certificate_valid,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificate", [value]))

    @jsii.member(jsii_name="putClientIp")
    def put_client_ip(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            use_headers=use_headers,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIp", [value]))

    @jsii.member(jsii_name="putClientIpVersion")
    def put_client_ip_version(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion(
            locked=locked,
            template_uuid=template_uuid,
            use_x_forwarded_for=use_x_forwarded_for,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIpVersion", [value_]))

    @jsii.member(jsii_name="putCloudletsOrigin")
    def put_cloudlets_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletsOrigin", [value]))

    @jsii.member(jsii_name="putContentDeliveryNetwork")
    def put_content_delivery_network(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork(
            locked=locked,
            match_operator=match_operator,
            network=network,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentDeliveryNetwork", [value]))

    @jsii.member(jsii_name="putContentType")
    def put_content_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putContentType", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristic")
    def put_device_characteristic(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic(
            boolean_value=boolean_value,
            characteristic=characteristic,
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_wildcard=match_wildcard,
            numeric_match_operator=numeric_match_operator,
            numeric_value=numeric_value,
            string_match_operator=string_match_operator,
            string_value=string_value,
            template_uuid=template_uuid,
            uuid=uuid,
            version_match_operator=version_match_operator,
            version_value=version_value,
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristic", [value]))

    @jsii.member(jsii_name="putEcmdAuthGroups")
    def put_ecmd_auth_groups(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthGroups", [value_]))

    @jsii.member(jsii_name="putEcmdAuthScheme")
    def put_ecmd_auth_scheme(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme(
            auth_scheme=auth_scheme,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthScheme", [value]))

    @jsii.member(jsii_name="putEcmdIsAuthenticated")
    def put_ecmd_is_authenticated(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdIsAuthenticated", [value]))

    @jsii.member(jsii_name="putEcmdUsername")
    def put_ecmd_username(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername(
            length=length,
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdUsername", [value_]))

    @jsii.member(jsii_name="putEdgeWorkersFailure")
    def put_edge_workers_failure(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure(
            exec_status=exec_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorkersFailure", [value]))

    @jsii.member(jsii_name="putFileExtension")
    def put_file_extension(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFileExtension", [value]))

    @jsii.member(jsii_name="putFilename")
    def put_filename(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFilename", [value]))

    @jsii.member(jsii_name="putHostname")
    def put_hostname(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putHostname", [value]))

    @jsii.member(jsii_name="putMatchAdvanced")
    def put_match_advanced(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced(
            close_xml=close_xml,
            description=description,
            locked=locked,
            open_xml=open_xml,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchAdvanced", [value]))

    @jsii.member(jsii_name="putMatchCpCode")
    def put_match_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putMatchCpCode", [value_]))

    @jsii.member(jsii_name="putMatchResponseCode")
    def put_match_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode(
            locked=locked,
            lower_bound=lower_bound,
            match_operator=match_operator,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchResponseCode", [value]))

    @jsii.member(jsii_name="putMatchVariable")
    def put_match_variable(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable(
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            variable_expression=variable_expression,
            variable_name=variable_name,
            variable_values=variable_values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchVariable", [value]))

    @jsii.member(jsii_name="putMetadataStage")
    def put_metadata_stage(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataStage", [value_]))

    @jsii.member(jsii_name="putOriginTimeout")
    def put_origin_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginTimeout", [value]))

    @jsii.member(jsii_name="putPath")
    def put_path(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            normalize=normalize,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putPath", [value]))

    @jsii.member(jsii_name="putQueryStringParameter")
    def put_query_string_parameter(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter(
            escape_value=escape_value,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            parameter_name=parameter_name,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putQueryStringParameter", [value]))

    @jsii.member(jsii_name="putRandom")
    def put_random(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom(
            bucket=bucket, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRandom", [value]))

    @jsii.member(jsii_name="putRecoveryConfig")
    def put_recovery_config(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig(
            config_name=config_name,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRecoveryConfig", [value]))

    @jsii.member(jsii_name="putRegularExpression")
    def put_regular_expression(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression(
            case_sensitive=case_sensitive,
            locked=locked,
            match_string=match_string,
            regex=regex,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRegularExpression", [value]))

    @jsii.member(jsii_name="putRequestCookie")
    def put_request_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie(
            cookie_name=cookie_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestCookie", [value_]))

    @jsii.member(jsii_name="putRequestHeader")
    def put_request_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader(
            header_name=header_name,
            locked=locked,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestHeader", [value]))

    @jsii.member(jsii_name="putRequestMethod")
    def put_request_method(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestMethod", [value_]))

    @jsii.member(jsii_name="putRequestProtocol")
    def put_request_protocol(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putRequestProtocol", [value_]))

    @jsii.member(jsii_name="putRequestType")
    def put_request_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestType", [value_]))

    @jsii.member(jsii_name="putResponseHeader")
    def put_response_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader(
            header_name=header_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseHeader", [value]))

    @jsii.member(jsii_name="putServerLocation")
    def put_server_location(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation(
            continents=continents,
            countries=countries,
            location_type=location_type,
            locked=locked,
            match_operator=match_operator,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putServerLocation", [value]))

    @jsii.member(jsii_name="putTime")
    def put_time(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime(
            apply_daylight_savings_time=apply_daylight_savings_time,
            begin_date=begin_date,
            end_date=end_date,
            lasting_date=lasting_date,
            lasting_duration=lasting_duration,
            locked=locked,
            match_operator=match_operator,
            repeat_begin_date=repeat_begin_date,
            repeat_duration=repeat_duration,
            repeat_interval=repeat_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTime", [value]))

    @jsii.member(jsii_name="putTokenAuthorization")
    def put_token_authorization(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization(
            locked=locked,
            match_operator=match_operator,
            status_list=status_list,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTokenAuthorization", [value]))

    @jsii.member(jsii_name="putUserAgent")
    def put_user_agent(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putUserAgent", [value]))

    @jsii.member(jsii_name="putUserLocation")
    def put_user_location(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation(
            check_ips=check_ips,
            continent_values=continent_values,
            country_values=country_values,
            field=field,
            locked=locked,
            match_operator=match_operator,
            region_values=region_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserLocation", [value]))

    @jsii.member(jsii_name="putUserNetwork")
    def put_user_network(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork(
            bandwidth_values=bandwidth_values,
            check_ips=check_ips,
            field=field,
            locked=locked,
            match_operator=match_operator,
            network_type_values=network_type_values,
            network_values=network_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserNetwork", [value]))

    @jsii.member(jsii_name="putVariableError")
    def put_variable_error(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError(
            locked=locked,
            result=result,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_names=variable_names,
        )

        return typing.cast(None, jsii.invoke(self, "putVariableError", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomRequest")
    def put_virtual_waiting_room_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomRequest", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationRequest")
    def put_visitor_prioritization_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationRequest", [value]))

    @jsii.member(jsii_name="resetAdvancedImMatch")
    def reset_advanced_im_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedImMatch", []))

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetCacheability")
    def reset_cacheability(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheability", []))

    @jsii.member(jsii_name="resetChinaCdnRegion")
    def reset_china_cdn_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnRegion", []))

    @jsii.member(jsii_name="resetClientCertificate")
    def reset_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificate", []))

    @jsii.member(jsii_name="resetClientIp")
    def reset_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIp", []))

    @jsii.member(jsii_name="resetClientIpVersion")
    def reset_client_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIpVersion", []))

    @jsii.member(jsii_name="resetCloudletsOrigin")
    def reset_cloudlets_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletsOrigin", []))

    @jsii.member(jsii_name="resetContentDeliveryNetwork")
    def reset_content_delivery_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentDeliveryNetwork", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDeviceCharacteristic")
    def reset_device_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristic", []))

    @jsii.member(jsii_name="resetEcmdAuthGroups")
    def reset_ecmd_auth_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthGroups", []))

    @jsii.member(jsii_name="resetEcmdAuthScheme")
    def reset_ecmd_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthScheme", []))

    @jsii.member(jsii_name="resetEcmdIsAuthenticated")
    def reset_ecmd_is_authenticated(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdIsAuthenticated", []))

    @jsii.member(jsii_name="resetEcmdUsername")
    def reset_ecmd_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdUsername", []))

    @jsii.member(jsii_name="resetEdgeWorkersFailure")
    def reset_edge_workers_failure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkersFailure", []))

    @jsii.member(jsii_name="resetFileExtension")
    def reset_file_extension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileExtension", []))

    @jsii.member(jsii_name="resetFilename")
    def reset_filename(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFilename", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetMatchAdvanced")
    def reset_match_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchAdvanced", []))

    @jsii.member(jsii_name="resetMatchCpCode")
    def reset_match_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCpCode", []))

    @jsii.member(jsii_name="resetMatchResponseCode")
    def reset_match_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchResponseCode", []))

    @jsii.member(jsii_name="resetMatchVariable")
    def reset_match_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchVariable", []))

    @jsii.member(jsii_name="resetMetadataStage")
    def reset_metadata_stage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataStage", []))

    @jsii.member(jsii_name="resetOriginTimeout")
    def reset_origin_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginTimeout", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetQueryStringParameter")
    def reset_query_string_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryStringParameter", []))

    @jsii.member(jsii_name="resetRandom")
    def reset_random(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandom", []))

    @jsii.member(jsii_name="resetRecoveryConfig")
    def reset_recovery_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryConfig", []))

    @jsii.member(jsii_name="resetRegularExpression")
    def reset_regular_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegularExpression", []))

    @jsii.member(jsii_name="resetRequestCookie")
    def reset_request_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestCookie", []))

    @jsii.member(jsii_name="resetRequestHeader")
    def reset_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestHeader", []))

    @jsii.member(jsii_name="resetRequestMethod")
    def reset_request_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestMethod", []))

    @jsii.member(jsii_name="resetRequestProtocol")
    def reset_request_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestProtocol", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetResponseHeader")
    def reset_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeader", []))

    @jsii.member(jsii_name="resetServerLocation")
    def reset_server_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerLocation", []))

    @jsii.member(jsii_name="resetTime")
    def reset_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTime", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUserAgent")
    def reset_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserAgent", []))

    @jsii.member(jsii_name="resetUserLocation")
    def reset_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserLocation", []))

    @jsii.member(jsii_name="resetUserNetwork")
    def reset_user_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserNetwork", []))

    @jsii.member(jsii_name="resetVariableError")
    def reset_variable_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableError", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomRequest")
    def reset_virtual_waiting_room_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomRequest", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationRequest")
    def reset_visitor_prioritization_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationRequest", []))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatch")
    def advanced_im_match(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatchOutputReference, jsii.get(self, "advancedImMatch"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucketOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucketOutputReference, jsii.get(self, "bucket"))

    @builtins.property
    @jsii.member(jsii_name="cacheability")
    def cacheability(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheabilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheabilityOutputReference, jsii.get(self, "cacheability"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegion")
    def china_cdn_region(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegionOutputReference, jsii.get(self, "chinaCdnRegion"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificate")
    def client_certificate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificateOutputReference, jsii.get(self, "clientCertificate"))

    @builtins.property
    @jsii.member(jsii_name="clientIp")
    def client_ip(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpOutputReference, jsii.get(self, "clientIp"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersion")
    def client_ip_version(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersionOutputReference, jsii.get(self, "clientIpVersion"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOrigin")
    def cloudlets_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOriginOutputReference, jsii.get(self, "cloudletsOrigin"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetwork")
    def content_delivery_network(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetworkOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetworkOutputReference, jsii.get(self, "contentDeliveryNetwork"))

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentTypeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentTypeOutputReference, jsii.get(self, "contentType"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristic")
    def device_characteristic(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristicOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristicOutputReference, jsii.get(self, "deviceCharacteristic"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroups")
    def ecmd_auth_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroupsOutputReference, jsii.get(self, "ecmdAuthGroups"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthScheme")
    def ecmd_auth_scheme(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthSchemeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthSchemeOutputReference, jsii.get(self, "ecmdAuthScheme"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticated")
    def ecmd_is_authenticated(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticatedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticatedOutputReference, jsii.get(self, "ecmdIsAuthenticated"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsername")
    def ecmd_username(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsernameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsernameOutputReference, jsii.get(self, "ecmdUsername"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailure")
    def edge_workers_failure(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailureOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailureOutputReference, jsii.get(self, "edgeWorkersFailure"))

    @builtins.property
    @jsii.member(jsii_name="fileExtension")
    def file_extension(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtensionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtensionOutputReference, jsii.get(self, "fileExtension"))

    @builtins.property
    @jsii.member(jsii_name="filename")
    def filename(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilenameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilenameOutputReference, jsii.get(self, "filename"))

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostnameOutputReference, jsii.get(self, "hostname"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvanced")
    def match_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvancedOutputReference, jsii.get(self, "matchAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCode")
    def match_cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeOutputReference, jsii.get(self, "matchCpCode"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCode")
    def match_response_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCodeOutputReference, jsii.get(self, "matchResponseCode"))

    @builtins.property
    @jsii.member(jsii_name="matchVariable")
    def match_variable(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariableOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariableOutputReference, jsii.get(self, "matchVariable"))

    @builtins.property
    @jsii.member(jsii_name="metadataStage")
    def metadata_stage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStageOutputReference, jsii.get(self, "metadataStage"))

    @builtins.property
    @jsii.member(jsii_name="originTimeout")
    def origin_timeout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeoutOutputReference, jsii.get(self, "originTimeout"))

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPathOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPathOutputReference", jsii.get(self, "path"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameter")
    def query_string_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameterOutputReference", jsii.get(self, "queryStringParameter"))

    @builtins.property
    @jsii.member(jsii_name="random")
    def random(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandomOutputReference", jsii.get(self, "random"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfig")
    def recovery_config(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfigOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfigOutputReference", jsii.get(self, "recoveryConfig"))

    @builtins.property
    @jsii.member(jsii_name="regularExpression")
    def regular_expression(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpressionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpressionOutputReference", jsii.get(self, "regularExpression"))

    @builtins.property
    @jsii.member(jsii_name="requestCookie")
    def request_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookieOutputReference", jsii.get(self, "requestCookie"))

    @builtins.property
    @jsii.member(jsii_name="requestHeader")
    def request_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeaderOutputReference", jsii.get(self, "requestHeader"))

    @builtins.property
    @jsii.member(jsii_name="requestMethod")
    def request_method(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethodOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethodOutputReference", jsii.get(self, "requestMethod"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocol")
    def request_protocol(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocolOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocolOutputReference", jsii.get(self, "requestProtocol"))

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestTypeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestTypeOutputReference", jsii.get(self, "requestType"))

    @builtins.property
    @jsii.member(jsii_name="responseHeader")
    def response_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeaderOutputReference", jsii.get(self, "responseHeader"))

    @builtins.property
    @jsii.member(jsii_name="serverLocation")
    def server_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocationOutputReference", jsii.get(self, "serverLocation"))

    @builtins.property
    @jsii.member(jsii_name="time")
    def time(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTimeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTimeOutputReference", jsii.get(self, "time"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorizationOutputReference", jsii.get(self, "tokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="userAgent")
    def user_agent(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgentOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgentOutputReference", jsii.get(self, "userAgent"))

    @builtins.property
    @jsii.member(jsii_name="userLocation")
    def user_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocationOutputReference", jsii.get(self, "userLocation"))

    @builtins.property
    @jsii.member(jsii_name="userNetwork")
    def user_network(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetworkOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetworkOutputReference", jsii.get(self, "userNetwork"))

    @builtins.property
    @jsii.member(jsii_name="variableError")
    def variable_error(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableErrorOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableErrorOutputReference", jsii.get(self, "variableError"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequest")
    def virtual_waiting_room_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequestOutputReference", jsii.get(self, "virtualWaitingRoomRequest"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequest")
    def visitor_prioritization_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequestOutputReference", jsii.get(self, "visitorPrioritizationRequest"))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatchInput")
    def advanced_im_match_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch], jsii.get(self, "advancedImMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilityInput")
    def cacheability_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability], jsii.get(self, "cacheabilityInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegionInput")
    def china_cdn_region_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion], jsii.get(self, "chinaCdnRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateInput")
    def client_certificate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate], jsii.get(self, "clientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpInput")
    def client_ip_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp], jsii.get(self, "clientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersionInput")
    def client_ip_version_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion], jsii.get(self, "clientIpVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOriginInput")
    def cloudlets_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin], jsii.get(self, "cloudletsOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetworkInput")
    def content_delivery_network_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork], jsii.get(self, "contentDeliveryNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicInput")
    def device_characteristic_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic], jsii.get(self, "deviceCharacteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroupsInput")
    def ecmd_auth_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups], jsii.get(self, "ecmdAuthGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthSchemeInput")
    def ecmd_auth_scheme_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme], jsii.get(self, "ecmdAuthSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticatedInput")
    def ecmd_is_authenticated_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated], jsii.get(self, "ecmdIsAuthenticatedInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsernameInput")
    def ecmd_username_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername], jsii.get(self, "ecmdUsernameInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailureInput")
    def edge_workers_failure_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure], jsii.get(self, "edgeWorkersFailureInput"))

    @builtins.property
    @jsii.member(jsii_name="fileExtensionInput")
    def file_extension_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension], jsii.get(self, "fileExtensionInput"))

    @builtins.property
    @jsii.member(jsii_name="filenameInput")
    def filename_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename], jsii.get(self, "filenameInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvancedInput")
    def match_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced], jsii.get(self, "matchAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCodeInput")
    def match_cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode], jsii.get(self, "matchCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCodeInput")
    def match_response_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode], jsii.get(self, "matchResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchVariableInput")
    def match_variable_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable], jsii.get(self, "matchVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataStageInput")
    def metadata_stage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage], jsii.get(self, "metadataStageInput"))

    @builtins.property
    @jsii.member(jsii_name="originTimeoutInput")
    def origin_timeout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout], jsii.get(self, "originTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath"], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameterInput")
    def query_string_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter"], jsii.get(self, "queryStringParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="randomInput")
    def random_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom"], jsii.get(self, "randomInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfigInput")
    def recovery_config_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig"], jsii.get(self, "recoveryConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="regularExpressionInput")
    def regular_expression_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression"], jsii.get(self, "regularExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="requestCookieInput")
    def request_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie"], jsii.get(self, "requestCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="requestHeaderInput")
    def request_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader"], jsii.get(self, "requestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="requestMethodInput")
    def request_method_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod"], jsii.get(self, "requestMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocolInput")
    def request_protocol_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol"], jsii.get(self, "requestProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType"], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderInput")
    def response_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader"], jsii.get(self, "responseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="serverLocationInput")
    def server_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation"], jsii.get(self, "serverLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="timeInput")
    def time_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime"], jsii.get(self, "timeInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization"], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="userAgentInput")
    def user_agent_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent"], jsii.get(self, "userAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="userLocationInput")
    def user_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation"], jsii.get(self, "userLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="userNetworkInput")
    def user_network_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork"], jsii.get(self, "userNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="variableErrorInput")
    def variable_error_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError"], jsii.get(self, "variableErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequestInput")
    def virtual_waiting_room_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest"], jsii.get(self, "virtualWaitingRoomRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequestInput")
    def visitor_prioritization_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest"], jsii.get(self, "visitorPrioritizationRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef047b7d4c769a1999e651c51734b085fa5e2f050ed00c0af4979c63721966b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "normalize": "normalize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e6efc1079716a55c4b414c0dccb56b2072d02a33983b05d782407ab5456b65f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument normalize", value=normalize, expected_type=type_hints["normalize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if normalize is not None:
            self._values["normalize"] = normalize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of the ``values`` array.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def normalize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Transforms URLs before comparing them with the provided value.

        URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        '''
        result = self._values.get("normalize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the URL path, excluding leading hostname and trailing query parameters.

        The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}

        Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPathOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPathOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5625908beef4650a90fcdcdf57f9cf3045c7db856a7140e6b5b0303f1dba456c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNormalize")
    def reset_normalize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNormalize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="normalizeInput")
    def normalize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "normalizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e51fcfbd4c09843541d89603e0c64658959c268272cba3ed6587b91c93fb51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67bed213508d137db571b3bcaac87d8294a9704e51120c6a1c5ec19d21d2b3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fbc7debf6da8ac06043c98a8aed286202daab2387931c42d9de6e7532b9fd27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="normalize")
    def normalize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "normalize"))

    @normalize.setter
    def normalize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39db7f7027c8c47804e6efbb643122c98df6b13f366d3ed0a3e2980e43f57b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "normalize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae492224013e8fe75ec34e62aeca7a26a357dfe33f9e8fcfd4f968f2b94e4b78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__469747e9de5b2b0c834c9fe208e102822c9e03c579be5ebe0d4539e6aad52732)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68e28720a5960c54698864da97566f7f2427839eec3b0a8c292b3ef431aa820f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a3e99c94bdd7fb7f221e765ebc7060b4f6ec40d1eb66b0dcedf5b3e5c8d62e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter",
    jsii_struct_bases=[],
    name_mapping={
        "escape_value": "escapeValue",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "parameter_name": "parameterName",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter:
    def __init__(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5babf0b45ebc91f4f28e797ecdc0414479f051a5ae247dbdcecce61a4882a8b)
            check_type(argname="argument escape_value", value=escape_value, expected_type=type_hints["escape_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument parameter_name", value=parameter_name, expected_type=type_hints["parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if escape_value is not None:
            self._values["escape_value"] = escape_value
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if parameter_name is not None:
            self._values["parameter_name"] = parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def escape_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches when the ``value`` is URL-escaped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        '''
        result = self._values.get("escape_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``parameterName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the query field, for example, ``q`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        '''
        result = self._values.get("parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The value of the query field, for example, ``string`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5e6c6e285fe17ca60ef4dcd756b70630f7bdcc781aeae82a2acd819677ad8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEscapeValue")
    def reset_escape_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetParameterName")
    def reset_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="escapeValueInput")
    def escape_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="parameterNameInput")
    def parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "parameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeValue")
    def escape_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeValue"))

    @escape_value.setter
    def escape_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3af90b9db503251cdeb4f36a028e82899d1536965ffde24487b0a1273fa8211)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cecefcde72495edb4182b2b76fda82b5418f9b724659d4b138446cc5e121be8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319d1d250c9d24acbfddc9eb5144a659966e0b963c9429511a4fe8bffe465773)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd55a2f42b5bd10f74f7b4dc236974b35060a66b88f3478a12d98cc2156f03a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c93be9b647f90a7f69d01d511f81afb288404acfc4228baec91076797157f7b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__518e74f6d05b551eeb46c7879bb33b585430f14cfd4f1b403e068efe76a290df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fe5c9db7b35711c279d8db410265b2819a39362a6d6fb28530ed452af4a3644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3a165e22efcd9109fe6eff30b28f71b0969e2005177e74433c257179a30c3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="parameterName")
    def parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "parameterName"))

    @parameter_name.setter
    def parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9397a3d87b8dc8d3b84497521c0bf7d38c84a4c9c792c8b5ba3c66da0d2dea10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7ce17c892e277d50f4ed24bfa6d86ce83b410798daa81934384e76ac05bc59b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdeb9691c764b1ea3045f3e55df771b1f1a807bf9e8780ca932e0d9786877cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64caa496fab805e63808ad2fabe996ce280c2fbda98e6a25fc864ec4a4e50a6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f1b13417cf33993520b5afd31a0ddef8ff52ab29196071ad2b080edb89f7ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04fe3a9f4e7cfd1940f4858e228888fa1f3069e3efbdb5b72ca63e48ca0f981e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom",
    jsii_struct_bases=[],
    name_mapping={
        "bucket": "bucket",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom:
    def __init__(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88addb6bb9c3f1cc9255a0a31591748716b6496b388b8812195b55f9cb241b8d)
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bucket is not None:
            self._values["bucket"] = bucket
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bucket(self) -> typing.Optional[jsii.Number]:
        '''Specify a percentage of random requests to which to apply a behavior. Any remainders do not match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7f987eb352a98d51dd96270def4b77ee1898d3f104dcfa9e4ec9a18be1d9295)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bucket"))

    @bucket.setter
    def bucket(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d22aabdb3be601b4a32bc44b232f410eca66dd3c1e04e5e74b0a3c9a5ef4e24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bucket", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__466f6352e3bbd20b27b691ba526209d196d9186e02b5c1cced232e38054e9e34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ec8871b0d14f4e48f9b555ed741214567a316e00cc1e95491db2835b0c4e7be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__606da7d53c88a359c35dae65e0cf5241e52cfa9d8739c49c64a3d4fc1da4d796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24d3a670e29c4b619641969e89f39defd4c3f464de3e8c8c2acad37df527566e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig",
    jsii_struct_bases=[],
    name_mapping={
        "config_name": "configName",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig:
    def __init__(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99524b9de9a9ad672e0ac8c7f468b5206fe1fcea0079bb81ff8e58cd41702633)
            check_type(argname="argument config_name", value=config_name, expected_type=type_hints["config_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_name is not None:
            self._values["config_name"] = config_name
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def config_name(self) -> typing.Optional[builtins.str]:
        '''A unique identifier used for origin failure recovery configurations.

        This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        '''
        result = self._values.get("config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30c18e5e3924e572f0cc9b0478234119db4734860de50b633377c8df60d44896)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigName")
    def reset_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="configNameInput")
    def config_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="configName")
    def config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configName"))

    @config_name.setter
    def config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6af42acb38cde787116978d6fe591dc1a21c3a23e39a1a80a47cca145dcfb3c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e6f5bed8e9532070cb4fc822af1ecdf5a94740b922b2de7d3d2c6dd98beb2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a60fc5a7b26ce6bd85923d169dea109e8a980a6a81bd62305b175ff65a94acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcd6ac05bd5704237ac6e27ef60fcd96523e7df8a79688bc8423d5b664881d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f6d7875d989f2170ff3d80f8bd508abc8ff8797c8ab756658613197704ac10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression",
    jsii_struct_bases=[],
    name_mapping={
        "case_sensitive": "caseSensitive",
        "locked": "locked",
        "match_string": "matchString",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression:
    def __init__(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bc4fd6a7978a07bdbcfaa49b9c1e90a44ab66016ec1dfe037feef6aa0bc7908)
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_string", value=match_string, expected_type=type_hints["match_string"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if locked is not None:
            self._values["locked"] = locked
        if match_string is not None:
            self._values["match_string"] = match_string
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive regular expression match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_string(self) -> typing.Optional[builtins.str]:
        '''The string to match, typically the contents of a dynamic variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        '''
        result = self._values.get("match_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''The regular expression (PCRE) to match against the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba99dcce2be6de0ce5bcd715ef079bbf9f4c52948886eeba12925f203c9f7cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchString")
    def reset_match_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchString", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchStringInput")
    def match_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchStringInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a47ddb494f107834aac73b8cab1938e614760664cce7f1a709c08860005a522)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe81076d4c5262e413bd08f5e58a30dac7d4f73c9bf4e38d0e911363e2ffb17e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchString")
    def match_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchString"))

    @match_string.setter
    def match_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8d983b91e6fb04f7e4986b939a99a00251916d3997a2e613731181f4109419e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchString", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcdc89eda1e71b4583f8e833098a81d115b3a2758c321d74298bb9b9334a081a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d4d1124468426cadfd37ec75263ce600a8d44d3d6abe865c4eb3bd649f3997a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0e770c5003db3950e2f1155ed5f39e49fa74b4ea4fb09bdea8aa84dae0b8267)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07f2d5fc50d0ee78c64e2969dd4beae184802efabbc0a4affba6080be0afd99b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__575deccca2ef75bee691ce2770f172f78dc32f6456b1c752d26157ca23d5a9f3)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''The name of the cookie, for example, ``visitor`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``cookieName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The cookie's value, for example, ``anon`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73efaeda09228504578ca6f096af8205914f26ddc3bfdbd252e58bb4ad1bd041)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da2424e99ac7816673eb4320dd5238d913ac4b29b9a1f32ebbebf6005bd3b51d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__731c89ef84b0016138aaf0095f76e92a79e267a7e589cf5ded9319d484a1594a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1eda6056c91d54af51b5f3127ecc6786e5736b872c4bcd581f01aa348bc246db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbff4cb6769d75c08d6846b8222db27b3a80aea35e6527b659997184e62f1ea4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831e934cf57a7f85427d545bf319feab07060116aeaf88bb31d4b830317343c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e52c10e7e27f93a5a77f6fc271928423e633a9f9494127e7f38c59821008b1f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e8abfea17851f338b295f08bd2e0137e9c3dba32b8800b445b7f411918650e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1dc4fc3bdf148257a7386abe752b29ee7a699e3d28e88288668cff995fa1db8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__135c7d132e048021b8bfdfd57cb9008232e2d3d96321a78da969fe3b1f1a292a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24feea3ab4a9c9d1da05d4268e8fdda0027c0a880c9fb988a72dc2864cc77822)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf486804cce84bb1619f2c581ca40f979663d0ada7a26a8b33dd9b5597291dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f37a97124512895155f7b335db5913159a528526eab4248f63d791a9fd51499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f5a54c78f8a7cb5ae103b7185a2dbd6955dd85e253a1feea737ed856a19ee21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e26b355e336a927d7d4448efd99cff40920e784b64b904a321aa3d5470f06c56)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the request header, for example ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04a2ba3bcbcb69546fc94996ad6984c0e3d186dbd929a0da70194bd77abeff6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08db75ee33dbca3c49457164ab6dc69e72a99ce2c81f792f73a9ff8390c5e431)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3190573153885aadaa832278bebadd6613fc290c52d5e5d627bbb0914d21d858)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aa997597d9e58f713d19bf622eb5cec29baf658fed9d65133a6c6cbf0725669)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f0e4ae1bec4247ea9fec50194e866208f212efb5f26982a7e57a1198d5a80b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e85e99a046752d793d17f1b0a76b8ad1c6df1f5f4f94ae7bbd293e58a0bd04cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0df3d1b180866c61df53c19c9ba3f2227c0ed1d3650a59fc6d1bcd6e8283047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212892bbb7064116c3384bbc3e0f70df3819a36585dadaa823310f3d823fdabd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8952aec0e196f7c301b8308a39105bdb5d3056f3320f891f1d61bbc252ab9d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cbde22fefe68327143554d9ec1b53d185e824c8718faac5ed6a600933803ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aeac12b7a7e51478fbe99d0f8ee9543393c3b1bdba6ab7cf10afbbb2b6061e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6d4b41d1b8aac1635b7799f8b770b0025a4f8ae388d92db59050689eefcb7c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Any of these HTTP methods,  WebDAV methods, or Akamai operations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e41c51615eb2fca7efe86b78a6d06258a6740685504c47a653701c0cf6777e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45fccc0e87392bc5659f3da0ebb5b2137675a6492157855580a51968cc11d7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__170aa28233aa70c7389a6b2e5e96d0c68d6614c50d2c7b755734380b53aeb56c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a6cf27dbb69d6e5e7453c80db5840d137c496ac3b78ade1f0e3651cd14163d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d799c2d83524de55a9e42fb526401bdc1703933132a46656854eb8a5e37f0bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d29aeb324dcb2b3fcd994a67c602891ce756e64b3bcabdf4c5754d77b8f3790)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45868a09609053ae8992377d69f5917bd0a1f74165e36af059758a514eda937d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a223c5ffdc4b47379c33478abea59fb7ef1918092fa7d3efc1bd0e23324eaa17)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bc63758625fd94ba090130ade85e1ebf212304e21f21d156dc79267064af77f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65e652af17d009b99206d8a4a694abaa3c13920035d29a1c5165e29b427bf4e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d25c516f32ccab40cef96af068f40ac06d654b426dcd2cf2228686c0b29dc25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9d712db69971aec9f5f1590a774ae633b37891d2a47f78865a89cee3a0c9484)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0de0686871f942446a861c8f81d3534813e84a9f0b12576f3db6927f2f8d638f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b40d4709d4aba2e9c5e663e4dad09e1307e64de91655e02d5d763c33d7cd027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b59ce31c6b7adb9303432d15fabb0f2a3cbd24ae1aea98abd56b15d2ffa24e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f00d2252308e4ab5eedf17ebddd6f3a1c148cb85183e2665da9f12e7be67744)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8cc6d739b9639d32b5040bd4041c0cfaf3715e2d663afc0f2f7107b6e902aca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ebbd1f6ef6e3b11470d67fa46b4813ebd6e034ad13a8a9060ed17cb8f346788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3574fa58555a347da693c8fc12a1dee797051dd89c60e71a61d7daa358ff0ec8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee096c4b8efbb5ea22a324a326d13d3709ed072556e05640f419bacbea2c3f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09c5c06e79b5e2681a90636b72145b693e42732d2d4b4c5ed0e271af0716b1d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb276d4c87684e46b30402915b7d27ead9e09111c00e87f737e5264d37281313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd138cfe9a3685729d6fc300bf552d5d71f4cbc972ba6ecadc2afaba6b147b2)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the response header, for example ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the match is case-sensitive for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match according to various criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__513a21b7cb18e48ccf3c23f9757e90fc4a71e60bf1f247ccbe34d179bd264bb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ceca6d622ba5547da52ce28caf61863e5a4ef8e0f01764875ffc7468e312f24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b3e3c9efe29e89133914160aa8bb6a3f2c48d5e08185cfd43507565f3670caf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9556ab3c1e54b976faab8aa985a948e2a5bf8a759acee0feb0b97668b91f8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e294837c78283da2203cffbb20e49bc68a19f3c4bfa28ef7e4a4d3cb45cdf6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f95fd20db1de0429f250d26138175e9f900b2aff8ccfc4e6b7ed5bcbcab2f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cd95c5169966759835c6a06e2244dbbbbad4ba770401b7626b0afabbab48dcb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7894b19c92f5876823144c258cb1c17ab54033dac6d11c96a19bb37105f3ae62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56bbcd3ce4c59a666d233260ec8612c9f8e5f6a91a699995dd9acaca6cdcf5f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80ebf5e3c6d5c6c6c9c4e57c45ec6b46c6646239951f809e67f4237ff9db13a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ead92513c0b7959b6db40c7be2143d2bd72df864242cf0acf3e662b76393bcd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd7d9adb4bcb9662efa2b533a0613d54c2916b83b11ef527ade0129f49b9da36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b18a8552f0c86b5bc5fa900c8e3ff9dd6171282360d0d8599a942975572d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation",
    jsii_struct_bases=[],
    name_mapping={
        "continents": "continents",
        "countries": "countries",
        "location_type": "locationType",
        "locked": "locked",
        "match_operator": "matchOperator",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation:
    def __init__(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dee144618b099e5a1ddee9139e04dd72c99f7f21522de9053d96230404733f2)
            check_type(argname="argument continents", value=continents, expected_type=type_hints["continents"])
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument location_type", value=location_type, expected_type=type_hints["location_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if continents is not None:
            self._values["continents"] = continents
        if countries is not None:
            self._values["countries"] = countries
        if location_type is not None:
            self._values["location_type"] = location_type
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def continents(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        '''
        result = self._values.get("continents")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def location_type(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        '''
        result = self._values.get("location_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50c44d7d25538068fa5124ba8aff9eb759061cffe316fc20ff99b149b3d8da2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetContinents")
    def reset_continents(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinents", []))

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetLocationType")
    def reset_location_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="continentsInput")
    def continents_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentsInput"))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="locationTypeInput")
    def location_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="continents")
    def continents(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continents"))

    @continents.setter
    def continents(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f21e966487f9f9369f8fdcadd55a1e4f8f7a8a820fc915e7b30e986209c5156e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continents", value)

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88ea9be71c0b4fb6c0ded28730c948a8b4094c4f9bee29966fdda2037556774e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="locationType")
    def location_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationType"))

    @location_type.setter
    def location_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e96e33b700a682a1e50bbc7803cbabdcbc078a52d6c152e9d6157a3130edecc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c8f210861a9fbb530c460b8822dc96a00832085a8f7e3d89f823b23bce938e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffd6c3736271ca7401f2c1d1145c6e5141873a8d2fe5db1490502a6693ac245c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f40d3343e928718301b01f5f9fbc7c9a8f28e41cbd8aefe1c6f17b0e904d9b22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730603a34b604467071aae73f03593e77e25908e6e305f2b8e0e74d336f4bd06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cabc7c821fb61060bd7a93070ea07e124f36ca55499c9cee378d26d4b2b56a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ab94c7f45650facd9931844d72aa3b4924e906df6aa2154fd934ba35e1f4a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime",
    jsii_struct_bases=[],
    name_mapping={
        "apply_daylight_savings_time": "applyDaylightSavingsTime",
        "begin_date": "beginDate",
        "end_date": "endDate",
        "lasting_date": "lastingDate",
        "lasting_duration": "lastingDuration",
        "locked": "locked",
        "match_operator": "matchOperator",
        "repeat_begin_date": "repeatBeginDate",
        "repeat_duration": "repeatDuration",
        "repeat_interval": "repeatInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime:
    def __init__(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a46f4c67ebbbd2b093b15b37531022513dfdcfc9a7ba2f945241863e9287265)
            check_type(argname="argument apply_daylight_savings_time", value=apply_daylight_savings_time, expected_type=type_hints["apply_daylight_savings_time"])
            check_type(argname="argument begin_date", value=begin_date, expected_type=type_hints["begin_date"])
            check_type(argname="argument end_date", value=end_date, expected_type=type_hints["end_date"])
            check_type(argname="argument lasting_date", value=lasting_date, expected_type=type_hints["lasting_date"])
            check_type(argname="argument lasting_duration", value=lasting_duration, expected_type=type_hints["lasting_duration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument repeat_begin_date", value=repeat_begin_date, expected_type=type_hints["repeat_begin_date"])
            check_type(argname="argument repeat_duration", value=repeat_duration, expected_type=type_hints["repeat_duration"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_daylight_savings_time is not None:
            self._values["apply_daylight_savings_time"] = apply_daylight_savings_time
        if begin_date is not None:
            self._values["begin_date"] = begin_date
        if end_date is not None:
            self._values["end_date"] = end_date
        if lasting_date is not None:
            self._values["lasting_date"] = lasting_date
        if lasting_duration is not None:
            self._values["lasting_duration"] = lasting_duration
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if repeat_begin_date is not None:
            self._values["repeat_begin_date"] = repeat_begin_date
        if repeat_duration is not None:
            self._values["repeat_duration"] = repeat_duration
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def apply_daylight_savings_time(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adjusts the start time plus repeat interval to account for daylight saving time.

        Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        '''
        result = self._values.get("apply_daylight_savings_time")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        '''
        result = self._values.get("begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_date(self) -> typing.Optional[builtins.str]:
        '''Sets the end of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        '''
        result = self._values.get("end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        '''
        result = self._values.get("lasting_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the end of a time period as a duration relative to the ``lastingDate``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        '''
        result = self._values.get("lasting_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies how to define the range of time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of the initial time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        '''
        result = self._values.get("repeat_begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of each repeating time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        '''
        result = self._values.get("repeat_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Sets the time between each repeating time period's starting points.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTimeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTimeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81cd2260773d2cd8b219d47f548aadc0bd09b25e275e9fc77e5dab6bf8e3f967)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplyDaylightSavingsTime")
    def reset_apply_daylight_savings_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyDaylightSavingsTime", []))

    @jsii.member(jsii_name="resetBeginDate")
    def reset_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeginDate", []))

    @jsii.member(jsii_name="resetEndDate")
    def reset_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndDate", []))

    @jsii.member(jsii_name="resetLastingDate")
    def reset_lasting_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDate", []))

    @jsii.member(jsii_name="resetLastingDuration")
    def reset_lasting_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDuration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRepeatBeginDate")
    def reset_repeat_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatBeginDate", []))

    @jsii.member(jsii_name="resetRepeatDuration")
    def reset_repeat_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatDuration", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTimeInput")
    def apply_daylight_savings_time_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyDaylightSavingsTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="beginDateInput")
    def begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="endDateInput")
    def end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDateInput")
    def lasting_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDurationInput")
    def lasting_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDateInput")
    def repeat_begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatBeginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatDurationInput")
    def repeat_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTime")
    def apply_daylight_savings_time(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyDaylightSavingsTime"))

    @apply_daylight_savings_time.setter
    def apply_daylight_savings_time(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50aefcfa821793adff60cdfd918a379de69e291054c1bbeb19a6f85662d66cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyDaylightSavingsTime", value)

    @builtins.property
    @jsii.member(jsii_name="beginDate")
    def begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beginDate"))

    @begin_date.setter
    def begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d8f62ed00d38fa3fbca74391a971aa0b3594a816b6475690282400ca364d9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beginDate", value)

    @builtins.property
    @jsii.member(jsii_name="endDate")
    def end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endDate"))

    @end_date.setter
    def end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988702f2b1dcc576ee218434ec3816fb3262bcadab340647c0ac5b8f96641769)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDate")
    def lasting_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDate"))

    @lasting_date.setter
    def lasting_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3728c98cdd9f1025c3e31d05ae694e29c55a26b884748604ba4f869347eaca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDuration")
    def lasting_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDuration"))

    @lasting_duration.setter
    def lasting_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__346f9b732aef2872d9fc661641bc59930581dd81a13bcd546d67c48e9d06651e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8c7004c93a2981b87f0061c66d3799d807b528f7dad0cec1079c164cdb7765d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad54fdb46f0d8151b5d6521bf56b7819fa9e76f7e46c3bd91442352068ce7b90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDate")
    def repeat_begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatBeginDate"))

    @repeat_begin_date.setter
    def repeat_begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d8ad20b39654ac01957bfae89c9d15d99de234b4d5becf15a79902787ecad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatBeginDate", value)

    @builtins.property
    @jsii.member(jsii_name="repeatDuration")
    def repeat_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatDuration"))

    @repeat_duration.setter
    def repeat_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2becaae24c2bef0ba752e2fbc32a761028d8f6567ff0f0a7925033331269d20b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatDuration", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4d5b99280c3995c752a101c9a3b97c028d50da04903c6356f1a8e9e35ec7c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192ce26c2a2a67b9688c29cdc145ebd6df6895cf4909aa9c3c0a9dd6dcdec9f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4038a90a0de0e6ad3476831f5e73b915b063e15130a1720635ba0881e13d2291)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08e003d31bd5ca81488348b05442e2a74b9193da7a02009d5261d4aa78b61993)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "status_list": "statusList",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea8c73cd5a52f76635f43a413ca570921e2eb0f93558151fa87a3efc49a2a4cb)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument status_list", value=status_list, expected_type=type_hints["status_list"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if status_list is not None:
            self._values["status_list"] = status_list
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Error match scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_list(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.'''
        result = self._values.get("status_list")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf2950b56b9b775b0ee26a1de9e1809bba69037e58a742776db597c596f85f37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetStatusList")
    def reset_status_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusList", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="statusListInput")
    def status_list_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "statusListInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db3347aa9bd00efe6c3291c0cb10e3331829131a600895f3fcc73e43652f5d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89037adce21169b4d67c46e3d98e90cc721cd4ee9eaed15f82f07f8c8a5e18db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="statusList")
    def status_list(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "statusList"))

    @status_list.setter
    def status_list(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa3da746c1effb554ea47fd9bc0ab85cc2e02bcdee527e3392a8f17abc7173b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusList", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cd98e24602c6fd69c10e3a52996edd0a805ecf9e39d7c1183ca86318cadb5ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be41ebfd82fde5bd4f6819a28429b2c773e1d6a92273287b84014968e3dd97ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3303b926e2d9f6c292ca5ed890461d6a9df531d4cb94db853f0bc54595477ca8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d457a2a596839a2c4f50d5cfc8fcbea2183111c820ed239c78b6f62b90f6e990)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__322dacebe404006773991d19d91943e7bf7a38069220cc8838f5a03412954c7e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1452148a59115f268d48f81cbf28f8371da9ae245de56529c9afa9cc00523ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d87eccb4d599bfb1b8adc0a028e998b8ad021210b54be221bb6c7f810acdbdc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2142e372cdf2525a7fdd77208118393d20f36ed2769c509b76da2d936517ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17aff5771ded57f05f3e8211804e6f9a8d14e974550988f21bf1af6c4b09cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a75cc0e0d99b17526e9f3467955219fc329ab83a061402cab617462600c960)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3250cd8c45f2822f3f1a90187e0bf89fb4969dfef1f4ea35d8193ded9e384767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a304c1f58efd92782f3ee7487d540e77a065c565ffa751edf802c9cab080c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f00d3212cae322a42879585bd55acb8a17484ce40d0a1495f39ee1a0fdc1757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation",
    jsii_struct_bases=[],
    name_mapping={
        "check_ips": "checkIps",
        "continent_values": "continentValues",
        "country_values": "countryValues",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "region_values": "regionValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation:
    def __init__(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a461bc51a61433a8c8bc2ca2d5735c7000c39e44cafca9cbdb836ee49208d20)
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument continent_values", value=continent_values, expected_type=type_hints["continent_values"])
            check_type(argname="argument country_values", value=country_values, expected_type=type_hints["country_values"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument region_values", value=region_values, expected_type=type_hints["region_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if continent_values is not None:
            self._values["continent_values"] = continent_values
        if country_values is not None:
            self._values["country_values"] = country_values
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if region_values is not None:
            self._values["region_values"] = region_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def continent_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        '''
        result = self._values.get("continent_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def country_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        '''
        result = self._values.get("country_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def region_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        '''
        result = self._values.get("region_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaf708d1a1829fb8c7e807aee949d3f016567fc1b50f5eac7d89a08dd3a8ef37)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetContinentValues")
    def reset_continent_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinentValues", []))

    @jsii.member(jsii_name="resetCountryValues")
    def reset_country_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountryValues", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegionValues")
    def reset_region_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="continentValuesInput")
    def continent_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="countryValuesInput")
    def country_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countryValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionValuesInput")
    def region_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f15265107b0cc7733102dde7e80d6db9fdbce4ae4e1433a0bf9159216cd1db7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="continentValues")
    def continent_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continentValues"))

    @continent_values.setter
    def continent_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae8c5dcf5a7c959abde388db3f66b935a8dfcfddfa15290ccbca2726956f829)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continentValues", value)

    @builtins.property
    @jsii.member(jsii_name="countryValues")
    def country_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countryValues"))

    @country_values.setter
    def country_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d38c287bad4ae2b85412c60ffa631fdd08b966248748c79362167d21ad79ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countryValues", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c4ccbda164677ef472a8be555fd7aa4607992fbb42f9f46a24ccbeef64adab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6329a913fae2afdc64a442a00fe176873021c71ba399e40a4e956248c101d3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__320fed49d6e123fdeb02d3805d0c52464cd36670cc0fcd654e70abfb1956e9e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regionValues")
    def region_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regionValues"))

    @region_values.setter
    def region_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59aa0578b5ffa92e0a5fe7c5048805e87792d78814d83a9dd831545124b02cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regionValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ff7500c44ea5a01d96115d6722fed61a98ca97f091a71c3dd90823660cea83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36220cb9462c192f4cf11677fb538572e1be8457f74e2f43f74f7d755f8a871a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f332dc499c16bc1f1eb3e221578e33b007861286d52e0c654b23318df22064a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0b6336db8cb7c34af42ab0325fa7a31336ed3c098e643be5ee39532045b214c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "bandwidth_values": "bandwidthValues",
        "check_ips": "checkIps",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "network_type_values": "networkTypeValues",
        "network_values": "networkValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork:
    def __init__(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca48777fda14068ee511771c52d43a1e0066ed49ec7103e7504cf3354549d72)
            check_type(argname="argument bandwidth_values", value=bandwidth_values, expected_type=type_hints["bandwidth_values"])
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network_type_values", value=network_type_values, expected_type=type_hints["network_type_values"])
            check_type(argname="argument network_values", value=network_values, expected_type=type_hints["network_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bandwidth_values is not None:
            self._values["bandwidth_values"] = bandwidth_values
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network_type_values is not None:
            self._values["network_type_values"] = network_type_values
        if network_values is not None:
            self._values["network_values"] = network_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bandwidth_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        '''
        result = self._values.get("bandwidth_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''The type of information to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network_type_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.'''
        result = self._values.get("network_type_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def network_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Any set of specific networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        '''
        result = self._values.get("network_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6e0b9e7f28362a15cd03e322ce74fe40be3bca9d2e48a372eee5bc41445b30)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBandwidthValues")
    def reset_bandwidth_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBandwidthValues", []))

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetworkTypeValues")
    def reset_network_type_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkTypeValues", []))

    @jsii.member(jsii_name="resetNetworkValues")
    def reset_network_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValuesInput")
    def bandwidth_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "bandwidthValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkTypeValuesInput")
    def network_type_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkTypeValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="networkValuesInput")
    def network_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValues")
    def bandwidth_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "bandwidthValues"))

    @bandwidth_values.setter
    def bandwidth_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfda356e50da624cca699034ceefcc4c958405a4395f3e74739954afdd8d5a57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bandwidthValues", value)

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b036d542580001aaa08ac2b43f4b2fa87abac3eb495563afbdd127e1663ad4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e22b6352e7acb1513ffaa35b3431d354ddd96796dbed650624c75d225bcd5d70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__531debc73e1f2e44ef785d2f0342f8ba0d5c96e53a16a7d7bde206a8eee594aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c0a6eb10438ab5f765f78fb1582c80dcf38ba46081bbe13c626a7b40d0b3e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="networkTypeValues")
    def network_type_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkTypeValues"))

    @network_type_values.setter
    def network_type_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad4b09a1732e71800a56dd7eb86ee5b4bae4dc0ef08b374a4972ab5d6b98f331)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkTypeValues", value)

    @builtins.property
    @jsii.member(jsii_name="networkValues")
    def network_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkValues"))

    @network_values.setter
    def network_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a07c488c24c47024c443a45d1fceb646ba2fc5cd018c3ea612a662ea31b21cf3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4215a44f10a1932233d77805981233f66efeba5e7c0a1d2c4937d03aa641a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fbc9a62785431d0d1706e17b2677b682c8ff501329db3fa5ed731084e77032a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a61ebb55a687042316c30e9228731405aca38eef18c5414800a541501c60f28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__301384aef514ba7809d8a9100aef6c143226ed33bb911d598c7df1be654ddbc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "result": "result",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_names": "variableNames",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5fd7d3021e1efb6a7f546ca63a37ca1e2d035dae809db1a71ae1647a9a1b1e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument result", value=result, expected_type=type_hints["result"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_names", value=variable_names, expected_type=type_hints["variable_names"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if result is not None:
            self._values["result"] = result
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_names is not None:
            self._values["variable_names"] = variable_names

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def result(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        '''
        result = self._values.get("result")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name.

        Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        result = self._values.get("variable_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a659fb8a24e789a6bd1c9dd08904194bfe515ba9c85ff706bb39f17bb5269c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResult")
    def reset_result(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResult", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableNames")
    def reset_variable_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableNames", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resultInput")
    def result_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resultInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNamesInput")
    def variable_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d73211f70d08def9d976fb6f52698a1594261566177959cadffa16ae9d03b52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="result")
    def result(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "result"))

    @result.setter
    def result(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83ed3160c4cb954328eb7564637795aef13ec27788ee1f3a47e69f21446d6439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "result", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d99b21a6fa586bafb0411eb11a8d06526d4a18424e7f23f2ebb7508f9974886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13b52ae761336b0970ab0b2b28f42d90316036f7ed893393656e87d8469f764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableNames")
    def variable_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableNames"))

    @variable_names.setter
    def variable_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0eccfed6630e63c2cd8884666a8eb6675c4b6e1d8652d9fc13c4e5489c0933af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableNames", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33760837f55497909ee9bca4cae5cd453c9c6641292be756129218ccdc42b303)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b8f913a9bec5097a8b9d0e9fd74faee878f4b0a36b2fb114d67dab176ec526a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``virtualWaitingRoom`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f7af969f9bb82399683b0672db52005cb0839b54ed7582f42d6eeb6004b0a3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01333a8a23d294ea7f9f6d8197e376d47ccda6fd358bb6b31005d8b26fc29be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7ec9b5b6149bc4c05e1174ba7e973fa9a25fedecac75a3897baba4a7efd2b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__320c107062687a39c24c7dfe04829e7d3bf824c51d7df014e5a005449269a75d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728cddbf5ab977a7a911543ae998536cfd8d427e6bf29230a133a0aadd9bf26e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdd128d013d34900bd762a35c5d387c6317d9bf86cf7b9a2f5739b9edb892925)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__991c7e2bd190abdc3cee2c0573747871fb2ff5d73cdf3292bec96208d426cff8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4898e3a4f2c89b2e42a45ac232285eb63d07ab96c8d41471c52ae575d3cd5a6b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bfc827bafb23b61f8f7b3b197ce9fc0246eac95ddf62a040812d38375e19f38)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ee7aceae9d4d6b888e0e03ff2ea1a2ed66f5bb298235c973854806ba305ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aceebeec00a8f1c183d77b41bf84c758beb473fb609a641f82aa9013a56aaa89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e560c55e2966935b9f08117394e4c43b428f9d6670f588373ed154e3200fb30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6348b6130fc58d47496543b8953324b3c071b78657ba85c94234d106f5876360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b601ec34ebb62b524b6d20a7d4969db0f3330bcf7cc5427751c94b456d1dcc88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fd9e117c9e731835ae10f47c736a0c3be564d1ea8e6accea25ad100340f314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride",
    jsii_struct_bases=[],
    name_mapping={"name": "name", "override_id": "overrideId"},
)
class DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride:
    def __init__(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7111fc72581d70d809c70aa7c90ace993a5484b5792aee49a7190209d2e1c4fb)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument override_id", value=override_id, expected_type=type_hints["override_id"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if name is not None:
            self._values["name"] = name
        if override_id is not None:
            self._values["override_id"] = override_id

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''The name of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def override_id(self) -> typing.Optional[builtins.str]:
        '''The ID of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        result = self._values.get("override_id")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__990a807e3fd59e279589a52eb4a36824c1737e50ef5ba3b56a6f0979855ee069)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetOverrideId")
    def reset_override_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideId", []))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIdInput")
    def override_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideIdInput"))

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__935dbfba0a0d88d3043cce50f229f268d2154d1751b819031fd331724a7aad06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="overrideId")
    def override_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "overrideId"))

    @override_id.setter
    def override_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab79eb777dfbe00e3cfca61d5a1bddbbe61f36069ed642d269583c66380ede22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideId", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b884212ff24f4cd4d05e8c473a777f74d71e085613c98aafbf7d8d993d1a8047)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b24d5b86074c4e79044531a8650d25046f736a2348985ef3ffa581adbf7be41)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBehavior")
    def put_behavior(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0b4cc7db41b3a16e0734e692b9eaba4990bdbf2e66b5d551ae8796d942261f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBehavior", [value]))

    @jsii.member(jsii_name="putCriterion")
    def put_criterion(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__455a126670d6d1089893276ad10fbba9fff9e196b69beb17dc4b7086a00ff2cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCriterion", [value]))

    @jsii.member(jsii_name="putCustomOverride")
    def put_custom_override(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride(
            name=name, override_id=override_id
        )

        return typing.cast(None, jsii.invoke(self, "putCustomOverride", [value]))

    @jsii.member(jsii_name="putVariable")
    def put_variable(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20231030Variable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa4a91bda348758dff5c880a974a271e45dc8ec74730b298c3905aff13f8dd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putVariable", [value]))

    @jsii.member(jsii_name="resetAdvancedOverride")
    def reset_advanced_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedOverride", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetChildren")
    def reset_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChildren", []))

    @jsii.member(jsii_name="resetComments")
    def reset_comments(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComments", []))

    @jsii.member(jsii_name="resetCriteriaLocked")
    def reset_criteria_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaLocked", []))

    @jsii.member(jsii_name="resetCriteriaMustSatisfy")
    def reset_criteria_must_satisfy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaMustSatisfy", []))

    @jsii.member(jsii_name="resetCriterion")
    def reset_criterion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriterion", []))

    @jsii.member(jsii_name="resetCustomOverride")
    def reset_custom_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomOverride", []))

    @jsii.member(jsii_name="resetIsSecure")
    def reset_is_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSecure", []))

    @jsii.member(jsii_name="resetTemplateLink")
    def reset_template_link(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateLink", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariable")
    def reset_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariable", []))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorList, jsii.get(self, "behavior"))

    @builtins.property
    @jsii.member(jsii_name="criterion")
    def criterion(self) -> DataAkamaiPropertyRulesBuilderRulesV20231030CriterionList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CriterionList, jsii.get(self, "criterion"))

    @builtins.property
    @jsii.member(jsii_name="customOverride")
    def custom_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverrideOutputReference, jsii.get(self, "customOverride"))

    @builtins.property
    @jsii.member(jsii_name="variable")
    def variable(self) -> "DataAkamaiPropertyRulesBuilderRulesV20231030VariableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030VariableList", jsii.get(self, "variable"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverrideInput")
    def advanced_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]]], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="childrenInput")
    def children_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "childrenInput"))

    @builtins.property
    @jsii.member(jsii_name="commentsInput")
    def comments_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "commentsInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaLockedInput")
    def criteria_locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "criteriaLockedInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfyInput")
    def criteria_must_satisfy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "criteriaMustSatisfyInput"))

    @builtins.property
    @jsii.member(jsii_name="criterionInput")
    def criterion_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]]], jsii.get(self, "criterionInput"))

    @builtins.property
    @jsii.member(jsii_name="customOverrideInput")
    def custom_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride], jsii.get(self, "customOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="isSecureInput")
    def is_secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSecureInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateLinkInput")
    def template_link_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateLinkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableInput")
    def variable_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Variable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20231030Variable"]]], jsii.get(self, "variableInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverride")
    def advanced_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advancedOverride"))

    @advanced_override.setter
    def advanced_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a3105cf776ad2796e75d1a0e64e5909470666baed639e8ea41f1e3a09dfcbd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advancedOverride", value)

    @builtins.property
    @jsii.member(jsii_name="children")
    def children(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "children"))

    @children.setter
    def children(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de39cc9071b96124b6f50c1a7b9d975827c85422a92de899bb8314fd259bf2fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "children", value)

    @builtins.property
    @jsii.member(jsii_name="comments")
    def comments(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "comments"))

    @comments.setter
    def comments(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16ad930d84c9297a6c525a0380c951c7b3f256e41991b48106046c1269081e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "comments", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaLocked")
    def criteria_locked(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "criteriaLocked"))

    @criteria_locked.setter
    def criteria_locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da617199a37ee70898eb56bfbb346bef7ed4293fe217ee747c0caeab84280da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaLocked", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfy")
    def criteria_must_satisfy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "criteriaMustSatisfy"))

    @criteria_must_satisfy.setter
    def criteria_must_satisfy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0e7ba58b32f3cbb224f9efc9d6edea86033b4ad540f923e50c26d01fc67124d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaMustSatisfy", value)

    @builtins.property
    @jsii.member(jsii_name="isSecure")
    def is_secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSecure"))

    @is_secure.setter
    def is_secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06201d9fec4d9bc025d0ea8196b2362bb7893f9b1107451b6b0558fed36b9a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSecure", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f5c9c3c6028c284408b03cb66a245872f1e3f7727f8698d75876d70fcb4c72f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="templateLink")
    def template_link(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateLink"))

    @template_link.setter
    def template_link(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d7e78ce30f7d12d82f725dc67ef1282a70b45e06d52d14f24ac07eb76c18957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateLink", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e93f39c5c5fb98924b60bba52ba3505bdf173ce461731e06c7c4721080f86a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c2b06004af44814e9f1bc87de1e087addb4f22d51f485c9b4fb0f53924d90f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a7567b69688bcd7229478a64ebaecdc818673a1faf92f12c75d7fd756cafce2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030Variable",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "hidden": "hidden",
        "name": "name",
        "sensitive": "sensitive",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20231030Variable:
    def __init__(
        self,
        *,
        description: builtins.str,
        hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        name: builtins.str,
        sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        value: builtins.str,
    ) -> None:
        '''
        :param description: The description for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param hidden: Whether a variable should be hidden. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        :param name: The name of a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param sensitive: States whether a variable contains sensitive information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        :param value: The value for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f78392066eeb11606b75355cb8f02afcaaa476d1b6f5741bbc7cf9117b7c211)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument hidden", value=hidden, expected_type=type_hints["hidden"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument sensitive", value=sensitive, expected_type=type_hints["sensitive"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "description": description,
            "hidden": hidden,
            "name": name,
            "sensitive": sensitive,
            "value": value,
        }

    @builtins.property
    def description(self) -> builtins.str:
        '''The description for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        assert result is not None, "Required property 'description' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''Whether a variable should be hidden.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        '''
        result = self._values.get("hidden")
        assert result is not None, "Required property 'hidden' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''States whether a variable contains sensitive information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        '''
        result = self._values.get("sensitive")
        assert result is not None, "Required property 'sensitive' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def value(self) -> builtins.str:
        '''The value for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        assert result is not None, "Required property 'value' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20231030Variable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20231030VariableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030VariableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e731a17ddffedb426dab82d80175d6d7ef9dec62867630ae0b7850691904af51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20231030VariableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4869df89cf49bc0e2ec45933d68ca74330d42d2bf3d5da177f8dc769cdafd61f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20231030VariableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d0eccbf761b4d70233be3ca25c13749843e709a248adb2ada4a7f7c1f299d0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d1072c8ca5729d4570bd57ec9d1888922714a2f063ef32d479c3d7acbfff1dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f7ffe44fb934454100d34ae2a32563f0c2720f018db08b465618746f8693fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Variable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Variable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Variable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91deaed8619c77715e95632f95cda8037687254470df9b5a47000d151f1b9be7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20231030VariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20231030VariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d977bc8a69c851a88e811d51cd5fcecf43eea8cacd377834821417f688255f51)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="hiddenInput")
    def hidden_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hiddenInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="sensitiveInput")
    def sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e37f5da8daefa6d8b8333001a60a8718dbc56ac63b5ea96903388afd6e7472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="hidden")
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hidden"))

    @hidden.setter
    def hidden(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea028025ae5747f9fc4d4d9878a1f48096530d6f7d17ac6c85a6ee194e15d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hidden", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2834df03cfd6f3845aabd379fd87a963c58a00977c4c2e5905a7199e0cd8d23d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="sensitive")
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sensitive"))

    @sensitive.setter
    def sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a33bafd5244e53f507e1514d633e5314f911ee6bdeb25c32d0279d377c92e6af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sensitive", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dc8690f4e71de566dca889950c2914238c46ad4bb2d64408453dab655ad6cfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Variable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Variable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Variable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292e7d97c809f8eb3336c77b92e77173bb8a6c639cbde4ca2e2d8015fe60e938)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109",
    jsii_struct_bases=[],
    name_mapping={
        "name": "name",
        "advanced_override": "advancedOverride",
        "behavior": "behavior",
        "children": "children",
        "comments": "comments",
        "criteria_locked": "criteriaLocked",
        "criteria_must_satisfy": "criteriaMustSatisfy",
        "criterion": "criterion",
        "custom_override": "customOverride",
        "is_secure": "isSecure",
        "template_link": "templateLink",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable": "variable",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109:
    def __init__(
        self,
        *,
        name: builtins.str,
        advanced_override: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109Behavior", typing.Dict[builtins.str, typing.Any]]]]] = None,
        children: typing.Optional[typing.Sequence[builtins.str]] = None,
        comments: typing.Optional[builtins.str] = None,
        criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        criteria_must_satisfy: typing.Optional[builtins.str] = None,
        criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109Criterion", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_link: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109Variable", typing.Dict[builtins.str, typing.Any]]]]] = None,
    ) -> None:
        '''
        :param name: The name of a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param advanced_override: XML metadata of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        :param behavior: behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param children: A list of child rules for a particular rule in JSON format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        :param comments: The comments for a rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        :param criteria_locked: States whether changes to 'criterion' objects are prohibited. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        :param criteria_must_satisfy: States whether 'all' criteria need to match or 'any'. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        :param criterion: criterion block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        :param custom_override: custom_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        :param is_secure: States whether a rule is secure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        :param template_link: The template link for the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        :param template_uuid: The UUID of a rule template. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: The UUID of the rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable: variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        if isinstance(custom_override, dict):
            custom_override = DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride(**custom_override)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e66f021419346055dbbc5de45a62a1f4e53d088f70b57ec2f9e461497550c40)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument advanced_override", value=advanced_override, expected_type=type_hints["advanced_override"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument children", value=children, expected_type=type_hints["children"])
            check_type(argname="argument comments", value=comments, expected_type=type_hints["comments"])
            check_type(argname="argument criteria_locked", value=criteria_locked, expected_type=type_hints["criteria_locked"])
            check_type(argname="argument criteria_must_satisfy", value=criteria_must_satisfy, expected_type=type_hints["criteria_must_satisfy"])
            check_type(argname="argument criterion", value=criterion, expected_type=type_hints["criterion"])
            check_type(argname="argument custom_override", value=custom_override, expected_type=type_hints["custom_override"])
            check_type(argname="argument is_secure", value=is_secure, expected_type=type_hints["is_secure"])
            check_type(argname="argument template_link", value=template_link, expected_type=type_hints["template_link"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable", value=variable, expected_type=type_hints["variable"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "name": name,
        }
        if advanced_override is not None:
            self._values["advanced_override"] = advanced_override
        if behavior is not None:
            self._values["behavior"] = behavior
        if children is not None:
            self._values["children"] = children
        if comments is not None:
            self._values["comments"] = comments
        if criteria_locked is not None:
            self._values["criteria_locked"] = criteria_locked
        if criteria_must_satisfy is not None:
            self._values["criteria_must_satisfy"] = criteria_must_satisfy
        if criterion is not None:
            self._values["criterion"] = criterion
        if custom_override is not None:
            self._values["custom_override"] = custom_override
        if is_secure is not None:
            self._values["is_secure"] = is_secure
        if template_link is not None:
            self._values["template_link"] = template_link
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable is not None:
            self._values["variable"] = variable

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def advanced_override(self) -> typing.Optional[builtins.str]:
        '''XML metadata of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_override DataAkamaiPropertyRulesBuilder#advanced_override}
        '''
        result = self._values.get("advanced_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Behavior"]]]:
        '''behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Behavior"]]], result)

    @builtins.property
    def children(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of child rules for a particular rule in JSON format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#children DataAkamaiPropertyRulesBuilder#children}
        '''
        result = self._values.get("children")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def comments(self) -> typing.Optional[builtins.str]:
        '''The comments for a rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#comments DataAkamaiPropertyRulesBuilder#comments}
        '''
        result = self._values.get("comments")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criteria_locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether changes to 'criterion' objects are prohibited.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_locked DataAkamaiPropertyRulesBuilder#criteria_locked}
        '''
        result = self._values.get("criteria_locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def criteria_must_satisfy(self) -> typing.Optional[builtins.str]:
        '''States whether 'all' criteria need to match or 'any'.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criteria_must_satisfy DataAkamaiPropertyRulesBuilder#criteria_must_satisfy}
        '''
        result = self._values.get("criteria_must_satisfy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def criterion(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Criterion"]]]:
        '''criterion block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#criterion DataAkamaiPropertyRulesBuilder#criterion}
        '''
        result = self._values.get("criterion")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Criterion"]]], result)

    @builtins.property
    def custom_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride"]:
        '''custom_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_override DataAkamaiPropertyRulesBuilder#custom_override}
        '''
        result = self._values.get("custom_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride"], result)

    @builtins.property
    def is_secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''States whether a rule is secure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_secure DataAkamaiPropertyRulesBuilder#is_secure}
        '''
        result = self._values.get("is_secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_link(self) -> typing.Optional[builtins.str]:
        '''The template link for the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_link DataAkamaiPropertyRulesBuilder#template_link}
        '''
        result = self._values.get("template_link")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of a rule template.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''The UUID of the rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Variable"]]]:
        '''variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable DataAkamaiPropertyRulesBuilder#variable}
        '''
        result = self._values.get("variable")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Variable"]]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109Behavior",
    jsii_struct_bases=[],
    name_mapping={
        "adaptive_acceleration": "adaptiveAcceleration",
        "adaptive_image_compression": "adaptiveImageCompression",
        "ad_scaler_circuit_breaker": "adScalerCircuitBreaker",
        "advanced": "advanced",
        "aggregated_reporting": "aggregatedReporting",
        "akamaizer": "akamaizer",
        "akamaizer_tag": "akamaizerTag",
        "all_http_in_cache_hierarchy": "allHttpInCacheHierarchy",
        "allow_cloudlets_origins": "allowCloudletsOrigins",
        "allow_delete": "allowDelete",
        "allow_https_cache_key_sharing": "allowHttpsCacheKeySharing",
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_options": "allowOptions",
        "allow_patch": "allowPatch",
        "allow_post": "allowPost",
        "allow_put": "allowPut",
        "allow_transfer_encoding": "allowTransferEncoding",
        "alt_svc_header": "altSvcHeader",
        "api_prioritization": "apiPrioritization",
        "application_load_balancer": "applicationLoadBalancer",
        "audience_segmentation": "audienceSegmentation",
        "auto_domain_validation": "autoDomainValidation",
        "base_directory": "baseDirectory",
        "boss_beaconing": "bossBeaconing",
        "breadcrumbs": "breadcrumbs",
        "break_connection": "breakConnection",
        "brotli": "brotli",
        "cache_error": "cacheError",
        "cache_id": "cacheId",
        "cache_key_ignore_case": "cacheKeyIgnoreCase",
        "cache_key_query_params": "cacheKeyQueryParams",
        "cache_key_rewrite": "cacheKeyRewrite",
        "cache_post": "cachePost",
        "cache_redirect": "cacheRedirect",
        "cache_tag": "cacheTag",
        "cache_tag_visible": "cacheTagVisible",
        "caching": "caching",
        "central_authorization": "centralAuthorization",
        "chase_redirects": "chaseRedirects",
        "client_certificate_auth": "clientCertificateAuth",
        "client_characteristics": "clientCharacteristics",
        "cloud_interconnects": "cloudInterconnects",
        "cloud_wrapper": "cloudWrapper",
        "cloud_wrapper_advanced": "cloudWrapperAdvanced",
        "common_media_client_data": "commonMediaClientData",
        "conditional_origin": "conditionalOrigin",
        "construct_response": "constructResponse",
        "content_characteristics": "contentCharacteristics",
        "content_characteristics_amd": "contentCharacteristicsAmd",
        "content_characteristics_dd": "contentCharacteristicsDd",
        "content_characteristics_wsd_large_file": "contentCharacteristicsWsdLargeFile",
        "content_characteristics_wsd_live": "contentCharacteristicsWsdLive",
        "content_characteristics_wsd_vod": "contentCharacteristicsWsdVod",
        "content_pre_position": "contentPrePosition",
        "content_targeting_protection": "contentTargetingProtection",
        "cors_support": "corsSupport",
        "cp_code": "cpCode",
        "custom_behavior": "customBehavior",
        "datastream": "datastream",
        "dcp": "dcp",
        "dcp_auth_hmac_transformation": "dcpAuthHmacTransformation",
        "dcp_auth_regex_transformation": "dcpAuthRegexTransformation",
        "dcp_auth_substring_transformation": "dcpAuthSubstringTransformation",
        "dcp_auth_variable_extractor": "dcpAuthVariableExtractor",
        "dcp_default_authz_groups": "dcpDefaultAuthzGroups",
        "dcp_dev_relations": "dcpDevRelations",
        "dcp_real_time_auth": "dcpRealTimeAuth",
        "delivery_receipt": "deliveryReceipt",
        "deny_access": "denyAccess",
        "deny_direct_failover_access": "denyDirectFailoverAccess",
        "device_characteristic_cache_id": "deviceCharacteristicCacheId",
        "device_characteristic_header": "deviceCharacteristicHeader",
        "dns_async_refresh": "dnsAsyncRefresh",
        "dns_prefresh": "dnsPrefresh",
        "downgrade_protocol": "downgradeProtocol",
        "download_complete_marker": "downloadCompleteMarker",
        "download_notification": "downloadNotification",
        "downstream_cache": "downstreamCache",
        "dynamic_throughtput_optimization": "dynamicThroughtputOptimization",
        "dynamic_throughtput_optimization_override": "dynamicThroughtputOptimizationOverride",
        "dynamic_web_content": "dynamicWebContent",
        "ecms_bulk_upload": "ecmsBulkUpload",
        "ecms_database": "ecmsDatabase",
        "ecms_dataset": "ecmsDataset",
        "ecms_object_key": "ecmsObjectKey",
        "edge_connect": "edgeConnect",
        "edge_load_balancing_advanced": "edgeLoadBalancingAdvanced",
        "edge_load_balancing_data_center": "edgeLoadBalancingDataCenter",
        "edge_load_balancing_origin": "edgeLoadBalancingOrigin",
        "edge_origin_authorization": "edgeOriginAuthorization",
        "edge_redirector": "edgeRedirector",
        "edge_scape": "edgeScape",
        "edge_side_includes": "edgeSideIncludes",
        "edge_worker": "edgeWorker",
        "enforce_mtls_settings": "enforceMtlsSettings",
        "enhanced_akamai_protocol": "enhancedAkamaiProtocol",
        "enhanced_proxy_detection": "enhancedProxyDetection",
        "epd_forward_header_enrichment": "epdForwardHeaderEnrichment",
        "fail_action": "failAction",
        "failover_bot_manager_feature_compatibility": "failoverBotManagerFeatureCompatibility",
        "fast_invalidate": "fastInvalidate",
        "fips": "fips",
        "first_party_marketing": "firstPartyMarketing",
        "first_party_marketing_plus": "firstPartyMarketingPlus",
        "forward_rewrite": "forwardRewrite",
        "g2_oheader": "g2Oheader",
        "global_request_number": "globalRequestNumber",
        "graphql_caching": "graphqlCaching",
        "gzip_response": "gzipResponse",
        "hd_data_advanced": "hdDataAdvanced",
        "health_detection": "healthDetection",
        "hsaf_eip_binding": "hsafEipBinding",
        "http2": "http2",
        "http3": "http3",
        "http_strict_transport_security": "httpStrictTransportSecurity",
        "http_to_https_upgrade": "httpToHttpsUpgrade",
        "image_and_video_manager": "imageAndVideoManager",
        "image_manager": "imageManager",
        "image_manager_video": "imageManagerVideo",
        "im_override": "imOverride",
        "include": "include",
        "instant": "instant",
        "instant_config": "instantConfig",
        "large_file_optimization": "largeFileOptimization",
        "large_file_optimization_advanced": "largeFileOptimizationAdvanced",
        "limit_bit_rate": "limitBitRate",
        "log_custom": "logCustom",
        "manifest_personalization": "manifestPersonalization",
        "manifest_rerouting": "manifestRerouting",
        "manual_server_push": "manualServerPush",
        "media_acceleration": "mediaAcceleration",
        "media_acceleration_quic_optout": "mediaAccelerationQuicOptout",
        "media_client": "mediaClient",
        "media_file_retrieval_optimization": "mediaFileRetrievalOptimization",
        "media_origin_failover": "mediaOriginFailover",
        "metadata_caching": "metadataCaching",
        "mobile_sdk_performance": "mobileSdkPerformance",
        "modify_incoming_request_header": "modifyIncomingRequestHeader",
        "modify_incoming_response_header": "modifyIncomingResponseHeader",
        "modify_outgoing_request_header": "modifyOutgoingRequestHeader",
        "modify_outgoing_response_header": "modifyOutgoingResponseHeader",
        "modify_via_header": "modifyViaHeader",
        "m_pulse": "mPulse",
        "origin": "origin",
        "origin_characteristics": "originCharacteristics",
        "origin_characteristics_wsd": "originCharacteristicsWsd",
        "origin_failure_recovery_method": "originFailureRecoveryMethod",
        "origin_failure_recovery_policy": "originFailureRecoveryPolicy",
        "origin_ip_acl": "originIpAcl",
        "permissions_policy": "permissionsPolicy",
        "persistent_client_connection": "persistentClientConnection",
        "persistent_connection": "persistentConnection",
        "personally_identifiable_information": "personallyIdentifiableInformation",
        "phased_release": "phasedRelease",
        "preconnect": "preconnect",
        "predictive_content_delivery": "predictiveContentDelivery",
        "predictive_prefetching": "predictivePrefetching",
        "prefetch": "prefetch",
        "prefetchable": "prefetchable",
        "prefresh_cache": "prefreshCache",
        "quality": "quality",
        "quic_beta": "quicBeta",
        "random_seek": "randomSeek",
        "rapid": "rapid",
        "read_timeout": "readTimeout",
        "real_time_reporting": "realTimeReporting",
        "real_user_monitoring": "realUserMonitoring",
        "redirect": "redirect",
        "redirectplus": "redirectplus",
        "referer_checking": "refererChecking",
        "remove_query_parameter": "removeQueryParameter",
        "remove_vary": "removeVary",
        "report": "report",
        "request_client_hints": "requestClientHints",
        "request_control": "requestControl",
        "request_type_marker": "requestTypeMarker",
        "resource_optimizer": "resourceOptimizer",
        "resource_optimizer_extended_compatibility": "resourceOptimizerExtendedCompatibility",
        "response_code": "responseCode",
        "response_cookie": "responseCookie",
        "restrict_object_caching": "restrictObjectCaching",
        "return_cache_status": "returnCacheStatus",
        "rewrite_url": "rewriteUrl",
        "rum_custom": "rumCustom",
        "saas_definitions": "saasDefinitions",
        "sales_force_commerce_cloud_client": "salesForceCommerceCloudClient",
        "sales_force_commerce_cloud_provider": "salesForceCommerceCloudProvider",
        "sales_force_commerce_cloud_provider_host_header": "salesForceCommerceCloudProviderHostHeader",
        "save_post_dca_processing": "savePostDcaProcessing",
        "schedule_invalidation": "scheduleInvalidation",
        "script_management": "scriptManagement",
        "segmented_content_protection": "segmentedContentProtection",
        "segmented_media_optimization": "segmentedMediaOptimization",
        "segmented_media_streaming_prefetch": "segmentedMediaStreamingPrefetch",
        "set_variable": "setVariable",
        "simulate_error_code": "simulateErrorCode",
        "site_shield": "siteShield",
        "standard_tls_migration": "standardTlsMigration",
        "standard_tls_migration_override": "standardTlsMigrationOverride",
        "strict_header_parsing": "strictHeaderParsing",
        "sub_customer": "subCustomer",
        "sure_route": "sureRoute",
        "tcp_optimization": "tcpOptimization",
        "tea_leaf": "teaLeaf",
        "tiered_distribution": "tieredDistribution",
        "tiered_distribution_advanced": "tieredDistributionAdvanced",
        "tiered_distribution_customization": "tieredDistributionCustomization",
        "timeout": "timeout",
        "uid_configuration": "uidConfiguration",
        "validate_entity_tag": "validateEntityTag",
        "verify_json_web_token": "verifyJsonWebToken",
        "verify_json_web_token_for_dcp": "verifyJsonWebTokenForDcp",
        "verify_token_authorization": "verifyTokenAuthorization",
        "virtual_waiting_room": "virtualWaitingRoom",
        "virtual_waiting_room_with_edge_workers": "virtualWaitingRoomWithEdgeWorkers",
        "visitor_prioritization": "visitorPrioritization",
        "visitor_prioritization_fifo": "visitorPrioritizationFifo",
        "visitor_prioritization_fifo_standalone": "visitorPrioritizationFifoStandalone",
        "watermarking": "watermarking",
        "web_application_firewall": "webApplicationFirewall",
        "webdav": "webdav",
        "web_sockets": "webSockets",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109Behavior:
    def __init__(
        self,
        *,
        adaptive_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        adaptive_image_compression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression", typing.Dict[builtins.str, typing.Any]]] = None,
        ad_scaler_circuit_breaker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker", typing.Dict[builtins.str, typing.Any]]] = None,
        advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        aggregated_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer", typing.Dict[builtins.str, typing.Any]]] = None,
        akamaizer_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag", typing.Dict[builtins.str, typing.Any]]] = None,
        all_http_in_cache_hierarchy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_cloudlets_origins: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_delete: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_cache_key_sharing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_https_downgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_options: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_patch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_put: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut", typing.Dict[builtins.str, typing.Any]]] = None,
        allow_transfer_encoding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding", typing.Dict[builtins.str, typing.Any]]] = None,
        alt_svc_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        api_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        application_load_balancer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer", typing.Dict[builtins.str, typing.Any]]] = None,
        audience_segmentation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation", typing.Dict[builtins.str, typing.Any]]] = None,
        auto_domain_validation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation", typing.Dict[builtins.str, typing.Any]]] = None,
        base_directory: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory", typing.Dict[builtins.str, typing.Any]]] = None,
        boss_beaconing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing", typing.Dict[builtins.str, typing.Any]]] = None,
        breadcrumbs: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs", typing.Dict[builtins.str, typing.Any]]] = None,
        break_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        brotli: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_ignore_case: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_query_params: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_key_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_post: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag", typing.Dict[builtins.str, typing.Any]]] = None,
        cache_tag_visible: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible", typing.Dict[builtins.str, typing.Any]]] = None,
        caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        central_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        chase_redirects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        client_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_interconnects: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper", typing.Dict[builtins.str, typing.Any]]] = None,
        cloud_wrapper_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        common_media_client_data: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData", typing.Dict[builtins.str, typing.Any]]] = None,
        conditional_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        construct_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_amd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_dd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_large_file: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_live: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive", typing.Dict[builtins.str, typing.Any]]] = None,
        content_characteristics_wsd_vod: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod", typing.Dict[builtins.str, typing.Any]]] = None,
        content_pre_position: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition", typing.Dict[builtins.str, typing.Any]]] = None,
        content_targeting_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        cors_support: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        custom_behavior: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior", typing.Dict[builtins.str, typing.Any]]] = None,
        datastream: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_hmac_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_regex_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_substring_transformation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_auth_variable_extractor: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_default_authz_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_dev_relations: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations", typing.Dict[builtins.str, typing.Any]]] = None,
        dcp_real_time_auth: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth", typing.Dict[builtins.str, typing.Any]]] = None,
        delivery_receipt: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        deny_direct_failover_access: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_cache_id: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_async_refresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        dns_prefresh: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh", typing.Dict[builtins.str, typing.Any]]] = None,
        downgrade_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        download_complete_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        download_notification: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification", typing.Dict[builtins.str, typing.Any]]] = None,
        downstream_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_throughtput_optimization_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_web_content: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_bulk_upload: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_database: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_dataset: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset", typing.Dict[builtins.str, typing.Any]]] = None,
        ecms_object_key: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_connect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_data_center: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_load_balancing_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_origin_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_redirector: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_scape: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_side_includes: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_worker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker", typing.Dict[builtins.str, typing.Any]]] = None,
        enforce_mtls_settings: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_akamai_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        enhanced_proxy_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        epd_forward_header_enrichment: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment", typing.Dict[builtins.str, typing.Any]]] = None,
        fail_action: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction", typing.Dict[builtins.str, typing.Any]]] = None,
        failover_bot_manager_feature_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        fast_invalidate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate", typing.Dict[builtins.str, typing.Any]]] = None,
        fips: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing", typing.Dict[builtins.str, typing.Any]]] = None,
        first_party_marketing_plus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus", typing.Dict[builtins.str, typing.Any]]] = None,
        forward_rewrite: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite", typing.Dict[builtins.str, typing.Any]]] = None,
        g2_oheader: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader", typing.Dict[builtins.str, typing.Any]]] = None,
        global_request_number: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber", typing.Dict[builtins.str, typing.Any]]] = None,
        graphql_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        gzip_response: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse", typing.Dict[builtins.str, typing.Any]]] = None,
        hd_data_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        health_detection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection", typing.Dict[builtins.str, typing.Any]]] = None,
        hsaf_eip_binding: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding", typing.Dict[builtins.str, typing.Any]]] = None,
        http2: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2", typing.Dict[builtins.str, typing.Any]]] = None,
        http3: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3", typing.Dict[builtins.str, typing.Any]]] = None,
        http_strict_transport_security: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity", typing.Dict[builtins.str, typing.Any]]] = None,
        http_to_https_upgrade: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade", typing.Dict[builtins.str, typing.Any]]] = None,
        image_and_video_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager", typing.Dict[builtins.str, typing.Any]]] = None,
        image_manager_video: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo", typing.Dict[builtins.str, typing.Any]]] = None,
        im_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        include: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude", typing.Dict[builtins.str, typing.Any]]] = None,
        instant: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant", typing.Dict[builtins.str, typing.Any]]] = None,
        instant_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        large_file_optimization_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        limit_bit_rate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate", typing.Dict[builtins.str, typing.Any]]] = None,
        log_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_personalization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization", typing.Dict[builtins.str, typing.Any]]] = None,
        manifest_rerouting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting", typing.Dict[builtins.str, typing.Any]]] = None,
        manual_server_push: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration", typing.Dict[builtins.str, typing.Any]]] = None,
        media_acceleration_quic_optout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout", typing.Dict[builtins.str, typing.Any]]] = None,
        media_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient", typing.Dict[builtins.str, typing.Any]]] = None,
        media_file_retrieval_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        media_origin_failover: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        mobile_sdk_performance: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_incoming_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_outgoing_response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        modify_via_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        m_pulse: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse", typing.Dict[builtins.str, typing.Any]]] = None,
        origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_characteristics_wsd: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_failure_recovery_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_ip_acl: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl", typing.Dict[builtins.str, typing.Any]]] = None,
        permissions_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_client_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        persistent_connection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection", typing.Dict[builtins.str, typing.Any]]] = None,
        personally_identifiable_information: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation", typing.Dict[builtins.str, typing.Any]]] = None,
        phased_release: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease", typing.Dict[builtins.str, typing.Any]]] = None,
        preconnect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_content_delivery: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery", typing.Dict[builtins.str, typing.Any]]] = None,
        predictive_prefetching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        prefetchable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable", typing.Dict[builtins.str, typing.Any]]] = None,
        prefresh_cache: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache", typing.Dict[builtins.str, typing.Any]]] = None,
        quality: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality", typing.Dict[builtins.str, typing.Any]]] = None,
        quic_beta: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta", typing.Dict[builtins.str, typing.Any]]] = None,
        random_seek: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek", typing.Dict[builtins.str, typing.Any]]] = None,
        rapid: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid", typing.Dict[builtins.str, typing.Any]]] = None,
        read_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        real_time_reporting: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting", typing.Dict[builtins.str, typing.Any]]] = None,
        real_user_monitoring: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring", typing.Dict[builtins.str, typing.Any]]] = None,
        redirect: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect", typing.Dict[builtins.str, typing.Any]]] = None,
        redirectplus: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus", typing.Dict[builtins.str, typing.Any]]] = None,
        referer_checking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_query_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        remove_vary: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary", typing.Dict[builtins.str, typing.Any]]] = None,
        report: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport", typing.Dict[builtins.str, typing.Any]]] = None,
        request_client_hints: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints", typing.Dict[builtins.str, typing.Any]]] = None,
        request_control: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type_marker: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer", typing.Dict[builtins.str, typing.Any]]] = None,
        resource_optimizer_extended_compatibility: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility", typing.Dict[builtins.str, typing.Any]]] = None,
        response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        response_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        restrict_object_caching: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching", typing.Dict[builtins.str, typing.Any]]] = None,
        return_cache_status: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus", typing.Dict[builtins.str, typing.Any]]] = None,
        rewrite_url: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl", typing.Dict[builtins.str, typing.Any]]] = None,
        rum_custom: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom", typing.Dict[builtins.str, typing.Any]]] = None,
        saas_definitions: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_client: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider", typing.Dict[builtins.str, typing.Any]]] = None,
        sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        save_post_dca_processing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing", typing.Dict[builtins.str, typing.Any]]] = None,
        schedule_invalidation: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation", typing.Dict[builtins.str, typing.Any]]] = None,
        script_management: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_content_protection: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        segmented_media_streaming_prefetch: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch", typing.Dict[builtins.str, typing.Any]]] = None,
        set_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        simulate_error_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode", typing.Dict[builtins.str, typing.Any]]] = None,
        site_shield: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration", typing.Dict[builtins.str, typing.Any]]] = None,
        standard_tls_migration_override: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride", typing.Dict[builtins.str, typing.Any]]] = None,
        strict_header_parsing: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing", typing.Dict[builtins.str, typing.Any]]] = None,
        sub_customer: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer", typing.Dict[builtins.str, typing.Any]]] = None,
        sure_route: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute", typing.Dict[builtins.str, typing.Any]]] = None,
        tcp_optimization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization", typing.Dict[builtins.str, typing.Any]]] = None,
        tea_leaf: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        tiered_distribution_customization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization", typing.Dict[builtins.str, typing.Any]]] = None,
        timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        uid_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        validate_entity_tag: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_json_web_token_for_dcp: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp", typing.Dict[builtins.str, typing.Any]]] = None,
        verify_token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_fifo_standalone: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone", typing.Dict[builtins.str, typing.Any]]] = None,
        watermarking: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking", typing.Dict[builtins.str, typing.Any]]] = None,
        web_application_firewall: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall", typing.Dict[builtins.str, typing.Any]]] = None,
        webdav: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav", typing.Dict[builtins.str, typing.Any]]] = None,
        web_sockets: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param adaptive_acceleration: adaptive_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        :param adaptive_image_compression: adaptive_image_compression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        :param ad_scaler_circuit_breaker: ad_scaler_circuit_breaker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        :param advanced: advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param aggregated_reporting: aggregated_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        :param akamaizer: akamaizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        :param akamaizer_tag: akamaizer_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        :param all_http_in_cache_hierarchy: all_http_in_cache_hierarchy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        :param allow_cloudlets_origins: allow_cloudlets_origins block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        :param allow_delete: allow_delete block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        :param allow_https_cache_key_sharing: allow_https_cache_key_sharing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        :param allow_https_downgrade: allow_https_downgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_options: allow_options block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        :param allow_patch: allow_patch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        :param allow_post: allow_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        :param allow_put: allow_put block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        :param allow_transfer_encoding: allow_transfer_encoding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        :param alt_svc_header: alt_svc_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        :param api_prioritization: api_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        :param application_load_balancer: application_load_balancer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        :param audience_segmentation: audience_segmentation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        :param auto_domain_validation: auto_domain_validation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        :param base_directory: base_directory block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        :param boss_beaconing: boss_beaconing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        :param breadcrumbs: breadcrumbs block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        :param break_connection: break_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        :param brotli: brotli block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        :param cache_error: cache_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        :param cache_id: cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        :param cache_key_ignore_case: cache_key_ignore_case block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        :param cache_key_query_params: cache_key_query_params block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        :param cache_key_rewrite: cache_key_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        :param cache_post: cache_post block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        :param cache_redirect: cache_redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        :param cache_tag: cache_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        :param cache_tag_visible: cache_tag_visible block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        :param caching: caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param central_authorization: central_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        :param chase_redirects: chase_redirects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        :param client_certificate_auth: client_certificate_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_auth DataAkamaiPropertyRulesBuilder#client_certificate_auth}
        :param client_characteristics: client_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        :param cloud_interconnects: cloud_interconnects block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        :param cloud_wrapper: cloud_wrapper block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        :param cloud_wrapper_advanced: cloud_wrapper_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        :param common_media_client_data: common_media_client_data block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        :param conditional_origin: conditional_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        :param construct_response: construct_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        :param content_characteristics: content_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        :param content_characteristics_amd: content_characteristics_amd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        :param content_characteristics_dd: content_characteristics_dd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        :param content_characteristics_wsd_large_file: content_characteristics_wsd_large_file block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        :param content_characteristics_wsd_live: content_characteristics_wsd_live block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        :param content_characteristics_wsd_vod: content_characteristics_wsd_vod block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        :param content_pre_position: content_pre_position block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        :param content_targeting_protection: content_targeting_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        :param cors_support: cors_support block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param custom_behavior: custom_behavior block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        :param datastream: datastream block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        :param dcp: dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        :param dcp_auth_hmac_transformation: dcp_auth_hmac_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        :param dcp_auth_regex_transformation: dcp_auth_regex_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        :param dcp_auth_substring_transformation: dcp_auth_substring_transformation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        :param dcp_auth_variable_extractor: dcp_auth_variable_extractor block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        :param dcp_default_authz_groups: dcp_default_authz_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        :param dcp_dev_relations: dcp_dev_relations block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        :param dcp_real_time_auth: dcp_real_time_auth block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        :param delivery_receipt: delivery_receipt block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        :param deny_access: deny_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        :param deny_direct_failover_access: deny_direct_failover_access block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        :param device_characteristic_cache_id: device_characteristic_cache_id block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        :param device_characteristic_header: device_characteristic_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        :param dns_async_refresh: dns_async_refresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        :param dns_prefresh: dns_prefresh block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        :param downgrade_protocol: downgrade_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        :param download_complete_marker: download_complete_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        :param download_notification: download_notification block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        :param downstream_cache: downstream_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        :param dynamic_throughtput_optimization: dynamic_throughtput_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        :param dynamic_throughtput_optimization_override: dynamic_throughtput_optimization_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        :param dynamic_web_content: dynamic_web_content block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param ecms_bulk_upload: ecms_bulk_upload block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        :param ecms_database: ecms_database block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        :param ecms_dataset: ecms_dataset block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        :param ecms_object_key: ecms_object_key block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        :param edge_connect: edge_connect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        :param edge_load_balancing_advanced: edge_load_balancing_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        :param edge_load_balancing_data_center: edge_load_balancing_data_center block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        :param edge_load_balancing_origin: edge_load_balancing_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        :param edge_origin_authorization: edge_origin_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        :param edge_redirector: edge_redirector block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        :param edge_scape: edge_scape block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        :param edge_side_includes: edge_side_includes block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        :param edge_worker: edge_worker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        :param enforce_mtls_settings: enforce_mtls_settings block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls_settings DataAkamaiPropertyRulesBuilder#enforce_mtls_settings}
        :param enhanced_akamai_protocol: enhanced_akamai_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        :param enhanced_proxy_detection: enhanced_proxy_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        :param epd_forward_header_enrichment: epd_forward_header_enrichment block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        :param fail_action: fail_action block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        :param failover_bot_manager_feature_compatibility: failover_bot_manager_feature_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        :param fast_invalidate: fast_invalidate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        :param fips: fips block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fips DataAkamaiPropertyRulesBuilder#fips}
        :param first_party_marketing: first_party_marketing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        :param first_party_marketing_plus: first_party_marketing_plus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        :param forward_rewrite: forward_rewrite block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        :param g2_oheader: g2oheader block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        :param global_request_number: global_request_number block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        :param graphql_caching: graphql_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        :param gzip_response: gzip_response block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        :param hd_data_advanced: hd_data_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        :param health_detection: health_detection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        :param hsaf_eip_binding: hsaf_eip_binding block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        :param http2: http2 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        :param http3: http3 block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        :param http_strict_transport_security: http_strict_transport_security block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        :param http_to_https_upgrade: http_to_https_upgrade block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        :param image_and_video_manager: image_and_video_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        :param image_manager: image_manager block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        :param image_manager_video: image_manager_video block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        :param im_override: im_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        :param include: include block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        :param instant: instant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        :param instant_config: instant_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        :param large_file_optimization: large_file_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        :param large_file_optimization_advanced: large_file_optimization_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        :param limit_bit_rate: limit_bit_rate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        :param log_custom: log_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        :param manifest_personalization: manifest_personalization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        :param manifest_rerouting: manifest_rerouting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        :param manual_server_push: manual_server_push block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        :param media_acceleration: media_acceleration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        :param media_acceleration_quic_optout: media_acceleration_quic_optout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        :param media_client: media_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        :param media_file_retrieval_optimization: media_file_retrieval_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        :param media_origin_failover: media_origin_failover block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        :param metadata_caching: metadata_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        :param mobile_sdk_performance: mobile_sdk_performance block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        :param modify_incoming_request_header: modify_incoming_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        :param modify_incoming_response_header: modify_incoming_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        :param modify_outgoing_request_header: modify_outgoing_request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        :param modify_outgoing_response_header: modify_outgoing_response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        :param modify_via_header: modify_via_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        :param m_pulse: m_pulse block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param origin: origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param origin_characteristics: origin_characteristics block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        :param origin_characteristics_wsd: origin_characteristics_wsd block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        :param origin_failure_recovery_method: origin_failure_recovery_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        :param origin_failure_recovery_policy: origin_failure_recovery_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        :param origin_ip_acl: origin_ip_acl block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        :param permissions_policy: permissions_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy DataAkamaiPropertyRulesBuilder#permissions_policy}
        :param persistent_client_connection: persistent_client_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        :param persistent_connection: persistent_connection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        :param personally_identifiable_information: personally_identifiable_information block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        :param phased_release: phased_release block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        :param preconnect: preconnect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        :param predictive_content_delivery: predictive_content_delivery block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        :param predictive_prefetching: predictive_prefetching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        :param prefetch: prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param prefetchable: prefetchable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        :param prefresh_cache: prefresh_cache block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        :param quality: quality block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        :param quic_beta: quic_beta block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        :param random_seek: random_seek block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        :param rapid: rapid block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        :param read_timeout: read_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        :param real_time_reporting: real_time_reporting block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        :param real_user_monitoring: real_user_monitoring block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param redirect: redirect block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirectplus: redirectplus block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        :param referer_checking: referer_checking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        :param remove_query_parameter: remove_query_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        :param remove_vary: remove_vary block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        :param report: report block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        :param request_client_hints: request_client_hints block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_client_hints DataAkamaiPropertyRulesBuilder#request_client_hints}
        :param request_control: request_control block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        :param request_type_marker: request_type_marker block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        :param resource_optimizer: resource_optimizer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        :param resource_optimizer_extended_compatibility: resource_optimizer_extended_compatibility block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        :param response_code: response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param response_cookie: response_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        :param restrict_object_caching: restrict_object_caching block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        :param return_cache_status: return_cache_status block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        :param rewrite_url: rewrite_url block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        :param rum_custom: rum_custom block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        :param saas_definitions: saas_definitions block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        :param sales_force_commerce_cloud_client: sales_force_commerce_cloud_client block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        :param sales_force_commerce_cloud_provider: sales_force_commerce_cloud_provider block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        :param sales_force_commerce_cloud_provider_host_header: sales_force_commerce_cloud_provider_host_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        :param save_post_dca_processing: save_post_dca_processing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        :param schedule_invalidation: schedule_invalidation block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        :param script_management: script_management block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        :param segmented_content_protection: segmented_content_protection block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        :param segmented_media_optimization: segmented_media_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        :param segmented_media_streaming_prefetch: segmented_media_streaming_prefetch block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        :param set_variable: set_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        :param simulate_error_code: simulate_error_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        :param site_shield: site_shield block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        :param standard_tls_migration: standard_tls_migration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        :param standard_tls_migration_override: standard_tls_migration_override block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        :param strict_header_parsing: strict_header_parsing block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        :param sub_customer: sub_customer block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        :param sure_route: sure_route block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param tcp_optimization: tcp_optimization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        :param tea_leaf: tea_leaf block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        :param tiered_distribution: tiered_distribution block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        :param tiered_distribution_advanced: tiered_distribution_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        :param tiered_distribution_customization: tiered_distribution_customization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        :param timeout: timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uid_configuration: uid_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        :param validate_entity_tag: validate_entity_tag block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        :param verify_json_web_token: verify_json_web_token block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        :param verify_json_web_token_for_dcp: verify_json_web_token_for_dcp block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        :param verify_token_authorization: verify_token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        :param virtual_waiting_room: virtual_waiting_room block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        :param virtual_waiting_room_with_edge_workers: virtual_waiting_room_with_edge_workers block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        :param visitor_prioritization: visitor_prioritization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        :param visitor_prioritization_fifo: visitor_prioritization_fifo block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        :param visitor_prioritization_fifo_standalone: visitor_prioritization_fifo_standalone block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        :param watermarking: watermarking block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        :param web_application_firewall: web_application_firewall block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        :param webdav: webdav block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        :param web_sockets: web_sockets block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        if isinstance(adaptive_acceleration, dict):
            adaptive_acceleration = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration(**adaptive_acceleration)
        if isinstance(adaptive_image_compression, dict):
            adaptive_image_compression = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression(**adaptive_image_compression)
        if isinstance(ad_scaler_circuit_breaker, dict):
            ad_scaler_circuit_breaker = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker(**ad_scaler_circuit_breaker)
        if isinstance(advanced, dict):
            advanced = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced(**advanced)
        if isinstance(aggregated_reporting, dict):
            aggregated_reporting = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting(**aggregated_reporting)
        if isinstance(akamaizer, dict):
            akamaizer = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer(**akamaizer)
        if isinstance(akamaizer_tag, dict):
            akamaizer_tag = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag(**akamaizer_tag)
        if isinstance(all_http_in_cache_hierarchy, dict):
            all_http_in_cache_hierarchy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy(**all_http_in_cache_hierarchy)
        if isinstance(allow_cloudlets_origins, dict):
            allow_cloudlets_origins = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins(**allow_cloudlets_origins)
        if isinstance(allow_delete, dict):
            allow_delete = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete(**allow_delete)
        if isinstance(allow_https_cache_key_sharing, dict):
            allow_https_cache_key_sharing = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing(**allow_https_cache_key_sharing)
        if isinstance(allow_https_downgrade, dict):
            allow_https_downgrade = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade(**allow_https_downgrade)
        if isinstance(allow_options, dict):
            allow_options = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions(**allow_options)
        if isinstance(allow_patch, dict):
            allow_patch = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch(**allow_patch)
        if isinstance(allow_post, dict):
            allow_post = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost(**allow_post)
        if isinstance(allow_put, dict):
            allow_put = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut(**allow_put)
        if isinstance(allow_transfer_encoding, dict):
            allow_transfer_encoding = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding(**allow_transfer_encoding)
        if isinstance(alt_svc_header, dict):
            alt_svc_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader(**alt_svc_header)
        if isinstance(api_prioritization, dict):
            api_prioritization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization(**api_prioritization)
        if isinstance(application_load_balancer, dict):
            application_load_balancer = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer(**application_load_balancer)
        if isinstance(audience_segmentation, dict):
            audience_segmentation = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation(**audience_segmentation)
        if isinstance(auto_domain_validation, dict):
            auto_domain_validation = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation(**auto_domain_validation)
        if isinstance(base_directory, dict):
            base_directory = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory(**base_directory)
        if isinstance(boss_beaconing, dict):
            boss_beaconing = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing(**boss_beaconing)
        if isinstance(breadcrumbs, dict):
            breadcrumbs = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs(**breadcrumbs)
        if isinstance(break_connection, dict):
            break_connection = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection(**break_connection)
        if isinstance(brotli, dict):
            brotli = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli(**brotli)
        if isinstance(cache_error, dict):
            cache_error = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError(**cache_error)
        if isinstance(cache_id, dict):
            cache_id = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId(**cache_id)
        if isinstance(cache_key_ignore_case, dict):
            cache_key_ignore_case = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase(**cache_key_ignore_case)
        if isinstance(cache_key_query_params, dict):
            cache_key_query_params = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams(**cache_key_query_params)
        if isinstance(cache_key_rewrite, dict):
            cache_key_rewrite = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite(**cache_key_rewrite)
        if isinstance(cache_post, dict):
            cache_post = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost(**cache_post)
        if isinstance(cache_redirect, dict):
            cache_redirect = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect(**cache_redirect)
        if isinstance(cache_tag, dict):
            cache_tag = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag(**cache_tag)
        if isinstance(cache_tag_visible, dict):
            cache_tag_visible = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible(**cache_tag_visible)
        if isinstance(caching, dict):
            caching = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching(**caching)
        if isinstance(central_authorization, dict):
            central_authorization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization(**central_authorization)
        if isinstance(chase_redirects, dict):
            chase_redirects = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects(**chase_redirects)
        if isinstance(client_certificate_auth, dict):
            client_certificate_auth = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth(**client_certificate_auth)
        if isinstance(client_characteristics, dict):
            client_characteristics = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics(**client_characteristics)
        if isinstance(cloud_interconnects, dict):
            cloud_interconnects = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects(**cloud_interconnects)
        if isinstance(cloud_wrapper, dict):
            cloud_wrapper = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper(**cloud_wrapper)
        if isinstance(cloud_wrapper_advanced, dict):
            cloud_wrapper_advanced = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced(**cloud_wrapper_advanced)
        if isinstance(common_media_client_data, dict):
            common_media_client_data = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData(**common_media_client_data)
        if isinstance(conditional_origin, dict):
            conditional_origin = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin(**conditional_origin)
        if isinstance(construct_response, dict):
            construct_response = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse(**construct_response)
        if isinstance(content_characteristics, dict):
            content_characteristics = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics(**content_characteristics)
        if isinstance(content_characteristics_amd, dict):
            content_characteristics_amd = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd(**content_characteristics_amd)
        if isinstance(content_characteristics_dd, dict):
            content_characteristics_dd = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd(**content_characteristics_dd)
        if isinstance(content_characteristics_wsd_large_file, dict):
            content_characteristics_wsd_large_file = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile(**content_characteristics_wsd_large_file)
        if isinstance(content_characteristics_wsd_live, dict):
            content_characteristics_wsd_live = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive(**content_characteristics_wsd_live)
        if isinstance(content_characteristics_wsd_vod, dict):
            content_characteristics_wsd_vod = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod(**content_characteristics_wsd_vod)
        if isinstance(content_pre_position, dict):
            content_pre_position = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition(**content_pre_position)
        if isinstance(content_targeting_protection, dict):
            content_targeting_protection = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection(**content_targeting_protection)
        if isinstance(cors_support, dict):
            cors_support = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport(**cors_support)
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode(**cp_code)
        if isinstance(custom_behavior, dict):
            custom_behavior = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior(**custom_behavior)
        if isinstance(datastream, dict):
            datastream = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream(**datastream)
        if isinstance(dcp, dict):
            dcp = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp(**dcp)
        if isinstance(dcp_auth_hmac_transformation, dict):
            dcp_auth_hmac_transformation = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation(**dcp_auth_hmac_transformation)
        if isinstance(dcp_auth_regex_transformation, dict):
            dcp_auth_regex_transformation = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation(**dcp_auth_regex_transformation)
        if isinstance(dcp_auth_substring_transformation, dict):
            dcp_auth_substring_transformation = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation(**dcp_auth_substring_transformation)
        if isinstance(dcp_auth_variable_extractor, dict):
            dcp_auth_variable_extractor = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor(**dcp_auth_variable_extractor)
        if isinstance(dcp_default_authz_groups, dict):
            dcp_default_authz_groups = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups(**dcp_default_authz_groups)
        if isinstance(dcp_dev_relations, dict):
            dcp_dev_relations = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations(**dcp_dev_relations)
        if isinstance(dcp_real_time_auth, dict):
            dcp_real_time_auth = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth(**dcp_real_time_auth)
        if isinstance(delivery_receipt, dict):
            delivery_receipt = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt(**delivery_receipt)
        if isinstance(deny_access, dict):
            deny_access = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess(**deny_access)
        if isinstance(deny_direct_failover_access, dict):
            deny_direct_failover_access = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess(**deny_direct_failover_access)
        if isinstance(device_characteristic_cache_id, dict):
            device_characteristic_cache_id = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId(**device_characteristic_cache_id)
        if isinstance(device_characteristic_header, dict):
            device_characteristic_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader(**device_characteristic_header)
        if isinstance(dns_async_refresh, dict):
            dns_async_refresh = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh(**dns_async_refresh)
        if isinstance(dns_prefresh, dict):
            dns_prefresh = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh(**dns_prefresh)
        if isinstance(downgrade_protocol, dict):
            downgrade_protocol = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol(**downgrade_protocol)
        if isinstance(download_complete_marker, dict):
            download_complete_marker = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker(**download_complete_marker)
        if isinstance(download_notification, dict):
            download_notification = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification(**download_notification)
        if isinstance(downstream_cache, dict):
            downstream_cache = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache(**downstream_cache)
        if isinstance(dynamic_throughtput_optimization, dict):
            dynamic_throughtput_optimization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization(**dynamic_throughtput_optimization)
        if isinstance(dynamic_throughtput_optimization_override, dict):
            dynamic_throughtput_optimization_override = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride(**dynamic_throughtput_optimization_override)
        if isinstance(dynamic_web_content, dict):
            dynamic_web_content = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent(**dynamic_web_content)
        if isinstance(ecms_bulk_upload, dict):
            ecms_bulk_upload = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload(**ecms_bulk_upload)
        if isinstance(ecms_database, dict):
            ecms_database = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase(**ecms_database)
        if isinstance(ecms_dataset, dict):
            ecms_dataset = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset(**ecms_dataset)
        if isinstance(ecms_object_key, dict):
            ecms_object_key = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey(**ecms_object_key)
        if isinstance(edge_connect, dict):
            edge_connect = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect(**edge_connect)
        if isinstance(edge_load_balancing_advanced, dict):
            edge_load_balancing_advanced = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced(**edge_load_balancing_advanced)
        if isinstance(edge_load_balancing_data_center, dict):
            edge_load_balancing_data_center = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter(**edge_load_balancing_data_center)
        if isinstance(edge_load_balancing_origin, dict):
            edge_load_balancing_origin = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin(**edge_load_balancing_origin)
        if isinstance(edge_origin_authorization, dict):
            edge_origin_authorization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization(**edge_origin_authorization)
        if isinstance(edge_redirector, dict):
            edge_redirector = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector(**edge_redirector)
        if isinstance(edge_scape, dict):
            edge_scape = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape(**edge_scape)
        if isinstance(edge_side_includes, dict):
            edge_side_includes = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes(**edge_side_includes)
        if isinstance(edge_worker, dict):
            edge_worker = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker(**edge_worker)
        if isinstance(enforce_mtls_settings, dict):
            enforce_mtls_settings = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings(**enforce_mtls_settings)
        if isinstance(enhanced_akamai_protocol, dict):
            enhanced_akamai_protocol = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol(**enhanced_akamai_protocol)
        if isinstance(enhanced_proxy_detection, dict):
            enhanced_proxy_detection = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection(**enhanced_proxy_detection)
        if isinstance(epd_forward_header_enrichment, dict):
            epd_forward_header_enrichment = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment(**epd_forward_header_enrichment)
        if isinstance(fail_action, dict):
            fail_action = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction(**fail_action)
        if isinstance(failover_bot_manager_feature_compatibility, dict):
            failover_bot_manager_feature_compatibility = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility(**failover_bot_manager_feature_compatibility)
        if isinstance(fast_invalidate, dict):
            fast_invalidate = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate(**fast_invalidate)
        if isinstance(fips, dict):
            fips = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips(**fips)
        if isinstance(first_party_marketing, dict):
            first_party_marketing = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing(**first_party_marketing)
        if isinstance(first_party_marketing_plus, dict):
            first_party_marketing_plus = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus(**first_party_marketing_plus)
        if isinstance(forward_rewrite, dict):
            forward_rewrite = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite(**forward_rewrite)
        if isinstance(g2_oheader, dict):
            g2_oheader = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader(**g2_oheader)
        if isinstance(global_request_number, dict):
            global_request_number = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber(**global_request_number)
        if isinstance(graphql_caching, dict):
            graphql_caching = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching(**graphql_caching)
        if isinstance(gzip_response, dict):
            gzip_response = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse(**gzip_response)
        if isinstance(hd_data_advanced, dict):
            hd_data_advanced = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced(**hd_data_advanced)
        if isinstance(health_detection, dict):
            health_detection = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection(**health_detection)
        if isinstance(hsaf_eip_binding, dict):
            hsaf_eip_binding = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding(**hsaf_eip_binding)
        if isinstance(http2, dict):
            http2 = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2(**http2)
        if isinstance(http3, dict):
            http3 = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3(**http3)
        if isinstance(http_strict_transport_security, dict):
            http_strict_transport_security = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity(**http_strict_transport_security)
        if isinstance(http_to_https_upgrade, dict):
            http_to_https_upgrade = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade(**http_to_https_upgrade)
        if isinstance(image_and_video_manager, dict):
            image_and_video_manager = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager(**image_and_video_manager)
        if isinstance(image_manager, dict):
            image_manager = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager(**image_manager)
        if isinstance(image_manager_video, dict):
            image_manager_video = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo(**image_manager_video)
        if isinstance(im_override, dict):
            im_override = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride(**im_override)
        if isinstance(include, dict):
            include = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude(**include)
        if isinstance(instant, dict):
            instant = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant(**instant)
        if isinstance(instant_config, dict):
            instant_config = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig(**instant_config)
        if isinstance(large_file_optimization, dict):
            large_file_optimization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization(**large_file_optimization)
        if isinstance(large_file_optimization_advanced, dict):
            large_file_optimization_advanced = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced(**large_file_optimization_advanced)
        if isinstance(limit_bit_rate, dict):
            limit_bit_rate = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate(**limit_bit_rate)
        if isinstance(log_custom, dict):
            log_custom = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom(**log_custom)
        if isinstance(manifest_personalization, dict):
            manifest_personalization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization(**manifest_personalization)
        if isinstance(manifest_rerouting, dict):
            manifest_rerouting = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting(**manifest_rerouting)
        if isinstance(manual_server_push, dict):
            manual_server_push = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush(**manual_server_push)
        if isinstance(media_acceleration, dict):
            media_acceleration = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration(**media_acceleration)
        if isinstance(media_acceleration_quic_optout, dict):
            media_acceleration_quic_optout = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout(**media_acceleration_quic_optout)
        if isinstance(media_client, dict):
            media_client = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient(**media_client)
        if isinstance(media_file_retrieval_optimization, dict):
            media_file_retrieval_optimization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization(**media_file_retrieval_optimization)
        if isinstance(media_origin_failover, dict):
            media_origin_failover = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover(**media_origin_failover)
        if isinstance(metadata_caching, dict):
            metadata_caching = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching(**metadata_caching)
        if isinstance(mobile_sdk_performance, dict):
            mobile_sdk_performance = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance(**mobile_sdk_performance)
        if isinstance(modify_incoming_request_header, dict):
            modify_incoming_request_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader(**modify_incoming_request_header)
        if isinstance(modify_incoming_response_header, dict):
            modify_incoming_response_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader(**modify_incoming_response_header)
        if isinstance(modify_outgoing_request_header, dict):
            modify_outgoing_request_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader(**modify_outgoing_request_header)
        if isinstance(modify_outgoing_response_header, dict):
            modify_outgoing_response_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader(**modify_outgoing_response_header)
        if isinstance(modify_via_header, dict):
            modify_via_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader(**modify_via_header)
        if isinstance(m_pulse, dict):
            m_pulse = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse(**m_pulse)
        if isinstance(origin, dict):
            origin = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin(**origin)
        if isinstance(origin_characteristics, dict):
            origin_characteristics = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics(**origin_characteristics)
        if isinstance(origin_characteristics_wsd, dict):
            origin_characteristics_wsd = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd(**origin_characteristics_wsd)
        if isinstance(origin_failure_recovery_method, dict):
            origin_failure_recovery_method = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod(**origin_failure_recovery_method)
        if isinstance(origin_failure_recovery_policy, dict):
            origin_failure_recovery_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy(**origin_failure_recovery_policy)
        if isinstance(origin_ip_acl, dict):
            origin_ip_acl = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl(**origin_ip_acl)
        if isinstance(permissions_policy, dict):
            permissions_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy(**permissions_policy)
        if isinstance(persistent_client_connection, dict):
            persistent_client_connection = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection(**persistent_client_connection)
        if isinstance(persistent_connection, dict):
            persistent_connection = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection(**persistent_connection)
        if isinstance(personally_identifiable_information, dict):
            personally_identifiable_information = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation(**personally_identifiable_information)
        if isinstance(phased_release, dict):
            phased_release = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease(**phased_release)
        if isinstance(preconnect, dict):
            preconnect = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect(**preconnect)
        if isinstance(predictive_content_delivery, dict):
            predictive_content_delivery = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery(**predictive_content_delivery)
        if isinstance(predictive_prefetching, dict):
            predictive_prefetching = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching(**predictive_prefetching)
        if isinstance(prefetch, dict):
            prefetch = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch(**prefetch)
        if isinstance(prefetchable, dict):
            prefetchable = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable(**prefetchable)
        if isinstance(prefresh_cache, dict):
            prefresh_cache = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache(**prefresh_cache)
        if isinstance(quality, dict):
            quality = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality(**quality)
        if isinstance(quic_beta, dict):
            quic_beta = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta(**quic_beta)
        if isinstance(random_seek, dict):
            random_seek = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek(**random_seek)
        if isinstance(rapid, dict):
            rapid = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid(**rapid)
        if isinstance(read_timeout, dict):
            read_timeout = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout(**read_timeout)
        if isinstance(real_time_reporting, dict):
            real_time_reporting = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting(**real_time_reporting)
        if isinstance(real_user_monitoring, dict):
            real_user_monitoring = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring(**real_user_monitoring)
        if isinstance(redirect, dict):
            redirect = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect(**redirect)
        if isinstance(redirectplus, dict):
            redirectplus = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus(**redirectplus)
        if isinstance(referer_checking, dict):
            referer_checking = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking(**referer_checking)
        if isinstance(remove_query_parameter, dict):
            remove_query_parameter = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter(**remove_query_parameter)
        if isinstance(remove_vary, dict):
            remove_vary = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary(**remove_vary)
        if isinstance(report, dict):
            report = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport(**report)
        if isinstance(request_client_hints, dict):
            request_client_hints = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints(**request_client_hints)
        if isinstance(request_control, dict):
            request_control = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl(**request_control)
        if isinstance(request_type_marker, dict):
            request_type_marker = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker(**request_type_marker)
        if isinstance(resource_optimizer, dict):
            resource_optimizer = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer(**resource_optimizer)
        if isinstance(resource_optimizer_extended_compatibility, dict):
            resource_optimizer_extended_compatibility = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility(**resource_optimizer_extended_compatibility)
        if isinstance(response_code, dict):
            response_code = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode(**response_code)
        if isinstance(response_cookie, dict):
            response_cookie = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie(**response_cookie)
        if isinstance(restrict_object_caching, dict):
            restrict_object_caching = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching(**restrict_object_caching)
        if isinstance(return_cache_status, dict):
            return_cache_status = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus(**return_cache_status)
        if isinstance(rewrite_url, dict):
            rewrite_url = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl(**rewrite_url)
        if isinstance(rum_custom, dict):
            rum_custom = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom(**rum_custom)
        if isinstance(saas_definitions, dict):
            saas_definitions = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions(**saas_definitions)
        if isinstance(sales_force_commerce_cloud_client, dict):
            sales_force_commerce_cloud_client = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient(**sales_force_commerce_cloud_client)
        if isinstance(sales_force_commerce_cloud_provider, dict):
            sales_force_commerce_cloud_provider = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider(**sales_force_commerce_cloud_provider)
        if isinstance(sales_force_commerce_cloud_provider_host_header, dict):
            sales_force_commerce_cloud_provider_host_header = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader(**sales_force_commerce_cloud_provider_host_header)
        if isinstance(save_post_dca_processing, dict):
            save_post_dca_processing = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing(**save_post_dca_processing)
        if isinstance(schedule_invalidation, dict):
            schedule_invalidation = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation(**schedule_invalidation)
        if isinstance(script_management, dict):
            script_management = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement(**script_management)
        if isinstance(segmented_content_protection, dict):
            segmented_content_protection = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection(**segmented_content_protection)
        if isinstance(segmented_media_optimization, dict):
            segmented_media_optimization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization(**segmented_media_optimization)
        if isinstance(segmented_media_streaming_prefetch, dict):
            segmented_media_streaming_prefetch = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch(**segmented_media_streaming_prefetch)
        if isinstance(set_variable, dict):
            set_variable = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable(**set_variable)
        if isinstance(simulate_error_code, dict):
            simulate_error_code = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode(**simulate_error_code)
        if isinstance(site_shield, dict):
            site_shield = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield(**site_shield)
        if isinstance(standard_tls_migration, dict):
            standard_tls_migration = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration(**standard_tls_migration)
        if isinstance(standard_tls_migration_override, dict):
            standard_tls_migration_override = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride(**standard_tls_migration_override)
        if isinstance(strict_header_parsing, dict):
            strict_header_parsing = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing(**strict_header_parsing)
        if isinstance(sub_customer, dict):
            sub_customer = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer(**sub_customer)
        if isinstance(sure_route, dict):
            sure_route = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute(**sure_route)
        if isinstance(tcp_optimization, dict):
            tcp_optimization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization(**tcp_optimization)
        if isinstance(tea_leaf, dict):
            tea_leaf = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf(**tea_leaf)
        if isinstance(tiered_distribution, dict):
            tiered_distribution = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution(**tiered_distribution)
        if isinstance(tiered_distribution_advanced, dict):
            tiered_distribution_advanced = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced(**tiered_distribution_advanced)
        if isinstance(tiered_distribution_customization, dict):
            tiered_distribution_customization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization(**tiered_distribution_customization)
        if isinstance(timeout, dict):
            timeout = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout(**timeout)
        if isinstance(uid_configuration, dict):
            uid_configuration = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration(**uid_configuration)
        if isinstance(validate_entity_tag, dict):
            validate_entity_tag = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag(**validate_entity_tag)
        if isinstance(verify_json_web_token, dict):
            verify_json_web_token = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken(**verify_json_web_token)
        if isinstance(verify_json_web_token_for_dcp, dict):
            verify_json_web_token_for_dcp = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp(**verify_json_web_token_for_dcp)
        if isinstance(verify_token_authorization, dict):
            verify_token_authorization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization(**verify_token_authorization)
        if isinstance(virtual_waiting_room, dict):
            virtual_waiting_room = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom(**virtual_waiting_room)
        if isinstance(virtual_waiting_room_with_edge_workers, dict):
            virtual_waiting_room_with_edge_workers = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers(**virtual_waiting_room_with_edge_workers)
        if isinstance(visitor_prioritization, dict):
            visitor_prioritization = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization(**visitor_prioritization)
        if isinstance(visitor_prioritization_fifo, dict):
            visitor_prioritization_fifo = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo(**visitor_prioritization_fifo)
        if isinstance(visitor_prioritization_fifo_standalone, dict):
            visitor_prioritization_fifo_standalone = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone(**visitor_prioritization_fifo_standalone)
        if isinstance(watermarking, dict):
            watermarking = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking(**watermarking)
        if isinstance(web_application_firewall, dict):
            web_application_firewall = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall(**web_application_firewall)
        if isinstance(webdav, dict):
            webdav = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav(**webdav)
        if isinstance(web_sockets, dict):
            web_sockets = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets(**web_sockets)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__748537e1bdbcf95dde08e3f07362528b609924a638ab2cdc42e61e84894fcd38)
            check_type(argname="argument adaptive_acceleration", value=adaptive_acceleration, expected_type=type_hints["adaptive_acceleration"])
            check_type(argname="argument adaptive_image_compression", value=adaptive_image_compression, expected_type=type_hints["adaptive_image_compression"])
            check_type(argname="argument ad_scaler_circuit_breaker", value=ad_scaler_circuit_breaker, expected_type=type_hints["ad_scaler_circuit_breaker"])
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument aggregated_reporting", value=aggregated_reporting, expected_type=type_hints["aggregated_reporting"])
            check_type(argname="argument akamaizer", value=akamaizer, expected_type=type_hints["akamaizer"])
            check_type(argname="argument akamaizer_tag", value=akamaizer_tag, expected_type=type_hints["akamaizer_tag"])
            check_type(argname="argument all_http_in_cache_hierarchy", value=all_http_in_cache_hierarchy, expected_type=type_hints["all_http_in_cache_hierarchy"])
            check_type(argname="argument allow_cloudlets_origins", value=allow_cloudlets_origins, expected_type=type_hints["allow_cloudlets_origins"])
            check_type(argname="argument allow_delete", value=allow_delete, expected_type=type_hints["allow_delete"])
            check_type(argname="argument allow_https_cache_key_sharing", value=allow_https_cache_key_sharing, expected_type=type_hints["allow_https_cache_key_sharing"])
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_options", value=allow_options, expected_type=type_hints["allow_options"])
            check_type(argname="argument allow_patch", value=allow_patch, expected_type=type_hints["allow_patch"])
            check_type(argname="argument allow_post", value=allow_post, expected_type=type_hints["allow_post"])
            check_type(argname="argument allow_put", value=allow_put, expected_type=type_hints["allow_put"])
            check_type(argname="argument allow_transfer_encoding", value=allow_transfer_encoding, expected_type=type_hints["allow_transfer_encoding"])
            check_type(argname="argument alt_svc_header", value=alt_svc_header, expected_type=type_hints["alt_svc_header"])
            check_type(argname="argument api_prioritization", value=api_prioritization, expected_type=type_hints["api_prioritization"])
            check_type(argname="argument application_load_balancer", value=application_load_balancer, expected_type=type_hints["application_load_balancer"])
            check_type(argname="argument audience_segmentation", value=audience_segmentation, expected_type=type_hints["audience_segmentation"])
            check_type(argname="argument auto_domain_validation", value=auto_domain_validation, expected_type=type_hints["auto_domain_validation"])
            check_type(argname="argument base_directory", value=base_directory, expected_type=type_hints["base_directory"])
            check_type(argname="argument boss_beaconing", value=boss_beaconing, expected_type=type_hints["boss_beaconing"])
            check_type(argname="argument breadcrumbs", value=breadcrumbs, expected_type=type_hints["breadcrumbs"])
            check_type(argname="argument break_connection", value=break_connection, expected_type=type_hints["break_connection"])
            check_type(argname="argument brotli", value=brotli, expected_type=type_hints["brotli"])
            check_type(argname="argument cache_error", value=cache_error, expected_type=type_hints["cache_error"])
            check_type(argname="argument cache_id", value=cache_id, expected_type=type_hints["cache_id"])
            check_type(argname="argument cache_key_ignore_case", value=cache_key_ignore_case, expected_type=type_hints["cache_key_ignore_case"])
            check_type(argname="argument cache_key_query_params", value=cache_key_query_params, expected_type=type_hints["cache_key_query_params"])
            check_type(argname="argument cache_key_rewrite", value=cache_key_rewrite, expected_type=type_hints["cache_key_rewrite"])
            check_type(argname="argument cache_post", value=cache_post, expected_type=type_hints["cache_post"])
            check_type(argname="argument cache_redirect", value=cache_redirect, expected_type=type_hints["cache_redirect"])
            check_type(argname="argument cache_tag", value=cache_tag, expected_type=type_hints["cache_tag"])
            check_type(argname="argument cache_tag_visible", value=cache_tag_visible, expected_type=type_hints["cache_tag_visible"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument central_authorization", value=central_authorization, expected_type=type_hints["central_authorization"])
            check_type(argname="argument chase_redirects", value=chase_redirects, expected_type=type_hints["chase_redirects"])
            check_type(argname="argument client_certificate_auth", value=client_certificate_auth, expected_type=type_hints["client_certificate_auth"])
            check_type(argname="argument client_characteristics", value=client_characteristics, expected_type=type_hints["client_characteristics"])
            check_type(argname="argument cloud_interconnects", value=cloud_interconnects, expected_type=type_hints["cloud_interconnects"])
            check_type(argname="argument cloud_wrapper", value=cloud_wrapper, expected_type=type_hints["cloud_wrapper"])
            check_type(argname="argument cloud_wrapper_advanced", value=cloud_wrapper_advanced, expected_type=type_hints["cloud_wrapper_advanced"])
            check_type(argname="argument common_media_client_data", value=common_media_client_data, expected_type=type_hints["common_media_client_data"])
            check_type(argname="argument conditional_origin", value=conditional_origin, expected_type=type_hints["conditional_origin"])
            check_type(argname="argument construct_response", value=construct_response, expected_type=type_hints["construct_response"])
            check_type(argname="argument content_characteristics", value=content_characteristics, expected_type=type_hints["content_characteristics"])
            check_type(argname="argument content_characteristics_amd", value=content_characteristics_amd, expected_type=type_hints["content_characteristics_amd"])
            check_type(argname="argument content_characteristics_dd", value=content_characteristics_dd, expected_type=type_hints["content_characteristics_dd"])
            check_type(argname="argument content_characteristics_wsd_large_file", value=content_characteristics_wsd_large_file, expected_type=type_hints["content_characteristics_wsd_large_file"])
            check_type(argname="argument content_characteristics_wsd_live", value=content_characteristics_wsd_live, expected_type=type_hints["content_characteristics_wsd_live"])
            check_type(argname="argument content_characteristics_wsd_vod", value=content_characteristics_wsd_vod, expected_type=type_hints["content_characteristics_wsd_vod"])
            check_type(argname="argument content_pre_position", value=content_pre_position, expected_type=type_hints["content_pre_position"])
            check_type(argname="argument content_targeting_protection", value=content_targeting_protection, expected_type=type_hints["content_targeting_protection"])
            check_type(argname="argument cors_support", value=cors_support, expected_type=type_hints["cors_support"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument custom_behavior", value=custom_behavior, expected_type=type_hints["custom_behavior"])
            check_type(argname="argument datastream", value=datastream, expected_type=type_hints["datastream"])
            check_type(argname="argument dcp", value=dcp, expected_type=type_hints["dcp"])
            check_type(argname="argument dcp_auth_hmac_transformation", value=dcp_auth_hmac_transformation, expected_type=type_hints["dcp_auth_hmac_transformation"])
            check_type(argname="argument dcp_auth_regex_transformation", value=dcp_auth_regex_transformation, expected_type=type_hints["dcp_auth_regex_transformation"])
            check_type(argname="argument dcp_auth_substring_transformation", value=dcp_auth_substring_transformation, expected_type=type_hints["dcp_auth_substring_transformation"])
            check_type(argname="argument dcp_auth_variable_extractor", value=dcp_auth_variable_extractor, expected_type=type_hints["dcp_auth_variable_extractor"])
            check_type(argname="argument dcp_default_authz_groups", value=dcp_default_authz_groups, expected_type=type_hints["dcp_default_authz_groups"])
            check_type(argname="argument dcp_dev_relations", value=dcp_dev_relations, expected_type=type_hints["dcp_dev_relations"])
            check_type(argname="argument dcp_real_time_auth", value=dcp_real_time_auth, expected_type=type_hints["dcp_real_time_auth"])
            check_type(argname="argument delivery_receipt", value=delivery_receipt, expected_type=type_hints["delivery_receipt"])
            check_type(argname="argument deny_access", value=deny_access, expected_type=type_hints["deny_access"])
            check_type(argname="argument deny_direct_failover_access", value=deny_direct_failover_access, expected_type=type_hints["deny_direct_failover_access"])
            check_type(argname="argument device_characteristic_cache_id", value=device_characteristic_cache_id, expected_type=type_hints["device_characteristic_cache_id"])
            check_type(argname="argument device_characteristic_header", value=device_characteristic_header, expected_type=type_hints["device_characteristic_header"])
            check_type(argname="argument dns_async_refresh", value=dns_async_refresh, expected_type=type_hints["dns_async_refresh"])
            check_type(argname="argument dns_prefresh", value=dns_prefresh, expected_type=type_hints["dns_prefresh"])
            check_type(argname="argument downgrade_protocol", value=downgrade_protocol, expected_type=type_hints["downgrade_protocol"])
            check_type(argname="argument download_complete_marker", value=download_complete_marker, expected_type=type_hints["download_complete_marker"])
            check_type(argname="argument download_notification", value=download_notification, expected_type=type_hints["download_notification"])
            check_type(argname="argument downstream_cache", value=downstream_cache, expected_type=type_hints["downstream_cache"])
            check_type(argname="argument dynamic_throughtput_optimization", value=dynamic_throughtput_optimization, expected_type=type_hints["dynamic_throughtput_optimization"])
            check_type(argname="argument dynamic_throughtput_optimization_override", value=dynamic_throughtput_optimization_override, expected_type=type_hints["dynamic_throughtput_optimization_override"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument ecms_bulk_upload", value=ecms_bulk_upload, expected_type=type_hints["ecms_bulk_upload"])
            check_type(argname="argument ecms_database", value=ecms_database, expected_type=type_hints["ecms_database"])
            check_type(argname="argument ecms_dataset", value=ecms_dataset, expected_type=type_hints["ecms_dataset"])
            check_type(argname="argument ecms_object_key", value=ecms_object_key, expected_type=type_hints["ecms_object_key"])
            check_type(argname="argument edge_connect", value=edge_connect, expected_type=type_hints["edge_connect"])
            check_type(argname="argument edge_load_balancing_advanced", value=edge_load_balancing_advanced, expected_type=type_hints["edge_load_balancing_advanced"])
            check_type(argname="argument edge_load_balancing_data_center", value=edge_load_balancing_data_center, expected_type=type_hints["edge_load_balancing_data_center"])
            check_type(argname="argument edge_load_balancing_origin", value=edge_load_balancing_origin, expected_type=type_hints["edge_load_balancing_origin"])
            check_type(argname="argument edge_origin_authorization", value=edge_origin_authorization, expected_type=type_hints["edge_origin_authorization"])
            check_type(argname="argument edge_redirector", value=edge_redirector, expected_type=type_hints["edge_redirector"])
            check_type(argname="argument edge_scape", value=edge_scape, expected_type=type_hints["edge_scape"])
            check_type(argname="argument edge_side_includes", value=edge_side_includes, expected_type=type_hints["edge_side_includes"])
            check_type(argname="argument edge_worker", value=edge_worker, expected_type=type_hints["edge_worker"])
            check_type(argname="argument enforce_mtls_settings", value=enforce_mtls_settings, expected_type=type_hints["enforce_mtls_settings"])
            check_type(argname="argument enhanced_akamai_protocol", value=enhanced_akamai_protocol, expected_type=type_hints["enhanced_akamai_protocol"])
            check_type(argname="argument enhanced_proxy_detection", value=enhanced_proxy_detection, expected_type=type_hints["enhanced_proxy_detection"])
            check_type(argname="argument epd_forward_header_enrichment", value=epd_forward_header_enrichment, expected_type=type_hints["epd_forward_header_enrichment"])
            check_type(argname="argument fail_action", value=fail_action, expected_type=type_hints["fail_action"])
            check_type(argname="argument failover_bot_manager_feature_compatibility", value=failover_bot_manager_feature_compatibility, expected_type=type_hints["failover_bot_manager_feature_compatibility"])
            check_type(argname="argument fast_invalidate", value=fast_invalidate, expected_type=type_hints["fast_invalidate"])
            check_type(argname="argument fips", value=fips, expected_type=type_hints["fips"])
            check_type(argname="argument first_party_marketing", value=first_party_marketing, expected_type=type_hints["first_party_marketing"])
            check_type(argname="argument first_party_marketing_plus", value=first_party_marketing_plus, expected_type=type_hints["first_party_marketing_plus"])
            check_type(argname="argument forward_rewrite", value=forward_rewrite, expected_type=type_hints["forward_rewrite"])
            check_type(argname="argument g2_oheader", value=g2_oheader, expected_type=type_hints["g2_oheader"])
            check_type(argname="argument global_request_number", value=global_request_number, expected_type=type_hints["global_request_number"])
            check_type(argname="argument graphql_caching", value=graphql_caching, expected_type=type_hints["graphql_caching"])
            check_type(argname="argument gzip_response", value=gzip_response, expected_type=type_hints["gzip_response"])
            check_type(argname="argument hd_data_advanced", value=hd_data_advanced, expected_type=type_hints["hd_data_advanced"])
            check_type(argname="argument health_detection", value=health_detection, expected_type=type_hints["health_detection"])
            check_type(argname="argument hsaf_eip_binding", value=hsaf_eip_binding, expected_type=type_hints["hsaf_eip_binding"])
            check_type(argname="argument http2", value=http2, expected_type=type_hints["http2"])
            check_type(argname="argument http3", value=http3, expected_type=type_hints["http3"])
            check_type(argname="argument http_strict_transport_security", value=http_strict_transport_security, expected_type=type_hints["http_strict_transport_security"])
            check_type(argname="argument http_to_https_upgrade", value=http_to_https_upgrade, expected_type=type_hints["http_to_https_upgrade"])
            check_type(argname="argument image_and_video_manager", value=image_and_video_manager, expected_type=type_hints["image_and_video_manager"])
            check_type(argname="argument image_manager", value=image_manager, expected_type=type_hints["image_manager"])
            check_type(argname="argument image_manager_video", value=image_manager_video, expected_type=type_hints["image_manager_video"])
            check_type(argname="argument im_override", value=im_override, expected_type=type_hints["im_override"])
            check_type(argname="argument include", value=include, expected_type=type_hints["include"])
            check_type(argname="argument instant", value=instant, expected_type=type_hints["instant"])
            check_type(argname="argument instant_config", value=instant_config, expected_type=type_hints["instant_config"])
            check_type(argname="argument large_file_optimization", value=large_file_optimization, expected_type=type_hints["large_file_optimization"])
            check_type(argname="argument large_file_optimization_advanced", value=large_file_optimization_advanced, expected_type=type_hints["large_file_optimization_advanced"])
            check_type(argname="argument limit_bit_rate", value=limit_bit_rate, expected_type=type_hints["limit_bit_rate"])
            check_type(argname="argument log_custom", value=log_custom, expected_type=type_hints["log_custom"])
            check_type(argname="argument manifest_personalization", value=manifest_personalization, expected_type=type_hints["manifest_personalization"])
            check_type(argname="argument manifest_rerouting", value=manifest_rerouting, expected_type=type_hints["manifest_rerouting"])
            check_type(argname="argument manual_server_push", value=manual_server_push, expected_type=type_hints["manual_server_push"])
            check_type(argname="argument media_acceleration", value=media_acceleration, expected_type=type_hints["media_acceleration"])
            check_type(argname="argument media_acceleration_quic_optout", value=media_acceleration_quic_optout, expected_type=type_hints["media_acceleration_quic_optout"])
            check_type(argname="argument media_client", value=media_client, expected_type=type_hints["media_client"])
            check_type(argname="argument media_file_retrieval_optimization", value=media_file_retrieval_optimization, expected_type=type_hints["media_file_retrieval_optimization"])
            check_type(argname="argument media_origin_failover", value=media_origin_failover, expected_type=type_hints["media_origin_failover"])
            check_type(argname="argument metadata_caching", value=metadata_caching, expected_type=type_hints["metadata_caching"])
            check_type(argname="argument mobile_sdk_performance", value=mobile_sdk_performance, expected_type=type_hints["mobile_sdk_performance"])
            check_type(argname="argument modify_incoming_request_header", value=modify_incoming_request_header, expected_type=type_hints["modify_incoming_request_header"])
            check_type(argname="argument modify_incoming_response_header", value=modify_incoming_response_header, expected_type=type_hints["modify_incoming_response_header"])
            check_type(argname="argument modify_outgoing_request_header", value=modify_outgoing_request_header, expected_type=type_hints["modify_outgoing_request_header"])
            check_type(argname="argument modify_outgoing_response_header", value=modify_outgoing_response_header, expected_type=type_hints["modify_outgoing_response_header"])
            check_type(argname="argument modify_via_header", value=modify_via_header, expected_type=type_hints["modify_via_header"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument origin_characteristics", value=origin_characteristics, expected_type=type_hints["origin_characteristics"])
            check_type(argname="argument origin_characteristics_wsd", value=origin_characteristics_wsd, expected_type=type_hints["origin_characteristics_wsd"])
            check_type(argname="argument origin_failure_recovery_method", value=origin_failure_recovery_method, expected_type=type_hints["origin_failure_recovery_method"])
            check_type(argname="argument origin_failure_recovery_policy", value=origin_failure_recovery_policy, expected_type=type_hints["origin_failure_recovery_policy"])
            check_type(argname="argument origin_ip_acl", value=origin_ip_acl, expected_type=type_hints["origin_ip_acl"])
            check_type(argname="argument permissions_policy", value=permissions_policy, expected_type=type_hints["permissions_policy"])
            check_type(argname="argument persistent_client_connection", value=persistent_client_connection, expected_type=type_hints["persistent_client_connection"])
            check_type(argname="argument persistent_connection", value=persistent_connection, expected_type=type_hints["persistent_connection"])
            check_type(argname="argument personally_identifiable_information", value=personally_identifiable_information, expected_type=type_hints["personally_identifiable_information"])
            check_type(argname="argument phased_release", value=phased_release, expected_type=type_hints["phased_release"])
            check_type(argname="argument preconnect", value=preconnect, expected_type=type_hints["preconnect"])
            check_type(argname="argument predictive_content_delivery", value=predictive_content_delivery, expected_type=type_hints["predictive_content_delivery"])
            check_type(argname="argument predictive_prefetching", value=predictive_prefetching, expected_type=type_hints["predictive_prefetching"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument prefetchable", value=prefetchable, expected_type=type_hints["prefetchable"])
            check_type(argname="argument prefresh_cache", value=prefresh_cache, expected_type=type_hints["prefresh_cache"])
            check_type(argname="argument quality", value=quality, expected_type=type_hints["quality"])
            check_type(argname="argument quic_beta", value=quic_beta, expected_type=type_hints["quic_beta"])
            check_type(argname="argument random_seek", value=random_seek, expected_type=type_hints["random_seek"])
            check_type(argname="argument rapid", value=rapid, expected_type=type_hints["rapid"])
            check_type(argname="argument read_timeout", value=read_timeout, expected_type=type_hints["read_timeout"])
            check_type(argname="argument real_time_reporting", value=real_time_reporting, expected_type=type_hints["real_time_reporting"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirectplus", value=redirectplus, expected_type=type_hints["redirectplus"])
            check_type(argname="argument referer_checking", value=referer_checking, expected_type=type_hints["referer_checking"])
            check_type(argname="argument remove_query_parameter", value=remove_query_parameter, expected_type=type_hints["remove_query_parameter"])
            check_type(argname="argument remove_vary", value=remove_vary, expected_type=type_hints["remove_vary"])
            check_type(argname="argument report", value=report, expected_type=type_hints["report"])
            check_type(argname="argument request_client_hints", value=request_client_hints, expected_type=type_hints["request_client_hints"])
            check_type(argname="argument request_control", value=request_control, expected_type=type_hints["request_control"])
            check_type(argname="argument request_type_marker", value=request_type_marker, expected_type=type_hints["request_type_marker"])
            check_type(argname="argument resource_optimizer", value=resource_optimizer, expected_type=type_hints["resource_optimizer"])
            check_type(argname="argument resource_optimizer_extended_compatibility", value=resource_optimizer_extended_compatibility, expected_type=type_hints["resource_optimizer_extended_compatibility"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument response_cookie", value=response_cookie, expected_type=type_hints["response_cookie"])
            check_type(argname="argument restrict_object_caching", value=restrict_object_caching, expected_type=type_hints["restrict_object_caching"])
            check_type(argname="argument return_cache_status", value=return_cache_status, expected_type=type_hints["return_cache_status"])
            check_type(argname="argument rewrite_url", value=rewrite_url, expected_type=type_hints["rewrite_url"])
            check_type(argname="argument rum_custom", value=rum_custom, expected_type=type_hints["rum_custom"])
            check_type(argname="argument saas_definitions", value=saas_definitions, expected_type=type_hints["saas_definitions"])
            check_type(argname="argument sales_force_commerce_cloud_client", value=sales_force_commerce_cloud_client, expected_type=type_hints["sales_force_commerce_cloud_client"])
            check_type(argname="argument sales_force_commerce_cloud_provider", value=sales_force_commerce_cloud_provider, expected_type=type_hints["sales_force_commerce_cloud_provider"])
            check_type(argname="argument sales_force_commerce_cloud_provider_host_header", value=sales_force_commerce_cloud_provider_host_header, expected_type=type_hints["sales_force_commerce_cloud_provider_host_header"])
            check_type(argname="argument save_post_dca_processing", value=save_post_dca_processing, expected_type=type_hints["save_post_dca_processing"])
            check_type(argname="argument schedule_invalidation", value=schedule_invalidation, expected_type=type_hints["schedule_invalidation"])
            check_type(argname="argument script_management", value=script_management, expected_type=type_hints["script_management"])
            check_type(argname="argument segmented_content_protection", value=segmented_content_protection, expected_type=type_hints["segmented_content_protection"])
            check_type(argname="argument segmented_media_optimization", value=segmented_media_optimization, expected_type=type_hints["segmented_media_optimization"])
            check_type(argname="argument segmented_media_streaming_prefetch", value=segmented_media_streaming_prefetch, expected_type=type_hints["segmented_media_streaming_prefetch"])
            check_type(argname="argument set_variable", value=set_variable, expected_type=type_hints["set_variable"])
            check_type(argname="argument simulate_error_code", value=simulate_error_code, expected_type=type_hints["simulate_error_code"])
            check_type(argname="argument site_shield", value=site_shield, expected_type=type_hints["site_shield"])
            check_type(argname="argument standard_tls_migration", value=standard_tls_migration, expected_type=type_hints["standard_tls_migration"])
            check_type(argname="argument standard_tls_migration_override", value=standard_tls_migration_override, expected_type=type_hints["standard_tls_migration_override"])
            check_type(argname="argument strict_header_parsing", value=strict_header_parsing, expected_type=type_hints["strict_header_parsing"])
            check_type(argname="argument sub_customer", value=sub_customer, expected_type=type_hints["sub_customer"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument tcp_optimization", value=tcp_optimization, expected_type=type_hints["tcp_optimization"])
            check_type(argname="argument tea_leaf", value=tea_leaf, expected_type=type_hints["tea_leaf"])
            check_type(argname="argument tiered_distribution", value=tiered_distribution, expected_type=type_hints["tiered_distribution"])
            check_type(argname="argument tiered_distribution_advanced", value=tiered_distribution_advanced, expected_type=type_hints["tiered_distribution_advanced"])
            check_type(argname="argument tiered_distribution_customization", value=tiered_distribution_customization, expected_type=type_hints["tiered_distribution_customization"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uid_configuration", value=uid_configuration, expected_type=type_hints["uid_configuration"])
            check_type(argname="argument validate_entity_tag", value=validate_entity_tag, expected_type=type_hints["validate_entity_tag"])
            check_type(argname="argument verify_json_web_token", value=verify_json_web_token, expected_type=type_hints["verify_json_web_token"])
            check_type(argname="argument verify_json_web_token_for_dcp", value=verify_json_web_token_for_dcp, expected_type=type_hints["verify_json_web_token_for_dcp"])
            check_type(argname="argument verify_token_authorization", value=verify_token_authorization, expected_type=type_hints["verify_token_authorization"])
            check_type(argname="argument virtual_waiting_room", value=virtual_waiting_room, expected_type=type_hints["virtual_waiting_room"])
            check_type(argname="argument virtual_waiting_room_with_edge_workers", value=virtual_waiting_room_with_edge_workers, expected_type=type_hints["virtual_waiting_room_with_edge_workers"])
            check_type(argname="argument visitor_prioritization", value=visitor_prioritization, expected_type=type_hints["visitor_prioritization"])
            check_type(argname="argument visitor_prioritization_fifo", value=visitor_prioritization_fifo, expected_type=type_hints["visitor_prioritization_fifo"])
            check_type(argname="argument visitor_prioritization_fifo_standalone", value=visitor_prioritization_fifo_standalone, expected_type=type_hints["visitor_prioritization_fifo_standalone"])
            check_type(argname="argument watermarking", value=watermarking, expected_type=type_hints["watermarking"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
            check_type(argname="argument webdav", value=webdav, expected_type=type_hints["webdav"])
            check_type(argname="argument web_sockets", value=web_sockets, expected_type=type_hints["web_sockets"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if adaptive_acceleration is not None:
            self._values["adaptive_acceleration"] = adaptive_acceleration
        if adaptive_image_compression is not None:
            self._values["adaptive_image_compression"] = adaptive_image_compression
        if ad_scaler_circuit_breaker is not None:
            self._values["ad_scaler_circuit_breaker"] = ad_scaler_circuit_breaker
        if advanced is not None:
            self._values["advanced"] = advanced
        if aggregated_reporting is not None:
            self._values["aggregated_reporting"] = aggregated_reporting
        if akamaizer is not None:
            self._values["akamaizer"] = akamaizer
        if akamaizer_tag is not None:
            self._values["akamaizer_tag"] = akamaizer_tag
        if all_http_in_cache_hierarchy is not None:
            self._values["all_http_in_cache_hierarchy"] = all_http_in_cache_hierarchy
        if allow_cloudlets_origins is not None:
            self._values["allow_cloudlets_origins"] = allow_cloudlets_origins
        if allow_delete is not None:
            self._values["allow_delete"] = allow_delete
        if allow_https_cache_key_sharing is not None:
            self._values["allow_https_cache_key_sharing"] = allow_https_cache_key_sharing
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_options is not None:
            self._values["allow_options"] = allow_options
        if allow_patch is not None:
            self._values["allow_patch"] = allow_patch
        if allow_post is not None:
            self._values["allow_post"] = allow_post
        if allow_put is not None:
            self._values["allow_put"] = allow_put
        if allow_transfer_encoding is not None:
            self._values["allow_transfer_encoding"] = allow_transfer_encoding
        if alt_svc_header is not None:
            self._values["alt_svc_header"] = alt_svc_header
        if api_prioritization is not None:
            self._values["api_prioritization"] = api_prioritization
        if application_load_balancer is not None:
            self._values["application_load_balancer"] = application_load_balancer
        if audience_segmentation is not None:
            self._values["audience_segmentation"] = audience_segmentation
        if auto_domain_validation is not None:
            self._values["auto_domain_validation"] = auto_domain_validation
        if base_directory is not None:
            self._values["base_directory"] = base_directory
        if boss_beaconing is not None:
            self._values["boss_beaconing"] = boss_beaconing
        if breadcrumbs is not None:
            self._values["breadcrumbs"] = breadcrumbs
        if break_connection is not None:
            self._values["break_connection"] = break_connection
        if brotli is not None:
            self._values["brotli"] = brotli
        if cache_error is not None:
            self._values["cache_error"] = cache_error
        if cache_id is not None:
            self._values["cache_id"] = cache_id
        if cache_key_ignore_case is not None:
            self._values["cache_key_ignore_case"] = cache_key_ignore_case
        if cache_key_query_params is not None:
            self._values["cache_key_query_params"] = cache_key_query_params
        if cache_key_rewrite is not None:
            self._values["cache_key_rewrite"] = cache_key_rewrite
        if cache_post is not None:
            self._values["cache_post"] = cache_post
        if cache_redirect is not None:
            self._values["cache_redirect"] = cache_redirect
        if cache_tag is not None:
            self._values["cache_tag"] = cache_tag
        if cache_tag_visible is not None:
            self._values["cache_tag_visible"] = cache_tag_visible
        if caching is not None:
            self._values["caching"] = caching
        if central_authorization is not None:
            self._values["central_authorization"] = central_authorization
        if chase_redirects is not None:
            self._values["chase_redirects"] = chase_redirects
        if client_certificate_auth is not None:
            self._values["client_certificate_auth"] = client_certificate_auth
        if client_characteristics is not None:
            self._values["client_characteristics"] = client_characteristics
        if cloud_interconnects is not None:
            self._values["cloud_interconnects"] = cloud_interconnects
        if cloud_wrapper is not None:
            self._values["cloud_wrapper"] = cloud_wrapper
        if cloud_wrapper_advanced is not None:
            self._values["cloud_wrapper_advanced"] = cloud_wrapper_advanced
        if common_media_client_data is not None:
            self._values["common_media_client_data"] = common_media_client_data
        if conditional_origin is not None:
            self._values["conditional_origin"] = conditional_origin
        if construct_response is not None:
            self._values["construct_response"] = construct_response
        if content_characteristics is not None:
            self._values["content_characteristics"] = content_characteristics
        if content_characteristics_amd is not None:
            self._values["content_characteristics_amd"] = content_characteristics_amd
        if content_characteristics_dd is not None:
            self._values["content_characteristics_dd"] = content_characteristics_dd
        if content_characteristics_wsd_large_file is not None:
            self._values["content_characteristics_wsd_large_file"] = content_characteristics_wsd_large_file
        if content_characteristics_wsd_live is not None:
            self._values["content_characteristics_wsd_live"] = content_characteristics_wsd_live
        if content_characteristics_wsd_vod is not None:
            self._values["content_characteristics_wsd_vod"] = content_characteristics_wsd_vod
        if content_pre_position is not None:
            self._values["content_pre_position"] = content_pre_position
        if content_targeting_protection is not None:
            self._values["content_targeting_protection"] = content_targeting_protection
        if cors_support is not None:
            self._values["cors_support"] = cors_support
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if custom_behavior is not None:
            self._values["custom_behavior"] = custom_behavior
        if datastream is not None:
            self._values["datastream"] = datastream
        if dcp is not None:
            self._values["dcp"] = dcp
        if dcp_auth_hmac_transformation is not None:
            self._values["dcp_auth_hmac_transformation"] = dcp_auth_hmac_transformation
        if dcp_auth_regex_transformation is not None:
            self._values["dcp_auth_regex_transformation"] = dcp_auth_regex_transformation
        if dcp_auth_substring_transformation is not None:
            self._values["dcp_auth_substring_transformation"] = dcp_auth_substring_transformation
        if dcp_auth_variable_extractor is not None:
            self._values["dcp_auth_variable_extractor"] = dcp_auth_variable_extractor
        if dcp_default_authz_groups is not None:
            self._values["dcp_default_authz_groups"] = dcp_default_authz_groups
        if dcp_dev_relations is not None:
            self._values["dcp_dev_relations"] = dcp_dev_relations
        if dcp_real_time_auth is not None:
            self._values["dcp_real_time_auth"] = dcp_real_time_auth
        if delivery_receipt is not None:
            self._values["delivery_receipt"] = delivery_receipt
        if deny_access is not None:
            self._values["deny_access"] = deny_access
        if deny_direct_failover_access is not None:
            self._values["deny_direct_failover_access"] = deny_direct_failover_access
        if device_characteristic_cache_id is not None:
            self._values["device_characteristic_cache_id"] = device_characteristic_cache_id
        if device_characteristic_header is not None:
            self._values["device_characteristic_header"] = device_characteristic_header
        if dns_async_refresh is not None:
            self._values["dns_async_refresh"] = dns_async_refresh
        if dns_prefresh is not None:
            self._values["dns_prefresh"] = dns_prefresh
        if downgrade_protocol is not None:
            self._values["downgrade_protocol"] = downgrade_protocol
        if download_complete_marker is not None:
            self._values["download_complete_marker"] = download_complete_marker
        if download_notification is not None:
            self._values["download_notification"] = download_notification
        if downstream_cache is not None:
            self._values["downstream_cache"] = downstream_cache
        if dynamic_throughtput_optimization is not None:
            self._values["dynamic_throughtput_optimization"] = dynamic_throughtput_optimization
        if dynamic_throughtput_optimization_override is not None:
            self._values["dynamic_throughtput_optimization_override"] = dynamic_throughtput_optimization_override
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if ecms_bulk_upload is not None:
            self._values["ecms_bulk_upload"] = ecms_bulk_upload
        if ecms_database is not None:
            self._values["ecms_database"] = ecms_database
        if ecms_dataset is not None:
            self._values["ecms_dataset"] = ecms_dataset
        if ecms_object_key is not None:
            self._values["ecms_object_key"] = ecms_object_key
        if edge_connect is not None:
            self._values["edge_connect"] = edge_connect
        if edge_load_balancing_advanced is not None:
            self._values["edge_load_balancing_advanced"] = edge_load_balancing_advanced
        if edge_load_balancing_data_center is not None:
            self._values["edge_load_balancing_data_center"] = edge_load_balancing_data_center
        if edge_load_balancing_origin is not None:
            self._values["edge_load_balancing_origin"] = edge_load_balancing_origin
        if edge_origin_authorization is not None:
            self._values["edge_origin_authorization"] = edge_origin_authorization
        if edge_redirector is not None:
            self._values["edge_redirector"] = edge_redirector
        if edge_scape is not None:
            self._values["edge_scape"] = edge_scape
        if edge_side_includes is not None:
            self._values["edge_side_includes"] = edge_side_includes
        if edge_worker is not None:
            self._values["edge_worker"] = edge_worker
        if enforce_mtls_settings is not None:
            self._values["enforce_mtls_settings"] = enforce_mtls_settings
        if enhanced_akamai_protocol is not None:
            self._values["enhanced_akamai_protocol"] = enhanced_akamai_protocol
        if enhanced_proxy_detection is not None:
            self._values["enhanced_proxy_detection"] = enhanced_proxy_detection
        if epd_forward_header_enrichment is not None:
            self._values["epd_forward_header_enrichment"] = epd_forward_header_enrichment
        if fail_action is not None:
            self._values["fail_action"] = fail_action
        if failover_bot_manager_feature_compatibility is not None:
            self._values["failover_bot_manager_feature_compatibility"] = failover_bot_manager_feature_compatibility
        if fast_invalidate is not None:
            self._values["fast_invalidate"] = fast_invalidate
        if fips is not None:
            self._values["fips"] = fips
        if first_party_marketing is not None:
            self._values["first_party_marketing"] = first_party_marketing
        if first_party_marketing_plus is not None:
            self._values["first_party_marketing_plus"] = first_party_marketing_plus
        if forward_rewrite is not None:
            self._values["forward_rewrite"] = forward_rewrite
        if g2_oheader is not None:
            self._values["g2_oheader"] = g2_oheader
        if global_request_number is not None:
            self._values["global_request_number"] = global_request_number
        if graphql_caching is not None:
            self._values["graphql_caching"] = graphql_caching
        if gzip_response is not None:
            self._values["gzip_response"] = gzip_response
        if hd_data_advanced is not None:
            self._values["hd_data_advanced"] = hd_data_advanced
        if health_detection is not None:
            self._values["health_detection"] = health_detection
        if hsaf_eip_binding is not None:
            self._values["hsaf_eip_binding"] = hsaf_eip_binding
        if http2 is not None:
            self._values["http2"] = http2
        if http3 is not None:
            self._values["http3"] = http3
        if http_strict_transport_security is not None:
            self._values["http_strict_transport_security"] = http_strict_transport_security
        if http_to_https_upgrade is not None:
            self._values["http_to_https_upgrade"] = http_to_https_upgrade
        if image_and_video_manager is not None:
            self._values["image_and_video_manager"] = image_and_video_manager
        if image_manager is not None:
            self._values["image_manager"] = image_manager
        if image_manager_video is not None:
            self._values["image_manager_video"] = image_manager_video
        if im_override is not None:
            self._values["im_override"] = im_override
        if include is not None:
            self._values["include"] = include
        if instant is not None:
            self._values["instant"] = instant
        if instant_config is not None:
            self._values["instant_config"] = instant_config
        if large_file_optimization is not None:
            self._values["large_file_optimization"] = large_file_optimization
        if large_file_optimization_advanced is not None:
            self._values["large_file_optimization_advanced"] = large_file_optimization_advanced
        if limit_bit_rate is not None:
            self._values["limit_bit_rate"] = limit_bit_rate
        if log_custom is not None:
            self._values["log_custom"] = log_custom
        if manifest_personalization is not None:
            self._values["manifest_personalization"] = manifest_personalization
        if manifest_rerouting is not None:
            self._values["manifest_rerouting"] = manifest_rerouting
        if manual_server_push is not None:
            self._values["manual_server_push"] = manual_server_push
        if media_acceleration is not None:
            self._values["media_acceleration"] = media_acceleration
        if media_acceleration_quic_optout is not None:
            self._values["media_acceleration_quic_optout"] = media_acceleration_quic_optout
        if media_client is not None:
            self._values["media_client"] = media_client
        if media_file_retrieval_optimization is not None:
            self._values["media_file_retrieval_optimization"] = media_file_retrieval_optimization
        if media_origin_failover is not None:
            self._values["media_origin_failover"] = media_origin_failover
        if metadata_caching is not None:
            self._values["metadata_caching"] = metadata_caching
        if mobile_sdk_performance is not None:
            self._values["mobile_sdk_performance"] = mobile_sdk_performance
        if modify_incoming_request_header is not None:
            self._values["modify_incoming_request_header"] = modify_incoming_request_header
        if modify_incoming_response_header is not None:
            self._values["modify_incoming_response_header"] = modify_incoming_response_header
        if modify_outgoing_request_header is not None:
            self._values["modify_outgoing_request_header"] = modify_outgoing_request_header
        if modify_outgoing_response_header is not None:
            self._values["modify_outgoing_response_header"] = modify_outgoing_response_header
        if modify_via_header is not None:
            self._values["modify_via_header"] = modify_via_header
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if origin is not None:
            self._values["origin"] = origin
        if origin_characteristics is not None:
            self._values["origin_characteristics"] = origin_characteristics
        if origin_characteristics_wsd is not None:
            self._values["origin_characteristics_wsd"] = origin_characteristics_wsd
        if origin_failure_recovery_method is not None:
            self._values["origin_failure_recovery_method"] = origin_failure_recovery_method
        if origin_failure_recovery_policy is not None:
            self._values["origin_failure_recovery_policy"] = origin_failure_recovery_policy
        if origin_ip_acl is not None:
            self._values["origin_ip_acl"] = origin_ip_acl
        if permissions_policy is not None:
            self._values["permissions_policy"] = permissions_policy
        if persistent_client_connection is not None:
            self._values["persistent_client_connection"] = persistent_client_connection
        if persistent_connection is not None:
            self._values["persistent_connection"] = persistent_connection
        if personally_identifiable_information is not None:
            self._values["personally_identifiable_information"] = personally_identifiable_information
        if phased_release is not None:
            self._values["phased_release"] = phased_release
        if preconnect is not None:
            self._values["preconnect"] = preconnect
        if predictive_content_delivery is not None:
            self._values["predictive_content_delivery"] = predictive_content_delivery
        if predictive_prefetching is not None:
            self._values["predictive_prefetching"] = predictive_prefetching
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if prefetchable is not None:
            self._values["prefetchable"] = prefetchable
        if prefresh_cache is not None:
            self._values["prefresh_cache"] = prefresh_cache
        if quality is not None:
            self._values["quality"] = quality
        if quic_beta is not None:
            self._values["quic_beta"] = quic_beta
        if random_seek is not None:
            self._values["random_seek"] = random_seek
        if rapid is not None:
            self._values["rapid"] = rapid
        if read_timeout is not None:
            self._values["read_timeout"] = read_timeout
        if real_time_reporting is not None:
            self._values["real_time_reporting"] = real_time_reporting
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirectplus is not None:
            self._values["redirectplus"] = redirectplus
        if referer_checking is not None:
            self._values["referer_checking"] = referer_checking
        if remove_query_parameter is not None:
            self._values["remove_query_parameter"] = remove_query_parameter
        if remove_vary is not None:
            self._values["remove_vary"] = remove_vary
        if report is not None:
            self._values["report"] = report
        if request_client_hints is not None:
            self._values["request_client_hints"] = request_client_hints
        if request_control is not None:
            self._values["request_control"] = request_control
        if request_type_marker is not None:
            self._values["request_type_marker"] = request_type_marker
        if resource_optimizer is not None:
            self._values["resource_optimizer"] = resource_optimizer
        if resource_optimizer_extended_compatibility is not None:
            self._values["resource_optimizer_extended_compatibility"] = resource_optimizer_extended_compatibility
        if response_code is not None:
            self._values["response_code"] = response_code
        if response_cookie is not None:
            self._values["response_cookie"] = response_cookie
        if restrict_object_caching is not None:
            self._values["restrict_object_caching"] = restrict_object_caching
        if return_cache_status is not None:
            self._values["return_cache_status"] = return_cache_status
        if rewrite_url is not None:
            self._values["rewrite_url"] = rewrite_url
        if rum_custom is not None:
            self._values["rum_custom"] = rum_custom
        if saas_definitions is not None:
            self._values["saas_definitions"] = saas_definitions
        if sales_force_commerce_cloud_client is not None:
            self._values["sales_force_commerce_cloud_client"] = sales_force_commerce_cloud_client
        if sales_force_commerce_cloud_provider is not None:
            self._values["sales_force_commerce_cloud_provider"] = sales_force_commerce_cloud_provider
        if sales_force_commerce_cloud_provider_host_header is not None:
            self._values["sales_force_commerce_cloud_provider_host_header"] = sales_force_commerce_cloud_provider_host_header
        if save_post_dca_processing is not None:
            self._values["save_post_dca_processing"] = save_post_dca_processing
        if schedule_invalidation is not None:
            self._values["schedule_invalidation"] = schedule_invalidation
        if script_management is not None:
            self._values["script_management"] = script_management
        if segmented_content_protection is not None:
            self._values["segmented_content_protection"] = segmented_content_protection
        if segmented_media_optimization is not None:
            self._values["segmented_media_optimization"] = segmented_media_optimization
        if segmented_media_streaming_prefetch is not None:
            self._values["segmented_media_streaming_prefetch"] = segmented_media_streaming_prefetch
        if set_variable is not None:
            self._values["set_variable"] = set_variable
        if simulate_error_code is not None:
            self._values["simulate_error_code"] = simulate_error_code
        if site_shield is not None:
            self._values["site_shield"] = site_shield
        if standard_tls_migration is not None:
            self._values["standard_tls_migration"] = standard_tls_migration
        if standard_tls_migration_override is not None:
            self._values["standard_tls_migration_override"] = standard_tls_migration_override
        if strict_header_parsing is not None:
            self._values["strict_header_parsing"] = strict_header_parsing
        if sub_customer is not None:
            self._values["sub_customer"] = sub_customer
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if tcp_optimization is not None:
            self._values["tcp_optimization"] = tcp_optimization
        if tea_leaf is not None:
            self._values["tea_leaf"] = tea_leaf
        if tiered_distribution is not None:
            self._values["tiered_distribution"] = tiered_distribution
        if tiered_distribution_advanced is not None:
            self._values["tiered_distribution_advanced"] = tiered_distribution_advanced
        if tiered_distribution_customization is not None:
            self._values["tiered_distribution_customization"] = tiered_distribution_customization
        if timeout is not None:
            self._values["timeout"] = timeout
        if uid_configuration is not None:
            self._values["uid_configuration"] = uid_configuration
        if validate_entity_tag is not None:
            self._values["validate_entity_tag"] = validate_entity_tag
        if verify_json_web_token is not None:
            self._values["verify_json_web_token"] = verify_json_web_token
        if verify_json_web_token_for_dcp is not None:
            self._values["verify_json_web_token_for_dcp"] = verify_json_web_token_for_dcp
        if verify_token_authorization is not None:
            self._values["verify_token_authorization"] = verify_token_authorization
        if virtual_waiting_room is not None:
            self._values["virtual_waiting_room"] = virtual_waiting_room
        if virtual_waiting_room_with_edge_workers is not None:
            self._values["virtual_waiting_room_with_edge_workers"] = virtual_waiting_room_with_edge_workers
        if visitor_prioritization is not None:
            self._values["visitor_prioritization"] = visitor_prioritization
        if visitor_prioritization_fifo is not None:
            self._values["visitor_prioritization_fifo"] = visitor_prioritization_fifo
        if visitor_prioritization_fifo_standalone is not None:
            self._values["visitor_prioritization_fifo_standalone"] = visitor_prioritization_fifo_standalone
        if watermarking is not None:
            self._values["watermarking"] = watermarking
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall
        if webdav is not None:
            self._values["webdav"] = webdav
        if web_sockets is not None:
            self._values["web_sockets"] = web_sockets

    @builtins.property
    def adaptive_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration"]:
        '''adaptive_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_acceleration DataAkamaiPropertyRulesBuilder#adaptive_acceleration}
        '''
        result = self._values.get("adaptive_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration"], result)

    @builtins.property
    def adaptive_image_compression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression"]:
        '''adaptive_image_compression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adaptive_image_compression DataAkamaiPropertyRulesBuilder#adaptive_image_compression}
        '''
        result = self._values.get("adaptive_image_compression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression"], result)

    @builtins.property
    def ad_scaler_circuit_breaker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker"]:
        '''ad_scaler_circuit_breaker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ad_scaler_circuit_breaker DataAkamaiPropertyRulesBuilder#ad_scaler_circuit_breaker}
        '''
        result = self._values.get("ad_scaler_circuit_breaker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker"], result)

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced"]:
        '''advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced"], result)

    @builtins.property
    def aggregated_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting"]:
        '''aggregated_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregated_reporting DataAkamaiPropertyRulesBuilder#aggregated_reporting}
        '''
        result = self._values.get("aggregated_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting"], result)

    @builtins.property
    def akamaizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer"]:
        '''akamaizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer DataAkamaiPropertyRulesBuilder#akamaizer}
        '''
        result = self._values.get("akamaizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer"], result)

    @builtins.property
    def akamaizer_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag"]:
        '''akamaizer_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#akamaizer_tag DataAkamaiPropertyRulesBuilder#akamaizer_tag}
        '''
        result = self._values.get("akamaizer_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag"], result)

    @builtins.property
    def all_http_in_cache_hierarchy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy"]:
        '''all_http_in_cache_hierarchy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_http_in_cache_hierarchy DataAkamaiPropertyRulesBuilder#all_http_in_cache_hierarchy}
        '''
        result = self._values.get("all_http_in_cache_hierarchy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy"], result)

    @builtins.property
    def allow_cloudlets_origins(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins"]:
        '''allow_cloudlets_origins block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cloudlets_origins DataAkamaiPropertyRulesBuilder#allow_cloudlets_origins}
        '''
        result = self._values.get("allow_cloudlets_origins")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins"], result)

    @builtins.property
    def allow_delete(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete"]:
        '''allow_delete block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_delete DataAkamaiPropertyRulesBuilder#allow_delete}
        '''
        result = self._values.get("allow_delete")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete"], result)

    @builtins.property
    def allow_https_cache_key_sharing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing"]:
        '''allow_https_cache_key_sharing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_cache_key_sharing DataAkamaiPropertyRulesBuilder#allow_https_cache_key_sharing}
        '''
        result = self._values.get("allow_https_cache_key_sharing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing"], result)

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade"]:
        '''allow_https_downgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade"], result)

    @builtins.property
    def allow_options(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions"]:
        '''allow_options block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_options DataAkamaiPropertyRulesBuilder#allow_options}
        '''
        result = self._values.get("allow_options")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions"], result)

    @builtins.property
    def allow_patch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch"]:
        '''allow_patch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_patch DataAkamaiPropertyRulesBuilder#allow_patch}
        '''
        result = self._values.get("allow_patch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch"], result)

    @builtins.property
    def allow_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost"]:
        '''allow_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_post DataAkamaiPropertyRulesBuilder#allow_post}
        '''
        result = self._values.get("allow_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost"], result)

    @builtins.property
    def allow_put(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut"]:
        '''allow_put block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_put DataAkamaiPropertyRulesBuilder#allow_put}
        '''
        result = self._values.get("allow_put")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut"], result)

    @builtins.property
    def allow_transfer_encoding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding"]:
        '''allow_transfer_encoding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_transfer_encoding DataAkamaiPropertyRulesBuilder#allow_transfer_encoding}
        '''
        result = self._values.get("allow_transfer_encoding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding"], result)

    @builtins.property
    def alt_svc_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader"]:
        '''alt_svc_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alt_svc_header DataAkamaiPropertyRulesBuilder#alt_svc_header}
        '''
        result = self._values.get("alt_svc_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader"], result)

    @builtins.property
    def api_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization"]:
        '''api_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_prioritization DataAkamaiPropertyRulesBuilder#api_prioritization}
        '''
        result = self._values.get("api_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization"], result)

    @builtins.property
    def application_load_balancer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer"]:
        '''application_load_balancer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_load_balancer DataAkamaiPropertyRulesBuilder#application_load_balancer}
        '''
        result = self._values.get("application_load_balancer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer"], result)

    @builtins.property
    def audience_segmentation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation"]:
        '''audience_segmentation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_segmentation DataAkamaiPropertyRulesBuilder#audience_segmentation}
        '''
        result = self._values.get("audience_segmentation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation"], result)

    @builtins.property
    def auto_domain_validation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation"]:
        '''auto_domain_validation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auto_domain_validation DataAkamaiPropertyRulesBuilder#auto_domain_validation}
        '''
        result = self._values.get("auto_domain_validation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation"], result)

    @builtins.property
    def base_directory(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory"]:
        '''base_directory block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#base_directory DataAkamaiPropertyRulesBuilder#base_directory}
        '''
        result = self._values.get("base_directory")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory"], result)

    @builtins.property
    def boss_beaconing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing"]:
        '''boss_beaconing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boss_beaconing DataAkamaiPropertyRulesBuilder#boss_beaconing}
        '''
        result = self._values.get("boss_beaconing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing"], result)

    @builtins.property
    def breadcrumbs(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs"]:
        '''breadcrumbs block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#breadcrumbs DataAkamaiPropertyRulesBuilder#breadcrumbs}
        '''
        result = self._values.get("breadcrumbs")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs"], result)

    @builtins.property
    def break_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection"]:
        '''break_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#break_connection DataAkamaiPropertyRulesBuilder#break_connection}
        '''
        result = self._values.get("break_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection"], result)

    @builtins.property
    def brotli(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli"]:
        '''brotli block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#brotli DataAkamaiPropertyRulesBuilder#brotli}
        '''
        result = self._values.get("brotli")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli"], result)

    @builtins.property
    def cache_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError"]:
        '''cache_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error DataAkamaiPropertyRulesBuilder#cache_error}
        '''
        result = self._values.get("cache_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError"], result)

    @builtins.property
    def cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId"]:
        '''cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_id DataAkamaiPropertyRulesBuilder#cache_id}
        '''
        result = self._values.get("cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId"], result)

    @builtins.property
    def cache_key_ignore_case(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase"]:
        '''cache_key_ignore_case block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_ignore_case DataAkamaiPropertyRulesBuilder#cache_key_ignore_case}
        '''
        result = self._values.get("cache_key_ignore_case")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase"], result)

    @builtins.property
    def cache_key_query_params(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams"]:
        '''cache_key_query_params block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_query_params DataAkamaiPropertyRulesBuilder#cache_key_query_params}
        '''
        result = self._values.get("cache_key_query_params")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams"], result)

    @builtins.property
    def cache_key_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite"]:
        '''cache_key_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_rewrite DataAkamaiPropertyRulesBuilder#cache_key_rewrite}
        '''
        result = self._values.get("cache_key_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite"], result)

    @builtins.property
    def cache_post(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost"]:
        '''cache_post block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_post DataAkamaiPropertyRulesBuilder#cache_post}
        '''
        result = self._values.get("cache_post")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost"], result)

    @builtins.property
    def cache_redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect"]:
        '''cache_redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_redirect DataAkamaiPropertyRulesBuilder#cache_redirect}
        '''
        result = self._values.get("cache_redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect"], result)

    @builtins.property
    def cache_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag"]:
        '''cache_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag DataAkamaiPropertyRulesBuilder#cache_tag}
        '''
        result = self._values.get("cache_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag"], result)

    @builtins.property
    def cache_tag_visible(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible"]:
        '''cache_tag_visible block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_tag_visible DataAkamaiPropertyRulesBuilder#cache_tag_visible}
        '''
        result = self._values.get("cache_tag_visible")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible"], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching"]:
        '''caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching"], result)

    @builtins.property
    def central_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization"]:
        '''central_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#central_authorization DataAkamaiPropertyRulesBuilder#central_authorization}
        '''
        result = self._values.get("central_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization"], result)

    @builtins.property
    def chase_redirects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects"]:
        '''chase_redirects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#chase_redirects DataAkamaiPropertyRulesBuilder#chase_redirects}
        '''
        result = self._values.get("chase_redirects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects"], result)

    @builtins.property
    def client_certificate_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth"]:
        '''client_certificate_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_auth DataAkamaiPropertyRulesBuilder#client_certificate_auth}
        '''
        result = self._values.get("client_certificate_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth"], result)

    @builtins.property
    def client_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics"]:
        '''client_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_characteristics DataAkamaiPropertyRulesBuilder#client_characteristics}
        '''
        result = self._values.get("client_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics"], result)

    @builtins.property
    def cloud_interconnects(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects"]:
        '''cloud_interconnects block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_interconnects DataAkamaiPropertyRulesBuilder#cloud_interconnects}
        '''
        result = self._values.get("cloud_interconnects")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects"], result)

    @builtins.property
    def cloud_wrapper(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper"]:
        '''cloud_wrapper block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper DataAkamaiPropertyRulesBuilder#cloud_wrapper}
        '''
        result = self._values.get("cloud_wrapper")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper"], result)

    @builtins.property
    def cloud_wrapper_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced"]:
        '''cloud_wrapper_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_wrapper_advanced DataAkamaiPropertyRulesBuilder#cloud_wrapper_advanced}
        '''
        result = self._values.get("cloud_wrapper_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced"], result)

    @builtins.property
    def common_media_client_data(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData"]:
        '''common_media_client_data block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#common_media_client_data DataAkamaiPropertyRulesBuilder#common_media_client_data}
        '''
        result = self._values.get("common_media_client_data")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData"], result)

    @builtins.property
    def conditional_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin"]:
        '''conditional_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_origin DataAkamaiPropertyRulesBuilder#conditional_origin}
        '''
        result = self._values.get("conditional_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin"], result)

    @builtins.property
    def construct_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse"]:
        '''construct_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#construct_response DataAkamaiPropertyRulesBuilder#construct_response}
        '''
        result = self._values.get("construct_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse"], result)

    @builtins.property
    def content_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics"]:
        '''content_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics DataAkamaiPropertyRulesBuilder#content_characteristics}
        '''
        result = self._values.get("content_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics"], result)

    @builtins.property
    def content_characteristics_amd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd"]:
        '''content_characteristics_amd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_amd DataAkamaiPropertyRulesBuilder#content_characteristics_amd}
        '''
        result = self._values.get("content_characteristics_amd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd"], result)

    @builtins.property
    def content_characteristics_dd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd"]:
        '''content_characteristics_dd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_dd DataAkamaiPropertyRulesBuilder#content_characteristics_dd}
        '''
        result = self._values.get("content_characteristics_dd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd"], result)

    @builtins.property
    def content_characteristics_wsd_large_file(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile"]:
        '''content_characteristics_wsd_large_file block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_large_file DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_large_file}
        '''
        result = self._values.get("content_characteristics_wsd_large_file")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile"], result)

    @builtins.property
    def content_characteristics_wsd_live(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive"]:
        '''content_characteristics_wsd_live block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_live DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_live}
        '''
        result = self._values.get("content_characteristics_wsd_live")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive"], result)

    @builtins.property
    def content_characteristics_wsd_vod(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod"]:
        '''content_characteristics_wsd_vod block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_characteristics_wsd_vod DataAkamaiPropertyRulesBuilder#content_characteristics_wsd_vod}
        '''
        result = self._values.get("content_characteristics_wsd_vod")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod"], result)

    @builtins.property
    def content_pre_position(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition"]:
        '''content_pre_position block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_pre_position DataAkamaiPropertyRulesBuilder#content_pre_position}
        '''
        result = self._values.get("content_pre_position")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition"], result)

    @builtins.property
    def content_targeting_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection"]:
        '''content_targeting_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_targeting_protection DataAkamaiPropertyRulesBuilder#content_targeting_protection}
        '''
        result = self._values.get("content_targeting_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection"], result)

    @builtins.property
    def cors_support(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport"]:
        '''cors_support block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cors_support DataAkamaiPropertyRulesBuilder#cors_support}
        '''
        result = self._values.get("cors_support")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport"], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode"], result)

    @builtins.property
    def custom_behavior(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior"]:
        '''custom_behavior block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_behavior DataAkamaiPropertyRulesBuilder#custom_behavior}
        '''
        result = self._values.get("custom_behavior")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior"], result)

    @builtins.property
    def datastream(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream"]:
        '''datastream block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream DataAkamaiPropertyRulesBuilder#datastream}
        '''
        result = self._values.get("datastream")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream"], result)

    @builtins.property
    def dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp"]:
        '''dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp DataAkamaiPropertyRulesBuilder#dcp}
        '''
        result = self._values.get("dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp"], result)

    @builtins.property
    def dcp_auth_hmac_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation"]:
        '''dcp_auth_hmac_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_hmac_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_hmac_transformation}
        '''
        result = self._values.get("dcp_auth_hmac_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation"], result)

    @builtins.property
    def dcp_auth_regex_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation"]:
        '''dcp_auth_regex_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_regex_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_regex_transformation}
        '''
        result = self._values.get("dcp_auth_regex_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation"], result)

    @builtins.property
    def dcp_auth_substring_transformation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation"]:
        '''dcp_auth_substring_transformation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_substring_transformation DataAkamaiPropertyRulesBuilder#dcp_auth_substring_transformation}
        '''
        result = self._values.get("dcp_auth_substring_transformation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation"], result)

    @builtins.property
    def dcp_auth_variable_extractor(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor"]:
        '''dcp_auth_variable_extractor block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_auth_variable_extractor DataAkamaiPropertyRulesBuilder#dcp_auth_variable_extractor}
        '''
        result = self._values.get("dcp_auth_variable_extractor")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor"], result)

    @builtins.property
    def dcp_default_authz_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups"]:
        '''dcp_default_authz_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_default_authz_groups DataAkamaiPropertyRulesBuilder#dcp_default_authz_groups}
        '''
        result = self._values.get("dcp_default_authz_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups"], result)

    @builtins.property
    def dcp_dev_relations(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations"]:
        '''dcp_dev_relations block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_dev_relations DataAkamaiPropertyRulesBuilder#dcp_dev_relations}
        '''
        result = self._values.get("dcp_dev_relations")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations"], result)

    @builtins.property
    def dcp_real_time_auth(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth"]:
        '''dcp_real_time_auth block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_real_time_auth DataAkamaiPropertyRulesBuilder#dcp_real_time_auth}
        '''
        result = self._values.get("dcp_real_time_auth")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth"], result)

    @builtins.property
    def delivery_receipt(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt"]:
        '''delivery_receipt block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_receipt DataAkamaiPropertyRulesBuilder#delivery_receipt}
        '''
        result = self._values.get("delivery_receipt")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt"], result)

    @builtins.property
    def deny_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess"]:
        '''deny_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_access DataAkamaiPropertyRulesBuilder#deny_access}
        '''
        result = self._values.get("deny_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess"], result)

    @builtins.property
    def deny_direct_failover_access(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess"]:
        '''deny_direct_failover_access block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#deny_direct_failover_access DataAkamaiPropertyRulesBuilder#deny_direct_failover_access}
        '''
        result = self._values.get("deny_direct_failover_access")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess"], result)

    @builtins.property
    def device_characteristic_cache_id(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId"]:
        '''device_characteristic_cache_id block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_cache_id DataAkamaiPropertyRulesBuilder#device_characteristic_cache_id}
        '''
        result = self._values.get("device_characteristic_cache_id")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId"], result)

    @builtins.property
    def device_characteristic_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader"]:
        '''device_characteristic_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic_header DataAkamaiPropertyRulesBuilder#device_characteristic_header}
        '''
        result = self._values.get("device_characteristic_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader"], result)

    @builtins.property
    def dns_async_refresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh"]:
        '''dns_async_refresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_async_refresh DataAkamaiPropertyRulesBuilder#dns_async_refresh}
        '''
        result = self._values.get("dns_async_refresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh"], result)

    @builtins.property
    def dns_prefresh(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh"]:
        '''dns_prefresh block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dns_prefresh DataAkamaiPropertyRulesBuilder#dns_prefresh}
        '''
        result = self._values.get("dns_prefresh")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh"], result)

    @builtins.property
    def downgrade_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol"]:
        '''downgrade_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downgrade_protocol DataAkamaiPropertyRulesBuilder#downgrade_protocol}
        '''
        result = self._values.get("downgrade_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol"], result)

    @builtins.property
    def download_complete_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker"]:
        '''download_complete_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_complete_marker DataAkamaiPropertyRulesBuilder#download_complete_marker}
        '''
        result = self._values.get("download_complete_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker"], result)

    @builtins.property
    def download_notification(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification"]:
        '''download_notification block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_notification DataAkamaiPropertyRulesBuilder#download_notification}
        '''
        result = self._values.get("download_notification")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification"], result)

    @builtins.property
    def downstream_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache"]:
        '''downstream_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#downstream_cache DataAkamaiPropertyRulesBuilder#downstream_cache}
        '''
        result = self._values.get("downstream_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache"], result)

    @builtins.property
    def dynamic_throughtput_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization"]:
        '''dynamic_throughtput_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization}
        '''
        result = self._values.get("dynamic_throughtput_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization"], result)

    @builtins.property
    def dynamic_throughtput_optimization_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride"]:
        '''dynamic_throughtput_optimization_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_throughtput_optimization_override DataAkamaiPropertyRulesBuilder#dynamic_throughtput_optimization_override}
        '''
        result = self._values.get("dynamic_throughtput_optimization_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride"], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent"]:
        '''dynamic_web_content block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent"], result)

    @builtins.property
    def ecms_bulk_upload(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload"]:
        '''ecms_bulk_upload block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_bulk_upload DataAkamaiPropertyRulesBuilder#ecms_bulk_upload}
        '''
        result = self._values.get("ecms_bulk_upload")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload"], result)

    @builtins.property
    def ecms_database(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase"]:
        '''ecms_database block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_database DataAkamaiPropertyRulesBuilder#ecms_database}
        '''
        result = self._values.get("ecms_database")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase"], result)

    @builtins.property
    def ecms_dataset(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset"]:
        '''ecms_dataset block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_dataset DataAkamaiPropertyRulesBuilder#ecms_dataset}
        '''
        result = self._values.get("ecms_dataset")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset"], result)

    @builtins.property
    def ecms_object_key(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey"]:
        '''ecms_object_key block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecms_object_key DataAkamaiPropertyRulesBuilder#ecms_object_key}
        '''
        result = self._values.get("ecms_object_key")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey"], result)

    @builtins.property
    def edge_connect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect"]:
        '''edge_connect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_connect DataAkamaiPropertyRulesBuilder#edge_connect}
        '''
        result = self._values.get("edge_connect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect"], result)

    @builtins.property
    def edge_load_balancing_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced"]:
        '''edge_load_balancing_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_advanced DataAkamaiPropertyRulesBuilder#edge_load_balancing_advanced}
        '''
        result = self._values.get("edge_load_balancing_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced"], result)

    @builtins.property
    def edge_load_balancing_data_center(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter"]:
        '''edge_load_balancing_data_center block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_data_center DataAkamaiPropertyRulesBuilder#edge_load_balancing_data_center}
        '''
        result = self._values.get("edge_load_balancing_data_center")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter"], result)

    @builtins.property
    def edge_load_balancing_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin"]:
        '''edge_load_balancing_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_load_balancing_origin DataAkamaiPropertyRulesBuilder#edge_load_balancing_origin}
        '''
        result = self._values.get("edge_load_balancing_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin"], result)

    @builtins.property
    def edge_origin_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization"]:
        '''edge_origin_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_origin_authorization DataAkamaiPropertyRulesBuilder#edge_origin_authorization}
        '''
        result = self._values.get("edge_origin_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization"], result)

    @builtins.property
    def edge_redirector(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector"]:
        '''edge_redirector block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_redirector DataAkamaiPropertyRulesBuilder#edge_redirector}
        '''
        result = self._values.get("edge_redirector")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector"], result)

    @builtins.property
    def edge_scape(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape"]:
        '''edge_scape block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_scape DataAkamaiPropertyRulesBuilder#edge_scape}
        '''
        result = self._values.get("edge_scape")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape"], result)

    @builtins.property
    def edge_side_includes(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes"]:
        '''edge_side_includes block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_side_includes DataAkamaiPropertyRulesBuilder#edge_side_includes}
        '''
        result = self._values.get("edge_side_includes")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes"], result)

    @builtins.property
    def edge_worker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker"]:
        '''edge_worker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker DataAkamaiPropertyRulesBuilder#edge_worker}
        '''
        result = self._values.get("edge_worker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker"], result)

    @builtins.property
    def enforce_mtls_settings(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings"]:
        '''enforce_mtls_settings block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls_settings DataAkamaiPropertyRulesBuilder#enforce_mtls_settings}
        '''
        result = self._values.get("enforce_mtls_settings")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings"], result)

    @builtins.property
    def enhanced_akamai_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol"]:
        '''enhanced_akamai_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_akamai_protocol DataAkamaiPropertyRulesBuilder#enhanced_akamai_protocol}
        '''
        result = self._values.get("enhanced_akamai_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol"], result)

    @builtins.property
    def enhanced_proxy_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection"]:
        '''enhanced_proxy_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_proxy_detection DataAkamaiPropertyRulesBuilder#enhanced_proxy_detection}
        '''
        result = self._values.get("enhanced_proxy_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection"], result)

    @builtins.property
    def epd_forward_header_enrichment(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment"]:
        '''epd_forward_header_enrichment block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#epd_forward_header_enrichment DataAkamaiPropertyRulesBuilder#epd_forward_header_enrichment}
        '''
        result = self._values.get("epd_forward_header_enrichment")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment"], result)

    @builtins.property
    def fail_action(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction"]:
        '''fail_action block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fail_action DataAkamaiPropertyRulesBuilder#fail_action}
        '''
        result = self._values.get("fail_action")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction"], result)

    @builtins.property
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility"]:
        '''failover_bot_manager_feature_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_bot_manager_feature_compatibility DataAkamaiPropertyRulesBuilder#failover_bot_manager_feature_compatibility}
        '''
        result = self._values.get("failover_bot_manager_feature_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility"], result)

    @builtins.property
    def fast_invalidate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate"]:
        '''fast_invalidate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fast_invalidate DataAkamaiPropertyRulesBuilder#fast_invalidate}
        '''
        result = self._values.get("fast_invalidate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate"], result)

    @builtins.property
    def fips(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips"]:
        '''fips block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fips DataAkamaiPropertyRulesBuilder#fips}
        '''
        result = self._values.get("fips")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips"], result)

    @builtins.property
    def first_party_marketing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing"]:
        '''first_party_marketing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing DataAkamaiPropertyRulesBuilder#first_party_marketing}
        '''
        result = self._values.get("first_party_marketing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing"], result)

    @builtins.property
    def first_party_marketing_plus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus"]:
        '''first_party_marketing_plus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_party_marketing_plus DataAkamaiPropertyRulesBuilder#first_party_marketing_plus}
        '''
        result = self._values.get("first_party_marketing_plus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus"], result)

    @builtins.property
    def forward_rewrite(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite"]:
        '''forward_rewrite block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_rewrite DataAkamaiPropertyRulesBuilder#forward_rewrite}
        '''
        result = self._values.get("forward_rewrite")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite"], result)

    @builtins.property
    def g2_oheader(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader"]:
        '''g2oheader block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2oheader DataAkamaiPropertyRulesBuilder#g2oheader}
        '''
        result = self._values.get("g2_oheader")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader"], result)

    @builtins.property
    def global_request_number(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber"]:
        '''global_request_number block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_request_number DataAkamaiPropertyRulesBuilder#global_request_number}
        '''
        result = self._values.get("global_request_number")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber"], result)

    @builtins.property
    def graphql_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching"]:
        '''graphql_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#graphql_caching DataAkamaiPropertyRulesBuilder#graphql_caching}
        '''
        result = self._values.get("graphql_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching"], result)

    @builtins.property
    def gzip_response(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse"]:
        '''gzip_response block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gzip_response DataAkamaiPropertyRulesBuilder#gzip_response}
        '''
        result = self._values.get("gzip_response")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse"], result)

    @builtins.property
    def hd_data_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced"]:
        '''hd_data_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hd_data_advanced DataAkamaiPropertyRulesBuilder#hd_data_advanced}
        '''
        result = self._values.get("hd_data_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced"], result)

    @builtins.property
    def health_detection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection"]:
        '''health_detection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#health_detection DataAkamaiPropertyRulesBuilder#health_detection}
        '''
        result = self._values.get("health_detection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection"], result)

    @builtins.property
    def hsaf_eip_binding(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding"]:
        '''hsaf_eip_binding block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hsaf_eip_binding DataAkamaiPropertyRulesBuilder#hsaf_eip_binding}
        '''
        result = self._values.get("hsaf_eip_binding")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding"], result)

    @builtins.property
    def http2(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2"]:
        '''http2 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http2 DataAkamaiPropertyRulesBuilder#http2}
        '''
        result = self._values.get("http2")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2"], result)

    @builtins.property
    def http3(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3"]:
        '''http3 block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http3 DataAkamaiPropertyRulesBuilder#http3}
        '''
        result = self._values.get("http3")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3"], result)

    @builtins.property
    def http_strict_transport_security(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity"]:
        '''http_strict_transport_security block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_strict_transport_security DataAkamaiPropertyRulesBuilder#http_strict_transport_security}
        '''
        result = self._values.get("http_strict_transport_security")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity"], result)

    @builtins.property
    def http_to_https_upgrade(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade"]:
        '''http_to_https_upgrade block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_to_https_upgrade DataAkamaiPropertyRulesBuilder#http_to_https_upgrade}
        '''
        result = self._values.get("http_to_https_upgrade")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade"], result)

    @builtins.property
    def image_and_video_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager"]:
        '''image_and_video_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_and_video_manager DataAkamaiPropertyRulesBuilder#image_and_video_manager}
        '''
        result = self._values.get("image_and_video_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager"], result)

    @builtins.property
    def image_manager(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager"]:
        '''image_manager block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager DataAkamaiPropertyRulesBuilder#image_manager}
        '''
        result = self._values.get("image_manager")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager"], result)

    @builtins.property
    def image_manager_video(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo"]:
        '''image_manager_video block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_manager_video DataAkamaiPropertyRulesBuilder#image_manager_video}
        '''
        result = self._values.get("image_manager_video")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo"], result)

    @builtins.property
    def im_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride"]:
        '''im_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#im_override DataAkamaiPropertyRulesBuilder#im_override}
        '''
        result = self._values.get("im_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride"], result)

    @builtins.property
    def include(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude"]:
        '''include block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include DataAkamaiPropertyRulesBuilder#include}
        '''
        result = self._values.get("include")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude"], result)

    @builtins.property
    def instant(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant"]:
        '''instant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant DataAkamaiPropertyRulesBuilder#instant}
        '''
        result = self._values.get("instant")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant"], result)

    @builtins.property
    def instant_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig"]:
        '''instant_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#instant_config DataAkamaiPropertyRulesBuilder#instant_config}
        '''
        result = self._values.get("instant_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig"], result)

    @builtins.property
    def large_file_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization"]:
        '''large_file_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization DataAkamaiPropertyRulesBuilder#large_file_optimization}
        '''
        result = self._values.get("large_file_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization"], result)

    @builtins.property
    def large_file_optimization_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced"]:
        '''large_file_optimization_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_optimization_advanced DataAkamaiPropertyRulesBuilder#large_file_optimization_advanced}
        '''
        result = self._values.get("large_file_optimization_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced"], result)

    @builtins.property
    def limit_bit_rate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate"]:
        '''limit_bit_rate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_bit_rate DataAkamaiPropertyRulesBuilder#limit_bit_rate}
        '''
        result = self._values.get("limit_bit_rate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate"], result)

    @builtins.property
    def log_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom"]:
        '''log_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom DataAkamaiPropertyRulesBuilder#log_custom}
        '''
        result = self._values.get("log_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom"], result)

    @builtins.property
    def manifest_personalization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization"]:
        '''manifest_personalization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_personalization DataAkamaiPropertyRulesBuilder#manifest_personalization}
        '''
        result = self._values.get("manifest_personalization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization"], result)

    @builtins.property
    def manifest_rerouting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting"]:
        '''manifest_rerouting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manifest_rerouting DataAkamaiPropertyRulesBuilder#manifest_rerouting}
        '''
        result = self._values.get("manifest_rerouting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting"], result)

    @builtins.property
    def manual_server_push(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush"]:
        '''manual_server_push block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#manual_server_push DataAkamaiPropertyRulesBuilder#manual_server_push}
        '''
        result = self._values.get("manual_server_push")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush"], result)

    @builtins.property
    def media_acceleration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration"]:
        '''media_acceleration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration DataAkamaiPropertyRulesBuilder#media_acceleration}
        '''
        result = self._values.get("media_acceleration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration"], result)

    @builtins.property
    def media_acceleration_quic_optout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout"]:
        '''media_acceleration_quic_optout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_acceleration_quic_optout DataAkamaiPropertyRulesBuilder#media_acceleration_quic_optout}
        '''
        result = self._values.get("media_acceleration_quic_optout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout"], result)

    @builtins.property
    def media_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient"]:
        '''media_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_client DataAkamaiPropertyRulesBuilder#media_client}
        '''
        result = self._values.get("media_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient"], result)

    @builtins.property
    def media_file_retrieval_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization"]:
        '''media_file_retrieval_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_file_retrieval_optimization DataAkamaiPropertyRulesBuilder#media_file_retrieval_optimization}
        '''
        result = self._values.get("media_file_retrieval_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization"], result)

    @builtins.property
    def media_origin_failover(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover"]:
        '''media_origin_failover block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_origin_failover DataAkamaiPropertyRulesBuilder#media_origin_failover}
        '''
        result = self._values.get("media_origin_failover")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover"], result)

    @builtins.property
    def metadata_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching"]:
        '''metadata_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_caching DataAkamaiPropertyRulesBuilder#metadata_caching}
        '''
        result = self._values.get("metadata_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching"], result)

    @builtins.property
    def mobile_sdk_performance(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance"]:
        '''mobile_sdk_performance block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_sdk_performance DataAkamaiPropertyRulesBuilder#mobile_sdk_performance}
        '''
        result = self._values.get("mobile_sdk_performance")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance"], result)

    @builtins.property
    def modify_incoming_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader"]:
        '''modify_incoming_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_request_header DataAkamaiPropertyRulesBuilder#modify_incoming_request_header}
        '''
        result = self._values.get("modify_incoming_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader"], result)

    @builtins.property
    def modify_incoming_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader"]:
        '''modify_incoming_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_incoming_response_header DataAkamaiPropertyRulesBuilder#modify_incoming_response_header}
        '''
        result = self._values.get("modify_incoming_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader"], result)

    @builtins.property
    def modify_outgoing_request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader"]:
        '''modify_outgoing_request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_request_header DataAkamaiPropertyRulesBuilder#modify_outgoing_request_header}
        '''
        result = self._values.get("modify_outgoing_request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader"], result)

    @builtins.property
    def modify_outgoing_response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader"]:
        '''modify_outgoing_response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_outgoing_response_header DataAkamaiPropertyRulesBuilder#modify_outgoing_response_header}
        '''
        result = self._values.get("modify_outgoing_response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader"], result)

    @builtins.property
    def modify_via_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader"]:
        '''modify_via_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_via_header DataAkamaiPropertyRulesBuilder#modify_via_header}
        '''
        result = self._values.get("modify_via_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader"], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse"]:
        '''m_pulse block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse"], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin"]:
        '''origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin"], result)

    @builtins.property
    def origin_characteristics(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics"]:
        '''origin_characteristics block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics DataAkamaiPropertyRulesBuilder#origin_characteristics}
        '''
        result = self._values.get("origin_characteristics")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics"], result)

    @builtins.property
    def origin_characteristics_wsd(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd"]:
        '''origin_characteristics_wsd block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_characteristics_wsd DataAkamaiPropertyRulesBuilder#origin_characteristics_wsd}
        '''
        result = self._values.get("origin_characteristics_wsd")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd"], result)

    @builtins.property
    def origin_failure_recovery_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod"]:
        '''origin_failure_recovery_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_method DataAkamaiPropertyRulesBuilder#origin_failure_recovery_method}
        '''
        result = self._values.get("origin_failure_recovery_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod"], result)

    @builtins.property
    def origin_failure_recovery_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy"]:
        '''origin_failure_recovery_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_failure_recovery_policy DataAkamaiPropertyRulesBuilder#origin_failure_recovery_policy}
        '''
        result = self._values.get("origin_failure_recovery_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy"], result)

    @builtins.property
    def origin_ip_acl(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl"]:
        '''origin_ip_acl block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_ip_acl DataAkamaiPropertyRulesBuilder#origin_ip_acl}
        '''
        result = self._values.get("origin_ip_acl")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl"], result)

    @builtins.property
    def permissions_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy"]:
        '''permissions_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy DataAkamaiPropertyRulesBuilder#permissions_policy}
        '''
        result = self._values.get("permissions_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy"], result)

    @builtins.property
    def persistent_client_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection"]:
        '''persistent_client_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_client_connection DataAkamaiPropertyRulesBuilder#persistent_client_connection}
        '''
        result = self._values.get("persistent_client_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection"], result)

    @builtins.property
    def persistent_connection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection"]:
        '''persistent_connection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#persistent_connection DataAkamaiPropertyRulesBuilder#persistent_connection}
        '''
        result = self._values.get("persistent_connection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection"], result)

    @builtins.property
    def personally_identifiable_information(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation"]:
        '''personally_identifiable_information block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#personally_identifiable_information DataAkamaiPropertyRulesBuilder#personally_identifiable_information}
        '''
        result = self._values.get("personally_identifiable_information")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation"], result)

    @builtins.property
    def phased_release(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease"]:
        '''phased_release block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#phased_release DataAkamaiPropertyRulesBuilder#phased_release}
        '''
        result = self._values.get("phased_release")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease"], result)

    @builtins.property
    def preconnect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect"]:
        '''preconnect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnect DataAkamaiPropertyRulesBuilder#preconnect}
        '''
        result = self._values.get("preconnect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect"], result)

    @builtins.property
    def predictive_content_delivery(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery"]:
        '''predictive_content_delivery block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_content_delivery DataAkamaiPropertyRulesBuilder#predictive_content_delivery}
        '''
        result = self._values.get("predictive_content_delivery")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery"], result)

    @builtins.property
    def predictive_prefetching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching"]:
        '''predictive_prefetching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#predictive_prefetching DataAkamaiPropertyRulesBuilder#predictive_prefetching}
        '''
        result = self._values.get("predictive_prefetching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching"], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch"]:
        '''prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch"], result)

    @builtins.property
    def prefetchable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable"]:
        '''prefetchable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetchable DataAkamaiPropertyRulesBuilder#prefetchable}
        '''
        result = self._values.get("prefetchable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable"], result)

    @builtins.property
    def prefresh_cache(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache"]:
        '''prefresh_cache block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefresh_cache DataAkamaiPropertyRulesBuilder#prefresh_cache}
        '''
        result = self._values.get("prefresh_cache")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache"], result)

    @builtins.property
    def quality(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality"]:
        '''quality block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quality DataAkamaiPropertyRulesBuilder#quality}
        '''
        result = self._values.get("quality")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality"], result)

    @builtins.property
    def quic_beta(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta"]:
        '''quic_beta block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_beta DataAkamaiPropertyRulesBuilder#quic_beta}
        '''
        result = self._values.get("quic_beta")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta"], result)

    @builtins.property
    def random_seek(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek"]:
        '''random_seek block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random_seek DataAkamaiPropertyRulesBuilder#random_seek}
        '''
        result = self._values.get("random_seek")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek"], result)

    @builtins.property
    def rapid(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid"]:
        '''rapid block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rapid DataAkamaiPropertyRulesBuilder#rapid}
        '''
        result = self._values.get("rapid")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid"], result)

    @builtins.property
    def read_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout"]:
        '''read_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#read_timeout DataAkamaiPropertyRulesBuilder#read_timeout}
        '''
        result = self._values.get("read_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout"], result)

    @builtins.property
    def real_time_reporting(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting"]:
        '''real_time_reporting block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_time_reporting DataAkamaiPropertyRulesBuilder#real_time_reporting}
        '''
        result = self._values.get("real_time_reporting")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting"], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring"]:
        '''real_user_monitoring block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring"], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect"]:
        '''redirect block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect"], result)

    @builtins.property
    def redirectplus(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus"]:
        '''redirectplus block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirectplus DataAkamaiPropertyRulesBuilder#redirectplus}
        '''
        result = self._values.get("redirectplus")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus"], result)

    @builtins.property
    def referer_checking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking"]:
        '''referer_checking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referer_checking DataAkamaiPropertyRulesBuilder#referer_checking}
        '''
        result = self._values.get("referer_checking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking"], result)

    @builtins.property
    def remove_query_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter"]:
        '''remove_query_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_query_parameter DataAkamaiPropertyRulesBuilder#remove_query_parameter}
        '''
        result = self._values.get("remove_query_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter"], result)

    @builtins.property
    def remove_vary(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary"]:
        '''remove_vary block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#remove_vary DataAkamaiPropertyRulesBuilder#remove_vary}
        '''
        result = self._values.get("remove_vary")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary"], result)

    @builtins.property
    def report(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport"]:
        '''report block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report DataAkamaiPropertyRulesBuilder#report}
        '''
        result = self._values.get("report")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport"], result)

    @builtins.property
    def request_client_hints(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints"]:
        '''request_client_hints block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_client_hints DataAkamaiPropertyRulesBuilder#request_client_hints}
        '''
        result = self._values.get("request_client_hints")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints"], result)

    @builtins.property
    def request_control(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl"]:
        '''request_control block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_control DataAkamaiPropertyRulesBuilder#request_control}
        '''
        result = self._values.get("request_control")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl"], result)

    @builtins.property
    def request_type_marker(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker"]:
        '''request_type_marker block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type_marker DataAkamaiPropertyRulesBuilder#request_type_marker}
        '''
        result = self._values.get("request_type_marker")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker"], result)

    @builtins.property
    def resource_optimizer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer"]:
        '''resource_optimizer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer DataAkamaiPropertyRulesBuilder#resource_optimizer}
        '''
        result = self._values.get("resource_optimizer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer"], result)

    @builtins.property
    def resource_optimizer_extended_compatibility(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility"]:
        '''resource_optimizer_extended_compatibility block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_optimizer_extended_compatibility DataAkamaiPropertyRulesBuilder#resource_optimizer_extended_compatibility}
        '''
        result = self._values.get("resource_optimizer_extended_compatibility")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility"], result)

    @builtins.property
    def response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode"]:
        '''response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode"], result)

    @builtins.property
    def response_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie"]:
        '''response_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_cookie DataAkamaiPropertyRulesBuilder#response_cookie}
        '''
        result = self._values.get("response_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie"], result)

    @builtins.property
    def restrict_object_caching(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching"]:
        '''restrict_object_caching block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#restrict_object_caching DataAkamaiPropertyRulesBuilder#restrict_object_caching}
        '''
        result = self._values.get("restrict_object_caching")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching"], result)

    @builtins.property
    def return_cache_status(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus"]:
        '''return_cache_status block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_cache_status DataAkamaiPropertyRulesBuilder#return_cache_status}
        '''
        result = self._values.get("return_cache_status")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus"], result)

    @builtins.property
    def rewrite_url(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl"]:
        '''rewrite_url block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rewrite_url DataAkamaiPropertyRulesBuilder#rewrite_url}
        '''
        result = self._values.get("rewrite_url")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl"], result)

    @builtins.property
    def rum_custom(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom"]:
        '''rum_custom block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_custom DataAkamaiPropertyRulesBuilder#rum_custom}
        '''
        result = self._values.get("rum_custom")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom"], result)

    @builtins.property
    def saas_definitions(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions"]:
        '''saas_definitions block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_definitions DataAkamaiPropertyRulesBuilder#saas_definitions}
        '''
        result = self._values.get("saas_definitions")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions"], result)

    @builtins.property
    def sales_force_commerce_cloud_client(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient"]:
        '''sales_force_commerce_cloud_client block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_client DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_client}
        '''
        result = self._values.get("sales_force_commerce_cloud_client")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider"]:
        '''sales_force_commerce_cloud_provider block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider"], result)

    @builtins.property
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        '''sales_force_commerce_cloud_provider_host_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sales_force_commerce_cloud_provider_host_header DataAkamaiPropertyRulesBuilder#sales_force_commerce_cloud_provider_host_header}
        '''
        result = self._values.get("sales_force_commerce_cloud_provider_host_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader"], result)

    @builtins.property
    def save_post_dca_processing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing"]:
        '''save_post_dca_processing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#save_post_dca_processing DataAkamaiPropertyRulesBuilder#save_post_dca_processing}
        '''
        result = self._values.get("save_post_dca_processing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing"], result)

    @builtins.property
    def schedule_invalidation(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation"]:
        '''schedule_invalidation block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#schedule_invalidation DataAkamaiPropertyRulesBuilder#schedule_invalidation}
        '''
        result = self._values.get("schedule_invalidation")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation"], result)

    @builtins.property
    def script_management(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement"]:
        '''script_management block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#script_management DataAkamaiPropertyRulesBuilder#script_management}
        '''
        result = self._values.get("script_management")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement"], result)

    @builtins.property
    def segmented_content_protection(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection"]:
        '''segmented_content_protection block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_content_protection DataAkamaiPropertyRulesBuilder#segmented_content_protection}
        '''
        result = self._values.get("segmented_content_protection")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection"], result)

    @builtins.property
    def segmented_media_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization"]:
        '''segmented_media_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_optimization DataAkamaiPropertyRulesBuilder#segmented_media_optimization}
        '''
        result = self._values.get("segmented_media_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization"], result)

    @builtins.property
    def segmented_media_streaming_prefetch(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch"]:
        '''segmented_media_streaming_prefetch block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segmented_media_streaming_prefetch DataAkamaiPropertyRulesBuilder#segmented_media_streaming_prefetch}
        '''
        result = self._values.get("segmented_media_streaming_prefetch")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch"], result)

    @builtins.property
    def set_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable"]:
        '''set_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_variable DataAkamaiPropertyRulesBuilder#set_variable}
        '''
        result = self._values.get("set_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable"], result)

    @builtins.property
    def simulate_error_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode"]:
        '''simulate_error_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#simulate_error_code DataAkamaiPropertyRulesBuilder#simulate_error_code}
        '''
        result = self._values.get("simulate_error_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode"], result)

    @builtins.property
    def site_shield(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield"]:
        '''site_shield block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_shield DataAkamaiPropertyRulesBuilder#site_shield}
        '''
        result = self._values.get("site_shield")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield"], result)

    @builtins.property
    def standard_tls_migration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration"]:
        '''standard_tls_migration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration DataAkamaiPropertyRulesBuilder#standard_tls_migration}
        '''
        result = self._values.get("standard_tls_migration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration"], result)

    @builtins.property
    def standard_tls_migration_override(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride"]:
        '''standard_tls_migration_override block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_tls_migration_override DataAkamaiPropertyRulesBuilder#standard_tls_migration_override}
        '''
        result = self._values.get("standard_tls_migration_override")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride"], result)

    @builtins.property
    def strict_header_parsing(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing"]:
        '''strict_header_parsing block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_header_parsing DataAkamaiPropertyRulesBuilder#strict_header_parsing}
        '''
        result = self._values.get("strict_header_parsing")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing"], result)

    @builtins.property
    def sub_customer(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer"]:
        '''sub_customer block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_customer DataAkamaiPropertyRulesBuilder#sub_customer}
        '''
        result = self._values.get("sub_customer")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer"], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute"]:
        '''sure_route block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute"], result)

    @builtins.property
    def tcp_optimization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization"]:
        '''tcp_optimization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tcp_optimization DataAkamaiPropertyRulesBuilder#tcp_optimization}
        '''
        result = self._values.get("tcp_optimization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization"], result)

    @builtins.property
    def tea_leaf(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf"]:
        '''tea_leaf block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tea_leaf DataAkamaiPropertyRulesBuilder#tea_leaf}
        '''
        result = self._values.get("tea_leaf")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf"], result)

    @builtins.property
    def tiered_distribution(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution"]:
        '''tiered_distribution block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution DataAkamaiPropertyRulesBuilder#tiered_distribution}
        '''
        result = self._values.get("tiered_distribution")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution"], result)

    @builtins.property
    def tiered_distribution_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced"]:
        '''tiered_distribution_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_advanced DataAkamaiPropertyRulesBuilder#tiered_distribution_advanced}
        '''
        result = self._values.get("tiered_distribution_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced"], result)

    @builtins.property
    def tiered_distribution_customization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization"]:
        '''tiered_distribution_customization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_customization DataAkamaiPropertyRulesBuilder#tiered_distribution_customization}
        '''
        result = self._values.get("tiered_distribution_customization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization"], result)

    @builtins.property
    def timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout"]:
        '''timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout"], result)

    @builtins.property
    def uid_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration"]:
        '''uid_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uid_configuration DataAkamaiPropertyRulesBuilder#uid_configuration}
        '''
        result = self._values.get("uid_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration"], result)

    @builtins.property
    def validate_entity_tag(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag"]:
        '''validate_entity_tag block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#validate_entity_tag DataAkamaiPropertyRulesBuilder#validate_entity_tag}
        '''
        result = self._values.get("validate_entity_tag")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag"], result)

    @builtins.property
    def verify_json_web_token(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken"]:
        '''verify_json_web_token block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token DataAkamaiPropertyRulesBuilder#verify_json_web_token}
        '''
        result = self._values.get("verify_json_web_token")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken"], result)

    @builtins.property
    def verify_json_web_token_for_dcp(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp"]:
        '''verify_json_web_token_for_dcp block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_json_web_token_for_dcp DataAkamaiPropertyRulesBuilder#verify_json_web_token_for_dcp}
        '''
        result = self._values.get("verify_json_web_token_for_dcp")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp"], result)

    @builtins.property
    def verify_token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization"]:
        '''verify_token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verify_token_authorization DataAkamaiPropertyRulesBuilder#verify_token_authorization}
        '''
        result = self._values.get("verify_token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization"], result)

    @builtins.property
    def virtual_waiting_room(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom"]:
        '''virtual_waiting_room block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room DataAkamaiPropertyRulesBuilder#virtual_waiting_room}
        '''
        result = self._values.get("virtual_waiting_room")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom"], result)

    @builtins.property
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        '''virtual_waiting_room_with_edge_workers block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_with_edge_workers DataAkamaiPropertyRulesBuilder#virtual_waiting_room_with_edge_workers}
        '''
        result = self._values.get("virtual_waiting_room_with_edge_workers")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers"], result)

    @builtins.property
    def visitor_prioritization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization"]:
        '''visitor_prioritization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization DataAkamaiPropertyRulesBuilder#visitor_prioritization}
        '''
        result = self._values.get("visitor_prioritization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization"], result)

    @builtins.property
    def visitor_prioritization_fifo(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo"]:
        '''visitor_prioritization_fifo block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo}
        '''
        result = self._values.get("visitor_prioritization_fifo")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo"], result)

    @builtins.property
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone"]:
        '''visitor_prioritization_fifo_standalone block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_fifo_standalone DataAkamaiPropertyRulesBuilder#visitor_prioritization_fifo_standalone}
        '''
        result = self._values.get("visitor_prioritization_fifo_standalone")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone"], result)

    @builtins.property
    def watermarking(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking"]:
        '''watermarking block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#watermarking DataAkamaiPropertyRulesBuilder#watermarking}
        '''
        result = self._values.get("watermarking")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking"], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall"]:
        '''web_application_firewall block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall"], result)

    @builtins.property
    def webdav(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav"]:
        '''webdav block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#webdav DataAkamaiPropertyRulesBuilder#webdav}
        '''
        result = self._values.get("webdav")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav"], result)

    @builtins.property
    def web_sockets(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets"]:
        '''web_sockets block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_sockets DataAkamaiPropertyRulesBuilder#web_sockets}
        '''
        result = self._values.get("web_sockets")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109Behavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker",
    jsii_struct_bases=[],
    name_mapping={
        "fallback_action_response_code_based": "fallbackActionResponseCodeBased",
        "locked": "locked",
        "response_code_based": "responseCodeBased",
        "response_codes": "responseCodes",
        "response_delay_based": "responseDelayBased",
        "response_delay_threshold": "responseDelayThreshold",
        "return_error_response_code_based": "returnErrorResponseCodeBased",
        "specify_your_own_response_code_based": "specifyYourOwnResponseCodeBased",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker:
    def __init__(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f02dc0b818f1077d699a40e8a61d6a0f0c171dfc004f5ffa69713f3270f1500)
            check_type(argname="argument fallback_action_response_code_based", value=fallback_action_response_code_based, expected_type=type_hints["fallback_action_response_code_based"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code_based", value=response_code_based, expected_type=type_hints["response_code_based"])
            check_type(argname="argument response_codes", value=response_codes, expected_type=type_hints["response_codes"])
            check_type(argname="argument response_delay_based", value=response_delay_based, expected_type=type_hints["response_delay_based"])
            check_type(argname="argument response_delay_threshold", value=response_delay_threshold, expected_type=type_hints["response_delay_threshold"])
            check_type(argname="argument return_error_response_code_based", value=return_error_response_code_based, expected_type=type_hints["return_error_response_code_based"])
            check_type(argname="argument specify_your_own_response_code_based", value=specify_your_own_response_code_based, expected_type=type_hints["specify_your_own_response_code_based"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if fallback_action_response_code_based is not None:
            self._values["fallback_action_response_code_based"] = fallback_action_response_code_based
        if locked is not None:
            self._values["locked"] = locked
        if response_code_based is not None:
            self._values["response_code_based"] = response_code_based
        if response_codes is not None:
            self._values["response_codes"] = response_codes
        if response_delay_based is not None:
            self._values["response_delay_based"] = response_delay_based
        if response_delay_threshold is not None:
            self._values["response_delay_threshold"] = response_delay_threshold
        if return_error_response_code_based is not None:
            self._values["return_error_response_code_based"] = return_error_response_code_based
        if specify_your_own_response_code_based is not None:
            self._values["specify_your_own_response_code_based"] = specify_your_own_response_code_based
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def fallback_action_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        '''
        result = self._values.get("fallback_action_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the response code from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        '''
        result = self._values.get("response_code_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_codes(self) -> typing.Optional[builtins.str]:
        '''Specifies the codes in the partner's response that trigger the fallback action,  either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        '''
        result = self._values.get("response_codes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_delay_based(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Triggers a fallback action based on the delayed response from the technology partner's server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        '''
        result = self._values.get("response_delay_based")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_delay_threshold(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum response delay that, if exceeded, triggers the fallback action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        '''
        result = self._values.get("response_delay_threshold")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def return_error_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Specifies the error to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        '''
        result = self._values.get("return_error_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_your_own_response_code_based(self) -> typing.Optional[builtins.str]:
        '''Defines a custom error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        '''
        result = self._values.get("specify_your_own_response_code_based")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreakerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreakerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7fe7d4e62c73a152a5b01da35293cab4f025bbd4c53bb968b90f0d24203cd3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFallbackActionResponseCodeBased")
    def reset_fallback_action_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFallbackActionResponseCodeBased", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCodeBased")
    def reset_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodeBased", []))

    @jsii.member(jsii_name="resetResponseCodes")
    def reset_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCodes", []))

    @jsii.member(jsii_name="resetResponseDelayBased")
    def reset_response_delay_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayBased", []))

    @jsii.member(jsii_name="resetResponseDelayThreshold")
    def reset_response_delay_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseDelayThreshold", []))

    @jsii.member(jsii_name="resetReturnErrorResponseCodeBased")
    def reset_return_error_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnErrorResponseCodeBased", []))

    @jsii.member(jsii_name="resetSpecifyYourOwnResponseCodeBased")
    def reset_specify_your_own_response_code_based(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyYourOwnResponseCodeBased", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBasedInput")
    def fallback_action_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fallbackActionResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeBasedInput")
    def response_code_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodesInput")
    def response_codes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayBasedInput")
    def response_delay_based_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "responseDelayBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseDelayThresholdInput")
    def response_delay_threshold_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseDelayThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBasedInput")
    def return_error_response_code_based_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "returnErrorResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBasedInput")
    def specify_your_own_response_code_based_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "specifyYourOwnResponseCodeBasedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="fallbackActionResponseCodeBased")
    def fallback_action_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fallbackActionResponseCodeBased"))

    @fallback_action_response_code_based.setter
    def fallback_action_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2628beb52e6c47a61b377b9a30ae6d82317b9d741f14b2d4e51c91df15eff76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fallbackActionResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e6338a67f7f3bf452f359d40c92fb0b59d31e48acf6b0c0c78a5b29011a94d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodeBased")
    def response_code_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseCodeBased"))

    @response_code_based.setter
    def response_code_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e7904e651b38a89a0744457b31144b3c27f1fe678bd092f2235f571dc17977d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseCodes")
    def response_codes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseCodes"))

    @response_codes.setter
    def response_codes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d9e02ac176326bbe228636c7924c3f164fe14cfc2c8fc751b71b9d26ea28a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayBased")
    def response_delay_based(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "responseDelayBased"))

    @response_delay_based.setter
    def response_delay_based(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf2dd3d48e8c3bd60aaf17b3befdf3eb641f9a5ead6ae2b0561ef2720852c5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayBased", value)

    @builtins.property
    @jsii.member(jsii_name="responseDelayThreshold")
    def response_delay_threshold(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseDelayThreshold"))

    @response_delay_threshold.setter
    def response_delay_threshold(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711b06481e3ea2f173896076c6117cbb0ea61ce3ae76846827c59543e488390a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseDelayThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="returnErrorResponseCodeBased")
    def return_error_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "returnErrorResponseCodeBased"))

    @return_error_response_code_based.setter
    def return_error_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46824708375d022953e8b3c04cd2261cd7d3f051e869ab039bc0e5d6d8e93cfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "returnErrorResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="specifyYourOwnResponseCodeBased")
    def specify_your_own_response_code_based(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "specifyYourOwnResponseCodeBased"))

    @specify_your_own_response_code_based.setter
    def specify_your_own_response_code_based(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888fec4928f6898a1f4c75fc7bba6bb00f99d2a1355dad2676cb6bee9d30dfa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyYourOwnResponseCodeBased", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e61a80139b387b08a75a6c6e7ae0dc1db927c55ad511ed21ee691f317fb50c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c5720b360e6b4c795f9eb11436fa09e0d426b16c9dbbe096fedb2118ad278b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e8f6d5ed8375b7dd238e8e5c8b088481553efea4c361009e0f84a309285a03e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "ab_logic": "abLogic",
        "ab_testing": "abTesting",
        "compression": "compression",
        "cookie_name": "cookieName",
        "enable_brotli_compression": "enableBrotliCompression",
        "enable_for_noncacheable": "enableForNoncacheable",
        "enable_preconnect": "enablePreconnect",
        "enable_push": "enablePush",
        "enable_ro": "enableRo",
        "locked": "locked",
        "preload_enable": "preloadEnable",
        "source": "source",
        "template_uuid": "templateUuid",
        "title_brotli": "titleBrotli",
        "title_http2_server_push": "titleHttp2ServerPush",
        "title_preconnect": "titlePreconnect",
        "title_preload": "titlePreload",
        "title_ro": "titleRo",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration:
    def __init__(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a79ca13454765fb0b31c65a3e70eaf1c51aacca3967addc6d0695b55ada05a)
            check_type(argname="argument ab_logic", value=ab_logic, expected_type=type_hints["ab_logic"])
            check_type(argname="argument ab_testing", value=ab_testing, expected_type=type_hints["ab_testing"])
            check_type(argname="argument compression", value=compression, expected_type=type_hints["compression"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument enable_brotli_compression", value=enable_brotli_compression, expected_type=type_hints["enable_brotli_compression"])
            check_type(argname="argument enable_for_noncacheable", value=enable_for_noncacheable, expected_type=type_hints["enable_for_noncacheable"])
            check_type(argname="argument enable_preconnect", value=enable_preconnect, expected_type=type_hints["enable_preconnect"])
            check_type(argname="argument enable_push", value=enable_push, expected_type=type_hints["enable_push"])
            check_type(argname="argument enable_ro", value=enable_ro, expected_type=type_hints["enable_ro"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preload_enable", value=preload_enable, expected_type=type_hints["preload_enable"])
            check_type(argname="argument source", value=source, expected_type=type_hints["source"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_brotli", value=title_brotli, expected_type=type_hints["title_brotli"])
            check_type(argname="argument title_http2_server_push", value=title_http2_server_push, expected_type=type_hints["title_http2_server_push"])
            check_type(argname="argument title_preconnect", value=title_preconnect, expected_type=type_hints["title_preconnect"])
            check_type(argname="argument title_preload", value=title_preload, expected_type=type_hints["title_preload"])
            check_type(argname="argument title_ro", value=title_ro, expected_type=type_hints["title_ro"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_logic is not None:
            self._values["ab_logic"] = ab_logic
        if ab_testing is not None:
            self._values["ab_testing"] = ab_testing
        if compression is not None:
            self._values["compression"] = compression
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if enable_brotli_compression is not None:
            self._values["enable_brotli_compression"] = enable_brotli_compression
        if enable_for_noncacheable is not None:
            self._values["enable_for_noncacheable"] = enable_for_noncacheable
        if enable_preconnect is not None:
            self._values["enable_preconnect"] = enable_preconnect
        if enable_push is not None:
            self._values["enable_push"] = enable_push
        if enable_ro is not None:
            self._values["enable_ro"] = enable_ro
        if locked is not None:
            self._values["locked"] = locked
        if preload_enable is not None:
            self._values["preload_enable"] = preload_enable
        if source is not None:
            self._values["source"] = source
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_brotli is not None:
            self._values["title_brotli"] = title_brotli
        if title_http2_server_push is not None:
            self._values["title_http2_server_push"] = title_http2_server_push
        if title_preconnect is not None:
            self._values["title_preconnect"] = title_preconnect
        if title_preload is not None:
            self._values["title_preload"] = title_preload
        if title_ro is not None:
            self._values["title_ro"] = title_ro
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def ab_logic(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to use Adaptive Acceleration in an A/B testing environment.

        To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        '''
        result = self._values.get("ab_logic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ab_testing(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        '''
        result = self._values.get("ab_testing")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compression(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        '''
        result = self._values.get("compression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_brotli_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression, converting your origin content to cache on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        '''
        result = self._values.get("enable_brotli_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_for_noncacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Brotli compression to non-cacheable content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        '''
        result = self._values.get("enable_for_noncacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_preconnect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time.

        See ``Automatic Preconnect`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        '''
        result = self._values.get("enable_preconnect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_push(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Recognizes resources like JavaScript, CSS, and images  based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app.

        See ``Automatic Server Push`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        '''
        result = self._values.get("enable_push")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ro(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        '''
        result = self._values.get("enable_ro")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preload_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows browsers to preload necessary fonts before they fetch and process other resources.

        See ``Automatic Font Preload`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        '''
        result = self._values.get("preload_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def source(self) -> typing.Optional[builtins.str]:
        '''The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``.

        The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        '''
        result = self._values.get("source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_brotli(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        '''
        result = self._values.get("title_brotli")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_http2_server_push(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        '''
        result = self._values.get("title_http2_server_push")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preconnect(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        '''
        result = self._values.get("title_preconnect")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_preload(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        '''
        result = self._values.get("title_preload")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_ro(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        '''
        result = self._values.get("title_ro")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c613ad4041e0d663a143fe48019ceeb5a9a0748eaaeed895d5df04bd1d3ea7e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbLogic")
    def reset_ab_logic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbLogic", []))

    @jsii.member(jsii_name="resetAbTesting")
    def reset_ab_testing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbTesting", []))

    @jsii.member(jsii_name="resetCompression")
    def reset_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompression", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetEnableBrotliCompression")
    def reset_enable_brotli_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBrotliCompression", []))

    @jsii.member(jsii_name="resetEnableForNoncacheable")
    def reset_enable_for_noncacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableForNoncacheable", []))

    @jsii.member(jsii_name="resetEnablePreconnect")
    def reset_enable_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePreconnect", []))

    @jsii.member(jsii_name="resetEnablePush")
    def reset_enable_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePush", []))

    @jsii.member(jsii_name="resetEnableRo")
    def reset_enable_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreloadEnable")
    def reset_preload_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreloadEnable", []))

    @jsii.member(jsii_name="resetSource")
    def reset_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSource", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleBrotli")
    def reset_title_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleBrotli", []))

    @jsii.member(jsii_name="resetTitleHttp2ServerPush")
    def reset_title_http2_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleHttp2ServerPush", []))

    @jsii.member(jsii_name="resetTitlePreconnect")
    def reset_title_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreconnect", []))

    @jsii.member(jsii_name="resetTitlePreload")
    def reset_title_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitlePreload", []))

    @jsii.member(jsii_name="resetTitleRo")
    def reset_title_ro(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleRo", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="abLogicInput")
    def ab_logic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abLogicInput"))

    @builtins.property
    @jsii.member(jsii_name="abTestingInput")
    def ab_testing_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abTestingInput"))

    @builtins.property
    @jsii.member(jsii_name="compressionInput")
    def compression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "compressionInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompressionInput")
    def enable_brotli_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBrotliCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheableInput")
    def enable_for_noncacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableForNoncacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePreconnectInput")
    def enable_preconnect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePushInput")
    def enable_push_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enablePushInput"))

    @builtins.property
    @jsii.member(jsii_name="enableRoInput")
    def enable_ro_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadEnableInput")
    def preload_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceInput")
    def source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleBrotliInput")
    def title_brotli_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleBrotliInput"))

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPushInput")
    def title_http2_server_push_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleHttp2ServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreconnectInput")
    def title_preconnect_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="titlePreloadInput")
    def title_preload_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titlePreloadInput"))

    @builtins.property
    @jsii.member(jsii_name="titleRoInput")
    def title_ro_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleRoInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="abLogic")
    def ab_logic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abLogic"))

    @ab_logic.setter
    def ab_logic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd09899a34cdaba2198783ae6a3b1c2bfb976b12d68947ff5e620252f2589c87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abLogic", value)

    @builtins.property
    @jsii.member(jsii_name="abTesting")
    def ab_testing(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abTesting"))

    @ab_testing.setter
    def ab_testing(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__619e376430e6d683e13fc56117a110812cc0eabea21a6e262a734dcceff63215)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abTesting", value)

    @builtins.property
    @jsii.member(jsii_name="compression")
    def compression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "compression"))

    @compression.setter
    def compression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb119ecd03366d1f2eb4e0bd5174e67515d3e21fe3c70533d27fa0dfac17500d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compression", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0a7888c8cf3b86810807349fb1cee7030a97516fde68afc1bc4c7c4d7542150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="enableBrotliCompression")
    def enable_brotli_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBrotliCompression"))

    @enable_brotli_compression.setter
    def enable_brotli_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c313f58a971799744d8efe0633493ef96a68c9240a04fe6d3ee20fa92a92c6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBrotliCompression", value)

    @builtins.property
    @jsii.member(jsii_name="enableForNoncacheable")
    def enable_for_noncacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableForNoncacheable"))

    @enable_for_noncacheable.setter
    def enable_for_noncacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599c3b9901926b2e92bb420578872789d76829b1eb20ea47f4fd54d9f0913846)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableForNoncacheable", value)

    @builtins.property
    @jsii.member(jsii_name="enablePreconnect")
    def enable_preconnect(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePreconnect"))

    @enable_preconnect.setter
    def enable_preconnect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bb4df7c5d73f75b81a135f461e030c3a175236493091eb5697d97461b841b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="enablePush")
    def enable_push(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enablePush"))

    @enable_push.setter
    def enable_push(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e4d4824a8e775f60d949006fc72d973a8fbc0d4a49d3659e79770b227c08add)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePush", value)

    @builtins.property
    @jsii.member(jsii_name="enableRo")
    def enable_ro(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRo"))

    @enable_ro.setter
    def enable_ro(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9236423291c4d362b87e4e253fb45b1777740ae2dea2eae7b65d231a775327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRo", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485ae48d756ed4f29c60a0da2314f7c2b0f9e56353929ddb1e0d6dc3e0301754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preloadEnable")
    def preload_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preloadEnable"))

    @preload_enable.setter
    def preload_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf61867a6897bdb88bced46a1b3be19179a32033d5b4a8f9c5137be0b8fdfe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preloadEnable", value)

    @builtins.property
    @jsii.member(jsii_name="source")
    def source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "source"))

    @source.setter
    def source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85aa67a361bed6c94c66e267d91bfa384d02dffb209441e9299ca20fe8351653)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "source", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3ff300a77a158ece14a5584f37b15c959e740db30b3c5a166bcb02fa18c8c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleBrotli")
    def title_brotli(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleBrotli"))

    @title_brotli.setter
    def title_brotli(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bce92d7b1a717752cf241ea6bcc0d6414dcc731039b4e9f55b44c35f3094fa4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleBrotli", value)

    @builtins.property
    @jsii.member(jsii_name="titleHttp2ServerPush")
    def title_http2_server_push(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleHttp2ServerPush"))

    @title_http2_server_push.setter
    def title_http2_server_push(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631665d8f17cceff7194014932697a7bd7534ed3852f3398fcd103eae663a99b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleHttp2ServerPush", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreconnect")
    def title_preconnect(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreconnect"))

    @title_preconnect.setter
    def title_preconnect(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d223aad9a5e3db532b056362bf8d33a6c5b299a396265fde5539d5898c248cb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreconnect", value)

    @builtins.property
    @jsii.member(jsii_name="titlePreload")
    def title_preload(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titlePreload"))

    @title_preload.setter
    def title_preload(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f7cbbbd6a86cbaf5b0d18d61a4348bb5335af835c9a616d1029e2f65e924b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titlePreload", value)

    @builtins.property
    @jsii.member(jsii_name="titleRo")
    def title_ro(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleRo"))

    @title_ro.setter
    def title_ro(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__931d5c0344bf799a310dbc156a87b83e5a72c2bf5ab515048305b9b51bfa94f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleRo", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9753c881049c11a396a5c7e580d2065580521b40d233c4f0c4d94709dd2459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbb0840cf53fae8fc1c6423495664212050d3514a7dac30b1525234a805fcf63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression",
    jsii_struct_bases=[],
    name_mapping={
        "compress_mobile": "compressMobile",
        "compress_standard": "compressStandard",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier1_mobile_compression_method": "tier1MobileCompressionMethod",
        "tier1_mobile_compression_value": "tier1MobileCompressionValue",
        "tier1_standard_compression_method": "tier1StandardCompressionMethod",
        "tier1_standard_compression_value": "tier1StandardCompressionValue",
        "tier2_mobile_compression_method": "tier2MobileCompressionMethod",
        "tier2_mobile_compression_value": "tier2MobileCompressionValue",
        "tier2_standard_compression_method": "tier2StandardCompressionMethod",
        "tier2_standard_compression_value": "tier2StandardCompressionValue",
        "tier3_mobile_compression_method": "tier3MobileCompressionMethod",
        "tier3_mobile_compression_value": "tier3MobileCompressionValue",
        "tier3_standard_compression_method": "tier3StandardCompressionMethod",
        "tier3_standard_compression_value": "tier3StandardCompressionValue",
        "title_aic_mobile": "titleAicMobile",
        "title_aic_nonmobile": "titleAicNonmobile",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression:
    def __init__(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5882da1f348797bd817fac268a5e0988c74895cd257a1d7bfe08fe089f3c8e6)
            check_type(argname="argument compress_mobile", value=compress_mobile, expected_type=type_hints["compress_mobile"])
            check_type(argname="argument compress_standard", value=compress_standard, expected_type=type_hints["compress_standard"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_mobile_compression_method", value=tier1_mobile_compression_method, expected_type=type_hints["tier1_mobile_compression_method"])
            check_type(argname="argument tier1_mobile_compression_value", value=tier1_mobile_compression_value, expected_type=type_hints["tier1_mobile_compression_value"])
            check_type(argname="argument tier1_standard_compression_method", value=tier1_standard_compression_method, expected_type=type_hints["tier1_standard_compression_method"])
            check_type(argname="argument tier1_standard_compression_value", value=tier1_standard_compression_value, expected_type=type_hints["tier1_standard_compression_value"])
            check_type(argname="argument tier2_mobile_compression_method", value=tier2_mobile_compression_method, expected_type=type_hints["tier2_mobile_compression_method"])
            check_type(argname="argument tier2_mobile_compression_value", value=tier2_mobile_compression_value, expected_type=type_hints["tier2_mobile_compression_value"])
            check_type(argname="argument tier2_standard_compression_method", value=tier2_standard_compression_method, expected_type=type_hints["tier2_standard_compression_method"])
            check_type(argname="argument tier2_standard_compression_value", value=tier2_standard_compression_value, expected_type=type_hints["tier2_standard_compression_value"])
            check_type(argname="argument tier3_mobile_compression_method", value=tier3_mobile_compression_method, expected_type=type_hints["tier3_mobile_compression_method"])
            check_type(argname="argument tier3_mobile_compression_value", value=tier3_mobile_compression_value, expected_type=type_hints["tier3_mobile_compression_value"])
            check_type(argname="argument tier3_standard_compression_method", value=tier3_standard_compression_method, expected_type=type_hints["tier3_standard_compression_method"])
            check_type(argname="argument tier3_standard_compression_value", value=tier3_standard_compression_value, expected_type=type_hints["tier3_standard_compression_value"])
            check_type(argname="argument title_aic_mobile", value=title_aic_mobile, expected_type=type_hints["title_aic_mobile"])
            check_type(argname="argument title_aic_nonmobile", value=title_aic_nonmobile, expected_type=type_hints["title_aic_nonmobile"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compress_mobile is not None:
            self._values["compress_mobile"] = compress_mobile
        if compress_standard is not None:
            self._values["compress_standard"] = compress_standard
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_mobile_compression_method is not None:
            self._values["tier1_mobile_compression_method"] = tier1_mobile_compression_method
        if tier1_mobile_compression_value is not None:
            self._values["tier1_mobile_compression_value"] = tier1_mobile_compression_value
        if tier1_standard_compression_method is not None:
            self._values["tier1_standard_compression_method"] = tier1_standard_compression_method
        if tier1_standard_compression_value is not None:
            self._values["tier1_standard_compression_value"] = tier1_standard_compression_value
        if tier2_mobile_compression_method is not None:
            self._values["tier2_mobile_compression_method"] = tier2_mobile_compression_method
        if tier2_mobile_compression_value is not None:
            self._values["tier2_mobile_compression_value"] = tier2_mobile_compression_value
        if tier2_standard_compression_method is not None:
            self._values["tier2_standard_compression_method"] = tier2_standard_compression_method
        if tier2_standard_compression_value is not None:
            self._values["tier2_standard_compression_value"] = tier2_standard_compression_value
        if tier3_mobile_compression_method is not None:
            self._values["tier3_mobile_compression_method"] = tier3_mobile_compression_method
        if tier3_mobile_compression_value is not None:
            self._values["tier3_mobile_compression_value"] = tier3_mobile_compression_value
        if tier3_standard_compression_method is not None:
            self._values["tier3_standard_compression_method"] = tier3_standard_compression_method
        if tier3_standard_compression_value is not None:
            self._values["tier3_standard_compression_value"] = tier3_standard_compression_value
        if title_aic_mobile is not None:
            self._values["title_aic_mobile"] = title_aic_mobile
        if title_aic_nonmobile is not None:
            self._values["title_aic_nonmobile"] = title_aic_nonmobile
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compress_mobile(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over cellular mobile networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        '''
        result = self._values.get("compress_mobile")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def compress_standard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adapts images served over non-cellular networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        '''
        result = self._values.get("compress_standard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        '''
        result = self._values.get("tier1_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        '''
        result = self._values.get("tier1_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier1_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-1 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        '''
        result = self._values.get("tier1_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        '''
        result = self._values.get("tier1_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        '''
        result = self._values.get("tier2_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        '''
        result = self._values.get("tier2_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier2_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-2 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        '''
        result = self._values.get("tier2_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier2_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        '''
        result = self._values.get("tier2_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_mobile_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 cellular-network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        '''
        result = self._values.get("tier3_mobile_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_mobile_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        '''
        result = self._values.get("tier3_mobile_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def tier3_standard_compression_method(self) -> typing.Optional[builtins.str]:
        '''Specifies tier-3 non-cellular network behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        '''
        result = self._values.get("tier3_standard_compression_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier3_standard_compression_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the compression percentage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        '''
        result = self._values.get("tier3_standard_compression_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def title_aic_mobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        '''
        result = self._values.get("title_aic_mobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_aic_nonmobile(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        '''
        result = self._values.get("title_aic_nonmobile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2986d429097e49555464e4186fb64b51c38f0d0d63db8f4ba7d33b403e66f4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompressMobile")
    def reset_compress_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressMobile", []))

    @jsii.member(jsii_name="resetCompressStandard")
    def reset_compress_standard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompressStandard", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionMethod")
    def reset_tier1_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1MobileCompressionValue")
    def reset_tier1_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionMethod")
    def reset_tier1_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier1StandardCompressionValue")
    def reset_tier1_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionMethod")
    def reset_tier2_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2MobileCompressionValue")
    def reset_tier2_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionMethod")
    def reset_tier2_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier2StandardCompressionValue")
    def reset_tier2_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier2StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionMethod")
    def reset_tier3_mobile_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3MobileCompressionValue")
    def reset_tier3_mobile_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3MobileCompressionValue", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionMethod")
    def reset_tier3_standard_compression_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionMethod", []))

    @jsii.member(jsii_name="resetTier3StandardCompressionValue")
    def reset_tier3_standard_compression_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier3StandardCompressionValue", []))

    @jsii.member(jsii_name="resetTitleAicMobile")
    def reset_title_aic_mobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicMobile", []))

    @jsii.member(jsii_name="resetTitleAicNonmobile")
    def reset_title_aic_nonmobile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleAicNonmobile", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compressMobileInput")
    def compress_mobile_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="compressStandardInput")
    def compress_standard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressStandardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethodInput")
    def tier1_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValueInput")
    def tier1_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethodInput")
    def tier1_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValueInput")
    def tier1_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier1StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethodInput")
    def tier2_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValueInput")
    def tier2_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethodInput")
    def tier2_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier2StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValueInput")
    def tier2_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier2StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethodInput")
    def tier3_mobile_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3MobileCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValueInput")
    def tier3_mobile_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3MobileCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethodInput")
    def tier3_standard_compression_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier3StandardCompressionMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValueInput")
    def tier3_standard_compression_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "tier3StandardCompressionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicMobileInput")
    def title_aic_mobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicMobileInput"))

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobileInput")
    def title_aic_nonmobile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleAicNonmobileInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compressMobile")
    def compress_mobile(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressMobile"))

    @compress_mobile.setter
    def compress_mobile(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c19d1a548d289acf309da19e5b7d3fc31fc3ddb2de58c670cd94ec96cbf7ad79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressMobile", value)

    @builtins.property
    @jsii.member(jsii_name="compressStandard")
    def compress_standard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compressStandard"))

    @compress_standard.setter
    def compress_standard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa112c4302d8a65f09caa54c654eefca677fd268b177303607af6bc32ab06ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compressStandard", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0017ec29eef361c1f345fe1febd99895bea29362a4e6b06e6c56c01b462c4b96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78892529196842169ffaad0b950d813afe6120d27677d8737d25aa0812e5e4d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionMethod")
    def tier1_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1MobileCompressionMethod"))

    @tier1_mobile_compression_method.setter
    def tier1_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37462151cc129d38ef91733e6d4abea069cd30e16bd2274225a638dccd8d3c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1MobileCompressionValue")
    def tier1_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1MobileCompressionValue"))

    @tier1_mobile_compression_value.setter
    def tier1_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff511f3d0ab7a2d3d720992c7fe7afb0e54efd93d1c404c040615020bc2aefa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionMethod")
    def tier1_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1StandardCompressionMethod"))

    @tier1_standard_compression_method.setter
    def tier1_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e72ba4e124a9b6cf37e8c31fd6c45abf211d81405fbe3a33a0880f1c01bec918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier1StandardCompressionValue")
    def tier1_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier1StandardCompressionValue"))

    @tier1_standard_compression_value.setter
    def tier1_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8864430dce8d825197d695299e5b0aca6310a14e6f2be8185827a3398ed67b91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionMethod")
    def tier2_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2MobileCompressionMethod"))

    @tier2_mobile_compression_method.setter
    def tier2_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a61b7ef0c3b4143b02369eb6d9b3fd78a10397bffa73fd4186cb911a82982bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2MobileCompressionValue")
    def tier2_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2MobileCompressionValue"))

    @tier2_mobile_compression_value.setter
    def tier2_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0bef8f6f56d85f0b247dd7d6d9318bd4b163cd68778f0a62e28ab45afabea1b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionMethod")
    def tier2_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier2StandardCompressionMethod"))

    @tier2_standard_compression_method.setter
    def tier2_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__538842108f3e935e40ce34dd10a0588297dbb19e9b4d06ce64c30c5148dabb4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier2StandardCompressionValue")
    def tier2_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier2StandardCompressionValue"))

    @tier2_standard_compression_value.setter
    def tier2_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e74946e959197d64409bd623bfb2ca5ba6c6a55dffa4f6969482b0ac252e9d85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier2StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionMethod")
    def tier3_mobile_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3MobileCompressionMethod"))

    @tier3_mobile_compression_method.setter
    def tier3_mobile_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b234b62ba77adcd08fa939f9ccca510f568ab55c67dcbb2c0dbf39fa62ade571)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3MobileCompressionValue")
    def tier3_mobile_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3MobileCompressionValue"))

    @tier3_mobile_compression_value.setter
    def tier3_mobile_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff8896ee716f5b1efc5b7c54723a68e0610c1d2e54dd7be642aeb280a1ce1ffb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3MobileCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionMethod")
    def tier3_standard_compression_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier3StandardCompressionMethod"))

    @tier3_standard_compression_method.setter
    def tier3_standard_compression_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f4c66e0bf58951b8d5c92f695bd84432042b2a6e51c8689722b373f4f1096c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionMethod", value)

    @builtins.property
    @jsii.member(jsii_name="tier3StandardCompressionValue")
    def tier3_standard_compression_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "tier3StandardCompressionValue"))

    @tier3_standard_compression_value.setter
    def tier3_standard_compression_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76bce91d91f3d3b7303cf4e882ef5efa5dba10eb37415fc2d4890b6970aec0dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier3StandardCompressionValue", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicMobile")
    def title_aic_mobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicMobile"))

    @title_aic_mobile.setter
    def title_aic_mobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5086e6c539b6739fbd7bb1e0c8c8172ee48497c9638d6c0705a5ce1c9df1465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicMobile", value)

    @builtins.property
    @jsii.member(jsii_name="titleAicNonmobile")
    def title_aic_nonmobile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleAicNonmobile"))

    @title_aic_nonmobile.setter
    def title_aic_nonmobile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216a7d5254458377f9fd50c15f8a97d1284b723382e8320bee222d45c7bfa028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleAicNonmobile", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbd1ea043740e3d10df266c747277ba87bae3dd4dc531467e8bf20a2c7aef7e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3daa311cc8be02b6c9ca5402334a5e541cf2dc729300c75ee3f8346498394c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b008e8ce3ab59ac7dce9ef18b131a86d8a27793665f41895a2433a252fa168e)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62230289e1f2278beb9f0744ae75ba7ad44605b5425b72462777d4dd0aed17ac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b707767ec0e12727959dcbca76e0da72a30b41745d5bb231f687956a71fb418)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e8ea744d07ff712f04d832bdd128a676ec2b242f0d953fd588782a341e1126)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b8a8d3fd46af36da628ac2c216f52fab6b81c0c662c43223c470b36c6df89b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21490e16f6102285d4195835184bdef3dd735584c48e7c47d96154198c757f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__260466bb38de9ffe4d216c9e7e83333fdb64ad4768eca076b9e6695077e0c0e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8123da6eff3b72d0b72d682b9c5b02561726dad6ac3236513206cda9232b2676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting",
    jsii_struct_bases=[],
    name_mapping={
        "attribute1": "attribute1",
        "attribute2": "attribute2",
        "attribute3": "attribute3",
        "attribute4": "attribute4",
        "attributes_count": "attributesCount",
        "enabled": "enabled",
        "locked": "locked",
        "report_name": "reportName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting:
    def __init__(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__203936d2ce395d780f33d5bb944780429b1d54c1911da5acb98fcb365413db74)
            check_type(argname="argument attribute1", value=attribute1, expected_type=type_hints["attribute1"])
            check_type(argname="argument attribute2", value=attribute2, expected_type=type_hints["attribute2"])
            check_type(argname="argument attribute3", value=attribute3, expected_type=type_hints["attribute3"])
            check_type(argname="argument attribute4", value=attribute4, expected_type=type_hints["attribute4"])
            check_type(argname="argument attributes_count", value=attributes_count, expected_type=type_hints["attributes_count"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument report_name", value=report_name, expected_type=type_hints["report_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if attribute1 is not None:
            self._values["attribute1"] = attribute1
        if attribute2 is not None:
            self._values["attribute2"] = attribute2
        if attribute3 is not None:
            self._values["attribute3"] = attribute3
        if attribute4 is not None:
            self._values["attribute4"] = attribute4
        if attributes_count is not None:
            self._values["attributes_count"] = attributes_count
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if report_name is not None:
            self._values["report_name"] = report_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def attribute1(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        '''
        result = self._values.get("attribute1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute2(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        '''
        result = self._values.get("attribute2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute3(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        '''
        result = self._values.get("attribute3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attribute4(self) -> typing.Optional[builtins.str]:
        '''Specify a previously user-defined variable name as a report attribute.

        The values extracted for all attributes range from 0 to 20 characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        '''
        result = self._values.get("attribute4")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def attributes_count(self) -> typing.Optional[jsii.Number]:
        '''The number of attributes to include in the report, ranging from 1 to 4.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        '''
        result = self._values.get("attributes_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables aggregated reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def report_name(self) -> typing.Optional[builtins.str]:
        '''The unique name of the aggregated report within the property.

        If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        '''
        result = self._values.get("report_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2eef99868f5ff41ba91713cf29cd8a14229695e6f5f80e3409e895e18cfb2ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAttribute1")
    def reset_attribute1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute1", []))

    @jsii.member(jsii_name="resetAttribute2")
    def reset_attribute2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute2", []))

    @jsii.member(jsii_name="resetAttribute3")
    def reset_attribute3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute3", []))

    @jsii.member(jsii_name="resetAttribute4")
    def reset_attribute4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttribute4", []))

    @jsii.member(jsii_name="resetAttributesCount")
    def reset_attributes_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAttributesCount", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReportName")
    def reset_report_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReportName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="attribute1Input")
    def attribute1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute1Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute2Input")
    def attribute2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute2Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute3Input")
    def attribute3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute3Input"))

    @builtins.property
    @jsii.member(jsii_name="attribute4Input")
    def attribute4_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "attribute4Input"))

    @builtins.property
    @jsii.member(jsii_name="attributesCountInput")
    def attributes_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "attributesCountInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reportNameInput")
    def report_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reportNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="attribute1")
    def attribute1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute1"))

    @attribute1.setter
    def attribute1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b38cfb5b75207fb6ddbb2812aeb9ccb80cfc9be410f7b4d8f9d9e06f1f3a20f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute1", value)

    @builtins.property
    @jsii.member(jsii_name="attribute2")
    def attribute2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute2"))

    @attribute2.setter
    def attribute2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09a09e63854f3b213dbb91808f9354faa535993954539230472253f0ce173a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute2", value)

    @builtins.property
    @jsii.member(jsii_name="attribute3")
    def attribute3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute3"))

    @attribute3.setter
    def attribute3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3cc6d59ba37a03f8c7e2ab6e8a5602fabeaeb9b7ce16270b3d672e2026912b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute3", value)

    @builtins.property
    @jsii.member(jsii_name="attribute4")
    def attribute4(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "attribute4"))

    @attribute4.setter
    def attribute4(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c489e133e78bfc14baa6117c0c8765b81c940727cc483ea1828fa80d2f182fcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attribute4", value)

    @builtins.property
    @jsii.member(jsii_name="attributesCount")
    def attributes_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "attributesCount"))

    @attributes_count.setter
    def attributes_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30c67562846afd94b975b8651a716b827f71b6fde8e10bca7c50a93648a54038)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "attributesCount", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d5504b9a121ada2d14acaf593c4eb44d7b3b7160b7fc65275c7e5cbe2fd1618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bb9dafb0a82c6aa0857b09c7a491ff9901b2395ce310f8944c4e0d11110c7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reportName")
    def report_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reportName"))

    @report_name.setter
    def report_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3f52c21ef9d5c64bb12fd486b2b8c640ea40fb5c0e56fbcaa6857123425fa17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reportName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e58a4dd9141da0d551eb73642fde662e10a5ea5b1f01fb1983641744907bb99c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cea3a603740b2a928c590fa5736910d9655fec72e88b935c51cfb830fdff737b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb96d481238c0ed7a2353837d5de4d3e764aaacd4b98d9a21f2536343db7dcab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b1254fe6d4bf98e06d7ba89462d8125afe44929267a16812c53d44df79152b4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamaizer behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c48aa7c0c57674dd382b2daa8529fe0a2d651332fd32fcb78b7c09e6b9ead3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd4f716fae178261102d8912235d546bb79d9487abc63e7fc9a8e50e8f34ad31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6823d8cd8a0b073a6a35a617a79f2c8a86275b076b915b71dc0bc8283fc39e86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__735a19a2ce9e030dd048f136071f1998c375ceef67d9c987b9549ab5f1960bba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c800ae3cada457612816cdbabf540a9620d42607afc43615df826820118adaee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d74e5bfa9fe7258312eac1d217d3c50602caa7664562e17f5b92a8f5af0e487a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag",
    jsii_struct_bases=[],
    name_mapping={
        "include_tags_attribute": "includeTagsAttribute",
        "locked": "locked",
        "match_hostname": "matchHostname",
        "replace_all": "replaceAll",
        "replacement_hostname": "replacementHostname",
        "scope": "scope",
        "tags_attribute": "tagsAttribute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag:
    def __init__(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b197cde6b5beb04dba4f4a17213fce85dcd8a3fc1177959b8725effe596a11ea)
            check_type(argname="argument include_tags_attribute", value=include_tags_attribute, expected_type=type_hints["include_tags_attribute"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_hostname", value=match_hostname, expected_type=type_hints["match_hostname"])
            check_type(argname="argument replace_all", value=replace_all, expected_type=type_hints["replace_all"])
            check_type(argname="argument replacement_hostname", value=replacement_hostname, expected_type=type_hints["replacement_hostname"])
            check_type(argname="argument scope", value=scope, expected_type=type_hints["scope"])
            check_type(argname="argument tags_attribute", value=tags_attribute, expected_type=type_hints["tags_attribute"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if include_tags_attribute is not None:
            self._values["include_tags_attribute"] = include_tags_attribute
        if locked is not None:
            self._values["locked"] = locked
        if match_hostname is not None:
            self._values["match_hostname"] = match_hostname
        if replace_all is not None:
            self._values["replace_all"] = replace_all
        if replacement_hostname is not None:
            self._values["replacement_hostname"] = replacement_hostname
        if scope is not None:
            self._values["scope"] = scope
        if tags_attribute is not None:
            self._values["tags_attribute"] = tags_attribute
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def include_tags_attribute(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the ``tagsAttribute`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        '''
        result = self._values.get("include_tags_attribute")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to match on as a Perl-compatible regular expression.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        '''
        result = self._values.get("match_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replace_all(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches when enabled, otherwise replaces only the first match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        '''
        result = self._values.get("replace_all")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def replacement_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement hostname for the tag to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        '''
        result = self._values.get("replacement_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def scope(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of HTML content the ``tagsAttribute`` refers to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        '''
        result = self._values.get("scope")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tags_attribute(self) -> typing.Optional[builtins.str]:
        '''Specifies the tag or tag/attribute combination to operate on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        '''
        result = self._values.get("tags_attribute")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c306a1c6a27034c7e561991b9b1a72f6a2ae0efbf6595611d7167795cad05fb1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetIncludeTagsAttribute")
    def reset_include_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeTagsAttribute", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchHostname")
    def reset_match_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchHostname", []))

    @jsii.member(jsii_name="resetReplaceAll")
    def reset_replace_all(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplaceAll", []))

    @jsii.member(jsii_name="resetReplacementHostname")
    def reset_replacement_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacementHostname", []))

    @jsii.member(jsii_name="resetScope")
    def reset_scope(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScope", []))

    @jsii.member(jsii_name="resetTagsAttribute")
    def reset_tags_attribute(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTagsAttribute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttributeInput")
    def include_tags_attribute_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeTagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchHostnameInput")
    def match_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="replaceAllInput")
    def replace_all_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "replaceAllInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementHostnameInput")
    def replacement_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="scopeInput")
    def scope_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "scopeInput"))

    @builtins.property
    @jsii.member(jsii_name="tagsAttributeInput")
    def tags_attribute_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagsAttributeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="includeTagsAttribute")
    def include_tags_attribute(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeTagsAttribute"))

    @include_tags_attribute.setter
    def include_tags_attribute(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83f1c10159363c02b82792d44c15f866899afcd9a46dc9d2cacda0457f9b7cae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeTagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b91b29344527851b7e60d401093baa22c2a78cde62f5e5b5ef955ef62efd1224)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchHostname")
    def match_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchHostname"))

    @match_hostname.setter
    def match_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d2f526e6f1cfb8a629e782d74cc0e3dd0daa11ea4fe443c8d0fb409860fd41f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchHostname", value)

    @builtins.property
    @jsii.member(jsii_name="replaceAll")
    def replace_all(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "replaceAll"))

    @replace_all.setter
    def replace_all(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9584ba5953f530f2946382ac35dd72179ef1b59595c272b4724dfc099528ce78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replaceAll", value)

    @builtins.property
    @jsii.member(jsii_name="replacementHostname")
    def replacement_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacementHostname"))

    @replacement_hostname.setter
    def replacement_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e260b86857e607aaabab8b9bdcac01918b9f57d680934da1ce7dea56dc279e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacementHostname", value)

    @builtins.property
    @jsii.member(jsii_name="scope")
    def scope(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "scope"))

    @scope.setter
    def scope(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__002d8f2375288a7c2b3f18e31af2188a4c44567347068364bc3d94dbfcba1f16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "scope", value)

    @builtins.property
    @jsii.member(jsii_name="tagsAttribute")
    def tags_attribute(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tagsAttribute"))

    @tags_attribute.setter
    def tags_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1932f0290b85156698aa73fcb61eebd25a6ae09cd733966753b8b0ed5ccc78a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tagsAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37fc0d2e5babd5c1ed2d5d7a1985c0788bd4f6db727f8996ce2cc80230b11053)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c3b85d1fa98c9f36532b8f38e383050d9fd159927375fd6d0fc812bd5da3d3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1789b7f253811b14ca33edb7df5fba51c045591aae6971a09dcd5501d604e54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7cd4ea5cb327373372877b17f62fe9d6d6e02b8ff2ad437d7bbdfc045789c1)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables all HTTP requests for parent servers in the cache hierarchy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__856a1f128de8d8409cb2d31840f6a216c36998f80df235f0ba01214214f50795)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd15510d82857f1ea261631390a26d490f97ee7ef5ad7116cb98ede482a38574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60f424c480d568840084f7ba109101ac534bd337067bc31b07053997bfff99c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f74d51c4cfe75c14cdd8e3653866d30f6d3cea763fe25411d15dde5f6f81778b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4960229e07cddb087a599d9fe9609179d10a10d16437c28ebfe0f91cd657501)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6224e1d4444630f7619612e8560f0c870fbc800bf3060083f04b2516dc0c6f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "honor_base_directory": "honorBaseDirectory",
        "locked": "locked",
        "purge_origin_query_parameter": "purgeOriginQueryParameter",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ceb6f9f7baa4b8cd5dca4173b0edb7af9cbd492481eb60155c41baf2d7ca516)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument honor_base_directory", value=honor_base_directory, expected_type=type_hints["honor_base_directory"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_origin_query_parameter", value=purge_origin_query_parameter, expected_type=type_hints["purge_origin_query_parameter"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if honor_base_directory is not None:
            self._values["honor_base_directory"] = honor_base_directory
        if locked is not None:
            self._values["locked"] = locked
        if purge_origin_query_parameter is not None:
            self._values["purge_origin_query_parameter"] = purge_origin_query_parameter
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_base_directory(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior.

        If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        '''
        result = self._values.get("honor_base_directory")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_origin_query_parameter(self) -> typing.Optional[builtins.str]:
        '''When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge.

        Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        '''
        result = self._values.get("purge_origin_query_parameter")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOriginsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOriginsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3182fd7c328410f6513b32f73cc075ca586032037c163d6b28e8cff858ed4774)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHonorBaseDirectory")
    def reset_honor_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorBaseDirectory", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeOriginQueryParameter")
    def reset_purge_origin_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeOriginQueryParameter", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectoryInput")
    def honor_base_directory_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorBaseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameterInput")
    def purge_origin_query_parameter_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeOriginQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4896e297dfd97ec076a001cf418f495d987a947ccfdf6860f14c5b5f3bcd0a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="honorBaseDirectory")
    def honor_base_directory(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorBaseDirectory"))

    @honor_base_directory.setter
    def honor_base_directory(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84e884fcd634cf60d5089a7eeed0966962b69e0cf11c1e790f8b69fbf94b4c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorBaseDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72e052de12687397a4e7cddafae74baf23edac59141d943c2e5bdba268c0ee43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeOriginQueryParameter")
    def purge_origin_query_parameter(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeOriginQueryParameter"))

    @purge_origin_query_parameter.setter
    def purge_origin_query_parameter(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09e32adc04a639d74d35c5e2b6e1e8f1d6f25d7ac6894c852952e8f29f29b77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeOriginQueryParameter", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbedb300c74fb423e9216e5b4fe5e8f64fef2af5b8195bd9b4d32fa2de6b87c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49297502ccb03c09142f13c316f3bd1fe14ba32c46cd344a8e79f19745054197)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ea2fa64a79e967b7af69c09768540b322cd9e92018299d1f4f074249a9701b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete",
    jsii_struct_bases=[],
    name_mapping={
        "allow_body": "allowBody",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete:
    def __init__(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf80c755a78ba015a337ece9f51276ed6f82b98f2648c37dd596121a2fbfceae)
            check_type(argname="argument allow_body", value=allow_body, expected_type=type_hints["allow_body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_body is not None:
            self._values["allow_body"] = allow_body
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_body(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows data in the body of the DELETE request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        '''
        result = self._values.get("allow_body")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows DELETE requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDeleteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDeleteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69d3608beffcf71ee9c6b52a73d3a6bc46d9486c130f9e57a133729dcfab90eb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBody")
    def reset_allow_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBodyInput")
    def allow_body_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBody")
    def allow_body(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowBody"))

    @allow_body.setter
    def allow_body(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec7416657e41e1534d0035ec102402a0eacc4061386e801fda505ad9ce27839)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBody", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85bd243ea90dc7c212aaa196e51c619d4a2504cfb82a992c248ec2a2f573f7eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8fec9ca71ff6fe5c39d552ad39db255fe095d55f071ba43d3c39d2d717d5f7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aed2b2a0a1110f332916f6120df2c80044d4ba7fa8681009e1e4645ec40fe08c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2d68004a1a3449c0f1be8bb4d8107b944bcdd18a972dafd2fa33aaf63d30924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6d9ca99e385bd0bef501a5fd0030431188f96fe8422a358babdc40752102998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b6e8812da9229e605c109c09b1c8b0b0285df12836a5566f4a6bad944348b1d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HTTPS cache key sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc22b911546f5ecb6a132cc3b60c1775e9b99eacf8c7eea092ae2915d28524f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c79df386ae92c2274463ca1dd2050cfda5f632748e4ce203a503b27f01e8ce4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a0b8708c99eee8bf0887ef60568e0f08e9e98700a77a7a82ff1c7ef3452a18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d31beb79e05d8bef0617da1ab78813d81b85d5070b795d4c0c89cb478eb4fa14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5206158e08aec02a6409f8ad7765b5fc526fa04609d5f1b0a3b4265524908436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ba40517712bcc6884bde18f9e3db2f4ba7916f74725d8d3912313579dee3b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1475955850e66a2678a55c5878c799614fb8780dcdb423dc475427a4c52e37fa)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Downgrades to HTTP protocol for the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90807a2c5859eeacecf2f7b8fba7930406ce41b4d7f386c950bbd756ad348f58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bff480f700ead828a5a1bb984037cb450aeb24942c32d538393655ac4569b5b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bce4c8b605756cdf8c7bdb3fd992e7e68bdb366d8ea03561cf2d58bcef01c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ae7cbe25fb1913ffd3e030e710d2e962002b569308bcf1d6a33f6d2da7f7800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4096b97cf29774582137e76cfcd3ff72456eb63cd845c524cfa780fb647e6f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4e0d74d4e70119266164fa8c26d4aa5134768f95a486f042cb386232772ef3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d0e34f821d7dd3a5c7cf0b5e400725deabee1f0df70df783110f2289387269)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response.

        Set this to ``false`` to deny OPTIONS requests and respond with a 501 error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__201e93715cf7bf9c03c399e9fa93a649bc7dcfad3dc231e65748cf0d371b1812)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e54239c0f580c10d433a78f87e26704de1878b170b0dc44e1a05550d68d6b63a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb8ef6e109c579f5e780ace6ca309f5507606e23e0854e4b75b3b9b244207ed8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8951d8ad173d486a85461f4c2c55099af67c444394f65e39905fabe972fa1ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76ec3b7eff124d06769daf589505d2e12f84fabb1c4ec033817e31bca0716bbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af00325156907cc83673849e222e16f2a83550c5bc8bee6d809579faefcb1b6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43d55badedc0a00ec655f7a84d8d24e65aa1214c886aa1e713e8bb57f8055c24)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PATCH requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__010b6b921e5c8bb381a49b005a0094a15ea16f16ccbd8983aab8ec5a7bd28276)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01313aa627e06d99982287ee5e7b67b88de8fd752087b8dfacf80636426a3596)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b9e90c9c147a18f4f1a8ac199c5a8074890751c22d7fc4ee7e22f60c45ed726)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6a656a5604c3fc6babee03afa6c5cd2a86cbe92b2cb41d35fc5e1ba3b22936e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b51280c0a1c223a2bb55933855f100c0e58365a9a678b75b0351fe7b3e9367)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58ec1681baec324a910182adf2f6a28bdec56f67fd79c07611475fffb930f33e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost",
    jsii_struct_bases=[],
    name_mapping={
        "allow_without_content_length": "allowWithoutContentLength",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost:
    def __init__(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a770997a3cb99b6eb547de4f54f999c6ad25c2726ae9ee013aad61273c8d6772)
            check_type(argname="argument allow_without_content_length", value=allow_without_content_length, expected_type=type_hints["allow_without_content_length"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_without_content_length is not None:
            self._values["allow_without_content_length"] = allow_without_content_length
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_without_content_length(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error.

        With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        '''
        result = self._values.get("allow_without_content_length")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a32e654e2fcaae57442d706f8d17fb828cac51f2a6cfff393c386c74dc99ea0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowWithoutContentLength")
    def reset_allow_without_content_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowWithoutContentLength", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLengthInput")
    def allow_without_content_length_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowWithoutContentLengthInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowWithoutContentLength")
    def allow_without_content_length(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowWithoutContentLength"))

    @allow_without_content_length.setter
    def allow_without_content_length(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8bd0f1ea21419569ccf962991e4733a66912baa1818f94df21c378dd14b1d96a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowWithoutContentLength", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c27e0555a1bf32d83a3ef57013e86751f26c22547f335b088f5423c2e394e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f89f7db321284bf173d641914aee362fe49de07ab854571481459a84b16ea27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2acd9035403424acef73738122f81efae3deb9b452af4d6e83203350f42cf14a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dacb0b07f683d47053f9feaa3cc8abc0a2e1d9cc4b48c88b9375666d5d35f0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee59edbd547ec542cb0c74c7c9cf3d0be29c7c1ee427eeaf7972a784e0bf0b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe5bd1b6a8c3c94f5dab36ecc897bcf7d0f68a84083d38cad2b90a54423180e)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows PUT requests. Content does ``not`` cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__441c551b5700f1e7802c9228619ecbe69e1123a9cda25a19aec730132a79963b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__763dcd41712326ad7cd8092e44fa021a1365ba63bed4519b60e62c2d00f08b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6ac606487b25c2b790b24766e531d4ef6b8f256bad2ad87c870f7e66f1bbc7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcee3751b7d598bff6ee1a2656beb26255eb9cd04f7987ae5c9352c4511cfb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62a8677bc87c566b78b67d788f1479cae21c9ff074b9c70ef1cb6c310bff8f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__040f8aa4afff2349dc6ba2f54167ac7d90b5ac12bf25959a0780ff882d3c3952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49d4ca31f4e8cdeb06868af742fc80ad3daf6676b8f24b096069899c3ea1767d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Chunked Transfer Encoding requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncodingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncodingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac80b03c4cb8260cee4057ced5dc78f0f48e5238c739a7c0d91719f0441267dc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53112c14a37208b3bc75b98332718d1ab6d51dc2d3afa43a1a1e3e1bd4c410f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0efcea4658814ef3c522d72b97f06e44dcfafe6fde650951d794a537f27fd72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9746bef3d797ce9bae3a10e1e3cac57de7aa0d2f2332e884fed8ca03be5ce6be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92e58e8a777f5a468c7af72547cc0eca149efc7a1ff8ba0cb689b1c01181ccf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eee24d5c07da0f95c7aac2eeafe3a25780aaa6fae88f7bc387523eb1c30ea387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "max_age": "maxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6f21a6d7818804937af37a783f4a10cb347c224a080d4a55dd9f3e13e44909f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[jsii.Number]:
        '''Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header.

        The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5bce02e9f5454470402b99901869e40fc3f0feaca931822f70fc1b318691b49)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdbc43498732c8d0209f17130c9fba7e01d5e5a9b71728efca26743362b6288)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c46a009121990cb8fe3c894c9df558a829f2217c6d18a9fe2948217c9e661dd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f0828c06d9d1be361ce3108f27a98282066d5cb4d2e56242cbed3a5dde81b57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e005437ef8206a9a68a86d5b843bf7ba5f2dec63cf0c1dfd3d044a8dd2c364c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0196764f4e3c15e41ce14e1c9ec6806297db751836f3f9730243ac0719846e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "alternate_response_cache_ttl": "alternateResponseCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "net_storage": "netStorage",
        "net_storage_path": "netStoragePath",
        "template_uuid": "templateUuid",
        "throttled_cp_code": "throttledCpCode",
        "throttled_status_code": "throttledStatusCode",
        "use_throttled_cp_code": "useThrottledCpCode",
        "use_throttled_status_code": "useThrottledStatusCode",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization:
    def __init__(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage(**net_storage)
        if isinstance(throttled_cp_code, dict):
            throttled_cp_code = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode(**throttled_cp_code)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90db49b96920868dcf475cb348145a7f767e81885b1502dae9cea4f01288d3c7)
            check_type(argname="argument alternate_response_cache_ttl", value=alternate_response_cache_ttl, expected_type=type_hints["alternate_response_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throttled_cp_code", value=throttled_cp_code, expected_type=type_hints["throttled_cp_code"])
            check_type(argname="argument throttled_status_code", value=throttled_status_code, expected_type=type_hints["throttled_status_code"])
            check_type(argname="argument use_throttled_cp_code", value=use_throttled_cp_code, expected_type=type_hints["use_throttled_cp_code"])
            check_type(argname="argument use_throttled_status_code", value=use_throttled_status_code, expected_type=type_hints["use_throttled_status_code"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if alternate_response_cache_ttl is not None:
            self._values["alternate_response_cache_ttl"] = alternate_response_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throttled_cp_code is not None:
            self._values["throttled_cp_code"] = throttled_cp_code
        if throttled_status_code is not None:
            self._values["throttled_status_code"] = throttled_status_code
        if use_throttled_cp_code is not None:
            self._values["use_throttled_cp_code"] = use_throttled_cp_code
        if use_throttled_status_code is not None:
            self._values["use_throttled_status_code"] = use_throttled_status_code
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def alternate_response_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the alternate response's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        '''
        result = self._values.get("alternate_response_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the API Prioritization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this API Prioritization policy from any others in the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''Specify the full NetStorage path for the alternate response, including trailing file name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throttled_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode"]:
        '''throttled_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        '''
        result = self._values.get("throttled_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode"], result)

    @builtins.property
    def throttled_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code for requests that receive the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        '''
        result = self._values.get("throttled_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def use_throttled_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to apply an alternative CP code for requests served the alternate response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        '''
        result = self._values.get("use_throttled_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def use_throttled_status_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a specific HTTP response code to a throttled request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        '''
        result = self._values.get("use_throttled_status_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4c29c0a1eff8f58ccee143b06725373cdb0035d4ac55dea7a8e5684a9c90796)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9aef64a99f5bd6c6423dc85faa5e132d4caef0b0000876786492b30250814f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8f5743aea5d090be14999a7201a94a83645f07e7317e766605da7e19fc3ce6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d026f55ea3ae3972d061149c489b3a0cc61ea3aeef9bb0cd24a219a9fc608ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1fb048a2df7f125a60449d6ce27d181b6dc8125571f1b51a67a326103c5514e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__722b13ba5b27712da194cd2f21d31e536ba4d1ceb58d4758eecbc7e4f184ed3e)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c8b9e04480b4761c6a5bdd5d7a8e13b47a5df5a124055e3eb52c7605eb1914)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8438229015ea74b8f8bd439ba78b3698a4b4cf030d82896ea5c0cf2a81668f13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95edbd28d410f2124287d5b38dc5d4e191466c824cf1739ac22936a91517dd84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6031e5d3721ba8446cf11d0de3a6b4824dc37d3c26b4e77fb30f4f000ed87aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af5f91fabc5147f5af2aef12c074a7fd307e5aa27d97aedb11292bdc3b2ceac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e11bab590fd0cf31f35b8bf94433b535dcaeaf1e5868f9a0e18c7dbf43d70c96)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="putThrottledCpCode")
    def put_throttled_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putThrottledCpCode", [value]))

    @jsii.member(jsii_name="resetAlternateResponseCacheTtl")
    def reset_alternate_response_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlternateResponseCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThrottledCpCode")
    def reset_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledCpCode", []))

    @jsii.member(jsii_name="resetThrottledStatusCode")
    def reset_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUseThrottledCpCode")
    def reset_use_throttled_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledCpCode", []))

    @jsii.member(jsii_name="resetUseThrottledStatusCode")
    def reset_use_throttled_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseThrottledStatusCode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCode")
    def throttled_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeOutputReference", jsii.get(self, "throttledCpCode"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtlInput")
    def alternate_response_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "alternateResponseCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledCpCodeInput")
    def throttled_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode"], jsii.get(self, "throttledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCodeInput")
    def throttled_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "throttledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCodeInput")
    def use_throttled_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCodeInput")
    def use_throttled_status_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useThrottledStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="alternateResponseCacheTtl")
    def alternate_response_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "alternateResponseCacheTtl"))

    @alternate_response_cache_ttl.setter
    def alternate_response_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8702ed0a5d049b9ca2ca6351a32bb4be779194a8a473026592ea8c0b841eff8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "alternateResponseCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__698834cbb4157acdc108ca1643c7911522d224c74c34b8298b7754c8f0b6ca28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__141c03193bdda18b896f995f4f66dd395d50e5f8dcf0552ae25c99801b9b4f92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81bcd3906949b05c5890d639bd106967dc9e761b62d627797d32091dceaae384)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3997c75d7b3037b59286439e1944654d27b13f41700e292bfc60f0c6e43be996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5caaa46b5a849632645abcbe479eabe2d99846c977dbf5838257c5dc2971dc91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bd5f425bb994e384ccd273ed92741dacf294ed603cb5c008dd206a9c1d69757)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dedaedaf286394ea9fc12253b7e87214e35bd592936855bccf70231c09735076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throttledStatusCode")
    def throttled_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "throttledStatusCode"))

    @throttled_status_code.setter
    def throttled_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0f4475b91c21e11b36a69f5cadf7e1f1de995e1c1ae4238e0c2ad4b5cd28554)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throttledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledCpCode")
    def use_throttled_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledCpCode"))

    @use_throttled_cp_code.setter
    def use_throttled_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46f649675633ee6520518ec94759de6a66b95733cc8aabc88363a74a6b40212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="useThrottledStatusCode")
    def use_throttled_status_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useThrottledStatusCode"))

    @use_throttled_status_code.setter
    def use_throttled_status_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f0dbf7e7436a8806df2cb67223cdd9381944495318df868c1915573a970eb82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useThrottledStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e06b7abb47fd736477e415b61d90196c08bf48552dda462fdc3fa4978bd0583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea796f2fe45bcdc2d3a662715019ff0c57d0576e6961928ad0122c5faa099637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc7b97625fdf9336f1e848367b3c4a1cceca5758a305f43d7bbf2490d730f033)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a13398bcec96899b1493e35bdf2909dee0d58af9928250906284a859776c9f5b)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81b6fa637f8debacdff9b794bc4ea750fbe2aa7455eae8c6bbcd0a524e437e25)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1691c5716064ffec1e996e03bf5bc708432516b81e07b88a84a1c3a1c69075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d724e2b5caa765df4d4d21c0b83b1a3f536bed61b7c60881de2f0dc14accf40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811350fada08ec35ee10f4bfb94eeaac668d5e20dd5dbfb57b9c4e329b00d559)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7a441be4ec6bc0420bd2ca932a2e3c9e2007cce59837379068adfbc995cc72c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f769cf75565f649e30d3e213625e46c6d81254023a7e04a27c6aa998a6167487)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7f357e70b30f3e5633d6208648f0608d32813a1f0c36080abcc90415271eb29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fef063fd7e5b45e41fa2338c3befe9f0c8bb8836eb8f2071acb037fc24c0f6c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a98c5aaece044eed87a8365fc082a985c8ada5c8a0078ebafb4a6720ca8d903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20f8e957d97f83739abd4ca182c84a6a7a935739618d9a46c290aafca34a3119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50566a62f13c3dd4af5d874400e0a20bf6e05a139e8466802836988ca931c7d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d831a7e2b5fee3a9b5ef879d1b767561cac1160aa6c40c9994dfac364715ea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer",
    jsii_struct_bases=[],
    name_mapping={
        "all_down_net_storage": "allDownNetStorage",
        "all_down_net_storage_file": "allDownNetStorageFile",
        "all_down_status_code": "allDownStatusCode",
        "all_down_title": "allDownTitle",
        "allow_cache_prefresh": "allowCachePrefresh",
        "cached_content_title": "cachedContentTitle",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "failover_attempts_threshold": "failoverAttemptsThreshold",
        "failover_mode": "failoverMode",
        "failover_origin_map": "failoverOriginMap",
        "failover_status_codes": "failoverStatusCodes",
        "failover_title": "failoverTitle",
        "label": "label",
        "locked": "locked",
        "origin_cookie_name": "originCookieName",
        "specify_stickiness_cookie_domain": "specifyStickinessCookieDomain",
        "stickiness_cookie_automatic_salt": "stickinessCookieAutomaticSalt",
        "stickiness_cookie_domain": "stickinessCookieDomain",
        "stickiness_cookie_salt": "stickinessCookieSalt",
        "stickiness_cookie_set_http_only_flag": "stickinessCookieSetHttpOnlyFlag",
        "stickiness_cookie_type": "stickinessCookieType",
        "stickiness_duration": "stickinessDuration",
        "stickiness_expiration_date": "stickinessExpirationDate",
        "stickiness_refresh": "stickinessRefresh",
        "stickiness_title": "stickinessTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer:
    def __init__(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(all_down_net_storage, dict):
            all_down_net_storage = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage(**all_down_net_storage)
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3e9c3f8e92b45e8f79ffb9d156a975c8e348a836e363f19e1441863b155b2d4)
            check_type(argname="argument all_down_net_storage", value=all_down_net_storage, expected_type=type_hints["all_down_net_storage"])
            check_type(argname="argument all_down_net_storage_file", value=all_down_net_storage_file, expected_type=type_hints["all_down_net_storage_file"])
            check_type(argname="argument all_down_status_code", value=all_down_status_code, expected_type=type_hints["all_down_status_code"])
            check_type(argname="argument all_down_title", value=all_down_title, expected_type=type_hints["all_down_title"])
            check_type(argname="argument allow_cache_prefresh", value=allow_cache_prefresh, expected_type=type_hints["allow_cache_prefresh"])
            check_type(argname="argument cached_content_title", value=cached_content_title, expected_type=type_hints["cached_content_title"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_attempts_threshold", value=failover_attempts_threshold, expected_type=type_hints["failover_attempts_threshold"])
            check_type(argname="argument failover_mode", value=failover_mode, expected_type=type_hints["failover_mode"])
            check_type(argname="argument failover_origin_map", value=failover_origin_map, expected_type=type_hints["failover_origin_map"])
            check_type(argname="argument failover_status_codes", value=failover_status_codes, expected_type=type_hints["failover_status_codes"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_cookie_name", value=origin_cookie_name, expected_type=type_hints["origin_cookie_name"])
            check_type(argname="argument specify_stickiness_cookie_domain", value=specify_stickiness_cookie_domain, expected_type=type_hints["specify_stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_automatic_salt", value=stickiness_cookie_automatic_salt, expected_type=type_hints["stickiness_cookie_automatic_salt"])
            check_type(argname="argument stickiness_cookie_domain", value=stickiness_cookie_domain, expected_type=type_hints["stickiness_cookie_domain"])
            check_type(argname="argument stickiness_cookie_salt", value=stickiness_cookie_salt, expected_type=type_hints["stickiness_cookie_salt"])
            check_type(argname="argument stickiness_cookie_set_http_only_flag", value=stickiness_cookie_set_http_only_flag, expected_type=type_hints["stickiness_cookie_set_http_only_flag"])
            check_type(argname="argument stickiness_cookie_type", value=stickiness_cookie_type, expected_type=type_hints["stickiness_cookie_type"])
            check_type(argname="argument stickiness_duration", value=stickiness_duration, expected_type=type_hints["stickiness_duration"])
            check_type(argname="argument stickiness_expiration_date", value=stickiness_expiration_date, expected_type=type_hints["stickiness_expiration_date"])
            check_type(argname="argument stickiness_refresh", value=stickiness_refresh, expected_type=type_hints["stickiness_refresh"])
            check_type(argname="argument stickiness_title", value=stickiness_title, expected_type=type_hints["stickiness_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if all_down_net_storage is not None:
            self._values["all_down_net_storage"] = all_down_net_storage
        if all_down_net_storage_file is not None:
            self._values["all_down_net_storage_file"] = all_down_net_storage_file
        if all_down_status_code is not None:
            self._values["all_down_status_code"] = all_down_status_code
        if all_down_title is not None:
            self._values["all_down_title"] = all_down_title
        if allow_cache_prefresh is not None:
            self._values["allow_cache_prefresh"] = allow_cache_prefresh
        if cached_content_title is not None:
            self._values["cached_content_title"] = cached_content_title
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_attempts_threshold is not None:
            self._values["failover_attempts_threshold"] = failover_attempts_threshold
        if failover_mode is not None:
            self._values["failover_mode"] = failover_mode
        if failover_origin_map is not None:
            self._values["failover_origin_map"] = failover_origin_map
        if failover_status_codes is not None:
            self._values["failover_status_codes"] = failover_status_codes
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if origin_cookie_name is not None:
            self._values["origin_cookie_name"] = origin_cookie_name
        if specify_stickiness_cookie_domain is not None:
            self._values["specify_stickiness_cookie_domain"] = specify_stickiness_cookie_domain
        if stickiness_cookie_automatic_salt is not None:
            self._values["stickiness_cookie_automatic_salt"] = stickiness_cookie_automatic_salt
        if stickiness_cookie_domain is not None:
            self._values["stickiness_cookie_domain"] = stickiness_cookie_domain
        if stickiness_cookie_salt is not None:
            self._values["stickiness_cookie_salt"] = stickiness_cookie_salt
        if stickiness_cookie_set_http_only_flag is not None:
            self._values["stickiness_cookie_set_http_only_flag"] = stickiness_cookie_set_http_only_flag
        if stickiness_cookie_type is not None:
            self._values["stickiness_cookie_type"] = stickiness_cookie_type
        if stickiness_duration is not None:
            self._values["stickiness_duration"] = stickiness_duration
        if stickiness_expiration_date is not None:
            self._values["stickiness_expiration_date"] = stickiness_expiration_date
        if stickiness_refresh is not None:
            self._values["stickiness_refresh"] = stickiness_refresh
        if stickiness_title is not None:
            self._values["stickiness_title"] = stickiness_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def all_down_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage"]:
        '''all_down_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        '''
        result = self._values.get("all_down_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage"], result)

    @builtins.property
    def all_down_net_storage_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        '''
        result = self._values.get("all_down_net_storage_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP response code when all load-balancing origins are unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        '''
        result = self._values.get("all_down_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def all_down_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        '''
        result = self._values.get("all_down_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_cache_prefresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows the cache to prefresh.  Only appropriate if all origins serve the same content for the same URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        '''
        result = self._values.get("allow_cache_prefresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cached_content_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        '''
        result = self._values.get("cached_content_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the Application Load Balancer Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_attempts_threshold(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of failed requests that would trigger the failover process.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        '''
        result = self._values.get("failover_attempts_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_mode(self) -> typing.Optional[builtins.str]:
        '''Determines what to do if an origin fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        '''
        result = self._values.get("failover_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_origin_map(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap"]]]:
        '''failover_origin_map block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        '''
        result = self._values.get("failover_origin_map")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap"]]], result)

    @builtins.property
    def failover_status_codes(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        '''
        result = self._values.get("failover_status_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Application Load Balancer policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name for your session cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        '''
        result = self._values.get("origin_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        '''
        result = self._values.get("specify_stickiness_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable this if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        '''
        result = self._values.get("stickiness_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the stickiness cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        '''
        result = self._values.get("stickiness_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        '''
        result = self._values.get("stickiness_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ensures the cookie is transmitted only over HTTP.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        '''
        result = self._values.get("stickiness_cookie_set_http_only_flag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Determines how a cookie persistently associates the client with a load-balanced origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        '''
        result = self._values.get("stickiness_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_duration(self) -> typing.Optional[builtins.str]:
        '''Sets how long it is before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        '''
        result = self._values.get("stickiness_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        '''
        result = self._values.get("stickiness_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def stickiness_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extends the duration of the cookie with each new request.

        When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        '''
        result = self._values.get("stickiness_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def stickiness_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        '''
        result = self._values.get("stickiness_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c756d2d7ebd07f5120772a1b41fb0efe96d574408c6c77b1ccc87be1339048f5)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a8d012356c547e4a68b1994fd354bbc463eb7802534b4fb1374b257e393b90)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2511d78b9c2b564ee6078b97d9f7adc2003620d7fd8ca3a4a9661eb4c028a5e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef71dfa4b6b639a41ad31358863641a28d8632d253d6ba82eb0db948da2138f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f923211ca053c31116852637c90543c89b5ff1cf362d75fac156e83c446e3117)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60af920177f8916150f13b6047f23a91eb939e846c4772de28dfa72fc4031d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86bac8485ec0557a02f1535b25bbb07b285f762a82bf75b7a876179faa5a0429)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d29b8c49a6508cf52e5aa9a68377c69167f945980fa20e2818a86f5016998b8d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce6ede4c8a907b0aaf39cd31df84fde5a219d53ea0dcf9f87be05e0422e34bd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d51bedfad45ab593fde372b05a09366e04f7a4aadf54bc1620bbbbdda60fa9da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__237dd38658b466328e10d57699a5a6082ac79076868a4247d5228aeec46105c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap",
    jsii_struct_bases=[],
    name_mapping={"from_origin_id": "fromOriginId", "to_origin_ids": "toOriginIds"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap:
    def __init__(
        self,
        *,
        from_origin_id: typing.Optional[builtins.str] = None,
        to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param from_origin_id: Specifies the origin whose failure triggers the mapping rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        :param to_origin_ids: Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25513913f9864b60d9c41736dff5e65dfaab38c9f09f9391a36a59a2e0c8082c)
            check_type(argname="argument from_origin_id", value=from_origin_id, expected_type=type_hints["from_origin_id"])
            check_type(argname="argument to_origin_ids", value=to_origin_ids, expected_type=type_hints["to_origin_ids"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if from_origin_id is not None:
            self._values["from_origin_id"] = from_origin_id
        if to_origin_ids is not None:
            self._values["to_origin_ids"] = to_origin_ids

    @builtins.property
    def from_origin_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin whose failure triggers the mapping rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#from_origin_id DataAkamaiPropertyRulesBuilder#from_origin_id}
        '''
        result = self._values.get("from_origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_origin_ids(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Requests stuck to the ``fromOriginId`` origin retry for each alternate origin ``toOriginIds``, until one succeeds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_origin_ids DataAkamaiPropertyRulesBuilder#to_origin_ids}
        '''
        result = self._values.get("to_origin_ids")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a67fe3a9096c60a5385707e011ef5e5c6b3fd2092d006d9b9485bf3f0f586c89)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6095aa8728d57248aac8dc7b09739746b2b738ad72027482d1eac377cef5cde)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db400c106e291246b56acd9c48cd48f1f13eb3ba25f6cbb3614f3b8e3bf65982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0672d2bc4e4cf458d949592a8fe99d980ee5dc9b3c79cb1ae220543125b9499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bff3fa13b2ec42c0ac589373739790cf56870d0292b2abaa1fdcd8335cf60ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e5785b35b09f05cca1d605a3a07b4247626bc0a00871505f44fe8f5a13f1676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5618de8e45977ab57d8198a3a439ade2627ceebd6369332d590c37c57d43924)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetFromOriginId")
    def reset_from_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFromOriginId", []))

    @jsii.member(jsii_name="resetToOriginIds")
    def reset_to_origin_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToOriginIds", []))

    @builtins.property
    @jsii.member(jsii_name="fromOriginIdInput")
    def from_origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fromOriginIdInput"))

    @builtins.property
    @jsii.member(jsii_name="toOriginIdsInput")
    def to_origin_ids_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "toOriginIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="fromOriginId")
    def from_origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fromOriginId"))

    @from_origin_id.setter
    def from_origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__106eff6da9c38bdbad78d019105902c4a3e0fdae3e6fa0f8c291cae65781a02c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fromOriginId", value)

    @builtins.property
    @jsii.member(jsii_name="toOriginIds")
    def to_origin_ids(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "toOriginIds"))

    @to_origin_ids.setter
    def to_origin_ids(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdde67fea5cf538677e0a763693e8bafceea2febc5a14a3b3d7de556f53fb29b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toOriginIds", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721d9e5a018e365fb6ba93ae8b5af80f46127ba4e80d21a25bcb01e5481ea2be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__047fd1a881710104819fdc10e093eb6b95dc3b015ef75820a42011e4c722d426)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putAllDownNetStorage")
    def put_all_down_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putAllDownNetStorage", [value]))

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putFailoverOriginMap")
    def put_failover_origin_map(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fae8dbfd445cf40c7207671d335995b191faa65ba9cd995a7667eb3641a4e6c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverOriginMap", [value]))

    @jsii.member(jsii_name="resetAllDownNetStorage")
    def reset_all_down_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorage", []))

    @jsii.member(jsii_name="resetAllDownNetStorageFile")
    def reset_all_down_net_storage_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownNetStorageFile", []))

    @jsii.member(jsii_name="resetAllDownStatusCode")
    def reset_all_down_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownStatusCode", []))

    @jsii.member(jsii_name="resetAllDownTitle")
    def reset_all_down_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllDownTitle", []))

    @jsii.member(jsii_name="resetAllowCachePrefresh")
    def reset_allow_cache_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCachePrefresh", []))

    @jsii.member(jsii_name="resetCachedContentTitle")
    def reset_cached_content_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachedContentTitle", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverAttemptsThreshold")
    def reset_failover_attempts_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverAttemptsThreshold", []))

    @jsii.member(jsii_name="resetFailoverMode")
    def reset_failover_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMode", []))

    @jsii.member(jsii_name="resetFailoverOriginMap")
    def reset_failover_origin_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverOriginMap", []))

    @jsii.member(jsii_name="resetFailoverStatusCodes")
    def reset_failover_status_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverStatusCodes", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginCookieName")
    def reset_origin_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCookieName", []))

    @jsii.member(jsii_name="resetSpecifyStickinessCookieDomain")
    def reset_specify_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieAutomaticSalt")
    def reset_stickiness_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieDomain")
    def reset_stickiness_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieDomain", []))

    @jsii.member(jsii_name="resetStickinessCookieSalt")
    def reset_stickiness_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSalt", []))

    @jsii.member(jsii_name="resetStickinessCookieSetHttpOnlyFlag")
    def reset_stickiness_cookie_set_http_only_flag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieSetHttpOnlyFlag", []))

    @jsii.member(jsii_name="resetStickinessCookieType")
    def reset_stickiness_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessCookieType", []))

    @jsii.member(jsii_name="resetStickinessDuration")
    def reset_stickiness_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessDuration", []))

    @jsii.member(jsii_name="resetStickinessExpirationDate")
    def reset_stickiness_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessExpirationDate", []))

    @jsii.member(jsii_name="resetStickinessRefresh")
    def reset_stickiness_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessRefresh", []))

    @jsii.member(jsii_name="resetStickinessTitle")
    def reset_stickiness_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStickinessTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorage")
    def all_down_net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference, jsii.get(self, "allDownNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMap")
    def failover_origin_map(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapList, jsii.get(self, "failoverOriginMap"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFileInput")
    def all_down_net_storage_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownNetStorageFileInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageInput")
    def all_down_net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage], jsii.get(self, "allDownNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCodeInput")
    def all_down_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownTitleInput")
    def all_down_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allDownTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefreshInput")
    def allow_cache_prefresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCachePrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitleInput")
    def cached_content_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cachedContentTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThresholdInput")
    def failover_attempts_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverAttemptsThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverModeInput")
    def failover_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverModeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverOriginMapInput")
    def failover_origin_map_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]]], jsii.get(self, "failoverOriginMapInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodesInput")
    def failover_status_codes_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverStatusCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originCookieNameInput")
    def origin_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomainInput")
    def specify_stickiness_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyStickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSaltInput")
    def stickiness_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomainInput")
    def stickiness_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSaltInput")
    def stickiness_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlagInput")
    def stickiness_cookie_set_http_only_flag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessCookieSetHttpOnlyFlagInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieTypeInput")
    def stickiness_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessDurationInput")
    def stickiness_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDateInput")
    def stickiness_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessRefreshInput")
    def stickiness_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "stickinessRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="stickinessTitleInput")
    def stickiness_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stickinessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allDownNetStorageFile")
    def all_down_net_storage_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownNetStorageFile"))

    @all_down_net_storage_file.setter
    def all_down_net_storage_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72593e96828fa7a9bec1645fec69e30a22df8982436d0b6dd2285e5d2c417c17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownNetStorageFile", value)

    @builtins.property
    @jsii.member(jsii_name="allDownStatusCode")
    def all_down_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownStatusCode"))

    @all_down_status_code.setter
    def all_down_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__971d38294d4dc3ec11d782acb2f2f89bc8e0a70b1f7f30ec59fc431f4492de48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="allDownTitle")
    def all_down_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allDownTitle"))

    @all_down_title.setter
    def all_down_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__389057084a84b822a05ede8d1f4d8fc2f34cb9cf72bc8a88b1920e8c41f1b402)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allDownTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowCachePrefresh")
    def allow_cache_prefresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCachePrefresh"))

    @allow_cache_prefresh.setter
    def allow_cache_prefresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d98e889e38b30d6581b7cfd1c0a159bcc7f4a274e0085c0c4b2eabc9edcbb5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCachePrefresh", value)

    @builtins.property
    @jsii.member(jsii_name="cachedContentTitle")
    def cached_content_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cachedContentTitle"))

    @cached_content_title.setter
    def cached_content_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc59bd672761692ccf1c865d7e0dc9ef36ae5a4f8ded1658976005340efcf95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cachedContentTitle", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1595ebcf6eb7c50331bce53574c60e818a4c39a42260c2dba37ba8d04712829a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverAttemptsThreshold")
    def failover_attempts_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverAttemptsThreshold"))

    @failover_attempts_threshold.setter
    def failover_attempts_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f62a3aa24513de0c39ede349660693e97078f94087dc42cbfd6df2e21712b22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverAttemptsThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMode")
    def failover_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMode"))

    @failover_mode.setter
    def failover_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a96086425f2f432569910d02d63e14d918195f65992c8d53536191f33ab565b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverStatusCodes")
    def failover_status_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverStatusCodes"))

    @failover_status_codes.setter
    def failover_status_codes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a7baeb886db20c2a05cfcd64d17aec2ffb23d6c34d98726af6a1d529db3103)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverStatusCodes", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a02215f62c7815527aa4a80d7dd885bfbdcada980926a44230c66744b8159f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de977a2830162094bf23f8305d65abcac91066d32c89b982c177555a8e319926)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__416878e6e5a603626bc0635a32cc64cb44e34de1f4b7966b210e74c084765bef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originCookieName")
    def origin_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCookieName"))

    @origin_cookie_name.setter
    def origin_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__879277c9d74cbe28de0bb6ae7d0ff5fb8f0ac1e67670fe9d101620b0f4060ae0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="specifyStickinessCookieDomain")
    def specify_stickiness_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyStickinessCookieDomain"))

    @specify_stickiness_cookie_domain.setter
    def specify_stickiness_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e47c3321797950d1493c911aa4e26383e56fece248989569688d1a85e2fa7dde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyStickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieAutomaticSalt")
    def stickiness_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieAutomaticSalt"))

    @stickiness_cookie_automatic_salt.setter
    def stickiness_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef162f3d7995bf5e5356beb6cc97ea6ec219551897b3e3cdc8162e89f6a284f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieDomain")
    def stickiness_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieDomain"))

    @stickiness_cookie_domain.setter
    def stickiness_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9c0d69d02a835f33577f63c8bf10753eceaf554a0b2972ba3b441b21c1509d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSalt")
    def stickiness_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieSalt"))

    @stickiness_cookie_salt.setter
    def stickiness_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e7957ae531b0ebdcff25e399597c168b56d1683720b8917711b7c8049b44e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieSetHttpOnlyFlag")
    def stickiness_cookie_set_http_only_flag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessCookieSetHttpOnlyFlag"))

    @stickiness_cookie_set_http_only_flag.setter
    def stickiness_cookie_set_http_only_flag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e617190a70452a0575ac87566e4409a4af7ebe797ddbb831141b1adb38fc008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieSetHttpOnlyFlag", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessCookieType")
    def stickiness_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessCookieType"))

    @stickiness_cookie_type.setter
    def stickiness_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__251b69c56bafac2ea3ed3a34014a83ebac45d37875ef2ca0604c3c3ef6897b86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessDuration")
    def stickiness_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessDuration"))

    @stickiness_duration.setter
    def stickiness_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68d94d2a6899d8f7dd247c995f91575d9482568c1db1e93cde5daf9392cef963)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessDuration", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessExpirationDate")
    def stickiness_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessExpirationDate"))

    @stickiness_expiration_date.setter
    def stickiness_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1820355702a69ef29d6e4796a356595b1a8afee0c1473a3f0e6a32f5d95cb9cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessRefresh")
    def stickiness_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "stickinessRefresh"))

    @stickiness_refresh.setter
    def stickiness_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c95c43c845009c90bfd6f48ad1333f23c5d00151891bbd00e6ccc78a205c3e2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="stickinessTitle")
    def stickiness_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stickinessTitle"))

    @stickiness_title.setter
    def stickiness_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c3a697f9593cc476b02f336e62cd4c52ceee4534c469755dc5278e0d870c8fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stickinessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae820ba5d8d5741ec17a56df849230c53f5f1b658351a7cbb8fc3638bd9df069)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20771f89e108d9b9d1298f158801976eefe2bfd5b78dc5cdfd8ce193345b933b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__327a698bb56e7a9ec008a70fac460b2fed794aa0e56942cb5ba02896acdf6885)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_automatic_salt": "populationCookieAutomaticSalt",
        "population_cookie_domain": "populationCookieDomain",
        "population_cookie_include_rule_name": "populationCookieIncludeRuleName",
        "population_cookie_salt": "populationCookieSalt",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "segment_tracking_cookie_name": "segmentTrackingCookieName",
        "segment_tracking_custom_header": "segmentTrackingCustomHeader",
        "segment_tracking_method": "segmentTrackingMethod",
        "segment_tracking_query_param": "segmentTrackingQueryParam",
        "segment_tracking_title": "segmentTrackingTitle",
        "specify_population_cookie_domain": "specifyPopulationCookieDomain",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78204291b829b439d126b0e9a7bd85467233f7bae6a441a6ece5e18ee894d94)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_automatic_salt", value=population_cookie_automatic_salt, expected_type=type_hints["population_cookie_automatic_salt"])
            check_type(argname="argument population_cookie_domain", value=population_cookie_domain, expected_type=type_hints["population_cookie_domain"])
            check_type(argname="argument population_cookie_include_rule_name", value=population_cookie_include_rule_name, expected_type=type_hints["population_cookie_include_rule_name"])
            check_type(argname="argument population_cookie_salt", value=population_cookie_salt, expected_type=type_hints["population_cookie_salt"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument segment_tracking_cookie_name", value=segment_tracking_cookie_name, expected_type=type_hints["segment_tracking_cookie_name"])
            check_type(argname="argument segment_tracking_custom_header", value=segment_tracking_custom_header, expected_type=type_hints["segment_tracking_custom_header"])
            check_type(argname="argument segment_tracking_method", value=segment_tracking_method, expected_type=type_hints["segment_tracking_method"])
            check_type(argname="argument segment_tracking_query_param", value=segment_tracking_query_param, expected_type=type_hints["segment_tracking_query_param"])
            check_type(argname="argument segment_tracking_title", value=segment_tracking_title, expected_type=type_hints["segment_tracking_title"])
            check_type(argname="argument specify_population_cookie_domain", value=specify_population_cookie_domain, expected_type=type_hints["specify_population_cookie_domain"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_automatic_salt is not None:
            self._values["population_cookie_automatic_salt"] = population_cookie_automatic_salt
        if population_cookie_domain is not None:
            self._values["population_cookie_domain"] = population_cookie_domain
        if population_cookie_include_rule_name is not None:
            self._values["population_cookie_include_rule_name"] = population_cookie_include_rule_name
        if population_cookie_salt is not None:
            self._values["population_cookie_salt"] = population_cookie_salt
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if segment_tracking_cookie_name is not None:
            self._values["segment_tracking_cookie_name"] = segment_tracking_cookie_name
        if segment_tracking_custom_header is not None:
            self._values["segment_tracking_custom_header"] = segment_tracking_custom_header
        if segment_tracking_method is not None:
            self._values["segment_tracking_method"] = segment_tracking_method
        if segment_tracking_query_param is not None:
            self._values["segment_tracking_query_param"] = segment_tracking_query_param
        if segment_tracking_title is not None:
            self._values["segment_tracking_title"] = segment_tracking_title
        if specify_population_cookie_domain is not None:
            self._values["specify_population_cookie_domain"] = specify_population_cookie_domain
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Audience Segmentation cloudlet feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''Specifies a suffix to append to the cookie name.

        This helps distinguish this audience segmentation policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user.

        You should not enable if sharing the population cookie across more than one property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        '''
        result = self._values.get("population_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies the domain to track the population cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        '''
        result = self._values.get("population_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes in the session cookie the name of the rule in which this behavior appears.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        '''
        result = self._values.get("population_cookie_include_rule_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies the cookie's salt value. Use this option to share the cookie across many properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        '''
        result = self._values.get("population_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Specifies when the segmentation cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the lifetime of the segmentation cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If disabled, sets the expiration time only if the cookie is not yet present in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_cookie_name(self) -> typing.Optional[builtins.str]:
        '''This cookie name specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        '''
        result = self._values.get("segment_tracking_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_custom_header(self) -> typing.Optional[builtins.str]:
        '''This custom HTTP header specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        '''
        result = self._values.get("segment_tracking_custom_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the method to pass segment information to the origin.

        The Cloudlet passes the rule applied to a given request location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        '''
        result = self._values.get("segment_tracking_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_query_param(self) -> typing.Optional[builtins.str]:
        '''This query parameter specifies the name of the segmentation rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        '''
        result = self._values.get("segment_tracking_query_param")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_tracking_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        '''
        result = self._values.get("segment_tracking_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def specify_population_cookie_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to specify a cookie domain with the population cookie.

        It tells the browser to which domain to send the cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        '''
        result = self._values.get("specify_population_cookie_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39c17146d6460fee8bcb26f26790f2a38a5f8d3b884277eb90876b05080ec3eb)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c190f86d83268f249c4faea05c8e0e55b42432f2842e7ce0c01a0ddd05daa3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2271a5b73f903047d7c2cac76838836b6da06bea5adb0f2ae39110b12eaa25d1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0af034b978be9ea8e72758c2ece32d5de2e97c98b141f5435b5239b5f4d81f3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7bdaf2f998bcf8fa02ba6e7b6fdd1e734e18449270df18a8e355584c35078ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7567aad0dfa9e360854d44847780c1bd089692060985c58225bf255e29787894)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieAutomaticSalt")
    def reset_population_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieDomain")
    def reset_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetPopulationCookieIncludeRuleName")
    def reset_population_cookie_include_rule_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieIncludeRuleName", []))

    @jsii.member(jsii_name="resetPopulationCookieSalt")
    def reset_population_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieSalt", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetSegmentTrackingCookieName")
    def reset_segment_tracking_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCookieName", []))

    @jsii.member(jsii_name="resetSegmentTrackingCustomHeader")
    def reset_segment_tracking_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingCustomHeader", []))

    @jsii.member(jsii_name="resetSegmentTrackingMethod")
    def reset_segment_tracking_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingMethod", []))

    @jsii.member(jsii_name="resetSegmentTrackingQueryParam")
    def reset_segment_tracking_query_param(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingQueryParam", []))

    @jsii.member(jsii_name="resetSegmentTrackingTitle")
    def reset_segment_tracking_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentTrackingTitle", []))

    @jsii.member(jsii_name="resetSpecifyPopulationCookieDomain")
    def reset_specify_population_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSpecifyPopulationCookieDomain", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSaltInput")
    def population_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomainInput")
    def population_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleNameInput")
    def population_cookie_include_rule_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationCookieIncludeRuleNameInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieSaltInput")
    def population_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieNameInput")
    def segment_tracking_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeaderInput")
    def segment_tracking_custom_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingCustomHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethodInput")
    def segment_tracking_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParamInput")
    def segment_tracking_query_param_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingQueryParamInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitleInput")
    def segment_tracking_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentTrackingTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomainInput")
    def specify_population_cookie_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "specifyPopulationCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3041b0b33cd3d03121a4ab869fdff8ad5756fdcf015cf96dfa66f97ebb854e6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0240f7c4faaa6083753a52a4dc06038b612e336fd5a54ed80527502e27667b63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aba332586d62a8c731a73ee694510d7b99238568d94daff40407b93fef171a9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65615ac2a4727a85fa73313f26858d3fa673e9c39a3ca4d17e60de86b03c5ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed5af354c8fc32338bf543adc39f1b598986068984ae43d33d4a08e2ed09f498)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieAutomaticSalt")
    def population_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieAutomaticSalt"))

    @population_cookie_automatic_salt.setter
    def population_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96a49cb6ea88ad2d1df1fcd6ace9a776266a9d532a6df2e0d2a9fae85ed1800d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieDomain")
    def population_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieDomain"))

    @population_cookie_domain.setter
    def population_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36a288d8228b4df9f4c057fd89dd5ae97164ca0b2d256d21b688f3dc62f2e93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieIncludeRuleName")
    def population_cookie_include_rule_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationCookieIncludeRuleName"))

    @population_cookie_include_rule_name.setter
    def population_cookie_include_rule_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a91bcd8e14f64571dcbec29025a72630c0b3afc1ef7595bdfc4320ee6530e2ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieIncludeRuleName", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieSalt")
    def population_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieSalt"))

    @population_cookie_salt.setter
    def population_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c2559909fb3b4cb6c6349baac1877804811b000a2f5eaa993e8b867b54e89a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2d4fd0055dffd61dad0daa48baacb6f64dea5ffdbb6de16ecabf45826c7f188)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af112bc128c2f21c78b1b89beae959302331a1fa79e98d7b32d92bad407f2775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749fc3d69916e16d8ad5e39bd0ba5e037e11f5677fa4fa04bb822ff52cc4172f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88d7a79d7f04151c87528615f23ed519eba0d5e00045f57c7a7a5bafddbe8f2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCookieName")
    def segment_tracking_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCookieName"))

    @segment_tracking_cookie_name.setter
    def segment_tracking_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cf07dd0cdfdfacc1beafc8522ddbb6616d509b2dc509fee02fb194e17a8807b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingCustomHeader")
    def segment_tracking_custom_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingCustomHeader"))

    @segment_tracking_custom_header.setter
    def segment_tracking_custom_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9eea9a37c29c4d5d586b8e37eac35b20972603adb797909400040503369fcd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingCustomHeader", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingMethod")
    def segment_tracking_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingMethod"))

    @segment_tracking_method.setter
    def segment_tracking_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59ce8b2bc7827f9e14a9166df0934407ce010e485fba246702efe4b2389570fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingMethod", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingQueryParam")
    def segment_tracking_query_param(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingQueryParam"))

    @segment_tracking_query_param.setter
    def segment_tracking_query_param(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08ff01b58c351b77f9ed3521546f814fcbf783d28b2315bb66c4954877dd64ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingQueryParam", value)

    @builtins.property
    @jsii.member(jsii_name="segmentTrackingTitle")
    def segment_tracking_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentTrackingTitle"))

    @segment_tracking_title.setter
    def segment_tracking_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f81c3ea7adfeb0e8bce83b4aaa1c56ee51880d2cae5aaa7abdeeea37169c50ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentTrackingTitle", value)

    @builtins.property
    @jsii.member(jsii_name="specifyPopulationCookieDomain")
    def specify_population_cookie_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "specifyPopulationCookieDomain"))

    @specify_population_cookie_domain.setter
    def specify_population_cookie_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe129962322f732f2913df9099c82214f0a297b3880c2295268b1a092cdb83e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "specifyPopulationCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d57ebc9f8452c4ab4711a3a6b9fc00bd9c6025808e257e0512d289923eb7d61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c087d1c8089145f47c7b2f74dd7eb9d73f437a188ed05086d5b703d0c2b60c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b7c97064e9a59de3d0bf5f616edf34593b958a91530dc5b59c8bd1051c230c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation",
    jsii_struct_bases=[],
    name_mapping={
        "autodv": "autodv",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation:
    def __init__(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__779d3e4bbeefafe3dac9e737235af39b702c5872738b3a2c0ed54d7546ffb368)
            check_type(argname="argument autodv", value=autodv, expected_type=type_hints["autodv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if autodv is not None:
            self._values["autodv"] = autodv
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def autodv(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        '''
        result = self._values.get("autodv")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f28131c5d8090885f048315c400590da2ca2592f85a97ae180867594b211771b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAutodv")
    def reset_autodv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutodv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="autodvInput")
    def autodv_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "autodvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="autodv")
    def autodv(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "autodv"))

    @autodv.setter
    def autodv(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dea309c699aa3789c5bb6e1977bb58fc92ba070d0244c2ae5d34014954aa588e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "autodv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__073a1c21eb87fb385024e02e26f9824ba4378a3c1d209b95d50bf0ead1f6138b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cac145c70fde071e7b608e52292fb1b691a3b69182c30d164b672537317522d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb248ab93c977f11d44ee72aadc1689c6f8c952731a404248fad42c5b01e966f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e689817a918a9e8700a017b420f5c82f84d1a5c73f082da0d6d141715d6c71e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a00771da1c23d364299551dcc67ffaa93fc25a7330138c0bb66ff8341d4e186)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the base path of content on your origin server.

        The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectoryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectoryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd41c22873e819f3666a76f6442d3868bdf608065efb7b137f2a268a04e5237)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b912314b1ab86c3a6f80dd584160026579372955eab9622d6be77c1c3f121cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2047cd78876798948505335732a13c3df35544cf0ce39afe9693740bbe0837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b1825b9de53af37130a38006a9353d59ced693a8807b0999fb24945ae5728bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69f679aebcceab3f719208d7bed72bda1ed7b5d849ef37778a31a5d5399566b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a370cf4f9166ae3d31c902c71b2715741d63107b81686aaa6c8f8d764ff97c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing",
    jsii_struct_bases=[],
    name_mapping={
        "conditional_error_pattern": "conditionalErrorPattern",
        "conditional_http_status": "conditionalHttpStatus",
        "conditional_sampling_frequency": "conditionalSamplingFrequency",
        "cpcodes": "cpcodes",
        "enabled": "enabled",
        "forward_type": "forwardType",
        "locked": "locked",
        "request_type": "requestType",
        "sampling_frequency": "samplingFrequency",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing:
    def __init__(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d871f86e6f90191d317365828641ed0f26fe4afa9d43c713bf2179b4390825)
            check_type(argname="argument conditional_error_pattern", value=conditional_error_pattern, expected_type=type_hints["conditional_error_pattern"])
            check_type(argname="argument conditional_http_status", value=conditional_http_status, expected_type=type_hints["conditional_http_status"])
            check_type(argname="argument conditional_sampling_frequency", value=conditional_sampling_frequency, expected_type=type_hints["conditional_sampling_frequency"])
            check_type(argname="argument cpcodes", value=cpcodes, expected_type=type_hints["cpcodes"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_type", value=forward_type, expected_type=type_hints["forward_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument sampling_frequency", value=sampling_frequency, expected_type=type_hints["sampling_frequency"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if conditional_error_pattern is not None:
            self._values["conditional_error_pattern"] = conditional_error_pattern
        if conditional_http_status is not None:
            self._values["conditional_http_status"] = conditional_http_status
        if conditional_sampling_frequency is not None:
            self._values["conditional_sampling_frequency"] = conditional_sampling_frequency
        if cpcodes is not None:
            self._values["cpcodes"] = cpcodes
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_type is not None:
            self._values["forward_type"] = forward_type
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if sampling_frequency is not None:
            self._values["sampling_frequency"] = sampling_frequency
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def conditional_error_pattern(self) -> typing.Optional[builtins.str]:
        '''A space-separated set of error patterns that trigger beacons to conditional feeds.

        Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        '''
        result = self._values.get("conditional_error_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def conditional_http_status(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response status codes or ranges that trigger the beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        '''
        result = self._values.get("conditional_http_status")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def conditional_sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a conditional sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        '''
        result = self._values.get("conditional_sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cpcodes(self) -> typing.Optional[builtins.str]:
        '''The space-separated list of CP codes that trigger the beacons.

        You need to specify the same set of CP codes within BOSS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        '''
        result = self._values.get("cpcodes")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable diagnostic data beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        '''
        result = self._values.get("forward_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specify when to trigger a beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_frequency(self) -> typing.Optional[builtins.str]:
        '''Specifies a sampling frequency or disables beacons.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        '''
        result = self._values.get("sampling_frequency")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be0b4564a3aaeef05cbeef9c25bacf0f82b2201727e78866a2cd783779921bbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConditionalErrorPattern")
    def reset_conditional_error_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalErrorPattern", []))

    @jsii.member(jsii_name="resetConditionalHttpStatus")
    def reset_conditional_http_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalHttpStatus", []))

    @jsii.member(jsii_name="resetConditionalSamplingFrequency")
    def reset_conditional_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalSamplingFrequency", []))

    @jsii.member(jsii_name="resetCpcodes")
    def reset_cpcodes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpcodes", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardType")
    def reset_forward_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetSamplingFrequency")
    def reset_sampling_frequency(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingFrequency", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPatternInput")
    def conditional_error_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalErrorPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatusInput")
    def conditional_http_status_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "conditionalHttpStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequencyInput")
    def conditional_sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "conditionalSamplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="cpcodesInput")
    def cpcodes_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cpcodesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardTypeInput")
    def forward_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingFrequencyInput")
    def sampling_frequency_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "samplingFrequencyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalErrorPattern")
    def conditional_error_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalErrorPattern"))

    @conditional_error_pattern.setter
    def conditional_error_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__545edae499b63c0b5cb4609a36f3ff65be082d3d961a69bf8b2b5722bbdcb8d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalErrorPattern", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalHttpStatus")
    def conditional_http_status(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "conditionalHttpStatus"))

    @conditional_http_status.setter
    def conditional_http_status(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d8b84d7be93c356ffc24f2a2dc279dcd3889d093c0b9d683e6b6c33c5078f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalHttpStatus", value)

    @builtins.property
    @jsii.member(jsii_name="conditionalSamplingFrequency")
    def conditional_sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "conditionalSamplingFrequency"))

    @conditional_sampling_frequency.setter
    def conditional_sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23d4ad1a86462d9f852b4afe478f77c68266cce7e9185adb1787841db3983610)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "conditionalSamplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="cpcodes")
    def cpcodes(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cpcodes"))

    @cpcodes.setter
    def cpcodes(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14c343c43f2c262e00d27438b1253bcc20ed7723c268b5b43e97ee1b6c7945ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpcodes", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__904f5349aed9b4dd3f64d865f0bc533c3a7861a3084bd30579d646b563294c0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardType")
    def forward_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardType"))

    @forward_type.setter
    def forward_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b67fc2d717ea7de1604835c4cd8812d45c6f3e278cf83167633f92a9e5517e45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__588793f0d97741bafadd77fb5b7d06ea30ca45d0721016702ab1dab3756c00d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30386409ba047cf921f12ae55dfbab5a948d11d7196aedb863a47e44d482246f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="samplingFrequency")
    def sampling_frequency(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "samplingFrequency"))

    @sampling_frequency.setter
    def sampling_frequency(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c70391e458ab28a8c9ef8306ba960866c793d6c50ad5d05de1682327bfeff3a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingFrequency", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__232726affc2d08ba767fedc1d170cb45ce9155f85b3f98bc06c45c09a0e54814)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a632f0d94fbc9b770a36f85f879001be87d4086a2d2021b8c0e22b39a15bbea2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42529d3ea8d32a03e7ff074b451632c86705fa8548d469bfefe2a8a5065100bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "logging_enabled": "loggingEnabled",
        "opt_mode": "optMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19bece2a3d4e8a4aabc12573cb097cfab0bd2bf069e1896d868e65e45cb84592)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument logging_enabled", value=logging_enabled, expected_type=type_hints["logging_enabled"])
            check_type(argname="argument opt_mode", value=opt_mode, expected_type=type_hints["opt_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if logging_enabled is not None:
            self._values["logging_enabled"] = logging_enabled
        if opt_mode is not None:
            self._values["opt_mode"] = opt_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Breadcrumbs feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def logging_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client.

        This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        '''
        result = self._values.get("logging_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def opt_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to include Breadcrumbs data in the response header.

        To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        '''
        result = self._values.get("opt_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2905cc471be6416d6a9a44bcbb89ca93be91b4da063b91326a50008c7f04bc4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLoggingEnabled")
    def reset_logging_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoggingEnabled", []))

    @jsii.member(jsii_name="resetOptMode")
    def reset_opt_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="loggingEnabledInput")
    def logging_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "loggingEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="optModeInput")
    def opt_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4fe801b22708d475ce98da3028fb8366aa345b1ac2b044d94c44bd1c783196d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__079f34ff5d7520edb0a9ab294c17d99772569bee7d01b91d0fdde491b8819bb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="loggingEnabled")
    def logging_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "loggingEnabled"))

    @logging_enabled.setter
    def logging_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4362f5c53105bbd22b356e75cbd8bf592f741e8a5e9dfdd855a7d402da5c22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loggingEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="optMode")
    def opt_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optMode"))

    @opt_mode.setter
    def opt_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262c109b232153d41b03514df1a6970333312a16666859bd90ac9bebd034b6e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__504a4d8aaa7974fc672f958735d9a401b91dd98a77ce62cbdf8fe9f20f0e8f83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d67816efb9ba0054ae0d9ba036f355bb7ff4a7c1e86805909ae1f09d76b474f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b82a47f394964ebc526a8a543e8acc0404fed2e5af832ec872d82faa31bb741)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4b705a79bb5b244723ad97a238c3f14747ca83c1098954e5cf9cf0d50d414ed)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the break connection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b516ff8647cc7d042c8111d5706f8c3e9787077ddb22de271d29f13743d168)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb79c5597b854625668043fb5e1fac3b33e8ab3b087d7150f44837f3baaf0677)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff76072456ad6aa40feb7bca4bd0b1dc168ea7fc39964866cac6d0d20fba11c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03547cd4e0f78ca0d87defba73f1c7482c40ba2e13fa9f9690f07f6deda85ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea76e1eeba864e25af800146b4f52dc8fe142bfd4702bb015f0920a74bdd3db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14606628f4d1ae00db3ac07c210dceb8e9655ccc5f63389a6aebe59d0b44ab2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a666ab792ccd6f166f137d5302b7235159ada0ea9d01cb8a8039d7e45a6d17c4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Fetches Brotli-compressed assets from your origin and caches them on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotliOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotliOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a78e1da86a790fc8c9583408575222ee8a749bb83e037c7a4adf07ae9cae094)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91088b0b963a6b3aa1b1bd3e238240c1b28a336d7dd1889d05036aaf19603a04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b754bf04a98212f4260b0611279c96b1e5250c4b428b69db467797d0c630fd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19e7e237bccb06d0c97a4a2abcf2fef0b95703909a30a31b8fe1274f7f112bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219aa60cb8a8eb046448489ba1c21ab76b68cc1c292eceeee9f5bb06a94091f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4675dcc9de31fce964821fc08cf79640c4db1cca4031f442837b10bc1aafc7be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "preserve_stale": "preserveStale",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35600f3026fa3440d1350ec7caa8210a5a23f2e4f46f533b76a0e640cc1a1cc4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preserve_stale", value=preserve_stale, expected_type=type_hints["preserve_stale"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if preserve_stale is not None:
            self._values["preserve_stale"] = preserve_stale
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates the error-caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preserve_stale(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes.

        This avoids re-fetching and re-caching content after transient errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        '''
        result = self._values.get("preserve_stale")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Overrides the default caching duration of ``10s``.

        Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e645fbf4a720cca6714e1a094b2aa0e9d3a362081f30a8c63f1b993f2d51f39c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreserveStale")
    def reset_preserve_stale(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveStale", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveStaleInput")
    def preserve_stale_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveStaleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723fb93ff21ad7a757554b42fbf662f216b60995a99b6f73572a7b1721ab1a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491173d857c5c857badd59c61488759a54a4246236abc3bd5d7b626aa7c46619)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preserveStale")
    def preserve_stale(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveStale"))

    @preserve_stale.setter
    def preserve_stale(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a62c25ce73c9bb29eec7a0af90671e7d0db44fa039526b693ace3511da1c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveStale", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d988d9b12942e7888547d8d368c15d0b29c090aecff938c1fe3996650a3f8221)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64b377f4582d491d5f06d893ad698a34731cc181be99f503bd9addd4a88f8523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fbd0b73874fb2497f5b9eb8fb600c375da30b6180b23d07cda40caba9a3d3bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1387b575e95fd2d6b6d836424f13620baa807084398d1d8792bde2e75728b697)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "include_value": "includeValue",
        "locked": "locked",
        "optional": "optional",
        "rule": "rule",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6283dbc2464542cb10a509fc7385966c0907dd8f551da123525c90f265acba3c)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument include_value", value=include_value, expected_type=type_hints["include_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optional", value=optional, expected_type=type_hints["optional"])
            check_type(argname="argument rule", value=rule, expected_type=type_hints["rule"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if include_value is not None:
            self._values["include_value"] = include_value
        if locked is not None:
            self._values["locked"] = locked
        if optional is not None:
            self._values["optional"] = optional
        if rule is not None:
            self._values["rule"] = rule
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def include_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes the value of the specified elements in the cache ID. Otherwise only their names are included.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        '''
        result = self._values.get("include_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optional(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Requires the behavior's specified elements to be present for content to cache.

        When disabled, requests that lack the specified elements are still cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        '''
        result = self._values.get("optional")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rule(self) -> typing.Optional[builtins.str]:
        '''Specifies how to modify the cache ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        '''
        result = self._values.get("rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the variable you want to include in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6403703d1472c2cd038e0b1c9b92564a15874947a92563ececc9655f6cfc0cbb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetIncludeValue")
    def reset_include_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptional")
    def reset_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptional", []))

    @jsii.member(jsii_name="resetRule")
    def reset_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRule", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="includeValueInput")
    def include_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optionalInput")
    def optional_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optionalInput"))

    @builtins.property
    @jsii.member(jsii_name="ruleInput")
    def rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ruleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c9ffea1808ef4dcbc36a82850e13d3ec95277c26e9fb65cf418335c999718fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="includeValue")
    def include_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeValue"))

    @include_value.setter
    def include_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae7cae71d735d81f73b42a2e7a33b6d92cfc266fa035b4608170522e6e075ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eb6c6d90e9beea81faab3446eac9a641695261636677d78b92cb95f095d6f55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optional")
    def optional(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optional"))

    @optional.setter
    def optional(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c56d13066ba0a616c1cc02f2b054a60b6656563aa917655619426817cdb1ed08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optional", value)

    @builtins.property
    @jsii.member(jsii_name="rule")
    def rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rule"))

    @rule.setter
    def rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20938a1cdfb518f5c8a56b06addaefffcee310975f32e8411daeeac44f5ac865)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rule", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7584f0ad7652db671fae661267d49c36f132689d4bb370a1dd2b2a26b0cd3688)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ca4ecf21f2d6c6e7352c12ec8b7439e4fc60c1e46925fc5fe8c9d3ab5d1ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4556ab8febd5cd51a1423b64a7f6bf54b7a5289093fb4d5386cadaedfaff521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0590bd1c943fc602fcd0b45e544d82c1a2a719b4d41198469420aaed46551632)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0129c8e34d23934cbeed2406d26adfbee5efd84a88f175a9863e01c48edbc7b1)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Ignores case when forming cache keys.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__192ee27dc084a7a3c43baa698b505c7c22c28fa20d1f2c26d10803aec478f918)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7c90fbf86bbce3752e826b977d02f7e3a695daf55180015e8ea54f64f24c346)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93fb7dd8286746805f0f60d9c70d6ba23527486de8589cc1541ababca32def2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b125d002418088c75f4a608316fd0fa3355af6e1ce687ebad9acf0cee954cbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d74e55479af4ec6963558e97fd9a7562b4b928b55eae8cdf1388dbda2cce0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__222fa11bb424985b130547f1ea35e057c36c8044c88ed3b9291724cb11ce03fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "exact_match": "exactMatch",
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c99213359870cc73264116610d1d981649a3eb0e056956ff33a2e98f6ab58d4d)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument exact_match", value=exact_match, expected_type=type_hints["exact_match"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if exact_match is not None:
            self._values["exact_match"] = exact_match
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Configures how sets of query string parameters translate to cache keys.

        Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exact_match(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        '''
        result = self._values.get("exact_match")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of parameter field names to include in or exclude from the cache key.

        By default, these match the field names as string prefixes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6bcfab5dbf144eab51d98b4e9d2f1fb63282a008f30c763a1af1c304a0fb29a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetExactMatch")
    def reset_exact_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExactMatch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="exactMatchInput")
    def exact_match_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "exactMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa03fcfc808067dc33e2e39e498171c4cfb09aa7db6b0d3345e03897c94d38eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="exactMatch")
    def exact_match(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "exactMatch"))

    @exact_match.setter
    def exact_match(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b66b8683414b183a0f6937f71a5a18989fa7b74599e8e7116d6a606e4621d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exactMatch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a3a116872c9f70762be2423944f176950006e18150ddc51f34cd3c7a1321a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab1f7f085cf4b9b6c6da3b86ef1039aec47052318ce6e7dc47c527ee39d785d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8a856816fddbacdd16aeb588d183cc7e318bed3c332635de5db1f9128c81a08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__686c61e22b2bc85cf0f5ed91774d9841c7e2cb5cfedce4ecd5439b4a89e3de48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c408878951f739b0a2539e243cb10d2c89cd51060683171867c0f25dc4d334d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "purge_key": "purgeKey",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__825538757376db0e797900fd94b90261899616e35af3ad672a9c2376810c8704)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument purge_key", value=purge_key, expected_type=type_hints["purge_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if purge_key is not None:
            self._values["purge_key"] = purge_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def purge_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the new cache key path as an alphanumeric value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        '''
        result = self._values.get("purge_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7d8fbfeca00becdd2276406d10933feffb10165e4ae0b3a90ff07987d05edb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPurgeKey")
    def reset_purge_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPurgeKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="purgeKeyInput")
    def purge_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "purgeKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80718b9a9063304c9fe5f71ad57e50bb505ef5803ca977a56aadfa9fe82801e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="purgeKey")
    def purge_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "purgeKey"))

    @purge_key.setter
    def purge_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae1bc8e087afd82b714d190a5ca12364d85391dffbabd4f761866f106ac9a4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "purgeKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ef4a8a77c5775f06894da5826196781e3d815fe3e1ad29bcb4e1728d9738b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eb01c5ec7159ade84cf9ab1fc92245d1aafb5b9be7bd15149f96596618a7371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3a84f875986d3d379092c0dc49ba681e937e94cd3e15c8d75d93008e2e0a54e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_body": "useBody",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__598cd951569c9dce844a9c8046dbd3755eeeb49ac4088a0294ee5b7d855b6cf7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_body", value=use_body, expected_type=type_hints["use_body"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_body is not None:
            self._values["use_body"] = use_body
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables caching of POST responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_body(self) -> typing.Optional[builtins.str]:
        '''Define how and whether to use the POST message body as a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        '''
        result = self._values.get("use_body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbbc0c3502dbc647baf46c13223a8dc39dd17907c78fc8da86d510ab3761abce)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseBody")
    def reset_use_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseBody", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useBodyInput")
    def use_body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "useBodyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0a63f19bfee63d3fc5e1c4f1a891f54d0ca71b2d88174ec53beb9eed63e480)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1864cbbb8bfa89cc1cf43f71481ade251bfe4d0cedb6e9e8c831a09043e6b00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcab72d0c4a2cd2cde035130c94da0003515ffad6d6b5cd961aac953dcd5859a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useBody")
    def use_body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "useBody"))

    @use_body.setter
    def use_body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1a48e4ffec2f93f4ce540fb86ae549f57326a5e846dbfdecd9a545831b6eaec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useBody", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__225a96039e2dfca18ff114c5017c3fa8d136e163eacb6d58b61d33ba96428608)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cb64598fc6cdffe7a4d59184e3a01627b6616294f4dac30a9ec1803b34c0ca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b7186409fb34b239cf81dec7922a731234a9a5e72659750b3d71c63fc70e3d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the redirect caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce606f53259f8cf5e18483e0b8161d38b16021e0329711505dbc2335cb78821)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7696da7d4f6253256a16da2710c4b7ae6c1778984d4712bed7e1960dc7cfc903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee85e7a1b4d90804c1152c1e485a9ca4415e85f9712a17bb3692125a4ef99a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72721acabb949107f4a10175d50dd3e50c172591c4a7990493d2c18d5b6ce0b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbd38c91996390e4da2812292cb16b7053ce744b046c470a55aa0ffc6bc3320f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__048e0ab7b9d3f7398f55361e4b6d6a038fa90a402dde2ac7b6fae9ca5857c9fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "tag": "tag",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b821728a8ab340746cda0d2795b2e931ac791fd7c2256f8017b937d0aa6b8ad)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument tag", value=tag, expected_type=type_hints["tag"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if tag is not None:
            self._values["tag"] = tag
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tag(self) -> typing.Optional[builtins.str]:
        '''Specifies the cache tag you want to add to your cached content.

        A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_``|~-]`

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        '''
        result = self._values.get("tag")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76222248fdbec7f56219e0490529cface299a5e5a4984c8e23d6aeb025830170)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTag")
    def reset_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTag", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="tagInput")
    def tag_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tagInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4417d3adcf26e4f577583ca0dddcd2b2a561d1c9239d8bd39380185a09401593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="tag")
    def tag(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tag"))

    @tag.setter
    def tag(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f08843b8b3292058ee4a3c11c7306148e1b4e54c22599ff36b36a38376af3cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tag", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__627a44fa625ca45a2c7366451f76a64263059e5f21af5bd2d12f4ce406bc9ef6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db2686dd8280fc0079acde386e0aa962898290106336dbe0d93db5f305c0157)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c1a36d57be609d01f13a36110ea569f5797355058d8d5ed60744e3e0161e15f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e2c880ec31a1bddacd5484bcfc2edad2ae7f29e27d98c721f936470f6544aa6)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specifies when to include the ``Edge-Cache-Tag`` in responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a5dd0b36c7038f39e5bc630dc6885989173395300e35d8c4caf1b1a06b29b67)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07e2bb2f466a81af86082f0b82b318d513b59ee84f3ee7b3a19296fe2e3f20e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00697b576302e0d5f8d032013a172ca5ad854eb3d757eee77b3d1460c3b99d2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b71320b07071be4dfaabe96860c472548a8b7bc78ff817c94f1688fffd8d7015)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4366b29477837c88e375f2d08da4d2bf53c72829c26dba95e3e36a3ff20b1b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37a46c6b6e36136b3188232810f4effeaf73a5d0cb585be044bdeb238dbee722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "cacheability_settings": "cacheabilitySettings",
        "cache_control_directives": "cacheControlDirectives",
        "default_ttl": "defaultTtl",
        "enhanced_rfc_support": "enhancedRfcSupport",
        "expiration_settings": "expirationSettings",
        "honor_max_age": "honorMaxAge",
        "honor_must_revalidate": "honorMustRevalidate",
        "honor_no_cache": "honorNoCache",
        "honor_no_store": "honorNoStore",
        "honor_private": "honorPrivate",
        "honor_proxy_revalidate": "honorProxyRevalidate",
        "honor_s_maxage": "honorSMaxage",
        "locked": "locked",
        "must_revalidate": "mustRevalidate",
        "revalidation_settings": "revalidationSettings",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e54738d287eb02db48994035c014198315129c9bdf402397a44161c132d45ee)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument cacheability_settings", value=cacheability_settings, expected_type=type_hints["cacheability_settings"])
            check_type(argname="argument cache_control_directives", value=cache_control_directives, expected_type=type_hints["cache_control_directives"])
            check_type(argname="argument default_ttl", value=default_ttl, expected_type=type_hints["default_ttl"])
            check_type(argname="argument enhanced_rfc_support", value=enhanced_rfc_support, expected_type=type_hints["enhanced_rfc_support"])
            check_type(argname="argument expiration_settings", value=expiration_settings, expected_type=type_hints["expiration_settings"])
            check_type(argname="argument honor_max_age", value=honor_max_age, expected_type=type_hints["honor_max_age"])
            check_type(argname="argument honor_must_revalidate", value=honor_must_revalidate, expected_type=type_hints["honor_must_revalidate"])
            check_type(argname="argument honor_no_cache", value=honor_no_cache, expected_type=type_hints["honor_no_cache"])
            check_type(argname="argument honor_no_store", value=honor_no_store, expected_type=type_hints["honor_no_store"])
            check_type(argname="argument honor_private", value=honor_private, expected_type=type_hints["honor_private"])
            check_type(argname="argument honor_proxy_revalidate", value=honor_proxy_revalidate, expected_type=type_hints["honor_proxy_revalidate"])
            check_type(argname="argument honor_s_maxage", value=honor_s_maxage, expected_type=type_hints["honor_s_maxage"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument must_revalidate", value=must_revalidate, expected_type=type_hints["must_revalidate"])
            check_type(argname="argument revalidation_settings", value=revalidation_settings, expected_type=type_hints["revalidation_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if cacheability_settings is not None:
            self._values["cacheability_settings"] = cacheability_settings
        if cache_control_directives is not None:
            self._values["cache_control_directives"] = cache_control_directives
        if default_ttl is not None:
            self._values["default_ttl"] = default_ttl
        if enhanced_rfc_support is not None:
            self._values["enhanced_rfc_support"] = enhanced_rfc_support
        if expiration_settings is not None:
            self._values["expiration_settings"] = expiration_settings
        if honor_max_age is not None:
            self._values["honor_max_age"] = honor_max_age
        if honor_must_revalidate is not None:
            self._values["honor_must_revalidate"] = honor_must_revalidate
        if honor_no_cache is not None:
            self._values["honor_no_cache"] = honor_no_cache
        if honor_no_store is not None:
            self._values["honor_no_store"] = honor_no_store
        if honor_private is not None:
            self._values["honor_private"] = honor_private
        if honor_proxy_revalidate is not None:
            self._values["honor_proxy_revalidate"] = honor_proxy_revalidate
        if honor_s_maxage is not None:
            self._values["honor_s_maxage"] = honor_s_maxage
        if locked is not None:
            self._values["locked"] = locked
        if must_revalidate is not None:
            self._values["must_revalidate"] = must_revalidate
        if revalidation_settings is not None:
            self._values["revalidation_settings"] = revalidation_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cacheability_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        '''
        result = self._values.get("cacheability_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_control_directives(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        '''
        result = self._values.get("cache_control_directives")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_ttl(self) -> typing.Optional[builtins.str]:
        '''Set the ``MAX_AGE`` header for the cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        '''
        result = self._values.get("default_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enhanced_rfc_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        '''
        result = self._values.get("enhanced_rfc_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        '''
        result = self._values.get("expiration_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def honor_max_age(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        '''
        result = self._values.get("honor_max_age")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        '''
        result = self._values.get("honor_must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_cache(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request.

        Effectively, set the time to live ``ttl`` to zero seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        '''
        result = self._values.get("honor_no_cache")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        '''
        result = self._values.get("honor_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers not to cache the response when the origin response includes the ``private`` directive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        '''
        result = self._values.get("honor_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_proxy_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        '''
        result = self._values.get("honor_proxy_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def honor_s_maxage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response.

        When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        '''
        result = self._values.get("honor_s_maxage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def must_revalidate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin.

        If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        '''
        result = self._values.get("must_revalidate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def revalidation_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        '''
        result = self._values.get("revalidation_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''The maximum time content may remain cached.

        Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110bf3382f2bffbc2966175aff70188e1716f1ad180e0dd0057d477e201b5ffa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetCacheabilitySettings")
    def reset_cacheability_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheabilitySettings", []))

    @jsii.member(jsii_name="resetCacheControlDirectives")
    def reset_cache_control_directives(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheControlDirectives", []))

    @jsii.member(jsii_name="resetDefaultTtl")
    def reset_default_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultTtl", []))

    @jsii.member(jsii_name="resetEnhancedRfcSupport")
    def reset_enhanced_rfc_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedRfcSupport", []))

    @jsii.member(jsii_name="resetExpirationSettings")
    def reset_expiration_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationSettings", []))

    @jsii.member(jsii_name="resetHonorMaxAge")
    def reset_honor_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMaxAge", []))

    @jsii.member(jsii_name="resetHonorMustRevalidate")
    def reset_honor_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorMustRevalidate", []))

    @jsii.member(jsii_name="resetHonorNoCache")
    def reset_honor_no_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoCache", []))

    @jsii.member(jsii_name="resetHonorNoStore")
    def reset_honor_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorNoStore", []))

    @jsii.member(jsii_name="resetHonorPrivate")
    def reset_honor_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorPrivate", []))

    @jsii.member(jsii_name="resetHonorProxyRevalidate")
    def reset_honor_proxy_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorProxyRevalidate", []))

    @jsii.member(jsii_name="resetHonorSMaxage")
    def reset_honor_s_maxage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHonorSMaxage", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMustRevalidate")
    def reset_must_revalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMustRevalidate", []))

    @jsii.member(jsii_name="resetRevalidationSettings")
    def reset_revalidation_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevalidationSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettingsInput")
    def cacheability_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheabilitySettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectivesInput")
    def cache_control_directives_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheControlDirectivesInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultTtlInput")
    def default_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "defaultTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupportInput")
    def enhanced_rfc_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enhancedRfcSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationSettingsInput")
    def expiration_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMaxAgeInput")
    def honor_max_age_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidateInput")
    def honor_must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorMustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoCacheInput")
    def honor_no_cache_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="honorNoStoreInput")
    def honor_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="honorPrivateInput")
    def honor_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidateInput")
    def honor_proxy_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorProxyRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="honorSMaxageInput")
    def honor_s_maxage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "honorSMaxageInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mustRevalidateInput")
    def must_revalidate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mustRevalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="revalidationSettingsInput")
    def revalidation_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "revalidationSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f2e7e838202eadc266fdbf6f732200277e555d54f3efc92d5b55a1429bbbbc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="cacheabilitySettings")
    def cacheability_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheabilitySettings"))

    @cacheability_settings.setter
    def cacheability_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9156e01c075d7d6a4d651a7953c431531e01d2899e56b9fc06d4e750f805c528)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheabilitySettings", value)

    @builtins.property
    @jsii.member(jsii_name="cacheControlDirectives")
    def cache_control_directives(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheControlDirectives"))

    @cache_control_directives.setter
    def cache_control_directives(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c65514b507b6159ce344c1d028ec5a789c9f784f54f6393f4496334da3f610c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheControlDirectives", value)

    @builtins.property
    @jsii.member(jsii_name="defaultTtl")
    def default_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "defaultTtl"))

    @default_ttl.setter
    def default_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e1f1a3b05afc140e0953a30fce217f181d87cc1e93445f934f56cf270261daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultTtl", value)

    @builtins.property
    @jsii.member(jsii_name="enhancedRfcSupport")
    def enhanced_rfc_support(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enhancedRfcSupport"))

    @enhanced_rfc_support.setter
    def enhanced_rfc_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63fbe5f36db092ebdc11325019a7eb195e348a8e244e567998cefdb0816823be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enhancedRfcSupport", value)

    @builtins.property
    @jsii.member(jsii_name="expirationSettings")
    def expiration_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationSettings"))

    @expiration_settings.setter
    def expiration_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6cdbd70846014ad7c062f44c558b322a94e0e6551328d826afbc06d73ac81ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="honorMaxAge")
    def honor_max_age(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMaxAge"))

    @honor_max_age.setter
    def honor_max_age(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b3217ef096eccca7ecb998d764069a5c3faa58f394fe9c451f1d146681fdec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="honorMustRevalidate")
    def honor_must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorMustRevalidate"))

    @honor_must_revalidate.setter
    def honor_must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1beebf2e3804d6de03ea881cdc37b86ae28c601ebcb59d6802e934b6ab0267d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorMustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoCache")
    def honor_no_cache(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoCache"))

    @honor_no_cache.setter
    def honor_no_cache(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33506ad5c44b90620eb6c8d4e1e22acf8ebf34564ff612521dc527f67c91dd17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoCache", value)

    @builtins.property
    @jsii.member(jsii_name="honorNoStore")
    def honor_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorNoStore"))

    @honor_no_store.setter
    def honor_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f9d09b773adbfefc5a879922daeac0937c8e6dc615d84a0313bb2ea39fed9ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="honorPrivate")
    def honor_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorPrivate"))

    @honor_private.setter
    def honor_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40e64148793132c016241555b1e08d6bde65c1f054e811c0ce4bd334c76ceb83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="honorProxyRevalidate")
    def honor_proxy_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorProxyRevalidate"))

    @honor_proxy_revalidate.setter
    def honor_proxy_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94a58bd7720197e685dee6c294a0c1d3d5e0ed342434cdbd4a79b79e3c9ab835)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorProxyRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="honorSMaxage")
    def honor_s_maxage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "honorSMaxage"))

    @honor_s_maxage.setter
    def honor_s_maxage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68164bb89a322b9f7f5b070444b1152fe74206f22402a0493e27786e9bc2111d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "honorSMaxage", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d65882d069d2cda7648692b9e783122fa64ee6b0de2d9ee3df12ac68299e4abf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mustRevalidate")
    def must_revalidate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mustRevalidate"))

    @must_revalidate.setter
    def must_revalidate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29ff4f6bda44a4cee9c22a531c8fe3c9d7c11edde26d580420ba3b5bcab8351f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mustRevalidate", value)

    @builtins.property
    @jsii.member(jsii_name="revalidationSettings")
    def revalidation_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "revalidationSettings"))

    @revalidation_settings.setter
    def revalidation_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce0f236d3a713bbe5261e51cf315eecb65b4105d1fe0d75793ba896e8891de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revalidationSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd186a3ad211a65356db89143303ab7181a51a4451c057d046033332186d1500)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eeb2cd2756eb672c710ffd1bc136445998afcd3c2ab92ea9e73898cd5d09777)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__426a111c3167ba15cdafcbf1c8c627d94cbe33ae644075c068f96b167cd3e208)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8662d8a7391b504446da42a6f03e69276a3e28baa6749923affd225c06a29b48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23404900324bcddf06dfcd7a312746f1a82275954ef5caca0c502ef619824e36)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the centralized authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1dd6de6d032d8a89b7fff3dc68ecbe2164a56a15b2455315d2cf4c10eecbf2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7005cb69693cf165445482713ed73296f194a89afeb9761f4e3f7c16685003)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9778ce239330161cc21160a77646b480c0744ed51b775d97e792ac872b083aea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e344363a4fe827a52cc0cb6f65ef7d3c4000557abc436b607ccb4642fa106b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48da7b96a3f95af1c0278fdb89e48b9fc566e6f3e301048c2acc1d142650260b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b19394fca0149d9026442aa49520c661232796e13b6d687aca2c3c9ba444ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "limit": "limit",
        "locked": "locked",
        "serve404": "serve404",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9331747901280a6e44e92b7298c10508288d50ea07044ab427819e4d024d279a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serve404", value=serve404, expected_type=type_hints["serve404"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if limit is not None:
            self._values["limit"] = limit
        if locked is not None:
            self._values["locked"] = locked
        if serve404 is not None:
            self._values["serve404"] = serve404
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to chase redirects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def limit(self) -> typing.Optional[builtins.str]:
        '''Specifies, as a string, the maximum number of redirects to follow.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serve404(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        '''
        result = self._values.get("serve404")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c34e922bb17bb0fb5c1b6edd1f8a18f8c6c252502a3b66cdd644c401ff3a2d48)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServe404")
    def reset_serve404(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServe404", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serve404Input")
    def serve404_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "serve404Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9bb6e35795d3040e2764e10909f8f273dcc17e5cc47012d67d5a73e357e443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7727e220e00bbdcc67de06fd5aa3b867b63b62ca280d522eb1c90270bb5a6c59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6fd9dfbf1cddffe676aea8eabe3820e664ad30a64511be47c7225a8b4fe44ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serve404")
    def serve404(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "serve404"))

    @serve404.setter
    def serve404(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270e46d36548d5f18f5c4b423b108ffc0d74e8de8351983f04425b708d625a8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serve404", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57522d83620f9413a92bedd31410c6820d2f5379ca87cd0715f5d5a5d0a9d800)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddab63cceea0d4f06e20263c395206b51666891f4c7fdf71956aca78f1a4bf7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75b1a86718900d24098658cbf0525355312a804b7a6e60a771b9a1e4d4f51dad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth",
    jsii_struct_bases=[],
    name_mapping={
        "client_certificate_attributes": "clientCertificateAttributes",
        "enable": "enable",
        "enable_client_certificate_validation_status": "enableClientCertificateValidationStatus",
        "enable_complete_client_certificate": "enableCompleteClientCertificate",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth:
    def __init__(
        self,
        *,
        client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param client_certificate_attributes: Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        :param enable: Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param enable_client_certificate_validation_status: Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        :param enable_complete_client_certificate: Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee647821f09bee04711d39484fb896be888398bf6d93b31177f8406a1e32a073)
            check_type(argname="argument client_certificate_attributes", value=client_certificate_attributes, expected_type=type_hints["client_certificate_attributes"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument enable_client_certificate_validation_status", value=enable_client_certificate_validation_status, expected_type=type_hints["enable_client_certificate_validation_status"])
            check_type(argname="argument enable_complete_client_certificate", value=enable_complete_client_certificate, expected_type=type_hints["enable_complete_client_certificate"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if client_certificate_attributes is not None:
            self._values["client_certificate_attributes"] = client_certificate_attributes
        if enable is not None:
            self._values["enable"] = enable
        if enable_client_certificate_validation_status is not None:
            self._values["enable_client_certificate_validation_status"] = enable_client_certificate_validation_status
        if enable_complete_client_certificate is not None:
            self._values["enable_complete_client_certificate"] = enable_complete_client_certificate
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def client_certificate_attributes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        '''
        result = self._values.get("client_certificate_attributes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin.

        You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_client_certificate_validation_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header.

        This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        '''
        result = self._values.get("enable_client_certificate_validation_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_complete_client_certificate(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to include the complete client certificate in the header, in its binary (DER) format.

        DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        '''
        result = self._values.get("enable_complete_client_certificate")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8e85045ab9f656f1d6f08222d43ff3c9b67eb62e3a6c8ed181bddf492c9bad7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetClientCertificateAttributes")
    def reset_client_certificate_attributes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificateAttributes", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetEnableClientCertificateValidationStatus")
    def reset_enable_client_certificate_validation_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableClientCertificateValidationStatus", []))

    @jsii.member(jsii_name="resetEnableCompleteClientCertificate")
    def reset_enable_complete_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCompleteClientCertificate", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAttributesInput")
    def client_certificate_attributes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "clientCertificateAttributesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableClientCertificateValidationStatusInput")
    def enable_client_certificate_validation_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableClientCertificateValidationStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCompleteClientCertificateInput")
    def enable_complete_client_certificate_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCompleteClientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAttributes")
    def client_certificate_attributes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "clientCertificateAttributes"))

    @client_certificate_attributes.setter
    def client_certificate_attributes(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eedae5aaf664dcb1d9bef929aa7f79770d8dac62205b5c2b3ad613d203cbca1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientCertificateAttributes", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d77ab3a449bcc895401f05fdd4a0b8b2db47454f91905316365c4d4d09abd724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="enableClientCertificateValidationStatus")
    def enable_client_certificate_validation_status(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableClientCertificateValidationStatus"))

    @enable_client_certificate_validation_status.setter
    def enable_client_certificate_validation_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acedfd9e62b177dc3d433a263e1653136d22f1165f763451a875a0a6e4ec37d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableClientCertificateValidationStatus", value)

    @builtins.property
    @jsii.member(jsii_name="enableCompleteClientCertificate")
    def enable_complete_client_certificate(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCompleteClientCertificate"))

    @enable_complete_client_certificate.setter
    def enable_complete_client_certificate(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8eadae9282668c7ea78b02d69c4cc1c55721463a0eb74a2a7a52d6a34a432f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCompleteClientCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd40a33b8ab59eeff7cf2973ea2075d30ae60b9b151a7f94548ebc361affa22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50eec85ff32551b6c5efd18369c504063f42ddfde2719ff1e81ae246a5346975)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ff5fadac6f4c158a8fa5a42db32e6dacb2e8853ca356353146aeb2832c24def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f92c923dd8c567c85aebe8df75d31d51eb16204bf4eb510b5c6088b46fb5f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "country": "country",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics:
    def __init__(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d919a4577f4c80ea938d166df2d322d7d8c145621dd3a9dcf5dd7a61f2fde810)
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if country is not None:
            self._values["country"] = country
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the client request's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a56291ee1ba934c57832a31fc30d9b5d31d7622acd1ed713c7b90aff05ace06f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97b8a35b29e4d6693951f835101070d399032906f9096da6761496923dfd998c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c15939625c97bb4974ac7482515d415fbb9289216f4b26e4eab4b413bb225fda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__833b76b8dd07a0b27a7084c97e5e5c9a0c0f6f0c44df97ed36c800285ad0c824)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__746d81d32590450e6622371df08f76f32695727ee4655ee9c2f79498e62e642a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f5f256f9f2687d2c06c24d8aa2955615c5cb82c9b2404f0ed08bc7face8f45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects",
    jsii_struct_bases=[],
    name_mapping={
        "cloud_locations": "cloudLocations",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects:
    def __init__(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61bc03fbc40271e63bf2e34e1bc8c226a91ff60e177ed7166595e170db818340)
            check_type(argname="argument cloud_locations", value=cloud_locations, expected_type=type_hints["cloud_locations"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloud_locations is not None:
            self._values["cloud_locations"] = cloud_locations
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloud_locations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the geographical locations of your cloud origin.

        You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        '''
        result = self._values.get("cloud_locations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Channels the traffic to maximize the egress discount at the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__afa1e8c8925573efb45e010c008e6e829aabb02d6e5ed67c42f97dc474371927)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudLocations")
    def reset_cloud_locations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudLocations", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudLocationsInput")
    def cloud_locations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cloudLocationsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudLocations")
    def cloud_locations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cloudLocations"))

    @cloud_locations.setter
    def cloud_locations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__310943d9fdc9c0b63cea3b9b250af8e3a35d8e2f7015f926604e2190f0804135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudLocations", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__860416d7e89b93b87a214f5748a1e56ec0d96254a660500474694dbafa106624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92c28e164ae19f03e6fe97b5d757fda9e9f8ac07cbdf63a911cc095d8ab4a633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8cba5df39a21485a6a58ed8903bfaae64453f27c64c65843d3888e16613df41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8191c8fc44e8b134688288e61361ff5197c4baeea2c256fe0af07d8448acb98c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93e16fe7c603bfa75f452382f25a8cdad48c2b6e3705ad83904643e82a8c5ad9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "location": "location",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48e1f32d0b7007bae54ce1f01eb9c692580069eebd5b44025de909f7b07c321)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Wrapper behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''The location you want to distribute your Cloud Wrapper cache space to.

        This behavior allows all locations configured in your Cloud Wrapper configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "custom_failover_map": "customFailoverMap",
        "enabled": "enabled",
        "failover_map": "failoverMap",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced:
    def __init__(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d9deabaaf904f0c8b797358ea3c9b359cdf26a5094445df64eaf39d3da07bb)
            check_type(argname="argument custom_failover_map", value=custom_failover_map, expected_type=type_hints["custom_failover_map"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_map", value=failover_map, expected_type=type_hints["failover_map"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_failover_map is not None:
            self._values["custom_failover_map"] = custom_failover_map
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_map is not None:
            self._values["failover_map"] = failover_map
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        '''
        result = self._values.get("custom_failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables failover for Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_map(self) -> typing.Optional[builtins.str]:
        '''Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        '''
        result = self._values.get("failover_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9908de47c41280f9b3f130771d38389afcc2b4d5781bd64c393208f09563bf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomFailoverMap")
    def reset_custom_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomFailoverMap", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverMap")
    def reset_failover_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverMap", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMapInput")
    def custom_failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customFailoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverMapInput")
    def failover_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverMapInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customFailoverMap")
    def custom_failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customFailoverMap"))

    @custom_failover_map.setter
    def custom_failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3f8f1020cfee5a2b9b2313cd37211d852ff07d32df9f8888b8849a5693b779b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customFailoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c553eb062d1c26f17c582b54fead7371cc009aa5ea19d9f0beb0de3ac47585e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverMap")
    def failover_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverMap"))

    @failover_map.setter
    def failover_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__987ab49130e322b50aec408eeafd64983d5e9f8dbcf7976da5d32ed1c9e1ccaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverMap", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7a8d5245bb549867dd9af91d260e145c4dff5b945868ecefa70d29727a042f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ceef25ad0b90477e1d3f557b8b4fad5ca8759daced4bc112fdbb4625ee4debf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3383c2926fb8b582fa85d0f74701e68eb30e85ecf6367913c901ac2209ece1e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8a9a10c304e64ef05c91e710f5f1e677d4067d81f3b1b3235b24639247d94a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__303fe067bb79610e2dca96e1cfee83c6e14e26abefabf360b9c0bf2d81de32e2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f1b532320d96d6a7b04c39b039d3faa4404598de4c14f878ad5e4a25eaa39d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db14336bc6f963273cbcaf10fa92d69598b76e1a6e8891c37b4c3e9d9d0e9aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fd5e8dba5297216cb4a0d40682a2c1f737154730fdc92509dc6d22092fbbf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b51a6ad1933f2ac703b4541cba38b391fad6be1c28a37f1bda1bec695af6d931)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5bfce05ecbd3436ac040a99f8b59dc8da168c2fba3e1914a88d9939c22ada61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8991f46b7f2f2751098a4a61c6d2b0e0b213383aca2926c2802b623880e6cacb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData",
    jsii_struct_bases=[],
    name_mapping={
        "enable_cmcd_segment_prefetch": "enableCmcdSegmentPrefetch",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData:
    def __init__(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c603a0aceaca1f4d59dd8af2ae08e87a5a35109033756fa8589a2b4ffcb2b6)
            check_type(argname="argument enable_cmcd_segment_prefetch", value=enable_cmcd_segment_prefetch, expected_type=type_hints["enable_cmcd_segment_prefetch"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_cmcd_segment_prefetch is not None:
            self._values["enable_cmcd_segment_prefetch"] = enable_cmcd_segment_prefetch
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        '''
        result = self._values.get("enable_cmcd_segment_prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a69d4a203e8776ec0b2566e82eb7c4c7b4488774ecb95914dfcf0fa3d9710f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableCmcdSegmentPrefetch")
    def reset_enable_cmcd_segment_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCmcdSegmentPrefetch", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetchInput")
    def enable_cmcd_segment_prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCmcdSegmentPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCmcdSegmentPrefetch")
    def enable_cmcd_segment_prefetch(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCmcdSegmentPrefetch"))

    @enable_cmcd_segment_prefetch.setter
    def enable_cmcd_segment_prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de9035d5c0e680f0d77920c8c02945db60a3edb47db3cfc596cd5db32618c9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCmcdSegmentPrefetch", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b676a9f464c763c0147a587e5e85f2e8762c403a2e48d22104e090aa30a0ec2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac77a79ff1cb5f6d6fd3a5e502bf3aca179cf12859422d68125d83e2a0ce50af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1d320f6b7ff460f1ffe21889a3681c2fdfc6e879b37232ab9ae39717b4a2e8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281fdd0e14759cc3ad8f52c5cae5d85116d991effc2fa0d1c13ca5e37744f96a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d44e3f319888ab59cd3f9471714a8ec78515bd8d239291ccd8197f4c340416f)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.'''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2e84740a1a4499da0502355a87b808ab78ff06574e506218b6190d60168ece6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f95050e3f6cad519882f74aca4343256e207b9884490494a9c756007094ca89e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7499715c8025181aa456193603d1c0999bd20002ff2be5fb0373b79f9b33449)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__291ab059ca29d77d3f60034df665db32baa16ce29e80e72fbf2f71ff3f0b207b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5561dfa5fcd0c33b50f56008e6db0bb2d5a9b8aff6ad97ec618b7afdb4f0495)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b062fa13a4fa8ea1a891f383e66f95a7fced7707aa40301df431c5ba2896ccbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse",
    jsii_struct_bases=[],
    name_mapping={
        "body": "body",
        "enabled": "enabled",
        "force_eviction": "forceEviction",
        "ignore_purge": "ignorePurge",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse:
    def __init__(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6b23e26ac6d83321b081cb9e3b70e3bad3823d7a889bed83276a0bd7f10f0c8)
            check_type(argname="argument body", value=body, expected_type=type_hints["body"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_eviction", value=force_eviction, expected_type=type_hints["force_eviction"])
            check_type(argname="argument ignore_purge", value=ignore_purge, expected_type=type_hints["ignore_purge"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if body is not None:
            self._values["body"] = body
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_eviction is not None:
            self._values["force_eviction"] = force_eviction
        if ignore_purge is not None:
            self._values["ignore_purge"] = ignore_purge
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def body(self) -> typing.Optional[builtins.str]:
        '''HTML response of up to 2000 characters to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        '''
        result = self._values.get("body")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Serves the custom response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_eviction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        '''
        result = self._values.get("force_eviction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_purge(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to ignore the custom response when purging.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        '''
        result = self._values.get("ignore_purge")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP response code to send to the end-user client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__254ba6afda9fbb5d62aac6510a4996835d755baa4194a5f04ec7e9bee6d7a083)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBody")
    def reset_body(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBody", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceEviction")
    def reset_force_eviction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceEviction", []))

    @jsii.member(jsii_name="resetIgnorePurge")
    def reset_ignore_purge(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnorePurge", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bodyInput")
    def body_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bodyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceEvictionInput")
    def force_eviction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceEvictionInput"))

    @builtins.property
    @jsii.member(jsii_name="ignorePurgeInput")
    def ignore_purge_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignorePurgeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="body")
    def body(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "body"))

    @body.setter
    def body(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d302f961a5903faec4a9fd37b66863696deff5b8c60f55e18610ad686f78d91e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "body", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2bf3c63a9355ef8827aafd87cf8c95026240977c52fbded836ead3a51d8f9f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceEviction")
    def force_eviction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceEviction"))

    @force_eviction.setter
    def force_eviction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd22d75e0c37d2aaa73945fcf7db3125699e445c5392306c6a599e7fa9166a86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceEviction", value)

    @builtins.property
    @jsii.member(jsii_name="ignorePurge")
    def ignore_purge(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignorePurge"))

    @ignore_purge.setter
    def ignore_purge(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6374431d39c8e334567f3be731af66191c2e2b9f84a4da6493fbfe0b27393bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignorePurge", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e46779535e2b66e11bc1cca6c7841a2a2ba965f06d2c2718bfa7571836afb05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__946d254a7ea6fce27b60298fa0e7da7c48d8668aa3179d6e33c54740a1fe0d1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3618ffaf4a2de588ef54744abdfc775b3bdc6aa7b0e478e1ee60d8238b70e887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7809f6c86be32452c880ec6517a3f35ffb13ae5807d56c9e31a5cd459c1ae5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e09430d574c6f9d154d40880ec9f851ef50bdedf598cf4d30aff57c614c6b6dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__094fe25151123bde365520f050efa460a24bad3525c67dd88944466e35d88c2c)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_dash_custom": "segmentDurationDashCustom",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hds_custom": "segmentDurationHdsCustom",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_hls_custom": "segmentDurationHlsCustom",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_duration_smooth_custom": "segmentDurationSmoothCustom",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12505f985f83f9604e969d3ad883794f7dbe46e1046007453309418b1a74631a)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_dash_custom", value=segment_duration_dash_custom, expected_type=type_hints["segment_duration_dash_custom"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hds_custom", value=segment_duration_hds_custom, expected_type=type_hints["segment_duration_hds_custom"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_hls_custom", value=segment_duration_hls_custom, expected_type=type_hints["segment_duration_hls_custom"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_duration_smooth_custom", value=segment_duration_smooth_custom, expected_type=type_hints["segment_duration_smooth_custom"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_dash_custom is not None:
            self._values["segment_duration_dash_custom"] = segment_duration_dash_custom
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hds_custom is not None:
            self._values["segment_duration_hds_custom"] = segment_duration_hds_custom
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_hls_custom is not None:
            self._values["segment_duration_hls_custom"] = segment_duration_hls_custom
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_duration_smooth_custom is not None:
            self._values["segment_duration_smooth_custom"] = segment_duration_smooth_custom
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        '''
        result = self._values.get("segment_duration_dash_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        '''
        result = self._values.get("segment_duration_hds_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the segment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        '''
        result = self._values.get("segment_duration_hls_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth_custom(self) -> typing.Optional[jsii.Number]:
        '''Customizes the number of seconds for the fragment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        '''
        result = self._values.get("segment_duration_smooth_custom")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9258470aa6bda82b2752394930f8527b65cf3471531ff2acb8d64e5d69f9ae60)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationDashCustom")
    def reset_segment_duration_dash_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDashCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHdsCustom")
    def reset_segment_duration_hds_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHdsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationHlsCustom")
    def reset_segment_duration_hls_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHlsCustom", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentDurationSmoothCustom")
    def reset_segment_duration_smooth_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmoothCustom", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustomInput")
    def segment_duration_dash_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationDashCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustomInput")
    def segment_duration_hds_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHdsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustomInput")
    def segment_duration_hls_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationHlsCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustomInput")
    def segment_duration_smooth_custom_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationSmoothCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0473fb6c5b5629de343216482db5932ed312a936d709ad79da594a0a33a8df07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aff5a438beaf3c315a8c5fc0aad269943a5fa84bdf6eda8e545e0063803f7e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fc606e3372f768e53238bfd66e65e74d7aa911653a917b34b82fbdb2ff58070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3123b5229d3e3c2493a9e100c74a479ad9b0b17a4a624fe85e98f0402dd3814f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae509aca154e762ccdd2bbe29dcdddaefb962d92313b9258dd0ed4fecd723e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607ee54a7f21790e026cebd508415793d4410be2f37b614bb4c532bfb3b237a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784c9fa8d88a509372edd8ca0c4bf9f285143aceb867c8adb0dbb45893b37c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adb8d4457e8a8ee7b4d98b7e7fd644383180ab3ba5278e5e9e863d223806254c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashCustom")
    def segment_duration_dash_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationDashCustom"))

    @segment_duration_dash_custom.setter
    def segment_duration_dash_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc4b6bafc8296bf9ef86de16c0f9810e008032cac230f08442b10f94d971b46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDashCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dac17f03b6577938648b16bac268571221de1670ef206e3e5e1437f91abb2dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsCustom")
    def segment_duration_hds_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHdsCustom"))

    @segment_duration_hds_custom.setter
    def segment_duration_hds_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3e94c96ecd6fc8d3bfd1446be7b2023537e2247c660c8041df6905b463ce09c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHdsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72abfead25bc65f3ad4841322d66fd1acc59a871c7cfc6c02368d91409fbb22a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsCustom")
    def segment_duration_hls_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationHlsCustom"))

    @segment_duration_hls_custom.setter
    def segment_duration_hls_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3247be488c34b4450edfe9c9ac2dba1fdac60fc84f50e73073d0d97f234e0a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHlsCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb675387dfada228b0bfb568b71522170725e359c011df6db4200b89aa872190)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothCustom")
    def segment_duration_smooth_custom(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDurationSmoothCustom"))

    @segment_duration_smooth_custom.setter
    def segment_duration_smooth_custom(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17e0ee808e0a7b1ae3e0a4b9aa250a878c8da355bbd228de9bf8141cfe92731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmoothCustom", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3ed90a71e1d4925c680704ceba6797cbb13fb3cd1207381ce8a1f63d236f35d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c1ab4f3b32683ba08e358b2ca350046284a12d176a4e23e9ca5d70ceb7a1b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9dc349a336dd9b8947bacb8c973689c149d8fc5ecad1c9c0d1d333a7042848f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4600b5b3373c5d16adb5fe3da54bc1d60b794297c67ce0aa454415a364f7b0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd60a361dec9614e0b62773d2267612bf4cb3678e04618a336e74651ad2704cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b0b7f27582c9cc209b56b6aad1301a3d74b37221defdc9b5463880958fc95bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b997209716b743febe2507df0befce4249dde12359ada97e0819cd41bfc6738d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5df1da94cfdb5264d4fcacf3bbfd9d7991f60c6c4a66a9e8112a2bb9e40e541f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "optimize_option": "optimizeOption",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e575245db0af3c8eb07bebb6b164e40c8e30f8e9e2811b12d070a4e07d54f9f6)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_option", value=optimize_option, expected_type=type_hints["optimize_option"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_option is not None:
            self._values["optimize_option"] = optimize_option
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_option(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes the delivery throughput and download times for large files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        '''
        result = self._values.get("optimize_option")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45fb70a403a17ce74807968cbb2ed39128dd6dcd5657f27327381d48deff40e9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeOption")
    def reset_optimize_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeOption", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeOptionInput")
    def optimize_option_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "optimizeOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bce40e4962420a84a4076f6a66312a87e58fce8850020e10bdd344b5a3b895f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29a4b9ec01d5ed5b8648d8edcf5f6cdc89547069f2439e84ee80a9f6b0ba338a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba91f00df2fc2090c83b67fbfe1c49dcacc227d6763804184b3cde72bffc09b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c6ef1181e025cde72a23d18c11f7679d51ee84b90638b01e9e08779614791e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeOption")
    def optimize_option(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "optimizeOption"))

    @optimize_option.setter
    def optimize_option(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c0da9f73f9ce9e4bad9925edf13387a508e4a098c31b7ffd7a1712d9ffb8396)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeOption", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a167ab4b42266cf206a08f71d3f6c12baa42273c1df178daf0ea9554d7a2f1a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__652b1b29e9e0e5b15e41a9903509c1d18b3642adb2cb91c34e87eb2282f72575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdf9a07fd26e5c46e04c8af65fda96f8837b156fc5ee05dc88553982f32108e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a6acbf2528fabfdd0adf7d1beb2e93a786b54181e7d79497104c21ef79cb28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eba95ed3438f1a8fa2c54be02fcc5bb28032b367a8d574b7273ea76ee3924cc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6074bd17182c11df49054524946dacd6ece345dd0a9030198391939c160fdb28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f431497bc426877c1661b43d4b40c884c44f8a4048a4c1db6fd831222c7e65d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c74ae1cf38ef235238778395f9ecebe46ab6826c72617d338c188b300d1cfb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b859a9e0059a9d9cab5f5f17f909653fb2678a03c54d29b6a7de9b32be66b179)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__552aee1e29d62cd64b0dbf5578f9d094b0b6143d53152107af397deddae4fd70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__069f12816b4b8fd72be7fa4e98c56ec5834a94e8ad83fecddea46eca03551ef0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__328916e2783ef7ab7b4d850e536500cd7950597c459a5262fe955c62afd40096)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14258d55af9b9811ab7be0bcadeb23fbaa3f9d6c179d09b4f943454de0cdc69e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "locked": "locked",
        "object_size": "objectSize",
        "popularity_distribution": "popularityDistribution",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4f01d2ec15c1b44d0d70b9bec1f8e9b0fce2b297cadadaee368e23414a22b33)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the type of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the size of the object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0174ff21d12e2c4fd1fc2b621e695c11a0c75a3ad8324413352e2c87f213f47b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92a9900b838ae71d02d477941374869823c53b74baa5b3bd61df78cd4243a1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a25d80583c0b993020dab9eb9be61d639a851dce0507233d43aa200152305168)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a99fdfbf92a5c9838a31e11262669886bed0e0c3e2c35d00877b2556b5205ab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7b02a713e2e3e2b782ff824a86d809493f346c2ffc9b49d786952dc53943ec4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769b260986235fa435bbee7931cf808afc7cdf966768a39ffeebd272eb08ffad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a3d27ab43d8deb8a5f0532ddc795dee0922211809f8dfc02bb136428707120)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3827fa854d2d8442ccec2048d50dd87f6c17cfdb80f45adcdf360cc4ccf4b0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc71e3bee8efa8f17a27094e5f7736d4a34946224da57978d570facefed981e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe455d032556fccb0157c07511578112b8e6898a0b63293a036fa7791458670f)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d84d21f0253046cce56b20c821b46dc9ed797c03e8a4a2566fd0d932d6790ceb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431a6daef726f438610cb83a2fe915d3374f8ff10970ff3981575ab1be3a605e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b143331da47bf1d8aba9388e9e420199209366655c9c2269cf05b466401ac8cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f3a675aed8f8deee2a2f80d5e0247fa813e930b91f68880977424ac27588681)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6df4cda91ed527ab5c70e809eb7eb198d595e8d4782fac5bef6b6f1e554c9785)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2d84a15198a35f0bfbdd4bded393e3a64a7c0c2e883ffb48f2bf99eaa953ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bba0d9403e91095c8180697d685a721dc0cd93504ed02d8b8645db94c2b4a60e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467d389ea4b70292d560288a912a1acd136fd0afa28241a9a4b38d040ddd1bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fea1f5cb3d3b2a005bc1c21c96b844615fb2952d20a00e7e0841094845bac2e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74b3693adb252da011f05b31d544fa210efe532e37f0dad799ffb80d57ff1be2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98086471f3b83778a60e44c696bd942ee0eb77f2c8f647f9689edf4e9b8bf968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4015b9594d903ccda34c19cf9594887ad9030f9e2dd63b3cb093b5c2f39430ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb03a940b613271d310b275192dd0056d11d3fa3d728c2f25e198034240608cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c265845723fdbc40f650eee6e7cd91c36294b4b7fc4342d422f0cfb541563594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc080222089887ac84dbec6fb5f13e3ffc2027e6af2ecf08a791dc114ec6d69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0ca8f93cbac93887012806b831e581f728ec6a864289365715bf38d7239d3f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1e9cf9b236147d02442cf2fd69b157f6ba9797c047f8cbda7b2c9d76779f718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4fe1b7e11309d4f0c1ca8dce37d3f4d570f705ac3744e1642a34e38551a3fd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fbcb1d6c4564d210fe3b3734d1fc934b8a05a160510ec54a8d8314f8d6ffe53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c98a69c38a80657ecc55ef289f1bf1e1e63ca1de8ee92727a7ea0a554e15eaf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod",
    jsii_struct_bases=[],
    name_mapping={
        "catalog_size": "catalogSize",
        "content_type": "contentType",
        "dash": "dash",
        "hds": "hds",
        "hls": "hls",
        "locked": "locked",
        "popularity_distribution": "popularityDistribution",
        "segment_duration_dash": "segmentDurationDash",
        "segment_duration_hds": "segmentDurationHds",
        "segment_duration_hls": "segmentDurationHls",
        "segment_duration_smooth": "segmentDurationSmooth",
        "segment_size_dash": "segmentSizeDash",
        "segment_size_hds": "segmentSizeHds",
        "segment_size_hls": "segmentSizeHls",
        "segment_size_smooth": "segmentSizeSmooth",
        "smooth": "smooth",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod:
    def __init__(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f686eaf5fcbb94624780fb7a4bf1e2823d28716cfe1795efab8b7ea1b4955ef)
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument dash", value=dash, expected_type=type_hints["dash"])
            check_type(argname="argument hds", value=hds, expected_type=type_hints["hds"])
            check_type(argname="argument hls", value=hls, expected_type=type_hints["hls"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument segment_duration_dash", value=segment_duration_dash, expected_type=type_hints["segment_duration_dash"])
            check_type(argname="argument segment_duration_hds", value=segment_duration_hds, expected_type=type_hints["segment_duration_hds"])
            check_type(argname="argument segment_duration_hls", value=segment_duration_hls, expected_type=type_hints["segment_duration_hls"])
            check_type(argname="argument segment_duration_smooth", value=segment_duration_smooth, expected_type=type_hints["segment_duration_smooth"])
            check_type(argname="argument segment_size_dash", value=segment_size_dash, expected_type=type_hints["segment_size_dash"])
            check_type(argname="argument segment_size_hds", value=segment_size_hds, expected_type=type_hints["segment_size_hds"])
            check_type(argname="argument segment_size_hls", value=segment_size_hls, expected_type=type_hints["segment_size_hls"])
            check_type(argname="argument segment_size_smooth", value=segment_size_smooth, expected_type=type_hints["segment_size_smooth"])
            check_type(argname="argument smooth", value=smooth, expected_type=type_hints["smooth"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_type is not None:
            self._values["content_type"] = content_type
        if dash is not None:
            self._values["dash"] = dash
        if hds is not None:
            self._values["hds"] = hds
        if hls is not None:
            self._values["hls"] = hls
        if locked is not None:
            self._values["locked"] = locked
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if segment_duration_dash is not None:
            self._values["segment_duration_dash"] = segment_duration_dash
        if segment_duration_hds is not None:
            self._values["segment_duration_hds"] = segment_duration_hds
        if segment_duration_hls is not None:
            self._values["segment_duration_hls"] = segment_duration_hls
        if segment_duration_smooth is not None:
            self._values["segment_duration_smooth"] = segment_duration_smooth
        if segment_size_dash is not None:
            self._values["segment_size_dash"] = segment_size_dash
        if segment_size_hds is not None:
            self._values["segment_size_hds"] = segment_size_hds
        if segment_size_hls is not None:
            self._values["segment_size_hls"] = segment_size_hls
        if segment_size_smooth is not None:
            self._values["segment_size_smooth"] = segment_size_smooth
        if smooth is not None:
            self._values["smooth"] = smooth
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the total size of the content library delivered.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        '''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the quality of media content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dash(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of DASH media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        '''
        result = self._values.get("dash")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hds(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HDS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        '''
        result = self._values.get("hds")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of HLS media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        '''
        result = self._values.get("hls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Optimize based on the content's expected popularity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        '''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        '''
        result = self._values.get("segment_duration_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        '''
        result = self._values.get("segment_duration_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        '''
        result = self._values.get("segment_duration_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration of individual fragments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        '''
        result = self._values.get("segment_duration_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_dash(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        '''
        result = self._values.get("segment_size_dash")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hds(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        '''
        result = self._values.get("segment_size_hds")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_hls(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        '''
        result = self._values.get("segment_size_hls")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_size_smooth(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the media object retrieved from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        '''
        result = self._values.get("segment_size_smooth")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smooth(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable delivery of Smooth media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        '''
        result = self._values.get("smooth")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0a166745a8125b763cfee2a38eb2ad3853dcaf6be14e78d0771172de76efa9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDash")
    def reset_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDash", []))

    @jsii.member(jsii_name="resetHds")
    def reset_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHds", []))

    @jsii.member(jsii_name="resetHls")
    def reset_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHls", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetSegmentDurationDash")
    def reset_segment_duration_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationDash", []))

    @jsii.member(jsii_name="resetSegmentDurationHds")
    def reset_segment_duration_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHds", []))

    @jsii.member(jsii_name="resetSegmentDurationHls")
    def reset_segment_duration_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationHls", []))

    @jsii.member(jsii_name="resetSegmentDurationSmooth")
    def reset_segment_duration_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDurationSmooth", []))

    @jsii.member(jsii_name="resetSegmentSizeDash")
    def reset_segment_size_dash(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeDash", []))

    @jsii.member(jsii_name="resetSegmentSizeHds")
    def reset_segment_size_hds(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHds", []))

    @jsii.member(jsii_name="resetSegmentSizeHls")
    def reset_segment_size_hls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeHls", []))

    @jsii.member(jsii_name="resetSegmentSizeSmooth")
    def reset_segment_size_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentSizeSmooth", []))

    @jsii.member(jsii_name="resetSmooth")
    def reset_smooth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmooth", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dashInput")
    def dash_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashInput"))

    @builtins.property
    @jsii.member(jsii_name="hdsInput")
    def hds_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hdsInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsInput")
    def hls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDashInput")
    def segment_duration_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHdsInput")
    def segment_duration_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHlsInput")
    def segment_duration_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmoothInput")
    def segment_duration_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentDurationSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDashInput")
    def segment_size_dash_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeDashInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHdsInput")
    def segment_size_hds_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHdsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHlsInput")
    def segment_size_hls_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeHlsInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmoothInput")
    def segment_size_smooth_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "segmentSizeSmoothInput"))

    @builtins.property
    @jsii.member(jsii_name="smoothInput")
    def smooth_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "smoothInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a0a83ed962c4585484088801ee1366c6179e425becd74f90884cfe63073b21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0a817fec1e2a8fff68048663910a416affae8bf4fad4f25984dbf857a35a2b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="dash")
    def dash(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dash"))

    @dash.setter
    def dash(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71709a920bb3c056da6224e5c359a2b6aa664c7d017c109cbb2c01a8dae14e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dash", value)

    @builtins.property
    @jsii.member(jsii_name="hds")
    def hds(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hds"))

    @hds.setter
    def hds(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512dd805099b4c8c700ac0336fc3166fe1399fcb29deae9f35d67e2955cab0b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hds", value)

    @builtins.property
    @jsii.member(jsii_name="hls")
    def hls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hls"))

    @hls.setter
    def hls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f0ac5d697aa50fd2295c65eb0757ef2c02100938c8ec6732cd75dff6432c07b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hls", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__337714f63a94a4dad4ae0cd93ec3404a51c332ce995dea91cf288ee477ba2978)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d3474557e4c757f468190739ea5d54417ac76140cb34a0ef3a6367fdca02b7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationDash")
    def segment_duration_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationDash"))

    @segment_duration_dash.setter
    def segment_duration_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5777554fd6d62cedaf9d84fe22233186bfdd009f2b9f38f99d703d632d17148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHds")
    def segment_duration_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHds"))

    @segment_duration_hds.setter
    def segment_duration_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc5b5cf6c03c7ba93ccbb5ce3b207f3fb1101a6dd779370018af65b20d685a73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationHls")
    def segment_duration_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationHls"))

    @segment_duration_hls.setter
    def segment_duration_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7131865aaf69aa6b4b044e7758a6bfe6876ab13b977a2fae9e6d7acaa5fb74f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDurationSmooth")
    def segment_duration_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentDurationSmooth"))

    @segment_duration_smooth.setter
    def segment_duration_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dd695ac64b8a07307e4717a8dbfef7a7e8411b33057790c15fcac8ca975284e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDurationSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeDash")
    def segment_size_dash(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeDash"))

    @segment_size_dash.setter
    def segment_size_dash(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__195a00c1df5f8aa37a47a6640bcac0bedbd724c5dee2d374091a3f4af6ae6fc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeDash", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHds")
    def segment_size_hds(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHds"))

    @segment_size_hds.setter
    def segment_size_hds(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d83a8aa2a7382a3bf6ec31b38fa78792feae708315255bc0ca4a4dc22b731b1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHds", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeHls")
    def segment_size_hls(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeHls"))

    @segment_size_hls.setter
    def segment_size_hls(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78598276800d7ea44ba1ab803ddd2c1f791b781b5438d9e208279bca612bf116)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeHls", value)

    @builtins.property
    @jsii.member(jsii_name="segmentSizeSmooth")
    def segment_size_smooth(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "segmentSizeSmooth"))

    @segment_size_smooth.setter
    def segment_size_smooth(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85225c6c53fc2e7af735299f6901e7288f0354515752ffdafb7f0659d2592999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentSizeSmooth", value)

    @builtins.property
    @jsii.member(jsii_name="smooth")
    def smooth(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "smooth"))

    @smooth.setter
    def smooth(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b83e16a9916b5844138f8d115970d70754f45634ec20ab601ee3cc57de2db1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smooth", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e693416c719f55a0c66bfba4853533856bff519e4236d259a6cab8a8b5016fd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae2c59c4b7cf7f0bc55d00251b4f99c16f1dddffe431d70535a906fe12c8736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0f648960527a7f3c5713514777bbbfc4392427e6c9e321769650f6c870708c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "first_location": "firstLocation",
        "locked": "locked",
        "second_location": "secondLocation",
        "source_type": "sourceType",
        "targets": "targets",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93d62cbd3220599479088e44c940517e50e56b1385d6480e7bfc3112fdbe76a5)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument first_location", value=first_location, expected_type=type_hints["first_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument second_location", value=second_location, expected_type=type_hints["second_location"])
            check_type(argname="argument source_type", value=source_type, expected_type=type_hints["source_type"])
            check_type(argname="argument targets", value=targets, expected_type=type_hints["targets"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if first_location is not None:
            self._values["first_location"] = first_location
        if locked is not None:
            self._values["locked"] = locked
        if second_location is not None:
            self._values["second_location"] = second_location
        if source_type is not None:
            self._values["source_type"] = source_type
        if targets is not None:
            self._values["targets"] = targets
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content PrePosition behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def first_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.'''
        result = self._values.get("first_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def second_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.'''
        result = self._values.get("second_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def source_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.'''
        result = self._values.get("source_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def targets(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.'''
        result = self._values.get("targets")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2f27808d2e909d046bc37db54c40f139956d6abfc5b28040ceeb882d1d84cdb)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFirstLocation")
    def reset_first_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondLocation")
    def reset_second_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondLocation", []))

    @jsii.member(jsii_name="resetSourceType")
    def reset_source_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSourceType", []))

    @jsii.member(jsii_name="resetTargets")
    def reset_targets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargets", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="firstLocationInput")
    def first_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "firstLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondLocationInput")
    def second_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="sourceTypeInput")
    def source_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sourceTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="targetsInput")
    def targets_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf12aa68bc677c397020692a9f0d5ab97006b5a62d48d0aebb55678995bffa23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="firstLocation")
    def first_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "firstLocation"))

    @first_location.setter
    def first_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff12b2c69132b5e3dc5b65272c49d2c79a809766ca598df53d598719fdcf383b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "firstLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bf6c558fe127fc2f4935a0309091108baa76a49caf72f7111e8c6e2a9cb991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondLocation")
    def second_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondLocation"))

    @second_location.setter
    def second_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f6474115e6a44f03a800879662592fe861b458412a4cdf8a58f8be1b4da414c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondLocation", value)

    @builtins.property
    @jsii.member(jsii_name="sourceType")
    def source_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sourceType"))

    @source_type.setter
    def source_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed581d555284d67154638115c56a61af2f419bca1ec4ff785fa99c36699c40d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sourceType", value)

    @builtins.property
    @jsii.member(jsii_name="targets")
    def targets(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targets"))

    @targets.setter
    def targets(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7644cce10d105dd9b8d6fd30fe8337ebb21cc3a8e03de0dee309690979c4fff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targets", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ecbfeba1d0684ec96fc82042c33bedbb07df1633d164d1eb3b7c38aacf59c45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd78db356682474f02ff9b5dae92fe016ede0fe4985cd8974cec4bf3499ba0cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3c0319baea709e7a3a449f17f3575ee5fdf851476055fc56f3012a8c3d862af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection",
    jsii_struct_bases=[],
    name_mapping={
        "countries": "countries",
        "dmas": "dmas",
        "enabled": "enabled",
        "enable_geo_protection": "enableGeoProtection",
        "enable_geo_redirect_on_deny": "enableGeoRedirectOnDeny",
        "enable_ip_protection": "enableIpProtection",
        "enable_ip_redirect_on_deny": "enableIpRedirectOnDeny",
        "enable_referrer_protection": "enableReferrerProtection",
        "enable_referrer_redirect_on_deny": "enableReferrerRedirectOnDeny",
        "geo_protection_mode": "geoProtectionMode",
        "geo_protection_title": "geoProtectionTitle",
        "geo_redirect_url": "geoRedirectUrl",
        "ip_addresses": "ipAddresses",
        "ip_protection_mode": "ipProtectionMode",
        "ip_protection_title": "ipProtectionTitle",
        "ip_redirect_url": "ipRedirectUrl",
        "locked": "locked",
        "override_ip_addresses": "overrideIpAddresses",
        "referrer_domains": "referrerDomains",
        "referrer_protection_mode": "referrerProtectionMode",
        "referrer_protection_title": "referrerProtectionTitle",
        "referrer_redirect_url": "referrerRedirectUrl",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection:
    def __init__(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfa4d8afd92331bf25d615401bf8175c75f80c540bec447f6e2992065cf48098)
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument dmas", value=dmas, expected_type=type_hints["dmas"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_geo_protection", value=enable_geo_protection, expected_type=type_hints["enable_geo_protection"])
            check_type(argname="argument enable_geo_redirect_on_deny", value=enable_geo_redirect_on_deny, expected_type=type_hints["enable_geo_redirect_on_deny"])
            check_type(argname="argument enable_ip_protection", value=enable_ip_protection, expected_type=type_hints["enable_ip_protection"])
            check_type(argname="argument enable_ip_redirect_on_deny", value=enable_ip_redirect_on_deny, expected_type=type_hints["enable_ip_redirect_on_deny"])
            check_type(argname="argument enable_referrer_protection", value=enable_referrer_protection, expected_type=type_hints["enable_referrer_protection"])
            check_type(argname="argument enable_referrer_redirect_on_deny", value=enable_referrer_redirect_on_deny, expected_type=type_hints["enable_referrer_redirect_on_deny"])
            check_type(argname="argument geo_protection_mode", value=geo_protection_mode, expected_type=type_hints["geo_protection_mode"])
            check_type(argname="argument geo_protection_title", value=geo_protection_title, expected_type=type_hints["geo_protection_title"])
            check_type(argname="argument geo_redirect_url", value=geo_redirect_url, expected_type=type_hints["geo_redirect_url"])
            check_type(argname="argument ip_addresses", value=ip_addresses, expected_type=type_hints["ip_addresses"])
            check_type(argname="argument ip_protection_mode", value=ip_protection_mode, expected_type=type_hints["ip_protection_mode"])
            check_type(argname="argument ip_protection_title", value=ip_protection_title, expected_type=type_hints["ip_protection_title"])
            check_type(argname="argument ip_redirect_url", value=ip_redirect_url, expected_type=type_hints["ip_redirect_url"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_ip_addresses", value=override_ip_addresses, expected_type=type_hints["override_ip_addresses"])
            check_type(argname="argument referrer_domains", value=referrer_domains, expected_type=type_hints["referrer_domains"])
            check_type(argname="argument referrer_protection_mode", value=referrer_protection_mode, expected_type=type_hints["referrer_protection_mode"])
            check_type(argname="argument referrer_protection_title", value=referrer_protection_title, expected_type=type_hints["referrer_protection_title"])
            check_type(argname="argument referrer_redirect_url", value=referrer_redirect_url, expected_type=type_hints["referrer_redirect_url"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if countries is not None:
            self._values["countries"] = countries
        if dmas is not None:
            self._values["dmas"] = dmas
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_geo_protection is not None:
            self._values["enable_geo_protection"] = enable_geo_protection
        if enable_geo_redirect_on_deny is not None:
            self._values["enable_geo_redirect_on_deny"] = enable_geo_redirect_on_deny
        if enable_ip_protection is not None:
            self._values["enable_ip_protection"] = enable_ip_protection
        if enable_ip_redirect_on_deny is not None:
            self._values["enable_ip_redirect_on_deny"] = enable_ip_redirect_on_deny
        if enable_referrer_protection is not None:
            self._values["enable_referrer_protection"] = enable_referrer_protection
        if enable_referrer_redirect_on_deny is not None:
            self._values["enable_referrer_redirect_on_deny"] = enable_referrer_redirect_on_deny
        if geo_protection_mode is not None:
            self._values["geo_protection_mode"] = geo_protection_mode
        if geo_protection_title is not None:
            self._values["geo_protection_title"] = geo_protection_title
        if geo_redirect_url is not None:
            self._values["geo_redirect_url"] = geo_redirect_url
        if ip_addresses is not None:
            self._values["ip_addresses"] = ip_addresses
        if ip_protection_mode is not None:
            self._values["ip_protection_mode"] = ip_protection_mode
        if ip_protection_title is not None:
            self._values["ip_protection_title"] = ip_protection_title
        if ip_redirect_url is not None:
            self._values["ip_redirect_url"] = ip_redirect_url
        if locked is not None:
            self._values["locked"] = locked
        if override_ip_addresses is not None:
            self._values["override_ip_addresses"] = override_ip_addresses
        if referrer_domains is not None:
            self._values["referrer_domains"] = referrer_domains
        if referrer_protection_mode is not None:
            self._values["referrer_protection_mode"] = referrer_protection_mode
        if referrer_protection_title is not None:
            self._values["referrer_protection_title"] = referrer_protection_title
        if referrer_redirect_url is not None:
            self._values["referrer_redirect_url"] = referrer_redirect_url
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def dmas(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of Designated Market Area codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        '''
        result = self._values.get("dmas")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Content Targeting feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, verifies IP addresses are unique to specific geographic regions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        '''
        result = self._values.get("enable_geo_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        '''
        result = self._values.get("enable_geo_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to control access to your content from specific sets of IP addresses and CIDR blocks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        '''
        result = self._values.get("enable_ip_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        '''
        result = self._values.get("enable_ip_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_protection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        '''
        result = self._values.get("enable_referrer_protection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects denied requests rather than responding with an error code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        '''
        result = self._values.get("enable_referrer_redirect_on_deny")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        '''
        result = self._values.get("geo_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        '''
        result = self._values.get("geo_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def geo_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        '''
        result = self._values.get("geo_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks to allow or deny.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        '''
        result = self._values.get("ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def ip_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to handle requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        '''
        result = self._values.get("ip_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        '''
        result = self._values.get("ip_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        '''
        result = self._values.get("ip_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_ip_addresses(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        '''
        result = self._values.get("override_ip_addresses")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of domains from which to allow or deny traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        '''
        result = self._values.get("referrer_domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def referrer_protection_mode(self) -> typing.Optional[builtins.str]:
        '''Specify the action to take.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        '''
        result = self._values.get("referrer_protection_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_protection_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        '''
        result = self._values.get("referrer_protection_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer_redirect_url(self) -> typing.Optional[builtins.str]:
        '''This specifies the full URL to the redirect page for denied requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        '''
        result = self._values.get("referrer_redirect_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic.

        See ``EdgeScape Data Codes`` for a list.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__648583d18293b9225e7658c9c133ff69b83cb8e2fb9183fde5af92f4e94b625c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetDmas")
    def reset_dmas(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDmas", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableGeoProtection")
    def reset_enable_geo_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoProtection", []))

    @jsii.member(jsii_name="resetEnableGeoRedirectOnDeny")
    def reset_enable_geo_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableGeoRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableIpProtection")
    def reset_enable_ip_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpProtection", []))

    @jsii.member(jsii_name="resetEnableIpRedirectOnDeny")
    def reset_enable_ip_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpRedirectOnDeny", []))

    @jsii.member(jsii_name="resetEnableReferrerProtection")
    def reset_enable_referrer_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerProtection", []))

    @jsii.member(jsii_name="resetEnableReferrerRedirectOnDeny")
    def reset_enable_referrer_redirect_on_deny(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableReferrerRedirectOnDeny", []))

    @jsii.member(jsii_name="resetGeoProtectionMode")
    def reset_geo_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionMode", []))

    @jsii.member(jsii_name="resetGeoProtectionTitle")
    def reset_geo_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoProtectionTitle", []))

    @jsii.member(jsii_name="resetGeoRedirectUrl")
    def reset_geo_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoRedirectUrl", []))

    @jsii.member(jsii_name="resetIpAddresses")
    def reset_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAddresses", []))

    @jsii.member(jsii_name="resetIpProtectionMode")
    def reset_ip_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionMode", []))

    @jsii.member(jsii_name="resetIpProtectionTitle")
    def reset_ip_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpProtectionTitle", []))

    @jsii.member(jsii_name="resetIpRedirectUrl")
    def reset_ip_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpRedirectUrl", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideIpAddresses")
    def reset_override_ip_addresses(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideIpAddresses", []))

    @jsii.member(jsii_name="resetReferrerDomains")
    def reset_referrer_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerDomains", []))

    @jsii.member(jsii_name="resetReferrerProtectionMode")
    def reset_referrer_protection_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionMode", []))

    @jsii.member(jsii_name="resetReferrerProtectionTitle")
    def reset_referrer_protection_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerProtectionTitle", []))

    @jsii.member(jsii_name="resetReferrerRedirectUrl")
    def reset_referrer_redirect_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrerRedirectUrl", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="dmasInput")
    def dmas_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "dmasInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtectionInput")
    def enable_geo_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDenyInput")
    def enable_geo_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableGeoRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpProtectionInput")
    def enable_ip_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDenyInput")
    def enable_ip_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtectionInput")
    def enable_referrer_protection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDenyInput")
    def enable_referrer_redirect_on_deny_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableReferrerRedirectOnDenyInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionModeInput")
    def geo_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitleInput")
    def geo_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrlInput")
    def geo_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "geoRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAddressesInput")
    def ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "ipAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionModeInput")
    def ip_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitleInput")
    def ip_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrlInput")
    def ip_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddressesInput")
    def override_ip_addresses_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "overrideIpAddressesInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerDomainsInput")
    def referrer_domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "referrerDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionModeInput")
    def referrer_protection_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitleInput")
    def referrer_protection_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerProtectionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrlInput")
    def referrer_redirect_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "referrerRedirectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__061344605bf4b73660b4d4fac3d310ede9fd003fb4e62ebf5864ee26b21ac3ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="dmas")
    def dmas(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "dmas"))

    @dmas.setter
    def dmas(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1292a7ec2c1f1f2b41fff14c0ca5443c314ac9e61cf4fa7624b1a1efebd892)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dmas", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446cc453799c1cc40b17af5b27a84ae4c7105c8f1afd7d8717bc5bf2bc28f341)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoProtection")
    def enable_geo_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoProtection"))

    @enable_geo_protection.setter
    def enable_geo_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3501834fea02fe0a63abfd80c7f411aeaa5680a127b15d6bdbd11301947ea87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableGeoRedirectOnDeny")
    def enable_geo_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableGeoRedirectOnDeny"))

    @enable_geo_redirect_on_deny.setter
    def enable_geo_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b9d35e186ca0031737a0e0be49dc03d71e816f444940090aa09150955a1fe6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableGeoRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpProtection")
    def enable_ip_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpProtection"))

    @enable_ip_protection.setter
    def enable_ip_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82387685b7043e6664946f75dfcf3f086359ae661d7513445b883873c5aa89d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpRedirectOnDeny")
    def enable_ip_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpRedirectOnDeny"))

    @enable_ip_redirect_on_deny.setter
    def enable_ip_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da7cc57ac45fa85f5464ef7cff5e5bd3f7011a0af05e6333a85e9ef63f2b4744)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerProtection")
    def enable_referrer_protection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerProtection"))

    @enable_referrer_protection.setter
    def enable_referrer_protection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea3b743fe36ae55c3334dd388dd10a843eb65a1b60cf8992162335bd88ae2a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerProtection", value)

    @builtins.property
    @jsii.member(jsii_name="enableReferrerRedirectOnDeny")
    def enable_referrer_redirect_on_deny(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableReferrerRedirectOnDeny"))

    @enable_referrer_redirect_on_deny.setter
    def enable_referrer_redirect_on_deny(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9641308cad71357d5a8f47bcc1fb3a2dc19934db36b5a140085bb358f1309c8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableReferrerRedirectOnDeny", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionMode")
    def geo_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionMode"))

    @geo_protection_mode.setter
    def geo_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fdee0089eed8bee354b3ad856880886ec53f62d8b84aa64ddb7a00fc8d26d23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="geoProtectionTitle")
    def geo_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoProtectionTitle"))

    @geo_protection_title.setter
    def geo_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ae244db6108d0a63eb6cafd45a5cb3a2135f482424bda2c26ceae76250b3d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="geoRedirectUrl")
    def geo_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "geoRedirectUrl"))

    @geo_redirect_url.setter
    def geo_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a492bb23c094a853ea1f2c5ab59b1c3bec6c5ed77fc38c279b47ee31068e2bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="ipAddresses")
    def ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "ipAddresses"))

    @ip_addresses.setter
    def ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a4c608f2a6a154c31b47a41b70fafd8a9989ec5fc81f9ccde54c089a8ac31cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionMode")
    def ip_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionMode"))

    @ip_protection_mode.setter
    def ip_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee55f2473959a0b10bdf5386cd3203db31d344875ca3d344da0feb7b9fd6135)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="ipProtectionTitle")
    def ip_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipProtectionTitle"))

    @ip_protection_title.setter
    def ip_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61233e60a95158cb4a2787056631f1e652f5e3e775599ebf976e4c14a6be195a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="ipRedirectUrl")
    def ip_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipRedirectUrl"))

    @ip_redirect_url.setter
    def ip_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a2786983077d1fc5a22c3b78a530c9e6d7f0a20c21a6b06f734dc4780b36e7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1da6419ed0d63dba8f9b11c0301c17fb0df63d1253ca80109b08174a464cde3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideIpAddresses")
    def override_ip_addresses(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "overrideIpAddresses"))

    @override_ip_addresses.setter
    def override_ip_addresses(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df79a41d28322a89ca27a38a0f8f5628091e2c2d70259b1e818c9ef23d15801d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideIpAddresses", value)

    @builtins.property
    @jsii.member(jsii_name="referrerDomains")
    def referrer_domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "referrerDomains"))

    @referrer_domains.setter
    def referrer_domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__262c38ff1968d6f5c0bfe8fad7ead955484777c514fda70341ec84c2c3cbe36c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerDomains", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionMode")
    def referrer_protection_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionMode"))

    @referrer_protection_mode.setter
    def referrer_protection_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f6e57f21fa7dc9e9f415f21d9e110ca17eb94e5eafe737765c925068312443c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionMode", value)

    @builtins.property
    @jsii.member(jsii_name="referrerProtectionTitle")
    def referrer_protection_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerProtectionTitle"))

    @referrer_protection_title.setter
    def referrer_protection_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__438c700647e2172cd69aab958f7065acf57d537840332c613f98171a8da9f216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerProtectionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="referrerRedirectUrl")
    def referrer_redirect_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "referrerRedirectUrl"))

    @referrer_redirect_url.setter
    def referrer_redirect_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cafc0994ce6460b9e0d7d4e264543f1026a2d473838b4155d3e5f3c09f066e84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrerRedirectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a33595eb383e52b61590656da5bef51a42f0b61ff3227d96b349b450551a008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2f04679383373f2d7c04dd24839d3e5f94b4daa52725247b122a23746ef5c35)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff52c4a70a54a472e913f5723d4e2318dffb44bbc9968352efd9e06f37d4e69a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79a1cf767fb3d310beb751b52638b4a6eecd4b1d23a00cabce2a897ac47179b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport",
    jsii_struct_bases=[],
    name_mapping={
        "allow_credentials": "allowCredentials",
        "allow_headers": "allowHeaders",
        "allow_origins": "allowOrigins",
        "enabled": "enabled",
        "expose_headers": "exposeHeaders",
        "headers": "headers",
        "locked": "locked",
        "methods": "methods",
        "origins": "origins",
        "preflight_max_age": "preflightMaxAge",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport:
    def __init__(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20ba596f70f863bbf68aa80036bd21890d04c048a9ea0b88d3a66c4b97abbc4d)
            check_type(argname="argument allow_credentials", value=allow_credentials, expected_type=type_hints["allow_credentials"])
            check_type(argname="argument allow_headers", value=allow_headers, expected_type=type_hints["allow_headers"])
            check_type(argname="argument allow_origins", value=allow_origins, expected_type=type_hints["allow_origins"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expose_headers", value=expose_headers, expected_type=type_hints["expose_headers"])
            check_type(argname="argument headers", value=headers, expected_type=type_hints["headers"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument methods", value=methods, expected_type=type_hints["methods"])
            check_type(argname="argument origins", value=origins, expected_type=type_hints["origins"])
            check_type(argname="argument preflight_max_age", value=preflight_max_age, expected_type=type_hints["preflight_max_age"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_credentials is not None:
            self._values["allow_credentials"] = allow_credentials
        if allow_headers is not None:
            self._values["allow_headers"] = allow_headers
        if allow_origins is not None:
            self._values["allow_origins"] = allow_origins
        if enabled is not None:
            self._values["enabled"] = enabled
        if expose_headers is not None:
            self._values["expose_headers"] = expose_headers
        if headers is not None:
            self._values["headers"] = headers
        if locked is not None:
            self._values["locked"] = locked
        if methods is not None:
            self._values["methods"] = methods
        if origins is not None:
            self._values["origins"] = origins
        if preflight_max_age is not None:
            self._values["preflight_max_age"] = preflight_max_age
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_credentials(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Accepts requests made using credentials, like cookies or TLS client certificates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        '''
        result = self._values.get("allow_credentials")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_headers(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, defines which headers to allow when making the actual request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        '''
        result = self._values.get("allow_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_origins(self) -> typing.Optional[builtins.str]:
        '''In responses to preflight requests, sets which origin hostnames to accept requests from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        '''
        result = self._values.get("allow_origins")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables CORS feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expose_headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''In responses to preflight requests, lists names of headers that clients can access.

        By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        '''
        result = self._values.get("expose_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def headers(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the supported request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        '''
        result = self._values.get("headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def methods(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        '''
        result = self._values.get("methods")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origins(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin hostnames to accept requests from.

        The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        '''
        result = self._values.get("origins")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def preflight_max_age(self) -> typing.Optional[builtins.str]:
        '''Defines the number of seconds that the browser should cache the response to a preflight request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        '''
        result = self._values.get("preflight_max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6123e70c362336259f7703146c9d2c83dbff72444fc9a9e29f421b189f12942)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowCredentials")
    def reset_allow_credentials(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCredentials", []))

    @jsii.member(jsii_name="resetAllowHeaders")
    def reset_allow_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHeaders", []))

    @jsii.member(jsii_name="resetAllowOrigins")
    def reset_allow_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOrigins", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExposeHeaders")
    def reset_expose_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExposeHeaders", []))

    @jsii.member(jsii_name="resetHeaders")
    def reset_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaders", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethods")
    def reset_methods(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethods", []))

    @jsii.member(jsii_name="resetOrigins")
    def reset_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigins", []))

    @jsii.member(jsii_name="resetPreflightMaxAge")
    def reset_preflight_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreflightMaxAge", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowCredentialsInput")
    def allow_credentials_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowCredentialsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHeadersInput")
    def allow_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOriginsInput")
    def allow_origins_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="exposeHeadersInput")
    def expose_headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "exposeHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="headersInput")
    def headers_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headersInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodsInput")
    def methods_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "methodsInput"))

    @builtins.property
    @jsii.member(jsii_name="originsInput")
    def origins_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originsInput"))

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAgeInput")
    def preflight_max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "preflightMaxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCredentials")
    def allow_credentials(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowCredentials"))

    @allow_credentials.setter
    def allow_credentials(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc5b5e961ae575804ba3cbcfba4af23545ca36b13d7d45e45817dfc691c960d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowCredentials", value)

    @builtins.property
    @jsii.member(jsii_name="allowHeaders")
    def allow_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowHeaders"))

    @allow_headers.setter
    def allow_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d49b779f8ffb64a347776eb4e168e2c55410661bd6b15747fafdef736f0457a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="allowOrigins")
    def allow_origins(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowOrigins"))

    @allow_origins.setter
    def allow_origins(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25e2d0a91dd132ead4916c2bf1922f9152d5385a49215eb7a74876c9b332514c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOrigins", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be50ebc7c42684bddfce4d476420602f9327d329000b99a8d9dfcdabc88a5afe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="exposeHeaders")
    def expose_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "exposeHeaders"))

    @expose_headers.setter
    def expose_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f428be0c9d5562fade283e7b0907b332ae119a2d36c6653f4472b4702e0b302)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exposeHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="headers")
    def headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headers"))

    @headers.setter
    def headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7066b2531e2ef1d243cf9c1a38fa0354485770966fe5959100f85cc47a41c3fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headers", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4693fdee0e5a44ae462e524cf4c373edb1ca4498afd790b694ff792ef9b588b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="methods")
    def methods(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "methods"))

    @methods.setter
    def methods(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4857da0f68eaa43689808ff28ef1b5af8797d584906493e426c8700417593952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "methods", value)

    @builtins.property
    @jsii.member(jsii_name="origins")
    def origins(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "origins"))

    @origins.setter
    def origins(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__117cba2d27bcafe92b82f7bacbd2e515dbfdee538b2e2024731d747f0fb3657d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origins", value)

    @builtins.property
    @jsii.member(jsii_name="preflightMaxAge")
    def preflight_max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "preflightMaxAge"))

    @preflight_max_age.setter
    def preflight_max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de50a4b9e72c4cdf7746d27656ec7fa7a24553670e30ff2ae3194954ba6c71e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preflightMaxAge", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21212ce1a565a707cbb959dc8400fd17b58fbe23d6950789919f0dddf9c7d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab2a5ccd3372de32ebb64abe666c37c5a623909565bb289eaae84712b6442daf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46537fb43efe0e9a3884c6a315d6fb105e46772b09d1234c05ebf4a2fe57d1e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c647c93da84cf392f5da45bdc135752f3b59958639a9f8c320a311851e7971c9)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__630f6172f7bdb7d869325ae85169871d98e6b814251ebf79f72948b4e18f0e24)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2be4d90db665f30bbde0979f7dd795d67d9330947fe4fc1ba1baa55c598116c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99b72c0859980f11fe92fe5e15b1063f03d322f28c1230883e1c586ca2561db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ed933ab6ae4abe3d76ded177046124a73b1f06a3d941dc17744970088631675)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__145baca2cf2419f205ff63ac69873404ccb299f3a97dcdaffe043070b2512dcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1374fc6f8a387e0d264acab156279c6c0efbd7aeefae617e5ae4e4a1fc046c)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091e71487d9a1d3799128ac7e39b705a7fe4f90c5e46c83355788d29fe04a11e)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14bd8216afec08039bd969a3c52377c181d0214ae7e569c400bb1bfc25a9aad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f6ad9c58d7b2ac689128fc0002372fe9b34d42b71ce99c291d13c9abcdadea5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0066a6a861fbc7e6fe7b0a733476589c7edbdb700cb30017be21c9f4a56c8512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84fd75c0eabc12f7165b98237f8b8ecbfa75ff374fa263f76185a69e25e38729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41c196fd5a904d797e83c01cf8538d36da16402960e7c4dda135afa704009752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9072f46d3c6f0f1ba43af4f35333d1846f949b9e3d6b0ee64d35a2b79e01daa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe4eb17a0a87c9cf2d434ffa8341be6224332f392e6b4533272e7805cdecbfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51579a6aa0af2b4ee65fe65f31c5c41dbc95c3e723160033c013bdb07cfef4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f01da6c01789c90e9ec85754dfa44911f7930828efc0691958c434d6dce0f519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a545113fc28c01869a5799b734bb72c368ff2c02ad5e3cd3e67968adae68b228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26e59822b2c9eef30c9e0ddae3b8f5dc46fac6a2e5cf733f0df78d970bc1b905)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1ebe042f794e0a047e11480e58def41cc84c82064b30981f7441ffc0079f3c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior",
    jsii_struct_bases=[],
    name_mapping={
        "behavior_id": "behaviorId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior:
    def __init__(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca4d3abe69e3ce3ec8255b2d755209753b931243648fd132ec867f421d16d0b0)
            check_type(argname="argument behavior_id", value=behavior_id, expected_type=type_hints["behavior_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior_id is not None:
            self._values["behavior_id"] = behavior_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior_id(self) -> typing.Optional[builtins.str]:
        '''The unique identifier for the predefined custom behavior you want to insert into the current rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        '''
        result = self._values.get("behavior_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b58deb819e3cf1e545075fbf758b8b7586041754b45828d7e9cf7de1b26824)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehaviorId")
    def reset_behavior_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehaviorId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorIdInput")
    def behavior_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorId")
    def behavior_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behaviorId"))

    @behavior_id.setter
    def behavior_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b3b9753209fa6543cb96f8c75e0751ceeeec332a2e56a1a02fb78f90edc2da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behaviorId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__600006f8089f96fe504f62d31d1138d54bb7db139143ce73e4f4a798ec1461f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77002543f1a4b61f6f74ac799b6f88e6a195c388da96c76ef9e77f49d0a16a0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d403ebc26beb80eed7eeadfddfeec746ccc7572f2aecac315c3f7edc7d3b4bc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__925a0daf64275cb9ef6ac6d3dd0701dff22f7e666d80ead66e99e46313fb12de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_stream_title": "beaconStreamTitle",
        "collect_midgress_traffic": "collectMidgressTraffic",
        "datastream_ids": "datastreamIds",
        "enabled": "enabled",
        "locked": "locked",
        "log_enabled": "logEnabled",
        "log_stream_name": "logStreamName",
        "log_stream_title": "logStreamTitle",
        "sampling_percentage": "samplingPercentage",
        "stream_type": "streamType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream:
    def __init__(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed17d9f530f27957f1e480b3d624238743892c1ff3b408d9e34929a3bb1b2007)
            check_type(argname="argument beacon_stream_title", value=beacon_stream_title, expected_type=type_hints["beacon_stream_title"])
            check_type(argname="argument collect_midgress_traffic", value=collect_midgress_traffic, expected_type=type_hints["collect_midgress_traffic"])
            check_type(argname="argument datastream_ids", value=datastream_ids, expected_type=type_hints["datastream_ids"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_enabled", value=log_enabled, expected_type=type_hints["log_enabled"])
            check_type(argname="argument log_stream_name", value=log_stream_name, expected_type=type_hints["log_stream_name"])
            check_type(argname="argument log_stream_title", value=log_stream_title, expected_type=type_hints["log_stream_title"])
            check_type(argname="argument sampling_percentage", value=sampling_percentage, expected_type=type_hints["sampling_percentage"])
            check_type(argname="argument stream_type", value=stream_type, expected_type=type_hints["stream_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_stream_title is not None:
            self._values["beacon_stream_title"] = beacon_stream_title
        if collect_midgress_traffic is not None:
            self._values["collect_midgress_traffic"] = collect_midgress_traffic
        if datastream_ids is not None:
            self._values["datastream_ids"] = datastream_ids
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if log_enabled is not None:
            self._values["log_enabled"] = log_enabled
        if log_stream_name is not None:
            self._values["log_stream_name"] = log_stream_name
        if log_stream_title is not None:
            self._values["log_stream_title"] = log_stream_title
        if sampling_percentage is not None:
            self._values["sampling_percentage"] = sampling_percentage
        if stream_type is not None:
            self._values["stream_type"] = stream_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        '''
        result = self._values.get("beacon_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def collect_midgress_traffic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        '''
        result = self._values.get("collect_midgress_traffic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def datastream_ids(self) -> typing.Optional[builtins.str]:
        '''A set of dash-separated DataStream ID values to limit the scope of reported data.

        By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        '''
        result = self._values.get("datastream_ids")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables DataStream reporting.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables log collection for the property by associating it with DataStream configurations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        '''
        result = self._values.get("log_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_stream_name(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the unique IDs of streams configured for the property.

        For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        '''
        result = self._values.get("log_stream_name")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def log_stream_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        '''
        result = self._values.get("log_stream_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of log data you want to collect for this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        '''
        result = self._values.get("sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def stream_type(self) -> typing.Optional[builtins.str]:
        '''Specify the DataStream type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        '''
        result = self._values.get("stream_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb2901818bbe86de55f7e807891fa67c2ce6f9c0476836ec3a1782845a64ec3f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconStreamTitle")
    def reset_beacon_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconStreamTitle", []))

    @jsii.member(jsii_name="resetCollectMidgressTraffic")
    def reset_collect_midgress_traffic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCollectMidgressTraffic", []))

    @jsii.member(jsii_name="resetDatastreamIds")
    def reset_datastream_ids(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastreamIds", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogEnabled")
    def reset_log_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEnabled", []))

    @jsii.member(jsii_name="resetLogStreamName")
    def reset_log_stream_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamName", []))

    @jsii.member(jsii_name="resetLogStreamTitle")
    def reset_log_stream_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogStreamTitle", []))

    @jsii.member(jsii_name="resetSamplingPercentage")
    def reset_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSamplingPercentage", []))

    @jsii.member(jsii_name="resetStreamType")
    def reset_stream_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStreamType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitleInput")
    def beacon_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTrafficInput")
    def collect_midgress_traffic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "collectMidgressTrafficInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamIdsInput")
    def datastream_ids_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datastreamIdsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logEnabledInput")
    def log_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamNameInput")
    def log_stream_name_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "logStreamNameInput"))

    @builtins.property
    @jsii.member(jsii_name="logStreamTitleInput")
    def log_stream_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logStreamTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="samplingPercentageInput")
    def sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "samplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="streamTypeInput")
    def stream_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "streamTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconStreamTitle")
    def beacon_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconStreamTitle"))

    @beacon_stream_title.setter
    def beacon_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70eb87720a56c0492e1fe8d5509018d8aa98243baef3cb34fd0d3ce163854a59)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="collectMidgressTraffic")
    def collect_midgress_traffic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "collectMidgressTraffic"))

    @collect_midgress_traffic.setter
    def collect_midgress_traffic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06baab5503ea4c4ffebcbd76015b2dbd15a6469904ee0f3d57279af52409f320)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "collectMidgressTraffic", value)

    @builtins.property
    @jsii.member(jsii_name="datastreamIds")
    def datastream_ids(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "datastreamIds"))

    @datastream_ids.setter
    def datastream_ids(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66d3da38445cdfb97ba13cf0c61dd57c1e8573c6af76876dce06908b7b77af7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "datastreamIds", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__057acca036351a1c6cfc61ef4aa5bf0e0a8bcf1dcfc4387e3f90abece27237aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9907f3406d067af2e3449984e90a624e1dab47fa0d2c69d31b80468d11f6f848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logEnabled")
    def log_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEnabled"))

    @log_enabled.setter
    def log_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d32204ff0f2547935d32c908d6257d79a80b9089f3387d4e465c21e5a79312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamName")
    def log_stream_name(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "logStreamName"))

    @log_stream_name.setter
    def log_stream_name(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b27e59d5efca8de405877c24cc12bee61302a74c6a3ac66a785892b8c016d385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamName", value)

    @builtins.property
    @jsii.member(jsii_name="logStreamTitle")
    def log_stream_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logStreamTitle"))

    @log_stream_title.setter
    def log_stream_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3da94e721feebd115621a88f491e59fa13ed5ac6587c04e8373a25059481ed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logStreamTitle", value)

    @builtins.property
    @jsii.member(jsii_name="samplingPercentage")
    def sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "samplingPercentage"))

    @sampling_percentage.setter
    def sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83538f670acab538ff8eaa7cc32f823a59a0f4148190247b3e77cc0caf42b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "samplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="streamType")
    def stream_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "streamType"))

    @stream_type.setter
    def stream_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db1be8738a70f1d1457d11db1e179f0fe3ac95ed2455c44e5b79047564fd5db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "streamType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__939444efcefb1580abaaac1dad221a1b9661552487893a488fe22cbb2f2810e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89dce5c4f98c9e39971c8625f4834b512a009807e48bfbd40d255374a1e26792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b130f95b791230ba33f5559664c3e2f6523d064243a31dbfa431dac004c13f0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous": "anonymous",
        "enabled": "enabled",
        "gwenabled": "gwenabled",
        "locked": "locked",
        "namespace_id": "namespaceId",
        "template_uuid": "templateUuid",
        "tlsenabled": "tlsenabled",
        "uuid": "uuid",
        "wsenabled": "wsenabled",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp:
    def __init__(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6c739fb0b7e1f3e861220ecc8651dae068571914415e382d806cbc4fb2fe597)
            check_type(argname="argument anonymous", value=anonymous, expected_type=type_hints["anonymous"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument gwenabled", value=gwenabled, expected_type=type_hints["gwenabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_id", value=namespace_id, expected_type=type_hints["namespace_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tlsenabled", value=tlsenabled, expected_type=type_hints["tlsenabled"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument wsenabled", value=wsenabled, expected_type=type_hints["wsenabled"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous is not None:
            self._values["anonymous"] = anonymous
        if enabled is not None:
            self._values["enabled"] = enabled
        if gwenabled is not None:
            self._values["gwenabled"] = gwenabled
        if locked is not None:
            self._values["locked"] = locked
        if namespace_id is not None:
            self._values["namespace_id"] = namespace_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tlsenabled is not None:
            self._values["tlsenabled"] = tlsenabled
        if uuid is not None:
            self._values["uuid"] = uuid
        if wsenabled is not None:
            self._values["wsenabled"] = wsenabled

    @builtins.property
    def anonymous(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        '''
        result = self._values.get("anonymous")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables IoT Edge Connect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def gwenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured HTTP connection on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        '''
        result = self._values.get("gwenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the globally reserved name for a specific configuration.

        It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration.  You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        '''
        result = self._values.get("namespace_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tlsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages over a secured MQTT connection on port 8883.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        '''
        result = self._values.get("tlsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def wsenabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        result = self._values.get("wsenabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "hash_conversion_algorithm": "hashConversionAlgorithm",
        "hash_conversion_key": "hashConversionKey",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation:
    def __init__(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76111d68d18fa06da4395eb1609595909ca956c492a999d90f1d4ce3bce759c3)
            check_type(argname="argument hash_conversion_algorithm", value=hash_conversion_algorithm, expected_type=type_hints["hash_conversion_algorithm"])
            check_type(argname="argument hash_conversion_key", value=hash_conversion_key, expected_type=type_hints["hash_conversion_key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if hash_conversion_algorithm is not None:
            self._values["hash_conversion_algorithm"] = hash_conversion_algorithm
        if hash_conversion_key is not None:
            self._values["hash_conversion_key"] = hash_conversion_key
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def hash_conversion_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        '''
        result = self._values.get("hash_conversion_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_conversion_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the key to generate the hash, ideally a long random string to ensure adequate security.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        '''
        result = self._values.get("hash_conversion_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__281d324eafee6ba6ac224e90fe87f6a2f089d6f7091deb506303892bf350c48d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHashConversionAlgorithm")
    def reset_hash_conversion_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionAlgorithm", []))

    @jsii.member(jsii_name="resetHashConversionKey")
    def reset_hash_conversion_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashConversionKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithmInput")
    def hash_conversion_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionKeyInput")
    def hash_conversion_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashConversionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hashConversionAlgorithm")
    def hash_conversion_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionAlgorithm"))

    @hash_conversion_algorithm.setter
    def hash_conversion_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fcd372279c295cee85475efbf8a74ac58db50306fddeb1a7465e293410de1eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hashConversionKey")
    def hash_conversion_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashConversionKey"))

    @hash_conversion_key.setter
    def hash_conversion_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6484ed9c8c0fc811d7a1879aa77a24453ac56c0a482f05dde8e2d5fd5be7e727)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashConversionKey", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8a183d5b721c4403e96d371c1881bc3294d6de2d8f40911b0325cb8cb92ca32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00a658ff5cc29a9f5eb273d36285c94931dc530e84f2ba7ab9d3a451c0dbcd42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2179f94bdd8cc11f4f83e09f85c40e5ee11131410d9fec01dde143a105268c66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e1003175a7abcdce5940f451b17bf52ff3474f1de478ba62a13750ab73e585d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a818218e7d491014294c6c8ae7cee0ee7f8d4f53b4b6546245214247ba0d50c3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with a single grouping to capture the text.

        For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8919fe97cc612138b36cb9be0f5859dbd937a0dfef7db1b039cee4fc1b2cfd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5223c9d9dfa594fc2b76cd3840e5023975799b55eda9f07560d06e5bc9ff619f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63239a70f8a1f2b8c488f43f0b52c3d4672aef5714fea75ef75b08b899ebbae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d858e02a5a9d49d50434e93d9a61dcc1e5a7cfd6d3ba5b838607d7d1be5a7f20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c21ab7179dc8a0458b1bfdd02a7554830ad9981542d566c3896e756f3c05164b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f517337347886b4b22dac3013917b46f3f5b43783b04b96a3757b67774c0008)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "substring_end": "substringEnd",
        "substring_start": "substringStart",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__780d35335be68a2bd362d8fbaaa89daf975bfceb55ad0f2e97e676531ff600de)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument substring_end", value=substring_end, expected_type=type_hints["substring_end"])
            check_type(argname="argument substring_start", value=substring_start, expected_type=type_hints["substring_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if substring_end is not None:
            self._values["substring_end"] = substring_end
        if substring_start is not None:
            self._values["substring_start"] = substring_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def substring_end(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        '''
        result = self._values.get("substring_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def substring_start(self) -> typing.Optional[builtins.str]:
        '''The zero-based index offset of the first character to extract.

        If the index is out of bound from the string's length, authentication may fail.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        '''
        result = self._values.get("substring_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25204e1c87d7d6ac9d53013b9b406b5a73b7732eda5f85f641f1a06e5927f1a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSubstringEnd")
    def reset_substring_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringEnd", []))

    @jsii.member(jsii_name="resetSubstringStart")
    def reset_substring_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubstringStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="substringEndInput")
    def substring_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringEndInput"))

    @builtins.property
    @jsii.member(jsii_name="substringStartInput")
    def substring_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "substringStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc354fe1e5ee17a4cc1109736f027065060dce587541b25719ed227c2c689d7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="substringEnd")
    def substring_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringEnd"))

    @substring_end.setter
    def substring_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__290f0f3a56db0c544ec1e8d0233c5dd424e00c7bb1fe874a7ea5df4f3aa1732e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringEnd", value)

    @builtins.property
    @jsii.member(jsii_name="substringStart")
    def substring_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "substringStart"))

    @substring_start.setter
    def substring_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ac75064b2a9934cfe56d0ceeeaab36f0afceaded8d762ad88af8fc7137628a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "substringStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d747bd5e81a08e2b5f304d94ba4a255bfc44a230a2c925fd5274fa2a3c15a091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f3cf884daaefeb9c8fac48321b6216453d28a97a6bab021010e762f39ef05a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd6c4d391da50771a8d55c5ef1e27a52fedc9f1e469f11a8a208c08fc1095fb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_field": "certificateField",
        "dcp_mutual_auth_processing_variable_id": "dcpMutualAuthProcessingVariableId",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor:
    def __init__(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a693046779e8217e88145536258c09a3df0b9503e1477c2825100022ba10c2d)
            check_type(argname="argument certificate_field", value=certificate_field, expected_type=type_hints["certificate_field"])
            check_type(argname="argument dcp_mutual_auth_processing_variable_id", value=dcp_mutual_auth_processing_variable_id, expected_type=type_hints["dcp_mutual_auth_processing_variable_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_field is not None:
            self._values["certificate_field"] = certificate_field
        if dcp_mutual_auth_processing_variable_id is not None:
            self._values["dcp_mutual_auth_processing_variable_id"] = dcp_mutual_auth_processing_variable_id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_field(self) -> typing.Optional[builtins.str]:
        '''Specifies the field in the client certificate to extract the variable from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        '''
        result = self._values.get("certificate_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dcp_mutual_auth_processing_variable_id(self) -> typing.Optional[builtins.str]:
        '''Where to store the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        '''
        result = self._values.get("dcp_mutual_auth_processing_variable_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4e1a6a56792139586b36123a36f58ba7858f436825738b8aeaf15e43bae62d6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateField")
    def reset_certificate_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateField", []))

    @jsii.member(jsii_name="resetDcpMutualAuthProcessingVariableId")
    def reset_dcp_mutual_auth_processing_variable_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpMutualAuthProcessingVariableId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldInput")
    def certificate_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableIdInput")
    def dcp_mutual_auth_processing_variable_id_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dcpMutualAuthProcessingVariableIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateField")
    def certificate_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateField"))

    @certificate_field.setter
    def certificate_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c0418e54cddf191f1416cbc5fa22c956446f70ee3ee256d6f4e43fac8f4979)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateField", value)

    @builtins.property
    @jsii.member(jsii_name="dcpMutualAuthProcessingVariableId")
    def dcp_mutual_auth_processing_variable_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dcpMutualAuthProcessingVariableId"))

    @dcp_mutual_auth_processing_variable_id.setter
    def dcp_mutual_auth_processing_variable_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a11d10db91ae36ae2aa7faf1b583ccaa2173515d83ee248d44b95f4e3756aa61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dcpMutualAuthProcessingVariableId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb45fa67183a0ec8962cadfa4eaa4c282c206e768fe55af1cb5898814565425c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b012ca3b19109b0a4894d4db7bafe232e3b1d219968c33f22f72ba42d8140d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a824b95679d1ce15b111e13d3c3e78ef3186ed0479ee0111c07d48622437af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a023c6b5cd93378aa2e8f8cabc380a051831801f57b75fc5199cb8722957246e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups",
    jsii_struct_bases=[],
    name_mapping={
        "group_names": "groupNames",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups:
    def __init__(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3ec8840fe74c211615709912d7c0ad5a9b665fa9b6119e3df998919dfd3a662)
            check_type(argname="argument group_names", value=group_names, expected_type=type_hints["group_names"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if group_names is not None:
            self._values["group_names"] = group_names
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def group_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of authorization groups to assign to all connecting devices.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        '''
        result = self._values.get("group_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27fef64d9ccb31f3389515ff8d5f0e64f85010b0657caea5f92ed3dd54afc421)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetGroupNames")
    def reset_group_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGroupNames", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="groupNamesInput")
    def group_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "groupNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="groupNames")
    def group_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "groupNames"))

    @group_names.setter
    def group_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98f0ca0f654e20421d9bab8ca5b2b420015d0e346a0200220ef67c887e4cd2c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "groupNames", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfe5d1e0bc58f96cdb7ec3e581ee5909357d466fe056387793df86090df59395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8dcc3628a65253594fdc3670532e21bef2e15dc26aafd7b0481e24d2b47c3d66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__246fb5c0e728dc6c740cf576e1b8a709af498ecb230d70c3518679251ca3e8a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7edce798ad8c182a62c0d3019233896770c7d0d95643d4ce73c39a7efc1fe5fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations",
    jsii_struct_bases=[],
    name_mapping={
        "custom_values": "customValues",
        "enabled": "enabled",
        "hostname": "hostname",
        "locked": "locked",
        "path": "path",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations:
    def __init__(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d4f547fa801be47f7aaab5abb998f934f9beec6e034a71571faa88160b40a9)
            check_type(argname="argument custom_values", value=custom_values, expected_type=type_hints["custom_values"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_values is not None:
            self._values["custom_values"] = custom_values
        if enabled is not None:
            self._values["enabled"] = enabled
        if hostname is not None:
            self._values["hostname"] = hostname
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_values(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify custom JWT server connection values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        '''
        result = self._values.get("custom_values")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the default JWT server and sets the authentication endpoint to a default path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the JWT server's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4035a0aac37b71ad4026abe62a48bb0ea26b91d025c472308b66c7e4b9abd7a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomValues")
    def reset_custom_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValues", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customValuesInput")
    def custom_values_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customValues")
    def custom_values(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customValues"))

    @custom_values.setter
    def custom_values(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7498a61e8920ab52a33d9fad4d1967e69187bbb63b72cf510d9777df0158e33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValues", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a5cf1fbaac2ca833a69a21d6ddd3d66a090c4ba3179c06241c7af5debd81f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03e9a7b2dfaaf8a5585e7b7f65a9271df566c770b3e9f414c33bfde0b32b96b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee365cd1321b2a60c912e501b31ff7c538fb23ada8015fcbd7d67f06bd7e6d25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8671ea088b5a33e5be3a6baf928163265516645c9e0b86b13ed149d8a06546c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d092d78fb1ca7e1b93e48e04cc40ea27c3784731e09dc7a201680934a1880d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9f3e31996418374dd74e70f8f192a203f7161378ceeca59059660ed9e791d38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c078ce00e1ffac119a2a43127a663f8bfc645e0b9d62875158c37db4537020f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4d7ed5cbe42d559c0e80898822fb5c5b65d0d20455bae35e0544053e3728d6d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymous")
    def reset_anonymous(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymous", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGwenabled")
    def reset_gwenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGwenabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceId")
    def reset_namespace_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTlsenabled")
    def reset_tlsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsenabled", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWsenabled")
    def reset_wsenabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWsenabled", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousInput")
    def anonymous_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "anonymousInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="gwenabledInput")
    def gwenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "gwenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceIdInput")
    def namespace_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsenabledInput")
    def tlsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tlsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="wsenabledInput")
    def wsenabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "wsenabledInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymous")
    def anonymous(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "anonymous"))

    @anonymous.setter
    def anonymous(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3dce12a2b340fb5b0a61afca415b05f877227015ed2e4d2f1738ec743973122)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymous", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5685c7e433fd5f768ffa9e1a31a45c73e09990c70fb8ce82fda8563f58a79ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="gwenabled")
    def gwenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "gwenabled"))

    @gwenabled.setter
    def gwenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4134552e2f933258fe6cd535e30fdccf7905282dd87f46140d00b374159db86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gwenabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__718db57bc183e9824ae0d8f3bb396317b861c3389cc37f4a890f915230d4edfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceId")
    def namespace_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceId"))

    @namespace_id.setter
    def namespace_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__215a927a9873b45f1e44993d748c4b3feb5cfbf55149385530c34313a90f50c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a763ccef43d92274feab1bdcd522f4f755ba6655bcec48b3ad55dbf671058521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tlsenabled")
    def tlsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tlsenabled"))

    @tlsenabled.setter
    def tlsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8454287f2a6955d4cf603caa0e309e13bfaeeb7c37a6340610781627dcda1bc8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cfbdb0738ef0945ff03ea8e13f09f051ab549e9dc3a0885380920b99e35dfca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="wsenabled")
    def wsenabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "wsenabled"))

    @wsenabled.setter
    def wsenabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a900885d4c84a1680acae63d637cc705dc25de7fbd2cc4c5028fe37eb7d74143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wsenabled", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d1355672f5de510fa8891851c46a3e48c55a3a7ca6ddb316a59ad7d035815e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth",
    jsii_struct_bases=[],
    name_mapping={
        "extract_hostname": "extractHostname",
        "extract_jurisdiction": "extractJurisdiction",
        "extract_namespace": "extractNamespace",
        "hostname_claim": "hostnameClaim",
        "jurisdiction_claim": "jurisdictionClaim",
        "locked": "locked",
        "namespace_claim": "namespaceClaim",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth:
    def __init__(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63285d845501b910ec0b0c146cd61f1ad7cea0a5c73a1150c12258d23e5cdd96)
            check_type(argname="argument extract_hostname", value=extract_hostname, expected_type=type_hints["extract_hostname"])
            check_type(argname="argument extract_jurisdiction", value=extract_jurisdiction, expected_type=type_hints["extract_jurisdiction"])
            check_type(argname="argument extract_namespace", value=extract_namespace, expected_type=type_hints["extract_namespace"])
            check_type(argname="argument hostname_claim", value=hostname_claim, expected_type=type_hints["hostname_claim"])
            check_type(argname="argument jurisdiction_claim", value=jurisdiction_claim, expected_type=type_hints["jurisdiction_claim"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument namespace_claim", value=namespace_claim, expected_type=type_hints["namespace_claim"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if extract_hostname is not None:
            self._values["extract_hostname"] = extract_hostname
        if extract_jurisdiction is not None:
            self._values["extract_jurisdiction"] = extract_jurisdiction
        if extract_namespace is not None:
            self._values["extract_namespace"] = extract_namespace
        if hostname_claim is not None:
            self._values["hostname_claim"] = hostname_claim
        if jurisdiction_claim is not None:
            self._values["jurisdiction_claim"] = jurisdiction_claim
        if locked is not None:
            self._values["locked"] = locked
        if namespace_claim is not None:
            self._values["namespace_claim"] = namespace_claim
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def extract_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a hostname from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        '''
        result = self._values.get("extract_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_jurisdiction(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a jurisdiction that defines a geographically distributed set of servers from JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        '''
        result = self._values.get("extract_jurisdiction")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_namespace(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Extracts a namespace from JSON web tokens (JWT).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        '''
        result = self._values.get("extract_namespace")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the hostname from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        '''
        result = self._values.get("hostname_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jurisdiction_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the jurisdiction from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        '''
        result = self._values.get("jurisdiction_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def namespace_claim(self) -> typing.Optional[builtins.str]:
        '''Specifies the claim in JWT to extract the namespace from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        '''
        result = self._values.get("namespace_claim")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32d7d3d45880fbd2056eeacfe9b0546e0a99d3ebcd6d090c619d0bf42de8a687)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExtractHostname")
    def reset_extract_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractHostname", []))

    @jsii.member(jsii_name="resetExtractJurisdiction")
    def reset_extract_jurisdiction(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractJurisdiction", []))

    @jsii.member(jsii_name="resetExtractNamespace")
    def reset_extract_namespace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractNamespace", []))

    @jsii.member(jsii_name="resetHostnameClaim")
    def reset_hostname_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameClaim", []))

    @jsii.member(jsii_name="resetJurisdictionClaim")
    def reset_jurisdiction_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJurisdictionClaim", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNamespaceClaim")
    def reset_namespace_claim(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNamespaceClaim", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="extractHostnameInput")
    def extract_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="extractJurisdictionInput")
    def extract_jurisdiction_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractJurisdictionInput"))

    @builtins.property
    @jsii.member(jsii_name="extractNamespaceInput")
    def extract_namespace_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractNamespaceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameClaimInput")
    def hostname_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaimInput")
    def jurisdiction_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jurisdictionClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="namespaceClaimInput")
    def namespace_claim_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "namespaceClaimInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="extractHostname")
    def extract_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractHostname"))

    @extract_hostname.setter
    def extract_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c0e23f925e8ba5b8e471193400ac6d419510e36c7566aee93c4244537f82b71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractHostname", value)

    @builtins.property
    @jsii.member(jsii_name="extractJurisdiction")
    def extract_jurisdiction(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractJurisdiction"))

    @extract_jurisdiction.setter
    def extract_jurisdiction(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6430a7bb3f2a12b2c6752b5abe78650c84adc4e96a6721b27e1aaaaf0748276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractJurisdiction", value)

    @builtins.property
    @jsii.member(jsii_name="extractNamespace")
    def extract_namespace(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractNamespace"))

    @extract_namespace.setter
    def extract_namespace(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df56ec2bd3635a0c201f144364dcde0c291ccd2fd66d3c3c6ed40c8169654ae9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractNamespace", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameClaim")
    def hostname_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostnameClaim"))

    @hostname_claim.setter
    def hostname_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0c55f0d5d8dcab2f237237820fee776d44911584577ff35ac9f449bfcd2c344)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameClaim", value)

    @builtins.property
    @jsii.member(jsii_name="jurisdictionClaim")
    def jurisdiction_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jurisdictionClaim"))

    @jurisdiction_claim.setter
    def jurisdiction_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c83c9e94a144ff7212ea8c85e1819f0fe699843a9c7b23ece62b433af32da203)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jurisdictionClaim", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56056fbb8a43673edbd7d01585111f8e1dba65db6924a87266bb1ec734f02bcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="namespaceClaim")
    def namespace_claim(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "namespaceClaim"))

    @namespace_claim.setter
    def namespace_claim(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d32e57115625461ddc5b0b2dbf4b7c0245138461eac38516e289a18b2ea375)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "namespaceClaim", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c991173aa80cd53fdc7a2277ae313295ef66e8c4599417825ff345714ab66d57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__275a9d7f7c4b934c108729fc5ec7028311da0a8ae47e8082b895dd597d264dd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fbea1856c698e9dd52ee7524da47e96947b19a42fcf7acdac4c04b82c9db9da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b2a85d48028dc6183310a690bc2b299713a89a6438032078aa29cf81a9229a9)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''Enables the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f61c72986963d0f109dca81746b2247a9d7d24c17ef35c081a738dd15db7729)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3348405011531ff26cce3d8837e207016ed08b3a20c8e4ce95b8e9c0eb94e33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33489f0173af581bda5fbc8a823c4ec186d33e0791a74e6fd0ab7fe80b6a6074)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d1ba0a28cb21100c3ac4acedb960fa41ca4bab9e9df087947786f0a7ef33422)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f42aec63c6317d2f6071b6ed0130d22b1704cd98c6a374a398ccb83e90d36d61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f5b7cfe7cd74df13f6701c73fb78faa2a03f329b2c9d61ea160d588683d2201)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "reason": "reason",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b4933a69d6aa735f58f8abdb8c697d65d0f380503ef08b0be7b08f8f46f835)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reason", value=reason, expected_type=type_hints["reason"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if reason is not None:
            self._values["reason"] = reason
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies access when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reason(self) -> typing.Optional[builtins.str]:
        '''Text message that keys why access is denied.

        Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        '''
        result = self._values.get("reason")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1fda297769dc7fb2631a194c5d308636ce2d78c00794431c558e49735e8d4e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReason")
    def reset_reason(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReason", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="reasonInput")
    def reason_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "reasonInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40d71b5e0831315e47d95528fad93d5191a5bccc8bf9be2dafdaa82d5363b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4d4cff103831d35f8b6ef3e6171d50eab17950bd16062b31e09f5fc03d83977)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reason")
    def reason(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "reason"))

    @reason.setter
    def reason(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c4318ee4085676ccdd187495460e40ad07a571f79d8ebca30549345f1b615d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reason", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beed8ec4147b02cc5dfc09c291e06347fffb77ac32881f73a326dbe58f3159c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd853132308700a8a7a86b243ece7a65837828ac96f67545608321429198da4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e53742f7362a260784d7728702d36e1fcef3617fd56c0345fd951bb3c9fafa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab683aaefed1cb4064043f9b5a4835677e34d1ebda5e584c3023a99c1873e119)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f721570016921412cc48d0c03be96a09d3b7791a1e4d631d84b274d5ff65783)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a83d9a1d1bb7d8d1a07e73622e7017e0edc0911b7117247a5ff048ceeb37279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83122f96aae0a0f66fe2fda11f759624da70c10d2c7b00fe43b1d5a79a2f88f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca80ea8fe963e046632bfe6e56efc50cbb0be2a33daf510769cd216b85a378e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a52d4d5aadcf7932342b528c88253b62e7116544e2c1bf1c3134eb59124047ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16d16f6ccb64d1053be24639cdf0c0ae6558d776ce20c1ee2ea0481e0d42076)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58f2c0c02d8be46f1cffcb82abd2810640ff702573a23baac8b74befb96e552)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of information about the device with which to generate a separate cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c397e7475f89a457ae2bde3633f685fe751bf6679079eeb61860a0149bf23bc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6841272ced7031082aa633fd9ba69728e689c1b459ba08b93af3ccc52b2394cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbcf40f817c3111cb2c766315f10dc99d271efaceab812a26471a439e263ff27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264cc801719eb9dd8450d3cda26098fbd9dd191f37f730b8247242d3b3b43871)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1506ef8c4d4ac10a44b73ddfebeae06839310ca68c4c782d0b6b360562aa5b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ea756e4d6b1c1190777c6e50a6135a16d02e35cc6538b4d937bec41a5287e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader",
    jsii_struct_bases=[],
    name_mapping={
        "elements": "elements",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader:
    def __init__(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d14a4d3304e3582bfa395c2889984ce53592a53f03283ee6d5f20364fa9ddf90)
            check_type(argname="argument elements", value=elements, expected_type=type_hints["elements"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if elements is not None:
            self._values["elements"] = elements
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of information about the requesting device to send to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        '''
        result = self._values.get("elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed4c478a8f5ea8327f0508211c902ed4eca3ab69bb12ea60aa192b87d0c39766)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetElements")
    def reset_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetElements", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="elementsInput")
    def elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "elementsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="elements")
    def elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "elements"))

    @elements.setter
    def elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078d3b2f9b60eb947c395f81e3a91e18aa58b6ebe409ba4794ba39d4da7a6cdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "elements", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a49ac659a66934bf78530620999be9ea8d82d4b5c65304d20e66a9670717df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a687115457e9dfb905ca7acffff3f17f4b2809baaf99ed3a889d0fbbf20b426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e630ad17e20a8df37cd91b4012b5cdc2b6b14497d9fe0ce66bcf30ded1efcd11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d00b9e26ddf738225af3556291a7688fc8c8958c48e9242c813a71e82d521fbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4ee04db3ddbf72d3174d76bc5730f4edf4c005406518efdec76de39b2566e40)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh an expired DNS record after serving content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Set the maximum allowed time an expired DNS record may be active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef7a610c06c7c41bdc34408ba4e3ba12cfcce03a950d3ea70c012f42ef907736)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25d857ef55c850ff61eae21d41f8e48b3290f588fee6fed6512f926a85160d56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6ff2cab6e85a9477fa7de6a94558b43abca6c8c510ba86e9bb92c92f0ad312)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce2afdede3c65de6df38037574b1a47abcc04ec701eb44a3ac118104f2d9f8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__697c03b3d63a597a7504048f019fdfa1704434be6c95c30b55d39cbc4e28f0d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65ac967fc07e49543382196a9603788f54b7553393a14b431c059e84ebd42d89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e8a573ace3717a2b342ef20ab5c996233e282fd46954b9493a1c7b28bf8079c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh",
    jsii_struct_bases=[],
    name_mapping={
        "delay": "delay",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh:
    def __init__(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4eb0f105b13713cfdec65a15c6fd8b3464ad2dc583ec43a5601f0bfeda1795)
            check_type(argname="argument delay", value=delay, expected_type=type_hints["delay"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if delay is not None:
            self._values["delay"] = delay
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def delay(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        '''
        result = self._values.get("delay")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to refresh DNS records before they expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe47582364d19764e01aae8bff622c0569773a6684a0e37bd51677f922443c0b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDelay")
    def reset_delay(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDelay", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="delayInput")
    def delay_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "delayInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="delay")
    def delay(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "delay"))

    @delay.setter
    def delay(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365f3efff94525fc7cea8255179055debc8bcf04001f0dbc335ddc0fd0511beb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "delay", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a618f2c2971fbf5f66508b2453ee465ca59104e7e9096c74dfcee4a69cef2fb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d5794dbbb9d83f83e5b9c6a6de83d99bf7b76bc598ab8d87f001f742d1468d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8146e433f4375b0b2e2b994ca506e898008933fc10427d46ab36d148a7b43406)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e2406c6acb8bb4d7e1fcfd2bb293b1464092b1e8dbe9147e4d969f5ba5150f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bc1787295767b194aac68e6c3307f6aa16656d381c31900c5aeb7d003567fc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b2723f67ce2cfb18b665814bcd826514e9213434d6e195d4fc4263748a08a79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9cc5cb4190d43f93255af923c1b4212badf2a2dea167fdf06d68d8afbae94ee)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the protocol downgrading behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4d9bbbd2abfc0b9ad500469590ab0bb2b4b8d16e8d145a78a7ec5d5bb4c0748)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e90924ea926bc77d33d9fcc6bc2cf4c37379f21beca5444d7e55058c2d02af60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__264cf4ecf4cb8e5b5a098c1adfdaa2c4739c6376d81aed81f80265131e1cb930)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efe92cc8402b5894138e09da144015d73da28eedb42a63baab97137e7dd2d81f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4620975d8d95ceac2679d7d2c1e5ac38a3e4754d7793b52a212d12dd6adf174c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94c1553cb33cc0f5f6e9fe4f0f4dfda1c4a70d0c3c79a5b97ff40a03e450630b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdaaa220e4ea1ab3fc33e337f08c3d5afc029e910aff38bfb0105b87aadef9e0)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f751fbaa176e4a71d5a849e7c82c3e8364d3d228a4c898f44b30a63a98a70bf5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92796c75d656ae2ef3182c7b6ee269220e404191148b61fad76b0850672c5313)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e3cf8da4f377bde367f700b120f88f186e80b12c000582f358d560418b3d760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53b1e1fbe46f0037179f670f4b985bbe75c628af8f4c9b2d375fe503bcc57b55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de5b7da1da7398b365ac411867b0424c80b0dc856a5b0ef1414443cb80bbc31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8824e47aa6810e617a153e1aa136431847f65063f8e5900e466f9c23dd69b6cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80058994f07b5dc4a1104040dee7c588e4a4307965b6373f26f6a43f84a34a02)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c4f750efe63bb09fc5566a921dd53c41970333b7835664dd9657c29a28d1d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9823a2bd5db936ee51b2d0f3df633228e3794b79b5baa48c1feec63fcff2fd94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f76ebcf6a903d7aa1fec02f37491f1bc5700f1a71ae4a96cf5823b6a9441e7e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f9c0ece340bc30ea022de89cd5567441bd0f71a1759bc847040bfbc8a26c550)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bf1dede66e34a291eaa59c2519bb6e0fe2ceb54e1bf0ed1e95ef87f72ecfb32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ddfef0730020e0de9545c6896015d80d415f362389cae807f2f9f09bdca1372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache",
    jsii_struct_bases=[],
    name_mapping={
        "allow_behavior": "allowBehavior",
        "behavior": "behavior",
        "locked": "locked",
        "send_headers": "sendHeaders",
        "send_private": "sendPrivate",
        "template_uuid": "templateUuid",
        "ttl": "ttl",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache:
    def __init__(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55a7f4b741d6a6fea807978f47aa68915ed419d627ef47f99caf6d91ff19c01)
            check_type(argname="argument allow_behavior", value=allow_behavior, expected_type=type_hints["allow_behavior"])
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument send_headers", value=send_headers, expected_type=type_hints["send_headers"])
            check_type(argname="argument send_private", value=send_private, expected_type=type_hints["send_private"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument ttl", value=ttl, expected_type=type_hints["ttl"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_behavior is not None:
            self._values["allow_behavior"] = allow_behavior
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if send_headers is not None:
            self._values["send_headers"] = send_headers
        if send_private is not None:
            self._values["send_private"] = send_private
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if ttl is not None:
            self._values["ttl"] = ttl
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_behavior(self) -> typing.Optional[builtins.str]:
        '''Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        '''
        result = self._values.get("allow_behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify the caching instructions the edge server sends to the end user's client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def send_headers(self) -> typing.Optional[builtins.str]:
        '''Specifies the HTTP headers to include in the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        '''
        result = self._values.get("send_headers")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def send_private(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        '''
        result = self._values.get("send_private")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ttl(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        '''
        result = self._values.get("ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63c0910a181e179b1d542e7c44a6a4e08bf8cdeae61f275e691441bba24f8ede)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowBehavior")
    def reset_allow_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowBehavior", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSendHeaders")
    def reset_send_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendHeaders", []))

    @jsii.member(jsii_name="resetSendPrivate")
    def reset_send_private(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSendPrivate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTtl")
    def reset_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTtl", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowBehaviorInput")
    def allow_behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sendHeadersInput")
    def send_headers_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sendHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="sendPrivateInput")
    def send_private_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sendPrivateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="ttlInput")
    def ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ttlInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowBehavior")
    def allow_behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowBehavior"))

    @allow_behavior.setter
    def allow_behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ed9cd01fa0ddf9bc0f682eafabfae4845079781a40471690a3f04a5b5f1ce6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowBehavior", value)

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef67c7e7315853b587839baec91462d21b1b479e8132c1027ec4a0422f7393f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad154af65362b9fe37fdbd3e9798edfbdcb26f39feb05b4f5ad78ba40de8ed7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sendHeaders")
    def send_headers(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sendHeaders"))

    @send_headers.setter
    def send_headers(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c77f960f334e88a1709cbb3270e1e9c697d6d9347b3e85dde9fcfdaed33f7b70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="sendPrivate")
    def send_private(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sendPrivate"))

    @send_private.setter
    def send_private(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__150796f5f49f727b2d213ed67e909882042266c3799527226a14cf6dc58a282b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sendPrivate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96eeace99890146a55b9c2e2d4874e3556a8ccbec5994103f11a75118dc5dfc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="ttl")
    def ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ttl"))

    @ttl.setter
    def ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd703e9b16d60a9a8ddc46c8d2e4f0e653149dff6b358d0a27e7031020f76be6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ttl", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c3d265422f13ce79dc9ba406525e98b2db20ade81a8558b730d247f80bb93f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b156eb1f19a3d4648cc6d85146846f70ace28972cd6398a324c748988600869)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__677415cae9b133f0499d35a46eb096f73afb98b714fc63fcb7a0e3e630c27794)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the quick retry feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ce645b22f1cfffa18ed62f73b6c67359703dbb34363051575699ed4ecaac50)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09fdbcaccb7b012cf91178ffa25bcb7c9a7953fc024eeca1dc771f732160b631)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3e928d99106b8d2fadb857c9ce85650806f0f330f8488776ddfc30cb325d5cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14936c21088b83d952e83be04eb793af98f564840ae5b52592f278f82abf7fd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3505da1b8906d6c46899a06f676480e57345c5a96bde7a6c744cd09b26dc13fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b53a3ad7fd1a9352240702f3a4f6e2832f3a1bdd6af3db8a6747e32d6f48a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "throughput": "throughput",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d2601da929c28f5041fe12ab48d113adfa91c84910a02dced85fe632e1456e8)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument throughput", value=throughput, expected_type=type_hints["throughput"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if throughput is not None:
            self._values["throughput"] = throughput
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def throughput(self) -> typing.Optional[builtins.str]:
        '''Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps.

        If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        '''
        result = self._values.get("throughput")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7c4a013f929e5baeae0dc15f8744f2fd845dc16443c3926e62446fc5b887330)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThroughput")
    def reset_throughput(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThroughput", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="throughputInput")
    def throughput_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "throughputInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffffe735bc3f0be15b265b9cbb5336854eb270a52d8a44ec41006c2a1d43b8bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfdde72e2358c3ab98601de496055a2fe0341b4c77929f5e1388ee27eba12d74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="throughput")
    def throughput(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "throughput"))

    @throughput.setter
    def throughput(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70ff19cd56192f5939b329be24084ba9b6faa6eab0492a4f3c7c0b626cdcfed5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "throughput", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__483244c1415c70e4be61c897dd018497207c74f5d8e0f46a590f9998723a6c83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b65394fbe3c54c2601275405a3a1b810b47aad3691ff5082c9a38a0aab548696)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent",
    jsii_struct_bases=[],
    name_mapping={
        "image_compression": "imageCompression",
        "locked": "locked",
        "prefetch": "prefetch",
        "real_user_monitoring": "realUserMonitoring",
        "sure_route": "sureRoute",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent:
    def __init__(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1e99d2f1311b09b318f521d9a18940fa2c1aed750d5ac854fe2cfe01c5deb60)
            check_type(argname="argument image_compression", value=image_compression, expected_type=type_hints["image_compression"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch", value=prefetch, expected_type=type_hints["prefetch"])
            check_type(argname="argument real_user_monitoring", value=real_user_monitoring, expected_type=type_hints["real_user_monitoring"])
            check_type(argname="argument sure_route", value=sure_route, expected_type=type_hints["sure_route"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if image_compression is not None:
            self._values["image_compression"] = image_compression
        if locked is not None:
            self._values["locked"] = locked
        if prefetch is not None:
            self._values["prefetch"] = prefetch
        if real_user_monitoring is not None:
            self._values["real_user_monitoring"] = real_user_monitoring
        if sure_route is not None:
            self._values["sure_route"] = sure_route
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def image_compression(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables image compression for subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        '''
        result = self._values.get("image_compression")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows subcustomer content to prefetch over HTTP/2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        '''
        result = self._values.get("prefetch")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def real_user_monitoring(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        '''
        result = self._values.get("real_user_monitoring")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def sure_route(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Optimizes how subcustomer traffic routes from origin to edge servers.  See the ``sureRoute`` behavior for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        '''
        result = self._values.get("sure_route")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f623b75fa09ed0c728fe5d698c7481ba1ae839945ca3eceb00ebba07c8cbec9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetImageCompression")
    def reset_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageCompression", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="imageCompressionInput")
    def image_compression_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "imageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="imageCompression")
    def image_compression(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "imageCompression"))

    @image_compression.setter
    def image_compression(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__274c56cb58faf069ab0bc56ede0f3aee056b6a7b4ba06d4584b9a5e957a8d512)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageCompression", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89667fe8e9b290740a23270255576990fadac79839439cf1e5e3293c2f3937fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetch"))

    @prefetch.setter
    def prefetch(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__930b92d3bba068363a2c1901c3e8bdd41d87b7adc285198d51658cb611122ae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetch", value)

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "realUserMonitoring"))

    @real_user_monitoring.setter
    def real_user_monitoring(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c407f3b15cde37e77c4271978df2ff4dc34b5f5153e10532ae7da1dc2244a969)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "realUserMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sureRoute"))

    @sure_route.setter
    def sure_route(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaa634a7815f2a675130223323969d1dc1d2b4d526ee95c0d7254bec9db4f4c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sureRoute", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cddc927a3116e143297dd82d658714cb5fb6c16234701634306c45e62dc37621)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a979c6f39d58a0d8f1041b03a87cd7c7271efdc6e1a58b425fc75545726380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784e3fea6f1cac8d9984c0281638b7d0d3538669d8233ef5c3bbd43a4c67aab0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__967961039ac4f0dcb226612104c76bc13628f29f8ea25417ca0c45e77980ad12)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables sending a compressed archive file with objects.

        Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67965f4169ac6356e6a072b004228df0e9a3671bf54a51c3263247eccc8381b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71c4461b106a1c46ac120f187a725a2e3e74e2b01f7a40e7ce64ff2f86470004)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cf9f1e7857d8a95bbcbc9306ae6b6d3b255ebcf4278daebc44aa7c662959133)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f92562983bb35d5dc57dde9459a1c67363dd49eca1be5010cee73ad7784ca0b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de849068aa81d7ee2414f8e4c5c98502241e4e66e0f6e967b191ed897fa5856)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0862b5a1869881d1cdb8ae8234f4dd609234a18c4de9335ac19dfa13ddfce57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase",
    jsii_struct_bases=[],
    name_mapping={
        "database": "database",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase:
    def __init__(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b62b7bbcd4ecc7e2bd75fcd6a0967db0fa23bdf2db796978f6d59e3d20d8fe52)
            check_type(argname="argument database", value=database, expected_type=type_hints["database"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if database is not None:
            self._values["database"] = database
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def database(self) -> typing.Optional[builtins.str]:
        '''Specifies a default database for this property.

        If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        '''
        result = self._values.get("database")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a database name in requests.

        If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the database name. By default, it points to ``database``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the database name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ee2cd80f3438edfb0066e074cd2da67e695185a3688c59e0a8825c17f7a5cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDatabase")
    def reset_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatabase", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="databaseInput")
    def database_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "databaseInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="database")
    def database(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "database"))

    @database.setter
    def database(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42051d839c1cb8e22f3fac5135eb3274fb4354e1754236d8fbba5bd17cffc5fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "database", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__730639e8a1c8413dc0a5c454d04988383f5211094811997dae262bae5fb6ce2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661767a4d7e5fa3994f2d85ba172b85e19ff8a17a634327c5b0171f37a027ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cf303e4fadd094f9d1196160335f8905f36421bb5fa3e0458fc682905ee9481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddaf106e25bd4a5582390ba625e563078abbcd9736a107073770652ff1f6764a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5460acf2bd3233df43fe563a16039e45c09d378ea759842414ba65d8cc7ba64d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2b16be7a520516f200deb18cd9e8229fece674003ca86c722f01f39564a9710)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e69794c2e9e39dd11bbcfd3471fc793cb5386a212c40adf65b048c384dd756d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8df4a8fb0c214e285fbf1a9a799e7d6dd96f63103b3372ae76356759bb64e5ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset",
    jsii_struct_bases=[],
    name_mapping={
        "dataset": "dataset",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "regex_pattern": "regexPattern",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset:
    def __init__(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bde58ff9210a03b705e2938699f37353a5e437652a1272c622bc6fc446dccd94)
            check_type(argname="argument dataset", value=dataset, expected_type=type_hints["dataset"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex_pattern", value=regex_pattern, expected_type=type_hints["regex_pattern"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dataset is not None:
            self._values["dataset"] = dataset
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex_pattern is not None:
            self._values["regex_pattern"] = regex_pattern
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def dataset(self) -> typing.Optional[builtins.str]:
        '''Specifies a default data set for this property.

        If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        '''
        result = self._values.get("dataset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to pass a data set name in requests.

        If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_pattern(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression that matches the data set name in the URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        '''
        result = self._values.get("regex_pattern")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78baabd60bd19395f19080ab30b088f9c8609f2a8ba96beec00e051c76160352)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDataset")
    def reset_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataset", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegexPattern")
    def reset_regex_pattern(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexPattern", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="datasetInput")
    def dataset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "datasetInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexPatternInput")
    def regex_pattern_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexPatternInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="dataset")
    def dataset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataset"))

    @dataset.setter
    def dataset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8bd088a33aa9bea1d18886353b492fe3657d02ee30f13b56fb8560457606b1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataset", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1869672a762902762fff20cf240a29cdeed3bf3a4cf0df748ebfa7757e7989f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31646e23c0168ba62826da5bd3de5dcab9b79a3936cce660b45c6150deaed989)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e285b2c6abc3c9013a30727f911fb77a8343b245a7178bb3ad09a21889a515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__759e86582d50529242f770e3b48350f6bbc77592163d88aad97e366cf869e2fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regexPattern")
    def regex_pattern(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexPattern"))

    @regex_pattern.setter
    def regex_pattern(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a76e896bbd90a29a53b5221c623e1a5b53df01e6e846c2cf871c31a445dc056)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexPattern", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63eb3bfc60a5aa1aecbfbb4004ffb3215a3ed4c9a5f51a2b6d6d9418efb05775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891972938def4d3116c46c78144a104d1ab680a14f6525359d294a1e04b651ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6e1c398f540c4a7c24058721af3d87f3ba17d86955ca1033b86436b9858b013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2800517951b18eeea4d9e55c781ef4500f5af184285d5e664e54883dddce9b3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73381d39e2f9dca04af8c4cea2d08cfb5989191296859cddead863acc7bc79de)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2459462a2f339724acbbf544524c0f758eca538bee6f62b4ca012189840d2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__891dbaf7c812c5c02bfe22e79313b6b012f005c7ac12768d4629026b9bb6afc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd4337ac2b12e8fd0f654b2fc902cad80c47e1cade2aee5febc1d59531365e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbfbb936d301cd2022ebe7cff14c51fd3c8bec81448a1d1b6ea7abb9394e9332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14318d6df4566abe78d967680477ff40a99c7cef0870f885de10158a35f7b79f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect",
    jsii_struct_bases=[],
    name_mapping={
        "aggregate_lines": "aggregateLines",
        "aggregate_size": "aggregateSize",
        "aggregate_time": "aggregateTime",
        "api_connector": "apiConnector",
        "api_data_elements": "apiDataElements",
        "destination_hostname": "destinationHostname",
        "destination_path": "destinationPath",
        "enabled": "enabled",
        "locked": "locked",
        "override_aggregate_settings": "overrideAggregateSettings",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect:
    def __init__(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a8f27f86bf5672abc616598735354f7b4d4a0ffd3fad196c1c852a43399656e)
            check_type(argname="argument aggregate_lines", value=aggregate_lines, expected_type=type_hints["aggregate_lines"])
            check_type(argname="argument aggregate_size", value=aggregate_size, expected_type=type_hints["aggregate_size"])
            check_type(argname="argument aggregate_time", value=aggregate_time, expected_type=type_hints["aggregate_time"])
            check_type(argname="argument api_connector", value=api_connector, expected_type=type_hints["api_connector"])
            check_type(argname="argument api_data_elements", value=api_data_elements, expected_type=type_hints["api_data_elements"])
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override_aggregate_settings", value=override_aggregate_settings, expected_type=type_hints["override_aggregate_settings"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if aggregate_lines is not None:
            self._values["aggregate_lines"] = aggregate_lines
        if aggregate_size is not None:
            self._values["aggregate_size"] = aggregate_size
        if aggregate_time is not None:
            self._values["aggregate_time"] = aggregate_time
        if api_connector is not None:
            self._values["api_connector"] = api_connector
        if api_data_elements is not None:
            self._values["api_data_elements"] = api_data_elements
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if override_aggregate_settings is not None:
            self._values["override_aggregate_settings"] = override_aggregate_settings
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def aggregate_lines(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum number of lines to include in each log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        '''
        result = self._values.get("aggregate_lines")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the log's maximum size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        '''
        result = self._values.get("aggregate_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aggregate_time(self) -> typing.Optional[builtins.str]:
        '''Specifies how often logs are generated.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        '''
        result = self._values.get("aggregate_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_connector(self) -> typing.Optional[builtins.str]:
        '''Describes the API connector type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        '''
        result = self._values.get("api_connector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def api_data_elements(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data set to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        '''
        result = self._values.get("api_data_elements")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the target hostname accepting push API requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the push API's endpoint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Cloud Monitor's log-publishing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_aggregate_settings(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides default log settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        '''
        result = self._values.get("override_aggregate_settings")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3724b2ff04ed862bc99d4958131ae44d7d17b373c97a26ef2250256bf82b1ba6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAggregateLines")
    def reset_aggregate_lines(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateLines", []))

    @jsii.member(jsii_name="resetAggregateSize")
    def reset_aggregate_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateSize", []))

    @jsii.member(jsii_name="resetAggregateTime")
    def reset_aggregate_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregateTime", []))

    @jsii.member(jsii_name="resetApiConnector")
    def reset_api_connector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiConnector", []))

    @jsii.member(jsii_name="resetApiDataElements")
    def reset_api_data_elements(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiDataElements", []))

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverrideAggregateSettings")
    def reset_override_aggregate_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideAggregateSettings", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aggregateLinesInput")
    def aggregate_lines_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateLinesInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateSizeInput")
    def aggregate_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateTimeInput")
    def aggregate_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "aggregateTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="apiConnectorInput")
    def api_connector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiConnectorInput"))

    @builtins.property
    @jsii.member(jsii_name="apiDataElementsInput")
    def api_data_elements_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "apiDataElementsInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettingsInput")
    def override_aggregate_settings_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideAggregateSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregateLines")
    def aggregate_lines(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateLines"))

    @aggregate_lines.setter
    def aggregate_lines(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be511be8fa940a0667af5d95e416b49b27704abec7cc2f761e55346ff449bd9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateLines", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateSize")
    def aggregate_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateSize"))

    @aggregate_size.setter
    def aggregate_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92bc71a24aedbce8600386cc21fe640975c13f50d7d0db4771880f0d00cb784a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateSize", value)

    @builtins.property
    @jsii.member(jsii_name="aggregateTime")
    def aggregate_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "aggregateTime"))

    @aggregate_time.setter
    def aggregate_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7baacc86f38b7d9c6c348588046bd152f0fa2894a0db4c512505a5446627665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "aggregateTime", value)

    @builtins.property
    @jsii.member(jsii_name="apiConnector")
    def api_connector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiConnector"))

    @api_connector.setter
    def api_connector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41b1a797b18efb9b6614d8f0dfd7bc485291b06131c8311c29d4ba1009bf8d30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiConnector", value)

    @builtins.property
    @jsii.member(jsii_name="apiDataElements")
    def api_data_elements(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "apiDataElements"))

    @api_data_elements.setter
    def api_data_elements(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ad34d44a04441c04e343c094d099dc89852b4e666eb842374a884de3e636df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiDataElements", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f629e03462b3b9a331dd1578e4cf09fc123fc424d70f073ffdd7f90c1c6289f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcb272e3ee3ee6ccf9041a2c4cb32a97f3d14a85d8e64145625c0f5df131036a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e708a58a452500559901e623b1caec7c01b210d8f1fdad3f7c91fce09ad6e78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__540bd1934bff0874a7be55de186678b4b07473bcac141703e7a18790e2ffc3b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="overrideAggregateSettings")
    def override_aggregate_settings(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideAggregateSettings"))

    @override_aggregate_settings.setter
    def override_aggregate_settings(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a17ef9e557b0dae18d5c6f0884683f54ec50d704258ebc98de2c9e3f54c66f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideAggregateSettings", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07a7fa1b0cb02732269196788c338449c9dfc71c48cb57372f317fd9639a3c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66d359041b78facbe818c07d1c62d65e765cd8eb4aff62fcf5207835ba64036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb85b8ccab07564784c7eaa2c894ac1e98d0679994afb0e8ab5ce48d43ba10f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc7da95f53a71ed24017c4f8570ff8740285bb2dc7cf2d4b9b422e4427f6ed9)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A description of what the ``xml`` block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4aad7265995d0d15348d7d053d6a4a5a3db7970350f2499eafaab9c9d907e6ad)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf83af430a82fe1f793b5b0daa7c29f4925a8d1e25a0af25d50538e0dd3b47a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3239f17b20709be5a800e5fcaafb9fa882b2c229362d0fa09eeccef3391d8013)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b4bb3431fb6f9c419e51820a3b6837cc56f0555cb77cead4807427529637a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10eaaa41dd088ff25f637b25f46b5c7ab1d93542b648ae2185de96680b9051ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f837b0782a4cd0bd2f85e4871b58dfff39cf935240e8b0e242139b77b9285e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be25788cc77084cdab17f61b8fc8be216ba726820f37cb2fa38ca5cb49897aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_failover": "enableFailover",
        "failover_rules": "failoverRules",
        "failover_title": "failoverTitle",
        "hostname": "hostname",
        "ip": "ip",
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules", typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b801ec7c1e27982a4cf4a6f650a949f413b25f22691bd92d092a707f4c5231b)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_failover", value=enable_failover, expected_type=type_hints["enable_failover"])
            check_type(argname="argument failover_rules", value=failover_rules, expected_type=type_hints["failover_rules"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_failover is not None:
            self._values["enable_failover"] = enable_failover
        if failover_rules is not None:
            self._values["failover_rules"] = failover_rules
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if hostname is not None:
            self._values["hostname"] = hostname
        if ip is not None:
            self._values["ip"] = ip
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB data center, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify failover rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        '''
        result = self._values.get("enable_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_rules(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]]:
        '''failover_rules block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        '''
        result = self._values.get("failover_rules")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules"]]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the data center's hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ip(self) -> typing.Optional[builtins.str]:
        '''Specifies this data center's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    jsii_struct_bases=[],
    name_mapping={
        "absolute_path": "absolutePath",
        "context_root": "contextRoot",
        "failover_hostname": "failoverHostname",
        "modify_request": "modifyRequest",
        "override_hostname": "overrideHostname",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules:
    def __init__(
        self,
        *,
        absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        context_root: typing.Optional[builtins.str] = None,
        failover_hostname: typing.Optional[builtins.str] = None,
        modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param absolute_path: When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page. Otherwise when disabled, the path is appended to the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        :param context_root: Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        :param failover_hostname: The hostname of the data center to fail over to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        :param modify_request: Allows you to modify the request's hostname or path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        :param override_hostname: Overrides the request's hostname with the ``failover_hostname``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad9fec87c0b0d37405b8762a744727ca6fab2a44af7efbb0c34262e13b37a96f)
            check_type(argname="argument absolute_path", value=absolute_path, expected_type=type_hints["absolute_path"])
            check_type(argname="argument context_root", value=context_root, expected_type=type_hints["context_root"])
            check_type(argname="argument failover_hostname", value=failover_hostname, expected_type=type_hints["failover_hostname"])
            check_type(argname="argument modify_request", value=modify_request, expected_type=type_hints["modify_request"])
            check_type(argname="argument override_hostname", value=override_hostname, expected_type=type_hints["override_hostname"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if absolute_path is not None:
            self._values["absolute_path"] = absolute_path
        if context_root is not None:
            self._values["context_root"] = context_root
        if failover_hostname is not None:
            self._values["failover_hostname"] = failover_hostname
        if modify_request is not None:
            self._values["modify_request"] = modify_request
        if override_hostname is not None:
            self._values["override_hostname"] = override_hostname

    @builtins.property
    def absolute_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, interprets the path specified by ``context_root`` as an absolute server path, for example to reference a site-down page.

        Otherwise when disabled, the path is appended to the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#absolute_path DataAkamaiPropertyRulesBuilder#absolute_path}
        '''
        result = self._values.get("absolute_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def context_root(self) -> typing.Optional[builtins.str]:
        '''Specifies the path to use in the forwarding request, typically the root (``/``) when failing over to a different data center, or a full path such as ``/static/error.html`` when failing over to an error page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#context_root DataAkamaiPropertyRulesBuilder#context_root}
        '''
        result = self._values.get("context_root")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def failover_hostname(self) -> typing.Optional[builtins.str]:
        '''The hostname of the data center to fail over to.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_hostname DataAkamaiPropertyRulesBuilder#failover_hostname}
        '''
        result = self._values.get("failover_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def modify_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the request's hostname or path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_request DataAkamaiPropertyRulesBuilder#modify_request}
        '''
        result = self._values.get("modify_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override_hostname(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Overrides the request's hostname with the ``failover_hostname``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_hostname DataAkamaiPropertyRulesBuilder#override_hostname}
        '''
        result = self._values.get("override_hostname")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ac563f0f58c63258b75b0f95b268eb5e6e99b34eecf7b4b32ba98e6d0187bed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3dc7d975136fa3e0586eb434e15b3a4b133b49d7e9b714f1141216866909abf7)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc6aeadcf9b788e1b695bdbc34f4b6e0ceb56d438a6f326b238d916b1d30e255)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b6345091573bc76ce5906eab3a9788b8ef7bf39703b0fb29d1a4f9e8ac84b28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3fb1c9d026f6821d0dd586c83a71de928fcf7af12d90177f5ee1e6a068f5f3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__68b707477b21abbb6d2f2cf90334e36fe38db1ed1591bbcd5b940308d3bd694d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c875159bc713849f0cbf96b6d46b2850808a05b6a44139e4c95981e1aa5f094e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetAbsolutePath")
    def reset_absolute_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbsolutePath", []))

    @jsii.member(jsii_name="resetContextRoot")
    def reset_context_root(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContextRoot", []))

    @jsii.member(jsii_name="resetFailoverHostname")
    def reset_failover_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverHostname", []))

    @jsii.member(jsii_name="resetModifyRequest")
    def reset_modify_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyRequest", []))

    @jsii.member(jsii_name="resetOverrideHostname")
    def reset_override_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideHostname", []))

    @builtins.property
    @jsii.member(jsii_name="absolutePathInput")
    def absolute_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "absolutePathInput"))

    @builtins.property
    @jsii.member(jsii_name="contextRootInput")
    def context_root_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contextRootInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverHostnameInput")
    def failover_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyRequestInput")
    def modify_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideHostnameInput")
    def override_hostname_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "overrideHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="absolutePath")
    def absolute_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "absolutePath"))

    @absolute_path.setter
    def absolute_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a57b5702365d54f7000c3b177903b9c5508ebc10c90580476b0bf4194d746d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "absolutePath", value)

    @builtins.property
    @jsii.member(jsii_name="contextRoot")
    def context_root(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contextRoot"))

    @context_root.setter
    def context_root(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7563fac2512d4f25db549e3f248fe71020f678e8c5033d75a97ad044443f4d9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contextRoot", value)

    @builtins.property
    @jsii.member(jsii_name="failoverHostname")
    def failover_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverHostname"))

    @failover_hostname.setter
    def failover_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e84920ea37bcb6ab128faaa030573b04ebf3d29cb4efd95cf4452054c62bc266)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverHostname", value)

    @builtins.property
    @jsii.member(jsii_name="modifyRequest")
    def modify_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyRequest"))

    @modify_request.setter
    def modify_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4038111df9f0e726fc3fb27956868e29b4d754be4d6d7d101babb6f41e46a270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="overrideHostname")
    def override_hostname(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "overrideHostname"))

    @override_hostname.setter
    def override_hostname(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69cd3f5aec4d08c290e9b6846b0c8a42e684ce266e25199ed50abb4fbbdc580c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideHostname", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e8a26719cd0a923a5d9a5f014bf1077a8e00020cbc68bf533a363f0d4cc4cdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65b948ee512fcd37c0cd0cb88b3ed5c7df14d82396486c2329fde27461dfdd95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFailoverRules")
    def put_failover_rules(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeaa82cc660771140bee9067dc27163095044312a99b30f332f07a9c05aec867)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putFailoverRules", [value]))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableFailover")
    def reset_enable_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableFailover", []))

    @jsii.member(jsii_name="resetFailoverRules")
    def reset_failover_rules(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverRules", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="failoverRules")
    def failover_rules(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesList, jsii.get(self, "failoverRules"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableFailoverInput")
    def enable_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverRulesInput")
    def failover_rules_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]]], jsii.get(self, "failoverRulesInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0acc23f7e452ad2fc2d891affb217f844a15f42f9926d5b423410385fc324f7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de2eec43949be69b2c7c92882505dddd291700c31a3719aacc370cff0ed6de5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableFailover")
    def enable_failover(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableFailover"))

    @enable_failover.setter
    def enable_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b8f3787357de0ba01515a0ccad25319a09d945957df039bd2e4b5997f62947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableFailover", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67ab505cd63e054c75f594c1ee5af953a3b79dbef2fb5abb9a471cc86faf9f5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ba1514b800d2ed8d249b5d19bfd6e30c47213a02483070af5b98356e156635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ip"))

    @ip.setter
    def ip(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7da8afe8a42e383bc8736793af8e975d16be66d71b9cbeff68e6eb78e009f9ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8643a9e49c54eb363a067f1504e9270df171fef173738db99bb4023b1952660d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__448ce3940125fffe5af58f9777b347c1940fb2ccfd9015f8807cdf44ffd6e15d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fccac880171c54a583e2c0f99f3b20ed7d169d41cbe11948e09a866c6547eac5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb9b58ffca707c84bac86335b6d5cc7a08ff5eb0bbffbfef548c03f02ab59bc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28ec5942715c0260a9fa9f635d73b5ae11cf0a4a866ed2ad1b460074efa6718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "description": "description",
        "enable_session_persistence": "enableSessionPersistence",
        "hostname": "hostname",
        "id": "id",
        "locked": "locked",
        "session_persistence_title": "sessionPersistenceTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc863a80716a90ed8f4eb5d0b97ab24afe1b03cf55b965c44056d1710df405cf)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument enable_session_persistence", value=enable_session_persistence, expected_type=type_hints["enable_session_persistence"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_persistence_title", value=session_persistence_title, expected_type=type_hints["session_persistence_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if description is not None:
            self._values["description"] = description
        if enable_session_persistence is not None:
            self._values["enable_session_persistence"] = enable_session_persistence
        if hostname is not None:
            self._values["hostname"] = hostname
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if session_persistence_title is not None:
            self._values["session_persistence_title"] = session_persistence_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that marks users' persistent sessions.

        The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Provides a description for the ELB origin, for your own reference.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_session_persistence(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify a cookie to pin the user's browser session to one data center.

        When disabled, ELB's default load balancing may send users to various data centers within the same session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        '''
        result = self._values.get("enable_session_persistence")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname associated with the ELB rule.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique descriptive string for this ELB origin.

        The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_persistence_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        '''
        result = self._values.get("session_persistence_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18792a0db6f7d8edf47d9ce3a3cded1afc2b19034dfb28af0f750f51c0aed923)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetEnableSessionPersistence")
    def reset_enable_session_persistence(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableSessionPersistence", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionPersistenceTitle")
    def reset_session_persistence_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionPersistenceTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistenceInput")
    def enable_session_persistence_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableSessionPersistenceInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitleInput")
    def session_persistence_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sessionPersistenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e61dfed1fca3724bb2b9f064a95f9b14c5e20a1812709511f405a46ffd924b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19fcd65bd0244f4e08841cd7f4d1a38fd05f7ed9244517382ac8b98d9fefeb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="enableSessionPersistence")
    def enable_session_persistence(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableSessionPersistence"))

    @enable_session_persistence.setter
    def enable_session_persistence(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70d5aceb491d2a07cd81f474845f131368dbb5106ce27761390534723f10990b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableSessionPersistence", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e94cddeb4071658e72a2fd35f8908348374cb1ba6b8c894ec113caa839e8bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17948b0a43974c30d2b9d8ae91c6793c0b3d9284417093c968466a1f034c2a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d07dfb6531014b6072dfa3d8943ed8ef0530cdf185a10e9c852f21631098d90c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionPersistenceTitle")
    def session_persistence_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sessionPersistenceTitle"))

    @session_persistence_title.setter
    def session_persistence_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a8e551544b0e234c93020397a9bd29fcf359190ef7e336e1983121d039bb02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionPersistenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3fd94d3a06c01593febb0c655c392035fd798f2f7539e60260423cf99a74e88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a457cfc425adac1219b350d027472738378650b3954eb80a98203aaa0229036)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e3d4619e4e21edade60f5a81525b7d1e5462ffd4de920c72ae4aefa594964a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "domain": "domain",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bd415f9cdebd214e3a8a95a7a7be59825ed8392bbf57acfb25ec589ffd6b511)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if domain is not None:
            self._values["domain"] = domain
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to use for authorization.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cookie-authorization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the value of the authorization cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2440f8eac7360f8f2705b6378fa82035d88395047d98bbbcb07f23e32c4d059a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b7d2a0bd437abf72cb93862299344da7a585b3f6fc2f8bd73324d56ab023aac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b48deef7ac28238dd7c22a60aba6b6d5bd124fccc9fbc5e4dad39fddecf1828)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22e9d018fae4995e75371d251c487333d86249bda9f68168504ba72c46d9798e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc3bdddae46e4e5bb82d27a7dfec7830e2bfaf99dc316c9f3b3fcf25b68c9fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549c783952ba4cfd3e7d1a9a9287b89ddeaa16aad0bdf73b6fb59e94b31b8ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa8cc184a0d1c910cee5b8989df51e3d843877980c78289602456feec27cc207)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a24ec09a9a938be7b5339a5c74084c3b0788e303caca9d51ea12ad58b1dc7903)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8ff1a66e1dc5a0a6899562ce5c0066844a40d351a37f07c6c83e0951d445298)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9bad4e16d2c349ccd9dab43e07c445a99404787ec8ca5963f775e930e6a48a)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Edge Redirector Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__375419442d3ef4715a4f44b518ec45f4bf3dbde2069877d30206b7c562b5fe0b)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__771ca77b5b7d11ca139d07f7f51113f5954bc22928032bd74378667022ddf9e4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08b0137acb1ce57b1d5752f3fb7c5e3d77373d28036f2fae32535e2a3c3e1b6f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ae5494c49f5d0b33a1e5da7d5604fc75c184eff3ebe7e560faf45f61d851c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83747136a8a199d1f2cdd4c890c4662c428840a956eb073a27f7da2ddab73373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0a72fe5bd1264780298288f4ba283aaa640cd082b14bd0eba80fe26c0575e55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da7b8248ec9ef4f176637363e15ec08cbb33715815713c8043037f512b490882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a245f2b42cd5c81f885775de9722ecd0ad19a7815972e92cc9682514aa7774c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b2498c47f9a7d7eb345a645a8605134afe2e44a740c1df500cf43431f32ff9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4274db55ad49e1e3878cea9b53f26d09268fc53d961b937f73a4bf6500b2864e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee4fd9232573426c1d72e3ead00602d58c6bafbd8ee227fe799f7d6fba58c0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b0ef1bea263173cc93c7662fb0e507f36a80c04ea08ca6146f10962e94a169)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94748bf7376f3af9133b982064e46c5b19d31a39a9e4708d656d62ce982da1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a0c626f52337a7005b03da4bc39d0f1ef422ed669524e3c6a9fe03f417b1009)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdfe4da01c3284cfbafe6852c9ed32029c4cb8fac089cf48b5f5f41797956c53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6c80cb1b7b6fa5d6c3db79e55732a7e3e31f9587459fb57c7b6a3c2f4f9170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd3bf3707ad112f881978db4957371442f738589bc39a5c8e938dd9eba3b1521)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198437edde8c6042f795044df0a729c6cd4f3c27b1c038696418e1ae072a4c70)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2af3f49b0aa6f1134d4efff835dc53c5fd72e2a71e4031ae7df5390b52d2f81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4dff7be4a62150e47d0fc2c38a4d2f3d0bfd91082419d74822b1d7597798760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes",
    jsii_struct_bases=[],
    name_mapping={
        "detect_injection": "detectInjection",
        "enabled": "enabled",
        "enable_via_http": "enableViaHttp",
        "i18_n_charset": "i18NCharset",
        "i18_n_status": "i18NStatus",
        "locked": "locked",
        "pass_client_ip": "passClientIp",
        "pass_set_cookie": "passSetCookie",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes:
    def __init__(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__549cbd107a664ef96cd175202998e0f5cb929fb2142c571ad0ad2e0b86f2cf75)
            check_type(argname="argument detect_injection", value=detect_injection, expected_type=type_hints["detect_injection"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_via_http", value=enable_via_http, expected_type=type_hints["enable_via_http"])
            check_type(argname="argument i18_n_charset", value=i18_n_charset, expected_type=type_hints["i18_n_charset"])
            check_type(argname="argument i18_n_status", value=i18_n_status, expected_type=type_hints["i18_n_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument pass_client_ip", value=pass_client_ip, expected_type=type_hints["pass_client_ip"])
            check_type(argname="argument pass_set_cookie", value=pass_set_cookie, expected_type=type_hints["pass_set_cookie"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if detect_injection is not None:
            self._values["detect_injection"] = detect_injection
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_via_http is not None:
            self._values["enable_via_http"] = enable_via_http
        if i18_n_charset is not None:
            self._values["i18_n_charset"] = i18_n_charset
        if i18_n_status is not None:
            self._values["i18_n_status"] = i18_n_status
        if locked is not None:
            self._values["locked"] = locked
        if pass_client_ip is not None:
            self._values["pass_client_ip"] = pass_client_ip
        if pass_set_cookie is not None:
            self._values["pass_set_cookie"] = pass_set_cookie
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def detect_injection(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Denies attempts to inject ESI code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        '''
        result = self._values.get("detect_injection")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ESI processing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_via_http(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        '''
        result = self._values.get("enable_via_http")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def i18_n_charset(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        '''
        result = self._values.get("i18_n_charset")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def i18_n_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Provides internationalization support for ESI.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        '''
        result = self._values.get("i18_n_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass the client IP header to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        '''
        result = self._values.get("pass_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pass_set_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to pass your origin server's cookies to the ESI processor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        '''
        result = self._values.get("pass_set_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13aed92e64d73ac26029d3e01e938f234308389ecd6fa37d24be92ed023b107)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDetectInjection")
    def reset_detect_injection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectInjection", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableViaHttp")
    def reset_enable_via_http(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableViaHttp", []))

    @jsii.member(jsii_name="resetI18NCharset")
    def reset_i18_n_charset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NCharset", []))

    @jsii.member(jsii_name="resetI18NStatus")
    def reset_i18_n_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetI18NStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPassClientIp")
    def reset_pass_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassClientIp", []))

    @jsii.member(jsii_name="resetPassSetCookie")
    def reset_pass_set_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPassSetCookie", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="detectInjectionInput")
    def detect_injection_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectInjectionInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableViaHttpInput")
    def enable_via_http_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableViaHttpInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NCharsetInput")
    def i18_n_charset_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "i18NCharsetInput"))

    @builtins.property
    @jsii.member(jsii_name="i18NStatusInput")
    def i18_n_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "i18NStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="passClientIpInput")
    def pass_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="passSetCookieInput")
    def pass_set_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "passSetCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="detectInjection")
    def detect_injection(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectInjection"))

    @detect_injection.setter
    def detect_injection(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc536288c62917f8b0bd6c5649cef669ac8396601f7c974efc824b171ea4c33d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectInjection", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3db762d56535fa4d11a027539baf8b509d2f503fc1903a7db18aa290aa445f44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableViaHttp")
    def enable_via_http(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableViaHttp"))

    @enable_via_http.setter
    def enable_via_http(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581c29190590a8d650443766b65d44e67fa860d016a7e79acc5ebc82b813ea48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableViaHttp", value)

    @builtins.property
    @jsii.member(jsii_name="i18NCharset")
    def i18_n_charset(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "i18NCharset"))

    @i18_n_charset.setter
    def i18_n_charset(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a5d9916d627cbce92d46e34ce80750fe94bbe9bcb1f2b4553be32529c8bc54c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NCharset", value)

    @builtins.property
    @jsii.member(jsii_name="i18NStatus")
    def i18_n_status(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "i18NStatus"))

    @i18_n_status.setter
    def i18_n_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5f32e378a7b4af9f6a8d712fa6f26a9e333959796e7f61e241525b044adba1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "i18NStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d11870402383098dcc88c74e094746fd37b496f4d9eb76fc4ba16c4b51a43412)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="passClientIp")
    def pass_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passClientIp"))

    @pass_client_ip.setter
    def pass_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c970cb29dea145a65c267b24596fde7f27f08e8b7a490f54497886542045babf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="passSetCookie")
    def pass_set_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "passSetCookie"))

    @pass_set_cookie.setter
    def pass_set_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d395ba3f882a5ee8a0f66a3fd555e01b7f9b64cc8b824ca097f294dece8c48e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "passSetCookie", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71ad869d80c1c9a7999adf251a4702296daaa8a1b19c21c7b9eb0d3a526fe1c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc9cb1633c792ea316e4188fdd3bd7574f47b616aa70904839dcc7cc5dd5d12c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e037c1201b191fbb08a017e4cf2effa729c7369e93abda0fa1161ebf19004918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker",
    jsii_struct_bases=[],
    name_mapping={
        "create_edge_worker": "createEdgeWorker",
        "edge_worker_id": "edgeWorkerId",
        "enabled": "enabled",
        "locked": "locked",
        "m_pulse": "mPulse",
        "m_pulse_information": "mPulseInformation",
        "resource_tier": "resourceTier",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker:
    def __init__(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse_information: typing.Optional[builtins.str] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param m_pulse: Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see ``Integrate mPulse reports with EdgeWorkers``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param m_pulse_information: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180a6fdb610da09c6030ad1273745c62eae9b107be5b954e54a48e178d32df17)
            check_type(argname="argument create_edge_worker", value=create_edge_worker, expected_type=type_hints["create_edge_worker"])
            check_type(argname="argument edge_worker_id", value=edge_worker_id, expected_type=type_hints["edge_worker_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument m_pulse", value=m_pulse, expected_type=type_hints["m_pulse"])
            check_type(argname="argument m_pulse_information", value=m_pulse_information, expected_type=type_hints["m_pulse_information"])
            check_type(argname="argument resource_tier", value=resource_tier, expected_type=type_hints["resource_tier"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if create_edge_worker is not None:
            self._values["create_edge_worker"] = create_edge_worker
        if edge_worker_id is not None:
            self._values["edge_worker_id"] = edge_worker_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if m_pulse is not None:
            self._values["m_pulse"] = m_pulse
        if m_pulse_information is not None:
            self._values["m_pulse_information"] = m_pulse_information
        if resource_tier is not None:
            self._values["resource_tier"] = resource_tier
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def create_edge_worker(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        '''
        result = self._values.get("create_edge_worker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def edge_worker_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the EdgeWorker application to apply to this rule's web traffic.

        You can use the ``EdgeWorkers API`` to get this value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        '''
        result = self._values.get("edge_worker_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies specified EdgeWorker functionality to this rule's web traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def m_pulse(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors.

        For more details, see ``Integrate mPulse reports with EdgeWorkers``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        '''
        result = self._values.get("m_pulse")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def m_pulse_information(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        '''
        result = self._values.get("m_pulse_information")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resource_tier(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        '''
        result = self._values.get("resource_tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c09b6f86552c25db7f47e4c5b1196ff9b95c0896f407d58ba82a5343bf6f0a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCreateEdgeWorker")
    def reset_create_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreateEdgeWorker", []))

    @jsii.member(jsii_name="resetEdgeWorkerId")
    def reset_edge_worker_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkerId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetMPulseInformation")
    def reset_m_pulse_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulseInformation", []))

    @jsii.member(jsii_name="resetResourceTier")
    def reset_resource_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceTier", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorkerInput")
    def create_edge_worker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "createEdgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerIdInput")
    def edge_worker_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "edgeWorkerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInformationInput")
    def m_pulse_information_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mPulseInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceTierInput")
    def resource_tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "resourceTierInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="createEdgeWorker")
    def create_edge_worker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "createEdgeWorker"))

    @create_edge_worker.setter
    def create_edge_worker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c41dd0ce6c926d4dcd71a641d1155646653a8f85b89c7c0832f00f346a21fa31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createEdgeWorker", value)

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerId")
    def edge_worker_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "edgeWorkerId"))

    @edge_worker_id.setter
    def edge_worker_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af825e8ec71a7a289a0119d62c9c2bea88b194f47ec1b280195e873dfce802d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "edgeWorkerId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af94c62d38dd6afbebcf6a01d591b0a2c68909c1bfbe35ea71cc15f7a853aae6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f1efe3bd7dc8369be344b7afc2267196d1ca8bfac4c17d99d077cdd977be492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mPulse"))

    @m_pulse.setter
    def m_pulse(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33a202b077a69c2456457ccc9d8f47944647f0e34ac20b18081f2f457fb40323)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mPulse", value)

    @builtins.property
    @jsii.member(jsii_name="mPulseInformation")
    def m_pulse_information(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mPulseInformation"))

    @m_pulse_information.setter
    def m_pulse_information(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aaaf0aa12198a23640f62272969260b3c6e11e2253b3921e3874192bdc30d52d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mPulseInformation", value)

    @builtins.property
    @jsii.member(jsii_name="resourceTier")
    def resource_tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "resourceTier"))

    @resource_tier.setter
    def resource_tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__656ebdec99fdf7026b745c7c75a843775d6e0dd8dc7777428b580c831f47ac8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resourceTier", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a47157d28542c0eb52c41fb59ca7d4e41ae4946b8b854b985e649aa2616b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39023327a12126fa6474689f1cc56ee3bd43f49ec8fb46e5cce14a531458d091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6930c9cac84e055b1b12085381ddad79cf88e47d3d89004a07ef546edb0eefd9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings",
    jsii_struct_bases=[],
    name_mapping={
        "certificate_authority_set": "certificateAuthoritySet",
        "enable_auth_set": "enableAuthSet",
        "enable_deny_request": "enableDenyRequest",
        "enable_ocsp_status": "enableOcspStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings:
    def __init__(
        self,
        *,
        certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_authority_set: Specify the client certificate authority (CA) sets you want to support in client requests. Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        :param enable_auth_set: Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        :param enable_deny_request: This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        :param enable_ocsp_status: Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01c010ba99422f66ae1ff01f91ee4c99c3d5ed70b2e8a44726c672073ac5f35c)
            check_type(argname="argument certificate_authority_set", value=certificate_authority_set, expected_type=type_hints["certificate_authority_set"])
            check_type(argname="argument enable_auth_set", value=enable_auth_set, expected_type=type_hints["enable_auth_set"])
            check_type(argname="argument enable_deny_request", value=enable_deny_request, expected_type=type_hints["enable_deny_request"])
            check_type(argname="argument enable_ocsp_status", value=enable_ocsp_status, expected_type=type_hints["enable_ocsp_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if certificate_authority_set is not None:
            self._values["certificate_authority_set"] = certificate_authority_set
        if enable_auth_set is not None:
            self._values["enable_auth_set"] = enable_auth_set
        if enable_deny_request is not None:
            self._values["enable_deny_request"] = enable_deny_request
        if enable_ocsp_status is not None:
            self._values["enable_ocsp_status"] = enable_ocsp_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def certificate_authority_set(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify the client certificate authority (CA) sets you want to support in client requests.

        Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        '''
        result = self._values.get("certificate_authority_set")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_auth_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        '''
        result = self._values.get("enable_auth_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_deny_request(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This denies a request from a client that doesn't match what you've set for the options in this behavior.

        When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        '''
        result = self._values.get("enable_deny_request")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ocsp_status(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP).

        OCSP can determine the x.509 certificate revocation status during the TLS handshake.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        '''
        result = self._values.get("enable_ocsp_status")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c1f327e736b8bee52770e1f1e470495c70e2d8a57c86ba1f1fe9feacfd0eeb2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCertificateAuthoritySet")
    def reset_certificate_authority_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateAuthoritySet", []))

    @jsii.member(jsii_name="resetEnableAuthSet")
    def reset_enable_auth_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAuthSet", []))

    @jsii.member(jsii_name="resetEnableDenyRequest")
    def reset_enable_deny_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableDenyRequest", []))

    @jsii.member(jsii_name="resetEnableOcspStatus")
    def reset_enable_ocsp_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableOcspStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="certificateAuthoritySetInput")
    def certificate_authority_set_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "certificateAuthoritySetInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAuthSetInput")
    def enable_auth_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAuthSetInput"))

    @builtins.property
    @jsii.member(jsii_name="enableDenyRequestInput")
    def enable_deny_request_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableDenyRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="enableOcspStatusInput")
    def enable_ocsp_status_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableOcspStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateAuthoritySet")
    def certificate_authority_set(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "certificateAuthoritySet"))

    @certificate_authority_set.setter
    def certificate_authority_set(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f76185fc12fffeea09dda2726cbeebc4c6853513bcdbc0c3fd1433d4a2790f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateAuthoritySet", value)

    @builtins.property
    @jsii.member(jsii_name="enableAuthSet")
    def enable_auth_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAuthSet"))

    @enable_auth_set.setter
    def enable_auth_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761a81c7bedb95a0ec69d5af1d1181c3904d041384717ef45c98967e6f1a179b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAuthSet", value)

    @builtins.property
    @jsii.member(jsii_name="enableDenyRequest")
    def enable_deny_request(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableDenyRequest"))

    @enable_deny_request.setter
    def enable_deny_request(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__663ad964161f28a9dc5a20feeed5ad5bb8cdf6fd6540af881a5b15167053b295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableDenyRequest", value)

    @builtins.property
    @jsii.member(jsii_name="enableOcspStatus")
    def enable_ocsp_status(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableOcspStatus"))

    @enable_ocsp_status.setter
    def enable_ocsp_status(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebc40b1e858d2bbf1a8a7cdbdb4d52a2c72e32989f9477bab6441b880a981e29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableOcspStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__761128a153600b9979957a62a4c36a9cf172f5542c8e77e056bab425393a2bfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e08c3a3b152c543c6a42acaf15a93108c29e4fc88619f056d906ceb21d140ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d3e456ab88889ee7b3d118713bec4bf1ae15ea8da75884599e973680687f627)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a6466303eb19f80c09f43bf552c1d97d53682366437c9c87fae378d0baf37d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12bab2c80fed15ed079e8ebf9bedefc0673ee25be2f65ae7f324b0f52057e3a2)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03a49c98bed1ed036a14a5c755c00adeb0b5212b09a77d140f292eed4fe22e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1949b0c6fb6045a4645d1449084ea0d2b1a416dce0ed896bf0f1d1de856edee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c7185c4650dee24fafc9c6508128e515887090e1636236dc53a3f4bcc6d1ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c51464e5c3d7ddc6cf1d92f2dfce97cb97838717bea75c18543c5e3c44801e65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5b1d2f5ca1fd69d77c245cd19caba4dd77eb9cc7a20092e095818c333970e20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b9619abcb2d2cb68aae9376d06c06e2e12896f046b3a24d6dccc558a7100664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection",
    jsii_struct_bases=[],
    name_mapping={
        "anonymous_vpn": "anonymousVpn",
        "best_practice_action": "bestPracticeAction",
        "best_practice_redirecturl": "bestPracticeRedirecturl",
        "detect_anonymous_vpn": "detectAnonymousVpn",
        "detect_anonymous_vpn_action": "detectAnonymousVpnAction",
        "detect_anonymous_vpn_redirecturl": "detectAnonymousVpnRedirecturl",
        "detect_hosting_provider": "detectHostingProvider",
        "detect_hosting_provider_action": "detectHostingProviderAction",
        "detect_hosting_provider_redirecturl": "detectHostingProviderRedirecturl",
        "detect_public_proxy": "detectPublicProxy",
        "detect_public_proxy_action": "detectPublicProxyAction",
        "detect_public_proxy_redirecturl": "detectPublicProxyRedirecturl",
        "detect_residential_proxy": "detectResidentialProxy",
        "detect_residential_proxy_action": "detectResidentialProxyAction",
        "detect_residential_proxy_redirecturl": "detectResidentialProxyRedirecturl",
        "detect_smart_dns_proxy": "detectSmartDnsProxy",
        "detect_smart_dns_proxy_action": "detectSmartDnsProxyAction",
        "detect_smart_dns_proxy_redirecturl": "detectSmartDnsProxyRedirecturl",
        "detect_tor_exit_node": "detectTorExitNode",
        "detect_tor_exit_node_action": "detectTorExitNodeAction",
        "detect_tor_exit_node_redirecturl": "detectTorExitNodeRedirecturl",
        "detect_vpn_data_center": "detectVpnDataCenter",
        "detect_vpn_data_center_action": "detectVpnDataCenterAction",
        "detect_vpn_data_center_redirecturl": "detectVpnDataCenterRedirecturl",
        "enable_configuration_mode": "enableConfigurationMode",
        "enabled": "enabled",
        "forward_header_enrichment": "forwardHeaderEnrichment",
        "hosting_provider": "hostingProvider",
        "locked": "locked",
        "public_proxy": "publicProxy",
        "residential_proxy": "residentialProxy",
        "smart_dns_proxy": "smartDnsProxy",
        "template_uuid": "templateUuid",
        "tor_exit_node": "torExitNode",
        "uuid": "uuid",
        "vpn_data_center": "vpnDataCenter",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection:
    def __init__(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3701bffb2f30ebcfe93ea44cbc3340db429d49355e32abc935e90bd04c63ccba)
            check_type(argname="argument anonymous_vpn", value=anonymous_vpn, expected_type=type_hints["anonymous_vpn"])
            check_type(argname="argument best_practice_action", value=best_practice_action, expected_type=type_hints["best_practice_action"])
            check_type(argname="argument best_practice_redirecturl", value=best_practice_redirecturl, expected_type=type_hints["best_practice_redirecturl"])
            check_type(argname="argument detect_anonymous_vpn", value=detect_anonymous_vpn, expected_type=type_hints["detect_anonymous_vpn"])
            check_type(argname="argument detect_anonymous_vpn_action", value=detect_anonymous_vpn_action, expected_type=type_hints["detect_anonymous_vpn_action"])
            check_type(argname="argument detect_anonymous_vpn_redirecturl", value=detect_anonymous_vpn_redirecturl, expected_type=type_hints["detect_anonymous_vpn_redirecturl"])
            check_type(argname="argument detect_hosting_provider", value=detect_hosting_provider, expected_type=type_hints["detect_hosting_provider"])
            check_type(argname="argument detect_hosting_provider_action", value=detect_hosting_provider_action, expected_type=type_hints["detect_hosting_provider_action"])
            check_type(argname="argument detect_hosting_provider_redirecturl", value=detect_hosting_provider_redirecturl, expected_type=type_hints["detect_hosting_provider_redirecturl"])
            check_type(argname="argument detect_public_proxy", value=detect_public_proxy, expected_type=type_hints["detect_public_proxy"])
            check_type(argname="argument detect_public_proxy_action", value=detect_public_proxy_action, expected_type=type_hints["detect_public_proxy_action"])
            check_type(argname="argument detect_public_proxy_redirecturl", value=detect_public_proxy_redirecturl, expected_type=type_hints["detect_public_proxy_redirecturl"])
            check_type(argname="argument detect_residential_proxy", value=detect_residential_proxy, expected_type=type_hints["detect_residential_proxy"])
            check_type(argname="argument detect_residential_proxy_action", value=detect_residential_proxy_action, expected_type=type_hints["detect_residential_proxy_action"])
            check_type(argname="argument detect_residential_proxy_redirecturl", value=detect_residential_proxy_redirecturl, expected_type=type_hints["detect_residential_proxy_redirecturl"])
            check_type(argname="argument detect_smart_dns_proxy", value=detect_smart_dns_proxy, expected_type=type_hints["detect_smart_dns_proxy"])
            check_type(argname="argument detect_smart_dns_proxy_action", value=detect_smart_dns_proxy_action, expected_type=type_hints["detect_smart_dns_proxy_action"])
            check_type(argname="argument detect_smart_dns_proxy_redirecturl", value=detect_smart_dns_proxy_redirecturl, expected_type=type_hints["detect_smart_dns_proxy_redirecturl"])
            check_type(argname="argument detect_tor_exit_node", value=detect_tor_exit_node, expected_type=type_hints["detect_tor_exit_node"])
            check_type(argname="argument detect_tor_exit_node_action", value=detect_tor_exit_node_action, expected_type=type_hints["detect_tor_exit_node_action"])
            check_type(argname="argument detect_tor_exit_node_redirecturl", value=detect_tor_exit_node_redirecturl, expected_type=type_hints["detect_tor_exit_node_redirecturl"])
            check_type(argname="argument detect_vpn_data_center", value=detect_vpn_data_center, expected_type=type_hints["detect_vpn_data_center"])
            check_type(argname="argument detect_vpn_data_center_action", value=detect_vpn_data_center_action, expected_type=type_hints["detect_vpn_data_center_action"])
            check_type(argname="argument detect_vpn_data_center_redirecturl", value=detect_vpn_data_center_redirecturl, expected_type=type_hints["detect_vpn_data_center_redirecturl"])
            check_type(argname="argument enable_configuration_mode", value=enable_configuration_mode, expected_type=type_hints["enable_configuration_mode"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument forward_header_enrichment", value=forward_header_enrichment, expected_type=type_hints["forward_header_enrichment"])
            check_type(argname="argument hosting_provider", value=hosting_provider, expected_type=type_hints["hosting_provider"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument public_proxy", value=public_proxy, expected_type=type_hints["public_proxy"])
            check_type(argname="argument residential_proxy", value=residential_proxy, expected_type=type_hints["residential_proxy"])
            check_type(argname="argument smart_dns_proxy", value=smart_dns_proxy, expected_type=type_hints["smart_dns_proxy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tor_exit_node", value=tor_exit_node, expected_type=type_hints["tor_exit_node"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument vpn_data_center", value=vpn_data_center, expected_type=type_hints["vpn_data_center"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if anonymous_vpn is not None:
            self._values["anonymous_vpn"] = anonymous_vpn
        if best_practice_action is not None:
            self._values["best_practice_action"] = best_practice_action
        if best_practice_redirecturl is not None:
            self._values["best_practice_redirecturl"] = best_practice_redirecturl
        if detect_anonymous_vpn is not None:
            self._values["detect_anonymous_vpn"] = detect_anonymous_vpn
        if detect_anonymous_vpn_action is not None:
            self._values["detect_anonymous_vpn_action"] = detect_anonymous_vpn_action
        if detect_anonymous_vpn_redirecturl is not None:
            self._values["detect_anonymous_vpn_redirecturl"] = detect_anonymous_vpn_redirecturl
        if detect_hosting_provider is not None:
            self._values["detect_hosting_provider"] = detect_hosting_provider
        if detect_hosting_provider_action is not None:
            self._values["detect_hosting_provider_action"] = detect_hosting_provider_action
        if detect_hosting_provider_redirecturl is not None:
            self._values["detect_hosting_provider_redirecturl"] = detect_hosting_provider_redirecturl
        if detect_public_proxy is not None:
            self._values["detect_public_proxy"] = detect_public_proxy
        if detect_public_proxy_action is not None:
            self._values["detect_public_proxy_action"] = detect_public_proxy_action
        if detect_public_proxy_redirecturl is not None:
            self._values["detect_public_proxy_redirecturl"] = detect_public_proxy_redirecturl
        if detect_residential_proxy is not None:
            self._values["detect_residential_proxy"] = detect_residential_proxy
        if detect_residential_proxy_action is not None:
            self._values["detect_residential_proxy_action"] = detect_residential_proxy_action
        if detect_residential_proxy_redirecturl is not None:
            self._values["detect_residential_proxy_redirecturl"] = detect_residential_proxy_redirecturl
        if detect_smart_dns_proxy is not None:
            self._values["detect_smart_dns_proxy"] = detect_smart_dns_proxy
        if detect_smart_dns_proxy_action is not None:
            self._values["detect_smart_dns_proxy_action"] = detect_smart_dns_proxy_action
        if detect_smart_dns_proxy_redirecturl is not None:
            self._values["detect_smart_dns_proxy_redirecturl"] = detect_smart_dns_proxy_redirecturl
        if detect_tor_exit_node is not None:
            self._values["detect_tor_exit_node"] = detect_tor_exit_node
        if detect_tor_exit_node_action is not None:
            self._values["detect_tor_exit_node_action"] = detect_tor_exit_node_action
        if detect_tor_exit_node_redirecturl is not None:
            self._values["detect_tor_exit_node_redirecturl"] = detect_tor_exit_node_redirecturl
        if detect_vpn_data_center is not None:
            self._values["detect_vpn_data_center"] = detect_vpn_data_center
        if detect_vpn_data_center_action is not None:
            self._values["detect_vpn_data_center_action"] = detect_vpn_data_center_action
        if detect_vpn_data_center_redirecturl is not None:
            self._values["detect_vpn_data_center_redirecturl"] = detect_vpn_data_center_redirecturl
        if enable_configuration_mode is not None:
            self._values["enable_configuration_mode"] = enable_configuration_mode
        if enabled is not None:
            self._values["enabled"] = enabled
        if forward_header_enrichment is not None:
            self._values["forward_header_enrichment"] = forward_header_enrichment
        if hosting_provider is not None:
            self._values["hosting_provider"] = hosting_provider
        if locked is not None:
            self._values["locked"] = locked
        if public_proxy is not None:
            self._values["public_proxy"] = public_proxy
        if residential_proxy is not None:
            self._values["residential_proxy"] = residential_proxy
        if smart_dns_proxy is not None:
            self._values["smart_dns_proxy"] = smart_dns_proxy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tor_exit_node is not None:
            self._values["tor_exit_node"] = tor_exit_node
        if uuid is not None:
            self._values["uuid"] = uuid
        if vpn_data_center is not None:
            self._values["vpn_data_center"] = vpn_data_center

    @builtins.property
    def anonymous_vpn(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        '''
        result = self._values.get("anonymous_vpn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        '''
        result = self._values.get("best_practice_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def best_practice_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        '''
        result = self._values.get("best_practice_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from anonymous VPNs.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        '''
        result = self._values.get("detect_anonymous_vpn")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_anonymous_vpn_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        '''
        result = self._values.get("detect_anonymous_vpn_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_anonymous_vpn_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect anonymous VPN requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        '''
        result = self._values.get("detect_anonymous_vpn_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This detects requests from a hosting provider.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        '''
        result = self._values.get("detect_hosting_provider")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_hosting_provider_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        '''
        result = self._values.get("detect_hosting_provider_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_hosting_provider_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the absolute URL to which to redirect requests from hosting providers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        '''
        result = self._values.get("detect_hosting_provider_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from public proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        '''
        result = self._values.get("detect_public_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_public_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        '''
        result = self._values.get("detect_public_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_public_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect public proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        '''
        result = self._values.get("detect_public_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from a residential proxy.

        See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        '''
        result = self._values.get("detect_residential_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_residential_proxy_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        '''
        result = self._values.get("detect_residential_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_residential_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        '''
        result = self._values.get("detect_residential_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from smart DNS proxies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        '''
        result = self._values.get("detect_smart_dns_proxy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_smart_dns_proxy_action(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        '''
        result = self._values.get("detect_smart_dns_proxy_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_smart_dns_proxy_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect DNS proxy requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        '''
        result = self._values.get("detect_smart_dns_proxy_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        '''
        result = self._values.get("detect_tor_exit_node")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_tor_exit_node_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        '''
        result = self._values.get("detect_tor_exit_node_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_tor_exit_node_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from Tor exit nodes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        '''
        result = self._values.get("detect_tor_exit_node_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables detection of requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        '''
        result = self._values.get("detect_vpn_data_center")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_vpn_data_center_action(self) -> typing.Optional[builtins.str]:
        '''This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        '''
        result = self._values.get("detect_vpn_data_center_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_vpn_data_center_redirecturl(self) -> typing.Optional[builtins.str]:
        '''This specifies the URL to which to redirect requests from VPN data centers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        '''
        result = self._values.get("detect_vpn_data_center_redirecturl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_configuration_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies how to field the proxy request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        '''
        result = self._values.get("enable_configuration_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies GeoGuard proxy detection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_header_enrichment(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation.

        See the ``epdForwardHeaderEnrichment`` behavior for details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        '''
        result = self._values.get("forward_header_enrichment")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hosting_provider(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        '''
        result = self._values.get("hosting_provider")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def public_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        '''
        result = self._values.get("public_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def residential_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        '''
        result = self._values.get("residential_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def smart_dns_proxy(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        '''
        result = self._values.get("smart_dns_proxy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tor_exit_node(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        '''
        result = self._values.get("tor_exit_node")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def vpn_data_center(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        result = self._values.get("vpn_data_center")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7869a4574ec186d0ed93fedf012459004c92607a3b0e95472d01998e74c79110)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAnonymousVpn")
    def reset_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAnonymousVpn", []))

    @jsii.member(jsii_name="resetBestPracticeAction")
    def reset_best_practice_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeAction", []))

    @jsii.member(jsii_name="resetBestPracticeRedirecturl")
    def reset_best_practice_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBestPracticeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpn")
    def reset_detect_anonymous_vpn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpn", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnAction")
    def reset_detect_anonymous_vpn_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnAction", []))

    @jsii.member(jsii_name="resetDetectAnonymousVpnRedirecturl")
    def reset_detect_anonymous_vpn_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectAnonymousVpnRedirecturl", []))

    @jsii.member(jsii_name="resetDetectHostingProvider")
    def reset_detect_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProvider", []))

    @jsii.member(jsii_name="resetDetectHostingProviderAction")
    def reset_detect_hosting_provider_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderAction", []))

    @jsii.member(jsii_name="resetDetectHostingProviderRedirecturl")
    def reset_detect_hosting_provider_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectHostingProviderRedirecturl", []))

    @jsii.member(jsii_name="resetDetectPublicProxy")
    def reset_detect_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxy", []))

    @jsii.member(jsii_name="resetDetectPublicProxyAction")
    def reset_detect_public_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyAction", []))

    @jsii.member(jsii_name="resetDetectPublicProxyRedirecturl")
    def reset_detect_public_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectPublicProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectResidentialProxy")
    def reset_detect_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxy", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyAction")
    def reset_detect_residential_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyAction", []))

    @jsii.member(jsii_name="resetDetectResidentialProxyRedirecturl")
    def reset_detect_residential_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectResidentialProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxy")
    def reset_detect_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxy", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyAction")
    def reset_detect_smart_dns_proxy_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyAction", []))

    @jsii.member(jsii_name="resetDetectSmartDnsProxyRedirecturl")
    def reset_detect_smart_dns_proxy_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectSmartDnsProxyRedirecturl", []))

    @jsii.member(jsii_name="resetDetectTorExitNode")
    def reset_detect_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNode", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeAction")
    def reset_detect_tor_exit_node_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeAction", []))

    @jsii.member(jsii_name="resetDetectTorExitNodeRedirecturl")
    def reset_detect_tor_exit_node_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectTorExitNodeRedirecturl", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenter")
    def reset_detect_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenter", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterAction")
    def reset_detect_vpn_data_center_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterAction", []))

    @jsii.member(jsii_name="resetDetectVpnDataCenterRedirecturl")
    def reset_detect_vpn_data_center_redirecturl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectVpnDataCenterRedirecturl", []))

    @jsii.member(jsii_name="resetEnableConfigurationMode")
    def reset_enable_configuration_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableConfigurationMode", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForwardHeaderEnrichment")
    def reset_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetHostingProvider")
    def reset_hosting_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostingProvider", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPublicProxy")
    def reset_public_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicProxy", []))

    @jsii.member(jsii_name="resetResidentialProxy")
    def reset_residential_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResidentialProxy", []))

    @jsii.member(jsii_name="resetSmartDnsProxy")
    def reset_smart_dns_proxy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSmartDnsProxy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTorExitNode")
    def reset_tor_exit_node(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTorExitNode", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVpnDataCenter")
    def reset_vpn_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVpnDataCenter", []))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpnInput")
    def anonymous_vpn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "anonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeActionInput")
    def best_practice_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturlInput")
    def best_practice_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bestPracticeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnActionInput")
    def detect_anonymous_vpn_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnInput")
    def detect_anonymous_vpn_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectAnonymousVpnInput"))

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturlInput")
    def detect_anonymous_vpn_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectAnonymousVpnRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderActionInput")
    def detect_hosting_provider_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderInput")
    def detect_hosting_provider_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectHostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturlInput")
    def detect_hosting_provider_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectHostingProviderRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyActionInput")
    def detect_public_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyInput")
    def detect_public_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectPublicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturlInput")
    def detect_public_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectPublicProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyActionInput")
    def detect_residential_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyInput")
    def detect_residential_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectResidentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturlInput")
    def detect_residential_proxy_redirecturl_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectResidentialProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyActionInput")
    def detect_smart_dns_proxy_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyInput")
    def detect_smart_dns_proxy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectSmartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturlInput")
    def detect_smart_dns_proxy_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectSmartDnsProxyRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeActionInput")
    def detect_tor_exit_node_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeInput")
    def detect_tor_exit_node_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectTorExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturlInput")
    def detect_tor_exit_node_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectTorExitNodeRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterActionInput")
    def detect_vpn_data_center_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterActionInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterInput")
    def detect_vpn_data_center_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectVpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturlInput")
    def detect_vpn_data_center_redirecturl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectVpnDataCenterRedirecturlInput"))

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationModeInput")
    def enable_configuration_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enableConfigurationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichmentInput")
    def forward_header_enrichment_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="hostingProviderInput")
    def hosting_provider_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostingProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="publicProxyInput")
    def public_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="residentialProxyInput")
    def residential_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "residentialProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxyInput")
    def smart_dns_proxy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "smartDnsProxyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="torExitNodeInput")
    def tor_exit_node_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "torExitNodeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenterInput")
    def vpn_data_center_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "vpnDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="anonymousVpn")
    def anonymous_vpn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "anonymousVpn"))

    @anonymous_vpn.setter
    def anonymous_vpn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44b99931efee966e6c2cf2f43236c390c6c8974fb925537607cc24eaf920571d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "anonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeAction")
    def best_practice_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeAction"))

    @best_practice_action.setter
    def best_practice_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e38de6fdb49cea2cbb5e8f163bfa791b76853382e8f56b5ef1109191cf36612)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeAction", value)

    @builtins.property
    @jsii.member(jsii_name="bestPracticeRedirecturl")
    def best_practice_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bestPracticeRedirecturl"))

    @best_practice_redirecturl.setter
    def best_practice_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b399f00089f2b89b7fa8afcf734e1d5ad5ec210d764e65b1ecdccf060d62a247)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bestPracticeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpn")
    def detect_anonymous_vpn(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectAnonymousVpn"))

    @detect_anonymous_vpn.setter
    def detect_anonymous_vpn(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__723f1475c3599e574c6cfd47e4965f177eca044fddf7aebee21e1434defd0fff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpn", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnAction")
    def detect_anonymous_vpn_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnAction"))

    @detect_anonymous_vpn_action.setter
    def detect_anonymous_vpn_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be21ea5a89b28ed83120765deb8b21f4f5fffd8981266816b5eb9b82656c5900)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectAnonymousVpnRedirecturl")
    def detect_anonymous_vpn_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectAnonymousVpnRedirecturl"))

    @detect_anonymous_vpn_redirecturl.setter
    def detect_anonymous_vpn_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93cfaa0dc165e823bcecc6a9ab283f4582f1c7e2c78f58315cfecf180c9485d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectAnonymousVpnRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProvider")
    def detect_hosting_provider(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectHostingProvider"))

    @detect_hosting_provider.setter
    def detect_hosting_provider(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66e61a4d551400f18a8cc142e6c516bc73c7eabea59641cec0d5923dcff9e392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderAction")
    def detect_hosting_provider_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderAction"))

    @detect_hosting_provider_action.setter
    def detect_hosting_provider_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__45d185cc186654f3f70798688b42e364f5da8b3e5e6ff576460847bf63f50798)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectHostingProviderRedirecturl")
    def detect_hosting_provider_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectHostingProviderRedirecturl"))

    @detect_hosting_provider_redirecturl.setter
    def detect_hosting_provider_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__711d265873a8b951f85c40d7e155366daabd65e38eacc52519471a75f2073c17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectHostingProviderRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxy")
    def detect_public_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectPublicProxy"))

    @detect_public_proxy.setter
    def detect_public_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1f3f72692d7275739d280741e0f0b1797e4f5ed38d038d46b3a9d29f916a624)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyAction")
    def detect_public_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyAction"))

    @detect_public_proxy_action.setter
    def detect_public_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1a4a0a929ed796df0245fa9228754204f3d1bddb3867a0fbf2983a19fe0248c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectPublicProxyRedirecturl")
    def detect_public_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectPublicProxyRedirecturl"))

    @detect_public_proxy_redirecturl.setter
    def detect_public_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83a26e09e250fba1b20f08005f7c4b1332a48b7c1f9debe5ab2d86128e9f6708)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectPublicProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxy")
    def detect_residential_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectResidentialProxy"))

    @detect_residential_proxy.setter
    def detect_residential_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2530ac742b2afaf7a2e9da74eae193125247a97bbffff348a3f59cee23ca81b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyAction")
    def detect_residential_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyAction"))

    @detect_residential_proxy_action.setter
    def detect_residential_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__559f7be471d6f4730e17e36d8bd357418de61f163b274f03f160aeb85fb0766a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectResidentialProxyRedirecturl")
    def detect_residential_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectResidentialProxyRedirecturl"))

    @detect_residential_proxy_redirecturl.setter
    def detect_residential_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b347b99ceb2336e01e073639faa1b50e806a094923d6a62fa5286e69eac85b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectResidentialProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxy")
    def detect_smart_dns_proxy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectSmartDnsProxy"))

    @detect_smart_dns_proxy.setter
    def detect_smart_dns_proxy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd152fb9e9b1515defd06c6fc63d28953852e25aaf4c409d5e786ef5578f437b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyAction")
    def detect_smart_dns_proxy_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyAction"))

    @detect_smart_dns_proxy_action.setter
    def detect_smart_dns_proxy_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9154dc49d10dbb934066a85e58460b25eca2be90c746b3fee0e29854506afdeb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectSmartDnsProxyRedirecturl")
    def detect_smart_dns_proxy_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectSmartDnsProxyRedirecturl"))

    @detect_smart_dns_proxy_redirecturl.setter
    def detect_smart_dns_proxy_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__923e9b874777044ec1b2b511686d651842add2e2ee97fc634a22241dde54b338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectSmartDnsProxyRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNode")
    def detect_tor_exit_node(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectTorExitNode"))

    @detect_tor_exit_node.setter
    def detect_tor_exit_node(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4266c60aee9fcea8cb693e16c59e42c42ba6ae801198ddb16cf0cb081259c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeAction")
    def detect_tor_exit_node_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeAction"))

    @detect_tor_exit_node_action.setter
    def detect_tor_exit_node_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577c6efdd723151865d0fde162403734a1cafbc210bca3fe56dbe553964b267e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectTorExitNodeRedirecturl")
    def detect_tor_exit_node_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectTorExitNodeRedirecturl"))

    @detect_tor_exit_node_redirecturl.setter
    def detect_tor_exit_node_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d4f7c46e31f3cd1aea46631c16a7e0ff6a7b8ade33635f61770356219860736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectTorExitNodeRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenter")
    def detect_vpn_data_center(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectVpnDataCenter"))

    @detect_vpn_data_center.setter
    def detect_vpn_data_center(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c7a07b5090c2bcc9bca4d0af00c6f48de4409c8a5360253e6641bf2af3783d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterAction")
    def detect_vpn_data_center_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterAction"))

    @detect_vpn_data_center_action.setter
    def detect_vpn_data_center_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fb75af41941810f2c643b785a4c745f6b4c09ea7a45ef02351eaa525f6c0bb6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterAction", value)

    @builtins.property
    @jsii.member(jsii_name="detectVpnDataCenterRedirecturl")
    def detect_vpn_data_center_redirecturl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectVpnDataCenterRedirecturl"))

    @detect_vpn_data_center_redirecturl.setter
    def detect_vpn_data_center_redirecturl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eee1a7fa4495211ed09dd849f95ed50c082c6d6f2c58683a3a36a20bd1ea6fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectVpnDataCenterRedirecturl", value)

    @builtins.property
    @jsii.member(jsii_name="enableConfigurationMode")
    def enable_configuration_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enableConfigurationMode"))

    @enable_configuration_mode.setter
    def enable_configuration_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3938ac4be31aaaeeea570dc63ee89f43e80e291c0fe68b9310b46ab4a1d9b29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableConfigurationMode", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc54e990f6ef24f7e5f21cb22dffd3b53fa62a7831c8af005c4e7f4422d4e28d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHeaderEnrichment")
    def forward_header_enrichment(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forwardHeaderEnrichment"))

    @forward_header_enrichment.setter
    def forward_header_enrichment(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c168b40ece3c82d6b5a3ef7040e20b0118e472119c350fb04022b0abbe43a4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHeaderEnrichment", value)

    @builtins.property
    @jsii.member(jsii_name="hostingProvider")
    def hosting_provider(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostingProvider"))

    @hosting_provider.setter
    def hosting_provider(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f55c4a2a55752c4063921e326b567a51ee4c63394bdd5626a3f64f9e79f530a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostingProvider", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca27a0b4dd41223610ddfb29904a07099ccb9ea8192bbc9e951bee3b796cfa50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="publicProxy")
    def public_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicProxy"))

    @public_proxy.setter
    def public_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2143642ac75b30375e4c6e9f57d61a37e0e676eff71be349d4bb83cb1ecd89d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicProxy", value)

    @builtins.property
    @jsii.member(jsii_name="residentialProxy")
    def residential_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "residentialProxy"))

    @residential_proxy.setter
    def residential_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac32aa41df9c8ad825eb69605cd38f259028bf3cd5506f3a238746d28f1fd999)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "residentialProxy", value)

    @builtins.property
    @jsii.member(jsii_name="smartDnsProxy")
    def smart_dns_proxy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "smartDnsProxy"))

    @smart_dns_proxy.setter
    def smart_dns_proxy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36d815d8d01c3c2560e0b9db655557900314922ddf22ec1c7e13c88dcb1f7fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "smartDnsProxy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1706693efcc4d5629ba7cb92a4c6fb9311d0abd8070d7977b1666e309b2ecc8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="torExitNode")
    def tor_exit_node(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "torExitNode"))

    @tor_exit_node.setter
    def tor_exit_node(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f84eb43c90c74724bb90816618de6f204d7f2ea7c7316e787df41c384a07daf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "torExitNode", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f70c0bb279fa3f38378d1918f343a214f6aad0f2b8013522d9a19b47d79f818)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="vpnDataCenter")
    def vpn_data_center(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "vpnDataCenter"))

    @vpn_data_center.setter
    def vpn_data_center(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edd00706c894afc0f6b0435ea6bea5ccf170587ae93537ec56ff12b07cc8c617)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "vpnDataCenter", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b84bb0c6307a22c6c67d6e5d995f337896b96c6170cf33ef8792fb567142256)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bc829060a0ea269038ef53e280de64f9f26af563df6953f9b463c760259ce61)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy.

        The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers:

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66884955d024094bcbaed2db9b1fce2ed56047d4fc26eba71a4dff7ec480c7f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3eb41a7160c005a5e109abef0e7c5ead6e89c367c37658ec164a1c92f0d42bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4c62af3c18c3636c28d709f21c1d19141293cd7413d532c02899d7ca64fbc52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc2a9c7a722051adbb5f8c3d6dae1fc55ea3b04d0c82d56e62a44b324fed1e60)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ece661f810acbf3e6c768a8b878a4a7576b85ad82ec8da64fff846f3f11b023)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36185b05c3c097fc4f33b44e0751eec21bf8a33a4be35e66160e877f488b2924)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction",
    jsii_struct_bases=[],
    name_mapping={
        "action_type": "actionType",
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "cex_custom_path": "cexCustomPath",
        "cex_hostname": "cexHostname",
        "cex_path": "cexPath",
        "content_custom_path": "contentCustomPath",
        "content_hostname": "contentHostname",
        "content_path": "contentPath",
        "cp_code": "cpCode",
        "dynamic_custom_path": "dynamicCustomPath",
        "dynamic_method": "dynamicMethod",
        "dynamic_path": "dynamicPath",
        "enabled": "enabled",
        "locked": "locked",
        "modify_protocol": "modifyProtocol",
        "net_storage_hostname": "netStorageHostname",
        "net_storage_path": "netStoragePath",
        "preserve_query_string": "preserveQueryString",
        "protocol": "protocol",
        "redirect_custom_path": "redirectCustomPath",
        "redirect_hostname": "redirectHostname",
        "redirect_hostname_type": "redirectHostnameType",
        "redirect_method": "redirectMethod",
        "redirect_path": "redirectPath",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction:
    def __init__(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code, dict):
            cp_code = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode(**cp_code)
        if isinstance(net_storage_hostname, dict):
            net_storage_hostname = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname(**net_storage_hostname)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cf5989ba12ede946b228ae7549984dc342d435dfa66d11c9b129d2cdbbca627)
            check_type(argname="argument action_type", value=action_type, expected_type=type_hints["action_type"])
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument cex_custom_path", value=cex_custom_path, expected_type=type_hints["cex_custom_path"])
            check_type(argname="argument cex_hostname", value=cex_hostname, expected_type=type_hints["cex_hostname"])
            check_type(argname="argument cex_path", value=cex_path, expected_type=type_hints["cex_path"])
            check_type(argname="argument content_custom_path", value=content_custom_path, expected_type=type_hints["content_custom_path"])
            check_type(argname="argument content_hostname", value=content_hostname, expected_type=type_hints["content_hostname"])
            check_type(argname="argument content_path", value=content_path, expected_type=type_hints["content_path"])
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument dynamic_custom_path", value=dynamic_custom_path, expected_type=type_hints["dynamic_custom_path"])
            check_type(argname="argument dynamic_method", value=dynamic_method, expected_type=type_hints["dynamic_method"])
            check_type(argname="argument dynamic_path", value=dynamic_path, expected_type=type_hints["dynamic_path"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_protocol", value=modify_protocol, expected_type=type_hints["modify_protocol"])
            check_type(argname="argument net_storage_hostname", value=net_storage_hostname, expected_type=type_hints["net_storage_hostname"])
            check_type(argname="argument net_storage_path", value=net_storage_path, expected_type=type_hints["net_storage_path"])
            check_type(argname="argument preserve_query_string", value=preserve_query_string, expected_type=type_hints["preserve_query_string"])
            check_type(argname="argument protocol", value=protocol, expected_type=type_hints["protocol"])
            check_type(argname="argument redirect_custom_path", value=redirect_custom_path, expected_type=type_hints["redirect_custom_path"])
            check_type(argname="argument redirect_hostname", value=redirect_hostname, expected_type=type_hints["redirect_hostname"])
            check_type(argname="argument redirect_hostname_type", value=redirect_hostname_type, expected_type=type_hints["redirect_hostname_type"])
            check_type(argname="argument redirect_method", value=redirect_method, expected_type=type_hints["redirect_method"])
            check_type(argname="argument redirect_path", value=redirect_path, expected_type=type_hints["redirect_path"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action_type is not None:
            self._values["action_type"] = action_type
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if cex_custom_path is not None:
            self._values["cex_custom_path"] = cex_custom_path
        if cex_hostname is not None:
            self._values["cex_hostname"] = cex_hostname
        if cex_path is not None:
            self._values["cex_path"] = cex_path
        if content_custom_path is not None:
            self._values["content_custom_path"] = content_custom_path
        if content_hostname is not None:
            self._values["content_hostname"] = content_hostname
        if content_path is not None:
            self._values["content_path"] = content_path
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if dynamic_custom_path is not None:
            self._values["dynamic_custom_path"] = dynamic_custom_path
        if dynamic_method is not None:
            self._values["dynamic_method"] = dynamic_method
        if dynamic_path is not None:
            self._values["dynamic_path"] = dynamic_path
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modify_protocol is not None:
            self._values["modify_protocol"] = modify_protocol
        if net_storage_hostname is not None:
            self._values["net_storage_hostname"] = net_storage_hostname
        if net_storage_path is not None:
            self._values["net_storage_path"] = net_storage_path
        if preserve_query_string is not None:
            self._values["preserve_query_string"] = preserve_query_string
        if protocol is not None:
            self._values["protocol"] = protocol
        if redirect_custom_path is not None:
            self._values["redirect_custom_path"] = redirect_custom_path
        if redirect_hostname is not None:
            self._values["redirect_hostname"] = redirect_hostname
        if redirect_hostname_type is not None:
            self._values["redirect_hostname_type"] = redirect_hostname_type
        if redirect_method is not None:
            self._values["redirect_method"] = redirect_method
        if redirect_path is not None:
            self._values["redirect_path"] = redirect_path
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the basic action to take when there is a failure to contact the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        '''
        result = self._values.get("action_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        '''
        result = self._values.get("cex_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cex_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies a hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        '''
        result = self._values.get("cex_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cex_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        '''
        result = self._values.get("cex_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        '''
        result = self._values.get("content_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the static hostname for the alternate redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        '''
        result = self._values.get("content_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom redirect path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        '''
        result = self._values.get("content_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode"]:
        '''cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        '''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode"], result)

    @builtins.property
    def dynamic_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to modify the original requested path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        '''
        result = self._values.get("dynamic_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        '''
        result = self._values.get("dynamic_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dynamic_path(self) -> typing.Optional[builtins.str]:
        '''Specifies the new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        '''
        result = self._values.get("dynamic_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled in case of a failure to contact the origin, the current behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the redirect's protocol using the value of the ``protocol`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        '''
        result = self._values.get("modify_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage_hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname"]:
        '''net_storage_hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        '''
        result = self._values.get("net_storage_hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname"], result)

    @builtins.property
    def net_storage_path(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        '''
        result = self._values.get("net_storage_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preserve_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        '''
        result = self._values.get("preserve_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def protocol(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        '''
        result = self._values.get("protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_custom_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Uses the ``redirectPath`` to customize a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        '''
        result = self._values.get("redirect_custom_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_hostname(self) -> typing.Optional[builtins.str]:
        '''When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        '''
        result = self._values.get("redirect_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_hostname_type(self) -> typing.Optional[builtins.str]:
        '''Whether to preserve or customize the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        '''
        result = self._values.get("redirect_hostname_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the HTTP response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        '''
        result = self._values.get("redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def redirect_path(self) -> typing.Optional[builtins.str]:
        '''Specifies a new path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        '''
        result = self._values.get("redirect_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement pattern that defines the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static portion of the SaaS dynamic failaction.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Identifies the component of the request that identifies the SaaS dynamic fail action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns a new HTTP status code to the failure response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cefc850170ee7b415417c2d7bef7bd1bc94622841b4c186595cac54764536db)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__710e66f29febeb5ae4e73e344e603b6d7ee594823edc79da57fa0ab1d14775ac)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94cebb8833b97db9ca8faaacacf9a010b9ef1b433b5f5ee1e33c01f97f3ded3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6c8689ff0c0827d8380f40688bccb0565599d1a086939572e47cfd4b3e88e17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6d666e8eea2a8a25f8bd2a1939e1b7e138785d0246a5970f2ee1fca31c69c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97262b1aeb0d227d78aebda3e1a669172f02460476152e0ce2b9c3d8d5764b8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b9ce65936c29ae7be58ebf975918efe3aefefe171d33d9791b370d4def6bbe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc40fe3f87311641130eb4ad522b144206bd899ea403ffe50fc45115f6aa7d02)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216f93f89b7fc2ef430deb1316a653788e5c361da6224cc179ad09c1e6a0937d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5712da6215949699aedc3ed82bfa2a40cf59f1e65ce0ed134b66f2ff739436ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2337d3f3d78995f8f4dc3b205626efab4cc796233e73415dd99e29f227425c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80b20532c7b41a265c0879474d22765e01988290734463967de4acb8b2d31c29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21b38ac2184b89faf19567f4edd03c334b84e8337993a47b28e2c74eebf86db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f97056046f359fbbfc6c90c0c37849d07fd2b811126630e5dbf56c8bdb0c7119)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c67f9601acfe694c9c58b30b960cdb7181e95d1968d92bd4b3a4ff01eeba2c5b)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311a213aa1bd4aa19e8a024ab8bf72c61eeef4648de7467d547db8f428b58df3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__485d3763746beaea5f5a082c670d598a86f4952912819f04acc55b4ffd33c4fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c06b69f2b1a9ea823bb3b1b4155de82733bebdd72553cc68b43efed78bd88aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7110fa13b9adfd58a580f864459f3a4bb93412bc8b1772a6c964c45f8780f2c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed66df30c0a8ce9331cad678a3483093f98a35d2378dd0cfcd86e6e61dc842cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376009e59e93b6891b8e9a6cbb970ed98b92fbbaf890c301f5d2c02d3de987f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value]))

    @jsii.member(jsii_name="putNetStorageHostname")
    def put_net_storage_hostname(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorageHostname", [value]))

    @jsii.member(jsii_name="resetActionType")
    def reset_action_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetActionType", []))

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCexCustomPath")
    def reset_cex_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexCustomPath", []))

    @jsii.member(jsii_name="resetCexHostname")
    def reset_cex_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexHostname", []))

    @jsii.member(jsii_name="resetCexPath")
    def reset_cex_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCexPath", []))

    @jsii.member(jsii_name="resetContentCustomPath")
    def reset_content_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCustomPath", []))

    @jsii.member(jsii_name="resetContentHostname")
    def reset_content_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentHostname", []))

    @jsii.member(jsii_name="resetContentPath")
    def reset_content_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPath", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDynamicCustomPath")
    def reset_dynamic_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicCustomPath", []))

    @jsii.member(jsii_name="resetDynamicMethod")
    def reset_dynamic_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicMethod", []))

    @jsii.member(jsii_name="resetDynamicPath")
    def reset_dynamic_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicPath", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyProtocol")
    def reset_modify_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyProtocol", []))

    @jsii.member(jsii_name="resetNetStorageHostname")
    def reset_net_storage_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorageHostname", []))

    @jsii.member(jsii_name="resetNetStoragePath")
    def reset_net_storage_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStoragePath", []))

    @jsii.member(jsii_name="resetPreserveQueryString")
    def reset_preserve_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreserveQueryString", []))

    @jsii.member(jsii_name="resetProtocol")
    def reset_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProtocol", []))

    @jsii.member(jsii_name="resetRedirectCustomPath")
    def reset_redirect_custom_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectCustomPath", []))

    @jsii.member(jsii_name="resetRedirectHostname")
    def reset_redirect_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostname", []))

    @jsii.member(jsii_name="resetRedirectHostnameType")
    def reset_redirect_hostname_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectHostnameType", []))

    @jsii.member(jsii_name="resetRedirectMethod")
    def reset_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectMethod", []))

    @jsii.member(jsii_name="resetRedirectPath")
    def reset_redirect_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectPath", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostname")
    def net_storage_hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference, jsii.get(self, "netStorageHostname"))

    @builtins.property
    @jsii.member(jsii_name="actionTypeInput")
    def action_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="cexCustomPathInput")
    def cex_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cexCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cexHostnameInput")
    def cex_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="cexPathInput")
    def cex_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cexPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCustomPathInput")
    def content_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="contentHostnameInput")
    def content_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPathInput")
    def content_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentPathInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPathInput")
    def dynamic_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicMethodInput")
    def dynamic_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicPathInput")
    def dynamic_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dynamicPathInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyProtocolInput")
    def modify_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageHostnameInput")
    def net_storage_hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname], jsii.get(self, "netStorageHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="netStoragePathInput")
    def net_storage_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "netStoragePathInput"))

    @builtins.property
    @jsii.member(jsii_name="preserveQueryStringInput")
    def preserve_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preserveQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="protocolInput")
    def protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "protocolInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPathInput")
    def redirect_custom_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectCustomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameInput")
    def redirect_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameTypeInput")
    def redirect_hostname_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectHostnameTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectMethodInput")
    def redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectPathInput")
    def redirect_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "redirectPathInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="actionType")
    def action_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "actionType"))

    @action_type.setter
    def action_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__905b6897901fb79125de4b4ca61763247b9660056dbd51964cd14244523fc5c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "actionType", value)

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a0e3b0b313885ea5bd6b70f85d9919a98642de74d11d5129c23bc9aed3cc83)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="cexCustomPath")
    def cex_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cexCustomPath"))

    @cex_custom_path.setter
    def cex_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__769f8d95d9560cdcab094455f322caac866b0f1601f3c7dfb3d7ddb719acb426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="cexHostname")
    def cex_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexHostname"))

    @cex_hostname.setter
    def cex_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__453ea6253adda90a38c2f2b98fee5b74d6335d9381708be5cc002dfc9de6c7a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexHostname", value)

    @builtins.property
    @jsii.member(jsii_name="cexPath")
    def cex_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cexPath"))

    @cex_path.setter
    def cex_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dcaa56c0f363361b309be50921589f125eceb897d89b2037997bac5b9fd0ab8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cexPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentCustomPath")
    def content_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCustomPath"))

    @content_custom_path.setter
    def content_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d89ba8718fce9347088aeae5537f5dc21f598e2f2a8b8f5e4e2befe9ed24e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="contentHostname")
    def content_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentHostname"))

    @content_hostname.setter
    def content_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05826629a45a043a972876f0157a0c5e827e3a63a4ccf9c68e4ac5b559146394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentHostname", value)

    @builtins.property
    @jsii.member(jsii_name="contentPath")
    def content_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentPath"))

    @content_path.setter
    def content_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a89fd5f8cbade2861c060639e78f80a9edf40bcefc067f250b81b7b970b59c13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicCustomPath")
    def dynamic_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicCustomPath"))

    @dynamic_custom_path.setter
    def dynamic_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e76b9ea35aed1215be8baacdf946584e1dcba91708f64d38bab07734468efa5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicMethod")
    def dynamic_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicMethod"))

    @dynamic_method.setter
    def dynamic_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162a19c9073a7090c2abc83f6dd203282df2527aefeb045a9050d5d9bd5ffb89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicMethod", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicPath")
    def dynamic_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dynamicPath"))

    @dynamic_path.setter
    def dynamic_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce81a15277d73777f396f9ff8aef53e28133e450e8c8732e8274f1079e136450)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicPath", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43fcbe7c9c095b2284ca272b615ce2eaa8f5087ca6c7f6279e6acf94308ea21d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd9f518483c3f2ae404cae720e993afa95ca8127b6e98538103f52d0106dba81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyProtocol")
    def modify_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyProtocol"))

    @modify_protocol.setter
    def modify_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18ad6e642938f4cf6f2d0a5c3e880f8ceebf7dbb76805ebb77f00e3f9152e1ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="netStoragePath")
    def net_storage_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "netStoragePath"))

    @net_storage_path.setter
    def net_storage_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c89866bb0cac1f7bda48188ff83617a3198946edcd7bbb7d14b54406636307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "netStoragePath", value)

    @builtins.property
    @jsii.member(jsii_name="preserveQueryString")
    def preserve_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preserveQueryString"))

    @preserve_query_string.setter
    def preserve_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d5d6177ade9beadba300b2bd34b4b75064016297a4da2f7d62c7fd5d3d8cc08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preserveQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="protocol")
    def protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "protocol"))

    @protocol.setter
    def protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__181662578da77278781eafc27b993d7028f8930682601fec1055aa46d9b7a78b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "protocol", value)

    @builtins.property
    @jsii.member(jsii_name="redirectCustomPath")
    def redirect_custom_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirectCustomPath"))

    @redirect_custom_path.setter
    def redirect_custom_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c10a861f7ebe9892ed1c014d709b816993c7490f0508d03bb3aee6d688ef15d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectCustomPath", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostname")
    def redirect_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostname"))

    @redirect_hostname.setter
    def redirect_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6a90af58c0dfd5619a422beacbaacb0ed12cd378ccb43ce09672928fa330385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostname", value)

    @builtins.property
    @jsii.member(jsii_name="redirectHostnameType")
    def redirect_hostname_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectHostnameType"))

    @redirect_hostname_type.setter
    def redirect_hostname_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce508540b692516b5cdec85fd4827fb67408518b4c2a54c0a0f46632411e92cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectHostnameType", value)

    @builtins.property
    @jsii.member(jsii_name="redirectMethod")
    def redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectMethod"))

    @redirect_method.setter
    def redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__020abdaeb25cbb787c0efcab8e14f8f26c5d38709ff29c35ba0d697684434b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="redirectPath")
    def redirect_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "redirectPath"))

    @redirect_path.setter
    def redirect_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__045f1469a45eb351197e04f641afa0335554834ebcba76fbad9032793961d3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectPath", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a5567dc49c29475f070d47b63d445ad85fc51e1a6c991db4b9dc9321115049f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d0679c07981ac23306cf09191b9e242fb4b5c439b46071519bcb14e0965216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0c9dca42433036548c70b2e679f43105da5dd27a4dd5844fa52d87f7c6c329f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a6d0bd0e4eb4171d157475430b3176947211fb64e973319e7870a4590e6a393)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ff287e3f9e465fb5e65e0e01c1a41ef89d513ef02fd7a2fa39266a13c59816c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628f176e7b305a0e148293aa53e8a4b080ba00c35f1342e099f0baf52cd58937)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f5b3636e505cd5a7f21442a80cb88d4c1a4aa4362cf8e83f860f962a13a5bf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9a120d81012c5c52e730f1aa0191b27eb15c8d20c85b40d6eb5ea506f7e1397)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b9cbc771e30e021e5d87a3342bf6ad1e552e9bf274b9878578cbff6257fc536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ef35d14d62a6b96d14f603cd9dc38e29cfd8e3180f64504af908df67d3fc94f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__835ff272d1cbdc152da2344b3db6610b0e39688bb5a645c2a77fe4657457602c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d916791bd9f1bb343404a550bb54b074382cb84de94e6733b9176e4f57b18e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "compatibility": "compatibility",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility:
    def __init__(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce37576b87dd57e7c8f32a641f6bef3a3933f77a5cdac283a9c074a051c97b31)
            check_type(argname="argument compatibility", value=compatibility, expected_type=type_hints["compatibility"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if compatibility is not None:
            self._values["compatibility"] = compatibility
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def compatibility(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This behavior does not include any options. Specifying the behavior itself enables it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        '''
        result = self._values.get("compatibility")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d94a6ecd970279c7ccafe44f1656e7b1bf65725f9a03911926573d9d3493af8e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCompatibility")
    def reset_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompatibility", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="compatibilityInput")
    def compatibility_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="compatibility")
    def compatibility(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compatibility"))

    @compatibility.setter
    def compatibility(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11f8d30b82a7e60343332e11fe18d31320350e021862b116ad66cfedcb7cc7ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compatibility", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__739b974750db73cffd4aae8f127d2c91ce4a35dcb171479d3ddc1a6adfbd7837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b77ab9b6f589bbb25822a2dc83b3a58eb64710e0d9963382e3edac653c83520)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02c389f2b65d10fea29b3fd7a821bf87cf33b76cec1a6bb8dbcbb0f786fcf13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71a19bcd3b49dac107424919ff66cec77c6ef953e72b04dd78add2c0c2b5a0d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f72227e1a09e49dc628da0e2dc397d7d1ae73d0f77caef84e43d19b3a081ce4)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, forces a validation test for all edge content to which the behavior applies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e381c66d1941953b0969e2a01e8e6cc790555470ee1ccc19e327b46f480a27f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a71590fd9dd078cb540014fb9eac5416849556461875267badf294b63cf971d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6d182630174c19c69c2f5d61c730506f456b776725b1a7bbf5681f8a86b0756)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e39ed947b89ab71721b41dba01731d0048f50a17db9e01eef6916d05d39bbf9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef38caf0ed155fdde3d2451613b0ea461738af389c05245e816100bbbc8d705f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76d008d5f77642994b74745a0dfc2dbc92319ea8aa16d900cf957807bb5bd435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9ff60b5c0efd6935f81ea783d94bb6b583a1e3fb6dbd7c3e22f81fb8d6fcafa)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f20f4f5f5cbfb69bd3ebceaaa82da45a4a3ff5da45a6d7934545c98a0c88ffc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecb89b7fc44ce86602ba7068fcd5ef1206f5c2055de89d1d9fbd5fd0e3f899fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__992e0c542d4eebee10b5af9cba08f86431db37314a76e196fdf5f539bd70a0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d92fc5d58aec4006633f34ac06cc5f136446b66407d981bf0bf01fc9095a420c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6be172157eb88071b9ab6557b29f5df643060d5d4e3d731dfe73b1119df80a86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac85150147fe384be6aadfd1f9e37f10d7b83c1fd8715fbffb9e0dfd3d63705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a30190b24e9953a9341603cd78f0c9e1e38aa9943c384bcda9d03b588eb99dd3)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12cef9ba4acef778680f66e8a3832e5c37eb62f059fa362a36f823d9f4c6c7d)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9734f655e0f53d93d7fe2cfc1a2e501a685d44c209394450654e3027588806e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cf840c93f59473034144fc1e51c8c3259807b56169a4c0a854779903e1e100b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31206dde591f1f1d811ee4af904cc20d9506524d14b2d0827b8e6e4c4a3f981e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be51e3c14f911b46f609461d762e080067d258f47f0fa76383eda30847de480b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36533414d70336020f75d99e89e4e7860f08f1df08ab7909ea60134ba7aceb9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__548eee75261555e29db0127021aaddbc1b98530576fb1d1200ed09232ee2a640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97831a0329dc3012b07cccc2d7335155b6d42233a10836be846175f4dfb04426)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93b0a24680cd36a4ab4e9750a251471c008bdf13166530f1d0a32be610b0d70c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e44fb4e2610eda91591803eb1b428158e3d44ffceae3ef1c44c37da1e4c692f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2de435c2ef013312ecdb0fbf88f76bc27d2218ca2ffc5d7d09365aa381587c73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86b6823aebf970ec29bdffe1efc7814b03915859d9d4a69b12392401430c0660)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a330fd42ee58480e5e4b3313a1e4220b5d3bac044151aeb098b8ba335e0aae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "java_script_insertion_rule": "javaScriptInsertionRule",
        "locked": "locked",
        "media_math_prefix": "mediaMathPrefix",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a403d7dcf287b48f0dcddab5566f75f01baed04e41f99a1348a0e705037f8073)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument java_script_insertion_rule", value=java_script_insertion_rule, expected_type=type_hints["java_script_insertion_rule"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_math_prefix", value=media_math_prefix, expected_type=type_hints["media_math_prefix"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if java_script_insertion_rule is not None:
            self._values["java_script_insertion_rule"] = java_script_insertion_rule
        if locked is not None:
            self._values["locked"] = locked
        if media_math_prefix is not None:
            self._values["media_math_prefix"] = media_math_prefix
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Cloud Marketing Plus Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def java_script_insertion_rule(self) -> typing.Optional[builtins.str]:
        '''Select how to insert the MediaMath JavaScript reference script.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        '''
        result = self._values.get("java_script_insertion_rule")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_math_prefix(self) -> typing.Optional[builtins.str]:
        '''Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic.

        Include the leading slash character, but no trailing slash.  For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        '''
        result = self._values.get("media_math_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ab954a8f71fb2b225bffeaca87b9cb446aa788221cc2c5a694461580b5b7718)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c59665866b187d04cf1d711f2540fee18336acfd03db84abf74099da5ac9538)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2787f8f9c4a1865366b1ec1921a07a9e135b87b5019393bbeef9a6c956a5d622)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d73cdfe2839b4958293b3204945d8a8275bf022939daf66efed8f9922a38ad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35a62074650f8e23f3cfc5ea0c5114f489984db714b889b8557fb7fc8b68e9cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bdf1f44f70cec29f26abfe1b8ac4de82f098a7ba372520e38f8d082cc9f4c34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetJavaScriptInsertionRule")
    def reset_java_script_insertion_rule(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJavaScriptInsertionRule", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaMathPrefix")
    def reset_media_math_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaMathPrefix", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRuleInput")
    def java_script_insertion_rule_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "javaScriptInsertionRuleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefixInput")
    def media_math_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaMathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f6227fc76e3b2c0f295ffaaa77dfb175cf6fc4f6374d483337495a71b7c7f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="javaScriptInsertionRule")
    def java_script_insertion_rule(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "javaScriptInsertionRule"))

    @java_script_insertion_rule.setter
    def java_script_insertion_rule(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b18254da0e31c63562ed72dbe9b8f5aa381503f84ff3f978cab9a52b79a0e1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "javaScriptInsertionRule", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ac06af132ece5c542d7d338c00426cce5e92e5f58a03e1c180db5b4d6010b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaMathPrefix")
    def media_math_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaMathPrefix"))

    @media_math_prefix.setter
    def media_math_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7e00e71c486c8f33982e62535cad000765557683abbb2c74b887c2346f33ecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaMathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a9073ff70625e2d659f1ccb2e989a76c80b432069f5b3082d0d6b42427e42d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8357de776cc3597a894044a85c0fa4c061a40db585d5e0678f626ec950a6481)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8266b70d65e9c6f75604941c4870d96c5e4a029b2d655aa970e11b03352afd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e97f639cbf5c69100e2f9c622afe3124feb7a417d145e8c58e0d13c2b0e674c0)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Forward Rewrite Cloudlet behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to use a shared policy for a Cloudlet.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d4f7e96a7d2983ac4b40fd0d6da830539005f2ab54bbdcc66071467d3a33da)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b148d07452beab1a550d372e768b7e2262f6f48e0f91f3317c1a8b216de1792a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b8ca875a4ffc0e212878583f931fcd07205f86bf5940a8e559f5620bfefa21f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc49ef9a83da22ef7a59f3356eeeddab3c422f56b71537bf59ed145037b0d88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b185cd50b72b5dffd12af67add838362c4082d7cb70f32be7dad4a098a02b549)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aae523208cf9ea377fb85ad77b0736b417928ba1751d6540052c60f700525435)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cae6db698501e41aa669f549e0272b7caf0c8d57af91f406141104a4ec26b24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__105b34eb1e11b27c25afb105041bcd7ffc2ba3d8a6d0f178ccfcb42e2786ef3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53fed39e994e24d1273f1daa22bcf247aec3150428066c42967dee7ecd9b0edf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d806c94d280ac047b83dc3f374ac2a992d51d54d8e528c0615ad3e9b259b7ffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7de18656a55c0e7215a79f723a28f7642611a9a3612ec421ee5a60ea7c6d65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8d445ee396651126d57d0f64e7c9dd182345e159895697bd51c964dacc0f2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4e687f74e0b0933b9049312dfd7c6157fb54d6487ac1a178e1d51021a5cba21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader",
    jsii_struct_bases=[],
    name_mapping={
        "custom_sign_string": "customSignString",
        "data_header": "dataHeader",
        "enabled": "enabled",
        "encoding_version": "encodingVersion",
        "locked": "locked",
        "nonce": "nonce",
        "secret_key": "secretKey",
        "signed_header": "signedHeader",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader:
    def __init__(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871c71b523862dd46448fedaae56768dbac7d99845e5f976ffa2a822655472d6)
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument data_header", value=data_header, expected_type=type_hints["data_header"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument signed_header", value=signed_header, expected_type=type_hints["signed_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if data_header is not None:
            self._values["data_header"] = data_header
        if enabled is not None:
            self._values["enabled"] = enabled
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if locked is not None:
            self._values["locked"] = locked
        if nonce is not None:
            self._values["nonce"] = nonce
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if signed_header is not None:
            self._values["signed_header"] = signed_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of data to be encrypted as a combination of concatenated strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def data_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header that contains the request data that needs to be encrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        '''
        result = self._values.get("data_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the g2o verification behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the cryptographic ``nonce`` string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signed_header(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the header containing encrypted request data.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        '''
        result = self._values.get("signed_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, the encrypted string is based on the forwarded URL.

        If enabled, you can use ``customSignString`` to customize the set of data to encrypt.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__268efa158852728af9d3980d8981bceccbbf0ecdd6013acd0284a9f7772dea92)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDataHeader")
    def reset_data_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataHeader", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetSignedHeader")
    def reset_signed_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignedHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="dataHeaderInput")
    def data_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dataHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="signedHeaderInput")
    def signed_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "signedHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__054e4d991cdb34a22c7437996c7bdd9c2eaad2fe7feade5bcf4c31a23482213a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="dataHeader")
    def data_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dataHeader"))

    @data_header.setter
    def data_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d19ee845d087e64ff580f6b5c2d3b56f11cadc2c0c15ab96c4b3303ca5a926dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3470c84fae8c68d3481946ad86bdf2bc66f2f90ef6f2c35d0b284eddab4c760)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa413c1e052070b400f3b86c66500fca67c3062a74a7654d33ad006a80a9ccd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c7a289aab55c880249bd90ab570e61a26dba0b92e7e83c40fafc549890318d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d016fece97130a43722819bb119ee439c64f7945aa46617a2dd8f050ec67583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc1cea5c51a5766ef26467001a8d5c1f7305546305a8b3bd738dac7d997bac5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="signedHeader")
    def signed_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "signedHeader"))

    @signed_header.setter
    def signed_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819290d0ece80b58655823dd804ba64c43646324cdbb2a88a466416d026646ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signedHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b41780dd7647ba4986eaf0489229bcafa6d6ecf0e1b213bcf9fb008f35adf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a970b87e50941b1dcfa1ac0c27b2138337766b284de7de761c5b31979b18b81d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3103b96384af65cde82d8c3d9425accba8c6645eba7dd6e301164bb5ebe18c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55e0989e38d986c7da5eb9b46b7e7c5079cc83f108cd78335454d5bbec0c0e47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "output_option": "outputOption",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__338fb9ee4cf62b571ffa7268f061897321c6c2b38f513d1ce0a95ccade0695e6)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument output_option", value=output_option, expected_type=type_hints["output_option"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if output_option is not None:
            self._values["output_option"] = output_option
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def output_option(self) -> typing.Optional[builtins.str]:
        '''Specifies how to report the GRN value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        '''
        result = self._values.get("output_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the variable to assign the GRN value to.

        You need to pre-declare any ``variable`` you specify within the rule tree.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__330e4153fa53cd17af6d4d4c3bfe5ddb6a8561ecf204c32f50da3d080f48695a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOutputOption")
    def reset_output_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOutputOption", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="outputOptionInput")
    def output_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "outputOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b73f168fd8786bad4775b01019eb8e313d0e24ec9a73f0f04080ed88fabb297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__877318aaef5ba5e1344cf4e24d6b075da3058dfaed741f02209cb3cc088012d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="outputOption")
    def output_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "outputOption"))

    @output_option.setter
    def output_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d020c587fee6d42b8f274ab46c89d81225c7557f174fc23583cdab121dcfe3f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "outputOption", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b05ab11aefc97612848d376dba1bffc977aa2b2499a1614c28dbe018e73a17a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__519689b4795d122e3564a3a850f2158d27d28d981bad9569bf3cd9b3ef11504c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0da0bbd3e9ebfade1e68ab02a1fad9302dce3f049fcfca0ed3a391d9cdddd825)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3a4d0ce65e33e6a27d384309f4d4a455a254b1d210373e089850ad66b8c04b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "cache_responses_with_errors": "cacheResponsesWithErrors",
        "enabled": "enabled",
        "locked": "locked",
        "operations_json_body_parameter_name": "operationsJsonBodyParameterName",
        "operations_url_query_parameter_name": "operationsUrlQueryParameterName",
        "post_request_processing_error_handling": "postRequestProcessingErrorHandling",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching:
    def __init__(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f959ad0e3f74154755efecd76e6fc1e619e4fdfaae456b78a5bdd524ee11b083)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument cache_responses_with_errors", value=cache_responses_with_errors, expected_type=type_hints["cache_responses_with_errors"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument operations_json_body_parameter_name", value=operations_json_body_parameter_name, expected_type=type_hints["operations_json_body_parameter_name"])
            check_type(argname="argument operations_url_query_parameter_name", value=operations_url_query_parameter_name, expected_type=type_hints["operations_url_query_parameter_name"])
            check_type(argname="argument post_request_processing_error_handling", value=post_request_processing_error_handling, expected_type=type_hints["post_request_processing_error_handling"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if cache_responses_with_errors is not None:
            self._values["cache_responses_with_errors"] = cache_responses_with_errors
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if operations_json_body_parameter_name is not None:
            self._values["operations_json_body_parameter_name"] = operations_json_body_parameter_name
        if operations_url_query_parameter_name is not None:
            self._values["operations_url_query_parameter_name"] = operations_url_query_parameter_name
        if post_request_processing_error_handling is not None:
            self._values["post_request_processing_error_handling"] = post_request_processing_error_handling
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cache_responses_with_errors(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches responses that include an ``error`` field at the top of the response body object.

        Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        '''
        result = self._values.get("cache_responses_with_errors")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables GraphQL caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def operations_json_body_parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the JSON body parameter that identifies GraphQL POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        '''
        result = self._values.get("operations_json_body_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def operations_url_query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of a query parameter that identifies requests as GraphQL queries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        '''
        result = self._values.get("operations_url_query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def post_request_processing_error_handling(self) -> typing.Optional[builtins.str]:
        '''Specify what happens if GraphQL query processing fails on POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        '''
        result = self._values.get("post_request_processing_error_handling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d36eb51d8dfefe693677496ca482924eb3303791078132858dfe10ba1f7e4d69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetCacheResponsesWithErrors")
    def reset_cache_responses_with_errors(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheResponsesWithErrors", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOperationsJsonBodyParameterName")
    def reset_operations_json_body_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsJsonBodyParameterName", []))

    @jsii.member(jsii_name="resetOperationsUrlQueryParameterName")
    def reset_operations_url_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperationsUrlQueryParameterName", []))

    @jsii.member(jsii_name="resetPostRequestProcessingErrorHandling")
    def reset_post_request_processing_error_handling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPostRequestProcessingErrorHandling", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrorsInput")
    def cache_responses_with_errors_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheResponsesWithErrorsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterNameInput")
    def operations_json_body_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsJsonBodyParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterNameInput")
    def operations_url_query_parameter_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operationsUrlQueryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandlingInput")
    def post_request_processing_error_handling_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "postRequestProcessingErrorHandlingInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f75ba58b056b9955911fe3fe2093c4b498fa0237036bf260e39c47ccc28dbb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="cacheResponsesWithErrors")
    def cache_responses_with_errors(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheResponsesWithErrors"))

    @cache_responses_with_errors.setter
    def cache_responses_with_errors(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22d02c5cf81431cd96fc94e4989baae1d81dc0f338baee867b5093dda9fb27d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheResponsesWithErrors", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98ba6db2c301913fcad796653742e80e4ff2e90d91f1df1c20fd58baba44d081)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7fade7f2cf66bc28dfb2106cec60b8a8357c222052f706551857eb386f1e79ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="operationsJsonBodyParameterName")
    def operations_json_body_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsJsonBodyParameterName"))

    @operations_json_body_parameter_name.setter
    def operations_json_body_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30ecb50322daa65910186e43175cd29fbfd807f5781c1db8973ae86b4b7f0e46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsJsonBodyParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="operationsUrlQueryParameterName")
    def operations_url_query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operationsUrlQueryParameterName"))

    @operations_url_query_parameter_name.setter
    def operations_url_query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84a5b0fca81b9a8faa02a1f10f1bc96954a0f4b75f18c624ebd20493da8ddc8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operationsUrlQueryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="postRequestProcessingErrorHandling")
    def post_request_processing_error_handling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "postRequestProcessingErrorHandling"))

    @post_request_processing_error_handling.setter
    def post_request_processing_error_handling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39b33a3ead699e2465772235bf0c9f1e7b95a57c15202a5d96e2563c8b1db9e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "postRequestProcessingErrorHandling", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33cdaa993b1e0e00392a48f990b3197b3cd8eaff05eb7877fc2e8eb40c8f5e21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec97a594ca815f4e9dd514a38cd4c0361db8e385abe1b216513f82b67d10736)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__110845b25fbbb276738f726c2ed2697e9960b9577d6e677eada13d0c1423d837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa9ae2194f3ddf358e4f43b0c03160be689e662991f37115e764faf48a9c0a21)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Specify when to compress responses.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__777ae09aa7a8f638fb572649a76c46a0d51068c650829d35842d051e304c7887)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c56a7e4dd4d1d7362ab07d9740cee3d3c73a0fc51fa79aa0cccc84fe2a8d57a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7608ce8b70ecf312b27b764da45f199924a10f30a01cbccf24b84821345fd84f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba6bb1bd387f5c9806f7a9d6764a7bec144e23d0b9846d8752c1b0b889e9288a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aee3b8f58686b5b198cd12fe9a2a57c69a0d924d483f168ae1c0a222b234c345)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac1f508f146ae5323ce1e139eba000aa50952264137e01be61e0fac4ec2f6dda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "xml": "xml",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced:
    def __init__(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0df490b881c569690b0f5abdb38b3ca66b7d7b22a56fb30ecf1686d71f8608e2)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument xml", value=xml, expected_type=type_hints["xml"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if xml is not None:
            self._values["xml"] = xml

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''Human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def xml(self) -> typing.Optional[builtins.str]:
        '''A block of Akamai XML metadata.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        result = self._values.get("xml")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcf4da3a430a3f3a3082ed1b79063072ba1a19551883cb2c972fc45246cc855)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetXml")
    def reset_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetXml", []))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="xmlInput")
    def xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "xmlInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78fdc68046c65e1057d2da93a3aae15e9eb0bbe12ae7160caef5d5f8ec70718)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__257a3311786608dbc3006904afdadbf8bf308a362ff64070066147eb070b0cc0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bbddb0320c90a8be8bee7b09425e6954aff56d8abaa775ec172ea4a678b4538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11b46da674ecec2d802c70343d573b9774e76603017c6e7f2aeaddcd5ba78338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="xml")
    def xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "xml"))

    @xml.setter
    def xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33306f3e385fd6652f3b3f22da3ec045e1f96605da2b6084bf40d7dc2b0ad67d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "xml", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c8d55adf261667012a27f5beadbef73452e0366f3c3e7c2665a15df6a82c958)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_reconnects": "maximumReconnects",
        "retry_count": "retryCount",
        "retry_interval": "retryInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c194236e8a6a87836f32b7c7190fc8ce569bef431bb68ee3eecd2b78b4d281fa)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_reconnects", value=maximum_reconnects, expected_type=type_hints["maximum_reconnects"])
            check_type(argname="argument retry_count", value=retry_count, expected_type=type_hints["retry_count"])
            check_type(argname="argument retry_interval", value=retry_interval, expected_type=type_hints["retry_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_reconnects is not None:
            self._values["maximum_reconnects"] = maximum_reconnects
        if retry_count is not None:
            self._values["retry_count"] = retry_count
        if retry_interval is not None:
            self._values["retry_interval"] = retry_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_reconnects(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum number of times the edge server will contact your origin server.

        If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        '''
        result = self._values.get("maximum_reconnects")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_count(self) -> typing.Optional[jsii.Number]:
        '''The number of consecutive connection failures that mark an IP address as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        '''
        result = self._values.get("retry_count")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def retry_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        '''
        result = self._values.get("retry_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb802e1d0dbfd670b72a5ece9dd2240805dfe1d65a7f7923d43a89ccb869d95)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumReconnects")
    def reset_maximum_reconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumReconnects", []))

    @jsii.member(jsii_name="resetRetryCount")
    def reset_retry_count(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryCount", []))

    @jsii.member(jsii_name="resetRetryInterval")
    def reset_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRetryInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumReconnectsInput")
    def maximum_reconnects_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maximumReconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="retryCountInput")
    def retry_count_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "retryCountInput"))

    @builtins.property
    @jsii.member(jsii_name="retryIntervalInput")
    def retry_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "retryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0660349edbb5cf3c74fffe5e987f5643759b02ca1b31be6810d8287ea0fc1b7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumReconnects")
    def maximum_reconnects(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maximumReconnects"))

    @maximum_reconnects.setter
    def maximum_reconnects(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf1bccead7fc94aea5ed40eafa7ec1b4c281613897a4f4ed7aeecc8756d6ed06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumReconnects", value)

    @builtins.property
    @jsii.member(jsii_name="retryCount")
    def retry_count(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "retryCount"))

    @retry_count.setter
    def retry_count(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24c287fe466ee8de86ad760c4642a7a4f03a187f80ba1537c05485159a5871dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryCount", value)

    @builtins.property
    @jsii.member(jsii_name="retryInterval")
    def retry_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "retryInterval"))

    @retry_interval.setter
    def retry_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c58370c2adabc901295698dbc8bd43c8d30d98dc06fb2b1cc3f3b3d428c9fbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "retryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ce244919a58d97153a5158f2887296ab8cf065c6cdd4393b2fe07aadd97529d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f29d2dd73382088093ac77a690d2057bf065b269842476262306dd46d5237e7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7e7829a46714ce8ba083b3c8f3e7084ba173d39f93ac6e22ddb0a6cd1f738c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding",
    jsii_struct_bases=[],
    name_mapping={
        "custom_extracted_serial": "customExtractedSerial",
        "enabled": "enabled",
        "hash_max_value": "hashMaxValue",
        "hash_min_value": "hashMinValue",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tier": "tier",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding:
    def __init__(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86138294376c194d14be92f9404ef30d06caa4faa21f42b68da9f44e770570e2)
            check_type(argname="argument custom_extracted_serial", value=custom_extracted_serial, expected_type=type_hints["custom_extracted_serial"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hash_max_value", value=hash_max_value, expected_type=type_hints["hash_max_value"])
            check_type(argname="argument hash_min_value", value=hash_min_value, expected_type=type_hints["hash_min_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier", value=tier, expected_type=type_hints["tier"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_extracted_serial is not None:
            self._values["custom_extracted_serial"] = custom_extracted_serial
        if enabled is not None:
            self._values["enabled"] = enabled
        if hash_max_value is not None:
            self._values["hash_max_value"] = hash_max_value
        if hash_min_value is not None:
            self._values["hash_min_value"] = hash_min_value
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier is not None:
            self._values["tier"] = tier
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_extracted_serial(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to pull the serial number from the variable value set in the ``advanced`` behavior.

        Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        '''
        result = self._values.get("custom_extracted_serial")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HSAF for Edge IP Binding customers with a large footprint.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hash_max_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        '''
        result = self._values.get("hash_max_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def hash_min_value(self) -> typing.Optional[jsii.Number]:
        '''Specifies the minimum value for the HSAF hash range, from 2 through 2045.

        This needs to be lower than ``hashMaxValue``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        '''
        result = self._values.get("hash_min_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier(self) -> typing.Optional[builtins.str]:
        '''Specifies where the behavior is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        '''
        result = self._values.get("tier")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8740020774e17b7cdbb11f40e601cc27315e4764e089f401b0c4d8950678da9e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomExtractedSerial")
    def reset_custom_extracted_serial(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomExtractedSerial", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHashMaxValue")
    def reset_hash_max_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMaxValue", []))

    @jsii.member(jsii_name="resetHashMinValue")
    def reset_hash_min_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashMinValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier")
    def reset_tier(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerialInput")
    def custom_extracted_serial_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customExtractedSerialInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMaxValueInput")
    def hash_max_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMaxValueInput"))

    @builtins.property
    @jsii.member(jsii_name="hashMinValueInput")
    def hash_min_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "hashMinValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tierInput")
    def tier_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tierInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customExtractedSerial")
    def custom_extracted_serial(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customExtractedSerial"))

    @custom_extracted_serial.setter
    def custom_extracted_serial(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17f040e4cc8092542bdc8e01c50ba620bc1a093c5d6cb0e80359c7b0e4df4333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customExtractedSerial", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecac1a078621929b9ab3d8e2a38f3164b37e05e564b0ee4a95359d146dc0cd72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hashMaxValue")
    def hash_max_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMaxValue"))

    @hash_max_value.setter
    def hash_max_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c632ba717377069f777fe5d1dcce3a469d1a45ea6e5effd70725524aa4bdb7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMaxValue", value)

    @builtins.property
    @jsii.member(jsii_name="hashMinValue")
    def hash_min_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "hashMinValue"))

    @hash_min_value.setter
    def hash_min_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8851c37e069cb489e7a3f6007635ee4c5277901ebab8dbc7b5abbb6860bbd615)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashMinValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09877befb21ecfd362a0ee407a2d8ced179f555978fdb5d3792cd066799e80b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e972829c10e8eac5f9b48e55fa4be78eae4227575e4f7542c6ae5018472a87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier")
    def tier(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier"))

    @tier.setter
    def tier(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bb2069f74b84941c885e7da533653343313269fd558b3bf604e2babc8862daa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16aa7a70cca6c5836a74a928f6996d185fcdba86a59dbc70cc9cb7809e909f72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61b10650563c7680071c6a44f0dcb75dd2dc84f52b82053cc4ed86e806f134c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2:
    def __init__(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc559fcc885f19559ede772a08e803c0c7e17ac1abdcc8f7e8217e092f1f1839)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbd2b523b1f7619cfb1df089a8fe9c8ee5aa70363e1fe56b9aa00ce47c0a7c34)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f406197d3b836c87565e22afb7abe762e45e19f612b2b769b912dc7f4ca82ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e6f1afa01bdaae59a36ac7b481b1f7860cf0d29fbc17cae304d194173530933)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd499f2d614808ad0ac0c2d91e7a8c5778450eb1bdc6ae3415f81aec79bdd435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4336a5516b86de3430abd815f362e5b043bcaadd08871ad8eb7e796e56ac87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f0dbbc9ded7f569a030760c91678953977ad4d88dc9839286dca8189f2e4a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5322539a2d99a4eadc5e01da36b23f3e03aa4250e662670e5764d3064e31e5)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This enables HTTP/3 connections between requesting clients and Akamai edge servers.

        You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1014ba38612c60217e1714f1ff110156ed6a26e4f28b8b99982d37e995db75)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2eb973883619ac33c568ba8ef7ddd527383d5d8814acb961452a3ea9e64fdfaf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e963f9dcffa00d831566e030d8eaaf802e0f528aa008bda23e1a20974ebf9311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0010b482fd17fee43c68a0bb2579acc6d048b1b65a65290fa56456699adb572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5feaf55b9f79df36ab69a5fd04401db478e5355a0db95e8fd41d752041f09fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b72171f8606154fa6b018d2ec47b7003322a47fac3261c7c7293e6a42dd4734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "include_sub_domains": "includeSubDomains",
        "locked": "locked",
        "max_age": "maxAge",
        "preload": "preload",
        "redirect": "redirect",
        "redirect_status_code": "redirectStatusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__512f8d5c8eeb7ba5d21e5ec396c5582a32a6bbaedffe9456848b4b0040b5a101)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument include_sub_domains", value=include_sub_domains, expected_type=type_hints["include_sub_domains"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_age", value=max_age, expected_type=type_hints["max_age"])
            check_type(argname="argument preload", value=preload, expected_type=type_hints["preload"])
            check_type(argname="argument redirect", value=redirect, expected_type=type_hints["redirect"])
            check_type(argname="argument redirect_status_code", value=redirect_status_code, expected_type=type_hints["redirect_status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if include_sub_domains is not None:
            self._values["include_sub_domains"] = include_sub_domains
        if locked is not None:
            self._values["locked"] = locked
        if max_age is not None:
            self._values["max_age"] = max_age
        if preload is not None:
            self._values["preload"] = preload
        if redirect is not None:
            self._values["redirect"] = redirect
        if redirect_status_code is not None:
            self._values["redirect_status_code"] = redirect_status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies HSTS to this set of requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def include_sub_domains(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies HSTS to all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        '''
        result = self._values.get("include_sub_domains")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_age(self) -> typing.Optional[builtins.str]:
        '''Specifies the duration for which to apply HSTS for new browser connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        '''
        result = self._values.get("max_age")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def preload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        '''
        result = self._values.get("preload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, redirects all HTTP requests to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        '''
        result = self._values.get("redirect")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def redirect_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies a response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        '''
        result = self._values.get("redirect_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12ae9d20a3a7313ab09c430366f1ce33b6965bcf9fd7cc3fbd3887438146648d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetIncludeSubDomains")
    def reset_include_sub_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIncludeSubDomains", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxAge")
    def reset_max_age(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxAge", []))

    @jsii.member(jsii_name="resetPreload")
    def reset_preload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreload", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectStatusCode")
    def reset_redirect_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="includeSubDomainsInput")
    def include_sub_domains_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "includeSubDomainsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxAgeInput")
    def max_age_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxAgeInput"))

    @builtins.property
    @jsii.member(jsii_name="preloadInput")
    def preload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "preloadInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCodeInput")
    def redirect_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "redirectStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89068ebf1e8965f591fd0dbccfc603cedaac7887d305660ae94839d61100de3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="includeSubDomains")
    def include_sub_domains(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "includeSubDomains"))

    @include_sub_domains.setter
    def include_sub_domains(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e5569330345e3b724085275f26837e978bbb2dd53b8c0081b8538046019e76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "includeSubDomains", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bbb932039dc69bf7cf66d4403d40a30a8e3086eec1eee78472aa07a2e4f80487)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxAge")
    def max_age(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxAge"))

    @max_age.setter
    def max_age(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53d2f020ba3c87d46e08292c59c1b2eb79ef4b3ac02b6ed4ea1b8a66ce11fa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxAge", value)

    @builtins.property
    @jsii.member(jsii_name="preload")
    def preload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "preload"))

    @preload.setter
    def preload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__217485d8c32549eeb6f9de874612c80e7434dc3fcfe6580a2b00b2d39ec1196f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preload", value)

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "redirect"))

    @redirect.setter
    def redirect(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbb58eb3e1f567524356e66dcde59189c1cccd3cc2809f254f07199715bd3723)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirect", value)

    @builtins.property
    @jsii.member(jsii_name="redirectStatusCode")
    def redirect_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "redirectStatusCode"))

    @redirect_status_code.setter
    def redirect_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90cb9d63c95ac9a6fecfe9c3252221cc605da387fbc2d742744f9945839aac98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "redirectStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ee3947b94d2a24bdd39684b6e0ff9a532cf9e2fa5c78335930ede9528b43508)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0aeb400434044724fa9b8f3e1cf0c6ab77bbf29a4969a8ce7b0c9540255d4e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f47a05d7807737f4fa83149586aa1b3fe91c6b529b48ef55080f30fdae9c5b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "upgrade": "upgrade",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f44484001e4f75b4dd0b77505cdccc6b44ccc800d0b860f1c84acba5201d511)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upgrade", value=upgrade, expected_type=type_hints["upgrade"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upgrade is not None:
            self._values["upgrade"] = upgrade
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upgrade(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        '''
        result = self._values.get("upgrade")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21057fe510b80aeaf4eeb114005401721a47fe8192663c855c2a3ef10fcf531d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpgrade")
    def reset_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpgrade", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upgradeInput")
    def upgrade_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18e73bc2d871b7aa04e8bd554dfe46e182968e9dfca75a9da48180511c256f2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84487b1382bd90c0080444dbd308ec91840aedf47145c370d999de2a5f94dea3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upgrade")
    def upgrade(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upgrade"))

    @upgrade.setter
    def upgrade(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18da36e7bf28d1d126aea577273470a9115f5deb0bf0be270ee44fae9d7890f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upgrade", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cca4619ce34b81edafd47792657b84eac4c2dc0e55de5ff643b5d087767b06e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b73b12bbe4e7a65e730fa1ac26266bfa189f0d8af1c12e73a4d574f1110b7b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride",
    jsii_struct_bases=[],
    name_mapping={
        "dpr": "dpr",
        "dprvar": "dprvar",
        "exclude_all_query_parameters": "excludeAllQueryParameters",
        "excluded_query_parameters": "excludedQueryParameters",
        "format": "format",
        "formatvar": "formatvar",
        "locked": "locked",
        "override": "override",
        "policy": "policy",
        "policyvar": "policyvar",
        "policyvar_i_mvar": "policyvarIMvar",
        "policyvar_name": "policyvarName",
        "template_uuid": "templateUuid",
        "typesel": "typesel",
        "uuid": "uuid",
        "width": "width",
        "widthvar": "widthvar",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride:
    def __init__(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b5d928316353571b89d0e521c4ef74a874aecec98851442cad2959feaaec7fb)
            check_type(argname="argument dpr", value=dpr, expected_type=type_hints["dpr"])
            check_type(argname="argument dprvar", value=dprvar, expected_type=type_hints["dprvar"])
            check_type(argname="argument exclude_all_query_parameters", value=exclude_all_query_parameters, expected_type=type_hints["exclude_all_query_parameters"])
            check_type(argname="argument excluded_query_parameters", value=excluded_query_parameters, expected_type=type_hints["excluded_query_parameters"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument formatvar", value=formatvar, expected_type=type_hints["formatvar"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override", value=override, expected_type=type_hints["override"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument policyvar", value=policyvar, expected_type=type_hints["policyvar"])
            check_type(argname="argument policyvar_i_mvar", value=policyvar_i_mvar, expected_type=type_hints["policyvar_i_mvar"])
            check_type(argname="argument policyvar_name", value=policyvar_name, expected_type=type_hints["policyvar_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument typesel", value=typesel, expected_type=type_hints["typesel"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument width", value=width, expected_type=type_hints["width"])
            check_type(argname="argument widthvar", value=widthvar, expected_type=type_hints["widthvar"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if dpr is not None:
            self._values["dpr"] = dpr
        if dprvar is not None:
            self._values["dprvar"] = dprvar
        if exclude_all_query_parameters is not None:
            self._values["exclude_all_query_parameters"] = exclude_all_query_parameters
        if excluded_query_parameters is not None:
            self._values["excluded_query_parameters"] = excluded_query_parameters
        if format is not None:
            self._values["format"] = format
        if formatvar is not None:
            self._values["formatvar"] = formatvar
        if locked is not None:
            self._values["locked"] = locked
        if override is not None:
            self._values["override"] = override
        if policy is not None:
            self._values["policy"] = policy
        if policyvar is not None:
            self._values["policyvar"] = policyvar
        if policyvar_i_mvar is not None:
            self._values["policyvar_i_mvar"] = policyvar_i_mvar
        if policyvar_name is not None:
            self._values["policyvar_name"] = policyvar_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if typesel is not None:
            self._values["typesel"] = typesel
        if uuid is not None:
            self._values["uuid"] = uuid
        if width is not None:
            self._values["width"] = width
        if widthvar is not None:
            self._values["widthvar"] = widthvar

    @builtins.property
    def dpr(self) -> typing.Optional[jsii.Number]:
        '''Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        '''
        result = self._values.get("dpr")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def dprvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired pixel density.

        The variable specifies the same type of data as the ``dpr`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        '''
        result = self._values.get("dprvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def exclude_all_query_parameters(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to exclude all query parameters from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        '''
        result = self._values.get("exclude_all_query_parameters")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def excluded_query_parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies individual query parameters to exclude from the Image and Video Manager cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        '''
        result = self._values.get("excluded_query_parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def formatvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the name of the browser you want to optimize images for.

        The variable specifies the same type of data as the ``format`` option below.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        '''
        result = self._values.get("formatvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override(self) -> typing.Optional[builtins.str]:
        '''Selects the type of query parameter you want to set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        '''
        result = self._values.get("override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''This selects the desired Image and Video Manager policy name directly.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        '''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar(self) -> typing.Optional[builtins.str]:
        '''This selects the variable with the desired Image and Video Manager policy name to apply to image requests.

        If there is no policy by that name, Image and Video Manager serves the image unmodified.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        '''
        result = self._values.get("policyvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_i_mvar(self) -> typing.Optional[builtins.str]:
        '''This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        '''
        result = self._values.get("policyvar_i_mvar")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policyvar_name(self) -> typing.Optional[builtins.str]:
        '''This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        '''
        result = self._values.get("policyvar_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def typesel(self) -> typing.Optional[builtins.str]:
        '''Specifies how to set a query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        '''
        result = self._values.get("typesel")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def width(self) -> typing.Optional[jsii.Number]:
        '''Sets the image's desired pixel width directly.

        If the Image Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        '''
        result = self._values.get("width")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def widthvar(self) -> typing.Optional[builtins.str]:
        '''Selects the variable with the desired width.

        If the Image and Video Manager policy doesn't define that width, it serves the next largest width.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        result = self._values.get("widthvar")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2037ea1beeacf51640c4e47dade764a2b0b5e42a541790021d420c8ed6f0e17e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDpr")
    def reset_dpr(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDpr", []))

    @jsii.member(jsii_name="resetDprvar")
    def reset_dprvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDprvar", []))

    @jsii.member(jsii_name="resetExcludeAllQueryParameters")
    def reset_exclude_all_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludeAllQueryParameters", []))

    @jsii.member(jsii_name="resetExcludedQueryParameters")
    def reset_excluded_query_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExcludedQueryParameters", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetFormatvar")
    def reset_formatvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatvar", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride")
    def reset_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetPolicyvar")
    def reset_policyvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvar", []))

    @jsii.member(jsii_name="resetPolicyvarIMvar")
    def reset_policyvar_i_mvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarIMvar", []))

    @jsii.member(jsii_name="resetPolicyvarName")
    def reset_policyvar_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyvarName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTypesel")
    def reset_typesel(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTypesel", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWidth")
    def reset_width(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidth", []))

    @jsii.member(jsii_name="resetWidthvar")
    def reset_widthvar(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWidthvar", []))

    @builtins.property
    @jsii.member(jsii_name="dprInput")
    def dpr_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "dprInput"))

    @builtins.property
    @jsii.member(jsii_name="dprvarInput")
    def dprvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dprvarInput"))

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParametersInput")
    def exclude_all_query_parameters_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "excludeAllQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParametersInput")
    def excluded_query_parameters_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "excludedQueryParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="formatvarInput")
    def formatvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatvarInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideInput")
    def override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvarInput")
    def policyvar_i_mvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarIMvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarInput")
    def policyvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarInput"))

    @builtins.property
    @jsii.member(jsii_name="policyvarNameInput")
    def policyvar_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyvarNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeselInput")
    def typesel_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeselInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="widthInput")
    def width_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "widthInput"))

    @builtins.property
    @jsii.member(jsii_name="widthvarInput")
    def widthvar_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "widthvarInput"))

    @builtins.property
    @jsii.member(jsii_name="dpr")
    def dpr(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "dpr"))

    @dpr.setter
    def dpr(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb5a9285699384e8d14f245de94065dbbcac072e6283f3ae1db8338f077ba6fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dpr", value)

    @builtins.property
    @jsii.member(jsii_name="dprvar")
    def dprvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dprvar"))

    @dprvar.setter
    def dprvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a76b1ec827f8747e20c238c08cdf15cc8f9130afe0b882b8d0ac85a357dbb7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dprvar", value)

    @builtins.property
    @jsii.member(jsii_name="excludeAllQueryParameters")
    def exclude_all_query_parameters(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "excludeAllQueryParameters"))

    @exclude_all_query_parameters.setter
    def exclude_all_query_parameters(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__287aeb6d3c6b0b0cdebf98d41c70172ec8a0b9a0aceea1c535297b020dcc8491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludeAllQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="excludedQueryParameters")
    def excluded_query_parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "excludedQueryParameters"))

    @excluded_query_parameters.setter
    def excluded_query_parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8251ebf9c55dddd46499b9a8c5d8d67b3490a596f5b572b4c031c068ecc695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "excludedQueryParameters", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42f07e642d0670afa9b757e6aa33406ec5cf7b1f4e6d829450e49c1c1cb63e09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="formatvar")
    def formatvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatvar"))

    @formatvar.setter
    def formatvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f87f1aff0580d216217ef5e13265f9c318e8fb2b705f012036724ff8082186b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatvar", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e11fc92a30b98fb226a21865ebb408aa634780442de12a0be830f7c7a5f807c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override")
    def override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "override"))

    @override.setter
    def override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__959464e785c974bb7a3368d6cc3d17651cf5643372e15de385a59987ecbfd0f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3832892873eec9352f14175bb6bc8d0f442491c50affc4cd51313f02e88cbb2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="policyvar")
    def policyvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvar"))

    @policyvar.setter
    def policyvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8041b70ecac879863b8da6d1b823f9cb2d97fc28272248c0b5086836ce00a071)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarIMvar")
    def policyvar_i_mvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarIMvar"))

    @policyvar_i_mvar.setter
    def policyvar_i_mvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdc4616f9069c5723889f01695f3eeeff69956c3ed96c8c6450f1280086a75fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarIMvar", value)

    @builtins.property
    @jsii.member(jsii_name="policyvarName")
    def policyvar_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyvarName"))

    @policyvar_name.setter
    def policyvar_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a473ceab6decb12ba3bdbab74ce796a636dcef6c482055179df222e6630319ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyvarName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d323195ba7faf25b795ce6ff130fe31883085130a540cc9ecf5efb3ebdca014)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="typesel")
    def typesel(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "typesel"))

    @typesel.setter
    def typesel(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9744aeaaee3bc19ab14ab1a596433ce722f2acc966f0bbd63cddb352c1d3c85d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "typesel", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e783ec7cbc822aa9bcd09a0ce909b958c41e66079770bcdad92d5ef20f702db6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="width")
    def width(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "width"))

    @width.setter
    def width(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3282c6230041c54dacd4691366bbfe1b918222b686a9c72a81404b45022234)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "width", value)

    @builtins.property
    @jsii.member(jsii_name="widthvar")
    def widthvar(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "widthvar"))

    @widthvar.setter
    def widthvar(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a312eb97c06c13571ec8c502c0b3d61d8b57a97e50dc78d854bd6a003ba96e64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "widthvar", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0033c05890fbc4fcdeb6bfcb415cdb6fcbb6dd825e3d4787e471812d8bdbe14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager",
    jsii_struct_bases=[],
    name_mapping={
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "image_set": "imageSet",
        "locked": "locked",
        "policy_set_type": "policySetType",
        "resize": "resize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "video_set": "videoSet",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager:
    def __init__(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d952560ff0f025bb14f27965cc5c17b7cca027e3a5de50118bc34dd88a531ded)
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument image_set", value=image_set, expected_type=type_hints["image_set"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set_type", value=policy_set_type, expected_type=type_hints["policy_set_type"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument video_set", value=video_set, expected_type=type_hints["video_set"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if image_set is not None:
            self._values["image_set"] = image_set
        if locked is not None:
            self._values["locked"] = locked
        if policy_set_type is not None:
            self._values["policy_set_type"] = policy_set_type
        if resize is not None:
            self._values["resize"] = resize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if video_set is not None:
            self._values["video_set"] = video_set

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.'''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.'''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def image_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.'''
        result = self._values.get("image_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.'''
        result = self._values.get("policy_set_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.'''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def video_set(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.'''
        result = self._values.get("video_set")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb5838c818f975dc382e5b7da6bf43d06023a7e6e77f5da10bf83412632248e2)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5e6b72f109c1a9cbdcfdb5974ddb0964dc65d49cd1c0fca583d2873f22677f7)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__467266a91735f0a043f875f435d1166a5eef124e922a6acd3b02c44494312db3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517d092dcaf2a7b2b6b2f87d97437e7cd3d98e197bbacaa84e9628c2cb1eb0e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26b2f1acb0b250c1ed1432a8d496e93618c7ac87948e2b4c71670617a5d776b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42c889e88a50358a6c173c736138f47027a4fdf20b9adadd9f52ddb2535f05ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70de8022833b87d837b26bd996dd54d50d025e3a5e808778778c267366eb5adb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e986ffc4e4327f4c96e718a6de26be39112e65126ab56ba6d46d08de1cb80e5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b2b37f80986f3ef060eacd2656d6c7c9fefd82d3a70dcd63d6220e718e40421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b85f322bc07e20d21109d1ddfc90e8d2fb47aaca55d093ae890c75b6f04e7a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05059596730b8340560846d0b780cae6490fa3fdd24123eb720196e7f2b028f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__805b2ccc83f513957739e2c10a24d581f6091e0589ea9227e18563ddb03faecd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f790e112bbb3e9e06b8ce8bc17ecbbe2007c8e0b639866e06d78557bae83eab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__091539fdcc030909c62633f664185953aaea55ca8f7880c2f3048f2b98871c51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__740182cabda610fbe85cc8c31c9786f513264730c2d1e1b4832bddc1ffffd948)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ae6b78cd8ec98d469342fc8a2f78818a568a79512aeb0ec506a14012a2344b1)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0411e34aa3634927ef1d3bd0716aac885b53c6c45307252a239340a79f2b4cd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0906c4b1e0bea444d01e5971a0f847245b93310a4f240dec6bceca82a15634d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__983758906085f2fbff74c1a02353c9948c3fa94890a5aa1bbdef15de23ae74b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4b5176f396413b4236782a9d314debc4d024545485ac2b2aaaee999eb502625)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29425139dfb661d3a9e47ecb66c7c7a7eea72fc939f4cb499eff85540e027941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ba04035de549ec0fae8a8aadb99a7b045ec9bb9720217cb9737e9a1e9624a2d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2615e637c09a8e8543b4da7a3c85ce464260c03d2c72435e451c77f7484bfc2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f4aacefb8004837494d5f96720c4e9fc28f033c950ed32444e537a9e1fb075)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e30a7fee8c85fd32ea19f2f3d4dde9cf7e07d3934aeae69d7e37be8ff2fb94e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6d10ad46abfc400325faa4444bccfe81a32bf8cd06e8028ec3f2fb0f14d0476)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d2d6c2edede0c9b3bc05a42cdd53337023805356b1cf0d4296e3eb56556578f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f02db95858bfb21814d0757eb9e4533bf01e30c7f3d667c842311ae29df9715)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ad50ce75f5d50b79964d696d470d1d39988316b4353f92b868cb56d22a1d0d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetImageSet")
    def reset_image_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageSet", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySetType")
    def reset_policy_set_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySetType", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVideoSet")
    def reset_video_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVideoSet", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="imageSetInput")
    def image_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "imageSetInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetTypeInput")
    def policy_set_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="videoSetInput")
    def video_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "videoSetInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__431b4757dd3b34a34c126db5fc9656c61f789c8cb7e25eda4377066f830beb13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c353d133657078d4bf2f75f77a6b9df2692ef508b3b9e52287329dedadd1315)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="imageSet")
    def image_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "imageSet"))

    @image_set.setter
    def image_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e6c73b3dbb25cab4ce8d6777928f8738735598db330992c7518468b1054411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "imageSet", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd9fd970aa51c2f91315e29ec29addae04f106a8ba915b6219b4e7129401d607)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySetType")
    def policy_set_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySetType"))

    @policy_set_type.setter
    def policy_set_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d1b552eed3f5869acf29db507d33d93c38b3bb7041aceec8b1b0cb8c0bcaa79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySetType", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94c033e5843497c276f6ed209b17fdb8cdba0f3e61f30eb44581b0d4332e03d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82bb0162769585439c2bfdc125eba922200cc7cee5160447a4b4d3b8d1b15ccb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b7c3f817fa089fb76e6e8c7492f034bb1e1a27a580e757d70d86c1cc974e7dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="videoSet")
    def video_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "videoSet"))

    @video_set.setter
    def video_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d8f5b5ad712aec42a66380f35a0d282fa3f9bb4b4c9978d2ea91d8c97ec2143)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "videoSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dabe4e3ce06135539dd9d77d084b485e88ab70910afa940fc33b58d5c78aa54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b37fca31ee38d5ae14191f5e55c57b5ad10dcbf1897e7b127e8fcc0df469119c)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images.

        The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file.

        This produces the smallest file size possible that retains image quality.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable image management capabilities and generate a corresponding API token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters.

        If you don't specify a label, ``default`` becomes the prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        The ``advanced`` option needs to be inactive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent.

        Note that enabling this may affect screen layout in unexpected ways.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e38b463169b061c4e42ca8ef745c0aca8a46229929025f8fdc8bff002f8f7601)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__881f2b7e103acc3ef19f776864ea94ad5df97d421d6f1b0d751a84cfe7c0f11d)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c571a65d93d2e85c924dc1c291777207a619c4aaf8c15c49222641c06259a582)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e60574b92210a845428a0b3d4fed8d5a9b8618cc0ff549faf9f6db5fe230d1ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a27b09d1262c7fb4ca28ecf13c874b03a04cfab605ff5219be7bcaaf4aed2c15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490954a3f117c438a595bfedb27482d95c13bdf99ef8e7d71d892c6e7b6cd33b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d797a9ede9fe35156eb7bb782f03961b964735ffc41edb5764049b42004d9fb2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cfea5a65eba6180211bffe4f6ccc0060e1c163ea8cebd4ea88a647fe90bf2aa)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eaa987c683e7f26ab51d70a99de08ea8e2b6051e5224787d20a144347455eeca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fe5d416488aaed0e4044420371a054a14c726c8adaa68b782137064ad5ca2e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5d89a4a30c25d56c536ebd07df2366c47516ca4c5f1cb2881f84ad43e7734bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b9a64ba86e3a2c49e02d189e0daf5e9fe361c1b495021c0d710adb756e8c69d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ddbc9ed01f612ca22adc0331bd84a928a3dbbefe1ed8ad2007e5f8863ef5377)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc74c3f6d4debf82af3f99e2a63f1d3ea5392a5fd6900414fb241031d728ff2b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d5ae64b115f69a52217f2c3578a15231e3eb79cfc99bc405cbf0aadd8b7182)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2ef414f261b67e4dbc1d574164c1466c817f79701d94f33ec5a47cf18c8ab5d)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d2823b2ee9b5c635b3a43a4bfb99117fecff333eee327d78cf4e0f8efc66da)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff4bf1a955e1da8474623e1b647b35ac56d36085c8b66eb87f183f5a0635e8ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d7a0345f3a6c5d472f8feda3ca4482599ed3dd355406611b55fa656c21973cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0939c4a12ce4fec8ffa78727a7dfbca44c18783854ceec0310e846ddbe08cdbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b7774f5e398ef7554d6ecfc4999f42107d1f58a0c2c91190c63e71e35600c04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ceca2c83534646243e49ac8d310fcb4633676053d7c15ce75321dc28aaefdf3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de721a401008ae63f08cac423b32e1d379446a4d34ba86c23a39f57a6ac1775)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cfb0605fcdcd3bb62c66eca56012c758c5b0d19900ec1ea5541ca471fe5645d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35973419376350dd277d6d2e406de10080aece71495423b9e1e7dbda5d0d828c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f52aa0ee97b9d2e091cef4b8098d9b7140a34a65e286dd63d505c020faaa4ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d26d99f50cc4e6dd64f1267f736f6ec2a5bdce13bd90d60b7d9fe323e9ec1721)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03347b699d0b3d0cfdd040a5e26d33f9aa5eb7863316c338161cfe17b40ec574)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4699de71d1e825e8548f01f0d13b101e070139627ec033adb7f223a58973110)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f79764fee0ffbcb145896cd54e36f26b100acd095f82eb7f5e33898487ed77e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d77f19487f30c0af0ad0ea8da2526d377aeca4daa8c293acb180244cb883546a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__804893d26d4fb911769d25cb076c925ec392e7039c8018be64866a34bddecf07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fbfe6fec503cc88f2591e470669f4e051b610d46ffe9d38f6780cd4b89fe9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfac3063e297f876a731f2a53f52e050970369cf78ddad79a67fd254c6b461dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f462b9da74d68cd05efbf81da3851d792e076d11ee182e41da2214a35be4e63)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89b1d191cbbfb5eac5d2e0aeb9d5a54954317dc16954b64810b275a05c0a7767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a474aa9a4813937f3790b7482fa2ef3b29126bb59f511bbe8617852ba54da5cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1a9b5b6e222a9b951a222348ac74820cde361ae4b4be93f57737febb6378912)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8b53f5c95c286276294c700c9a095c5e7189408f66e0031ada0319a6de42c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09aa66f250dd5076fcb4483b88ecf5cb56e8c6ab56b5463f3246ea867c08153c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8cd4840a804fa852314f1c387bfe6ca296a7a32ad4372539b06fc640b7b3a4c2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0decf7ee1a257906bf5aff60bc1d00602041003eea7628efb4b7458cd01cb002)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65d85cc9c38771ddf6fcf1481032ef5eb327df7d09b05cf734b54611e868dfa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d52dc0eb17a2d275fdcf30a0cb1090dd4ba0e71775ab935122f102a7d16c8f2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16fffdc0d5d29a1855917a0f808fecf1ff27de53d1e2d3df6c4b931bfd41b6ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "api_reference_title": "apiReferenceTitle",
        "apply_best_file_type": "applyBestFileType",
        "cp_code_original": "cpCodeOriginal",
        "cp_code_transformed": "cpCodeTransformed",
        "enabled": "enabled",
        "locked": "locked",
        "policy_set": "policySet",
        "policy_token": "policyToken",
        "policy_token_default": "policyTokenDefault",
        "resize": "resize",
        "settings_title": "settingsTitle",
        "super_cache_region": "superCacheRegion",
        "template_uuid": "templateUuid",
        "traffic_title": "trafficTitle",
        "use_existing_policy_set": "useExistingPolicySet",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal", typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cp_code_original, dict):
            cp_code_original = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal(**cp_code_original)
        if isinstance(cp_code_transformed, dict):
            cp_code_transformed = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed(**cp_code_transformed)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15dc0f6d42e16002ee7f776da49cceb2869f040c26bee3cb21b493fd92ee7761)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument api_reference_title", value=api_reference_title, expected_type=type_hints["api_reference_title"])
            check_type(argname="argument apply_best_file_type", value=apply_best_file_type, expected_type=type_hints["apply_best_file_type"])
            check_type(argname="argument cp_code_original", value=cp_code_original, expected_type=type_hints["cp_code_original"])
            check_type(argname="argument cp_code_transformed", value=cp_code_transformed, expected_type=type_hints["cp_code_transformed"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument policy_set", value=policy_set, expected_type=type_hints["policy_set"])
            check_type(argname="argument policy_token", value=policy_token, expected_type=type_hints["policy_token"])
            check_type(argname="argument policy_token_default", value=policy_token_default, expected_type=type_hints["policy_token_default"])
            check_type(argname="argument resize", value=resize, expected_type=type_hints["resize"])
            check_type(argname="argument settings_title", value=settings_title, expected_type=type_hints["settings_title"])
            check_type(argname="argument super_cache_region", value=super_cache_region, expected_type=type_hints["super_cache_region"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument traffic_title", value=traffic_title, expected_type=type_hints["traffic_title"])
            check_type(argname="argument use_existing_policy_set", value=use_existing_policy_set, expected_type=type_hints["use_existing_policy_set"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if api_reference_title is not None:
            self._values["api_reference_title"] = api_reference_title
        if apply_best_file_type is not None:
            self._values["apply_best_file_type"] = apply_best_file_type
        if cp_code_original is not None:
            self._values["cp_code_original"] = cp_code_original
        if cp_code_transformed is not None:
            self._values["cp_code_transformed"] = cp_code_transformed
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if policy_set is not None:
            self._values["policy_set"] = policy_set
        if policy_token is not None:
            self._values["policy_token"] = policy_token
        if policy_token_default is not None:
            self._values["policy_token_default"] = policy_token_default
        if resize is not None:
            self._values["resize"] = resize
        if settings_title is not None:
            self._values["settings_title"] = settings_title
        if super_cache_region is not None:
            self._values["super_cache_region"] = super_cache_region
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if traffic_title is not None:
            self._values["traffic_title"] = traffic_title
        if use_existing_policy_set is not None:
            self._values["use_existing_policy_set"] = use_existing_policy_set
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, applies a single standard policy based on your property name.

        Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def api_reference_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        '''
        result = self._values.get("api_reference_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def apply_best_file_type(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, automatically converts videos to the best file type for the requesting device.

        This produces the smallest file size that retains image quality, based on the user agent and the initial image file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        '''
        result = self._values.get("apply_best_file_type")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cp_code_original(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal"]:
        '''cp_code_original block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        '''
        result = self._values.get("cp_code_original")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal"], result)

    @builtins.property
    def cp_code_transformed(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed"]:
        '''cp_code_transformed block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        '''
        result = self._values.get("cp_code_transformed")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies Image and Video Manager's video optimization to the current content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def policy_set(self) -> typing.Optional[builtins.str]:
        '''Identifies the existing policy set configured with ``Image and Video Manager API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        '''
        result = self._values.get("policy_set")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``.

        The policy name can include up to 64 alphanumeric, dash, or underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        '''
        result = self._values.get("policy_token")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy_token_default(self) -> typing.Optional[builtins.str]:
        '''Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        '''
        result = self._values.get("policy_token_default")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def resize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        '''
        result = self._values.get("resize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        '''
        result = self._values.get("settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def super_cache_region(self) -> typing.Optional[builtins.str]:
        '''To optimize caching, assign a region close to your site's heaviest traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        '''
        result = self._values.get("super_cache_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def traffic_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        '''
        result = self._values.get("traffic_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_existing_policy_set(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property.

        A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        '''
        result = self._values.get("use_existing_policy_set")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff7f343ecbf86710504f00e7abce1510fe8fcf3bd7ef4786c8e80ec6551530b2)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1828081d6bbb0d9014aaed23aed8a314fc305cc2ea14ec83c45caabdeb5abf)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78a86bd81d84c4c9a4f9d344a70495836a8e7e2333eb19837607783be2e588b8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0772a1c44ff1ab2f35d58334d7ff2136da14615518f51df1f1097aacd316b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00a97b1f5b98a7212ce4d5d8731ad6bd347396b817f0366e0f24a52f054f1162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4426377b9aad1f7ca5a2eb2cdb99ac5e7816addbe1086c961112d0008b07b162)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41ba2b4517054ffd9a082eac4c019b8b93203b71ca2d234cda1729ce2b5805ef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44045d6834a5bfaf415ec51eb2a9b29f0b47247ef8ff9f9a8bfb3f491a280fc9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__883a46f6ad778208856cd572c765c08d4f5646bc4ae5e023294e91a06c47424f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2085ad4f95fe0733377bb5c53ed7a14021ef704ebdeef2b7b2269e7f3cb9853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d374315c954b72259cb95f2f2f368ab668c5b69f17b2514176edb40d7bceadb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28676555c6b8a407782f528a0f10c1ebb60edd35589df790377d3fc3792d0e16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a43a34175958c1d10b75563ffe34ef1b8b1259409e4f436d896eb8538818ae2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e82baa8afb6e002247ff7bda152cb51df51470c796858e4a5f1b140658081fee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82eed5aae8a8a4449f568123acfa9117f54dece67697f8c93c7009fd62e2ade7)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a62ed7bf2e0565081f0601b585e3307e860404c161c2aa03a61753706e949665)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d57f5d2987f2b377eea41b4276d5e8b72114c844bc73425f456c5d192082e47)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e005b2ef9464a6fbd25b729258788d3803d4f029e3e1a202b36551c5e7037b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14e7f7b0ac78da80ab353aee3651cc64d53f201e5a6cfa87bf6bc44ff96a2105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__248a8bedc6a8b61cd41177e2ac8c3fa6ecf52de35d2aa9491a7eba9719e4965f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d608c2a64978211f7f2e2e444700eb244a5087fc2bbc5ba5081eb7b47b27d54)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc51acc22b2f269dd0925d670e501967c1e9ddfdd443c6e494726b55a493cb7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae1ef1f143feebc49c5fb6d6be27916bba8fe404e384084f9307c14a5331dfba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8ca096d59897ef4bb6ecf718a83df893133414c3beecf819e56d692b56fb7c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ebdd4d4981e08e260f466ee3ff64237b4b09f13967c4ef5923342167cde1c6e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bacbe70083c143ebd0d6d7d6bb913f3fecc6de35b99a9774af7eb82c9841aca1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19eebf67d9b89d0c1899556b90d637ffa6b8a91e9a4b9d9a9fb8d1b1b3fdba4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__119045585a2e7e4f778757c4834984b5476c03301527e13e77bf9b2c39e0e509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e07d54d3ecdd255bb2f54e228990182481557be2450050103de9937dbf1b552)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeOriginal")
    def put_cp_code_original(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeOriginal", [value]))

    @jsii.member(jsii_name="putCpCodeTransformed")
    def put_cp_code_transformed(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeTransformed", [value]))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetApiReferenceTitle")
    def reset_api_reference_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiReferenceTitle", []))

    @jsii.member(jsii_name="resetApplyBestFileType")
    def reset_apply_best_file_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyBestFileType", []))

    @jsii.member(jsii_name="resetCpCodeOriginal")
    def reset_cp_code_original(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeOriginal", []))

    @jsii.member(jsii_name="resetCpCodeTransformed")
    def reset_cp_code_transformed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeTransformed", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPolicySet")
    def reset_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicySet", []))

    @jsii.member(jsii_name="resetPolicyToken")
    def reset_policy_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyToken", []))

    @jsii.member(jsii_name="resetPolicyTokenDefault")
    def reset_policy_token_default(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicyTokenDefault", []))

    @jsii.member(jsii_name="resetResize")
    def reset_resize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResize", []))

    @jsii.member(jsii_name="resetSettingsTitle")
    def reset_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSettingsTitle", []))

    @jsii.member(jsii_name="resetSuperCacheRegion")
    def reset_super_cache_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSuperCacheRegion", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTrafficTitle")
    def reset_traffic_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrafficTitle", []))

    @jsii.member(jsii_name="resetUseExistingPolicySet")
    def reset_use_existing_policy_set(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseExistingPolicySet", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginal")
    def cp_code_original(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference, jsii.get(self, "cpCodeOriginal"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformed")
    def cp_code_transformed(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference, jsii.get(self, "cpCodeTransformed"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitleInput")
    def api_reference_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiReferenceTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="applyBestFileTypeInput")
    def apply_best_file_type_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyBestFileTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeOriginalInput")
    def cp_code_original_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal], jsii.get(self, "cpCodeOriginalInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeTransformedInput")
    def cp_code_transformed_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed], jsii.get(self, "cpCodeTransformedInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="policySetInput")
    def policy_set_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policySetInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefaultInput")
    def policy_token_default_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenDefaultInput"))

    @builtins.property
    @jsii.member(jsii_name="policyTokenInput")
    def policy_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="resizeInput")
    def resize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resizeInput"))

    @builtins.property
    @jsii.member(jsii_name="settingsTitleInput")
    def settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "settingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="superCacheRegionInput")
    def super_cache_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "superCacheRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="trafficTitleInput")
    def traffic_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trafficTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySetInput")
    def use_existing_policy_set_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useExistingPolicySetInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c2c1af432c5e075901888a8c633ff0eef3df438f817e3af1e05f409b3d0e9ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="apiReferenceTitle")
    def api_reference_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiReferenceTitle"))

    @api_reference_title.setter
    def api_reference_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7164cba2877e8376864f0f26524197a45a8f5d11abfa2b9340508433d41475b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiReferenceTitle", value)

    @builtins.property
    @jsii.member(jsii_name="applyBestFileType")
    def apply_best_file_type(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyBestFileType"))

    @apply_best_file_type.setter
    def apply_best_file_type(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a2bd2eb7d6d2dce9c7e97cf05e25192804921fecc5db338f7280b362fea2b1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyBestFileType", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589feed43c8c9e8586604fe820de36e7d259c21a22eb215c01eebbd6893facb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b73a449017f0b42e25b22c77aea73642a67de1adcbe09af83f44b04a7f82160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="policySet")
    def policy_set(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policySet"))

    @policy_set.setter
    def policy_set(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9e6732b21a4f16a46adae61a0a53be6fd9dbe7d72e64c76607159b377e76436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policySet", value)

    @builtins.property
    @jsii.member(jsii_name="policyToken")
    def policy_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyToken"))

    @policy_token.setter
    def policy_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a657c17a8add561f7c428e5973a792394a1eca9f0e883da1155104d727f6947)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyToken", value)

    @builtins.property
    @jsii.member(jsii_name="policyTokenDefault")
    def policy_token_default(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policyTokenDefault"))

    @policy_token_default.setter
    def policy_token_default(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d6165962106b2b237d3fecdfd966396caad7373d4bf5372108155dd425a355d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policyTokenDefault", value)

    @builtins.property
    @jsii.member(jsii_name="resize")
    def resize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "resize"))

    @resize.setter
    def resize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e73e3dd8a556ae4522f2ca677cd3726424d4acd84a96e70391c63c8d1f4f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "resize", value)

    @builtins.property
    @jsii.member(jsii_name="settingsTitle")
    def settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "settingsTitle"))

    @settings_title.setter
    def settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad8b1f1c42d7583a8c2661d1dba427e2159b3b1f8ccd20dff2327b1b86ca48d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "settingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="superCacheRegion")
    def super_cache_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "superCacheRegion"))

    @super_cache_region.setter
    def super_cache_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a58a01f66e4b2d4635b94958e828e7680b8675bec1fc42be7f748e950d641def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "superCacheRegion", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04829dcf3147b15aa633314908721bae0ecc9f49651bd7e7c08ca3dd2599d6cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="trafficTitle")
    def traffic_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trafficTitle"))

    @traffic_title.setter
    def traffic_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee01df4921118c478c7d28bb634645ff3f6c78061c25d3cec530464c5143a35a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trafficTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useExistingPolicySet")
    def use_existing_policy_set(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useExistingPolicySet"))

    @use_existing_policy_set.setter
    def use_existing_policy_set(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd43595af0b4502fd5c430ad6d4cdc23bc22be763ef89c8ecefd0767828f9bf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useExistingPolicySet", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59b3251ef47894604e81693753455db574f5c00fd2f82558cbfd91e6e32665f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fd2491133dcd32e4c5e012279be8916ff537d649a75853bd69fcfb98cafceb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude",
    jsii_struct_bases=[],
    name_mapping={
        "id": "id",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude:
    def __init__(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f524e6a81e2c0a10bccf4e698725ca1443252062eaee0a14579be0526692cf66)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def id(self) -> typing.Optional[builtins.str]:
        '''Identifies the include you want to add to your rule tree.

        You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f4e7a8bb5f633ee7a19ee70ad58bf31eff5723a39b40b5ba098a742a8ea30cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "id"))

    @id.setter
    def id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ee5f2920735760dcb67f0b125708f9ddf19ecffbae6b5fb70649e46a803919f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3df35d69fe5463b02afc7dc7bd55c4c27728d0c508bd08b9b24ecdc7ccf8654d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ac88daf48bc0195e5dd5add0ef02e431dd5f5f00d7fae51dce9212964e3052e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fa2eb0a3e359ab61a6ca0fb8d4f0489e8f69fe252900d4efc720a19117d2a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2464b17d482c230c69466092495236b9f898d7f1fd7e7c24fa48217a3599a07c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant",
    jsii_struct_bases=[],
    name_mapping={
        "custom_link_relations": "customLinkRelations",
        "locked": "locked",
        "prefetch_cacheable": "prefetchCacheable",
        "prefetch_html": "prefetchHtml",
        "prefetch_no_store": "prefetchNoStore",
        "prefetch_no_store_extensions": "prefetchNoStoreExtensions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant:
    def __init__(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f38813b653691ad247fdd92692032c0fcb6ca361ac2863b20c9a14fc6cbe0dd8)
            check_type(argname="argument custom_link_relations", value=custom_link_relations, expected_type=type_hints["custom_link_relations"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefetch_cacheable", value=prefetch_cacheable, expected_type=type_hints["prefetch_cacheable"])
            check_type(argname="argument prefetch_html", value=prefetch_html, expected_type=type_hints["prefetch_html"])
            check_type(argname="argument prefetch_no_store", value=prefetch_no_store, expected_type=type_hints["prefetch_no_store"])
            check_type(argname="argument prefetch_no_store_extensions", value=prefetch_no_store_extensions, expected_type=type_hints["prefetch_no_store_extensions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_link_relations is not None:
            self._values["custom_link_relations"] = custom_link_relations
        if locked is not None:
            self._values["locked"] = locked
        if prefetch_cacheable is not None:
            self._values["prefetch_cacheable"] = prefetch_cacheable
        if prefetch_html is not None:
            self._values["prefetch_html"] = prefetch_html
        if prefetch_no_store is not None:
            self._values["prefetch_no_store"] = prefetch_no_store
        if prefetch_no_store_extensions is not None:
            self._values["prefetch_no_store_extensions"] = prefetch_no_store_extensions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_link_relations(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specify link relation values that activate the prefetching behavior.

        For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        '''
        result = self._values.get("custom_link_relations")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_cacheable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior.

        Only applies to content with the ``tieredDistribution`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        '''
        result = self._values.get("prefetch_cacheable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_html(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered.

        This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        '''
        result = self._values.get("prefetch_html")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option.

        Only applies to content with the ``sureRoute`` behavior enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        '''
        result = self._values.get("prefetch_no_store")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefetch_no_store_extensions(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        '''
        result = self._values.get("prefetch_no_store_extensions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f695f38bd4c3e2cec7c79fb5791586f8aab7b47305df3864d9f911c359481aa)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the InstantConfig behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__082a2fc481f1aa44b2bad6d52f6c1c81016898c3834d6ee38191c60daaae7b9f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab1448fd88d77444fa267345fa33a227a2edf8de2d3d87340d058ad26d0bad1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e128fee74f187da216cbab986b572e94268c9d97c61a92d42b042b6addff0b66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cca9597c9c0d61e74969072e5598060b7c8a3f4ac4f106a169a981bc2b53764)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7f2435f81992cdeb6d1462ccc10625f206ddd30b7322e8b4c2df03421be63f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a63dac4c8265e3ecff0529796817063473bb152215a9c458b5b11b5387f26e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5354988ca70c632b1cffc0c61efa468bd72476e8679648a647f64c07d0207616)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLinkRelations")
    def reset_custom_link_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLinkRelations", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefetchCacheable")
    def reset_prefetch_cacheable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchCacheable", []))

    @jsii.member(jsii_name="resetPrefetchHtml")
    def reset_prefetch_html(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchHtml", []))

    @jsii.member(jsii_name="resetPrefetchNoStore")
    def reset_prefetch_no_store(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStore", []))

    @jsii.member(jsii_name="resetPrefetchNoStoreExtensions")
    def reset_prefetch_no_store_extensions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchNoStoreExtensions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelationsInput")
    def custom_link_relations_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customLinkRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheableInput")
    def prefetch_cacheable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchCacheableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchHtmlInput")
    def prefetch_html_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchHtmlInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensionsInput")
    def prefetch_no_store_extensions_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "prefetchNoStoreExtensionsInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreInput")
    def prefetch_no_store_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prefetchNoStoreInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLinkRelations")
    def custom_link_relations(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customLinkRelations"))

    @custom_link_relations.setter
    def custom_link_relations(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d0e83e15c4dc4106a381c13d20d243276b65529420a0c597826a2fd2326c220)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLinkRelations", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e332764f4fbff9c9043df6d69aaa626c0e4dd173531a1d809d4568b720b52885)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchCacheable")
    def prefetch_cacheable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchCacheable"))

    @prefetch_cacheable.setter
    def prefetch_cacheable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f833e3388c8a623efac68486f1a2fd89a084cfd4cecd3df85ac225cda17c4803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchCacheable", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchHtml")
    def prefetch_html(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchHtml"))

    @prefetch_html.setter
    def prefetch_html(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd542ab36f30c658984cea722ab7ff85668b6110abc55eb67351e616c5537fdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchHtml", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStore")
    def prefetch_no_store(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prefetchNoStore"))

    @prefetch_no_store.setter
    def prefetch_no_store(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51255d7b1df8369770ac6e4f67623b7b4459881441a60fc3690de8b47d0b50a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStore", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchNoStoreExtensions")
    def prefetch_no_store_extensions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "prefetchNoStoreExtensions"))

    @prefetch_no_store_extensions.setter
    def prefetch_no_store_extensions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__211a1305be47eaaab12f52e62cbd6bf98712577763ee694ca8b5732a4ca6a387)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchNoStoreExtensions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbbd97d33e6331aad64eb5b20fad93fa22d80efafaebbf3bf8681b45a9733430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b64173a153cc240f21500f2a5ca35e23b5a089560314134fe82d8b15b97b7f8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e2e76dca9d475112359cce9abc9d9b54c2a07b4f1b458bc50e8c110e603cb8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "enable_partial_object_caching": "enablePartialObjectCaching",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "minimum_size": "minimumSize",
        "template_uuid": "templateUuid",
        "use_versioning": "useVersioning",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0089b659d2c0f010c7c74ed9b5ef74a227a76a104d495cf5041f1e3ca8bc5035)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_partial_object_caching", value=enable_partial_object_caching, expected_type=type_hints["enable_partial_object_caching"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument minimum_size", value=minimum_size, expected_type=type_hints["minimum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_versioning", value=use_versioning, expected_type=type_hints["use_versioning"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_partial_object_caching is not None:
            self._values["enable_partial_object_caching"] = enable_partial_object_caching
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if minimum_size is not None:
            self._values["minimum_size"] = minimum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_versioning is not None:
            self._values["use_versioning"] = use_versioning
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_partial_object_caching(self) -> typing.Optional[builtins.str]:
        '''Specifies whether to cache partial objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        '''
        result = self._values.get("enable_partial_object_caching")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def minimum_size(self) -> typing.Optional[builtins.str]:
        '''Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        '''
        result = self._values.get("minimum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_versioning(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        '''
        result = self._values.get("use_versioning")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "fragment_size": "fragmentSize",
        "locked": "locked",
        "object_size": "objectSize",
        "prefetch_after_request": "prefetchAfterRequest",
        "prefetch_during_request": "prefetchDuringRequest",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9105810c0eacc30652cc78482e13fbe95ac2c07fe16f6e6153ff1aeebd84eb43)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument fragment_size", value=fragment_size, expected_type=type_hints["fragment_size"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument prefetch_after_request", value=prefetch_after_request, expected_type=type_hints["prefetch_after_request"])
            check_type(argname="argument prefetch_during_request", value=prefetch_during_request, expected_type=type_hints["prefetch_during_request"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if fragment_size is not None:
            self._values["fragment_size"] = fragment_size
        if locked is not None:
            self._values["locked"] = locked
        if object_size is not None:
            self._values["object_size"] = object_size
        if prefetch_after_request is not None:
            self._values["prefetch_after_request"] = prefetch_after_request
        if prefetch_during_request is not None:
            self._values["prefetch_during_request"] = prefetch_during_request
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the file optimization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def fragment_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of each fragment used for partial object caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        '''
        result = self._values.get("fragment_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Specifies the size of the file at which point to apply partial object (POC) caching.

        Append a numeric value with a ``MB`` or ``GB`` suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        '''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prefetch_after_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch after the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        '''
        result = self._values.get("prefetch_after_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def prefetch_during_request(self) -> typing.Optional[jsii.Number]:
        '''The number of POC fragments to prefetch during the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        '''
        result = self._values.get("prefetch_during_request")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42ad028eecf0f18319e2318ce9cfb1e630f3f22a4990da71f9a90eaeaffea0c3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFragmentSize")
    def reset_fragment_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFragmentSize", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetPrefetchAfterRequest")
    def reset_prefetch_after_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchAfterRequest", []))

    @jsii.member(jsii_name="resetPrefetchDuringRequest")
    def reset_prefetch_during_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchDuringRequest", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="fragmentSizeInput")
    def fragment_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fragmentSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequestInput")
    def prefetch_after_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchAfterRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequestInput")
    def prefetch_during_request_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefetchDuringRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47bad84fc5a54b8ea0b08cbbd4b96eb90868046bd5185c26a87beb52ca893b9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="fragmentSize")
    def fragment_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fragmentSize"))

    @fragment_size.setter
    def fragment_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ac0612284984b745ce28d7f57b7e4b69b3417440a810a93c35b511a70f6ae15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fragmentSize", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a720c32fcc903395070597c62929d2467b87d508a84754f4ced461c4b037b26)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e46676272e3fa153233829468e667d538a52a3709ac9a19397b39ddcadbde411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchAfterRequest")
    def prefetch_after_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchAfterRequest"))

    @prefetch_after_request.setter
    def prefetch_after_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3abad7d4ca0f22e89395091f7d6a2f2bc195d9ff76d463d1dc52b00c005208a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchAfterRequest", value)

    @builtins.property
    @jsii.member(jsii_name="prefetchDuringRequest")
    def prefetch_during_request(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefetchDuringRequest"))

    @prefetch_during_request.setter
    def prefetch_during_request(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85c08c8dfbf9f59c0bdbb4af481243a444d330f09a8df13531d2c5caabcc97fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefetchDuringRequest", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__412586e51fe331f160f912545eeac1b9278fc6c7201ccff8d67f1436b135bd68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06735e5e6240d35c18ec4d41386a7fd49ac32cafd864386798fe2697c4299439)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84056ebc108e589ca916f2410fc4fe9667944b3add33008deb3bd2f8e498153e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58652e71e5a1cd37cbb777bc12f8f60fbe3d9ea34ce430c2fd62253f78f48d3d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnablePartialObjectCaching")
    def reset_enable_partial_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnablePartialObjectCaching", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMinimumSize")
    def reset_minimum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinimumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseVersioning")
    def reset_use_versioning(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseVersioning", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCachingInput")
    def enable_partial_object_caching_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "enablePartialObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="minimumSizeInput")
    def minimum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minimumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useVersioningInput")
    def use_versioning_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useVersioningInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b750e7f537176b1a9ccdbaefbadbd6243ced3ea16db2ce382c6ee62a15566ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enablePartialObjectCaching")
    def enable_partial_object_caching(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "enablePartialObjectCaching"))

    @enable_partial_object_caching.setter
    def enable_partial_object_caching(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b68278bf77475e0da97c0746ab8e519ffb5ca1214a0aea80a42a07b08679f39a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enablePartialObjectCaching", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a2644a04c0d494caf12ea858b847f6db3fd0a9b4d490b0f672b53efe19d9311)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65a0c7932acc77fc6396e512e8839313d58f0f6400b1ab70fcaf44a711cef643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="minimumSize")
    def minimum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minimumSize"))

    @minimum_size.setter
    def minimum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b786a807c452c28d136379eb6267e67d7e06114a1351d661abeefaccbb9e9062)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minimumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7699510fd8a38110ace01c12eb222f09ebb20c576e8f5e2d68a19508219d67e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useVersioning")
    def use_versioning(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useVersioning"))

    @use_versioning.setter
    def use_versioning(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0357559c666fa3fc5079a1da6dbe421476d51dacbcdc29de0938269b45ee01ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useVersioning", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14ce8ace41f8f0359917527c98e0bcd5320dfe31e3156d97a499527907016df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1da6807206e3bb47c7ca78f94d8ec45d9c2d084fa02d12193dc3fc86e9a2c68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate",
    jsii_struct_bases=[],
    name_mapping={
        "bitrate_table": "bitrateTable",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "threshold_table": "thresholdTable",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate:
    def __init__(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b209667c1f2cbcf2eb6d7c34d02711dbf8d9d17b8919e362981ef58f1fed2d22)
            check_type(argname="argument bitrate_table", value=bitrate_table, expected_type=type_hints["bitrate_table"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument threshold_table", value=threshold_table, expected_type=type_hints["threshold_table"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_table is not None:
            self._values["bitrate_table"] = bitrate_table
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if threshold_table is not None:
            self._values["threshold_table"] = threshold_table
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bitrate_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable"]]]:
        '''bitrate_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        '''
        result = self._values.get("bitrate_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable"]]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates the bit rate limiting behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_table(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable"]]]:
        '''threshold_table block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        '''
        result = self._values.get("threshold_table")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable"]]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable",
    jsii_struct_bases=[],
    name_mapping={"bitrate_unit": "bitrateUnit", "bitrate_value": "bitrateValue"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable:
    def __init__(
        self,
        *,
        bitrate_unit: typing.Optional[builtins.str] = None,
        bitrate_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param bitrate_unit: The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        :param bitrate_value: The numeric indicator of the download rate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be84f132aa9715aaa238a6849f25fe5806c1590ffa3d097644935fbc0bf6d51)
            check_type(argname="argument bitrate_unit", value=bitrate_unit, expected_type=type_hints["bitrate_unit"])
            check_type(argname="argument bitrate_value", value=bitrate_value, expected_type=type_hints["bitrate_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bitrate_unit is not None:
            self._values["bitrate_unit"] = bitrate_unit
        if bitrate_value is not None:
            self._values["bitrate_value"] = bitrate_value

    @builtins.property
    def bitrate_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``KBPS``, ``MBPS``, or ``GBPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_unit DataAkamaiPropertyRulesBuilder#bitrate_unit}
        '''
        result = self._values.get("bitrate_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def bitrate_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the download rate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_value DataAkamaiPropertyRulesBuilder#bitrate_value}
        '''
        result = self._values.get("bitrate_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73437b479abd008c99fbc3a1d411cd1bedf34fbc900f30046ebad71c302909f8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a749827e85e41e13822dc1d990f95622baadfe0db8630eb29e8e6247a0ad450)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd45b5eea553eeed5376d366a62ca2164f827c16b8908db6148851f0a646d5f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2886712e6e06efed4c6166116102b75d56ba60982e865d398cd281d5aee62b92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a422c1b0ee9d4664c6f1e4c85d27855cfebffd8a0ac7ba1ef0b1c90da3e00a98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a030c5275c2eab763859e40c9f233a932ce901a59188792c7405cc599ca492d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e2063809d5980ecb0bd1121a2e75314d249a0fe30197466fbd834a59b918106)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetBitrateUnit")
    def reset_bitrate_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateUnit", []))

    @jsii.member(jsii_name="resetBitrateValue")
    def reset_bitrate_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateValue", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnitInput")
    def bitrate_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bitrateUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateValueInput")
    def bitrate_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bitrateValueInput"))

    @builtins.property
    @jsii.member(jsii_name="bitrateUnit")
    def bitrate_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bitrateUnit"))

    @bitrate_unit.setter
    def bitrate_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16d12fb159da516e32bee85bf45c37aede165b5002c482126afa6476d149733)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateUnit", value)

    @builtins.property
    @jsii.member(jsii_name="bitrateValue")
    def bitrate_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bitrateValue"))

    @bitrate_value.setter
    def bitrate_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17b3eace01c45cd7e8de64c0f83639fa8ebb5db42200c90ffe3566d6f2961862)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bitrateValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7e558d643fe5e44409b024596c3ae1557edf9fdb56b3faa31c1e1388afff9c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6de283c7484deda78066037eacba8639683ebeff0a255e761f16be66d3ea8d78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBitrateTable")
    def put_bitrate_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__30e9113e7f9a9bd16ef5b08fece6e7ca2de6ba0efc0f46e4e72064f2c9b95882)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBitrateTable", [value]))

    @jsii.member(jsii_name="putThresholdTable")
    def put_threshold_table(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b35c99f47d17eb0e7c80bc4553ab9163315436d646e04be0eb33f017e7898e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putThresholdTable", [value]))

    @jsii.member(jsii_name="resetBitrateTable")
    def reset_bitrate_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBitrateTable", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetThresholdTable")
    def reset_threshold_table(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdTable", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bitrateTable")
    def bitrate_table(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableList, jsii.get(self, "bitrateTable"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTable")
    def threshold_table(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableList", jsii.get(self, "thresholdTable"))

    @builtins.property
    @jsii.member(jsii_name="bitrateTableInput")
    def bitrate_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]]], jsii.get(self, "bitrateTableInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdTableInput")
    def threshold_table_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable"]]], jsii.get(self, "thresholdTableInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__635628cabaa746cb9c763c77a471c975807918884a7d62f74b67a1d7ac4ca887)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5284ccc3157530276766f97f2e3fd7bf7068a9946f3069b84806960f8a5c2dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4da1e28df76aa7a7602f394208b184ac51d5641090a3edfd588d35ec4cd4242)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f992f21488a3a8debe88f9f4b0f036ef64f3f17bddd745364e27b459edca173c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f529a9592b70a4ed126b06fb0fcf9420c0b30400774b6266a218184148772380)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable",
    jsii_struct_bases=[],
    name_mapping={
        "threshold_unit": "thresholdUnit",
        "threshold_value": "thresholdValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable:
    def __init__(
        self,
        *,
        threshold_unit: typing.Optional[builtins.str] = None,
        threshold_value: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param threshold_unit: The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        :param threshold_value: The numeric indicator of the minimum file size or elapsed download time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54a0e45fc16e5d5fab0b656799e98489e5380dba945cf4b22b80fbabff5b6d14)
            check_type(argname="argument threshold_unit", value=threshold_unit, expected_type=type_hints["threshold_unit"])
            check_type(argname="argument threshold_value", value=threshold_value, expected_type=type_hints["threshold_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if threshold_unit is not None:
            self._values["threshold_unit"] = threshold_unit
        if threshold_value is not None:
            self._values["threshold_value"] = threshold_value

    @builtins.property
    def threshold_unit(self) -> typing.Optional[builtins.str]:
        '''The unit of measurement, either ``SECONDS`` of the elapsed download time, or ``BYTES`` of the file size.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_unit DataAkamaiPropertyRulesBuilder#threshold_unit}
        '''
        result = self._values.get("threshold_unit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def threshold_value(self) -> typing.Optional[jsii.Number]:
        '''The numeric indicator of the minimum file size or elapsed download time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_value DataAkamaiPropertyRulesBuilder#threshold_value}
        '''
        result = self._values.get("threshold_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b53c752b9c9e092b7c0ae799c3bd5c38377f6a12111ecbf69155552955ce98e7)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ca5b6c2ef4887abfc64a27a9bd9079548ed2d5c83c2cd07871ddc1b374b96c)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1047ba335c697c3cf75d23453bef7597dde3321295e7f083d66c9635a6ecccb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0778d8da9f07a2d553c440dfe7a93ffe82b97791adfbe5072da5e12ce601857c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b444d3035127a3819b307f9518a69325033a072def8518f2fcac85f46752ad49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8399934203a27938acc2e4abf68bbfa0568a6a706a85f7689e5fe33d2f11ea73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fc2150079e819e3977d162654c35c860a501975ee977f019a3c84b839ed023d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="resetThresholdUnit")
    def reset_threshold_unit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdUnit", []))

    @jsii.member(jsii_name="resetThresholdValue")
    def reset_threshold_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetThresholdValue", []))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnitInput")
    def threshold_unit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "thresholdUnitInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdValueInput")
    def threshold_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "thresholdValueInput"))

    @builtins.property
    @jsii.member(jsii_name="thresholdUnit")
    def threshold_unit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "thresholdUnit"))

    @threshold_unit.setter
    def threshold_unit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40f24213248849dc23aca47707383a880f8f77920963bc2aa2cbb28f574fd60e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdUnit", value)

    @builtins.property
    @jsii.member(jsii_name="thresholdValue")
    def threshold_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "thresholdValue"))

    @threshold_value.setter
    def threshold_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c2c2333ac7e3c9c132ad0c94d42a41f01b0ac01a2c47f21ac022906df70ef46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "thresholdValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddb6e84088f46c2943bc6b610a0d783f8c5df7c2922d6934c2f94a62856cc47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3cb004b4b661f883b3cab47dea2c094d78581200b8948e41c0dde5339b4d2704)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843f2ed6ea110f0dad268ba82c83ada593dc39fa1693bd94f2b67a39c6c922f9)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cde8b72b7116f5e1d9b90e624ce3195f0205ec50738cc925c5b34eee0a772bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__429efb05cbe0fcc55b205644ebfeee6f8c629026492e63fa07165d5711c17b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aca9d3ba22ac9f6163d820ae05f1e1515cb51b34e2c8af267f296513a4c0ea29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2169b961d668f3cfd322a1b8e90c1d31e86d40a99745cc6bda3a66546c0813e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom",
    jsii_struct_bases=[],
    name_mapping={
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_custom_log_field": "logCustomLogField",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom:
    def __init__(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f45a586cbd7f145a6d7a7144ec852c5915163c223dda94c558ee8fec77f3827f)
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8e9a84e5f6710001571adeca1b13b4780390a6bbdac454ed3a8cfd1ac180509)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22c057bce33d192b89c4e19da2fa51ed17b468b14ed4561326799ff123a018ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a6e8599c950d4682a1be0c2e8c88fda5be0f45f529af109679702afcce0028)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82c4c8adc521038c3f5c517fc2321c2cf54a1d7659b765201a8da87ee757d5e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55aa2aa4c6905b4f5fb201daa752ac1e5ebaf0e54ae29cbc8f065e711706acda)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c418333f014d2f5ecdd02d5bed5816a83eb9f687cb8f7c2e53073701a2e8c32)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fbe22ef5b95596cb78391854e321f075a603221af372b8728e36b6c4db1936f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse",
    jsii_struct_bases=[],
    name_mapping={
        "api_key": "apiKey",
        "buffer_size": "bufferSize",
        "config_override": "configOverride",
        "enabled": "enabled",
        "loader_version": "loaderVersion",
        "locked": "locked",
        "require_pci": "requirePci",
        "template_uuid": "templateUuid",
        "title_optional": "titleOptional",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse:
    def __init__(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__beb94403b10d56acc7f3479e6db0755dde2ad132b48388efcf7b7db997eb808b)
            check_type(argname="argument api_key", value=api_key, expected_type=type_hints["api_key"])
            check_type(argname="argument buffer_size", value=buffer_size, expected_type=type_hints["buffer_size"])
            check_type(argname="argument config_override", value=config_override, expected_type=type_hints["config_override"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument loader_version", value=loader_version, expected_type=type_hints["loader_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument require_pci", value=require_pci, expected_type=type_hints["require_pci"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument title_optional", value=title_optional, expected_type=type_hints["title_optional"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if api_key is not None:
            self._values["api_key"] = api_key
        if buffer_size is not None:
            self._values["buffer_size"] = buffer_size
        if config_override is not None:
            self._values["config_override"] = config_override
        if enabled is not None:
            self._values["enabled"] = enabled
        if loader_version is not None:
            self._values["loader_version"] = loader_version
        if locked is not None:
            self._values["locked"] = locked
        if require_pci is not None:
            self._values["require_pci"] = require_pci
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if title_optional is not None:
            self._values["title_optional"] = title_optional
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def api_key(self) -> typing.Optional[builtins.str]:
        '''This generated value uniquely identifies sections of your website for you to analyze independently.

        To access this value, see ``Enable mPulse in Property Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        '''
        result = self._values.get("api_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def buffer_size(self) -> typing.Optional[builtins.str]:
        '''Allows you to override the browser's default (150) maximum number of reported performance timeline entries.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        '''
        result = self._values.get("buffer_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def config_override(self) -> typing.Optional[builtins.str]:
        '''A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs.

        It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``.  See ``Configuration Overrides`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        '''
        result = self._values.get("config_override")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies performance monitoring to this behavior's set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def loader_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        '''
        result = self._values.get("loader_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def require_pci(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        '''
        result = self._values.get("require_pci")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def title_optional(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        '''
        result = self._values.get("title_optional")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bafdbbf953a8f3b3218e221b83fac7d224687b00bd10e63eafec66a789ba024)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApiKey")
    def reset_api_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiKey", []))

    @jsii.member(jsii_name="resetBufferSize")
    def reset_buffer_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBufferSize", []))

    @jsii.member(jsii_name="resetConfigOverride")
    def reset_config_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigOverride", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLoaderVersion")
    def reset_loader_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLoaderVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequirePci")
    def reset_require_pci(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequirePci", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTitleOptional")
    def reset_title_optional(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTitleOptional", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="apiKeyInput")
    def api_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "apiKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="bufferSizeInput")
    def buffer_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "bufferSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="configOverrideInput")
    def config_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="loaderVersionInput")
    def loader_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "loaderVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requirePciInput")
    def require_pci_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "requirePciInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="titleOptionalInput")
    def title_optional_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "titleOptionalInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="apiKey")
    def api_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "apiKey"))

    @api_key.setter
    def api_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15df56f4e4365746d5664b96365c541b96b4383bd96c73289c48a8cf46914525)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "apiKey", value)

    @builtins.property
    @jsii.member(jsii_name="bufferSize")
    def buffer_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "bufferSize"))

    @buffer_size.setter
    def buffer_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9ad73bf95b769d0d6e9c17e77791f61cd006b2c99b272967a50172d5d2e4eff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bufferSize", value)

    @builtins.property
    @jsii.member(jsii_name="configOverride")
    def config_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configOverride"))

    @config_override.setter
    def config_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac8b3d0c512df5192d0f28d4db7f6a20f4c59aef981ddbbc5b673404d1ce16e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configOverride", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db392791ac4df7937b869f6110090ff8e52fcffa0061f2878942236e73757fbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="loaderVersion")
    def loader_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "loaderVersion"))

    @loader_version.setter
    def loader_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef2dac179c3ed87cf57f9c96c2be5625ed4708ffd3d8d9ca703e4be474b24459)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "loaderVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0854f9a12e5cb6689d04c0dfdaa2b1ed9344369ce64144353884bf3e23b689)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requirePci")
    def require_pci(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "requirePci"))

    @require_pci.setter
    def require_pci(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ca1247ec9619113cd7312c370e717fb38af3240bdfccc14885804ff11abc9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requirePci", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d97561ed57a3c53c74a2043fbd9ae4daf0a02aba7e8b6d16a394a40593015395)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="titleOptional")
    def title_optional(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "titleOptional"))

    @title_optional.setter
    def title_optional(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__869efa5da08a644cb9fed2cec8ac799a28f749643a1337cafec22a33e5d40598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "titleOptional", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c2d3a66a56324b8333f22cd35fe72b0ab14689b0d01dd7f283b195644d9d664)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28cafb7e65654badaadaa1980ceea54b0a128b30acb29f75a3186dafcfc6153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "hls_enabled": "hlsEnabled",
        "hls_enable_debug_headers": "hlsEnableDebugHeaders",
        "hls_filter_in_bitrate_ranges": "hlsFilterInBitrateRanges",
        "hls_filter_in_bitrates": "hlsFilterInBitrates",
        "hls_mode": "hlsMode",
        "hls_preferred_bitrate": "hlsPreferredBitrate",
        "hls_query_param_enabled": "hlsQueryParamEnabled",
        "hls_query_param_secret_key": "hlsQueryParamSecretKey",
        "hls_query_param_transition_key": "hlsQueryParamTransitionKey",
        "hls_show_advanced": "hlsShowAdvanced",
        "hls_title": "hlsTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef8b52aa65fad53a59e52b2738248b15c74b989c7c8af3c1d6f8db1e19f6b92a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument hls_enabled", value=hls_enabled, expected_type=type_hints["hls_enabled"])
            check_type(argname="argument hls_enable_debug_headers", value=hls_enable_debug_headers, expected_type=type_hints["hls_enable_debug_headers"])
            check_type(argname="argument hls_filter_in_bitrate_ranges", value=hls_filter_in_bitrate_ranges, expected_type=type_hints["hls_filter_in_bitrate_ranges"])
            check_type(argname="argument hls_filter_in_bitrates", value=hls_filter_in_bitrates, expected_type=type_hints["hls_filter_in_bitrates"])
            check_type(argname="argument hls_mode", value=hls_mode, expected_type=type_hints["hls_mode"])
            check_type(argname="argument hls_preferred_bitrate", value=hls_preferred_bitrate, expected_type=type_hints["hls_preferred_bitrate"])
            check_type(argname="argument hls_query_param_enabled", value=hls_query_param_enabled, expected_type=type_hints["hls_query_param_enabled"])
            check_type(argname="argument hls_query_param_secret_key", value=hls_query_param_secret_key, expected_type=type_hints["hls_query_param_secret_key"])
            check_type(argname="argument hls_query_param_transition_key", value=hls_query_param_transition_key, expected_type=type_hints["hls_query_param_transition_key"])
            check_type(argname="argument hls_show_advanced", value=hls_show_advanced, expected_type=type_hints["hls_show_advanced"])
            check_type(argname="argument hls_title", value=hls_title, expected_type=type_hints["hls_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if hls_enabled is not None:
            self._values["hls_enabled"] = hls_enabled
        if hls_enable_debug_headers is not None:
            self._values["hls_enable_debug_headers"] = hls_enable_debug_headers
        if hls_filter_in_bitrate_ranges is not None:
            self._values["hls_filter_in_bitrate_ranges"] = hls_filter_in_bitrate_ranges
        if hls_filter_in_bitrates is not None:
            self._values["hls_filter_in_bitrates"] = hls_filter_in_bitrates
        if hls_mode is not None:
            self._values["hls_mode"] = hls_mode
        if hls_preferred_bitrate is not None:
            self._values["hls_preferred_bitrate"] = hls_preferred_bitrate
        if hls_query_param_enabled is not None:
            self._values["hls_query_param_enabled"] = hls_query_param_enabled
        if hls_query_param_secret_key is not None:
            self._values["hls_query_param_secret_key"] = hls_query_param_secret_key
        if hls_query_param_transition_key is not None:
            self._values["hls_query_param_transition_key"] = hls_query_param_transition_key
        if hls_show_advanced is not None:
            self._values["hls_show_advanced"] = hls_show_advanced
        if hls_title is not None:
            self._values["hls_title"] = hls_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Manifest Personalization feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to customize the HLS master manifest that's sent to the requesting client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        '''
        result = self._values.get("hls_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_enable_debug_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        '''
        result = self._values.get("hls_enable_debug_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_filter_in_bitrate_ranges(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        '''
        result = self._values.get("hls_filter_in_bitrate_ranges")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_filter_in_bitrates(self) -> typing.Optional[builtins.str]:
        '''Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``.

        Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        '''
        result = self._values.get("hls_filter_in_bitrates")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_mode(self) -> typing.Optional[builtins.str]:
        '''Applies with ``hlsEnabled`` on.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        '''
        result = self._values.get("hls_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_preferred_bitrate(self) -> typing.Optional[builtins.str]:
        '''Sets the preferred bit rate in Kbps.

        This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        '''
        result = self._values.get("hls_preferred_bitrate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies query parameters for the HLS master manifest to customize the manifest's content.

        Any settings specified in the query string override those already configured in Property Manager.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        '''
        result = self._values.get("hls_query_param_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_query_param_secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a primary key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        '''
        result = self._values.get("hls_query_param_secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_query_param_transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a token to accompany the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        '''
        result = self._values.get("hls_query_param_transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hls_show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        '''
        result = self._values.get("hls_show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        '''
        result = self._values.get("hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__badbc5eecfbc1f8110c64f37ff1faef255bcc59e1c09a3b91b6f2419cde7212c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetHlsEnabled")
    def reset_hls_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnabled", []))

    @jsii.member(jsii_name="resetHlsEnableDebugHeaders")
    def reset_hls_enable_debug_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsEnableDebugHeaders", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrateRanges")
    def reset_hls_filter_in_bitrate_ranges(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrateRanges", []))

    @jsii.member(jsii_name="resetHlsFilterInBitrates")
    def reset_hls_filter_in_bitrates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsFilterInBitrates", []))

    @jsii.member(jsii_name="resetHlsMode")
    def reset_hls_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMode", []))

    @jsii.member(jsii_name="resetHlsPreferredBitrate")
    def reset_hls_preferred_bitrate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsPreferredBitrate", []))

    @jsii.member(jsii_name="resetHlsQueryParamEnabled")
    def reset_hls_query_param_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamEnabled", []))

    @jsii.member(jsii_name="resetHlsQueryParamSecretKey")
    def reset_hls_query_param_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamSecretKey", []))

    @jsii.member(jsii_name="resetHlsQueryParamTransitionKey")
    def reset_hls_query_param_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsQueryParamTransitionKey", []))

    @jsii.member(jsii_name="resetHlsShowAdvanced")
    def reset_hls_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsShowAdvanced", []))

    @jsii.member(jsii_name="resetHlsTitle")
    def reset_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeadersInput")
    def hls_enable_debug_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnableDebugHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsEnabledInput")
    def hls_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRangesInput")
    def hls_filter_in_bitrate_ranges_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitrateRangesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitratesInput")
    def hls_filter_in_bitrates_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsFilterInBitratesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsModeInput")
    def hls_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsModeInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrateInput")
    def hls_preferred_bitrate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsPreferredBitrateInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabledInput")
    def hls_query_param_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsQueryParamEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKeyInput")
    def hls_query_param_secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamSecretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKeyInput")
    def hls_query_param_transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsQueryParamTransitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvancedInput")
    def hls_show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsShowAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsTitleInput")
    def hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d490f1e283aad01d66c5a7361a4e06ecd3ba8c2def522c07978bf27f99390131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnabled")
    def hls_enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnabled"))

    @hls_enabled.setter
    def hls_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8387b250aa257a09f8ddf73a73b303d0011ac5350a25f760dbb6e18b764418b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsEnableDebugHeaders")
    def hls_enable_debug_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsEnableDebugHeaders"))

    @hls_enable_debug_headers.setter
    def hls_enable_debug_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4a972452c9d5ea680a3cfc7998bac28242e888afded7c00f85f84ad644a0277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsEnableDebugHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrateRanges")
    def hls_filter_in_bitrate_ranges(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrateRanges"))

    @hls_filter_in_bitrate_ranges.setter
    def hls_filter_in_bitrate_ranges(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90dc46a6df813e31609acba98b1e050335269fab5ffb191065ec648dba031b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrateRanges", value)

    @builtins.property
    @jsii.member(jsii_name="hlsFilterInBitrates")
    def hls_filter_in_bitrates(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsFilterInBitrates"))

    @hls_filter_in_bitrates.setter
    def hls_filter_in_bitrates(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2c76670314153ad3a368160f0b450a95832951b294e8c311ddcb0905da0f7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsFilterInBitrates", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMode")
    def hls_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsMode"))

    @hls_mode.setter
    def hls_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35e0782fec76b533e0c71fed5ea2f0168b93b4be10a4780be1bb14f3bb8a7065)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMode", value)

    @builtins.property
    @jsii.member(jsii_name="hlsPreferredBitrate")
    def hls_preferred_bitrate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsPreferredBitrate"))

    @hls_preferred_bitrate.setter
    def hls_preferred_bitrate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9e131cfb68d725558c8a7a40d01e1e64656326c07e31b70d26ad17b6e706f27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsPreferredBitrate", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamEnabled")
    def hls_query_param_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsQueryParamEnabled"))

    @hls_query_param_enabled.setter
    def hls_query_param_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae9956279d2109ad5b2813e517923d22ebb51ffe60a19de02ff930deffdf3980)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamSecretKey")
    def hls_query_param_secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamSecretKey"))

    @hls_query_param_secret_key.setter
    def hls_query_param_secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__831e1f9d4af91c5add2245c5209a00ee6a2f8e3a7aa6b8a50af1441bd079d57a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamSecretKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsQueryParamTransitionKey")
    def hls_query_param_transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsQueryParamTransitionKey"))

    @hls_query_param_transition_key.setter
    def hls_query_param_transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f6c14db47d5a2752fd6b23ec9680eeca61f0ef6ea2f7c11e0be12852db8e403)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsQueryParamTransitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="hlsShowAdvanced")
    def hls_show_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsShowAdvanced"))

    @hls_show_advanced.setter
    def hls_show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9d47ebb3abad4e6385a928eb5048282b098b75504520181d3360be949070ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsShowAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="hlsTitle")
    def hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hlsTitle"))

    @hls_title.setter
    def hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f89c056832541d9cc9987bdb88ef8b570521e58016967ae79feb6b659261e2c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4c8d3ab4e0423434fa3a68ff8291c0ea103ef9eeb31b1d1fbf6c086cef899de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__abba7aebe7e434b834fa54273a2e5015c9c662ddf0a49142305f5bcdcaaa1465)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b09206538138428f22e41fef90c3d1c9cc486b38bf7fe16aef92a777cc531ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__479475f15665d5377269581613aac7abf4a00a34accb4b0ed416368f198aa919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "partner": "partner",
        "template_uuid": "templateUuid",
        "username": "username",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a5e544cc65ceda4a098399a608cba79be43a8dd2f7a99c8cd1f18abec3907b2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument partner", value=partner, expected_type=type_hints["partner"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument username", value=username, expected_type=type_hints["username"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if partner is not None:
            self._values["partner"] = partner
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if username is not None:
            self._values["username"] = username
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner(self) -> typing.Optional[builtins.str]:
        '''Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        '''
        result = self._values.get("partner")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def username(self) -> typing.Optional[builtins.str]:
        '''The user name for your Adobe Primetime account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        '''
        result = self._values.get("username")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__843155514a6e82da2cb3e603cb25a5fad2b8771a847e64c32b83f9a94dc03efd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPartner")
    def reset_partner(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartner", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsername")
    def reset_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsername", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerInput")
    def partner_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usernameInput")
    def username_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usernameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__320b3cbc4be7eb34b40942006485a167b6ffe2433573a293eb16eda5d6c8845c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="partner")
    def partner(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partner"))

    @partner.setter
    def partner(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__529078b1bf4f1176276e6808b0e813eee3ee06b8b4961cd4260962079d7647ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partner", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be8414c436cde914530f192412db188bd6ad461b2e6126fc4775298b5431b49b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="username")
    def username(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "username"))

    @username.setter
    def username(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e31b295e8f56f3ccaf4a5a8c8e3dc419d71d12ba860eea588d2c02b78348ce18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "username", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__212bd261badfd453e7e26bd827e9c9714e6450e287107a804766ef4291cd08e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e845ec354a8fb317a74eeaefc31f3d6da4578a89fddc1b648175f7d8942ff8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "serverpushlist": "serverpushlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71f54ca710cdd1749a1c3d6a0804826bce98a445768663f918ca39f0930aef40)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serverpushlist", value=serverpushlist, expected_type=type_hints["serverpushlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if serverpushlist is not None:
            self._values["serverpushlist"] = serverpushlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serverpushlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of objects to load into the client browser's cache over HTTP2.

        Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        '''
        result = self._values.get("serverpushlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89670eff3277630ccf41270df8109678f64587e8b111e13612d655c2b0310218)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServerpushlist")
    def reset_serverpushlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerpushlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serverpushlistInput")
    def serverpushlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "serverpushlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3633417ff7d5a26a0788513671d8f2ec16daa5492f3a5941d55955f0e1ce948a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serverpushlist")
    def serverpushlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "serverpushlist"))

    @serverpushlist.setter
    def serverpushlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__954d1cd5057ec9bfd561dcc0de1627f0f7512588036ae0c324dfbe69b4344d8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serverpushlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0230c3e7163e14771a4b5f313c1c8cba8475a7a55fb448c4c1732423981c5b87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fba0657670a8f99e3c4b3c4859e918e4aa179d5b34d9a06cba70fb05e993d03b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6783c6d6e27028d5e55f428ae7a39d0c8ddc6ccce96507bd895e4c48927c2ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a99f5605792c37a420e28862ff87e4a2e14db9f5b53eaa1e23d8e7a5cd4587a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Media Acceleration.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ff5fdfd574ea9244114dce3afef8668991de124e59484ffd08a49728fd67816)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__072221981e23b76c6042490258d629688ee35b4c3f3d0e151fd9aac8e0b501a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b4fc36db3ff23e9b27c8885bde38242e4fc64a0f869d4dbbde9115b22c37f38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3906747a32aab08bed45110718194edd034ed4611a678aea971f4998432adf03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24e6d23248f705dc76c980d84d73637fd68f7345e8b42c9eedc41e6cde06fae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d2c43516da79a74f689da26937e6991b52c2351d80b3e1f2e90bd9638935def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "optout": "optout",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ac1a8ba1033551aaa39584eb89f49f318da687fc10b03144865a6efe19aa679)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument optout", value=optout, expected_type=type_hints["optout"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if optout is not None:
            self._values["optout"] = optout
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def optout(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        '''
        result = self._values.get("optout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ab5c02a7e60ec8efdb8527f155e20ee53392292f80bd168c42a3783642a258)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOptout")
    def reset_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptout", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="optoutInput")
    def optout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optoutInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34582cee0dc46ca934648924e2805ca62f8866d03ed5b1a843bdb21bb64fd275)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="optout")
    def optout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optout"))

    @optout.setter
    def optout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63567fb7abd643c2a669ae5d55b9ca3010b0ca9b16e5e673cac94035ec18821c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optout", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b4a0c65bf160d9850d08863e3ff1c357d36a10ecc7948267245c8941ae87dac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98fbea2267a2da819eb7b48f39e5afc4b780d50c5b4425fcf7b661a2c5a67955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e94f713e0d14888942a50c7c0d8fcdfe7528a0117b434e1ce21d7923efa058f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient",
    jsii_struct_bases=[],
    name_mapping={
        "beacon_id": "beaconId",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_hybrid_http_udp": "useHybridHttpUdp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient:
    def __init__(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b604d2596b4f72c174abd3031c326c1e97c5f57ae2b7ca564c8d187dbf2d101)
            check_type(argname="argument beacon_id", value=beacon_id, expected_type=type_hints["beacon_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_hybrid_http_udp", value=use_hybrid_http_udp, expected_type=type_hints["use_hybrid_http_udp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if beacon_id is not None:
            self._values["beacon_id"] = beacon_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_hybrid_http_udp is not None:
            self._values["use_hybrid_http_udp"] = use_hybrid_http_udp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def beacon_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ID of data source's beacon.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        '''
        result = self._values.get("beacon_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables client-side download analytics.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_hybrid_http_udp(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the hybrid HTTP/UDP protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        '''
        result = self._values.get("use_hybrid_http_udp")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33ce48d03d71899a8415761b2ebe45c10cb46dcf8701c594c84584e5da6b7c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBeaconId")
    def reset_beacon_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHybridHttpUdp")
    def reset_use_hybrid_http_udp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHybridHttpUdp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="beaconIdInput")
    def beacon_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beaconIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdpInput")
    def use_hybrid_http_udp_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHybridHttpUdpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconId")
    def beacon_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beaconId"))

    @beacon_id.setter
    def beacon_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0447591e215754c2977650d3d48e0a222d71a60dc726a84e7d24480ca4dd1dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e7c1dd54cdc1628840f60e6fc1d84f21ad0fcb804677acb2dd0d4c175ea37c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5112273fdf4d84231675e59a9b8f9ab946a5a6265ce4f3c19a58a040f8e33509)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be2125ccd338815dec2ea8584f04af93aa2107014f72873ccaf910ccc92f5cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHybridHttpUdp")
    def use_hybrid_http_udp(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHybridHttpUdp"))

    @use_hybrid_http_udp.setter
    def use_hybrid_http_udp(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6132af03668a5bcdb9b888d1ef8a6153883b10225ebe9b2f1cf441720bacc338)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHybridHttpUdp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f24af2ef334205dbc14784642473115cad248c70a452ef907d906feaf517a81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dbd39b5c94161a12d3e25382ad830536195b7401e0b8f1580a0067cc984f98d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d11b4bf9731bb8228d3bf745853b3eeab585f2f54da4b6fe542598f0e4727bd)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the partial-object caching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5e525c69147109db6a734c0001df2141e0bf529e3e03561b4ea546d9c2aff3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161a058fc888d3b872b7f1824279ff86a8c06570911ed6b78541231931b31fed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed0261aa82ff848be8dfcd0e5b1a38619b6c36970411d2614ff614b4225e5a5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2692e99662875de4823233b453911cefc69950ede689aa5741e49b1f7aa3fd09)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0203bf089ce3d83061bbbbb2cce8025bd7d1e3422d13d1d330307214d87f1cab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dcef50c39d968fb810f8ee9853a44400824de14ce15c2e5b1e60d39207527ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover",
    jsii_struct_bases=[],
    name_mapping={
        "cache_error_response": "cacheErrorResponse",
        "cache_window": "cacheWindow",
        "client_response_code": "clientResponseCode",
        "detect_object_unavailable": "detectObjectUnavailable",
        "detect_object_unavailable_title": "detectObjectUnavailableTitle",
        "detect_origin_unavailable": "detectOriginUnavailable",
        "detect_origin_unavailable_title": "detectOriginUnavailableTitle",
        "detect_origin_unresponsive": "detectOriginUnresponsive",
        "detect_origin_unresponsive_title": "detectOriginUnresponsiveTitle",
        "locked": "locked",
        "object_unavailable_alternate_host": "objectUnavailableAlternateHost",
        "object_unavailable_backup_host": "objectUnavailableBackupHost",
        "object_unavailable_blacklist_origin_ip": "objectUnavailableBlacklistOriginIp",
        "object_unavailable_blacklist_window": "objectUnavailableBlacklistWindow",
        "object_unavailable_change_protocol": "objectUnavailableChangeProtocol",
        "object_unavailable_detection_level": "objectUnavailableDetectionLevel",
        "object_unavailable_include_query_string": "objectUnavailableIncludeQueryString",
        "object_unavailable_modified_path": "objectUnavailableModifiedPath",
        "object_unavailable_modify_request_path": "objectUnavailableModifyRequestPath",
        "object_unavailable_protocol": "objectUnavailableProtocol",
        "object_unavailable_recovery": "objectUnavailableRecovery",
        "object_unavailable_redirect_method": "objectUnavailableRedirectMethod",
        "object_unavailable_response_codes": "objectUnavailableResponseCodes",
        "object_unavailable_retry_limit": "objectUnavailableRetryLimit",
        "origin_unavailable_alternate_host": "originUnavailableAlternateHost",
        "origin_unavailable_backup_host": "originUnavailableBackupHost",
        "origin_unavailable_blacklist_origin_ip": "originUnavailableBlacklistOriginIp",
        "origin_unavailable_blacklist_window": "originUnavailableBlacklistWindow",
        "origin_unavailable_change_protocol": "originUnavailableChangeProtocol",
        "origin_unavailable_detection_level": "originUnavailableDetectionLevel",
        "origin_unavailable_include_query_string": "originUnavailableIncludeQueryString",
        "origin_unavailable_modified_path": "originUnavailableModifiedPath",
        "origin_unavailable_modify_request_path": "originUnavailableModifyRequestPath",
        "origin_unavailable_protocol": "originUnavailableProtocol",
        "origin_unavailable_recovery": "originUnavailableRecovery",
        "origin_unavailable_redirect_method": "originUnavailableRedirectMethod",
        "origin_unavailable_response_codes": "originUnavailableResponseCodes",
        "origin_unavailable_retry_limit": "originUnavailableRetryLimit",
        "origin_unresponsive_alternate_host": "originUnresponsiveAlternateHost",
        "origin_unresponsive_backup_host": "originUnresponsiveBackupHost",
        "origin_unresponsive_blacklist_origin_ip": "originUnresponsiveBlacklistOriginIp",
        "origin_unresponsive_blacklist_window": "originUnresponsiveBlacklistWindow",
        "origin_unresponsive_change_protocol": "originUnresponsiveChangeProtocol",
        "origin_unresponsive_detection_level": "originUnresponsiveDetectionLevel",
        "origin_unresponsive_include_query_string": "originUnresponsiveIncludeQueryString",
        "origin_unresponsive_modified_path": "originUnresponsiveModifiedPath",
        "origin_unresponsive_modify_request_path": "originUnresponsiveModifyRequestPath",
        "origin_unresponsive_protocol": "originUnresponsiveProtocol",
        "origin_unresponsive_recovery": "originUnresponsiveRecovery",
        "origin_unresponsive_redirect_method": "originUnresponsiveRedirectMethod",
        "origin_unresponsive_retry_limit": "originUnresponsiveRetryLimit",
        "other_options": "otherOptions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover:
    def __init__(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c3b47ac97d86c104846bc9948754995d1569387ecc4094465f72a8181f76539)
            check_type(argname="argument cache_error_response", value=cache_error_response, expected_type=type_hints["cache_error_response"])
            check_type(argname="argument cache_window", value=cache_window, expected_type=type_hints["cache_window"])
            check_type(argname="argument client_response_code", value=client_response_code, expected_type=type_hints["client_response_code"])
            check_type(argname="argument detect_object_unavailable", value=detect_object_unavailable, expected_type=type_hints["detect_object_unavailable"])
            check_type(argname="argument detect_object_unavailable_title", value=detect_object_unavailable_title, expected_type=type_hints["detect_object_unavailable_title"])
            check_type(argname="argument detect_origin_unavailable", value=detect_origin_unavailable, expected_type=type_hints["detect_origin_unavailable"])
            check_type(argname="argument detect_origin_unavailable_title", value=detect_origin_unavailable_title, expected_type=type_hints["detect_origin_unavailable_title"])
            check_type(argname="argument detect_origin_unresponsive", value=detect_origin_unresponsive, expected_type=type_hints["detect_origin_unresponsive"])
            check_type(argname="argument detect_origin_unresponsive_title", value=detect_origin_unresponsive_title, expected_type=type_hints["detect_origin_unresponsive_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument object_unavailable_alternate_host", value=object_unavailable_alternate_host, expected_type=type_hints["object_unavailable_alternate_host"])
            check_type(argname="argument object_unavailable_backup_host", value=object_unavailable_backup_host, expected_type=type_hints["object_unavailable_backup_host"])
            check_type(argname="argument object_unavailable_blacklist_origin_ip", value=object_unavailable_blacklist_origin_ip, expected_type=type_hints["object_unavailable_blacklist_origin_ip"])
            check_type(argname="argument object_unavailable_blacklist_window", value=object_unavailable_blacklist_window, expected_type=type_hints["object_unavailable_blacklist_window"])
            check_type(argname="argument object_unavailable_change_protocol", value=object_unavailable_change_protocol, expected_type=type_hints["object_unavailable_change_protocol"])
            check_type(argname="argument object_unavailable_detection_level", value=object_unavailable_detection_level, expected_type=type_hints["object_unavailable_detection_level"])
            check_type(argname="argument object_unavailable_include_query_string", value=object_unavailable_include_query_string, expected_type=type_hints["object_unavailable_include_query_string"])
            check_type(argname="argument object_unavailable_modified_path", value=object_unavailable_modified_path, expected_type=type_hints["object_unavailable_modified_path"])
            check_type(argname="argument object_unavailable_modify_request_path", value=object_unavailable_modify_request_path, expected_type=type_hints["object_unavailable_modify_request_path"])
            check_type(argname="argument object_unavailable_protocol", value=object_unavailable_protocol, expected_type=type_hints["object_unavailable_protocol"])
            check_type(argname="argument object_unavailable_recovery", value=object_unavailable_recovery, expected_type=type_hints["object_unavailable_recovery"])
            check_type(argname="argument object_unavailable_redirect_method", value=object_unavailable_redirect_method, expected_type=type_hints["object_unavailable_redirect_method"])
            check_type(argname="argument object_unavailable_response_codes", value=object_unavailable_response_codes, expected_type=type_hints["object_unavailable_response_codes"])
            check_type(argname="argument object_unavailable_retry_limit", value=object_unavailable_retry_limit, expected_type=type_hints["object_unavailable_retry_limit"])
            check_type(argname="argument origin_unavailable_alternate_host", value=origin_unavailable_alternate_host, expected_type=type_hints["origin_unavailable_alternate_host"])
            check_type(argname="argument origin_unavailable_backup_host", value=origin_unavailable_backup_host, expected_type=type_hints["origin_unavailable_backup_host"])
            check_type(argname="argument origin_unavailable_blacklist_origin_ip", value=origin_unavailable_blacklist_origin_ip, expected_type=type_hints["origin_unavailable_blacklist_origin_ip"])
            check_type(argname="argument origin_unavailable_blacklist_window", value=origin_unavailable_blacklist_window, expected_type=type_hints["origin_unavailable_blacklist_window"])
            check_type(argname="argument origin_unavailable_change_protocol", value=origin_unavailable_change_protocol, expected_type=type_hints["origin_unavailable_change_protocol"])
            check_type(argname="argument origin_unavailable_detection_level", value=origin_unavailable_detection_level, expected_type=type_hints["origin_unavailable_detection_level"])
            check_type(argname="argument origin_unavailable_include_query_string", value=origin_unavailable_include_query_string, expected_type=type_hints["origin_unavailable_include_query_string"])
            check_type(argname="argument origin_unavailable_modified_path", value=origin_unavailable_modified_path, expected_type=type_hints["origin_unavailable_modified_path"])
            check_type(argname="argument origin_unavailable_modify_request_path", value=origin_unavailable_modify_request_path, expected_type=type_hints["origin_unavailable_modify_request_path"])
            check_type(argname="argument origin_unavailable_protocol", value=origin_unavailable_protocol, expected_type=type_hints["origin_unavailable_protocol"])
            check_type(argname="argument origin_unavailable_recovery", value=origin_unavailable_recovery, expected_type=type_hints["origin_unavailable_recovery"])
            check_type(argname="argument origin_unavailable_redirect_method", value=origin_unavailable_redirect_method, expected_type=type_hints["origin_unavailable_redirect_method"])
            check_type(argname="argument origin_unavailable_response_codes", value=origin_unavailable_response_codes, expected_type=type_hints["origin_unavailable_response_codes"])
            check_type(argname="argument origin_unavailable_retry_limit", value=origin_unavailable_retry_limit, expected_type=type_hints["origin_unavailable_retry_limit"])
            check_type(argname="argument origin_unresponsive_alternate_host", value=origin_unresponsive_alternate_host, expected_type=type_hints["origin_unresponsive_alternate_host"])
            check_type(argname="argument origin_unresponsive_backup_host", value=origin_unresponsive_backup_host, expected_type=type_hints["origin_unresponsive_backup_host"])
            check_type(argname="argument origin_unresponsive_blacklist_origin_ip", value=origin_unresponsive_blacklist_origin_ip, expected_type=type_hints["origin_unresponsive_blacklist_origin_ip"])
            check_type(argname="argument origin_unresponsive_blacklist_window", value=origin_unresponsive_blacklist_window, expected_type=type_hints["origin_unresponsive_blacklist_window"])
            check_type(argname="argument origin_unresponsive_change_protocol", value=origin_unresponsive_change_protocol, expected_type=type_hints["origin_unresponsive_change_protocol"])
            check_type(argname="argument origin_unresponsive_detection_level", value=origin_unresponsive_detection_level, expected_type=type_hints["origin_unresponsive_detection_level"])
            check_type(argname="argument origin_unresponsive_include_query_string", value=origin_unresponsive_include_query_string, expected_type=type_hints["origin_unresponsive_include_query_string"])
            check_type(argname="argument origin_unresponsive_modified_path", value=origin_unresponsive_modified_path, expected_type=type_hints["origin_unresponsive_modified_path"])
            check_type(argname="argument origin_unresponsive_modify_request_path", value=origin_unresponsive_modify_request_path, expected_type=type_hints["origin_unresponsive_modify_request_path"])
            check_type(argname="argument origin_unresponsive_protocol", value=origin_unresponsive_protocol, expected_type=type_hints["origin_unresponsive_protocol"])
            check_type(argname="argument origin_unresponsive_recovery", value=origin_unresponsive_recovery, expected_type=type_hints["origin_unresponsive_recovery"])
            check_type(argname="argument origin_unresponsive_redirect_method", value=origin_unresponsive_redirect_method, expected_type=type_hints["origin_unresponsive_redirect_method"])
            check_type(argname="argument origin_unresponsive_retry_limit", value=origin_unresponsive_retry_limit, expected_type=type_hints["origin_unresponsive_retry_limit"])
            check_type(argname="argument other_options", value=other_options, expected_type=type_hints["other_options"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_error_response is not None:
            self._values["cache_error_response"] = cache_error_response
        if cache_window is not None:
            self._values["cache_window"] = cache_window
        if client_response_code is not None:
            self._values["client_response_code"] = client_response_code
        if detect_object_unavailable is not None:
            self._values["detect_object_unavailable"] = detect_object_unavailable
        if detect_object_unavailable_title is not None:
            self._values["detect_object_unavailable_title"] = detect_object_unavailable_title
        if detect_origin_unavailable is not None:
            self._values["detect_origin_unavailable"] = detect_origin_unavailable
        if detect_origin_unavailable_title is not None:
            self._values["detect_origin_unavailable_title"] = detect_origin_unavailable_title
        if detect_origin_unresponsive is not None:
            self._values["detect_origin_unresponsive"] = detect_origin_unresponsive
        if detect_origin_unresponsive_title is not None:
            self._values["detect_origin_unresponsive_title"] = detect_origin_unresponsive_title
        if locked is not None:
            self._values["locked"] = locked
        if object_unavailable_alternate_host is not None:
            self._values["object_unavailable_alternate_host"] = object_unavailable_alternate_host
        if object_unavailable_backup_host is not None:
            self._values["object_unavailable_backup_host"] = object_unavailable_backup_host
        if object_unavailable_blacklist_origin_ip is not None:
            self._values["object_unavailable_blacklist_origin_ip"] = object_unavailable_blacklist_origin_ip
        if object_unavailable_blacklist_window is not None:
            self._values["object_unavailable_blacklist_window"] = object_unavailable_blacklist_window
        if object_unavailable_change_protocol is not None:
            self._values["object_unavailable_change_protocol"] = object_unavailable_change_protocol
        if object_unavailable_detection_level is not None:
            self._values["object_unavailable_detection_level"] = object_unavailable_detection_level
        if object_unavailable_include_query_string is not None:
            self._values["object_unavailable_include_query_string"] = object_unavailable_include_query_string
        if object_unavailable_modified_path is not None:
            self._values["object_unavailable_modified_path"] = object_unavailable_modified_path
        if object_unavailable_modify_request_path is not None:
            self._values["object_unavailable_modify_request_path"] = object_unavailable_modify_request_path
        if object_unavailable_protocol is not None:
            self._values["object_unavailable_protocol"] = object_unavailable_protocol
        if object_unavailable_recovery is not None:
            self._values["object_unavailable_recovery"] = object_unavailable_recovery
        if object_unavailable_redirect_method is not None:
            self._values["object_unavailable_redirect_method"] = object_unavailable_redirect_method
        if object_unavailable_response_codes is not None:
            self._values["object_unavailable_response_codes"] = object_unavailable_response_codes
        if object_unavailable_retry_limit is not None:
            self._values["object_unavailable_retry_limit"] = object_unavailable_retry_limit
        if origin_unavailable_alternate_host is not None:
            self._values["origin_unavailable_alternate_host"] = origin_unavailable_alternate_host
        if origin_unavailable_backup_host is not None:
            self._values["origin_unavailable_backup_host"] = origin_unavailable_backup_host
        if origin_unavailable_blacklist_origin_ip is not None:
            self._values["origin_unavailable_blacklist_origin_ip"] = origin_unavailable_blacklist_origin_ip
        if origin_unavailable_blacklist_window is not None:
            self._values["origin_unavailable_blacklist_window"] = origin_unavailable_blacklist_window
        if origin_unavailable_change_protocol is not None:
            self._values["origin_unavailable_change_protocol"] = origin_unavailable_change_protocol
        if origin_unavailable_detection_level is not None:
            self._values["origin_unavailable_detection_level"] = origin_unavailable_detection_level
        if origin_unavailable_include_query_string is not None:
            self._values["origin_unavailable_include_query_string"] = origin_unavailable_include_query_string
        if origin_unavailable_modified_path is not None:
            self._values["origin_unavailable_modified_path"] = origin_unavailable_modified_path
        if origin_unavailable_modify_request_path is not None:
            self._values["origin_unavailable_modify_request_path"] = origin_unavailable_modify_request_path
        if origin_unavailable_protocol is not None:
            self._values["origin_unavailable_protocol"] = origin_unavailable_protocol
        if origin_unavailable_recovery is not None:
            self._values["origin_unavailable_recovery"] = origin_unavailable_recovery
        if origin_unavailable_redirect_method is not None:
            self._values["origin_unavailable_redirect_method"] = origin_unavailable_redirect_method
        if origin_unavailable_response_codes is not None:
            self._values["origin_unavailable_response_codes"] = origin_unavailable_response_codes
        if origin_unavailable_retry_limit is not None:
            self._values["origin_unavailable_retry_limit"] = origin_unavailable_retry_limit
        if origin_unresponsive_alternate_host is not None:
            self._values["origin_unresponsive_alternate_host"] = origin_unresponsive_alternate_host
        if origin_unresponsive_backup_host is not None:
            self._values["origin_unresponsive_backup_host"] = origin_unresponsive_backup_host
        if origin_unresponsive_blacklist_origin_ip is not None:
            self._values["origin_unresponsive_blacklist_origin_ip"] = origin_unresponsive_blacklist_origin_ip
        if origin_unresponsive_blacklist_window is not None:
            self._values["origin_unresponsive_blacklist_window"] = origin_unresponsive_blacklist_window
        if origin_unresponsive_change_protocol is not None:
            self._values["origin_unresponsive_change_protocol"] = origin_unresponsive_change_protocol
        if origin_unresponsive_detection_level is not None:
            self._values["origin_unresponsive_detection_level"] = origin_unresponsive_detection_level
        if origin_unresponsive_include_query_string is not None:
            self._values["origin_unresponsive_include_query_string"] = origin_unresponsive_include_query_string
        if origin_unresponsive_modified_path is not None:
            self._values["origin_unresponsive_modified_path"] = origin_unresponsive_modified_path
        if origin_unresponsive_modify_request_path is not None:
            self._values["origin_unresponsive_modify_request_path"] = origin_unresponsive_modify_request_path
        if origin_unresponsive_protocol is not None:
            self._values["origin_unresponsive_protocol"] = origin_unresponsive_protocol
        if origin_unresponsive_recovery is not None:
            self._values["origin_unresponsive_recovery"] = origin_unresponsive_recovery
        if origin_unresponsive_redirect_method is not None:
            self._values["origin_unresponsive_redirect_method"] = origin_unresponsive_redirect_method
        if origin_unresponsive_retry_limit is not None:
            self._values["origin_unresponsive_retry_limit"] = origin_unresponsive_retry_limit
        if other_options is not None:
            self._values["other_options"] = other_options
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cache_error_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, caches the error response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        '''
        result = self._values.get("cache_error_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_window(self) -> typing.Optional[builtins.str]:
        '''This sets error response's TTL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        '''
        result = self._values.get("cache_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_response_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the response code served to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        '''
        result = self._values.get("client_response_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_object_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin has content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        '''
        result = self._values.get("detect_object_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_object_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        '''
        result = self._values.get("detect_object_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unavailable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure failover settings when the origin server responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        '''
        result = self._values.get("detect_origin_unavailable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unavailable_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        '''
        result = self._values.get("detect_origin_unavailable_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def detect_origin_unresponsive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure what happens when the origin is unresponsive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        '''
        result = self._values.get("detect_origin_unresponsive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def detect_origin_unresponsive_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        '''
        result = self._values.get("detect_origin_unresponsive_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        '''
        result = self._values.get("object_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        '''
        result = self._values.get("object_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("object_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        '''
        result = self._values.get("object_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Changes the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        '''
        result = self._values.get("object_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        '''
        result = self._values.get("object_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        '''
        result = self._values.get("object_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        '''
        result = self._values.get("object_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to modify the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        '''
        result = self._values.get("object_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def object_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        '''
        result = self._values.get("object_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        '''
        result = self._values.get("object_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        '''
        result = self._values.get("object_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def object_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when there are content errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        '''
        result = self._values.get("object_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def object_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        '''
        result = self._values.get("object_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        '''
        result = self._values.get("origin_unavailable_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        '''
        result = self._values.get("origin_unavailable_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unavailable_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        '''
        result = self._values.get("origin_unavailable_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        '''
        result = self._values.get("origin_unavailable_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify ``RESPONSE_CODES``, the only available option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        '''
        result = self._values.get("origin_unavailable_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        '''
        result = self._values.get("origin_unavailable_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        '''
        result = self._values.get("origin_unavailable_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        '''
        result = self._values.get("origin_unavailable_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unavailable_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies either the ``HTTP`` or ``HTTPS`` protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        '''
        result = self._values.get("origin_unavailable_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        '''
        result = self._values.get("origin_unavailable_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unavailable_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies either a redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        '''
        result = self._values.get("origin_unavailable_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unavailable_response_codes(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of response codes identifying when the origin responds with errors.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        '''
        result = self._values.get("origin_unavailable_response_codes")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def origin_unavailable_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        '''
        result = self._values.get("origin_unavailable_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_alternate_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the redirect's destination hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        '''
        result = self._values.get("origin_unresponsive_alternate_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_backup_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the origin hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        '''
        result = self._values.get("origin_unresponsive_backup_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this blacklists the origin's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        '''
        result = self._values.get("origin_unresponsive_blacklist_origin_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_blacklist_window(self) -> typing.Optional[builtins.str]:
        '''This sets the delay before blacklisting an IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        '''
        result = self._values.get("origin_unresponsive_blacklist_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This allows you to change the request protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        '''
        result = self._values.get("origin_unresponsive_change_protocol")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_detection_level(self) -> typing.Optional[builtins.str]:
        '''Specify the level of response to slow origin connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        '''
        result = self._values.get("origin_unresponsive_detection_level")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this includes the original set of query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        '''
        result = self._values.get("origin_unresponsive_include_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_modified_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to form the new URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        '''
        result = self._values.get("origin_unresponsive_modified_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies the request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        '''
        result = self._values.get("origin_unresponsive_modify_request_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_unresponsive_protocol(self) -> typing.Optional[builtins.str]:
        '''Specifies which protocol to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        '''
        result = self._values.get("origin_unresponsive_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_recovery(self) -> typing.Optional[builtins.str]:
        '''This sets the recovery option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        '''
        result = self._values.get("origin_unresponsive_recovery")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_unresponsive_redirect_method(self) -> typing.Optional[jsii.Number]:
        '''Specifies the redirect response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        '''
        result = self._values.get("origin_unresponsive_redirect_method")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_unresponsive_retry_limit(self) -> typing.Optional[builtins.str]:
        '''Sets how many times to retry.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        '''
        result = self._values.get("origin_unresponsive_retry_limit")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def other_options(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        '''
        result = self._values.get("other_options")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c94216cea022b11a9bf2a8da80f3024f3e2b985ddfc6fa56b6bc613812df6a08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCacheErrorResponse")
    def reset_cache_error_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheErrorResponse", []))

    @jsii.member(jsii_name="resetCacheWindow")
    def reset_cache_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheWindow", []))

    @jsii.member(jsii_name="resetClientResponseCode")
    def reset_client_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientResponseCode", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailable")
    def reset_detect_object_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailable", []))

    @jsii.member(jsii_name="resetDetectObjectUnavailableTitle")
    def reset_detect_object_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectObjectUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailable")
    def reset_detect_origin_unavailable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailable", []))

    @jsii.member(jsii_name="resetDetectOriginUnavailableTitle")
    def reset_detect_origin_unavailable_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnavailableTitle", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsive")
    def reset_detect_origin_unresponsive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsive", []))

    @jsii.member(jsii_name="resetDetectOriginUnresponsiveTitle")
    def reset_detect_origin_unresponsive_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDetectOriginUnresponsiveTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetObjectUnavailableAlternateHost")
    def reset_object_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBackupHost")
    def reset_object_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistOriginIp")
    def reset_object_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetObjectUnavailableBlacklistWindow")
    def reset_object_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetObjectUnavailableChangeProtocol")
    def reset_object_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableDetectionLevel")
    def reset_object_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetObjectUnavailableIncludeQueryString")
    def reset_object_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifiedPath")
    def reset_object_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableModifyRequestPath")
    def reset_object_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetObjectUnavailableProtocol")
    def reset_object_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableProtocol", []))

    @jsii.member(jsii_name="resetObjectUnavailableRecovery")
    def reset_object_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRecovery", []))

    @jsii.member(jsii_name="resetObjectUnavailableRedirectMethod")
    def reset_object_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetObjectUnavailableResponseCodes")
    def reset_object_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetObjectUnavailableRetryLimit")
    def reset_object_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnavailableAlternateHost")
    def reset_origin_unavailable_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBackupHost")
    def reset_origin_unavailable_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistOriginIp")
    def reset_origin_unavailable_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnavailableBlacklistWindow")
    def reset_origin_unavailable_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnavailableChangeProtocol")
    def reset_origin_unavailable_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableDetectionLevel")
    def reset_origin_unavailable_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnavailableIncludeQueryString")
    def reset_origin_unavailable_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifiedPath")
    def reset_origin_unavailable_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableModifyRequestPath")
    def reset_origin_unavailable_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnavailableProtocol")
    def reset_origin_unavailable_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableProtocol", []))

    @jsii.member(jsii_name="resetOriginUnavailableRecovery")
    def reset_origin_unavailable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRecovery", []))

    @jsii.member(jsii_name="resetOriginUnavailableRedirectMethod")
    def reset_origin_unavailable_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnavailableResponseCodes")
    def reset_origin_unavailable_response_codes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableResponseCodes", []))

    @jsii.member(jsii_name="resetOriginUnavailableRetryLimit")
    def reset_origin_unavailable_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnavailableRetryLimit", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveAlternateHost")
    def reset_origin_unresponsive_alternate_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveAlternateHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBackupHost")
    def reset_origin_unresponsive_backup_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBackupHost", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistOriginIp")
    def reset_origin_unresponsive_blacklist_origin_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistOriginIp", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveBlacklistWindow")
    def reset_origin_unresponsive_blacklist_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveBlacklistWindow", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveChangeProtocol")
    def reset_origin_unresponsive_change_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveChangeProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveDetectionLevel")
    def reset_origin_unresponsive_detection_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveDetectionLevel", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveIncludeQueryString")
    def reset_origin_unresponsive_include_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveIncludeQueryString", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifiedPath")
    def reset_origin_unresponsive_modified_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifiedPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveModifyRequestPath")
    def reset_origin_unresponsive_modify_request_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveModifyRequestPath", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveProtocol")
    def reset_origin_unresponsive_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveProtocol", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRecovery")
    def reset_origin_unresponsive_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRecovery", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRedirectMethod")
    def reset_origin_unresponsive_redirect_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRedirectMethod", []))

    @jsii.member(jsii_name="resetOriginUnresponsiveRetryLimit")
    def reset_origin_unresponsive_retry_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginUnresponsiveRetryLimit", []))

    @jsii.member(jsii_name="resetOtherOptions")
    def reset_other_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOtherOptions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponseInput")
    def cache_error_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheErrorResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheWindowInput")
    def cache_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="clientResponseCodeInput")
    def client_response_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableInput")
    def detect_object_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectObjectUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitleInput")
    def detect_object_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectObjectUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableInput")
    def detect_origin_unavailable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnavailableInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitleInput")
    def detect_origin_unavailable_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnavailableTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveInput")
    def detect_origin_unresponsive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "detectOriginUnresponsiveInput"))

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitleInput")
    def detect_origin_unresponsive_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "detectOriginUnresponsiveTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHostInput")
    def object_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHostInput")
    def object_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIpInput")
    def object_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindowInput")
    def object_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocolInput")
    def object_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevelInput")
    def object_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryStringInput")
    def object_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPathInput")
    def object_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPathInput")
    def object_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "objectUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocolInput")
    def object_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecoveryInput")
    def object_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethodInput")
    def object_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "objectUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodesInput")
    def object_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "objectUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimitInput")
    def object_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHostInput")
    def origin_unavailable_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHostInput")
    def origin_unavailable_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIpInput")
    def origin_unavailable_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindowInput")
    def origin_unavailable_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocolInput")
    def origin_unavailable_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevelInput")
    def origin_unavailable_detection_level_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryStringInput")
    def origin_unavailable_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPathInput")
    def origin_unavailable_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPathInput")
    def origin_unavailable_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnavailableModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocolInput")
    def origin_unavailable_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecoveryInput")
    def origin_unavailable_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethodInput")
    def origin_unavailable_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnavailableRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodesInput")
    def origin_unavailable_response_codes_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "originUnavailableResponseCodesInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimitInput")
    def origin_unavailable_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnavailableRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHostInput")
    def origin_unresponsive_alternate_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveAlternateHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHostInput")
    def origin_unresponsive_backup_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBackupHostInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIpInput")
    def origin_unresponsive_blacklist_origin_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveBlacklistOriginIpInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindowInput")
    def origin_unresponsive_blacklist_window_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveBlacklistWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocolInput")
    def origin_unresponsive_change_protocol_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveChangeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevelInput")
    def origin_unresponsive_detection_level_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveDetectionLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryStringInput")
    def origin_unresponsive_include_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveIncludeQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPathInput")
    def origin_unresponsive_modified_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveModifiedPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPathInput")
    def origin_unresponsive_modify_request_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originUnresponsiveModifyRequestPathInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocolInput")
    def origin_unresponsive_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecoveryInput")
    def origin_unresponsive_recovery_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethodInput")
    def origin_unresponsive_redirect_method_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originUnresponsiveRedirectMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimitInput")
    def origin_unresponsive_retry_limit_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originUnresponsiveRetryLimitInput"))

    @builtins.property
    @jsii.member(jsii_name="otherOptionsInput")
    def other_options_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "otherOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorResponse")
    def cache_error_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheErrorResponse"))

    @cache_error_response.setter
    def cache_error_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__595f3c7c2b2ba64532c5811ecff8aacec96167c23591e70b7a5ab5dc5489b4c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheErrorResponse", value)

    @builtins.property
    @jsii.member(jsii_name="cacheWindow")
    def cache_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheWindow"))

    @cache_window.setter
    def cache_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f3ec238baa5990dd143a9437b6b8867e2a47d90e16bd69134cd8ee2d8a4a1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheWindow", value)

    @builtins.property
    @jsii.member(jsii_name="clientResponseCode")
    def client_response_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientResponseCode"))

    @client_response_code.setter
    def client_response_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc1cf89c7c13d31274913df861c9271158f1b82a4fe76fd130a971304d42451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailable")
    def detect_object_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectObjectUnavailable"))

    @detect_object_unavailable.setter
    def detect_object_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02953748a3f4beb3f54958cc913a62818dcddfd105a036a462f6639728ff2e06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectObjectUnavailableTitle")
    def detect_object_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectObjectUnavailableTitle"))

    @detect_object_unavailable_title.setter
    def detect_object_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aeab18a5be2c55bacda26cfc7ce98368fdad451335cb85c069a8f1e968c3788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectObjectUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailable")
    def detect_origin_unavailable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnavailable"))

    @detect_origin_unavailable.setter
    def detect_origin_unavailable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c4fd77795bc1977e46c5661a510a849a01381a41ee32098a8b5ec560a3f5c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailable", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnavailableTitle")
    def detect_origin_unavailable_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnavailableTitle"))

    @detect_origin_unavailable_title.setter
    def detect_origin_unavailable_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2fdb9e618138254636f107fd4b5766b290847d79e285ca840a536979a9bd2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnavailableTitle", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsive")
    def detect_origin_unresponsive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "detectOriginUnresponsive"))

    @detect_origin_unresponsive.setter
    def detect_origin_unresponsive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91dd92664a2b7608ffa469f48c25d7872564be9d5e758e582ff1e0f750250e52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsive", value)

    @builtins.property
    @jsii.member(jsii_name="detectOriginUnresponsiveTitle")
    def detect_origin_unresponsive_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "detectOriginUnresponsiveTitle"))

    @detect_origin_unresponsive_title.setter
    def detect_origin_unresponsive_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a93ba412b1f65f11b9970ec74cbb1c5f0da1b6a2e68efa86fefcd6d5ff2e409)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "detectOriginUnresponsiveTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca47058355d04895c5867261cd22323b89750f24f6fa51a5338b35cca87f1b88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableAlternateHost")
    def object_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableAlternateHost"))

    @object_unavailable_alternate_host.setter
    def object_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d2cd69f3d8c083c7ad6d654e9bdfd879eaa2209ba49a8347a5fc8597986b3b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBackupHost")
    def object_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBackupHost"))

    @object_unavailable_backup_host.setter
    def object_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fcf111b91bd21beb45b10867d4a4b3b1c6f03c8f3eb38ad8ba5de0834beccb5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistOriginIp")
    def object_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableBlacklistOriginIp"))

    @object_unavailable_blacklist_origin_ip.setter
    def object_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d68aed7f94af34f116d737698b4e1542b996c22a16a5cdbb1f19f8b0df67f5ea)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableBlacklistWindow")
    def object_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableBlacklistWindow"))

    @object_unavailable_blacklist_window.setter
    def object_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9df124629f1037ae5cfb5366e7ae4deb500fe8296c06e08e9d6da40fef890fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableChangeProtocol")
    def object_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableChangeProtocol"))

    @object_unavailable_change_protocol.setter
    def object_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bdc92b3c2e673eccc7ee356a5a455d8ae5a3642925d2ae1ce255b35786588ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableDetectionLevel")
    def object_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableDetectionLevel"))

    @object_unavailable_detection_level.setter
    def object_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d9600ff750596494a1a64dac16d6665fa5835c2e53bba371430669ba692b8a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableIncludeQueryString")
    def object_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableIncludeQueryString"))

    @object_unavailable_include_query_string.setter
    def object_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74e7bb80a8c8f9f3a720b619891d6db6ade4cd123f9aa4aa690dd9c69dae28f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifiedPath")
    def object_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableModifiedPath"))

    @object_unavailable_modified_path.setter
    def object_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49991d17c3cb6bab0f6048256d5cddfa3d189ae1c2034bb9057a31e83c67e089)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableModifyRequestPath")
    def object_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "objectUnavailableModifyRequestPath"))

    @object_unavailable_modify_request_path.setter
    def object_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1be7b3ae268277f0c1305a8a134feb00fd0417e73bf92be8ee857a12b2b62f3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableProtocol")
    def object_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableProtocol"))

    @object_unavailable_protocol.setter
    def object_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd4cf9d3282216a7961abb6335ca195bc3e79f510645dd02e5881d5e6ddd2def)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRecovery")
    def object_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRecovery"))

    @object_unavailable_recovery.setter
    def object_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d81bc80973146a331603c0f83fd32744eb00a0ddaff12cbfa34ba47f57c1d735)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRedirectMethod")
    def object_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "objectUnavailableRedirectMethod"))

    @object_unavailable_redirect_method.setter
    def object_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21726838e6425737050b033837a10a0aaf1c5d98a6eff15c57e8c3aa51e25b5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableResponseCodes")
    def object_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "objectUnavailableResponseCodes"))

    @object_unavailable_response_codes.setter
    def object_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1709aa465acb841b8549cad7329810d55355eed66ca2d607e0b7e5b492d8e569)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="objectUnavailableRetryLimit")
    def object_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectUnavailableRetryLimit"))

    @object_unavailable_retry_limit.setter
    def object_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__423e81e2e81639b2820428e888f478515f4111989718175a3c12644c1b33f3fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableAlternateHost")
    def origin_unavailable_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableAlternateHost"))

    @origin_unavailable_alternate_host.setter
    def origin_unavailable_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69b46d343fdc27ec48b80c50f8b4f8dcdb16f4f6620edfbd62c47c488a66d2f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBackupHost")
    def origin_unavailable_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBackupHost"))

    @origin_unavailable_backup_host.setter
    def origin_unavailable_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9cfd84a0a8e23034850fb662e59aa96f4fa24628b56dc370bf76402501fe916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistOriginIp")
    def origin_unavailable_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableBlacklistOriginIp"))

    @origin_unavailable_blacklist_origin_ip.setter
    def origin_unavailable_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cffef49ea72d037db749db2598598b55ddfe07e864a4d548451f2d9dd415325e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableBlacklistWindow")
    def origin_unavailable_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableBlacklistWindow"))

    @origin_unavailable_blacklist_window.setter
    def origin_unavailable_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__661fe96888fceda81f8e4269da318b6e45673a54f04223340eec4742e890031c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableChangeProtocol")
    def origin_unavailable_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableChangeProtocol"))

    @origin_unavailable_change_protocol.setter
    def origin_unavailable_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f19a3c327f250102f1f75158f843b1bdde79a93bfb260cefb8c79b2e114c62ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableDetectionLevel")
    def origin_unavailable_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableDetectionLevel"))

    @origin_unavailable_detection_level.setter
    def origin_unavailable_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7e2e87b1aec58776adadf25c72e79e726b0f952cfecc99d7013d94bd60f793a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableIncludeQueryString")
    def origin_unavailable_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableIncludeQueryString"))

    @origin_unavailable_include_query_string.setter
    def origin_unavailable_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acf6ede2fcb6cc89de7902190c4131bdb0e547a3b8673aecf03cc5c85d48f1cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifiedPath")
    def origin_unavailable_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableModifiedPath"))

    @origin_unavailable_modified_path.setter
    def origin_unavailable_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc72a8d412228c8902b0f68d5a83dc219c428f09658e91c0d911ebdd6ca5edb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableModifyRequestPath")
    def origin_unavailable_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnavailableModifyRequestPath"))

    @origin_unavailable_modify_request_path.setter
    def origin_unavailable_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7f6ac0a6e70e8e38fdf7a6da12c673f35eb1dc2a49a3a6ea22f71fddbf175c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableProtocol")
    def origin_unavailable_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableProtocol"))

    @origin_unavailable_protocol.setter
    def origin_unavailable_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab361e50ccf6144e462459f903c89c629736ed46a5cae92cb23ba5c1cf506ee1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRecovery")
    def origin_unavailable_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRecovery"))

    @origin_unavailable_recovery.setter
    def origin_unavailable_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0756048b03e36d6077b981d9f66ea824953bb9cc63b05d4b19a25a1f91b4c635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRedirectMethod")
    def origin_unavailable_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnavailableRedirectMethod"))

    @origin_unavailable_redirect_method.setter
    def origin_unavailable_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__044630fe69285ed751847990059a1d55315ff2a3a1a3ac1b3de4cf7ad7da2e95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableResponseCodes")
    def origin_unavailable_response_codes(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "originUnavailableResponseCodes"))

    @origin_unavailable_response_codes.setter
    def origin_unavailable_response_codes(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0df6cf3480b0a86a72e12696040d3e6435f5431717ba193e16162e21356a020)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableResponseCodes", value)

    @builtins.property
    @jsii.member(jsii_name="originUnavailableRetryLimit")
    def origin_unavailable_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnavailableRetryLimit"))

    @origin_unavailable_retry_limit.setter
    def origin_unavailable_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa626c8d07b8335eb8134eb73f1e2bcd0f411784980aa038416b078310b9959)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnavailableRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveAlternateHost")
    def origin_unresponsive_alternate_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveAlternateHost"))

    @origin_unresponsive_alternate_host.setter
    def origin_unresponsive_alternate_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a12552ce24cf6a12d67f034628f63138c5b7255510e3039975b2c9ddf6db153)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveAlternateHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBackupHost")
    def origin_unresponsive_backup_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBackupHost"))

    @origin_unresponsive_backup_host.setter
    def origin_unresponsive_backup_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48ad64e8526fc321f5baa40f7f12085404869d051cac4b8ca05c4f9b3ee67bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBackupHost", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistOriginIp")
    def origin_unresponsive_blacklist_origin_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveBlacklistOriginIp"))

    @origin_unresponsive_blacklist_origin_ip.setter
    def origin_unresponsive_blacklist_origin_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__762d488d37fd8dba64cc3bd8690b375475d9a490f1474a8eb3117e4a802b7af2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistOriginIp", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveBlacklistWindow")
    def origin_unresponsive_blacklist_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveBlacklistWindow"))

    @origin_unresponsive_blacklist_window.setter
    def origin_unresponsive_blacklist_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e772d22a808545aa34a163a4a741c7dff3a81e11d4573102a24401f0714e2a71)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveBlacklistWindow", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveChangeProtocol")
    def origin_unresponsive_change_protocol(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveChangeProtocol"))

    @origin_unresponsive_change_protocol.setter
    def origin_unresponsive_change_protocol(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d23ab7cc134658579f19e29d9dbafdcd13488995fad36a62d6ce0f5d7e3fdaca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveChangeProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveDetectionLevel")
    def origin_unresponsive_detection_level(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveDetectionLevel"))

    @origin_unresponsive_detection_level.setter
    def origin_unresponsive_detection_level(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe9a5754bfac4030091a7b9a4fc0fde46078aa57e16cbaf3164df168dbaa4b02)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveDetectionLevel", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveIncludeQueryString")
    def origin_unresponsive_include_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveIncludeQueryString"))

    @origin_unresponsive_include_query_string.setter
    def origin_unresponsive_include_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eac1854929cdf1365ab7b110077c837ce17b3e41067e175516229d748bd62c3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveIncludeQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifiedPath")
    def origin_unresponsive_modified_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveModifiedPath"))

    @origin_unresponsive_modified_path.setter
    def origin_unresponsive_modified_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__671c32c3ce7e22c4129690d62243f7d34dc35207652350222bd281513a1ba2a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifiedPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveModifyRequestPath")
    def origin_unresponsive_modify_request_path(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originUnresponsiveModifyRequestPath"))

    @origin_unresponsive_modify_request_path.setter
    def origin_unresponsive_modify_request_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c241d9647e20aca543d64ede5002528da36bf601aaae7ba5503a4cbd5911ac75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveModifyRequestPath", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveProtocol")
    def origin_unresponsive_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveProtocol"))

    @origin_unresponsive_protocol.setter
    def origin_unresponsive_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__754eeb16f93303ba14884daa479b64cd23c4979eed587f592e0194f4d129be39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRecovery")
    def origin_unresponsive_recovery(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRecovery"))

    @origin_unresponsive_recovery.setter
    def origin_unresponsive_recovery(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb39f2e9d797d84f68b521ea7ad5f389a53f662fb1f99ce277ebab3682d246d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRedirectMethod")
    def origin_unresponsive_redirect_method(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originUnresponsiveRedirectMethod"))

    @origin_unresponsive_redirect_method.setter
    def origin_unresponsive_redirect_method(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__162985e02e825882241d7e75714207ae525c369c53758a710612b60ed8566857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRedirectMethod", value)

    @builtins.property
    @jsii.member(jsii_name="originUnresponsiveRetryLimit")
    def origin_unresponsive_retry_limit(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originUnresponsiveRetryLimit"))

    @origin_unresponsive_retry_limit.setter
    def origin_unresponsive_retry_limit(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b04dc87796c7352fac3d3c7a965e0fac23d3addf21f320593ef64c00dd51fc45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originUnresponsiveRetryLimit", value)

    @builtins.property
    @jsii.member(jsii_name="otherOptions")
    def other_options(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "otherOptions"))

    @other_options.setter
    def other_options(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad12210a9aa3b9c739691cdc1fe895ef8e7d417bf1c46217be86772f1d19ada)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "otherOptions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff499eaec8257372d38e52bcdf9d042c3f35fdb438b740cf7c96109429de5750)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__965cb376b9d0941eeac4207b5c051eed2fbf78df5aeba36f59ad5711bbf68774)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cc4b8506f2a68328ad0a3978da860e7172b669924f21b8082adfd6e93c94e1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2abf60bf510270676e8f8a1a93e3248a0f9dffae508f9ff13017ca617f60f21f)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables metadata caching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baf08814f4636d658f6b50b34778951eb51f183df217c8281b17e0c2fd94e158)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa22adfd2032014530d496d6fc6d910b96d89c256c12d447e654032e3c29f199)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af9cd6415ba5ade9ff2351aee09d15d6552cfcde7c92df714432a83e72e9e3e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04802100ccd5233d0bf44862b7de46f0d3aba5e368a53e63aec92ee096135276)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18585fbbac6792b260efc7afbd43b08a91bb69c3b810da05ae734689235f4b89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d52f7f81baf429b1709c11f9435c50e3088d35a069c78d2cbcec070ab22511)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "secondary_multipath_to_origin": "secondaryMultipathToOrigin",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9540fb67b745e15807bb4ffb545afe6e3832fd37918c93255575ad4cbc6ef780)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument secondary_multipath_to_origin", value=secondary_multipath_to_origin, expected_type=type_hints["secondary_multipath_to_origin"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if secondary_multipath_to_origin is not None:
            self._values["secondary_multipath_to_origin"] = secondary_multipath_to_origin
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Mobile App Performance SDK.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends secondary multi-path requests to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        '''
        result = self._values.get("secondary_multipath_to_origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformanceOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformanceOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31189cba8ce10dc2622cfa817770f9cd75fc642eee93c5aeca44aa56c37d7e10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSecondaryMultipathToOrigin")
    def reset_secondary_multipath_to_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondaryMultipathToOrigin", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOriginInput")
    def secondary_multipath_to_origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondaryMultipathToOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f89798c6196e3cbdb6790f48ee05661b2d403c9950bc2e5455ed7228e9437d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecd3d1b0a473a2c291edaa589f5c48fc6cad92064874b2722d49942bc236f202)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="secondaryMultipathToOrigin")
    def secondary_multipath_to_origin(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondaryMultipathToOrigin"))

    @secondary_multipath_to_origin.setter
    def secondary_multipath_to_origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c123d15d9f64f4cc46579e675dc5ab7fe700db9bda76c5e0de2347272981c85c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondaryMultipathToOrigin", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__969d763dead419cfe3f9770ec6858540c2adde7674a6b6e029b2d9f5b9191433)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5131cf6aa6058d3d4e2aef4b8b4d7d489952cd726f90e18e9391612062b404b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93d59c2a0dc082109d04d73e53612293bca3cd893f5eaf544d85736e53a95027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e02af80433b4b1e58849b2b412879102b8a4f8cf3c8a50410f73072d85a3deac)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Supplies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a12bebf8c662094cb7cae91ae6e9dec37dfa903a89cf3a3ddcc9f526e086f7ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__639d65801ed2c725948c064d28a815462f723bceda8203da81ddb2b7aae9769b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb70395d6da3bb4a167e8ad73d3bcfc995016b77a90c93dbd744c71eb321ca6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b8ad99bd9885271b20c3f3e2d213d2d99b02fb77e2635983eb847001ad9730f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cba60dd0c676bcbb46dab788324b0ce512b655e7e58817dcd6b58894469e2b20)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4053ae7d15e5fed28f2465246fc9076da30c0d31fb0f09de2e72b03da431665)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f080c35f2a2a3456a4cbec7a39b1e3c0b81a8357f764c3ada3d4a82205439f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78b44b1b43120986cba302fabd37c819307dd0a9bf050b38379319163dd9e8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc79e29fc96eb112c8f3c54812229160868ac93e2e37ea8a18aff55f7fe2cc40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c067b4f138763f5a5a665efc568186d4863bf8a93c898291d85f9c7fc8af61b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb6e24b98a4824a5669b47c3a254950b10b7bee81b1a070560c42b8d37f158f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0360cec6f0b3a0303da24981e3f4703f468312ca2e88eaa191a969291d90f04a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71754393addbe5ece715f0420b3c840c9f39f59746b1e935eb8159062b5b5eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1311abc5b204477f9f610dc48c95087df2f27b3fa40562b9775a90f43beacef5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "new_header_value": "newHeaderValue",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "standard_pass_header_name": "standardPassHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1c4fdd08b308b1b914a2f7acf52e5fa90942858d2c8d501eecc51b04bac8a69)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument standard_pass_header_name", value=standard_pass_header_name, expected_type=type_hints["standard_pass_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if standard_pass_header_name is not None:
            self._values["standard_pass_header_name"] = standard_pass_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the header's new value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_pass_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        '''
        result = self._values.get("standard_pass_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__786e8544836be59a497ba51027c08d6f9bafff63ffb9b1303f2ae88e42ed6c13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetStandardPassHeaderName")
    def reset_standard_pass_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardPassHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderNameInput")
    def standard_pass_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardPassHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc7289174966e5133a0b7d233ea14987e51d8fbdeba68cc48de444d48a0b1a82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__283c213819e432526e0db235f3b597b7293b9be2c8255bffeb36cea6eb423586)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18752f8cc817455ee2613148343a63c2cd97f68104a8901fa09911fe0c6fc6f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf27d25af3cfbadce5bf4693d2eed660d062b3750b23372ea304f88e428fca9a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3f86b30aa303f76c72174192e397e85eea6130de9831ab6353261c52024c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ff715191905caff32594f9992e14fcd55ea8f8b379cec2e44cf6555bb5563a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1536c02036485d61bd29523424fe5941d91c9f68b24f7f4b651fba80d72e65cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b53d427345d405af25d9c12bb4f3179df176f1f0d62dd069148b9898425a23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce0aeb7f65f06bd9782ef128fcae198a64679f7c2b87dde9c80b9923c8ec5327)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardPassHeaderName")
    def standard_pass_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardPassHeaderName"))

    @standard_pass_header_name.setter
    def standard_pass_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ca5b653cd83e2f4f826c4293046b9fcf9a4b60e97b1b17de2a281f9d966c3d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardPassHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c78c6e052798f6496e9710598778c23735184365158d4015da0dd22ce5a5ec3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d32ea76b8cf412cafcf276c4dac9b8a083a288db2ad9a9771733cacdceb07d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025b1050a0eb6f29dd4911168ce86ac499ac5b88ada9a3ae9422dea1a51e8184)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__909e31f7f101958683faa24fd7b6408f98f90b9c39fe649ba17a5185298d08cd)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies an HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93c5ccb541c3b04beb60b5c705a4a5a9bf7265cd9d010075d1b13a657e5e3f3a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9f23dd47469890d6599dd98d9c4aac21363b7e7796b0950b6d372b68d53a7dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97c77879498b40c6de6d55e352fa400b4c182678fddf0ed85c637c253c09929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dc7c7aec75b179b447b7529785fef5750d2fb32a6c2d928f981fd99780c22d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db4268efcf83151fbdc36de14c7fee2711c4fe16589d85fcb58703045922625a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98afcde48929e52f9f7dd554d3c18c74b9e3dfcff84257430d6704d1f5def379)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e4723bb23e84e23628c729f8d5f0f3566032ac6f645a9a3df51ff3e2d9d0915)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421be889610b93c343929cbb0cf94bb081aed29643baede0fdbc5794b5949bdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dae8721413b9d5a006dfd067bfe0a72e9d767b2620977fc5262ce27df416e0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b74df4a7e45da27d7f43c0a54b88f34760514394f941c4e59af65dad02ef9638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f62dbea4aaacaef4f01133a27025be13b10fd8fed961f6bc270ede7dc9e005b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1be0ba97eb6d2674b4f850c03884a2a86cb0904472085206ff37598528ed0359)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8ae527aa0e25ca74b37f64d94c9f6fc43cc8e9b16702cbbd9f07092378c5f14f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de60b0eda11859624dce910f5d333e69d5b10dac5d1fd1541a8fd65da8d87de0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd557b035b69c4e573605b75afbb9c57d55d6aa908d9b8d690e33312f8b6b4ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78aed3e20ac9fae68ecd160eac6efe57a7ab405c913dd01ee980ffce35c4e8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "action": "action",
        "avoid_duplicate_headers": "avoidDuplicateHeaders",
        "custom_header_name": "customHeaderName",
        "header_value": "headerValue",
        "locked": "locked",
        "match_multiple": "matchMultiple",
        "new_header_value": "newHeaderValue",
        "regex_header_match": "regexHeaderMatch",
        "regex_header_replace": "regexHeaderReplace",
        "standard_add_header_name": "standardAddHeaderName",
        "standard_delete_header_name": "standardDeleteHeaderName",
        "standard_modify_header_name": "standardModifyHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader:
    def __init__(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d14cf0b1de8ff62acaba4532db1fac3cbbe9191314a95c9d705d388ec9f7892)
            check_type(argname="argument action", value=action, expected_type=type_hints["action"])
            check_type(argname="argument avoid_duplicate_headers", value=avoid_duplicate_headers, expected_type=type_hints["avoid_duplicate_headers"])
            check_type(argname="argument custom_header_name", value=custom_header_name, expected_type=type_hints["custom_header_name"])
            check_type(argname="argument header_value", value=header_value, expected_type=type_hints["header_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument new_header_value", value=new_header_value, expected_type=type_hints["new_header_value"])
            check_type(argname="argument regex_header_match", value=regex_header_match, expected_type=type_hints["regex_header_match"])
            check_type(argname="argument regex_header_replace", value=regex_header_replace, expected_type=type_hints["regex_header_replace"])
            check_type(argname="argument standard_add_header_name", value=standard_add_header_name, expected_type=type_hints["standard_add_header_name"])
            check_type(argname="argument standard_delete_header_name", value=standard_delete_header_name, expected_type=type_hints["standard_delete_header_name"])
            check_type(argname="argument standard_modify_header_name", value=standard_modify_header_name, expected_type=type_hints["standard_modify_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if action is not None:
            self._values["action"] = action
        if avoid_duplicate_headers is not None:
            self._values["avoid_duplicate_headers"] = avoid_duplicate_headers
        if custom_header_name is not None:
            self._values["custom_header_name"] = custom_header_name
        if header_value is not None:
            self._values["header_value"] = header_value
        if locked is not None:
            self._values["locked"] = locked
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if new_header_value is not None:
            self._values["new_header_value"] = new_header_value
        if regex_header_match is not None:
            self._values["regex_header_match"] = regex_header_match
        if regex_header_replace is not None:
            self._values["regex_header_replace"] = regex_header_replace
        if standard_add_header_name is not None:
            self._values["standard_add_header_name"] = standard_add_header_name
        if standard_delete_header_name is not None:
            self._values["standard_delete_header_name"] = standard_delete_header_name
        if standard_modify_header_name is not None:
            self._values["standard_modify_header_name"] = standard_modify_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def action(self) -> typing.Optional[builtins.str]:
        '''Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        '''
        result = self._values.get("action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def avoid_duplicate_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header.

        The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        '''
        result = self._values.get("avoid_duplicate_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        '''
        result = self._values.get("custom_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the existing value of the header to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        '''
        result = self._values.get("header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def new_header_value(self) -> typing.Optional[builtins.str]:
        '''Specifies the new HTTP header replacement value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        '''
        result = self._values.get("new_header_value")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_match(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression to match within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        '''
        result = self._values.get("regex_header_match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex_header_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        '''
        result = self._values.get("regex_header_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_add_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``ADD``, this specifies the name of the field to add.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        '''
        result = self._values.get("standard_add_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_delete_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        '''
        result = self._values.get("standard_delete_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def standard_modify_header_name(self) -> typing.Optional[builtins.str]:
        '''If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        '''
        result = self._values.get("standard_modify_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e9734a172f7daa4cccfb94c0db7412a749e514089e6e501604998bae8a2827ab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAction")
    def reset_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAction", []))

    @jsii.member(jsii_name="resetAvoidDuplicateHeaders")
    def reset_avoid_duplicate_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAvoidDuplicateHeaders", []))

    @jsii.member(jsii_name="resetCustomHeaderName")
    def reset_custom_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeaderName", []))

    @jsii.member(jsii_name="resetHeaderValue")
    def reset_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetNewHeaderValue")
    def reset_new_header_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNewHeaderValue", []))

    @jsii.member(jsii_name="resetRegexHeaderMatch")
    def reset_regex_header_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderMatch", []))

    @jsii.member(jsii_name="resetRegexHeaderReplace")
    def reset_regex_header_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegexHeaderReplace", []))

    @jsii.member(jsii_name="resetStandardAddHeaderName")
    def reset_standard_add_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardAddHeaderName", []))

    @jsii.member(jsii_name="resetStandardDeleteHeaderName")
    def reset_standard_delete_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardDeleteHeaderName", []))

    @jsii.member(jsii_name="resetStandardModifyHeaderName")
    def reset_standard_modify_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardModifyHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="actionInput")
    def action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "actionInput"))

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeadersInput")
    def avoid_duplicate_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "avoidDuplicateHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderNameInput")
    def custom_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerValueInput")
    def header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="newHeaderValueInput")
    def new_header_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "newHeaderValueInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatchInput")
    def regex_header_match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplaceInput")
    def regex_header_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexHeaderReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderNameInput")
    def standard_add_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardAddHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderNameInput")
    def standard_delete_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardDeleteHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderNameInput")
    def standard_modify_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "standardModifyHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="action")
    def action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "action"))

    @action.setter
    def action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9c8a75c4d6ba0f7c8d64913676024083c21d24611bf9742ce9bd6c1b2776fc65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "action", value)

    @builtins.property
    @jsii.member(jsii_name="avoidDuplicateHeaders")
    def avoid_duplicate_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "avoidDuplicateHeaders"))

    @avoid_duplicate_headers.setter
    def avoid_duplicate_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94f58a549cf27c1ed6ecc885455fd9bb7e622477af5e094491463a64b2206bf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "avoidDuplicateHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="customHeaderName")
    def custom_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customHeaderName"))

    @custom_header_name.setter
    def custom_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f35c31df6db56a53c2ea13dab5ca254f74c9f004d603d94393782ea7114f47e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="headerValue")
    def header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerValue"))

    @header_value.setter
    def header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2dd82d18d08c7020a54e6f5fea195375f2595cf8f22f77184e9b5009c878b334)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9555f413b61f32f033fac2772e8f73cc407f39a852d8f316bf4c2e34838a4e6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29d39367c567e2c4999b52220d01e4ee54698d4cd5d5bf4546164e57797a9d9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="newHeaderValue")
    def new_header_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "newHeaderValue"))

    @new_header_value.setter
    def new_header_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1580ec9113ea8f290785e0e6fb5015244f0ffda64f6f8d85a8b47a160eb6c557)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "newHeaderValue", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderMatch")
    def regex_header_match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderMatch"))

    @regex_header_match.setter
    def regex_header_match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1dc8b05cd9af1fbca8a336572ff7d5ee789722f095c0019f5a195e664ceb804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderMatch", value)

    @builtins.property
    @jsii.member(jsii_name="regexHeaderReplace")
    def regex_header_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regexHeaderReplace"))

    @regex_header_replace.setter
    def regex_header_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7083721112af575851c33cd5b906a20c3cd0ecb8ad836a1eb3b34a1d698abc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regexHeaderReplace", value)

    @builtins.property
    @jsii.member(jsii_name="standardAddHeaderName")
    def standard_add_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardAddHeaderName"))

    @standard_add_header_name.setter
    def standard_add_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bd88ddfdede8911f269278a173c12ef83a9b4a331576fce77f554acd6a52132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardAddHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardDeleteHeaderName")
    def standard_delete_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardDeleteHeaderName"))

    @standard_delete_header_name.setter
    def standard_delete_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b366bcb56f216b976142cfac3eb9b75d1607567c0ef498c8fe59869cbe98c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardDeleteHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="standardModifyHeaderName")
    def standard_modify_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "standardModifyHeaderName"))

    @standard_modify_header_name.setter
    def standard_modify_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a351398147e53989524febfa4c79fd6c4df1e1d4bd73eba98218b5f4a0c3c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardModifyHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f24cc5acb95368ec806d629c0684ad19ca13b486b1282505d06598cb9076b41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99bc0ceae0b943b139b0eb9b1fa024127afea3145204c06ab492718d0402a319)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__524f57847d4ac97a0cd32adc2dda6864f6fbd8754db03ae3378633b66df16ad8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "modification_option": "modificationOption",
        "rename_header_to": "renameHeaderTo",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8a11408500ecfbdd941f4f18656d41723250492dd24d278c04cd4db499e9d33)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modification_option", value=modification_option, expected_type=type_hints["modification_option"])
            check_type(argname="argument rename_header_to", value=rename_header_to, expected_type=type_hints["rename_header_to"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if modification_option is not None:
            self._values["modification_option"] = modification_option
        if rename_header_to is not None:
            self._values["rename_header_to"] = rename_header_to
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``Via`` header modifications.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modification_option(self) -> typing.Optional[builtins.str]:
        '''Specify how you want to handle the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        '''
        result = self._values.get("modification_option")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rename_header_to(self) -> typing.Optional[builtins.str]:
        '''Specifies a new name to replace the existing ``Via`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        '''
        result = self._values.get("rename_header_to")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b482be1b7370eb0040984e9ece19bb9b36c89925cf876c0903d9983f553eb42)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModificationOption")
    def reset_modification_option(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModificationOption", []))

    @jsii.member(jsii_name="resetRenameHeaderTo")
    def reset_rename_header_to(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRenameHeaderTo", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modificationOptionInput")
    def modification_option_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "modificationOptionInput"))

    @builtins.property
    @jsii.member(jsii_name="renameHeaderToInput")
    def rename_header_to_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "renameHeaderToInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ea007679b23441356a13aa199b02fbd5abfe9b948e50c8980ff7d00fae3a260)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99fcf11a2af0bd7fef62dfdd36e8b301d0aab463dc3602076ac82bff94d8289f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modificationOption")
    def modification_option(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "modificationOption"))

    @modification_option.setter
    def modification_option(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fffcc8848f279ae9d19c05033e4a97af2694a41c9f8f4a98895309c3b77306b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modificationOption", value)

    @builtins.property
    @jsii.member(jsii_name="renameHeaderTo")
    def rename_header_to(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "renameHeaderTo"))

    @rename_header_to.setter
    def rename_header_to(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad26a2beb0a362b19f7dc1b1ca672ad51c9501890d1cdd77d647415f9d36f0cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "renameHeaderTo", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5291a770ae94e8c3c8825c181811427dd0c5f5ca334dcbbc01ffc6f3e1c5f4f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13e2ec7fb0f0615cdfee3ff52d14d0f5009de7ef85bfdbc11484273648d0bd01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e565319a8425f2cea3085a5bab785ee6eb1dd15cdfb25285b6a0191bc81622d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "cache_key_hostname": "cacheKeyHostname",
        "compress": "compress",
        "custom_certificate_authorities": "customCertificateAuthorities",
        "custom_certificates": "customCertificates",
        "custom_forward_host_header": "customForwardHostHeader",
        "custom_valid_cn_values": "customValidCnValues",
        "enable_true_client_ip": "enableTrueClientIp",
        "forward_host_header": "forwardHostHeader",
        "hostname": "hostname",
        "http_port": "httpPort",
        "https_port": "httpsPort",
        "ip_version": "ipVersion",
        "locked": "locked",
        "max_tls_version": "maxTlsVersion",
        "min_tls_version": "minTlsVersion",
        "mslorigin": "mslorigin",
        "net_storage": "netStorage",
        "origin_certificate": "originCertificate",
        "origin_certs_to_honor": "originCertsToHonor",
        "origin_id": "originId",
        "origin_sni": "originSni",
        "origin_type": "originType",
        "ports": "ports",
        "saas_cname_enabled": "saasCnameEnabled",
        "saas_cname_level": "saasCnameLevel",
        "saas_cookie": "saasCookie",
        "saas_query_string": "saasQueryString",
        "saas_regex": "saasRegex",
        "saas_replace": "saasReplace",
        "saas_suffix": "saasSuffix",
        "saas_type": "saasType",
        "second_hostname": "secondHostname",
        "second_hostname_enabled": "secondHostnameEnabled",
        "standard_certificate_authorities": "standardCertificateAuthorities",
        "template_uuid": "templateUuid",
        "tls13_support": "tls13Support",
        "tls_version_title": "tlsVersionTitle",
        "true_client_ip_client_setting": "trueClientIpClientSetting",
        "true_client_ip_header": "trueClientIpHeader",
        "use_unique_cache_key": "useUniqueCacheKey",
        "uuid": "uuid",
        "verification_mode": "verificationMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin:
    def __init__(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates", typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_tls_version: typing.Optional[builtins.str] = None,
        min_tls_version: typing.Optional[builtins.str] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tls_version_title: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_tls_version: Specifies the maximum TLS version to use for connections to your origin server. As best practice, use ``DYNAMIC`` to automatically apply the latest supported version. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        :param min_tls_version: Specifies the minimum TLS version to use for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tls13_support: Enables transport layer security (TLS) version 1.3 for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        :param tls_version_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b371ff458ffc0824504ff224bc0398fb39ea7311c22d6a4e3d09c6be707c5fe1)
            check_type(argname="argument cache_key_hostname", value=cache_key_hostname, expected_type=type_hints["cache_key_hostname"])
            check_type(argname="argument compress", value=compress, expected_type=type_hints["compress"])
            check_type(argname="argument custom_certificate_authorities", value=custom_certificate_authorities, expected_type=type_hints["custom_certificate_authorities"])
            check_type(argname="argument custom_certificates", value=custom_certificates, expected_type=type_hints["custom_certificates"])
            check_type(argname="argument custom_forward_host_header", value=custom_forward_host_header, expected_type=type_hints["custom_forward_host_header"])
            check_type(argname="argument custom_valid_cn_values", value=custom_valid_cn_values, expected_type=type_hints["custom_valid_cn_values"])
            check_type(argname="argument enable_true_client_ip", value=enable_true_client_ip, expected_type=type_hints["enable_true_client_ip"])
            check_type(argname="argument forward_host_header", value=forward_host_header, expected_type=type_hints["forward_host_header"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument http_port", value=http_port, expected_type=type_hints["http_port"])
            check_type(argname="argument https_port", value=https_port, expected_type=type_hints["https_port"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max_tls_version", value=max_tls_version, expected_type=type_hints["max_tls_version"])
            check_type(argname="argument min_tls_version", value=min_tls_version, expected_type=type_hints["min_tls_version"])
            check_type(argname="argument mslorigin", value=mslorigin, expected_type=type_hints["mslorigin"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument origin_certificate", value=origin_certificate, expected_type=type_hints["origin_certificate"])
            check_type(argname="argument origin_certs_to_honor", value=origin_certs_to_honor, expected_type=type_hints["origin_certs_to_honor"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument origin_sni", value=origin_sni, expected_type=type_hints["origin_sni"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument ports", value=ports, expected_type=type_hints["ports"])
            check_type(argname="argument saas_cname_enabled", value=saas_cname_enabled, expected_type=type_hints["saas_cname_enabled"])
            check_type(argname="argument saas_cname_level", value=saas_cname_level, expected_type=type_hints["saas_cname_level"])
            check_type(argname="argument saas_cookie", value=saas_cookie, expected_type=type_hints["saas_cookie"])
            check_type(argname="argument saas_query_string", value=saas_query_string, expected_type=type_hints["saas_query_string"])
            check_type(argname="argument saas_regex", value=saas_regex, expected_type=type_hints["saas_regex"])
            check_type(argname="argument saas_replace", value=saas_replace, expected_type=type_hints["saas_replace"])
            check_type(argname="argument saas_suffix", value=saas_suffix, expected_type=type_hints["saas_suffix"])
            check_type(argname="argument saas_type", value=saas_type, expected_type=type_hints["saas_type"])
            check_type(argname="argument second_hostname", value=second_hostname, expected_type=type_hints["second_hostname"])
            check_type(argname="argument second_hostname_enabled", value=second_hostname_enabled, expected_type=type_hints["second_hostname_enabled"])
            check_type(argname="argument standard_certificate_authorities", value=standard_certificate_authorities, expected_type=type_hints["standard_certificate_authorities"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tls13_support", value=tls13_support, expected_type=type_hints["tls13_support"])
            check_type(argname="argument tls_version_title", value=tls_version_title, expected_type=type_hints["tls_version_title"])
            check_type(argname="argument true_client_ip_client_setting", value=true_client_ip_client_setting, expected_type=type_hints["true_client_ip_client_setting"])
            check_type(argname="argument true_client_ip_header", value=true_client_ip_header, expected_type=type_hints["true_client_ip_header"])
            check_type(argname="argument use_unique_cache_key", value=use_unique_cache_key, expected_type=type_hints["use_unique_cache_key"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_mode", value=verification_mode, expected_type=type_hints["verification_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cache_key_hostname is not None:
            self._values["cache_key_hostname"] = cache_key_hostname
        if compress is not None:
            self._values["compress"] = compress
        if custom_certificate_authorities is not None:
            self._values["custom_certificate_authorities"] = custom_certificate_authorities
        if custom_certificates is not None:
            self._values["custom_certificates"] = custom_certificates
        if custom_forward_host_header is not None:
            self._values["custom_forward_host_header"] = custom_forward_host_header
        if custom_valid_cn_values is not None:
            self._values["custom_valid_cn_values"] = custom_valid_cn_values
        if enable_true_client_ip is not None:
            self._values["enable_true_client_ip"] = enable_true_client_ip
        if forward_host_header is not None:
            self._values["forward_host_header"] = forward_host_header
        if hostname is not None:
            self._values["hostname"] = hostname
        if http_port is not None:
            self._values["http_port"] = http_port
        if https_port is not None:
            self._values["https_port"] = https_port
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if locked is not None:
            self._values["locked"] = locked
        if max_tls_version is not None:
            self._values["max_tls_version"] = max_tls_version
        if min_tls_version is not None:
            self._values["min_tls_version"] = min_tls_version
        if mslorigin is not None:
            self._values["mslorigin"] = mslorigin
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if origin_certificate is not None:
            self._values["origin_certificate"] = origin_certificate
        if origin_certs_to_honor is not None:
            self._values["origin_certs_to_honor"] = origin_certs_to_honor
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if origin_sni is not None:
            self._values["origin_sni"] = origin_sni
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if ports is not None:
            self._values["ports"] = ports
        if saas_cname_enabled is not None:
            self._values["saas_cname_enabled"] = saas_cname_enabled
        if saas_cname_level is not None:
            self._values["saas_cname_level"] = saas_cname_level
        if saas_cookie is not None:
            self._values["saas_cookie"] = saas_cookie
        if saas_query_string is not None:
            self._values["saas_query_string"] = saas_query_string
        if saas_regex is not None:
            self._values["saas_regex"] = saas_regex
        if saas_replace is not None:
            self._values["saas_replace"] = saas_replace
        if saas_suffix is not None:
            self._values["saas_suffix"] = saas_suffix
        if saas_type is not None:
            self._values["saas_type"] = saas_type
        if second_hostname is not None:
            self._values["second_hostname"] = second_hostname
        if second_hostname_enabled is not None:
            self._values["second_hostname_enabled"] = second_hostname_enabled
        if standard_certificate_authorities is not None:
            self._values["standard_certificate_authorities"] = standard_certificate_authorities
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tls13_support is not None:
            self._values["tls13_support"] = tls13_support
        if tls_version_title is not None:
            self._values["tls_version_title"] = tls_version_title
        if true_client_ip_client_setting is not None:
            self._values["true_client_ip_client_setting"] = true_client_ip_client_setting
        if true_client_ip_header is not None:
            self._values["true_client_ip_header"] = true_client_ip_header
        if use_unique_cache_key is not None:
            self._values["use_unique_cache_key"] = use_unique_cache_key
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_mode is not None:
            self._values["verification_mode"] = verification_mode

    @builtins.property
    def cache_key_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname to use when forming a cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        '''
        result = self._values.get("cache_key_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def compress(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``gzip`` compression for non-NetStorage origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        '''
        result = self._values.get("compress")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_certificate_authorities(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities"]]]:
        '''custom_certificate_authorities block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        '''
        result = self._values.get("custom_certificate_authorities")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities"]]], result)

    @builtins.property
    def custom_certificates(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates"]]]:
        '''custom_certificates block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        '''
        result = self._values.get("custom_certificates")
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates"]]], result)

    @builtins.property
    def custom_forward_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the custom host header the edge server should pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        '''
        result = self._values.get("custom_forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_valid_cn_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields.

        Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        '''
        result = self._values.get("custom_valid_cn_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enable_true_client_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server.

        This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        '''
        result = self._values.get("enable_true_client_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def forward_host_header(self) -> typing.Optional[builtins.str]:
        '''When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        '''
        result = self._values.get("forward_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        '''
        result = self._values.get("http_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def https_port(self) -> typing.Optional[jsii.Number]:
        '''Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``.

        This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        '''
        result = self._values.get("https_port")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP version to use when getting content from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max_tls_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the maximum TLS version to use for connections to your origin server.

        As best practice, use ``DYNAMIC`` to automatically apply the latest supported version.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        '''
        result = self._values.get("max_tls_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def min_tls_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the minimum TLS version to use for connections to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        '''
        result = self._values.get("min_tls_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslorigin(self) -> typing.Optional[builtins.str]:
        '''This specifies the media's origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        '''
        result = self._values.get("mslorigin")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage"], result)

    @builtins.property
    def origin_certificate(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        '''
        result = self._values.get("origin_certificate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_certs_to_honor(self) -> typing.Optional[builtins.str]:
        '''Specifies which certificate to trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        '''
        result = self._values.get("origin_certs_to_honor")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''Identifies the Edge Load Balancing origin.

        This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_sni(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value.

        See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        '''
        result = self._values.get("origin_sni")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Choose where your content is retrieved from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ports(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        '''
        result = self._values.get("ports")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        '''
        result = self._values.get("saas_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def saas_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        '''
        result = self._values.get("saas_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def saas_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        '''
        result = self._values.get("saas_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_query_string(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        '''
        result = self._values.get("saas_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        '''
        result = self._values.get("saas_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies replacement text for what ``saasRegex`` matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        '''
        result = self._values.get("saas_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_suffix(self) -> typing.Optional[builtins.str]:
        '''Specifies the static part of the SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        '''
        result = self._values.get("saas_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def saas_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the part of the request that identifies this SaaS dynamic origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        '''
        result = self._values.get("saas_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        '''
        result = self._values.get("second_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def second_hostname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Available only for certain products. This specifies whether you want to use an additional origin server address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        '''
        result = self._values.get("second_hostname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def standard_certificate_authorities(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.'''
        result = self._values.get("standard_certificate_authorities")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tls13_support(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables transport layer security (TLS) version 1.3 for connections to your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        '''
        result = self._values.get("tls13_support")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def tls_version_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        '''
        result = self._values.get("tls_version_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def true_client_ip_client_setting(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin.

        Otherwise the edge server removes it and sets the value itself.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        '''
        result = self._values.get("true_client_ip_client_setting")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def true_client_ip_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        '''
        result = self._values.get("true_client_ip_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_unique_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        '''
        result = self._values.get("use_unique_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_mode(self) -> typing.Optional[builtins.str]:
        '''For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        result = self._values.get("verification_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics",
    jsii_struct_bases=[],
    name_mapping={
        "access_key_encrypted_storage": "accessKeyEncryptedStorage",
        "adc_title": "adcTitle",
        "authentication_method": "authenticationMethod",
        "authentication_method_title": "authenticationMethodTitle",
        "aws_access_key_id": "awsAccessKeyId",
        "aws_access_key_version_guid": "awsAccessKeyVersionGuid",
        "aws_ar_region": "awsArRegion",
        "aws_host": "awsHost",
        "aws_region": "awsRegion",
        "aws_secret_access_key": "awsSecretAccessKey",
        "aws_service": "awsService",
        "country": "country",
        "custom_sign_string": "customSignString",
        "direct_connect_geo": "directConnectGeo",
        "encoding_version": "encodingVersion",
        "end_point_service": "endPointService",
        "gcs_access_key_version_guid": "gcsAccessKeyVersionGuid",
        "gcs_hmac_key_access_id": "gcsHmacKeyAccessId",
        "gcs_hmac_key_secret": "gcsHmacKeySecret",
        "hostname_tag": "hostnameTag",
        "locked": "locked",
        "mslkey": "mslkey",
        "mslname": "mslname",
        "nonce": "nonce",
        "origin_location_title": "originLocationTitle",
        "property_id_tag": "propertyIdTag",
        "role_arn": "roleArn",
        "secret_key": "secretKey",
        "template_uuid": "templateUuid",
        "use_custom_sign_string": "useCustomSignString",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics:
    def __init__(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49a703847002a81e81e7cdce710b38ad36e7cbe53be9032f4cb7f246c3bf7e65)
            check_type(argname="argument access_key_encrypted_storage", value=access_key_encrypted_storage, expected_type=type_hints["access_key_encrypted_storage"])
            check_type(argname="argument adc_title", value=adc_title, expected_type=type_hints["adc_title"])
            check_type(argname="argument authentication_method", value=authentication_method, expected_type=type_hints["authentication_method"])
            check_type(argname="argument authentication_method_title", value=authentication_method_title, expected_type=type_hints["authentication_method_title"])
            check_type(argname="argument aws_access_key_id", value=aws_access_key_id, expected_type=type_hints["aws_access_key_id"])
            check_type(argname="argument aws_access_key_version_guid", value=aws_access_key_version_guid, expected_type=type_hints["aws_access_key_version_guid"])
            check_type(argname="argument aws_ar_region", value=aws_ar_region, expected_type=type_hints["aws_ar_region"])
            check_type(argname="argument aws_host", value=aws_host, expected_type=type_hints["aws_host"])
            check_type(argname="argument aws_region", value=aws_region, expected_type=type_hints["aws_region"])
            check_type(argname="argument aws_secret_access_key", value=aws_secret_access_key, expected_type=type_hints["aws_secret_access_key"])
            check_type(argname="argument aws_service", value=aws_service, expected_type=type_hints["aws_service"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument custom_sign_string", value=custom_sign_string, expected_type=type_hints["custom_sign_string"])
            check_type(argname="argument direct_connect_geo", value=direct_connect_geo, expected_type=type_hints["direct_connect_geo"])
            check_type(argname="argument encoding_version", value=encoding_version, expected_type=type_hints["encoding_version"])
            check_type(argname="argument end_point_service", value=end_point_service, expected_type=type_hints["end_point_service"])
            check_type(argname="argument gcs_access_key_version_guid", value=gcs_access_key_version_guid, expected_type=type_hints["gcs_access_key_version_guid"])
            check_type(argname="argument gcs_hmac_key_access_id", value=gcs_hmac_key_access_id, expected_type=type_hints["gcs_hmac_key_access_id"])
            check_type(argname="argument gcs_hmac_key_secret", value=gcs_hmac_key_secret, expected_type=type_hints["gcs_hmac_key_secret"])
            check_type(argname="argument hostname_tag", value=hostname_tag, expected_type=type_hints["hostname_tag"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mslkey", value=mslkey, expected_type=type_hints["mslkey"])
            check_type(argname="argument mslname", value=mslname, expected_type=type_hints["mslname"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument origin_location_title", value=origin_location_title, expected_type=type_hints["origin_location_title"])
            check_type(argname="argument property_id_tag", value=property_id_tag, expected_type=type_hints["property_id_tag"])
            check_type(argname="argument role_arn", value=role_arn, expected_type=type_hints["role_arn"])
            check_type(argname="argument secret_key", value=secret_key, expected_type=type_hints["secret_key"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_custom_sign_string", value=use_custom_sign_string, expected_type=type_hints["use_custom_sign_string"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_key_encrypted_storage is not None:
            self._values["access_key_encrypted_storage"] = access_key_encrypted_storage
        if adc_title is not None:
            self._values["adc_title"] = adc_title
        if authentication_method is not None:
            self._values["authentication_method"] = authentication_method
        if authentication_method_title is not None:
            self._values["authentication_method_title"] = authentication_method_title
        if aws_access_key_id is not None:
            self._values["aws_access_key_id"] = aws_access_key_id
        if aws_access_key_version_guid is not None:
            self._values["aws_access_key_version_guid"] = aws_access_key_version_guid
        if aws_ar_region is not None:
            self._values["aws_ar_region"] = aws_ar_region
        if aws_host is not None:
            self._values["aws_host"] = aws_host
        if aws_region is not None:
            self._values["aws_region"] = aws_region
        if aws_secret_access_key is not None:
            self._values["aws_secret_access_key"] = aws_secret_access_key
        if aws_service is not None:
            self._values["aws_service"] = aws_service
        if country is not None:
            self._values["country"] = country
        if custom_sign_string is not None:
            self._values["custom_sign_string"] = custom_sign_string
        if direct_connect_geo is not None:
            self._values["direct_connect_geo"] = direct_connect_geo
        if encoding_version is not None:
            self._values["encoding_version"] = encoding_version
        if end_point_service is not None:
            self._values["end_point_service"] = end_point_service
        if gcs_access_key_version_guid is not None:
            self._values["gcs_access_key_version_guid"] = gcs_access_key_version_guid
        if gcs_hmac_key_access_id is not None:
            self._values["gcs_hmac_key_access_id"] = gcs_hmac_key_access_id
        if gcs_hmac_key_secret is not None:
            self._values["gcs_hmac_key_secret"] = gcs_hmac_key_secret
        if hostname_tag is not None:
            self._values["hostname_tag"] = hostname_tag
        if locked is not None:
            self._values["locked"] = locked
        if mslkey is not None:
            self._values["mslkey"] = mslkey
        if mslname is not None:
            self._values["mslname"] = mslname
        if nonce is not None:
            self._values["nonce"] = nonce
        if origin_location_title is not None:
            self._values["origin_location_title"] = origin_location_title
        if property_id_tag is not None:
            self._values["property_id_tag"] = property_id_tag
        if role_arn is not None:
            self._values["role_arn"] = role_arn
        if secret_key is not None:
            self._values["secret_key"] = secret_key
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_custom_sign_string is not None:
            self._values["use_custom_sign_string"] = use_custom_sign_string
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def access_key_encrypted_storage(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables secure use of access keys defined in Cloud Access Manager.

        Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        '''
        result = self._values.get("access_key_encrypted_storage")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def adc_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        '''
        result = self._values.get("adc_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the authentication method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        '''
        result = self._values.get("authentication_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def authentication_method_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        '''
        result = self._values.get("authentication_method_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_id(self) -> typing.Optional[builtins.str]:
        '''Specifies active access key ID linked to your AWS account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        '''
        result = self._values.get("aws_access_key_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        '''
        result = self._values.get("aws_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_ar_region(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.'''
        result = self._values.get("aws_ar_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes.

        If you leave this option empty, it inherits the hostname from the ``origin`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        '''
        result = self._values.get("aws_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_region(self) -> typing.Optional[builtins.str]:
        '''This specifies the AWS region code of the location where your bucket resides.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        '''
        result = self._values.get("aws_region")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_secret_access_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        '''
        result = self._values.get("aws_secret_access_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def aws_service(self) -> typing.Optional[builtins.str]:
        '''This specifies the subdomain of your AWS service.

        It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        '''
        result = self._values.get("aws_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin's geographic region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        '''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_sign_string(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the data to be encrypted as a series of enumerated variable names.

        See ``Built-in system variables`` for guidance on each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        '''
        result = self._values.get("custom_sign_string")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def direct_connect_geo(self) -> typing.Optional[builtins.str]:
        '''Provides a region used by Akamai Direct Connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        '''
        result = self._values.get("direct_connect_geo")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encoding_version(self) -> typing.Optional[jsii.Number]:
        '''Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        '''
        result = self._values.get("encoding_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def end_point_service(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.'''
        result = self._values.get("end_point_service")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_access_key_version_guid(self) -> typing.Optional[builtins.str]:
        '''Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        '''
        result = self._values.get("gcs_access_key_version_guid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_access_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the active access ID linked to your Google account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        '''
        result = self._values.get("gcs_hmac_key_access_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def gcs_hmac_key_secret(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        '''
        result = self._values.get("gcs_hmac_key_secret")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hostname_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.'''
        result = self._values.get("hostname_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mslkey(self) -> typing.Optional[builtins.str]:
        '''Specifies the access key provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        '''
        result = self._values.get("mslkey")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mslname(self) -> typing.Optional[builtins.str]:
        '''Specifies the origin name provided by the hosting service.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        '''
        result = self._values.get("mslname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the nonce.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_location_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        '''
        result = self._values.get("origin_location_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def property_id_tag(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.'''
        result = self._values.get("property_id_tag")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def role_arn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.'''
        result = self._values.get("role_arn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secret_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the shared secret key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        '''
        result = self._values.get("secret_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_custom_sign_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies whether to customize your signed string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        '''
        result = self._values.get("use_custom_sign_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7560fef56f48f62e283ad4dff97c7ab8de37feff5ad2b7ed662dc48913be2a8)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessKeyEncryptedStorage")
    def reset_access_key_encrypted_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessKeyEncryptedStorage", []))

    @jsii.member(jsii_name="resetAdcTitle")
    def reset_adc_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdcTitle", []))

    @jsii.member(jsii_name="resetAuthenticationMethod")
    def reset_authentication_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethod", []))

    @jsii.member(jsii_name="resetAuthenticationMethodTitle")
    def reset_authentication_method_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthenticationMethodTitle", []))

    @jsii.member(jsii_name="resetAwsAccessKeyId")
    def reset_aws_access_key_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyId", []))

    @jsii.member(jsii_name="resetAwsAccessKeyVersionGuid")
    def reset_aws_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetAwsArRegion")
    def reset_aws_ar_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsArRegion", []))

    @jsii.member(jsii_name="resetAwsHost")
    def reset_aws_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsHost", []))

    @jsii.member(jsii_name="resetAwsRegion")
    def reset_aws_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsRegion", []))

    @jsii.member(jsii_name="resetAwsSecretAccessKey")
    def reset_aws_secret_access_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsSecretAccessKey", []))

    @jsii.member(jsii_name="resetAwsService")
    def reset_aws_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAwsService", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetCustomSignString")
    def reset_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomSignString", []))

    @jsii.member(jsii_name="resetDirectConnectGeo")
    def reset_direct_connect_geo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDirectConnectGeo", []))

    @jsii.member(jsii_name="resetEncodingVersion")
    def reset_encoding_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncodingVersion", []))

    @jsii.member(jsii_name="resetEndPointService")
    def reset_end_point_service(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndPointService", []))

    @jsii.member(jsii_name="resetGcsAccessKeyVersionGuid")
    def reset_gcs_access_key_version_guid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsAccessKeyVersionGuid", []))

    @jsii.member(jsii_name="resetGcsHmacKeyAccessId")
    def reset_gcs_hmac_key_access_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeyAccessId", []))

    @jsii.member(jsii_name="resetGcsHmacKeySecret")
    def reset_gcs_hmac_key_secret(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGcsHmacKeySecret", []))

    @jsii.member(jsii_name="resetHostnameTag")
    def reset_hostname_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostnameTag", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMslkey")
    def reset_mslkey(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslkey", []))

    @jsii.member(jsii_name="resetMslname")
    def reset_mslname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslname", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetOriginLocationTitle")
    def reset_origin_location_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginLocationTitle", []))

    @jsii.member(jsii_name="resetPropertyIdTag")
    def reset_property_id_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPropertyIdTag", []))

    @jsii.member(jsii_name="resetRoleArn")
    def reset_role_arn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRoleArn", []))

    @jsii.member(jsii_name="resetSecretKey")
    def reset_secret_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecretKey", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseCustomSignString")
    def reset_use_custom_sign_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseCustomSignString", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorageInput")
    def access_key_encrypted_storage_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessKeyEncryptedStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="adcTitleInput")
    def adc_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "adcTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodInput")
    def authentication_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitleInput")
    def authentication_method_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authenticationMethodTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyIdInput")
    def aws_access_key_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyIdInput"))

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuidInput")
    def aws_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="awsArRegionInput")
    def aws_ar_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsArRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsHostInput")
    def aws_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsHostInput"))

    @builtins.property
    @jsii.member(jsii_name="awsRegionInput")
    def aws_region_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKeyInput")
    def aws_secret_access_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsSecretAccessKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="awsServiceInput")
    def aws_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "awsServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="customSignStringInput")
    def custom_sign_string_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="directConnectGeoInput")
    def direct_connect_geo_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "directConnectGeoInput"))

    @builtins.property
    @jsii.member(jsii_name="encodingVersionInput")
    def encoding_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "encodingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="endPointServiceInput")
    def end_point_service_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endPointServiceInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuidInput")
    def gcs_access_key_version_guid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsAccessKeyVersionGuidInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessIdInput")
    def gcs_hmac_key_access_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeyAccessIdInput"))

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecretInput")
    def gcs_hmac_key_secret_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "gcsHmacKeySecretInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameTagInput")
    def hostname_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hostnameTagInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mslkeyInput")
    def mslkey_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslkeyInput"))

    @builtins.property
    @jsii.member(jsii_name="mslnameInput")
    def mslname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mslnameInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="originLocationTitleInput")
    def origin_location_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originLocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="propertyIdTagInput")
    def property_id_tag_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "propertyIdTagInput"))

    @builtins.property
    @jsii.member(jsii_name="roleArnInput")
    def role_arn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "roleArnInput"))

    @builtins.property
    @jsii.member(jsii_name="secretKeyInput")
    def secret_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secretKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useCustomSignStringInput")
    def use_custom_sign_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useCustomSignStringInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accessKeyEncryptedStorage")
    def access_key_encrypted_storage(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessKeyEncryptedStorage"))

    @access_key_encrypted_storage.setter
    def access_key_encrypted_storage(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef185933ff289f3485b881ca410389296ebf137a921bae8d30c926df368b18ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessKeyEncryptedStorage", value)

    @builtins.property
    @jsii.member(jsii_name="adcTitle")
    def adc_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "adcTitle"))

    @adc_title.setter
    def adc_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35fb585a2c8c1048338c5481c76049f66c71f79bd8757cb5a617d7cbfa5d3564)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "adcTitle", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethod")
    def authentication_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethod"))

    @authentication_method.setter
    def authentication_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1fc81a3dec21ef3e33ed71e5f6243f7a30826e798a508f6aa6fbdf885761e3ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethod", value)

    @builtins.property
    @jsii.member(jsii_name="authenticationMethodTitle")
    def authentication_method_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authenticationMethodTitle"))

    @authentication_method_title.setter
    def authentication_method_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9594c406a33fa174102d3ab97e5641fff5ab77a5519ae28097fe5413d243c38)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authenticationMethodTitle", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyId")
    def aws_access_key_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyId"))

    @aws_access_key_id.setter
    def aws_access_key_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06acacc3112494f1923a7c831e44a8c50cf9ec8e07fb3c0490e360fed555237c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyId", value)

    @builtins.property
    @jsii.member(jsii_name="awsAccessKeyVersionGuid")
    def aws_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsAccessKeyVersionGuid"))

    @aws_access_key_version_guid.setter
    def aws_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a03b98004a55d9f833052663cdf08ac4054458e3a9259fcb359a5a9f21ce4cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="awsArRegion")
    def aws_ar_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsArRegion"))

    @aws_ar_region.setter
    def aws_ar_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd997c9140d75842e354b056b7ec5d62c02a1fe73b7da11836c7f3bd57bbb7c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsArRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsHost")
    def aws_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsHost"))

    @aws_host.setter
    def aws_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f3a87acac0493646e0a2c1ef5575ddeddfdba53ed9319bb2de99dc2f7955e3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsHost", value)

    @builtins.property
    @jsii.member(jsii_name="awsRegion")
    def aws_region(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsRegion"))

    @aws_region.setter
    def aws_region(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b1c2129abb4252f1ebe7f7c6f7543c649db81433fbea4f239d53df83535f39e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsRegion", value)

    @builtins.property
    @jsii.member(jsii_name="awsSecretAccessKey")
    def aws_secret_access_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsSecretAccessKey"))

    @aws_secret_access_key.setter
    def aws_secret_access_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a264cebf994e45d828c80295881cad19b9b6caa5c252b22069967c2377688f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsSecretAccessKey", value)

    @builtins.property
    @jsii.member(jsii_name="awsService")
    def aws_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "awsService"))

    @aws_service.setter
    def aws_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7c813a27acd9250783705bc74323ff55ad7f5552c09dba1ef6261e686cc5c58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "awsService", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baa7213cd38dd002f8df1c5be96a1be123286ad6bb49d5cd5aaa6a46ac3ed13c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="customSignString")
    def custom_sign_string(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customSignString"))

    @custom_sign_string.setter
    def custom_sign_string(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bac801b022701948143428181cc9229ecf66c6478bb56a33f20cfccac876a2c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customSignString", value)

    @builtins.property
    @jsii.member(jsii_name="directConnectGeo")
    def direct_connect_geo(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "directConnectGeo"))

    @direct_connect_geo.setter
    def direct_connect_geo(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61ccba51c7fad485623594ca65fd1d0947de8ffea1c009b42b66a695060aed39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "directConnectGeo", value)

    @builtins.property
    @jsii.member(jsii_name="encodingVersion")
    def encoding_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "encodingVersion"))

    @encoding_version.setter
    def encoding_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87b598bc9364eb72cb474743efd79342fb3603fd5ff42eeb871cf5dd07ad4c27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encodingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="endPointService")
    def end_point_service(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endPointService"))

    @end_point_service.setter
    def end_point_service(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05664bd3616842457eddd459e23ec22b15829bc36900db17e1a3765c8dc81eaa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endPointService", value)

    @builtins.property
    @jsii.member(jsii_name="gcsAccessKeyVersionGuid")
    def gcs_access_key_version_guid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsAccessKeyVersionGuid"))

    @gcs_access_key_version_guid.setter
    def gcs_access_key_version_guid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71938c8ff3cdf9a588d356c9493625e5c1c1c229aeca57f5050f605f882d3155)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsAccessKeyVersionGuid", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeyAccessId")
    def gcs_hmac_key_access_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeyAccessId"))

    @gcs_hmac_key_access_id.setter
    def gcs_hmac_key_access_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e8f8bd423ad3a534b5e7f252791d92f46a5f3436036959cec553c7446d42442)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeyAccessId", value)

    @builtins.property
    @jsii.member(jsii_name="gcsHmacKeySecret")
    def gcs_hmac_key_secret(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "gcsHmacKeySecret"))

    @gcs_hmac_key_secret.setter
    def gcs_hmac_key_secret(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__60ce846baa79a072f0e5663f2fd916ac7ce13bfff3b345a20497b021e366f415)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "gcsHmacKeySecret", value)

    @builtins.property
    @jsii.member(jsii_name="hostnameTag")
    def hostname_tag(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hostnameTag"))

    @hostname_tag.setter
    def hostname_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6cd0107dfb9e82d81a716c49b06f2179d84a1b8465f16d3385dee551f364018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostnameTag", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e383b72e51553212435458f9b05423583f36129d176eec5c97e88f45f9df651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mslkey")
    def mslkey(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslkey"))

    @mslkey.setter
    def mslkey(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57cda99e98069ee36bdc7461308df94dad6d2a7d89ea9abd9cdf1c0ab1f76948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslkey", value)

    @builtins.property
    @jsii.member(jsii_name="mslname")
    def mslname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslname"))

    @mslname.setter
    def mslname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a89505cfcb908da5b9fc7fc37f9d4ed6d0d791fd338ed92b118b98f7b694a00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslname", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8f0172a49b87e44b8661613703e68a863ab218084ec27abf198c5651939544d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="originLocationTitle")
    def origin_location_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originLocationTitle"))

    @origin_location_title.setter
    def origin_location_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b359136c0a72b519f5be720d964cb0ccf8f5d5b432bd507c6d221eb22140ea2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originLocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="propertyIdTag")
    def property_id_tag(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "propertyIdTag"))

    @property_id_tag.setter
    def property_id_tag(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4a213446f4e5fe6514a6226d3f013f3939744ac5f4f8e0eb214a84e229f00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "propertyIdTag", value)

    @builtins.property
    @jsii.member(jsii_name="roleArn")
    def role_arn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "roleArn"))

    @role_arn.setter
    def role_arn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294f9a0de032b23909335619a1394b0ab4bbb323dc37e55dbade9f932333e0bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "roleArn", value)

    @builtins.property
    @jsii.member(jsii_name="secretKey")
    def secret_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secretKey"))

    @secret_key.setter
    def secret_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94bb6d07a5260e48858a42b4a755f1197e5fa72f24a7b97875e55a9c57d22604)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secretKey", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__616266bbb0a197d904aaa14e90f7681c6efc7471e10a29cf4e16aa25531016a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useCustomSignString")
    def use_custom_sign_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useCustomSignString"))

    @use_custom_sign_string.setter
    def use_custom_sign_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33de5dffdffe85dc91348c39602014eb5b3502cc1d7ea28b56ac9df8a8aae6f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useCustomSignString", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__baaec1119fa94afdd13d68a39bd7c83daf568746c25d2a5f91b5238c7f15a74e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67aebb7f38061a9532ed8de097449082cd8d00a6a201dd340a963f9f634ee7bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origintype": "origintype",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5831c6700f0195dbc738fa7a72d06b9cbd8f4532ba2000e94384c21cc2d45f96)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origintype", value=origintype, expected_type=type_hints["origintype"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origintype is not None:
            self._values["origintype"] = origintype
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origintype(self) -> typing.Optional[builtins.str]:
        '''Specifies an origin type.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        '''
        result = self._values.get("origintype")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsdOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsdOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c117baac34f298bdda8aae0ab81473bac11a721d09107f8fdd2dbf2883f34cec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOrigintype")
    def reset_origintype(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigintype", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="origintypeInput")
    def origintype_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "origintypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__493f7cc81f8dd2928280f4ea85a855836f13b014d270da6b6962c678a7358874)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="origintype")
    def origintype(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "origintype"))

    @origintype.setter
    def origintype(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02109a60e0765ff73cdc3e954b244c019c4abd249f7e3d037dce398bbfb9bc91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origintype", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fa24c3cac23bc6c1710e8bbaaf82644d6c67e6c3aba9f93a41c21e0e27ffda4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c2e4a88e9c382825c574dc29b605fa062c755fbb8f03179f65f87ab307bab307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5093e86715ccf8c144dd2ac1acac75780370d0f12a150d13c91a09dff9256724)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b076456c5f6c8ef40afff998c7cc079c401478e08bc31d743e2b113ee3507af)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b2cac2de32d818a07d6d9feb5308184e02ca695784036b287f2c095e6b8fa5e)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7796ded68060a1e4b9d607b012bce38819c3033ee8527d42c479c605169101e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4de623d94d5cb018a13bfd1f4f4b60bd65f0b2245beaae3e938a802059d538e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5941c6013dbd31ba7f1cb08f142a392141322629ba1808708a609e281b0388a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57e4161f8022fac23875a6f263fe1a61ed031ec723cefe0cac268ed16d9ce6ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9944bf6e60adde28926fa278fb6c9626c5631c1590920db29c36070ec5cc3cf7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db9768d39e65b8687129130400e4cbe3fb893fa3eb425a3da419131c35db7485)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe4c50598ffdfa5e2bba76f92325937c0e359165df91ac3353c25300b8791d31)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1709480d648333a612b765473ae1fa58be8906cb707d8034d4fc4903f0f4e5ef)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d22a8deec098e167887e2cfe3689fe750d6707e15f40e4ac68d3d2a20e5bb4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a794d23b410e0bcf89ae11f0495ce33c3982f1e77ca7cd0a43e1448440840df0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2934b1aa3eabb91a6f18947a869dacb28c9fb94a278de9e599ed25585d9ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78566649d785f541151c1345d49506f7ad160c5fe7b9c939915e717ac1d6e249)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__356121a15f52f159931982ecbd3d615d85a114a24277b1eada62c980ebefbd10)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2f4503953b1622579d060dfd335cff94afef93b1f3311a9a9ae1527cbed0be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61afd42612b5c35bfe643465da126c145818f0f54dd2d74b5d4cae6112f7d674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4809640f86cee2f2d45b3fd0acda5b0ffd78c03b2a3fecb71482e72574ff24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4d2bd16ad1b628c6f77ce9fac9dbdeded8af27f83a90d36755da5d274ea7f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2c5283620bef581adc76359b7933e7ef45e496a3fb6878d0d659effd90112a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a551ef827ae5ef3d3dbd96b3de913c7673c4b521fdd63719e31dd4c4c03e910)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25576b6e08a006d1fcda3660051d93dca8e5c13ccead285bd1fec9955656ea14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db01ada76b2a87c8b4afc5ae8a81d2b5b0293728dd65c09727273ff76140f132)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a81bc97943129e64f3d6afdd1508da2fe5f2a2607e6b9563d66a3d321fa5858d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cf3b51c0c1ac9dc8072fc490e13dff7b2e71c0fe1bd488968a76e7dccc22811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b8b7e362a0d7f15b3c310e9795cffbbc124c5f5f61f3ee867e8550ed1445be4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__372bc3eda3f6bcb6cee2977769cd5c0c84f2787b57a8a8ec03e38421782d323b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__50cb6d024454b07b4ea52066e6be901e7cbaaf2ca6156c247ad177ed2d1c52c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80c042085dacd8c0c310b6136163ced0152395b9bc1c575bd48a2dc6599cc88f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2e5443979215c47ffb5ce0a5e5d58a4ccdd4411d5f3fc89b1b5c9af89e3636b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12f0ad967b9df6722b82e175bf02cdcfb3203a97c7a346adf4be8d749bbb6804)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d8fb2a3270cbf6a230daef0cdf20719e521b7197807dbcab10092b83092a2b6)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02a201447681d27cd952b75dc7bd953fbd065588262a725bb26aea4013031d2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d067cd5739f65efa4e78f2dec461e986335df3afb8b4cedee67b47f29bddfb7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96d11369b31bc6df9f00abe6b3685a67e19b6d41fbbab84bea6dfc9af74aaaee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41e26451573b6e7900f5992ca201cd40dcdb41930daae37691d51636029e95ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__124d26c5c3823fe90d2814364c91c107d9754d2e228226fd1ef66e5d4ac231a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599fa383fda799025635be51b873ba5d83e230674492f22b5661b4b33a118499)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates",
    jsii_struct_bases=[],
    name_mapping={
        "can_be_ca": "canBeCa",
        "can_be_leaf": "canBeLeaf",
        "issuer_rdns": "issuerRdns",
        "not_after": "notAfter",
        "not_before": "notBefore",
        "pem_encoded_cert": "pemEncodedCert",
        "public_key": "publicKey",
        "public_key_algorithm": "publicKeyAlgorithm",
        "public_key_format": "publicKeyFormat",
        "self_signed": "selfSigned",
        "serial_number": "serialNumber",
        "sha1_fingerprint": "sha1Fingerprint",
        "sig_alg_name": "sigAlgName",
        "subject_alternative_names": "subjectAlternativeNames",
        "subject_cn": "subjectCn",
        "subject_rdns": "subjectRdns",
        "version": "version",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates:
    def __init__(
        self,
        *,
        can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        issuer_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        not_after: typing.Optional[jsii.Number] = None,
        not_before: typing.Optional[jsii.Number] = None,
        pem_encoded_cert: typing.Optional[builtins.str] = None,
        public_key: typing.Optional[builtins.str] = None,
        public_key_algorithm: typing.Optional[builtins.str] = None,
        public_key_format: typing.Optional[builtins.str] = None,
        self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_number: typing.Optional[builtins.str] = None,
        sha1_fingerprint: typing.Optional[builtins.str] = None,
        sig_alg_name: typing.Optional[builtins.str] = None,
        subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        subject_cn: typing.Optional[builtins.str] = None,
        subject_rdns: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns", typing.Dict[builtins.str, typing.Any]]] = None,
        version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param can_be_ca: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.
        :param can_be_leaf: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.
        :param issuer_rdns: issuer_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        :param not_after: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.
        :param not_before: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.
        :param pem_encoded_cert: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.
        :param public_key: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.
        :param public_key_algorithm: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.
        :param public_key_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.
        :param self_signed: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.
        :param serial_number: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.
        :param sha1_fingerprint: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.
        :param sig_alg_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.
        :param subject_alternative_names: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.
        :param subject_cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.
        :param subject_rdns: subject_rdns block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        :param version: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.
        '''
        if isinstance(issuer_rdns, dict):
            issuer_rdns = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns(**issuer_rdns)
        if isinstance(subject_rdns, dict):
            subject_rdns = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns(**subject_rdns)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df350bc65ecf4979b0dbc8fbc1b4c486c205220a835a50e4949a6924bf3ba2bb)
            check_type(argname="argument can_be_ca", value=can_be_ca, expected_type=type_hints["can_be_ca"])
            check_type(argname="argument can_be_leaf", value=can_be_leaf, expected_type=type_hints["can_be_leaf"])
            check_type(argname="argument issuer_rdns", value=issuer_rdns, expected_type=type_hints["issuer_rdns"])
            check_type(argname="argument not_after", value=not_after, expected_type=type_hints["not_after"])
            check_type(argname="argument not_before", value=not_before, expected_type=type_hints["not_before"])
            check_type(argname="argument pem_encoded_cert", value=pem_encoded_cert, expected_type=type_hints["pem_encoded_cert"])
            check_type(argname="argument public_key", value=public_key, expected_type=type_hints["public_key"])
            check_type(argname="argument public_key_algorithm", value=public_key_algorithm, expected_type=type_hints["public_key_algorithm"])
            check_type(argname="argument public_key_format", value=public_key_format, expected_type=type_hints["public_key_format"])
            check_type(argname="argument self_signed", value=self_signed, expected_type=type_hints["self_signed"])
            check_type(argname="argument serial_number", value=serial_number, expected_type=type_hints["serial_number"])
            check_type(argname="argument sha1_fingerprint", value=sha1_fingerprint, expected_type=type_hints["sha1_fingerprint"])
            check_type(argname="argument sig_alg_name", value=sig_alg_name, expected_type=type_hints["sig_alg_name"])
            check_type(argname="argument subject_alternative_names", value=subject_alternative_names, expected_type=type_hints["subject_alternative_names"])
            check_type(argname="argument subject_cn", value=subject_cn, expected_type=type_hints["subject_cn"])
            check_type(argname="argument subject_rdns", value=subject_rdns, expected_type=type_hints["subject_rdns"])
            check_type(argname="argument version", value=version, expected_type=type_hints["version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if can_be_ca is not None:
            self._values["can_be_ca"] = can_be_ca
        if can_be_leaf is not None:
            self._values["can_be_leaf"] = can_be_leaf
        if issuer_rdns is not None:
            self._values["issuer_rdns"] = issuer_rdns
        if not_after is not None:
            self._values["not_after"] = not_after
        if not_before is not None:
            self._values["not_before"] = not_before
        if pem_encoded_cert is not None:
            self._values["pem_encoded_cert"] = pem_encoded_cert
        if public_key is not None:
            self._values["public_key"] = public_key
        if public_key_algorithm is not None:
            self._values["public_key_algorithm"] = public_key_algorithm
        if public_key_format is not None:
            self._values["public_key_format"] = public_key_format
        if self_signed is not None:
            self._values["self_signed"] = self_signed
        if serial_number is not None:
            self._values["serial_number"] = serial_number
        if sha1_fingerprint is not None:
            self._values["sha1_fingerprint"] = sha1_fingerprint
        if sig_alg_name is not None:
            self._values["sig_alg_name"] = sig_alg_name
        if subject_alternative_names is not None:
            self._values["subject_alternative_names"] = subject_alternative_names
        if subject_cn is not None:
            self._values["subject_cn"] = subject_cn
        if subject_rdns is not None:
            self._values["subject_rdns"] = subject_rdns
        if version is not None:
            self._values["version"] = version

    @builtins.property
    def can_be_ca(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_ca DataAkamaiPropertyRulesBuilder#can_be_ca}.'''
        result = self._values.get("can_be_ca")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def can_be_leaf(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#can_be_leaf DataAkamaiPropertyRulesBuilder#can_be_leaf}.'''
        result = self._values.get("can_be_leaf")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def issuer_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns"]:
        '''issuer_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#issuer_rdns DataAkamaiPropertyRulesBuilder#issuer_rdns}
        '''
        result = self._values.get("issuer_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns"], result)

    @builtins.property
    def not_after(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_after DataAkamaiPropertyRulesBuilder#not_after}.'''
        result = self._values.get("not_after")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def not_before(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#not_before DataAkamaiPropertyRulesBuilder#not_before}.'''
        result = self._values.get("not_before")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def pem_encoded_cert(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pem_encoded_cert DataAkamaiPropertyRulesBuilder#pem_encoded_cert}.'''
        result = self._values.get("pem_encoded_cert")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key DataAkamaiPropertyRulesBuilder#public_key}.'''
        result = self._values.get("public_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_algorithm(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_algorithm DataAkamaiPropertyRulesBuilder#public_key_algorithm}.'''
        result = self._values.get("public_key_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def public_key_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_key_format DataAkamaiPropertyRulesBuilder#public_key_format}.'''
        result = self._values.get("public_key_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def self_signed(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#self_signed DataAkamaiPropertyRulesBuilder#self_signed}.'''
        result = self._values.get("self_signed")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_number(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_number DataAkamaiPropertyRulesBuilder#serial_number}.'''
        result = self._values.get("serial_number")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sha1_fingerprint(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sha1_fingerprint DataAkamaiPropertyRulesBuilder#sha1_fingerprint}.'''
        result = self._values.get("sha1_fingerprint")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sig_alg_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sig_alg_name DataAkamaiPropertyRulesBuilder#sig_alg_name}.'''
        result = self._values.get("sig_alg_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_alternative_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_alternative_names DataAkamaiPropertyRulesBuilder#subject_alternative_names}.'''
        result = self._values.get("subject_alternative_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def subject_cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_cn DataAkamaiPropertyRulesBuilder#subject_cn}.'''
        result = self._values.get("subject_cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def subject_rdns(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns"]:
        '''subject_rdns block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#subject_rdns DataAkamaiPropertyRulesBuilder#subject_rdns}
        '''
        result = self._values.get("subject_rdns")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns"], result)

    @builtins.property
    def version(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version DataAkamaiPropertyRulesBuilder#version}.'''
        result = self._values.get("version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb1bc2479bef465702d85be99ab970ea738e24c133a6f0d121de4f9df181852d)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3c5e2fba20894a2f25e4fa76925d82a2a14deac44f77c5cff00ab7001d8259c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b228542d48ba8f234b6ffbe0a79edd3e98445f878db1032894393d2011d5d668)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d04ca099272e649fbb6e1bc28421b72f5f2a49e9f1d7349f787af8460c4bfc6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__49f26d26d2002ff4086a0d723431685432544338f05b52071e606c5abab66a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8382caac5c8cb88fb1e6317d55fb101f06cd35cf347c66c47fda3da59dcc8425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a62ada284bed67a2960d3ca6d4bbffef54ec40696f1e658151a9f80a054a3218)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02822a7400a7a494a9e54df31d28eb707900743159ebc086101e1fc5cb49af4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__425de90d2a00e28fb5de4dc0c0c3635664ce172d6724bfd977368e11d9f95626)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f0fa24a5dd438bb2eecf8c5a3a35f909e115d9c5abb49658211657f8cbcf8c12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75535e6ee35231cc916535258f0c31cff400f6993d3531da39cf8b3d0294a180)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1172f03e87b5e86ef7a246a0df1f250a3665bcdc88c6fcde901b27bcf117513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7027a101e4c64fb18f3114377bd02ea0ddc7d3094495b8cb9026af2c44b7abb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53907eb64d785ddc30a0404d7314a9d559c6635a6195d0c38379f06948294bb0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putIssuerRdns")
    def put_issuer_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putIssuerRdns", [value]))

    @jsii.member(jsii_name="putSubjectRdns")
    def put_subject_rdns(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns(
            c=c, cn=cn, o=o, ou=ou
        )

        return typing.cast(None, jsii.invoke(self, "putSubjectRdns", [value]))

    @jsii.member(jsii_name="resetCanBeCa")
    def reset_can_be_ca(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeCa", []))

    @jsii.member(jsii_name="resetCanBeLeaf")
    def reset_can_be_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCanBeLeaf", []))

    @jsii.member(jsii_name="resetIssuerRdns")
    def reset_issuer_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIssuerRdns", []))

    @jsii.member(jsii_name="resetNotAfter")
    def reset_not_after(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotAfter", []))

    @jsii.member(jsii_name="resetNotBefore")
    def reset_not_before(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNotBefore", []))

    @jsii.member(jsii_name="resetPemEncodedCert")
    def reset_pem_encoded_cert(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPemEncodedCert", []))

    @jsii.member(jsii_name="resetPublicKey")
    def reset_public_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKey", []))

    @jsii.member(jsii_name="resetPublicKeyAlgorithm")
    def reset_public_key_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyAlgorithm", []))

    @jsii.member(jsii_name="resetPublicKeyFormat")
    def reset_public_key_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPublicKeyFormat", []))

    @jsii.member(jsii_name="resetSelfSigned")
    def reset_self_signed(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSelfSigned", []))

    @jsii.member(jsii_name="resetSerialNumber")
    def reset_serial_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialNumber", []))

    @jsii.member(jsii_name="resetSha1Fingerprint")
    def reset_sha1_fingerprint(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSha1Fingerprint", []))

    @jsii.member(jsii_name="resetSigAlgName")
    def reset_sig_alg_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSigAlgName", []))

    @jsii.member(jsii_name="resetSubjectAlternativeNames")
    def reset_subject_alternative_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectAlternativeNames", []))

    @jsii.member(jsii_name="resetSubjectCn")
    def reset_subject_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectCn", []))

    @jsii.member(jsii_name="resetSubjectRdns")
    def reset_subject_rdns(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubjectRdns", []))

    @jsii.member(jsii_name="resetVersion")
    def reset_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersion", []))

    @builtins.property
    @jsii.member(jsii_name="issuerRdns")
    def issuer_rdns(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdnsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdnsOutputReference, jsii.get(self, "issuerRdns"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdns")
    def subject_rdns(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdnsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdnsOutputReference", jsii.get(self, "subjectRdns"))

    @builtins.property
    @jsii.member(jsii_name="canBeCaInput")
    def can_be_ca_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeCaInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeLeafInput")
    def can_be_leaf_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "canBeLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="issuerRdnsInput")
    def issuer_rdns_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns], jsii.get(self, "issuerRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="notAfterInput")
    def not_after_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notAfterInput"))

    @builtins.property
    @jsii.member(jsii_name="notBeforeInput")
    def not_before_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "notBeforeInput"))

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCertInput")
    def pem_encoded_cert_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pemEncodedCertInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithmInput")
    def public_key_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormatInput")
    def public_key_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="publicKeyInput")
    def public_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "publicKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="selfSignedInput")
    def self_signed_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "selfSignedInput"))

    @builtins.property
    @jsii.member(jsii_name="serialNumberInput")
    def serial_number_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="sha1FingerprintInput")
    def sha1_fingerprint_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sha1FingerprintInput"))

    @builtins.property
    @jsii.member(jsii_name="sigAlgNameInput")
    def sig_alg_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sigAlgNameInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNamesInput")
    def subject_alternative_names_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "subjectAlternativeNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectCnInput")
    def subject_cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subjectCnInput"))

    @builtins.property
    @jsii.member(jsii_name="subjectRdnsInput")
    def subject_rdns_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns"], jsii.get(self, "subjectRdnsInput"))

    @builtins.property
    @jsii.member(jsii_name="versionInput")
    def version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "versionInput"))

    @builtins.property
    @jsii.member(jsii_name="canBeCa")
    def can_be_ca(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeCa"))

    @can_be_ca.setter
    def can_be_ca(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cf4b55a0f9c52d66b9f9bcea8791b8da2fb620bce1ce5d72d4ca737206b54366)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeCa", value)

    @builtins.property
    @jsii.member(jsii_name="canBeLeaf")
    def can_be_leaf(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "canBeLeaf"))

    @can_be_leaf.setter
    def can_be_leaf(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2c59ba697f07d7931d2bafe37acdb08670e42f07ef7cb70b937ff513c7b9dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "canBeLeaf", value)

    @builtins.property
    @jsii.member(jsii_name="notAfter")
    def not_after(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notAfter"))

    @not_after.setter
    def not_after(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__219aa3eadc53495d5ae70023bd1b479ac9128ae31a05fd0ddce09976f6f4f4cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notAfter", value)

    @builtins.property
    @jsii.member(jsii_name="notBefore")
    def not_before(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "notBefore"))

    @not_before.setter
    def not_before(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6544dfb32fe4a9af81d347f3d17238e21fd55986f3a03fde7e29087135c528a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "notBefore", value)

    @builtins.property
    @jsii.member(jsii_name="pemEncodedCert")
    def pem_encoded_cert(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pemEncodedCert"))

    @pem_encoded_cert.setter
    def pem_encoded_cert(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1d51deb7a535286043226c311b92c1404939ea8c8d0f77c5efc9190c73ac41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pemEncodedCert", value)

    @builtins.property
    @jsii.member(jsii_name="publicKey")
    def public_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKey"))

    @public_key.setter
    def public_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2956e8d2f969f55a0cbd2b6978e2bb5e8a22f3475cf6a4a7b5d844f66e7ce47b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKey", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyAlgorithm")
    def public_key_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyAlgorithm"))

    @public_key_algorithm.setter
    def public_key_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c877b85297c5ad8989d426388079a73b9128f2019d5357e2ea45146c6da44c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="publicKeyFormat")
    def public_key_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "publicKeyFormat"))

    @public_key_format.setter
    def public_key_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06edae8724c2db10152de525a10ac27bfb5c7268ed98c3c59488b92444c31674)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "publicKeyFormat", value)

    @builtins.property
    @jsii.member(jsii_name="selfSigned")
    def self_signed(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "selfSigned"))

    @self_signed.setter
    def self_signed(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bae6f17bdb61db7450aac057d68a9a1091d421750438de3898a62fa3a4faef2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "selfSigned", value)

    @builtins.property
    @jsii.member(jsii_name="serialNumber")
    def serial_number(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialNumber"))

    @serial_number.setter
    def serial_number(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3886b573dd9df16ad3ebe0feac45d194625ccfa6387db2e859fcdaabbf412bfc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialNumber", value)

    @builtins.property
    @jsii.member(jsii_name="sha1Fingerprint")
    def sha1_fingerprint(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sha1Fingerprint"))

    @sha1_fingerprint.setter
    def sha1_fingerprint(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a04280f76858579e2ee0f2b38c4a66667b5bf68d5fad0c7d41b61f53ab4bc95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sha1Fingerprint", value)

    @builtins.property
    @jsii.member(jsii_name="sigAlgName")
    def sig_alg_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sigAlgName"))

    @sig_alg_name.setter
    def sig_alg_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8755e379a2214463be9cf40542010aa7ad2c8cae19f82999469d632171c065d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sigAlgName", value)

    @builtins.property
    @jsii.member(jsii_name="subjectAlternativeNames")
    def subject_alternative_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "subjectAlternativeNames"))

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d37538c75df459281312f703221cb443471460bb4e634ae91bb88ad44693a7d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectAlternativeNames", value)

    @builtins.property
    @jsii.member(jsii_name="subjectCn")
    def subject_cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subjectCn"))

    @subject_cn.setter
    def subject_cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16298bb1b5c47fb9e813a0dda2d99a9fcd42b19e944bee06abb3b395ccd6c1ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subjectCn", value)

    @builtins.property
    @jsii.member(jsii_name="version")
    def version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "version"))

    @version.setter
    def version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26c6d832669a59c85833d3a899354f2ba68a8f17dbc8f50881bf2de0b7f473b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "version", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64580cb7bf59198918e6e7f61b1d8702f35faf41e23c12597ab73b4b7a5e1272)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns",
    jsii_struct_bases=[],
    name_mapping={"c": "c", "cn": "cn", "o": "o", "ou": "ou"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns:
    def __init__(
        self,
        *,
        c: typing.Optional[builtins.str] = None,
        cn: typing.Optional[builtins.str] = None,
        o: typing.Optional[builtins.str] = None,
        ou: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param c: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.
        :param cn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.
        :param o: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.
        :param ou: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__599e97b2fbe41dbd3de92965a6a11e6b42e1f6087dcb22de2b480e7f41e4b7d8)
            check_type(argname="argument c", value=c, expected_type=type_hints["c"])
            check_type(argname="argument cn", value=cn, expected_type=type_hints["cn"])
            check_type(argname="argument o", value=o, expected_type=type_hints["o"])
            check_type(argname="argument ou", value=ou, expected_type=type_hints["ou"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if c is not None:
            self._values["c"] = c
        if cn is not None:
            self._values["cn"] = cn
        if o is not None:
            self._values["o"] = o
        if ou is not None:
            self._values["ou"] = ou

    @builtins.property
    def c(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#c DataAkamaiPropertyRulesBuilder#c}.'''
        result = self._values.get("c")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cn(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cn DataAkamaiPropertyRulesBuilder#cn}.'''
        result = self._values.get("cn")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def o(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#o DataAkamaiPropertyRulesBuilder#o}.'''
        result = self._values.get("o")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ou(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ou DataAkamaiPropertyRulesBuilder#ou}.'''
        result = self._values.get("ou")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdnsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__673b22b8bea935aefe5b48b02265f8d67e56233e184a993995a65a9963b4d44f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetC")
    def reset_c(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetC", []))

    @jsii.member(jsii_name="resetCn")
    def reset_cn(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCn", []))

    @jsii.member(jsii_name="resetO")
    def reset_o(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetO", []))

    @jsii.member(jsii_name="resetOu")
    def reset_ou(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOu", []))

    @builtins.property
    @jsii.member(jsii_name="cInput")
    def c_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cInput"))

    @builtins.property
    @jsii.member(jsii_name="cnInput")
    def cn_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cnInput"))

    @builtins.property
    @jsii.member(jsii_name="oInput")
    def o_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "oInput"))

    @builtins.property
    @jsii.member(jsii_name="ouInput")
    def ou_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ouInput"))

    @builtins.property
    @jsii.member(jsii_name="c")
    def c(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "c"))

    @c.setter
    def c(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3867d151e59238564712af3526ec0d90a45ba15fbf6eb1ca118a7d00c88d6ad5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "c", value)

    @builtins.property
    @jsii.member(jsii_name="cn")
    def cn(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cn"))

    @cn.setter
    def cn(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ce1e4b08404c0003a8ee18ebb67608942c699c332e773869abf09919b3fa42e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cn", value)

    @builtins.property
    @jsii.member(jsii_name="o")
    def o(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "o"))

    @o.setter
    def o(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a050856beb3cfdb195cf97049a123e6876b6ab781d7bd7a4425230be2783689b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "o", value)

    @builtins.property
    @jsii.member(jsii_name="ou")
    def ou(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ou"))

    @ou.setter
    def ou(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cab543356b74fee1903e9d29fb825c77546b323600eda0a090836933b9c0bcde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ou", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__819f50db6a5fc0e619fb6c5a0455cf8dd414dff5c9df9afea2f030b2da7a4941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod",
    jsii_struct_bases=[],
    name_mapping={
        "custom_status_code": "customStatusCode",
        "locked": "locked",
        "recovery_method": "recoveryMethod",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod:
    def __init__(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15db40ebfe3676dac9091c28106557b319b175973a67151fbe8194f2be4e953f)
            check_type(argname="argument custom_status_code", value=custom_status_code, expected_type=type_hints["custom_status_code"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument recovery_method", value=recovery_method, expected_type=type_hints["recovery_method"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if custom_status_code is not None:
            self._values["custom_status_code"] = custom_status_code
        if locked is not None:
            self._values["locked"] = locked
        if recovery_method is not None:
            self._values["recovery_method"] = recovery_method
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def custom_status_code(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom status code to be sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        '''
        result = self._values.get("custom_status_code")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def recovery_method(self) -> typing.Optional[builtins.str]:
        '''Specifies the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        '''
        result = self._values.get("recovery_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd91cbd281b9d1ccfc8a022d32259e80ff740ce571d372381e55d4b1ac1c3f02)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCustomStatusCode")
    def reset_custom_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatusCode", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRecoveryMethod")
    def reset_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryMethod", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="customStatusCodeInput")
    def custom_status_code_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryMethodInput")
    def recovery_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "recoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatusCode")
    def custom_status_code(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatusCode"))

    @custom_status_code.setter
    def custom_status_code(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1072e5f61c1ab018abac13a38d4e37edcd331137e8cd55dcb99f221bb56a02c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e598136219c90a8520f6d34bffbf889497753019f3eac4ed3b3a016573ffa9e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="recoveryMethod")
    def recovery_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "recoveryMethod"))

    @recovery_method.setter
    def recovery_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fa2d9a3918add49580be86619412d7a78e406057046dd1f477b676fc9c735982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "recoveryMethod", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72c5323df35176077048eaa97359492f6118d512090578b0c8295633e0ad2676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeece6486b02883500dd3a79b43cfb37ca1b1ec7f771365e2279a0ba93f3b9f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ee75c497a9b49dcd44bd7ee555cc5f1b010e9309d207329de1edce184599763)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "binary_equivalent_content": "binaryEquivalentContent",
        "enabled": "enabled",
        "enable_ip_avoidance": "enableIpAvoidance",
        "ip_avoidance_error_threshold": "ipAvoidanceErrorThreshold",
        "ip_avoidance_retry_interval": "ipAvoidanceRetryInterval",
        "locked": "locked",
        "monitor_origin_responsiveness": "monitorOriginResponsiveness",
        "monitor_response_codes1": "monitorResponseCodes1",
        "monitor_response_codes2": "monitorResponseCodes2",
        "monitor_response_codes3": "monitorResponseCodes3",
        "monitor_status_codes1": "monitorStatusCodes1",
        "monitor_status_codes1_enable_recovery": "monitorStatusCodes1EnableRecovery",
        "monitor_status_codes1_enable_retry": "monitorStatusCodes1EnableRetry",
        "monitor_status_codes1_recovery_config_name": "monitorStatusCodes1RecoveryConfigName",
        "monitor_status_codes2": "monitorStatusCodes2",
        "monitor_status_codes2_enable_recovery": "monitorStatusCodes2EnableRecovery",
        "monitor_status_codes2_enable_retry": "monitorStatusCodes2EnableRetry",
        "monitor_status_codes2_recovery_config_name": "monitorStatusCodes2RecoveryConfigName",
        "monitor_status_codes3": "monitorStatusCodes3",
        "monitor_status_codes3_enable_recovery": "monitorStatusCodes3EnableRecovery",
        "monitor_status_codes3_enable_retry": "monitorStatusCodes3EnableRetry",
        "monitor_status_codes3_recovery_config_name": "monitorStatusCodes3RecoveryConfigName",
        "origin_responsiveness_custom_timeout": "originResponsivenessCustomTimeout",
        "origin_responsiveness_enable_recovery": "originResponsivenessEnableRecovery",
        "origin_responsiveness_enable_retry": "originResponsivenessEnableRetry",
        "origin_responsiveness_monitoring": "originResponsivenessMonitoring",
        "origin_responsiveness_recovery_config_name": "originResponsivenessRecoveryConfigName",
        "origin_responsiveness_timeout": "originResponsivenessTimeout",
        "status_code_monitoring1": "statusCodeMonitoring1",
        "status_code_monitoring2": "statusCodeMonitoring2",
        "status_code_monitoring3": "statusCodeMonitoring3",
        "template_uuid": "templateUuid",
        "tuning_parameters": "tuningParameters",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy:
    def __init__(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b638e9e860f7614965b5bd97f51f8c092b039872a953e3422d8f9b1821dd7eb2)
            check_type(argname="argument binary_equivalent_content", value=binary_equivalent_content, expected_type=type_hints["binary_equivalent_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_ip_avoidance", value=enable_ip_avoidance, expected_type=type_hints["enable_ip_avoidance"])
            check_type(argname="argument ip_avoidance_error_threshold", value=ip_avoidance_error_threshold, expected_type=type_hints["ip_avoidance_error_threshold"])
            check_type(argname="argument ip_avoidance_retry_interval", value=ip_avoidance_retry_interval, expected_type=type_hints["ip_avoidance_retry_interval"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument monitor_origin_responsiveness", value=monitor_origin_responsiveness, expected_type=type_hints["monitor_origin_responsiveness"])
            check_type(argname="argument monitor_response_codes1", value=monitor_response_codes1, expected_type=type_hints["monitor_response_codes1"])
            check_type(argname="argument monitor_response_codes2", value=monitor_response_codes2, expected_type=type_hints["monitor_response_codes2"])
            check_type(argname="argument monitor_response_codes3", value=monitor_response_codes3, expected_type=type_hints["monitor_response_codes3"])
            check_type(argname="argument monitor_status_codes1", value=monitor_status_codes1, expected_type=type_hints["monitor_status_codes1"])
            check_type(argname="argument monitor_status_codes1_enable_recovery", value=monitor_status_codes1_enable_recovery, expected_type=type_hints["monitor_status_codes1_enable_recovery"])
            check_type(argname="argument monitor_status_codes1_enable_retry", value=monitor_status_codes1_enable_retry, expected_type=type_hints["monitor_status_codes1_enable_retry"])
            check_type(argname="argument monitor_status_codes1_recovery_config_name", value=monitor_status_codes1_recovery_config_name, expected_type=type_hints["monitor_status_codes1_recovery_config_name"])
            check_type(argname="argument monitor_status_codes2", value=monitor_status_codes2, expected_type=type_hints["monitor_status_codes2"])
            check_type(argname="argument monitor_status_codes2_enable_recovery", value=monitor_status_codes2_enable_recovery, expected_type=type_hints["monitor_status_codes2_enable_recovery"])
            check_type(argname="argument monitor_status_codes2_enable_retry", value=monitor_status_codes2_enable_retry, expected_type=type_hints["monitor_status_codes2_enable_retry"])
            check_type(argname="argument monitor_status_codes2_recovery_config_name", value=monitor_status_codes2_recovery_config_name, expected_type=type_hints["monitor_status_codes2_recovery_config_name"])
            check_type(argname="argument monitor_status_codes3", value=monitor_status_codes3, expected_type=type_hints["monitor_status_codes3"])
            check_type(argname="argument monitor_status_codes3_enable_recovery", value=monitor_status_codes3_enable_recovery, expected_type=type_hints["monitor_status_codes3_enable_recovery"])
            check_type(argname="argument monitor_status_codes3_enable_retry", value=monitor_status_codes3_enable_retry, expected_type=type_hints["monitor_status_codes3_enable_retry"])
            check_type(argname="argument monitor_status_codes3_recovery_config_name", value=monitor_status_codes3_recovery_config_name, expected_type=type_hints["monitor_status_codes3_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_custom_timeout", value=origin_responsiveness_custom_timeout, expected_type=type_hints["origin_responsiveness_custom_timeout"])
            check_type(argname="argument origin_responsiveness_enable_recovery", value=origin_responsiveness_enable_recovery, expected_type=type_hints["origin_responsiveness_enable_recovery"])
            check_type(argname="argument origin_responsiveness_enable_retry", value=origin_responsiveness_enable_retry, expected_type=type_hints["origin_responsiveness_enable_retry"])
            check_type(argname="argument origin_responsiveness_monitoring", value=origin_responsiveness_monitoring, expected_type=type_hints["origin_responsiveness_monitoring"])
            check_type(argname="argument origin_responsiveness_recovery_config_name", value=origin_responsiveness_recovery_config_name, expected_type=type_hints["origin_responsiveness_recovery_config_name"])
            check_type(argname="argument origin_responsiveness_timeout", value=origin_responsiveness_timeout, expected_type=type_hints["origin_responsiveness_timeout"])
            check_type(argname="argument status_code_monitoring1", value=status_code_monitoring1, expected_type=type_hints["status_code_monitoring1"])
            check_type(argname="argument status_code_monitoring2", value=status_code_monitoring2, expected_type=type_hints["status_code_monitoring2"])
            check_type(argname="argument status_code_monitoring3", value=status_code_monitoring3, expected_type=type_hints["status_code_monitoring3"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tuning_parameters", value=tuning_parameters, expected_type=type_hints["tuning_parameters"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if binary_equivalent_content is not None:
            self._values["binary_equivalent_content"] = binary_equivalent_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_ip_avoidance is not None:
            self._values["enable_ip_avoidance"] = enable_ip_avoidance
        if ip_avoidance_error_threshold is not None:
            self._values["ip_avoidance_error_threshold"] = ip_avoidance_error_threshold
        if ip_avoidance_retry_interval is not None:
            self._values["ip_avoidance_retry_interval"] = ip_avoidance_retry_interval
        if locked is not None:
            self._values["locked"] = locked
        if monitor_origin_responsiveness is not None:
            self._values["monitor_origin_responsiveness"] = monitor_origin_responsiveness
        if monitor_response_codes1 is not None:
            self._values["monitor_response_codes1"] = monitor_response_codes1
        if monitor_response_codes2 is not None:
            self._values["monitor_response_codes2"] = monitor_response_codes2
        if monitor_response_codes3 is not None:
            self._values["monitor_response_codes3"] = monitor_response_codes3
        if monitor_status_codes1 is not None:
            self._values["monitor_status_codes1"] = monitor_status_codes1
        if monitor_status_codes1_enable_recovery is not None:
            self._values["monitor_status_codes1_enable_recovery"] = monitor_status_codes1_enable_recovery
        if monitor_status_codes1_enable_retry is not None:
            self._values["monitor_status_codes1_enable_retry"] = monitor_status_codes1_enable_retry
        if monitor_status_codes1_recovery_config_name is not None:
            self._values["monitor_status_codes1_recovery_config_name"] = monitor_status_codes1_recovery_config_name
        if monitor_status_codes2 is not None:
            self._values["monitor_status_codes2"] = monitor_status_codes2
        if monitor_status_codes2_enable_recovery is not None:
            self._values["monitor_status_codes2_enable_recovery"] = monitor_status_codes2_enable_recovery
        if monitor_status_codes2_enable_retry is not None:
            self._values["monitor_status_codes2_enable_retry"] = monitor_status_codes2_enable_retry
        if monitor_status_codes2_recovery_config_name is not None:
            self._values["monitor_status_codes2_recovery_config_name"] = monitor_status_codes2_recovery_config_name
        if monitor_status_codes3 is not None:
            self._values["monitor_status_codes3"] = monitor_status_codes3
        if monitor_status_codes3_enable_recovery is not None:
            self._values["monitor_status_codes3_enable_recovery"] = monitor_status_codes3_enable_recovery
        if monitor_status_codes3_enable_retry is not None:
            self._values["monitor_status_codes3_enable_retry"] = monitor_status_codes3_enable_retry
        if monitor_status_codes3_recovery_config_name is not None:
            self._values["monitor_status_codes3_recovery_config_name"] = monitor_status_codes3_recovery_config_name
        if origin_responsiveness_custom_timeout is not None:
            self._values["origin_responsiveness_custom_timeout"] = origin_responsiveness_custom_timeout
        if origin_responsiveness_enable_recovery is not None:
            self._values["origin_responsiveness_enable_recovery"] = origin_responsiveness_enable_recovery
        if origin_responsiveness_enable_retry is not None:
            self._values["origin_responsiveness_enable_retry"] = origin_responsiveness_enable_retry
        if origin_responsiveness_monitoring is not None:
            self._values["origin_responsiveness_monitoring"] = origin_responsiveness_monitoring
        if origin_responsiveness_recovery_config_name is not None:
            self._values["origin_responsiveness_recovery_config_name"] = origin_responsiveness_recovery_config_name
        if origin_responsiveness_timeout is not None:
            self._values["origin_responsiveness_timeout"] = origin_responsiveness_timeout
        if status_code_monitoring1 is not None:
            self._values["status_code_monitoring1"] = status_code_monitoring1
        if status_code_monitoring2 is not None:
            self._values["status_code_monitoring2"] = status_code_monitoring2
        if status_code_monitoring3 is not None:
            self._values["status_code_monitoring3"] = status_code_monitoring3
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tuning_parameters is not None:
            self._values["tuning_parameters"] = tuning_parameters
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def binary_equivalent_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Synchronizes content between the primary and backup origins, byte for byte.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        '''
        result = self._values.get("binary_equivalent_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Activates and configures a recovery policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_ip_avoidance(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Temporarily blocks an origin IP address that experienced a certain number of failures.

        When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        '''
        result = self._values.get("enable_ip_avoidance")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip_avoidance_error_threshold(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of failures that need to occur to an origin address before it's blocked.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        '''
        result = self._values.get("ip_avoidance_error_threshold")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_avoidance_retry_interval(self) -> typing.Optional[jsii.Number]:
        '''Defines the number of seconds after which the IP address is removed from the blocklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        '''
        result = self._values.get("ip_avoidance_retry_interval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        '''
        result = self._values.get("monitor_origin_responsiveness")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_response_codes1(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        '''
        result = self._values.get("monitor_response_codes1")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes2(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        '''
        result = self._values.get("monitor_response_codes2")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_response_codes3(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the origin response codes that trigger a subsequent retry or recovery action.

        Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here..

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        '''
        result = self._values.get("monitor_response_codes3")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def monitor_status_codes1(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        '''
        result = self._values.get("monitor_status_codes1")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes1_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        '''
        result = self._values.get("monitor_status_codes1_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes1_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes1_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes2(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        '''
        result = self._values.get("monitor_status_codes2")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes2_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        '''
        result = self._values.get("monitor_status_codes2_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes2_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes2_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def monitor_status_codes3(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        '''
        result = self._values.get("monitor_status_codes3")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the recovery action for the response codes you define.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        '''
        result = self._values.get("monitor_status_codes3_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the defined response codes apply, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        '''
        result = self._values.get("monitor_status_codes3_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def monitor_status_codes3_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        '''
        result = self._values.get("monitor_status_codes3_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_custom_timeout(self) -> typing.Optional[jsii.Number]:
        '''Specify a custom timeout, from 1 to 10 seconds.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        '''
        result = self._values.get("origin_responsiveness_custom_timeout")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a recovery action for a specific failure condition.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        '''
        result = self._values.get("origin_responsiveness_enable_recovery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        '''
        result = self._values.get("origin_responsiveness_enable_retry")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_responsiveness_monitoring(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        '''
        result = self._values.get("origin_responsiveness_monitoring")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_recovery_config_name(
        self,
    ) -> typing.Optional[builtins.str]:
        '''Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria.

        Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        '''
        result = self._values.get("origin_responsiveness_recovery_config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_responsiveness_timeout(self) -> typing.Optional[builtins.str]:
        '''The timeout threshold that triggers a retry or recovery action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        '''
        result = self._values.get("origin_responsiveness_timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring1(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        '''
        result = self._values.get("status_code_monitoring1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring2(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        '''
        result = self._values.get("status_code_monitoring2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_code_monitoring3(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        '''
        result = self._values.get("status_code_monitoring3")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tuning_parameters(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        '''
        result = self._values.get("tuning_parameters")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d1b4a56aaf72a6b54c68463091ceed3ca6eb896b93308262434c299e2516327)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBinaryEquivalentContent")
    def reset_binary_equivalent_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBinaryEquivalentContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableIpAvoidance")
    def reset_enable_ip_avoidance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableIpAvoidance", []))

    @jsii.member(jsii_name="resetIpAvoidanceErrorThreshold")
    def reset_ip_avoidance_error_threshold(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceErrorThreshold", []))

    @jsii.member(jsii_name="resetIpAvoidanceRetryInterval")
    def reset_ip_avoidance_retry_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpAvoidanceRetryInterval", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMonitorOriginResponsiveness")
    def reset_monitor_origin_responsiveness(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorOriginResponsiveness", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes1")
    def reset_monitor_response_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes1", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes2")
    def reset_monitor_response_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes2", []))

    @jsii.member(jsii_name="resetMonitorResponseCodes3")
    def reset_monitor_response_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorResponseCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1")
    def reset_monitor_status_codes1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRecovery")
    def reset_monitor_status_codes1_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1EnableRetry")
    def reset_monitor_status_codes1_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes1RecoveryConfigName")
    def reset_monitor_status_codes1_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes1RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2")
    def reset_monitor_status_codes2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRecovery")
    def reset_monitor_status_codes2_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2EnableRetry")
    def reset_monitor_status_codes2_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes2RecoveryConfigName")
    def reset_monitor_status_codes2_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes2RecoveryConfigName", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3")
    def reset_monitor_status_codes3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRecovery")
    def reset_monitor_status_codes3_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRecovery", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3EnableRetry")
    def reset_monitor_status_codes3_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3EnableRetry", []))

    @jsii.member(jsii_name="resetMonitorStatusCodes3RecoveryConfigName")
    def reset_monitor_status_codes3_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMonitorStatusCodes3RecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessCustomTimeout")
    def reset_origin_responsiveness_custom_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessCustomTimeout", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRecovery")
    def reset_origin_responsiveness_enable_recovery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRecovery", []))

    @jsii.member(jsii_name="resetOriginResponsivenessEnableRetry")
    def reset_origin_responsiveness_enable_retry(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessEnableRetry", []))

    @jsii.member(jsii_name="resetOriginResponsivenessMonitoring")
    def reset_origin_responsiveness_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessMonitoring", []))

    @jsii.member(jsii_name="resetOriginResponsivenessRecoveryConfigName")
    def reset_origin_responsiveness_recovery_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessRecoveryConfigName", []))

    @jsii.member(jsii_name="resetOriginResponsivenessTimeout")
    def reset_origin_responsiveness_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginResponsivenessTimeout", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring1")
    def reset_status_code_monitoring1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring1", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring2")
    def reset_status_code_monitoring2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring2", []))

    @jsii.member(jsii_name="resetStatusCodeMonitoring3")
    def reset_status_code_monitoring3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCodeMonitoring3", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTuningParameters")
    def reset_tuning_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTuningParameters", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContentInput")
    def binary_equivalent_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "binaryEquivalentContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidanceInput")
    def enable_ip_avoidance_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableIpAvoidanceInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThresholdInput")
    def ip_avoidance_error_threshold_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceErrorThresholdInput"))

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryIntervalInput")
    def ip_avoidance_retry_interval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipAvoidanceRetryIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsivenessInput")
    def monitor_origin_responsiveness_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorOriginResponsivenessInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1Input")
    def monitor_response_codes1_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2Input")
    def monitor_response_codes2_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3Input")
    def monitor_response_codes3_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "monitorResponseCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecoveryInput")
    def monitor_status_codes1_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetryInput")
    def monitor_status_codes1_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1Input")
    def monitor_status_codes1_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes1Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigNameInput")
    def monitor_status_codes1_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes1RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecoveryInput")
    def monitor_status_codes2_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetryInput")
    def monitor_status_codes2_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2Input")
    def monitor_status_codes2_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes2Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigNameInput")
    def monitor_status_codes2_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes2RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecoveryInput")
    def monitor_status_codes3_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetryInput")
    def monitor_status_codes3_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3EnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3Input")
    def monitor_status_codes3_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "monitorStatusCodes3Input"))

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigNameInput")
    def monitor_status_codes3_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "monitorStatusCodes3RecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeoutInput")
    def origin_responsiveness_custom_timeout_input(
        self,
    ) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "originResponsivenessCustomTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecoveryInput")
    def origin_responsiveness_enable_recovery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRecoveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetryInput")
    def origin_responsiveness_enable_retry_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originResponsivenessEnableRetryInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoringInput")
    def origin_responsiveness_monitoring_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigNameInput")
    def origin_responsiveness_recovery_config_name_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessRecoveryConfigNameInput"))

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeoutInput")
    def origin_responsiveness_timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originResponsivenessTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1Input")
    def status_code_monitoring1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring1Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2Input")
    def status_code_monitoring2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring2Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3Input")
    def status_code_monitoring3_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "statusCodeMonitoring3Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tuningParametersInput")
    def tuning_parameters_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tuningParametersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="binaryEquivalentContent")
    def binary_equivalent_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "binaryEquivalentContent"))

    @binary_equivalent_content.setter
    def binary_equivalent_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__294e0f8d0c79caf6a2cfc26fb26758b4c700cde92ba82bdae90dfbb54cc9ce33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "binaryEquivalentContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2380f876057b68149cb9221e133e4489d30c8414d00f70afc633bf8045d300c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableIpAvoidance")
    def enable_ip_avoidance(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableIpAvoidance"))

    @enable_ip_avoidance.setter
    def enable_ip_avoidance(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__853423f0571560226da479255de61b8ff5f1d8e4ef61ed9e061c2fe0c9bded73)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableIpAvoidance", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceErrorThreshold")
    def ip_avoidance_error_threshold(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceErrorThreshold"))

    @ip_avoidance_error_threshold.setter
    def ip_avoidance_error_threshold(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379abdfbfe21cf158cb5bdeceb039b50d3d7bd17b27b39eb93793bda12c7d7e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceErrorThreshold", value)

    @builtins.property
    @jsii.member(jsii_name="ipAvoidanceRetryInterval")
    def ip_avoidance_retry_interval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipAvoidanceRetryInterval"))

    @ip_avoidance_retry_interval.setter
    def ip_avoidance_retry_interval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be94552f8eeab9a5f5a35b66445e73a09bc4de323745a80323a04ec408cc6ec1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipAvoidanceRetryInterval", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e79d4f741d33d4bfa934b09f89171f3305928501f0d343b3a720eea337fd3f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="monitorOriginResponsiveness")
    def monitor_origin_responsiveness(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorOriginResponsiveness"))

    @monitor_origin_responsiveness.setter
    def monitor_origin_responsiveness(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d380f7aead6ff968076eb168647c8195881a8773841376fa2743ca5e9fc99ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorOriginResponsiveness", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes1")
    def monitor_response_codes1(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes1"))

    @monitor_response_codes1.setter
    def monitor_response_codes1(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b20866790eecea3af19ffa1315a1b4b0c7106029a56eec36730fb2fcd7a741b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes2")
    def monitor_response_codes2(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes2"))

    @monitor_response_codes2.setter
    def monitor_response_codes2(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c8e71a5856afd85ba57bfaa692351bfc41baf2b9392367c25a847593701137)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorResponseCodes3")
    def monitor_response_codes3(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "monitorResponseCodes3"))

    @monitor_response_codes3.setter
    def monitor_response_codes3(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6dc3ce8b1e422e9a5be053cb7cbf5516fa5bfc4f24d984ab518e506a30a16d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorResponseCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1")
    def monitor_status_codes1(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1"))

    @monitor_status_codes1.setter
    def monitor_status_codes1(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd42558edf00b933d3b812e308386fd1e2ec69e5cbb0325009502aa32dc8b74a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRecovery")
    def monitor_status_codes1_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRecovery"))

    @monitor_status_codes1_enable_recovery.setter
    def monitor_status_codes1_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d825808b914932079c55b315e681204d415c8e8205a269f41350d621ec9f1d2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1EnableRetry")
    def monitor_status_codes1_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes1EnableRetry"))

    @monitor_status_codes1_enable_retry.setter
    def monitor_status_codes1_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55570879c78d27d3365bd0392e723df3dfff3d9a20e6cddfa228f1ecf5c5c7cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes1RecoveryConfigName")
    def monitor_status_codes1_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes1RecoveryConfigName"))

    @monitor_status_codes1_recovery_config_name.setter
    def monitor_status_codes1_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__003c59410ea4461391df912e025b95647845e447656ad96a8534e8781aced50f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes1RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2")
    def monitor_status_codes2(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2"))

    @monitor_status_codes2.setter
    def monitor_status_codes2(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a5712fc42efb967bec5dde24e41ccdfbdc769d5f5d89e9410b8d41416806df2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRecovery")
    def monitor_status_codes2_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRecovery"))

    @monitor_status_codes2_enable_recovery.setter
    def monitor_status_codes2_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2a6759750dd6d3091d52e48f340917747450d370142314805456052be069e79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2EnableRetry")
    def monitor_status_codes2_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes2EnableRetry"))

    @monitor_status_codes2_enable_retry.setter
    def monitor_status_codes2_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80054aa4f61921faefd08c0b95326b371a9b0a5aed5f36c23a11c440282bd98b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes2RecoveryConfigName")
    def monitor_status_codes2_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes2RecoveryConfigName"))

    @monitor_status_codes2_recovery_config_name.setter
    def monitor_status_codes2_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__76c19fe503f1879e77c3e6dccf5dfe2ad5a688ed5d9965aacb5efc5ed3e8001f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes2RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3")
    def monitor_status_codes3(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3"))

    @monitor_status_codes3.setter
    def monitor_status_codes3(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfb742bf857608656ddb1c61f47fa25400131e5afcb085fe86cc97354c36c779)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRecovery")
    def monitor_status_codes3_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRecovery"))

    @monitor_status_codes3_enable_recovery.setter
    def monitor_status_codes3_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d0fb38c852a4ed0a5999c3acc7d03b47de964afacd1e54a38681a824050b5a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3EnableRetry")
    def monitor_status_codes3_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "monitorStatusCodes3EnableRetry"))

    @monitor_status_codes3_enable_retry.setter
    def monitor_status_codes3_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7cc25e3dc68023fdd610f199fee2843de6f6f454e2729169938b368f2ede6105)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3EnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="monitorStatusCodes3RecoveryConfigName")
    def monitor_status_codes3_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "monitorStatusCodes3RecoveryConfigName"))

    @monitor_status_codes3_recovery_config_name.setter
    def monitor_status_codes3_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43305f6983aee1d4bf50cdb5d72e5bc88599de5f578df17a997bccd7eafa4e82)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "monitorStatusCodes3RecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessCustomTimeout")
    def origin_responsiveness_custom_timeout(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "originResponsivenessCustomTimeout"))

    @origin_responsiveness_custom_timeout.setter
    def origin_responsiveness_custom_timeout(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ebd7fabcef6cddd76337286860696e72e15dffb545a4a74c2947d86921f552a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessCustomTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRecovery")
    def origin_responsiveness_enable_recovery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRecovery"))

    @origin_responsiveness_enable_recovery.setter
    def origin_responsiveness_enable_recovery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__667fcc8bfa2d70bb2ab45be3d39dc45defe7d60ea5829ed6babce92f35a77519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRecovery", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessEnableRetry")
    def origin_responsiveness_enable_retry(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originResponsivenessEnableRetry"))

    @origin_responsiveness_enable_retry.setter
    def origin_responsiveness_enable_retry(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f42e9c8a6bae71c122ca7fbc82127695b3de7e4ea98db2c13db44f037e3496c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessEnableRetry", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessMonitoring")
    def origin_responsiveness_monitoring(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessMonitoring"))

    @origin_responsiveness_monitoring.setter
    def origin_responsiveness_monitoring(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6590e8edcaadce48fdd8d1193f741d5bc12573aceddb7c06aef99056de77898b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessMonitoring", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessRecoveryConfigName")
    def origin_responsiveness_recovery_config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessRecoveryConfigName"))

    @origin_responsiveness_recovery_config_name.setter
    def origin_responsiveness_recovery_config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a93e98e6f4156e7152db2fbe397df1d00810303e84c8831c216d54abdd8f443)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessRecoveryConfigName", value)

    @builtins.property
    @jsii.member(jsii_name="originResponsivenessTimeout")
    def origin_responsiveness_timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originResponsivenessTimeout"))

    @origin_responsiveness_timeout.setter
    def origin_responsiveness_timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1724999dc37b41e5e0f402504eb50d497586a49cbf7dfd0c8987353dc612f6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originResponsivenessTimeout", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring1")
    def status_code_monitoring1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring1"))

    @status_code_monitoring1.setter
    def status_code_monitoring1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6d4576709f58d52f08e79ab0de46a3f2c8d62913abf78197e9aef50e2735976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring1", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring2")
    def status_code_monitoring2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring2"))

    @status_code_monitoring2.setter
    def status_code_monitoring2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7595c25f240a01ca119ad9a9b15df120a15d4e22e30ca9be3598cc802c103b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring2", value)

    @builtins.property
    @jsii.member(jsii_name="statusCodeMonitoring3")
    def status_code_monitoring3(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "statusCodeMonitoring3"))

    @status_code_monitoring3.setter
    def status_code_monitoring3(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbc828e19023e8717ad035ec3e83d824a8a291e517d97edab50053c2a8d59a6b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCodeMonitoring3", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d02b6cf2b440c87c16508b759fefea9bb59762f79e334a5630483fa74dd3237)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tuningParameters")
    def tuning_parameters(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tuningParameters"))

    @tuning_parameters.setter
    def tuning_parameters(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3feba49c4f6595b49a4ed06dd40aadb6b87f36bfe9bc758bd668ec403717996)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tuningParameters", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a9f8f4fc41047b934cd875db68b8b4a971e2684a3527986ebd9de84889d5c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad32a67a1a4f1b4055feb681c53891f66b34afa35ea51ad3dca42f97c6b00228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl",
    jsii_struct_bases=[],
    name_mapping={
        "enable": "enable",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl:
    def __init__(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e04606e3e86036b68ecc9fa7dcb244228e913f3f8c6786c7b11b111867d90e68)
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Origin IP Access Control List behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAclOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAclOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__998ff54a1b3ebc215cb1c4b35a4dc7ed8c9502eca08590fd4a3a9fe25cb7066d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ef36fddd46bf7a7d915e10a300a3dc42b4c089edc30e15e30eab6fce0d11b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2b99315515bc8053c476c3f11bc1306ebeb346b9c4fac7ea87a93931f23979c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7007835b2d654190077b4173e4b0c46554fb10bb9a0e4e0ce1936029dfa56e13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5635d5c698137f7e04419c02fcfdcb9481fa19e66ad6b69580d12c3e5362468)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3952d7d030d9a32369809a90f97a09a42e3b9940ccb44d566231054674b30e9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25108e73df6c55df2542e18c0764e2d0eacaa781d5c79e015f2b4a8aa6da00dc)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d17672946af7e730f5a38080c233408cafa75ffb5cc8b1e78f7e4725d0a707a0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4ddf420c65e994874eba9a793e3a8ecb68d740297b157ac97740a09b931bb8e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__388c67b68c994e14226f60ba23a4c465ce4fc3354be6c86b102db2773fbcb285)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f32082d0be633745b5825d50f6ce7b27150bcec0a152cc03d72b89bf73aa34e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c43f84c7d1da7479bb5d333ea6681344bdc36f2ee73f6ef063c54d388e83401)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df845407da98d830438b77aaaf99edd2a930244ae5bfedcf76e80295530eee4f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCustomCertificateAuthorities")
    def put_custom_certificate_authorities(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__161ac6cdfaa99f4b209cbc4cf4043a82551465950b1e81e601ac2c7683f4b177)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificateAuthorities", [value]))

    @jsii.member(jsii_name="putCustomCertificates")
    def put_custom_certificates(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47fb21c2e999d813665eb79b3c8b7b0b685085670ec010ae9aa1e0df31171b42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCustomCertificates", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetCacheKeyHostname")
    def reset_cache_key_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyHostname", []))

    @jsii.member(jsii_name="resetCompress")
    def reset_compress(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCompress", []))

    @jsii.member(jsii_name="resetCustomCertificateAuthorities")
    def reset_custom_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificateAuthorities", []))

    @jsii.member(jsii_name="resetCustomCertificates")
    def reset_custom_certificates(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCertificates", []))

    @jsii.member(jsii_name="resetCustomForwardHostHeader")
    def reset_custom_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomForwardHostHeader", []))

    @jsii.member(jsii_name="resetCustomValidCnValues")
    def reset_custom_valid_cn_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomValidCnValues", []))

    @jsii.member(jsii_name="resetEnableTrueClientIp")
    def reset_enable_true_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTrueClientIp", []))

    @jsii.member(jsii_name="resetForwardHostHeader")
    def reset_forward_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardHostHeader", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetHttpPort")
    def reset_http_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpPort", []))

    @jsii.member(jsii_name="resetHttpsPort")
    def reset_https_port(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpsPort", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaxTlsVersion")
    def reset_max_tls_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxTlsVersion", []))

    @jsii.member(jsii_name="resetMinTlsVersion")
    def reset_min_tls_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinTlsVersion", []))

    @jsii.member(jsii_name="resetMslorigin")
    def reset_mslorigin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMslorigin", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetOriginCertificate")
    def reset_origin_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertificate", []))

    @jsii.member(jsii_name="resetOriginCertsToHonor")
    def reset_origin_certs_to_honor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCertsToHonor", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetOriginSni")
    def reset_origin_sni(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSni", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetPorts")
    def reset_ports(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPorts", []))

    @jsii.member(jsii_name="resetSaasCnameEnabled")
    def reset_saas_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameEnabled", []))

    @jsii.member(jsii_name="resetSaasCnameLevel")
    def reset_saas_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCnameLevel", []))

    @jsii.member(jsii_name="resetSaasCookie")
    def reset_saas_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasCookie", []))

    @jsii.member(jsii_name="resetSaasQueryString")
    def reset_saas_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasQueryString", []))

    @jsii.member(jsii_name="resetSaasRegex")
    def reset_saas_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasRegex", []))

    @jsii.member(jsii_name="resetSaasReplace")
    def reset_saas_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasReplace", []))

    @jsii.member(jsii_name="resetSaasSuffix")
    def reset_saas_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasSuffix", []))

    @jsii.member(jsii_name="resetSaasType")
    def reset_saas_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasType", []))

    @jsii.member(jsii_name="resetSecondHostname")
    def reset_second_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostname", []))

    @jsii.member(jsii_name="resetSecondHostnameEnabled")
    def reset_second_hostname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecondHostnameEnabled", []))

    @jsii.member(jsii_name="resetStandardCertificateAuthorities")
    def reset_standard_certificate_authorities(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardCertificateAuthorities", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTls13Support")
    def reset_tls13_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTls13Support", []))

    @jsii.member(jsii_name="resetTlsVersionTitle")
    def reset_tls_version_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTlsVersionTitle", []))

    @jsii.member(jsii_name="resetTrueClientIpClientSetting")
    def reset_true_client_ip_client_setting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpClientSetting", []))

    @jsii.member(jsii_name="resetTrueClientIpHeader")
    def reset_true_client_ip_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTrueClientIpHeader", []))

    @jsii.member(jsii_name="resetUseUniqueCacheKey")
    def reset_use_unique_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseUniqueCacheKey", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationMode")
    def reset_verification_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationMode", []))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthorities")
    def custom_certificate_authorities(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesList, jsii.get(self, "customCertificateAuthorities"))

    @builtins.property
    @jsii.member(jsii_name="customCertificates")
    def custom_certificates(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesList, jsii.get(self, "customCertificates"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostnameInput")
    def cache_key_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheKeyHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="compressInput")
    def compress_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "compressInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificateAuthoritiesInput")
    def custom_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]]], jsii.get(self, "customCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customCertificatesInput")
    def custom_certificates_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]]], jsii.get(self, "customCertificatesInput"))

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeaderInput")
    def custom_forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customForwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="customValidCnValuesInput")
    def custom_valid_cn_values_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "customValidCnValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIpInput")
    def enable_true_client_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTrueClientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeaderInput")
    def forward_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forwardHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="httpPortInput")
    def http_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpPortInput"))

    @builtins.property
    @jsii.member(jsii_name="httpsPortInput")
    def https_port_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "httpsPortInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxTlsVersionInput")
    def max_tls_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maxTlsVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="minTlsVersionInput")
    def min_tls_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "minTlsVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="msloriginInput")
    def mslorigin_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "msloriginInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertificateInput")
    def origin_certificate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonorInput")
    def origin_certs_to_honor_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originCertsToHonorInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="originSniInput")
    def origin_sni_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originSniInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="portsInput")
    def ports_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "portsInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabledInput")
    def saas_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "saasCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevelInput")
    def saas_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "saasCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="saasCookieInput")
    def saas_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="saasQueryStringInput")
    def saas_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="saasRegexInput")
    def saas_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="saasReplaceInput")
    def saas_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="saasSuffixInput")
    def saas_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="saasTypeInput")
    def saas_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saasTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabledInput")
    def second_hostname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secondHostnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="secondHostnameInput")
    def second_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "secondHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthoritiesInput")
    def standard_certificate_authorities_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "standardCertificateAuthoritiesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tls13SupportInput")
    def tls13_support_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tls13SupportInput"))

    @builtins.property
    @jsii.member(jsii_name="tlsVersionTitleInput")
    def tls_version_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tlsVersionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSettingInput")
    def true_client_ip_client_setting_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "trueClientIpClientSettingInput"))

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeaderInput")
    def true_client_ip_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "trueClientIpHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKeyInput")
    def use_unique_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useUniqueCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationModeInput")
    def verification_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationModeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyHostname")
    def cache_key_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheKeyHostname"))

    @cache_key_hostname.setter
    def cache_key_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f22bebcfc83a75d7bca161126cdf930ff5a5c5c4d2738f13cd1f6e7a1533121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKeyHostname", value)

    @builtins.property
    @jsii.member(jsii_name="compress")
    def compress(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "compress"))

    @compress.setter
    def compress(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4868a5f128637538fe967ead06a0ab9b64b4ca83d6a3d2bbcb459628fa27d7fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "compress", value)

    @builtins.property
    @jsii.member(jsii_name="customForwardHostHeader")
    def custom_forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customForwardHostHeader"))

    @custom_forward_host_header.setter
    def custom_forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eb837f3efded3b5d9d71cbe84282a0b399fd76ddc62f032df4f8fbc4bad09170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customForwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="customValidCnValues")
    def custom_valid_cn_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "customValidCnValues"))

    @custom_valid_cn_values.setter
    def custom_valid_cn_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__938b897a70b679947b9a38e65aa869f0a2f483ce7aa6f47750e38e780a7ab83c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customValidCnValues", value)

    @builtins.property
    @jsii.member(jsii_name="enableTrueClientIp")
    def enable_true_client_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTrueClientIp"))

    @enable_true_client_ip.setter
    def enable_true_client_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f0bac425785163dda5a85ac79cd23d45e5c5e8142a269db646425c36a21f96b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTrueClientIp", value)

    @builtins.property
    @jsii.member(jsii_name="forwardHostHeader")
    def forward_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forwardHostHeader"))

    @forward_host_header.setter
    def forward_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff637ab3e3d35bfce9b6b1b2b0340624e8d9c92a887586ea6b6a24d76f5fe982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forwardHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostname"))

    @hostname.setter
    def hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21c8a854aa9e91cdfdaae080441b519683449afc881960ce3546752f8ad238e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostname", value)

    @builtins.property
    @jsii.member(jsii_name="httpPort")
    def http_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpPort"))

    @http_port.setter
    def http_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1bb99b4db671f8f9d0910d478a6ba5c21d9a5212495ec218075f767b59a97dba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpPort", value)

    @builtins.property
    @jsii.member(jsii_name="httpsPort")
    def https_port(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "httpsPort"))

    @https_port.setter
    def https_port(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__533d4bb5d8c2a51cd433a4bf7c894867bf56c6b03a13aad016fe3a489c79b447)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpsPort", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f49a64a92e06c3927fedf33a2e93a521fd499d68798c326768e715cc9daa00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51edbd45720a0d7f7c673133796d00d0ea59ca2196ae30e10298e1bb335dd1c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maxTlsVersion")
    def max_tls_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maxTlsVersion"))

    @max_tls_version.setter
    def max_tls_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8617adbadee258200263c06600b4d2973b5825e28805a501da14ee88c51bb79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxTlsVersion", value)

    @builtins.property
    @jsii.member(jsii_name="minTlsVersion")
    def min_tls_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "minTlsVersion"))

    @min_tls_version.setter
    def min_tls_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3631a2d4411693b31bbed6dc216c2aabb41e8c3940d97a48bba4bd688f34d04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minTlsVersion", value)

    @builtins.property
    @jsii.member(jsii_name="mslorigin")
    def mslorigin(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mslorigin"))

    @mslorigin.setter
    def mslorigin(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca05ec227000353d87873de671ca49b40ab8baaadb45a99973a60f18c79741c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mslorigin", value)

    @builtins.property
    @jsii.member(jsii_name="originCertificate")
    def origin_certificate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertificate"))

    @origin_certificate.setter
    def origin_certificate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59797642b8d10ce5f16007033cb5cacad8c932378caa3e990ee6915139ede24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertificate", value)

    @builtins.property
    @jsii.member(jsii_name="originCertsToHonor")
    def origin_certs_to_honor(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originCertsToHonor"))

    @origin_certs_to_honor.setter
    def origin_certs_to_honor(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32256ddb2e96674cdd78879df54b3d4d098b2bbbb509c9b317cce2b7d4af8fae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originCertsToHonor", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c0559be2ff77f1baad769a6224cefe051e35cb65c9b2a5a2751887f247e00a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="originSni")
    def origin_sni(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "originSni"))

    @origin_sni.setter
    def origin_sni(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72ffc1640584b7bdd0beff6d57a292f672e17c830dc2a007247f20cc25aaff25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSni", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d08934e7bfadbce23f5a0f7ea4ec4949da43ed0870806273384d16c7e0da8dae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="ports")
    def ports(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ports"))

    @ports.setter
    def ports(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__daa1c34112aa42bfb050f6cd0a01cdf8b42cc88241c1e3e12200811232d31eca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ports", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameEnabled")
    def saas_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "saasCnameEnabled"))

    @saas_cname_enabled.setter
    def saas_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1b01c89e2d91bcfba2abad6a6f624cdbef21cb858dd072c815934a72390e491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="saasCnameLevel")
    def saas_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "saasCnameLevel"))

    @saas_cname_level.setter
    def saas_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__507be261daada3b6e0eaad62a321f7df73b237302c671e025644ac78996edc6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="saasCookie")
    def saas_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasCookie"))

    @saas_cookie.setter
    def saas_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74db62f1dbcb8b2fe400a2f5ac332207333a0b351880865ba724af8c053d1676)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasCookie", value)

    @builtins.property
    @jsii.member(jsii_name="saasQueryString")
    def saas_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasQueryString"))

    @saas_query_string.setter
    def saas_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82db1ae169a01623fc770b7b11875bc284d9b47e784f08359f7e129b90d0e148)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="saasRegex")
    def saas_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasRegex"))

    @saas_regex.setter
    def saas_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6ecf6f2331e9d9df83ef9a64fe2579a70df6d4289cf0bf68d1d463feca4a5aa1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasRegex", value)

    @builtins.property
    @jsii.member(jsii_name="saasReplace")
    def saas_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasReplace"))

    @saas_replace.setter
    def saas_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0743eb910615958adeddf9344c1b1fd7d671182ef359b053a0e7b0a5b43e9561)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasReplace", value)

    @builtins.property
    @jsii.member(jsii_name="saasSuffix")
    def saas_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasSuffix"))

    @saas_suffix.setter
    def saas_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05c9795039d0d10e22c7835f89ec18a9057d6d250cca174b10cba8c80086cdf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="saasType")
    def saas_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "saasType"))

    @saas_type.setter
    def saas_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ca964755532cc34ee9ff7fe5543794510bf5d8c9277f03fae3474f5956a0b12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "saasType", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostname")
    def second_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "secondHostname"))

    @second_hostname.setter
    def second_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d6e7327b605e78c1e54bf27ff600af63cce11f012e8ec61e6fb060566ad7161)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostname", value)

    @builtins.property
    @jsii.member(jsii_name="secondHostnameEnabled")
    def second_hostname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secondHostnameEnabled"))

    @second_hostname_enabled.setter
    def second_hostname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11dd33cbdafbff5aabed8b9bed0bc2a7384c23c74ca3635ac8853ef5b09e8f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secondHostnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="standardCertificateAuthorities")
    def standard_certificate_authorities(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "standardCertificateAuthorities"))

    @standard_certificate_authorities.setter
    def standard_certificate_authorities(
        self,
        value: typing.List[builtins.str],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7479b1ce1c92e098107946b8014b2f029208a69a061c79ab51a354614a4e3ed4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "standardCertificateAuthorities", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e024bbc09bb147ed7e58431a4548ffa531599a3ac6682b67eeee7f3da4ef24e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tls13Support")
    def tls13_support(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tls13Support"))

    @tls13_support.setter
    def tls13_support(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1d9c438edd5aa6a519c7589993a517714225410ab29c44f41d0203aeea8c2d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tls13Support", value)

    @builtins.property
    @jsii.member(jsii_name="tlsVersionTitle")
    def tls_version_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tlsVersionTitle"))

    @tls_version_title.setter
    def tls_version_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f82eb34b175b33d3f4be668473cae86b168628c1fa710f9d4b8e2acce82a6ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tlsVersionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpClientSetting")
    def true_client_ip_client_setting(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "trueClientIpClientSetting"))

    @true_client_ip_client_setting.setter
    def true_client_ip_client_setting(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e83bbab0b360e761574de1a5f96c81cf5b46afc34a2da3eff92d627600f2d7be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpClientSetting", value)

    @builtins.property
    @jsii.member(jsii_name="trueClientIpHeader")
    def true_client_ip_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "trueClientIpHeader"))

    @true_client_ip_header.setter
    def true_client_ip_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bc59639c99978837f1307fe859433f92317bc70d8b8226a4fe6524ebaae5e0d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "trueClientIpHeader", value)

    @builtins.property
    @jsii.member(jsii_name="useUniqueCacheKey")
    def use_unique_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useUniqueCacheKey"))

    @use_unique_cache_key.setter
    def use_unique_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a95be1223a6bee36e44f84c5755be641496af3f899ea4ae5f90083677ec7af8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useUniqueCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e969429dbbdab64b07ea15cfa17f25a555bda0a790f00a0fa866d146fba93b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationMode")
    def verification_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationMode"))

    @verification_mode.setter
    def verification_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cfc651e8f291dc6e28e937f596d9730a59624d55f9b682e2437247215551ce4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adf8709787ae023480f15e71f40587538949d55e85cd42a1462f7f2b4478ea52)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__605f646db0684b7de3b848d3f61c406981349c7bfda480a1d2acd9e1ffee3674)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdaptiveAcceleration")
    def put_adaptive_acceleration(
        self,
        *,
        ab_logic: typing.Optional[builtins.str] = None,
        ab_testing: typing.Optional[builtins.str] = None,
        compression: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        source: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_brotli: typing.Optional[builtins.str] = None,
        title_http2_server_push: typing.Optional[builtins.str] = None,
        title_preconnect: typing.Optional[builtins.str] = None,
        title_preload: typing.Optional[builtins.str] = None,
        title_ro: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_logic: Specifies whether to use Adaptive Acceleration in an A/B testing environment. To include Adaptive Acceleration data in your A/B testing, specify the mode you want to apply. Otherwise, ``DISABLED`` by default. See ``Add A/B testing to A2`` for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_logic DataAkamaiPropertyRulesBuilder#ab_logic}
        :param ab_testing: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_testing DataAkamaiPropertyRulesBuilder#ab_testing}
        :param compression: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compression DataAkamaiPropertyRulesBuilder#compression}
        :param cookie_name: This specifies the name of the cookie file used for redirecting the requests in the A/B testing environment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param enable_brotli_compression: Applies Brotli compression, converting your origin content to cache on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_brotli_compression DataAkamaiPropertyRulesBuilder#enable_brotli_compression}
        :param enable_for_noncacheable: Applies Brotli compression to non-cacheable content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_for_noncacheable DataAkamaiPropertyRulesBuilder#enable_for_noncacheable}
        :param enable_preconnect: Allows browsers to anticipate what connections your site needs, and establishes those connections ahead of time. See ``Automatic Preconnect`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_preconnect DataAkamaiPropertyRulesBuilder#enable_preconnect}
        :param enable_push: Recognizes resources like JavaScript, CSS, and images based on gathered timing data and sends these resources to a browser as it's waiting for a response to the initial request for your website or app. See ``Automatic Server Push`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_push DataAkamaiPropertyRulesBuilder#enable_push}
        :param enable_ro: Enables the Resource Optimizer, which automates the compression and delivery of your ``.css``, ``.js``, and ``.svg`` content using a combination of Brotli and Zopfli compressions. The compression is performed offline, during a time to live that the feature automatically sets. See the ``resourceOptimizer`` and ``resourceOptimizerExtendedCompatibility`` behaviors for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ro DataAkamaiPropertyRulesBuilder#enable_ro}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preload_enable: Allows browsers to preload necessary fonts before they fetch and process other resources. See ``Automatic Font Preload`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload_enable DataAkamaiPropertyRulesBuilder#preload_enable}
        :param source: The source Adaptive Acceleration uses to gather the real user monitoring timing data, either ``mPulse`` or ``realUserMonitoring``. The recommended ``mPulse`` option supports all optimizations and requires the ``mPulse`` behavior added by default to new Ion properties. The classic ``realUserMonitoring`` method has been deprecated. If you set it as the data source, make sure you use it with the ``realUserMonitoring`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source DataAkamaiPropertyRulesBuilder#source}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_brotli: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_brotli DataAkamaiPropertyRulesBuilder#title_brotli}
        :param title_http2_server_push: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_http2_server_push DataAkamaiPropertyRulesBuilder#title_http2_server_push}
        :param title_preconnect: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preconnect DataAkamaiPropertyRulesBuilder#title_preconnect}
        :param title_preload: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_preload DataAkamaiPropertyRulesBuilder#title_preload}
        :param title_ro: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_ro DataAkamaiPropertyRulesBuilder#title_ro}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration(
            ab_logic=ab_logic,
            ab_testing=ab_testing,
            compression=compression,
            cookie_name=cookie_name,
            enable_brotli_compression=enable_brotli_compression,
            enable_for_noncacheable=enable_for_noncacheable,
            enable_preconnect=enable_preconnect,
            enable_push=enable_push,
            enable_ro=enable_ro,
            locked=locked,
            preload_enable=preload_enable,
            source=source,
            template_uuid=template_uuid,
            title_brotli=title_brotli,
            title_http2_server_push=title_http2_server_push,
            title_preconnect=title_preconnect,
            title_preload=title_preload,
            title_ro=title_ro,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveAcceleration", [value]))

    @jsii.member(jsii_name="putAdaptiveImageCompression")
    def put_adaptive_image_compression(
        self,
        *,
        compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier1_standard_compression_method: typing.Optional[builtins.str] = None,
        tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier2_standard_compression_method: typing.Optional[builtins.str] = None,
        tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
        tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
        tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
        tier3_standard_compression_method: typing.Optional[builtins.str] = None,
        tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
        title_aic_mobile: typing.Optional[builtins.str] = None,
        title_aic_nonmobile: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compress_mobile: Adapts images served over cellular mobile networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_mobile DataAkamaiPropertyRulesBuilder#compress_mobile}
        :param compress_standard: Adapts images served over non-cellular networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress_standard DataAkamaiPropertyRulesBuilder#compress_standard}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_mobile_compression_method: Specifies tier-1 behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_method}
        :param tier1_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier1_mobile_compression_value}
        :param tier1_standard_compression_method: Specifies tier-1 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_method DataAkamaiPropertyRulesBuilder#tier1_standard_compression_method}
        :param tier1_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_standard_compression_value DataAkamaiPropertyRulesBuilder#tier1_standard_compression_value}
        :param tier2_mobile_compression_method: Specifies tier-2 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_method}
        :param tier2_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier2_mobile_compression_value}
        :param tier2_standard_compression_method: Specifies tier-2 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_method DataAkamaiPropertyRulesBuilder#tier2_standard_compression_method}
        :param tier2_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier2_standard_compression_value DataAkamaiPropertyRulesBuilder#tier2_standard_compression_value}
        :param tier3_mobile_compression_method: Specifies tier-3 cellular-network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_method DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_method}
        :param tier3_mobile_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_mobile_compression_value DataAkamaiPropertyRulesBuilder#tier3_mobile_compression_value}
        :param tier3_standard_compression_method: Specifies tier-3 non-cellular network behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_method DataAkamaiPropertyRulesBuilder#tier3_standard_compression_method}
        :param tier3_standard_compression_value: Specifies the compression percentage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier3_standard_compression_value DataAkamaiPropertyRulesBuilder#tier3_standard_compression_value}
        :param title_aic_mobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_mobile DataAkamaiPropertyRulesBuilder#title_aic_mobile}
        :param title_aic_nonmobile: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_aic_nonmobile DataAkamaiPropertyRulesBuilder#title_aic_nonmobile}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression(
            compress_mobile=compress_mobile,
            compress_standard=compress_standard,
            locked=locked,
            template_uuid=template_uuid,
            tier1_mobile_compression_method=tier1_mobile_compression_method,
            tier1_mobile_compression_value=tier1_mobile_compression_value,
            tier1_standard_compression_method=tier1_standard_compression_method,
            tier1_standard_compression_value=tier1_standard_compression_value,
            tier2_mobile_compression_method=tier2_mobile_compression_method,
            tier2_mobile_compression_value=tier2_mobile_compression_value,
            tier2_standard_compression_method=tier2_standard_compression_method,
            tier2_standard_compression_value=tier2_standard_compression_value,
            tier3_mobile_compression_method=tier3_mobile_compression_method,
            tier3_mobile_compression_value=tier3_mobile_compression_value,
            tier3_standard_compression_method=tier3_standard_compression_method,
            tier3_standard_compression_value=tier3_standard_compression_value,
            title_aic_mobile=title_aic_mobile,
            title_aic_nonmobile=title_aic_nonmobile,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdaptiveImageCompression", [value]))

    @jsii.member(jsii_name="putAdScalerCircuitBreaker")
    def put_ad_scaler_circuit_breaker(
        self,
        *,
        fallback_action_response_code_based: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_codes: typing.Optional[builtins.str] = None,
        response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_delay_threshold: typing.Optional[builtins.str] = None,
        return_error_response_code_based: typing.Optional[builtins.str] = None,
        specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param fallback_action_response_code_based: Specifies the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fallback_action_response_code_based DataAkamaiPropertyRulesBuilder#fallback_action_response_code_based}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code_based: Triggers a fallback action based on the response code from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code_based DataAkamaiPropertyRulesBuilder#response_code_based}
        :param response_codes: Specifies the codes in the partner's response that trigger the fallback action, either ``408``, ``500``, ``502``, ``504``, ``SAME_AS_RECEIEVED``, or ``SPECIFY_YOUR_OWN`` for a custom code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_codes DataAkamaiPropertyRulesBuilder#response_codes}
        :param response_delay_based: Triggers a fallback action based on the delayed response from the technology partner's server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_based DataAkamaiPropertyRulesBuilder#response_delay_based}
        :param response_delay_threshold: Specifies the maximum response delay that, if exceeded, triggers the fallback action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_delay_threshold DataAkamaiPropertyRulesBuilder#response_delay_threshold}
        :param return_error_response_code_based: Specifies the error to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#return_error_response_code_based DataAkamaiPropertyRulesBuilder#return_error_response_code_based}
        :param specify_your_own_response_code_based: Defines a custom error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_your_own_response_code_based DataAkamaiPropertyRulesBuilder#specify_your_own_response_code_based}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker(
            fallback_action_response_code_based=fallback_action_response_code_based,
            locked=locked,
            response_code_based=response_code_based,
            response_codes=response_codes,
            response_delay_based=response_delay_based,
            response_delay_threshold=response_delay_threshold,
            return_error_response_code_based=return_error_response_code_based,
            specify_your_own_response_code_based=specify_your_own_response_code_based,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdScalerCircuitBreaker", [value]))

    @jsii.member(jsii_name="putAdvanced")
    def put_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvanced", [value]))

    @jsii.member(jsii_name="putAggregatedReporting")
    def put_aggregated_reporting(
        self,
        *,
        attribute1: typing.Optional[builtins.str] = None,
        attribute2: typing.Optional[builtins.str] = None,
        attribute3: typing.Optional[builtins.str] = None,
        attribute4: typing.Optional[builtins.str] = None,
        attributes_count: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        report_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param attribute1: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute1 DataAkamaiPropertyRulesBuilder#attribute1}
        :param attribute2: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute2 DataAkamaiPropertyRulesBuilder#attribute2}
        :param attribute3: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute3 DataAkamaiPropertyRulesBuilder#attribute3}
        :param attribute4: Specify a previously user-defined variable name as a report attribute. The values extracted for all attributes range from 0 to 20 characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attribute4 DataAkamaiPropertyRulesBuilder#attribute4}
        :param attributes_count: The number of attributes to include in the report, ranging from 1 to 4. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#attributes_count DataAkamaiPropertyRulesBuilder#attributes_count}
        :param enabled: Enables aggregated reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param report_name: The unique name of the aggregated report within the property. If you reconfigure any attributes or variables in the aggregated reporting behavior, update this field to a unique value to enable logging data in a new instance of the report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#report_name DataAkamaiPropertyRulesBuilder#report_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting(
            attribute1=attribute1,
            attribute2=attribute2,
            attribute3=attribute3,
            attribute4=attribute4,
            attributes_count=attributes_count,
            enabled=enabled,
            locked=locked,
            report_name=report_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAggregatedReporting", [value]))

    @jsii.member(jsii_name="putAkamaizer")
    def put_akamaizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Akamaizer behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizer", [value]))

    @jsii.member(jsii_name="putAkamaizerTag")
    def put_akamaizer_tag(
        self,
        *,
        include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_hostname: typing.Optional[builtins.str] = None,
        replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        replacement_hostname: typing.Optional[builtins.str] = None,
        scope: typing.Optional[builtins.str] = None,
        tags_attribute: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param include_tags_attribute: Whether to include the ``tagsAttribute`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_tags_attribute DataAkamaiPropertyRulesBuilder#include_tags_attribute}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_hostname: Specifies the hostname to match on as a Perl-compatible regular expression. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_hostname DataAkamaiPropertyRulesBuilder#match_hostname}
        :param replace_all: Replaces all matches when enabled, otherwise replaces only the first match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replace_all DataAkamaiPropertyRulesBuilder#replace_all}
        :param replacement_hostname: Specifies the replacement hostname for the tag to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement_hostname DataAkamaiPropertyRulesBuilder#replacement_hostname}
        :param scope: Specifies the part of HTML content the ``tagsAttribute`` refers to. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#scope DataAkamaiPropertyRulesBuilder#scope}
        :param tags_attribute: Specifies the tag or tag/attribute combination to operate on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tags_attribute DataAkamaiPropertyRulesBuilder#tags_attribute}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag(
            include_tags_attribute=include_tags_attribute,
            locked=locked,
            match_hostname=match_hostname,
            replace_all=replace_all,
            replacement_hostname=replacement_hostname,
            scope=scope,
            tags_attribute=tags_attribute,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAkamaizerTag", [value]))

    @jsii.member(jsii_name="putAllHttpInCacheHierarchy")
    def put_all_http_in_cache_hierarchy(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables all HTTP requests for parent servers in the cache hierarchy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllHttpInCacheHierarchy", [value]))

    @jsii.member(jsii_name="putAllowCloudletsOrigins")
    def put_allow_cloudlets_origins(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_origin_query_parameter: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to assign custom origin definitions referenced in sub-rules by ``cloudletsOrigin`` labels. If disabled, all sub-rules are ignored. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param honor_base_directory: Prefixes any Cloudlet-generated origin path with a path defined by an Origin Base Path behavior. If no path is defined, it has no effect. If another Cloudlet policy already prepends the same Origin Base Path, the path is not duplicated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_base_directory DataAkamaiPropertyRulesBuilder#honor_base_directory}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_origin_query_parameter: When purging content from a Cloudlets Origin, this specifies a query parameter name whose value is the specific named origin to purge. Note that this only applies to content purge requests, for example when using the ``Content Control Utility API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_origin_query_parameter DataAkamaiPropertyRulesBuilder#purge_origin_query_parameter}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins(
            enabled=enabled,
            honor_base_directory=honor_base_directory,
            locked=locked,
            purge_origin_query_parameter=purge_origin_query_parameter,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowCloudletsOrigins", [value]))

    @jsii.member(jsii_name="putAllowDelete")
    def put_allow_delete(
        self,
        *,
        allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_body: Allows data in the body of the DELETE request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_body DataAkamaiPropertyRulesBuilder#allow_body}
        :param enabled: Allows DELETE requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete(
            allow_body=allow_body,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowDelete", [value]))

    @jsii.member(jsii_name="putAllowHttpsCacheKeySharing")
    def put_allow_https_cache_key_sharing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables HTTPS cache key sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsCacheKeySharing", [value]))

    @jsii.member(jsii_name="putAllowHttpsDowngrade")
    def put_allow_https_downgrade(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Downgrades to HTTP protocol for the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowHttpsDowngrade", [value]))

    @jsii.member(jsii_name="putAllowOptions")
    def put_allow_options(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Set this to ``true`` to reflect the default policy where edge servers allow the OPTIONS method, without caching the response. Set this to ``false`` to deny OPTIONS requests and respond with a 501 error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowOptions", [value]))

    @jsii.member(jsii_name="putAllowPatch")
    def put_allow_patch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PATCH requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPatch", [value]))

    @jsii.member(jsii_name="putAllowPost")
    def put_allow_post(
        self,
        *,
        allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_without_content_length: By default, POST requests also require a ``Content-Length`` header, or they result in a 411 error. With this option enabled with no specified ``Content-Length``, the edge server relies on a ``Transfer-Encoding`` header to chunk the data. If neither header is present, it assumes the request has no body, and it adds a header with a ``0`` value to the forward request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_without_content_length DataAkamaiPropertyRulesBuilder#allow_without_content_length}
        :param enabled: Allows POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost(
            allow_without_content_length=allow_without_content_length,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPost", [value]))

    @jsii.member(jsii_name="putAllowPut")
    def put_allow_put(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows PUT requests. Content does ``not`` cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowPut", [value]))

    @jsii.member(jsii_name="putAllowTransferEncoding")
    def put_allow_transfer_encoding(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows Chunked Transfer Encoding requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAllowTransferEncoding", [value]))

    @jsii.member(jsii_name="putAltSvcHeader")
    def put_alt_svc_header(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the ``max-age`` value in seconds for the ``Alt-Svc`` header. The default ``max-age`` for an ``Alt-Svc`` header is 93600 seconds (26 hours). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader(
            locked=locked, max_age=max_age, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAltSvcHeader", [value]))

    @jsii.member(jsii_name="putApiPrioritization")
    def put_api_prioritization(
        self,
        *,
        alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        throttled_status_code: typing.Optional[jsii.Number] = None,
        use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param alternate_response_cache_ttl: Specifies the alternate response's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#alternate_response_cache_ttl DataAkamaiPropertyRulesBuilder#alternate_response_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Activates the API Prioritization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this API Prioritization policy from any others in the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param net_storage_path: Specify the full NetStorage path for the alternate response, including trailing file name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throttled_cp_code: throttled_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_cp_code DataAkamaiPropertyRulesBuilder#throttled_cp_code}
        :param throttled_status_code: Specifies the HTTP response code for requests that receive the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throttled_status_code DataAkamaiPropertyRulesBuilder#throttled_status_code}
        :param use_throttled_cp_code: Specifies whether to apply an alternative CP code for requests served the alternate response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_cp_code DataAkamaiPropertyRulesBuilder#use_throttled_cp_code}
        :param use_throttled_status_code: Allows you to assign a specific HTTP response code to a throttled request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_throttled_status_code DataAkamaiPropertyRulesBuilder#use_throttled_status_code}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization(
            alternate_response_cache_ttl=alternate_response_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            net_storage=net_storage,
            net_storage_path=net_storage_path,
            template_uuid=template_uuid,
            throttled_cp_code=throttled_cp_code,
            throttled_status_code=throttled_status_code,
            use_throttled_cp_code=use_throttled_cp_code,
            use_throttled_status_code=use_throttled_status_code,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApiPrioritization", [value]))

    @jsii.member(jsii_name="putApplicationLoadBalancer")
    def put_application_load_balancer(
        self,
        *,
        all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        all_down_net_storage_file: typing.Optional[builtins.str] = None,
        all_down_status_code: typing.Optional[builtins.str] = None,
        all_down_title: typing.Optional[builtins.str] = None,
        allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cached_content_title: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_attempts_threshold: typing.Optional[jsii.Number] = None,
        failover_mode: typing.Optional[builtins.str] = None,
        failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_cookie_name: typing.Optional[builtins.str] = None,
        specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_domain: typing.Optional[builtins.str] = None,
        stickiness_cookie_salt: typing.Optional[builtins.str] = None,
        stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_cookie_type: typing.Optional[builtins.str] = None,
        stickiness_duration: typing.Optional[builtins.str] = None,
        stickiness_expiration_date: typing.Optional[builtins.str] = None,
        stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        stickiness_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param all_down_net_storage: all_down_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage DataAkamaiPropertyRulesBuilder#all_down_net_storage}
        :param all_down_net_storage_file: Specifies the fallback maintenance page's filename, expressed as a full path from the root of the NetStorage server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_net_storage_file DataAkamaiPropertyRulesBuilder#all_down_net_storage_file}
        :param all_down_status_code: Specifies the HTTP response code when all load-balancing origins are unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_status_code DataAkamaiPropertyRulesBuilder#all_down_status_code}
        :param all_down_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#all_down_title DataAkamaiPropertyRulesBuilder#all_down_title}
        :param allow_cache_prefresh: Allows the cache to prefresh. Only appropriate if all origins serve the same content for the same URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_cache_prefresh DataAkamaiPropertyRulesBuilder#allow_cache_prefresh}
        :param cached_content_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cached_content_title DataAkamaiPropertyRulesBuilder#cached_content_title}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Activates the Application Load Balancer Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_attempts_threshold: Sets the number of failed requests that would trigger the failover process. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_attempts_threshold DataAkamaiPropertyRulesBuilder#failover_attempts_threshold}
        :param failover_mode: Determines what to do if an origin fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_mode DataAkamaiPropertyRulesBuilder#failover_mode}
        :param failover_origin_map: failover_origin_map block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_origin_map DataAkamaiPropertyRulesBuilder#failover_origin_map}
        :param failover_status_codes: Specifies a set of HTTP status codes that signal a failure on the origin, in which case the cookie that binds the client to that origin is invalidated and the client is rerouted to another available origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_status_codes DataAkamaiPropertyRulesBuilder#failover_status_codes}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param label: A label to distinguish this Application Load Balancer policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_cookie_name: Specifies the name for your session cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_cookie_name DataAkamaiPropertyRulesBuilder#origin_cookie_name}
        :param specify_stickiness_cookie_domain: Specifies whether to use a cookie domain with the stickiness cookie, to tell the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#specify_stickiness_cookie_domain}
        :param stickiness_cookie_automatic_salt: Sets whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable this if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_automatic_salt}
        :param stickiness_cookie_domain: Specifies the domain to track the stickiness cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_domain DataAkamaiPropertyRulesBuilder#stickiness_cookie_domain}
        :param stickiness_cookie_salt: Specifies the stickiness cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_salt DataAkamaiPropertyRulesBuilder#stickiness_cookie_salt}
        :param stickiness_cookie_set_http_only_flag: Ensures the cookie is transmitted only over HTTP. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_set_http_only_flag DataAkamaiPropertyRulesBuilder#stickiness_cookie_set_http_only_flag}
        :param stickiness_cookie_type: Determines how a cookie persistently associates the client with a load-balanced origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_cookie_type DataAkamaiPropertyRulesBuilder#stickiness_cookie_type}
        :param stickiness_duration: Sets how long it is before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_duration DataAkamaiPropertyRulesBuilder#stickiness_duration}
        :param stickiness_expiration_date: Specifies when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_expiration_date DataAkamaiPropertyRulesBuilder#stickiness_expiration_date}
        :param stickiness_refresh: Extends the duration of the cookie with each new request. When enabled, the ``DURATION`` thus specifies the latency between requests that would cause the cookie to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_refresh DataAkamaiPropertyRulesBuilder#stickiness_refresh}
        :param stickiness_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stickiness_title DataAkamaiPropertyRulesBuilder#stickiness_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer(
            all_down_net_storage=all_down_net_storage,
            all_down_net_storage_file=all_down_net_storage_file,
            all_down_status_code=all_down_status_code,
            all_down_title=all_down_title,
            allow_cache_prefresh=allow_cache_prefresh,
            cached_content_title=cached_content_title,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            failover_attempts_threshold=failover_attempts_threshold,
            failover_mode=failover_mode,
            failover_origin_map=failover_origin_map,
            failover_status_codes=failover_status_codes,
            failover_title=failover_title,
            label=label,
            locked=locked,
            origin_cookie_name=origin_cookie_name,
            specify_stickiness_cookie_domain=specify_stickiness_cookie_domain,
            stickiness_cookie_automatic_salt=stickiness_cookie_automatic_salt,
            stickiness_cookie_domain=stickiness_cookie_domain,
            stickiness_cookie_salt=stickiness_cookie_salt,
            stickiness_cookie_set_http_only_flag=stickiness_cookie_set_http_only_flag,
            stickiness_cookie_type=stickiness_cookie_type,
            stickiness_duration=stickiness_duration,
            stickiness_expiration_date=stickiness_expiration_date,
            stickiness_refresh=stickiness_refresh,
            stickiness_title=stickiness_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putApplicationLoadBalancer", [value]))

    @jsii.member(jsii_name="putAudienceSegmentation")
    def put_audience_segmentation(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_domain: typing.Optional[builtins.str] = None,
        population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_salt: typing.Optional[builtins.str] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
        segment_tracking_custom_header: typing.Optional[builtins.str] = None,
        segment_tracking_method: typing.Optional[builtins.str] = None,
        segment_tracking_query_param: typing.Optional[builtins.str] = None,
        segment_tracking_title: typing.Optional[builtins.str] = None,
        specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Audience Segmentation cloudlet feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: Specifies a suffix to append to the cookie name. This helps distinguish this audience segmentation policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_automatic_salt: Whether to assign a ``salt`` value automatically to the cookie to prevent manipulation by the user. You should not enable if sharing the population cookie across more than one property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#population_cookie_automatic_salt}
        :param population_cookie_domain: Specifies the domain to track the population cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_domain DataAkamaiPropertyRulesBuilder#population_cookie_domain}
        :param population_cookie_include_rule_name: When enabled, includes in the session cookie the name of the rule in which this behavior appears. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_include_rule_name DataAkamaiPropertyRulesBuilder#population_cookie_include_rule_name}
        :param population_cookie_salt: Specifies the cookie's salt value. Use this option to share the cookie across many properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_salt DataAkamaiPropertyRulesBuilder#population_cookie_salt}
        :param population_cookie_type: Specifies when the segmentation cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Specifies the lifetime of the segmentation cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_refresh: If disabled, sets the expiration time only if the cookie is not yet present in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param segment_tracking_cookie_name: This cookie name specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_cookie_name DataAkamaiPropertyRulesBuilder#segment_tracking_cookie_name}
        :param segment_tracking_custom_header: This custom HTTP header specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_custom_header DataAkamaiPropertyRulesBuilder#segment_tracking_custom_header}
        :param segment_tracking_method: Specifies the method to pass segment information to the origin. The Cloudlet passes the rule applied to a given request location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_method DataAkamaiPropertyRulesBuilder#segment_tracking_method}
        :param segment_tracking_query_param: This query parameter specifies the name of the segmentation rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_query_param DataAkamaiPropertyRulesBuilder#segment_tracking_query_param}
        :param segment_tracking_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_tracking_title DataAkamaiPropertyRulesBuilder#segment_tracking_title}
        :param specify_population_cookie_domain: Whether to specify a cookie domain with the population cookie. It tells the browser to which domain to send the cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#specify_population_cookie_domain DataAkamaiPropertyRulesBuilder#specify_population_cookie_domain}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_automatic_salt=population_cookie_automatic_salt,
            population_cookie_domain=population_cookie_domain,
            population_cookie_include_rule_name=population_cookie_include_rule_name,
            population_cookie_salt=population_cookie_salt,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_refresh=population_refresh,
            population_title=population_title,
            segment_tracking_cookie_name=segment_tracking_cookie_name,
            segment_tracking_custom_header=segment_tracking_custom_header,
            segment_tracking_method=segment_tracking_method,
            segment_tracking_query_param=segment_tracking_query_param,
            segment_tracking_title=segment_tracking_title,
            specify_population_cookie_domain=specify_population_cookie_domain,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAudienceSegmentation", [value]))

    @jsii.member(jsii_name="putAutoDomainValidation")
    def put_auto_domain_validation(
        self,
        *,
        autodv: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param autodv: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#autodv DataAkamaiPropertyRulesBuilder#autodv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation(
            autodv=autodv, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putAutoDomainValidation", [value]))

    @jsii.member(jsii_name="putBaseDirectory")
    def put_base_directory(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the base path of content on your origin server. The value needs to begin and end with a slash (``/``) character, for example ``/parent/child/``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putBaseDirectory", [value_]))

    @jsii.member(jsii_name="putBossBeaconing")
    def put_boss_beaconing(
        self,
        *,
        conditional_error_pattern: typing.Optional[builtins.str] = None,
        conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
        conditional_sampling_frequency: typing.Optional[builtins.str] = None,
        cpcodes: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        sampling_frequency: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param conditional_error_pattern: A space-separated set of error patterns that trigger beacons to conditional feeds. Each pattern can include wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*CONNECT* *DENIED*`` matches two different words as substrings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_error_pattern DataAkamaiPropertyRulesBuilder#conditional_error_pattern}
        :param conditional_http_status: Specifies the set of response status codes or ranges that trigger the beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_http_status DataAkamaiPropertyRulesBuilder#conditional_http_status}
        :param conditional_sampling_frequency: Specifies a conditional sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#conditional_sampling_frequency DataAkamaiPropertyRulesBuilder#conditional_sampling_frequency}
        :param cpcodes: The space-separated list of CP codes that trigger the beacons. You need to specify the same set of CP codes within BOSS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cpcodes DataAkamaiPropertyRulesBuilder#cpcodes}
        :param enabled: Enable diagnostic data beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_type DataAkamaiPropertyRulesBuilder#forward_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specify when to trigger a beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param sampling_frequency: Specifies a sampling frequency or disables beacons. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_frequency DataAkamaiPropertyRulesBuilder#sampling_frequency}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing(
            conditional_error_pattern=conditional_error_pattern,
            conditional_http_status=conditional_http_status,
            conditional_sampling_frequency=conditional_sampling_frequency,
            cpcodes=cpcodes,
            enabled=enabled,
            forward_type=forward_type,
            locked=locked,
            request_type=request_type,
            sampling_frequency=sampling_frequency,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBossBeaconing", [value]))

    @jsii.member(jsii_name="putBreadcrumbs")
    def put_breadcrumbs(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Breadcrumbs feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param logging_enabled: Whether to collect all Breadcrumbs data in logs, including the response headers sent a requesting client. This can also be helpful if you're using ``DataStream 2`` to retrieve log data. This way, all Breadcrumbs data is carried in the logs it uses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#logging_enabled DataAkamaiPropertyRulesBuilder#logging_enabled}
        :param opt_mode: Specifies whether to include Breadcrumbs data in the response header. To bypass the current ``optMode``, append the opposite ``ak-bc`` query string to each request from your player. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#opt_mode DataAkamaiPropertyRulesBuilder#opt_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs(
            enabled=enabled,
            locked=locked,
            logging_enabled=logging_enabled,
            opt_mode=opt_mode,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBreadcrumbs", [value]))

    @jsii.member(jsii_name="putBreakConnection")
    def put_break_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the break connection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBreakConnection", [value]))

    @jsii.member(jsii_name="putBrotli")
    def put_brotli(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Fetches Brotli-compressed assets from your origin and caches them on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putBrotli", [value]))

    @jsii.member(jsii_name="putCacheError")
    def put_cache_error(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Activates the error-caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preserve_stale: When enabled, the edge server preserves stale cached objects when the origin returns ``500``, ``502``, ``503``, and ``504`` error codes. This avoids re-fetching and re-caching content after transient errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_stale DataAkamaiPropertyRulesBuilder#preserve_stale}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Overrides the default caching duration of ``10s``. Note that if set to ``0``, it is equivalent to ``no-cache``, which forces revalidation and may cause a traffic spike. This can be counterproductive when, for example, the origin is producing an error code of ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError(
            enabled=enabled,
            locked=locked,
            preserve_stale=preserve_stale,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheError", [value]))

    @jsii.member(jsii_name="putCacheId")
    def put_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rule: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the names of the query parameters, cookies, or headers to include or exclude from the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param include_value: Includes the value of the specified elements in the cache ID. Otherwise only their names are included. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_value DataAkamaiPropertyRulesBuilder#include_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optional: Requires the behavior's specified elements to be present for content to cache. When disabled, requests that lack the specified elements are still cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optional DataAkamaiPropertyRulesBuilder#optional}
        :param rule: Specifies how to modify the cache ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rule DataAkamaiPropertyRulesBuilder#rule}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: Specifies the name of the variable you want to include in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId(
            elements=elements,
            include_value=include_value,
            locked=locked,
            optional=optional,
            rule=rule,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheId", [value]))

    @jsii.member(jsii_name="putCacheKeyIgnoreCase")
    def put_cache_key_ignore_case(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Ignores case when forming cache keys. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyIgnoreCase", [value]))

    @jsii.member(jsii_name="putCacheKeyQueryParams")
    def put_cache_key_query_params(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Configures how sets of query string parameters translate to cache keys. Be careful not to ignore any parameters that result in substantially different content, as it is ``not`` reflected in the cached object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param exact_match: When enabled, ``parameters`` needs to match exactly. Keep disabled to match string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exact_match DataAkamaiPropertyRulesBuilder#exact_match}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies the set of parameter field names to include in or exclude from the cache key. By default, these match the field names as string prefixes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams(
            behavior=behavior,
            exact_match=exact_match,
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyQueryParams", [value]))

    @jsii.member(jsii_name="putCacheKeyRewrite")
    def put_cache_key_rewrite(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        purge_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param purge_key: Specifies the new cache key path as an alphanumeric value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#purge_key DataAkamaiPropertyRulesBuilder#purge_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite(
            locked=locked, purge_key=purge_key, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheKeyRewrite", [value]))

    @jsii.member(jsii_name="putCachePost")
    def put_cache_post(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_body: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables caching of POST responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_body: Define how and whether to use the POST message body as a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_body DataAkamaiPropertyRulesBuilder#use_body}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_body=use_body,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCachePost", [value]))

    @jsii.member(jsii_name="putCacheRedirect")
    def put_cache_redirect(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the redirect caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheRedirect", [value]))

    @jsii.member(jsii_name="putCacheTag")
    def put_cache_tag(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tag: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param tag: Specifies the cache tag you want to add to your cached content. A cache tag is only added when the object is first added to cache. A single cache tag can't exceed 128 characters and can only include alphanumeric characters, plus this class of characters: ``[!#$%'+./^_`|~-]`` Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tag DataAkamaiPropertyRulesBuilder#tag}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag(
            locked=locked, tag=tag, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTag", [value]))

    @jsii.member(jsii_name="putCacheTagVisible")
    def put_cache_tag_visible(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specifies when to include the ``Edge-Cache-Tag`` in responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCacheTagVisible", [value]))

    @jsii.member(jsii_name="putCaching")
    def put_caching(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        cacheability_settings: typing.Optional[builtins.str] = None,
        cache_control_directives: typing.Optional[builtins.str] = None,
        default_ttl: typing.Optional[builtins.str] = None,
        enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_settings: typing.Optional[builtins.str] = None,
        honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        revalidation_settings: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify the caching option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param cacheability_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability_settings DataAkamaiPropertyRulesBuilder#cacheability_settings}
        :param cache_control_directives: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_control_directives DataAkamaiPropertyRulesBuilder#cache_control_directives}
        :param default_ttl: Set the ``MAX_AGE`` header for the cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_ttl DataAkamaiPropertyRulesBuilder#default_ttl}
        :param enhanced_rfc_support: This enables honoring particular ``Cache-Control`` header directives from the origin. Supports all official ``RFC 7234`` directives except for ``no-transform``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enhanced_rfc_support DataAkamaiPropertyRulesBuilder#enhanced_rfc_support}
        :param expiration_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_settings DataAkamaiPropertyRulesBuilder#expiration_settings}
        :param honor_max_age: This instructs edge servers to cache the object for a length of time set by the ``max-age`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_max_age DataAkamaiPropertyRulesBuilder#honor_max_age}
        :param honor_must_revalidate: This instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_must_revalidate DataAkamaiPropertyRulesBuilder#honor_must_revalidate}
        :param honor_no_cache: With the ``no-cache`` directive present in the response, this instructs edge servers to validate or refetch the response for each request. Effectively, set the time to live ``ttl`` to zero seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_cache DataAkamaiPropertyRulesBuilder#honor_no_cache}
        :param honor_no_store: Instructs edge servers not to cache the response when the origin response includes the ``no-store`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_no_store DataAkamaiPropertyRulesBuilder#honor_no_store}
        :param honor_private: Instructs edge servers not to cache the response when the origin response includes the ``private`` directive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_private DataAkamaiPropertyRulesBuilder#honor_private}
        :param honor_proxy_revalidate: With the ``proxy-revalidate`` directive present in the response, this instructs edge servers to successfully revalidate with the origin server before using stale objects in the cache to satisfy new requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_proxy_revalidate DataAkamaiPropertyRulesBuilder#honor_proxy_revalidate}
        :param honor_s_maxage: Instructs edge servers to cache the object for a length of time set by the ``s-maxage`` directive in the response. When present in the origin response, this directive takes precedence over the ``max-age`` directive and the ``defaultTtl`` setting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#honor_s_maxage DataAkamaiPropertyRulesBuilder#honor_s_maxage}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param must_revalidate: Determines what to do once the cached content has expired, by which time the Akamai platform should have re-fetched and validated content from the origin. If enabled, only allows the re-fetched content to be served. If disabled, may serve stale content if the origin is unavailable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#must_revalidate DataAkamaiPropertyRulesBuilder#must_revalidate}
        :param revalidation_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revalidation_settings DataAkamaiPropertyRulesBuilder#revalidation_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: The maximum time content may remain cached. Setting the value to ``0`` is the same as setting a ``no-cache`` header, which forces content to revalidate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching(
            behavior=behavior,
            cacheability_settings=cacheability_settings,
            cache_control_directives=cache_control_directives,
            default_ttl=default_ttl,
            enhanced_rfc_support=enhanced_rfc_support,
            expiration_settings=expiration_settings,
            honor_max_age=honor_max_age,
            honor_must_revalidate=honor_must_revalidate,
            honor_no_cache=honor_no_cache,
            honor_no_store=honor_no_store,
            honor_private=honor_private,
            honor_proxy_revalidate=honor_proxy_revalidate,
            honor_s_maxage=honor_s_maxage,
            locked=locked,
            must_revalidate=must_revalidate,
            revalidation_settings=revalidation_settings,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCaching", [value]))

    @jsii.member(jsii_name="putCentralAuthorization")
    def put_central_authorization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the centralized authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCentralAuthorization", [value]))

    @jsii.member(jsii_name="putChaseRedirects")
    def put_chase_redirects(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        limit: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to chase redirects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param limit: Specifies, as a string, the maximum number of redirects to follow. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serve404: Once the redirect ``limit`` is reached, enabling this option serves an HTTP ``404`` (Not Found) error instead of the last redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serve404 DataAkamaiPropertyRulesBuilder#serve404}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects(
            enabled=enabled,
            limit=limit,
            locked=locked,
            serve404=serve404,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChaseRedirects", [value]))

    @jsii.member(jsii_name="putClientCertificateAuth")
    def put_client_certificate_auth(
        self,
        *,
        client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param client_certificate_attributes: Specify client certificate attributes to include in the ``Client-To-Edge`` authentication header that's sent to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate_attributes DataAkamaiPropertyRulesBuilder#client_certificate_attributes}
        :param enable: Constructs the ``Client-To-Edge`` authentication header using information from the client to edge mTLS handshake and forwards it to your origin. You can configure your origin to acknowledge the header to enable transitive trust. Some form of the client x.509 certificate needs to be included in the header. You can include the full certificate or specific attributes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param enable_client_certificate_validation_status: Whether to include the current validation status of the client certificate in the ``Client-To-Edge`` authentication header. This verifies the validation status of the certificate, regardless of the certificate attributes you're including in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_client_certificate_validation_status DataAkamaiPropertyRulesBuilder#enable_client_certificate_validation_status}
        :param enable_complete_client_certificate: Whether to include the complete client certificate in the header, in its binary (DER) format. DER-formatted certificates leave out the ``BEGIN CERTIFICATE/END CERTIFICATE`` statements and most often use the ``.der`` extension. Alternatively, you can specify individual ``clientCertificateAttributes`` you want included in the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_complete_client_certificate DataAkamaiPropertyRulesBuilder#enable_complete_client_certificate}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth(
            client_certificate_attributes=client_certificate_attributes,
            enable=enable,
            enable_client_certificate_validation_status=enable_client_certificate_validation_status,
            enable_complete_client_certificate=enable_complete_client_certificate,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificateAuth", [value]))

    @jsii.member(jsii_name="putClientCharacteristics")
    def put_client_characteristics(
        self,
        *,
        country: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param country: Specifies the client request's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics(
            country=country, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putClientCharacteristics", [value]))

    @jsii.member(jsii_name="putCloudInterconnects")
    def put_cloud_interconnects(
        self,
        *,
        cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloud_locations: Specifies the geographical locations of your cloud origin. You should enable Cloud Interconnects only if your origin is in one of these locations, since GCP doesn't provide a discount for egress traffic for any other regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloud_locations DataAkamaiPropertyRulesBuilder#cloud_locations}
        :param enabled: Channels the traffic to maximize the egress discount at the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects(
            cloud_locations=cloud_locations,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudInterconnects", [value]))

    @jsii.member(jsii_name="putCloudWrapper")
    def put_cloud_wrapper(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Cloud Wrapper behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param location: The location you want to distribute your Cloud Wrapper cache space to. This behavior allows all locations configured in your Cloud Wrapper configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper(
            enabled=enabled,
            location=location,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapper", [value]))

    @jsii.member(jsii_name="putCloudWrapperAdvanced")
    def put_cloud_wrapper_advanced(
        self,
        *,
        custom_failover_map: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_map: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_failover_map: Specifies the custom failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_failover_map DataAkamaiPropertyRulesBuilder#custom_failover_map}
        :param enabled: Enables failover for Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_map: Specifies the failover map to handle Cloud Wrapper failures. Contact your account representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_map DataAkamaiPropertyRulesBuilder#failover_map}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced(
            custom_failover_map=custom_failover_map,
            enabled=enabled,
            failover_map=failover_map,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCloudWrapperAdvanced", [value]))

    @jsii.member(jsii_name="putCommonMediaClientData")
    def put_common_media_client_data(
        self,
        *,
        enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_cmcd_segment_prefetch: Uses Common Media Client Data (CMCD) metadata to determine the segment URLs your origin server prefetches to speed up content delivery. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_cmcd_segment_prefetch DataAkamaiPropertyRulesBuilder#enable_cmcd_segment_prefetch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData(
            enable_cmcd_segment_prefetch=enable_cmcd_segment_prefetch,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCommonMediaClientData", [value]))

    @jsii.member(jsii_name="putConditionalOrigin")
    def put_conditional_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putConditionalOrigin", [value]))

    @jsii.member(jsii_name="putConstructResponse")
    def put_construct_response(
        self,
        *,
        body: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param body: HTML response of up to 2000 characters to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#body DataAkamaiPropertyRulesBuilder#body}
        :param enabled: Serves the custom response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_eviction: For GET requests from clients, this forces edge servers to evict the underlying object from cache. Defaults to ``false``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_eviction DataAkamaiPropertyRulesBuilder#force_eviction}
        :param ignore_purge: Whether to ignore the custom response when purging. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_purge DataAkamaiPropertyRulesBuilder#ignore_purge}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: The HTTP response code to send to the end-user client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse(
            body=body,
            enabled=enabled,
            force_eviction=force_eviction,
            ignore_purge=ignore_purge,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putConstructResponse", [value]))

    @jsii.member(jsii_name="putContentCharacteristics")
    def put_content_characteristics(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristics", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsAmd")
    def put_content_characteristics_amd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_dash_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash_custom DataAkamaiPropertyRulesBuilder#segment_duration_dash_custom}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hds_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds_custom DataAkamaiPropertyRulesBuilder#segment_duration_hds_custom}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_hls_custom: Customizes the number of seconds for the segment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls_custom DataAkamaiPropertyRulesBuilder#segment_duration_hls_custom}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_duration_smooth_custom: Customizes the number of seconds for the fragment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth_custom DataAkamaiPropertyRulesBuilder#segment_duration_smooth_custom}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_dash_custom=segment_duration_dash_custom,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hds_custom=segment_duration_hds_custom,
            segment_duration_hls=segment_duration_hls,
            segment_duration_hls_custom=segment_duration_hls_custom,
            segment_duration_smooth=segment_duration_smooth,
            segment_duration_smooth_custom=segment_duration_smooth_custom,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsAmd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsDd")
    def put_content_characteristics_dd(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param optimize_option: Optimizes the delivery throughput and download times for large files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_option DataAkamaiPropertyRulesBuilder#optimize_option}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            optimize_option=optimize_option,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsDd", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLargeFile")
    def put_content_characteristics_wsd_large_file(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the type of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Optimize based on the size of the object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile(
            catalog_size=catalog_size,
            content_type=content_type,
            locked=locked,
            object_size=object_size,
            popularity_distribution=popularity_distribution,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLargeFile", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdLive")
    def put_content_characteristics_wsd_live(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdLive", [value]))

    @jsii.member(jsii_name="putContentCharacteristicsWsdVod")
    def put_content_characteristics_wsd_vod(
        self,
        *,
        catalog_size: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        segment_duration_dash: typing.Optional[builtins.str] = None,
        segment_duration_hds: typing.Optional[builtins.str] = None,
        segment_duration_hls: typing.Optional[builtins.str] = None,
        segment_duration_smooth: typing.Optional[builtins.str] = None,
        segment_size_dash: typing.Optional[builtins.str] = None,
        segment_size_hds: typing.Optional[builtins.str] = None,
        segment_size_hls: typing.Optional[builtins.str] = None,
        segment_size_smooth: typing.Optional[builtins.str] = None,
        smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param catalog_size: Optimize based on the total size of the content library delivered. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}
        :param content_type: Optimize based on the quality of media content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param dash: Enable delivery of DASH media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash DataAkamaiPropertyRulesBuilder#dash}
        :param hds: Enable delivery of HDS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hds DataAkamaiPropertyRulesBuilder#hds}
        :param hls: Enable delivery of HLS media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls DataAkamaiPropertyRulesBuilder#hls}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param popularity_distribution: Optimize based on the content's expected popularity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}
        :param segment_duration_dash: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_dash DataAkamaiPropertyRulesBuilder#segment_duration_dash}
        :param segment_duration_hds: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hds DataAkamaiPropertyRulesBuilder#segment_duration_hds}
        :param segment_duration_hls: Specifies the duration of individual segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_hls DataAkamaiPropertyRulesBuilder#segment_duration_hls}
        :param segment_duration_smooth: Specifies the duration of individual fragments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration_smooth DataAkamaiPropertyRulesBuilder#segment_duration_smooth}
        :param segment_size_dash: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_dash DataAkamaiPropertyRulesBuilder#segment_size_dash}
        :param segment_size_hds: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hds DataAkamaiPropertyRulesBuilder#segment_size_hds}
        :param segment_size_hls: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_hls DataAkamaiPropertyRulesBuilder#segment_size_hls}
        :param segment_size_smooth: Specifies the size of the media object retrieved from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_size_smooth DataAkamaiPropertyRulesBuilder#segment_size_smooth}
        :param smooth: Enable delivery of Smooth media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smooth DataAkamaiPropertyRulesBuilder#smooth}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod(
            catalog_size=catalog_size,
            content_type=content_type,
            dash=dash,
            hds=hds,
            hls=hls,
            locked=locked,
            popularity_distribution=popularity_distribution,
            segment_duration_dash=segment_duration_dash,
            segment_duration_hds=segment_duration_hds,
            segment_duration_hls=segment_duration_hls,
            segment_duration_smooth=segment_duration_smooth,
            segment_size_dash=segment_size_dash,
            segment_size_hds=segment_size_hds,
            segment_size_hls=segment_size_hls,
            segment_size_smooth=segment_size_smooth,
            smooth=smooth,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentCharacteristicsWsdVod", [value]))

    @jsii.member(jsii_name="putContentPrePosition")
    def put_content_pre_position(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        first_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        second_location: typing.Optional[builtins.str] = None,
        source_type: typing.Optional[builtins.str] = None,
        targets: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Content PrePosition behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param first_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#first_location DataAkamaiPropertyRulesBuilder#first_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param second_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_location DataAkamaiPropertyRulesBuilder#second_location}.
        :param source_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#source_type DataAkamaiPropertyRulesBuilder#source_type}.
        :param targets: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#targets DataAkamaiPropertyRulesBuilder#targets}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition(
            enabled=enabled,
            first_location=first_location,
            locked=locked,
            second_location=second_location,
            source_type=source_type,
            targets=targets,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentPrePosition", [value]))

    @jsii.member(jsii_name="putContentTargetingProtection")
    def put_content_targeting_protection(
        self,
        *,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_protection_mode: typing.Optional[builtins.str] = None,
        geo_protection_title: typing.Optional[builtins.str] = None,
        geo_redirect_url: typing.Optional[builtins.str] = None,
        ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        ip_protection_mode: typing.Optional[builtins.str] = None,
        ip_protection_title: typing.Optional[builtins.str] = None,
        ip_redirect_url: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        referrer_protection_mode: typing.Optional[builtins.str] = None,
        referrer_protection_title: typing.Optional[builtins.str] = None,
        referrer_redirect_url: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param countries: Specifies a set of two-character ISO 3166 country codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param dmas: Specifies the set of Designated Market Area codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dmas DataAkamaiPropertyRulesBuilder#dmas}
        :param enabled: Enables the Content Targeting feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_geo_protection: When enabled, verifies IP addresses are unique to specific geographic regions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_protection DataAkamaiPropertyRulesBuilder#enable_geo_protection}
        :param enable_geo_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_geo_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_geo_redirect_on_deny}
        :param enable_ip_protection: Allows you to control access to your content from specific sets of IP addresses and CIDR blocks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_protection DataAkamaiPropertyRulesBuilder#enable_ip_protection}
        :param enable_ip_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_ip_redirect_on_deny}
        :param enable_referrer_protection: Allows you allow traffic from certain referring websites, and disallow traffic from unauthorized sites that hijack those links. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_protection DataAkamaiPropertyRulesBuilder#enable_referrer_protection}
        :param enable_referrer_redirect_on_deny: When enabled, redirects denied requests rather than responding with an error code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_referrer_redirect_on_deny DataAkamaiPropertyRulesBuilder#enable_referrer_redirect_on_deny}
        :param geo_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_mode DataAkamaiPropertyRulesBuilder#geo_protection_mode}
        :param geo_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_protection_title DataAkamaiPropertyRulesBuilder#geo_protection_title}
        :param geo_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_redirect_url DataAkamaiPropertyRulesBuilder#geo_redirect_url}
        :param ip_addresses: Specify a set of IP addresses or CIDR blocks to allow or deny. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_addresses DataAkamaiPropertyRulesBuilder#ip_addresses}
        :param ip_protection_mode: Specifies how to handle requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_mode DataAkamaiPropertyRulesBuilder#ip_protection_mode}
        :param ip_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_protection_title DataAkamaiPropertyRulesBuilder#ip_protection_title}
        :param ip_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_redirect_url DataAkamaiPropertyRulesBuilder#ip_redirect_url}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_ip_addresses: Specify a set of IP addresses or CIDR blocks that exceptions to the set of included or excluded areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_ip_addresses DataAkamaiPropertyRulesBuilder#override_ip_addresses}
        :param referrer_domains: Specifies the set of domains from which to allow or deny traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_domains DataAkamaiPropertyRulesBuilder#referrer_domains}
        :param referrer_protection_mode: Specify the action to take. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_mode DataAkamaiPropertyRulesBuilder#referrer_protection_mode}
        :param referrer_protection_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_protection_title DataAkamaiPropertyRulesBuilder#referrer_protection_title}
        :param referrer_redirect_url: This specifies the full URL to the redirect page for denied requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer_redirect_url DataAkamaiPropertyRulesBuilder#referrer_redirect_url}
        :param regions: Specifies a set of ISO 3166-2 regional codes from which to allow or deny traffic. See ``EdgeScape Data Codes`` for a list. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection(
            countries=countries,
            dmas=dmas,
            enabled=enabled,
            enable_geo_protection=enable_geo_protection,
            enable_geo_redirect_on_deny=enable_geo_redirect_on_deny,
            enable_ip_protection=enable_ip_protection,
            enable_ip_redirect_on_deny=enable_ip_redirect_on_deny,
            enable_referrer_protection=enable_referrer_protection,
            enable_referrer_redirect_on_deny=enable_referrer_redirect_on_deny,
            geo_protection_mode=geo_protection_mode,
            geo_protection_title=geo_protection_title,
            geo_redirect_url=geo_redirect_url,
            ip_addresses=ip_addresses,
            ip_protection_mode=ip_protection_mode,
            ip_protection_title=ip_protection_title,
            ip_redirect_url=ip_redirect_url,
            locked=locked,
            override_ip_addresses=override_ip_addresses,
            referrer_domains=referrer_domains,
            referrer_protection_mode=referrer_protection_mode,
            referrer_protection_title=referrer_protection_title,
            referrer_redirect_url=referrer_redirect_url,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentTargetingProtection", [value]))

    @jsii.member(jsii_name="putCorsSupport")
    def put_cors_support(
        self,
        *,
        allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_headers: typing.Optional[builtins.str] = None,
        allow_origins: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        methods: typing.Optional[typing.Sequence[builtins.str]] = None,
        origins: typing.Optional[typing.Sequence[builtins.str]] = None,
        preflight_max_age: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_credentials: Accepts requests made using credentials, like cookies or TLS client certificates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_credentials DataAkamaiPropertyRulesBuilder#allow_credentials}
        :param allow_headers: In responses to preflight requests, defines which headers to allow when making the actual request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_headers DataAkamaiPropertyRulesBuilder#allow_headers}
        :param allow_origins: In responses to preflight requests, sets which origin hostnames to accept requests from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_origins DataAkamaiPropertyRulesBuilder#allow_origins}
        :param enabled: Enables CORS feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expose_headers: In responses to preflight requests, lists names of headers that clients can access. By default, clients can access the following simple response headers: ``Cache-Control``, ``Content-Language``, ``Content-Type``, ``Expires``, ``Last-Modified``, and ``Pragma``. You can add other header names to make them accessible to clients. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expose_headers DataAkamaiPropertyRulesBuilder#expose_headers}
        :param headers: Defines the supported request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#headers DataAkamaiPropertyRulesBuilder#headers}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param methods: Specifies any combination of the following methods: ``DELETE``, ``GET``, ``PATCH``, ``POST``, and ``PUT`` that are allowed when accessing the resource from an external domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#methods DataAkamaiPropertyRulesBuilder#methods}
        :param origins: Defines the origin hostnames to accept requests from. The hostnames that you enter need to start with ``http`` or ``https``. For detailed hostname syntax requirements, refer to RFC-952 and RFC-1123 specifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origins DataAkamaiPropertyRulesBuilder#origins}
        :param preflight_max_age: Defines the number of seconds that the browser should cache the response to a preflight request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preflight_max_age DataAkamaiPropertyRulesBuilder#preflight_max_age}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport(
            allow_credentials=allow_credentials,
            allow_headers=allow_headers,
            allow_origins=allow_origins,
            enabled=enabled,
            expose_headers=expose_headers,
            headers=headers,
            locked=locked,
            methods=methods,
            origins=origins,
            preflight_max_age=preflight_max_age,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCorsSupport", [value]))

    @jsii.member(jsii_name="putCpCode")
    def put_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putCpCode", [value_]))

    @jsii.member(jsii_name="putCustomBehavior")
    def put_custom_behavior(
        self,
        *,
        behavior_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior_id: The unique identifier for the predefined custom behavior you want to insert into the current rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior_id DataAkamaiPropertyRulesBuilder#behavior_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior(
            behavior_id=behavior_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putCustomBehavior", [value]))

    @jsii.member(jsii_name="putDatastream")
    def put_datastream(
        self,
        *,
        beacon_stream_title: typing.Optional[builtins.str] = None,
        collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        datastream_ids: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
        log_stream_title: typing.Optional[builtins.str] = None,
        sampling_percentage: typing.Optional[jsii.Number] = None,
        stream_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_stream_title DataAkamaiPropertyRulesBuilder#beacon_stream_title}
        :param collect_midgress_traffic: If enabled, gathers midgress traffic data within the Akamai platform, such as between two edge servers, for all streams configured. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#collect_midgress_traffic DataAkamaiPropertyRulesBuilder#collect_midgress_traffic}
        :param datastream_ids: A set of dash-separated DataStream ID values to limit the scope of reported data. By default, all active streams report. Use the DataStream application to gather stream ID values that apply to this property configuration. Specifying IDs for any streams that don't apply to this property has no effect, and results in no data reported. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#datastream_ids DataAkamaiPropertyRulesBuilder#datastream_ids}
        :param enabled: Enables DataStream reporting. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_enabled: Enables log collection for the property by associating it with DataStream configurations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_enabled DataAkamaiPropertyRulesBuilder#log_enabled}
        :param log_stream_name: Specifies the unique IDs of streams configured for the property. For properties created with the previous version of the rule format, this option contains a string instead of an array of strings. You can use the ``List streams`` operation to get stream IDs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_name DataAkamaiPropertyRulesBuilder#log_stream_name}
        :param log_stream_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_stream_title DataAkamaiPropertyRulesBuilder#log_stream_title}
        :param sampling_percentage: Specifies the percentage of log data you want to collect for this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sampling_percentage DataAkamaiPropertyRulesBuilder#sampling_percentage}
        :param stream_type: Specify the DataStream type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#stream_type DataAkamaiPropertyRulesBuilder#stream_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream(
            beacon_stream_title=beacon_stream_title,
            collect_midgress_traffic=collect_midgress_traffic,
            datastream_ids=datastream_ids,
            enabled=enabled,
            locked=locked,
            log_enabled=log_enabled,
            log_stream_name=log_stream_name,
            log_stream_title=log_stream_title,
            sampling_percentage=sampling_percentage,
            stream_type=stream_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDatastream", [value]))

    @jsii.member(jsii_name="putDcp")
    def put_dcp(
        self,
        *,
        anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param anonymous: When enabled, you don't need to pass the JWT token with the mqtt request, and JWT validation is skipped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous DataAkamaiPropertyRulesBuilder#anonymous}
        :param enabled: Enables IoT Edge Connect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param gwenabled: When enabled, you can publish and receive messages over a secured HTTP connection on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gwenabled DataAkamaiPropertyRulesBuilder#gwenabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_id: Specifies the globally reserved name for a specific configuration. It includes authorization rules over publishing and subscribing to logical categories known as ``topics``. This provides a root path for all topics defined within a namespace configuration. You can use the ``IoT Edge Connect API`` to configure access control lists for your namespace configuration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_id DataAkamaiPropertyRulesBuilder#namespace_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tlsenabled: When enabled, you can publish and receive messages over a secured MQTT connection on port 8883. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tlsenabled DataAkamaiPropertyRulesBuilder#tlsenabled}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param wsenabled: When enabled, you can publish and receive messages through a secured MQTT connection over WebSockets on port 443. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#wsenabled DataAkamaiPropertyRulesBuilder#wsenabled}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp(
            anonymous=anonymous,
            enabled=enabled,
            gwenabled=gwenabled,
            locked=locked,
            namespace_id=namespace_id,
            template_uuid=template_uuid,
            tlsenabled=tlsenabled,
            uuid=uuid,
            wsenabled=wsenabled,
        )

        return typing.cast(None, jsii.invoke(self, "putDcp", [value]))

    @jsii.member(jsii_name="putDcpAuthHmacTransformation")
    def put_dcp_auth_hmac_transformation(
        self,
        *,
        hash_conversion_algorithm: typing.Optional[builtins.str] = None,
        hash_conversion_key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param hash_conversion_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_algorithm DataAkamaiPropertyRulesBuilder#hash_conversion_algorithm}
        :param hash_conversion_key: Specifies the key to generate the hash, ideally a long random string to ensure adequate security. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_conversion_key DataAkamaiPropertyRulesBuilder#hash_conversion_key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation(
            hash_conversion_algorithm=hash_conversion_algorithm,
            hash_conversion_key=hash_conversion_key,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthHmacTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthRegexTransformation")
    def put_dcp_auth_regex_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex_pattern: Specifies a Perl-compatible regular expression with a single grouping to capture the text. For example, a value of ``^.(.{0,10})`` omits the first character, but then captures up to 10 characters after that. If the regular expression does not capture a substring, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation(
            locked=locked,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthRegexTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthSubstringTransformation")
    def put_dcp_auth_substring_transformation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        substring_end: typing.Optional[builtins.str] = None,
        substring_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param substring_end: The zero-based index offset of the last character to extract, where ``-1`` selects the remainder of the string. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_end DataAkamaiPropertyRulesBuilder#substring_end}
        :param substring_start: The zero-based index offset of the first character to extract. If the index is out of bound from the string's length, authentication may fail. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#substring_start DataAkamaiPropertyRulesBuilder#substring_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation(
            locked=locked,
            substring_end=substring_end,
            substring_start=substring_start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthSubstringTransformation", [value]))

    @jsii.member(jsii_name="putDcpAuthVariableExtractor")
    def put_dcp_auth_variable_extractor(
        self,
        *,
        certificate_field: typing.Optional[builtins.str] = None,
        dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_field: Specifies the field in the client certificate to extract the variable from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field DataAkamaiPropertyRulesBuilder#certificate_field}
        :param dcp_mutual_auth_processing_variable_id: Where to store the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dcp_mutual_auth_processing_variable_id DataAkamaiPropertyRulesBuilder#dcp_mutual_auth_processing_variable_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor(
            certificate_field=certificate_field,
            dcp_mutual_auth_processing_variable_id=dcp_mutual_auth_processing_variable_id,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpAuthVariableExtractor", [value]))

    @jsii.member(jsii_name="putDcpDefaultAuthzGroups")
    def put_dcp_default_authz_groups(
        self,
        *,
        group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param group_names: Specifies the set of authorization groups to assign to all connecting devices. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#group_names DataAkamaiPropertyRulesBuilder#group_names}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups(
            group_names=group_names,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDefaultAuthzGroups", [value]))

    @jsii.member(jsii_name="putDcpDevRelations")
    def put_dcp_dev_relations(
        self,
        *,
        custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_values: Allows you to specify custom JWT server connection values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_values DataAkamaiPropertyRulesBuilder#custom_values}
        :param enabled: Enables the default JWT server and sets the authentication endpoint to a default path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hostname: Specifies the JWT server's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: Specifies the path to your JWT server's authentication endpoint. This lets you generate JWTs to sign your requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations(
            custom_values=custom_values,
            enabled=enabled,
            hostname=hostname,
            locked=locked,
            path=path,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpDevRelations", [value]))

    @jsii.member(jsii_name="putDcpRealTimeAuth")
    def put_dcp_real_time_auth(
        self,
        *,
        extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname_claim: typing.Optional[builtins.str] = None,
        jurisdiction_claim: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        namespace_claim: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param extract_hostname: Extracts a hostname from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_hostname DataAkamaiPropertyRulesBuilder#extract_hostname}
        :param extract_jurisdiction: Extracts a jurisdiction that defines a geographically distributed set of servers from JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_jurisdiction DataAkamaiPropertyRulesBuilder#extract_jurisdiction}
        :param extract_namespace: Extracts a namespace from JSON web tokens (JWT). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_namespace DataAkamaiPropertyRulesBuilder#extract_namespace}
        :param hostname_claim: Specifies the claim in JWT to extract the hostname from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_claim DataAkamaiPropertyRulesBuilder#hostname_claim}
        :param jurisdiction_claim: Specifies the claim in JWT to extract the jurisdiction from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jurisdiction_claim DataAkamaiPropertyRulesBuilder#jurisdiction_claim}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param namespace_claim: Specifies the claim in JWT to extract the namespace from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#namespace_claim DataAkamaiPropertyRulesBuilder#namespace_claim}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth(
            extract_hostname=extract_hostname,
            extract_jurisdiction=extract_jurisdiction,
            extract_namespace=extract_namespace,
            hostname_claim=hostname_claim,
            jurisdiction_claim=jurisdiction_claim,
            locked=locked,
            namespace_claim=namespace_claim,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDcpRealTimeAuth", [value]))

    @jsii.member(jsii_name="putDeliveryReceipt")
    def put_delivery_receipt(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeliveryReceipt", [value]))

    @jsii.member(jsii_name="putDenyAccess")
    def put_deny_access(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reason: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Denies access when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reason: Text message that keys why access is denied. Any subsequent ``denyAccess`` behaviors within the rule tree may refer to the same ``reason`` key to override the current behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reason DataAkamaiPropertyRulesBuilder#reason}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess(
            enabled=enabled,
            locked=locked,
            reason=reason,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDenyAccess", [value]))

    @jsii.member(jsii_name="putDenyDirectFailoverAccess")
    def put_deny_direct_failover_access(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDenyDirectFailoverAccess", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicCacheId")
    def put_device_characteristic_cache_id(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies a set of information about the device with which to generate a separate cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicCacheId", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristicHeader")
    def put_device_characteristic_header(
        self,
        *,
        elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param elements: Specifies the set of information about the requesting device to send to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#elements DataAkamaiPropertyRulesBuilder#elements}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader(
            elements=elements, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristicHeader", [value]))

    @jsii.member(jsii_name="putDnsAsyncRefresh")
    def put_dns_async_refresh(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows edge servers to refresh an expired DNS record after serving content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Set the maximum allowed time an expired DNS record may be active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsAsyncRefresh", [value]))

    @jsii.member(jsii_name="putDnsPrefresh")
    def put_dns_prefresh(
        self,
        *,
        delay: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param delay: Specifies the amount of time following a DNS record's expiration to asynchronously prefresh it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delay DataAkamaiPropertyRulesBuilder#delay}
        :param enabled: Allows edge servers to refresh DNS records before they expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the amount of time to prefresh a DNS entry if there have been no requests to the domain name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh(
            delay=delay,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDnsPrefresh", [value]))

    @jsii.member(jsii_name="putDowngradeProtocol")
    def put_downgrade_protocol(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the protocol downgrading behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDowngradeProtocol", [value]))

    @jsii.member(jsii_name="putDownloadCompleteMarker")
    def put_download_complete_marker(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadCompleteMarker", [value]))

    @jsii.member(jsii_name="putDownloadNotification")
    def put_download_notification(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDownloadNotification", [value]))

    @jsii.member(jsii_name="putDownstreamCache")
    def put_downstream_cache(
        self,
        *,
        allow_behavior: typing.Optional[builtins.str] = None,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        send_headers: typing.Optional[builtins.str] = None,
        send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        ttl: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_behavior: Specify how the edge server calculates the downstream cache by setting the value of the ``Expires`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_behavior DataAkamaiPropertyRulesBuilder#allow_behavior}
        :param behavior: Specify the caching instructions the edge server sends to the end user's client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param send_headers: Specifies the HTTP headers to include in the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_headers DataAkamaiPropertyRulesBuilder#send_headers}
        :param send_private: Adds a ``Cache-Control: private`` header to prevent objects from being cached in a shared caching proxy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#send_private DataAkamaiPropertyRulesBuilder#send_private}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param ttl: Sets the duration of the cache. Setting the value to ``0`` equates to a ``no-cache`` header that forces revalidation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ttl DataAkamaiPropertyRulesBuilder#ttl}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache(
            allow_behavior=allow_behavior,
            behavior=behavior,
            locked=locked,
            send_headers=send_headers,
            send_private=send_private,
            template_uuid=template_uuid,
            ttl=ttl,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDownstreamCache", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimization")
    def put_dynamic_throughtput_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the quick retry feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimization", [value]))

    @jsii.member(jsii_name="putDynamicThroughtputOptimizationOverride")
    def put_dynamic_throughtput_optimization_override(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        throughput: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param throughput: Specifies the default target forward throughput in Mbps, ranging from 2 to 50 Mbps. If this time is exceeded during a connection attempt, quick retry is enabled and a different forward connection path is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#throughput DataAkamaiPropertyRulesBuilder#throughput}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride(
            locked=locked,
            template_uuid=template_uuid,
            throughput=throughput,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicThroughtputOptimizationOverride", [value]))

    @jsii.member(jsii_name="putDynamicWebContent")
    def put_dynamic_web_content(
        self,
        *,
        image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param image_compression: Enables image compression for subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_compression DataAkamaiPropertyRulesBuilder#image_compression}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch: Allows subcustomer content to prefetch over HTTP/2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch DataAkamaiPropertyRulesBuilder#prefetch}
        :param real_user_monitoring: Allows Real User Monitoring (RUM) to collect performance data for subcustomer content. See the ``realUserMonitoring`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#real_user_monitoring DataAkamaiPropertyRulesBuilder#real_user_monitoring}
        :param sure_route: Optimizes how subcustomer traffic routes from origin to edge servers. See the ``sureRoute`` behavior for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sure_route DataAkamaiPropertyRulesBuilder#sure_route}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent(
            image_compression=image_compression,
            locked=locked,
            prefetch=prefetch,
            real_user_monitoring=real_user_monitoring,
            sure_route=sure_route,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putDynamicWebContent", [value]))

    @jsii.member(jsii_name="putEcmsBulkUpload")
    def put_ecms_bulk_upload(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables sending a compressed archive file with objects. Sends the archive file to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsBulkUpload", [value]))

    @jsii.member(jsii_name="putEcmsDatabase")
    def put_ecms_database(
        self,
        *,
        database: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param database: Specifies a default database for this property. If you don't configure a default data set in the ``ecmsDataset`` behavior, requests to objects in this database follow the pattern: ``<hostname>/datastore/<data_set_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#database DataAkamaiPropertyRulesBuilder#database}
        :param extract_location: Specifies where to pass a database name in requests. If the specified location doesn't include the database name or the name doesn't match the regular expression, the default database is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the database name. By default, it points to ``X-KV-Database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the database name. By default, it points to ``database``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the database name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase(
            database=database,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDatabase", [value]))

    @jsii.member(jsii_name="putEcmsDataset")
    def put_ecms_dataset(
        self,
        *,
        dataset: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex_pattern: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dataset: Specifies a default data set for this property. If you don't configure a default database in the ``ecmsDatabase`` behavior, requests to objects in this data set follow the pattern: ``<hostname>/datastore/<database_name>/<object_key>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dataset DataAkamaiPropertyRulesBuilder#dataset}
        :param extract_location: Specifies where to pass a data set name in requests. If the specified location doesn't include the data set name or the name doesn't match the regular expression pattern, the default data set is used. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: Specifies the request header that passed the data set name. By default, it points to ``X-KV-Dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: Specifies the query string parameter that passed the data set name. By default, it points to ``dataset``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex_pattern: Specifies the regular expression that matches the data set name in the URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_pattern DataAkamaiPropertyRulesBuilder#regex_pattern}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset(
            dataset=dataset,
            extract_location=extract_location,
            header_name=header_name,
            locked=locked,
            query_parameter_name=query_parameter_name,
            regex_pattern=regex_pattern,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsDataset", [value]))

    @jsii.member(jsii_name="putEcmsObjectKey")
    def put_ecms_object_key(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param regex: Enables sending a compressed archive file with objects to the default path of the target data set: ``<hostname>/bulk/<database_name>/<dataset_name>``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey(
            locked=locked, regex=regex, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEcmsObjectKey", [value]))

    @jsii.member(jsii_name="putEdgeConnect")
    def put_edge_connect(
        self,
        *,
        aggregate_lines: typing.Optional[builtins.str] = None,
        aggregate_size: typing.Optional[builtins.str] = None,
        aggregate_time: typing.Optional[builtins.str] = None,
        api_connector: typing.Optional[builtins.str] = None,
        api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param aggregate_lines: Specifies the maximum number of lines to include in each log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_lines DataAkamaiPropertyRulesBuilder#aggregate_lines}
        :param aggregate_size: Specifies the log's maximum size. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_size DataAkamaiPropertyRulesBuilder#aggregate_size}
        :param aggregate_time: Specifies how often logs are generated. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aggregate_time DataAkamaiPropertyRulesBuilder#aggregate_time}
        :param api_connector: Describes the API connector type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_connector DataAkamaiPropertyRulesBuilder#api_connector}
        :param api_data_elements: Specifies the data set to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_data_elements DataAkamaiPropertyRulesBuilder#api_data_elements}
        :param destination_hostname: Specifies the target hostname accepting push API requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_path: Specifies the push API's endpoint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param enabled: Enables Cloud Monitor's log-publishing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override_aggregate_settings: When enabled, overrides default log settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_aggregate_settings DataAkamaiPropertyRulesBuilder#override_aggregate_settings}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect(
            aggregate_lines=aggregate_lines,
            aggregate_size=aggregate_size,
            aggregate_time=aggregate_time,
            api_connector=api_connector,
            api_data_elements=api_data_elements,
            destination_hostname=destination_hostname,
            destination_path=destination_path,
            enabled=enabled,
            locked=locked,
            override_aggregate_settings=override_aggregate_settings,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeConnect", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingAdvanced")
    def put_edge_load_balancing_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: A description of what the ``xml`` block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingAdvanced", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingDataCenter")
    def put_edge_load_balancing_data_center(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        ip: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: If using session persistence, this specifies the value of the cookie named in the corresponding ``edgeLoadBalancingOrigin`` behavior's ``cookie_name`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB data center, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_failover: Allows you to specify failover rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_failover DataAkamaiPropertyRulesBuilder#enable_failover}
        :param failover_rules: failover_rules block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_rules DataAkamaiPropertyRulesBuilder#failover_rules}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param hostname: Specifies the data center's hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param ip: Specifies this data center's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: Corresponds to the ``id`` specified by the ``edgeLoadBalancingOrigin`` behavior associated with this data center. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter(
            cookie_name=cookie_name,
            description=description,
            enable_failover=enable_failover,
            failover_rules=failover_rules,
            failover_title=failover_title,
            hostname=hostname,
            ip=ip,
            locked=locked,
            origin_id=origin_id,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingDataCenter", [value]))

    @jsii.member(jsii_name="putEdgeLoadBalancingOrigin")
    def put_edge_load_balancing_origin(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hostname: typing.Optional[builtins.str] = None,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_persistence_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: This specifies the name of the cookie that marks users' persistent sessions. The accompanying ``edgeLoadBalancingDataCenter`` behavior's ``description`` option specifies the cookie's value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param description: Provides a description for the ELB origin, for your own reference. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param enable_session_persistence: Allows you to specify a cookie to pin the user's browser session to one data center. When disabled, ELB's default load balancing may send users to various data centers within the same session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_session_persistence DataAkamaiPropertyRulesBuilder#enable_session_persistence}
        :param hostname: Specifies the hostname associated with the ELB rule. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param id: Specifies a unique descriptive string for this ELB origin. The value needs to match the ``origin_id`` specified by the ``edgeLoadBalancingDataCenter`` behavior associated with this origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_persistence_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_persistence_title DataAkamaiPropertyRulesBuilder#session_persistence_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin(
            cookie_name=cookie_name,
            description=description,
            enable_session_persistence=enable_session_persistence,
            hostname=hostname,
            id=id,
            locked=locked,
            session_persistence_title=session_persistence_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeLoadBalancingOrigin", [value]))

    @jsii.member(jsii_name="putEdgeOriginAuthorization")
    def put_edge_origin_authorization(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        domain: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie to use for authorization. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param domain: Specify the cookie's domain, which needs to match the top-level domain of the ``Host`` header the origin server receives. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param enabled: Enables the cookie-authorization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the value of the authorization cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization(
            cookie_name=cookie_name,
            domain=domain,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeOriginAuthorization", [value_]))

    @jsii.member(jsii_name="putEdgeRedirector")
    def put_edge_redirector(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Edge Redirector Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeRedirector", [value]))

    @jsii.member(jsii_name="putEdgeScape")
    def put_edge_scape(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, sends the ``X-Akamai-Edgescape`` request header to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeScape", [value]))

    @jsii.member(jsii_name="putEdgeSideIncludes")
    def put_edge_side_includes(
        self,
        *,
        detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
        i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param detect_injection: Denies attempts to inject ESI code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_injection DataAkamaiPropertyRulesBuilder#detect_injection}
        :param enabled: Enables ESI processing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_via_http: Enable ESI only for content featuring the ``Edge-control: dca=esi`` HTTP response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_via_http DataAkamaiPropertyRulesBuilder#enable_via_http}
        :param i18_n_charset: Specifies the character sets to use when transcoding the ESI language, ``UTF-8`` and ``ISO-8859-1`` for example. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_charset DataAkamaiPropertyRulesBuilder#i18n_charset}
        :param i18_n_status: Provides internationalization support for ESI. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#i18n_status DataAkamaiPropertyRulesBuilder#i18n_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param pass_client_ip: Allows edge servers to pass the client IP header to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_client_ip DataAkamaiPropertyRulesBuilder#pass_client_ip}
        :param pass_set_cookie: Allows edge servers to pass your origin server's cookies to the ESI processor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pass_set_cookie DataAkamaiPropertyRulesBuilder#pass_set_cookie}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes(
            detect_injection=detect_injection,
            enabled=enabled,
            enable_via_http=enable_via_http,
            i18_n_charset=i18_n_charset,
            i18_n_status=i18_n_status,
            locked=locked,
            pass_client_ip=pass_client_ip,
            pass_set_cookie=pass_set_cookie,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeSideIncludes", [value]))

    @jsii.member(jsii_name="putEdgeWorker")
    def put_edge_worker(
        self,
        *,
        create_edge_worker: typing.Optional[builtins.str] = None,
        edge_worker_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        m_pulse_information: typing.Optional[builtins.str] = None,
        resource_tier: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param create_edge_worker: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#create_edge_worker DataAkamaiPropertyRulesBuilder#create_edge_worker}
        :param edge_worker_id: Identifies the EdgeWorker application to apply to this rule's web traffic. You can use the ``EdgeWorkers API`` to get this value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_worker_id DataAkamaiPropertyRulesBuilder#edge_worker_id}
        :param enabled: When enabled, applies specified EdgeWorker functionality to this rule's web traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param m_pulse: Enables mPulse reports that include data about EdgeWorkers errors generated due to JavaScript errors. For more details, see ``Integrate mPulse reports with EdgeWorkers``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse DataAkamaiPropertyRulesBuilder#m_pulse}
        :param m_pulse_information: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#m_pulse_information DataAkamaiPropertyRulesBuilder#m_pulse_information}
        :param resource_tier: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resource_tier DataAkamaiPropertyRulesBuilder#resource_tier}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker(
            create_edge_worker=create_edge_worker,
            edge_worker_id=edge_worker_id,
            enabled=enabled,
            locked=locked,
            m_pulse=m_pulse,
            m_pulse_information=m_pulse_information,
            resource_tier=resource_tier,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorker", [value]))

    @jsii.member(jsii_name="putEnforceMtlsSettings")
    def put_enforce_mtls_settings(
        self,
        *,
        certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param certificate_authority_set: Specify the client certificate authority (CA) sets you want to support in client requests. Run the ``List CA Sets`` operation in the mTLS Edge TrustStore API to get the ``setId`` value and pass it in this option as a string. If a request includes a set not defined here, it will be denied. The preset list items you can select are contingent on the CA sets you've created using the mTLS Edge Truststore, and then associated with a certificate in the ``Certificate Provisioning System``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_authority_set DataAkamaiPropertyRulesBuilder#certificate_authority_set}
        :param enable_auth_set: Whether to require a specific mutual transport layer security (mTLS) certificate authority (CA) set in a request from a client to the edge network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_auth_set DataAkamaiPropertyRulesBuilder#enable_auth_set}
        :param enable_deny_request: This denies a request from a client that doesn't match what you've set for the options in this behavior. When disabled, non-matching requests are allowed, but you can incorporate a custom handling operation, such as reviewing generated log entries to see the discrepancies, enable the ``Client-To-Edge`` authentication header, or issue a custom message. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_deny_request DataAkamaiPropertyRulesBuilder#enable_deny_request}
        :param enable_ocsp_status: Whether the mutual transport layer security requests from a client should use the online certificate support protocol (OCSP). OCSP can determine the x.509 certificate revocation status during the TLS handshake. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ocsp_status DataAkamaiPropertyRulesBuilder#enable_ocsp_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings(
            certificate_authority_set=certificate_authority_set,
            enable_auth_set=enable_auth_set,
            enable_deny_request=enable_deny_request,
            enable_ocsp_status=enable_ocsp_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEnforceMtlsSettings", [value]))

    @jsii.member(jsii_name="putEnhancedAkamaiProtocol")
    def put_enhanced_akamai_protocol(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedAkamaiProtocol", [value]))

    @jsii.member(jsii_name="putEnhancedProxyDetection")
    def put_enhanced_proxy_detection(
        self,
        *,
        anonymous_vpn: typing.Optional[builtins.str] = None,
        best_practice_action: typing.Optional[builtins.str] = None,
        best_practice_redirecturl: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
        detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
        detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_hosting_provider_action: typing.Optional[builtins.str] = None,
        detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
        detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_public_proxy_action: typing.Optional[builtins.str] = None,
        detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_residential_proxy_action: typing.Optional[builtins.str] = None,
        detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
        detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
        detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
        detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
        detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
        detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
        enable_configuration_mode: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hosting_provider: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        public_proxy: typing.Optional[builtins.str] = None,
        residential_proxy: typing.Optional[builtins.str] = None,
        smart_dns_proxy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tor_exit_node: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        vpn_data_center: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param anonymous_vpn: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#anonymous_vpn DataAkamaiPropertyRulesBuilder#anonymous_vpn}
        :param best_practice_action: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_action DataAkamaiPropertyRulesBuilder#best_practice_action}
        :param best_practice_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#best_practice_redirecturl DataAkamaiPropertyRulesBuilder#best_practice_redirecturl}
        :param detect_anonymous_vpn: This enables detection of requests from anonymous VPNs. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn}
        :param detect_anonymous_vpn_action: Specifies how to field anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_action DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_action}
        :param detect_anonymous_vpn_redirecturl: This specifies the URL to which to redirect anonymous VPN requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_anonymous_vpn_redirecturl DataAkamaiPropertyRulesBuilder#detect_anonymous_vpn_redirecturl}
        :param detect_hosting_provider: This detects requests from a hosting provider. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider DataAkamaiPropertyRulesBuilder#detect_hosting_provider}
        :param detect_hosting_provider_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_action DataAkamaiPropertyRulesBuilder#detect_hosting_provider_action}
        :param detect_hosting_provider_redirecturl: This specifies the absolute URL to which to redirect requests from hosting providers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_hosting_provider_redirecturl DataAkamaiPropertyRulesBuilder#detect_hosting_provider_redirecturl}
        :param detect_public_proxy: This enables detection of requests from public proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy DataAkamaiPropertyRulesBuilder#detect_public_proxy}
        :param detect_public_proxy_action: Specifies how to field public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_action DataAkamaiPropertyRulesBuilder#detect_public_proxy_action}
        :param detect_public_proxy_redirecturl: This specifies the URL to which to redirect public proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_public_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_public_proxy_redirecturl}
        :param detect_residential_proxy: This enables detection of requests from a residential proxy. See ``Enhanced Proxy Detection with GeoGuard`` and learn more about this GeoGuard category before enabling it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy DataAkamaiPropertyRulesBuilder#detect_residential_proxy}
        :param detect_residential_proxy_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from residential proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_action DataAkamaiPropertyRulesBuilder#detect_residential_proxy_action}
        :param detect_residential_proxy_redirecturl: This specifies the URL to which to redirect requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_residential_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_residential_proxy_redirecturl}
        :param detect_smart_dns_proxy: This enables detection of requests from smart DNS proxies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy}
        :param detect_smart_dns_proxy_action: Specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` smart DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_action DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_action}
        :param detect_smart_dns_proxy_redirecturl: This specifies the URL to which to redirect DNS proxy requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_smart_dns_proxy_redirecturl DataAkamaiPropertyRulesBuilder#detect_smart_dns_proxy_redirecturl}
        :param detect_tor_exit_node: This enables detection of requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node DataAkamaiPropertyRulesBuilder#detect_tor_exit_node}
        :param detect_tor_exit_node_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_action DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_action}
        :param detect_tor_exit_node_redirecturl: This specifies the URL to which to redirect requests from Tor exit nodes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_tor_exit_node_redirecturl DataAkamaiPropertyRulesBuilder#detect_tor_exit_node_redirecturl}
        :param detect_vpn_data_center: This enables detection of requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center DataAkamaiPropertyRulesBuilder#detect_vpn_data_center}
        :param detect_vpn_data_center_action: This specifies whether to ``DENY``, ``ALLOW``, or ``REDIRECT`` requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_action DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_action}
        :param detect_vpn_data_center_redirecturl: This specifies the URL to which to redirect requests from VPN data centers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_vpn_data_center_redirecturl DataAkamaiPropertyRulesBuilder#detect_vpn_data_center_redirecturl}
        :param enable_configuration_mode: Specifies how to field the proxy request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_configuration_mode DataAkamaiPropertyRulesBuilder#enable_configuration_mode}
        :param enabled: Applies GeoGuard proxy detection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param forward_header_enrichment: Whether the Enhanced Proxy Detection (Akamai-EPD) header is included in the forward request to mark a connecting IP address as an anonymous proxy, with a two-letter designation. See the ``epdForwardHeaderEnrichment`` behavior for details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_header_enrichment DataAkamaiPropertyRulesBuilder#forward_header_enrichment}
        :param hosting_provider: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hosting_provider DataAkamaiPropertyRulesBuilder#hosting_provider}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param public_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#public_proxy DataAkamaiPropertyRulesBuilder#public_proxy}
        :param residential_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#residential_proxy DataAkamaiPropertyRulesBuilder#residential_proxy}
        :param smart_dns_proxy: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#smart_dns_proxy DataAkamaiPropertyRulesBuilder#smart_dns_proxy}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tor_exit_node: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tor_exit_node DataAkamaiPropertyRulesBuilder#tor_exit_node}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param vpn_data_center: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#vpn_data_center DataAkamaiPropertyRulesBuilder#vpn_data_center}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection(
            anonymous_vpn=anonymous_vpn,
            best_practice_action=best_practice_action,
            best_practice_redirecturl=best_practice_redirecturl,
            detect_anonymous_vpn=detect_anonymous_vpn,
            detect_anonymous_vpn_action=detect_anonymous_vpn_action,
            detect_anonymous_vpn_redirecturl=detect_anonymous_vpn_redirecturl,
            detect_hosting_provider=detect_hosting_provider,
            detect_hosting_provider_action=detect_hosting_provider_action,
            detect_hosting_provider_redirecturl=detect_hosting_provider_redirecturl,
            detect_public_proxy=detect_public_proxy,
            detect_public_proxy_action=detect_public_proxy_action,
            detect_public_proxy_redirecturl=detect_public_proxy_redirecturl,
            detect_residential_proxy=detect_residential_proxy,
            detect_residential_proxy_action=detect_residential_proxy_action,
            detect_residential_proxy_redirecturl=detect_residential_proxy_redirecturl,
            detect_smart_dns_proxy=detect_smart_dns_proxy,
            detect_smart_dns_proxy_action=detect_smart_dns_proxy_action,
            detect_smart_dns_proxy_redirecturl=detect_smart_dns_proxy_redirecturl,
            detect_tor_exit_node=detect_tor_exit_node,
            detect_tor_exit_node_action=detect_tor_exit_node_action,
            detect_tor_exit_node_redirecturl=detect_tor_exit_node_redirecturl,
            detect_vpn_data_center=detect_vpn_data_center,
            detect_vpn_data_center_action=detect_vpn_data_center_action,
            detect_vpn_data_center_redirecturl=detect_vpn_data_center_redirecturl,
            enable_configuration_mode=enable_configuration_mode,
            enabled=enabled,
            forward_header_enrichment=forward_header_enrichment,
            hosting_provider=hosting_provider,
            locked=locked,
            public_proxy=public_proxy,
            residential_proxy=residential_proxy,
            smart_dns_proxy=smart_dns_proxy,
            template_uuid=template_uuid,
            tor_exit_node=tor_exit_node,
            uuid=uuid,
            vpn_data_center=vpn_data_center,
        )

        return typing.cast(None, jsii.invoke(self, "putEnhancedProxyDetection", [value]))

    @jsii.member(jsii_name="putEpdForwardHeaderEnrichment")
    def put_epd_forward_header_enrichment(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Sends the Enhanced Proxy Detection (``Akamai-EPD``) header in the forward request to determine whether the connecting IP address is an anonymous proxy. The header can contain one or more two-letter codes that indicate the IP address type detected by edge servers: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putEpdForwardHeaderEnrichment", [value]))

    @jsii.member(jsii_name="putFailAction")
    def put_fail_action(
        self,
        *,
        action_type: typing.Optional[builtins.str] = None,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cex_hostname: typing.Optional[builtins.str] = None,
        cex_path: typing.Optional[builtins.str] = None,
        content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_hostname: typing.Optional[builtins.str] = None,
        content_path: typing.Optional[builtins.str] = None,
        cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
        dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_method: typing.Optional[builtins.str] = None,
        dynamic_path: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
        net_storage_path: typing.Optional[builtins.str] = None,
        preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        protocol: typing.Optional[builtins.str] = None,
        redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_hostname: typing.Optional[builtins.str] = None,
        redirect_hostname_type: typing.Optional[builtins.str] = None,
        redirect_method: typing.Optional[jsii.Number] = None,
        redirect_path: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action_type: Specifies the basic action to take when there is a failure to contact the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action_type DataAkamaiPropertyRulesBuilder#action_type}
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param cex_custom_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_custom_path DataAkamaiPropertyRulesBuilder#cex_custom_path}
        :param cex_hostname: Specifies a hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_hostname DataAkamaiPropertyRulesBuilder#cex_hostname}
        :param cex_path: Specifies a custom path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cex_path DataAkamaiPropertyRulesBuilder#cex_path}
        :param content_custom_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_custom_path DataAkamaiPropertyRulesBuilder#content_custom_path}
        :param content_hostname: Specifies the static hostname for the alternate redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_hostname DataAkamaiPropertyRulesBuilder#content_hostname}
        :param content_path: Specifies a custom redirect path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_path DataAkamaiPropertyRulesBuilder#content_path}
        :param cp_code: cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}
        :param dynamic_custom_path: Allows you to modify the original requested path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_custom_path DataAkamaiPropertyRulesBuilder#dynamic_custom_path}
        :param dynamic_method: Specifies the redirect method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_method DataAkamaiPropertyRulesBuilder#dynamic_method}
        :param dynamic_path: Specifies the new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_path DataAkamaiPropertyRulesBuilder#dynamic_path}
        :param enabled: When enabled in case of a failure to contact the origin, the current behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_protocol: Modifies the redirect's protocol using the value of the ``protocol`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_protocol DataAkamaiPropertyRulesBuilder#modify_protocol}
        :param net_storage_hostname: net_storage_hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_hostname DataAkamaiPropertyRulesBuilder#net_storage_hostname}
        :param net_storage_path: When the ``actionType`` is ``RECREATED_NS``, specifies the path for the ``NetStorage`` request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage_path DataAkamaiPropertyRulesBuilder#net_storage_path}
        :param preserve_query_string: When using either ``contentCustomPath``, ``cexCustomPath``, ``dynamicCustomPath``, or ``redirectCustomPath`` to specify a custom path, enabling this passes in the original request's query string as part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preserve_query_string DataAkamaiPropertyRulesBuilder#preserve_query_string}
        :param protocol: When the ``actionType`` is ``REDIRECT`` and ``modifyProtocol`` is enabled, this specifies the redirect's protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#protocol DataAkamaiPropertyRulesBuilder#protocol}
        :param redirect_custom_path: Uses the ``redirectPath`` to customize a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_custom_path DataAkamaiPropertyRulesBuilder#redirect_custom_path}
        :param redirect_hostname: When the ``actionType`` is ``REDIRECT`` and the ``redirectHostnameType`` is ``ALTERNATE``, this specifies the hostname for the redirect. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname DataAkamaiPropertyRulesBuilder#redirect_hostname}
        :param redirect_hostname_type: Whether to preserve or customize the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_hostname_type DataAkamaiPropertyRulesBuilder#redirect_hostname_type}
        :param redirect_method: Specifies the HTTP response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_method DataAkamaiPropertyRulesBuilder#redirect_method}
        :param redirect_path: Specifies a new path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_path DataAkamaiPropertyRulesBuilder#redirect_path}
        :param saas_cname_enabled: Specifies whether to use a CNAME chain to determine the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the number of elements in the CNAME chain backwards from the edge hostname that determines the hostname for the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the substitution pattern (a Perl-compatible regular expression) that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies the replacement pattern that defines the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static portion of the SaaS dynamic failaction. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Identifies the component of the request that identifies the SaaS dynamic fail action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param status_code: Assigns a new HTTP status code to the failure response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction(
            action_type=action_type,
            allow_fcm_parent_override=allow_fcm_parent_override,
            cex_custom_path=cex_custom_path,
            cex_hostname=cex_hostname,
            cex_path=cex_path,
            content_custom_path=content_custom_path,
            content_hostname=content_hostname,
            content_path=content_path,
            cp_code=cp_code,
            dynamic_custom_path=dynamic_custom_path,
            dynamic_method=dynamic_method,
            dynamic_path=dynamic_path,
            enabled=enabled,
            locked=locked,
            modify_protocol=modify_protocol,
            net_storage_hostname=net_storage_hostname,
            net_storage_path=net_storage_path,
            preserve_query_string=preserve_query_string,
            protocol=protocol,
            redirect_custom_path=redirect_custom_path,
            redirect_hostname=redirect_hostname,
            redirect_hostname_type=redirect_hostname_type,
            redirect_method=redirect_method,
            redirect_path=redirect_path,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailAction", [value]))

    @jsii.member(jsii_name="putFailoverBotManagerFeatureCompatibility")
    def put_failover_bot_manager_feature_compatibility(
        self,
        *,
        compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param compatibility: This behavior does not include any options. Specifying the behavior itself enables it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compatibility DataAkamaiPropertyRulesBuilder#compatibility}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility(
            compatibility=compatibility,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFailoverBotManagerFeatureCompatibility", [value]))

    @jsii.member(jsii_name="putFastInvalidate")
    def put_fast_invalidate(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, forces a validation test for all edge content to which the behavior applies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFastInvalidate", [value]))

    @jsii.member(jsii_name="putFips")
    def put_fips(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: When enabled, supports the use of FIPS-validated ciphers in the connection between this delivery configuration and your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putFips", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketing")
    def put_first_party_marketing(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketing", [value]))

    @jsii.member(jsii_name="putFirstPartyMarketingPlus")
    def put_first_party_marketing_plus(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        java_script_insertion_rule: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_math_prefix: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Cloud Marketing Plus Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param java_script_insertion_rule: Select how to insert the MediaMath JavaScript reference script. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#java_script_insertion_rule DataAkamaiPropertyRulesBuilder#java_script_insertion_rule}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_math_prefix: Specify the URL path prefix that distinguishes Cloud Marketing requests from your other web traffic. Include the leading slash character, but no trailing slash. For example, if the path prefix is ``/mmath``, and the request is for ``www.example.com/dir``, the new URL is ``www.example.com/mmath/dir``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_math_prefix DataAkamaiPropertyRulesBuilder#media_math_prefix}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus(
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            java_script_insertion_rule=java_script_insertion_rule,
            locked=locked,
            media_math_prefix=media_math_prefix,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putFirstPartyMarketingPlus", [value]))

    @jsii.member(jsii_name="putForwardRewrite")
    def put_forward_rewrite(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: This identifies the Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Forward Rewrite Cloudlet behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to use a shared policy for a Cloudlet. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putForwardRewrite", [value]))

    @jsii.member(jsii_name="putG2Oheader")
    def put_g2_oheader(
        self,
        *,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        data_header: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nonce: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        signed_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_sign_string: Specifies the set of data to be encrypted as a combination of concatenated strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param data_header: Specifies the name of the header that contains the request data that needs to be encrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_header DataAkamaiPropertyRulesBuilder#data_header}
        :param enabled: Enables the g2o verification behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param encoding_version: Specifies the version of the encryption algorithm as an integer from ``1`` through ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nonce: Specifies the cryptographic ``nonce`` string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param signed_header: Specifies the name of the header containing encrypted request data. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signed_header DataAkamaiPropertyRulesBuilder#signed_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: When disabled, the encrypted string is based on the forwarded URL. If enabled, you can use ``customSignString`` to customize the set of data to encrypt. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader(
            custom_sign_string=custom_sign_string,
            data_header=data_header,
            enabled=enabled,
            encoding_version=encoding_version,
            locked=locked,
            nonce=nonce,
            secret_key=secret_key,
            signed_header=signed_header,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putG2Oheader", [value]))

    @jsii.member(jsii_name="putGlobalRequestNumber")
    def put_global_request_number(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        output_option: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param header_name: With ``outputOption`` set to specify any set of headers, this specifies the name of the header to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param output_option: Specifies how to report the GRN value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#output_option DataAkamaiPropertyRulesBuilder#output_option}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the variable to assign the GRN value to. You need to pre-declare any ``variable`` you specify within the rule tree. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber(
            header_name=header_name,
            locked=locked,
            output_option=output_option,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putGlobalRequestNumber", [value]))

    @jsii.member(jsii_name="putGraphqlCaching")
    def put_graphql_caching(
        self,
        *,
        advanced: typing.Optional[builtins.str] = None,
        cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
        operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
        post_request_processing_error_handling: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param cache_responses_with_errors: When enabled, caches responses that include an ``error`` field at the top of the response body object. Disable this if your GraphQL server yields temporary errors with success codes in the 2xx range. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_responses_with_errors DataAkamaiPropertyRulesBuilder#cache_responses_with_errors}
        :param enabled: Enables GraphQL caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param operations_json_body_parameter_name: The name of the JSON body parameter that identifies GraphQL POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_json_body_parameter_name DataAkamaiPropertyRulesBuilder#operations_json_body_parameter_name}
        :param operations_url_query_parameter_name: Specifies the name of a query parameter that identifies requests as GraphQL queries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operations_url_query_parameter_name DataAkamaiPropertyRulesBuilder#operations_url_query_parameter_name}
        :param post_request_processing_error_handling: Specify what happens if GraphQL query processing fails on POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#post_request_processing_error_handling DataAkamaiPropertyRulesBuilder#post_request_processing_error_handling}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching(
            advanced=advanced,
            cache_responses_with_errors=cache_responses_with_errors,
            enabled=enabled,
            locked=locked,
            operations_json_body_parameter_name=operations_json_body_parameter_name,
            operations_url_query_parameter_name=operations_url_query_parameter_name,
            post_request_processing_error_handling=post_request_processing_error_handling,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putGraphqlCaching", [value]))

    @jsii.member(jsii_name="putGzipResponse")
    def put_gzip_response(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Specify when to compress responses. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse(
            behavior=behavior, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putGzipResponse", [value]))

    @jsii.member(jsii_name="putHdDataAdvanced")
    def put_hd_data_advanced(
        self,
        *,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        xml: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param description: Human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param xml: A block of Akamai XML metadata. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#xml DataAkamaiPropertyRulesBuilder#xml}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced(
            description=description,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
            xml=xml,
        )

        return typing.cast(None, jsii.invoke(self, "putHdDataAdvanced", [value]))

    @jsii.member(jsii_name="putHealthDetection")
    def put_health_detection(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_reconnects: typing.Optional[jsii.Number] = None,
        retry_count: typing.Optional[jsii.Number] = None,
        retry_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_reconnects: Specifies the maximum number of times the edge server will contact your origin server. If your origin is associated with several IP addresses, ``maximumReconnects`` effectively overrides the value of ``retryCount``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_reconnects DataAkamaiPropertyRulesBuilder#maximum_reconnects}
        :param retry_count: The number of consecutive connection failures that mark an IP address as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_count DataAkamaiPropertyRulesBuilder#retry_count}
        :param retry_interval: Specifies the amount of time the edge server will wait before trying to reconnect to an IP address it has already identified as faulty. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#retry_interval DataAkamaiPropertyRulesBuilder#retry_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection(
            locked=locked,
            maximum_reconnects=maximum_reconnects,
            retry_count=retry_count,
            retry_interval=retry_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHealthDetection", [value]))

    @jsii.member(jsii_name="putHsafEipBinding")
    def put_hsaf_eip_binding(
        self,
        *,
        custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hash_max_value: typing.Optional[jsii.Number] = None,
        hash_min_value: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_extracted_serial: Whether to pull the serial number from the variable value set in the ``advanced`` behavior. Work with your Akamai Services team to add the ``advanced`` behavior earlier in your property to extract and apply the ``AKA_PM_EIP_HSAF_SERIAL`` variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_extracted_serial DataAkamaiPropertyRulesBuilder#custom_extracted_serial}
        :param enabled: Enables HSAF for Edge IP Binding customers with a large footprint. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hash_max_value: Specifies the maximum value for the hash range, from 3 through 2046. This needs to be higher than ``hashMinValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_max_value DataAkamaiPropertyRulesBuilder#hash_max_value}
        :param hash_min_value: Specifies the minimum value for the HSAF hash range, from 2 through 2045. This needs to be lower than ``hashMaxValue``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_min_value DataAkamaiPropertyRulesBuilder#hash_min_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier: Specifies where the behavior is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier DataAkamaiPropertyRulesBuilder#tier}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding(
            custom_extracted_serial=custom_extracted_serial,
            enabled=enabled,
            hash_max_value=hash_max_value,
            hash_min_value=hash_min_value,
            locked=locked,
            template_uuid=template_uuid,
            tier=tier,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHsafEipBinding", [value]))

    @jsii.member(jsii_name="putHttp2")
    def put_http2(
        self,
        *,
        enabled: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp2", [value]))

    @jsii.member(jsii_name="putHttp3")
    def put_http3(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: This enables HTTP/3 connections between requesting clients and Akamai edge servers. You also need to enable QUIC and TLS 1.3 in your certificate deployment settings. See the ``Property Manager documentation`` for more details. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttp3", [value]))

    @jsii.member(jsii_name="putHttpStrictTransportSecurity")
    def put_http_strict_transport_security(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_age: typing.Optional[builtins.str] = None,
        preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        redirect_status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Applies HSTS to this set of requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param include_sub_domains: When enabled, applies HSTS to all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#include_sub_domains DataAkamaiPropertyRulesBuilder#include_sub_domains}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_age: Specifies the duration for which to apply HSTS for new browser connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_age DataAkamaiPropertyRulesBuilder#max_age}
        :param preload: When enabled, adds this domain to the browser's preload list. You still need to declare the domain at ``hstspreload.org``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preload DataAkamaiPropertyRulesBuilder#preload}
        :param redirect: When enabled, redirects all HTTP requests to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect DataAkamaiPropertyRulesBuilder#redirect}
        :param redirect_status_code: Specifies a response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#redirect_status_code DataAkamaiPropertyRulesBuilder#redirect_status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity(
            enable=enable,
            include_sub_domains=include_sub_domains,
            locked=locked,
            max_age=max_age,
            preload=preload,
            redirect=redirect,
            redirect_status_code=redirect_status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putHttpStrictTransportSecurity", [value]))

    @jsii.member(jsii_name="putHttpToHttpsUpgrade")
    def put_http_to_https_upgrade(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upgrade: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upgrade: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upgrade DataAkamaiPropertyRulesBuilder#upgrade}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade(
            locked=locked, template_uuid=template_uuid, upgrade=upgrade, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putHttpToHttpsUpgrade", [value]))

    @jsii.member(jsii_name="putImageAndVideoManager")
    def put_image_and_video_manager(
        self,
        *,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        image_set: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set_type: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        video_set: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_best_file_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}.
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}.
        :param image_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#image_set DataAkamaiPropertyRulesBuilder#image_set}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set_type DataAkamaiPropertyRulesBuilder#policy_set_type}.
        :param resize: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param video_set: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#video_set DataAkamaiPropertyRulesBuilder#video_set}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager(
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            image_set=image_set,
            locked=locked,
            policy_set_type=policy_set_type,
            resize=resize,
            template_uuid=template_uuid,
            uuid=uuid,
            video_set=video_set,
        )

        return typing.cast(None, jsii.invoke(self, "putImageAndVideoManager", [value]))

    @jsii.member(jsii_name="putImageManager")
    def put_image_manager(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Generates a custom ``Image and Video Manager API`` token to apply a corresponding policy to this set of images. The token consists of a descriptive label (the ``policyToken``) concatenated with a property-specific identifier that's generated when you save the property. The API registers the token when you activate the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: Specify whether to convert images to the best file type for the requesting device, based on its user agent and the initial image file. This produces the smallest file size possible that retains image quality. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Enable image management capabilities and generate a corresponding API token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Assign a prefix label to help match the policy token to this set of images, limited to 32 alphanumeric or underscore characters. If you don't specify a label, ``default`` becomes the prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specify the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. The ``advanced`` option needs to be inactive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: Specify whether to scale down images to the maximum screen resolution, as determined by the rendering device's user agent. Note that enabling this may affect screen layout in unexpected ways. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: Specifies a location for your site's heaviest traffic, for use in caching derivatives on edge servers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManager", [value]))

    @jsii.member(jsii_name="putImageManagerVideo")
    def put_image_manager_video(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        api_reference_title: typing.Optional[builtins.str] = None,
        apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
        cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        policy_set: typing.Optional[builtins.str] = None,
        policy_token: typing.Optional[builtins.str] = None,
        policy_token_default: typing.Optional[builtins.str] = None,
        resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        settings_title: typing.Optional[builtins.str] = None,
        super_cache_region: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        traffic_title: typing.Optional[builtins.str] = None,
        use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: When disabled, applies a single standard policy based on your property name. Allows you to reference a rule-specific ``policyToken`` for videos with different match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param api_reference_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_reference_title DataAkamaiPropertyRulesBuilder#api_reference_title}
        :param apply_best_file_type: When enabled, automatically converts videos to the best file type for the requesting device. This produces the smallest file size that retains image quality, based on the user agent and the initial image file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_best_file_type DataAkamaiPropertyRulesBuilder#apply_best_file_type}
        :param cp_code_original: cp_code_original block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_original DataAkamaiPropertyRulesBuilder#cp_code_original}
        :param cp_code_transformed: cp_code_transformed block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_transformed DataAkamaiPropertyRulesBuilder#cp_code_transformed}
        :param enabled: Applies Image and Video Manager's video optimization to the current content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param policy_set: Identifies the existing policy set configured with ``Image and Video Manager API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_set DataAkamaiPropertyRulesBuilder#policy_set}
        :param policy_token: Specifies a custom policy defined in the Image and Video Manager Policy Manager or the ``Image and Video Manager API``. The policy name can include up to 64 alphanumeric, dash, or underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token DataAkamaiPropertyRulesBuilder#policy_token}
        :param policy_token_default: Specifies the default policy identifier, which is registered with the ``Image and Video Manager API`` once you activate this property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy_token_default DataAkamaiPropertyRulesBuilder#policy_token_default}
        :param resize: When enabled, scales down video for smaller mobile screens, based on the device's ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#resize DataAkamaiPropertyRulesBuilder#resize}
        :param settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#settings_title DataAkamaiPropertyRulesBuilder#settings_title}
        :param super_cache_region: To optimize caching, assign a region close to your site's heaviest traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#super_cache_region DataAkamaiPropertyRulesBuilder#super_cache_region}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param traffic_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#traffic_title DataAkamaiPropertyRulesBuilder#traffic_title}
        :param use_existing_policy_set: Whether to use a previously created policy set that may be referenced in other properties, or create a new policy set to use with this property. A policy set can be shared across multiple properties belonging to the same contract. The behavior populates any changes to the policy set across all properties that reference that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_existing_policy_set DataAkamaiPropertyRulesBuilder#use_existing_policy_set}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo(
            advanced=advanced,
            api_reference_title=api_reference_title,
            apply_best_file_type=apply_best_file_type,
            cp_code_original=cp_code_original,
            cp_code_transformed=cp_code_transformed,
            enabled=enabled,
            locked=locked,
            policy_set=policy_set,
            policy_token=policy_token,
            policy_token_default=policy_token_default,
            resize=resize,
            settings_title=settings_title,
            super_cache_region=super_cache_region,
            template_uuid=template_uuid,
            traffic_title=traffic_title,
            use_existing_policy_set=use_existing_policy_set,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putImageManagerVideo", [value]))

    @jsii.member(jsii_name="putImOverride")
    def put_im_override(
        self,
        *,
        dpr: typing.Optional[jsii.Number] = None,
        dprvar: typing.Optional[builtins.str] = None,
        exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        format: typing.Optional[builtins.str] = None,
        formatvar: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        policyvar: typing.Optional[builtins.str] = None,
        policyvar_i_mvar: typing.Optional[builtins.str] = None,
        policyvar_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        typesel: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        width: typing.Optional[jsii.Number] = None,
        widthvar: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param dpr: Directly specifies the pixel density. The numeric value is a scaling factor of 1, representing normal density. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dpr DataAkamaiPropertyRulesBuilder#dpr}
        :param dprvar: This selects the variable with the desired pixel density. The variable specifies the same type of data as the ``dpr`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dprvar DataAkamaiPropertyRulesBuilder#dprvar}
        :param exclude_all_query_parameters: Whether to exclude all query parameters from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exclude_all_query_parameters DataAkamaiPropertyRulesBuilder#exclude_all_query_parameters}
        :param excluded_query_parameters: Specifies individual query parameters to exclude from the Image and Video Manager cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#excluded_query_parameters DataAkamaiPropertyRulesBuilder#excluded_query_parameters}
        :param format: Specifies the type of the browser, or the encodings passed in the ``Accept`` header, that you want to optimize images for. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param formatvar: This selects the variable with the name of the browser you want to optimize images for. The variable specifies the same type of data as the ``format`` option below. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#formatvar DataAkamaiPropertyRulesBuilder#formatvar}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override: Selects the type of query parameter you want to set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override DataAkamaiPropertyRulesBuilder#override}
        :param policy: This selects the desired Image and Video Manager policy name directly. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}
        :param policyvar: This selects the variable with the desired Image and Video Manager policy name to apply to image requests. If there is no policy by that name, Image and Video Manager serves the image unmodified. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar DataAkamaiPropertyRulesBuilder#policyvar}
        :param policyvar_i_mvar: This selects one of the property's rule tree variables to assign to the ``policyvarName`` variable within Image and Video Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_i_mvar DataAkamaiPropertyRulesBuilder#policyvar_i_mvar}
        :param policyvar_name: This selects the name of one of the variables defined in an Image and Video Manager policy that you want to replace with the property's rule tree variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policyvar_name DataAkamaiPropertyRulesBuilder#policyvar_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param typesel: Specifies how to set a query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#typesel DataAkamaiPropertyRulesBuilder#typesel}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param width: Sets the image's desired pixel width directly. If the Image Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#width DataAkamaiPropertyRulesBuilder#width}
        :param widthvar: Selects the variable with the desired width. If the Image and Video Manager policy doesn't define that width, it serves the next largest width. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#widthvar DataAkamaiPropertyRulesBuilder#widthvar}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride(
            dpr=dpr,
            dprvar=dprvar,
            exclude_all_query_parameters=exclude_all_query_parameters,
            excluded_query_parameters=excluded_query_parameters,
            format=format,
            formatvar=formatvar,
            locked=locked,
            override=override,
            policy=policy,
            policyvar=policyvar,
            policyvar_i_mvar=policyvar_i_mvar,
            policyvar_name=policyvar_name,
            template_uuid=template_uuid,
            typesel=typesel,
            uuid=uuid,
            width=width,
            widthvar=widthvar,
        )

        return typing.cast(None, jsii.invoke(self, "putImOverride", [value]))

    @jsii.member(jsii_name="putInclude")
    def put_include(
        self,
        *,
        id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Identifies the include you want to add to your rule tree. You can get the include ID using ``PAPI``. This option only accepts digits, without the ``inc_`` ID prefix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id} Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude(
            id=id, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInclude", [value]))

    @jsii.member(jsii_name="putInstant")
    def put_instant(
        self,
        *,
        custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_link_relations: Specify link relation values that activate the prefetching behavior. For example, specifying ``fetch`` allows you to use shorter ``rel="fetch"`` markup. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_link_relations DataAkamaiPropertyRulesBuilder#custom_link_relations}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefetch_cacheable: When enabled, applies prefetching only to objects already set to be cacheable, for example using the ``caching`` behavior. Only applies to content with the ``tieredDistribution`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_cacheable DataAkamaiPropertyRulesBuilder#prefetch_cacheable}
        :param prefetch_html: Allows edge servers to prefetch additional HTML pages while pages that link to them are being delivered. This only applies to links from ``<a>`` or ``<link>`` tags with the appropriate link relation attribute. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_html DataAkamaiPropertyRulesBuilder#prefetch_html}
        :param prefetch_no_store: Allows otherwise non-cacheable ``no-store`` content to prefetch if the URL path ends with ``/`` to indicate a request for a default file, or if the extension matches the value of the ``prefetchNoStoreExtensions`` option. Only applies to content with the ``sureRoute`` behavior enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store DataAkamaiPropertyRulesBuilder#prefetch_no_store}
        :param prefetch_no_store_extensions: Specifies a set of file extensions for which the ``prefetchNoStore`` option is allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_no_store_extensions DataAkamaiPropertyRulesBuilder#prefetch_no_store_extensions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant(
            custom_link_relations=custom_link_relations,
            locked=locked,
            prefetch_cacheable=prefetch_cacheable,
            prefetch_html=prefetch_html,
            prefetch_no_store=prefetch_no_store,
            prefetch_no_store_extensions=prefetch_no_store_extensions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putInstant", [value]))

    @jsii.member(jsii_name="putInstantConfig")
    def put_instant_config(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the InstantConfig behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putInstantConfig", [value]))

    @jsii.member(jsii_name="putLargeFileOptimization")
    def put_large_file_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_partial_object_caching: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        minimum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_partial_object_caching: Specifies whether to cache partial objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_partial_object_caching DataAkamaiPropertyRulesBuilder#enable_partial_object_caching}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Optimization does not apply to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. The size of a file can't be greater than 323 GB. If you need to optimize a larger file, contact Akamai Professional Services for help. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param minimum_size: Optimization only applies to files larger than this, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#minimum_size DataAkamaiPropertyRulesBuilder#minimum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_versioning: When ``enablePartialObjectCaching`` is set to ``PARTIAL_OBJECT_CACHING``, enabling this option signals your intention to vary filenames by version, strongly recommended to avoid serving corrupt content when chunks come from different versions of the same file. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_versioning DataAkamaiPropertyRulesBuilder#use_versioning}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization(
            enabled=enabled,
            enable_partial_object_caching=enable_partial_object_caching,
            locked=locked,
            maximum_size=maximum_size,
            minimum_size=minimum_size,
            template_uuid=template_uuid,
            use_versioning=use_versioning,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimization", [value]))

    @jsii.member(jsii_name="putLargeFileOptimizationAdvanced")
    def put_large_file_optimization_advanced(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        fragment_size: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_size: typing.Optional[builtins.str] = None,
        prefetch_after_request: typing.Optional[jsii.Number] = None,
        prefetch_during_request: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the file optimization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param fragment_size: Specifies the size of each fragment used for partial object caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#fragment_size DataAkamaiPropertyRulesBuilder#fragment_size}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_size: Specifies the size of the file at which point to apply partial object (POC) caching. Append a numeric value with a ``MB`` or ``GB`` suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}
        :param prefetch_after_request: The number of POC fragments to prefetch after the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_after_request DataAkamaiPropertyRulesBuilder#prefetch_after_request}
        :param prefetch_during_request: The number of POC fragments to prefetch during the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefetch_during_request DataAkamaiPropertyRulesBuilder#prefetch_during_request}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced(
            enabled=enabled,
            fragment_size=fragment_size,
            locked=locked,
            object_size=object_size,
            prefetch_after_request=prefetch_after_request,
            prefetch_during_request=prefetch_during_request,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLargeFileOptimizationAdvanced", [value]))

    @jsii.member(jsii_name="putLimitBitRate")
    def put_limit_bit_rate(
        self,
        *,
        bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bitrate_table: bitrate_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bitrate_table DataAkamaiPropertyRulesBuilder#bitrate_table}
        :param enabled: When enabled, activates the bit rate limiting behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param threshold_table: threshold_table block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#threshold_table DataAkamaiPropertyRulesBuilder#threshold_table}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate(
            bitrate_table=bitrate_table,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            threshold_table=threshold_table,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLimitBitRate", [value]))

    @jsii.member(jsii_name="putLogCustom")
    def put_log_custom(
        self,
        *,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. Since this option can specify both a request and response, it overrides any ``customLogField`` settings in the ``report`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom(
            custom_log_field=custom_log_field,
            locked=locked,
            log_custom_log_field=log_custom_log_field,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putLogCustom", [value]))

    @jsii.member(jsii_name="putManifestPersonalization")
    def put_manifest_personalization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
        hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
        hls_mode: typing.Optional[builtins.str] = None,
        hls_preferred_bitrate: typing.Optional[builtins.str] = None,
        hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_query_param_secret_key: typing.Optional[builtins.str] = None,
        hls_query_param_transition_key: typing.Optional[builtins.str] = None,
        hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        hls_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Manifest Personalization feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param hls_enabled: Allows you to customize the HLS master manifest that's sent to the requesting client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enabled DataAkamaiPropertyRulesBuilder#hls_enabled}
        :param hls_enable_debug_headers: Includes additional ``Akamai-Manifest-Personalization`` and ``Akamai-Manifest-Personalization-Config-Source`` debugging headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_enable_debug_headers DataAkamaiPropertyRulesBuilder#hls_enable_debug_headers}
        :param hls_filter_in_bitrate_ranges: Specifies a comma-delimited set of bit rate ranges, such as ``100-400,1000-4000``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those ranges are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrate_ranges DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrate_ranges}
        :param hls_filter_in_bitrates: Specifies a comma-delimited set of preferred bit rates, such as ``100,200,400``. Playlists specified in the ``#EXT-X-STREAM-INF`` tag with bit rates outside of any of those values by up to 100 Kbps are excluded from the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_filter_in_bitrates DataAkamaiPropertyRulesBuilder#hls_filter_in_bitrates}
        :param hls_mode: Applies with ``hlsEnabled`` on. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_mode DataAkamaiPropertyRulesBuilder#hls_mode}
        :param hls_preferred_bitrate: Sets the preferred bit rate in Kbps. This causes the media playlist specified in the ``#EXT-X-STREAM-INF`` tag that most closely matches the value to list first. All other playlists maintain their current position in the manifest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_preferred_bitrate DataAkamaiPropertyRulesBuilder#hls_preferred_bitrate}
        :param hls_query_param_enabled: Specifies query parameters for the HLS master manifest to customize the manifest's content. Any settings specified in the query string override those already configured in Property Manager. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_enabled DataAkamaiPropertyRulesBuilder#hls_query_param_enabled}
        :param hls_query_param_secret_key: Specifies a primary key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_secret_key DataAkamaiPropertyRulesBuilder#hls_query_param_secret_key}
        :param hls_query_param_transition_key: Specifies a transition key as a token to accompany the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_query_param_transition_key DataAkamaiPropertyRulesBuilder#hls_query_param_transition_key}
        :param hls_show_advanced: Allows you to configure advanced settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_show_advanced DataAkamaiPropertyRulesBuilder#hls_show_advanced}
        :param hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_title DataAkamaiPropertyRulesBuilder#hls_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization(
            enabled=enabled,
            hls_enabled=hls_enabled,
            hls_enable_debug_headers=hls_enable_debug_headers,
            hls_filter_in_bitrate_ranges=hls_filter_in_bitrate_ranges,
            hls_filter_in_bitrates=hls_filter_in_bitrates,
            hls_mode=hls_mode,
            hls_preferred_bitrate=hls_preferred_bitrate,
            hls_query_param_enabled=hls_query_param_enabled,
            hls_query_param_secret_key=hls_query_param_secret_key,
            hls_query_param_transition_key=hls_query_param_transition_key,
            hls_show_advanced=hls_show_advanced,
            hls_title=hls_title,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestPersonalization", [value]))

    @jsii.member(jsii_name="putManifestRerouting")
    def put_manifest_rerouting(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        username: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param partner: Set this value to ``adobe_primetime``, which is an external technology partner that provides value added offerings, like advertisement integration, to the requested media objects. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner DataAkamaiPropertyRulesBuilder#partner}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param username: The user name for your Adobe Primetime account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#username DataAkamaiPropertyRulesBuilder#username}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting(
            locked=locked,
            partner=partner,
            template_uuid=template_uuid,
            username=username,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManifestRerouting", [value]))

    @jsii.member(jsii_name="putManualServerPush")
    def put_manual_server_push(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serverpushlist: Specifies the set of objects to load into the client browser's cache over HTTP2. Each value in the array represents a hostname and full path to the object, such as ``www.example.com/js/site.js``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serverpushlist DataAkamaiPropertyRulesBuilder#serverpushlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush(
            locked=locked,
            serverpushlist=serverpushlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putManualServerPush", [value]))

    @jsii.member(jsii_name="putMediaAcceleration")
    def put_media_acceleration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Media Acceleration. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAcceleration", [value]))

    @jsii.member(jsii_name="putMediaAccelerationQuicOptout")
    def put_media_acceleration_quic_optout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        optout: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param optout: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optout DataAkamaiPropertyRulesBuilder#optout}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout(
            locked=locked, optout=optout, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaAccelerationQuicOptout", [value]))

    @jsii.member(jsii_name="putMediaClient")
    def put_media_client(
        self,
        *,
        beacon_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param beacon_id: Specifies the ID of data source's beacon. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_id DataAkamaiPropertyRulesBuilder#beacon_id}
        :param enabled: Enables client-side download analytics. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_hybrid_http_udp: Enables the hybrid HTTP/UDP protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_hybrid_http_udp DataAkamaiPropertyRulesBuilder#use_hybrid_http_udp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient(
            beacon_id=beacon_id,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            use_hybrid_http_udp=use_hybrid_http_udp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaClient", [value]))

    @jsii.member(jsii_name="putMediaFileRetrievalOptimization")
    def put_media_file_retrieval_optimization(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the partial-object caching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMediaFileRetrievalOptimization", [value]))

    @jsii.member(jsii_name="putMediaOriginFailover")
    def put_media_origin_failover(
        self,
        *,
        cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_window: typing.Optional[builtins.str] = None,
        client_response_code: typing.Optional[builtins.str] = None,
        detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_object_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
        detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        object_unavailable_backup_host: typing.Optional[builtins.str] = None,
        object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_detection_level: typing.Optional[builtins.str] = None,
        object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_modified_path: typing.Optional[builtins.str] = None,
        object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        object_unavailable_protocol: typing.Optional[builtins.str] = None,
        object_unavailable_recovery: typing.Optional[builtins.str] = None,
        object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
        origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
        origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
        origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
        origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unavailable_protocol: typing.Optional[builtins.str] = None,
        origin_unavailable_recovery: typing.Optional[builtins.str] = None,
        origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
        origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
        origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
        origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
        origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
        origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
        origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
        origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
        origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
        origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
        other_options: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_error_response: When enabled, caches the error response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_error_response DataAkamaiPropertyRulesBuilder#cache_error_response}
        :param cache_window: This sets error response's TTL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_window DataAkamaiPropertyRulesBuilder#cache_window}
        :param client_response_code: Specifies the response code served to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_response_code DataAkamaiPropertyRulesBuilder#client_response_code}
        :param detect_object_unavailable: Allows you to configure failover settings when the origin has content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable DataAkamaiPropertyRulesBuilder#detect_object_unavailable}
        :param detect_object_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_object_unavailable_title DataAkamaiPropertyRulesBuilder#detect_object_unavailable_title}
        :param detect_origin_unavailable: Allows you to configure failover settings when the origin server responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable DataAkamaiPropertyRulesBuilder#detect_origin_unavailable}
        :param detect_origin_unavailable_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unavailable_title DataAkamaiPropertyRulesBuilder#detect_origin_unavailable_title}
        :param detect_origin_unresponsive: Allows you to configure what happens when the origin is unresponsive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive}
        :param detect_origin_unresponsive_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#detect_origin_unresponsive_title DataAkamaiPropertyRulesBuilder#detect_origin_unresponsive_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param object_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#object_unavailable_alternate_host}
        :param object_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_backup_host DataAkamaiPropertyRulesBuilder#object_unavailable_backup_host}
        :param object_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_origin_ip}
        :param object_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#object_unavailable_blacklist_window}
        :param object_unavailable_change_protocol: Changes the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_change_protocol}
        :param object_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_detection_level DataAkamaiPropertyRulesBuilder#object_unavailable_detection_level}
        :param object_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#object_unavailable_include_query_string}
        :param object_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modified_path DataAkamaiPropertyRulesBuilder#object_unavailable_modified_path}
        :param object_unavailable_modify_request_path: Enabling this allows you to modify the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#object_unavailable_modify_request_path}
        :param object_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_protocol DataAkamaiPropertyRulesBuilder#object_unavailable_protocol}
        :param object_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_recovery DataAkamaiPropertyRulesBuilder#object_unavailable_recovery}
        :param object_unavailable_redirect_method: Specifies a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#object_unavailable_redirect_method}
        :param object_unavailable_response_codes: Specifies the set of response codes identifying when there are content errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_response_codes DataAkamaiPropertyRulesBuilder#object_unavailable_response_codes}
        :param object_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#object_unavailable_retry_limit}
        :param origin_unavailable_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_alternate_host DataAkamaiPropertyRulesBuilder#origin_unavailable_alternate_host}
        :param origin_unavailable_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_backup_host DataAkamaiPropertyRulesBuilder#origin_unavailable_backup_host}
        :param origin_unavailable_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_origin_ip}
        :param origin_unavailable_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unavailable_blacklist_window}
        :param origin_unavailable_change_protocol: Modifies the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_change_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_change_protocol}
        :param origin_unavailable_detection_level: Specify ``RESPONSE_CODES``, the only available option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_detection_level DataAkamaiPropertyRulesBuilder#origin_unavailable_detection_level}
        :param origin_unavailable_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_include_query_string DataAkamaiPropertyRulesBuilder#origin_unavailable_include_query_string}
        :param origin_unavailable_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modified_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modified_path}
        :param origin_unavailable_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unavailable_modify_request_path}
        :param origin_unavailable_protocol: Specifies either the ``HTTP`` or ``HTTPS`` protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_protocol DataAkamaiPropertyRulesBuilder#origin_unavailable_protocol}
        :param origin_unavailable_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_recovery DataAkamaiPropertyRulesBuilder#origin_unavailable_recovery}
        :param origin_unavailable_redirect_method: Specifies either a redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_redirect_method DataAkamaiPropertyRulesBuilder#origin_unavailable_redirect_method}
        :param origin_unavailable_response_codes: Specifies the set of response codes identifying when the origin responds with errors. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_response_codes DataAkamaiPropertyRulesBuilder#origin_unavailable_response_codes}
        :param origin_unavailable_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unavailable_retry_limit DataAkamaiPropertyRulesBuilder#origin_unavailable_retry_limit}
        :param origin_unresponsive_alternate_host: This specifies the redirect's destination hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_alternate_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_alternate_host}
        :param origin_unresponsive_backup_host: This specifies the origin hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_backup_host DataAkamaiPropertyRulesBuilder#origin_unresponsive_backup_host}
        :param origin_unresponsive_blacklist_origin_ip: Enabling this blacklists the origin's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_origin_ip DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_origin_ip}
        :param origin_unresponsive_blacklist_window: This sets the delay before blacklisting an IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_blacklist_window DataAkamaiPropertyRulesBuilder#origin_unresponsive_blacklist_window}
        :param origin_unresponsive_change_protocol: This allows you to change the request protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_change_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_change_protocol}
        :param origin_unresponsive_detection_level: Specify the level of response to slow origin connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_detection_level DataAkamaiPropertyRulesBuilder#origin_unresponsive_detection_level}
        :param origin_unresponsive_include_query_string: Enabling this includes the original set of query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_include_query_string DataAkamaiPropertyRulesBuilder#origin_unresponsive_include_query_string}
        :param origin_unresponsive_modified_path: This specifies the path to form the new URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modified_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modified_path}
        :param origin_unresponsive_modify_request_path: Modifies the request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_modify_request_path DataAkamaiPropertyRulesBuilder#origin_unresponsive_modify_request_path}
        :param origin_unresponsive_protocol: Specifies which protocol to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_protocol DataAkamaiPropertyRulesBuilder#origin_unresponsive_protocol}
        :param origin_unresponsive_recovery: This sets the recovery option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_recovery DataAkamaiPropertyRulesBuilder#origin_unresponsive_recovery}
        :param origin_unresponsive_redirect_method: Specifies the redirect response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_redirect_method DataAkamaiPropertyRulesBuilder#origin_unresponsive_redirect_method}
        :param origin_unresponsive_retry_limit: Sets how many times to retry. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_unresponsive_retry_limit DataAkamaiPropertyRulesBuilder#origin_unresponsive_retry_limit}
        :param other_options: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#other_options DataAkamaiPropertyRulesBuilder#other_options}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover(
            cache_error_response=cache_error_response,
            cache_window=cache_window,
            client_response_code=client_response_code,
            detect_object_unavailable=detect_object_unavailable,
            detect_object_unavailable_title=detect_object_unavailable_title,
            detect_origin_unavailable=detect_origin_unavailable,
            detect_origin_unavailable_title=detect_origin_unavailable_title,
            detect_origin_unresponsive=detect_origin_unresponsive,
            detect_origin_unresponsive_title=detect_origin_unresponsive_title,
            locked=locked,
            object_unavailable_alternate_host=object_unavailable_alternate_host,
            object_unavailable_backup_host=object_unavailable_backup_host,
            object_unavailable_blacklist_origin_ip=object_unavailable_blacklist_origin_ip,
            object_unavailable_blacklist_window=object_unavailable_blacklist_window,
            object_unavailable_change_protocol=object_unavailable_change_protocol,
            object_unavailable_detection_level=object_unavailable_detection_level,
            object_unavailable_include_query_string=object_unavailable_include_query_string,
            object_unavailable_modified_path=object_unavailable_modified_path,
            object_unavailable_modify_request_path=object_unavailable_modify_request_path,
            object_unavailable_protocol=object_unavailable_protocol,
            object_unavailable_recovery=object_unavailable_recovery,
            object_unavailable_redirect_method=object_unavailable_redirect_method,
            object_unavailable_response_codes=object_unavailable_response_codes,
            object_unavailable_retry_limit=object_unavailable_retry_limit,
            origin_unavailable_alternate_host=origin_unavailable_alternate_host,
            origin_unavailable_backup_host=origin_unavailable_backup_host,
            origin_unavailable_blacklist_origin_ip=origin_unavailable_blacklist_origin_ip,
            origin_unavailable_blacklist_window=origin_unavailable_blacklist_window,
            origin_unavailable_change_protocol=origin_unavailable_change_protocol,
            origin_unavailable_detection_level=origin_unavailable_detection_level,
            origin_unavailable_include_query_string=origin_unavailable_include_query_string,
            origin_unavailable_modified_path=origin_unavailable_modified_path,
            origin_unavailable_modify_request_path=origin_unavailable_modify_request_path,
            origin_unavailable_protocol=origin_unavailable_protocol,
            origin_unavailable_recovery=origin_unavailable_recovery,
            origin_unavailable_redirect_method=origin_unavailable_redirect_method,
            origin_unavailable_response_codes=origin_unavailable_response_codes,
            origin_unavailable_retry_limit=origin_unavailable_retry_limit,
            origin_unresponsive_alternate_host=origin_unresponsive_alternate_host,
            origin_unresponsive_backup_host=origin_unresponsive_backup_host,
            origin_unresponsive_blacklist_origin_ip=origin_unresponsive_blacklist_origin_ip,
            origin_unresponsive_blacklist_window=origin_unresponsive_blacklist_window,
            origin_unresponsive_change_protocol=origin_unresponsive_change_protocol,
            origin_unresponsive_detection_level=origin_unresponsive_detection_level,
            origin_unresponsive_include_query_string=origin_unresponsive_include_query_string,
            origin_unresponsive_modified_path=origin_unresponsive_modified_path,
            origin_unresponsive_modify_request_path=origin_unresponsive_modify_request_path,
            origin_unresponsive_protocol=origin_unresponsive_protocol,
            origin_unresponsive_recovery=origin_unresponsive_recovery,
            origin_unresponsive_redirect_method=origin_unresponsive_redirect_method,
            origin_unresponsive_retry_limit=origin_unresponsive_retry_limit,
            other_options=other_options,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMediaOriginFailover", [value]))

    @jsii.member(jsii_name="putMetadataCaching")
    def put_metadata_caching(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables metadata caching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataCaching", [value]))

    @jsii.member(jsii_name="putMobileSdkPerformance")
    def put_mobile_sdk_performance(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Mobile App Performance SDK. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param secondary_multipath_to_origin: When enabled, sends secondary multi-path requests to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secondary_multipath_to_origin DataAkamaiPropertyRulesBuilder#secondary_multipath_to_origin}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance(
            enabled=enabled,
            locked=locked,
            secondary_multipath_to_origin=secondary_multipath_to_origin,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMobileSdkPerformance", [value]))

    @jsii.member(jsii_name="putModifyIncomingRequestHeader")
    def put_modify_incoming_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Supplies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyIncomingResponseHeader")
    def put_modify_incoming_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        standard_pass_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD``, ``DELETE``, ``MODIFY``, or ``PASS`` incoming HTTP response headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the header's new value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param standard_pass_header_name: If the value of ``action`` is ``PASS``, this specifies the name of the field to pass through. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_pass_header_name DataAkamaiPropertyRulesBuilder#standard_pass_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            new_header_value=new_header_value,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            standard_pass_header_name=standard_pass_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyIncomingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingRequestHeader")
    def put_modify_outgoing_request_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP request headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the new header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies an HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingRequestHeader", [value]))

    @jsii.member(jsii_name="putModifyOutgoingResponseHeader")
    def put_modify_outgoing_response_header(
        self,
        *,
        action: typing.Optional[builtins.str] = None,
        avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_header_name: typing.Optional[builtins.str] = None,
        header_value: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        new_header_value: typing.Optional[builtins.str] = None,
        regex_header_match: typing.Optional[builtins.str] = None,
        regex_header_replace: typing.Optional[builtins.str] = None,
        standard_add_header_name: typing.Optional[builtins.str] = None,
        standard_delete_header_name: typing.Optional[builtins.str] = None,
        standard_modify_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param action: Either ``ADD`` or ``DELETE`` outgoing HTTP response headers, ``MODIFY`` their fixed values, or specify a ``REGEX`` pattern to transform them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#action DataAkamaiPropertyRulesBuilder#action}
        :param avoid_duplicate_headers: When enabled with the ``action`` set to ``MODIFY``, prevents creation of more than one instance of a header. The last header clobbers others with the same name. This option affects the entire set of outgoing headers, and is not confined to the subset of regular expression matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#avoid_duplicate_headers DataAkamaiPropertyRulesBuilder#avoid_duplicate_headers}
        :param custom_header_name: Specifies a custom field name that applies when the relevant ``standard`` header name is set to ``OTHER``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header_name DataAkamaiPropertyRulesBuilder#custom_header_name}
        :param header_value: Specifies the existing value of the header to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_value DataAkamaiPropertyRulesBuilder#header_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_multiple: When enabled with the ``action`` set to ``REGEX``, replaces all occurrences of the matched regular expression, otherwise only the first match if disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param new_header_value: Specifies the new HTTP header replacement value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#new_header_value DataAkamaiPropertyRulesBuilder#new_header_value}
        :param regex_header_match: Specifies a Perl-compatible regular expression to match within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_match DataAkamaiPropertyRulesBuilder#regex_header_match}
        :param regex_header_replace: Specifies text that replaces the ``regexHeaderMatch`` pattern within the header value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex_header_replace DataAkamaiPropertyRulesBuilder#regex_header_replace}
        :param standard_add_header_name: If the value of ``action`` is ``ADD``, this specifies the name of the field to add. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_add_header_name DataAkamaiPropertyRulesBuilder#standard_add_header_name}
        :param standard_delete_header_name: If the value of ``action`` is ``DELETE``, this specifies the name of the field to remove. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_delete_header_name DataAkamaiPropertyRulesBuilder#standard_delete_header_name}
        :param standard_modify_header_name: If the value of ``action`` is ``MODIFY`` or ``REGEX``, this specifies the name of the field to modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_modify_header_name DataAkamaiPropertyRulesBuilder#standard_modify_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader(
            action=action,
            avoid_duplicate_headers=avoid_duplicate_headers,
            custom_header_name=custom_header_name,
            header_value=header_value,
            locked=locked,
            match_multiple=match_multiple,
            new_header_value=new_header_value,
            regex_header_match=regex_header_match,
            regex_header_replace=regex_header_replace,
            standard_add_header_name=standard_add_header_name,
            standard_delete_header_name=standard_delete_header_name,
            standard_modify_header_name=standard_modify_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyOutgoingResponseHeader", [value]))

    @jsii.member(jsii_name="putModifyViaHeader")
    def put_modify_via_header(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modification_option: typing.Optional[builtins.str] = None,
        rename_header_to: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables ``Via`` header modifications. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modification_option: Specify how you want to handle the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modification_option DataAkamaiPropertyRulesBuilder#modification_option}
        :param rename_header_to: Specifies a new name to replace the existing ``Via`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rename_header_to DataAkamaiPropertyRulesBuilder#rename_header_to}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader(
            enabled=enabled,
            locked=locked,
            modification_option=modification_option,
            rename_header_to=rename_header_to,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putModifyViaHeader", [value]))

    @jsii.member(jsii_name="putMPulse")
    def put_m_pulse(
        self,
        *,
        api_key: typing.Optional[builtins.str] = None,
        buffer_size: typing.Optional[builtins.str] = None,
        config_override: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        loader_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        title_optional: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param api_key: This generated value uniquely identifies sections of your website for you to analyze independently. To access this value, see ``Enable mPulse in Property Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#api_key DataAkamaiPropertyRulesBuilder#api_key}
        :param buffer_size: Allows you to override the browser's default (150) maximum number of reported performance timeline entries. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#buffer_size DataAkamaiPropertyRulesBuilder#buffer_size}
        :param config_override: A JSON string representing a configuration object passed to the JavaScript library under which mPulse runs. It corresponds at run-time to the ``window.BOOMR_config`` object. For example, this turns on monitoring of Single Page App frameworks: ``"{\\"history\\": {\\"enabled\\": true, \\"auto\\": true}}"``. See ``Configuration Overrides`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_override DataAkamaiPropertyRulesBuilder#config_override}
        :param enabled: Applies performance monitoring to this behavior's set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param loader_version: Specifies the version of the Boomerang JavaScript loader snippet. See ``mPulse Loader Snippets`` for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#loader_version DataAkamaiPropertyRulesBuilder#loader_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param require_pci: Suppresses gathering metrics for potentially sensitive end-user interactions. Enabling this omits data from some older browsers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#require_pci DataAkamaiPropertyRulesBuilder#require_pci}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param title_optional: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#title_optional DataAkamaiPropertyRulesBuilder#title_optional}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse(
            api_key=api_key,
            buffer_size=buffer_size,
            config_override=config_override,
            enabled=enabled,
            loader_version=loader_version,
            locked=locked,
            require_pci=require_pci,
            template_uuid=template_uuid,
            title_optional=title_optional,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMPulse", [value]))

    @jsii.member(jsii_name="putOrigin")
    def put_origin(
        self,
        *,
        cache_key_hostname: typing.Optional[builtins.str] = None,
        compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
        custom_forward_host_header: typing.Optional[builtins.str] = None,
        custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        forward_host_header: typing.Optional[builtins.str] = None,
        hostname: typing.Optional[builtins.str] = None,
        http_port: typing.Optional[jsii.Number] = None,
        https_port: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max_tls_version: typing.Optional[builtins.str] = None,
        min_tls_version: typing.Optional[builtins.str] = None,
        mslorigin: typing.Optional[builtins.str] = None,
        net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
        origin_certificate: typing.Optional[builtins.str] = None,
        origin_certs_to_honor: typing.Optional[builtins.str] = None,
        origin_id: typing.Optional[builtins.str] = None,
        origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_type: typing.Optional[builtins.str] = None,
        ports: typing.Optional[builtins.str] = None,
        saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        saas_cname_level: typing.Optional[jsii.Number] = None,
        saas_cookie: typing.Optional[builtins.str] = None,
        saas_query_string: typing.Optional[builtins.str] = None,
        saas_regex: typing.Optional[builtins.str] = None,
        saas_replace: typing.Optional[builtins.str] = None,
        saas_suffix: typing.Optional[builtins.str] = None,
        saas_type: typing.Optional[builtins.str] = None,
        second_hostname: typing.Optional[builtins.str] = None,
        second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        tls_version_title: typing.Optional[builtins.str] = None,
        true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        true_client_ip_header: typing.Optional[builtins.str] = None,
        use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_mode: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cache_key_hostname: Specifies the hostname to use when forming a cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key_hostname DataAkamaiPropertyRulesBuilder#cache_key_hostname}
        :param compress: Enables ``gzip`` compression for non-NetStorage origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#compress DataAkamaiPropertyRulesBuilder#compress}
        :param custom_certificate_authorities: custom_certificate_authorities block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificate_authorities DataAkamaiPropertyRulesBuilder#custom_certificate_authorities}
        :param custom_certificates: custom_certificates block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_certificates DataAkamaiPropertyRulesBuilder#custom_certificates}
        :param custom_forward_host_header: This specifies the name of the custom host header the edge server should pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_forward_host_header DataAkamaiPropertyRulesBuilder#custom_forward_host_header}
        :param custom_valid_cn_values: Specifies values to look for in the origin certificate's ``Subject Alternate Name`` or ``Common Name`` fields. Specify ``{{Origin Hostname}}`` and ``{{Forward Host Header}}`` within the text in the order you want them to be evaluated. (Note that these two template items are not the same as in-line ``variables``, which use the same curly-brace syntax.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_valid_cn_values DataAkamaiPropertyRulesBuilder#custom_valid_cn_values}
        :param enable_true_client_ip: When enabled on non-NetStorage origins, allows you to send a custom header (the ``trueClientIpHeader``) identifying the IP address of the immediate client connecting to the edge server. This may provide more useful information than the standard ``X-Forward-For`` header, which proxies may modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_true_client_ip DataAkamaiPropertyRulesBuilder#enable_true_client_ip}
        :param forward_host_header: When the ``originType`` is set to either ``CUSTOMER`` or ``SAAS_DYNAMIC_ORIGIN``, this specifies which ``Host`` header to pass to the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#forward_host_header DataAkamaiPropertyRulesBuilder#forward_host_header}
        :param hostname: Specifies the hostname or IPv4 address of your origin server, from which edge servers can retrieve your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param http_port: Specifies the port on your origin server to which edge servers should connect for HTTP requests, customarily ``80``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_port DataAkamaiPropertyRulesBuilder#http_port}
        :param https_port: Specifies the port on your origin server to which edge servers should connect for secure HTTPS requests, customarily ``443``. This option only applies if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#https_port DataAkamaiPropertyRulesBuilder#https_port}
        :param ip_version: Specifies which IP version to use when getting content from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max_tls_version: Specifies the maximum TLS version to use for connections to your origin server. As best practice, use ``DYNAMIC`` to automatically apply the latest supported version. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_tls_version DataAkamaiPropertyRulesBuilder#max_tls_version}
        :param min_tls_version: Specifies the minimum TLS version to use for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_tls_version DataAkamaiPropertyRulesBuilder#min_tls_version}
        :param mslorigin: This specifies the media's origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslorigin DataAkamaiPropertyRulesBuilder#mslorigin}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param origin_certificate: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certificate DataAkamaiPropertyRulesBuilder#origin_certificate}
        :param origin_certs_to_honor: Specifies which certificate to trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_certs_to_honor DataAkamaiPropertyRulesBuilder#origin_certs_to_honor}
        :param origin_id: Identifies the Edge Load Balancing origin. This needs to correspond to an ``edgeLoadBalancingOrigin`` behavior's ``id`` attribute within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param origin_sni: For non-NetStorage origins, enabling this adds a Server Name Indication (SNI) header in the SSL request sent to the origin, with the origin hostname as the value. See the ``verification settings in the Origin Server behavior`` or contact your Akamai representative for more information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_sni DataAkamaiPropertyRulesBuilder#origin_sni}
        :param origin_type: Choose where your content is retrieved from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param ports: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ports DataAkamaiPropertyRulesBuilder#ports}
        :param saas_cname_enabled: Enabling this allows you to use a ``CNAME chain`` to determine the hostname for this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_enabled DataAkamaiPropertyRulesBuilder#saas_cname_enabled}
        :param saas_cname_level: Specifies the desired number of hostnames to use in the ``CNAME chain``, starting backwards from the edge server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cname_level DataAkamaiPropertyRulesBuilder#saas_cname_level}
        :param saas_cookie: Specifies the name of the cookie that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_cookie DataAkamaiPropertyRulesBuilder#saas_cookie}
        :param saas_query_string: Specifies the name of the query parameter that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_query_string DataAkamaiPropertyRulesBuilder#saas_query_string}
        :param saas_regex: Specifies the Perl-compatible regular expression match that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_regex DataAkamaiPropertyRulesBuilder#saas_regex}
        :param saas_replace: Specifies replacement text for what ``saasRegex`` matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_replace DataAkamaiPropertyRulesBuilder#saas_replace}
        :param saas_suffix: Specifies the static part of the SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_suffix DataAkamaiPropertyRulesBuilder#saas_suffix}
        :param saas_type: Specifies the part of the request that identifies this SaaS dynamic origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#saas_type DataAkamaiPropertyRulesBuilder#saas_type}
        :param second_hostname: Specifies the origin server's hostname, IPv4 address, or IPv6 address. Edge servers retrieve your content from this origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname DataAkamaiPropertyRulesBuilder#second_hostname}
        :param second_hostname_enabled: Available only for certain products. This specifies whether you want to use an additional origin server address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#second_hostname_enabled DataAkamaiPropertyRulesBuilder#second_hostname_enabled}
        :param standard_certificate_authorities: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#standard_certificate_authorities DataAkamaiPropertyRulesBuilder#standard_certificate_authorities}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tls13_support: Enables transport layer security (TLS) version 1.3 for connections to your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls13_support DataAkamaiPropertyRulesBuilder#tls13_support}
        :param tls_version_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tls_version_title DataAkamaiPropertyRulesBuilder#tls_version_title}
        :param true_client_ip_client_setting: If a client sets the ``True-Client-IP`` header, the edge server allows it and passes the value to the origin. Otherwise the edge server removes it and sets the value itself. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_client_setting DataAkamaiPropertyRulesBuilder#true_client_ip_client_setting}
        :param true_client_ip_header: This specifies the name of the field that identifies the end client's IP address, for example ``True-Client-IP``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#true_client_ip_header DataAkamaiPropertyRulesBuilder#true_client_ip_header}
        :param use_unique_cache_key: With a shared ``hostname`` such as provided by Amazon AWS, sets a unique cache key for your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_unique_cache_key DataAkamaiPropertyRulesBuilder#use_unique_cache_key}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_mode: For non-NetStorage origins, maximize security by controlling which certificates edge servers should trust. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_mode DataAkamaiPropertyRulesBuilder#verification_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin(
            cache_key_hostname=cache_key_hostname,
            compress=compress,
            custom_certificate_authorities=custom_certificate_authorities,
            custom_certificates=custom_certificates,
            custom_forward_host_header=custom_forward_host_header,
            custom_valid_cn_values=custom_valid_cn_values,
            enable_true_client_ip=enable_true_client_ip,
            forward_host_header=forward_host_header,
            hostname=hostname,
            http_port=http_port,
            https_port=https_port,
            ip_version=ip_version,
            locked=locked,
            max_tls_version=max_tls_version,
            min_tls_version=min_tls_version,
            mslorigin=mslorigin,
            net_storage=net_storage,
            origin_certificate=origin_certificate,
            origin_certs_to_honor=origin_certs_to_honor,
            origin_id=origin_id,
            origin_sni=origin_sni,
            origin_type=origin_type,
            ports=ports,
            saas_cname_enabled=saas_cname_enabled,
            saas_cname_level=saas_cname_level,
            saas_cookie=saas_cookie,
            saas_query_string=saas_query_string,
            saas_regex=saas_regex,
            saas_replace=saas_replace,
            saas_suffix=saas_suffix,
            saas_type=saas_type,
            second_hostname=second_hostname,
            second_hostname_enabled=second_hostname_enabled,
            standard_certificate_authorities=standard_certificate_authorities,
            template_uuid=template_uuid,
            tls13_support=tls13_support,
            tls_version_title=tls_version_title,
            true_client_ip_client_setting=true_client_ip_client_setting,
            true_client_ip_header=true_client_ip_header,
            use_unique_cache_key=use_unique_cache_key,
            uuid=uuid,
            verification_mode=verification_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putOrigin", [value]))

    @jsii.member(jsii_name="putOriginCharacteristics")
    def put_origin_characteristics(
        self,
        *,
        access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        adc_title: typing.Optional[builtins.str] = None,
        authentication_method: typing.Optional[builtins.str] = None,
        authentication_method_title: typing.Optional[builtins.str] = None,
        aws_access_key_id: typing.Optional[builtins.str] = None,
        aws_access_key_version_guid: typing.Optional[builtins.str] = None,
        aws_ar_region: typing.Optional[builtins.str] = None,
        aws_host: typing.Optional[builtins.str] = None,
        aws_region: typing.Optional[builtins.str] = None,
        aws_secret_access_key: typing.Optional[builtins.str] = None,
        aws_service: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
        direct_connect_geo: typing.Optional[builtins.str] = None,
        encoding_version: typing.Optional[jsii.Number] = None,
        end_point_service: typing.Optional[builtins.str] = None,
        gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
        gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
        gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
        hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mslkey: typing.Optional[builtins.str] = None,
        mslname: typing.Optional[builtins.str] = None,
        nonce: typing.Optional[builtins.str] = None,
        origin_location_title: typing.Optional[builtins.str] = None,
        property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        role_arn: typing.Optional[builtins.str] = None,
        secret_key: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_key_encrypted_storage: Enables secure use of access keys defined in Cloud Access Manager. Access keys store encrypted authentication details required to sign requests to cloud origins. If you disable this option, you'll need to store the authentication details unencrypted. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_key_encrypted_storage DataAkamaiPropertyRulesBuilder#access_key_encrypted_storage}
        :param adc_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#adc_title DataAkamaiPropertyRulesBuilder#adc_title}
        :param authentication_method: Specifies the authentication method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method DataAkamaiPropertyRulesBuilder#authentication_method}
        :param authentication_method_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authentication_method_title DataAkamaiPropertyRulesBuilder#authentication_method_title}
        :param aws_access_key_id: Specifies active access key ID linked to your AWS account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_id DataAkamaiPropertyRulesBuilder#aws_access_key_id}
        :param aws_access_key_version_guid: Identifies the unique ``awsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to AWS S3. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_access_key_version_guid DataAkamaiPropertyRulesBuilder#aws_access_key_version_guid}
        :param aws_ar_region: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_ar_region DataAkamaiPropertyRulesBuilder#aws_ar_region}.
        :param aws_host: This specifies the AWS hostname, without ``http://`` or ``https://`` prefixes. If you leave this option empty, it inherits the hostname from the ``origin`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_host DataAkamaiPropertyRulesBuilder#aws_host}
        :param aws_region: This specifies the AWS region code of the location where your bucket resides. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_region DataAkamaiPropertyRulesBuilder#aws_region}
        :param aws_secret_access_key: Specifies the secret linked to the access key identifier that you want to use to sign requests to AWS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_secret_access_key DataAkamaiPropertyRulesBuilder#aws_secret_access_key}
        :param aws_service: This specifies the subdomain of your AWS service. It precedes ``amazonaws.com`` or the region code in the AWS hostname. For example, ``s3.amazonaws.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#aws_service DataAkamaiPropertyRulesBuilder#aws_service}
        :param country: Specifies the origin's geographic region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}
        :param custom_sign_string: Specifies the data to be encrypted as a series of enumerated variable names. See ``Built-in system variables`` for guidance on each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_sign_string DataAkamaiPropertyRulesBuilder#custom_sign_string}
        :param direct_connect_geo: Provides a region used by Akamai Direct Connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#direct_connect_geo DataAkamaiPropertyRulesBuilder#direct_connect_geo}
        :param encoding_version: Specifies the version of the encryption algorithm, an integer from ``1`` to ``5``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encoding_version DataAkamaiPropertyRulesBuilder#encoding_version}
        :param end_point_service: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_point_service DataAkamaiPropertyRulesBuilder#end_point_service}.
        :param gcs_access_key_version_guid: Identifies the unique ``gcsAccessKeyVersionGuid`` access key ``created`` in Cloud Access Manager to sign your requests to Google Cloud Storage in interoperability mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_access_key_version_guid DataAkamaiPropertyRulesBuilder#gcs_access_key_version_guid}
        :param gcs_hmac_key_access_id: Specifies the active access ID linked to your Google account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_access_id DataAkamaiPropertyRulesBuilder#gcs_hmac_key_access_id}
        :param gcs_hmac_key_secret: Specifies the secret linked to the access ID that you want to use to sign requests to Google Cloud Storage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#gcs_hmac_key_secret DataAkamaiPropertyRulesBuilder#gcs_hmac_key_secret}
        :param hostname_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname_tag DataAkamaiPropertyRulesBuilder#hostname_tag}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mslkey: Specifies the access key provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslkey DataAkamaiPropertyRulesBuilder#mslkey}
        :param mslname: Specifies the origin name provided by the hosting service. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mslname DataAkamaiPropertyRulesBuilder#mslname}
        :param nonce: Specifies the nonce. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param origin_location_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_location_title DataAkamaiPropertyRulesBuilder#origin_location_title}
        :param property_id_tag: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#property_id_tag DataAkamaiPropertyRulesBuilder#property_id_tag}.
        :param role_arn: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#role_arn DataAkamaiPropertyRulesBuilder#role_arn}.
        :param secret_key: Specifies the shared secret key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secret_key DataAkamaiPropertyRulesBuilder#secret_key}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_custom_sign_string: Specifies whether to customize your signed string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_custom_sign_string DataAkamaiPropertyRulesBuilder#use_custom_sign_string}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics(
            access_key_encrypted_storage=access_key_encrypted_storage,
            adc_title=adc_title,
            authentication_method=authentication_method,
            authentication_method_title=authentication_method_title,
            aws_access_key_id=aws_access_key_id,
            aws_access_key_version_guid=aws_access_key_version_guid,
            aws_ar_region=aws_ar_region,
            aws_host=aws_host,
            aws_region=aws_region,
            aws_secret_access_key=aws_secret_access_key,
            aws_service=aws_service,
            country=country,
            custom_sign_string=custom_sign_string,
            direct_connect_geo=direct_connect_geo,
            encoding_version=encoding_version,
            end_point_service=end_point_service,
            gcs_access_key_version_guid=gcs_access_key_version_guid,
            gcs_hmac_key_access_id=gcs_hmac_key_access_id,
            gcs_hmac_key_secret=gcs_hmac_key_secret,
            hostname_tag=hostname_tag,
            locked=locked,
            mslkey=mslkey,
            mslname=mslname,
            nonce=nonce,
            origin_location_title=origin_location_title,
            property_id_tag=property_id_tag,
            role_arn=role_arn,
            secret_key=secret_key,
            template_uuid=template_uuid,
            use_custom_sign_string=use_custom_sign_string,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristics", [value]))

    @jsii.member(jsii_name="putOriginCharacteristicsWsd")
    def put_origin_characteristics_wsd(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origintype: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origintype: Specifies an origin type. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origintype DataAkamaiPropertyRulesBuilder#origintype}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd(
            locked=locked,
            origintype=origintype,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginCharacteristicsWsd", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryMethod")
    def put_origin_failure_recovery_method(
        self,
        *,
        custom_status_code: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        recovery_method: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param custom_status_code: Specifies the custom status code to be sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_status_code DataAkamaiPropertyRulesBuilder#custom_status_code}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param recovery_method: Specifies the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_method DataAkamaiPropertyRulesBuilder#recovery_method}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod(
            custom_status_code=custom_status_code,
            locked=locked,
            recovery_method=recovery_method,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryMethod", [value]))

    @jsii.member(jsii_name="putOriginFailureRecoveryPolicy")
    def put_origin_failure_recovery_policy(
        self,
        *,
        binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
        ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
        monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
        monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
        origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
        origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
        origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
        status_code_monitoring1: typing.Optional[builtins.str] = None,
        status_code_monitoring2: typing.Optional[builtins.str] = None,
        status_code_monitoring3: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tuning_parameters: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param binary_equivalent_content: Synchronizes content between the primary and backup origins, byte for byte. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#binary_equivalent_content DataAkamaiPropertyRulesBuilder#binary_equivalent_content}
        :param enabled: Activates and configures a recovery policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_ip_avoidance: Temporarily blocks an origin IP address that experienced a certain number of failures. When an IP address is blocked, the ``configName`` established for ``originResponsivenessRecoveryConfigName`` is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ip_avoidance DataAkamaiPropertyRulesBuilder#enable_ip_avoidance}
        :param ip_avoidance_error_threshold: Defines the number of failures that need to occur to an origin address before it's blocked. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_error_threshold DataAkamaiPropertyRulesBuilder#ip_avoidance_error_threshold}
        :param ip_avoidance_retry_interval: Defines the number of seconds after which the IP address is removed from the blocklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_avoidance_retry_interval DataAkamaiPropertyRulesBuilder#ip_avoidance_retry_interval}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param monitor_origin_responsiveness: Enables continuous monitoring of connectivity to the origin. If necessary, applies retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_origin_responsiveness DataAkamaiPropertyRulesBuilder#monitor_origin_responsiveness}
        :param monitor_response_codes1: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes1 DataAkamaiPropertyRulesBuilder#monitor_response_codes1}
        :param monitor_response_codes2: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes2 DataAkamaiPropertyRulesBuilder#monitor_response_codes2}
        :param monitor_response_codes3: Defines the origin response codes that trigger a subsequent retry or recovery action. Specify a single code entry (``501``) or a range (``501:504``). If you configure other ``monitorStatusCodes*`` and ``monitorResponseCodes*`` options, you can't use the same codes here.. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_response_codes3 DataAkamaiPropertyRulesBuilder#monitor_response_codes3}
        :param monitor_status_codes1: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1 DataAkamaiPropertyRulesBuilder#monitor_status_codes1}
        :param monitor_status_codes1_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_recovery}
        :param monitor_status_codes1_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes1_enable_retry}
        :param monitor_status_codes1_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes1_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes1_recovery_config_name}
        :param monitor_status_codes2: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2 DataAkamaiPropertyRulesBuilder#monitor_status_codes2}
        :param monitor_status_codes2_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_recovery}
        :param monitor_status_codes2_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes2_enable_retry}
        :param monitor_status_codes2_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes2_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes2_recovery_config_name}
        :param monitor_status_codes3: Enables continuous monitoring for the specific origin status codes that trigger retry or recovery actions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3 DataAkamaiPropertyRulesBuilder#monitor_status_codes3}
        :param monitor_status_codes3_enable_recovery: Enables the recovery action for the response codes you define. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_recovery DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_recovery}
        :param monitor_status_codes3_enable_retry: When the defined response codes apply, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_enable_retry DataAkamaiPropertyRulesBuilder#monitor_status_codes3_enable_retry}
        :param monitor_status_codes3_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#monitor_status_codes3_recovery_config_name DataAkamaiPropertyRulesBuilder#monitor_status_codes3_recovery_config_name}
        :param origin_responsiveness_custom_timeout: Specify a custom timeout, from 1 to 10 seconds. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_custom_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_custom_timeout}
        :param origin_responsiveness_enable_recovery: Enables a recovery action for a specific failure condition. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_recovery DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_recovery}
        :param origin_responsiveness_enable_retry: If a specific failure condition applies, attempts a retry on the same origin before executing the recovery method. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_enable_retry DataAkamaiPropertyRulesBuilder#origin_responsiveness_enable_retry}
        :param origin_responsiveness_monitoring: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_monitoring DataAkamaiPropertyRulesBuilder#origin_responsiveness_monitoring}
        :param origin_responsiveness_recovery_config_name: Specifies a recovery configuration using the ``configName`` you defined in the ``recoveryConfig`` match criteria. Specify 3 to 20 alphanumeric characters or dashes. Ensure that you use the ``recoveryConfig`` match criteria to apply this option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_recovery_config_name DataAkamaiPropertyRulesBuilder#origin_responsiveness_recovery_config_name}
        :param origin_responsiveness_timeout: The timeout threshold that triggers a retry or recovery action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_responsiveness_timeout DataAkamaiPropertyRulesBuilder#origin_responsiveness_timeout}
        :param status_code_monitoring1: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring1 DataAkamaiPropertyRulesBuilder#status_code_monitoring1}
        :param status_code_monitoring2: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring2 DataAkamaiPropertyRulesBuilder#status_code_monitoring2}
        :param status_code_monitoring3: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code_monitoring3 DataAkamaiPropertyRulesBuilder#status_code_monitoring3}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tuning_parameters: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tuning_parameters DataAkamaiPropertyRulesBuilder#tuning_parameters}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy(
            binary_equivalent_content=binary_equivalent_content,
            enabled=enabled,
            enable_ip_avoidance=enable_ip_avoidance,
            ip_avoidance_error_threshold=ip_avoidance_error_threshold,
            ip_avoidance_retry_interval=ip_avoidance_retry_interval,
            locked=locked,
            monitor_origin_responsiveness=monitor_origin_responsiveness,
            monitor_response_codes1=monitor_response_codes1,
            monitor_response_codes2=monitor_response_codes2,
            monitor_response_codes3=monitor_response_codes3,
            monitor_status_codes1=monitor_status_codes1,
            monitor_status_codes1_enable_recovery=monitor_status_codes1_enable_recovery,
            monitor_status_codes1_enable_retry=monitor_status_codes1_enable_retry,
            monitor_status_codes1_recovery_config_name=monitor_status_codes1_recovery_config_name,
            monitor_status_codes2=monitor_status_codes2,
            monitor_status_codes2_enable_recovery=monitor_status_codes2_enable_recovery,
            monitor_status_codes2_enable_retry=monitor_status_codes2_enable_retry,
            monitor_status_codes2_recovery_config_name=monitor_status_codes2_recovery_config_name,
            monitor_status_codes3=monitor_status_codes3,
            monitor_status_codes3_enable_recovery=monitor_status_codes3_enable_recovery,
            monitor_status_codes3_enable_retry=monitor_status_codes3_enable_retry,
            monitor_status_codes3_recovery_config_name=monitor_status_codes3_recovery_config_name,
            origin_responsiveness_custom_timeout=origin_responsiveness_custom_timeout,
            origin_responsiveness_enable_recovery=origin_responsiveness_enable_recovery,
            origin_responsiveness_enable_retry=origin_responsiveness_enable_retry,
            origin_responsiveness_monitoring=origin_responsiveness_monitoring,
            origin_responsiveness_recovery_config_name=origin_responsiveness_recovery_config_name,
            origin_responsiveness_timeout=origin_responsiveness_timeout,
            status_code_monitoring1=status_code_monitoring1,
            status_code_monitoring2=status_code_monitoring2,
            status_code_monitoring3=status_code_monitoring3,
            template_uuid=template_uuid,
            tuning_parameters=tuning_parameters,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginFailureRecoveryPolicy", [value]))

    @jsii.member(jsii_name="putOriginIpAcl")
    def put_origin_ip_acl(
        self,
        *,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable: Enables the Origin IP Access Control List behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl(
            enable=enable, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putOriginIpAcl", [value]))

    @jsii.member(jsii_name="putPermissionsPolicy")
    def put_permissions_policy(
        self,
        *,
        allow_list: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_list: The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here. They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param permissions_policy_directive: Each directive represents a browser feature. Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy(
            allow_list=allow_list,
            locked=locked,
            permissions_policy_directive=permissions_policy_directive,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPermissionsPolicy", [value]))

    @jsii.member(jsii_name="putPersistentClientConnection")
    def put_persistent_client_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentClientConnection", [value]))

    @jsii.member(jsii_name="putPersistentConnection")
    def put_persistent_connection(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPersistentConnection", [value]))

    @jsii.member(jsii_name="putPersonallyIdentifiableInformation")
    def put_personally_identifiable_information(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPersonallyIdentifiableInformation", [value]))

    @jsii.member(jsii_name="putPhasedRelease")
    def put_phased_release(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease(
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enabled=enabled,
            failover_duration=failover_duration,
            failover_enabled=failover_enabled,
            failover_response_code=failover_response_code,
            failover_title=failover_title,
            is_shared_policy=is_shared_policy,
            label=label,
            locked=locked,
            population_cookie_type=population_cookie_type,
            population_duration=population_duration,
            population_expiration_date=population_expiration_date,
            population_refresh=population_refresh,
            population_title=population_title,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPhasedRelease", [value]))

    @jsii.member(jsii_name="putPreconnect")
    def put_preconnect(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect(
            locked=locked,
            preconnectlist=preconnectlist,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPreconnect", [value]))

    @jsii.member(jsii_name="putPredictiveContentDelivery")
    def put_predictive_content_delivery(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPredictiveContentDelivery", [value]))

    @jsii.member(jsii_name="putPredictivePrefetching")
    def put_predictive_prefetching(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching(
            accuracy_target=accuracy_target,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPredictivePrefetching", [value]))

    @jsii.member(jsii_name="putPrefetch")
    def put_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetch", [value]))

    @jsii.member(jsii_name="putPrefetchable")
    def put_prefetchable(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putPrefetchable", [value]))

    @jsii.member(jsii_name="putPrefreshCache")
    def put_prefresh_cache(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache(
            enabled=enabled,
            locked=locked,
            prefreshval=prefreshval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putPrefreshCache", [value]))

    @jsii.member(jsii_name="putQuality")
    def put_quality(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality(
            audience_settings=audience_settings,
            catalog_size=catalog_size,
            content_settings=content_settings,
            content_type=content_type,
            country=country,
            delivery_format=delivery_format,
            delivery_type=delivery_type,
            download_type=download_type,
            end_user_location=end_user_location,
            locked=locked,
            maximum_concurrent_users=maximum_concurrent_users,
            object_size=object_size,
            optimize_for=optimize_for,
            origin_settings=origin_settings,
            popularity_distribution=popularity_distribution,
            refresh_rate=refresh_rate,
            segment_duration=segment_duration,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuality", [value]))

    @jsii.member(jsii_name="putQuicBeta")
    def put_quic_beta(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta(
            enabled=enabled,
            locked=locked,
            quic_offer_percentage=quic_offer_percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putQuicBeta", [value]))

    @jsii.member(jsii_name="putRandomSeek")
    def put_random_seek(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek(
            flv=flv,
            locked=locked,
            maximum_size=maximum_size,
            mp4=mp4,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRandomSeek", [value]))

    @jsii.member(jsii_name="putRapid")
    def put_rapid(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRapid", [value]))

    @jsii.member(jsii_name="putReadTimeout")
    def put_read_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putReadTimeout", [value_]))

    @jsii.member(jsii_name="putRealTimeReporting")
    def put_real_time_reporting(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting(
            advanced=advanced,
            beacon_sampling_percentage=beacon_sampling_percentage,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRealTimeReporting", [value]))

    @jsii.member(jsii_name="putRealUserMonitoring")
    def put_real_user_monitoring(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRealUserMonitoring", [value]))

    @jsii.member(jsii_name="putRedirect")
    def put_redirect(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect(
            destination_hostname=destination_hostname,
            destination_hostname_other=destination_hostname_other,
            destination_hostname_sibling=destination_hostname_sibling,
            destination_hostname_subdomain=destination_hostname_subdomain,
            destination_path=destination_path,
            destination_path_other=destination_path_other,
            destination_path_prefix=destination_path_prefix,
            destination_path_suffix=destination_path_suffix,
            destination_path_suffix_status=destination_path_suffix_status,
            destination_protocol=destination_protocol,
            locked=locked,
            mobile_default_choice=mobile_default_choice,
            query_string=query_string,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirect", [value]))

    @jsii.member(jsii_name="putRedirectplus")
    def put_redirectplus(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus(
            destination=destination,
            enabled=enabled,
            locked=locked,
            response_code=response_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRedirectplus", [value]))

    @jsii.member(jsii_name="putRefererChecking")
    def put_referer_checking(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking(
            allow_children=allow_children,
            domains=domains,
            enabled=enabled,
            locked=locked,
            strict=strict,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRefererChecking", [value]))

    @jsii.member(jsii_name="putRemoveQueryParameter")
    def put_remove_query_parameter(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter(
            locked=locked,
            parameters=parameters,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveQueryParameter", [value]))

    @jsii.member(jsii_name="putRemoveVary")
    def put_remove_vary(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRemoveVary", [value]))

    @jsii.member(jsii_name="putReport")
    def put_report(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport(
            cookies=cookies,
            custom_log_field=custom_log_field,
            locked=locked,
            log_accept_language=log_accept_language,
            log_cookies=log_cookies,
            log_custom_log_field=log_custom_log_field,
            log_edge_ip=log_edge_ip,
            log_host=log_host,
            log_referer=log_referer,
            log_user_agent=log_user_agent,
            log_x_forwarded_for=log_x_forwarded_for,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReport", [value]))

    @jsii.member(jsii_name="putRequestClientHints")
    def put_request_client_hints(
        self,
        *,
        accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accept_ch: The client hint data objects you want to receive from the browser. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        :param accept_critical_ch: The critical client hint data objects you want to receive from the browser. The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reset: This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser. This empty header doesn't get merged with other objects sent from your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints(
            accept_ch=accept_ch,
            accept_critical_ch=accept_critical_ch,
            locked=locked,
            reset=reset,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestClientHints", [value]))

    @jsii.member(jsii_name="putRequestControl")
    def put_request_control(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl(
            branded403_file=branded403_file,
            branded403_status_code=branded403_status_code,
            branded403_url=branded403_url,
            branded_deny_cache_ttl=branded_deny_cache_ttl,
            cloudlet_policy=cloudlet_policy,
            cloudlet_shared_policy=cloudlet_shared_policy,
            enable_branded403=enable_branded403,
            enabled=enabled,
            is_shared_policy=is_shared_policy,
            locked=locked,
            net_storage=net_storage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestControl", [value]))

    @jsii.member(jsii_name="putRequestTypeMarker")
    def put_request_type_marker(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker(
            locked=locked,
            request_type=request_type,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestTypeMarker", [value]))

    @jsii.member(jsii_name="putResourceOptimizer")
    def put_resource_optimizer(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizer", [value]))

    @jsii.member(jsii_name="putResourceOptimizerExtendedCompatibility")
    def put_resource_optimizer_extended_compatibility(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility(
            enable_all_features=enable_all_features,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResourceOptimizerExtendedCompatibility", [value]))

    @jsii.member(jsii_name="putResponseCode")
    def put_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode(
            locked=locked,
            override206=override206,
            status_code=status_code,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCode", [value]))

    @jsii.member(jsii_name="putResponseCookie")
    def put_response_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie(
            cookie_name=cookie_name,
            default_domain=default_domain,
            default_path=default_path,
            domain=domain,
            duration=duration,
            enabled=enabled,
            expiration_date=expiration_date,
            expires=expires,
            format=format,
            http_only=http_only,
            locked=locked,
            path=path,
            same_site=same_site,
            secure=secure,
            template_uuid=template_uuid,
            type=type,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseCookie", [value_]))

    @jsii.member(jsii_name="putRestrictObjectCaching")
    def put_restrict_object_caching(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching(
            locked=locked,
            maximum_size=maximum_size,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRestrictObjectCaching", [value]))

    @jsii.member(jsii_name="putReturnCacheStatus")
    def put_return_cache_status(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus(
            locked=locked,
            response_header_name=response_header_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putReturnCacheStatus", [value]))

    @jsii.member(jsii_name="putRewriteUrl")
    def put_rewrite_url(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl(
            behavior=behavior,
            keep_query_string=keep_query_string,
            locked=locked,
            match=match,
            match_multiple=match_multiple,
            match_regex=match_regex,
            target_path=target_path,
            target_path_prepend=target_path_prepend,
            target_regex=target_regex,
            target_url=target_url,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRewriteUrl", [value]))

    @jsii.member(jsii_name="putRumCustom")
    def put_rum_custom(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom(
            locked=locked,
            rum_group_name=rum_group_name,
            rum_sample_rate=rum_sample_rate,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRumCustom", [value]))

    @jsii.member(jsii_name="putSaasDefinitions")
    def put_saas_definitions(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions(
            application_action=application_action,
            application_cname_enabled=application_cname_enabled,
            application_cname_level=application_cname_level,
            application_cookie=application_cookie,
            application_query_string=application_query_string,
            application_regex=application_regex,
            application_replace=application_replace,
            application_title=application_title,
            customer_action=customer_action,
            customer_cname_enabled=customer_cname_enabled,
            customer_cname_level=customer_cname_level,
            customer_cookie=customer_cookie,
            customer_query_string=customer_query_string,
            customer_regex=customer_regex,
            customer_replace=customer_replace,
            customer_title=customer_title,
            locked=locked,
            template_uuid=template_uuid,
            users_action=users_action,
            users_cname_enabled=users_cname_enabled,
            users_cname_level=users_cname_level,
            users_cookie=users_cookie,
            users_query_string=users_query_string,
            users_regex=users_regex,
            users_replace=users_replace,
            users_title=users_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSaasDefinitions", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudClient")
    def put_sales_force_commerce_cloud_client(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient(
            allow_override_origin_cache_key=allow_override_origin_cache_key,
            connector_id=connector_id,
            enabled=enabled,
            locked=locked,
            origin_host_header=origin_host_header,
            origin_type=origin_type,
            sf3_c_origin_host=sf3_c_origin_host,
            sf3_c_origin_host_header=sf3_c_origin_host_header,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudClient", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProvider")
    def put_sales_force_commerce_cloud_provider(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProvider", [value]))

    @jsii.member(jsii_name="putSalesForceCommerceCloudProviderHostHeader")
    def put_sales_force_commerce_cloud_provider_host_header(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader(
            host_header_source=host_header_source,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSalesForceCommerceCloudProviderHostHeader", [value]))

    @jsii.member(jsii_name="putSavePostDcaProcessing")
    def put_save_post_dca_processing(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSavePostDcaProcessing", [value]))

    @jsii.member(jsii_name="putScheduleInvalidation")
    def put_schedule_invalidation(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation(
            locked=locked,
            refresh_method=refresh_method,
            repeat=repeat,
            repeat_interval=repeat_interval,
            start=start,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScheduleInvalidation", [value]))

    @jsii.member(jsii_name="putScriptManagement")
    def put_script_management(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement(
            enabled=enabled,
            locked=locked,
            serviceworker=serviceworker,
            template_uuid=template_uuid,
            timestamp=timestamp,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putScriptManagement", [value]))

    @jsii.member(jsii_name="putSegmentedContentProtection")
    def put_segmented_content_protection(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection(
            acl=acl,
            dash_media_encryption=dash_media_encryption,
            data_payload=data_payload,
            enabled=enabled,
            enable_token_in_uri=enable_token_in_uri,
            field_carry_over=field_carry_over,
            header_for_salt=header_for_salt,
            hls_master_manifest_files=hls_master_manifest_files,
            hls_media_encryption=hls_media_encryption,
            ip=ip,
            key=key,
            locked=locked,
            media_encryption_title=media_encryption_title,
            revoked_list_id=revoked_list_id,
            salt=salt,
            session_id=session_id,
            template_uuid=template_uuid,
            token_authentication_title=token_authentication_title,
            token_auth_hls_title=token_auth_hls_title,
            token_revocation_enabled=token_revocation_enabled,
            token_revocation_title=token_revocation_title,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedContentProtection", [value]))

    @jsii.member(jsii_name="putSegmentedMediaOptimization")
    def put_segmented_media_optimization(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization(
            behavior=behavior,
            dvr_type=dvr_type,
            dvr_window=dvr_window,
            enable_ull_streaming=enable_ull_streaming,
            end_time=end_time,
            live_type=live_type,
            locked=locked,
            show_advanced=show_advanced,
            start_time=start_time,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaOptimization", [value]))

    @jsii.member(jsii_name="putSegmentedMediaStreamingPrefetch")
    def put_segmented_media_streaming_prefetch(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putSegmentedMediaStreamingPrefetch", [value]))

    @jsii.member(jsii_name="putSetVariable")
    def put_set_variable(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[jsii.Number] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[jsii.Number] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[jsii.Number] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[jsii.Number] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable(
            algorithm=algorithm,
            case_sensitive=case_sensitive,
            certificate_field_name=certificate_field_name,
            cookie_name=cookie_name,
            device_profile=device_profile,
            encryption_key=encryption_key,
            encryption_mode=encryption_mode,
            end_index=end_index,
            except_chars=except_chars,
            extract_location=extract_location,
            force_chars=force_chars,
            format_string=format_string,
            generator=generator,
            global_substitution=global_substitution,
            header_name=header_name,
            hmac_algorithm=hmac_algorithm,
            hmac_key=hmac_key,
            initialization_vector=initialization_vector,
            ipv4_prefix=ipv4_prefix,
            ipv6_prefix=ipv6_prefix,
            ip_version=ip_version,
            location_id=location_id,
            locked=locked,
            max=max,
            max_random_number=max_random_number,
            min=min,
            min_random_number=min_random_number,
            nonce=nonce,
            number_of_bytes=number_of_bytes,
            operand_one=operand_one,
            param_name=param_name,
            path_component_offset=path_component_offset,
            prepend_bytes=prepend_bytes,
            query_parameter_name=query_parameter_name,
            regex=regex,
            replacement=replacement,
            response_header_name=response_header_name,
            separator=separator,
            set_cookie_name=set_cookie_name,
            start_index=start_index,
            sub_string=sub_string,
            template_uuid=template_uuid,
            transform=transform,
            uuid=uuid,
            value_source=value_source,
            variable_name=variable_name,
            variable_value=variable_value,
        )

        return typing.cast(None, jsii.invoke(self, "putSetVariable", [value]))

    @jsii.member(jsii_name="putSimulateErrorCode")
    def put_simulate_error_code(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode(
            error_type=error_type,
            locked=locked,
            template_uuid=template_uuid,
            timeout=timeout,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSimulateErrorCode", [value]))

    @jsii.member(jsii_name="putSiteShield")
    def put_site_shield(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield(
            locked=locked,
            nossmap=nossmap,
            ssmap=ssmap,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSiteShield", [value]))

    @jsii.member(jsii_name="putStandardTlsMigration")
    def put_standard_tls_migration(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration(
            allow_https_downgrade=allow_https_downgrade,
            allow_https_upgrade=allow_https_upgrade,
            cache_sharing_duration=cache_sharing_duration,
            cache_sharing_start_time=cache_sharing_start_time,
            enabled=enabled,
            is_certificate_sni_only=is_certificate_sni_only,
            is_tiered_distribution_used=is_tiered_distribution_used,
            locked=locked,
            migration_duration=migration_duration,
            migration_from=migration_from,
            migration_start_time=migration_start_time,
            td_location=td_location,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigration", [value]))

    @jsii.member(jsii_name="putStandardTlsMigrationOverride")
    def put_standard_tls_migration_override(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride(
            info=info, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putStandardTlsMigrationOverride", [value]))

    @jsii.member(jsii_name="putStrictHeaderParsing")
    def put_strict_header_parsing(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing(
            locked=locked,
            strict_mode=strict_mode,
            template_uuid=template_uuid,
            uuid=uuid,
            valid_mode=valid_mode,
        )

        return typing.cast(None, jsii.invoke(self, "putStrictHeaderParsing", [value]))

    @jsii.member(jsii_name="putSubCustomer")
    def put_sub_customer(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer(
            access_control=access_control,
            cache_key=cache_key,
            caching=caching,
            content_compressor=content_compressor,
            dynamic_web_content=dynamic_web_content,
            enabled=enabled,
            geo_location=geo_location,
            ip=ip,
            large_file_delivery=large_file_delivery,
            live_video_delivery=live_video_delivery,
            locked=locked,
            modify_path=modify_path,
            on_demand_video_delivery=on_demand_video_delivery,
            origin=origin,
            partner_domain_suffix=partner_domain_suffix,
            referrer=referrer,
            refresh_content=refresh_content,
            site_failover=site_failover,
            template_uuid=template_uuid,
            token_authorization=token_authorization,
            uuid=uuid,
            web_application_firewall=web_application_firewall,
        )

        return typing.cast(None, jsii.invoke(self, "putSubCustomer", [value]))

    @jsii.member(jsii_name="putSureRoute")
    def put_sure_route(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute(
            allow_fcm_parent_override=allow_fcm_parent_override,
            custom_map=custom_map,
            custom_stat_key=custom_stat_key,
            enable_custom_key=enable_custom_key,
            enabled=enabled,
            force_ssl_forward=force_ssl_forward,
            locked=locked,
            race_stat_ttl=race_stat_ttl,
            sr_download_link_title=sr_download_link_title,
            template_uuid=template_uuid,
            test_object_url=test_object_url,
            to_host=to_host,
            to_host_status=to_host_status,
            type=type,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putSureRoute", [value]))

    @jsii.member(jsii_name="putTcpOptimization")
    def put_tcp_optimization(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization(
            display=display, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putTcpOptimization", [value]))

    @jsii.member(jsii_name="putTeaLeaf")
    def put_tea_leaf(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf(
            enabled=enabled,
            ibm_customer_id=ibm_customer_id,
            limit_to_dynamic=limit_to_dynamic,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTeaLeaf", [value]))

    @jsii.member(jsii_name="putTieredDistribution")
    def put_tiered_distribution(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution(
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistribution", [value]))

    @jsii.member(jsii_name="putTieredDistributionAdvanced")
    def put_tiered_distribution_advanced(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced(
            allowall=allowall,
            enabled=enabled,
            locked=locked,
            method=method,
            policy=policy,
            template_uuid=template_uuid,
            tiered_distribution_map=tiered_distribution_map,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionAdvanced", [value]))

    @jsii.member(jsii_name="putTieredDistributionCustomization")
    def put_tiered_distribution_customization(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization(
            cloudwrapper_map_migration_title=cloudwrapper_map_migration_title,
            custom_map_enabled=custom_map_enabled,
            custom_map_name=custom_map_name,
            hash_algorithm=hash_algorithm,
            location=location,
            locked=locked,
            map_migration_enabled=map_migration_enabled,
            migration_end_date=migration_end_date,
            migration_start_date=migration_start_date,
            migration_within_cw_maps_enabled=migration_within_cw_maps_enabled,
            serial_end=serial_end,
            serial_start=serial_start,
            template_uuid=template_uuid,
            tier1_title=tier1_title,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTieredDistributionCustomization", [value]))

    @jsii.member(jsii_name="putTimeout")
    def put_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putTimeout", [value_]))

    @jsii.member(jsii_name="putUidConfiguration")
    def put_uid_configuration(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration(
            enabled=enabled,
            extract_location=extract_location,
            header_name=header_name,
            legal_text=legal_text,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_name=variable_name,
        )

        return typing.cast(None, jsii.invoke(self, "putUidConfiguration", [value]))

    @jsii.member(jsii_name="putValidateEntityTag")
    def put_validate_entity_tag(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putValidateEntityTag", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebToken")
    def put_verify_json_web_token(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken(
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_location=extract_location,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebToken", [value]))

    @jsii.member(jsii_name="putVerifyJsonWebTokenForDcp")
    def put_verify_json_web_token_for_dcp(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp(
            authorizations=authorizations,
            client_id=client_id,
            custom_header=custom_header,
            enable_es256=enable_es256,
            enable_rs256=enable_rs256,
            extract_authorizations=extract_authorizations,
            extract_client_id=extract_client_id,
            extract_location=extract_location,
            extract_user_name=extract_user_name,
            header_name=header_name,
            jwt=jwt,
            locked=locked,
            primary_location=primary_location,
            query_parameter_name=query_parameter_name,
            template_uuid=template_uuid,
            user_name=user_name,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyJsonWebTokenForDcp", [value]))

    @jsii.member(jsii_name="putVerifyTokenAuthorization")
    def put_verify_token_authorization(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization(
            algorithm=algorithm,
            escape_hmac_inputs=escape_hmac_inputs,
            failure_response=failure_response,
            ignore_query_string=ignore_query_string,
            key=key,
            location=location,
            location_id=location_id,
            locked=locked,
            salt=salt,
            template_uuid=template_uuid,
            transition_key=transition_key,
            use_advanced=use_advanced,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVerifyTokenAuthorization", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoom")
    def put_virtual_waiting_room(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoom", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomWithEdgeWorkers")
    def put_virtual_waiting_room_with_edge_workers(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomWithEdgeWorkers", [value]))

    @jsii.member(jsii_name="putVisitorPrioritization")
    def put_visitor_prioritization(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization(
            allowed_user_cookie_advanced=allowed_user_cookie_advanced,
            allowed_user_cookie_automatic_salt=allowed_user_cookie_automatic_salt,
            allowed_user_cookie_domain=allowed_user_cookie_domain,
            allowed_user_cookie_domain_type=allowed_user_cookie_domain_type,
            allowed_user_cookie_duration=allowed_user_cookie_duration,
            allowed_user_cookie_enabled=allowed_user_cookie_enabled,
            allowed_user_cookie_http_only=allowed_user_cookie_http_only,
            allowed_user_cookie_label=allowed_user_cookie_label,
            allowed_user_cookie_management_title=allowed_user_cookie_management_title,
            allowed_user_cookie_refresh=allowed_user_cookie_refresh,
            allowed_user_cookie_salt=allowed_user_cookie_salt,
            cloudlet_policy=cloudlet_policy,
            enabled=enabled,
            locked=locked,
            template_uuid=template_uuid,
            user_identification_by_cookie=user_identification_by_cookie,
            user_identification_by_headers=user_identification_by_headers,
            user_identification_by_ip=user_identification_by_ip,
            user_identification_by_params=user_identification_by_params,
            user_identification_key_cookie=user_identification_key_cookie,
            user_identification_key_headers=user_identification_key_headers,
            user_identification_key_params=user_identification_key_params,
            user_identification_title=user_identification_title,
            uuid=uuid,
            waiting_room_cache_ttl=waiting_room_cache_ttl,
            waiting_room_cookie_advanced=waiting_room_cookie_advanced,
            waiting_room_cookie_automatic_salt=waiting_room_cookie_automatic_salt,
            waiting_room_cookie_domain=waiting_room_cookie_domain,
            waiting_room_cookie_domain_type=waiting_room_cookie_domain_type,
            waiting_room_cookie_duration=waiting_room_cookie_duration,
            waiting_room_cookie_enabled=waiting_room_cookie_enabled,
            waiting_room_cookie_http_only=waiting_room_cookie_http_only,
            waiting_room_cookie_label=waiting_room_cookie_label,
            waiting_room_cookie_management_title=waiting_room_cookie_management_title,
            waiting_room_cookie_salt=waiting_room_cookie_salt,
            waiting_room_cookie_share_label=waiting_room_cookie_share_label,
            waiting_room_cp_code=waiting_room_cp_code,
            waiting_room_directory=waiting_room_directory,
            waiting_room_management_title=waiting_room_management_title,
            waiting_room_net_storage=waiting_room_net_storage,
            waiting_room_status_code=waiting_room_status_code,
            waiting_room_use_cp_code=waiting_room_use_cp_code,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritization", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifo")
    def put_visitor_prioritization_fifo(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo(
            access_title=access_title,
            cloudlet_shared_policy=cloudlet_shared_policy,
            custom_cookie_domain=custom_cookie_domain,
            domain_config=domain_config,
            locked=locked,
            session_auto_prolong=session_auto_prolong,
            session_duration=session_duration,
            template_uuid=template_uuid,
            uuid=uuid,
            waiting_room_assets_paths=waiting_room_assets_paths,
            waiting_room_path=waiting_room_path,
            waiting_room_title=waiting_room_title,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifo", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationFifoStandalone")
    def put_visitor_prioritization_fifo_standalone(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone(
            locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationFifoStandalone", [value]))

    @jsii.member(jsii_name="putWatermarking")
    def put_watermarking(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking(
            ab_variant_location=ab_variant_location,
            decryption_password1=decryption_password1,
            decryption_password2=decryption_password2,
            decryption_password_id1=decryption_password_id1,
            decryption_password_id2=decryption_password_id2,
            enable=enable,
            locked=locked,
            miscellaneous_settings_title=miscellaneous_settings_title,
            pattern_decryption_enable=pattern_decryption_enable,
            pattern_encryption_title=pattern_encryption_title,
            signature_verification_enable=signature_verification_enable,
            template_uuid=template_uuid,
            token_signing_title=token_signing_title,
            use_original_as_a=use_original_as_a,
            uuid=uuid,
            verification_key_id1=verification_key_id1,
            verification_key_id2=verification_key_id2,
            verification_public_key1=verification_public_key1,
            verification_public_key2=verification_public_key2,
        )

        return typing.cast(None, jsii.invoke(self, "putWatermarking", [value]))

    @jsii.member(jsii_name="putWebApplicationFirewall")
    def put_web_application_firewall(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall(
            firewall_configuration=firewall_configuration,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putWebApplicationFirewall", [value]))

    @jsii.member(jsii_name="putWebdav")
    def put_webdav(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebdav", [value]))

    @jsii.member(jsii_name="putWebSockets")
    def put_web_sockets(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets(
            enabled=enabled, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putWebSockets", [value]))

    @jsii.member(jsii_name="resetAdaptiveAcceleration")
    def reset_adaptive_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveAcceleration", []))

    @jsii.member(jsii_name="resetAdaptiveImageCompression")
    def reset_adaptive_image_compression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdaptiveImageCompression", []))

    @jsii.member(jsii_name="resetAdScalerCircuitBreaker")
    def reset_ad_scaler_circuit_breaker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdScalerCircuitBreaker", []))

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetAggregatedReporting")
    def reset_aggregated_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAggregatedReporting", []))

    @jsii.member(jsii_name="resetAkamaizer")
    def reset_akamaizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizer", []))

    @jsii.member(jsii_name="resetAkamaizerTag")
    def reset_akamaizer_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAkamaizerTag", []))

    @jsii.member(jsii_name="resetAllHttpInCacheHierarchy")
    def reset_all_http_in_cache_hierarchy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllHttpInCacheHierarchy", []))

    @jsii.member(jsii_name="resetAllowCloudletsOrigins")
    def reset_allow_cloudlets_origins(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowCloudletsOrigins", []))

    @jsii.member(jsii_name="resetAllowDelete")
    def reset_allow_delete(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowDelete", []))

    @jsii.member(jsii_name="resetAllowHttpsCacheKeySharing")
    def reset_allow_https_cache_key_sharing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsCacheKeySharing", []))

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowOptions")
    def reset_allow_options(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOptions", []))

    @jsii.member(jsii_name="resetAllowPatch")
    def reset_allow_patch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPatch", []))

    @jsii.member(jsii_name="resetAllowPost")
    def reset_allow_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPost", []))

    @jsii.member(jsii_name="resetAllowPut")
    def reset_allow_put(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowPut", []))

    @jsii.member(jsii_name="resetAllowTransferEncoding")
    def reset_allow_transfer_encoding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowTransferEncoding", []))

    @jsii.member(jsii_name="resetAltSvcHeader")
    def reset_alt_svc_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAltSvcHeader", []))

    @jsii.member(jsii_name="resetApiPrioritization")
    def reset_api_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApiPrioritization", []))

    @jsii.member(jsii_name="resetApplicationLoadBalancer")
    def reset_application_load_balancer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationLoadBalancer", []))

    @jsii.member(jsii_name="resetAudienceSegmentation")
    def reset_audience_segmentation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSegmentation", []))

    @jsii.member(jsii_name="resetAutoDomainValidation")
    def reset_auto_domain_validation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAutoDomainValidation", []))

    @jsii.member(jsii_name="resetBaseDirectory")
    def reset_base_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBaseDirectory", []))

    @jsii.member(jsii_name="resetBossBeaconing")
    def reset_boss_beaconing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBossBeaconing", []))

    @jsii.member(jsii_name="resetBreadcrumbs")
    def reset_breadcrumbs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreadcrumbs", []))

    @jsii.member(jsii_name="resetBreakConnection")
    def reset_break_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBreakConnection", []))

    @jsii.member(jsii_name="resetBrotli")
    def reset_brotli(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrotli", []))

    @jsii.member(jsii_name="resetCacheError")
    def reset_cache_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheError", []))

    @jsii.member(jsii_name="resetCacheId")
    def reset_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheId", []))

    @jsii.member(jsii_name="resetCacheKeyIgnoreCase")
    def reset_cache_key_ignore_case(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyIgnoreCase", []))

    @jsii.member(jsii_name="resetCacheKeyQueryParams")
    def reset_cache_key_query_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyQueryParams", []))

    @jsii.member(jsii_name="resetCacheKeyRewrite")
    def reset_cache_key_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKeyRewrite", []))

    @jsii.member(jsii_name="resetCachePost")
    def reset_cache_post(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCachePost", []))

    @jsii.member(jsii_name="resetCacheRedirect")
    def reset_cache_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheRedirect", []))

    @jsii.member(jsii_name="resetCacheTag")
    def reset_cache_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTag", []))

    @jsii.member(jsii_name="resetCacheTagVisible")
    def reset_cache_tag_visible(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheTagVisible", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetCentralAuthorization")
    def reset_central_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCentralAuthorization", []))

    @jsii.member(jsii_name="resetChaseRedirects")
    def reset_chase_redirects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChaseRedirects", []))

    @jsii.member(jsii_name="resetClientCertificateAuth")
    def reset_client_certificate_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificateAuth", []))

    @jsii.member(jsii_name="resetClientCharacteristics")
    def reset_client_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCharacteristics", []))

    @jsii.member(jsii_name="resetCloudInterconnects")
    def reset_cloud_interconnects(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudInterconnects", []))

    @jsii.member(jsii_name="resetCloudWrapper")
    def reset_cloud_wrapper(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapper", []))

    @jsii.member(jsii_name="resetCloudWrapperAdvanced")
    def reset_cloud_wrapper_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudWrapperAdvanced", []))

    @jsii.member(jsii_name="resetCommonMediaClientData")
    def reset_common_media_client_data(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCommonMediaClientData", []))

    @jsii.member(jsii_name="resetConditionalOrigin")
    def reset_conditional_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConditionalOrigin", []))

    @jsii.member(jsii_name="resetConstructResponse")
    def reset_construct_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConstructResponse", []))

    @jsii.member(jsii_name="resetContentCharacteristics")
    def reset_content_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristics", []))

    @jsii.member(jsii_name="resetContentCharacteristicsAmd")
    def reset_content_characteristics_amd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsAmd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsDd")
    def reset_content_characteristics_dd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsDd", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLargeFile")
    def reset_content_characteristics_wsd_large_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLargeFile", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdLive")
    def reset_content_characteristics_wsd_live(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdLive", []))

    @jsii.member(jsii_name="resetContentCharacteristicsWsdVod")
    def reset_content_characteristics_wsd_vod(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCharacteristicsWsdVod", []))

    @jsii.member(jsii_name="resetContentPrePosition")
    def reset_content_pre_position(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentPrePosition", []))

    @jsii.member(jsii_name="resetContentTargetingProtection")
    def reset_content_targeting_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentTargetingProtection", []))

    @jsii.member(jsii_name="resetCorsSupport")
    def reset_cors_support(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCorsSupport", []))

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetCustomBehavior")
    def reset_custom_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomBehavior", []))

    @jsii.member(jsii_name="resetDatastream")
    def reset_datastream(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDatastream", []))

    @jsii.member(jsii_name="resetDcp")
    def reset_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcp", []))

    @jsii.member(jsii_name="resetDcpAuthHmacTransformation")
    def reset_dcp_auth_hmac_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthHmacTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthRegexTransformation")
    def reset_dcp_auth_regex_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthRegexTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthSubstringTransformation")
    def reset_dcp_auth_substring_transformation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthSubstringTransformation", []))

    @jsii.member(jsii_name="resetDcpAuthVariableExtractor")
    def reset_dcp_auth_variable_extractor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpAuthVariableExtractor", []))

    @jsii.member(jsii_name="resetDcpDefaultAuthzGroups")
    def reset_dcp_default_authz_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDefaultAuthzGroups", []))

    @jsii.member(jsii_name="resetDcpDevRelations")
    def reset_dcp_dev_relations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpDevRelations", []))

    @jsii.member(jsii_name="resetDcpRealTimeAuth")
    def reset_dcp_real_time_auth(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDcpRealTimeAuth", []))

    @jsii.member(jsii_name="resetDeliveryReceipt")
    def reset_delivery_receipt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryReceipt", []))

    @jsii.member(jsii_name="resetDenyAccess")
    def reset_deny_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyAccess", []))

    @jsii.member(jsii_name="resetDenyDirectFailoverAccess")
    def reset_deny_direct_failover_access(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDenyDirectFailoverAccess", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicCacheId")
    def reset_device_characteristic_cache_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicCacheId", []))

    @jsii.member(jsii_name="resetDeviceCharacteristicHeader")
    def reset_device_characteristic_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristicHeader", []))

    @jsii.member(jsii_name="resetDnsAsyncRefresh")
    def reset_dns_async_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsAsyncRefresh", []))

    @jsii.member(jsii_name="resetDnsPrefresh")
    def reset_dns_prefresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDnsPrefresh", []))

    @jsii.member(jsii_name="resetDowngradeProtocol")
    def reset_downgrade_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDowngradeProtocol", []))

    @jsii.member(jsii_name="resetDownloadCompleteMarker")
    def reset_download_complete_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadCompleteMarker", []))

    @jsii.member(jsii_name="resetDownloadNotification")
    def reset_download_notification(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadNotification", []))

    @jsii.member(jsii_name="resetDownstreamCache")
    def reset_downstream_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownstreamCache", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimization")
    def reset_dynamic_throughtput_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimization", []))

    @jsii.member(jsii_name="resetDynamicThroughtputOptimizationOverride")
    def reset_dynamic_throughtput_optimization_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicThroughtputOptimizationOverride", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEcmsBulkUpload")
    def reset_ecms_bulk_upload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsBulkUpload", []))

    @jsii.member(jsii_name="resetEcmsDatabase")
    def reset_ecms_database(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDatabase", []))

    @jsii.member(jsii_name="resetEcmsDataset")
    def reset_ecms_dataset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsDataset", []))

    @jsii.member(jsii_name="resetEcmsObjectKey")
    def reset_ecms_object_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmsObjectKey", []))

    @jsii.member(jsii_name="resetEdgeConnect")
    def reset_edge_connect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeConnect", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingAdvanced")
    def reset_edge_load_balancing_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingAdvanced", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingDataCenter")
    def reset_edge_load_balancing_data_center(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingDataCenter", []))

    @jsii.member(jsii_name="resetEdgeLoadBalancingOrigin")
    def reset_edge_load_balancing_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeLoadBalancingOrigin", []))

    @jsii.member(jsii_name="resetEdgeOriginAuthorization")
    def reset_edge_origin_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeOriginAuthorization", []))

    @jsii.member(jsii_name="resetEdgeRedirector")
    def reset_edge_redirector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeRedirector", []))

    @jsii.member(jsii_name="resetEdgeScape")
    def reset_edge_scape(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeScape", []))

    @jsii.member(jsii_name="resetEdgeSideIncludes")
    def reset_edge_side_includes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeSideIncludes", []))

    @jsii.member(jsii_name="resetEdgeWorker")
    def reset_edge_worker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorker", []))

    @jsii.member(jsii_name="resetEnforceMtlsSettings")
    def reset_enforce_mtls_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnforceMtlsSettings", []))

    @jsii.member(jsii_name="resetEnhancedAkamaiProtocol")
    def reset_enhanced_akamai_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedAkamaiProtocol", []))

    @jsii.member(jsii_name="resetEnhancedProxyDetection")
    def reset_enhanced_proxy_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnhancedProxyDetection", []))

    @jsii.member(jsii_name="resetEpdForwardHeaderEnrichment")
    def reset_epd_forward_header_enrichment(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEpdForwardHeaderEnrichment", []))

    @jsii.member(jsii_name="resetFailAction")
    def reset_fail_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailAction", []))

    @jsii.member(jsii_name="resetFailoverBotManagerFeatureCompatibility")
    def reset_failover_bot_manager_feature_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverBotManagerFeatureCompatibility", []))

    @jsii.member(jsii_name="resetFastInvalidate")
    def reset_fast_invalidate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFastInvalidate", []))

    @jsii.member(jsii_name="resetFips")
    def reset_fips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFips", []))

    @jsii.member(jsii_name="resetFirstPartyMarketing")
    def reset_first_party_marketing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketing", []))

    @jsii.member(jsii_name="resetFirstPartyMarketingPlus")
    def reset_first_party_marketing_plus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirstPartyMarketingPlus", []))

    @jsii.member(jsii_name="resetForwardRewrite")
    def reset_forward_rewrite(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForwardRewrite", []))

    @jsii.member(jsii_name="resetG2Oheader")
    def reset_g2_oheader(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2Oheader", []))

    @jsii.member(jsii_name="resetGlobalRequestNumber")
    def reset_global_request_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalRequestNumber", []))

    @jsii.member(jsii_name="resetGraphqlCaching")
    def reset_graphql_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGraphqlCaching", []))

    @jsii.member(jsii_name="resetGzipResponse")
    def reset_gzip_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGzipResponse", []))

    @jsii.member(jsii_name="resetHdDataAdvanced")
    def reset_hd_data_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHdDataAdvanced", []))

    @jsii.member(jsii_name="resetHealthDetection")
    def reset_health_detection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHealthDetection", []))

    @jsii.member(jsii_name="resetHsafEipBinding")
    def reset_hsaf_eip_binding(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHsafEipBinding", []))

    @jsii.member(jsii_name="resetHttp2")
    def reset_http2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp2", []))

    @jsii.member(jsii_name="resetHttp3")
    def reset_http3(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttp3", []))

    @jsii.member(jsii_name="resetHttpStrictTransportSecurity")
    def reset_http_strict_transport_security(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpStrictTransportSecurity", []))

    @jsii.member(jsii_name="resetHttpToHttpsUpgrade")
    def reset_http_to_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpToHttpsUpgrade", []))

    @jsii.member(jsii_name="resetImageAndVideoManager")
    def reset_image_and_video_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageAndVideoManager", []))

    @jsii.member(jsii_name="resetImageManager")
    def reset_image_manager(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManager", []))

    @jsii.member(jsii_name="resetImageManagerVideo")
    def reset_image_manager_video(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImageManagerVideo", []))

    @jsii.member(jsii_name="resetImOverride")
    def reset_im_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetImOverride", []))

    @jsii.member(jsii_name="resetInclude")
    def reset_include(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInclude", []))

    @jsii.member(jsii_name="resetInstant")
    def reset_instant(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstant", []))

    @jsii.member(jsii_name="resetInstantConfig")
    def reset_instant_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInstantConfig", []))

    @jsii.member(jsii_name="resetLargeFileOptimization")
    def reset_large_file_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimization", []))

    @jsii.member(jsii_name="resetLargeFileOptimizationAdvanced")
    def reset_large_file_optimization_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileOptimizationAdvanced", []))

    @jsii.member(jsii_name="resetLimitBitRate")
    def reset_limit_bit_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitBitRate", []))

    @jsii.member(jsii_name="resetLogCustom")
    def reset_log_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustom", []))

    @jsii.member(jsii_name="resetManifestPersonalization")
    def reset_manifest_personalization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestPersonalization", []))

    @jsii.member(jsii_name="resetManifestRerouting")
    def reset_manifest_rerouting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManifestRerouting", []))

    @jsii.member(jsii_name="resetManualServerPush")
    def reset_manual_server_push(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetManualServerPush", []))

    @jsii.member(jsii_name="resetMediaAcceleration")
    def reset_media_acceleration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAcceleration", []))

    @jsii.member(jsii_name="resetMediaAccelerationQuicOptout")
    def reset_media_acceleration_quic_optout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaAccelerationQuicOptout", []))

    @jsii.member(jsii_name="resetMediaClient")
    def reset_media_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaClient", []))

    @jsii.member(jsii_name="resetMediaFileRetrievalOptimization")
    def reset_media_file_retrieval_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaFileRetrievalOptimization", []))

    @jsii.member(jsii_name="resetMediaOriginFailover")
    def reset_media_origin_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaOriginFailover", []))

    @jsii.member(jsii_name="resetMetadataCaching")
    def reset_metadata_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataCaching", []))

    @jsii.member(jsii_name="resetMobileSdkPerformance")
    def reset_mobile_sdk_performance(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileSdkPerformance", []))

    @jsii.member(jsii_name="resetModifyIncomingRequestHeader")
    def reset_modify_incoming_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyIncomingResponseHeader")
    def reset_modify_incoming_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyIncomingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingRequestHeader")
    def reset_modify_outgoing_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingRequestHeader", []))

    @jsii.member(jsii_name="resetModifyOutgoingResponseHeader")
    def reset_modify_outgoing_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyOutgoingResponseHeader", []))

    @jsii.member(jsii_name="resetModifyViaHeader")
    def reset_modify_via_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyViaHeader", []))

    @jsii.member(jsii_name="resetMPulse")
    def reset_m_pulse(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMPulse", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetOriginCharacteristics")
    def reset_origin_characteristics(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristics", []))

    @jsii.member(jsii_name="resetOriginCharacteristicsWsd")
    def reset_origin_characteristics_wsd(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginCharacteristicsWsd", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryMethod")
    def reset_origin_failure_recovery_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryMethod", []))

    @jsii.member(jsii_name="resetOriginFailureRecoveryPolicy")
    def reset_origin_failure_recovery_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginFailureRecoveryPolicy", []))

    @jsii.member(jsii_name="resetOriginIpAcl")
    def reset_origin_ip_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginIpAcl", []))

    @jsii.member(jsii_name="resetPermissionsPolicy")
    def reset_permissions_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPermissionsPolicy", []))

    @jsii.member(jsii_name="resetPersistentClientConnection")
    def reset_persistent_client_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentClientConnection", []))

    @jsii.member(jsii_name="resetPersistentConnection")
    def reset_persistent_connection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersistentConnection", []))

    @jsii.member(jsii_name="resetPersonallyIdentifiableInformation")
    def reset_personally_identifiable_information(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPersonallyIdentifiableInformation", []))

    @jsii.member(jsii_name="resetPhasedRelease")
    def reset_phased_release(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPhasedRelease", []))

    @jsii.member(jsii_name="resetPreconnect")
    def reset_preconnect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnect", []))

    @jsii.member(jsii_name="resetPredictiveContentDelivery")
    def reset_predictive_content_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictiveContentDelivery", []))

    @jsii.member(jsii_name="resetPredictivePrefetching")
    def reset_predictive_prefetching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPredictivePrefetching", []))

    @jsii.member(jsii_name="resetPrefetch")
    def reset_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetch", []))

    @jsii.member(jsii_name="resetPrefetchable")
    def reset_prefetchable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefetchable", []))

    @jsii.member(jsii_name="resetPrefreshCache")
    def reset_prefresh_cache(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshCache", []))

    @jsii.member(jsii_name="resetQuality")
    def reset_quality(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuality", []))

    @jsii.member(jsii_name="resetQuicBeta")
    def reset_quic_beta(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicBeta", []))

    @jsii.member(jsii_name="resetRandomSeek")
    def reset_random_seek(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandomSeek", []))

    @jsii.member(jsii_name="resetRapid")
    def reset_rapid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRapid", []))

    @jsii.member(jsii_name="resetReadTimeout")
    def reset_read_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReadTimeout", []))

    @jsii.member(jsii_name="resetRealTimeReporting")
    def reset_real_time_reporting(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealTimeReporting", []))

    @jsii.member(jsii_name="resetRealUserMonitoring")
    def reset_real_user_monitoring(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRealUserMonitoring", []))

    @jsii.member(jsii_name="resetRedirect")
    def reset_redirect(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirect", []))

    @jsii.member(jsii_name="resetRedirectplus")
    def reset_redirectplus(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRedirectplus", []))

    @jsii.member(jsii_name="resetRefererChecking")
    def reset_referer_checking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefererChecking", []))

    @jsii.member(jsii_name="resetRemoveQueryParameter")
    def reset_remove_query_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveQueryParameter", []))

    @jsii.member(jsii_name="resetRemoveVary")
    def reset_remove_vary(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRemoveVary", []))

    @jsii.member(jsii_name="resetReport")
    def reset_report(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReport", []))

    @jsii.member(jsii_name="resetRequestClientHints")
    def reset_request_client_hints(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestClientHints", []))

    @jsii.member(jsii_name="resetRequestControl")
    def reset_request_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestControl", []))

    @jsii.member(jsii_name="resetRequestTypeMarker")
    def reset_request_type_marker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestTypeMarker", []))

    @jsii.member(jsii_name="resetResourceOptimizer")
    def reset_resource_optimizer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizer", []))

    @jsii.member(jsii_name="resetResourceOptimizerExtendedCompatibility")
    def reset_resource_optimizer_extended_compatibility(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResourceOptimizerExtendedCompatibility", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetResponseCookie")
    def reset_response_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCookie", []))

    @jsii.member(jsii_name="resetRestrictObjectCaching")
    def reset_restrict_object_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRestrictObjectCaching", []))

    @jsii.member(jsii_name="resetReturnCacheStatus")
    def reset_return_cache_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReturnCacheStatus", []))

    @jsii.member(jsii_name="resetRewriteUrl")
    def reset_rewrite_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRewriteUrl", []))

    @jsii.member(jsii_name="resetRumCustom")
    def reset_rum_custom(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumCustom", []))

    @jsii.member(jsii_name="resetSaasDefinitions")
    def reset_saas_definitions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSaasDefinitions", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudClient")
    def reset_sales_force_commerce_cloud_client(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudClient", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProvider")
    def reset_sales_force_commerce_cloud_provider(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProvider", []))

    @jsii.member(jsii_name="resetSalesForceCommerceCloudProviderHostHeader")
    def reset_sales_force_commerce_cloud_provider_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalesForceCommerceCloudProviderHostHeader", []))

    @jsii.member(jsii_name="resetSavePostDcaProcessing")
    def reset_save_post_dca_processing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSavePostDcaProcessing", []))

    @jsii.member(jsii_name="resetScheduleInvalidation")
    def reset_schedule_invalidation(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScheduleInvalidation", []))

    @jsii.member(jsii_name="resetScriptManagement")
    def reset_script_management(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetScriptManagement", []))

    @jsii.member(jsii_name="resetSegmentedContentProtection")
    def reset_segmented_content_protection(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedContentProtection", []))

    @jsii.member(jsii_name="resetSegmentedMediaOptimization")
    def reset_segmented_media_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaOptimization", []))

    @jsii.member(jsii_name="resetSegmentedMediaStreamingPrefetch")
    def reset_segmented_media_streaming_prefetch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentedMediaStreamingPrefetch", []))

    @jsii.member(jsii_name="resetSetVariable")
    def reset_set_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetVariable", []))

    @jsii.member(jsii_name="resetSimulateErrorCode")
    def reset_simulate_error_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSimulateErrorCode", []))

    @jsii.member(jsii_name="resetSiteShield")
    def reset_site_shield(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteShield", []))

    @jsii.member(jsii_name="resetStandardTlsMigration")
    def reset_standard_tls_migration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigration", []))

    @jsii.member(jsii_name="resetStandardTlsMigrationOverride")
    def reset_standard_tls_migration_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStandardTlsMigrationOverride", []))

    @jsii.member(jsii_name="resetStrictHeaderParsing")
    def reset_strict_header_parsing(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictHeaderParsing", []))

    @jsii.member(jsii_name="resetSubCustomer")
    def reset_sub_customer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubCustomer", []))

    @jsii.member(jsii_name="resetSureRoute")
    def reset_sure_route(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSureRoute", []))

    @jsii.member(jsii_name="resetTcpOptimization")
    def reset_tcp_optimization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTcpOptimization", []))

    @jsii.member(jsii_name="resetTeaLeaf")
    def reset_tea_leaf(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTeaLeaf", []))

    @jsii.member(jsii_name="resetTieredDistribution")
    def reset_tiered_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistribution", []))

    @jsii.member(jsii_name="resetTieredDistributionAdvanced")
    def reset_tiered_distribution_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionAdvanced", []))

    @jsii.member(jsii_name="resetTieredDistributionCustomization")
    def reset_tiered_distribution_customization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionCustomization", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUidConfiguration")
    def reset_uid_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUidConfiguration", []))

    @jsii.member(jsii_name="resetValidateEntityTag")
    def reset_validate_entity_tag(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidateEntityTag", []))

    @jsii.member(jsii_name="resetVerifyJsonWebToken")
    def reset_verify_json_web_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebToken", []))

    @jsii.member(jsii_name="resetVerifyJsonWebTokenForDcp")
    def reset_verify_json_web_token_for_dcp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyJsonWebTokenForDcp", []))

    @jsii.member(jsii_name="resetVerifyTokenAuthorization")
    def reset_verify_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerifyTokenAuthorization", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoom")
    def reset_virtual_waiting_room(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoom", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomWithEdgeWorkers")
    def reset_virtual_waiting_room_with_edge_workers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomWithEdgeWorkers", []))

    @jsii.member(jsii_name="resetVisitorPrioritization")
    def reset_visitor_prioritization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritization", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifo")
    def reset_visitor_prioritization_fifo(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifo", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationFifoStandalone")
    def reset_visitor_prioritization_fifo_standalone(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationFifoStandalone", []))

    @jsii.member(jsii_name="resetWatermarking")
    def reset_watermarking(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWatermarking", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @jsii.member(jsii_name="resetWebdav")
    def reset_webdav(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebdav", []))

    @jsii.member(jsii_name="resetWebSockets")
    def reset_web_sockets(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebSockets", []))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAcceleration")
    def adaptive_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAccelerationOutputReference, jsii.get(self, "adaptiveAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompression")
    def adaptive_image_compression(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompressionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompressionOutputReference, jsii.get(self, "adaptiveImageCompression"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreaker")
    def ad_scaler_circuit_breaker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreakerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreakerOutputReference, jsii.get(self, "adScalerCircuitBreaker"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvancedOutputReference, jsii.get(self, "advanced"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReporting")
    def aggregated_reporting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReportingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReportingOutputReference, jsii.get(self, "aggregatedReporting"))

    @builtins.property
    @jsii.member(jsii_name="akamaizer")
    def akamaizer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerOutputReference, jsii.get(self, "akamaizer"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTag")
    def akamaizer_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTagOutputReference, jsii.get(self, "akamaizerTag"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchy")
    def all_http_in_cache_hierarchy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchyOutputReference, jsii.get(self, "allHttpInCacheHierarchy"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOrigins")
    def allow_cloudlets_origins(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOriginsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOriginsOutputReference, jsii.get(self, "allowCloudletsOrigins"))

    @builtins.property
    @jsii.member(jsii_name="allowDelete")
    def allow_delete(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDeleteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDeleteOutputReference, jsii.get(self, "allowDelete"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharing")
    def allow_https_cache_key_sharing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharingOutputReference, jsii.get(self, "allowHttpsCacheKeySharing"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngradeOutputReference, jsii.get(self, "allowHttpsDowngrade"))

    @builtins.property
    @jsii.member(jsii_name="allowOptions")
    def allow_options(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptionsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptionsOutputReference, jsii.get(self, "allowOptions"))

    @builtins.property
    @jsii.member(jsii_name="allowPatch")
    def allow_patch(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatchOutputReference, jsii.get(self, "allowPatch"))

    @builtins.property
    @jsii.member(jsii_name="allowPost")
    def allow_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPostOutputReference, jsii.get(self, "allowPost"))

    @builtins.property
    @jsii.member(jsii_name="allowPut")
    def allow_put(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPutOutputReference, jsii.get(self, "allowPut"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncoding")
    def allow_transfer_encoding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncodingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncodingOutputReference, jsii.get(self, "allowTransferEncoding"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeader")
    def alt_svc_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeaderOutputReference, jsii.get(self, "altSvcHeader"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritization")
    def api_prioritization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationOutputReference, jsii.get(self, "apiPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancer")
    def application_load_balancer(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerOutputReference, jsii.get(self, "applicationLoadBalancer"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentation")
    def audience_segmentation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationOutputReference, jsii.get(self, "audienceSegmentation"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidation")
    def auto_domain_validation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidationOutputReference, jsii.get(self, "autoDomainValidation"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectory")
    def base_directory(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectoryOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectoryOutputReference, jsii.get(self, "baseDirectory"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconing")
    def boss_beaconing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconingOutputReference, jsii.get(self, "bossBeaconing"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbs")
    def breadcrumbs(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbsOutputReference, jsii.get(self, "breadcrumbs"))

    @builtins.property
    @jsii.member(jsii_name="breakConnection")
    def break_connection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnectionOutputReference, jsii.get(self, "breakConnection"))

    @builtins.property
    @jsii.member(jsii_name="brotli")
    def brotli(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotliOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotliOutputReference, jsii.get(self, "brotli"))

    @builtins.property
    @jsii.member(jsii_name="cacheError")
    def cache_error(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheErrorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheErrorOutputReference, jsii.get(self, "cacheError"))

    @builtins.property
    @jsii.member(jsii_name="cacheId")
    def cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference, jsii.get(self, "cacheId"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCase")
    def cache_key_ignore_case(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference, jsii.get(self, "cacheKeyIgnoreCase"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParams")
    def cache_key_query_params(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference, jsii.get(self, "cacheKeyQueryParams"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewrite")
    def cache_key_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference, jsii.get(self, "cacheKeyRewrite"))

    @builtins.property
    @jsii.member(jsii_name="cachePost")
    def cache_post(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference, jsii.get(self, "cachePost"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirect")
    def cache_redirect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference, jsii.get(self, "cacheRedirect"))

    @builtins.property
    @jsii.member(jsii_name="cacheTag")
    def cache_tag(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference, jsii.get(self, "cacheTag"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisible")
    def cache_tag_visible(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference, jsii.get(self, "cacheTagVisible"))

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference, jsii.get(self, "caching"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorization")
    def central_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference, jsii.get(self, "centralAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirects")
    def chase_redirects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference, jsii.get(self, "chaseRedirects"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAuth")
    def client_certificate_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference, jsii.get(self, "clientCertificateAuth"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristics")
    def client_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference, jsii.get(self, "clientCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnects")
    def cloud_interconnects(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference, jsii.get(self, "cloudInterconnects"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapper")
    def cloud_wrapper(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference, jsii.get(self, "cloudWrapper"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvanced")
    def cloud_wrapper_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference, jsii.get(self, "cloudWrapperAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientData")
    def common_media_client_data(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference, jsii.get(self, "commonMediaClientData"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOrigin")
    def conditional_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference, jsii.get(self, "conditionalOrigin"))

    @builtins.property
    @jsii.member(jsii_name="constructResponse")
    def construct_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference, jsii.get(self, "constructResponse"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristics")
    def content_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference, jsii.get(self, "contentCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmd")
    def content_characteristics_amd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference, jsii.get(self, "contentCharacteristicsAmd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDd")
    def content_characteristics_dd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference, jsii.get(self, "contentCharacteristicsDd"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFile")
    def content_characteristics_wsd_large_file(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference, jsii.get(self, "contentCharacteristicsWsdLargeFile"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLive")
    def content_characteristics_wsd_live(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference, jsii.get(self, "contentCharacteristicsWsdLive"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVod")
    def content_characteristics_wsd_vod(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference, jsii.get(self, "contentCharacteristicsWsdVod"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePosition")
    def content_pre_position(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference, jsii.get(self, "contentPrePosition"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtection")
    def content_targeting_protection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference, jsii.get(self, "contentTargetingProtection"))

    @builtins.property
    @jsii.member(jsii_name="corsSupport")
    def cors_support(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference, jsii.get(self, "corsSupport"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference, jsii.get(self, "cpCode"))

    @builtins.property
    @jsii.member(jsii_name="customBehavior")
    def custom_behavior(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference, jsii.get(self, "customBehavior"))

    @builtins.property
    @jsii.member(jsii_name="datastream")
    def datastream(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference, jsii.get(self, "datastream"))

    @builtins.property
    @jsii.member(jsii_name="dcp")
    def dcp(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference, jsii.get(self, "dcp"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformation")
    def dcp_auth_hmac_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference, jsii.get(self, "dcpAuthHmacTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformation")
    def dcp_auth_regex_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference, jsii.get(self, "dcpAuthRegexTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformation")
    def dcp_auth_substring_transformation(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference, jsii.get(self, "dcpAuthSubstringTransformation"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractor")
    def dcp_auth_variable_extractor(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference, jsii.get(self, "dcpAuthVariableExtractor"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroups")
    def dcp_default_authz_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference, jsii.get(self, "dcpDefaultAuthzGroups"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelations")
    def dcp_dev_relations(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference, jsii.get(self, "dcpDevRelations"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuth")
    def dcp_real_time_auth(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference, jsii.get(self, "dcpRealTimeAuth"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceipt")
    def delivery_receipt(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference, jsii.get(self, "deliveryReceipt"))

    @builtins.property
    @jsii.member(jsii_name="denyAccess")
    def deny_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference, jsii.get(self, "denyAccess"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccess")
    def deny_direct_failover_access(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference, jsii.get(self, "denyDirectFailoverAccess"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheId")
    def device_characteristic_cache_id(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference, jsii.get(self, "deviceCharacteristicCacheId"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeader")
    def device_characteristic_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference, jsii.get(self, "deviceCharacteristicHeader"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefresh")
    def dns_async_refresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference, jsii.get(self, "dnsAsyncRefresh"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefresh")
    def dns_prefresh(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference, jsii.get(self, "dnsPrefresh"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocol")
    def downgrade_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference, jsii.get(self, "downgradeProtocol"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarker")
    def download_complete_marker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference, jsii.get(self, "downloadCompleteMarker"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotification")
    def download_notification(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference, jsii.get(self, "downloadNotification"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCache")
    def downstream_cache(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference, jsii.get(self, "downstreamCache"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimization")
    def dynamic_throughtput_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference, jsii.get(self, "dynamicThroughtputOptimization"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverride")
    def dynamic_throughtput_optimization_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference, jsii.get(self, "dynamicThroughtputOptimizationOverride"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference, jsii.get(self, "dynamicWebContent"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUpload")
    def ecms_bulk_upload(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference, jsii.get(self, "ecmsBulkUpload"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabase")
    def ecms_database(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference, jsii.get(self, "ecmsDatabase"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDataset")
    def ecms_dataset(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference, jsii.get(self, "ecmsDataset"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKey")
    def ecms_object_key(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference, jsii.get(self, "ecmsObjectKey"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnect")
    def edge_connect(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference, jsii.get(self, "edgeConnect"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvanced")
    def edge_load_balancing_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference, jsii.get(self, "edgeLoadBalancingAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenter")
    def edge_load_balancing_data_center(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference, jsii.get(self, "edgeLoadBalancingDataCenter"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOrigin")
    def edge_load_balancing_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference, jsii.get(self, "edgeLoadBalancingOrigin"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorization")
    def edge_origin_authorization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference, jsii.get(self, "edgeOriginAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirector")
    def edge_redirector(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference, jsii.get(self, "edgeRedirector"))

    @builtins.property
    @jsii.member(jsii_name="edgeScape")
    def edge_scape(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference, jsii.get(self, "edgeScape"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludes")
    def edge_side_includes(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference, jsii.get(self, "edgeSideIncludes"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorker")
    def edge_worker(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference, jsii.get(self, "edgeWorker"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsSettings")
    def enforce_mtls_settings(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference, jsii.get(self, "enforceMtlsSettings"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocol")
    def enhanced_akamai_protocol(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference, jsii.get(self, "enhancedAkamaiProtocol"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetection")
    def enhanced_proxy_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference, jsii.get(self, "enhancedProxyDetection"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichment")
    def epd_forward_header_enrichment(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference, jsii.get(self, "epdForwardHeaderEnrichment"))

    @builtins.property
    @jsii.member(jsii_name="failAction")
    def fail_action(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference, jsii.get(self, "failAction"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibility")
    def failover_bot_manager_feature_compatibility(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference, jsii.get(self, "failoverBotManagerFeatureCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidate")
    def fast_invalidate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference, jsii.get(self, "fastInvalidate"))

    @builtins.property
    @jsii.member(jsii_name="fips")
    def fips(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference, jsii.get(self, "fips"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketing")
    def first_party_marketing(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference, jsii.get(self, "firstPartyMarketing"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlus")
    def first_party_marketing_plus(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference, jsii.get(self, "firstPartyMarketingPlus"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewrite")
    def forward_rewrite(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference, jsii.get(self, "forwardRewrite"))

    @builtins.property
    @jsii.member(jsii_name="g2Oheader")
    def g2_oheader(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference, jsii.get(self, "g2Oheader"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumber")
    def global_request_number(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference, jsii.get(self, "globalRequestNumber"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCaching")
    def graphql_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference, jsii.get(self, "graphqlCaching"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponse")
    def gzip_response(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference, jsii.get(self, "gzipResponse"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvanced")
    def hd_data_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference, jsii.get(self, "hdDataAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="healthDetection")
    def health_detection(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference, jsii.get(self, "healthDetection"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBinding")
    def hsaf_eip_binding(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference, jsii.get(self, "hsafEipBinding"))

    @builtins.property
    @jsii.member(jsii_name="http2")
    def http2(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference, jsii.get(self, "http2"))

    @builtins.property
    @jsii.member(jsii_name="http3")
    def http3(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference, jsii.get(self, "http3"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurity")
    def http_strict_transport_security(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference, jsii.get(self, "httpStrictTransportSecurity"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgrade")
    def http_to_https_upgrade(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference, jsii.get(self, "httpToHttpsUpgrade"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManager")
    def image_and_video_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference, jsii.get(self, "imageAndVideoManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManager")
    def image_manager(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference, jsii.get(self, "imageManager"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideo")
    def image_manager_video(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference, jsii.get(self, "imageManagerVideo"))

    @builtins.property
    @jsii.member(jsii_name="imOverride")
    def im_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference, jsii.get(self, "imOverride"))

    @builtins.property
    @jsii.member(jsii_name="include")
    def include(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference, jsii.get(self, "include"))

    @builtins.property
    @jsii.member(jsii_name="instant")
    def instant(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference, jsii.get(self, "instant"))

    @builtins.property
    @jsii.member(jsii_name="instantConfig")
    def instant_config(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference, jsii.get(self, "instantConfig"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimization")
    def large_file_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference, jsii.get(self, "largeFileOptimization"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvanced")
    def large_file_optimization_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference, jsii.get(self, "largeFileOptimizationAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRate")
    def limit_bit_rate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference, jsii.get(self, "limitBitRate"))

    @builtins.property
    @jsii.member(jsii_name="logCustom")
    def log_custom(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference, jsii.get(self, "logCustom"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalization")
    def manifest_personalization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference, jsii.get(self, "manifestPersonalization"))

    @builtins.property
    @jsii.member(jsii_name="manifestRerouting")
    def manifest_rerouting(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference, jsii.get(self, "manifestRerouting"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPush")
    def manual_server_push(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference, jsii.get(self, "manualServerPush"))

    @builtins.property
    @jsii.member(jsii_name="mediaAcceleration")
    def media_acceleration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference, jsii.get(self, "mediaAcceleration"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptout")
    def media_acceleration_quic_optout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference, jsii.get(self, "mediaAccelerationQuicOptout"))

    @builtins.property
    @jsii.member(jsii_name="mediaClient")
    def media_client(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference, jsii.get(self, "mediaClient"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimization")
    def media_file_retrieval_optimization(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference, jsii.get(self, "mediaFileRetrievalOptimization"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailover")
    def media_origin_failover(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference, jsii.get(self, "mediaOriginFailover"))

    @builtins.property
    @jsii.member(jsii_name="metadataCaching")
    def metadata_caching(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCachingOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCachingOutputReference, jsii.get(self, "metadataCaching"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformance")
    def mobile_sdk_performance(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformanceOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformanceOutputReference, jsii.get(self, "mobileSdkPerformance"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeader")
    def modify_incoming_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeaderOutputReference, jsii.get(self, "modifyIncomingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeader")
    def modify_incoming_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeaderOutputReference, jsii.get(self, "modifyIncomingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeader")
    def modify_outgoing_request_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeaderOutputReference, jsii.get(self, "modifyOutgoingRequestHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeader")
    def modify_outgoing_response_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeaderOutputReference, jsii.get(self, "modifyOutgoingResponseHeader"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeader")
    def modify_via_header(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeaderOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeaderOutputReference, jsii.get(self, "modifyViaHeader"))

    @builtins.property
    @jsii.member(jsii_name="mPulse")
    def m_pulse(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference, jsii.get(self, "mPulse"))

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginOutputReference, jsii.get(self, "origin"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristics")
    def origin_characteristics(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsOutputReference, jsii.get(self, "originCharacteristics"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsd")
    def origin_characteristics_wsd(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsdOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsdOutputReference, jsii.get(self, "originCharacteristicsWsd"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethod")
    def origin_failure_recovery_method(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethodOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethodOutputReference, jsii.get(self, "originFailureRecoveryMethod"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicy")
    def origin_failure_recovery_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicyOutputReference, jsii.get(self, "originFailureRecoveryPolicy"))

    @builtins.property
    @jsii.member(jsii_name="originIpAcl")
    def origin_ip_acl(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAclOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAclOutputReference, jsii.get(self, "originIpAcl"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicy")
    def permissions_policy(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicyOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicyOutputReference", jsii.get(self, "permissionsPolicy"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnection")
    def persistent_client_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnectionOutputReference", jsii.get(self, "persistentClientConnection"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnection")
    def persistent_connection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnectionOutputReference", jsii.get(self, "persistentConnection"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformation")
    def personally_identifiable_information(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformationOutputReference", jsii.get(self, "personallyIdentifiableInformation"))

    @builtins.property
    @jsii.member(jsii_name="phasedRelease")
    def phased_release(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseOutputReference", jsii.get(self, "phasedRelease"))

    @builtins.property
    @jsii.member(jsii_name="preconnect")
    def preconnect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnectOutputReference", jsii.get(self, "preconnect"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDelivery")
    def predictive_content_delivery(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDeliveryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDeliveryOutputReference", jsii.get(self, "predictiveContentDelivery"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetching")
    def predictive_prefetching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetchingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetchingOutputReference", jsii.get(self, "predictivePrefetching"))

    @builtins.property
    @jsii.member(jsii_name="prefetch")
    def prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchOutputReference", jsii.get(self, "prefetch"))

    @builtins.property
    @jsii.member(jsii_name="prefetchable")
    def prefetchable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchableOutputReference", jsii.get(self, "prefetchable"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCache")
    def prefresh_cache(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCacheOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCacheOutputReference", jsii.get(self, "prefreshCache"))

    @builtins.property
    @jsii.member(jsii_name="quality")
    def quality(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQualityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQualityOutputReference", jsii.get(self, "quality"))

    @builtins.property
    @jsii.member(jsii_name="quicBeta")
    def quic_beta(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBetaOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBetaOutputReference", jsii.get(self, "quicBeta"))

    @builtins.property
    @jsii.member(jsii_name="randomSeek")
    def random_seek(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeekOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeekOutputReference", jsii.get(self, "randomSeek"))

    @builtins.property
    @jsii.member(jsii_name="rapid")
    def rapid(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapidOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapidOutputReference", jsii.get(self, "rapid"))

    @builtins.property
    @jsii.member(jsii_name="readTimeout")
    def read_timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeoutOutputReference", jsii.get(self, "readTimeout"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReporting")
    def real_time_reporting(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReportingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReportingOutputReference", jsii.get(self, "realTimeReporting"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoring")
    def real_user_monitoring(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoringOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoringOutputReference", jsii.get(self, "realUserMonitoring"))

    @builtins.property
    @jsii.member(jsii_name="redirect")
    def redirect(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectOutputReference", jsii.get(self, "redirect"))

    @builtins.property
    @jsii.member(jsii_name="redirectplus")
    def redirectplus(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplusOutputReference", jsii.get(self, "redirectplus"))

    @builtins.property
    @jsii.member(jsii_name="refererChecking")
    def referer_checking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererCheckingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererCheckingOutputReference", jsii.get(self, "refererChecking"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameter")
    def remove_query_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameterOutputReference", jsii.get(self, "removeQueryParameter"))

    @builtins.property
    @jsii.member(jsii_name="removeVary")
    def remove_vary(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVaryOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVaryOutputReference", jsii.get(self, "removeVary"))

    @builtins.property
    @jsii.member(jsii_name="report")
    def report(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReportOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReportOutputReference", jsii.get(self, "report"))

    @builtins.property
    @jsii.member(jsii_name="requestClientHints")
    def request_client_hints(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHintsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHintsOutputReference", jsii.get(self, "requestClientHints"))

    @builtins.property
    @jsii.member(jsii_name="requestControl")
    def request_control(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlOutputReference", jsii.get(self, "requestControl"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarker")
    def request_type_marker(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarkerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarkerOutputReference", jsii.get(self, "requestTypeMarker"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizer")
    def resource_optimizer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerOutputReference", jsii.get(self, "resourceOptimizer"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibility")
    def resource_optimizer_extended_compatibility(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibilityOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibilityOutputReference", jsii.get(self, "resourceOptimizerExtendedCompatibility"))

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCodeOutputReference", jsii.get(self, "responseCode"))

    @builtins.property
    @jsii.member(jsii_name="responseCookie")
    def response_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookieOutputReference", jsii.get(self, "responseCookie"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCaching")
    def restrict_object_caching(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCachingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCachingOutputReference", jsii.get(self, "restrictObjectCaching"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatus")
    def return_cache_status(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatusOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatusOutputReference", jsii.get(self, "returnCacheStatus"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrl")
    def rewrite_url(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrlOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrlOutputReference", jsii.get(self, "rewriteUrl"))

    @builtins.property
    @jsii.member(jsii_name="rumCustom")
    def rum_custom(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustomOutputReference", jsii.get(self, "rumCustom"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitions")
    def saas_definitions(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitionsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitionsOutputReference", jsii.get(self, "saasDefinitions"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClient")
    def sales_force_commerce_cloud_client(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClientOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClientOutputReference", jsii.get(self, "salesForceCommerceCloudClient"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProvider")
    def sales_force_commerce_cloud_provider(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderOutputReference", jsii.get(self, "salesForceCommerceCloudProvider"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeader")
    def sales_force_commerce_cloud_provider_host_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference", jsii.get(self, "salesForceCommerceCloudProviderHostHeader"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessing")
    def save_post_dca_processing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessingOutputReference", jsii.get(self, "savePostDcaProcessing"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidation")
    def schedule_invalidation(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidationOutputReference", jsii.get(self, "scheduleInvalidation"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagement")
    def script_management(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagementOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagementOutputReference", jsii.get(self, "scriptManagement"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtection")
    def segmented_content_protection(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtectionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtectionOutputReference", jsii.get(self, "segmentedContentProtection"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimization")
    def segmented_media_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimizationOutputReference", jsii.get(self, "segmentedMediaOptimization"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetch")
    def segmented_media_streaming_prefetch(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetchOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetchOutputReference", jsii.get(self, "segmentedMediaStreamingPrefetch"))

    @builtins.property
    @jsii.member(jsii_name="setVariable")
    def set_variable(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariableOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariableOutputReference", jsii.get(self, "setVariable"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCode")
    def simulate_error_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCodeOutputReference", jsii.get(self, "simulateErrorCode"))

    @builtins.property
    @jsii.member(jsii_name="siteShield")
    def site_shield(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldOutputReference", jsii.get(self, "siteShield"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigration")
    def standard_tls_migration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOutputReference", jsii.get(self, "standardTlsMigration"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverride")
    def standard_tls_migration_override(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverrideOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverrideOutputReference", jsii.get(self, "standardTlsMigrationOverride"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsing")
    def strict_header_parsing(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsingOutputReference", jsii.get(self, "strictHeaderParsing"))

    @builtins.property
    @jsii.member(jsii_name="subCustomer")
    def sub_customer(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomerOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomerOutputReference", jsii.get(self, "subCustomer"))

    @builtins.property
    @jsii.member(jsii_name="sureRoute")
    def sure_route(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRouteOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRouteOutputReference", jsii.get(self, "sureRoute"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimization")
    def tcp_optimization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimizationOutputReference", jsii.get(self, "tcpOptimization"))

    @builtins.property
    @jsii.member(jsii_name="teaLeaf")
    def tea_leaf(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeafOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeafOutputReference", jsii.get(self, "teaLeaf"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistribution")
    def tiered_distribution(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionOutputReference", jsii.get(self, "tieredDistribution"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvanced")
    def tiered_distribution_advanced(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvancedOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvancedOutputReference", jsii.get(self, "tieredDistributionAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomization")
    def tiered_distribution_customization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomizationOutputReference", jsii.get(self, "tieredDistributionCustomization"))

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeoutOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeoutOutputReference", jsii.get(self, "timeout"))

    @builtins.property
    @jsii.member(jsii_name="uidConfiguration")
    def uid_configuration(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfigurationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfigurationOutputReference", jsii.get(self, "uidConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTag")
    def validate_entity_tag(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTagOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTagOutputReference", jsii.get(self, "validateEntityTag"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebToken")
    def verify_json_web_token(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenOutputReference", jsii.get(self, "verifyJsonWebToken"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcp")
    def verify_json_web_token_for_dcp(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcpOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcpOutputReference", jsii.get(self, "verifyJsonWebTokenForDcp"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorization")
    def verify_token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorizationOutputReference", jsii.get(self, "verifyTokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoom")
    def virtual_waiting_room(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomOutputReference", jsii.get(self, "virtualWaitingRoom"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkers")
    def virtual_waiting_room_with_edge_workers(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference", jsii.get(self, "virtualWaitingRoomWithEdgeWorkers"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritization")
    def visitor_prioritization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationOutputReference", jsii.get(self, "visitorPrioritization"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifo")
    def visitor_prioritization_fifo(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoOutputReference", jsii.get(self, "visitorPrioritizationFifo"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandalone")
    def visitor_prioritization_fifo_standalone(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandaloneOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandaloneOutputReference", jsii.get(self, "visitorPrioritizationFifoStandalone"))

    @builtins.property
    @jsii.member(jsii_name="watermarking")
    def watermarking(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarkingOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarkingOutputReference", jsii.get(self, "watermarking"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallOutputReference", jsii.get(self, "webApplicationFirewall"))

    @builtins.property
    @jsii.member(jsii_name="webdav")
    def webdav(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdavOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdavOutputReference", jsii.get(self, "webdav"))

    @builtins.property
    @jsii.member(jsii_name="webSockets")
    def web_sockets(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSocketsOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSocketsOutputReference", jsii.get(self, "webSockets"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveAccelerationInput")
    def adaptive_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration], jsii.get(self, "adaptiveAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="adaptiveImageCompressionInput")
    def adaptive_image_compression_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression], jsii.get(self, "adaptiveImageCompressionInput"))

    @builtins.property
    @jsii.member(jsii_name="adScalerCircuitBreakerInput")
    def ad_scaler_circuit_breaker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker], jsii.get(self, "adScalerCircuitBreakerInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="aggregatedReportingInput")
    def aggregated_reporting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting], jsii.get(self, "aggregatedReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerInput")
    def akamaizer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer], jsii.get(self, "akamaizerInput"))

    @builtins.property
    @jsii.member(jsii_name="akamaizerTagInput")
    def akamaizer_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag], jsii.get(self, "akamaizerTagInput"))

    @builtins.property
    @jsii.member(jsii_name="allHttpInCacheHierarchyInput")
    def all_http_in_cache_hierarchy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy], jsii.get(self, "allHttpInCacheHierarchyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowCloudletsOriginsInput")
    def allow_cloudlets_origins_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins], jsii.get(self, "allowCloudletsOriginsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowDeleteInput")
    def allow_delete_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete], jsii.get(self, "allowDeleteInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsCacheKeySharingInput")
    def allow_https_cache_key_sharing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing], jsii.get(self, "allowHttpsCacheKeySharingInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOptionsInput")
    def allow_options_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions], jsii.get(self, "allowOptionsInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPatchInput")
    def allow_patch_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch], jsii.get(self, "allowPatchInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPostInput")
    def allow_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost], jsii.get(self, "allowPostInput"))

    @builtins.property
    @jsii.member(jsii_name="allowPutInput")
    def allow_put_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut], jsii.get(self, "allowPutInput"))

    @builtins.property
    @jsii.member(jsii_name="allowTransferEncodingInput")
    def allow_transfer_encoding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding], jsii.get(self, "allowTransferEncodingInput"))

    @builtins.property
    @jsii.member(jsii_name="altSvcHeaderInput")
    def alt_svc_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader], jsii.get(self, "altSvcHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="apiPrioritizationInput")
    def api_prioritization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization], jsii.get(self, "apiPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationLoadBalancerInput")
    def application_load_balancer_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer], jsii.get(self, "applicationLoadBalancerInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSegmentationInput")
    def audience_segmentation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation], jsii.get(self, "audienceSegmentationInput"))

    @builtins.property
    @jsii.member(jsii_name="autoDomainValidationInput")
    def auto_domain_validation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation], jsii.get(self, "autoDomainValidationInput"))

    @builtins.property
    @jsii.member(jsii_name="baseDirectoryInput")
    def base_directory_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory], jsii.get(self, "baseDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="bossBeaconingInput")
    def boss_beaconing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing], jsii.get(self, "bossBeaconingInput"))

    @builtins.property
    @jsii.member(jsii_name="breadcrumbsInput")
    def breadcrumbs_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs], jsii.get(self, "breadcrumbsInput"))

    @builtins.property
    @jsii.member(jsii_name="breakConnectionInput")
    def break_connection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection], jsii.get(self, "breakConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="brotliInput")
    def brotli_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli], jsii.get(self, "brotliInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheErrorInput")
    def cache_error_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError], jsii.get(self, "cacheErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheIdInput")
    def cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId], jsii.get(self, "cacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyIgnoreCaseInput")
    def cache_key_ignore_case_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase], jsii.get(self, "cacheKeyIgnoreCaseInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyQueryParamsInput")
    def cache_key_query_params_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams], jsii.get(self, "cacheKeyQueryParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyRewriteInput")
    def cache_key_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite], jsii.get(self, "cacheKeyRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="cachePostInput")
    def cache_post_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost], jsii.get(self, "cachePostInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheRedirectInput")
    def cache_redirect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect], jsii.get(self, "cacheRedirectInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagInput")
    def cache_tag_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag], jsii.get(self, "cacheTagInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheTagVisibleInput")
    def cache_tag_visible_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible], jsii.get(self, "cacheTagVisibleInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="centralAuthorizationInput")
    def central_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization], jsii.get(self, "centralAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="chaseRedirectsInput")
    def chase_redirects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects], jsii.get(self, "chaseRedirectsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateAuthInput")
    def client_certificate_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth], jsii.get(self, "clientCertificateAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCharacteristicsInput")
    def client_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics], jsii.get(self, "clientCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudInterconnectsInput")
    def cloud_interconnects_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects], jsii.get(self, "cloudInterconnectsInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperAdvancedInput")
    def cloud_wrapper_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced], jsii.get(self, "cloudWrapperAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudWrapperInput")
    def cloud_wrapper_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper], jsii.get(self, "cloudWrapperInput"))

    @builtins.property
    @jsii.member(jsii_name="commonMediaClientDataInput")
    def common_media_client_data_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData], jsii.get(self, "commonMediaClientDataInput"))

    @builtins.property
    @jsii.member(jsii_name="conditionalOriginInput")
    def conditional_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin], jsii.get(self, "conditionalOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="constructResponseInput")
    def construct_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse], jsii.get(self, "constructResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsAmdInput")
    def content_characteristics_amd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd], jsii.get(self, "contentCharacteristicsAmdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsDdInput")
    def content_characteristics_dd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd], jsii.get(self, "contentCharacteristicsDdInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsInput")
    def content_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics], jsii.get(self, "contentCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLargeFileInput")
    def content_characteristics_wsd_large_file_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile], jsii.get(self, "contentCharacteristicsWsdLargeFileInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdLiveInput")
    def content_characteristics_wsd_live_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive], jsii.get(self, "contentCharacteristicsWsdLiveInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCharacteristicsWsdVodInput")
    def content_characteristics_wsd_vod_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod], jsii.get(self, "contentCharacteristicsWsdVodInput"))

    @builtins.property
    @jsii.member(jsii_name="contentPrePositionInput")
    def content_pre_position_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition], jsii.get(self, "contentPrePositionInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTargetingProtectionInput")
    def content_targeting_protection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection], jsii.get(self, "contentTargetingProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="corsSupportInput")
    def cors_support_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport], jsii.get(self, "corsSupportInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="customBehaviorInput")
    def custom_behavior_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior], jsii.get(self, "customBehaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="datastreamInput")
    def datastream_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream], jsii.get(self, "datastreamInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthHmacTransformationInput")
    def dcp_auth_hmac_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation], jsii.get(self, "dcpAuthHmacTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthRegexTransformationInput")
    def dcp_auth_regex_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation], jsii.get(self, "dcpAuthRegexTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthSubstringTransformationInput")
    def dcp_auth_substring_transformation_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation], jsii.get(self, "dcpAuthSubstringTransformationInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpAuthVariableExtractorInput")
    def dcp_auth_variable_extractor_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor], jsii.get(self, "dcpAuthVariableExtractorInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDefaultAuthzGroupsInput")
    def dcp_default_authz_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups], jsii.get(self, "dcpDefaultAuthzGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpDevRelationsInput")
    def dcp_dev_relations_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations], jsii.get(self, "dcpDevRelationsInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpInput")
    def dcp_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp], jsii.get(self, "dcpInput"))

    @builtins.property
    @jsii.member(jsii_name="dcpRealTimeAuthInput")
    def dcp_real_time_auth_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth], jsii.get(self, "dcpRealTimeAuthInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryReceiptInput")
    def delivery_receipt_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt], jsii.get(self, "deliveryReceiptInput"))

    @builtins.property
    @jsii.member(jsii_name="denyAccessInput")
    def deny_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess], jsii.get(self, "denyAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="denyDirectFailoverAccessInput")
    def deny_direct_failover_access_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess], jsii.get(self, "denyDirectFailoverAccessInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicCacheIdInput")
    def device_characteristic_cache_id_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId], jsii.get(self, "deviceCharacteristicCacheIdInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicHeaderInput")
    def device_characteristic_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader], jsii.get(self, "deviceCharacteristicHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsAsyncRefreshInput")
    def dns_async_refresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh], jsii.get(self, "dnsAsyncRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="dnsPrefreshInput")
    def dns_prefresh_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh], jsii.get(self, "dnsPrefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="downgradeProtocolInput")
    def downgrade_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol], jsii.get(self, "downgradeProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadCompleteMarkerInput")
    def download_complete_marker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker], jsii.get(self, "downloadCompleteMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadNotificationInput")
    def download_notification_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification], jsii.get(self, "downloadNotificationInput"))

    @builtins.property
    @jsii.member(jsii_name="downstreamCacheInput")
    def downstream_cache_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache], jsii.get(self, "downstreamCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationInput")
    def dynamic_throughtput_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization], jsii.get(self, "dynamicThroughtputOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicThroughtputOptimizationOverrideInput")
    def dynamic_throughtput_optimization_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride], jsii.get(self, "dynamicThroughtputOptimizationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsBulkUploadInput")
    def ecms_bulk_upload_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload], jsii.get(self, "ecmsBulkUploadInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatabaseInput")
    def ecms_database_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase], jsii.get(self, "ecmsDatabaseInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsDatasetInput")
    def ecms_dataset_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset], jsii.get(self, "ecmsDatasetInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmsObjectKeyInput")
    def ecms_object_key_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey], jsii.get(self, "ecmsObjectKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeConnectInput")
    def edge_connect_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect], jsii.get(self, "edgeConnectInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingAdvancedInput")
    def edge_load_balancing_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced], jsii.get(self, "edgeLoadBalancingAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingDataCenterInput")
    def edge_load_balancing_data_center_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter], jsii.get(self, "edgeLoadBalancingDataCenterInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeLoadBalancingOriginInput")
    def edge_load_balancing_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin], jsii.get(self, "edgeLoadBalancingOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeOriginAuthorizationInput")
    def edge_origin_authorization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization], jsii.get(self, "edgeOriginAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeRedirectorInput")
    def edge_redirector_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector], jsii.get(self, "edgeRedirectorInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeScapeInput")
    def edge_scape_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape], jsii.get(self, "edgeScapeInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeSideIncludesInput")
    def edge_side_includes_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes], jsii.get(self, "edgeSideIncludesInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkerInput")
    def edge_worker_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker], jsii.get(self, "edgeWorkerInput"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsSettingsInput")
    def enforce_mtls_settings_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings], jsii.get(self, "enforceMtlsSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedAkamaiProtocolInput")
    def enhanced_akamai_protocol_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol], jsii.get(self, "enhancedAkamaiProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="enhancedProxyDetectionInput")
    def enhanced_proxy_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection], jsii.get(self, "enhancedProxyDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="epdForwardHeaderEnrichmentInput")
    def epd_forward_header_enrichment_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment], jsii.get(self, "epdForwardHeaderEnrichmentInput"))

    @builtins.property
    @jsii.member(jsii_name="failActionInput")
    def fail_action_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction], jsii.get(self, "failActionInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverBotManagerFeatureCompatibilityInput")
    def failover_bot_manager_feature_compatibility_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility], jsii.get(self, "failoverBotManagerFeatureCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="fastInvalidateInput")
    def fast_invalidate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate], jsii.get(self, "fastInvalidateInput"))

    @builtins.property
    @jsii.member(jsii_name="fipsInput")
    def fips_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips], jsii.get(self, "fipsInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingInput")
    def first_party_marketing_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing], jsii.get(self, "firstPartyMarketingInput"))

    @builtins.property
    @jsii.member(jsii_name="firstPartyMarketingPlusInput")
    def first_party_marketing_plus_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus], jsii.get(self, "firstPartyMarketingPlusInput"))

    @builtins.property
    @jsii.member(jsii_name="forwardRewriteInput")
    def forward_rewrite_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite], jsii.get(self, "forwardRewriteInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OheaderInput")
    def g2_oheader_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader], jsii.get(self, "g2OheaderInput"))

    @builtins.property
    @jsii.member(jsii_name="globalRequestNumberInput")
    def global_request_number_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber], jsii.get(self, "globalRequestNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="graphqlCachingInput")
    def graphql_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching], jsii.get(self, "graphqlCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="gzipResponseInput")
    def gzip_response_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse], jsii.get(self, "gzipResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="hdDataAdvancedInput")
    def hd_data_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced], jsii.get(self, "hdDataAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="healthDetectionInput")
    def health_detection_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection], jsii.get(self, "healthDetectionInput"))

    @builtins.property
    @jsii.member(jsii_name="hsafEipBindingInput")
    def hsaf_eip_binding_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding], jsii.get(self, "hsafEipBindingInput"))

    @builtins.property
    @jsii.member(jsii_name="http2Input")
    def http2_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2], jsii.get(self, "http2Input"))

    @builtins.property
    @jsii.member(jsii_name="http3Input")
    def http3_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3], jsii.get(self, "http3Input"))

    @builtins.property
    @jsii.member(jsii_name="httpStrictTransportSecurityInput")
    def http_strict_transport_security_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity], jsii.get(self, "httpStrictTransportSecurityInput"))

    @builtins.property
    @jsii.member(jsii_name="httpToHttpsUpgradeInput")
    def http_to_https_upgrade_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade], jsii.get(self, "httpToHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="imageAndVideoManagerInput")
    def image_and_video_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager], jsii.get(self, "imageAndVideoManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerInput")
    def image_manager_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager], jsii.get(self, "imageManagerInput"))

    @builtins.property
    @jsii.member(jsii_name="imageManagerVideoInput")
    def image_manager_video_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo], jsii.get(self, "imageManagerVideoInput"))

    @builtins.property
    @jsii.member(jsii_name="imOverrideInput")
    def im_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride], jsii.get(self, "imOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="includeInput")
    def include_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude], jsii.get(self, "includeInput"))

    @builtins.property
    @jsii.member(jsii_name="instantConfigInput")
    def instant_config_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig], jsii.get(self, "instantConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="instantInput")
    def instant_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant], jsii.get(self, "instantInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationAdvancedInput")
    def large_file_optimization_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced], jsii.get(self, "largeFileOptimizationAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileOptimizationInput")
    def large_file_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization], jsii.get(self, "largeFileOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="limitBitRateInput")
    def limit_bit_rate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate], jsii.get(self, "limitBitRateInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomInput")
    def log_custom_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom], jsii.get(self, "logCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestPersonalizationInput")
    def manifest_personalization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization], jsii.get(self, "manifestPersonalizationInput"))

    @builtins.property
    @jsii.member(jsii_name="manifestReroutingInput")
    def manifest_rerouting_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting], jsii.get(self, "manifestReroutingInput"))

    @builtins.property
    @jsii.member(jsii_name="manualServerPushInput")
    def manual_server_push_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush], jsii.get(self, "manualServerPushInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationInput")
    def media_acceleration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration], jsii.get(self, "mediaAccelerationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaAccelerationQuicOptoutInput")
    def media_acceleration_quic_optout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout], jsii.get(self, "mediaAccelerationQuicOptoutInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaClientInput")
    def media_client_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient], jsii.get(self, "mediaClientInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaFileRetrievalOptimizationInput")
    def media_file_retrieval_optimization_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization], jsii.get(self, "mediaFileRetrievalOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaOriginFailoverInput")
    def media_origin_failover_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover], jsii.get(self, "mediaOriginFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataCachingInput")
    def metadata_caching_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching], jsii.get(self, "metadataCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileSdkPerformanceInput")
    def mobile_sdk_performance_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance], jsii.get(self, "mobileSdkPerformanceInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingRequestHeaderInput")
    def modify_incoming_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader], jsii.get(self, "modifyIncomingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyIncomingResponseHeaderInput")
    def modify_incoming_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader], jsii.get(self, "modifyIncomingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingRequestHeaderInput")
    def modify_outgoing_request_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader], jsii.get(self, "modifyOutgoingRequestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyOutgoingResponseHeaderInput")
    def modify_outgoing_response_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader], jsii.get(self, "modifyOutgoingResponseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyViaHeaderInput")
    def modify_via_header_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader], jsii.get(self, "modifyViaHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="mPulseInput")
    def m_pulse_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse], jsii.get(self, "mPulseInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsInput")
    def origin_characteristics_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics], jsii.get(self, "originCharacteristicsInput"))

    @builtins.property
    @jsii.member(jsii_name="originCharacteristicsWsdInput")
    def origin_characteristics_wsd_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd], jsii.get(self, "originCharacteristicsWsdInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryMethodInput")
    def origin_failure_recovery_method_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod], jsii.get(self, "originFailureRecoveryMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="originFailureRecoveryPolicyInput")
    def origin_failure_recovery_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy], jsii.get(self, "originFailureRecoveryPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="originIpAclInput")
    def origin_ip_acl_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl], jsii.get(self, "originIpAclInput"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyInput")
    def permissions_policy_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy"], jsii.get(self, "permissionsPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentClientConnectionInput")
    def persistent_client_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection"], jsii.get(self, "persistentClientConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="persistentConnectionInput")
    def persistent_connection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection"], jsii.get(self, "persistentConnectionInput"))

    @builtins.property
    @jsii.member(jsii_name="personallyIdentifiableInformationInput")
    def personally_identifiable_information_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation"], jsii.get(self, "personallyIdentifiableInformationInput"))

    @builtins.property
    @jsii.member(jsii_name="phasedReleaseInput")
    def phased_release_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease"], jsii.get(self, "phasedReleaseInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectInput")
    def preconnect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect"], jsii.get(self, "preconnectInput"))

    @builtins.property
    @jsii.member(jsii_name="predictiveContentDeliveryInput")
    def predictive_content_delivery_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery"], jsii.get(self, "predictiveContentDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="predictivePrefetchingInput")
    def predictive_prefetching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching"], jsii.get(self, "predictivePrefetchingInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchableInput")
    def prefetchable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable"], jsii.get(self, "prefetchableInput"))

    @builtins.property
    @jsii.member(jsii_name="prefetchInput")
    def prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch"], jsii.get(self, "prefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshCacheInput")
    def prefresh_cache_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache"], jsii.get(self, "prefreshCacheInput"))

    @builtins.property
    @jsii.member(jsii_name="qualityInput")
    def quality_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality"], jsii.get(self, "qualityInput"))

    @builtins.property
    @jsii.member(jsii_name="quicBetaInput")
    def quic_beta_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta"], jsii.get(self, "quicBetaInput"))

    @builtins.property
    @jsii.member(jsii_name="randomSeekInput")
    def random_seek_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek"], jsii.get(self, "randomSeekInput"))

    @builtins.property
    @jsii.member(jsii_name="rapidInput")
    def rapid_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid"], jsii.get(self, "rapidInput"))

    @builtins.property
    @jsii.member(jsii_name="readTimeoutInput")
    def read_timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout"], jsii.get(self, "readTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="realTimeReportingInput")
    def real_time_reporting_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting"], jsii.get(self, "realTimeReportingInput"))

    @builtins.property
    @jsii.member(jsii_name="realUserMonitoringInput")
    def real_user_monitoring_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring"], jsii.get(self, "realUserMonitoringInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectInput")
    def redirect_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect"], jsii.get(self, "redirectInput"))

    @builtins.property
    @jsii.member(jsii_name="redirectplusInput")
    def redirectplus_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus"], jsii.get(self, "redirectplusInput"))

    @builtins.property
    @jsii.member(jsii_name="refererCheckingInput")
    def referer_checking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking"], jsii.get(self, "refererCheckingInput"))

    @builtins.property
    @jsii.member(jsii_name="removeQueryParameterInput")
    def remove_query_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter"], jsii.get(self, "removeQueryParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="removeVaryInput")
    def remove_vary_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary"], jsii.get(self, "removeVaryInput"))

    @builtins.property
    @jsii.member(jsii_name="reportInput")
    def report_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport"], jsii.get(self, "reportInput"))

    @builtins.property
    @jsii.member(jsii_name="requestClientHintsInput")
    def request_client_hints_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints"], jsii.get(self, "requestClientHintsInput"))

    @builtins.property
    @jsii.member(jsii_name="requestControlInput")
    def request_control_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl"], jsii.get(self, "requestControlInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeMarkerInput")
    def request_type_marker_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker"], jsii.get(self, "requestTypeMarkerInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerExtendedCompatibilityInput")
    def resource_optimizer_extended_compatibility_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility"], jsii.get(self, "resourceOptimizerExtendedCompatibilityInput"))

    @builtins.property
    @jsii.member(jsii_name="resourceOptimizerInput")
    def resource_optimizer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer"], jsii.get(self, "resourceOptimizerInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode"], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCookieInput")
    def response_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie"], jsii.get(self, "responseCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="restrictObjectCachingInput")
    def restrict_object_caching_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching"], jsii.get(self, "restrictObjectCachingInput"))

    @builtins.property
    @jsii.member(jsii_name="returnCacheStatusInput")
    def return_cache_status_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus"], jsii.get(self, "returnCacheStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="rewriteUrlInput")
    def rewrite_url_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl"], jsii.get(self, "rewriteUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="rumCustomInput")
    def rum_custom_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom"], jsii.get(self, "rumCustomInput"))

    @builtins.property
    @jsii.member(jsii_name="saasDefinitionsInput")
    def saas_definitions_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions"], jsii.get(self, "saasDefinitionsInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudClientInput")
    def sales_force_commerce_cloud_client_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient"], jsii.get(self, "salesForceCommerceCloudClientInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderHostHeaderInput")
    def sales_force_commerce_cloud_provider_host_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader"], jsii.get(self, "salesForceCommerceCloudProviderHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="salesForceCommerceCloudProviderInput")
    def sales_force_commerce_cloud_provider_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider"], jsii.get(self, "salesForceCommerceCloudProviderInput"))

    @builtins.property
    @jsii.member(jsii_name="savePostDcaProcessingInput")
    def save_post_dca_processing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing"], jsii.get(self, "savePostDcaProcessingInput"))

    @builtins.property
    @jsii.member(jsii_name="scheduleInvalidationInput")
    def schedule_invalidation_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation"], jsii.get(self, "scheduleInvalidationInput"))

    @builtins.property
    @jsii.member(jsii_name="scriptManagementInput")
    def script_management_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement"], jsii.get(self, "scriptManagementInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedContentProtectionInput")
    def segmented_content_protection_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection"], jsii.get(self, "segmentedContentProtectionInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaOptimizationInput")
    def segmented_media_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization"], jsii.get(self, "segmentedMediaOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentedMediaStreamingPrefetchInput")
    def segmented_media_streaming_prefetch_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch"], jsii.get(self, "segmentedMediaStreamingPrefetchInput"))

    @builtins.property
    @jsii.member(jsii_name="setVariableInput")
    def set_variable_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable"], jsii.get(self, "setVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="simulateErrorCodeInput")
    def simulate_error_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode"], jsii.get(self, "simulateErrorCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="siteShieldInput")
    def site_shield_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield"], jsii.get(self, "siteShieldInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationInput")
    def standard_tls_migration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration"], jsii.get(self, "standardTlsMigrationInput"))

    @builtins.property
    @jsii.member(jsii_name="standardTlsMigrationOverrideInput")
    def standard_tls_migration_override_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride"], jsii.get(self, "standardTlsMigrationOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="strictHeaderParsingInput")
    def strict_header_parsing_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing"], jsii.get(self, "strictHeaderParsingInput"))

    @builtins.property
    @jsii.member(jsii_name="subCustomerInput")
    def sub_customer_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer"], jsii.get(self, "subCustomerInput"))

    @builtins.property
    @jsii.member(jsii_name="sureRouteInput")
    def sure_route_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute"], jsii.get(self, "sureRouteInput"))

    @builtins.property
    @jsii.member(jsii_name="tcpOptimizationInput")
    def tcp_optimization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization"], jsii.get(self, "tcpOptimizationInput"))

    @builtins.property
    @jsii.member(jsii_name="teaLeafInput")
    def tea_leaf_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf"], jsii.get(self, "teaLeafInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionAdvancedInput")
    def tiered_distribution_advanced_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced"], jsii.get(self, "tieredDistributionAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionCustomizationInput")
    def tiered_distribution_customization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization"], jsii.get(self, "tieredDistributionCustomizationInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionInput")
    def tiered_distribution_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution"], jsii.get(self, "tieredDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout"], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uidConfigurationInput")
    def uid_configuration_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration"], jsii.get(self, "uidConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="validateEntityTagInput")
    def validate_entity_tag_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag"], jsii.get(self, "validateEntityTagInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenForDcpInput")
    def verify_json_web_token_for_dcp_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp"], jsii.get(self, "verifyJsonWebTokenForDcpInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyJsonWebTokenInput")
    def verify_json_web_token_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken"], jsii.get(self, "verifyJsonWebTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="verifyTokenAuthorizationInput")
    def verify_token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization"], jsii.get(self, "verifyTokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomInput")
    def virtual_waiting_room_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom"], jsii.get(self, "virtualWaitingRoomInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomWithEdgeWorkersInput")
    def virtual_waiting_room_with_edge_workers_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers"], jsii.get(self, "virtualWaitingRoomWithEdgeWorkersInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoInput")
    def visitor_prioritization_fifo_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo"], jsii.get(self, "visitorPrioritizationFifoInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationFifoStandaloneInput")
    def visitor_prioritization_fifo_standalone_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone"], jsii.get(self, "visitorPrioritizationFifoStandaloneInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationInput")
    def visitor_prioritization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization"], jsii.get(self, "visitorPrioritizationInput"))

    @builtins.property
    @jsii.member(jsii_name="watermarkingInput")
    def watermarking_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking"], jsii.get(self, "watermarkingInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall"], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="webdavInput")
    def webdav_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav"], jsii.get(self, "webdavInput"))

    @builtins.property
    @jsii.member(jsii_name="webSocketsInput")
    def web_sockets_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets"], jsii.get(self, "webSocketsInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__236e9a89cee854e5c619b92b11d66dc3107a29c2d01a1ad44a64f864e03bb4cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy",
    jsii_struct_bases=[],
    name_mapping={
        "allow_list": "allowList",
        "locked": "locked",
        "permissions_policy_directive": "permissionsPolicyDirective",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy:
    def __init__(
        self,
        *,
        allow_list: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_list: The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here. They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param permissions_policy_directive: Each directive represents a browser feature. Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16efb7ed1476f4ea4419d9a13239760353624854ddbd4c7950c52259a8dd06f2)
            check_type(argname="argument allow_list", value=allow_list, expected_type=type_hints["allow_list"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument permissions_policy_directive", value=permissions_policy_directive, expected_type=type_hints["permissions_policy_directive"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_list is not None:
            self._values["allow_list"] = allow_list
        if locked is not None:
            self._values["locked"] = locked
        if permissions_policy_directive is not None:
            self._values["permissions_policy_directive"] = permissions_policy_directive
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_list(self) -> typing.Optional[builtins.str]:
        '''The features you've set in ``permissionsPolicyDirective`` are enabled for domains you specify here.

        They'll remain disabled for all other domains. Separate multiple domains with a single space. To block the specified directives from all domains, set this to ``none``. This generates an empty value in the ``Permissions-Policy`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_list DataAkamaiPropertyRulesBuilder#allow_list}
        '''
        result = self._values.get("allow_list")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def permissions_policy_directive(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Each directive represents a browser feature.

        Specify the ones you want enabled in a client browser that accesses your content. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#permissions_policy_directive DataAkamaiPropertyRulesBuilder#permissions_policy_directive}
        '''
        result = self._values.get("permissions_policy_directive")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4db414e2274f81a16f030548d24a5f88d8dc1a97d9ef4827817b057aba0114ed)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowList")
    def reset_allow_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowList", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPermissionsPolicyDirective")
    def reset_permissions_policy_directive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPermissionsPolicyDirective", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowListInput")
    def allow_list_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowListInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyDirectiveInput")
    def permissions_policy_directive_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "permissionsPolicyDirectiveInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowList")
    def allow_list(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowList"))

    @allow_list.setter
    def allow_list(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96791e6a53d64d59bda7c69883c6b41823648628bc040815a41d10389e701583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowList", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83d4c7a2c4cd79cbde2c146a5b64c9c41b62d43ac3d9d59c8213735baa7bd633)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="permissionsPolicyDirective")
    def permissions_policy_directive(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "permissionsPolicyDirective"))

    @permissions_policy_directive.setter
    def permissions_policy_directive(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46b4d0b220efca69bcb54cc281665eea00c31406ca9475b376ff76516a3fb144)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "permissionsPolicyDirective", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c254238c908e2ee84d1cf8df39a25eb0f17a2f838b59e5d2c2e467bd2bf8a9b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad780cbbb9caefcf6add59e796d2c953daf5d89332b02f484acb2d0c1c61bb15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66172df2c8b4c9c8f8dc361b1d8d98d87c1c6102bf497b444887411d23a2ae4d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the persistent connections behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63ff9db1862bf61ffc1d25e8d07dad56b5a1376f0a6d4abef76aa4b681d18885)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the persistent connections behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes the persistent connection with the client, 500 seconds by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10bb64f174874a4b8204e766d8f0f527a795f06e36f697b290609001556d8c5c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b412dc950f2d46376ceb619481cff75ac162415fdf6b90a189e425b45938ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5869b424a6684e01712fa4a32b3007fce719662e20fd902f4ad99167c12805b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2aff8287bad4cbf426f4614cd4be06ff0264366f3f3d89e1d4f8a2fb7573c6ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8b348dd54480d4e4db772242051a77df4d81cbcf58b28105c56e13039a3ebdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fef3ccaafd21591a0319b8f33d934ee24a5f187347b92358b4bbf42ebfe22cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6636ba25f614155de0d0e3ce22c42afd1c5b5f269f884bacdca4a99757ca3c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables persistent connections. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: Specifies the timeout period after which edge server closes a persistent connection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04370d3fbbe4c2a6d4e4e1fa1c9f6aeaf98be4dbbd34235fab24526240421dc5)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables persistent connections.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout period after which edge server closes a persistent connection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be0e13112835795a771fc6e9f54ee1d16ea4d77d38011b71797da56d46d43416)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a0b96b80c3aabe6ae6988588ce252a05a64590f239f4124ecaec1ef091a2bac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f681c475857bc831eb01516ec9eb2fa33f18796f348bfd420172bb801633fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3ea05a474a9d7dabf05c401fa385fb27543080d2a8859c1345b0f46a74ed686)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab198f9c90c4bbd8096f2fcc59cecb186286840ec609d49e337f828c10c742c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfd7be0bd67fb1cd06ccd2a4370f4c62b4191da845e2d3b1477ed3f79d20fadd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa190aafa4704a0be94fae43fa50622506d2bd05c39154419ed159c5e739aaf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, marks content as personally identifiable information (PII). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0c9633f16315bc3d55aba2184d432f3507fe60eabc18472f9623c1696773ab)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, marks content as personally identifiable information (PII).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__151f17653dd8554728efbd4761e6b3cc805c28da55b22e9c03c73924c7f0de45)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae59d92b4e2578cab9c1e2a975130201b05a46478ff529daa49960d5d8f97d33)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11c6d124b41f959b76ca527ed35008f304377265efdd4a0cd00913d3e3a7b0db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd382e3b73c517de664f34d8858c29bed29824ce3a8139b8bf3955a2f4cd05f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81fcfad76abf2cc7c5848e88b7a106d6c462f7795c556a05f2aa7064960e2fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef079d7b362348766cecd5757bc4a1707387f31eadf885170ee4ebf90ad13388)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease",
    jsii_struct_bases=[],
    name_mapping={
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enabled": "enabled",
        "failover_duration": "failoverDuration",
        "failover_enabled": "failoverEnabled",
        "failover_response_code": "failoverResponseCode",
        "failover_title": "failoverTitle",
        "is_shared_policy": "isSharedPolicy",
        "label": "label",
        "locked": "locked",
        "population_cookie_type": "populationCookieType",
        "population_duration": "populationDuration",
        "population_expiration_date": "populationExpirationDate",
        "population_refresh": "populationRefresh",
        "population_title": "populationTitle",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease:
    def __init__(
        self,
        *,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_duration: typing.Optional[jsii.Number] = None,
        failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
        failover_title: typing.Optional[builtins.str] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        label: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_cookie_type: typing.Optional[builtins.str] = None,
        population_duration: typing.Optional[builtins.str] = None,
        population_expiration_date: typing.Optional[builtins.str] = None,
        population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        population_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enabled: Enables the Phased Release Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param failover_duration: Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected. Set the value to ``0`` to immediately request the alternate origin upon failure. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        :param failover_enabled: Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        :param failover_response_code: Defines the set of failure codes that initiate the failover response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        :param failover_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param label: A label to distinguish this Phased Release policy from any others within the same property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param population_cookie_type: Select when to assign a cookie to the population of users the Cloudlet defines. If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        :param population_duration: Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        :param population_expiration_date: Specifies the date and time when membership expires, and the browser no longer sends the cookie. Subsequent requests re-evaluate based on current membership settings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        :param population_refresh: Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        :param population_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy(**cloudlet_policy)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af2266a68bf079effa6573a935e9f077eed6f0a73b4d8adea7426acee76647d6)
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument failover_duration", value=failover_duration, expected_type=type_hints["failover_duration"])
            check_type(argname="argument failover_enabled", value=failover_enabled, expected_type=type_hints["failover_enabled"])
            check_type(argname="argument failover_response_code", value=failover_response_code, expected_type=type_hints["failover_response_code"])
            check_type(argname="argument failover_title", value=failover_title, expected_type=type_hints["failover_title"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument label", value=label, expected_type=type_hints["label"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument population_cookie_type", value=population_cookie_type, expected_type=type_hints["population_cookie_type"])
            check_type(argname="argument population_duration", value=population_duration, expected_type=type_hints["population_duration"])
            check_type(argname="argument population_expiration_date", value=population_expiration_date, expected_type=type_hints["population_expiration_date"])
            check_type(argname="argument population_refresh", value=population_refresh, expected_type=type_hints["population_refresh"])
            check_type(argname="argument population_title", value=population_title, expected_type=type_hints["population_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if failover_duration is not None:
            self._values["failover_duration"] = failover_duration
        if failover_enabled is not None:
            self._values["failover_enabled"] = failover_enabled
        if failover_response_code is not None:
            self._values["failover_response_code"] = failover_response_code
        if failover_title is not None:
            self._values["failover_title"] = failover_title
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if label is not None:
            self._values["label"] = label
        if locked is not None:
            self._values["locked"] = locked
        if population_cookie_type is not None:
            self._values["population_cookie_type"] = population_cookie_type
        if population_duration is not None:
            self._values["population_duration"] = population_duration
        if population_expiration_date is not None:
            self._values["population_expiration_date"] = population_expiration_date
        if population_refresh is not None:
            self._values["population_refresh"] = population_refresh
        if population_title is not None:
            self._values["population_title"] = population_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Phased Release Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds to wait until the client tries to access the failover origin after the initial failure is detected.

        Set the value to ``0`` to immediately request the alternate origin upon failure.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_duration DataAkamaiPropertyRulesBuilder#failover_duration}
        '''
        result = self._values.get("failover_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def failover_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows failure responses at the origin defined by the Cloudlet to fail over to the prevailing origin defined by the property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_enabled DataAkamaiPropertyRulesBuilder#failover_enabled}
        '''
        result = self._values.get("failover_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failover_response_code(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Defines the set of failure codes that initiate the failover response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_response_code DataAkamaiPropertyRulesBuilder#failover_response_code}
        '''
        result = self._values.get("failover_response_code")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def failover_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failover_title DataAkamaiPropertyRulesBuilder#failover_title}
        '''
        result = self._values.get("failover_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def label(self) -> typing.Optional[builtins.str]:
        '''A label to distinguish this Phased Release policy from any others within the same property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#label DataAkamaiPropertyRulesBuilder#label}
        '''
        result = self._values.get("label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_cookie_type(self) -> typing.Optional[builtins.str]:
        '''Select when to assign a cookie to the population of users the Cloudlet defines.

        If you select the Cloudlet's ``random`` membership option, it overrides this option's value so that it is effectively ``NONE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_cookie_type DataAkamaiPropertyRulesBuilder#population_cookie_type}
        '''
        result = self._values.get("population_cookie_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the lifetime of the cookie from the initial request. Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_duration DataAkamaiPropertyRulesBuilder#population_duration}
        '''
        result = self._values.get("population_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_expiration_date(self) -> typing.Optional[builtins.str]:
        '''Specifies the date and time when membership expires, and the browser no longer sends the cookie.

        Subsequent requests re-evaluate based on current membership settings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_expiration_date DataAkamaiPropertyRulesBuilder#population_expiration_date}
        '''
        result = self._values.get("population_expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def population_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option resets the original duration of the cookie if the browser refreshes before the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_refresh DataAkamaiPropertyRulesBuilder#population_refresh}
        '''
        result = self._values.get("population_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def population_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#population_title DataAkamaiPropertyRulesBuilder#population_title}
        '''
        result = self._values.get("population_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccb0d921c6f691a4cceea1e784089c92ceb7e5a5fdf6dd709bd8f1978fdbc200)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07d392e23445d22aaf3bb5703f5f67708612f9e18a8d26d599e7f094be04f261)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9994b83fd498dbc6fe96dbe0bad6da083a16b1e8093378c30bf525c599c247ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72a17302f35ffe19e54e75d7e9a4b5fa001ca969ca629e340fc40b20e5f5c070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2668ed09ea5762f706e0cd82950023bffc9efdd2f0a70b704858dd6e506b63f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10df4b2e20a69ac3ae065a27eee60d63f765333de52b25953b8afd05f07db9b4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetFailoverDuration")
    def reset_failover_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverDuration", []))

    @jsii.member(jsii_name="resetFailoverEnabled")
    def reset_failover_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverEnabled", []))

    @jsii.member(jsii_name="resetFailoverResponseCode")
    def reset_failover_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverResponseCode", []))

    @jsii.member(jsii_name="resetFailoverTitle")
    def reset_failover_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailoverTitle", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLabel")
    def reset_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLabel", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPopulationCookieType")
    def reset_population_cookie_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationCookieType", []))

    @jsii.member(jsii_name="resetPopulationDuration")
    def reset_population_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationDuration", []))

    @jsii.member(jsii_name="resetPopulationExpirationDate")
    def reset_population_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationExpirationDate", []))

    @jsii.member(jsii_name="resetPopulationRefresh")
    def reset_population_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationRefresh", []))

    @jsii.member(jsii_name="resetPopulationTitle")
    def reset_population_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopulationTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverDurationInput")
    def failover_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "failoverDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverEnabledInput")
    def failover_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failoverEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCodeInput")
    def failover_response_code_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "failoverResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="failoverTitleInput")
    def failover_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "failoverTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="labelInput")
    def label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "labelInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="populationCookieTypeInput")
    def population_cookie_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationCookieTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="populationDurationInput")
    def population_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDateInput")
    def population_expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationExpirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="populationRefreshInput")
    def population_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "populationRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="populationTitleInput")
    def population_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "populationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99cc43f19aaa02ccf977c37e697f7fad25473dc0184ee1ac254007971da6b8e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__399d5b52a0f91a4e301ab0a7e602c1ea5a936986888c9b3c96acf4444db05bd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverDuration")
    def failover_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "failoverDuration"))

    @failover_duration.setter
    def failover_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b10c7542ae6d3715439134faf19c09eaa1fbc8c0a89ad9baba7db25ec2179b3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverDuration", value)

    @builtins.property
    @jsii.member(jsii_name="failoverEnabled")
    def failover_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failoverEnabled"))

    @failover_enabled.setter
    def failover_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be22cdd0f14a5639630ea637cd8b8e13c0cee54e6efa822194b8a68348ab83e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="failoverResponseCode")
    def failover_response_code(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "failoverResponseCode"))

    @failover_response_code.setter
    def failover_response_code(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5773de14829c6752d346332e68aaab302c924b2215fa9e32a94d6a53dd80a93f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverResponseCode", value)

    @builtins.property
    @jsii.member(jsii_name="failoverTitle")
    def failover_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "failoverTitle"))

    @failover_title.setter
    def failover_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__292419f9526b2544cc470516d9d4657df6f0cc3114f54abf1537a7b43d2951e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failoverTitle", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bc9498da0f3f30a31f19f6c9d4e059bda7a818c6a081cd12296b907d14d821c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="label")
    def label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "label"))

    @label.setter
    def label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__623d409a1a80ed18e157b45ba7be6169937a49a467eac4ba333c3b82f8620575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "label", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b76b35faa0a47a92bc5685fc553895d926dd6a0d0925c841c66c39999bc19b40)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="populationCookieType")
    def population_cookie_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationCookieType"))

    @population_cookie_type.setter
    def population_cookie_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5429d37f3a6e97418ccca2a56db5150143542151631f799f6536253fc7a9666b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationCookieType", value)

    @builtins.property
    @jsii.member(jsii_name="populationDuration")
    def population_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationDuration"))

    @population_duration.setter
    def population_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c55f5b6a63b9da9ffa05a8f48cf1d32eb5aa98b86794d0193dbb63399df168b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="populationExpirationDate")
    def population_expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationExpirationDate"))

    @population_expiration_date.setter
    def population_expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe68b6c255281ad824cf93ef76cad41765cba3e669cab3b360f872169596f22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationExpirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="populationRefresh")
    def population_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "populationRefresh"))

    @population_refresh.setter
    def population_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6e28d11c066ec1583497b1a0959accd58cb5c9cce9916f06b15f4e744032cb8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="populationTitle")
    def population_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "populationTitle"))

    @population_title.setter
    def population_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7152e2a03da91fece896b87d68765b76e4a8a27ec0717e50c9e7519d41ff1948)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "populationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84ecda0f0b897088c41dda7762159c6299c3c4e1b20ef8a007f48ec7f206af50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92f6d0d7f5a39751cecfe3af4b8efe5abbab76eca797511c6d45537c02447dcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f7a0a43413a3b979adcd8fcb088180ed649801ab0e4437cd3147ea01687079a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "preconnectlist": "preconnectlist",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param preconnectlist: Specifies the set of hostnames to which to preconnect over HTTP2. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b4522082d31135482af2805d11ac7025b09dd4f6929fc98b23bcf778f49898e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument preconnectlist", value=preconnectlist, expected_type=type_hints["preconnectlist"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if preconnectlist is not None:
            self._values["preconnectlist"] = preconnectlist
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def preconnectlist(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of hostnames to which to preconnect over HTTP2.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#preconnectlist DataAkamaiPropertyRulesBuilder#preconnectlist}
        '''
        result = self._values.get("preconnectlist")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7191f0457d90541f8280d43b1453b5f2263c24606a322c0d1633b832557b7ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPreconnectlist")
    def reset_preconnectlist(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPreconnectlist", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="preconnectlistInput")
    def preconnectlist_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "preconnectlistInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b11386520739eb97573db5bc52616694db2f39ef877522f20d218b9d0a040b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="preconnectlist")
    def preconnectlist(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "preconnectlist"))

    @preconnectlist.setter
    def preconnectlist(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24f9f49ec3b36ff8cb4d1f106a740e1acd21dfdb5137c32a23c52a9bef67d701)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "preconnectlist", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd8807dd347950a17a9ce5c66cc972f016229eac4b4412eedbe7e605b4e1e30b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__721a799f1fbcd5909bbacdb1631733099124d960db3245f5f5e55e92c011492a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b655acc03efac4b041c711db4fc592eddfbfc557b6bcc9aac1687d502248807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the predictive content delivery behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43078f96358397b1fce10f06ab7bf5c18255615e93c3b1be4ead091e0e7990bf)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive content delivery behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDeliveryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDeliveryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f830442c1e213c18b283074b2f31ad2d5bd8900e9b8c436c1d4479d7636f8a8b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589c7b2a92044dc13061596d89f10c59f1aab2aeb4ae898bb64ab43215852ed1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28d415f4c6d829831349a8ec21fc872c5639dff6b352fd68acf5936cc1911a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92df952188acfcad2e55663fdd7dffa3d412b9b33a7562d34f273c26141ac5c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d285dc9ab97e65ed4dbdd9774867eb8bf03c23640ebd3cd1116a65222b5d01ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95aeb9d82d821f78109f19e892cdc81bf4a1a00bf933d9923a2d1b12da453348)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching",
    jsii_struct_bases=[],
    name_mapping={
        "accuracy_target": "accuracyTarget",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching:
    def __init__(
        self,
        *,
        accuracy_target: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accuracy_target: The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        :param enabled: Enables the predictive prefetching behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71628e1d451ba1d685c3a36c8e455e96db2e4588a2e97eae2114452a9a585af2)
            check_type(argname="argument accuracy_target", value=accuracy_target, expected_type=type_hints["accuracy_target"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accuracy_target is not None:
            self._values["accuracy_target"] = accuracy_target
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accuracy_target(self) -> typing.Optional[builtins.str]:
        '''The level of prefetching. A higher level results in better client performance, but potentially greater load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accuracy_target DataAkamaiPropertyRulesBuilder#accuracy_target}
        '''
        result = self._values.get("accuracy_target")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the predictive prefetching behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetchingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetchingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d28bcfed6098d4273eddd4074dae502c076475d046ad230a24bb8402f16e1e14)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccuracyTarget")
    def reset_accuracy_target(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccuracyTarget", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="accuracyTargetInput")
    def accuracy_target_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accuracyTargetInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="accuracyTarget")
    def accuracy_target(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accuracyTarget"))

    @accuracy_target.setter
    def accuracy_target(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__210cb115ea4765ec20df077fbd79374c22dad917470a2e054be4580a4f69208e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accuracyTarget", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__993c00d870dd8b8d0d8bbfbdd4b9387582c41443b97be9f4b0f7300ca0182edb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97e2fe3b690e203de0c51ea1492c45fb3426371cc9d1fc7de92bfb0fbbbf464f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed46a8bef25585848dad045e63e05f7ba376d6ee5539ca721a57269c2768ca4e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc83b55b94791cb5bd5086c116e213b0640da41ee6f803f446e2dcd6c5b864b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__913c8fc29a1829bdfee88f7f834e29a7aec3ac2a971874a6947882f168304f69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Applies prefetching behavior when enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b7ba32440736202f794813ae4a84b33900ce2be94dafeff62ab17826250cd796)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies prefetching behavior when enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a737ae1a284a53b8644b59c31765c3988c85bae6f144193f43a055aca93c2091)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2e2f2b031915a02dd18ee32c0acb9b2071c8841b5ca37df85acf48ff5a4be51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2258aaf8bfe865232cf1a00e31a1a534083981cff5de6a43271727a11b1f919)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ce5f9b6f67375048e860485a7278d18cdc8b3c67b3e593a1404fe85f9fe21a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__025fd29c6e4fcee09143c4edac931581a6185bbf7b31bb67926d82507cb1423f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79a0a4831cdd9b8e9dd4e95e295ddf3d95cc16a132f71747265dd01f39f08795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows matching content to prefetch when referenced on a requested parent page. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a623ea17ccc97d4b443f71c8b3c5384105a0e37bb9b0ddec6263741d7278f666)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows matching content to prefetch when referenced on a requested parent page.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__760cfae25af6cdaf92993a3c9a3637f6ca85d0cce332be621a55b088e845a31f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79b9af688cf9641e7e799f8f3a6941cfd8f5bab5586ca502f798657995800a24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__704aab6d3fe0d49e4f21abf329a5e7e24119e3d8244d376e819137e67ed1e788)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05d1ee0b863dba0a77cb5d525160f183124156acdc9a873664c72cd10f1420b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__175bc06aaadad862b2714a0d27ae2d52860f9f468163e946736963931a01ada7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ecfb717e9c82ac46fa5adb30d060ccb8d4a343a4644b5057e04897992fb0444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "prefreshval": "prefreshval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        prefreshval: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the cache prefreshing behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param prefreshval: Specifies when the prefresh occurs as a percentage of the TTL. For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70bb29c74c40dd2b2d8ec25282a1fb8f5b3347d4f0041a42db5fc6469b41687a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument prefreshval", value=prefreshval, expected_type=type_hints["prefreshval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if prefreshval is not None:
            self._values["prefreshval"] = prefreshval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the cache prefreshing behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def prefreshval(self) -> typing.Optional[jsii.Number]:
        '''Specifies when the prefresh occurs as a percentage of the TTL.

        For example, for an object whose cache has 10 minutes left to live, and an origin response that is routinely less than 30 seconds, a percentage of ``95`` prefreshes the content without unnecessarily increasing load on the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prefreshval DataAkamaiPropertyRulesBuilder#prefreshval}
        '''
        result = self._values.get("prefreshval")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCacheOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCacheOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bb9de741ffc9470927e4775fae58fd07174c636c6d9aa540775b44e45bd66f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrefreshval")
    def reset_prefreshval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrefreshval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="prefreshvalInput")
    def prefreshval_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "prefreshvalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7724cb0606fb77d947f6db8a7eeff7a975dd6d1aa1a4ca27c1521ef31bc553d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02fef0d11974c159541e74547ef0ad2c9acbae8f196a9601d156761b51540ec6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="prefreshval")
    def prefreshval(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "prefreshval"))

    @prefreshval.setter
    def prefreshval(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba3be47e7a35270da2b376ec7908dd057fb4bfb6c0dbd46d7af83e76bc772cee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prefreshval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6be1695641340894fc3496f0f1a05a51ad05625131777206ae4092f0592e13f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f304db7ba662646e2cc0a156d89cfcc2b9db88dc6745ab6a7a6d3c01f92b3a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b1b97fd458c08483a839c7553b12ac69740d18c05eae4a447b29855a96328d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality",
    jsii_struct_bases=[],
    name_mapping={
        "audience_settings": "audienceSettings",
        "catalog_size": "catalogSize",
        "content_settings": "contentSettings",
        "content_type": "contentType",
        "country": "country",
        "delivery_format": "deliveryFormat",
        "delivery_type": "deliveryType",
        "download_type": "downloadType",
        "end_user_location": "endUserLocation",
        "locked": "locked",
        "maximum_concurrent_users": "maximumConcurrentUsers",
        "object_size": "objectSize",
        "optimize_for": "optimizeFor",
        "origin_settings": "originSettings",
        "popularity_distribution": "popularityDistribution",
        "refresh_rate": "refreshRate",
        "segment_duration": "segmentDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality:
    def __init__(
        self,
        *,
        audience_settings: typing.Optional[builtins.str] = None,
        catalog_size: typing.Optional[builtins.str] = None,
        content_settings: typing.Optional[builtins.str] = None,
        content_type: typing.Optional[builtins.str] = None,
        country: typing.Optional[builtins.str] = None,
        delivery_format: typing.Optional[builtins.str] = None,
        delivery_type: typing.Optional[builtins.str] = None,
        download_type: typing.Optional[builtins.str] = None,
        end_user_location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_concurrent_users: typing.Optional[builtins.str] = None,
        object_size: typing.Optional[builtins.str] = None,
        optimize_for: typing.Optional[builtins.str] = None,
        origin_settings: typing.Optional[builtins.str] = None,
        popularity_distribution: typing.Optional[builtins.str] = None,
        refresh_rate: typing.Optional[builtins.str] = None,
        segment_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param audience_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        :param catalog_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.
        :param content_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        :param content_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.
        :param country: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.
        :param delivery_format: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.
        :param delivery_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.
        :param download_type: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.
        :param end_user_location: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_concurrent_users: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.
        :param object_size: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.
        :param optimize_for: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.
        :param origin_settings: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        :param popularity_distribution: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.
        :param refresh_rate: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.
        :param segment_duration: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c9c8f22baf6d0209b685b3bb5223e20a4c38640b3b033c3369ed68c515134d5)
            check_type(argname="argument audience_settings", value=audience_settings, expected_type=type_hints["audience_settings"])
            check_type(argname="argument catalog_size", value=catalog_size, expected_type=type_hints["catalog_size"])
            check_type(argname="argument content_settings", value=content_settings, expected_type=type_hints["content_settings"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument country", value=country, expected_type=type_hints["country"])
            check_type(argname="argument delivery_format", value=delivery_format, expected_type=type_hints["delivery_format"])
            check_type(argname="argument delivery_type", value=delivery_type, expected_type=type_hints["delivery_type"])
            check_type(argname="argument download_type", value=download_type, expected_type=type_hints["download_type"])
            check_type(argname="argument end_user_location", value=end_user_location, expected_type=type_hints["end_user_location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_concurrent_users", value=maximum_concurrent_users, expected_type=type_hints["maximum_concurrent_users"])
            check_type(argname="argument object_size", value=object_size, expected_type=type_hints["object_size"])
            check_type(argname="argument optimize_for", value=optimize_for, expected_type=type_hints["optimize_for"])
            check_type(argname="argument origin_settings", value=origin_settings, expected_type=type_hints["origin_settings"])
            check_type(argname="argument popularity_distribution", value=popularity_distribution, expected_type=type_hints["popularity_distribution"])
            check_type(argname="argument refresh_rate", value=refresh_rate, expected_type=type_hints["refresh_rate"])
            check_type(argname="argument segment_duration", value=segment_duration, expected_type=type_hints["segment_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if audience_settings is not None:
            self._values["audience_settings"] = audience_settings
        if catalog_size is not None:
            self._values["catalog_size"] = catalog_size
        if content_settings is not None:
            self._values["content_settings"] = content_settings
        if content_type is not None:
            self._values["content_type"] = content_type
        if country is not None:
            self._values["country"] = country
        if delivery_format is not None:
            self._values["delivery_format"] = delivery_format
        if delivery_type is not None:
            self._values["delivery_type"] = delivery_type
        if download_type is not None:
            self._values["download_type"] = download_type
        if end_user_location is not None:
            self._values["end_user_location"] = end_user_location
        if locked is not None:
            self._values["locked"] = locked
        if maximum_concurrent_users is not None:
            self._values["maximum_concurrent_users"] = maximum_concurrent_users
        if object_size is not None:
            self._values["object_size"] = object_size
        if optimize_for is not None:
            self._values["optimize_for"] = optimize_for
        if origin_settings is not None:
            self._values["origin_settings"] = origin_settings
        if popularity_distribution is not None:
            self._values["popularity_distribution"] = popularity_distribution
        if refresh_rate is not None:
            self._values["refresh_rate"] = refresh_rate
        if segment_duration is not None:
            self._values["segment_duration"] = segment_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def audience_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#audience_settings DataAkamaiPropertyRulesBuilder#audience_settings}
        '''
        result = self._values.get("audience_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def catalog_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#catalog_size DataAkamaiPropertyRulesBuilder#catalog_size}.'''
        result = self._values.get("catalog_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_settings DataAkamaiPropertyRulesBuilder#content_settings}
        '''
        result = self._values.get("content_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def content_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}.'''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def country(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country DataAkamaiPropertyRulesBuilder#country}.'''
        result = self._values.get("country")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_format(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_format DataAkamaiPropertyRulesBuilder#delivery_format}.'''
        result = self._values.get("delivery_format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def delivery_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#delivery_type DataAkamaiPropertyRulesBuilder#delivery_type}.'''
        result = self._values.get("delivery_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def download_type(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_type DataAkamaiPropertyRulesBuilder#download_type}.'''
        result = self._values.get("download_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_user_location(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_user_location DataAkamaiPropertyRulesBuilder#end_user_location}.'''
        result = self._values.get("end_user_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_concurrent_users(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_concurrent_users DataAkamaiPropertyRulesBuilder#maximum_concurrent_users}.'''
        result = self._values.get("maximum_concurrent_users")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def object_size(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#object_size DataAkamaiPropertyRulesBuilder#object_size}.'''
        result = self._values.get("object_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def optimize_for(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#optimize_for DataAkamaiPropertyRulesBuilder#optimize_for}.'''
        result = self._values.get("optimize_for")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_settings(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_settings DataAkamaiPropertyRulesBuilder#origin_settings}
        '''
        result = self._values.get("origin_settings")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def popularity_distribution(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#popularity_distribution DataAkamaiPropertyRulesBuilder#popularity_distribution}.'''
        result = self._values.get("popularity_distribution")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def refresh_rate(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_rate DataAkamaiPropertyRulesBuilder#refresh_rate}.'''
        result = self._values.get("refresh_rate")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def segment_duration(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#segment_duration DataAkamaiPropertyRulesBuilder#segment_duration}.'''
        result = self._values.get("segment_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQualityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQualityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3200cf66b491a66a09b4f92c964d2cf45fb79095e37a7e2f5693d27e12ae3ad4)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAudienceSettings")
    def reset_audience_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAudienceSettings", []))

    @jsii.member(jsii_name="resetCatalogSize")
    def reset_catalog_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCatalogSize", []))

    @jsii.member(jsii_name="resetContentSettings")
    def reset_content_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentSettings", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetCountry")
    def reset_country(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountry", []))

    @jsii.member(jsii_name="resetDeliveryFormat")
    def reset_delivery_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryFormat", []))

    @jsii.member(jsii_name="resetDeliveryType")
    def reset_delivery_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeliveryType", []))

    @jsii.member(jsii_name="resetDownloadType")
    def reset_download_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadType", []))

    @jsii.member(jsii_name="resetEndUserLocation")
    def reset_end_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndUserLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumConcurrentUsers")
    def reset_maximum_concurrent_users(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumConcurrentUsers", []))

    @jsii.member(jsii_name="resetObjectSize")
    def reset_object_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetObjectSize", []))

    @jsii.member(jsii_name="resetOptimizeFor")
    def reset_optimize_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOptimizeFor", []))

    @jsii.member(jsii_name="resetOriginSettings")
    def reset_origin_settings(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginSettings", []))

    @jsii.member(jsii_name="resetPopularityDistribution")
    def reset_popularity_distribution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPopularityDistribution", []))

    @jsii.member(jsii_name="resetRefreshRate")
    def reset_refresh_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshRate", []))

    @jsii.member(jsii_name="resetSegmentDuration")
    def reset_segment_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSegmentDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="audienceSettingsInput")
    def audience_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "audienceSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="catalogSizeInput")
    def catalog_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "catalogSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="contentSettingsInput")
    def content_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="countryInput")
    def country_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "countryInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryFormatInput")
    def delivery_format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryFormatInput"))

    @builtins.property
    @jsii.member(jsii_name="deliveryTypeInput")
    def delivery_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deliveryTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadTypeInput")
    def download_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="endUserLocationInput")
    def end_user_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endUserLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsersInput")
    def maximum_concurrent_users_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumConcurrentUsersInput"))

    @builtins.property
    @jsii.member(jsii_name="objectSizeInput")
    def object_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "objectSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="optimizeForInput")
    def optimize_for_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "optimizeForInput"))

    @builtins.property
    @jsii.member(jsii_name="originSettingsInput")
    def origin_settings_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originSettingsInput"))

    @builtins.property
    @jsii.member(jsii_name="popularityDistributionInput")
    def popularity_distribution_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "popularityDistributionInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshRateInput")
    def refresh_rate_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshRateInput"))

    @builtins.property
    @jsii.member(jsii_name="segmentDurationInput")
    def segment_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "segmentDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="audienceSettings")
    def audience_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "audienceSettings"))

    @audience_settings.setter
    def audience_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff9a06f7a07795f6570bac346a27c95ef733926573d15f61694283acce2a4c17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "audienceSettings", value)

    @builtins.property
    @jsii.member(jsii_name="catalogSize")
    def catalog_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "catalogSize"))

    @catalog_size.setter
    def catalog_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3bb5068795f4e7a67f73d22f988af35fc34c67a402e11ed1c42dde6fa59c1e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "catalogSize", value)

    @builtins.property
    @jsii.member(jsii_name="contentSettings")
    def content_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentSettings"))

    @content_settings.setter
    def content_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa6f3048a15253151d01a8a43af0f2c69b67fdb9d3b6c28d2529ca9077b2fffe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentSettings", value)

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "contentType"))

    @content_type.setter
    def content_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aabbdfcfaea670af55d565e0f4b80cf25bd51b5a1f43dc367a91a30d88d9dc34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentType", value)

    @builtins.property
    @jsii.member(jsii_name="country")
    def country(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "country"))

    @country.setter
    def country(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ccf5fc86e200382ee2a3434ca8e2a86c47bb7107c1c42bd6f0ddfb89fb1399)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "country", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryFormat")
    def delivery_format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryFormat"))

    @delivery_format.setter
    def delivery_format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__999e440a37a741bc3352930d6d43919b32f71a0847d0fd04cbbfb3e528a79811)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryFormat", value)

    @builtins.property
    @jsii.member(jsii_name="deliveryType")
    def delivery_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deliveryType"))

    @delivery_type.setter
    def delivery_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3262a62f1562a0c722c6f3b2a21bc3ec3bbd31e94476e796554cc2c02e10a8c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deliveryType", value)

    @builtins.property
    @jsii.member(jsii_name="downloadType")
    def download_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadType"))

    @download_type.setter
    def download_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35c94a5857c5a6ffdf073cc0b68f7889b556f60378d571b1f547bda19cb897ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadType", value)

    @builtins.property
    @jsii.member(jsii_name="endUserLocation")
    def end_user_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endUserLocation"))

    @end_user_location.setter
    def end_user_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e226a54117e794726f2d40931c22e40cd5e3508ad66631acb789ee77a54d849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endUserLocation", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b3c53ab42425c2b755ca0296a65d327816b3e0224275b37e9d54de4b53743fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumConcurrentUsers")
    def maximum_concurrent_users(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumConcurrentUsers"))

    @maximum_concurrent_users.setter
    def maximum_concurrent_users(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4ad9e77bb7e9353b609324da8c6620af6c604339fa005b0016575770fc2640)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumConcurrentUsers", value)

    @builtins.property
    @jsii.member(jsii_name="objectSize")
    def object_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "objectSize"))

    @object_size.setter
    def object_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97d8e7fffccb41330f75a906350bf50b179e0ff90da1debb2fda6350d6f5040)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "objectSize", value)

    @builtins.property
    @jsii.member(jsii_name="optimizeFor")
    def optimize_for(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "optimizeFor"))

    @optimize_for.setter
    def optimize_for(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dc5a0da318c9b3fa95c63a931807f3868286606b53cac1709513b35f1ac4463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "optimizeFor", value)

    @builtins.property
    @jsii.member(jsii_name="originSettings")
    def origin_settings(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originSettings"))

    @origin_settings.setter
    def origin_settings(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339e2a9de95157015747369bec3674fc8a7db0293a5a61309fa6454437c82deb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originSettings", value)

    @builtins.property
    @jsii.member(jsii_name="popularityDistribution")
    def popularity_distribution(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "popularityDistribution"))

    @popularity_distribution.setter
    def popularity_distribution(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62b4d73f14e59b0bbd4c3b42667cd70c92221f81c8d5a35594c7b7c05cdab2fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "popularityDistribution", value)

    @builtins.property
    @jsii.member(jsii_name="refreshRate")
    def refresh_rate(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshRate"))

    @refresh_rate.setter
    def refresh_rate(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dc99d2f7ddbcb7ac57d86aafa2c09c03b39b131da2845968ca8b8ae83dc3c4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshRate", value)

    @builtins.property
    @jsii.member(jsii_name="segmentDuration")
    def segment_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "segmentDuration"))

    @segment_duration.setter
    def segment_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea0b3fa1c1e5bdf9ad00a2494512e9213f377a59e6ffea21ade80a3b2a7b58f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "segmentDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42135fabe2dc8912dad25aa389845ec38b0849971a9ebd87c434ef3aed7ba598)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e919799c2bfda2e449f5de77caded706c90eda90ced3bc1edc5db99573f4f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__088e7a9721b287cf7770f12dcf3bbf9376828d4656d7c39f88609947a89960ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "quic_offer_percentage": "quicOfferPercentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        quic_offer_percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables QUIC support. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param quic_offer_percentage: The percentage of responses for which to allow QUIC sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06cad1eeb7b8954da8fb2beaa88d297dbdf4a26e14ca1fcec4f079a78190cdf9)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument quic_offer_percentage", value=quic_offer_percentage, expected_type=type_hints["quic_offer_percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if quic_offer_percentage is not None:
            self._values["quic_offer_percentage"] = quic_offer_percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables QUIC support.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def quic_offer_percentage(self) -> typing.Optional[jsii.Number]:
        '''The percentage of responses for which to allow QUIC sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#quic_offer_percentage DataAkamaiPropertyRulesBuilder#quic_offer_percentage}
        '''
        result = self._values.get("quic_offer_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBetaOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBetaOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52006e1475d25efd5616ecaf5d35ae43844cb09c286be8eb413c5f4c5c727b1d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQuicOfferPercentage")
    def reset_quic_offer_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQuicOfferPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentageInput")
    def quic_offer_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "quicOfferPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7832a9adf79cc7846f428a7b96435410c5136fd6ff4b0582cda7da6c237a0045)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15c21866738d24363711a27eb9465540c0e15a878846b7d6ad0a54e6ecfb8491)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="quicOfferPercentage")
    def quic_offer_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "quicOfferPercentage"))

    @quic_offer_percentage.setter
    def quic_offer_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0002b4cf6617a7c9627a33f6e85a5ccca7f95d116bc425a38078843d3f784b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "quicOfferPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22f9d6118970f8018f65f3fb711170b7832c451e061aa979b5171005a9bdbec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dce224066aa3541e70de06f2cb33aef553a68efce858ef59e7eb5c8eacd9adc4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__547516f4afa31ccf2b592e9a29d60854e26d84a589f81a41898a3c1faf2f986d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek",
    jsii_struct_bases=[],
    name_mapping={
        "flv": "flv",
        "locked": "locked",
        "maximum_size": "maximumSize",
        "mp4": "mp4",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek:
    def __init__(
        self,
        *,
        flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param flv: Enables random seek optimization in FLV files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param mp4: Enables random seek optimization in MP4 files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__83585d0da3216c017a6f52b6075785cfd5a824cb6044fb3c85ce331dd6870fa0)
            check_type(argname="argument flv", value=flv, expected_type=type_hints["flv"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument mp4", value=mp4, expected_type=type_hints["mp4"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if flv is not None:
            self._values["flv"] = flv
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if mp4 is not None:
            self._values["mp4"] = mp4
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def flv(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in FLV files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#flv DataAkamaiPropertyRulesBuilder#flv}
        '''
        result = self._values.get("flv")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Sets the maximum size of the MP4 file to optimize, expressed as a number suffixed with a unit string such as ``MB`` or ``GB``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def mp4(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables random seek optimization in MP4 files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mp4 DataAkamaiPropertyRulesBuilder#mp4}
        '''
        result = self._values.get("mp4")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeekOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeekOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f5d57bf9bb170f098f6947aa0fcfd0e845d2479c1e5421a515e4296b05967d0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetFlv")
    def reset_flv(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFlv", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetMp4")
    def reset_mp4(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMp4", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="flvInput")
    def flv_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "flvInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="mp4Input")
    def mp4_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mp4Input"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="flv")
    def flv(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "flv"))

    @flv.setter
    def flv(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06e9c63fa426502a27e0f454e06c45bbf2b106f44cca89c7920c5e8efffb5d1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "flv", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a259e7c51760554cc2baaf66471086ba5b44db76799cef6a035bcc697f64c10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9801f1bea25e0aa21090efe1f299749440754a51774732d8c0dc8890862199e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="mp4")
    def mp4(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mp4"))

    @mp4.setter
    def mp4(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51bffe2538b343d9f0bb9f7cc5c8ff86b4c2cd9a68b9a3d0136c53298a60828e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mp4", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a1d6e8ca3b8ac9af71520e7c9a7d5f28de22a934dba958c45c0ca26b31c2411)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__360541ed38ff505574ab190b3803b8c0df43bf4593670a8d70e0173802c2fee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21d5a600e283c2c9e1fd1e5c2018649d013affad49a963c993321f3f123a6b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables API Gateway for the current set of content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__577868ec8252dcd9356d0f93c9fbb4c24ef2978462232698dc4ad7fe5ebdf184)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables API Gateway for the current set of content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapidOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapidOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__358417e8ed0a017f70996b53305886cd363b8e50159fbceda51d41e2aba0d2fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__628043d487709aae3c45f0bb9cfa302bd62a506aed71db09ec334152eb369fb1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef1a90e1aaa153accda67c0f03b3cea3c9f742f7844f26325ddb68a6e08a1420)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b526fda9af0e3547e8082d126a5a6fc5a5960661b72fbeb2f737f3fdf4627448)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea823e90ecddd78cc07c604538311173279faa971b9d4cb1f6df3fe75b211dd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__691c54924617df8d5dcc38f2756f4a5689b86eff5cbf2cd398889be68c50f2f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0b8ea8be66338f57308ba645581234b4c1020c364498f1638f852840e6e3ed3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the read timeout necessary before failing with a ``504`` error. This value should never be zero.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4cc78f97d45d095f9631d245cc456026f617a8552f9698522e365465e40425f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92b55d8dc31afe42c36878a1a1ce3f706557f143cf375cfc61414f8eff05d0a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__144588d9605ec196f12e21eee4e5bc677f21df07ba358761ff724306c6ea2df5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__841fda9320d7bd773539083ab5a0477d6a4201db188483cbda3d919d7608bed2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc12cc340aae73c74adf60f2f656b7bd713f9b1cb9e8bc22b2da6a9ec76ed8db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a758aa3e95d3ca917f88d29c674ccfcd8123f1606475a7d7596b295f143484a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting",
    jsii_struct_bases=[],
    name_mapping={
        "advanced": "advanced",
        "beacon_sampling_percentage": "beaconSamplingPercentage",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting:
    def __init__(
        self,
        *,
        advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param advanced: Enables advanced options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        :param beacon_sampling_percentage: Specifies the percentage for sampling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        :param enabled: Enables reports on delivery of cloud hosted content at near real-time latencies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f4096c7861047c8546bbf10120b9a8542b7f2d44ddcd5f1986ddb2134bdcae8)
            check_type(argname="argument advanced", value=advanced, expected_type=type_hints["advanced"])
            check_type(argname="argument beacon_sampling_percentage", value=beacon_sampling_percentage, expected_type=type_hints["beacon_sampling_percentage"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced is not None:
            self._values["advanced"] = advanced
        if beacon_sampling_percentage is not None:
            self._values["beacon_sampling_percentage"] = beacon_sampling_percentage
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables advanced options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced DataAkamaiPropertyRulesBuilder#advanced}
        '''
        result = self._values.get("advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def beacon_sampling_percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage for sampling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#beacon_sampling_percentage DataAkamaiPropertyRulesBuilder#beacon_sampling_percentage}
        '''
        result = self._values.get("beacon_sampling_percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables reports on delivery of cloud hosted content at near real-time latencies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReportingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReportingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57539fac22cea7a63761503ea3f1010c2e8d3624bd6d143f4cba0caa4c05e6ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAdvanced")
    def reset_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvanced", []))

    @jsii.member(jsii_name="resetBeaconSamplingPercentage")
    def reset_beacon_sampling_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeaconSamplingPercentage", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="advancedInput")
    def advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "advancedInput"))

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentageInput")
    def beacon_sampling_percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "beaconSamplingPercentageInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="advanced")
    def advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "advanced"))

    @advanced.setter
    def advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b06308e8bed25372aadc8e1fc33b453de01b740e6dbffc1add03e50c2af90225)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advanced", value)

    @builtins.property
    @jsii.member(jsii_name="beaconSamplingPercentage")
    def beacon_sampling_percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "beaconSamplingPercentage"))

    @beacon_sampling_percentage.setter
    def beacon_sampling_percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54bcc69772587afad4c0000184c36099f473bf4bd8cba56abec1975ff8377593)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beaconSamplingPercentage", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__319821d89495d26804208e9089a44f37b2e569881c848ac7bb7450c7266b8ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee3ad2e1b081b7c4079aa1198a44a911e21d4c404b8d43698f9be00cfb192602)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b97ec1d0c96dea630c03fd1ee66fcc88d2f388af9420d74ab716909727a590e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6144adf90ff9374b1d1e1d10fcb876bd1e9bd235b32f3a2094458de0997411a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fcd78e6ce8cbba00bbe199dba8fa03bdb36282b7f3f67c2ee75684dde04928b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates real-use monitoring. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d249b3cb0a878125918498af997812a57d95e95b826850116871836b7ab6ef)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates real-use monitoring.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoringOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoringOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f32d6b0272c5a87d42058296d5fc690bd85ef799458f5d7f02263440f9dd8ca)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac3b773e18afc1c9dadb1e6ac334c8bbe57ab86a78589feda5dd534a5851c45b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70810d78ccf4c88c6c20f8767475de05c65cfe22464367355916b5108c7ee92e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cf229482ff8352538ce61bebbb88515abbdce29ac61ea7c58eac784a1ca2cd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b77a37fa91f18dee2e5b1a6218b808aabf7f7815f80a2e9229a1c58808e3e0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a34989fedaee97725aa3fab61eb3dda43d3ff6d0f0adf6eb757cb70631eec86c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect",
    jsii_struct_bases=[],
    name_mapping={
        "destination_hostname": "destinationHostname",
        "destination_hostname_other": "destinationHostnameOther",
        "destination_hostname_sibling": "destinationHostnameSibling",
        "destination_hostname_subdomain": "destinationHostnameSubdomain",
        "destination_path": "destinationPath",
        "destination_path_other": "destinationPathOther",
        "destination_path_prefix": "destinationPathPrefix",
        "destination_path_suffix": "destinationPathSuffix",
        "destination_path_suffix_status": "destinationPathSuffixStatus",
        "destination_protocol": "destinationProtocol",
        "locked": "locked",
        "mobile_default_choice": "mobileDefaultChoice",
        "query_string": "queryString",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect:
    def __init__(
        self,
        *,
        destination_hostname: typing.Optional[builtins.str] = None,
        destination_hostname_other: typing.Optional[builtins.str] = None,
        destination_hostname_sibling: typing.Optional[builtins.str] = None,
        destination_hostname_subdomain: typing.Optional[builtins.str] = None,
        destination_path: typing.Optional[builtins.str] = None,
        destination_path_other: typing.Optional[builtins.str] = None,
        destination_path_prefix: typing.Optional[builtins.str] = None,
        destination_path_suffix: typing.Optional[builtins.str] = None,
        destination_path_suffix_status: typing.Optional[builtins.str] = None,
        destination_protocol: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        mobile_default_choice: typing.Optional[builtins.str] = None,
        query_string: typing.Optional[builtins.str] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination_hostname: Specify how to change the requested hostname, independently from the pathname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        :param destination_hostname_other: Specifies the full hostname with which to replace the current hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        :param destination_hostname_sibling: Specifies the subdomain with which to replace to the current hostname's leftmost subdomain. For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        :param destination_hostname_subdomain: Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        :param destination_path: Specify how to change the requested pathname, independently from the hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        :param destination_path_other: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        :param destination_path_prefix: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path. For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        :param destination_path_suffix: When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        :param destination_path_suffix_status: When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        :param destination_protocol: Choose the protocol for the redirect URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param mobile_default_choice: Either specify a default response for mobile browsers, or customize your own. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        :param query_string: When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL. Otherwise set this to ``IGNORE``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        :param response_code: Specify the redirect's response code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4856a5de217b693d70a34ca0bd2075f75bedca7b4cec2aff2b5cf08121ad494)
            check_type(argname="argument destination_hostname", value=destination_hostname, expected_type=type_hints["destination_hostname"])
            check_type(argname="argument destination_hostname_other", value=destination_hostname_other, expected_type=type_hints["destination_hostname_other"])
            check_type(argname="argument destination_hostname_sibling", value=destination_hostname_sibling, expected_type=type_hints["destination_hostname_sibling"])
            check_type(argname="argument destination_hostname_subdomain", value=destination_hostname_subdomain, expected_type=type_hints["destination_hostname_subdomain"])
            check_type(argname="argument destination_path", value=destination_path, expected_type=type_hints["destination_path"])
            check_type(argname="argument destination_path_other", value=destination_path_other, expected_type=type_hints["destination_path_other"])
            check_type(argname="argument destination_path_prefix", value=destination_path_prefix, expected_type=type_hints["destination_path_prefix"])
            check_type(argname="argument destination_path_suffix", value=destination_path_suffix, expected_type=type_hints["destination_path_suffix"])
            check_type(argname="argument destination_path_suffix_status", value=destination_path_suffix_status, expected_type=type_hints["destination_path_suffix_status"])
            check_type(argname="argument destination_protocol", value=destination_protocol, expected_type=type_hints["destination_protocol"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument mobile_default_choice", value=mobile_default_choice, expected_type=type_hints["mobile_default_choice"])
            check_type(argname="argument query_string", value=query_string, expected_type=type_hints["query_string"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination_hostname is not None:
            self._values["destination_hostname"] = destination_hostname
        if destination_hostname_other is not None:
            self._values["destination_hostname_other"] = destination_hostname_other
        if destination_hostname_sibling is not None:
            self._values["destination_hostname_sibling"] = destination_hostname_sibling
        if destination_hostname_subdomain is not None:
            self._values["destination_hostname_subdomain"] = destination_hostname_subdomain
        if destination_path is not None:
            self._values["destination_path"] = destination_path
        if destination_path_other is not None:
            self._values["destination_path_other"] = destination_path_other
        if destination_path_prefix is not None:
            self._values["destination_path_prefix"] = destination_path_prefix
        if destination_path_suffix is not None:
            self._values["destination_path_suffix"] = destination_path_suffix
        if destination_path_suffix_status is not None:
            self._values["destination_path_suffix_status"] = destination_path_suffix_status
        if destination_protocol is not None:
            self._values["destination_protocol"] = destination_protocol
        if locked is not None:
            self._values["locked"] = locked
        if mobile_default_choice is not None:
            self._values["mobile_default_choice"] = mobile_default_choice
        if query_string is not None:
            self._values["query_string"] = query_string
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination_hostname(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested hostname, independently from the pathname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname DataAkamaiPropertyRulesBuilder#destination_hostname}
        '''
        result = self._values.get("destination_hostname")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_other(self) -> typing.Optional[builtins.str]:
        '''Specifies the full hostname with which to replace the current hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_other DataAkamaiPropertyRulesBuilder#destination_hostname_other}
        '''
        result = self._values.get("destination_hostname_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_sibling(self) -> typing.Optional[builtins.str]:
        '''Specifies the subdomain with which to replace to the current hostname's leftmost subdomain.

        For example, a value of ``m`` changes ``www.example.com`` to ``m.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_sibling DataAkamaiPropertyRulesBuilder#destination_hostname_sibling}
        '''
        result = self._values.get("destination_hostname_sibling")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_hostname_subdomain(self) -> typing.Optional[builtins.str]:
        '''Specifies a subdomain to prepend to the current hostname. For example, a value of ``m`` changes ``www.example.com`` to ``m.www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_hostname_subdomain DataAkamaiPropertyRulesBuilder#destination_hostname_subdomain}
        '''
        result = self._values.get("destination_hostname_subdomain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path(self) -> typing.Optional[builtins.str]:
        '''Specify how to change the requested pathname, independently from the hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path DataAkamaiPropertyRulesBuilder#destination_path}
        '''
        result = self._values.get("destination_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_other(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this replaces the current path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_other DataAkamaiPropertyRulesBuilder#destination_path_other}
        '''
        result = self._values.get("destination_path_other")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_prefix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this prepends the current path.

        For example, a value of ``/prefix/path`` changes ``/example/index.html`` to ``/prefix/path/example/index.html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_prefix DataAkamaiPropertyRulesBuilder#destination_path_prefix}
        '''
        result = self._values.get("destination_path_prefix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST`` and ``destinationPathSuffixStatus`` is set to ``SUFFIX``, this specifies the suffix to append to the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix DataAkamaiPropertyRulesBuilder#destination_path_suffix}
        '''
        result = self._values.get("destination_path_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_path_suffix_status(self) -> typing.Optional[builtins.str]:
        '''When ``destinationPath`` is set to ``PREFIX_REQUEST``, this gives you the option of adding a suffix.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_path_suffix_status DataAkamaiPropertyRulesBuilder#destination_path_suffix_status}
        '''
        result = self._values.get("destination_path_suffix_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def destination_protocol(self) -> typing.Optional[builtins.str]:
        '''Choose the protocol for the redirect URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination_protocol DataAkamaiPropertyRulesBuilder#destination_protocol}
        '''
        result = self._values.get("destination_protocol")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def mobile_default_choice(self) -> typing.Optional[builtins.str]:
        '''Either specify a default response for mobile browsers, or customize your own.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#mobile_default_choice DataAkamaiPropertyRulesBuilder#mobile_default_choice}
        '''
        result = self._values.get("mobile_default_choice")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_string(self) -> typing.Optional[builtins.str]:
        '''When set to ``APPEND``, passes incoming query string parameters as part of the redirect URL.

        Otherwise set this to ``IGNORE``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string DataAkamaiPropertyRulesBuilder#query_string}
        '''
        result = self._values.get("query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Specify the redirect's response code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0fa21fdec7ea650ecbd4f4c03044c3993110bfcaa4c967b497731276feb7f4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestinationHostname")
    def reset_destination_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostname", []))

    @jsii.member(jsii_name="resetDestinationHostnameOther")
    def reset_destination_hostname_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameOther", []))

    @jsii.member(jsii_name="resetDestinationHostnameSibling")
    def reset_destination_hostname_sibling(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSibling", []))

    @jsii.member(jsii_name="resetDestinationHostnameSubdomain")
    def reset_destination_hostname_subdomain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationHostnameSubdomain", []))

    @jsii.member(jsii_name="resetDestinationPath")
    def reset_destination_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPath", []))

    @jsii.member(jsii_name="resetDestinationPathOther")
    def reset_destination_path_other(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathOther", []))

    @jsii.member(jsii_name="resetDestinationPathPrefix")
    def reset_destination_path_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathPrefix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffix")
    def reset_destination_path_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffix", []))

    @jsii.member(jsii_name="resetDestinationPathSuffixStatus")
    def reset_destination_path_suffix_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationPathSuffixStatus", []))

    @jsii.member(jsii_name="resetDestinationProtocol")
    def reset_destination_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestinationProtocol", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMobileDefaultChoice")
    def reset_mobile_default_choice(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMobileDefaultChoice", []))

    @jsii.member(jsii_name="resetQueryString")
    def reset_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryString", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameInput")
    def destination_hostname_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOtherInput")
    def destination_hostname_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSiblingInput")
    def destination_hostname_sibling_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSiblingInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomainInput")
    def destination_hostname_subdomain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationHostnameSubdomainInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathInput")
    def destination_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathOtherInput")
    def destination_path_other_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathOtherInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefixInput")
    def destination_path_prefix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathPrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixInput")
    def destination_path_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatusInput")
    def destination_path_suffix_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationPathSuffixStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationProtocolInput")
    def destination_protocol_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoiceInput")
    def mobile_default_choice_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mobileDefaultChoiceInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringInput")
    def query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destinationHostname")
    def destination_hostname(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostname"))

    @destination_hostname.setter
    def destination_hostname(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55f9df4a025f6692af0eca71d9162cdd5b31f3a913ec8bd4c07bbf2cc5a7a6f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostname", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameOther")
    def destination_hostname_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameOther"))

    @destination_hostname_other.setter
    def destination_hostname_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__64654981abaa6c9c334487c6305631c680b514345ceaaac0b25b9f54d4c4e6cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSibling")
    def destination_hostname_sibling(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSibling"))

    @destination_hostname_sibling.setter
    def destination_hostname_sibling(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd05a01f4d2b74ee0947a03c51ec8f6e5bb2cf4f7bd98cebe83db3ef7f531e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSibling", value)

    @builtins.property
    @jsii.member(jsii_name="destinationHostnameSubdomain")
    def destination_hostname_subdomain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationHostnameSubdomain"))

    @destination_hostname_subdomain.setter
    def destination_hostname_subdomain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0997003ae6986e43ae9b57a915ac9811cffb0fe13329c04c0694eca99009781)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationHostnameSubdomain", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPath")
    def destination_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPath"))

    @destination_path.setter
    def destination_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33b7289720ac8f7c6aa4bc1cf755c3d82f0d6a1b5a457633e48bec9c6288f3d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPath", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathOther")
    def destination_path_other(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathOther"))

    @destination_path_other.setter
    def destination_path_other(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3d3ca0a0bd456ed4921217b6b6a5b86098ab4531389e593302a1f4382072f78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathOther", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathPrefix")
    def destination_path_prefix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathPrefix"))

    @destination_path_prefix.setter
    def destination_path_prefix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__de7f280652b9953838f4f9d807e7c30a881d5770f746840ff108c83f028e0808)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathPrefix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffix")
    def destination_path_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffix"))

    @destination_path_suffix.setter
    def destination_path_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d149340c38053f44a9b3727640485788bc83916875007f51e51349aa021bda2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="destinationPathSuffixStatus")
    def destination_path_suffix_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationPathSuffixStatus"))

    @destination_path_suffix_status.setter
    def destination_path_suffix_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a02fd141f29ed95719bbd939dd40d1ac371697b0da1ed0f549d8f2bbbf64100f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationPathSuffixStatus", value)

    @builtins.property
    @jsii.member(jsii_name="destinationProtocol")
    def destination_protocol(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destinationProtocol"))

    @destination_protocol.setter
    def destination_protocol(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__282e475ac6bb1b4d5c3a7ebee4087f6ab8ecf46603f5fcfa5b2fed63e6933a43)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destinationProtocol", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acc61f6de412812ba3a981073c08ea3f3eb40225d8edbca1c7f2968e88b97695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mobileDefaultChoice")
    def mobile_default_choice(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mobileDefaultChoice"))

    @mobile_default_choice.setter
    def mobile_default_choice(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbac1d31f9269e56ebc077e37c1c06077af9c7e9e50ae9f2392786d16bc1bbfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mobileDefaultChoice", value)

    @builtins.property
    @jsii.member(jsii_name="queryString")
    def query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryString"))

    @query_string.setter
    def query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11085587cc4faa0c9c1086ba4b81ee411386dbb76aab5cd96b86c209b1059651)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryString", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e79b4dc35b232ddd2d2dae1b5beeedd9e25288c998ded017ab2cc464d2df181e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a048ef79ab11de9b041d772eb77975dccca799dd01da0b09aa56c5ef2c40812c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c59037bf99149f3731a1ad763c310313f523bc14aed54d82c1efb7171890c1b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__11adef81b52623dee161ed7aaedb1696c5a2c4596b424225e7b38ba5edd592b1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus",
    jsii_struct_bases=[],
    name_mapping={
        "destination": "destination",
        "enabled": "enabled",
        "locked": "locked",
        "response_code": "responseCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus:
    def __init__(
        self,
        *,
        destination: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param destination: Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL. Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        :param enabled: Enables the redirect feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_code: Assigns the status code for the redirect response. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed3581843e69b4fa941b74ff857012db00045869d2c300867301eda5e491d100)
            check_type(argname="argument destination", value=destination, expected_type=type_hints["destination"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_code", value=response_code, expected_type=type_hints["response_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if destination is not None:
            self._values["destination"] = destination
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if response_code is not None:
            self._values["response_code"] = response_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def destination(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect as a path expression starting with a ``/`` character relative to the current root, or as a fully qualified URL.

        Optionally inject variables, as in this example that refers to the original request's filename: ``/path/to/{{builtin.AK_FILENAME}}``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#destination DataAkamaiPropertyRulesBuilder#destination}
        '''
        result = self._values.get("destination")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the redirect feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_code(self) -> typing.Optional[jsii.Number]:
        '''Assigns the status code for the redirect response.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_code DataAkamaiPropertyRulesBuilder#response_code}
        '''
        result = self._values.get("response_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2355162cf49bc218954789069acbbbf746fea7d1b69627e2c4c87beb81b8fc3b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDestination")
    def reset_destination(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDestination", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseCode")
    def reset_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="destinationInput")
    def destination_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "destinationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseCodeInput")
    def response_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "responseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="destination")
    def destination(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "destination"))

    @destination.setter
    def destination(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c6ae855e209507bfca7a4ae48174cdfb8cf226feedb6bf24ec9b03b625754f3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "destination", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd7ec13402bf25d59aec1103ea66589bb1f234541ffa895a0222c453e73061e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f2e27740d734474e8f661d9fcb0e70fc586781750923d8b46a26b2562b26ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseCode")
    def response_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "responseCode"))

    @response_code.setter
    def response_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a26117170415278cf87212d6b4959b204b51c4f094346ddbcd1690ed04b6e421)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fd108f9588cee48c2d911bb6bf9964dfc53a76838d72585e973e5f5b053f752)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5ca4f9d7d9dbd719f2644e8e2fa8e3c215f6bff57d0a432989c7feb5c96ebd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c21f1c4f953aa91976a77841c1279c16cddf10efa89a8f6c0f5b0dbc87e6c1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking",
    jsii_struct_bases=[],
    name_mapping={
        "allow_children": "allowChildren",
        "domains": "domains",
        "enabled": "enabled",
        "locked": "locked",
        "strict": "strict",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking:
    def __init__(
        self,
        *,
        allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domains: typing.Optional[typing.Sequence[builtins.str]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_children: Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        :param domains: Specifies the set of allowed domains. With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        :param enabled: Enables the referer-checking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict: When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``. When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__157c9dfcf593309d2b11174f073b2bfeeecfc70f89bf25ffef0897a7940b721d)
            check_type(argname="argument allow_children", value=allow_children, expected_type=type_hints["allow_children"])
            check_type(argname="argument domains", value=domains, expected_type=type_hints["domains"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict", value=strict, expected_type=type_hints["strict"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_children is not None:
            self._values["allow_children"] = allow_children
        if domains is not None:
            self._values["domains"] = domains
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if strict is not None:
            self._values["strict"] = strict
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_children(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows all subdomains for the ``domains`` set, just like adding a ``*.`` prefix to each.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_children DataAkamaiPropertyRulesBuilder#allow_children}
        '''
        result = self._values.get("allow_children")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domains(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of allowed domains.

        With ``allowChildren`` disabled, prefixing values with ``*.`` specifies domains for which subdomains are allowed.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domains DataAkamaiPropertyRulesBuilder#domains}
        '''
        result = self._values.get("domains")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the referer-checking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, excludes requests whose ``Referer`` header include a relative path, or that are missing a ``Referer``.

        When disabled, only excludes requests whose ``Referer`` hostname is not part of the ``domains`` set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict DataAkamaiPropertyRulesBuilder#strict}
        '''
        result = self._values.get("strict")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererCheckingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererCheckingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dccf7f5940a0a2fea564a5bea6dc359f92290b65fdddb81a95007cc82f8aa1ee)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowChildren")
    def reset_allow_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowChildren", []))

    @jsii.member(jsii_name="resetDomains")
    def reset_domains(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomains", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrict")
    def reset_strict(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrict", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowChildrenInput")
    def allow_children_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowChildrenInput"))

    @builtins.property
    @jsii.member(jsii_name="domainsInput")
    def domains_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "domainsInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictInput")
    def strict_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowChildren")
    def allow_children(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowChildren"))

    @allow_children.setter
    def allow_children(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f425e6550ee595dced1535e5858b6100e4c29b5c0f9ebf615a2a343d55db838)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowChildren", value)

    @builtins.property
    @jsii.member(jsii_name="domains")
    def domains(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "domains"))

    @domains.setter
    def domains(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421bc8adc6f3f0ac60fe61e12d6603449e625d568c9ad5fe65e4fb9aab4a5430)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domains", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa07a258cd66784a9f7f1b450103e33234d47789639d1d0bed4f90506aeb78c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a97557251ee1d429493be2535fbbb6cd4a9c3b7eded362979eb5c00a29a58b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strict")
    def strict(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strict"))

    @strict.setter
    def strict(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e1890f2df74be216e982f97f54f3dbcad392251493ef3a90f101377aeefc69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strict", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51b51465988588a1fb29877b1581bab8db02e64680e3febed023433b94eb2438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__024cc821bddc319dedda8f03dbc0985e199b371a20a5fbddacf760482b84c9a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58db347810ca8d1075cf4d1727c37391d4ef00be365ddec71d6082c45b5918f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "parameters": "parameters",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param parameters: Specifies parameters to remove from the request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b14437612fe5d82abdd55c27fe146d535c5a6e052f671c32b667457601eae04)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument parameters", value=parameters, expected_type=type_hints["parameters"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if parameters is not None:
            self._values["parameters"] = parameters
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameters(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies parameters to remove from the request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameters DataAkamaiPropertyRulesBuilder#parameters}
        '''
        result = self._values.get("parameters")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7321013826967a5011ea3c16115aca62c7e2a7d0187ea278e5de2b3e9fbca5f0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetParameters")
    def reset_parameters(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameters", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="parametersInput")
    def parameters_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "parametersInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e76c7229f443265b2d163241e4b5637de7f081792523151890aedd38b812c8c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="parameters")
    def parameters(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "parameters"))

    @parameters.setter
    def parameters(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ef3268db56bac9eef623dda19cfcd08f69f7aa2e83a59bfe373a1e56a83c55f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameters", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3545e2aac7736338511384f8d942ebea649aa3d20af2ca3ac1a248519ec07bb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9958fe35ce85812d22954eb1fdf772741697dea5d60a46171b2b722b49cb2cbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7eb66567edd5c15f2ea889c69d9fd8109a92d2f66c2373c19117d13e52cf69da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, removes the ``Vary`` header to ensure objects can be cached. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5fa197c80733ebae3ba9a61320359c3f086cf31c1b408811858e2f794db09f26)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, removes the ``Vary`` header to ensure objects can be cached.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVaryOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVaryOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__26172127b94bc54b31d3757f63d874f8a81b1375210e9711b244ae8fb96599dd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa14fdd511369e2de8402e466c851e826588459b9ef77c0609aff95bb4bd2d58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7bdcea847753dad446ca0ad8f965ddd24e1d1dc6b00fe9585da73d4f338fbc29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0ef2c355d19030925adc3e73734620750a30bb3421d3a57764c54617ac1d43d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f93e77e810aa33e657d71f4506102c59e2ee394fb9d57be29172fa6a1b283aec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b12c55574f696ebbe215e146b811541d3dc5b50f59b0d36c2af11ae98e2b6cb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport",
    jsii_struct_bases=[],
    name_mapping={
        "cookies": "cookies",
        "custom_log_field": "customLogField",
        "locked": "locked",
        "log_accept_language": "logAcceptLanguage",
        "log_cookies": "logCookies",
        "log_custom_log_field": "logCustomLogField",
        "log_edge_ip": "logEdgeIp",
        "log_host": "logHost",
        "log_referer": "logReferer",
        "log_user_agent": "logUserAgent",
        "log_x_forwarded_for": "logXForwardedFor",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport:
    def __init__(
        self,
        *,
        cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
        custom_log_field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_cookies: typing.Optional[builtins.str] = None,
        log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookies: This specifies the set of cookies names whose values you want to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        :param custom_log_field: Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable. For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param log_accept_language: Log the ``Accept-Language`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        :param log_cookies: Specifies the set of cookies to log. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        :param log_custom_log_field: Whether to append additional custom data to each log line. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        :param log_edge_ip: Whether to log the IP address of the Akamai edge server that served the response to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        :param log_host: Log the ``Host`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        :param log_referer: Log the ``Referer`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        :param log_user_agent: Log the ``User-Agent`` header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        :param log_x_forwarded_for: Log any ``X-Forwarded-For`` request header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9feeee19886a94b4afd0f952b0ee22830c07031d3f5864d5db94dc95bc51bda0)
            check_type(argname="argument cookies", value=cookies, expected_type=type_hints["cookies"])
            check_type(argname="argument custom_log_field", value=custom_log_field, expected_type=type_hints["custom_log_field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument log_accept_language", value=log_accept_language, expected_type=type_hints["log_accept_language"])
            check_type(argname="argument log_cookies", value=log_cookies, expected_type=type_hints["log_cookies"])
            check_type(argname="argument log_custom_log_field", value=log_custom_log_field, expected_type=type_hints["log_custom_log_field"])
            check_type(argname="argument log_edge_ip", value=log_edge_ip, expected_type=type_hints["log_edge_ip"])
            check_type(argname="argument log_host", value=log_host, expected_type=type_hints["log_host"])
            check_type(argname="argument log_referer", value=log_referer, expected_type=type_hints["log_referer"])
            check_type(argname="argument log_user_agent", value=log_user_agent, expected_type=type_hints["log_user_agent"])
            check_type(argname="argument log_x_forwarded_for", value=log_x_forwarded_for, expected_type=type_hints["log_x_forwarded_for"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookies is not None:
            self._values["cookies"] = cookies
        if custom_log_field is not None:
            self._values["custom_log_field"] = custom_log_field
        if locked is not None:
            self._values["locked"] = locked
        if log_accept_language is not None:
            self._values["log_accept_language"] = log_accept_language
        if log_cookies is not None:
            self._values["log_cookies"] = log_cookies
        if log_custom_log_field is not None:
            self._values["log_custom_log_field"] = log_custom_log_field
        if log_edge_ip is not None:
            self._values["log_edge_ip"] = log_edge_ip
        if log_host is not None:
            self._values["log_host"] = log_host
        if log_referer is not None:
            self._values["log_referer"] = log_referer
        if log_user_agent is not None:
            self._values["log_user_agent"] = log_user_agent
        if log_x_forwarded_for is not None:
            self._values["log_x_forwarded_for"] = log_x_forwarded_for
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cookies(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the set of cookies names whose values you want to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookies DataAkamaiPropertyRulesBuilder#cookies}
        '''
        result = self._values.get("cookies")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def custom_log_field(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional data field to append to each log line, maximum 1000 bytes, typically based on a dynamically generated built-in system variable.

        For example, ``round-trip: {{builtin.AK_CLIENT_TURNAROUND_TIME}}ms`` logs the total time to complete the response. See ``Support for variables`` for more information. If you enable the ``logCustom`` behavior, it overrides the ``customLogField`` option.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_log_field DataAkamaiPropertyRulesBuilder#custom_log_field}
        '''
        result = self._values.get("custom_log_field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_accept_language(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Accept-Language`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_accept_language DataAkamaiPropertyRulesBuilder#log_accept_language}
        '''
        result = self._values.get("log_accept_language")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_cookies(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of cookies to log.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_cookies DataAkamaiPropertyRulesBuilder#log_cookies}
        '''
        result = self._values.get("log_cookies")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def log_custom_log_field(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to append additional custom data to each log line.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_custom_log_field DataAkamaiPropertyRulesBuilder#log_custom_log_field}
        '''
        result = self._values.get("log_custom_log_field")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_edge_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to log the IP address of the Akamai edge server that served the response to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_edge_ip DataAkamaiPropertyRulesBuilder#log_edge_ip}
        '''
        result = self._values.get("log_edge_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_host(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Host`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_host DataAkamaiPropertyRulesBuilder#log_host}
        '''
        result = self._values.get("log_host")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_referer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``Referer`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_referer DataAkamaiPropertyRulesBuilder#log_referer}
        '''
        result = self._values.get("log_referer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_user_agent(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log the ``User-Agent`` header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_user_agent DataAkamaiPropertyRulesBuilder#log_user_agent}
        '''
        result = self._values.get("log_user_agent")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def log_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Log any ``X-Forwarded-For`` request header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#log_x_forwarded_for DataAkamaiPropertyRulesBuilder#log_x_forwarded_for}
        '''
        result = self._values.get("log_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReportOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReportOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98a464135a63e06dc9a6cb1e8008c4a0103be45df0f0d4714e7431b8cd702428)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookies")
    def reset_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookies", []))

    @jsii.member(jsii_name="resetCustomLogField")
    def reset_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomLogField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLogAcceptLanguage")
    def reset_log_accept_language(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogAcceptLanguage", []))

    @jsii.member(jsii_name="resetLogCookies")
    def reset_log_cookies(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCookies", []))

    @jsii.member(jsii_name="resetLogCustomLogField")
    def reset_log_custom_log_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogCustomLogField", []))

    @jsii.member(jsii_name="resetLogEdgeIp")
    def reset_log_edge_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogEdgeIp", []))

    @jsii.member(jsii_name="resetLogHost")
    def reset_log_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogHost", []))

    @jsii.member(jsii_name="resetLogReferer")
    def reset_log_referer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogReferer", []))

    @jsii.member(jsii_name="resetLogUserAgent")
    def reset_log_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogUserAgent", []))

    @jsii.member(jsii_name="resetLogXForwardedFor")
    def reset_log_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLogXForwardedFor", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cookiesInput")
    def cookies_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "cookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="customLogFieldInput")
    def custom_log_field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguageInput")
    def log_accept_language_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logAcceptLanguageInput"))

    @builtins.property
    @jsii.member(jsii_name="logCookiesInput")
    def log_cookies_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "logCookiesInput"))

    @builtins.property
    @jsii.member(jsii_name="logCustomLogFieldInput")
    def log_custom_log_field_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logCustomLogFieldInput"))

    @builtins.property
    @jsii.member(jsii_name="logEdgeIpInput")
    def log_edge_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logEdgeIpInput"))

    @builtins.property
    @jsii.member(jsii_name="logHostInput")
    def log_host_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logHostInput"))

    @builtins.property
    @jsii.member(jsii_name="logRefererInput")
    def log_referer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logRefererInput"))

    @builtins.property
    @jsii.member(jsii_name="logUserAgentInput")
    def log_user_agent_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logUserAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="logXForwardedForInput")
    def log_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "logXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cookies")
    def cookies(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "cookies"))

    @cookies.setter
    def cookies(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f938a535c0436910243fc5052a5430ae7ec96d27766bafa05fb9555162ce2eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookies", value)

    @builtins.property
    @jsii.member(jsii_name="customLogField")
    def custom_log_field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customLogField"))

    @custom_log_field.setter
    def custom_log_field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3be4ad3185e0c4d318844befa391076f1279718437bfecafd7120b6a8813bb10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customLogField", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a4a6f7069149151d65aa98ac44f324e1aa356cbf3c3d7e48cbfabf36beca7d7f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="logAcceptLanguage")
    def log_accept_language(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logAcceptLanguage"))

    @log_accept_language.setter
    def log_accept_language(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47a194c42613258213ae47583d40df00daf73ca0bd1da0363bb7dd425fea19df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logAcceptLanguage", value)

    @builtins.property
    @jsii.member(jsii_name="logCookies")
    def log_cookies(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "logCookies"))

    @log_cookies.setter
    def log_cookies(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac7fba0a1cf55d15c0a0ad9a2f437544f7788508bf8d22c3e562737dec968a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCookies", value)

    @builtins.property
    @jsii.member(jsii_name="logCustomLogField")
    def log_custom_log_field(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logCustomLogField"))

    @log_custom_log_field.setter
    def log_custom_log_field(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b05d199298964fb854552e5ab3fc9f7077b008b6631c862364ef306d24f5512e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logCustomLogField", value)

    @builtins.property
    @jsii.member(jsii_name="logEdgeIp")
    def log_edge_ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logEdgeIp"))

    @log_edge_ip.setter
    def log_edge_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb989ed3610f4b1c228c34ecd1c7d88c17ec7916ac7ef4da44b66d4e7065094)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logEdgeIp", value)

    @builtins.property
    @jsii.member(jsii_name="logHost")
    def log_host(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logHost"))

    @log_host.setter
    def log_host(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__28c06dcb5179b33b5b4e25697cdf926cb393e7a638e89fce772b9806d8b214f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logHost", value)

    @builtins.property
    @jsii.member(jsii_name="logReferer")
    def log_referer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logReferer"))

    @log_referer.setter
    def log_referer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c72cdc0df9a29a10fa6bf325b871282e025e18fcdfd7af8bc78fa84c8f191679)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logReferer", value)

    @builtins.property
    @jsii.member(jsii_name="logUserAgent")
    def log_user_agent(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logUserAgent"))

    @log_user_agent.setter
    def log_user_agent(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6ffe1f78efb5bb44f49b6bde38b3047b89aa0f3273d6def27876b5fdfef8129)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logUserAgent", value)

    @builtins.property
    @jsii.member(jsii_name="logXForwardedFor")
    def log_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "logXForwardedFor"))

    @log_x_forwarded_for.setter
    def log_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__728367df451ea98d2390802c0249e1583da72751329784b8e22563f454decb57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "logXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5aa827d4ef02eb167045c56b4362cbc0a7c3f35e652fbaf975979271c047d98a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61d757834a4eb7244b2acc5b5aab1e58a7f74098eb6b382cb7d2770631136fc3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccd620385827120caa5c852fab87848f350f8d3b151e87394f365da946e48722)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints",
    jsii_struct_bases=[],
    name_mapping={
        "accept_ch": "acceptCh",
        "accept_critical_ch": "acceptCriticalCh",
        "locked": "locked",
        "reset": "reset",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints:
    def __init__(
        self,
        *,
        accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param accept_ch: The client hint data objects you want to receive from the browser. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        :param accept_critical_ch: The critical client hint data objects you want to receive from the browser. The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param reset: This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser. This empty header doesn't get merged with other objects sent from your origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9d2d168e4298a2822e6897e12b839262e4c176b31b5156b6494f6ca1b85c16b)
            check_type(argname="argument accept_ch", value=accept_ch, expected_type=type_hints["accept_ch"])
            check_type(argname="argument accept_critical_ch", value=accept_critical_ch, expected_type=type_hints["accept_critical_ch"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument reset", value=reset, expected_type=type_hints["reset"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if accept_ch is not None:
            self._values["accept_ch"] = accept_ch
        if accept_critical_ch is not None:
            self._values["accept_critical_ch"] = accept_critical_ch
        if locked is not None:
            self._values["locked"] = locked
        if reset is not None:
            self._values["reset"] = reset
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def accept_ch(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The client hint data objects you want to receive from the browser.

        You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior. If you've configured your origin server to pass along data objects, they merge with the ones you set in this array, before the list is sent to the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_ch DataAkamaiPropertyRulesBuilder#accept_ch}
        '''
        result = self._values.get("accept_ch")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def accept_critical_ch(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The critical client hint data objects you want to receive from the browser.

        The original request from the browser needs to include these objects. Otherwise, a new response header is sent back to the client, asking for all of these client hint data objects. You can add custom entries or provide pre-set values from the list. For more details on each value, see the ``guide section`` for this behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#accept_critical_ch DataAkamaiPropertyRulesBuilder#accept_critical_ch}
        '''
        result = self._values.get("accept_critical_ch")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def reset(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''This sends an empty instance of the ``Accept-CH`` response header to clear other ``Accept-CH`` values currently stored in the client browser.

        This empty header doesn't get merged with other objects sent from your origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#reset DataAkamaiPropertyRulesBuilder#reset}
        '''
        result = self._values.get("reset")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHintsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHintsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c60105281b496898ab48b95c2ad41a568cee6376c5f14c5d12f389a0940559e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcceptCh")
    def reset_accept_ch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcceptCh", []))

    @jsii.member(jsii_name="resetAcceptCriticalCh")
    def reset_accept_critical_ch(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcceptCriticalCh", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetReset")
    def reset_reset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReset", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="acceptChInput")
    def accept_ch_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "acceptChInput"))

    @builtins.property
    @jsii.member(jsii_name="acceptCriticalChInput")
    def accept_critical_ch_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "acceptCriticalChInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resetInput")
    def reset_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resetInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acceptCh")
    def accept_ch(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "acceptCh"))

    @accept_ch.setter
    def accept_ch(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0a4cafa0ae2c6b83b7b8842ae726177e35e51e9da043d3f03f281fc1f81dbd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acceptCh", value)

    @builtins.property
    @jsii.member(jsii_name="acceptCriticalCh")
    def accept_critical_ch(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "acceptCriticalCh"))

    @accept_critical_ch.setter
    def accept_critical_ch(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b48589ab689675821bccd500f8ddf53526696d6ec966b4abbcccf8ca82c179a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acceptCriticalCh", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__04c29dfa29ca4d4977cce2e99dcedfd4a715c064f7e1a20c8ee1b7a11041684e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="reset")
    def reset(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "reset"))

    @reset.setter
    def reset(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b219d16e663e214628d8960a75bf3545c250806eef19b84e863505b804173b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "reset", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d7bcc5637391853c93093f3bf36ebf106e538b79898a32c7d061f38dea3fde3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c88cf72580ce34a9b163e141a323a0fa167b84f3adbda7810046ced1ebfe3827)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39947c7d67b707c71d6a3d322f43c327eff86fe507028ce42930acf43a55dbdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl",
    jsii_struct_bases=[],
    name_mapping={
        "branded403_file": "branded403File",
        "branded403_status_code": "branded403StatusCode",
        "branded403_url": "branded403Url",
        "branded_deny_cache_ttl": "brandedDenyCacheTtl",
        "cloudlet_policy": "cloudletPolicy",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "enable_branded403": "enableBranded403",
        "enabled": "enabled",
        "is_shared_policy": "isSharedPolicy",
        "locked": "locked",
        "net_storage": "netStorage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl:
    def __init__(
        self,
        *,
        branded403_file: typing.Optional[builtins.str] = None,
        branded403_status_code: typing.Optional[jsii.Number] = None,
        branded403_url: typing.Optional[builtins.str] = None,
        branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param branded403_file: Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        :param branded403_status_code: Specifies the response status code for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        :param branded403_url: Specifies the redirect URL for the branded deny action. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        :param branded_deny_cache_ttl: Specifies the branded response page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param cloudlet_shared_policy: Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param enable_branded403: If enabled, serves a branded 403 page for this Cloudlet instance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        :param enabled: Enables the Request Control Cloudlet. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_shared_policy: Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account. Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param net_storage: net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy(**cloudlet_policy)
        if isinstance(net_storage, dict):
            net_storage = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage(**net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e33529cd55131a5ad93a11bf42a099bbce081d484d961de6516bf98e37803528)
            check_type(argname="argument branded403_file", value=branded403_file, expected_type=type_hints["branded403_file"])
            check_type(argname="argument branded403_status_code", value=branded403_status_code, expected_type=type_hints["branded403_status_code"])
            check_type(argname="argument branded403_url", value=branded403_url, expected_type=type_hints["branded403_url"])
            check_type(argname="argument branded_deny_cache_ttl", value=branded_deny_cache_ttl, expected_type=type_hints["branded_deny_cache_ttl"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument enable_branded403", value=enable_branded403, expected_type=type_hints["enable_branded403"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_shared_policy", value=is_shared_policy, expected_type=type_hints["is_shared_policy"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument net_storage", value=net_storage, expected_type=type_hints["net_storage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if branded403_file is not None:
            self._values["branded403_file"] = branded403_file
        if branded403_status_code is not None:
            self._values["branded403_status_code"] = branded403_status_code
        if branded403_url is not None:
            self._values["branded403_url"] = branded403_url
        if branded_deny_cache_ttl is not None:
            self._values["branded_deny_cache_ttl"] = branded_deny_cache_ttl
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if enable_branded403 is not None:
            self._values["enable_branded403"] = enable_branded403
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_shared_policy is not None:
            self._values["is_shared_policy"] = is_shared_policy
        if locked is not None:
            self._values["locked"] = locked
        if net_storage is not None:
            self._values["net_storage"] = net_storage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def branded403_file(self) -> typing.Optional[builtins.str]:
        '''Specifies the full path of the branded 403 page, including the filename, but excluding the NetStorage CP code path component.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_file DataAkamaiPropertyRulesBuilder#branded403_file}
        '''
        result = self._values.get("branded403_file")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded403_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response status code for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_status_code DataAkamaiPropertyRulesBuilder#branded403_status_code}
        '''
        result = self._values.get("branded403_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def branded403_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the redirect URL for the branded deny action.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded403_url DataAkamaiPropertyRulesBuilder#branded403_url}
        '''
        result = self._values.get("branded403_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def branded_deny_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the branded response page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#branded_deny_cache_ttl DataAkamaiPropertyRulesBuilder#branded_deny_cache_ttl}
        '''
        result = self._values.get("branded_deny_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy"], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''Identifies the Cloudlet shared policy to use with this behavior. Use the ``Cloudlets API`` to list available shared policies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def enable_branded403(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, serves a branded 403 page for this Cloudlet instance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_branded403 DataAkamaiPropertyRulesBuilder#enable_branded403}
        '''
        result = self._values.get("enable_branded403")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Request Control Cloudlet.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_shared_policy(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether you want to apply the Cloudlet shared policy to an unlimited number of properties within your account.

        Learn more about shared policies and how to create them in ``Cloudlets Policy Manager``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_shared_policy DataAkamaiPropertyRulesBuilder#is_shared_policy}
        '''
        result = self._values.get("is_shared_policy")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage"]:
        '''net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#net_storage DataAkamaiPropertyRulesBuilder#net_storage}
        '''
        result = self._values.get("net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ab2865e219a452c1020f7795c29c1cdabcbeac05f793267f575cac85b692b3a)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a260052204026eed1239527f289996fd694ef9f81eaf42afcb8c41d7d021ecc5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d591b268b286f54f34d321419938c75db5802bffe3478dd3b261a5d09b93bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c6c421d88aa1c0baa5a9d78709f580040e50e6012672d0e92952ae16c808a94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffee7effde2b9e1658a6c0272cf849ccc6ea25dc42cb106bf21265ec8d5a5dca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e900d939fd8a0032df2fd5ab01336341edaece29e662fd943318bc724f0f54fb)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7f12d291bb4fbf97d603d23993d597e4ba466a03652dd9694aed1b98e38eb66e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b6afb300f9a2c5a13166d6971f55b2a959c283cfd9e533216badac6d214708a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d93367f67821ac9eec59a3a8380252180d57d646bbc6f218fd1ed9694c636ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c61e22b058a6b559c5c32a8abe17a72a0a2f35bfbdad845b6e5ddba6b76105c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48ea57b9925d94c00a12fc3a3895a325418721e14331c88e46dcdbc8cb637b9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd001e89f71ef0dc85ce47d608b7c4bdea059434959dfbc5c08cc29431afb51e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putNetStorage")
    def put_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putNetStorage", [value]))

    @jsii.member(jsii_name="resetBranded403File")
    def reset_branded403_file(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403File", []))

    @jsii.member(jsii_name="resetBranded403StatusCode")
    def reset_branded403_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403StatusCode", []))

    @jsii.member(jsii_name="resetBranded403Url")
    def reset_branded403_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBranded403Url", []))

    @jsii.member(jsii_name="resetBrandedDenyCacheTtl")
    def reset_branded_deny_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBrandedDenyCacheTtl", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetEnableBranded403")
    def reset_enable_branded403(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableBranded403", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsSharedPolicy")
    def reset_is_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSharedPolicy", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNetStorage")
    def reset_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetStorage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="netStorage")
    def net_storage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorageOutputReference, jsii.get(self, "netStorage"))

    @builtins.property
    @jsii.member(jsii_name="branded403FileInput")
    def branded403_file_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403FileInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCodeInput")
    def branded403_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "branded403StatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403UrlInput")
    def branded403_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "branded403UrlInput"))

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtlInput")
    def branded_deny_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "brandedDenyCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableBranded403Input")
    def enable_branded403_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableBranded403Input"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicyInput")
    def is_shared_policy_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="netStorageInput")
    def net_storage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage], jsii.get(self, "netStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="branded403File")
    def branded403_file(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403File"))

    @branded403_file.setter
    def branded403_file(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b9dbdad89f09f61cc0768fe727942fe9eef19395ad9b0d61ad4a5ff05f57df4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403File", value)

    @builtins.property
    @jsii.member(jsii_name="branded403StatusCode")
    def branded403_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "branded403StatusCode"))

    @branded403_status_code.setter
    def branded403_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__197aea871d7e3a30974cec20be7367216993271a3e7bbae273f76af0090625bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403StatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="branded403Url")
    def branded403_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "branded403Url"))

    @branded403_url.setter
    def branded403_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621687331e56e1c6178b0033f47aa41f06f9d140c4cc09df3a718fc8be05f29d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "branded403Url", value)

    @builtins.property
    @jsii.member(jsii_name="brandedDenyCacheTtl")
    def branded_deny_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "brandedDenyCacheTtl"))

    @branded_deny_cache_ttl.setter
    def branded_deny_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7684f130addf74d682797fea66abc5912c33c08dbe1b661681bd6c1faafc2a1f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "brandedDenyCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a96772bff22cfbc781773510eeb4c30850466edd78c9d4c9621f6736a347f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="enableBranded403")
    def enable_branded403(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableBranded403"))

    @enable_branded403.setter
    def enable_branded403(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__756d62701a392ff68dd660e477324390fdf6d332bfd8697196fadc2d85563fca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableBranded403", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0785d6d276ef908a33b43f7b39d706ef48f817ebe48c24b0beacc07816982787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isSharedPolicy")
    def is_shared_policy(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSharedPolicy"))

    @is_shared_policy.setter
    def is_shared_policy(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d55389deb72c9599511c8b0a53302b956565edb9c7d9263f810e8441d74050fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__517c5eb53525a673e0aea7a58ffe2750ba02e284666a6e51b1840fa7cf4d84f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__764e1d4acfffad59550989f26d422c9db761373b169d266fa0ea1ed9f0270b2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c16d830850b4584d3ead3136217ff3a7a509e7e0aeffc3dce728c06639b03f15)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b827a88ec50aa9b77ce578264724baf71d2419b7d3349686417b9191600c65b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "request_type": "requestType",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        request_type: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param request_type: Specifies the type of request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41bebe3835859962222ec8984e87a61b47b4deb3d2332509d7c52a04ac1e7e7c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if request_type is not None:
            self._values["request_type"] = request_type
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def request_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarkerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarkerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf8dc83855d06652cc705cdc4768fe88436e918d4a19fb2df84fbac5f995d574)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6236313e19a5fa953b6c229408979c2457c116482a2cecf047fa3a340e7238d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "requestType"))

    @request_type.setter
    def request_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__574c950000bd639b833d19bedb4788ee27aa25573d6da66ea0011f7ac7a895d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "requestType", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cd7f2595cb13b1a5b6c7f956a6ebe2f8fec3fdf0ac77e5eb1a6ce07fd8f2776)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d7ea7604b3c3c6c31ea8fdd0624f3e315347ad0ada63423a4f41407e367be7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b693b88483a33863bc2c4f6acfb1850ad424b47926be4ce07011e732b3fc270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dfd3baec07818a9e51219b049361f326d0840584521251c7059fad0051354dfb)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility",
    jsii_struct_bases=[],
    name_mapping={
        "enable_all_features": "enableAllFeatures",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility:
    def __init__(
        self,
        *,
        enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_all_features: Enables ``additional support`` and error handling. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        :param enabled: Enables the Resource Optimizer feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e4ea898c527eab8938f0a8e70bef12cf35916b3ff1d660cf56a3a69e7932dfd)
            check_type(argname="argument enable_all_features", value=enable_all_features, expected_type=type_hints["enable_all_features"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_all_features is not None:
            self._values["enable_all_features"] = enable_all_features
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_all_features(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ``additional support`` and error handling.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_all_features DataAkamaiPropertyRulesBuilder#enable_all_features}
        '''
        result = self._values.get("enable_all_features")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Resource Optimizer feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6864a7565a9d34e9190e220b7ac8264263cd0dec11fb86506f2e7c0bdfbcd2b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableAllFeatures")
    def reset_enable_all_features(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableAllFeatures", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeaturesInput")
    def enable_all_features_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableAllFeaturesInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableAllFeatures")
    def enable_all_features(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableAllFeatures"))

    @enable_all_features.setter
    def enable_all_features(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e519003f1ebc49f5af57a1f3bcc96567623344e96021dbbe807f452fcd1d0bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableAllFeatures", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__945e89eaf7b830343b374a8f3b679674db1c8defbe8aad91ae8f85f4d8f7596c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ef86e0eac476187a7cea8969ab3b3e9ae6ec6c6e8c969a13fbf670d8e8d7364)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0014dee316922f7604387691082a30b33c892853cdff2896b4795845241047b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec873129e8a48b55bf63a769a3f6ca7ba570816d7ab1214e7dae9ce1afad7333)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1f833ef75c65cf314f7c9f632b18aadc2da70fb6ad35041c37b0075d791b8bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b95abf8a4c10658e3d4d940fc6bb7ba925aff43d1f3e0c091e4f6eb0004b0f5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__738fbda2fb4fc0b8e00b3ff120ebc862247f4357494e3ca235ad69b374daf0b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c12d2a5891ac29dcbbba8df922a1d23b98a9ccbd624ba4576e6d1fd677d57a88)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa74648c4695b8284c5751a6ba3e03092fdce3f7722fc91860647996bd14a922)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3839c6bac262402cd2a5c19a716f6b55945675e7850632432cc06e1a7c473b79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd408f51ee73c57487566526f0886989197e1ffc52ba73f6831fd2495e114547)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "override206": "override206",
        "status_code": "statusCode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        status_code: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param override206: Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        :param status_code: The HTTP status code to replace the existing one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b75ad94f5a9b5d53c07ddb75ff95aaaa16663ff51f63733208d14dd3a38e6147)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument override206", value=override206, expected_type=type_hints["override206"])
            check_type(argname="argument status_code", value=status_code, expected_type=type_hints["status_code"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if override206 is not None:
            self._values["override206"] = override206
        if status_code is not None:
            self._values["status_code"] = status_code
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def override206(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows any specified ``200`` success code to override a ``206`` partial-content code, in which case the response's content length matches the requested range length.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override206 DataAkamaiPropertyRulesBuilder#override206}
        '''
        result = self._values.get("override206")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def status_code(self) -> typing.Optional[jsii.Number]:
        '''The HTTP status code to replace the existing one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_code DataAkamaiPropertyRulesBuilder#status_code}
        '''
        result = self._values.get("status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7ba650557db62564ec8bf1c8c5ab0581abf597178675fbc0d518478540b506)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOverride206")
    def reset_override206(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverride206", []))

    @jsii.member(jsii_name="resetStatusCode")
    def reset_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusCode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="override206Input")
    def override206_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "override206Input"))

    @builtins.property
    @jsii.member(jsii_name="statusCodeInput")
    def status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "statusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f691ac214e4c48acb50f8e9f735d2e474ef4717abd3bde3789843edd3a96b96d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="override206")
    def override206(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "override206"))

    @override206.setter
    def override206(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b3feca4f49734dc19cf5cf97a21b47ab357cb327240dbaae1e9ed4658fc2a65)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "override206", value)

    @builtins.property
    @jsii.member(jsii_name="statusCode")
    def status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "statusCode"))

    @status_code.setter
    def status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ddd336050f07e85404105c35e134b0aeda746500290253c851cbf05caea8837b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusCode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18bd5c0e55f2438459404668d56a62185fdb0b5a414aa5bf0dc8c30232ed4371)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0564094ae540cf92cd410937f9e01fc98ce69c585c7069ab2fe80cfb22df746)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__584518c1946aad7b97d952e4f4a772b4b114a4d6bef0afeba2782a5322c3e638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "default_domain": "defaultDomain",
        "default_path": "defaultPath",
        "domain": "domain",
        "duration": "duration",
        "enabled": "enabled",
        "expiration_date": "expirationDate",
        "expires": "expires",
        "format": "format",
        "http_only": "httpOnly",
        "locked": "locked",
        "path": "path",
        "same_site": "sameSite",
        "secure": "secure",
        "template_uuid": "templateUuid",
        "type": "type",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        domain: typing.Optional[builtins.str] = None,
        duration: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        expiration_date: typing.Optional[builtins.str] = None,
        expires: typing.Optional[builtins.str] = None,
        format: typing.Optional[builtins.str] = None,
        http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        path: typing.Optional[builtins.str] = None,
        same_site: typing.Optional[builtins.str] = None,
        secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: Specifies the name of the cookie, which serves as a key to determine if the cookie is set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param default_domain: When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        :param default_path: When enabled, uses the default path value, otherwise the set specified in the ``path`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        :param domain: If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid. For example, ``example.com`` makes the cookie valid for that hostname and all subdomains. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        :param duration: If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        :param enabled: Allows you to set a response cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param expiration_date: If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        :param expires: Sets various ways to specify when the cookie expires. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        :param format: When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        :param http_only: When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param path: If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param same_site: This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        :param secure: When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param type: What type of value to assign. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: If the cookie ``type`` is ``FIXED``, this specifies the cookie value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8aa885de3c307a1c4586dd3802f025eb3f028eb74d8267f2af3bf29863de09)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument default_domain", value=default_domain, expected_type=type_hints["default_domain"])
            check_type(argname="argument default_path", value=default_path, expected_type=type_hints["default_path"])
            check_type(argname="argument domain", value=domain, expected_type=type_hints["domain"])
            check_type(argname="argument duration", value=duration, expected_type=type_hints["duration"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument expiration_date", value=expiration_date, expected_type=type_hints["expiration_date"])
            check_type(argname="argument expires", value=expires, expected_type=type_hints["expires"])
            check_type(argname="argument format", value=format, expected_type=type_hints["format"])
            check_type(argname="argument http_only", value=http_only, expected_type=type_hints["http_only"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument same_site", value=same_site, expected_type=type_hints["same_site"])
            check_type(argname="argument secure", value=secure, expected_type=type_hints["secure"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if default_domain is not None:
            self._values["default_domain"] = default_domain
        if default_path is not None:
            self._values["default_path"] = default_path
        if domain is not None:
            self._values["domain"] = domain
        if duration is not None:
            self._values["duration"] = duration
        if enabled is not None:
            self._values["enabled"] = enabled
        if expiration_date is not None:
            self._values["expiration_date"] = expiration_date
        if expires is not None:
            self._values["expires"] = expires
        if format is not None:
            self._values["format"] = format
        if http_only is not None:
            self._values["http_only"] = http_only
        if locked is not None:
            self._values["locked"] = locked
        if path is not None:
            self._values["path"] = path
        if same_site is not None:
            self._values["same_site"] = same_site
        if secure is not None:
            self._values["secure"] = secure
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie, which serves as a key to determine if the cookie is set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def default_domain(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default domain value, otherwise the set specified in the ``domain`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_domain DataAkamaiPropertyRulesBuilder#default_domain}
        '''
        result = self._values.get("default_domain")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def default_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, uses the default path value, otherwise the set specified in the ``path`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#default_path DataAkamaiPropertyRulesBuilder#default_path}
        '''
        result = self._values.get("default_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def domain(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultDomain`` is disabled, this sets the domain for which the cookie is valid.

        For example, ``example.com`` makes the cookie valid for that hostname and all subdomains.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain DataAkamaiPropertyRulesBuilder#domain}
        '''
        result = self._values.get("domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def duration(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``DURATION``, this sets the cookie's lifetime.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#duration DataAkamaiPropertyRulesBuilder#duration}
        '''
        result = self._values.get("duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set a response cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def expiration_date(self) -> typing.Optional[builtins.str]:
        '''If ``expires`` is set to ``FIXED_DATE``, this sets when the cookie expires as a UTC date and time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expiration_date DataAkamaiPropertyRulesBuilder#expiration_date}
        '''
        result = self._values.get("expiration_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def expires(self) -> typing.Optional[builtins.str]:
        '''Sets various ways to specify when the cookie expires.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#expires DataAkamaiPropertyRulesBuilder#expires}
        '''
        result = self._values.get("expires")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format(self) -> typing.Optional[builtins.str]:
        '''When the ``type`` of cookie is set to ``UNIQUE``, this sets the date format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format DataAkamaiPropertyRulesBuilder#format}
        '''
        result = self._values.get("format")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, includes the ``HttpOnly`` attribute in the ``Set-Cookie`` response header to mitigate the risk of client-side scripts accessing the protected cookie, if the browser supports it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#http_only DataAkamaiPropertyRulesBuilder#http_only}
        '''
        result = self._values.get("http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def path(self) -> typing.Optional[builtins.str]:
        '''If the ``defaultPath`` is disabled, sets the path component for which the cookie is valid.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def same_site(self) -> typing.Optional[builtins.str]:
        '''This option controls the ``SameSite`` cookie attribute that reduces the risk of cross-site request forgery attacks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#same_site DataAkamaiPropertyRulesBuilder#same_site}
        '''
        result = self._values.get("same_site")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def secure(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sets the cookie's ``Secure`` flag to transmit it with ``HTTPS``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#secure DataAkamaiPropertyRulesBuilder#secure}
        '''
        result = self._values.get("secure")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''What type of value to assign.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''If the cookie ``type`` is ``FIXED``, this specifies the cookie value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__716a2a991bba7619200d4e9403a464b287a86fd1aedb21df0c8d97f3112b786f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDefaultDomain")
    def reset_default_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultDomain", []))

    @jsii.member(jsii_name="resetDefaultPath")
    def reset_default_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDefaultPath", []))

    @jsii.member(jsii_name="resetDomain")
    def reset_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomain", []))

    @jsii.member(jsii_name="resetDuration")
    def reset_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDuration", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExpirationDate")
    def reset_expiration_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpirationDate", []))

    @jsii.member(jsii_name="resetExpires")
    def reset_expires(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExpires", []))

    @jsii.member(jsii_name="resetFormat")
    def reset_format(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormat", []))

    @jsii.member(jsii_name="resetHttpOnly")
    def reset_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHttpOnly", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetSameSite")
    def reset_same_site(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSameSite", []))

    @jsii.member(jsii_name="resetSecure")
    def reset_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSecure", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultDomainInput")
    def default_domain_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="defaultPathInput")
    def default_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "defaultPathInput"))

    @builtins.property
    @jsii.member(jsii_name="domainInput")
    def domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainInput"))

    @builtins.property
    @jsii.member(jsii_name="durationInput")
    def duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "durationInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="expirationDateInput")
    def expiration_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expirationDateInput"))

    @builtins.property
    @jsii.member(jsii_name="expiresInput")
    def expires_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "expiresInput"))

    @builtins.property
    @jsii.member(jsii_name="formatInput")
    def format_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatInput"))

    @builtins.property
    @jsii.member(jsii_name="httpOnlyInput")
    def http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "httpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="sameSiteInput")
    def same_site_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sameSiteInput"))

    @builtins.property
    @jsii.member(jsii_name="secureInput")
    def secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "secureInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5103fa573ef2e3de1fdd0433de95153b7cc3bd16cc45035ceb22d75b678b5731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="defaultDomain")
    def default_domain(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultDomain"))

    @default_domain.setter
    def default_domain(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a09cfb0634b0b545df27204057bf7a61c90e89638f98b0804ee8046256e7b27b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultDomain", value)

    @builtins.property
    @jsii.member(jsii_name="defaultPath")
    def default_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "defaultPath"))

    @default_path.setter
    def default_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df2322c1923bc04052d31714fd53cbb06c557e4b78675d698dbad923c6c3a4e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "defaultPath", value)

    @builtins.property
    @jsii.member(jsii_name="domain")
    def domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domain"))

    @domain.setter
    def domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3bb2223b051fa79a42243f883d2e7ad46643a7d17ae91b7955df67f461e08340)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domain", value)

    @builtins.property
    @jsii.member(jsii_name="duration")
    def duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "duration"))

    @duration.setter
    def duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4846c20e454f183ac76deb4ef34809966985b1f8fda0993fa5ab43e005030292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "duration", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9582b318c62d26422a13024e953f3fee031262f2f973e25f9c087c580badff4b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="expirationDate")
    def expiration_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expirationDate"))

    @expiration_date.setter
    def expiration_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae22dad0158c13c63d0076bfd92d7038b3861e85529642994f060322d65bb0bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expirationDate", value)

    @builtins.property
    @jsii.member(jsii_name="expires")
    def expires(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "expires"))

    @expires.setter
    def expires(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__183b97667defa9ebb57c4912e09031cc864c70e74f10bfd8b68c7e76e623da36)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "expires", value)

    @builtins.property
    @jsii.member(jsii_name="format")
    def format(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "format"))

    @format.setter
    def format(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50b5ef2c7875781169e94f77c943e811e92b0b847af75c24c1c001ddf61b3b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "format", value)

    @builtins.property
    @jsii.member(jsii_name="httpOnly")
    def http_only(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "httpOnly"))

    @http_only.setter
    def http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97828c418f2d59259f25ffc11e972ec2ed8693fbc552372ba337167fd831ab1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "httpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73428ea4ce087eb9c7b93221e178767542a17b04148c887c67a6a78df8d4c2e0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "path"))

    @path.setter
    def path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8b335c52ec7b0669c44d0ba01af44ce37dcafd6af393e61bf2bfd0abb74ae7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "path", value)

    @builtins.property
    @jsii.member(jsii_name="sameSite")
    def same_site(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sameSite"))

    @same_site.setter
    def same_site(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f933ebd39e5daa9c739ee010ab1d4e1b0bf10c566b0f6dba8b39e7e3ac258bf6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sameSite", value)

    @builtins.property
    @jsii.member(jsii_name="secure")
    def secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "secure"))

    @secure.setter
    def secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__def84d2596e4f8c0cc6408924ee7167c571f7abeaab68d8a68bbecdc96965a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "secure", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__483462e2abccd2558d966bd68ad303da8518cdd56e6012f818fadc6aa9979fd8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89a95aee4956588e4335a54a20b225cfd34ad4dfbd1a7b66d1f4d0250db0baad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__376287a8942d56771c88278f287a44d170394f3c707895e3278d99569f18456d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e73d7453bcdc25258de152f18ebd7fb53f356a623d5207955e1f599f67f2ae0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbc1f9397761f19f8cc83b078eee39f4f0c73dc39fd8d4a40f1c76ba7878695)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "maximum_size": "maximumSize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        maximum_size: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param maximum_size: Specifies a fixed maximum size of non-HTML content to cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d6ba1beb3065c47418f243015154e1482788fd8481312459a5e3cbf7aecb70d)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument maximum_size", value=maximum_size, expected_type=type_hints["maximum_size"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if maximum_size is not None:
            self._values["maximum_size"] = maximum_size
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def maximum_size(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed maximum size of non-HTML content to cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#maximum_size DataAkamaiPropertyRulesBuilder#maximum_size}
        '''
        result = self._values.get("maximum_size")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCachingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCachingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66a35d998aee5f1537490911361620684f67749572ba45f0ccbc3036b9b604a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMaximumSize")
    def reset_maximum_size(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaximumSize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maximumSizeInput")
    def maximum_size_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "maximumSizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__583678f67de735b3cc8cacfd51e93190252ae8b33d7a87deffcf3eb21f6c514f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="maximumSize")
    def maximum_size(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "maximumSize"))

    @maximum_size.setter
    def maximum_size(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffed2da6d71dc13bdfa97fb05e70efdf12639a09b5428d0b2b5da3a2e51d2cfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maximumSize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2cdd42f6017a547681be159e4b0adae6c8ffba99498e51ed0e278a48ac898b94)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c27a86053eb02868f088e20519de2eff60a43b011f9fafe14771468dca318b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b40745d96aee422f894894c0955f393af89f909d7888fa92784523a0eee9d72f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "response_header_name": "responseHeaderName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param response_header_name: Specifies the name of the HTTP header in which to report the cache status value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7855958fe618a271f81a46855b48502f1d89ab04a9c008fa0ed5132dffee5ea1)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the HTTP header in which to report the cache status value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatusOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatusOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38785f236836e0ced572f5039f97e40d6ba2a83cc3c769c18785d8c1b1ea9f04)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d110f1936ecff2fc7f97027d04cfb73dd4f41f7b55b77b8f91db1eff7ec64369)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c14be7cc3a6ce1b54a383d9344e83b3ffb0652f811bf8a0349fd695939dd391)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee64a3cb96659b878dc9eafcc8bacf0fae61e6a42c4dd17c86dcf7de8955cba3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd45c3b0efc169ec48b28cba6406c9ce04cad11199d8676452744a3d6927694d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3a896f0f492d10b1480d45e8e304d430c8d12eaeab3464d4787aa53f94e85ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "keep_query_string": "keepQueryString",
        "locked": "locked",
        "match": "match",
        "match_multiple": "matchMultiple",
        "match_regex": "matchRegex",
        "target_path": "targetPath",
        "target_path_prepend": "targetPathPrepend",
        "target_regex": "targetRegex",
        "target_url": "targetUrl",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match: typing.Optional[builtins.str] = None,
        match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_regex: typing.Optional[builtins.str] = None,
        target_path: typing.Optional[builtins.str] = None,
        target_path_prepend: typing.Optional[builtins.str] = None,
        target_regex: typing.Optional[builtins.str] = None,
        target_url: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: The action to perform on the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param keep_query_string: When enabled, retains the original path's query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match: When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        :param match_multiple: When enabled, replaces all potential matches rather than only the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        :param match_regex: When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        :param target_path: When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        :param target_path_prepend: When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        :param target_regex: When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        :param target_url: When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24a0ec2014e086b997b5d68efca8325526140e8a62004b552d99212a28de6c0a)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument keep_query_string", value=keep_query_string, expected_type=type_hints["keep_query_string"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match", value=match, expected_type=type_hints["match"])
            check_type(argname="argument match_multiple", value=match_multiple, expected_type=type_hints["match_multiple"])
            check_type(argname="argument match_regex", value=match_regex, expected_type=type_hints["match_regex"])
            check_type(argname="argument target_path", value=target_path, expected_type=type_hints["target_path"])
            check_type(argname="argument target_path_prepend", value=target_path_prepend, expected_type=type_hints["target_path_prepend"])
            check_type(argname="argument target_regex", value=target_regex, expected_type=type_hints["target_regex"])
            check_type(argname="argument target_url", value=target_url, expected_type=type_hints["target_url"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if keep_query_string is not None:
            self._values["keep_query_string"] = keep_query_string
        if locked is not None:
            self._values["locked"] = locked
        if match is not None:
            self._values["match"] = match
        if match_multiple is not None:
            self._values["match_multiple"] = match_multiple
        if match_regex is not None:
            self._values["match_regex"] = match_regex
        if target_path is not None:
            self._values["target_path"] = target_path
        if target_path_prepend is not None:
            self._values["target_path_prepend"] = target_path_prepend
        if target_regex is not None:
            self._values["target_regex"] = target_regex
        if target_url is not None:
            self._values["target_url"] = target_url
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''The action to perform on the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def keep_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, retains the original path's query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#keep_query_string DataAkamaiPropertyRulesBuilder#keep_query_string}
        '''
        result = self._values.get("keep_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is ``REMOVE`` or ``REPLACE``, specifies the part of the incoming path you'd like to remove or modify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match DataAkamaiPropertyRulesBuilder#match}
        '''
        result = self._values.get("match")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_multiple(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, replaces all potential matches rather than only the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_multiple DataAkamaiPropertyRulesBuilder#match_multiple}
        '''
        result = self._values.get("match_multiple")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, specifies the Perl-compatible regular expression to replace with ``targetRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_regex DataAkamaiPropertyRulesBuilder#match_regex}
        '''
        result = self._values.get("match_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REPLACE``, this path replaces whatever the ``match`` field matches in the incoming request's path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path DataAkamaiPropertyRulesBuilder#target_path}
        '''
        result = self._values.get("target_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_path_prepend(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``PREPEND``, specifies a path to prepend to the incoming request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_path_prepend DataAkamaiPropertyRulesBuilder#target_path_prepend}
        '''
        result = self._values.get("target_path_prepend")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_regex(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REGEX_REPLACE``, this replaces whatever the ``matchRegex`` field matches, along with any captured sequences from ``\\$1`` through ``\\$9``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_regex DataAkamaiPropertyRulesBuilder#target_regex}
        '''
        result = self._values.get("target_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def target_url(self) -> typing.Optional[builtins.str]:
        '''When ``behavior`` is set to ``REWRITE``, specifies the full path to request from the origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#target_url DataAkamaiPropertyRulesBuilder#target_url}
        '''
        result = self._values.get("target_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrlOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrlOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d364e8d8265afd6ccc000daf73d2bd8d03c9e79a5cef13ef909135f5b63042a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetKeepQueryString")
    def reset_keep_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKeepQueryString", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatch")
    def reset_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatch", []))

    @jsii.member(jsii_name="resetMatchMultiple")
    def reset_match_multiple(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchMultiple", []))

    @jsii.member(jsii_name="resetMatchRegex")
    def reset_match_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchRegex", []))

    @jsii.member(jsii_name="resetTargetPath")
    def reset_target_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPath", []))

    @jsii.member(jsii_name="resetTargetPathPrepend")
    def reset_target_path_prepend(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetPathPrepend", []))

    @jsii.member(jsii_name="resetTargetRegex")
    def reset_target_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetRegex", []))

    @jsii.member(jsii_name="resetTargetUrl")
    def reset_target_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTargetUrl", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="keepQueryStringInput")
    def keep_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "keepQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchInput")
    def match_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchInput"))

    @builtins.property
    @jsii.member(jsii_name="matchMultipleInput")
    def match_multiple_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchMultipleInput"))

    @builtins.property
    @jsii.member(jsii_name="matchRegexInput")
    def match_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathInput")
    def target_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathInput"))

    @builtins.property
    @jsii.member(jsii_name="targetPathPrependInput")
    def target_path_prepend_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetPathPrependInput"))

    @builtins.property
    @jsii.member(jsii_name="targetRegexInput")
    def target_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="targetUrlInput")
    def target_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "targetUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61793fb4b6abfe62448c76fd10098d90bf244a93cca45c375fd253e6ab7f6c13)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="keepQueryString")
    def keep_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "keepQueryString"))

    @keep_query_string.setter
    def keep_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9de6990ecc9f25d1ea4c15d18e2ed8703a4baaaba29da68be88c147d510cacf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "keepQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4bba83032b4f452d5b2a4f1f595ae93b012b7595a24615259ff6e44e4d27bb9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="match")
    def match(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "match"))

    @match.setter
    def match(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__73dcebd4ef13a9b143861bd69b0141816ec64a354553af77c48d6b615a4b4643)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "match", value)

    @builtins.property
    @jsii.member(jsii_name="matchMultiple")
    def match_multiple(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchMultiple"))

    @match_multiple.setter
    def match_multiple(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee03c06106caa660340d70c2429a11b85d0528d8bad8c66618730a11fb3897da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchMultiple", value)

    @builtins.property
    @jsii.member(jsii_name="matchRegex")
    def match_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchRegex"))

    @match_regex.setter
    def match_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__688a52094e109fc48a5dd3de674a9e5e42f28ab0e113f2834f251345eb6b391a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetPath")
    def target_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPath"))

    @target_path.setter
    def target_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab845e26334b124e0c84ccd0b68fb94a97f46b210889bd7339bcca82e1137654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPath", value)

    @builtins.property
    @jsii.member(jsii_name="targetPathPrepend")
    def target_path_prepend(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetPathPrepend"))

    @target_path_prepend.setter
    def target_path_prepend(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__24ff5a05f766a787fdfbab9639fe14588955a47180862e77a8175a71a03eca55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetPathPrepend", value)

    @builtins.property
    @jsii.member(jsii_name="targetRegex")
    def target_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetRegex"))

    @target_regex.setter
    def target_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14fb7fd79ee3bef338be2eb2c059f01bade2e3739d2b8263d979ba56c289ea51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetRegex", value)

    @builtins.property
    @jsii.member(jsii_name="targetUrl")
    def target_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "targetUrl"))

    @target_url.setter
    def target_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d48119690ad51de936af20d7f6eebf7eb478fb1187b8186cdc71cf7d45a20321)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "targetUrl", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9df20b2adeddfeb5806799252f606808ff1767fdc4eeb0c2a79ddc4127ec37d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a604e7695d75e6b6cdeeef9ab34da3272caeb581a040c2c088b4799c0eefda3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c45ef26e1f542ce0f4fbb6d7bf93d9327e75b15db561916ea7e6ccc32f483575)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "rum_group_name": "rumGroupName",
        "rum_sample_rate": "rumSampleRate",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        rum_group_name: typing.Optional[builtins.str] = None,
        rum_sample_rate: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param rum_group_name: A deprecated option to specify an alternate name under which to batch this set of web traffic in your report. Do not use it. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        :param rum_sample_rate: Specifies the percentage of web traffic to include in your RUM report. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5484fff6cc80f3f2d1b09059074ebd9801e3f5ccb68815c264bd9946a0f342b2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument rum_group_name", value=rum_group_name, expected_type=type_hints["rum_group_name"])
            check_type(argname="argument rum_sample_rate", value=rum_sample_rate, expected_type=type_hints["rum_sample_rate"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if rum_group_name is not None:
            self._values["rum_group_name"] = rum_group_name
        if rum_sample_rate is not None:
            self._values["rum_sample_rate"] = rum_sample_rate
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def rum_group_name(self) -> typing.Optional[builtins.str]:
        '''A deprecated option to specify an alternate name under which to batch this set of web traffic in your report.

        Do not use it.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_group_name DataAkamaiPropertyRulesBuilder#rum_group_name}
        '''
        result = self._values.get("rum_group_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def rum_sample_rate(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of web traffic to include in your RUM report.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#rum_sample_rate DataAkamaiPropertyRulesBuilder#rum_sample_rate}
        '''
        result = self._values.get("rum_sample_rate")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc6febc6b3797d80e466876c2a642c57f1f1867db2f6ef463c8441cef524897)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRumGroupName")
    def reset_rum_group_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumGroupName", []))

    @jsii.member(jsii_name="resetRumSampleRate")
    def reset_rum_sample_rate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRumSampleRate", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="rumGroupNameInput")
    def rum_group_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "rumGroupNameInput"))

    @builtins.property
    @jsii.member(jsii_name="rumSampleRateInput")
    def rum_sample_rate_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "rumSampleRateInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__270bf978bfa33a181e7fc45cad893ba8cf102c8b1b5debfffed5ab72f2e385ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="rumGroupName")
    def rum_group_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "rumGroupName"))

    @rum_group_name.setter
    def rum_group_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33c6d9e07b81b400e0b73c910bdb1b26efa896b5d36919e772d8bd39471bf45b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumGroupName", value)

    @builtins.property
    @jsii.member(jsii_name="rumSampleRate")
    def rum_sample_rate(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "rumSampleRate"))

    @rum_sample_rate.setter
    def rum_sample_rate(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56eb76213fd42cd1e14cf165d7ab834f09b218a1aefb65cb28547fac91082d2f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "rumSampleRate", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df282890eea50ad588eceef5a004c1464ce291b8f72cb5cda719d025b2d64b5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d30159216106ae23748eac649e546e8afcc53bb1aa33c54b6a38fb64b55362d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__813c24279792ff24287d9cb7105e5e7add2de03a2d1b9025d7dedb61d5cd6e7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions",
    jsii_struct_bases=[],
    name_mapping={
        "application_action": "applicationAction",
        "application_cname_enabled": "applicationCnameEnabled",
        "application_cname_level": "applicationCnameLevel",
        "application_cookie": "applicationCookie",
        "application_query_string": "applicationQueryString",
        "application_regex": "applicationRegex",
        "application_replace": "applicationReplace",
        "application_title": "applicationTitle",
        "customer_action": "customerAction",
        "customer_cname_enabled": "customerCnameEnabled",
        "customer_cname_level": "customerCnameLevel",
        "customer_cookie": "customerCookie",
        "customer_query_string": "customerQueryString",
        "customer_regex": "customerRegex",
        "customer_replace": "customerReplace",
        "customer_title": "customerTitle",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "users_action": "usersAction",
        "users_cname_enabled": "usersCnameEnabled",
        "users_cname_level": "usersCnameLevel",
        "users_cookie": "usersCookie",
        "users_query_string": "usersQueryString",
        "users_regex": "usersRegex",
        "users_replace": "usersReplace",
        "users_title": "usersTitle",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions:
    def __init__(
        self,
        *,
        application_action: typing.Optional[builtins.str] = None,
        application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        application_cname_level: typing.Optional[jsii.Number] = None,
        application_cookie: typing.Optional[builtins.str] = None,
        application_query_string: typing.Optional[builtins.str] = None,
        application_regex: typing.Optional[builtins.str] = None,
        application_replace: typing.Optional[builtins.str] = None,
        application_title: typing.Optional[builtins.str] = None,
        customer_action: typing.Optional[builtins.str] = None,
        customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        customer_cname_level: typing.Optional[jsii.Number] = None,
        customer_cookie: typing.Optional[builtins.str] = None,
        customer_query_string: typing.Optional[builtins.str] = None,
        customer_regex: typing.Optional[builtins.str] = None,
        customer_replace: typing.Optional[builtins.str] = None,
        customer_title: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        users_action: typing.Optional[builtins.str] = None,
        users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        users_cname_level: typing.Optional[jsii.Number] = None,
        users_cookie: typing.Optional[builtins.str] = None,
        users_query_string: typing.Optional[builtins.str] = None,
        users_regex: typing.Optional[builtins.str] = None,
        users_replace: typing.Optional[builtins.str] = None,
        users_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param application_action: Specifies the request component that identifies a SaaS application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        :param application_cname_enabled: Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        :param application_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        :param application_cookie: This specifies the name of the cookie that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        :param application_query_string: This names the query parameter that identifies the application. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        :param application_regex: Specifies a Perl-compatible regular expression with which to substitute the request's application ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        :param application_replace: Specifies a string to replace the request's application ID matched by ``applicationRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        :param application_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        :param customer_action: Specifies the request component that identifies a SaaS customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        :param customer_cname_enabled: Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        :param customer_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        :param customer_cookie: This specifies the name of the cookie that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        :param customer_query_string: This names the query parameter that identifies the customer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        :param customer_regex: Specifies a Perl-compatible regular expression with which to substitute the request's customer ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        :param customer_replace: Specifies a string to replace the request's customer ID matched by ``customerRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        :param customer_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param users_action: Specifies the request component that identifies a SaaS user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        :param users_cname_enabled: Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        :param users_cname_level: Specifies the number of CNAMEs to use in the chain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        :param users_cookie: This specifies the name of the cookie that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        :param users_query_string: This names the query parameter that identifies the user. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        :param users_regex: Specifies a Perl-compatible regular expression with which to substitute the request's user ID. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        :param users_replace: Specifies a string to replace the request's user ID matched by ``usersRegex``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        :param users_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18b0e70582f51ae2a2091b31bcce5bf37bb9328773fa7114e3b21280f49be4c9)
            check_type(argname="argument application_action", value=application_action, expected_type=type_hints["application_action"])
            check_type(argname="argument application_cname_enabled", value=application_cname_enabled, expected_type=type_hints["application_cname_enabled"])
            check_type(argname="argument application_cname_level", value=application_cname_level, expected_type=type_hints["application_cname_level"])
            check_type(argname="argument application_cookie", value=application_cookie, expected_type=type_hints["application_cookie"])
            check_type(argname="argument application_query_string", value=application_query_string, expected_type=type_hints["application_query_string"])
            check_type(argname="argument application_regex", value=application_regex, expected_type=type_hints["application_regex"])
            check_type(argname="argument application_replace", value=application_replace, expected_type=type_hints["application_replace"])
            check_type(argname="argument application_title", value=application_title, expected_type=type_hints["application_title"])
            check_type(argname="argument customer_action", value=customer_action, expected_type=type_hints["customer_action"])
            check_type(argname="argument customer_cname_enabled", value=customer_cname_enabled, expected_type=type_hints["customer_cname_enabled"])
            check_type(argname="argument customer_cname_level", value=customer_cname_level, expected_type=type_hints["customer_cname_level"])
            check_type(argname="argument customer_cookie", value=customer_cookie, expected_type=type_hints["customer_cookie"])
            check_type(argname="argument customer_query_string", value=customer_query_string, expected_type=type_hints["customer_query_string"])
            check_type(argname="argument customer_regex", value=customer_regex, expected_type=type_hints["customer_regex"])
            check_type(argname="argument customer_replace", value=customer_replace, expected_type=type_hints["customer_replace"])
            check_type(argname="argument customer_title", value=customer_title, expected_type=type_hints["customer_title"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument users_action", value=users_action, expected_type=type_hints["users_action"])
            check_type(argname="argument users_cname_enabled", value=users_cname_enabled, expected_type=type_hints["users_cname_enabled"])
            check_type(argname="argument users_cname_level", value=users_cname_level, expected_type=type_hints["users_cname_level"])
            check_type(argname="argument users_cookie", value=users_cookie, expected_type=type_hints["users_cookie"])
            check_type(argname="argument users_query_string", value=users_query_string, expected_type=type_hints["users_query_string"])
            check_type(argname="argument users_regex", value=users_regex, expected_type=type_hints["users_regex"])
            check_type(argname="argument users_replace", value=users_replace, expected_type=type_hints["users_replace"])
            check_type(argname="argument users_title", value=users_title, expected_type=type_hints["users_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if application_action is not None:
            self._values["application_action"] = application_action
        if application_cname_enabled is not None:
            self._values["application_cname_enabled"] = application_cname_enabled
        if application_cname_level is not None:
            self._values["application_cname_level"] = application_cname_level
        if application_cookie is not None:
            self._values["application_cookie"] = application_cookie
        if application_query_string is not None:
            self._values["application_query_string"] = application_query_string
        if application_regex is not None:
            self._values["application_regex"] = application_regex
        if application_replace is not None:
            self._values["application_replace"] = application_replace
        if application_title is not None:
            self._values["application_title"] = application_title
        if customer_action is not None:
            self._values["customer_action"] = customer_action
        if customer_cname_enabled is not None:
            self._values["customer_cname_enabled"] = customer_cname_enabled
        if customer_cname_level is not None:
            self._values["customer_cname_level"] = customer_cname_level
        if customer_cookie is not None:
            self._values["customer_cookie"] = customer_cookie
        if customer_query_string is not None:
            self._values["customer_query_string"] = customer_query_string
        if customer_regex is not None:
            self._values["customer_regex"] = customer_regex
        if customer_replace is not None:
            self._values["customer_replace"] = customer_replace
        if customer_title is not None:
            self._values["customer_title"] = customer_title
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if users_action is not None:
            self._values["users_action"] = users_action
        if users_cname_enabled is not None:
            self._values["users_cname_enabled"] = users_cname_enabled
        if users_cname_level is not None:
            self._values["users_cname_level"] = users_cname_level
        if users_cookie is not None:
            self._values["users_cookie"] = users_cookie
        if users_query_string is not None:
            self._values["users_query_string"] = users_query_string
        if users_regex is not None:
            self._values["users_regex"] = users_regex
        if users_replace is not None:
            self._values["users_replace"] = users_replace
        if users_title is not None:
            self._values["users_title"] = users_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def application_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_action DataAkamaiPropertyRulesBuilder#application_action}
        '''
        result = self._values.get("application_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify applications using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_enabled DataAkamaiPropertyRulesBuilder#application_cname_enabled}
        '''
        result = self._values.get("application_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def application_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cname_level DataAkamaiPropertyRulesBuilder#application_cname_level}
        '''
        result = self._values.get("application_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def application_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_cookie DataAkamaiPropertyRulesBuilder#application_cookie}
        '''
        result = self._values.get("application_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the application.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_query_string DataAkamaiPropertyRulesBuilder#application_query_string}
        '''
        result = self._values.get("application_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's application ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_regex DataAkamaiPropertyRulesBuilder#application_regex}
        '''
        result = self._values.get("application_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's application ID matched by ``applicationRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_replace DataAkamaiPropertyRulesBuilder#application_replace}
        '''
        result = self._values.get("application_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def application_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#application_title DataAkamaiPropertyRulesBuilder#application_title}
        '''
        result = self._values.get("application_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_action DataAkamaiPropertyRulesBuilder#customer_action}
        '''
        result = self._values.get("customer_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify customers using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_enabled DataAkamaiPropertyRulesBuilder#customer_cname_enabled}
        '''
        result = self._values.get("customer_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def customer_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cname_level DataAkamaiPropertyRulesBuilder#customer_cname_level}
        '''
        result = self._values.get("customer_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def customer_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_cookie DataAkamaiPropertyRulesBuilder#customer_cookie}
        '''
        result = self._values.get("customer_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the customer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_query_string DataAkamaiPropertyRulesBuilder#customer_query_string}
        '''
        result = self._values.get("customer_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's customer ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_regex DataAkamaiPropertyRulesBuilder#customer_regex}
        '''
        result = self._values.get("customer_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's customer ID matched by ``customerRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_replace DataAkamaiPropertyRulesBuilder#customer_replace}
        '''
        result = self._values.get("customer_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def customer_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#customer_title DataAkamaiPropertyRulesBuilder#customer_title}
        '''
        result = self._values.get("customer_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_action(self) -> typing.Optional[builtins.str]:
        '''Specifies the request component that identifies a SaaS user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_action DataAkamaiPropertyRulesBuilder#users_action}
        '''
        result = self._values.get("users_action")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_cname_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this allows you to identify users using a ``CNAME chain`` rather than a single hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_enabled DataAkamaiPropertyRulesBuilder#users_cname_enabled}
        '''
        result = self._values.get("users_cname_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def users_cname_level(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of CNAMEs to use in the chain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cname_level DataAkamaiPropertyRulesBuilder#users_cname_level}
        '''
        result = self._values.get("users_cname_level")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def users_cookie(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the cookie that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_cookie DataAkamaiPropertyRulesBuilder#users_cookie}
        '''
        result = self._values.get("users_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_query_string(self) -> typing.Optional[builtins.str]:
        '''This names the query parameter that identifies the user.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_query_string DataAkamaiPropertyRulesBuilder#users_query_string}
        '''
        result = self._values.get("users_query_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_regex(self) -> typing.Optional[builtins.str]:
        '''Specifies a Perl-compatible regular expression with which to substitute the request's user ID.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_regex DataAkamaiPropertyRulesBuilder#users_regex}
        '''
        result = self._values.get("users_regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_replace(self) -> typing.Optional[builtins.str]:
        '''Specifies a string to replace the request's user ID matched by ``usersRegex``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_replace DataAkamaiPropertyRulesBuilder#users_replace}
        '''
        result = self._values.get("users_replace")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def users_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#users_title DataAkamaiPropertyRulesBuilder#users_title}
        '''
        result = self._values.get("users_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitionsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitionsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c3e45e0829196da0d3804d422514049bf6deb8e659d156791b5eadf13e7f5b1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplicationAction")
    def reset_application_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationAction", []))

    @jsii.member(jsii_name="resetApplicationCnameEnabled")
    def reset_application_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameEnabled", []))

    @jsii.member(jsii_name="resetApplicationCnameLevel")
    def reset_application_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCnameLevel", []))

    @jsii.member(jsii_name="resetApplicationCookie")
    def reset_application_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationCookie", []))

    @jsii.member(jsii_name="resetApplicationQueryString")
    def reset_application_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationQueryString", []))

    @jsii.member(jsii_name="resetApplicationRegex")
    def reset_application_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationRegex", []))

    @jsii.member(jsii_name="resetApplicationReplace")
    def reset_application_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationReplace", []))

    @jsii.member(jsii_name="resetApplicationTitle")
    def reset_application_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplicationTitle", []))

    @jsii.member(jsii_name="resetCustomerAction")
    def reset_customer_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerAction", []))

    @jsii.member(jsii_name="resetCustomerCnameEnabled")
    def reset_customer_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameEnabled", []))

    @jsii.member(jsii_name="resetCustomerCnameLevel")
    def reset_customer_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCnameLevel", []))

    @jsii.member(jsii_name="resetCustomerCookie")
    def reset_customer_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerCookie", []))

    @jsii.member(jsii_name="resetCustomerQueryString")
    def reset_customer_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerQueryString", []))

    @jsii.member(jsii_name="resetCustomerRegex")
    def reset_customer_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerRegex", []))

    @jsii.member(jsii_name="resetCustomerReplace")
    def reset_customer_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerReplace", []))

    @jsii.member(jsii_name="resetCustomerTitle")
    def reset_customer_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomerTitle", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUsersAction")
    def reset_users_action(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersAction", []))

    @jsii.member(jsii_name="resetUsersCnameEnabled")
    def reset_users_cname_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameEnabled", []))

    @jsii.member(jsii_name="resetUsersCnameLevel")
    def reset_users_cname_level(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCnameLevel", []))

    @jsii.member(jsii_name="resetUsersCookie")
    def reset_users_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersCookie", []))

    @jsii.member(jsii_name="resetUsersQueryString")
    def reset_users_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersQueryString", []))

    @jsii.member(jsii_name="resetUsersRegex")
    def reset_users_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersRegex", []))

    @jsii.member(jsii_name="resetUsersReplace")
    def reset_users_replace(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersReplace", []))

    @jsii.member(jsii_name="resetUsersTitle")
    def reset_users_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUsersTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applicationActionInput")
    def application_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationActionInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabledInput")
    def application_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applicationCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevelInput")
    def application_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "applicationCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationCookieInput")
    def application_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationQueryStringInput")
    def application_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationRegexInput")
    def application_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationReplaceInput")
    def application_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationTitleInput")
    def application_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "applicationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customerActionInput")
    def customer_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerActionInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabledInput")
    def customer_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customerCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevelInput")
    def customer_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "customerCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="customerCookieInput")
    def customer_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="customerQueryStringInput")
    def customer_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="customerRegexInput")
    def customer_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="customerReplaceInput")
    def customer_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="customerTitleInput")
    def customer_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customerTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="usersActionInput")
    def users_action_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersActionInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabledInput")
    def users_cname_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "usersCnameEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevelInput")
    def users_cname_level_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "usersCnameLevelInput"))

    @builtins.property
    @jsii.member(jsii_name="usersCookieInput")
    def users_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="usersQueryStringInput")
    def users_query_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="usersRegexInput")
    def users_regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersRegexInput"))

    @builtins.property
    @jsii.member(jsii_name="usersReplaceInput")
    def users_replace_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersReplaceInput"))

    @builtins.property
    @jsii.member(jsii_name="usersTitleInput")
    def users_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "usersTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applicationAction")
    def application_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationAction"))

    @application_action.setter
    def application_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9626b8b16d4ae7536abf7dfe91ae634227ba03ef54b515469f3e787330840658)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationAction", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameEnabled")
    def application_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applicationCnameEnabled"))

    @application_cname_enabled.setter
    def application_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87e5d6672b3b7dfb286ad07208307da29ae7b6b6cdb6c24fa534cef4ec8bcfbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCnameLevel")
    def application_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "applicationCnameLevel"))

    @application_cname_level.setter
    def application_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25f9d3ff71a7c51758fcdd7cbff4ed84267321c9f83786a6c4eb17febc33b75b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="applicationCookie")
    def application_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationCookie"))

    @application_cookie.setter
    def application_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__475df8665da20d3bb5729b6e8e02702a0fa0467b4b607b53a0fdca0fcc9f4be5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationCookie", value)

    @builtins.property
    @jsii.member(jsii_name="applicationQueryString")
    def application_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationQueryString"))

    @application_query_string.setter
    def application_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f6fc78442bec033157f857cb1ca7efeee95c7e3b7369fb26d3dfe0c65e8959b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="applicationRegex")
    def application_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationRegex"))

    @application_regex.setter
    def application_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ed28c1917e26519e619ddc07cfa4292ded97d3410e7fe25d81dbcc94c2fce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationRegex", value)

    @builtins.property
    @jsii.member(jsii_name="applicationReplace")
    def application_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationReplace"))

    @application_replace.setter
    def application_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93457985b258ca39c12d024b23fb667887e5cdf19662f72862825bc69e5d0f56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationReplace", value)

    @builtins.property
    @jsii.member(jsii_name="applicationTitle")
    def application_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "applicationTitle"))

    @application_title.setter
    def application_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d426c5d2354f36a9e1bbda0145a104f38b2508bdf581b111240733f08354b8ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applicationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customerAction")
    def customer_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerAction"))

    @customer_action.setter
    def customer_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61effa1925f04052d5501afb3afb78c7d6bc6f68361dbfc7f78cf014db326342)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerAction", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameEnabled")
    def customer_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customerCnameEnabled"))

    @customer_cname_enabled.setter
    def customer_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__811dd01c779510e5ed91bad6bba567d0ab3fc7d5cbcaece0409a80e5151873e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customerCnameLevel")
    def customer_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "customerCnameLevel"))

    @customer_cname_level.setter
    def customer_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf1c4b2f30ab1ebbd9daca5f968ec8a6b6892be2f80b251af6e5fdf68df31f1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="customerCookie")
    def customer_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerCookie"))

    @customer_cookie.setter
    def customer_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ae150411a15533dc838780b038fb10224c817144879233e0f0f51337252145d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerCookie", value)

    @builtins.property
    @jsii.member(jsii_name="customerQueryString")
    def customer_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerQueryString"))

    @customer_query_string.setter
    def customer_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aad2330f7ba9a53189e78892eaba1f690cd51d804411b450f5465b3f13cd419)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="customerRegex")
    def customer_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerRegex"))

    @customer_regex.setter
    def customer_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__be3dec2844702b8cc5829e0f24fd2d01af21bcb7d992f7339f60a02ced31ca6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerRegex", value)

    @builtins.property
    @jsii.member(jsii_name="customerReplace")
    def customer_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerReplace"))

    @customer_replace.setter
    def customer_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1569956cfbf6a6c1a66b5b7f1842f40926a5e60f73ee4d2f1e4f49f74557fa12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerReplace", value)

    @builtins.property
    @jsii.member(jsii_name="customerTitle")
    def customer_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customerTitle"))

    @customer_title.setter
    def customer_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a48f62fe2400117914e5bcf5e00b27276bbddaca0f28150b15f2988a6148d95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customerTitle", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8e1a82e6d848f4f4a34d8ce73e603ed0d0ab026c63ba7bf534dcab4dfb97cae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f10395c1abac37ec495258e8ae6aa72821acffe8b6618e75cce1c1a5a9dec7e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="usersAction")
    def users_action(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersAction"))

    @users_action.setter
    def users_action(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96ed18f2930863fcb0e15066dd0dbc0c455ea69b61e6ae3d012b439c1ad6f1a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersAction", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameEnabled")
    def users_cname_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "usersCnameEnabled"))

    @users_cname_enabled.setter
    def users_cname_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d943bc36712d0c18a2e9502cd68df1acbde13579ec4836393e06a84eb733c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="usersCnameLevel")
    def users_cname_level(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "usersCnameLevel"))

    @users_cname_level.setter
    def users_cname_level(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbe656839cae9da10937bf077e08ac84bd9f6cb7dadb3f946109713185884111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCnameLevel", value)

    @builtins.property
    @jsii.member(jsii_name="usersCookie")
    def users_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersCookie"))

    @users_cookie.setter
    def users_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aef765f7a2fb361db321fd343f63bac5cdd39ee413ae1e488e0410e867f02a7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersCookie", value)

    @builtins.property
    @jsii.member(jsii_name="usersQueryString")
    def users_query_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersQueryString"))

    @users_query_string.setter
    def users_query_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a97c16aa45028b2a073e0612a1d6320928f98af7b4b50329dace5e79dcb9be27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="usersRegex")
    def users_regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersRegex"))

    @users_regex.setter
    def users_regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b3800dab527a74e5b48f1839d1b1f07cbabc92df9646935f7b38356b62e558ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersRegex", value)

    @builtins.property
    @jsii.member(jsii_name="usersReplace")
    def users_replace(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersReplace"))

    @users_replace.setter
    def users_replace(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcdbe24a5edb89cb65764edf400aa24cb2e3ef164f84602519f15c5ec623ceef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersReplace", value)

    @builtins.property
    @jsii.member(jsii_name="usersTitle")
    def users_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "usersTitle"))

    @users_title.setter
    def users_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8595c43ad4b1154b0cdc1ae56319e11969b1aa971f1ab76a2576c7eda2e7ae11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "usersTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d5b91e1caf0ecb49efcd3163cbdfd1402302c29f9ac6e8ead4acf8188af4472)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7bb06f7d2e0a3f1e9216937fb130d86d5fa2f8c4ef500df20af7286f8b581b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient",
    jsii_struct_bases=[],
    name_mapping={
        "allow_override_origin_cache_key": "allowOverrideOriginCacheKey",
        "connector_id": "connectorId",
        "enabled": "enabled",
        "locked": "locked",
        "origin_host_header": "originHostHeader",
        "origin_type": "originType",
        "sf3_c_origin_host": "sf3COriginHost",
        "sf3_c_origin_host_header": "sf3COriginHostHeader",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient:
    def __init__(
        self,
        *,
        allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        connector_id: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_host_header: typing.Optional[builtins.str] = None,
        origin_type: typing.Optional[builtins.str] = None,
        sf3_c_origin_host: typing.Optional[builtins.str] = None,
        sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_override_origin_cache_key: When enabled, overrides the forwarding origin's cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        :param connector_id: An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud. Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud. You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        :param enabled: Enables the Akamai Connector for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_host_header: Specifies where the ``Host`` header is defined. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        :param origin_type: Specifies where the origin is. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        :param sf3_c_origin_host: This specifies the hostname or IP address of the custom Salesforce origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        :param sf3_c_origin_host_header: This specifies the hostname or IP address of the custom Salesforce host header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__198dcfbc063f9c39165679caaae70e9e3d214d3d44c5257e9deec69127345976)
            check_type(argname="argument allow_override_origin_cache_key", value=allow_override_origin_cache_key, expected_type=type_hints["allow_override_origin_cache_key"])
            check_type(argname="argument connector_id", value=connector_id, expected_type=type_hints["connector_id"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_host_header", value=origin_host_header, expected_type=type_hints["origin_host_header"])
            check_type(argname="argument origin_type", value=origin_type, expected_type=type_hints["origin_type"])
            check_type(argname="argument sf3_c_origin_host", value=sf3_c_origin_host, expected_type=type_hints["sf3_c_origin_host"])
            check_type(argname="argument sf3_c_origin_host_header", value=sf3_c_origin_host_header, expected_type=type_hints["sf3_c_origin_host_header"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_override_origin_cache_key is not None:
            self._values["allow_override_origin_cache_key"] = allow_override_origin_cache_key
        if connector_id is not None:
            self._values["connector_id"] = connector_id
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if origin_host_header is not None:
            self._values["origin_host_header"] = origin_host_header
        if origin_type is not None:
            self._values["origin_type"] = origin_type
        if sf3_c_origin_host is not None:
            self._values["sf3_c_origin_host"] = sf3_c_origin_host
        if sf3_c_origin_host_header is not None:
            self._values["sf3_c_origin_host_header"] = sf3_c_origin_host_header
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, overrides the forwarding origin's cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_override_origin_cache_key DataAkamaiPropertyRulesBuilder#allow_override_origin_cache_key}
        '''
        result = self._values.get("allow_override_origin_cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def connector_id(self) -> typing.Optional[builtins.str]:
        '''An ID value that helps distinguish different types of traffic sent from Akamai to the Salesforce Commerce Cloud.

        Form the value as ``instance-realm-customer``, where ``instance`` is either ``production`` or ``development``, ``realm`` is your Salesforce Commerce Cloud service ``$REALM`` value, and ``customer`` is the name for your organization in Salesforce Commerce Cloud.  You can use alphanumeric characters, underscores, or dot characters within dash-delimited segment values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#connector_id DataAkamaiPropertyRulesBuilder#connector_id}
        '''
        result = self._values.get("connector_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Akamai Connector for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_host_header(self) -> typing.Optional[builtins.str]:
        '''Specifies where the ``Host`` header is defined.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_host_header DataAkamaiPropertyRulesBuilder#origin_host_header}
        '''
        result = self._values.get("origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def origin_type(self) -> typing.Optional[builtins.str]:
        '''Specifies where the origin is.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_type DataAkamaiPropertyRulesBuilder#origin_type}
        '''
        result = self._values.get("origin_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host DataAkamaiPropertyRulesBuilder#sf3c_origin_host}
        '''
        result = self._values.get("sf3_c_origin_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sf3_c_origin_host_header(self) -> typing.Optional[builtins.str]:
        '''This specifies the hostname or IP address of the custom Salesforce host header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sf3c_origin_host_header DataAkamaiPropertyRulesBuilder#sf3c_origin_host_header}
        '''
        result = self._values.get("sf3_c_origin_host_header")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClientOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClientOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9bc9db6df4b215b0513d2914ef5c4119d4254c8bf6eb62a8770ec96dbb70af1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowOverrideOriginCacheKey")
    def reset_allow_override_origin_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowOverrideOriginCacheKey", []))

    @jsii.member(jsii_name="resetConnectorId")
    def reset_connector_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConnectorId", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginHostHeader")
    def reset_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginHostHeader", []))

    @jsii.member(jsii_name="resetOriginType")
    def reset_origin_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginType", []))

    @jsii.member(jsii_name="resetSf3COriginHost")
    def reset_sf3_c_origin_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHost", []))

    @jsii.member(jsii_name="resetSf3COriginHostHeader")
    def reset_sf3_c_origin_host_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSf3COriginHostHeader", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKeyInput")
    def allow_override_origin_cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowOverrideOriginCacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="connectorIdInput")
    def connector_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "connectorIdInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originHostHeaderInput")
    def origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="originTypeInput")
    def origin_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeaderInput")
    def sf3_c_origin_host_header_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostInput")
    def sf3_c_origin_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "sf3COriginHostInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowOverrideOriginCacheKey")
    def allow_override_origin_cache_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowOverrideOriginCacheKey"))

    @allow_override_origin_cache_key.setter
    def allow_override_origin_cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fec176e6bf876f72fb6dfa3d75e2ab1a7f046b4f6017e38c088bff0713643a91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowOverrideOriginCacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="connectorId")
    def connector_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "connectorId"))

    @connector_id.setter
    def connector_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa932d32aa6d0ca7dbc90b96ba2fdce977d88338868a47dcb903033c29209b3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "connectorId", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__61391b65e412606bf9ce31055c9499493ad7699791e5876616021ab8754ddcbb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fc008bdde963b1f4e6af2629de2d4bf211521b3cee894340e1a29f56e7f4a4f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originHostHeader")
    def origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originHostHeader"))

    @origin_host_header.setter
    def origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee3f7613447a695c1bfe0b3336ed975a2c55aa39e13f37528e8f10210eaacedf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="originType")
    def origin_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originType"))

    @origin_type.setter
    def origin_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6333ec8f16387d19d43d6d9d5400ec7225c6d4ea20c1bd5b4dcf720f7cf80638)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originType", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHost")
    def sf3_c_origin_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHost"))

    @sf3_c_origin_host.setter
    def sf3_c_origin_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5788379d03b952dfbb50ebd2d6064a5bc20fe762176e21da27d32fd970871e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHost", value)

    @builtins.property
    @jsii.member(jsii_name="sf3COriginHostHeader")
    def sf3_c_origin_host_header(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "sf3COriginHostHeader"))

    @sf3_c_origin_host_header.setter
    def sf3_c_origin_host_header(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03fdac6ebc738dc66fcaf22c84a244220f05c35235eb82389e4406223744f731)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sf3COriginHostHeader", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5c9252560055dc13286d7965c236b3f655649154e6e2903ddb23402f181a72b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b9db22fa6ca9803d0502c623bf775906b40b4f9c8d1e8c3ad9a54cfbb385f42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67060902c7c5a7eeb7c65f80879bbc4e7d0fa4209aa1d719ff9bf6b0a9832988)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables Akamai Provider for Salesforce Commerce Cloud. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3603b6e27bf03181e3cd390a7d5ad107507508e0430eff6549c998effd34b79a)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables Akamai Provider for Salesforce Commerce Cloud.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader",
    jsii_struct_bases=[],
    name_mapping={
        "host_header_source": "hostHeaderSource",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader:
    def __init__(
        self,
        *,
        host_header_source: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param host_header_source: Specify where the host header derives from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__063592a1188fc5e6712334d5e7b84a0038aa704991ecac79236549dace2f7585)
            check_type(argname="argument host_header_source", value=host_header_source, expected_type=type_hints["host_header_source"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if host_header_source is not None:
            self._values["host_header_source"] = host_header_source
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def host_header_source(self) -> typing.Optional[builtins.str]:
        '''Specify where the host header derives from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#host_header_source DataAkamaiPropertyRulesBuilder#host_header_source}
        '''
        result = self._values.get("host_header_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18fe29fdd1bc80175cdc1a4bb61fd955b4957f1ff5bb66fedbc1fdbcfb2063ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHostHeaderSource")
    def reset_host_header_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostHeaderSource", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSourceInput")
    def host_header_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hostHeaderSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="hostHeaderSource")
    def host_header_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hostHeaderSource"))

    @host_header_source.setter
    def host_header_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd9a11d8f274c4e7ed2bde479cf3a359178ef48705964a1aea769c864f831ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hostHeaderSource", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a1d6dd2eb84ad9767f489a9b9fd1d828dfd980b3f17c3559c0853338f80ff1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46fe0f88b5b52430c5bb674788d035ff1c6f881364618f8768e7438a7633541b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c92c500935d1cd03cf1202aa856be85dddfbd2e6c3c3f000dec8398b59174163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0db4744e99eeecdb7f1fa9989fcae7ded9c9296057d47176bcca8751501ea4b0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dd48c38a60395f896821cc534b6a98eaae65275de16e007cda8d2cb3b46ae1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463cf8dd56131b3c2889a65d7c8109afd8c60c0b18cd2e76873678a1627bbc21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53128aa13dff40b82ce856736ce55967344ccc0f3db7d19f5d542cf06c88d7f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d80eebada80bbe23ff25d018cbd29471c6a5e83d17809813e093c43410c5dcd2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc49419efd0bdff58a5c59910b99989486539d63d3d60c1305ffddf7509f25b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36ebca3bcace3f9991faada8ca2fc0acf77e782b9ce76b3eb9550bd83ab4845e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables processing of POST requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cebddfd88e699c5c19de0989527cce7907263704d24cd084ef0a8029c623dc2)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables processing of POST requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13f346edb2ddf0d83249bc2d2acb4531447bb58d160d1262a9526409e18cacd)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__75a9f24017cb61d42347d79a72450bdba56b8f038c6ea2ef943d998a91024a7a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdd5059f6c1d014a393374ad15b6b1555f7141429d31e8521397382e4210dd86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6065311ded0edf7b21ed214af146524801092238b5786f8d5354f83189ca9837)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2fee66ac9f0d73a6fd3d3e24ae5d53d6e1d2bf637fb656b3b8b0e00e89bf40d2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a00d58e5c61d965ff15d5e3691e9cc8c20eed862401f205cca1bbf944a701fe6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "refresh_method": "refreshMethod",
        "repeat": "repeat",
        "repeat_interval": "repeatInterval",
        "start": "start",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_method: typing.Optional[builtins.str] = None,
        repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param refresh_method: Specifies how to invalidate the content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        :param repeat: When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        :param repeat_interval: Specifies how often to invalidate content from the ``start`` time, expressed in seconds. For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day. Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param start: The UTC date and time when matching cached content is to expire. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9684b6f1cfbe2b69fb76131893d99f24785c2935d16d52e657aa63a6aaa3939)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument refresh_method", value=refresh_method, expected_type=type_hints["refresh_method"])
            check_type(argname="argument repeat", value=repeat, expected_type=type_hints["repeat"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument start", value=start, expected_type=type_hints["start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if refresh_method is not None:
            self._values["refresh_method"] = refresh_method
        if repeat is not None:
            self._values["repeat"] = repeat
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if start is not None:
            self._values["start"] = start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_method(self) -> typing.Optional[builtins.str]:
        '''Specifies how to invalidate the content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_method DataAkamaiPropertyRulesBuilder#refresh_method}
        '''
        result = self._values.get("refresh_method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, invalidation recurs periodically from the ``start`` time based on the ``repeatInterval`` time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat DataAkamaiPropertyRulesBuilder#repeat}
        '''
        result = self._values.get("repeat")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Specifies how often to invalidate content from the ``start`` time, expressed in seconds.

        For example, an expiration set to midnight and an interval of ``86400`` seconds invalidates content once a day.  Repeating intervals of less than 5 minutes are not allowed for ``NetStorage`` origins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start(self) -> typing.Optional[builtins.str]:
        '''The UTC date and time when matching cached content is to expire.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start DataAkamaiPropertyRulesBuilder#start}
        '''
        result = self._values.get("start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e29be8e44b0c7d73ab8767a54cf2a17ee61a336d13726dec69e909bf4cf9bae6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRefreshMethod")
    def reset_refresh_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshMethod", []))

    @jsii.member(jsii_name="resetRepeat")
    def reset_repeat(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeat", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetStart")
    def reset_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshMethodInput")
    def refresh_method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "refreshMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatInput")
    def repeat_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "repeatInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="startInput")
    def start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dbdb0f2583d7f48744d22b26165505a79d027660e7c9621f5e83289d85ae5039)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="refreshMethod")
    def refresh_method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "refreshMethod"))

    @refresh_method.setter
    def refresh_method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac6ed57a9774ec188e5042af30e13837188554744d68678b6e78df6e13e7dd1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshMethod", value)

    @builtins.property
    @jsii.member(jsii_name="repeat")
    def repeat(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "repeat"))

    @repeat.setter
    def repeat(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66136d877c08717ffe402516a3962de6fdd4b69153bcbc898b63ef1d3f7a1e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeat", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f9429f68d049bffa2bcc6192f082bad1740bee8ed276c4cfb4e0ab6425c2343)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="start")
    def start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "start"))

    @start.setter
    def start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c727f7025bdf8857c316968f701c1d32a60b6a11c1c21576ac85a896a47bc121)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "start", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__470cc246f8b7af90e15a9251ea141cbe0b9cbb9fae3b5f09e109f8d3537289c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1371dd0f6851fa940319b6e9cd4cbc70b905e61d5b9ae82a45087c80f88f2f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c05aad0147aa60faefb29fa9191536ebf95a48384b0d1d345632d08f1c4504b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "serviceworker": "serviceworker",
        "template_uuid": "templateUuid",
        "timestamp": "timestamp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serviceworker: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timestamp: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the Script Management feature. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param serviceworker: Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timestamp: A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06afd6ba79d44eaff4bce5f679de8820a70ad5d234f7edfdae7d5cd50ab89cf7)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument serviceworker", value=serviceworker, expected_type=type_hints["serviceworker"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timestamp", value=timestamp, expected_type=type_hints["timestamp"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if serviceworker is not None:
            self._values["serviceworker"] = serviceworker
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timestamp is not None:
            self._values["timestamp"] = timestamp
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Script Management feature.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serviceworker(self) -> typing.Optional[builtins.str]:
        '''Script Management uses a JavaScript service worker called ``akam-sw.js``. It applies a policy that helps you manage scripts.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serviceworker DataAkamaiPropertyRulesBuilder#serviceworker}
        '''
        result = self._values.get("serviceworker")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timestamp(self) -> typing.Optional[jsii.Number]:
        '''A read-only epoch timestamp that represents the last time a Script Management policy was synchronized with its Ion property.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timestamp DataAkamaiPropertyRulesBuilder#timestamp}
        '''
        result = self._values.get("timestamp")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagementOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagementOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__436f55944fe184bf711eba1a4c5f8c2fe3f984c14b0d23acad22c99d04bf1e53)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetServiceworker")
    def reset_serviceworker(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServiceworker", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimestamp")
    def reset_timestamp(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimestamp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="serviceworkerInput")
    def serviceworker_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serviceworkerInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timestampInput")
    def timestamp_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "timestampInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7add2ca197e97f3ad03f549b056a35a2aebfb581d38b3365d1f12bdbbc4093a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__859d9e3826f7dc29ae9287f201047c162f35a1f274f087c5460dc0fafaa6b373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="serviceworker")
    def serviceworker(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serviceworker"))

    @serviceworker.setter
    def serviceworker(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b41822a5984a81c0230a4c233d9d4463de3765caf3ffe874148388d70c88fdd7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serviceworker", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__263fa6313257e10cbc7137e74c032d3f01f103820191ce6c776b73e32d8713f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timestamp")
    def timestamp(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "timestamp"))

    @timestamp.setter
    def timestamp(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03dab271fe61ad3fbd02b6f1c5bd580abae9c14e4fdd9bddff084b907d528030)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timestamp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7c4278935c9f0a6d139a9d290045806b7a50c1891aa56f9577b91d9777bc9463)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da0ffaf40f23a6f933e8c19ba0fcdc2fec072c93683b6a3208b8ee3ccdf26d42)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection",
    jsii_struct_bases=[],
    name_mapping={
        "acl": "acl",
        "dash_media_encryption": "dashMediaEncryption",
        "data_payload": "dataPayload",
        "enabled": "enabled",
        "enable_token_in_uri": "enableTokenInUri",
        "field_carry_over": "fieldCarryOver",
        "header_for_salt": "headerForSalt",
        "hls_master_manifest_files": "hlsMasterManifestFiles",
        "hls_media_encryption": "hlsMediaEncryption",
        "ip": "ip",
        "key": "key",
        "locked": "locked",
        "media_encryption_title": "mediaEncryptionTitle",
        "revoked_list_id": "revokedListId",
        "salt": "salt",
        "session_id": "sessionId",
        "template_uuid": "templateUuid",
        "token_authentication_title": "tokenAuthenticationTitle",
        "token_auth_hls_title": "tokenAuthHlsTitle",
        "token_revocation_enabled": "tokenRevocationEnabled",
        "token_revocation_title": "tokenRevocationTitle",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection:
    def __init__(
        self,
        *,
        acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        field_carry_over: typing.Optional[builtins.str] = None,
        header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
        hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        media_encryption_title: typing.Optional[builtins.str] = None,
        revoked_list_id: typing.Optional[jsii.Number] = None,
        salt: typing.Optional[builtins.str] = None,
        session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authentication_title: typing.Optional[builtins.str] = None,
        token_auth_hls_title: typing.Optional[builtins.str] = None,
        token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        token_revocation_title: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param acl: Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field. Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        :param dash_media_encryption: Whether to enable DASH Media Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        :param data_payload: Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        :param enabled: Enables the segmented content protection behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param enable_token_in_uri: When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        :param field_carry_over: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        :param header_for_salt: This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session. This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        :param hls_master_manifest_files: Specifies the set of filenames that form HLS master manifest URLs. You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        :param hls_media_encryption: Enables HLS Segment Encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        :param ip: Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param key: Specifies the encryption key to use as a shared secret to validate tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param media_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        :param revoked_list_id: Identifies the ``TokenAuth`` tokens to block from accessing your content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        :param salt: Specifies a salt as input into the token for added security. This value needs to match the salt used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param session_id: Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authentication_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        :param token_auth_hls_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        :param token_revocation_enabled: Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        :param token_revocation_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        :param transition_key: An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: Allows you to specify advanced ``transitionKey`` and ``salt`` options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ec91e5f7368b564ff96464966424b9021828c149d2621bf860231208a13821e)
            check_type(argname="argument acl", value=acl, expected_type=type_hints["acl"])
            check_type(argname="argument dash_media_encryption", value=dash_media_encryption, expected_type=type_hints["dash_media_encryption"])
            check_type(argname="argument data_payload", value=data_payload, expected_type=type_hints["data_payload"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument enable_token_in_uri", value=enable_token_in_uri, expected_type=type_hints["enable_token_in_uri"])
            check_type(argname="argument field_carry_over", value=field_carry_over, expected_type=type_hints["field_carry_over"])
            check_type(argname="argument header_for_salt", value=header_for_salt, expected_type=type_hints["header_for_salt"])
            check_type(argname="argument hls_master_manifest_files", value=hls_master_manifest_files, expected_type=type_hints["hls_master_manifest_files"])
            check_type(argname="argument hls_media_encryption", value=hls_media_encryption, expected_type=type_hints["hls_media_encryption"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument media_encryption_title", value=media_encryption_title, expected_type=type_hints["media_encryption_title"])
            check_type(argname="argument revoked_list_id", value=revoked_list_id, expected_type=type_hints["revoked_list_id"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument session_id", value=session_id, expected_type=type_hints["session_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authentication_title", value=token_authentication_title, expected_type=type_hints["token_authentication_title"])
            check_type(argname="argument token_auth_hls_title", value=token_auth_hls_title, expected_type=type_hints["token_auth_hls_title"])
            check_type(argname="argument token_revocation_enabled", value=token_revocation_enabled, expected_type=type_hints["token_revocation_enabled"])
            check_type(argname="argument token_revocation_title", value=token_revocation_title, expected_type=type_hints["token_revocation_title"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if acl is not None:
            self._values["acl"] = acl
        if dash_media_encryption is not None:
            self._values["dash_media_encryption"] = dash_media_encryption
        if data_payload is not None:
            self._values["data_payload"] = data_payload
        if enabled is not None:
            self._values["enabled"] = enabled
        if enable_token_in_uri is not None:
            self._values["enable_token_in_uri"] = enable_token_in_uri
        if field_carry_over is not None:
            self._values["field_carry_over"] = field_carry_over
        if header_for_salt is not None:
            self._values["header_for_salt"] = header_for_salt
        if hls_master_manifest_files is not None:
            self._values["hls_master_manifest_files"] = hls_master_manifest_files
        if hls_media_encryption is not None:
            self._values["hls_media_encryption"] = hls_media_encryption
        if ip is not None:
            self._values["ip"] = ip
        if key is not None:
            self._values["key"] = key
        if locked is not None:
            self._values["locked"] = locked
        if media_encryption_title is not None:
            self._values["media_encryption_title"] = media_encryption_title
        if revoked_list_id is not None:
            self._values["revoked_list_id"] = revoked_list_id
        if salt is not None:
            self._values["salt"] = salt
        if session_id is not None:
            self._values["session_id"] = session_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authentication_title is not None:
            self._values["token_authentication_title"] = token_authentication_title
        if token_auth_hls_title is not None:
            self._values["token_auth_hls_title"] = token_auth_hls_title
        if token_revocation_enabled is not None:
            self._values["token_revocation_enabled"] = token_revocation_enabled
        if token_revocation_title is not None:
            self._values["token_revocation_title"] = token_revocation_title
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def acl(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``ACL`` field from the access token over to the session token, to limit the requesting client's access to the specific URL or path set in the ``ACL`` field.

        Playback may fail if the base path of the master playlist (and variant playlist, plus segments) varies from that of the ``ACL`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#acl DataAkamaiPropertyRulesBuilder#acl}
        '''
        result = self._values.get("acl")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dash_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether to enable DASH Media Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dash_media_encryption DataAkamaiPropertyRulesBuilder#dash_media_encryption}
        '''
        result = self._values.get("dash_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def data_payload(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``data/payload`` field from the access token over to the session token, allowing access to opaque data for log analysis for a URL protected by a session token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#data_payload DataAkamaiPropertyRulesBuilder#data_payload}
        '''
        result = self._values.get("data_payload")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the segmented content protection behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_token_in_uri(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, passes tokens in HLS variant manifest URLs and HLS segment URLs, as an alternative to cookies.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_token_in_uri DataAkamaiPropertyRulesBuilder#enable_token_in_uri}
        '''
        result = self._values.get("enable_token_in_uri")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def field_carry_over(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field_carry_over DataAkamaiPropertyRulesBuilder#field_carry_over}
        '''
        result = self._values.get("field_carry_over")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_for_salt(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This allows you to include additional salt properties specific to each end user to strengthen the relationship between the session token and playback session.

        This specifies the set of request headers whose values generate the salt value, typically ``User-Agent``, ``X-Playback-Session-Id``, and ``Origin``. Any specified header needs to appear in the player's request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_for_salt DataAkamaiPropertyRulesBuilder#header_for_salt}
        '''
        result = self._values.get("header_for_salt")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_master_manifest_files(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies the set of filenames that form HLS master manifest URLs.

        You can use ``*`` wildcard character that matches zero or more characters. Make sure to specify master manifest filenames uniquely, to distinguish them from variant manifest files.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_master_manifest_files DataAkamaiPropertyRulesBuilder#hls_master_manifest_files}
        '''
        result = self._values.get("hls_master_manifest_files")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def hls_media_encryption(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables HLS Segment Encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hls_media_encryption DataAkamaiPropertyRulesBuilder#hls_media_encryption}
        '''
        result = self._values.get("hls_media_encryption")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this restricts content access to a specific IP address, only appropriate if it does not change during the playback session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption key to use as a shared secret to validate tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def media_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#media_encryption_title DataAkamaiPropertyRulesBuilder#media_encryption_title}
        '''
        result = self._values.get("media_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def revoked_list_id(self) -> typing.Optional[jsii.Number]:
        '''Identifies the ``TokenAuth`` tokens to block from accessing your content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#revoked_list_id DataAkamaiPropertyRulesBuilder#revoked_list_id}
        '''
        result = self._values.get("revoked_list_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt as input into the token for added security.

        This value needs to match the salt used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def session_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option carries the ``session_id`` value from the access token over to the session token, for use in tracking and counting unique playback sessions.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_id DataAkamaiPropertyRulesBuilder#session_id}
        '''
        result = self._values.get("session_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authentication_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authentication_title DataAkamaiPropertyRulesBuilder#token_authentication_title}
        '''
        result = self._values.get("token_authentication_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_auth_hls_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_auth_hls_title DataAkamaiPropertyRulesBuilder#token_auth_hls_title}
        '''
        result = self._values.get("token_auth_hls_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_revocation_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enable this to deny requests from playback URLs that contain a ``TokenAuth`` token that uses specific token identifiers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_enabled DataAkamaiPropertyRulesBuilder#token_revocation_enabled}
        '''
        result = self._values.get("token_revocation_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def token_revocation_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_revocation_title DataAkamaiPropertyRulesBuilder#token_revocation_title}
        '''
        result = self._values.get("token_revocation_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''An alternate encryption key to match along with the ``key`` field, allowing you to rotate keys with no down time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to specify advanced ``transitionKey`` and ``salt`` options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtectionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtectionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56008c61c98747255746f572a1d6ba9c9f460940bc6bd7d32e35979ca0f44a79)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAcl")
    def reset_acl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAcl", []))

    @jsii.member(jsii_name="resetDashMediaEncryption")
    def reset_dash_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDashMediaEncryption", []))

    @jsii.member(jsii_name="resetDataPayload")
    def reset_data_payload(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDataPayload", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetEnableTokenInUri")
    def reset_enable_token_in_uri(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableTokenInUri", []))

    @jsii.member(jsii_name="resetFieldCarryOver")
    def reset_field_carry_over(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFieldCarryOver", []))

    @jsii.member(jsii_name="resetHeaderForSalt")
    def reset_header_for_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderForSalt", []))

    @jsii.member(jsii_name="resetHlsMasterManifestFiles")
    def reset_hls_master_manifest_files(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMasterManifestFiles", []))

    @jsii.member(jsii_name="resetHlsMediaEncryption")
    def reset_hls_media_encryption(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHlsMediaEncryption", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMediaEncryptionTitle")
    def reset_media_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMediaEncryptionTitle", []))

    @jsii.member(jsii_name="resetRevokedListId")
    def reset_revoked_list_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRevokedListId", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetSessionId")
    def reset_session_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthenticationTitle")
    def reset_token_authentication_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthenticationTitle", []))

    @jsii.member(jsii_name="resetTokenAuthHlsTitle")
    def reset_token_auth_hls_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthHlsTitle", []))

    @jsii.member(jsii_name="resetTokenRevocationEnabled")
    def reset_token_revocation_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationEnabled", []))

    @jsii.member(jsii_name="resetTokenRevocationTitle")
    def reset_token_revocation_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenRevocationTitle", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="aclInput")
    def acl_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "aclInput"))

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryptionInput")
    def dash_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dashMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="dataPayloadInput")
    def data_payload_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dataPayloadInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUriInput")
    def enable_token_in_uri_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableTokenInUriInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOverInput")
    def field_carry_over_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldCarryOverInput"))

    @builtins.property
    @jsii.member(jsii_name="headerForSaltInput")
    def header_for_salt_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "headerForSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFilesInput")
    def hls_master_manifest_files_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "hlsMasterManifestFilesInput"))

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryptionInput")
    def hls_media_encryption_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hlsMediaEncryptionInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitleInput")
    def media_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "mediaEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="revokedListIdInput")
    def revoked_list_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "revokedListIdInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionIdInput")
    def session_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitleInput")
    def token_authentication_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthenticationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitleInput")
    def token_auth_hls_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenAuthHlsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabledInput")
    def token_revocation_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenRevocationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitleInput")
    def token_revocation_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenRevocationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="acl")
    def acl(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "acl"))

    @acl.setter
    def acl(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a1864960950f92ca562f1b6e8d39e39e192335ea1faa0d1a35ddfb221e19c6b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "acl", value)

    @builtins.property
    @jsii.member(jsii_name="dashMediaEncryption")
    def dash_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dashMediaEncryption"))

    @dash_media_encryption.setter
    def dash_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63bb27773724229106a6c6f6d28e9ce370ba67529efcc1fb05ceda0176774254)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dashMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="dataPayload")
    def data_payload(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dataPayload"))

    @data_payload.setter
    def data_payload(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4d602e7d4b4d88cdc0d2c29be0702b01ca9b22c4285ce9b296e0cad9d135332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dataPayload", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ef16ba1cef94a61b9a27410febaec9a5fa3eb49df2f256895f379ed22a1c966)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="enableTokenInUri")
    def enable_token_in_uri(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableTokenInUri"))

    @enable_token_in_uri.setter
    def enable_token_in_uri(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e9f6e9f6d4e067ea959a58a5e714322a31ccc19a6b90f50336aa9e91f8c7a6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableTokenInUri", value)

    @builtins.property
    @jsii.member(jsii_name="fieldCarryOver")
    def field_carry_over(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fieldCarryOver"))

    @field_carry_over.setter
    def field_carry_over(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__168d28fefb19a420d7b4a256240a74531866693231f8f3111589a5afe27e06f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fieldCarryOver", value)

    @builtins.property
    @jsii.member(jsii_name="headerForSalt")
    def header_for_salt(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "headerForSalt"))

    @header_for_salt.setter
    def header_for_salt(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81fa0a8d5a66545fc7ba7d289c5195cd4a9a7814d1de17ed91fc25999df7c523)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerForSalt", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMasterManifestFiles")
    def hls_master_manifest_files(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "hlsMasterManifestFiles"))

    @hls_master_manifest_files.setter
    def hls_master_manifest_files(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac9c3c6bb987bbbae61cd76b7a42cca04873dd1c3ac3226bb79f7557a72b4fdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMasterManifestFiles", value)

    @builtins.property
    @jsii.member(jsii_name="hlsMediaEncryption")
    def hls_media_encryption(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hlsMediaEncryption"))

    @hls_media_encryption.setter
    def hls_media_encryption(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44e177be7f2d37e9d6703ef626ae57d4bb86be8c6aef162558c7ba4ff8b3a503)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hlsMediaEncryption", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3d9a7ed731c36935e498e1c3d37f053c28dc2934c90c48291557963e2177228)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce8ec2bcb903cb05b36dc6bf8bf38b9ac49dc67715f50381d41d19c74139ad4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7db551c904456642672ec33ac2c73087ce230e70ee4ba2e3ff6a8d3e969cd2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mediaEncryptionTitle")
    def media_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "mediaEncryptionTitle"))

    @media_encryption_title.setter
    def media_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3049dec4d12c3073e2b889584bf9135cb7f2fae4926a26fd87fd7adcfd2d8027)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mediaEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="revokedListId")
    def revoked_list_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "revokedListId"))

    @revoked_list_id.setter
    def revoked_list_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5613b4dd9983130e2e1e01b3324c7863a396634f5775b6c3a44506e0cabe3223)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "revokedListId", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99ee2947c420bedab183663d79da8b41ae36003a449444e876cd2dc965db353)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="sessionId")
    def session_id(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionId"))

    @session_id.setter
    def session_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e3af3923c4613be66a50b7bc9e32ed7f71a99ec945e7d7c64a8058ca4835149)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cfc595e30b75c9df7a7f2392140ddba3bea9f065525e46fb956533ff0d2df98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthenticationTitle")
    def token_authentication_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthenticationTitle"))

    @token_authentication_title.setter
    def token_authentication_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9224cf26f354d4a10f51af2838a287a66711107c3ca92d40f131d523e9565526)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthenticationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthHlsTitle")
    def token_auth_hls_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenAuthHlsTitle"))

    @token_auth_hls_title.setter
    def token_auth_hls_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4cf050f50e88c09c9433ea8a5b64c6a31f4cc1d0f18ebdb837c52d485053af0c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthHlsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationEnabled")
    def token_revocation_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenRevocationEnabled"))

    @token_revocation_enabled.setter
    def token_revocation_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ecc820650753ca5812c5524b14b0d37a358d3e4cf704f3ae7858b2914a0a90c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="tokenRevocationTitle")
    def token_revocation_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenRevocationTitle"))

    @token_revocation_title.setter
    def token_revocation_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f16f1068385b61a783e8cbf78beb49d4196dfd2e5cafe852fa01d380fdce7f00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenRevocationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4af4117faa3697f7519271e30f4c07648ca1cedbe8f3c8af90db8e1ed494c8ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b06b80d45e3f5040b669cb4137ed732e66cb18eaec0899f1c512af6481ae88e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__851aa21ffdcc301de3c7aeed20c63220b11741ff625f04cd46c451e9d5d16b19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c417029ccf849ae99b77d6f666e148ffd8eb7265c178dab41c03fe05baec3986)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "behavior": "behavior",
        "dvr_type": "dvrType",
        "dvr_window": "dvrWindow",
        "enable_ull_streaming": "enableUllStreaming",
        "end_time": "endTime",
        "live_type": "liveType",
        "locked": "locked",
        "show_advanced": "showAdvanced",
        "start_time": "startTime",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization:
    def __init__(
        self,
        *,
        behavior: typing.Optional[builtins.str] = None,
        dvr_type: typing.Optional[builtins.str] = None,
        dvr_window: typing.Optional[builtins.str] = None,
        enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        end_time: typing.Optional[builtins.str] = None,
        live_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        start_time: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param behavior: Sets the type of media content to optimize. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        :param dvr_type: The type of DVR. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        :param dvr_window: Set the duration for your media, or ``0m`` if a DVR is not required. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        :param enable_ull_streaming: Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        :param end_time: This specifies when the live media event ends. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        :param live_type: The type of live media. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param show_advanced: Allows you to configure advanced media options. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        :param start_time: This specifies when the live media event begins. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__871edcea16131a1cdfbb7fde0b3d835f5ec1fc17473b3dafbb3f1864f7ea0e0b)
            check_type(argname="argument behavior", value=behavior, expected_type=type_hints["behavior"])
            check_type(argname="argument dvr_type", value=dvr_type, expected_type=type_hints["dvr_type"])
            check_type(argname="argument dvr_window", value=dvr_window, expected_type=type_hints["dvr_window"])
            check_type(argname="argument enable_ull_streaming", value=enable_ull_streaming, expected_type=type_hints["enable_ull_streaming"])
            check_type(argname="argument end_time", value=end_time, expected_type=type_hints["end_time"])
            check_type(argname="argument live_type", value=live_type, expected_type=type_hints["live_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument show_advanced", value=show_advanced, expected_type=type_hints["show_advanced"])
            check_type(argname="argument start_time", value=start_time, expected_type=type_hints["start_time"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if behavior is not None:
            self._values["behavior"] = behavior
        if dvr_type is not None:
            self._values["dvr_type"] = dvr_type
        if dvr_window is not None:
            self._values["dvr_window"] = dvr_window
        if enable_ull_streaming is not None:
            self._values["enable_ull_streaming"] = enable_ull_streaming
        if end_time is not None:
            self._values["end_time"] = end_time
        if live_type is not None:
            self._values["live_type"] = live_type
        if locked is not None:
            self._values["locked"] = locked
        if show_advanced is not None:
            self._values["show_advanced"] = show_advanced
        if start_time is not None:
            self._values["start_time"] = start_time
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def behavior(self) -> typing.Optional[builtins.str]:
        '''Sets the type of media content to optimize.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#behavior DataAkamaiPropertyRulesBuilder#behavior}
        '''
        result = self._values.get("behavior")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_type(self) -> typing.Optional[builtins.str]:
        '''The type of DVR.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_type DataAkamaiPropertyRulesBuilder#dvr_type}
        '''
        result = self._values.get("dvr_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def dvr_window(self) -> typing.Optional[builtins.str]:
        '''Set the duration for your media, or ``0m`` if a DVR is not required.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dvr_window DataAkamaiPropertyRulesBuilder#dvr_window}
        '''
        result = self._values.get("dvr_window")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_ull_streaming(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables ultra low latency (ULL) streaming. ULL reduces latency and decreases overall transfer time of live streams.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_ull_streaming DataAkamaiPropertyRulesBuilder#enable_ull_streaming}
        '''
        result = self._values.get("enable_ull_streaming")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def end_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event ends.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_time DataAkamaiPropertyRulesBuilder#end_time}
        '''
        result = self._values.get("end_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def live_type(self) -> typing.Optional[builtins.str]:
        '''The type of live media.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_type DataAkamaiPropertyRulesBuilder#live_type}
        '''
        result = self._values.get("live_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def show_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure advanced media options.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#show_advanced DataAkamaiPropertyRulesBuilder#show_advanced}
        '''
        result = self._values.get("show_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def start_time(self) -> typing.Optional[builtins.str]:
        '''This specifies when the live media event begins.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_time DataAkamaiPropertyRulesBuilder#start_time}
        '''
        result = self._values.get("start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__893cd9e9e6db1ee10ea7ef266b049e8d9c42e404c5857fb988649f3c1dde52c6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetDvrType")
    def reset_dvr_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrType", []))

    @jsii.member(jsii_name="resetDvrWindow")
    def reset_dvr_window(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDvrWindow", []))

    @jsii.member(jsii_name="resetEnableUllStreaming")
    def reset_enable_ull_streaming(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableUllStreaming", []))

    @jsii.member(jsii_name="resetEndTime")
    def reset_end_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndTime", []))

    @jsii.member(jsii_name="resetLiveType")
    def reset_live_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetShowAdvanced")
    def reset_show_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetShowAdvanced", []))

    @jsii.member(jsii_name="resetStartTime")
    def reset_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartTime", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrTypeInput")
    def dvr_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="dvrWindowInput")
    def dvr_window_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "dvrWindowInput"))

    @builtins.property
    @jsii.member(jsii_name="enableUllStreamingInput")
    def enable_ull_streaming_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableUllStreamingInput"))

    @builtins.property
    @jsii.member(jsii_name="endTimeInput")
    def end_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="liveTypeInput")
    def live_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "liveTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="showAdvancedInput")
    def show_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "showAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="startTimeInput")
    def start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "startTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "behavior"))

    @behavior.setter
    def behavior(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d24a21fff83781379d676769ed75f8162ce841d76f795e7a050bca477cbb8ef3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "behavior", value)

    @builtins.property
    @jsii.member(jsii_name="dvrType")
    def dvr_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrType"))

    @dvr_type.setter
    def dvr_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__341e8a47ec19384208410c755fff13e7bff7dc4a41555f379a3379a4c52b7c47)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrType", value)

    @builtins.property
    @jsii.member(jsii_name="dvrWindow")
    def dvr_window(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "dvrWindow"))

    @dvr_window.setter
    def dvr_window(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cbcaa8218af4516c7906d3a37505a297cb47994e69bcca73a6fa7d716512099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dvrWindow", value)

    @builtins.property
    @jsii.member(jsii_name="enableUllStreaming")
    def enable_ull_streaming(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableUllStreaming"))

    @enable_ull_streaming.setter
    def enable_ull_streaming(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75b3bd8f7432308b0dca0f93ba94e454df15c540d4488baace031d9bef4dcfb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableUllStreaming", value)

    @builtins.property
    @jsii.member(jsii_name="endTime")
    def end_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endTime"))

    @end_time.setter
    def end_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97d2b697e0f02b86ec762cd06c7054c528ea237727e727a7af4c81da3f174aba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endTime", value)

    @builtins.property
    @jsii.member(jsii_name="liveType")
    def live_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "liveType"))

    @live_type.setter
    def live_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fb7bb050c1a59ea6562bb8df66b3b529ae2365137137017dbec611c6d7db404)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__40d081544a29e4c35e2a771c1f024866a1f23883387d295d0068090f7d284111)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="showAdvanced")
    def show_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "showAdvanced"))

    @show_advanced.setter
    def show_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd4b6d7a674376c536b262a64f021842cc87cd6a284b4f14c043584ae5cc1ce1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "showAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="startTime")
    def start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "startTime"))

    @start_time.setter
    def start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7a8e7735961eadc1e2c64d54e3e2ba979ed8666f9721fb48e670a0c597e71c99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startTime", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__172540afee6c64f3c2c0c56fe1cb2a42e1f316817c5b6c31c20fa72080d9a175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac03b658203555e336fb5851bf61aaf5063c3af9f95a0f1d331163171e7f15cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec2a9a69e56bacbbc98c01e2a5cf4ecfec211adc586eddaf67eb9a986d57217)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables media stream prefetching. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__313de4a7775d81a9eb8654741a7135b89372007d87dde2ecbfa60d6ae89d6ae3)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables media stream prefetching.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c55958466a391e4134b43a46bd4870f089e0e60172b82677779a8e856b44313)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2acaf290158e8025f29c649b1d76f8c029da560a709eb2e873aa713d3868f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1b823aa9dbfea39e10ab2c9607597f0780e6e9015375349b9ac3a66f79b84889)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5899e0d73841f4a5c4ed44a9123f2cf4f24158f88587d0d9142a59344858d97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99951e570a0307e6cfa49bf9f0867b3edc379e4af2b0ee92266b437824aeb78f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__855f3b5eacac175c2ce7554f80cfa225e5ec75efb98d13a4f32e6e0cd60e2024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "case_sensitive": "caseSensitive",
        "certificate_field_name": "certificateFieldName",
        "cookie_name": "cookieName",
        "device_profile": "deviceProfile",
        "encryption_key": "encryptionKey",
        "encryption_mode": "encryptionMode",
        "end_index": "endIndex",
        "except_chars": "exceptChars",
        "extract_location": "extractLocation",
        "force_chars": "forceChars",
        "format_string": "formatString",
        "generator": "generator",
        "global_substitution": "globalSubstitution",
        "header_name": "headerName",
        "hmac_algorithm": "hmacAlgorithm",
        "hmac_key": "hmacKey",
        "initialization_vector": "initializationVector",
        "ipv4_prefix": "ipv4Prefix",
        "ipv6_prefix": "ipv6Prefix",
        "ip_version": "ipVersion",
        "location_id": "locationId",
        "locked": "locked",
        "max": "max",
        "max_random_number": "maxRandomNumber",
        "min": "min",
        "min_random_number": "minRandomNumber",
        "nonce": "nonce",
        "number_of_bytes": "numberOfBytes",
        "operand_one": "operandOne",
        "param_name": "paramName",
        "path_component_offset": "pathComponentOffset",
        "prepend_bytes": "prependBytes",
        "query_parameter_name": "queryParameterName",
        "regex": "regex",
        "replacement": "replacement",
        "response_header_name": "responseHeaderName",
        "separator": "separator",
        "set_cookie_name": "setCookieName",
        "start_index": "startIndex",
        "sub_string": "subString",
        "template_uuid": "templateUuid",
        "transform": "transform",
        "uuid": "uuid",
        "value_source": "valueSource",
        "variable_name": "variableName",
        "variable_value": "variableValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        certificate_field_name: typing.Optional[builtins.str] = None,
        cookie_name: typing.Optional[builtins.str] = None,
        device_profile: typing.Optional[builtins.str] = None,
        encryption_key: typing.Optional[builtins.str] = None,
        encryption_mode: typing.Optional[builtins.str] = None,
        end_index: typing.Optional[jsii.Number] = None,
        except_chars: typing.Optional[builtins.str] = None,
        extract_location: typing.Optional[builtins.str] = None,
        force_chars: typing.Optional[builtins.str] = None,
        format_string: typing.Optional[builtins.str] = None,
        generator: typing.Optional[builtins.str] = None,
        global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        hmac_algorithm: typing.Optional[builtins.str] = None,
        hmac_key: typing.Optional[builtins.str] = None,
        initialization_vector: typing.Optional[builtins.str] = None,
        ipv4_prefix: typing.Optional[jsii.Number] = None,
        ipv6_prefix: typing.Optional[jsii.Number] = None,
        ip_version: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        max: typing.Optional[jsii.Number] = None,
        max_random_number: typing.Optional[jsii.Number] = None,
        min: typing.Optional[jsii.Number] = None,
        min_random_number: typing.Optional[jsii.Number] = None,
        nonce: typing.Optional[builtins.str] = None,
        number_of_bytes: typing.Optional[jsii.Number] = None,
        operand_one: typing.Optional[builtins.str] = None,
        param_name: typing.Optional[builtins.str] = None,
        path_component_offset: typing.Optional[builtins.str] = None,
        prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        replacement: typing.Optional[builtins.str] = None,
        response_header_name: typing.Optional[builtins.str] = None,
        separator: typing.Optional[builtins.str] = None,
        set_cookie_name: typing.Optional[builtins.str] = None,
        start_index: typing.Optional[jsii.Number] = None,
        sub_string: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transform: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value_source: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm to apply. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param case_sensitive: Enabling this makes all matches case sensitive. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param certificate_field_name: Specifies the certificate's content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        :param cookie_name: Specifies the name of the cookie to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param device_profile: Specifies the client device attribute. Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        :param encryption_key: Specifies the encryption hex key. For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        :param encryption_mode: Specifies the encryption mode. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        :param end_index: Specifies the zero-based character offset at the end of the substring, without including the character at that index position. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        :param except_chars: Specifies characters ``not`` to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        :param extract_location: This specifies from where to get the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param force_chars: Specifies characters to encode, possibly overriding the default set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        :param format_string: Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``. A blank value defaults to RFC-2616 format. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        :param generator: This specifies the type of value to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        :param global_substitution: Replaces all matches in the string, not just the first. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        :param header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param hmac_algorithm: Specifies the algorithm to use to generate the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        :param hmac_key: Specifies the secret to use in generating the base64-encoded digest. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        :param initialization_vector: Specifies a one-time number as an initialization vector. It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        :param ipv4_prefix: Specifies the prefix of the IPV4 address, a value between 0 and 32. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        :param ipv6_prefix: Specifies the prefix of the IPV6 address, a value between 0 and 128. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        :param ip_version: Specifies the IP version under which a subnet mask generates. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        :param location_id: Specifies the ``X-Akamai-Edgescape`` header's field name. Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param max: Specifies a maximum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        :param max_random_number: Specifies the upper bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        :param min: Specifies a minimum value for the generated integer. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        :param min_random_number: Specifies the lower bound of the random number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        :param nonce: Specifies the one-time number used for encryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        :param number_of_bytes: Specifies the number of random hex bytes to generate. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        :param operand_one: Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        :param param_name: Extracts the value for the specified parameter name from a string that contains key/value pairs. (Use ``separator`` below to parse them.) Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        :param path_component_offset: This specifies a portion of the path. The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        :param prepend_bytes: Specifies a number of random bytes to prepend to the key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param regex: Specifies the regular expression pattern (PCRE) to match the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param replacement: Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        :param response_header_name: Specifies the case-insensitive name of the HTTP header to extract. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        :param separator: Specifies the character that separates pairs of values within the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        :param set_cookie_name: Specifies the name of the origin's ``Set-Cookie`` response header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        :param start_index: Specifies the zero-based character offset at the start of the substring. Negative indexes specify the offset from the end of the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        :param sub_string: Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transform: Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value_source: Determines how you want to set the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        :param variable_name: Specifies the predeclared root name of the variable to modify. When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_value: This directly specifies the value to assign to the variable. The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e58af4a03db48ab00d3aa7472db2abffd7a8783767ef9acf2b31ae4ec026cec)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument certificate_field_name", value=certificate_field_name, expected_type=type_hints["certificate_field_name"])
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument device_profile", value=device_profile, expected_type=type_hints["device_profile"])
            check_type(argname="argument encryption_key", value=encryption_key, expected_type=type_hints["encryption_key"])
            check_type(argname="argument encryption_mode", value=encryption_mode, expected_type=type_hints["encryption_mode"])
            check_type(argname="argument end_index", value=end_index, expected_type=type_hints["end_index"])
            check_type(argname="argument except_chars", value=except_chars, expected_type=type_hints["except_chars"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument force_chars", value=force_chars, expected_type=type_hints["force_chars"])
            check_type(argname="argument format_string", value=format_string, expected_type=type_hints["format_string"])
            check_type(argname="argument generator", value=generator, expected_type=type_hints["generator"])
            check_type(argname="argument global_substitution", value=global_substitution, expected_type=type_hints["global_substitution"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument hmac_algorithm", value=hmac_algorithm, expected_type=type_hints["hmac_algorithm"])
            check_type(argname="argument hmac_key", value=hmac_key, expected_type=type_hints["hmac_key"])
            check_type(argname="argument initialization_vector", value=initialization_vector, expected_type=type_hints["initialization_vector"])
            check_type(argname="argument ipv4_prefix", value=ipv4_prefix, expected_type=type_hints["ipv4_prefix"])
            check_type(argname="argument ipv6_prefix", value=ipv6_prefix, expected_type=type_hints["ipv6_prefix"])
            check_type(argname="argument ip_version", value=ip_version, expected_type=type_hints["ip_version"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument max", value=max, expected_type=type_hints["max"])
            check_type(argname="argument max_random_number", value=max_random_number, expected_type=type_hints["max_random_number"])
            check_type(argname="argument min", value=min, expected_type=type_hints["min"])
            check_type(argname="argument min_random_number", value=min_random_number, expected_type=type_hints["min_random_number"])
            check_type(argname="argument nonce", value=nonce, expected_type=type_hints["nonce"])
            check_type(argname="argument number_of_bytes", value=number_of_bytes, expected_type=type_hints["number_of_bytes"])
            check_type(argname="argument operand_one", value=operand_one, expected_type=type_hints["operand_one"])
            check_type(argname="argument param_name", value=param_name, expected_type=type_hints["param_name"])
            check_type(argname="argument path_component_offset", value=path_component_offset, expected_type=type_hints["path_component_offset"])
            check_type(argname="argument prepend_bytes", value=prepend_bytes, expected_type=type_hints["prepend_bytes"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument replacement", value=replacement, expected_type=type_hints["replacement"])
            check_type(argname="argument response_header_name", value=response_header_name, expected_type=type_hints["response_header_name"])
            check_type(argname="argument separator", value=separator, expected_type=type_hints["separator"])
            check_type(argname="argument set_cookie_name", value=set_cookie_name, expected_type=type_hints["set_cookie_name"])
            check_type(argname="argument start_index", value=start_index, expected_type=type_hints["start_index"])
            check_type(argname="argument sub_string", value=sub_string, expected_type=type_hints["sub_string"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transform", value=transform, expected_type=type_hints["transform"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value_source", value=value_source, expected_type=type_hints["value_source"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_value", value=variable_value, expected_type=type_hints["variable_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if certificate_field_name is not None:
            self._values["certificate_field_name"] = certificate_field_name
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if device_profile is not None:
            self._values["device_profile"] = device_profile
        if encryption_key is not None:
            self._values["encryption_key"] = encryption_key
        if encryption_mode is not None:
            self._values["encryption_mode"] = encryption_mode
        if end_index is not None:
            self._values["end_index"] = end_index
        if except_chars is not None:
            self._values["except_chars"] = except_chars
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if force_chars is not None:
            self._values["force_chars"] = force_chars
        if format_string is not None:
            self._values["format_string"] = format_string
        if generator is not None:
            self._values["generator"] = generator
        if global_substitution is not None:
            self._values["global_substitution"] = global_substitution
        if header_name is not None:
            self._values["header_name"] = header_name
        if hmac_algorithm is not None:
            self._values["hmac_algorithm"] = hmac_algorithm
        if hmac_key is not None:
            self._values["hmac_key"] = hmac_key
        if initialization_vector is not None:
            self._values["initialization_vector"] = initialization_vector
        if ipv4_prefix is not None:
            self._values["ipv4_prefix"] = ipv4_prefix
        if ipv6_prefix is not None:
            self._values["ipv6_prefix"] = ipv6_prefix
        if ip_version is not None:
            self._values["ip_version"] = ip_version
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if max is not None:
            self._values["max"] = max
        if max_random_number is not None:
            self._values["max_random_number"] = max_random_number
        if min is not None:
            self._values["min"] = min
        if min_random_number is not None:
            self._values["min_random_number"] = min_random_number
        if nonce is not None:
            self._values["nonce"] = nonce
        if number_of_bytes is not None:
            self._values["number_of_bytes"] = number_of_bytes
        if operand_one is not None:
            self._values["operand_one"] = operand_one
        if param_name is not None:
            self._values["param_name"] = param_name
        if path_component_offset is not None:
            self._values["path_component_offset"] = path_component_offset
        if prepend_bytes is not None:
            self._values["prepend_bytes"] = prepend_bytes
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if regex is not None:
            self._values["regex"] = regex
        if replacement is not None:
            self._values["replacement"] = replacement
        if response_header_name is not None:
            self._values["response_header_name"] = response_header_name
        if separator is not None:
            self._values["separator"] = separator
        if set_cookie_name is not None:
            self._values["set_cookie_name"] = set_cookie_name
        if start_index is not None:
            self._values["start_index"] = start_index
        if sub_string is not None:
            self._values["sub_string"] = sub_string
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transform is not None:
            self._values["transform"] = transform
        if uuid is not None:
            self._values["uuid"] = uuid
        if value_source is not None:
            self._values["value_source"] = value_source
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_value is not None:
            self._values["variable_value"] = variable_value

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to apply.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this makes all matches case sensitive.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def certificate_field_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the certificate's content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#certificate_field_name DataAkamaiPropertyRulesBuilder#certificate_field_name}
        '''
        result = self._values.get("certificate_field_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def device_profile(self) -> typing.Optional[builtins.str]:
        '''Specifies the client device attribute.

        Possible values specify information about the client device, including device type, size and browser. For details on fields, see ``Device Characterization``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_profile DataAkamaiPropertyRulesBuilder#device_profile}
        '''
        result = self._values.get("device_profile")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption hex key.

        For ``ALG_3DES`` it needs to be 48 characters long, 32 characters for ``ALG_AES128``, and 64 characters for ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_key DataAkamaiPropertyRulesBuilder#encryption_key}
        '''
        result = self._values.get("encryption_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def encryption_mode(self) -> typing.Optional[builtins.str]:
        '''Specifies the encryption mode.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#encryption_mode DataAkamaiPropertyRulesBuilder#encryption_mode}
        '''
        result = self._values.get("encryption_mode")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_index(self) -> typing.Optional[jsii.Number]:
        '''Specifies the zero-based character offset at the end of the substring, without including the character at that index position.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_index DataAkamaiPropertyRulesBuilder#end_index}
        '''
        result = self._values.get("end_index")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def except_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters ``not`` to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#except_chars DataAkamaiPropertyRulesBuilder#except_chars}
        '''
        result = self._values.get("except_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''This specifies from where to get the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def force_chars(self) -> typing.Optional[builtins.str]:
        '''Specifies characters to encode, possibly overriding the default set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_chars DataAkamaiPropertyRulesBuilder#force_chars}
        '''
        result = self._values.get("force_chars")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def format_string(self) -> typing.Optional[builtins.str]:
        '''Specifies an optional format string for the conversion, using format codes such as ``%m/%d/%y`` as specified by ``strftime``.

        A blank value defaults to RFC-2616 format.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#format_string DataAkamaiPropertyRulesBuilder#format_string}
        '''
        result = self._values.get("format_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def generator(self) -> typing.Optional[builtins.str]:
        '''This specifies the type of value to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#generator DataAkamaiPropertyRulesBuilder#generator}
        '''
        result = self._values.get("generator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def global_substitution(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Replaces all matches in the string, not just the first.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#global_substitution DataAkamaiPropertyRulesBuilder#global_substitution}
        '''
        result = self._values.get("global_substitution")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm to use to generate the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_algorithm DataAkamaiPropertyRulesBuilder#hmac_algorithm}
        '''
        result = self._values.get("hmac_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hmac_key(self) -> typing.Optional[builtins.str]:
        '''Specifies the secret to use in generating the base64-encoded digest.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hmac_key DataAkamaiPropertyRulesBuilder#hmac_key}
        '''
        result = self._values.get("hmac_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def initialization_vector(self) -> typing.Optional[builtins.str]:
        '''Specifies a one-time number as an initialization vector.

        It needs to be 15 characters long for ``ALG_3DES``, and 32 characters for both ``ALG_AES128`` and ``ALG_AES256``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#initialization_vector DataAkamaiPropertyRulesBuilder#initialization_vector}
        '''
        result = self._values.get("initialization_vector")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ipv4_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV4 address, a value between 0 and 32.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv4_prefix DataAkamaiPropertyRulesBuilder#ipv4_prefix}
        '''
        result = self._values.get("ipv4_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ipv6_prefix(self) -> typing.Optional[jsii.Number]:
        '''Specifies the prefix of the IPV6 address, a value between 0 and 128.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ipv6_prefix DataAkamaiPropertyRulesBuilder#ipv6_prefix}
        '''
        result = self._values.get("ipv6_prefix")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def ip_version(self) -> typing.Optional[builtins.str]:
        '''Specifies the IP version under which a subnet mask generates.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip_version DataAkamaiPropertyRulesBuilder#ip_version}
        '''
        result = self._values.get("ip_version")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``X-Akamai-Edgescape`` header's field name.

        Possible values specify basic geolocation, various geographic standards, and information about the client's network. For details on EdgeScape header fields, see the ``EdgeScape User Guide``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def max(self) -> typing.Optional[jsii.Number]:
        '''Specifies a maximum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max DataAkamaiPropertyRulesBuilder#max}
        '''
        result = self._values.get("max")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def max_random_number(self) -> typing.Optional[jsii.Number]:
        '''Specifies the upper bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#max_random_number DataAkamaiPropertyRulesBuilder#max_random_number}
        '''
        result = self._values.get("max_random_number")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min(self) -> typing.Optional[jsii.Number]:
        '''Specifies a minimum value for the generated integer.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min DataAkamaiPropertyRulesBuilder#min}
        '''
        result = self._values.get("min")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def min_random_number(self) -> typing.Optional[jsii.Number]:
        '''Specifies the lower bound of the random number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#min_random_number DataAkamaiPropertyRulesBuilder#min_random_number}
        '''
        result = self._values.get("min_random_number")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def nonce(self) -> typing.Optional[builtins.str]:
        '''Specifies the one-time number used for encryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nonce DataAkamaiPropertyRulesBuilder#nonce}
        '''
        result = self._values.get("nonce")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def number_of_bytes(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of random hex bytes to generate.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#number_of_bytes DataAkamaiPropertyRulesBuilder#number_of_bytes}
        '''
        result = self._values.get("number_of_bytes")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def operand_one(self) -> typing.Optional[builtins.str]:
        '''Specifies an additional operand when the ``transform`` function is set to various arithmetic functions (``ADD``, ``SUBTRACT``, ``MULTIPLY``, ``DIVIDE``, or ``MODULO``) or bitwise functions (``BITWISE_AND``, ``BITWISE_OR``, or ``BITWISE_XOR``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#operand_one DataAkamaiPropertyRulesBuilder#operand_one}
        '''
        result = self._values.get("operand_one")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def param_name(self) -> typing.Optional[builtins.str]:
        '''Extracts the value for the specified parameter name from a string that contains key/value pairs.

        (Use ``separator`` below to parse them.)

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#param_name DataAkamaiPropertyRulesBuilder#param_name}
        '''
        result = self._values.get("param_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def path_component_offset(self) -> typing.Optional[builtins.str]:
        '''This specifies a portion of the path.

        The indexing starts from ``1``, so a value of ``/path/to/nested/filename.html`` and an offset of ``1`` yields ``path``, and ``3`` yields ``nested``. Negative indexes offset from the right, so ``-2`` also yields ``nested``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path_component_offset DataAkamaiPropertyRulesBuilder#path_component_offset}
        '''
        result = self._values.get("path_component_offset")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def prepend_bytes(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies a number of random bytes to prepend to the key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#prepend_bytes DataAkamaiPropertyRulesBuilder#prepend_bytes}
        '''
        result = self._values.get("prepend_bytes")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''Specifies the regular expression pattern (PCRE) to match the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def replacement(self) -> typing.Optional[builtins.str]:
        '''Specifies the replacement string. Reinsert grouped items from the match into the replacement using ``$1``, ``$2`` ... ``$n``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#replacement DataAkamaiPropertyRulesBuilder#replacement}
        '''
        result = self._values.get("replacement")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def response_header_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the case-insensitive name of the HTTP header to extract.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header_name DataAkamaiPropertyRulesBuilder#response_header_name}
        '''
        result = self._values.get("response_header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def separator(self) -> typing.Optional[builtins.str]:
        '''Specifies the character that separates pairs of values within the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#separator DataAkamaiPropertyRulesBuilder#separator}
        '''
        result = self._values.get("separator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def set_cookie_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the origin's ``Set-Cookie`` response header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#set_cookie_name DataAkamaiPropertyRulesBuilder#set_cookie_name}
        '''
        result = self._values.get("set_cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def start_index(self) -> typing.Optional[jsii.Number]:
        '''Specifies the zero-based character offset at the start of the substring.

        Negative indexes specify the offset from the end of the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#start_index DataAkamaiPropertyRulesBuilder#start_index}
        '''
        result = self._values.get("start_index")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def sub_string(self) -> typing.Optional[builtins.str]:
        '''Specifies a substring for which the returned value represents a zero-based offset of where it appears in the original string, or ``-1`` if there's no match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sub_string DataAkamaiPropertyRulesBuilder#sub_string}
        '''
        result = self._values.get("sub_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transform(self) -> typing.Optional[builtins.str]:
        '''Specifies a function to transform the value. For more details on each transform function, see ``Set Variable: Operations``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transform DataAkamaiPropertyRulesBuilder#transform}
        '''
        result = self._values.get("transform")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value_source(self) -> typing.Optional[builtins.str]:
        '''Determines how you want to set the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value_source DataAkamaiPropertyRulesBuilder#value_source}
        '''
        result = self._values.get("value_source")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the predeclared root name of the variable to modify.

        When you declare a variable name such as ``VAR``, its name is preprended with ``PMUSER_`` and accessible in a ``user`` namespace, so that you invoke it in subsequent text fields within the rule tree as ``{{user.PMUSER_VAR}}``. In deployed ``XML metadata``, it appears as ``%(PMUSER_VAR)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_value(self) -> typing.Optional[builtins.str]:
        '''This directly specifies the value to assign to the variable.

        The expression may include a mix of static text and other variables, such as ``new_filename.{{builtin.AK_EXTENSION}}`` to embed a system variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_value DataAkamaiPropertyRulesBuilder#variable_value}
        '''
        result = self._values.get("variable_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22bfaac10bca1243a0e09206629bcb0663693ad68eaebcd68981f7742f7549f6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetCertificateFieldName")
    def reset_certificate_field_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCertificateFieldName", []))

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetDeviceProfile")
    def reset_device_profile(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceProfile", []))

    @jsii.member(jsii_name="resetEncryptionKey")
    def reset_encryption_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionKey", []))

    @jsii.member(jsii_name="resetEncryptionMode")
    def reset_encryption_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEncryptionMode", []))

    @jsii.member(jsii_name="resetEndIndex")
    def reset_end_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndIndex", []))

    @jsii.member(jsii_name="resetExceptChars")
    def reset_except_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExceptChars", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetForceChars")
    def reset_force_chars(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceChars", []))

    @jsii.member(jsii_name="resetFormatString")
    def reset_format_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFormatString", []))

    @jsii.member(jsii_name="resetGenerator")
    def reset_generator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGenerator", []))

    @jsii.member(jsii_name="resetGlobalSubstitution")
    def reset_global_substitution(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGlobalSubstitution", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetHmacAlgorithm")
    def reset_hmac_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacAlgorithm", []))

    @jsii.member(jsii_name="resetHmacKey")
    def reset_hmac_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHmacKey", []))

    @jsii.member(jsii_name="resetInitializationVector")
    def reset_initialization_vector(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInitializationVector", []))

    @jsii.member(jsii_name="resetIpv4Prefix")
    def reset_ipv4_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv4Prefix", []))

    @jsii.member(jsii_name="resetIpv6Prefix")
    def reset_ipv6_prefix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpv6Prefix", []))

    @jsii.member(jsii_name="resetIpVersion")
    def reset_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIpVersion", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMax")
    def reset_max(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMax", []))

    @jsii.member(jsii_name="resetMaxRandomNumber")
    def reset_max_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMaxRandomNumber", []))

    @jsii.member(jsii_name="resetMin")
    def reset_min(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMin", []))

    @jsii.member(jsii_name="resetMinRandomNumber")
    def reset_min_random_number(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMinRandomNumber", []))

    @jsii.member(jsii_name="resetNonce")
    def reset_nonce(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNonce", []))

    @jsii.member(jsii_name="resetNumberOfBytes")
    def reset_number_of_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumberOfBytes", []))

    @jsii.member(jsii_name="resetOperandOne")
    def reset_operand_one(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOperandOne", []))

    @jsii.member(jsii_name="resetParamName")
    def reset_param_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParamName", []))

    @jsii.member(jsii_name="resetPathComponentOffset")
    def reset_path_component_offset(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPathComponentOffset", []))

    @jsii.member(jsii_name="resetPrependBytes")
    def reset_prepend_bytes(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrependBytes", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetReplacement")
    def reset_replacement(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReplacement", []))

    @jsii.member(jsii_name="resetResponseHeaderName")
    def reset_response_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeaderName", []))

    @jsii.member(jsii_name="resetSeparator")
    def reset_separator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSeparator", []))

    @jsii.member(jsii_name="resetSetCookieName")
    def reset_set_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSetCookieName", []))

    @jsii.member(jsii_name="resetStartIndex")
    def reset_start_index(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStartIndex", []))

    @jsii.member(jsii_name="resetSubString")
    def reset_sub_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSubString", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransform")
    def reset_transform(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransform", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValueSource")
    def reset_value_source(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValueSource", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValue")
    def reset_variable_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValue", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="certificateFieldNameInput")
    def certificate_field_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "certificateFieldNameInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceProfileInput")
    def device_profile_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "deviceProfileInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionKeyInput")
    def encryption_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="encryptionModeInput")
    def encryption_mode_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "encryptionModeInput"))

    @builtins.property
    @jsii.member(jsii_name="endIndexInput")
    def end_index_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "endIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="exceptCharsInput")
    def except_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "exceptCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="forceCharsInput")
    def force_chars_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "forceCharsInput"))

    @builtins.property
    @jsii.member(jsii_name="formatStringInput")
    def format_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "formatStringInput"))

    @builtins.property
    @jsii.member(jsii_name="generatorInput")
    def generator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "generatorInput"))

    @builtins.property
    @jsii.member(jsii_name="globalSubstitutionInput")
    def global_substitution_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "globalSubstitutionInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithmInput")
    def hmac_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="hmacKeyInput")
    def hmac_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hmacKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="initializationVectorInput")
    def initialization_vector_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "initializationVectorInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv4PrefixInput")
    def ipv4_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv4PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipv6PrefixInput")
    def ipv6_prefix_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ipv6PrefixInput"))

    @builtins.property
    @jsii.member(jsii_name="ipVersionInput")
    def ip_version_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "ipVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="maxInput")
    def max_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxInput"))

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumberInput")
    def max_random_number_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "maxRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="minInput")
    def min_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minInput"))

    @builtins.property
    @jsii.member(jsii_name="minRandomNumberInput")
    def min_random_number_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "minRandomNumberInput"))

    @builtins.property
    @jsii.member(jsii_name="nonceInput")
    def nonce_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nonceInput"))

    @builtins.property
    @jsii.member(jsii_name="numberOfBytesInput")
    def number_of_bytes_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numberOfBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="operandOneInput")
    def operand_one_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "operandOneInput"))

    @builtins.property
    @jsii.member(jsii_name="paramNameInput")
    def param_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "paramNameInput"))

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffsetInput")
    def path_component_offset_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "pathComponentOffsetInput"))

    @builtins.property
    @jsii.member(jsii_name="prependBytesInput")
    def prepend_bytes_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "prependBytesInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="replacementInput")
    def replacement_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "replacementInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderNameInput")
    def response_header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "responseHeaderNameInput"))

    @builtins.property
    @jsii.member(jsii_name="separatorInput")
    def separator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "separatorInput"))

    @builtins.property
    @jsii.member(jsii_name="setCookieNameInput")
    def set_cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "setCookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="startIndexInput")
    def start_index_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "startIndexInput"))

    @builtins.property
    @jsii.member(jsii_name="subStringInput")
    def sub_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "subStringInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transformInput")
    def transform_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transformInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueSourceInput")
    def value_source_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueSourceInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValueInput")
    def variable_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableValueInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b7bb220d05143f10e97f5d76a258f4e82041b55ac733693229932fd53e420d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bec78bbb7decf82c2f7ec6b72cf6c0934a13eb4ab69ad4c2a8e3673dd7f8e976)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="certificateFieldName")
    def certificate_field_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "certificateFieldName"))

    @certificate_field_name.setter
    def certificate_field_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adaf5c77f805f6c1bb3a224225621518f1f9bcd1c3c00ba5d50953dedecf7f51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "certificateFieldName", value)

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253ec4ebf28f149214700f6a41b8e2647d209d0745956cc81e4d18a841b372e4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="deviceProfile")
    def device_profile(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "deviceProfile"))

    @device_profile.setter
    def device_profile(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__80e9c91f4a1eca7de2a7b4c2831b73a9b2b4bc8b75758d2290e850318a9d2da4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "deviceProfile", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionKey")
    def encryption_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionKey"))

    @encryption_key.setter
    def encryption_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35426add12bdf6759fca5e887da0c5812f938bcf2b0db49b6ed79a1ffa3b9f06)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionKey", value)

    @builtins.property
    @jsii.member(jsii_name="encryptionMode")
    def encryption_mode(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "encryptionMode"))

    @encryption_mode.setter
    def encryption_mode(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2530e0180ef1afe936571f803b7d18b11544c5d1b90700f063b9328dd60596b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "encryptionMode", value)

    @builtins.property
    @jsii.member(jsii_name="endIndex")
    def end_index(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "endIndex"))

    @end_index.setter
    def end_index(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__329e41a4edc5c375d27efe1ab3b49242cc883b4333fe16396baad82c7f3689b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endIndex", value)

    @builtins.property
    @jsii.member(jsii_name="exceptChars")
    def except_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "exceptChars"))

    @except_chars.setter
    def except_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ac02b6ae332746326444d31d8bb2cd2bd5ef3ddde4730702557292c410ecc2e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "exceptChars", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bde55be38550c43420fdf208f8a842eb7529692657e44d081ec4b0c1a38c705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="forceChars")
    def force_chars(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "forceChars"))

    @force_chars.setter
    def force_chars(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3cbe5add18904d3ae5a982af259ae712bb4bdc44b89abeb772590204c1a43ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceChars", value)

    @builtins.property
    @jsii.member(jsii_name="formatString")
    def format_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "formatString"))

    @format_string.setter
    def format_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62f836f94e70b3c5267cdb9dfe6858c6730cd594f310eb6912958f3b6c8b82e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "formatString", value)

    @builtins.property
    @jsii.member(jsii_name="generator")
    def generator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "generator"))

    @generator.setter
    def generator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d1ad7eee8bd3cdb44a2367d07889e3662bcf3ce82a6f323b5ac789016b5d69c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "generator", value)

    @builtins.property
    @jsii.member(jsii_name="globalSubstitution")
    def global_substitution(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "globalSubstitution"))

    @global_substitution.setter
    def global_substitution(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7430dd80edb4db17ac480fc639672c2be46d0d9a29fcd5030838f4ccb4c27174)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "globalSubstitution", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__784be34ae7bfe2b3634eb45a0e73c8e5f89e508f6a7db5b4c1e66f44342cc5c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="hmacAlgorithm")
    def hmac_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacAlgorithm"))

    @hmac_algorithm.setter
    def hmac_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a061d7c575a5ca8cb287c394797ee66f63fcb95df04a10ac11bfab6253b6a4a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="hmacKey")
    def hmac_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hmacKey"))

    @hmac_key.setter
    def hmac_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17ac40e5b09897499a56a970d2bf866c8717773c3a3a21ef48da595d1e7091a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hmacKey", value)

    @builtins.property
    @jsii.member(jsii_name="initializationVector")
    def initialization_vector(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "initializationVector"))

    @initialization_vector.setter
    def initialization_vector(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdec004ce5ed65b5bde2f0ec02b17d55860181af7e720373c41c54a382f7e551)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "initializationVector", value)

    @builtins.property
    @jsii.member(jsii_name="ipv4Prefix")
    def ipv4_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv4Prefix"))

    @ipv4_prefix.setter
    def ipv4_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__209a38ba9c349d001a149a263db302da00db8a818b35d8f9f0f8f643eb0891c4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv4Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipv6Prefix")
    def ipv6_prefix(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ipv6Prefix"))

    @ipv6_prefix.setter
    def ipv6_prefix(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb7bc2cac8e353602a9bd300db526937edc08e4f782fc106ac2bd4f1e02660d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipv6Prefix", value)

    @builtins.property
    @jsii.member(jsii_name="ipVersion")
    def ip_version(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "ipVersion"))

    @ip_version.setter
    def ip_version(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a87226a683084e994c8e11dfff47b53dccaaeec5a8def3858ccbae4a2e90d611)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ipVersion", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38affdbf8c9039cf8c515d29817a6ff9148928347347416c99de059ffebea594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af0f921dcf86e9e3df0ec1b17b11a2c974048805d8eb2de64277a90b738e4a46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="max")
    def max(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "max"))

    @max.setter
    def max(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86ecc4f73bbe96aef1de3b4cba48e5e5ae5af986b453b8da74c3f5b5f49cd34d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "max", value)

    @builtins.property
    @jsii.member(jsii_name="maxRandomNumber")
    def max_random_number(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "maxRandomNumber"))

    @max_random_number.setter
    def max_random_number(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2033491dbbd200f346a7e016ac1f2041222eae2113ea8a09d3ac8ed4674a13a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "maxRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="min")
    def min(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "min"))

    @min.setter
    def min(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9212bb01c140ff82130b7f250523b81d6d4fbbeacffca30186d038385773d3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "min", value)

    @builtins.property
    @jsii.member(jsii_name="minRandomNumber")
    def min_random_number(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "minRandomNumber"))

    @min_random_number.setter
    def min_random_number(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5a8db92c471f446544eb3e4e6c3504123fab1578d1268524ddb1b90b8b93803)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "minRandomNumber", value)

    @builtins.property
    @jsii.member(jsii_name="nonce")
    def nonce(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nonce"))

    @nonce.setter
    def nonce(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__684a14bcd91d66cf06903e9ceefcea0cfd49895a24fd4c611e2936e01c04f45a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nonce", value)

    @builtins.property
    @jsii.member(jsii_name="numberOfBytes")
    def number_of_bytes(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numberOfBytes"))

    @number_of_bytes.setter
    def number_of_bytes(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eda1d1a006243a9c9478de7ad6eadb842dacd0510a67f43a7237612ac654ef49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numberOfBytes", value)

    @builtins.property
    @jsii.member(jsii_name="operandOne")
    def operand_one(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "operandOne"))

    @operand_one.setter
    def operand_one(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c668840a1ec6f9c4a95d5740616ee1a456dfb92205df7fc6a644e592622e2bf0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "operandOne", value)

    @builtins.property
    @jsii.member(jsii_name="paramName")
    def param_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "paramName"))

    @param_name.setter
    def param_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8331d25cd2daee84f99949bbf6e92a62fd506579994ad9f08a69ac753e51c253)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "paramName", value)

    @builtins.property
    @jsii.member(jsii_name="pathComponentOffset")
    def path_component_offset(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "pathComponentOffset"))

    @path_component_offset.setter
    def path_component_offset(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a3d05f304c06e1255eaf476f7d6dfacde1284655ff3d15258054517f0286077)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "pathComponentOffset", value)

    @builtins.property
    @jsii.member(jsii_name="prependBytes")
    def prepend_bytes(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "prependBytes"))

    @prepend_bytes.setter
    def prepend_bytes(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0a5861c86cd100e7d780bf0c774de27cc3e853d80f1936eba95792bbc4d9da0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "prependBytes", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc30a0a0269aea0bacb7a014aa524f974b0047be6055bbd5287e5c1f646e3170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339647f569706175b0f635639933c5fcc569540c01237314b85764149da423c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="replacement")
    def replacement(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "replacement"))

    @replacement.setter
    def replacement(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__88581f9fcad4664c5e7f0d11f2cb0e25d6ee96d76df443c61eb7f78b3237e37a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "replacement", value)

    @builtins.property
    @jsii.member(jsii_name="responseHeaderName")
    def response_header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "responseHeaderName"))

    @response_header_name.setter
    def response_header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fa4be0c7b955d9fb07a967ef3bcc2f611d9ac6eb433f70b5967f5a6b9e142d8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "responseHeaderName", value)

    @builtins.property
    @jsii.member(jsii_name="separator")
    def separator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "separator"))

    @separator.setter
    def separator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952108cf2fa1fc3a4f9eb86f3be7fe543c768257ae3a7aabea2346462824b12a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "separator", value)

    @builtins.property
    @jsii.member(jsii_name="setCookieName")
    def set_cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "setCookieName"))

    @set_cookie_name.setter
    def set_cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5f9a6f963a7429ef4fbfc47873068d95ccab1969f1daf9208b24ff346c79b317)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "setCookieName", value)

    @builtins.property
    @jsii.member(jsii_name="startIndex")
    def start_index(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "startIndex"))

    @start_index.setter
    def start_index(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__efa0689c62c74b6d76afe08e255e3af665d567a765cab2516391563abc0d4b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "startIndex", value)

    @builtins.property
    @jsii.member(jsii_name="subString")
    def sub_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "subString"))

    @sub_string.setter
    def sub_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f400781b95a7ddd97fefb1fb52a5095c2e0fdb17934bb54bb33817a3bcf6d998)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "subString", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cfda5de1fba435ce3f51254decb6ee21009ce6a4160cc0c1745e4d1186f5ed0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transform")
    def transform(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transform"))

    @transform.setter
    def transform(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c518539583be5eb2100aa138c1aeb75a2f1a7c1f5ba9d82028205dbdc80e5da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transform", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b99b55be8ceb520e8546f3e952d66079e3a11a278ae31a3476f5d1d6c985d5c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="valueSource")
    def value_source(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "valueSource"))

    @value_source.setter
    def value_source(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b1e26335e1f2313f9f65cd9bbb8ee51e4f0b21257ac91f5b99ce9edd3e9e95f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "valueSource", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__043d63fe2f5787c353afdc08ca9a9fec7a8fc41d6cf373cf681603a9d8ad6970)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValue")
    def variable_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableValue"))

    @variable_value.setter
    def variable_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a59ff42e54a2dd34b96f5a1f557a8417354ba98e201869bf5884d4010a63d055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4c4d116a91686b29b596b4d07a0737c971e7f8acf172fa7d13b511833faf392)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode",
    jsii_struct_bases=[],
    name_mapping={
        "error_type": "errorType",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "timeout": "timeout",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode:
    def __init__(
        self,
        *,
        error_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        timeout: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param error_type: Specifies the type of error. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param timeout: When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8b2f8daec36b8d6e242621a3e70363cfa5c6d7953bb116a367395f2843dd3c)
            check_type(argname="argument error_type", value=error_type, expected_type=type_hints["error_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument timeout", value=timeout, expected_type=type_hints["timeout"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if error_type is not None:
            self._values["error_type"] = error_type
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if timeout is not None:
            self._values["timeout"] = timeout
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def error_type(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of error.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#error_type DataAkamaiPropertyRulesBuilder#error_type}
        '''
        result = self._values.get("error_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def timeout(self) -> typing.Optional[builtins.str]:
        '''When the ``errorType`` is ``ERR_CONNECT_TIMEOUT``, ``ERR_DNS_TIMEOUT``, ``ERR_SUREROUTE_DNS_FAIL``, or ``ERR_READ_TIMEOUT``, generates an error after the specified amount of time from the initial request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#timeout DataAkamaiPropertyRulesBuilder#timeout}
        '''
        result = self._values.get("timeout")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d97ce705301ee558d4fd81a122a476b5ddce9ba0857300b10d87a324c88e106)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetErrorType")
    def reset_error_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetErrorType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTimeout")
    def reset_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTimeout", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="errorTypeInput")
    def error_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "errorTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="timeoutInput")
    def timeout_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "timeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="errorType")
    def error_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "errorType"))

    @error_type.setter
    def error_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4a7812cf6eaaa60482903fceb526550eb9cfa1334d29a1a79d55e1f785d54b7b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "errorType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac79d1e5111e41cf1b730984346afabacd532dda032a45f98c8ca820562ba417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1dd9a33804ef2b82cf0acda15a0d76f56f3dee5db728bf3c763ffa4c2cd341e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="timeout")
    def timeout(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "timeout"))

    @timeout.setter
    def timeout(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51445e60f9a76283c6dac392db7ba8f3b4d763fb986ac551be6a427e5d247538)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "timeout", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cb63b028fdb90b5a347a1da465eafe694b71e245fb83df26564283f96005186)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b72da8c0da9cdf7cfd5949cb6e3f0598dc390d990a77f79e1fa01ea267a39767)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "nossmap": "nossmap",
        "ssmap": "ssmap",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        nossmap: typing.Optional[builtins.str] = None,
        ssmap: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap", typing.Dict[builtins.str, typing.Any]]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param nossmap: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        :param ssmap: ssmap block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(ssmap, dict):
            ssmap = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap(**ssmap)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d8aa59d563feb4bde9fa7cd48dc77eac80e45f7226554073048f481b44aeef5)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument nossmap", value=nossmap, expected_type=type_hints["nossmap"])
            check_type(argname="argument ssmap", value=ssmap, expected_type=type_hints["ssmap"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if nossmap is not None:
            self._values["nossmap"] = nossmap
        if ssmap is not None:
            self._values["ssmap"] = ssmap
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def nossmap(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#nossmap DataAkamaiPropertyRulesBuilder#nossmap}
        '''
        result = self._values.get("nossmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def ssmap(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap"]:
        '''ssmap block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ssmap DataAkamaiPropertyRulesBuilder#ssmap}
        '''
        result = self._values.get("ssmap")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap"], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ec61a5d8202e51bc077e70e2b7300b0e4e1009208c5ae851a1d78ad3b263f64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putSsmap")
    def put_ssmap(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap(
            china_cdn_map=china_cdn_map,
            has_mixed_hosts=has_mixed_hosts,
            name=name,
            src=src,
            srmap=srmap,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putSsmap", [value_]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetNossmap")
    def reset_nossmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNossmap", []))

    @jsii.member(jsii_name="resetSsmap")
    def reset_ssmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSsmap", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="ssmap")
    def ssmap(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmapOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmapOutputReference", jsii.get(self, "ssmap"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="nossmapInput")
    def nossmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nossmapInput"))

    @builtins.property
    @jsii.member(jsii_name="ssmapInput")
    def ssmap_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap"], jsii.get(self, "ssmapInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__52bb0120b925d68a238ba7b373364d53066b0b9f89c686cf7c6a04e6e95e26bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="nossmap")
    def nossmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "nossmap"))

    @nossmap.setter
    def nossmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16247fc89afafd9f6d98383946ab7b0cd96ce5e73e6cbfe9120cd6093a4a1389)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "nossmap", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ca1bb471d700ec47700426a6826defc795b9757f5cc3d63850612760e2680cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3e87ab368682e774ddc1901764dd30a6e8631484ae2656b64c7d65dc4d934ca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d7b95688be632b79d43ec6300c11bd764af1ff1696b9954589fbc4e5376c973)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap",
    jsii_struct_bases=[],
    name_mapping={
        "china_cdn_map": "chinaCdnMap",
        "has_mixed_hosts": "hasMixedHosts",
        "name": "name",
        "src": "src",
        "srmap": "srmap",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap:
    def __init__(
        self,
        *,
        china_cdn_map: typing.Optional[builtins.str] = None,
        has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        name: typing.Optional[builtins.str] = None,
        src: typing.Optional[builtins.str] = None,
        srmap: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param china_cdn_map: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.
        :param has_mixed_hosts: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        :param src: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.
        :param srmap: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__074589abff8836de4c10929b11936f1cfdcbda3bc69abef24d81e9cdff703828)
            check_type(argname="argument china_cdn_map", value=china_cdn_map, expected_type=type_hints["china_cdn_map"])
            check_type(argname="argument has_mixed_hosts", value=has_mixed_hosts, expected_type=type_hints["has_mixed_hosts"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument src", value=src, expected_type=type_hints["src"])
            check_type(argname="argument srmap", value=srmap, expected_type=type_hints["srmap"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if china_cdn_map is not None:
            self._values["china_cdn_map"] = china_cdn_map
        if has_mixed_hosts is not None:
            self._values["has_mixed_hosts"] = has_mixed_hosts
        if name is not None:
            self._values["name"] = name
        if src is not None:
            self._values["src"] = src
        if srmap is not None:
            self._values["srmap"] = srmap
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def china_cdn_map(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_map DataAkamaiPropertyRulesBuilder#china_cdn_map}.'''
        result = self._values.get("china_cdn_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def has_mixed_hosts(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#has_mixed_hosts DataAkamaiPropertyRulesBuilder#has_mixed_hosts}.'''
        result = self._values.get("has_mixed_hosts")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def src(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#src DataAkamaiPropertyRulesBuilder#src}.'''
        result = self._values.get("src")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def srmap(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#srmap DataAkamaiPropertyRulesBuilder#srmap}.'''
        result = self._values.get("srmap")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmapOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmapOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fde3fbb4327284198e21798ad5b71ab543d9d078910b523a58f7474a1c73968)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetChinaCdnMap")
    def reset_china_cdn_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnMap", []))

    @jsii.member(jsii_name="resetHasMixedHosts")
    def reset_has_mixed_hosts(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHasMixedHosts", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetSrc")
    def reset_src(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrc", []))

    @jsii.member(jsii_name="resetSrmap")
    def reset_srmap(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrmap", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMapInput")
    def china_cdn_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "chinaCdnMapInput"))

    @builtins.property
    @jsii.member(jsii_name="hasMixedHostsInput")
    def has_mixed_hosts_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hasMixedHostsInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="srcInput")
    def src_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srcInput"))

    @builtins.property
    @jsii.member(jsii_name="srmapInput")
    def srmap_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srmapInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnMap")
    def china_cdn_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "chinaCdnMap"))

    @china_cdn_map.setter
    def china_cdn_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d61bda3c7147d3abd72b2fd31c43e5ad3490ed4e80467b6470f3a145edbb6dc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "chinaCdnMap", value)

    @builtins.property
    @jsii.member(jsii_name="hasMixedHosts")
    def has_mixed_hosts(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hasMixedHosts"))

    @has_mixed_hosts.setter
    def has_mixed_hosts(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c92112c58383d8c457b64b83cadb9186013e284a1af4ea7fc58b803831ab6eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hasMixedHosts", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__171f28141d7b862437d5cb43ba83cccc9660be435255c17da0370da760362805)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="src")
    def src(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "src"))

    @src.setter
    def src(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bc640e2a400665645ea051fb22f700c0683fe81bd5736a016e58535ee491dc9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "src", value)

    @builtins.property
    @jsii.member(jsii_name="srmap")
    def srmap(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srmap"))

    @srmap.setter
    def srmap(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13ca6e66418056898f7d00547c16f4e677442c4fe9c57d73fc5d0d9d6c7f4175)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srmap", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22a680c8c204667ea5b3b5531309f29fa97f6a9aafbf381397c1bee1e17b6c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aa6923679654cdd9e973bcb301a79b921052fda3b34520640ec02e1b7567b51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration",
    jsii_struct_bases=[],
    name_mapping={
        "allow_https_downgrade": "allowHttpsDowngrade",
        "allow_https_upgrade": "allowHttpsUpgrade",
        "cache_sharing_duration": "cacheSharingDuration",
        "cache_sharing_start_time": "cacheSharingStartTime",
        "enabled": "enabled",
        "is_certificate_sni_only": "isCertificateSniOnly",
        "is_tiered_distribution_used": "isTieredDistributionUsed",
        "locked": "locked",
        "migration_duration": "migrationDuration",
        "migration_from": "migrationFrom",
        "migration_start_time": "migrationStartTime",
        "td_location": "tdLocation",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration:
    def __init__(
        self,
        *,
        allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_sharing_duration: typing.Optional[jsii.Number] = None,
        cache_sharing_start_time: typing.Optional[builtins.str] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_duration: typing.Optional[jsii.Number] = None,
        migration_from: typing.Optional[builtins.str] = None,
        migration_start_time: typing.Optional[builtins.str] = None,
        td_location: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_https_downgrade: Allow temporary downgrade of HTTPS traffic to HTTP. This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        :param allow_https_upgrade: Allows temporary upgrade of HTTP traffic to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        :param cache_sharing_duration: Specifies the number cache sharing days. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        :param cache_sharing_start_time: Specifies when to start cache sharing. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        :param enabled: Allows migration to Standard TLS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param is_certificate_sni_only: Sets whether your new certificate is SNI-only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        :param is_tiered_distribution_used: Allows you to align traffic to various ``tieredDistribution`` areas. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param migration_duration: Specifies the number of days to migrate the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        :param migration_from: What kind of traffic you're migrating from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        :param migration_start_time: Specifies when to start migrating the cache. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        :param td_location: Specifies the ``tieredDistribution`` location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01927461f0f2acca49c101add29dd2cd23363c7503a8985e99e44943c9853789)
            check_type(argname="argument allow_https_downgrade", value=allow_https_downgrade, expected_type=type_hints["allow_https_downgrade"])
            check_type(argname="argument allow_https_upgrade", value=allow_https_upgrade, expected_type=type_hints["allow_https_upgrade"])
            check_type(argname="argument cache_sharing_duration", value=cache_sharing_duration, expected_type=type_hints["cache_sharing_duration"])
            check_type(argname="argument cache_sharing_start_time", value=cache_sharing_start_time, expected_type=type_hints["cache_sharing_start_time"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument is_certificate_sni_only", value=is_certificate_sni_only, expected_type=type_hints["is_certificate_sni_only"])
            check_type(argname="argument is_tiered_distribution_used", value=is_tiered_distribution_used, expected_type=type_hints["is_tiered_distribution_used"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument migration_duration", value=migration_duration, expected_type=type_hints["migration_duration"])
            check_type(argname="argument migration_from", value=migration_from, expected_type=type_hints["migration_from"])
            check_type(argname="argument migration_start_time", value=migration_start_time, expected_type=type_hints["migration_start_time"])
            check_type(argname="argument td_location", value=td_location, expected_type=type_hints["td_location"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_https_downgrade is not None:
            self._values["allow_https_downgrade"] = allow_https_downgrade
        if allow_https_upgrade is not None:
            self._values["allow_https_upgrade"] = allow_https_upgrade
        if cache_sharing_duration is not None:
            self._values["cache_sharing_duration"] = cache_sharing_duration
        if cache_sharing_start_time is not None:
            self._values["cache_sharing_start_time"] = cache_sharing_start_time
        if enabled is not None:
            self._values["enabled"] = enabled
        if is_certificate_sni_only is not None:
            self._values["is_certificate_sni_only"] = is_certificate_sni_only
        if is_tiered_distribution_used is not None:
            self._values["is_tiered_distribution_used"] = is_tiered_distribution_used
        if locked is not None:
            self._values["locked"] = locked
        if migration_duration is not None:
            self._values["migration_duration"] = migration_duration
        if migration_from is not None:
            self._values["migration_from"] = migration_from
        if migration_start_time is not None:
            self._values["migration_start_time"] = migration_start_time
        if td_location is not None:
            self._values["td_location"] = td_location
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_https_downgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allow temporary downgrade of HTTPS traffic to HTTP.

        This removes various ``Origin``, ``Referer``, ``Cookie``, ``Cookie2``, ``sec-*`` and ``proxy-*`` headers from the request to origin.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_downgrade DataAkamaiPropertyRulesBuilder#allow_https_downgrade}
        '''
        result = self._values.get("allow_https_downgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allow_https_upgrade(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows temporary upgrade of HTTP traffic to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_https_upgrade DataAkamaiPropertyRulesBuilder#allow_https_upgrade}
        '''
        result = self._values.get("allow_https_upgrade")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_sharing_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number cache sharing days.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_duration DataAkamaiPropertyRulesBuilder#cache_sharing_duration}
        '''
        result = self._values.get("cache_sharing_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def cache_sharing_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start cache sharing.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_sharing_start_time DataAkamaiPropertyRulesBuilder#cache_sharing_start_time}
        '''
        result = self._values.get("cache_sharing_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows migration to Standard TLS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_sni_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets whether your new certificate is SNI-only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_sni_only DataAkamaiPropertyRulesBuilder#is_certificate_sni_only}
        '''
        result = self._values.get("is_certificate_sni_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_tiered_distribution_used(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to align traffic to various ``tieredDistribution`` areas.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_tiered_distribution_used DataAkamaiPropertyRulesBuilder#is_tiered_distribution_used}
        '''
        result = self._values.get("is_tiered_distribution_used")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of days to migrate the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_duration DataAkamaiPropertyRulesBuilder#migration_duration}
        '''
        result = self._values.get("migration_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def migration_from(self) -> typing.Optional[builtins.str]:
        '''What kind of traffic you're migrating from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_from DataAkamaiPropertyRulesBuilder#migration_from}
        '''
        result = self._values.get("migration_from")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_time(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the cache.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_time DataAkamaiPropertyRulesBuilder#migration_start_time}
        '''
        result = self._values.get("migration_start_time")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def td_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the ``tieredDistribution`` location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#td_location DataAkamaiPropertyRulesBuilder#td_location}
        '''
        result = self._values.get("td_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ae65c7284b6ccb39eab7f2276db71adf07fe97f3d12dc4250b8b784981bd041)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowHttpsDowngrade")
    def reset_allow_https_downgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsDowngrade", []))

    @jsii.member(jsii_name="resetAllowHttpsUpgrade")
    def reset_allow_https_upgrade(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowHttpsUpgrade", []))

    @jsii.member(jsii_name="resetCacheSharingDuration")
    def reset_cache_sharing_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingDuration", []))

    @jsii.member(jsii_name="resetCacheSharingStartTime")
    def reset_cache_sharing_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheSharingStartTime", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIsCertificateSniOnly")
    def reset_is_certificate_sni_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateSniOnly", []))

    @jsii.member(jsii_name="resetIsTieredDistributionUsed")
    def reset_is_tiered_distribution_used(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsTieredDistributionUsed", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMigrationDuration")
    def reset_migration_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationDuration", []))

    @jsii.member(jsii_name="resetMigrationFrom")
    def reset_migration_from(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationFrom", []))

    @jsii.member(jsii_name="resetMigrationStartTime")
    def reset_migration_start_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartTime", []))

    @jsii.member(jsii_name="resetTdLocation")
    def reset_td_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTdLocation", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngradeInput")
    def allow_https_downgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsDowngradeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgradeInput")
    def allow_https_upgrade_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowHttpsUpgradeInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDurationInput")
    def cache_sharing_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cacheSharingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTimeInput")
    def cache_sharing_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cacheSharingStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnlyInput")
    def is_certificate_sni_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificateSniOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsedInput")
    def is_tiered_distribution_used_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isTieredDistributionUsedInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationDurationInput")
    def migration_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "migrationDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationFromInput")
    def migration_from_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationFromInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartTimeInput")
    def migration_start_time_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="tdLocationInput")
    def td_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tdLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowHttpsDowngrade")
    def allow_https_downgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsDowngrade"))

    @allow_https_downgrade.setter
    def allow_https_downgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb3def89a93b724744cca8f2e722dfd9853a786264343f3f0e28d596937ba0ad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsDowngrade", value)

    @builtins.property
    @jsii.member(jsii_name="allowHttpsUpgrade")
    def allow_https_upgrade(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowHttpsUpgrade"))

    @allow_https_upgrade.setter
    def allow_https_upgrade(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d8a0b40b35019f1985cbfa8c2890ac9e18cea1df064190012716b923623a09a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowHttpsUpgrade", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingDuration")
    def cache_sharing_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cacheSharingDuration"))

    @cache_sharing_duration.setter
    def cache_sharing_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6afdf6ffc74d8946db65dfd497458e991a7bb334ef82bdf3e05fb2aa12fca637)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="cacheSharingStartTime")
    def cache_sharing_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cacheSharingStartTime"))

    @cache_sharing_start_time.setter
    def cache_sharing_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103737a5655e81786581b83bd7d2a1b3fab8a8de8becb0b814d20b294af85db4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheSharingStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__947bc3c707847b681f06772e58620363c25bd96ebde9f2db56aee0212377ba90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateSniOnly")
    def is_certificate_sni_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificateSniOnly"))

    @is_certificate_sni_only.setter
    def is_certificate_sni_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c71ad69ff8c054e7c7d3308ac7f2454850d15f55071c0a29451e095ea1427ab)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateSniOnly", value)

    @builtins.property
    @jsii.member(jsii_name="isTieredDistributionUsed")
    def is_tiered_distribution_used(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isTieredDistributionUsed"))

    @is_tiered_distribution_used.setter
    def is_tiered_distribution_used(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0b6c3a7048714596c13f5f5ca9e40e5f800759cf2ca8d14d872cecafb91ac204)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isTieredDistributionUsed", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__489de337b7fa2bb94b629ec7af9297899538f3a3f842583bcde8c344ed344ea0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="migrationDuration")
    def migration_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "migrationDuration"))

    @migration_duration.setter
    def migration_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72d64745dc6a75b827a6c09dcf6363c81a7f912bc4fb4a6ef5c3d0e74cbc8f74)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationDuration", value)

    @builtins.property
    @jsii.member(jsii_name="migrationFrom")
    def migration_from(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationFrom"))

    @migration_from.setter
    def migration_from(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4dd99c72a4471f8238e44dd1d32c648f83ced0f92ba2d205bc37f71cee196bf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationFrom", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartTime")
    def migration_start_time(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartTime"))

    @migration_start_time.setter
    def migration_start_time(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3708ef33652493b0ddd1809397872567013fcee950b92b06a6896c80fe59eceb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartTime", value)

    @builtins.property
    @jsii.member(jsii_name="tdLocation")
    def td_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tdLocation"))

    @td_location.setter
    def td_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19356d9082a3cd0e397cfa3aaef1c6fcfbb914249b844e2c8c37084ffd989005)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tdLocation", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e31265668ed962cec0dd0439c5b35f16fa0f1588ae39bddee1d0b186dcfb80f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a681d9990d01c6e0f4ac1f27699a069410dedaf20e46acc580f00356b392a34b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac81a34083ce019a9af93c983cde2768bd33f2376a5fe2bdf34b79a73f445198)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride",
    jsii_struct_bases=[],
    name_mapping={
        "info": "info",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride:
    def __init__(
        self,
        *,
        info: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param info: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d5eec8c6891d3b328d6d5cf083db7ac9d8ec55b02eb50c96be6f73f332cf6ed)
            check_type(argname="argument info", value=info, expected_type=type_hints["info"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if info is not None:
            self._values["info"] = info
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def info(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#info DataAkamaiPropertyRulesBuilder#info}
        '''
        result = self._values.get("info")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ee1eb40420dd641b1688dd784f94a6054b4e5c735d64229765472048d90799f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetInfo")
    def reset_info(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetInfo", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="infoInput")
    def info_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "infoInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="info")
    def info(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "info"))

    @info.setter
    def info(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ebbd56c561340fe099e41a1bf20ba77f898bc83e8575363b793f38a5cbd89f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "info", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__323453c1a3de17c79e036fe988dead24eabd943e8924e654ebd5132361a04f30)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff3f9ee406fb6379d7a0b0fc8a81a461611cbd04c3a42e7e4643a7478d9b0294)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__566a0bac5e7929fc8e1e884e2dd889aec8ef202454c383b45947749eedc39f8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c011c455a82875ddd5d0d3b6671182ba9b0f31edfff45b0e1f033f64af2aae8f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "strict_mode": "strictMode",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "valid_mode": "validMode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param strict_mode: Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF. When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param valid_mode: Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines. When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d05c64480c0cfe7321915f7962bc3ab16522134152f286ae96aba67d268402a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument strict_mode", value=strict_mode, expected_type=type_hints["strict_mode"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument valid_mode", value=valid_mode, expected_type=type_hints["valid_mode"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if strict_mode is not None:
            self._values["strict_mode"] = strict_mode
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if valid_mode is not None:
            self._values["valid_mode"] = valid_mode

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def strict_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant, improperly formatted headers, where the header line starts with a colon, misses a colon or doesn’t end with CR LF.

        When disabled, the edge servers allow such requests, but correct the violation by removing or rewriting the header line before passing the headers to the origin server.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#strict_mode DataAkamaiPropertyRulesBuilder#strict_mode}
        '''
        result = self._values.get("strict_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def valid_mode(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Rejects requests made with non-RFC-compliant headers that contain invalid characters in the header name or value or which contain invalidly-folded header lines.

        When disabled, the edge servers allow such requests, passing the invalid headers to the origin server unchanged.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#valid_mode DataAkamaiPropertyRulesBuilder#valid_mode}
        '''
        result = self._values.get("valid_mode")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da58acb6017590c9f0e98582f20244468e067518274d7f889b1e0338bbef1dab)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetStrictMode")
    def reset_strict_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStrictMode", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValidMode")
    def reset_valid_mode(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValidMode", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="strictModeInput")
    def strict_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "strictModeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="validModeInput")
    def valid_mode_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "validModeInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47dd449adb5c4cb686b4b3d699fa1e10406e5a93b1a728b7cd4d327f803d18d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="strictMode")
    def strict_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "strictMode"))

    @strict_mode.setter
    def strict_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f8fa092b1d87e57a08a9d8eb549418f188a36c22d75172322ae3d2f865b0e70b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "strictMode", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__155972882a9d1ca3f8c3e0eae6d3980b7a16ed70003d94ab62e5637218e71b97)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c3f4a9f67f70aa85a0f7ef0000b46577b6ab39184b9d7740ae88cd930e1f7ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="validMode")
    def valid_mode(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "validMode"))

    @valid_mode.setter
    def valid_mode(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37e479354ab62b6863c63d59b2ccd111a784d17680123df3ee3e7bf0f205654)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "validMode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c99dcf56a383d62e961d151aa57dea44d28821af4c3107cb4a6678db18d6147)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer",
    jsii_struct_bases=[],
    name_mapping={
        "access_control": "accessControl",
        "cache_key": "cacheKey",
        "caching": "caching",
        "content_compressor": "contentCompressor",
        "dynamic_web_content": "dynamicWebContent",
        "enabled": "enabled",
        "geo_location": "geoLocation",
        "ip": "ip",
        "large_file_delivery": "largeFileDelivery",
        "live_video_delivery": "liveVideoDelivery",
        "locked": "locked",
        "modify_path": "modifyPath",
        "on_demand_video_delivery": "onDemandVideoDelivery",
        "origin": "origin",
        "partner_domain_suffix": "partnerDomainSuffix",
        "referrer": "referrer",
        "refresh_content": "refreshContent",
        "site_failover": "siteFailover",
        "template_uuid": "templateUuid",
        "token_authorization": "tokenAuthorization",
        "uuid": "uuid",
        "web_application_firewall": "webApplicationFirewall",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer:
    def __init__(
        self,
        *,
        access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        partner_domain_suffix: typing.Optional[builtins.str] = None,
        referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param access_control: When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        :param cache_key: Allows you to set which query parameters are included in the cache key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        :param caching: Modifies content caching rules. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        :param content_compressor: Allows compression of subcustomer content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        :param dynamic_web_content: Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        :param enabled: Allows Cloud Embed to dynamically modify your subcustomers' content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param geo_location: Sets subcustomers' location-based whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        :param ip: Sets subcustomers' IP whitelists or blacklists. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        :param large_file_delivery: Enables large file delivery for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        :param live_video_delivery: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param modify_path: Modifies a subcustomer's request path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        :param on_demand_video_delivery: Enables delivery of media assets to subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        :param origin: Allows you to assign origin hostnames for customers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        :param partner_domain_suffix: This specifies the appropriate domain suffix, which you should typically match with your property hostname. It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        :param referrer: Sets subcustomers' referrer whitelists or blacklist. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        :param refresh_content: Allows you to reschedule when content validates for subcustomers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        :param site_failover: Allows you to configure unique failover sites for each subcustomer's policy. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_authorization: When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content. Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param web_application_firewall: Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic. Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b5c3937ebf5f7219287eecbc4e4a3e76c5c1c27f14358bfc8bf11523e6b4a9)
            check_type(argname="argument access_control", value=access_control, expected_type=type_hints["access_control"])
            check_type(argname="argument cache_key", value=cache_key, expected_type=type_hints["cache_key"])
            check_type(argname="argument caching", value=caching, expected_type=type_hints["caching"])
            check_type(argname="argument content_compressor", value=content_compressor, expected_type=type_hints["content_compressor"])
            check_type(argname="argument dynamic_web_content", value=dynamic_web_content, expected_type=type_hints["dynamic_web_content"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument geo_location", value=geo_location, expected_type=type_hints["geo_location"])
            check_type(argname="argument ip", value=ip, expected_type=type_hints["ip"])
            check_type(argname="argument large_file_delivery", value=large_file_delivery, expected_type=type_hints["large_file_delivery"])
            check_type(argname="argument live_video_delivery", value=live_video_delivery, expected_type=type_hints["live_video_delivery"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument modify_path", value=modify_path, expected_type=type_hints["modify_path"])
            check_type(argname="argument on_demand_video_delivery", value=on_demand_video_delivery, expected_type=type_hints["on_demand_video_delivery"])
            check_type(argname="argument origin", value=origin, expected_type=type_hints["origin"])
            check_type(argname="argument partner_domain_suffix", value=partner_domain_suffix, expected_type=type_hints["partner_domain_suffix"])
            check_type(argname="argument referrer", value=referrer, expected_type=type_hints["referrer"])
            check_type(argname="argument refresh_content", value=refresh_content, expected_type=type_hints["refresh_content"])
            check_type(argname="argument site_failover", value=site_failover, expected_type=type_hints["site_failover"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument web_application_firewall", value=web_application_firewall, expected_type=type_hints["web_application_firewall"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_control is not None:
            self._values["access_control"] = access_control
        if cache_key is not None:
            self._values["cache_key"] = cache_key
        if caching is not None:
            self._values["caching"] = caching
        if content_compressor is not None:
            self._values["content_compressor"] = content_compressor
        if dynamic_web_content is not None:
            self._values["dynamic_web_content"] = dynamic_web_content
        if enabled is not None:
            self._values["enabled"] = enabled
        if geo_location is not None:
            self._values["geo_location"] = geo_location
        if ip is not None:
            self._values["ip"] = ip
        if large_file_delivery is not None:
            self._values["large_file_delivery"] = large_file_delivery
        if live_video_delivery is not None:
            self._values["live_video_delivery"] = live_video_delivery
        if locked is not None:
            self._values["locked"] = locked
        if modify_path is not None:
            self._values["modify_path"] = modify_path
        if on_demand_video_delivery is not None:
            self._values["on_demand_video_delivery"] = on_demand_video_delivery
        if origin is not None:
            self._values["origin"] = origin
        if partner_domain_suffix is not None:
            self._values["partner_domain_suffix"] = partner_domain_suffix
        if referrer is not None:
            self._values["referrer"] = referrer
        if refresh_content is not None:
            self._values["refresh_content"] = refresh_content
        if site_failover is not None:
            self._values["site_failover"] = site_failover
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if uuid is not None:
            self._values["uuid"] = uuid
        if web_application_firewall is not None:
            self._values["web_application_firewall"] = web_application_firewall

    @builtins.property
    def access_control(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to deny requests to a subcustomer's content based on specific match conditions, which you use Cloud Embed to configure in each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_control DataAkamaiPropertyRulesBuilder#access_control}
        '''
        result = self._values.get("access_control")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def cache_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to set which query parameters are included in the cache key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cache_key DataAkamaiPropertyRulesBuilder#cache_key}
        '''
        result = self._values.get("cache_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def caching(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies content caching rules.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#caching DataAkamaiPropertyRulesBuilder#caching}
        '''
        result = self._values.get("caching")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def content_compressor(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows compression of subcustomer content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_compressor DataAkamaiPropertyRulesBuilder#content_compressor}
        '''
        result = self._values.get("content_compressor")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def dynamic_web_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to apply the ``dynamicWebContent`` behavior to further modify how dynamic content behaves for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#dynamic_web_content DataAkamaiPropertyRulesBuilder#dynamic_web_content}
        '''
        result = self._values.get("dynamic_web_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows Cloud Embed to dynamically modify your subcustomers' content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def geo_location(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' location-based whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#geo_location DataAkamaiPropertyRulesBuilder#geo_location}
        '''
        result = self._values.get("geo_location")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' IP whitelists or blacklists.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ip DataAkamaiPropertyRulesBuilder#ip}
        '''
        result = self._values.get("ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def large_file_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables large file delivery for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#large_file_delivery DataAkamaiPropertyRulesBuilder#large_file_delivery}
        '''
        result = self._values.get("large_file_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def live_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#live_video_delivery DataAkamaiPropertyRulesBuilder#live_video_delivery}.'''
        result = self._values.get("live_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def modify_path(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Modifies a subcustomer's request path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#modify_path DataAkamaiPropertyRulesBuilder#modify_path}
        '''
        result = self._values.get("modify_path")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def on_demand_video_delivery(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables delivery of media assets to subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#on_demand_video_delivery DataAkamaiPropertyRulesBuilder#on_demand_video_delivery}
        '''
        result = self._values.get("on_demand_video_delivery")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign origin hostnames for customers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin DataAkamaiPropertyRulesBuilder#origin}
        '''
        result = self._values.get("origin")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def partner_domain_suffix(self) -> typing.Optional[builtins.str]:
        '''This specifies the appropriate domain suffix, which you should typically match with your property hostname.

        It identifies the domain as trustworthy on the Akamai network, despite being defined within Cloud Embed, outside of your base property configuration. Include this domain suffix if you want to purge subcustomer URLs. For example, if you provide a value of ``suffix.example.com``, then to purge ``subcustomer.com/some/path``, specify ``subcustomer.com.suffix.example.com/some/path`` as the purge request's URL.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#partner_domain_suffix DataAkamaiPropertyRulesBuilder#partner_domain_suffix}
        '''
        result = self._values.get("partner_domain_suffix")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def referrer(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets subcustomers' referrer whitelists or blacklist.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#referrer DataAkamaiPropertyRulesBuilder#referrer}
        '''
        result = self._values.get("referrer")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def refresh_content(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to reschedule when content validates for subcustomers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#refresh_content DataAkamaiPropertyRulesBuilder#refresh_content}
        '''
        result = self._values.get("refresh_content")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def site_failover(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to configure unique failover sites for each subcustomer's policy.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#site_failover DataAkamaiPropertyRulesBuilder#site_failover}
        '''
        result = self._values.get("site_failover")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, this allows you to configure edge servers to use tokens to control access to subcustomer content.

        Use Cloud Embed to configure the token to appear in a cookie, header, or query parameter.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def web_application_firewall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Web application firewall (WAF) filters, monitors, and blocks certain HTTP traffic.

        Use ``Akamai Cloud Embed`` to add a specific behavior to a subcustomer policy and configure how WAF protection is applied.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#web_application_firewall DataAkamaiPropertyRulesBuilder#web_application_firewall}
        '''
        result = self._values.get("web_application_firewall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomerOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomerOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55034ad4a93790ee566051a0c4de9726a26d63da6b3768d62fc875be546404f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessControl")
    def reset_access_control(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessControl", []))

    @jsii.member(jsii_name="resetCacheKey")
    def reset_cache_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheKey", []))

    @jsii.member(jsii_name="resetCaching")
    def reset_caching(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaching", []))

    @jsii.member(jsii_name="resetContentCompressor")
    def reset_content_compressor(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentCompressor", []))

    @jsii.member(jsii_name="resetDynamicWebContent")
    def reset_dynamic_web_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDynamicWebContent", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetGeoLocation")
    def reset_geo_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetGeoLocation", []))

    @jsii.member(jsii_name="resetIp")
    def reset_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIp", []))

    @jsii.member(jsii_name="resetLargeFileDelivery")
    def reset_large_file_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLargeFileDelivery", []))

    @jsii.member(jsii_name="resetLiveVideoDelivery")
    def reset_live_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLiveVideoDelivery", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetModifyPath")
    def reset_modify_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetModifyPath", []))

    @jsii.member(jsii_name="resetOnDemandVideoDelivery")
    def reset_on_demand_video_delivery(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOnDemandVideoDelivery", []))

    @jsii.member(jsii_name="resetOrigin")
    def reset_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOrigin", []))

    @jsii.member(jsii_name="resetPartnerDomainSuffix")
    def reset_partner_domain_suffix(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPartnerDomainSuffix", []))

    @jsii.member(jsii_name="resetReferrer")
    def reset_referrer(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetReferrer", []))

    @jsii.member(jsii_name="resetRefreshContent")
    def reset_refresh_content(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRefreshContent", []))

    @jsii.member(jsii_name="resetSiteFailover")
    def reset_site_failover(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSiteFailover", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWebApplicationFirewall")
    def reset_web_application_firewall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWebApplicationFirewall", []))

    @builtins.property
    @jsii.member(jsii_name="accessControlInput")
    def access_control_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "accessControlInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheKeyInput")
    def cache_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cacheKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="cachingInput")
    def caching_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "cachingInput"))

    @builtins.property
    @jsii.member(jsii_name="contentCompressorInput")
    def content_compressor_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "contentCompressorInput"))

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContentInput")
    def dynamic_web_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "dynamicWebContentInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="geoLocationInput")
    def geo_location_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "geoLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="ipInput")
    def ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ipInput"))

    @builtins.property
    @jsii.member(jsii_name="largeFileDeliveryInput")
    def large_file_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "largeFileDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="liveVideoDeliveryInput")
    def live_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "liveVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="modifyPathInput")
    def modify_path_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "modifyPathInput"))

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDeliveryInput")
    def on_demand_video_delivery_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "onDemandVideoDeliveryInput"))

    @builtins.property
    @jsii.member(jsii_name="originInput")
    def origin_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "originInput"))

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffixInput")
    def partner_domain_suffix_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "partnerDomainSuffixInput"))

    @builtins.property
    @jsii.member(jsii_name="referrerInput")
    def referrer_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "referrerInput"))

    @builtins.property
    @jsii.member(jsii_name="refreshContentInput")
    def refresh_content_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "refreshContentInput"))

    @builtins.property
    @jsii.member(jsii_name="siteFailoverInput")
    def site_failover_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "siteFailoverInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewallInput")
    def web_application_firewall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "webApplicationFirewallInput"))

    @builtins.property
    @jsii.member(jsii_name="accessControl")
    def access_control(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "accessControl"))

    @access_control.setter
    def access_control(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d48ebff8ebad99d48705e1ec070e66340a24b9cdd3d6e2127c08ecaf420a451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessControl", value)

    @builtins.property
    @jsii.member(jsii_name="cacheKey")
    def cache_key(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "cacheKey"))

    @cache_key.setter
    def cache_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e05f51c4932f57d97dcb6154ebac43efe4e3e07e82d41df224f3eaf5e64046cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cacheKey", value)

    @builtins.property
    @jsii.member(jsii_name="caching")
    def caching(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caching"))

    @caching.setter
    def caching(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeded650a0dcfa3bfcc3ae642c8aff9d55063989c06a65c6d6c658ad434ecb9c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caching", value)

    @builtins.property
    @jsii.member(jsii_name="contentCompressor")
    def content_compressor(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "contentCompressor"))

    @content_compressor.setter
    def content_compressor(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9a0bbf47699e2c1517d061c2637d268de7b9dffa10fe5788e648fd78388c50f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "contentCompressor", value)

    @builtins.property
    @jsii.member(jsii_name="dynamicWebContent")
    def dynamic_web_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "dynamicWebContent"))

    @dynamic_web_content.setter
    def dynamic_web_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c854a431c2970293240fadb68a0f137e897bf06a484feaf5d84a1982a2e63f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "dynamicWebContent", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5586d86a6ad1a1f29ae93ded16f0fddddfd12e2b40da8d416b3fb90e957b1fec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="geoLocation")
    def geo_location(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "geoLocation"))

    @geo_location.setter
    def geo_location(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55ae3997ddcf5f4b6e6bfc66e0f80d15f10a9f5e9116e707931834da34f758b8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "geoLocation", value)

    @builtins.property
    @jsii.member(jsii_name="ip")
    def ip(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ip"))

    @ip.setter
    def ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb13e175ff328fe8963528bfee553b27b075e75c4670cf9f9e2cf53f1f5adc44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ip", value)

    @builtins.property
    @jsii.member(jsii_name="largeFileDelivery")
    def large_file_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "largeFileDelivery"))

    @large_file_delivery.setter
    def large_file_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55b3228ea22dd45a494b22e79f2db605ae4158a9e0ba8b9fe1e3fdf4181c0863)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "largeFileDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="liveVideoDelivery")
    def live_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "liveVideoDelivery"))

    @live_video_delivery.setter
    def live_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d797dc60cc7ccd9e8ccbe510e0dc30d3188d1cd07bba9cc7427351538722b2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "liveVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f527c11989c80a3d1817b3ea783b920a3460f4644b62e567b75b87a1c723212)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="modifyPath")
    def modify_path(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "modifyPath"))

    @modify_path.setter
    def modify_path(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16c9b679e5e66127c074c10d8f98c9bd22925399b02f153e4f4f7aa60d1c3347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "modifyPath", value)

    @builtins.property
    @jsii.member(jsii_name="onDemandVideoDelivery")
    def on_demand_video_delivery(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "onDemandVideoDelivery"))

    @on_demand_video_delivery.setter
    def on_demand_video_delivery(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d115052f409da3ee8102891e0086d8a1ab46fdde108074b43af0182b37a0b84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "onDemandVideoDelivery", value)

    @builtins.property
    @jsii.member(jsii_name="origin")
    def origin(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "origin"))

    @origin.setter
    def origin(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd670aacf0b9a77d61b404ac53f7fde49e06ff19c2474e60d10b5d8836639417)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "origin", value)

    @builtins.property
    @jsii.member(jsii_name="partnerDomainSuffix")
    def partner_domain_suffix(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "partnerDomainSuffix"))

    @partner_domain_suffix.setter
    def partner_domain_suffix(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44835b39c58560d564e818930ac22ebfbd871febfe9a133b23b8dacd7e9940da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "partnerDomainSuffix", value)

    @builtins.property
    @jsii.member(jsii_name="referrer")
    def referrer(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "referrer"))

    @referrer.setter
    def referrer(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4ce27e4ae625ed6910e5878dbd9a6a4f6695bd8718a2467da68834fe24d1d72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "referrer", value)

    @builtins.property
    @jsii.member(jsii_name="refreshContent")
    def refresh_content(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "refreshContent"))

    @refresh_content.setter
    def refresh_content(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af54ff5b2d5b01e4e9290ab47014762b0c2a12f4f4cb8d8670cf8a83d4849784)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "refreshContent", value)

    @builtins.property
    @jsii.member(jsii_name="siteFailover")
    def site_failover(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "siteFailover"))

    @site_failover.setter
    def site_failover(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__230e1bcecc92d18fdbefb2c74dc0004048b6ee81ee8f5ea44386ddd6a7cc9678)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "siteFailover", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17a01484e3e1759cbd297e91e32db13ccc36637d110971dc99d24afb1883f32c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "tokenAuthorization"))

    @token_authorization.setter
    def token_authorization(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dd05303a8444713d4b2cf79c9486f4f8679202fcc62085b14b8ba195c2175e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenAuthorization", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ba5b0eed65d0e068a105db22a765fee5be7374acd8222f52c33d79bdeb318e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="webApplicationFirewall")
    def web_application_firewall(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "webApplicationFirewall"))

    @web_application_firewall.setter
    def web_application_firewall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589684be1d254ea86173fac9c4b534e98fa0536955e978a47d0be5606288a50b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "webApplicationFirewall", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d8347e2f03a1745ab2057b9a18c19d8cb0db8243196c333aac4ad871675163)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute",
    jsii_struct_bases=[],
    name_mapping={
        "allow_fcm_parent_override": "allowFcmParentOverride",
        "custom_map": "customMap",
        "custom_stat_key": "customStatKey",
        "enable_custom_key": "enableCustomKey",
        "enabled": "enabled",
        "force_ssl_forward": "forceSslForward",
        "locked": "locked",
        "race_stat_ttl": "raceStatTtl",
        "sr_download_link_title": "srDownloadLinkTitle",
        "template_uuid": "templateUuid",
        "test_object_url": "testObjectUrl",
        "to_host": "toHost",
        "to_host_status": "toHostStatus",
        "type": "type",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute:
    def __init__(
        self,
        *,
        allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map: typing.Optional[builtins.str] = None,
        custom_stat_key: typing.Optional[builtins.str] = None,
        enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        race_stat_ttl: typing.Optional[builtins.str] = None,
        sr_download_link_title: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        test_object_url: typing.Optional[builtins.str] = None,
        to_host: typing.Optional[builtins.str] = None,
        to_host_status: typing.Optional[builtins.str] = None,
        type: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allow_fcm_parent_override: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.
        :param custom_map: If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        :param custom_stat_key: This specifies a hostname under which to cache race results. This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        :param enable_custom_key: When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        :param enabled: Enables the SureRoute behavior, to optimize delivery of non-cached content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param force_ssl_forward: Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param race_stat_ttl: Specifies the time-to-live to preserve SureRoute race results, typically ``30m``. If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        :param sr_download_link_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param test_object_url: Specifies the path and filename for your origin's test object to use in races to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        :param to_host: If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        :param to_host_status: Specifies which hostname to use. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        :param type: Specifies the set of edge servers used to test routes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5a6efa90e7573b1f470ae5406242155ddc05e4976b0e1f050877a9c254dbbe16)
            check_type(argname="argument allow_fcm_parent_override", value=allow_fcm_parent_override, expected_type=type_hints["allow_fcm_parent_override"])
            check_type(argname="argument custom_map", value=custom_map, expected_type=type_hints["custom_map"])
            check_type(argname="argument custom_stat_key", value=custom_stat_key, expected_type=type_hints["custom_stat_key"])
            check_type(argname="argument enable_custom_key", value=enable_custom_key, expected_type=type_hints["enable_custom_key"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument force_ssl_forward", value=force_ssl_forward, expected_type=type_hints["force_ssl_forward"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument race_stat_ttl", value=race_stat_ttl, expected_type=type_hints["race_stat_ttl"])
            check_type(argname="argument sr_download_link_title", value=sr_download_link_title, expected_type=type_hints["sr_download_link_title"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument test_object_url", value=test_object_url, expected_type=type_hints["test_object_url"])
            check_type(argname="argument to_host", value=to_host, expected_type=type_hints["to_host"])
            check_type(argname="argument to_host_status", value=to_host_status, expected_type=type_hints["to_host_status"])
            check_type(argname="argument type", value=type, expected_type=type_hints["type"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allow_fcm_parent_override is not None:
            self._values["allow_fcm_parent_override"] = allow_fcm_parent_override
        if custom_map is not None:
            self._values["custom_map"] = custom_map
        if custom_stat_key is not None:
            self._values["custom_stat_key"] = custom_stat_key
        if enable_custom_key is not None:
            self._values["enable_custom_key"] = enable_custom_key
        if enabled is not None:
            self._values["enabled"] = enabled
        if force_ssl_forward is not None:
            self._values["force_ssl_forward"] = force_ssl_forward
        if locked is not None:
            self._values["locked"] = locked
        if race_stat_ttl is not None:
            self._values["race_stat_ttl"] = race_stat_ttl
        if sr_download_link_title is not None:
            self._values["sr_download_link_title"] = sr_download_link_title
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if test_object_url is not None:
            self._values["test_object_url"] = test_object_url
        if to_host is not None:
            self._values["to_host"] = to_host
        if to_host_status is not None:
            self._values["to_host_status"] = to_host_status
        if type is not None:
            self._values["type"] = type
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allow_fcm_parent_override(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allow_fcm_parent_override DataAkamaiPropertyRulesBuilder#allow_fcm_parent_override}.'''
        result = self._values.get("allow_fcm_parent_override")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map(self) -> typing.Optional[builtins.str]:
        '''If ``type`` is ``CUSTOM_MAP``, this specifies the map string provided to you by Akamai Professional Services, or included as part of the ``Site Shield`` product.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map DataAkamaiPropertyRulesBuilder#custom_map}
        '''
        result = self._values.get("custom_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_stat_key(self) -> typing.Optional[builtins.str]:
        '''This specifies a hostname under which to cache race results.

        This may be useful when a property corresponds to many origin hostnames. By default, SureRoute would launch races for each origin, but consolidating under a single hostname runs only one race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_stat_key DataAkamaiPropertyRulesBuilder#custom_stat_key}
        '''
        result = self._values.get("custom_stat_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable_custom_key(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When disabled, caches race results under the race destination's hostname. If enabled, use ``customStatKey`` to specify a custom hostname.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_custom_key DataAkamaiPropertyRulesBuilder#enable_custom_key}
        '''
        result = self._values.get("enable_custom_key")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the SureRoute behavior, to optimize delivery of non-cached content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def force_ssl_forward(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Forces SureRoute to use SSL when requesting the origin's test object, appropriate if your origin does not respond to HTTP requests, or responds with a redirect to HTTPS.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#force_ssl_forward DataAkamaiPropertyRulesBuilder#force_ssl_forward}
        '''
        result = self._values.get("force_ssl_forward")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def race_stat_ttl(self) -> typing.Optional[builtins.str]:
        '''Specifies the time-to-live to preserve SureRoute race results, typically ``30m``.

        If traffic exceeds a certain threshold after TTL expires, the overflow is routed directly to the origin, not necessarily optimally. If traffic remains under the threshold, the route is determined by the winner of the most recent race.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#race_stat_ttl DataAkamaiPropertyRulesBuilder#race_stat_ttl}
        '''
        result = self._values.get("race_stat_ttl")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def sr_download_link_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sr_download_link_title DataAkamaiPropertyRulesBuilder#sr_download_link_title}
        '''
        result = self._values.get("sr_download_link_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def test_object_url(self) -> typing.Optional[builtins.str]:
        '''Specifies the path and filename for your origin's test object to use in races to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#test_object_url DataAkamaiPropertyRulesBuilder#test_object_url}
        '''
        result = self._values.get("test_object_url")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host(self) -> typing.Optional[builtins.str]:
        '''If ``toHostStatus`` is ``OTHER``, this specifies the custom ``Host`` header to use when requesting the SureRoute test object.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host DataAkamaiPropertyRulesBuilder#to_host}
        '''
        result = self._values.get("to_host")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def to_host_status(self) -> typing.Optional[builtins.str]:
        '''Specifies which hostname to use.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#to_host_status DataAkamaiPropertyRulesBuilder#to_host_status}
        '''
        result = self._values.get("to_host_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def type(self) -> typing.Optional[builtins.str]:
        '''Specifies the set of edge servers used to test routes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#type DataAkamaiPropertyRulesBuilder#type}
        '''
        result = self._values.get("type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRouteOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRouteOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aafe6ba6e09b928c146d17a7eab484d120b9cd89e0fc5d89b47681c096ddb8f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowFcmParentOverride")
    def reset_allow_fcm_parent_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowFcmParentOverride", []))

    @jsii.member(jsii_name="resetCustomMap")
    def reset_custom_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMap", []))

    @jsii.member(jsii_name="resetCustomStatKey")
    def reset_custom_stat_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomStatKey", []))

    @jsii.member(jsii_name="resetEnableCustomKey")
    def reset_enable_custom_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableCustomKey", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetForceSslForward")
    def reset_force_ssl_forward(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetForceSslForward", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetRaceStatTtl")
    def reset_race_stat_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRaceStatTtl", []))

    @jsii.member(jsii_name="resetSrDownloadLinkTitle")
    def reset_sr_download_link_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSrDownloadLinkTitle", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTestObjectUrl")
    def reset_test_object_url(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTestObjectUrl", []))

    @jsii.member(jsii_name="resetToHost")
    def reset_to_host(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHost", []))

    @jsii.member(jsii_name="resetToHostStatus")
    def reset_to_host_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetToHostStatus", []))

    @jsii.member(jsii_name="resetType")
    def reset_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetType", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverrideInput")
    def allow_fcm_parent_override_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowFcmParentOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapInput")
    def custom_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapInput"))

    @builtins.property
    @jsii.member(jsii_name="customStatKeyInput")
    def custom_stat_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customStatKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enableCustomKeyInput")
    def enable_custom_key_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableCustomKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="forceSslForwardInput")
    def force_ssl_forward_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "forceSslForwardInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="raceStatTtlInput")
    def race_stat_ttl_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "raceStatTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitleInput")
    def sr_download_link_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "srDownloadLinkTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="testObjectUrlInput")
    def test_object_url_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "testObjectUrlInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostInput")
    def to_host_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostInput"))

    @builtins.property
    @jsii.member(jsii_name="toHostStatusInput")
    def to_host_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "toHostStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="typeInput")
    def type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "typeInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowFcmParentOverride")
    def allow_fcm_parent_override(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowFcmParentOverride"))

    @allow_fcm_parent_override.setter
    def allow_fcm_parent_override(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9b4f3fed2ad5dd7ac4a7be2385790cfdd11024a9d9cd973a4ddfacd446d1bc5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowFcmParentOverride", value)

    @builtins.property
    @jsii.member(jsii_name="customMap")
    def custom_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMap"))

    @custom_map.setter
    def custom_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d270f5ebe37814d20bc2c0ba3c29b8776b6211c19d6c79b7bd8675eb9ba9219c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMap", value)

    @builtins.property
    @jsii.member(jsii_name="customStatKey")
    def custom_stat_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customStatKey"))

    @custom_stat_key.setter
    def custom_stat_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81960d5fa4b5e479842092f1edecccdfd5440488c6096514ce40281f525cecf1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customStatKey", value)

    @builtins.property
    @jsii.member(jsii_name="enableCustomKey")
    def enable_custom_key(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableCustomKey"))

    @enable_custom_key.setter
    def enable_custom_key(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a4ba90ecfe85f77bd0d0ae9d8b1800fedf6f491661be9ce78ce1c16d1f5f743)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableCustomKey", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82e3b67c2d0eec7ea8c33eef0030cd182b0369b6934192814f775a765cdfc4a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="forceSslForward")
    def force_ssl_forward(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "forceSslForward"))

    @force_ssl_forward.setter
    def force_ssl_forward(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2288f769bb782de8e83bccd3a0c33615cc181e451c9eb426eb5edeed0f206aa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "forceSslForward", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__176b77edd1f424aff22aaccccdab2ec68d6a94de96616be3d9835cb5932d547f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="raceStatTtl")
    def race_stat_ttl(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "raceStatTtl"))

    @race_stat_ttl.setter
    def race_stat_ttl(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7aff2074bf53721237919842de0bdf1f1603fad2ea0f01e277a9f9d2e93692c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "raceStatTtl", value)

    @builtins.property
    @jsii.member(jsii_name="srDownloadLinkTitle")
    def sr_download_link_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "srDownloadLinkTitle"))

    @sr_download_link_title.setter
    def sr_download_link_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e1ac5c7b8741a41bb67855a9e105225b2038a0e42e6149e845caf4168b665c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "srDownloadLinkTitle", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__491cd6e629ae217cb2dd4ab1d7567d11457b87ca2c66e4c21723bc2d8c86d14d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="testObjectUrl")
    def test_object_url(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "testObjectUrl"))

    @test_object_url.setter
    def test_object_url(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__674baf3504be22233dfb601ee588d55f697765ff38a2a6d5a600ff833bb05537)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "testObjectUrl", value)

    @builtins.property
    @jsii.member(jsii_name="toHost")
    def to_host(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHost"))

    @to_host.setter
    def to_host(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0057dfc6e0c21a45f529f2f080b16483c2ebf84161c495ea6f26037506b09c1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHost", value)

    @builtins.property
    @jsii.member(jsii_name="toHostStatus")
    def to_host_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "toHostStatus"))

    @to_host_status.setter
    def to_host_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da709f7d3de0bd564536a7f45bdc4e0f354055d6bda61704ebfa88398f2521af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "toHostStatus", value)

    @builtins.property
    @jsii.member(jsii_name="type")
    def type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "type"))

    @type.setter
    def type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__97c4eb4d7df4e13e2687e3230460162515f29a00e5eba3b0397158ad022260bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "type", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c84bda76e8a9791080bcd02efcf435eb13aaadd01b3af5c4fa210e690db01fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__14d629b9ff47b12b107621094c7e70cb0e1f88209c84b88e423edfa9811c7a4c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization",
    jsii_struct_bases=[],
    name_mapping={
        "display": "display",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization:
    def __init__(
        self,
        *,
        display: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param display: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d179c2887d5449388118e50f593e9129815473eca66928e762d09fc1b28a66e)
            check_type(argname="argument display", value=display, expected_type=type_hints["display"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if display is not None:
            self._values["display"] = display
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def display(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#display DataAkamaiPropertyRulesBuilder#display}
        '''
        result = self._values.get("display")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77bf925b6c1c357015073b9decfc49d69e9308c31e77a6476f01559a2bb92261)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetDisplay")
    def reset_display(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDisplay", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="displayInput")
    def display_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "displayInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="display")
    def display(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "display"))

    @display.setter
    def display(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c0dcd07f2804fd41a51d51d619af86b8ff4c89a988af5747661b0d59676817a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "display", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd930e8479e2d83e94485fa80673b335e0a161a837d4eb577c3e0261f88fefb5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e053811894b6b156de42a5de7484cc0d6801b7e7e6ec830fa9ae40e56ef273dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd22e2f6a87cc5fd3bc196d6d0fd893cbbd0529d2e0da2ddde247e2848b2dcf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29e2f8e8f8323a1beb0e2821712cf05398062b651b4a17cbd6c2c6b35348b691)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "ibm_customer_id": "ibmCustomerId",
        "limit_to_dynamic": "limitToDynamic",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ibm_customer_id: typing.Optional[jsii.Number] = None,
        limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param ibm_customer_id: The integer identifier for the IBM Tealeaf Connector account. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        :param limit_to_dynamic: Limit traffic to dynamic, uncached (``No-Store``) content. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2dd9853fe998e639850bcc14bf4e408d102516c421a930b4d38c558a3206d41)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument ibm_customer_id", value=ibm_customer_id, expected_type=type_hints["ibm_customer_id"])
            check_type(argname="argument limit_to_dynamic", value=limit_to_dynamic, expected_type=type_hints["limit_to_dynamic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if ibm_customer_id is not None:
            self._values["ibm_customer_id"] = ibm_customer_id
        if limit_to_dynamic is not None:
            self._values["limit_to_dynamic"] = limit_to_dynamic
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, capture HTTPS requests and responses, and send the data to your IBM Tealeaf account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ibm_customer_id(self) -> typing.Optional[jsii.Number]:
        '''The integer identifier for the IBM Tealeaf Connector account.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ibm_customer_id DataAkamaiPropertyRulesBuilder#ibm_customer_id}
        '''
        result = self._values.get("ibm_customer_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_to_dynamic(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Limit traffic to dynamic, uncached (``No-Store``) content.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_to_dynamic DataAkamaiPropertyRulesBuilder#limit_to_dynamic}
        '''
        result = self._values.get("limit_to_dynamic")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeafOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeafOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70fc7daae62257521fe5d4538c172188b5b03d94ec62d1595a1b7394d7f9a03a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetIbmCustomerId")
    def reset_ibm_customer_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIbmCustomerId", []))

    @jsii.member(jsii_name="resetLimitToDynamic")
    def reset_limit_to_dynamic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitToDynamic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerIdInput")
    def ibm_customer_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "ibmCustomerIdInput"))

    @builtins.property
    @jsii.member(jsii_name="limitToDynamicInput")
    def limit_to_dynamic_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "limitToDynamicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0b48444ee476bf8ab08c510b6eec2e58e8ce76fcc3e3dfe13d602774da05e07)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="ibmCustomerId")
    def ibm_customer_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "ibmCustomerId"))

    @ibm_customer_id.setter
    def ibm_customer_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__503823b36d8ca37dc481ed1487011a63db8b63782739c348a977f18502dee6fc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ibmCustomerId", value)

    @builtins.property
    @jsii.member(jsii_name="limitToDynamic")
    def limit_to_dynamic(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "limitToDynamic"))

    @limit_to_dynamic.setter
    def limit_to_dynamic(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__888bd529290dccd60370e6facc8283e9bed3834ee0fe01dbcd2d3d7fda5a5d7c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitToDynamic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a91ab9ccf97d5c7ee3b6970d330944faa86a7be42c55406fef2e4eb283fa070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0060bb48ae9c180451cdeb21f3239a4cbb3c5bb0b28331070bccd6caac5af51c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20775da55699cf818e120631f4b02f16e5d6e7d8851935ad1bdb4f13074bf03a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f7cf941ec0bb422e944db9f5dfbaf3ab481cd3cebe0aa81b97373d66e626f9a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f1955ed15492219efcba9f5f7d5e0ae43a48cc8a4dc3888e8e9e05fb587db00)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin.

        A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "allowall": "allowall",
        "enabled": "enabled",
        "locked": "locked",
        "method": "method",
        "policy": "policy",
        "template_uuid": "templateUuid",
        "tiered_distribution_map": "tieredDistributionMap",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced:
    def __init__(
        self,
        *,
        allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        method: typing.Optional[builtins.str] = None,
        policy: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tiered_distribution_map: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param allowall: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.
        :param enabled: When enabled, activates tiered distribution. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param method: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.
        :param policy: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tiered_distribution_map: Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe; ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache. This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4284078d75774b0f4ead9828cb5c278411a34963e279a15bd8872c52277ddf75)
            check_type(argname="argument allowall", value=allowall, expected_type=type_hints["allowall"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument method", value=method, expected_type=type_hints["method"])
            check_type(argname="argument policy", value=policy, expected_type=type_hints["policy"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tiered_distribution_map", value=tiered_distribution_map, expected_type=type_hints["tiered_distribution_map"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowall is not None:
            self._values["allowall"] = allowall
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if method is not None:
            self._values["method"] = method
        if policy is not None:
            self._values["policy"] = policy
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tiered_distribution_map is not None:
            self._values["tiered_distribution_map"] = tiered_distribution_map
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def allowall(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowall DataAkamaiPropertyRulesBuilder#allowall}.'''
        result = self._values.get("allowall")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, activates tiered distribution.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def method(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#method DataAkamaiPropertyRulesBuilder#method}.'''
        result = self._values.get("method")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def policy(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#policy DataAkamaiPropertyRulesBuilder#policy}.'''
        result = self._values.get("policy")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tiered_distribution_map(self) -> typing.Optional[builtins.str]:
        '''Optionally map the tiered parent server's location close to your origin: ``CHEU2`` for Europe;

        ``CHAUS`` for Australia; ``CHAPAC`` for China and the Asian Pacific area; ``CHWUS2``, ``CHCUS2``, and ``CHEUS2`` for different parts of the United States. Choose ``CH`` or ``CH2`` for a more global map. A narrower local map minimizes the origin server's load, and increases the likelihood the requested object is cached. A wider global map reduces end-user latency, but decreases the likelihood the requested object is in any given parent server's cache.  This option cannot apply if the property is marked as secure. See ``Secure property requirements`` for guidance.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tiered_distribution_map DataAkamaiPropertyRulesBuilder#tiered_distribution_map}
        '''
        result = self._values.get("tiered_distribution_map")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__631342eb484d35c6508bcbcc76a83093e9a1622222014e176011753404244328)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAllowall")
    def reset_allowall(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowall", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMethod")
    def reset_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMethod", []))

    @jsii.member(jsii_name="resetPolicy")
    def reset_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPolicy", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="allowallInput")
    def allowall_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowallInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="methodInput")
    def method_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "methodInput"))

    @builtins.property
    @jsii.member(jsii_name="policyInput")
    def policy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "policyInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="allowall")
    def allowall(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowall"))

    @allowall.setter
    def allowall(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fd34a90d2cc5fc5ec9e19d29bcdb6e85bbc903175ef059b82cb2210c2dad6ff7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowall", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e729c626586ef4aa78c9bd88d55204a9b808acf0357bba8371b383ab5940bb50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f63f9277977d379641acdb1c1bf322cea15545b5b7c50d808de777dc4f7a4bc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="method")
    def method(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "method"))

    @method.setter
    def method(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__311594a8eee4756cfd1304559955958a16079cf8a8b635614cd74967bfb8bdd1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "method", value)

    @builtins.property
    @jsii.member(jsii_name="policy")
    def policy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "policy"))

    @policy.setter
    def policy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74d68e9dcd9530dd696a4473f0cc9e3045f3108776426822404b81496f8bddf5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "policy", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__582e056802f99645744887858c595128b092ae455a9548d3d074394392b8089f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__42908fa899ba5667f9fe00a95f655fa455379eac343f520d12850344ed8d6a7d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8236b623350aaebdb4dcffb2bb40a671335585daab61e363840c0c0471d29241)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__528b0984bee06876b122f17ccd02c1772aa86b90626612c17dfe193adc6c2d41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization",
    jsii_struct_bases=[],
    name_mapping={
        "cloudwrapper_map_migration_title": "cloudwrapperMapMigrationTitle",
        "custom_map_enabled": "customMapEnabled",
        "custom_map_name": "customMapName",
        "hash_algorithm": "hashAlgorithm",
        "location": "location",
        "locked": "locked",
        "map_migration_enabled": "mapMigrationEnabled",
        "migration_end_date": "migrationEndDate",
        "migration_start_date": "migrationStartDate",
        "migration_within_cw_maps_enabled": "migrationWithinCwMapsEnabled",
        "serial_end": "serialEnd",
        "serial_start": "serialStart",
        "template_uuid": "templateUuid",
        "tier1_title": "tier1Title",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization:
    def __init__(
        self,
        *,
        cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
        custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        custom_map_name: typing.Optional[builtins.str] = None,
        hash_algorithm: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        migration_end_date: typing.Optional[builtins.str] = None,
        migration_start_date: typing.Optional[builtins.str] = None,
        migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        serial_end: typing.Optional[builtins.str] = None,
        serial_start: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        tier1_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cloudwrapper_map_migration_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        :param custom_map_enabled: Enables custom maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        :param custom_map_name: Specifies the custom map name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        :param hash_algorithm: Specifies the hash algorithm. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        :param location: Location from which Cloud Wrapper migration is performed. User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param map_migration_enabled: Enables migration of the custom map to Cloud Wrapper. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        :param migration_end_date: Specifies when the map migration should end. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        :param migration_start_date: Specifies when to start migrating the map. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        :param migration_within_cw_maps_enabled: Enables migration within Cloud Wrapper maps. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        :param serial_end: Specifies a numeric serial end value. Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        :param serial_start: Specifies a numeric serial start value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param tier1_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__097f8ce3e23f81734623e2b7fa84a34a28ac6bf0ce0cf41ca5e08721739ca29b)
            check_type(argname="argument cloudwrapper_map_migration_title", value=cloudwrapper_map_migration_title, expected_type=type_hints["cloudwrapper_map_migration_title"])
            check_type(argname="argument custom_map_enabled", value=custom_map_enabled, expected_type=type_hints["custom_map_enabled"])
            check_type(argname="argument custom_map_name", value=custom_map_name, expected_type=type_hints["custom_map_name"])
            check_type(argname="argument hash_algorithm", value=hash_algorithm, expected_type=type_hints["hash_algorithm"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument map_migration_enabled", value=map_migration_enabled, expected_type=type_hints["map_migration_enabled"])
            check_type(argname="argument migration_end_date", value=migration_end_date, expected_type=type_hints["migration_end_date"])
            check_type(argname="argument migration_start_date", value=migration_start_date, expected_type=type_hints["migration_start_date"])
            check_type(argname="argument migration_within_cw_maps_enabled", value=migration_within_cw_maps_enabled, expected_type=type_hints["migration_within_cw_maps_enabled"])
            check_type(argname="argument serial_end", value=serial_end, expected_type=type_hints["serial_end"])
            check_type(argname="argument serial_start", value=serial_start, expected_type=type_hints["serial_start"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument tier1_title", value=tier1_title, expected_type=type_hints["tier1_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cloudwrapper_map_migration_title is not None:
            self._values["cloudwrapper_map_migration_title"] = cloudwrapper_map_migration_title
        if custom_map_enabled is not None:
            self._values["custom_map_enabled"] = custom_map_enabled
        if custom_map_name is not None:
            self._values["custom_map_name"] = custom_map_name
        if hash_algorithm is not None:
            self._values["hash_algorithm"] = hash_algorithm
        if location is not None:
            self._values["location"] = location
        if locked is not None:
            self._values["locked"] = locked
        if map_migration_enabled is not None:
            self._values["map_migration_enabled"] = map_migration_enabled
        if migration_end_date is not None:
            self._values["migration_end_date"] = migration_end_date
        if migration_start_date is not None:
            self._values["migration_start_date"] = migration_start_date
        if migration_within_cw_maps_enabled is not None:
            self._values["migration_within_cw_maps_enabled"] = migration_within_cw_maps_enabled
        if serial_end is not None:
            self._values["serial_end"] = serial_end
        if serial_start is not None:
            self._values["serial_start"] = serial_start
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if tier1_title is not None:
            self._values["tier1_title"] = tier1_title
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def cloudwrapper_map_migration_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudwrapper_map_migration_title DataAkamaiPropertyRulesBuilder#cloudwrapper_map_migration_title}
        '''
        result = self._values.get("cloudwrapper_map_migration_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_map_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables custom maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_enabled DataAkamaiPropertyRulesBuilder#custom_map_enabled}
        '''
        result = self._values.get("custom_map_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def custom_map_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the custom map name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_map_name DataAkamaiPropertyRulesBuilder#custom_map_name}
        '''
        result = self._values.get("custom_map_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def hash_algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the hash algorithm.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hash_algorithm DataAkamaiPropertyRulesBuilder#hash_algorithm}
        '''
        result = self._values.get("hash_algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Location from which Cloud Wrapper migration is performed.

        User should choose the existing Cloud Wrapper location. The new Cloud Wrapper location (to which migration has to happen) is expected to be updated as part of the main "Cloud Wrapper" behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def map_migration_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration of the custom map to Cloud Wrapper.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#map_migration_enabled DataAkamaiPropertyRulesBuilder#map_migration_enabled}
        '''
        result = self._values.get("map_migration_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def migration_end_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when the map migration should end.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_end_date DataAkamaiPropertyRulesBuilder#migration_end_date}
        '''
        result = self._values.get("migration_end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_start_date(self) -> typing.Optional[builtins.str]:
        '''Specifies when to start migrating the map.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_start_date DataAkamaiPropertyRulesBuilder#migration_start_date}
        '''
        result = self._values.get("migration_start_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables migration within Cloud Wrapper maps.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#migration_within_cw_maps_enabled DataAkamaiPropertyRulesBuilder#migration_within_cw_maps_enabled}
        '''
        result = self._values.get("migration_within_cw_maps_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def serial_end(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial end value.

        Akamai uses serial numbers to group machines and share objects in their cache with other machines in the same region.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_end DataAkamaiPropertyRulesBuilder#serial_end}
        '''
        result = self._values.get("serial_end")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def serial_start(self) -> typing.Optional[builtins.str]:
        '''Specifies a numeric serial start value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#serial_start DataAkamaiPropertyRulesBuilder#serial_start}
        '''
        result = self._values.get("serial_start")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def tier1_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#tier1_title DataAkamaiPropertyRulesBuilder#tier1_title}
        '''
        result = self._values.get("tier1_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36e3d446f0a8e3df7cabc7bd46fd749a9f0cfe3bcf63a96e33e6e7a4a8873a69)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloudwrapperMapMigrationTitle")
    def reset_cloudwrapper_map_migration_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudwrapperMapMigrationTitle", []))

    @jsii.member(jsii_name="resetCustomMapEnabled")
    def reset_custom_map_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapEnabled", []))

    @jsii.member(jsii_name="resetCustomMapName")
    def reset_custom_map_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomMapName", []))

    @jsii.member(jsii_name="resetHashAlgorithm")
    def reset_hash_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHashAlgorithm", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMapMigrationEnabled")
    def reset_map_migration_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMapMigrationEnabled", []))

    @jsii.member(jsii_name="resetMigrationEndDate")
    def reset_migration_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationEndDate", []))

    @jsii.member(jsii_name="resetMigrationStartDate")
    def reset_migration_start_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationStartDate", []))

    @jsii.member(jsii_name="resetMigrationWithinCwMapsEnabled")
    def reset_migration_within_cw_maps_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMigrationWithinCwMapsEnabled", []))

    @jsii.member(jsii_name="resetSerialEnd")
    def reset_serial_end(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialEnd", []))

    @jsii.member(jsii_name="resetSerialStart")
    def reset_serial_start(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSerialStart", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTier1Title")
    def reset_tier1_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTier1Title", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitleInput")
    def cloudwrapper_map_migration_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cloudwrapperMapMigrationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapEnabledInput")
    def custom_map_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customMapEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="customMapNameInput")
    def custom_map_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customMapNameInput"))

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithmInput")
    def hash_algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "hashAlgorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabledInput")
    def map_migration_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "mapMigrationEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationEndDateInput")
    def migration_end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationEndDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationStartDateInput")
    def migration_start_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "migrationStartDateInput"))

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabledInput")
    def migration_within_cw_maps_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "migrationWithinCwMapsEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="serialEndInput")
    def serial_end_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialEndInput"))

    @builtins.property
    @jsii.member(jsii_name="serialStartInput")
    def serial_start_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "serialStartInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tier1TitleInput")
    def tier1_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tier1TitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudwrapperMapMigrationTitle")
    def cloudwrapper_map_migration_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cloudwrapperMapMigrationTitle"))

    @cloudwrapper_map_migration_title.setter
    def cloudwrapper_map_migration_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc026a385237443d93f653d99aee585ae9af31c218ebada1b2ec23322f416373)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudwrapperMapMigrationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="customMapEnabled")
    def custom_map_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customMapEnabled"))

    @custom_map_enabled.setter
    def custom_map_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ec4868facfc9566a45013007bc8860630660ceb2222c7bf1f6574d256a15f1d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="customMapName")
    def custom_map_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customMapName"))

    @custom_map_name.setter
    def custom_map_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4b5374e20aa5dddb08de5baafee637632907e03d584b20c4acab1af70512551a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customMapName", value)

    @builtins.property
    @jsii.member(jsii_name="hashAlgorithm")
    def hash_algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "hashAlgorithm"))

    @hash_algorithm.setter
    def hash_algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f082a22c18835b6deef606dce31f3a9607618bdeb2fea04150dcaa333253e514)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hashAlgorithm", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397e95a0f75231417d43edb5bb9304ff80b897c1fe04469f9a0cd122641afc66)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46d116bc396bd3dc266d7684a8ccc6c6fb29e9625de4e82d2c9bbccc4325e436)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="mapMigrationEnabled")
    def map_migration_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "mapMigrationEnabled"))

    @map_migration_enabled.setter
    def map_migration_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__083b652a8039b30ec7127e5bd42fd8afdf46957b8ef98295ce0c47b46d82d451)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "mapMigrationEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="migrationEndDate")
    def migration_end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationEndDate"))

    @migration_end_date.setter
    def migration_end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e7d139e0af6ef38a9048a2a3d200b88ac56b8b04487e5b2df924bbec07f2918)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationEndDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationStartDate")
    def migration_start_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "migrationStartDate"))

    @migration_start_date.setter
    def migration_start_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bb7d096ccfdc904910179ce4f142c599ba3a252b99e99b737661798357eb59f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationStartDate", value)

    @builtins.property
    @jsii.member(jsii_name="migrationWithinCwMapsEnabled")
    def migration_within_cw_maps_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "migrationWithinCwMapsEnabled"))

    @migration_within_cw_maps_enabled.setter
    def migration_within_cw_maps_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08d744fdad1d12ab37f3a6c4146e799de1f67e88c58084d904379c36871291c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "migrationWithinCwMapsEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="serialEnd")
    def serial_end(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialEnd"))

    @serial_end.setter
    def serial_end(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6f866ce315738df0771ff8f6392358cdaef048bbe3220ee76b420d89e6aafb3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialEnd", value)

    @builtins.property
    @jsii.member(jsii_name="serialStart")
    def serial_start(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "serialStart"))

    @serial_start.setter
    def serial_start(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a358c18ba02e4572c496c8480ce6b1aeab9573ee532f784dfd7326abaaf2192)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "serialStart", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1faabbbd3b28b52b922e9629da6d8e72a04926734f61dce809609aaa6599b3f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tier1Title")
    def tier1_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tier1Title"))

    @tier1_title.setter
    def tier1_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5df64d71d86584a07e65683e6dde487de2521860873b662410c10a93cde801)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tier1Title", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8d0d408556126c404b9babc962e1bc3a7a2aa27ba661e0bd1a298ff55855150)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34e0206052238370127b906f7b960b81a95130992df58d562ce5bb94ce0cad1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb3dbdbc48668d4dfc6bff0f195f455db947ac65d26510bf5f86f9309a408335)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTieredDistributionMap")
    def reset_tiered_distribution_map(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTieredDistributionMap", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMapInput")
    def tiered_distribution_map_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tieredDistributionMapInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62390ed8bc5f5358b22293e31870b0a49fa72b7a0c9c568fb5e842b44b3c62bb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1210cb8e868bf129b80f89803582e418e464cbd82a2f5ee1c116928c70bc7e9d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b4b21fde9f863bcd53e9da0590e3adcb39a96f70a496fb3a5d288995d835594)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tieredDistributionMap")
    def tiered_distribution_map(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tieredDistributionMap"))

    @tiered_distribution_map.setter
    def tiered_distribution_map(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35cefe8c4e8a36b25eb08172357ff8169cb908f8ad0cf0d54db5386c30eaf42a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tieredDistributionMap", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9afdb333f0247cf701550f71653e2ed8ded99aacc3792bb37ecaaa2b6f917f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__44c897a69b4cc7e6f68357f185f39d5d0ff6143eafc03b3adc163b57df79e268)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the timeout, for example ``10s``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca2cd6f6ebe9a7dcb2eb27b0eccfdfa52cb7140ed28bbc8f05e132fef9d472fb)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the timeout, for example ``10s``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6eb4c2c006d4a7234c001e4e5879b9ef54fa3dd439f551b22f192f1bcfd67c08)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ef76eba7a409670d5fb246280037793845cac5451d602b40cebb3cab5864aad3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__008f680143080ccdf61017aa26ab0cbf423f903d79a4bff51cc1ed11d6efd435)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcb008033103b734fa14358cad02b59ba7ad24d35fb15e2fccc1559259e0bb64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f930bd2ccbaf0f720d9a8061ed7bd0d597e72f996c271bfcc1d35e978d037fa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02a5c1358a38cb171b0ea5b00d0bc05ed9546c26575f839d914eef9b75c827b3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "legal_text": "legalText",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_name": "variableName",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        legal_text: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Allows you to extract UIDs from client requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param extract_location: Where to extract the UID value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the HTTP header from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param legal_text: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_name: This specifies the name of the rule tree variable from which to extract the UID value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae5a999d44d8892a9ecfc462c2ac4654dead5e8f156d686ee49487b52a57cae9)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument legal_text", value=legal_text, expected_type=type_hints["legal_text"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if legal_text is not None:
            self._values["legal_text"] = legal_text
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_name is not None:
            self._values["variable_name"] = variable_name

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract UIDs from client requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Where to extract the UID value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the HTTP header from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def legal_text(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#legal_text DataAkamaiPropertyRulesBuilder#legal_text}
        '''
        result = self._values.get("legal_text")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the rule tree variable from which to extract the UID value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5dd185b483022e170feba95416978f0de46424c93ba0015f155f08bc0a0864d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLegalText")
    def reset_legal_text(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLegalText", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="legalTextInput")
    def legal_text_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "legalTextInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98c2b6d0358592094a60cca2527876bc6eebaae06cb76a337db8a07c0dcb9131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f5dbbfda7477b1a99d20210c74fdbdea55d1920badb44e519d2b57d0d9ec8da6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fc844763acb1bd9cc873f0b7838d9d0bfcab714e0e8900dbaa77448ab6d14ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="legalText")
    def legal_text(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "legalText"))

    @legal_text.setter
    def legal_text(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5e12bdd0fe300d95a61529eb0212210b04742b23fd79c77f1ceea29f507399a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "legalText", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d7b80bdf066b13da4cc943f9ed248c1bb5bda4253c8a47981734c80a7b2e0061)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c0dba6a5bd51495d6a792491b8c92b8f8cdf731ecdd70d4be6f5bf3bd862ad0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d0775b6d78300da879c42512e118e665ff9e94382d60b7be6d10e937a2c2f13b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0816bf07015268ee956f57ee1674b8a38a1245ca609687fcc8386eec19f4c374)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea2787a97f06a0e14d321ed30c709c2ec66b965f974c5fe4ed6b1555e59bdeef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b179d22b519c5e9be4b6632cfdf806daa4548a0ce989429d41d471e27a9e8d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the ETag validation behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb4cccc5fc33f8baa790227e2afcfa1bfe752f1242a73a746550b98cd0069056)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the ETag validation behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTagOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTagOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15d7815575802b85cc65e9b5e49d978914e20d57931c7b16a79695b9fbd546a2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ea41e7e92d10965218791ca3f6124bcb55e71e6024791ddd01565bb0c402db5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea5357c8dd28910d82d380c2ff2d7fbfb1256f1dcd6d218443d985d10b763a17)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f594377806ca4e06ec0f8810d8133155b6c42424d1145d68901249c13f683299)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__446cc49e4bb54941c3b9acd56b3d2717eb332f0efff349bee6612f471d87ef1a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58997628556cdcd85bfddda547acdebd25cdd4462910e1b4593928367246e85a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken",
    jsii_struct_bases=[],
    name_mapping={
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_location": "extractLocation",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken:
    def __init__(
        self,
        *,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_location: Specify from where to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param header_name: This specifies the name of the header from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param query_parameter_name: This specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8169c2ee43cb930b7d064eb68d250a1453bdc713aeafb373c69cd9c8adf5de0)
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specify from where to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp",
    jsii_struct_bases=[],
    name_mapping={
        "authorizations": "authorizations",
        "client_id": "clientId",
        "custom_header": "customHeader",
        "enable_es256": "enableEs256",
        "enable_rs256": "enableRs256",
        "extract_authorizations": "extractAuthorizations",
        "extract_client_id": "extractClientId",
        "extract_location": "extractLocation",
        "extract_user_name": "extractUserName",
        "header_name": "headerName",
        "jwt": "jwt",
        "locked": "locked",
        "primary_location": "primaryLocation",
        "query_parameter_name": "queryParameterName",
        "template_uuid": "templateUuid",
        "user_name": "userName",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp:
    def __init__(
        self,
        *,
        authorizations: typing.Optional[builtins.str] = None,
        client_id: typing.Optional[builtins.str] = None,
        custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        extract_location: typing.Optional[builtins.str] = None,
        extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        header_name: typing.Optional[builtins.str] = None,
        jwt: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        primary_location: typing.Optional[builtins.str] = None,
        query_parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_name: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param authorizations: This specifies the authorization group name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        :param client_id: This specifies the claim name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        :param custom_header: The JWT value comes from the ``X-Akamai-DCP-Token`` header by default. Enabling this option allows you to extract it from another header name that you specify. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        :param enable_es256: Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        :param enable_rs256: Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        :param extract_authorizations: Allows you to extract the authorization groups stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        :param extract_client_id: Allows you to extract the client ID claim name stored in JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        :param extract_location: Specifies where to get the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        :param extract_user_name: Allows you to extract the user name stored in the JWT. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        :param header_name: This specifies the name of the header to extract the JWT value from. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param jwt: An identifier for the JWT keys collection. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param primary_location: Specifies the primary location to extract the JWT value from. If the specified option doesn't include the JWTs, the system checks the secondary one. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        :param query_parameter_name: Specifies the name of the query parameter from which to extract the JWT value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_name: This specifies the user name. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7228d4e00ea12949e222a9b4d5f2f3d62c683bc555315a33f5b7703a82104d43)
            check_type(argname="argument authorizations", value=authorizations, expected_type=type_hints["authorizations"])
            check_type(argname="argument client_id", value=client_id, expected_type=type_hints["client_id"])
            check_type(argname="argument custom_header", value=custom_header, expected_type=type_hints["custom_header"])
            check_type(argname="argument enable_es256", value=enable_es256, expected_type=type_hints["enable_es256"])
            check_type(argname="argument enable_rs256", value=enable_rs256, expected_type=type_hints["enable_rs256"])
            check_type(argname="argument extract_authorizations", value=extract_authorizations, expected_type=type_hints["extract_authorizations"])
            check_type(argname="argument extract_client_id", value=extract_client_id, expected_type=type_hints["extract_client_id"])
            check_type(argname="argument extract_location", value=extract_location, expected_type=type_hints["extract_location"])
            check_type(argname="argument extract_user_name", value=extract_user_name, expected_type=type_hints["extract_user_name"])
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument jwt", value=jwt, expected_type=type_hints["jwt"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument primary_location", value=primary_location, expected_type=type_hints["primary_location"])
            check_type(argname="argument query_parameter_name", value=query_parameter_name, expected_type=type_hints["query_parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_name", value=user_name, expected_type=type_hints["user_name"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if authorizations is not None:
            self._values["authorizations"] = authorizations
        if client_id is not None:
            self._values["client_id"] = client_id
        if custom_header is not None:
            self._values["custom_header"] = custom_header
        if enable_es256 is not None:
            self._values["enable_es256"] = enable_es256
        if enable_rs256 is not None:
            self._values["enable_rs256"] = enable_rs256
        if extract_authorizations is not None:
            self._values["extract_authorizations"] = extract_authorizations
        if extract_client_id is not None:
            self._values["extract_client_id"] = extract_client_id
        if extract_location is not None:
            self._values["extract_location"] = extract_location
        if extract_user_name is not None:
            self._values["extract_user_name"] = extract_user_name
        if header_name is not None:
            self._values["header_name"] = header_name
        if jwt is not None:
            self._values["jwt"] = jwt
        if locked is not None:
            self._values["locked"] = locked
        if primary_location is not None:
            self._values["primary_location"] = primary_location
        if query_parameter_name is not None:
            self._values["query_parameter_name"] = query_parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_name is not None:
            self._values["user_name"] = user_name
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def authorizations(self) -> typing.Optional[builtins.str]:
        '''This specifies the authorization group name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#authorizations DataAkamaiPropertyRulesBuilder#authorizations}
        '''
        result = self._values.get("authorizations")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def client_id(self) -> typing.Optional[builtins.str]:
        '''This specifies the claim name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_id DataAkamaiPropertyRulesBuilder#client_id}
        '''
        result = self._values.get("client_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def custom_header(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''The JWT value comes from the ``X-Akamai-DCP-Token`` header by default.

        Enabling this option allows you to extract it from another header name that you specify.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_header DataAkamaiPropertyRulesBuilder#custom_header}
        '''
        result = self._values.get("custom_header")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_es256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the ES256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_es256 DataAkamaiPropertyRulesBuilder#enable_es256}
        '''
        result = self._values.get("enable_es256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def enable_rs256(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Verifies JWTs signed with the RS256 algorithm. This signature helps to ensure that the token hasn't been tampered with.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable_rs256 DataAkamaiPropertyRulesBuilder#enable_rs256}
        '''
        result = self._values.get("enable_rs256")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_authorizations(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the authorization groups stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_authorizations DataAkamaiPropertyRulesBuilder#extract_authorizations}
        '''
        result = self._values.get("extract_authorizations")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_client_id(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the client ID claim name stored in JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_client_id DataAkamaiPropertyRulesBuilder#extract_client_id}
        '''
        result = self._values.get("extract_client_id")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def extract_location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to get the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_location DataAkamaiPropertyRulesBuilder#extract_location}
        '''
        result = self._values.get("extract_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def extract_user_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to extract the user name stored in the JWT.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#extract_user_name DataAkamaiPropertyRulesBuilder#extract_user_name}
        '''
        result = self._values.get("extract_user_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the name of the header to extract the JWT value from.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def jwt(self) -> typing.Optional[builtins.str]:
        '''An identifier for the JWT keys collection.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#jwt DataAkamaiPropertyRulesBuilder#jwt}
        '''
        result = self._values.get("jwt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def primary_location(self) -> typing.Optional[builtins.str]:
        '''Specifies the primary location to extract the JWT value from.

        If the specified option doesn't include the JWTs, the system checks the secondary one.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#primary_location DataAkamaiPropertyRulesBuilder#primary_location}
        '''
        result = self._values.get("primary_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def query_parameter_name(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the query parameter from which to extract the JWT value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_parameter_name DataAkamaiPropertyRulesBuilder#query_parameter_name}
        '''
        result = self._values.get("query_parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_name(self) -> typing.Optional[builtins.str]:
        '''This specifies the user name.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_name DataAkamaiPropertyRulesBuilder#user_name}
        '''
        result = self._values.get("user_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3c59e5a746d702edad2e7c49c15f360bbbed31d70f11d15a4d2dfe3a29e3419b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthorizations")
    def reset_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthorizations", []))

    @jsii.member(jsii_name="resetClientId")
    def reset_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientId", []))

    @jsii.member(jsii_name="resetCustomHeader")
    def reset_custom_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomHeader", []))

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractAuthorizations")
    def reset_extract_authorizations(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractAuthorizations", []))

    @jsii.member(jsii_name="resetExtractClientId")
    def reset_extract_client_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractClientId", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetExtractUserName")
    def reset_extract_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractUserName", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPrimaryLocation")
    def reset_primary_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPrimaryLocation", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserName")
    def reset_user_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserName", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authorizationsInput")
    def authorizations_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIdInput")
    def client_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "clientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="customHeaderInput")
    def custom_header_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "customHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizationsInput")
    def extract_authorizations_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractAuthorizationsInput"))

    @builtins.property
    @jsii.member(jsii_name="extractClientIdInput")
    def extract_client_id_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractClientIdInput"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="extractUserNameInput")
    def extract_user_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "extractUserNameInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="primaryLocationInput")
    def primary_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "primaryLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userNameInput")
    def user_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userNameInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authorizations")
    def authorizations(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authorizations"))

    @authorizations.setter
    def authorizations(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23ae7e811253c7ff239d3034faf70826b893b152c66d3ae0ef85340af5ff7548)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authorizations", value)

    @builtins.property
    @jsii.member(jsii_name="clientId")
    def client_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "clientId"))

    @client_id.setter
    def client_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f75950dcd98e36f92308f3a4e55e37a6a73ebae4d16b68a9fbe4e236e2f2142f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "clientId", value)

    @builtins.property
    @jsii.member(jsii_name="customHeader")
    def custom_header(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "customHeader"))

    @custom_header.setter
    def custom_header(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed9b86c6390f2c3173aee0786ad2f9ab33e96fe9bc71fe8018701489146f5705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customHeader", value)

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__56e232d4f3ad843ab6559f2600faa7b436e9ea0c92253b04e2d143da19d40e46)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e4c9e22a832d8a0c4c0a5951647bfc4b52fd40b94f16366d7f65de20c54ca90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractAuthorizations")
    def extract_authorizations(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractAuthorizations"))

    @extract_authorizations.setter
    def extract_authorizations(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23fd4606d672de1bfd4107cac254c199dc67981dd138ed487f6b809ce7b5d0e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractAuthorizations", value)

    @builtins.property
    @jsii.member(jsii_name="extractClientId")
    def extract_client_id(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractClientId"))

    @extract_client_id.setter
    def extract_client_id(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27f0a28735073c9cd139ecab8819f915780e46fa89da17ed9dfbb66f31c36372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractClientId", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4bcc29f3c70b827c4b353bd19ef62b44bc6a8af7c1dba8a52dfc6cf8af7da2c5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="extractUserName")
    def extract_user_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "extractUserName"))

    @extract_user_name.setter
    def extract_user_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b002621af6cd0971029fac2ba69974ac4a5a217811605d1637a160820d877997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractUserName", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca02aac0a857b6416300dc681a4d881677e9ab365a3a37d400abd4b6c7650473)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55a206f8c7edfce80cbdb7b8a8a1522d637c12a3f06ba03a818c5fb02e409703)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bcdb6efecb77c3605f1b47df9946dfa3e9a64acb8443ccc17d78bc501601a770)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="primaryLocation")
    def primary_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "primaryLocation"))

    @primary_location.setter
    def primary_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96f484732a1d6ffbcea9b95afb5aaacdf231fa2313d54d9446f3bf732a7fb7be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "primaryLocation", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b4f400bfbe75298c0e472410b37d98d6e8bd863d08ecb592325ecfe12db35e6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b266f57baa5a93eab7e36e55ddb1fa0a402c0d55ef04850338b019205c271ddf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userName")
    def user_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userName"))

    @user_name.setter
    def user_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6dc49f56bc0343e7adaf694439c6d94cac02d3b88ce3bbdcb94fd2dd45457492)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userName", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b8e94dcba6bfefa6b3b5c67e6170af71eeb0c24b8e9b8438a210b9cbd0a70ae1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__495a041fa2fb47f7f0c0b463fb1d4d9711a5bb85c4310b60d523e968f6c051a3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__90a676ab9fd007946665128c2af97f1a05f0af98758fed4c8138bf8c61b5db6f)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnableEs256")
    def reset_enable_es256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableEs256", []))

    @jsii.member(jsii_name="resetEnableRs256")
    def reset_enable_rs256(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnableRs256", []))

    @jsii.member(jsii_name="resetExtractLocation")
    def reset_extract_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExtractLocation", []))

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetJwt")
    def reset_jwt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetJwt", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetQueryParameterName")
    def reset_query_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enableEs256Input")
    def enable_es256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableEs256Input"))

    @builtins.property
    @jsii.member(jsii_name="enableRs256Input")
    def enable_rs256_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableRs256Input"))

    @builtins.property
    @jsii.member(jsii_name="extractLocationInput")
    def extract_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "extractLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="jwtInput")
    def jwt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "jwtInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="queryParameterNameInput")
    def query_parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "queryParameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enableEs256")
    def enable_es256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableEs256"))

    @enable_es256.setter
    def enable_es256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c573c31f2faf4cef6ad82c4d31c7c0ec3c749c5c0be6274ddec4b5bb30ae3a92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableEs256", value)

    @builtins.property
    @jsii.member(jsii_name="enableRs256")
    def enable_rs256(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enableRs256"))

    @enable_rs256.setter
    def enable_rs256(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b820a02baa6e8c3befdb8d159ccf14e10a8bc4e968d16765a563111379f4aa37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enableRs256", value)

    @builtins.property
    @jsii.member(jsii_name="extractLocation")
    def extract_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "extractLocation"))

    @extract_location.setter
    def extract_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77da3ec5efa7b3c65787157a8ab103a8e05e2ca74a5b9212732a9e4d2bf7d6e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "extractLocation", value)

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fac9373f337e0186e5c2430ee56870356ea1e2e95e353896305004bea88d36d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="jwt")
    def jwt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "jwt"))

    @jwt.setter
    def jwt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__087fc8f2a2d0dc04bd9ac2319b0bd2c9aa6eaafd533a139ba29859f1e763bf19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "jwt", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1987b2166bc4eb54948357af3d500b02548a46cdfa348dcaa4dc6b994b5fa513)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="queryParameterName")
    def query_parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "queryParameterName"))

    @query_parameter_name.setter
    def query_parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d83d5cd5b8709eaffc35c051f330311c16313e3578d1893ffc771f10a0ecc34)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "queryParameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c416025e1f75e9c24f5a968aa188c4267b008ffc41add94ef413904050151f96)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95a810037e397d43b17de272701d7626379c92ade908552553ba5c5d516a74a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fdb696e0130b4be4d9b259cb8c8296ea90c11f2ad26244088385ad384b6fe641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "algorithm": "algorithm",
        "escape_hmac_inputs": "escapeHmacInputs",
        "failure_response": "failureResponse",
        "ignore_query_string": "ignoreQueryString",
        "key": "key",
        "location": "location",
        "location_id": "locationId",
        "locked": "locked",
        "salt": "salt",
        "template_uuid": "templateUuid",
        "transition_key": "transitionKey",
        "use_advanced": "useAdvanced",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization:
    def __init__(
        self,
        *,
        algorithm: typing.Optional[builtins.str] = None,
        escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        key: typing.Optional[builtins.str] = None,
        location: typing.Optional[builtins.str] = None,
        location_id: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        salt: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        transition_key: typing.Optional[builtins.str] = None,
        use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param algorithm: Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        :param escape_hmac_inputs: URL-escapes HMAC inputs passed in as query parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        :param failure_response: When enabled, sends an HTTP error when an authentication test fails. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        :param ignore_query_string: Enabling this removes the query string from the URL used to form an encryption key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        :param key: The shared secret used to validate tokens, which needs to match the key used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        :param location: Specifies where to find the token in the incoming request. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        :param location_id: When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param salt: Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param transition_key: Specifies a transition key as a hex value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        :param use_advanced: If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5658c53b8358383f21be1f134c6b4f62b8aa08c1298edefe203027d3f15518fc)
            check_type(argname="argument algorithm", value=algorithm, expected_type=type_hints["algorithm"])
            check_type(argname="argument escape_hmac_inputs", value=escape_hmac_inputs, expected_type=type_hints["escape_hmac_inputs"])
            check_type(argname="argument failure_response", value=failure_response, expected_type=type_hints["failure_response"])
            check_type(argname="argument ignore_query_string", value=ignore_query_string, expected_type=type_hints["ignore_query_string"])
            check_type(argname="argument key", value=key, expected_type=type_hints["key"])
            check_type(argname="argument location", value=location, expected_type=type_hints["location"])
            check_type(argname="argument location_id", value=location_id, expected_type=type_hints["location_id"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument salt", value=salt, expected_type=type_hints["salt"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument transition_key", value=transition_key, expected_type=type_hints["transition_key"])
            check_type(argname="argument use_advanced", value=use_advanced, expected_type=type_hints["use_advanced"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if algorithm is not None:
            self._values["algorithm"] = algorithm
        if escape_hmac_inputs is not None:
            self._values["escape_hmac_inputs"] = escape_hmac_inputs
        if failure_response is not None:
            self._values["failure_response"] = failure_response
        if ignore_query_string is not None:
            self._values["ignore_query_string"] = ignore_query_string
        if key is not None:
            self._values["key"] = key
        if location is not None:
            self._values["location"] = location
        if location_id is not None:
            self._values["location_id"] = location_id
        if locked is not None:
            self._values["locked"] = locked
        if salt is not None:
            self._values["salt"] = salt
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if transition_key is not None:
            self._values["transition_key"] = transition_key
        if use_advanced is not None:
            self._values["use_advanced"] = use_advanced
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def algorithm(self) -> typing.Optional[builtins.str]:
        '''Specifies the algorithm that generates the token. It needs to match the method chosen in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#algorithm DataAkamaiPropertyRulesBuilder#algorithm}
        '''
        result = self._values.get("algorithm")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def escape_hmac_inputs(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''URL-escapes HMAC inputs passed in as query parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_hmac_inputs DataAkamaiPropertyRulesBuilder#escape_hmac_inputs}
        '''
        result = self._values.get("escape_hmac_inputs")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def failure_response(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, sends an HTTP error when an authentication test fails.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#failure_response DataAkamaiPropertyRulesBuilder#failure_response}
        '''
        result = self._values.get("failure_response")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def ignore_query_string(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this removes the query string from the URL used to form an encryption key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ignore_query_string DataAkamaiPropertyRulesBuilder#ignore_query_string}
        '''
        result = self._values.get("ignore_query_string")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def key(self) -> typing.Optional[builtins.str]:
        '''The shared secret used to validate tokens, which needs to match the key used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#key DataAkamaiPropertyRulesBuilder#key}
        '''
        result = self._values.get("key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location(self) -> typing.Optional[builtins.str]:
        '''Specifies where to find the token in the incoming request.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location DataAkamaiPropertyRulesBuilder#location}
        '''
        result = self._values.get("location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def location_id(self) -> typing.Optional[builtins.str]:
        '''When ``location`` is ``CLIENT_REQUEST_HEADER``, specifies the name of the incoming request's header where to find the token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_id DataAkamaiPropertyRulesBuilder#location_id}
        '''
        result = self._values.get("location_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a salt string for input when generating the token, which needs to match the salt value used in the token generation code.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#salt DataAkamaiPropertyRulesBuilder#salt}
        '''
        result = self._values.get("salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def transition_key(self) -> typing.Optional[builtins.str]:
        '''Specifies a transition key as a hex value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#transition_key DataAkamaiPropertyRulesBuilder#transition_key}
        '''
        result = self._values.get("transition_key")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If enabled, allows you to specify advanced options such as ``algorithm``, ``escapeHmacInputs``, ``ignoreQueryString``, ``transitionKey``, and ``salt``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_advanced DataAkamaiPropertyRulesBuilder#use_advanced}
        '''
        result = self._values.get("use_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92653f8fd8f47b070fa967f1d2d00315ddbae5cc41583fdff031abd3fa7f8e03)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAlgorithm")
    def reset_algorithm(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAlgorithm", []))

    @jsii.member(jsii_name="resetEscapeHmacInputs")
    def reset_escape_hmac_inputs(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeHmacInputs", []))

    @jsii.member(jsii_name="resetFailureResponse")
    def reset_failure_response(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFailureResponse", []))

    @jsii.member(jsii_name="resetIgnoreQueryString")
    def reset_ignore_query_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIgnoreQueryString", []))

    @jsii.member(jsii_name="resetKey")
    def reset_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetKey", []))

    @jsii.member(jsii_name="resetLocation")
    def reset_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocation", []))

    @jsii.member(jsii_name="resetLocationId")
    def reset_location_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationId", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSalt")
    def reset_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSalt", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTransitionKey")
    def reset_transition_key(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTransitionKey", []))

    @jsii.member(jsii_name="resetUseAdvanced")
    def reset_use_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseAdvanced", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="algorithmInput")
    def algorithm_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "algorithmInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputsInput")
    def escape_hmac_inputs_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeHmacInputsInput"))

    @builtins.property
    @jsii.member(jsii_name="failureResponseInput")
    def failure_response_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "failureResponseInput"))

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryStringInput")
    def ignore_query_string_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "ignoreQueryStringInput"))

    @builtins.property
    @jsii.member(jsii_name="keyInput")
    def key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "keyInput"))

    @builtins.property
    @jsii.member(jsii_name="locationIdInput")
    def location_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationIdInput"))

    @builtins.property
    @jsii.member(jsii_name="locationInput")
    def location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="saltInput")
    def salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "saltInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="transitionKeyInput")
    def transition_key_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "transitionKeyInput"))

    @builtins.property
    @jsii.member(jsii_name="useAdvancedInput")
    def use_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="algorithm")
    def algorithm(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "algorithm"))

    @algorithm.setter
    def algorithm(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__51ccdcfea9c7b91709914e83ade95034a1fa9c5411fca31d89fb1dbd9e339a0b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "algorithm", value)

    @builtins.property
    @jsii.member(jsii_name="escapeHmacInputs")
    def escape_hmac_inputs(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeHmacInputs"))

    @escape_hmac_inputs.setter
    def escape_hmac_inputs(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34f68f7e252f2e01ddf412265e4e95c2ef11b4022e5159a5866b36f472b954ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeHmacInputs", value)

    @builtins.property
    @jsii.member(jsii_name="failureResponse")
    def failure_response(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "failureResponse"))

    @failure_response.setter
    def failure_response(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aded4c148a772c2aa0e4593ee81e056f1e7bb7d2f107111ed5834d82c77102eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "failureResponse", value)

    @builtins.property
    @jsii.member(jsii_name="ignoreQueryString")
    def ignore_query_string(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "ignoreQueryString"))

    @ignore_query_string.setter
    def ignore_query_string(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d02850a5e163aee2583292062f611c841b420636a3853114f2874933d204363)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "ignoreQueryString", value)

    @builtins.property
    @jsii.member(jsii_name="key")
    def key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "key"))

    @key.setter
    def key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00ceb567a094a907a7df1c38ac808bd91f488baf52057f3b0153d66119210b37)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "key", value)

    @builtins.property
    @jsii.member(jsii_name="location")
    def location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "location"))

    @location.setter
    def location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e27f09ab73f345b473c39708e800b662ee78aeb35cefaaab039cf0fb01a1b3d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "location", value)

    @builtins.property
    @jsii.member(jsii_name="locationId")
    def location_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationId"))

    @location_id.setter
    def location_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb5cdf43aa1396a51a296f6239c4ac5ac352982ef51a4d1b9bf88ab2a0a95c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationId", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__15db987eb1fc3054eb36d47e9342c7ae26cda3c1cd232b69a93d8fc96dfc9646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="salt")
    def salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "salt"))

    @salt.setter
    def salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19ec7c95b939b42549c2142687356d33fdc5180e3ebf57f5d261e6ca67f1221d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "salt", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__00723e6b6588a77cf4193f801bf79e917b9450e4d93edebe4fbdcd43482bc8b2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="transitionKey")
    def transition_key(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "transitionKey"))

    @transition_key.setter
    def transition_key(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a05d728e4482af6f099c9013b9d4f49f7198d3096e2c3aecd76f0f6a471688e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "transitionKey", value)

    @builtins.property
    @jsii.member(jsii_name="useAdvanced")
    def use_advanced(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useAdvanced"))

    @use_advanced.setter
    def use_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9b001b02b9b6f7cab4135747a4f43e24f24296f909fd741baf1c817bd7872f6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f6a619e19f27a34e4144755d6fd2a37c6bc554b60327655c6079fa20fc3d9d48)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c8f3a0abc627ec05872e71a008d465fa86e59b6a6d16fecf68701eae39be10ee)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests. The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d719b5476a65d5e8d1a861c44afe37bc38aa4bcf434c534d26b67a6ea1f0b79)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Waiting Room Cloudlet shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``virtualWaitingRoom`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as JavaScript, CSS, or image files for the Waiting Room Main Page requests.

        The option supports the ``*`` wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as Waiting Room Main Page and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``virtualWaitingRoomRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7517fa339a6f2e8337a1d7f7a718c76232773ff4cb95b413bb3d65f2331f85ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38b4291bc0103287b46192ce299e1c8f40d6dcc725c432f00d0de9b6264ebaad)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6b0ce94f62a4759c642c3880a9a4fe07b7fdb5329eac72b07f5adf599c04efb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab0b32b34e3506f8a09fd6f0ad137423f805dd7b651cc5a6a6719dcc0cd2111c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fb83b8ccecc484c9e7c37e7426367fbec2ba764fca3c6b6ea428c25cc42851f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8150c1020d11efe021e302a1bb34b14fb0bf125b3488c8fe4b1cdb5989c1f848)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f1aef692de2547ab5acac2712ea80ec3d44536d285f2b155010f968c5c07787)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fe20fbf6f8e90bff90f426b738efdfd069d1fa590a753b9ab667178a3534b314)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d9ddbadb67222bdadf7b5e8a5bcf5d052a7e83ddd2e5bd9dcb9f15a5f49838a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0049c759d180dc0edbc1669932b55873b1b5a7edb810c903050152467cafc821)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a312c3c47bdf1aa0a9591e16f961310c420f5571f3bf08fb3e33ce4101b1d968)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b3f8644066024fccb7b25a2b53769c7f8ac1e5641560401cb24cfc425a8b79c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5d4ba1728a1178585d3f5cb3f8f2f9655d1b4155b93e1219afaada962be8853)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7daa945c3b86cd3e228380d3ba69888c3d20a5a235aa66f1df9887c202df396d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f59fc89323df4dfb8a5cf337b241c5cc0c6ad120e073a2f92f19c129a0aa1c5)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1458468a4579b171064ff5f37811a34a97a9c5910113a25cedde51d484b3c9ec)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5f76af32a7edd4c16ebf239408476d9d443e1f4bdaad9e1d8978bc195327bf2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__694b5ce43092fb020bb2543203ee41d9ea44eaee8775474fd60176f45f9c6a3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__807df0925db8131aa41decbc2d32edc43d1776acf45b3268186ec07130698991)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e658dd975c90e69cf6e47e3933039a8c090aef9d38021d6e0a9761b3c85feed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization",
    jsii_struct_bases=[],
    name_mapping={
        "allowed_user_cookie_advanced": "allowedUserCookieAdvanced",
        "allowed_user_cookie_automatic_salt": "allowedUserCookieAutomaticSalt",
        "allowed_user_cookie_domain": "allowedUserCookieDomain",
        "allowed_user_cookie_domain_type": "allowedUserCookieDomainType",
        "allowed_user_cookie_duration": "allowedUserCookieDuration",
        "allowed_user_cookie_enabled": "allowedUserCookieEnabled",
        "allowed_user_cookie_http_only": "allowedUserCookieHttpOnly",
        "allowed_user_cookie_label": "allowedUserCookieLabel",
        "allowed_user_cookie_management_title": "allowedUserCookieManagementTitle",
        "allowed_user_cookie_refresh": "allowedUserCookieRefresh",
        "allowed_user_cookie_salt": "allowedUserCookieSalt",
        "cloudlet_policy": "cloudletPolicy",
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "user_identification_by_cookie": "userIdentificationByCookie",
        "user_identification_by_headers": "userIdentificationByHeaders",
        "user_identification_by_ip": "userIdentificationByIp",
        "user_identification_by_params": "userIdentificationByParams",
        "user_identification_key_cookie": "userIdentificationKeyCookie",
        "user_identification_key_headers": "userIdentificationKeyHeaders",
        "user_identification_key_params": "userIdentificationKeyParams",
        "user_identification_title": "userIdentificationTitle",
        "uuid": "uuid",
        "waiting_room_cache_ttl": "waitingRoomCacheTtl",
        "waiting_room_cookie_advanced": "waitingRoomCookieAdvanced",
        "waiting_room_cookie_automatic_salt": "waitingRoomCookieAutomaticSalt",
        "waiting_room_cookie_domain": "waitingRoomCookieDomain",
        "waiting_room_cookie_domain_type": "waitingRoomCookieDomainType",
        "waiting_room_cookie_duration": "waitingRoomCookieDuration",
        "waiting_room_cookie_enabled": "waitingRoomCookieEnabled",
        "waiting_room_cookie_http_only": "waitingRoomCookieHttpOnly",
        "waiting_room_cookie_label": "waitingRoomCookieLabel",
        "waiting_room_cookie_management_title": "waitingRoomCookieManagementTitle",
        "waiting_room_cookie_salt": "waitingRoomCookieSalt",
        "waiting_room_cookie_share_label": "waitingRoomCookieShareLabel",
        "waiting_room_cp_code": "waitingRoomCpCode",
        "waiting_room_directory": "waitingRoomDirectory",
        "waiting_room_management_title": "waitingRoomManagementTitle",
        "waiting_room_net_storage": "waitingRoomNetStorage",
        "waiting_room_status_code": "waitingRoomStatusCode",
        "waiting_room_use_cp_code": "waitingRoomUseCpCode",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization:
    def __init__(
        self,
        *,
        allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
        allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
        allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
        allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_label: typing.Optional[builtins.str] = None,
        allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
        allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
        cloudlet_policy: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy", typing.Dict[builtins.str, typing.Any]]] = None,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        user_identification_key_cookie: typing.Optional[builtins.str] = None,
        user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
        user_identification_title: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
        waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
        waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
        waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cookie_label: typing.Optional[builtins.str] = None,
        waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
        waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
        waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        waiting_room_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_directory: typing.Optional[builtins.str] = None,
        waiting_room_management_title: typing.Optional[builtins.str] = None,
        waiting_room_net_storage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage", typing.Dict[builtins.str, typing.Any]]] = None,
        waiting_room_status_code: typing.Optional[jsii.Number] = None,
        waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ) -> None:
        '''
        :param allowed_user_cookie_advanced: Sets advanced configuration options for the allowed user's cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        :param allowed_user_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        :param allowed_user_cookie_domain: Specifies a domain for an allowed user cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        :param allowed_user_cookie_domain_type: Specify with ``allowedUserCookieAdvanced`` enabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        :param allowed_user_cookie_duration: Sets the number of seconds for the allowed user's session once allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        :param allowed_user_cookie_enabled: Sets a cookie for users who have been allowed through to the site. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        :param allowed_user_cookie_http_only: Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        :param allowed_user_cookie_label: Specifies a label to distinguish this cookie for an allowed user from others. The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        :param allowed_user_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        :param allowed_user_cookie_refresh: Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration. Do not enable this option if you want to set a fixed time for all users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        :param allowed_user_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        :param cloudlet_policy: cloudlet_policy block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        :param enabled: Enables the Visitor Prioritization behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param user_identification_by_cookie: When enabled, identifies users by the value of a cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        :param user_identification_by_headers: When enabled, identifies users by the values of GET or POST request headers. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        :param user_identification_by_ip: Allows IP addresses to identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        :param user_identification_by_params: When enabled, identifies users by the values of GET or POST request parameters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        :param user_identification_key_cookie: Specifies the name of the cookie whose value identifies users. To match a user, the value of the cookie needs to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        :param user_identification_key_headers: Specifies names of request headers whose values identify users. To match a user, values for all the specified headers need to remain constant across all requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        :param user_identification_key_params: Specifies names of request parameters whose values identify users. To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        :param user_identification_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_cache_ttl: Specifies the waiting room page's time to live in the cache, ``5`` minutes by default. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        :param waiting_room_cookie_advanced: When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        :param waiting_room_cookie_automatic_salt: Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie. Disable this if you want to share the cookie across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        :param waiting_room_cookie_domain: Specifies a domain for the waiting room cookie. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        :param waiting_room_cookie_domain_type: Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        :param waiting_room_cookie_duration: Sets the number of seconds for which users remain in the waiting room. During this time, users who refresh the waiting room page remain there. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        :param waiting_room_cookie_enabled: Enables a cookie to track a waiting room assignment. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        :param waiting_room_cookie_http_only: Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        :param waiting_room_cookie_label: Specifies a label to distinguish this waiting room cookie from others. The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        :param waiting_room_cookie_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        :param waiting_room_cookie_salt: Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it. You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        :param waiting_room_cookie_share_label: Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        :param waiting_room_cp_code: waiting_room_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        :param waiting_room_directory: Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        :param waiting_room_management_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        :param waiting_room_net_storage: waiting_room_net_storage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        :param waiting_room_status_code: Specifies the response code for requests sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        :param waiting_room_use_cp_code: Allows you to assign a different CP code that tracks any requests that are sent to the waiting room. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        if isinstance(cloudlet_policy, dict):
            cloudlet_policy = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy(**cloudlet_policy)
        if isinstance(waiting_room_cp_code, dict):
            waiting_room_cp_code = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode(**waiting_room_cp_code)
        if isinstance(waiting_room_net_storage, dict):
            waiting_room_net_storage = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage(**waiting_room_net_storage)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__134b7a4cf13f7c8a5631c91f73a669a5d05e7212c307017802604927636a3dd0)
            check_type(argname="argument allowed_user_cookie_advanced", value=allowed_user_cookie_advanced, expected_type=type_hints["allowed_user_cookie_advanced"])
            check_type(argname="argument allowed_user_cookie_automatic_salt", value=allowed_user_cookie_automatic_salt, expected_type=type_hints["allowed_user_cookie_automatic_salt"])
            check_type(argname="argument allowed_user_cookie_domain", value=allowed_user_cookie_domain, expected_type=type_hints["allowed_user_cookie_domain"])
            check_type(argname="argument allowed_user_cookie_domain_type", value=allowed_user_cookie_domain_type, expected_type=type_hints["allowed_user_cookie_domain_type"])
            check_type(argname="argument allowed_user_cookie_duration", value=allowed_user_cookie_duration, expected_type=type_hints["allowed_user_cookie_duration"])
            check_type(argname="argument allowed_user_cookie_enabled", value=allowed_user_cookie_enabled, expected_type=type_hints["allowed_user_cookie_enabled"])
            check_type(argname="argument allowed_user_cookie_http_only", value=allowed_user_cookie_http_only, expected_type=type_hints["allowed_user_cookie_http_only"])
            check_type(argname="argument allowed_user_cookie_label", value=allowed_user_cookie_label, expected_type=type_hints["allowed_user_cookie_label"])
            check_type(argname="argument allowed_user_cookie_management_title", value=allowed_user_cookie_management_title, expected_type=type_hints["allowed_user_cookie_management_title"])
            check_type(argname="argument allowed_user_cookie_refresh", value=allowed_user_cookie_refresh, expected_type=type_hints["allowed_user_cookie_refresh"])
            check_type(argname="argument allowed_user_cookie_salt", value=allowed_user_cookie_salt, expected_type=type_hints["allowed_user_cookie_salt"])
            check_type(argname="argument cloudlet_policy", value=cloudlet_policy, expected_type=type_hints["cloudlet_policy"])
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument user_identification_by_cookie", value=user_identification_by_cookie, expected_type=type_hints["user_identification_by_cookie"])
            check_type(argname="argument user_identification_by_headers", value=user_identification_by_headers, expected_type=type_hints["user_identification_by_headers"])
            check_type(argname="argument user_identification_by_ip", value=user_identification_by_ip, expected_type=type_hints["user_identification_by_ip"])
            check_type(argname="argument user_identification_by_params", value=user_identification_by_params, expected_type=type_hints["user_identification_by_params"])
            check_type(argname="argument user_identification_key_cookie", value=user_identification_key_cookie, expected_type=type_hints["user_identification_key_cookie"])
            check_type(argname="argument user_identification_key_headers", value=user_identification_key_headers, expected_type=type_hints["user_identification_key_headers"])
            check_type(argname="argument user_identification_key_params", value=user_identification_key_params, expected_type=type_hints["user_identification_key_params"])
            check_type(argname="argument user_identification_title", value=user_identification_title, expected_type=type_hints["user_identification_title"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_cache_ttl", value=waiting_room_cache_ttl, expected_type=type_hints["waiting_room_cache_ttl"])
            check_type(argname="argument waiting_room_cookie_advanced", value=waiting_room_cookie_advanced, expected_type=type_hints["waiting_room_cookie_advanced"])
            check_type(argname="argument waiting_room_cookie_automatic_salt", value=waiting_room_cookie_automatic_salt, expected_type=type_hints["waiting_room_cookie_automatic_salt"])
            check_type(argname="argument waiting_room_cookie_domain", value=waiting_room_cookie_domain, expected_type=type_hints["waiting_room_cookie_domain"])
            check_type(argname="argument waiting_room_cookie_domain_type", value=waiting_room_cookie_domain_type, expected_type=type_hints["waiting_room_cookie_domain_type"])
            check_type(argname="argument waiting_room_cookie_duration", value=waiting_room_cookie_duration, expected_type=type_hints["waiting_room_cookie_duration"])
            check_type(argname="argument waiting_room_cookie_enabled", value=waiting_room_cookie_enabled, expected_type=type_hints["waiting_room_cookie_enabled"])
            check_type(argname="argument waiting_room_cookie_http_only", value=waiting_room_cookie_http_only, expected_type=type_hints["waiting_room_cookie_http_only"])
            check_type(argname="argument waiting_room_cookie_label", value=waiting_room_cookie_label, expected_type=type_hints["waiting_room_cookie_label"])
            check_type(argname="argument waiting_room_cookie_management_title", value=waiting_room_cookie_management_title, expected_type=type_hints["waiting_room_cookie_management_title"])
            check_type(argname="argument waiting_room_cookie_salt", value=waiting_room_cookie_salt, expected_type=type_hints["waiting_room_cookie_salt"])
            check_type(argname="argument waiting_room_cookie_share_label", value=waiting_room_cookie_share_label, expected_type=type_hints["waiting_room_cookie_share_label"])
            check_type(argname="argument waiting_room_cp_code", value=waiting_room_cp_code, expected_type=type_hints["waiting_room_cp_code"])
            check_type(argname="argument waiting_room_directory", value=waiting_room_directory, expected_type=type_hints["waiting_room_directory"])
            check_type(argname="argument waiting_room_management_title", value=waiting_room_management_title, expected_type=type_hints["waiting_room_management_title"])
            check_type(argname="argument waiting_room_net_storage", value=waiting_room_net_storage, expected_type=type_hints["waiting_room_net_storage"])
            check_type(argname="argument waiting_room_status_code", value=waiting_room_status_code, expected_type=type_hints["waiting_room_status_code"])
            check_type(argname="argument waiting_room_use_cp_code", value=waiting_room_use_cp_code, expected_type=type_hints["waiting_room_use_cp_code"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if allowed_user_cookie_advanced is not None:
            self._values["allowed_user_cookie_advanced"] = allowed_user_cookie_advanced
        if allowed_user_cookie_automatic_salt is not None:
            self._values["allowed_user_cookie_automatic_salt"] = allowed_user_cookie_automatic_salt
        if allowed_user_cookie_domain is not None:
            self._values["allowed_user_cookie_domain"] = allowed_user_cookie_domain
        if allowed_user_cookie_domain_type is not None:
            self._values["allowed_user_cookie_domain_type"] = allowed_user_cookie_domain_type
        if allowed_user_cookie_duration is not None:
            self._values["allowed_user_cookie_duration"] = allowed_user_cookie_duration
        if allowed_user_cookie_enabled is not None:
            self._values["allowed_user_cookie_enabled"] = allowed_user_cookie_enabled
        if allowed_user_cookie_http_only is not None:
            self._values["allowed_user_cookie_http_only"] = allowed_user_cookie_http_only
        if allowed_user_cookie_label is not None:
            self._values["allowed_user_cookie_label"] = allowed_user_cookie_label
        if allowed_user_cookie_management_title is not None:
            self._values["allowed_user_cookie_management_title"] = allowed_user_cookie_management_title
        if allowed_user_cookie_refresh is not None:
            self._values["allowed_user_cookie_refresh"] = allowed_user_cookie_refresh
        if allowed_user_cookie_salt is not None:
            self._values["allowed_user_cookie_salt"] = allowed_user_cookie_salt
        if cloudlet_policy is not None:
            self._values["cloudlet_policy"] = cloudlet_policy
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if user_identification_by_cookie is not None:
            self._values["user_identification_by_cookie"] = user_identification_by_cookie
        if user_identification_by_headers is not None:
            self._values["user_identification_by_headers"] = user_identification_by_headers
        if user_identification_by_ip is not None:
            self._values["user_identification_by_ip"] = user_identification_by_ip
        if user_identification_by_params is not None:
            self._values["user_identification_by_params"] = user_identification_by_params
        if user_identification_key_cookie is not None:
            self._values["user_identification_key_cookie"] = user_identification_key_cookie
        if user_identification_key_headers is not None:
            self._values["user_identification_key_headers"] = user_identification_key_headers
        if user_identification_key_params is not None:
            self._values["user_identification_key_params"] = user_identification_key_params
        if user_identification_title is not None:
            self._values["user_identification_title"] = user_identification_title
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_cache_ttl is not None:
            self._values["waiting_room_cache_ttl"] = waiting_room_cache_ttl
        if waiting_room_cookie_advanced is not None:
            self._values["waiting_room_cookie_advanced"] = waiting_room_cookie_advanced
        if waiting_room_cookie_automatic_salt is not None:
            self._values["waiting_room_cookie_automatic_salt"] = waiting_room_cookie_automatic_salt
        if waiting_room_cookie_domain is not None:
            self._values["waiting_room_cookie_domain"] = waiting_room_cookie_domain
        if waiting_room_cookie_domain_type is not None:
            self._values["waiting_room_cookie_domain_type"] = waiting_room_cookie_domain_type
        if waiting_room_cookie_duration is not None:
            self._values["waiting_room_cookie_duration"] = waiting_room_cookie_duration
        if waiting_room_cookie_enabled is not None:
            self._values["waiting_room_cookie_enabled"] = waiting_room_cookie_enabled
        if waiting_room_cookie_http_only is not None:
            self._values["waiting_room_cookie_http_only"] = waiting_room_cookie_http_only
        if waiting_room_cookie_label is not None:
            self._values["waiting_room_cookie_label"] = waiting_room_cookie_label
        if waiting_room_cookie_management_title is not None:
            self._values["waiting_room_cookie_management_title"] = waiting_room_cookie_management_title
        if waiting_room_cookie_salt is not None:
            self._values["waiting_room_cookie_salt"] = waiting_room_cookie_salt
        if waiting_room_cookie_share_label is not None:
            self._values["waiting_room_cookie_share_label"] = waiting_room_cookie_share_label
        if waiting_room_cp_code is not None:
            self._values["waiting_room_cp_code"] = waiting_room_cp_code
        if waiting_room_directory is not None:
            self._values["waiting_room_directory"] = waiting_room_directory
        if waiting_room_management_title is not None:
            self._values["waiting_room_management_title"] = waiting_room_management_title
        if waiting_room_net_storage is not None:
            self._values["waiting_room_net_storage"] = waiting_room_net_storage
        if waiting_room_status_code is not None:
            self._values["waiting_room_status_code"] = waiting_room_status_code
        if waiting_room_use_cp_code is not None:
            self._values["waiting_room_use_cp_code"] = waiting_room_use_cp_code

    @builtins.property
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets advanced configuration options for the allowed user's cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_advanced DataAkamaiPropertyRulesBuilder#allowed_user_cookie_advanced}
        '''
        result = self._values.get("allowed_user_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the cookie for an allowed user.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_automatic_salt}
        '''
        result = self._values.get("allowed_user_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for an allowed user cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain}
        '''
        result = self._values.get("allowed_user_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``allowedUserCookieAdvanced`` enabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_domain_type DataAkamaiPropertyRulesBuilder#allowed_user_cookie_domain_type}
        '''
        result = self._values.get("allowed_user_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for the allowed user's session once allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_duration DataAkamaiPropertyRulesBuilder#allowed_user_cookie_duration}
        '''
        result = self._values.get("allowed_user_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a cookie for users who have been allowed through to the site.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_enabled DataAkamaiPropertyRulesBuilder#allowed_user_cookie_enabled}
        '''
        result = self._values.get("allowed_user_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the allowed user's cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_http_only DataAkamaiPropertyRulesBuilder#allowed_user_cookie_http_only}
        '''
        result = self._values.get("allowed_user_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this cookie for an allowed user from others.

        The value appends to the cookie's name, and helps you to maintain the same user assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_label DataAkamaiPropertyRulesBuilder#allowed_user_cookie_label}
        '''
        result = self._values.get("allowed_user_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_management_title DataAkamaiPropertyRulesBuilder#allowed_user_cookie_management_title}
        '''
        result = self._values.get("allowed_user_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Resets the duration of an allowed cookie with each request, so that it only expires if the user doesn't make any requests for the specified duration.

        Do not enable this option if you want to set a fixed time for all users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_refresh DataAkamaiPropertyRulesBuilder#allowed_user_cookie_refresh}
        '''
        result = self._values.get("allowed_user_cookie_refresh")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def allowed_user_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie to all allowed users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#allowed_user_cookie_salt DataAkamaiPropertyRulesBuilder#allowed_user_cookie_salt}
        '''
        result = self._values.get("allowed_user_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_policy(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy"]:
        '''cloudlet_policy block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_policy DataAkamaiPropertyRulesBuilder#cloudlet_policy}
        '''
        result = self._values.get("cloudlet_policy")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy"], result)

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the Visitor Prioritization behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_by_cookie(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the value of a cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_cookie DataAkamaiPropertyRulesBuilder#user_identification_by_cookie}
        '''
        result = self._values.get("user_identification_by_cookie")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request headers.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_headers DataAkamaiPropertyRulesBuilder#user_identification_by_headers}
        '''
        result = self._values.get("user_identification_by_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows IP addresses to identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_ip DataAkamaiPropertyRulesBuilder#user_identification_by_ip}
        '''
        result = self._values.get("user_identification_by_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_by_params(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, identifies users by the values of GET or POST request parameters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_by_params DataAkamaiPropertyRulesBuilder#user_identification_by_params}
        '''
        result = self._values.get("user_identification_by_params")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def user_identification_key_cookie(self) -> typing.Optional[builtins.str]:
        '''Specifies the name of the cookie whose value identifies users.

        To match a user, the value of the cookie needs to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_cookie DataAkamaiPropertyRulesBuilder#user_identification_key_cookie}
        '''
        result = self._values.get("user_identification_key_cookie")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def user_identification_key_headers(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request headers whose values identify users.

        To match a user, values for all the specified headers need to remain constant across all requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_headers DataAkamaiPropertyRulesBuilder#user_identification_key_headers}
        '''
        result = self._values.get("user_identification_key_headers")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_key_params(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies names of request parameters whose values identify users.

        To match a user, values for all the specified parameters need to remain constant across all requests. Parameters that are absent or blank may also identify users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_key_params DataAkamaiPropertyRulesBuilder#user_identification_key_params}
        '''
        result = self._values.get("user_identification_key_params")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def user_identification_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_identification_title DataAkamaiPropertyRulesBuilder#user_identification_title}
        '''
        result = self._values.get("user_identification_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cache_ttl(self) -> typing.Optional[jsii.Number]:
        '''Specifies the waiting room page's time to live in the cache, ``5`` minutes by default.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cache_ttl DataAkamaiPropertyRulesBuilder#waiting_room_cache_ttl}
        '''
        result = self._values.get("waiting_room_cache_ttl")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled along with ``waitingRoomCookieEnabled``, sets advanced configuration options for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_advanced DataAkamaiPropertyRulesBuilder#waiting_room_cookie_advanced}
        '''
        result = self._values.get("waiting_room_cookie_advanced")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets an automatic ``salt`` value to verify the integrity of the waiting room cookie.

        Disable this if you want to share the cookie across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_automatic_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_automatic_salt}
        '''
        result = self._values.get("waiting_room_cookie_automatic_salt")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''Specifies a domain for the waiting room cookie.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain}
        '''
        result = self._values.get("waiting_room_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_domain_type(self) -> typing.Optional[builtins.str]:
        '''Specify with ``waitingRoomCookieAdvanced`` enabled, selects whether to use the ``DYNAMIC`` incoming host header, or a ``CUSTOMER``-defined cookie domain.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_domain_type DataAkamaiPropertyRulesBuilder#waiting_room_cookie_domain_type}
        '''
        result = self._values.get("waiting_room_cookie_domain_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_duration(self) -> typing.Optional[jsii.Number]:
        '''Sets the number of seconds for which users remain in the waiting room.

        During this time, users who refresh the waiting room page remain there.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_duration DataAkamaiPropertyRulesBuilder#waiting_room_cookie_duration}
        '''
        result = self._values.get("waiting_room_cookie_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables a cookie to track a waiting room assignment.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_enabled DataAkamaiPropertyRulesBuilder#waiting_room_cookie_enabled}
        '''
        result = self._values.get("waiting_room_cookie_enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Applies the ``HttpOnly`` flag to the waiting room cookie to ensure it's accessed over HTTP and not manipulated by the client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_http_only DataAkamaiPropertyRulesBuilder#waiting_room_cookie_http_only}
        '''
        result = self._values.get("waiting_room_cookie_http_only")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cookie_label(self) -> typing.Optional[builtins.str]:
        '''Specifies a label to distinguish this waiting room cookie from others.

        The value appends to the cookie's name, and helps you to maintain the same waiting room assignment across behaviors within a property, and across properties.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_label}
        '''
        result = self._values.get("waiting_room_cookie_label")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_management_title DataAkamaiPropertyRulesBuilder#waiting_room_cookie_management_title}
        '''
        result = self._values.get("waiting_room_cookie_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_salt(self) -> typing.Optional[builtins.str]:
        '''Specifies a fixed ``salt`` value, which is incorporated into the cookie's value to prevent users from manipulating it.

        You can use the same salt string across different behaviors or properties to apply a single cookie for the waiting room session.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_salt DataAkamaiPropertyRulesBuilder#waiting_room_cookie_salt}
        '''
        result = self._values.get("waiting_room_cookie_salt")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enabling this option shares the same ``allowedUserCookieLabel`` string. If disabled, specify a different ``waitingRoomCookieLabel``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cookie_share_label DataAkamaiPropertyRulesBuilder#waiting_room_cookie_share_label}
        '''
        result = self._values.get("waiting_room_cookie_share_label")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def waiting_room_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        '''waiting_room_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_cp_code}
        '''
        result = self._values.get("waiting_room_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode"], result)

    @builtins.property
    def waiting_room_directory(self) -> typing.Optional[builtins.str]:
        '''Specifies the NetStorage directory that contains the static waiting room page, with no trailing slash character.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_directory DataAkamaiPropertyRulesBuilder#waiting_room_directory}
        '''
        result = self._values.get("waiting_room_directory")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_management_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_management_title DataAkamaiPropertyRulesBuilder#waiting_room_management_title}
        '''
        result = self._values.get("waiting_room_management_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_net_storage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        '''waiting_room_net_storage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_net_storage DataAkamaiPropertyRulesBuilder#waiting_room_net_storage}
        '''
        result = self._values.get("waiting_room_net_storage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage"], result)

    @builtins.property
    def waiting_room_status_code(self) -> typing.Optional[jsii.Number]:
        '''Specifies the response code for requests sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_status_code DataAkamaiPropertyRulesBuilder#waiting_room_status_code}
        '''
        result = self._values.get("waiting_room_status_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows you to assign a different CP code that tracks any requests that are sent to the waiting room.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_use_cp_code DataAkamaiPropertyRulesBuilder#waiting_room_use_cp_code}
        '''
        result = self._values.get("waiting_room_use_cp_code")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy",
    jsii_struct_bases=[],
    name_mapping={"id": "id", "name": "name"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy:
    def __init__(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57f59e4890f308d98f1ff7f5aaf06e13ef717021765309f56c283b913e5700a6)
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.'''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicyOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__93187d68e2d169a697b66b59d6f08d45ff3043070ddf9ba76a301e4ae0646d8a)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f72f2afa42dee7cb097908fac49542286b8588951ccc1c25da76e77cf03fd86)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72098d186bc211080cd46ead08bdd3a2b687cbbd9b2684b02de1fee7cdddcbca)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2512037ecc513376aca4e785f12e6e878d7c25810456ce3c443af9735c5a0055)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo",
    jsii_struct_bases=[],
    name_mapping={
        "access_title": "accessTitle",
        "cloudlet_shared_policy": "cloudletSharedPolicy",
        "custom_cookie_domain": "customCookieDomain",
        "domain_config": "domainConfig",
        "locked": "locked",
        "session_auto_prolong": "sessionAutoProlong",
        "session_duration": "sessionDuration",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "waiting_room_assets_paths": "waitingRoomAssetsPaths",
        "waiting_room_path": "waitingRoomPath",
        "waiting_room_title": "waitingRoomTitle",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo:
    def __init__(
        self,
        *,
        access_title: typing.Optional[builtins.str] = None,
        cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
        custom_cookie_domain: typing.Optional[builtins.str] = None,
        domain_config: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        session_duration: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
        waiting_room_path: typing.Optional[builtins.str] = None,
        waiting_room_title: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param access_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        :param cloudlet_shared_policy: This identifies the Visitor Prioritization FIFO shared policy to use with this behavior. You can list available shared policies with the ``Cloudlets API``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        :param custom_cookie_domain: This specifies a domain for all session cookies. In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        :param domain_config: This specifies how to set the domain used to establish a session with the visitor. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param session_auto_prolong: Whether the queue session should prolong automatically when the ``sessionDuration`` expires and the visitor remains active. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        :param session_duration: Specifies the number of seconds users remain in the waiting room queue. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param waiting_room_assets_paths: This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests. The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        :param waiting_room_path: This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        :param waiting_room_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7bf47c991565b2d74e594563f38970a649a66f7275d8c20505b0e73bc4f51b3)
            check_type(argname="argument access_title", value=access_title, expected_type=type_hints["access_title"])
            check_type(argname="argument cloudlet_shared_policy", value=cloudlet_shared_policy, expected_type=type_hints["cloudlet_shared_policy"])
            check_type(argname="argument custom_cookie_domain", value=custom_cookie_domain, expected_type=type_hints["custom_cookie_domain"])
            check_type(argname="argument domain_config", value=domain_config, expected_type=type_hints["domain_config"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument session_auto_prolong", value=session_auto_prolong, expected_type=type_hints["session_auto_prolong"])
            check_type(argname="argument session_duration", value=session_duration, expected_type=type_hints["session_duration"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument waiting_room_assets_paths", value=waiting_room_assets_paths, expected_type=type_hints["waiting_room_assets_paths"])
            check_type(argname="argument waiting_room_path", value=waiting_room_path, expected_type=type_hints["waiting_room_path"])
            check_type(argname="argument waiting_room_title", value=waiting_room_title, expected_type=type_hints["waiting_room_title"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if access_title is not None:
            self._values["access_title"] = access_title
        if cloudlet_shared_policy is not None:
            self._values["cloudlet_shared_policy"] = cloudlet_shared_policy
        if custom_cookie_domain is not None:
            self._values["custom_cookie_domain"] = custom_cookie_domain
        if domain_config is not None:
            self._values["domain_config"] = domain_config
        if locked is not None:
            self._values["locked"] = locked
        if session_auto_prolong is not None:
            self._values["session_auto_prolong"] = session_auto_prolong
        if session_duration is not None:
            self._values["session_duration"] = session_duration
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if waiting_room_assets_paths is not None:
            self._values["waiting_room_assets_paths"] = waiting_room_assets_paths
        if waiting_room_path is not None:
            self._values["waiting_room_path"] = waiting_room_path
        if waiting_room_title is not None:
            self._values["waiting_room_title"] = waiting_room_title

    @builtins.property
    def access_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#access_title DataAkamaiPropertyRulesBuilder#access_title}
        '''
        result = self._values.get("access_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def cloudlet_shared_policy(self) -> typing.Optional[jsii.Number]:
        '''This identifies the Visitor Prioritization FIFO shared policy to use with this behavior.

        You can list available shared policies with the ``Cloudlets API``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlet_shared_policy DataAkamaiPropertyRulesBuilder#cloudlet_shared_policy}
        '''
        result = self._values.get("cloudlet_shared_policy")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def custom_cookie_domain(self) -> typing.Optional[builtins.str]:
        '''This specifies a domain for all session cookies.

        In case you configure many property hostnames, this may be their common domain. Make sure the user agent accepts the custom domain for any request matching the ``visitorPrioritizationFifo`` behavior. Don't use top level domains (TLDs).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#custom_cookie_domain DataAkamaiPropertyRulesBuilder#custom_cookie_domain}
        '''
        result = self._values.get("custom_cookie_domain")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def domain_config(self) -> typing.Optional[builtins.str]:
        '''This specifies how to set the domain used to establish a session with the visitor.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#domain_config DataAkamaiPropertyRulesBuilder#domain_config}
        '''
        result = self._values.get("domain_config")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_auto_prolong(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Whether the queue session should prolong automatically when the ``sessionDuration`` expires  and the visitor remains active.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_auto_prolong DataAkamaiPropertyRulesBuilder#session_auto_prolong}
        '''
        result = self._values.get("session_auto_prolong")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def session_duration(self) -> typing.Optional[jsii.Number]:
        '''Specifies the number of seconds users remain in the waiting room queue.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#session_duration DataAkamaiPropertyRulesBuilder#session_duration}
        '''
        result = self._values.get("session_duration")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_assets_paths(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This specifies the base paths to static resources such as ``JavaScript``, ``CSS``, or image files for the ``Waiting Room Main Page`` requests.

        The option supports the ``*`` wildcard wildcard that matches zero or more characters. Requests matching any of these paths aren't blocked, but marked as Waiting Room Assets and passed through to the origin. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_assets_paths DataAkamaiPropertyRulesBuilder#waiting_room_assets_paths}
        '''
        result = self._values.get("waiting_room_assets_paths")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def waiting_room_path(self) -> typing.Optional[builtins.str]:
        '''This specifies the path to the waiting room main page on the origin server, for example ``/vp/waiting-room.html``. When the request is marked as ``Waiting Room Main Page`` and blocked, the visitor enters the waiting room. The behavior sets the outgoing request path to the ``waitingRoomPath`` and modifies the cache key accordingly. See the ``visitorPrioritizationRequest`` match criteria to further customize these requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_path DataAkamaiPropertyRulesBuilder#waiting_room_path}
        '''
        result = self._values.get("waiting_room_path")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def waiting_room_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#waiting_room_title DataAkamaiPropertyRulesBuilder#waiting_room_title}
        '''
        result = self._values.get("waiting_room_title")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c671f98a01f4047a0299893604121cbe6e51c852f473a2a989c7665b9cb7ca64)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAccessTitle")
    def reset_access_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAccessTitle", []))

    @jsii.member(jsii_name="resetCloudletSharedPolicy")
    def reset_cloudlet_shared_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletSharedPolicy", []))

    @jsii.member(jsii_name="resetCustomCookieDomain")
    def reset_custom_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomCookieDomain", []))

    @jsii.member(jsii_name="resetDomainConfig")
    def reset_domain_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDomainConfig", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetSessionAutoProlong")
    def reset_session_auto_prolong(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionAutoProlong", []))

    @jsii.member(jsii_name="resetSessionDuration")
    def reset_session_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSessionDuration", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomAssetsPaths")
    def reset_waiting_room_assets_paths(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomAssetsPaths", []))

    @jsii.member(jsii_name="resetWaitingRoomPath")
    def reset_waiting_room_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomPath", []))

    @jsii.member(jsii_name="resetWaitingRoomTitle")
    def reset_waiting_room_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomTitle", []))

    @builtins.property
    @jsii.member(jsii_name="accessTitleInput")
    def access_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "accessTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicyInput")
    def cloudlet_shared_policy_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cloudletSharedPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="customCookieDomainInput")
    def custom_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "customCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="domainConfigInput")
    def domain_config_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "domainConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlongInput")
    def session_auto_prolong_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sessionAutoProlongInput"))

    @builtins.property
    @jsii.member(jsii_name="sessionDurationInput")
    def session_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "sessionDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPathsInput")
    def waiting_room_assets_paths_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "waitingRoomAssetsPathsInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPathInput")
    def waiting_room_path_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomPathInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitleInput")
    def waiting_room_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="accessTitle")
    def access_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "accessTitle"))

    @access_title.setter
    def access_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__269636c22d1f4083249cf59ff29b9273b9f302cb3269ecd81a87378a801717c1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "accessTitle", value)

    @builtins.property
    @jsii.member(jsii_name="cloudletSharedPolicy")
    def cloudlet_shared_policy(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cloudletSharedPolicy"))

    @cloudlet_shared_policy.setter
    def cloudlet_shared_policy(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e3dee6daecc35679ca563877a873320060eb7dde2df8327b5a5b80d966a12ae)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cloudletSharedPolicy", value)

    @builtins.property
    @jsii.member(jsii_name="customCookieDomain")
    def custom_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "customCookieDomain"))

    @custom_cookie_domain.setter
    def custom_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__724435c0feb950ba135448a6959e83d44417ebbbd1979d72390b939f78def394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "customCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="domainConfig")
    def domain_config(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "domainConfig"))

    @domain_config.setter
    def domain_config(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd283cb09fc335447fc7f27941b379b472a9e3e6c1e897d72b73712701862cd0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "domainConfig", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2651eef3f7c449f18f4747ffa2e34699e2a909f88010a40e0456686d20a86446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="sessionAutoProlong")
    def session_auto_prolong(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sessionAutoProlong"))

    @session_auto_prolong.setter
    def session_auto_prolong(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdb5fa8a0ee678a69ef75a3aeb6a5c000e12850032368774406ad7907874d4ba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionAutoProlong", value)

    @builtins.property
    @jsii.member(jsii_name="sessionDuration")
    def session_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "sessionDuration"))

    @session_duration.setter
    def session_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__326a69c2740482bf5d2f24f3ff3a2ffa4ec603f6e6d4604167dbd34bca1183e5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sessionDuration", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6370190d60fba79455eb8590cc6961212bf073c2a87c1fd11d6740f0d3c9444)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__573d2d28cbc1ee17752c6b615e9dee2f94351c609753426facbceae114ae59fe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomAssetsPaths")
    def waiting_room_assets_paths(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "waitingRoomAssetsPaths"))

    @waiting_room_assets_paths.setter
    def waiting_room_assets_paths(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee6a6207795ccd9d5858e79133bf0f47da2b09f97a9ea6c5431546012179247f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomAssetsPaths", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomPath")
    def waiting_room_path(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomPath"))

    @waiting_room_path.setter
    def waiting_room_path(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9682ec240a0c3cb50cd243a9a4c66d4ef272fdef72587a0b7fa3e50830002f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomPath", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomTitle")
    def waiting_room_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomTitle"))

    @waiting_room_title.setter
    def waiting_room_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8730153be65e8c0345c409da3ba5bd751e2be44504018107c28aa4210f3b2ec5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomTitle", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82292dccb14543ae3ad5657b5048f61d5e4247426405279acc5baac7a0b27cbf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone",
    jsii_struct_bases=[],
    name_mapping={"locked": "locked", "template_uuid": "templateUuid", "uuid": "uuid"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c19a193ac27beee22f14f0b9f7c2f2f1c3490b4142f9897fc60fbe97b521bd)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandaloneOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__000ff5421ed09630631142106deca0d6ca791236e5fa64c64e5c6c17258abd39)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2521637a122cb0a4ee034d740767683f786fcda4bb92562cc8cc5232dc522d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f711fdcaa11d7f85be8dcdda792047b374f5ed127b20f5aaa6224e83d87bd81)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4442ab468688c38e6a94d2fbda9befdca7ab4ed30005d5f16b7a953ad19a618)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac2035c55dfc0fb59a823ff09bb7e195b1ddb0c83a976965f647aaba8ec75ae8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b831bdb770c017c99c10e4e39253cded253a0b3cdc0aba5dc6c8ddee357d8ced)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCloudletPolicy")
    def put_cloudlet_policy(
        self,
        *,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy(
            id=id, name=name
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletPolicy", [value]))

    @jsii.member(jsii_name="putWaitingRoomCpCode")
    def put_waiting_room_cp_code(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomCpCode", [value]))

    @jsii.member(jsii_name="putWaitingRoomNetStorage")
    def put_waiting_room_net_storage(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage(
            cp_code=cp_code,
            download_domain_name=download_domain_name,
            g2_o_token=g2_o_token,
        )

        return typing.cast(None, jsii.invoke(self, "putWaitingRoomNetStorage", [value]))

    @jsii.member(jsii_name="resetAllowedUserCookieAdvanced")
    def reset_allowed_user_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAdvanced", []))

    @jsii.member(jsii_name="resetAllowedUserCookieAutomaticSalt")
    def reset_allowed_user_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomain")
    def reset_allowed_user_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomain", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDomainType")
    def reset_allowed_user_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDomainType", []))

    @jsii.member(jsii_name="resetAllowedUserCookieDuration")
    def reset_allowed_user_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieDuration", []))

    @jsii.member(jsii_name="resetAllowedUserCookieEnabled")
    def reset_allowed_user_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieEnabled", []))

    @jsii.member(jsii_name="resetAllowedUserCookieHttpOnly")
    def reset_allowed_user_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieHttpOnly", []))

    @jsii.member(jsii_name="resetAllowedUserCookieLabel")
    def reset_allowed_user_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieLabel", []))

    @jsii.member(jsii_name="resetAllowedUserCookieManagementTitle")
    def reset_allowed_user_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieManagementTitle", []))

    @jsii.member(jsii_name="resetAllowedUserCookieRefresh")
    def reset_allowed_user_cookie_refresh(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieRefresh", []))

    @jsii.member(jsii_name="resetAllowedUserCookieSalt")
    def reset_allowed_user_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAllowedUserCookieSalt", []))

    @jsii.member(jsii_name="resetCloudletPolicy")
    def reset_cloudlet_policy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletPolicy", []))

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUserIdentificationByCookie")
    def reset_user_identification_by_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationByHeaders")
    def reset_user_identification_by_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationByIp")
    def reset_user_identification_by_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByIp", []))

    @jsii.member(jsii_name="resetUserIdentificationByParams")
    def reset_user_identification_by_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationByParams", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyCookie")
    def reset_user_identification_key_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyCookie", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyHeaders")
    def reset_user_identification_key_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyHeaders", []))

    @jsii.member(jsii_name="resetUserIdentificationKeyParams")
    def reset_user_identification_key_params(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationKeyParams", []))

    @jsii.member(jsii_name="resetUserIdentificationTitle")
    def reset_user_identification_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserIdentificationTitle", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetWaitingRoomCacheTtl")
    def reset_waiting_room_cache_ttl(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCacheTtl", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAdvanced")
    def reset_waiting_room_cookie_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAdvanced", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieAutomaticSalt")
    def reset_waiting_room_cookie_automatic_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieAutomaticSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomain")
    def reset_waiting_room_cookie_domain(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomain", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDomainType")
    def reset_waiting_room_cookie_domain_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDomainType", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieDuration")
    def reset_waiting_room_cookie_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieDuration", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieEnabled")
    def reset_waiting_room_cookie_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieEnabled", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieHttpOnly")
    def reset_waiting_room_cookie_http_only(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieHttpOnly", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieLabel")
    def reset_waiting_room_cookie_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieManagementTitle")
    def reset_waiting_room_cookie_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieSalt")
    def reset_waiting_room_cookie_salt(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieSalt", []))

    @jsii.member(jsii_name="resetWaitingRoomCookieShareLabel")
    def reset_waiting_room_cookie_share_label(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCookieShareLabel", []))

    @jsii.member(jsii_name="resetWaitingRoomCpCode")
    def reset_waiting_room_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomCpCode", []))

    @jsii.member(jsii_name="resetWaitingRoomDirectory")
    def reset_waiting_room_directory(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomDirectory", []))

    @jsii.member(jsii_name="resetWaitingRoomManagementTitle")
    def reset_waiting_room_management_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomManagementTitle", []))

    @jsii.member(jsii_name="resetWaitingRoomNetStorage")
    def reset_waiting_room_net_storage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomNetStorage", []))

    @jsii.member(jsii_name="resetWaitingRoomStatusCode")
    def reset_waiting_room_status_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomStatusCode", []))

    @jsii.member(jsii_name="resetWaitingRoomUseCpCode")
    def reset_waiting_room_use_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetWaitingRoomUseCpCode", []))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicy")
    def cloudlet_policy(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicyOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicyOutputReference, jsii.get(self, "cloudletPolicy"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCode")
    def waiting_room_cp_code(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference", jsii.get(self, "waitingRoomCpCode"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorage")
    def waiting_room_net_storage(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference", jsii.get(self, "waitingRoomNetStorage"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvancedInput")
    def allowed_user_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSaltInput")
    def allowed_user_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainInput")
    def allowed_user_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainTypeInput")
    def allowed_user_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDurationInput")
    def allowed_user_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "allowedUserCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabledInput")
    def allowed_user_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnlyInput")
    def allowed_user_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabelInput")
    def allowed_user_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitleInput")
    def allowed_user_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefreshInput")
    def allowed_user_cookie_refresh_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "allowedUserCookieRefreshInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSaltInput")
    def allowed_user_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "allowedUserCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletPolicyInput")
    def cloudlet_policy_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy], jsii.get(self, "cloudletPolicyInput"))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookieInput")
    def user_identification_by_cookie_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeadersInput")
    def user_identification_by_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIpInput")
    def user_identification_by_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByIpInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParamsInput")
    def user_identification_by_params_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "userIdentificationByParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookieInput")
    def user_identification_key_cookie_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationKeyCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeadersInput")
    def user_identification_key_headers_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParamsInput")
    def user_identification_key_params_input(
        self,
    ) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "userIdentificationKeyParamsInput"))

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitleInput")
    def user_identification_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "userIdentificationTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtlInput")
    def waiting_room_cache_ttl_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCacheTtlInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvancedInput")
    def waiting_room_cookie_advanced_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSaltInput")
    def waiting_room_cookie_automatic_salt_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieAutomaticSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainInput")
    def waiting_room_cookie_domain_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainTypeInput")
    def waiting_room_cookie_domain_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieDomainTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDurationInput")
    def waiting_room_cookie_duration_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomCookieDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabledInput")
    def waiting_room_cookie_enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieEnabledInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnlyInput")
    def waiting_room_cookie_http_only_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieHttpOnlyInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabelInput")
    def waiting_room_cookie_label_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitleInput")
    def waiting_room_cookie_management_title_input(
        self,
    ) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSaltInput")
    def waiting_room_cookie_salt_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomCookieSaltInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabelInput")
    def waiting_room_cookie_share_label_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomCookieShareLabelInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCpCodeInput")
    def waiting_room_cp_code_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode"], jsii.get(self, "waitingRoomCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectoryInput")
    def waiting_room_directory_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomDirectoryInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitleInput")
    def waiting_room_management_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "waitingRoomManagementTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomNetStorageInput")
    def waiting_room_net_storage_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage"], jsii.get(self, "waitingRoomNetStorageInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCodeInput")
    def waiting_room_status_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "waitingRoomStatusCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCodeInput")
    def waiting_room_use_cp_code_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "waitingRoomUseCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAdvanced")
    def allowed_user_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAdvanced"))

    @allowed_user_cookie_advanced.setter
    def allowed_user_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bb852367e4efddd5bc82a8abb35528cc74740e3a6beb6064922478308865944)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieAutomaticSalt")
    def allowed_user_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieAutomaticSalt"))

    @allowed_user_cookie_automatic_salt.setter
    def allowed_user_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__211b5b998644d2ea9d69423fcafa3317f246fa2dba1649c2dc680fdc4a1af59c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomain")
    def allowed_user_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomain"))

    @allowed_user_cookie_domain.setter
    def allowed_user_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2d0613fcdfd2c26fa7b2eaa954517d3872c03ee4dbabd647680bb57a553fae77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDomainType")
    def allowed_user_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieDomainType"))

    @allowed_user_cookie_domain_type.setter
    def allowed_user_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9400ae2fb26aa41625bf27675643c00b465c22d5e92b71ddc2da8fe5effb000e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieDuration")
    def allowed_user_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "allowedUserCookieDuration"))

    @allowed_user_cookie_duration.setter
    def allowed_user_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6a8a2d4e598c0b338607f1a6d7dda4fd31a70e59de96cc160c7e49232fae383b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieEnabled")
    def allowed_user_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieEnabled"))

    @allowed_user_cookie_enabled.setter
    def allowed_user_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8c514ac4683605df323b189f9e2d071d675b92defb93ab850399cae367b8cdd4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieHttpOnly")
    def allowed_user_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieHttpOnly"))

    @allowed_user_cookie_http_only.setter
    def allowed_user_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a506cb9cff5d9f8229dc97e0880dfecfcc4bccf60a172ebf2d88f3c6e1b3812b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieLabel")
    def allowed_user_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieLabel"))

    @allowed_user_cookie_label.setter
    def allowed_user_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9060d0d83bc12e95d71172a5c9a62f5df8fb71952df7a11edb621862d4b2d1e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieManagementTitle")
    def allowed_user_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieManagementTitle"))

    @allowed_user_cookie_management_title.setter
    def allowed_user_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b946f84a5d9a00ceec022b83e237602725903c9f8ef37eff498bf5da2302982)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieRefresh")
    def allowed_user_cookie_refresh(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "allowedUserCookieRefresh"))

    @allowed_user_cookie_refresh.setter
    def allowed_user_cookie_refresh(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e2b142ebab89ecaa6d480c6597d8f7ced401b403387e8dc053bda25f2181e72)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieRefresh", value)

    @builtins.property
    @jsii.member(jsii_name="allowedUserCookieSalt")
    def allowed_user_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "allowedUserCookieSalt"))

    @allowed_user_cookie_salt.setter
    def allowed_user_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b9f5eb2446a5467788098347f071e256b4033cfeb43055dfb560ca2ec1c0425)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "allowedUserCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__06807613cd2abe89d0ecdccb8dc9e05dc9a0b4c6b532b182f703fd3752071cfe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d920bd783e5139f6ac181ab7b270beb9796b48529a4e7a2a175c59e5b0b480c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33d4a3da29a3aafbf885ffcac7f8b535072718a3f68b98127f06713871252916)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByCookie")
    def user_identification_by_cookie(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByCookie"))

    @user_identification_by_cookie.setter
    def user_identification_by_cookie(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__621e9f882254a32311e5e4c14a3ca8696e9cc53c7081483f4c7c1036c5bfcfc7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByHeaders")
    def user_identification_by_headers(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByHeaders"))

    @user_identification_by_headers.setter
    def user_identification_by_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d06743635739287d3a5e73f0104b0728ce81a2076ff1541cc82ffa9f68c7e534)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByIp")
    def user_identification_by_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByIp"))

    @user_identification_by_ip.setter
    def user_identification_by_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b11f95ce1801b8d8ba38e3775076d075199ea08b0acceeaefbd09dc3f1d1f07a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByIp", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationByParams")
    def user_identification_by_params(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "userIdentificationByParams"))

    @user_identification_by_params.setter
    def user_identification_by_params(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4764eb58323aac85e57aaff35fb7ee17acc262b67c4698c1a4219cebd5007af4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationByParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyCookie")
    def user_identification_key_cookie(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationKeyCookie"))

    @user_identification_key_cookie.setter
    def user_identification_key_cookie(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__758434d098c058ebffe63dd27197af37bb1e0799c5396087a701f79ad67efca5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyCookie", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyHeaders")
    def user_identification_key_headers(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyHeaders"))

    @user_identification_key_headers.setter
    def user_identification_key_headers(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92149b263472cb047ae5e320ea8a1adb01f9ca6ebbdefd441c1c4f4169f6a957)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationKeyParams")
    def user_identification_key_params(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "userIdentificationKeyParams"))

    @user_identification_key_params.setter
    def user_identification_key_params(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78dfa28120cc3c54c9999188ea9b84a3917f6534e7abce3723effebd55d21fa5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationKeyParams", value)

    @builtins.property
    @jsii.member(jsii_name="userIdentificationTitle")
    def user_identification_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "userIdentificationTitle"))

    @user_identification_title.setter
    def user_identification_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f921d5e77d31763c2a21ca4024279608b5763de7d7d5c4d2938fd822a118a25)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "userIdentificationTitle", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77beb1d9e997b34782828bf47a02da4d825f1986e9c67866319a5aa079a6f75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCacheTtl")
    def waiting_room_cache_ttl(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCacheTtl"))

    @waiting_room_cache_ttl.setter
    def waiting_room_cache_ttl(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9fbeabeaf87eeedf587c267aa10583b7e6045193ee83f468170b5f6c71bb51af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCacheTtl", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAdvanced")
    def waiting_room_cookie_advanced(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAdvanced"))

    @waiting_room_cookie_advanced.setter
    def waiting_room_cookie_advanced(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8bc4b24e6101d2532eec12249a70bb0bbe1afef366caff5e4a0b4d6b13f667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAdvanced", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieAutomaticSalt")
    def waiting_room_cookie_automatic_salt(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieAutomaticSalt"))

    @waiting_room_cookie_automatic_salt.setter
    def waiting_room_cookie_automatic_salt(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d288f94e390d21bc28bb75b0b838965ebed617e760cd978c09563183b78858d0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieAutomaticSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomain")
    def waiting_room_cookie_domain(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomain"))

    @waiting_room_cookie_domain.setter
    def waiting_room_cookie_domain(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57ea7bc92bb59dbdb03916a62616d83d336a07f5aa5d094c5e54d8beab14d6a4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomain", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDomainType")
    def waiting_room_cookie_domain_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieDomainType"))

    @waiting_room_cookie_domain_type.setter
    def waiting_room_cookie_domain_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee473ffa0404ece8351b6e70f25a93488cd2da641991ef88518d68d3dd3f5099)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDomainType", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieDuration")
    def waiting_room_cookie_duration(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomCookieDuration"))

    @waiting_room_cookie_duration.setter
    def waiting_room_cookie_duration(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2d728c2b3acec109f50085069274545da8250e680d0c1cc2610b2deb2c11385)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieDuration", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieEnabled")
    def waiting_room_cookie_enabled(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieEnabled"))

    @waiting_room_cookie_enabled.setter
    def waiting_room_cookie_enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8628b490841557cf81d91b17c1bb1d5b3083de1d34ec0e10fbcc8b102501056c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieEnabled", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieHttpOnly")
    def waiting_room_cookie_http_only(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieHttpOnly"))

    @waiting_room_cookie_http_only.setter
    def waiting_room_cookie_http_only(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63def3ca65306746348159ec74b0beb8bfc4f34e31c46110332ce2bc42360213)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieHttpOnly", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieLabel")
    def waiting_room_cookie_label(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieLabel"))

    @waiting_room_cookie_label.setter
    def waiting_room_cookie_label(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5c4f80014fdcdd768e3f79e8db2de75d93a12d1e111c293b3fe24f52aa97c428)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieManagementTitle")
    def waiting_room_cookie_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieManagementTitle"))

    @waiting_room_cookie_management_title.setter
    def waiting_room_cookie_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6cfdd3dad06afac783ce793d2b01d991e1ca498c1290f67c607bf2073bbe4807)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieSalt")
    def waiting_room_cookie_salt(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomCookieSalt"))

    @waiting_room_cookie_salt.setter
    def waiting_room_cookie_salt(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71793470e2a168a0c7e80f67a1d28ef55946f22a8a9059ed46d2f3a8c5e15f84)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieSalt", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomCookieShareLabel")
    def waiting_room_cookie_share_label(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomCookieShareLabel"))

    @waiting_room_cookie_share_label.setter
    def waiting_room_cookie_share_label(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cc42f7adc51a8877b524455bc048bc4cb7ba6fc98b96403e59aa8beaa2deb479)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomCookieShareLabel", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomDirectory")
    def waiting_room_directory(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomDirectory"))

    @waiting_room_directory.setter
    def waiting_room_directory(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__810640f16b35755ec72298a2ae245579fd6ba38c57786734a9d8c34cef5196d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomDirectory", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomManagementTitle")
    def waiting_room_management_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "waitingRoomManagementTitle"))

    @waiting_room_management_title.setter
    def waiting_room_management_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87c8c08d97d84a026e8362a0a034f29c4a79cf0784e7d4556b025dc877c2019e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomManagementTitle", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomStatusCode")
    def waiting_room_status_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "waitingRoomStatusCode"))

    @waiting_room_status_code.setter
    def waiting_room_status_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c49cb489ab839cfa18fe5074e87fce2c99528f67c6fdc5ed259ce13dd1641f5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomStatusCode", value)

    @builtins.property
    @jsii.member(jsii_name="waitingRoomUseCpCode")
    def waiting_room_use_cp_code(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "waitingRoomUseCpCode"))

    @waiting_room_use_cp_code.setter
    def waiting_room_use_cp_code(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__920e3d9c3431e9c37487ae4d1e565d9ac501eca1b751c7f987252d4ded2d0d92)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "waitingRoomUseCpCode", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d377e1211230620d56d7055008a837b83c0a07664949e4af327d7dc1fed34cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__19a8dc6ae363280ba4b43e7b0130c234c184184d9edec31451540f3e67fcd0b3)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__558142d4d4806d694a223b0b676742fd78fc746a76f5fbca20d8c55654a8f023)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__607b5a23a2cf8292e9691f36479d5b1070a7e3f7d706efb822c73f523421dc9d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9094b206dec46e2dc432f74538f9b7608ace3e3cba819fc7883c42b45e94b5e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__07955b51d8d15bf1ceb1cf46418867ea7ad11ee9dc825d42646665f9e24bf307)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__887edde0bf47d571d3c101098ba051c74d8abfe69f96a45b06dfb94577bfa381)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__81d8da9920aef6ec795da45606bbf00c396274ad32c54f54ed34dc87fd4373e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__387ed77a78d9a7c6309d55bacbbc56ab5749d166f5d030d726ef8d46d5b74086)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4641387ebcad24f645496d411c79a4398ff09c09226e161e5d118a4736ea2c8b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3fdfdf13c4584a75c47436036eaeb06d00feaefd6dc70b6f64d914ada455e7fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed1c5f477b0a7756ebd39e7b8d95ddfd69bf4ef71f1260c38d6b7e478e43f5b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1448a7af694ce932c96f54666c6fec78cb89a54fd90c22dca2f633bb5eeb710f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c42e49c69afca645b929f65e682400c3771ce3fd3445848861083b3012197943)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f72a8ef7ff24f15fbc59f2f60f30bff5e6348164c6d7b3baf3c5e512fce40eb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code": "cpCode",
        "download_domain_name": "downloadDomainName",
        "g2_o_token": "g2OToken",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage:
    def __init__(
        self,
        *,
        cp_code: typing.Optional[jsii.Number] = None,
        download_domain_name: typing.Optional[builtins.str] = None,
        g2_o_token: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cp_code: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.
        :param download_domain_name: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.
        :param g2_o_token: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__12563490863815ae630ef90e8742ab5984143402715e9711c2f18d07b3838b5b)
            check_type(argname="argument cp_code", value=cp_code, expected_type=type_hints["cp_code"])
            check_type(argname="argument download_domain_name", value=download_domain_name, expected_type=type_hints["download_domain_name"])
            check_type(argname="argument g2_o_token", value=g2_o_token, expected_type=type_hints["g2_o_token"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code is not None:
            self._values["cp_code"] = cp_code
        if download_domain_name is not None:
            self._values["download_domain_name"] = download_domain_name
        if g2_o_token is not None:
            self._values["g2_o_token"] = g2_o_token

    @builtins.property
    def cp_code(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code DataAkamaiPropertyRulesBuilder#cp_code}.'''
        result = self._values.get("cp_code")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def download_domain_name(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#download_domain_name DataAkamaiPropertyRulesBuilder#download_domain_name}.'''
        result = self._values.get("download_domain_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def g2_o_token(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#g2o_token DataAkamaiPropertyRulesBuilder#g2o_token}.'''
        result = self._values.get("g2_o_token")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9324cf776487fd944201d6bb154d863cbb99b344968b23f46f90ea2103d6c6b6)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCpCode")
    def reset_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCode", []))

    @jsii.member(jsii_name="resetDownloadDomainName")
    def reset_download_domain_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDownloadDomainName", []))

    @jsii.member(jsii_name="resetG2OToken")
    def reset_g2_o_token(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetG2OToken", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeInput")
    def cp_code_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "cpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="downloadDomainNameInput")
    def download_domain_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "downloadDomainNameInput"))

    @builtins.property
    @jsii.member(jsii_name="g2OTokenInput")
    def g2_o_token_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "g2OTokenInput"))

    @builtins.property
    @jsii.member(jsii_name="cpCode")
    def cp_code(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "cpCode"))

    @cp_code.setter
    def cp_code(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0062b96c9d13033124e660a6d70c0d166679de6f15e931a58ee54408f1f5c57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cpCode", value)

    @builtins.property
    @jsii.member(jsii_name="downloadDomainName")
    def download_domain_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "downloadDomainName"))

    @download_domain_name.setter
    def download_domain_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8677f54206ff2d20c36ca1533814e7be58ad5489876f0597f76aa96d800bcde6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "downloadDomainName", value)

    @builtins.property
    @jsii.member(jsii_name="g2OToken")
    def g2_o_token(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "g2OToken"))

    @g2_o_token.setter
    def g2_o_token(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78cd5a35fbe28671513f02c53cad23ed6d3c12e44f9972e8825a8f9aa1f7abf8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "g2OToken", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0dea2c22cad6dd2779824264df51d96d6be634a6553c18b775f78cfc1a66f530)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking",
    jsii_struct_bases=[],
    name_mapping={
        "ab_variant_location": "abVariantLocation",
        "decryption_password1": "decryptionPassword1",
        "decryption_password2": "decryptionPassword2",
        "decryption_password_id1": "decryptionPasswordId1",
        "decryption_password_id2": "decryptionPasswordId2",
        "enable": "enable",
        "locked": "locked",
        "miscellaneous_settings_title": "miscellaneousSettingsTitle",
        "pattern_decryption_enable": "patternDecryptionEnable",
        "pattern_encryption_title": "patternEncryptionTitle",
        "signature_verification_enable": "signatureVerificationEnable",
        "template_uuid": "templateUuid",
        "token_signing_title": "tokenSigningTitle",
        "use_original_as_a": "useOriginalAsA",
        "uuid": "uuid",
        "verification_key_id1": "verificationKeyId1",
        "verification_key_id2": "verificationKeyId2",
        "verification_public_key1": "verificationPublicKey1",
        "verification_public_key2": "verificationPublicKey2",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking:
    def __init__(
        self,
        *,
        ab_variant_location: typing.Optional[builtins.str] = None,
        decryption_password1: typing.Optional[builtins.str] = None,
        decryption_password2: typing.Optional[builtins.str] = None,
        decryption_password_id1: typing.Optional[builtins.str] = None,
        decryption_password_id2: typing.Optional[builtins.str] = None,
        enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        miscellaneous_settings_title: typing.Optional[builtins.str] = None,
        pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        pattern_encryption_title: typing.Optional[builtins.str] = None,
        signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        token_signing_title: typing.Optional[builtins.str] = None,
        use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        verification_key_id1: typing.Optional[builtins.str] = None,
        verification_key_id2: typing.Optional[builtins.str] = None,
        verification_public_key1: typing.Optional[builtins.str] = None,
        verification_public_key2: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param ab_variant_location: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        :param decryption_password1: Provides the primary password used to encrypt patterns in your watermarking tokens. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        :param decryption_password2: Provides the secondary password you can use to rotate passwords. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        :param decryption_password_id1: Specifies a label that corresponds to the primary password. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        :param decryption_password_id2: Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        :param enable: Enables the watermarking behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param miscellaneous_settings_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        :param pattern_decryption_enable: If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        :param pattern_encryption_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        :param signature_verification_enable: When enabled, you can verify the signature in your watermarking token. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param token_signing_title: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        :param use_original_as_a: When you work with your watermarking vendor, you can apply several preprocessing methods to your content. See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param verification_key_id1: Specifies a unique identifier for the first public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        :param verification_key_id2: Specifies a unique identifier for the optional second public key. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        :param verification_public_key1: Specifies the first public key in its entirety. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        :param verification_public_key2: Specifies the optional second public key in its entirety. Specify a second key to enable rotation. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a03483a53502fe506ecdb9ffaf4284778a006b44b42123717bdf8be1d60528d)
            check_type(argname="argument ab_variant_location", value=ab_variant_location, expected_type=type_hints["ab_variant_location"])
            check_type(argname="argument decryption_password1", value=decryption_password1, expected_type=type_hints["decryption_password1"])
            check_type(argname="argument decryption_password2", value=decryption_password2, expected_type=type_hints["decryption_password2"])
            check_type(argname="argument decryption_password_id1", value=decryption_password_id1, expected_type=type_hints["decryption_password_id1"])
            check_type(argname="argument decryption_password_id2", value=decryption_password_id2, expected_type=type_hints["decryption_password_id2"])
            check_type(argname="argument enable", value=enable, expected_type=type_hints["enable"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument miscellaneous_settings_title", value=miscellaneous_settings_title, expected_type=type_hints["miscellaneous_settings_title"])
            check_type(argname="argument pattern_decryption_enable", value=pattern_decryption_enable, expected_type=type_hints["pattern_decryption_enable"])
            check_type(argname="argument pattern_encryption_title", value=pattern_encryption_title, expected_type=type_hints["pattern_encryption_title"])
            check_type(argname="argument signature_verification_enable", value=signature_verification_enable, expected_type=type_hints["signature_verification_enable"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument token_signing_title", value=token_signing_title, expected_type=type_hints["token_signing_title"])
            check_type(argname="argument use_original_as_a", value=use_original_as_a, expected_type=type_hints["use_original_as_a"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument verification_key_id1", value=verification_key_id1, expected_type=type_hints["verification_key_id1"])
            check_type(argname="argument verification_key_id2", value=verification_key_id2, expected_type=type_hints["verification_key_id2"])
            check_type(argname="argument verification_public_key1", value=verification_public_key1, expected_type=type_hints["verification_public_key1"])
            check_type(argname="argument verification_public_key2", value=verification_public_key2, expected_type=type_hints["verification_public_key2"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if ab_variant_location is not None:
            self._values["ab_variant_location"] = ab_variant_location
        if decryption_password1 is not None:
            self._values["decryption_password1"] = decryption_password1
        if decryption_password2 is not None:
            self._values["decryption_password2"] = decryption_password2
        if decryption_password_id1 is not None:
            self._values["decryption_password_id1"] = decryption_password_id1
        if decryption_password_id2 is not None:
            self._values["decryption_password_id2"] = decryption_password_id2
        if enable is not None:
            self._values["enable"] = enable
        if locked is not None:
            self._values["locked"] = locked
        if miscellaneous_settings_title is not None:
            self._values["miscellaneous_settings_title"] = miscellaneous_settings_title
        if pattern_decryption_enable is not None:
            self._values["pattern_decryption_enable"] = pattern_decryption_enable
        if pattern_encryption_title is not None:
            self._values["pattern_encryption_title"] = pattern_encryption_title
        if signature_verification_enable is not None:
            self._values["signature_verification_enable"] = signature_verification_enable
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if token_signing_title is not None:
            self._values["token_signing_title"] = token_signing_title
        if use_original_as_a is not None:
            self._values["use_original_as_a"] = use_original_as_a
        if uuid is not None:
            self._values["uuid"] = uuid
        if verification_key_id1 is not None:
            self._values["verification_key_id1"] = verification_key_id1
        if verification_key_id2 is not None:
            self._values["verification_key_id2"] = verification_key_id2
        if verification_public_key1 is not None:
            self._values["verification_public_key1"] = verification_public_key1
        if verification_public_key2 is not None:
            self._values["verification_public_key2"] = verification_public_key2

    @builtins.property
    def ab_variant_location(self) -> typing.Optional[builtins.str]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. Use this option to specify the location of the ``A`` and ``B`` variant segments.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ab_variant_location DataAkamaiPropertyRulesBuilder#ab_variant_location}
        '''
        result = self._values.get("ab_variant_location")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password1(self) -> typing.Optional[builtins.str]:
        '''Provides the primary password used to encrypt patterns in your watermarking tokens.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password1 DataAkamaiPropertyRulesBuilder#decryption_password1}
        '''
        result = self._values.get("decryption_password1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password2(self) -> typing.Optional[builtins.str]:
        '''Provides the secondary password you can use to rotate passwords.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password2 DataAkamaiPropertyRulesBuilder#decryption_password2}
        '''
        result = self._values.get("decryption_password2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a label that corresponds to the primary password.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id1 DataAkamaiPropertyRulesBuilder#decryption_password_id1}
        '''
        result = self._values.get("decryption_password_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def decryption_password_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a label for the secondary password, used in rotation scenarios to identify which password to use for decryption.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#decryption_password_id2 DataAkamaiPropertyRulesBuilder#decryption_password_id2}
        '''
        result = self._values.get("decryption_password_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the watermarking behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enable DataAkamaiPropertyRulesBuilder#enable}
        '''
        result = self._values.get("enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def miscellaneous_settings_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#miscellaneous_settings_title DataAkamaiPropertyRulesBuilder#miscellaneous_settings_title}
        '''
        result = self._values.get("miscellaneous_settings_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def pattern_decryption_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''If patterns in your watermarking tokens have been encrypted, enabling this allows you to provide values to decrypt them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_decryption_enable DataAkamaiPropertyRulesBuilder#pattern_decryption_enable}
        '''
        result = self._values.get("pattern_decryption_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def pattern_encryption_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#pattern_encryption_title DataAkamaiPropertyRulesBuilder#pattern_encryption_title}
        '''
        result = self._values.get("pattern_encryption_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def signature_verification_enable(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, you can verify the signature in your watermarking token.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#signature_verification_enable DataAkamaiPropertyRulesBuilder#signature_verification_enable}
        '''
        result = self._values.get("signature_verification_enable")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def token_signing_title(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_signing_title DataAkamaiPropertyRulesBuilder#token_signing_title}
        '''
        result = self._values.get("token_signing_title")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_original_as_a(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When you work with your watermarking vendor, you can apply several preprocessing methods to your content.

        See the ``AMD help`` for more information. With the standard ``filename-prefix AB naming`` preprocessing method, the watermarking vendor creates two variants of the original segment content and labels them as an ``A`` and ``B`` segment in the filename. If you selected the ``unlabeled A variant`` preprocessing method, enabling this option tells your configuration to use the original filename segment content as your ``A`` variant.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_original_as_a DataAkamaiPropertyRulesBuilder#use_original_as_a}
        '''
        result = self._values.get("use_original_as_a")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id1(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the first public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id1 DataAkamaiPropertyRulesBuilder#verification_key_id1}
        '''
        result = self._values.get("verification_key_id1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_key_id2(self) -> typing.Optional[builtins.str]:
        '''Specifies a unique identifier for the optional second public key.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_key_id2 DataAkamaiPropertyRulesBuilder#verification_key_id2}
        '''
        result = self._values.get("verification_key_id2")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key1(self) -> typing.Optional[builtins.str]:
        '''Specifies the first public key in its entirety.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key1 DataAkamaiPropertyRulesBuilder#verification_public_key1}
        '''
        result = self._values.get("verification_public_key1")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def verification_public_key2(self) -> typing.Optional[builtins.str]:
        '''Specifies the optional second public key in its entirety. Specify a second key to enable rotation.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#verification_public_key2 DataAkamaiPropertyRulesBuilder#verification_public_key2}
        '''
        result = self._values.get("verification_public_key2")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarkingOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarkingOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__463fff504aa3b9c74b140ada8001f8522fd3ab1ec01c5902be6b7986b7d8c3fe)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAbVariantLocation")
    def reset_ab_variant_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAbVariantLocation", []))

    @jsii.member(jsii_name="resetDecryptionPassword1")
    def reset_decryption_password1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword1", []))

    @jsii.member(jsii_name="resetDecryptionPassword2")
    def reset_decryption_password2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPassword2", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId1")
    def reset_decryption_password_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId1", []))

    @jsii.member(jsii_name="resetDecryptionPasswordId2")
    def reset_decryption_password_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDecryptionPasswordId2", []))

    @jsii.member(jsii_name="resetEnable")
    def reset_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnable", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMiscellaneousSettingsTitle")
    def reset_miscellaneous_settings_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMiscellaneousSettingsTitle", []))

    @jsii.member(jsii_name="resetPatternDecryptionEnable")
    def reset_pattern_decryption_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternDecryptionEnable", []))

    @jsii.member(jsii_name="resetPatternEncryptionTitle")
    def reset_pattern_encryption_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPatternEncryptionTitle", []))

    @jsii.member(jsii_name="resetSignatureVerificationEnable")
    def reset_signature_verification_enable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetSignatureVerificationEnable", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetTokenSigningTitle")
    def reset_token_signing_title(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenSigningTitle", []))

    @jsii.member(jsii_name="resetUseOriginalAsA")
    def reset_use_original_as_a(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOriginalAsA", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVerificationKeyId1")
    def reset_verification_key_id1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId1", []))

    @jsii.member(jsii_name="resetVerificationKeyId2")
    def reset_verification_key_id2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationKeyId2", []))

    @jsii.member(jsii_name="resetVerificationPublicKey1")
    def reset_verification_public_key1(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey1", []))

    @jsii.member(jsii_name="resetVerificationPublicKey2")
    def reset_verification_public_key2(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVerificationPublicKey2", []))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocationInput")
    def ab_variant_location_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "abVariantLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1Input")
    def decryption_password1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2Input")
    def decryption_password2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPassword2Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1Input")
    def decryption_password_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId1Input"))

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2Input")
    def decryption_password_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "decryptionPasswordId2Input"))

    @builtins.property
    @jsii.member(jsii_name="enableInput")
    def enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enableInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitleInput")
    def miscellaneous_settings_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "miscellaneousSettingsTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnableInput")
    def pattern_decryption_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "patternDecryptionEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitleInput")
    def pattern_encryption_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "patternEncryptionTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnableInput")
    def signature_verification_enable_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "signatureVerificationEnableInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitleInput")
    def token_signing_title_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "tokenSigningTitleInput"))

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsAInput")
    def use_original_as_a_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOriginalAsAInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1Input")
    def verification_key_id1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2Input")
    def verification_key_id2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationKeyId2Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1Input")
    def verification_public_key1_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey1Input"))

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2Input")
    def verification_public_key2_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "verificationPublicKey2Input"))

    @builtins.property
    @jsii.member(jsii_name="abVariantLocation")
    def ab_variant_location(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "abVariantLocation"))

    @ab_variant_location.setter
    def ab_variant_location(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2968c5c22acfe7f47d6b4d90a8d8132bf0de424d448372340d7fd1a04d8437a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "abVariantLocation", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword1")
    def decryption_password1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword1"))

    @decryption_password1.setter
    def decryption_password1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__22144b93ab80308fa99e7be9752fb455d3216fa15bcd71638906a4eb284603d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPassword2")
    def decryption_password2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPassword2"))

    @decryption_password2.setter
    def decryption_password2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f72e67c9c20d29ea46fba8304a3326c0ed78b50b23c49ac3e03df51b2229e52f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPassword2", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId1")
    def decryption_password_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId1"))

    @decryption_password_id1.setter
    def decryption_password_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67a806131d11cc77072b8ad767ceb3114847a986dd3141a518b795ff179978af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId1", value)

    @builtins.property
    @jsii.member(jsii_name="decryptionPasswordId2")
    def decryption_password_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "decryptionPasswordId2"))

    @decryption_password_id2.setter
    def decryption_password_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32b901fc7476112fdc8173b20567b0b47bdc412aba255694f57af607b46b4e2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "decryptionPasswordId2", value)

    @builtins.property
    @jsii.member(jsii_name="enable")
    def enable(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enable"))

    @enable.setter
    def enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__414eccb0e81b88e8ba2b56d21a5f8ee6bb6f5db5f496e245174d0cf02e4778e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enable", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05019c95cf0ad5942f34f6ea4ebd6b1f072cee9e498039df73044da6c6d84f87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="miscellaneousSettingsTitle")
    def miscellaneous_settings_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "miscellaneousSettingsTitle"))

    @miscellaneous_settings_title.setter
    def miscellaneous_settings_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6446d184ce02fcf0f0592f1821c6be6b2b5dfff6fa87dab0abbca11d8f54c5a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "miscellaneousSettingsTitle", value)

    @builtins.property
    @jsii.member(jsii_name="patternDecryptionEnable")
    def pattern_decryption_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "patternDecryptionEnable"))

    @pattern_decryption_enable.setter
    def pattern_decryption_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__626c4b5bcc404f4411767de1e74b0e585871cf73917a07033e583c7d8fc49f21)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternDecryptionEnable", value)

    @builtins.property
    @jsii.member(jsii_name="patternEncryptionTitle")
    def pattern_encryption_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "patternEncryptionTitle"))

    @pattern_encryption_title.setter
    def pattern_encryption_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cfc9bb2b14b82fc11086c4dc33961887739aaf7d92bbfdcdac17378e14505768)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "patternEncryptionTitle", value)

    @builtins.property
    @jsii.member(jsii_name="signatureVerificationEnable")
    def signature_verification_enable(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "signatureVerificationEnable"))

    @signature_verification_enable.setter
    def signature_verification_enable(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4542ebe9c074930b72260eca4e726d06d48ee18b384e1777208407c81691a347)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "signatureVerificationEnable", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d66cffce25e60c9c0ce82f808ac0055103391ccd6660cf3beb4fccb3a90640a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="tokenSigningTitle")
    def token_signing_title(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "tokenSigningTitle"))

    @token_signing_title.setter
    def token_signing_title(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa4f22559f67a6d52eb976aef318bbf2cf094febd9d2ae88d79bc9af2d576250)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "tokenSigningTitle", value)

    @builtins.property
    @jsii.member(jsii_name="useOriginalAsA")
    def use_original_as_a(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOriginalAsA"))

    @use_original_as_a.setter
    def use_original_as_a(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__490d566527be68d51c8192426f4ec34f7c02626ccb87ab2379936e2912aecdbe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOriginalAsA", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2655c424d914b3d677ab2ea6cb4ef9529e87b18c55f4cb90da9283168b27252)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId1")
    def verification_key_id1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId1"))

    @verification_key_id1.setter
    def verification_key_id1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__94ab60e0e24b33485c7944fa401f36314a60283e195c7c8b59c256014af11b27)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationKeyId2")
    def verification_key_id2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationKeyId2"))

    @verification_key_id2.setter
    def verification_key_id2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__180901bf65b061e36dc5adebcc51b55fb5be2b0551f4f6ea5791e4740a02197e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationKeyId2", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey1")
    def verification_public_key1(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey1"))

    @verification_public_key1.setter
    def verification_public_key1(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__988f076dc860e3047bc186879f7763b0a9fa68a4b2da4fb73fb3ecd4166c0164)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey1", value)

    @builtins.property
    @jsii.member(jsii_name="verificationPublicKey2")
    def verification_public_key2(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "verificationPublicKey2"))

    @verification_public_key2.setter
    def verification_public_key2(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__581dd51ced9c88514e4a84b9c017a689733d66f3be2d6e838c80c4072be5fe5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "verificationPublicKey2", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d86ba62545f6ce4495fb7205e8af4a42ac90051d5734ea03f57e3c2260d4df16)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall",
    jsii_struct_bases=[],
    name_mapping={
        "firewall_configuration": "firewallConfiguration",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall:
    def __init__(
        self,
        *,
        firewall_configuration: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration", typing.Dict[builtins.str, typing.Any]]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param firewall_configuration: firewall_configuration block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if isinstance(firewall_configuration, dict):
            firewall_configuration = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration(**firewall_configuration)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9865256312a59f84c24c2a1b788e61ade03f90bf585ecf16ed7802882a6ed41e)
            check_type(argname="argument firewall_configuration", value=firewall_configuration, expected_type=type_hints["firewall_configuration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if firewall_configuration is not None:
            self._values["firewall_configuration"] = firewall_configuration
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def firewall_configuration(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration"]:
        '''firewall_configuration block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#firewall_configuration DataAkamaiPropertyRulesBuilder#firewall_configuration}
        '''
        result = self._values.get("firewall_configuration")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration"], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration",
    jsii_struct_bases=[],
    name_mapping={
        "config_id": "configId",
        "file_name": "fileName",
        "production_status": "productionStatus",
        "production_version": "productionVersion",
        "staging_status": "stagingStatus",
        "staging_version": "stagingVersion",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration:
    def __init__(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6661fb572c91f629da7e573df3f64ca50004a937ac31bd628e4a6e3afeef7098)
            check_type(argname="argument config_id", value=config_id, expected_type=type_hints["config_id"])
            check_type(argname="argument file_name", value=file_name, expected_type=type_hints["file_name"])
            check_type(argname="argument production_status", value=production_status, expected_type=type_hints["production_status"])
            check_type(argname="argument production_version", value=production_version, expected_type=type_hints["production_version"])
            check_type(argname="argument staging_status", value=staging_status, expected_type=type_hints["staging_status"])
            check_type(argname="argument staging_version", value=staging_version, expected_type=type_hints["staging_version"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_id is not None:
            self._values["config_id"] = config_id
        if file_name is not None:
            self._values["file_name"] = file_name
        if production_status is not None:
            self._values["production_status"] = production_status
        if production_version is not None:
            self._values["production_version"] = production_version
        if staging_status is not None:
            self._values["staging_status"] = staging_status
        if staging_version is not None:
            self._values["staging_version"] = staging_version

    @builtins.property
    def config_id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.'''
        result = self._values.get("config_id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def file_name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        '''
        result = self._values.get("file_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        '''
        result = self._values.get("production_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def production_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        '''
        result = self._values.get("production_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def staging_status(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        '''
        result = self._values.get("staging_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def staging_version(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        result = self._values.get("staging_version")
        return typing.cast(typing.Optional[jsii.Number], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfigurationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__103b085d171185bef0556f878cd7bdd1b112d7d5044942812d667862e55b1a91)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigId")
    def reset_config_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigId", []))

    @jsii.member(jsii_name="resetFileName")
    def reset_file_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileName", []))

    @jsii.member(jsii_name="resetProductionStatus")
    def reset_production_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionStatus", []))

    @jsii.member(jsii_name="resetProductionVersion")
    def reset_production_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProductionVersion", []))

    @jsii.member(jsii_name="resetStagingStatus")
    def reset_staging_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingStatus", []))

    @jsii.member(jsii_name="resetStagingVersion")
    def reset_staging_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStagingVersion", []))

    @builtins.property
    @jsii.member(jsii_name="configIdInput")
    def config_id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "configIdInput"))

    @builtins.property
    @jsii.member(jsii_name="fileNameInput")
    def file_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fileNameInput"))

    @builtins.property
    @jsii.member(jsii_name="productionStatusInput")
    def production_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "productionStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="productionVersionInput")
    def production_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "productionVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingStatusInput")
    def staging_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stagingStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="stagingVersionInput")
    def staging_version_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "stagingVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="configId")
    def config_id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "configId"))

    @config_id.setter
    def config_id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b6d6da236d97ee41006ddfdf467a34aa8a8c2593d2df112b8ade2be39327be14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configId", value)

    @builtins.property
    @jsii.member(jsii_name="fileName")
    def file_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "fileName"))

    @file_name.setter
    def file_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad7f697de0dba5767a7304300f8bd471eecaeb8a94f499c737a29e321b8e562d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "fileName", value)

    @builtins.property
    @jsii.member(jsii_name="productionStatus")
    def production_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "productionStatus"))

    @production_status.setter
    def production_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cc9f6d3114d8d32bf667a2b2f1b6626c5483e864497936355ee1034681af908)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionStatus", value)

    @builtins.property
    @jsii.member(jsii_name="productionVersion")
    def production_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "productionVersion"))

    @production_version.setter
    def production_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bdba29fb792820fdf6b6e4ac047097e80e6eda90732e36193c4bd8c4457bb41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "productionVersion", value)

    @builtins.property
    @jsii.member(jsii_name="stagingStatus")
    def staging_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stagingStatus"))

    @staging_status.setter
    def staging_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c568165fc4c8c8b42eb536c3b6410e0a6f74d309dc0a183b0fd878b64f32265e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingStatus", value)

    @builtins.property
    @jsii.member(jsii_name="stagingVersion")
    def staging_version(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "stagingVersion"))

    @staging_version.setter
    def staging_version(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32dcb0c9a697266b3abae2a33a479904b012c3fb1835abadf1c776a377ff4ced)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stagingVersion", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e44ad29165e558fbbf057a7b8d146403edb2854dffbc88106bbdd9562712b57b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__74c6ca56eef25bd53419a804ab4c7c1a540189af89618dd0ca863d7bb901a5a3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putFirewallConfiguration")
    def put_firewall_configuration(
        self,
        *,
        config_id: typing.Optional[jsii.Number] = None,
        file_name: typing.Optional[builtins.str] = None,
        production_status: typing.Optional[builtins.str] = None,
        production_version: typing.Optional[jsii.Number] = None,
        staging_status: typing.Optional[builtins.str] = None,
        staging_version: typing.Optional[jsii.Number] = None,
    ) -> None:
        '''
        :param config_id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_id DataAkamaiPropertyRulesBuilder#config_id}.
        :param file_name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_name DataAkamaiPropertyRulesBuilder#file_name}
        :param production_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_status DataAkamaiPropertyRulesBuilder#production_status}
        :param production_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#production_version DataAkamaiPropertyRulesBuilder#production_version}
        :param staging_status: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_status DataAkamaiPropertyRulesBuilder#staging_status}
        :param staging_version: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#staging_version DataAkamaiPropertyRulesBuilder#staging_version}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration(
            config_id=config_id,
            file_name=file_name,
            production_status=production_status,
            production_version=production_version,
            staging_status=staging_status,
            staging_version=staging_version,
        )

        return typing.cast(None, jsii.invoke(self, "putFirewallConfiguration", [value]))

    @jsii.member(jsii_name="resetFirewallConfiguration")
    def reset_firewall_configuration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFirewallConfiguration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="firewallConfiguration")
    def firewall_configuration(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfigurationOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfigurationOutputReference, jsii.get(self, "firewallConfiguration"))

    @builtins.property
    @jsii.member(jsii_name="firewallConfigurationInput")
    def firewall_configuration_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration], jsii.get(self, "firewallConfigurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e98ba9c83a3cb2a73429dd6c49b246846ddf9339e22109b0e3755283dc0ab64)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf4f9818033775199d44748f3dca2d56e6c86789e1ab7da7588c32d93308aaa2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8aac6f101bc9c91cb566e2ae954702d911ab08817d3b4b9e3e58bfd1d2853daf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6cc2deb9ca764e03c7d8379793ea448ed0a669dfd8083e3d64a538b02af96de)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables WebSocket traffic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d483a73632d55d341e3ff042888917815c86f920f207bb08b286e15e8f48139d)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables WebSocket traffic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSocketsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSocketsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9cad92f477d0f1d05bdd5ce063290e54793bfa2732976123350d0a94ce3ea7e0)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b774dee5d0aa547842591229888cebb2fe69364c083284ce220b4d6e98139ff4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0439f0e20265fbd8ff6963ccaef4515743df665d9cb92eb8a8210e69661c5c24)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2535d0ee517b0ef617131def027af2e88c28367cc2f174ebaf3fe8c7b7c201cb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f636bd5aa66dd845990bd61aba881e72dbadf480dd2baa571a4ffc41da27b886)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e7443f88f02c5d105e461c98fd79946407caf18060d70e27c011e539c52353dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav",
    jsii_struct_bases=[],
    name_mapping={
        "enabled": "enabled",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav:
    def __init__(
        self,
        *,
        enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enabled: Enables the WebDAV behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce4bf29dd10cac4f6b947fd220eaa077dc6555f4bdba7073c72d5ba4c678a87)
            check_type(argname="argument enabled", value=enabled, expected_type=type_hints["enabled"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enabled is not None:
            self._values["enabled"] = enabled
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enabled(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Enables the WebDAV behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enabled DataAkamaiPropertyRulesBuilder#enabled}
        '''
        result = self._values.get("enabled")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdavOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdavOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__934194c0b64aa72032a27509a7379dcd2f696bfb47bdce044357166128c031af)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnabled")
    def reset_enabled(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnabled", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enabledInput")
    def enabled_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enabledInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enabled")
    def enabled(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enabled"))

    @enabled.setter
    def enabled(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25dc1f3410b1b4591290e44425b82dff6801e115d946ab99466ea035536cc05f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enabled", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__acb9821572e47e434baf0ca3f67b575155e48d00276fae5504fe6023f50224f8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39990c5faa586b4423c46721ac48e6d8682fbb195da4c1d9993b53ca3d5c336d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cfdee8b0402fe414077c973f4a640f78d1496d2ca7847449586927aa1a6dc0a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d87f994b5183f4d5bee4120b2222dd83cf0e55007c1005c6acdd25c5c9dd1c11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109Criterion",
    jsii_struct_bases=[],
    name_mapping={
        "advanced_im_match": "advancedImMatch",
        "bucket": "bucket",
        "cacheability": "cacheability",
        "china_cdn_region": "chinaCdnRegion",
        "client_certificate": "clientCertificate",
        "client_ip": "clientIp",
        "client_ip_version": "clientIpVersion",
        "cloudlets_origin": "cloudletsOrigin",
        "content_delivery_network": "contentDeliveryNetwork",
        "content_type": "contentType",
        "device_characteristic": "deviceCharacteristic",
        "ecmd_auth_groups": "ecmdAuthGroups",
        "ecmd_auth_scheme": "ecmdAuthScheme",
        "ecmd_is_authenticated": "ecmdIsAuthenticated",
        "ecmd_username": "ecmdUsername",
        "edge_workers_failure": "edgeWorkersFailure",
        "file_extension": "fileExtension",
        "filename": "filename",
        "hostname": "hostname",
        "match_advanced": "matchAdvanced",
        "match_cp_code": "matchCpCode",
        "match_response_code": "matchResponseCode",
        "match_variable": "matchVariable",
        "metadata_stage": "metadataStage",
        "origin_timeout": "originTimeout",
        "path": "path",
        "query_string_parameter": "queryStringParameter",
        "random": "random",
        "recovery_config": "recoveryConfig",
        "regular_expression": "regularExpression",
        "request_cookie": "requestCookie",
        "request_header": "requestHeader",
        "request_method": "requestMethod",
        "request_protocol": "requestProtocol",
        "request_type": "requestType",
        "response_header": "responseHeader",
        "server_location": "serverLocation",
        "time": "time",
        "token_authorization": "tokenAuthorization",
        "user_agent": "userAgent",
        "user_location": "userLocation",
        "user_network": "userNetwork",
        "variable_error": "variableError",
        "virtual_waiting_room_request": "virtualWaitingRoomRequest",
        "visitor_prioritization_request": "visitorPrioritizationRequest",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109Criterion:
    def __init__(
        self,
        *,
        advanced_im_match: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch", typing.Dict[builtins.str, typing.Any]]] = None,
        bucket: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket", typing.Dict[builtins.str, typing.Any]]] = None,
        cacheability: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability", typing.Dict[builtins.str, typing.Any]]] = None,
        china_cdn_region: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion", typing.Dict[builtins.str, typing.Any]]] = None,
        client_certificate: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp", typing.Dict[builtins.str, typing.Any]]] = None,
        client_ip_version: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion", typing.Dict[builtins.str, typing.Any]]] = None,
        cloudlets_origin: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin", typing.Dict[builtins.str, typing.Any]]] = None,
        content_delivery_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        content_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType", typing.Dict[builtins.str, typing.Any]]] = None,
        device_characteristic: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_groups: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_auth_scheme: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_is_authenticated: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated", typing.Dict[builtins.str, typing.Any]]] = None,
        ecmd_username: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername", typing.Dict[builtins.str, typing.Any]]] = None,
        edge_workers_failure: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure", typing.Dict[builtins.str, typing.Any]]] = None,
        file_extension: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension", typing.Dict[builtins.str, typing.Any]]] = None,
        filename: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename", typing.Dict[builtins.str, typing.Any]]] = None,
        hostname: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname", typing.Dict[builtins.str, typing.Any]]] = None,
        match_advanced: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced", typing.Dict[builtins.str, typing.Any]]] = None,
        match_cp_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_response_code: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode", typing.Dict[builtins.str, typing.Any]]] = None,
        match_variable: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable", typing.Dict[builtins.str, typing.Any]]] = None,
        metadata_stage: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage", typing.Dict[builtins.str, typing.Any]]] = None,
        origin_timeout: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout", typing.Dict[builtins.str, typing.Any]]] = None,
        path: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath", typing.Dict[builtins.str, typing.Any]]] = None,
        query_string_parameter: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter", typing.Dict[builtins.str, typing.Any]]] = None,
        random: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom", typing.Dict[builtins.str, typing.Any]]] = None,
        recovery_config: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig", typing.Dict[builtins.str, typing.Any]]] = None,
        regular_expression: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression", typing.Dict[builtins.str, typing.Any]]] = None,
        request_cookie: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie", typing.Dict[builtins.str, typing.Any]]] = None,
        request_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        request_method: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod", typing.Dict[builtins.str, typing.Any]]] = None,
        request_protocol: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol", typing.Dict[builtins.str, typing.Any]]] = None,
        request_type: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType", typing.Dict[builtins.str, typing.Any]]] = None,
        response_header: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader", typing.Dict[builtins.str, typing.Any]]] = None,
        server_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        time: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime", typing.Dict[builtins.str, typing.Any]]] = None,
        token_authorization: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization", typing.Dict[builtins.str, typing.Any]]] = None,
        user_agent: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent", typing.Dict[builtins.str, typing.Any]]] = None,
        user_location: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation", typing.Dict[builtins.str, typing.Any]]] = None,
        user_network: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork", typing.Dict[builtins.str, typing.Any]]] = None,
        variable_error: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError", typing.Dict[builtins.str, typing.Any]]] = None,
        virtual_waiting_room_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest", typing.Dict[builtins.str, typing.Any]]] = None,
        visitor_prioritization_request: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param advanced_im_match: advanced_im_match block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        :param bucket: bucket block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param cacheability: cacheability block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        :param china_cdn_region: china_cdn_region block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        :param client_certificate: client_certificate block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        :param client_ip: client_ip block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        :param client_ip_version: client_ip_version block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        :param cloudlets_origin: cloudlets_origin block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        :param content_delivery_network: content_delivery_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        :param content_type: content_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        :param device_characteristic: device_characteristic block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        :param ecmd_auth_groups: ecmd_auth_groups block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        :param ecmd_auth_scheme: ecmd_auth_scheme block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        :param ecmd_is_authenticated: ecmd_is_authenticated block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        :param ecmd_username: ecmd_username block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        :param edge_workers_failure: edge_workers_failure block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        :param file_extension: file_extension block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        :param filename: filename block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        :param hostname: hostname block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        :param match_advanced: match_advanced block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        :param match_cp_code: match_cp_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        :param match_response_code: match_response_code block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        :param match_variable: match_variable block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        :param metadata_stage: metadata_stage block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        :param origin_timeout: origin_timeout block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        :param path: path block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        :param query_string_parameter: query_string_parameter block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        :param random: random block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        :param recovery_config: recovery_config block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        :param regular_expression: regular_expression block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        :param request_cookie: request_cookie block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        :param request_header: request_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        :param request_method: request_method block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        :param request_protocol: request_protocol block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        :param request_type: request_type block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        :param response_header: response_header block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        :param server_location: server_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        :param time: time block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        :param token_authorization: token_authorization block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        :param user_agent: user_agent block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        :param user_location: user_location block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        :param user_network: user_network block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        :param variable_error: variable_error block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        :param virtual_waiting_room_request: virtual_waiting_room_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        :param visitor_prioritization_request: visitor_prioritization_request block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        if isinstance(advanced_im_match, dict):
            advanced_im_match = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch(**advanced_im_match)
        if isinstance(bucket, dict):
            bucket = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket(**bucket)
        if isinstance(cacheability, dict):
            cacheability = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability(**cacheability)
        if isinstance(china_cdn_region, dict):
            china_cdn_region = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion(**china_cdn_region)
        if isinstance(client_certificate, dict):
            client_certificate = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate(**client_certificate)
        if isinstance(client_ip, dict):
            client_ip = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp(**client_ip)
        if isinstance(client_ip_version, dict):
            client_ip_version = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion(**client_ip_version)
        if isinstance(cloudlets_origin, dict):
            cloudlets_origin = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin(**cloudlets_origin)
        if isinstance(content_delivery_network, dict):
            content_delivery_network = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork(**content_delivery_network)
        if isinstance(content_type, dict):
            content_type = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType(**content_type)
        if isinstance(device_characteristic, dict):
            device_characteristic = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic(**device_characteristic)
        if isinstance(ecmd_auth_groups, dict):
            ecmd_auth_groups = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups(**ecmd_auth_groups)
        if isinstance(ecmd_auth_scheme, dict):
            ecmd_auth_scheme = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme(**ecmd_auth_scheme)
        if isinstance(ecmd_is_authenticated, dict):
            ecmd_is_authenticated = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated(**ecmd_is_authenticated)
        if isinstance(ecmd_username, dict):
            ecmd_username = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername(**ecmd_username)
        if isinstance(edge_workers_failure, dict):
            edge_workers_failure = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure(**edge_workers_failure)
        if isinstance(file_extension, dict):
            file_extension = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension(**file_extension)
        if isinstance(filename, dict):
            filename = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename(**filename)
        if isinstance(hostname, dict):
            hostname = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname(**hostname)
        if isinstance(match_advanced, dict):
            match_advanced = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced(**match_advanced)
        if isinstance(match_cp_code, dict):
            match_cp_code = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode(**match_cp_code)
        if isinstance(match_response_code, dict):
            match_response_code = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode(**match_response_code)
        if isinstance(match_variable, dict):
            match_variable = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable(**match_variable)
        if isinstance(metadata_stage, dict):
            metadata_stage = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage(**metadata_stage)
        if isinstance(origin_timeout, dict):
            origin_timeout = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout(**origin_timeout)
        if isinstance(path, dict):
            path = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath(**path)
        if isinstance(query_string_parameter, dict):
            query_string_parameter = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter(**query_string_parameter)
        if isinstance(random, dict):
            random = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom(**random)
        if isinstance(recovery_config, dict):
            recovery_config = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig(**recovery_config)
        if isinstance(regular_expression, dict):
            regular_expression = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression(**regular_expression)
        if isinstance(request_cookie, dict):
            request_cookie = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie(**request_cookie)
        if isinstance(request_header, dict):
            request_header = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader(**request_header)
        if isinstance(request_method, dict):
            request_method = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod(**request_method)
        if isinstance(request_protocol, dict):
            request_protocol = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol(**request_protocol)
        if isinstance(request_type, dict):
            request_type = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType(**request_type)
        if isinstance(response_header, dict):
            response_header = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader(**response_header)
        if isinstance(server_location, dict):
            server_location = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation(**server_location)
        if isinstance(time, dict):
            time = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime(**time)
        if isinstance(token_authorization, dict):
            token_authorization = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization(**token_authorization)
        if isinstance(user_agent, dict):
            user_agent = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent(**user_agent)
        if isinstance(user_location, dict):
            user_location = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation(**user_location)
        if isinstance(user_network, dict):
            user_network = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork(**user_network)
        if isinstance(variable_error, dict):
            variable_error = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError(**variable_error)
        if isinstance(virtual_waiting_room_request, dict):
            virtual_waiting_room_request = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest(**virtual_waiting_room_request)
        if isinstance(visitor_prioritization_request, dict):
            visitor_prioritization_request = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest(**visitor_prioritization_request)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bde48029c8efb5a283ce37a912bf4776eca5f2e4547a0f98882ed31a2cc780a)
            check_type(argname="argument advanced_im_match", value=advanced_im_match, expected_type=type_hints["advanced_im_match"])
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument cacheability", value=cacheability, expected_type=type_hints["cacheability"])
            check_type(argname="argument china_cdn_region", value=china_cdn_region, expected_type=type_hints["china_cdn_region"])
            check_type(argname="argument client_certificate", value=client_certificate, expected_type=type_hints["client_certificate"])
            check_type(argname="argument client_ip", value=client_ip, expected_type=type_hints["client_ip"])
            check_type(argname="argument client_ip_version", value=client_ip_version, expected_type=type_hints["client_ip_version"])
            check_type(argname="argument cloudlets_origin", value=cloudlets_origin, expected_type=type_hints["cloudlets_origin"])
            check_type(argname="argument content_delivery_network", value=content_delivery_network, expected_type=type_hints["content_delivery_network"])
            check_type(argname="argument content_type", value=content_type, expected_type=type_hints["content_type"])
            check_type(argname="argument device_characteristic", value=device_characteristic, expected_type=type_hints["device_characteristic"])
            check_type(argname="argument ecmd_auth_groups", value=ecmd_auth_groups, expected_type=type_hints["ecmd_auth_groups"])
            check_type(argname="argument ecmd_auth_scheme", value=ecmd_auth_scheme, expected_type=type_hints["ecmd_auth_scheme"])
            check_type(argname="argument ecmd_is_authenticated", value=ecmd_is_authenticated, expected_type=type_hints["ecmd_is_authenticated"])
            check_type(argname="argument ecmd_username", value=ecmd_username, expected_type=type_hints["ecmd_username"])
            check_type(argname="argument edge_workers_failure", value=edge_workers_failure, expected_type=type_hints["edge_workers_failure"])
            check_type(argname="argument file_extension", value=file_extension, expected_type=type_hints["file_extension"])
            check_type(argname="argument filename", value=filename, expected_type=type_hints["filename"])
            check_type(argname="argument hostname", value=hostname, expected_type=type_hints["hostname"])
            check_type(argname="argument match_advanced", value=match_advanced, expected_type=type_hints["match_advanced"])
            check_type(argname="argument match_cp_code", value=match_cp_code, expected_type=type_hints["match_cp_code"])
            check_type(argname="argument match_response_code", value=match_response_code, expected_type=type_hints["match_response_code"])
            check_type(argname="argument match_variable", value=match_variable, expected_type=type_hints["match_variable"])
            check_type(argname="argument metadata_stage", value=metadata_stage, expected_type=type_hints["metadata_stage"])
            check_type(argname="argument origin_timeout", value=origin_timeout, expected_type=type_hints["origin_timeout"])
            check_type(argname="argument path", value=path, expected_type=type_hints["path"])
            check_type(argname="argument query_string_parameter", value=query_string_parameter, expected_type=type_hints["query_string_parameter"])
            check_type(argname="argument random", value=random, expected_type=type_hints["random"])
            check_type(argname="argument recovery_config", value=recovery_config, expected_type=type_hints["recovery_config"])
            check_type(argname="argument regular_expression", value=regular_expression, expected_type=type_hints["regular_expression"])
            check_type(argname="argument request_cookie", value=request_cookie, expected_type=type_hints["request_cookie"])
            check_type(argname="argument request_header", value=request_header, expected_type=type_hints["request_header"])
            check_type(argname="argument request_method", value=request_method, expected_type=type_hints["request_method"])
            check_type(argname="argument request_protocol", value=request_protocol, expected_type=type_hints["request_protocol"])
            check_type(argname="argument request_type", value=request_type, expected_type=type_hints["request_type"])
            check_type(argname="argument response_header", value=response_header, expected_type=type_hints["response_header"])
            check_type(argname="argument server_location", value=server_location, expected_type=type_hints["server_location"])
            check_type(argname="argument time", value=time, expected_type=type_hints["time"])
            check_type(argname="argument token_authorization", value=token_authorization, expected_type=type_hints["token_authorization"])
            check_type(argname="argument user_agent", value=user_agent, expected_type=type_hints["user_agent"])
            check_type(argname="argument user_location", value=user_location, expected_type=type_hints["user_location"])
            check_type(argname="argument user_network", value=user_network, expected_type=type_hints["user_network"])
            check_type(argname="argument variable_error", value=variable_error, expected_type=type_hints["variable_error"])
            check_type(argname="argument virtual_waiting_room_request", value=virtual_waiting_room_request, expected_type=type_hints["virtual_waiting_room_request"])
            check_type(argname="argument visitor_prioritization_request", value=visitor_prioritization_request, expected_type=type_hints["visitor_prioritization_request"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if advanced_im_match is not None:
            self._values["advanced_im_match"] = advanced_im_match
        if bucket is not None:
            self._values["bucket"] = bucket
        if cacheability is not None:
            self._values["cacheability"] = cacheability
        if china_cdn_region is not None:
            self._values["china_cdn_region"] = china_cdn_region
        if client_certificate is not None:
            self._values["client_certificate"] = client_certificate
        if client_ip is not None:
            self._values["client_ip"] = client_ip
        if client_ip_version is not None:
            self._values["client_ip_version"] = client_ip_version
        if cloudlets_origin is not None:
            self._values["cloudlets_origin"] = cloudlets_origin
        if content_delivery_network is not None:
            self._values["content_delivery_network"] = content_delivery_network
        if content_type is not None:
            self._values["content_type"] = content_type
        if device_characteristic is not None:
            self._values["device_characteristic"] = device_characteristic
        if ecmd_auth_groups is not None:
            self._values["ecmd_auth_groups"] = ecmd_auth_groups
        if ecmd_auth_scheme is not None:
            self._values["ecmd_auth_scheme"] = ecmd_auth_scheme
        if ecmd_is_authenticated is not None:
            self._values["ecmd_is_authenticated"] = ecmd_is_authenticated
        if ecmd_username is not None:
            self._values["ecmd_username"] = ecmd_username
        if edge_workers_failure is not None:
            self._values["edge_workers_failure"] = edge_workers_failure
        if file_extension is not None:
            self._values["file_extension"] = file_extension
        if filename is not None:
            self._values["filename"] = filename
        if hostname is not None:
            self._values["hostname"] = hostname
        if match_advanced is not None:
            self._values["match_advanced"] = match_advanced
        if match_cp_code is not None:
            self._values["match_cp_code"] = match_cp_code
        if match_response_code is not None:
            self._values["match_response_code"] = match_response_code
        if match_variable is not None:
            self._values["match_variable"] = match_variable
        if metadata_stage is not None:
            self._values["metadata_stage"] = metadata_stage
        if origin_timeout is not None:
            self._values["origin_timeout"] = origin_timeout
        if path is not None:
            self._values["path"] = path
        if query_string_parameter is not None:
            self._values["query_string_parameter"] = query_string_parameter
        if random is not None:
            self._values["random"] = random
        if recovery_config is not None:
            self._values["recovery_config"] = recovery_config
        if regular_expression is not None:
            self._values["regular_expression"] = regular_expression
        if request_cookie is not None:
            self._values["request_cookie"] = request_cookie
        if request_header is not None:
            self._values["request_header"] = request_header
        if request_method is not None:
            self._values["request_method"] = request_method
        if request_protocol is not None:
            self._values["request_protocol"] = request_protocol
        if request_type is not None:
            self._values["request_type"] = request_type
        if response_header is not None:
            self._values["response_header"] = response_header
        if server_location is not None:
            self._values["server_location"] = server_location
        if time is not None:
            self._values["time"] = time
        if token_authorization is not None:
            self._values["token_authorization"] = token_authorization
        if user_agent is not None:
            self._values["user_agent"] = user_agent
        if user_location is not None:
            self._values["user_location"] = user_location
        if user_network is not None:
            self._values["user_network"] = user_network
        if variable_error is not None:
            self._values["variable_error"] = variable_error
        if virtual_waiting_room_request is not None:
            self._values["virtual_waiting_room_request"] = virtual_waiting_room_request
        if visitor_prioritization_request is not None:
            self._values["visitor_prioritization_request"] = visitor_prioritization_request

    @builtins.property
    def advanced_im_match(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch"]:
        '''advanced_im_match block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#advanced_im_match DataAkamaiPropertyRulesBuilder#advanced_im_match}
        '''
        result = self._values.get("advanced_im_match")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch"], result)

    @builtins.property
    def bucket(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket"]:
        '''bucket block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket"], result)

    @builtins.property
    def cacheability(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability"]:
        '''cacheability block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cacheability DataAkamaiPropertyRulesBuilder#cacheability}
        '''
        result = self._values.get("cacheability")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability"], result)

    @builtins.property
    def china_cdn_region(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion"]:
        '''china_cdn_region block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#china_cdn_region DataAkamaiPropertyRulesBuilder#china_cdn_region}
        '''
        result = self._values.get("china_cdn_region")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion"], result)

    @builtins.property
    def client_certificate(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate"]:
        '''client_certificate block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_certificate DataAkamaiPropertyRulesBuilder#client_certificate}
        '''
        result = self._values.get("client_certificate")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate"], result)

    @builtins.property
    def client_ip(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp"]:
        '''client_ip block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip DataAkamaiPropertyRulesBuilder#client_ip}
        '''
        result = self._values.get("client_ip")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp"], result)

    @builtins.property
    def client_ip_version(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion"]:
        '''client_ip_version block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#client_ip_version DataAkamaiPropertyRulesBuilder#client_ip_version}
        '''
        result = self._values.get("client_ip_version")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion"], result)

    @builtins.property
    def cloudlets_origin(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin"]:
        '''cloudlets_origin block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cloudlets_origin DataAkamaiPropertyRulesBuilder#cloudlets_origin}
        '''
        result = self._values.get("cloudlets_origin")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin"], result)

    @builtins.property
    def content_delivery_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork"]:
        '''content_delivery_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_delivery_network DataAkamaiPropertyRulesBuilder#content_delivery_network}
        '''
        result = self._values.get("content_delivery_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork"], result)

    @builtins.property
    def content_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType"]:
        '''content_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#content_type DataAkamaiPropertyRulesBuilder#content_type}
        '''
        result = self._values.get("content_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType"], result)

    @builtins.property
    def device_characteristic(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic"]:
        '''device_characteristic block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#device_characteristic DataAkamaiPropertyRulesBuilder#device_characteristic}
        '''
        result = self._values.get("device_characteristic")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic"], result)

    @builtins.property
    def ecmd_auth_groups(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups"]:
        '''ecmd_auth_groups block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_groups DataAkamaiPropertyRulesBuilder#ecmd_auth_groups}
        '''
        result = self._values.get("ecmd_auth_groups")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups"], result)

    @builtins.property
    def ecmd_auth_scheme(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme"]:
        '''ecmd_auth_scheme block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_auth_scheme DataAkamaiPropertyRulesBuilder#ecmd_auth_scheme}
        '''
        result = self._values.get("ecmd_auth_scheme")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme"], result)

    @builtins.property
    def ecmd_is_authenticated(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated"]:
        '''ecmd_is_authenticated block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_is_authenticated DataAkamaiPropertyRulesBuilder#ecmd_is_authenticated}
        '''
        result = self._values.get("ecmd_is_authenticated")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated"], result)

    @builtins.property
    def ecmd_username(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername"]:
        '''ecmd_username block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#ecmd_username DataAkamaiPropertyRulesBuilder#ecmd_username}
        '''
        result = self._values.get("ecmd_username")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername"], result)

    @builtins.property
    def edge_workers_failure(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure"]:
        '''edge_workers_failure block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#edge_workers_failure DataAkamaiPropertyRulesBuilder#edge_workers_failure}
        '''
        result = self._values.get("edge_workers_failure")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure"], result)

    @builtins.property
    def file_extension(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension"]:
        '''file_extension block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#file_extension DataAkamaiPropertyRulesBuilder#file_extension}
        '''
        result = self._values.get("file_extension")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension"], result)

    @builtins.property
    def filename(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename"]:
        '''filename block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#filename DataAkamaiPropertyRulesBuilder#filename}
        '''
        result = self._values.get("filename")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename"], result)

    @builtins.property
    def hostname(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname"]:
        '''hostname block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hostname DataAkamaiPropertyRulesBuilder#hostname}
        '''
        result = self._values.get("hostname")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname"], result)

    @builtins.property
    def match_advanced(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced"]:
        '''match_advanced block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_advanced DataAkamaiPropertyRulesBuilder#match_advanced}
        '''
        result = self._values.get("match_advanced")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced"], result)

    @builtins.property
    def match_cp_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode"]:
        '''match_cp_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_cp_code DataAkamaiPropertyRulesBuilder#match_cp_code}
        '''
        result = self._values.get("match_cp_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode"], result)

    @builtins.property
    def match_response_code(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode"]:
        '''match_response_code block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_response_code DataAkamaiPropertyRulesBuilder#match_response_code}
        '''
        result = self._values.get("match_response_code")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode"], result)

    @builtins.property
    def match_variable(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable"]:
        '''match_variable block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_variable DataAkamaiPropertyRulesBuilder#match_variable}
        '''
        result = self._values.get("match_variable")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable"], result)

    @builtins.property
    def metadata_stage(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage"]:
        '''metadata_stage block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#metadata_stage DataAkamaiPropertyRulesBuilder#metadata_stage}
        '''
        result = self._values.get("metadata_stage")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage"], result)

    @builtins.property
    def origin_timeout(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout"]:
        '''origin_timeout block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_timeout DataAkamaiPropertyRulesBuilder#origin_timeout}
        '''
        result = self._values.get("origin_timeout")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout"], result)

    @builtins.property
    def path(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath"]:
        '''path block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#path DataAkamaiPropertyRulesBuilder#path}
        '''
        result = self._values.get("path")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath"], result)

    @builtins.property
    def query_string_parameter(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter"]:
        '''query_string_parameter block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#query_string_parameter DataAkamaiPropertyRulesBuilder#query_string_parameter}
        '''
        result = self._values.get("query_string_parameter")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter"], result)

    @builtins.property
    def random(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom"]:
        '''random block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#random DataAkamaiPropertyRulesBuilder#random}
        '''
        result = self._values.get("random")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom"], result)

    @builtins.property
    def recovery_config(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig"]:
        '''recovery_config block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#recovery_config DataAkamaiPropertyRulesBuilder#recovery_config}
        '''
        result = self._values.get("recovery_config")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig"], result)

    @builtins.property
    def regular_expression(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression"]:
        '''regular_expression block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regular_expression DataAkamaiPropertyRulesBuilder#regular_expression}
        '''
        result = self._values.get("regular_expression")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression"], result)

    @builtins.property
    def request_cookie(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie"]:
        '''request_cookie block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_cookie DataAkamaiPropertyRulesBuilder#request_cookie}
        '''
        result = self._values.get("request_cookie")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie"], result)

    @builtins.property
    def request_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader"]:
        '''request_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_header DataAkamaiPropertyRulesBuilder#request_header}
        '''
        result = self._values.get("request_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader"], result)

    @builtins.property
    def request_method(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod"]:
        '''request_method block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_method DataAkamaiPropertyRulesBuilder#request_method}
        '''
        result = self._values.get("request_method")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod"], result)

    @builtins.property
    def request_protocol(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol"]:
        '''request_protocol block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_protocol DataAkamaiPropertyRulesBuilder#request_protocol}
        '''
        result = self._values.get("request_protocol")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol"], result)

    @builtins.property
    def request_type(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType"]:
        '''request_type block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#request_type DataAkamaiPropertyRulesBuilder#request_type}
        '''
        result = self._values.get("request_type")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType"], result)

    @builtins.property
    def response_header(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader"]:
        '''response_header block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#response_header DataAkamaiPropertyRulesBuilder#response_header}
        '''
        result = self._values.get("response_header")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader"], result)

    @builtins.property
    def server_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation"]:
        '''server_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#server_location DataAkamaiPropertyRulesBuilder#server_location}
        '''
        result = self._values.get("server_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation"], result)

    @builtins.property
    def time(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime"]:
        '''time block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#time DataAkamaiPropertyRulesBuilder#time}
        '''
        result = self._values.get("time")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime"], result)

    @builtins.property
    def token_authorization(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization"]:
        '''token_authorization block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#token_authorization DataAkamaiPropertyRulesBuilder#token_authorization}
        '''
        result = self._values.get("token_authorization")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization"], result)

    @builtins.property
    def user_agent(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent"]:
        '''user_agent block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_agent DataAkamaiPropertyRulesBuilder#user_agent}
        '''
        result = self._values.get("user_agent")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent"], result)

    @builtins.property
    def user_location(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation"]:
        '''user_location block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_location DataAkamaiPropertyRulesBuilder#user_location}
        '''
        result = self._values.get("user_location")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation"], result)

    @builtins.property
    def user_network(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork"]:
        '''user_network block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#user_network DataAkamaiPropertyRulesBuilder#user_network}
        '''
        result = self._values.get("user_network")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork"], result)

    @builtins.property
    def variable_error(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError"]:
        '''variable_error block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_error DataAkamaiPropertyRulesBuilder#variable_error}
        '''
        result = self._values.get("variable_error")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError"], result)

    @builtins.property
    def virtual_waiting_room_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest"]:
        '''virtual_waiting_room_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#virtual_waiting_room_request DataAkamaiPropertyRulesBuilder#virtual_waiting_room_request}
        '''
        result = self._values.get("virtual_waiting_room_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest"], result)

    @builtins.property
    def visitor_prioritization_request(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest"]:
        '''visitor_prioritization_request block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#visitor_prioritization_request DataAkamaiPropertyRulesBuilder#visitor_prioritization_request}
        '''
        result = self._values.get("visitor_prioritization_request")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109Criterion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9252ac1c14ac359198bd07c7d1355770f6e36e80818ad00b42f2f00aa31e01c6)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatchOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatchOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__23e7b509349e9aa91b6e0c4872875fee908b05e264c2eff1b715a7d042a904c9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7031a3f6a65dc8d564686be6b569cb232adb4180807c093a479a81a0d97b10d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69ca5fdb1c56496ff1014a1dade7b28403343780db2a5cbecb44f7b43a3fff99)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5295265b7bd2c80b158e2c84cb102100b7081794b93389829034e0a01f31acd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3f3d0f01c2d93e751938ea591bf95ff7e1655aaac4e6559eb4efb79bfc890c76)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__440c2186e20d0e911efb5309630aea896dcfd44ae668d8bb7d071791014a1160)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9e2ddc089a7e8ef8549b2d8c35afc0e301249dc6644a22b99ae6e0f8eaafd0d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "percentage": "percentage",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9463c8b57c4aa4fe260b9d3e94427009e2561578048a32a215eeca89874ce51e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument percentage", value=percentage, expected_type=type_hints["percentage"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if percentage is not None:
            self._values["percentage"] = percentage
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def percentage(self) -> typing.Optional[jsii.Number]:
        '''Specifies the percentage of requests to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        '''
        result = self._values.get("percentage")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucketOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucketOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d92598fe3548c1091621fc0b6702f92a841ca8b8a1df4ebdea41d89e383f58)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetPercentage")
    def reset_percentage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPercentage", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="percentageInput")
    def percentage_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "percentageInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__53091059ce6b698d7462a22df0ddb73d34b283a4a1c088eb5e7b57300ad9bc55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="percentage")
    def percentage(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "percentage"))

    @percentage.setter
    def percentage(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87ae1aa9a8a79dc8243348d49005da6767214fdab1b0e146cade127861305646)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "percentage", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__27386074b0bcccaf104da5d7461aba21801789bf45f4cb81ff185d2e808df826)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab7e5f0b138198f782847071b555032896af80878926e40097b4fa94a77fd992)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2094ce02fed5b6cb1b7e86dfbd659e026c1e903b488e40a03e4a2bc6147ae94a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2c713882c20597c4fb92ceb3e69bc7101e15755b19b86678139473354d8ae7c8)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``).

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheabilityOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheabilityOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3b76c973f9506ec344babd656c4439e22713b9c9eeed3b3e05bcba6f723921d5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__749c13bb25e16a6ad68c40375b34f6f8630e53de522d4aab413ffd6bfb9a26a6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7d29817503549c9598516e74c1a657e68f8eb2a6ce33ecadabc4c81fab3a83aa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6e9d73bd022b7a0a11a0a28469791412e006af0bb2a24c2625e77885383352c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__29f25da768a5ee38372377df760fafb0648014741b8b910f42389b7c5e92c13b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d1683ee75ffd3f9f08caf2f80898f183275fcf6d79f25943c985f51ddb22d56)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dc0e20e46c95904f5723c31a47a595adb27cdc0d6172be914fe1559d0801519)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__035bc3e495da6f6f51e9b168dbd56162bee4dd978ae64dfbbbb8a14ec29f0226)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5b018edc1af1c99cfbd0842f13f51b5889667954ad9ade359334afc6c249e7f2)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a8b7610b917e9bed46d745fad6d0e127fb92e19a912983ba07cf6e4d782e2c89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5bdcf61a7e25ab1be5beb81390d889e3e1cc76d0166d6f52e75614b67e5b4dd3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca1489fd58e616026b482a5b9365829c25a088547ba315a8b9ef399df181fd8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__01b565e6dacdde29e6d292d5efcd335c3e0efb188acd71bb69d791716316b72d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da378f1e36ae0c51c5764ca1426c2d099587bfaae0941911dc70b78a979e6279)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate",
    jsii_struct_bases=[],
    name_mapping={
        "enforce_mtls": "enforceMtls",
        "is_certificate_present": "isCertificatePresent",
        "is_certificate_valid": "isCertificateValid",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate:
    def __init__(
        self,
        *,
        enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enforce_mtls: Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail. Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__706f56c47fddc01fc8a64fc501a62d11fc7f038dcaa2b2d0fd29a82890f2d534)
            check_type(argname="argument enforce_mtls", value=enforce_mtls, expected_type=type_hints["enforce_mtls"])
            check_type(argname="argument is_certificate_present", value=is_certificate_present, expected_type=type_hints["is_certificate_present"])
            check_type(argname="argument is_certificate_valid", value=is_certificate_valid, expected_type=type_hints["is_certificate_valid"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if enforce_mtls is not None:
            self._values["enforce_mtls"] = enforce_mtls
        if is_certificate_present is not None:
            self._values["is_certificate_present"] = is_certificate_present
        if is_certificate_valid is not None:
            self._values["is_certificate_valid"] = is_certificate_valid
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def enforce_mtls(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail.

        Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        '''
        result = self._values.get("enforce_mtls")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_present(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Executes rule behaviors only if a client certificate authenticates requests.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        '''
        result = self._values.get("is_certificate_present")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def is_certificate_valid(self) -> typing.Optional[builtins.str]:
        '''Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        '''
        result = self._values.get("is_certificate_valid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificateOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificateOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3015825b3ef8df852b765e9e940592697f79ff900abb474273e670d809a6418)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEnforceMtls")
    def reset_enforce_mtls(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEnforceMtls", []))

    @jsii.member(jsii_name="resetIsCertificatePresent")
    def reset_is_certificate_present(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificatePresent", []))

    @jsii.member(jsii_name="resetIsCertificateValid")
    def reset_is_certificate_valid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsCertificateValid", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="enforceMtlsInput")
    def enforce_mtls_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "enforceMtlsInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresentInput")
    def is_certificate_present_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isCertificatePresentInput"))

    @builtins.property
    @jsii.member(jsii_name="isCertificateValidInput")
    def is_certificate_valid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "isCertificateValidInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="enforceMtls")
    def enforce_mtls(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "enforceMtls"))

    @enforce_mtls.setter
    def enforce_mtls(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bdc04376d428cf6f6785c8e592b03d2f5923ba9c8e5e8bf8ff8412e96ee88b6e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "enforceMtls", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificatePresent")
    def is_certificate_present(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isCertificatePresent"))

    @is_certificate_present.setter
    def is_certificate_present(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9202541e017ab45d370956f6d8c5161874aacb9814863e068ecb8ba1885f625a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificatePresent", value)

    @builtins.property
    @jsii.member(jsii_name="isCertificateValid")
    def is_certificate_valid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "isCertificateValid"))

    @is_certificate_valid.setter
    def is_certificate_valid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6379b8897cf8566230a44ee2d9bbae553ddd4c0d2ce730ba855ac44766315ec2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isCertificateValid", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4c1afcd2975759220c01f0d5fc8181c4df215aee34956f385dee9177245ba11)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca0b246f27becb0d173d4b16ef85141eb5eb97d11563363c1274dfcfecc6da45)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4d02a03c24d17b79bd59e3a06a58f44a20501eff9028601c41d35bc39944526f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feec29facfdaad8fe9424fac96519ced89d5fcf9b912525dd95a911d23349469)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "use_headers": "useHeaders",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eec00cb2affa72070e12870b59ab18452be9c98cd5fa8b81b7d5f5816a88a75e)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_headers", value=use_headers, expected_type=type_hints["use_headers"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_headers is not None:
            self._values["use_headers"] = use_headers
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_headers(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        '''
        result = self._values.get("use_headers")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''IP or CIDR block, for example: ``71.92.0.0/14``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0ee465ffaea7435f4f9e2dfb042bbaee3fe4e3e2db6dce97a6e1e047e6a0651)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseHeaders")
    def reset_use_headers(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseHeaders", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useHeadersInput")
    def use_headers_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useHeadersInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5abbceacf480297eed04289d2c2827bbde5dcdd72583f5ff7b2f71588eaf8070)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a21d35046404e17d9627cda034c013090c95669093e68bacce7766ae439c6230)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df4b9cba95bba5c189a70124fe6491f46d8fb8ec7d52234fa4d5d7b751411b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useHeaders")
    def use_headers(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useHeaders"))

    @use_headers.setter
    def use_headers(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ea79b68c85288072de8fd55e9e8f63272d1ab93c8c8c516feb6196c43f89986d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useHeaders", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f1fd5b3aeb342c7e90191be676731beab3d710f4ff96523d7f0a07ef64f71fdb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aac24541716f4b29bbe633f6492e005ad683d42a07dc975373b55f629d92d33e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5a41d18a333a7d0a0d6b923da436d0059cdc5eb486a1496ac8cbb410950bab6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "use_x_forwarded_for": "useXForwardedFor",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd6918c53312af58b774d4355e344a85b92a3cea95f7609ed6341ad4a81082c6)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_x_forwarded_for", value=use_x_forwarded_for, expected_type=type_hints["use_x_forwarded_for"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_x_forwarded_for is not None:
            self._values["use_x_forwarded_for"] = use_x_forwarded_for
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_x_forwarded_for(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        '''
        result = self._values.get("use_x_forwarded_for")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The IP version of the client request, either ``IPV4`` or ``IPV6``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__361437516a63bc5d4b3f512efe1801734f1bd9d336d7f72ba67b3641b6221721)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseXForwardedFor")
    def reset_use_x_forwarded_for(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseXForwardedFor", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useXForwardedForInput")
    def use_x_forwarded_for_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useXForwardedForInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a045c309a0f70c086234b1ae993c6b2cbd2c157e5ba351ec594a3ab7f2a8db7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d67f6f6b0c05a7b6850dbdffc5805e4f91ca6f6c25967a915c4d89c6e2f90332)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useXForwardedFor")
    def use_x_forwarded_for(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useXForwardedFor"))

    @use_x_forwarded_for.setter
    def use_x_forwarded_for(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__57b740a42cf2352100cd7c813998362bc57c40447da5fcd3fab911d7011f1bdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useXForwardedFor", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0e331a95e43483c72dd869fd79d841d5c605cbf060613e5c705d3d4f009236e1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8f8eaa134d0945aecbcaf71a2f1610dc2b09061000c33f3b1dbee01405b59606)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1e1aee421cea361c5907d4ec6966b85186439459d0e359383074b826530b5b69)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "origin_id": "originId",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5629b1c630a26d1f44e6367dde7716b1df754ebac9254eaf3b0ed156cca2e8f3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument origin_id", value=origin_id, expected_type=type_hints["origin_id"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if origin_id is not None:
            self._values["origin_id"] = origin_id
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def origin_id(self) -> typing.Optional[builtins.str]:
        '''The Cloudlets Origins identifier, limited to alphanumeric and underscore characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        '''
        result = self._values.get("origin_id")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOriginOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOriginOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bebeed73ddecdd771885b09654812cec7009ffed59f3719272dd209cade3afff)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOriginId")
    def reset_origin_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginId", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="originIdInput")
    def origin_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "originIdInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__31b08671bf593bcea03e8435fa2ad8764aac1a9f1e34161e3d959049abc873f0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="originId")
    def origin_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "originId"))

    @origin_id.setter
    def origin_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aa6a3da7403e6b01dfc8dc22d9d74a74a2b01fde7c00e0471df70479dbef7c08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "originId", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71abb130f2f1a7e35db2680774cd2025a43fd8aa62064e84665632afd703024c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8e13312f4c4e5af28130003ed349ddcdf241295ce1bf2182681fdd46a5628e23)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87db10858e4b554a2524d8565da43600179f9892f599d5d771491f091b07932a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "network": "network",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__16e08b294641b2fab10c2e62cafb81a92aa8e39ceac324e128dc859963481cd7)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network", value=network, expected_type=type_hints["network"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network is not None:
            self._values["network"] = network
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network(self) -> typing.Optional[builtins.str]:
        '''Match the network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        '''
        result = self._values.get("network")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5569ba7fb971e192cf87f4b8fe0609a59b62e7de245414d2c63018935802931d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetwork")
    def reset_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetwork", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkInput")
    def network_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "networkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d9711a685e48a0461a013640708abfdfed594098e899312118accf2cc939fdcd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2f3d0436dbcda54bf78d1558425fc350c75fac53f3c787756826133235ac4df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="network")
    def network(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "network"))

    @network.setter
    def network(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a6869e6c69d76b6140e5ab8249682a6e7d8a7b825148ddd4d2a0ca5ea6942e5d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "network", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5b089176a0cce5b1aa87cb40bdd489e66fe5430f8215dce5655cb8361a54b1d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4e0878fecc9c954df202115b302af78f680f5e5cb97b73455d9757c01f34bd28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2e4060292019eb4c3aca5d30b72cdd4326395c58ae5638a4a8623582672f38f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a9a3585f0522f062eafb4360b2f66c3dcf6c1ee870039de17d01fbaed645d5e8)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for all ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''``Content-Type`` response header value, for example ``text/html``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__feee33c702f194a5a9e4d07fe6fa7f60722b1ca0c4ea3a67fef8c21c01137d13)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd59f5700c4a5ada5fd77c7124710e48f83a2dbd25ca696cabe404fcedc97f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f7b6848baefac66cce1977326ee042e123dcdc4cd1ca388658ebf1a2bb9409a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1af1f404776715d55218ac2a7f128314400985c839bb99014d8c117eae49bfa)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__208c8af487ab71ae1d0d33fa93fbc130f4b9f070d298dd494ae953882b7b9110)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5e03c8726d23f3b5b14a9c680798da42ec6bb8ce1f8395ef0f8df7c1e5626749)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b23f0bd53e5ebd8bd658f4cc823e4e3a6dacdc67b5375d2667bccc8cc438fb78)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab83b6c4c8d851be935b4838880c2a5c1e34622dcfff8dc0d776dc8556e88f62)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fed06ac5c830b2b9914cb03d8146740db25b73d2571abdd687da1f5bb50706a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic",
    jsii_struct_bases=[],
    name_mapping={
        "boolean_value": "booleanValue",
        "characteristic": "characteristic",
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_wildcard": "matchWildcard",
        "numeric_match_operator": "numericMatchOperator",
        "numeric_value": "numericValue",
        "string_match_operator": "stringMatchOperator",
        "string_value": "stringValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "version_match_operator": "versionMatchOperator",
        "version_value": "versionValue",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic:
    def __init__(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__96993abbefeb91b7fd72e9299276e1a615803a1338532810e8e15e92e56024bb)
            check_type(argname="argument boolean_value", value=boolean_value, expected_type=type_hints["boolean_value"])
            check_type(argname="argument characteristic", value=characteristic, expected_type=type_hints["characteristic"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument numeric_match_operator", value=numeric_match_operator, expected_type=type_hints["numeric_match_operator"])
            check_type(argname="argument numeric_value", value=numeric_value, expected_type=type_hints["numeric_value"])
            check_type(argname="argument string_match_operator", value=string_match_operator, expected_type=type_hints["string_match_operator"])
            check_type(argname="argument string_value", value=string_value, expected_type=type_hints["string_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument version_match_operator", value=version_match_operator, expected_type=type_hints["version_match_operator"])
            check_type(argname="argument version_value", value=version_value, expected_type=type_hints["version_value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if boolean_value is not None:
            self._values["boolean_value"] = boolean_value
        if characteristic is not None:
            self._values["characteristic"] = characteristic
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if numeric_match_operator is not None:
            self._values["numeric_match_operator"] = numeric_match_operator
        if numeric_value is not None:
            self._values["numeric_value"] = numeric_value
        if string_match_operator is not None:
            self._values["string_match_operator"] = string_match_operator
        if string_value is not None:
            self._values["string_value"] = string_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if version_match_operator is not None:
            self._values["version_match_operator"] = version_match_operator
        if version_value is not None:
            self._values["version_value"] = version_value

    @builtins.property
    def boolean_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When the ``characteristic`` expects a boolean value, this specifies the value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        '''
        result = self._values.get("boolean_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def characteristic(self) -> typing.Optional[builtins.str]:
        '''Aspect of the device or browser to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        '''
        result = self._values.get("characteristic")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``stringValue`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def numeric_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        '''
        result = self._values.get("numeric_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def numeric_value(self) -> typing.Optional[jsii.Number]:
        '''When the ``characteristic`` expects a numeric value, this specifies the number.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        '''
        result = self._values.get("numeric_value")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def string_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        '''
        result = self._values.get("string_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def string_value(self) -> typing.Optional[typing.List[builtins.str]]:
        '''When the ``characteristic`` expects a string, this specifies the set of values.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        '''
        result = self._values.get("string_value")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_match_operator(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        '''
        result = self._values.get("version_match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def version_value(self) -> typing.Optional[builtins.str]:
        '''When the ``characteristic`` expects a version number, this specifies it as a string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        result = self._values.get("version_value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristicOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristicOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2aa2ebac18aa0e8c09c959990f76d3ee9bcdee2da0bce3d983e8b9d2456a375)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBooleanValue")
    def reset_boolean_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBooleanValue", []))

    @jsii.member(jsii_name="resetCharacteristic")
    def reset_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCharacteristic", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetNumericMatchOperator")
    def reset_numeric_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericMatchOperator", []))

    @jsii.member(jsii_name="resetNumericValue")
    def reset_numeric_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNumericValue", []))

    @jsii.member(jsii_name="resetStringMatchOperator")
    def reset_string_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringMatchOperator", []))

    @jsii.member(jsii_name="resetStringValue")
    def reset_string_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStringValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVersionMatchOperator")
    def reset_version_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionMatchOperator", []))

    @jsii.member(jsii_name="resetVersionValue")
    def reset_version_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVersionValue", []))

    @builtins.property
    @jsii.member(jsii_name="booleanValueInput")
    def boolean_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "booleanValueInput"))

    @builtins.property
    @jsii.member(jsii_name="characteristicInput")
    def characteristic_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "characteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperatorInput")
    def numeric_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "numericMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="numericValueInput")
    def numeric_value_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "numericValueInput"))

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperatorInput")
    def string_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "stringMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="stringValueInput")
    def string_value_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "stringValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperatorInput")
    def version_match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionMatchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="versionValueInput")
    def version_value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "versionValueInput"))

    @builtins.property
    @jsii.member(jsii_name="booleanValue")
    def boolean_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "booleanValue"))

    @boolean_value.setter
    def boolean_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2a238d724f74bb3ebfb93765cb004464b13de7b81227c470758bf4684f5ff16c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "booleanValue", value)

    @builtins.property
    @jsii.member(jsii_name="characteristic")
    def characteristic(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "characteristic"))

    @characteristic.setter
    def characteristic(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71226ec80afa8846ac0502ba67031216ef5d1db8aad10576376d1d3e210f64cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "characteristic", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__41f1879ed915f5e5cbf27a9bf97e78f2e6332961a041dc8a4f8fd54bdd8beebe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__af7c7a4e5acda2061f04e3c0e85122e36520d6e4b03bd41c1293b87ef3a93c3a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7520194748f7b0d99948e6879a09691c7b94468405383e00bcc12fc57ae58871)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="numericMatchOperator")
    def numeric_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "numericMatchOperator"))

    @numeric_match_operator.setter
    def numeric_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e7efa3485e08e6887366042e3d101c3c84220b1cdb930be23251981d66a4a31)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="numericValue")
    def numeric_value(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "numericValue"))

    @numeric_value.setter
    def numeric_value(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bf5a903afe2dac2754362c8daafd143120935191dd708c0ed9e5b652662d7b08)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "numericValue", value)

    @builtins.property
    @jsii.member(jsii_name="stringMatchOperator")
    def string_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "stringMatchOperator"))

    @string_match_operator.setter
    def string_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6fea624584ee402e65e9620e566b0ff76c9d41166afdf7f65fe21eab454c9c7e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="stringValue")
    def string_value(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "stringValue"))

    @string_value.setter
    def string_value(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b0314d37286a3d6022880e1dbe99a2bd44d9811f5bbebfb060c87a7d406f47f6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "stringValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__700ddfd88eb48d53c7bf8cff28e925240bf58980e7f98bf46a429f9344b285ac)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95d0ba18181a484bdcdec9e32eac60b7b4caf4dd3e6021e4b423c75e3f308bcf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="versionMatchOperator")
    def version_match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionMatchOperator"))

    @version_match_operator.setter
    def version_match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff197ab90e12b169ad4a24f63777f9758ef156ccad231879191cff1e31c6155b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionMatchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="versionValue")
    def version_value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "versionValue"))

    @version_value.setter
    def version_value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__df1bb585ef81a79d76b4a349e3520dc3819debb8a62095f099424a1a836f9e8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "versionValue", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4df0e5b3726f2c0a092fb02ae388821e2da7c6c0f3ccd609f0e8d31263dc0e49)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7837fcd40be05cb7f6ebcbe83404d4533dcddeb9a403f347ac766b26fceaa7ac)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroupsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroupsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e633ccfd5c8a0fb1c1786a71d579e55a0080a667451aeb81dd6b0bb32247a429)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2834a8a9551c777ab82821d97e8d32e290ab9a189364e4e0124e7574a2fc051e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7dd73969628f0a8e6bc2b73c1e47292ef0cf150e2282c29768ea0b49b551aa57)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6c1cc3f4da38b1d7a95580b6917dd359b6526317d360f18811ffe6ab4bbc227b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4dfebf9063349cb961918b57e3bb3900fc7ff893fde21630fbb8cc5341ed380d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed28b23601b39eea14bfa79e95836ddac0a27655221764074060ed2f1034aa39)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55dcb4a476dfae845ef36f335e448199ae2ca65bd90a3937f764d2ec959769d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme",
    jsii_struct_bases=[],
    name_mapping={
        "auth_scheme": "authScheme",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme:
    def __init__(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a77b70a609e50e1ae7243220e7217ae604d5bfe7af2156ccdd46b2af28c0ce35)
            check_type(argname="argument auth_scheme", value=auth_scheme, expected_type=type_hints["auth_scheme"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if auth_scheme is not None:
            self._values["auth_scheme"] = auth_scheme
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def auth_scheme(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.'''
        result = self._values.get("auth_scheme")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthSchemeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthSchemeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91f5a076326eafcf713acf9876464305e2b4d855d7725401d752caea4f5fa07e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetAuthScheme")
    def reset_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAuthScheme", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="authSchemeInput")
    def auth_scheme_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "authSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="authScheme")
    def auth_scheme(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "authScheme"))

    @auth_scheme.setter
    def auth_scheme(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a54b5919adbd78e2f294106573fef5cce3b9a934d3f5b1d7abc775cfe08f7a3b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "authScheme", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0fb32802e6607a5d59eda315d6e6021936430f21e1fdccc802ec6353bbe432b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8082cd1271c40a18ff93901a35304d422f1591a9c86bae2b036c3b19db152e18)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__962d1c0c71237304dcd209fa2532aedeacb3082b488d8523bc584a24ce0b0360)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0ba2bc784d6b9309f082678020c6e9097265deecc53ce3550e2982fb9271be5c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b78390cf1ec683bcd7e9d3b32ae61574aee6bfa0b1ca15185fb7a8e20398205c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticatedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticatedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__604cf6014e4252db350c878e25bc774adfebaef4b06cfdc79b474ebec6c71100)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__861ab2d7d238aecf8b57b8f2b1646e910a65bef4e199ddb4c14b870fa3737f79)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__078649a8fbdd196980d816c86e36c5f76d194a4338f2bdb07b7b917a3e23473c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__421c1a32ceb3fb7e7d1e327ee087ee4e4e2c876e56d283b18d8d0be15ac22641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d73633dd4edfc3bbc8ccee644623a06578d9d319bf93b5071f9deb8eb1a53e5f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aea046ac607903251360a7148c52b95291fed43e5756bc446989d907d7408f87)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername",
    jsii_struct_bases=[],
    name_mapping={
        "length": "length",
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername:
    def __init__(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c9b818e796b190dc2573bd6fd2154b56caa6ad620fdd553d8fb8546d900ceee1)
            check_type(argname="argument length", value=length, expected_type=type_hints["length"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if length is not None:
            self._values["length"] = length
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def length(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.'''
        result = self._values.get("length")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.'''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.'''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsernameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsernameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__08a9c27aacf8c5ae2724cbf2a9629d1d721454fb84017c4714ac698c423b0f4c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLength")
    def reset_length(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLength", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lengthInput")
    def length_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lengthInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="length")
    def length(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "length"))

    @length.setter
    def length(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8a003960615964a69b6cacf3fde0e8fbd29edb246069cedb87f00dc09597e394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "length", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e8ab97ca7fcf317392e992b1066ce9b0569a632fc1f0d388fe30cc4a641745f5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__422c73758c88c7fc6da66431ea6b0eb8b22a15550bb1baedd7103af54b94f63b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d54fe9ff3568a5bc16dc12638c5c6969a140f84647fa089d26cdb6f7efc1b6c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dcdf8c97941179ac4da58146970b2c9e08a493d5460e2c5eb0abcdb4a2d5b68)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5d7e621979396188ccdcc194e39ff05df67c676e309be3f857f39cad9d98ac0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__973e0206f68674fc3a3dc849b29cc4de7087639cbe9baa3c72e264f1b1f806b7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure",
    jsii_struct_bases=[],
    name_mapping={
        "exec_status": "execStatus",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure:
    def __init__(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__98048e3960cc9a1a1ef5551ff53c4788eaf482bac1c192eb7327c6125f04848c)
            check_type(argname="argument exec_status", value=exec_status, expected_type=type_hints["exec_status"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if exec_status is not None:
            self._values["exec_status"] = exec_status
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def exec_status(self) -> typing.Optional[builtins.str]:
        '''Specify execution status.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        '''
        result = self._values.get("exec_status")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailureOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailureOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__034aa5d429a8e1c5cea759921097e45c8ba7210fd3d60a40456554a46ef5f49d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetExecStatus")
    def reset_exec_status(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetExecStatus", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="execStatusInput")
    def exec_status_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "execStatusInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="execStatus")
    def exec_status(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "execStatus"))

    @exec_status.setter
    def exec_status(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71cf88df8a588b8bd0428d37f48316b046f00b6eaf6e8643438ff8e540449df7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "execStatus", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__714b25ace7f5b61a170921b9fa230e9db87ba06cfd4d53a6a910b0779dd9f81c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13493f771088f0abafaea36bb8b8c4400e5abc45ec6713053faf96046c8cc7e6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e997e3b027bd4486ae4c1d21ffe78ae5175d7d2d16f7ca928c5ce18673ead273)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1396b2cb05a89acbef69fca687426b2e2bce61e9863105e93d71d1d7747cf0c3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d4ec59165a97e015d79f2f32b4262e3f37229c70e8002c3cd7bf2eca0690d325)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtensionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtensionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8fb03876612997d2cdf4f134d561b34174f948a79329910c4b5bdcdbfa4e8cb9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3cecbde89a433371134552a5f2119b042d2fb88aa15b41bcd00d77200fcf852)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__832231906d703f79b4774bfcb2382b9ca1033f663f966390568488cb11d32952)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c5632f3aef4b5aea03a5b7385d18e4cc9b6da7cf2f576246f59b47f138f8b74a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f488315d14364cd6ff8e22aa4034f00e71571543262689f9e476e3a6bd8a90b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6678ed97203e13c2ded419cb071437f33b61586f2bc9e929c44aad54452e95ec)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__99e4161a7fcfd421d662c7698508ef5eee3e3718d5bac07a3ab688a50250df8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__382534295f8bfb4fd3e416280905d700b5005ff527bb65ebf201307671395c85)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2acf3bfd3326fd89bc95bd24a656e7ac44ecf7f273ca3f149c6637bbe6b38b2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``values`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``.

        If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the filename component of the request URL.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilenameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilenameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__77a51244ba2efb8c4771d86c2db26302d8c25fd5f3edaa49781e50521e6d8c66)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d8e125cebdab888b52eb230d573bf077ad7dfc4f8ac62bb6df2dbe710b3ba3f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__78e04eed75c315f1d02a67da87c209f8a48c4bebe4c01c4ba8ccf59a5ca15fa0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__019eda56dde8c7ca1e62f2799317955c9b5c26fabd4fe9406ca8b320d88756e8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6f69079a875653e45a0b75429a8454b6cf089bec6b38c0f7c3da9cd1797faa75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b2137331601afa5de2e228736c610d89cddebabe4bdfd8d41d594169af55611f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d3d9d1a954556aa80a9c36b0573171ff13d9044ba762f3f48214631f2ec2e3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__885158b100a71cdddc5af8263cd4dfcce679ff643df591558d5e73ec435ab6a5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e77630b9a302f1e6d6cd6593b62639f0f62fa5a14e935ba383b5efd024d3a809)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A list of hostnames.

        Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostnameOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostnameOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35b295c2560cc04f68f8d2771b910b6a70405e96a26eadc8c9fa557a4762aed9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__58e80fe6f61b1a545aebda8ace747d5c45a3f2b240147da0befe630359947295)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd48c683b73e8faad00a8dc12e20119a494e7412c590bc1284374b7c6d6d4b0e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1ecc6278d8e4db10bf8e92d4792cf32856e45e0d8b6b7423850d8d29b5993fde)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f768cf815ea2d07ca8c19c08100f0e920320ada42bb2854d2f31b57900eedbc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cb4492eb3d3cf5a0e7f29cf309c4c2b3094104180f6bbaff0a7394c6c131acdd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c6cc08e8d9985e4997f732636082f55734698e9b098a0bb8f22a01dc39c0dafe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10403448a20bfe0ede9d79f3a443cb43bb7c96cdc3ef3b42f130cafdc188a7b)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17d645f9435d39aa5ce482d44b4702ef3b868a335bf60e5a6200659eebc0919f)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e0c60d9ea086c437c8710e044e13648fccaaffd40d87d956e4d0187f23dc7e51)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ca936b3b607a0f9f5b6e0b5c1de9439dd943036e46cda2b605ee9115e5d66370)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a2370743c73134165bc34c40dfbc686bf7be06b02b285b35e33ba7cc4736832c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d041f4af8f90430f1480151f32024e08295218f5e12b1af623602888fc346883)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced",
    jsii_struct_bases=[],
    name_mapping={
        "close_xml": "closeXml",
        "description": "description",
        "locked": "locked",
        "open_xml": "openXml",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced:
    def __init__(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fff9939745b7365aeaefa2e243e89aa8af4b7a0184425b61cae978981cdda339)
            check_type(argname="argument close_xml", value=close_xml, expected_type=type_hints["close_xml"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument open_xml", value=open_xml, expected_type=type_hints["open_xml"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if close_xml is not None:
            self._values["close_xml"] = close_xml
        if description is not None:
            self._values["description"] = description
        if locked is not None:
            self._values["locked"] = locked
        if open_xml is not None:
            self._values["open_xml"] = open_xml
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def close_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that closes the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        '''
        result = self._values.get("close_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''A human-readable description of what the XML block does.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def open_xml(self) -> typing.Optional[builtins.str]:
        '''An XML string that opens the relevant block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        '''
        result = self._values.get("open_xml")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvancedOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvancedOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39ab5a18fcb5d28aca18c717f695e75a023f38bf7e040118efee144c52c677a5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCloseXml")
    def reset_close_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloseXml", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetOpenXml")
    def reset_open_xml(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOpenXml", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="closeXmlInput")
    def close_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "closeXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="openXmlInput")
    def open_xml_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "openXmlInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="closeXml")
    def close_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "closeXml"))

    @close_xml.setter
    def close_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13fcbebd39f711d061e2b814de56be922b42b4fe5fda692e01e97901cc14ed9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "closeXml", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eacfc963f73e4227e4f64fcfa92a524fb65562f7cd5293150217c38d7a16154c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c656e807e371540ee30d05715c2e27d9e5b72a4eb1d4cf99ae1697a5310c76e7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="openXml")
    def open_xml(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "openXml"))

    @open_xml.setter
    def open_xml(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6b056af4575ab0ede36cf66b69eeb5a74e14d7abb8723fa8d6451555702bc4d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "openXml", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d460cbc014390d30d5984125dfdf515926e55373a5760e010ee7e29d41507953)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b7248bb6ee3f96cd4e04f8342deb2bc2f18e6bc0b269cbd9ae44afbdd2ebaa4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f13d5cdaff42341ce7cddff2bd586362d9061dce052c5c529cdcc3574f46c7f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue", typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if isinstance(value, dict):
            value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue(**value)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__84e3af6ddaa9babf679203012654ee1fd71604de3a3e20242ac7f3460da4a1e2)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue"]:
        '''value block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue"], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6490c5bef368565e6bf065dbcd9806bfc36b36d76e8be8214d15b754e3859db3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putValue")
    def put_value(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue(
            cp_code_limits=cp_code_limits,
            created_date=created_date,
            description=description,
            id=id,
            name=name,
            products=products,
        )

        return typing.cast(None, jsii.invoke(self, "putValue", [value]))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueOutputReference", jsii.get(self, "value"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue"], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__213a9138796cfce1d95b4ee6d712d743f1b9a2a512fafde714b73bf6543b2fb0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2e91154bf8817e05b9e49d542d398c18cada56060633e0ee0c25e4098097df00)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c7d913c36756313371cae0663901498d423352a11333fa4c51dab73e5a9b0af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a95b183b8d1f90959e6f1b4b64b535903577977c5d2f59048a3b6875a46491fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue",
    jsii_struct_bases=[],
    name_mapping={
        "cp_code_limits": "cpCodeLimits",
        "created_date": "createdDate",
        "description": "description",
        "id": "id",
        "name": "name",
        "products": "products",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue:
    def __init__(
        self,
        *,
        cp_code_limits: typing.Optional[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits", typing.Dict[builtins.str, typing.Any]]] = None,
        created_date: typing.Optional[jsii.Number] = None,
        description: typing.Optional[builtins.str] = None,
        id: typing.Optional[jsii.Number] = None,
        name: typing.Optional[builtins.str] = None,
        products: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param cp_code_limits: cp_code_limits block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        :param created_date: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        :param description: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param id: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}. Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2. If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        :param name: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param products: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        if isinstance(cp_code_limits, dict):
            cp_code_limits = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits(**cp_code_limits)
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c10d4140619a2e27dac80fc1af94a12a4c8e3c7ca09e1eb192de93d1490c9d92)
            check_type(argname="argument cp_code_limits", value=cp_code_limits, expected_type=type_hints["cp_code_limits"])
            check_type(argname="argument created_date", value=created_date, expected_type=type_hints["created_date"])
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument id", value=id, expected_type=type_hints["id"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument products", value=products, expected_type=type_hints["products"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cp_code_limits is not None:
            self._values["cp_code_limits"] = cp_code_limits
        if created_date is not None:
            self._values["created_date"] = created_date
        if description is not None:
            self._values["description"] = description
        if id is not None:
            self._values["id"] = id
        if name is not None:
            self._values["name"] = name
        if products is not None:
            self._values["products"] = products

    @builtins.property
    def cp_code_limits(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits"]:
        '''cp_code_limits block.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cp_code_limits DataAkamaiPropertyRulesBuilder#cp_code_limits}
        '''
        result = self._values.get("cp_code_limits")
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits"], result)

    @builtins.property
    def created_date(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#created_date DataAkamaiPropertyRulesBuilder#created_date}
        '''
        result = self._values.get("created_date")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def description(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def id(self) -> typing.Optional[jsii.Number]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#id DataAkamaiPropertyRulesBuilder#id}.

        Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
        If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
        '''
        result = self._values.get("id")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def products(self) -> typing.Optional[typing.List[builtins.str]]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#products DataAkamaiPropertyRulesBuilder#products}
        '''
        result = self._values.get("products")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits",
    jsii_struct_bases=[],
    name_mapping={
        "current_capacity": "currentCapacity",
        "limit": "limit",
        "limit_type": "limitType",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits:
    def __init__(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c66321f4f138149a1d6449da45ae2d4e1e1570a52352620fb669e11a72d13bd)
            check_type(argname="argument current_capacity", value=current_capacity, expected_type=type_hints["current_capacity"])
            check_type(argname="argument limit", value=limit, expected_type=type_hints["limit"])
            check_type(argname="argument limit_type", value=limit_type, expected_type=type_hints["limit_type"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if current_capacity is not None:
            self._values["current_capacity"] = current_capacity
        if limit is not None:
            self._values["limit"] = limit
        if limit_type is not None:
            self._values["limit_type"] = limit_type

    @builtins.property
    def current_capacity(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        '''
        result = self._values.get("current_capacity")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit(self) -> typing.Optional[jsii.Number]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        '''
        result = self._values.get("limit")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def limit_type(self) -> typing.Optional[builtins.str]:
        '''This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        result = self._values.get("limit_type")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimitsOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603eb9444ad7428b9b30134a1f0d3019223c8abf5f99075b2a8d733243065c55)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCurrentCapacity")
    def reset_current_capacity(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCurrentCapacity", []))

    @jsii.member(jsii_name="resetLimit")
    def reset_limit(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimit", []))

    @jsii.member(jsii_name="resetLimitType")
    def reset_limit_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLimitType", []))

    @builtins.property
    @jsii.member(jsii_name="currentCapacityInput")
    def current_capacity_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "currentCapacityInput"))

    @builtins.property
    @jsii.member(jsii_name="limitInput")
    def limit_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "limitInput"))

    @builtins.property
    @jsii.member(jsii_name="limitTypeInput")
    def limit_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "limitTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="currentCapacity")
    def current_capacity(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "currentCapacity"))

    @current_capacity.setter
    def current_capacity(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__62d0ca2c3184a4810bed9d7b50521d3a823ac7e09335f6efcd9786ebb223e5dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "currentCapacity", value)

    @builtins.property
    @jsii.member(jsii_name="limit")
    def limit(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "limit"))

    @limit.setter
    def limit(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__952505dc62aaa829e9c58120af089aa32b81ebca8a522f6dcc3be1159cefe4ed)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limit", value)

    @builtins.property
    @jsii.member(jsii_name="limitType")
    def limit_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "limitType"))

    @limit_type.setter
    def limit_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d8662a6a050e548c2ba96f0ebc2a5d669d2d4212cb28da4cce2a6da1d510ee4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "limitType", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__69e861e450573d784a6fd5f74123bd15c8a490ee6120c38e2b8c6d98c6f897f1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2852d755a184b0411541742ace08a8591a166f5160a1faf3028b634332e29dd9)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putCpCodeLimits")
    def put_cp_code_limits(
        self,
        *,
        current_capacity: typing.Optional[jsii.Number] = None,
        limit: typing.Optional[jsii.Number] = None,
        limit_type: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param current_capacity: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#current_capacity DataAkamaiPropertyRulesBuilder#current_capacity}
        :param limit: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit DataAkamaiPropertyRulesBuilder#limit}
        :param limit_type: This field is only intended for export compatibility purposes, and modifying it will not impact your use of the behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#limit_type DataAkamaiPropertyRulesBuilder#limit_type}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits(
            current_capacity=current_capacity, limit=limit, limit_type=limit_type
        )

        return typing.cast(None, jsii.invoke(self, "putCpCodeLimits", [value]))

    @jsii.member(jsii_name="resetCpCodeLimits")
    def reset_cp_code_limits(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCpCodeLimits", []))

    @jsii.member(jsii_name="resetCreatedDate")
    def reset_created_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCreatedDate", []))

    @jsii.member(jsii_name="resetDescription")
    def reset_description(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDescription", []))

    @jsii.member(jsii_name="resetId")
    def reset_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetId", []))

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetProducts")
    def reset_products(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetProducts", []))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimits")
    def cp_code_limits(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimitsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimitsOutputReference, jsii.get(self, "cpCodeLimits"))

    @builtins.property
    @jsii.member(jsii_name="cpCodeLimitsInput")
    def cp_code_limits_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits], jsii.get(self, "cpCodeLimitsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDateInput")
    def created_date_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "createdDateInput"))

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="idInput")
    def id_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "idInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="productsInput")
    def products_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "productsInput"))

    @builtins.property
    @jsii.member(jsii_name="createdDate")
    def created_date(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "createdDate"))

    @created_date.setter
    def created_date(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7ee134ed4638afd182f7d37b9791685d26f41880b4622fae033284f7b36f8e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "createdDate", value)

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d78b571f593c848c94ba32b33191d3db4fef4f91a2d4afec6bd51a929fa32ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="id")
    def id(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "id"))

    @id.setter
    def id(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__216b30c407648fff704196b21b74802325c822d7eb3071cf75ef522f166db66c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "id", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a7d6987be12e0b3a6f168a0a8af2368678505d098fb219653e02ac3aeb0dd4c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="products")
    def products(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "products"))

    @products.setter
    def products(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb36dca7e1e7cc7cf1570a9762eaad74c83a9edc263795914afdbc48d54a137f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "products", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__32bb142def577f2b9b3394e8ac2af57923c1dfb523d615fbc5a29c67c7d99e55)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d50003084d87276ff7a0183fc08ab7db69307f733a8b01f19e5e35f97ff8dd33)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches numeric range or a specified set of ``values``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''A set of response codes to match, for example ``["404","500"]``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCodeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCodeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1f90d03cd35142462803de548516dff0c9380bd6b546137287e88ef2e53fc276)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d01c6e3dc993f47a2aabd17c9dc28fdf4bfb58aae426d051803ed1389698a705)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dac3967c757d8235e5d7b522b2fc1179f2c50dd5104548b839d53e78c3e0ed8d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9eaac4f17f0645929dcec0cd9d31736e4d992c543b7b76b18245773ebbf61572)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d39db28a31e6639d97ae8f9d3f744ab27cff2a77c5455e991f6f98f81d375ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__028c95e6bc846444c19239238859ffe760bdb157937d1d9adc6e2fa374288277)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__02f0013ea8d21dc3a6c520992661dd2723f94f8ec94c1bfbbaa6b626f8bceabb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bb6d7fc20b055113b60db4e0adcbdd7b87996371013867674eb18c33969fd4df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9ab1bfdf1a32e3f525e483cd1c3a919c893a5522fc19ccc10f31a7ed5a072018)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "variable_expression": "variableExpression",
        "variable_name": "variableName",
        "variable_values": "variableValues",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10c8d229db9313e1628f6c096fb623db7371ae9e303af825ffa655a647c9aa8b)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_expression", value=variable_expression, expected_type=type_hints["variable_expression"])
            check_type(argname="argument variable_name", value=variable_name, expected_type=type_hints["variable_name"])
            check_type(argname="argument variable_values", value=variable_values, expected_type=type_hints["variable_values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_expression is not None:
            self._values["variable_expression"] = variable_expression
        if variable_name is not None:
            self._values["variable_name"] = variable_name
        if variable_values is not None:
            self._values["variable_values"] = variable_values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this performs a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''The type of match, based on which you use different options to specify the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[builtins.str]:
        '''Specifies the range's numeric maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_expression(self) -> typing.Optional[builtins.str]:
        '''Specifies a single matching string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        '''
        result = self._values.get("variable_expression")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_name(self) -> typing.Optional[builtins.str]:
        '''The name of the variable to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        '''
        result = self._values.get("variable_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Specifies an array of matching strings.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        result = self._values.get("variable_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ad4713831eee03a2d9588e2d4e219f02630d2e5391e54974c39b4c88edb0a28)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableExpression")
    def reset_variable_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableExpression", []))

    @jsii.member(jsii_name="resetVariableName")
    def reset_variable_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableName", []))

    @jsii.member(jsii_name="resetVariableValues")
    def reset_variable_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableExpressionInput")
    def variable_expression_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNameInput")
    def variable_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "variableNameInput"))

    @builtins.property
    @jsii.member(jsii_name="variableValuesInput")
    def variable_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70be376db103dfbf54f69e2ccea31145ab2fedd34ec6acd902a479c69a9f6e90)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9efede69e1e440b520caca95b61491e41336e4b5787f13796d2161eb73e2b796)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14fa37ffdbf5df19117734be7eb73dacc66627b0725868bf4fc95de63925536)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f7164a24b79266f50035eb75a26c9b08ccf1b893547f9a98706a589c59bb351)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3853fe7cdfdb31382f5e8b68f33f33a68d1334e4f4b6264fead89256cf17982a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e2a2f3ca82f2ec39cba4b5c57b57bec39bb0a6516cdc49afa189d0435c09f372)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8b497fa07bba24845096b05e6a52bca0f46f8f35af99fcb89ec3ea2ba7023e44)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5368e9c48c646ece15323801567715fe105b2f29d9fe248fca3239300d8ec170)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableExpression")
    def variable_expression(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableExpression"))

    @variable_expression.setter
    def variable_expression(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce627499e3b0b284f18d59233c13c576814e5471e6a38602a38415bbbccbce04)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableExpression", value)

    @builtins.property
    @jsii.member(jsii_name="variableName")
    def variable_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "variableName"))

    @variable_name.setter
    def variable_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d622bf616eefcc549273930189ec65b584b9015d9b969f413c7858ef49923f5a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableName", value)

    @builtins.property
    @jsii.member(jsii_name="variableValues")
    def variable_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableValues"))

    @variable_values.setter
    def variable_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1921455dbc7104a14be3a87cc165dd632bbb849d435fb778824054792e94842b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableValues", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__863857984948eab4b1e6a844ce100d96c165d0a9e3e1fd34cc08923707f41644)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee40254551d115bf094c1c4c8afd64172ea1aced9a6f6bf1c8032c801a3c8559)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Compares the current rule with the specified metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the metadata stage.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStageOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStageOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9becc9f907d7c63f914b6906ad2f4941efe73fbebd29cab22f238dc20ec68ea)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4bbeff472c874b30074e355458ba5f2c214b6d378533960cf2778ff3775a955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f9e87e54de69c042726bfbac61619908be6a81c122ade63abbf113fadd30a589)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__91b800252f89528b61d9e108cd3d6b75e6cc5abb330c5af98e8cd5ce2e1ac50d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f3c12752b9ea4089038f1bcd79e975bc31a5807d0ae208845b1645e9ffdea46c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4edca54a58586e437f80a3260d2f38dcb8475b66fa488e19a81dc28038220b50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__33decb025e69e730bb34832154976668038bc13cd620a481bfbc6f2f46873da2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7380578bd4a889b6598a960c4467205041934df21aaf8aa3263376258c25d3cf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies a single required ``ORIGIN_TIMED_OUT`` value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeoutOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeoutOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5576de75343f47da9d4881a905efb3c1ea4c471b51fbbb583aed788c40522153)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__65f6e73182420875735108b6184ba40ac0ab26c6115d9cb8b8d7e90069ea2734)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1431beab0862144c16406b34d1b8d5f6c01999640f0680d6b8d35d4c9e90bd28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5cb6f585389212058e937f4550fac58068614025a3e416209e7d4253f1427f2c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba77557ea119dd1b968706294f35ac01746a73ced90919fd9ffa1413127b3c3e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__89e5aa9203dae8db384d876674b048b304c1b28603d4ef493119311e0f1ed849)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae94e059263977e3a5efdf551a32572acf98c286780fbdbd4877c3bc89335761)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @jsii.member(jsii_name="putAdvancedImMatch")
    def put_advanced_im_match(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the match's scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putAdvancedImMatch", [value]))

    @jsii.member(jsii_name="putBucket")
    def put_bucket(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        percentage: typing.Optional[jsii.Number] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param percentage: Specifies the percentage of requests to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#percentage DataAkamaiPropertyRulesBuilder#percentage}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket(
            locked=locked,
            percentage=percentage,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putBucket", [value]))

    @jsii.member(jsii_name="putCacheability")
    def put_cacheability(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Content's cache is enabled (``CACHEABLE``) or not (``NO_STORE``), or else is ignored (``BYPASS_CACHE``). Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putCacheability", [value_]))

    @jsii.member(jsii_name="putChinaCdnRegion")
    def put_china_cdn_region(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specify whether the request ``IS`` or ``IS_NOT`` deployed over ChinaCDN. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putChinaCdnRegion", [value]))

    @jsii.member(jsii_name="putClientCertificate")
    def put_client_certificate(
        self,
        *,
        enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        is_certificate_valid: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param enforce_mtls: Specifies custom handling of requests if any of the checks in the ``enforceMtlsSettings`` behavior fail. Enable this and use with behaviors such as ``logCustom`` so that they execute if the check fails. You need to add the ``enforceMtlsSettings`` behavior to a parent rule, with its own unique match condition and ``enableDenyRequest`` option disabled. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#enforce_mtls DataAkamaiPropertyRulesBuilder#enforce_mtls}
        :param is_certificate_present: Executes rule behaviors only if a client certificate authenticates requests. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_present DataAkamaiPropertyRulesBuilder#is_certificate_present}
        :param is_certificate_valid: Matches whether the certificate is ``VALID`` or ``INVALID``. You can also ``IGNORE`` the certificate's validity. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#is_certificate_valid DataAkamaiPropertyRulesBuilder#is_certificate_valid}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate(
            enforce_mtls=enforce_mtls,
            is_certificate_present=is_certificate_present,
            is_certificate_valid=is_certificate_valid,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putClientCertificate", [value]))

    @jsii.member(jsii_name="putClientIp")
    def put_client_ip(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_headers: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_headers DataAkamaiPropertyRulesBuilder#use_headers}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: IP or CIDR block, for example: ``71.92.0.0/14``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            use_headers=use_headers,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIp", [value]))

    @jsii.member(jsii_name="putClientIpVersion")
    def put_client_ip_version(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_x_forwarded_for: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the connecting client's IP address rather than the original end client specified in the header. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_x_forwarded_for DataAkamaiPropertyRulesBuilder#use_x_forwarded_for}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The IP version of the client request, either ``IPV4`` or ``IPV6``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion(
            locked=locked,
            template_uuid=template_uuid,
            use_x_forwarded_for=use_x_forwarded_for,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putClientIpVersion", [value_]))

    @jsii.member(jsii_name="putCloudletsOrigin")
    def put_cloudlets_origin(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        origin_id: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param origin_id: The Cloudlets Origins identifier, limited to alphanumeric and underscore characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#origin_id DataAkamaiPropertyRulesBuilder#origin_id}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin(
            locked=locked, origin_id=origin_id, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putCloudletsOrigin", [value]))

    @jsii.member(jsii_name="putContentDeliveryNetwork")
    def put_content_delivery_network(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified ``network`` if set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network: Match the network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network DataAkamaiPropertyRulesBuilder#network}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork(
            locked=locked,
            match_operator=match_operator,
            network=network,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putContentDeliveryNetwork", [value]))

    @jsii.member(jsii_name="putContentType")
    def put_content_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for all ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches any ``Content-Type`` among specified ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``text/*`` matches both ``text/html`` and ``text/css``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: ``Content-Type`` response header value, for example ``text/html``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putContentType", [value]))

    @jsii.member(jsii_name="putDeviceCharacteristic")
    def put_device_characteristic(
        self,
        *,
        boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        characteristic: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        numeric_match_operator: typing.Optional[builtins.str] = None,
        numeric_value: typing.Optional[jsii.Number] = None,
        string_match_operator: typing.Optional[builtins.str] = None,
        string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        version_match_operator: typing.Optional[builtins.str] = None,
        version_value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param boolean_value: When the ``characteristic`` expects a boolean value, this specifies the value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#boolean_value DataAkamaiPropertyRulesBuilder#boolean_value}
        :param characteristic: Aspect of the device or browser to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#characteristic DataAkamaiPropertyRulesBuilder#characteristic}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``stringValue`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_wildcard: Allows wildcards in the ``stringValue`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param numeric_match_operator: When the ``characteristic`` expects a numeric value, compares the specified ``numericValue`` against the matched client. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_match_operator DataAkamaiPropertyRulesBuilder#numeric_match_operator}
        :param numeric_value: When the ``characteristic`` expects a numeric value, this specifies the number. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#numeric_value DataAkamaiPropertyRulesBuilder#numeric_value}
        :param string_match_operator: When the ``characteristic`` expects a string value, set this to ``MATCHES_ONE_OF`` to match against the ``stringValue`` set, otherwise set to ``DOES_NOT_MATCH_ONE_OF`` to exclude that set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_match_operator DataAkamaiPropertyRulesBuilder#string_match_operator}
        :param string_value: When the ``characteristic`` expects a string, this specifies the set of values. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#string_value DataAkamaiPropertyRulesBuilder#string_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param version_match_operator: When the ``characteristic`` expects a version string value, compares the specified ``versionValue`` against the matched client, using the following operators: ``IS``, ``IS_MORE_THAN_OR_EQUAL``, ``IS_MORE_THAN``, ``IS_LESS_THAN_OR_EQUAL``, ``IS_LESS_THAN``, ``IS_NOT``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_match_operator DataAkamaiPropertyRulesBuilder#version_match_operator}
        :param version_value: When the ``characteristic`` expects a version number, this specifies it as a string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#version_value DataAkamaiPropertyRulesBuilder#version_value}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic(
            boolean_value=boolean_value,
            characteristic=characteristic,
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_wildcard=match_wildcard,
            numeric_match_operator=numeric_match_operator,
            numeric_value=numeric_value,
            string_match_operator=string_match_operator,
            string_value=string_value,
            template_uuid=template_uuid,
            uuid=uuid,
            version_match_operator=version_match_operator,
            version_value=version_value,
        )

        return typing.cast(None, jsii.invoke(self, "putDeviceCharacteristic", [value]))

    @jsii.member(jsii_name="putEcmdAuthGroups")
    def put_ecmd_auth_groups(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthGroups", [value_]))

    @jsii.member(jsii_name="putEcmdAuthScheme")
    def put_ecmd_auth_scheme(
        self,
        *,
        auth_scheme: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param auth_scheme: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#auth_scheme DataAkamaiPropertyRulesBuilder#auth_scheme}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme(
            auth_scheme=auth_scheme,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdAuthScheme", [value]))

    @jsii.member(jsii_name="putEcmdIsAuthenticated")
    def put_ecmd_is_authenticated(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdIsAuthenticated", [value]))

    @jsii.member(jsii_name="putEcmdUsername")
    def put_ecmd_username(
        self,
        *,
        length: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param length: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#length DataAkamaiPropertyRulesBuilder#length}.
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}.
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername(
            length=length,
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putEcmdUsername", [value_]))

    @jsii.member(jsii_name="putEdgeWorkersFailure")
    def put_edge_workers_failure(
        self,
        *,
        exec_status: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param exec_status: Specify execution status. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#exec_status DataAkamaiPropertyRulesBuilder#exec_status}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure(
            exec_status=exec_status,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putEdgeWorkersFailure", [value]))

    @jsii.member(jsii_name="putFileExtension")
    def put_file_extension(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of ``values`` if set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: An array of file extension strings, with no leading dot characters, for example ``png``, ``jpg``, ``jpeg``, and ``gif``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFileExtension", [value]))

    @jsii.member(jsii_name="putFilename")
    def put_filename(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``values`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: If set to ``IS_ONE_OF`` or ``IS_NOT_ONE_OF``, matches whether the filename matches one of the ``values``. If set to ``IS_EMPTY`` or ``IS_NOT_EMPTY``, matches whether the specified filename is part of the path. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the filename component of the request URL. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, specify ``filename.*`` to accept any extension. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putFilename", [value]))

    @jsii.member(jsii_name="putHostname")
    def put_hostname(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the contents of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A list of hostnames. Allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Specifying ``*.example.com`` matches both ``m.example.com`` and ``www.example.com``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putHostname", [value]))

    @jsii.member(jsii_name="putMatchAdvanced")
    def put_match_advanced(
        self,
        *,
        close_xml: typing.Optional[builtins.str] = None,
        description: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        open_xml: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param close_xml: An XML string that closes the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#close_xml DataAkamaiPropertyRulesBuilder#close_xml}
        :param description: A human-readable description of what the XML block does. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param open_xml: An XML string that opens the relevant block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#open_xml DataAkamaiPropertyRulesBuilder#open_xml}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced(
            close_xml=close_xml,
            description=description,
            locked=locked,
            open_xml=open_xml,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchAdvanced", [value]))

    @jsii.member(jsii_name="putMatchCpCode")
    def put_match_cp_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: value block. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putMatchCpCode", [value_]))

    @jsii.member(jsii_name="putMatchResponseCode")
    def put_match_response_code(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the start of a range of responses. For example, ``400`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_operator: Matches numeric range or a specified set of ``values``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the end of a range of responses. For example, ``500`` to match anything from ``400`` to ``500``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: A set of response codes to match, for example ``["404","500"]``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode(
            locked=locked,
            lower_bound=lower_bound,
            match_operator=match_operator,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchResponseCode", [value]))

    @jsii.member(jsii_name="putMatchVariable")
    def put_match_variable(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[builtins.str] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_expression: typing.Optional[builtins.str] = None,
        variable_name: typing.Optional[builtins.str] = None,
        variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the range's numeric minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive: When matching string expressions, enabling this performs a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: The type of match, based on which you use different options to specify the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: When matching string expressions, enabling this allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: Specifies the range's numeric maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_expression: Specifies a single matching string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_expression DataAkamaiPropertyRulesBuilder#variable_expression}
        :param variable_name: The name of the variable to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_name DataAkamaiPropertyRulesBuilder#variable_name}
        :param variable_values: Specifies an array of matching strings. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_values DataAkamaiPropertyRulesBuilder#variable_values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable(
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            variable_expression=variable_expression,
            variable_name=variable_name,
            variable_values=variable_values,
        )

        return typing.cast(None, jsii.invoke(self, "putMatchVariable", [value]))

    @jsii.member(jsii_name="putMetadataStage")
    def put_metadata_stage(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Compares the current rule with the specified metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the metadata stage. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putMetadataStage", [value_]))

    @jsii.member(jsii_name="putOriginTimeout")
    def put_origin_timeout(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies a single required ``ORIGIN_TIMED_OUT`` value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putOriginTimeout", [value]))

    @jsii.member(jsii_name="putPath")
    def put_path(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            normalize=normalize,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putPath", [value]))

    @jsii.member(jsii_name="putQueryStringParameter")
    def put_query_string_parameter(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter(
            escape_value=escape_value,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            parameter_name=parameter_name,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putQueryStringParameter", [value]))

    @jsii.member(jsii_name="putRandom")
    def put_random(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom(
            bucket=bucket, locked=locked, template_uuid=template_uuid, uuid=uuid
        )

        return typing.cast(None, jsii.invoke(self, "putRandom", [value]))

    @jsii.member(jsii_name="putRecoveryConfig")
    def put_recovery_config(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig(
            config_name=config_name,
            locked=locked,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRecoveryConfig", [value]))

    @jsii.member(jsii_name="putRegularExpression")
    def put_regular_expression(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression(
            case_sensitive=case_sensitive,
            locked=locked,
            match_string=match_string,
            regex=regex,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putRegularExpression", [value]))

    @jsii.member(jsii_name="putRequestCookie")
    def put_request_cookie(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie(
            cookie_name=cookie_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_name=match_case_sensitive_name,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestCookie", [value_]))

    @jsii.member(jsii_name="putRequestHeader")
    def put_request_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader(
            header_name=header_name,
            locked=locked,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestHeader", [value]))

    @jsii.member(jsii_name="putRequestMethod")
    def put_request_method(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestMethod", [value_]))

    @jsii.member(jsii_name="putRequestProtocol")
    def put_request_protocol(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol(
            locked=locked, template_uuid=template_uuid, uuid=uuid, value=value
        )

        return typing.cast(None, jsii.invoke(self, "putRequestProtocol", [value_]))

    @jsii.member(jsii_name="putRequestType")
    def put_request_type(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        value_ = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType(
            locked=locked,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
            value=value,
        )

        return typing.cast(None, jsii.invoke(self, "putRequestType", [value_]))

    @jsii.member(jsii_name="putResponseHeader")
    def put_response_header(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader(
            header_name=header_name,
            locked=locked,
            lower_bound=lower_bound,
            match_case_sensitive_value=match_case_sensitive_value,
            match_operator=match_operator,
            match_wildcard_name=match_wildcard_name,
            match_wildcard_value=match_wildcard_value,
            template_uuid=template_uuid,
            upper_bound=upper_bound,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putResponseHeader", [value]))

    @jsii.member(jsii_name="putServerLocation")
    def put_server_location(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation(
            continents=continents,
            countries=countries,
            location_type=location_type,
            locked=locked,
            match_operator=match_operator,
            regions=regions,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putServerLocation", [value]))

    @jsii.member(jsii_name="putTime")
    def put_time(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime(
            apply_daylight_savings_time=apply_daylight_savings_time,
            begin_date=begin_date,
            end_date=end_date,
            lasting_date=lasting_date,
            lasting_duration=lasting_duration,
            locked=locked,
            match_operator=match_operator,
            repeat_begin_date=repeat_begin_date,
            repeat_duration=repeat_duration,
            repeat_interval=repeat_interval,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTime", [value]))

    @jsii.member(jsii_name="putTokenAuthorization")
    def put_token_authorization(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization(
            locked=locked,
            match_operator=match_operator,
            status_list=status_list,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putTokenAuthorization", [value]))

    @jsii.member(jsii_name="putUserAgent")
    def put_user_agent(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent(
            locked=locked,
            match_case_sensitive=match_case_sensitive,
            match_operator=match_operator,
            match_wildcard=match_wildcard,
            template_uuid=template_uuid,
            uuid=uuid,
            values=values,
        )

        return typing.cast(None, jsii.invoke(self, "putUserAgent", [value]))

    @jsii.member(jsii_name="putUserLocation")
    def put_user_location(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation(
            check_ips=check_ips,
            continent_values=continent_values,
            country_values=country_values,
            field=field,
            locked=locked,
            match_operator=match_operator,
            region_values=region_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserLocation", [value]))

    @jsii.member(jsii_name="putUserNetwork")
    def put_user_network(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork(
            bandwidth_values=bandwidth_values,
            check_ips=check_ips,
            field=field,
            locked=locked,
            match_operator=match_operator,
            network_type_values=network_type_values,
            network_values=network_values,
            template_uuid=template_uuid,
            use_only_first_x_forwarded_for_ip=use_only_first_x_forwarded_for_ip,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putUserNetwork", [value]))

    @jsii.member(jsii_name="putVariableError")
    def put_variable_error(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError(
            locked=locked,
            result=result,
            template_uuid=template_uuid,
            uuid=uuid,
            variable_names=variable_names,
        )

        return typing.cast(None, jsii.invoke(self, "putVariableError", [value]))

    @jsii.member(jsii_name="putVirtualWaitingRoomRequest")
    def put_virtual_waiting_room_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVirtualWaitingRoomRequest", [value]))

    @jsii.member(jsii_name="putVisitorPrioritizationRequest")
    def put_visitor_prioritization_request(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest(
            locked=locked,
            match_on=match_on,
            match_operator=match_operator,
            template_uuid=template_uuid,
            uuid=uuid,
        )

        return typing.cast(None, jsii.invoke(self, "putVisitorPrioritizationRequest", [value]))

    @jsii.member(jsii_name="resetAdvancedImMatch")
    def reset_advanced_im_match(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedImMatch", []))

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetCacheability")
    def reset_cacheability(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCacheability", []))

    @jsii.member(jsii_name="resetChinaCdnRegion")
    def reset_china_cdn_region(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChinaCdnRegion", []))

    @jsii.member(jsii_name="resetClientCertificate")
    def reset_client_certificate(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientCertificate", []))

    @jsii.member(jsii_name="resetClientIp")
    def reset_client_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIp", []))

    @jsii.member(jsii_name="resetClientIpVersion")
    def reset_client_ip_version(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetClientIpVersion", []))

    @jsii.member(jsii_name="resetCloudletsOrigin")
    def reset_cloudlets_origin(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCloudletsOrigin", []))

    @jsii.member(jsii_name="resetContentDeliveryNetwork")
    def reset_content_delivery_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentDeliveryNetwork", []))

    @jsii.member(jsii_name="resetContentType")
    def reset_content_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContentType", []))

    @jsii.member(jsii_name="resetDeviceCharacteristic")
    def reset_device_characteristic(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetDeviceCharacteristic", []))

    @jsii.member(jsii_name="resetEcmdAuthGroups")
    def reset_ecmd_auth_groups(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthGroups", []))

    @jsii.member(jsii_name="resetEcmdAuthScheme")
    def reset_ecmd_auth_scheme(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdAuthScheme", []))

    @jsii.member(jsii_name="resetEcmdIsAuthenticated")
    def reset_ecmd_is_authenticated(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdIsAuthenticated", []))

    @jsii.member(jsii_name="resetEcmdUsername")
    def reset_ecmd_username(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEcmdUsername", []))

    @jsii.member(jsii_name="resetEdgeWorkersFailure")
    def reset_edge_workers_failure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEdgeWorkersFailure", []))

    @jsii.member(jsii_name="resetFileExtension")
    def reset_file_extension(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFileExtension", []))

    @jsii.member(jsii_name="resetFilename")
    def reset_filename(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetFilename", []))

    @jsii.member(jsii_name="resetHostname")
    def reset_hostname(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHostname", []))

    @jsii.member(jsii_name="resetMatchAdvanced")
    def reset_match_advanced(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchAdvanced", []))

    @jsii.member(jsii_name="resetMatchCpCode")
    def reset_match_cp_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCpCode", []))

    @jsii.member(jsii_name="resetMatchResponseCode")
    def reset_match_response_code(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchResponseCode", []))

    @jsii.member(jsii_name="resetMatchVariable")
    def reset_match_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchVariable", []))

    @jsii.member(jsii_name="resetMetadataStage")
    def reset_metadata_stage(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMetadataStage", []))

    @jsii.member(jsii_name="resetOriginTimeout")
    def reset_origin_timeout(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOriginTimeout", []))

    @jsii.member(jsii_name="resetPath")
    def reset_path(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetPath", []))

    @jsii.member(jsii_name="resetQueryStringParameter")
    def reset_query_string_parameter(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetQueryStringParameter", []))

    @jsii.member(jsii_name="resetRandom")
    def reset_random(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRandom", []))

    @jsii.member(jsii_name="resetRecoveryConfig")
    def reset_recovery_config(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRecoveryConfig", []))

    @jsii.member(jsii_name="resetRegularExpression")
    def reset_regular_expression(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegularExpression", []))

    @jsii.member(jsii_name="resetRequestCookie")
    def reset_request_cookie(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestCookie", []))

    @jsii.member(jsii_name="resetRequestHeader")
    def reset_request_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestHeader", []))

    @jsii.member(jsii_name="resetRequestMethod")
    def reset_request_method(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestMethod", []))

    @jsii.member(jsii_name="resetRequestProtocol")
    def reset_request_protocol(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestProtocol", []))

    @jsii.member(jsii_name="resetRequestType")
    def reset_request_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRequestType", []))

    @jsii.member(jsii_name="resetResponseHeader")
    def reset_response_header(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResponseHeader", []))

    @jsii.member(jsii_name="resetServerLocation")
    def reset_server_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetServerLocation", []))

    @jsii.member(jsii_name="resetTime")
    def reset_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTime", []))

    @jsii.member(jsii_name="resetTokenAuthorization")
    def reset_token_authorization(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTokenAuthorization", []))

    @jsii.member(jsii_name="resetUserAgent")
    def reset_user_agent(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserAgent", []))

    @jsii.member(jsii_name="resetUserLocation")
    def reset_user_location(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserLocation", []))

    @jsii.member(jsii_name="resetUserNetwork")
    def reset_user_network(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUserNetwork", []))

    @jsii.member(jsii_name="resetVariableError")
    def reset_variable_error(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableError", []))

    @jsii.member(jsii_name="resetVirtualWaitingRoomRequest")
    def reset_virtual_waiting_room_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVirtualWaitingRoomRequest", []))

    @jsii.member(jsii_name="resetVisitorPrioritizationRequest")
    def reset_visitor_prioritization_request(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVisitorPrioritizationRequest", []))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatch")
    def advanced_im_match(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatchOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatchOutputReference, jsii.get(self, "advancedImMatch"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucketOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucketOutputReference, jsii.get(self, "bucket"))

    @builtins.property
    @jsii.member(jsii_name="cacheability")
    def cacheability(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheabilityOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheabilityOutputReference, jsii.get(self, "cacheability"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegion")
    def china_cdn_region(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegionOutputReference, jsii.get(self, "chinaCdnRegion"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificate")
    def client_certificate(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificateOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificateOutputReference, jsii.get(self, "clientCertificate"))

    @builtins.property
    @jsii.member(jsii_name="clientIp")
    def client_ip(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpOutputReference, jsii.get(self, "clientIp"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersion")
    def client_ip_version(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersionOutputReference, jsii.get(self, "clientIpVersion"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOrigin")
    def cloudlets_origin(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOriginOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOriginOutputReference, jsii.get(self, "cloudletsOrigin"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetwork")
    def content_delivery_network(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetworkOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetworkOutputReference, jsii.get(self, "contentDeliveryNetwork"))

    @builtins.property
    @jsii.member(jsii_name="contentType")
    def content_type(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentTypeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentTypeOutputReference, jsii.get(self, "contentType"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristic")
    def device_characteristic(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristicOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristicOutputReference, jsii.get(self, "deviceCharacteristic"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroups")
    def ecmd_auth_groups(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroupsOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroupsOutputReference, jsii.get(self, "ecmdAuthGroups"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthScheme")
    def ecmd_auth_scheme(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthSchemeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthSchemeOutputReference, jsii.get(self, "ecmdAuthScheme"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticated")
    def ecmd_is_authenticated(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticatedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticatedOutputReference, jsii.get(self, "ecmdIsAuthenticated"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsername")
    def ecmd_username(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsernameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsernameOutputReference, jsii.get(self, "ecmdUsername"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailure")
    def edge_workers_failure(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailureOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailureOutputReference, jsii.get(self, "edgeWorkersFailure"))

    @builtins.property
    @jsii.member(jsii_name="fileExtension")
    def file_extension(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtensionOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtensionOutputReference, jsii.get(self, "fileExtension"))

    @builtins.property
    @jsii.member(jsii_name="filename")
    def filename(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilenameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilenameOutputReference, jsii.get(self, "filename"))

    @builtins.property
    @jsii.member(jsii_name="hostname")
    def hostname(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostnameOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostnameOutputReference, jsii.get(self, "hostname"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvanced")
    def match_advanced(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvancedOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvancedOutputReference, jsii.get(self, "matchAdvanced"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCode")
    def match_cp_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeOutputReference, jsii.get(self, "matchCpCode"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCode")
    def match_response_code(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCodeOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCodeOutputReference, jsii.get(self, "matchResponseCode"))

    @builtins.property
    @jsii.member(jsii_name="matchVariable")
    def match_variable(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariableOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariableOutputReference, jsii.get(self, "matchVariable"))

    @builtins.property
    @jsii.member(jsii_name="metadataStage")
    def metadata_stage(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStageOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStageOutputReference, jsii.get(self, "metadataStage"))

    @builtins.property
    @jsii.member(jsii_name="originTimeout")
    def origin_timeout(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeoutOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeoutOutputReference, jsii.get(self, "originTimeout"))

    @builtins.property
    @jsii.member(jsii_name="path")
    def path(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPathOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPathOutputReference", jsii.get(self, "path"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameter")
    def query_string_parameter(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameterOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameterOutputReference", jsii.get(self, "queryStringParameter"))

    @builtins.property
    @jsii.member(jsii_name="random")
    def random(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandomOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandomOutputReference", jsii.get(self, "random"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfig")
    def recovery_config(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfigOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfigOutputReference", jsii.get(self, "recoveryConfig"))

    @builtins.property
    @jsii.member(jsii_name="regularExpression")
    def regular_expression(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpressionOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpressionOutputReference", jsii.get(self, "regularExpression"))

    @builtins.property
    @jsii.member(jsii_name="requestCookie")
    def request_cookie(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookieOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookieOutputReference", jsii.get(self, "requestCookie"))

    @builtins.property
    @jsii.member(jsii_name="requestHeader")
    def request_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeaderOutputReference", jsii.get(self, "requestHeader"))

    @builtins.property
    @jsii.member(jsii_name="requestMethod")
    def request_method(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethodOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethodOutputReference", jsii.get(self, "requestMethod"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocol")
    def request_protocol(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocolOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocolOutputReference", jsii.get(self, "requestProtocol"))

    @builtins.property
    @jsii.member(jsii_name="requestType")
    def request_type(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestTypeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestTypeOutputReference", jsii.get(self, "requestType"))

    @builtins.property
    @jsii.member(jsii_name="responseHeader")
    def response_header(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeaderOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeaderOutputReference", jsii.get(self, "responseHeader"))

    @builtins.property
    @jsii.member(jsii_name="serverLocation")
    def server_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocationOutputReference", jsii.get(self, "serverLocation"))

    @builtins.property
    @jsii.member(jsii_name="time")
    def time(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTimeOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTimeOutputReference", jsii.get(self, "time"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorization")
    def token_authorization(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorizationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorizationOutputReference", jsii.get(self, "tokenAuthorization"))

    @builtins.property
    @jsii.member(jsii_name="userAgent")
    def user_agent(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgentOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgentOutputReference", jsii.get(self, "userAgent"))

    @builtins.property
    @jsii.member(jsii_name="userLocation")
    def user_location(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocationOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocationOutputReference", jsii.get(self, "userLocation"))

    @builtins.property
    @jsii.member(jsii_name="userNetwork")
    def user_network(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetworkOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetworkOutputReference", jsii.get(self, "userNetwork"))

    @builtins.property
    @jsii.member(jsii_name="variableError")
    def variable_error(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableErrorOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableErrorOutputReference", jsii.get(self, "variableError"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequest")
    def virtual_waiting_room_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequestOutputReference", jsii.get(self, "virtualWaitingRoomRequest"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequest")
    def visitor_prioritization_request(
        self,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequestOutputReference":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequestOutputReference", jsii.get(self, "visitorPrioritizationRequest"))

    @builtins.property
    @jsii.member(jsii_name="advancedImMatchInput")
    def advanced_im_match_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch], jsii.get(self, "advancedImMatchInput"))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="cacheabilityInput")
    def cacheability_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability], jsii.get(self, "cacheabilityInput"))

    @builtins.property
    @jsii.member(jsii_name="chinaCdnRegionInput")
    def china_cdn_region_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion], jsii.get(self, "chinaCdnRegionInput"))

    @builtins.property
    @jsii.member(jsii_name="clientCertificateInput")
    def client_certificate_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate], jsii.get(self, "clientCertificateInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpInput")
    def client_ip_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp], jsii.get(self, "clientIpInput"))

    @builtins.property
    @jsii.member(jsii_name="clientIpVersionInput")
    def client_ip_version_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion], jsii.get(self, "clientIpVersionInput"))

    @builtins.property
    @jsii.member(jsii_name="cloudletsOriginInput")
    def cloudlets_origin_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin], jsii.get(self, "cloudletsOriginInput"))

    @builtins.property
    @jsii.member(jsii_name="contentDeliveryNetworkInput")
    def content_delivery_network_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork], jsii.get(self, "contentDeliveryNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="contentTypeInput")
    def content_type_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType], jsii.get(self, "contentTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="deviceCharacteristicInput")
    def device_characteristic_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic], jsii.get(self, "deviceCharacteristicInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthGroupsInput")
    def ecmd_auth_groups_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups], jsii.get(self, "ecmdAuthGroupsInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdAuthSchemeInput")
    def ecmd_auth_scheme_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme], jsii.get(self, "ecmdAuthSchemeInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdIsAuthenticatedInput")
    def ecmd_is_authenticated_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated], jsii.get(self, "ecmdIsAuthenticatedInput"))

    @builtins.property
    @jsii.member(jsii_name="ecmdUsernameInput")
    def ecmd_username_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername], jsii.get(self, "ecmdUsernameInput"))

    @builtins.property
    @jsii.member(jsii_name="edgeWorkersFailureInput")
    def edge_workers_failure_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure], jsii.get(self, "edgeWorkersFailureInput"))

    @builtins.property
    @jsii.member(jsii_name="fileExtensionInput")
    def file_extension_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension], jsii.get(self, "fileExtensionInput"))

    @builtins.property
    @jsii.member(jsii_name="filenameInput")
    def filename_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename], jsii.get(self, "filenameInput"))

    @builtins.property
    @jsii.member(jsii_name="hostnameInput")
    def hostname_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname], jsii.get(self, "hostnameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchAdvancedInput")
    def match_advanced_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced], jsii.get(self, "matchAdvancedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCpCodeInput")
    def match_cp_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode], jsii.get(self, "matchCpCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchResponseCodeInput")
    def match_response_code_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode], jsii.get(self, "matchResponseCodeInput"))

    @builtins.property
    @jsii.member(jsii_name="matchVariableInput")
    def match_variable_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable], jsii.get(self, "matchVariableInput"))

    @builtins.property
    @jsii.member(jsii_name="metadataStageInput")
    def metadata_stage_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage], jsii.get(self, "metadataStageInput"))

    @builtins.property
    @jsii.member(jsii_name="originTimeoutInput")
    def origin_timeout_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout], jsii.get(self, "originTimeoutInput"))

    @builtins.property
    @jsii.member(jsii_name="pathInput")
    def path_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath"], jsii.get(self, "pathInput"))

    @builtins.property
    @jsii.member(jsii_name="queryStringParameterInput")
    def query_string_parameter_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter"], jsii.get(self, "queryStringParameterInput"))

    @builtins.property
    @jsii.member(jsii_name="randomInput")
    def random_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom"], jsii.get(self, "randomInput"))

    @builtins.property
    @jsii.member(jsii_name="recoveryConfigInput")
    def recovery_config_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig"], jsii.get(self, "recoveryConfigInput"))

    @builtins.property
    @jsii.member(jsii_name="regularExpressionInput")
    def regular_expression_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression"], jsii.get(self, "regularExpressionInput"))

    @builtins.property
    @jsii.member(jsii_name="requestCookieInput")
    def request_cookie_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie"], jsii.get(self, "requestCookieInput"))

    @builtins.property
    @jsii.member(jsii_name="requestHeaderInput")
    def request_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader"], jsii.get(self, "requestHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="requestMethodInput")
    def request_method_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod"], jsii.get(self, "requestMethodInput"))

    @builtins.property
    @jsii.member(jsii_name="requestProtocolInput")
    def request_protocol_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol"], jsii.get(self, "requestProtocolInput"))

    @builtins.property
    @jsii.member(jsii_name="requestTypeInput")
    def request_type_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType"], jsii.get(self, "requestTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="responseHeaderInput")
    def response_header_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader"], jsii.get(self, "responseHeaderInput"))

    @builtins.property
    @jsii.member(jsii_name="serverLocationInput")
    def server_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation"], jsii.get(self, "serverLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="timeInput")
    def time_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime"], jsii.get(self, "timeInput"))

    @builtins.property
    @jsii.member(jsii_name="tokenAuthorizationInput")
    def token_authorization_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization"], jsii.get(self, "tokenAuthorizationInput"))

    @builtins.property
    @jsii.member(jsii_name="userAgentInput")
    def user_agent_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent"], jsii.get(self, "userAgentInput"))

    @builtins.property
    @jsii.member(jsii_name="userLocationInput")
    def user_location_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation"], jsii.get(self, "userLocationInput"))

    @builtins.property
    @jsii.member(jsii_name="userNetworkInput")
    def user_network_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork"], jsii.get(self, "userNetworkInput"))

    @builtins.property
    @jsii.member(jsii_name="variableErrorInput")
    def variable_error_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError"], jsii.get(self, "variableErrorInput"))

    @builtins.property
    @jsii.member(jsii_name="virtualWaitingRoomRequestInput")
    def virtual_waiting_room_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest"], jsii.get(self, "virtualWaitingRoomRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="visitorPrioritizationRequestInput")
    def visitor_prioritization_request_input(
        self,
    ) -> typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest"]:
        return typing.cast(typing.Optional["DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest"], jsii.get(self, "visitorPrioritizationRequestInput"))

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__37187da11a49b3d295264e7e388f6fd5f126aab4c82dc5e6068cdf2e681f5e53)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "normalize": "normalize",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the contents of the ``values`` array. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param normalize: Transforms URLs before comparing them with the provided value. URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: Matches the URL path, excluding leading hostname and trailing query parameters. The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values} Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__227ab89d16a858d8c6e4cdbdfff516e19ea4137ad5b6c14d7aa2a852ba02b97c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument normalize", value=normalize, expected_type=type_hints["normalize"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if normalize is not None:
            self._values["normalize"] = normalize
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the contents of the ``values`` array.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def normalize(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Transforms URLs before comparing them with the provided value.

        URLs are decoded, and any directory syntax such as ``../..`` or ``//`` is stripped as a security measure. This protects URL paths from being accessed by unauthorized users.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#normalize DataAkamaiPropertyRulesBuilder#normalize}
        '''
        result = self._values.get("normalize")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Matches the URL path, excluding leading hostname and trailing query parameters.

        The path is relative to the server root, for example ``/blog``. This field allows wildcards, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``/blog/* /2014`` matches paths with two fixed segments and other varying segments between them.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}

        Note: The above comment contained a comment block ending sequence (* followed by /). We have introduced a space between to prevent syntax errors. Please ignore the space.
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPathOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPathOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a78a93ceb0f5681a38239e9a174bc7b5ce55c8f6589983340655593b76b2b966)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNormalize")
    def reset_normalize(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNormalize", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="normalizeInput")
    def normalize_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "normalizeInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__72340353d75f00a7a520890274d13451a307f333512f203357a8da4458106205)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0bdf723676c2496470d5cb14b1a99884dcec604fc7418a682650fe65a5afb4af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e03ae4c43d44d4269cc8f69de4fe8d7dce8f76c6f738a1e36a69e555a937fcff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="normalize")
    def normalize(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "normalize"))

    @normalize.setter
    def normalize(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ffbfcf43ba15978f29df9e2b73434e82eb0ef8b58f985845335f13511ab35a22)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "normalize", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3de3b66c59230e4d53e811987f31a106ab4aa820f7d8ec9883cf327174dae7fb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__339b8fd723b984fed83fe09d040f80cf4743e0b703b3b2fff23385c21d0732dd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__870ef1d74def58700afa1d03e5adb28596b481e56d8eb2b69bd229a8d5964e05)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e73d7e05ea35002484cbd9ba2f7d16a91d5dd470a4ee840b83984fc992e83c7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter",
    jsii_struct_bases=[],
    name_mapping={
        "escape_value": "escapeValue",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "parameter_name": "parameterName",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter:
    def __init__(
        self,
        *,
        escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        parameter_name: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param escape_value: Matches when the ``value`` is URL-escaped. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: Specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``parameterName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param parameter_name: The name of the query field, for example, ``q`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The value of the query field, for example, ``string`` in ``?q=string``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2ce566b9089df2918187bb250d57c219a71e46fbb2c683348d858eaac0233480)
            check_type(argname="argument escape_value", value=escape_value, expected_type=type_hints["escape_value"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument parameter_name", value=parameter_name, expected_type=type_hints["parameter_name"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if escape_value is not None:
            self._values["escape_value"] = escape_value
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if parameter_name is not None:
            self._values["parameter_name"] = parameter_name
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def escape_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches when the ``value`` is URL-escaped.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#escape_value DataAkamaiPropertyRulesBuilder#escape_value}
        '''
        result = self._values.get("escape_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''Specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``parameterName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``parameterName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def parameter_name(self) -> typing.Optional[builtins.str]:
        '''The name of the query field, for example, ``q`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#parameter_name DataAkamaiPropertyRulesBuilder#parameter_name}
        '''
        result = self._values.get("parameter_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The value of the query field, for example, ``string`` in ``?q=string``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameterOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameterOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d2881598c9cef1e080498fc30ec9766e79e42dfb7898dbbf8f93376ef12d2d78)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetEscapeValue")
    def reset_escape_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEscapeValue", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetParameterName")
    def reset_parameter_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetParameterName", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="escapeValueInput")
    def escape_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "escapeValueInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="parameterNameInput")
    def parameter_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "parameterNameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="escapeValue")
    def escape_value(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "escapeValue"))

    @escape_value.setter
    def escape_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__67eefa6a0867b2ab2ead0398931b10aaba15db989f5735d81fb3c407eba57b10)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "escapeValue", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3eda5683cef963a0cc7616e14c71d2212b6edcd64d712eaebe9b0370729b4588)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__db7b6fd3c640169982711364f116d9db560ff8f7cbdfdecd30fe2f5a785cc8dc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59874b6837011dd95f58e0595825dc617ffd8a6db9d36a83eeffd6732a829e75)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7efa81813ce731d3d3422cd6e2196af0404acda1c43e3c9836f96472e2bd0349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c7d6c184017a67301af3f98a71261272b7a2113a1d953e56cc894425c2296dd5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__374f9a4422fcf4766e6896ea159c52c80554727f69ef90706f4cd8893f556239)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63818807ebc7e76d9c2894f4dcba38bdf4103293ac447a2b50fb32b603f0f5af)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="parameterName")
    def parameter_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "parameterName"))

    @parameter_name.setter
    def parameter_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2bbcfd4b427f2276e928bb2926bae5977c05220ea4a4d6afc322841d8323c1da)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "parameterName", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__95f0c9470dc175d741c015db5106dcba38730f6904fbc999222eef87aafff3b5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd8f859116c4aa9e1c34027b9ed1d21114a8f5e8bd744c73a1822bfbc9346d77)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6d3019ee6c066b80cc05b24344eae09c5fb458339940400d751776db9b9a3394)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__66677c0818f8d84bbbbcd5b20a4eb8b4d79c7b381ad9b0eb39b551d0fd5835d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0370204efc79552cc079da5ec140573f297b8735f9621880e17b275be80218d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom",
    jsii_struct_bases=[],
    name_mapping={
        "bucket": "bucket",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom:
    def __init__(
        self,
        *,
        bucket: typing.Optional[jsii.Number] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bucket: Specify a percentage of random requests to which to apply a behavior. Any remainders do not match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__788e4f8fcefdb43b6a1c2896a441cc085335e9e16cdb89cb1b1543c49f403e32)
            check_type(argname="argument bucket", value=bucket, expected_type=type_hints["bucket"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bucket is not None:
            self._values["bucket"] = bucket
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bucket(self) -> typing.Optional[jsii.Number]:
        '''Specify a percentage of random requests to which to apply a behavior. Any remainders do not match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bucket DataAkamaiPropertyRulesBuilder#bucket}
        '''
        result = self._values.get("bucket")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandomOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandomOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ccefa64383587f62cb8d647aa80ae8a6372954543a3bfaf274eee4042afff422)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBucket")
    def reset_bucket(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBucket", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bucketInput")
    def bucket_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "bucketInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bucket")
    def bucket(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "bucket"))

    @bucket.setter
    def bucket(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__133e7a5bac654f5e49174d6c8aba2657fee631905c0774917edb1c0ae516e3df)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bucket", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__791e8d01da3f3e529d6a4682e3e1f405912a14ae7a2a723affdfa4944a406d0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__82b8f00d363fb1e70c176d726e5380cca2e3a1558a9d8ee570f24dd3cc838929)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__186c7f5ff16800d523f8e4ae72c4d9247bf4984bb90520177e55c05b5c43093a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__05b08b747bffc3473d9d69a6aea18454189bf18dedcfbac81e5336a7fcdaadba)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig",
    jsii_struct_bases=[],
    name_mapping={
        "config_name": "configName",
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig:
    def __init__(
        self,
        *,
        config_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param config_name: A unique identifier used for origin failure recovery configurations. This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c6fe3c7cf2b06edf4ba2cd413a3bec3f415ed586ff1c1e53c120e7283af544f)
            check_type(argname="argument config_name", value=config_name, expected_type=type_hints["config_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if config_name is not None:
            self._values["config_name"] = config_name
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def config_name(self) -> typing.Optional[builtins.str]:
        '''A unique identifier used for origin failure recovery configurations.

        This is the recovery method configuration name you apply when setting origin failure recovery methods and scenarios in ``originFailureRecoveryMethod`` and ``originFailureRecoveryPolicy`` behaviors. The value can contain alphanumeric characters and dashes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#config_name DataAkamaiPropertyRulesBuilder#config_name}
        '''
        result = self._values.get("config_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfigOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfigOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc8b175ff36baca60153b541cdb9fc305c29f369084b0a86b0a79b7b7bf36cda)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetConfigName")
    def reset_config_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetConfigName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="configNameInput")
    def config_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "configNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="configName")
    def config_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "configName"))

    @config_name.setter
    def config_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__471a9b3a4a38333d987f9ddd30bf5bcc73ada24b33f590335885dc520d90da8e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "configName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__70e35ace0243c492c9ab79593e6a0e52c9809e321a1dffc08dd0205f5033654f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5d5e4bc251ae6a81cdd39bd1920b55eb1c7bd5cfcaac66eb9702a0163aebc601)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c89e7efb7273cda3ad94694e13fac873df26a6e45dbccb46abf651edc883216)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c43f94c61fc8fee8840069f3a69f725742d61afb69ec0ebceb8950c2f5d239c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression",
    jsii_struct_bases=[],
    name_mapping={
        "case_sensitive": "caseSensitive",
        "locked": "locked",
        "match_string": "matchString",
        "regex": "regex",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression:
    def __init__(
        self,
        *,
        case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_string: typing.Optional[builtins.str] = None,
        regex: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param case_sensitive: Sets a case-sensitive regular expression match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_string: The string to match, typically the contents of a dynamic variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        :param regex: The regular expression (PCRE) to match against the string. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20a4509b8d217e7203e77c4402a3168fe70f830ff57b5acf328128a169a6ba97)
            check_type(argname="argument case_sensitive", value=case_sensitive, expected_type=type_hints["case_sensitive"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_string", value=match_string, expected_type=type_hints["match_string"])
            check_type(argname="argument regex", value=regex, expected_type=type_hints["regex"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if case_sensitive is not None:
            self._values["case_sensitive"] = case_sensitive
        if locked is not None:
            self._values["locked"] = locked
        if match_string is not None:
            self._values["match_string"] = match_string
        if regex is not None:
            self._values["regex"] = regex
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive regular expression match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#case_sensitive DataAkamaiPropertyRulesBuilder#case_sensitive}
        '''
        result = self._values.get("case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_string(self) -> typing.Optional[builtins.str]:
        '''The string to match, typically the contents of a dynamic variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_string DataAkamaiPropertyRulesBuilder#match_string}
        '''
        result = self._values.get("match_string")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regex(self) -> typing.Optional[builtins.str]:
        '''The regular expression (PCRE) to match against the string.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regex DataAkamaiPropertyRulesBuilder#regex}
        '''
        result = self._values.get("regex")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpressionOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpressionOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b83c6d9a8f490bfc4b4d42c6058e93e80494b283e35b5685077afc93647a4ff1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCaseSensitive")
    def reset_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCaseSensitive", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchString")
    def reset_match_string(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchString", []))

    @jsii.member(jsii_name="resetRegex")
    def reset_regex(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegex", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="caseSensitiveInput")
    def case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "caseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchStringInput")
    def match_string_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchStringInput"))

    @builtins.property
    @jsii.member(jsii_name="regexInput")
    def regex_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "regexInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="caseSensitive")
    def case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "caseSensitive"))

    @case_sensitive.setter
    def case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c7170927714c3c0c28709effd695aaf44d7923b8051a1a51566d9f82532fafb)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "caseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ae75c5cd8bf62a112fc8db99d99abe2c293942d1f5e48ca4516989fcfec3c376)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchString")
    def match_string(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchString"))

    @match_string.setter
    def match_string(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a648c781ce43078373edfcb5bf080282c1f1e2a687f5a474dca1992cc68c3d01)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchString", value)

    @builtins.property
    @jsii.member(jsii_name="regex")
    def regex(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "regex"))

    @regex.setter
    def regex(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eeb95030849af3443eedf4bd7c19401e6293b8e19e10b21720568aa39bea064f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regex", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9bd5a58b7e7de36cf7a9192a4367b00cf74f8cbe97a49e9701fad931e83b4024)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d0909fbe2d7e6c2f95e12dcf6db1473f1d283052e5d952db4b5608dafb67140)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e6c58cf26b9a6291d1b4a9a2125a38092cf41d2ad4cec00cb3031230a2636515)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie",
    jsii_struct_bases=[],
    name_mapping={
        "cookie_name": "cookieName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_name": "matchCaseSensitiveName",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie:
    def __init__(
        self,
        *,
        cookie_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param cookie_name: The name of the cookie, for example, ``visitor`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_name: Sets a case-sensitive match for the ``cookieName`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: The cookie's value, for example, ``anon`` in ``visitor:anon``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0f030d5dbbfa678c92071a48071f278bd680ef63b105bd0b50ccea011bed550)
            check_type(argname="argument cookie_name", value=cookie_name, expected_type=type_hints["cookie_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_name", value=match_case_sensitive_name, expected_type=type_hints["match_case_sensitive_name"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if cookie_name is not None:
            self._values["cookie_name"] = cookie_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_name is not None:
            self._values["match_case_sensitive_name"] = match_case_sensitive_name
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def cookie_name(self) -> typing.Optional[builtins.str]:
        '''The name of the cookie, for example, ``visitor`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#cookie_name DataAkamaiPropertyRulesBuilder#cookie_name}
        '''
        result = self._values.get("cookie_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``cookieName`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_name DataAkamaiPropertyRulesBuilder#match_case_sensitive_name}
        '''
        result = self._values.get("match_case_sensitive_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``cookieName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''The cookie's value, for example, ``anon`` in ``visitor:anon``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookieOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookieOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d6779d0adc109dade38be138b8142a37c4532ed5cf79433d27ca758fe1ac02f1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCookieName")
    def reset_cookie_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCookieName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveName")
    def reset_match_case_sensitive_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveName", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="cookieNameInput")
    def cookie_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "cookieNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveNameInput")
    def match_case_sensitive_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="cookieName")
    def cookie_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "cookieName"))

    @cookie_name.setter
    def cookie_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ad1b99d7c0077020c7c2b8496da2d1be8087ca65e3de952d7cdcad8c9dc40270)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "cookieName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a80d34ad602ae75221d700e79903b080a60df7a39cd2f89e484165360edd157a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a0bc164426516d7ea46efa0e7aaa7e99e7d6577a9db99ad7bd73a5f7e86cc452)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveName")
    def match_case_sensitive_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveName"))

    @match_case_sensitive_name.setter
    def match_case_sensitive_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4eb134acf9f01938e8a1bcb0dd1686aae115662c62d441b3a71d34a2c143edcc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveName", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1579a6d59695941c7632ede348539c7a35e9db91a331c290ab0a91d82d2f1d9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__014567db57c2e76180ef7616972ed6c922e0d77bc200d397f45d774b15a5b792)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03be9156ce0d253211a2d7559b92c685f7559c11fece09e22c440a9d001031b9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__38adbd57ad309c5e5c13c8be5cccc74fb651e3666bfcc1b56483fd3cdb1af8b6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__47848bcb81e15bf2dc13809c4cbbc2991db2e051df5bee5c679b51fe80d45967)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b5f1e7c50eeae09fb380404ba35688a93f3430e08129dcc91fadd6dd673dd0a1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f1a68159081477441155ba25c3387a57818e579eb59c69f27663a8621ebd61)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__397093a859e8b8fecdda0a2aede186e0a4b1b9c34b8d16e7a7a46c096c8c8ab5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d5a280331e68366a4d214bbf6816194baec9fa7ba18b8694565bf924358b82a8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the request header, for example ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive_value: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a3a7b6dedaec985a82ea52a76de7345a18072d7ee2e8bf47ab2ffb28d8bcb420)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the request header, for example ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The request header's value, for example ``en-US`` when the header ``headerName`` is ``Accept-Language``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aec7bf27dc29757d63676f8a6699b95bb53275d5c48e8812c33bb727354e40b3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21bd66bb884009aa0ab135cc4bf698750667bfc23dc6eeb1b25c6f0aab3aebef)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__da27a862cfd37d565f073a98f409f266dabb758129c90a37a1ab645f972172cd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__43ecb5cdbd509be7dbfbe04322cbee012b4e3575cd936a48c1380c6f3dae3997)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__589b97364483ef38005229cc2dfebc01a80f2398d62af2797a73bbfa38e45816)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1341ed7d5cedbe80429eb4b5fbc9f458ed0d3f3c909b2bc2fa51236dd350394c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__613506e25d7a006d8208a2480e42623b354d1655129c352b9e5b620b630e827c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1334d672e04b0d2a14dff89a48b3864ac881aa75b67b20ccb575dc4683ca0abd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03f9ea8cbd18ea84fdd3132fa8f5372b48a3c2719f7c5ac7cd7536b2141510b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7af2e96feffb20065913a308990fc388d058308238b20d224781118f10b2cfc1)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__36b17e3642b906764c8f5650e451f32e826f87fa471eceab35629a4d967269a2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Any of these HTTP methods, WebDAV methods, or Akamai operations. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__695317ba2b80f749dea23447a19355a20ebeb8e51e7cf792263ad12c471ec075)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the ``value`` when set to ``IS``, otherwise ``IS_NOT`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Any of these HTTP methods,  WebDAV methods, or Akamai operations.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethodOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethodOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ba54d43a854dcafd58c886e8dd6fcb299a3d1e4bae10b7847b8bf80b836ae395)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f5ad4ce9ed47c98de353f0c663f3afad6d2d76cc52c40f606f8202c2994767f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4fab0c52c2a7cb5f72122a9e3b177d1e73b1012a346e2e8c78aaf7d72f1a046a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6549ed6710bcb7d2840efab7d406fa86ddfdf3ded77289d32b30b1e96ef78628)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d8a97443e63f8616c6f885daa4f09feaf4a7b04fc924149ce707cd5349a7cb6a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d863e42e44bdb6136c45c24136ce321575a00eca6cbc6a737468e51376a319d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__adcca86ff0c7a621f1faceca5a5fca7379af20c5563bffa250f8332f5f63b3fd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the protocol. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__365339a0fc2c05fa5dd27ae8cb80abe9b2de8b4ad10b4b54239e7abe4abc8b4c)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the protocol.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocolOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocolOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f14b8037e10507e694343f1420e9eed1f496cfde573cd8a4941c0b283d243788)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c1ea917581b92355889cc47ae7ad0edbb2ac1d410a9e21f7abfe5a875fa90ba5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b85ecbc704a466c89499b450c113cca8693904f2c52b1d1f6dec9d214890536c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a5c5912310f153985aa3c271ab24df84f41a81d6726b0d0b45848beac2028754)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__71bdbf349095e372fa859a62aa9a3b48383a59904c17f6b416e76464aeb3c63d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d39ee647aea3bd9756fa7ea7e577b74b834dec2da943236a2aaffdbfef7633e2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        value: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param value: Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3a9221156f46ce1318c9425ffc31ceb448cc19a5890dfa594de08a2dbbdf9001)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if value is not None:
            self._values["value"] = value

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies whether the request ``IS`` or ``IS_NOT`` the type of specified ``value``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def value(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request, either a standard ``CLIENT_REQ``, an ``ESI_FRAGMENT``, or an ``EW_SUBREQUEST``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestTypeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestTypeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4c2cc2389ca5712788a7eefa09a452b620d66115c4c9fe02e7a34402ce5d225e)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValue")
    def reset_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValue", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0624f12a7f9847882b5d144f0cb9c20ce303900b3de90bc21683ba2df70cc00f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c4b99891031f732126d4bdf911b5b21e02cb31b46b39d4680c99b637c7674663)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__10c7008fe6e48d54fd2dd8dcbee71301fe7de1710effdc5747d027f69030cab2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5eae00883d293f161486c159bdc091c97795dcd43f0967b0bef5bd7a629f3c2a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86249e26227726b985a0c241742da8e40c63a36d3b7dee0829e15eb5d21cbc1c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d10073c69e92a7535261aae109db3189e92df8d9a3711708b12708e2d50c4941)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader",
    jsii_struct_bases=[],
    name_mapping={
        "header_name": "headerName",
        "locked": "locked",
        "lower_bound": "lowerBound",
        "match_case_sensitive_value": "matchCaseSensitiveValue",
        "match_operator": "matchOperator",
        "match_wildcard_name": "matchWildcardName",
        "match_wildcard_value": "matchWildcardValue",
        "template_uuid": "templateUuid",
        "upper_bound": "upperBound",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader:
    def __init__(
        self,
        *,
        header_name: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        lower_bound: typing.Optional[jsii.Number] = None,
        match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        upper_bound: typing.Optional[jsii.Number] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param header_name: The name of the response header, for example ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param lower_bound: When the ``value`` is numeric, this field specifies the match's minimum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        :param match_case_sensitive_value: When enabled, the match is case-sensitive for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        :param match_operator: Narrows the match according to various criteria. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard_name: Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        :param match_wildcard_value: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param upper_bound: When the ``value`` is numeric, this field specifies the match's maximum value. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__63f5a13a3ac2026528418cd1ac83399345a38b14d0e497ef47c627b6a6afdbf7)
            check_type(argname="argument header_name", value=header_name, expected_type=type_hints["header_name"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument lower_bound", value=lower_bound, expected_type=type_hints["lower_bound"])
            check_type(argname="argument match_case_sensitive_value", value=match_case_sensitive_value, expected_type=type_hints["match_case_sensitive_value"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard_name", value=match_wildcard_name, expected_type=type_hints["match_wildcard_name"])
            check_type(argname="argument match_wildcard_value", value=match_wildcard_value, expected_type=type_hints["match_wildcard_value"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument upper_bound", value=upper_bound, expected_type=type_hints["upper_bound"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if header_name is not None:
            self._values["header_name"] = header_name
        if locked is not None:
            self._values["locked"] = locked
        if lower_bound is not None:
            self._values["lower_bound"] = lower_bound
        if match_case_sensitive_value is not None:
            self._values["match_case_sensitive_value"] = match_case_sensitive_value
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard_name is not None:
            self._values["match_wildcard_name"] = match_wildcard_name
        if match_wildcard_value is not None:
            self._values["match_wildcard_value"] = match_wildcard_value
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if upper_bound is not None:
            self._values["upper_bound"] = upper_bound
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def header_name(self) -> typing.Optional[builtins.str]:
        '''The name of the response header, for example ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#header_name DataAkamaiPropertyRulesBuilder#header_name}
        '''
        result = self._values.get("header_name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def lower_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's minimum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lower_bound DataAkamaiPropertyRulesBuilder#lower_bound}
        '''
        result = self._values.get("lower_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def match_case_sensitive_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When enabled, the match is case-sensitive for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive_value DataAkamaiPropertyRulesBuilder#match_case_sensitive_value}
        '''
        result = self._values.get("match_case_sensitive_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Narrows the match according to various criteria.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard_name(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``headerName`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_name DataAkamaiPropertyRulesBuilder#match_wildcard_name}
        '''
        result = self._values.get("match_wildcard_name")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_wildcard_value(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard_value DataAkamaiPropertyRulesBuilder#match_wildcard_value}
        '''
        result = self._values.get("match_wildcard_value")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def upper_bound(self) -> typing.Optional[jsii.Number]:
        '''When the ``value`` is numeric, this field specifies the match's maximum value.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#upper_bound DataAkamaiPropertyRulesBuilder#upper_bound}
        '''
        result = self._values.get("upper_bound")
        return typing.cast(typing.Optional[jsii.Number], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The response header's value, for example ``application/x-www-form-urlencoded`` when the header ``headerName`` is ``Content-Type``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeaderOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeaderOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__34d098e6c319cc7e1d984c2be4b6cb06f1f2e43683a3d16bfc5a1832a373f3ef)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetHeaderName")
    def reset_header_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetHeaderName", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetLowerBound")
    def reset_lower_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLowerBound", []))

    @jsii.member(jsii_name="resetMatchCaseSensitiveValue")
    def reset_match_case_sensitive_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitiveValue", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcardName")
    def reset_match_wildcard_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardName", []))

    @jsii.member(jsii_name="resetMatchWildcardValue")
    def reset_match_wildcard_value(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcardValue", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUpperBound")
    def reset_upper_bound(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUpperBound", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="headerNameInput")
    def header_name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "headerNameInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="lowerBoundInput")
    def lower_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "lowerBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValueInput")
    def match_case_sensitive_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveValueInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardNameInput")
    def match_wildcard_name_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardNameInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValueInput")
    def match_wildcard_value_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardValueInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="upperBoundInput")
    def upper_bound_input(self) -> typing.Optional[jsii.Number]:
        return typing.cast(typing.Optional[jsii.Number], jsii.get(self, "upperBoundInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="headerName")
    def header_name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "headerName"))

    @header_name.setter
    def header_name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f37315ef33ad961ef66f895c049627cac800e7480b22b05096fff875aca9b33a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "headerName", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__eae59def5df490cc68876172fdf8d87048f231ab1b1734443114eca24ddea4c0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="lowerBound")
    def lower_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "lowerBound"))

    @lower_bound.setter
    def lower_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee72a5340b2103906641d22b33e7ad34ed460ba653add0dca76f27241cad680c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lowerBound", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveValue")
    def match_case_sensitive_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitiveValue"))

    @match_case_sensitive_value.setter
    def match_case_sensitive_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__253e5512178c3d3d7bf5ce3ceb6c8b387b7eaaa01c05ef6f3754c4345d73f558)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitiveValue", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__03b18dc30f0563ee1f246c07bbcdf9e163ab02cdff2e5011821b8f26ba938134)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardName")
    def match_wildcard_name(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardName"))

    @match_wildcard_name.setter
    def match_wildcard_name(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__35d4cced69744e42b51a3fe7a61eec1db5cd932541f9844bbe4f092fe09b8857)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardName", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcardValue")
    def match_wildcard_value(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcardValue"))

    @match_wildcard_value.setter
    def match_wildcard_value(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c091716ada9ab83d0b702f602bc5b0b23bd913f9d8e3ea56c389ec7e246e18c9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcardValue", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1005943eea919d7f155ca4d83a6db6544d3fb3bf27b93934d0c30e618b10a4f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="upperBound")
    def upper_bound(self) -> jsii.Number:
        return typing.cast(jsii.Number, jsii.get(self, "upperBound"))

    @upper_bound.setter
    def upper_bound(self, value: jsii.Number) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__379d7b7e7cfd86fc2f336a19caa6656db1600a6cfd49eb6787086595a023fd29)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "upperBound", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3149838cabce2dfe2ed0f200cc7ed97a86b4007a4e5bd0f97cdb6b39017f000a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e48b9410b5ffbf74c0381d06b9cd74c92d0f20dd97b8297155720483cff7b8cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__658d8c5a49fb741f6a422839a93c531ec190ccf1d4de1a7558f9e445b9a899f7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation",
    jsii_struct_bases=[],
    name_mapping={
        "continents": "continents",
        "countries": "countries",
        "location_type": "locationType",
        "locked": "locked",
        "match_operator": "matchOperator",
        "regions": "regions",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation:
    def __init__(
        self,
        *,
        continents: typing.Optional[typing.Sequence[builtins.str]] = None,
        countries: typing.Optional[typing.Sequence[builtins.str]] = None,
        location_type: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        regions: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param continents: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        :param countries: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        :param location_type: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param regions: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1c0312e30391e481f5e6b9427a1a09ada44f9a99395a92675288b3340e76c848)
            check_type(argname="argument continents", value=continents, expected_type=type_hints["continents"])
            check_type(argname="argument countries", value=countries, expected_type=type_hints["countries"])
            check_type(argname="argument location_type", value=location_type, expected_type=type_hints["location_type"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument regions", value=regions, expected_type=type_hints["regions"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if continents is not None:
            self._values["continents"] = continents
        if countries is not None:
            self._values["countries"] = countries
        if location_type is not None:
            self._values["location_type"] = location_type
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if regions is not None:
            self._values["regions"] = regions
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def continents(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continents DataAkamaiPropertyRulesBuilder#continents}
        '''
        result = self._values.get("continents")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def countries(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#countries DataAkamaiPropertyRulesBuilder#countries}
        '''
        result = self._values.get("countries")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def location_type(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#location_type DataAkamaiPropertyRulesBuilder#location_type}
        '''
        result = self._values.get("location_type")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def regions(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#regions DataAkamaiPropertyRulesBuilder#regions}
        '''
        result = self._values.get("regions")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ac17931ba0b3fba889877c1cda29d339985e4226bde707c04a7ce242626ecfac)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetContinents")
    def reset_continents(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinents", []))

    @jsii.member(jsii_name="resetCountries")
    def reset_countries(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountries", []))

    @jsii.member(jsii_name="resetLocationType")
    def reset_location_type(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocationType", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegions")
    def reset_regions(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegions", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="continentsInput")
    def continents_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentsInput"))

    @builtins.property
    @jsii.member(jsii_name="countriesInput")
    def countries_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countriesInput"))

    @builtins.property
    @jsii.member(jsii_name="locationTypeInput")
    def location_type_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "locationTypeInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionsInput")
    def regions_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionsInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="continents")
    def continents(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continents"))

    @continents.setter
    def continents(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__774eaae17f8c584e90a295932b11f79f412e8f4c25a4ad070274b0a6e05375ce)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continents", value)

    @builtins.property
    @jsii.member(jsii_name="countries")
    def countries(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countries"))

    @countries.setter
    def countries(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__903736816160d8317b7535d4910e0e0d8ddf5f6bbdaa8bc36ab1a832eeba274d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countries", value)

    @builtins.property
    @jsii.member(jsii_name="locationType")
    def location_type(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "locationType"))

    @location_type.setter
    def location_type(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9f89b40e6190c58b4e8eae15979b7be4687be27f706f4e3de8a888d1c43e4df8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locationType", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c62e8deced25b29dc2a0db48e7b0cdbf2b5333fb6efa7d7d62cb57b456e3b297)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85a221f05e232e8786dbbe0ba50e2a36d62dbae25a848e2fc7a051fc847bc7db)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regions")
    def regions(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regions"))

    @regions.setter
    def regions(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__79e3253b6670368eb96d16615d31160c64ef9b192e092d013c3b6afbb0ac40e9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regions", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7455645fd384e8e5dd3a93db6b81f81004b92258457a4bfcd37fffc42e1b411e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4823b1a15b3c82d3e586a5e3ed25fa49da779364d3297584b612b88ba1334583)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e16b1d39db6f92feacc486c0249a74b223c9b8043e79c6139f08d22c5e8adb9f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime",
    jsii_struct_bases=[],
    name_mapping={
        "apply_daylight_savings_time": "applyDaylightSavingsTime",
        "begin_date": "beginDate",
        "end_date": "endDate",
        "lasting_date": "lastingDate",
        "lasting_duration": "lastingDuration",
        "locked": "locked",
        "match_operator": "matchOperator",
        "repeat_begin_date": "repeatBeginDate",
        "repeat_duration": "repeatDuration",
        "repeat_interval": "repeatInterval",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime:
    def __init__(
        self,
        *,
        apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        begin_date: typing.Optional[builtins.str] = None,
        end_date: typing.Optional[builtins.str] = None,
        lasting_date: typing.Optional[builtins.str] = None,
        lasting_duration: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        repeat_begin_date: typing.Optional[builtins.str] = None,
        repeat_duration: typing.Optional[builtins.str] = None,
        repeat_interval: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param apply_daylight_savings_time: Adjusts the start time plus repeat interval to account for daylight saving time. Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        :param begin_date: Sets the start of a time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        :param end_date: Sets the end of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        :param lasting_date: Sets the start of a fixed time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        :param lasting_duration: Specifies the end of a time period as a duration relative to the ``lastingDate``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Specifies how to define the range of time. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param repeat_begin_date: Sets the start of the initial time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        :param repeat_duration: Sets the duration of each repeating time period. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        :param repeat_interval: Sets the time between each repeating time period's starting points. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__59bb591b5b3c80a317068a79a8d876fa66a98dfa2f71c01b64fcbed7cfd6c013)
            check_type(argname="argument apply_daylight_savings_time", value=apply_daylight_savings_time, expected_type=type_hints["apply_daylight_savings_time"])
            check_type(argname="argument begin_date", value=begin_date, expected_type=type_hints["begin_date"])
            check_type(argname="argument end_date", value=end_date, expected_type=type_hints["end_date"])
            check_type(argname="argument lasting_date", value=lasting_date, expected_type=type_hints["lasting_date"])
            check_type(argname="argument lasting_duration", value=lasting_duration, expected_type=type_hints["lasting_duration"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument repeat_begin_date", value=repeat_begin_date, expected_type=type_hints["repeat_begin_date"])
            check_type(argname="argument repeat_duration", value=repeat_duration, expected_type=type_hints["repeat_duration"])
            check_type(argname="argument repeat_interval", value=repeat_interval, expected_type=type_hints["repeat_interval"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if apply_daylight_savings_time is not None:
            self._values["apply_daylight_savings_time"] = apply_daylight_savings_time
        if begin_date is not None:
            self._values["begin_date"] = begin_date
        if end_date is not None:
            self._values["end_date"] = end_date
        if lasting_date is not None:
            self._values["lasting_date"] = lasting_date
        if lasting_duration is not None:
            self._values["lasting_duration"] = lasting_duration
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if repeat_begin_date is not None:
            self._values["repeat_begin_date"] = repeat_begin_date
        if repeat_duration is not None:
            self._values["repeat_duration"] = repeat_duration
        if repeat_interval is not None:
            self._values["repeat_interval"] = repeat_interval
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def apply_daylight_savings_time(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Adjusts the start time plus repeat interval to account for daylight saving time.

        Applies when the current time and the start time use different systems, daylight and standard, and the two values are in conflict.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#apply_daylight_savings_time DataAkamaiPropertyRulesBuilder#apply_daylight_savings_time}
        '''
        result = self._values.get("apply_daylight_savings_time")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#begin_date DataAkamaiPropertyRulesBuilder#begin_date}
        '''
        result = self._values.get("begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def end_date(self) -> typing.Optional[builtins.str]:
        '''Sets the end of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#end_date DataAkamaiPropertyRulesBuilder#end_date}
        '''
        result = self._values.get("end_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of a fixed time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_date DataAkamaiPropertyRulesBuilder#lasting_date}
        '''
        result = self._values.get("lasting_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def lasting_duration(self) -> typing.Optional[builtins.str]:
        '''Specifies the end of a time period as a duration relative to the ``lastingDate``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#lasting_duration DataAkamaiPropertyRulesBuilder#lasting_duration}
        '''
        result = self._values.get("lasting_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies how to define the range of time.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_begin_date(self) -> typing.Optional[builtins.str]:
        '''Sets the start of the initial time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_begin_date DataAkamaiPropertyRulesBuilder#repeat_begin_date}
        '''
        result = self._values.get("repeat_begin_date")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_duration(self) -> typing.Optional[builtins.str]:
        '''Sets the duration of each repeating time period.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_duration DataAkamaiPropertyRulesBuilder#repeat_duration}
        '''
        result = self._values.get("repeat_duration")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def repeat_interval(self) -> typing.Optional[builtins.str]:
        '''Sets the time between each repeating time period's starting points.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#repeat_interval DataAkamaiPropertyRulesBuilder#repeat_interval}
        '''
        result = self._values.get("repeat_interval")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTimeOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTimeOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__603216c284c05b71c82c9af6a7ec05187d8543a386ac2d09eb4c34aa01c65e4d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetApplyDaylightSavingsTime")
    def reset_apply_daylight_savings_time(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetApplyDaylightSavingsTime", []))

    @jsii.member(jsii_name="resetBeginDate")
    def reset_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBeginDate", []))

    @jsii.member(jsii_name="resetEndDate")
    def reset_end_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetEndDate", []))

    @jsii.member(jsii_name="resetLastingDate")
    def reset_lasting_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDate", []))

    @jsii.member(jsii_name="resetLastingDuration")
    def reset_lasting_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLastingDuration", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRepeatBeginDate")
    def reset_repeat_begin_date(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatBeginDate", []))

    @jsii.member(jsii_name="resetRepeatDuration")
    def reset_repeat_duration(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatDuration", []))

    @jsii.member(jsii_name="resetRepeatInterval")
    def reset_repeat_interval(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRepeatInterval", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTimeInput")
    def apply_daylight_savings_time_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "applyDaylightSavingsTimeInput"))

    @builtins.property
    @jsii.member(jsii_name="beginDateInput")
    def begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "beginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="endDateInput")
    def end_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "endDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDateInput")
    def lasting_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDateInput"))

    @builtins.property
    @jsii.member(jsii_name="lastingDurationInput")
    def lasting_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "lastingDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDateInput")
    def repeat_begin_date_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatBeginDateInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatDurationInput")
    def repeat_duration_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatDurationInput"))

    @builtins.property
    @jsii.member(jsii_name="repeatIntervalInput")
    def repeat_interval_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "repeatIntervalInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="applyDaylightSavingsTime")
    def apply_daylight_savings_time(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "applyDaylightSavingsTime"))

    @apply_daylight_savings_time.setter
    def apply_daylight_savings_time(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f4189df5d8d9ccf7a728d204b674f799f9ee8281323ecc9f45e1b34c55137f89)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "applyDaylightSavingsTime", value)

    @builtins.property
    @jsii.member(jsii_name="beginDate")
    def begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "beginDate"))

    @begin_date.setter
    def begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__404f4d10ccb2d1c64effa1cc22de15c00f50c93f9c75a82d5ab240872eee3e41)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "beginDate", value)

    @builtins.property
    @jsii.member(jsii_name="endDate")
    def end_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "endDate"))

    @end_date.setter
    def end_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f96bdaf1cf6dbc6104408ef9aa82982d6ad7aabef3cd22287218a5cbaeb3cf0f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "endDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDate")
    def lasting_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDate"))

    @lasting_date.setter
    def lasting_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cef6e0d1fa116669275728710ff06593b2cdcbaf43430520fa14ddf0ec9023a0)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDate", value)

    @builtins.property
    @jsii.member(jsii_name="lastingDuration")
    def lasting_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "lastingDuration"))

    @lasting_duration.setter
    def lasting_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__edf0094a7f96740adef0801fe793d644e35884e6ea33a5e207e9a73e8583694e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "lastingDuration", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f65bfc4b99c1c00d77071a667a2c9d9a7050f8abc39f9313051ec12f808364bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b0b18c2635b5198506c24e8fbe741af40bf3e9f96a2cdc29726288ed8eb6b58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="repeatBeginDate")
    def repeat_begin_date(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatBeginDate"))

    @repeat_begin_date.setter
    def repeat_begin_date(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8916ea34098e75c5ef757a308ecc48aa2989382a9811fa7a5f32afca2bf8433e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatBeginDate", value)

    @builtins.property
    @jsii.member(jsii_name="repeatDuration")
    def repeat_duration(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatDuration"))

    @repeat_duration.setter
    def repeat_duration(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7e68d9d8e2fa983cf58ba96ee5f02850e68ce3bd8f08aa7dd69481d77b6a5ff2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatDuration", value)

    @builtins.property
    @jsii.member(jsii_name="repeatInterval")
    def repeat_interval(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "repeatInterval"))

    @repeat_interval.setter
    def repeat_interval(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0cc394b57200b1042eb4ca8e273d3dd738816836cf5b60a33b5bcdf44ff95672)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "repeatInterval", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d8959cf9076f566cf2594751c420e8efb3915586cd9dd3c725e4fba61847fa7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b9957831a21c339dff0d69bcbf9d317797c0315e62bb200a826c8a928fbb5a19)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__18052ea6c9b61cdede61c4f54af4cba62db13218799aaaee7eb6fe35b499952c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_operator": "matchOperator",
        "status_list": "statusList",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Error match scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param status_list: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbe5cf1477c97f38ab56dd06efc32aa63bdfd522e2d728aca192d2367e3b0b41)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument status_list", value=status_list, expected_type=type_hints["status_list"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if status_list is not None:
            self._values["status_list"] = status_list
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Error match scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def status_list(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#status_list DataAkamaiPropertyRulesBuilder#status_list}.'''
        result = self._values.get("status_list")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorizationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorizationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86a1ab1800f37e91efe495bacd24865df8d6314ca15cccefab6b61a77e4c0f1c)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetStatusList")
    def reset_status_list(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetStatusList", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="statusListInput")
    def status_list_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "statusListInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e4dfa76f2b4de58a61d674c4f2bdba3957fa1c3398759f15929ce28613f5e159)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46af5f420ddee99e0d9f16727fb12790b5399e38e504b4348a9b1193c86a157a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="statusList")
    def status_list(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "statusList"))

    @status_list.setter
    def status_list(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1cbe60527125639bba5b35ed14e0e3ce952c1059f3f81c1d27f232c046ad966d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "statusList", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c3493b4fff15e9f1b5c2a0721bc35d23b04a65a09740cfd12026e37c17b9e8a7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e660d1cf4d9a860b04be158a112dea9914b4d16f73e9f0274a44157b396fe9cc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__39175aa1514083242b0810307e5452b13a7a3da0f0bb2c08b822ef0a9e436ad4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_case_sensitive": "matchCaseSensitive",
        "match_operator": "matchOperator",
        "match_wildcard": "matchWildcard",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "values": "values",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        values: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_case_sensitive: Sets a case-sensitive match for the ``value`` field. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        :param match_operator: Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param match_wildcard: Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param values: The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4270c82b7307160e48eb2e4bebd602cd23c5a938376094bca81ce4c5a08eabdf)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_case_sensitive", value=match_case_sensitive, expected_type=type_hints["match_case_sensitive"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument match_wildcard", value=match_wildcard, expected_type=type_hints["match_wildcard"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument values", value=values, expected_type=type_hints["values"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_case_sensitive is not None:
            self._values["match_case_sensitive"] = match_case_sensitive
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if match_wildcard is not None:
            self._values["match_wildcard"] = match_wildcard
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if values is not None:
            self._values["values"] = values

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_case_sensitive(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Sets a case-sensitive match for the ``value`` field.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_case_sensitive DataAkamaiPropertyRulesBuilder#match_case_sensitive}
        '''
        result = self._values.get("match_case_sensitive")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of ``values`` when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_wildcard(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Allows wildcards in the ``value`` field, where ``?`` matches a single character and ``*`` matches zero or more characters. For example, ``*Android*``, ``*iPhone5*``, ``*Firefox*``, or ``*Chrome*`` allow substring matches.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_wildcard DataAkamaiPropertyRulesBuilder#match_wildcard}
        '''
        result = self._values.get("match_wildcard")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The ``User-Agent`` header's value. For example, ``Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#values DataAkamaiPropertyRulesBuilder#values}
        '''
        result = self._values.get("values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgentOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgentOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9344d6fc91485af58c155590e22112ee1e35628c6faafdb152613f5b8ae4a21d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchCaseSensitive")
    def reset_match_case_sensitive(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchCaseSensitive", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetMatchWildcard")
    def reset_match_wildcard(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchWildcard", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetValues")
    def reset_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetValues", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitiveInput")
    def match_case_sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchCaseSensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="matchWildcardInput")
    def match_wildcard_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "matchWildcardInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="valuesInput")
    def values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "valuesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4f621b5e48830b572f92b77511a5da416659aea15c23326e95ffff6c4ee40b93)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchCaseSensitive")
    def match_case_sensitive(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchCaseSensitive"))

    @match_case_sensitive.setter
    def match_case_sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9628ae77c89167402e9975599286c492d8b260552a6364f52feab6ae5aed45ff)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchCaseSensitive", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e1e5341102bc9e0c348b786dfe9de16fb6f1cb9a394b6fdda336e7225f361a50)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="matchWildcard")
    def match_wildcard(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "matchWildcard"))

    @match_wildcard.setter
    def match_wildcard(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__86dfeee87381b6bd510bd17fe3430800994377087bfe1c7a78331ff79630319b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchWildcard", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce809d9d2a5d76c264c084cf00acef605e89450777b167632e5170fc4c94ed03)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd758da319c3f0cd35dd513415a27ada9242728e07ac634cb8cdd50c84588bf4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="values")
    def values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "values"))

    @values.setter
    def values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9aa097369bca78dd00cc03a34c52bb9a3a98549d2f10dddb757566e9261df349)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "values", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cd61ef598966e108bd8283587fcf21927bc70646b94347a584cb0682e31f6328)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation",
    jsii_struct_bases=[],
    name_mapping={
        "check_ips": "checkIps",
        "continent_values": "continentValues",
        "country_values": "countryValues",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "region_values": "regionValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation:
    def __init__(
        self,
        *,
        check_ips: typing.Optional[builtins.str] = None,
        continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param check_ips: Specifies which IP addresses determine the user's location. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param continent_values: Continent codes. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        :param country_values: ISO 3166-1 country codes, such as ``US`` or ``CN``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        :param field: Indicates the geographic scope. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param region_values: ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17986b5fa75542d47f2be06d37efd02bf1cd8585be26f92739db6dd672e5416b)
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument continent_values", value=continent_values, expected_type=type_hints["continent_values"])
            check_type(argname="argument country_values", value=country_values, expected_type=type_hints["country_values"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument region_values", value=region_values, expected_type=type_hints["region_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if continent_values is not None:
            self._values["continent_values"] = continent_values
        if country_values is not None:
            self._values["country_values"] = country_values
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if region_values is not None:
            self._values["region_values"] = region_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's location.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def continent_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Continent codes.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#continent_values DataAkamaiPropertyRulesBuilder#continent_values}
        '''
        result = self._values.get("continent_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def country_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166-1 country codes, such as ``US`` or ``CN``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#country_values DataAkamaiPropertyRulesBuilder#country_values}
        '''
        result = self._values.get("country_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''Indicates the geographic scope.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def region_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''ISO 3166 country and region codes, for example ``US:MA`` for Massachusetts or ``JP:13`` for Tokyo.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#region_values DataAkamaiPropertyRulesBuilder#region_values}
        '''
        result = self._values.get("region_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocationOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocationOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3ea485a35dcea73e8e71807d52cef67be5229cb1db9161a76b862b0fdb29645d)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetContinentValues")
    def reset_continent_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetContinentValues", []))

    @jsii.member(jsii_name="resetCountryValues")
    def reset_country_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCountryValues", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetRegionValues")
    def reset_region_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetRegionValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="continentValuesInput")
    def continent_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "continentValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="countryValuesInput")
    def country_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "countryValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="regionValuesInput")
    def region_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "regionValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__13eb3f56e9282827bfec8b09b97b89797310d4e2b0a178f6e9df3a64260d681e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="continentValues")
    def continent_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "continentValues"))

    @continent_values.setter
    def continent_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8932c2400fc1c0fe539ea5eaaa22a246d4f78e998d4c14a083ed17cae93ef994)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "continentValues", value)

    @builtins.property
    @jsii.member(jsii_name="countryValues")
    def country_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "countryValues"))

    @country_values.setter
    def country_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9d2c8b426a1f4fe1efa9c67e4a53f833c557ec344082fb6c4768442983f15c5b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "countryValues", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1d08633a98625b611ec1b0c929f72b76d7bced3262ede81e1912b64ab9bb026a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ab470dc8eddced061f927a6b6ac70878bf062fa35556b765fda770659143df9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bd2ecd38b291af5a64c8e9be856680556fc0f177161ab12a2c54a9eeca10e124)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="regionValues")
    def region_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "regionValues"))

    @region_values.setter
    def region_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d655cbc3ead0f2855ea62522c91e3056f496adb36a47c077b81b32e17dcb1d7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "regionValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ce150dddc0d62be2bb2b93bef62438e2c4b2925212dd0650919925e888e87131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a933e60ff4a2a1fcc78df361a842bd506bb1dfd77cb20d939dc9375a6cc293cf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__980b32fe07a71d9226cb4ae50fdd982f2e943d12e9d5b1827840824e5f413d91)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cbbe83d93df8650c0ca13f3358c9fb83631958bbfd844286f97b1eeba6f6ef95)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork",
    jsii_struct_bases=[],
    name_mapping={
        "bandwidth_values": "bandwidthValues",
        "check_ips": "checkIps",
        "field": "field",
        "locked": "locked",
        "match_operator": "matchOperator",
        "network_type_values": "networkTypeValues",
        "network_values": "networkValues",
        "template_uuid": "templateUuid",
        "use_only_first_x_forwarded_for_ip": "useOnlyFirstXForwardedForIp",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork:
    def __init__(
        self,
        *,
        bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        check_ips: typing.Optional[builtins.str] = None,
        field: typing.Optional[builtins.str] = None,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_operator: typing.Optional[builtins.str] = None,
        network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param bandwidth_values: Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        :param check_ips: Specifies which IP addresses determine the user's network. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        :param field: The type of information to match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_operator: Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param network_type_values: Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.
        :param network_values: Any set of specific networks. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param use_only_first_x_forwarded_for_ip: When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header. Disabling it matches the connecting client's IP address. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0a9dc575edddaa55c21e4f8fa2abae7306397245640b2b80b7d944813944e22d)
            check_type(argname="argument bandwidth_values", value=bandwidth_values, expected_type=type_hints["bandwidth_values"])
            check_type(argname="argument check_ips", value=check_ips, expected_type=type_hints["check_ips"])
            check_type(argname="argument field", value=field, expected_type=type_hints["field"])
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument network_type_values", value=network_type_values, expected_type=type_hints["network_type_values"])
            check_type(argname="argument network_values", value=network_values, expected_type=type_hints["network_values"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument use_only_first_x_forwarded_for_ip", value=use_only_first_x_forwarded_for_ip, expected_type=type_hints["use_only_first_x_forwarded_for_ip"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if bandwidth_values is not None:
            self._values["bandwidth_values"] = bandwidth_values
        if check_ips is not None:
            self._values["check_ips"] = check_ips
        if field is not None:
            self._values["field"] = field
        if locked is not None:
            self._values["locked"] = locked
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if network_type_values is not None:
            self._values["network_type_values"] = network_type_values
        if network_values is not None:
            self._values["network_values"] = network_values
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if use_only_first_x_forwarded_for_ip is not None:
            self._values["use_only_first_x_forwarded_for_ip"] = use_only_first_x_forwarded_for_ip
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def bandwidth_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Bandwidth range in bits per second, either ``1``, ``57``, ``257``, ``1000``, ``2000``, or ``5000``.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#bandwidth_values DataAkamaiPropertyRulesBuilder#bandwidth_values}
        '''
        result = self._values.get("bandwidth_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def check_ips(self) -> typing.Optional[builtins.str]:
        '''Specifies which IP addresses determine the user's network.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#check_ips DataAkamaiPropertyRulesBuilder#check_ips}
        '''
        result = self._values.get("check_ips")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def field(self) -> typing.Optional[builtins.str]:
        '''The type of information to match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#field DataAkamaiPropertyRulesBuilder#field}
        '''
        result = self._values.get("field")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Matches the specified set of values when set to ``IS_ONE_OF``, otherwise ``IS_NOT_ONE_OF`` reverses the match.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def network_type_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_type_values DataAkamaiPropertyRulesBuilder#network_type_values}.'''
        result = self._values.get("network_type_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def network_values(self) -> typing.Optional[typing.List[builtins.str]]:
        '''Any set of specific networks.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#network_values DataAkamaiPropertyRulesBuilder#network_values}
        '''
        result = self._values.get("network_values")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''When connecting via a proxy server as determined by the ``X-Forwarded-For`` header, enabling this option matches the end client specified in the header.

        Disabling it matches the connecting client's IP address.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#use_only_first_x_forwarded_for_ip DataAkamaiPropertyRulesBuilder#use_only_first_x_forwarded_for_ip}
        '''
        result = self._values.get("use_only_first_x_forwarded_for_ip")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetworkOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetworkOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__578556078ce71dda01cbe3bdb74f71d1653ba7fd8215ce6e07ea3bc9e301fbbc)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetBandwidthValues")
    def reset_bandwidth_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBandwidthValues", []))

    @jsii.member(jsii_name="resetCheckIps")
    def reset_check_ips(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCheckIps", []))

    @jsii.member(jsii_name="resetField")
    def reset_field(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetField", []))

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetNetworkTypeValues")
    def reset_network_type_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkTypeValues", []))

    @jsii.member(jsii_name="resetNetworkValues")
    def reset_network_values(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetNetworkValues", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUseOnlyFirstXForwardedForIp")
    def reset_use_only_first_x_forwarded_for_ip(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUseOnlyFirstXForwardedForIp", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValuesInput")
    def bandwidth_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "bandwidthValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="checkIpsInput")
    def check_ips_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "checkIpsInput"))

    @builtins.property
    @jsii.member(jsii_name="fieldInput")
    def field_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "fieldInput"))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="networkTypeValuesInput")
    def network_type_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkTypeValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="networkValuesInput")
    def network_values_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "networkValuesInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIpInput")
    def use_only_first_x_forwarded_for_ip_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "useOnlyFirstXForwardedForIpInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="bandwidthValues")
    def bandwidth_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "bandwidthValues"))

    @bandwidth_values.setter
    def bandwidth_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bc7550d65d6849fea9060dfbfdbc2a7bbb931c7273bcd99f1b8c9bd929df5052)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "bandwidthValues", value)

    @builtins.property
    @jsii.member(jsii_name="checkIps")
    def check_ips(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "checkIps"))

    @check_ips.setter
    def check_ips(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dd2f68ce0fbf47ba0b394b8287b864e89087eb2722d22a0722843b3cc5da87f4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "checkIps", value)

    @builtins.property
    @jsii.member(jsii_name="field")
    def field(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "field"))

    @field.setter
    def field(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__cdedb06d3eed50559775c443a2c66ba7fb7c17dd0b38e84901f63ee841784845)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "field", value)

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f2083d279e75f1ec450d8d9179d551c7c58bbd8623719131dc04af0ce51c0f14)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__46910b42c1ffa25ef43984ba448104b0bcc67ccee4fbe4a055f5568d7ec47955)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="networkTypeValues")
    def network_type_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkTypeValues"))

    @network_type_values.setter
    def network_type_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__54b871624ded350534edcecbf7a378c14858f15d97faea0db4476cfb7622febe)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkTypeValues", value)

    @builtins.property
    @jsii.member(jsii_name="networkValues")
    def network_values(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "networkValues"))

    @network_values.setter
    def network_values(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__25238cd487252689eb11769db52cffc3929a12ea6c2083adabfaef3177152438)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "networkValues", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e04ea10b45053fb5540e229fe313211d772da37b42a92d1f4c1e333210c3e729)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="useOnlyFirstXForwardedForIp")
    def use_only_first_x_forwarded_for_ip(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "useOnlyFirstXForwardedForIp"))

    @use_only_first_x_forwarded_for_ip.setter
    def use_only_first_x_forwarded_for_ip(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5dccb6b034e3844485eda17b11347efdb64d0cd0f1eb647808cda95da98b2178)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "useOnlyFirstXForwardedForIp", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__55cc738420dd606419c8a091a256252fdd146717fe42ad308c7bf971171d8c3c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e91631dc7da6c8185f3943d5dc784d718c27dbe60cf77c9500a762d9da3c682a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "result": "result",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
        "variable_names": "variableNames",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
        variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param result: Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        :param variable_names: The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name. Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ee3a113aefdde47d9c6d048a48be2a2ea0154ebcdd7d25718f1a6a07daf31ff3)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument result", value=result, expected_type=type_hints["result"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
            check_type(argname="argument variable_names", value=variable_names, expected_type=type_hints["variable_names"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if result is not None:
            self._values["result"] = result
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid
        if variable_names is not None:
            self._values["variable_names"] = variable_names

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def result(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Matches errors for the specified set of ``variableNames``, otherwise matches errors from variables outside that set.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#result DataAkamaiPropertyRulesBuilder#result}
        '''
        result = self._values.get("result")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def variable_names(self) -> typing.Optional[typing.List[builtins.str]]:
        '''The name of the variable whose error triggers the match, or a space- or comma-delimited list of more than one variable name.

        Note that if you define a variable named ``VAR``, the name in this field needs to appear with its added prefix as ``PMUSER_VAR``. When such a variable is inserted into other fields, it appears with an additional namespace as ``{{user.PMUSER_VAR}}``. See the ``setVariable`` behavior for details on variable names.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#variable_names DataAkamaiPropertyRulesBuilder#variable_names}
        '''
        result = self._values.get("variable_names")
        return typing.cast(typing.Optional[typing.List[builtins.str]], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableErrorOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableErrorOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__2b1aa22a964ba0e5de16016a62320d5737b93096047ea9fb792fc53219e457db)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetResult")
    def reset_result(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetResult", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariableNames")
    def reset_variable_names(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariableNames", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="resultInput")
    def result_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "resultInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableNamesInput")
    def variable_names_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "variableNamesInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__a327edb761944e824221f8bb03a1c3ded7e7bfc7253193f9c4dd533279796446)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="result")
    def result(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "result"))

    @result.setter
    def result(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__20ff7934bcda10c6e93cba5742cc2a92e7d5557f9c7f9ad595b83fe081c38667)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "result", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0846ee63f033445872d3d8c8fb9646f8c7e3b9f5c2da8a65cc4c1d3e1fc3a44a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__17188998b60161e886db97c4e76f1ed291404d2676ca4b30eab248ec46bb93b4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="variableNames")
    def variable_names(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "variableNames"))

    @variable_names.setter
    def variable_names(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f153af93a5107e50f4bdd3026cf2be1a0e59e56aae7963cc4078937c79c1224c)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "variableNames", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b236c7e2ae6a4a6f84dd7f31b94f8517047282b1a72c993a71aee8437f37d2c6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``virtualWaitingRoom`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e5ba42dfcf6755cb259f6cc8612843620d4346a0a8228b28ad32fe12a496a633)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``virtualWaitingRoom`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0f15d715c8e20f6725081d9ed37ec43854659520faa47a816ecfe2e8077ec0c1)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b95a2d4140ec6558d3a5d12b8732beb272fbe517e27bc9ea6486627e9375fb9e)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87d311ee3d68df1fb2dfc3421119c04782fa54b1f5ea0b88823b2869b9f151f9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3e81a48a9bc2b25bd0e86772716ca575f07c1ffba73a81cb316c45789da26bdf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__163f36f4eac90b6733aec31b7a739424728d26355c7eaac85581c0b36e9bb5d6)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7baa250035b6b6687fa35dc5b782d902371949db842b184500fc7acf5d7ff560)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b404d89e56efb2ddb4fa29f6b6ae49d1861667cf2a914cf9d80a1e17ebf072f2)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest",
    jsii_struct_bases=[],
    name_mapping={
        "locked": "locked",
        "match_on": "matchOn",
        "match_operator": "matchOperator",
        "template_uuid": "templateUuid",
        "uuid": "uuid",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest:
    def __init__(
        self,
        *,
        locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
        match_on: typing.Optional[builtins.str] = None,
        match_operator: typing.Optional[builtins.str] = None,
        template_uuid: typing.Optional[builtins.str] = None,
        uuid: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param locked: Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        :param match_on: Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        :param match_operator: Specifies the match's logic. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        :param template_uuid: This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        :param uuid: A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only. You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__7b74ab15b575410a2ac929e19ecc0015e01a799f4823cfafa6113d112eb4f70a)
            check_type(argname="argument locked", value=locked, expected_type=type_hints["locked"])
            check_type(argname="argument match_on", value=match_on, expected_type=type_hints["match_on"])
            check_type(argname="argument match_operator", value=match_operator, expected_type=type_hints["match_operator"])
            check_type(argname="argument template_uuid", value=template_uuid, expected_type=type_hints["template_uuid"])
            check_type(argname="argument uuid", value=uuid, expected_type=type_hints["uuid"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if locked is not None:
            self._values["locked"] = locked
        if match_on is not None:
            self._values["match_on"] = match_on
        if match_operator is not None:
            self._values["match_operator"] = match_operator
        if template_uuid is not None:
            self._values["template_uuid"] = template_uuid
        if uuid is not None:
            self._values["uuid"] = uuid

    @builtins.property
    def locked(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        '''Indicates that your Akamai representative has locked this behavior or criteria so that you can't modify it.

        This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#locked DataAkamaiPropertyRulesBuilder#locked}
        '''
        result = self._values.get("locked")
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], result)

    @builtins.property
    def match_on(self) -> typing.Optional[builtins.str]:
        '''Specifies the type of request identified by the ``visitorPrioritizationFifo`` behavior.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_on DataAkamaiPropertyRulesBuilder#match_on}
        '''
        result = self._values.get("match_on")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def match_operator(self) -> typing.Optional[builtins.str]:
        '''Specifies the match's logic.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#match_operator DataAkamaiPropertyRulesBuilder#match_operator}
        '''
        result = self._values.get("match_operator")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def template_uuid(self) -> typing.Optional[builtins.str]:
        '''This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#template_uuid DataAkamaiPropertyRulesBuilder#template_uuid}
        '''
        result = self._values.get("template_uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def uuid(self) -> typing.Optional[builtins.str]:
        '''A uuid member indicates that at least one of its component behaviors or criteria is advanced and read-only.

        You need to preserve this uuid as well when modifying the rule tree. This option is for internal usage only.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#uuid DataAkamaiPropertyRulesBuilder#uuid}
        '''
        result = self._values.get("uuid")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequestOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequestOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__dc29f60e944982a6c942896882f6d9fb6eb66cd8233d6dccb9472bfaf51ea5f3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetLocked")
    def reset_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetLocked", []))

    @jsii.member(jsii_name="resetMatchOn")
    def reset_match_on(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOn", []))

    @jsii.member(jsii_name="resetMatchOperator")
    def reset_match_operator(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetMatchOperator", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @builtins.property
    @jsii.member(jsii_name="lockedInput")
    def locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "lockedInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOnInput")
    def match_on_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOnInput"))

    @builtins.property
    @jsii.member(jsii_name="matchOperatorInput")
    def match_operator_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "matchOperatorInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="locked")
    def locked(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "locked"))

    @locked.setter
    def locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__978730cb531f36b640ad9e0e522d6e8f1d863cd9a2ecf0cd901a6d3863d6c7a9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "locked", value)

    @builtins.property
    @jsii.member(jsii_name="matchOn")
    def match_on(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOn"))

    @match_on.setter
    def match_on(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__aeba7a2c8ef4836a9b1173fe65e883c66d5b2e871ec010e655cf45ff94fcfacf)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOn", value)

    @builtins.property
    @jsii.member(jsii_name="matchOperator")
    def match_operator(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "matchOperator"))

    @match_operator.setter
    def match_operator(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__801c61941c8900c04cd91d8365fbf3c7b42ebd4d81adf329ebf891393f318ec7)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "matchOperator", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8263a2e82036acbd4d90445baee60d24cbbb35fb3e0d8cfbde564ec619465795)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__075bd170781e0863245acd01196f8195b9c1dd9aab8d3c49be0579e80d9bd0d3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ab7d795023241d78b77d0fdc5bab8fa0443de990bc0bd0d3ee9713a6afcb1635)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride",
    jsii_struct_bases=[],
    name_mapping={"name": "name", "override_id": "overrideId"},
)
class DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride:
    def __init__(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__3d4b267e2bd502e05b24e5ad9ca152f1d80c9e5bfc5acb9f9022fa58d9c85dfb)
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument override_id", value=override_id, expected_type=type_hints["override_id"])
        self._values: typing.Dict[builtins.str, typing.Any] = {}
        if name is not None:
            self._values["name"] = name
        if override_id is not None:
            self._values["override_id"] = override_id

    @builtins.property
    def name(self) -> typing.Optional[builtins.str]:
        '''The name of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        return typing.cast(typing.Optional[builtins.str], result)

    @builtins.property
    def override_id(self) -> typing.Optional[builtins.str]:
        '''The ID of a custom override.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        result = self._values.get("override_id")
        return typing.cast(typing.Optional[builtins.str], result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverrideOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverrideOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ed8f00d29c215c74fc24a787f00e358e3cf87edb30be856dc968a12df3e92800)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="resetName")
    def reset_name(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetName", []))

    @jsii.member(jsii_name="resetOverrideId")
    def reset_override_id(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetOverrideId", []))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="overrideIdInput")
    def override_id_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "overrideIdInput"))

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__c28bb8f47fcd0901c6300e715afa3685797f5f85a60bdc524f38b079a421d4c8)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="overrideId")
    def override_id(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "overrideId"))

    @override_id.setter
    def override_id(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__6bef4a158a30ae41637d25159d33cae46847b959b6fb3c486394fcf3d74cd54a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "overrideId", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__87cc153e17d55813afbbf1ee9082ef75b353d186c9421324766a7d394ada8e98)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109OutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109OutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0c7dd3cebb21adbbc6a96ce7bf413e0eafcea794046de16e4041eadbb9df19e3)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute])

    @jsii.member(jsii_name="putBehavior")
    def put_behavior(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__632555e193424c4981e350bc2e3fc08e722218869dbf7faad975abab932bc292)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putBehavior", [value]))

    @jsii.member(jsii_name="putCriterion")
    def put_criterion(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion, typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__09d10fffcdd9b66f8b4b82d897ace8f864c8598c367db4ffafa0e208b1258a6d)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putCriterion", [value]))

    @jsii.member(jsii_name="putCustomOverride")
    def put_custom_override(
        self,
        *,
        name: typing.Optional[builtins.str] = None,
        override_id: typing.Optional[builtins.str] = None,
    ) -> None:
        '''
        :param name: The name of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param override_id: The ID of a custom override. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#override_id DataAkamaiPropertyRulesBuilder#override_id}
        '''
        value = DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride(
            name=name, override_id=override_id
        )

        return typing.cast(None, jsii.invoke(self, "putCustomOverride", [value]))

    @jsii.member(jsii_name="putVariable")
    def put_variable(
        self,
        value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union["DataAkamaiPropertyRulesBuilderRulesV20240109Variable", typing.Dict[builtins.str, typing.Any]]]],
    ) -> None:
        '''
        :param value: -
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d661a878e20df7e439a219e717111ff80283f75066120d0b916159e0d3b15b12)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        return typing.cast(None, jsii.invoke(self, "putVariable", [value]))

    @jsii.member(jsii_name="resetAdvancedOverride")
    def reset_advanced_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetAdvancedOverride", []))

    @jsii.member(jsii_name="resetBehavior")
    def reset_behavior(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetBehavior", []))

    @jsii.member(jsii_name="resetChildren")
    def reset_children(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetChildren", []))

    @jsii.member(jsii_name="resetComments")
    def reset_comments(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetComments", []))

    @jsii.member(jsii_name="resetCriteriaLocked")
    def reset_criteria_locked(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaLocked", []))

    @jsii.member(jsii_name="resetCriteriaMustSatisfy")
    def reset_criteria_must_satisfy(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriteriaMustSatisfy", []))

    @jsii.member(jsii_name="resetCriterion")
    def reset_criterion(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCriterion", []))

    @jsii.member(jsii_name="resetCustomOverride")
    def reset_custom_override(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetCustomOverride", []))

    @jsii.member(jsii_name="resetIsSecure")
    def reset_is_secure(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetIsSecure", []))

    @jsii.member(jsii_name="resetTemplateLink")
    def reset_template_link(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateLink", []))

    @jsii.member(jsii_name="resetTemplateUuid")
    def reset_template_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetTemplateUuid", []))

    @jsii.member(jsii_name="resetUuid")
    def reset_uuid(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetUuid", []))

    @jsii.member(jsii_name="resetVariable")
    def reset_variable(self) -> None:
        return typing.cast(None, jsii.invoke(self, "resetVariable", []))

    @builtins.property
    @jsii.member(jsii_name="behavior")
    def behavior(self) -> DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorList, jsii.get(self, "behavior"))

    @builtins.property
    @jsii.member(jsii_name="criterion")
    def criterion(self) -> DataAkamaiPropertyRulesBuilderRulesV20240109CriterionList:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CriterionList, jsii.get(self, "criterion"))

    @builtins.property
    @jsii.member(jsii_name="customOverride")
    def custom_override(
        self,
    ) -> DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverrideOutputReference:
        return typing.cast(DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverrideOutputReference, jsii.get(self, "customOverride"))

    @builtins.property
    @jsii.member(jsii_name="variable")
    def variable(self) -> "DataAkamaiPropertyRulesBuilderRulesV20240109VariableList":
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109VariableList", jsii.get(self, "variable"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverrideInput")
    def advanced_override_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "advancedOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="behaviorInput")
    def behavior_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]]], jsii.get(self, "behaviorInput"))

    @builtins.property
    @jsii.member(jsii_name="childrenInput")
    def children_input(self) -> typing.Optional[typing.List[builtins.str]]:
        return typing.cast(typing.Optional[typing.List[builtins.str]], jsii.get(self, "childrenInput"))

    @builtins.property
    @jsii.member(jsii_name="commentsInput")
    def comments_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "commentsInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaLockedInput")
    def criteria_locked_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "criteriaLockedInput"))

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfyInput")
    def criteria_must_satisfy_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "criteriaMustSatisfyInput"))

    @builtins.property
    @jsii.member(jsii_name="criterionInput")
    def criterion_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]]], jsii.get(self, "criterionInput"))

    @builtins.property
    @jsii.member(jsii_name="customOverrideInput")
    def custom_override_input(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride], jsii.get(self, "customOverrideInput"))

    @builtins.property
    @jsii.member(jsii_name="isSecureInput")
    def is_secure_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "isSecureInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="templateLinkInput")
    def template_link_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateLinkInput"))

    @builtins.property
    @jsii.member(jsii_name="templateUuidInput")
    def template_uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "templateUuidInput"))

    @builtins.property
    @jsii.member(jsii_name="uuidInput")
    def uuid_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "uuidInput"))

    @builtins.property
    @jsii.member(jsii_name="variableInput")
    def variable_input(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Variable"]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List["DataAkamaiPropertyRulesBuilderRulesV20240109Variable"]]], jsii.get(self, "variableInput"))

    @builtins.property
    @jsii.member(jsii_name="advancedOverride")
    def advanced_override(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "advancedOverride"))

    @advanced_override.setter
    def advanced_override(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__433d56e75e17c15848569aa60aef3ad239a7384d09c9e6c64b13fbc19bc33e58)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "advancedOverride", value)

    @builtins.property
    @jsii.member(jsii_name="children")
    def children(self) -> typing.List[builtins.str]:
        return typing.cast(typing.List[builtins.str], jsii.get(self, "children"))

    @children.setter
    def children(self, value: typing.List[builtins.str]) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__85782cd6cd5409766bf6d484db7faebf59f135e443790767e658ffe702fb7082)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "children", value)

    @builtins.property
    @jsii.member(jsii_name="comments")
    def comments(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "comments"))

    @comments.setter
    def comments(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__9be38ce260dfea222ac1dce4e96f6b63569e5ec37682e184e2289f1abc5b987b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "comments", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaLocked")
    def criteria_locked(
        self,
    ) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "criteriaLocked"))

    @criteria_locked.setter
    def criteria_locked(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__b13863201febc6d2c8089c2db95a2edc32d5343364720e3c686b28efe5283011)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaLocked", value)

    @builtins.property
    @jsii.member(jsii_name="criteriaMustSatisfy")
    def criteria_must_satisfy(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "criteriaMustSatisfy"))

    @criteria_must_satisfy.setter
    def criteria_must_satisfy(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__ff541c3ad8751f4748a5f5ea4f5c1fda2a8c5e6d3db54e557dcf09cc1320b131)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "criteriaMustSatisfy", value)

    @builtins.property
    @jsii.member(jsii_name="isSecure")
    def is_secure(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "isSecure"))

    @is_secure.setter
    def is_secure(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8599a6e3178560506e03a26d17a4d65f2c2da41952e622e81b86ae896df024be)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "isSecure", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__320037a1726795f3422ead617a731ef1b94700bec1a2209ce7d1850568473797)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="templateLink")
    def template_link(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateLink"))

    @template_link.setter
    def template_link(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e3c4943916af43ac98c8eabd3561d66c693496d2f3e38a9e308bc57d78b901e3)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateLink", value)

    @builtins.property
    @jsii.member(jsii_name="templateUuid")
    def template_uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "templateUuid"))

    @template_uuid.setter
    def template_uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8d920e305056390bb5f2eb28137dcebd0dc355141703a52a0b40eddc4e77f1d4)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "templateUuid", value)

    @builtins.property
    @jsii.member(jsii_name="uuid")
    def uuid(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "uuid"))

    @uuid.setter
    def uuid(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__8be3399e190ed577bbd0f15db3d7b738bad73b5602ced60d00986ca368553641)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "uuid", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109]:
        return typing.cast(typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__e038058591bedb56d969ce13f1cbb985ca189ed4cc9f32a08096f6077562f47f)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


@jsii.data_type(
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109Variable",
    jsii_struct_bases=[],
    name_mapping={
        "description": "description",
        "hidden": "hidden",
        "name": "name",
        "sensitive": "sensitive",
        "value": "value",
    },
)
class DataAkamaiPropertyRulesBuilderRulesV20240109Variable:
    def __init__(
        self,
        *,
        description: builtins.str,
        hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        name: builtins.str,
        sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
        value: builtins.str,
    ) -> None:
        '''
        :param description: The description for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        :param hidden: Whether a variable should be hidden. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        :param name: The name of a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        :param sensitive: States whether a variable contains sensitive information. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        :param value: The value for a variable. Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d375756145ed8648216086d073d4441340647818911e496e27dfb8db42d5bc69)
            check_type(argname="argument description", value=description, expected_type=type_hints["description"])
            check_type(argname="argument hidden", value=hidden, expected_type=type_hints["hidden"])
            check_type(argname="argument name", value=name, expected_type=type_hints["name"])
            check_type(argname="argument sensitive", value=sensitive, expected_type=type_hints["sensitive"])
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        self._values: typing.Dict[builtins.str, typing.Any] = {
            "description": description,
            "hidden": hidden,
            "name": name,
            "sensitive": sensitive,
            "value": value,
        }

    @builtins.property
    def description(self) -> builtins.str:
        '''The description for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#description DataAkamaiPropertyRulesBuilder#description}
        '''
        result = self._values.get("description")
        assert result is not None, "Required property 'description' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''Whether a variable should be hidden.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#hidden DataAkamaiPropertyRulesBuilder#hidden}
        '''
        result = self._values.get("hidden")
        assert result is not None, "Required property 'hidden' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def name(self) -> builtins.str:
        '''The name of a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#name DataAkamaiPropertyRulesBuilder#name}
        '''
        result = self._values.get("name")
        assert result is not None, "Required property 'name' is missing"
        return typing.cast(builtins.str, result)

    @builtins.property
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        '''States whether a variable contains sensitive information.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#sensitive DataAkamaiPropertyRulesBuilder#sensitive}
        '''
        result = self._values.get("sensitive")
        assert result is not None, "Required property 'sensitive' is missing"
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], result)

    @builtins.property
    def value(self) -> builtins.str:
        '''The value for a variable.

        Docs at Terraform Registry: {@link https://registry.terraform.io/providers/akamai/akamai/5.6.0/docs/data-sources/property_rules_builder#value DataAkamaiPropertyRulesBuilder#value}
        '''
        result = self._values.get("value")
        assert result is not None, "Required property 'value' is missing"
        return typing.cast(builtins.str, result)

    def __eq__(self, rhs: typing.Any) -> builtins.bool:
        return isinstance(rhs, self.__class__) and rhs._values == self._values

    def __ne__(self, rhs: typing.Any) -> builtins.bool:
        return not (rhs == self)

    def __repr__(self) -> str:
        return "DataAkamaiPropertyRulesBuilderRulesV20240109Variable(%s)" % ", ".join(
            k + "=" + repr(v) for k, v in self._values.items()
        )


class DataAkamaiPropertyRulesBuilderRulesV20240109VariableList(
    _cdktf_9a9027ec.ComplexList,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109VariableList",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        wraps_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param wraps_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__4731289bccb450e88090f1c208247c094ac9cd8178870f864738b083bfd097cf)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument wraps_set", value=wraps_set, expected_type=type_hints["wraps_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, wraps_set])

    @jsii.member(jsii_name="get")
    def get(
        self,
        index: jsii.Number,
    ) -> "DataAkamaiPropertyRulesBuilderRulesV20240109VariableOutputReference":
        '''
        :param index: the index of the item to return.
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__703186223b67ff12e800fe72be98540eade21a89cfae3eb88a2fb3c7bd07271a)
            check_type(argname="argument index", value=index, expected_type=type_hints["index"])
        return typing.cast("DataAkamaiPropertyRulesBuilderRulesV20240109VariableOutputReference", jsii.invoke(self, "get", [index]))

    @builtins.property
    @jsii.member(jsii_name="terraformAttribute")
    def _terraform_attribute(self) -> builtins.str:
        '''The attribute on the parent resource this class is referencing.'''
        return typing.cast(builtins.str, jsii.get(self, "terraformAttribute"))

    @_terraform_attribute.setter
    def _terraform_attribute(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__21e71773b0d6922e009dabc7160b6ef34a092b60e5b3df8d77149c36a9a380bd)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformAttribute", value)

    @builtins.property
    @jsii.member(jsii_name="terraformResource")
    def _terraform_resource(self) -> _cdktf_9a9027ec.IInterpolatingParent:
        '''The parent resource.'''
        return typing.cast(_cdktf_9a9027ec.IInterpolatingParent, jsii.get(self, "terraformResource"))

    @_terraform_resource.setter
    def _terraform_resource(self, value: _cdktf_9a9027ec.IInterpolatingParent) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__5ddfc08cbc87e101dce06e53f1173c47fef8a7d6e1bd6c4ce0c71ff8c017cff9)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "terraformResource", value)

    @builtins.property
    @jsii.member(jsii_name="wrapsSet")
    def _wraps_set(self) -> builtins.bool:
        '''whether the list is wrapping a set (will add tolist() to be able to access an item via an index).'''
        return typing.cast(builtins.bool, jsii.get(self, "wrapsSet"))

    @_wraps_set.setter
    def _wraps_set(self, value: builtins.bool) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__f02e70ba6d8190f2c4fd218f006d6cbac308681320002612122bca81b02ac361)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "wrapsSet", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Variable]]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Variable]]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Variable]]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__48875eff9cced7e71d4b0b7939782ba5ac2ac24c482ffeb82cddabcca0c6c032)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


class DataAkamaiPropertyRulesBuilderRulesV20240109VariableOutputReference(
    _cdktf_9a9027ec.ComplexObject,
    metaclass=jsii.JSIIMeta,
    jsii_type="akamai.dataAkamaiPropertyRulesBuilder.DataAkamaiPropertyRulesBuilderRulesV20240109VariableOutputReference",
):
    def __init__(
        self,
        terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
        terraform_attribute: builtins.str,
        complex_object_index: jsii.Number,
        complex_object_is_from_set: builtins.bool,
    ) -> None:
        '''
        :param terraform_resource: The parent resource.
        :param terraform_attribute: The attribute on the parent resource this class is referencing.
        :param complex_object_index: the index of this item in the list.
        :param complex_object_is_from_set: whether the list is wrapping a set (will add tolist() to be able to access an item via an index).
        '''
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__898d607c3643fdfb4fa6576406fa539d3b400495a6bf888b49dd1c8d049babb5)
            check_type(argname="argument terraform_resource", value=terraform_resource, expected_type=type_hints["terraform_resource"])
            check_type(argname="argument terraform_attribute", value=terraform_attribute, expected_type=type_hints["terraform_attribute"])
            check_type(argname="argument complex_object_index", value=complex_object_index, expected_type=type_hints["complex_object_index"])
            check_type(argname="argument complex_object_is_from_set", value=complex_object_is_from_set, expected_type=type_hints["complex_object_is_from_set"])
        jsii.create(self.__class__, self, [terraform_resource, terraform_attribute, complex_object_index, complex_object_is_from_set])

    @builtins.property
    @jsii.member(jsii_name="descriptionInput")
    def description_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "descriptionInput"))

    @builtins.property
    @jsii.member(jsii_name="hiddenInput")
    def hidden_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "hiddenInput"))

    @builtins.property
    @jsii.member(jsii_name="nameInput")
    def name_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "nameInput"))

    @builtins.property
    @jsii.member(jsii_name="sensitiveInput")
    def sensitive_input(
        self,
    ) -> typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]]:
        return typing.cast(typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]], jsii.get(self, "sensitiveInput"))

    @builtins.property
    @jsii.member(jsii_name="valueInput")
    def value_input(self) -> typing.Optional[builtins.str]:
        return typing.cast(typing.Optional[builtins.str], jsii.get(self, "valueInput"))

    @builtins.property
    @jsii.member(jsii_name="description")
    def description(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "description"))

    @description.setter
    def description(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__0d3bb27fde4a93fb0797fda4d8d05383b2dbdc7a28b2e8ac013a99b48c308c8a)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "description", value)

    @builtins.property
    @jsii.member(jsii_name="hidden")
    def hidden(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "hidden"))

    @hidden.setter
    def hidden(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__92a04ba46b1fa2626d2f165ae245935f3fabfcefb66e4ea17a616021b29371d5)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "hidden", value)

    @builtins.property
    @jsii.member(jsii_name="name")
    def name(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "name"))

    @name.setter
    def name(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__d99bbdbb7404a3ff5f0f236180a66bd1ba7673e09aa0d1cadeed125e7cd5fd28)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "name", value)

    @builtins.property
    @jsii.member(jsii_name="sensitive")
    def sensitive(self) -> typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]:
        return typing.cast(typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable], jsii.get(self, "sensitive"))

    @sensitive.setter
    def sensitive(
        self,
        value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__fab165c8b8b4b964667d27405aac76a2fb6a23c97f05cd3fe87503b78db4d091)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "sensitive", value)

    @builtins.property
    @jsii.member(jsii_name="value")
    def value(self) -> builtins.str:
        return typing.cast(builtins.str, jsii.get(self, "value"))

    @value.setter
    def value(self, value: builtins.str) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__1a01b68706332ea98a75002ce728fd1ed20efc742ee25e7607c86709ce4a963b)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "value", value)

    @builtins.property
    @jsii.member(jsii_name="internalValue")
    def internal_value(
        self,
    ) -> typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Variable]]:
        return typing.cast(typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Variable]], jsii.get(self, "internalValue"))

    @internal_value.setter
    def internal_value(
        self,
        value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Variable]],
    ) -> None:
        if __debug__:
            type_hints = typing.get_type_hints(_typecheckingstub__bffdbb1e2ebf930562bb70fcf43605fc42f2cd834f5bc8f03ab8065c8d528fdc)
            check_type(argname="argument value", value=value, expected_type=type_hints["value"])
        jsii.set(self, "internalValue", value)


__all__ = [
    "DataAkamaiPropertyRulesBuilder",
    "DataAkamaiPropertyRulesBuilderConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20230105",
    "DataAkamaiPropertyRulesBuilderRulesV20230105Behavior",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreakerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOriginsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDeleteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncodingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectoryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotliOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParamsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisibleOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFileOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLiveOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePositionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastreamOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelationsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceiptOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotificationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUploadOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatasetOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKeyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScapeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichmentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2OheaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumberOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBindingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorIncludeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestReroutingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPushOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailoverOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformanceOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAclOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDeliveryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetchingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQualityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBetaOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeekOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapidOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoringOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererCheckingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVaryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagementOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutrOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRouteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeafOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarkingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSocketsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav",
    "DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdavOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105Criterion",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucketOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheabilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristicOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthSchemeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticatedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsernameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailureOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtensionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilenameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPathOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTimeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230105Variable",
    "DataAkamaiPropertyRulesBuilderRulesV20230105VariableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230105VariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530",
    "DataAkamaiPropertyRulesBuilderRulesV20230530Behavior",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreakerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOriginsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDeleteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncodingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectoryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotliOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParamsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisibleOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientDataOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFileOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLiveOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePositionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastreamOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelationsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceiptOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotificationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUploadOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatasetOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKeyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScapeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichmentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2OheaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumberOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBindingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorIncludeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestReroutingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPushOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailoverOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformanceOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAclOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDeliveryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetchingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQualityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBetaOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeekOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapidOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoringOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererCheckingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVaryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagementOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRouteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeafOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarkingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSocketsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav",
    "DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdavOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530Criterion",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucketOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheabilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristicOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthSchemeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticatedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsernameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailureOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtensionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilenameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPathOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTimeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230530Variable",
    "DataAkamaiPropertyRulesBuilderRulesV20230530VariableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230530VariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920",
    "DataAkamaiPropertyRulesBuilderRulesV20230920Behavior",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreakerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOriginsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDeleteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncodingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectoryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotliOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParamsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisibleOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientDataOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFileOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLiveOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePositionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastreamOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelationsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceiptOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotificationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUploadOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatasetOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKeyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScapeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettingsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichmentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFipsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2OheaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumberOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBindingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorIncludeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestReroutingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPushOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailoverOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformanceOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAclOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDeliveryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetchingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQualityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBetaOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeekOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapidOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoringOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererCheckingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVaryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHintsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagementOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRouteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeafOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarkingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSocketsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav",
    "DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdavOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920Criterion",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucketOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheabilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristicOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthSchemeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticatedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsernameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailureOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtensionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilenameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPathOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTimeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20230920Variable",
    "DataAkamaiPropertyRulesBuilderRulesV20230920VariableList",
    "DataAkamaiPropertyRulesBuilderRulesV20230920VariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030",
    "DataAkamaiPropertyRulesBuilderRulesV20231030Behavior",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreakerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOriginsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDeleteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncodingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectoryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotliOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParamsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisibleOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientDataOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFileOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLiveOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePositionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastreamOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelationsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceiptOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotificationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUploadOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatasetOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKeyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScapeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettingsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichmentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFipsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2OheaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumberOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBindingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorIncludeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestReroutingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPushOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailoverOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformanceOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAclOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDeliveryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetchingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQualityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBetaOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeekOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapidOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoringOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererCheckingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVaryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHintsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagementOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRouteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeafOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarkingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSocketsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav",
    "DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdavOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030Criterion",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucketOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheabilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristicOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthSchemeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticatedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsernameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailureOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtensionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilenameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPathOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTimeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20231030Variable",
    "DataAkamaiPropertyRulesBuilderRulesV20231030VariableList",
    "DataAkamaiPropertyRulesBuilderRulesV20231030VariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109",
    "DataAkamaiPropertyRulesBuilderRulesV20240109Behavior",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreakerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOriginsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDeleteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncodingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectoryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotliOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParamsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePostOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisibleOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnectsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientDataOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFileOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLiveOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePositionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastreamOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelationsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuthOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceiptOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccessOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheIdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefreshOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotificationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUploadOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatasetOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKeyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRulesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScapeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettingsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichmentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFipsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2OheaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumberOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBindingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgradeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorIncludeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestReroutingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPushOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailoverOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformanceOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsdOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdnsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAclOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDeliveryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetchingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCacheOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQualityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBetaOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeekOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapidOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReportingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoringOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererCheckingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVaryOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReportOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHintsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarkerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCachingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatusOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrlOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitionsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClientOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagementOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtectionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmapOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomerOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRouteOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeafOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTagOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkersOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicyOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandaloneOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarkingOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfigurationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSocketsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav",
    "DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdavOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109Criterion",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatchOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucketOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheabilityOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificateOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOriginOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristicOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroupsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthSchemeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticatedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsernameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailureOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtensionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilenameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostnameOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvancedOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimitsOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCodeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariableOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStageOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeoutOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPathOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameterOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandomOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfigOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpressionOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookieOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethodOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocolOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestTypeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeaderOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTimeOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorizationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgentOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocationOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetworkOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableErrorOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequestOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride",
    "DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverrideOutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109OutputReference",
    "DataAkamaiPropertyRulesBuilderRulesV20240109Variable",
    "DataAkamaiPropertyRulesBuilderRulesV20240109VariableList",
    "DataAkamaiPropertyRulesBuilderRulesV20240109VariableOutputReference",
]

publication.publish()

def _typecheckingstub__acef2b9a06d87ce3b4c4f865c9686829948f24c27bc462c19671aaa3854c5ed4(
    scope: _constructs_77d1e7e8.Construct,
    id_: builtins.str,
    *,
    id: typing.Optional[builtins.str] = None,
    rules_v20230105: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20230530: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20230920: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20231030: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20240109: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109, typing.Dict[builtins.str, typing.Any]]] = None,
    connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
    count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
    depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
    for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
    lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
    provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
    provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3e57f2caeb0b80b76298c6c8ab9fd08455c33e1f5805a260f921e38ef45cd6(
    scope: _constructs_77d1e7e8.Construct,
    import_to_id: builtins.str,
    import_from_id: builtins.str,
    provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__332a15df44218be82bc9b15a4440f8801e2071f0741933f5506f85e8f8714886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4364c214ff2336fcb6b1f39fda7db8f63abea2d1664b5a431bfe2a4fb66b67b0(
    *,
    connection: typing.Optional[typing.Union[typing.Union[_cdktf_9a9027ec.SSHProvisionerConnection, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.WinrmProvisionerConnection, typing.Dict[builtins.str, typing.Any]]]] = None,
    count: typing.Optional[typing.Union[jsii.Number, _cdktf_9a9027ec.TerraformCount]] = None,
    depends_on: typing.Optional[typing.Sequence[_cdktf_9a9027ec.ITerraformDependable]] = None,
    for_each: typing.Optional[_cdktf_9a9027ec.ITerraformIterator] = None,
    lifecycle: typing.Optional[typing.Union[_cdktf_9a9027ec.TerraformResourceLifecycle, typing.Dict[builtins.str, typing.Any]]] = None,
    provider: typing.Optional[_cdktf_9a9027ec.TerraformProvider] = None,
    provisioners: typing.Optional[typing.Sequence[typing.Union[typing.Union[_cdktf_9a9027ec.FileProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.LocalExecProvisioner, typing.Dict[builtins.str, typing.Any]], typing.Union[_cdktf_9a9027ec.RemoteExecProvisioner, typing.Dict[builtins.str, typing.Any]]]]] = None,
    id: typing.Optional[builtins.str] = None,
    rules_v20230105: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20230530: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20230920: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20231030: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030, typing.Dict[builtins.str, typing.Any]]] = None,
    rules_v20240109: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17be5f5396b124d2b64da8b5ae7f2c13769f109df146029ddcfccda897ee3bda(
    *,
    name: builtins.str,
    advanced_override: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior, typing.Dict[builtins.str, typing.Any]]]]] = None,
    children: typing.Optional[typing.Sequence[builtins.str]] = None,
    comments: typing.Optional[builtins.str] = None,
    criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    criteria_must_satisfy: typing.Optional[builtins.str] = None,
    criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_link: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Variable, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb55d3d69a2c78038b6a628d86efe34cd24a2671c078bd92bb61972beaf32149(
    *,
    adaptive_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    adaptive_image_compression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression, typing.Dict[builtins.str, typing.Any]]] = None,
    ad_scaler_circuit_breaker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker, typing.Dict[builtins.str, typing.Any]]] = None,
    advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    aggregated_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag, typing.Dict[builtins.str, typing.Any]]] = None,
    all_http_in_cache_hierarchy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_cloudlets_origins: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_delete: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_cache_key_sharing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_downgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_options: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_patch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_put: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_transfer_encoding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding, typing.Dict[builtins.str, typing.Any]]] = None,
    alt_svc_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    api_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    application_load_balancer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer, typing.Dict[builtins.str, typing.Any]]] = None,
    audience_segmentation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation, typing.Dict[builtins.str, typing.Any]]] = None,
    auto_domain_validation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation, typing.Dict[builtins.str, typing.Any]]] = None,
    base_directory: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory, typing.Dict[builtins.str, typing.Any]]] = None,
    boss_beaconing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing, typing.Dict[builtins.str, typing.Any]]] = None,
    breadcrumbs: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs, typing.Dict[builtins.str, typing.Any]]] = None,
    break_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    brotli: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_ignore_case: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_query_params: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag_visible: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible, typing.Dict[builtins.str, typing.Any]]] = None,
    caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    central_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    chase_redirects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects, typing.Dict[builtins.str, typing.Any]]] = None,
    client_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_interconnects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    conditional_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    construct_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_amd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_dd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_large_file: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_live: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_vod: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod, typing.Dict[builtins.str, typing.Any]]] = None,
    content_pre_position: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition, typing.Dict[builtins.str, typing.Any]]] = None,
    content_targeting_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    cors_support: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    custom_behavior: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior, typing.Dict[builtins.str, typing.Any]]] = None,
    datastream: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_hmac_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_regex_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_substring_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_variable_extractor: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_default_authz_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_dev_relations: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_real_time_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    delivery_receipt: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_direct_failover_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_async_refresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_prefresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    downgrade_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    download_complete_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    download_notification: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification, typing.Dict[builtins.str, typing.Any]]] = None,
    downstream_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_web_content: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_bulk_upload: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_database: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_dataset: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_object_key: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_connect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_data_center: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_origin_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_redirector: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_scape: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_side_includes: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_worker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_akamai_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_proxy_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    epd_forward_header_enrichment: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment, typing.Dict[builtins.str, typing.Any]]] = None,
    fail_action: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction, typing.Dict[builtins.str, typing.Any]]] = None,
    failover_bot_manager_feature_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    fast_invalidate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing_plus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus, typing.Dict[builtins.str, typing.Any]]] = None,
    forward_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    front_end_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    g2_oheader: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader, typing.Dict[builtins.str, typing.Any]]] = None,
    global_request_number: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber, typing.Dict[builtins.str, typing.Any]]] = None,
    graphql_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    gzip_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    hd_data_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    health_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    hsaf_eip_binding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding, typing.Dict[builtins.str, typing.Any]]] = None,
    http2: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2, typing.Dict[builtins.str, typing.Any]]] = None,
    http3: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3, typing.Dict[builtins.str, typing.Any]]] = None,
    http_strict_transport_security: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity, typing.Dict[builtins.str, typing.Any]]] = None,
    http_to_https_upgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade, typing.Dict[builtins.str, typing.Any]]] = None,
    image_and_video_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager_video: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo, typing.Dict[builtins.str, typing.Any]]] = None,
    im_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    include: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude, typing.Dict[builtins.str, typing.Any]]] = None,
    input_validation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation, typing.Dict[builtins.str, typing.Any]]] = None,
    instant: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant, typing.Dict[builtins.str, typing.Any]]] = None,
    instant_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    limit_bit_rate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate, typing.Dict[builtins.str, typing.Any]]] = None,
    log_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_personalization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_rerouting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting, typing.Dict[builtins.str, typing.Any]]] = None,
    manual_server_push: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration_quic_optout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout, typing.Dict[builtins.str, typing.Any]]] = None,
    media_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient, typing.Dict[builtins.str, typing.Any]]] = None,
    media_file_retrieval_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    media_origin_failover: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    mobile_sdk_performance: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_via_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    m_pulse: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse, typing.Dict[builtins.str, typing.Any]]] = None,
    origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics_wsd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_ip_acl: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_client_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    personally_identifiable_information: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation, typing.Dict[builtins.str, typing.Any]]] = None,
    phased_release: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease, typing.Dict[builtins.str, typing.Any]]] = None,
    preconnect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_content_delivery: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_prefetching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetchable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable, typing.Dict[builtins.str, typing.Any]]] = None,
    prefresh_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache, typing.Dict[builtins.str, typing.Any]]] = None,
    quality: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality, typing.Dict[builtins.str, typing.Any]]] = None,
    quic_beta: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta, typing.Dict[builtins.str, typing.Any]]] = None,
    random_seek: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek, typing.Dict[builtins.str, typing.Any]]] = None,
    rapid: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid, typing.Dict[builtins.str, typing.Any]]] = None,
    read_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    real_time_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    real_user_monitoring: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring, typing.Dict[builtins.str, typing.Any]]] = None,
    redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    redirectplus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus, typing.Dict[builtins.str, typing.Any]]] = None,
    referer_checking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_query_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_vary: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary, typing.Dict[builtins.str, typing.Any]]] = None,
    report: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport, typing.Dict[builtins.str, typing.Any]]] = None,
    request_control: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer_extended_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    response_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    restrict_object_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    return_cache_status: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus, typing.Dict[builtins.str, typing.Any]]] = None,
    rewrite_url: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl, typing.Dict[builtins.str, typing.Any]]] = None,
    rum_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    saas_definitions: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    save_post_dca_processing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing, typing.Dict[builtins.str, typing.Any]]] = None,
    schedule_invalidation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation, typing.Dict[builtins.str, typing.Any]]] = None,
    script_management: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_content_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_streaming_prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    set_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    shutr: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr, typing.Dict[builtins.str, typing.Any]]] = None,
    simulate_error_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode, typing.Dict[builtins.str, typing.Any]]] = None,
    site_shield: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    strict_header_parsing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing, typing.Dict[builtins.str, typing.Any]]] = None,
    sub_customer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer, typing.Dict[builtins.str, typing.Any]]] = None,
    sure_route: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute, typing.Dict[builtins.str, typing.Any]]] = None,
    tcp_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    tea_leaf: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_customization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization, typing.Dict[builtins.str, typing.Any]]] = None,
    timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    uid_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    validate_entity_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token_for_dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo_standalone: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone, typing.Dict[builtins.str, typing.Any]]] = None,
    watermarking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking, typing.Dict[builtins.str, typing.Any]]] = None,
    web_application_firewall: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall, typing.Dict[builtins.str, typing.Any]]] = None,
    webdav: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav, typing.Dict[builtins.str, typing.Any]]] = None,
    web_sockets: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685f8aab0ecd3889630226f28313d28c772d65ed2370851705a1fc68b43c6ea3(
    *,
    fallback_action_response_code_based: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_codes: typing.Optional[builtins.str] = None,
    response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_delay_threshold: typing.Optional[builtins.str] = None,
    return_error_response_code_based: typing.Optional[builtins.str] = None,
    specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4db19b55c16052f855f861f1cd4b36c94da76d2b378c7aea3fd688c851d24f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b38aae20391b96027c80110373952a3306ef1d702ba13b5c3bb930b245d46d39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03db5eafcee8383e2175865668b09b49cfb42892bf9e741e51dad0f5dfd327e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ad4bb556ea33b46b8ea4c25969ad23bb725762a484ac539937c863ff6b61de(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf83e1d18909d86d8c8de6d5f99e1ac6f7923778f4e581e35ff82b1183758bcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c0e608c3344e3363973604ab7c666b02e80f5282f97bfc0a9cdc8fe2c884c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988cefda399bf965bf70869373ca5e13c13cd2ad094bb1506aae68d4051291bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191ac0f9d8cb9e6b6d6972c634f8604127c2b09b405aade5df14106861cba0cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b8254ad4aecf2ef41c3a5d07406f86eb1d969c3ab008239e61ede7c6e10e638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6991ce874e71e1c94558f15a7526c1acab994db1bdacae0801045c34df4c3a06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6931289d4ba2c23ed91442913d0dd93d92a00ff762c8f53ffdafc4f4f3ec3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e0fb54b272b1f57dfc17bb05821ef08d6330a869fb2169c53139c6300061ab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdScalerCircuitBreaker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8398a23f9020d5a091b007fb60cbdfc57a35d0ad0b5c79a0d5959ea88ae8aa56(
    *,
    ab_logic: typing.Optional[builtins.str] = None,
    ab_testing: typing.Optional[builtins.str] = None,
    compression: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    source: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_brotli: typing.Optional[builtins.str] = None,
    title_http2_server_push: typing.Optional[builtins.str] = None,
    title_preconnect: typing.Optional[builtins.str] = None,
    title_preload: typing.Optional[builtins.str] = None,
    title_ro: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce397b94b949ea697fbfe59cf05a12795b6e1527555ff174aface96fbba18a83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df7f6fe5a804584584994589a40171fdbd353ec43bd18f330d308182326c3523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b6c487a023d559f4a4c4c0d7144006ef144695a0b9127e42d39bc1595b3523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e009f024e9f690d57c37653a40a981f2b249dfd4c353240333c3973063f56f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb028b0a9fa9725494f6526160c192ab363160f92c9bc92c7135726033c49e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1442d18d9187006402ea106b0df1076b11a22fff704b6bc5f6b6f55620d6f66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2bb8e3100c9054eba613a1a129a6db3836a691eb9b9e7b7414f1bcf421930e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb34ef8a043e979b2cccc38b50003eee402b187653cdba20670d58c18577c1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14336263d369be69481abc1bc0242c3e4e43cdc7c032321c615891a34611e240(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__390833eb1ca36a72f4658403c5339ba4a32271267afe4156132ab938eda0a005(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ba5f32d760bd1952547902550bfb1be815b8b71adf8fbb5058e0e7dace91cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f2d33b2e2f0bc34c1d114b19caeba46902d554d4f93f338dcb3855f83f2ba5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__394219d49cf188e44fe542d3961fbef7ff6dee626622e822ae6bcd2737b1cd23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__717bec8f00768713a8a9e0d12ecd61b854c408b43c2628e7f84e0192809a7cb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b098a15f3e9ff76ad728a123d23ec0a1ad20fbaef333b20632879904c163fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5b571ecddcfa82c5496dd298dde45ced15011ed75793531016306b2d3edbe18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88befd8f7bf9b4eca8650b15f2ca56c720fdd277993fa7205bb8c39b765d060d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e344b01d2780bcc4cf625342eb6c1233ef8e0b97144887322f1cc72673729f46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515455833004b372f84fc27f9aac6e03bd05a1583fdd3258f0d59e9e406b5f5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab39efa2c6604683802cb1b9b7487bce8b77b3d0f10fa005e9c7d0c4bba6060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83df80d7b263cc337c18a00504942c114bf88b9d2c7cdb35b569f4d887ebd5d8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c888b1283c26a0b3d694f13eb4a6532d64c4ee76e9ed953a4a88162564dabc(
    *,
    compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier1_standard_compression_method: typing.Optional[builtins.str] = None,
    tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier2_standard_compression_method: typing.Optional[builtins.str] = None,
    tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier3_standard_compression_method: typing.Optional[builtins.str] = None,
    tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
    title_aic_mobile: typing.Optional[builtins.str] = None,
    title_aic_nonmobile: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6fd200d8fa37adcff7518734cc238f16190fda58a71f5d092e6acf7b321d9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9407eeecc2456cd55625b05c7de231bf48de4d9e1b612bc195591ce006c7eb3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15efa0af217a148411693be7bd20ad5ecaefa6620aebf949db3d08f44c0b4228(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ddc3b0198a563b355aabaa2d459ae229dfc23befed88fe5db31fa7f0cdfd57(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb1eda6c3a9a187faa2bd790254bb722f34224adbd81c00c13f01609820ec1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e468850572053f03dc19b33725f2676048389326d4b3261d97f9015acbce9754(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b87c985da1b825a7ed6b57503543dacf326fa50047ac712138f73a5d782486(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6a9314643e4a66338d9517f881ead07500b01a4b2354c101a8ad745977dd9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feb50694ee7150140c39342de594f8eff46371ab2aba5cd1cee2343720aa554f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a36e8728b2c7632632cff632c7fb9e465bf081ea710cb06d015d0dd24cdf167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190a51959bafdc882bf69a760290a51674cd8f267808da123299e1099e31965c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0e88e4e4e5aaa6c1399838d69792ff19ecee5b909c39b31527ec1ac847cf50f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__121643a1131051ac6e11364b832b3dc35c362a14c1e9ce47c5fbcaa50a5fdb12(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa4139bb1c6bf4cb9f303b313b8526853fd832f6193754ba25a87f467be68c94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed6dbba77b7d543edd00729d5f9ee49ad38c28d20ecb4a637a1a4e0850c69091(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98e66d1b4ccaa310e7c4bd50f9d2c5224b2c75313a608515c63692834bd18451(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0872b7247c3264b9beeb2ab8341b3d22cc054b75b42dfbb450ef78d88ce6613e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ccc43be76cb3a92a68ea1fc124a0074c63503415fc6570b69a48a7e987db9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cccb6fa862b6f948c239e535365f82d03a85eb5a81300fca84e201cd08f8400a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52927ea3c313a6cbfd7318d58a3cd309df5522770086728065038644a897990d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f6ac8245782c4e3b43ae0a4216994a62e565f0497d620154f1305e7774b8fe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdaptiveImageCompression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387697263234a9ecf36b5b515f61c0d5d72d0ac825e910bf9d21a4d44a7772fe(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246681faf2cb67945f5060148ef11a39828d61118278a017916c35682fd5794c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daed56a9fcbe071214d432056e4decb93e7b4e979531d7a7859f8a94764e4b07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f1e493073e6f9f91585d7b2ec4b1c66281bdeabb5bd0dfb019305cfeb394ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55280c38ded586921424ea760d6ee4d02824df95d2ade8b3120feed8bf46e65a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fcd42a9637e5c496e7eeed2ae9b25db85dd27cf1777641a0339f246b4d93363(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f09085e94c33a31afee761788ca191b8cf9799ac07d060815a1481b2ad3e3bf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb88ccc6d28150a41765a9d88e43c8ef3cf1653585bcfa07778941a00f7afb46(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20c150d8f65582e485045c7f62cd06bc42d3cfcb322060623c63a74bd7b014a(
    *,
    attribute1: typing.Optional[builtins.str] = None,
    attribute2: typing.Optional[builtins.str] = None,
    attribute3: typing.Optional[builtins.str] = None,
    attribute4: typing.Optional[builtins.str] = None,
    attributes_count: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    report_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71aa84d7b848e3d1baf1ecf78144f1c094707e8af7d4851f9793825c0084d42c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__256ba134b38a553639db4697af53b5c89004ee236df94079076d458b295d0648(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b870898bb4078d495485b79e4848724a8939102867d3382d455428c3269d0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa5cb012c1aa9e3b4d507ec4c4e0a66b90d1d0236cc987cf179012201bcf500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e6bf910aa155efdc3d57343cb82d09e74d8fa1ac5ac8b880619bdf0888e557(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082db1629ed56cef08ab47eeb96ed89500fb7ed0c258e0040312dc83aab696bc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4fc374780340bc1f6bffb7821f80a9a7234dbf9c940470df4a642d11243b3a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f66cd11107aaaa31a5eeed25c0fd7be41f155f95fee323c113d75304925974(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c2188e9843fe9b641edf10a1bac2b31042d709dc7191137c7be11d842bae88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a7877f112a14693805743feb95180d2aee01ee9e5d9131db1943bef05941db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46249f29b07b9304020ffddc27ca2354a9ef1d19633aa53a909d252a51e9186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7a531e0832114fe4b95cf74a4c1b51f51b392120bb30012b0e8197869c75bb9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAggregatedReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf9f7991a6fd097b100d77ea30f4954c43e99c88cbb201d3b1a5036e7df4d79(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988fe9735135d3c7a6cbb774a74c98d197f6193253711d161ef4d019322ae8b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1bc9bd5d5aee4804f425329fae8f9ec7bc52a597ceebef35aee58b7edc29aa3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50e10604980783c1b05d25ef5beb407e168e6e95c66a4dbb6da48a0552fa0f50(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5d861d75bed33ce5eac20422dbb6de0790683f1728f465b0a7b78d6184b2c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33925e34128e22b908b8677314dbb1eb3f201a86114fc38a894acc6967e5bec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c825a392d7812409baeb0f555608d6cc2fb6bc5c46220b9a4ef7de32f84f9063(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ca2b193519c0914f127955cd84449f00d0a751d18f384b3f447385c57437d88(
    *,
    include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_hostname: typing.Optional[builtins.str] = None,
    replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    replacement_hostname: typing.Optional[builtins.str] = None,
    scope: typing.Optional[builtins.str] = None,
    tags_attribute: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a6e57127d590f887e2b34b4d1e3f36a8bcbec2064a4fbeab494ce8d1a0094a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd7ce6c97c5f74dae2fb7789171948d735eba999c2b37008b074d37601da8420(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d64bd1aba9654dadf08d54f0031a5c0102b7d23a1136d515e32c46323192e4b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f243872e15161d407e6c5cb1975ba504cb1ff087602ec6ed726a61442eae51a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5507a2979e52a16b54eec4e466c0f1a399dbe94c6c03915466cd4801c7d636(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dfc780a4c6b29f71596366833865ac8984841ab81ea7373bec6ecf64c65286a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6a9166e1f6b836f0f222a2fe7231ecbdc04c199607cc1ef27701f1f60986229(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69956929a0041afb1e10834ff497d1f59ae5e3bd888371a4c36e5685446529e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edad90df5788fab2b5c664aa38d62e80979568ff776436572535f8ac7f62ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a40884fa82a229c67f2c830fbaae7a4225a4bb53683b276cc02ffcba1b589f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd61b6db46baf3b6314953a83f460963eaeca2ca2f37d67cc3d1b0419e32dd5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAkamaizerTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cad663c3217929a62ba5c4b97265361209521a121285782dc818ea9fb647517(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25574b721b2d11da035381d7abd973d24e9cb01ba88146f0c55ab6737786fd86(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8762cc37d7862cd2bccd12b91e54ed8e88ff60a0601845c56ba244c41a5db2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__508e1ab6e9c7ccf4686795be80a1b946de493034b8df8fed2927a5f3776821e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905aa2dbbd45345e558194abc0978bfaab1efd24cf3aaec39584c409b3460fd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cede92b3d0a5639c9abb2d5fd9e5088df4320776f514e99975925c2bdbececb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7b25a9cec83d05fdf7cd148beca17a58439f527e270c71724ef6cdd6f64e6e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllHttpInCacheHierarchy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2765d76e4d8d65ef044559adbb1769514ad9e4b3de6e94d51e3951bf8db665(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_origin_query_parameter: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55cd5cdf24c2fb885726647993ef5e3dae8747cc3ec6e1fc9dbfcfb8104cfd74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef9fc9914fdca6070423674b8b8f5158935a01b4bcd5fd58d136aecea6fad069(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cdb9954826ff2ef8e0a633425ed1901577e7016c0d08cb613e83b5f8785f4a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ef7a37078ebf9d67fa0fce9ca99a07c4684cf8b6f4e581209bf2660aecc105(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a734dbac7316ce0b9c4514620adf4e20d4f6f79813bc566957ab127284122dcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27876ab8ab9c057993f4b69d862e43534f0434eedb89f0145fc80dbb608b89a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96541f881f27a33f09c914e221156e6a694357f3c4bee8c02124125bb8d834ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e240a4126906684af6a670e835ff3322c6e4457991ba37a5d27dc165e0af68f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowCloudletsOrigins],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6deda17c1693d969427dcdc2c588cfcdd806c87093f9dfd79bac42f2990b0971(
    *,
    allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e97b4dcfa199ebaa34bee20deafda47d0592275864517df14921ac42276fe41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7987593e0a66b06bbd899922e28346849c35343761d31827763bd3fcbc1c5b1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60d139e5186618db0f8662623c17a6f7467a09f277b787d92b5ca45a1e3ae89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460ddc46bfbd187c4b7765c37d59a1f7877cfed3e359af8fb930780b1ae571b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ddd87c4d2fe9dd8518b8234853ce30575559a70b8bc69d029a5c2e5b5d909d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7126522a842e4773f290ae3f9a23e5c1794c132d7ddcfc49731080a4de6a4421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7caea8125c035007c1e5bc70b8444b287dc495129a5aa0b96549f65b699310(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowDelete],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60747e32daa4caa1c6809d72429c98cb1ac505c847c9c7a936c3cc59e4cb8aa5(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c14f03e8ec3bbc445c91f90ebb80511b319f7ad4947342cad01fde9ec750792(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89de039a4de1bedff8bf16906d614554028130a5667eab61b5536bad8a6dfac9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f6c37452f194af1213497c61c8a7b30f2fee3ea6346a16bff3124ce6fe21bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e1fe2e62a7c9f16972738856a2d56124f4019190e9814a37a05b6851dd6cb97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7eb87cf8260d82af665c01d28a0ace68fc745e47c18e84ed2ee63c91cf1fc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21088ae58e6abc597e76960db8ffae5a2f29a796e14238de61214704c2039a5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsCacheKeySharing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3b1ce9b7af3c86db6c67034359519b27c8cc0078cc2094072e41ebc3a68feb(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db61c38cec5a28611d3b0c42040a4444c8bf29b19a82a44bd38f832799216e6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77f7f5ea99463c76c527ccc56fbe8d72b5c357af0fb5eaf15d5b2c0ba9d7907(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3cd5e7658ba4aa7ca5b464d0e72bd8a85f41aca1e82e7fe9be3401c15dec59f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2912d767da3178971cf3b75527b4383251bc14696e22d3751a66e4cc79d4d61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a93ea30027e74ec259b130f69163ff4331b55f8808ec6f1532fc7dd150de0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3fea5761c40929689ec8b4d107f0255db3568ff349bc420bf1378e91f0ebd1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowHttpsDowngrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957c81dafca868bd14076c1e1036a8143fe5d4d0386c32afc69cdebb39b10349(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f722f6389a6a7d3df6558aedf049df2009b06bb216ba3e32bfb296837e00ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b5188c3f42dd6a2dc945ac1e3c2ec07eaa93672b68af126b6bce1f9d55c993(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffff2eb9a0d4ddaeef1fa1edd367fdd0070cd72fa908f4367b12ad9737e2dbf5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d96cca64374b0c0f64e8ab190251e4e48ee6215cc52dc90f038cdc161c7a248f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1db627122fa03a7ecbe539813fe55e20c86140da81d2e90dbdb7af85093393e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c97978be8a5b8f18d6d6bf7a3ca7b2f9274804b2528e640997eac66acf0543a9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowOptions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be3fa8320ac40cd99a520c7b4349d07e660b041a3c0ebdbfcc4cc39f88bd0e5(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce52e1f42645e7722732f10f6708146cd30c4e0308cb4f21d26ad50370e4ebfb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f4b7302fe9e1dda9efdbab755e276aabc9aed737e15ceab29a79054ff56cb14(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8f0b7f55ce37ceb84130f5173fc50dd8166658083276087ca5197c4d4a7556(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c43cfe6d0ee5ae7df7864740e2bda4d6b5ddc2f074aedd31958c6dc4affc55d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784ae5f896e2a62f1a9f8a5735b66e52e45ea07d44aee59a64a1379077470529(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0133d8a071a9dd14cf7354be78f59e93774146351081b5c9456ef151010bbcc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99efe25366e8e0d345a5748e473754d3afc8aa7574df5b1be6c7f7a570aadb67(
    *,
    allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9393f6e3f694f33b0d4f59a7d365a93c59c156944eb42989d8690d68a293ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1d9f5861aaf3864b7219a4603c1ce654888649dfedb67c46cd445a67cc023d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ac9116662d1e20ae7b75d48ab215c1a30f6a8d690e362621f16c374974ddf5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c894dd7dc48f0246fa864a9a9b9326af950c6928dd335627f7c9ffe1a363c454(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983a0127bf1bde3b52eb4760c41b988449fd59a6985c310e421617b38bbcf824(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edb8356fbca1fa7a9abf7b2981fd0f8b1265cc181ccef9032464b0054253955(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb4dd7ad39dee2e6c67c07d20733543ae3f742508d3498a1b04a37a644992720(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__672e642925f442c0217761547716c19112f4ac6c810aae5f38ddfe5c52d1dffa(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34f086dd7dab62900b1d8e7e53cca522aa1f0169fe9dca849b36c127cbc4940(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb373381b21a75f671e6a51eecedb6da68eec0a6d5fa30703ec8b7e02b2eeb1a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6f257a4cf32eebb1c43dc55cd67b6e57a74c36e33d7e3e6854bd1643570e5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b6b07c19f016a9eb8e0ef8c22692d538eac80fef83fa9eb20109d05245342fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1b03d8d3768d8aee07ac90830f4127e8494ed039f924d55152d62d10346ef5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dff6ec2cc6775ee3a3e86a8f82f3bf7c134cfbc4fdbed14294f13c7904641159(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowPut],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410457bc2e001330ccaf89eb27c87040c7d957203890e434fb8e3e9e138ed2af(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b7cfd141a269d593ed6666dbbc48a64854b04710abe19735d136e5f6fd60a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97454e385b9dfbeb4ce17f2a97379ba63a29ef24f9e9bc0a923fb1ac80963743(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee9fdf37be95e22b06e59fe455853ec3f93df4384840f5369fc0d6f7fd4d1e95(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20fed451b2847b991136b6dfc252c5dacc08bb7cc7e13a15d48769ec8ba67ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63da22583c2856144265771099cfaf5f66b13f67dfbe060fa0165f2a565dc2d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e51b217592c8297d686245465def11eec09ebbc3c9e04cf4888afdd76de3f60(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAllowTransferEncoding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba25a4cc56f111d3a26301087541b29572770e19a7924fd0199f0d87f4030c82(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c1f3f5f2505c90b8ba5d8f237f53b2bcc92e47a8934241fe118bd6670cdf09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61cca4c34880d4b6d72d7508fd29d36af238fc3bc2a593cdf01db57ef9edd34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba702d1feb2fb934a8f3fc441cb077aa05e5392deeee6c9bf005f8eaeb67e4f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183de904522474c2b9a393ce31f1317327b19a7835181f21221943bf9e52ebd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e4286e1b57bee6bc1b80d071ef67acde0811509c1a97e51ce10ea6148a6460(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e45ba58b97fb8f42017e30490227bebd5438225d9630f5f002b0bc29403e8d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAltSvcHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143980a3af0c9ee5a4b0e3055a63739c7033472fe092d104bd6a9226b567f4ca(
    *,
    alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    throttled_status_code: typing.Optional[jsii.Number] = None,
    use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723d6d12e15dbb0ca173c5dc3b7fd049f9796c559cedc3e7b8bffbcc879043e5(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ee30b6cc75a831b0341037c62ae6b0479618802ebec7dc593e8530092305ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619d2cf1eccaee85c1b6978fdeb5547be43e3f997e283501af86a9ffe8ac5f3f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b04b987cf9514f869c809df7c51ad1c5cd137b905de8c8811df7652e8d5246e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2cc19a989dd2244b592b9c05e3e4bf3922181b5eede5a2834293823234b8c6a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe1b4f913b0aa52d4c9af1a1e20aad536d1523d9051392223199db6b8b617ab(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6df393235f6dc8a51afbe434b30b5fd3745f597d2a4ae774279ab8bce2ef4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f4e04b6d1a3ec7edf04b4b257b8d9c3ce063cf915a9dec9d5fec6784863b00(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cbd1383a3bec8219cc8f88d6abd5e250edaeae9e39d734ae4d89887076c1cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c58d6680e9fe7c5497ada4bed91d98a2fda548bde7763d60c1e5f2bc6ea7a6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c27c81b096317953f2ff14e0e523445f94be3b1d480d78b0b4e5cce7e477f98e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c84155d3a67f7d25316676c9e20c5dae8d9a408625fa840c700699df5a33f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5abf757a36eecd29131cac503487540bf8de275461584494788781ac903535f4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78cd2237d1075f9c20ba5d9cc1301505183f9fa95a130888da0916fb0dc70030(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c950a2055fedc2f6228ddefd92b5deef537de379cb139277436f869e61b5e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8a20045d5be364b07104a2c9e0990074c4d0e6efa016c73129d984097e6297(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9b110d5b9e2f3d75e9e78772eea4ebce98f5d685a32f422d5ca25b8da7407a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed22d25998a8cef9f7ca015c64466b981dd7d2c460d455b48f9d93e399396a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1bcbf1970259d781cb55d19ac20802648a93c225c08dc361f12286a328387a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b3c4f98c8b715ac24ce1047d38c60e7089a897678f00c50e861c0fc457397c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e065f7cd3771497365c0226fe614feb5ba45921be995d2aa9eef1bd25d24528(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05afb2a14b9843ec5c3dead1b07ab3e4a2d1f30e12de7b34ebea79d4bc98117(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebf1d180941e936c6ed56be867c6e51286c87d5bc957a7c47e13cfa36655c61(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9013a8b72da84ec72606189ea5fb4973fe810644705d36a9725c1c344f088db(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7ab21a00468427a8f42d73e986e4ee6a19f1124ae54decb22c123436d31690(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57313351de658f56a41a4974c33fd8fdf7441825058794a2e4a2d4cff35c944(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b22a2f5db0701bcf14e8055416a92f5b705926cadb094286d987a4f0e1c807(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335ea52c7379fde82921648011344cbe6df8f6a32e692ce9107b8325c00858ae(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1aba76c3b9e92fa3bd98d40b2fc40956763e923bccaf2a5bd763fc79ed6daf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65944815df4cd073f1f7a99a8838a7e7fdd25174d622225e6e1a92e3f9b148e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbbfd1d78ef04a716fbe9540698aec36caaac15998e3ed95a8516275cb62815(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1461828ad11a36c72969ff69a2dc3fd68e2900936c58d1a808a55bf1627ef1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2a87f8d4ebf991a9c2ebba9361ca0f08897c56186ff8c1b5bc9a396f1002ac9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3a78a0e7ea215c7392580e1ca6739523c05d533a3c6aef2a9d1c8247edab73(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16f3a0c9f38a332223866db29b15c9d7b2ff9012f1d6a997e4b8072f93bf7f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0138644521b7d575479bc80bbcfe4c48c354c90345520fd20a0512a68005b590(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f827644db509ff8f87dbd88ae88b84cdbb959d6f0e1c2b60fee61b00f36495bc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApiPrioritizationThrottledCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1a8e412f97951c8f5a6c9fa9b90fccf39ece25b4179936301747f9ef983cd0(
    *,
    all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    all_down_net_storage_file: typing.Optional[builtins.str] = None,
    all_down_status_code: typing.Optional[builtins.str] = None,
    all_down_title: typing.Optional[builtins.str] = None,
    allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cached_content_title: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_attempts_threshold: typing.Optional[jsii.Number] = None,
    failover_mode: typing.Optional[builtins.str] = None,
    failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_cookie_name: typing.Optional[builtins.str] = None,
    specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_domain: typing.Optional[builtins.str] = None,
    stickiness_cookie_salt: typing.Optional[builtins.str] = None,
    stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_type: typing.Optional[builtins.str] = None,
    stickiness_duration: typing.Optional[builtins.str] = None,
    stickiness_expiration_date: typing.Optional[builtins.str] = None,
    stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a38c4c00b2b21f7c862a8d1adf647a220d804f6734e298698621c5c24e36f7a(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab0e196ccc599bca76c7535edc34d63f0a45b153d6265e91b83cbeff11cf669(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b59b0deaa637d74a49af16103d6df37bd0039108b84225111fc47932128cb385(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b46d8b9f24be2ca35c0257a5a47230d85bd8b6d50e84b8be179102ae4be054a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6187118e0940f151cd93362fd9a215d5873d996c5510baadd431dbfa6bf341(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22e6f255889acc751499ebb7dd2f0258a633b864d30e5b371c86acc8dc7fca5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerAllDownNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba667150b98605e32c6ed3a56d8ce8454a08ad50dc6a4cbe119d7776d97eb35e(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b314d27b4fd7bc93cc16551be124cdcbe665d9d6fa6c61cfef24d45f705d8805(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9debc32aa675baa7dfe4e76c9d83b6fd81411bde87573ae419c627b0dc65747(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7104906312f2f984c1081dc59d5e9291767c6ec0dd888c6f69f54d83b9b8d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb22c53031d106a0589da6f39c5a4cca34971ecfcdc76c3192b5478b176f8726(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc894112b3e431552361d80015b755e9a227280384b4e62b7a7af524b627d43a(
    *,
    from_origin_id: typing.Optional[builtins.str] = None,
    to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f308841e0f705ec6f45d87e20d62480d59777fd93f3c78e38503dc98bc04d9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe2be3286a9245019d4f137f013987d1dd04e91675be342ff513e8c7ffa5264(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1adc23ce9c3fe4ea6bf75f82d53f47aaf51aad0db58688d83b743d1c2ae5998(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1934b97b13456de907c5aa887880c8e293953c07d071ed4d4815601a2461cbb(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e74a8b443bf0a46ca8e13d9fafc76f303bc315ed60f4230d8a740573db7208(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ad90843e4a8eda0460c8cf0f656e1ebaea754cbf7330fc945654bd4b99998be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18656608b18d5bdd167e214f08b331707a00f60b970e19dc07fe79371bcdf549(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d8db7fde48a50d478b58e4d9bc3fac00f611217a0686c28f152ebcaa4d9d14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18253010eea2f927f7edb7dea36b62f4be698285d2d34695fb7041e8402223ac(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134d0f07b676ced8b5633224911ae2e9173b29df267d471f38d71a24774bfe95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b56845939d892c78b219f5c8f9f16c581bbb8b2cd1e03c5ae10ebedf45be9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079241c2c3b0f8204301f45fb85140908e899bc57cbb6ece81f44ab7e4444345(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a48ef39f21c29e8bb0716702faa4e7548436a1cbaad9b5d76b2052c4a8b7a1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9be254dfed0a52bc4d9960c1aa01c1d90348dbd46b3cfe7689a46b9037bf99b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce7e487dce38cf6b8787eedd16ef98027f612d3b7a2a37be578fe960c95a835d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__821d09c467e8caeb05da717cc2c9d975a4edfa135a8ab32cf81bf74283c0473e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0100d06f26950798eaa6520799095a93b25777e23dfb9cb42752a7a6e3200a66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3a8dc7c5599e2924e3693988b60acd5148d40f7c7012cffcfd81d1ed9abd10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__808fbc75d67088523d90de92e3c96c434907921d39faab64ac66f0b9629609b8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7275ddec3cffe2f28e62802e741adda33436ab216623a9358c5173b7c66f248(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b076d0df10ff7ce510fd5c74485ccb4fff4407251728f76500a74c604e8e262e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc720b4364cfbceac2294ab9b13248584be68dcf0ad2dec2c0ae361096091ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3736059067e89248a3a578b4a8ef2a0ecd7423a5cf45402e3d978f57377d2cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39024d44f4aa2829beb1d84b698a8e119240a665391dbca945e8a60701739d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ea00aaee5aca3c712aaed8b939c3f6f34c109e999e137b83eafc9e3885e4fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae187f8bc77574a8a147f715cd76fe9da213b6ff207af0f02a5d4a54647120b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c4c0a88d1e3b2884796d7f92473f9d15e4ba9cd0e19dcfd166e649bd6b6046(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2767da244aec78fa4a2b80c28a9f9e4cadd979a059de7fdb531c4758ca3961c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0bc0ef4db48ec5de761b4ccb3f2cc8942c38da1ea8200db04ee993362df95a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3d33074aa36fd12bbb59cd947513eea10b2683a52ac976d7a8979a32bde0e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe95849a9b7ee1c252386344960a4952c53b88ecebeece22369a2e9f7e328c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0189e202653a1d4033a89dd4c88e84798638f6ab1c1d0b282cc23e7f197204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e048e833a35a8747f7849db42f635a3f7bc0a5533f7b8a5fa58d97b9d667f51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d557fdf3317f9bfa816dafb39cde69ff0398e565d62ae4d5b876ac1c428ab2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2267ff1fa55b490b1064a33610942bd50833dfe9f7f59daa2ac02d37f48afd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75534fa986a757187c90004dcee8e0b4f18f98c0106060c2e4ce81e9fb9001bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea95c9ef1ca8d4a7402918158b8b234bcfb3240954ecdfa413982c51e583a9db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be9d7450a865353415ec4b5cd922dd5be02c2689ed15d9bb713534b460b1f92(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorApplicationLoadBalancer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ce5eec33adbd6fe8ad4d6c57c18ceeca87ddcc07ca3bf92d5ad23778533ad2(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_domain: typing.Optional[builtins.str] = None,
    population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_salt: typing.Optional[builtins.str] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
    segment_tracking_custom_header: typing.Optional[builtins.str] = None,
    segment_tracking_method: typing.Optional[builtins.str] = None,
    segment_tracking_query_param: typing.Optional[builtins.str] = None,
    segment_tracking_title: typing.Optional[builtins.str] = None,
    specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b83ff9278946d04d6b7521f18ce0c1629d99cf7c7954317debb72ec1ea99f9(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb13b7fb33aa7c53ecf45ef394614c5c8f0ff229f02096a1e73542c9ab0010f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c354fe0b75e57041532da915190a8e125081bd9001540d0e53a01dad6982cdc1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53a701397c1df4bea53483d00ac96a4fc4a5b2132990ef879902c72c07ee4f36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93536d16b261b526c65f572c8d930fc642155e296a3d77ea92b9ff3ad8beb8f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1abc67994ebf108a57499ad05b185855b0b37dfafc8ce9a6aa31eb83c20790(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246c1fc17c11b265ae8600c4b9c77600c3d5d9bbea13c75ddd12ba3fc4041566(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9fa87bfa7c6765a53fc8f44811161bcaf3f1e1eb4c09349a3b09cc03b6aa9d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9edbd20d6c5325e15e76a7795129a0e3bfeb1694afa77186bf81d5b86f05bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5951df52aff10e62a8ba7bb139f5ca98b88d483c7224e13a3af36d3f5a9e8988(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ded89a15e1ace94f5d54576a37ef35f8b621f2ed7c2f532c9cb4824ac6ae3a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525829294094f01c43c93e8fa10dca0e968a129b0a329d42f9d2ccaab00b2fa8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f647b6531089733ab1749a29b052eb118fe1e36cff099598cc1ddc5d503045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a15cfba5cdfb7cf3cbb40442a00baa28bac8d69126f20a2e96846baa691671f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e17cfa7537d340b3676634b608c1444f90baa1c016623c65305b35ca0455e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff05f56cbb68ac83a4f8c9b6a6a51f126b78816bddbc8c60ad9eb365c1c0be5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e631ac0ecf4af0faad54ce9b58f04e05801d1bbe1699823de45d387e7ea070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c457e2044e566e0e5d997ea77b88b6c386621467f71ce7e1f0327966917092(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df113c56bd73742c2444f547aa5ba72e74e43ff4fe635d1de43c0133eb839f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410a230c2eeec3717afbd70b060fa9774675669ce1e34fe09156502731ba048a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e5a288d922acd52c398db3cbb186b08929262996843d1a75295d30c5a2b2cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58ebc39a7f9590a541ecede9ff9135684305ff91d443190ae16230c3ae756e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993b595c41ca1d46d3793a05c14480a05b5b984fe751e608fde9e72514a3d9cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77a8f6bc4de4e4289b254d8a1f155c3c95661fca4f5a972d2399cb1aee27d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c0339dbc7a58d9d3aebaef2c4495da0cb31a1f7134ca0045353aba4ba69d06(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4126a8436f54b33d222c425afb6949d2c19e444747ede1592214c56f869d2635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de01bb0e2b46ffd075e554b10991e6b55750526e57ceb594763fc47368cfa2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62015621bc3469d77b5bac5bcf182756d809f60566c62eb5d533bde551443f95(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAudienceSegmentation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7281a113339b5a2a164969980897d08da08ed1101dd3845da8caa95a4e2dd6(
    *,
    autodv: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9991c0c5ed660969fa46c5274c3050f2244d41482e6a44b02b7e27a2c6811b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__682bf0713dd5191280e1287d5d02d0d515b75e6d240dc9d93cf665d25c949487(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd6a5b136dd20e3c93df884e1f6f9b8ec942e268aaf96ca1d3f2678afddf3ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63957ea8ae6f8f11b8e58b97a5b6b000385634525f15e362a1f94a6413213c90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74cf4508c1b8ad1cb560d01b38ee107b94047b66f92dbcc2c0ba5d70ebaccf88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e29425f02a3c5f2f2e8eec06fb2f3459b9cbb045f70548b8ced30c96b515f3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorAutoDomainValidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6706cbbc5cceed4764275b82bf80a5a406efd95c8097c9397b9aef9d9b8052eb(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d6bb527d482540560baaf7d9b9a0db5f2bc9d74750ca2aff4873a2e1211c42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d414a4cfc2cdf28e49409e59b7d51f493a712d44814cfcb58b8188d3b7ce7f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ce9e6291faa701a715c2a26ecd4b73e2d86e5e37b40ceecadd976ef363a341(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a04eaa087848fc01fbcc89dcd4b548b7ab8a147d84066499f1c326e88fe7bcea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34a0f0ed4f4dc2df377d88facff36b01fc44f6f90186fc291dfd9267cc23daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1bd5e6a7714ee88c1d0e461732ff2889d472236ab3eb248d5e8ce0e104cb1f5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBaseDirectory],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6d091d7a4aa93bfae11fe45e819b8f28cf66990d05309a5a76036010277d77(
    *,
    conditional_error_pattern: typing.Optional[builtins.str] = None,
    conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
    conditional_sampling_frequency: typing.Optional[builtins.str] = None,
    cpcodes: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    sampling_frequency: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65e7f534fbba6338f70db15120fb0572fc2d30cc8e435f8e30a0afbf04646e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4224932b13e33a71ab2f27a6dd629b1b88802f41ecaab34632fa1d51a8784c0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e712cf4620c52c765db38e0b091494f68e619302fcaf017c8af20aaa7fe1294(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed79123c9832f8fa4579193198fcfe7c4d66f27d82e9e2eeb18f46ebd882f0d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a82fc614df2755fe13e0ae0a3d2bc91ff0bcbebd0551aea0acbf2d6bae19b5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a374fe34c10a9207ac4a9893c0708fbc3d86ebd87377508bf69638528c30cb81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589ac09fc93b137450032e2949692328a33784c2ecc9d7de4afc43ad3410e097(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75cb7e6cf0117507d32337fd70b2346ec7ec95eeac0fbf1b16cd82742fd2ded0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07feea11db7c604d41b04507c70ac9303b1aca5aedcc30a9b1a5626d01f9963a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b90d00368563915d647e6748fbca89bae1c90079299cdc28f74fa6099ce9f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0004d99c9af13bcd8ba5d906c120087f08066faf8d30f6a1060654ad1558a246(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c43e28232446489ca63bea62c865249b413460844582ae5ad52ab0972cf2a6b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d931d12b02b040d1010dbf9e384b313dc9d4225e31dbc937ca2a1aebb87c31(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBossBeaconing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcec8052a58989cb44738bcee1835b2b725ddb9fcc6bc74131beb5ecf53d96c4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45769b6797aa7478627b43887aed9d48df1d05d82e1b18968c9566cae7509ba4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__882e706215eb009e24c4458839a0454a02dea83e9c4af351fd94ae3913846e60(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eee1e205d20bf5a66b385c4665c5e634cea19d16107b33f69f1ed0ee8414ef9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a8984c103bbe1ee9c14ee04f53945b90f0ac77d5c125439e4dbac8e317faa6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4593df195ad037b728621495b993a193b676d9f7d7e08f23f28c7523194ec4a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ba25b552d3000e9295cbd873bd38fe4a6c4e2ae5a5d60c9f18a41f2080fd2cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85301caff2d9b7e485bb242986f19e595f735a30d3e0ad00bfe638ec498ca89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd496763d84c4640abf012642312a84776701477682476255fec3f2db6aaa57f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreadcrumbs],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e701779107b60b7e5652755b24711f76d3ae616b6e2bea455a4937e6053c14(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78b3cacb029bfe2a8d6042445c33b4bd8eaa552a7ce1017727b6c1b2c78b80e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d098909cf8cb39b257fb9ef2cc795caf11215e745490db345ad0f8849e2493f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e45a5f21baa2bf9c4583920bc732d5e0b7ad90b8aaa527ac1924d28923ee2b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048245b83819c85c2279593d28b8b23b6bbbc43fda85a22523e96d54c812d598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9dfd72d33039fb261dbe340b000472f8f561531846c30d4629fd137d93aa82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafc4c5845b277d0c3b2b3fe833d058681bcdb3510c65434674bf7dc52ed05e4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBreakConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710e87cbe458adb28c2b814100a93ab6e02930a8c231035d7aeeb3b57666ae14(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af330e05c7358ce8100ebcacb5aabdce5ccc5dff0297a2e86dd292931c747bb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17cc0e03f483fb2fe73b69fe2394d23861725998e602f8a6a3d5128418fc344(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e12d888778bb79c8ea3361b6e6d7e00aa8a47642a69ab4b90b2f33c67a0a72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca7aa396891f9064149dc99eaa1816304701e1a1fb239d09baf0e281b833f42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d0cfd45b10113ad9e7a010115db8e4b171daab0098ed810fc3ac1afa161dac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bda4f9825914e81d76aa670c9e00de266fbe23fab12ba08d97eb85b14199040(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorBrotli],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a1816f18b618cc45ca336c3c0c645c6c3a8d953f758e75cba9afb7345cf73f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45dce10569bb5f523cacd1bfeae4f66a32c9f0dfebe4112a1618377cd5cdc110(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa024b6c5e952bd86fb605514f5d4c587277d70c6298ec5457ddffe1069cc10e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c0649016549870b829bd730f2429d19f5f2f59dcf5348d0ac23ce1a5552478b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817f67d64606f2fbc0c7cd93633409bd116c61d1e6d35a364a645592d08823fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1a9d0495a21626110361eeb9418575b0ffef3d664df4fa0cc712edab6e18f58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34273042b3179d7e2e15d5c2364fbd89131044e6721ffd8695feab01f0f50045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7deeb8452d89784ea469fed3bbbde86faaba98e1bb408fa40e4c246a36bec68b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6052780d2c644408e0eb7ed860e5aa78d3c057e1f1caf85cea6364da766ebc6d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b57d87449490625a999bd5515cfafd247213c9ca61b7fece1b17169cbab887(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rule: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9534b04f9dc24dda5d721e5c47a73b9fb410e550bd2da71eb37625865bd06cd2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b483c85d045d8ccc9b5a4348615959dfd8bf485a0b350d57423123ea2cafe56(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b30af3d1789a2a969db8bfe9d604e228008f2f033143ac9152254feaba9bd350(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1598b4c1654be50e239ecd2fa871eeab085679030ec5d9a0b997f09fbb7e0275(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff822030c4514f991b1d0cc6cb23686527fdb8c15caff84cabd0dd979b40c1c2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f27709a2223baf9f97b6d4b7bb7a3f1e48ba37ddd55316ca574be2a776caa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7dc9604d917ec0e3c97e36fd4f82bd0469dbe1d0baf7c7309210c2dfb31948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6719e0e12a3603153a8f498d72e3160ead48b0d9d427c1a4745dca7cb87e9c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6485fb249872fc8554168ad979aacceaebd59e7979f1b7194f8fa21a2178d8ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d4efadb6c60d792772706f9d27aeafd5ede694040a0a37607231fc5de5e83a0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e770960cfe48b63c623ae32343517221e7e5fb8a1888639f6ea3941ce80851db(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d166cb89e7b0400255ad2d220c222bed85575ec95d1a26c7440b977fbc180f2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27053e1f491c553a5e3e538a7ba1499b2bec65571d0edb27e8a7de095babc588(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73ea182b74ed4667c7b47f39e3509b0383ed0f453dd0f7a71b240a88df33175(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e08cc9ac38c722dddc6a8b110c4bc2f7a0652eb7ef81c620eb4eba93e3ab627f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db655f61edf4041798237684b546594b7591499dfe95c3f927a27f6f5cef1c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271c5fdd09fba265f11a1f9ae554802d86ad5dcb94889fabd7c3be775b1742e3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyIgnoreCase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d28011623e0aafad090757dff1b8dad74c025445ee1426a9a06fbaf95e6bfc3(
    *,
    behavior: typing.Optional[builtins.str] = None,
    exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1a89274c86997c86ad83da20d9148a033d7436956311cb381918e1e8612a1b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9424cbc7d7477b6a7727e07c00465cf3ce8a6fe6ded725a51e8c9e990aef0a70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98471cb9d708fc1072f5bb75750eb3cb1ea7c612a5ae940c25c904605c800439(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc1e1c5ea7b32daf5dbb084e13216cbba4233bf6c95234a20d1c9b2246cd78c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac72c24c47f8842e7191af420668de21648ce0ad8bf47bf5ae59cdb01cfec7f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca9db3ce0988b1f6df2c39aaa536883e0493e29c9952cebc3bfae8c1516e155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e976bc68a2ab60c68929ffc87c98cb33671e409e7e088cc35db47c400dcab406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf0d7096255f575aa35bed24191e6f6cac1ea2b6fcc6a12f3206fa0452987c8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyQueryParams],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c55129f0696824e93a881e995390b217cb4d709fd08226e7c76b4c4de8f65ecf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086127b732be4317abe226d9f1458647edaa8d9e3baf35c64c8bd0b9bc049630(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5984a029d56f9b7f8ba62aba6dfc27e59af4e8379564649c6c112e2706e5fcb6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e1cf57eacb3fe82de87c0e9d4143fa3a637baeb0a3816d271f03771f16cb803(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6697fd9a7a4a9b35635c26364f11944e9ff2d6a4fa1f634598f1b94d0fc518e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4da375e08786c75ca6e07d2fd353eadb950c96dc7adbb94fe56c8c7e8846a85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf1930637728c1f4bd1e3fb890f13bcfa3bc613af7648aafa9262e61a203588(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheKeyRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3055bcea43761a47b3023748309ffff287a2c6e88506927df6075331261b239d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_body: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6edd0133255038a5d4e6931b9fdf98a7b0a6544f25be09a640fc8aeac107bc9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb4b2902c0ac46363d4158f2122bbc05aca05f1904ef96f7a2bf414faee0f7c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db05675b0196216032bd9e6f23cb89defb1d0389ed9759df016becb266d4b6ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9af41670d5d6f5e9cd55da4376d2a21cebd5d4c9d286e6565c94c46db88a35e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4492b1dff4b6b1538642642758600dbe127b83803460529d350d9f8ab33e840c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad783184b4526d2147cddc8be8d6b318d9a9deb5194ccfe783bf35d8f2e7ea7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913e97591e44de5b089adcaa6573a3c3e4d2dc37c1d897c34cc7b4eaf1fed971(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCachePost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3a55f40ddcbf2c20496be8686afd465f456b0b218f57fdd726e6bbb3877b927(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134a2fc97e5e88f41f75f77f30e7929bd8d1067ba66963dfe49cafc1646f7827(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc728e731f9beff4d038dd0d2c2e9bc5d56bc5f567eabd84be825bfcbb5064fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__015e79ab0f904cf65d62f9ddeb552e2757e601187d232378ea5df59c961938f2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92efef3c710ceba08cedc940268711c88fd7562ba18040bd7e0b9c811568b06b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93bff958e1ef982e0355bafba6dbe9e9baa5ffb2534573b4e25dee53d6e32dd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f965caf67ce3c999a8bf561414eda071b137fdae2c10b741e3ee03f1d46244(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10fe5fcc93895ce61616d7d919cca21f23aba1607683848aea7c18393802a848(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tag: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83fcfdf37c1401ebfaca20684ecfc169e2cd0392b23fd5265135e7fd7dcede4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abb617762597fa7ca015c5e56c8529cac29d3197b668328aa7ae5d1db6e94a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f0f3d29fc07501699b33b0225999af3e6c2795edce9137bbac0de145361a56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dbcd9dd70f612867a80d97c2146f925d5f9114fca0cd3482e07744a00dda356(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab75b768d3c1152bbc0e3e4b994b917ae2a937f409dbfad1e1e987e20f30c498(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8eaa8ea56f53d0e9a9c619b7acfbf4c87e192d9404f3bf76ed5a99a8daee73(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbbb842cf24d28e544e6f25b53c02ecd057aa13445023093d70a589555493bc(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40f679d615a308e66970cbffcf8e2c7c2fbc9f269cee341256da33d6c9b9c18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c221d3bec904723c143d04fa8cedf4c552c031b9bc3fb1921eac89d9e2c1a98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b5aa7f858a55bb6cfdfae1fc1a83f9fe503084f6d7de38842341a4abd8e4c28(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49310d1c9a2b8308b8cbf80e2372b8a772ce83ac3c20ab12c82a8ab29a38f21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00621d2d74dccd87b5bbfac6a07c06f0c968fa21fb63b4211e9435c111376c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d934b61405d8cef5f930b0d4de25e00434f35c10bead82e24710b1062a8070b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCacheTagVisible],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f961cfb9d3a5655c900d8076d36c92c636bc14b63e1061501f90ed21619804ed(
    *,
    behavior: typing.Optional[builtins.str] = None,
    cacheability_settings: typing.Optional[builtins.str] = None,
    cache_control_directives: typing.Optional[builtins.str] = None,
    default_ttl: typing.Optional[builtins.str] = None,
    enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_settings: typing.Optional[builtins.str] = None,
    honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    revalidation_settings: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48796e8205266a5a11eef13c7df046ca7dd8771d20115b2e3243711770dd997(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ddeac020d27f9b29fdd17ff8635bab2528071a790d1f2044dd3b9e77b8cb73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779cc96a476ca5c1d247d4d19bff17d7c4d93d2e1b74110e1e8042a60bf6e669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513c3065a86020a55666722f4fd3a789b38978e7756033c74eeff9ec7a68efb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eff02bff47f49e09f1da9205e5636d83b3e75eac60039d091ef1af7612f6776(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08810bdaed25487dd452f70f0dd98c33184e05a62f51114aadc388a28ea4319f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c944a2b0ab0822f52872342b8c3b0e0b89f5b8b5344c88fb078262a0d90af79a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3036dfb43a7d6869546e05cb8d6ce3ea34f14a2483d05b8642b20ac3e1f31da7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4eca2b72c36a142067c9322646fb5dcebf75d3942d5ee1379aac13d314c2dbc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52106e92a618b5fc8ef0210315f2baad850d138bb0932d712f1fa4ecfbe6e099(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fce14d576131d8bd5e4c2b7cb18de0659d84caca26963472ec3b2942c899886(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da7d0a4db09f001266d89c1e40929a5a15267e5f0053089bc58ce6e6a5ad9b7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39eb5cbe25a5e771bb9d6b4a94cbe1715a8adcfbdf6aa3141cafd3c8b4876833(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8811af19186accb176fae49db6769168f6399fc25763074e4ae760a7d0572204(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5f33437189a0767475e2b008617be47bd613db5a2d6eec75485b4c9a4152f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d82e92ce1506f70ec03f97b20f6cda9cd17f81b8ee8793cbe6b8e5798535d47c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b208221d18b252667ba84961e477370b715b14bc9cae03dfb61ac62a17ca38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc941ba7d8376b5fb69a18689e0d8be0044763fff19f1ba0a9be70d2522f9ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2002571ce0bfa1314cf0e22222b9be61826d8bed633e4a6f6f73908a120e7d55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba77c6f232d750f9860a42da4067098271758e53ba869a59a66c0e97940b6cd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2788f75484e14f25a43070a1d6d3d612a5b8f3ca44ecda600d11db4d1772ed91(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d69a9e1e234b260fef254a8b9403e87dffa5f98760f09805e95504ef2f59ee3c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1476797f224e3063aafe6c236e488739c41a005736ef3f0709920319856ad4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5181fa63b60c1150f3f8e75422d29f481b25a627a4c24bcb47fc1fc392c0f00e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b543073f584b9a3f807c414f93afcf481ec99f7cf485f8316eae226334b40d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8d5036ca913d0217c789631c9783fb049dbd2da40ff8ea34e12ae59a4e1dfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e69c198d700a689dd394a86dc9b8a2c1f0cb31bf1c34d0e759958ba0e3b19f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6f7d182f702bf2b06fdd7be6793d94b0947772f48c60b0827f63f4fa611202(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCentralAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8be1406b1f897468f40de341a5bdc9e4790d4c9131597a13b6756147c0aed8(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    limit: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6df016139cd72790464b0339fbd36ed056bab39e037ebfcfac19bbff0057e9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef3e871ccd288078070d12fea046aaf1ed44096b429f90ebd5952673e64ae12(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef891b1ae137bd5141cf2d36c69f8b9f4992e24d0a9705212dae00faab07dc1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e7c7dd44b397289b738c39acaea478e0e4074b736c3bd0dd28a7da0b1a40e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547d31f90e48f3002da4b10770bdaa710ce185c517ec07b05c488ae48e6e0a27(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59dedbe680c2133baf90635c5e053e2a83fc8ff0e7b76df24687a7a9b8590268(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2b19fba55a6ed2b6eb2597919912ee637eaba569dc02e095cfa5f32fde2788c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22417035ef4e1b9d9baf526b9346a6a5d9a8d3c1cec0c75348d258b151028f2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorChaseRedirects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a510357b2540396d543634d72f83dcef7e0ab73e37a0c1ab05dc5635587b413e(
    *,
    country: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db29cb45074b1ca1718d081b1bb8f90ee4f3aff2744950a5a6e194395e096b8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc763d629da8bad48ca40b4f28f8c23aa7e1d9a4c25aa767e1c23082307f4a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__792c83de90e1022cda790e5d9954a147f4ce568a4427d895983329347b0a0247(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcae48b2090bfe3b6c2146fe1eb25a36c4f3d5449cf7a872219281076cda1d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f3541796fa4378d965ef48a7fcfcec91810e824402a770d0b4363fff0d95f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573cec39ee809aea002064152b00861217fdf1054e595d6935505296843ee40c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorClientCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bfdd5ab135b2116bbae9d64f02eaf654ca10b7ff8581c820f8632db296f7ef8(
    *,
    cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df23bc2c108d033413f8b5b26fe079ed054882133eee449a186fa9f22cc40ed2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a183b98ab52c02ee424e78cdadb17d2edcd13bea7da398071820ab2b6339f9c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7394666204a6e4abd922793d2f86675bbff1aa8d29c8bca5b978d97569ec8b9d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2296df7e7ecac117e9aaa46b12fd802bc3e3d6503d01227d54bea03958e627(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eac9742546af1ca039cabf4d18ff6a61704188f94eae7760d9f0ba0cb2770d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12383f265fb5c72aa5884bd1e7cd7ab2d2fad51540973d36eda7840fd0ae06e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da51d097c63c5fb9a9a142d3cbf5169edb6a0ad9ad462e6538b6c46e99e5a2df(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudInterconnects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b20e17ad0af5525de12a9729ae1c86b487da5b0969a84c6475bbf2c37e7f79(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc36e1d910fc8ffabd063652a44e0e58d0c41aad22d398ae9c3a56b746447e43(
    *,
    custom_failover_map: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_map: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad6e4f71fdf7fe2d7454e156ff3d8254aa6d2ab91e299beb3a6d2c24af7e8b8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae676d33dcb09fb132b08a31456c74d68d4772a22248360736e91141528fd0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a5140767a60230c336cd38ae475cefffd9f2d7ede43efb2f14f452069a7ae1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9480712d10e76f8a4ba75aa42de1a12b86df8132df7c2368eda28cd67d13b170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc278eea5dc49f82d4e903e680be3f0d88f0d67310a1bbcbefff8a9878b167f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622d257d3a83bd3004d1428b7a18018f3acf1a8554ffc49573bbcc35a0e00148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e79fa1921adebdc0446a250a0d7df8a83b0dccce4996bc60205a2374bc655c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2b22bd69dfaea2c992bffbe47162b3ba3295172e77dd6e6f710d9be8d84336(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapperAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73f7577d93822bc55c94474fe49e200800459bef26292cea8bd0a151951b606(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a0be59425b76cc0a317633e8162e657ef4840648637b85600a363fb465beed9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96982bb85091763d36c75b88a06a7347b34930267f0bb05b1cd887074048a50d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc47c315f7e555d0a43120c782043a83e965c73e54fec92571e83451bb72fb2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01732f10f23debcc62be3fa77450f86336422557603941f0ab83d1d56e806009(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc1d66973daa212eeb4b134c1f69eda84c5ca37da06722501733db71c2bc29f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf188acfe09b9cd060b6468bed1261b863af74f4f11e22f98c15320fb95f602(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCloudWrapper],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68030a4f86a1c242f045223c3e9c285ca3a357c79beda854be8449c3e95b2eb7(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae5f1eede85b3b93b4c1a1d5c183d05eca04f9804181653c5be4fadb37c850c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4def981dbeef4a5cb55bb6a61712b9c9ab96a15c4aff6a3c25c6183e399d49d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ffdf5da7f3d950ed8201b114c482030a9529e257f15786158eda8724c8617c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68c94cc7b00021756eac767e0dde0106c44bf9278994e03f4fed1d419dbce46f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38aa40fcc8e8712e144af7ee5855532938b3287c0c9f8cb7c6786f27ba7e9286(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae920239a7a014a8b01defbb77513beab4d8a2599571123145a938577d9868d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConditionalOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063a4deebc24b2346276153d36915b44ce25c7bffb6f162dc4c3471b42e2a35e(
    *,
    body: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b03ba065f29f5c785fbbdc7f9107a32e2fa247bebba2bf202f8f53202e92d81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0f8b262391c0213f12a3638cfe0cbe54ef0414d3ad2bbe538da022b45bc7f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6756992a5e95bcf9ddf8004db8034516ea0c98beb8c3439587ff1041590f3072(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01176d0048dec1cedd80358d945bcb82ac55d2d1338944b2c2a7a628cd94ddd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dbed27131bededfa32e57df8a159c8a90f74041863ba65134d46e4b1d82d95c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c018aa55090e536768e15f32ebd5d8e70e262bdafb6214299279c2709a79c67(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f45acd50dc2a6ae7f2a470afff0ae917767d5bb843feff063f25bc22d59bf05(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746b9c1517c653f52676b5fb21bc321d165883d55e9e78e45788dcd137f03e20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda6990251b5348dad9a1499b42c1ec4401d618cdc6361d60207a34066898685(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50aaaf1dfb962e6ac82f76df6576dc1c641cfbb56bb00f451b0a1d09da170803(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorConstructResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ad5a0cbc6de2bbf4f3ec071aab3ba9a22f5d9f53f752237d77f11e986bb8ff(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c9656b854d2d29de2aaefa3c85cffa9729c7e3bb9d52a5345b08997e938856(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d832c11be048c726b933a2af42d610153ee890e2d315e9090ad4949fd3dc3b6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e00d1dc9e2f5996b15d94ad27d6a8cac64b6e83ce09b1e5ccbc139356300b2ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88db7336ae81c0d1eb57ffa17aa2a22b9a2e903db3365b41121aaf7c38886517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__341b34c0d762b4ff49e46032aa5919a46645f9c867aea368c4743510244157ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caaddd770ec31c207f330270eac18169e95f93889a49f65a7544d5d6afbabc78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e376d65dfbfc70dbf4c856fc19b10b258456ba840c68e9f7bbd2ca12dae6d3b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578fdc33269611397938b3c2f8e7f9bc2d684f92f4d76499c828a0dd9ee53745(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ebb291a9da5104168fd71bbd958397c146bef31926b00d181e7a34583542b98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef470cbab9bb9c8189f89f0e5fb55c0efbd8ca34634f67a381d5a4af1b8ae36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aded8318b9a9a20241042f4320b35d5ecacfb0eebeb6982ef3ad19866e4c49c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eefc98313937fcbd6d3b915acacf687732ae00c43c6c762f430c72189f45cb5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39285c31b1060b80e00bfc35f3ac050470083a78dd63814d8bbbbf26a2d94059(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2312507d860e720c788559bc301f40fc36cd6cea089c5b0046d885874bbac275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d04d3e8ecbc90501675d49bf5742767be25a133112f16f67c0a4d0952fd292(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5af9a58f631c9676b8d180be52d3abec82e7ae5198aad30936f581bfdab64cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760fc3f569cab2762e79dbc1fd78284db70d82761308f993a3fcfab182f6c887(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742dd3a63576cbc95daad1a7fb21279d54ab2be6192fcb1df54a1d24a433f067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff4b4c219d90b7576f56532f1643ddc0a0c3516e31b4191ba0258a70b6f4772c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__072c4a626f41cd80e44cdc96f57153d3cded1251093efae824ff940c5722e968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97bb163fad6e5d3b2d73f5661721e554cebfe41b2ef749a82fccba679f0c7c0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881da71711a850c11f7fc75a75a48c088c23fe8339e9faf0d49679398b943090(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74172ddd9851fc98b30f3f8c9e59a2558d92f0f08fd8e338d8c6680627bb5c32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c48afcda3e1357a4b10aaeb9d236849dc79cbace013f478827165cfaab601493(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7144979117ce0a8ab2ddf562305e26246ec69b8c3d6ae056f85bf1707f8690(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsAmd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce9b4e543b75487922ba68bd58efecbaf2966d9f44f60abda236623b4b706b3(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40726b685951aef7ae0bdb99c819e6882197716e39eeee8d86055774032aa28a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76865c40d0b25f11c81339ed0588119f1b687c43022c45d8f7df0d5adf4f921c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19dbfccc25f9a9f758ff4a6e7e1963bf15bf478932a45ad60f44890e7b715ef1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e70a503e274ef7329f7859556a1ffc4afaf35121bf131210550482e539331514(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6dee890c69351638da82e16413c22b4899de812d6b1a9f9bc95aab1411b1f35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1af3441e161a910d6f619cd06b1c8919ef18ff4bbff75d558a1761a1ee4710f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e250ba8f56c0bdc7fdb16af8ea612c8e1238e7442116ff700dbde65fb255d430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4217da966591e162051a90eabb3a98cf73a4a10f74a608a98fe6a55d96b5cbce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ebbb107dd3c0161601d02565a4577bf04f588efd2e9737fe4c5992b6592c64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f299328cfc8a4715e223d33112f7469cd6f184483e284a4afc2761f7a146eac(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsDd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29da795674f262649c0b2f36e0cb9e476d8996ad8b143e433f7729d1085eb41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330224c298494d127f7435d9117daf5604bd6a7742e9f0d195dc4023e29e9194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d723bf494e0a4a9513192fcd93f87ff6c5346a17247d19611f1acfb1f388ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__606dbebbfbf7002d44cfc6ba9a0dddcc762c42c4b1598fcf95e2506d9bd8c1ee(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef7d192689c70baede78e0dcdd5cc803a5cdcdfb80a959cfd33b470c02abf91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39c25ff4f0071e73f5f07afbc50447e7f0d721cd00ff7b81cea04039f5bac18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec68e3fb450627afe12113bfb54de3606c4f772277a10768f0777fbad259ec20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb44373a1f8960093a3a399d54d656def27d69a70324a83b7e97dcfceae872e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__609e3934cd4555900704f81568c18f21b897fa336b666602b3d914d5b4eac3aa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce06301ac5a2ff702042e0c9ebc26a7e714f0acf83e88452f8824271b5a6669b(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__284a7cd3f8b78ffebcc20c28ff28e12db5d654feb2552bc9c1bbf633bb221347(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae404d7e9ce0148009b839718f4637e3c05c7b5bcc0c27e63c2366250f06ce0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0e87dff8b389b55dd8148cbcdcd08e1eb24e7c4cb8e0c654617674813ab7592(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84f73531fd654a0f9d27dd69afc7e28a58957d06082adf2a55989efb9f18cb49(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05edb7a4fdfaa0a7433c61228d513e9058679111af20c76fc312b22142c9359f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc350c7e5dac45423a3abebafc2b2cddcf9ce876d32bc9592ac51c4a6fb3e1da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ce1135b45402a0ade3fe90ba43bab6f1c2752227494a9367480e46591ca521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148b7677a8bef95020082269433f018710d606f632d145c466b64868b64dd8a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f18ed09de17cb7bf5b4954b51cd43da79b1ecc224ec58d6d124257a410059b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLargeFile],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24003efaea3c1f9574f6667956d82687e47b98e174770db814a93630db3dd3a3(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f43d322112a0800e34156bde823045b80af4f727bc577a9ae899fa4d2de3795(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44501e7a908bc1fd0f0b16f3cf33becdd0cd34519c4a5e3f110c8b6f319f38f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e889c8c8f0f1394afbda9bdf5c1be12c2c1727514d928cdb67d3a595712bb82d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11559447844a3fe9aa600ea43357cf4071485ecbd573844c7c38956bd9ac5c77(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4251c2f8415f0e258a7e57905701d4584ceccf29e5c207f10ec3915cecc9724(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891c4b13381628aaa1b3acdf7130a8cd484d935ea0a436b3bb31107fda1638af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7318b9c29dda1d37db53f46e21216e827220d0c606fdab7994826c90be68f9f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__439a386f3300030393f649c6282925699f2ca14e048880d7cb7d5620863ebb80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f030777716b65383f118e32a208385a13a8187d99ac22f737deb8015fa7f99b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6423eabce51b704c336c8a39372d19bb5241c708ca0ee80d638bc621d23bdcd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9275e1b019d592a1b5c8af667487a8d6c1297887e9dc143ac7c690d36d4e68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6649014448c647ccb872902edd43b17aeecb882acf5a673e63040b39bd876191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e18e2c811c8a20be9e7e38bf70d9450edb0e9513d87e42df89d6e30082d4db80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afbd2a10d459b7219b3223a9ffb39723d0c0aab24657ce89781aca526b2403ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3a174eb630fad9e131732f0c4c82d84e16b841a8ab19ce43df425b09b07170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ee8ebbfdfc30e053f2f7a090d99bcd761ea941d652f6db3101f418e8e9557c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c39a361698e91ec2c4e0afd3eda7876e5fec7eb8bd094652578791241fb8f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f159ca02428a850d56bef8fea7a157cafb148734fdbc176f7d5c21d6a978a0f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af07f27acf00b662ec146a2fe00cd9cf06ae916b74bad8ab79485ce593151085(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b506bdf823262a565a44baf1804bfb628c0d51f04b7b57249dbdf95884826b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdLive],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e741bcc44672cda273b91da6400a2d8196c28b68cd69ce639f8c0936c78d8a(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6297f9eeda94ecd3d66dd7e7b4a6e37fe7ee63fe8b8e2bc68fbb94392825dceb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bded6386a5b3f1f607b4d9ff6e67ecdc7e72e47bb666b6416dccd6a9ffe6aee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fc5f894e287c4739808c053cae624c79de9764b60b736392187a182c81c601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4d23dcb03d1409e64ea535d60abdc6e742f02c5d62d1ea8ce3d50ef745f165a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2a9810c37704b73a9c603aafb6dcce87a739ef021b18ddaccbcb88c85f2f94(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d7691214b5396e3f429038c53bb1e3a1974fa41b6e6ab7437a4c65f6a115f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c4f6d4dd182ca345f102d506e92d994a547585bc66b52ff36baa5e86b18af16(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e68ccf183c095054bbbfd47596f008d02bd67bf17fa42fde886ada70d7d87d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155f627561789b493781b57ba9fdfa2cdbfb67bd16918b1f1808dfd9f4c20a77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a62c2b273f39bdabd85fe5dbe03dbb733bfffa9d6a42bc564ad0de17fddee07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca6753342465ccd709e5e76ae3f56f5169afdefa65afb68199d32c40e18d3b28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c742dbb358ec0edce2bb000f96cf38477f6e33fa282d624f4c2283992ae203e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33aac649b599621a3ddd9e37d16483256d71f2b436f2f9ea03050b47a90fb83e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7bfad10d99b6752e1a3917a14e1852c10485690c0324553fe7b7b91c80c230f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1594049fb3ec7d716c16e17b31469a0388e31d368df779d5f79a37d9515d6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a30ed9a3dfc79ca01b5a715c929f5ed1387c3d78ff33c480424e81c5f82adc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ce58958d44ee17d54be595e50233a504259e7be068f196ee93bd0233329fff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb81283996e6ffc0eef32f85ff3feda950fe18fb1c71e8969f4cd8de7f84c33f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019c156e80d9649d65dc84dfc276283432a952daa66efc30101d837cd9b5ecca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb545cc90c77c11b374af19906c8ba75c1c1737dc90ded965270fbc92139b24(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentCharacteristicsWsdVod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138c1062d14b86a5fd06cc01ec604c252a5bd1eba99b00bcd596f50492c401b8(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    first_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    second_location: typing.Optional[builtins.str] = None,
    source_type: typing.Optional[builtins.str] = None,
    targets: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f27e53c2a31708e085a49d42ae0ab31148fbd31c15f6f6203040cc221ebe071(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a96d8653198af9013aed7411a23992475a63e3021d7dcce7340f631ed3b1af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5d2577a2e294ca133db61052116c0fef4e550cbfe2ca4c0e34da019e6c09c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ace87cb15fe0234b61ebb9a91de81232a9bff47f08cd5ef753b3699354264990(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a271059edcdd52b9c9840e281008ee02c9b216338f0f5074d1eab2050417bc9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df570ee151cacbd61aad13973ab8d1dc2725f7572fa284b427d32847515b725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b6fcea4afe5747f48574caae367e4542e5393c7c30325a3f3d2dacebb56863(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a12fcdddea1ac2c813e339bfce7baced5e730a7f0b6ca2c65bf8f2b4946fef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc407e70b2cdcfb3f2a4eb4de4e573ab3cca52e3069ea015f5ed4fbb98420406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078682c9db0aad61893d5ea4966bfd90c9a9829cddbfe4a271d0764f2f7f838a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentPrePosition],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf906679cf3eaa0e0c9c02d6d116125ad37437b25ae16b333d11503b424ecb4(
    *,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_protection_mode: typing.Optional[builtins.str] = None,
    geo_protection_title: typing.Optional[builtins.str] = None,
    geo_redirect_url: typing.Optional[builtins.str] = None,
    ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    ip_protection_mode: typing.Optional[builtins.str] = None,
    ip_protection_title: typing.Optional[builtins.str] = None,
    ip_redirect_url: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_protection_mode: typing.Optional[builtins.str] = None,
    referrer_protection_title: typing.Optional[builtins.str] = None,
    referrer_redirect_url: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4375286cdd7f1e8900f8d3f4f9aa9926bc09dff914d6152b79dad435630aea10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c990e692852915a621d3637ebe389b1ac8295315c1274381730fdcfcd04c92e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948a958e6444e702cf0cb4656be9ea5bc8833334737224b7ada144afad67527a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e8c693c6f84761214e541af0dbe9b82aa673c07e7c7735dccc54af6366cc16(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5107916369e56d951c0997acd35a90dfa6495338e72b583bb05cdb57b2443da7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c2a6e4c6453dff2520c3de9152b26022c935231517230a8434db8bfa2e23c6d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e103d234836244acd7eddc42dd55b9d668d74f82c9ac9d6f5da88f1902d1145c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80a6efe7ee1f1ee84561a0d485121aeb0758872108ab744c8fb24f19c5ca174f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3b6205d72109335492c2fbe5c5a35ad48a3a783f00c35b79f7ce0cf91e2293(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a46052d1dd75d711b0e3a01c0f6a75b4a3b020c4e906a038b11f4e21f3a78c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__625a0dac415b3d2d9f781dbbf3015a308f28eeffc30d0a6f13068ace8a788ca7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f99910fb077931246536aff572b2ec84b9d6cfbd463a2454f23679796a8e5f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850b670cbe03205084d196ce1d8cb51f038d336a3aaa5cec1923725b4e8ac157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c797303f8f0b0cb78552e864ceb9ac79d57fb77c2716f0f5aa69fa94091a3a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760576b99ad4d04e5c35ce0244b384e413b1e733286c42d0c850cbce3e1f7b3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cd93ea5f9b31821b3438b3c8005c3c55914f42033d794984e4b8384cb996111(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060992252d55f70d724e5f14deb6eb8b23dc13eef2838cfa2f706a947cb801f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd381c2ef2c3ab84049cfd83f1719d2d7f1ec4095aa6ec8dd45c1cd7359a75cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f95864c18f96344cd74da46e9f552de70a109ed05f550c7800b8e9ab52d3ef(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa80fbb48201154e9155137ae5945178b6525e5f1be755d90e0e95a35d1322fe(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490a017f3cf0dccb46e0927a38c25e78527464ecb304c34639212561efc194e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84c037f50cbeea639c4c9d4fa2f28d0335ebfd1b04d42829bd0c767a5cb48d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee74ece1f868c9cbed550264f832c05ce308bea20c58b2b1cc58f2f4090cb323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53fdad051562ab5a0a5c1aae8ba590139ff3655183de076f37d391aa56784813(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e799ba4a664b046c9431e8c3bc0aed2e09ae8e4bb7971d88fa8a5a9ef4527a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40768231b1b6d7bd391c6cb97340bedab7e68e5f4e4d98cec4e205eaaf7442f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f4cc139874e81b9c4d46e5561e729c13963d3d54498d1ed8b1ea341c057260(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorContentTargetingProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6eb929a60b78f8fb5ac5b844a1f4d76e998dc4f5b3c8063864ad0496219c425(
    *,
    allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_headers: typing.Optional[builtins.str] = None,
    allow_origins: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    methods: typing.Optional[typing.Sequence[builtins.str]] = None,
    origins: typing.Optional[typing.Sequence[builtins.str]] = None,
    preflight_max_age: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53f753e76a5da4057c49d93ad15ca05b0bb278c8021aba3d69f69da090c361d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a610fd21d4f796dd20e4d464eae966f20c7ccf0f8a617246f54e4720e348da28(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dce478a0296e52767f8325d682cf949e0fd2afbba65aff109974bfc63bfa108(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3b478f412319c0348374e6e5435ad3f65be02c8fa42a753c323dc9f0e32258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6bdfe7e38567746320178a1456a4e42aca1e6770e11b7d335b18ad1d634fea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecdd5c484b6e4b24288a8e0fad4d56e2f50b66e8ef315d853883331c895e4f9f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3ad7ac9ab95ae3511e2693c4b5f14dd45ffdfc339fba25a95c4754274c1b81(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a3f1cd670b1f7bb94ca45d05d634e59350ce48df455187fdfa57fb33a22e5b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f4daa170edbf346630eb68451d09607c8e8b3429e1f427702bd29ac07f9a27(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129584e0c30e08c08687678cbec2890d3c134a497f8545e7b442af8749cefecf(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e686457ca30bc35040dedfcbd40722d2fedc6add7b342d50c518ba22001eac64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9b17889f294c802cf815a696b28df7f228d5fc9262fd841a2d8da1455912d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549dba8c5e0930bce6adf0a36046478a29bfc950d6f94eeba60084c9421c7ca4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7b0bfb16f4fd72db52bce7c8d9f7926614d5c68adeb378f3b227574a24d452f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCorsSupport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbec5240b1d09a2a42eed47e82790513dd694cf4c0e31f3ac1a0e90538857d26(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__122b4ef481dd71109455c05f46819d7ee27d340af3b3896ed0105724266bd5ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c196f5be9f9ecbf3bf9b80e202e3967a38e55943a13874a07cc3f11bedc5a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32cccc295f6c728bb8a4f56f8585ec4725a2a76ef7532fcc92492c26b8166cec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b03e8965170afa5309c26d9355819cbb6b4f0f9bd1ca19135f3fdd7e207479b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0761fb6c46749929f93a367a3590cfb47adba9c5d4b81e655850e480763f254(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f565d5024ed241fc63043d68cd0d306b6d77a95bc38c2431add591e4a2258e09(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eae7cc49f6eb76f7437c075d3b5634945625cb91dfa0727e76a0cbbe3424271(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e8d2c56e32715da11ca4537c2dd6d5e0f68e5ffcdbf47494ff6b33157e25fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ba250a4fb5e6d264c43a2dee315ff3b877c20992b63c3267d2f594247341c1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1cf28cdb8ebdf10556d08d3c4ceac193be419acce31f01a3466f1428abffa70(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c3f2168db7cb83defa2475dba2e8bcde8e47275224be9d375a02da07fbbcf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c610a3bc834d8ff024882086b560398c595d5fd73e82546c4f81922257a26b0b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a9cf580ec9c14f30a0a146bdb6c76b56597763f68bc993a3c159fa0ad9c0431(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1724ea218fc6484d8c10d33f59d972f2253ebd9981f4e96a3f84215eb94c33c8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4b617d232b1820554c7d3e9546a68f292e41bf1008a6fc57d4fdcafface887(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2397c32b8b7d83d39c5202e62a42a38e273a865c117741472012d8f9c4b0268a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f91e31bc813830256e9209212fc58c4744e26f34066343790cb145bd16f97d12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e385be49288765ed9b409765c36ff4235356345f2e49fbfdd3d96303e013d3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e3800e5956e1a0d41a247149eac351d30ba22c60febb575c9e0ca02e01fb17(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a879f7617bd507e329651dba1db5bc35786ed51e05438edbf6852dd6d43000(
    *,
    behavior_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df99bfe402120b141d28f083c35e28c329bbd1d130d702d58afefd47b4328637(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54078868d9854c37f859ee2917a9e9c40c41c0f92c17c0aa8eba0a7fcbeb62ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df337ae84ac9f87e6738eff843680f7aa5ba97cb4a5a7504804b53a90f91fd8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45ee5c8df902718644f392f2815aca52c5578f999a8a22ca6d6c5ab7cafbc5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e2eeacec754df88e0990081952d14b6596292b9b485ebd49a8e516f6d097b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d81d995fc00a932b69d4d61ffa05634a09324808d1069087fad7b6686522bf25(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorCustomBehavior],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6954c3398f90b1497c654fe22e291317f51fb07ed1fe94e5a5aedf0d2b9210c3(
    *,
    beacon_stream_title: typing.Optional[builtins.str] = None,
    collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    datastream_ids: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_stream_name: typing.Optional[jsii.Number] = None,
    log_stream_title: typing.Optional[builtins.str] = None,
    sampling_percentage: typing.Optional[jsii.Number] = None,
    stream_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e58f81909bfb7515e62d594a557e7db9b95bee536491b88119fff73bcbdd90ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a223fc89a695ca4e54f9f4e3286dc36ff848f18d3091b891230515e0021a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e137218b79130cf45cfb6862ff126a7eb704bd571323f92e63d192c0ce62dd10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0875060693d9949c2f10396256420b12bce25c53f5c65074c544099022f817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3911a638cf7169e2f097c74f955651e509b47386fa75fcb438f9eff98883d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f94f3f5c81e21807c8d1abeb015f494cf9666243f253a5b8eb1a0f8422e39dae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba68872dd101072d7cb3945a12b7c28a952c445d3d96db5503098bc837d951f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4478c8ee6e9714e9d3e95e4a3ed72135a342057b85237a29a0bab5405b5edae1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714a49332657a74f0fcfadbe9f7105320baade45b6dc43988a6b19f5f279c7d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43bb039c91fa86fcc14aed89c123df74fb8b09538781c8e2740e070dd308cd7c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55cf53d6410cb1fdf05cc1ebaefc8bd54044c286206fce8af924583eda81801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2514c23c32e342f55830650c5272b3375d8445b0822a456db876967869eeceac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__169ec4d3eec30b95575e6787586e41ce91e7c538592985860671acd9d26b5e19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef045d62cfd4805eab620a545fbb96b4e2aa74d0db7e128a56a4025b7e2681d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDatastream],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e691c3a7a9929e475fedd6261fb20d1450025adbbc8ead1e6658c769bf52c7(
    *,
    anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48e3cd1832dc4a322fc2e6db4719cc3f7a8c12692f8b12889fe5eb7529c8321(
    *,
    hash_conversion_algorithm: typing.Optional[builtins.str] = None,
    hash_conversion_key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c37c107a436e19f9ca8f17e80ab9e65a00a21e88cade3fcf6b5b9a8dbeb087f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e313a9b2011dada4fa0df2a85172bf827192a482148987e13d411cffd61243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033d3c0221ca14bd44ad50281bb0e36b23cc1af928540bc821fd375cceb54923(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c618d390bd24e32450a58739873d131585bc11a86e31d55847b64eb2e1a68bb9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7193ddbba4c03dbf1c1e2ee5fe4e0fb0c335396daac37d5b52c4ce6e435c16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2b2b4b63ec0aae31a775ba454d82837d4a1d0ed5621880e378188aabbb68b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7a6b06e4499e67a3f983cf70a7d92685931343894be3a105d0e3601018b766e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthHmacTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9b66bc2b3d4532090cfcb6245ed01ea411dfce371aef65994866a34cb4c06c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69a90817bca628510d083162971db15314db9703a55ef3463596229f21cf0a1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bbaf23de5a5aa3d98b2a9b1b885de73486f761073a4d2ef58f1a2e3723bd6f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8578290e70da8f5f16a85a2602cf9af244fc26e02693099689cb77350defa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75f7c49e0b8506b7feeec031a626f766e6118ff2cf94ce06f61a8e0edfc55a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc555ef67b0aee8d7608a3335c605222fe22c34e1ac6ba99f4ba5094b47c9e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb6d7ec842efae2a2fd2767d9803cb51ebc5a609db0df793f8b74c3280a758f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthRegexTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7d1302c0ebc6f5c0aea7d886236a9052ed9f3f8ad9a7c42d14e3ec608ab9f46(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    substring_end: typing.Optional[builtins.str] = None,
    substring_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc43d6a4ab9c06f80c2a55c2e3885006b567c9d42c611f58873d31f239038b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cca3b9c153ecc0de0a6c843c2147d8bf9c06064c1103933445e64aa45a7e1bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79b7086f20ca98d6b2301f3881e21d363a4fa4ff692cf8b7ef68156c9368952(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74815e467e1c866076f2257509034444159eb3e37bb62055b01f31ff65bfd533(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__369491ee3256886f3e7796f3e54dbc71d8833e39df35e98500424f52764247e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649548c6728d50594efd3e760f2ccc7e5df81c6c7482fdcb972c9c2a9cc2dedb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd7ca1aa7a570b198a9657ac214c5322791c034c07e614241f3e431f9e46a5e0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthSubstringTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9ab412a29dd27081f8e86b6e1cf88569a579481f66f4cacbc6fdf0bc8d85d1(
    *,
    certificate_field: typing.Optional[builtins.str] = None,
    dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89b12a63fd1b6b09675edc81880d5b56048bf82f2e9c9b7eb55f0f170fbabe1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c4fa12cb4665f5e021a9a921ae801d8daa30f092d92086c54b1c47c71acbdf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6f7116ab5c0d366e16431c700ff26c7fea445344ffbf73975c49c080638421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d506668f3b7c96262629587659fb5d20a35ed702b8543b2478ec110ef3aee3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ff83b790437919c0f1a6957777925982a5ef52d4ee5fa2ace3efd20f3da8c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad18ea09eb2b0ef4adc62a626346f3d6c9613f47d247af25e453d2effb1e725(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdbce220555cfe79cdb89475aad8733fd279b8fdf4c1e0b38f21933217556e3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpAuthVariableExtractor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8271445c670fb144ab96b869eddc711a2756e361d3603627000e35a28fa1d403(
    *,
    group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8014f840ee97e3fb603d6900e682672ebec15dda72b800cb320136cc35a477(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa290273c975964892dfcdf6507c840d12d762ae35393be90e253229f2611a0f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e22f313dc35044c00e9a5e6405c4297b5f4ae87a103b1e5c87c7ffe9a986d92(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a819304187066f4a5e71c0980d6b9e8b3f2e432ce41c20ba2d6abef04f0814bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fa406afbe7dca5f8817d4aaf1960ed215cb5ec9a4ec61abd1a8f16dd5a9383(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c625614448b65402c6066a5144089ad825477b82902144a89d1212881f985a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDefaultAuthzGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7df63500c80993a915b7bd9e5bd88679d88a6871914a922054dfb079ca8e47(
    *,
    custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d45cd0f426cc647ed19eab6efe284bd15159d1217d30ba174d80a6a0da09d9bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6e93ae81cf9e335d0a44b72911da9b7d1851cbc29d913e4611377c59c7fb07(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad2a8a7c518554509317afbdfbd53917951db3620b9083d9b219b46dd1ac92b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4fe4a90eba8cc274d49862e1c1569b8a4558d9a39f617b703ffdecab0cee2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5563e69abeea7efaf848db12b05b1ccb1710e3b928e2ae1d879afa82acf21438(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5161969eb557c542f403c2cbd0e54ed3a47fda4cbdd64a5251f35b03ad1d9fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4b5f5b5b49a9ed5747da2e4cfcd1521584f25cba275ceacbd8ed5cd6bd0dc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4bda23465b59794be5c3e43e534dc77333e8052b4d440549d357e86b2008888(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a16ce273c5e2d0472b9bbc4a5c9d4df46a5752fa0b3fb18191ff3e75d26894(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpDevRelations],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06cc13809f4ce64a79c335d1a3bd660e166c1fa25e4eab626cad6e23a2653b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9006866474b06b60eed1b0ba69f9e0e3647369808e87aea68f60f6d24eb0888b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__442301f98e36911e18be3230cc89600bd799d0e969bd48e04466179de8ecf013(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb34bbe81e3d4053f6d27a11fa1eaf7ab3a90da2f01c1dbb31f6c534e70282b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46c48e9c880563c61a4fa1cdf25941981ec19397336a76b3a3b4693f461502f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3684bd77640d1fa1d3dffa3cdae3771e2cdb5f6c78e4f62551385a5e9d08f25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a1f9d9a0db77b2cd77a0e953dc91c6abdb34b33bc17f66fb4b11a053c140a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a81b5417c9652dc91155735d5cde097567086b347400cf9f08d20664383c4ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05af0f9c9bbec2e2df8388a547c389d18456224b625c97eee5a2c2e47cd79bc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__642e5d2750a41b52d0a941b4423264cdb6d9fad09dbdf0b9a1432fb935c92d0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada50520088b8320fe7cd3db4361270357f3b315168b764c2ee6964a57a26381(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d7a5a1fabce30005f1ed93346dcf83fccf44b7d666af13451861d1de81180d(
    *,
    extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname_claim: typing.Optional[builtins.str] = None,
    jurisdiction_claim: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_claim: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c07ecf8da3a8066659a8dd6760386d31ed1526a20e4750f95ff5869c47320b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970bc65ef9bc2b615721aee5d0597c4b904788945a24774c2ca8c6fdaf210377(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff4da5f3da3fa944404164e9420414cdc1a4e85e436f88349ab392085f55f55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bbe3a0abd911d03c2c3d34b6ff165c5b283df0446b9f83e03f4bdcf098e01cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd507e1409f601413ef692bd8ced31753e4ff18204f4c169a5ae44e9f81aed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293026829f49589ce5c251e5c10d3ba0c2e2d3ee026a3391c6199c27d262b95b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6150383e5b109185f63f0f08974ad7eca48b244d979c334177ed84758cf38a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83dd213d021a922e5ac20fb5761264c7a46b09b5d3622d87e8403dcd138163c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa268a6d2a548648041c6ae6203ff9aa065f7a02e3db7749124c71271af007e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__028b930bd0b0f9b92f207a6c9cdda020642bbe2925b6dbc2a735255d859ee94c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410ae3667fbf9b7bbc6056a33ca7fb5e0b1b7040c1b313926853068fe1816a4e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDcpRealTimeAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776252d3b635ba4f2c136d4531629ffdf6b7c68bed6cc4cf63120a638fa361c4(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410025654ceb6af239ab319412028b4c2f8eaac4a9140854d28b11e669e14d8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2520942a67c58d8890bd0441f9d8338bc4cf1c5826dd4a06a40cbf49d41d90bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__415a64f32ae39283203433977876189a55b891aafcbb41df0bc237385320e735(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2d3eba7bc7081efe7f20c4ec89b0823bb2634fa822b0b111a9ed2b8bd4bfde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fbc943f4d00b209b2311f51a0059607f02fa4e82f2f68ed2611649e17fa9997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6dbd3ff7ceb35bdbd333219d0956fd7e553df984ec1e6a6332d7fbd5dcd1e55(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeliveryReceipt],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef8dbe0b5c7d473a4228fe1ab79cc4106db4c837d412b298a171a9cf9b81ad4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reason: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebbf21a04069a0a53c1a3e1147f22dcf75b8f3fbea079937158e268ddb0d6232(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd4cf450dad32870a5b861d3b31ad5fd1b17fbe06c5d03473b440eee13d2a32(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82848acf2822fd0f0fa9279cf3d372538b38501ac2e73f38c4f345a84de63dd6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f9370aa4e572484a28a52ea94099109f9bd921ae07e2be25d22f6e35f33659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea931b9cf0a7ee55eed5fc6048f1be466ebec646e77b65ec3251f730c9c35fb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a49a5d1d7d42d4eb35f1a56eab73c5797883a04efe94f23ac44ffcf621cf08e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7704841b1d984f114f7f104600191740c5fbe0a3bd08977d9d3c10e2edc2d4d9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f77845fbb23dae2fd59979db06548281f8f1c2a97c265f084ba81d3dcfffb9e7(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a30fa683bbaca75c1b73ee2adbad6b63c5438b782fefefcfc96ce141c28634(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138be3c20dd3280237f854246ac1e0283e7ae8cab5ccba2cabceb0f3cfcd4f60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3166b8c4560bac669264043ea7fe42462285c58d8b28b3598b1d6d5314adc16(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e6ed07e6ef7fd2c2ef4d5f694009a4253748aa7537e934db89cbf921c4b114(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9124904eaf70c2f0b2be5048a6535fc50b02fc35b07056aba56078aba9783fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c4bfa00c24bc1a980b5e220551798b3944c1daf2c5ef3c993a2024155ca02a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDenyDirectFailoverAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311b454d0fb9a70663e8bba0115b274222dacebb572f756bd73a6a82e6301163(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0243e71377615fda437f0578cfcd17bd0966dfaa6909e9501dc9e012b2c27c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd59756caa35f235ad39a706db9508c87cc70fcbcfc1ef813e6453a1b74541f6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dad59541b72ae7314650809d5067416796ba96af98af0e78738df4d76f584da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1697d52d1c1d1a46e07583f5eeb37f92322c0739e4f2284a949acc60d90a1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559145da4afef32146c923b6b66e44b11cd02ed1b52786a66bc34a59bf5e8508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e158238195f7f5260bb3b11e99dbdef7e9a4d45399c11444fb08d05a23bfbd24(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__185b57003880c7969494c480b95971995582da047d9e1e6fc65dd025b44ec26c(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409c8f1e6f189a465d6f7478e20f087aca1c10ebf305f135307051e52b7faf35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393f5327a994021dd8ef9fc58c9e804f65846470734d66ef4523887fac29942c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd3e510fe55de32caf261cbf6507fc8511dcd56e74f51764081e0fe5f1ac8df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87715fb727675ca3f1651d8edc45710f288266edcc2ccca21551d12a6caa41e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10244b61ae39a288e0025e085562d512ec8ddecb3c4e4ed3d565a44f06d80724(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da29c8bfd3a689f1e29fbd2b579a2c49afd884c54e2e3eaeb8187efe275e442b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDeviceCharacteristicHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949aeff43c5ee4f455207fa6ca8ad78778e2e503064cc8c60166623543747642(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da2d502502f68823348e30a8a9489fab7db888c5cd5647609533dddf8778ff8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b721a18d2427df3329a7d69e700c90c50da0cc00fead50be875ee467c138e83c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea40f71b0d07da2eef7abd43ca95bd65a288603ce1010df0f2ce257cec34e44d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd3ff7ec51ea6e2d83c870dc437f96349554eb19876d4c863cc62d36d5408742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb1a80e8a49684ed2ba59c6a9143741ca021a55a9b71bac61e2cebbf34cee498(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb7e5a3bfb8473ddc472d092bf4df529f2a68c006c3c56db35f5d2dcd871916(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef452866750fa0b92c04943d133938ba6f136d484e21563d2a4e9e0ad02f84f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsAsyncRefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e8c77a957e7e2fbeb26b60c369a26b18f20c7010471c179a17f9f81d23022e8(
    *,
    delay: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c076b845593fce1d291190d0e985100bd0b696cdec829aaa490d40c7b7cdb63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16f777f285a3a2a505897a2b0f06fcefdd4d18f6c8ae28ada832b9521d8fb35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89cf88382e4bb3c7496d82f49b0062a6bf8b6bed48df286bdaf0fde91eb9201f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2703e887a8296c00cb321979dc09b03c726c130e0aa6c90c1800758a3455bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc2f6e8845c906ee27b9a075aa66c88d21dfe7113720baedb24f77dd71f7b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cd4a177c4d78e79fd892825de96fed1bf9336c1880b28b7898ea19c9fd4627(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ade43d45e8590cdd9f6384de8f1ed8118c20ff8bf6bab06ea0d1dcea4240148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ac20f0d1ebfbb2a9ef40be47f05bccbe13c9372e2c61b60416fba64d99b2ba7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDnsPrefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1544e5caf17322e8dcb20a5c7d4a014dd54d6ac5f0a6d22eeec84e887fb64b2c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d14da358690fb5134072c1a397646f38de6c32a8c0a744c3781ce22ce4c403a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6198d9a28b13aea21855129955d3b3e4a07a73ac3fdc6e5c1be97010b7ed77e7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a378c7891af5b825c4cf23a1d57c0b6d7b286a45564268b1eebbab273f4fd4d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4211abff5b5a59ede053359d33d75544bebc5891fef851d40117a980cef38134(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2acf5a8f11b4d63bf4a16b99e599a78045458b833724435246bc092b9d08d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0cdf795a43fe14444d2570a60caa0decedac7f85be3ed493943200331ee32a9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDowngradeProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8392d50c4e488fedef7cc6548ebd36ce54f849cd0f42c740f7c64063e86ea65(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2587d5c2d34d1e02e0f23d59d37064ca47d964888bf7f88c8578de5167310fb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcef75b82379fb32c8801c3efd572c24ba598ef772b5eaf47e71192290cefc63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1ad8901f2f893b7d7d2fbaebecb17429432e475df2bc23997ce2bd2a5f0f7f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a024864f42832ccf973be71bf6102cb8dcc22073609dfd4338e9ea6f061a40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c9871a55d415bd05470ee609ddb78b342aaf13bf1e7ff897ee2257a35019d35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce2fd5e64980698df21c80f0f7e9d30ac2f3ce050107c2292a6932b52affc8d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadCompleteMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23895fc9b0424196ec40de5bb75fe4ff0eddf497b037bf11fc6eaa69d59b072a(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b50fee2900097fa7bbdd4c6fc9bb9acb439f33d07c94eb404bd4f9432d0fe4df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577e849b39f1d51d08bca25c4c4eb85bd9a4554832739e873a6fe1f2d46ca899(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd90e9d9e1af20aa53199f973cc765f313f3778440245aee428ccaba7aaf1e49(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11cd7f02d7bed13c5668d8c65042f9a8dea2fd058fc54cd37c39e7ad6e0b6d7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73beecf012a5b8fef173d3343974ab6fdbdf203b682bb1e75c6e41283f07a4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__434f684a8fc8e4adc03a7ce934c1b257db32ae0af57ca4a4e07407ffa288991f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownloadNotification],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70279619a1f82adbb7cdd7b4bd4ab1d0659e10029ee0d720a92a4cf195d770a4(
    *,
    allow_behavior: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    send_headers: typing.Optional[builtins.str] = None,
    send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfceef6492d0784f5ce0e2c8a1211c9e129ca1b317ae75abb3bc78d2c2520606(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe89c77bfaf019231281c0d6f5513e3df71661b7b121e61b5e8f3ea6c6d13f8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c660005c8ca2f28037672ce7384661d7876b5d0c1da6e3511c66e592698cd823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcba37031e26973e4f3a8788274a97f65e5eb6549ed0888d56eb6a7b9b69d7c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e7b3c8699f0033ba4d85c2f75d8435c734a74492bb99c68b293ba509f1efada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002554a1642e9c6de1f8aab2d3b68ae6a0483304f9b5831631d7351413af0113(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75bb90b55ecdbecd578819df3fe530e5f203c18329b40ea7c361b4b5642fc2bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90c577c30a9e5384314eaff329d675ff71ffa9c5cdc3e839fa4daec21cfddc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1d4fcf3ac8126ec5364d1bfd74557507fde7697a91b36318d19c8d3b1516c6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d75cdaae9c3f053bd3ffed1c3299e833af3092dad1455a4dcbbebe994ff460a6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDownstreamCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cfd526848dbec4efb6da5b555ab4d8cc5b2389a56ce8a1ea7eff550fdaf1db4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49c284a17209a1f6f8ce0bf2c9c313f5593423019aaf3f9c953a7187b68a605b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6080600224447dda4c4d92d9bae195139aa019305553acc2cd565f01e89d5359(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c30d586af34163bd55fdb51a54096764ac3adf966bd809ba556130edfc0dd9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dd3ec5ff81310ced81700db571e4e4d6a4570cfb57d0c94df08cad3c918a133(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac394bd3b9cb6f00c7200da44b5d2bbb2549eb9682c416c53c8858d40e8f451f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554d6f94d2726fe0f48ed705bd73bcc497ada902f09536e44f3a089853cd7000(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f6e653373e46f23711dd058bdcffb5f968a98e8744f51ca8bc748e9a23e5c9(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throughput: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94dc2f50d51a74c13db8b8862355dc3bdfca6d3ce4225dc65a383e436eefba99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f479d79828a5826116fcbec06a246a68336fb8ddba213bbe8bc58ad920f978d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377223cccb625bbd403396895ee2588582504be501b8e9fc6a9771822d644ea1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089269fa9c16d03ba43d8fb6646c5b4ec69f009e9c28574be5cb164d276f152e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af843e5dbec430d23a1cc21a61fba17430ca36f58936635ab255a2ca753a036f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d0b93e00cd2a14e74c7f4f5c91c8064e56a808d9647ddcf10b058c780918e9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicThroughtputOptimizationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee21b89f6451c4dbbfd8616d96c8a763ce0a0284b8561aa37f56bf7cd2477f3(
    *,
    image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ea34ed0c204dfecf9085e0d3484277ea8055b17a45b146c8dbc3b194c385ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0042982c5078fcc0348bd1b44e09c9951e814e3eeb3fdfba6451bfc32ff972b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1978c40149fc3550f396e7b55f8e3c7a86e7154aab5371b0a12b9eaad13546(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7479ea30489856c33bd6aa3566d16e411b8c2857ee291a0f06e0beea8a142027(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc880785a06f2ab887d7f1293d74d21d852965357a27e7b17443908b5e23363(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1848f014220f7f32105305c27b0484dc0b296bf3057a2e022219a7741f79973(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae276a331d8a705c609f6b0ebdc1e11e9bca22744df5a17b3c845dcc79865cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85b65ac546cf2c3ca87727097184c3e482403cca7b1be1416b1d8fce4a5a434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3e93186a7417cd5e27c97f00b636325c37592bc230686e1478bb12840e373f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorDynamicWebContent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d2a32595950dd4636720f1d5738ed8b2aa974f699c2c65fd5feef7357b266e(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba9c60a52fdbff556ea41fb8d082052a3ed5d1cc94691548121983c8b743c9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e181b03f26e7a68543f26429a253c076556a5ba5afb0368f2e02d77fe30ab0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b654469659737217e5ddf7e3f52dbe07b070ffb92c0b33ed801d5f0ba8c24495(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee84287aae2788669d21a6069cfc407f99cd2ab26fd601286cb4b48a29f22fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe19833af30f3a5225ad9a7b9f35ef5d5926353acc7461b3876fa7f62c79ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744d09e8821b4ccb4169dbdc83f49bb662065a13dc62a576caafcec3f24cdff7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsBulkUpload],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7a2279dba636da765c559bb092b226111c0c34954aa0c60b79006b5581aed9(
    *,
    database: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce0003c92f75c2d58747e8d129d5f72e2d425084c3cecf294f3930ca83c8e4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703cba26929cc727c2e314f89ec0ce1605f27ec147c33261b717fec0722ccd7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f8df8ef20f5a72a15a6e2861c99440891e49eb8c5fce82be8d0191991c03148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30a0fa609dec65eb96fe060b4dfa8ae2668f9a3a12bf9f58f848156c7a15b28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e80024f0a2afd7c3e7bf7f46f0ec258cdc0616e2261888d9ec4a334cceaea3a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2adb7fdeb1b2c5ecef3ebfc044d9d07177bf260f52d2294506279491aa55d69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cafa9ada783216c98ee8d7d738bb8c6775238917a494e3dd1fbf0ce71f33d3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d39c9fb6f2452726880f34fa3428d3f038aa0fead0b6bc6b24afadab8d8700(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a4c895b032ac9b7dfee911c510d109de51916f0ca0c455f170793e9294c2883(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b016bd65188659eb343053d5f4ad00bd437d47755279c04c5233e50697f8cc7a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDatabase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4056e8eb9b0fcbb46fee0b66470787a91d63b9c0d6b962bfc7a753dcca69df(
    *,
    dataset: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a42228e0d70acbb5f7c218e1a8dc632556bd7f4b1006e15b851a0df6029943cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987b0a792d23cf0f3da7e4569dd0b949564d8c6d4db566648bc15760dd24fc76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce4c191669d1fd7d724556b6868921537c785195e105619c4c9e951b4707f39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6768fc0a407b322563615fdf21159f7fe3b4134ee269d000084ddb465ee953c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85b5d86f797feb1c0a73a1fe09ac871733b2a9a4401fd4a92c72117067d228c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29b32a72b353df5dc2c5788bde4d23486769dffb8b98edcb45cf18e8ce048c0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e908fc2dd5d1a81cdd09ec2f431b8fdd2b256fbbf5a4b8b4d509c61f5d65bae1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661485c66f4a044fb8ebac94e6b963243f8cdf9e3a03ea7522bdf72f17fabc7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a617074be7bc03347efd3022f96e5fe3d4a0a1d5acce0ac11e1b7d11066cb61a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d46c8bbd604db53aaa1ef0c48d01ce7d0a9affe9c97d2480a42c4b1313b8976(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsDataset],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e6f4997ce231d6bcbdfab25da56d1a47e0f9207c3a43a90ffba59caf37ef13(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc3153b8d664b3d99b7884b4a7a8243657c54986835f68c49037f23fabcee0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f64ccb61019f65885e520888d5ea7a78bfdd4ea52e09b827e8486525a0e7979(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e3f557e7c8a4f0201a5457b18423fef44aa66b01eea378cd61421d8ce2d357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd087bafc611b63c6684b40a653aa73fbff3e2243e8926b50a751eb5a5ee8a51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9fc9726606e5e5711029231beb01839f4c0e07a7b49ba08087af5c4c785e665(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6629e390e5c6d081a2fd3c6f95b817a56ab425bdc56e792636c9738642411a50(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEcmsObjectKey],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5918165c10164352334b7d0a8f3708bb69a74387a949116eb599ab4b094adabf(
    *,
    aggregate_lines: typing.Optional[builtins.str] = None,
    aggregate_size: typing.Optional[builtins.str] = None,
    aggregate_time: typing.Optional[builtins.str] = None,
    api_connector: typing.Optional[builtins.str] = None,
    api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa012517267b91ceae8cf23094478e336941091572916886943e242d52a773d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a874cead1c384aa5818c268d4b4e3060f1fcd235f27b98f79fcf23ccc29dca22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec054407ac75acab2d58d8ed8ad5692de46b22622fd951989351e5fdeeba75b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d007742bb224f791fbf8c56cc14d27a99e17645daa1f2c66b7f9868c654cdf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21fc9a7a53feb67aba510e9a00784b4ae92026d952a78692aa712a4524a0e6c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665a55852be269b3148eaae3344443b3c2249b07d39b47c3f4a937589915354f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c48bc9588511c3323a29debe1efc0739fc588f1071ef18e7f6a994f79dc992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bc424de76055faa4a28297e7f4c5d5361b44abfd48b55076ac68c443a1a45f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118e9dff1dead2b7a21cf3563fc194757f861c41de76c88edcb05cf933484929(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__245563b9331ad99e84fa88a63894747575c31439a91a4af0bfe194a960e34643(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1881e0f99eab092bcca5b67039ae57e0edc6a00686e83592836dcbb89bbb28be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08aa73cb2a9e5592020430d1910a37885b74ce56b16d3a8e2324156ee411fff7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a660e2d208d4941c589676a58fdb6edacf131c98ae55c57827cdf25f6015931b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ba4f310f45dba69d291de9fab6602a8f7c4ca9073c2968d8a0bff56c8fa8a47(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeConnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6daa3d4290bfff5544e02ed95c723c9a89dda495168acfd3ee466c874e3572d(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cde696864c49833bd443d91fc04a23d2619204cabb88c51c823a8bf61af76db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf33c6254aae23911020b5281b469c849031db25f3f31ff2bf608611a7ed8179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0021c7716ae29fadf0ddb9fa48c761eba25211285516abde4ad04d11b34ddea4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361dbcb11bd93dba52dd6398bbc5210849290f411ab30fd1e83a463778027c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d989795b44fcc7746290c59c2ea11bf9e335c29be3b238f67c554dca3ff1f162(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee500f317ff6436fef9ce65499a02d5bfbafabd879331fdfabe3c9883faff8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed9e91524feb53e480d7d1c2c756243d7cc11fe04b3c6929170d43718f5307e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fda8d5e5f4e6801a84a0a29499d77ed525710a3ad70844e57024774fa8ac3f(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    ip: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5005b20221cf0843379d0065d8d525a1f128f390c229f34cb8113cce887cc0(
    *,
    absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    context_root: typing.Optional[builtins.str] = None,
    failover_hostname: typing.Optional[builtins.str] = None,
    modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88570699fa299031b23b103dde94118d97c340bdc8cc9aa77745c72a21be694(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c17954f3bb2686d16084e18fb173048028f334bd7a1805909566123f792f7f8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b25d23d69bac69a3683d81434ddbe534c943ce95a9db944fc8c9d47592ec926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e29b96f34ca359cad0814e0e7d8e141e9f9c4b6dcd1a7082760d7dc1044345(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a898a54c4846d724947dac9a4e90c549786cd9aa6da4384d18b9e5ecc69193a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef1189965e68556d00d1604e584c4398653236f60eedf7da2ec3e89df5e53d5(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de001784347dc79b5e0fb3962ae0dbbf7f1aa75b3299c241034f33508a74f45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__805f37629c0c064666070462353daeca6bd7bb06cf36f5e4f204f8bddeb98d8b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f95f4ed11fb0ef661ac062ca3b4d0a0aaf7f96b45843892817b51d43d1eca07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b205de80828a41fdffb13ce51442820567704d470b5a9c95d0364c0b6c612177(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb77611d64077569795b624ed502bacf4c07c1c451bebea08e6541eb6ee34d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9bf79abda87bc540c90dc27f36f0fc1b45931944a968f2e7d137b6aa861286(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7a98ace876f07ff341c69ae7c968d4c457fd2aa897753cf6cdf74d4457436a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4c055dbba8d4b3b805c3e29f5ec6527aa5fcd1ca720e2b6ab05e050e5cf1e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6777bd401f8b606c123eccf7e55a3d74420b2f006c37c8fd413851222089c537(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e8eb4be8a1c7948e749d8bf75d45c9854200a8c3e8d3c83aeb9a3bd14b5fdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbae9ea7f8953995fc8f3db1ebe8dd19e2df32f03a4de6e28a6571af06766653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e8af80fcaec13bc12417070b8510bd2409fa3a35038bfb7e847f7271ac437c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59226ed3b4bbe12134f7cb8186f0a945de46ecde4f7cc7687e829f68cdedeb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e169ef52d279bbba08491b11dfc120bb1573b142c1d288190e1ed24c93fe82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b4bb931832f92bd98a8d859f455b4dd6aabb3d9150ddfb238875c3c03ec191(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a19b6fdd14066b812db30d6f4f4821bce8893ae7c3cb8e5416f521fd42b827c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc18c3304c172a8b0e71278cd7b75158d321e10d1851652e94a7c4761bf2399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3419eef25658daebb89cd66515549ba806e7e37319e32a80534ca19fa2e959c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a39d710f752d641ed77da9279aeee26e078fc1caec93d809dd617d12b6e4c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed580a79740f36173f585f5ae5a31f95f4b1a91d8ad0beef7c5791ed8df91b4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingDataCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf740f4971e6f30eb6cb7590a1ad841ffa0ee7199b2d9bbc4bd4b41a703ce1a(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_persistence_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb47c706f4e1e2effda88273fd48000af23846897613754261e21cb392d9138(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e4b6047db78f90fc50dc12be7306916d81668a5e20c21c186b0925d12b323b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d0dedef4bc735496d60b612af097b1f45f0e8e8c7d3ec87e8eaeced99ae3f7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3873c3d3618ef224c5302d839defb9c99a2c1b04b7701be4541b33e8ae400d03(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527f542684fe0eb4d05965b7624534e5a961fca7e953e23f704ab8c925598a80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__682ac013a1197e6d374b3073c7519e021ab7f64008096e2be63da3e543f2b3ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6816173d6522e7a59bacdf0a4277bc9b625ed0caee660b8e12c603b66fd26a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7b56c53eb45bba03e887dc23d1fff74f5938791e6281ff8569857736b5922a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d50610e8f10089da901b15919927f9ea9b18403fa78d3a7904daf578c8de75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b25223feb72d27b5db3aad0a21371c8e36a7e9b6cfe1d189b015db77bcdd53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78eb0994a2898aa328d9aced14c3fbcbc62bfe291cb755fe67bb50516d9174bb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeLoadBalancingOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e422d791e8ad5468587c96186b1d504c4ef170768ffbf40bd0f007f9ae1835d0(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    domain: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70e8474aabcb1e4b6938c8f3e3dce82ab9c8eeba030671bada2cd6d36c24a29(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7c0ed2aaebba8850465b96f267b5d3b218cf2d7a21c6a1a1c691cfb998d395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8538137a8e49a21dc791afc5a5b5d5d57201d99b10a1e727fc6f7739b436128(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df337f39f47808ad01d4dd4ec40fab94417f18a476e20dc877f57c0effa1827(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f998a83ff15fefaaa07ce838a11394e23a23a95667a34d0ccc65a3a7d247d452(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4546f26626e7a5f559fdd67ca8ed134fb5d4213beaeba9737e58b65ce2f08f78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a6fd3b1686a1f1d138b3f237909c087d0722bd58699c0f628f45c94ac135d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2836ff6208387d2dc421f9ffac84faf6a3ed8b361722415ab5a39744deabad35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd4a739dd9d2fe628bd329a87bd9fd680cd0a5e07b078810cbb92c550103de6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeOriginAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8cef1e7b551f3dc097a3a8fbbfd5610ded2dad785e43232d097ca1785f6e3d3(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322c8caff75cda9ce41e7071b6502102c365ffeb46252cdbcce915af46eaa4ea(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331b70246d0424ac580992bcd882838d8a8173aebe6ef6cd98982c8485c18eb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d36ec3d70a967bb20679e2fadfc726ebd66916a0e1831e4daefd050ff34ead(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22df294ec5db3745b304bf3aab2fc64f0075ac8efe19ade7b56fbd843c0c9c68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a61c19d963f8e86a0762b4a3e6d941a1bad54cf2022fb9bc96cc4d44c8cf311(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirectorCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd6d9167f90e4e8d5ad818f25b58e7fb1a15e302c7f56ea86e006ff7a2f48b9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd75c69093da552e4b86c745ac5ace837bf4a7a430843bf350005a2ff1c4fbd2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3e1ffe59f935cec45f9e7513f61232fc284a478722d2f3b4380c76b744b959(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835bb49524e3b7efd9a0369aee912a53d52f18f6e1b0685e5296af0562851016(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e6ad5c4160dbd4d71e833e1a681f5d248d00526a2590380217ca1c8096e307(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe098e9cc12a24f1736e864ec797350e12c85c7b6c7e5d6f5a7325a7480526ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__795f311c094550016d3386fd35b079b11dc794ba75cf65130accb72d9f3996c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3f358993d0e4fae91bce591bbafb28174fddddc4bc3e2ae103744532491423e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeRedirector],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f79e3fb861807cfb123636a7904501f4391011bcb3ea6a36c809007becea33a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257fc42b6e4591673e59273ab712c47aecfe9ac7e864a706b1df9b46150d9402(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a331432ee99e95b3b030e15af9466c085dd730dcc4affba61968175901a8bc5f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd86d0a39d3ff2b43a2fff0068f3117024aa92eb7843001371afb173475d9a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5baa961a76b4d24cd3ce0dcfbf3efcdfd997741b0051d45fcb05a01191be09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__489525e0f4dcd38565d4e2d7cc0589dc93c217f362c54c4b0dbc149724393c9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b6b66c17938f0e9802751ab3a9a98abe67c47eb177cf831e5cec316e3fad44(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeScape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3512083f336313d452f4828ec30bebbe0e57f42c22fefc832a29f4f9a7b1297a(
    *,
    detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
    i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebbef6665e1f56dfb27808743feeb5e2069ae625e643e858f8ae72ed6777b407(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__252b50783a5be2fd89e1929b4004808938316a21368383a2845e4b483e155bfa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eaa0f9444163adc8e52702eedbcd61807b32fb816ddc7597a36bfcc74e1c036(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d047da01ac0244ddb90c45bc35da34f4daa438f1a9845d019e73f7ad88e26b97(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__778c32d3168a3c8b1bb5ca9a64453f2773fc5231e0efa1ee0302709fbc4e4d3e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9afa658730a449f7be68fc8081114344eb922b8704e87e45347d31cf892cf9c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d4b7705d497be428338a2adf8de55bf458483242ab614b02692f56d41cb1b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6340b8c4046cb4fa8e08af75bc5a310eefe1fe1b33e5a9f324b9085e172d5043(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd54c91d3da8f8bd684dacf9900b7efb6fb239a73139021a3090164169b03fb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1a43918d0568717b85dcf91e505b477ca39670c25a8d5256b574d33e95b622d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3c2b71de25c46ea28975c95079a2b7185d96ef74f430f68856fbb2bc02fef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc6a37b3ca54b3b810afb48a6f3a10d4aeaebd054b1d0103f7733ea5c871156(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeSideIncludes],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e5fdfd937e0323177bc35434f87eb4267fb0c1feb22ac57d87fd09b22f20124(
    *,
    create_edge_worker: typing.Optional[builtins.str] = None,
    edge_worker_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    resource_tier: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d925da961fd558995fcc44611d62c56866f43971ae49a533aedc3311c54945ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8e27ff3aa6faf43a7701254883d9b11330057e7cfb75a651e0ac22faff2fcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80fc0b846be61ffb8048fc9706099d5f58f4ef7be95ef204b5d955e10b0d700f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d728fe77926d8fa3f7120ac521cc702e3d2a2db7ca90a03d682bb3c64280b37(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10e33a262af9527cc7978aaf42e31d3091155a1a4522dcdd68954b8b8fce619(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1388f424a0018d66d690debfd7eda77607e23768e9255a018a834470fa97cce8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04766ffa63e763247d31c00b381bba1fc1e2d158a86a722352aac4f41db2dcc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95431b851631cb259ac01afd05704e1e4f7e2726093c54859f07fbf8badeb158(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac393c9488e3497394effc03875160786f266bdc03de49bef56df07a4b38cd1d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEdgeWorker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e17bbbc904bed074d76a40d0be5c2ebc51bb9ac25381d220418629083b24bc5(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b129e3dc4aba5520f2a932bbf869f26fd954e5ff2f9270dee83a927005acab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb2a9ec3558e97528bd3a55fe0b23f358d54b4ba35def3f8cb0ce492dddc6fb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2169a070aff82f2bb961c7347f1192fe5cd39540ba979ff56438532d9b606b2f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc523dc28647536f03f8a964c1a31b951997163df66096baa260ebeb34c68c19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b05542450701e8e97a6addbaac241bc03f8b8c255f03b5196ccfe7445769411f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c4763a1b41df78f86a85354e20b9aa1c1ff754afe568e1a04b111d2b41f690(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedAkamaiProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e7f3ee2097ce40d6d29056c7cdc36bf0c4f923c9a36c16f6434e7412e15002(
    *,
    anonymous_vpn: typing.Optional[builtins.str] = None,
    best_practice_action: typing.Optional[builtins.str] = None,
    best_practice_redirecturl: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
    detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_hosting_provider_action: typing.Optional[builtins.str] = None,
    detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
    detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_public_proxy_action: typing.Optional[builtins.str] = None,
    detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_residential_proxy_action: typing.Optional[builtins.str] = None,
    detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
    detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
    detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
    detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
    enable_configuration_mode: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hosting_provider: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    public_proxy: typing.Optional[builtins.str] = None,
    residential_proxy: typing.Optional[builtins.str] = None,
    smart_dns_proxy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tor_exit_node: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    vpn_data_center: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f8afb0b13c2f2d6a15635602f9bb6b3a7a7f029c707dfed744214538ee7d48f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412510d0ee3891986f3318f70d5c85e090e3e9060bd11f088cc5b0d7feb1f5ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6106fd42ddc67aae2fd56ecc4335882fdc453f7c1f63746337ec4e384c253275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8995e663bdc8eb4f4d4cd110afc4f0ff95727ba766a8e7e00fe5526a783e1d04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8a29d733ecde1146999710f0cc9de6112cf6c6b081f710064ff33c2afe135c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecebb7929fc5b27ac1a06b5fc46bef22ba736a3e8413cd3cddf1b9dba3140c53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff83ecdc47e697b24f982e5a543af1cbfd926e7866ea298b184003f4303702d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822fcb723caf87da625626ad536d7540608568c746fecdf4ed1004b8175a492b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8436fc5ec72f4b0d0b29f7b5647571a443b42f0552ae3b6d47047cd5bc806060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3439e124cf9ec23519c8a28b65c842b190561b6eaf70d2c787fe02bf12691afa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf8beafc75ae108632a84063eead37191763070bce96da67153da803b1ecb3b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ed9d97fd2346e6e7517baf89e2e29c34ca637d90b854ed7c759d8cc0e1d690(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2291ebe004e7150f21f9efefe61072eddbc3027edb213073a899061f1311fa5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5692323b801770c096e798e8b270b7cf792d5389d2bc6929f9d2926d79eeb729(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a590777ca528a355d6a55f651e46713d614ac8992f588b8e33225967cea66d31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0604d8589bcdcd7dbc91c2b3a9d45c9148fca1e402d3a16bdf69f4c15268d42e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d213d97c8942de76c1766adf7e47cd2286b67f5a4cbfe74acc4b96aee4bb10fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a72c246c533d540639a81b09522636886e418aa54d73e883700fdcec7f04a688(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__527d4dcc2ff69620d913a5bfd24ade77f8679fd11f8c185a03ec9e4d5d5af1a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be97001315ffb7813b3bacaf809e53f79fe4c626aa1aded6c6a54bbc0545aa7c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6df94700dcc032c257d15aa095afe1d9e6621d3945b37674bcc87b2630bab23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51b768948ebcd943d92dccd0ab8ed1b3fb55b2789fefd91e35fb8108603ea1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6356a4845f9a944773595f9dd8e3e023058b62a80f5d09196d202b78fa58694c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195775d3b5c4b235b3de5bc4e16bf39b5f14ccc525ba8b4fc0f4b2e362fbab55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f91a834c3149c7cbb87253659dfb6f28b36c2b2afceb41654e4f112926075e42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebff9cfcb780af92b26c0f2fe46ab8b461ca2f06fe23f125bc63257115e2a09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bfe320dcf9c72ccfcb9cf84b0cf65328049c38f3202e53dde655d4edce34c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4581848c8452ff97363ce633b8f054823752b76436df61b1412be133d71c7124(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f434f7fe7cb396e476418cda9a1e6df3f58f8a6529899f230041b53a6f15aa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f090431cb4ccc485bf5a141b3223e56d30ee444968e0469e19060bd462b96413(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6396cbe9bbcf194e5e39064165dcf286cf22d03e4bc1a221dea99a4b7ff618(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fe64e898f0e71427d408cdf46b2ac9be98d20b20976aefa92042b39b57d81c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c76d34c579081b1e91ee591764380b1d39fc4d5b2853887520e405567b54896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924ff20239fe84cb58e194235000cd42d856f970b679842007e6a927f250205c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c61d02ec6a504398842dafe2b1259dda5158b019cee832a1cb4aa4bdf5e612d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3626bafabb780f25f5f559a29905e24ed98de4f89d1f4824209af86190f4921b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944cda9e51421227329d522e6e9af794e29d1361f1eac4e3c5d48cddeaaf02d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc07c6417b12ef23a75019eaec7ce11173b1c76b66a8b1ccf1115216112c429f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEnhancedProxyDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e240ba6ef704796f7a1a9163257d5a0f21141e4651ca5ddf84e5c61fefcae233(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deffe0d0262f51b2c89e70824c0b074be807fec982dd4c6aaf6bdb3f06f6b26a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201871a13af5e1129374147d8d4378db2a46cd178660f3613d1c2251b72fd692(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7761fa018d0918d529d801cbdec424c39e77d05d89ef59f7b59a8a10a2945f7d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989d06f9784136f532c61c740c312a6cb95ffdb3c5878b981d226e971dd062c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c90580e753910cbc14cb64b46fb6cc356df82624e4f44615e63580cce501cb0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ad4ad2dcb9087bf058503a569bdb4c9f747d5d6ea932c522541ec8d19cabe0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorEpdForwardHeaderEnrichment],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4ee38765b25e0c4b208b7718ed73435382a434730816f1e0f4ee399e7129c9(
    *,
    action_type: typing.Optional[builtins.str] = None,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_hostname: typing.Optional[builtins.str] = None,
    cex_path: typing.Optional[builtins.str] = None,
    content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_hostname: typing.Optional[builtins.str] = None,
    content_path: typing.Optional[builtins.str] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_method: typing.Optional[builtins.str] = None,
    dynamic_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    protocol: typing.Optional[builtins.str] = None,
    redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_hostname: typing.Optional[builtins.str] = None,
    redirect_hostname_type: typing.Optional[builtins.str] = None,
    redirect_method: typing.Optional[jsii.Number] = None,
    redirect_path: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60940e03e6a5aac851f599496036615082295c7d985ef1bc49023ba0908f379b(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89145d63056c67e9c276cf2a03ae14c56df00ebc19b2b1c818e178706e9b9e1a(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e4f1c1ba9c3d34d50a458f8ead4429d40fb29a6e9afa3e0da8175aec66fb171(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d496e393bfb30ee5cf8e17d1e8ebf4b47375c0573eba9b8589d9427a14fa0b3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089cc86dcfa25945099c22165431bbdd6ceae9a89c3d7d8a773140c767f4dc58(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8482493a0c8c3906bc3fafa5d099450cefa80070494c88d1ad511771a88c72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a2f9453a3516433e0d0996e7314362445d6f639bcf0f54c1cd28907c72f0ec(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8f56253460bda255fbb81c49560084fb29705b459b07e9f01fe4e2cbb4ca6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9314fc402dd4fc6120764c354406d0154677df16b6147d27acc23aaee92535(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95534b2ad76104cacccb4705802878f177ef4e83bb9cf6494206f4fe0ca6d6d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652812a85e57e029e7797059305bbb6c22cf9b2d26ac6cddd09a90ae1725cd67(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7126f0aff339c13901d62aee50b3e4e8db4f17563936d545030997d10720da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30fb4af5a15a0a31b66a930ec0f1c33360124620dfc778642faabb0374d64aa3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a004367165b778064c80239fdda58d2572d11bd0c8b622c0341f4b7373f9775(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbda534eb1dc5cbcb5f8ed44644797a8f094fc5a14b2e4bd4b98e7746dd9533(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436f5b8f03be0b693ffc24c84348b2505999176a95dc1fb5ced04206acbcfad1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37218d259ae14c374b7f58ef7a5ed52a5c5ee7c54effeb5eef2666a36ed7d2aa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a383c1b49136472063d3a961f53e7f0c0b16c6ee0ce1709c0c7fead6b1b08be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38e5bb4bf89a4d508b940502880fccd2e193b0bffd02ed6e5bc213fc40f65f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbcbb50040b635f6cca6bb5deb7bdf3d773fc2cbc05ed9f316a54e5fe55466e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailActionNetStorageHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9a1f0ff480662ae2d52bf5cd5998a335e0e1396f93c80c0608ec36a7ab051a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61c4e1eccf60110c0500d25018ec3fb4221e6ea684fc5b946228a863da10b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18fcf5bc6d2d131cbf6641dc24d8b77c23981abd352926fd5d8c36bf15a6634c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada2f286c78d1e8cfbe0d3b223d141f6261133e775ec09477c8f02ec4eb8b2a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__245561b414e5fb41915574f03292b136f2ec170e41db63ce7f665d35a5c8be02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62871771b78ea9cd94f7dc648c23a0e054cf8373259907500ad38e6abc223e9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77908eee69bdafe829cd7a84530ce325c525ef1b8f14ecd4adf7aabd422d60f3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aad2f0730e0c6760df9e1a6df03904b90acc5859de443450ac4517b54072356e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7648f0ea6dcd2d1e9c2fbca6385b45b3e1e8fbe3ffd37153730a1ccd55a82635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a681d46b7b63dd417bed788f4d84f520249f0547bca82e998e7e27fc742fca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6e62a94ddd40d420a5f4982f1cc07607e1e2f49f5e29ff7acf8f38c2ee49e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47ec44015f315302e0f72f0c58b9842bcf93e5f49980812d27e5d0b4d776f6da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59de9d861584f68a3f2a218579af1b04c3f519371cb31f8a804f88b384806152(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f18c67f108ede31213d0a89e26cae66973425d901a483eb443dd498679b6c7c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380e89d7a1d861e7087286991071bd688068845ede0f51c9da69fdcc9a0b8522(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691a04b608d096c82a7951e269c77899d4acad0d3144d2645e9b66cc4b2d8410(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33bbf48fc001285f48399cc4420ba5a94d77d6898ac179c6cc53290e9376ca91(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816c83dde6f725650dfcc87f85aa9171c01958698399fbdcd44c17224f866e6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee3cc6245a799e070595f77eb8cd76688e7bf77fbac35119c45b08bf820e0b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998cc8f17f42751f7220d488906aec66b3714f07db52d98f5e166e6bb2de123a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a16136fc7352b8b14c789670649474b18f0fe3727922a0ed7a95c73cc284d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9069e66f13f684fee13c7f66b92f5a187fe54061f65c0ec2b4b5edc33a56c59(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5364a052fcf7ece43730f1d69def98af502e3c66810df0c4410117438f7f6bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea232490646f6f07af48bec15b04444ad903a0c12a7dbc1e8f31a492d195118(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52197fa2ea2c96fe742d99df1ca76db63c5b1d9cba275ec982f9aa4d2e49ef3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59e1a915673bc3a25613be6764b8680feea881f2ecff9d2608bd18b9d43a0016(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b9817d187cc25690a6af30037f3a5c90dda2892b8e5da86e97e04294bccc3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195dad56ce513f91aa6da90c68734c1b26a348fac007ab6c58ee8e1b8d818b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85e59f766d1dacb0b375485906e852047dae9b880c47d72cf3a1612d0ca4219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fde08df161ff6caef90c3e23f0b1255e5f8ab29573b1f8d46d8d770e03237f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc9a9e067a108049db88a797e2db31f615e9f2999589ddd7055ad759007e9fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48cf514efd1b4b4645fb7ffec2ce8800779e0de5962264f9cc6f2f3ca904bda2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e209c0155cbcf349d9ade099b5b046a5d1cf8bb801aa144911faa8c96bb67b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc9b0efab67f551e7e93f1a0d1b83c367c973ae2c1909c9ea5997f728196edc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14225dffe12a80b5867d9f28edcded1e883cd45386a3d8b40f5e43bef43bb3fa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailAction],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec24d504dada3d6275c462dc5a5a1106bd19c3c8449af28de807f085ccb4a14(
    *,
    compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__230c7f08d0b11e9bd218337749181ae15be0da7cadf5346f5a8008524afab217(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58b6fc6a910588ffe9ee86bf1e21200589560b73ce8caf80cef0468d3a73bbe3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708e5845ced316e0820ff49d4164d183aec1e8fd7c0a5024a3b56c898cb135fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc1ce8701e4369b86cb65fde0fbc30169c689d9e3c16be16c8aeb81c0a79881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a95b044b09e92106fecb80508af9495f94103e83eeb7a03224a7e3fede3672a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16885581489da92e4b54a7223a0d37610f8089b4f4b02da486ed8f7eb842d42c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFailoverBotManagerFeatureCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03dd65a83666d6c7d30ee71fd2aca4425e4b5eb693f82505dbe5ea8b10fe386(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e40a216beada2f306f8a094a68ff8eee4b3ae6aea13a11b96f87292ebe369b7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c7c6c14913e7f96c19cce940deb9d0cfef8e24dd638d748816b32da488d603(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234ce0a2b9973b69bae0f544cb239a9d7814ce0bd8ed12a92308fa29f5df5091(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b7b2024ae01135371691c80972dc54bb3c9c5d0a9a645ed9dba2787e7f452c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eab23e9dec3f0d1b1ae358c46a9c84ec141268d0f95a2c929e224af4ed223b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9061c335ebcb4339e454ec1205abce4e1ef869d2721b9602ef55392aa8da92e2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFastInvalidate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11ead7f6065d059fbaea62f991631707a7774b33a2e02e3fb38598d92a7d626(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6377a43bb7ec8bb496814452f475a8ce953a824675c71a38f1f7524b87a13d5d(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ebc78bdc7ad501473acdd5f8acbb5a597870abc50417aeec4dbe0eb7d2692ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2701426bdd262f8d22c21b365d7a943674dea012d6d4450ecbf548aa9c6c52d1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2250b63d7beb35d20f75055f68a88e5a8befddf1f7ef922f8d4895bb655b5ee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb7b6f4d81c4a3195955fa05a5a3f487da448803af491ff908119695774cb76(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f430fa4d87a3d1886bc4a2b84f0ba06ad730d22608688c450bb9f0df03743f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7fd3e85e06fd2b0f663e9384359acfbb92989c2cfd472994fc37c323afb5be9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847861f1bc36d484a459b194aea8e7e2e02cc477cc747f06caaa4245546b92a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9247bc157ad024b9a5f6b91c4d76a14370d12cdd5ec3a8309898afe40d3bcde8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb936fb4a3c32c4bef7e1079feb6d7016fbd2fe512f7375d5fc3b1b68acd8011(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492fbb9e37190e8b8c24093014367678f5a2d8da69f2486594e48bfd02fbc57b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc5ee1f8ec8e7822ce753db6dcae779dfe1d7f9185e70e9553336eede5a2d8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ebf72e9042efd85df69b65ba028b12fc9e40afe8d479ae30207d6c3a5f4647(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9799788e18f8c71dc28001ef0c30ced90bb3e24dbb2d19b09bf4cf52cf80e472(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc403b6d512623fffab83b3a645d913e6d4e0b7901d063fadd7e4e62b19d705(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13f933154660b682cf75b8ea6c15de2a8f7bf195cc8cc3333e4d68098540ada(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f27410e8c200d1feaa74907330f77cd57b86750f00ebe7f311472ed0ddd56a5c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840ec1b73f2a5a9841b2b173a6c1ed4156f587e70c0cbda5c47cd1c00c235d95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86000a7f80689e1d59745a2770f12b8717b80b7eda833a7a0038b1dfa6f59fc2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlusCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90660415844fc9d29ebdeade9b13e0f5f0fc63580b363c7bf722395e101b239(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd64c14ae3c2ae5e6c504e1efa153babf00d53fe6f86d59f143c14e77a5bc5ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e574ce97038ff234bf190cd2017e9cbb6e028b1d8189b1cfc8c513fe1b5f6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587488f0c4a16fff6f2a7d588c51163ab5ac5180f4cbd15c5b5016da8e120a93(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45177ec244f1eacae151c108c74f2b38024beafd7b41402521bee4e414f99b8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907fb76381ea229bf29fc498b1d96e80af38937b81d42701a2a6a4ce87eb9a21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df1be0f4653faf779546f732f0f2f87ff1e3895d09e0fe659584c5832f50fb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61f5908032fe6348f47da3e1b34e3f3e08c31ef3194c5b920faa518ee744a90b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFirstPartyMarketingPlus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae69b327fb435173f41c37ed121b36406cbe17ce6c0fd420b190e04a740ab07(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc3202a80ba67dea64417e7b8551857fe5aab7eb41e460418b62820ce9f6ab1(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470fdfe184a7c41c5c63b77936225e2f8c3f39e6c73dbc94a792f4145f2a05ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34033f9582f9edf15212bd43d31f0de736228e9a555eb73be8d4f38eca209f46(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__441dce0108849391b618f0dce828e4a704b901a5eac25507c014fbc0bb464570(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7917f0d417cccda108df2eba12c0fcf69e251a7cfa15afd59fe5e89fd8e19f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewriteCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386cf387ab546fe6e5ee70ca6c3c5d6f4d5579236ba72d3af2579d78c87d21d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6baa2a6d418cc36458dfca4b2e2b17c522a407e10148a39b2edaaf60af8debb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76cd8e5602bc70edb20644e953c3fc1906abf96a9fa1bba597cc3b86f139a8d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b082c5fa079d9c2b92f7af2eec8c8f0bfd5c4105158fda4c08ebccc054494dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bc3a52cfa8a5be6f338493cf7b8bff69ee80e6bd9ed076b1fb7ca1443a67d66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca277384b6537980391dedc8701785354bf3725198996d82b37d119fc70d0c2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb54e929d54a6d5e566a562a1fd8e0058fe9d2834d697cc51ff7bea0a18f47f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8238b94361c5c2f8d81e4019afa9f23f7ecb26bad86946a7b03f28337cca6e96(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorForwardRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3b845d9cdbe77a556243ea71dc90fa7178fc4137f9720a4fc763bdc04cf23ef(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe4532d9fe5f855407cf94429cb516aef7c59a94c1dc1366f3ec365c0d8fbc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0764567e3603463647ae9393939421bbf316dc32f7e8e3bcd6ae6549b910337(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a390efb7740b7a59aa45e543abf65f911e4f54d540c44a18db73104ab90275(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79953f3064eade73a3168ce04691ead49cd4732ede0957ea67797ce292560858(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4440a7c6574ebbbeb28da04706b1bc8847ae74f1b91728237d5e8c4d53b5d2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad6efd8b6b72a0341215a9c987abf1d17ac1af0cca8cad6f96a8c5d5c7ce9747(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorFrontEndOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba36ce71b989c7cafa254fa1fc6a5a159563b7534f7bef40db17933fb7a8ec24(
    *,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    data_header: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nonce: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    signed_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70476d55d9de557e710f80e5f02575b689dc447c7f1f5e04f86cfb1db22565f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc7ee2054f491de3a9a927c53f463e3e2a9b0e4b00dfb7e893ce2730d69597d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d70f8d06d48d2b5a1518750614bf76333504a9aec182af3fa7692cc1df42c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cbc570f4759f026571cce5834fd646e59a7bf628e0299491f0dbec26aa3bbc5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12304cb71928df49a50a4178cf1d3b69a5ed54efed5b0bddef94e85b76b07760(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a80937371ea366affb665fbbdcef2228c1a459a3f2c47af4ce3c03330a7fac1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__992ea4e519454c240ef1c57d7873ab6c0df4ff69475261373b08329c6c3a0ac8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad4f6e38d124e552ac2c76258a5cffaa30c87495df45d8d6d55de5014d07e41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e1ed2a9e6f12cc29d5defe9d3bfce55dbc94560a5bd2614b18b2a6d4176fea8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783a89d04017c7b207ca7ffba7544caf1ced18d554d5cc8f37a6edfd52437545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e963127959b6a86ab5846a6b7032d1128fa66ab5648119efa80b56f62ac0ca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0f41e011bef0e602281ed1b301433dc8cae9d8d5dc71e24ece1383fa485318(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cbcc1715ad71391c1cec2c88aa477554e1b8f507a04c29cf0e2045fee5eff1e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorG2Oheader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b6fba6f25c2c87baf9d108cb3004b5976300ef5e235758e0f191d49ef77231(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    output_option: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96cf843671acd5823b66c2b1724d38e31e971c1746557de8c6edc4c5f492a734(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f8442e80bf3bae221d686085bc04b7934bfc2b8e7918f6bd0aa60da2713ca80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef95d5ccd8358a7fcea9c66e748d4e461b0940a02b88a83a9ce272a5682cef97(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7678d13726c3e3f16d0392ad249f5a27efd3e57e61e95ccc027af8d981b7a8ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1fb684b763cbb4178c135a3383ced19016c33f1b78e06210ba97a6b03f04f40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aedc118b9e2f1d3ed5eb32ca2de39e2cf2a5ed8eb47f20370f2b02fb13fdf0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f10fb110cadbb37bd752d7e0832feab4d1e52e2b7a12fd9b40744f84341ba9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1886a6e2921df1a23b5fe7ef4944f4c698b24a184ade00e3f72c1031f06bc4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGlobalRequestNumber],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c299d2ca7277ac0212551214d8d9f4728f3adaec45ebf7e479f116d41078170(
    *,
    advanced: typing.Optional[builtins.str] = None,
    cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
    operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
    post_request_processing_error_handling: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab8199c442c4f03b7a3eec4dbd681e210a8d16a701d50d3be318f25ea62857d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95847f57a321cf8fc2374dbc0e7897ed7fff33c0fa575db994f397e8b512d3c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9656524ad81d9cc90828940d78bd24c0ff2b9cafc3cf95e2d18c17b7cd85bd9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012885861ac77a13b2e1e024d2715cab93db33b5da1f570d0c82c403fe879a7a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9849210525e90340615cb3cc9159caa4ac25725e846f1ad04a31d48fc3da2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0cd768f825e1bfd46a13eb3ba0a0febeaf1ca6551e67e8f5237ee20e4cce077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5741cb4fe5f25e7b821a05d967c213cffed8e6bdd6f31dab010d2c50867c4a02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab710b3c7740742bf67fe9546c4340111f429732b60c42e9b9f45ef5b55731a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5740588497139bf7a1021656ba86c9dfa88fd89263aa750349e6b871287b4dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3d628d7c3b02dd179e008472a097926b8ebf0b5b680270dde8e0c9c0743e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bca85997d862694e4f7c6981e791cc835f3520b08b5c44fa06f0552b9ef9465(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGraphqlCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e847c436217b401d556566d6f542bf7d9340778fe0e0368225536f56ff4b23(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__571c91d6cbe000167e3b4f06a21b46f78037d5db85db1c3b4b855a249f992704(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975e6a176d77f8766445f9cd694c77c4cd99ce9dc35e55096c686596fde2ede4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6c8c40de9f04fb72207a3592d6eb8d1ea0a2f6fe4318cb90902276a3304e20(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01250a7408dcc25cf22cf9aa844ed5c0b034ad4ae465524e21e7f13a2dd3f0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faa2f393103f5596d8bf4539a0527c9f3060f7d0f4ac1824c06062ec38aab762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f2a8a7d35d292c719aa5ed46f9943096654a041a843da31dcf03f5556822dc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorGzipResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74d8c2cc97d8c07f792ad21d025206e977515d67c7d3ebf269c339fdc16bf22(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bd2a0c4e8aa0b56d7b8a6d8aae92e90b179b93e03f46d571171d340eb26273(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caea3cbdbc0d9d4fd4d8fa30cbef1a3a5a348e1cc6e971fc6d1b100385d36172(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67cbad3c5a23a853ab6a906f801d665e63424aac4c6f1b399ab4279cdbe04e40(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216c8c04e0f9fb3d7364605d924bfa06e8e1f7627cd78b6d3bc99077df3fc1af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a1ea473c84b8535297f1a1a23632af9970d2553e2d884d8124dae3c67f791b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57e4f717ddd393635f707cb19dd0b4f7871b688b217f13b964d8c5d813fb2b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215883a091b8959dbdfc412e8808e9cda8517266ad5676b15307e833e037f1f0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHdDataAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9017d649920f0de239f846e88defe2022f0d593713d639d4c44c4d192d724f8e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_reconnects: typing.Optional[jsii.Number] = None,
    retry_count: typing.Optional[jsii.Number] = None,
    retry_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e8826e3adf3a3359f035e6f3446a40464f512023ea8861e5c93a3de48d8fbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2cd5d2fd6f991adb463cc9873f34146489b8c0e60d2189c7a6f54203e5acc01(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8b665f8ec08690aa9f91e17686a7acf2ef2e9c6ccffc991b5b528cc50b21a1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc30e4df3f022008980eb94f07ad287464be50d801a46fe16b0e1ed45f0a54a0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1084f8dadecc524f98ac1ff2f460bc4afdc58fc8718b3f1f93bf3f93dda0d11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c2baa71f7bebfe38970838e38293298dc42718d7ce3fb2b0dec0553041f8f69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b53fcd8819f7a49256c094e79d49f8fcd1fe5cf44f3ca8d071d20dd414c777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d446e113cb50b7521710579ca76ffe75d3d849fe6353d83ca168f7e5cb2a6fe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHealthDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2a23c4186580d40fcf67e890f3179600ba052402a84f7ba0516574c5f57330(
    *,
    custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hash_max_value: typing.Optional[jsii.Number] = None,
    hash_min_value: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d47d1a268c059b36132dfbb417d70b2f5381b45ea341a0d6d4815e12d7ea84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1ce2cb4072c6fa45886872d7a0f0eaae3abced4087e63e8deef921e4885512(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca74a8d2a8e9cd6a3c7ab2f49f9a5f26ec24fc9e5b35a84b6c8d84e5b32b373a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fab6dd1de1f6118cc221152997f4e529ac9d72dc717acc4691d645383ac3050(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea172ee2a41a98d9fdd0d29c13820e6bbb979be04809cd2b47c15313e291e57(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd700bff160e1c7b290aad6a55309ad037896fbd5dbe8602306ae4305b05243(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5fbdd9f27aa5053d459141e42f25cfbc96d53a6aeab1dce9f4b31e7fe6c1889(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e831aaafd709858cf346626bdeb8ec8f8bb36078cce7201ddf809d242000f474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969055a67179881a429e4bb14be4478c5124830aea9867d7525453fc8dabfe8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a829618fda74b007f25df6efb7252576f432ba5dd0604bcda6897d1d58e721e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHsafEipBinding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc3e65307a7e329c26be535f2a650371c283c37bc193265909bb925fb8044653(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__933c3ff009e41cd9c6647842bbc42b354a75eafa4ce4b9a88cae0ce74220c8c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__681d71bcc6e91a86db0ebc825bfdbd557b65b31baaf23c38de648ed930a3a24b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa2341c5a305e0edc22d18d01ee17b77096febcd2e80c456fbd619112e3ecec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464ff6557b50d913f9df4a1cabf7feab0993729308fd3fcfa777761c680c169c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb271fada17c332493e5b6a298ef838c1055c5859a50b9e32cfae23a8f96702(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__427198335b9577777e84e04163501cf6b719c91b58e2cb3fa204095be222387c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp2],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d102b623dedd36de1e94f740c2d65761838bf0a126f6bf1a0e1d06441627af8(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54cb1c1506dec74cc19752c03ae64a7dcbda330a0d55e4d378e2e2f2c87e938b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__635c3c2ccdc09521d8ec49bd26698446e2d1f0e10690faa67bbdebcf9f0de913(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6bc5507c4b82e8c4206711c5dfc8519c4384ab1868eb1394a03e2e67aef1f9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bc69965d8089978ec11042b2277418b6b335a6434065213fad6e8ec60ba547(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d331e55f3084e60897acd24bb852166bf026e4d46fc38c9faad4302fcaf925a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09494caccdc5fe57889f16e250608f01ed739de002876ddb420a639bba041a9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttp3],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d274107f2a2befbad5bcd5a3986a8c0e72d1033c982ed1de83c5da8e7976233(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[builtins.str] = None,
    preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44815e8b4c28191d70149dc1cccdfc8fd9163f91c916f8109d74feb7fc8a004e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e254309a5e850fd09b1b8c1ad0ef26b113780978c4848c501bdf1c7d5ea86e49(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c2fae5c9880d92adef5e17a39e241ecc87ed1097a84dbef23b3b9b11a6397d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed88c86071c1e9733aeb67c5cfd65920978c9b9e19eeb7e032a3d71d2d709d8b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14815d38e73c4c6abfe1395e06e7ce7b73aedd23a915ee7fe703b1a88f6eaedc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69d1ef02b5285b7b559113bc53872eb4ee682680ae6d84a804219ad4ce99ce1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258df6ad7aa75ca3d65f3ec7c046bc6ee1e1b18166d9deb0959a1e3694f71370(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082b9d7d43706482a9f7f3888f75cd6cc5db24ec5284fa81a12d9f1db823c322(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d1d82dc16acb3a6437df1496ab1b4a996760c36e527ee06a76786ded26bd9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10d51bf7b8c422f1b20d762c1e0c24630d0282ba67c7d3ae8b49332b87d3b07a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412dfc71eb98d08887c93888b6cc40f7c3690f73bd7dc9165e8dde46623e8156(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpStrictTransportSecurity],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec76cb285b0d4ebf4ae2db64bb3cc0d980339e24871bd635cff88c435206aea(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upgrade: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8972dd006da76507361d14bf380e7514e96fb7f0322e65310332a5b32b32cae4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b2a24a3c144e4901266bb1206d67abcf8093ee2093b448905976288cca0868(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e0605333d8644e61717102a2462d7fb8d7757604034c4125b74aab3aba0c1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d0c9590346c2dc4786cea80bb318c9386acfdfb1a6de65efa680153b4eec6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d230ae2e04d2f3187c68272af2fb93ace5f30376829d50fe559a1fc1f9eceb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2ce4c7e6df3aefbf6aa7ddc37eaf3315ceef3bc797497a8fbf61494f4b9463(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorHttpToHttpsUpgrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd89813a7d29d7ac964bc6a5a808600e24be896c929a1540fc6443ead24246ff(
    *,
    dpr: typing.Optional[jsii.Number] = None,
    dprvar: typing.Optional[builtins.str] = None,
    exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    format: typing.Optional[builtins.str] = None,
    formatvar: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    policyvar: typing.Optional[builtins.str] = None,
    policyvar_i_mvar: typing.Optional[builtins.str] = None,
    policyvar_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    typesel: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    width: typing.Optional[jsii.Number] = None,
    widthvar: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52bfffcd65130950aa11597e458d1059d3c84b53ce6a69daa3d04650c2dc7f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81596ca12a5df9ff7701b3e20157976fb30faf8291974e361f5477525ee76851(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6aa6618551bec4ea296103f09cf6b9a5c487a404966f16e2d79c3db9b28e72d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da817944ce50a9d45181efd3ae6642ab8245b8ea06b73f3540394d4c980dee4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27255cf52ab4c361d921c49f3b13e8ca3b583370c288f0c5ba72ac5d38f57f3b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473b69de4daf024618343204b390845b6cc967b398bbd4b75781cc44d56c29ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a96c1faa39fb2eba9f704848b1bd8c58cec187ed6d045bbf7ee6619cd1c3e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459514a71f15769a2a74cc331d5b52d283944a640e786316a7e362b333277c65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5653ddc804ab02acdb8240dc85d6bbe691efe1ef9dc9222afeb142b09a3e9a55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65bdbcdbfbe0e115241fb3c313435073ff175684dcf16e8a5bc7941480f263f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f6e69299754dd814fb2af44f4915f6b47dba920037a393ecefe69a2183751d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd9a2acdee63fd53a094daf3c60b5de59896de0066c57e6bc85acfb40ee93d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a48b0ab9be7f48db5cbf9f45a155b601cc23c4f69e5527f327adccdd4c1ec405(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd85587f7b20c13858797781998242de6fe70164feb436ab2ad2f342e80073d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde214750c51f3a9e989dc9b099c961223da2d324cdec61817c8139823a1a57d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7f2029f2cd4c91a1542e1f7d7927493b4c8943c84f4389fa83bad3ddaa05a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96cab7eeb8d1ad06e586c02716af9edb5edbb4deb193ed9a555f83902a17a4ce(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03557c1676cf9051338a6ac0ab40507046327232d31265e04bd4170ba107df02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e330b95002ebccddf2c09f8b708ffb39a97f8f83dd5edd3d2079d5841a17befa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a72e88fb5f1940373966e7f6b00f97f52f8eb679c6092c049ecda664e0964a8(
    *,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    image_set: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set_type: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    video_set: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c8b527691f439dce9ac21022769ebd992befeee0e28a7851ef2982d2ab4db9(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531b0593f5b516425f34b5b2dc01d2cf09d3dd852d8f4b25dd273d079ade2745(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c375bc0a2dc801a7cf82fa74d8c9ac8cae0b12b4e6ca0678382139cf9707f67b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d092a3359a8e9f4a2272e2a18516c95b12ea0ab962cf63ef0cddd91e1f48b5b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5faaea4a75dee34c5c7e6a7fee2a735d7c2c6395456b706fd5e9ddf328c9041b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c52025c9967b65c4ec401b34ada4f5cba32ffff8c5fb6251443651c8da2600c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1c03fd0b377de194513b25efa8896aded51a96bed46977c1de448fd9c74511(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b839f931429ac01bba976f9b1bc7c08f72abd568b35278b5bf3d9aa8d3db67f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8926527de350a37b8eef9a16d1c3ea45ddaed7f899a74a6dbbb22cf53ee148e3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b309d1092a4b806b038022eb81e2548d20ecbb8637d070d0d4af2f9b1c3b1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a1cc7a63f78bad7222087757d26dc6b23418390506df6e47bd3e2ad99e92250(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11b44146eb4ddb8c58b85ec99e053766010d07d995978cb62e43cb77773196f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a032f2dbd292c1732fd2f91bef192e40e8f0054dce3fe8d01d908079ebb82e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745f0ac002046665449c6049bd711cf0667c6f70409a3e6c92464525afe4afab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684a04ab4077f8bcdddd901332be275a462323540114e0d0b211ead9672ccea8(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37ad1bc7faa5ebf8cde542abe3c57e6260c1255465d7a4a61746d523ff9ac7a(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f496b5582b299abf1d68d952e2a291cb90829c17b77850e86f35cf1717277520(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ce4ba3a6293ccd500c9931839a2bcfe22f749da688d1354815730e07de2d5c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45b5c2565ebfeb8d1a008e4ca1197f182b0e2bdeb14bd8ab7969d1a718971de(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588ae0f082c205a30828e1e17fa481f57eacac789704ae2852d98cbf6cabfd0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f91f682c49b91219464d6f20a0a96180ef3cfa687d8007408c8cdb345f9f880c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aafbdd75a2e0633e91f2c6c6c59a137ae424b19f1c6a64274ac30f02b342a01f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ce8109da65dae6076f88bf11e3e8a28772fc904c0976b01669336656b557dc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa604ddf06333f54845ac5c7f8b2dffd1e5703682d98b40476098bb948f3b68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8cbc138554d5fdba94e6b544a29e202fd937f360ccfbc45732aa772ba758b9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e09c61acd30b20b06b93f9502c8b11c4db4501b384a8b72441226f89c9aa492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78dbc88ce1fce5d57984e7a683fea2793c094c2ca739739b8d020abc7e05ced(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36d2e5f4fc0d491ff1854ea6363784293045e15ccdf63b6715ef5256e4b24eb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5169a1413c0fce7bd05d9cd8837c6cb4eff56b3f519773fd4d9253b7caf335(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a72c34a1a66326cec92fcbb169376152c15bb56ac3f68c4779fa4d59d98b34c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eddb352110b3997634d21663b4001366aa70701e082149369a9e08fc992c485(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f84814deee19ec11b2471d0ff365f380c637eb011e2774f7887637aa1b2f748(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de056229d0c76e8a2fb57a35732a3e729c000fb999c1737cd22c93cb837881b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9821a06445eb4ab2c243cb38833b64d510050418b0408d79ea77e2822f68e9a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d54982da16e3ea3adba01d0247def6adeb158019eb0345c2348a1b5e42f3712(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a43d60126cccceb209a6f33a744674638cf11c59bdf98fce3c5f27919729f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd790024a4a72a0ea7acc57513bea004956f17ea01fe272abeb350bade0b9896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c3796f64f733fa82eebd898e4becff94b2e2a4c1cd968e3c52d8c1b93afc71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ae154327eb9a13db2c88e05cda45fd4b28e39d5aa4c2cfc41f39af62eeafe8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageAndVideoManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad962fb7ad76addfd318506c1bf53828633a1117e552c4d0af227d2d439abe77(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9199b5ca6014af92fe8005985c0d71aa369c76b5a4815fdcaaf1348690760feb(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5a61d07617649f64c088c32ab5913392233924cca49410cba20a769d3e113e(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be73304711198b018ec0f4812c965e3ea8d834a71a6c1d516df9da98d0009c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ebedb0c1487fb136c63386e2e8ad7d3a88437b35bad880b6527c2bc7ce941eb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6a68a0cacdbabf2e6121120b96ab6cf9af7a70fbc278e7fbd7bf7c0cbd6f6f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f961db8b2dcc6c8369b001e351aebd3c6722f5f4fb04a8fecb97dd3f10b392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df34d51783997bee0765f2e4d42ace5decd254ba1dff8e95acf3f0aa72f3cf7a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ca03581e3f56216470a2f7d1370a1efc0412c85c3a48340e026ca38f61d65e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06216c0cf7d36f204c37d468fa762618934cda67edd1099a7a22ffe5c218cd77(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c830f652a72f4f96f8ce062d42ac5b4c4177d5451c5162191a8171203fa5f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99f1a3273bb4f86e734d4788a23360c1114b39c8992757a042872a2d2f01ac3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ef58935aa795173045233722c3ed10e68e975579e30601a42beea1e2752bb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384ab8f65ec9167c3dc9990a1eb754a04b4c606674f6e2bdc7066f7de1ccecb7(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d7c9762b15d95f0eb36de798b4aa7ee6d83ed8a6fce23d0b4be83759cbfa87(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d726778ea9f4fa870c6558569a9d753ceb3749a3655bd51c30ebd5e4b5d9f0c6(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2a9b518b63fa3c2f04ed81a18a9e10d4445fb7650b010f9ab60cc274c14f85(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3080b0d5a9d4e6802c539c7743f0d4bbfbe890aeb023ecd06256bc190471d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c1bdd5edf29978657c315256e5179caa2588f90620bfaab0ccdba45b52b3392(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d9163edd32c7d626cac23b412445e4765b354bc6ca0e96a74b97826bc970f6e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75066303f75c6a1ceb7d168e9886a65fc1b1588ab2bb858b3cafb05a46b6f948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02080aa73b762941430dc13e9a9c98a11185f7f7b1338586af17ed53dcb66cb3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be95cb90e5fb82e0605c042bc3b6ce33b571e676ab2afaa74dacc73af830a63(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68915cd1c0a6a113a2c186fa5dcb6a331ac6fff4d3b3c1210b166dfd64be9eca(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba672e67b1a6e4c1b4c243c28e468822edad5bd20766adf0dc6fe96540ab6dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56bf7c44a68ac81e5f32d6b8e592a7bd0b289ac46b4ffed8bc5a698942c33225(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41024d2625ff4118b329ecd3beaf554a8e17454140eb6e60e22fd5fd8657ffd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465702c33f59a6b8a75267a3e7e9cb7562ccf14af0f04b14bcb38e22b6166b86(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba500be2405cfcc867a66099793e2efc3a8c4a7289c87420c1fbe0dd9d49e2cb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f957ce5add30b6549b2dfcaff8b4e67eb3191142ef7881145f0ad4014ca9e09d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__486f3c8bcfe35bca98a6c350fa17c0a97f7512dda42d7c43341f00e309e35192(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c9874da5088767c52bfd21c5a71ab6817f170c7c8dabf0eaa2035585ea7b45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f3faf3bf38cf17c81c43c56301a149506286d2488e25ff8f2519465f83f5a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb7ad45f45ee1866cd1b96b8ce9392d00fd9931e3fa4b384f0c218bdf0f7248(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb5dea7dd4b40373f5ce091e0c7e9b84bddb6f97b0526076d83d1c6c750e0015(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__182148952808b7e5e778f420df5992a2156e1f78f59e6c7506bef3b555437ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23f7bcef6f3f1c6a03953334f70de8968a31bde22c9a9bc1619ca9b1e180b27e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa8e80b7d6f2695c1615868639c3d89cf16a88d768e80a5a1ab1b171cc75d6ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5a1493a0616799c2ebb6a310554bb7df22209dab799288974c31a3ebe6ed94(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d283285c8bab3a814442cf31303f934243ee73f84d003c5bdb993c2fb7065f62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__402d64ad890bc2f36f00b675295657c2174493ba8cb75fca0fedc9796d103dbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ecd9dfab533c8520f16393415aa86d77ed4618e9e16dc6802898f5c41a428f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3097dce73df8b9519266981d55758fc2e1486fa6afdec3559099e775016121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3101bdcf8f5f18ac2daea4dcb1c7d498b9c271952326abee19b637db98ae02a2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85da73db19f1db92d89657ab59556c75f709c75635d433e933684b7d35161d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949587feb03cbcb1d43af67ceca4848c8353fd722e253ed22238fcec83bf2ef7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0740c88e635b2a3ee7cdcad9aa2f0c5e5ce358c8103ced812e66ab21c0b2472f(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229fa7684e6c1eddbcb78a44f2859e45ad4b712650aa4252f1fe20d62cdf6314(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__858411bf7fa1cdd6f89309fcaa5c9a20f2d94d1d1826e4974da42bbdfa48f38b(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f3e2ff83f7799419ee5240211eac5c6a7e6254ee5e0802e7fb7bc34e204a0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd19cb0dc6372f3c24f3bcaabc4f6c292291b103870ba7b11b39a161e02f735(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6280536ef9268380dd49c8f6c8e166cf254fe04bab0e25b631ba98b98348fbf(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25833e89c8eaeb470118f0c0c5d206844033304c28825381728421a37cb333b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a91c6f4fde07d6c0b9e114f4ff1a622c29313576a34979cecdaa9f03f4acee7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710b88b6269506509079583fd5272c667888a04334899710eab68d0fe611e33c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81fbf38602ac56180a1afc5ac59a687809a22d5d6656f1f551083f674dcbd0b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e9e300d041c72907a519d56b67e187276655ae29c44334c931435e93f103aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8c241348a3e455880acbcde985de74702be7d7f6a47b5d6ac8e113be75d996(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ad6f2f411d5eb09693bc27ba2ffc6e36c4052342b1d711316e5be9c12797ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb9fd7b2a6e4541f3989b62e6e8116231d1f882bf2a486ea5633dce23aa4cd5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4462b0abd0fa54b45aed2f799994da89bb16e46f556ef6fcc077dd0e1294f9d0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c677640a80966eeaaef81aab78b56ad619a5fee5c8cd91afccc09eabfd44210(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2fcd2d30078d37ca2cb37a3ba5888004dd33341c18e153fc095276cb2c72032(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05f912e3e1be41b3794d6b91ba7bc48dac6d0405ff600236309daa15c05f1d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8202397879f949fa9113f2e17fe00351504dab844274cd0ea3abd96977cd127f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264c954279379af9348d7ec76064b1308fb8ed4646a9a39a28909d97eda0e055(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38cd55cf59c474b656e9fc5ecbf338251e6da3edd62edfd904bfb629c2ae460(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f74dac2cc49ad3f02b14972aaba89e7b7581db66d86e61ef2d759928791058(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9dd953d1806d26854e8f9292149772e30ac3ed188e2e6406ba447ba63b5aa1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974d3aa0f3cbdc23291823c3053a0144105f893ab50ef4f62eb98d89fdd60d87(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ad3b5445fd84f27e614e83bf239241f7f13b38ce5a7fadc751b8562876250a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ffc986ee0e08508d927e1a339677b0ff9075bc8ea21532f96637114ce11dbc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f8b2510d104f6eb028753d750d7a1c9636ba0edffaf16b3ac4b354dbb3d4358(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6cecb333a4836f5041063980d4ec4b1b2f862b0a46e7734dabe009cbd882fc(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4bb8542e57e606c977e5112e5abd675fed4bbd1bbf6b38041e08cc9ab01efb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideoCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b67ce1b73443eade1c4185250c341513e8425cfad67cd51b3ae9d610d8ecfc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8682427f3babd98afe584ef8e28daeb044bd7ef72565738c5268fdea51e12e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a023c385822aa106dfc6dd7018d196a2505f917e75463fda8f39fdc1ce695717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e110fd913feaadc02de86d5cc2297a088c2dddebf72e6df6d8b61173c80c8c72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39edebaf2ed43520438b6e9586a3678a4c23c7c11f5922b709eb5e4613cd8818(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07628eb5290d24453074a4950467c0a2f769536112db767f7fbad59ea580928b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c994553b419f463dd03770c2f8cfcef7e984de8118d50a5c8c2d1f2a5c6e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170f86614ff55ddf0fb4edcc164bf56e1e77a673cae3aab5e25def027c2a3f80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d26a938f41aef8c989fd8ebd511b35d588325959ae6b5c2a988ea6560b3f815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31fd8355e90c9a0a1d083deef99fd5fd02bd3dc2f5c21c2890bba1a2105e554e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57808553527b7481116825e0e164f28a97270aef48f8b2486de47f608ad863dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a3602c2424e0bd26a3ce9359ca634f5943e7aafcffd8a1c8dd76e7109ba7b45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7799cf09d5f50468ab0cbd80711c04098271afbcfa224c8d592b5eb68bd2c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__027e3eabcee2bd236b49ee53e31b8b677a2678c18bb5ff485264f51666a4d549(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f2804d29c2c10deccad59c77ea907bb90582487d6935978711e72cac1f8f23a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf9fcfe155ce559711e01420a4dab485552c6e5559ae3cd7285a30e642f3506(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034e6c049d1fc1580c218e9ccb46370df4b887c17a76894196b04d7e428ab39f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorImageManagerVideo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961e2aeba79c11df100cc9e5c4adb51ef3efff633a47cfc1138e613ea5733479(
    *,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fabd2bc07a9bd363218f0f56fc12d03c063d6727829b3ae33778dc5a3c5fc67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3875b77fc572f0e3e895e237689eb88c6d9eca528266f67854bc73e1cb9a496b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5302b5b8f4e7b5e9190f0023e764fa780098a18b62e7b9e4b86c852e868ee2eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3a17aa8bbbb2b0969a83ec501c7e2f28dd3877732c124c15b259a98148b03b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ab6b02a3e35dfc0ff09beceaca727229ce457036d3c26c01404daee3173340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3169bceb5062714bb51185898fb7af32099092b7b0e7b5d45c7f69ae67a75380(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInclude],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eb728d6e120798b8090ed97efb7385a8f1eb7503a97415c59d082d3cabcb253(
    *,
    allow_large_post_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failure302_uri: typing.Optional[builtins.str] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    penalty302_uri: typing.Optional[builtins.str] = None,
    penalty403_net_storage_path: typing.Optional[builtins.str] = None,
    penalty_action: typing.Optional[builtins.str] = None,
    penalty_branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
    penalty_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    penalty_threshold: typing.Optional[jsii.Number] = None,
    penalty_title: typing.Optional[builtins.str] = None,
    reset_on_valid: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_key_cookie: typing.Optional[builtins.str] = None,
    user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    validate_on_origin_header_name: typing.Optional[builtins.str] = None,
    validate_on_origin_header_value: typing.Optional[builtins.str] = None,
    validate_on_origin_response_code: typing.Optional[jsii.Number] = None,
    validate_on_origin_with: typing.Optional[builtins.str] = None,
    validation_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b35721e2e3fb9dbb4be1c39da28597291c61ce1e0002dbd4776f4d217422a694(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8a2c65f4aba9b0f6b8011e820a311fc2298c5b2dce354c6b81ca9191bbb927(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ec7d09de7a2fe25d2621b04963237c740b2593469a2224e60c4136f3f965528(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7a31f63a39b3b62fb7f4096ad27d2ce3efa39365415078ce528355f8a62b27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f935644469021ba95b0e587a909fca7f4ef2f0abb5ff4161ba89986481926f2b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e2ad7e05ead9095e4a0a986c427c98f29ab3d3217e86305cb42e9b85229a07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dbbf4eb8d642a2c0434450a013697bbf13fb96b64e6d1407014bff1036cc16b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd17f23a41cf7cc6de370175165ea98104280b2630ad106b2cced82b2117ee53(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d35ae409623ae84e9c4e8ef35e847af7fe9e8a9518d69185b0b683cc795f952(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46bbc939b44bba2d2311bcb8bb0ce49d9ad829ba3c056a6519e3a8304dd6092e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5c609863b26cbc703115a5bb86441d1e3885d12d17d8f433152c963bcf67b7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ced3c25830a6205ba035670836877fd70f51e48fa5042af3f3e3c2c0e6f00e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dc9ccc3266c9f08fd5a0997e77eb07275c91c4229a717de6af8f8c24c8f0e0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287f4aa6bcae122782774fff1972e7161a43890ac8efa1adf593b6cb3732c8f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2f5e8f2ca7a162c9672ddaf11831f116af14243b35f30294d78d45ac5ad757(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba704dd14e349c85db7b48795db4f9aafd76e97e537ea29096c8ee05bea0a3e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e67aa398d8c2d4d68944c5f15455e98afc8f7f5f6e3f0f418eda7d7f2a64bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4422b3132cde08f5d3fdbc8d1153700f36fe0761e111ee9fa71116a286d68bd9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9051c3dd0c56b5991168b7e9b9ff287aed61e1076b23a83247be5377d1bf2512(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098023f5c957b24901b434e206f3d1a2156765e7b666ffb60e66f5cfe6632121(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6f40b97fbd8b6f31d5e880cecfd1b8a9d8facb613447b6e0e1d7ec296db1f81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbdaac07ee77c37ec0d3c48252d474c83e8255284cea4e44957b492d75ca329(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e48255ff61c676cfe83eca2d581c6600f8fc94dfdc01dcd2ca5f2df1f4c778(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5910bf14cd5a57968afe12d0140a469a0665364c636f38775b45fb652dfbd13b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f80ad959c9d752fccd0fdd725c46737f630ba586d50cd9bfab050f089e177f86(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d004f2230c5464c9f32958abebaedff3bf7e725f851e78aed2f624c2870d01d1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe2d5fa782856af5a4202ee39973aa2bfbb8903bd8e6bac1f6223d7b2ddab99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6237458acec2ef169e7f1dcb9b9630079c5c03039050bab5165ed00c4bc992a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076af5be94daa3aed0b5ac8543d0c8e1e92a49691632db7e4cfe88dcdbe82cfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75bcc372eaed8d58064761ac0a9316975c476ef8375ec5d883fb782a3d105fd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2367f6e349a656799858696547e8cc2fc06cab0acd83c21a427b9afb1c88aa4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9ccc36efb5b0f6bb6c78431f12dd37912466ba8ca382f4e82319b067a75a76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53885b41fd95fc8936603ae4c75666059cd099331d927b6e46740730ea3471e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__203992919fcb94dbac391ce3d8e70ce8c5ab33ef354a5a8dae80133b470581fc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb47067065f176851b8927c202b94ae674348dbc311613770fb4394d9df4654(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59260b9f5d809b5792ab8270e9718001656037d7f0818dd71671dc33e3bc1a54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dadb0636437beb528daf4ea18614b7f23cd646347cf6ce1e5d1658df9db1160c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa66aa3332bc39886869fbfbda59530496c8f8581052cbf0ca2f2f1d4bd27575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4661baccb952ef23466393c5e858fe46815b89de3d3e4b2e14d09187ba16de75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b4cf77637484d7466f3e2731c1c2d763cd417f79fbc829f8e82d455653e297(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInputValidationPenaltyNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082bd36c745e3707d2b8edb1e45f6c3bd3b56115264c58e68c3894080b691381(
    *,
    custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6cd0e4979b0fec83ad0e438bdbff79d39aee567bd61c1997196c384e87b1e0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71839fa9d45326811bd93d7e94ad920135f296fe126cfcff1c707a7ced56e0b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d1b3cfa4229a59d063a41bde8d9361725b465d826bfc0a98b50c439908c71f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ea219551cd8bbb9900d38492701af4d07c50faae00535a8d3daa0e8df932a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a65094a708c1ddf8c7107433533e8404ff9f69a112ce2b91b102f8b588d4f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5160ec71b4fc974cd9af7431c4f9417d38bd259e1a23b7b0d23cb1f1310d4449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a457d4af66807bdddd39758303fccb9e54a73de0b91373838554ede8081e928c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstantConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ff850cbc861d191f9bbde1f06026270cd9faae01e5da18d79c089b5770cacf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f6cf6a96c0e8cd38a48ced35181444e7539077e4618ae80f97585ac9db9621(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f2d26aa3d01f2d40ad577baae1dd065985c6d4cbc3cdf0f242de78ce348b28(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0acd97a9476e5b9775b7204460a37e9839e3924e528e3c8a2e83b1ee937ff6ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bebb7d5a5ae6b9d0bf417d38482a62c066abdb7f43b3aad42d680d119ecbb54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1c2b2aff7ae21ba71d333121950a3030c30adcef511f1bfc62313325254a207(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7207c7bc3ee70833b83c859cc030fb9daa78bfa80ccbcf0fae2928e162daefdb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c6fa04b01d2dae523d9858228fdafe1a57afc1108120defb8edb9c0b985094(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87210da1a0ace2a3ffb36fd844ec81519a804b3fc4e2bf8000d0f005a891c198(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__307a79c531d0b66dbd11c3833fe3d751447cf27c9cef15dc3a6081ebc14c10d1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorInstant],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd2edae12c305734b9da0d8d55fe49756c3aaf6892f3d4868f1331a1796c7f1(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_partial_object_caching: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    minimum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2080905349f26ad4ebd98d98498a0c69f658ec29899c8d4b333eda8751166a6(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    fragment_size: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    prefetch_after_request: typing.Optional[jsii.Number] = None,
    prefetch_during_request: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d127387c2cee3c476ce67fcccdaf104858bae9755c01d590a5a4f519a2f7ccc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfbed70488e50316458b2444d7ffa265bde77834f2d2cacb91e995b5e9d36347(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e60ecab5da5e302f47fc5f3ae661e035e7a2fa78639760b6cee179770ec9a71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a118709debeb84ef0404b3e045021893401246d89d7ea076e1e2f983ac3c70(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e38eb9bd732321b19404b92a1095eae312ec42cefc309ca16d5f7fb72d1b365(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb5030d84a431a4a2fb06c2be95d69b5d067eff835f6d57b6b03d576c15ba67(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1e83de715777cf2245279e2c5016877b07f9d3d1551195285c324a9e6f4548(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23976e11d65212cb1d6ba94f8f4935d65434c3d5ec2b3ab903d13f97a4346167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10eeb1ecb57c790e47e2b65146c96acc1c8b8802f0851b3f808905a12f85ff0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d041231c1436af577fa002be9386ce322b0cd4e5047b83b59aa63986e8d625(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimizationAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8892cfa374b2d8de5f85922ed9fc86b85fa6d653ea2585eefdbbd41038af4c73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42490bfeb8cc7e989736c9c746e99385cf226732770b91a8751659e55c8b68f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d04efe0747c7cba97160f33f2f4ce661d5fe5a05be542c2fbe9f2e8d1618ebdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a36dfb89418e2e6e4ef99dc0dfbc78fc88bc3163e686c8c7b20b6387858530c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73add711342316f7131722736b3cac8ebbe239b22236b940b97857ede7c47306(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0b758d6e14bedf930c33fd24bbdc95390ae02332ffa7d4665ad38c58da9214(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436a8a55b10f1aa361339452552cbde07e7994f0d38c5a6a33a28473bad67694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695a51e50c9f368321919bc4e2626038e8c969960db9ed7166d155d6a4d0a2b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83d797b7990f877b64a05c26d767b60003a536d80302d74527e3743bed72086(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ceaad778e04a051a119ea35ee35fba57f52e230a40426272e410adbea49075(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLargeFileOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99d8351a318a87c4e6a41e6a2610d37e8457f6539120f6aecb8af64226b79da(
    *,
    bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600fe9e168d25ed014c66fa5abff158bae759d1e2dfa588823a41b38e88931a3(
    *,
    bitrate_unit: typing.Optional[builtins.str] = None,
    bitrate_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eeace3094ebdc596581c82890ea12c19bd6efefd56abc5e32cbde5ef8af714d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b43ff59a8fa0344672d2fb2b3488ae9abaa0d11248e6a73f52cb7437c1c5505(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c0a8e133cdd15372db4be0c86759defde6eb9c13503cc8a2613eea4836b089(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c83f619b404ff63da205e6d34d1fd4cf0b65b75f06cfbbb40f3aa83d94a50ae(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7378cb5ea4e7d5807a879659e1a5118f2c4f82aef335442f79e2c2778bb84c58(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af814249ac8e28c97b8d2e165b5636b4da36002a06035c9d3f54de2dc0af3e81(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17c47c2d6028ea9b9e1d36ddc6c04e56b07859cceb7664adf329ff20733a2035(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8d2371b30768e60978d322c5ca37fdb357f5ab116e2001aecf3ac94f2133d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8738531bd27a3d1aa2422719dd8c424c09b06bc3aeb7dd920d930b79257c1f5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a4ae207c66e35f8d0ddd0c6d5b74da367b1136267ee449f84219ba4d789eb46(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b908503f1fb0f5aa3ef77eb66da84cd97f4124936fe7bb3cec3d4288ec5584a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b05b6d1f049244a9ca5ec472cfdb4af6a42fe45763674d5173181e10d5cdf212(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b086987d3fc918d33bfd7bf3da07baea1427f2af75c94073b8f2edcf7248c9a1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddec9a194c25a74e9a2b299f1eb48d0ca7fb9fe63676b9e88752f01f7c65a87b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b02e6a9f9a541d206c0fbc55511f596f9e1b17c5b06e4462d06af9714ec91e3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea217c31aded82b4df3a3126fb92660ab41131e5da494984d9f597110083ca41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b922b3e54f2095ea543becb0d568797edff889de2b551b4662c6ef887b3adf50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f325545342f80d911991c527c2d305c8b6be70507bd31560cd4dde3e6ab9c3a2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef39f3869069f6316e43fc4201c8f8a38f6d60e7a9445e87816513f46d84669(
    *,
    threshold_unit: typing.Optional[builtins.str] = None,
    threshold_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66ff4fd80de3dd3dd06f0b9b1487daf230841c80d015b7357645d61f02a5720(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb5e5ccd33594e1ec03306d3970be41b7accca884cf63c83d1f801b58cc3292(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070051471aefe11bdf13ca4c0e04af6ccdd1b7b11547a259cd25a0bde211404f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09eac6f6eebe15cfdeb165dbe4a5c22b39cd86b9871df3a2f788986ccaf1e448(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8ccb3eae92a5d18363b7ab511e75465f2b64ebce9b39af7fbb3d015976209a(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51f8ad9700d66a00c910db6e216f1aec8359588607ed761af40d71ada2ea859(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc0435ecd19580d83af920ebb0bfb35776f492c1c251453ae9e9fe266f4a79a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bbcd63a130dbf297faaa91a053938c9a1e28a157151fc3cab41b41099b39bb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3249a81c92bb1cbc288dddebde2f3f0f7b8aacd343ef2412f9132937204cc9f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9038ecc4fcb3937edb4eaee7b608686f289bf349defcd5339a7a0f8ea4527cce(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLimitBitRateThresholdTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f220b8b35dd67b845fb01ab2867017719c2c4e1798a68c044113c0c6d818406a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d50c04a27009827ee203a4f8d466c4df3d8ce2ddd10c12a559b26c126eb16ae(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__031525cd86a943f7e6e7b8611dcc3327497f09429ada77346e372751f9d6fd8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3abf3e425d2500a44bece91978d98ea8b22d40f2d9c682ec0cf1fea275707ed1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c65a06238aa7eac30a1f374ac91ac77342a6ad32fe16c5baf69881271aa909f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e225d1e3ed418f08c9eadc86affd7fab2b7b5745db9cdb110cb5de3cd1438121(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad544ff81fa9a1a64c1d8a1c8a34e9973ee149af3e2616194cefdbf618a31cc(
    *,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a166f60f6a23742a93da6a678cc7442e95f37cd5d19a15ba901ebd91b5bac627(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f23fae21155a03e7dec14f5b8fe05f14ea593aa1473097d0bd37c181bd7f0da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fd2a2ab4388696f1eb0339e499efb7c7a95012525c88c03e913c2fc47e054f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6bd498f976f86487cbad2ed21b55dd1d48f9e74c78751b77d4b50fa61e51a39(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6368c1cee885c64fcb5f37e28422ccb00215110c0ebaa7e356055e3658366ec9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd860e2a0dc967967def95dab73ff8cf98ec213697a7411ee649461b3530b97d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f756eb2ab05ac6330049bcdfac3414e616068edfca144eb7a78ea4b9504658ca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorLogCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28fded08ea63ba1bcbdea92e08ce261d0bdc52ab2296f4679388db0c1c37fd31(
    *,
    api_key: typing.Optional[builtins.str] = None,
    buffer_size: typing.Optional[builtins.str] = None,
    config_override: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    loader_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_optional: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b787c4850424137913aacefba79fb57c0a9b86e7cdcbc97c42d88cc0d4c1300f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50588f1b98cd846ca437c0382958f4e5df91a0b9fd862ea1c2bcbc447e3211ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b634993316dd8fbd113e64b11a015fe1ed98d400510bb6445732073cf08ea57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2a095c90b10c17016e12640bf27960b2f4b6260ffab6e8f920e4ff151ccb49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d7a602a72f0022e3f40f022286904e3bb3bf6d16aa19be8d4de6c8b9547fd7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a939a8a7af35b76db4ce67643cca8e702b411259fd3bb6cd775147da18f870c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab6b3beec4863ae50be145fc31ac2e1b161213f2abaeadb304301182df059b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51cd2640dcd8b7712d2e9ab327be89f073a0f511d3c728545a1abf86a31963b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67f09814a13b1f06fdeac3d588489e9f278e1e050fff060bce558edc431f1310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d364c48680ae64863443f5688dc571dbf8a58552b9838921b62debd1c9af74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801f471dbc10e6b6ca087f17bad75b1678a8b030d2a3ffc140e02debf73668e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d578ca746cb915d48c4b647c54f4e4793235a27db15cb2c2e5ae8b2ea587f6dd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMPulse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cca6922809b9253eddc0ad1e15787b968a976e184941ce4a909d31e3be15319(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
    hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
    hls_mode: typing.Optional[builtins.str] = None,
    hls_preferred_bitrate: typing.Optional[builtins.str] = None,
    hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_query_param_secret_key: typing.Optional[builtins.str] = None,
    hls_query_param_transition_key: typing.Optional[builtins.str] = None,
    hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__106a59b83f75ced15e95108bca78fe086a98ae1877acac4ddab4aea72d4146cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7caaefb80690d2fc20c752f5b1134c969209bdd694aafa0c1da92d7ac26af33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1229a15466adf7e56e100a2e25115570b951ddc9c79574ccca2024e7c98fc5ef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa8a036e7c054c52d65be88e8d43709bccea8f30ff3482ea963d6db7e16d8a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2240f96a07a73c5d7361bce3c2a0cb3010d4c5f5e8094937fcdd41d879b2a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__104cb6778009af0100a8d95da025f7b7c123982769ab7b98941df7d84ae3271c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c40dab4c361d362940fafceebc912848c2717e551fb1e92d099987a9083f501(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4534b2f4a104d8640839185f0001b57e3630d7a13337c9eeb3f33d048c23012(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a72f203dd698a697c6fff67f5ec58f23a313dbf73b1aa8ec191cb527ec51b782(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fbd5747d32cfd3f739aeea5a361ca7b660ac0117c0cc04001b3b8838f47db24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208f15064ed3fa4eda7e28e1135fab506345debbb1855ef0ba722d955446f169(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0348acd105ffce06174d8a23011c7e3d1497821016c008e2054da14f979792(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc8197695d4fe87428a6d30044ad7a84c3f3c0092f76b9ff7f87923dab72bd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226ad1c17c931cfe47b442c9111db0792190dc9869f3de9980b5ae9bb3123b59(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__990b49f26dcbf5111197243456923600862d7b4f92ae182972d6b90d8d4be7d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f84ff1efa2aabe504f71aee09db8aa266e332c9bcbcb6619cb928c986607162(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb7ea1cdc9f1dfdfa65df904ed8b6cbff5d03616e4f5c8295b493e556da0608(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestPersonalization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__781a88c33824aa0f53809927495f4d6579683a8f94dcb0bf7b9c513b2b9d337e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    username: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8286ef5c55bbe06efb88260ae2c2283cea6fcd57fe02688b0775a8bd9a16042(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75994945e1ff914c8193f564c3651e01e94e64b1c0496a1b7515a1ab9d54792(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f16f3a96db266057b8f4737c2ce34b1de53da4cc81b727cbb21d654af497fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b22e845771f9fae0b7018b41087896e8a9b736cc7155b17166de8a67003ee99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e2977f4d8ef022ae7fa56c04ef453ef932f704cad0c1cb125bcfe66de3d4ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f458ab4aba360f0af8af4fdd072477b1b9cab7c8329cd92ab6b53bb5e53ab05e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d7307018631dfd1c3f6a90b3437213473ef5a3d7eb8248320e04d2e4a13cb8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManifestRerouting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ad96e64e9ee36cd59631a8962b8402e377f19b00622a5ef286041de9f6ed99(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2068465ecd485a44d35151aac97be4bf4ee36386e206a841c7992140d7b43614(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834e7403e60e0c9f2a82807b6f94aeae45cea5201319a31661df8c153f08f1f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e29284bbe33c643103b69f1dcb32d31798d6a2c451f57c0b4a7cf48561b26a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785df7412c4d0e62f8147c07039639dfe7d4283d655d20b96b081746a2a0359a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d37bdd42f99abffd08c312f61f6de0f3ae0d0acbadfd3f05ecfb3b416e4098(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5217b7b6c24e48628a2d12d050ddee566171768cbe354549259cf686e6ebd83(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorManualServerPush],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bab96763427f45afa35ca483617aebb8759a3811a9c093b94043111b326f17a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbd8537291ad66d806f1027db59de7e734ce46e82e51822575ec368d78fbd8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb5b95b3a32017d679cdede97ac9302793c5abe11a5802d381af2f0f09a4778(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7123272e2e924cb9a6dc37b70b2c673803cc2814926baf3d7766c96d053a78c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e259b704074788a61b87abb6f6bff1a073849597e15e1e1325d61779b69f4ffc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e62d66fbf7d4d94414067243de10f149c7722eae7661825caeef9cec134d0733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6daf243b9fa65239767d34a82504ee3ddeac4eac8b982229893450a9cc5801df(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd65519b3b8a1acb80315496a27bd12a91e4cd10580f13b5850eb7738809880(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optout: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a8fd7971b14947f2cf956077f235d4c50e62ac0a5612404123099bd966fcb54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b43b7368b30f4e3675e41f30f5b9e8613d34e25cbfc587bbe71a4269d676d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fac84fc8ac3a48aa1560a44e3fdcc71a9121e0f685a0a7834eb8decea5e5179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__371485525b64347697b0136db94800750d516b5d63b985ef48239ba3025ced3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49baf15ee629b9901efea15b7c73d9b9634ec8ba4b186096a09e052a150b9c6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d505bc9a2b9bb11c1f7fb8eb491a06b9017eef3d1fe64fe1ae71f5e2978a87(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaAccelerationQuicOptout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0486d8ef3b23249d79d3f898f73a8dcddbc6a9f53816b1b7be9f7d4bc68977e(
    *,
    beacon_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8cd3780db8896dae69c18017f9f32f8f15c5af85e839472f87611c7df901a9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64c2047635d6eaa97c4b72a3fedb92283c4a26843a2f694ce3858b89bfcb126(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297369dece63591b7101675f7e999a2474996378e1c0a82788a80f68f1a69090(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a299bacd9decb8b0cb33b475bc313ee722b57bf31130a7c10364a577926d35(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bf2c8c4af04e413124f55f98d8660099b870a4a897540571641cb9a5b18123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e3cc7418b672e106392cf65ee6de9ca7eb6769567b28196c40ee7d4ec8584a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254fc6bef0d5cf0c030266f783b7c745484b625d88b3c622f18d3981cb279d1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189d61b69ea758269d488a731215d6af63fb626948881c1581ae5007100da906(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0959f21751bcef57225e487585bcae56cde32ec7bfd66fb252d99de091028a2(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2c63e8743e740a2d7000ff83f9fc280039d903a87e62013cd304642f491f44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__896b5a9d70e853a76697c52879f64cd68d41cfee12704c8c5e7ffcd3edce2534(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea487f228ef07394ec57075122bb8707aa3c89e9009b566e2da0570b3ce15ec4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea58d80279e7563d01e6d2d57535cbef34be0af0d1fe528bd332c7e15ab52e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b6115743c9bd9bfa3fb8aa725280750ae3659dbf472f26b4f73855ba18e14b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4cbbef818c91b432e4468c0415dcb157a05881af8735526a9af15def2444dbb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaFileRetrievalOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27dbe2d5d79d7e72bdba9b8ab97f38a23ab42b239ced48b04c875104da1e50ee(
    *,
    cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_window: typing.Optional[builtins.str] = None,
    client_response_code: typing.Optional[builtins.str] = None,
    detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_object_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    object_unavailable_backup_host: typing.Optional[builtins.str] = None,
    object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_detection_level: typing.Optional[builtins.str] = None,
    object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_modified_path: typing.Optional[builtins.str] = None,
    object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_protocol: typing.Optional[builtins.str] = None,
    object_unavailable_recovery: typing.Optional[builtins.str] = None,
    object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
    origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
    origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
    origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_protocol: typing.Optional[builtins.str] = None,
    origin_unavailable_recovery: typing.Optional[builtins.str] = None,
    origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
    origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
    origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
    origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
    origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
    other_options: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe0218da7f7bffa183bbbd3846e689b4634506b52d4e26c648f8ba8647cc017(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9aafbeadc7b02a618741db76028a8630f48b0f413a54ddcfb84998326be460f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbb42601e3bdf15390e098e1adfc53279ed6af10b7b2fcba4e17930789e1ed09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2517cc7041a4c9616e01f67cde08310a12561817f77d58a3836273d7ac8bad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa1a71e6da00dae4f114d54a490ef0ba6d4bf4c9f3b6a73ab37afd8da7336bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9f59d3b9f2434e33802cd630a0e9727cf39cf5f346fb71ed234b7e05800e1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8550bc8885ffed78fad34e35af7019f101160ad73379738f6cec8dee32de1e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0d97f10f68ed4c6681f3ce629cd282fac178e47c92fdc3dd205924c240090b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30739d1cf3ba39e6b4974d23a89fde171ca9113f4e20361394ea3b8c58e08a9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a3eb53801474776a1504a450ab994c55042fdd02e736edef7e9adaeaa41bc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a43d775fa71e49ea9b8547a49664c52e3d690beeea6713fe814ef5042da4af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a7670affa3f8bf7222fe95630a67050d4221b898b7deee53d4bcbdd44e2f81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a541a47dd1faddfb81ce825a8a77cfa2e3b0323eb2f3fcb46838b5b328798c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35c4fd342a81431c7231823cdbb6393a48728a762e244738a19cf1263129b411(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea14f37d0e04ff5b6abcaf6bab795f39ec2a880c81c29991101354076373426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2749b977f2b62d17d2c94e9d5d026bac8206a5d8ec809b4ab40c2c0836f63f1f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9737a8753a808c7ff61c7fbe3a01b5ca855c8fb8da2b8da042b470bc51b28e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5effb2eeba77bc93f32590deb741d3086a42b39e6896a76fd9590cb38228d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0e1fab64061703c9fd93ed7870d79ed5449bf943900d1ae11c1d0036761465b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397c7329dd885ad9ecb9801600117823048d704a97b98c12ae70805d2c1059b7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dca7dc12eae08533a5d53eb599ecd6e44ae855dfbbd006b864c07a7aebdb055(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a480062561f365589e2d99ab46003656925a495e8bdf4df149d513fe35f89b40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6e08d4187163db0f1429c84cf4633a3dbfcf4df01e10efb460f0a0f1f82adc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f44e5a41ede2109e3f157dfd0dd1d6e13f9a1e0b0b51f5f1dfbb5184a6c0ff6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__966aa57a0eb61da0cb25b046b69e81e062f71003f48b41e02722102125fba07e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__954a17e7847c55cf9b6fc831e3f37b510b089ebca8159bebad6b47629b184ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b6d10fbf60f4b434bb30180830befebec8e1dcf25943a41b7aec6119926b918(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d97285de1f72f8580569f46fbb88457f4f0c0a1662e1fdeebe282408d36163f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8904cedd7d5f7b7fd9f99b1a0fb8331d9443ab23351b51cff5aa3de2bfcb4433(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea50cb7d0fe8ef14f55cd9b7b6c38c17cf6067b1591541ac01c99d6a9dea477(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab807d0f019d5baf11260d74c74c10abc40df3b51c4e436034016cd79b9ba54a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa6e5fe13dff3a9c6b51f9ea974f936689559e19131f991094648d41fe26e2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb35cc809c183ff27a5aa167ca7afae6d83bb81d20a6ce87ba068f1a41789d31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__242c64eea4708ec1bc583c721b46a72e586e1af8fb4425ca3e27b9659755a1ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c82aff9b7bbf8373a6d24b98f1179629dc11963047580f8039ee2c0552b06a69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15798fd9a4502def56e5e1e2f08b5eb04aefc6c402ff6fa3bfab3554de435a95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a113ba77915fca5b2884a5618e323ede665d3c0e62ced47c87b7bdf54c8e07e3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1172f21a4afb351988fdbb5dd3758ac74089d6c5028fda633306b781623d669(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cbadba114b4bf1415efd37c9c98e6e780598a561c8fde9b5d99308fbb8241d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__235f003216a37c0c06c79cc0a2c9640408bbf7a7ee64f0193295aa022baf549a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f39f7c00bdf5c97bcbe318a4f67caa70e00de1d23c8097d88e24466a34f757f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e21f81658080f920084398c56e7b3014df0b5f68da472e31d28c7833c304e7e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc28658f7ee25777bc373d3ce10d58be4a6acc417937bb712f2244b660ccaaf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b513f14a104ba4f84fc928d8be7133e2dde94c224a5b697faf5500109d9164b1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8196f6be8e6fe20e4da4533001473befc7940ca4428ffc82bd4891f35871258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6ecd728d85ba87016436488acd6263ed87bb2923792f49eaf7c940090a3eef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686fe4d603a613dea1616d6d4d8912a8f64c298d24969c2150b08d5dbfc7fdd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a97342cc018412117b9116713af1cac1e78d90b2bb0708f0a02a1590eb877a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a911a7b8679d22ba7eee923cf5426fb4dcb4930e1b72544b7852598bb3615f42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7fad801ae99cee5bb113da2787791228831fe405b5aa2ecc5ae107db4aa671(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1be8dde4dc0d1b0fe0ec591e19a08a2751f59fc626d5b2854f5e290c772dcc65(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03cdbe5e43248ce9a78cf94e77393a16d40a7cd8446a348068a1ecd4b9a2e815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cced09201f33a49feb725fbcaf5bfe1574d0fb6dce17fda6f9ba4bfcbb26c4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb85ccf233658b99ab5de3332660cd3d5d6defdf95cc468e3a5ba1993076ae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d51db9a48589ceb5b88e981dde9381c3f14d8a28ad65b10a2b1e3bfb5df4a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463bdabd87508189d2cde0141305fb39ddbffb46800ba79e62c78bfd94e41a66(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMediaOriginFailover],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b07db59147651c66ed55326efcb4177ee9ccb0b6be55999ceb7004892664d435(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d97a51f33c2ee3e4a06316b39b044b7834a5c8062ee47daa1b5a6f958d91754(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fa6e41dde02ada213afb6839c62413ba02960d58dcac1db15c5a01a8d96b0d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88274ea52109059b2cb2fe3aaaf558dca3a315030d4ac38eb80fbbb3e924df2b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed2fe50f9b5a85ee200bfe1a24db48ff5ec2374ed199872025c3b837ec22cfc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6618ae6118dec2b64dd057d6b51011582428a702e26f473138eb36eff12356f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355a2eb9395d9f7ecbfd13aa5b69d15eb2031c24742d20d1c036f1a580f0c163(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMetadataCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92dc8379a946c599061a8fa359935130be6510a874f832b3152c1eb2e5c8b2b4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174f0dd63e81f566ce89803816979f27214dd3bcbe10f3e610ab5761606f05de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c20560aed2b4c0b2a74cd3e073b46aff51e0bdb842e2d58b7144eefcf23fed53(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4319da64a26990d7720a28b9293b4b4678c88335247815dbe68b3507644836ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95fee70bfd4219210b2a3d57e5732a643658d845fca25a8f4634d5a959bb62c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56fae786976ae52078aeb3f3ac2539394081333ebf1be63b7963ef7186f94dfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7446f2284dd869258d3d228b58a8e46ff782a24cdb536b2ed62cbfee6f9e1dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c52ea35b7b0831e342b6695e221c84fcf0dbc7c2a924669a2d49a7241929d539(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorMobileSdkPerformance],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6fd5d841629f339751ad5f96a2ed757d91efd4a7505b0ca45813bef7ce6303(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47fcb46927e7f363989cf5c2bb67f6b65b545a23ddd19febb32c4b1ffc1506fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5cd4f2253917746ce72601c31208de6fbc7ecbfff1f559ee57062ea3eb3f9c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9d58c86a5c5a574478c0480b121555b4c5c221cb07e837ccc0ad6c4a97abe5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c38b76be47c8cd0a68b1e151225538223aa0fe4b553d278e673fcd0ffdefe8e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e98cb21650715b01c40c4361fc98a061e4211315c4764f2458eb01ea0bb801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f68a901ff1c74d64b843edab15e957f475335d104dbc4cd8f26c68c407d530(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d93a6b7a8ca544aa7143cb846f45cc09e9bcd9c3a74efe489fb759b67cf45a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5922d4a2980f5e329171ad177034d32980b80653b5b600e633b65f3589b00167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eca3a008fd3697cfce269b273950816d17e81d238e22319e48046aa4ff5ad8f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae84a20ee60f05a947a7a5e0f82ab3c54110910f35869a6151eec6cede324b43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8cab3a86514a2638e797e7a3f547b9541f3e10398fcaa4e9ed6e3bd66ff0724(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1edd111f6b760884e02adf78ec99b4c52b9a744ac63c96601368e8e208f08795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a0063c17b2418c6af3733efdc1be0bc7a5cb4a64a67b401aac480ae55c1bce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f62561f226b0e5b30a6c1bdac592cc2d058218b0563a273327cb4834212da45(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf75156ab6df59bc6fdc15e756e6145c41cc5a4746a723578dc20439c04d146(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0360e18c0eae0e92c0f41f7f6653228a32bf6776ec9aaf8550945caeb5432bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263daa1915bfe8ed45f46ce54804bfe9dcdce559e272ae8f472ebebe98b87687(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450e4d80330299f16fef531bbe1cb79111ddb6159506f8b45b594c64e01cbca3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e8ddd338a89584468ff616575bfd49ade76c47ef844e9641eea7ce5f778fde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a71700f9be54621ae3ac9ab35a53dff4a58a2291a41b2f7405c0567e875ff5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad4ef4ef5c546f731033ec68b7f61c71d4be0264248d5f71f6b57690f771e78c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2010187d5533802582ae1c55a2685ce1684361e4747b5bf30155c57cafbf17d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00eb07ee1d7e0bab7ee2930f94427cd7bebdf088dfcdf327132d04b626a2207e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c49026b30a90e38f897b7caf13b9cd14f55681b8c0b3a7809402092a00cb706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c3d3f3883d0afc07fdf07c41f37138021d7fb8e5f32596ec49d36291a28674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__392d9e15c1555024acfb24b1e0aef7db23bc472e424832609ffc1ff53823a903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343162f4037672b186726acdcccdde10c5b6c4872585f00c173d5131df1e8e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f8683fa853439532c3940a02db613463137b2516ea9592b11be552b72273a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66492182e322d9950cc5242e017a72f5f7cc919f538a2a11433e825bbec6b964(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyIncomingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55662e821f844c073fb40d2786d6000ce698c793818b939a3b3e0fc96679d2ae(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ca7a8032894a8ce73837150655ec1aa00807892001a890b29e89a42adcbe76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc815ca1d9158b0ee4770a837701eb858e72bc4b95c48c59aa22f65fad5a959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4823aee033fb0bf938492d8ff7b6e17d47ee5913e739f2714a7cb17ecf9ed697(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525d06f1b69dbaead09011cb1f70f17d28a7586f200c5b4115dc5e137593c228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398fe82f840e452e9433f693ce70d727bd8d2af8f9bc619b5f1a4352edc11f10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e6f6a559bb01298a0deee927cb937d2ff1e8d73ce3168a7d22df5902bb13a4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ff3e4dedccfd6dcf6e1099096d58d2737e9dce9a37d99bf1a16421d24e1e37(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069ccbb21dad1ad5d1630d5aa47a9e817fd8cb6b5c9606010ca87542546908cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818e00489a66630f13ba02022d4b04508e7ee1265725d2504ca7846ee58b3941(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09bb39c6a0559f41c51ed93a694e0b7b8f9b5362218f945e85f82fa7d28e9a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17e03d30e3a19f13357f660e36c5b21889333c3e067435876ed56ac84541899(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac10a38d51953caee57f135f2fe4d01d722f15c567d6303a8a67f952b3c1e429(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ef59d3d2556d27700472587b00e8c77b8e55e973d9ab85bbd2e310bf540a02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f96210aba7cbfba67926fde0f7194de72d79f38fca6454270a665c78934c22a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da33081663e6733068f15ddf400c3dc403c6d0bcc5248fd994b94c7892ac8e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e6942a8f6e1bcf0134ac484659c8a79a1b34fb29c466ca8632c94780c04ea4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347a440f50522715593a5462b6d52426d036c1eb0390480aaa85fd24c79a8378(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c171786f53eaa613cffb7141b3c695827acd7cdc4b25755c4a5a532e0896c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf530f3d60a1c58de41486727289fbf6d9710214cb6f5ccccac89100b9feee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f3f1c9733cc01d86884f025206fd83e3d6313f42f2ae422f861653858d7f607(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0dabfac234230804dd926464612e55a527005e001d3492c5cef06eaa829e7b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5376830158f8cd8aa7a3a90d1d93e9717fb12533d5cc4451f00bec5ec8d67cc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc4f57db58c1ac2219e7690daa9ab6e42eee9a70e776a644dd53c60d40b23e3e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1ba4cd6ff340e53ea1b7b094f09875734d047f42b8f2b8a46b78450afa2e68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29315188e2fdd8945038783b41d60150a0f2e67b1f3d8791499537824e93b795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8862133b071526e1e80ac1b6962ed540defffbb5aae2d53948809c84d4a182(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8853bdb40c90145c535a9210d504e4840743ce9ea631eb323975ec6dbf393e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a803483157c7ad6c283fcceb39c2fb68ffa912c688e6ea27a1cb4e1fdff6f39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ee0781a1c6f1f97d32270c6802dc5781c106e9c9cfd343306d17a338a7841d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9badfcf52ea1afb86d61894e590dc8819f8acca87f26cb8528049d9671fc99d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9695aa0842138661ae297a04433722cce16b56958e0885d5a62a847bbd26a5ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a46958f5f0c654141b55a83143ddfa118e4f5f54141053e3f7195a7973bb03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eace61c826d2b33a21660075ef0682764b4ceee6637f46f9b89323fcb5424c9c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyOutgoingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db31795c0f5e398f4c3f8593ba772e5cfab5cd2ff329a27cd71a228e730af12(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modification_option: typing.Optional[builtins.str] = None,
    rename_header_to: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8547b62758a7d2f0c30e9d855408ddcf6b0972d9e42ff619183818a45ac2c61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f447e03bffe4d87fbbbd9943d3c808bf2d3ca214d238ad5ac4c799c85e5ddf76(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e20fb9ac82939d940b6fc630bf265f6ec1b8383a31bf8bd31894b80b1ff9f6d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd975a2727af375fce5c22012c68b77b8d34f6014d83a2c36e73276e204e449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de745fb794356edfe3611d7226a463f1bc3ab86cddc6327b943e299df8546c47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8bcbdda0d9c6fd7ac81b9df2d236eb5c2c3c006185a0f33c8a69c9bb2c83ea6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5147e50fabd9a1faa9265faca75807ad299b7c71d321c8eb9a7ee46088374485(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8548f0480ea2c08b54449ffda12eccd9ff42ddfe5ef0672e4ccb9fea46d06efa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorModifyViaHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685eae61c083d186330bf98a83dea6c4e0924092771105597871bbdc26237f32(
    *,
    cache_key_hostname: typing.Optional[builtins.str] = None,
    compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_forward_host_header: typing.Optional[builtins.str] = None,
    custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_host_header: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    http_port: typing.Optional[jsii.Number] = None,
    https_port: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mslorigin: typing.Optional[builtins.str] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_certificate: typing.Optional[builtins.str] = None,
    origin_certs_to_honor: typing.Optional[builtins.str] = None,
    origin_id: typing.Optional[builtins.str] = None,
    origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_type: typing.Optional[builtins.str] = None,
    ports: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    second_hostname: typing.Optional[builtins.str] = None,
    second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    true_client_ip_header: typing.Optional[builtins.str] = None,
    use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_mode: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523ee84e1ca703c77ab9edba579b041f5db1e796fc265ccb37c03f0f4ee7c4b2(
    *,
    access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    adc_title: typing.Optional[builtins.str] = None,
    authentication_method: typing.Optional[builtins.str] = None,
    authentication_method_title: typing.Optional[builtins.str] = None,
    aws_access_key_id: typing.Optional[builtins.str] = None,
    aws_access_key_version_guid: typing.Optional[builtins.str] = None,
    aws_host: typing.Optional[builtins.str] = None,
    aws_region: typing.Optional[builtins.str] = None,
    aws_secret_access_key: typing.Optional[builtins.str] = None,
    aws_service: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    direct_connect_geo: typing.Optional[builtins.str] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
    gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
    gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mslkey: typing.Optional[builtins.str] = None,
    mslname: typing.Optional[builtins.str] = None,
    nonce: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fabedfbf3d57c11b519d7499b3c13ccf61040507931b6d259bc243b1412ea347(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16ead657674ba0c5768bf4bff7bc3aafdf0f50a73249acce1a850444c7a06e7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f78f5d857ef7264cb918d082221ff7554b85a5e25f36e035ec3c8a30bc781b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39e58a72808e8f1500894f74194aacce0486170085dea4d9bc7a24ab9a098142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73eb9b83f0e8d6b26323d84d17aa11314c07818c124b8901a5cff1d44d02717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5274f3efcf7aa614562dbf59fa4e67c2807633b4eacfe5e7f09dfe1454bcb45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb2b769a37c580157b4a59f9387eab9998dabb31072248a301b58a90194c83fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac8434fe018d0e8b6cbbbf7ca9fbe0e83dcbf65f2150269c823f09b74c4e556(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186b4d13cc9053faa69869e86329df01f20882ecd1f6dd41cca0d8acc08e3642(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ba23be3bc2f1036ab376bf6d05fe27d58271a22e7e462f55dbd2d17304e4a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d155709d61f92d584875e2acdcd65168d70f8f7b614d46adaee7f199c60ea1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d93acb6e51272b4cbda2ad4c011b89b5e3f7124e84f24a845f54b461ed18d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91afed080b5240435067d0bd58675c30f90c416bf6427a9850f480c1ad14ff88(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52a1136b2f9fa5cdf4a5b1421a7901c9a1ec211b75623ac7eb00ae12f8c3528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0269e57e05366e91312359bb0d5482f66f9c48bac1f969e4f6c24b19a5d3da4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f21bfb2cd3886440df1faebdc6987589c3ab5711ec6b8e3c82f111f67fb7644(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6028a1b3b03cf27a28c47972821bc2157e8cc14d885671b2cce8d6936ab549e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84260efac5bf145d59fac4ff57f1169a813cc64f6319add2fa721834dc3ed045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef141a9775c4e90cd8fa8f14f95ccf3a1dbab8ffbec1a7d2b95f18fb71fab245(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe75e817abc0484e51635d2a44e6d7edef9fcdec13dff9267bc42cf4a9ded44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9eee8333b1b7340ea5f2d899916307500728f3c0d2553593dd37dfcabf281c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7780ca41206bd73930fe4ae9debbdf7a0fcc633577973c1bf0df13f4bfbc112b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5213ba5e7fa145499314abec508093e89c4d945440096b4695fd88771bdee65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8df5685219fd238e7d1ecbe31ed2b6c97f4b045969b40b4f659d113b2a568c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4bd60629b6c5ab1cb54dba5f3fa41e04549ac349036b6f945b5f6876cc4654(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9772b0914337663ae4b71176261f039c0e80c3cfd192bc77e1b7967a8f9a0807(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47325d541428b22786f53aa2362af6cb1d360acf7bf11af3d06a4f10033b7998(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5cb556285de71aa117313587380803cc35398420bafc0fa4720e0bb9f008c8(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origintype: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb9b28b5ffdf0c60648ecf608942104134a7e478c7c9ec8cd7eb4470a2ba661(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d352121a2f6600045970d55a6fc41b1d0b69a8d90f70367ba60fa7d397cfe8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9002c6afc8874d464cc360becd3c9439dd214529ccec4d96c4011d652b411cfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495f07b6303df2a566e4f49b064f6d881bba269479aacadc9231ac104407b2a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b460b630d5641cc456ee3edda64793127569cec6829938f72972c7a1525564a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a92b28f675f1a46909d0886018c318d28df382841914a68516f5654bd049f21(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCharacteristicsWsd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6071d23ac14ae71b290b6728a0c892b24f772cb1181aff5bc5a7004155d417bd(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f178a21d01fcc02fa0dd9eb18ed66e6246977d90289321301233a84a57fda3(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4568bd5df9956aa557afd9cc1ffe469b25e93ac1f5779508efd92785dd50b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca2666efe09e7b563b96249b1ea7dafc78c43fdb97cdb72a19f4f840b05cef64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40be8dfbb222918a9561b934f99a14ef138e8f1a508cc356a2d45637d9a613b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee662eacd50e797b570ffee89ad82b5c5430b5b962736272d23c29ead721bcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8adf839cab2a5e10e09bd0b0ca5ae446b26df5ba076c9ac4454f35999da521b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aefcca396f16d5d2b8a2fe89ff34e47bb3bd227b04175db66514333161ebc9b4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7bb9b415ccf6a69f2d4825739da51c078f5e8fe3fe477461bdefed087fa56ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa896a65f1e90b02baf2ed076e7a65820db2b859cbbefc61cf59eb280d772b2(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1065efe96c14af3c94ab5791b5d1ed9fede997e95446fd9198b9ac0c1cfd9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4d85596bf86f863f9d2edecafb7a5d484dc4b6791296588c1a9316b77c3107(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b06d6c7530f27af0eb0f3cb937ec3575ba1d63ba06b9b3d17b5c95d009a34bf(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2d4c0eed62f417b9c1e7110a00fd95350be0661bd58649ee80f58109f83f53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae55bc0f3ade90ada7eea02549e7673f1df184af69337a8e5cfa2abe6691cb2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723e70779642c27dbe19556d520ea9c9caa39b5dd85026960eca373b885efcc1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55220a23b8801ca123fc7672b3f61a35d0f6a35791c0d734a83ec8d936ebaaf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7197875ec38758640349a29985e2627486ef3fa5a0c445018ec67c44ea59606(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45b6a93cbcaf5dca37cd0284b124cfd2f71eb4c7c75069b4ceedf5d69b7c7b6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92fc63563e34a94f56ab3d7f884d7e8afbbf27866abe0fce4b407074947a6b79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__617ada5ac0e43e43495034b2b0b75a93ce39863878dd38e1363b01c822f5958d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02791dc03981efa9e472b9f9a818b1ff29e3f62eb1999bac93ef03849435445b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7771a09512db5fb376ba70264fbfeed650938b0ae6375db02665df45ca0a722c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0c7dac000c2b98c6ca582195eb5011729fd3a1a635f3401af1da1b8bbb4934(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f6761d0d4562581f70deaa083f815b0e855f864ef23aeb1785a8f3ef364211(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90bdf7ad6e17c17beb7887b5ba355e27a497e76ba80888faf45ac2fd3506ac8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df476f510be18a02e11ce1516f4637472bee60604611cee6f6ab903ad17c6e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e49ae29d2f279e1c38ba50f2d64dbd04ee01fd1bd6182361610b67c50578c23d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed5672f56e04c7673048e94b36d3b75761cad34ee0a7caab2f376c9d0521180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a36b63f4afb9851049ab1cb087dbd019c3f2e9d66942e7221e23c02ea6bf1a2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a1f9ab520acefb092450d12fbf4464f88779a4c786ac1a29ad8d0599355731(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5c74c2cf5bf255f8b315488a4b12d43d1924009c5dd3b9aef5de2a593ca1c1(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0d4241dd5f29bc49ace719a0dd4f9219a867de8b8ef95dddfda655c330a34e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__016b2e7f8551b48c0381d2ab4910898235da626e85447d5e9dbfb11d8d269379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb53c3442d490b2aadb9701fc66aeb880d3df82f4844a9cef96906c03eccde9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853e2ffb4f391756e6af207079ac4b3b98cb75ecb16607111986ac178aa082fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec1fab4e16506acab193b529aff385565ac66fdaf566c5f64d60c8b563ec0fc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb17ff09a5ce0a98503f102276e6a2c13867b8fd95529e26989fd771a96d6ca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f8692b4973492060b6a96c160174a07d6a6a0f27a97b9501b5520f2c9f6b6dd(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790786596d9bb4f5048ab08e03d8122f92bb017783e733c589d130210610cc99(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492a5c655ec1aebc335bceb2e93a9ffb4a90a7baed4f8a2f7df9c23e95265872(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a9c98861c17cb46cfd3523f3e8f3b962f3319758b79f6d4ebe424e8f5dfe80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1b0f6da5a2a95f1cbca35d0319daf83af77c84a0d9f07af5c61dc1adb15aae2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d443eda85a8b92aa4bb6b0a1cfd975f5edceb138a6c666def2d49e663ff6b189(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54adf2bc0a3be5c3bf17da75054938109ead92dbca27ab1178646c0cf77bb02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fb49a6bb3e080d3fdc7e8821f095b1a66a697be998a0cf0f42f83b28362bdf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01038abbbca63fcf4876810a779bcaf36041b5a42ac05fb4ac3b668275c04baf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fcb04e409a30ba4276306aa0e4c728376fe775429deae5777cd1925e5d2cec9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ee350f2a4e20d461dbf323f49ab0760c99d91478c60e4b3bab0b7a44ff6f6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__593d0984b985442a600246277ff83fcc12f2091ecca5e3d36eadd39cc107758c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a49b697351627de7a5f652bfaf72f1348cb109d4f19c1b61690a77d1c92bf7b(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae7af7ce8e99e03186feea839fd92eedf89ad949039683fce6abedd52fffc6c(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fa8b8dfc0a406a9309a305b827321ec58847fe0a8322846ac656121d1dcfeb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b5c66cff31d93e1d23281ccd9b9d9751d5521eff63ac43e75450c6b77f8704(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3bf4f3712b261625e55f74660af1480d3a628ceb8618dd5d60b8ad1011e0223(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad72966c6b0c7d511012c37496399fb72dba8d9595e005ae4e700b33e9b92920(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ae116d01079ea7e6795eae57ff75ebd47f199a857a3c91b07d460d203724e7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5880c32ff9236b6cb2bde787b1a37594de9b8554d641a15fa989d9de5fd644b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2fc9257a3083fb36768d1d4b7b5cf73877374132429a092bc0c30c11f38791b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711598a27dbeadd4dbc95a6a33bcccaac815d6eb00c8fefcecb1c4220a4332ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb4b99fbc81e3f7a88c15996ba8a5ebec5a311c200a72d074849f260b2f665f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0bd128db884694d4a5eb77bf49daf081ff39c7e7ae664ac67cec8a374ace63(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e41846edbd4bfac41e77964361ce7fefb2332fc27325815bb10361914850ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec9fd9d0842e9fc6b829af1d3bcef27f8586ed504a87e77a181219fe7467bfd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8977d4cf4374fff01946c9fd3750e6f62d208b7c0b59d157d1d16379295cafb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe8eee389fe46339a051ce4210c766e3b576c0a217016b202f1d1b11143ddbf1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcb707133f849baae51ea6924a1c248a8ae63d6ddb61fad9649708c302f4e4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc1619676c4da74aaf116f855b2d1f6be05d5280e74a76b6b48ba87a43fb658(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bcc804e3fef7b6ab0497c60ad918e2063fabc6a32b7d976533cdff105c0aef(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c354da404f7357aa0df8dde9df0fd67499cf006044f908b78c0c0a052a603c9(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfeebb17049df608eab22182e24e6f3365b685be38857aeec4d71d80a6a8447b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77bf2948a5f9b57fa81468cd004182b759ccb6412842472ecb17db08aa2a411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__886298c4f29bd6504ea2cdce4487d7601118dd3e065555fd8ffd2cfb0c229af0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4686f75ee8f7af53bd558988c873791c43befddda5a70aeecc4e185dad147f3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64cb21e54dcb55ea8a50d0305bee30c79428844843b741b0d579b576a630d083(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6e3aa0a187bb9cb0c754c86814e764571401c6ea3bb4599b4ef89e0dfda44e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificatesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0a6cc761b0770f2451c37f70c54f0007b6bda987ddff274f55a48d2f3e4040(
    *,
    custom_status_code: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    recovery_method: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c96a409bcea79fb9ba3b0c8b4d3ce319a0e1bdd1153359b45e1bc63501aecd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed8b57a4de6c020bbf820a8654d9a330e59db242c9d2ce3e4adb2f984125b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082e33b9ed2325ff23b220127d6b51da72f816776a2d672325e1b250a1de550c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0051fdd8615b7bb70b5981dbeb22ee267f70d42a3652e433cbef9b2287cdc32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ec1f25fd78e724c05dc24384994e33dbddccdd075b099fb2b83ef9a93965c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322e88898b8351935bd99658c590dda68a56e671746dbe1bcc437aaf6e2cc605(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7d947f8776966c644c53151626b5c3c16a35a8ec5d2681b56aba84c0254c37(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae28f3df58bd42566a361f99927c8151d8d0f05306e6680c86ca4298e48d813(
    *,
    binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
    ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
    origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
    origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
    status_code_monitoring1: typing.Optional[builtins.str] = None,
    status_code_monitoring2: typing.Optional[builtins.str] = None,
    status_code_monitoring3: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tuning_parameters: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d6574ee6f28da323807367e77572d2b044950ae7587ea401b7d5bd68169c987(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2cc06b47e8d0a0a54bd0790ead9b30fad6b457ace93200f90207dbe9266e44(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035dc1363b2b10120fe461b1d6776de9cbcfaf71525b62da5d6ff7032ad5112c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2750b07989f298700426358fe64fa00bdae30e37b2abd296b4fe03e8c1b912f8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cdcfac4160dbf62a675eaa93591828d3731b006a143e7105d8e0760aa650803(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dfb1053b84300acfd5ad43b9fe4bb788dd0cb960eac1327897a028eeb05874a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddaecaae55ea8a2b6ccb9a0223cbfde5d6fcf1d2a5db71cabfb16b6d8ebc170(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__130c7b9a5987d75c37047e9f4e7750f785cadddfbefb0ad226192c06778dfde1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b9c4de63116dc498d03aab33dc1efaadfd20a2f64802aed3a78442f148ec61f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13afcc2e4671068a5a19b1e8649e42be167e97269b1f90cbd00f5c10ca03a590(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d7be1259cf596662307d89d94bdb79c3798ef8b5c1f486c48e1c61169884b5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd5a34be760694bbf35efa159631ea8431d5778821fb007cf069fde0ace79b1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a7b13864a1a1379b6c23978d827415aae9d9980c876b26158005cdc15952f8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842c6ad77268f65debb23338d15199c8e84cda2b07fb5a4b2ad1a4064c7d4061(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57bd7872b31dd216b6cbf6de619ae0ff9665c443dee6986c9c3478abfd1aa66f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f44e7687cd082c2a4fb6ca42e6c48434c70636cbde987dfeef9dfd9b0ec0094(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a36c5cf0c755b0a7bb8dfbfc1711790c9d55971edc8c51df1d8156ba19c8538d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9da8fadd0c2f6b53e63d8bb1c91a1bd148759c63154495ab743a44b50c8b339(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da703fd26a7a3e82c9fea75249a6dd25d2d9fbb425a50a1d71ff584b6261058e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276d4a341d982c172d9765d385c176c87713d067aff0de4647b25efd7d87444d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720235a39342b12ff8bff36bea20a5482891139c54cf330d99fe48f72bc086ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67f4d30abc183b44304012707bd0ac61af28a8d6a3335b0f7a18756b792c27c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7da3972bd4fcf2aeeabf38732c009074235b741cd4a00ef171f9822aba1d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__321e2e2ae5348d3608061f6ebe9f247a52d56ce4e4b8ecc620af3856b23ce053(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ceb723ca5cc79e8be61df718371d500229e9761f377fcd1e0f64cf2199d2909(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bdee7dbbcfc9e66c5b0c8f7d7e66650596e535c366c890fad864017f853865(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc8376ff52a7f1eca8cff9dcfa2999947747cabdfecd160414b6f5467cc2dbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68bf059edffa009a26a4a38338186ae21c94e10d41a7452783bc1074771c0b39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc48712db77795117568a3d129ef302b9aab8d012a63cc48feb56bf35ec29b6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d548f93f0fc05f0b330767f08dc534c11d58b2cf5150eb106652ab434b5484e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d325d0c945d6922722f6e289de4ab2d82b70b95dd516d262f9d625bb87bc6d70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6309cfddc86a13df4a1ff16107b13bfa7632ab5906830f6108e526f2c5eea92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de95d84e1f45d988941bed4684ad77ea256e1227cf19b95bc041fe7ad2e200ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d8ab04f8752c03b27f02b17d4b1e12c6aec28c167e3e5895dab3791d9135000(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3edfcad6a7ce26960c5b06da1ed4149d6ea4781c61879503c0fc236ba6a364c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a63f7d7f5fd6c7186c0fd63df89c51efe351dbdc4f595cfdb61acb31f16770de(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginFailureRecoveryPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a36f97c67ba7f47b259f2dd5e404b9cb3b50c20a0fed81708d2e8ec3bcd99e(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b77c0f6e0a24fcd0bad32d4dd8847a8146f834d212a34b61a8397150ad57635c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfb5c05c8042d3e8d5d9367f9b92e788e6bdea7d219e4fa39e52fae4100e6e9c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67e57027128250c7446e56ddef9d767017cddc5ee285fbbc0e4245f9e51989c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68c8a19fb359657471eff9b4eacf3ca816583c1af57b90e38478c61b17e5fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b804cf2192dc7d40a92f928c088521d22b97ef62efb999aa8666aaad71c27bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cf78c369732a5f606664c2efd6ba036fae83468bcd2823e55359292904cc81b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginIpAcl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c497a8c22c37219c5ea137bf177c96d4d574aeec89f6e4d33af1f4d4f06b1d8(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edfd671fbf79b53f47d6d5fb8230fa5373fd259f0648eb8444a06b3db4378ad8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d88953a7a2fbc0586b308062e18c9fb72b6b2cd7b076fa039b6ff5581ab9fb2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6027c6efad2716a04307da899c37b71b4bc94d09a4bfc7dad289994fc9ac7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd4458584e8b3809033a4d0533cbdfab7ef4b18364a19c208e151a52eb75744(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ee93c05e038484ff50bd018d165ebc74e9aa3617a1ff34d9c9d5118e1232d4e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f269f2cd40624ef43f14aa3a127ad04fbb214f9bbe81c71071a9389a0f3b880(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abf4c7e000179396370832ea8047b8562a2c1bb49b8be663262594f2fd9bb4c8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc504243295b2c7b7a3767633fb4b0733450a373e2e297fa5adecbd47a4592a4(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8008447b4b2d71aecef90472555aadad0ae50a55f74d0d482e65bd237c616659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9353b6d881c5d83d0705cf7a039df4edbd5483a260f142d7fa96c514ab3f5d54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffc3f877bbdcae505ccb719819f6cca8d5943eb8ebb0c40983bf6976ada0319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360572b9d9c91bf04f1d01a506c9da7fcdca537e087ea46823fff89e935c324c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4fcaf5ea7114925022e5b0b57e31128396cc35b75e518cb07220f574d0e61d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc75e2faea65fef65c2beed5e4ebd5f2c0c245bfa493ec92abae4329eea105b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a6439e7994310ca9424d0f485e4d816d97d86b563f830e6d6a54fd14a147d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83745cde89f688684cf43f5d4162aa1647be1f7c51b406db18fa6ffb589e9436(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707e97a0d7254e8d6d74d6541d1829626691bed315148a803287b695e4761448(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f900f040c5f8ce75a801981c7c27ed95404f6aec7474af3f3ce8c536e947d6f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f33b78a8f52daf3f9c89831ce36d6bd70c4b5369f8ed41ae0ca2c2978cbb3bce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8b9932cecd815ea5b7cf8dbcc5eab5a29dac6e3bbd61c720c9b2d112752d03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a5fe7e8abab55624c5471ccb8099f585fb1eca973ba4186d2266a8fa4e7d052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1820e30e59c11608469935ddaa175084c72e5d44d28c7851e46d8fd10472b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52a20b90d577460e0814d323eccd2e696e67c3cc87bfa7e3e80bc6b74ddd75ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a04e64b0a56015ff51312962ad1d122599c7c2b0f372b97769990f8d14bcd78b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f094440fa49f77828ea3089a05d78a42e6f4c51fdeaeacb83c36394b3017f116(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__390c629e4bca77d9271cfc7409d0bbb299e415259dac96f3e852e2be5cf59dbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876d006c6307f0c1091be338b711ec6c8f997c5ff7076bba0202b98d874071b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675f8e65a6bb1efb8cdb1686efe21177170faff0f552d0f68915470ba2ed944b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409dad5d1ef9cbd7708d9c4f8c12d2fe47bd5cdd6a9c19ec8a32e4f63e4c1fe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f3ea5f0584c4e03440d58f8d7e58498d3cc5b3151016af2617d5b7261eb345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eaff6d3da6a80d71e33dd74d8beef0c3b2142d3f0fbcaccc5cce4edb083af56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6679caad26bd8a60cbac2312bddf50904b61b14742629cca38b31930cf873e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41bac95d003a9e2a4c19eed364dd71dc061f6ecdc40f0ae257c26f55ff7d504(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf82367d1e06c14a4392bdc04c7d1159f10d2dc860a577536ba582527eb22c00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06b567fcc0b5087c04ce8e826e920b81454420d58a636da5984432b77fcd802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea7306fc5d592524968780d0d6070cef465fdff3e49ea733e17ceca106eb9391(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfd6099074e8bb25e3f334281166a2bd45ae9b066b06d6a8efaede78fa0c46c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d12675c86c9080a84f8c3c31ac2efeda282781aa49864a19387e46090d7acc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f79d00a2b224abe2a72ab6b3644c31b4c5b28c30acf98db1d5488546b83dce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd471b758a418ab93b379b9507c921260bf0361425b8c3f21144d697fc81818(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8562f262e1a80095f836ee35849b0c4acf1fb25f53e9bc5ac9e54e630902b97(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f859560a5c29d0d3e12fe0360d7fed6bd417913800c6dd81a44c83557db56011(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56edfdf77bb1535be12017629e3f054e86d55250e52e932ebd6748ce37f4456(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd0dc76f69e383315e1b046d01e5ecf21509ab02cbe57c00786d19ee186ed4b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f1f28dd156266d2187c6ba0b55b1690ad2c1d26dad97d54e63aaea78a21bfe1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887189596fcac20226764e2d208f01be3ce283c6e3d14b5b815491649795f5c2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Behavior]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8752c0c9c1917cc5c7b2af1c9d863c2edf5196ea177a6e31cdd609c128cc24d7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141de19b0493a3eb015f081a2a63aef41849c75060d7b39a74288494ed026d54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22000876e4dd144809c96f4f9ce4e6a2910dc8e92306a23636e139b9da3fe8a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f728d6f246d50ed2f7ace9a7734c62f88812f552622c528954a3ad63c1fe36f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba4f6d3c6c99ff33b14922128389fecaf4775021da68729ac81f11b548cca013(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc2465c6a0fd151638277fdacd787e0f4c42a32c418beece0f72e616ec024da8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745737bc285d9ac53fd00d7df5c98b2307b682245853c9b79052cf28fa1203fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098aed5a455485238005d8c43420ad0515d9861b4e4b35d04867c44e9f82e93a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentClientConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94c90303c98e356968a31d3d2d5ccfa48fb0dff400d0fc695753708d806734bb(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__240af7623a2e9a4023c89462363d0528615999f2ad251c63be6a09d39d7395bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e656fa7e205c9c357ec9742ecf6db439144d0c0d8a90e771f756ae975ea3780a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c223dd95b0e42620f4459f6dc117ebeb3ff1b94799d47bde54366b1f9cb97a5c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0416354e30161288a88e91fae62a1ac24671ad3c7a627ba4931015e053867110(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6e671d140615b5a6981e95478efad64a7b9d77db64049b55878a12f68467dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df8506bf3ffd55f12dbb00024a21c5077536ce4eb6e6d3cf48672c70f90e8fbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3668d1f5c9c8c89914664d9b6024c7c6f38e80c586825cea5a29ee337459dcf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersistentConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09dd97699e07493b7bfbcb8900614b65977af0108636a850380c81a70f2d263e(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b26fb68f8708e609533ee218fa8279aca2e33a2a9b4baefc211a6db6b2482bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e62de73a9229d1eae4feddcb3d83202618f8cbfd26893176354cbc93dba610(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8e1e3186aaa54e25c5e12571dca3910311ab8f108e1f88371ab3eeac93880e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ad3ffaa6266fa29f219c0f14c894eedc323e736ba4a2ba3e49d0f0d07cf30e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87dfc9cae8f9b8afe83a4efea9e2056f05152374df4b746eae3a04768e323b18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07269d2689c51f89b6781891ccab11b93c3298d98bfeba0d77c857873583762(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPersonallyIdentifiableInformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8366396c5a36511cdfdd66f63cd62190a2bdb7b3440f302c652b83e966bf9fb(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_duration: typing.Optional[jsii.Number] = None,
    failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_expiration_date: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76033ada4b6beea0faed613f737605f137db13ff9281cf637d6dfafb7d1d45a3(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a230fa47ee08d7560e1c8082c92423429aaeed2940d05fa8ed4c81efc10618d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__751a5522e514401c0a85d18f1bfb56044f9bac998e2727b2475b500c4282d283(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc1ea8f803a49b5c4a33fec5cd458193d1d082a02d1e3085e763df49364f8a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d90dfad1af08952bc153f82a636f62d01d5085d1098f3d63afd68fb969f09e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedReleaseCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2ec2202be52c9b9d2f81b0d7d156b46d5d0e1b611a3b49615995e8d2dc354a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d5773560720834012ac4a6387ae31cbaae8eaa82ef177586cab63ee598a07c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67984dfc6eba16cacc002a219f0bd41e0dd10e1ecc5eed2995ed7a7901662677(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d783485ea9a0f69b469e3ad4692ad0500a0093ece4e2124c3c48258bf87dd55f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24793f3e005514d5f69437438523027a92eb6aef111a781bd04fd73fde97fba(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b197603e4f8fea865c2fe11e6636d03c0c9b7043f4598a7f85fd2a3cbdd3d95d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83057f3e5e85903a29e1f01e97d31ee2f933fb79ffc3ffe735b98dc28247d4f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77f6faf7f88170615e73a00fcfc408258259f52ff56a5156286414038f397de0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69de4b652545053e86406cfc3f9819b39ee008acc89efd87693f3e08af0a3b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a3087887959bfd502d9938d657c6324ba452111e553b6b6ee514a8d0845ec11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13e41a237e90c6c09f87aa6cd2914de4e009fb34e83f63b7b3d3fa1110c5fcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65dbd1bfdcf30d7efebdafeb49881d79d9de6e86264359340a732606ddea387f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef17d0b1539ea9dd1fef36b7d37187cd10800bdfe7a570924eb8aa60406fd6db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458a49a55875503b1cb20204eff6184c55ac4df8cfc94b6edd722f5e4a87e8ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aafe02e25029fec6871390d17375932c3cdadd97c6247fe8fcee1ef1b31f23e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c4165cae0fdf939e16c22ffce007bd63f9625eea4404c52555407af00e26b81(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPhasedRelease],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a910e555c2edc4ef3b731ecd049e6f2444c9467517afd2b430e31a1ab9cb307(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c594967b8c7d7cc477ce9eb298f554e5234c75ce21fda66d6e72829b620b43e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f36399e4154afa951be458ac0bfd4e8c2b84260c1ae83adba0fc1e4ba1df22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc53e13b9fb689010a0fa9cc1fb1fc09bb115a8d3330f59dd53b4fbd820de90(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382eb38b98352c3f46c3018473cf7c5b7cee3ab6bf555c6366acc3904e67eb85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ec7449f371d5da27356cd41a7ef851fd218f4d8a25e12c0a072b302ffa81c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2455d023461b64328cd39db037de600c7efb8e658db6998d0527029305d84fbf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPreconnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__787cf44caebe40a1f35e60f3c44885710c43ac05477c4f9bccde2f9548e7127c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b1089775c1079eb7fa8a19c3beb5bf8f6f2d0c0e545c6a76549c227c8245b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef206e5effffe5fb9a0862ccebf2d9c5b4a00de7c718dcd1dd387240b36f1bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c153d8da17193986e7b5f9a51b2ec22cf36946c216ac1d69a24cad4eef38eff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40b1a1fd2d6483fbaac322b84bae984cb0e10b7201c90064913fcbfa5acb6757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__827674f189babcb9c0a6038b9a870c41c23c009b850714586dfd2b1bc7d87778(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223b615e9749a76b051c49ae1e90868ba49e1656bfada1efe495ed9bcf0136a7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictiveContentDelivery],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83531ce95d8c631ca40be2d16b7c7920ccc58af6d1153c0ff4b6ad3e0a4530c(
    *,
    accuracy_target: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6dabd131a343f9816263118b0d068160ed48e6954052f441e31701fd5c1bd09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ce7a641801a0152d05f0fef3e6fcf2f96c2cc6cf1a2c023b773d5c92cc3793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe0a70f21a6e55cac9befda3f3c8c79d5dfbeac07da3d302aeeda97fd629a5d4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f1424c4c23f2e81720409ac738b6c455c9cb82d001ee55000b0e9167644a56a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb57076300f43e4046bdc629ca9ffececd3402b06212b8d3d592d54d8b01ee1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887aa861c5a678dd503d2188845efba4593078af0fc5aa889d904065d54e964d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8567ce292cc728c03e103ecb66a986b6193bec845017b03bfccba785aefd6a0f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPredictivePrefetching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c26e706d28f3a308b5296019052697360a2fd7fe8ebaa5b15b0bde78a08cd046(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b0ec3d8fb1124837853926530fd873146a3380a839dd1e615a6258a3e38af91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3d59ba350b313eb609374710bf6acd675e592fa085fe2f431421f8ba8511ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__995ade311b68e577b4afd294c8f182343ad2c80e4b816cf22ba4391b775e8633(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77275132daa683c2315a603cd730ed9df4c769dea3f5ae03bf258c20c4163104(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f557e5ccac2ff78c605bfdc4e6dd311991e59d0d0dd329aae5bea6a105671973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5f9dc0dc0a2a11f47d8a1dab30ae8be7b805e8937740bcfd24743a204c43c20(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b4106a0ed5b197ffdc592d808d7800efd7e0ba79f7fe1ed403306ce78340e7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b984956f61fbf0ff04d50d93ee8701b28e29689c4101bb0b5851665d7aa87621(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53996785c518f84951c90d3d0580791f36fc13e98aafd30226fae5dfe54da22f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd00af88a9d9d82e442241a75fd62bf4616907428e47785aa516ddf7606ca4c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__847b5238bf4fe3e80e1b50828e45d8b7de21f0e95169f1c4b4e217c1bab7d6f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7566fb6402880942222c8475f0b0fec285e4be2f2158b08184d8a29087f719(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea494d9e0d4c5fcc3bb0410af4c9ecf926e4959ccd345bd0900137070bd0664(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefetchable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d60540e82813ee3eb3b55319f91ed4049dc0405707caa2bff68e3926186c282c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefreshval: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f92c5464b64a0e3c466bbc912d1bbc641ddf0598d753ed4dd230c26e2074977(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb73a04a8b049d890332a7bc48684671a91c739a84fbd43b27315fd02670386f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27fdec305bbe0235e2c86a6a7c973b843ffbac5667bb989ffabc428552b272f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f49a2acfad0b7a18b6ce5787b25dde4f4428818ad30be3971cdb93cedcbef16(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2b3703d751fde07b50bdb0f035c15ecb7e1b54e8fed7eca66b4aaa7a58b8ffb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55f28c4c343a82e0d0fb993df2277ceb17c7a7a07428eaeca32599f4989c77e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a20994d859b74cc33f772a757f6b48325a38fa4022e9c0cf2bee3f0ee7b5f771(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorPrefreshCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c0d89a5bc6cbcd9bf8e1fba06b0d8f6c8609c61f6a36c9842bf216d418b6b6(
    *,
    audience_settings: typing.Optional[builtins.str] = None,
    catalog_size: typing.Optional[builtins.str] = None,
    content_settings: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    delivery_format: typing.Optional[builtins.str] = None,
    delivery_type: typing.Optional[builtins.str] = None,
    download_type: typing.Optional[builtins.str] = None,
    end_user_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_concurrent_users: typing.Optional[builtins.str] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_for: typing.Optional[builtins.str] = None,
    origin_settings: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    refresh_rate: typing.Optional[builtins.str] = None,
    segment_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8f5234ba959f006e91750442e4e8da3243347374f055663054749eb9bf5fa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18aa5293457b6bdca79cfc8a24247d455a669018c1f7b431a263e0098c8ed434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c4e8b5b250f71b139696add817bdf07e04eb87e16400b03c327b15e48929f39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceb9b5d88179789774af3b0bf5503868ddd456b7c3cd2961f9e8ac4a7d20b22e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf656a4e5f1b1505b197bbebf9ced16e4f09542175f4ceb6d307b74e3ce2c64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618023f3eb6714d14c8d28bb76998be769ec3101a958cf8545b1f44ca519dc19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6ead7594b233bbaa29c1165eb46d8a615059b991be3fa5126aabe33150c6ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3027dc905aaacffd6ac498fb2476f953ecf7998828af90f31324555709c935f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715d19d7c7775a15248c22d8e2945a8803a67a36794c912a638b94e45972a38b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a86e0c7929fc50ae2bcde0686bd1ec73283e44d6c0ac3053cdda7a114fa7d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810173cd374a0a227ec5dab921025db4ac873e96e74d149ee52bfcee57cd06e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6328e18161b317e9c7993f02b6fcb9cfe2289151a5abc281c4e7e6dbe31991(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef84accde9aee9a3628fb82a82bdb27d648fa9b805946e9ca91ccb35d8253be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34cb8548669183eb2a7e3ec296946e84bb84a26fc9c7c19ed8ffd82c14ef7f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a1a1b84eb74ac2c77eed0602e06fdd2afb5c4fbf97035d2674a8bc88c46f61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b059072d612302b5721da60c0bc1f3a267a42bef95bfcd1c41879414fee5bda5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3106819ffde142f91f45c43d65b5da5b06a0a3931e09b971a52c312b721608ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f04fc585fe20ba319e27b3626fec9185a85e83d00667d45b8df69a4b45c2c29(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7de2f3f2d0794bee9a4ed1f61f2a3ab8b96ddc9f5cb073a5bd89eb5a0d0a45cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0eeed91a976aeaa88a387b3a08253feab9fa0394601673487e7be218361793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c29e8d0ed1804ec71dd1643587eb5733d8772747c62ffbd5d71c46467aa8c35(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuality],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc635a1406f0364c4302db21fbf544532a731a96dff6d8c4c010db180fb20122(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    quic_offer_percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b5204f2e85786d199bd47f63895d9e5dd116ec33526f2c97d0c5d4fb6cc59dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef501724a108690bee72d9b5daa5780f8fad6e3d254586d5397f6dd7e4a33aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89da648d7b29c739da9099ab9ce74867049a7298a2e90688a6fc9dbe9579e8f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6b0d235d01aa8797b308106dc73b212a92c0f0d4fe333d28a43de4951545fa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f04901c775d06fae6d24028e80b796fb1f0b0e845336ce779845a3f7f672db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da93acd9e8f1211b92935cec1f083a9440ba8a7d41a7105355161477c18277af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007c80b4220f28bf4ea6781eb9d2fdf62e2924d877b4c1ad9fd65f3ff7d215aa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorQuicBeta],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbeda34ec1431fa1f5d19da89afcc32764a7f15c314983d365d3db1a1d513c73(
    *,
    flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e59310dcb1228b5c1750b995dbd399e5ce66404bddb4cd7303a1a339e9aa9d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d393d75fee1f507a76acb8b0e7351ed12340bf61bbe7995d391d07032bc8fa2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11643ff660db2f09952342d76ea5fac3b6f4d2e70c921b8cdbd97a5b87eb149d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b31bacca9d3e1bf156041f5a8f84fca2a037b9aa89b5a8b5b89f8063dfe5a0f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71349c3552311b5b8dedef698fae7d4a8c2d00fff8f40cbee759b291cc1894f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ce9a1305744388d40e1139cebd00dd67f9c6886fe499292f0e050babf009ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__168dc3934d411e56535e778ffbf94da903c400e4aeb413962c30823181c138f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe92d277838df22db24a87e2211adf7d19ce84ef4ef0ae1a54a2e82b4ecab8c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRandomSeek],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e969154d3047308a11fd613487eeb50e9ad7c68e909d9beb0e66f5d6a8a6933c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fc5b66cc2f8ca7a56a3000ae9a473626c56112af90014b8e16f83f131c290cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91549ab4029f3793f6f5764a1290b56acd07d87d9aa7dd86ae4c258b227599a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d387f8e80993049a76ce2c13b779bc356cb396e6d4467079562209140475c66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02cd828308a46dadad7a10ca9a223373302f48862353db65a5ee64b712aa5e8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98af1b8123a5f9eb0a33549d95ccca60cf3b023ec3000bfe77b1ed425754c207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0726f14a420c7f351647ca5cc28d27fca249765eef60570ddc64c3a8316fe2d2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRapid],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d51f6279bc7a236d2325917eecd7232c713e4c6113813d9c6f6d1f64fbd3e4(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab2798d168a2a7f3b2e89a3692a2ff4cdd227c935290fa7d7ceaae3209790e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fd73cae18e01263e76db2cd2bd680917d61052c9da9da56e539cca8e148319(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c085fb86a0d73c2c6cc0c8145d0637c9617f6cf4dbd1d86d7e1262858691c7e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4dcc208ddf307d4e82583a8aa2802847ce843d01a5bd6da33ee4858df935702(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75370188ff4fd67b520891732c24c66c02a2da9325e2518c852364561167810e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02f72ce52417e63a10ad78a318a8b575800f43426c901c1b4009871426e42fd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReadTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04fbc9f29b4f258ad30fe47524ceecc00708aa7358e09601aad9582dc9681eaa(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c996899b696f9d103b859443aa272af2c5879949e5543b657093d3730865e0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__401a8a8b075f915b1cba538d52115c73cd06acba82c9a5b6a0e607ea80b91bad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6826bb4f8d01459f074ebb64c9bb69daee8f7b9a63dc29b2337383b681b43f44(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d59740c6320bd6e30bf7783a6cbc4d60386828e388eadd1667fa7c9524d766(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c82c966249f998382f06b862c20632e1b25c6a84ab12eb0fdf22a0ed7502c470(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac61787581f7a8ea18c6736f2a6dc95a5fd25532819857bb22cf7dde205e4c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9580aff9dab2b930989fd919d9adfa4e5e04424e77d123d9a06eb62e7f6e0de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34beab76a157a59d2578a9c382d4b4134bf6121a9988be964f23427fae28b95(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealTimeReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a13714fbead53b520838f62aa648ced4218573fa93be3b212f4324020d35f80(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d40beef78f893ef4cf67322c274a2390ac9a207f27944e632239ab7d5ec371a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d02afd0d8c7dedf594f93e3ff93dc30125dfe1b64666d3df102ed2209e9f45(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51fd8904df3bf7ecab86626727093819c0d4521e2544a7cb330968f25d03e25(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8803c1e7b685768bc0557e88759a87709538192f1ea14208d27896f12e14317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da45b4de9f8c844610a91be10a16ba41aa3405652cfca9778f711da6643b588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9700e7534ab2f3959bb11b366bdfaed7879948102a8789fc14269aec0ba58459(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRealUserMonitoring],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4eb128097e7c82bac732a199323a18ed97d5cb4777683e13151b91b0f87d113(
    *,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_hostname_other: typing.Optional[builtins.str] = None,
    destination_hostname_sibling: typing.Optional[builtins.str] = None,
    destination_hostname_subdomain: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    destination_path_other: typing.Optional[builtins.str] = None,
    destination_path_prefix: typing.Optional[builtins.str] = None,
    destination_path_suffix: typing.Optional[builtins.str] = None,
    destination_path_suffix_status: typing.Optional[builtins.str] = None,
    destination_protocol: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mobile_default_choice: typing.Optional[builtins.str] = None,
    query_string: typing.Optional[builtins.str] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a09935e39a04ea91051c5f94fa11d9f912ec48eb9280d8ad3aa00f290009a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b26089505638eff944af73516908de2285452442118da785f1f0b85495244be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bd9b69c31f69c53b721edc40b55673dca21751dffe698cac20d5f973a65c4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6fe0fed8a75946e487a3a53b23334730bcbf45efbe6c476ccfb59bfc138ee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6160ceed1a2d7117b7dbc068843048b9decf74ce4ad17bd9a1073d2b0ec07190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18897908ea7f5f1f714bf4e3c8f5a09663670a52811334df0cdb783ce6681590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__477d7fff5e8b2485f33daf3ea33c116c6da2c89090a7228295c9a242696283ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74065e70270de089fa93b633f3aa9a7ccee2c61e79a3708ac320e1dc876beae8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf300b15de8f4345ceafedf73e08eb08fc21d758a28b41a18d6fde29f1698ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64464767c864fb26be4f25e97d44db7ee1bad5dd9e842c8ea94ae1753c203a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554ac06ca33686ff8887bb7e3cb091a89d932524ca1d1f41d4dedf219d69c0f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365fdee4611756b5a64b7c8ffce486e9fec68f5472b302c770ec68d237e40120(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda861bc24d70ac30927890b6af2a66d7540a11c46112ad990c00376adf488fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4f329d7d875154004097b3fa4c1537f217249cc66ef591d40c3816c2afb7d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be39d2a1d5037abc5c123f56cd3ded3c06dbf7d4acfcab80d34ac9043d6518d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db7d3708e61fa1954f750a132398d476fe82da3ae4f6a3f21aa2ff8e8c5444e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbd197cf5d5e0ac24b90dfd975fbb60fee97b3044f959a89e78e83cb99c4ce68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ace8f05f4f6cdaf7183aa7035d628c24bbd85d0d74e0e596693188712262672(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22b261b9ec77fd3faaaae9693de98e93135f432e3079538b42eb0bfbe7a2e84a(
    *,
    destination: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__315582ac9e976bacc64979a1bb5e987d4bcd2f4a4fd84f6e0eb3f6f5e977de2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6d4a7f03887005814610ee55ca19c3c359d083b0073cc7ad4fcebaa08a4aa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9336ded81a99828684c1bc4c2dba4cbfb377abbbe5de9c701b603b98ff74336(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7be2b46ea2269218278cd711e1d5e890123c1f2482ee9926d568c16d54e69da4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524c521cd7de4b63cfa5ce3982285f469b8c96c75bf88556a42c8c5428413b8d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3d2d63e037ba787c3892f6aa98ffdb6365bffdd78c6f453007910fff88cdc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb7ba3f2a01f9d94bf16d42722bb13bb7e5ffac1be6ca6f8e9b2c1124ae0e3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba1ce383623124aa3763b8e5879da5ab8828b3b675f2a2a37d161b0a899ac1d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRedirectplus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b1f11bc7ff53cb72d8aa6c35b99eced2e00000423eadd55cc95b8340c4174a(
    *,
    allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de65b9848906699176434d4cd669f330ce24957b1a08716ebb15961dbf258065(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bdd5833c3b700b829813185da9d4e50a1b0b394f2992f02dd05f8870208c810(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8d6cd1a47e0781f78ecb8bbab7bc887486b1140e7652a86b27ad18aff9f2d44(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efce4d2dd987b93c7785419f44b0eb3851dfd84daca75799f5a19ec93b329a93(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f5da71d7d711ced9c1ec627310af5baf24035db5035b9964e2aaae2943b9e5c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3167528cbe9e2aa0b15da5fe72f1343e69dbfb8931806952f05ef2247ae826d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f856ad6311b2641ae72f5875c641a22200e7b8a1a6b4d958d000d54444ecf598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b0edb3755c12ca838184be3516971de33f57740ebfa9d539506734e0e50e9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e0a730647ab0369eeb215b3d1d3f7f355abbef3b64d0e3593f04de9aff69d0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRefererChecking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257129e826e2774e3ecd6d08719f09b4ed5e2196d3f87c4ec99fe11b32b25d02(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c09d9d6cade1ea3d6976900058b867f36e4dcb6f72cc7b1837532f28d5860ee3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4cfc010ff2889bebfe7c1e76a6329a8f1511ea50abd8940d56f31fc224f30d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7d24a61268e9e713d008f8b07daf8b10da96aadefe3e728c056d34cb949f93(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49283e6af269752a3984df1f55a416a19f82274ca457e7d335b0a8c483ab4aea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b999b9afe4b46d9b908e68d14c57bd0e776f4d4eddfb1ee356077dfb32cb6a66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13633e43a16bea861bfc2372a3811b6f1d5f55ed3dbaafb0a01fb17e9492276b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveQueryParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__053c3327e6c904c725e0192a809280f7c766dd3c45c410eeb18e353d3bb778d8(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3768911e9942a184e940ca3f8a644a2bae4b1fc2df13703475644281a074d2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765e94b9b6554978b0121f32987fe9018984330c91a9bdcfa977964df0a343b7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5754b422daccf50cdd1ffceccaf592afd186ac9aa897daab775d61c7ce4ef8e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b246bfff0a4f5f4e18f35f7ff68b4bfc3798d8f7b7accbe845e37c79596487c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554693b45a696a2e133f8b2fc5a35aa10c1dec072b82c2b23844efe604e6ab34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5a8943e011a5b3185f60a28413a396114dd77fbb24726468fd38ca2feae0c6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRemoveVary],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3453fa937a2182cd43cd0f1520c5a8ebecc173307064c3875fd185d532d9145f(
    *,
    cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_cookies: typing.Optional[builtins.str] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d771eb703b11e51bb0b55f227a53083aff3676e425f25b4ee09473adb28c69dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05cfa93873e8e0f674f5a94b52c0d908ee1dca6cdc9cca25cef905e12cf0a08(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32118cf46fd5a10d4561aad1d53b44b6e439a59d093bf2d7c62995cec33da9d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0d6c9bbe4361ed73a080903118022029b8d267626df87896481ef5cae539bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad855db4eab3280519fb47db1f88ef07f37b52dc2d0c410da03402e048f76f41(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bde5c7844c0bfce1977825b62bc71627e6c9325cd28c7ff97c85ad245cc26bfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765ed3764663abbf5df18b36a04e05b3615d3e73d52a2538fb0e4d780c51f896(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__addc565485d2444705a887361ba0c3353906ae28ec1f42954172dcff6644ac5e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7faed35ba3db032e044cc8e2ab681b901a60f2540f728324d91b7bb851612725(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d1c37bea8bdafe891b415eb672fb0c432bb5b1bf47020b10927def5d63c1a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ff67c34c44749fb22b2c4569c7e8d6e4d081241779e6a7024538ab38e44d75(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7fa9beba91415038ae85a21d4852dcd5bb2b25cc5dfbd108dbc003717b1ebb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062a3a360eb05d955f0e14b8cce18e43e6c345522bf6c5223214ec198440fa38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c157a9b440dcb77e5d999f3df1a9946cbaa3026e60b9c3916fbbfad3c6e0e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b6890d39a05f43998bca26a8a9342f7dd9408caf80a5c076b1e6847ee91ea2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd929ab46a51e92d6058288ac45f9579bd80c501df64e1927b909eeb27f8819a(
    *,
    branded403_file: typing.Optional[builtins.str] = None,
    branded403_status_code: typing.Optional[jsii.Number] = None,
    branded403_url: typing.Optional[builtins.str] = None,
    branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1ccf54840f25d3ce4c7255ce8892abcc30a0ef3fa68b136dedaffde05e2ac24(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f26a979cb37a751797a435d1a548ca3fc3c374d98c46939647354b9ee35018(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e161a1b8dcf023e0dce821024c4d8d2e8772236ed26059a8fc3abb86ec58e10d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e99a0cd1940b1c9e1046b8f38ba627d7e08b0740848de6885fe4d4d499a408(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e20e046e8f452e9e44f333238afed383567701e90e2bf711db27d424d5f5ce(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e8a032f33be5fe35821a354ceec72b81b4ec633d4a0e92eaf396a74b0c05df(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cde2cef56cdabb0a4a3fac833b5e85c2ebb0579ee1544909ce3442c82ceb7f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22520b92649295abbe4e5d9340909271bf4caa9babb34fedb7c0b408305e038(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae77cef80a9131dde7126d8afc4f7639314ec30a4825cbb88f514f74bac3d86e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc0be852d831215a432f529c1d6371d630d5fcac93e79dd925b0fde79f2de77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f818d2c53c32bb8205407c9cdc37c44c866bd556e4df1cd93588fcaf2bb485(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControlNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb25e42ef9d97c31c5cfa9377490744dbc56e9b9635ba63f825eb523eb05a8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d29c0abea2e5d23695e237ff708618ec6ae61deab12d0de5a71f81573b5378d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__565f909a5f6f193e08903337230f1578beb78c08f6c1ad0765cf8c03e440d723(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5639a3ab4f5f2fa8547e916f7427c56b4b021378f6ee628ebc520b2d6f405164(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10d16e651a2033246acaa8943df0c25fdafaf77f5c8bf8929b60750893eefc3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf710fe677ead32aa7d783f7d032c7dc6db5e78dc2cc83f5e42481723ed1b4ae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e783687e40b472944828cee4c208da37173af86a64494d2110118e9b4d349c45(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a90d5a232f4c816ef5dc83f338784a8c30e489251cfb7c4ce87dfb8a3dac6e29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97ca2753ec80950db94911f7edd82023b247f9a4733f8debc3b34eaa1ca4e39a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0f5349c03f2fa635707fb3ce2e2723bed8a00289874e6daf9a9f4bf4bb3b12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6440111741315efa4f62339dba6a89b9db4994b1ef294788ea868a2d429958(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestControl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f2aa13cfab011956f3211704bdc123c7e29a6e3f1e3bc3d174f7b586f3db4c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82934dc2140864c1ce6c8f0ed4c8c43fefc382878b7412a415b74b36f897e8c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8542572bb0ab48bbebdeb708beb779735bc8933a27c28b4d90b7ecd80d2857(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419252fa10fa619c7448c0cba202869b5d943939194b202fa8fea1bf3c1d0d16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36aefce0160feab2bf13cc475f0da6bd860aeea7245954417d44e29269e16808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01095202b12a5facd5412b1369525ac30feb0a8b7817038015c11469711686e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56fa37f8be1352e140cabd912497a02caace862fd9e1f6d7df5921a883faa561(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRequestTypeMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50db10ab44f91cc189d2e29cb0e44347a3e2a48ba5ad22feb2aff3afec6002b3(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da7306461a3086c011cc432f827ad48fe172cdaef8ef9c4f91f3a0b33a994ee1(
    *,
    enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d89f3ffcc433a52ae2fd87158815205286ad99fa4d151223f2e2d189a2d0f19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ee0da8d1854060f6d9615461af8d1ee7aa6a3cf89caa48ac4388c8832bf41b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc23eac2b2649ccdd610f8a11792f814afd51780d017db29a8a86d8a9f971cd0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d9261aa08d34c30c6797212d66a053cd4ebfc16cddce5f10b33a11700ca3a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e5e66c76ff9fa8c29886db689a29a1fab1fccebfd5a59c6955c75b8b4e79686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5aab9aa5195b565e69139b84794730f16b0b144e9b055783048c9518d7641ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55c249aca588e7afb158a75fb4423ff170f5f6d225414cf85d249724b3ccb4c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizerExtendedCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19869b57c8467ea2c5fc86cd78aeb0fb40cde319ef6b0c4d9a65b99a8238e074(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e84bd398b0b1c1569e7da3e21685d60f9e882bcbbd2340a8580b8917209bfc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31ed2493abe725c38c592a49de61d17f8a30e057e92a8f15cbd55ff56194b19c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7054f414ef010018ec94b5bf8b126b40336d9bf764b2633f0b3dd06db098b85d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7be68a28c04dd4172d9c28a244e90eb4a733f45477e44bfb6697d11a0f1dba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9141d293b5906697d707ee420bb42e5fbccc19b38d7b05c23dafd19972cc106d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResourceOptimizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2728a02f9478e0198bdeb2ae04670ec7d03f68f8d61479aca67cae03fe60ffed(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595ac921aa12ef6223b95e9a5c5d327831cda0736775802409825e950a4232d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5c2cafee612359d599648d40ff7ab44d45de47bd5c61a9fa608f04269e5cee5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174b88db3801b842a0c1a8b7492c4166e2c9ff60d8838a60580015c1fe9f6d10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf047f3dcb6eafc2f5ce3989071b8c1d0f15e6902248fa849c0b637d30b044e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4440b1e44c18c57063f3482b6e24778d56622d9ecbdd3a1e753214fe8344231e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e03219b413a2b4d7ff89b025ec26b32647ed8adb3f5d2c68088050df0e5d24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11e85bf9dc3f8fada3e7900c7a4396de169bc8b0aebac3650828596ecd2575be(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76055b5ae7ec6c92590d8f43d181c5b6724a744e2bc6bd46f5cbe44faa623a9(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domain: typing.Optional[builtins.str] = None,
    duration: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_date: typing.Optional[builtins.str] = None,
    expires: typing.Optional[builtins.str] = None,
    format: typing.Optional[builtins.str] = None,
    http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    same_site: typing.Optional[builtins.str] = None,
    secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db91eca4fd1674a0390933f09fe59fb0990c8960c38c482badd90af8ec2f06a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5513d5550859c4f1fedf02aa55ca0abd8945670aa099c9c6ebcafbf3c1ce7248(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7368993cde1389f1a9af100472a8d0662be6c365714245f8c3a35f950e29f025(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__754fc3d91756c2d0fa52d065d48569c826443242b11ba41f1461273ee3139faf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd80dff88eaa265f73e9540d2d1571905e276c0853507c6663329b7f1bd3adb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf45c7848e650c4136ac78c748dfe39f976b280957aba97f2c2da4f6d959822(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f5ca4493817ce79b02b9b1010e4e1d616411d299469b1def4f9dea3346e5ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409ab9f07b937f6db23479012ec71ea711d3329f3baf9eada32a66e6eec0e09f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894fabd12d088fc273cef1a5f7f8086833ae09104285463b7c62d5b5208d9db0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4e0c2aa9297451682c5601a7c58d58baaf41aa51f163c2045f546c3a5ffa962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ab98696c4dbf55ffa6b2aa80be99905913c49799e85c2e36753e8af7d5e03d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7475fff6b8278d23ed7187a0557fa7e5726f55a81d25a1b98d6e1fdd5e46e514(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec86b81d546c57715a5146df2b8f2ddcad347ea57803cc7d9798759ce149fad2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4863686bd678ac88d8ea17065e3948ae482f52f60065be00cec496836a8fd7ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d55f484992b48aa2076d15eeb43ffb27def7bb8f1f6ef3ac7f023bbf9ee68b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f498b316172b818a951de8b46c3a3275e4c7dc850c0524c30d7f26d6a60ae57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0bdfd54815c6d62ba087e5d62e381214edc1884fb3db7f2f1c0f8fd26936a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b743bbc616e235e23f75e30237ab06e537dc0a464164cf5f9b962782753d83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__859e40284381c18bb303419ec3539d9723adc0fc5752194f30519a141c22d7f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517df98cfb19c7d2fb621a9787dd541cd5374b37a879886057aa585e6379e63b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorResponseCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3eb09a85a9da613c4addcde020ff96bf3c5324495d440361c44b3baeaac9ade(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e81d53448d07a8ade865d1db865815a182fb00b7bfffb0d4d5fcbf4485743c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955f15c7b3fdb05a847163c45b1df94739dbbf3cedf7bbfb4306ec51c4656efa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4add1d09c4f5017cbdce553d4d29381f351f95852c9bfbc26b59a569660b9e72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa4414c2b02517d84ad56bb1495d6cc1ff922c718c94034dc9c14e361d3ae63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597ebe8613d150444fa830c4224961877e915089155c589613bfd2af78076f1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02218c9a6940b4a866822cca5df2cd9e71f7605a401dd0a15ba2d4dcdc859bf7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRestrictObjectCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8391a6e726f061d2551a7910b6877db340768e72e540490c248edf13ba9a8c15(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e02afdac4bbdd457ccf59dac75881c266537af6df45b16dea06e93e0aa7f339(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7931786701b134d8683963c8969278546a34c1124d4d21790c2382422396c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d3c363e05fbea7b89e5a26a8cd8cd7ab686118a22eeb4f7a65b38cf946a6e6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42db3aa026499f3efcfed18cbca4dd24eacae9d58b67d31865d64500e50676fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3128c2d7a8af4fdafe5a54cd5969767d17eda2f3b9824be5bc4242bf07f7b101(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136893a37931819e05edefc899fb64db5ce9a5e66935f17454e8877b0311a0d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorReturnCacheStatus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6fb82f77bd61c8e529bd045c3ff3bd35b90cf1e40f90abc3215deec2fcca87(
    *,
    behavior: typing.Optional[builtins.str] = None,
    keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match: typing.Optional[builtins.str] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_regex: typing.Optional[builtins.str] = None,
    target_path: typing.Optional[builtins.str] = None,
    target_path_prepend: typing.Optional[builtins.str] = None,
    target_regex: typing.Optional[builtins.str] = None,
    target_url: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc147bf38756db3a7c3351d328d676facf0de31b8306408e114544a3961571bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07bebc2279b6942fe865b36324d7ec56a77aa6fb200fe2e597a5ab587e89349c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5da5ac2495a6b037b0781547ca13bb880569caacab5d79a12c30dec383567e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beafa938f153d35e292d68be34d52a82f73d35f1f4ce54f63f310054ac3aa3b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59cd7d199fd3757d9cba6e95ca593d9c733cb92aa23396021e779088787f509a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e7232b52a41fd11b8d2e0537944302205eb54392c9913b7478b9530e9cb699(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca0913fc93445bed97f086f67d40233c0b01391902b299c102467f366ed1fe16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5b12c3d5c4040f7f2039903dda3aba1c2dd7b32feaf760f03344297afc94e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b7cc30cdb75761daa6faa2e13ed5fb0a6c2b8665cb2d8982ee9157d0f5627c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b072fab66905fccc896af1d9c689eec9c5d5a49b9bb65ef21587079a6ec0f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f905386cddcb951139b1720da6647167f8827c2eca8bb25ce896e4e15126b57b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed82cbee17d9c33463696f45777b347366cd216bf2b5c7b1766a1454611724d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd10fbf8c913e454ca910c9ff875911c7d8a656318f714c45d2ae03b4c42cba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de078e1f0ece39cc762becf70ac804ff7122fe9374c895723447a0add17dddbd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRewriteUrl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bbb2b51f58236891f09346aa9243ceee3bf3b2df4fa54ccb50ced40ba1067b6(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rum_group_name: typing.Optional[builtins.str] = None,
    rum_sample_rate: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2aedbc5c5f05f632aad3d886acdf686f9e1930f0ba384625642a279b4b0ddfa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d107187769ea8726013bfb186c93f3e696e4d1d70a6e4e711cb0d3a18940e39(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddeb974adb5ce0165bc71010ba0429b09cb32565943a29d86333602df42119e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f2110a204694a750f1bcaebdca22673549ffd4b1b49649b584724326769bc5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b71931a43d89678b7d82ec93bf989f3cca6bac2020fe64c406ec6fd80e69755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c9d52a5f4595a950efbdc653ecd35f567b28a4b8be9d933bf1fdf5802711cd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6cce1e6d9367aeaee836b13825434abb566cfb741b066ed7fc640a84cbc6be(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorRumCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc5127c49cf7565065f9a44b2739a07a8e346acf8eb8115258195c26408106e(
    *,
    application_action: typing.Optional[builtins.str] = None,
    application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    application_cname_level: typing.Optional[jsii.Number] = None,
    application_cookie: typing.Optional[builtins.str] = None,
    application_query_string: typing.Optional[builtins.str] = None,
    application_regex: typing.Optional[builtins.str] = None,
    application_replace: typing.Optional[builtins.str] = None,
    application_title: typing.Optional[builtins.str] = None,
    customer_action: typing.Optional[builtins.str] = None,
    customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    customer_cname_level: typing.Optional[jsii.Number] = None,
    customer_cookie: typing.Optional[builtins.str] = None,
    customer_query_string: typing.Optional[builtins.str] = None,
    customer_regex: typing.Optional[builtins.str] = None,
    customer_replace: typing.Optional[builtins.str] = None,
    customer_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    users_action: typing.Optional[builtins.str] = None,
    users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    users_cname_level: typing.Optional[jsii.Number] = None,
    users_cookie: typing.Optional[builtins.str] = None,
    users_query_string: typing.Optional[builtins.str] = None,
    users_regex: typing.Optional[builtins.str] = None,
    users_replace: typing.Optional[builtins.str] = None,
    users_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f6513eb43c8b871e4dd80c718dac4f880bfddfa0f579dd6e1fe9a49f83ecd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__996d9f8043ee3295cacf9a1cf2359f4381b735bfa40a68586b83252c701d30ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8092f37cb6646e08f68df0b0a2f171443e8a44ba8e173a4a3e6b988d7bdf8bdf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8438a4a38f2efa144a0ad849f9a63646a165802a755fd10579da6219f7b37b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8faa04e7f30d99d03edeed1e311989ad2c7d2468d86a291dd67f1328d91a7227(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec47ae65fefe3ed9bbcb05567ab5c4386d85fb798a34ddd2d4ef6c502298b0c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead24b82b65327ee0996c02f0b3aee6f5b1bc5629cc71a19992bd50faeccdda9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__383713d1551d1e1bc9ab115e289d46cefd795a7ec4d66e623f85c804bdfddde1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e60b67c85e0dda82ef6f565ba1fb49000666174045d7e566f48824094ed3e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3d93cbd2e2359e65fa4922ed6a2af97df605d23515c500b8e8db7c54f1f024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dee3b68282c3a421a75b9a93b91bde5d2a9baf0eee19eb3b527472ffe2fa1a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b23910e1dd29fb7cadaa9df61d442419035e420640c616329b4a19ffddcbcd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3729d6f6c8964da140e18768eba4d0ffdfac7d2d0ab76d5746fae4029a8c8e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524316ce182b935c66d09748dc7b7d37e6bbd36e51dc7067e55e07b2dc833c61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fde5eaca37170c5e812ed6fc44b50192c777c189d31776bfe5d8915da083505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1684a97ecc0d8bd2de713cc29d3b64d491548912ce1227789ae7fe1832a3bf17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c2e5c52058872066ea61c0a9388e5c32bd4502d7f3f872f6ef812e1e0e58cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feb8d75a5c9a6091eb83ff83573a58f7f37096437ae440492b30a72583fab2b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf178fa3f21658a39aea65cb8ba214f408389c4bef45f634ca71bb5d5557a30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5ead8094c2dca2267d1fcda05c675228bd0641dafebeb6e9229e448b2f4152(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd02b68f23b72dd75054b308e6ca04f28c8d4e59b42ed8608f40c63e158d8c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4933f5a46f5ddf7ef716619873fc1e6e92643b2c83dfbab8d81575b1229fd67(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dba95e9936d2cb5a9682043a9cc302b34c6fafa9785ebc8f202e126610f15d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5859f12526d1ffe5b947729c2ef7deb4fbbe57ad7e7e2da543f74e6efe1d367c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aedf7cf3db6dcf39c79a1e8fe15591b3b07b465e1d115a996fdb835631d18514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e9acf419975bb31a924d5f3ddd84379fe943a50141d899c9997e9d353293d1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ddab621892222621fe4fc6b4368869592a640798ee1a1cc4a1f1d379854f4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8caadc3ead7e5a8a2368b785c191ba38f461062d3779c352055da06b698d476b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f18e46294f6f4ef89c6075fbbd33fb987dec3ec6670cf884409111b13e7cbaca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSaasDefinitions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0210e730c4e825d30187ca2ea644d0ada3b89f3d7e0c6f38cc32130909d48220(
    *,
    allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    connector_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_host_header: typing.Optional[builtins.str] = None,
    origin_type: typing.Optional[builtins.str] = None,
    sf3_c_origin_host: typing.Optional[builtins.str] = None,
    sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a4e94221b66a84f932c44602a1ec58703e716033b7fe23a5e75846caa736797(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d022754417db22059f49165b1cfcfaac515fbb591d2106f59fa97d8ea765b36a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079923a97d690a0d7ca1733e22dfad7e3950c619612b2fa772f84d10cf8552fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d044a3d3cef140c57fcbedcba13a60cb300c5dc47207434ddb82e4aeaecefbb7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4749e46d11ba26f7fa512c5b68273e57a276e0db5fd83431b0318e1c16a6926a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661ab7427524d2df6d61f42f3b319fe2b9caeb26cb810a0f7795e92cfc0f7572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c029b034fc6e2f14a8586fec95d1b7126bf2737aba94a43dc68aa6e1c7ceb8ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7130bf27f28a1684b0abeb4747cc165888722847c8b4a37288b633e3b504c1e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9895dd2d1a419d6c1bbabe9c1d7294ee628a5bac64d40ff6a6f48e918a380167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae9e567513a8b2b7b8f195f1b153226b848c704120f2bb3e5545ec3e157cb1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd07e8e751f11675060e191f57ae6065fdf8794253c0e2b7f54dfc5d2c9ec11f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55335c7c7cbedd9d631cd6cdb2f8c8109e4339258a91d579843471a02e82298(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c239f3413b14fd0dbb98ad2a997711a6e6d1e9186e8eb5537500e6780999fdbd(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dbf2e85ca3e1f0d82c9c60f77e21cfd566221ef770e32301f987e72fb39e566(
    *,
    host_header_source: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c9bea08266e8da4f99bc61d644c1787200bfee30fb309f4f51c429b9a0d529(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53434faa3e65d2c5b45813ad084b428917d610fa4c5d5736e08b18bb89c28e96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11c19be69858f2678314d603cfb1984f7023dfc65ade473d488df30df3af187(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4306d65ab8c7c1927052f43f99252ddaf91f3e312043641fa819782a28da48d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17cc7c2c130097d0d671e572a8e1a557fef0c234f8bae55f6c63c32290fe5d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3318df075a3757d156fe906d7404341cf8cd6810280a26677e759effc8ef424(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProviderHostHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c207a26ea4783fecf4869c8de14fa97950d90cae45bee74f087d824a14a131c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a540ccca7075a16a02183868002c5130f5665c44f091963391b62812c7489df2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82cb558d29bc21be065e8fbe53829d7c1d04ed489456934a2abeaae16d4c5330(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b95c5a40e4d2a1cb1b3641a0ce5ef5fe3a452fe2c53695e7f80da291354522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006813c4fe1e85ceae8227cc0dbee6fc52587e3224ea527434861dde76f4b30c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e957fc69cfbf88aad2307e6aefc55a2eabcbdb17046828b4f9e4ee365dce47f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSalesForceCommerceCloudProvider],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803b061a809c43fee06c813a0fb87ea0862b55582b5f18fe8f4a9bed7c77f574(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3588be465a811c06c52b5fb9ced861399e6c5713fb4517527a3efcafd2fcf578(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19c23e9eafc996cf9ab874d71346fa38e1a795ad4b02b87f8b6c9353848e682(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__948d4100219d925a6783f6728a40a1a3f6de744f08e905e5a9587c79b7134117(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5096380ff22ca4be70386eb47179b3ca19ff393d37238b804e35ee39dac89681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2b370106411198407eabaeb357900dba1e2a3f3f339a2fce72d5ac0c48a07ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb3a6dd170888da22bd35584523c796543ee8bcb98d99ade03d98353aaebadc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSavePostDcaProcessing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d0bc5ab6772212f15b592f13872487cf45080e19d501b306466fc6a7430ede8(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_method: typing.Optional[builtins.str] = None,
    repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7991729ac966f6f347061ed44b25b42126e4ed12ac869335b809afa29e8bfeb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d87584d5460b62fa8671157ea74cd959cdf8360ed9e7a78fbdd65bb2f5066183(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd054bc17e083c896e2f6a2d935fcdc57948ffa1d144f05c42f2def868be41a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dfcf30c9db41df8c663579bc0f86d4a0ca927297ec85f055422e96d3df86078(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0023c8ffcf64f7e2b187c2ea7d383f62fbaf640c5f5293064204a10b37b61de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3218238235517371d12a73fdd87706b6e66c349d7cda2069fbdf325ca0a2f67a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda820801b560971a899606b6fc6ed396bbb3d252d4a4dc31a2d3d916e3103c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fcc7650247410737122b3e452da8c750b4ed27e99cd42789f3e3579f37fe96c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429479c92df45940081e06b5a79e3d1a7235ac56ad229330a84c28b5c4e068f5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScheduleInvalidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d7ce0bc4fedb75df3724e8176a009831ff87127855f28d63088b4d52cea889(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serviceworker: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timestamp: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c609f0409b4e2338da5b6861cf3d035c900f9a6cc46f11dfd02b9c6b25974494(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__051c177dc8d6d7143d16d701629359ed17ca90e0ef52226d29164b82baac7163(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d0656632891f3dccb4b5aaaa5c61ed3c273d63eaded60bcbc1343374d5099fe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d06b719b93bc4136e9e25dc5bc4458ca0698742c9e4d51abf0ebf1b90be648f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294ba90642d72c2a7263df52000820afa703c8795904bad6f12fd3b21be38195(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc815e0acd6558679d805b46f63b86aceb143d2a335099766ba29720ea4e47e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678c9a4cd629ef5ed2c3fe037dd3232ad9af2cefb4672e6aa6361a7418caea4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f2b0bb99fbfe3eab0495cd7c48d2399eb32dff8d5c919b57d5a9cadf4d274d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorScriptManagement],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e95e3a119767877483739c17429c8333b781e3e5e25cb2457d01a5d717539f(
    *,
    acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    field_carry_over: typing.Optional[builtins.str] = None,
    header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_encryption_title: typing.Optional[builtins.str] = None,
    revoked_list_id: typing.Optional[jsii.Number] = None,
    salt: typing.Optional[builtins.str] = None,
    session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authentication_title: typing.Optional[builtins.str] = None,
    token_auth_hls_title: typing.Optional[builtins.str] = None,
    token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    token_revocation_title: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca844a0b307a6af14e234144df6ea1a33a13d10db4e22b1b12621e288a712618(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6aed33551e68b5a63f9bb04d358df78b1c53c972f3aa224024351b279ef6a69(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcbf805a8513b1a3f06ab3da7a6b1f029a3741000486923c99d952d954f7d971(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e9363306223d59454f7e14a4987d912110f112c8d9a220ff41f5ddc0a73029(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c63533da56b41a868d2110bf261d19dd55c547a6afd3e46f546d6befd8d8fa3e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39abba8f9ef9377e9dd136fbf8923228be63c07b38c051a2b96f1d3b939951ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2033d808b3292733df4d12fd6ec276fe4e5e0f283dbd2a9e13c43e8a7b1741(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9302a2eb6bee9a69e0766c680205367b2889f5911ff443a4fb7dc5ed2f55b9f5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0559cbe69118ecbdf015b43a87f39e1f1b064df476fc7f44b3ce1a11ebcc1c1a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f6e453e238393a7bcf6a03dd3ea1acfb2a844d0ecee7fc0a0c45589286b3c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7c5306b247612456e021cd1bce6a1f618e922850ef8b7e602950d6dcc69e31(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236ceeda261a1e9dfbdac29d829ae1dff83badc52523fc4873d20bcee0fb5b23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f5582ac167c6bdc2e150bdf12b753ab47a9a5ddabef425a3d5e3132e402958(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5332eaabcbaa884fdf60b18374789b17ff477aacbc746d6b73acfe6cfc309c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12253bd7437c0fe8e0df1f5c90fc09da5ff647c61bb5cd64d96c4de78d306b83(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc09e180a7508f304144d6130e3bdbc2f2a55378e8419fcd55ad7e360ad1b978(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be07c1b0fe3f5b43d74b33bc9268382a5de6cb085b93cfd5fae9f0deb45c7a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b858abb7ed6c8f55400cadec11177be50a905b6a92a5523f2c55dfd6e6953ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f4986b327edf3941e2a58d310f0dc8eadcd60d7d1f5989afb5d8d864bb81b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4917bcfd89b21a8a2677252bcb91d5f7ecb4b75db443557e057d0ec0c8b5fb9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5adfdf896d816c49eaf1f751b5bcaa54dc869b43a51a84fa7ce2958a05992c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeac53c79896d1e19a95ea2d687899eefab35dca9dd7b5d157332a9c2e7dcfb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2731818c9333ad700a5bafad5bf9cf48fd8807a6b612fd834a23b6de95e58aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167f10825f01b6b25285311ab2643ca63aeb85ad334273a43d02f376a4d86a52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b7663ea6837392239dc8d95d1a6d0549d3a46003301e0d874fd42f8d643e498(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95c7cb2f83888f9ef54b8122ff5974510ec5fd102b00c00a323980997bc4032(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedContentProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53274eac8e96d8f372386fabebb68c19b376dd4ef39ac07ce610570f802cad90(
    *,
    behavior: typing.Optional[builtins.str] = None,
    dvr_type: typing.Optional[builtins.str] = None,
    dvr_window: typing.Optional[builtins.str] = None,
    enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    end_time: typing.Optional[builtins.str] = None,
    live_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    start_time: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7c68bc970a7f495ef8bff5bed8ff7da3de2902a9b49c7c02e6e1347aea128c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa6617033c7367dd463e993ec8798d534c5b0221583ea575683065d57fb35fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17ed610fc2c3c3d5d25766200555959ae25d6c6f3e5b20a5aaeed9eeb77c9a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a225b0c5fd3afbde387786a063c5b01c944ff0a70c2290cf4b1e145b9171f5ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7d354f775b77a19256c2c7b406df0fff33d64ab8f307af813f6d15aed0f4d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59071a39978efabffe25bf4e636187e01c8f90c1d216aa7af396506596787e5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7b0eebd8418a4e9325917426b5f8202628ca05cfa711ec0dbc8fb3a3da0421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62f827e429402a031010a0725c251031496623d4f6292ddd5bc847d6f761fb0c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__798997626f49210457feac65184f010c4f5f5b25f6b6d3cacbff5757eb19cea5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3a640adad80cac21ce599b7a96be79a572cb3d2889512d89bc3d460b376c81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01dee6d7da98ec3d13c3c32d94a31208ef12bd0b45a321a7e2765ccd318fd574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2471b9aef331412cdb84781489898c06d8a27f578a7c0e4f296633dd61e23694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05bd3c64fa172c6561d27914ef00544f642f54bcd6225dfc75f2f7b3a1f0fda2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec8ff237ce9ec9c39820990b47817cbf56cf850b47c8bcdc2df8d23782328037(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a320cb4871f45910b48c91a000489828a7d64715f606599ad7e5f8ae293c6eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a654114f37decc2aa016d591aae5d15a3023f927248150acbf68b51ac8ba561f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2983b45b71817793818681b83de18fcf333db14904b801382278de42d674369d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900c45bb3b926866ce27db71f04463140e15bd251baecf48b8d1659adc9d2062(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__050e1589a207c1c245a448b496075dfd4fe8c23e95fb9177d3312033561a5292(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74aaf00fde0f544a559f1aa1e80a0443dd4d0368e761182a2fc842accaeb4319(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSegmentedMediaStreamingPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e2a2b0d7310fdd95493622fda387999c16e568bcea6d00e8b23f027ef2a053(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    certificate_field_name: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    device_profile: typing.Optional[builtins.str] = None,
    encryption_key: typing.Optional[builtins.str] = None,
    encryption_mode: typing.Optional[builtins.str] = None,
    end_index: typing.Optional[builtins.str] = None,
    except_chars: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    force_chars: typing.Optional[builtins.str] = None,
    format_string: typing.Optional[builtins.str] = None,
    generator: typing.Optional[builtins.str] = None,
    global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    hmac_algorithm: typing.Optional[builtins.str] = None,
    hmac_key: typing.Optional[builtins.str] = None,
    initialization_vector: typing.Optional[builtins.str] = None,
    ipv4_prefix: typing.Optional[jsii.Number] = None,
    ipv6_prefix: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max: typing.Optional[jsii.Number] = None,
    max_random_number: typing.Optional[builtins.str] = None,
    min: typing.Optional[jsii.Number] = None,
    min_random_number: typing.Optional[builtins.str] = None,
    nonce: typing.Optional[builtins.str] = None,
    number_of_bytes: typing.Optional[jsii.Number] = None,
    operand_one: typing.Optional[builtins.str] = None,
    param_name: typing.Optional[builtins.str] = None,
    path_component_offset: typing.Optional[builtins.str] = None,
    prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    replacement: typing.Optional[builtins.str] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    separator: typing.Optional[builtins.str] = None,
    set_cookie_name: typing.Optional[builtins.str] = None,
    start_index: typing.Optional[builtins.str] = None,
    sub_string: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transform: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value_source: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03bba3669cc950744c47a62b93f27e23c53da45c4b54e9d40e3d2fd1b9a24ce6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ac3df6d8822d25ece5399804e9374154f19cd16f7394ab198df39ac81b273ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce9ab2d48b5545062aa1dab911cbb57e1c118826b0583ec00890b297d9b92ed7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3fa5e9fd7a1990d6876c3d312e7bc76186a8c6146a2717e0c3377ecd61981d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acd40ece6c9bce8ebce0cc4dc93ad48ff6b2a869b3e945d7efedcba193793d0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea828c3bd038fb913a3ab00138a55c94e82ea84bcf4a3bd9cc29dd03f0c97ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f72d9a1adba074134cbfc4f20f50ff9ad3e6a5165a85b6d5602ce9453c13338(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbbc33496b31dc9f268c6bf39736cdef122f03a47ad279fd04ee34c4bb0f2e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90e499c8c18071a87fb2e24f7e7725b30057ac13e25aecb94bb925104441b4ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daff6a2ca5be06ca37c4ae3dad622e931ee4c35db4ec118b88a618af4cba605e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73b864a552f0a0a006d5c751a1e2dd007277ff8adc471ee7810af95e4c69a77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b06a8b431373bcbba5fa879ee96abe9e0ea543fab45e3120592ab0ade93086(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d83aba293331e9744e829095f75f42d9342d732ed63499b2cb8e6a9f4bc0fc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887af14204c516957ddf8c902c7c82027eecc3f085e81a520018a95b92da35e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4beef46b70268b116c13220eacf0940b4a66d78390691b31a6c7caf3df541db(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35a8e9f96a47eda3f2401deaf1300819b9b07eb0ad0a9ae4c663aa8b60f9e1c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936de23df6a37933d550cf30fcd512aaa83571e3f0c07e87f59ed4888eb3784f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12cd7c016862c7229eef015ccacfff03ca62099fb965ffb0e52f7b504ee921a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77777c34452b07adb16c3f69c6533fa52bb6363196064018a40aac10d8b52423(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25ab582c30df97ea3137af56b51702c91fc6541e7356035cdc19229cea2c5c6e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd8f0c0f61ef457087433a48807a90e3dd67b764e867e3ac4fa8f8239d7a03d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191a61852ff0d440691a5844651e6b2e3712c80ade3431dd490a1a143a4c5246(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc5dc63cb1e7ba83d1a9fdbc835fb2caa09678d2bde6cdc9bcd9d08600b9934(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a44c55f6a94d025b51f865cdd8e7015e1974306dfab5a492346bedf99b27b1a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16d891f2d34d63f6f62c31fb726bf639a94ab251c6d5efd1250837da9c3d006(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__699b455064a557f9793b543c57a1f615446950d3d3afccb06e0446693e3a6d1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c274a0caf9503f1a83651d4c6c5038b51d55001baddc37bb93f079f283def0ad(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e9c9b97c2feeaa9c29161c94adb92cbb40e9b804f346b0a4323135abf5962e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcacf2f4760930f2fa842ce3946f77f0a38baa1c6d64f925311d3777c27c4dcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7159ef45ff94955b9476c5474f097d2f95e74c79e0ce24368df3f42ad9ea50d3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c46ccd9b26eb7a1b594be85826e3fdf8a4996a2de156f64478fd8c782d93d51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5a77c2fdc386ee16c134ce59e21686f62f125094c1fd88a09a769cf02ff021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9869d102fc6f0219293c7c50d7fe8b60cb344a8107ba5cc298e49e45672e31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696161c4c3684355f57c6f8613e3153aee42b1ddb11b77ea14cfd084ea638ee4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6abe1f134f01680ad200fb64e3fa1fe6be80639cfc6089e75266240822805c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b1382ffc65d1f072111bdf238edd2017b74969129ac3b8450eb3a505c004fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df61f4e6620c01c0e5d422565d0d457b6e91bddde7dd6fbd28c6d297583d252(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f211f1f859392f5f780c69ed371428f7592718a63533edacf5697fb59e80f0cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a4108f50792356ddea60e6aee41a3737125cf5be383077d39ce83310319668d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37f2d66d656a56aae3b5ef2baeecb787674c4aa177a4e42d8b16803c1b4f7056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85df3b8b79614427ba47b4baa7dc50559387fec11f9a784c59709acffac0ca63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b87cd1641a208eaccb9405a4fc2f5566f67fe970ba2613e6a180be199bc527(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc7490916922a366c639aca17c78dd7144ba43c32d5e3bae40fbe2382bfd00a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a38f0fc358fd0ec1c1431318eaa0291c366711609adf2c8069449c74ae6e845(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f8b2a67620622f9ff124cac0da56a6ed26141b1772da641833a4daf5810469(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e901bb925bf7e5ca01d5c51787d992a2e6a5128dd7852c37b8845bee21ff323f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219de553e5a780296af83976c2368addd7f89cbbd030fae593a547d2b6caf937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e2cc7dd344ea7e268c76aed81abc94b08e4a445247d78685923106293a06f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5f69646003eada7e2e91e9a008eca4ff3ac8951511d27d469b0b667fff45dc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSetVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f456aedd51668dd0b52f00ade2619acf0a199c6544eee88df238886f5594530(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    status: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72b4ba11b1b901cd0a8c67f05ae41aeb398b390aa961a1633d5dcda301531928(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1838683ab7389595847c44bb06a0f00ac23cefb4a7e564f286a5e937bbf4451(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191574813fbc61d08c9134f6d53ed997608e8af4e0cf272f5bc45a6cf49582ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e7a2b906f1b3f8bed5c22385e41a9892b82cf132dd76e147d3ff8f3fca6718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01838d40bfeceba4f56b827bc80f528d681720baf971bf22cf32e819561b70f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e799733c608836e8d44c7a760df6c97a96a1c380cddcbfa731c158cad82c2aa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorShutr],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5fd96ca75c91aea3c3f185c3f0f88b199e4ed52fef28009bb7cd67f5e46b3a(
    *,
    error_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c5fea6e0edc8f4720e6f506a85ec3c468bf8c6a9ff221576d48110e694b940(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b513e4a9160beb79733287541b01b0c6bef7ed276e2a74e09b01461796c49d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a5a35c43dd9c1cfa2be584c697c320c24340f291b56d6dab5697fe9089d785(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a7071190f2e3fea32fab2af17b1fadf32b3805a42a25f6452fd2033ba987b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a23b3f9786cf673a8ed4ab3de9db3726747c9eb5762040ea5e49419438053400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee207b0aefef915e3d5c8cda0f4653c78813f7b265e31b6d2ac79a0027149196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d730e14a57ad1418beac0a2b2019ff46190373c76c2dd40b85cfc443dda765f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSimulateErrorCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce983dc9bf221aae5d0db75ca44bb8fea70fdfc6916cbf97e3c6f6e2f2ac321(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nossmap: typing.Optional[builtins.str] = None,
    ssmap: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c0a5138ac754dbe3ed4dea910c4bef7e7dc0b71a2d92da25a27a8532422cf6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__799caf2072a5f43474c995964963a5fa961c89f017970cfcc63b8fad22b19906(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f818a4fd3eaa2eb8319923c935e4bea3fb27a114d7fabc79dc01925569c00485(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be7aef17c7b3e12807c8afda07fea8bf6913f5e41974310097f348585482abc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d2e35b4492a9f031ea7176acfa71355b6bb9038e3a911ab6cccc915d0c12e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b18463b4b23f9788a73a06c0e89cecc05ebe4645bd157f1373226473b8be2a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShield],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e104d091e33591cb8cf2c241bd5a3206261555415227c3bad5debf2511cf97fb(
    *,
    china_cdn_map: typing.Optional[builtins.str] = None,
    has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    name: typing.Optional[builtins.str] = None,
    src: typing.Optional[builtins.str] = None,
    srmap: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd7b3ea16260c9b70c49d66738eda08082581322bb5e4df1ec0f7af41ccd61b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc557c264e80e419923a90675dde1135aae5ea4fe1e4eca5e9722253f1dcdfef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72361bf4de906dc93f852a0179e9cde8eb214f718422b1bc045892c92e4e1f6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949987ce34c1f5e75d347345f4784271390c2133d7d83174e41b70c231c6a5bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6131f4adbcaff0ddf7379dc8c2f98ee0bf508dbfdf041dc4346c9daae5bb7652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa5432b304cfeca5807fc025edc3ed512bf45be4066fcea8977e8e93ab8febe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb00469d490fd4eacfe7efac4c2c364ea1fa2a94c1fdad6c8cd8f6e1c206769b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5417e207d87f666dbbd9e0a4653975334ab74b1b48632224e40ba90bcdeaa3c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSiteShieldSsmap],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c58b784e742aa7dbb36097ed2162f226b6b042efdd056318db258e2b16e090(
    *,
    allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_sharing_duration: typing.Optional[jsii.Number] = None,
    cache_sharing_start_time: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_duration: typing.Optional[jsii.Number] = None,
    migration_from: typing.Optional[builtins.str] = None,
    migration_start_time: typing.Optional[builtins.str] = None,
    td_location: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4468d6f153f99e8aa9a9bb0a660a56c37e4cd5c1e6d2dce10c5a442dc227c9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc98e36003efd4500e24b8f2ed5c6ea4a0b46c28def53271d32ed9bae804afb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87959ad2b8a859ebbf4f1920b7116a03dbff2c247a6e4484573688cbda0c07d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b94ee7955cecc60100cc2da99fed3be0448cc516acddab8b9d80a5c1281c53(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b1c27030a2436888358b266db23c5f590a6a18a066dd4f7922c778d9f6d862(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f28ab1083b1ebb442e1fe495be272c02d7fe6793015b36787ce35c1390b351(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0dc9be37b25e34653357d091269f9a798393150ad6bd812d7acc87c4600863(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0c59c69d27a3dfb3bea60e700c1e5e83d22dedd88014a5e285978a0dce7d0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c82491f2488ef13e47015b86f9a49940d20a40192004f7d1e2b72f3faa532443(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce018e7ae1b0f28f3d238a00c0666a810b5db10b24ee3590631b832e04a09f33(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e82e1ba4c1219f66ba6fc9f6097ff1eda94940a2299f9d443ec8d9c34ae0c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c83c03d0a684c52936a6fafa30d1141ae7a8f825cba0b30cd7397bd00f9f98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc9e3db8f66039d806f95fc014b6a127c08a1c750b183768d5d4925461914be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0250cfeee3a5826531effed96ea482f523f6671df4751e2411fbe7019e1f415d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a248bbc34fe2a2ab77f601351c5198a936a1d455776fabf132e26e4a80ba1645(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d414c45b4d9e4e869ca2412ad6120fb38383d7b3b9639a1d8248f27ec2f4493(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa07b71328e05d917c6363e8baf33bb1394ce81078bcef27e8f000b7f4fb4f6e(
    *,
    info: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f263813d3e241f93c758530ddb6e6f6dfe75f8da8f6b0b6d33f3e20f64490c92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6618a9240763c128df52a228459562a82b6aae876aa07b646067b849a72a902d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2340644b0a4712c5e96254c03ba4b647f36b25a7013219152d3317189177fab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af955be8e7b42a6bc040ea15e30be1888bcdc52515bebe2232cf4b2a548a52b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9895b15981cdf6a122bd27bae9adc8af5f151bcfe11ab5cd2b1935853d8c8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da86f2a250b2a5c926ba9756a10f34924f3f07941eb6d64d741220d72e6b5eb8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStandardTlsMigrationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce08b6d0f9f4b9cddd4da7258c9f88383e2e4b20b90c9107b3885c488f2e071b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b59d57d85b41c4180c4ab68db5dc8b1579a1355b0bd2670ca13e8e77542713ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e2f4fcb9a8d89e6841599015412a135ea3ee59435733307a693243d59b5a7b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5445236ef1c737dd5491231e6f657d422da873437883fd4bd47d434a112bcdb2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124de965ecf2a511a38059ea97b3c61350621ff0836844c877f84a5b595d9cbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c93dabbd1bdb679d75e3978b00653a1af7d551752a9ace78bd467e931857b46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e588fc15e64354251df291ddaf970c7f7f5a7adf43c84be4b7232541c7557b4b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5412af13b5a466f8d7239e7bc96e90553a230d6ef17b7cb07a64660949b2b62(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorStrictHeaderParsing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0cca92686adf692fee35dc775a48c6c745a9db1cb026689f8fc12a5e1f27f8(
    *,
    access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner_domain_suffix: typing.Optional[builtins.str] = None,
    referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791d21cd879b4889c1de79028dd7abf4931a599c7210c7f291438ed87b567c9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032e341f54b5c937bdf829dd29f996edea68c67e78516491be04b91baced1d0f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6955a9922cc096a6952b176155175f1de2219b9665192a0728a3a993f4dfa1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ae290bd16bd6a5dcfd3af32606846f27bf0f803d5437787bde3785db1b085d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75f5ae7bb27a427e20c2413e520261b228222e17b0cf4dac72a8947315f10940(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b35814da6527239d87c5650a9ce818b4dde084906487b9734cf7340c32bc1e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8a78267cc15244ec32df71686b89dda063ae21cab82b724e3b4f3b33efc1f3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d23f3e9e52e8b114809b07a9edde9133d91443e38900052856032e72fe64ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a08eabae3df592273d0c44358051f787e6d04a6c14c8b1bc2f9eebd98cab255(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0eea1a2221e35224920fe0c0c121d09ba62aeda412d333d824953a168f5de94(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c14e3cf3f1c1cc14cf88d39f3c877e159eaf4ad29f14391f51251332c62517d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00fba26efe3a66974fbb6e85e09c09c1383b995148b8661b0a8380c5f18b2982(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__165f67282643e2dab8f2494d84052d2bfedb60f13499ab1126a0f31a1500408d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37f263a72e2675d5d32e81099a7cff48678b995a5ae7ffa5de79926f40a8d5dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edaa4fbf5bc24c52baa6f33a15a2ad9a9957aec9f071845f6ab2de85479bc279(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2808d4c6a397e0350b3db17db6f72d766f5a96bfc5cac4982e59dde07935aa2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8551b657c2b4608ea20bf705b496d0aced035b565791502fc32d7db3304331(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27cff05da4235d97be8e32de2cbd516da2f77a9a689b17f46373372557a412f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8605a198d48a7bde4f38daa95d005a553390599ff018226a7fc48e667a4e9ecb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50a5db5b7e2dcbea9fb965e14284f097975dab0edd3cc95914a36c85acc953c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74e64e46a587affec5fc7915b8924d694f0bc2d943adf8ac1fe9f8f230bbcbe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e71c880a7a1aa503bbb20996722bb1b4b33dd3a5a1ab5ccb0dfbdc996029f78d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11100347e588acdf0ffa206840af13d0ee7ccf36ba8ec60c54951215ca1fc91(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1482ba7bb84cc4777d766f4d67846d9a7e0adc508b25fe79e5111df4258348b8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSubCustomer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2dc1a1e6c36bb06dbc183592c920ff41c2c992948fd61e21aa23ad3b77c6fab(
    *,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map: typing.Optional[builtins.str] = None,
    custom_stat_key: typing.Optional[builtins.str] = None,
    enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    race_stat_ttl: typing.Optional[builtins.str] = None,
    sr_download_link_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    test_object_url: typing.Optional[builtins.str] = None,
    to_host: typing.Optional[builtins.str] = None,
    to_host_status: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7665df5442b384da095e6bd1743f46a80affba65bd49a0d930c94d5f81216bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4f49675085dffcd45ae50f969bd6d47692219347d2a327ecaa5d624f96b733(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac6c2145c154ac7e3e6f8d52a6a3713e5a91bdd9c97b6fc6c79fb2779033ed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a819796dfc77a9d11d62068b97b21b7bb733bc5843c68bdda1388ae52237768d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5183010645da7e76a43684db2be3129dd0184ff1ff708bb357de6daf525a50a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__142d956ea2569a58c2a71a63735fdbdf21c977898f98fb6af43251b241cb912e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03dc46b5f9c16b07770a5c10b8444e187e84a6f24423e692c898551da3633278(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208ac108140456790809ae5916a9bfdfce0a3a0d04af229a4b69eaf3b7c3f9a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a54b58b8acb6f974b6bba4db411f716ef0fa0447840853c41e774469db57acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1b8607c0cca896e8581cdfb80e00df782b60dff28d22931046bb15a7bafe0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4f602347640d1fded4b5516d85bf74c7e86162dca26a9a99df3f33d6534cdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8027cc403145179065de80e035a265e10e370a43aa8f7e29cb8984f7dd14e95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55af222a2b3fa42b34573e744e945eed1da54ccb4b58ac5d86e8afb5879c697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d426fbef87c7edd338e5db4b3388891c5dca7a21fad6d2cbb6117e60df4364(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5885492a1a2574aaafc8392273e7048e714aec521f93cb1fc47f60db930c116b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c4c858a2d9d0d4a203206e24720fbefb4ad40efb435d75772bf3982c20c7c42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78caef5819153877bac2cb82b06a0c6b00e6c6f3699b64725e2ce88b0be359dd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorSureRoute],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904de1ee889416325e0bba6993d13a7a799a4bececf0801de1183cd5e5edba82(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d18e950b907d555aa109f39767f5226e4449a4824c79877e763e1f1e19ef12d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8180103b7676d9b052b1e0d05b00b76770c85206226fdf1883262b287c6e3e0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560951252cfd03b46640102269d0cca3ebb91b071eb4c3075fcbd8f7cdbfbb07(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1748eda2e12a3e718eb54c2d635a1699c3c2e73814d7a30ea36308ae7163d9f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1eeae55a027896d79f0bbc7babc732703913fe1ba0f1c95c458a0188df03abe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec92fd2b38b76379722ac2022ca1855eafe79e9eedc75309282e57da7103d819(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTcpOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edf402ed297b4b4b78c05a5d584066a4434c90d7169f0da7a4b6a121bdf33eb5(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ibm_customer_id: typing.Optional[jsii.Number] = None,
    limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a8c25623285dbe937e68bacdc07be51a20dd472e20dcd5fa724a50e70809239(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6678b79c56765f9891ab690e1110b432670e98540d7531fb8ced8b1520b8f1fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21544eccf189266463d2be5092f9c38e53511ea9a79501b45d739ef65a73ec6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1496cff20bb244e741db08ed3e1f15de23ee74733a4e3afa981ffec93b4884d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1e429ff14b5414e3113ab230c01e7a7645f2c77a86a7f677d59440b053c7aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b1ee3db89e61953a034e6eee9fa4b24e00e4ba9d21ccccce094168bd8bb2d68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af38423c482ba8e869ba2161c594c27685762c5b9db4b941f6dcd3c6ffccc929(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d37f0ca89a064323fd53c7c1178591a6ddbb7b1124273cdab3f835030f46af(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTeaLeaf],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c44ab6ba1db008de7b8041d7fa3f1d5ee9c24c8550621f4d50654832085ef03(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82bf7c263c2383aaba9f6a02b195ca9f204a1245b97e670ce025f9e00cd3b42d(
    *,
    allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    method: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ee3c4cacd73365ce07544d820750b9e2abe79112cdc0a6d7880d6da252322a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c9ff27a374e66eb80546c86ff09788221933ce49a355d517ce8dd324d6489d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b6a252243db89a518c0dfecd906a415d385433efb57e543459c782c9b0cd04(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb6fc9b0020ac2b84bd8b7dd995bd4c6fa4aa57e1688395fdfd59ae553264f84(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75520ccc5ea4613749905256d8d933bd604cea472656827c474853398130bd93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67808d7594c0ae97ab677374f2967a59ac570b6794ca192fbd155249a5b65352(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607a43cb656b890bb2500ac273ba756f0339b461665dcb9b61ab7c5c953ca515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419a2bc78fae51e80410d46bfc6d7e3e26fceb46745ddf06092090883b82693d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3877089a432fd340446f0f67e57c568fac5f0f4ed9703baaf6f6ba34c187ded(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1d9dad4d737a4c17cb6ab61e4d774c0048743af39f62c192525fcebe4c5f19(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9b24ed3dbd8cdbe071b691f3d5f29b7ee4eda6faf44739ae1b6243a05fd893(
    *,
    cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
    custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map_name: typing.Optional[builtins.str] = None,
    hash_algorithm: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_end_date: typing.Optional[builtins.str] = None,
    migration_start_date: typing.Optional[builtins.str] = None,
    migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_end: typing.Optional[builtins.str] = None,
    serial_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b18d2a7621fbbba9198000935ced9e08557c97a3eaa698da1c18df90dfbfd4fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2f13d63c4b5ce16be1bdd53d2ca660dfde5786950b9cc536a935290073b22c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2320ef210ec089b92ed7bd5efe965f4694a424c01646ec552f80a36b1c5f2ec4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618b6bca62448d7d4bc447741ce48065e67da412d2e466a56fbb6db5f07d8619(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450e1af99a97f52db0751ef57dc2eaba659fc0bd35c470211a79194619a32f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a442042c81af02a8aed6518e6356b8554419b595f499b92f0e28f025f5932c6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10da1cf5f17f619cf614d0fc3a3eaaaf97eacf35c76cc121f49481050aa5081b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3aa73ae0b401699d2aabeef2e39aeec4a429fdb51cebaa0111ab3e2f98a82db(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ba9c50341bad2784dc5310997e245f391a38179f8290314b23362d4f724e41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e385d20fe470a83e35f33ead1ed49de18a1f88d2814f5ab764c2963516be434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bac455cc0af16da348cb3fc7d6b07b564ef4c23ab6c10f187a73c7062e0073(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023c136f15f20acd44488ac1a7910d24c88b231e6033f2acb9cee118f1b8d6a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8009cf38bc8a1362b36a36e501d7346275428c8ec615db5253954588229d9d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec0d0263ea3c5c2bdb02aa523053bd7c5765f112a3ee8daf2a7a684b181afac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c32b1e0261c0e0c4f00485b8b17be63833dacc274f285029836f6fb9d0b703d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9ec0ce04e5115d2ce06c34142190187a7c11c5b544a5e3046117f70774e502(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20be1d70bab69eca4372065f30a03d848bff87a1f71f6edef478b8448f47493e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistributionCustomization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a4eb40125aa3f000fe11d5e9dd29b322d3153f758cd3a3408256b9154a398b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1917950394961886f055a220710aab9fabb71e79d9c04944470050b6b7c08ccd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8841dd6b783bec71c0ede2efd4d553d8e0162176a6d598c20d4fb44a632c7bb2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__315cf289eecc32f93bcbd696e4438892f278c9dcaa92a5097a0ed6dff7e21f7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8804ce6649a96bb45ff2be5019fc0cbc4b4cc9c34b4acbb4a627f859ddcbddc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32913c9c2a694be336535ee2577e7124e5aa6cf65acaa748841810e186cdad7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220990000a7999541ba77d01e9205a144626d7108cbeded3d1109256cc17796e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTieredDistribution],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fdfca74e4a5c62abc716eb2c8e00e1e4276eadb7be17acabef418c568cf227(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b15f4cd2e998ead0ad7e1aed71b97b5aeb14b486b70641d05809d38cabc209d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b94001d5c3e4e8ca55f09b791ce60bc76297a3ecba00407dd41f23d6ceaf126(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f984da1f59b61890055d4c343e3690c7ee468b1479425f458237942dc1972868(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f53ac5f6ec922771668b954735d8bae3a37cd1ed0c4a21e56e39cd3515adc394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb8d33bfe560ed140dea747be215b194c132425cbe8ef568642d9fd03ee8c4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1affc5fedb0022af3cd4618a3922daa906793dfbc6a11bbbbdc550efa32853(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03346ff9e8a4a55483e7f8ad8b6b2b993a4de9104c1337a355a1c5926993d596(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    legal_text: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f2f9a1e4ccef409c7c5dae23fa8554be5cba15ec3aa5485e5efe6da001ff7f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867459d2ab8ced30121138ec614f8b0e65f2302089216d7907a220a2fdaef3e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c782d2549804009f3fa34c7caf112d641f04b5c0d8e94afe9498c977fbf900c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c3e21dd623d88997f994f956e481dccb97df593f1a80a93b11def243681931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c83ae5daf61ed0063d61497a6ecd90742ce8061b672bfa08c30487bcce71619(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b173fb4e4203064356e200f031e02ca7a51346c9c15271e646fc520b8e151cf1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd06e40b4ec808cb7195709ecab894a8352170b5cee19ec5b286175ef456907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcf7810a86f55b534456199dbe2c91af51ada594ec03f573bdb2e8e9879c04d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0fa7085272ab42ddb6fcaeb747a8859ca3f48d80513e5736215476cbdbd5ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129fc0ac6af02aa223dbd80b808a8c56f1b4c8926032bf7c4e22ba5bb3391c28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4671c9feb8cc4ae9435017bc3e1c637c4336953532e3f9673fafc754114306ca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorUidConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd915c675a47d5814d08e4d720957b1e5c69bf4f598a381d5334e44be913768(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991d2f34d855f3e9a8bd558cdeaf3818e4d1d4f9f39145dc593c92f58cc55fa4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1c370eab8078e05518c864511c2b671823bb7d4d17790a7fa895b6b931a71dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cede03277f2ab4e01d0c7b96d552c9e44b85042af862451c330e0810d3bcab18(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b0a10ab304dea9bcd8a1b627a95e3b20dfe731c0b15b83836d426f76ed98f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b62f3067893a06be0c8880f158b68739db772dc9b689413c8b647e525cf83a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5de21758414f9bcf002824a436b98f6a30d99dff8c6b3c816e2dd2075e1dd01(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorValidateEntityTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb170d555a621d04bcd3048f1fd42476bddd012599bdcf20487b8162478c7114(
    *,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a671f4a22aeada09e6aac2b0d1eb37c294b7e84d190cc33f599a0fdc7eabd743(
    *,
    authorizations: typing.Optional[builtins.str] = None,
    client_id: typing.Optional[builtins.str] = None,
    custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    primary_location: typing.Optional[builtins.str] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_name: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c81d79bd1e272b9cfb7240d380f18e3e44f0d5f24df2d4e36dc34214dcc19b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc59b25d03756e5121e8a54f51a7cb91097473f2f47022e37629a97211eaa8d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9736a327841dc6c8f0b3fd8c8e151473cb5257f1be6cd0fdcd08fe03d797c47d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe02399653ee5e734d61d363a2e129b07af540265153de5dc1d981ff3ecf7ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf3d33e56c5404791211febc6fd8a35a5527986b4aee626714aeca4c24de680(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d30c066400c3af18adf908b4adc6898b8999b960a2de19a3d4f18986b73dbe08(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37879261def51e5995245d9dd6e1c873fe1dcc205dee9e663ab16050e60b7f22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057b4aa6686df5bdd8dc62131f25df44f69d65febf7ec3e19dbf4061b27215c8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4f9213741a62c6800d8fccd30fe2b1c75510eaa388df86492a577624985807(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d97bd496c8c273b95ada10973718007de14d8709027c075cb1d0e62a94e09af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4904037908d151a504f5490bd9877905b98c1b561feb21693392534900df694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f83dc937cc6441aaf91b184dc2eff693bb1b1ad7a954c84f93e7d0ea4f58b4a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f396db0ea9b3a49c70e370991c8f21061ddea56d19698ba095c4235a1c0de3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913b152e906227ac66392c48464052837da3eaf0e2d8d918b2713191e7dd2ce6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9f9099d6eac876c6112e0c8401f029e28a521de9ac33e65d765b472a04bb1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc188097ad1e897b0adc0e1c1ef85de1e2f6ab41c9693e0171eb1dfd8ab57b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c7a46224dce2df2a23d9d417116dd3e595c57d8fd0f6e0536ae46ba8ff9203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2a0dc51bf19234d545a67d5093730a673cb340f45badb9dda250c4eadd3574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8f4b592fd37cac9e9d843b2f3d4642a25f5706df79355cd7ed181d74bd0aa8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebTokenForDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe58cd53598129c4e81790cf93a284d73505bc239b05ecd28fc72bed5e160286(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c146842a4d335aa4ea886e7d65fa94dfd246e316abb15237e9ce19ed7ad4f898(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3dc86d2ece143bcf6f3dd5316e262844f79d74bd75cf9ff71720bd56091884(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e75d86c0629beb3619c1996cd6f5b644057e102503d70458bb8b119b66678e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f097ff83f9591ff0cdd85225c8301fbaea962cba93f6f7d17e801046781939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3846044af008d11eabc1e90511347c93978c3b936b8dbcab1db2f0cc853abcea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479bd2482a4ea182a609ca936c3173dd869b66f809a0e1dd55571ce1e535cb8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f288193bce4deb4acdfee9ca087ca13e3e911c18d03797ed0b7db2b4997ee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c3356bdeb186bfb4f0d0952c27446c5f96efa45adc668053c5176b37ee8814(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d345c349cadbad5e8c83cc5d3570fd5e7af3e4d06576a5f20eda6da44de23f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d1de0a696c6b895714044146ea8d18b2b0057d79bdcc22c60a420fcb40c376(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyJsonWebToken],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c43d6e9eb3c2c794d0dabf7a423c4491891ec5be346b91733084a87fee2232(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    salt: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217f1c34f863e6b42c66a1a1364e38ae5d4f6c6aae00139589f6b42302254337(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53adcedff29ef893334cb0c5ede8eea2c00776d12f0b99a53cee676178d24231(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ecdbd3492cf8cc2846f778c792f12095017ece02dd94b66aa82a9ac327a456(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8ac06f019aeda6dc9e958c457fcd0471efd394c364b78a277c35990af3048d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f759399585b7b04ecec082b22fa6ebfa2f4ea1cf2a8bef799c443aa2582150(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f0395d650c24427aa41a03f28c25753b48ce1ab8cbcd0216e53328f68717579(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9cbecf0aa0dc7374e01bebd76a2f156353a342b58dcf9f067779cf826226a3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__919e57a032b47c92ea638161a2dc9195b1d8ca29d56b764e0f665db002b434b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1980c7b08f7686c0ad920506bb98f7d2997c5af9e795f2c1ebde061e37deb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5b6df3527904d4c1f1b4640a22e96de98b7fc395f682cca714ea835aea87eb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20086dcaf9c9e4d953ad5fedad17b2cf8ed2bb3fe9f4d5bac3a457cc622b338b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ce8d763b02ffed30133adb8e7e3423962197d47f0309985b160f5e27d12380(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__358525d475d224cc0716301c555b75afc47fd87621b7c7ed6a8dcb5d7afdf1a4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd5af37e82c69cf9da26969751f79ddd996af4915b4cbe2150e77ec39750b30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e83783fe2cd45dfd7bb2e27c76c8e6690e02f41efbdba7199a645838ad143a1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVerifyTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7da3d518978c6777b7fd80660a3a27c24b36a4af23b824c33812a1a78d200895(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__687a38ac159ad835dbf1ad2ae765bb8829fd40e4a08bff8357837e9bc376866c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27346c741a91744eac37b5c76b815153abcce5a84ba5af627dd3a4c27e352414(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411c99b9b6bf6a84b72ad8de805bc1ce34c1e20d9ad6795b3fc935d2fc941fa9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06416e919c7009315525ffdb5b2104ac04bca73b7198c03bae6f68ac89dd86c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6b1b2a803d7d93ad2225adbe9f18bc28f01da596505ed3d32d7f2768573c8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436a28e1b9dc3bd13980ec82a1d74176465f73d16ef4958aee4b4d1fad2e1e33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad1dd7d61a9cd5db10880e19d08ed4a5707908ad83810d838d007a89171b6ca5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70796c500fc8b93c125ceaebb3ba7012f9e9e42437e3d5a76d7aeb9a8fe9956d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652dc028491f10655129e75c9a6a02af40927e37510ab9ccec8bedb47410c45d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3216dc168b08dc720734844c03fb14034f80730add84012fca86c96d7f6cd2d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c986c4bab6d5a8573d715c83181d7764deee1e22fb5846f399499b87a64fe8d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28a41be41482c99cd9117c3e4395f1aa0619aee9f7c72e4c089bae31ff367c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b593ebc6c4cd758cd4fef81c131834d5b95a7a1c4bda28d207499ae4032e9913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe2becc09dcbc711647ffb34dae6a16f3f8a4f58350fde026c9b9b546a38922(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__028e9dc0dc41ad0d56cea98591ab966fa72c575a6ab123c54a579a95422ef80d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c3913f21b04b072279431773a23ddd9dc9a85a7f4a928c2076b0da586b109eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07869081ee05a1172c502252cbfb2318f51f5ec930849435e3e00219c7f8614(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea374e44d2786671a8a1f9679230a5ca759a887fcef53f25d505214b5df65e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9850765881782c7774c4a9c5a617615ed27ac7e7ba88d4f9f857994c362c531(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a131b7f7a10c174874058701f36b33beb8a0527f4c0e90ac17296d9bad55e7a8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVirtualWaitingRoomWithEdgeWorkers],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e92903fda0562590927e829545dd5b49513e6a8655f7b76dc7409aed86eff66(
    *,
    allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
    allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
    allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
    allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_label: typing.Optional[builtins.str] = None,
    allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
    allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_key_cookie: typing.Optional[builtins.str] = None,
    user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
    waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
    waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_label: typing.Optional[builtins.str] = None,
    waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
    waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
    waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_directory: typing.Optional[builtins.str] = None,
    waiting_room_management_title: typing.Optional[builtins.str] = None,
    waiting_room_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_status_code: typing.Optional[jsii.Number] = None,
    waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4fab52806f847f24618cad9925199f1e68eb4b32e1921c4fb3757b6a39cec7(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e42ac8947cd1072424466eac45e7973799048ca692fe137165fafcd4b586556(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcdcd62669f37f9714777605c688876a837b7a089ea105127ee75b100eeec711(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f41c2539cdbfc8c1239862534d0392ada9dd79d0453fb055efea3f77d36abd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29483f296576096264a0bf8cd3f72b3dca55817f41c25fa4dd06527622754c43(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8813a174f1b22d7525610f88cc23377a8a460428d79cdd1bd3a1970b334731ed(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db54b574982556c9fbe5aa905009bd862024324268fe125de001a33b76e416a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f49f7098b8baedc2dfbb10511e18a7efd5b031144130cd9e970a373e33698f02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54faebf1363728a8c74e2e3f8d4efb78da6bb452abf49fb1c2ebf8dafa8b5a93(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a822a5e8b41388f314831f9a701dac0d66fe99cde33f0b82edf43b1510522c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36daff73309b9796047f4acbf91d49a958289ab704227e42454fb493e356d7bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11576e73225e597843610c81241516e817a4d42d7a8afe7ff8008554c74c5fc0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1764b78d418db942433902b411581598994327520a4d32a8705ed820a026dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c32071357a2cf48c8dc018775f6975a24d4ad5767c4cde6fd30f05ad84071e2f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d5067a9489ff4b770e64919bac5c270aa04f90113df8c345bf71038b2b8829(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111549501bd61474fd45da533a55b8bb2ea74a44f737358052ca0aff44308d7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4044774f3ff0891aa117db278395774e484e47d5016fb6edbe2236ef1011f550(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5af7c600feb17c757a71584f3d9f3a7d025f1f506af1982848aa21999146f32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52212df1c95b2402111378bd8aaffb9784a5af67e46067df9bda64ff460add6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee92c80ac22508c2fde9c6761d4cf3e1ba63ece0f84e9418a5c168939d7074b7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b497293da2e489523e321bfc1da3348ae1de398a11c7ce13360db6b453e781a7(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5515e42c8fd916c74b08b64da3cea03ccfb01fe8ea0f42e9a66913f2768ca04d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632badc2982b6f349e9d2988748c769c6404c09f8aed58505238ac0759a30f65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0476903964d7671f67691d5adeb9f033c37377f1c004c27de1091beafab14c75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf615e0160eca3c4974711e539293c90f07b2c16decdaecaa08f29292b2eebf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed37dccecacf2c8d872a506f3bd8f5db20155989344edb11e55f5e8a4bc2458(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationFifoStandalone],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93993f83e556022f7fe1431fb79f30a28d99fa03217727f745b2e917235a7828(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e62498910dbf2643a173f299bdf508d9bdbf06e271eb086ea0b2b255ddce4b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2166c06c357705a8f360991ca4028f6cec3b1a2f980b6942527126014dbabc0b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4f0df502175ab15baa8027fba005c5388630ac812acc637ab36ea5bc90291b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124a3cdfa752fcfa6371b13595258595b7a3585ed8479ee117f0bf25cc0b4db6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7ab98fa206126c9118633c9440eb27358439db917143432ea0dce96a90fdf5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588062f3c84b6563937fc46da5f256c6c6c76c4189a843d1fc3e062ee4062b29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f89c3853a33745af4b6bec749c028918ae166fa2c9114ea3f7f436fd43e3abc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9d18827f89d6da4a740a7becb05bc74ad380d2c4e7f42935f14bf140ca9148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec636c3dc5ef692c6a002133aca23e69511a4a7cb9fb836304f6cf3d15eda225(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932554ffe35e00ff80c872de5204b376e7d8c81f0ae3edaedd6d18f6a41f7872(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b4e19f8a72e2106bee3094f9b0bfe7b14468fdc852a2b8538f51f30e0adcb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331016adad28a1167bf0491c93ee812ab9c36f5bedd5685fc73c615b80993a7e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__099b7e7ef64f9fa819519997ffe69c10a87209406c99ae9306a60d9cacdae24b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ddd1275734503e88a63b13990b7eac8885117bf37919ea1f074a6f0d5ae2cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c86ac28d944469a13b6fb3cad92547d1017902aeb22b6e31931a28ca157aa39(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4768492f5b78bfd877ee7d17c5e31a7ce94a0f6feb63dad38004c65cbc2f1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ecf56e0069ea1f4e97b8499a20aa213c75c27817ba1c79e68618b38ad6d8f1b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4c87fc10c0f173e43190149af25f5a02f4992244fd8838c12b103fb42cd82c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e317c7f80d3b7e6694460298674f361dac6f109709718f413118c214030d158(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__914bf0facf303b24d0af4dc5ef44ff9fdd1123056ddef96c5bf4f77fbc2f6c79(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d038bb232dc45942eaeab04d04cf05dbad13a547cef893c73c2073ffd765cd2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__165ad87061db9b26183d5b8de6e7e122c3f7ad93726a72a35dce6f4f941e9ab5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__848247f37908015a4b1de6270f15359071f8ec9ad8c722490dac1bdef30c9258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfc9aab6d4175a2cb9a558990740c3c4f6847f0c1ccf58a59815791946f0324(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659fb8a31e9739b4eae03763931825d65317c920dfd7fd13c9bfea991a2da323(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6019490a5ac4f62eb0fefbbfa87fa1218e7f5bde4364c390205f4a871d7bcd9c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82144bc2589f632e3dca351d321cd68a72622ffce5c75a4e6f854827be270af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eac5e2063599258108f5b5f1be058db3789ba998aa5d962cf0c3d4b47597ea6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8552699ba67dbd7edcca0e8f77152ded9f6d17ffa4ac4c64971112cb8863fc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d95649e668e7e7ca6876b4d27370036442698129a4009a1f9fa4d607a156b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329535c2e562c127acdb1745f20cc906fe6fecd9b8e4b215fe477e6253d48589(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f26c51bb4629e1f59d879d87fbfb0e1b372414987bd9b0c4fc20d82aeb66ad99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2f71774d4d01015475775a36b3ee2760a281a1e0c28234a8d0bf5849f632ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__018cc22597529fdc9d022b2b75dac34b85d79b48999ce7a3da8e5f0a12963ed6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a0d175daaa97c0afc2364ba6377c8adf20f9921cf1039392ff3f91143b578a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1f06945277bafcfd528e4b90a91dc454ed0fc71b638e52bd34d09325b0e97d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9611d43ed35b8ce1d31810b8aea0858c1a82ceca3909e07c6131642f5b72804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a93669726d5f16efbf2a6bf4168b7e819e830656781f4f3ecf7c048fc77f18(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37bf3452f01c786b8acabdafc83d736f3847b1743241cc421033c2bff23d67b1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb58bd90804c9ba3c4eae303ec61dbc587ec480a1e8f661be3631f33ed7f6632(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b56b450f98e16ef18b1c647d844842db9633e574575e51c4725222c09d8d4b(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa18c3c77b6543af669c9932411673d5ff409b8f2bb22efc1294737fb0bc5766(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5817f898663bbe51d212973b62e41feb9b5f3f241de2478487f36f28838902e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204ca7fd3b9846961b4f2f67bc993d1f1c441bee999183140b42bfeeb14ab58a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fee540366bfcace3fd5e5397b9118ab21d811162ddfa1fe2399eb0852ffb64a3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ae7723745603a5649832348275d93d20da26fb0c8c67c99bbbcbda55979ab9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a1490a2237deeefe5b6099175c717692136d866e30eeb7f2b6d5baea2e6529(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305e796e49904a3ae04271e62ef5f9326b1595b297a88841c1e65894d6977fea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1e9cac90fd00e2aab66ff4169d3c160b009cd0d67fc099e63a8efa4fd9601e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a0ad2fdff7957ee45bfe9e85b697fe05024847ee46210ade84cde213a79a5ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a7a3fca3b2edf61c534962dec62f051008a46f7cc876d793309fda8a5b80e1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5694846ca6ba8c47c2ba4320e70625895d5bddcbc3e223f278dd7c85c5ad749e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc09acdeb9c3788f8abdb3aaf8c89d19be8d45f851e195d4e7cc7b84aa0a73e3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a65720d3553a93dcafd793ca4d3af9d4f480f1152c635af6852171319cc6532(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790d1cc634e4a9a552b630d2d8fdaaad4de6beea3f40c8302af74052c5237985(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2487e9646f398b35c2219e199237508202498d592e55f50c0802293be7ef902b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421301ac2eb348dab2fd6c16d49b86475eecce6b34067bec7654e67f97dec340(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52cf7959bd7f0149f332e7a12e086bf0f8e3c9217cc8ad7eac12228aeb857801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db4d23decaad2ac8b74f238969c065552b616979da9f06542d32d60e89f4558(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098add49d3b51a7968c99e19b6a032d8782025a6283493db7cdc5a6f97811b11(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorVisitorPrioritizationWaitingRoomNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220fbb05e974b35e4613db953355df67902db636dbfd05e5f67e1a234797676c(
    *,
    ab_variant_location: typing.Optional[builtins.str] = None,
    decryption_password1: typing.Optional[builtins.str] = None,
    decryption_password2: typing.Optional[builtins.str] = None,
    decryption_password_id1: typing.Optional[builtins.str] = None,
    decryption_password_id2: typing.Optional[builtins.str] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    miscellaneous_settings_title: typing.Optional[builtins.str] = None,
    pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pattern_encryption_title: typing.Optional[builtins.str] = None,
    signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_signing_title: typing.Optional[builtins.str] = None,
    use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_key_id1: typing.Optional[builtins.str] = None,
    verification_key_id2: typing.Optional[builtins.str] = None,
    verification_public_key1: typing.Optional[builtins.str] = None,
    verification_public_key2: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e389f46b1c7fa5892b5dea6260658825b3e110163ea161cc2357e392cc19fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1584aa2ca6230eccad5f61961355bf3e38c09c487ef285e66945cae92114fe90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__620811ac78d90d76db33c060be8f5bb1e9c0c9cdbbe7f702358c47501a50b639(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a14357d50dcb24628a1f0648a839201cfb7415d685d27a9898e5588f2c00828(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3892eecd6a9ff6be77431b25c9af8ab610bb6defb9cce6f84257c5acbc543735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b5b0106fe0842e037cd6c832fb0d923a78e2ba63797e02509ad41ca25e8c0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0e1d8a1c7b258393fe82b04e6e5340fa77d3322691bad16680e2f3404fbbef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0832e1c5eceb3fdd4f3105333ecd34e69492e6fa50daf34812d2dbbd1c10b9a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa0762163e7ba94d152232299283ef8670cbb7279c2de8edf5d8b4eb7142f389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b968b1a2e0950f5688e9c1e354b4e4ed750bf7915dfe1858403e151b495ddeb0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a9141c69dbb5f7b0ce77bad402716884bf8225fdf22cd6ad4497a1ef68175d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caea0e6f83cbc9c9232fef0fe7964029661f2879b5e1baa3c0a1ef4e1c309d4e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5917334e44278d8af165d66f865aca636c64854a34c5859df08c9fe029f04b7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6243c744c559d595ef15f5284033775166996de184a86af54d7447cd2bab39b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a75b8cd3e7717ebc5c7c67c3e064a304bec4c860a4a9ffc25c1269b0291e99c2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea84b05a03080062549c0dbbd1ad3e1f4cc89e5d03723787ff3e2c68a1674a37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d536459503c77241993bef5f38c2ae1be1c8e638c5dda9695f06408fd208ceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8381832f1296437736096c39a9ec8b1dc7ee43c83dc958f97b5759a2c355896(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a66f0df8abe7fe0ca1733e84e82bf0701da1335ba1e5005391a651292a3a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0978e2bc22ad1e7b9e8f8499ced48927a95cf1f141088308319e2f47ebcfda4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94315385346ac19a8aadda06e34865b1b5651175c7b4870423a5e0d3a6d8e434(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWatermarking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cb9427c2ae05a6d83f333cb66f13b62d0c5d59676bbd969b7b880074d176908(
    *,
    firewall_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0569453f9304ea3c437c5ad45ac3657ab882ba459b3b37a944797acbbb94b4b9(
    *,
    config_id: typing.Optional[jsii.Number] = None,
    file_name: typing.Optional[builtins.str] = None,
    production_status: typing.Optional[builtins.str] = None,
    production_version: typing.Optional[jsii.Number] = None,
    staging_status: typing.Optional[builtins.str] = None,
    staging_version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e3e6c2c68b1188bb25b8cd3a25e9562b278729520cc4c6feb1a3d08ead6651f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebaa1f4d8500b1cb4961e91ca1385247d67b77461798f17e0537218d776588b2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41140cc19dcb9bcada4ce2f6d99c73d88f4071d2d24eb0f4e0710ec1c6c9a5d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983608a535ca27956d061b88a6ad87ce53889527110cf9bd139a86ddc84d0d47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__addea865c5178038eb25e22871561b28c5b0a9b733c2aec77079d37f7e90f761(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__733dde2ca2c8c0ab19eded9466f4d3554165cd9d7a2dab0ae81d99c313414e94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fdd86617745778a19dadbc1dc5460f797038250ea7f7eb0fc66b4dd70884445(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025fae8655ff06cef10c1879fe16c814b5c9b324f2009fb0872f1690418a19b7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewallFirewallConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400b0432257c14741abf08b839bd345ee6c4bb5eff64c07c40c93605bdc2a84d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892d59acd5baba4ddf6a22de6b7819be892f5646327618edcfe8e4590d4bf9aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac49a8076428bcd8f32dbbe2055c79e95fdd70974f02ff0dd5dfd4b24b432260(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee9bf40a3eda224ea788bf96bb0cb985b57c6a74e045023641f1a481216b6c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99076a4df686917ff58a9b59e449741f95ab7431120033cc1f9737c078f0c800(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebApplicationFirewall],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f76be085119e41149d911bfe5f0103a783972b2e7b4e56aa0abf2988742734(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f3206677132b23f719feba16ee217777dc63be3e880ba261c69a105e4436be1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abf9fd6aff3025cdb7405cf8ce53686deae9cd5a86ef0b4b1c057e38fd684645(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776d4ffd2d33bb6b773f452292f1065b2728a8f6ad7fbd9f583defb97b118d0b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27fcf3dea89c10c3035680295deec78925333e99804f6f720e213e300a0b479(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dca4a97e355b94ad71d60a19e02895a2e7d594282c7a1e2c578436ac859c8a61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8e6da137664475c64a605bf7573becfb570408e47f78b4143d54ec99b1c32d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebSockets],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c2952ff3eec86e3c056436315f0b5f95ad3816ee36584d62960239e178b10f9(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a32456f13f18cc9d43a6ea6f9ced23eed6813add9c5d7f1352f9e7c05f057af7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8af512183c25813903e1f9aac9ea0b792a45eb7d8b71305613101f73efc8327e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c82eef3a2f08e662f160b7cbbb2ef8d9bffdebf2c57463fb44a980397cddc7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec409750b2744eade5382b5c50f0c970b14afeca266cce1838bb290081958b97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb62cf6f2dfbae9cb6be5e023a54b8b20c1f483522cb22c354dc59549888a2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd37e2e8ed709f2ff5fb3427c05b86b0cdd3af74ea1c957ef990a98741e8e63d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105BehaviorWebdav],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82db7952bb0ade63995916cbaca6edb5b5273c2829294799e1c3fee1974368a6(
    *,
    advanced_im_match: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch, typing.Dict[builtins.str, typing.Any]]] = None,
    bucket: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket, typing.Dict[builtins.str, typing.Any]]] = None,
    cacheability: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability, typing.Dict[builtins.str, typing.Any]]] = None,
    china_cdn_region: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip_version: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlets_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    content_delivery_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    content_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_scheme: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_is_authenticated: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_username: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_workers_failure: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure, typing.Dict[builtins.str, typing.Any]]] = None,
    file_extension: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension, typing.Dict[builtins.str, typing.Any]]] = None,
    filename: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename, typing.Dict[builtins.str, typing.Any]]] = None,
    hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    match_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    match_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_stage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    path: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath, typing.Dict[builtins.str, typing.Any]]] = None,
    query_string_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    random: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom, typing.Dict[builtins.str, typing.Any]]] = None,
    recovery_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    regular_expression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression, typing.Dict[builtins.str, typing.Any]]] = None,
    request_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    request_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    request_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType, typing.Dict[builtins.str, typing.Any]]] = None,
    response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    time: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime, typing.Dict[builtins.str, typing.Any]]] = None,
    token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    user_agent: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent, typing.Dict[builtins.str, typing.Any]]] = None,
    user_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    user_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    variable_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa94a76f72a6ccd6aafbbd2a6ac4571b1b31459d21b8050b52a386c5c2d7c6b4(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3297b078d0fa0dd7b4d64f22d162687ad1388874e2864a5638816ed8d7917c34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e45417b467cd991a38ffeb99d72f5333ad05c95be333382d7a94902d96fa2d3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195318daac84aacc923b030e1dbfafb24ea335107eb222f8e303bbf86a4357a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec8334c29f227978cb6f6e8f1a5a2964186af8a52c613b810f5aa8782f3529c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a39aaba4b3d166c9e68001d440a581426a29bab594f4504a467499f29ace5ca5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e0e405e52557d32c29993db09da5a717b53a7c2ea389accf5fc48c40881e93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5188c24cad6aedf98f102160dee14cfe3cf45ba53b42aeb663ee0099b67ecf30(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionAdvancedImMatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80e811a854a8a86bf5ea3b4aa00d566e34f3cde43fd34dcbc4cc54350da1638(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25437d180c76a0e5b97eac11efe3a639cbe0debdfbef15e307edbb296dbee195(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc98c01bc34c4f17cea335aee97ec5586cafb8dcd3179b64e977f1913c0c044(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674acc5e7abcb96cd0db179746b3ac0b202bebda599aa1db5aff59f79a51013a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8437a84db19e36179622a066ff60e5cdd150b526e97753f621e9cc2ccf58afe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06fdecce3641321800aa4950d23f603166efb5188fa23de0f37250af58154dd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9e34ce675f2ef5e9ee43d18cd94813696cb97ad11ec3ba4a8c80bdb29eea6b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionBucket],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69959369c3d8ef0be2adf58353c6633cf59913f2a12de5ca2cbf84a099fc335c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eef334af84d5341c0b6c19c3437d537993a00bd733ef5d60b51336e283a755e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ecfc52eda4ddd19bde5f916d26d77d5ef601c89221307e84f7660662b41c47f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcbb2d195037e6fdb0b2154828ddc3fbe6b677d2bf517bd39843c5b3f47b336e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987ef285d0dce6e07a5d8b31fe56a977e3db3c1b229003cc3a1dfcbeb8de1f71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709cf6f1b591ed769d51fccfb7cc56a5639db3f2d5390e3d66b1f7bb5e1b16fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbecda0535edffb74dfe547a4146eac396cd74b8ba73a11c488d060ebf26b101(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea42a88737d759c17cc2e835a5c07d36c01038176ab0a871e609b5bb4a72a0ac(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCacheability],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eedad2ed38e2d319716388de2437fd87040eb7e7c66d8b3f4903b1de86e7381e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b762395447592740fc13393b22baf16dd0b3e92927983733e5d74ba42893f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5989bbf491a146f4fb9cd6421201ace68d245e4a1067a15a28d1eadf67efe2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1b04472eb827a07b83f56e54ba601217d21a060945f0386faf8c55d847d6af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f761641b5489d2fd0c4fe5fb12ea4f78f068b84807e7942076e575e17fb7a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4cb9e8f09ab1dd65e52dfd3e4ba486f832b4f50bc7ea99bb8f694b0e3a9f70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c789586f621cf4f47c3cbed3c236e511510fc62c127985fb32b4d8aacfb2f355(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionChinaCdnRegion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__decacae98fb6ee331d58d894cd83bd772be8c0119e78bc1e471dd3efeb1f1b64(
    *,
    is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_valid: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c45d61d26412c2a626c35c344faefa18b0caa83df80159b0fb9840c94cd61116(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728bae78f0cd9d927948b02724a7068cfffbd99e67dc597ee7dfe3e54f9c9340(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010cc5cc024a61616a2d890661d7918c03cbc8ce271fa3c3e69598411c1c50b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649d38fea6877640d48225a79c92f2d6a8aad270edf0e2c604154801ec4c8aa2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15718bd39b30ceaa41b704d6b1229c3571bd26c789b55b30ea521699b2848a48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d74549632ba521284bdc290146f474027258b40a32226c033f164a0c5c09e01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed49534360079db9063034e45c4c5962e5bc790bfc86dfadd155bead8a2fecf9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientCertificate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc93bd5d4808e640babc51fccef78c0d04205fc861dadf65e835b6ffc92f3876(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27fc6f748f12e7539df0dd8dc188c997e5ed9c214c20458c52eda6d1a5843438(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589fcef75af6cdfdfde7454cecf3c1b7e4d5beaa1d9b2f76617ac70acb225601(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50349598d001f8d33bb63754b967c1c59daeb846a4b4eb4c8ee61a517751f449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26dbdfbb0e77034b6e9f96135cf6345cc445978e35aa57cb647a70684add6755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75937f0866bb68f3e004c3805bfca5cf5e65a77cf9f27b82559b673048fed3e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975c583e725d0091d2781df27cd82aa2bca277cc10a98822df93a52c204e1e82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b208dd06b7d134cf73c9945be6b6e9ec6ea29c3e324eb6c3ac0b23e934bd7f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8036a1f582ba561c1a31571ebb8a4420bf76aa1682943de30908bdecc26a8b0e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17b9305c4c41b77e7d36d7e8c7f559d7b8449cd23291812887f89bccb596698(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a80d315a27b1ed37471e9da7f030e6d889eb72eef40b67e4b0bbcf5a5bf462(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce51862a094f79095bd6b481954ac07195a849f0c0965e10182c3ef9470c4c5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d71f0a00fcab9d44040c42fd6c17f3a02a176e278b70c995d104ce6869f0eeb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f7f93ec2edc3bc86e6ced216c96c05f8aa976184f72e800ec4d12bdc2edcf9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1808a3f0b64c5946b209fa95b75267cb39fd62ed0567c958b51fa027b1575e3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52febc91a2e07fd6cd0654d534bcad745d0dc807dfcd73b424d6c279eb5fcfdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccc8dd7afb4c12a5d10fa869a36c0f5fd0032fd182bb7a087cd6166a5d982dd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionClientIpVersion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81de63e9490f0d2fcdf1b190e2c7df0c0d68e9a783e6e23dbc75343442f4635e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b13aa0109487e340c00cc3a2c4d92c6e9055967af3343d86bbabf7a525eeb2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ceb96d1f3ce8b50276a1a1e76b02c8b313d21f3032b2080802d2de069c77135(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e157242f40a378895971590db886598161465a94841ebcfb57c4e284ce112cb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b94212c57d6244c615784f03113204d10be2cf1f21437900f906d1be6c64cc4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af02e99c7a29fbd44859ff95f23d28b37d9e889dfa1b7609069479396226ebd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a8dad2b4211e55ba763f7a3c11cdb8a5ef7dc0291a55ab9366168d494575f9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionCloudletsOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa31a37a1816497bed7e95c38e4c8d6bac56b5cc9ac76399c03d221abfaf20b0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d0c84470c048bf2f32a257f3190199ae62cac9364472b41056867eb95be58f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdfe7c22a77c0ed22ab5328e08abacf38b9d2063693eae6d7bd461419002c269(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64b895b93125bbad139407f8120e79bc0b71da359a41b3d75d53ff670577e70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21111630d8d9eb425ff7784c5679172ec908282775d321f68d932efe68f272a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff683d7e9f4afa0a639a2974b933e2b8ff85cb3678783fcb9abfef1e2cf6293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12bd1fff4f9e477713d02c4da94660abf06fa35eb615865e5c7b2d659d9cc1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68f62b284e397fd178a8e3713e0a13e834d41a6372b471d9f1c5a1b575f4350(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentDeliveryNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078f936422545f3e55d2595d8e56cd8ea078ce3a7c60b07060e5782aefb49969(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5fd7497903ae127c36bbc6f9c41ee65661e645e6ef01268128336384aa882d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2977212fdbcaa8f6ee16ac7360d5bf8f62c0d02db48429dca7d22556123c45f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc123c3e27b88c4bb8ddfe053e3f858c359000cd0d342c2c16b5c9ff81ab625(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183d2dcf1c706e5e43ed8ab6551ab41988e716fb9ed6e19bbabf2e9b25d040c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002a05d7d1a657881b7f8b44db106cc601bfed7cc9a7e894e0eec37e8c91c549(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5063955ae701ecae588de384b019e8ea5fa3a52b60bbca914a2307bb14f7c37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5331e898bcf599cc8fcd8b6569ed5f2faf18e07a0afd19951ca40e02621aaae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879c6d822b789bed92464ea6b5b1378f8a2dc2dacc19d5aa1e531fca6d8d6152(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90eb4ca9b5b23feaecda8ed547685f0735a57c524d778ce2f916fe854cf76642(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionContentType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b417cef7524f794bf4c3d36d404e6ba46baf0da1039a69a4393889808e15a4ad(
    *,
    boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    characteristic: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    numeric_match_operator: typing.Optional[builtins.str] = None,
    numeric_value: typing.Optional[jsii.Number] = None,
    string_match_operator: typing.Optional[builtins.str] = None,
    string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    version_match_operator: typing.Optional[builtins.str] = None,
    version_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d288b492dd963c4839d464c3605588a079e0e924b880d70411d17d6149861b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8bf80a773126cd5259655c51a5843627ea75e86daf886d225c460721ee2ae9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3c4d680a774de62b4517c2be4d02ea6ef4768b233a05f4420aea53fd0242b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__675a4d064f070fef87097df1c22576c8c0a9166583306e4364e08581e53dc3aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d092ba1e36e26c7d912373a166decffd402293006ff426f36789990c264f355d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076294dab853bced06a52715ea9d4aa3f981a9866c307812afdf42cdf38a2791(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5ec10b69ea54bbf545cdcc1e73916b9cf525ec1c88d233c97dd15e5c776a80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2121d4e4ba2f72f31f2b60ab52654e4914d64ca678316d9537183381746ce4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033d61250472881ea1042c14d62dfe5c9d042d9f47524db7a2d3373abca67e53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f0bd1b0968d3726db1fe5c1c6cf2a95b4fa3c6d565d8a8af71f3a1de6cc8bf(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a45c280d5561030b8364e5db294a4bc823ec5aa254736788796a6612b85148a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ba9b23ebe276e6986b28952d68339db7b79bac6f1d5749b4b6c9fb2b523b46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c2151b7ac9dad0cccb15675babce2e4f9406e3850dd5e8c820d33ae9001338(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5f2dc5264f6e806b278fb5bbc9109e447babf3e240ed0deae1e7569442533d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88731b2bec6d687c4020bfba55f27af20d4b501ad7e44a758d9c83bc327bd915(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionDeviceCharacteristic],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3691602a8b4a8c27daac2faa7bcb5dc2070dac45290390c6d11d87438bf33c5f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bad5500309f497bfebd00f6b47050f67c5def9d48b7010beba7e3d6e4028e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e213f7b5c89d678841f025e3312161eaebe097145f78d8ceea328916459963(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4edec5327f73714633e3a143fd372593cb8b7c5d08a05efeee1bf9d24dc39617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2c17369c5a5a5fa6710349809f845af7f93d3f52192d138b901425a08c0733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02c05d4f70cff6197abcd75f00aaf57e4190a3ca3bedc7842394e629ae24f23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5637baa867d7a92fa8cd56320671c2082578402cda54d65ffbb78450d0efa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff3d77de66ef48cb4a9fa90afb7bcc115d33ced2ffbd59b85cd9b4244e4e13f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c6dc34cb5c3f561704bf386acd64019192faae242896e4bcd805ddebcaa50b5(
    *,
    auth_scheme: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93868b73c928d31b8711a0de83edfb7fe053d27408793bad617df6dcfdfbd7a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b6f0332d4df6e1f9ba3cc4d8b12c1c72e538ab3f143002d0d789288c9be49bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a63f2dc2d8e35b6a059848f631f87847dafbc984184dbbe1c87d46fbcb57c168(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf00e59486966e962809532e685c9ab6f0ed3d819dc3fa04b69c28ec10357193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e37008f40643da5fa96eb97a996ff8023ff3dffaf8f6e4adc6cd200f5020f3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2de96259c141ecd43b5470800005a66890cf0d9651e08a1cc1c8235de765a1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdAuthScheme],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4ab0d9907f28cbcf808cef2f49664fb7510d63e4479f9c3664dd7103605356(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0fab4b3e7c7497d41f76ad722a5fc33a4fcaa21d2e8c905d44550ef3222d804(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64db7aa09e82280c64c5226a2bee3b5ddbee4bd5334e03fe1c882272721d419b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95e5a0f29fc5e7a8812515c82a45abdcbfe9b2248a936e59fd596ff9c9391af6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcacfaa84bd1752c3ea3f26434c0847382feaf5c9e4a08ed84abe7b723b66ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aca4f0b2fa5190f3c0f8b06c8b517980d9f13199488c8e0a17b7292980eda75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c9f3ed567744ebfd9ad888791253aa630d331b325502af2b5864a64cc92751d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdIsAuthenticated],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a291b6e8b2e6f2ed08ffd5a5ea00f7111f96acec80e8cab71f371e262150b9a(
    *,
    length: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ebdca58bd428b13a7ea95dc471b9e1605fdffa8ea8c6757f3944643eb8e442(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ab8ae50814df36df9b744b6990736dc65ac20569b1a6a20471ad7a7f51fb3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71f3a1e4d00fc3a49f60292fc97aec2d2f01b0a12f563457af3803ad9c5fa17(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a24722c85e2251d1fe4ab291e668db853928f1aef5ba13ad3604fdc06de6a30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33efa9c404217be773e998712ee2aa0759fbe2899658d9cae957696c20d85657(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__943ff927de9b5e5d16611e35e103692f0715ec1d453c142e4e80621cacf4d60b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf34880ffa176a0a48fe95e6e2827b07b89aee94633b83939e26a6d32ae745d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163a1809515a476fab645fb18d8f405d5e429af9668ca78626806b2dd5e26727(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEcmdUsername],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cbdd4cb38e3e15fe2f16e2182b98098543e74fd390f2e94eac6d514e5bf5c94(
    *,
    exec_status: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1fdcd6198cc49914ebe550f124a9161439b26b9de4e3f122c6c560a25ec3b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458478918b6cdef82075f1f638ba827a4f0c1d61fa49586603e6626bb8a59fa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1705f399fa696df281086b01bf85ba14e48a3728fea658797454746e1a4d6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ad47bb8c6de821c06eb8e844401e5de54e9b046bcb4572151ff6e63f725670(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd33ac921525f75bbd75fd827d7116b6388790aedc86a3da00121a0a6e61732(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2903346a7f9296be5e9a2e5ed1b046b13b8fa08c7f6921cf2885079fe99ddb7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionEdgeWorkersFailure],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa415979283cdfc47a4bbf1aed824289005c7fcf4ce9cecf939e452386b736da(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5c06c1b6a04b59bb8b09096bfa42456f352daeac40422ef8b553b4f5d23483(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc7034488eb859608008c678b3eff1be05e29f58a6fa586f285e629d9b37870(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f1bac09cc290f7c877a24188c96fae92e79a0d2ad468c5f931ed8169c6f957(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03462b651731e38b1786e8ee883bc20a79fcebba4942016646c7f71b3b36e497(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c44d267d0fd734ab3e175a1180108c8647d25420eef076639a4dcc4b5899d67c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91679b6b40ddba946cef2cf150839f35d1ea842d8ab25982745f9a8397957685(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__022793958aed3da6173234c8bed9544df36bc20d6ab3ccb773a2bb5f1b866c47(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fdcfcd26c0a47e79a72c0f4f7a36a14ee7bb84fb56e512d98375ad07c551981(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFileExtension],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3cd265371bdc3040355a53cd00b2ee6d32ddc5ea2ad5016ae76b873d5807ca9(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1da8517b98f8240656853d6dcff3ea26b881d59f7bd59bfadb46374ac266715(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0f44900d6b9b349a1179cef20bbb1bc031242f0c25ea6283c5fa421ce217ef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ac6d569ac2c87d234674f987fb124b52a9f6dcb4de19385c1abb369b735d408(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e830fb5b1e8cf2f933f07147978e942ed8b37baa540deba60ea63571913771a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7bb7dac6ab8e26564aef626d5cde46105909b241f09adf41581daaecb03f86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e07444b49394137e12098a05189494495567bdea451dc085548c86c68f3a4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c2422749fdbd4de28ee7ccc9d161ddc6422e4b51b892cb1e5e9f1230c7884d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899bb26562bd737bc1b8eb25637cb7182c2dc3ea9f57b5d3c50ab3ea51673384(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionFilename],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d187c71cd94d7a3576023cb065846a10e1b3aca881658f6d873eee8e8e569fae(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d6f34b2434f4528bdcf12969bd9ef93d580b3aa6575f98ecc5e3413194917f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5f0be4f42c7c2aad91008454dd7e0c7b15a0945a128da63f16cb93b2d5e29c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0ead77c8a03eaa4ef736f25bcf885a65ecb55889ae6bcf272a13db1f7ca7b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265532bb0f14aa0814e1e68e60685710d4c8306b2cc7f25fc63e6a84440fbee8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07c869e8dc389370100a7d3a0245c654eb98a62031021b2956ed981895d055a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b3909b71c893c3d73fdc50644ba369b6e7266997170fda1f687b2fd1778621(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96bba91c43a54460318deb2ae33c8e63636ffdc23929b173922334f508888f16(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fbf1d284eb3613a4c2859da1414e614bbd0d600771273c1ee50eac3a311d545(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f881e1833052509a41113b74bccc590fb8593ea82a392e4ff1f22cce9e766c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb2a8226cd49dd59837c77e20fc286b771d4aeea7f1033545ba53c69cbe1d81e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a82663cc93cb65e28723451b7e09be1fc3aef954709ccce158bc661919b5c33(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce1e66f3100382889fd6a70d6d18dc18a093446e6273319e815cc09d354cb0d(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1693c946c3a1314361c78b60cb003239353ea9c30f904d9da96ccd66df8c67(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d60cfc1ec8a349b569b7c060373874fce5d0acfd56c65d96cac492484084dc(
    *,
    close_xml: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    open_xml: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6b6f35fb12d41daa1d3fce40ff66bbd500ee30554be0b52ebc4ce671390acd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11d29542ebda1a094bcc34d4b4ee4e66d11140ca570aa409bf3f9fd9a70bfe2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131e7b6e55f4694f0882d152a85ddafb2685c904d00a33730b89f0be4bab70cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa86573ce3d3b75a1bdf5d9cb5eb6a7e9b2bd768c259faa8a88a9ec4dea51c57(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e67a45acda0b9391790301743e8211cd7beae784013c25286caafb6ce83578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85842e0df82b8d45c8fbfddfb9a99a2441caf40525f6645f016f31ff595398b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db8c76841dde3616b3a1315a87d1cc21cc98b9f5bb560be7ce128c8910c95e07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c8fb2c41ff3594bb094b1db2be736630354184d509a93e5420c802a342cbb7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70ee025c66f240d9c75bc3542adb11c99a28b9f078f6f8e14caeec95275674e0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e93d36526fba154e29c4da8f6e963bc530c8a8dcfb21a562af2cd650213025(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e556f0e931edb28a05b692f29115d4fcb237b8e33223b37cb53eb5d49f486c93(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5705981a0d20206ba17d368976e35d0bacaf2e9522841f65bf5a5fb5857c11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf273871945585a9cb6c8aca7e17101145562ae77d7140a88c14070329d109a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0794e4a10e8e6ec0ea81f9549bb93ef799dac15b2277d1fbbce491a6626b1492(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d2e640ff9fbab72bcdcc9026d11312fbbb856a9d98111112dcec3709ae36f62(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37807deff99b2e62a1f803471581b23e18534129a2a58f5979ca6c1d3edb1579(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b32f79033bd2381ed0d4c6337b0f4311cffe5690b08d5aa54ecdb70ea66e006(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5194655efb0f66ef209c361b7e0f49f25dd173c80bc360cfc2158ad95ea091d4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4deb06a387c516b09b17ac107eb2bd3effaddfa25a018deb35443313565196a8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef6ebb61d03cbe1fb31cbee3efdcdc41682987f0ecc3935d4bd9f4dc460b427a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9c1aa6dd74f5a9633f4aa0312f2ce5a6445a024486384d17abc23c86d2af87(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ab94f4b39e8db30d27e011d8114ccd1456f4145ef5deea05f36c8d1e6ef07e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a24913f05c513fc220fd3931be66c4e11ecf3988a718c483fc857f51b354407(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c414a98955eda8d8b0a59ba504c40a98e31d957b496936fc58149b7911f1c584(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa9a08abb341ba913d4da05fb716dcb4b63f4c587dfa363f0b294e407938b796(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79576b3533f80489f50eef35c1e7d6f02107ea7863aa36993b776397b6416b76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8ec4189092a2065f309ba855905cb39efc701df8fa1de4460116e5e6f343ba(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e260fcac8687beeddfe52a5bb1814c4558a39bdf48819a02f559232e8f7ed04f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8325d851305a48e255d31bc09b7d5732c61eae5a2bbfb37972f46503b61f1ec(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55b8ae4d88c1553bdfe405db9af404fe40632b1d42eb32350db4d9f6330ce7fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd5a57dc10391b53a0e277a7f579ed2a9f2f674bb83cecf3e3d630ba569f0a4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4b40dd1dd7826f08fdde7ebbbddb104d41239857f98a851a40c0985136b007(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c253a5d817fbd74ba8c2b69078e2b05f4c46762d30a1e9f82a00738a2daca8b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5476d761cb8fe38f992f94c7999952109b11e11d8e138201347d5085c02c7c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf06337e93871110886e8395ed3b615d7f8d699bc48fb89a2f5564b57c397db(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b37a20a72bca2a83ab434501bf23c8ae782b51e3fab07bc4256c3d80105c7db5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548867c879f0ad38401ac7786b634aad2b1ffc054cd8298643f217b623f1e603(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f92c4ca20a5052ceed33df1dacddddcf8428acd017254c83e512bd54797ece4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cffb4da88f0ea213ce1c523ecec6b92b0e6977e113e4f7851051c0aa58dc042(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[builtins.str] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_expression: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7574d5b252d54b635de8b2c763ad70afb9511424efb936af1a1f64e140e04a6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ae7c844783033256e2a26fad45e6fa6101731b3c1fb9e0e3ff82e73e44f9da1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4531bd697c43d98cead9bc216297ffb0db11fe233f4a735febc95469780ceee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a287019442d4b92d6723cc093d2eb178ea2b303fe40e0eb1a56ffa3f24f4b88(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bea56e7432af95e4db8812679b54074a058975d2746562d68b2f9e83fcd2d40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ead1b42009735b595f76f74354d37595e32c59d2460dcae904dffc41cf541f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219ce0a5931be36f7bdf7b00692736353fea3e4e1ae105a29d761db4a2319099(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac63268fc869ca9a688d874889cae688fbac59042e9087cbd452b207dddac698(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d18363519adb6b5ef049e69cea5f7aa7f16f8803d9ffd762f83ac47bab4fab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3f777746033de84d66f3cb0a94a23d63cc6f5af4c82ab4676fda0ce987ac5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1288e39b0f76b97bed2951834e1f28382c36f4a078aea2114e242612f6417f0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e9807b9acb98fbd0a16a846a15a0c630832507c1ec79aac8c6d3b1f5478839(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e03e24711bf94dbcf7022280f48737a17d491765f4837f2a1f220d4f9b2cdc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMatchVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a473b97667af34caaf59b06e2c6a928cc1b59e06c730f15a71f4971c550d1d8c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af386086c737e95b5fcfd9b79bbecdde9fc9e9e2804660beb117568c33cce1ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9af440f91b7dce19b1cf9ad464b331e8c6fb84f2fac7a163d76a1b82eeb72b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28aa411eb64ba3b0001f2cc3bdd1811fd1cb83a835cdba86a3d9c59930752345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6bc860f87403bb2612e2d032bf28d941165d49e31f95447ad823bcbf2526cf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f94546bca73b8b4e59b899d29030e538966f24e9fcf4c7935355a3f9ded0f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9308ed0a3bfb125e158f2d1e5dd02bf1b52f6f41065e9c5a1b9fcc42b889df0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12756d7a737e94d58724ccfe56d9401f078ccbd5c30d963cc9470bd6da9f26bf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionMetadataStage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be6ef807eb8661cfae29d61ab3de23773ea4897a7dac195786ac95c86b39c88(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00b1e433bfed74327055574326e1de288af50a271b55bbf894996abfc849fdc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e24a57f269017ebb3029a9f1815d9b1870ee90ae42f736ab4ee7d137308237(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e402426845193babc7f71e1647b8fa99d03aae8b50e9a58674ae5ddc571376d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97bebe84af1501b61b5c223d2d6c1f1f4de1e5a5f6ce3b9bd9f8b72520f21b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e20e157b4fa2b4d12df90708514c37de7bbaf50946ed5c194042b428d4add90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b910acbd2bbc4c1af78e689af6179d4ca06ba9f7b1b89eed5fba677faf7a4b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionOriginTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61881f384da0dfbb23f57848e09b78da97cbf982894325d9afeeb2cdaf9450e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ff4667e3645e7d778274f6d402176761c27f35b002e702405ed33e93b5e628(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Criterion]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054d66a6e8715dc33bf98440f56aca124433d18636ed5dd0e30eae35b91f54cd(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feb49d21b49f086712d61da78ee27db7fafe351aaacd85a8dd08eadc03530b14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de4b33ba5fc7cd4457dd997d6fb1541bc13263cedccff785f39feede5a3f555f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a35ba8d1f56190feff06ae9279127893352182bead8e5e6d0f2410e5b9a25ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22dfec3e13d601622df60d0124340819e01d2af99ed754dafd3dd6c1f6547af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f210e91e4c61059ffbced254d95952b496559b3955c9a7e6fb67df90419453c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e756cebc767732075b995f7d38422ef73c2a712dd21c0e16552806ae8f9e0558(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95e0ff3cf6e8211fc8c4eb9c8d4a4762cfc291becdd09f28843ebaa6afa9753(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7b5dfde2522b101e0a49670083707c07cec8d82b2502d0baf059980c69cad3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb2540d1702352c95fd9de2df7b76d3d489662fbadb560c6d993e701fc4b761(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionPath],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a22e89fb1bd53e764a6b868d4455ba5a0f8a5f78ac5b76f8ac7c4242322b733c(
    *,
    escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__420b850cd4a28acd75db3c5e1597037aa8e1843ed35b4a9c17c8e378ee6c84bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0cd692344ecf38d362e127d73cae7fb86ddccd49ebeac9b793c5ae0a0063efa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7815c7eb6603938d6c12c1aa7144f677ddb6396633232891f5f3f150a52d120a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a630c399e6cd002a781bc57bfabefdd004f7274fe4ac67df0d7a979b2720fa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a968952f34a8231d14978c5292b7a497ea8afbf7f2e358cca87491edd1261d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a73349c09d9135c52cf9409b2699e6a782d91ae818c5b04c4f5f2d883711ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8308b7ff6c2a10c13d5254477e26b404e1289a98f5e745d3d9f30d7eb4400737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76bd588fa7ac1d08327f8e994dcd28ae821894683088d3f46cc4990f3e3c0129(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95db58bff20053c1fe2db8b31354bfed734472b4aa25923fdc2d58751b333b2d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5bb71661ee19cae5bb93dc2701254df7bd3284acd8b60fa6512cb45b44a55c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e101125125eff16d1ba2c6d7f361971cc39a8d78e8fb6153d6c7fd2342fc9d64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2fad26c39c82260dfd9dad358658391012057fb8b9031156182f1f85b094d8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4524ec3ee0e42dda7b94033c6881e8117a3105eac86b62be293a55309bfbdc47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bed6f3a892bbaf1bfa28eca55cb068ec121cc39c78a1fc284c0e60357b17c934(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e95dd309ca60ce27e23d86bff98bbc517616716c3e03d9e734bcc585e41c5c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionQueryStringParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5a411f5c337b658dbc79312c675f2d97073a548d41183290b9f1f06bb16fa0e(
    *,
    bucket: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5d802be91756c1027a858a80ce4ed1f0c13e3218d06b1345f395f1dbbfe65e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5f94161c67b4e520ff16eb89ea6f2b17a7dea8facc91a2f79d14ea137f1fe9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb8da0297f7db4832e0eee72aabbac15827beef3fb6250da1b188931e78abe4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c5b8137295ec0fdbbbc6c5970f6dfc763816123fd6c5cc362527ccb34be42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a508af3829386d283239626c24d99c9ba4cf47964b4a5b6d6e54abf27d97945b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0889df582821dbfb60483dade84de563e8ad17a84631877751db924a65727a05(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRandom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f550a9c5543d65c63bf0d947e164547b47d0e23385bf058759830811293198(
    *,
    config_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa08b489acfe9467d2b3ec8ad55053c00198f7101e390377b3fe74206d1f519c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e580f94269eb25aa0934ae19c063f5a39d2e8b8ae6f5bb7f7c26eaf7840f1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e0dd52d12e876474b8ba0bbbf195015c5f9a552d7d05fcae068babbedf3ea00(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14b35dada666e759c4499ae68090c765649d21f4a536ff5589a74edeeb200217(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4770dd8f7feb2237d950818823e92510dd243ae821bfb63b8eff699037fbd5b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff23dbe23d9dcb4979de8d9f43c01126284e04bbf4d76e825fa858e5038842e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRecoveryConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960e23e7226f95e866fb25d1085174a26c0107ed3b67f07ce0c150ab06a57b50(
    *,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_string: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419d1a077572c729527e90e1197c2be604621a306a553c0f6420abf4e4258286(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7724b4f4285834dbfbbd645c492cced9eaddc7ed7bf7d0dbf39a036925b3bd5b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f00e3fd8bc8045abde48c4ec4535fcabbd1b1cec9e2131c122669d4f0c068f3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45079e567928938dfda25a16679df8772ed8830abbcd0ffbb57124f60b2f238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e0e596b39fb19c1335ebd6d126f157aa50af66d64650f91af032691e66d3d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a333de5f10c2c78a362c7c6ca9b5c53099f97e89f9bc8ed13703c1edbbb7de05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61e7c81f654389ce34669cfd3e93d8cdf18ab70ed72bbaaa272e0c9bf4dc088e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1b0bdab23bb484de2d413106ef52d1cee92814b7eb01a7545fd15b2d9bf6cd2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRegularExpression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6655346baf32cacc313bf397c21da5066c945801b910b19f67115caa777b62b3(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__770c451d508d9a0c37528bc9e712a731db4fb1541bac32e21c12edf92b3f5653(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d863529fec9c65e7b7d21a91f2954b50340af4a42c11bb4c950e02be8cfff0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a79202050b2adbf02bf3b664352abb74e80ebdd9bcb1815707812462cd8c49f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9b08914a86435b9e7500f722492e2e23a7c3da287e233919126e757dd11fc0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bec8ac5b8da123e0ecbfa3c78a1aa41440e0d8dfd2e9adf9bf020c10d5fb3d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f7d7f7eab76a0b7c8161ee5f0559fd2fb9564a8d62c8dd21538fa86ff2332c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1503c9124d78ea9d0452fe586cc078ff05f6b05c2d0bf6f532e8c8c539c44d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a30cb9a395ea421dffbb59828ffee1b56312b29eb22033549020a413770538(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fafaa5d39b64222b03290a21f746c94963a9682c0afe7470507af28efe84da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12037c21af458c321a429fc4a972f07359aca924e2b397559bec25a56d3815a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad22867ae98a1671bc5da5d735ce6e0ce92e81a265ab4e44c85d96428fa27a4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323e55df731e0fecadd061aea54474251433a723a30c37f1426aa7d2bad10974(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b326684dc43fbb72f9f1183db3dccb74831e02bbf0bb538d304e12e9d8f877c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b90d028bcaf716ad2f86838a322b252ec5cc9be23525e5ebd4b224a25755c52(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9e6f4ef509afd38f5da3e520df6b4d127ade619ca0820f208161e4041701d1(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcfe9b26a34632a64af81ff18d90dbdb36a1e27b067fca36dce4abb39fbb1e72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3ee3e12cc01156d7f6b7923f1bd15dfb6ebb3ec98505b751405936f7706efd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c91874d87f6411226b98e7252b37455682269f0b113bf4457d6d8a9e05be5f6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21873a53c2892b8409b150fde007e2ab1f26d7dc7ce057df399eb2c16038bac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6c15d78d7c5624b1e7f6c50b31436aae3e6144f153a631009cf7c627a36c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e151ee46827c0fb267dda2370071eaefdcbada2940581cb8c91f13c885c9e8b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5797529a9601cf7cceddb45e02ce44ed6c70c5f8da66285e02e6e70cacd02af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a242651c6e0d8728b411fa3a5ba49add16b87dcda13d50b21231024045310b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4673a57ccee9badcbb272422eafce31ca664f31dbd02424102b1dab78e5015a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89d42e28ab6e105eda6278655147bda290dbe08171464b73df69d201e9068dc(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a39e283ebbb347477761234330cf731c0bfb50c1da4f09d0e4fc239f78800e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003f439cd8cdee769fcb58df9c3f76010973e06bd08c99b3fe1fde43e4a2c89d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad16694120c9e5e83b793d3c36f8ed93f612eded29b163d04496eb948f556faf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b2bb7af22ad4b12bd8a82950e9198c803cafac570517f3f178c60d9bf5ba01(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2d80e8b0f5dca0ed98718da11f3ddecd810d2b91453dd7f1b854439248642c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa67b6ba11f63494b303a5d951a0b9937db90f76dfc60480cf79a876018399b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878b9ef9ea3f0d52ed1c30cefdfdc478b0985d56e8f35e59e1ad308bbb82f832(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c40f9cba48bfbda5ba9c818f0c70deab5584dcbeec324a0a81c7002540ad5fec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bff69c7ca9e6f62d94ff7f3bda99edfb25c300e1e76fd50d05ac1c00f074a72(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0a1523a789ac125babbfe02beee60aa2bcd8f0ac22bac7f6e956694b5e9091(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec897f0172ca3891d7f3a400b4395824d0a720c7ded46787432cf9691892b79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b65b715fe3d21ddcf0e89a690fb6499d2a0055992f30b80707583d563aa670(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28d9829898e21a44bdb7e062ba19c97d2bae2e5be4536ad5e4e246e8697038e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ae2cb0f90fab33d2b8434a212defa0583a5791b247c2a36e2390abcd470445(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9db4fa49d933043128ebc26814d969ab66f1b6b86acb163bdf7ef4b0ec96c2a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f41385c8978686e124d1e5442c23d6093c979efb58a157cddca7ea67983d000(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097380890d6a7801deca907c329991c72d51e2b3a2a5b98e2f505cee5fb7445e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1178b0bb2c72164925c09fef55f4f097e28fc7905638a987d912913fc11c9b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec784ee3019559a960a351a01af0ca77ca850d60bcbdad60a6ef278e9ffa6a33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6d19f094651da053e99ba2d0a42289e8fd1de70105345e8661331f400e38a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7644ca02ac9860747264fc3b6923d9e7c87337ef176c5f9c3152a21d4c25379b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157f82f884f3b30f77bfbc0e61ebd3c7aa73626ee9a0ce73ec23bdc3f620f205(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a6f7a2516d9f12e79f67d10c2862269ca43e9068de14beace166bb7e1c51739(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c28f4c79a82a8e9ea4e22ff921d8fb155e8350eb74ea34eaa948a57a6e6628(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionRequestType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7385e4a8a9d944cfbb7cca9e3d466177f6c8edebf8de1bd1bec1ea6a631be4b9(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1441aace23c1a651fde75e6c018573c2a9acebecd22a2c159d45e03c87a6d494(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2ebc14aeff103784ba3973928fea0d521fa7133f7b24be0d2257c42a499237(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9ec755a667e73d77b09d8c9ad6a5b53c64871404f71558d69650ea91453654(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ae711e098f28af60815d62558653da5877c9cf6c21eb9dd024f294c75eddc4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e856c3d651cfddedc381f31aed801579e956e6f205449a554e4e14c5eaac13(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7dfd34419ff1173d14074a3b9e0090c3854a40041ff1557f984227ff090b85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab77659363a704cc3d70be45f81770539c2db417d89bbda42ff0f86c6d116fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970e0b703ad088e333951fcfb265a3d1602467623d56f38d6d43accba0fe358a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd84af6bca44157450f5ffce20951f7dabb9e95bfddb0b99c71853302cabbb06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef7eb71cf9fff123a6d0ab05fe1fbd1dca2aad551ec909f001d0ed728352e8a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b8ab41eb362a59e8da5adf0824b23797ce019e2e67b2db0411a3b6e384652f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee5ade175e513e11f131ab03220cac35f95806d50980b49eeff6f9a74a7a86a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b0d16751d4d2309fa375fa93ff8ae13a9d4f3b6ffc3d5f638c6dc2500caff1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca4a8346dc34bd50e003159a9bb2a871665c0a09209ee8d351666d8b610c38d(
    *,
    apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    begin_date: typing.Optional[builtins.str] = None,
    end_date: typing.Optional[builtins.str] = None,
    lasting_date: typing.Optional[builtins.str] = None,
    lasting_duration: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    repeat_begin_date: typing.Optional[builtins.str] = None,
    repeat_duration: typing.Optional[builtins.str] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73c9fbc3cc00aadf7eaba187018ac8991f931c6d06d90795a1f73950bc7ba0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd0f2f31602f9a3fcdb6798b28818886b87c363dfb404274a734c0bc190d6ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b898132772b2e7a56a16bbcca3ad80299e19d1a1f5ccc51f5ee735ec2153f4a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f198371f0b574333ad673705a036e42aa787efca95e58453f9dd28031cbc33a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec8f78eee4160aaf8e4078a5a82c814ebcb9a2e539e55eddb749e77548af767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb92cb9071b36dfb07ebc328751cbfdecde8395efb353890c2c6e391f375109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9288c327b34ea51b01688c2248da25d759006a6ca5a94dcf41b2544c2f1ea174(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd796028353b4adaef02a823a8cbaf23bbeba1dc75cf277cb13e2481bab62190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76b53fe5942e0219dc8f53dd4cfbd35dc9bf47f1e54d5ee871e4207db263b9eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72961903477e5f8f2aef489962304dcc1624640f034e175ba6d871d7aab451fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18211868cb5df63c2eff7c05abd5f14f7b237ef24cd023019c8d79ff9de5463c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1ee479e9a68c44a801e9de5d13039f5c63a28257e349f4df175fe56cab1331(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647e75d95e11921141b4234db99f1ab344c42cce0997e35c7e7e0bdc72886cfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c018b2474807c466ff303dff3fad093b388ef1d019380fc79a3bf60d5b63c5d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTime],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2f48f218077ec177c4b4ada1a5d40f3ad0ef0648cd3308642dabc567dbaa6e5(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5284337e192d8b87b3c89e61211d71260766fed19f56128863a10631d0fa5039(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa5e47bfd7da0de598ba4d4cfb8f515e0c35aeaae0766c7b66a4ce6dc89febd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90cfe64fe062248735df28b239792f49d7bfb54f5082d04979d460efd30a1d3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473e3262e46392679529d72d8aff4c202837043ff6441e394d0ededb5af3ceb2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6cf600a08064d6f768758c08ec97a332658cec080419ddfbf23e2023a706a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec91aef52ea44cd73ecba97c5f4a474ccca540f9baf03b9697ffd02fd9f04c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e59ea25fdadb27767b36da3a9f9192481abafd02dacec5fcf6a8d9af6b39a59(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524aec6d16ee585ade63b81b2a2cf88a68f69c75c0709a7467a0140635c538ab(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2aa0f8f7dcade6333dc8b7ac8732de7b1366c88410fca24b57a731e91b7798(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900794168f0765a314b32807438e4c79903fe6733a9c8724ac21507b8a67d0e6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfe3bc49e05030325106f1bd280fd311f4404822d472089e2c47e240f0bdcb8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d520e5746451f7043481605cac6599a0767d8418cd2583a1f124d1668efdf793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5affe4bb39a2a61adbf0602a5aefc26bc899b8c62ae0828ba309ac3967206f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5465ca2645818b6b8c4770f96d0d16dd452da6990549fb0c9eca3f380a1ebcd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc03ca6556f9f283fd1e8856eb63b743a17cc8c5afd9024d65e8087b5a0aee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55907749617cdf574fd8a4cb45984988ce7a342a99af9e07f6978f01776c32a0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d1c1afa4994ace94c02f80fbb4a3cb944bbd6b2969577af9d10b946fca701b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserAgent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9346f00288f1c1db0add7d0aa8a2b884033f4dbae585040a07d226765d94e22(
    *,
    check_ips: typing.Optional[builtins.str] = None,
    continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69a475990acce47e94b92601edbd09a394b39e392a3faa66fe8b0ffcfa38c13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43a91224a0691b71cbfdabd9c849a96cc229e10914b0a3d2c49b916372c04947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca8673c591131642e558ae790450d520eb7ff8335dacbb54890721f6c7939fb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f70b0331d9853c2bc0c264cd306b91f303aa3a3cc57c8a6669d73a6eabe09f09(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f30500bd79c05b610fef2661cedb5d34d228df03395b60cdd70f1f96e8fb41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78c18acd0d4e016229861f38969785e046d5c7298dcdb30062590117208a8713(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0ce224242e1aa9fcbe36f74b026ee9ba82177eabfb01f30f610bef4667f64e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd0fc85c5423b38ff3323714c4ea03b9626c5a9fb30b90e852bc570a16ddb44c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65e270402acf34dfee13f714a27c83eeb2fd6461bd095bbb830c3faab92f139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5691b0f4d6a67c4d3c1ea4ef4d167e172e183280b134bebf77125083367932(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de51aca9f49c53fe17ffec0f4052be7799bede96c2fabeb1e1968b71cdb568d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69d30be53daf8284fa578c8ee643a52f500ae5fb7c15981685ba872582d40ce(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c938e198df33c4ff5da11de145ea3fe3727d1f921c75ecbb6522b86ad0a2c6f8(
    *,
    bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    check_ips: typing.Optional[builtins.str] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909ab40565b7caf0d66827c9196fb4ed09344aff4c349ed9ce7212ede48d6a9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e10f374736e9b7aa6ce619f532431398ea6b87b10d6d0015fbd3bcafcd9e4d8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b0de7518e2b0d4eca57a9e433458d829708110b2acdb94187ba712169fa15e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdfc6862e99ecc44d1c5b71c25db2019f5a25aae495bbbedf6bf9cea7e73aca9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00656c97cdfae31fecee9e296d5624b6e03d86e2296a6f9665d35091cb72548(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88efa08b9f5e49f25c41e9f3bd5202d2b02a9e60f38a27e3a97c01738b212a3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749f3541bba7905c8c3604e19c22235750f7feab4b7b94ce0fd0407315843099(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e43b4d7a25803a64424581509247199247be83f8ab3028d3081cc8c3e03c06(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37104082d11da3b0672fcff8ece96bacdb3d85b200ec8530028cbc006cf14d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d04b3e0f77e55c0a614c6d7ab4f1d28048da3d143507c592cd34bfbb04dde2a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__388a4011724077cf9ff99cd560f11dec7563f7262e149fe829cd15609222c49c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b563deb86b62c9dc0ca8329e839460a7cfe71b043243c63020811d7846c565b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionUserNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb2377da711fb0ff5a7d4c2c402e069d6a69bddc0904fffea67b2ebfcc22f58(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba557d89d8f6344270ffa5012005bdf6d444f4ad1a9e42fb9b5f8fe17654942a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b398d51ea6ecad6f2486adbeb1e3c466ac3defb189c301884b2b2d32c3c3855c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fdc6fc2a279abf334d8b5c4dca94c721106c9c29a48ef740693152a53c7357(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e200121985249807d6904a1b7b950b38ec7b242140246599f3562491158ea09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8138f9e99373886d27256a6b5db6f7e84e1453488bfed248982d23dd6fb286a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e0aa795113c3057ff9c9aecc8b74d0337af4c216b836dc2bb92372c9d7ae6d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56fce9e20b6c931f76e6a62118e0b47b60086098323325c3a4cf2625117425bc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVariableError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf5f9905b162cf12d2ab16d04c6a03c7d5160040161fe3da467df2e77cd0750(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d62c286ec70a3943e3fc6afa2ff1c2d048d49e99efee186179c0e0d3729e2ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec2d63fafac20df3da8e76248561d26a54f03a245197c84fe61deda0894c47a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5761647ab4e66cb69276e63798a3d6b62bd20cc40fffe5073bbca3eee5f32401(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e994d377f2f3161b952452ca868632d99898df938471af0e9b57f4565601511(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9dcc36726fc6eec3bc2ceca48c4b62f53caf3011ddb914963101013825db591(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c48ef8ccfde96be30273c61b245ea64e49e2f5840ca48049e009fca792341d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7242705ebcca93af79884a6b69b154fe26373366d1da68304acc8bd0d871d2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVirtualWaitingRoomRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725a4a0e0b072402946755945841cc2e170f8665e0d672da9a9f37732704288b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907d8972fc809cfe8f291f1abd8d7b11159e312568c606d55cf6f49f09496955(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__483da73d6ed85d80f9aa6bef40d1169fd5f0432848dc983f3c8a8533c7c6f4a2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f5191f68bce2be096ff6f866967191c6c760fbcc7870bacba421a2feaa08d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b369b36cf4e1d5175b7a56e76f541c45e41e6bd1c78e96c7158896ea4bf9e8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__759652281d86a203a1f03309ea94d728e90f78a1b4c9df9720144946798451bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8aa8ad324e4bfa61b7fe04c54af0870fba00a7f3951ebc5a6c1c2d42a1ccfd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10c2983bb2d7f28942652b5647191b86dc258803d1a6ae3d85f871c93f66305a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CriterionVisitorPrioritizationRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d7e3a27dd594527577e65656b8f113801ca4c861ded6bc3bc23d2cfb393e0e(
    *,
    name: typing.Optional[builtins.str] = None,
    override_id: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08fff4b9d75c11198a69e0f0ce7034937d16db420ca35bebab745cf5c63f43f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c7f1dea52f065fdefb861449c56a512bdc3b19f9a39dbbb9cfee743bef81fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a9c3128336492e29040fef1c1f06c0fcb52fff0df407f765bd4fdb281e4691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0314f2db5fe6a639206610373263b56d13a20b468174e1450daa34758e86eacf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105CustomOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88cd19be3c27a155bdb74333eb34807f41e08d67b743c1100e586f5d019b8988(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c59cc511a13f21ae5485a2ed57c84f0e7ad681e1ef00a30390985109e3667db(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Behavior, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881e820e8032c6ee17defe1d0a03a47d39b2075ee3b31d96c5b30edaf64b4031(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Criterion, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64049ba73024a85ba4428dbaa6fe198c1d4f4aaea585199354055e26aa0dece1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230105Variable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f44d17485dd67179f8df22b45013c494a8be45a6038007618eb99c2d005eb31d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12cf64a17136e116ae8538f448ebd573b245d472f61afa584e23b69970137c5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9b0e4a608edffc2a57f9b6ab0cc2e1494d7bd528ab5c40885fbcf60007b54b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5c9fa3df9e67cd728ce7589a3aa5d8995ee4b5de5da330c48f1dec687ca8eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a699b2cbfa4f1ecee3e5f2a305fbdf6551445afdc458e4d0dc580a29118c92a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cd15b457e0348c3463f369e94dcdd9d9a7338072a7c5c969c1b6fab11f70164(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e4f5bc1a548d249a34a09b1e27281f2c518bd39034c84eab2c47811e8105c67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca38d639cbdce10c5879f229907ff86c4bdd07b9cbe49fbe8d38951f6aa889f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50be8ea351a4539efd5a6df849d6557be8cf503a2dbb55c00764fec10f09270(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b290721c63fb3b5d345c5528f768570db62850710aae3fbb4eb77fdb062470b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e8922b7afb221cf42e258edb171bb90e86e53a8ebda77aef3eaf6b824a1a30(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230105],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48709c270061d1fedcdc08737e493cfc641386d8b517961b1aa2b40d0893f5c8(
    *,
    description: builtins.str,
    hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    name: builtins.str,
    sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea99331d7c1ae9de9f81fa8a20537511acab228b7bad9d2e28a3a61d5ebf26b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3123b1d570928e1df4c3110d05f53463e4728066c67dc56079388af4f1bdfc2b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc39f08aaad96ac5b2bc894343b86ad9b8212860f20690e2cf6474cbfcc2372(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea85941425e23e4d8d856c1918654ef181dd7d86a1b37f8a0eeacabbbecbf29e(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da97c7c8d0ee649cbe4ababe1a01cbeb3d7cb753d78937389942708ebf750cb6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1b2d0b153ced0d00a83b3f18f9878c0bbdd1bb5a686eacc6b25ef7199c2c9b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230105Variable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2d49766fdd3db266e0361aa55834ee8a0894abadd5eff70d3129c3ba2dcb3c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7b823d5ae3ccada7019c5fcbca19368b388bebc6db61f2e0fd84f4e3cce651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02c5121b6b0a116f10f8f47a7b1783c07d328323052ab7fccd169ce206b4474(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa5df6ecca5cedea5023728ddc8a639bb3198a23ab5d472d957775499c49c41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a374bd64efa40d25ed563519046adc8f5d2900f1233da5c97f4346df4d3be02f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d0716d64c24e637434e46cd71174be7093d49b5f1d9c0082519eac78a47190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c05523c78d8f9a8a0bd76e2d50f708f71f5493b92ba9469ea14e057d83b90f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230105Variable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2856fdd58b676cbbf40aca62bf4f9bdf2151e8209dfc096548b6ca70b4eaf1(
    *,
    name: builtins.str,
    advanced_override: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior, typing.Dict[builtins.str, typing.Any]]]]] = None,
    children: typing.Optional[typing.Sequence[builtins.str]] = None,
    comments: typing.Optional[builtins.str] = None,
    criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    criteria_must_satisfy: typing.Optional[builtins.str] = None,
    criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_link: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Variable, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16cea767c4cc9dd6df0e36918d1a784ec2beb36706a07fc7e0ecb22d57ad85c7(
    *,
    adaptive_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    adaptive_image_compression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression, typing.Dict[builtins.str, typing.Any]]] = None,
    ad_scaler_circuit_breaker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker, typing.Dict[builtins.str, typing.Any]]] = None,
    advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    aggregated_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag, typing.Dict[builtins.str, typing.Any]]] = None,
    all_http_in_cache_hierarchy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_cloudlets_origins: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_delete: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_cache_key_sharing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_downgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_options: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_patch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_put: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_transfer_encoding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding, typing.Dict[builtins.str, typing.Any]]] = None,
    alt_svc_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    api_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    application_load_balancer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer, typing.Dict[builtins.str, typing.Any]]] = None,
    audience_segmentation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation, typing.Dict[builtins.str, typing.Any]]] = None,
    auto_domain_validation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation, typing.Dict[builtins.str, typing.Any]]] = None,
    base_directory: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory, typing.Dict[builtins.str, typing.Any]]] = None,
    boss_beaconing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing, typing.Dict[builtins.str, typing.Any]]] = None,
    breadcrumbs: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs, typing.Dict[builtins.str, typing.Any]]] = None,
    break_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    brotli: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_ignore_case: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_query_params: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag_visible: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible, typing.Dict[builtins.str, typing.Any]]] = None,
    caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    central_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    chase_redirects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects, typing.Dict[builtins.str, typing.Any]]] = None,
    client_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_interconnects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    common_media_client_data: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData, typing.Dict[builtins.str, typing.Any]]] = None,
    conditional_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    construct_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_amd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_dd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_large_file: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_live: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_vod: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod, typing.Dict[builtins.str, typing.Any]]] = None,
    content_pre_position: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition, typing.Dict[builtins.str, typing.Any]]] = None,
    content_targeting_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    cors_support: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    custom_behavior: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior, typing.Dict[builtins.str, typing.Any]]] = None,
    datastream: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_hmac_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_regex_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_substring_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_variable_extractor: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_default_authz_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_dev_relations: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_real_time_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    delivery_receipt: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_direct_failover_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_async_refresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_prefresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    downgrade_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    download_complete_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    download_notification: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification, typing.Dict[builtins.str, typing.Any]]] = None,
    downstream_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_web_content: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_bulk_upload: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_database: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_dataset: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_object_key: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_connect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_data_center: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_origin_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_redirector: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_scape: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_side_includes: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_worker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_akamai_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_proxy_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    epd_forward_header_enrichment: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment, typing.Dict[builtins.str, typing.Any]]] = None,
    fail_action: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction, typing.Dict[builtins.str, typing.Any]]] = None,
    failover_bot_manager_feature_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    fast_invalidate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing_plus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus, typing.Dict[builtins.str, typing.Any]]] = None,
    forward_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    g2_oheader: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader, typing.Dict[builtins.str, typing.Any]]] = None,
    global_request_number: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber, typing.Dict[builtins.str, typing.Any]]] = None,
    graphql_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    gzip_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    hd_data_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    health_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    hsaf_eip_binding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding, typing.Dict[builtins.str, typing.Any]]] = None,
    http2: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2, typing.Dict[builtins.str, typing.Any]]] = None,
    http3: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3, typing.Dict[builtins.str, typing.Any]]] = None,
    http_strict_transport_security: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity, typing.Dict[builtins.str, typing.Any]]] = None,
    http_to_https_upgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade, typing.Dict[builtins.str, typing.Any]]] = None,
    image_and_video_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager_video: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo, typing.Dict[builtins.str, typing.Any]]] = None,
    im_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    include: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude, typing.Dict[builtins.str, typing.Any]]] = None,
    instant: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant, typing.Dict[builtins.str, typing.Any]]] = None,
    instant_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    limit_bit_rate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate, typing.Dict[builtins.str, typing.Any]]] = None,
    log_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_personalization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_rerouting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting, typing.Dict[builtins.str, typing.Any]]] = None,
    manual_server_push: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration_quic_optout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout, typing.Dict[builtins.str, typing.Any]]] = None,
    media_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient, typing.Dict[builtins.str, typing.Any]]] = None,
    media_file_retrieval_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    media_origin_failover: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    mobile_sdk_performance: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_via_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    m_pulse: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse, typing.Dict[builtins.str, typing.Any]]] = None,
    origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics_wsd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_ip_acl: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_client_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    personally_identifiable_information: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation, typing.Dict[builtins.str, typing.Any]]] = None,
    phased_release: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease, typing.Dict[builtins.str, typing.Any]]] = None,
    preconnect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_content_delivery: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_prefetching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetchable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable, typing.Dict[builtins.str, typing.Any]]] = None,
    prefresh_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache, typing.Dict[builtins.str, typing.Any]]] = None,
    quality: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality, typing.Dict[builtins.str, typing.Any]]] = None,
    quic_beta: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta, typing.Dict[builtins.str, typing.Any]]] = None,
    random_seek: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek, typing.Dict[builtins.str, typing.Any]]] = None,
    rapid: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid, typing.Dict[builtins.str, typing.Any]]] = None,
    read_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    real_time_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    real_user_monitoring: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring, typing.Dict[builtins.str, typing.Any]]] = None,
    redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    redirectplus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus, typing.Dict[builtins.str, typing.Any]]] = None,
    referer_checking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_query_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_vary: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary, typing.Dict[builtins.str, typing.Any]]] = None,
    report: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport, typing.Dict[builtins.str, typing.Any]]] = None,
    request_control: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer_extended_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    response_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    restrict_object_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    return_cache_status: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus, typing.Dict[builtins.str, typing.Any]]] = None,
    rewrite_url: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl, typing.Dict[builtins.str, typing.Any]]] = None,
    rum_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    saas_definitions: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    save_post_dca_processing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing, typing.Dict[builtins.str, typing.Any]]] = None,
    schedule_invalidation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation, typing.Dict[builtins.str, typing.Any]]] = None,
    script_management: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_content_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_streaming_prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    set_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    simulate_error_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode, typing.Dict[builtins.str, typing.Any]]] = None,
    site_shield: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    strict_header_parsing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing, typing.Dict[builtins.str, typing.Any]]] = None,
    sub_customer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer, typing.Dict[builtins.str, typing.Any]]] = None,
    sure_route: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute, typing.Dict[builtins.str, typing.Any]]] = None,
    tcp_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    tea_leaf: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_customization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization, typing.Dict[builtins.str, typing.Any]]] = None,
    timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    uid_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    validate_entity_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token_for_dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo_standalone: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone, typing.Dict[builtins.str, typing.Any]]] = None,
    watermarking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking, typing.Dict[builtins.str, typing.Any]]] = None,
    web_application_firewall: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall, typing.Dict[builtins.str, typing.Any]]] = None,
    webdav: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav, typing.Dict[builtins.str, typing.Any]]] = None,
    web_sockets: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bcaa2cc213a73423a6937fb28d2135b96939607050206dd5546f5197abbe6f1(
    *,
    fallback_action_response_code_based: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_codes: typing.Optional[builtins.str] = None,
    response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_delay_threshold: typing.Optional[builtins.str] = None,
    return_error_response_code_based: typing.Optional[builtins.str] = None,
    specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84bf687efd8ddc3674048faf7918fe133a163b0edbae0b20f264b3ddafae8721(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c811bfaf7f5d0be7d8017bddfdf4a067d4fb613790b4302fa27b621751cab825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26cc132fdaef04297a22da25a3adedb177fafad2737fc32735727b750950c22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd89929ac4401b1fa25dfda5b358aab47863ce9a290a56a2034fa5a0f82704b4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163a6e5be8b707d2be495f54391e7235a3fcfda5bf38e5a98db2af99dba2c4c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__164a11551191cf9ba30819e6e27a83326b0d0199f665bfa5fe7cdd07c2e447a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469016f202b37407aeb0832833973384f5eec26b7ccf94ac2ab6f618a60f3058(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b102e6ce0d9381bd4d3a7928c7dcd22427a1f2b94217c6a2548fbf7bceec605(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b83a5ab42508a71a4998994633c9c74a9a45af03a1fea262457b91e0b568a04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e393b246e9b95ac64a6ca2e00dc17d1ad4dc7593a9d7b02d54104b93764e9b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8832307dd4f504f38cf8b46cb1b639a8cd9efaeeacb4f82fd806b5c6aa6d0ad8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__363e2d014f0ad8bfb847558bf9c7827b890991d285da56c8c45c8f380d75f113(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdScalerCircuitBreaker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b2c127c3fbf6713bb3543b53c99a51fe46107ea5a84ce6b045d8e1a17011c2(
    *,
    ab_logic: typing.Optional[builtins.str] = None,
    ab_testing: typing.Optional[builtins.str] = None,
    compression: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    source: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_brotli: typing.Optional[builtins.str] = None,
    title_http2_server_push: typing.Optional[builtins.str] = None,
    title_preconnect: typing.Optional[builtins.str] = None,
    title_preload: typing.Optional[builtins.str] = None,
    title_ro: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecaf9b13eb9d75d25ef86af64c75d2f6e7d4cdda0c77f4b0298b1a7b585fc4c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678851da0611bd692c18cd27711eba4b3537b42ae3e3df2c39a0fd8d34cb542a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7632b5e8cc08325e7adce6cb8d6e3209aa15df46f2c9241ffe511bde6bda651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d389882eab035bd37814ba71c5b4acc05404125a0625425c327ca16d7b1792b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f276c5b31b8876c2e031184fa1a4769371af6d22bf78396eada9ea3dbd9ec38b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89fc1aee09345a9c7a0d06730e060ecf729e50eec15db1657cd47e2e11d22707(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b3f2387ec5737f5d7ebcacefa3902667d0e0773b047662a0c5ee9fda4e2178(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f11ca7a9745a0061631ad88100e043043e53c0a8a736940a08ee4640dd0480a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9132557d9dea897a4c109b9ec3b900f31edc62bd6a981332d4061b8b2f1d48(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c0eedd531b3ab403e090f509fb99e2b7ec8a8f71ca57c82a3ab3b1d29bc6ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e880c8afc95b110e44dcb983bcb042366d73439a6443f4773304730331eddc19(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180398f36b0c1e8a7b0b7e6f1888913510829f4de45801b166fc6dc6f4157f34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1b79039eb3ef399c1888728ae5c696bb6058aa968713ad993dcfcc7a490806e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__245edf8adcb256f1ffd807f009298a2b8cc8baefb4165c027dc3a930532ec9f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b62faf910e2f9d6a8af7b135b750603d8d45bb6ac5ac13777e1fed812ac32d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcd0d53c5c6d02955284421d5775e61326c4a440081e10ea736a2158bd76114(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b70c3455d011da4fd52c297a404f480b2b077b36a3e97c8c229b16d1850243(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ec06585677d9cf589925a97b8083dba26753fb0d6e07703d6ca6cbd871d37bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce178c1b48697cfce38f7628f948353d23662072d3f40ab97f9c561b021d8ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59f803b8f64de8e64aaea6b5eb9e6d37ddda4a3f002dbde67fa7d2c3c107ce4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086d712fb0ae90845f625ade6267b7eaf07f9e9e8c130986ea8cb4ac4faaa77e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4e6ae94c584bb5182612c6cfdabedabc6ec29ef7332b9299c0d60a15f781dc(
    *,
    compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier1_standard_compression_method: typing.Optional[builtins.str] = None,
    tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier2_standard_compression_method: typing.Optional[builtins.str] = None,
    tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier3_standard_compression_method: typing.Optional[builtins.str] = None,
    tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
    title_aic_mobile: typing.Optional[builtins.str] = None,
    title_aic_nonmobile: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b9d6a3af16dcc07104d6653d12a99f411f96dff81cf791aacbb7b5d514f07d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed0a3d1f4fc187133359f0a75fef68f8b100991376b623a4025553259a7b0858(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecea5bc758843df4626faff3bda68c191c9dbf1a8cd0e68bfd5177cf459b8958(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379578028c8882c82746a0d2767146c5c6538626909888673df633146c085ad3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb43116202f39e229121eee640ac4fde48bdf35bf9955bba2c75027127fce828(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e828b7776f1a9a0128594350af11a1d79abf327ed4d691b4ce4857bebc2961cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec0ea461b720195643fd8315d988e96fc20f7145acf2489b4e86959fb59eb93(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4fbe68c9b8786fced3d37274cc486febd873ff385275ec1370daadf74f935a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4dec3cd4f02d73571977ddb81541fc1ae1f43601cc418c4c0669e9ac5952ee(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16eef482367d533cd8d736398975182f2d2f8767b6628096d1d6312964352eb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3928576ab6d73cbd884c01feacc3bd0bfcc7c9516a4e34d6bce9067ee4a97de8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e63b2b7ffbaa6a43836c62eca75d728fc3e47454271a95d5f284e4ed78db0a1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d15ebe8c8e00c92047f4f65361c2f1cfaa5033084182ed26e0c8b09aa2e90910(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed100ffe39941c38856dbd7b733c3d9db7a10198efe1ae542955de1f156dffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ab45d8e60cafbad5a1715c35478f0e751e07aeeb774c60715d625141db564f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1317f50f5d9a2229e89b0d91b20135431ca63f262eda1799e9067b1a926c80f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c679ff8af1e86420bed93eabd38db3043a72ceb94979b65fd380d98bb03ab6d8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f979c0de3498a895eb230b5917b791bc95d0143249d6832302004445a5dd92c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3996a0b6568a64157ee6bb2acd9e76b0eb176dc3732e40a2094fc9b53d3368ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3555a7d4dd6bd1bb22d956e5cd87a060b5e531f06b549e32ab80b67105f37463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949dfba40d32acd63c32ea6d2fa0015a4611e8d52a7ce5bcc5aaec2e3893d978(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdaptiveImageCompression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e22d1a0d5cb926dbc37a696f05c2177e11ba6bb5772706b51c06824560d7d3c(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9e3882ec153328bade9fedf99c570f48d1926c1bb1734c010a2e2663e476f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f368b86ad1a662b1e3f26a731f2514b71fde0bc382ceb84465298aadb2026fcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c5e705695b4ac1d954d43f40d7e1366760ac71ac716912f7ee6b3f511e820c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e5a84cbcc0de84ea8b62e46222deb93b8d5b8caa7ce01ba54ded7370602a94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f31caebcb3ef3c178281f4bc9d22ae37ff7ff8bb67780f096eceb6acf12c48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__402d25d636af826d3e19344bc9e5095c7e97295fd5862d3e176d22449beb5059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__392b9146061a2f2958592ad89fa75d4b0073c838fb6dbfd9ace3de03cee2bb26(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d77a2975f707273b4c558214cf3b1b18e140dd10be18f780b08f7aa51f5485d(
    *,
    attribute1: typing.Optional[builtins.str] = None,
    attribute2: typing.Optional[builtins.str] = None,
    attribute3: typing.Optional[builtins.str] = None,
    attribute4: typing.Optional[builtins.str] = None,
    attributes_count: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    report_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365877f4ec9dcc802156df9fb46d2e99e9fb20097259aaa028c76b69d42408ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecd3472963fa02947c862ffc5181002989e1d9bd81de89a14236dcf1b054f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d85cad771c2a4d031f76fd72f87a04947b387134b012be10f9fffb0cd76557f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8640f45cdb58be14965e97b5fdfa7b89e2ae62669b1bdf8e8bcccbbc2f1e86f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa85400ae0d6496e637e1801d659cbcd52cdf36567657bc7e6b885bc79882fa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05e8c4c2944218c7d0406ffeb5195b9d68de46f74c027ec1dc013b360ea5ca99(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9ba399272411d7bd559436319695081fd10d0301331c6d62379d8cda5aa83ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453085787ec0935fa3c87fb5066efd78df63a8484aec79e1ed81ccc2b6a0fcc3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d392ff1d0d15c03c7da72626211b688e184945f6a3d61de0f53b8bdaf00949(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__920081269a5e139f24e0199833a9699a25d1f89a786316b2b3f9bf5d1ed62997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469ba3561a05305b10e778f074bead2d45a7a45a47880b3950bf8ffa253ea51e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42866da02ad26f3588492abcd20bb0906d177eb30137d887110b9993d8739384(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAggregatedReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c5ed5aa79d3ac6fcf5109f3c89f05db81ba6c84124aedbd16be8f7365d12a19(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b357e8d8bb93d09261d2d62f44b038300e26dc914ab79d80fc85b817875e90f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ec78cb5786940296483d60af26fb490ca9e4d0920fc14adaa6269bf640d647(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__354e80fc275a7c886f7b7d9ecc0135081359770f38bcba2a24c8313bd8685fa4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da4b00fec7156136a731ad6ee5f5836f7513b795f5aeb3e0d99e322cbd71eeaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a95db3077bbf3eac392a68d8738f1b34993caa29f9c0ec9022940cd26770e50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b7d97b8cbda6bc5ba77a97b2d2e95fc48a438ea5ee9caf5734588a5d2e6bff(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faaca826576d6aaeabc322444a6704fd0a7f5fd7345706d99b50d2e679110d33(
    *,
    include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_hostname: typing.Optional[builtins.str] = None,
    replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    replacement_hostname: typing.Optional[builtins.str] = None,
    scope: typing.Optional[builtins.str] = None,
    tags_attribute: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__142fd9fc822979933e07fdb6e409d37765a68efd4c8e63fbe8741b722fcd06cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de74f12c710819786104ee33100efdcfa87cadef1ba46e45ee1c542de7ee39dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8b5e8d06e084957b2ed631b10776fa845a2c05dfccbb1933c85aa2319b1742(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f272b986ceb0e15cdfeebbf7693be14bc43bf8969a2ec22f392ab9e7b548270e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db02b41c699c238a5445d719549d9ccd321260baf661f0e898b31b8dc897ee1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22cbe27ae39d8a25875f692b62c5f52ceef78f2b9b15c821308675541dcdeec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0153db9365bfb42c246843379cb08963db8604293883fe6bbe2d6d2423b0f93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b518a10a61ec92bb1e75a7454204e5a1485c215bf167475979e26c2f0b8ca3aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264b0c10014480de6890ef1598f2b50412bb53d0e0f10075b2eabe139fcec3df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbfc85cdc6727d5cdb3d5a8ca89c0e265cadeab541b66da10876ff447a4714f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b61d29e4baa74e426e82448e0ac59e76870e76270c54f9bdc2eba52711a1194(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAkamaizerTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad28915fd26175e70f8a41da8fe819241962dac719353a22ff0139561ac3873(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5adda1adc85db08e9b50491e04f486cbeb12c8926c6534738a50ca9921e64f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e3b4d7bdee87c22c5918134f39d3d949c6fcdf407e0e214814a089fc3ea9e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f382e469465b1b93c9ea652e4c686faf6f2796a1986e8293946a005f5dbde6fe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c04b24c65056ab6a108caabae981591d875abbe1994ed8de1efa95826ea5eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5efeffb6c41d4716c4bbdf49b219512a87f9b70bd1ce04f263985e9f577654(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb9454e7a3aa75c45c6b356ef6e07df5f0dd402fc6c30158fbe70d0f0df81228(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllHttpInCacheHierarchy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb8a15f8147f63acac266022d898d73a0c2f53c044cb9692ef331f1e5ed7fc8(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_origin_query_parameter: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b75d571b60e892dd45363cdc0de9dd3bad41dde06f1765a806f4d50cc2fcd27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148d778aa9ad8d94b37b3299d9c91cbe9a0ad60c0d5d30f6157038aeed1b3521(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5ed4372a541462de46f12934d4f758694aa895ae61c2df73c916e8e23ee5339(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0be77974b3d08377bece5d591608228f48abed3cab2a66d5c4912a05463070a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e6363f16b47c756cdb7238db6777080b88ad4438eed52364333f5c2917a059(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__006ae7e8a70a456cdcac0ecf24a65d4b2c10a9cb9130c2c365870bb1234a79fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ebfe5c621d1248d8f1bf5492a98b7be782bb8965770375e0b8cbd82d929412f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed140db835df72b19f1daeea59cde827900773bafeb21cf665d3360c6bc8783(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowCloudletsOrigins],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1599a260fa5ce5fc97d02911878a66ced4f2d0e03c6cb0e9a541bb5a94108bef(
    *,
    allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dfce9de1ba606de14f7365723ad8b1f8b9f833579336b0c729718a192aca868(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5222777c738714666bc8b8b973a720ff49178d406560de27c75ac55bf835a301(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b654c0d0195b12f92f26919907e9ffefa2be0249e5a516b03de19132ecef18d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ecbb6ae44a181c63882318c0015c5e4aa011ed02579e9b5e5ada53da50e83e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2d57fa4a7a70edaf7f7fd2ddbbf22fd79db0cf94ae17d3844f1cfb08b2e280(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8da0dc0b61f0877956add721969d7a8cd89cdb671d6e33e1b5dc385fe16b3f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5b5ac04f4b6ba6f4f4438b6e1b4e7da17d3410c01c2409d80513839bd5247ba(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowDelete],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec12eed206ed4c0c2dc8edd3d4e14cc1c1e7dcdf275f85ebc223b3cc9fde6a3(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d3694c0fa7c3fea217be22af0eade2bceddbe1cd45dd6d85332af8f4c2918d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__601ccd378381a0a4e26ed54fce7fe5f00105fa28954a7b8f03a9be3ba14a1f8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dcfa15a7ce9fb5c8a2c33231c286c8200b38905d55d2f78d051037d7136d50e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f3135964cc065342fc0d39e620e51dc6d409f07bef5264211e649cb1ff2723a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7bbad72be160f7ac387ed956ed45eca299ed1846d7f353139a7f626a3080ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ae64e3a81173a0e45a5ef2adbe45b269fc8e73cfe7737a1cc5fc5f0e002ae1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsCacheKeySharing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13cecb9532c7ef61fa237ddb4e5824939c83567a60136d5eb24814e38d951a64(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d083bc11d6b616496827c81dc3a68b091f847a365039080d7a36e0cad0d9ebbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2399f369998d20e547261116103545d8f0c69470eb502e71e6700bc985e883(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd880847a562a65b1109cd66d4fd0e68067452ccfccb35dc3b92fd925b92d3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7deb08551b425f969e4ac91ae0784206500682c156d4aac4af780af51d617937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63a48080022380ba76c086837e5315e4c7a8d43f489b6abede688178bd914c54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944727f6f1d878cb7306681b6bb80d79184f6ad299becdfc5f7e48248793ea68(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowHttpsDowngrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4970b37b07b522cb2ab30570d6b0b9a568360f29a321660e669c719170d151b2(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7587427734f9e1900021f14965256c629ce427baf8d3a1719ecb7cba635871f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5692f679672237b60ee8ff52b9adeb54b81b37dfa54d4ccc6cdc2193c37cb1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10dd6812205369e1c290b0cc4a28ab88892bd03616cb3944eb97e4324891522(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327a6ea4585d2134a8da5c3f9da3c3431c2c2fe7a5bb34a5033ffffed2eed463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbabbc47f20bf5813c7245667863df203dc6081fd794c3316243593b952632a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90656d0de56fe02d7a41d98dc6b1b28eb8953ef46f9b80f461c09a35ddd362b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowOptions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc61a96d64073a719ed1eb7b732d8133b737b2a7f766e23f49c2edb3f7244a0c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1884e10329a9a84f0d9c0907d3539cfb9bd3db87e27944db63f70b4e25856f2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f650640974cf553787ffb346aa43c7df3af615cbdf142934d4372608b97225df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b00203f939507e545542e65a668e919d82acd7bd78f33ccedc58161d670270(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d596d4ffc4fa52e87ec88a9d8a2f76559d45868392e58e95ad22a2719ba017ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352d941607be6eb5bb8ef623335036d87f7a1921befe1f9ecccb240b26c00ad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf039345faa6fb73d741d81a589d25edbc2a2bf5740bcc53dbb5079fe328c4c2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ccd8b696b2edd0cc6a2df8407c938505969189f9df83b3a3dba75e54ec02ed9(
    *,
    allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebfc4eff54b217ea23c29cc4a6526f44320c8bbe9915d6d373a4df2a8154bcc0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f05ec9f29c9dd85d7469930541bda02be343299030cd057c65c588a83f0df0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e920a7a95d45169b4157d5b076274b363ce3f838485c06384884dbd40b1ac294(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f4b6e9b8dbfdb1a4b8d985c9ec8b2ddaaeb01700ebe65469f132135d7019da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b076930b0d216abf243b8e6a52146a74898e49d3643823dd8361df38887f5b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f48442987ef0accc8db0fa00ced6ff098f887ee92b2a7e66a96764c0ebdf0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599dac4122228098b573282461b53d7c91fccad1489e062be7584576e88bcfc3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f112b96f4b47d0bb1ececed74937b6641eb13c2ea744109c0c275651aafd8ac(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ffe13388779cff9362326f035a3beaa90234c03d1dd6a869bbc03f6716b5071(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381b6cec61448c31bbafb44a6808f0726d9d9fbb6eb70e92f6404b0e4552e2f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25a6a82902ded8bc261cfbe38b3f55d566263c7da8e7916ff5034a761baccb08(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__930e9af74386f40df47cc413921a394edac5b1f359ed757565148429f7ec90c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20adbb681776a846b6782bb8b93af6a1b6c69e52c5da518b0324a03ba1666109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ef8a3dee6441cbd523fee3d7cc26dafd6acb1db51448f4f2013196363b8945(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowPut],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d7c46c18a9dc591659475f02bb9e03d9d742f6caeffd9352a9aeacededcd563(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ca3b8aa842abfaeb923f6ffba60ea9bd1f6959df7bc87da773fd2c13560f07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34c61a7198a2975171b7559e50149b368642b284473f3bc2cbddb0852d14015(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b09b7a627e8caeb2df79eafaf17b796bb6bca667d6ddb0ffe2a1dab87ecc000(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0507ca86ea2d1a5ebb55406dbd35990ca78d2ccc630fe8558aa4904a5607d2f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7b1fb3b8070cb10ef9fb2f37837914c7bed193515e34a12aff2a79eae81516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479b86b17429fd97e99b443764b950db42251b13edd447c55af04fd01ebaaf34(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAllowTransferEncoding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d058d74b0268507e78664056692fded5164dec9122fbe5f0fc9e2d30ab3c96a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4004096678f620bbbb8fc09b1f6c5ab9f270cf53b81414633b41b8631921bf0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d473dbecab2e28aff9702e47b43c18dd80cf9033d61b1f05f890a3903f0260(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1119006a14f1e703a6b39885f7a71b3fe662d007dc1878d0f154789c1c628abd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca0d2cfc2cd563fa08bac79ce4cc0f17d833cc9c52586d1bd1697e3d244aeed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f5a680e269a60ab1ad425f9dfb3a82f9b5ca7486fedd7733cf466335eb90dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dff79955709058f2b77c5d660391a011de0cc07e6e566937fe1a0e0e270a72b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAltSvcHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcfbb394d25ae6afae8f6c6bfe3f6762d992c72d6e4add3fa84ca5270937d2f8(
    *,
    alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    throttled_status_code: typing.Optional[jsii.Number] = None,
    use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f33a8b44fcd3a1f5bfe4b98489f20e3a4bbe326311f09057e8d5ef525ff256(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d53fc894a9742d6529adfc95a0c16ba610491652fe21d1f2565568948737263(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5034ed7b14374c57bcb21a12916c41a7519f107f36411ddb627a44c284cf5ca2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59c0b16576b4fe50ffd11c93c1ac6f83d1a752124157ba4bbb0a6ac7e4228d95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5febd19e096be4866e6934976af6915c0f2f0d7c9c799830684bb4d67ab22491(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eea949886570db26e0ec4ffe815f892a57a121fef8bdc31adb70fb2d012704e0(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf31363d024d2b218ecb23ac2f46899610e7843701e64f2317ba8fc20c5a9c42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3692270feea3590b4c2b4a762cbdac02bf81600d0a256ac280a1cd5e04b4b7f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f757d7094180bb6fe30017700bd904e3f4e990d3462fa51ff48530f31729a52c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__949054da79ec06875fcba173d55d3ea897c2325e560617b28e352e3a8a8171f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40293018387251c57cc27c6ee23869b6767fc12195cb14922ea7812e9164d001(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__165463a55979b3d7ee8e24e359f6550096a098f4fd195716acbe8b54b24130e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84eb699ab49344dcd018b091cee4ae4c4021654bfe70a407931dbd7c9d12cc0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__602c0a6244ad23e8564d259ae9ad4355a378876d1d5b9f3d89d0c93fe70cf744(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ff2625bbe04181372ad14e637b24df07706a8eba2e0685e036dde76cc5e3a2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e335f3c41378e9dc28e8846fe951543442e90ae7a33be4ae42220c96e226a205(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4d017cf4624a0b14551a5254316e23fc044c4175d52a9d756c5ce99ac7f46f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09099bf5b9e7fbd3acc0212c6260f8bd91c5a4522d402f779f73f8c817fe8a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ffb638bffebee259738964237e3dd7deff13735dc9df30b99e37d9e84e0959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__534f8fd803ee0308fb74e71121c1e39b977148741a4befa33b9c540b9bb620a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a9c3d73f867ac897b5199cfcacdd5343febe3c9e134f8432dfe280650b947a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67c61fe0d3e791daec2d7f244cd36bc1af04b554255db9a7e4081772f2f19385(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2fbbd38e94a6ea2c55e3b08645f3ade21bbb428fcec481a06b394b1c331bcfa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da306c831f92ae30fe34b151389fe17ff7c3001a8e1634e67afea82fd011f12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05f373b794fa6750463e4ac6f20cc0659f637832a3b7a8110106049819d88783(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95112e1fd850bdc587f38147f8f42b7a06a65f197693bdd2f76c03ec606d29bf(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101187b310084c6780d12c898590cb6f2d6f1e1621bc2b4b60f3355a510ff013(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2630b61a58797ad6fe8b790c04ef9ef482ac9e9cb848f7f491dfea97f017f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__295ad7d3550a7e0cc93079209214d194d297c7fb7ce008cb8e0c7f9a2bbfb09c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d692345c88f7e54ac0f6fdb5f44e078e5ed562d8fc1a9bb6981757ac3eb80b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67a6b2cf120fe2269e5e030a5aef1993456abc64afcc4252e144d91e38663f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d137a971dbee792356fbca907b1bbd33e7af062368ca1a183166a6156480792(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeecc6b9b061f8555c6e0f554cec693791f6fc410b8880cd95e83b5984a9acbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c579ab0423bfb12545236defe30ef5e6963c5b874acfac243e90687845496c52(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2502dea3fc2d9ece46bc56a2f0ac5220de512f4bb2986f96378db8433d0cf65e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce07f61161f9c4ac073a7572afd1ef7df1eed0968182cea15a1be6277c34286(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a9fe80a7a4ddbd4d963102a0c7803ffd3b52af444c33272a9f301a1e0823bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d150c6ef3c02dda83516e633d123d11433907366791044f2b0c9afd8ccb2c0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc123b95869a08d595f446af038cef128cfd9e1b58306ebdeae2b77d95d33709(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApiPrioritizationThrottledCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48c703df5ae015e17771bbbac019326fdccb41d41697c7c18094045db31a9d5(
    *,
    all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    all_down_net_storage_file: typing.Optional[builtins.str] = None,
    all_down_status_code: typing.Optional[builtins.str] = None,
    all_down_title: typing.Optional[builtins.str] = None,
    allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cached_content_title: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_attempts_threshold: typing.Optional[jsii.Number] = None,
    failover_mode: typing.Optional[builtins.str] = None,
    failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_cookie_name: typing.Optional[builtins.str] = None,
    specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_domain: typing.Optional[builtins.str] = None,
    stickiness_cookie_salt: typing.Optional[builtins.str] = None,
    stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_type: typing.Optional[builtins.str] = None,
    stickiness_duration: typing.Optional[builtins.str] = None,
    stickiness_expiration_date: typing.Optional[builtins.str] = None,
    stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29562254d694bbfafee96c73fc87a9207a6f68fc36a659dd3542870571d45f9(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54af023972d79c8a4a29fae9123e7a9ab98b01b9f1945002795cbc5c1136f78e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__200d6e26b32219fb3ef6902b97b6d9974ce235a6fdda221cc6df20f3616740bc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2430c519461b00f305ce28cac43679621a128645f0461ee9fbd34a13592519ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3b8ef8b323834304e5c0c2a6d78768f1f70f8851c1c4fcd5627dd58e7d9e87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde6f712cd447d47895495836857e947af6c4ec606348edef8dab7a79e3880a2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerAllDownNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b2e97663bfd7eae192d0927f6e6f4f4330d57de76873300e4a0eabec7ecff8(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b09a8abead8222960c7d4ef9c4c8949ec6a8a3411838e2660af4d9304e60c8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afdcbb6528cc3f91674ef2871813bf2f887f049b42b386670b1ee94fb70fe7b1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cec6c61b21eea7410e9c9b9671ce55dd3aaf30229906a1d65be79d0ba4aa5e61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a041985bf57ea82e0c35ec03379e4f9edf3b74c1d7d572e30aa61ec641d3124(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__852f4d96c075318cd745ba71666b6f20568c6fd2a32eeec022956caf41e1a5ee(
    *,
    from_origin_id: typing.Optional[builtins.str] = None,
    to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdf81c51053cc983cda3d8cbe97747649e1e4ea545c9c22153c5589106e882e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c2317d08d4a64d1a629723bd8b106b57ad3e2ad0180527736cf54308b51fbd(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a665918348bb25db3b2a22e83b91d197b1ba5bf18fd636f7497d37a95be4ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045e5bfb0e42926cfc7223ed829b77c6c19f3a2f48e6713497ba9fadf18763b8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bdb32e2d85218f0477cb4ebe5d960d134cec0fe59b849801d45c9555790cf67(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b055d44cce37e36fcabe2d8a33e6068c9b9ceb48e0a5de459efe048ffc125cb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdfc7a819766a3c96ef5b0c94bb521f07fec818d8788e5e42c1e28a51513e5d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d5d89194a4c2151e87cba7fab2312aafbe1e0f36257006c96183a190d65b46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ad3da094a378860208ecdae0d813f93b1dd4a934e14e14a6ac4c20c9bf4d3b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1d15557a6a923a6c0887d8943c9af609719d53c4d0ac616cbee4c9b7065969d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e534fec22471664a1bd72eeacab9b39579eb9c0f857b1ccbb7d21b8a1774c11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7607a78a43cc594ef7a2626a39a1d81dcebb8563ca7ea302db0b3f72e0838847(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ace0297d603c788f9c58c089ace9e731d61a7c029c292d8897d534fc5ff06f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed6ccf97d5fda85845f00ec93704e07bcf627d421fcea5722c4d4e292237d8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fefa2ca86af7d11b1abcf359d97c0868a202d4f693fb165cd8d21046afa927be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3bb5392d1e89b67150076e164a6ff7ade9b094016f08fd84221fb9a5a3db1d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9577145c64dc08f0fdf1e8227fb0e800bd52b005f8a15e44768e77b7e6b65e9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__062abf21c3030cb7234b883a5c2bfac6841805650cd0382f2b523ef4ab49ce5f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07fa099efa46458bb9ea8b2be21f47f0deb9f8fb089821f26d285683add3ab0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13700ef9197d94b150b3f7741d351360ae919bb03ba9d485bf102e2439d27c7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3f0f1c8decc12df4e74413eae379ff03dc5a27ef017d27bd73b854ceab0ce0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5227caea12447184d752a6a9176b2cb83c6200567f4bb83a90cf0e0665514204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ed460b96104ab1f928f28a528413b488f37070ef222e92ee2e871042ca2ea69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c19ffe2969c993c3a3f8b553f8cab0d974b51f2d55a32e93f7a45c33f25bdb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8585cabc4a7dec2d98cca8eb66f5dbc3d0f313d9a765a102ee3674064845611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c8528a86edb8edf8917ebfe776317c538826e2fa5547ff87ebe5689b7e41b1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10ade4d26a653f29b79ade908d9a6d5934b40b7ed3ac97baf4c5048d88de2906(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31d76d07c8fa848f960c31ded62d9cef68461296a68fe1805a95f59ccbcee05a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb645e07aa675acc17154e65f0eae6b267114cdab4a34d386938aff6b9f3a25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10512ccd1c7f4f5d20e1cdc958cfa2760c6464906b127ad30a785080038db519(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c26eeeee7637cfab5d39cd4002f8ff4b563ac65be188c9ced30aafd36c0c83e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aedc096563f92a5e8c39cdc230118455e519d6793e7202bfdf3b31fb33239ce5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c175628b717620d1a1c8c013ae60631b5155479aa282edb18bd9e77780d8354f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7946f86de54f69b34771b07cd76aa13709ce7f15bd78e3e0847b1553b0479af9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f152fd37ef2d46b0edf3c2dd0186e8167e8f29ec2fc01009e0f221edfd4b4ef9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3c279ba10ab81a96950a3619aea64a2a8a2f16bf9ee97fa7c894b17a8340cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3bb03a1d0ed5f76f61a7e1edbddb52d35bc837e21f22ecc849253df1bdf384c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901ab0a5e7ff4344be20f09cc1078cf6ada2239cc593e927d36e04f5aa9095af(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorApplicationLoadBalancer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c53a206da7a4343a2feea91cb6460aa78c0b2c8cfec14ebd662f566e6cd0fb(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_domain: typing.Optional[builtins.str] = None,
    population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_salt: typing.Optional[builtins.str] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
    segment_tracking_custom_header: typing.Optional[builtins.str] = None,
    segment_tracking_method: typing.Optional[builtins.str] = None,
    segment_tracking_query_param: typing.Optional[builtins.str] = None,
    segment_tracking_title: typing.Optional[builtins.str] = None,
    specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c8a8a5e35f1530d0ca1bf82354d82b97efa5f2d3d79d551d4a45731a75fa9c(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f190c9cc6c0cd19391d0fa504140fd29ca7e0124864270914da1c68c9c86773(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96fbb71c388e44534baa4bf533c7cdc4cdc84da57a33025fab45111423a1f24(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c33be09f2e199c86fe09f359fe9298a531c4f8d4e17b23492312812709ab6a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e091bb8a57adce73e5cf7b705b4a8ca3385b979d109d8408a09a2a319718b483(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f565b369623ae002ce729c0a5395704362c39b104c427f07a1872c9efac794a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f3e14a070bcf8953df9e4c1d4eb5ab11d920ab8ec236930eeb6b55767fcf5c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720a92c4b0714d7f4639b6252d018700c2cd909fd3c8af52472f1c6eb190488f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5f3e932e1728550f79bc338c78e72e02a41e2daffef3fd5a52d18321f3928f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27c1ba97ecdf98f3f62da8409619f097a4dfde6c01bf43121227a73554dd4d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa95d3e7668236668cc73f5afd51ad66a4e4f159937307597bb8aff6879a4a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e6760437179881a78fb3278f5fad302150b8c5e44d9d714246bfb2b1fc8fdb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c055341bf9e474e6a1e325df0bd5d48a8806aeb38ea095fe5a3ad23838db0825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3fb775f6798157f1df79fee48fb00f6d9bcfd1a6a17ef9540e21d4ac69cfea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1eb7dcc6a87e87e328ff376a0036bd926fc7fc293077cdd584b98d271f59925(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10af09c807f217535d8fa18a2772f160573b76674ddae5d8f87faec67af9a327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce82a8f8d9003a8fad86c371ec065292d144ea9b718e62d9ee438a35e8619da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30f47a617bf6e06302f3f4f1e171f74fb3d49d0e97ddd4f5345693a791b532f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee44860310f8697713f15049bc7054cac9e3b39dc5cf55a0d32f6417aec36259(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b267b37ff7830aa48400d9be197f055680074285ad367c39588204fb106d84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3dfad2a281617b12b0a65c0342edafdce188a2e0f79a945800ee9b4ba028a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d0fc942d6bd5bcbfcf9c4fe3a6f107325d0a2b23710184ab2149f4de4dbdf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a7652c0d62d4b6fac95253af53f9a68c04eef4626afaf9ff84fae1ffad91cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f82844e5793d2e091661c5ca7afb6afef9d9006837cfe4011aab511633e265e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127c1050355ccedea3f5c1d30d39f1635f4bb314d92e592a0d63ee1c9a82e771(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f40dc58034058176a4c153b657630fe11217fb4a5d936af296d6159655b702e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5fd5481b22ee7d672cd78781b6b25eb0f03f27da8d1bf467be23b97f221db6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8a8d2402d75d494984f53a0cb89e8f46031dbf06e4b7779e6ea270f5149c76(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAudienceSegmentation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce1c4659887d8c6d81267132a990a73d5ea5dd79e09b1d718c66603fa8c188a(
    *,
    autodv: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d13f9dbb1730e48460ed1d4e6df9ce50217966457bb0a746c33bc5a73b73a8f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ecf26cffafbd75fe2494f0357555ac135ffd54982701a7f532065b99149997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e76d2f1e6e6ed260c861c100415586b080d4fea8a4e1b904a0721d063e41710(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf116ca6029444ae2abe20ed9cd9c9193131270f9f5b56d57661678a29a0660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694203c3499ec213a14565166423d4fb0e882f2e6922eb9f9c0df6e1e514da39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93093b5a244d389cc72b522c1d1695ec04a93a7c6f8328c5baef8147bb825a6a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorAutoDomainValidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8608d2a68ed560bc9783e6f8704a749ce3ace39acdbef8ac10387f21e3c1c4(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76d5ed0cae9a1bd6dcbfdd0f1e6b4021d5ab8517dc8a7230d0fe34ef357e787(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2698a5a6d089811ffbd5c0a17a65d2f95e446d8d162cb10a0d435c9f745e912(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__649c5e3defeb5b194e06d188b143ee496b5f3f5a5768e040ab7a356135dbde49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb1327296b1970eaaa695cca7bc1f0f29f0b85eaf836bab87593a0f73599eab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7554ae4a3a98752049388fe7477db93b30562d9e9ec090abcea8aeba9ca257a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79573ea7330fe0d3303528b13038860ca4ec25473d8ddb9c760b94a2d280da38(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBaseDirectory],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48544527a3207d150df4fd83f3b57d1d13e6cca0213126814a04b9eec6e2914d(
    *,
    conditional_error_pattern: typing.Optional[builtins.str] = None,
    conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
    conditional_sampling_frequency: typing.Optional[builtins.str] = None,
    cpcodes: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    sampling_frequency: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f69df797769ef23031de19cdee98c53ef3a4db4024a258d1dfbf94585f7700cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c41215936efa051b6c5ce091d918352dcf4647065ce0bf3275e189fb000c50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c6e2e60c23ddc77fa6320327680ef066e25104129b7315f40be4aa44f34051(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26aaf0abf30248943929476c63c79da38746a31d977569dfc920e9d7ad49697e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4905e733cb353eaa3e566b4d9f71742415f2638907b5b4718235a2074566723d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828d109c96d8d39a4e1692a4a2ea170ea91955be59ccf3cd8947288eb8a1bd6b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ebdc0edf85cce391550b322d39b1d38acd1e6386639286a5f694d226684c7ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4903655d49eaa4b1b02352b7c8a561705fa1a76d519f643533291524d9e9807(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d704421b07eeec3feee8f182e8c481e3baa15c332d2d09c2747d4f34f29118da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11073dbd6542aff2abb2d4d436ce9c04d8ad3566d43890e479676b155f9bd9b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d00f51425ae8025cd2f33f490b45e01e08441429936a8e06854d40c4529f1c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a54600c60adcadb97aaa102b5d036303b5c487628ed4987c3a94bfa8579d4dec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d08fe09c39b8414aa2995b76d1318afbb08981e1432b59051899622edfa55a6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBossBeaconing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b725cc5c2c6ba14005635f5428cf60a87532c56f00d0e5cb5ff27b168856d165(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5bc99f82d690e45114e2162c39fdb2798d8399898c7b5eb179a23b90bc4958(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d385be5ccb6ee6e801fa1e45698500bedf2936133bc5ac1db3c49e2994dc0627(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07ea9d6904c25b6e2ab33c8516964050fd9cde76dbd6e530dfdbd1a52c99e04f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a2db0b9ebcb8594b0f1e1bdb8bb955163f4c01612b93fff14fd7d9afa52c5ef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e03d2b009f2cfc097c5de633fccf34f280b9fe84b959d35b9ef6666e0caa719(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b823f1eee2e8d1cd7246f5514e2f2034f4ada674df25197ae6d973a9fb07fbf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf025aabd87beb19ee716bb5882fe220db6db737d27d7bd35654fa551846488(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__437ba2a2ccd44917df55510b7b11ffe84e42f272da3ef0626858d22db6eaaf74(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreadcrumbs],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d45ddb2b194ea03451abfe99fd9bc5ccf0a5fdac01139e28d2079993a0e249d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__380ca5cd01ee4e789504e6c07e464e10eb71ccb01625b983be8bebf060d8a067(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0af9688df055e0b5a74677855d4dbbc33b6e595a724df6387661f7b8fc0dc948(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab9fa1e58b7ce58755656026bb3d2184cfca357c910703a18a639bc04a2c16d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c6c1e5597eebda552d64d5d42af708ec36e6d124c6cbc38341c565d81e43e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c30041f58d9f58b0cfa84c71da6410ba65821b90daa4c47a647742c9c063ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18d6fcc91c59d86885029d8f17be8c1ff3b09d4b61011399d70691623a3423dd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBreakConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97d9c975ad45783de917b6050a87f484fe8d57bf72094cac044c71ac72134d9(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e0d43525d30240e85296358cd0e265b2e93c9dc53f674d659ad03c871a6590(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9adb522ef411aa84ad746cfd2b890ef20d43b794e54c2bebb9ba809ab0b7fb2d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8192f629e84d7239173c5104a8e613c141c95d23a28ad88c462bd7a2f3467def(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc6cc9cfaf418ccb632870df9f06ba2f6e55f190c65c660f86ed607c59db4f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298f83b46e75994d07d7d88ba3c3c18774bdb16df4a6f03ce864603d1531feb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc82b1b7c551d9684c7ed82af5e70ad33c1d4b698aceb2b91fe52e379cf17236(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorBrotli],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12cefd3cc456bcf9559a94d91ac3d68a9ca9eab49049eef46760c30394acac0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df0a49705d34bb7b5d605de513a6eceaf5f78dda969101025f9a1033292b9b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1d5342762766026c91198f5e56fdbe13aac696d06c26f87fe04029cc9a1c424(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ffd3cceae0183220d17787ecf26feba42665fa719fd9eeadd0300f63015fa9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36a6628ae072e6c05655d384b3183d9aa55ca0f14eee80d51d076a5a6b606b2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e79d70f6eabcdbd61bff3e91f3aa0bf5fd3f4159c6a893bcf7e891d45c510f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__565ac5aa7639893149b68cf295a337350bbcf79123e9d9027e4defca9d617c09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b73f0858a71b355fbe3491c2a1ae9bb47732df7189139e6a92da14455a9b27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5e984605081d1578a95b7dbb11f05dc7f5e6d3fb8801d8fe6762f10c858123(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8a66dbbcc5f90e67afb7fdd14105ef1fea417409506fa09b060f30caef9fc6(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rule: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89dcada1f40f319c6eaf74660504679031acb8005f61c3ea0641e51c50c54fe2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8168ed6d7e215cd220cacf83ca2405954d25e633aa0c1403e6ba456b7998b2e9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae97ee755107b2a0fae6a560f9bbad70cf3b646edbeb1f33e60501c377c76911(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__863fcd7a814c0d0029e7c6d2656fd507b3f25ae6c7c06a7309a4c053e8ae8bc8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fda680b079e39da08777c9ed7a161e1c9f8de39ec8418bc7f8c82471da5151c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf9349bebba86c59f665d1406442a2dac8ba788676528f81898cec051d56bd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b254095866b4f99a1215cbc8ed4c9856424ce37d8a5ddcdeead23c7681cf2c93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e652ccffd77820ab9b1e4f99f25b9d712ee073616ea096f6ed9a6c9fe1d6e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b893bceaca8a0024d953231485c602be2da2fd66ee2c4a4baebb85f478893d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1973099ab26b6f8bc44b69d46dc77e72df339bb0f9620369a75b64c0e1d745ed(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af4bb578f6a3d596dd9090be55e29fd11dc26af15321d15953bbeccb852cf53(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a80a4f32cfef92b6768c33020bbddcb47abd690fa01ef0be00ef6c71f4a8f3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29aefb3470d5d44cbab1a179a7c9fa873f3e50eb704dea562059d317a7fe9a78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e011fdf229c0798e6e1839ccf69f17f65778eb0367394b72d73a5c65a363c4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ebbd22fd7ac933505217aa9858cbda65f72ce2ad3ec49de078d592b3582501f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42cb02f195731030a220450139ddce27eb86b27492ff34eb7bda98a5d0e5f720(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a582b38b074723e7ce5bc537f5aab1f217ea37b06491fd1c1b3dd50e802d1ea(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyIgnoreCase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94d02255b0e08839d998d36a2b3f4a59c52809f6d3ff056c03a896fc62c9acf(
    *,
    behavior: typing.Optional[builtins.str] = None,
    exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a40571205331b40e46ea165f83c72c66b01ee05bd269db70aa7b944553fcbb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceb30401a3cc78036a3f8653e72c6b2a6a4ef2d248ba9a75e81c17a40d45ab51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f361b47f53dab4bd113c10ac45b6ccc4f62b17e1eae5ac4efb54272e59d13e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8357bbddf0c4db7cf9a5577f2c4f43b826672ec098257fa876c17aa8455a3e65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1c9f5c3e67a6f3e9d87f64c7c7948211aa1cd21393da79aab24d104ad540bc(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf6dc689d6815991566b444cf88518af6d136f8a07aa3a90286214bf50a9ee2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b5b06e8ad7e0742a05f865191a9c592874504843e2618171954070213353ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c880343c6d667b5d5cc4efe46b2632d334c84ccf61cd359b51e7747b1cf4a53a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyQueryParams],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09d3480ac27aee2d0694b6a090d1ce249ca198ec9948e5200abf7f8edc1c773(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1964765a21475fb4520a3b600163ec35ecdaa2fc5ad42ba29c1da465bc2ef2f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e3b997b04a4d159a5cbef4971bced67358066ff1d42f487ada98590079c2a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f37b3257564da234f3c605bb0b9614393e16ed72ef60359af02a4cbe0e3478e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a425c4113e638374516aef7dbd9e651b553175d386cbf792bac713f10bdd3845(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686accef2d44120300ab49fe78fa554cee6b51c6d562512834206ab471d6ede8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d3a9fb100c4083a57a3eef4ae887fe8fca7362af89f060e318c41b7ef227cc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheKeyRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c885bcd6f3068a15fffbce19ac0f8f1db5cd394daa0b9eb475ad15609c35def6(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_body: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__567765c02085922fe2514c0c8530835a3afe8f5766ce116533d3f29055b96f76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e4bc3c54f92e6bf7c888877a61d77b81fc9a0c350afaf217e584ea1c142777(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657188a9c0b0d2fa5dbbd88b540377c2dd7a53e54f16123ba6d2860149917247(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ceffb9cdb5171dc3935c75fd75318879d5c5bf570c57e338854b185025a415(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b533bfa2416898947006eb53b78bf0f1e609b8269b307fe679cbe2022e45023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f622be17f3ed4c6085ab3c2385f622d885a7c9f1591bcd934ebe37584d5a9b51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23265be08fa754a93c2f4d91db21934003128fc1f7c0a3f18f876c762a58d5eb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCachePost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0510f5899eed1a1eca886b6efbe2f011085901569240498790cf305288f48b07(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65ad5840a8def7fe549e73e4939cc685557e421b5d5476afaee48ccf5f83725(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293e3158a8b00f2c60fb59a128ee56232bf0c1bd271356c4780046030d1c2af0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326bfff60939bdc8a4216c410a81a61721574db2b6de2dfc7daa894b558a0880(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acdfb4d3800072c35c8436aaf737af710b5fc6a512ca93b31bf370a432a0ca92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb49cb7fa81ff69e21f6c26be95d4202aa9a754d3f2084e13c3aebb3384a9cb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d48365439652d356b64a75dc7058d0448de8a4b6d99060e69ef10ea687017d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f8f4780123df2fe701dbbe24caf97b437d9498c613b2055f08799e3c26f45e9(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tag: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ad5cbbe2e3d5aef501fe086dd45bf5a6bef5769e9471bee6b6113caba8846f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5ab97091a51ae81339f39d892e23b28d206b61a8f9e745523bf1b975266ce3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa924639a4d56cac6168301ce409bb33aa390118a3847b8e818d34148fd43cfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cbe40d1d751c6a7d95e60201187d9394de2b437dc97ea0ec386a46a3603e914(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e177148757f955dfa4e72cef46dcdfd66e86e3466a13d156912122ce3a09b07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b65c0650e30d46a76a7570ebabe734c25f319a16afc8427f0bb5e27a35a8385(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c6d4d3d9c4f6eeacf8fcb443193a63d7072cbcd6bf4175d783704189af442e(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e4e13ec025aaf07ddd9243bd68a6338645f232baf85ac1ff9128108761946c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c519aca86eaf9575fa8ae5ba34e9717f8f1f6748b3eb851734decc3875879ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1142e484be8fccb0b267217240a1692588ad50ae49d1b50e5590051989bd97f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae4a8416d436fb08b98bceb05e7c45cf4d18113330285fa6654a2a6336460cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1c75b3d5c578082bdaec31246943f5f4cad322f16ebcca13b0e370d70ab802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caeba75759b8bc851de9206b07e813198abd892329b6418f046560923846f70f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCacheTagVisible],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c98f45e7ea6004d7f7660aa730757169abac783b8715045588ea9ecef4dca2(
    *,
    behavior: typing.Optional[builtins.str] = None,
    cacheability_settings: typing.Optional[builtins.str] = None,
    cache_control_directives: typing.Optional[builtins.str] = None,
    default_ttl: typing.Optional[builtins.str] = None,
    enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_settings: typing.Optional[builtins.str] = None,
    honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    revalidation_settings: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91afb27f2b0fb6f591d3b945527d03c07af5b7372dc699a69d2787ffc17e544(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d667eec5b35beeb236a9891e128ce70b4fa496e356cd149168d02e6b0a5430c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1e780eabff888b0fc66ca7329dbe9a10d7170c38a0d993866cf0a4f0e922bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7920fe8d7a2cec583cf177da90cc89b0912cc2e616d0606489800d1849f13e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6335a7a99554294aba3522e8962625e02cd0fa8fe377238d03766f4753b9caa3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6899dfdfc65deb8cc9fdb6d9ecd4c14769e91d9a122e08677f2ea9d1cef3bd81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ebf01ba58cb732bd32d6ac64bfe2e67c049587aa54651f686698dc8a7e6fd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a820bf7a1be7430463a08fac1f7fce5b7837a0ab11d158db92775853fde9373(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fab7d74253b821d81b86a059fc8723323c98e1b1e43666767470ff58830ec29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c66d12bf3b51db8cb9712ca156d5653fbbdedee14b94dd2310e9fc7c729232b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f65954e31e9caec0bbd4bcf66ee3715df41c45aa71b14749baff841b53686e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd858790e5283355749f50984f566894c1e2213a1566e21089bb4b7a8ba1360c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cdf4dcd94940ff9b1163653755c6ad7c9f5bcc0f455b4d062610c9da132c991(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133e8ecdc9a9b59983406b83292f0d191db6feaef3c98f8c25f2d00a134116d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86098cb54d19f8405543449e99ad38590f92e73ff4237e8e49496fed450f13ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ccdffb2730aa39b3abb2a1e43a5300e9be368ae47c9dbc81d5e7bf6328f13e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450eb30707f10b97a81422a9516ae529f3019b58972367db03ea047d9fb115be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d676f344f35ed81769497588c1fc3003c7f51a88b414010568ffa47abdc9bcc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059553ebb4e1fdb1684506bf64c153eca8d23425aed571a9ce8cf89255d346eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27fdb84d9a1b3ced58aeae6507b2c8b97c63469c4e913a8845e16fe914029e1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377565e805dbbc58afb0602eaf8af5134404bae1b12a0bc35e38610abbfc4fae(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84ae910b61db8ee22c0f15b108b00f470a6a89566cfec11054414e74744f882(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cca0c11fea21b180a27bc7ce46356981f9e9f48629f3d2ed0c37d0885f781377(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0354a7d1b81f694144b641b11b88d79b59446f2146815414986b37fc3b2b8801(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e4f2ad1cf9894fcf844901cfed83dee82511316675ea8d37c86af05cd8403f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf1bc9196b2a1524dff7b59135b12641afe6c9df53dfe1f38597fde2f1a1b75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6413786c63018102ff3177e901bdf12e86867f90f1039d957c62fcff96a55274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d84224a2d2d382a75c316bf504d4983a63cb6e468eb51ed64dd1d281dc99a0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCentralAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503c5ea08b2d1ae1ed49649ea2316fb0e91e55c9b7201857e15cadf30254366d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    limit: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac54728a51e0053cf5a05ca9bf5b462bfe91b2cd22f19879cf65a50ef85cae0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51540232086801d0e58a3bc25d8b33249b75dea9f69f58e8e82c1e06c7d31d72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1be3c980247c814e03f9aac57884857099a003ea01d4d78a8964c4556fe0f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138ed26b04613b76071f2b0e348211e461b6968e71d8b609bc19b47e06283163(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb9d73ea89bda5d2e15c24afa7ace617b6f0cc6ee01ab0e099ce668a5a32fee(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9d866a9bb11fa67249ad6da9f4339dd441cf2a28876e0007d8fa6f3eb60c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8dfbc4a995b2a54d828a1302f0f06f4bc0343d49c1680de97ec7708d2746d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf0f6c5f178b2390872f88612ac7f600a33b167b8a24cfb29ee7da2a81c7957(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorChaseRedirects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84eea56637753f40f872dd8e5e9d933e06267e7e970e7bdcfaca1619272f297b(
    *,
    country: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27eefda4606d5c8981ec5d8c37ffdd4e5529ea521dda7cfa5ccd047aab291d76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34bb8ea00c65d889d0792e106e763d5153f328afd97fda3173b4b34c31a81fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aa8991df6a5228cfcef61b2b05072ed4bb1751826c20700883a020ae8803614(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc566c7b0fa178f34c2332b3b7a8e4344dd529f72b7337454f4b5ee20268433d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e280f6697adb4f21bcd52f938cfe16145e3a703433179beabbcce1909de43279(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca72c96896ae285012c50c03d099efb482b2b9edbfff9afdffb8cf2886ab274(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorClientCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e43c9b6bb1731af5b223915956668aaa79aab6657184385b6286f994eadbc40d(
    *,
    cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc99e76e565459c5b2a7e0108f5f50f8b9323b8f4020c1f4bc883bbf012fff4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f640d5ac298e8bd59cc90d77dc11d588a6c9be9b1c2df008650d30dd03a1ea(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b52c0d5676c153057e5c1726270300f88ffd28b90767b0a8c19fcbd8a9d7f80(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed3830642e04e499aa3c81aa4be5cdd5c596e2365d41243807376e83532df17(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd9ded087af93891603bcefd0fa0852401a5f15315ea14ea57c6b3c16375fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b602b9e9723a75cc242cb3d0924f810da3c4148f25c12e52b46549c70cc9e9ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb60820875853fa9b6ed08c879562ad8657446c521775cc6084d921b60c90988(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudInterconnects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae914d4a34965b4aedce9847fd7686163da6ce1bc9ff4c04f9eaf585956dc965(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53739e9ef11f344648c64c4d0ef9053ed0cd825cdac8bf9f8e1751746c63fcc7(
    *,
    custom_failover_map: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_map: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cec1328fa42c37ce6d25469512de52beb1ffca6f8ae37c91cbdf99e6e79502c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__357ab3e673df4b0639a3c7fadad6b0e3db6176bf214f38267da75c55bc954213(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa58ca7585a247529d088ad0992ed6303a9bc4e68a9855fc8ffd4e356425493(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902ad1508b970de0536acd7dc3bfe27a22eeacbb23e751a15451eac97a6f96d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d358518669a8c64edadb456e9c657060fa6bd7cfb3c69309d3dee07f390917b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84bd594a498b27a4a12ae5001fbbd397cd2ff9aaf5bf225a24044a6d7b760ca8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d753d303e21c1f958fc68312a85b448374c039267d0213993594953751724571(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f672f33abd6659ceac33c0b911e862666bb7fd048068eb9bee4f347921b2969(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapperAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8175f6411239be497b4696eeb990b401b43e54c8e44bc0ef337f8f9dcc1235(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce004d128651509daf0443a0d5d496be9fb27c9d96ab1a232aff72cb39782064(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3ee403050a60ffd3758e96fdb75985c762e90706a6173edce1664d9419fe04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec3c05672bf2e6bb09fc9610c09d2c518d6334ca37a9c8cbbba333fc23c73460(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ced10c1cfa3bcc8511fceba1f687809fcf102e5baa1a48f01de6bb3a7d92bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__454d67022d7dbd6275e012b4f970e114b7747cff578e23797a9debc6cafae38f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf7e753af5438328621a556ac946b43123ec0625ebbb1bf4963379d455dd85a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCloudWrapper],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a609de5809a496bb3354bc11a13d3ef5e004804fb3e77e77ff2de828d8a88f5(
    *,
    enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8f61437020a6edc6979a45fead86650f4ef8f14d254c1bbf5848bdcbe9a282(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99c22fc5ebddfcaf1deba24a7d6080e1661c999ca9b956a83e6f91c134cdfb6f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292f73a12cf1dab66411714ee2778ca0d0f1afd7d0f0c2d0a9a0bdddc2f3077b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53a07b9e9d930a55af010ad1d5b3b56cf4a71a05e269056384a7cdda3eabbf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc4579bd6c9bf8f6172927463541fb5148f03881e0531ee6fc0674e3a1e3566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f072e9ae10329578bba6131ad7cb94599d2adee71cf38e15f1a3ed29f0a9ff(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCommonMediaClientData],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8c05d19da15f1e05d403c695592f30ff088ea4bfa47d6f819dad66084a2e6c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d47e6b771cafd07991fa2ebf62a383641284db4eb642a9782c3c1e2035f65a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78aa8f6603feafab81e109db32065b243b6bab5beb781476ed24a0cd522ef0d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13830dbe47ff0c671ff01e5d0794325846cb9e89c6ca9b6507316b308cdc9bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc2d82e6df85f996dba7309ac97f65f31d4bc81ea1526d231a99f2019a0e246(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207b01ac43eb5f1fdeec2f288ccfa86119517bf77aec689cb684ee7a53b67cba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eac95036ff135cd9f5006799886eee4a20c1e347fdfe6d8b39593f7a53f78c9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConditionalOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9c924e6aeca9ae62f866cc202ecbf15a10842ef22f21e6d7be693efe4f9e2a(
    *,
    body: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99cf9892c2cf49980b7e8f2579f3735ef32979941a62fee262f87cc6e68a26c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c16ffe5cd5d37f0ad374500c9bced987dd0632add5a4cb49e8672972c0dec1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b1b2e6566594f2621f65d993bd85883a162a8dcb79b4463440c371da244642(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc41ec65d307b0a0a45e72201a4cf7e2805ca2c8057dff6bdffa10a1e4199d26(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7e2d8ddb6bcf18f4adcf43b983f84e53aea20083854277168a504318a61139(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e2f6f5294c2c344131586a85d8c6ca484dbd4bb474bf5268f9e130716219d4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb4b6e84cab47c92506805a297e66098f86cef09d15e2fbf4bc7a2bc5d8a48e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd534f971c4521cdfdd935ba09f4c4a8ed54941e8920f606fd4f02f9964c65d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19937b2307b80167056c4df247c872129a916c288cc5c4d0a0c4bbe83e9d8e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef48890e6bab9976ede4569b1c58e0f3fb1aacf7f2f619fe15414c8f89842a44(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorConstructResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1a8b9689d1a791f521838a7cd755708df20046a01157346b35fbf3d46d31f3(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c8ca056c3c7788b604136a82a48d9dd126f564e3b849035c9bda79048903a99(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f2ee18daec14d565e58d3b192172e8fa9d241b17959c27f7c5ee2857212b6e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc739a06f105646e32d75ad44314213e9b4d892c85161709601771a33e57af2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea3512ac691e15473265c0a54e7467b98c68d3fc9ff25904a0ee1b4a1d39c1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61486bbb174cc8d116e3692190d3b13c1fc3106ff8298285afde7fee5b4611c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d71dcb0044b07ddad2230e511a6da19ab2cf30c2fa99cdfe9af19e74c91031(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cf76df8d629506e83daa137828477cf9f2f2f22fa05b84684a7eb49a16e3c68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055305df65a432931a3ed77bce742d65dfbbe165f32296785289f99fccff5ec9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b08c0d3c57b9c0b7f6513a67c9d854940c1966d6a49906145d45e2e8701a95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5559ae1131576ba292feab8a546670810fe05c28fa694054d1091532c7baf8af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d2a3aed07150e6b808de7349f2997be331b97f8c6090dbc8b392cbeee5ce57(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726cb51d764e8a453208943a8ef4866cc50e18de76cf1da1a33192d568762620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93be630cf5e099f940e7b0878dbc7643249f5f022633a97327ef78ae055520b4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21229496ef57f3ec6bd2b0fcd2e46f8120423959cf53cc4109b7eb7d15d7c56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a24be1a470a1aaa32cd9429bf477945fb49b8b43ec26dfecc846bdef766a720(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6121d62635450386b2a0642fda931c6de61334f8283d41166483c2c91ac7ad6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ae2fef0e8cecb28235de9902eac60ebfd77455bb936e67328923ba1412c2f3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3debede3d97ada4a2ac5ffc20a16f63278f9f46adbbcecec42c177facdc30d3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae036e8f27a1fc3ffe6d28d72fb6aee754aaeacfb52cf04dea9f29321fec7dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8207ad4b8ed95306a81de0744bb2dd47da2886de5d833c4090019da12fb1e2e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5918a2677f8db0242a2865b4ec1ce7483bcbedd170687d23c2a237ec6463c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84e2195fb8a9481296a662d6a0d581ca7605cf2317f2f6fe5fba0ee2dff202a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d7bc8cd87d23d75378a6f522f21378d1145eeb9fe434a1e3350d2454eea79b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82fb7b87a6ea30d4ebe2da30e9bad55052da398d5f5430f11800f6f7a424f427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37491506dd793c26c0bdc2b9b66b3f3c65310a8e8e3e116074bb3d42f102ed61(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsAmd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a4bb5c305b7aef0b2757bbae20ff25ec5b948b574745c52c51ef98a194403f(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c10b8c0e79ae2cf91db9e3b70b29ef6990ca8621fea75fd612e89f5685837e1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4cc63e478d2829e93a4f3f7d51a1f0f708faabc8b8f5662093adf9b61a44c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6cf0148c8e33a54959f541e0a8808ac941b17a2851db43da182555bd8c5d40e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55aa2161f24d0ba0a5e9036f5872a939fe512087623a784424b67cb7a792943(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6382b57abb70b802221e4e49d3bd4cadf7b56f43434123e0b64242ee1f0934e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2624d630a4f5508ca2f1c90155c5f4e76f27ed3436e5d85d3bc3c2408b0929e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1f91f3bb9f5ab7cab71c1624a7b1920ba3ec716351887a45777394dfa4177c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d515f2a888d8e145cfaa73e55b1c5e06f3419a1903c09a5ca067071dd75d6142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4775c0f6c406d4095a1f3e3fe17b1e5a730a15654219ac83f1ab6b4982ccc9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41eaeccb60247222a9efc22e408bc33bef786ce4b65d054a2c97cf7223920691(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsDd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc1936ceae3676f3642451d1cc4600abb606edbf3de447459ab737f1028627f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a05d974147ed829429a0bd92e2c9ac6eb56ca1932c186cf7a30aa328f36ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71354284216367933059f0dcaa83fa7c2746b268bfa7c196ca196570b02cdf04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c187d8c50c783a7659a5f65ff5793d6fce1e75a8a20d3d30878ad800219d770(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b81e716c8fc29f7bcc0bd8e38a01fe6a84492e2376993b9605788f88b3b289(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb39e0803b28bce73b63f409b75dad09c2cce3b2a9b3368d3521bc07caa7970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e5141c3cb547b363807fd598c23da6c1814941f0f66d84c77635df7712fd192(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb12835c41c49edfd2b51689ebe7b8044b2cdadbc6cca422030c4dc13a3db516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d492df2aa5c97a6f879bb24a64941c2cd9f0f08df1c13487f8cce64a7bdd09c8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35229b4d2ede71a3949b87e8139faeef8de30420e4702b12085830a07e01686(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__394e28c65ab60a025f2263f2343f9a460ec805f956891358a415c8945157f113(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f753909c133da45ddd9a09f99831a4e3b1234a8464b39bf2394ad4d84198ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fd721d2fd250fc124a4918f93dfa4a7afbcf12986914c0988a989d1e07a1d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b10ee8d1aeeb3cfd0e8f0741bd1ee628b1f48f366114e40112de9a5dddee1b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fddb8026844e7517e8486eab84f1e5c6852ee871a8728cc88142d903050de87b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4686e378ac85eeb3118f0151f990b726a20bfa7df59a75b86a943ba9886c5b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__203ffbd6ab3a4048690d6b27c27832a8808394f3100a56018819fd43a11cbf13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d43f3be4a721e06aec8e08df6c894e5a1026526595fa79e156a3bf6ec8a938(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34b806389733fd53e5b8e0b9b297fa57dc5c2f507d5ef53fcf37baf6a3c84e9f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLargeFile],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d896ca42fe1069317d0fcf337e0cbc912798fe70359da04b27352039b3bf284d(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd4a08fa658bbc4baffc6a31dbb059837dff656a477cf33e65551fbf346db7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843331a429a460e7286180d7d97d77a24f37afbe84c0e5da91b658d58c1749f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f01846dfbdb314b09c5d203321beeec702bb2f023962c54da4172ab0eb9117c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95f003718ea349785db9e918ce7a2ff3b8394b3e4505c0836c9458c52091acc4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3333be84e777077a5916d5fcb66533a4a13daaeb312a74aafa0c795eb0e0cda6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895b741614431e18e6f4a6184162d438e847a2d7f6efcba3f5596795352b8447(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d676a99b8ce33b57400b04eaa5ea4f9cd05a8731de6a1cb27e9eb49ab17961aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ea97e0c2a72bcd12f50411df80abf6c62f859bf4b078e1a06033d21abd2ecf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a4d3363781f4ad9ed12aae775f3c7b6bd0f0c1187c3d79cf5d4ae6ca0721da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5bd5f77e3dd508a40d29172799c9e762230d32993d4433c4000d1226a5d8a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8be68070ca90e618c586901ab9bec88dbb690ac0225a0d3772ea50b1329c215(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5df1c575a65677b82941c5b28af340c69567b83343d6661e0932121adffd0a24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aff6acae0c3a4848313d8028c3a46e887bf7d4460e32696040a2046373f3c84f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad646125d187d2b989ac3bde45fd8d1711ab21a18723dd717643ab6c171e47a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44370427e7ed604730bb0e1ab00797812e5acf5c94a4bc2d0a24ca00143c85c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36cf918ca92aee5b4206798da48d0f442e0116fe96a3d665ae69dd9d0289168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c398a52a30ef7abaf4d954faf3df22c5b765c81dd94866db47fc10f1298f59d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7364d26963d393f0ca6e1dbb37adeab042d10d9fc70d297b4b3127645cefb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37102edf7c3ae9e6b8dbc4a773d13454005c8d9aa9d732b7fbc27cc2dee4973(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb4998087203b1da3a4754dc24eab8ecc0eff92063e55df2333bea0ebc2b246(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdLive],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f9582ca4e83bbd9f61281867c9d54d63ad4dd0695b7356778a6823d915d4dfd(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3843058262ebd8599a973db920198c8b6b30a1082f3a0844cbcdd91d059dcf3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2507fe5078d0fd0052ae8b7ae65deefc20d298eeea6587b74c3ffb6969982129(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab9c26c0f04a1a546d5eab77e4fc79b24e64955afc26e5200deb995519c3b2db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc0f0e883fb45f81b4cd47031060b2f0f68014c3986696247cd92221e948c39(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b1ba6e15193160ff7f107f3f4ff2849acf934a871a7afeb7f49308424bb836(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f412451227342ca5c73504d3274353ab6b5f3b80b6340328e4d2a5662df70d1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39919d7fe81c059678f8f04cb167e596987537b09ab4c5e992da6fea52d2c197(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fd2d97577d0dffad7e2140070c1bb09e2923422cba2f19569b5ca06639be20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e22d636e02a704e192831119a6f261f3dbd771c06cd30643e992e0c29084d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8aa66cc5d0b098be27063f9ccc2e432ca0d8f37deface5128b8aade5ba9533(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61695dfef80a728f2e83421150f8eb0d1f05169156b55e0721e02cc9f6624a6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a5d89b71b9e6e23d53bee734b5f949eb0eb5f835f12291970f873d402a5e4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607ac5a5f13d698c4227b105d3d5987267cd099ab173a00000317354356ce808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fea8f0dfcd95e841eb524b8b431525eeee5766b78ac36f93aacb183dae718a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec47f86c161168e34c8c71e61b6ed261cc6061294b036026ae599d52982aad26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee4c012a48854e1f303e36bbfdddeea7736256d9749418fa69bf540351b9348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3b04101a7b592c0510ff02c09b56e8608d48afebd568c2df46054ff839ebe70(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79def181cae203325ae56459a9527693aa6618577fe7bbc73b9d8aac49d66611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bdd033beddf16f11973457d2158815ec59c376f02a58c1be94ecb2134db342b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a883a51ca209d057e3488074277c4f3635fcc650ab0da4867fa7c62c2a135b8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentCharacteristicsWsdVod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c4c08001edf06c13d3c02a34187f27d0e4857f0bc433c48b64833461674b8b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    first_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    second_location: typing.Optional[builtins.str] = None,
    source_type: typing.Optional[builtins.str] = None,
    targets: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446fb68402d2c22c3695d4dc5f943de2cf6e6c2d705a5b906529c44f41baf222(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703b274c157529029ddb3c89a4a54c8ea5e7cf0aab237574765326ff8b2a782e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1211f219046203de9d4271bae64f7e9a706139644ec4f75eafe27f42238f0634(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60d4ff7589571f1445b3e0bda790127eea92ecc2d7fcc20ccb5c114b471dce88(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5460b66693620f60e7759f6587dcc06c3f4f079c6385eab291fba8a9af127db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7998b118af85d091d7bbe1b99e9fa0ec22b089d031628a1fcc2a590a1971c221(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87024f8992771a16b08aaff1cd94186cff765fb162dc54f5b552fe1753120e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__890dfb741bd421d261d6c0b68c6a01db36b3a3abf59592f5d954ebb1caf1ece3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ae08cdc1d7e0168bb3dd1f3f309a78ac8b4e984e0a5a7c03fb757e56c50acf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d5bfafb330a6f96bf5e9b0ddc10f70174451890fff567dc07161aa3dbee888(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentPrePosition],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a54085714a3799552e1ccd7965636353ad298a261b5b1963efea18c50279fa1(
    *,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_protection_mode: typing.Optional[builtins.str] = None,
    geo_protection_title: typing.Optional[builtins.str] = None,
    geo_redirect_url: typing.Optional[builtins.str] = None,
    ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    ip_protection_mode: typing.Optional[builtins.str] = None,
    ip_protection_title: typing.Optional[builtins.str] = None,
    ip_redirect_url: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_protection_mode: typing.Optional[builtins.str] = None,
    referrer_protection_title: typing.Optional[builtins.str] = None,
    referrer_redirect_url: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77d568b2f1a0190c9f8d323ed53f082328db406913381531f765fdd93f9d04a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d91127b1fa17e2535f821c9d3531105c6887135bc3edfc403b10cf0ff3bbb4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776152f77eff84971a6727998959a20460b14719206daec01c33ace8abcc402b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8534964b2e2b8d4a37bf139d092e219e03cf0b552fcbc7c8c921e5cb0626e8d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2dbced2304f11637d059c08f27ebd882381a8ec17ab73e4ce36581e6ded74a2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2785a5bb50c2909d3e1a47e489be3d3944667d6781b463f53460a95f4d523aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e409f2d3514af68c2a07c9765d7e190f4fbb6facf6adb0d8e85e2ad84bff736(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54acda5cdcd831b1b2e5f997739e8df071aa1f58dd50fdcb58c2a21a124dc34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc2605fe342aa78f2254e1d39465152ec772b1df41862072ed68ab2cbc90e0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ebbdd116a49bbea0d55da5167b790d2417832c0b9e03d3103606ef1b94fafc4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ea566d4294f15386138168f86c7eb3e33fe1ef6d8364b380b38889ffb596d44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c1725216bb6a423a93b9de5fa866887adae1caf67f9ab1496f8bc8f95c2e3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d08ee1e6ddc97981ace43ce59d7447425c1c9f19ba2ef517c8b3e5916d4ce0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2a4d8be7ca3233ffd2efe2b6c07972ff4d1d7da2c4ab2cdcb00092e25dd573(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e31a684f4a3488cbef64acf5d8e896c32d91a7fc32a92cb1dcd5a3db0c9fd26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe56215b38c9a7ba5a9f443c356e0f3bbcda2d2279a5f8caf217e93642a0900(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44767bba17d4c359db4be69bfbd1482c0e5a6b3b23eee4a3d576d62bfde5ad28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677633214fb95b49fdaa187a0623068df1a763f3b41de60ba9630f097ba86278(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6218d6a3429072ac60932c49157f57b53e24a8e96b7ba3b57e511479c9fec743(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1897ba7fabcbf8ba86129b875e582fdb97fbd06b7bf947129da63877a7178957(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba13dc872702168999d297ca77cf3a70fa7c3e2a07fc02c648903027e6f0ced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f8cbefde56ec73d79c42df3971a7637a71b573fbee876d1b9d5bf8ee79333a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30ed5a329d5d7d1335a6df545d0644056ef3bcf4aab6c02cf8e83be71719978(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a9c03a08138b57500cc79aadf4e866539d834f1f53818264224f13ec43c583(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b195f48ce387aaa2bbc6d20a88d18e30d7347d32d1b3709d5712693f5b76769(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c1e87fb7e752fb38edc5cd5c3a72e67d09bf63b55ebe08e8f3d5461963767c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24760c21ed8129fafffe3878cbfce0ca6637d4cba8682fa623b7b2ab5470673e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorContentTargetingProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9293c7213ae5d4c25e8da54275fb268bb12ff1110462c24646edc34a4eda507(
    *,
    allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_headers: typing.Optional[builtins.str] = None,
    allow_origins: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    methods: typing.Optional[typing.Sequence[builtins.str]] = None,
    origins: typing.Optional[typing.Sequence[builtins.str]] = None,
    preflight_max_age: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033b516ecc3946d5443fee2feab89d3b5f9a87129d5080334ae6f02413c9175d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d29acc0d9c4072b0c1f106fe98828236a2dceaddda044a34c714f567d73ca7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b882d2232d3859bc6220e20ef233cf3e1dc7b0d483e0c2c6b8328ee24bfb6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2acc35212a3826e4b7c0c25d4c2bc6dea28f08380867d7b51c351d89b50521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5ce1282959a9ebec7b576e49d7aa76fce0b09fecd014f637c698c2582926e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57420cb3fc0c18cb59d69444c353dd58995d1b5f7c8381f788601bdd5e99ea4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d8ca1d3b60964f0d9aab8f745e689bac2d759cd8dab515d6969ae7dabcb4ab(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e389e191e4e02b40caaff545656f86ad0ba3077917c70d82e25742dc09663992(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c355550f74ca4e6f19a5c85ea1b28e11ec6080e54880115b235626bec78cf9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ee94123c34c0b29f02cfaf7786dec648aaf0ec2f31ee9c171706aa3eee362be(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404aa868e54419b60be8b20b2cbc7ed88493a6a442b8a03348408049367fb0e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfca11dadfd98900f00b093da8527af401230b9fbdd2b86efbfb3eb9d452d73f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78c36164c1f8fc987c22f1bc942d789039272fbf17e88f33036c0cea2fd76f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc683beaf03952a95adde4d8c10ae54f832d8e462d6425df0f38547a590f97ae(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCorsSupport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06255ffb281e7c4217f4539c25f22359e41a35b6f00bfe8f8e5779384011731d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d2f7b73b536422da6c150cef2fe37e1cfe74b7e44c8bfdd0451aa33b6fba07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2593164b819895ced9b1328406aec893a7fe9c2c142f0415af7c2b2dd5397630(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adbce0941d350de7cd76cd09f17d476dd57fdf554a6cacabd955352dc735f944(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec36786726815d1ea2bc4f1a66b8b99bfce99f58021a5964c35243e8f10882ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd62f382b811ce4836986aa93f340ea93f04ca78c6c0faa010166350efe16a60(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baaa15c3097bcf393c546ff8e6382c075419045523edd71002144bcecef1c114(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cbb5697cbaba50748945b931e2675aee08da6b34e94e84fc475f608c535b977(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195a32bc170d2d19fdb0125eef6e7cfbea21b1d6232cb4db49f89f8cdda7e3c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3433ba9f16d08292ab1fa011051a660f263e41e4f1c4894a437a857200d0551(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f785a27acc89a3c41fc79fba7fa4c393d528867b4e0cfd07fa0d7193a774f13d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126e007dcafae48f6d3fba804ef6c44bad6e691b9d7aacdee4eab035dee1641e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ea5e61b02fe6e3e12132afa3ea145446c5a008ece42476c8c2527dd32aaf06(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac43d85028b67555d5ce043c07ec98c8768cc5c91dff3df14af1d881880a6c46(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d535439e4f9770ec873814059360b7cbb5a0971b918a133ddfebed46652ccbc3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455a142b7fa68452a19eb1a013b273f941cec5d1d18b6598203be39fdca81f71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93515c158147e657d69919afa692d6680e252f079d335a5b16dbee5489421642(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d27deaceec50b114f0a6034f79d0a88a62b8299f39ebcb7621c6a7257b13d58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9abf6b450a59f8a92c36963d20e0af7193b3d666f8c3898fb45a9df8818bd0a2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f189371893cc430a6a73b38087bae4cb4ab89b792fbda1bc8a73ac896e27291(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9105e4a58110a08adfa5cdd0ea03084940b884875ac621facbb54ab3ec18cf98(
    *,
    behavior_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5587ccb22965c2ff351912caf56b39f610a7ae4e1072570c6843030d3d6fbe56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40175841b48255014cc5b1c386d56f8e33c59c6d8a719428cd56d2e48922b311(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b970ec1cab6b793b8b0705be774a51029accf4778889a33641960ce6ff47053(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003f2ba97a9e30592af5e955a3bf3de5f0b03ae22b7f4d0c0fce785de36d4383(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c211c4ed0c668b41ecd866348d152b31c9bda656ec0291b1ea4330f1135944(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d751a6e68727df05af1c62665206bad2607ebe1f141116be1b1fbf9d84a3f4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorCustomBehavior],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2181af5371a36d476b2cc8af8af23f7c0557eb71f516afd742dd05cabc2e5971(
    *,
    beacon_stream_title: typing.Optional[builtins.str] = None,
    collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    datastream_ids: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
    log_stream_title: typing.Optional[builtins.str] = None,
    sampling_percentage: typing.Optional[jsii.Number] = None,
    stream_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfaad48532fee09d8a09b978f2fdf0b7c2dd0311058049ee9da317e97ad3057(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8db3e0ba1a40e7ad071dceb991c7a6c9851d5512e83ae0cd8f7755259e07ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__768993dd6a11af6dd345b494ba1e9ef5c5538150d4e4435eed4df36a7636a021(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f48903dda5d2041d89f61256606033976e77620e4704a3f82c40d7de196a7b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a6fc8507d557344534a7f60d07a684961a4896d2156b1484a40aa7ad5708bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6706a38afd88e4f7653ef8eb7b4805f7877cfecc680b9c650b85fea57ae0ab8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746931d0d19031cf6af995bda40d88fcb93bb70bea5fdc24e58548ec1e1192b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ff58e638d2132404881a2044afa17938483f86fc725af389b6ec0d3a4cc1d8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16bb18842e003c7cc882848eb49cd636419f45daa4311fa7db11267ebbac28f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__886ef5effffbda1592e9404ef0cea6aba4919b4bd7fd82ff952fef13f9779291(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcf013b4af9b9ba89324c31126db32085522e9f60b18b042590c44a5a61067da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2f122607b5b714dc0c6c8ece931fec5e146d19150402baef1bff50c687b0a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bdd615cd79d1286f3360a545c37f9a4eedc8072933e5a1af8ee8a672361bde2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c603f86a7efd4effd7fec8595dce6921f821834657c51ac17a1effe58b33db7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDatastream],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8c22fc33ff04a093093a939f787ed98d2bcc0618e9cc7f0261357bc16b17ba(
    *,
    anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73435f32d953550a965eb6474231cfe4f03ca3ba1ee1fc362fd98eafd1017c99(
    *,
    hash_conversion_algorithm: typing.Optional[builtins.str] = None,
    hash_conversion_key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e1a48f4a50f69e111fe097f9ebaa239ed969fbcda1df71a6a15f1bb08de278(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e597c89ddcf81bf201a6d4e8ebf1cf650b36e2109e7071af7da651ccb736c168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a06a0da26aafc752c0076c76bb2368be2f2a194b17b65999e863799fb33725a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93aa0c4af68804ab0348c052128e9ec566c1433b32d4972bf13ce8449b269731(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02c0c39b1ac75a2e69c100d9de1bf8c9447b23469e26ad9fcaefbf41699e7c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__850a075b0bb766b1563f979d36b0850841c293a894c013316449ce23d6bd5a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__193394a6234732dc6f869b84c1b18087f93f27a308e1729d9ae3db16cb54fa11(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthHmacTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b4db3654f8b481d934e5a47142a735221c70742b7a91fb07217e8fc0a27ef3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cfaa6010f20b37b1ab8836ca3142907ba07cc072730138a2d5686456b94a2a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0cf7092b99097df518b63ea2a11e482e1e57f07f902fac2d500ea8f88baaeb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79d01cb60459c295d3e430aabe75b86dd6defc02d7de49d0237dc368bc5fd74b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a525a186c428ac5139d24b1f6def7835ef1c9326bc229560db07721182edcdc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84db459b8c250f2c83efc6204e868dd54172dc02103db93cd4275b16f1ed0818(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17dd2b55ee9b4e1c733398318f8a8d31ba8c9e9fb72abac2a08c069e3a563d0e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthRegexTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4b40a643aba5b870fe8f2baa3891d55b478ecf4f2703205f463d758c62b8f2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    substring_end: typing.Optional[builtins.str] = None,
    substring_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a766413597535c720abc33f6df0123bcb09ea285ee27b0226b9a15adb37184a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e80377711819070b3f4ffbdb7185d2ffe0ea2122ae81526cfc06f306eb895c02(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc090c1a202b58c274d0f3c56fb7b80ae64e6656ad6101922af9d262f7101f0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159bfad31ea0b2ec1d905c5d933272e77c4f609aba07414cc9c89edf1230d6c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd31d3209a339c953cac0aa14efe77c4bdd9352009799ca344e348a0aea9801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7eabf159f339f48e20d8d7fae5046c4c517afdf7d02b3cae4cd42c1b23e2c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb64780efe3aca4cef88c8e6de4273cc39a258a83de57a3db316adff9a83412(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthSubstringTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b16448a0f3922038f2a270b64cd80523ea87260ddfddd5b82cf2cba5ab51917d(
    *,
    certificate_field: typing.Optional[builtins.str] = None,
    dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13971598db9d10aea11a49589c941b1253d100330ce7114e5911d60615c9878a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ef53706e9037c4b3cb5bf1e18d0b3d0482ffdb0a4eb9d4ba011f8ec8db2fa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb6f72109b1264f05b454ed275775e75802dd82ed331526f4599667d3d3d4e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8bb7962568ef3ee7c389868ac948bfe8aa7fc41f92a8dd50f7a720609000c7f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb28256f7a447e42f0b370d227aa9792e7501e2cbb02355fe446a0ef1e3b8c84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc45aadfbc7f99b5d41e602de4ff3672ab3a0c347116490a92d9d74978142be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad14cca93852e80ccbb318b37f4065d05f76097d3fdf8cbb0aecd5c751514a7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpAuthVariableExtractor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3255e0cfa13ce8651f636f4cb602939957e214121b868c994d838bf09a2e3fd3(
    *,
    group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba5993f61ceb63b60ae2293b992e4db56a80de8828faaea3dd587898ca98395a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95a68b248a65d5865597c1462f90a634ad90d7534a3b28a790ada124f937c9b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748a0cb11fa2500755c38cee46f8230e5ae2fbd9e8f353671afff4c1c2ed6fdd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59edcd5179ac034320e7ed789970809b9b75d21e22cc1270cf5e5791a6c7dd89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90f83be9b21f07632a4c5a558a0fff3f988234ccf09969f4b5cfc30882b8e289(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d499069c612ca8647d89a5fa45c2f326361c4880f4859557a0423ffc55f8eeb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDefaultAuthzGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70a5e67ffd2336b462b87a44090ef723b46a039b59df62be4bd17a3f5c2749a1(
    *,
    custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e53b7a148005c61f0375e73fd2a79f1d91c63f591d2d6c2a521ffbb02378bfc2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6faa76e425f578577ef9a6ebca6eb9b9fd070768fd1b50bca6f9ebbfc02718(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a571584e6462d214f8354493993bc9a3cd1b54ea8b0fcf441d74174a0525b767(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e807e97ec2ef04502a5e11c46083ccd45714a94db70b0c8715a7427d36e0c58f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cd92a86e56934a36d51ca27e34f39fa2136a8e93172c3d2bc8c5cd2abf718c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2286604175c40720b57ddd26bdda7503848b59064a97d6a3c0fa99ea8d116978(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9b5eb2719c829879f0f55f665d6130aab39eb1eb334c95d9e28eb3ba77d0ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f790e0ef789c7ce3be558b4ed0ed60f3b4b7695cebbe261c81eac6ae07d106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f5db69a60f84c90413944a2ce1abf85bcfa74f7102d1cfd052cd8607f666ef(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpDevRelations],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1a5d521cec21d97bc1f73acc24fe64332bb030703421921a763c6f129967e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8930332b5439ed5c34a5e534b4f6285df3d99c14b44efd7be13ff8ea5d5a8744(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27066fb5c3ffe4474eb55be153bbaf9604b7926cdb991a0671ed318efbf7bc8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b1b17a49d1d1599095e4429a6481f757e0837e45f264ab0fd85d89b756337e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92cb78e7e17fc4c1f046e5c4f1f74bd52f966a130bad21981460785ec771bfb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853a585ea8c9cc50ef8d9a0f876f4f272f372f27200b1489b2d74ecde6fce27e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59da73a766f47e47c8480f0ebd902d7f33bc9c045a7eeea4766861a93cd4d507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff3b3a25fe137262d73dbfbc0e47c79d174bd5306902fa80e2957d6be06003e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa19618e49ea049f6a7e090848c1ac3702c14790749ccc6d27572fd89342c73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba225be657e1d739e11dfd521d2b32754cee4055aff544ceae236d605aa9fe26(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0420ec5ee08cbb07eac99b469203cad4b3dd63b3a10883a65fafe56c66c2b55f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48645868cea5981e21389d35ef649475edb2ef2accbaf1ab43a52e0f00ea9a0c(
    *,
    extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname_claim: typing.Optional[builtins.str] = None,
    jurisdiction_claim: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_claim: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f756da662c036c345d2eb2a430ce26556acbd95a9599b3f79f213e1f633b5cc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65727a3cc7580b54965067a42c3b9742abfe6c6e38eedb0f74d9f10482e56de6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8588a43fc4fb659806c48a846bfc5bee6554ce1330399cde52c9b6d2190993bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b698cccfcf875b30c2b4c0ebfe89efa6aae674327051249966c39d4e87c6d0a4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a88ec3a9ff3e3463a6dce81a9606dac7da3a3ed5ded351a39664bc098c30e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca882047fac245f8880d356a0c6738291be021674c1c89b59bec6833b57e0d88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468e23e84300bd7b47021fcbfa868cc07bc58ae24e45e2e9b47443f9c9c71853(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f4f739dc784b914f786c3fcfb373acefc472805c84c84baa20f58557a52b0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7adc54c597f4a226b33fc96ef6fcca67b466eec1895bd68091bed7d3d79913ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac604737c84b238766e251dbc8fe2b503f1f32b7b3ae120519011a9a4c8babb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36043f16e4976eabd4c68a71314bd4b3d79dcd26dcc8db0dfdb736467f806b31(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDcpRealTimeAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189bf52cbc8a58c36753f0a5f08ee6b5f4dced180f3095442f9e4a2ef75d88aa(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05fc1373674b236282f1e139a7d2d991eb7ece0fa9248464d456bf70afbc096d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92c0db1b4a2c6de54600f45eefdd120057356ffde5d73cdf70edbe74b8de564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d73e0b397209fd12583ad836ff3f408f2f623f766e81377fd8ce8166a6f41c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337703a66ab12c601764eda050b94246df69a02b941028e60ae6e6c59144d518(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6258fb40bab447375286ca1a3bacb02aa3b3aabaa7152a3c4a37fd90d7f7dfb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cbdccd611d7efa6f8ae2d330c2723d373506b1089e611efc7747f29883ea83a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeliveryReceipt],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0136ae377af17b93f755f1e5e479a3633baaad5dfbd7b2194b64055a006ba47(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reason: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c6c839e56b77866d279ec72147bd83b0ab15ddeff6eae2670424d3210696ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32b0afd4628922ea970dabc581e51b82e975b378945adbf2ab6a194e8cc13d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62cccc9035b7688573933d34f56eb653d7c44a9cc816d5d89455324b40e11c2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd29c25596cab2f0527f309bef95140f91f235eac9ef579c2b157602699e902d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54756a6aa5cace575c809369cc44b2bb0ca366102d3631a9dd5d5d9eddb2ed9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__569e214a02b7984e259702d75ba27f9869c1c187a35a827321bcde6a55903e11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5306bd4fc23dcb0894a9d09d65507cb392aee85e0c48a3d37b713078db7777a2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf8744210ae6804fdbe426c949d62cbfb3ecd97cc70844fbb3e3fb5f4ddcda08(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc77aa80df984ab18406cef2a3d450098924b78ad098ff45a7c8d1cbd60fa289(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed473bd605d4ad13c16d71b70ef7949ec8f967f593ef57213a59f1c9404a608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9cafe1315ba6c2f932133444834f6a7c936da2ac125380d56259bc7c9389e73(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5bc964a63efe97ba6b945e542d155f1f1679ccf6ddb3f5c950dc81549eba01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc22ee1795126c1f4c8029b1df0ba41f77d2c42f4e58e589690ccaffd0ff0d83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__834ef60900daac42bc69d614f96731b76965de7b7083eef22b5d0ac051a33a3d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDenyDirectFailoverAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7009ed23898ce1f11dbccf25420d8978439a7e985edb2003059081629d4a0054(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b265b713809143bb6cb0a19e45b774b8c58b0174a62147783d855adb9553f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18c4d3d40e4a4c88fd2fe7ed980b480ed234a8ec695dc5ae2a094a46151ee2fb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76735a35aa089dab39f82ecd04df46032ea904b7f982e9d5ed8c5a62d54a91e7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67791ea6435674eb09f2ce9a0bfff17c35745d49241daa376329f80c4a5e96e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6406bdc55006e9b9209ac97f34dc93c454efb7ff13e59023d9cb39fb2a811f51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ff3354f33eac4d4cb5b1cc5354322d6e07acc4b8361e2461eee1856de34532(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78ae567a63cb787eb42614ac6cc4a8cd72a06b7605198bdaba3b8a0a88b28e6b(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14feb98791b84e0ceb038f327bc198b14db89c3540f89304395a57c6d18a45cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069b690c1f185425f75e037555b7c47ab4023ff00db4c1c638c19175b408cc18(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757d4eefbe644df6355a5d8cc85086215423f5ba2c674df42f64b88c19e743ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0346079043a4b7bcbf44fc686fd9bc9d5e8eaaf346d60d18fdb88850b39a86d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b361957096552f05d9c14934d7f3f99fc31b3b1ad54184a690e96559d34b82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cce5e52b92aecd1fcd8ef03c7be49bc844b7953f82c547b5578fd9de21598d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDeviceCharacteristicHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9437dc543a188f08e7d96926fdba90c94da569ec8cfb5ee07bf566c1b2f715cb(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee486af41cc4d05531d0c0942f91c126500e3a18c9c5d55f6de3073ce85d0bae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9974ea3f484a652e3c1482e5bb698b788e525bcca40c141daf9e247076c8c779(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b730e74b7993afd9657696cd02b78b72feacdc24927b0f4fdb24780ff3ddbf18(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e874c6b28141b41cb1fab03762d02a8eb33ecab042296dd117af2e512fa2e74c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b6d3cb6d0116701717703f7efb7183aab25205cb0a9393c51e5bbd26db588c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dcdcb734620d65e2dae6aa41267d0e074d20af35e18f5982bf94256a103926d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__637f5be045f155a6d03cf68fe98f0f282746f2d719be545779a59d2afd178eb1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsAsyncRefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c725def29a5ae80bef1c53783be5e0b2985648e8ee468b42b2239e5a6517be(
    *,
    delay: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee40091d36c97b4e8d339b13fddf204a65c7e059d0d404f0aacc42a158c9b505(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a705c04d68e61413a0e97bf653311594f5eafa0861222a73534dcdcc0ab377(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3d445e8bb2dd4a9aa5e17f5a3190a1e866c645424162384488aeb820a6f72b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b062b161404c27404823591dd3e21aaab85b1c561793f25b623167be7dfe55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae75b01cefeab6f3c3668b5c80c64436cd84cb7f3a3099a87c0f5a616c919fc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec91d8902d36140ba90d31732f5bd04acc475d82a27d6b428d9ad9c534591425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81e2c3e7db06be64aeb7e9df906bfa071c7fee3170dbffddff56a66b829e9025(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4c8d830ce45073d4e76f71536462e787ae1ac0ede4ac6e5c3ff9b78bff24c05(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDnsPrefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24eb310f4973935e2081dd100eb112b9d5d6ab63105f2a79fa272be3a2562582(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf15e9a10f5aa9c355c617f3e3a2442c1343809f640c8b12a330123f77a6b9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da8e8c2f02c834bc329b55128bbb3001c2119aebf79cc5293a9a8d43db990e5c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162b79452777fd53b52529fc234cd15588f1a35a0f6b0171844d0e3ae77ba2d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__debf2560792e5c4e6a6b164028716cc7fb37d0a2d2a922dc0aad02b44bfee9ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8502b5b3a8dc3b40caf25780de22f19b4feb183fe982fbc58b98ccb77434f5ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9056f41b6b4c1b826575d292658fa69ad28a26f250adac1314734388af1a61(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDowngradeProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7981740684ec6625bff0637d7e4e51fa3bb83912b567ad42806ec74c9f159f95(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbb333c8ac1d2b242575bfbc78e5e0b6dd09f47962177ebf04390c1cfbc45808(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__553bcac8acd036f98256d9a74fc0de386726cb61485e5d07f254e336e7f98bbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ec086afb9dc1dc3d412b2205780e609c0c80292ea2034e98519a8b69701f55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f68c68be8bb118522e7e490fd86b075d524c66d6eb247649d99b7484693a106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e7f2026950dcbec718b584e659c0206b0dd498fa3299671d9b86a25deefbd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58292de14b21acc8d3ec61774d65264ef7643cc607c2ea40565ef14d578d8dd6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadCompleteMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fea26b71674d9db135d363900cbd6d05ec1a52b379f596c2c4751c98114fa6(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035040aea5133c82041f95f831d2333a8112de9f1d1b166802ae327c2d81dc9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28200c9c8e28f79504a7feec7102bcca4374713eed2eef80123b52f8b9c51e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226c33badee826c0852f6ae459743a541d2e79a446c6f547f7c84d86cfb2d91d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fdb26cd8e368036667160c884f39f710aabf1f6f7b6848e6c2cde62ad3c79a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b0e3b5a6f0821088c94d0d08476bf81bc20273bc2f8338792f58164b20c312a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e7f171dd67667d0e4e2502f7ef4ecabb1c98b05eb3e97192697444277a02f0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownloadNotification],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db40ff05f26c179571b875dbe552ad3d490c7ce47268f36507ea67873372b9ec(
    *,
    allow_behavior: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    send_headers: typing.Optional[builtins.str] = None,
    send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069557d45b50a66e9a4505450d4b092e22f9b2bb17164670d6a3b9d9bcc27388(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e052788fef9bcc123b5380c157b01d5bc887ba4b00d5f36f896c31da1031430d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fa00788076d54dc8524db3910355d99ce478a5ea55a64704e2c2cb4c0f46f17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69145103567a676083fcc00a48fe552649b0ad4fba79f4f2b1b0b6bce0ca0c54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19c565a79c26bcf8e0f2bdd292579b3603490f58258e35dfb4f603dd891ea54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf6e4939e9945cfa4b9ca1bbaf95f65764681e5453053b5cde6ccb2b35c45ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71770c4332bb5a4cc29011722f9c0d235aa9f30b20938fbd33776dae877be656(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37704136d6477ab79234c072ecf7b2713cd4e0da3d457ab52d4b8accb069c6c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23878abfbc163486cd78b93bd8bcc909094a6c2e9dda524665bc3bc586d3d658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec27be77d22d9a6cd14850a540dadd684ce8a3e8b283e563578fcc628ea655ad(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDownstreamCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1715938e3da9e0fb48784fab8dfc6664c0fcd50e550d91570990b985224fd904(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090abdca73f711c064a9916399af0c088ad7e29588420b5ccdcd521da49f7c7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78bb514f54a90c7ab0d85f68890b1883efd6010104ca61446737594873727fa6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da39a32c55830ab4e8e2cc27181ad0461dd3bbf0c629cdde14a5c8ae2a5d8cf6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__389355ae75d740091bcd41a1426f77e016c7ba6d6a69088efe6e865f62f35f64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39028e353feba7084aee80388deeee89696916dc65a5f7f746d66df1809ee528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__758f45a99726115b62cb5e6058661750cd7c20075adb0cbde43b36de48019286(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813fa0b18c6a4cbbe0173055f6a27d7a15fdc0e086a3b6e55329d7b66bb86d08(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throughput: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d4f034142bb60e3ea0ee2a101b56561c0212e04250e881deacebb103f1a815(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f24c85bb94de29152cccdb9d02358129464024e12b23fd6c27e9b4b1b415c01(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce5b7196bd9b8cb0b488917563aa115c9fb76dc321370d4fa316b2304d1de49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456ca905f074175dbb051ab7b24aa50c1d568869a689dd5353fb7e936ea32029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe5d9fb1fb5432de5d54579cb1865ae5ca9ddb537d828090b42431dfd773d714(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0fd05493fbaba8651a6e2a629dd5fcda9e5be5aea670732149143ee85b198b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicThroughtputOptimizationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a86dbfdad20e720a9bb8f5fd9d743303e990aa3c55df0196822aec5ba48706e(
    *,
    image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__926019ed68a4cda156299bcf3a79bc3fa6c74264d338d5c07033c7584eb450e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__637f041fab27561e401c3a8b181fd254aaf200d34a7f1c65599593240bbd8afa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f203b75c1591010af9f742a82998955c506df6528423b2ad2ec8b30b728eaa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7375581c814a1d68f40b801a9628d0dac1af02b6460c7a3dd6b5cc40b03fce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45a5ea7e6e027522608026768dff772a78524ce5f512e1787f3316acedf4603(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84a24c9496071a6b533f08752731add79a7a630954465558321178058197fcc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc022f079501c939b80a3665a17aabca33d9f0ce97407b4dffb669e6f6c7bb42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e740eaf5c07fac03d8a1c8a4e7512e201694d4cec767d98b5d2e1a0b6b31cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67da7562715bee553e7051d93103df972b0cbf700dfed2d850c6e38d54b104ea(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorDynamicWebContent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd83a1ce3aa81a0ec1f50694247b8fbd523e949eb3eab84e03485073ea5a12f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35e9ec6c72ed124555e65deb601cfbd5f3c795391c3201de633ab5c69ac9854(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174460898b0e876166b49b5d2b823e9571432798acdd552c8f87c26c54101236(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab0ba76f858dfebc5eb4ac9971d86c34e10f290dee0595acef206464a073b11(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14b091ee7908ec65f0e0d360ded8e52b41212a1e9722738b29eda2d7e7ce5f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df5f844564a9d0dbecf57eadebdd5dcae7ca662cd465dbb3181a84910b0ff31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cb5d8a3c5a72a2891dc5d449ced6347b598b4c52bb2ad5a160236c467b3874(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsBulkUpload],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89313e105009ecf1484ea8a40df670e1b4b3141d0e955a1a10125c950737cfb(
    *,
    database: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4b52c8c78717f57b20e827878bf1eea3f8c221748942501d1e997f3c98152c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9192ecc0f7e0f4ab3e835316448de5cf33661833f98983a91095d6e445913a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5501412cb945fc092898701ae5938f7aac10dafd5e14bba46b29e475485feada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01f761e80cb39ec2f0a7ff27760654e041b034f50df3a5342277dc617fee8dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf4c935489b820c23f15567bb5affac68d2bd73b86e765e147a4c671fa21866(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b80ba6433d7b7a64800b9adef5eecb2a6f5daaf4db833480ee8727f7235db10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0657a8d9b284df58a46fa5e21ad4ec0c3fdca710b5762c4a7913df5849c7859c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a986832a5bb7640d70bbaf9106e43a4dcc04f1dafe9dc04bd8f6a9ece34786(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53a22732a483bb97cfcf1a02ea24ff26f3c9bd5df9f48d52c97d3d6dc317f81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0dd82a10af0eb2037ae86e541134f6cb9898856f6f449f59320447e54bd75fe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDatabase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36db485b49790428f0cf9e113cd8a56ba89798f7ac5c0ac8f023c6a46907f73b(
    *,
    dataset: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc281538fa5209513532c1c8d503e32a90cf1ec43b0ee3e5c95f55b6965735d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__793a72687e41d980023103b043c3691eb790a2f895c84787a2fb98a6a149a7c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631fc8512b6b571d39cb424a6e9a856b2fabf94f6428a514406af03a37792cb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac74df6907b04b9f5efd3d387745bc47a2fef4bbd9a1dfa7769fce9b54ad5a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__955062f8a704543d319504260bf02c754521228382da9121e6c4eef31d24d79a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90355e0ebbbab60b90659dc9a80755a1dc26559f373469b6b0a95d619ea32608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e92a64ac33abb2322f77a61b2b82863280e2f5ea89786bcc77640e58460042f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81dcadb850850cc525385dcbbca2d7cd5cfbc6be5257906efa0c31bd03cc1344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__402a2109d948b2067b4b7a396843ba1722f99563b1d1bc600b5f21f28ef2b4b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec9bb8d94a15c5be9b2be14f2d68b7327f3e13ed340b734fbfaa4480f7c527c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsDataset],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79fd3ccc88631e665d83adf1c968152e061b21a14fde79b6d08fbedee6370bea(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9be8734c0a80e6a21bde59e2831c75426343132403a8d8d5e21fbf121e637ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e971768dc2be5b2db4f520cb8521f76b199452265185334aae06b970893e1be4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a65d26435a9e19863636c568ac455b622ef1d138d71456b39cef044d49a24a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__914fc98e581f7b61de8fd43e8a62b2e69825a89de0c3472f9a59e75988a6d215(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05a9e674283e959f28387807d5157527aff93086268b599e9a3e1069232268e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33162dd064e987cd7e4db7b608ce1c335e3333f201f9ef55c028355104a1d22a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEcmsObjectKey],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78e871fa0ec54c6d87fb82e22bd448058e2f5bc716ef0c3f7308ae8e8089c4b(
    *,
    aggregate_lines: typing.Optional[builtins.str] = None,
    aggregate_size: typing.Optional[builtins.str] = None,
    aggregate_time: typing.Optional[builtins.str] = None,
    api_connector: typing.Optional[builtins.str] = None,
    api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1f02fab238f85c2269fabfdce241f4d8b6d75bac9456a36466fc5a4e136ca2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f42ed33aaa3eb94f17a985aac1c206176bfd9334370f9fa739e6d013cef54b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0ffb959ad1efb784ac3073ab579f1a1187b77deb40f18e395c5dc65d78ee73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7afe712f496ed23ea2ea9d01e8948e1db672b4b21716b652cb572f5f11ac86c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd7c7f15f03a8e3f360ffbd563e45c8acc7c8fd5892b5c24068de6ae5c4e5ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__534194eb1adb9d6bd4298c7a3f5ed2011ba3ff3006db0d6ae5d56a523d2300d6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02c3627de0133a94938c37dedccffc2cc9a88c7b34296c80ef17a23d9dbcadf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c9d9ae396df385f56be5a99fb212b7e0be7edab5d063605da6f1a0a264b93d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ced2c8948fd7d5dec885c1d2a1d6f700a0a7a3f47c70bbf77026fbcc38eae36(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27756e8f1f04307e13527ad2a0673a69fd4a2f13cad4853b75089b3628ab25fc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1369e85f3bba8376112ffe2215326cc7c6db02e8a3d27f5b459c6d9611538c60(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa68cda728724a12befe58905b7d1b163bfbadf179c7d4c0f78b5d0b3d6380b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aefcd8c400ca70d2c0b18923921a3197832ba1ce6b618d6457d5ff6ab2ec72f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b58536575e6d4d2b482dfd39766cee3c3da8d4120f92a1dc5a2e8f2118ebf02(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeConnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb7608a100a8a533664913f2bada35df28f01225198e6da8c0e62e3f9912d4c(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98546c72c714561662e0df521c3f60c30ea92cd2c3291e0121a3a77b08102def(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e05a0e522db73979b713ba526a85f712a8ffcd70f839feb71dd36d378899951(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa6cca3fa84f73bd043028b621c4daa899d321a18eaaaeef25090917110e456(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a2c043cf26b8891d60f10e96a2f8be5ce6f4cd739c68266a562ab9e7555fd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83700a1956b0877ce5ca425e9fcc4755dc7a3bd93a30e019da907fd2cc0540ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f606f86fa2e246d016dfa575f4f83c2451d8333632b67f2df8071b5a3f5f4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96d12c30b768f542895783ad09ad1c45101abcc51baa562fb88e19cea8a59463(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84666b8ebc24ea0264b170efa0acf6ed36f096fa1bac41067e4de86e15e3fb83(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    ip: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ec65aca8df09c36eec29d6c423c1b1ac64e941047ecc042e38e0263662bd2b(
    *,
    absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    context_root: typing.Optional[builtins.str] = None,
    failover_hostname: typing.Optional[builtins.str] = None,
    modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0579ad546c79e72ac2254b47e052037d8acf6fa01d960e8056616b40c33aed08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459e9e2f0fc1f5057ed66704cda2e78a22b52952eeddd399a3317a6f1c57aca6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a35cb98a83ed62c24c198ad6df54ce4c4bcb4552491900de62c803b3746870(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889fe1706148c2e954706cd50a649b3c7a1fca85a6a4fdb1023742724ef1e2d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1053413a2b533a9a47d7f9ae20d384ced592b1d679ae5073ef4dd3501b70b4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9346403d777230a33329ffbd47c199f821f959c70209f4e5c6caa66402288509(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023bdc22289a4d2fc1373ac5ef1e2d55ffbf701f90ec0fd7e178fa21eed8800a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7837c0b81f8f691d69ffbe8c3b4cde6199069a0d5e70448621d1fcfa27dddf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d403b7f3b1e67804f5af102486398a9ed0ec4a1267d168d8249608e5b6fc245b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a869407324c6c96e660a25aa37c096d9b534b38b4565d3d5452118e219ef64db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ad3d0b1bcfb594b0e6d8fc048328690a4543dc6f72465b78b7cbea2691b2da1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02716ae7504df7bcf6048540b7a151263a4b52ae97098581b500aa1e0719cd0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d30dd0f4f3aefcd236e80b9fb2ab67dec24bd5b0063976d4879f1b1bb5e275(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b637003621d675ebfb2cbb3201dec1d808a1c769daf61c6ab1c78df1e4e9021f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb31f5ef92099663a5a7a15efe9198a1fa438ed4afa1fe99b50addc1619ea16(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a64652c815f6374b13a9be943ad8e6cf1ceadef0eb0ff0070ffdf1cac699bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__533b80ffd323ef6e6698bb5b79db64ea160e6e9fec4645d55d7bcecce419147b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9d9b3f1a56b510e15b5d38802af449d6b8ef8dc515d5d983f38c47771dc19e3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc1f6f0b92938615705955e468a7138fe44fe9d9336a23463f1a9f91936dad0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987b5f1c042d416d8e7929611b290f0259a6f03864d34ec18eedeb6970c531be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1acdf629011cb8c1e671eb09ebe7990705575b199809b32eea6df6452777e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4555a0559f3ae7fc3c6702c201577fe64834d5e868ab0d38e47225603530a469(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96d2b219fb4148728f73ce823cde140608fe495c7f1288bdcaab5563e1722423(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8897813ca900691dbfb7f8588b4bd0f95f40404560edb7d7eecbdc08589322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905ac54ab73a035f4fd77c53d99195855a6e360ead5bd3e87e71136c96c2f366(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559d727a8bd0e425290e301b5ce5dcf387ef00445eb5d74a43f1d8fd09c05645(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingDataCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9150b35ca0f8c7e3fe5e88c199e47dd126e5a668b1c83dc561a87e8a782869(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_persistence_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ffe45f1995048cc7e9c70be6697ce071c429c54174f3162e5ed94312bf54693(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f569228e6cdce14811f8fd4778fc2624b2253bd688bed0363b66d9297c39f23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f6d89e641a58dfd73625eac0ae5e660c4c914d090de4b10752c415acc29f8d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b06263ce14e15aae465378213209f5ff94d2895a174428c7b6493312abdb78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__939dd5ece17fccc280cf2ba2937c71da6e1493d1d58ec0f5a5346e9689c0f294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75fee4d38dc5d57be4b8a7107c9d4b0a8ee26517e0cd3ed9034a607a83f7fa74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4f8c9acda4bae6c663f4eb6b3e7d78d8173ea0fc13aaa86202f79a1bdac07e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a179d14266619aaccc6e957e81bea67216b6f1ba28fe520bbf6c914926b5e815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e482e6f5b6127488c996f0981c8b71bdebc097aa233a5b40ad2fb8ff7a87ae5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30ea14da7ab6481a2ae321f44f315160707faa12e53950adb55baf79129d454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b62c6847dd5ec2d035153b05574daf0e85629fd2ab94e8b296218381f185a8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeLoadBalancingOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06af4f059ebb5a89d0ece762ae74f82419e54478f966c5139ee490034f3e1d81(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    domain: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25bd16b3b75576f5a8d86e7f4f1e352bbd4de613787bc740e7e7d1b788f4e49e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__184b750d6ca7c75392988bf3effd87572bff8a7e6e9ce4d7ae9b492fc0a9ae67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8e83dd2e0f709c49b42da60d0757c28551e275e0a7e0e9438302ca55945716(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c46c11c00b590b6d64eae3376f50fa649731dea2f52cac20dead105e603f6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__363c1123abc01aec737636250f731b16a9eb495a743605e0ce4c298d177c3093(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8daca7584028f1aff601afa0d2705e06a535b9c49a5cb5143e296608308ba46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9da8fac8e1c4b4f4f46b4f8c48a7b8631b04e4aef6cee7a7fa189fb07759ff40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f4078508e4e5cb0793ad22f13443e8c4153b4d63b5b7bababe58e81af85a6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ff410c748a2866b767f6834a180502b5a404cf80f61cfc6229d23d1a5c4c401(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeOriginAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41718eb9a9b2e209fcdd2f8869e819e149ff559ea661b36fc506e861625d7bec(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de0f8e20cbbe3b71c5798a83bca9a08866f3e754e3155ec7415192426369512(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd718836932e5fdd022d6dc364aeb79f54670b6fa6f287540cb04691421c0a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3484dd2b59ec378561acbef6863d3b77173fa89ad69cfb50d5dfeec99e30a59f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e5ec42bb705e9b264c42a8f3f64b9e1ecc6f266c72fe990045d8ab4bada2f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe88991ed55d831599719f96894ce21243bfc34d3f7a2c4bba3428c140a03ac(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirectorCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e58065c6f2b88d5137eb0d701ed8321af9d7373539af46559fbd5795e2fac21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75142381ac04f0718b2edb2aca180101a20292216a7b8d72b916af8fb05d64e5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dded737f348f0f31ff621b0367ab2f301effe76790e5f8bc9bceb01af427cd25(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ed4f534b16cc14299a111752d5b451a54f4897d6505265d75d148549a009ebd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a03f9e151bdf62aa0c7f5bed8a2f52879219a6244a95259ea57dc2e5976879(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38893073b0768565c74c5fc3b3a39444e7b1f97a87f3e84f6310d7ccd289c8c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe335da499d7ce276503fa4078527d4a37e696fb31b294689c0f162e7cc361e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8560fb97c189f2054b42f3b2bff0ee0b9d8cfeec032f1747e421e06891f6f80c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeRedirector],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9bee92ae23247216387ecd66818e8204c3c8dcd3dbd85350643ee3be95cf75(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06a747689ccc9fe32c15c72bbc55f95a276e1feee880842fc56d14a6e113366(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__447e96378c0a73848c34b3a70f2cdbd635728c79625e333312c25f37f588ad50(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2832262ec505c1f7b3a76d55de0b9c1e98cf836496aa10cf4ebb18ebb0a5c05(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d689a40f62d758271b59cfbddca57bebf227df8b5ea60a63f54aa097c8c756(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b4b6e7299155380fcf692ab38ecfd6f0f3bcda5f9917ec6f785850e8ca6c127(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e428f28d0e69df0b6a98538748ef24619a79976d698985e1646aaf977a7bbc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeScape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae848092b23566907bbb84f9dad8150d22c83a65273613aa2f5d3774cea47529(
    *,
    detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
    i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361375bd0a517b66c5094c1f760893042121793ddf2e079e53437f9b4b2f7ca1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0cfaf3039bbaa27384c4d29b2649cc287685dd4039290172d01bfbf912d775f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89cfa0dbb61df4eccc2d518ffac0dbc3be45a6045932e02526aff21e68ef955d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37203e45ce98edc6d420ee6dbbf87611a04874dd433bb416c5f7703abade22df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ceaa252d83836b02de168066ed5c7a5c794db5b68bec98dfd01e88328a0d186(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84c5b998aa26d96703e0d7495399da5e2be7e1aec4927ca169e0bb8e74b79d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1db020f9ff851dfdcacbaf206060aae5e8c08a5920892b744297b9072e6f0a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4af6edceb3560e435b2de56107e527d29147e914f5db9abae5c09150e659b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06889e01412e0b21615c5fcfcbc27fd35cf7d7ea6345ec06317de3baf2e68e65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438b7cf0225db0264e0c93744ed5fc77d1aa82a5e768553b073478e9d922477f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f1c0413ae254ffbdaf510e8721e19ad583850e0ba503043a2a2c9321be9c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c9837d02dd2ce68e5f812a9e60b73003701e23bb898cd560a66fd3499d07ecd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeSideIncludes],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3a89abe5689ceeadb83a0175fc719c11def4b7822f51a98a9f75efd0c434dda(
    *,
    create_edge_worker: typing.Optional[builtins.str] = None,
    edge_worker_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    resource_tier: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fe613755ed21c9cceaa3f7e0562e9bfb70f5016fda1dd615ba37f3dc926385(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dcdef2adecdeed86c6290490bc7e2da42db1cfa3a7fa0dbadc53cb516141240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51f44e241b51f3145fd2cc737b9a92381f3356f4188be058028ee0933708267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08045be2c3d0a04e4daa593492f782f09ca197e40c1584dedcdddbdd1304622(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__502ea200f9e84edd8afe84e712c725e7ee9bdb1407486514eeeb8e90eeb7c408(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e93067cb4d30cbdbd1715f92a1f189c1f26494ba1c0b0b77f5aa077ef70681b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81404588748d684177d5711681d2ca6082510d1a37ea53399e05716101c87ecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239d140ef640f1b901cffddc27ec6c862a06338ca734d3e62636bc66d58e2a35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d4f22372f31793e1bfeeaa38f8b9d3b08ea4285788912c84c5830564c2c7643(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEdgeWorker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85d641501a077660bc5a72d4956da2e34d822b79a18a7de0d69e983186300709(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8616e823659fa85dd872df7cba697c1cf17c23df327363d73e9392b1c7a1de47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52cc1cb8486351545e9079f7d9ec32058e8958abe4a0bcf10db3aac535acbcfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__930859f39c7401e316a4b418b4709525dfae55374ecafadccb2047fc4f092955(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2740bed0b016a9f2a77aafeb9ad474b2eb5a287119bf177dd9a4aa48d80a48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5e299b1bf73d07e8269d8592559ead518051a0f46e54c1117e724b93ec1da13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9d2f03fc3fb0b0cd4f57789f97281c4c54d04a669ca5ae92da5fa0b9cd0e51(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedAkamaiProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fb619488c5063195a73f6ec082d7665876df491fc8404898301087af228fb4d(
    *,
    anonymous_vpn: typing.Optional[builtins.str] = None,
    best_practice_action: typing.Optional[builtins.str] = None,
    best_practice_redirecturl: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
    detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_hosting_provider_action: typing.Optional[builtins.str] = None,
    detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
    detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_public_proxy_action: typing.Optional[builtins.str] = None,
    detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_residential_proxy_action: typing.Optional[builtins.str] = None,
    detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
    detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
    detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
    detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
    enable_configuration_mode: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hosting_provider: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    public_proxy: typing.Optional[builtins.str] = None,
    residential_proxy: typing.Optional[builtins.str] = None,
    smart_dns_proxy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tor_exit_node: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    vpn_data_center: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f2cd7c98097afac225339ea98466e1cb778b3698d3c13e338b05ec2f26c367d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fd5f6bd2a6c6c4b30708799399c55b4953489f0b3eadaeed5605600b51a1258(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e366d08b0320ea8578d6459452e395098edad0644f240c8ef513993ef8dd63c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c43118f11c1b2aba46923b297c4b76e4047f76d600eb308698c2db3b3e04cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__726280b3a18bbaaf67d1534b990e2c36eae69cd930c7f3eca41128be3c101b79(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c57de068b8e0decbb4691cfe9ecbdd694d2ee611aa003d75f38a2636430897d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb46d6a925b05db158662a3aa59fc9e218f6c0a97a3dd167780db26f402b2e87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c289b4e278aad35b2f7c7af673af41fadbceabe044443fa3b2ad5c6d9a7ab19e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efab4e94b99ab32be864be99e4b83c8a8fce1b5e76189b3c0692e878963f8458(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e9a2b0a7548eddf2e75be475ef640827ae90058813c694bbb065348bb7a09e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b19c0be1538188da8576edc49826346f198d4a5ade68855f9c53a9371517829f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c746429f850a4d1fd325c07f2ef477981de379f9b65b09087d6d88671a7c0565(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd616dc2e7afd760c91b4e02283fa95e3578f842bc4bfacaf827d3fc8c566b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed84f250437aa20d582c384c06b212d1913ec7d79db75e5c51bbbb4c1fe09ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33168211e83579bddad0eb674716fbcf8a5863f4dda0068fc4e628971579d11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db1168b0186d642d00d0f03fbaa2d4c07b9682cfcb26f0b01c9853a6182dd91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efc71591660847dd3447ad620793b23ea85505d9435943e792d63775cc8051b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248fa46e23c6e011a23e4c6a4a1179ddf26919c798349a76b57f42faedf07f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae2e67fa3ffdf5b0ca920e2e81d743a3f5bbdbfdd9fb9e25da52bb215c9059ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cc600d70f45614ee47b9557c787ee51d73e902a66629275b8e10e17d4d42a3f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee6a9d94dce635dbdfab500cce43d8a79f02721d546c2570a3b840a4370b93e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5324adc366a59fc9b3c0908c84e12ff08f936b63b2debd4bc104ca19f99182ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1059b4af3fb825b07d5533872f4f79f5e273cae7d59ae4860d2f1a5470cece(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2529cff1144376a299404292aab718adbf45d7bafaf312c790d6e92d9758c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786587a0ef8dc8a7c95a5b68d9d306f9d4a2ab0b887e14aa4ee4d27b5ece6be0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0426246b6159f202025976f9bf1a0c5ecbff4646ec2b91d291c4b4838c9167c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9477d521ffb7ae15ce5e4a6258679acc6149700812dcb3cee25bc5eb69f76c71(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a418d66b6f280d1f6c6b183b05c21c7d378af2bcf44ca6e0093bd87d61a67f6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3518ee35018ac2267ddaa0680e9433ea9f3add2a2ebe7548f282923fc92cf541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02e38e641b631e4a9737534a617cdfcaa9f32ed6e4b36d7742b760a964012a67(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e583992d465f7a99b30eb9b52292d95539ab4b02bc86ad14a3b0494be773987(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855544c05d3353e3cdd83c9ee4b0b4afe7c51d33553846ae41a63aac840ed55a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e507752abc5f0e4f704e593256989729cbb5501b4a119446fa5085034df590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c965bc2052a6f14c650606aefdd6bc6317fcef8c05b8d87e93d8d562a4eed806(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b790a9c72d84a5b4cc8c300fd53ffc88318357cd151ca6e1000531ab906796c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc21d1001f6b5f792fb0649b67ea192fd8e892eea8a8a995f5090c8326f0a499(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f06867397fd1dec77c0fd212bbdbe57e856615f151a5001ede5dc9538ea26bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b754bd06bf1b891f520ddcb1ac3b65d6ed86f82781417cb9954fb285d6bdbf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEnhancedProxyDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ec59e31db6219776cf292103450ed19d0c40e1ac7467cceacb37ffe4b19569(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c0279d6f6041616dd5f2fe6efa98a440da602102cb61cebda0e3b6f9872977(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76bd5dd730c1452ed9db8d1a28bbb56b625602f90bd843deaa9298a72270095(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af56652af07ff22b2b6e2394d79231cb0f0750884590908e0f5f9ad95a68744c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbc0c42e312653bdd6ba74ca19d5063f405e99e34fda525a09528a6480c8f06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19b7b0e5bdadbadfc1ab5a1e2b76eab595a9fa6b53dc7cdad23acda448cc41c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__712103685489c7af9ee37bf75dff277639f774ac34affd95a459adcfe822a080(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorEpdForwardHeaderEnrichment],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c03f25d69c80da3200e9a625369d8e211272146767ed6ebef16307ac4b96804f(
    *,
    action_type: typing.Optional[builtins.str] = None,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_hostname: typing.Optional[builtins.str] = None,
    cex_path: typing.Optional[builtins.str] = None,
    content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_hostname: typing.Optional[builtins.str] = None,
    content_path: typing.Optional[builtins.str] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_method: typing.Optional[builtins.str] = None,
    dynamic_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    protocol: typing.Optional[builtins.str] = None,
    redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_hostname: typing.Optional[builtins.str] = None,
    redirect_hostname_type: typing.Optional[builtins.str] = None,
    redirect_method: typing.Optional[jsii.Number] = None,
    redirect_path: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__182c8140bccbe57addc59325dcfe6ef4ded66704ab3d9c009f91f918a70a6b39(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99f24e8d6ba63342daa760276b700d85e4eb5d32a507afc5608c72388d011fa4(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f06ce7461c4a2c2554eff9065017b2c457f8f5fd8f26c347a680c11ade9ba0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6a77b86a4c08f56b4c084ae65407456d580212ada25e061c80a61ddec5c89b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__283deee409d1f283fca3dc4dfb415f25f78e9b43e063885ac9d725a6b9b8ccfb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595e5412827b05b40da808c1a801b52c2d2ce74efac4a7e4bb69742aebca8323(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bbdb7a1f0e1556591561bbb0c82e9803d5293961f460189c1f4145df1b37a1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6048edb4369029d1a27178bb67def180f5ede5e7002416b69acdef936e33c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0753bc9ef2b8e6f975dd591a444df96a8205c3439b6c028c95c8af9dd74a763a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b092861406783f869197fc03ae0c61d6e0e776dc034fcd62252a189231d54b3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60db2d8c8b338f02b955e20fd1a7713df299ffd684a4ac2377ce75363d211032(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc90d9c94c6ed279bc1e518b43327b049420ea8be6045d8712de0d112081e3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c1aae9fb97555d4568f51c8642d1871c8f43bf45938fa6e63e5c6f34075f41(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6e197bd2582fc0561b277718b1e856ee48138e26ae74ddc52b7fc4077d5bb33(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5051ba0300e77027c573fba16a0a26bd2b5b0b2274f1a489761f1cd65d483602(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e358f8a136854739734d0ccc8f326b7e42ba1b3ef845e88405f5581c784fcde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4d47ea5617c406ed0fbdf6ad58abcd82d81abeea4749d0753c218d9b65a7cac(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8548f34f668a755d840aaca4824cc1528b92eec7871cdc9784408660dacb8e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb83e517672a22b83fe7272be39c8a8949fe1defa0103a2e3d8282769aa93247(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1cd3ed6920e2047fc5d6151cda5987a8647c97e79463e7ae4dce3f7fb2cbd14(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailActionNetStorageHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d825020ee49abe1b45c921dd6b8b3d6c5d90ee499a322b22d209cb93605b6bcf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2c2c42c699b368da53591050af8868aaaa9fa0d60d669aaca0c03f60e918e6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__001485debbd4a34d6fdc1376cfa50073046f0a6a5a14732c549b9b1a36a2f27f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9151b3a37fe0d673cee9f90aca87639936c466bee96c141b19b0306d631aad19(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd9d822c06acafadd31535c4b18370b4dbb48bcb2fe5241682b590d9d624355(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bdbbe2d7ff013f0eaaef1a6acfe07da80fd42f6b38d4f2092ee8da6fca5c942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af0f2476835908ab5d82013be4062656c162b2484ac1aec2d98da26763840cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a493f3ec891ada461161626736e4b4bb150837d5ea247ac52106f7f19ebd3318(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecda67c09495d162f1756535a52a85d547bfbe2d88b43b9364802b788d2eb8a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7321f46e7679b13dc1fae29af1a92abeea040853d9a6ba23beb52b72bb24ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ee925edd031c97482451bc72e2978c14fd2606ceb635d71310b2f431983001(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1207d1525561be361654684d6c3aa7c1199c63d48213ec89ca2474c5e2690a44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf489050bbd9be9e8a6534fdc58bdda69d46365b6febf881b6c8178e66be3c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b85e6355bea19d5fc3d864e77f8f92b88c4428e6336e72ef5e43a38d8f9cdda(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63543d829193f6ef4273684efbbfc47a5f68ee32cf37ff057dc3a885a5ebe8e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9737661e70aa12bb573bd5bc4a1b8872df7d549b858f741ab90f840525fdf88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6db03760030b55b213aeca2383625e9dffabf8d7de410aca6a0c5a34568eb7ea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f8a97d4ea77027eec70583a850ad182ab56e72135703b9552b04b39510e2040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8efea6f9cc78a90813bb2bc81d88920c1f0d43604e1cd08094d2db36f28336d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e00e788f30acd6ed9459b10056a3ae3dafe1c988a4a0eec1664143116d3b6f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4fb65e6b1422cbbc3a01bf1d8a0587dfaba6105e60943573c0c3fc972e6d912(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef8f68f4e2dd1fec9e0d6e59e31c51b52d75f9a25a343f6c4f1a6aa79c126e2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a605bc48ef2b57ef14e57bc4592ccf959bed046cbcf21cc9f0020a53c3a59500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d7facfce27e4d1e6b4f0116f13f5865cd55d337dc427737cf0738f79016af11(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd26c7252c96c7a824cb425b706e2ac007c38393ba4cd44f9d5d081a9a13ced(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c167c36744b9a4ab7e9bb9cae8458258ca0b4adef15accf056a2f91e42dfc3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e777492e8b3a1cac93f9111e44aeafbc5c92024485c6dd364a93a2a0ec356a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26696f39f8f8df3662c19f2005e9a6fcb966723f3cc349dd5d092470f40dce6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d76fbb193acd41a63eb8183e22148f8aa426e6f861e1f25809ee83caeb7ce0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5f6962b5a035f9bb272bb376f83dbcea5892b0e1235478f55269130f971857(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f99c1f6f312e4531f7fce1619b05a13e57b8de8d7c896ca18c517f36783d3482(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca2798b71293fe932fce3175c5b3f1b0fe8394c941054179ca01e6955ba62909(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab19962f97ab93420aa1e47b491eeb536f8a06baa7c1ccfde8058ce8483a53d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d278de2dda79d051ec0176fa3128595dce1f37d3b69c15b156111062827e60c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c835295ff4af13843376297ce38f1a385ab31d2df3986eb9d0458c972bce4b2f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailAction],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16357c15ada8e0f59a3d4df7493b2071d5ee47cfc41da100bae93ab8867a8c7a(
    *,
    compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adaa656ae9e7bc2e852756dce4411dd66e937256a4e382f3d54b822e302e7b82(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f35e718749a7881671643e5433c2b0468128ec8c8988502a19a0e6ee5eb0c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c841f2a51e5dd205c29be2ddf578fa175fc1522f6787f1ded07c4857b481781(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1516c4c1b61e36141e9fdd1186ddf6dabd18c6f8db97396d9b9c173594aeaa2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257c93e64cf871ab90ca32b373eeff0baa713a24997a870588b3d94d2c70999b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9235b281a9730d9619bcb58921b83144603a17608d786b70bec9324c8bd84d6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFailoverBotManagerFeatureCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e4d587c0d6712f6865dcb922dac94702a38c05d7c1716e5c8e8cdf2f125ae1(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7815d9fedead12a1be256f71f63cfa70c40a25823fcf51b0ca48744b2c7b158(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ccdbd63f7bf380a2fd6499ffbba1491b18e9713b476b38c74a39a7f810d3953(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89816d35bda8b149e01bf300fbdeb38ceeeee8bd79fb43e52183f1e13d5f7c2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f792e94ed8efe9c452d923928341ef09a18ee4cddcc9619138b54554ef0706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d97a2890b60c1ec10d7fce74d5b1e3b69c8b99bb64d19ec972fe88e85878ed97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d55a0308f1a0a42eb4884f3bffc102cea7de058fa8ee96f2890914a7645ccd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFastInvalidate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abaee182f0f76a8545b2373fdef8a57f95c531808723dcc0a85e4929f7a01a40(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d8a3d755129e012a32965e7968368cc50fbd9bf80893767e87d9ff30a624d3(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3228fa990b288986d749408b59ab5e2cd215a6af47bfea3ce28b3e9db95d0063(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0809d85827a036de88e34dc94c1c39f88b03e51ed5540d1e50f00acdef49450(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a420dcfa485bb9262197f27cd6d2e59510146b1601c79782097ef5cfff929a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40964f308fc1773d0ef8c1d3df01908fa25be275fc99fd100be8a1d6b2487dff(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edf8c7479c4b008ceeb329677aa973c4c8e9da8f0373ec3d2b9ba5998a5fbb6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9606b126b968ebb3e17ab4b9af4099c1aa270c573c76c6460df94809198bbfcc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcaedf5492c7e21035fdd6588ac291b5eb3c2dc64da4c3523c746ea7f2404c3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8844b214733b839a18244cee47676227ccc9f960ae2de055dfe6d7cfb789effa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d02503529f05e797082e3575047a4c4c0b6ec52f3b32660343b2a0afdd467f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bb1ef42eb0ce091b829a0d6ae15ab2e9f18362adaec0275772117e098153e26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400140bbfeddffad2c5f623f43ebf015025ad6d1b9113612ef0d8a573725290a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63cf1c0a922e16a2a8574de516ffa1ea785348b0292b4452c11f5dc9dc66e5d3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac0e01f1902ec5c9fc6fd7e2409ec6d56c63c829c1bdd2794b1dce34b005ca4(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b6630a06babddc6c4b977eed9ba76ca5521e55fa55dade262e201fdf5b047c0(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb88dbc7a2f7d16e7d5b76c163ced160dec44a70c86c4ed7cd5cae71eb8e0e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0312e22dc19436b5c169e17de74c73f315afee5502b12b66b27e282349e5a8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52d40ee3378b890fd0038c6e408806afbff8eb575ce137f77f606e370015e72b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5329b1e526f7599d3cfe23768f943c012ff1eae638ac7d4c44e5669e06d925d2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlusCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e06bd183256b47eccfab2d55d892b359505fd10bab7821c873b5de5de0a709b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f868026d3b77f6102338f322894f27a483da2a68140989c41bc19e3ab10b5d83(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df66d61e82e5ec5d1d7cb8ff3332e8a9120b72a954cbd01eae452e8138c6e1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeec16a8d726c28100e8e7546d0015bc555e960a3d21fe0c997c1306a9e44dc4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51abe3cb5bb1ca4ce3f0c57f63896c8595edeeb2505784e54603004074d20ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e9d1a8143f06362ca59eadf48fbfde3eceb12f29f824fa64929af3bcb7427c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c748dc8c831e6455841dcbee15a19c4db15be6b6af3bec28b9a7eae54ed03fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bbfb0c41c7c149cf3f18f1ffa46a7649724b80abf29b7fe2f3687d276464cee(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorFirstPartyMarketingPlus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cb6c208d1f722a75ad4c7263789c8803823fa1f8c815fa87b4fcda4f22a5b36(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47669c31b8ff65b57d19f7dc4062f10c73e09cbc8a8bd88e8784ff0639366603(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87781d114c85655ae7aff2897b87ccc42a879bd3e141cadcf5423abaae2f2cd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bbb2dcdc7e61a564b50e975b19995b13f23a096d4a0ba0a347944110f81394e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afb23f801d80a71c6ca3a36e788efb6d6174af3411597eb4c03ec951332136f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09bbfa9c894b65ee4013af0fc58ce3e77a30eee2833317e3bc2ffde6c2fb7c4c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewriteCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__537e924df0c2acb603ee589c4cf7a6976c01b05ed6eb6af5c981b8548e041234(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32acd501ccbd2ffaf8cc8d1c5cdda989b8c7fe8ea9bf888db92e101721b22d16(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16cc6252849a056e5360f841cfc95199c61163bc1aa27e0800e52248539f3ae1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d463599f4068876033bac243b0b29833176fc7ce6b3cf3639065294fccfdc6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34e803d1d2e745ff8720bc795ec315ce4bce4deb8342c86f3ec4c551dc8505a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7febfd690aef90deb242b17153c7b12e8bbfa3d067fd165e57124f97e37ef04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338104720c0e5c177091e9d66f56254c3708e13b40277a921de04e4f02292d58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f22831e0885b0dcb67ce5ed5cdd1da96d8d8be04a8cbb76baa8b36e1da5c06c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorForwardRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2188dc250cd5dcba78756102edede2e3d24b590c721be3eafcf72eb0933f9e(
    *,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    data_header: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nonce: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    signed_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5561f9d98a7517633880b8e84172fa909760a3e7fc9b5772b08cdda2fcc4a8f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6c820bc1525d11789f4d7c0c6595ef1a63a6dee7df373ea0a03f88e4452e174(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5b1e49ac9ee55ea1d70061b8c6338fa828f5c621bf26a6bd42161eb39723a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d228335c63467b10196b7fe6d417c2db27e1da357dc458c8947267d83fa08f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b522b37271bf7cf7d565dc33646e7080a081c7c3b5dc5283febc6e02cd6580(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa0fa100999083d7067260fb5ebe424894c9f93d27bd27540ea63c739bb6ca4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7de55a76402e1e54e1b96368d0182ae04ce45a0f92e76108dc51408aa86178d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad0d5fbb62eb5891fc29204b900109ec20d43d6d139a060c4ca9ff642fbfc22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c9832a47a7f241571967dc29cffb54282e3496ca9f8175941bb2d1c7de89225(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2caad6cf3c71f57364f43de1027a171ee83338315d2c88d08ada0cdb8416e9ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19972b496d2123fd96fc87c0f92395a43d08ba8edffae639928e04bd7096975(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be452e0baba597fe11c79ece0d6d95fdbe0db464cae729583114e3bd29e09458(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88055b443296874eefd81e28fb8e981a63395d90f250bdac54eb9dd725b84e16(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorG2Oheader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b231b115db607cf4181107ea2ecd9308c44dba3ea79834c54a740dd8423cbbcb(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    output_option: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c6a5c96c62ba3f02de718649245218b9a5e0fbf4556d1619d91f06516cf4a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e290425617ab7c3552c96add59c60bb79b25eb9a85f2bf5f55632b29c93e3e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412889d0b884a7079904289e7c2a80d452b466a713ab80b708f77d3f3fa1a7fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e464fba559d99ff8fb950b665b7bc40f2cda22f389fc16338c30fef118aba7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849e527d1c8d2907d9059ec94ce71e1a657b0df76f0b62ee955e2ab93477934b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4a5adc99a493de92be828387f238e5f488749baae198bd344a71e0915d21c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e100ccd7562c1b8e5e9113f0fc448a2340b694ad1ec885c4ff34a9290fb5aec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12a4e9f37359c6354fef8d0d12d9d7f78b8ef5c5118b66d2203744a5317ccc3a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGlobalRequestNumber],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6401c225127b7cef21b3a6a0c24fffd7d235f6545fc08b6d91094664be58f6a2(
    *,
    advanced: typing.Optional[builtins.str] = None,
    cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
    operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
    post_request_processing_error_handling: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5bf526112b8333f0a51b1cc82107b6514bfbbfc1a6f9d5f96fff937aa08c526(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff82f6ce9f883d0a3fdfa9ec7ca98115ede9337eeab43d269935979417c32ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ceb6ceda695eadf39609d40eb0152911ab2e1c8d464e1636b578188af44824(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6378688d6acf35993e453ed5cc0f092679e76931cfe828b732858b5f5200bb5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8930515c8f5059eed0b8b820c326dcab2272ec9c8458ace7b95e58afe116f458(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__858ce0e8b3ebcc21c7a778bd1fdb814a09c3053a676ef0f8cfc418cdad71147b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95a2db5db9d3e8c6a8a394e1b2f99b86d00780250640b00cc70b172b8e16c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5859a167c8bf0bae6bb7ca7defc74a5921b99a9f1f821685cb5a7307279e2b0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adc15524de0daab81ac047374f5e274338da1e17bf2208f8360fbbb91698892c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22439a65be371019aea6f97cbf1123ebd1383695b163e0936c70d9eea8c7cf50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e4572c45136e126571f3192438503951674893b557dfaa3c0bb311cc3f6c57d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGraphqlCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352f54363ebb0b7bd1cddbc7accff1cc1df1d0e0bb6a99dffba7283f66215031(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__373a5d4bf4674de70a4ed41e901d78251a8e3651035b21a16002211458f88e8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__074e401b9f74d05c32fa7eabbef383894e6fb90dde466721a9771df5fd2cbf58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163f85626234ec70d1143a860e5ed9ceaac5dd01d9573dbd68ff29e19798a6ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9123b4ddae78a6296f39d09e1dfbee0a4d9205664deeffa47a3a5631514b192(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa5471bb7dd39e7e7e66d708c48da8565b66d10186d7bd862a4232acb178bcff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15ff3c37c900f51730a3070696c64915d993b86ea3634d0188acbde9d2991b9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorGzipResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352059d69f59b2fd9a58d42a84e24676fd11db18fbba5aa23b0b32f1a0a1f6d6(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d59369316a706f50c3db830bc00f5d847be8f01386a03f16d42a9894ed548da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9e3aea738babaafdb293fdf6b298cf5b0187c566dfd298e17a54e2cc6ec7b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6014f9cecd34468e4f446985a82faeb5cd898d6ae4c33e49117980aded43ae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeda3a2d0d77b032bc7d2cdc602e0932b5f7005bd7491481d430f8b5f5282fee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e12a88d989ec528960a6568d2ba6bb5574f557590e6511f252779fb021f09e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83fbf74053c66e31145686e8a885d042b3e182a445cfa23a5b5e0695d056e945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1a4576d08b16a5d6e21b1da45b433eb666959e648011998aa1e91184ff2c5d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHdDataAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c92a9d76eab8ea8cba67e971c1da2f742267fe475918aa420abfcbeb91ffbf2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_reconnects: typing.Optional[jsii.Number] = None,
    retry_count: typing.Optional[jsii.Number] = None,
    retry_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79881c38d8bf318466e85affff69993955288306624c22255b2bb1c1128209a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b46028c699fd6f05032bbd1136eef13a89b1c4dbdb894a1b6f927cdaa6e1ab65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31af0c1c49ab40f7e06978aee6e23f563d4348241866a120f9f77e4ac042caab(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31774314a1b106a9b572b1da55257588645809f342ab4d425f2d505c14eea269(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4056e59e1bd735396d36b97e4be1050c790fe4dda06c208e0235d61d7346714f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf71eeb3824ac9c290efe4a8a01d9f3d9e35675578c0a3f4726e91c5874c7293(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d87c0dfc01b7d9802cbeeb2ca94b6c32cbaa19e866623fe57d1b632f725d81a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b100cf7766ad78ceb9f516758ef9aaf3e1a14c678807e8338ec47348eee03b1a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHealthDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77bf58243d91cf0cff385ab5dfff692e32c3954d0cfba09c2f8c4a7a38cf080(
    *,
    custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hash_max_value: typing.Optional[jsii.Number] = None,
    hash_min_value: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4f217113b0c1be80c81261ff57b3ea1c01f93ea65c252238c534d9a88d739c5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f4f34ebf79e5bb76e7b4dbb63f361f7ce00835a04a75bcb0428aab9fcae712(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c9e2e2f07a6bc721f6e75232e2d04ef09098c2cd599924136f8e4de8ddb2c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4a24a4f75b58f443104c63efdc0f40e4dc1956a9949ea320b43fba75f43c75(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa92a69e074265d25a4b9683b29143fc026525648f108abe77912a6e9eddff27(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2861ffd39e51ad7c11444fe54aff8b3585a52262767d31724c5529298bb07bed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7f370fcf297d67dd3c9b325d5052865553caf422cf5204621df271e654a2ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66cb9a9709da4c8e6f868137b9f921ee38af4442fa0f7cb73731bde20a7121db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cec77851b3ecbc0ea86e539d56d57402f5a9442a83bc56f7bdba7b6b15f8cbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__521038747c3666e94e8cfad0da81a26608cd23d0d6ad725bdb143130d6328829(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHsafEipBinding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0ae34309894575d6b314aec3fe7b0f07b01c511891faade05069a2ee0eb587(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df370990125b8785eb19a2037c31ffc0ca39ef8a73572f5f843d35175b7519a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5133df56ab2857700c5f77d799e746ad7b129f77a7d1985fe976f50ab3cb5db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e2684ae14d438b8f97a68c68fd30e1b561c4986faf173a5daea8958e225573(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0cb299b6ef3a182c0016436a4277004f11e3b99d556516dd3cf6a924666066d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05ea775c2b972e7d4442cd435080bfe8715e2d5bd747c64eed3a7034c250b162(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813434e748fdaa8329f7a52a2f21408d17bb7d961c866e3745eeb289d8d576c2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp2],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab30bc0ad29f2d57f3bb9a47b7b669e91dc30ce6856b3bd290bc3330b67c886(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343b7d61528f40be371201d6733a88e5f44b7422b48a228e455e6a0ed6bea9da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2349c75cbe456311d36c7105bc0ab6b7d85c5108d127eab48380236ba8ccc4b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c04687616ff586a1c4dfde2e8c4ca0ef62967650d29a6a353c98bd3d6c3a155(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd3b6e7df25614739455c5715a45546831ccef3788144fcf99fd5ace68aaba6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6600eee84cb9270026a6f6ad7b73b3a7e7bd31fc5b1c250d98092d2a6d89c7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b116f58e5a75f45cad877eafb31990f247cd3b42a9b45eb378684a09f4d8c94f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttp3],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49e34a8f6305a035cfecb248d1ebe8eadaf739c280cf5ec5c2978d2d1342cd06(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[builtins.str] = None,
    preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94f90a36630cc3063dd8d18394221520c28e3f449f660fc57009bd0bd37978c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab295056a1dc43482f725e1d30c7d09702ae3b51c5e2f950f1bd226d091e5bbd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15651b8ae75318d65a9e380e4dcfd6707874a3f69287216044817f58b5b43212(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdf0aaccde21d04aafa97b191540940fbb259b9cd6620a0420c5dd493e5da9c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8007685f85d4838175c93b7248e7827cd36c35812a5b5b8cf294b08fa3e011a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94668756193d8872bfec2fd1dde66d665e5a34d1af1861f010b4783b36cbff22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d920efa25e7f8988aa49aa5f37d026d3638832be46ed3221edf37bcdcaedad8a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe275f3f062a6eaf21773bbc8db2b220a8d645086673d57b244dd4b3ce19b7c6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0fe13484e46eb09eff8858758b21e1c9e96c4952654e2a3a7ec319bfdc11a26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0254161a8caf4b0dcf53c93324d2b442c6293e5469412bae2564e66d4ddd20ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef025033af228983842cb2812137ba0d3122a6552b92a943ef3ca63effd26ba(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpStrictTransportSecurity],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c64c3d897cb0840b1006adeea3b83bc175d02cbd37d377ae7025e4552cba2f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upgrade: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c69ab23ddf1d377b34ba777ddc03c2030ac95c3978cf769ae1db3f98212f66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b09318c2d9326f2935ed554887e0727e617682a30ef8122da351e5b9c52e87e7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad040f2f2ebbca5381273725ae91191cd6454b752c96ea2a702e776058e45d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2fd2b99372524356f93de6050d71fbbc58651c8af64cf4a70671e960b794454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6baad93db31df32caf197e3e4cafed49edb3f10a6ee879caf6ecf57c6f036588(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6789ee23162d47e0fc4a1c8f72f1f83a9f5a7d883d385eaa1952f28c4def01ce(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorHttpToHttpsUpgrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3f6ee78d40aa7e4dc080649f7b654b5d98c5a95f724adfee07d910b61f6319(
    *,
    dpr: typing.Optional[jsii.Number] = None,
    dprvar: typing.Optional[builtins.str] = None,
    exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    format: typing.Optional[builtins.str] = None,
    formatvar: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    policyvar: typing.Optional[builtins.str] = None,
    policyvar_i_mvar: typing.Optional[builtins.str] = None,
    policyvar_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    typesel: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    width: typing.Optional[jsii.Number] = None,
    widthvar: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3984858f8f35721042edb3c6752d7c97929d4a864be5347d6e43569cc873985(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fab3f91910a3c2099b09112a41803db9f61f054b23d6f9fab4380ff554d627a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6e06da0231995dac0bdc66f1ebd128949ed90c8a9dd92512221e788d47494a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1992eeba03a3d7add7fd9fc65bf146138c6bf9956c3e336c498c04e53b8e47f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29ba46eac5f5334a1e89c560f6ba53ce7ebd1353fcbe64fa108f286438b484d0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00399d64b0eeff0f7f95f46ebe7085499c52e02d4eb97311b09ccf89c278f7e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3f34be6b23f48fea8429492e93d3da1274d1cb9244fac71b37e659fccee374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eee84483c592fa3b67b89065385a4cc66fed1ab82a9ed6d7dc8e52ab506aa1b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b43eca007c4e57cf33334a992a1d5c35ae118de59c350dd26ec76ce2ca232c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2ac853cfe6c278ce4fed7f8acfaa08bb717cebc9a17f8a8f28591db3776920(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e44593d39428e56530a340fdc82dcdbeaa05ba516210bd5d6e7eb6b9d55300(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e836033d5220b0057b39e806493d30fb259f9ca179eb3471226c6cd5b412b9bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0093dfbc706be0e09b39db6ec5affe019a81ecf6695a666fee3bf665b4b340f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcad4e30809f073d677ee72b99e90dd9d6fa248bc130a01c4850f00d9e40eb3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46272ac4759cfadb9c937b271e33ad8b5f60b9eddfd3a2bb7d7d4cc911ceccdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72791286b33cbb528c4b0b0d786fb39156bcb237092309f3ccedd4e27b3f3dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217fc3c11916aef0c4cdc89ee61cd309293981507f6fa28846c3c35b2c338f37(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9903fa35304128ca96249e065f2748ecfa8d3aad1e6bdfe2be574f92edc4ce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f0134df7b6413655209447715245d034adf6c18cf97d54be872ee6af6e8a6a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f008c658b5ca6498632d0c71e0b966d447f8f75061b758fc82956b1e23be4180(
    *,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    image_set: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set_type: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    video_set: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a84db3b2f32f81fa27581d661dad0c9c21eaa444c045caeaf08988d13142b88(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4992036570b099f472692785d2be9829a78535044e4d838520cf645fa09b460(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d7aed26c933a197e33d71aafaf0bef6803bb55e728e7a52add42ca876be8f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9edfa7129a17b86daac3fb96ab768e72556fd98fb2c92b2bbf7364bdd0ac12(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b262ac11d597a770aebe825921d2b8f0b9d4adc2398f188ef346cfcfebe9f44b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff7dd77e5011a7397261d2b909c9ec95ffe2bc82990333f9ff455b7496f4525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d8b29f84d561e65b0ecd4dbb73676b406139d46226334a9058d73f5d1d7694(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede09aac7cdb4602e674107c6c2ba92a63744947572e2853c2e84eb703657833(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee508dd1b7ddace678a3d407e8d655934248a65b7b454097c8a9b9dee62f071(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cbb4757f61fb57e6792eef02606a3175f510d6f18a79fccf4177110d73f6c32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56c6afd5698cb62e71284bdd379f39ba22f7d0af5ac26e7337ba7dd1deb68b84(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__522de67d876d15dc8efcea61d575c899d1474decf3f6bde4f7dd8a982bad60de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2510d6b1452861455681d537c7352c28e1086719eca82c0615e5ca277ed4fd8b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df5dc7065ae82133b7a2c4b20cde4e3d0ac8d8f1ea79a5b5af27bcfbcf16cdd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26f1036ce2b6498863c6b707d52ae2112812967d77188df98436b10e0e7467be(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce2d2d7dbb78a0a8d22f941db0e844e114502947ead8b54ca5d09474646264be(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa338f4a0548075ae11c3d2f14ed6ec897d88f70ab9ca4e6871467a5d4479de3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31daae3952818d47c9b666ba783762ef4e80ec311987dedf85dcf96a2b5b4731(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6da1ab2e9a9eaccec5c51a3a55f6b4d23b6aa2c39bfebaf70c486d7475f94b4f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703846eda6a3008c384d210ff1bdbb83180dbfd4264379ed64b8363587a6e87a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd21e12be4bc9c417c6603444d7bdc3cb5124b8a33c58c42655d6acc6bda1c27(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aee29d612e42d82e6b2f3fb78543943fa75e0141f511e97050fa7067f395a0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b04b996b35ac91ca9597c17adb35125f379ad98c674de8a739600919bdc7593(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a85a5d31133a06642a660bfcc966975fa53c3aa5a40954b156e24b7cf5a7c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036a7edcd4f6497520af0bd0ab7ed55717201f5d6b4a8ddde82343dfd81920b8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa46d48798faced8d65c9eff7e6812c488889697dddc54c18b833ada979b6f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126fb4e89b529376babe10658dfe51b97e388efea3e97b1e6d29bddfeb2c2032(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc32008e1def191e12f1a0b41ec48472dc98cecf7fc08e001710474ef25131c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef471e88b954c885da3bbac695f7769bdaae980a13cfa2fde49f174567f4e99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400bd332951ff865a733642e61f1121da906edd95b9565649a82396ae1735ede(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801303473411d3a95d35ee610bf0e96d27e7a16e7aa0c54432854cfcf0dbcf5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea889a42e30d1829401a617722a17f39508ebb9fd316ab60aad3c8133aba317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96da6a5448726950d2d39e3f6093902b9a1b17555d9b5f5b179707e8aaca3618(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fad2bf49c44dd30a5bf0d6db34423f97a1f7ab4654d9ca60f4d74fe5fe395c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c220550dc77d19b798ecb6db5b40429ba01ae68ebc7f3bbbbe422837d7ad65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9320d80b346d18fb438f37598c52bb709db8241d6f5054a64812ea434386973b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4150026a07ca1c9fd0d456af8a6a0df3363b64451712041b38acedb9471c8fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e9ea6a4e432c2fa97030accc443a6319a8500d56f2f594a0286b017bda90ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d80642cf9ad0cfafa5d09c10737255424cac016e40b58de2f123dda6d8150a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageAndVideoManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad226c4e07358982c3c8a30cbc6ae0b0046c8427223cacc471fdf634ca06aa49(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216ec081b69cd199ea1df5ff0b4e764c821e24e1c47f782465385bf37e88c084(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7957297c85d87694ad3f7903ce027a592fd42ffe81bd08145fa970b38ce7716d(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5ebf7573d0fd03b6bf1f1194514d17c1dc32c34af76e81b0f40ccdac448040b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078611a234319638dc49124435a02e629a499727f78b83c194e4faeecbeed223(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__305f3a9d371fcd4f7c68eb0f9789d72fb1d248d827f12657dcb1d21bb06d7946(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0857170aac3bc6967b26ed0acc86559052428137aab5ac0e75316763ea39972a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892855692e311258e39c6c5a3489c6302c8d948509b22445abfb65216fb04c6a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47357ea657bb48e55a13207e380dabfb026bd946fb4ab96430b09d83e99d86d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d722cf06696aa142dc7014215d9c859a3b4cae4d00e6a3da815849c2555ff5ac(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b518f3f9dc6e2d2af9cc4b70ff8e5c883a14514d725eceb69ed2ab8e57bb86af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2c9157fe2d8f6d19ec9f5a97f4357323b6b3628cd987c59ffeefdbd0f728681(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f327c021b0df07e2110eb8028a1e8e6cacaf658b3041323408a85391553876(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41eccdba7d6b155870c32912359a51d989aafb98b4c3680d23ad77eeab4b5694(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3fd8b937ca52238e2e4b29d2001f35c13ce4d39c49d9789f809d24a839bc60(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5ca0ec10994a954e53a52fc7301ec9fec3a366baebb78551d3dfd4d0f0198b(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3409f5491da56d87f2748eef14fa646b53b70f48db58727c3e454c4b8f79f5f3(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e5ed63a5c24498b5abb32f797d535be0456fb02b01760de056e1cea4f82ecde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b4ae959c4bd46aeaba8c90fb0fa8e215b7547d7c58c1ffedad7ebd494b851a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20cdddd737074ce9983b7656a8f37c570fcb0461290af40cfce19501331bb0af(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e3c3d0ed31ed39ad6f7cb6f900b2096aa7a42ab3e6aecdf3d608d8ca774dc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413ce3b9943c3140e6b5903199ff6fc18113ffa379d702d5cb125c436f7c345e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfac59dc9da1ee867c8b9f01d9156c91b6f2e5e9a8c06c19c01afa085a6f39a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f88c737dbdedddbc3bd3b2787a857f899627dd9ff3ba19b95eccc4f5c8eac5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb09acc92dd5b0e93e1e6661a9a41b3740c3d86b5a892614f6f34591e0fe2bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c5108c402689cafc99eb8b7667968470ee4698c5b96df3f3da348d1140b4cd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13811ec44f212c7df50c5e152f2b962bb9b97f76bc0c3108f38328b3c95082bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4f601a13e65dda8c3384f2febbee44b24aad849d75d614eb32a7cf077650dd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__989ec4c166c3ca759b7c284d3dad95bb9eeb1381465a08367941d0ac61c6065e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70873aa49b7941e16ee4419330f21d98d2388f6f1c67b9991524393d5ae6fcdc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5389463c5ddb376a2b019b676458bb80b1dca5c87362b97cfd8336f794b56e61(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d16970d096db060cb618a19e874bd37b5e7cbd8141fc7bd6f7ab9b9a5ad59a4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff318c14f9664e8a552a82ea02c985e72d71ec3376596fecd046bf1f25751747(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb4d154c5c49455e8d62ab618d0940d1c5d8b7e51b67c9469d816c0ab89d393b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9baa4e6ba17f3d1d9ccc52825da25a1b3a7a8262e2fbc3d79afdbc10f92165b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d97fb7d8d0b72abbb31e7f58d514cf4a49426cac8fb1fefe0219592fd9fc30e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f62a5efadf436e16710e79aeba1caea189b08ca9f38283c14c76638721cf44df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d918871d9d1d58ad593fb0f8bd33a0ade9440d817509e87f16f459c3ff4ba717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ae3361ca2fb59f2379549eef31eae89567e8e3277d429fbd11a405e3a34ccd8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17885b0a861fb3d20f14c27707802bf79b482bef3a4d5b78411df2b6819e519d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fc4670df64264b215333953a297873cfd2aba0f3248de84b1f1cc7db7365c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b0b318f5a7aad0d9d5007fb781639023c45782ad41e51a411cff3b32fb69d76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d10f8e1b778febe4357d780bc747fdd49d5967f024c9d6082ded40a12c727b1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2940cd4d691aed321bc98b6ad94d7ee66fbd590b832b1a3d9983d67de2444ee(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83fed6d7c4b4ed3f3d269c88d9f9f1fc2e0c11b1cf1eaf13d7d1eb98e3781e92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c896b9454ca07324a55938d89fd0c1949d315b988a3931aa9aef4961fbad387a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09df559383bc7723978a7b40ab33cb438853e53f70957e8d46b3b5c4f393a04c(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbaa2b3544026984a7e1da0b33dd6fabeaf7a701f8f27f68dac0a80370c5a280(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e905fa400ee90f0622872c9c1e3120445744e6df756dcc518924b37e0bda6eb7(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bc3aaf8cb6a888fcd9f8274b8a4f345cffc3b139c91a6b1a605609606aa6c0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7e9b03fbf216e0569e73ede0f955ce7b46a2f304b66c9ac0171a97c62c8c76(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8463c140800405827053c371e09275ba8d5f1475dfdebcf0f17e93b3c9242618(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27002ecb67e7d61835390f9f25e614fb6024aa96211599898ca4a4eaa9377473(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87237b05b101b1d4545bc40207c8971c898629e179365776dabe5f547b29b3bd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9f263957eac09aad2f015f8279bfe8556c601f9c1a4b009b9d60cb35693da9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6369572c925a78171c719aa17c848a41cd6a7f631b730a5a250ad199a9ca9e56(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0a28f90570f6e7f1c73fa05806d28d83847da6bf839deb651445559d4e49e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7641404582af843e13fb5652cf79b0b69be547c8aaf8ac2ce0e1f239006b84b2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91132bca9cc4c42754188d17c0c3099cecc7adfe0abbf2e1ca8fb4d195694de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14954aef62b7d98aeb2df1290a8c51e39d9247cacd32170c8d8ce3ad1f687f53(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__687ca7c53600b5251d9bc7173f44b14031ad75c31643cc1aa8b811c24fd99817(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f9cbba3563bd6993f84125f71010aad3357910a7af0e87a1bd917311c7b4db(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d842efbfee16ecbbfe6fc484157f5f813c7826595d57b0314f534385ced0aee2(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf92128efde98bb6727c03835224a17153047b1a4355d7e858c1317cc9f893d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c757f616906cdd2e0d89cc0b380e72f1c14d653585ece8e20bfc806cc64f4d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d820473e8579e13e1ba119d9707379d56a5030a8f71523babf09d87333b3ce07(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72af605a3e8ffe92e3f8834e75db77091fed7e0e2549fd9d23d400423437ec07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b053f0abd8a7328572fe40c7c5ce0e0bfeeb62c1114b8375f51190ccfdd0822(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b763939fff6d8b94e8fb02ba3b6cf96a370807b273dafca1121599a3dba26145(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db064feeba0760eb4c8bfc8fd7d233ec7c6160a054c9a24b18f31220c21d24fa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e17870195f287c706d2c740685dff803d2ea382475aec20cd9230dd4db6622(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d055a8ccc93ff1672e9aaf47c71361731714641acac0543c32bac58d570aa20c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d5ec262fd29c1e6fd6cd40626ed879397859b513d2b3e3b83377a5fb681d3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600160e8795691c50905583c1b8adcb544f7e5d52f2ba74311e211d2b8f8e67a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50f1a9278353dc6803c3d094c7f079a24f03fee5269c81da6c6a882e35380bbe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideoCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02fbe8d76c4a66e580699c49d9d847c4ec30807f7c9050ddb4eba8af6d3c028(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad0b74c5c16c4e2c05dfc099d04752d1def8d31d41f3192caa4dab8a1716163e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777b5166ef1c99fbd5d399f0256441c40fea030c875bd8f4a0c75a977b82116f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2d45c224f4ccb5860ddcbe5ffe7d6e28a6c371fcd4746b7899c2aebcdf7551(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3a3013ec972a426e7046f6cc6286e17ec1d96006891093c1c2466f60c13ba2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861ccb01369a6f51122fa5ee0cea5b11f7465634ece034d2a0f54c4f65ba97d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b274002e374cdf8f01338558a1271901eee9a5ceab7c817d394145c3fdb0084(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f145c26865264ab983c6aa8c8dbea5acff711aa6a38a7c9888ae7bb847b3db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65272a9ceaa5b2dde73a2b722c8c00b3453c24c255e842132af899661ce79bfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f29f3bcbbb0122f3a36819960d6874ac8bdf60d0907408ab9a129afeb8e8c0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ee6f119c29c972be54d9824ce12c80ee1207a9536ae15727f4d29272911742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a9978ec56e195eeb4395f6a418fce3b66710ac63910f9a1969a908fe78d1340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70181a30249f1ee2c62318def8bb9ed3664063f7a51f5a1001ea65da43822483(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2363860be2ede82880c2173859c17c89c88e8ad82681815b0403bafaee0989e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e268c3dcf804122155a4ffb990c6512ba3d98d9f620a16ca1bcab4ef606e5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3eaa4fd215d60e1c222184c3c022eb3cd0e365f268dbb08ac0cd2284dae4b0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3722fc87c8688e41efd455c3aa4fd3b398af95bfc497681b5bac7f477c2e2f63(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorImageManagerVideo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04327fdb87e48cef1ecc8daf2e0d96e02e4f3bf972208b2d29097380200d447b(
    *,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478c6614a7a87a18631339a2b725cd3cd26ebbfcc6a9624ba068c221fdbeb12c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af9cac2616b81ac53035d6c0173b76258ed692d1827908ea6a59f4a15a71a11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14dcb1b08c34c8808d73953c6f9140103db5d680ac963c0df863a1dd28d06477(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8be7b9f518ca210737326f1622f89cb87483597bc9aade15938184234c357f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac38037223e49eda3de063f7136394a52c05da1a3f2eddf1be819dd7fea634c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1bd1f9c31cd235a81982e68da92fc1fb75a1f1ece95c91f7fcc78a9309f34b1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInclude],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9baf280c33dd855e5bde3c7a7c953b95b3a314697616dc76de3a6e8869b05742(
    *,
    custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11844e3d84cf6117f01e31633665f9b5df9b76cf39532a54197813aa099315d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc9bea49436875872b977a881b0136c77dfde6a2f44aa86bdde54333af51b34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7b23ef6007d6a988768737365ceb1b32d806d0536d11709e52353f2eab5154(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec39b2849a38ee52cc146aeb90f226db451c7d651c579ca003c1a3ab1b6ca516(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba1f71219182311b27521d40b5cff41628c439d90622800e3498d38b6de81bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186beada2be6e5398e4747e0948f7fdfb442de3bb9f105a5a06b5620386bc48c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c805194da4e27c08763ea6361cc3bc728069620ccac3db617ce60821b277a4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstantConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4c1a789d4317f5cc8d74ad7c12fb19ba3b0c359a252048c8c0c2ca66d3997f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b861846e18643b94bfe675cb4432ee567128d363f2bcd2afbbd582bf381693(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ded568922d03c83ee40bce1c3c752d1f6f390cf9d3746061bdf18a524624237(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d046d6ab2b3d1552f76d9243bcb7d5fcc823c08ca263e6bc9f9305904ce7e5e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2331135aed837889f76dfc6ca33e707d603421b9daae1eeb86fd715a41b93ef6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda290c0c8fcc606726b635c4015e27cbeb765fbe55ef6bc6f874a1f6640b0ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b363623b0dca919b4aebd4a412f7a5a69af1f09434c81d7e143ec7b55caa3988(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba1a5f368618e1c99e89b7feb65182269cf0ed8db201fe4d469351292d90a2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a8e21df2cf646c94b85b554832a9d7e8057a3d2b3170fed722b8d5dcad6705a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873d877c7934adba18716679fc2c4c9b9b6791cdac03290318855c457ee77286(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorInstant],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d00883fff48d73fde266c987e1eafa779e94709e3fed008cf5733e00e74a094(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_partial_object_caching: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    minimum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f13195228aaeba5c3d3f9d3d71da3e5b6faec7cbdfcab598e21e7b852b1398(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    fragment_size: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    prefetch_after_request: typing.Optional[jsii.Number] = None,
    prefetch_during_request: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1eac3e1a7d35505dc495351d8811424aa880d951bc34c34067445fab6c4a6af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aafbda944d4636ccde4487520ecf0d269307fcf67968f766f2d0c99d02db6c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f614240ce704f711c6500efab8077e24fbc12ff8133782e1894441cf0c7cd44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987b6dbfc49855ded72cba8428fa6b86db5f50f5d83bea13eae3f6f072bff877(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83acffbe508fc900a271970c53ab18d21ae842d326778679113e105a283d8a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25eba0e9678261809614a8f8e90cceff8fc442f9c4cf89c3b657b19701fe0193(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28b64ff2023dd4a502ee0dfef873d666f3db82c856c5024cba3986f68a0d42a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75a2df82aa4885e5444f28fa61379408461562461b9f3ac9023d29a17dd7692(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8c7dcd354b17fd8af4e5b56fa978413641d42acc9257cc42903d803f6d0a4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9265f498fac8d29133d5121826d8016b0483b3114248b94dc9f7f1a5bdb662e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimizationAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31936019535d185ad3387a4d7b2a35fdbe4b660014b68f8a3fb7ea78166dcbb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4dd2003dc0aaf6dd42ee8ceb9833830debc3c9f153fc4ece9d926f6b221ffa0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aab5f918781a53e54d2deba79561fb9dc78b20819e581afc9d3bbb628c227f9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fb6fd899fc3e5ed2c75219fb729b8907a571386f860d45d0af452195ddedf0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6361d3e4c9ba630c3cab616c1810faabf52f17518f2cf35b17d6a7cd98082b3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c95796b67d25a1557ea7ef1a003fbffb460af138f8c394152b9f268e7f9ab6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f09d1fb3c42ac6aa9351c65fa03ad9f9218581d43d179f4471a4922fc54c8ecf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170d6184893d77815eb3ca5450c04d653c8f504188ae14e2406e13e674c7ee7c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a547de3540bf51f3a24bbaa952bfa0e768e7cd584f01c3de4db3ad36c3e412(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3f6a7e6bed23a1a3b1274f070be0de86c7288f022099f26c03369740660116(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLargeFileOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a12762570fa89ea3b3b376f50a879a18132569aa47c5c024368be715293cc8(
    *,
    bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8fce3547e5dcaf827683eab8aa322fc4f7b8da936a57116d7496efdea8fb83a(
    *,
    bitrate_unit: typing.Optional[builtins.str] = None,
    bitrate_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eea7e9fea297001e0f987c9c30e8daeace54e69f0e1f8cca731f40501da89c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64abfb4768b2c8d6fe954094e3b7d0e3de1d3d6e64ba5cd4224d89f024abfb6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89cb2fd603bc5bfeee7aeed1bc5df00ff3969d450e81ef0beb90b659ec5b29f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552b9b60ac40cee5393e1f55f60717361b190ae68cb6b5e53c759e3a0eeb1efd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e657a134bbbd774013dc980a13fd67ce891ed23a1b3b84a78068e895727966(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ea72aef054f5bdb436573410a54755cf5e94ef40cc4a30d51db38907b69341(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25d4496650fc893514ef511818301de6c83af257e5526bb705aa2a524a62bb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742e9ddc79239f561e25445933d9630e541665a6ee791d86abe31679a8cc3b60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a922889bd5f9d07c35091a37ea619382d2aa1106db580f859159fe772f6527e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c10ba19b2eab3868d0089ee593c587124f953e40c364f35ca30f5070ef9894(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef11a75980d450e77d06879682d486780488ae668167bb43c28dc1abb3dad54f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add8583141ed5aae76ab083dd62666da5c377451c3490a61b7c9d0a5610762b3(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6011e78080e0de183f8d711561faedb0acf87ca88bb9a932d6312b53a236703d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0bd60665b8a7f21522b1dbc7c0ea9f25cadd31bb86eada11e215282086fca75(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44999dfd53d9a05d19861238b712849bb99a34a470e928e35746b5abb3338d6e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b9559472f3ef93b4c21c7cc264bc7200de7aab371131774016dfae2756dd141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9c3cfd5c15ba2934c6046cb716504b5b57d0ba18f7e84caa973fdbcb9b8ec0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eaabc14bfdf24a2fe4a9f23d6251faba8541b9e0a28fe6846e520c365621fa3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e51c6578e574e0f0555ca05d171f4421760d3a227df42602c9c1e96e1bcb37f9(
    *,
    threshold_unit: typing.Optional[builtins.str] = None,
    threshold_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190d4c5c38a5333957ef0b08d2e16b4999222e702617916314709d67d36fc8c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021241fca833145cbab1ff2a49383d7ed0229d5f132f6034ac2ea8efbcdab74d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530fb9579fe6c205295702b96b8c427928eea1df8453ff7814cfe91d24ce253a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89f1feb9e13cc5cc86548a2cd03d94c19894849a437992d2ce95bcf03825627(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__accbcf542e4e5c1c48c37a686c6426a0d513d7c55d4773ea6a62b8efb9257d3f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35dd57489ca8ce2d3b6b454a27b1dbd9cd1802429bfc3443744d6b957e5ec3c6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6435f10b9dbdc72710069d73fb53792887c1f6124eb0bd44ccf4b4ee12112581(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7643f18d2f1d0a362adc230264953b91718d5725799f1e414774cf70228dcb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5f1cd97e08dd0c300b6247417afa4a7a41c25ddfc37388c01fba93ae87887b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837b49885dc13d4fb42c47ff8f14cc7cb6b09b0eda9b6db833f55059ac9d26d3(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLimitBitRateThresholdTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad1610ece0a96f6741f091aa325cdcd34e5827181f28d9095be31014dacc5d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c951667b9244f83ee9c4eed3dfa98f48d76bad3a3343dde06c32f4985ddefd8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8687b8b43de71e19d724c339e3815a38b0fef39a249c6c5f297a00162016ad8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012819f5f270e6ebc7c030a8a147fd5faf559332ec280583932a82a884eb660f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6891ffcc13952d4a09e15f7004ddd1f3aa93ff68424c8780675a6032cd866f6(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4addded43da36a548fef399eb8e69d42a3b53b3a15a141bf04d7428230896075(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45017fb0d6403d043940ab7fb77d2b65c719718d40b74dfb31ec40dd311e6213(
    *,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__084a07461076cc73350f8d579e2d7f76d37247af374e246e7f1872d877e78fa6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597dd118598238b088df79b50e4510e47d50a117368186dc952a8a21ffced755(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894f72ba6b84369adcbad68eaf42683a05b50ca51306f4fa9ccf1378e6377bf2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be38c5ef7b62415b1af0fccf472039466c77f9ad221ce27c40d0a70ed2f6b873(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf889f97e2402c7d470d8952da1938877b846945065b316e03681c7d06b1193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68f0db8de985d4b77bf0ccea62b666f16875102d63855d36398161f5a4c86772(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9db0ceab2387a7b3feafe1b801d017ae12fc14a99904bcfd6065fa8b4ec6847f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorLogCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0256dcda3abbf13c2c8c98118ec58b50ee44b5377aa8cc202af15e7c3a67150(
    *,
    api_key: typing.Optional[builtins.str] = None,
    buffer_size: typing.Optional[builtins.str] = None,
    config_override: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    loader_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_optional: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30abde26a0a26c92170d2cd7c1923d1d1e47e006ad8a90539fe9780b218f0d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9dfec2e68690675cc5e3f3c5c68729ff8fbb7b199252f418179d53894f44136(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66dcd1a9cc456f488d36f7a36f48f96c3de91073a39651506c3fd12acdd42edf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ea5776501198af4e9c1a60acbcb695d899ee7e215b33cb4461510c8dc025b69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f56c04e5f6a17bb3369b792959f97ea3efb2b270c57597aa33de16783d9214e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef21b0c929e978d06e6b567d1f2b426b2871663733dc72734b136717b8ef147a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec110eed108a8a8eac7f851bc4ca90ea3937239df885c5521694875cacae5b02(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411bf7043ba1c060f24a41557359404664ad0315c064061c204df69f490dcd37(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0e8ef539b6c8519005f716bd49d0c2b1bd9e9fe64a9c7047fd47698a57b7f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d546855150df4992bb62c7c126513c3df7f2722a1fbd87f15b57b94617026d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c845dd2f1f23958b6675c6e77833ddd0dcd20a50d14b2c03a75ef24ed051db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a105a67f72cd3eae4754d8e51079e155761df229760f9ff35ef2f365a563fc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMPulse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c971e21b7c7bc3dba5f39396c2a2ecd09735ef5d75049390fe4a8bfcf0c9627b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
    hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
    hls_mode: typing.Optional[builtins.str] = None,
    hls_preferred_bitrate: typing.Optional[builtins.str] = None,
    hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_query_param_secret_key: typing.Optional[builtins.str] = None,
    hls_query_param_transition_key: typing.Optional[builtins.str] = None,
    hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b106fa593175f6db255d58f489dc3def17de337f3621ecfbf7290ca81c2407da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79eac582dfea34a0ace78f74b4943daf81857ea3afdc55573655889f047c5667(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05952227a61a3033052295fa61fbe2223a1d23b1e66e8c3d68fd391e95ac2c8b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5face566e566151031f9edb8cde8139c4f9af291976112e900c3a444b55380db(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78edb16b014679a3688ed5a04f9e9e56b7f435edb2e7e875dc08c291fe85d8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69c952a688beeef2c8613bb4f1c973d90d1d0a071bbfa3b86dc904311a74aea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ba86e8b66cc32eab47c59423bc1da8538eafa164747dd96cf67151a0c443446(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9b3a3f36db4faee50a9c4cb7130ef1ef31443a04c38a1d6d462607bff8262f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e4b2f156d2c9410a7c877536689600132ec2eaac87ce9b00bf29ca138cde7b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__476fe0f681e60c66890d55c9ac94a508d29269cbe86ad4dfee9396e1973111eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ddfd18fcf3bff92dcc7bfd21f683194d59eda0e664394028ac6dc5bd2b47cc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc9e5edb908957eb3f0ebb08022bc384035d696a57f6fad7f0bae2ca28382312(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9cf5b862a78c14b9124d70f7b1dce82c4ba773571aee6bd10acd6fab271d65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1911c8be972405d642b018139863e200c8e99521381c4283f3156c736224c67b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a557837d21dbcd7a7c65527b384b6d280ba6316e173964305dcc1ab1e503ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faef811bd9d02ecf619441f24bf88ba6436650265cbf2c0bb21c5afcc5668fae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60f1e14857473e267186869a36778a2947cc2cf0c8a947f7b5e0a1e4b75dbdd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestPersonalization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777ab789b12dd47a3cb18bb7ec9e2f2b83992c82a167f5f47b176ccc721f92ae(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    username: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd14267d245c198fcc50efadee394948652ae08293c9f3ca70a891d59d68af5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d777fb91d4d5b498d9231056a300381a3031c9793533a1edc8a2f99962d9dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaca209057915fbc5a549060b18e6b5ce189946d0e14db6dbe6a57669e3045df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158295462241f391c66610a0fd9e49fc5a39fab1317254bc03061d10625bc3d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e125712593b7dacb85745c8122f268bb1d18dac18f1c70cafa7cbc687174db2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__190cc75a2add055b13b4d350ed1f2743cda46f7bcf9155f7998218afb4163c00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8111b27d8113343ae340f44e1565f7c81b9dda886220ffa367cdb280aff7a5b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManifestRerouting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b15c9c2af7f0118fb37d5332a93456ba6530a27ca7c6ce1e20f2149d71f40be(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2373b2d9420b0f83ff332f5a35a7b256dca6f92c3c9cb2db1c033b5acc2c0e2f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d69fab239ed7db79ef54bc7640689ff69a13deab724bd192799c762c78780c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d33b5f36eb6a57e2e0ef5553d8ac61a46836eb30133e6901b150306d7b41f82(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2fdc7691ad62f0cbfb0d2a5d0f2af4a5a200071f259e8d1d52c1f1bb5b0a815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da3eb085226f84a8c977a4a8d5587f3b8550ea99f5fb072d9fefa791bf224a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c872e74619f3fbaa1e2019e1e9d48618c21dfd6a4f8e035cf3ca06eb19f4c3a9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorManualServerPush],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285469c6f0f6ae1621bc76e1fd288503f13041db22e5829246200ccd39a2bd66(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9efdbab1c9c63c92c314198150d85f5ef5f36f71e56a11f1553aefc0862774(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f91022a5013beb86065eff0b36a2a04e0df9d8fb76d53f966d83b7b1a438f66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e285790c41b4a9afdd089c8df981a00d9357d04c096eccddc88f926b913633b4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5bac3f771d20be7a30876a4499976df096c84011258e1753ce6e7a57675c02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878ed489618c3563725bcd7fb3c1b1802ec00c56ce55973210aa89e61b2c5b90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__114309fb4cc609f6d7cadb130cee4dad36b6d053ed82985903b41d4b9ac80f38(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bf197a3dc8c6d74f4ff493dcf4a880006e0390b4b73b72d96b17e73d64aef32(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optout: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c5fe77c8ccf27d75afcf145e09c5f2e5d5c2e8bba59682bfa95d6c9d82205f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43fed24c148612d8cd33b271722c91570eefb59a8d1e335528559b44961f62f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115682f185a7a31d5660a87aa90474e6872057cb3100489e3ad98ca5b3c36b61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b8acfd86bef2cbcf17d6916e4b4072b17301f2223f7c82a7ff31c1114fcaf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ede138cdbca2a3d47eabf4ddb55786f1aecb60aba5a040806cc6ad9e9ec152e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37cd93656b8952d830d873d069545e2a846815cf5ff947d1819a4fd58e55307(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaAccelerationQuicOptout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c171f50d0b23212b225d61672238a9fffb7f7ee0e41e2f3ebf6daab9d5a4e0c6(
    *,
    beacon_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2ee3b77a531227edf8941069dac29b7d4fcbb41b0a217b5049dc4d731fd61a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0974b4ec55d23a733f355faeb7e7576f419b8dd4e2e0b6f59dcee7d35ae1fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbba63125e9ce5dc1e71a112782213b8b7f21e536fb3d4711e17f71415adebd6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38f94d7a66dead8be73256d351e7a8db885fec9172502d73aeb30c94bc8eb743(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702b282763ccdb217bff86036f0c3bd560518f2f5cf1cede000071f8c61071b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__816ce57ef1f2bc94c2478351b0aa91ec637d607920dafa260ee9e0fa4ea5b270(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff5b1fef753b0a68667dff8aa74920ee70ef767deaba413cea221c523b8d0d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44900de6a805d3ff6b9a928f619ba448def719c3e15bdfe618b44a951373ca2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d528fb18251d3e53c4af40dd2be978e2829f39cf7c8a089ca0093fa92ae78a8(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628ed98599eb562e92781ef8d0bde56c1c74acdf5b0e6483d6ab9491e5ec1489(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ec6dca758997feea288ac5a94da862cc8bb9b44210ddbb35e8e3120b4a5862(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__814099e208e480b47b3fba47e77e55595b9bc0ef08e28c1477c78db02a98d75a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77724b4683d5a27730e63aeb20984de7786d43743f50daecb1cdd031aa29ee81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c503af70aa9af86001e6abda626b7df3f90bb8f0961638afc32227ff9496fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d02103858c302063fffce84dff24e619cc57fa52da2ef8372b6031d297985bd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaFileRetrievalOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915177bd286f7309236bb79116c7589483930e79e800d2f4e343fdfd4fec17b1(
    *,
    cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_window: typing.Optional[builtins.str] = None,
    client_response_code: typing.Optional[builtins.str] = None,
    detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_object_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    object_unavailable_backup_host: typing.Optional[builtins.str] = None,
    object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_detection_level: typing.Optional[builtins.str] = None,
    object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_modified_path: typing.Optional[builtins.str] = None,
    object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_protocol: typing.Optional[builtins.str] = None,
    object_unavailable_recovery: typing.Optional[builtins.str] = None,
    object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
    origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
    origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
    origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_protocol: typing.Optional[builtins.str] = None,
    origin_unavailable_recovery: typing.Optional[builtins.str] = None,
    origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
    origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
    origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
    origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
    origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
    other_options: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1d79e6d330a32f3a5fc7142dcc7898c56748a6a521d84c23b9e60d6097c21c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2e648eb2e2b016ad78a7625325e0d99443ee2ac360942d1880c7425482ba482(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7f0d9ac0ceedac37305c278024c14432c49b71f70f13112faf7029b34211531(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b2f9abd7b865eeae1511aefb25411bbec295d782074259816ac184b4357508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a906b8492156167f40ce6ac53280f9019334ff171495e753055d3bce1ebbec39(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e9f066eda64a19007248137d11477219ecdfeb73f2a7c1c01ec5312497a0c5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aef57ea3482952b2cc45ade380edde58a0793fba03c487bd8e88045a2188a5a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__018ad077a5c34a5d7a60e37eef570a7f52d06c89312b53ee9cd50b37f46e87e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0fc16c52718b05c779d1f30475f0bc6689427aff2d7126071326584463d5e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887c4ba8d26bb08b3871a4ec956adbbb53bebc579c994fcebd888ca1fe2df146(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13e5f8e0fcf82815a544e9bba3887245b36dc30a9f587c231e26f49a098d18a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f4c7372c0a1771a4571da59f53db0721bbdf738c91c2ae630f20416ca5cc18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b2bf9e8b6eff0d52f1d717d81d780498804b53f53e0edb7aad9fb094d4f7d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52cfaa867fa9fe66188d79db22cdfcf9d9f920f60507da8cf0d221306707a90b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a1fe04e1ab9f5ebd0a9dc5ec11aa128dc8a545a503aec8b1b625fe17f3ef46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a35ed81bb136c215412d2b02cb6518836dfc65d940847b58147e55391193453(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdfda4e317c7b6892404cc7393b02883fd208fece908c070c977dc067a55617c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__239d066b53cc3ad6fbbef34b1edffa2be2aaa2c007ff37a0e9c863d00fe52813(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e60166c7815d3df0dc316879383c5d76c73bfa30df79bda5d8b952ad454a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f63898283c517496f791c39fc500a251fa714791d2b49b246a736657e1623cfd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060a994010a989771d71bca5a3f2b09f781b2f612c7d1172b2fe8f2fd747f7ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b56d429331ba567fbb79333ffd1fdf47505df59e7b19287c21cd415f550f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d59261b4a9471c7c2bd3bd937f9930f8c165040412e8c3ae6c9c6f9d7f783da(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__441452a784d0d4b52f36acdd941bb80dfe64651ad7c3bd66563d33ca1ae4d361(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a36e052468339544492a97c03ebab6fd5b1254a8d6e71cf2ea081de4588c430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b17a08e3c36573fbf1958c7b9e193461449e32ee246499a1952f7bbb357443b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3844aff9136d291e050dc71a5fe4aaf4dd13075e9750cead8ef379f74af60048(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893480873f3577996834b80558424100e4fdfe7201a0cd44332b5ed796e02790(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470a409b9d4f89832f48ae364ba4381c99c40aea3863c51c8a67c6dce2c42836(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e232579f12715b2bc5c971d32a772eab325646b7a44c34ea9c2bf9e642e3217e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8638aa80aa8d5336cc463e6bb7c355da0a62a6a277b3869e3be4d593ea3114e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ae82509a3111db24944133f7d8f328f4c0c812504267b7bf08da5b33b3a536(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30947fc92ce96cdac902a6dac5e3f6d9e0b3e40f6ee5dc4ac81f518caf1563cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d64219eb6a5f7c855eb04a7fd7b1fe243324e9acf5c4fccbc34aa80144721e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28e6a1e560ebf0cbfd78083a93736bc2e0e71c53bad17b2ca3dc6c685bc9ac1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b9fc88703d0cc1a579b083fbfa9176b102931226758238ffb008c25af988a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0244d883bad9c23ed654240be8981b2d57406b5b39cc1bc2d12b4ad5ee0c530f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e5278d5feda7aa84ee9d386bcd8a6e890befaeffcac50ceddc288a3337fd012(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a64bf3d560c1e99c11a456d8d5ba65599f7a35a95dce98ba5384d18dc80ba9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0faf88169ac6b27b1a872a476959a4e1102c09b806584903481fabb8dca7e0fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33354371a72418442e0f9b20a0d31b85fa5598b296f02913b0a1815760e04a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec26a79aceb5c7343f329cc25c82b4efab58f38993abb0ed54c2b728abbefb5f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540d8da475ee08bf36cc84838b17d76ae83d5035ad67459de202b0dc92240ac6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc60638c1278c4bce9a2dcb584bf51886ed0e24cc579d4b3c4f7e5db490da598(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10dab612b37f3e4ffd29f936761047fac0cec4c8576d802fef7aecd26a27b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf9ef117c1ff79db9e602136f27c1c71cbfb6d81c51f1ea411bda9d516d0a4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__572a5a855b2a48a573f054957c06f7f9e75646901b443c6f08d79bcdd2289fb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d1a46c7a456b30fc29df6295dc09f5a3149ad6e2cb6b45bf29ec0d32a12fb72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85e45012528cc00851a15f636df2edc59a1c9199c029a80ee85dbcb1ae19f24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c377916432b0e999261e787c91f8b0315187cd17cedb3eaaa32a0f4c971b3ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc3d8da30f16819f3ac717fc840dd347308faefbabfaa3cf5453570dc7e1aab3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f2d8cfe821e823b4ef8cb53e462fc62a7f7402e2903c075aebe8509dd6d814a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9372c3fb4b0948327aa5b0fdcaac8d3fc1591dc98620e3ed7bdfe2802ba9ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01133d55c48705ec9dcb21d4b8f055c27f34ab78ff83992f9d119976e8223992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43925f93a1dacf7a6bc12ddee9ed08007f9b3ad1555582c74e22eb6fcdc13526(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e694cbb5385d58f747ac5945486ed55d7ec560daabebe2fb07fa2de24411285f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMediaOriginFailover],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e826bc062fd9783bbdcfac4fa23faa4ce225391ceabd28815a405925671bd1(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f06d8232a59cb5ccf0750c3ff6f065e96907dfb8b94d14c409ecee4cb4493d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc253fd08b0326f7fad41f3ebd76905b7370bda1df9ada6faf85ff36c311dbbf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47fb30dd0e56fa73218a083363fdac9fd8bbf7114c4c96f0e5fcdf2f2fca76d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6689100e1cc53a0f0faf889793d19fabb62586f703e6fb9076c53ef26363b07c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f96d016f13a9c690090070f8d70f7dac02ffdbf852311e7e25626f5db5ce31d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bd65d03e032b034d7e65a22a93c2a1300024bd378cdca34990b9bd1d76d6943(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMetadataCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf3ffa680a21221f8752b4eb0397f4434022ce9177689b554b6f7ea1c7211bad(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b86fe481a201dc4fa76c0fd1e4332a5361875eea5716ffefa537a45fb1c0f868(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be4f891e27d0848b17476f3610314d898525e8861fefe9a01d734ed1c4e4f22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be007369f5540109a78181ba86dcb744cdd1a2f612e46fd5679631eb1c27e43d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83bd43fe16ffe3e38bc9b79f6a777d4c20c0642157506512f97c34a92279e0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__579926a1c76b1eb7c0a5fdea50dcd71d3f92ff487f6be95d0d4e2f9f1498f59f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9662de27a8bdfffdd6a1d3be89bc532394e45bb46f57ea0e29ec4e017c03c829(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d698c897ff3df65fb62e9e2d7669f07cc9a58d104bf4d65070cd41346d628ff9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorMobileSdkPerformance],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1201fc4da69252384c22727793f582738db3e7f87be54553518d181de8a4ca15(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8319ab64d90213ad5af85b3c8108c896b94e3423cc6adb6343ac5b7839a7d8d8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc0f9bd385a51bc0eb9bee84f51696b93acb6554ae3483a9dc8cb3878a232d79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf2f9bdd3fa20d44b72a0f0c378c99e72b528f4078855885977cf88da542acc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee2970ec058183b57b5492681e8dd6dc7fe4801ea15a7d50a73245bfb04219e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1c2415a726ba467567162ac800c429705999c5617020cbbffcf01c4521a314(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b9f49542bc9235bdea91d59475da651d2aa3c8216817370805cdf9ae587bfd9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0a192e152636deaded8385351cbf7a55212b80dbdd02cd0bfbb87b08949f86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f14d0df5ead1465f4be1d96b0db2d5cb76b9d708b5d9e9f8276b231d505724b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e4131da8045033ad5c2ce847210ef491b004fdce781a667587b77fd3c3ae67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__443e07b438c89caa29b6a7564f3e7cbae8359954c17404fc487b4cef0feda718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cabdf3876efa74fae10a850696434a7a70d7fec1854fb115d8e70e8bd61e44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39d2f3fe152b87d519a4002ce5fd8ea844079053f447521f5bc74590955212f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ceaaba1d6c2bda25922e8aaff5fdd1872ec2a61ce4cbda9a6dc99f17d234c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee28fa2a2761d0a4379f86352c9ed028650ac01425e2309d085bd189784134ad(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d1756cc7d89fe4d4842bcb8925a751ee09ac328e761cac839555bf38d9cb00(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749940241e75205232edb2b34422afb643a50a8443db31261aa997c83ee2ec0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1af29beaa2f17a6ff4e93abd32c82eb10e54b030312422ea2de31703fa60b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61e87c161c8bdc8bc6988f639ed788c93e462ee06182d99e70250461dddce10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b253ec0978ca69974531a63a924becc79dd8542d630f345b6665c5491724dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15bcd15e2c1b2d0f425135092d0cc6957f4a8e3a401e45d6cd552d79492bb81d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ff6cb183be98dfc9d6393e45f0e8428d433504955e188e8867ce04c5a32751(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d658a4b5f3fad283b66353e64423010de7b5569528eac280499ceadcf2f854(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bea217c69718bc5afff0a6136ab8456357fc86408cc693c6f6c0ec55e00b4cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c5c4b2b67b97b8652ac74e6e7123dee19c1f51ed5cb69272f51b1064d6984a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070c4b1520f726148ee00a0406e257fe71db1eccb3e88320d97482fec5549118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec8e2887e5ac98b6b959db8cdbf01da391587084aee772f22e50677189b245a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff8f61128c33d81460c31e8bc7eef378747b7074efe0357c8a0e5a9788e1d46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70484dc2ba74dfb269474bfb696796d8b6dd807927ac4f3194a67ae65018e83f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f136cd0ad9a444d035f277d921d21ec9b2cf6ec914e57741f4d3e45ebf7f03e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyIncomingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__671687e9c24927a697be7dad43a1d75abda9e857ecb501d7da0574f7ce8895ea(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8bcdc1d91c42419a603b06cff2447f798a60f3ed1b53d7dd780bbd4731d778(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3710e38c366f04b40e51b1afd84be3f4b560b8c9976c4d5e9d1831ccbb345a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff8b5b166081b0a9a1e67157f364d419b42a2169546f414b7b05a0d74181ed6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae830ff8b62ff03bcdd43ecf5586961bddb1b4bf8250c04ec628bb9b6ff7cb2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0894c134f2ee73a19fce8cb3d2a281968958ca0492adb39fe2758d5827abacfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f062429d2b304a7faced59f30e6ae4aec9b755ce7294c4b94f48a12a493407(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3966b9f37c3331bb2cb853524ec4e468c288811e1173dcc2e238b03af2ca8aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ccbbfcf436c4207cccfec9744f24533573eb18be2efe863c034e4c46c681604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e42869c617262130c3131f5528ec3e1c5d40c0e0d5dc652b4766eac86b23f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495d574a51be66b3f57c23f1390734fe4c3c3ce61176c0d0eecb33d671a43d9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02461cc113aad5c50cae9abfcf46359415ebe2eeac35b5e2cd73570ed5648cdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf7e8b2cecabb6d96220228cd97f717e6403758cb2c957f6b934ca828df5c1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c6e696e1ce5f8361c1b6411a4781b451413669784c8c08dc45f2abe8a2c382(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981246d31af79dca6365cc489a97611bbd009ece0e2155bc3731779030630578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6fb9e5f48ffb0135ebfd4b99a0186be32bc8e48b05945c0d91bd05cfbcf45d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3410268a7fea9f313bb5981ae25bac8d099629b97949e3bbd27c79881f33a97(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40922182fb56b0b4a34db83c8b1da100012080dfcf32108fc7f6462d435ccaf(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72469bc097baefbbb7bbd9922cc5599994ef86d9587979e467f8b48d0261d09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b516f201eea3a8721ee1a3852ce9f397b5435d8d7d36886f116d8a322e0a8184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__959c290739454f04e7a37cc74b132b9ef94c71cd3ccd3aac36e0842d160ba306(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a41d1bf9cc3fc39f568fd51a5035f4a342763d92aff11d72d9ba058c063ed388(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef79846cf7229655dd6a07980fcefbf3bb560e4feb25a196daf2c2ed61357087(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7369dbb4070170f5d2210c15347fb1fe89e2c18e7685c00aff5c69f85ff1b729(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2452d0fb9ab877e3453090838f3ed9d8c3061b7b5142b1838dfa834a678736b7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b143d91a65489a868e8dfb611e6164315fddf5ed1ed8985ddde80edec47ba7c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3466951c5cc5273b9fc58d80146611694e887a944739106289ccbdcfac13625(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf77b2811742bafe7aa959a1cb21f3dba8157e6a583a206a8a07a4c2f34e1dcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__931875e15361f879f17202fea3601b619247c720bf6ca9dbd094558032bd995a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47bf9e80ce9d0e7ea3f81bfde9e787a24a6690a01a9e17b53e65024e69357c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10fbab60282de6df1adfd3bbe982ba37a5d7ab3022f841d414de9649f8b1bdd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117ddfbf1857152ab697d62fa9923bf8844059300824b2181f58b3f43f84373b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16f702ac036aa4a81f81badbd7e00fd141c230b48f9dbb666d767b3f458b6de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285852efe827e7c3b6af189e44297077f41d583fedbd0e89c3517e6c570f5151(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyOutgoingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93bac97601527d93865461393a66798de5b126077397c5aacb33060759204f1e(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modification_option: typing.Optional[builtins.str] = None,
    rename_header_to: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eab7a0f382ee7cbf7a2316e0fca68bf1ac58b15bc71e6b385d99f001d661b13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a620471528486dcf068528ef4f092dcfa3a72df8ebc315781ad31b59521141b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12aafb45864f24b69b2b226800d6786ad3c8d590a075e69add98d2ad92514226(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2df92b0ce929b08f2159f7c6172e1681d80624957b3078b107174a15c466ecea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46f209cd0d4d26d4a2888fa045260a9c9c0bf82088a9e998781528277adbe835(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f99616b51daafdbee057b8c4eeff07248733e9680db9ceb209d0d5ebeedae6a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__561ed61f44d4906a7dc304a3fd438053b8b4feb67dd0978fd64df60a21aec750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909eba0c8af5a51bebd7b6f6da9aa3a0e2db51cb61727f4e2cd2f1b32300db1b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorModifyViaHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77af24cb69316c094f63187faea3d3cb86a1577a610bebcb190f25aa5630a9a(
    *,
    cache_key_hostname: typing.Optional[builtins.str] = None,
    compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_forward_host_header: typing.Optional[builtins.str] = None,
    custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_host_header: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    http_port: typing.Optional[jsii.Number] = None,
    https_port: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mslorigin: typing.Optional[builtins.str] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_certificate: typing.Optional[builtins.str] = None,
    origin_certs_to_honor: typing.Optional[builtins.str] = None,
    origin_id: typing.Optional[builtins.str] = None,
    origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_type: typing.Optional[builtins.str] = None,
    ports: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    second_hostname: typing.Optional[builtins.str] = None,
    second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    true_client_ip_header: typing.Optional[builtins.str] = None,
    use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_mode: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ac8d4a721cb210e053c0ecd5029f604585a488d5365cf7a61f820589929116e(
    *,
    access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    adc_title: typing.Optional[builtins.str] = None,
    authentication_method: typing.Optional[builtins.str] = None,
    authentication_method_title: typing.Optional[builtins.str] = None,
    aws_access_key_id: typing.Optional[builtins.str] = None,
    aws_access_key_version_guid: typing.Optional[builtins.str] = None,
    aws_ar_region: typing.Optional[builtins.str] = None,
    aws_host: typing.Optional[builtins.str] = None,
    aws_region: typing.Optional[builtins.str] = None,
    aws_secret_access_key: typing.Optional[builtins.str] = None,
    aws_service: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    direct_connect_geo: typing.Optional[builtins.str] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    end_point_service: typing.Optional[builtins.str] = None,
    gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
    gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
    gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
    hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mslkey: typing.Optional[builtins.str] = None,
    mslname: typing.Optional[builtins.str] = None,
    nonce: typing.Optional[builtins.str] = None,
    origin_location_title: typing.Optional[builtins.str] = None,
    property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    role_arn: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a5f477b49c70a5a39867cb83dfa88166b99881c5362ae8d31e0632c3e0f048(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938bc77a0221b611d66b46b12c617386b46ee4346eef0e54d66a30d3b6bc7a18(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6d9dfd59690f865cc3ef010abc46386d214d6a8063cf17d4db3ffc7ad48b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ada5dbc7ce017fd018fc7e6f7d02602d66771567c7d858af82590c9a5228a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__994e435dcb922706ff43d324b0f8af2e2c4cf6a44c543c2f2e947ec4fe23f9d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd7b135b64a66cfe4d5c9037f55824ea2e9e45b765c662bac1f47ca1d4e59c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93bdb36e690db791231ee4f47d196528ee77e621dcdf9241b5f96e3ab84fd523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a62ceb412e211a9d0d8123014ba5b7e2ae112b13e236f2807f977e1e6e009a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3aac4056a257662e112cb0ff19d25cd313d1e50d8d898e5ad4eed93da7cf4881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09436aee4efec1686762c2fcd327d38df90d7755553cfb59af49fb7ea9b8d13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc71a193883d94eef4caee93f857b1025c463ed02cfbf7171e4670a5578a70c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c236f682b1504235003ba68b30f0ea94a1857b8ef67b888f9696f9fce780c02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150ef22cc7d38b2a201c8970192fbd276ecb8402448f6b41f8bd41f8c968e8d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e1f154533ccd4139f3cbfc2d50c6d55c03c8315df0dc43ff0974170cd62f08(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0046cfd92b048e10ca7e5c9f5f08cbc8106c19cfef078e2481a5c4e2a9eafc85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488f0bd19ca43ddeecc8edb102ebaa1ad80647d574f97ebf142ed1d269fd215c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335bbeacb1119db6b77d379c050d8128da7c13b7b46396932662d85139d5b849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18fec29a57e9a2f264ee7451565ebf4a8e5e58782691e6f259715a765a761199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bdd865bff2406db95579770acb32d907bcb56e73b424d6559c8e1db636e45f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__688d0cc31f167f59c098fcbd12894e6cab08abb75073c00ee05645ffbdbfa655(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b4115860bebb641cd0e33b91d8fc9e539f6a3ad22695654f70578f4665fac4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509b10a9ad17639dfaad45f90699e7d91a386519eda92de6c2d37333dbad56b1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b263e38d8832c9cbf103e3a45e39bf7635323a2642170966e15700fa0d20abc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d7abf61dd093f39cd7c1c06f890aae9275b023a10bcd78616731c4aebdeae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685de741fa262de732fc52326191bf84ad705d255855cd679d71cb98b53a5d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c959b021e50a444621ac06f6f98fa0f85860fcfd907685ea6399e73e24e96a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b74cb9805bf6f42edcf5d1035cd30b5c844a68b4fa44519693794c419b89476(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141180e9ffb71258bb31fb551ec6ee978da2332e654917c6c094e034c8433b94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a8a529617365dd041f0027e50d7ade6b61e695d32beb36f6b214242515c1897(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66f060919cc927067c302c6a9225fa9b6480e4d1a515a6a2ad1379a3eefb7ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f31c47c82df635ef9c0a2c616b8c9ed1766f1c7ac289b2a77f136bb45cbdf6e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8a87ddd717bf13d554f59cd7f0bd2f94ea628954f0e34a59b2cc2b786d808d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa4e08c434993f28c6b58acd9afa5eed8004940c2f9a5ee9f9a49fae4f3737fb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3edc11135cc730e27b8b6ac0d6f12722744d92a07465b17c03fe32fdd88068(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origintype: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c112620fd1afc7bba041082aa1e60dc1135f8e2e35dac8ea4b19b27d3ee041be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0c85fcbaed0bb131a06de8519a768a9daf075f82d9fb085ac102e5e85eebe56(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cfc86116a14cef962b7ac90f4abe752368a22ce661f2c07ef3cbdb1480cd68a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b1c7f11115bc9608c460f9879ea32ef3553d4d3136ec5ece180c436a4a0d8ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33edb721ad253376e09c4332e59bc9317a7eefc591eacfc015168a2436a9b450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cbb63a5ae8a8380eb15259d88b290c41f6fb250d4111353f8f8e5053f7692c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCharacteristicsWsd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afe3a975621c5b5ff7052f21555f9330ec7f40f7f9398f5054a5a780f4caab2a(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c90054e4c38d88a246acb2be13419a970fc89e99dc34a0f4dd0106a2469172d(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49bb03e5771a8a1cd800e6610d1c3c09d986eeadd53ee0bb27e9971401e006a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5d3b13a2cf59d60d833a6c6407553d513236b51c6561e8db18260f090fc9f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__451389ff2f20ddee617b5fef164a12e443f468646bf5f7e5ff7b193dcfd6b46c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0d14185e2238b7133b1f6baea1d2a2fd12485c73a0ee1fc8b7f3c9ea4376d83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f045d6c97091b43d5e543ecde12d264b6ab43682826bd44ab9c43f30be752353(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853fbfd092fb3c6eac1228bddde09dc34bd1c53248bf47c9356b3d10fefcdb64(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c2d04c1e030b9676cdf121e2b322a4c63b66b7d8e5a9993b8cd1462c638bd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328484e2ee27132dff97c5d55dd687d47bfd19317c53d0054e6db2c52573b53d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be30d0bc3cf6893ab5ee4197e56a998cb28dc83dc74c0624400253b772e316fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__435472e9e9d934b81b98ef58e841ca7586f874f9dc668b9f72e70841367892ef(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8161aac5698351737c61bcd113dc04a9a4881e012e8728b1517d51db0656d362(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4b0ac1e4a8583e7b299eb60267a1ee8014aab9c32b4e9ff1e5c9656e7a1f39(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f0331dcfcebfd4a253976ef529c45cef83221b336d6e0687b577485b09874d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11fed582c5d12dabdeb9917e22c5ac38b7092d2a5683d22c7e05665484f1e4b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d414fa2872742f43bb589f6ee05889bc8433174c1e623c6b7d2edd265c7db74a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f51958b7515b257e1ddd2dffadf363f090e2880f08ac5e56b12aa43eac20cb9d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b66f1107f4be5bc3260eb222e2d952324b523eee613786e699be72a86eab04d0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bdb7a1a1bc28ebe745ea8d7a12da356e9d6b1e77c0bfa5dfd4d204cea41afd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66bdb4658c0ca478041745e3981f7e76b754f94dcfdfd95e9034454ea7d9919(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd2d6c4e99a82c606410537bccb54dd71db92d16624abe279163ecd82e916dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d828a65840028c054f06b992903eaad57dfff774bd6ae56dd622e3de378d3920(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8e714657114c0e69e5596e13a4edc3b13e290899dc60f3f3a7e976c0b5679e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd64068c35514c8f778b9505be525d7051e1170378bcb78c9a2663fd86c9bebd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7f39794c421eebae92045eace30c6845f3214d0de89be234c20ec64cd84096(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de625372d0914b170dae8503e36fdb56ce9cb10039ccdb7ba201911e9b87250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456df33205be0747af4cab1d9bdbf8238ba863901e0a107c72445e941975730f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d029bf18472f39cfc440c44211e8aac5bc8d522477875f9e13fb3297ad547e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__970606d4e7b8886bee02375b47a61cad4c2cd931d2ece0ac1599bdd22125ebf1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661bf4ec937037cd9939a7a5aa31d04f69c70cad08429ae96e3c1df5e3d5253f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65850d3201b845f60abe5d2b59f7d52731d19500d4181eb7e7e81592c4c9267(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e6fc072bebcf3eec848d7576f3830e5cf4e46e9ac5e2326180d663d449825b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a20c8e5ebe2b3fa82ca17728cdae244774b2e8f5e0cd5c9271e9dd120af5303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c3cb001a3ff6764fb4a57bc24ebadc670d3b15788e5a235a5210b507bdebe33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fd1d994c5fae3f52df327742a77064671a8bbb4ee9fb2fbbca60a3f485c853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02bd4acbb68b393355b65b81c0d6844280ad91967ca7b32f85a987bfda80ff8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cfb1f2bd5a566eea636b249edd03db2fea8694e9ad0b31c643011ad198e6d4b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad984dffe9830db9a42c08e5126e2d8c8b2d05611a7c710d67c298c159ce1548(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc965a01aa0c659f31031ed1e5c462c08dad2009fc1b2e6b9560d99d48096df0(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c088c9271c8d4d52fd0d6d0b886bb5c4cfa0e3c70d37d6a9de1e094b23b1f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__836d0253caf7dd15ae06f376936ec66ed8048bf01ed988d284ed4a0732e95ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c570f6150c2dd6549f5a09d217ccce9799a2d6cd08ba3c05aafe2b66f0b7b557(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b5b7dc3485351b812a4b4ebf79cced6d4324bd4ae85e43857ab04d5d396b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e7b55c8a678dbf169bf591e8b09b33a0067885901974abeb82c86680d6280a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8b77841cdc81a5ea8752e483537d1c88e539ba7e22088edf72260dba478127(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3195b3594b188981ece5fb27ed78c898b2bb9723cbf44410d35daafaf2108686(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3858426f88888287641c3020f3d47d06ddf82db3164f99eeac988d78b263bde5(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7fb8904ff4579bd12115a714b7de5e8b382b14a93d79659affc09134b04b1e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0efda8984ea2e70f4cddfca7311864d403d0369308ea2a48deac192bb904f807(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5efb46f8faf04b0cef188e3230256786eec47c18de85c388b93fbdc37192f0(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a230de3ac16bb80da937714f6d017b6c1fe7e6c52d7c9c933a456fcd97e1ed30(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a204dd9f2c4e450dbbe251301f6bbc12d89808b7c5064670e9171271a1ba7e2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b8871ced677396a54b69d4b586a440fa5e2b1e0030c39e1c0ab298dd1dda4c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128581efe0055d2746e2a2b626d9111ab4b2ffbac2aedf311068df3f322ca318(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfbe807890a7b0e0183fd9f5dfb0c81b94945c46563916b7e11f4949ea5babb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7d0b9d2d766298ed84fb6f351f48ce20addc7ff810fc27889ca56fb7816ded(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e2bfea385083679b1f9e9326521eb671a148d5befff9adbac814779f68a6af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204e886db0f5b512c93ac84e835d6c3e688a1c3b91beae9f2af4999249468fa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdfb9679b3a34b46f18c74e4ee912b8d53a818907df15492dc6eb5f24b0695f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac3dd40b9a0d7beee667187acc09110c57b61aa06097d98fd7b84042fbf6359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5538c2426e892754bf51d3e0c21c110df82a0aad448131826ca329e8c2d1fee0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcb072640db3d754b8ddd1dab91ff33d5f4b8f336f7a2bf5b4b3864e86c2a83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e8033d0214a28937cd29aaf932f2779a254734b0325d61fa4e7ccbcfbcc31a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51fbe82ac58303e351a61c48065f95fdac7058b2979c89efd3c173fbdd0349be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1040fa5a8f8cf75635525bf1c00a59e886112c3caee517764ae13e1e630b520(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ccfcdc1f25aabbd2ad44929f7740359d0001d8dd307f8fcfd00f02555bde75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c67084deb245ff533921659c2b84e860e40f8f7dfe4a48e57fd5fee43b139a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64af38114be936ee3a9b3a20ec919b6b40668bd8e29115bb04c2466fda8736b8(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaefce1732b0988335d2a4905db88c732bd594fb8d21a4fad7860c30c2b58dfe(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6150318cd1cb385f9830522e6ce62fd3807ab753ff4745c24db1fef29236f2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6547bb0e9948df82604eb77087cc51b043b40bdafffda01ef17d29f90457bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fbe034b8498be95bccc4371222ec1fc8f9ea0c1d7b41a902dbe1026d2b56dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c158db3be187e9e888ab8fb96db231233402806063989eda1c3cde895deb55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d27790e3c4441187ab8c7a923d8463d6b1f15dbb663ddafaf7b900d49d582e71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e330eb5611aa64ef4ad8b81b6296f90a947d1b8242e17b0db5d74aee0f23d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificatesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972038b996dbe073a685cdceb3b8812d7f363709edd3ac8c2cfb6650efb98c5a(
    *,
    custom_status_code: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    recovery_method: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff70b7213bd59cc1fd5175721f4fbc920cd09997e682e949aa068445553b165(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45dafae06e2d02dc5b157acbcc42c4e8057b5e67b99f994131301332a95bf5e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4423d3af4e5412112236b6c0ccc28a0ce5619f007e0af8db227b0d62ea303e57(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e52a7c8fc2ed726d2158d84dbeea6c1a1b2e8ee23f4a1aafb170dcb40f3ec15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d05e2f5ca188d3d1eff0b16e312e321c40183410af725b08dc698198973c81c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27da815b8de6e2a8dcfd9404a52e0075a914683ac080cdfec6eb721e7c63c576(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f291da9faa85882a72f7318751481fd7684373cd6a5786e1d793cbfcb9e6f1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fa444fa1ffadeb330794b5afc8afbf944119c77264a7b3caab22c3ee0c26fa(
    *,
    binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
    ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
    origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
    origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
    status_code_monitoring1: typing.Optional[builtins.str] = None,
    status_code_monitoring2: typing.Optional[builtins.str] = None,
    status_code_monitoring3: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tuning_parameters: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1c24ed3bfc470ae9f0080af8a2bc353ec9fc84364f774fbf44deb1996fe1be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68503136b7fdeb4b2c19674f4b89f3cdf8a1b608f32c81cfe3a3f4d2e82b6fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8701f5a170e55d7e3aa24b37a2827b30a35b05b63a52e5f19aed79f392755142(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4be05f17635132f11d113f7466a2bc95957911d8e46aeab5f0e4748deaac95(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c82e4e50b3c6a6c2d965c3f094109729134d63cdfd5a99fd4c26d42851dc947(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fe457223dec70e88ad8e913fe3414f1da8007a15676ca957d937f73cc15bc7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22eb3c76613a8c0dba38a4a44b4bae5fcb9df5b0762095b718d9d55fccebb977(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faf4ba3ad11a432f37076c435c5dd85011a3c72cb2b186d7ee98a9f7ad4ee59e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba1b4f9b6ffc2b0b3858984f811f9adc2165b09f00013db58edd1161d260c509(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a098c30612f1e1454cb3f00cc29ccc5ade2871cf5a9244c941ffb0db11e6da0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae8567aedcdf7a46c6da6a74c76781a0e5d7a3447b8bc381ef1c9d794817cb3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276987b03a9e46baff6ccd077c2f1f576739766b1da4b64e67404abd1edf93b1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2af520875fb92f5d8dda5ebb47853ff1d6b7624be62b15692d4dac0bdf8bf08(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9825a382aca9ce57ed57f0577379af038ad4208ddd1c25c8f1b0b91c418388(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee01a3ba2a0b6d7a255d37594bcde6b6d40a6150126911b28ec0c12504dd02b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ed08dde0b0eb152ff7b84f0b497012d38d4319364a5712743795199e1b8366(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea4ba567bcb2160b7505b78a4005c2f1317da4068852e64ab88ea92554b402f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db88d87cea3bd0047711298f1f00426ec30e09ef3dcfd991660dc7858097ed27(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__803003175a3e14ebdb20cc76dc9919e82a4c571b7fcfb2012922c363468219cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c582621ef30ba630def1d3dccaf13aa02e234ee5b7ea687fdc906f53a5bc61a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76e46cfacb383d537b2f69850f143433b45327bb4d0f44c0f5f3372ab7ecdffd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d195f9795f28606b7c313758298ecfb53d1f2e470f1319fabd21ba877e4a26b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11661048dfa0c54bfa48d81890f43dee0589a09eb9663a6bb371e92b9d0c8fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f7a94006fbed20ff75965bc7ecd1a1203a75efbae507e83ac2e90e4bf5b951(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada223b490798df1f5a656f9c2de95dac40667b492dd9b97e885e5fd74acab55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a5c8dedab6b6d81b2e868738dee12a4e7f9fd4434199477fc602d9832abef8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65168919900e5f0dfb518e734d08ed4edd0c567cd08f916e37b8e604eff36129(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9219e77937df00fce4fd2af5889f444e810a29ed6d72d61968488d7475dcad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b86493a75cb11514462218615acb08e8e91c29dcae25498c7e9a7cfd1099e751(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb6a0fcd9298231bd84f5d8a24d394592162cc79a76ce4827c1155d9e4269a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb8b08db6f128f35c2c3ccd7d9ddc0082c3b64af29b232ae94a398cbc402b41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d53924b21e5767f6b47a3d4a2cc0ad0b0cc76025e43db185b0576b84f3841949(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a09a78aa83d17cd453371a39f25d6f88b822297b6a3ac24f08f4e8103a27e4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ee6193b4d6e70189cc7cafdfb444d7813a52d71f18fff36b7241c66f78d14d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0be00f9ec21ccf41c280f4fd951f830d29d5d467c82e0ebe6bda362ff5b3fb29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adffd3aaae01be9b1d1d92f490ab7855badea72b00946680e7989b1cb65f9ca3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginFailureRecoveryPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6cec4c7326a7b72dd0075ec0a78097e9a9b926f1f5d17050f5aae836e89880(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa113e0f7411bb22634773a482126a0dc0d578a83f6960bb1b414dbfc8125d64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e8b47acecd4bb0df4dbfd0cba1dec396883da0e964d2fa724ecbe7504af4a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebe29941a2d01960a83e2add6135700b857312882e9535c6843a87f3e0ae8bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24ae566eb4f57a0fa05215fe3dc8f33763a2d78dd1e6ffd48d977fa1c86c3ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdf4119463867c3f9a20449afbd37bdcc42b2a4466c58ca11d6906b545af2cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5254235c952c33c69660bd925dee34b8330c5b28f3e59d0494876333eba4acd6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginIpAcl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c979525f9034ff4c0730a126e8ff16f7c0504c1ae1176e7480e790e7b350c2(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02710684436c14a92883723bc82bca76e038539b52725f9e2e7359595b5045b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce7aaa95312b881e901c29dce55b2eb345e2d456101c51d743ebabcaf622734(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f34dd0f5ca502800c11095ae1554ca45e50acd7fc873faa2f23b1910a5be755e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbeb4e1666b3c67817597b487fc91cdaa8455e23f5ace3b0cc5f1db594c5d466(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e22f2280a91f79b29effbda553fb8f3f760eb91115435a719b7268a6ce8198(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7093b76188ebb1627994d734fc50ba3322cb67f76f935d934891b94cbbce5ffb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50de080890db609a8b8f857f0c46db2bc6bf6c119472c174d930bce40ac90518(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50b0f9de11a797cae48cb89f1bd8221db910c163cb5449488d2caba4931dd4fb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204ba395d5deba6901e5475589479d709d130e3a2b65a8954cd30c1f22f8170b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89246af4b29e3baaa9485acf0fe22d482a80daa76b80645faef249a797fba6b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc5557f34b65961e1f16b15beafa65d3cc12f47346a4df1e942f9ddab95f77b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3f85919261aa8dbe87050711c5743a62a228705e96946e63e3bcf1b7dc5a07(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f33eb922b969036a93985dba09173d3171394917f4d274e4bed7c6935a7409e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8efd62c5ce2cf754efa96bbc5e844c99e0a6a98c447b51490cf9129f9cd0c30b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4315ef28cfcbfa17e1c0545e1b1b43784d8f1159351826693c4576f25842e0ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b02008a733868c44e1d2027d725702f3a41c4371b4ff13c679e3d86007b4396(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27488479070c2dc806f2264994a08d27c246d9c60bccaa6df1a13a915af01503(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9e290a4345eafbd526ef0ad0c3ddb83898b187fc62db77e7171e63c7fdf25f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e0b3d398aa95b149bfbace11aad33fcaf27500fce2a4776bae515ee279dc59(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e59a8005befdf4874b4a31dd1ffaf22a606b67fea3d92d1a2241bfb838bdc30e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e8ce9a623abe3cb1a545a6633ea0797d5f0f1c4d18320c1e302842d915f815(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7bf17166fca334e4a08eb708638ccca927405ef6526f0d856336f916b92ba37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca2b1494e6188d42f9a709d9acaf042830e1cad7e5caa246c1f323b81e543ee3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56953bce52e52652fea1a068e184d93492b2816a6294904f5ab2272bf11eb244(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674e4d5f93b4ef371f4a74c8530455f766af402eb336fc04fa5aacd3b3ab9359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2172dad83c8dd0a3c644fb8dc35eb1caa5a5d6cf597c271bedb72f9ebfea37d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a55d15062270abd071aa5544f6ce710401347aa75f697ef259118a64c6ca916(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39a1093e055cc6ae2b68ff2687b0219687a557ccef663e54b23771894a2edcd0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05716b5b1bf68f6eef77e731c6725a15651a1c13d69ae9e4facbfcc77722e073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6cbe30b5ec69cb6d0f23d10daaaa26f1e2c710b447e8bfffb1ac1cb49c2baa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196ddd1c59c17de195407a428fc89c7550558ae5ccf7dcb7ee78ecb4066ad62a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab54050e7c96f3dc74082cacc55b8bb890acc1407a6ccdd4116bce589d704373(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a29c5bf4e8b8e73d3c07f9a90feecbcfa081b6511efd9f6437511fe5615dda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f1862f22075073065525fd3ed4662e4c6ffb76e36df3fa24c44d5b7b2510a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcf3b10d4fe9e46081d2d44323da2acb32f86bbe55eb66c64778fd36c9d5fb17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3698f7c72fa528fddb0c359f9e3b1568ad6095a40324d354a815ac1141f70981(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84d5f74d2b23407587041567836032cb7233c0e3f3404a5ca122305e359e4284(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67bb5e541d2e077671758e87c9f3dc7ec37f815e096416cbe434df50ed5718d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01075376af0de27936cc882620bf3b0ac1746638d8f215d6e6eade5e3134e30d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e660a36530c0304100bb62cb3f85e140f7f73697a6fdd44298bb39f521fbc53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fef52de8b78ea090918ee537861e28aa8a7b0204e9e2e84b4c9b1979647b5a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1ae1ca09ac5c31f46ac843b13e7ba182a1bfb9fa9b1c30ef46996e02369389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a84540915fc2556c1e674dc2f4a097e9ab91c10150f029446c1e1a77381e4fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ace381a000364f8fe7144cda353b9ea339ac46ad288d1f84b246a3c8df2f37b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a1b8fd6e36b504964a6df440d842ea68149203483593f4637926d14cd29f46a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84e1b33033ef2ec73e3e61523cab09e46c33cd24282be52eddd799354d604e9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Behavior]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ae5c59e9334d0c0142164535d23254e128a84398472dcb1c7c49c7a7ddc9ef(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bddedb29bef04a8a32df9fa9afc7d3638df2b4b3b7be725dc13fbeab66e886f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f83115b8dd2006de484c6108a23f7b4634eec29f717558d6e5083c40fa297c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155aa9e1658c4eda7c4f4fc87900c01cf9f0d639aa5c533bea60ae797e2a4ef1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bdd7a147ebba7e636ffe3887c1160e43ba90c207d356360ded8a7266926143f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234f2ae8b59a2cf6b09ece0cd5d4b29d00282db80403bbd552da7f84ed52259a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378d0a45db7ecbf1ae7484e478d65f9a5fbcaa08a030dd254230411eb5eb0adc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed07acbb45c759ad6d2bf25b837529c113539dd8c796e15d6ca4d4732ff0ce1a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentClientConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048176bd3a379f062f7f48065aa27d376c51bd9c87babb1f8642ee8235386703(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdceb75f16b59ba0a5986a83480ceb06ec6d181aa8689e07684bce4455c8cc79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3092dd5761ca6f6beb9a66d4d1f5aa91023aaed753a82fd7eb18ddd4425016f3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f27b456d9740c87f4a7851c74ee068c6153c0a1c51046ba4f21a90de2f2315(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abc11e7fdaaae70be2d21f93493cb608728726a45d2bebeb73e97ebd07f75008(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ef835f77834bf54f49211b487969ea0c1f3cec744757db59340126462b9b95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffa1f36acc9aa39ddec5a48c5918aa98b93f4cc3afc3e4b7ce1c49149a9de3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__466288174bf0b82b6a49d800e41e87cc513a199bd07d9499777f2c6ba4038baf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersistentConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f767910ec48c0be44379b731a7a4ab3151491d915d2c653040b457963efa5b14(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecfd0a745cee5c2a7db3edb49c461ba384485c66a3b2e402bfdf7755bfa14320(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c17be7505b662628bd5e072da55c64b24d1c81980c24694082ba4dec477434d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3cacdc457e3ca16deefc5a50736672b415141036ccec4f14ef3da9fbbbd95c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc0970f565b5d25759997d8793ba9cbbfc30ceb2055d2c8d743cf01e51591961(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fefaf3e707dfe8f0117c80e0b67eaef1d4028cfc6927b78fc1fcfdaeaf8c3c85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495efb04e0ccc62afa9a8d6cef60167c493ed0b052415b31d569e29bea06ee40(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPersonallyIdentifiableInformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0489dba73eb47bc1dcac05ce31dc161d744774106f3ef92cca2c2f8fbba4faab(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_duration: typing.Optional[jsii.Number] = None,
    failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_expiration_date: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70f75436ba7d588983e373862046c774e48450b29b7e120b6a39bab09a6a86ac(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791b3fbef1dbb27f0c89f0daa3b91d915d05c01f696994695e7ccb8b70f4338b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bcc225a206dd0174b4e2148de41fcfd32e43840253885d8ecee1cc435209d7e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbae01f619fc69634c89c6b0c696f9342d28810cabb41f1a0bda1b0e7eea1980(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce03865db6b6d37da92fbefdb8ddf8a1fd0ac8d655cbda4bf97aff31b521beb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedReleaseCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220ee67f5e1ef916276b7d279285886a833bda14ab5aec71312c33eff48c3c49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50cfbc27b1eb96f0f0bf1666e60a0752d7ae5fe433beb2c67ce23acfaff1601(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02ae77039dbb9e3939607b4c1b091cd84dbb7e7b48a80b87cae357640eee3b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b567172fa87d0904b4ce506fd7b61ed191ac3d32ff51bc9f59df160323cade1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12eeb43689b447fb51b66a42212321bb6d29a775b9036f1207c33f51eaf099e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c31464b3d32702c61af627827ead49d5619ca8834f4541807b0b0b3432cb09db(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4042afb2bda618fc9b15b7060e19f26712ba5d93aaec7a7aa97b6cbaa7d40f82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4549558fabc38318bc7af428b8110f11aad4845d9c9dfec61e85ef8b1caa7442(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7f01d831a778d8a12a76231203f6cff6cf5cc413d5ac66c675d6424fa30bb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fcc52cc1dcaee5cdd7a269847039be83b27ef104845abd5e4ed8e281fc40d45(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a22147b81c27307fc08c10a5b821d7eda18135425fdb3f10670e322c8d8e95c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d778fdf326d0502fc525a3e9c50ce057c53169ba951b7cc39681f968b6a78df7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03689bd4de3228059fce806863c84fe0c3f1268c539d79b086cd8680aad3323d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a694a529005de13a8cf44573932732d60504d45beb47fc8fc16d73f19e33ec3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c176ecdba8715142a577d0ca04d2324486c122837e4c88610acc97f270b768a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ea398a09c707da5b676468ed6374bb9245e23214cbebd6254c141f2c51baad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3472bb1e665cbf2b8e000f8f5aecb5a64c92e89fe3389a8633f2566f0bc618(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f582af9a8bd3cb139ab29156a633b9ecaed186591e0dff9b0f7a39fdfaa732dd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPhasedRelease],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e320b442f27f71ae46dbd0c0570e83d1bc299c83ed0ad0ea81eb03569c8704(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f512ef8eee3e9f0e5869f75829b4d0f2adfcb3fe86799e9f07da019ac87cbd7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b0235493e6db727bb264cbb1cbd8eee7f3e5312ce381fed560930a816db7d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70605aefd8b3a5c6842f748cd9ed8eabe5ad2205868b0ac57f5b43dec7e10a6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513402d7e62e9a02d4d4b378289697e3c5fcf58ee60cb162f96d0fcdeac15297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53fb422a143140f2a433cec3d13abb66aad690d023224663b3e72e2b04d441c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66747a40514be41f2ca7016d314a34ce9b911cdf78e33913f0a86bbc3c23af3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPreconnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7ea4327920af5cc42607d6227ee377dcbbbeb84f791cbda07229c2a88b0141(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f8549379ce085f3533ebddda4aeff49d9f216db277851c7e9908ace2eed2210(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a753c08466a9956f973e8a2967b419ba79fa9d33553535645a55f41e7ad869(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c8936e45f9db58c5beccc76b0969406648ea7807c74b8632f5a6d8c299bd2b7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d668972bb246ac4e06f0191f0ae34d887a56c44430b525a299e93a6fa3e12315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdfd2e0e34777ba6ae967c73408615938b1c63c643b866d5016bb5c677ea4bba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03d38de49d695134553d9731dbf901bc2060a74a8947c26e70facabf6f678824(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictiveContentDelivery],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3cf4e5142c82b647a54067dede69e7f218df71a8ed44e4457fe60963adc8c39(
    *,
    accuracy_target: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca487930e9f01054485ec0573589fa13f663d12b195142b8f138042ab05b0381(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0502d1004067fc928584ca351ac1c6ac9e88eb6766da712e572f5f1e8912125(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e72688e6967c43c62ba62c17edc1194967fab272c86be6650b07ec56db885d03(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc16dc99e84786933a15ad5e2fd0f65f464e17ace506d5375904efdfdeb1dfaf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2831af1fbec70b7ea8632df123de73fc06ad7f3d19902ef27066eef3f0507c21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0715f5e5b64a0f028648f7913ff0999232a5ee695524e969a79cad8d2b85eb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d567097f2299f2faf6dda164df98d7f2ccc1bc716ad90532199069352db0a22b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPredictivePrefetching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e883a7eb43424258f350b504200d524b7f2af16c8568f60e9ad430ab42f91b29(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775d6c1c47719e7501b9fd4eb65c1c8ed0ea5492a2e6c46d57f0bba269189106(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b8c8ca3cdf20e84cad4b276583cd8fcca37d45a299d50b0198115b104139e3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba7be9cd2a6fe49b8dc0a3e02ba0734b55e1e719d737aa0ea71e08be5913cea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087dbb2bd254cd970e5a0605397dab823e3053c3b164465d2dc6b2db2c0e112b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cce9dda6d81849d540ba016ef3c12e35267164668573d9054bb4c9f24e02317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e64e987fcdbcfb9086eb57ad59d0e399501b42c7718278a78f004682bbb8af2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a866d480166f7656a4f58d95e57e33152ff85ffce92ee744157b640d0236c502(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68432457f4f9e96e70e30aa83cb7c4e5ae8fbc2944df0326aabb282712140eee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b3fe570008a2701ff52e3e6ee4b0ff15494dc912c1b74c3ac9d8224a6adeb60(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08c21e1e9417bc39b169d0d1654ff5c3f47b5c282bdbb14d64c25cbb60a4b89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aa5fc09918317d68c6d51a60326c864c79c5b43accd20ae21aa3928e67841ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5113adee18f5d280d1ff2f3e38a22f3513d96faed267717af64c7a4c1a57d0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__859bc62a298668bcc88a0277218c7d98b533c20680563319f67b978f5eee5ced(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefetchable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658cc24d2b4ee82ee589ac053e731b30e1ddc7c6f030c497d34873c866a3bf9b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefreshval: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2576c27d219006049bf8682f65278f9712fa865126a14abc09b9ed33e93fba4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3183ac33f8f25cc0b99bea194c6b5604ca3dae1a49baead37c9d89392da5e028(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d86d8b6d4c0339a1730779b25f4cd8c3d983b05167054c9542970fad1d311a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4f5c6f98eb4d53b7fc3a5b6e341220142193141538e48748cd0121b1e8194b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425afe9bfa38a5affdf0e29ecbf069c527e023de5167098245379299ef75eec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4abfef293dd1521799961c7ae6c56a25fda076b61afdde8a3b2d20419f89421(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0adabd11ef13e22b3c0bde3b6b11519741316a52c055fb9bf3a0c5a6c80d6b09(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorPrefreshCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce3bd40437c893f031f605cf5a054ea7f848076793f6c433e16be9cf30fa081(
    *,
    audience_settings: typing.Optional[builtins.str] = None,
    catalog_size: typing.Optional[builtins.str] = None,
    content_settings: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    delivery_format: typing.Optional[builtins.str] = None,
    delivery_type: typing.Optional[builtins.str] = None,
    download_type: typing.Optional[builtins.str] = None,
    end_user_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_concurrent_users: typing.Optional[builtins.str] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_for: typing.Optional[builtins.str] = None,
    origin_settings: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    refresh_rate: typing.Optional[builtins.str] = None,
    segment_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de1a7f7ecbd7c7c902c87b25405e71439ce787e1c301df3d79628f885fea52e6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ec0f14794c6ad9ef66a92dbe5cab9368e6b78ea619c69217ac94136b163c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb3b49e1541e06d989a8c68052d745e68870f3d1362522053b49ff5bb1978320(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc13fe045ecb06253527938d33714ce4dbe49ae79ccdca300fb741986d13121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de35dedd917bd845541377c9b81cc5839d3de88f1c601d81390558dac3f4b0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547a4a79e873d05d40cb61a426735e519f86b882a80c2785e5c27e20a86fe71b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84d6fe70748ba2be10c652c84e62ac61bcd2ae21f107c47f2d6b1e767d7e516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91bcf8bab17b5c27c273a33bef964fe009d36dabac43356396434d27c2931ce2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd3a9eb4198d73ec6ea8d909e51f21331511afedf238ff58692db9cfdb9ad5eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3744730e24486b9accc8c59b5f9a0b8ecfb7113cb5472e91590868a7ca71cf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d9ed343424bbb011dd5c176f4ee1659e138c9e47e38d62332dfc6ab591f236(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cdb289db29f0957a5f186ba165f8cdc27352edea9217e5aefd30b4dbdc91209(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d953f55afb8e583c3b2a8ddab3df3839a506d8a8b5e1e5d73c45be2927cdfd5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f48cfbe563e82c478a0bde24058b4a9ce82fa4984857e4f7e36c2db1596e66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d343034d4ee65504a658c2f3e1f42f374b5c394ae435a6b93dc49e0c97389250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb23a14c3bf17895853e425cc65047c38be06043e70972e83914176449356657(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cf53f6ee271d44941ef1d8123ef7bd0430ff4a8c8ea18bffc471c5a3ae7516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a49f306a8d9158acd3a681abdaad4c22063f54e89cd9d33e76ef04bed2359924(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dace6301cb0c3e8d516eca44a5daa9bce616bfbd3a0f114ab25e52a190ab0147(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1715ad73b5e0df2478dbbf46ab42cb5cc3e5f70e6c8ae030386bf7b3ec87ffde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f741de7b68b85e6592b5612d44bd18cb8e9acf81a04f859cb50bcff177303af5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuality],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d504ebf651a8f4975de590fe674d43e659f3ca7ac1ddc796915a06d518eeaeb4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    quic_offer_percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f5057a5e43141ab48d13c203870ac62fd848b361aaca4c108ab6e34aa48599(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ae88d53542e29c9e5b9704fc0bccb2fa7dae7a91759cdf2605ab745d015464(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04109243b2917784609c6e4066920e2a53768eca972a9ad0684a14ed4f3d0ea9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__032d971eebf24ae25d4b6299d5d5ed538a4c1f260e72193e3b84495ee944c33d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035d4c6d4990a4339716ad794402e6f1a2fdba073143253392402126df7c1e36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21ac3bfdecb5efaca4d84262cb3e621955dd3316e05522c2bcab5e3dcafb32f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8abf52078ada2c7883cfe50a80d6fa7a13f34bf6a6c81b96bd28de513c27ce9b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorQuicBeta],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c217cedfb2bd6c4949839cea3258e1bc47dae00ed10704acf3aa77a8701f30a5(
    *,
    flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d63f3a291c1f2606dd6f3e71ad791df992cb11577dfb61af67b782dd36e32d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba3ff715823665becc50a724052c73dba0ab850cc4dbb129f13f085669bf0d4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb652c0943b376630f7e21fd405ed1929268bab1e045a578373ee8bc03655d1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8ee079d5fced4e390a6d99ed642e889a80e88280da3f55953eedb427a3a26fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b561cd9a4fffee07ffff4c8872f48033ae8e55a9f8a9608de2e64e828cb31eb9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685baf70016d5ad722cca0291943d9e7e61f44e98433982bf7a781ff6c54fbb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217b9aa44f6825a643308d814251bcd73f9c1d0d33ee4ea7377e3057e77f3c96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d617c75a652db490d4311fa73b2dbe7cde77715315f2baea568e5ffa74115cdc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRandomSeek],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb2129c6210e84431447d058c7b05804d75b8f6238c6e1736eef53a3ed8b7e4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1655053df45db3d9729502fdf95ce2d50e53445661b7e1e4fb85817459d5e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bef0529c7c82f981936d3e56753245f9227782002f4b55b9185c1e887877701(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b48e15bfac11591322b3319be86382fb3d87011f4ea837f06abb7b0c2d69f3a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b46e4324d19daf721cd79ea2b48213ceaea094d98aa3f75082df6d66afd2509a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51969409e46db258afb08075af025447134d2a0bcfdcb9aaf2a31aeb4033c2b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3c7d5345519c0b3e8ae4078c5956bf25878a655173e3509bba1cf6ff3aac2ed(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRapid],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8288353b4b00a31b0eb7043bf7de5310f89eeabeab3bbefc3378b2ad736c00b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271d7314521b64a0ab592312b58c5b1052adb1bc7ac353b806d41c2ff27b1c3e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d469316ea6be6f6b4270ba37a9ad2542560b6accec8f3d20651e66562f0bb997(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7564516f39ba5c6bc20d234a40f0466476106e227a4c51fb62f21de02ee4841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab8e740b05a39e5e1ad8b788863a168adcc850ec3dbc2fd8f8f6eba41b27ddc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__537c4903b4b505c03b1add2163ffaf3d295c5cccfe76da65ec0861f3e69fc11b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965c2e992702d3c43a0f4236a75890fc74141a83fa7bde101418f662b9cc2ae1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReadTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93978c9f4adefa1ecc0cb2aff876f746732cbb98a047fd969079c0ad60a63234(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b72f2933e01b1abb71d6a5ee7bd71b55a36808b0dd3e92cd4788848bd093027e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__321cd9cf93bfd4fbcae8b65d5abc1ab8d0d347a6471fb6a5f6f3ae97c9456ba5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__862322f2ece029aff1b2802fd4b6bd5713825e4f25764fb5d8313fe72cfbd9d9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c150ec04588b5409be125c5f2cbd3833d7ce47a69110ec7b447a53d233bf5cb7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f83c3c79bab477618a5b0f3bc94af1f096f950eb0185ebc01ac34e81923027f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d65343e074dd5f35a5c75c812ec65c19f635caa269ef4309e29c6c4797c60ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7ae3f7a25c22ef1135e535d4297dd8a679d75f11d91f4b7a20e63c878dd5cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c4c3f0f38c6781f2334420e7962a06e5863d3bb00270ed41542996805fb745(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealTimeReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58d5aaa39679809d89c897e563c60a72484d257e2202adc1727f01675c75ece4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29af131aa2a6aa37a513dc18f5aba33cdaf8db7a6e56285c387b073dbdf81cbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea6a600b9a831dddd24187e7be3777979cead339fffbde29fb04ac80b2e70be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b20a4a060e6dc54c3ae558d035223d89dbc9761476de6ea16cc8e2027aaf3b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af84311e247910acd8ef20dc5f2f9ed646eab6c1d3d78ee8c23dfdd62e6178be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__505351715f5bfe0704c0f6a5bdd415d42819a822abb2a03c5222f8d5a121f56e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb54d88a7956f1d36cfc6b3ea75acac7a65d1d4ff13e992c8736a86d740d38f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRealUserMonitoring],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a939c3ea78d55310ec13d5d5cef8c5a9d8e5402fa6288226e4c87ceda9e5ffee(
    *,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_hostname_other: typing.Optional[builtins.str] = None,
    destination_hostname_sibling: typing.Optional[builtins.str] = None,
    destination_hostname_subdomain: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    destination_path_other: typing.Optional[builtins.str] = None,
    destination_path_prefix: typing.Optional[builtins.str] = None,
    destination_path_suffix: typing.Optional[builtins.str] = None,
    destination_path_suffix_status: typing.Optional[builtins.str] = None,
    destination_protocol: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mobile_default_choice: typing.Optional[builtins.str] = None,
    query_string: typing.Optional[builtins.str] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ac014147cb4b25995059e083af893a9a5d76fefb776db6f979005a9b6b856c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b371840cbe76336303b2a3b49ed90c3bc70c4d6e5494049d623f98920ca76b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd5d18653d02b54c3280475449158820a2d1a193a9e30c25d1795d99d4cc490b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b88f05dda6cccfbcdbc328c12bf3e26608e121e124653f3f6ca5afb5dbe1465c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a4c2bd7284ef1dc18d390e12e2dffe8e52a1592a675d84920eb599bf00bb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f9a4968de431aceb3b7f33fac71829f3e20f58ca92481e3444e1a8d25d6690(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2684e8ccb6e6c62e0f1b76bcfd69481126a58419cb82c42867caa0236dbc2e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__676fbf8a29a9864b10ed148e4d04c6ddf0f259253797a490bc6a2a030331630a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef26bdce3b8706fbae8a377b2da1fde203db7149e5bf0442a47a182b0559a9bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c473a97e32996032b2ef6b2bc6b723be9700b37904521602ec7b51f76cb804f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99537fa5c449b0f99a8b3e09a214dcfa44bf150c67e39fb15c247e7c61b6860c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd24b09126bafe34f86c48a9366f02e2493ec1fed938af67fb6097255337aea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cffd874f49465f8b88606c5481f6f15efec8b2dbcc9aaa80c0e58777343d16c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6c171c878578561d97ff6950b1335e05d9631d1dfa922ca76ab607b7dda038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4497b5e226befedfc13839a60e876442286dfb754bb38d85257ffcf7faf00e89(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ba9aa3d524aa62072503c8abe342001020e28ad9a6916cfffc9948e02f107d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8001e2d4f23afcbcccb2f23d9e06d377502506e3b6eee60dcbb65ccf70c70b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2307210f88be5d361bc343b104b643e89eb00dd929a2a9d689b9885fd753401(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e5593d2885383c4ceb890975af92a72ff1f4b678127b5e9ed475ad227bdea6(
    *,
    destination: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9342902bac2a654682cd11b9decb97eb9f1b62d6d912bbc7c755d855c6ada514(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3e7510ea79510999a0fbc3e89342d6e86825dcb4c06ec2b20b6065dc88b4d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183a5afeb1b981ab61c7455e107b1a9e0679d58f6a0bf3acf3dedcf8907c51b4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c8c18c2680372c281b6d8e8ef3462f4399f454b8eacb67f02fdc94b01b3ff22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62938111c217979d30fb5550546313b8b2135b11e9208e2e10011a2151e1b78b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf425e01c57ff1e79ece5e1e9d75912271a89b9160555ded038f71cc1324ae4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe0ccf9144fa30f5c2948920eda11a5d07b52568dde870939e80fb165ce73e38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__982fe456a634d65bdc2cd9a3f5ebb946259483caafad0c3da29ee4573e9c6429(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRedirectplus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e11fbf9a15f0af30927ba926df06438de263f597c7df87da8cca23afbb2e28b(
    *,
    allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111e59d89922c4ed4606214d3ac86f72a2e33e9740521480b97c5049c0b63c1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf3923908c44ace92352958a3e92bae15db8268e5583cb845bee8566618163b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ae4af0d4b70b835d9fcdc6e4dcb43eb13bee43a46aa230fc30820691557c00(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723156ede1483113f2bb6dde6ff559929e54b41426fe923112c798aad9916368(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1067b7849bf97ccf15f5624a0f5beca9a2607ac47d32ca1f1c6685517961ddc9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7616f3398216142c08099f6aba193c1207796bb86e9059ff5e06a0cb8b43535a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da429c569aeab162289d2b988253c252db26e0610f752354cd746790460902f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8c489216ff4cbab411124c213acb813ec3e978788efbe4235f5be430d4f8415(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94f8b1cfb27f3d8795860a6cabe57a2c42a7a5638559ee9f9449306fb379a02(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRefererChecking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f92377430ef219ad686c9d220024c7d39834bfa0c28a50240c57fa4b87e2c3c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e505be14767bb5fa5956672ab547282a2d57e7667d8a023cd5c13c149263851b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900ea388962529079b77032738f9086d72e49339dbab315bcb459541065353d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af04dea5d81b28c60611633e0e007c64ebfbd6d1ebe9ac06d8d2995dce517ec0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__114ff049195d60805f60f5ae1da87e947f54fb86fc467b03531e731965ee7f5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529b8550561a05b485131eb525e48341a42e52a08cc285976994c3a8bab757e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20847d13bf15fc81afc1b951d0b67a043ebd9ebe996eb8e0470279756651a212(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveQueryParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feb905a3aaf7959c0a216aa1718e417fa5a33627350499108d5434330f26c091(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3500bc3b3b89f668472a446a9e31cfe0b6cefa63a4849efdf5bf5355d06d62f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55f74b9ac60eab1973df4f10f3267123079d3f26b58cbaa93410320e7226ac9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc37b219b8348ed6934f4920453db4301949456531947725d6c1ec7f437248b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f13eca87d82a314da1b22cfb9c4e4ca69bcd0e2ed4e5b648b36030d826f2585(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dced1b44cb86b1ba61b6363925931731ba85ddc6f483298f42ee779447d178c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3af6384cc9aca4878cce146a60a80b018f51f4ea9361f6dfe814c59c416cf047(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRemoveVary],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3779f53340639f3d6c57de89f89848a5b2490a66ecda2d821e8d4354d9f9bfb6(
    *,
    cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_cookies: typing.Optional[builtins.str] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9564d7e886b0032efbaa33c27005f733e5e8f5d6528e3a4a99b7bff98981bf6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e982b244b10178aac586ad077ee2754b69b27b7bdbb3aed91f847f523be20b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73da9f58121c2036795ed318cbcc2e70c440e5f42c8855f0099eb17c5af768f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb7686263cd0022b1f88cd9b8399ff4ea9fa5233708291c6769bed504bdc4c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d3a1621f23c1515c2a746bc0dac136d22faa02b55ebb415ffae2953f4f18450(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c1db6df99b857fe8ed70b79bec9e5638ab19a50536f6aeab25029bcdcae519(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbaa2c32629a5649fc88d8434d47b21bc965b6e1c1a25cbc5170650470bfbb16(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cce86b0caa4dbf3fd14ce1ac31af4cbaf829a37aaeca00cda4fb58e20448347(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf73cc98079423c29fb21f2d682886176cabc990e9602185fc3e169466d8dc6d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63fb0848e59bcb85d25adad7917f9ded76cc1acf7b7a7fe344ca556d669355c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1ec66c381ea4eedd004f94462114a8c8dc593c8a0fcbfba514b4e0d5a453cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64dfa1876a74fc83f55cc8bd8a4e5aa6a984fd7ae43a4312b3edcabfedc5032d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcfcb51d2c0ca651c1ad86d4ec05b980800665169028556d1a5ee50bb25d3269(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6255abef5ad73793d22e5d077a2442dbdcd88bb92655f07964f1b929e621fc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8baaad8c3b08b39e725187659cf87e41c3c49313b710953375a9d6f37c73c0e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5476c9a2110b137bd44b0c8111ffc789166d19bcd2beda457738cc763bed930(
    *,
    branded403_file: typing.Optional[builtins.str] = None,
    branded403_status_code: typing.Optional[jsii.Number] = None,
    branded403_url: typing.Optional[builtins.str] = None,
    branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f058691ecc70b6f27b1aff39cdf664926c03139adb486617bf25d14425dfcb(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63cb68f3b11e947e84eeb69570e1a3331c594841bd506aabe6d80b6e190aa27c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c185d05951d9886532750c7aa5f917998568e9454457ad7082386bdbf7e9a2c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8575537038948c2d98bd963d7173ebe35b62bcfe9064088c5754211a061f1f8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06ab279417f91b1138d1146cf56c2564cd641d48e028ccaa59fde782e71e6ff(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b928738f841eeee456be634e3504e47ce399b883fae58580f9ae91c52cb9dbd1(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea9c2de1a37fd37b87689a3bd4f6fbacfdb2eda882679207e7cb099063d8704(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9111a7c6086ca37e750d8d9ba366e278c402fa568a3cc8eece10ecc101171c1f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b4f4605a8b7b1506b0d5ecdfdf58d0e365ce1180a30a951bfd359a824d686a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e95e3e242658d5aefd084bc4255e75e54a0093249865658e48142a74833e07fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a646776aec97ee17ec211c4a4c4c4d89fdf7e2cc5a9f9225259fc9ec7e8660(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControlNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791f715f6dd9226321744f4fec86f4757a034ed7c2a1cbb4d83a61226289ed21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd1d313ca6b0d76abf3a3a417d3135d25c5177c55d532bb818915e95643f0b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb1275b9c74f862a088547be483915bcad6aa5a2a3f6eaac2212240f468a6a6f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8195383945206006af5a72eef2243a09d579bf9982a9ef44332fa1c7458d153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1cbc85277c262619a37b2f14b1f4825b07a71178c43fe56ebf71582f1f8ed2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__793f37f680e7eba4419371639f1bdb73a8e7bdbcb594a24da2e724792d142630(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ddb97bd1296276d5a83219d57d90038244c52c9877e128306707954b226bcb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18fe49ddc5f7490a642a6e6f1f9cb403d4c87930cb8d9fba936468aff6c25c7d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86d4ef41e70e5061c1da3e6990ab18a049b4d217a18680b84162f6668f4ef6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517f0436b4f037207eadf8a29d0bf15593faca8f1da7190cad3888a927d88ae0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e792a67b78332c9225a29bd891030e750c840988f94ed611915e8111bcf7307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dace63d37fa837db41c4d9cde1c59473fafbb7cdea9118be726b9c3b3a92a24e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4592be08e19bd185635eafee5972aab03dfe39ce223359c5420ff73a169e7893(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestControl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017a5b795df565a832babf82594ec4aceded228530dc47d556da514c69858596(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a7f7a371459a013c543f3946f80b62398dac1e16cd996584826646e344db48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e141403ce89206f8761bf00d0758fcd1b161df7e46e5e4ef1075727b8114b6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fed81294227d713c43e80ae9fb9b8cc0cd9aefef906d9defe55eb82884cb50e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a31ba99b0b7382c4286ed7cb286113bb78f96627f3f613273d6c83842f8b18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5338dfaea70f839b655839f6826ed300dd09628cd1d57b13a107c0865894b0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c0f02e29998fc41e837902f0f40a0c5ab16f7f808d25fb64ce20645650480f1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRequestTypeMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b96387b7a6446f3e26cd7ed97b2e46e4b5bf9180ceb5c7728cfa164ed57b91b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361331e463d001b41789b3a5fc1f020dcd48a5bbbea4195da0042293e4119538(
    *,
    enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3933538e83f22da21ee5e778ff843aec229fd265ddb811e987411128be5b923(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e1fd97083057b0a59d8125e3846c8df7a07bb999798fc41e6799df4c848c0dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__934275390a6a8098b7f1e5f99d803dcedf4f6f0c04c0241692e38e5aabe9306a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11797ef78290a262898206a84551cf60cf7e111f60565a51ac595b7a242766c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a73eef015c80412e115acfbf0393dc968c7c3597dcded14b6551f6325286e51c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88db433a3b41cd03f0c94ac7327cc921347713a075c8a30548216e87fb32f222(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f15e960ea55653509d58cc3cf3fd30e535f5f140a9dc5e1478380a3664d4921(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizerExtendedCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe933019191e869c06ab3732cf1c8a75797c1c55145faaeede250cb923e382ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a66ffb6076e1325a763bf29d1b3c3db11dfc82063faa307c7029c8b0ae18459b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab410cfdbfefe2a715f9c8b1d3025a74679bc5386b0cb35197bf7ab2d77c26b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8b1ce0a0dcfb02db9504b05fdcadfabe75c95fc3490a86995ecabde2edb61f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29204ffbac8a1296507fba8f2bf004d689c8047408712bfd6637fe5a0e40ec65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad12b6801bc5a365c088b2e10e2fb5e7eca930ac20f14f79a55e7a6cb47baae(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResourceOptimizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__876464bfd4608feaaa9c2e9029505790b933ff3cff32ed96f4941ed8e0e2491d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8fe3ccba17a2d9a52e527c6d2cc2e009ae052b987120f3b7aeb379580c8a54(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de497ffac385de094f57a55ccf53f3f5c37de4ea0596e48e8de7f066329b1fd1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c13caf9e577797d7262b2b4fdcf519dc3b9a85b27a2c369e4948022a3881c56(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09ab1edae05e02e68c2ef67ef46261da9adf30e76000aa465783966e0bd14062(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f9a1ab609738c196c031a81c3fe4b0c3b7681a697306dbbc01593b05d9fa2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2fdfb0771992866880167e7c595607e260ab50ee5e36c231d3f21ccf63c12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0253313b82f0d5eacff0c6b46736f0ebbf7af6861a8bd1c2fcb3669f7015e581(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__693a550a717abcf7b10910120f48255760a3bf350f77fd7871d5ddd771ec7474(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domain: typing.Optional[builtins.str] = None,
    duration: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_date: typing.Optional[builtins.str] = None,
    expires: typing.Optional[builtins.str] = None,
    format: typing.Optional[builtins.str] = None,
    http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    same_site: typing.Optional[builtins.str] = None,
    secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90adaecde95bc8ddf35d613f1a841bee4c0fde083e65695965416b02bc3f3a9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db6bccfff7e90a4e7f8819a719af36d036d258c454f3097b3c6344628409327b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2de68675ea9669de4a6a2c7f1978b1761b301c631854cf3a5eb8ce1a2b6ae50(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7410109e335fc2369bd78d8415fafb990ac3096d0d07b4d20655d9dd3545d382(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db31a4e7224daf879d55c906fc2287f717b02a416d60c31c0608bc4c056bc2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc82b3b3aeb2a895f10ed61c9915b5e7770ad83613ba7446dccdd617ed40a34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7793e4181331bf54f3ea8f0940fa39020aea89bb47be071271929a400e150372(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37bd71096c9fdd73cc53af3eec9093168d4b9dace82aa7af4ebd5de2e51926b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d803125444fdcbfca58cef7eecaa27ad9c21724adb29baa3d70b27969d396a03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d646ecba862f350c05dfe9b4a99e877f49302dc134fb014eec4a4baf035f2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11889ed5c8b5c67d1857a1b682bc8ff54de7547421844cc651d9f10c80affed8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acd67b4181d9cd30aad93cd43f4d80dd67fb0da3b181979373c8bbcda773f976(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc48ce435590054d309b1874cee56b43ed6dc5cbab0eb1a642eb285efdf28c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097e9355516f402169185d61554767984c8067fec34fd382d88d360420333609(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8657fc4531e6650e6c2a548d70aae133fc08b0f2ce16206034874f1ef130a763(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08eb569a322c29dd4dc93270eb45293e8038eaf69029a2939c9bb46e893cd246(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd2d0ed5616c3ed5e645dda4462c0dfeeeec57f2a147fa63693ba4a5eddd9c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b8c43b494816dbba2714bf739681f76a4eea794342503cf26c3658db792ef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a13a4e1ddd90717cbe0f5dde5926a1ccc347ca1dab2f8f7b2c5a67197b736da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a25a6d0ca786075ceddcc3aac1f5faa12f8b568671f01839abd0b6d53c590cb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorResponseCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a241afae25b0619b663d5867e4244f41c5946b21aa11ce1f4cc055af425bcf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a07922ce65e5d2672cd6c4afe9c73a236b077565fc933d5346f1376dd449b77(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56cb78a20927f655b93f1caa21796468245588f99a8b7c896a7301399e03b409(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3a6a9ed2ba484bc7e5a4f1be128625723ad5a572544700a2bf4b7175f70cc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0d1dfe5d3ab2d0ee3a8f305ee22d1381441c6f59da34147da69ac337be353c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fdebcd13cb8286f7e4f1eb4871d5f4a3b07452b08c6a62f6e1ef9414f4d1c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2033cc939318fe6552d456e9cefe62f12d823a0da4634b621df8957ffdd12476(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRestrictObjectCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31c987be0a0510bc919c9839ee4a282fdf93a2f99e063259962c86686c3cb022(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b13e220fd551379992faceb2592a0834a93bfad92347a9014a2213b74b0328(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a212cdac60571e0f18078b3904683f07a4554b6b59bf862ea1ee51323bf8c47f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__796b0a6ab00f1466a587fc16901ab18b00745bd5a9c0cf3b1725131faffca9f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b528103dd7978d2fd8e40bf472893c5db4dfdf87d3cade0023b68831e7ad33d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f30fe2cc4680d8329f898a2928f22812bdba59bd5a6eac704b8bc8fa09d3a7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11b03aca484ac83f699e2fd91aaddfc84e8c92c39d675cb1b14f673771e2bee(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorReturnCacheStatus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4319a0c0a0126fd2e72b08ad3a2c85db6b69a81090f171ba3a36121daea64ca4(
    *,
    behavior: typing.Optional[builtins.str] = None,
    keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match: typing.Optional[builtins.str] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_regex: typing.Optional[builtins.str] = None,
    target_path: typing.Optional[builtins.str] = None,
    target_path_prepend: typing.Optional[builtins.str] = None,
    target_regex: typing.Optional[builtins.str] = None,
    target_url: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cce27c5e35eb609c08e552444626fdb1f02d74dde08d1262207cc7cff1709c87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__650aa8381cfa594932e5830a8bc6252b981ebb3a45123e08d0bbc94fe1cba666(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28ae47e8385378a5a77db4c57a5e6be7f0c13d6db5d0ea2db9657d882bf82e4b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4ddddf42c9fda2a3fbcb1fd855b0a7d35418b08b6836d140518b454b7e86df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f177ea6108db9f5d319cc33a586d0a3a05d7b40517c9e30c3210ff27ed60967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0fc99ecec72cc8fbf6d01c55ed9e66c0a33beccfba3ceb954a890f75278c5b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af81f8a6c5846bc833dee5c46300a379ba54e8425b2e4164699a7efd09eadefe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de38a8e1459ecb3810c34778d4dbcd4f20df3deb6b23e990bd9549374c440079(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b158ac1fae89f5465e1ecac0aed93a6c85d6366a2c41a26eff9c7408be0cdfd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f49b5dabc0ca84df268a0f3131622f2bc6e9a3afc4285019765f3c5ea0b832(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06748e9e59f0abe2d05b5e8c6f43d8a59739fff8e83504923bfe17b66a496af5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae4b033885a8088fce24ccc543781c113fb1c910422a8d30da68b519bf5a859(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04aac4676eb17960080603fc4a756a4314026f734fdeca89ad779a17093a9a05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebb26abf653fc6247058126abb63c328542cab4174444f49af5b4682fd59ed8a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRewriteUrl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed3f736246259bc87a7b58e41a83640073cdf33f5cfffa11334dadac33613bb(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rum_group_name: typing.Optional[builtins.str] = None,
    rum_sample_rate: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00706074c178ef5a65a58f9f0a64f959580b44e8277bfa7f82f172c4280cd8e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b53c3d347058f8673952fc7b14dca89e487f24015c7baad02f5c7f9f1588c62(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b749bba3f832deedf63b46664191a2e3efddcbaa22f6e48dd136968d9f3e8515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55e5487e4a73e2d61bc3115db192b156a3039050f70591515dc2843eba42abd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0007836f7182ee89ef5549f3adaa169104abe504ecdf9a9e5de6e3f3a805764e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610038a6c95d12a28fe07e1161de4851207e1dae525976c3085a984baeb3c61d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044330b14ac7e24f88558503b46f3e0bb92fd9c18408697b69e3ad4ef506dfcc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorRumCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a3d120ed42060314c67e6394d6d94e19516d0248eff1a356caabf608acda98b(
    *,
    application_action: typing.Optional[builtins.str] = None,
    application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    application_cname_level: typing.Optional[jsii.Number] = None,
    application_cookie: typing.Optional[builtins.str] = None,
    application_query_string: typing.Optional[builtins.str] = None,
    application_regex: typing.Optional[builtins.str] = None,
    application_replace: typing.Optional[builtins.str] = None,
    application_title: typing.Optional[builtins.str] = None,
    customer_action: typing.Optional[builtins.str] = None,
    customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    customer_cname_level: typing.Optional[jsii.Number] = None,
    customer_cookie: typing.Optional[builtins.str] = None,
    customer_query_string: typing.Optional[builtins.str] = None,
    customer_regex: typing.Optional[builtins.str] = None,
    customer_replace: typing.Optional[builtins.str] = None,
    customer_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    users_action: typing.Optional[builtins.str] = None,
    users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    users_cname_level: typing.Optional[jsii.Number] = None,
    users_cookie: typing.Optional[builtins.str] = None,
    users_query_string: typing.Optional[builtins.str] = None,
    users_regex: typing.Optional[builtins.str] = None,
    users_replace: typing.Optional[builtins.str] = None,
    users_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdbaa2c407d0ca34022e26b1a8e9e4e3ab61af08af58c05a86b46fe5d519a591(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56a3fe493e0ab02414f30abb0e14bccd881090d0990c8e3b361955511693f38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__add50aa4ef3b6e91758d5be9c0a56ccca21c3f25f656f93dab36008a90359d1a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5525c9c5586e50bb808cdb2540637bee5cda5b351c33189f0364fac3f79719(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e1d3c83842b48bdafca6fe00491e1ea5178a0f216cf8211707b8573c9a3e25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e93ab9e0e95081a55504d2a2706dd2536c52f8b7fa9b765b2e77836faf214f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cda0478b4812ee649cbf738db3a3e82bb23e1cf379c66cc44d3edda20c2fba7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265b35d54c969f579e3d8bfa5650822488cead190f9159293fab7b1929277091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec85b459b2d76a8518e4287d218a3ec81ebb2811b451d50ab87d2b6e89cd654(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d69fb926a087bc415e182687860ae924abbaf94525f6b681fee2bae74496856(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414d6f59e9b86bfd6748d5da7b9369a1e4cd5e866c2c6765a0f7fba346451936(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b70e340414c96674f41ce7d08749259bab3ae0d34156e1ff02fdcd2f398abe56(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93eb0020207d065889400502857f9723106dacbea60d8de2d814846501871b94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8bcb8789d3a2757a5f653fa0111203bae5c9a18fc4c3f90e6ad738c0cf45edb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0a3a95cbf94cf1c90ab4a991b9a25de7dc967289a877a52c008621a9228a43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c483d27b62ec7a66a75a7ad19227bdad9b6d5d9b2db5cb41b5bddbb098944a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cf2f199a9ffb9a9d3404d28bb78642301e71dfa8b6a839b49ceb0c1e5a689b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2264d24ed40dd4c61b588cd49bc3dfa5b68c51aff994ce26a8ccc64552a88f4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8b3f94899b191e80a87a1b04a2a35bcb1693976a74f5e64d7292cdfed19ba2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fdc703a4d61241175bd74ab05b638871674b592e2e8a331e9c94c39f40774d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3bed1cc29bfb1e9f710746ceab3196606b87f769578579a9383f58ba6ff4302(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08ee93cd5f159c2e76198aaf7b7a22afcbce934995cb2335993383fcffc79f66(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0bda908f5d5ee8bf72fd2b3ff412aef6134862411905236edf48fa32ce815b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f71918535ca289835ab614aeb780fcc371f535fb53abbf77f13dc9f9a253dcfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c23f575c51654b47c5a81ab2e3b06ca366a9df96e7e14502960b30d810b859b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe85ae934eaa7d2c73753eaf856c236faab183ff2eb3172638bb2486582fb53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101aad4b7fa5c179b71f1b19f40bfa5c63d18c151bfd2dfc9de6186a8c329f05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9c267517e899934907d6f447e2d13231d01fae99e9d079a97267952a3c0c8d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123ab4775d169ddf7202f8f1b6f686c25617689b1a565028259d991187ac82e6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSaasDefinitions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81fb618dfa1b0d05449875864e7f23c4840865877bf9e40099bf7032a8ae52bf(
    *,
    allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    connector_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_host_header: typing.Optional[builtins.str] = None,
    origin_type: typing.Optional[builtins.str] = None,
    sf3_c_origin_host: typing.Optional[builtins.str] = None,
    sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bad2882c4b4c8866d97cd7d77fa5751b210920024fd136538384e37da724f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f278b6820e299486ecd208b2224e5d42b9f74b02a63561b94dbd01673c05f914(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__818166031fab97fb183a521fe3817f5943d90ca71dff012b975b4fc9339c1389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b92c9435e544f16cab08bf29d66ad3f7f9ae8f4e5792a15faff9a353199e9617(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888832aca796b1755beff04f281f8dae7bf0cf3ae85137a5376f23f5d7cb2ff2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04c0298d3507c3f6c522167047362a42e2da75267cc2fbc7e0054e728ef95c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710faa1dda10be1fa69128c34bf6a5e768538e7d5bfaa438f3b449db89bf4b5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22549a50b785299255cef9b7d17041e1e1df6d7f491a9d632d097254dc8b76e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d000e46374dff9cdabd89d01ff05e7edf30f66e96cfb8e918682d4eca4591bad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d24070db6ffac29c6aec24557a8fd2a2e634ec7a861d8d1ff4a19ab10ad3e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4912dcb118f00b90c160050ed3d4eace6db4d2179a1b19135479a75802c054d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecb1bacefe6c1133238fa0cf107560bef53d3cafd359d29b3db8f5c8b9914e4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__862f6aad2eae7e1316af1b19e6fd39cc83497cf260116845224993f4e4f6feea(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad3a7222744874edc38ba8ba23700ff19ce800316818698df67af03d3e7f18d(
    *,
    host_header_source: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764a268999708aaf25ae9ff7ec9f93708f3a936e7aae25c123498b537e0ef52a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68122eb95b2da9df237d989c6d54a6413d9909534799dcd487a2bc53ba57c3ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b5eb26b6fa077d47e9bd77b8a02353d7f69dfef8fd8fa6e85dc10f675124339(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c726eb363fbc59beddb5aa7c9c2a54244a70e34c071b8abdd10a8c79f929dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fbb6393e20cbbd8ef47c90c2f8fb74f0ea7d3ec76530870b78d77569fe2d7c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ca38fb8b61c95a7e30d71633853cf8c5e15d0de2d816a8111fc9f224ae6c4d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProviderHostHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6877ac9e5475cd91801914b194c8637c81068f4b99a6521d6d9f0f1c39b4f733(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dfd99d2e4e55820999d8a7081d7fc1782005e27024ea9151d8346778136f7c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57583fcea5edfe0e2a4d9943e9bf272fcdc5046fb98f321bfacea9405943f4c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33da3033e726f36048f90d05fa6a105a6df86c20cf6d1ef1ca5d81c2b7ce92cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e87bf4a472e9c38536af5b815bc3ea0a9300fdf7d77f90e2f779ed29204d11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__173088b160c5f1ba7efd787b007ab1b491a4daa726b50284e9b1641c274a6c1b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSalesForceCommerceCloudProvider],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25bc24bdac2216d772b6d737a12f1d205c71f4b58ed5f33ebb5804bfcc2ba65(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33efe5bda261382eb1ef109c1788f620da0b0da0e7cc0040b3728fc3c6a0db42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e514acfa6e23f6dfb5fa3211a791c0f8cf5352b8cf31ec978c2e720a8204c081(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f5145d8e784def750470d1fcd971fc4b3fdd9e347698be974af4c99b917a5d3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed7c0cd3f70c101db715fd4921870c64b10ee314e0a098cd887aad05925694aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d437968052f28a68afa8810e912cc46c2fd683b4073bc76592aaeac05e5de9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8651834b3af76edc8d630454ae021ee01be99b2c0ee04b193d702bee691aeb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSavePostDcaProcessing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f244ddac9baa8ba09bb578327b816aabefb5fed53363b3eda2c6b849a9637fe(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_method: typing.Optional[builtins.str] = None,
    repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5b54067e540a2a230fe565728e9713e1d20c302c3f0b49f3fa6471ef701667(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b7881cb64d8b28d38b8686923b6e3c82d2588ffcae6e4d3666a735d85b9bb2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb34c6ef2fa3a09b7a484177d34933c8bbe2b03f10488e72125c384d156d7d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2595d4a6274d5a58063d684b1fdd46386c5c81c5363d90efdd827c28aede9757(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a2cef5ca7f3876df6375ea2d8c11a0a83d36817ec439d5a73c875e6bda7a543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__687a7a5bd53d18a690f6f8bdd0e12fb47cde25f7c9a2846f8191b968fe2eecdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605977f8129b504dc7581b543a8d3282927ca3ca4ca05ee64b5358ea6b680b0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb408e9a26a3a0bc03d5995b7b33190d88144d55557ff366ceaf80cbf4ea551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a234275982dd8f2d92e2a95dcb0af0f55f8d5183c1d9635c2fcc18c9b0877c1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScheduleInvalidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6152456172e09d56740970d6d7e238a212ed1fb3d03bf03f4674fd181cbb054a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serviceworker: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timestamp: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a98a3b40deef558b4a89c6ac8e5b2d80bb7c6cee95158a4c3d056e8c713696(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721d29410fa2b2f90ae5f27a689339d6abaf3c173cdf5f8853de6dc41bde63c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11238717b91c07e1531a27f7e4440c12892ab5af0cd6b11ebbac56023172bfd3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12379e1ffc0230acc8b737913601a6a13aff1d0ef18ac556928f80a83905dcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fb1dd6d496ddd1e09499fcaeee4b8eb32435bf0c0777bd4c11fbcc238216910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a764ec5ffca0e7eff0f419dc0ea8782032c5c3d8c744dc08ef4033704a901258(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219d00c762bc3db5fa0816683bbb61a5a5ec631ca2806a9ea1ce50fc73db9895(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55158c16754c9429d6c30d4b9568b8a6e255906eb896a7bc0dc60c487b725654(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorScriptManagement],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143da588b565e1c646f55ba3860562510af4becdf8c870303a8bc9e68f013403(
    *,
    acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    field_carry_over: typing.Optional[builtins.str] = None,
    header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_encryption_title: typing.Optional[builtins.str] = None,
    revoked_list_id: typing.Optional[jsii.Number] = None,
    salt: typing.Optional[builtins.str] = None,
    session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authentication_title: typing.Optional[builtins.str] = None,
    token_auth_hls_title: typing.Optional[builtins.str] = None,
    token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    token_revocation_title: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a40d8c1175d5cb4459df221345b8a34a5aaa9b73f795e8230c6845a3ce0658b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__114b3f4442f3d091b51d2821634d6570c6901d6b4a0e7f0539f86fc93ecb0889(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a86752cc75ee93a89d90661fb6a6ab88c5c58c9098ccc1d117e0fb6404f3d3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbc79fb5c365525883909c500dc4e15156c4fcf7a5d8919d8a7010a6aa1073c0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10cdbc433176a559edc75656e355260bcb632ef45ca1a13ff2d64db149373b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbec7471660af05820e9e52a2e348d534f82024d34c84f0e0a28bedbccde86a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889de4de1f77e4759e93628c07175b87e7cee9d3a3c633aa1fcec77e474faf64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111897d4a7c97e679861445d7bdb1032b707a9f193d2c671ba689a2c56da598d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c828b65c3c4deea84174c9e9ff9a4c71dad90ec7137e069d2c3741aabd336b77(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__956656e6ea2cd3b6d8fb71f542388e379e9ffab3e93d4c9bc6cd86968a5eff5a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__735dd46ea01ac8f6ed9801991ab23085dea541c03fa44855babc1599ce0a0eae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34cde6d2f10101d0835f2136ffd4089acb96a345af7e4946c46ca0adb59f232a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ac4b4a856bf77c7f0b0a8f74d1aa2cc3ebe6a333521521e8f0ad78cc3b9c75(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7668ad2384c5cf2a65216d14e9077b96e8f63dee480c7fcd7d73d8c651ac2193(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a61cd9d8a6b72561bf632fd0ad085a706222dd9eb4308ba6ba15dc80ab2ad3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70109b1ddc50f126b65a217fed248dc6246de6217f53ddabda0544b1b580e10e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8daa3ee36169993ced924787860e9e4641e69c8d985d4e375d65a3bcdb4303(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e336d636fde8111e65211b88866c9e849f050d4934d6e2387ce6e3049a3b58cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965294fbeab8c399427dce7b9d33e49e1fd7100c68d995fc969dfbe3a23423fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1507c5f46f7eb2a40deb0236cbe1bd6c4d6d7c80668064cf5e30a5e97766b0da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1386cb71fc7fbf1825a253472d24189cf3b5853a3fe63edb6198af28d81fc67(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74dc61c892ca1d2252cc66ac5eda4aa516039301f844319972e2276d65ebd8d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f72c28c6f39dbd94ae90eae30b65b1895555acc0e3333910d8587eb934d8e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1c22953937a2dabce4efdb52ea736b55f7100e21a0e3d4266df04dba9ca9cc7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e636ab1b8fec1190bb88e34813973e728bd7d1065df9017bf11a0a9e116fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b1dc221260ed0f49f67a28bfe4a65ac3fd8d09090a37fea68052ee2c27559a7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedContentProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8723991e2f0cf1a5101849707bf5783887b0f1b1fbd40370fb853fad419fae22(
    *,
    behavior: typing.Optional[builtins.str] = None,
    dvr_type: typing.Optional[builtins.str] = None,
    dvr_window: typing.Optional[builtins.str] = None,
    enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    end_time: typing.Optional[builtins.str] = None,
    live_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    start_time: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c83778a2ef8f66c6ac5733e72be3a4d14ea0139681a71db456dcdc02d77909(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ae48599df9dc3b71f48fb83e4205334bd85f50b90b368398a72c8b1d66e71b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f5f56e6c1acb6feab52e4c5a4126a88572721b61cb5dc4700bbbf3b3690fbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f3b0e78cad6465815df37bca7ad14b23eaf93c8dbd98b30e5437375330e669(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ace856b4d84a5bb793e379a15684a9acceae0bb37acdfa345fc7b40513fb9d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fe1cb92dc35e929a015c890e06a28971d69ef636d21c76cb39c274504641063(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f745ea79f762e797b0b20e949581270a0ba7f9aa2771848a27f3348d881a855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1321c7ebaae61e1365af466619e67f57163ca5a1575703e7740443c501bfa80a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21f3be192a0d2cd935a2543417c49aa8e0fcb2d3597fbdeb2e5c03ca0c5e1de(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894019181fe2e546704c16ae72644d32f722c76a64a100fb884bddef2f59ffd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9afe54defa483f5e00cffb973ee780a91c80c6e8ce8c912fd201cf1abcab8b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024db49e2d20cf72fde6a7391889b044723775a39adc6f6fa5fd6f3a9b515878(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5cce1581228782a970c28762e9334ead4fe66fe7aca15c2b1af3396de467d4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6257bc32400c291eeca76de32a124b2a0bb572397aad53bd3608e4796f183ff9(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f97a8f75f620d868babf173747afc5c710b70d3408d028366b0999efb72f3c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__522288e0abf101b49afb757257d0b0a0dd04134d790f2f95acbdeee0fc7d04cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30f5bd857ad65590f71dbcc2f13fd298465b14669a31c73ebc73c5d835600f18(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3107d7fe625fd40e7e53468ae1956243bf57ce21966e245b80cd46706e80d2db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc795495a39a2996a90d382a9dd77862500c6ad9631a0b998d45f8c6cec40736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a35e83d4dd29efbde3f522e34711c91f181abff375d346ea0038c661da2b8dc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSegmentedMediaStreamingPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3967cbe16238dfb55c32b445dd71adb561b577ece15c9065153f989c9fba2ce(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    certificate_field_name: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    device_profile: typing.Optional[builtins.str] = None,
    encryption_key: typing.Optional[builtins.str] = None,
    encryption_mode: typing.Optional[builtins.str] = None,
    end_index: typing.Optional[builtins.str] = None,
    except_chars: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    force_chars: typing.Optional[builtins.str] = None,
    format_string: typing.Optional[builtins.str] = None,
    generator: typing.Optional[builtins.str] = None,
    global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    hmac_algorithm: typing.Optional[builtins.str] = None,
    hmac_key: typing.Optional[builtins.str] = None,
    initialization_vector: typing.Optional[builtins.str] = None,
    ipv4_prefix: typing.Optional[jsii.Number] = None,
    ipv6_prefix: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max: typing.Optional[jsii.Number] = None,
    max_random_number: typing.Optional[builtins.str] = None,
    min: typing.Optional[jsii.Number] = None,
    min_random_number: typing.Optional[builtins.str] = None,
    nonce: typing.Optional[builtins.str] = None,
    number_of_bytes: typing.Optional[jsii.Number] = None,
    operand_one: typing.Optional[builtins.str] = None,
    param_name: typing.Optional[builtins.str] = None,
    path_component_offset: typing.Optional[builtins.str] = None,
    prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    replacement: typing.Optional[builtins.str] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    separator: typing.Optional[builtins.str] = None,
    set_cookie_name: typing.Optional[builtins.str] = None,
    start_index: typing.Optional[builtins.str] = None,
    sub_string: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transform: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value_source: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55c45cd3e7fc990bfb6bf59fd724ff9f8a758108245d6f9f886a608d135e21fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99ab346f07f9a2815fc91ec4a6ba80fd13ac03eadfc7952369efa2482967a4b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__131fb6947ebba90daf6115279a307de9ca225e151e3629aa8e449f7703cab040(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c16be9fd3daec187ba82d19e2b9bcb30697fa7d29029c31877d850165903250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__081f950d87afaa205ca8b40474ec2b1cd65ae785f80ad4013ee9518d174fa71d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2516f779c6255f8b545a1d6217c380eae31a8f5cbe8eff63926a5bc1cb3401bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f805da7e324605396522793d89520b8fd1b7990223c7c70c9ee70105ca7fd901(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8084795bc2e9f912e8786b51fa0a0bce73facca68e7f0e0f672531d45f559faa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98c102a33738982295805ab99cf0f69ea728368c2f7a384d92e1640e9d5002c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c2e4bac1777f6b068ecaed72830962e892a882b8652bdd46ee8c4cb39649e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5172a9f321b60157c07fe6630c82aff6a7c7d87557617651c0325680b16462(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30e53ef099c3bc297ad08adb7c3b6a4a7474b853aae9c80f15379d086438f6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95333a9e7647bdbd665f087186947ae9964dbf55a81cf9236f92210da7891431(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e8b0b17b1f776e03c663aec4cc2dd9254d5af2fe185adf9a1c3fa86310e65b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea13ff7b78befb37e70c546e9d67d8c31da77a95f369e919ee442f6822e6e9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e6b19da70b45b3a92dbed9d94803d6fe12a8e26df93069890ff93faa9de717c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eb785ed333428310c80ecdc2d67eac0ae09a44d0a6505c74eae55fa24b1031c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666e041211f4d8c3249d1a7c17d3cf19bfee4faed056174f2b2cde049e45a78a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a5c48242e771d512ea0243e182ea3e58d733109fdcc5a36ea9c3529fc2b3c82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a511fa0e2da237b33fd802d3e65a4f62f035acf49fb2b888d7cef6cbf2e501c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faff0d8ed2499abf5ebfdc45f98c62bc1f4679ca91761929a1ad4a0683ba17b8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36a410774ac3bb35bb42fb4eecd092ea737177a3862f05b026018d9cae392ced(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30451418b180c771146f0970b67f3eaff20e20b7aed530553ad2695fea66d000(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37c604cc78637dc61f12b209c83e2b461d643df570472f67ac584685e6817e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86e55e522d89809197af042f2818fd7f02c7296533ed55d291182f71a85a5ed(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338e584c4a2f4776546aefd02e0306ad2009d5440e28d7e0dcc05357bc73651a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85d0930e8ca30aaedd717dc2e11f9f22ddc01367d4b1c993a30ab3a7b60da6d1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae9fcc7fb726e1c3b54d4888eb46663f0aaf2c2359cbcce02408d0b055399f5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345434d4da05b1b51fd4d1998bf3dff099d142820f380f7700ce0809ee8e0d51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67d04ae7fdff5361c6f5f9f66e182a2ee8b8cd7277444819ec9aa2becff1e168(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f8ca9f133a12503ee253d6d238e1bb26b79abe290bcd39b6fecdbae2635f30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7694e7e1bec3713cc3f0bf4f9b3d581fa30350a7906e886d4b030d0620ee55f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dfb8ab7cbc5032ccb78bc7aa5efc82ad64ecd38553a0e0769304764b0e87b25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abe586481b6fae357e45f464a04bab2081f01fdac7d7a515163bcda5914ae63(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566593102ca1f61158429cb841ec121c9a2d84f1855bd0642228c5bf1693a2e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d5e2112fcb1fc2d27bd660a78e3933e05ee33c488c6cdd0afbb8d1525413ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bdd1f8638ccbd0e77839c9852f1d598f27f4ab607587b62f2e6b21589f42e40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493f2a0349428a43115888acde3ebae1ad8a8c8b3738873cdaebcf60017fc5e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e56c8c495953c9ba99e8b5a0f3433fb748f45e86ab280fde6122bd2a0e16cc59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902ccd5ab983714ff102fe37a28d48edd9057fc3e46d80b466addfda50d2ae23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01046b0cefca632e091711361f7e76d5c9fc849a0c5062f56afb07fc575bd73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c843d41cda011b2c429f599d75788b1b02b76c462cfdf75dde0f040873ff3c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a1b132f9626ce24245d56183c0746a302c555e24ea1279ef4de8a163e17907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556919bee518fb261dee20f1ba4d01800203f1916773f6339d1fef9dc82ac544(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347610296ca4a88f9ef5ada74b36f9742b752d98e81565a59c1d40f0b3416292(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b2d526cdd207235521ac7a3cc4aca1a7119b39bec1f8201e47e197cbfd4052(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d41cb0d4a144e4ae017a5a952a6d554a048bbce529fdb0770e20b9b6d1b689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf55aa593e9d8fe804d8bf1be7fc0337343a0954cf60a9131a453efb59b618f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3a75d3810a8e19534af9c7ead9d5ec0eb532128c1d41d53333c607b7284f28(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSetVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f05ff632bd0f2a5b3d17bac60a17b1803b037e62008cd2f32aeb105f356d865c(
    *,
    error_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b8d70db1f800fab4b2d05c2dd1c6931f42599c188556a8cf13ec3fe11f34a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78199f3c18a1764cf076bd7bacb23a39744d36655413e3891e1c120ec7f2da14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef7e7f62a088948922db87e6ab4f6b3e4019fcd23db10acfbe00e09663f3905(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e19c517264454ca74850defef10a7a61bcf1cd3b1a20e800fc36c383496f216(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6980e67e8d10a45f0f99be6b3baa36ebaabfdaf5fb35fc52eccd5288996962b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4185d5a0bca5d94c7ed36ec4bcc5e4bf6579d50c0526ad9e2d0af5b33f7ef215(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692a850a215800e2e41ed5950f1b8cc68e75429cc25932a871e44fe5e3e7821c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSimulateErrorCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ace11d3d4a7e0e3ec2111eaa44e01a039deb42923d551453389bfd9d283b2e5(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nossmap: typing.Optional[builtins.str] = None,
    ssmap: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760d90693b4323b6d84ff262be77cbfa1ff17903edfbea8f5f4ae176082ecc4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91cc3559bd673328f1c00cae3598387ba0360210f7374abc1447383d910597b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a362ce6c2e64947ea5a6716b8936ba5fe42ec71bc02f1bfd85c1e0343655432(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a94b1869978997f3d875c868e4ca920797a2fde2885fcce733e7139777962804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4905e9a81148b7b3d771b9f90dbe7ad0b91e75f9c685c67649223817c659d560(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f24ce7bb2ff225c1a16e6a73bedf5eb6ccd71c064e5f39629756b9dfdcf8983(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShield],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8febd03a3c8a49bf3e2fb6ef2088b03475cadaa14f10993c5939015519bb92(
    *,
    china_cdn_map: typing.Optional[builtins.str] = None,
    has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    name: typing.Optional[builtins.str] = None,
    src: typing.Optional[builtins.str] = None,
    srmap: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75666701f6811177fd8ba1174bd66973295ee4587f6a5a8ee69929341f7d3f94(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7119ce53808561cce0a79a5854c90afcd137b4a1c69e03c4ebc2327a1d82abc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e87a6adbdd27a290b454627c5204324fa26076c5c0ad2fe68655c12841925c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1ded1700023b612ed44ad54b6302cbfbf9f14f982db86311e7f6a6f553fef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c18abe8a8b4f0f19afda4bebe6f6c99017dfb02b8fb6a74df042b7f7a2abab0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc6adacec50b994aad08cc9bb169a41d5b8445f89bba31844bc29d5369f1276e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f140d799b8fb44e3646f3df76b32bcae26e2637941dde5217241d20f8d64ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2ec682da1210cbab9368d3af45e331ba54f78db2cd5881a46247a57d8f9bf5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSiteShieldSsmap],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f1dcc9a7865a0657747c8e56fdcaa5e1675ff90e3c6bfcb7f466f9d316bd69(
    *,
    allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_sharing_duration: typing.Optional[jsii.Number] = None,
    cache_sharing_start_time: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_duration: typing.Optional[jsii.Number] = None,
    migration_from: typing.Optional[builtins.str] = None,
    migration_start_time: typing.Optional[builtins.str] = None,
    td_location: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5f91cbb6c405c604be9b0bb494a909bfa517f998e9863d7b08add5d451e847(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be68bdf5b57b1018c659018b9ee179a7f89323346ec1bf7e2f3b1c72871c35c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e12b5fdbdb591e70175af16b9fd20463949071493103a8392bd43a3c4e60d4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6655d0312af8a040966622e2a59e32dd7e4501b1f66d04e70961fddce644af06(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3f90f576fd98a51b3e80de90960518fe7721972a506e048f61f3bcdc95a613(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb39cf1aa7d5bd41a328e447ec3863decd9fe568ba7068bb00833e936f121afc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab05152a33234ed8fee55b2e74a1de98b5da710a117a156b2b86153d29d4b6da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98bc59b5a8ee09d94ba5fee29ff4d70a9411a23684ede67437c78b0e80328a96(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d44c53214f8b9b61a552bbc62e1fb385f23bc922568a79bf91aee0f921dc0cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a76c1696d9633f6c273d0e961871e69592913a75f1e0fb2e6049eba086f6b1b3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1bb77d10aa4cb47f1283525df998d54a1812ba5d6e922ce088189598b90864e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffec8ec38d73d6739e8607a3a2f8957bf08e80420ecd44aa2b09ce23f153cade(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50c83db8b31e1d58c642188ee0fd694294cd26eeb0049a7f5f04256e492c16c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196d1d9a93493676093b2deba3d3e26a63d537ac8e705c7b4afb36ee4c33b89e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f82e82a5764a68803d0e2a15bd730c5337d50ea2d9904d78768752cc7729af9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e34d8888a2ec8023b573e9c50468132eab8b33822868c3d31b0515b39f62159(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e28b3fbe0016beea34f4db971a2305095ba10e677dcaf1a36ac5355538c9a524(
    *,
    info: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666d145bc6630f4ceefe1f97896d3c087eaf3fca88cf7840b478e22a63495f7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcea75d2c040a080e239673d5b710b462dd0ecf024a89678ec6b5f72e1f61367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba22ad781912deafb2f1f90e6b523e0084bc7f37d87d776d031f07f68e838bd1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1fc62349531b49faf370eb57e04005e396c03e0d0517b3c9c92651c0ea7f3a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17dbe55f8f7bae6e3a383ad372bcb3c0c4a02b265bc9a76b82d68edd1d99aff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0413f424eff518d368b7420a5d83f1c2419743346f90d6497e4f39ffbd2c0aca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStandardTlsMigrationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5b1a768a5b0c76379c5c108ab117e72ac1895d9284e0e54ed9100d16b8d817(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a72be06bc391268ced5cb4a782c83436ebb32bdb4895c5a3a254b081a52a8f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60062839741101a4db7c785dca4e2f84e4eec097d97ba11dd5e2efd61d934e66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d8180c9fefb4aac5155ccbc3665804279d19d0f1cb511067c5329cb966e168(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0795467bb4ee01b29402ecdef7e37d34d43cbc647deabf08e6a32a7085f07942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b74041987d5cc30a795e0d59a9bc26c6ffc320d20e2ab01fc048c5023a429b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b0709149f3a3bb9ca0cc3234310a650e65fff283340736c13c16ecaea0e24f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e60ec3b821b7f6e17cb185cb94404b54b63e75041e04ff14d9f9bae2d48fbb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorStrictHeaderParsing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57c0a8cdeb43e2f464daea4f3ad5846b3e81d110fba0882afd0efaa9fe5a507(
    *,
    access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner_domain_suffix: typing.Optional[builtins.str] = None,
    referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f33bfcccb52833c33395b1ea89d92b08d070fc9b234aa71d38b386467f1dc316(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8934e22f9095a557bba9ab185f0671befc64af3c613ce10c4ff7dd2bc7dc5eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1feba5b2971afcd4c12b89f52539c2e924f23edac3fa5ae9620302aa59023daf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__473a8c3213219531ffb88a62e7cab633800989110b55ee03aefddc267b57c1b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd1f21b49fefb986caa035c713bc773c41a03259b00671a038d74b59c6996adf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11fbcf3114d8c804a74aab7b2a8dafeee7a5f8f8444f2048c4506d1240ed5192(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da4e907b9c662716d72489623bb65ed18c6aec53e19e39a5cd29a797718f363(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53137bee079338fca7684b4665bc2456442bd45389c290e1e6dd5c4b623df710(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a372e47e82b886fe142a32c127167473cf81bd310f4c8e8f642b8a1bc3b99a9b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57bf7ec7f0857aea62c8a760a23c5e695f9fcbead21c3752e1d11be8a7434d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f3441ea9200b0b998fe0b1aa6c795be588ce3bcd6f4d096aa310de2f4699fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b943633f1fb3cceff3c953220d71bc154c09228646f3d4300a3d4133a63d38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ea98bb2a021dd06b7bffe2cba7aa16ea7ceea45760832e9fd8d60eb16dc3d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d3508e5ce11eb843ad16707ffda339af7319fb438c1169beb3c46f422f03bf2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bfa2ade9e46ed89aabf88e81c80ec84f8cc1196fce04031ab6d50f90b82c319(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b601c6a026384e5f09b1f1118428ca70c0137d6927bbab8c6c500f6345b82c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86ebbf8bee720f2a5988215ef4c1f18bf7b1b2f96e41abd194531d20f062073(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba2b3903e09e43a7ce71111362920b82a3baad1cd315a51a63638728ac69f8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca1724b04c0311c1cb73e149c595060ba82e45d5b8d7cd3464db05a831c7c40b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9fbdac6836bed5e857676eccef001b88170f9f95235d2c9984d11c764f0ba8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8103416c8343d2f25b2408014dceaf60da055386333237c0d695b305f4a6c00c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1dbc4b2d172b2f00b8bacc60d0dd091d18b675c66ffd4b6b949536704907c1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0982d9b5b9c0239c89fbcf9da52d06f97241d82ebb73819ac6be85bc9302899e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51e4588d0c33b37ad732dfa10ff30e396ddf258c266d9c5d3fc7a9c23eb45b21(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSubCustomer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbe0b529ed6ae243c06906d21363959872b628e7074cb9c5a876c596c2038be4(
    *,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map: typing.Optional[builtins.str] = None,
    custom_stat_key: typing.Optional[builtins.str] = None,
    enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    race_stat_ttl: typing.Optional[builtins.str] = None,
    sr_download_link_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    test_object_url: typing.Optional[builtins.str] = None,
    to_host: typing.Optional[builtins.str] = None,
    to_host_status: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b50709d47a612f744ba222c998b8f3da7b712e19f831cde373358f2aa30fa1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff1babf48bbd1849a8a182cc128e8a3eaa18037a17856255dfd3760bca8f81b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327208dd6a2b054046109ede05f700b4ba3d341ef9a17b7bb2d4f7a336f5b274(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4dfd3387681ba1870015d4a2d9abcc7a74423ce1c84e126b12ad1ae5c4e3455(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af081cc55ef87d72984190f40d9a853f8e40f5a1c2a0383bc8fa378d4944631d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97b09de0497c902198601f2e66e29cd037886ac22cf80f4d0b85ab16d3cf62c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b17474f84aab0fc6a02a3cf846cbbcdf3d083721aae8e3285aa5001e0a1f22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51dd1c384e365659e8613d6944ac8a9b816d1c264c6c8ba4a8f80273150f8fed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a5532c003ee85acd545f4006019bc131015194d3fb865b8a60c709091e5583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0471327d303d24869d44f653650444af03ac548276fea211ba84cf52518c2fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d346070656ea7e83fd3fa3c12d189c5342cd2df1653d700bffba7b804c8c43cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__386ac223abf268f2b64aa9fe38a7706ee5df3767db1dd75bdb8633569682a7d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27c54efbd83b8c3e13915cf0ac23fc16a4b0ed91855d1eefe97c1e3328f0c273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3dda6ea1e1755ce6e868521c39ff2f4abf366a038d44747792a47ae2b586a5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94ca27a0f1726fe232f5e4feb28de868f22183458abfc1184590321bf670a12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfc8621eb04781d5d27eaae8d6c2e8d4cfe534b1f829dadc14eedf00b36726a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d305dbc23980ca8281419c47a73cd0069fc952c46c778410a73b1c910759ab9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorSureRoute],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77d47859c7ea72d41060f230a185175944d95ad38c059e94b15d92452a9fabd(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__089674c4fa7503c8768f4ed96883024ad3ffab0925addbd040a0b97f9f63ce18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77643a4fde538cb8c6f34dd6a89b551ef5c0cc1d3c1489564208364f302b0793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039c99846340081b24d6965143f3a7d6e0ff8bd5419eddd54e6ad006f24fd781(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed2c3e58efa5964604cb46766ef39a7fc066f730478a85d8a8d965261e6369b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1865eefefc787e09639d73eb37713b34723d781afab229ea3eb1c7e4cf9ab0f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545cf8c86a7a8a96e1ed14b505acad2e5df883dee501d06f13cf98d2cb56fdcb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTcpOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cdd59b98ac591a2b62328aaaceb756c77a68f2096b44ccfddb3d92b607fdb95(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ibm_customer_id: typing.Optional[jsii.Number] = None,
    limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef304883820ea59fab0b14ebf90129e98ff62456838e27d8820c9563a2e0f5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b257a02ec5ee3ed0a9c9cd109192df5365fafe3ed7261096c885203fc722d9c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a83a9e82af02a556b16da387f0e57575c9361a37e5cd651ba004cad2e2d6aec3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46a5a8f779be3abf83c5fd56a9fdbab09968b8d98c8d59c76c74fd8a549e3a58(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d9e09f91764a8f43dac5d74450ecbd743b78a76ed39040cf67de2ce5a39455(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc403a63248d69b4fb6331150598ceeffa87749389752e93aea99008a88b9d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e24bbd5fe08bad1b62557ad9b08c208ee3ca4bc1eb38abbc270d2dda264a301f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64f22b65c1db2257d63761ab98834b45827a250e8917ef32c3175414667bbbb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTeaLeaf],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eedb209d143806193c2935e1ca3f282b285afb1ca00345cd94f0c1f2b24d630(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b603c51b501089a7543f030f18b298d4c3990eb9cada5e3706555e2010f29b8c(
    *,
    allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    method: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c230199c742293a1891722c9abd63f9c7954e880432d377d603e2bc3bb0c7623(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf73e6bb97b0182d713562880d1a9db84e3a9ec9665d9669e8210fcd3fad477f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ca82ce5b89f3276b42f3f331d19147694db9aa75880fe7d59277f31466ad79(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52dfc84ef68f0ce3ece4befc543b2ad9d8d33bfee13f9e16c29247b8db28a743(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b39ce05b7f84860d1770f60d88e4348db73a6a4c84f7ef6fa5acf896478e4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1448b39bd7671c43c0e0919ebf9b5b372c5aa844cf2540e802035dacbc74d36f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f99aa5c656e8dcaa029c7cb53c5e36ba099471338f4b2c1408e7c2279e7c80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d49f7aeac023888ed90aa68a89507a3c8a1ba24ba7ee8f2ca1c95145758bc61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__699dba8619d226f70a0d0f7a9e08bb6a8e4a292b77b1a5a5296ce4a576597f78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1fbb563e3f2e85d71c92e70a50150cc1498ba90e504e0296132ab5dd7be4115(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a292b58f13498abd92c9a71baf5c179c9d942f55202a96f4433eca081888517(
    *,
    cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
    custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map_name: typing.Optional[builtins.str] = None,
    hash_algorithm: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_end_date: typing.Optional[builtins.str] = None,
    migration_start_date: typing.Optional[builtins.str] = None,
    migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_end: typing.Optional[builtins.str] = None,
    serial_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__956b7ab28c9bcd8a4aa237a2633d1e9db99b482afb609e4b160da2e1f07432cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd627ca17a073b0c28511cd7288b07adc3fd2e98d8a1e281c28c10b3edb11cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c3b072febf0ea296211028e67f12d31fbbcb5f6ec49e241121d53bd33e3b81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4349797644f91dab145d57bbce392c85ed98273937e8b7721669cfedb1b61985(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57e59bd352b0f1763ce93d16d0d108b676594c2e6a00313c320f85639d70dbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75fba2f77c73f7face12ee4e051e045908c582284fbb751c3e816cd72154cbe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43c0dd0db0cb1f2f66057eab126cf2880e9cdbdc325aeed0b9e7bd26d5cad4b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2d705f2bdbdabafda98f00f9f13bd0388a9d748dfeacbecdd35249bbd6d261(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de183d443ced01ad3b991915238d0e251396f502524778334732937d08caca51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13bca63669d50437e392e3464f43db83add4a5659dbfae997e17f792f5f66202(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583bb6bbadb3aab1a8c0c3629322d70a4fb5696eba9d9c832aab8a164baa89b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82dc9c25a6cfd44ad8b70d9f7e2436e77f4cea9b14145f8ea1232c4973e1e72b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f58cf172023a360f93df51e2f10afb546f0691b51b741dc157df3725d13b2e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913e82dce24ee5a12b6b6d150b9a2b0d5d31c31eeaf052c481b51dd1600ccf4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0117c70148ff1883d3499374e5512467b17adf093bca9189802779d7ad78e5f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dffe9a94e43291bfe1ce1537b8c7dd1c5f1eb3f8d69cfec008d8d222c97ef1d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13767dc0b4263066d5de37660d0d60ca40375ff6ee5d3bdbb5212d2718121ad4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistributionCustomization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192d3c8d7c381c7ae84bee3e03483e54c41761fa923c3a0a2f0de636218e4d56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2bdef48985ffdfc564f072fd71ead95b703f1b1d38a25d759df01560097bdd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a0b494521181754e916342309b42b70714e24f195ca414b20beec0a04639de4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f8174386799daffbc4832271546b798040c0b85b8560f299020af95da63d09e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53451abbf161ee9177c555ad756c9cecdcf7b5b741614ae3543f459a85643264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3ad6aa40b008a7890c85d8f51af87c434ee42f78a832384c664c06dc8820de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__941f0ad94b514ead3c812d98ffb50d3aba7aa09626312205197385d8f9c99c01(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTieredDistribution],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cda8cafd59f5e1bd07869a4389d521c901e0a070c7cf160de9e656945fd4ec9(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9feefec19ff43be369dc44982ca4012ec859845108d611d1bae66865d10c7fba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5374912d8399dc9da6f5e78c20693130116f52c3ca2e9483e789577b95acd258(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e026ceef5ad1dc4ca4cdb8aa97d704dee621c4ca85c6d1e8b9aab6dda758fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4662f9b75b4a9ef4d848aa2bb74cc25a51d7cb35b98c1b734a92bf94e3822887(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b6503f862bcf9dbb1d14d1a9bacb32e2ea7b6c51767338bf2712fcd000041ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560ccdb052b7362166b28faceff348f45bf871f328eabdc5deba69d796dc76c2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871b9ab481e2c99370a6b477074ec5efbc6922307b979b3f38e76e2d087408e1(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    legal_text: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aebfbca50532e79bad917577647d5338fee213e2af80738ba2f3a0c45723f679(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d04c655c9fdb1776656df29790eb08880d3c6eaf9a7695d97448d6689fb73388(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0369f6e2fceabbab7d58ce4b3959618eefa9b1a67f14daee5dbcd343df1d6c4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bd643116852805d946d08c65b39a7720dfc100a29d7eb69edab23809190d4ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24c98c81e9faa7dfac0872b83cbe4e5f0c1c069744d2e34666a78e657ab6174(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e5acdff8d46bcdc957b4c8ca0890341f0957ed345c4f7a2df9cdfe658baeae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c6b0cd306a15c014f752a30a3c7c8933457dd3b2e36bd84520b00e7b67d58a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036b95055e6d21a6322a137eabd7187a847cef5463045ca79af2ded92859034d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae41c7966f5cbe45144eb3871b1c242cd5b4c8d2973285d88fa526eb4675020(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00c4b3c1f16d3a7a5be9d2f1effe92caa4e72c407674a3c1828b7ed0f0cf7e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7731d70f9664ef5c2525b46d1f32179000d7c7d30ad58f7f7a44ef9454d7fc39(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorUidConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc94f9c58fffbe3c43495cfe0217882b4344eadf7b396783b45cc531a1178cc(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4862462fd07d6dc1adbe9b080116dfb52063e1bcdc6d0cde8854873f9439cd76(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2db278713d33def44d2c1cb721b3e9d5430057a1c0837827a3758d73c6696ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1062924bd752e58f6647dc426327b078ea77bf948ef7e018b147d21c8204a83(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70348f7021bca03f823796c68cd8e29387501f43b9fe98d56a4a239b63c4a196(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cd99dc4feb39dcc3174dbf8608b507e2ebbe39990840d7ddb19b1d6f76b8f92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e5b6681bf7e2091a9fa9e867dd6805e466721c08f0b870bd54637c6a839783(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorValidateEntityTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49ffaeae86e5198dd86ee234a686429f76d0e4e3a0ffac5948173dd7eb5e4d66(
    *,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8047c7f19b2cb0707494c360f30a0e5675daaa716233e20ef3fad48ae72ffe81(
    *,
    authorizations: typing.Optional[builtins.str] = None,
    client_id: typing.Optional[builtins.str] = None,
    custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    primary_location: typing.Optional[builtins.str] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_name: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9900a3c66a27d0a8e03ee3e2c99dc614a4e5d10c433c9c9f50596e351f6ca2a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf262bc785051521ee0a89547c0ceb7f2989bd418435023dc3c4b451e55704c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56084858abe7c99eff7e42009997bf25440efb69ffc0f401ef169dbb43180b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74f60b65c696a14a84136a9639b7fc8dafe6c17b86bbc08088c5b4da08c2ace4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__994f4661e4f73fec26324b1f471860a7048de0d3ffb76a2496353d9a7118bc44(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__568ad13b1034ae65cbb0a787bf0adbc8917ceb3a904f77eddb01a327dfac8c62(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__104487df7c239254d073b06b38d22a12c383eb4e0d3f4b823821874b00ba0fd9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30af568b605aa2aafaff0861aeab94fee34b3f0d7f3f60dc9791fd4671173ce5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162efc76e29eda3f90070730a2e5f4c9f1b67333915380569ab1af66febff74f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02f089951585deb31c9f302046b74cd582e27aba9a57c039ef16ea69ce0fade(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c65ae3b0bc7b9afe2721b4aeee04c9292345666fa913b8e5e17c2c6be77cee74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__682fada8769941f7564b42a20def2fe5818a41ba729025d00eb9bdcaf5342480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e1f0303a5e6747160510351290b2b6b42ecb250f1c443f28fc46120da73fc6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45e5111c40e7d0445df1db4f59e391fbc3e4b04bed9288223527851bc95282a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54e2107ef1565b9c3b64ff842b46e050aa7df7ebbd1cd3ed8838b2d28c652e75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4ed0fda626668940a9bf8febff4e5e99370102959976d21089dbfe5742c4c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b928041ac4a7ce29f4d9457eca7ff60f8a981b83d6137063a10489f3de75faa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f40c8f6ba4f12717f82d2f74b22731d4af2e5895228f21c2473f88a6b321fe5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55b3a32e5c5bd953750a938bd1b65f8e068e07166d1ba7be0e6089555a943157(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebTokenForDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3d0f315d84950e29b3999ef0e4763874720e233425ef67bf0905b4d449b5fb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaea8249fee50c4235dfac504b20dc660994023dc56670d7e27682a295c32fce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6c3b188c184b5696bc1e99e5015ea6e41f459bcf24298bccd3e79d38fe2049e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0ee2e0611fe62760b5b54d2e43c0ed0604a4ecac4c0e7fe0c27f9b983e947e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587573844079a336ee07157aeb2484489976cf7be83a026a1096db5e2bdf64d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5b021d3c2299cd0348fa620c0260b472909ebec1957d431286bc534f826e67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a26cade7543a4e6fd79ae7585899ceedf3a7f7460a373889978e5a7c2400cce2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1a4a16377c3c3a59edcbff1559953908733b85fb1c7b5bd67562b1e3d049f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8700e9cecde2f669eb93be546da37a44700c16f45b12c395508bfa96762e037(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d6dabbf922d7758a7db83ce479a92a9cdf5cfbc50cc96299caf34c1a01c167(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275548be52c48a2d01e92546a38989adf312652549ed32a02598d5df3a6fe51a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyJsonWebToken],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0821eb4774b72f589b8d6f047df966b5e04cd7ba00765b50d0e75f4acebaff7(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    salt: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aba975b295b76c339c47e8f74c382b9793a2693611502b8d87edaefeb6b138e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__370200873006f571666b4f57a6bb07d2fa8556806da9667f0d2ac8e0c40efb29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c952adfd923daaf02bf5a8cdd1ab2a9adc640b8624c7235981bed9adbacba45(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025efcaf1603518469e9b1bd5d93e01607c38a44f70b107657454e30f5a7e819(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912aad4a86ff76586545c885df7150e6c86da06a18ab444d7087384bc9f651d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8187af1679c4d0aacfddc6650fa5fccdbff50a536840e5fc32679c91b7cd6d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a48c00aaf69f780d83bdec85fe71f1e1b06221332e32aae72d34f8df769821(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c13e4f8f61be8f16ac735952d3298da47912b60a80166cedde1ffaa22dc2ef2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec495fa634f91af45921f47d5e6c662d10dab364614ece87d84a68dab06f38b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5fd667eb6c74dd3344198e19b42d5ad9d48f44a33806f6279b2551e6615530(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03b38c2d9a44f50154bc91e6a489dee43640f6293abb5393ed6b8b67edd3b08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9265da44ccd18af0c262ef7be80f4d4fdcc1f2fee7053c1ed995a5beb6fbbe14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f638cca8f85a82133813cb23260560c9f9fbdf902125dcb775e72b33d9d934b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__950c588a48960c11272d6206aa3b2c214c37696bbb0acd26e4cac646705ee427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ce778481288bce4449fed62a19beea708ab5c1b69229d92affd0e267a53ac77(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVerifyTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff0068fa596876d2a0f3f7c741e729e01f59ecfa65ba6fd5bf4e630add85612(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329246ec1484f2730c4a141a6f6f7a44306b8ee8b9fad95fe807a64fa4380cc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b6d91b2ffd9a550834156fc6ab527f9f16755324bc1d4204ddacb2922dbd67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef33244709cd593e9c42995695e35204640fb22e2963db9f4b95095cfb59292(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70eff7722ce126853cd530d3954515f72600b9f725d2c5a2aea2d3f055a473da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c157f383e1c7fc3e4c085e88fc6d8a74d125422edd7a2d5e5ccf13fbc744cebb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374756dedeac8489f54da3355db416074c561d114ddff7247da74fe81a64e051(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65065d8c13770234b75a39c4dfaab346365c2206c3daa3bdb7010b361e0cd9ef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfa1a2fee3a5b04307f0c11f19b492aa28e77fdf180ca9fc8873efd0e814c21(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5db599c669879e7b9eb115528ed04e4858e643e98b33b31e98a272d487be9e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b924c1be8084a93dd73ff893d6d88ed15bfc3eb59a64dd89782eee979a3d184e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d126e3430621c1e1505fe955b893b6e6868d47b47ea3b5a84bc78ebdd3f8a50(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ac30fd25971c4f5911c909a9473f24d2b9a71b5275b728e9fa76ee4e114cbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8eb8269d6f315a1091258678590b89353c56621eb2e7de00f9839ec2e57adf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39260a188563a8b95a73393e2332f7a84ea814a48f9cab463952f786f91e40e1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c5abbf861117c48834c0dd71f98dacb05b886cb3128166a796bd44a3c6395f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6756e0a0617db8a557e0628612c5b42ed9be34970c98f5c34bfd70f2d78a04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afee1e075315fcfe722e0560c4ec262f4c03d7ad97f9a4516bd7079ec32fb29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999ee9defc8f10beeccbd673ef9afaeb36a8a0aa6b1aef9ec7a7d75e845227e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0340bf03530b50d636bd5e799f9e9c17cadce45f24d055c8fe0071c0914e509a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31875f31476a51c73fc81b2021c26b9e56b31e652a311e2dab77d405e86f0f10(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVirtualWaitingRoomWithEdgeWorkers],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ff738da30e3a9d38f0bf1c8d851c75fdeb4b8bd8cd8b9669440da2b280dc27(
    *,
    allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
    allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
    allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
    allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_label: typing.Optional[builtins.str] = None,
    allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
    allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_key_cookie: typing.Optional[builtins.str] = None,
    user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
    waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
    waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_label: typing.Optional[builtins.str] = None,
    waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
    waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
    waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_directory: typing.Optional[builtins.str] = None,
    waiting_room_management_title: typing.Optional[builtins.str] = None,
    waiting_room_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_status_code: typing.Optional[jsii.Number] = None,
    waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ff8e900c15d5fdf99727547a210311670ecc635eafe76e94319d47bb3f4b123(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0f9a1dd3714af70894ad0e869ca075e1c1d1ea16a1d39a7f979e42c24a8dfb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ba87954cb2c221724806fb0af245807254fac37a0fe63b39b9498c99b389d0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d56a8da333ebbc4889748efef308c4cb2eb517bf195c0a4cf257f213a28256(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7797225739cfaac5be9c9a944d653fdda140ddcd653c8d2bc80550adf9b2ccb6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1260e87835040534bf124cfd2542c6e7b24ca43a27441cd14e79f2bfc9bceea1(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d71c60627cc73204d7e44c9ea3f8bbaeefaa40825da7f68f48f695b26545835b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72fab99ace11caffc21b983c3996e1ec7b1bb3bc349a759025473a153381e33e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf81c853c50125fdef409db9e39947699597e6ffa87013fb1f75883a48991d8b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__410c49ef822e40703bb752beaae2b27c2ec16e9be58dfd487d7f96b00f8fca62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f9feb2600b8622c625e02e280e17516ca8b9351fed5e0e8ba39da69dd8d703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30370f06f0e3bb3e88a93df2975bc844e8f40c59805a15e8bbf23c35d9f1c2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c936239e1cbe2ed492b8b25425834b5d3ee27243b41f50252cbf8418659b534(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb7e414e1ac40ce6d34210bdce0538a39e1c35320169884a2c81471edbb07031(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4bc3f3f493eaf430dd53b2625be83f3bfbe5802c4ff09e65aaa6d1cf158c4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85c461fac7bc0dad0a7fea0847e3d943f74ec260d78430f1ff7462e246a3a16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c82eab21020812044688e020f1e65fb5c8b4d3daabfe287f0f74d2b87550650(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf58fc549369e86ac2816fca830b229446fb06e58efa91b915f2b04a4b4ad16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a05311d38f679c10270acc51a4aa35eee1fcf621da69b4ea05ae3b1a9264b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8157d2821a31248f82c336d554fcdd958392b090ba449d31a4e537a67c30886a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98743bca380a0ac959b18ef49fa5c8b1addc01cd740e6c363a0083fbc849dc70(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e200bbc0880eb81832580d09e6f795edd4afe4442b774cab9694013b11883bae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab78913404342bad7c1a5324cb5366d24c88cab846b58b57dba19605f9df1d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d068b90001721db62f8ce76d91a0019bf87eba7b2fdbc8a7185f085b83ab6ef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe3b1ca392acd6ad4470359ec717be1edf14bb669542f87fbb8da569e77fb1c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32be3b9a5e6ea87dbf1642866790045ca11cdc3f5d29e178c79bf47233329617(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationFifoStandalone],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422926523352a01465d8b5902baf95cbbd56509f2c4b5eafc57e5df3f0bbba5e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4106ce623abc4bb029a3ab91778bb7df8f4272bf915ebc3e4ed2c98681ebf570(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce3a0689e72283ebdfc8dffc6d42be4683641e986dd65728691d06e5d4d8fa9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a009f50444b68b725d64f599f023d6761d0592359a0a52be842b5c12a237c5e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e17c1a4149759767697fdb503041ec8b4d30dbd25f5d62de828783c536e29a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbaa56ceda2578d5bdc737b26f6d3f49b2d8ab2d240924e805ea13121a5d4cde(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bffc842dc494569fe8caa938a44f38b5a5caafe28648bbdd9d7f7c9de7507bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f6f93d6379753ce59235f2c409f2783d165d812323b23033051efff0994cb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ab26b1d5440d850b49dad56f465870ad93c1798e315f908ba1d35fd0a01d6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1b244ce744510390b6d006262f2f9e9848209687b860b8dbfb078f746657cd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a0174759bf85cde1cbf25f55316ee3dbd09a7761c2bfbf7b40ca2f221520a1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78895a0433e8475a91114724f6ed0961bcbaaf9d8fc794af822307c2195a98ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d337626a6a94045e17c3727316e60908d5ef720474bc41a7bebffb61a7e6adf6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__334c5917c882e2d8deea0fd559cd6a1f89495ea4eb93ccb6237c3f98fd2ee0ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d36aced04e27bcace909e83cb7c0cff650d1021b478bf16877a589004423a70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8db925ecbc8cafe81075c1a6cdbbd4571767eadc7bb89ee277b799f5c6c52876(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df851345accb4fa419d7a3be907ceb162cac9c042fe996cb730c92d818361046(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceecb73edbdd902cd78a23cf95b15c5a737e89de0df592596c8ceda47fef454b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e963b3f064a4e3c97ab33731004daf5a68e987fec085c4c0f07cf79027defaa5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25da72f3bfbe559ca32a9c777d9cfc3f2d3ab52e750fc808759a6419824a62a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a5185d3af8917b24fca6946c58dc145bd1f088af1d1b04d7ef6af13734ed56(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9112422a62471850a1552552052d9766699be1454bb16c646de53f8457691a64(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de14f506e31c14009bf17dfe1bafd1a6db5dd4cc8b372f796994d8098a823db2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234073ee0f3b39607cc968974fd18bf56aee786069077d6971ce00b2dda2723e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de77b8a818b56dba9855e57ae51b9506e56726406a81ae154386621a1805c89(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915eeba6b35bbf9f4481f51ca8f195d1b4ec3d0f667cddc213fa7e4e3c87a605(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0a493dfae36503e1fa0e59288e4433650c106343bbc47e9d6e59a68dd1f366(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a4a46d8ecbd7cfb97e1d657c54abee636efde17be3d7d9289803e7a4848d44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d609c1dacbb82176f96b5aa2c55504b58f592ed793a9e040742110fb561e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__537a089e663edadcc3f3bc47100b7fa37bdc44d5a787335df48b4f4389f220bd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360019b5c94895dfda0749b3b3cf6db779fbbb1817ea163af8e107cb3d9d3880(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c22ac64853c6a71dccdafea5ec7b841099d152c2d3082bf4cbe45ff8be73010(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c3799fc3a1bc65352d5fa9134c90004cf3c27fc7ae324ea02e22d1f800c3708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__707835cf703a68d648a556668cce288dcd4f949bec7e5011f391fc6339f35c95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c856be3e779b0252f04ce57e435cd424d366f168a2d1134b6e8d4af988bea75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7b4c32a8382d6f04e8861c51450cfbba278546da7aa7e79af0d02d26ee4a64(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eead3004eaaea5c14d1e1d4a33409d6addf1cc170c6bab677f09f76eeb2d4940(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00f258be07d413fc76cff98b28ca93c26888514241151368ae169416e5ab31a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd34001926e7e5ba5ddc4c386206300867f8dd3206f8a2879a65ef17bfed42f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae1413ef3181d38709a6969793594a25761974cf29f1c4eaf14cb640f6368a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__223eecbac924ccc9fb211465ce38a1732f27b7dfb6962f5d44e5a2894ea95f49(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f992b8d85c3f5bb9f56f7020bdfdfc483bcbff42e9992f1a87bd176718db0d72(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8730b50b9635938a704cfa35a265073875b1b8c234de167a6b768626dfa449f(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c5c0960d91effddc7260f1c86e7419575a3ad5773a294dc2cb32671c5bd444(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d4e6470ddce860eba43cdea3d681a4ec0e1aff0f88e29c2c3f275ab5e34dea(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04f11deb9d8bcede8732a484adec02775676dae3b1d469444d650cb82f8d9f12(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f0ea2166e21b2c11b3278d7582f4847c3bd4ce9ecef0cc7fe22154b986d03d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df66b24b919258e1a94ec6d2a35b5790aef984843238739e807325a36e4036d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3403e3dd1e6338d77f31f0a598accdb05bb88feb6792022f220280ec32ce0187(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7955a1f560abcb4d6efd14104af479f1a93de51e679668a8f9a6996e047f2cc7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc72f5136e78f860f1b3299e7b4e74c77d361637c307802bda5af2c82cc2f3d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__968ee9a16b317d9ee8015f8eb827752c26c9c970470b24eeae7bf9bf3cdad837(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab5ab46b5e6349d03bed563e8e2adfbd6cb46e66f4283b246de17c0eccff2de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d2b8e52981b9140cbdf61c01a5b821b020f50a5fe88c66fa3b54c822b3476a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab92ab76dcfb68c4d749d3e6249c59975cb766d7c1f1646fae87193c743d9aa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2586100342ae5c5c6ca73b3dae95028692601d30a13c012b2b72478194ac0e27(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc9e8a934058a58a2e6e95f2998db3187c8e6911dbbb3c6985b24e07a9e4c395(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ad7c67e30a71fec7cd91c3aac51fef60d277221e94fca4d3659e0d25708a5f1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f500506ed9e0707cc94fd71fb5fb0dbd7f1cc1dde4a20fc80d0f145161084e2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97eeb0c6679a8fd1b40a6f42d80a3a7698b7708e250df5ac50f1a84f69b9c758(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695f9c94d9881edc01fe1321a24e5ded2dae442c5ca5a07058738a720b0933e5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorVisitorPrioritizationWaitingRoomNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba33c55718a86187f6932882111b5f1440f5bf5a46cbd0f1359b39a8ad52ba25(
    *,
    ab_variant_location: typing.Optional[builtins.str] = None,
    decryption_password1: typing.Optional[builtins.str] = None,
    decryption_password2: typing.Optional[builtins.str] = None,
    decryption_password_id1: typing.Optional[builtins.str] = None,
    decryption_password_id2: typing.Optional[builtins.str] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    miscellaneous_settings_title: typing.Optional[builtins.str] = None,
    pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pattern_encryption_title: typing.Optional[builtins.str] = None,
    signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_signing_title: typing.Optional[builtins.str] = None,
    use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_key_id1: typing.Optional[builtins.str] = None,
    verification_key_id2: typing.Optional[builtins.str] = None,
    verification_public_key1: typing.Optional[builtins.str] = None,
    verification_public_key2: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccc96c3090a0a32de5b7f1148d5b1a8601d29d2d1a39378888d1ab604cc2c73(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5a906d19e03ee0fa08522c9f18e90acc0b04518ca0157993cc3a277f60dc8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b42931fe85ea92ca4f304e5b9a3e097c813a685a746aaae56b490b22203f4eba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58e9c1d85cfa2700e070d73fb61682bcd57e4ae05e23c88343588b5c34002ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__001e69d405070642e535ac85f9c4210638f9982394ee59480770674d4cca3dae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed2fec07e9d216fe64ea2826c048c203b7001366a21ae81d8cdd43cd0d30689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12996e8cdfafa18e3d375a7da0b482a6390a1f9f317aabb48539320f7e43c2b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6408f90c153b19b434c051f3c812063a5ceb723220cc2e90e300284f344d2a49(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088cba64eeb9e579cf6fd307cde664a99fcfd19653724899b987a29e26a017a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5825df1f2bf07ead78035f2cdf13494905f2ff717770f329449620023419efe0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30d41b6186d639c2f98b5d5e864a02def74aab0da7a5359efd3a1c1e6b764b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76891314eb15e3caf1a4dc0a258681c4cf4d745e058d545ec9cb32efe925e592(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b34cfe42450825cb42a460ce0e48ffc2a89c09051729e0c84290a50dee9e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49bb4128c4ba9357531533e46311e4a73fef800a1c77b6c032368c58e198c0ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7901220be005a086a48a7e9c791bd6836c3217431e390ae510396083e240e862(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06c24db3ca320c83fc5b772029a78058624cdfc23f5f8ed12b0a38ce6dc5f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a14348cb8a9e189318e78706ad16b9b228a9cfa3d347f7a11cb2e3b7b0564431(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e662717626a93d30dd92893f2820cb521dfb96cc1a7bb177da29cb79552ecd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d025d6bbcdcb5d884da0bb2b985d4e1bd223eaabbfe129082d41ca685042c699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f1f2495dc7c73cc4377afdf5f35318bdd4576f5529482e787efe9df0bee82b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49b965aeef1ff163137ddd27dc3c55e25d9241ed0f5834e7eafd02ec26c4733(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWatermarking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb034f76b67e3864bae48e663cfac336a45aacb3b1c44bd9772f3999cafe768(
    *,
    firewall_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0122fdaeb7e8c529c7e23369c273fcb14914c9301c9b507cbd9ce1fd9600ee9e(
    *,
    config_id: typing.Optional[jsii.Number] = None,
    file_name: typing.Optional[builtins.str] = None,
    production_status: typing.Optional[builtins.str] = None,
    production_version: typing.Optional[jsii.Number] = None,
    staging_status: typing.Optional[builtins.str] = None,
    staging_version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5f3e8b522133aceb3ef64ef1af2f513f9e019be6feec4cd8bce7cd77a11006(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e885a449a3fdf0f322b73d7f96d4d3ae1fa4212670caa62fd484fb8fec2eaedf(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d25586b7bbe8e74ed66896ca4d5d6173f7800c0aca9e3cd289a3f66cc85cbadb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4a446b7953eb520bb9bcf5bb654fe1a35f23241a4dfe37cbe49c0a7100927e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779d66cb068d5f3f5d19cd5e81697820e4d611d4ce01f756a7ef76e0c9c89b97(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dbd3981ba1e905cfe408210188b51fbce703c51eda6a52de32984354edeb4cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b56956d7cbe7c6a645d736f3bfd72d835a4952353c2333345ded1c8517eee752(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7126b1b8c11172cee00453b5a6d5f4c9e6820b208bc35a25f63e265a4c2e119a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewallFirewallConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99627a0c75c9b23f52d55e59d1c5bf261777256dbd6258a59799e936ea88bb93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a702c0170c373f988af6d8317f361ca51e02e469f9fb427feb7dcd3f8b0cebe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfbe63fe978c7427952691e03a682c35dc35ea42fcaf4ac2c77b835e14ed45a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7a3591247a1fa9722a0b4afcb2f2a26f8d6de015fff3e3c01e0542006edce23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19add992f4c6b20d25aee3762973fde9ba6fa37aac5d22bc78b55967cf055c71(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebApplicationFirewall],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2841f178463862ef6fecea33f5b52a04db84d3cba17590aef1da832eb24a8e06(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b64ace1b6bacca64e3f31327b9a16fa6c4c0fe3f97380f61d94233120660ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fd14e4c175147a202cf7b01a22ce1c1843d2e7f990f1001cde21f2cc418eb7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810f64ab2c298ea81ada5efbb26a0299eb3802d146bbdf2ddfa001901cc12253(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cfc86d22fe5131de67d1aa16ef71e28e1a95c04c69b0dbc8dd44ef3c3706ad9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfe7c3f11ad412248a0cb1169a9657b55b3117d71e38a2aa83a2e72f3256ef79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344f95840fad8f4ab6e50a6dec690c0329c87eb65675061391393687030c6e09(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebSockets],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6db7c88f983270909b60a88eb21b0f8918bbd2e27ef889d6362ccf9fa17905f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67e7ae292050a6adc5b4a4f41926958cbe3857fa3cb37894dde9f52ff5f1a8b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f2ddada5a7fcaffc91869964c6dd97fec7bcdf2fdc4fe287de6dbd4bf25e38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__981eeb5d1613b2b82b8e974f2e52829a35d3a6220e073389cff3e51dc90d6cc1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae33b816341de90ce4b7daa0a8791cba46625d0b27802b43fffd30c2732f7e59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__271cfa327df7a77d6feec7f093f6c2af7a5074f8ee5e432685b786bbc3e69f81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab89aeb68008af7c515ae8c00b9316122c900f3e56fb92301f87d7922fe1881(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530BehaviorWebdav],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__139f79072e9b94e0c39b102cd877c319e46b9f1f3b898674ff6ee0d8060e625e(
    *,
    advanced_im_match: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch, typing.Dict[builtins.str, typing.Any]]] = None,
    bucket: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket, typing.Dict[builtins.str, typing.Any]]] = None,
    cacheability: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability, typing.Dict[builtins.str, typing.Any]]] = None,
    china_cdn_region: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip_version: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlets_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    content_delivery_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    content_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_scheme: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_is_authenticated: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_username: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_workers_failure: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure, typing.Dict[builtins.str, typing.Any]]] = None,
    file_extension: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension, typing.Dict[builtins.str, typing.Any]]] = None,
    filename: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename, typing.Dict[builtins.str, typing.Any]]] = None,
    hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    match_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    match_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_stage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    path: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath, typing.Dict[builtins.str, typing.Any]]] = None,
    query_string_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    random: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom, typing.Dict[builtins.str, typing.Any]]] = None,
    recovery_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    regular_expression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression, typing.Dict[builtins.str, typing.Any]]] = None,
    request_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    request_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    request_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType, typing.Dict[builtins.str, typing.Any]]] = None,
    response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    server_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    time: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime, typing.Dict[builtins.str, typing.Any]]] = None,
    token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    user_agent: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent, typing.Dict[builtins.str, typing.Any]]] = None,
    user_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    user_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    variable_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844797949fe5996806d6b5581e7e3310def5fa6fabbb6e277b85f9334f9bda22(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__585f6fb201078750bf3a187f5161628b2b68ca597e5206a765e10146fb59b342(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39041d6770dfcd822de947b3003cec70e980a4d8a3c0578267c17c932978c73b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d77563bfe24464b6395b595fb433c943878f97c33ea144f832427e5ad829691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89105b15ba89a3b406092fa8f3a24e69e6224025ea95b37389e80251d05572b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d310ba4c92441966d0a30b76b29634bf29adcaced47e1f4b1f7a8ba5fa0e19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d31979ef043819d2f8cd546adff3abff7fbb029cc59cd5420097d05d96d87490(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b0a8ea7d3685fd464d2334e6206ab7e904a71d687910b777156ea45983bae1a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionAdvancedImMatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__894f56581d9ec15d1a9ca3ec44cd149bb8cd067690cd239e1300038f667d5875(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d935dfa1215a2616e78911a74b9b2bc04f94e91f0eacab0b0b50acec513dec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2dc4e1dac894f663e92506660ccc268663d31cc7524b671db2d97a0967f79ac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134b0010ebf66adabe06e605796afc21b861d18b9b976ef2d70ac11578bc82b5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d5d9ae772f883b44a6ae2de8857e3b8c343551f72dff04acb4031242ef9322(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf8fa485361d6c8e4527cb22131a0122210fd8d6c482b0eefa2b97bbf2a8af3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a813c22ddbf44ec5b6970ee00803584d114b3257673364e4c00b1eb1ab97e911(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionBucket],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d25086f34358c9742274c73b9fc7c11f05319fb530f2893a3eaac02313fe19c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4b6f8aa651a5b5af43c4fdd9069a40df0dce1775d4f47fe9b36a9bc3de7efe5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e12cc659f46b503118183eb0ee33c06fa568069d3fd06b65f4ff0f68b6af31(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5787132f2e3c17582da0d82d0b4d64e370a65ef398982b2ea0f27d89a7cdad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a66a08ca7aa3d9de9a2dd4cdd56889537d0c2d6fc921de7252ceeba916785dfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ece03735921769055c2fa64b52806e1f546b74dc01178142fb14c2495663b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89347d33898fdbfa902f5138b80d511038e40b29029af1a9ed6e1e31ab8eea9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__128c9a5637a25f25a7fc26b03aea423fd9d9f2d53e5739978244b40ff0ad0f24(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCacheability],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5874c7107680c69a8c73bf0b1cbdf272d789c4e25c9b4fdaaceddbdca218181(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb4459c10c964798cdf52f96a65c0cb086cffd04cf6df027b0a42ba60ebb4432(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10aa509214e6a554adc81583de9228f6a81d2a2c7cf3661a204e4cd80d6004b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7468d09dd3cf2185ee8381517f6995ef1850dbd8464a04f990e631e415d34e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4234597055237e9fec60726422e00b20bf65b9900dde6e2cf1591205d5bb11f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb09b7264a685cde037c859b4d16c504b9ad18680b34c816e2f788f231c5150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd96d1297a96648ce41a309a863f47348cd2b28efb64b92bcaecb98b9d6fa511(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionChinaCdnRegion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae5f5dcf7f5b45218f188b0e4db4d2c10e1c720c77b1870c900559c0be38c29(
    *,
    is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_valid: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63a1cb486ab038829551f874561b426186bd2d5de6159ecb422dc232b34efc8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a41f8a758a0bfc60dfac0d943713b186df0b5248dfd7ecfb3be25589295399(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af3cb10cf177cdc80fa67dc9c28255eb49a66a46cba5d1764807cc7f13afa4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460513df14a82be5383bdf2dfe28946d98a6d024f68287b535301767e2ae2d32(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46e8f1f5745dfc6a0917e47f83fcf0ca054e5d3290c6faf649a3a7165cd86a0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dfecf5fa6e93163539208f02ed02e1396d71f6ca7c4afb4adcc976bebf547fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd236e362d11f4d1804bc9665a7241e07b8e9ef4ddf49676d0ca2af438da9f84(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientCertificate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__377e2e985f5947c22b9b0f90d0e6947fcd412810c26362dac3a6afa55b421f2b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef2c0cf4f42dc65ddc04928a2ff214b794f00f2bf2dcf4aae10b8d059af9db9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa71744b663eea018882862e5942642062f888f731c408602ed546cfdb8f83a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76aa3673dad9428853371b10a6ea9c1ad275389c5d327f8ace6fe65a10b72ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6526859e4404fdb83c7d7f380937032d778b8848ed91987fe572953c5b8f8ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba84f0d13ec75a5800dc44da0b56a1616d3d7ff52d314458e3819f79499c9b42(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61fa7e48ec63f476fd1c4ce209a98244b651e0c5c80d3c02424da1d5958b5c56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5479f772c53f28754dbe43ec5d074e3d0db934cfe2d154f445434169da41ec2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba7abc5475931787f484416e40cbd9a723277637c461708a0b4fd44b322ea845(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9f525f83585957d2ae4cdf2d365c7da29bd9ccda51fa286469805bbf72dabe(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0908ef48bcb3064e447a30008aecf5457c84389821311d7566d0263098a0489(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab51cf37732292cdd3c73e2ff1c96925ff1107bb5660efa9c9abe5a5104cb912(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51267092b5d3d3d23ef737680528d5cf3ea01bd3c2786e2c567fab9682dbae95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8b38d6e45a0a11d79199384fd82163295230dda42405cb8ce8dffd064de4bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cc1555437670ad4685ad52b6e17f74d774ce56a5aeee1ccb4ba274975e373be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e4943e7caac419e10a5877b3fb4e09c4efb025b96c24c2dbca8f7b5f1ac5a16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bd5f92deaa7ba58136b4f383e03ff1ec578c6c969d4872cd344ea6a3ed508c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionClientIpVersion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853091b6e3c8bcd343dfaa23dfd6b5a0a72071084396ae2333a22d3a5898f349(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6cef76ef4de4208fedee0ea887a3d82ac72df1a48d50c04797c19b38a92975c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62516f763513d0cd65a678086a28097636c0d2b21410124741ba5cb3748eaa1d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacfaa99b0344f660c2cd8fc46604f332763d4f34a0b01e822cbc08bd1e8bb03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236780b8c8dec01d0c69d92813d597ceef00a720ea9e4893257b3f1c3aa2efce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30de4072845f28c9cea4a2c86f7b6d9ef3b6c1a7289cc46db8983d1bb277e6c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__394a15286f31d9773b4f7af202a628bb9382a4515b5b1906d0400303936dd26c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionCloudletsOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8849e966919d3f2add519e70d1600f0300e6efc5a16e5bcd570039176581a53f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e9a4505306977fd800299c415a9f2c4838eaa32dafb08470ab51e14526d348(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cda6ecc58c1fc261451231efce49551c22619bab45798965c9b016ad61dd3be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b814a7ed865c5c31d677fd55a87baa5e33af05ff0166ab51d79c51f98ef1572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c63a22d761b0ed9f4397bd825a6d468fb40dad8db8eec6d4a9c31fab2b3a264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254ad0ad5df337dc2b2752cd9433332c6c969ac4feb9955f752070c27908a302(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba75bc7236be0005965b96682af37d64a6dbb1a7559b94b1930db3f673898d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca995812f2cee764a316879af12f2dc12627c412bdfcf7cf241fcdccd17678a6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentDeliveryNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__849e84ae10a6c70a913138d6b26a4a2fe2796d5ed7e2c88e0e7f754651728420(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b145a727b8ca91a95e3ef29b799cb5e4ba196179c14bf639c17e0cb263c29196(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2a7ad5249431679d1373764b1dffe06dd017d1dd9d7cce13bd0dc90c46b4b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3121af6814b186a31100746538dc37685e0fbd9106a48c01b6aecd242a4c0db9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98cd443c3c5885a19f8e2dd27fe8ea3bb7c9dfb7f9d5409d3b8c56ccd23c1629(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27861021d340c8836fde7bf1cb76954e0335a2559bdecb51081f24e9eb7958cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae22004696112b781f44cd07cf1bf0a990797f4a55dd8a630c5c6ae6efcee56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a590761911af90e7fafbb23bafd555113b5eea1f4b3970341d09af0df9e6c0ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66ad47b0adacc19404794e9fbc47bc559d88c1993dad0bf436502b34abc3b04(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd2aadf4860c592f9990dfec46989a890db56e97f7a17187d29facbaff7329f8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionContentType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77cdd04b684c3218719672a5dbc98c47b64961bbee97154a2e17465779faeb5b(
    *,
    boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    characteristic: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    numeric_match_operator: typing.Optional[builtins.str] = None,
    numeric_value: typing.Optional[jsii.Number] = None,
    string_match_operator: typing.Optional[builtins.str] = None,
    string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    version_match_operator: typing.Optional[builtins.str] = None,
    version_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24b1782721c2833f1ea22788176bea5e70f8c4d91016928520f95179a2f67629(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9adb58671ea98231308028695e1b0679025bcb0688f63f81c49e225b5ad349(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__972618dba1e738ff4318e6f6f5a784b66528899995a63e92d9d40e86bcdd64fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a998b48d07acfbd211650f629eb842e3ba89d92c0d9ff3f3d26943b44285a432(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73627663e791e997616e9f74f0fdb0d64fe09202c9317177b9f7a9ed1f68492b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab01eee2966a924206e0bc523885da632a366759a546d0bfac2e6926b668abab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52f091161b8fe0b09c55e93e6437e521ce24717ae701c9c681adb706798f4253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bd24827f413396755df933133d23c795679d741dd2e0d4530c7bcb2043b372c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9868fe430bcde9c3d5262cc5779134a4feeab8029dc38973915368a5d69375c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa8da374388b5c282dffb7911c8c2507d892acf4970c7d039992564a8741b00(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe829a21fffd86dd646f5db6286526d0da28b5fc7f24664491c58a72ce49afb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ebabd2d9398709f7b11502afe623ffffd91440097fb5575687b3e154bf31df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69a9eb7429120a7b1e4fbbbbfb2eceb23057c56524fc76fedf580f844b93ca7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__187c5d3d7b180031ae1304600e84f3cc6883e5fde5cf1a0c28195b3ca13590eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a853148f04b3a48dec59532ac214060db4b361667a40f76b9638ddd56d4f0587(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionDeviceCharacteristic],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6847073927431e13d983967f4dd635a417b82165f816a2ec5968688908b1ff4a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa87daa2cbe002dc6fa65673ad7d028313d475104cbe574a6522f7042f9aa9c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acff801dab3c6d744cd616a57af35e9d102c18bf710db411b1fe0da75839f933(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4b27d855fef94ea4bdbeabfd65f34fa947f485bbc8bd621cf0b8fcae81f839(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4de556d4a7ec013a8a01b3e0a7cffc9aa0cf7d5a96a859796d4fdff63224515(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c87f41bf05b926eca7cbffeac244830c533c62d5c4c92d7b2078da1192afba62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e1e6c3845867eff006f465979dfa20187c4724bae96d7371d7d9da5160c687(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12fc54e2dc52bb23362750866dfe98f0dc4f30ab90c01a0a6a1e87bc1eb44f16(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7905bb83f16483e8249d156e1b80bcb53c4b42928cfc43843d7ef1445b4d20(
    *,
    auth_scheme: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bd458fbcb7b98e61b50b2bf67c62f33a7cf983f78d6ca9a1480811d4b6964e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80df74109b8ef2c59ad3e96562b446a31d368331250830d81f683b59ff3c6d0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b8c3f3a658803bd355d60d989dc1927e7002ae1a01fc876e29a843132adf97(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__047e5786d81c9d797d660b508791ebdb85f0ad16c3604b5eb3e93d0e58e4e82a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb141c82b0c2ffd520f6713eefc9d7679fa1b6798a4e21504d30602a2f28f75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba78434fbf433813c57f0b70ea44c8951b3ba162e9e1aa4adfb46a30c23a58bd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdAuthScheme],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc37c284ca5b31fc18ec8b086a60e0385f108060625c513d620da10770bac35(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c7c1d351c709ba6b442fada1124b0d72a23bf7d130824f10177d333f07f6dd1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f99980f2b8d796f49d076a05fca1d6df2a2a6335ae9357c6940d5b3210f0b6f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acfa0a56e842d1e3e6c2a8f54e583b31f33c3a84c9897d3265f59b2cf19f42b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da56f2305864a18db2904f8a7badc14fde58cae23cbecb02b2a0a93af56bd347(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00b45987995e8eca664af22c6c1a462127204876b48c85e9de155153224bcce3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7271992c2498e64ff9e01343bb1b0585a1f2000353a2e40988b6df18f11a611(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdIsAuthenticated],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc5e0feb2843045e2a6a640345e3bcbb6286396c67f90518f7169411fb709a17(
    *,
    length: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f14f412384854827a34773754504d9b7bbcaf172de529f9ef849910d3402bba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730f1cd2628421516a54da6e5b162d9280a4481d982bfa2b0d52de87d15c5444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503448f22c142d36d364c7b8f74389f2c67d38ea5b56f8c9ca52edba9f706f74(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d5a36d59af8bd228cf91d6de44c8c60fddab3a5b4c6b8c3f1c542bdab007b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da3c7acf1eef64f266cca21052bed85dd6252324ce8cd817be452ac9cfbf9771(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__560265d5d02bf2c52f89d3ceb8a7765c5cc06d206453d5ff60c2a5fa38f03f13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45e86fb2458b915b727691152dc0d856a34d0de4c325fbb21fefbaadcebe358(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8976d4e9aa11d8cf87a8e2d573a0d9999da7b3a678fb713fc8796621aa1d4768(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEcmdUsername],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee65d53527426e1328f95a3cd6b83b963ebe2ebf7067aec44d1640ea0ebac39(
    *,
    exec_status: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0875d0c78c63ee7bc10cc55c16cb2554951215b09d79e3d567bf7a09a7ad71bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ccc32c39e9fbe504d4579f0f2b8c8aff7212a5be758a41eca4d15d1ec6dd1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00c9cdc8907065151a75ce591e540d32cdbba20360ece47bee3feee00785d8b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35b2af609ecd4ae6151bf58fd03711a1f98165cfc0abf23729488649b1e633c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a26c4ab7967bac88d00ba6d8bcd18fbd15f57940d7918b5d192f2da75a794b24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d04141e2ea856e7e888d2a5b5f5b35e8a93c382a486037ef58896c88e2ceac(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionEdgeWorkersFailure],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d914a93c68aa0ef6705649515479cbce06c01005e7ad95f42cfbe3816705b8b5(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fd0d707f17ce2ee1ac63aec5258771f9f89034e03caceed90cbb791bd567846(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84465ce9446aba5aa98cd8384b6944d57c2839799c4cdd9750032cae9185ea0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5a06d5fa50e683bb61e3b2bf95bebae9944d9d6810df81c20b6bb89b1568f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935838cc9a07c8cf09c549f9d38e174c1f78588c2f0b7de0f843db235c23845c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a39d3628c9190bbe59c54d3651a05fea065730a387fb4ff0fa99087cdf3bc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32861f9d4f57506aa36c4fc1f3fa6b8e87734752389cf02d901fbd53a5d810da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6667b646ffd71897c90018a879df928e9514edb1ef43ee9cf9bdf18713d4b07d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a12718dfa47a93bd1f67e32090a30650d31f8a19609033c34718056ddbbf25(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFileExtension],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b785c1c11afd72337ca6d2a2f0708bf3917141c32900d312b8d68284546281(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f7c52fb1d10f791c968e6f64e14f5226fdb300f84c60bcff8260d30a25d1f3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0dd60f89aae7f7947eaf33c1e3f0d1d21395039fc9ddfc913ef84ac261a03a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e15e5f710a17b68fc5bef32a5736c38d55518c79531bfbb34c8bcb73245bcb1d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbeb539e1374fc4153758c4794923bf399efa99bb79eac3b3985ec5611eac79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e653603c827d71157b3a0ab35062f0b76f3710676b86c01f600fe1e055ba742(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8517ca9e1ac5d1d5fb5fe61dc6330ac04696c964fbaa526f94595b49e4a97c2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3afbfaa404293e5fb189ec4b31c6e9b937d2caedb03dc449ac395229844cafe0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39cb9f42d8700f975d93fa319d5e5245e9f9f41d85873bf5bb6d2d1fbf2f1a98(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionFilename],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9151f15e68648e917d53bdc31f91710767eab485a84dd3fac6a7bb0ef956e921(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a32839c3e3d14f30951167f42143ce37d700dfa2f949c8d2244755b014763aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6268af79ce74ef73c441805d1d5162b09a7277a2dcf74d05a3d2d787c45dc369(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086a94462a68b74e9690b186ef0bd7898b5c9363b48e7d535e855559c290fff8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5547a9a35b7cc5fc0300fbcfe852b22668c6d803dca5ba2c3fa406e84f5dc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a70ff268df1407cf4b76a1dd870836ff6f2f528ac2b1e407104761cb7f9f3384(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d203ab65ae870e7fcf9a2943b507e600125bf9ed39cfc76b119d8ce9977f9a77(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b263555f5c2c1ff7777b1a8598d4b636396ab9e1bd1ca3798d234741041f9f5b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab5dffb35653db6e814b31a869d1bc3fa7bd15e16513bf7d1c07a05d4a5369cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce58eeb648d3613cb7e14a53000ca26a69dde3d473f35647e4739f6495826496(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80540bb4299290de5c1946091efe5c67246152328d4c161ee52bcdf353b90255(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f862d1b6c175ae9d57191efbdbe448602e17d689fcb32f3429327ea0e5b13b58(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__874f064c2bd07c20b3f76a8211169e21762d5a67553a8e63fd4e1a1ce10320d8(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa8eb81b7434c2f2647f8e1e4200ba7bfdca860ef872d4b75b298d719182c0b(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152151d6a118248e488906bcfc6076b7cbd0c3107202d6ccc8bd8bc65af0ec26(
    *,
    close_xml: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    open_xml: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d383dedcdf03b3ec5720d5b7c58a81233ea5d8b4faa61a5de4e3272390733c96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc786e33608644d88e92d5bda0ed40f4cfb67dc8bc77600964256090f07e148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbaaa2f8f3451b5ef995f258b6a79f7ec123f9391dd8040455982af45cd431a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9181cb3d03823ba2df9658114555bfca2d3e4dbf1da2e9a41b37b935ecf6d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eefeefefd7552e2d74b75f4edb4e5b2755c13e29c69ca97e55954a31214b63f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7498c0713f588872da407caac3c9898a2b129b6f4381430eba5bcf45213f88da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba06fd17f61273ea27e8b86352ada93c4ad24d55746c00a91d143ea0e602bba8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c54a8937e22d9f9ef74fb607080ab15c7b64da80d2f422719f2d000dc2faf54(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f673ac9bbf169405686a3a7c5af594d56fdd37feb4304f0e1175374a35f8c550(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06a49788ef8a7c7550d528f4ffa9266ade95beb2ed953c2b7540c4b0ba8b1c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9afe5827b4a94a952813a1d84dddf414145f22a974782cd17633895ddfde1cfe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19dba5d3fef737184d93d2758e0131ea2df8e7b40e9ee61f0f20b62a39a3ad0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e64b250e96ec43de2a3d42cc832c9dd982a9ed7b78cdae3316d872d3fd0f317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8b64cf75c18141901100027a17f15d22efe3eb32a4b4a7f0c77aa29a1803b6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f560e225d6292a3fa678e532a54636cba3014e316176a2a20572f77e5c9dd9(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a196c9a3387210d217c75ef38b9397ea71b1ea178b63501521f8485b53a554b4(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e079bbf59ee52a98ac03e04272cd6556de73f67e868086a970b702e3306a23e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8eecd3d1cd83905ac5644b5af7979cd86f5b9cda22e228ebbffdc00cb16b132a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57f6f676cc4667c9d5844610f359cc404b3c65e872bb43351a76f600eeb9644(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e578eee4dfbbda82538bec585878dcfe891e0a3e5b93153ab2e5f326348f797e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aeb45f2d58e9c1e3906f60f6e49b1e8da832bde7b96dd70f2595657b3f57336(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750ce5039586d9bcabcf75525c46c231f8507f7f7af1be1e29ed713c58e19784(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c86ec548dc59e18b81596a77adcc4f50bf9f0f076f724ae1ef7d9444b0658d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda86763192c8a546d5e604859a7a7733bba71b9edc38144fe61a87ac85ea9d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45b2bb0e89a38d9590600543360304304e5c66599c793a6c1e7126b22b341664(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1280d42201181a0e9a930533964fedbf3be82a64de347e5920dad63b0438bfc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980d96ef245ce6fc1c640db633ec352fb527c74481bfd796fe6819a89ef83f32(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89ecb5543603a323be18eec7210ae09f599146da6759007a1261d33f83e2262e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952ff19237948f11231d45bf08a694309ba4dc817b505401e5e18615916ec9f5(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6edc4fefc632ac0d119e78867b71054dc3d43f4a1675ed9001258415a8e8aa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d15fc36135087ca6a9b7c4b032012e6b7755ccabce7c26f84081f52daea23f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a7d79a55fb9d30ad67104ec0a105c33c0b32d9422dbe4857bcdb131893d3fc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d0c6b668e51155f02ba1ce112ef34674e1ecbb4e6e36bb144d27173773fd6d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974764432e7f36e3fdf607da6bc98a772739bd645ade06a33a7b5ad8ad512220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26dd3939ed09756004fa8c4457488ef131479aaabfbd9bbb081ef4380d634b01(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766a7afd40ad5dec357b871698e5f3cb37eebc7e65dd698f8274a3bf66e32ba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a46edac9c1aa6afac1972dd99d03199031d5e99730cd823e2777bfa559717447(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e0e0892a8d6e11272a3bace8d9475bb82341640d89c4513092f516658844bc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824752e4142c70ea9063278f1b298a68bf689bbab47691909ae36d8c0c651438(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[builtins.str] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_expression: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bef63fcf00c19a84cc903ad73c00a69f2a3cee85248d6b041b170363dbadbe8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b11da6ecf2c758e7565372abcad0d9e891bd8e2c36d0da4cd0ae2056fea24288(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0833adaf638f919e77bf3b94424610431edd536f20853e3970ecacb4e30444af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02064985cdbf5c5fe36277dc57d7d2e7ece4677f3c3cd472ff08c9228bc300a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d885c8faa929271c87467ac1e1e05d4364037d6b2ed8ddc84d8a5426ccfb584(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55efb172457b2a103df27ade2feed50c46c4d8f1f018cf71e8e012d5ca7867fb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e5da96ad4ed32868e2d5d679aa3423d09c9937e7d182fec2c2f066673107970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa45a93056f3d27ba6fb9bbb048eb7a0fd102e0c4e61bd0f63d75acbc3eb8ac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40512deec401ac64bd2209e78e48a9591429d549ada93a3c28a673252424d3de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca16b14497bd17cd6779154812adb74c6b642d1a4a591064e877a0e37f976b53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba24c07b7d56063bad525aaf0d6ba6ac090b03a4d249c9345ff25d7c933771e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff034deaaecd9e84fb7205c3a9ed1dca9857d22b1613f181eed21e7076157901(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b757bebaf007e2fb7f28b151181704cb1f1969940cd7998d59fad92c939ec0a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMatchVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3539affb47a5deb0390c845db1ced29f9f03dbd220045dc692ec3a2c0ed79754(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4316b3b6dde08060e509cba7748405389ebfabf1a622adeab279b3d53ace2fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f040d9c9e07197e36ddd645919011ea7a7b11f9c3959e835ab776b6f609535e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b5feba08f9cc9dc5859964d27cac632fbef0691ac1a3d3b90602242a623497(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d5b5defb52316d8efeaa238f5be5064c091dd424143d40953f5cee7da95649(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398672bada67d129cc38f4410cb85b25a06f9e50d40f85738a456974425db874(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76bf809efd05f31be9b6cb77607bb0fc636d97ff73575a4eecd8f7107bb314ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fa0fbfe2f4c6597d3fbf5fe0384838a302c2a68d65ce53df602d2a2a399f523(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionMetadataStage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f3258db8b1479dfbc4ff6b6003f48a6c54971b33020917ce8a34ffe09c5535(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d582ae9cae467bcca1c2bbe20c96f0c6ebb5d4ecda84131676660800319c71f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0107aa087c4fe0edd0aed5107e3eba66bf5f8c52d89e73e537d85caceaa05a73(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a978f59fc44390a5457103e9a6e47bcdf39bdc3beb807d0f7639507846f29a75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f08b4156fbf577e4e2193ce1bf287cf010723863c5bbb364530a55aa6ead3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09e02dd0f6ac38f847f5f01ebb49bee230d18e96830083874e467def1fb329f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f56c60a80a559df6e5844a9b802ed83604037b477e51cf2c2459d7fadbd76c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionOriginTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b82e131d351e1381181ea928a3f0e3159713273441cd6f864f6547f495c983f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a75753240edca6bc8afce349d9e1466453d05fc00800c032cdcd516b6210456(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Criterion]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3aa85671702471e82d16884eb9718abe239adaecb12ce51d9116a6acccc03e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bda4b947c7558a089aea3bae1002caa2fd1849fb4c2d500666094995656a2d00(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154ce68cdede308711b7a74c0d161b2f681129854a3502eaae67d163c920375b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed6692978b88994769d1f0c4330ee7415f2b1bd5240356c5a2958dafb41b286(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895d3218488a6f7caf00e2d8b7ed8330978bec3ba756687a792f8891540a5346(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7752f7b2f297f7dfeb8362cfeaf54d30949d2bee1aa608e206b7053eb9f615eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db76dac0540b78646e65d2f896a10732916f2dd9584478d7f051fc0b7432f492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__515c87b152c667e732fb44fe5561b24a7c36390d47fe191fbfd2b21b4bd9eb3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72eca56536c69bef446065361205e6108332a6960bff143e87837f082c9bc8c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a6a1e4f5ff825601568953b22538f07d45ff5e748ef7ed83e2a6038c3433bb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionPath],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b605a38c254e1aab2a017a75ec57c10f6224c7b7a2b469fe9d09a01182c0395(
    *,
    escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4dfc69bda699879bd8453b02d773f0b61b4555114d61e8cc774faa1925c1a22(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141e98912c69ae38557ba48d0b418f67cd9508677c431b5b99154bae0ec4e3e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7844060b5988c6eba23ad28815cfe01228ce2891bcda1046827222ac7023a96(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5055ccb1db7ff8cbcd7fe79d948d87c60bc3bd4b760d43b539a04ee550736b27(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3e752fe6039ad75f4c948eb89116a0185ec4e404f401dc7aef0a33b56c82e73(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8983315eb12dc1c9ee269e0de1865f20179e041ebb76262de516fcc4d31c57e3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f679bcfc20b714613ac6bcffdaf61cff729128b66dc0f62a2177ba34913b6cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f0237e8ada9ada8ab86c99cc343ee9b872f5df2b65e9515025fc28921e1846(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b679c6da8de96cd34a61da38a1a92c61eb5cb22a46721449d2544c07d8efe6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82a2a3e77ae7a44127c904f44c1df7ff31029c1e6c2b68e627ebf153f573bde2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725dcae88c44bd46788d63fc20be334ffea33a1072ef72aeb2ea07acdb1258f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e908a349fea80139e7bdd46dcea13bf98372672d1eaecc7978108b5de4a24f5e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea32499dfebf3f0fc50389ea76192eb99a71d1f6e6451b4918c992d1719ccd11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be371bd17dcb2c9c25ea78cb6bb460873239ecdb602558d2b545dc7bdb78575(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d99ced43f175688615be719c881bdf9d0b8895e10ac980f273784963a005d3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionQueryStringParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6e82d0572e6e8e2fa1e1b9faa08cd6558385abdedfeb0f90feb4c9a9abe894a(
    *,
    bucket: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de97a91930901f80d6e295b5511462ad9c0f733916049ba692a750aba5ea97ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f35efaf9ce38747df381d1b16ac6f86a32cefc13a51512699ac427fa6ece334(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beeb7c574f72e7fa2b1c16e5592ad3a65540d3dd4171fb997d6aa633522f1ad4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7222cc74c88fea49d0dd6f3bd678680999f5efebf8c9751eb331d841cdfb770d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6ce590b3b725f99d7939338cddb1d6e74bbb7f68a782b3419aea4ac673fe7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446b9a97c1f80c1d19e3e3b838163c607c94dc62336c2ee5579075ef74a0003a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRandom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b8a58b87919cc43e2dd723eed44cf48ddc56c234fc774c032d5b7b8aaaad28(
    *,
    config_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e1661f772fcc425968f571926b4f0d5ce720f9e453e0a2f85df8a0ecd6824e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1097e0463e0f208e31447a6d066dec409738017ba678ccce4ec38d6e0dd71fe4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c6f01a8eef858cf957641264d9a24ab2badcfb996cfa7ccf53362f0c103e2f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5475bfed65c9a6065361da3b3471783f67ae06f8de86e5103aeded5b04d688cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4509bd811402f0135d10c20ff60c3a450e120fdf8af1d9a11cd31c9e7e4c57a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025c9d82cb5f7a0e74686d02534914ee5f64e7716f891401542a1044c08b75af(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRecoveryConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4517b1f753656eea7ded3826bdcd792700a6500fbb8660937cd0b14fb724f53(
    *,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_string: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c92cce8340c9cdc164000a4dc4b3c8a607e8d96716b45cc406e821071c8fa62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecfc6954dccb720a8f7c05ed444610540b8a5ad5f03f68d40d9d58c3b458ab6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1faed3d888774b22bdde5bc46d3099c5f48eaa499b2d608960602f740083726e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__601d8c3e71d5ae058e4a79a1e3150b7f6d1c27d5ce759b3a21f237f93dc620d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__929b779f701ae3d3c79875b3741e5e967c1d9710354bfbc75a0cc262fcc643a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ecf636320f0817f481aecea03cf0b3f87384fc91a32e843c9b5b330f02cd661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa6eaa4d828d7123721f833ae21a354762b17fe0c312eb2c6bf4f989b5c0023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1a4325dff6f4df35891d00f72e4009d91870bca9390c52aa3ced3df0c34a0fc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRegularExpression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3990d412f5d0bc00d77a80b6fb5e614ad8e232f19b60fc9d44277d56bec86f(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3358f80d40746cc649d261727731d8b46e05f54660261233b4ca0cf9ab8ceabe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72ae46a8bca1b96d439de075e0d2f909f46522c93ad68be3ab11bb359f359ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcc7b953af126482103def696ec12a4c982aa70fc57e4062005dd6ccefed166(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e10ca598046381b787efe7ddf7b1404a6db86ab54075c38669797bc04def12bf(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4081590c596e71c09334a9e2b8dda31c286b7fd2b2447d15ffad41be69dc3e6d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30936626db623ba96e4a3e3c2b1ac124a948bb58365b1863afa0fb76df653c54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1587615811d7bc835d627706cf64228b947d361db79ba6d805d525aef5488f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e5a0e1389b7712195561d93a721f2335a0c95d67b0b1489efa071b96f42d90f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb18478c62bccffd1587d25855e5de70d06c2300b0272c3cdccabfd98ef91fc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c277c4b434734e399041798bd24ee7c88c14b6f58b1dee07cbbd7a15791ebe9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8735d209be98231accce05c86213e14b014404cd8290f77a88382602a960fd0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e195335660f3359c1df6d1279e91793f11f4da8ef83dee1f1b61a96863b7335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d098e2450169c73e9467fcec296b1720188367a52409697258704b19fca7b44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f834bb711eb9002779b6b5371cf5c15b4f8f76051b20a4f9f3eb3e1eeadc9d38(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5def55d35a1c370aa9c26ba6dda552c378cb55227cef4d970c6f271c5150bc17(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb38696ed4f6516e8021d91670c08d12d9592aed80308517abd21d6b28b46d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3eb617f07ed4cc8a7afc470208a7b97fd3ce096630a8d7a2ca70bae5132f695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c875e3cdc76dbffd332b52c436169a1faa9add4b16e131e80add8e352de4f5ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26d7b2e84167e6220a3d34ecec54aa99a78df1fc60a0d0813a3f5df92b537cd2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32c9375c66ea67f71b8eee87f2ab59cc9ee8b91e41ff120d0750a2b4459204b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766bfbe41be26670cffa70cf701a8a26b122cd66daeacfa3c02cb0dac8ea1237(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9c2eaf901f4dd18b84b9c1d8ff6e94af6e795aecb52d8988572ccea4c0eea24(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1b85a92bdd61ff48cd90f7f57569aa6d87ec2c64d933dcc935bc3ccc1575c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__347c5221cf5a6ad75b79bf8c07122d81e5c3ce9afda700f999f1469ffb5b8194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c011ea105a5fed6afef30341de3c55ef224ec7499b7d37b80b944c6652e283(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d256ebab3ec4cf41284be4e0df5124e80fcddc81a8354c21b0babf2a6c820777(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3e2115a2805ce6ba1acfd29111b349bc0b6077bbdcbd50247513000c4b645c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8544da3479d019e21a52aef9df885c71d305ac9c911eb2aa7848a368f982022(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45e9a2c21d25dca3fbbc9e7303113fdffe0253077ba40f395df58672063c64df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4656fbba43010ae3138845a14715171cfb33b8d839127c9b72792285666cf34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b0f1bf5bf20cd25f30212802e648626f8b55c30ffcd5a65ecdeb50b7f84912(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0aa78b70fdd0af884ffefc5f3aa9cb8160d9df7343fce99e641a08e59394d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117b337a66d95756dc7b70c6ad1e94272fe6e0b1cdfd70f4c9935ef33dd4e49f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384136456b976f6d9348d62b9e078dad92b89ee1f2b1f5e56aa21e642dc58e77(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6eaca51217a4ad102a76f53e4ab5d82b4822895fc2ee8951e54e723fc17cfb6(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02b8531e33616047fbf98af03d4550b9078ca59db9ee8a127336e552ea90a72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfe4bb256e194b5a46bb912a11a9ffa9a6e6671c70db95351150677370ee262(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c698b22b071f6500398d0eafdec6fa0e67f86687ca908400a6ce2bc885eb500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f180aa830c23a6dec801bf05c7e68e12e21c41dab3f5b31697ac525b62154f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b60358b9a5d42a7b7b72f7c6fc69880f90ed696e7a5eb6fb73db13d1f9acef2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d0d95815b91fed05adbe203f4d68ecc45a9b6cd2695f2ebaeac1eba8fd4fdb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b071224bf6bd0464507c09f49578071a54956b7f67f1b1cc7dc24e98237327(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b064fac32cc989e26e8bd166496fed5fbb896fafe779d6b85e1465719f91c8cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ab73419ad14256445794f2dee32f8063086d72015a604f4afd998e3b702ff9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1710b9e68e0a8a0ddb6c168d515bc66b34c9f84e9b7c38c3e104a512fa4d32cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6394e2301789d625d497788a7b549814a687f36aa756d91f045393e779fb7545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea91e8c5b2147c133048018202c8d0d8122f137ec97b4e5a1e4ae3d386d8861(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f61c17bf0758898ed5a23c6bc2e8b1371f1412359c6e8c4468d30cfa6c6f0b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b609aff3e6d6f3095cb4e658bb857d7c46b7c6c1709f20c9c849c617f009f2a8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionRequestType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52cdcc37520355c11e2e8a3f665d97eb1b572c4a96bb8b7a1ae6be92e8579816(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf9e4c8b2a200b216ae2dd5687dd7366263e9cc8c0fdc0d743b8c835c897e0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9cc7631aafd8196000a78ae509eef8aa0b407e6b259b14575fa3409fe2f1a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d34a691011dbab7b7f0baf05f76a82804f022f139bb8acfb6a97ae1f349c42(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3d56acb11e9fe45413d746b70229544adf438d2425d29c8c0b75d073e9e156(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582cd87691647076113252a13f5cd1737c2ad3175e6fb3e025d9b70cb919196a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__351c27e682040576c03e4e59870eeea1b173ff82b7bfd87bde52ca12722de11b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1686de7563cbfab8c40c7ff1845c06f963e6cede690ae9fd434933b9d2038fa2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b96ce56b81d281a1b33c9eed7b66c69a4e35f639f1114977d6a1f493ca62757e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50500cc28f824f073627833f167bc49be262085a45cf9e67a4572fa40aeafe8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61edee3c7b4b10b46f1db0c8c7ef394662d8d782c4a2eab92527658993fafb41(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67299ad66656422289710c1b5a650af881b10fc546a80e892a875d712add07a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53658eb993c503105cf5cc5522ff9fb5a5514ac1eca5f5384fd2de6f26f84e9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca448f5b7c9283e3763d9bed7565bcd322950723fb68d27b66ab302cd750492d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c439befc9e9c8cef649ea52ca5bbc5ed4f704a815c1f08deb484fd61c873f18(
    *,
    continents: typing.Optional[typing.Sequence[builtins.str]] = None,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    location_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a97136c5a37e8bc03b915a1fdd437a29124b741e3eb939d1e289c04ff07510a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__122880419f558915b35e0238c9f7cee920c5ad90b1f3b0f028ef1d1ded58daff(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d603b13db4d1546fa5bf3ac068b38106380ffe768b9d93a0baa39457c022480(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2ecd43d48e71a5c8843a4da59b7c9685b96c58b870615655a60ffe94ed8a68f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__288a96490587121ddd1274c9a728bd1af260afc95a19a3a14d946139e95f97a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4816d90d8098cdcbf16acbce5165f31fe2f3adf137c228e36991e53150fde42d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47bbd34d8eb3517b98035efd569a5f9de5db7713f0bc37e2773e0bb5606925d7(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed0678d30e138b2c03dc3178bc3dcef623ce6d15c7d55085ecbddee8ddedefb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abe6d37ce1e43a13c736702625fca2f66ca95a44e9f9d1bf3032382e40a94704(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ebd0329301d0fe6d17d5e7f77a15013e144273bbb122e4f4b883c6164aae1f5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionServerLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75419c24276e3f2aa2ef16a79bb0dc6aa35fda9a8bf34c9273b8def8be678a4a(
    *,
    apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    begin_date: typing.Optional[builtins.str] = None,
    end_date: typing.Optional[builtins.str] = None,
    lasting_date: typing.Optional[builtins.str] = None,
    lasting_duration: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    repeat_begin_date: typing.Optional[builtins.str] = None,
    repeat_duration: typing.Optional[builtins.str] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78019bce92fa43286e35e850e7197515961b1b56750fdd826090badd9f9ebdac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c98e58afeabfb64aa27870276c3fffb727ff930020b0de0b318f214151dd475(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f001a82a164a1afdd597cc6c9d46f9c344f7dd5554fc3c4f43fd5879a30678d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6653b49d6dd068aa219907d86cb4a1665b2332117875bef67e1904d101e48ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae870c14ba8260fbe58384c27cb1b6713a8981bbccf2e8060e42bb630f0c4e62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db405bc74fee9d33e28c2383ecbf4161b14e7851fb54772bfb38e352fee62de1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e34e0b8ee7f2b325159039dcbfc1e0536bb461ba68e4ef552c5f05516962984(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f487bcae1b997f730e25800b0fec353ac05f17a371575d1dc8f14b50f5a455aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078946386ce6e50935183c5dcbf0bd9d52a0fc33a8a63977a580f59094e20483(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15e859375e96e3e7d3b26781eb4bb5232be12b1fbac5a845862dc0103d9b9271(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6689e5cb2d1b3399d618d7151533037601311b2167aa227cdffe1a34bf899f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd5a6d4f38e1a29df4b79d61ace0563b397a780403734d6ba922eaadd1df284(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc8714a05982c2b70665678c3fc40edff9a70dcd4eef8f45e5acb40a2442f2f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb396bef9dd4747db6edac4b9a0b1742dbd7e26bdb9e99b14aec40c0d806fef9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTime],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b5254c5fd0556be47269fe86472d75032d2f48466090ab6cc9a684d0d46e261(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6499cb28a025c045cb9ccc5c780de133239a23625f8bd3de988e520a8bfd12(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd13a638718e7791a8efd519bd0994a9e0ee9a0333cbd6bdfc28059a3e3a424(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700d93b3834eb9e75020fcdb6f6510b2aa88ff1135cc1ed4d2af27a4cf2a1823(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__671b6895e2dbe027e620368493fa4088785f26e2d5f1708711e4333db69c323a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f608049daac8953eed03eefdca945598dfc6d2ec4781f9073726b9846e5b63b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48c669080991a6a127cb365a3001d14dece9d2c74849f86218b8ab01691a8c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088c88b4c0438f93877399af4e77b827f5e9902c0c9811a6aa292be45169aeba(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e3c21a94d106eae54f1361a61bbb23d4173a8610d8e908b6f886fc4cd4d2d47(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1826ad613f883c4e14e189385c4a9edfba1783c57df47fda90b5e9729bb18a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5fce99be8bfc3ab02ca14e7ec007d3277c1c57c3086acfb45c1d6e9500d81c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fd6bab79acd40287b4fc5090a077ca8bd8986c75a6526c157a4b55c9b1f894f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e0bedb8fcae891964a3e0798e610e0bb2fe100036402d197912e68855f0853e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3874a0cc8484ab66c49c75efeaa6aafdce784d844d8e6ccbbf3f7b6a07d4bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e355d05576d680c7f842abd005c42abbb3307c0b3faaaf342aaea92886a3c045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19fcb92b4b6d717c9dd2d54c0bd0f577814d8fe7cdcd8853d784bcab229cb0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e789b10e39a347e62fcfc24a6ae040470de27d92430132f7014fc1204f18f001(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c71f42ab1caa4b12a1ce12f68c83348b09323c690fb718c7d4ed572d807d3fb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserAgent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280f3ea45ab9fa4a8eeb869aa8e9d146d3090fe4e27555e5c858eb56f0a0da43(
    *,
    check_ips: typing.Optional[builtins.str] = None,
    continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09727a248802b7e7eb3dcad47d6f2d0014e2fbe99867de27a0aa24ade9cac147(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9a0745f8f5161ae50569563da85356c342a9d3fa24858be1c87bf23b4e7661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40493f3590cc0bd948f57b5039837b214fd504e180e94f5e5fdca29dd45ffbeb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a1854d49f20301803ca5eb723a6f34236e58df39e37103c9bbe45bc3a4aee0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acd1385500bbbaa703c7d29d65878e9f541f6f252f55ebdbaa98263340d2ebf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8817ef7cfd5174b8144e434dc38820c04374be094b9632f5eb9da339ce989d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9199b3ebf42dcbc3763ca72cf8c2003c6955cf49972c4712c7ed6fae061d281f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d27feea975d703fdf450eeae6ba84337501c75400515d54e70a726ea7dd2df(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__144399509c6d0142d28e06f15996138726a2a20ee1a8490438f66586240fc148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7065a13a96c829cec7748becde4e1d394a491e21f02f73bec80da6d38fe6ce2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1394064e95d2405c9106e5bc78b1c400d3bef99a22266f1be39e0322718509c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d547fdac513721df10808ddfd3a4d6bc85bad47fa6b641cb17ed0591dbb34066(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3fd4269d9864e3cffdf6e0dd9266146e1e2fae9196def8e4dfc902144cfe53c(
    *,
    bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    check_ips: typing.Optional[builtins.str] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eee4e26f841c77ade82148238b1e3586fa94f2d95b5ae6cf74809347073df11(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6c26e878c34f57a5c5455952471a9d27ae3d2825c41f0bee0dc40de3036a3c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b41b91d322578cca66c0f097d1b9fd54dd3d1b204e6b6b16b974ae58abe154(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9f9f2b1a1100dc355f0b06a1713809af5d4d675b53c52aaa22b320f0fa9eb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf2ae7d568a15f685ddcdb1f9a315d33cb2b2027d767155228736afecb2ccd3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7425b76e641684e452903f07b57706305c61723c9cea5a4347642fc8d5074d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88eebcc50953ad6be3c658e7ae4bd7095a168c4e2d2b5713a3e0285fb4647d08(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af78d6f81b831ce5222f4ff346c2199cfa9a11d6082b745770d8d614f2aff2e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a995c21acb05c113a822fa2caf9924c377ee81ae8a422f70b4666d910bbe3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f6b2f076ab2ece56e3307c36c06ad9d9cfbbefa74b70f6125dd1f0bd0427a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e4597dc36e0cc7427d50c271a2cee1e908c31f992e037036224668fc2d0e52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07cfabe83d7e0b524c7739e397b6c562c527fc8251d8870524c386a66b7f24fb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionUserNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8bb8315ccea09e8f55dda640cdd25d9154e762051fc40e935e28d82ca09104e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0833c12068f2d1b087c7c81b7bff7de1c23333333ac857b7de8ebad15320fd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c40bbe7c58bb8503af8c985dd3b9d02d3a3e5f12a763a2b21e0ed991f6af61(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcfb0efa1dc3191525e98fd746198e5f97bf3788d0397b928bffa983847abd20(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89ae1de8c9c3d552766321a250c75f9ef75ae16ce2a28c0510efe163ca66e31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f621ca40758501b238d53e4a03a386697acafc1fb24ba9608022437ff5962f77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b79f0f6e88782a44e91f4ecc910368c9f5aea9ac38348a33cded4f812b2d7097(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64db978770d6b19b3c2e02bc4d03a2e3bc95aa2b8daaf837f405659e254f6a9d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVariableError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__956e25767006e30fbdc1a43c05d0a7955f50fab2f4b4dcc5e0ca17238b83f968(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27281eaffb4cb2700d1d5b6c11c47121cce46325a49e4c8b4f81306d647b489b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c288f2056ca4ccba0bb78a4f3f53e38a061c82481e784829ca9bf52d2062671(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce21fed1706c691e4fadf2a69f281e3ebaab883c6db82dd2d153d608a6a7d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6591f6db69c1915dd17a7d01c8191e088e2496eb84bbfb84d179996505aa4793(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b08fd05a2a84abf62d1ff7fb0eec0b314b52a618677c1807ab0bbfb123498e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0789884e1c27e9eb3e65f931d85edcfda668ab09474e5ee01a258432a8c401c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a3964d8b8bc93e252adbc2446456eaad9723e6c6a35f22505aa85f4660b0193(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVirtualWaitingRoomRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b8c93645efada78fbeed697940524fd01050bdb0c2aaddade6bd1ca4edd77e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4dc206eada0bd28c6ab58fa135969ff55412465f0375cbbfda0dd12bc34223f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a8cc2b8450170cd5287d6184470adb3653f9ce2148deee0b6f25cbd6d1bdb44(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745759557e9e51f8e9c66be5c721bda93ff31a28aee86f5551a4d16cbf9c1f44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616aa8375fec77861a59ebef1ecb8952fe3384b0cdefcf5e526af01812ce9cfd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf536ea49aa12693bd0b342308a3e9005dff00af30824b4bfcc9757fdab25a11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1230c4ca3d54cbf3f00cb5e944d573ff8bb31d8cdc2d1b84dab152e66a04d18b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a51bb9c1afd8b6f21a3333ec3f6206fffbfa16d4b4c722662a82035ab2faa279(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CriterionVisitorPrioritizationRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67494a3bbb555a79ba730351f4b3417763478910d2f98f6eeac5b6eacd71af40(
    *,
    name: typing.Optional[builtins.str] = None,
    override_id: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7b18b5c798b13c0bfd5648e47b0877e31b457fc9a777aca92d83eb211aa88ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c0790b2ede5ec910bd3b46916016195127c9813c748b7c849489e0dced6ece(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f5b6f00698fc78e7639c21c69fafb44862fe656caed0aefcf4a4bace80006d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51df01fb5ce76eb224aa51c7ce9a5bed1c43cbf203814cd1693ba0c9b31bd903(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530CustomOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19e10ea36bdfc5f25c597c9eae64b2f2b2e3f1601ac837108723ae70047ca02b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a3a4f33e1eb7db08043194457a2ad05bec602af9df4176fbe73b38298a3a905(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Behavior, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d4dc1bd001ce13cb56469f6aed2a0bea2540da55a1605ffa2097f0d7af63f4e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Criterion, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9545d272d588d7f64e687cf991043561e093392f217450453d18fd10766ce0e0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230530Variable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd1cc986daf84f222ab7ed0e5c0bb9497349f0186ca5f7583467bd8010870e86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60490ea3405304f07656f6e660fc1f7d060d2530d8711389d8bf2d11bdd68779(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d7462df45dfa180d512bb82c7eb00f60fea1d5d6e5630c9c8db27ee4e4f22e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd6de92328177bfef59ed6fa0a971e420984e98c0b2354921890d2efab9c7c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb89ac041b8a9757f30f0dabd0713ff150f34d1ce994b6c16fc7f28e02f669b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5429c841d435f170fe8b60bab3d0b4e4001a4c865cfdbfabc8e1d93082101a1e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1668d7ed5c245e50d7f132c7cba5e42a7d09f4ba13cb30c24166d1ddf61a04c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5428d0e827c7b49b53cfb94893789d6f2510a6e558b14a1fd6c0a8a936a92777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48c9c97b579077feafa8a2c9fc706e2e52d553ba3b62ced23cc583c7019206e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc8868fdfa0eb7674b9d4fae5372767c8747212fc326890553a4f3f3486a45a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e0c91b98fc3906c1a23af7e8fd7d86e68707786135d95c49d1464edc2f2a726(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230530],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c3fdcff24803ec87a3d03b22c5bbf3dcea288b8b18b07c77556fd5ba9d5f32(
    *,
    description: builtins.str,
    hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    name: builtins.str,
    sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644f54434171615990ba3256a94b6a68e91589f3983171b9dc27dd5a67778bb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1388c84b97a8cfef3e521e097baa4cea20edb1e625ccc0f565708927ad33db(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70070952e257e49470179dcf96572b5a87ba1c2177860c1f0b5903f79def2495(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b123ca21e2e647a83be4e966f31cb49de153d0608bb01c90a1eb61e6286194(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f4a68dcfa4229fb8cc3ef42253021f45dd173cab34d5bc88f90ba56474e105(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__514735e15215fcd4fcc115c68c88509e3109f931271e497859a961bd93b407d4(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230530Variable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37462d2d5443407c44d0b1e6b697484a7a41ed6b82ac23cb0a0fe3bddeea15ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51d04f0a50d086de0defcfa2f52d765d58788e28348c6b2c4e4ab7148f551dd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51343a6534a9af8f6d63c31a874672f8645d0f8d0bd1a3d4e0fc978a0ffabb2d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9db3190c3575ad5921e1b9ad18fa8847d4e620308d326fb3a563b0ce2f0b7b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c220bf988e815dce83b0a0f1fd8e34891e2f97f1d5e2e7cc0cf5d285f72027(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d87f9c5319f7a0ef69f7091581af7cd7ed02a513f93f15647995ecc26c5d72c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4950d577f9e13b8f33dfd195043477f97fe6e8e70fc884f767cd3a59874d9465(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230530Variable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4f1035a956264c98f89a72a77657914ba49eb15c7dc234366dcdf1e0073f0e2(
    *,
    name: builtins.str,
    advanced_override: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior, typing.Dict[builtins.str, typing.Any]]]]] = None,
    children: typing.Optional[typing.Sequence[builtins.str]] = None,
    comments: typing.Optional[builtins.str] = None,
    criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    criteria_must_satisfy: typing.Optional[builtins.str] = None,
    criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_link: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Variable, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c8b49b5fcba06c7e8d7f7a66f97e6e4fb0a1dba46eeb769b56d0ffc28f57c11(
    *,
    adaptive_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    adaptive_image_compression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression, typing.Dict[builtins.str, typing.Any]]] = None,
    ad_scaler_circuit_breaker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker, typing.Dict[builtins.str, typing.Any]]] = None,
    advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    aggregated_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag, typing.Dict[builtins.str, typing.Any]]] = None,
    all_http_in_cache_hierarchy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_cloudlets_origins: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_delete: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_cache_key_sharing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_downgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_options: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_patch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_put: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_transfer_encoding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding, typing.Dict[builtins.str, typing.Any]]] = None,
    alt_svc_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    api_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    application_load_balancer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer, typing.Dict[builtins.str, typing.Any]]] = None,
    audience_segmentation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation, typing.Dict[builtins.str, typing.Any]]] = None,
    auto_domain_validation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation, typing.Dict[builtins.str, typing.Any]]] = None,
    base_directory: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory, typing.Dict[builtins.str, typing.Any]]] = None,
    boss_beaconing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing, typing.Dict[builtins.str, typing.Any]]] = None,
    breadcrumbs: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs, typing.Dict[builtins.str, typing.Any]]] = None,
    break_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    brotli: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_ignore_case: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_query_params: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag_visible: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible, typing.Dict[builtins.str, typing.Any]]] = None,
    caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    central_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    chase_redirects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    client_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_interconnects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    common_media_client_data: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData, typing.Dict[builtins.str, typing.Any]]] = None,
    conditional_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    construct_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_amd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_dd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_large_file: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_live: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_vod: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod, typing.Dict[builtins.str, typing.Any]]] = None,
    content_pre_position: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition, typing.Dict[builtins.str, typing.Any]]] = None,
    content_targeting_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    cors_support: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    custom_behavior: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior, typing.Dict[builtins.str, typing.Any]]] = None,
    datastream: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_hmac_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_regex_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_substring_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_variable_extractor: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_default_authz_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_dev_relations: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_real_time_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    delivery_receipt: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_direct_failover_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_async_refresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_prefresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    downgrade_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    download_complete_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    download_notification: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification, typing.Dict[builtins.str, typing.Any]]] = None,
    downstream_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_web_content: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_bulk_upload: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_database: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_dataset: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_object_key: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_connect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_data_center: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_origin_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_redirector: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_scape: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_side_includes: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_worker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker, typing.Dict[builtins.str, typing.Any]]] = None,
    enforce_mtls_settings: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_akamai_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_proxy_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    epd_forward_header_enrichment: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment, typing.Dict[builtins.str, typing.Any]]] = None,
    fail_action: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction, typing.Dict[builtins.str, typing.Any]]] = None,
    failover_bot_manager_feature_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    fast_invalidate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate, typing.Dict[builtins.str, typing.Any]]] = None,
    fips: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing_plus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus, typing.Dict[builtins.str, typing.Any]]] = None,
    forward_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    g2_oheader: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader, typing.Dict[builtins.str, typing.Any]]] = None,
    global_request_number: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber, typing.Dict[builtins.str, typing.Any]]] = None,
    graphql_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    gzip_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    hd_data_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    health_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    hsaf_eip_binding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding, typing.Dict[builtins.str, typing.Any]]] = None,
    http2: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2, typing.Dict[builtins.str, typing.Any]]] = None,
    http3: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3, typing.Dict[builtins.str, typing.Any]]] = None,
    http_strict_transport_security: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity, typing.Dict[builtins.str, typing.Any]]] = None,
    http_to_https_upgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade, typing.Dict[builtins.str, typing.Any]]] = None,
    image_and_video_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager_video: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo, typing.Dict[builtins.str, typing.Any]]] = None,
    im_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    include: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude, typing.Dict[builtins.str, typing.Any]]] = None,
    instant: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant, typing.Dict[builtins.str, typing.Any]]] = None,
    instant_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    limit_bit_rate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate, typing.Dict[builtins.str, typing.Any]]] = None,
    log_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_personalization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_rerouting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting, typing.Dict[builtins.str, typing.Any]]] = None,
    manual_server_push: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration_quic_optout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout, typing.Dict[builtins.str, typing.Any]]] = None,
    media_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient, typing.Dict[builtins.str, typing.Any]]] = None,
    media_file_retrieval_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    media_origin_failover: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    mobile_sdk_performance: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_via_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    m_pulse: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse, typing.Dict[builtins.str, typing.Any]]] = None,
    origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics_wsd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_ip_acl: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl, typing.Dict[builtins.str, typing.Any]]] = None,
    permissions_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_client_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    personally_identifiable_information: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation, typing.Dict[builtins.str, typing.Any]]] = None,
    phased_release: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease, typing.Dict[builtins.str, typing.Any]]] = None,
    preconnect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_content_delivery: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_prefetching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetchable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable, typing.Dict[builtins.str, typing.Any]]] = None,
    prefresh_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache, typing.Dict[builtins.str, typing.Any]]] = None,
    quality: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality, typing.Dict[builtins.str, typing.Any]]] = None,
    quic_beta: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta, typing.Dict[builtins.str, typing.Any]]] = None,
    random_seek: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek, typing.Dict[builtins.str, typing.Any]]] = None,
    rapid: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid, typing.Dict[builtins.str, typing.Any]]] = None,
    read_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    real_time_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    real_user_monitoring: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring, typing.Dict[builtins.str, typing.Any]]] = None,
    redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    redirectplus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus, typing.Dict[builtins.str, typing.Any]]] = None,
    referer_checking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_query_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_vary: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary, typing.Dict[builtins.str, typing.Any]]] = None,
    report: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport, typing.Dict[builtins.str, typing.Any]]] = None,
    request_client_hints: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints, typing.Dict[builtins.str, typing.Any]]] = None,
    request_control: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer_extended_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    response_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    restrict_object_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    return_cache_status: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus, typing.Dict[builtins.str, typing.Any]]] = None,
    rewrite_url: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl, typing.Dict[builtins.str, typing.Any]]] = None,
    rum_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    saas_definitions: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    save_post_dca_processing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing, typing.Dict[builtins.str, typing.Any]]] = None,
    schedule_invalidation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation, typing.Dict[builtins.str, typing.Any]]] = None,
    script_management: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_content_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_streaming_prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    set_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    simulate_error_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode, typing.Dict[builtins.str, typing.Any]]] = None,
    site_shield: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    strict_header_parsing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing, typing.Dict[builtins.str, typing.Any]]] = None,
    sub_customer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer, typing.Dict[builtins.str, typing.Any]]] = None,
    sure_route: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute, typing.Dict[builtins.str, typing.Any]]] = None,
    tcp_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    tea_leaf: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_customization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization, typing.Dict[builtins.str, typing.Any]]] = None,
    timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    uid_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    validate_entity_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token_for_dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo_standalone: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone, typing.Dict[builtins.str, typing.Any]]] = None,
    watermarking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking, typing.Dict[builtins.str, typing.Any]]] = None,
    web_application_firewall: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall, typing.Dict[builtins.str, typing.Any]]] = None,
    webdav: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav, typing.Dict[builtins.str, typing.Any]]] = None,
    web_sockets: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e5373c83fc65b0f2a83743bc9e7047f229d9002912dc14330605cb0aabd9341(
    *,
    fallback_action_response_code_based: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_codes: typing.Optional[builtins.str] = None,
    response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_delay_threshold: typing.Optional[builtins.str] = None,
    return_error_response_code_based: typing.Optional[builtins.str] = None,
    specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33cdfd70bc2431f54faf10720739b4fd26d3adab4c216f1dcf272c6a52cd30cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbb555f35e51a8ca39ba7fba70d0a6153f8d6c38c0ffbe1d43c0500fcd89a11c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87f1eb6c3289dc192f84ca2d16e75750a223a63e9ad8a4ba71b469ac32a83738(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00345dc097fcd1403154dc5827223efc4d27e29bc9e7d337d01c6bd3757048e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c5bb566dfa17cd450aa8959376f7628ac8f03b21dff1a4a05de8812a2fd19b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11328230e0251ae49b4d2da804cb34cbd63c7722b4ceb4e4eef2462661ee8a6b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8381386f90c226e8a6325d3149825139db8684ed2dbea3d31233fc9ca6ab6eb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c4c8e0a8637eff8a7c16b41a7e1be8f8be2dc54de372beb1ac62f3e1323e4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad77164588a2002ea8d80a20c89afb9098fc2d12fba849da2910d30eae469c53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af5b6c0607eef58c425c0c9cdd8c329cfe9dbd5c73ba874586bf0da31d8ab8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e50ab4cd50eb9db6089d0968034c432a5dda19bfdb9c5871ea201eba39ff4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4438b133b42b4a152b5f15e3fff636c81f235042ec0c07853848cac7e5901e3c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdScalerCircuitBreaker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03601407b056a1865d07dd5a723267e303cc17fca8d4c326014c1482eba3b12(
    *,
    ab_logic: typing.Optional[builtins.str] = None,
    ab_testing: typing.Optional[builtins.str] = None,
    compression: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    source: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_brotli: typing.Optional[builtins.str] = None,
    title_http2_server_push: typing.Optional[builtins.str] = None,
    title_preconnect: typing.Optional[builtins.str] = None,
    title_preload: typing.Optional[builtins.str] = None,
    title_ro: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e911a7bf40d5f6be1c362a10916cae5dda76debc494afe0129709b38f24b383(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e05afa5267c9dc2280ccb3ab28c010adff4d7b1fde3360ea0b3bcd50625daaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6010752efcd2997d22b85fa646e3a1ff272a0d703c8d6dcf098a34a996e32ef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a566ae8d8eeed22eb569db3a17c4bc9dc82df5c2d115fadd701c02ae12f1ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c521b01fc470e7bdedab73adb9f0643f25cc1b517f40fa05d3c3bc018c7d4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10bf505b721e178b51b80dbd654fa6743de20f2c187b130909eb7f5656fb15d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36542b6b7b438fefc0bc91f965e55688691e13da4cec16aecf3433d9d31f8fcc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6e770b972ba7aacfaad86e618ecab567e79ad1f95fcc3b5c8b52bc1a6f52061(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f9bedfe639b360ae665c6d556bc5b2606d2a82597c1d588461ba6e16f5e155f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4c0a80e6aa1a656778c84ac8ac316c4467fa989766f55090f60a352d966680(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67378a377c5441894ecb1c7de1e77eb7d15b6d5978e02e816ea973d25a8e79a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488c3788035191dc2d3c0c195d482ae809528eea582a0d86d8d5942b3e17a1c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1502524740759791789081b1e40e06703c100273c1c10316a80f08267445adce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6363945d40f0496ba8b54ba9a098c5eabd55be6cab894e326cd8e85ad5fe963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c4bbafe35c13dfe62376d5da8c83a432cc51f72de2b8d5662f6a366a29262cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc5004cae1cc3b5a803aeb76660689bdb214f8286bb1bddaedf388c7bd1394f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96e7c1578815f4974bccc1289bf889ca22da425d4b4dd37f1b722a25a64c767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__076075ad04f860b7d97986e3b338629abcb78be428d8559e99f88abc3d23fbf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1308e9a7ca4daba6b3bfb5f25b1bf21574303e9deb99f8ceae3d4a3216b9b377(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9bcf44116e7d140ee93cc2ffbc3a5eb76200c9a6a980f385dd80a30c730a090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__334b05075cf7f69d7cbaea88f0b5cae0037c642cbac9cde40df1ece891e68756(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cebf18d475f7c002f80c62c1901d7a2c04faa29b99c0a6ecbbc749b94e175baa(
    *,
    compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier1_standard_compression_method: typing.Optional[builtins.str] = None,
    tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier2_standard_compression_method: typing.Optional[builtins.str] = None,
    tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier3_standard_compression_method: typing.Optional[builtins.str] = None,
    tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
    title_aic_mobile: typing.Optional[builtins.str] = None,
    title_aic_nonmobile: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da91c89a6409044a5c680b8d887775d941320f43c1663dca34ce74c4127342b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__266c03a7ac3ff3e6a4e37c3e139080ce3207c243a54a7917d3fe36bf44e07098(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36a8e10c11ce995c3a49e5ff40798e3cf313a6c39a50e5c9114e5224f2b0ed7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127fbf22484b36523c27cfd7b514ff4298e39df94de2bedb0e154b7f1bc7361d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241a3f387365a107c6c0efb38865ed3ce4197ccb2e38dc56a94ce1a83cb0b596(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42e97d158edcd0b59fae51f0016e6cda2f1707ca9306595b42969f8c118d1c04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed6da36f5211bd5d705f74f99ad4aaef3e0c088deb2aba75885f4dcd522d62e7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbf5d97d42d39ad8deebaa4632401f8e5924870de7d9d9250d985d0e8b99c16d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9b375ef8b897fe41b77a2e134fbd67cd9f9296d8cd1f338783088aac043fb91(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241759cd34e8ce0eb9bc198e0f45e9c7554492f4720e026f476f75c4a9a4b297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6630aefc244400f8d71d44ae6739eaa258b38e54515831890159dafe0e49e12(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3cb3257374e20f27ab379e2c7c0b7fb1fb9dbcb029c2b86e3138575bd9f4dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd65545a72efe4ffae111af8c2420e8668bcc815d400e34109496f64b5e4304(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a6f2589ba602093670a296e431026e5e10ef3a225e431e475f16b653d284bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c82361e47b4c6b0484d5592b83cf2312e13b479b57892ba12cc2dfc0ca62c91(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1507501b7371b3b8aedc2742b93f3a9a4fdb433e6c5917c3c61123520585c7a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e02748b16ef4b940b37a29bcb1f06b61ea1da9674e2b7066c087b78d1981c56(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be93ab37c6483bc7d2ab9f6ec56b00eb442e733fa4717d3b540947d0cfd1ae3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed33de33184eb40a849e85c27b98d1d359e1a042e762a23ed671c6c4f3b18be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a67d935e747f0f04dbd63fdb9d91f1d17f7384cd59967a3f8f935b50305de4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2baa818758fc20d6651b4212a172d0523787371fa668219895223780fe8a7317(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdaptiveImageCompression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969be3e324a55275910b78a9f4af967838503dd827b894aafe263afd4d6cabf3(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d26fafbebc2c388f795e475d9634dd518a12773538b191cfedd3d1a24cea9a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8ccc2107a89ca7e9b96d52da43a31f4a6d046cfb64da841bf178f0dee24c09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9019cf6a5d0dc5a8c1faf1ab44464c84447f54a3a1edee1a0c2b6c3765c603a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3239109fc28a487da48f61796d06e26c2d7abd65e160e7bdfecbc5caf153f1cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa852049ac9d3016338c0189c0b60b7ca62ab9ca5a8f3cb4d2b6e21a051b5e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0f3f16fcf40e4d87d60171a516f4bc72d80f826bcd73caaacd4916cda08b4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64b8172df0f8bb1ad7a4b142cddcedecd40e3aba635ba925a4e8f508d118e3f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df11c524af6c98992f9f1a929ca163fe9c1df1de23b95a5e62bdb7f5a3232e83(
    *,
    attribute1: typing.Optional[builtins.str] = None,
    attribute2: typing.Optional[builtins.str] = None,
    attribute3: typing.Optional[builtins.str] = None,
    attribute4: typing.Optional[builtins.str] = None,
    attributes_count: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    report_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023f166189afb2984d7899c436028b34d3111c44b409022519309dd041da17a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3819c4ae8161c6bca4a2b19efbd827d9e45c30347468e81746a0674803a42867(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8482fa6d1782169c54828199f757c5eed3a5d9798d82930ac778590517f44aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e19b015140278ff2fc7d0c2720336b1a47c5fc11c7b487fe44d1d33d91889d83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e834c5929c40a82a1a037b6599a6a3c8a4e4421d66a8000a516be7db0f293e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef927777e3030c5c41b43e7ca2c464bce588d4a368ace2ddf30bc070b8b1702(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df16c5c485b6f2dbc268fa3cfb35291831219f378522d4e607731ba2b05012dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be1c043322340aeb4b95102b8beac7940ee00cdc475a00df48a89e82df7579c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38a468e3c07e5ff879c956ee1fb288e1f80757e131d490f3fa34100decb8bde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b927de752dc263d584fd2243129c0fc1e5e1b38b285484cd675b35d0bbf6ecfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__874f91f7d1eac42f04b7d2481fb73aef35421132e96efe21edd57f2c91898477(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208191ae921f2781edeadce05475020857cb7b3e01d1fbcf397e6ac09340454e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAggregatedReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7792f47ca844999a6349af91edd6a9aa756b4f93ae9b987ba183c12ff89e6389(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fed718b598ead6d1e523df8903128dfc56e87bb20755e8799089c3e1f77a0c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a69ec409d10139ced40fd870dfb8a8019ceaccaca9b43c5e1c37f87968a4bd90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0320db48303843799236539e110a125c27dfe902284d0d90b5ec5d084df1685b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beebfc94351e7d6c9ce130d601df08d13d5188666598a44aede78420f62f9044(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def0aa5a67729e3a8643e4ed7078e40b9a967bb248d50892d2812b2d02afcf2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3883910e8721fe376ca9a6340f1c69b4021630f07421fe9bb03b177493aff3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1610e29bed0758940426f9b07c5400da7a681a42ca64dcec10a4a101490b791a(
    *,
    include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_hostname: typing.Optional[builtins.str] = None,
    replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    replacement_hostname: typing.Optional[builtins.str] = None,
    scope: typing.Optional[builtins.str] = None,
    tags_attribute: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c3c0e10100a34b7ede4e4e5a2d6354e606a2e3928285f24bf2a4a8c0edb634(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd74ed4cbbce5761dbfff1d707156c5f62a5d8eabab3735f4a070a4be6045ca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a48472aa4a645e7860853cde070b203b52f29f1763008f0293a17c51419f20c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a8f6d924e2ecaac10f0dbea7f22c046df3f5f62790aecb47fb782c5faaebc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0665cff6281c1f558f4f6eaecec4059573db855685f9ad2ee7995698ef90c2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4193dfaf2d71bfe24d7cde7aed4cf44d15b60cac2d58ff1ea3baba280dfce4b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d666cc1d2d4239913ec88bcfe5859d21fc9bf16393f0d1515168109e859b04b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23b06489b395756ae9afcca5a916aa811c1eb6e9e6996c6f10b96a8850d94be5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efe4ba885a3e4c4cb086cd273ac1b3665aaaa4a328524ea2dd23141062a3557(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c0815298db194d9d4fce8ef9449b89f763baf911e3b3766768f04c05c73fccc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b1d96c0f0cf2b09ffdc90d637e1e60e5ed9e3e981b377e6637de2708206027(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAkamaizerTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7ad3f9074f731a9aa4839441d04519e7061d6c43b2fbe39a3d0c463f829a979(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed2e695d684c36d23b888c64a690012c3a0d7b217f9c483113bc7523ffd2f40(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7300e5e4192ee843c4b668028b55b86f42057944b84915b7ebbc02eaed7c3b0c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e5045bba833d05aee7813fe72e81aff84a29557331f4d2427f057541f61e29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b16a9efafce966d6b59383a1452471739d14bf88cd1b549881a1c8c094ce5bd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337347996b626654750b418f13e3498a97605c8fd0c8c93aeeee66d9dad35d14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__023e6d42250b1c280f2980e0571ba0a4f6ac240f25ba4699781263fad5e866d6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllHttpInCacheHierarchy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db4dee9fa4053dadd519fc41967684d3b5820d7a9a5d1aebbed60c62b2a7c5e2(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_origin_query_parameter: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__118a42e969f824320a4812fd7977560bf4ea5533bef4dd4f6a1cdfccd28fa46a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c77de57815ae579be9c28093c21e35d3c72081a744c98c24de3b47bc105c584(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c10e85810e4915f88335f23658eedb7f0e9eeef534e1052d64a9daa5c765ca8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af05c2798ca9f9b53814bceba14dc56131425f5eb4288f1d3b566a7e0a2f8397(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1027503cc65facbf6027d92fbb6c94bd9b4da04a4cb2a901d15e4a93820dd69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dbf641a9b4c01cf534698ada7feb4afe0a3126666fcc20afc7b2e4966e1b26a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ddd61c14e0ee48510cbfbcb3c65782563a0fac628bfa8d84787e4e8a53398ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db61597af6f5c065a3ddab30ed7324a8fc89e246af580a343764504db7d53275(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowCloudletsOrigins],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de222f1e0f4292db569526df9c48a2e3616f7ec99302c11003610f8688b33c8(
    *,
    allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936e26052b2cb208d2b2c49cd3c02ccda3d62e6c68aa439fbea74b605662ac91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d481dbd022871ad8cb12b92750d5141fe6e93b9b82173a7e99637813b63c5a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd73dd4a474de5119672b7ebe922d6575f9e5a0357573efb0fd134edc084fd8b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01911dfd2abf2d54d804c9ca6f3453c5dd2fc907ed0db92fa67122447fc6cfa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__747fda052648b2d540b7f083c7313c6364319e44c86b82a18dfcbee57b65b505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59eefd4392a9cf39879b04bc78a426d906de79ee2bbc6a356a45cc9140f08076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49833cd1a50e3b52ed5ece355c68efffd6c8c80319a60d62ba5ab1589457d9a7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowDelete],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__335114baf35d251c3d365cc70c0dac3c78ee04a4e61434fb2764c2145fd7646a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a8b1823067e45c027cb0b4dcd915ffe02d57b9c768aaee22c1f296adcc0792(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f23e54ec4dfd78bc22cb60b2f5468a1ef90f0d3ecc021de5303e53b0f305d05a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6140e2d8abb96c8ffe18caa76a4079fd5f7936b503ca6341b3b0ea001d21f1a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c8dbd364e8e26308d911b9ce38c55569a229cfc921332e895d2512f6fb8a257(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb0213dafaa9d7ba1aeb25d60311bff70023283653a00cc1d3a4e548892e083(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b58e7e9673ea0dded6069e46c4df006fb6b16f12ab183c22e58da682b377d3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsCacheKeySharing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a48a0e83f95f0c7ca260e7badaa05e026b2d0949bba62a3c4539eb8644c33736(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ed03c8e5368dde30d1b60e084d3f7a08dea3e7452abba5866149ac8b3108fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15738793b5194c14c69b6a7762d246f17df40a4fbc19b251ff18de5b26c8832d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0275f9ab98f0b6b8d804abed312e6d1eb4b99cb67f73ca8c9423d58819a00d3d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426c7e6fc9c2c15d40a9d3587f642ebd088d94492e055056d1ee478adef597aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1373a24131e0fd90bee03c603c0355b1c49742ac8a80cc7b6813cb338bcea88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0466cb53e38ea37da6aa93e4b39d5405d6d85491d4b2b8822d153b3136d342be(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowHttpsDowngrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__840dae6eb885601a149d8b9602dfe36332b0b9f75334fda471d9e08a99bc4fef(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728407044625c926d05582c69c935b90681bc71b504731fae21a0a0a2353731a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b587ad3087ec3803c1fc8d9c141289b714d3f1e8b7437519b91de07c7837f161(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__030291359415a6ed93fc23da87a907255449f8a147602f73eb5d6b19773cb57c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eed07ebb4b7e61cf5f3d13595fc5bf7a5c24b7c63ecdee287df6e794d6214a67(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090387589be191e85f21839e9b8744f58d105032ac416cd24493a0eba10cc76f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8662dd953fd1f2b3af546f856efa3019f8fd41fb65c9546b8b57b1e99c487e14(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowOptions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14ec539aea7c20e063a9bf899459fc1cf91b9917b4ca3267bf313a1bfa19caf2(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b5f10395c0c302e94bf7c2ab6bb8d2e3aebd4a269822af42087701c97852aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ad846835982be5d4a7d5d8d78c8de6963c23b26d1befc375e02e8425d3a407(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e40a32c85b09ea3a3a2f274f2aa05a5ddd88b752f8add5eb64fd1f34354e4379(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b60a5261d4dde7be86f4ea77af914e65df77060adf9b53d1f883b5a4cf7333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a1cc00c1702832dbeda11efa04fbc7b0881a199265556c6e2ce1468f66aca8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234284ea468c17e99bbdb0f68e14f912801d28094895e1a79e8a5c03de5baf7b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3044c68a43f989f16266d5ed56062373db81c1e1d33a63c59a47af237af4747(
    *,
    allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb90db7b8eb437a88ac05c794a5db9b33d13ed32515c3ddec653b7c6e5aac01d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c7d611721cd6a0b7aab1cbf4d62071bc8a1c871784de7dc00c13a57a9afc1a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aefdaafdadf5378e3aaf26ef0f550493bd0bca0aaf152ea1a0ac2892e6dc5c88(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361973cb78bd31a5fc2b6aa53100dc78288e6e2dc005fca7d36e2194c7c29a26(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17e62f193fec1af248f8827201c98d485d09bb0d89f480208213caab45ee5f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b54df05f2a66a22722b719efada68d50c39c33162a80fa81706818c5ce78ca4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d7d8f9bc2154a8fe7dc41d9446c23d638df1602c1fdf7772c5267e7001ecc08(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3565981b331d4d35f76c14fa6677beba3a01277d6d8196777b37e04240d52f3a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d4c3363ddb2f44d8537f9caaf78e102a3ee8c750cf504487e4d489d332ac20(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8051069463c60042c23d4a6ca6ac6ced122add7d07f59402250c2f1e6e29084c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b61898e8fb7aad56f2336d75376c6531aa4fb48349d5c79f1ff2f4328dc797(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__630400080dd24350219d0b0e57674d9498730556df799206b9f1bdc351c85067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50438f34250a78581544aab5ca9494512987ba71374f6cb143b4873e7b0733eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bcbf1cdb663f69640aa0ca4afe2178dcf60c9342c33247127b8698f77b9eb3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowPut],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1d9d2e74cb2e54b049922ff44987744faa9c9f7ea192494563b6d1e2dff110(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8172cb505082862e359e2f950e136846c9ef54864b238049cbf25afecc1538bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154755a462b6d25d6c44f06b128e0b33ed764269d6e93ec72f6817d9f0581481(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75c06aec69d7f4aba78ee1fc7a4eac5f139836441c10af9c755d789db8fab3bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d721dbac9b9fc3b0b5416c76f5e668a324fc72a2d639d21d2a78a5ada2d6ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8e96ffd6023a75ad5b4d0f5ad10968c673b896f553e8317aa16bda9429bf51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a8ac0951405e3123631b1cbe651360393dc44bedeb9f6c2561fe6ffaff4f7bb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAllowTransferEncoding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35fcb5690b9d7a8b7918fdfb9f620ef2145788734f15274b3c318d64d59c053(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__868719e38a6349c2237fa53450cf6da724a51d3fac7399d2d07452bba9514c78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddcde37634ecddfcc7b0029bf1053f4b85ad2c94ab12c524779543cf3bb4484(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c487c0386cc4fa4d798ca66a335c5fc13d2a1e00a5c21802c67b80fabf8c9392(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db45e5eff8cadbf20153bb5d8a8e69a51f9cbfcd9e9d82f3ccabd7b868fd5151(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88f70c83ff6e38ade7ca84956a4b65d4a63b1c016a8301f17e83bc866b1f4a7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd74121c1000f20f31378ea524157ff2bed5b2e1b695ebf57c6c5d42c79d468(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAltSvcHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d534cd11e3bff977f2fd760108d6b088f9253446f0b0e8eaee7ee7c3c9825669(
    *,
    alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    throttled_status_code: typing.Optional[jsii.Number] = None,
    use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4070c66f0a617f05e665141b3181e8fa80c66d8858a9c7a1056f01668d5f3d6f(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294ee4fe1d91089ea8727225a060be46e5c2849fe0276669a0236560a6acae5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be4ba69c959ea536b6cd0aa5104c61d44b417df0939f6d1578beb17116d39227(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b628e68980a14004e5bd4e841d20973970cfb54bc9d053c2e26823c3522fc50f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2103a8eaf7548cb78910fce4f23cd41180f59304f261a81d1c9981c8e33c3017(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9742d9c86a284c32454cbb2e62da65d61b0372502e2e619444526b2fc5ad65(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e343ef79b5e0fc77a7bf4ea9a3a5db06443f0cae9841152de9ee7758876a503d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__776787ed6acd819cef9c03cc7d72f92aa401040e27d02334ad030ce1c0787296(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cedd902b57a42d60f58d0f5efbe3ad15e426d112d018e52ee6acc8c4b5d4575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fccece3647b047f4cad52555e37c6c71b8f741d8a6bfb49bf687c720bd1e3fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a7cc571e53fb5d1ef57693e1ab45f258298e233bc8d8897f7af3b3ce7c9e648(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd51f14966e6dc76ea36fe48f4f2bf4849fac7770e18d76096db0f81f4020593(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55b3beb1ae3ff1356f9816db6e36fe89b87ddaec56a5b2035446e87e037973ce(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffdbe970de44282411cfe71bbb6fbbd05e0f2c8e7555dba9dc596c3e18595ca2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b7a7a410326bef015dbc146486f931bbd53b32a3528d61591f254dbfa01ff34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ede6ebe0e1c55fc007f6398f283174191a035a0c585fbe6c30e9c83fa6abd3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0566e06c44a226cfddab3c00eaa6167f92f1926abc002f6d00971a13f948cabd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468b59062fa8d2a4b6f27ba6680b31c0e86226fb3f7467fb9e68f78df4da6dc1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ea54cafa4e26c6ef931c7e1956f16bfbb3794cb889e2b0aa4aad477076ec79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__568fcc8d65cb8fead5206842faecbf9b80c9de509e62e7dc1860da0a09fbe20b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411a3efccbeae49e9a430efa6b8cf91c7daf6bad6aba6f85e0ec7bab90c99910(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__146146c1b5a2fe2e3eebc733558dbfe7521cdea6152474f2418431c2cdeeae38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f2977c1301651398a1d68b5669857a4617e343da5aac13669f861d784367c5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e12f4bdfd299ed77892d5a8834e9b5e65165548e8318b361a05d7b7151fdee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4e7b93b8ab0cb33a4dbc911e309baa565aa036fae8040a53e5c708c4e24eb2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186c944451d8af309ce50a1a2b7f8ac6782f1286585e9dea93c45816d0d60c70(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efab04957d8ab57a46ef4a39d3ffede6ca0f45381f841d0ab8c1230ce8ac2fa(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ee1a6d0cff17689535841145841eb69fdf7de44afcaaa91a9f610292fdf127(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c9b834448469407fb353fc06752994773ec51bf76cc766f5e00f80af0c43c9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d90bb0594d7be2ff97d4d89df12bff7411ab057425b6d338d5e779fbdb04b95(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__594df214aa12ebd0f8370d4755d302b48e93d55fcf46737edc23aaa8dddfa982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8234918835ca6aecb50d852d4d41464648fa6ca5e1b66613c6eeec490008bf06(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877b43bba2f82e072a3c12dd55cc7ca19d48044197c28adacd0709d8ec30dd4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7df5b285229483d36db618e813ce79921e3a4665b4dd4dd23a9614fcf7c149e7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ef9ca177f9871ef6a0920fc66755431b6dd9d82004ec9e14629f2b7b3c7919(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f956cae1cdc91e1bc5759d68b6d3a8c6042efc43a105bd9e58290008b7cb31b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__873cd21138524d90a4def163f9c87c9075060b268bfd26938bef22d621797b34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6040d81d2e869e1f69053863cd076a20b41333fcacd7f1f1a9a1fc0a907124(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9670e726aa1a302a64d7d5c8c294f73f7c30f29f2a09bd8a3cb55e2959ccbd72(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApiPrioritizationThrottledCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28fd0a648c1fde1821a7fc5be70e8a387a7c5133540970ea580aead871f089b(
    *,
    all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    all_down_net_storage_file: typing.Optional[builtins.str] = None,
    all_down_status_code: typing.Optional[builtins.str] = None,
    all_down_title: typing.Optional[builtins.str] = None,
    allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cached_content_title: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_attempts_threshold: typing.Optional[jsii.Number] = None,
    failover_mode: typing.Optional[builtins.str] = None,
    failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_cookie_name: typing.Optional[builtins.str] = None,
    specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_domain: typing.Optional[builtins.str] = None,
    stickiness_cookie_salt: typing.Optional[builtins.str] = None,
    stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_type: typing.Optional[builtins.str] = None,
    stickiness_duration: typing.Optional[builtins.str] = None,
    stickiness_expiration_date: typing.Optional[builtins.str] = None,
    stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e4529b230c04b38d299fa322b36984c7130e2dd7c8f17417f1fb4aeddfc595f(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16329aced88b4e2d9df50e0d1082dc164a1f5be646503465ccd31e5279096bb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4911f567cbfec33b0bf42a25eb5eaa7f71a231837e494b5f1226cb87fc75d4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b043c173dc55cd5b2b24bedd19807575ddc987cdf5caf620ba874bb797a37c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efddf52a522b2cb933756a02c7a0ac66ebca2a6e419f6dc72cdc53f45b214b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7f3fa3ac0783f7a22859d62fd515322f30ea8ac1c9e924fa33730e09143d72(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerAllDownNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067dea485177cd04b3478bc5bde94a74ccce9587857a2760292a4d8ba2e539a0(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c14d5ccbc61e968f6423af849caadc60992a1426f46446f7853c725318c8377(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9bb590c23ea69391a7d04f0444d1462f2aedd3be24eb19bf2d12772a9dde2ad(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90cb7080bc743e8dc22c2ac4ef5a4d26804f8109424dee6fa914b9bf163f65b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__100818b6c8c82fdc472ec2ac7ec7330d2607a30b2d0d1db76f4fd0c56c2922f6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069b99e631b2bcadd4e5a4949b2524f879de989fcb8b196dac6324893e83de4e(
    *,
    from_origin_id: typing.Optional[builtins.str] = None,
    to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f628617775f5ad5f1b56468df454eeb6fad449b8836fbf4ff7eb654106d60cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a0a2ee407e4d8b62ef8bd52d66c22d6c91f0f7cc109c0062f2cda0f64a37ed(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9098116fae2d35a87b9c56786d1898485700570ef10be32954adb33ab6bbd2d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fe96ce31828e4f74ccca3284c3678e9a5b509a484e16071182bde8134d0b0a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a80f62e40319cf1b7d54f6237125d41d026f654f601897b117cee92be70b248(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81edc50c5bbdb346396f58d96c0e82ccf608595afa74a6690913817fc6094d48(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b1a81dfbcad24021cbfb70070a2f9fd0fcf2b54cd7a3b59f28de39f8b891d58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05742617cade4d3d3d5a65cbd404eeb078ef5559b21c8289a3e1f6bc539c4ba0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6e7a871cc47f7da7f27e3d93832290ef0b49fac2cc5becca354462e769d18f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e70d543fb5804092d7f912eea23783d3b19e4c7641b856231056793f0a253316(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f720d7bd52979d967b57da0cba59febd95d3a901dba7cc6de9b2337fb7156ae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129eef7cd40213f09330655f6978c7f7cbbfc216f1bb8a42f6a9bad2392fe7d5(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__967f3291e49f7b6ec11698450838210482c18a6d12fc45d91863cb785e9cec90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b93a2f4c8a93ca86ba1dfd25e6823b29d82f192a1af8e2198deae1b27f087c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4582733f7675964a3de9f6c7935c5c0a10752ca6ade13c37d1896576981b33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeef2518af2b2a79e7179475f1a26137faf1ff8aecd6a8fbddc7821ad5a47870(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8605573bb4dae9c1586f070d77bb433147b6c62d8c7d080139d3d6e4433c9fb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d2bf0b5d63782eb4a24b6a2504723c749b1804315a99dfd445eafb07375ea6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e553a6571b324ead71d5f8373391b9a21f004d2bd51e2f5c0f7c4998c67c97(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa1c7041989b248b023ea3dc6d887b922b947485221b4f8bde83ddd60336378(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c14cbc8aa6ab37bce76796cac6afaa589e0c596a8500c0c09029391e9bc2bee2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fe6f4aef13ef2f75add87803aa25f2c4719f09cd8aee04a62cc728be945fb77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaee08770eb9bcf6899096cae0aea714ad20fca68a8a844773e83289b8cc2c49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e9be3bcd6d0bb80642d3d895ee178c3f9439749765f08e4e5d1aa2ae0eb50a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e5b743bdee50fe38170678c9e2b77b9d25a8d1b495e2dfc0c79bca6b25e1ca4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85f5ea753ba382c4abc635e2a6339425c886e61296fbbcb565561d69c466bff6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb95ba48f18b2031d5568eff4a7cc1d9fad74a5251d73f8cc2eb6545fc36c97e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700ee9687e9d90d4822b4e8b72c26d19038c5d6503a5bea738e27c8ab1862f60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__278fa41cd4963ec6d00b11beb2f85b7d1ce2289d3fafa9d864554339642c09b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa752b4b40543f3af32d50f0d4228f92a24ff49e0bb42001999d89780a0992d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec123d2b593454d7d88c0a9175181e1ba62f790b8e3af29574ecc7b7504e970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6fc0b2e33cb9be7568219456e2ff933c7c00e76fd142eae3c7c1ffe5c211c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__627ada9b90c4471816396ec7d5a828c0ac839768edb293ab3330d1df583b6bd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53f2378566e65068fc48fbcff447c9c30c6a2055aebd53e9300240fe26823fd7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c3746be4d37dda71d390ddd1c306cef68eee0a5aabd960d89d448bd39afbc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dfb76f44a9b40c115abdb51c598c473d4705167b8654b991d7f1e1da72abdc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93392807817c3569920054a9192eb74299655bc8765bc2b17f9672e991c9384a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf6f07923c9018bc00785577a7ba22959f59d694f2c30fd93fbd302b22c91557(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorApplicationLoadBalancer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24442b7d7ff3e1625d2e67d723936a7402f18175e282cb77b4300da2f5a50a10(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_domain: typing.Optional[builtins.str] = None,
    population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_salt: typing.Optional[builtins.str] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
    segment_tracking_custom_header: typing.Optional[builtins.str] = None,
    segment_tracking_method: typing.Optional[builtins.str] = None,
    segment_tracking_query_param: typing.Optional[builtins.str] = None,
    segment_tracking_title: typing.Optional[builtins.str] = None,
    specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd299f039d6f9b18b4ff79870aeeb26fe82c4ee79bc2f6ce119b01bc18f0250(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fd10bef5b28c9842fdb75b0bf99f38de685e1e8610e1a41d2e87870f61e6d47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__317739cf38acc9646b7cfec7e66f13d09b35903666d840248e5736c34bfd96cd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd867bc1f5134098a998ba19561b757445ecfe8ad0b6db5604a984b5c940db7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f936a9e1e7b43bfbdf48889c6b550b77ac3a95d7d6ca85fdb87e0a66ce3300(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25417598eada961d93f50a1a795673457cea764b3deee5a4e47eb41c146b7024(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2293010b35a26a7ae19ae6d7198dbfc6aa6ea300618899a4900778e86b8528b2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a212b979472a40751277d19189653e037cc798662fc6ba9b0c6e737cb48b31f1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22bd860290ce76241c798c5314c2d924636b0d4a2e01cced26d97bbb29a1262c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e1c67991c26c3a632ea89e4348cfec94fb7e84faeef1d1dc2cbcb8f4b30672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08dd14774ba72b1497688901080623b6c3d164857134a7cb3ef38748d49f9f3d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b99839c1b34b2d873e4550e7dec23a654c2c6d99639d00696d98aaf9dab9110(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5389e61e925b6bf4187b91bf1326478a8fdd55eba7ce3d111e14e366ac603930(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69dc45ec81adcbf7c66c7616759447ad76898e44f17341a774dfc089b0a15ac1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e96eef9699422465bd6196e8a949a8a8a28d6e35c01a339b3e686a44e332abef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9cd890b3bb6cc4cdcb5e2611e5b866175a134aec9e9e64b1ab2cef299ec288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5058aa9f2babdc0eb3707e8fb2d7356665d8a6851cfc57e94720c6a46f823a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba38573fb08d1376bc03a4df54f0c8d7f8f34cce1caa34918eb6c1363834858(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e9fc9bbe14039b81a4f40237a71bc4c203c51c3c62232570b841a678da8fa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f561f7c1c22094fdfa1a4a86cc34dd09b5ebcb4891f473fb271aacf2004d01e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024436b5d69f39889dad4a4338ac78e16a6af5763bac9fe3af7de92fb4fbdaff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d93bab10cef1622ad99baeebb5633401bd1c8b41c6bfc6977f579c8dce9cd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02a350866d2b93a26fed66402c370f6bfea4e64de0ec038a686beb31f5af6ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b5f3c201c5a1e2d886a6d563223bc1392a2a1819ded09c3c9bfd178e2bc1a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__befb0dd81dc01c2579c1f8dc10813a23a3c203af6aa05654d4d8f2941aa9be0b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9bb8e655c24ad227fc899aa72e95cb286fbf2a5e8e1fad295546ef4bfdf90f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df35526a537e0cd58cff097d839cdc719e6feed0808f99acd686d0614ba36c85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c467a0178fc50ebaf48b22e404a3d5a042aa1ed7cd6095aaca910e6b8d7149a4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAudienceSegmentation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcee55b0d676391315d761c6282774571fa420b56c819d556148c62a975a634d(
    *,
    autodv: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368b1c756b80f81479d5a062e63b9e4dfaa9fbd4a75a2673f6defa9406cce362(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe237b2b35c5ebb551c1c26dfa0951e2c01189fe2e4fe65d9c17e9cc525155bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232d5497084e198b9aba83b02c9dab0b1a3504c62bed0653020ba4acc1a2ed1f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bdbc3eb86654e0a13313ff00e9cdb289a028136932c0610446b45edcb1691c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ae0436032bfe31e253f72a7c4a6e61c3863a8a50270a586115186c93aa4bee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca1b1dc128198d76224b342ba6fb1c78b4e2c6d62c5ef6500332bdffd1f4e9b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorAutoDomainValidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d23c77a865de5f486849d46ab37b71c9a1e42b736cf4ea5b3e7ee1792c65ee4(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2aad0e7ec9804fae281cce988586d37198f9535a36acfadc575f0642c1a662(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a932b62d913cdbb07cf46bb4c9357def73a1735e92840621ea93011089942c06(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5db6347561d33342d34d04bf1fdf82cc644924760ed360438f57abeda815726b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c4cb04074b699e1ad9546d1052c8040c9f586a80e4f672128f4bc946dce2ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d039ee1be427c501d73f89420871aeadc7cf1f269b18558b67140f36ac6b7a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07fa0cc889c89f27b10f4b4761271aa129adeeb5c242578967918f4c6ec6e28d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBaseDirectory],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f87053f107a218bcd9700d8e627f3a2fb71674732967fd7bd3df1dfc76a65b8(
    *,
    conditional_error_pattern: typing.Optional[builtins.str] = None,
    conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
    conditional_sampling_frequency: typing.Optional[builtins.str] = None,
    cpcodes: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    sampling_frequency: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c130c0d0c56a462b2a6d89e5bdc5422f320f3b3b10b71dc24e840edc7296d934(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d24b54173ee63546df0ffcc5933f0475d0b20653b2f5b93172772325537f14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d5f35a925ccaea4cb0b9b4f52ab6397d359bf8bab3b7c7d687248437e9e72f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be7514694be215f0cdd5967bd21dfee3b11412149e03ea88e0da67759d50cca6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6655c65e239df2d124f045293427229f0eb762defe826d14d0e99ea1551a0445(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5febc94a176f2c8788abe7d44a073cc3b61c416018ac27adffa35d123146311(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2018b86791dbb0254aed5213dd4955cab7785c19df2e2f9fd384361907853da9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6296cd7c3b87bddafda1c2ce95c0a2a21383e7612e90ed9048abbe9862e190ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6500be5c123e8d5c1803c48d72597232d141a0c47d4228ed51f986f2656916b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588b6fb010b23f0f43112bf9afdf73ffda5b4f8f4d1ca56583c5b44b0f48b609(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33f722261ce095f1f408b0ffd4b7166d92f721d671dbcfb063eb14c31292f25d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6b1fd749d9105c10d71f2b0e3ce4b494aa572fde6b8e7f522aaf146a160d2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b4333e88e7ba3557ecfff4550d669d94f36b770e055cb5d10e8cfec212d600(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBossBeaconing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de88a784a200eca16189c0b549447259de999f841bcd0c7e18a9c9dd43643d0e(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c53c9f70ffc0ef764efbe497a2a97a71afc92f27a2fa59813505cc7d2f4990a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd6e3b778bee8647462f4c43f500d95b30bf2659baa1cb185c5514a18f081c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03126268ae0b8f425271d2b545c1ba8ccb672d881f146daabde5e978e330db42(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a227bef5bdf38d9645167c94d8a5668ada6a1d880bec3fcd442dbef94a15a469(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfd8967466847ac2333d4105ae1fe48299ab6a263f81d999b48f14ad7d62c170(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82c54f15cb2178a7a68a710e1c0fe77aaa859bc140b22343cbfc6673ce1a7cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b82b128024b181ad6c59cf438bc08942e8250b6dfcf39758fe795a20666cc57e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cde9686234bda8f0059ce25937614b146becabdb1933e25a71e601f7b4b9514e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreadcrumbs],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161fc9e9e9668b68d8c81553ae860cc214180f83fd5274983e6ad070dd814cda(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66c9f9e981722302a508d7335b5b39480b1a7c29d30b7d44e61106a988fe463(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1871ea41d9b7a7875dea7eb1ba9c04d4cce36478a02d76ed694caaef59685143(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df73e5dd0b0392111ec1855255bc6bdc62676e62b3cbc6a651252d15ee24c41(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eec6c1b1e598899c937c9e7300070933528c92fee335aff28bd7afaf1969229(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07b61a216684240761e9376e04b425aa3d05587bda3345b0aec065dbf69e12cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6082bf4d8a6ec4ace5c43ec676498b5d7d51cbe7be4808b611d68bfd7ad5432(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBreakConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f938238cf77b798285eab4000e74e0aa2ec851eb220671a3112f75c8cbeecff(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d975d42d82d481392883a832585ab301d61986eca7c0b0458b4f90f357f83ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f4afd1da2a3e7a3ddc04c392da35167f0ff07bf4bbd440840ffe320b67d070(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c0d5eafbf780c2c6897a9e719102de99b4298f9ddb3224aa7644f8686fe027(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe737ef92e2903421334e372aed927bdc31f3cc6cd4585d6444b97133bc9a9c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f705f2384d9a369173d8210e9ca05e958bfce7ff9efc68188aa94105c52bd522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69ad59259b173c77d11fd8447aee4355fa0bd2abc9832e68833557b21209a08(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorBrotli],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5deee8fa00607b6acdd7a4f301bfb6f65b31234ae8c5ffc38ea9fc88b9d02a68(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a5221c68c0e0097c88d161f41a96f94e4ba4af764a5c62d7ac0eb654e918c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e72b73bf460010a65d91872949db32a350595fa5db2bedaba6cbe0ad9ca46441(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba2330576d76365f574c86a8f557544e4cbfeaf5e4a9127e8b2cc852b99f3f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9337433b740e3968a27513754e831a1ecccb69c5113335a16bb44b8f9b7e777c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3b1b59dbb192c7396e4452d2c1bbfdcc44c77bcad20c39ab0dc02cd5297c7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913096d8e3b9c1874b3bc5abf53a27040624eb1ca7915d440b6559ae39a99f14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3624f76ecec6a098372a3b13e5d485d9022ab4d44f9ef86e6f019827950c40e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626c7239fdb23387cc8bb72a2799491aa17327757fe6f91243debd060704d486(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__736814c758ff54dfe0745c97dff8d827a0bf08553f5accf26e6d18ef05ac05dc(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rule: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129d0b817066a160a1c97a3779c51ae3053ef5bebd764ea0fb2aa5e6dd7c552e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8055782a391114094b3049c410c479642e8b499f124f2bea63ef9b345245366(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb7c81f3462dbfcdde2aeaab194a2cf1a5de55f56e5340a56f1fb6c3afa6f1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8060391a80580747c86b16d1d70488a9df9d593f59faed42b97087d43bb4768(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25c8e63831c1c512ecdad2e48ed7534d35358b2773d8bd375705562a06625373(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__634350cf990cf130e02ede0c3db5b7411fe98e5af01b420d8513a21334e84246(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69eacb6e5a22c1bca633c713cc8e97e64a8aa34d27e7cd836d29d24ef9e1196f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40bbb0e4d6879fa14e710c73a7ad85a61a8f3d7bee01f4df9ec9bc106c3ce73d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5496074ff163dd1bac95571e00c84c112302b0f94adde04c6183ae26e913693(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f39ee6c4804d865cfdb34e9b9fb6864f30784d119b96f8e589c9c94b236437(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c889c51d3229f97262b3044d3860dac51b139580a71fc9794593b6fc739d0ad(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd04fc66c151c191f4e1bb8b9a8b33d333f7ac2698e52b23317641adc203a185(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6783a159c2b39fec67408ded0ff38fae792a26e119fb1193bba52f35892850(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa7190368f488c3c29200a6163bfdc70438d941e40c8bcb10d0313601c1804f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cee1c7f6295ec6c67dbd4f1d01444a360398cfa8d82288628622fa103055c2c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ce7e93bbf9af0f9483a9189a270fc5fc01e5aa5ee670d77633f1eb3582d6118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3b4c994e4c83a6371ce0664e5a321d273c7d4ddfe0307dc8902aae223bcfc1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyIgnoreCase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d706e397c74dbd9549848a6a8397052976d39811baf0743323779b9fa9d48d21(
    *,
    behavior: typing.Optional[builtins.str] = None,
    exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d38daf133adb44b4ec5d965e45a21da9e0347e8292a4b1b57f98631c5d6c80e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edf2765d0885466984e9960047acc86bcf80e7e4d5a510e8b59c54abfdf90c87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba91a36c49f1694f9878fefbebd100cccbb13c089199bbda34d26f5088f907e6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef3ad62985056f4ba78855da6888a914188e63156e5b9ca2abfd7869bf263279(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e39a207b4af636e91a09cbf3e7576c51128da9045404f65993b5f2dcf0b6fae4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff0ecbd70c5eeb609c89fc882a38232dcf9f55ad9da82cc10fe24b9250ce6f1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b65b503f241df60d60ef51166deecc7695af1ea9ee4255eeaf332133ee7ec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38a4faa95fed8da6ee06529cda34d663036bc98e2b4ac6a1de6f8d5023fded5a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyQueryParams],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e9ab9b8de290cf30135c7c3c91bf7f8305e853c3e5b8dd51fe50794825583e3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__720dd4298f199b1da977b5dd66f8b31eb8394de2cb1bfdbfe594f4c8453d431e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9486f46f02e4aa50bebf3d34d86b19a70f244404b2893bc805079344c45079e3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2608fcdfd4b38220330768f4b53336dca9fc4199d7f6048761adaaed1d532d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__314c3c7f52d515c2c516f952f57faca65065301ec8ed75219185f42d02740f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e102ff36a17e46c81345b59b03eb0e7e5d992fe7a1c3fe6eb844f3698e642a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915ed9b37d1cf021509ddc15728b716442b21acd1a8c38fab05c2732ce37361a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheKeyRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6007de02aa5ebee4f70ba117cce8bdc9ff67bb7ca6d8b98899fde594026ef5cd(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_body: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2243dcf3effac09d53be41831dc9e13db01e00a56c6ecfc81bb78e36dfe4919d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a79b66355ecd8d4ddf1560a2e35f1f091d361016e8d9964576ed37a515902d10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__345caad7c3d79f66c878c6d9d1afe8536268743e103a554881eb94ecfd6dd849(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdd60c3de4fd8be50dd7c9950784273700ca41d060dbf6773310070b751f5b26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8800740de94c0bb067d757ace960de697115f0f7dd8bf3dc8981f640ed9bdf6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52b4f5520cb699585b3c27d0f5fb2f061239aaff34af0f6057b827d219d135e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28265e89c871fe578d69904a57d71664b5360d2fe10e00424dcf10a1db856d50(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCachePost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce53acdcd92c3e4a6a758c2efb3dff289e09dd623686bd6f3ca475100ff702c7(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ddbd2a8f413e5a574761497e4f7994628d98a073602a98ace64ce60ff6671cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f038b45482ec417242ee3600fa1b066f5da024e2d069b36529d394ee12af236(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd730b9349312b0b50d789d949f3c6a7255a7d994f49d0582ef478c0af2652d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abff1a6fe7b2675fb84ea5299e5c32b74bdd02ed0e88437eaef2d07b97cce992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d0350b853cd840ad185f4a555f832b788aa621f52a3a0800bbdbff2040bd66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3ce75828d3cef99b2cc79ce8776580f1aaa6c43f8c6cefddfce04b12729082(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b7c72439ab9a655e7bfe45b83e3acc5aa8861a554a12a2500c7f550649a450(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tag: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a8a6a67c3c1268534924453ba3890343cc2ac06ff1a3c109118d141a501400(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3aebb8724bddc4104b7805e2c648b8b26c69e35bdb3e2d1c6af3f192c925b54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61472ae17c69d231b1f01526c995b329bad94c668014710659615b10e7a47b7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f771de21b31db87ea129343aea1e839c5820cbfb51304c6c0b22f2d2185bae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33ece048b4ace7c2b8152ea683832576a7898d51d8c3555de19f363b7f3dd197(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb30c8282a947375881cc43c96d127076e74ec737a44db7d697d3b148c4a649(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a511ebe14c2850be83e13937807b66ccc66ef1c7b9300f5ac490dd2d64a17f5e(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b493b68d8b35782adcccebb868a46d5218fc603bf7da103a52778afce6c5de5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093ba54a86788cd1dc14d36fe8a93721d03355ccc6c87d354877e83cc6159902(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8cfa1eadda21182524e6903beb46ca265a359653df28e15706806c8300cf27(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50f533e16580be50c52c0515501850f01fd58e0313afd6a2484334245a9ab27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c0a555565e1367e14e082867f974041d8530c341c10794c8cea6a8faa05c3ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77d13671c7d14d21958edd085088088e70f4eff09043f40b0533f2e3126caf0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCacheTagVisible],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb83b2f07d33f0a2b94e6465259d6298dd251bfec76eed19da08474d8f85fd7(
    *,
    behavior: typing.Optional[builtins.str] = None,
    cacheability_settings: typing.Optional[builtins.str] = None,
    cache_control_directives: typing.Optional[builtins.str] = None,
    default_ttl: typing.Optional[builtins.str] = None,
    enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_settings: typing.Optional[builtins.str] = None,
    honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    revalidation_settings: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a9dba1344658d56f582fae3af65f077a5e3f6e6443dee98abe2e7264a8a876(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6137af0dc094771b4f648de6605090bbff65ee1484984980a2f588f430ca811a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa8b3e264626713a073602208b1ef28c8e920042350d13e226f39e73343a298(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a63c2a0989c90c899e2cd3a497eb87bd651021cfca60b759079e17fd913930(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d105165b7f2597c63bf6dc6dc80c968b6e43128c5ea72ff31fa166e74b1c6ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f27dc95ab044b2c058a7925f0bfeeaae0c4ad9b6acd4022c7cb47f42c027ff82(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__822e9397d5c9db273e4698597f91001aed1cff476941f68ad99d37d5a0de4fb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae4c862bb37d3b27d64150c680dd2d01df324080bdfdc1b6f83804abbedf7c8a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89d41f971c8ccc1e05b628b432b43533f13367eef3fe9aac36c2a54c3658a24(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b824dfc5cfe77478b27635c56b44e425be75c4f813ec9c2e6eb6fd9c5dc418(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c002f02a1c512ce8c81604520b34f3c365c48efc3e6580c36d9cc2dc18a760cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__070125d7c77294b290b4ab617afd385a4e53d2f28e5b351fc1eb556bf3de9d3d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c336c284c5bb97c399fe09f2f326d74da283ea4c958f29f199f637ee714948(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765e3927a930ff1a1fb6aa0b28d5ea5940004deb71d2626b382fa8ed1763e913(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b66b9367ce64954690a3549f0da91a2710d5923b7f8bdaeb2740a8b289066d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0ef4db07bb63caab4f04eb780bc80c56b6623d792c8e90f6d3fafae0998b03(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e029dcba9bc5911f01ba922f11feb1414b693dbbff604862b8938f31e26c0965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b080f85ff5de009fb78e9cdf04a3d85db8b37a583115f98506b36e09c890264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217acaca0c4b25dd2c16947410381d35635d23022fe6a0f27465a52065064b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe6c485f8164530608f64abd6ef6716677f31700e0bdcaeda49757022b4a9953(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00d6da8caf54cfecfb7e34315e5ce353fa0aa4df3d69c9a6c29ca71870d2045e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2c5579f17bd4da6c9a97cf11eb671ceb058b7a1be4086070987468af9826df(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7cd9df80a550bc61167c4730080393bfe2d8603aa9265d4be9972d396d1e89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f8886d0af0c8bd5708fc9d5e4b017450915b2eef4224a797ff50fcea58e694(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a1c78f444885708efe003b8a12d125e2e23e27e30a6deb3d03bcb5dcb0fe37(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad5333262411cf0994dd8efbd7e6e7efc27514600f64c743ad2463c3edb1c72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381dac8aad3a910b1473385bf394a7283e5b69f3580a725de1dc1a6e4a32b467(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d916fa4064a91476cdb6dff5e330c66bd219eef0a61883c73f114f7901856eaf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCentralAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f73bea692d2abec5a0658df06d0148363e37f88b46b6e7483257ac05d1dbc41(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    limit: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1714fa8a63d74c88fb007ba47c36cd09948c2ecd8527312d62d2b1fcedd952f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1020c6fb67e948fc5f260238f5bc518eeb96fecb932e87ecb57537df839d002b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e25ee0a24ffb9f7b506781cc6569db178eb4a35c272bac9dc60b8db52aba1ec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__992ebf8c9e2cc89c74dd5c6d7b8a3b0d38245826bf065adc864e618ce46e5310(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc130dcd2e5519b7e03548cb279244f7b787b882ecacec83158de3ff2a7fc94f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c594200ece4bf497815be5736d36fc049615099df5b41b4fa45d96f75f00702(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29584678e10e98078b0afbf922ebf1d3ac2b8b309d539124aaafd0daaacd156c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fd1d64752bd37caff2b03ba903018a56f7d2af04b21e85901c589486dac4ec(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorChaseRedirects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5cd5b608e207d9758a2cea4eb88f03068025e54f073383a7662af353fbcd4f3(
    *,
    client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7c880f447be6353c61ff2f80c3c10984dbabfdd5a3c4d3443d3877d99cc391(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc6c964a3a694d24dd7474e37623b2e56dbf67e7cfb292668c74c26a58a675d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5440587d57fcd8974068c3338b1b952a05bf0ae74ec8cc8d705b7e4014d8bd7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ecb49c9fc33d113d71b9561a81ee01461bf62b68396a066b0f3b1fa9f54c72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42d9309f754160c2901ae953dccf077c568a4fa867548e359d3cf59dc3965add(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2379bb2257bf83cb9414f079c9449f913d283a94ce2ec6aa08697633ce4492e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ae6772d4613bef748451f8ee6e9cf2e418cd25b21c7cebae4f0c9bafdab672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e41b8ad69919ec9513299f61cc3077e5d094901ada4a67d7304bb7acfc97041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a29d21a500187277b076cab6ca3e7eec0f0297772e36fc73610fa81ed89074fb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCertificateAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90821190b7b8c84c636b6b2cc9ae0e5b1eae3ffeae718481f09e3ee36ee6e041(
    *,
    country: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4044160449165354aef1e8072e5ba566cf97787cd9c32689a723bbec0a6301(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13a84f322e584c32808bdc83c844b803bb903c095ea62b27b49cd14d7acf6b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e8ee6f8352e30c9f01bece543bf181d0c56db8780bcb78925d7f0ebe27b04e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0606951a714b0ec73b11875e37c6843e295766f6d79e660b6ac4b76b0d788922(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581bedc98091b07ed05bd3a49dd87af927aafe2c6d8cead4237a13178b11be63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd6ce83fbf28b6f143e1df00ead8f59b5cf3a18d61a7d957e81571f638500eb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorClientCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59f5a83012bf715276503c3ba7645150fae09b1c7ba2c605884d316db451ffe7(
    *,
    cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4514b594ade0d73dace0d957408d782cac4f60d83af95a01b4917c893421f7cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66eb18c3ee7f732685b3446206b8d15b5a6d9e4d7ca27ac8d1892b06de2175eb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a41aa850322a6ac03a7a8120287bf4f4fc7a549ec39c768ed1a008b6e26b0359(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8135d218309ec9f9b6a49767fdfbffa880d49f56650fa42a49ed64f2e30ead6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a438693242ccaf2a5efa4b3dab2eb804da89c791e0fcd166d8f6a0bfb32a97a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9396f4c6bef9786d8d29846f686cfd7ea292f47e688561496981d8ec9c184d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e930769cb03fd4ba0d8dd530438cedc1e95c199f71a1d3dfb0a3479c3dd5357(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudInterconnects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c53275099c23e972aa9d2c7e8c1c7030dc2563facf87b3828049ed3f1b3a37f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ea466918f456deb165dafd1332ff6095782053b8a1a7582e3c5a0da0eea973e(
    *,
    custom_failover_map: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_map: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a1e488b967746bfa43423968ef51fad2bea7a286ce04c2490be080a87d3a28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03746afee9450b281517b69a83611502ddef0433ef1836c76da506dd0c65bf54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c281d00c24147102d798c9476d94b96ffc3564e0cf859ccfdba69d2690b6a64(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc3fcc5b345244690185683cbd64f6748136e5876698683ab0e48042dedc7cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1cddd27e04a0306f0afe4aed38d1480a59c631cecef4faf5e479084daf0098(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f753503b882a2e6e428024e59903861ed03c97ae23515af1833151b54292038(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8efe03ac25b5a7b132e1e3e4746923a2fab130ef9adf5fd1358c4a4a01ff517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b531e37123d23c0fd679666cac1dd052dfb8c025961c8093ad28c234e6bdce1f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapperAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ea7e1d3a18f1b408f937fab406ee1229b58bb1c091185a9aaf1f89c9754875(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f71bef977acc21cdf31c5bea15399a604039d78a5d2ecb581252d57cc1e3a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64dc23f7878b6644ca5fee52932f43f238bb3e859c3f2cf96cd3debbc71a3f5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2a9eae30a483d5f3245ebb6d85e2ec2a7be2408c3077bf7ac3f257bb6f782c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a4599afdd79efd9dd9dd2fed0bc3d85cc999762136b46aa648feb1c97a3309(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c577ae2dccdab3029007344d30f020a995af008cc5edce54e90adc79a37a2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3675e39540250b02a35334a6ae568275a99eebf2adb7c2d783026ed4d2a5abf0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCloudWrapper],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c719a988f1955650dae5cd1b6d37b8a245af462e955d55d1c918417bb8fc0787(
    *,
    enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7adddc1b76b061eb8e17484a131d3ff746d417ede3c300678e63eff13ce8d20d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6496129b651737fbabf1c710cf7bbc439842a4b1d8ef99badfd47c61d3c14aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6968ad95d9405146bf9755a79b12d360c97e5f893bcce1100819bbd88d626b94(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d13c6b048e5ef257b70b729a4c35f7f3ae419951618fe92df2586ce5f293cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc39c4cd17017241c7bde65604196dc62cd68f2e35f39824352ae721d321ac65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b70490ce21486b8aeb50e55176c3d7e283050ff90f87c2d8fcc77915861960(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCommonMediaClientData],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__511415bf5e896f9f9ad85ed14d09d1bbdd9be0a4e31e2b74bd2bbc2e110a5688(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b375191b0255805dcc713d22f15578cb1b6ace6d1f42b81ae680401d3234aff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc60dd97522209de7a55eb1bae7975503b175a09f364a1d753aaf93416113a4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3868f967814c97858c1385126908d9c1732584c829051cf853cc7469df31aaf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c183dd1d0d56a41eb2008359fff976c7e2c302d8101e912e39a26ebddff0fba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024e580a52e5d2139d6e889a3fc2052719435e663217fbc5eced9fc86c04f49b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9cfa2267242ebd86536c2c290641736d9f3bf2a947a4e130d4c2c2a4afccd5d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConditionalOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d1b496f4f199d7d9b74ef897619ef6171b0d281c2f8a2bb21097f329294452(
    *,
    body: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa4d47d5cba0d5fee30f235edbc607f37c419b53cc53200e3e82d532c101452(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a1a9ce5d5cf11f97e13ed6439566badd013c01e54bd1ef849c5d74af32fdb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7c11bd72f4d49d84299d813ac43768097efa39932a06a4c5ba69e6783fd079(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bfcf386fa5890892c764ad27e87494a8ea0181594211e7fc353e92a20bd12c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588a1a0e7ff3b6571be22a3ade7d104b66edeedaa1ab86dcae5bbd0cef52437f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e74cb4fea97de2892ac255b7d5099406d84910a2c8c2066fdc871c98e5558d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99cc493c073850bb0a290aa26f867edcf01197658b9a971b7e8de63ba3764e90(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452e449d9a20695f779af0f15b588543c50ffdda518f85066b72f7fd59dca050(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a9c398a39e21de127ac61719326d89135a573c4f4b4af7b9cb9577e6539394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0e2cd507bbb1402a6eabe80c557f6305207a85670c00491defdb97cc421bd2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorConstructResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4cfb8ba81ad84edcd02b9a257953f458e50dcdc3d16d2b75583fe55bb0c665(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946d50e59917d14cb9451dc29e4701cf80e498ede8e7c2f0622f43593ff0123b(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a45e71d3be38107309b33fc7acb0cacaee47bc66e4c8c0178bb54ba7e386653(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2741098ea3c71655ea58cc17cf065dad2b16899997b16d7d68a5d4e9e31af698(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__358272ece740f64ebfd142e668d6d7b01fdb3f000b460c83752cf005ad971637(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb60ee94519f505a26922902e929645c87a0dca9db388c32dd997e0c4df58af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc408c2fa575d46938f471f948729de686b9fcd7948f4eb5f3b85bb4ae6e818a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503263674e723d27169b7ab72fabbf1909ec15a332bfe2288bee71c1ffb8c9aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6e8c0898a74f70605ea61bd7fcdd672d4311a696e248953a09c54a1e7de2052(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d092b6d88100f9d24aecd9429e410d7db97d32806bf85ad1195e7d25bf42ad00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89fbe1d9e08c2299aa066aa7eb311a57a16094f51f87ff27ee620cb929c29681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e6a0fe4d97772c488c1f7a04c75d2768bb62899bb58471530b2edaab0817572(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519ea25c9ed8d7cf9be9ee145098681d3b2e07d514a5d33974983eab1fa83a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0167ee0b4224d541982af58a527f862853e054bf6acd6eeda3fd9a445e922df(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__971ea5684f520dad469ae5f8e4388f246dd1b7571a960cde89e7d7299a23c77b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0f818b89836eaf5048027b9ec2db0cf9712e89dce4e7375f56cf892141fa2f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f26a9eb6d54967772dc8ba315f06b54a9f21a98b245cece249f159b760b3664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7629c050a5f428ca7358eed4747a8617a5bdea10e6e02c38522758d986c89c50(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339e3c296bc7227aef6f6b1b05e327cac45746fee10a99d403e605d29930a351(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27533313779fa8044d60e6300d7e4745a3feba5f2a663a720430bec890267c81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51855c0c148860d16e56261d1ead406d86fd29efd96d3aeaf5214060cafc405a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c472940ea34eefce1084f169ed80f21d32cc8447426000542be597e16d8dd30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28144b1b54e9122ebc61e8385a3338f431d0cc13c4fc02f2adf510e8860bee25(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d141df8bc8f1e7e223bc95d19677e8c496238cecc6ecc3ee0032ad8da14a5070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ee48bd6a9896ae74889adbf9bde5ba9b473f4ccc441c6a16945fae12d2e4f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52fb1d27e81df046f8e6e5374121bfb9bdc2581357466525f522e09fa5319877(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsAmd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16f0cbaf7f6dba8e291f2b72092be807966027c95602921d06a3561df497487d(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__142d2f71963da2cdb4e1f66a2f5e78ae986a442f753da111faddd9ef7f3580d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b19293515f50c872e6ef16d5a6de488110d0f38f691ec29a6612385f5e37c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cde7bc9793a2224832ffd4b948d061b6445169ec4b346ae02320c8b8a3097a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27d56c45681f5c3d3f2507bbf7f09111f64686fe30425cd4f4d975a81e74206(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e445ab7df77064004a722debef7b07cd4b71f08a54e982bd1213352491178507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed8ae8acf8598ddeda58f4bc312c75ea0232d39f85f4e9fb734e4aaee2ace52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec36af443211a72dcfe88ea15e75fbdf69ffb4621c931a308131b031a1cc5a97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a5a165644ce5efcaee838c542c8337ec6a8966d79ce707accfbbd79ac2b75e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f160e1ec8edf32586c483472e5e50a9c9b323b9fa59074e7ae13b0e28ba20e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30c7605395ec1169f38e86f661026a630321fc9f67ace1841cc7a2d9c2f191c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsDd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89451788b484f417bd45f32fb3ea081724728733dfef286d0dd77e9283f443f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701ec6f20e1209e77326c676836954c28a5535c6d0784a53007b71d823dd6564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a9d3ea501b992d8d4722b0d983eacbc95870a750a123ea89df2096a766b6ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470f358e2f5d34bcb11d6c8cbde99a53fe5b6b2f719fe99ea01257f1391b7598(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb0a04e515a63d0b5f6d09400a7b89782130df82f68c28ac927aa1cec8d5287d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ad25c268674e96e233416af416161a20946b98571625e1b62b8f87fb96c4a7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a26af17a5304395b0618a582e871e0f4c71fb0a565bff67f5273a9777f51475(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97a939e8ba4cab1172ad53b9d7df4a8bc07e008b9de6dcc66ab097bf3d63a3c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1e1b792595a51088de61f70a05913c90c89437e3feae2bc24b4fdc8b3b66d0d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cae1acf5897fd19692ea106f5c7cb8164835d681feab63594c5cf24bd50c2fd9(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a6b473379757779806b0b34deb63c97d0eedc045e30f7f57a448ed41a9940e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c972d770989b1f1dca1e15849387df4ca7b5a7dad98f31122cc47187cedefe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23814f6af6ee07e7b72aff46d34c13df9c9d11b05e23294d0fa7c8b6bd651a94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07d15442ba1880478b8283ce612136720b26fc223263f2ca458323b10cb2e72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6445b626e59b92752321bc9db43df35802cc99e6127638c1eece4253d721d45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c740f69ef10e40367e07c63bb7f895b69e93586e630c930a73df8844c5de611e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d595ac8364326611ad90c4c24d7e3b65b3d0c553dee67272715cd603669a47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f33e7ea48dbff68173b236d9f0c5ece56c518b7ce3c84e61722f79bebf702817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12cdac2395468fe7b578fda0bc180189337353a38ac3ff92715ba0f0197d1c20(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLargeFile],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bee2d3f6d21839fe1fe04a7293ce69608772f5485b67a545bf86412ce4bc31b(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853baf05a7627b72f712377567c528bd0e9dad21f8408608ed6e441de9f89288(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2bf0204aebedaa28cc795ca75202fd45f308e12dca2885ab8e37d7c74445195(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e6e5acaaab4f26576d63120e74c76c6d4cc2934123abd84b58a3127c355ce7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0327157ca8caaa47a27211ab88a114c9e751e6d520b882c6aadb6b9ae2e1323(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158e8dfe89f7bf2dbd692cf8f120d4f465c30877b1f3f4195446d9b435610964(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36230845cb4c75253262be3cb3cd024bc0e92867833d84613e479b7ab8213720(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9672f7a8d34198d6a1d18cc713431b2219288350391cf2f25eeb5e3ae0cca09f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1896929cd68166dbf4b4d7f93922e3da4236c9bb9772ccb29db32b758b4a733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5846680d7e35e20a4107975149050e31db6e8e67428db116fb59969d34dfd3d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__243895e6a308a7b1c4db7b337df47a25060f50471b0f71f88a6b047b61517259(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9a616e5be66394aedad0adb5922cfbc4a134b733421b5943a164c6db3d488b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a62c7a971069cd26a528137a5503aadecf40da16f9a7dc1aacb9a089d51d9e64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e7db0c5d397d72170f873e9ba260b201ca7492e38d6eb93a4c2f531889c3ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c997d5f108013b8567f3e7874f74c93338c1b38cd96381e27f4358db1bbc2703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d835773ccca0f1468cb10c3d63c9bcfedcb8b2e504b9740e62ac7e89aaa3cb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9700cc021f6731713df408b0be909fc0520229442d1e6411d30e0142c5d70429(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e733bcaaaa7d71668f3f196727fdec490f7a6f2f0e988938717ff273d18f2a31(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df826e9131df0ea72202b5f7092d273b3661222aee4ee07e51c64f9e8f08a3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d891938c0a020d160b8253ee8ef26fb3f02b3de567b8fd0417f0d41124dd0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540149df4107f8e200ea5961b68b9b92a41a7b67aeeb0d1bf76573deeb30f7e8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdLive],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f170dba585d9159b52e8af2aa698bd671012c916ddc45847b03c5c9b58cbfb(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e62a30d8e874dbf85cb9f72017c9f5e6e70d6ed987c00d295cb9afcf242ccb8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924439986851a3076e9f11fcd0c8b38ce52df39cca4f538c0063db67ea1553b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d82e975fcebb746fb983783eb416f1023364e183aa693d380ad11c39b85ebaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb436949b78d5c98d47467a8d3e2e33dfd7da96da7e4d52c3a3ddfbc0437dae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6a988d646f0390fc7d1ba76e195224f4746457aa1da05b6043b55ae5a8143a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2632891f416f455f0610d0d0f9c55e9045cd38da21e5c2e23d47e66abc2a00da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8c64aa79c862c77e407a838cba413317f3c19e470e672d97951a6ae38989f39(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f49727e50e4fcf7e981328addbb34c412c205ab0e1dba170ec9b3823ade124(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d3ac6d74c7428e03e640f5d7ea57538cd387537adce8b0e1db72fcb523445b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f775e115b364faae65053767abb7a345fbbb2236520ffaefe4ca47b176feeb4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1eb5a7cf21cd35194780a1fc594669055e4ce8ac4ca25aba4be5aec503f1a8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a15693214152d366e3b230c2e7f93a714d3fd540c4f462a071a1fa1b28c654c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde2ef44900f835dd8bcb2abaf42e81ac857104164bbba451c2dbfd0ff522ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00ab84e3ffe26c04f1963e2890f220fb4792cdb2c3b3fdbea390d771d948e6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a3c71b496f53de9f271163beed86ab3a6732141965e85913ba31fc2301d7b81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f9cc46af07ccaac41c39935c9bb965591fa9ffd93838997af6d7123d4e7fd42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c8e281b3b15dc000e77e1b61c28fd99745d9931cb86fa8f4ee947d3119f9d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3632838b3db67ae02a8bfb3f2b551f4893598f0ff658ef1abe6178dcabf03c80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9e1127540d31f2e6bfde2c0b89fdad7282f7718293f705084aab0e6bb74001(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbba81eac5c6fb7fe51c1f08a65248e843e42908f68d0d0e3f39d38e57c4208d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentCharacteristicsWsdVod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20bd0b317599f96da3c4528d931015f2e92b6f96d2d68e72e05adc1bed551637(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    first_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    second_location: typing.Optional[builtins.str] = None,
    source_type: typing.Optional[builtins.str] = None,
    targets: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0284a1b0b9f4dd9f4136396a7358e55a2981842f849a9a74125e2e32d723b6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8738dd1af6317d12e11c6cd07d1bf8fef9cfa64879cafac1980f5e897c8f84a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306751a993a5896fdb53f01030832cf7694c6e01dfe2ce87c2ac2f28350ce54c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c18b4966edf77232ef6345737df6b78f8a19eca1497a8b20be3d094c476309(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cc135fd0a7771346291d068e42fe244617dc0d6b85145bd7088c070a34df25e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc05abd4b9cd41323606f31a31f7e189ebfa475a254ef6ef70ca0e8e91dd282(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bbd00206b8f1cf597d73fb26e4ab7853203a7a783e9e1fcf0faf220bdd917a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9393da94f4398d1d9461216c156bbedc2d919532adf015091c5865a949e5907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__369cd23d23862efb00444eec5be86b2efac3db6ec94365b62036555e2f91b68f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4016d49b1f53489d55fdd10bbfb443b72bb16e10246beee2071954835ffd4b6c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentPrePosition],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__353f9ba7404e877c9590c1bf323c62ea1ccc08f25d1decd27debf75ae4e612e9(
    *,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_protection_mode: typing.Optional[builtins.str] = None,
    geo_protection_title: typing.Optional[builtins.str] = None,
    geo_redirect_url: typing.Optional[builtins.str] = None,
    ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    ip_protection_mode: typing.Optional[builtins.str] = None,
    ip_protection_title: typing.Optional[builtins.str] = None,
    ip_redirect_url: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_protection_mode: typing.Optional[builtins.str] = None,
    referrer_protection_title: typing.Optional[builtins.str] = None,
    referrer_redirect_url: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77feaffc8a9c4d9a60704e0d70d5c0ebeeb601b8bd9beaf3bf88c7ff75a8e7a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c728ba44b02016bca4b9a7ff62ec53736c9b6096e6888a82c02fdec0375e16(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98733924dd46af409b95ab2d39e400c093c3b9fef6be476d81580dd037984c4f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a264e5ba2b8a0710a852435adc1b5b8a5c5cec1b9ed7e5727b3c43edde0b4c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74693f243eb3b9bcf14789d9e987c8f1d5594bcd348f4c4c547657178e98321d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a50be17259ae753d449c5cc68f75b823de0180036919c48de545440af16d45(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c4ae8bc4573aca09134876653c0e7dd509135fb891240c3395790b290856f22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a25c1ff708d87791380fa242e3a43b2411de8ae2c2769cf31f0ada76ac24cb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7796063ce0af782696322f957bf940d1be52040db3cba0dbf4de6e9cc33a2eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e2412260e6013c2362a4f9f7ec486ad30c1cac33d9243ce73a784c03b9005b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961da10b51bfdf81fa7f7212689a7d957655da2763aa06b08d88572a57d831db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a4091ad290716bb8cdb6b08d857d8b2e89b66e6a7c6278077e3b97790d6adc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ec8f4b5db52d52a027f6d32121a0494d74371d881c665e95d1d284dae7aa40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8f1e4b54c404dd19d54d8943fa567c2ccd08d1f4bb8499ec95e782ffe8bc85(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84cfa06adab0856e80bab2f9ba489787b31c22fcbabce733aa4b82e7c72098ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__411fb1e5775306075fc1746b93f93f522366f83086ba4de13de41bcebd8c8123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4a0e116fa322d53299009c506a17bda16c9abf5ce7b359c902d109b4316848(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1086ae5d241d6f0921c16445babcad4d826d7ab601aeaae332df1a986065be7b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65f989b0c3e282649d9e51d063d6ea12ad40611fcc07831b5a94700619ee0f2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdb1a3af60e80c143affc26e820557ea98d3b113041f4b623c4f6605efcf512c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__962c4aaf5e7f6c750b608ce7c8a3e3b2d30e1108f80e00f2c944c32d98da7615(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3764c62a0c62a82951a7566c0af340fd4dcde22bee525f4a491dc752ee993e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e01b759a72d93ee32be9ec9858416579c0f8fdbefed94b419ca768bff4383b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c51395edc2c9e0d8c6bd5f785d6a78ef719406b85626f73e49f09408055222(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9597aa9e18955a3d688414f7a03be8724368a33b009a5d17848e7f2ac124b94b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af23a0ddc054c509539829a289e70caf41325edbfaa11797f3eb0bd28cce857(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b919127d232031f7e9baf8e52e62c09155bb98cf74b181bdca1c432e2c93a2e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorContentTargetingProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec8d333c15664a9467b87acff04a3a8beb9503c306287252f644f2c6eefbe83(
    *,
    allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_headers: typing.Optional[builtins.str] = None,
    allow_origins: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    methods: typing.Optional[typing.Sequence[builtins.str]] = None,
    origins: typing.Optional[typing.Sequence[builtins.str]] = None,
    preflight_max_age: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__725bd1a3a8175fae42a616d9ac6023e2fbfc98fddb4283a0c6e9d59a2405b86c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d8ea2fcc2ce5823346cdbb083f6f6cc880570b6aa9eed50f61870abfc2a298(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f8889a0ca98dec06f8e236ff6dabb7801c41ea0871384c381a400a51f5633e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3373a9375d3644b3ceda04132818d4c24e400ef325c5e17874337bc3a64b1d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f3e7d1e6188d6fd0e79d250759c83cb803fd99e8783fc6f6f1bb258b36362d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1930cfa082dc3f8c91980d1f84a889b9c898f908bba4cdbf52b5790d3bb369e9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83641b2c3b429e273fe28376eb42c93274d8553b94f8594ba9da0337e24d828e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e8b057c1b2c166ff4818167d4e663a35c43f2687deb43338f7498dd7ac4e697(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__085868938046635772f8d38cbf0f013e6db23f717652e590187098669041016c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4781de9c0b233dc457b2af87a9d39eb672f20bd59a719f3fb709073e688708(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905719fc05cc65a1bb52ce00f162f0f5eb65cc8ceedf0345fa7ab91ab29077e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c2ead48cee5315acf073ea5df6a4280112c2979eb9b14e7ae0bcedcec6c1cd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__396d6cbb23a180f890b1c53d2b37cbeacdb329cad839695cf6fceed874dc6554(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab9e5cb6800518509de5ff470721aea4c9ad7ce907f1345b0a4af397b39ccf2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCorsSupport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38fdbd698953029b7410305c4c65502e4c6742872f41284a7649837cc2d1a00e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f3cb2243177fc7fb98b645721444b1b4a24d97832f3d43c558b67b7b181d74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afdcd158abf88e642d08c09e73f030c954531f934ff93f045e094fc4af7d9328(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__522b3e5c6b3053929ce7632e696204b750f20ffceedf694b296a7cc3d29e0624(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14ca64c45a2e12bfd096a8887597d6cdd881874bc6bffbd9643bcf1e310244ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24fe712c565bf23a93533ea7fccb99c04e6ff7261f53710a4bc21aa36d391d59(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc25e4cd1f66782679bae16a99aa3052ee07c9b1211f0e4cbd595a343614600(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a0b788b057bcdc620a3684d3954ed5b2cbea7ee761055e048d9916d8cbeee4(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b87efa2dd53f8cb33da057b11e6c64909e7f9c80ef36be752042aac706bc70b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26cd74040f7734fb7b791920fc9bdf2e698cc2b44a701b42939c0599caf6e877(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2600054c4f41ae8721a8511971b7565230c0de39d175be5a26c7d2d40f259be6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9f80f505e166ad5b13a5b3ca17ba8a30f2d099df86ac57c4abb8a007171748(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6103ef62a382662bdc336a75e2e458e269eb01699e64a2367c3becf68a03a304(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa1ccb7e789945a45f6583013d294a3f4364418c54b8ff76c9601dde047a9be8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c546f2fae0f24d3ccf8ceb6e97b182f247f53083e01e44e13329cb26e332eb2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1d9a22728b3ab59337737d551eb17bb65eeeb8c7d786b4079a66e61c16f4b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb68b517c07150bbb4d4d4b48da9168883c6e00bf318b670ecec6d0115c237b5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__480f16841e66f0836c617194be9b50eb39df8acd26f9f1d99b44776b01817d47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ee84a0dfc59ddfea35841c53bc3069f88caa22d419f1f4deb6e6ccd8d58caf1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c462b8b78aea2788680dd29587f1c4f03de4e6e51ca011b062ba5ae7c945fd9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054724f53e90d7b80dbec40dd8afb0e447f5b7eba345b3dd08089d68842804b5(
    *,
    behavior_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0050aecfd0e2777086ba81d22b0d25d19b3a917aa6f96c597e7fdba55e76b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c9feb41204e6aab140af4af9fba9b7ac78a41a8f45c2545a5d88dee50d0817(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690b1c4fa765ce1417fe011bec1856a58898367ba604cc8c1a495f614b8c73c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc3351d9ba4e4f622a6649a700b66015b4253266b9e66311e6c9cd232a32799(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f23f96e3e0e363148f484fa12582a67e7b75ae6da56fd53c8354deed0ff409(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dee52808890b961dd7875049aa914b8599800793ad1ec8df478ea032c1cb98a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorCustomBehavior],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19c3c211a13fa2e8eef996622c848509a489a70ca82908c32e8b648c33c2c7d(
    *,
    beacon_stream_title: typing.Optional[builtins.str] = None,
    collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    datastream_ids: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
    log_stream_title: typing.Optional[builtins.str] = None,
    sampling_percentage: typing.Optional[jsii.Number] = None,
    stream_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d0488be62c1af8a51f318ea29c869f0c4caacc1aa2a97958722951188a676f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ccad41480e8bde9f2f62b383c29e7243d5de0780fa5723c8f895a0af3033e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6252d1cb471167be96aace54d166feccc83aec5827cf53dc763fd6a487501d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4800380e3f7914fda37e71568a29c24ba4721985c3b8f85d739f78de7e9f610d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17041b73aa9ad9b372618d15954514edde0f34cfa05b01e7f6eb2471e6e8239a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6a10283ba74b1d2da26a82513767a5cf066f4c9cd2480cc53dd8db83ba78b9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c6eb26ff8e8a1bc44fb9290e9daadd905484031a78435f4d6b7e71a86c2c81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f319db234d386e16347838ac3e5b9bc5eeb32d6e35123066d52efc2000a380db(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a93678df72658bad0d78a0d285d0add43fc5a35896825a08c4fd9fb8b88ddb5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987040a2e738cc8d62596e63e7b45ad22a5a767753a2f22c794f21cc57c9c826(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3188460a0b58c4579239d014991b6d97be4d45e02649f038df00a38cb87905a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__230cfe96c33df018c7840ad0feb409899616e11ca42987d1208ce073ee9d9505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6dfb4db09b3288e901969113da98d4bec56ba170c4608a3aee2b20e5804c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277af4439df1ed91955af010848491c48b102b8c569a5236f25c0f851ae960f5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDatastream],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6022b1f0e3f781acb251970f33314260c137ade67167c33b0c3d2f08e62a61c2(
    *,
    anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a776e5863519a99ef15a030a02c40260ee0828b75961c11647f2dc44879f59ab(
    *,
    hash_conversion_algorithm: typing.Optional[builtins.str] = None,
    hash_conversion_key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3b3f815f23bf1a55d393da34c2512a66b388850c684c833915968f5b13ff1ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c7c4f5a38469797412c1f2f84d7271daff157d8404ca29bc62a67929a1472a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aefdc867b06ef851b63e184f1f01603cd3964c9bacae7cc4cb679f68eb876ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d67865c1ebbb9f95ab545ec9a247882e06f036253a26ed805386df0142b1283(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3696ec0e4838bdc569c381d568487504d833d29ef55f339a5e79f6f3ba15360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2914e99b286164a8e26b65da6be8514eeb7b2a3a7da931532d544aa7450c88fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__343ac6ff832b11de2430f9581d5fb88de43aa2a1b43496d76534467c23e4b270(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthHmacTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51001fd96a8e896698e50429bfd7b0f71df2a22f73f30a05e6ba50338a091bbb(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36c75722521142e793d5962876e8ac2b8fe0181e855bfd4c6d3b6ea8fa4ba880(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f69ac82ae854792e2ed83fc0579717cfea8d8128ab02f8e960efc3c638c3044(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__641acacc41d7457df035d91aadd0a8639ff075efc120380daf8543d8c8d70d3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7480a7d2665ecaa2a1892ce19c0bd66c91eb23a839ad8cd8ad63d619a07469b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde4ff4e2c772c9d57cb5b0321732a97e959f78998932577271c291fbdba3218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd346cd87066a11c8620c570cc106cf81de7bf8d65391255fa0307e6973eeb1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthRegexTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de43370e232f7954987d62926ffb817293193348b7aab62b268bb830e852ab23(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    substring_end: typing.Optional[builtins.str] = None,
    substring_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81d9ed31d0bbfd78d504ab2789c4e7dd3fca1b2f674135412f9be230c831227(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0493f028602328507f680e357a0d29ef10b8a6b83723b0858bec598b11ed6017(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__459daf6c4f658ad8f08c92a24cba8ebf07bdd640b6f8b9d94d08dcf58b51eb9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b72786e67384b3e6471d8bd40e30901688eb6c90637b6a02e1ad66cbcc4a430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ecd2a385ffd0fa93f77df7846010bea061a5dc76a9d1f53c6187a48155504f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892b06e17a61c7fbff7a63aab091d38190e90559863566dd90205252eca2ba37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ed3c295b2533963d7168bcb95bc72205b59112bc4784c2310cfb58122cab729(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthSubstringTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b8fca992290c8eee46879befd4c121e616a2a4a0d0e9c598e674958a0da35b(
    *,
    certificate_field: typing.Optional[builtins.str] = None,
    dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dbc6469cd560d2e56172463628e053c801f74e0702bb54c543d5201d655e523(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe1da66cb257a949aa61087fb6182e3b5c5873da2852de2d888bb8b3ce5571b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__825d234a422582248f370b738a55455249ba711ae1fbe018ba38326977240b4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb02548858b772f0fa584c1cf5657d6f7abe44fb2620f5917bc9545ee09b7553(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0ac72a01c60096e98dcf00cfea210460ddfbda65f6d783d4d60e9af0ce6166(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59614874bc166e2a194a261b4579df69edccbc71c0598034147957e3e15555e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f321babce504fe5b3255dc81c1466df3e28521d0a7d2a7e42139f994cbc1230f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpAuthVariableExtractor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f0c4f748d1de7b49a6242f5056e20466384fa8738c918013a63aeb68f62bf6(
    *,
    group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6273501e9fcaab66df59ee8f1b3c9722440fed8bab59016ef39caf6c2f41705e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38d5d6d98defe34ab5513a82054c309dec6ee567d32f86ac5288b7232a8a2a91(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f33813f0be932e7d9fd0d2857f587b87554362c8a8df221da7e612ea1cb58ce8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e38a13dbc8d882fdc6dc40a1aa4bff6e47dcf6aa284ede861f0806d1029d17d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246e3779be44fe98666861372edc9c7109848d48dd7dcd805b8c7cd08453df7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af536e21886c06ea67e58f939e3e1fa7e01c7c3c6e2d18a233bc3146839fba80(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDefaultAuthzGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6580fe0ec3ec6bd2735cb857938fae244bd1c9e516960dba29fb09b9ebee160(
    *,
    custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff72be4713313f75cd18641996955dfe82780e83f202e3d6bfaf71f95fb74a2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547a0c06a657e2009148f84a33b194b70a63caf9e7dbc9e0a5f4b84036c776dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32496e849197052b5d636ece969b8e2a162f2bf37866074ee7761e85bffee886(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d9c5076496191bae92ce216ebeba362890f5d8f6f8947d3db788c95f31130f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5452c9341c928233289488253070d4f83d8b8572e848dc20b3c2e161b742e703(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3751b4890624c327746770e2953afb1b00065346ec525f733fcd198a6d12166e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b10e83272d1a1551c94c37bea5d07fd331e713e51a1b9aa7d866618be96a04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47626ac4aafac37a7b1d6e320ab48b2d687640f1fff6b84ede086c20367134da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3524b117047bc0244f0f43e89c365438751e97f1ea03e7636c9d64c5890c711(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpDevRelations],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89b694bac501038827fc2319e032dc39731d99909a61c54c39c160786ffb140(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4646f124927a21baabcb3d09331b4111aaf9113979a1130312568d5e88722ea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eef02a2b860fd75d19aadedf1d070b4fc02a43359eecdeebbec93732a16c456(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b2a58cecee27eaa16314ddab6b7b09aade401e65fa99cef58b672afc610805(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae04a9b0ca962c32e71cb931db0579bc83c420aac949679cfa60e53de1524a1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dff55995b3cf3ec4d35f4938092429733260982eaf101acfa59dc9b980a1f24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e233f117c849c00244e3c540c04dfd2146b9beabe1402121f35130464e16c9bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f122f8f8fc3e572764c886d2313c19df179d8155b1990be1ab90eee6c9399e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4087ca725b2a012a5ef9497330b87378974697e02ce88592dd2151c710497b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6bb262977c6918031db7d994fb5ddc36f0729c0cf3bd6a96670d4fc799fbc65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2924928cfcf8f661954aa11344e8fd1b3f5e74b423be9202ef3852264072e80c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd0f635a679a19c64627c8fd4a8f13e16f313177f26bb16157f0f3b4e387cae(
    *,
    extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname_claim: typing.Optional[builtins.str] = None,
    jurisdiction_claim: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_claim: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa22038e667742f72ddb209c1f7dca3f77d5ac49fd2a7749e11e90a1d1b79df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45e805a50a6aac885ce77d9bd6d6873d8ec92dfe4e37cb2c186ebca1e3b1533b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e432fedcd47ac811e0f233a9216e9b8e2d53d7738200ff265a0a82de7103f6f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b21d6510a0e9c261d20bb655c2663c5f501d215a49baa9cd15efa79519566af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a043b2bbc5338f211815dd642c91eb8065fa71e4580cce51b392c835aa231a73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e03398618c85ee82df65837f9a8cab30f4f903e9a78f42271791878bd3c067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e200b2c7be27bdf2f047174f84acb073526a8943ce5ca6054357f1a118abc1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aabeb1ad6861014cce02f9d6efe43eb9e98421639d60838d06dc28d76ecbab3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a7ee71c6421142b00326a650bf672fb3a72d512a381a9c929ad39b122b65785(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c887133368bd72372f11595a616a90c45ff1f8e5d574cb3020ae8dc69fe8bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda0bfd1e70cf96d6ad05984362c600d2d8cf0e1f89b772c0519f629c3ce52a6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDcpRealTimeAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__363c8162ae2244a0172a5e41f9346c845c7253ec26298df712651ac881ce8bc0(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e3035e64fb0173bf94f3e9b0fa03a8fbd04267b438fffd8637a6b57a3ac9f9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d036141fa0a148d4ffeb196365ed91e0e25e7a45c5c251fc67cb9f35ed59bc3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71cb7aff8d8a874f9bdb91d1caf9879c172b5a57d26f0517cf2f9a04faba7151(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a259b440335ed3b1ed77d1e4143aa6a9ca4698fc5321b2c36fdbef9ea02b773c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edadc395b919832b9d3846f3083babd9305f31fb4d5f7deb4de94d7d15d2ed90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a3dca5d12e161f80fa93c0ab210baeea50bb512dccbfa1b167ed0e62070024b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeliveryReceipt],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fd81b827f52ce6c398d85a83a72ac62a0c720fcf6c26a07b5874781f47b7dc(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reason: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04335ad9178643dafbc1a0a6edcb4970ad05d608863d86efdae67777fe3d0d1e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1675450ca054aa1c52d0f5da1d7babeeb5ca9773e741b9e862fcede273afe5db(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8aa905a5ebee7a1a1f3d060fce277c8e989d7802bd7347257f70f885448a8a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e26fc59a2d5f6a4ec9fb10717b14f2f982c67015da655c6f01c6548f9d79fc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8704798cba0e644cbe2e912944c7117ac0262b3976fd784b8c0cc241ad9bc33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d57ea695b99705fdd62869069358dc6b44fe9594b72b044fad84e8a7bf6c681(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__772d268944298378f2dd13a3afc75becf6a76697b785a1f09c12eb2b9455c49b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813f4b01b71a35657960358a5bae639b603e0f996c3fb4d350bd40bbc08339b0(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa1274178bcabbfa08f3dad12dee42bb585fd95b3ca96cd46699b7a1a367d6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e45deae751617d8812428ed36d5d9f46861452491e514df3da5b03c5682ff0a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__144fc0d46cb520c246733862dc31df45d9da056ca7f929615d8fa2972569e0ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84979d4450eed018949cc76074a28fc5c9901317fad458c2e021d565c95c48e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a8afff55d0f213742cbc4712a9a123203fb62327bd403a4f847818bfe01ea36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5fcfbdf0461dfe6e83e30db79856a1795ecb12738f2eacf5cccb939089330e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDenyDirectFailoverAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead7398cf3a1feaaf8586e0e2bab2572d77c5e3680a732c148dae775d1157f24(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4316c7f8b59e29de5ce646c39ba41cf243cd69f6ae08df78a584125404d856cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b1c3b3a2dd4b1993526e79e156d4df19f9bea74dd3b17a12d740f0285ef992a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9b965a3f9898207c5e6bd28f31d3cc23232987a8f5f6e189548686327818ab0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88649f89481f5cd373d96b1dc148402a939da4ad159d2ea2b9d31dc40af19cd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2691473102a55e3c2f0246be1643774e48b694abde86db7971734fd53ab40d59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db131c95336496d50868d0e3b6edd9121ed10ab2ca6a2f3604df71d608c4d680(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dacd416a415f09a764a64e84ae973f053f0e38017e132666aa73d287f1092456(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5a1ff77ca7761664b20dc64c6c00413fe97e931cf02ef5400197252099400c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5238a612be3fbda46694b0ff2d5478a241c9060bad4c0f808204bec3e775ec7c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36e5466e050fd8dc91006a8891ae3469db1a7a60345b36207f9b6bd309dac84(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35a3c82d4aaaf1e82efe172cc681a22fc62e4a51569917954dec239d76034aee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b44111e883ca08276c0a5da4105808c57f237c868cf80748c2146cb0c9ceff05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40a4d62722555de8ef3041be4c7ed0af43a043ff381ad2ad802bebde63e74ac1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDeviceCharacteristicHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c5407f75ccd9b48b73314763ca2bf68c39b448366924a673c69c04139153a65(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffcbf5169e21140c261fabf1b3433117f73baa5adc722d545ac7af1bfde7143(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64d2395c374084e08386618ffb304778d1bde5afeec35ed7f1c194d6b69c814(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d62cbe78d38406a1268f9fbb3a86b99cb1ad0332082b452fe178dc9286636991(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ac27874b22dc9581e47fc9535b772ef18df05556b3c357b138171c390d3014(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8ad80fabef66dd83cd4a847e492c7129a18f543447b5422d3d0b93bd36a878(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7043f5593e9e12ad4129d287aafc0312053f055c19af4a922c48647b21ff204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3762df64492577436744b95630dbdcaa47c39765907a8ae46fec5e26a16ecf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsAsyncRefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4652d91a2c3c97f7a691ae43e25ad75a8382a2ddad6055d2b66ee4d7569b041(
    *,
    delay: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd8f47ab3e54b213f9de00eee7ba83205e8b8a793985d36d03c69b3124f1713(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__773aa35aa450b8e4a071d029ed1c848736ab703936f98ca345db8ce271062010(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a3149794f61f109b585258819eb3b9a96b37a06e1300047ec56d82e2ed484ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd3c0fe53736b1c5dc6765c218ecff878ae1488b6a92983d89b8a586581a30f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a189123a35124c94c5c7e54be915e64d3b63a5ee0fc43bacf5bf978a8a2a3d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88efd04d79222314383e7f2295d83fe5b25f1fe3ee3b214999a1016d7f59555c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__043049f43319fb9c3db233fff8efc7041cf14bdd444b0963f8a2082de36b225b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6156840876ba31f416d48060fd5e0f626d6a231fae9b5eacce53531ac125c450(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDnsPrefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__874f6949c7720a52002ab720a35ecaac519e9fb9c96c6bbdf30c23856d4a1898(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17678450ff49751ba8b2604d00483f74918bc3678c240058a5972523420ccec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785dee918ba047b224a5421468ab2e024318b19b1f4e5918809c73ac28e80f16(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8466b94d7830e98227cd7dbeeb70977748d2e2586e18910ab656c72ea71c0c19(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd947f802ed92ba251e4ccbf2674529a2ff1b006be37fba67df2dab2669e1212(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d9681821ac0cd8d9b39ffe23af2b7c5af9f827338bb2a52decabae37f99fa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1916764d6af92c56a3277713d043a0913da7dc1f476a930b6ed1d5783283c38e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDowngradeProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bedc30b8cda364e6df362043c1d06ad5030fd800382c0fd20269715afbe773e7(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38482b26f5bb98c2b01764f5684f07d74c12d303151ac6382ea8c05828949726(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c89fd4e45f030218a5d1440ad71428a20b7733f2d9403c6ff0af860be5e42d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb7266b276b45912e8f50a157fba194c7a2a106bcf4734857997aa09df52c573(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1cb88bafe244e0cafc120d00d82de4a47000a661e29848ca49192c6517f7317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a919fc1aeef9877edb274aa0e0cb23dcbed5f8543b3a79259dec45ad963e3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b17a23cc8c29e5ca8c60b104a6141d31eeb3d7d296b9f9db29163c81d00a8d3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadCompleteMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac238b4064e0ad0edfc07fe7c79eceadf2a7e03fd6ebe2da53a8ea3a78d9b89e(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22c460afcba7aae1ef716c2cbe392efb4ec05e1b7063faba5ed7e24eed29d0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0d6c370445365487796aecd7439790c646fe686f407d5386a306daa97a7642f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b354d5775487df23934ca9cde538a45d59cdd33cc58d1392df68e7acc6a2649(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b773d6eb9fa44af5eedd37b58c2c52d5724513c28f3f436bfdb68039eb9756f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60150b0e907c2d685d30798071d36aac41f316aedfb0f51d2a45847d153cfe95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ddd3bb046219c13abad250a212adb1740221319596a9d7c687e67a027c19a2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownloadNotification],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b211f342e3a5fd607f2700e134177ecd0520bc3b40d0df0945d250559bcf0c(
    *,
    allow_behavior: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    send_headers: typing.Optional[builtins.str] = None,
    send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd753a74cf64b110ec790d8b97fca22de6d14830f58b2aa0aacedae4a97cc93b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36e51159837531708008f16038a50a2e9c0dbe15b3083220ff1044eadb8bd1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4405499622489f71ff9ed96cb8dd798dd546e9d77cac958a209dd7192b3023f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c6fb4843daba8f6afad6c9a947a0e98600dbda697527875019edd67d0077b56(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b504788ac6f34fe738ea72899a41feac4c5d08501f92081a3e4cddfb4098c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c3a211634941cad2792a0c725a24e21bec8acc3d1f8c4e1a221e154d433d2d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56a9c529c61067e3802779ef0603c2eb527d6285ca47d2814b0c142767b76dea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecda227f06d33116f5814b9eaf7cea82ac262dfc18ca4f928d139c54a6941dde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84bfc1253857c538ce00a6cdf714489c5f1e9327db3d921729960def86fe3af7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f7ce064ba778c64799d5c961b8fe8f8526908cd439cea4d315b86fbad801d1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDownstreamCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad79a65d17423e452ea3f252a5f7381c2b67003a78c567cb6515e3ef0b95b46(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93a35e2d90bf6c27434ab15d01fa705542924fb4c1bc02bdac95c1228f7987a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c82866e1716b4ff8c9c9825d56c5ecc2d50b77184a1c276d60f17310582d71d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d644174ab292f0bd5a517a9cc5942698bc1cada7656a2b5f896edf379e3ac2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2634074cac65b3dc3cff380c21c666fac04e2df509a478a0df35cd6e68b2abcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b05b0ec20a05db029b90924a73c8188a5e8fa2dec051c6fad031aebd0ce9aeb1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7466989bdf4ecb508b61d469772743462f12dff024d4b333de17150f79896ad4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6ebd37a17cedb720b4b79c70adfb792a6055f35e346c5741ad71d4622bd9cf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throughput: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8c23caded697b9240e9865a979e3b228d0a11a5dab7fb9462cdf2d10862451(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84c27ce4c78644b0807f6026f5004d67be63888e534f863f3fdb7840529b2f51(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce77f9fc13350bf20ce2d3558fed5e147aac00b2da86970fe914cd6427ca548b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4659b19e6130974ced27e2a57ce5f2183e0bc8f8b0b459e7451a4d1be9028cc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaec34f3d4df4ccb410fa5d552589dfda084377aadb964cac990ab2eb121c10d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478ef49de76bedf663bdaa17619db02cd49039eac9f5841d336153ff4cdffe16(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicThroughtputOptimizationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4c31b7f1ed97ea9a541da9f84674b5867efe54068df0e485cb2ca14f79a84e(
    *,
    image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339caf41e31e57addc0b90c41c65a76edb4535466209589b265c497bc4c65965(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93a26cd10c17e272fb2f10c33c2056f5fe716e1e4d62464cac99cc9e5d18c0d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9947c5050bf951566e5c41e192be52cf2180bce623c9d1271e202ab0a4d4e9d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50a342960115c945f0055969ee46a28f074484bc38c48cec5a743df704227d65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86837ad02771c7f45a237c5b7553ecfc318e4c91332746a4eb1d902d7095e910(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f6b0a3059816e66af29fd8338c66300f65b870a456379448dbd94b43005dbc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b94db6f6392a18fc252549a127f224fe905f552b206c02b09136c3f2e4fe6043(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c5637c64306ca5432fa9dfbd646dc6d4fa24474174843c02e95841848b6d37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472720b865c5064f5f8c9bf758efb30bd5b1aa48127fa477cfc37140d4646868(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorDynamicWebContent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2ac25d1c8b27d8b54b14e3a6310ecb36d53390e29f35b0cb9aef4ac20174fd(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33259d2dba06e63aa80e11128e219fd0521b120e96295cbdbfc3731a3d598c75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__072ba721093d850324fc6ac836607e6bbcc42cde47d16dd2bb173ae07be4bfbf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a9abbcea922fc23fb525ae391da6aa655b6b02172b3259d40a6536d63cbcc8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3194f2211cbc48e725a266ff9fecb64d0244a001318387114769bb4a0bef9aa8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac8adec45476980e2afe551234ff6cba00c524dfdef379780f62be62f3e98e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2b32d2e5a4452c2d293c70c0f132f58843b6f2b1f7486061446e0591ab0188(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsBulkUpload],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c84624904b6c3d1c8c8356219a73cfc09971789bed872b1be0dd2e32168514(
    *,
    database: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b2e25d4ef98bcd103f27cb174ebb13f22d1b7b9e66c2af02103e0cb14c5742(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aef6037bc30e988cf3e7059ab6b062ca87fd26b42c933f3371823f349c6fbb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4646fcf259313ac8f5c7c0ba3351481842ee056e941dbe2172fe6fd2b774e70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ceffef4708fd9f13f0e0ed3438537a678a625f234bbb8e025e73c7a026ea0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad687c8b113b885545c7976ffe5ffbd9bbab7571719775737991b197b9f04854(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72839329811378eadc0752a89a7e6351fc82cda2bb88a2d8f098fc4a16ca9d86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eac0f7ec24fc3ff91cb1bd2a901c7d2ad56100bf082cb1212455a1825cd05807(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98aa33aeb9989f5ad4080e2d8c909ca515b6566e60843d3d55821bf993ac17e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b755294b47e310bdc38fb129c72f2f89e37d8fda705ecf04d176a4397a8fa8c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06b5e35c2e8875522f5df1ccfb9b43d5d1c53f1d3d0b7b58d36a7e0b42acc373(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDatabase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4747936aff440514aef6c7766fb2ec9e4f447bf5ed5cfcf400a6f1b97fa901a4(
    *,
    dataset: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ffb8cd213cf30e36f80de59f9b8553a3c9645047e1563d92d38d41cbd4f203b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59c23449deaa8a5ffad6a8b0b484b068694f0697933ed75cfed1ecdcda19b58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78f71cabddd081692aa61677384fadec65b94990a46a61e6208f40aa8d043ffa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842b25c5648192c6491464d37c958008e0cdbb800f7cf31adad821b2bf8f49c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5abb81651a47c77665a343d9171a14a6d0d82156113abe65f0c7892a6ca4e79(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1d0f603ab91c35a1df327186ed92183a47160888eac3905455429c83899675e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1deb4e9fae646db626265883509cb1abaf31556737b8967bd775e19e88a554e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b74a9e4854e82816a8e105f840ff0b0d37ae42f8072b95e948a1cb5544b3d343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b6fa1aa659b67fcf1ce47eb8cd10be5bf2bab287a2eec9fcaadba7e8c1da398(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f825ce837638dbf389726fd34f65fa359a9bc20b8d52349ad06e8bc90c9bd24b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsDataset],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e4bf02dbeee458fb5a862bc80c6b255223b79c1fe4d248e1e8ea3d4725e63f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e27ccea938f77442a8f8aa258b0047ae0d82c9de6f0591c44b938d0b3f849b53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff585c2f457a330640cdac6ad5dbc70ce409d599d40bd6f4337a873c29196da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76a55302da79b4309720d0ff9e390bc97670f6723c60d5c9cf5f6db05475fdad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d363502d60e0baa354d29e2faa39c43a4cfd954e8b71de1d1192c8f0504e5d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6018cf61582e57f8c0e32077ca681cf645f6c2d73f66b32a58b480ea4f53337e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0d4b22608722fad75c41ce4fb6388900a51e0e17c5c0e16601602d2de422ea(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEcmsObjectKey],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb478ea22be61a7a67d8079e2cf29729cd0e0c236c5b62f2aa9e0b76f958ebb(
    *,
    aggregate_lines: typing.Optional[builtins.str] = None,
    aggregate_size: typing.Optional[builtins.str] = None,
    aggregate_time: typing.Optional[builtins.str] = None,
    api_connector: typing.Optional[builtins.str] = None,
    api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__679a74581143e7dc93138c9b5a41578b3d6626fa1aa817749d70e51d35da1ae9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0469edde61b695889b5995e1515f30c212a0bdfbc5623392c177bcd0f54482f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df3f1e901f9c25c9a6ddb8a098a2c5c0768c7ba972405d8d886fecbf91217937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf23b3e9e133948f82ca13ca9e31889f803dde77506d6bb657b99c6ecb187c34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ddb0ffd779252bb638b6ed2635453e7e3c80837ce634bda15d0c3a80d11eef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__645cb0cc854541010351259da96e9bee3078a7ef36856492d0f7a1af78e59d37(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e622dd1a9ed9da1abdcc057b1ce3402e93cbda5c2e0485122feee60995ad22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f5bc4f0d32706901081f0120a3e9261a3c06db57aeb1361e1e625b1d07f1e26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3905c14d998a1884330e0d7e096156531e8a1597164256048faa49131a67db12(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80bb9ec21e8077309d92ebf843a59bd15af56f3febd1c60f418e983d4bf585ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2b03ef81df85153f4c98543a93ec95cf539ad0727ae25e840b5aece31b5ac9a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84af00185a4f3929d4b4bd560c6d578975b72a89a7223046c478cbd08c4db36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__021c90a423f1a516c2081e6fec57f4cb65c94489ed38a9f8a08543b44b908be9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16b663777fcd7a5e734b55279b4b98aec4a58f4a0b4a1461306af0132e3b7b8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeConnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7bf502d5374e51872166fe680b26203dd4f8d2f9200cdc2c3335a58ccc9f90f(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eab98155000015b978850ec32a8d0306f6bc0e353cbaedfff0d9562cf7a5aaca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c233855abb7030b3e53b267701e92004604e3961848d0ff37f9b36af2e937c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5728aa5e120dcf011d2530b190a8c99e23cbfab1a5872039166e2e56ad637092(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77e02e04768e41073cd79739f4721eba73df15a1c833ab466a768eb85f912e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e23cfc8453576b837cde03a24f8cdd0b434242be0c26a852b71bf7b8bf1f37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa84f7105330a69a46f3372089360795c164cd666a100c0a57fdc97b051025c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8043e3bccfbde61a5aa8eaf3ba4bc079d0e833f596203657914ecf4bf62d038b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6942cd8aa154099528fb04c3a1f3c4407cfcb911e1b5886d1e8b6559629466ed(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    ip: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9dd3665de23095d98d257f49567babeed12e725a2b7ba8432babcf7c97ca82(
    *,
    absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    context_root: typing.Optional[builtins.str] = None,
    failover_hostname: typing.Optional[builtins.str] = None,
    modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5710f6a7e8f7994aaaa444b3655df41f4a558b243dbaf8717d0223ed6f916426(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ead3eaa10f8e5733f882296307c433af6e9200cbeb0b2adcf3f9084f986fdf6(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa56a6c4fd019318ad07f9a036d9fa3cee63725fe09b39a53835fd672d24c59a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__555495d9d4ab58f8362c965381b30c58d1d5ea8d79f5fd8e7050ee64ddd1af6d(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47ccb96302da2c6c0619569dcb74d6aea0be782035be939c8f47b0c2afc11c1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd0caebb7ffe43edc69bb919d7cf79ad535e7ba93f4020089324ba819de8afd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8f7043033f22b402d1725f3b7df7a075e4b2289744a8cc9b7dcec4ad28d055c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d8eb3d70854f94171574a1e9f993e72fba5db10c39bf8f566c6c61356a2f95(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__499485d35457e242bcc641c5ba1ee150cb94926ce5252c4e1989cd73f4022a48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cafee8f8e81e3376e36ed1adc4e4d27e69f72a39577df760ee5935f4d8a7a35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__773e18acc9bd95cd1065cfed685c46a5398bc7578bde96dcdedb099343dad668(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c6080c1e89ef2f26dcba7bcb8d92186d646ef414b9899138de113a231df11d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7923a74c935e33451e1b9399a897d1f2b92afdf2f1556cb970a4fb6c65ba111f(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052ddc00b29bff38398d045bc49b58420afa6cb82dfda75770ca3c892a30fe4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__699ee1a8660ed9a7d107eff0d8d725aa2a965e041a381ad4da8efd8354f13fb8(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4792c078576b64e167b34bef78098358fc314df3a66ab8dbf0846e22a7c68e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19cfe9887cad84d4dc1a55f7504e965f146c4a658c7ac110b815566a175629c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__609580e4e21dc17d3c8f6f3354fcd166704982340d4c92f1cf5f9eb4c74ccec9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dafe4ff911c6f9b8a5bece315b8a496343117f1643a566b6838405dc40f85da1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5875dd0b856bcecb3c7f5227649b9783f16bd2e63b416065e0fd041dbf4a8746(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcad6b193e6d6ccaac6dcde329358b5c4943efc16a609e25fe723bf694084e53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28b87294eab6d3b8dabccb46fbbba799126cb076eaf0591660f259a1982366e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12bec11930273ff0cb6ec6cb36cdcce3eaa2e4d7290dbe48a8c9878fb16f77b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17060c28d051c60d901ad0e4e717045bfa4deb784a0530c5a80deda8216e7b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4cb57fcd36d4a916f6270bb62a0f9db20b02a1429748ae267bdde3c9dd4b62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da63ae833c064f1bea93a6d15bb3ee92a143167b366994c519f861f73ea3e0a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingDataCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f0a8c481b065e5fee007c590de944ac96a8a8f21cd860b4182491daa41c1b5b(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_persistence_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e7282a08c55439404190422d05391c9aa5e258e05118ecd7d0791242fb2d0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab08fd742c4969aef6f626f81bffd2902156208e22069e88abf597213da001d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fc67268bda442db235a93c695d1a297c5b349cc33f91577967d93e06818be7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c2d4187163cbb613f102eafefe3b60995d2ea554f62a8a7da0fe303ff069ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d75441433f8673b2ce480f6a3132beaba9b0db7c67e62bb1a1fe57ccd553fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b401acbc4c01dd8b74d80335c18e353b47ff66b0719b87e860a250cf28f979d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7c8269d6d6e8c351f1cb68ca651f3dabf4a417b88c82e515b36e7b921355566(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3501340bbaec91ed465b67674bdef646e8bb116ff62fab54dd4604a23bd7bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__143ad10085439dbb3d357e7b6713f8859f5c8f781b6bfeef6c5584ec23d02cd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c405796b69977030f7d418d28c2d85c84b582401d8f5839451d4cb458a83eaa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a82d8891916b64d569b49069b1c4f6f29b0af904b9504a0f2ba3ef4d7f96b5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeLoadBalancingOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46a05ef9d376721f5d8be3933e16eec3a79289580bfdb9c5925189a79c0030d(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    domain: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ffd6580c87e8f6263c5671c024f6c93c1de5b12ca7c1129f7132c95695b0fea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b08ea04b6888675e00691dcaf1f64ff06f118dbc0eba495f9dccb8b7535d74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3b758b706bfa361a79c4865e2ed5debd4aaf418a6669e748b7f974204d5b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7bab29e7623221ccb587a3c7116c2b3321dc9754323fa732565b5026f560183(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ffdf9ada8443711e0381424d0c68cae961006ab89b59b7f9e30934301b1c7c0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6dd1e7ac4682c958536202d9cc18c5a0e4bcc5702620e4543fbf66c0ba91d1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__066f17aa29c75b167505076a746b0bb4efb326330b636bc8493f06beefb71f74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ebf67ee118624e2d5afeabc6fe41c0df617a809b980a71199e3bd2a732a1578(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665b152b863add924ddd31f1a4e94f8d673fd23f2c78bc93c14549c8b8d5d7b4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeOriginAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dedffc4168a2ce6c596181af27579d99494cffa4a63d9e4853cecdfca578ac49(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca9d1703d5374aa90938e97a83e575110026f45d274ad2d6ce8d44b578886a2(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ed08d100af0b97a595a6e8e88ec08fc109bc7aa1d1b3714b3b90ffbe536b16b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ffaa577b01b66a4f1f05bb9995300ec973d52a6ebb2acacd93dd385bf9e9add(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e57ba02c554737b7378719852ab7bd0b9fc4b0998e8a656228d6ba937828c609(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3dff3dfd27a9ee06489faa5d5bd24b2285ce1a4e1164cfc432dd8afd97bf465(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirectorCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1929d24b46f43dc19e31d6a7dbb7b266f0d7d281fd1f1e6ccf9b936677d6f2b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7146d768db2a2b3da0497b99d177c156d0b9e8dc110b7f0f1a1d398c97f9b8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f553e16c55247ff2298e3b977a6d0d4fd7000cc9e38727b8f0646f547234b5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a156d197c392c9029016e6af23f2138539d59cd4ea4f7467a5d85707d334c285(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f580872dac7396b8d885d85b5398253644ed459e0c8c98f4ab3f855586bfac73(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5806b10401b327b3006e39af1037d2305b0cd13a760d29eb5e3b3e6910ef39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0154259811bd5f1487d7e466f7e0c777a8ab20c56975a7a25957466b1b028cbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ac6572ad216425a7740600dbc610641c2f809023337115598c1ec6d50a6bf6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeRedirector],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1deb216bcd09cc0f29c8e03a3162c68ec8c66bd4d59276de7014efbb440484(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a5b2eb0fbbb2d4a02061c9ffb24de3f32ac894ed0c28ac36a84a8a662aaa21(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02bbd86787a05d9f5bcd8f8d07626ae4246292382b5736467c1450ff22b8ff2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4704ad3d16074da4ff22e7fd9aa5e7e4cac5704652ea980222f1d647ed3cb479(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf0b2e9e0d4c617ba5b7ef52c29db1e5333ba5c7e5d677035de55fe8d0f71a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c8b19ea6b7c4e8a2815d7b3e0aa48fe92d68e0dde485b5b57a7b8d5fcef77f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f500e77d08d98cd7ed0ce083a794a5046b251d4b901f32338a61be8b7c2ebe1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeScape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7d6e4e3ec39bf91c8677cb682c9ae3b504cd204742137c4ff1955599c69a72(
    *,
    detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
    i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f406ad43570392798fa949c646b109e0809b48c00298486ecf6a3030e964dbe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d830bceda6d1acf9a3e947653721f69924c1404122579b3c8899364dc3138c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e844d43a71bd4d873fdad5e2cecb3330d13bee1d971da9dd4b7826287010987f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9af91a918860bd3f54e2a59065ae3e32e1f2d80eb235b74d773cc2f4069229d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c689472a737ca6994e547ff01d8ff8dcf2895349a2b7ba7c645e019eeb28e5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838640802d4f4b67404562a8d1209d6b276b2a0ce9ba0c024443fffbfa91d400(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f3d78a0b667047c8a5e8d58b35233f1917db8a87f545ff00af9113bf9f1007(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b408f90c0021116ec95e72468876ebbcc12a1b8ed862d8cf400eb6bdb5f5ec0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a70ab8fceaa1b9453a70dc2e703e4f0875f8b815eff9d26cd5e846b20229c2d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab00386f2c9308f11c713f279903004a0d3dca38ebe55f31b8144e3a6b1f7ff5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2316d85ce204af2cf2f04d97e5f835bf3eb2793aa85af33b9d536a950460e4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd72cee467ecc020ad517be78efa3d3cf4204e33994311c17965aa83467e6437(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeSideIncludes],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b3c17cfceb46522a1b1eb3abe7444eb4acb458d497b9aabb6c728a159c3b51(
    *,
    create_edge_worker: typing.Optional[builtins.str] = None,
    edge_worker_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    m_pulse_information: typing.Optional[builtins.str] = None,
    resource_tier: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be068696be0417a03fcf2810c7d28c3f1a44e78544f925b126b2b315ac03dbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__994b49dd306371f546d68dff35fb7a7c49d20a8c23f8a04ab85d59d973076ffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ec758d67e3dba77957e4398717e76d59e1464ce5bf16110d87e9bd7113ede6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a20bb644b0b993a1468c67d029aef9d8a20b047dc23af0c3d9ecfc2c9880fc08(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5ef4f55d4e4572e982567093fc5d4c6c76dc77bc922ec3d3079b2fe4810e674(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacf2e055263f3bacb4ea9a8d0e9b306dcdf00937c62f5ec4ac6d96a0db6cd52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70420d85902f83317353c37a2ded76ada705a67f4276c2c324142ffad5d96acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b2263596a06e8f4b35468a61f77e64b12dea371ad2577acd52408c2d0e8a4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__844f47317b1e129731d58dd07d81b6e285822e6bc256b38b59ee5420acc9d497(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4449d252455407803aa95ca317ef51cfa570bd99e2eb78de6d246db330ab628e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bbed9d057b58b22e4b9b16ecc199edd423d0ad66a1e8277c3ebfcd91835550c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEdgeWorker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62276160005b7d153e6ddd81af5a941776d05e509a408783caa7f5b2b199ee9b(
    *,
    certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40a6786eb3c13bc894c0a188efb95e0de93880435bd903b3c41bd9e568a71e8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0afef3feace8621bf80c0a6cde18303e948ec14068656d7d835b04bc9ff502(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8c3102f647a7f259db61e1bd432b821b09fd3f5f4c2e47fdefb4b91e47b7ae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed124e3c383d7416f27b4fb3c2091cf879a37e96d4921cf5a2b72a5fd39fe087(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0be12832dc9a4e9b31cb3b7ee3f9b4da900439f0502c98b45b8ff6f851a70ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884998326116fb8a82aa38ac231c42698f5315710304faa37201ca0ba08fdf55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87fd3214933bc4db18687f263ff8868274d905a942724954c01f406f995f64fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5fc421e6c3077a4ccf1ed0104a9cbd4ea2c31cd905e69f86d81bc82d6fa4b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa625270a57850308b8f1c51665e5aa2d6405850cb674906a00dde9d25c9c63(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnforceMtlsSettings],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e7352441b734ec55c1805a2a86639c313719f6d8d6bcacf1a8e0ae41fa2f7fe(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7a53f699441eb7f3614c4e6b1a42822171bbef9572ccd6ae7a09ba0c54ff94f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ec84addf90d32195424ef2605184c426a26e8d0f344312a8bccc394f432418(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e88ab326a334d932809e93addf8a48d63ca18cc2e146b4c6efe7a41c72f44c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__990843715bed5f764ed3568e666c86d41b56a6b01ffe03647ef0b5c91f7dec86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b865f8d9950b332bf1156a7cbd3d43c5d8042f50ead1b6060072e9aa893e2c65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa1b097ba4aa96032545c0ba947689f86405beb3000cfb39461848484e742e2f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedAkamaiProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78aacab00b796e56abfd335db49f94be22396fb99d9220295651f4e6eac0a7fb(
    *,
    anonymous_vpn: typing.Optional[builtins.str] = None,
    best_practice_action: typing.Optional[builtins.str] = None,
    best_practice_redirecturl: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
    detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_hosting_provider_action: typing.Optional[builtins.str] = None,
    detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
    detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_public_proxy_action: typing.Optional[builtins.str] = None,
    detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_residential_proxy_action: typing.Optional[builtins.str] = None,
    detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
    detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
    detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
    detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
    enable_configuration_mode: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hosting_provider: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    public_proxy: typing.Optional[builtins.str] = None,
    residential_proxy: typing.Optional[builtins.str] = None,
    smart_dns_proxy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tor_exit_node: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    vpn_data_center: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a790537fe6f1be1e6a902f261003dde8258987fbdd6f13ac48812257bfd328ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a8349074dc871a35900fe4e64f8b768538f0800c1a4ae96d71bc1df56a6df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42be15746dc7fe72e2323ef3e2ae3ae3631a84ab46bab81a4861418ef9ea359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36fd9fec2d79117358b2319711ad3acc5ce369be610301b2201e70e8728880a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210446837c3505e661d8b77d199595509713586be047da22d50a4a9d382e177c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6747f409ae076234f85c8672e520046c43443546be335a398654734fb7c455e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf4900195dc19e0f7878b4614a80ae2b38848844bb924b74e272731b4c6931e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f861dda54397a3ad91bed60ead5f4d7c30873634cae4f675d4e412e094f241f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16a81290188e4f583988b0b4dca9f6ed62df2a38c5028245985897e3f4c51bdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07218f5d0fbc9ef8ffda0aad36ade395b29c474642bc1d53fc81007f5bb8e16c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9b7ae8c6802ca43404a5fe8c6b92fb48f2faf2d5aa1f858880fa87654d5651(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9601f766e2b8497cfcb0a24116cfb147062427b05d1731422bd6c2ba4934858b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c02e639e79b87b80a9967ade053e40466c0eea0e3e0a7b24430257280b90726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc33514ffb758e4a226c55162e57b73d10290e91a9ecba4ca5509235cacfed40(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fd1b3f94262bbe2ae8d339b8f831b07fe0b63253b158b764cd105015f1124bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae8a3cd2009035e73fc5b7e319d3fcbf01b1e8479a75429d438818b0f17416b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626f0ecedb70abe2aabb063861d8dcf0d1460856e88ab080f0ca550f598b4a81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__939ddeefcb09633d0ff62b735e7c0f493d8ba39988d8df1166b16884af821e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8de439871637f8563f592bd8bdbe882665541e84a059a832a3e4006fd1917b79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf2da0f645756b8e316ef9c61bfe7fe01ab35fbbb2ba88fa16d3a5c2ce212fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1344b10f31b065a606738ff01f84136d8b2b866e3c775a871bf8c6f67324539f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fa55e48972e79e3d8576f581352689f581e973e3b0ff1e48f1392f955450b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4009959f02924899c33a4172cd6f2dd1ea167b5cea214c32c459ee2e141df7b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f3d99b97016d39dde1d862de6e5039df07f56cf7196690bb63442b1eda9d2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c3cd8f6f6f8cde9a4464ed1eebb96a5ba86d429987c3482d8111c4e1a487ca2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b29b381863084116b9ef1077b4c434486b6dcbfe867e53fc991b845b596247c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbe54f917e105f43929cfc23a06638cebd8397284e211b944d3ca5809ece598(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0ba41450cc5adbc8bf1305adeae7b63b98d5b7b91c5ee43851923ea6fc258a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb2f55f434cf7fcfeb1c0a3b75e5e38dab190ee44ade2d6fb160db7d0d73c2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0e20b7775a2ac04be3922dc0d3830aaf1cc085bfd80565ec1e178a880ac351(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657283a4c4258c8e5f8c8f48a52435538cd1f7c9b978620b5f47bbddcb721b31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e3ddc51ed5757c183129488fc2dffb753b62f9eac16e461b200eb20d75a140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d13ef623fd4806fdd293c444abaf444d4864f326c9b70d55e3334211b09b7fca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef89746c1c6497fa244a48f2c6b8248b703a5d892b0d1a4fdba6ac97bdefca80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02ffa94fa9db61876bdf2cf932a25503b820496042256a46f30d6eb9ca07e021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8394e393c45d8ffd5e365d4afab5afbc33cc27e55321145c1d04c0ab49412619(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e0e11e0f60898eabca3d65bb7963ea621c7df90c8d163e08cbfb1a220eb75b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c825ae2db172079bc796e2ddca86145ca99694299bca57387c3a4c31ccfd8867(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEnhancedProxyDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d54624903716d65c6f21761e69570e475466bb03f773dcf53a8d87964ee204a7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dfadf66cc54ee72ea8265a72eec897e4613c5d200d946d6b0cc967dc76a4065(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b710f0258133607ed2fe06150b7492daffede44ac31e139e2889ec068d2d210d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdec431717b731b4f96a9250b45d2d18dfb44c92048277c035f6ba1feeaf8087(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57fc0d2404c84582f774087cf9e864a2c1c7d6b9f7d549af210c82ad46e1a81c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7c7c272a83b4c51e9e3360e59995dcd14dafe759ea22c8fcf4485e0cb7d204(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f61d9cffcb2338c97c1b2fc0145280a8233545efb7d815877ebf09d3f7980a35(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorEpdForwardHeaderEnrichment],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__449548d308c9e33b81bf09f839ac8cb61de7065fb00df477440a7c497f4a3757(
    *,
    action_type: typing.Optional[builtins.str] = None,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_hostname: typing.Optional[builtins.str] = None,
    cex_path: typing.Optional[builtins.str] = None,
    content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_hostname: typing.Optional[builtins.str] = None,
    content_path: typing.Optional[builtins.str] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_method: typing.Optional[builtins.str] = None,
    dynamic_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    protocol: typing.Optional[builtins.str] = None,
    redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_hostname: typing.Optional[builtins.str] = None,
    redirect_hostname_type: typing.Optional[builtins.str] = None,
    redirect_method: typing.Optional[jsii.Number] = None,
    redirect_path: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def2d452c59ecbb330ebd6be7c2cf96643678ab05b3711e8780d6ed05e608769(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fadddfde6b69b8c40aadb738d1103a60bd55ab5f3c5d7427cb418d3e2e83d98(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8e788f8354f915767ce85887d8475dc9d26a12ed87272c5ab62bda0cfcbaec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328b5ddc1bdf1723679fd45d264ac2cd2dc5f0b5e46176f6696206ccaa27523a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33240f8502e25898079b09349b437c53c400b926730c28de6d6bbd01455e7ce4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20dd468cd6a360ea6ef0fcb61921bcb476f32acd899cbefe75c6e8f8eaf7a33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__101011ebf0ac5978caf664432ce4a94cec9fc1328e81561072f045852dd61b9d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815488d5e81b6fc60b31e97af06680bee33ba13e3d44e34fa286892a0f7627a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556e0920efeac432a09dde6bcca3d649032b1287d9d3f2cda8faa84967703244(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa70aae68c06a5d5f9200c5fb907dbf048a6aa1ef77fbe187cc489443e085bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c04bddac96ada259050a5ef1bed99b72f22bb1c7ce565fd4056612f7839fa2a0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06bbfbb1ebeb46afdc9657f95cc11c72e8ff761a9302b5f030a14e6cccb4aa6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc94c034dcf0fa71c231446ec69f466b6d1e3b1e52ca736e25a100400538c34(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3e5b04fc684958aeafaf049e16d350aada968526591962105f8d7af015ea53f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fdcda56c49277466266f8bf50f06768c14f09b3eb8585aaba4c629a0a21323f(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae6fcc6bd9b31d2d6b92f04e8db1e5572755bccacce4d87f1f41964d89019ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887a1c65b9a113ee575e1558e477e5ce42fad7128adcfb7d05ff6f6eb497a428(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a23472c5b451d824001688fad3993da2969a641f0d39cc9fdad847d1641f0086(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77750fa8112953e99f5e02252e6db93dfabdc91dc76149a8d9b58dee68168442(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3668373af10746c9e4b3b0dc1f6b7bbd3ac1006e1766a136154bf50af20fea82(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailActionNetStorageHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b61f2de2b3dd0328f4267efb367771210b86d7d96e5565a5c2cc11720945f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea32208173db9f7a22f34e5d025f9165951b3d6ab1cca7f0159f1ab254a25deb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f108523255f9ebfe868e00fa9cd37ca188834d9c1fdc2c1b9578d42156296711(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a219b03c2942ec555e9a2f45b0b242f441048dfa9409adbaaf3ed5c710d5f2d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8b34fc06e2fd1b8a7101bb4a33bd1530174443cab7a1c5ac0c9ed0a9ab0ebf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6146c87f8d53f1ae51e7b4abd3d2d00a3148208539d370666130eced00dfd6d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14a3993d880c206e5eac31890ec5aee32ce8ec6ea5a2b805c0e0e9b311c3ffcd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046611047eb9915b84b6df1f521479c253b94232e265281bb9e87dd366380123(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62e31c94de894236e78b840d768337c296d7d6f9fac58faf52772b27c1c4b3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__202a43539cf780a234dc557b76cecdc50ebfd07d3da83faab50a0955fff7d712(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa75caba44bc627f8f5995593ebc5e7c09339988d783114c5509f9f2e392cda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d847066546a28696fc786886afb7fc03acf8d8ef6b9bbd5f6efe68ccd1819454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a912190b39d4bd930e7ca4aec47e6fa220b89f102e3644af33503f58e95c905d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783231e49f9d2fffe0095f75ce49b88cdf74fca6973f5ef91239e15f238e2e93(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f0f711f8e7647102057e53150420a45730e5818b1c2ab11ce46223c81a0faf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf3ce86d0bb8cc031dea9cb18cc06e5b6299a0e7038cfb8c2ffd4e2a81f3a737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a06ae525e7c0e41a307e39eb4bf09b32bbe2c0701d6520604df54b0a10f990fb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a927ba15bd8e0319ab227c502be6cf27572ce978dbf2d264c598ad531489852e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60cc979bc19b7cf38afae6e86afa0f31c81a8ea73c71ecd6e15bb74991ab68e6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b2892dfb57131f70cf38f16f5e58d0198c10408382a61093a38d86af6eb1827(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f3ff6670d9a185635eb2167e4cbbebe4ebbd7ba94a502d265d08d9e78bb01a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f229fd5cc059e201b2b10b99c4ccd0f748dae82bced3f63cae0eaff90599862(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9077db22c3ee1a0fff2c13f44781270e6daa6bbab8270484fa291308bf52bcb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d9f08ff4b1091de10bd47ef3344f55b45265f4d8e49f73dcb32b70486e9034(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa7b3cb9222c6da80bedd87938220b2a242ecd237dc147362b22b0898acb8bf(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6492c1ca94e617348ee2fef50f45bc7addefbad7157351623bcf6411db716308(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db83463bfe82579d23216442c9ba002189a534e17aaec7fcaa42c697ccbd2521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__167040f73d0b6c65d09aa395f506d771b857459f99418d7ac0776c9194b83527(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b931ea682e2f4ae2bd79449da7cd11113113ac3f7730a47210150be72e1757e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b8cd1ba89525916399c62fb0ce7e71f42a965a886cffa4a2bfd37538f221113(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d4bb4f14646f67f74e5124f48787f21eff9548e901105f5ec2f77077f2e434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3002546ca149d4a187299931e73a7e47715925918a32d64759003ac2ec334e0e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2748d25993f293cc321ed8e09a5cd57a7950d859f1cf355c273f3450ddacdfc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557768202f7733a19cadc8ae018c81450b1e9f92b96baa4d171cdf1182f67ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a04a94a2dd2ad0b960da7367476682db85c81ed72c8eaf26dc0a79c1dab616a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailAction],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1edae69d560babb21c7fb17dcf8f9b9bf3ff858b68cea289bc07ec42a82e303(
    *,
    compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff290ccc01a6a9559ce64eeb111bb1ffe5754e3776f82632ef75c3c112e9f477(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a863f03fab2bdaff73ebde432fe0489c31cb97297e4efd632161073e952f7d08(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1eba181d6778981a5cebb99aca866a8dba6809bc3c178f3d855df83bde4ebb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5771c49b9ff5059fcfc7d79ec475bdad631d82fe366c5b29773a083ce2550f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a3b6d72decdd42baeec8e778a7422e517771b3f01354894487377ce29fcb695(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa12b543c4b585074f3b6c490b9112b58ce813c5f06431389cd8cfc28f63c7ea(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFailoverBotManagerFeatureCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91df1b66eb3f7fe2de4d330b1c7feed30b05bda1b08c1b691d6f18a9490f4b1e(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7dffaef76900c6145811499c7636c82d66c4995d7330b4adac91ed3305eecb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb70194a9e99602a32e2b09cc8d8668e6da47864a16abed267ced2cfdf69fd1e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490731fd30f8d794747a3fac6f07bdee50ae1e15835290101e1ec38a56dd8d7a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d87c8274927e441725f233032862026030522d3205b377a2b5e0e5db41083901(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657376fcf9c446b29070f1fb25734cffd4b0a22fd61be58475cf063ecab934b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fca29c8c011ed25d73815e465863a24935292b315b2c9501ab855346bc4bdd1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFastInvalidate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8edbf75d10a268c7b631fb87d9d4526bbe0814bce957b3cd2b9a6ae94fc69afc(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892113fb598964261e2e2f0120e6adc6b24b20716a1af4f149ecb4ddb23e48ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f48df7a91a47b049e0817d9f03fc35529ef064067a10153abd0d9fdbd7251fb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7aeef377f47d2c246a77f9ba4efacff2fbc188e65f5d3c275370cc94c01eb8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3027bc4e9914e319b2724ded5933f102a7662daaa68276e3a93fa888d210a566(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__579067a0a17f495736d9068b1f55b7128a1ef502f52961f5764a9e97c557b21b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ae3716d24a8271a03e61b3e4a041fb8e3afc156886569dc281218b8c180fec(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFips],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8bb3819f293611fe376d431b5d8a76eadf03b931d93d33f31a9eb4ad591709e(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464ac3ca81dbeaeaaadcd9361fd3197be7edc7d1afaac556189927bdd152d7ef(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbfc018334fbd5c04db39d45cff4ad1dd5c556ac5b7c0f40feaa9a928d971538(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1efb9f9672208a0a93557794b171fc3ffe8d36ab2736a6360cceea92d45c8838(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edfcc32f2a4e41c1342e2027ee0ac5e5ba5e2d2b6eb58359f894a13ef189d0ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ab2ef344c2979cef8cff3a06fea90657fff42f61b730ad8ec19d1f43ecfa87(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c2e067c3f0d536ac8b69db342330785ee0376a60929d6b7217002b79da2822(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d42a6208652d1a2aac6829d3cb38be707eeeb358e1dd43a6697b92440f04adc2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11fb4ac1e14d49c6c8696d67172c903cd136f4fbba23426a8ec1da4a5bbfbda0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c6bde77344a17b63b092b6d4e3c0e8bf2eea5fb389b04c0b37e123c971c9b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294632948c6a504bf5616583371fea54f44e8784fd2e4abde597385fb3a14163(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6b78d898f4344ff079a41c55f3b3ad9f539e82fc90577ff837b6773cdc82800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1c263f91fbffc4d0b3140850ccd2809e4eb44d565352f0eb2b921e4b30c849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec381cab561a19cac184d8ace1f0ed637c21aba74194117646269a59364f388(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2dcd3ec285fb5de6feee7add5551d18e96d8f58c12e11eddfd29b334b487b8(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eba86cf80beec2c64dca241969a5ff1143fdb359c14eafbf0c5644590190d13e(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b534ecaabf4a4ca79c9763f278d4435a7dc15e28c9ac9c56277bcb71aa9bff6c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f0b6324f3f4476fb79579c742df198684c7a0aca2c07c7812ab3fdad831bc0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2afb578793ae8911e32db3f8620ff7c8118dbb252699831ee78709eb912331c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__267c67a23ca4955fe2e5758d662d1dad4347f075522688ea3b63a58f76c96ae8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlusCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a4515f0f073f2943a8c10713444e9970a0a140109e7430c47e23207aca4e70(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0910e7680550ca5c8ae4c3d08d46a883b2ea53c179f865dfe580599e9cfc82ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f04faf410dcf3b07d1e04053573a82eeb510b341b33779fd332400c5c5fc220e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff577fa1d66e90c2dcf5dce7e617401ec73bacf6c13417866d011d40d540efa4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f40b5dd57717fde40b14806e437e784d4ac6999bf1b4c1fcf4d0907f9936910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7327c6a95b56cbc9efa41c21361bd1ae8bfe38fefaa19fd1c1ba7856a7f8e151(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55539a6d68e46028d82687fd38382b058880a2f7f9b1ccbdd376c69b342701f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d212dc69b381980f3aaff0cd4d3d4a90a43058096bbe6bcb75f70b620ea15246(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorFirstPartyMarketingPlus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__221c92a6ece3aa41d19c6975320ac61153961ec335a64fa76d97191aed8aa8f7(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc2fd872684ed33129b95022643108d686a846dc5938496a1279b7a6f7ed5cf(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65934efe87c72963c726476e4392d73e5b97601448c3dbf08a9144245abb7f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25671441adff16aa9d069d353bd0fd82ede13562743953c9f7b2a7308f17000e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1a504dd7739b5fd1bb19ef6addd84a7704a2dcf768bae1a8f2ec154dc5a442(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e2df7570c0df817f6c12e02f0439b3b932249bbfb79c9555a4334306d9822bd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewriteCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54174898e3c109dcf7fb005b96c6f900d3f3e26a35e9f61493f77b810769b936(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9dd522afa2de34c8bd670a69d67aada5add518291e114acf04cff9a265c3a56(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d12804bd672a70bcfe917785872bdfcf3aa991949463c9f64ee31514efa37fc4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3058046006b30be9a1014ce57c66038d23db76af4cd06e067d407a2680f366f1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21135b8396f28ff72fb7dfdb350e57037eee6299ffe310aa11e37fe85ab37034(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db8369e61088bb96bc9deb07325f48484164f45cea919d43e82168df479bd50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff14f51130fb532576299fe806f32a2c556ea226a36a3481535696b51b0299a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cdb3c981f48f1573949b712225fb2cd698da25b2f840bf199b9961debd860db(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorForwardRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe2fedd98892344f8b09618dc8b3a78ed4c4b7253f5698d03ed86bb18775143(
    *,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    data_header: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nonce: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    signed_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12d8aab925f54abd2a1fe1649a1d8febf20f052eebaf934aa7a88be34cdf4ebb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be7455a43def4ddef11c2575ef63294eecf3eae61d9063febd60b7e36fa34237(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0a5784035fc8b52ddbd377ca5231053381703451f39ff69440104ea7ad779d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76112f3f705aafd0ff4a471824bcf6df6a2fbe47e630c08d461bd7dabea0c6b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e105e068b13b7d498ea5f69dabe496c27d952b48e3c4579c2bca3ee73deb00f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e8ed25483ae454564aa5a8a7d87582571a6ff8c5abb002a28e6724d9759319(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d725e1c530701ee94ff920739ce892adc58f504484e90cd30144c6e5798056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b9903047f496661504bc02c01883bfc11f792a0a691709c3de5caee84daaf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8b4f56f2c629fbadfda65d14a323eeb60ea333e21774c5590e6f9c6d986092(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeba86ab701264510a716480b848cf77a98528cb7871ac6b1bfbd97a804ce16b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d43238752131204b002d301092cd7bc88590fd537db251af57134373c8807730(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdcca72d8fc21f84e9341a5764268c6074f2511a7f7767c034e5d86127a00026(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9e3cba22ddbf882f2eca5f7ae8ff25b65a87adac64fa71f7fcd54b767a2b21(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorG2Oheader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a93a714a2348aa5042adee41ff0768db643c8c0ace930c2910bbb7a9458a2b(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    output_option: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47427f12000caa59c28272b32450192befcf8b913835d9b48641c0794695757(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5c3c630369b042be55a4339c0e33d24bc56ec66ca73ae81782bfae4cb31748(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667fa8601065c2d72cd57307013866845c70210e9cb89189b6977801247da4c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f77717455f0962db55b29aadacb3e28061495ab65d33dbd056d6219b75a198a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0b7602c8bbb2a1207867d052520c7abd5ce79e200c5a09ea88a83de44fded2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c96e5762fe74c82f0554bf829a1fa8fd81ecf728cf8aaa35f195bcf5f10f45b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba3fe02b0f03cb57d5fed5542b8de5ff1624f87f2b9c88b7f3746466f2d27444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2b6255999ed23135e2e7959dd4ba2f56e50ffda381fd856000aa509bb59bc3b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGlobalRequestNumber],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2e9bdd51085cbdbc848f8061f7ae135a2fb973ca96367876b4efb13659c2514(
    *,
    advanced: typing.Optional[builtins.str] = None,
    cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
    operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
    post_request_processing_error_handling: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccff98162eefa80ec0a296a81c629d98eabae8c926f5a1b69db696240586b830(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdccdf5a1d0c7faeb467b2d58729aaa57480126080df593300e6c9e4cda77e3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a52dff2cc984842cc0eec1b45745ea82bbea7ee06f2b706ef5370fa4deeaff3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02be935ad2643fba1cb5136f7967f82364fcd800392f6ef889553b22554d5394(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f733397d86aa9fd6dd9b2cfc1d0a8a0c8f729ade42fea45115c4bfea3815357(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19f01393387bd042c4d17728f459b6e81bbbb3715c526c82c5dfd7a70a3f5c97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135fbf1cd270a17857ecefa01d2541b273a6c79d843ce95b76e393cab3a14438(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3a00a5f9ada7c2ded976ae4bc0da0c0d9951f8661dc90b64eaa13533081d93e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913c98b7616b7fa72a33a6da197bbb86b883e3d4596b942c8d828e1e2124f345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ad2f8a809de1c14d7fd5469b26d7fced6532e49b872790ce1f88dde77f61eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ada4648e712f0de2c0422f6b653141b8707550b0942fb2b1a60914f4f64819d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGraphqlCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e1828441f30615786fbb99cc430165309c43a9974a4145fa6eba1cebcca125(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91677b864320b0ef43cf0573ec953ee46be36c2cc67c0539e4aa3990c2f2491a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abd0f7ed5dbc269b72d1c2a4d244040db37b641f5aed44f5822eee9f317f2ce9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff30a92c874ecf43d90dae71d36f63bb05a770cddf5c02f2b09f92a2a05dc63(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa583a3a86000ae222518e5aef401fa806ac80705115818d997eb33f8424850(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92334f4507a43c9b602d5218950679b4f8142450e2392642220a1107dc572c11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32e8640904c33960ba52c18cb96c50a155b851b9c08a891775195f679e3225a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorGzipResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45a6f0e921b28411b392a0e7c76ea484f0b29b5337ccf421cb732ce533fffa4(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b647e7ec633b4e103d434f28fd7bb19a7ad0076dfb03733f44abefbdb32d2b81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e49d83ff50a3ac0c84cb70d767d7b48e61adb13042ea10317b588bbde411bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b07d32aed253b26317e8d704b9657c537668c849b6de9675525a6110344d11(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e153b25fe216cf94a11d8edb682c245c8a9600673e206ea9b4ef91a61393f946(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584e2a9127165b3393c59d744248e2879302a14a91802f8cc0142b875e451027(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6570062a3a42395b42f7773bac5807ced2146b3e0ba18ba914954431683e4bff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc0dc0ac46d08b2fde28c95d01bceeeb38df6b69984871f6ae76654e6245458(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHdDataAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39008d63c4138cf7c0c8d46b6105d4b3cd0e0a8e359e45c75ce2c9fd5f28a47b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_reconnects: typing.Optional[jsii.Number] = None,
    retry_count: typing.Optional[jsii.Number] = None,
    retry_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e5c0bec0fa8ed4c0c4b9a1b8c6379cdac474ae68b7f5ff49502e08a765b2e4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a624b8cb97f25b1752203c6bb83e0f055a91111d59817d1ae925a2d91414a15(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__200d0033010fe3bd4bc170a960ba4d259ccc16fe47785dab9de9830508c89fc0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a949a69078f62b2e69c52e55cb812e811a06c778c00f4aa10b153c01abd971d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255fcd19d1a917277403b0b44de95b45f2538f3bae235de6a6d9036ef6909a40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c35bde4477d0d8c1e9e694f855296b8fb0673e257ce9c5ed95c52170695fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e9984737508152361a40c4b05bf1f86e511f45dbbeae64135eeab47edc05f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c551ddbac96fac653674990b2d4fa81d4e4dd1c2401324cf8d7f33fed95710b4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHealthDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d2a0ffda8ce847756b97d96875487ff53969bfdb5f82c3df6b0a189d22e7f5e(
    *,
    custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hash_max_value: typing.Optional[jsii.Number] = None,
    hash_min_value: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc2023ceb9282121d40f451b715a10c519e3bfd94a5d3c54d7d0b3cdec70b7cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02b9f121f9eadfed491d09215a26425f84969d3bffb01de5354a34717e8fe61e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08edf3526ad38d72b80caed82bd6a4a0d5d2dbf1ea385c43d3e7316a1f0df01d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3578f27e78de831a6f03fd2680b0e8986831e9ebe65f6e28d47894e7d03ce2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d534002366f5898df8f65b4ca62477c61f6e1e471c9deab06df05cc8d6bf61d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f26d3862c1d9ed8062e4680e3fc10655dcd8040ed2940788a4c51c9f920ff23(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__742a20b8bb54ecd17f1f522a93078150dae21988d2fd247c1a986302c23b57e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71a0dc9345c14b07df581ee87bd7d981100cdcc48c8342dff3c06293734732e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ebb048d35f0a949454c2fe3da99861f056a18d06604549210b708cd6c89275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2f467f882384c0e0aaa79eefc550bd0debad30657747a705e0c9a8ffdc0435(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHsafEipBinding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01f708a0d81124a9d9a8d8d5350396d14cc1a46ecbb076ec23ef21c5189312f9(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11cde966cc5e5b2b0a7ec9ceda3cca002b97330342c8b6f0e9e82c0f5e135b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8e702771aee86446edae2123b0b887d2f21f58c62bd440047979cbd8dbc4a5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb7c26a03de89f69b8a59ecb13d0e5c47f5d8eea4b46734212a7903832fd71cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46aa2500cd55c90757d550f29ea953a38f4a111ef72592fac4b2f0977ca741ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059d5a9be6b9b417ed2316a4d611529d13f330be4dd244b03c23333637d1fedc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b80000978e1078dcc31e99a881b76860d5f8fb63f1d293dcbbcb9c8ea4cdf227(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp2],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f640c417579654d4922713eb4a19946bace1a9f44be4c6c467464a783f4d77e(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b7f2ac27e43bd546b7772a7592c761a9e16c54d9c32c7a68aff9cf709ba75b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c93a144f8bc4c1682d4ce9d3014a60ab213549531c9b52a80947add5bf8ae0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca99436acd39d362b5672f9b4d32cce40a4e5d32105fb18a78afbb87f4c7f8f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93cfb1f26b4ba8b07ffa8cab7ab8d290a251daa1c989c75b136a52d0c6177e0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263f51994c2939518cfea287e288c1269f4689a0ed095cd4942ecfef115026a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e99cc72ef0047e5d6dad3ba21ad0012ee28b87b679b272af05dbe989fedbcd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttp3],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac58f1654aaf7a52cc1990e25892e925a33672abbc544f5537c49d020d436e8a(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[builtins.str] = None,
    preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89fe865761d43d29d45deafb78120339ed290f45e63b801d44801c179198eb09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37216c3e2f53baedc48ad1444441f036ce4187ba5e64b65c439351056e5c87bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca2b841712c70b38080657491217f05daa5db6a97ddbbede24d13afc4a980c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4be88beb6e13476513b3edfff71c226bdcc65d42decaef3fa5be91c8a6a1579b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd99ed32c68d7b93273170b3dd4b52a0d3cc1eca835a41669e2216674f46d57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234936e44f9182af784ed00c8c26f98ac51d3427233c877486dc379381e69bf5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce88fd31a860d5f957ac32e412accf42e1763705fe0624ffc49c3898f5115b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c86c14122d24583a0e6a910e4e1f32670d60774c165c14879b2c8e777c1f063a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3888a2c3f08df0163221a887c83bea369b20831e9b2360b7af6ee39c35f54be5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e099c7861edf981aca7c28b967346efb6034172c9cbeb9455678b466f4721f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f11be44a2c0ccddb0cfcc96f7388a8a1ef9ccf34cd0216fb0861a626768022(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpStrictTransportSecurity],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1557bedea2a015cd48edb0d9e743768bc92a2b07f0eca82408ebbd1c753b722c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upgrade: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33b41763e73c707aa8a4d53c8ef3af687e26ed59d1cf887e877f84485032142(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3853b58fd865f1536cab9103e4cdc141d4adad5de1ef3abccf306cd804707faa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8909fb8f575bcf54ced04f941b8330f1f89bbad710a72b862c97b652170ad2db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b79d3b0986232289ba7960f35d3b17be10c66f58f03a79ae17019b5918465d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__618cedb2c5e7a4421dfcba23723b0288112ab921aa19ff06370184d55bfe6aa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9866546225ed78c3028dbf19f69942fdff28edc51cbba2a16d8a48b9325670a4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorHttpToHttpsUpgrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb65c879030a9e3c9dc9946d685f74918c9bd8d3fc58c16107625169ed0c30b3(
    *,
    dpr: typing.Optional[jsii.Number] = None,
    dprvar: typing.Optional[builtins.str] = None,
    exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    format: typing.Optional[builtins.str] = None,
    formatvar: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    policyvar: typing.Optional[builtins.str] = None,
    policyvar_i_mvar: typing.Optional[builtins.str] = None,
    policyvar_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    typesel: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    width: typing.Optional[jsii.Number] = None,
    widthvar: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47e218209c644462b2c5c5902ef63fe6a6aa73425bf20dbc4b5622d226a10491(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a133a60cddcfb6f2aeceb0da8bbb52c327d30a771c44aad6dd52e8a184cff5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae541ee89cd1e6141db6fdec3e9d9f6a390e939c13407db6db5e4ed7d1c7fb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e753359e9dc57bb9786467a150d5b6cb78c8a8dac0ed58522d5e7fbb777e9622(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2b633fb7cde2236d53dc8f292e22bd69c270b7974c813ca91aead77b99abf5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36fa67295433f89d7581c2d410e70746306755e058859fef4e5fccb258eb0bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dc2a73b902af2522789d51d7958240d423bf42f7448907e654fa1ec218d2cef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456b884a25c7d9f1933487c085105ad88a9ad678876155d241f4de50b14b5799(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85eebb00e078dfb10344a9065b68b0a8ee921d096e43bbd234c489a6a99553e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45a92f4988186a2b5ea9e159c4298d77392c80961713696059cb90f9a0dec248(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4daf275bfef7f2066096472b90a7fcadc6b309b275bca19424bf56449b8476f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ce2b2a0c359bca73c576ec00a2861a2062427feeaf141506953729b02e2aed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68ae6434f394eba75d038410d82c46661c1c9af87b1b2fccd375bf8cf5c64fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec7a4b5673ff264b900d6b61b1662fdd09e84b5e4bf6286902929f1643a39d66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7baf40fbec4e2886ed9593577947367fbca61b34b3fc177a13a518e845cfef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3793d79160c280d2f59fc14707eff1d0ffb2b54e7f79c381562e4c61507aa02d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d11ae28d045e002d1f6f4445324056241465c19cc7862269f268c49a8cb2a7d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32944a39249c326c8bd008f10299ac387d3e77ac8997b5a7b4d21a0451c7fb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b6915639da100142f325261306cd116907fe76a1073b4182c2a8c1d4cb2a07c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2c921644fd51bbcb5862f7eae667b24f7a481729d6fa6703452bb2c1c783031(
    *,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    image_set: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set_type: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    video_set: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef396eedca828f436d28dd8cd420a9c67477c9f037d25097f29b35cb426f713(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a75909b0547433ae9963c149dd126e644eda91b20ae609bc831e730c220410(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__189fabca3978189c10f215c2658eb7a64d44dacb8354d497fd032446f7079bae(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1447fda7e28d49ee0502c93b9200ca51eaff88e0000e94ffe04cbb170d1578b8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af89fcf0e83ca42472544ea09714a9e6ecaaf7c6c89432979efd5acef9f8b80a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ed67f115ee9ced82590c10fc37c69a115683d82ada77fd2b0a1e623e01e69e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea8aa49659ba095905db58121957092caefb9aa511d4ccc11ed4eb9f10595ced(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469a5e12e3fd7453f84310c512ee121a13b48d011200d2ba13a39f9bca25a908(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c5a7a0c7a0653aa1cef4a9ed36367610c0602cfea1282772f7bc1973e69d0c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b0b5c4879cb281dc2acebde099ee04236ffbd78ddaf36ac330ca23750f9e78c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f08e9de4ecb0636149dad059c7429177d4df00dc54d9ada578e7f04a46a59d3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f93ca17bdf2f2198c5ec5c75ce25897368367121f3dcc68b880eea7eac41157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eb2a2b32dc3e7854a60eb88fa9d09cd5a761e80aef845f136c14c74604672cc(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f546fc066df4cc38bbeacd444e19db1631a9a676d48724b5bdb5403fed8da4d1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2f2c07bad8959a739d094a484cddf27659298102d04470da1f0b5156f88fe6(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4ba84782b392c249f79d8048183845a53b0009a38bf612bd77d24f6d5c5cfd(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__928ffda6d175842af095dd7f9ee8453250bc620d48740c93209dbc8e7a2f36fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dafa4739ceceb1dba4408d84669349389a326668842619985ab3fbd0a5e82acf(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d02c72029f6cdbb2bcced6552a8aea2a341a4542021f0115f84fc5ddb967df8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8df7eac756b610930bd5cbe9a8c83d234e4bdd0c5c630e2f4565c6b307c0d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3173256b837d54379d2aaa62a977bbd11a06eaaea616d21d25d9280b712da2df(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9397198b2da6b5fa3b3fe6ae18047102f83dddad9c75de4038e6d1d5f4e5e4c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__668b0128c96ca6fbaeffc17c9925a236b4325bf1f58782acbfeb0fb7f7fd9b9d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca8c4b027cb02fc370ab6a63e4021753e8b23926b5242f92b7790df771aa425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277914729fb806a41bcb1a318a0446f56292ee0f5b99176ea76ab9834c806edd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94331993aa1ddb87f8a9626481d003625eeebbbdf85a7fc309dfaf93353790f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8b9317da9016426fe8a628e7c12b7e8562e3acfdc98af8657c7835a131a427(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13334ba03a092e728b754fe0ca225c97f4f30f563c9a5e075f856b18334ec655(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a91434286942f91bc01e810210afc5325101a4c386b7f879a8053f972477902(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2339415d06fe84b9efd7b3c0cae8ee7d3b280a03f7dd982f3d231b58f06b8c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e99d213866744f5172b9aa1f1336a737a602eaf1ee54c52e9f2c14d7e6d411(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdea67a7cc42dbbb31c127fcf1d58ebd2880eab2ec79e4a31f41b479cbf6f46c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0700b43d4fd82a6a41669eeaf9d79d1342e534cd898abea7d31952f97998f141(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff6a9cd39d99a434a812e2ba3865c46ac3ab1bc8a6cfbd15a1062100780b836f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eddaa2182e3fee7f4a83ea113294263dfb57c3cef7896e1bcfcca8741ef9f4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c9fa0bd589878685228fd88415aa2e651ca241b2a54609ee37baf3334b593c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0783901532ed9a3aebbae555ac0fc6360bed81d76b0e9fc7b2d9beba564765b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c00722795249fdf6f315ca5379d9004228f4b841b7655cb8cb4f402fd06e171(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5be03fc788653a2835485087d3b289770140329b8bab8953b4cb166456df6460(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageAndVideoManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790592956708ff8762e31933ea2d7252253a4af48580a5283e299130924cebd1(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0492c4cf24b27453723419362dddd382ee6384c36da16898b8309cd3d4e033e0(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bdb85c3b20b61f4d64d6c277684c9bdbcf49160a49ea23c3e22e27c9022703c(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc198fe9cfda20d3997baae7bdf8bf0cee83abcec033c750fd25fa7a97acb60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c0fe2a3bd4160dc98eadd8a4ca7f66a4d0bcd8e9acb376aada668e83be54e4d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a172c0f34a5538c3aa6a6cd666757a7958ca6799daedb22b0641fb528825764(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1d30934e09f15374d8eee98f19c17c122f24f34cc28f89aa5d59a420b1ba320(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c027e56e87bed2980161fd21d5e5b56dc560a8dae56a76de456fac174e570ae5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9874ae621502929c1ecf28578498cbcf130384e4d22f81eeb8408408ea45d3fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7409484feb5abae8633d51ccb8da9c112f7d206926c90f7348bb667fb5b12572(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39d29fd8190e5ea5658ecb6527eee148810725115903ef919a8b941102194735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1426afcac38a62ed98fc2679d52a5509fcaf8533e28ca320f76dabee83c46ae0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c138cc618459fabff31c5104441af7d827427c7d503ab78d56f180963866422d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd8c363611466b2ed8c89a69530e4ccafed2c34ee86e394855f370c51c1b1af(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d50f09761f36023b4328a2c9878a65f010a29826c71bdb1ab3f3a2db06af1dc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a8501f52668110bcc3db9707fc292970111f1168851f74911856e1f308e181c(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf54d6ce4428ff93849383939a2082bcd0bd19b3763248c3fb7ea86157a3e1f(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a42041fdb4b4f97df2267ba19629bed32818c8ce470b5ad24c7ab873ee33119(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d9e2d4fbfad1020fdbd4bef71ae2b19d0d9cfd1a05dfc56ef0164b66f88434(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3032adceb8051e5d65176350fe59c4c6704abbd763ebb6d5553aa7770b4097f1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bca86f935f9c176296e077905fe3feb0d213a8f9d972c909c255805b0fe16093(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16fb2411bc54b9524bf915c430bfae178b9460b777cad72749779f0b0696ebf6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f41bd85370d69e65237ffe3e923dde952af0ba4af207fa760f3d103e4ffe088(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02e7c992adc1f0b0e4b57b77af2bd08904b4dae20dbe53d29af8f6cae5ee479(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7cd10aeeba548040b38b3e6b6535604472d879df65aa0f9ea9f365eae025d78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b59069106b1ada114f04b49ffa4c75e973d7cd0f7cb08ce9e703d24322d0ba(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183f84300f0f74f3ae99f2f5bb16cee0d3bc8eaec846931579510023aa7d6fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6736f41db99d39fcd1b344bd29b313a034bfa6d7b9f58e5ff35c78eb7fe0e735(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722a2b50bfb7133fbeeb9f97788d0782569b811eaa0d032a0e313cebbb533f42(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234bc1240222b491c6ae29961c28a57c345ca7f67a461d736e72b4eb17cac8a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7aebbed8fd30b812c93b4afe0da9a6aa6f6975b503b897d341627b2c75122e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72bca83d064c1fcefe0f19edf6a2d20313eca93ae3806d3c43a814499c32a194(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75074fba16bbccf16c5ccf2403e6e75434437b2a4e1844fb4d5c6bc7a28563b4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67461b3c454f35b9bdc69638ba805cf509dbdb80d7c7aea5cf7566c8d55a54a1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980bca11fb67be17ca8a30f4eec879801c52101e32e8e1983a5e95c0b44dcdf6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e8309848703f110c28a6ccf8d9929513141af37e89c51f97606e40c520534c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7b5abe0385f0ea6faa5f1568637cb265276b8381b9958fd0da2c2c73d5eaf75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632518f8eccf03b3fd9c5ea09ae6900a6fa93e17452b92628244db3bc36c5b2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8154590c892c6c1715fff2e8034f183287ffecd7ba7038f15242f4f59d20a271(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a050dbc4c61d42718273a73ae75eb080b318b4f239749420c0abce20ac132cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a64a46a98faf7af8a287f0e6485f26f46d54033489c5105b783b6eb68f03e227(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e10124fb63701869cedba82475481884c3c7aa6bb034fa0c3a71dda2476f10b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1478baf599c7272230d7acad9780a37e238af33c5bccf5a4d28bf733cdcaf595(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bb0bdcb500668d7799543a6356aea30ad6689aac113dad6b19463ef4b3211c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea40c7b65cbb2a3001b92e93e680ba4b65aa91845116bfd5493b7567f7ac48e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6eaf00fc4c89573b6652e99025b9c6848bca9639e0ac57a7b9ffa9fdcf93e5c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f73c890bf75f7cb5b981380d2fb778ed2727cfcb1a30cbf591d015becfca93(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e520a78cba38a98e709996ba151ced32c61d3b1e35ec29ac2a0866a6496a12e(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b76ab4e0343a8d89970a362df7d871e438c6b777b365ffc2b6464ee5b177444(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f36bc55a4569d1250ee26f3c236a0aacb3f61c2f2a5f59bcf46e6ea8a168a35(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__273f7c994c49de4bf995c5a5e4d34e88ed753556ecc2b436bd9d59a17833ee56(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a57c3ab4ac01e1a90c4e5e83fec30f65471026c007a9a338facc6b1786926fd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d5a96e011e2391197e38e5fdfa60a2b4e00c4d6ab3ad7e6ae17c771a580c25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8e32f09e78a1830c7afff1d17ae3bc1b98fdaf7a599c110f396440159acbe6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f284f305f319808ae04ef97152dbb490312ddde14760663e6e47e5da3059e7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c13ad0ea36b8f96a0aea34e6b34ffa20b051143f63f973eca2e5e7c8d3215a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeee8d8298fc49a6c780313ddc7a6331e9df6b99287b81c126af747b2271e1db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40e4bb3b8a406cd72f392866f191954b05df7b4c62d8bcbf15a39abd03b2b5f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f2dc2cc738d77ca394d0893848db4c8ad83e7ce3a5fa58bfe7d151529bf5229(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0906e387ee9bc77c4e7996d1bafe30b28e544cc8d5d00cdf4e6c0a7f211fe62f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea065bad3bdc4346e2253a4f9cafe125fc3c9a06e9f196b45674875cbc826727(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f82bc818125b2b2db226f024c6c0b8f5d579b80537b1415b5ab40a3df805848(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8520be6f41004ee29d0fc5da72ce973d5f3ad76874716b8942199e9a30a6b1d3(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a4fabbcf81a4674e2e25df83967723b9e6e5d1592fabbdba83c5ca74068753(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44333e846a4c0d4898439de22e487145caab9dd15fd6b648597a221dc0f4af80(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eeb84763c83c1202ec197ca32fad1a82ce53f7732d7cf3ab1e385aa784c7007(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de0b2ac3ccabcfd5771be6d61e7e4be84c169329089a834676485cf6ff3a0582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260ada835f716eef3153240184628ae118a9d399b214b1a0af626466f1823951(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5c7091f2ac925387424c339a16dd9f0e3e36bf103158fc0f1bc382f7b871bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09cd08af7616f9d59f07f770b45d751e713a7b8536f86c66433269e307902423(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36baf6340b4eada98d38fb1fa9f3dc47f541b49d22e788a41b1ca80c65ff1c82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e6e37ebb3a6ebfe70cefe3ec495682ef9e00a3076bb94eb3bcf5f4547d36bd5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6d40af1de33f87eb3adb2c61b673ce4b279fdbfe2f7a759bc624eeb5e12aaea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60bb63648a544991ce5e815e6a3bee438aa23ec1e59b8ca3412cb3674fed8199(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3107323b0fe9c1d7c70cbaaba444a94e59a00d7a450b5444eb4bc7bf2936ebb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideoCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be65ab923038d53ffd94402631f42dbb1ce4e1b7f4e644b78639576baad0603(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__939ca7afef057c1393ac3eff2322fe6cb7edc91928a9cf4d6f9b32179869d7bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52650e22b4dcd26a681f96bc1490c853a0966ad2fe756d9f2de75eac0b285a57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15fc2ded8017d825ec50a26e06e30fed412d9f73f9900b57fa825df52243f11(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50e3d1a5790a3e2ae827dd39868bb7cafb91136f2809b4e09f410845a50953eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20145c308871151d376be32f9047acce11ff9536a14f86baba72c6cb79765415(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58a19568661a177ac07c5021df88242fa81ed94e7337ca013cabb11483699c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17a04be189165d1b8dc3819078421cfadaa22dd8b80dbea534f7790dc324cf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993913d8771048794df4e94f273869f7e6dfac63445cd14df55c888b3019d809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f991ef3a8a3703934a6c9ff9cf7e9430ea91748293bfe7643b37ed3d9f5546e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218b75d5b347997581e8bf3ec585b1c91cb51e4c0cacd05a87fb487aca248587(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffb5919db995aba4351c6caf0c0259793c2fbf4b916afb0649dcdb1a08862747(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7cbf9b134d1ae888e68d4801a1562b5e49aad66d707e624a855784559891fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2e98f76a51799bb8ede5e24fbb62d345f9c6a0810cef860abd237d9c8d7c8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75ea6f8a92415ba765c44cfb64cad4f4b7e80f23b17412f0e04ae8608a77b396(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6705654db0d66a512be4055a37177bbdbeeac2cb9f6d44c55878a4b6f1fdaf35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb507ccdb8ed91fe3c34040e56307f6db8e3025dbd05d0d33a0fcbf4b59de8f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorImageManagerVideo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64e6fe6aefcf3572219559cb400d058344602284a25406114d2ce19e18a1ab6d(
    *,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e65310b44e1ec82734f3cf5142f64c11172389115e5496702da63e45b7bd22f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc560d3842bdebe651e1e322c0f23ca453394a0d7982f78c14a8f4eaa4ad866(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3611297c756dc67d7b5c61871b7a9e5b918be64a72f88f39115ae5b94659f18d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c243b61946a931c88d07642a558160119edf5d69245c5286d1807dbaa47384fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0d5e97988fb59a3103683ed1916ae81e3db66a250ff56a91323ec0bc291ccd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09f2050e1e82d9e1ea02607117287ed913903e6be70683a133380fe132ba2617(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInclude],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e6ddfa48409870416ffa48b2c367d36c7d21a17340e8e61d0b73b69f91360c7(
    *,
    custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbb255811a4c91a82153b44814a05114aaa292bdb91b01af611475e2a956c18(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9742823fb846259f08c8de77c2d148c9b738aad71aefaa7d93bde8f4765db4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c473d3fa92934ae445c88c1e1ddd3510a4ab5af9df51c89d8ad3d17fb2648af4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6beacebaaa1b178115f4dc31009e930990432411f2bdc46f3d53e48bd30d6ce1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c37743e046b125cd3956b55b7dc48cc3f17ee523a2f6d21187224dba36da9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61336892c00c7c81b6c4d4d4cffb07342f8172e011c02d8de601639273e735fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8044d382e7b83f4897b1f30ddd2db4e1bd6adb59bfea5b7b9b33b060218acd0f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstantConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f5377a0ca65afb01f413824dd29c26e53d63dda53a4cef4c873eb8b6334e3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06c521521e7d9d1c9d65d0bce152db07476979a6bb54b6ddb812845937da59c8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd065ae6ce33f56149f57ba8d19064a1dd2b8245f4093f8867b71416171fff61(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fb7db00af7b7e3b1bcf174251dd15d3b28767550ac59c138119acde24b75ad0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ed4dc6d6f6e91e04c0166eae5a6285dce19cbf82e24794eccb06eda42d8ad38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeff06e0b5a75657fdd8985342a09ca0534ee3832b65059df77157241097392a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff75554a0f673742e2c3f5a6f3c9d914d8b9af3767a115147e4e190392ec47f7(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f781fa1dd1d7082b6a0f6575ab4613d15454936c1a38a20171f4cd73eb88ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98f3b5e3b0f2a83b6fdabf4226205e39b23dbb8e69236055958b615fdad2ed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1ac4d20866760d8fda4820a25fa8030a8fb03bcc6982fee45c78adbdc24851d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorInstant],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e690185ec787b6eb3b39bbfbf086aefcfd275b01039d034b4bee9a406e69508(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_partial_object_caching: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    minimum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11096604ef826f5d0be05b0b65ec7647de1a6ebd241a0e917f799076cee1a90b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    fragment_size: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    prefetch_after_request: typing.Optional[jsii.Number] = None,
    prefetch_during_request: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac26c34801216203f26f3f242b90192b58f92bce4a5126dab8fe65f4d59efce8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b757fea0b9936162f0c7eca2d4ca8d4ca4b778cb8f9221da2f0ad111f244ac5a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__736e70a6071c1ee53b0eb665e578c234ebcdfc99108dc0a36db5bbfcf2797675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbbdcfbff26935790b67c2ce23c0738cf2f7d3812a646bc19c1fb98c3f9f514f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc33b9c530827c8837665333dc8eda81ba401b833759b125b9353dc642ea9fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade508f3403c0b6a5da126f1856f0b5f13dce7c0594b0d94e3f50012e6077222(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05bf7b2d4abe5e6388c64b097c4219721e333dc5f1e1ba135014c7ddda4677ed(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ca94b6765219d1741e9bb276f95819d3a60447a9cb70a7dcf890adc40ff5a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d12d8d54f3474a50c8a59edc181bb6b865cb9bf3befcb284d1fd35f80f8d60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e676b83e8813fa8ceb1494f4209b921eb93c04bcda1d2c4baf0421dc0cf32e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimizationAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138280b0ca85ad1a6249b7202c30dea8081a2401c590bc331a1ed6bab2ee4fd0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e29f85adef6de2d9ece250ffa6129bbf21c6daf813f89fddc39e20acfc92e2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da40697630064a5661ef0b9b015e5921891d0bed57e2134eb5cb9f03918b1dae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46469807078f670599f4413a82e29e578a239873638184b44700a6fb9160eb38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d10a14d73571081662d6f0a5226116087fc2b90ee839fac38ae854e9ac76cf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192ccfe34899ee6717fd8a6d1e3ceb7335781ba06270736692f5f80aed7ee1b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9009a309717d452da5c5f9553743cc090d6d69229cb1d7e600a89147ee7410ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__befcb2569fdb334345b73ff054c68444599c76e7924f2f2329cf0a18300a7f81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98aa129899471e323d2df14838eb38033d8a8e0963753ecbc315552ec435f574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89ae7093c9ad36c1673a8cd75feff6848a5263ba30f3a2182a6b5a757e5e83a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLargeFileOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a042698fbd07e167b2fba3d184f46e98ed454d6a8dc58f78d64d459689b4325(
    *,
    bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e017af0c14085b327846924cbe8d32b56765a37408ffe08ad1b49f84b8f7253(
    *,
    bitrate_unit: typing.Optional[builtins.str] = None,
    bitrate_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6779df0faeae9e1d304a74192f3a5c53484f21c2e87a843f0eca1f0b8348ff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1d870dc4b28bfd0b9b0b499feca7587555f618f636c12ff9487faff6dd77e8(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f697b433515fb0c70d2c684e803e12535be9d39784a364dc3bb831024adda4d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ce51766eaba37a0a8970f404f58ceef4caa9dc45938882ebcb1443703e6d458(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e248b0d96d222a9538099a8bcbd48e5218cb545bf846d57bf91e112a460d2618(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20028080038a15ea05ae41e1c023dfcc731a86386393393f9486bbfd2c88521(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b05197ec4dd1a4a43645db478fa8059d71fc10d18ff0cedd9be3f97b63ea1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204e66b3d2e62d0ff2d89f9bd4bf24f5f9fe8ad817f583f1b54d49e219eadadf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead7dd52ced22d38da1fe8fbf4720e2297b8c5e31ebf2cc71756470eb231c78e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__061d7952e2f6120030aee79dfcbfb7d9063cf272e266d44392bc1dae0ec7d365(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__543b360472477d90633da527c80292873ea9d3f31ced36324cfd53199b81dff9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__214ce65d6c195ca424cc029cf9f2dde1d1344d56433123b47853f053a9378c6a(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10971cd7dbbfd2857ec2afa263c91e6a759e4fe82c72f46e8276c6ad7edbac55(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__945ef7d6a9ddbcfef8fb864a2192d9ace958f7a7e11a370cfc3c47a5c7055ccd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89d64fd39a26a5e701d99bc11d737d7d3f58ba5e8d64d57b85d34d960c6fc451(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c7d00ccba14ba16177576d78ab2f5c2f6d10dfa1fdda72acbe65ac7c2e29bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73db432ffcab591b667f9729198b474589bd9687518b1f568e858fb07bc5fcb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5509225036777b79fcaf252cd3e89cae688be198193c1eb7a8efa338c3f0e23a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f399b4e0481cce749cd1bce4b5b4f9c8a7ddadf8b6caea8ba76bfb6c54893e4(
    *,
    threshold_unit: typing.Optional[builtins.str] = None,
    threshold_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9278aca55d4cd779cb8985029cda42d66a9aa359510677359f566227b438125f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d14f068394f812327d0f55173a3b2012946852568fda7ef58087a3845e97e3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff405af4be5c5d1492ee24d00e9d617dca15287c3af09e5f8e22875b56dffb93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d99219485b5c5650a555fe80fd277e1ac99c3128183851bf925a7ed34c41a0b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bbf877fb5a4cf87213a1adb64020df01e3b0d9b83565d3259e1f128aefb5331(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f7a2459cc497f0088962dc55b84bf7345f6eecea2b8a1b08f21a9c143698de(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d43f40ddfd600d9adcca3946f4b183b5afe6894bdd3f4ec301baec1fb8979c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ab2db4ebc685eee092aae5e59c364f84ced6fb2bb46aa5c2f1398b088d678f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16858e0afcda12b9e7629c3d55c34e5611ac87b5a934af51420fc40520fbd7d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe0a50993177ea4c521ec7945cebd6f11106f4b9d85c86ed0daf558f054239e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLimitBitRateThresholdTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67221e0a7757eebd8c4828e8adedd20a43676198ee93687c78c0e189d9a4bac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7648f742e78dfa8b0fffdf7bc8a57fe76a79e22fa848f3b10b4765662db238a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73ed481e70c5e0e4786e7a28003f9814e3811fced4010824896ecc9243429ab0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c8ed262070bd868b62f072293a1324c23577f76401a4da28dc003f56c2cedde(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d4024b8213c3921c6dd014888830f8e69af6ed98d0ba6c9838d68905d1e899(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0af756e2bc148f252103abe85ed07e06c2d262d1046ed14b2ef315043fa1c616(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3691a06aadea2ed3a10b44e82dc79ba9111803c1061ab261fa62c9f9c889a605(
    *,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722982a06bd0660e8b5182349a05837de7489b7477d279788a90bf9451269fed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0f295487deff1f199072f20ab4111fca8db24457e43048d4aa563c64e83706(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb9fcc20e2093dfecdd28ff4b1d7e36b73fa7417a165e3d1436db0fda91e8a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__450b152b68bde560b505c10763dfe2ba6022e3f89ed0aec4e057ff673e286f29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f1271448d9b0757a569e558503cb3db66303fd93d706d831ac6af6a3894702(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff0a8124ef4251f8a14284703740e41ecb115cb9af596ab2e17a409651a0696(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__102dac8da968f8df48887fe2e75603017b0f7254346dec7ac8803bf1ecf57b7e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorLogCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef7878718fba4aeac19d0c2424b95505d6fa826af21c0f3967a00c7c5d3c304(
    *,
    api_key: typing.Optional[builtins.str] = None,
    buffer_size: typing.Optional[builtins.str] = None,
    config_override: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    loader_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_optional: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc1e309e0f078985e245016b7f18a7b7f4c6cda6607efa47ce2d11a1b871a70b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265dc2870fece30b896ec1f709f8c8f60a9e032f8264b649652839760c72600f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8522256b8fae7639bd9a6f79bfa771912a60033c09a003feca4ba33466d2da5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e07df93975c5d96e073e0d7fb954dcdc50a6c05a0dd330518c86a8bcc6106d0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285b3f12472772a79c4aa1a93926bebc9aff3a709de053ad8108a920855d045c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e453e51418cc7cdbdeca3c12cf03955ae753980b4515a80d26ece10c0f649022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36793d074b2257e09ad23cda997a73faeb3be66d14618f91fdb0b109f6d1788(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66009b7e91dd71a82e6823aee4c4183745a2f010cc3dd46cc3c58ad745756854(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891bcac7337a18fea475cd41f8c17cf6de0dd26734136e2f575fa237d9aaf587(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0048646c4a578d4605f1ff20b8befd7adcb01d8fd0fc7242efcdc478846767a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507141fd4b99da788bb829cdcfd14d168349b56df6aab55c698344730a13287e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac28ebc53de04e67e31312a606c5d83bbcd1112f78515c8a1d0b16f000963624(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMPulse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0ba42d9d43189051c9af1bcff4cf93b00431593a57419cf676749bf03b5716(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
    hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
    hls_mode: typing.Optional[builtins.str] = None,
    hls_preferred_bitrate: typing.Optional[builtins.str] = None,
    hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_query_param_secret_key: typing.Optional[builtins.str] = None,
    hls_query_param_transition_key: typing.Optional[builtins.str] = None,
    hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f301c05db555d6705db2fa4c3dd3dbf7f1c2bd34dbc7be270de61a7d6707170(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52475c0ace561de2f8910ada0e201285715031163c2342e5268fac481d8382b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6e58dc6261f389c136919a0b7682ae955e63ac12d24bd2defcfcc89dc5fb3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1949c56b1468a6d389927af0bc1c1fedaad3a056f307944f3a24599f3880713c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4606c8608fe3bab5bd3eeee6b510668d6e40a0db3f0a4e1cfeed0de3ad7b4d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f8b4692ec00398e90f08ff943a4d9b190671cc99c13ac1dffd2476865824205(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ea1abdf0f776479986bf91df7cfab225c57d500d8078ae94c960def0ed871c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7babbdbc1b4a73cb0d982b34749b509d110d92755b8933f73d3fea4621078ebe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ad24b4946a28b9a9bd9ff66af4faed64773c6e91428107aa216be42d396948(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f883d5aae90427fb9643a976499f486853a460f61f92a52853e195e7903de68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb59c54251965d431bdd7602cb26338951565cc465950e1aebe11628ebb1543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59677c10faae45bfdec3f85623b4e4974495b2e15780af065942bbd8573591dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d215e0f4c2ca5e66622c1747e7046917a43c3127bf3152de8c78247b38c9cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b2b07901e3073c2d94df658cc97e768a6aad73a65baca615e7efc2ff4c2ff8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae0525580f846ba3640578c0543655d972bd6172251cfd0e3e20f9f37cef50d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4cfb22ad9d9eaaafd5dda0e4aa716855ec6ea986aa54b059562d2506fc9a51e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af85efa4639348f12b7257e0d182d4d5bf8d405fcc8781fb12ed9b639a8a567c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestPersonalization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d5392488b1d253abf45dbc9916ba90b2eb773649c5d3c4f9c5c7a6e65d3689(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    username: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__038c2c6eda439d29f57a688e61b537b4ba34cc89e2fcb4021db4f48d7a31f910(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa25ea5289465ded08b9bae0abf2199fe05062593547b9b5370736293c03ff4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fda2b4470619b4ec308e8aeb0c665d2cd6cb1e67a3ed63b1e15679ed173a7d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2f5bb4fd72afbf37227ed4633cdb707019842016592abf79a80568281338873(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6634b647744d37fe7e72a722952474ef76ceab3f92b6696076c4ad187d2402b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c7c6bb36990e8b63ae42631578f9c303c2432d739db9052f22ab5c8505a1f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__732a271a53cd231fe54ee2d127af6fefdbfe2a0b101cc44a017deeea4e1f197e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManifestRerouting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a83f98f4a30b63593e3a8bb95741bdb13c3d3af993d2fee379ce130662a5fc8(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12effe8da5814950e0367041045d70971cba2548f5b484ddad33879510b52172(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d7315bf6f916fc19c0f882a974804cc4995038f88a5f282c7f219306705711(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00df26d201be73648a78f70bead0da4d9beaf84545f11129291e36a4d2b8df6e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c64738be526774608cc58721ba0310c26799cdcda1fb040f17abd6a1ab7501d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d1a909a9cb18961309941ac3353b13ce9a463c08699803d508494c9029854cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb777f07184d175d218be106afdfa28bf8cae7347f4cb63c90f95164a21bf40(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorManualServerPush],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b72173f2692e7cbe61a94c98bc0db11d3b16512651de8c444a39b1a4bbf9a9f0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c4141c40c809a4008ea284907df8e5a0ed3dcba77d0f8b3a1e67c4cfccd3e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ceb69c3900e12e6518ba747d74432cf5ea7ebbe3e8bd162eb1a1d74fe6e9eb3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__908bd5ae2aa5f5c1f5fc984be110a9b7d1bc81b79c4d500a949409a959ca9eb3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab44c36459a7b8f17738e503929ad0a8a26400be4e58715318938db0d6b25fc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f1551130fa05a20830ebb364a3716dcc53867d33c006e698ee1391ec9be5cd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95fd8d2b201e98401eab91cd1519cb79fe578f41faa025237688e04a3411f4ab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__332f136457fec7b582879765684e6f2960c2e38032e67de12abecc43df7ee94b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optout: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4512fc76a175bc4ec39b9013ce1771a8caf2382f5a25520975e34fe98b8f27d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97fdc0773d999e72722e8d079e1c4080accbe09914d00b3ea42e9e8ceba761f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ed8a6c1f3f4e3bd3e1b0c746ee3384df9f939d32e076a14fcd2823f0e20e980(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8613256745af6c5a194e99b6fad9d311049cc251a05764a06704df52465a0fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad496988c7ab6b74aab4c7f06fa5eca61b770bc3ca1830fe5a52dbb1d53ad37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4ee634417fe7acd9d510efb112ae7c4629e1afb3315537ef1dc0548d9e35ea(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaAccelerationQuicOptout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93986021a3cd5fed327d9a0969b074f3e3892086cdecc5a4dceb75df57b42890(
    *,
    beacon_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999c4ed44b5767eebf2e762150706c1c38dcb3995771defb93f23bbb3adf5ab1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00dead95dfaad0b75f118d41d643bf74ecb104177b8797849003c18c5231dce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a3e2fdc8f88c942459fc386fe6f81677664729c8e4f6ef86c24181f9389df1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__156929294c05f238ae85bca3e6e3619e4ff9325ec094128d0fdbf0753813c00e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__975aa11bb2cfba91703b48df2b207db69402e0ddb608a6c4988a2aada59640e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8da504dbb7ec85ee556aad8a68556b1944b83a83b8c63f87a2ae88bde3b12c15(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56d7144f6ddc79578f90d53002f2e09fdef5bf44f25bfb3b859ce47665160345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dacb3d00388c8fe5ee3c198978b41942250d35b4b428f7fa18b26f865adf158f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf07f54aa34b7dfebcc3924486a090a167165b54fca84df061d7b74e3193974(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589fab1838631180ec321c8c0db14a3abe45cc4efef46bdb7a7365892f06f5c7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__093bbc24c8cea082aaa879eb602886acfa3fc5f89443126e68fb83f2123bfee3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e3839766b01a4d2895442b7120d7f248338418b5a1ebb48aa04fe05d1123cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c81d94e97acaa34e2edc5bc370c550d572f0c10b56ecf13ed37c27b8b0aea24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__502962d7750a3a118a146af1f7f2b0703f0960f295898a149be9c866e4761833(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8e15debfd48b34cfbc1d090c0dea49b7322cc2deb95c42eb0b290c76765e6c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaFileRetrievalOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96a1f30599c2cd4c76102a1077d922b57be58dcc0cea61c10f1f9a458eb520a(
    *,
    cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_window: typing.Optional[builtins.str] = None,
    client_response_code: typing.Optional[builtins.str] = None,
    detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_object_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    object_unavailable_backup_host: typing.Optional[builtins.str] = None,
    object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_detection_level: typing.Optional[builtins.str] = None,
    object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_modified_path: typing.Optional[builtins.str] = None,
    object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_protocol: typing.Optional[builtins.str] = None,
    object_unavailable_recovery: typing.Optional[builtins.str] = None,
    object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
    origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
    origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
    origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_protocol: typing.Optional[builtins.str] = None,
    origin_unavailable_recovery: typing.Optional[builtins.str] = None,
    origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
    origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
    origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
    origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
    origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
    other_options: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c99586870ab09a2759f6e518d6726198ce3937ab8978c93bd1fe29e3d23650c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16b545e9f2a9876ce98ac0be7631a9db4b0aa6f4f021b8e88db224cdd439578e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa727352b702cb62cd17499251b83bdaa56fb26d8e82110a1147a95fa1b3ed38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7434e25528af5c794d8b25c0e7024ff8a2a1c3dbead2d13bb299c111bf13f43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47d885a3e7ebbcbf8c212a650d24cda923dbf31263029fe1830ba119161d708c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c3e9ad69921905ec34a687a1cc0a004bc839f8867a01c48405ee8e4d8940740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cba23a7008a362f270bf02acb6b53d540295b4ba11c952f56e4babc02fbb0d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d30555590e6b1d31199e7818a723a2a3871323bef76b71f7fef9784883250a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dcd738c29176adb5ff250c6e5b7c9bbd93423682113754ffe62e7d7da02d66a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e342380abe772c8e7a0a4592f4556180e8ce5b9e0b7a393dd77b4bcc080001b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c54d89ff539d74c7d366e974d772aac25f8bc65c38cd4ec728132bc7695300b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf22ee2483d49d01f894959886b714505ec362c47728e39aa01c07a9a18a69fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573909fb85ff7138041bcaebf727eb6a02f91a6182ae1442c1b5d36e2074494b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892ff1760d88adb1212e20e3270cd436a7e9cd9615c0bd116466886b34229599(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c04f6d9f855ea242de47a696b93aaf7f714b16e875f4c4d32c5ad63b3d70661(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a2181d9461b97d77992e0ab2f4f19fa2a3fa679179b3b84143cda0a5cc866f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efbd546584ed3aa85a78868acbe3919d719e715f8a4c6e9c33abbda872adbccf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea094bcfb9c2b133e57537f97875bb837afc9ca159fa11b8abf46c75ad0a8c9d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2fc0b89c539d217e251a579f97b2ec4042ddd94ef4bbe92f0a526d19f24ed4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82036cb67847b5fa9b2e675a64a345e6c80d60e7b3e1ab30ee34778ffc070b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033da2fc6d37f7b3dc36506b727f46fca693466e2b54cff009e9c7d667840bac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40ed6cf0921d5f68381f33e8dbc4d22f01d57407a3bd1f7ac8d854a87d3407c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b47472cd03eee24a3715c7831bbbda6ad47193f131124dc394f3e4b78d756826(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03cf277621e35d94a91ecf12e6827d394175cd516838213c7023940bda435359(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66739edba63d1c87d345383562e9d3f1468792665422c00bcdfa9815293567dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54a471f080009ef684e703bde34a1720495ab24e22a12dba0633f44e2486d575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e76d67470a4aa5d7d531e77998e3894939f07bd81486d2853dabb990f50e66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d472d5f3c3b069f29b9755e806ab32c4edd960d947671f4ac7d9f7dee141f508(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc6476ed210e0748dec2c0663769188ca5b1d4dfb90894fcb01b80dc9b07606(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1647ad79191b34ebdabc9b1d92c88f45c1fe0c070cbd53b01eff84701925f92(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157308fece2a223a3cef7e0566cd0ebb35ece758d0418805666f5cdcda31e62d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78d2ed918d0e4c8c9a71c755a8917137c34ada91afd13b93b221de65e24e5371(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f726498442f048464806b035a7e3501a8e9679654d59a0ed381a4026ca59b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9ff287e5a296720bb9a2a14aa80213285e182aac08bff47854300169de78e6a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b29fc13ed15c4760b9f60b55549d5fa61a0112dd3757eeb5914177a1cb0c51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdaea6328d357e8572140b4a4d34851955e62c529862db7ef6918148881e840b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82ab5965ca139ad4c7ab91b77a66e125bbb89ecefe5ed3b4f433cedb808668bf(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a2f86796bc5151d1eb7ba11c15d5e6ab5204e05c764311d8c8f7b471006b27(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21146806943e8c97f373e7a6faa2f0c7618ce47f51ca98be1b8858e8d7e39122(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c3928d71ad8af8ed6ea18a1436a3db5ad86c90ec247a9990ca10da71c3cb0f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d649c8d57c6e7cf1eaed6aa66e94e3716d95c7de5977ec0cc3dcd3c248e3b5bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa30921e39249883343696cc69e1bf3f8251ef7d5610fa46c7efa407a030e6d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba999fb039846f49d35fb1869145217f0e735541ca01c0cca7d1b3f2f30795df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__194696ac230f61f68149d3e68f0359ec9c7d9b8498ef8125e61ad0be656b09ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06966946d3ed524b051c7bb798a257af41ec5d1a616809793be02f6ffcec7a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e76b8a2f3f6194071f6fd2e38e8c02945939c47a6c4a084e3377b86930f715(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4194860f9478625455cbd7226bf84a69721d6301f61795550d167936409a0dff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838b1318cdb4b3de1378972e6ae5629ab063448091a2fd2d3379756aeea6d6dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1f06740b76fb95a0a09d696c0d3f0ba7c1ab2f3907a513777fffdd2b8d4e29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2b50b4addb60fd82be3cd0595458a52554122db4d38d0cd01ec3fb6b66f106(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07688192917f84c35ebdb37cb9b35cce7aadbf7f25cf7c8a66ba680d0250e383(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1fe2b704c31ae8988df8f562fb65d5f3697be1bd91e81e53f39b194c6c040aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6092c1d8a382a5c12b1ab4300bc76ab092944544d780cd41d367ae85b4c649d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04104295dc235eb3d288399ef051b4d6269a9f109a641b81e3e021fe572302f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d394d87fe51ef8ccaa51b206b7733f518af90ade0e755fa7b8df27085feddc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95b7ecf49fd9739682013ac0b746a067bdb4431a118bf46ca4d36687461ef6fc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMediaOriginFailover],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2cbb6f1e7365cb51118aea15d44bb8f59e8a2b9a761ca3031fd9251a215c22d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab6973f337543bab51c588d1fbace3eaadebc66cba7085e28eb167a2dc17f25f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e32d299e089abc2bee1d7b6ddf636d85740f2e38e7e1ba36b5ffb20cca87258(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df35c4fd97821d81bcac3dc1c7450c08588aa6d9e1adca2d1f5efb021966fd91(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92dfe37ff947e1dd96b76f0e015d3258b3952e32dc746c4abebdb4ef8e9e1f97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b55f4b41ec5ddf69c718f48270df99f61edb7418f90beb554c90f815a6256c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3f69da11ced849efd1e430abe68996809a071bc2cba13790605b48c62a7323(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMetadataCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744e476839cac2561c1f7ace5241e684effab73de5a15d596134b0ae877dd5ed(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1557f7f34f84f44f2f46758b8f52510312d7a49b1241d38319dd5f0a75047f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a1f43c5908c96b7b336b03c714a4be0288123bf0bc5149d4fcb479d50a21196(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8074a02a2cd1c778c8a3d07aead3c8be1c8979fa8531de62aef370360b8fab0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12da03989c2a96bee0bebb734a79375bdd9353589a2456e68a15584fcd2e25cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abddaf4778066f6774a84b835e26f000e6bfd6a91dad5419ec08e2726845cf76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba820733e8d3472d389171f52f685303c57ac03ccfc562856bea8c71c1330d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621b49783009af8c84a452669ead86aaecf4737d8fcbf102dcefb9f14fb90fb1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorMobileSdkPerformance],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e472e8745790d2cabf524938c3926bef8eafae06c9781948f8028f0b8d35ccce(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0b7d0eb0cffbf54862545f01f682ab9288a7317c4f59ecedd8b16821b7d9fa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f727ea70fe0536e27fe9fdd781d0f4007ec9f6fc2ec3dd170b5bcb27f1f0965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3588a38f6f94af6eacb43a66bd694ba90552b9bbf2698cf3af15ce8e365c7d4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5457c41947dc52fb8fc367ea4fe560053a03c6c30f6ab60867ff92323bffa61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e2f1615062efe9c9db0111845b58b38a3ceb101db26f8b0dcbb2480e58af864(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4eb3000545e92d1ced3b677c48b1debe2a28f8dbd09b0a4739301cbd13ff3f3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__218af5ff2ebacd3cc2605517267c88956041ba4622713964530c3a361a37f752(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4bb4838a315922318fd778ccd71f1427f035fb140ad166f25884417cd3bbe29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__175e10fc5031421158551dbbd89d07aafe213c33765d1165d14d5b0dc368cdb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__333aad70e449e4c258e9cea9ed44555931f2dd0c4a8d21d8f9cd1e5a569b3c96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091dcce9bd7a221d0bf851fcd3c4754de6379e44a0bca2187557dc9cc5e63155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27d171b89c205cf6d877b92919c1dcc9bcce752cc0b86e11bf93a84d7835d35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d173b593c72db40bca740edb5ff46fb8ced7cb76e538ef426e102da7df50fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d857d03c66e8cef633d6173c4536dfb18cbc3682ce927eb18f5f3cf46db78366(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edc3943a50a905523191e97ce8afe7dbfab7e1df613925c6815393175fc838fc(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__567d114d13c7e3af82e61b817f03757aab920a880c33e27202bebe6d5f3ff7a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63166d696e1b7213508eb7f039fb33abdde94535add90ae2ca347f5fd5a2b222(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c7ee94cb99c0788f96244ef826d75e9c322b491e0d90be936cc73e2de6d697(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3db06952624513eff47edb15e802c9fe22277560b1347fa3e9e47f833311f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a4ddbe7b37d58356f9d7861cc0a5b3063576666c4ccc7a89b350c28c2f777bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cebdbff394f9ea37146b087a0f52eacb77a4b59e2422887f7178fae84a590eb0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb02db3bc2b3c278256d59b96e154bba837a660f41b2300686fc586958248977(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a99d8d0d48af48cae70b70d8e5507077a16cef161a87045d81ae4a0a82bca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8874077e9f7ce4927be81fdf6b44a993a1872dbdcd8a8c4229973b837fc07a41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb804a7f6ee29de424fdfd9354226c0797457da0a57517c1d011ac4be483e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7471f279a9e2aa9fad53f2f6c88cc5bb5980f7466c3af312a0e7e5b6703963a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd69444bf662f3062fcec74f1af805be81b918538ff98ea8e464a0914921919d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60809e89e0f38ec0ba0f5866ed2c82aa4180d951e47deb5096888633910c2347(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b1b251307e7b5606ee06af90b3e01b8664e8fef2824589dc8c85f76fc09d24(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyIncomingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca65477d9b97a49b3db020ef04a2ec8c5cdcd72b38129bd5378c0ea775c126b0(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f36c22b460d7faa665b45544e09aaa562afe49c8c757e61d1d9cc64607ce1f37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f2c461743215d704445c169af1a34597e090f33642378b66435655879612134(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0b570820fd65706df276cf47ea0f67e784d8cbe8a27dcded5537282c3d0e358(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8139d4be81a41e2c46c88f64fe2013418214dbf56512f4896475720f98848dab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a35baa06db79c38678138279cae9ac574fb5bd9b06da5a74274ed619a1ea1b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e88324b1dc8fdc657e3c02ba0d1687e72dc99634c2803bb6767cca18b95b46e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__520cdb4fd1c81f9efe81abafecbb5ddd04831cf13b3b1fa10ee19af8962c2d6a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5596b67799c6ac19dd6c393fa98241ddb37bd70da87b23d5b0cd86d76f8229d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23c60dca885ad96a50aefa34405447aababa033af3be21d66b306fdc9e63a033(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbce5079a63c99396744261464e0dc9adf31cc52f08bee9f12120247c3171f43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c02571b543d1a93794b09ce245a84037173af16374a340a004734537609d7471(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ef3d39a5171cf97a293d69cc7c5b99714e651bd53652f8f0b8ebd939a9bab1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3297627ded301d1e0d41a766a1b07742fefa4585379b4b4b843be5ee5bda4276(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__142556a54b4eda5e16a7674d3e16b90d9001cf33a737cf8979cf12c1a9ad05d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a0a245cebd02c5820d20606eef49f4b63e3595e79c431897e75b74a48cecf42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a6456f2d7cb82c2d0425ccbeee7cdedbbc448163477792730862cc679bd642(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cad1ef99ad3dbc3a25c7d6fbce353887591070b201b5bbc7dfe08274c6c5cc81(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c7b6fa4e5a84944460ffc5d3456eea00bf44b5e81b152293b2e4ed27a6a125a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012939652518b7fc62c30969d2734e3a773ffee501f89f522eef8f3b54ebe144(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4281d4ca95fd6d59b9e8342d69ddadcb68330b1eef4ac56ef9d08d6f3c7e1b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e50a2d9c47a0987326e6a476ae6617a57d4f01e888a74ebddf084e61c97ab1bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4975b0563ca94242276234ee9694668d01dc4ac33c40c6b7cd93bb26a73ddb16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b0ee4016b6e53482c1bf7e77e6ed809eeb24c4f95be6e4a80c0087f46e07e2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b4da28a7019d7577bd083389b25f3f0c11a9c6cb11af851f2af2d94abc5d1f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b4809bb3be75e3c3b1d05b28f3875955283772e46ccf58e56aed21ecd7b897c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37af5747afdaf3abc996a1419f1281460a9d209749666ad8fdbfe6fbb5210f1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06899ee0b2210b74b9f5731b2e66e10b3fe9a918c95b75aa7dbcef57dfa9afae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518f728c949f8ad0f2e78c67e704c8e332cb14c6d043993a5d0d051f5fa88288(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3bf19007acf3ca048908901f5df1d597412b9f139950c0ebd95ca1b72d8a2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df90174b32ae668b49c2d10f5962e1ccb35aef6404014809de80e1b5012c170c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83116e8215480adda2aeff194ebe8c120abea6a0410780b230f2bce7f55a6dad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9a27bff90080076356ff4f33249e39dbd1a4c82705c8c912b84e3638e2eda3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5579c6a00187698e822ee9ab3a9d7033f0966bc434cd2aec041b32cb785b71c3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyOutgoingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292358d1f057a2fa7dfc40bf5e7494728fb346fad14ccfefae97aa59639bc2b2(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modification_option: typing.Optional[builtins.str] = None,
    rename_header_to: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc3edfe2c37ffcf8dca2d307c408b4b9303eb34224e69749224ff28c2239b9ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a308ecb8b65e13165da5ebe739d049081f9094b0a7f2d73e4d44c57361fd56f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55d6305b531628a74e7fea95cd43623b1b631f9c728ea440dc4e7bd6d9f44fb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe66af5774426696232438fc109b31ba5c37a5a7d6aa41ea097121d024e23620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__116ccbd022c00d7af9427c3b11a0d71f15cec7793abddb478d53dcb375054999(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbad4c653e751a2fb3be0625a139cfdefc29b0d4a217d0df71e82f563d89635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998651e3694c828d8154bfdf8bb99dacc55d2960353176534b6f071b6244732e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6bd6c8a20dfd1d2eb7cbce0a445b90623a9824201822652b3383d64c995b45(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorModifyViaHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__762899253835660b48cfd81938bdc0362574459f2a824e019d93fbedf5ab9b00(
    *,
    cache_key_hostname: typing.Optional[builtins.str] = None,
    compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_forward_host_header: typing.Optional[builtins.str] = None,
    custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_host_header: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    http_port: typing.Optional[jsii.Number] = None,
    https_port: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_tls_version: typing.Optional[builtins.str] = None,
    min_tls_version: typing.Optional[builtins.str] = None,
    mslorigin: typing.Optional[builtins.str] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_certificate: typing.Optional[builtins.str] = None,
    origin_certs_to_honor: typing.Optional[builtins.str] = None,
    origin_id: typing.Optional[builtins.str] = None,
    origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_type: typing.Optional[builtins.str] = None,
    ports: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    second_hostname: typing.Optional[builtins.str] = None,
    second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tls_version_title: typing.Optional[builtins.str] = None,
    true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    true_client_ip_header: typing.Optional[builtins.str] = None,
    use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_mode: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a836cc749658abd87b6d0574af1b7fc1165c8efe315aafdda8f1d502be43c582(
    *,
    access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    adc_title: typing.Optional[builtins.str] = None,
    authentication_method: typing.Optional[builtins.str] = None,
    authentication_method_title: typing.Optional[builtins.str] = None,
    aws_access_key_id: typing.Optional[builtins.str] = None,
    aws_access_key_version_guid: typing.Optional[builtins.str] = None,
    aws_ar_region: typing.Optional[builtins.str] = None,
    aws_host: typing.Optional[builtins.str] = None,
    aws_region: typing.Optional[builtins.str] = None,
    aws_secret_access_key: typing.Optional[builtins.str] = None,
    aws_service: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    direct_connect_geo: typing.Optional[builtins.str] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    end_point_service: typing.Optional[builtins.str] = None,
    gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
    gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
    gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
    hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mslkey: typing.Optional[builtins.str] = None,
    mslname: typing.Optional[builtins.str] = None,
    nonce: typing.Optional[builtins.str] = None,
    origin_location_title: typing.Optional[builtins.str] = None,
    property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    role_arn: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9440c2736afe675eabf2733be3ad49cd2d89dbad7826a28ef329174cf0ac569(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef0b65387c53044e5a017de9a3fa026727feca3b6ba41e9c0f44c3a8ce86d62(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68289552d6c9dc0056ba14efd67f3a228a0a629270d2f3154ad55f2ef9a30699(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98d60355fa7a2824dc48d4c97d5ac12468fc675f21591816144f63395fe52eff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c8622c409683ca4674d57e3ff92fb2eceedfc3fccd6c4c917e5c6ef4a6d185d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35735da0f8cd73d0420ed8bdf56e81eba680b3b81be218a0d6976d2e3322528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca1fd14c66091d428de23d49b572729076565028f149c34a5706bd6146cc3cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06a3895d7eb30a13f429515e2a9e354fe109653236e05671364f266495e7f0f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__282878aaa2e8133c49cf0e0ee342698be8ae8f126c24d772911cefbf7bcc6fcb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e4394a419842fa580863b53449091b480ea8f92d119018c461c0fee266b5bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8801a7fac274b7215a707c77c143df4bcc4f8e1a59d52e5825ad38134294551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e468db41fed5c4d232112d6563a7be076d134c19f3ea51928fb3d804e1d4d49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db77bcb5aab276c519267d326bee4de6ef1e559a2af57c931be470467c157f0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d314eaeaf0ac39a708492cab4c2b372bd2853e242c0a6373e2f5d561e35b9a9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8561d28772dbc4356f75aeec8dd30f47d662c05fa907332e0c859a37d86b6855(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55034f5be2654df3c258f1eefdac9c548c8aad6c1cbd4e60bd50655344ff8d5b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067ae22da91257e542101182086b7bbb0f48e60c0ecd8eb12450c816ed05fffd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e88224a25ba759d1bc3387a8d8f357001b4387f729c0c66313737cabf6c1550(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1994618e37cc9de983e78252ff2e89e33e077d98a4d7a25452ce63e915dd8af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d626a80136195da11be3e4de61f2b0cdd52156fff909174db2e71f773667bd4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e5f416d13826601a4b1bdb0b34cec305fd422d062a31a14bbe0233f3b56915d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5104fdeeb6e7b5b71fa4c85c20895c7518c6aed8e398dce1e6a64f0899827afe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2308bec53ad19448a298da42fbf45decc47cbe850e79788f218ce2b01d192d5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__028e2b101c31f4a407a1e549cf122710536c17b08220792f785ebc71045a3bc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4035067242683c45545c821dbb8aae844b5abcf0648bf8fb2739e5c869bd454(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3564b766f4d4e11f25e49c5fa1ab3ffa62fb1606cce25ab21c7fbd5a13525900(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d57e9240291464710694da2e272300a745563b843168f4a90154715f774a0c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e58a154c1ad68d31e7eec339e7aa0a4fec667e7e76e2e1d9e14767470f8886d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__353ded4fbf40bbbad9dd3685c69cdfd6de2860e3da4a803398eec0386d3bd153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f96dbfe77aff84410ea2d1f244712bcf56e55dcdf1802d885fd64fa33408b2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5bc1ea64a0afbd35225e99b7e0da9400cc1096a85a888daf5a79f374d5c1a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2da5106d81c4f2b2379eeee73a8bcb34c70937e263136d6c477afe81cd7420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24130f714d9a9b9695222beb393a728fa88b39069509b9a19b53dfc5aaad7457(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91a1cd8eae77bab234f037c75dff578a29e00d3f230729570e5aa9c817b722ac(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origintype: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa18a4a07e6688b0bceec0112a8082fa705d056ec93c328651efb6a995c9753(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec49cfb6145dd5d16e5319b925ceb86086128707b2efbf9cfb25ded7d40e83ac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8507ae823be16286d21084c58857fb628595526d1690bdbffc94cbf8bf610b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913c09f0ee197a707acd853cee474f35ed02b6ed68fbc6ce9e9262f9d1bace00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ca24cc088ae22fac6f130f938d1af37b11fc69cad6f3f169594226048498cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604fdb7838b8199b01406e67eb408f50fd072e3ff66b88c44b220ba3c2792e47(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCharacteristicsWsd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417112bf9e9ef5e92627a874fe5a438a0ae545b5042b7bc78a30440ccd8c0b20(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174fefe32eb11c1795ff6cbe68043eb03f0c00f1bd7ba2088890f3f97205fdc1(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46cc475ca706c60819387eb77d4fa362b074ea42b61856d6f5e725ae6d884fd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5da096617001da536717db8d8e900171e0ec3345a2425da5a1a499f171cb830b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__919a85132cb7024e70e4bf13dca9b844c61c2cec63f77470fe515aca3ef0b87b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a551db8cba5c7095c80bd3f49d70865521fb0f2662d80438a8611fbbe76fb805(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a34c06af366eca8bab59c605b4fec0b58729b4571b078b41fa422d7c06156cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cb5b32db8fd53f57ca625477d2c50c96b774595ed0652be21dc6de14a8575fd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aacece7fa58a7db8b7de5695da794f648db9b965efda44b349414766380e0de4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec34129702f04252aa2eed631583507f94cfdbdcc8f3c6c1b113247883c33af3(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3f650670bfc821578077f0d03757068ff42f1a9f55acccfee6b213e6c3f07cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c6845b1d011754d20c6b25e0646138ff2cf744d00fe9ce5df090fae12efc29(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b4043f49bcc90980ad901a2372f8ca8261212f6705e50274a1864cc782c7cf2(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a09a745d581b8e2093ddbb2f1714a27540ae07efbcb8b122006d289cf751e95(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5190afddc3ee0df1611aa1f2597d3dcaa7ebe9af5ca17e46463fe5f72f249d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc6616745b90eaeac0f773744c1323e6caf191b6f703fdf0e01ff3809343b0e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9a32562fbcc2811f7f3ffeacbc6dd76ec080ee926b7dc121f27d68113983eb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a1dbd07deba2d8df02f7c90af6d141eeed59296c7aa99f560bab9bb1724e3e0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__053c807b2a0fbd8d0a0fd42e170cad465521eedefefc42c8e3241057133a0afe(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72620982c4ab2b7017aa507be084513204de9b14510a5c573c1be04efb53ddb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605a8105d6ad66704b2a4281c83f5cb01cd16b1f0018fd72531f7847641a8139(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d6c6dfb0c20c283c45090e868c108f61ecd0d8d14a4ca7dc5bf9766e96bd2b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581c139d172957192b843edb1ed8c6df873ba5012e53087e5d84d249a680554a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a180d5e24024e0baa5c0312d770e9d4bccbff8cfd556c306ab00baf6d3cd52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2002094aa4759223e2a53dd09f1d35bf57e39f7ae5e335a1f84746b63d0a1db8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85365b2c1f89da64b3c96c64b6b4cd2ad52d4df76f414b6c481dd2765bfb361(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be58c5a4627f5a9b9aa20a5a1b3203606efb0bdc455222a3e435e8006c2c397d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01dc4ce92b0b1ea2e3d89b0b6449273dbd55a515bfe9ed2e24db9544194fd9b8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f39d8e0e14e5802e4db217567bbef1b858e35a60db058700cb30fbf119de94b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5438b10c6401eca243bf33f5a914c5ef4bc95a1bdacff62a3d9c7cea5175e6b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d17045272d67f8f3782cc78de592af2e283f432b300b5ef80ebad5fa4fe217d2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87cf0ef03b4c0c6d6c779ed47f9ccbb41463eb2ebbd889fd28ef633fc00dce69(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5219bd7a55ab9055e36167e2e1ce5ff80b1ca50efa7dba581eccd0d72e9f3eca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88fc6961e226d5a4388a89270594d5dd627506425dada72cb12a1dd1c7b906e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52669f8609530bb3649886543eafc224e08d2f739b9990ca2104f4320bfb6ae5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb920de63010bee348d84656f5708f6678f553531f48afd58f116c09f764a87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2353033f6484386bb00cb3a5c6b7cec2c8ff3c66ee9119c0413c4d2da06350ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7ee998e6872e6a2a7600cd69e90dd76d720924e5eb42c4c99300447442fb22a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5a18329b20e169bd0c6762a23b4a9926e4bf9a0c04a919ef818ea470343f4a(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43143124127b73db8db764d4a5bc7356f2da153b5268d88867dd4319a4c954df(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b675a967ceabf5c605f5517f0c8edbd6f09599535c935c9bd062974ac75b83f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a55fa71379cdb0e67acf2d58444bd0395588e988688bd30776b69c2926a1f5af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f9bc8daea2962b8dcd9bb1a4e9938cdc679f7d80b756f3892f431ed55bed9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f2afb10147ea9f60dd18cc5ac9387b7832df2309784fd2297e7a5efc4679b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd6c37f4f804c676f42f703c9cd79d29e8e5148f204770ffd7cf09b7a44bad1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097c01aa02614304e71f2b276c27c2ac8b84219756a8ce28053cd02f61bcf8ee(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2405488f652f142523bf28686f5f01a14ef2783f3c7b6629d2b41b87b7e86dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50dc3d10a85882a874285072c9e67bae0bd16446801805ec902066b26935bd8c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fa970c61f5572635d4ccfe0bb6aae65ba6599a1d33af31cd585f82b48903db8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bca7cc9fed840ae2745e181a430f5d95a113401428087b586e957f542cc3da7(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97db26b2f293aba49b77d4f9f8a46661326b3115d22545fd0a397a28b07f3e38(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bc72c097dd7f8bdab425a1387823a496880239df29d53d02867ed6ea6fa173e(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2aa133bbff72de7479ee98a11e16979d271c551ea4d5263ed3b4d3fdcf3c735(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3531b3cce257893744473c88967a811f66b7cc99e8df444577761ecbbffe9764(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e22dfb9c9eadebb06dc9a2c785d42d64863473683104c70d248da9f6a7ed843(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a37f89e97fafaa10b7e6ec828b483ec5044bb984b3fce9df91983df441d4930(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__778e583b0139e7a094770b0650ac2f7d1e4e18221c39150f39bbb4fbaf06b2d4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6fbd97c013d5aa3abca1da36ef5b7ef9267e3069108ee769761a675807022c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__914a2dad4a843a87523c55fe77be8eb7be0a49ae4ff0cad79c03ae8e5cc411e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8f5f96df8df88969cf2d930a045af09cf55e96a7a40d2008507313add9a47d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c49b28a3a7069fd78857039f1f2c2d81396d1cf33e07639200cf3ac9754184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42cc0709acf33a1da9355e9b5fab40cba4dbaa3cdf1b54c9b5db556359556f18(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1ed8c9e4887f86167a0ddc2e2b8844110b9e182243bb84de20428197195144(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e24d2163d519de255e501163467a762478f7400c694070c4a0e768801f2276(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3e232c06ac8e80d398bbc2b9fbcad6d9d543e63908ce6facf3de1765469ec1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37b2a87ec50138779a4113def07b4ffa79455d4707842e621b1f30e32b4da92f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44f8acd9f74abcb0b7425939d836673105d33e467f7f23d62640bc8c8300bca0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a2bea5f3df57face16278eaf291fcb95102e1c639b0a8e85313820dba5b3592(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa30dbfd11b3fbea26df502248a70ffdbf24de38e31f6b70ae5c4d072e44178a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701987b8cf8b302a9162751ee23b21443a11afe8bcd8cbe8a5bb18b8507cc78a(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3638df956b6eb5cc26ef9ddccf1dde7bcbc5d941e845a65a9c7b56951a3f7b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a244b60d7f5c49aeb32c6b0344c1a526748dd67a09a6896a7dc03ac2172fe54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e685aefb5533a01545a3591964382d0f76b4525209aa608cf9367df05dc640d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e918daabc43ad29a78144304408e3a7a526195d7f77e5e598934de84660795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d680221374c488d033bdd0aac66adca0a1d21f38e29cf9eadd10f7bff880fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5f2ee8d507b0decb784961d3751c7619e628c4ae28b35c1ae3624974b291f6e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificatesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ca9cd5bbc1fb4f851b5c596d2eea0cddffbe3cd2820c495faac829bbb9c73c(
    *,
    custom_status_code: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    recovery_method: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a9d92a0c1401e4b557b553cd86e1fb33e253a82b95addaf1340341454bd2d57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28b3b848153ef2284c6f05039713e8b0a6c0bc72e8b941fcea8126de0f4cb6f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e831a4c591683577ab86c38d8e6b0cd03bf53251e605017d512dcd40456820cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040eba71b60df90b8902a93fa985b1c76d97b1247e19dab232d4234366105bee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66c33e99f95e5f5507ee50120dd0a410ac8ab4b4fe35abe1bd36145b930be208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b0206cc32deac4b2a9b3e27ed3d71662d4c3beae216e6062e752eb058f6984(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da5794173681db8e4de98aeb739cf5b9104b86eb977bcffb3aa03e2f680555a2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1912e6773b3dff7c063dccd3cc5cc82dc88ae8afb5346647baad012b6f788d2(
    *,
    binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
    ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
    origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
    origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
    status_code_monitoring1: typing.Optional[builtins.str] = None,
    status_code_monitoring2: typing.Optional[builtins.str] = None,
    status_code_monitoring3: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tuning_parameters: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a62fabf6b0ebac610d79695c149ad89da1289606656075d40194618c2764fc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cb231fe1321c91d39a2ad4e6985fa782876cb202e4bde9fdb9725b481af2df4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb9b910243df2a05615b955d530a1d9ebc8b984bcbb44fe90f621babdfdd1d3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5699763c5b2712423500e2a3157d70fb6eb2e8ae23fc794ad3f0a7974c98d763(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a7811a30067071ea6943eda6279f7292b7a0bd6eaf16eb64da6e5b720b07388(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce94db2513719a2855fa66c9932e68420f3bc59bd9f17260569e58a67d0bbc59(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f4910783214ab1325bf7bbb2d7aefe0985f3de9149ccd37be1dceb065fdd55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6067b4a44be0c2975fa6dcc585907ab639557a3c0cd4945858e90a2089779ac3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef4c9888325972c6e98d5c669e830c744e69cc8322dec75a6cd25c7be37b99d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4caf7e1fe3ed2b390bc313e0cb2e6e08805a937ee68014f615a9573c778ba992(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f609e23cd06e2251c02eb0715d4a2e39019f8212a2f0530eae547eac6a11be(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311161cdcfaabd41e4b25041acdcb5d169f4a8bddd2cdec69af0dc6aa55089ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a361fbd610b5396d9a187617de0e0d09fbbc985655bf64becb272df502f498(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade84d1c71e8fa8368a75224e54d16bb3d6d8e48c7f491cbfd97709315660d69(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c73bd7561cc108d55991fb06397dcb029dc3ad6290a8cf2ee4cfb1b3c76afb63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f849edde0c7958d0ec80313bc7c9dc4387b7e3aab1e956582d3958858c48d47c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e055eb9f1377230bbe90a7b58a7c302e679c2b40a7ee196325a8aeb54f92d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ff95dffe2361ffa83fc6986440ced130ee35d11c56e082a585c1f1ab8ee4b9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13a1a1ed3077e0c16eab2ee938911970f467738314416f46f91ce7a30123a3e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a41de9102f00a5912e0286dcd534001d45c7f8523817b46fa5c37484a30876(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a46982d47c67210e96197c9c92682cccdf05c606f1d758fea20d9b445dbc109(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33dbcfe5a6579bfe6d0f8e130bf0918b8d2ec363eb1873d5972e5ceefd3a7764(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56d4f0adabc5d3c1fd8f4fab15f8c1f95980e74f6f906229874257a0ab8ba83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9425b430b4bde7d75c8f5499c49e6d39f4baee7b716943333df58951a9319739(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e534d2a0c2b56e344f906d80b3e4d4dcf02b93e54cfc4967fe886d5235ca7b65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663a00b319e9f24a2dced4dd245d9268306fe7f926fbe63690553bf82ec79061(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397bf0fc8d11cab79ef215be8f55ea6fc63c291ca35c3434dda9650906b6682e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abe35cece8a6957d2f7ac59d614f4160081a6f401ba56592fbd20ffe69ab6e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d380166c6a813a2da85ca43502a9b5d628333ef0de3fc55ea7bbdfd50a584f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__790ce1d8b3b6eb0701537abf11178eee52da2d910a05d030eb8af4f260557fb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab6e3b9ee861787842b6b50c671cc490817f9956bd322bbdda4211f42ce04a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d08cb49da472fcac9c62dc95ffa865eaadb5a8ba2c45d91cf609a547d00e97c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28025517199c39cbe4380e4ea49a78bde2c3b827ebbc91bd61fa52ae7494a2d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d19b8da21bbeb11310f9b8687569340ab97b586ca6dffcd037eddfbfcdcd651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32365a4376167b5e140b7b613ca18c0f89fbed5c1c5a9abb765be8de1bc28b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78364f959a32cb19987e1f24c061386b0fc145c773a78d2ae989b7f3460126ab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginFailureRecoveryPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9124639f64c1c1c1faae8aaca7f7e5153c14b92f89d8ce6d6412b8131a89289e(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f3a54df5ad8f8c3666562c7ede463558132ac29bf89a405606c26c5d0e8d24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208a3064bc1687fc0870dd8ace58305c575a62574428c482370969a7baee8b54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2638ad3a2aff84c02b02d3ad484350080c0258ea0cd0902ceff7b5e989be28e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ed926fcb24ab9b54fef111ccfb2ec8d1385d3b27016583ed8262e673dc2d7a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ec529fa691d6e3daad5e817eee6a842d3c55887f58b34cea526e9e64d00492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__424310c62aea3c605e5d72c839e46442491ffbf3cf1f451b56680d3aed32f803(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginIpAcl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72448256e4a84c56333ef48f2e6468570054f4e7b1b4393c1fb3b99d48f25a9d(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d9a6fde1d030f5d8e8ddb3f699bc517dbc8277ec9edb5b5f3642adb90673035(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d7b66120ce44e088d9b91963a8f6162213093abd038f3c3e860d18d59e2d45(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150c3b36e2e2e730b82185666943316dce685c443cbe9219699fcb665091959c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38f64cf583a89e89f354e74d84f1f25bc13f2e0a68598c6a61d0113f3291ade(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9246c7c1d0c2a639c36715cd3caf778c8f852114092c7f5fc20d44213a33781(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f108fcf508bf35b4b5f7af88774c486882b7e6e3bdd80c8132396bd89747530(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046966f7612f4599e11a0b0d0dfdfbbabf209815c0e71738af9dd2a94373e23e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910dec8f6425c846d7a04d192fc8fd4184e6839fc33092945d50cb96959752c1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd3bde8499101aa5ff7ca3922d5198260d2a7f6d70c1fedce97d0dcdf9bf98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ad4f8b6497338a8a0fb8ae09bb73cbc5c1ed33e3818950ae2a92db5a919dd4c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2542d2262d4bc3aa576be5798e39c759b3b0f86a2bef6d488e0bee6a62ed25ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6fc1806b5b885c6151daed434ef3f1ddc4374fcea63e8cd53aabbd5f073753c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4777f3f3e5e58db069fd25b28e56b9084c2be57d64cad3031b29805f21169a57(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cae096c52e30e395f34c4373a6c1d54d1637f982cc5fcdbf472e7b54d93d671(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0541c8a6c3cae14683646e75a7d2e56b17189b5d4359f8c8bbf0dac5cd12ce4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da73ee38e49eb9029ae8a40a151e04c057f3fcd9f5ddf8c31abcaeeb11e38534(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654ad1b6e7ea5fa7d9f2096d87bc333d7b35fff5dd6c11f8f5b4eaa494e1f916(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93608280ec5b09f2cb2bb0de9d5d7840fc5b335c347c0719cead68cf7b830db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78b0b6355a9672ca4a66b0aaed23aca40aa697f8add2d310658f996c2e32944(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3f5ec6b38dc49d19d63bc2663237d50964b4a842530ecddb52be4c3bf63290(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__511df80424d18f0571a8033427ceb154c5d2dc8173e2a0a5809e86971d512563(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8393fd69229f19e310983ebdebf5ff5df4c67acdbefe1ae2c8b2af884c674d87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff650f6bc4923e187ee629b7a93dae40e08da45825e360d0c808f3ef9527b169(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d68ab9b036ac43eba83974efdebf937a8e858ea6fedcef23136c7a4b2c2a219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1de6310a6a95b7778b23cc2b9b23e79f3f7c1a1e0b5d6b85202b63bb94ca4adf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b7c2148acbd106dc3097f8576a23bfae39b20e362ed5ecaf5404d0c3fba917(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efb8ca01345d353b1ecbe58f0e502daf010a930933b558352bb98ee5d4bced9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408215ddc295da428e5e4ba0675a5704b6127d5cb72aedde8c3d3fa89ffcec8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73a61fb6d4202ffbf61a714bac76916be1cf9b3a955b9260f2fdfa48d0a4d48(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c034ee03d0b4e03ae2959d7d4e5c20132c9e9d75dd0f43c15be78644df079fb7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf4a123577efac58d8b690d1c211a0ffae75dc785d32fd3b5eb127ea2c84350(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab313077e72cfef5567b3e092e8c837e31e9ed2045d84a6033c18c76fd6723a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__751057d3f9a46b9a454f6e294227b1c36c95dc9ed74fbaa24d49d8bba6788ab0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648e00e12c0b004af0b515fb4c5b31dda8cf795faf3ebf4bd5a5df1fb1d8a95b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c5d332a14f1e7b4dbceaf1e2e7e4b42ae58155fd53b9082ca0ded33d7bd91a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb8ce8a7541fe49918e99c8e3007ab3f275588deb77d4797e24035366ca78cd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1df8c8d5da936548fc5371e1de0a5418575145724f93ba9965d52ef3b781eff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__007842b47c7f1e3792f5923f95086483be8f077aa0b21cf1445cb1484fe83a1a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f70e66001f70b212c5f67b345813aea43b02a274369efaeb86a96dbbd87769ae(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253b6aa8a5b7d4e7e4ae5d5d24f55b3c222bcbf7fcbf5b71ff96b17484e55beb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ed2888af9db63d87393e0886239fad82fe7e0219f48864ded38daa737996866(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__009912b94d4d2d33e8389eaf35657524e770e91c58bca1282d04e7d158244dc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b4d0dbf66740f02667ea591dab9394c95e8f6797debae78c3be0a73de3f201(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da56324fc9a7d935fb9daedb5120cd4062018ae01f0e50137980218bf9430e1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59293b2513e3d4ee507268c04e883acdaee6b4a3f5380cdf2a7dd46942e1da46(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e60e58b5f930c942cac26d5be5547ef7cee894f69c20b5f86ad3a66e86f74d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88324a9c7b5efd72a945d87335a1466e2d88651a1d2d07c154a1293dfe02ef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ca38e76a6eed889ce304892c64dfad9aa2a6af46cd4d76d2453f131e6d9115(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32757a4d8fc8487fa3fce0b0910fafc77282c68eac9774b6bf261caa11eef98d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67a923f7edab8e1f4a4d4d26e9bb16babf8be403bb57207593510e95d725881(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Behavior]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744d06dccca44310a4531557687bdf4ea09dfd4a3bc6b4ee24c3066774119cd6(
    *,
    allow_list: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517eb640e94d12c1490ff10260bbb0592718995a7214752561291fb35750f0be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cf8b7778d102d4a68915f6a04217dcc14cb8d80b5b49470da1d4736512eee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c7a50a80d840b45544244d319f3ad6ab93b01e4e710b1a987c0664c85c6bd4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1906afd1531efc2c3c55829aeb2d2f6e1bb56f504c5fefa83bd99236a584caa1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a35b12ea093201af089f63de8c34e6c59ac9be14d050b439341f1fd24417b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4781fbbe8bd6f92d86cd41181b177c7dfec43d7baee93777391b6997dac9cd9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c65efa5f11f26c8a1f1f57ada98df4c9f56f5001965f2e265f76e6e6b289fb3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPermissionsPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea8f2ba9dc555368b9ac39fc8abd1532d958c3349ad22573faf234316cba795(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27825b24f8f05855f8a108f00f88f93eeeb03c2d725e21e8da92adb45d251361(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c5ee88f87a41fdea7ecf7d08040b004d75f1f7eaefae8a347d45e9c55c885c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53ae562b687e0d495eb9ee7c7e80bf99e8010f7e1cef61a38d05983e58c983f3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2900e01f78259f26474ec8d7fcabb0e58fad7f85008888fe9f80fbc9f57b9a0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444ce0f37c7d7a1e807ddaad080fda8eff865d39ca1cd38f98ffc7b033f81072(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9fc8c26393265c326b0d2d4b7f03cee6cdb855426c17ce5a290b2b5accb692e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11a9bbc036f331e35ec8efcb8ea861c76e227283f0f326e2f4fab363adb50491(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentClientConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab96dd6a6cce25d08535747ced70ab66d829c698125b4f69410ef6c6b42d88a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c41297cc8c065930cf244bf13f1610119d11d7b805cff8e415eb15096fb2117(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192c989f8e960b1b0ff48f1dd24d2c8f870ff1aa71ffd59a887a184973d18274(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84b06b40cff9c99a212966e4241eb3ee78d23932e2597f7ec6cb6532ccdbb76d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fea587af2f6f4919703ef90718c6464a204f448d596d1ca450a192d09b423a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db28a745112038ddb4a45ce88cbd51b1513b77c6038225fceb6849983fab71ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba78decbfb6094eebeb0b868c0ee7caba76e9f6b58aa973ad5a44f52f7ed7967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfcc21e4c8c46f921f45986d50bad5934516d41060131285121c3e656e04f45d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersistentConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fea85440ab8279a89194cfae1c29eabd8c96e3cf9f62b706bed193b3f914551(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045a2b7e370965414bb2bd931b889dc48f6b838160d04bdf939eb60d9b5d660f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acc274b1f84aa26622cb8c97b56c28f95c9dccef01328b4e07257db22b2be90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00e3c4fd623bfda8e4a2a6f53bfe5009f925a1922df67bd6d657e6500fbb4a48(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111e1f44acc4d891d07d65eb81c8d2b973e47c659ca1a7c5309c554a91f883c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b94508ee6e21028b5b97e24d2e98c5b478cb5d99af1bfa2683ccbca0f545f96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e2724f5b131562b44b1e35fefadb7788655e514c1ef55b923061a605e096bc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPersonallyIdentifiableInformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9627ebc167a096387d9d6c1182a229e35862b4e11f57dcd4924de551e528925d(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_duration: typing.Optional[jsii.Number] = None,
    failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_expiration_date: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1006fc3da3e3b299903bf27f812d1746b76ee0488c46d20cb1088d4371400615(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d4643015c7f075417a077a0a66a403a46d4eb678b0d9ba16be07778c30ae88f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0975e03b056515516c5360b01b14b674a566bf5a4afbd93262cd1aa42ee9988(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a6128017e53e908d70f1558775b067a678b71da8db713f526aed1587e5a1f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d61059e1a04966a0e72080c45dcd859f61b305284c558177d11697d66a07515(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedReleaseCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6089b78665516ab6a2d71c12c69794633e5f26ba4abf7106e9284e7c680a855c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__196db62b43e15523983d4331efdf66216db1dbdfe328673d641107908e9529a8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24bf6b8a751b513f264ba4f4a62acf2ce8e50b468f66ef3f45b1e9a3f9857ce6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e9c5677eadffe1f722f1149d4c5fcd78de7fdfe765a81334d8dc59500e5214e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105e3c11b76addd0fbcc41a287e705bef45bfa04ddc03afe5246d1056c2d6b5f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eaa8139eb0e5b440f378f09e8bf9d8ee7dfa2d2655c9a2debea1cc36788c4f4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ff64f232f03cc94abe03fc30b75e85687cc7094591264618fddaae7aaf5b07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20eaf8a6b34cc2b87ea82871375a2985dc0ed494ca8c61c5f6e987c8f3656d3d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82afca395b72223eae17951343efd1e6beb7a114fd0e3a72e7e5bc7d8cb00fc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61808415dc7454175354d898c470a4f94ddbe21879d0c5baae45cb745caef25c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e70dbb323ced654d92ceb983d0543cd2bea7999d412168c05857028c408508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85cb41ce02e29022f4f12d836f1401919fbb6812dbecb405c5265b717b78b1fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca2df9a6ab5194d0e1ee7a411068f4a9df85ea104d94042cd09aff262215b1cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d895702c4b2c1a740f41e5a6c91313aee68ec830c0e909d622af45385b01a410(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__750c5be501890c328aef9c7bf419ab22557d2d9d825668f57d0f1a7db1796e9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48810fb698b7d0f89049deb86fc118d164cd2aa2e52690daf19d5dd4c525815d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67af0b72242bfcc67d7c517931a514014cb162ee22686b6a750950b22ae6e434(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fda54207e4cd049a0c3855bb7d5bf72ce480ce2b49f42b3c89ff3e3ab6b495f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPhasedRelease],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4005f37b6353d438b6cf98ad2fc1f799a5bdd7bccedc15a8bd81f18078fe9232(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c616706b1fa2da12f8ec463f4f24df558cc9960f93772f50e4898474916ada19(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b5e9a93382e6d8ced5c700aad214999f8f16b770b5f39b877ef75ca6bc2d6a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0635e840f36d74f710b7f956e6bd6d5eb3df92437cdb5b00084d0266c928cea(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d7037a5cffb333c16f535cd044ef8da53b65fb82d50035998b74fe5494efc4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dced88225579d89f5b38a5dec87837f1cd9264f3d5d09dc834bffbea5d87b20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301ce6d3147971d5ad082036186c227233fef278e4883e69d0d48482fbeef98c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPreconnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5161fd46c694bd081e9ca17307b10dbce70d212ebe20836f6ba9acd07559eeb(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ecd3cb83463406cb82cc3357c3ff2ca676192ecfc3f581023fb58f454c26c4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa611e67424124b64c5cc9a4dab3e7c610df34644a23f7048c0314b83c35ffad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d80f9aef203c1d827dfb8c0fa9ee7a3536e0716ad53d68776236072e7a65d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f72cf55dee73a624aa5dac43207e6bf2d3a05cc524a43be6545b8bdf3d5221(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d06bd7952300d4d0da79f03c1b1d5a4674757ed8d34bf05774fa8fcce4368b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aec16d2fe6c6fa62dc9ce8bc42ccba697f4a7e98e8d541b6ad690078696bdc2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictiveContentDelivery],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__907b4bfad115df2765d348790b9311ea356d4070d3d338edcf6d4a50c158d096(
    *,
    accuracy_target: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf91015c0b8bae20c497f36f4c2ec5c2adc5010360713018041696ef8d9e2ea9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da72ef7d54499cc30cd52e65fa71796d25318a93b7efe6f6ce391b6c4ab50b25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3acafb85854bf8d0fa67f8391ad71e8b77a7fe24e3327e47fd2eb7bb0e2712(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31dd6f9b4f6fd9ea200b8fee19a43a9fc0e9fc7dbf6cd9a1482b429ba0f37e3d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad3150718903f343a0a16f39372d5b8eb28bf4f0c7fb41aa551805ed3fdbf65e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23edf117534d39fda86440700a393a30d607b6a7052438359e4ebc0728bf2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6a1f73e8c82fa418e78c4173af176118ff7183141769e537772c4a2a02fdbd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPredictivePrefetching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99b9c94227042250161601a60a1af59733d10712866f6845f2fe0e2ef620fe6d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__068e1bee56e3af5ac9a90fbe2de50b7fd455eddf708cd5e2ddf32cf07fa77063(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__713e72250a9bf411cad205f66f39316205863873eeaad5932409ed76b2c2a604(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a0f4fe9a9513a9ef23b78cacd3f3c7388af0eba570bc8f5eb455f3c241b8989(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fe468a0a14a8c19f94117e72aeb04a1c38ec5ab2f53adb76b9b78fcfe1e7d2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__badce0fc3f8abdd892b2eeb61491a9c9bde03b7d8c0c35eac38eab3d3678ba6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f228a0572dad76a27252e356be0adaf8f4350a8d8cdb5c3fcad5779006eb18c1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c11a8c97e7197e842e33e8a01eaeaa9f75b3758ba6a30716be7961bbdfb661(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df63c8b7f4b31fed2c96b797c2f0c5751c4692045f89d88d3726e9b4f40d250(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bed51a6097456f859d62e453c1e33dd877328d41a664fa0dc8dd3cd37ef4703(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80fc4506973f0b858901a93191a4c867bf5d8d42dad507270e12a11be643a8fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81be27e47014d2706bd7a6de65142bcc26c6428c69a3de9e1b26b8e3d5496c62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f2ad13f4ba07f94239a64de9361e3d19827d2e5581513c8dad7593846b156f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa3d31a7b061f276601224ef38d8b2a13ea9a04cd572d4c23200f416d48f784b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefetchable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de895cd01de496e2ada223e911b001ce31530150c6aeb0c975a96e57c10db2f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefreshval: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa17e9b933a7d7e8ff8bb24e3a05885753c548fe1d288c23d98e50c1d21143c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d222e0a34099d9af82bd44c4fa05b854d27a4c5ce9ee27afbac06b57a5511eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5819b11eac652b4f2e035835a10c913ad594393d63d6d0326c6e970ea85a0ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bd0d439d53559e4ade74e838d0b98d48f54f340c7f3aa47da4b6751023da93(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b8622397ccb668935ce3cc2fa9bba6eb052700ac3542814a2045377bbbc58b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c5625620b3e1a9fd42360044405995ddcceebe9052f2fb54757afb5006cc86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c07205600cda07d218ae0992c702790abf8d37fbf5da1e5b37a5f49d3284c0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorPrefreshCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8977b6069046858d2db834d927402398cc6a5747af7bece60f4f263642c3628(
    *,
    audience_settings: typing.Optional[builtins.str] = None,
    catalog_size: typing.Optional[builtins.str] = None,
    content_settings: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    delivery_format: typing.Optional[builtins.str] = None,
    delivery_type: typing.Optional[builtins.str] = None,
    download_type: typing.Optional[builtins.str] = None,
    end_user_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_concurrent_users: typing.Optional[builtins.str] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_for: typing.Optional[builtins.str] = None,
    origin_settings: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    refresh_rate: typing.Optional[builtins.str] = None,
    segment_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47b0fd282a30895470cfb7f62f94eb81029d2dddfeeb93f51a88811b5696c3df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6471b74687f0469e0f5e53d963588a5e4cf7098d20ca2b7e73ce3e1dbc48bfaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d129ceaab0449bf8f2994be86d601dc348450c0a3ab6a278bd26b386fbe220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93616e4c3821772a88a58863dabb1bf372a5860e90bf87f649fc0c2169afd19f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f967d3cce8166534f8e3c0b1774df1b3c3a14925384d878c7ab1b0dccc6b77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf13d267298f81ac85d5ce1d410322531b6b9dc878e6b10d0431f1e877e0bf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1093a41e1db3f27863ab13dc36414ff2857af5ddf3a0edfdeac0a75390964671(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e78fe7b494dae65024b2322a3f0ae51a1747c8b69f28d5f5a0884537a7dbebff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceaec63b8d4a447e04928a8b2f144b40332f4aa19187da46e57836a2f140bc17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__205d6657c73532c268a82162ac00e1142584797e3a7ee4422a6b9fe48b84271c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3c11fca811b0582a71985952f0306ecb370f4efb32cc0eae0a1058ffbb0c1be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65c8212df39d775543172d66443f218b5e4daa3ca86455d02d5a1c751f37220b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff835db4ded7c3a4613ba7e533a1e99fa2c5db695af33b9f5655100694c87ab5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee5ffd603248513ebb72497fe3b6ea068d7146cb1c0e6a148b40e9d247767d29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90859b522bf6200883d017d768cfeb0254a3112c6ce1eca011f29ba5ad71ea3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e56a35f6b2925b3eb2c6ae2cc68e9d8e292b21fa58fcfc61c129738236784e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d492df178d2a68e1898fb766b826182ae0a4fd50d54a03be4f5bc35c42620600(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da461a2d981419f5a7fe39bcfbafe74726dc7f66bbffd43a7fa3ac6520401403(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb64556ced7af466c5ece1a87e343a4acdeee8c6c182d2954bb714292c1c606(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9020db7eb6714b3b44912d1fca733bfe778a07b68a32a70f36c41b07b0b0b2e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a179136494c6e7ddbcef1271b2a53cc477d184b14b5d082bb206b23987364b1c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuality],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc7023bd29dacd4a32c2aaf2d043097b1606d8a01082d5a9fe698b6d3bf2b96c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    quic_offer_percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d9f8953b8d4a1c4f596d92c944fdb926cc2af61f2a6c1b51b5b4e9aa52e423(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34232b2c13f9d39183541333aa1ce5da0c126a71486632561f823ef0a0e75eaa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95a231a582600950c41e9442ebf4b9d8b183f3a0719d03c9281f9d2279c7ec5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90271e274a7c4ac7aa26f9c888c114e754663dcbcab73053fa34569d77896ea6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0147a0e09079f3b23720ed6eb8e49630683c6908413f089f275d19b85f1f84dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7a5ef944fc585fb04932a6c524cdf0cebe5396cc31e416ebf1f71949ab745a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__915858668c207f656c65f172dd923132f6f5b4b909ef157287b186d466e7fc58(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorQuicBeta],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a47a0e60b06895c00a88f8f3aa39bfc989641cc30c27caccfe3c09a4c2786dcd(
    *,
    flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5c7ea9e9233d7b1254e8e0e3591d9dc19751461c58d95f7d1d3ea7d86fbf232(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01af38ef762a63d954013ee1992d18dc7010bf36c4f0d1a02baa6d43aacd3d5b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257363931b83f64b3a0c9befceb3416b2dedea6f7d88627dcf1f78297ca9a787(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__657046f51bd0f5cf2e44cab0cb4f189579e95b64312dc8559dc41003b906aabf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251c6f8807611270e6bd0f2526f782170010ef22d2bbaab7694edd976894ed5f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86f1daa02a5fb710d927c7e5cada8cd645352cae3b15b039db82441111a5d34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce1849b3ba7fd8947caabe41f46ac58f897aece3efc9b89b4399a6920a037764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4deb3c44abf048ceb642f73ee4ea2fa8510b383e5daa8442db90f64dd582dd0d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRandomSeek],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c65914b2ecce91d9f0af5ced0bb32f4032ca04fa7a7d6a7a1c479ab1edc880ec(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f2fa7960b41e7bb8677616892bc728f7ec15746113f695fe2e475bdd26912c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c0ff835ec82314e03b2a4df490af3d4205c05ef5dea018218ab5009b7fe208(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ed1f368242551633209d93e84fe76d72bf1c0281631c58077b6bd3505a37db(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a034ddd80a740f123a2881af0c9ac47aad61f5ed66a38da06850217f18b208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab60d7969ffc8b9584f2aaf17961f72738b374aff56ea54551719831fd6835db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b726fbe3ba80b08e6f606664b42f13768b04a8c76163170183150df91ad1f05d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRapid],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5002c0947b53b131f2ad0bd12a17156bc3ee1fe429eb813de77d14016f7256fa(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f82dc9a45e26399b3f2fc81a8154172a75555ffa2981711961270c44e7db8d43(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9254d89ab84d14391183d31a7bc2c78b0a8aae3caaacb237f1d2c9297b2b173b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4882c52f19e3fdd4aee9bd3db37e280c823395afa5b20bbe150287b1beae2a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96655f3cab4bbf61397bb6975b28f9c06dd14ee62a97ff469cc857939c44cd5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292633c9cbbc21de8046938f2f2d5dd40c58db52abe57d884ced52bba0178b35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82cf2c77b77bb2285e1386ae942c63d9a67e29dd71cf0f0be4d2bd61f44f0499(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReadTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5629ba6efda115d099c2e8d032254cf98c6419af5e1a853c4848326ecdc75e46(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51eba33871094627ba7d9edd3e6a317cfd1a50f4230564b10166dc91b9fc7a1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__466e3eaf93563ef3ce2738e467fde3a7e389c147f9243fcdf9f073895f570cb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcbe74589e9bb6d7e774733cc3657ff332e1d775615b698c364d1a012440e04f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc491ebf3402505b954e0602f2d61ed613db878071076c27b22c1dc75e250377(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb9cef91b6edf7c7c4d5f350b22214b88e10fe49c2f7db685f2a5348c41caf2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9510588a8f9fe8c388c7f948a6827e80ce447f8e063aeb2834fa17e170a5c37d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3315cd661b33c4b51a46a7ef08010d30b859d0ec062dd12530e309331fa29b1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfbb2e3f012449672c9f67a509043d8dd50015f1dadee3cb17fc85ff0514b6ca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealTimeReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe6d30a936a552c9d4877894e7d068eb94e787ffd481edd0e6f9526d0ca22b0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993dd3f8ee138ebdc16fd80c990d2819c099b5f92f1272959149d09a39df28c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3293aa065877f01b4096fd8459f4ccc516edd8b85acd5e8b411ed5471d9b274(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f3499cf72863e20bdc717dacd1eb7a804a10662a7997981fbdb62d22ed54ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52427fb2c9d8c2c8ecd99c3885180df436c543fe18db0202717cddc9665babf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf21e3c22e3ea4928d2d7f4c58312c83a1ac937e2b08b98588fb36dd979ab51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea3596610f984f1b312237d631a4141a5d7d5dab6380c954080e72a7e2e181f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRealUserMonitoring],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544ffd584082e78e13402152705258190b975942692801fe28370269d9591f6f(
    *,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_hostname_other: typing.Optional[builtins.str] = None,
    destination_hostname_sibling: typing.Optional[builtins.str] = None,
    destination_hostname_subdomain: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    destination_path_other: typing.Optional[builtins.str] = None,
    destination_path_prefix: typing.Optional[builtins.str] = None,
    destination_path_suffix: typing.Optional[builtins.str] = None,
    destination_path_suffix_status: typing.Optional[builtins.str] = None,
    destination_protocol: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mobile_default_choice: typing.Optional[builtins.str] = None,
    query_string: typing.Optional[builtins.str] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a57e5483c867668b845127c3b7b2d5509e8412c1bc2b468a8b421dfe12a64fe7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__494dc97d706fe055b2ff58a849e290edde8ff1e51993d5e4bed5379a9af073ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8831955a458370430aef91402dc9e8cab451c4079dca44ed4d6f8efa8f5ff572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6bb7de1bde40634307c723c91c03af007a21def16f8a76282dec46cba25e2d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069875f75101ad60b4dafd2d9f2e60882b94e11c28bd914b607213274789ee4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4522689c854f839ea6ff954ac106a9bbc358ddce42fbce81688f822b67a66c1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83da2d647f0c0ae62cb7f951888fa76fcb8023aec8d4c9b748d575d2b23c67e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c021726def3f33f328e566e65d7ef3b0c54db0fa88b3fbdb88971b499db04f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2b167aeb5b8f39809d2182c569b68b392fa7ff2c302d1d5e75371395f1f04ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f12c3274927cbd7019512d77717864f9a3f5d979f20c7e26bf40f7e51ca3b77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f60f9e4dd6480e9a136082701e2651e438639c3e3c15f1ab3854505adf13c10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__690f535854929e8eb2c7e9387cfb30e175de2e663864e9b68abd829871ce98c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc7938f1c71c2c943604f98f762097a83c5c72b173b4ce0012d9b2eb9b60c56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d4f785ab7624a5b3515fca75199761e786cbd634911ad3a65ca6d03c2bd22e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4391906ed4326561b80f6177946cb847aa67ea54447b6a6a7b0994bf189697ae(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c13ab55eb62398ae0422da292f974260dde367880ac4b2e6eb32137e20f2dd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86d39913acdc0fc12c6dc573ed743304b165bfe89eee361b862ce2e9abd2bc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d263348f66e99eb442644177b493e34da885ffb6ff2a12292b8d849323a1315(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fdb094dcf3f595e13fe04fdb82909985352464eac54afa61a23d3d8daea3239(
    *,
    destination: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__665f64eba5a1c0d8357f5f30dc872c221f5f1897695a88be3801c1c6af58eeb3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95af89233ac1153d9a24a2b88801ef718fdf06b0414089fe571b3bdf929beae6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c81e5ccf752fea9e8391d675a1fe647f7dda7c47c74bf6421fc0e292808b684(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45c02585f210131b8d068d7a34e4586ccecd2907eee2e600efe6da4483fa23dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bdc273051dad445bf596a41042797138345323a666393905382159790667e06(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694c5d397fb63203129ae47dc14c2d3a52ec325bf51f3624c49b6c02abde9de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cdb3f2ab2e3b04e71c813660ccf08f7de7f3c403b0efa08c1569b09bc77cafe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723c9a73bcdd86fc70e47c2a5a2e85ce7a17b1cca8b697c01fd202d0bd39d166(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRedirectplus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25d1517418606cf40e985932bc2b3a9535aa588532c0f4d53362232ad40ca8d(
    *,
    allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234e9ba1c1e030f759521d8fb1ccfd2d74a027e518a6b7742a67c24e2d37fb4e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f739713f69b41399407d25cf582e14d4d83db9cd012a783a50917e3fcd1a0cbe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23893311a5d14f21ded2369f2d1317a86fe84731bad5bb8a242bb543ae3a1d30(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e63de4f63b3c1707991608450340247a92ed76423693fb9b6d5d14be4290c3d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a182a70b22e9d6b1535da1a5853c98ad1f5ba85afdb796bc7920c8d9c4fc3b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7ff1d5c4e499a54636d3d523d6596902b67f05dc418fa507fadc9e5f9e1962(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19d8800119d45b2d394b350c7a95f182c87958d41436422cbffb439028ebee36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ecaeb5eac79ca94a791defbfd0048c20a23d4ddb35c23a1627864778a25bb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d392e9b564b85dd4b25207fccb3a2b000da9695e27d8b216d84d657f02ecdb44(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRefererChecking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__331f746c8eb0c3c719f3f7e71ec66046a0864563ed878add567af2e2dc02f9d2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b5b2f054eb040678c26cb9eef7073efcf3e1118919a1db6dbcea0fe01074cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c7f8674b1ba33c827b6106b584cbf68d1815b046a111ae774abc581446a6b81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd1f6a0d305a207050df8e8cd8bad73ab8fab04458b1190e4d0f2cf20e673e2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c810a293439021859f6f21bd094738c961968865dbee861852ebb2ffa42bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f6e372f5bf94751a4b7ee3699221de2019d8495bd62f6ef32b50aef2136da38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf9da9655890a35355a48db9c48072a99223e76108e72b0a282b541c85e40f94(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveQueryParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8269e063303530262356c0713c9c909527cec66c10e905dee1fc0a4f7deda7ab(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__737a7494e3b2312012f38514773bffee40008801e2fe97d7019e1aace7f1639f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a2a60d0452b7f1c53520e2730773553035b874dc70bc1ca3df157b3dd4abe2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb20da395fb854de62a208c4d57ba80dbcc641d5e959e94458a2a18f7b1cb833(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e7e8270995049d366851a1f33b1ae063e2d093d3366f43142eca283f58e5ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__373ca0f3d2276728c09e61e35fc9d28c9c50bacbc632328cda376c0311635a79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a2bfb6de9cd2d744454948bd081931f1a557a60b9950f5e3d0e69da908f216(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRemoveVary],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b66ce6d619e916682d8b88f3f6f1f5e5109a783c38521feb9f6931bc4583bb(
    *,
    cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_cookies: typing.Optional[builtins.str] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa79b3feed4253c9dc48138fb96d63de6e4e563ce584d240dbe1f30ba76d930f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73270d30fc29f690791bd8a9fae5819dc3a94b6bf8d211329429843a6b32f53(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7ebc4026a14ab76feb909acab8575561015eba959756a925f7d5509f523f707(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bedf2c96f18c7f31012957ee548f36922e1c3888937e4a446e3fbd2a81be1e31(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__724dd634e8dde43fb31aa762cf96715c1e0e6f808b8bf5c6b97e66b09a5acfae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5312bb3098f3e468d9e59d8c237a114b7bea90d6091b8b42bbd2f158b10eff64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa7d7dc9e94ee63779f65d835c6485e7714860945bde1ef65eabe24a0f8732a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98bb6ece7027509de09c38f818e41b9a8e3b8584d3ab1feb13fb053be43015d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa36c41f1a0f3bc4e3b34dc159eb150d66e5d3a6ba77e825d0a706916724d0ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6dccb971ee8f0037f16fb695bc40f40bcce99ce6246905bc73b7060ba95854(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71b2c17ca2d9721d4d1730d9cf6eb76bdc7aac9941c7614d112690f5585621b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24190eb92d7da5c494ea9d4a5964e42551f894b317a12e9a920bb2acd681182(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bee8cda3df10a6819ba8922962793158fc916411a800a211270ebe04345a298(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a3e21251ed6dcda58ffb2cd7bf5a27e723b2492388680d2b2c94db5fa9a7068(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2b60b5f5015e3670915723f6b38973f58c1330c5c296b9d5cbb54591e8d47cf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac0bc1f4e51ee7f908a9fede27f2644719a92e63f63788532865496cca51a388(
    *,
    accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
    accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed762296b3284b7c360752baa86e0b2cf5a0a4accef098a2b8d3bd4d1de75496(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b656d0dcee36d0b75b27bbf34a339b99c4e4d02a90e6ed6de8231f0af972f060(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd37f11ba9fee990841271db20c7a68ce758eca5ea44abed62e4f8a010c52112(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5ff66ced899f105a34e89b8b9c3840667b814953fc78b55d8e9db87f6c2f55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f3a3e2a880966e02184c3e88d4ffcb383bd79feb23d8e3fa96defb713b0a6e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10bf16ec3a8a2822be81a34c30013d4c642512db200d3c60e464e6817826762b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53135b362cff5531955024d2131d18fd64f57571184ade18d0526fe57594acc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43909fdada20800209009f0c408c63dfec6c2f686b9985250d5d417b0fab06cf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestClientHints],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50739defaacbfd3cddcacb2f3249c892640d3ee4c179349d29b3192f35001de(
    *,
    branded403_file: typing.Optional[builtins.str] = None,
    branded403_status_code: typing.Optional[jsii.Number] = None,
    branded403_url: typing.Optional[builtins.str] = None,
    branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b16b16d2c762552eddbc2de0a60a7c9c0f4e0a419a260f538f1a09fa5753b44(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abf7429609bcfb0a8a67ce5c85a88eac7dfda7adf051ba0b0cd4ccd061dcab5b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212a90d25887963c3cd83959df43dbbf3ef39121ed3f03d7b2906b289a3e82ff(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63092909d4a493222d889099e70cf9b7752c1b2224f49c30dba3f29fe65f89db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88fe3e5855d377a5bda6cd40a74ab0c1367073767565f0886d520a6e46678225(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5229babc32f53903f00e7f95f490498db0be0c9d70684f67252ed77aeb69f39(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2215e481d96f5ba63830dd029969b9c0f3665b26b31fd463918672dad97ef49a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f1290dc5a407123af5ed6949b3db4fa4362496ddb3bb9ddeca67f8748fc6d6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f755a1f988784e80f105c720d6e0e5ff996b2c2abde1babd1851bc9a5749965(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d223b294ba38f58ca8cef5330254e68c2cf710f4a60f28c23deecd6ad73dd20b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0e488784e9ce3a54818e8cb6c816445427aa725ab8df34f0601e68c1a7de46(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControlNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41c775581132e7022982cdc95f226902392b9fd4a7af82c8bc562cb4cd7158c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5f1742fac0dc6d57d0be9e996064846a7eb68c50a1e2ceea36d9f5b0df563c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885d4f47c05a4ca7af6dd02646dac78a9aef5a41bed2be464417019ea883fd36(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5e770d9f831cffec4ea80de2d4fbeb9ecf4d2a418e9009c41718f6f1c1dbab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83e4d456df9d85f1db54d4cf9eff7b3735ead572f6d1f728aef4889c3f59d5d9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49bdc759b13f4cfb8314f856bef77bf81b0d5f7c98043a13eec27bd103057e9c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961164042c022e68c139cfd662315d5d8dc3274ba2207b0cd4b16e13e81384d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1e2e8052d0d62893cbb68272d2f3963343c7409ec41b4206671a86545bbb9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46024f5d18ceaa3904e18e3f51589a64d58becdaf03221c906f288519e7ebbf9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32ca06209979895519c4de7c818cb4d964f28147224b12cb371f74342a179009(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8103f1abf6c61974fc00ae56095d3bea782618bf97ad03e64473c90e236d73a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56299e4ab93115217a58dae6dbc0c9dc7b715fa11a042cf3f86850dea690ea88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512aa9bd1663b6c1d26b7e887c4fb2f0b119fe94b896216962e7ceb197e5c281(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestControl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152a38152e57e1f422d6f3f4094f28a100a88be25ebaa2cd1cbc40c4de75fab1(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d977918f93a3e7ef531535b2c4c346be7c7ed161832f87df5c6b2bef5dbcc30b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76ccc1b77468be5545011f8a3ff8e78e3bc1d40f5092e203fbde3869f594588(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b46f79b344c1186cf17e8206328b50cf198341113303533b93b7ef49c97f68a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01087172333cd9a6d8d1d8e0d81e21e29401393418c4e41833f4dd969f75c3d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145226f0c74eb1173769e018c0839c781039b4b4fde441ce4680dc80b2cdeafb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b1531f1340b632441072d55019373343ca7ded454eebca6382d910d0e3aaf7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRequestTypeMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258ed320724cddc8d882123841c8f4db9d313729b0ae3cb0fe5abc0baa95f4fd(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c7217f5776b5b415d70d9b89d7acdb1aedb29e87d4ba59d45be0c72ec92e06(
    *,
    enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43fd76662019d175bc04dbeb14f013c82dee32f45e1eaf0860b9459be2be0b24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd6233f899f0d5cb718acddc913bec42e35b4bc8113dd5832db93199266b7e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d0b83f85dc0fc0b3285aaf33c1e9168997c7b2811de92e4501721f92e4cf450(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e30639dc2677936560f178d12168e71117ba0fade6104164e0df43635c9b191(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32bb4448bbf4fa96899096d01e242ad7384b85c68bfd0fd6e3f287a17da35689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d880c9dc8f4a45d99ce597b5e8e277e24f866767e06c112cf0148b17eefcb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33422d5567a6f3af933eb90d28d2bfe18cb7c9a6601903351f8c27cc79f4c815(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizerExtendedCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df695c6cf589406f6b2b263f883aa81391c785d9feef8856b042908e8e5fd374(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8646b36af93c8dd1d5fa56b2d6356775a09b3461425f9486b7a44bff0ed759eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ad2620ae7b22ad57f72fa36a523ce36006600a9dbc7c098b88530d8a62954c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d00b97bde55f4032419f1a12f6d35fb533dbf074212730a21da74b7f02f6502(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6a0f4e4fb863a24f1de2efea5306cc2ca3b95db67eefc08f33c0eb5fcfbe41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__476506310c8f91b06bbaed0d99d22d6ab75cbb74eab2c1fe8c4dfb9a90c14f22(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResourceOptimizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52fdc93a30ded2667ea34e118e942efb335fc7a1cc79fc8ce55968f128996d3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbfb668d986dabcaf9d6ca97eb5381ff277c119cf51dee694eda34b0219a157(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8f5178e9fcf64c10eb5731f0e950939f696724f541f7fa5fb61936392b4fc3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03ef821a975790c1d893243c3616ea6c454c35169f6be75a9de0df62c3efed0c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983967ed5e62ae3612df659f6c1c151a957aac72d159464d114c7386b8183474(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e6c6f81cf10f84a5d671fcfcaa605073de3c1bde5711c74fbe3bf701b2364be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba95be9b83068424632dbea2d45b532a67457bfd5c646c1acaebd4d14da4b27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e33837af4cd12b315d73221a23edf7b261736adb45b1800a89465c68cb2cdf6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__897b8834ae324174992969f138f32d8bafe4a6de081532e953dd9887bef07d0a(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domain: typing.Optional[builtins.str] = None,
    duration: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_date: typing.Optional[builtins.str] = None,
    expires: typing.Optional[builtins.str] = None,
    format: typing.Optional[builtins.str] = None,
    http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    same_site: typing.Optional[builtins.str] = None,
    secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a8a8f4092e03504c9e3f6d07657b3a5fa6c24a43a20cc15b9f48c45e7733931(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826f02bf3e3490e710fdc327c4d2fda710fea774caaa78b2af0e1c82e42ea53b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5250b0ff750363784a3fa9931800e9301414a5fcb84182f61dd2d54860d9d83f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af24f57243062247c87c5510d63865fd8f35b9f22a0aa4e40d8a003433d5e2cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bea9d30b16f51044355436c4f0c4df8604f3511dea5546a78ba44c65a458ae1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b4bef7ddd1c01af9b9ae64aee6e8326f1ed1360e6bc878c99d8866bebe46e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcb52da1b3eef2259fd2a35e049485c62a19e3d201b327ee53dee1ac1da812ac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__839ba82f706a3b878b918007720bcfae1617f6fa6ddccf44ccd528cd37ba40f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84eff6dbd3b327685d3b10989bb73ced9a19904d1fb743428c8ff09ff9c59e0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34cc4ec3cb9a4d4905a89aa77b2e7f7623fb98de999dcfe8ae20b303bd9dcb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5daa14abf6c6220494fba54209699b6326b460fc68bfa0e8e105841c6826b51e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95720596eeff8acf79909febcf3e9a7abd5b2c837d2ae5e764d276d47cd3a45(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ca10448565a0c3b090c477a2e12170aeea32cf629a9643b588cdb0f04fe82c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60b23bae2b587c1ff814f8314450bc24b4bdaab20178122d8de611eda845f07b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6a809437115af6620da28828d65ffe3fc0bc091615d1b02757f6ffa5f5a758a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__388e7b17576af0c21035dbcf32fa4f46020bcfab07df376fe9f211a0f7726e7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6f9afd924029bad669219b1d43a4028bc362198a803f1752ed92e7b17ac1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd107af1b3514e5a1a2f1de0f6c9937c2cf870fce181db233b7e4ef029ca2ffb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73e0e0ca6c7cdc8dd4278d08c8fa64fa7c8bd202c47feeb7891466882decacc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd15f4ecef5e05e5b7812b86557fa867c0d9f62c68ec5a26defc6908b69f03e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorResponseCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f448ccdbc963e348d4fdc98b9a07abfae3d94f704ef54732bc75984d00b0a34a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811c2965d733dd19c2c0cd03baaefbc933248ecbf933d630e8c63c8d149588e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6582ea7526aa04d397da44e0e5bc37adab99bd42d85e25cf22adadaafd159acb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ecc1869b7b7254c649ccf2eb363a9abd8c9108d47faec98572a62bbad4d83d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01190bb9f1d14f301bcd3ed19387cd73fd5bdbc10bc3677fb53f75a8a7eea73c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96dbe23525b3e993ea49f99aacc64b72eb2b95f18827e06b09376a5497234b07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a0e7d9cbbace1a3ce8718f527ab4064b73a0da80465fe532af9d00bb98d68f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRestrictObjectCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3ed0922f3b743485d5ddd2b5ca529f3f888efaff8bf0973679f1c550da5069(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d04206206d807bcf5d6b28e2278483ed737fc2828e1c7ebbb24af3d56e0dc2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0712002118f822c07f1da742c0916d6e77262b8eb4e02d35a54974be8b9200bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f380f18d7f70ab42329d00e869b9564d0a5d37cc0b4e7ee2f1fff0755f3b6ee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b0efb6e21362da1df5ec67097190061490e7df637bb8bb9454c2139d51ed88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837bc5001d62b203951e225bbc61b0ff56be1698acf5a1b9292945d67c7512e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7ef3cbe6c8657aecbf17ef0fe11c1841087dc92f803e871f090ca3019083b8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorReturnCacheStatus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a18c9d608a5f33ba9e017e7d4332c7fff4c3572d2be0b4000817080dd1604b77(
    *,
    behavior: typing.Optional[builtins.str] = None,
    keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match: typing.Optional[builtins.str] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_regex: typing.Optional[builtins.str] = None,
    target_path: typing.Optional[builtins.str] = None,
    target_path_prepend: typing.Optional[builtins.str] = None,
    target_regex: typing.Optional[builtins.str] = None,
    target_url: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9fc08b6296575736f182714a5ad503a492c2d16aed46253897f806d86f4f676(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd3ab3278f136d1c11db408236d7a02a821d5be8cd2a45bf7342be135176770(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eadfcd7482117e1ffa48737805e546f9e10a21ab96e577bb0f41f1b441ddbbbe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a460ac08cae33a0afd9c5d87dc8d413e3f0c0c1f748a6a79c073aed2b24b0f9d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__637c99acdee69552a799776fd1441e26d84073fbac371e2a9b05b30f4449f15a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9892d4d477dbb161dd4fc348aca6e55e808372d8a0fd0adfccb30bab03751b33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9914f640894ae71d957d5aa5d5e8787c83e58ca31efce23790ebf6036fa7d5a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64ccf78322095cad8ccec2d8bcabc00e853999f867216af875f756729b9b47dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6cecd842770f8dcbae0117ea60a6792cd81967d31977d647cfc30f3624c5d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10b117517c7d0dc5d8c63b84d44c458b5e595bb30aace2ffc40cb94216eeac1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ff0b829845f97f344e1ff555626d9789844b73a56dee492b5b053be2dc4ea16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c5837f23c599595b060fd294caedf8804d1c2d4f93a99a444f759836c77a4d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91b474c5e986dcf729a9d43c7ec64eefa3013f22995478d60541532dc98dd6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77c6515f69df0f06fe4269539119efbb286161bc60fce86aa109d4c88ec0870a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRewriteUrl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fbfd2547a74e44648b3f0edc22803cc171729d19244f259b585ccd0c31ef00(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rum_group_name: typing.Optional[builtins.str] = None,
    rum_sample_rate: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__282c7b0a3c7e198b22682b2d1a9b4b2854ddb7f64cf8246d60138ddc1a4c3695(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__964bf0bd7a2452448117c19e4d1dcadf04579308aa00763fe58977256efc14ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d378528b323fc15b42ef3e5fa571aa1d018c930461985943cd319e10e6ea5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b849502cd2f15abe287579f317321517ac2ce5e627e7ced314e8f422e10a7d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aabfb72cb24439065346fb2424d1ae414f71d601211f61586290e05545663cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35dbdc19c47a4e799535ba5f1ac162c98cf67441aac3a9f1738466fde3763220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__001722a336a0d8f0197a2daf45f5c5271b58906faa2127ae8430962ee1369a53(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorRumCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__809eec6d81eb92a31da1f5cbf3222e843050f92e2e40f00d258598d0195959f6(
    *,
    application_action: typing.Optional[builtins.str] = None,
    application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    application_cname_level: typing.Optional[jsii.Number] = None,
    application_cookie: typing.Optional[builtins.str] = None,
    application_query_string: typing.Optional[builtins.str] = None,
    application_regex: typing.Optional[builtins.str] = None,
    application_replace: typing.Optional[builtins.str] = None,
    application_title: typing.Optional[builtins.str] = None,
    customer_action: typing.Optional[builtins.str] = None,
    customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    customer_cname_level: typing.Optional[jsii.Number] = None,
    customer_cookie: typing.Optional[builtins.str] = None,
    customer_query_string: typing.Optional[builtins.str] = None,
    customer_regex: typing.Optional[builtins.str] = None,
    customer_replace: typing.Optional[builtins.str] = None,
    customer_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    users_action: typing.Optional[builtins.str] = None,
    users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    users_cname_level: typing.Optional[jsii.Number] = None,
    users_cookie: typing.Optional[builtins.str] = None,
    users_query_string: typing.Optional[builtins.str] = None,
    users_regex: typing.Optional[builtins.str] = None,
    users_replace: typing.Optional[builtins.str] = None,
    users_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e936508106e50e0a97385a31129d5ab0befa7b70109b0aecdea3e1a0f12af50e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18754565146bfdfdb1163583d58edab85dbae8ed53b22c915fc058f61c6e8e1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36f38b79f978b6cb788f159ea8b45b718c5fc8b81ace2b6e37909a17ea30a72d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__053338ffb86b7ade7e35717057eae2503306b567bbe4a5bfa80264a76777ff0a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd58c933bdb4d08964ed6b4d8e834018ed3a413a600eee4d2726a8e11ae39a18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1376687183af5979865bfc0ce07c5b40ceedf4e2ac07bb0460387b230a8caff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffe1686ac1f82a3f12cf53c8d1e6456e0bc7f9255883cd3e8c517ce1671d47e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27c2697b70cc5df512a94e61574a8a6ec483d22bc55f9702d1f2cc9fb8b0cf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2531473cd049ed3032cfddb5494467c7bc9f40a8197908d9739a2b9b0ee4a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5afdb231b991d3c585d2a490ad74d4af4e11cf9fd9797ed882ff167cfb4b630(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c30bf5e0f465846efc398be0dc26d59b94dfdbc0e6ead35cca674dbd6a2f7f66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4cec5c4348f06e9927db27ae461b6cdee5f41916539758a0d18b9e8c480a27d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0736e157ba7f154195bd087e1a0d7b302efb6a74fc341e986288281a0764d472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ff450d81a0a00b84ade13d70cba7f08a132e6ddc35f2177ea80614c56212c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44eb31947124ef7f7fcd47bd8200848f3d764519a89f1bb44fe2f16bc5fc55c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da106f785b328efd588dda25cfaf008cd758377aadfd94d4916eba2b359ecccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0e38bf1bacd0fc77b17b6fdcfc29929bbb4c8757074b9d8c4b0166f4fb9eeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed46390befddb1ee71d378a73ad296e28643481b3efb5dab23e17d6fcdca76a2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12e399ce894df4e86d145cdbe898359823cda35bbe894859bfa8dff7736edf98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8750ccc63c8b692744d68906d3cd58053c02dde359da71ec23a85285818e76f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd51428e2d9968537d2fcf0310398918bfff7b10420fe66c13e5d84191185e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed813a6f6da27322ae25af3fe8076c0edef98c8c0e45cfee7449f58ad28183b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__592c4ff2198bf37e27390497c2d2771878ee55fd617f6762ecf826e9dc049da1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6ed856ef30b820efce8a82740e2d26d6166d40225cc1ba742dee24879f2773f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddee341519cc735fad060371499bbe07bcfb27c75a7863288dd3945a9fb7d59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__274dd9b651f7e1e4e3359d4f94cc67b370830ff55115695a4ad75abed770900b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa761a262f4aa8178631aeb10161144e7e93a144c4fa59bcbbed6f888cfa841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f70ed2ec5d2dfdd204e43572541a4a48a88402c85c2eb8d7df14d0bcec31ee7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c68bd7ebe2675189bf43a1250951242b66c3e7c3bbb2050b21fb8ddfce2b2ae(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSaasDefinitions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c721f96f2bd12929d34fea373aa4c577dd7b49574810e9d5ed61b718605c44f5(
    *,
    allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    connector_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_host_header: typing.Optional[builtins.str] = None,
    origin_type: typing.Optional[builtins.str] = None,
    sf3_c_origin_host: typing.Optional[builtins.str] = None,
    sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e1adeb1823b7d6230319519cf74cac31d2f9530669e2b398d88dba5167144a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edaac8de3efad799ac44b0dd45e1157dcd89622aa55762e98439a5099e3f87d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee66074d0682fb7c49c9b585d8ce480d24a2120a200c6512a72cde3833ec4ba1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ca8ea13f7ddc8bc2b62eec7fdfc98326ebd9952bb0227db8e9d4b86858c4785(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7985289a1e16b965e1e87de110ab5516b9277718d15c78f9db16118889fda77f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e007c9b615b61dfc6aef94c16eb9967d77af9cc00f4a390c8377af31c055bc13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8fdabea5f1e53b7d6ae01e90bf730f132944d9832955ec2b9ba67ff67d04bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb902549535b203eb01e006dbe8f0a2f75b61eb026f4d40f2e9e954586206b38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f8d9568489b4688c36c43ff5a57700682a50aa56d6ee41e417cb3ecc63af95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c21cda4ae2d22d39c298f58bd2687c943be3968ef3636b871956f3e403c770(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80bbd4289d563e98b41c2d8b6ddc5829e141790fc738e72d2dc29b1d77832754(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5b69ac95be43db14b264edbb3aa1b3c3ef8edc7c9ec69d7dfe20475e41253c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba90bfe8d920338e4045e51ee832ad70557e956195bf16f5b2955f921526433(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__309eb1fa66ddc457021149ce42e93a43e451aaaefd680429b0413c6f3ac56f74(
    *,
    host_header_source: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cadcf56da94d5db738f99fa9d6f862329923154fe81ad6797c4ab6959ba55c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08848f46f96cae2ddbef276e491a9de2b5d699a29d3b5cf25903756231b42fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fbd681a7b449ed38594639a76257f8cc12169f0977d65c5aca191f0152c5320(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c17830667d3af21672e2fde3c52b8dabe28436fd34370a242f97548696d1c0d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25967a62ae203b01cf27725a7140ec8715d52635108eb754467449681bbf6041(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daed83d82c547dbb5992822691f88e60f3b5359ae3c0dc1016542c668e542af2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProviderHostHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b568246ad5de2d68f6f1ade6393b1847d35779075df366f03983b9231a8705c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__817bc637b83c65f2d0caf9152632940698af2a460141de50efeba31baf7b95db(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1835e37f150b737884f1c8bcffce8ab5600d01285a9730f0da3b5ff71880dab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b08a57f87b61eb9e0b3d506041c00378c629e064464c4727ac4f137b4cb1e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__085da73ab1c3e119e6f33690293d7b35218735e917a7da2b4d2ff085c89b41fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c43b882247b282ae4db137f00f611fb074e5014a339aab9bcfcae035bd009f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSalesForceCommerceCloudProvider],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf4c222c4c73d44d1266822fb5ab74fe90e55d4c9e2da8c781b9fb007e0d4a7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2a409f44fd0df8bbbd4f59c0644b4a23e3663a1998e02dd2609b3f915e1e8c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b100572317c15b0a250f24d4a147d9d3a6d910dcf55780bfaaf716b499f3a2f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__525608390316a641fc6a3650d07aff9d6be854b3ac86048d0484a5c5f66c1aac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce714977b5014ce8ea39f1949f4dd321fe02cc8cd0d79bf653620a29041f9426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__660d346c2e67b0a436823192ab6819bf3506a2c846195be7ca64f9512cd32b72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c848a724ed583ec11f4de2614af7bab4d4b928a354567a10023020c94161d28(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSavePostDcaProcessing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c35c6687d233cd3bce132f7408073d5d427d49799e6dcfca2fc6ca9f262c56(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_method: typing.Optional[builtins.str] = None,
    repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387fb924522e90059f2b38cdccf73e68fb2f7a3cdc6f11929bc53106ca675695(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0729fd4d2c9a445a5ef1b750f013c21c2be0bf2a6fd9ad0ba26532a9fec8477f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de3a15e8de49757e066999c893845827dd43da173dee83d5e5ce8c8356b663c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1788de1e4c5997add8aee9ab3945ba730b944e9f0dfacef35ce315ca960dcc55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e08a1bebaa8861474633f90598e61a6331c3a4a8c86a5b9e9f8bf57f3ad8568(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a18315153bb48e67ec4e9d6300b479a9a50ce911039d5ac3dcad71da5a9eb18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf4de377641d99f3e071b29108ecbe8041af00c2df3a3fafd7c373b30631b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5035cd7dce489ea0d90944af8a1666f6ebf0f763b84b9ca624d3385ad15b1bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa7bbb9a841a627d0812c73cfebd5559e5bf0ee17d2784b505bcdf8decb61e3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScheduleInvalidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d9027db28ecc3298db5de078f09fc08d00bde9a1df961cef38293f317607f27(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serviceworker: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timestamp: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f663765827ce76a611e9269dcf62153d59c6f690d43836b9fd063b056a0ac49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1460d1456394707d191598b798f31dd80adeeb551ab005ced6a4fdd3e31b21e3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e94b1219eef70638d88b98775fcb44f2541ce1c85e5210aac845fc1ea691fbf1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f48f630830178f4d8d00412b5eac577989029a75e59211a7725f010a0be2c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f4037c0c41e1c57e7b61bc4c7b540663bda38ad777930efd8b5c03eddcef86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c8f620e2b84b5212224c68a26b7fd71f0dd2429300e6987f39b417f96883a5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61cde84e7dd8b41d9d040f9a5a35b01b39ca9b75f79430a55ecbf1dd6ca3f39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae0e73bedfb54d3338b341efcd0a256b9134390e417d6e8bc412efa382eebbe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorScriptManagement],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__634e955d4c81a4c74040008b2027a791104767a5700ad940066eee8989782a7a(
    *,
    acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    field_carry_over: typing.Optional[builtins.str] = None,
    header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_encryption_title: typing.Optional[builtins.str] = None,
    revoked_list_id: typing.Optional[jsii.Number] = None,
    salt: typing.Optional[builtins.str] = None,
    session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authentication_title: typing.Optional[builtins.str] = None,
    token_auth_hls_title: typing.Optional[builtins.str] = None,
    token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    token_revocation_title: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfbdfe97a168de7f215bba44c9f704fdc666224127752a4c224c354085d10470(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45ed18fb7109e3ac843bdcae401236e8ae6d7784f24e9e108aab73262b1db30d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1beee27568659ff9225f5683d70c008651402918c789f5066b01deed88c1b16f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48de9a9d9421db443064693db360edfcd00a0d30ebc51343ee6f1b3dd9d34bdd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19beae5f59ee39eb1ff94e9b93d645b4fb75424557c1647b48b9308ec6542254(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff6c6f30a133ffc154a643b46fe27527ced39e7d24018ab771ab3f7e81f99878(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1f38e4cb087520e706553125230ea12654b2d5f62e0a9f793613fd030f16287(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce40d7819034af8f905813da05b4b58cf6c7040fabd0f9b1cb891da09c910d4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35107e3e37e6bb472686035f36f93de9b07dd670baf99eb2e7cb0a0afa6dca06(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__430a6c7fd6cd0ac35e114a291eded880beb70de0571c8435239340d78ed04020(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__906ee100a76d9fd3088ee173247c67a7f2328a8473bc678270cba87bab5116c0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fad395c98bfd4c396606b8e976c41c0d279edacc85ab67f730817948f190eca5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044cd188eb7cda6fc2b17fb61d84846e1aeacb3dc18180bf39abb22018852b18(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64a6a03dfd4264d301c6d8484337288dc9c59adbf33cdba728064f8430d3795c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6deb1bfe1a317aa8c1b29f5aefe9f69e2a0604f69417a45e047c255779ed89cc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e280392250008da255c4c412ada1e4370da02c26027bcb1d288d6132725967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efd061d9351396961d9fcd3f267e4d1584798bf37cb22e80a5fa785295cca77a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5759c029885e642afba3f16f1ac19a6f405ad89e874f4c008118b5321592d347(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa9622c3ed5e53270eaf3ba48c7f8353617246f2d794a5fce6d6dd8d0e00e6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7137edf0e74289f8da52856309592a242f68f2ee456f52e7c0c1a109142512db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a807cca0a42b385a0a9dd5383ebc31374075e66167283d3ab6a473e071791d54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fb60d4e749a96c3bf8917251d54923954fc8edfc861dc38fbf116dbaacc0ef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fefa12095eb4e6a21225f7dc52820ffdb9fd765c9ed55261088b0321c0d2a674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3eaf2efe172fe168311c0c9d3b4e22e3e0e700349a58c8f249797bfbf1343d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0151a6fa07e9191dcea59b8883a4cc83cfeca8f38c556187887e1525bb755e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa0880dede9bb4032003c079eeffb50c4dbeffe4e9719afa7535988a725116a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedContentProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c30d51c78c478f64b7cdb8ce78da4788db142bbe9e2d96aedf44aefe717090(
    *,
    behavior: typing.Optional[builtins.str] = None,
    dvr_type: typing.Optional[builtins.str] = None,
    dvr_window: typing.Optional[builtins.str] = None,
    enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    end_time: typing.Optional[builtins.str] = None,
    live_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    start_time: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15590360108d585c3d91e6fbaa5c5c1ce252d0728fe5ff529a3fc40d6542939a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eab7ad5343a7c47c57e3635d32c067009478dd8bbb304e09ece9607b76bf119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6089e732e2ffab8f042b5990ab8125f7992e25a9ab28d9c39c1112af85f5a833(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a44f6bb252f5619b3b96c7e2e0a63dc4a4786d25e3a049e2e0f0f16b552d36e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d81bc1a74fe856551843501a0417c86f955b28d09b3e48e34b216b80c9e497f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ee51f223c3f9d9722b16bbf8b49f875e27031fd212ff587d87ee2ece7766c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1cfb190fbc3e90cc1a934e0db25f67660026f75fe777aaab3e9f1ba4f2f083c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37dbfe414997eb10959c608746ab1ca3bac4246c1cad21731d4d0ebbdd3c0f62(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f47a7e8e7ae0201e738b574d5495616c97ae23f9d01f338cad8dbc8c219f8de(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a7e5fa217dbf63db6bbc94fb06c7acd0cdf8d0798d2afdc4158b0a5f12765fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df38a33ecf91ceba8dba1fda0c320851aee84c02ec4940e11d910d2cce2beae7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4a3b87f7ab0ea33fd1f79f52bed808a2daa2760ca51e48f8f247ef4f81a71c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19d2b818f0fc4fc08fb05f281222449da5265dcf9e472a61b4dc0df8b241b0f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901d4d46c4e368e726ebffc130ffebd0af0506ccd536a3808e16ac95d2a688f2(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48b679e8023808c91a1bfbcc9fb2d4497097bbab1fb9a0dbb99b0ec9f888927(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad83700aa42febdce311465eec76ad644e62038b8d09f44db70975780e9e34c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f59edcf52213fff610df2828aa4b1d1ecf89642a9f097f389cd801f226d3eb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1444ef0bc506c6c9d8626c3089710258febe82a09bea1920a3e3baf22ff6ff32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f74516f388117e6473eedd3ca6aef60344bba147f288cbc0512a496b450d40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9da82bef43cc43adbfa3f6898ba9f87ddf1055e263240bdbf25d0a29d6fc6bb6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSegmentedMediaStreamingPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f61746d998cd3e097704ad0a8a70dbeec083e336b53e3142ee9c90765bb5b8a6(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    certificate_field_name: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    device_profile: typing.Optional[builtins.str] = None,
    encryption_key: typing.Optional[builtins.str] = None,
    encryption_mode: typing.Optional[builtins.str] = None,
    end_index: typing.Optional[jsii.Number] = None,
    except_chars: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    force_chars: typing.Optional[builtins.str] = None,
    format_string: typing.Optional[builtins.str] = None,
    generator: typing.Optional[builtins.str] = None,
    global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    hmac_algorithm: typing.Optional[builtins.str] = None,
    hmac_key: typing.Optional[builtins.str] = None,
    initialization_vector: typing.Optional[builtins.str] = None,
    ipv4_prefix: typing.Optional[jsii.Number] = None,
    ipv6_prefix: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max: typing.Optional[jsii.Number] = None,
    max_random_number: typing.Optional[jsii.Number] = None,
    min: typing.Optional[jsii.Number] = None,
    min_random_number: typing.Optional[jsii.Number] = None,
    nonce: typing.Optional[builtins.str] = None,
    number_of_bytes: typing.Optional[jsii.Number] = None,
    operand_one: typing.Optional[builtins.str] = None,
    param_name: typing.Optional[builtins.str] = None,
    path_component_offset: typing.Optional[builtins.str] = None,
    prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    replacement: typing.Optional[builtins.str] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    separator: typing.Optional[builtins.str] = None,
    set_cookie_name: typing.Optional[builtins.str] = None,
    start_index: typing.Optional[jsii.Number] = None,
    sub_string: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transform: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value_source: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__204bb95b83dd843766d86f669821be0c16aa7d3758efd4cdd710392f03f9b5f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d56f612c376d6079ed9c7b8a0f8fec35bdc34d41aa05aafd2e3135099fbb545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40140fbac7c0d9a21a01970de5f85d712ecb6b95395c86147a440339b209b9cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88559e1a444fd187132b2d30c2697367536ed9068a174fbed6d3a033eea8fbc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927fc37512098de3f1de936becbfbc34c96b68e6b98c7831a07527ffe9210368(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960b2529c015768c8a2210d944be547fc2e78c0fd11bbbee5d800a02ac3741df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__859213ba9c7571aa07b0866b9a2e24dff652773d987bcb411e69a80231ad476a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8077093f2ebd09cf88a9edae3e152df6cd2fd0274418a7faa2a73595d60e240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb923dd07c058831a5ffbd7fb924488d960ed1c37dfb6d1d9be314d23bf519e9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4077b904b8b27e329b889d2ccd6c3b97fd49894ea39004d28fc9e835b86600dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fee78290817117d4c6eb0de4b5d5d154e6a1352762fe018847ce433049200a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311505003ea973c4ecb20d1a0c0a13ae6a783ead50b3ebd4fb715da4cd29ffe3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a53bd95e94faa0c9443369504ae766aad944f531550b607f4ab30b5be6d8be87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a7456faa83978793a3a7df38d63fe2d4f9878c259ab108b1fec31b52c09b70d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecf8b4284bc94852603ff0aac168e92fb18e42173bfe208f41dd30c6c584ef4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59194295f8bc1169523d986fe708f2bc466b143a4cb72b45b1702dbec2c6e5b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485f48d7199b9a7391dc2490abc4eb0e8eb09ddd516af95d311743995fef5b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc8c6b79ef2c4409246dd06a06bf5505236df2ac8b5c69e131c63c0f154e60e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b816e71fd0fbf06cb289f1fd26342a494af05ddaf69e3a5857e7d83375a0a320(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b02071821b9e3d2f8f9539ec2e1e014643259d26098e3aeba524b5978b1a6fae(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71e49d636242e03257a6b431f989bdb325134cc07ca63cae7f0d9fdb375c5656(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__921e16c85d7ebd45a56a19c816e388ce6457c2a60a6ee2b607e98b04050952b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e0f60f67efdfab359764670250411486c63dc3f9e5b901433188302419921f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a6cfead14c93be37468ceaf87a85b332b921e4547cfd2ff666e6c904a68ca29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5534e41d101b83641bc99266a82c1bd063f743deb0543f212982e3ea87454d73(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7998fddb646be6689635881c2efe1a46851309c1ce6608121f40cb80e15ef4b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e890c11670a44b881f3f4fa7e5e5b0a3ca87cdf7355099b7fd9882bd239225(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__353b55cb8df7149a7a2147b322be8120843133ab44303e0a28d363d888c0b103(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261ed0c5f0eb5f8c392e3332fcb0fc2acd83946fdb24bceee7cc2f327574b401(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85dadba8803f99b94a72aef651020698303af29155604e624e30db7f313b1f4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dff07736300ac1b330a2a4161065aab0d9f5d14b80f7bd1d885aaf4d112fac4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32e87340bb27f18bfc4fc1967485f9f47f2b43d6c55aa74845d7a5eeffc0fdb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fbbef5bcb8f8950bde45476e9bfc6ca73acf1fd4fde47501c5a774a8847707(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37ccb2c23a84f7e3e5234c7a522fdb1d645bd8efcfded73d7d7c864b0637ee34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bd0ac42dc20537120dea8729aaa1b81085c1e0700a5bdbd509333d2d087e01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__671344acc2a188a1d7e5e4a6622ec2acd65721469ae32adc046caf6df6cc8b49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1604636b1cdb0c0176c7967490961b109b1f65712933ea5374ba3c0bd94dca39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac4d55314d858236ff8d57c97ae7c40b17fcd7a165d3ac00dddfa6363b07dd86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c46f65c1984124e8298a7869366a2104ac0efc1ba2f0570e48554f5bf1fb0142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f88eeb084a05e15482ffc12d8c4871b741bae10b291c632b4dbcb3895a6a45b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__724fdcfc8831babbd254d33c1cb28711e6f324932bd371197f5e64899d9d9701(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e4eb0acf4b9924f4ae4a4da2670718cba772233710b9aa5d3bcd537bf6e389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1533a6561b8507f3f4fa4c77f573fe3e334be6b521dad4b00179797bd1b83b37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac437fa5fbda4ed956910337a02f09b12bb20c08443ffc85b9b2f47e4834a2cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2794ea29dffd7a6a6f91cc4033bb891861ffafe42349559a084a19775f7e4ac2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac2d2e4f214517e2b174f7d2cc0b77c7465f798c8058f53314ad185367421da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f877cfa344494a97cf702eb5a7bd36ae7da5685696284c133e9f7820eadccc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8081a29b7e7ab53700dc168a9171476250d5cf6d9fa47bf18552236f0f9452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3fcbbaf8abcd76f42fde2b80b6c558b8b5a6bbdbd12b41ec0e61c85c1ce7234(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSetVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3258ce02e523c55666756a5b625efd7588c9ff6056ee6060143fc8054ce44b78(
    *,
    error_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a9a63d210b43f5a23f40ba2ccbfecf0248e2539cff2e5ef71f695aa9a03e09(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8546957e0a161f822c12cbcd75c835a9f24e3012a8ad0693c7ef0305a28aea61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fad659df39435c783f7dd6e034e5ea17221c0e784eb75bd7862d6af6adc07f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59305cd51741cc2baad74366ed89fe8acfc360234c12d0ca73bbda9c6baaf866(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cad00458dce07f03b86a284d8c1bddf9dac571d6e89dea1517a2bee9b43180(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7459c517723a54b398af1b98415e8e3571b6e1f4de41745920738bf248d42667(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c50f8b35e6b44bfc4d7d7e570905b9e3b0d3b96dbf146b2235d605138043513e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSimulateErrorCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee542c864db784d099072c9d747cf43289f9299af1a1086fecdb689756cfb7e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nossmap: typing.Optional[builtins.str] = None,
    ssmap: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692deb50af9825141f9893f89ae4e484774782e67901e816b4ca1c51b99868e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249e908f044e77b9a37ebdb9c938a7aca9e95859b2a4b26fff61d1e8340ca47c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89e56f0cc638e4a670d1c2ecb889dcb20fd407257ede571f16a877a0039f8b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe576a43384798807b8b99860fd273af3ed591ff6a701a1f629a9a47d2452cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76e46964865d8dbef59c067b658928eaadce92a8b197d291c086a723625e979f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4670b587c9892a509c90e1b91d9bdcf116a7d0e0f91cf60c7823b782017c29e8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShield],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfd87f28f45ba659603307f5a1ebb16141b281f3b0f6356d2aab8fbf094b425e(
    *,
    china_cdn_map: typing.Optional[builtins.str] = None,
    has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    name: typing.Optional[builtins.str] = None,
    src: typing.Optional[builtins.str] = None,
    srmap: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8739797512738b9c30f1d749dda81425115bf1ccd4a1ea0bd758d91aced629e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__398634040002fd4b8efcadb6706f090aae8afa9d76ee2e281193d0ec949183f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dfb1bb9bdb17c03d339c2047bca202b98ccb0a94ae3232727b12fd09f4afeca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__febb9a3ef5c0a3a5120de0e0f9976bca062a5fb786ca30039a9e4f78c2176002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1459a185712f7b4302da7b88614afc5f3cc9aa43ea41af4713aff4f6ded374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8577a2ec26aa7e09f10e3f8852d735df8669f7f93fb3f2c1625a9372f9d5d2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14b5320e1470053b26c8b7eec1462cb8ee69c0eda28af257e751385fa6128d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7472cf006360ad6027b68272609381dc6fbb8f601461ae448f84267532bdfec9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSiteShieldSsmap],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb870a6c794be1bff1158a90011e3e3e80b5a472563aa28cc3eadb625e4d6a21(
    *,
    allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_sharing_duration: typing.Optional[jsii.Number] = None,
    cache_sharing_start_time: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_duration: typing.Optional[jsii.Number] = None,
    migration_from: typing.Optional[builtins.str] = None,
    migration_start_time: typing.Optional[builtins.str] = None,
    td_location: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6332fbbe5144a49655c2e9eb0443145f4119e5a180b2f55b86ddc2bd1e1574ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa2fa9dfb677ebabb4162805274af886605ed64f54d7b58d48787f6a0404638(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f099539db8c1b2b2fa5985c763d1139449fcfd1b794ffda359c919c48025816(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67448a83f8dcb121640bb84f91d45e008f112cab85afa8930162ce76162f14f7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c109ceb30cedbc0a75b9ac6b33c2dd706a178a7d85fa99f555d9dbf923e9cafb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b96592614c4f9cab9021c90144fc069a11fdd60e1f5f0b7840f871cf2fb4c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b5aafa853faab3142aba5b20f1284a308d5e5e16ac1bc4be626b4b39f77aaf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df21b39f1e2c00191a41d49da630937ec7bd267fed65a6deda0085efe83ef6fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a78c7ff6902c8a691e1f064274fe79224ce0e05b13f4944ab1fea0111bfaca1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a177c16593aa1ae9aa9cfadb94440e6e89d1621444f4740ef7395a25f73d058(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003e4329d2919a8047257629158f966e014fc20d74dccecdabbe24c1a549558b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a5886809367a3903aebf9f59b77518d3953820dc4385986fa3a189700e6aad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12a027bb894fdbe8e4c2b4444b0eee56395226e4e1a0408d7321c350b2ff6aea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46e457a98b4b39798d53116fcf9b9c13e8530c291b2307c40510701cc158427(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf7137d3723d862c00982bd33bf77dbd8f7a49dde76c0afa7123b324ad90b96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2367085ff5f4c7c3182b7d525721ad199eba5e5117dbdb3d8daa7f8015add43(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7197417a7468b10f349a49fd4cf7f88c6fe34a77a6a23e87c554d722cd83857(
    *,
    info: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fc983a5890ac26257f8c7e947946a33ac89d059a6f8699571f79ac6627ddf7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29997da27a9bad524a3e5f4fc0bfa173d097ccc3ff9f2d7105aa63d6f5097cf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d29ff046aa4367c7198ab7a3989d6e4806524c0851e7c139fe1ad89b95fefa0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa5745c01cc32f26d444744782b941478f5b64ce59b2ee5778f47625cf5ef94b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275c0d77c6da2970af36cde63a2d44c7f046ee252eeb46374fc2e05bc0fada39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b8bdb537d1376d39c059320f79db075445d141c6de18ba2340940ef18374af(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStandardTlsMigrationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38385d9ea995c69c1c3e916666dd0ee7b8d9c588bcf8bc12def339edcc7a4e86(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab4d5a39e42a386c2b057fcee0a48ca3af902d34d9bd0533a8372d154ff3579(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098768cc38eaf365f9fe1a499bc7db988a464973de9b38f325febfcb44028032(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9594d702cd6e2e604d12994ce9c53976d0e43efbe4205af3ec794790f52c2f9c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4f9384051451e7464bcba9b829af780347fada916e8176d5115294ab50a3d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c723cccf3076977ab996c30360df47afc285287dac521f3861075d60402a5c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311a7bf49238cab701f395492fc40f95af642bfeb1437e444af265636209f137(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61488947b25d1240a5d61bb9813fd485cd0624bc4bc215340fd4990238fe867f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorStrictHeaderParsing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f57c8e09d2542c51d7c6178dff8d18be1a2b3cac629eb748fb22ef019e6baa0d(
    *,
    access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner_domain_suffix: typing.Optional[builtins.str] = None,
    referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f8a3a911df2c61750cc21cb1ddb9a22e1f267c2bb56a5d4c221b3743e2b605(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0637460ce6503397b0b0d1e956ce0f89cfa44a099c4078fe473b43e9ff9e0295(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e39bdf298889e2a552a9a497a0c6b51b0d1b3a80f0d9d77ce129ed9563519db0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af63ab6c419918512d5ac681dd1c592168e9ed4654b2a54928868829d87f627(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__878ea4e84ecf392cf23c79abbaa4a4cfd9874d57166be0074c97a5c6f547c98a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74dd96fd9d40782e16ee7e1f0645c8b5bddbd8bca28c55741a046cabd0f9122f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6aab41eb7ee71b1f4e588f6efc8331b47523197d8265acb13e188713b09ad42(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e6b0470c36f8cd96d23466bd9373ada8c555427af6fcda7caff860a62dd2b05(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d802aee2579054a815870332ac381d415ec3af11289ed8aaa9f0b96d835109(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af51aed762652017517cf3fa514e45e1cd06e1c58d64976a97a761242fda1666(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__297ecaf2c540ad0bfdc5dabc1776fcc669e621b23a1af4e7a72d7583b31d0f65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb49a96fbab395dc266ef29f08d94133b2bd9141f008878e3cbf45af638e63cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd6a50dc7ad462a174eee6309cf147302600da35ced1aa87c26172456e4c7fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea6d382a90267bd54d63c3ce96431effe82848edd44399071936a0ab5299d8cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90ea3e4fde09838d9b4b6131ff9df6a58125ad4d93904ce74c2a5c7b839f6abe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f5564f709d3d9ea0950307ec48a2ad083be5cd1495f953dc11c324376b9868(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663d4f9145c355a873324a8cea9097dab04cf88569f6d33c4983972feb21a1b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93f8f3e0e0a0db5a22ccee46e169b9c3ac4e926ede88410864debd76f04d7f88(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd736bb21379be50aba5e569220eff47ebf69f8084579d3cd18893a87f18bda4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be9f5f1f2f39e849cc7fd3b1ab2de0980358a17ca3f3eb60cfd7721585590f8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c913c6a1ec3d0907cfef75ec883858edce61672f2865dcd7a6d6e0bff9cc6518(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30a99e87e136e2cded6db4f29f503e5f20c49b66c4f30df22eaedf56881821e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2354d4e47d651a9fb8a17a6e713e989bde72f4322decab54adcbc3698487cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3288cc20d9cd042a5b91994337bec0d0da804ecf37ecd5c04fce218e3abfe4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSubCustomer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8192231a86860a9db80e92831d942e451d852357c122e378dfd81ab3b6840229(
    *,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map: typing.Optional[builtins.str] = None,
    custom_stat_key: typing.Optional[builtins.str] = None,
    enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    race_stat_ttl: typing.Optional[builtins.str] = None,
    sr_download_link_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    test_object_url: typing.Optional[builtins.str] = None,
    to_host: typing.Optional[builtins.str] = None,
    to_host_status: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16fcc1de7ceeaa24a343931574875e2562de2385b09d76edb914a3adb5f01c14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b56c9afb07a8f0d623212f370a4a8cf9e961304cc5e613b734b7d35319e5ed21(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f8cdff092d3d1e70c93190a9058055e0ee8c6de4fc37c393e7aad871643199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e14db805b9f75c9c8668d242a2a62d33eff958bed0f6a04816616968b3edd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcd55275377c8c025096e021979dc1d86fe82d941a184980ce18c8d71c4b37c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3721d464495002e63f1af7943df3efe64b1cf78d961a1d98dd2998eb1bf33f90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbb1ef467e73f1fc2a891d0117fb7f989c8716ba44f2552d9e02efe3faa3c9bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c598fc91e1a3b3d7ef674d005772dc1115ead38bb8a3d433c8c05f448b4a6d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee07777771dd7810e7daff85a6d6f8203d36b18fe2a3e13e3bfb6dc465c8e91b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b2d37ef3bdde14ee08ecb3bf879762f0e0b932c1a1d21b140f1cebb786d058(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b268d3cbd810d842619d41befa7f09c76562c66df9c47c5729d30714241c11d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df61c3ce9c95be990ce17d8b244322eb24f7396716715946e3b160e72a09fd31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3fe27cd968c539671a3ace083c4da97d020f7c8401dcec9359330d562c7f303(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f22b7af576a1569b415b99c48ae8de78793556e0e1b7273eb73f879eb1d6e9c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec90dcac200acdd2a4f7ec1926d065734e67350dad4b100b6eb3fc5d735cf6fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__067ca6edfee4f18bcd145ca21aeac7fe764ef093dc0954ec6ebb587d4c6c693f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460879bd456f3360acf865d25c4c36b2ddec235b79207b29fd74ddd9276e1087(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorSureRoute],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c025a63cf0ba59ebcb8928d448fac533c93e9f7ae6ab851761dd17e6927093(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b932240b78297f192e272b3180372e68d7a5a7089428b4d6983823add379656(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d17f4cb2811e199691bc64ad9767ebe6b81808f31c006330785ad56cb5ea5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6637914db18f5b151f23d2f8fff8ec063fa3bcf02a097a699202e2a0e1384ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cf8d8ab06976c5291ac3fee5b85ded4ae71238bbebbad005b73261b9c136d50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e0468eb4b80c1ef24ed0e81c5f704548c6102e06c0ffdecb17620ee491ad0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93283bd9694b47025ed3bbd8111c71dd2c2767b1b017342ba389f171da77b313(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTcpOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ac2c3c72e7fa4e473f2447e1bf8acecb3ed8b8ad54aa6277a957ce1f10330a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ibm_customer_id: typing.Optional[jsii.Number] = None,
    limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f349fae839aff5f8c8c4e0bd85056702c769963282bd8ddbd96f504692ee400b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53c6985c39777d8752c1095043e693fce7f6ed1d4ee5363c2c89e90c2f389cf1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f2766086aa9f566def0868c99ce5f39c51c34b551b75e2d1bf4948d659b6fa0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3212a3e0471e4ddf3f4afa2433f1d09c21ab4823d79b3b3c7ed9a1f1794a2e38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195a626dab76d7dd210b6ea2daa5bb40699ca5df1d87401004c0369f68b95ded(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a1fb588f7294aacc029d2d5c595744e89e8ba96af95e9035626bbf003d53ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c23df74506541f81a2708dd48727e5c57ec68b653e62ba1409103926016344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a02ef09459f168d7e32202c8e44ff0a080ff2fc9c1bcb7f9cfed7d6a2ebe5d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTeaLeaf],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85b67e2c5cdd2affa944f99ce6684066575ac94286bdf51abff8cf1e7cc93c66(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715fcb3a741bc008f5750ae001b3e3dab3ce1859a10e3d3a8770e3cf454f472e(
    *,
    allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    method: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b72710349340f8ca0f805adcec67747e2c300268fdc25c13bf0529b56e9862(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d58f8f91879502dfa9de966f20c62106be29526e1d8e7da73e5a48a1289e5a30(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead99e9d697558e02ba5ba7a21f87a9203444ac0460744bd84c883088c1df636(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d6fd789b0f129a0d9aba58a5231cb1dbefc8bf8d5eac58e1d2f0a09688ce81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024eb724f03472d374c4541ae8f563c57d71e21bcd3ac90a146930824096dd04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a0d5dbcb33faf16de092c75ca4779be6ed2df039d7a778f8f17ac9fa31ebae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab57dad524e5bd0204c1ae11f499fcc585bd995ffd475f6ec4347918ef5bfde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1f83a8671a6acd440cb39a1ee9030bb7281417be1c442571d7d6c972a6e9d14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4315fb6f3435bee1d9c258ddc29f9172573194d2bc29ad2679339ea053a1fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__971b9d32a7e15eae61343e8e89096380140d8b9f1c4062358432dd2912158d76(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73c7a4306dea71b109d3011d61de55d43f7cddd5fb9656f8396e972e30f3fe6b(
    *,
    cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
    custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map_name: typing.Optional[builtins.str] = None,
    hash_algorithm: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_end_date: typing.Optional[builtins.str] = None,
    migration_start_date: typing.Optional[builtins.str] = None,
    migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_end: typing.Optional[builtins.str] = None,
    serial_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ecc5bd433cb614a405ddc8d1c6c44d4651e2316bb3c5bc0c40d1a17fe1eaccf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc57030236a4cd3d049f34071a1f9204b0df954c48b0d887c4c44a097a1d5c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a139140ca1288e803b1d48c153c6720a13ef9295c367b3f7f89f5196e21d6340(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76db7c49ef0767332a5835dbf3000fb1e14bd6f6d9a7154531af95cbf2a7991(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__153d34212805ca233023cc052f69f6ac129e47228e6730588b7a8756bbe0a0b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee4ee0cc4e9a895ae7df9a9a8932af7290feb217b93b96a937a8a524848e841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc425f79f88861e2bf5c645fe31eb9fc1bee445fff02360b8d092d9ba455f9c8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2505de756617c76a1f8314b02b13f9c19fbc77303ad3fbd6cce7602ac425f261(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a8c035774451048d0b20ab865d750128f634d2a3c0f3365b1755109955ee0d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15dc1325860ce5b88f54ab91eef9a0756ce2161dea4c421526d4e8aeb4fd1b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45b89f3f6fe3c1a47ce3c6024bb9d44ae65ec3c6b86b138a71b7f512786c9fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04eb88c4e536b563d14138766d1c56e1afc084b710954b0e2e597aaaf5c7097b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23d5beeb8989c5d26664aed752aa42153e0059bcaec5ac6d8f1b589d9c2bd12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3273dbfbdd344be99b02ed67043f3a6ed5a9b07e488685090af24af0debbb275(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25eae0da334438b0da807c3d6c57e8be824376c67ff016cfeb1f3660d7383612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06bfdeb6e3d1375fa52442400b6987e6f2025a5bb169840dca71746eb374cf70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6668def44e0c641b910aa3244a78b79e106a42ad66d2bf6481e73d4253eb5a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistributionCustomization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dde9098bfd4324c2500089f3e19b02809190389b2d172ed3284b15dca0543e44(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cae13b97c9ab7524d82f335c6c944ff031fed73b96292b19b111ab3c8ffcdcf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83b5a44d1cba838552954b108171164707c8d6a2ed2f56ee74c27776d18ee2af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48df585de58f8de55ae9cd6506f714539a452727a427c6bbe4b082f5dd089b7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98cdfef6571ee16573b9ac68abe5493b18f49d5c53fb75a36d872154286a84b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fb9145d52a30c3c0d1e693c5d67a7c10c6c1a63fa96aec15d435a64d271a34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ecc7634d922293fb4f6defba80ba2c53cb67e8eca7efff1355f232a25e6c81(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTieredDistribution],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7165a3fb1c490fb05de3880dd15a01ed7502d203bec5b41c503620b62d84146b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d59104d53d1696a2b81579d048bc307a7de569c456870580b7acf213e5c045ba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__804f61aa35b74be3630f61c31e0a16d432b9ca30084b8d0d14682e688c0c15c8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1896fed375867e5cc86991acd20dfb904a1a1281b862c920149e71aa1ffd7158(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c318fe2ebc16c2d88e963d3d3ca3f72df7022a49e84772af9210d59083da4be7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5486a1270494a3739b226b9b42c217758bf314b4adc000a3a54fd92de57bf1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f5cbafcf531f70daefbadb81892d6abc28adb2f73a39d1b384e5b5a749a52d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d6e893a22171b4a16f067572b5455487b690eb8f7761a95746da9209b39971(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    legal_text: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20ce0bac14009a8e216488d56c3d62c1b220185575eac48553f917969bf5c13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81e796c1e496d2c8d242b501327fd7c44177cd167b50ee8e9a45ee35b9ced5cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba8dd4fac3125e4732db19483a58a8e4c6a8ae1eaad4e26b5b6649e8effc435f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723dc2df4c859afe485924ae7b91c29e4c3db1be26dc3bea5471cbef4c3c02f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f0715f453a0fe30ba64c2eaabec0667a6b7cc0eabb6c8ab5acc0d3f11eac4d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f6d7ed22cf59485450aaaf66a2eafe46ee57885668c3c7db61283395a3b375(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3742af81c7138824af115425648e74298a38c7e200c507762768ac227e3f7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b850019fd2a3e5b8d032ec8bf079e3e45844d7042a543754137ebade02b456d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd9075c87d976ec4826cb48a582687ab3674635317ed6992c89a8aabb4799726(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9112cf77fdeb55e380d1d6b8cae38f084dd9dcc0239b2ec415f4f67f7bb6ccef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__838ff2993489f1c9f3b804bb310030de26e3c35d414c27d9636924b95225fa0d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorUidConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19fbd3b5d17220065bbbec57fbefb9237a6645b8694324869c149262180a96c3(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3c1c60118e42f97e974f18a453d23a79085d8a28b6e9ce9d88dd9c79c787a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fce93319499cfdc5b1c7f4130cb331c65d31d40073ff669a5334d332f41ae63f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f98ff2c6f6b3ce222af120620ee5941c74e335a2128fe2be6da9ee16e0aec5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cccb239e1b64103955e4704adf23eb993f6f99f2f1ce86188a9a111541a770a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ec7129a5b95410f6458b86ac3752bb294ea044b16bd130f8393997f03a3386(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9740893bcf4ecb4b3041a2f5ff109debdc3f0637e4edbea020b0bc62aad826fc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorValidateEntityTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5886327dc41854536fe174c5e9ccd9a1c3af3a48ceedfbf486577763e8f3d4b(
    *,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195dd0a723767d52a3c214897e46ac2a848c79dc1ccae07617a540fb28f34d59(
    *,
    authorizations: typing.Optional[builtins.str] = None,
    client_id: typing.Optional[builtins.str] = None,
    custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    primary_location: typing.Optional[builtins.str] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_name: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2580e4fadc4c94001a195b649d6da7a8cb71fb837a187eb9d3d1a3a66a2ff48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e863a498b52679d0631c4ef8b45d98dc286a7ad2746f7a7580c8197272fa3c90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1424068e0badfaf117f5e6cbd08b45c9f0adfcb4866c5e743c0d5b5245e120(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3afca5e15279fe4e202b5334aaedb1fb96574fa874e39071b949675190ca1803(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__954aadbff1fd7285ea1678421a41a4a69e6cd905c978431d31fc817dd30fa418(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4823c15163b9c44778e9eb226b3d6be0c941f296d8157dd0677eace7489d4941(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23fdf3a08c206272e8c7d30a56baa8769b2618b87f0a040a1ef73500e2a76fea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7beb890ae5144ef8d995c55e1041de33e081cdf4386842a214481c8432cbe034(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e66dcd3d178237b1c2edb25b0ede3429d0a711f8059d454b90905145e1174b01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff0873926f14c021655c2ceb30c273d8ddac79976afad9b4b6d47dacb56723d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21d3a55c13752339b18085dd250278b7cef2986eb90d31cee6172ff89d48476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5b9ebbaa0b6a3834129ddd77a6e683a2a11637c585d14d1bb69eee9e6f88a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57319d7efa171a7dabf3a3338743d8dff64b9aeb8ab20bdb976a1fcf16967579(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4c7df424394eacbb2266e98cef07c7f769bab3397b6314bcd0cb1ddc2083b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da44b7a65dbd3f06cb7914d8d06d90f990898a355acd2aba57ca1cdf0627bd51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97074f2125a9422474817a38e946e18f9a5428d83580fd8f4f35d320f9d37ecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cef1f6ef6837e2fab190819645d8a2b049bacc1230e2d18f5d155ca92eba697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49dcce69379e8fdde643b7419d64d0db5b56c11612b97ee385ae1a793e7ecce8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dde3ce4a9b71e14a6d4d168fdf77f460493c6a7488a5bfc86569b17192a6c88(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebTokenForDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16754e66ccae063b671591825b7eb86a96e4f7cea53627e90c1cf5aea932c3e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312c47bd51c3d7c2c31769fdd9eb3f6e473f839bfb3836717f1dabe6fe141e90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6fc3ae80c00fba6755fd58ef66af5e9460806ce3e68e9067995717b6a69c028(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bca7aabe1ded43be35a04a0c765380832510994a76c717118ed3054251c540a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20f983a9d55ba32c3b413942b33d1daaad5ab8a2919011b2b9f43610849b4b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ffe04211a976fe5843f9cd221bd6b07fc4a804470e93da17d56ed659ffa4775(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b231282acb28a38004f3086814a7b5385028fc4ad6d85ddd2509c1e4693c4f01(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__882137dade7eaebe679d5845e66aa355e427c1b2a2e72180b6872f618aa16ce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71db06dadad364590b06b44219dab24475824abe0557e5dd730ca80dee8cf9bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7f68167ab341f88f40e00a67a225b46558fff7bd552ca9aaf6c6d0dfb9d56bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb8e5936e7ff659cec3a31b51003b110c26de2929283ee1f30708e37149be949(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyJsonWebToken],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4776fc180944e024e7588cce9829cfa52374cd13d39f320893fa2503c7a91433(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    salt: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e98bd1f0b678031b5432daf7388bc37736d9d2749d90c8e16e75f3faff4d243(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765e07d4c72af9b80dc6ec5ded65cd84e7f002144208a54b93cac8d338a13ab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e1962eb1f2441d509cf2930fac8f908eeb381397bfc8bf45e6f32398e8ec439(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91d05c0bff959a741cb7816b175fa9e19ee1f5a713a2e628c965560228a08472(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bf96d96cb61313da327979d68bdc528df2be07e0148323ade9379dc4a37526(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c81f88296d2c79d56aa7386ccf02b1720c5798183b8e8af00ce872a43d5b978e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78012871b1a4398815ccaa92dd5e133bfc0ac9202b595fd5130daf026ab8ca23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d02dac2ae199731f3cf97dc0178924ce27652eb3aee9574ed6e38e447c4e31c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eace29472b4a5a467c7a50610c7d079c000b69880b5d4fd2cd9dbe23493514ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7789ae3d80ebe8e37dc0db9bcf612c6fa4aef235f4decc0b82235d40906bc3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3911cbc48cd6c6bdc4643f851de1dacd508328db7c4ea74a450c0810f2cc4ee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a83c714e18453258a4a4764f607b6870987ae4850324c001c7771bff221b5a9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270cece1acc501679ab0068105d581ccc7dab8715c100704d638389ccdcf2fe9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5549e93da4849bf629e8399879b8404fbd750d9d33d328b3b072039ffe0de6e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e21f4d5e027710b9090ae88617a48569658feec0c34346a584a417699be5192c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVerifyTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__837458543db15625fa04c1ba89e4b32484723c1ec5706c5fd62848a2b7e771c2(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04673403034c6dbab99c1373b3c951c6fc9518a79f09b6802f414745fd1c3447(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfc3449e9513291707f22752ae9b51b457f2dca1e8fdc955bb9726b5f3606a90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a5f343e96b1299eec883b1dc2bd2f040b801dbe121d20de2e6d80a1d14ce7c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8137140003b364ef00befd11520bf0aeefb4d5b4670ef440cd80e1f466a6a35b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad3ecaba5157b69dd48d7c660c640a8597b667601ec3ebc0fd332a426119df7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dee3200f4927d5ead199ebe06c17c9f01e4168a40ec2acb955366b5e6ae2db84(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__187ce4be3533d0d6a896735e7c706718d936146d2acb974808cc36914844e026(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b8ff0126c3d14facfd4c5197423913e21bf9d497589ca8ab7645547624418a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef6992ab13a75bbb22332b520bb48aaaa750538f278a574f03525f6c0f5c8d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30dd031a51eb047e43cc8394eea758e144633e53a2ad63ed76f1d3edcf9e6813(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c01f79ef43d7fdecc8d4aedcfbb8f97338642391f1156cd57918a48102615890(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef5ba9caaa0ca97ef2fe6f09b6641a63d3380ec24f433aa5e748d5d8fbef31e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd200a98d7cb80de8406ccbd66ab2786b029405d0f8f3c881a9c66978f436bee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4126e6cf5e97816d118c75bdc06edf61140ebedc0d0d949ae450df98d57bc635(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b01a6a2c5306c3cc8a41f13551e95978c851822474ea92b84fb95f640c64b3cf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be075302057f61ac07c56f61b73c670e477aafa47f8d3cd3020c7940bbfd86a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0d9fd9068eb630b91053cfeb732df369ce4a9140112d1ef5001fc4733f548c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fb6cca90abd4e0eeba5c2733d36e7f8b30a814bed054b80b69f04d58f4e556(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b0affcb4eeff03d8c054e0f429cfd17880dbeaf085aedd6b864a04b429de4c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151a41884e5bf4a850db936869d2cebd5b793efea5f63cf48311049c734171bd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVirtualWaitingRoomWithEdgeWorkers],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5620aa8d0766edca6ab1089b52398955849857569591ec857cd0d42d4eb518(
    *,
    allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
    allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
    allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
    allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_label: typing.Optional[builtins.str] = None,
    allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
    allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_key_cookie: typing.Optional[builtins.str] = None,
    user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
    waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
    waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_label: typing.Optional[builtins.str] = None,
    waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
    waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
    waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_directory: typing.Optional[builtins.str] = None,
    waiting_room_management_title: typing.Optional[builtins.str] = None,
    waiting_room_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_status_code: typing.Optional[jsii.Number] = None,
    waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38377db9da84031e56c6d2aa22e50801046f14ffc0209bc57981d5bee967eac9(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6491e2d03d7644060c3853c050727dc28fbad2d585073594f683deab608b41ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8361ed2e21c23be8a37a142f9daa8d0c61778dfc87d3e76e7ad86b41640cf1bc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa9b0c8f1bf8ddc29c0d4e0d682b41177ca00b71f5c99c0b93caabb9f15b400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53fd31800e1eeeb7926297b00eeed835ff0b84823e15ff28e94617fdc4e020c3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90c79ce4833345cb239c5847bc46aa14e0280e608c3169e928f2db1feec3f862(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e31fe494841bbe7226322dd2515b9a121d83a8e2ead675cb27abb65c59cb238(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa08865107f0b58dc4d1bc50c3069dbffcc19bbb0f8e34e7a73e6820e6983c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f8896cfb0b6ad731df24b5becf05f657da66bd33398277d5b78c6d537e4324(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e32fc87648dcdf36a586215246a47ee312ec64594226f3d92134edeff4fec4e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__121730847811e949be18f29b001be74cebd58059fc76d4b883ebae5ae24151a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afb25fdf4930eb2d4cc8421eae0225ca5cd171720695da9508b5cae4e301687a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd97bb80f5136cefa753a1c3ca554a239bb157eefe8d65981d4c0758d079fa05(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95c425624c580f5751ac12348dd1d92b8f64aa1b823c8acef2bfb4f3c36a7c9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b11323144255945dfda4972572859d6b2fa00d1dc4df5995bf9fda4f67c05d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48efa5dc6e3a24a1dfc5e44d052fcb0b6e2d1c9c78ff91d506d7c4f38c9814e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c698f79675bc5abfc444e2a20ba5e2d9d872ca7acedac658240599333543a506(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa5f3d16ac4442d80145f05133c6c7fef4a30ba250b9b4c8f07195028bc4c3a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdcdffe3a21d36f6d109e1c4f2a92c067aa2a6c80d815e6a89a6be81fb6567a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb10da5ef5ab6031972ae311199e01688d8b9dd2f292bad37cf6f1df59b846e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf41700e55575b5b508915b7058bf3b563d42e311ace10962f65548783d25dbf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54a828336b9d3335d2439505748b3cd1f489112f06eb55d3c8fae691c3ec4465(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7d6ee9e6ac6b9b3de4dc5753ac2116406f10218a5d8e5c584db0a3a220fedd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78349f9d62b57524bd1bb7929c951b58477e79c85c5376a143fe6824cccd18e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__864b24e5668b34d9e15f1a496e623ec1b5526f7ddff7eac71ee477800138c4d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65db1c7852c03446a1221a25af2fec460cb88ab861e4c71c853ca39f2684ca69(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationFifoStandalone],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe27a3e969da8df88bc5352f6743f9a427375f9c04282cef4f9d247bdad7013(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a812d37d053b2a503ee9655b581b2d15b4e8b39b6b7a3da60ef44417e0501175(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d556ec943f2cebe5b5cbec00dcfe3978a8ddf78cb0d7713c07e050a8a10a805(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6311af3d5a7e8e94a2057a0f4e1146fb0e27a1e529e98be646617ebd6d48194e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c1dbcf6419ccdace8d9c8b630a1903a7f6a0690e4ed3c1fced77924171d47e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fe07432e2b548e1c5b76bc36974b57a8098666fac17d78c3a80a032f88b695(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a35c493d4814121633a99673f1df842eb358403966d2da077ffb93976e076f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d0a9da0582c0c67f3438ead12bdba1c6215a52fc446999e98aa85a31b919f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3908d47a24b28cecfb61d8f8ebf7601b0ecfbd25553d0989bbcfe1a2e05322b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ef654ec5dabb6b664aa077cda1d813344c1ccd2b3501795fc13bcf309b2b3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8816bd8f77e9de91c1b6c2adff93d06fcdb29a7e6ca23367755e8955309f4bea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ba1d3ea5f1ef826ff127d70b54bc53a85963a9739d4d2a97d0ad0835f2f0096(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1aa5fe703eb0550a5418496d17b93cc3b9ffea38b471aee03bd0cfc66d6db92f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fceceec4a770969895a71ecd7211da9669563a37afaa619cdf13d7461268400c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68645fc8982f6d676fdfe71ed9a231102eafadf1527c60cb2516b19ee7711f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a064a1dbc9e08052bffded6fed76cd2e25c444a5173e0ac073c152ba6825420b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__159468e8f7a12c18523c015f4cee45434f9f8a364c4c0ae4d320b953c9ac443a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe0e76778f3d699b54f071c9297b1101e40f4a43faf2dc12523f9517a2be198c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f86f0f2d64c6568e86336fa2b5879e1227fe6e60d6b3ef91efd77090f59dc34f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7b31710c7de8cf3b80e43efea54b9df0072b93aaa6bb978ab5f7fc8fff5492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13710d0c62e274688f9d987bd075cb497ee0b68d2c14999558f9980ac399609(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88baa5cb8f57df3538e592575df79710f93add268269792a4c33c3848033e2a3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd6ae4ffcb6d367c11f537f3705f0944cf991a724dc30a230b0a2501a04e346a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9cc1dc7cf19d2c50778f9c1c072c4608eac961a54c67659148d30aa13ccfb70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aefb250fb2e8f3d5e1fd85ccf891687131f8eb24b6f7a8cfdebd935268fddf62(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f31b4f60597f9986ec6f1d919fe5538d8fb4ade3a6d41434e43a5728e7569131(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbd2bb4ed69e0580e6b499cc62bf058ba2748c4dbbd076481a44ccc8d277ea7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b793895e01cd1472eb40f627bd9e012cce8d3f7c1bb42ae1d10541c872f31a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a887d99eb9c4a653c89f4ed7a050c8141391d6f9a245b00aeefa9602f5495ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d19cea20a374438e030cd28aaccfa524670f082045846ef67d9c402ba853c4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0eac455f70dddf3dafdd1042123116dbe90fa161a8bf8e367570d1b7224e83f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f5a485c731cbeeddb728e6c9c21e82d41ca96788a986ac98d09fb0d036e182d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc8ae54473b57795caaad465ecdfc05de7ea1fc5265816312876caab210dd73b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0925789ac67ad9a5e56e3eb4e50de09ad31587fbe2154480cf3d08327f2f455(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d9b45e2305f1d22ef32bf756b293d1b1fef5d8b9e7258bf20c6717a11c21bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115e88eeeab91559771e8de3b71b8c3bc135f26dc63aa2eb67c37df4b5ccc69d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5718dbb03b8bc1d5397512c2e0c598b9d15c556a72b395f5dd3a52e95302d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__482882dac8e011155fedc2b6d115ac491ef4ca0ef992ea67fd5f364e05956560(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b2e4d412e084e670797e6f78cfd8d2152e0f4e0b7853d9841a74710be895e4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc349c09b244a8a2d60274e741de164d3b4fa78b0c850b03c2039c1b2dffa4d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33b0f9b06d562c89a96e19d0043934ce679eeb2a8d0a5fd4439b8f6353dbbc4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fdff03d05ff3be4fd4981339d2df414283690fadc60c31ad22879883e70190f(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3205f1fc06b9de9235188b5df027696b7a8a98b2099993291545e0b8e2eeb1c(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e34059e6ec4015d1468c4252e3878c7436a0bbf2c23bbdf337351e8f9d8d4d8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9ad0dd56cf4e38a7c207e89ccfb77048d397e02af354c320900395859d69877(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de5d4b5e9b041afd41fc4bb1fc67c57490161280b9c98d1ccd265eac6c421367(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea793832866d5e03f8340fa88ee1e2b497b64040aa392333e57f52be63f0a75d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6830d0dad6140f9ed892511fc32c61d181b36b1e24be75eddd29bac4dfaaa1ca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb355e837454d20dba31eacb7c8ced527b64ea0c512f02f7ec7fbdd7d5e5e89b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ab08106d72d21e1459d6d37f8af3d00a8ebda986efc21e07e2ccc9806709fa6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311ae3aa13a92234049531d568ea20f957782b71626a266335def66303d0509a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebd38bff7930176d695b73810b52b4caa96a8c3c5bb65671dea3216ab84cef76(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d0bf242af3fe5e1a52a682f5735514c1e51beaa7f7a52497fae252041ea238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4931dce43b1472d01569048a93cb801a1cb31f9ed3c57a2c7a5372d60b3507f7(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4845a57bd1865a31b7a9e14d6c50deb935410577684f99a3729e83adf86961ba(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c48e2fa5e144bb1f22f0b7c6ea75baa1d98dbe2d3bdaae09201751bf9bf668(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ba7c6ca42c3904e6eb5cca514bb0d36b5e075297d6a857f4e902fda1c0600e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bdd98e09e33e5c26caed433823f88fa30121b7e1ba0337074f0fc379192675(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__825ac40c7ec4c52d3c304592245b946c9c6bf956024c25882eeedc3c79b964c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f18daabfe035d1ef2ad796075f1d7b99490ca0468558d42398300c71169f8cf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__393e6ad53493c625f25591ed3ec3ace1a3fadbab056e1d440898b25db4ae72d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorVisitorPrioritizationWaitingRoomNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7052a5c646c59faf16c66a86d546095216a7852c12839d80dcea4f4b952e1cca(
    *,
    ab_variant_location: typing.Optional[builtins.str] = None,
    decryption_password1: typing.Optional[builtins.str] = None,
    decryption_password2: typing.Optional[builtins.str] = None,
    decryption_password_id1: typing.Optional[builtins.str] = None,
    decryption_password_id2: typing.Optional[builtins.str] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    miscellaneous_settings_title: typing.Optional[builtins.str] = None,
    pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pattern_encryption_title: typing.Optional[builtins.str] = None,
    signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_signing_title: typing.Optional[builtins.str] = None,
    use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_key_id1: typing.Optional[builtins.str] = None,
    verification_key_id2: typing.Optional[builtins.str] = None,
    verification_public_key1: typing.Optional[builtins.str] = None,
    verification_public_key2: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ffef741049b8e04ec8a60501724c92b3b563ddb1d355d740307a67726cb7e34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7417cbf5724969d7682ed0b37051773b24177c6b6f88cde1cbbe84ba56ff6e6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e3f5d807e967d7375062b1ad5b72b3fd4d8b7c4d5ae470d14a2f29e97744773(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb0472fd646a541183558777dbf17bbd3dbcef4e79cded35ee0743d13c37dbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e9b07dd9d2b4080b306fe8a09c7bcee78796e65b8cfb271f93d2a1fc3e0962(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b39f0f92d2b22dbaeabd27ea5402a8f6082b136b3e99621c657cb769999cfb7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9042a502b5becb6bca48950c04b339efbfa6aa7930b9d68fb9acdb0b95db00(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67da7b9f98b99b0834f1c6e8d8229ee707c7b83fed8a720b077e50e57f49765e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6a4a8470a9696c23fc01b655724f47d08bae92302b4eabc33e01208f503ab4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a48e69557d95183f82ae81cf520ce09562eb2c6346cce808bb5f6efcf470c8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f088b308a44693be225a4be56e53e9f02a9d9d8cec041b41b93c8d1250c67672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b88e0c4840ad2e349fdd46061426957757beaf9f62ec0e171f056c5f951a755b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__556afe4042262ef88ba7a90bfe04f4eebd5e4c35236861a0e4e6bb65d3e45476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8591f9b20df883dee93f97743168fdffc7d407039adaaec4747136cd03edfadb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127284337914672be7578a824986fb47e3dd3427bc56b84db7a656551ea817c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8430bdc8dc52bdf209d48e592e4355de5884630d0e2b403a17299c24379621c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5afaf5c90fc0226f0515701e06f821fddeacf76033f561b19afdfacc152f1d2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4550bed47490f8b08a1052487b9300e15a21104265a1e7815de838959a1c39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96b87cb9a04fa6039d2f61fbf0e0e9ca67894c1f44678d6165b362f4efb6ff63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7544a150a55421d7bb7b01cf01cf99486f4338b4add738fc0e72fff763cae11e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc04241a0b935f1fee2fe1669cd27b1d9834302ceecfdfeca99506e508b138f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWatermarking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4810141d3ba351a8f757265d6485aacb1460dc0a687ac6f7af145f871f5c422(
    *,
    firewall_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452c889ee3e03fbafe28f990b5ed47e725f4af8bd83b15976409ec3968612464(
    *,
    config_id: typing.Optional[jsii.Number] = None,
    file_name: typing.Optional[builtins.str] = None,
    production_status: typing.Optional[builtins.str] = None,
    production_version: typing.Optional[jsii.Number] = None,
    staging_status: typing.Optional[builtins.str] = None,
    staging_version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cb350062609b052fd2026a33ddc52a640bd84a15c25cb3a41a6e4db21ada12c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0812ed43b95c335963c6c91f762cc8cb9732bb256a827ff08afa750f42b43140(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26ef442da99ffdffab8e1b7e15a3a796584fd475075b55f9e90eba370ecc1753(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__800d382b40c7e769ac4a5127bc205942a7d281e42c5010b00e5ed508e100c67f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef5f73abc8622ca1e16669fbaa395182d7874049c8b00c459b63dd8b413ca5f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b53535d7f8a5aad4ddef7a7762273c13ea001e28466c116e53dec4901e8e21e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__958f428f23f95eaec3892945249340b88d4ce4b5c438aca5f18a6f263f16a5ab(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b58bc2b7a9128f19ff12b89c2addaa60253d67b462ab0a29f2cd1cffa77d20aa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewallFirewallConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__717aacdbf2c48e9308a096b3dc2a14405c1e2c4fd322a997a3d5e0565d725b84(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b826d9e843d95c0be148755d2b090925d7b9c80f6cf591840616a6031234f462(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298d64fbb49218b4265775556588efde743d216b55bcfb1c70dc738a4cb9f3ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4163510764201400397a1387ca9f2c6f6f439f0ff777d9ae58e219d98a23915(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306021c5aa14ad371d88c564d3ebf58e81c6dc5239e61b9a6d8a637f02b0b0b1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebApplicationFirewall],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73cdaf116858d34dc0f82e5ad9e31402aae5cb54afbd043083f91c9c9da3e9c0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da5a407982a267a5b42c825da1c7517de22e9c4b3e600f9532be6e4b120cc94d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5247ba358a9e8ef0c7164549a29beb33307d9b1586cf28d21c02fa28c762f8d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__065517fecd3dbfac592decaf958a2314e7ac2cda93518fc4eb06a38b2ba9163d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a42ea8e8a20249c2751ef7dc23b6f81ecce9d26365036eb419228b4812cf40cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ef004885a2691fac85eb97712433b625c08987643e26e48856a1e960f762e24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29eb0925d5808e7e17cd63afd6d804a0a43394bbb2d8df2f8e26f344dbb589ba(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebSockets],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d340d11be8b2192981c0b1519ddd78b27f4b019c7802b01e351ce27f4d731b7d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b9014c8b051323c410890b29f065df2c81de32ce4e8395a56bcb33602113819(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2713d36d80fc532a85604d08899a34ebfaa2a854cbd51a39d6737f8f7f2368fb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a0646be30ce83cb19006a0db2da878385745c1fb046df4653cd1c99b183a90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0784a2f14ab142a96853b3f5d1eebeb8006810fc75df3c596ac49d11370084fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0304c9338b6c483b2c9c4774ca1d03fbc83c83bc9c79d495823f6f2f3d5b4c7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38cd636866d915829f509abb3ebb8ac479a9a3056c6715f860ea860da22f5f12(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920BehaviorWebdav],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f87361bad8986c3e22169b89615d0d2d21c65bf99de4a32a82096ead4d5861d4(
    *,
    advanced_im_match: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch, typing.Dict[builtins.str, typing.Any]]] = None,
    bucket: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket, typing.Dict[builtins.str, typing.Any]]] = None,
    cacheability: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability, typing.Dict[builtins.str, typing.Any]]] = None,
    china_cdn_region: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip_version: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlets_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    content_delivery_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    content_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_scheme: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_is_authenticated: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_username: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_workers_failure: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure, typing.Dict[builtins.str, typing.Any]]] = None,
    file_extension: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension, typing.Dict[builtins.str, typing.Any]]] = None,
    filename: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename, typing.Dict[builtins.str, typing.Any]]] = None,
    hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    match_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    match_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_stage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    path: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath, typing.Dict[builtins.str, typing.Any]]] = None,
    query_string_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    random: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom, typing.Dict[builtins.str, typing.Any]]] = None,
    recovery_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    regular_expression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression, typing.Dict[builtins.str, typing.Any]]] = None,
    request_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    request_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    request_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType, typing.Dict[builtins.str, typing.Any]]] = None,
    response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    server_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    time: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime, typing.Dict[builtins.str, typing.Any]]] = None,
    token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    user_agent: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent, typing.Dict[builtins.str, typing.Any]]] = None,
    user_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    user_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    variable_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c759c5dedfa5443672371933da6d9a1008090c643e92bae10df3f659e5c11cb(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe5d0bc8f1e08030883e5cd7d826005536f904cd92a26eafd68eaf69f12d2c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31856f3caba2d069b5d6aafecd4feaf2b62c1b8c2425042e32b3c2d20008673f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__407032591b4e47e6c472d657a1668bb441e2a0848c570da0788079d6256f51be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e93d7a5a99cec15c9fdf4ca4890bdcd65c494b4fd64503a4bf662cb0de2c771(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c49ff5865b8e9c038b1f65af2ebcf4b41584cdbba7f83bd1b742a473e87acb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be09e29560fba32627a79295d7713baa28ba52b94b6eef41143e5e134d2f118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a825fa58a8af65b9bd8602a2b9079c046ed06ff7b128f7209a8236127a114a4f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionAdvancedImMatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b1bbe3b85725c2f965e3655cd09ded1c46fcbdd021d6b7afc465ae8eb8af3b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__359ab49c148b2bd27734fc6b26d2b9c5a6e420ca106ddf0800108aacd846d170(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e185eba613349cbd2e8b4b5f82518e296e062b1e261d7fe277cbd77e9d00c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1afcfdab18b35f9a3ce408127789949073d89846c745e41c7079d55fc126703b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a4b2f0ea8d4802a499728a9916cf03c041be97d4994aef592bc25d188243e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5af28b11063499bfd95a48cf158a024536310ce6fda8097785605a67123f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed017026172157e4f98e5abf4a5c580d5c6624aa8d964fbc06acd2d2f3690413(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionBucket],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87dd95ee9a49aaf2d7c44fa751c579dabc62f945a967e2316788386866f2ec67(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__046f64858826d1534e002ea28e650eea8b26fb81b5aae4b32aa16928c1b63921(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f53d55b3339fe4b6c582d807863c336928f16c54b1d19d2e786fb525df93f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157ba6dd80b90856e349285ac0b434d035668730c759db35223a0b2da87228a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9c55a87e4fc10ea2f9c93af47471dcf50a0c03f645822547c85160de1ef26a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e845e228d709bf5821adad20d814cb775ee988a055af7917e0baab8e3a26510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bab652a70f1452d40baedc96b98a43b5c8c05072532c624170f1b030f7191576(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aabadc121498a37a632e4d7a58ae158c471af6ddf640d515d2297d51d5a8c48(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCacheability],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b7c2f30233e61c3c154cbf4ec906ccd0fadb98f6efeb9cfc9fdc9eb069cd5e2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547959e7bf98884b09f4143a411830bedaa27f8e405ed4d23c5a97058b13af87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d739895533a7bf7cf2354923c1c1b86b477b85f9a8c76fecf59e1b87886a91c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4204d774f051454030341e74b2a6adb22aa73d4160702833c9b2e10ea5cb8605(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a56a4a1576c0000b955df73e0ded1efde57b0d04883da32c720969838ca24a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2edceb3d6022ff89be0bebf478ab3df70bcd9a61fe3717a143b49ee07a8e4ce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf1d81f0f87d1f1b64d66a1787380f5aaf7a970ffe7499003f83bf02914b8b0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionChinaCdnRegion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0057270461e2a00e8f1fccdaf33b5e1fc6d49e98c0ae5de1b85678b08f31d5b(
    *,
    enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_valid: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b89ba0076ed14f727e4a4923d4335dbcc051e872d65167e3f7f0199aafb35d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e2973821e5e98023ea33fe8793d4b67f223268711c570dc24c0efac804a0f32(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b1475a2eeb3cbd088b65a342a5033cfaa5463f6d4fc4adfc3c0aa87b3fb2b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7acb503afee983d885e377e9851106d564f78858bfacc92be21741d8682cc840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07ee3f0fdc645b8e83966e87cecd997786a119dd4783e3f6002ac8b17dd3adf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6118ef156f0505ed1ac4830f321284badb5ffbb90c1095cc4ca47aba16d9afe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cbd7f63c9a9176e016e0461c0053a4001447acbc489937f303c1f7d5ffd30e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ed2e483ede6ca0f70d9c2a7c9ae275cea0365141854ad1d1be86b65736aad3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientCertificate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bf6c171c164c79ff4d9ac3e4845a07008edb95f019c65cff8c21ef4171b5bdc(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69f20df0b9b6fe004db589bf2185d6634187589552e474f490a6b0af1dd542ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36018b3d310a71fbb62fa8d8821e73d5e5f8824416d8800c91f8ff2badab6059(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32a9b4b8b0cff64db4d7d0dea47c21fccb8835c6395451c5d80849d9e56210a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82efd7f5fdb5ba1bde00d116145e230eca4ea56c1f5936c963c2587af8f99ae1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37746ec8bbc9f855d7817784a862eac3c84ca115c4facd13f2958e938f3cbf66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72db14d3f3b311389113ee03039ce54f3d689411cb3e203c22ac65c8c757bf5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c3f1393aff3250b08e570eb0db99cef61bf3c4f4c22bd142a5cf67f0fb0944(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__830d53f03b3cf397590a3851373dff3b4672d0423446420bd71d698c6446fb02(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44240cc73350c39f307f853f10e9bdb7b1d6aef8d7e96fcc87dc8ec4845a4d2e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9ecc776283f602ceb0e8d391ed88286f9b0032c663083f4a8b5ed9ee07d256b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619d422c4a99cc2285212238ba0faa491b55af9c5c7d1fb62882dba0591b5e58(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2af6506828a0e7b97e204aa5477440047d750a143edb80ff63ecb00e5291d635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1bc63cf8aadf5fd75edcad4a1eb308a1434e1712a121afb7ab1ef93561d34f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0758bd8c78be7ae1b0417765c236c15e80cec0f5030e71fbf4f09892f49a65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a896bbf5fb2a4e1a3ee256ac15c8ac54b823f745e6ed46e3cdc44f5fcd8eeb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cfc4a72bda8e41f7012f1afc5bcd2e761cb14b3e54697abc90a9f7454c0d0c5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionClientIpVersion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63152df2b279f6b9da895cdb4f2082e4a0a6a1f73d84d35593cc7e789793b9e4(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d79c584eb86ad3f1b388a8a60ec382bac303c38b639ef6fac1ff9c1fa5e48b9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b6878f241a6e324517d737687d26cd0602e5a95d8372d3be8863209bdc35875(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2280e1009bf182fd1e158ad6110b1ee5af749623ede7d7020e5828a0231ab47f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c286db70ef07c4219967d352a65cf510d1bbbff9edafa10540166f31c4abb25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01182f4722aeadadb70c02a536f718e2b20fbbd578bfa77f7db4be1091fc0d26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__456d13394b74958ede726f5a6377df141a63d362c8b1d3cfe5bf508a09b8a409(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionCloudletsOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61aa07c0d0707acaea4e68096aa2daf049c8aa0d5dfbe1f52105092b81cd3776(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7905364f47745649c83872a68d2248ba120433d9e14ca9eb0e5a7fd0ff6043(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3742d99f622346edd7b886d288d77959e636f12a24afd92cd76151444c190086(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bc2e8da2628d68c0d082d9d89dfefa37cbc715f57781f55b1256791e5baf995(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a652d23349d348ea7bb846a12ba1c9742bf3161cefbfe5d0de84742f6dd94a5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5305bf727169d175d52826ddac5cebe33588a6fffe83388283d92e16752ea7d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4df805c1768d1b5065879dd3bd4bddb7daa643417a50b1a833d05c02141d294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7631057fb675a9acff03b0ba536b2bf74913e3dfdc355af5cd1c7e0bf0d51ab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentDeliveryNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91c9ab0c30fa1c2f5ec46159f1e1eea71bff4b8fd8e36059dd236a3db9df33c1(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd3c6671d66c0da3ad195574c57e25a9445fc95fa15f4efb61e0460caadada3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__705e1c399f92f0745b760201c6b58eeef94c1b2b2a541febfd3abcaaafb2dd33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de002ceb390598ca9900e7ccf3bcffcb826fae0bcc1636e5d0cb0c36a407965a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c26eb77f02e9362cbc1167fb78a8929a21f6ba19079c21ab62e2c92340c8d94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b98e1bdc14fd90ea38850fc77616de619a380c0ca6c61ef9eb4da9cc040d2181(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dba4b657ff636e5de5bf4e025720ad93c04ff3112609ec8dc65e85651d37a8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60422b685e4b65f587d8381bc1089b902ba50225c4c1d14d7a3693bccd55bafc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ef710c933686b161dba9969dc486950d3d1e3e06c2e3068e60f316977cdcfd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ea6e360ccc39a85f1740054c69ae54e66c1bbe3762c0a168052c098eccd5d28(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionContentType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2726d52043e7230eac5883277ebf126383a1db0ce7b144170d67862bf399d02b(
    *,
    boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    characteristic: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    numeric_match_operator: typing.Optional[builtins.str] = None,
    numeric_value: typing.Optional[jsii.Number] = None,
    string_match_operator: typing.Optional[builtins.str] = None,
    string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    version_match_operator: typing.Optional[builtins.str] = None,
    version_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab34c971efbb9d893733ae3b64adc1bbc90b773772c7643b36d63d25953f2c4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0f991c4f222637e06733185c16ef603b62121165cd4346999450972affc7e7c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d35867e75b610ab910145c1b3e5a5a1478411b6448019093a7ec4273efcb5dbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db0f7b9c27ef54df65aa919458dc6885c222b308186814c043aa9de4408f509c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c2d736211619afa814a6f749353ee4843fb7129c676229c35738fc945ce043(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0605557d8579653f0899af3e546671bc508d5a136ea1d8f17888d9e7d2aa54fb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfabaadc76c673c6f3be86274434544dc55851c1a67efc7433a0b12e6ee2168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c37557a6e22f94cb5d46fce2e03f22ca80d28100008fb05cd9db4f3a469539c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a65483d8f0edbfe36d6d9508558487734aad6ce479f897f7eb715474caf7840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3edeaa09485fef1329a444f88e32dc4381616ae883fedf9598456cce705bd12b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4538c1d7eeac9c197407753ec49e1cd45d5c2e7dd6d291716396ba26b7dd2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9c1000683aae53ca3dd5d9a83926f1865d8eccd403b475dc986464aaf8bcc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afd89ebf8dbfc2b1f0e96873f0706ada67d3cf491996879c29ba66eed058c6e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0e30638cf1414141ffa59726c3a1ffd54e48af5c29b37e6721cca8227e44159(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29c6fded740da2daa25ab595aefdcc70bd8e59c20d7f69f781af333ee6b248b0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionDeviceCharacteristic],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f90ac0bc69d06bcce4904d00031f05913df75f8ff3243802ba67a7498c759e91(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb2add0b37ffc6434607478109d20f82d0df9be222cac0d33c0deedc6b04cd18(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9190d4d638370702072f3619e3773bbdbc8ffa931b170fdde7a68c7eb1cd506e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4022c51f623d6454552df09afedfe4c9177bd35d048610b73d4abdffb6b070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa7cdc01f805593ca5fa06c6967273dea2d1bd1d303fdefb4d912b2a06585601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__543a0c064561c88f777737d9f48d3bcef2bda3bc9982f456ecab3ed7ef1ac691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a2e9e9214ea50bb2c3db9448bcdc94245a2b3ce6d9a1779508220c47616585(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf409b28475cb953ab332b0a97fe3c21fe199a3b6238438d5726ac7093c7928(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb9565fb1b0afad36244042c8ffd4fc72cff333276837bca8c1d07c68b8e998d(
    *,
    auth_scheme: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1335758d04825d187b562166a0924dd15aafccbd650a4b0de83437775ea648bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73b57903633d4d093aba377c53e13ccddf6ef90f8dca539d91c1b724062128f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7761693208fc92b0655956223165ace2036c9d6fba5e5eec4fb05bed1f72283e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a092a6315823a0ddefa70919040ea15d298bca249ee9b571d223c3929e7fc5b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7003414c9f4fc451438f7783b4cb2a3f1d6881ad87ce9c607f201385e42ebf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdf49527ec185699bcb9fd51df3ef4014ded765776c576c22718e84b8760b90(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdAuthScheme],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13681fa134b1f1f2af66a9c163a1b0d72fa522e5f1edfe8612ccb6a84bd2cce1(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b402a2352227315bf1f4c65fe03663035ede8ba5dd8c0fdb11123a85bee7f6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc2e4f18c41096b98d5e5ef842832729941e4fbb5e45acad0cc4bf6cb8104ed3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8951cca75685e8f2417a290068fa1d15557f7ce1277ab36959355a341365bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ea3035df7989f9331b094dab5b6d7241e5066166ba89dbc17bc3bc294f3e62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b2cd0b6ae00c2020e6f7150927c72f904042d5d556c37c75073791b76fecce9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9ee857d09202040136e5a23a8a8e953d0d6f4754a98862d88bcfd899682324(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdIsAuthenticated],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec6143a18f125f021929047ad6b09422fab2388ac7d30aecc31fa2a0905c4f53(
    *,
    length: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a9c5ee1769bfd7339375316d933a9ed96d6f90d3e31bf176071afb0c5015bd3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e0a2029dbdaaab8e0930952732301cb2526f33377be158e267e8fbff17b01a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6040db7d1054e158e4339eb115322859206d5a1e73f9bf0671a8899051febad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2620c49ca8c6797564e74a3808ddca76d17d2ea48ee2e14ad1ea2b8d01cad7dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab7804a718a6fa30077d061e1aae36e8170dbc81efe8ffa05350a326ff8ade71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52e3126475d0054bed13be16d6af8658f83cbbf75557a7cbc9a306ef18bd3eac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ba4cf4fc2b5f3d42c435a3a3ee236b0f3d0079edda9214f3965d78644b4100f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f710f2207ba48f2ca98711a6b3937e2c0c69d0d86bbe495b76f7db0266e314(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEcmdUsername],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a58346228b5318bdd0f8abec4f5df6c930f9d46352d63d1c05d31c69a480e39(
    *,
    exec_status: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__433135b98818c304fb2da0d561cc16e1ba62249e5f58de28ecc1dc6c0cf648bd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0437c66467670c2b7f8c27ed27de71760eafa71843d95fb8013d25432ee100d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438598b3c68bf1f15501d2b4f95bc040670d3ada8c51506a8ce27460741bfb80(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11ab77c533352d319983b591fca4148d2294e5eddea757be47f5814eb8479a68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f47a221119c614a0bb1cf894dc502ea4ef806f67b275866753c57fcd7c3e704(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30c0a9fdfd0ac986ece4ce5b65ff2af711a5c7d9d8f1000397161d73cc475c9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionEdgeWorkersFailure],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3223c5e17274c1710524915dc3f001c57d9ce6511ce8a6fc0fb61c04fa248ba0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c539403ac226a4bda83cbb06b2258e2f8feed905e7ad88845d96f85d4081c6af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38e21371e75d1a80c0ff8d6092d3e0b6605e8c34bf695070255054c437bc1e5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51840a85792172b946eced2cb79b9ebfb6d27a6d9cf252bc76d125c9740d27b0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9fad485b1039262175a4c6092b4723a8abeaea75593c1b4fb8f5aa0ff7f2741(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c771b41e6b6674527b24ddcc79b46f6ef80cba6a24957997eb2a0a639ecf0f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__815ee64131392dbf81716e15f5560a308e90be2a601cf31141419c97f2b8da77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7da99ca0491778ac00ff5e44a380d923731c7cf04ad819c5a9f104a496860f9e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1a988b2eb4290b5da61aff017679af6a71ebe30b66b4ad418a459b9f138dac(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFileExtension],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365203d2e3bed6bc59a1e06f488fa266f4c0d758d7e26c2696beb7eb47fc086f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b941882eaa381eeabc8cd998cef3f5eb86846a215ef6601224613c9fbce242(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7a527c3199a68ecc22e5808ac188ef16971ee2a2e4f6779583298e82ddb663(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7d108def5574678c73cf4a0c03e449d61581c2e436517076d5111452d4aba8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4121f34de72a1899b0105e136440beb0f0f8106cdaf250c760b9ceadf89bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95cf1a74c3c415dc2f4f56b9272aa5aa0329a8ab5e49b3544b734e9879fcd6a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc0a662350facc8596d99f42b7b3314c821c0e80ed6205bb019fc0e8b6e468e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e148a604e5dd918ec41db2bfcaed644191a93cce23b22194300d43ca0c8c453e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ae1116e930ed091fdd4d1934c2f2bed4fd34a4d472f22625b10c6cb730572b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionFilename],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee40bbc14ec27538808b3f26482dc0fdddc4adb26b7a0d2fc1ca175772a04155(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__037872220dc68c32baa1da88f09c2cba354455581896046198b7cf4741833d79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee5b60188c229929efd7df1167ec083d63e941d7a8d16c5329595bf6c6323e1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39598b86974dbc7c077df68f2f8064076e34388809b279fc6443a1c8f1f1f08b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087766389c387a14c1192a390fdce8ecedf063caf92faec9edde9e0ef8387027(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd0904c0b6cf232d79f986bce6ee0885d78352b9d923281a7bb04fefd551e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b029ae6f9684f5c3138b1133dd9d4576891c49f7a7e2a6cf064b78ea98aa593a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7539de4800fa82e3ff247d803b6be06fc09c518257e509fb434233337f592c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93986e8d721270f2119d16610edbd09bfb4bac440dda819d2f3a4a6dcab4d5f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a1ce9346b148bb225fa4e94600435d08fe2a80024766deb1ee0dba41d1af07(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddff05f192779013ae2b0fc555dfb902050f0d9eddabb5b11ecd19a7fd7a7bba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca1f0e3b3e66f45e97cde3931059a6a1ff60344631f619b6cf33901756171d5(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1b5d005a6c614b0f4192fb1ecc577ca36f322d29a1caae6f21b8e88b960f675(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02241dfff6145a9e4114db028a2a3a06def4af69125e0178ff8cc140c1703603(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b45ec667ed3c2e970b19c22527e779599f40f4915fb4fd48cf2f622a65a00ebc(
    *,
    close_xml: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    open_xml: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb43d043c3d0e200fa21a20c0684bc283f59d0b6111417419693b7cf2b797f7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef39118d074d73396a7b507fb6e64df71750d9dd83a1e4b6763f7295038d1b68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcdd981486fda6de790f8479f98875891ec56f76d0a90041ba6cf519e3d72374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c729daf3404ff314684fcf2d655fe13c2585e23b6a0eecb90a0cb82dc0b24326(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7416ef2a8ac10d58702437ae4e6c3013db3e45a575f48f01459afdba4762ea9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36277fe020eb3d5d44058c92256ddc9a717e15e397961b3224aaceaf8d7d1f2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b701d766eec65af3b24f152313f925182851595afa629471589e1f89c63873(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab70450095646837985daed46559eb570dbcd7d4f521709f59f3f29489b9e78(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44648a7683c710076bb526af44636310d8059f44aa5215912ffe0a2e4d79c4c0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__824341202351834e9067085f8d704e8b6c69e80e6709dc02826ff0586c434bbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4714f7c6e048e42fb04df27adeddc47c0ac83fe2879dba6e13c38c87bb443b58(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__234bbbae3de75bac45eb49d1060fd24c35b0f03c5fbfa1642ec07d53cbe8bc11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14951db883006c758b41bad0c5905c95f78d11dd6b7977f483da4b709f6b0cb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b20f719ee1f56a49da403f4a01695f78e7b62161ec1a8dd5a931fd3422af682(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38989703191440b6f14dde57d8ac2aa44c4e7daaf92a096982bcb152b18bfdb(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ca2c9c056aa5fe6d3db6ee19bfb0145e8b81cb649f541cb3a1f7dc6490b0541(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43e60c10a69ca9e0c2da19849c9c27e5a76208a773ec365a11967e21b2a74fbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e7588b4482739175188a92096c318875426639a5605f7a4a26fddc3a6c41c4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0570bc4db73b975e4967724b69c88815f1668d8e43dcab39709a89b164c9bb53(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc122f06876c47d0419773f0dbc359a91e7e53450617a3c883d23ee28f033f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbf531cf4a4ac9c4d2b3a48bda94d0fefc09861b9988cfef96206c7c98559970(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27372efe83abece1014fa821da1d88f529f330e57a1849cf8d78630461c01018(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa120012ef95d55ab7f0b9a59ebeba248dd319b3f1fa7b56e2e31511970d0556(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e75aec55d9244b6ac88df07b634134799c40f52413767ff9ea8716315a72937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__279e8ae628a4098678b81e1d3ba7d9dcac88efa7f99ab8b63ab77b015b632149(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b660ce52a641828068e5d987b135d98e80297096ab44e4a1e22df8d79528294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6503a134333c1ab573ad2c3859dbfe25618d4752707e0d93677d626c45d6248f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a50eeb21269db302f8f46a068592e1772f940ddbe24e66fb0df62609ece010a1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62dc2ba40ae67b36e36cdf8582a040a9e875a9abf2e3fb51fe2fb00aed11d659(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff904c88a742cf01b8a55df7ad3d672916bff61aef3514705e77a6778641f66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aa18eb8c2e2ab50ca9e8a22b3ff6de51cd1b72420c0d3278e5e8571a6f7f707(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff92ee9643f392c8de6e02cf01d0a0ab48065948133f3f218528862c0cff36ff(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1cfc1d7edcc471d83ff0c72d29a9de8a6c11cb176abd0fa90f107f7a6b8a4aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6ae7cb57868afd3f6c91be72cb91e1a390c1c51621d505bfcff6d59a00222e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a7dde36b9211e18673bfe028991a213139bdf1b7161c710a66c49ffc590731(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b16e3d0406f8022e4c9d2bf23ec549ee55c9f9a7373a548cccb84c2d48bb5250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4b6f261e13753c7bbf183b5064a123c1beafdcd7dbf1be5fcb240c8572d9ee4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e915434320adec6b191046631928cd4ffe23c4169e655325421bd428f06b08b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41355c96137fc0bdcda9f399742cd12be520a86e5e719607e5c69c9c1911313d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[builtins.str] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_expression: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdba272b50fcc60467d57d5249a1e0faa662c51334fb293facedd01cf26a19ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5370a74dfe1846eac6fb1a73d9dcd8938206162a4f2a640caaab6a1c1f7448eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49de9ca9282a819071708b272677c0e25cab44bb8569b65bc0b087922f06348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a7d5786f317cc9149a10d0c13f25b55ae82d1f045051f1942e83f829d594562(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f69bb35e6a01d1e0f55d473c2c9275402a4c90a556d50db87388d22cea300d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28f2c6bb4a0bdf78cba84fa0b0ac1d63a4594b4fb2a2aeebc9e85b21b9696bca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e6b36b575b7c3c44de2a4a5ed73c92ee0d3779dba887d17b11b8643cbad48cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9046150b7bfbddd30d739d2892f3a7d9402fe15e323d1b35fc77d4c88dcdaed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88fa0551616f5bb429737c4b3838523b85f0446c9466c42ca784bd30e7a8ed05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd68aee251dcfbe696af98bed64c7aabd3b4a1caa494d2d26000ff7cb88d8545(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3320a3b9ed31501cb6df43d065ed119befd45e73a758ccff3b56484a56be075f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26f99eba44b2939f006df8d84e9e1c947c5149dbc1645e76559f53c7a15887a2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da3b64bc22e5f84bf2d9c06a59b49a213f6932aed780867b1296c4f605b60a48(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMatchVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c30d62f7ec466bc0cd9999739fb749fcda142d15b480dd3442edc78c6011c9a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85b73442bca6f0153695bce4e960de788d64bae1d309f125b79537e25c8b566(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40cdeee2c77682c224b34aea77e642ca4ff47f5819a1b8de79700c4da2961174(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14ecdd2b4575c9cef3faa9ef55663256fc7c217fae90cdf00e2dd75844d3d67b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2637eb4751442a3a6f5fa71248d7ff075b98ddfb9c0e11c001a96d3467ea895f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088507632c8bb17e28f7bc500715a5afe9c96d54f4a75abdd4434b1e5ac354bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7239583fa05df13bbe8a08cf2dc5d5139bf2bcb74a4097ee356bdfa0f78e161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f231fa33377216fddb35103a975972462593733a050651a0da90b803c7f6fb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionMetadataStage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c926d1e71e131a800d19b12950ce4d05a0481f9023867dddf5726702457cc0f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ec880a9e9872d5a9a4afd07bf885626424eeb7115d0fa9f8733ddd98898413(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e757ca09b296b6e1d1319c013d52997eb1b1ee86d678bef5d9672291162693e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7170d97606f67edd72784d6636ee13e2a7f94d0908cb0a49bc95b0dc464a02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f3c0606a3adf201d650c96ac7a7843adf6132a396524143a7b2c275b2dc10f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b30b0b0945bab723fa18cd9fcf4a24f6cc62d4cd131c4c6839ce0e9942b21e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2099e55299918e87dcd7bb2dee2b11aff87194ead0470ebb53eaa01dd6474703(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionOriginTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee77ffc5eb04b4b4cc646f05d48954749df56f07bea03b2a91b0ccf24766b59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaad3e54046b17eca4de0a296444235afcf52ed974eccdbcace0ad0d7e86ee29(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Criterion]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dcfad776d1c9c31b97e2dff6a6f845206de6010765600f8630a5e3ed419deeb(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9acfdeb370618e9482f10a2821b26f88a9fb028783d40141562b62e638be6ddf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8079a63bb2cb2b1e44ce0c6de9f56b2ae0dfc733fd1788210ae662a4973914(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cb2da081db8ff8a1b10fa4305809ef7fa1e1a3da40d861115ed39f910fa8957(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d05455aa9fbf4d6cf331ae77d13b94e6af3665a3ebbf542b54e81c73c059438e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e0a2c6b8199e9e0e4f6c06460ea15c88849f3999bb987639ddc093f4ff72c89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0c91c20ab58f98add4a2ad569635299bb7dedab3ee7ad991df3bacccc99dd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__836bd84b1d72e2ca37615d2a860e9505b0e32450b9795de721e9c302dff888d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4ee4c82eb0208b2a4bc901e839607866359c04345b9904686547f1256a271c1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58a03623a60b9e7eb781e106cd740b6aeb31807889d95340e288c79916c69530(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionPath],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abefeb638b4fa20159da4304a7883db82ae6027f8355f02910482c1222e1379b(
    *,
    escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b910049cc1a0fe041680931cee03f08aba5946ce57a6c2daf7beb11967c24fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071b3b8fda1cafac894876327b8934b37b5a67d5bd39f4972a422420c0ba478c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854d54ad93f5ead9ed6d875ec628f226d82e9bda641d3c03e6a03981eae44be9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448f67d0c2e04500efbe9fdb00e77b02323720c5b3bb831c4d74953451d47f02(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a346a0ecac42db01b4051711ca93b8bbf22026145577491c15f325ab32643ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93ead9e02d7017021b7142b37e0c9a562a59bec53f3f4248f2346c193beec876(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7c1e9a70f63a903947ff68169ec024e1bc03070ddde91a3c31863d633f468e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4656277434e64371771ead96cbc9bb8ddf39547e6ad0d777e1cf028cb27a96ea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fe868e62951e9b3c9df798286c3806ba91383d2899d5b0ad0e4b5f015735913(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd688bcf41a3a8445824c4202f20e64910f3de34466c81781e33d5dff45a933(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86c4f298775c14a26a94c3f1eb02f2874a33f0cbe7d3eb5d930c4c2e9cdc80a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59e05e02f4629d3092d66b86030b0011aa9525c04cf7113acad0ff9bf195b371(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22273e215724f63adacc3d58c18929c173d4b24a123df4659d0f07e7ffd73ac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49b59fb224cd62b72aae205c33e2a5bb9c14dae4ab4ca734b1a0164c9ad66a3a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b276d10fe53f2b304df824c8ffdab5d47f23109f7e9462c98c94010cff9dfd7f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionQueryStringParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43204be239efded693a0964fc3b11632f025fd968fa64a3659ddfba5511232a2(
    *,
    bucket: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__027d75376abd59c741036f0982be806bfd638312d1355916ddec7f138eb2ead8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5738d2ebe6096ccafe9197af649b33a0962b357defb16237f89cefe110491e5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2f64132f44d1098e40387fd3104bb40b2dc96e9fe07dcc82fe4103563370982(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d76fe02a69b413bc4ed67c233a904faf4f9b39849a431864653ae525578314d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c07e04311ab3df126a833b8504b37c1cdc97bbc3ce5e467f24e96e6799787f74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7d7ab34b7468ffe8f8de89449223742e08e82b0eb4d6fd6891bfa1a22dda827(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRandom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3113043db64192ecc602e2b3482bf6af0e6f7a179104ac561f6b3cf530f294e(
    *,
    config_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de8161c12947aa5eabc24e64220e2a91cf04a1ec91cc533038cd9a37848a595e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49de1320929f3638c0208e70b5dcf256b8a4b47bf106be99b32799862e741047(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e922cf8ecc93aad1b0e0ce76a6f35e71037bd46d10f79af89e88811aa2e20f9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d33e9e1581d438318b28491a7de5892d21c911782cb99dd3a4b33e80c8c43aa6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38c623521e1c55f153c6546bab9ed5602d6719f03deb487d991d1e1634582597(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4cbd899b44781f431a725af8fe9485a95e3b2332a25c39f629b914a263a9f21(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRecoveryConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0930640cba4842ba895c0a34c705a0a918b66ff3e1b57a88c0afe927aaf89381(
    *,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_string: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__090f42021a88ec2cd0b9d03a4672218714d5cf3bad86aff40fdd3ba2272d0428(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6d211d5413253acdb555a212e0298def2e8ab633a6d45f4bc2f133d4ff295a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8744d8a4ec1380a448ad31f85f118fa5303f1c6b52f02a29630e64ca77f30c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30db26d778e154181fc37a9eff60718c1911aee9c82e6a784840226e9b07cf8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4240ea4a7d458b23d2bd26d28fc12597980d4d32893f68a42a75a7cbd82312(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ccc0745d82a24b2d1da3e875a6e987d024b08f369b0b5e7c004e501589c72d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca1968a8dabcd8b24df63e440ee6d9327498f805a68753d4a7a80437b866144(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c07f3d199d05f5c60a409a0cdc63677767c9beddb0137542f0d0a930cc87db8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRegularExpression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fcaab576a1ca55e18aa4942dbabb5ffb21b1d52e86e3802248dbdc8ba9e14e9(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c274c663b77d08a0cf44d2019b3cf114de77dc1b708d86f8f93111bd083c7e13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c71896c6f4c3e8e1943b161db863233ee822dcdae3afa11d34303282087751e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e902cfa01699a0752a79c5eb3b101bec0c26eda237626e9a8aa244478cfed75(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc56dc0d28b1b01ff12df8eb5994bded3c041bada1c692732a1b85acbf26494e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__484ce593e98bf9457e338d66b14fac482687896c33580f4a8c04f705469d8012(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c2d19615c2765554a9ac07008b8a674b3e4f33c378d176adc2608dfe0da7be8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5bc49a6b3e3bee51cf37473cc5ba007229309bd465d2d3330ce2787914d686a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2469b834eda71cc28064429edb47d6e8647a2a98df00b1cd49e8b02323423c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2afbb81b1dc79727d052920340630ae0bfcd43d0755d32ed4a191e8b89a81e81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1c17a238b482635722050bae2e85439840429c7582243605666f4da960e5d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05a9b0f44762a7b69ca57665d373899190f27c7dfec31648ae86d59b8f5ae4ff(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9957d8b2f4cfc05a1130e1d90ca2b4b6c95c5447a4ebf233a65f4c0ff0581a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bcf4fce72bc7e6da0fca94c2e7c24deb6c25295bbc16d6bda557d04de284cf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c29df4930034e169fe57f017dd3f841563833ec8199387e17942276be5d2726(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54e006ade5fb3d9b2f3b56bfb20b2e267293d391b769eae18c55d7cda3a9bfdf(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d740611e44ab0bd8ebee37479b7e5931d4119c78b273f0369739fdb259984f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66acf236bbb17b5d9c1198d36d5683b0aab0b6aad2eed7080d484a1d79168eac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f5c5de4da78e0963afcf5c5c3087a5f4a357f8188a49886fd9ff3834cb460d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5337d9fcbe7994e4dd8e450d141c9bdbcd014f16991bd0591868dd8e8ef2c73(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7236670185b229399e97d61bab07d68a4b56dfb83863c1eb1b34fd86600890(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3d29d0ce8c16426a0db9dba863b8e84ffa49f61febfb9b7accbc8c25517b9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d504d279b273bfb02351562135bb65fa027be2f196d704b15769cdb40021dd70(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__302ea95b67b13af0c2782e3e425df14cee24e18e0dcb0d8a5230c480672a5650(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d51bed0d11374a0d46b82bf0a112e4b29eac2de6fcd7e59cfc0615b457be445(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9228a29947e3a2a4151ce92c01a154a711a561c2cd251ba0ac8a26cb6453e13c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ce1908c7b6e163817b852c4d448e5fa0b9f609bb4e6c5122ebba81ad8d7006(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7759e35b7558f32e5295a9ebc97807f1d70db5b71174efaa3027cf8a0ad7ea89(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e13f5b69bb6e701550e44bc8cf49b97a8966a8c960b3308ca940aabbfa66c890(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f65519df239c7e13fa16932230fede9f3f1f0ed054c99800cc831b2e3d51229(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94bd39f704cddb7c313618ca1af314727f5677c0abaa44aa5ebf7cb208cd46f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa88b8c05f7e65c6074e551b89ce611be32292f02ab226d4fe65ec3d4f3c61a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fd15d8a182b600f746034262818776521adc36892fe71c3d360ebbe0bb1a39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9158e78d8a1d51608d4ecd6bfc08eb4852001770fb937c652850c3136dc2447a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb2602a01b28d5a5fc4b6f19e6fe67198c5b89e7f42ecc8d46e92a3b6ace341(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e686e47911ed469df4563b045e264967b0ee5d4a6b66c678f4a38e9efc14f7ec(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ddd895ffcdd615763f6e49563f7555c509732be4ae672bdda94f4ec5be5ba5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45f439f055e11f7a22ed03d2729db6602a5a18d1a819972d63f9f02dc4d58af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c9d150aea2b741b79fdb406bf173f40b29de33d78d7b67523721976ebb99d29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2360f7e625b93168046dc9e5c2cf4e31a93389b41f0d6139e747e37187a9be2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e276b915d087f37c4788cb16dcde4433bf25dec026f0166052c343a130dd3ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26609f0a2da5fa5ef4e869b954d482b87bdd680288962c828388885d84286c6a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdca5be28c0a38aaf20de6e4a86afb220197abf333da7f11c44f3b28aacb14b4(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e532b694dd0f1d5945517558d542b5dba5d72ca8f62f3252c59802100c1c0cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eadf11cc9ea1d963ca8278b977df788912f0c8f157f2c7a1400baad3d8992a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479894a6c8da90f74e3c847ea433a642c16a414f870b71db441ff68939490b80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2761dc648d5389bb8f6581aed646a49b37850e23f5cc38fe92ac333285b1a022(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d86f011dbb30a5acac3674f4d0358ed13f84b88bc1882379e8dbce38578bef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ddefd728a65a9c91fc92b01b73cb60596f2e34cf7dd2980adb59773a37a141(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9f5e5268d75e0fefa0fa0f61ed4d13c3cfdae9ad45228a029985d0acff6e71e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionRequestType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f78191782e5c2f46460f20572831a34980e3423ce1b57c23af700c564c4366(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c40c56ed3cba22bd20c8cbf2f03491f2314a01d39b8d1763ffb0dc63dc6e2fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3c5133b8f34c8fd7cef771b8dc001a829ececaa8d150b52dbb6182ea685798(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a904f6fb3f7084e4cbf6fb4de0b6124b7de7efad65ed6c4e657209d186c9820(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c269b4b7d05431c3c07281b5861f5c4036e09d9fbc9dbd9c2f186ce4a50751(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b24666ff36e6d0a8d590f8658a614bfc06bf3bb03e2ac224537cb013d8b7bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a589077bcadd3999fe5ca27945ea677325d9b7eee729e64d1086e12b2a7611f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7042c1fa0c609844a13976e41af2d54b74530530d51cd89f90714d78366008e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f2cb1c3ab34543bd70c84160a57c40ecb0a86a4bd853c3427961107ad78404c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a36d66b52b81c5e4805eb6e9342bcc84ecaa20aa07655faa2445e91e3c02b80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5331b4237f8ad4ee492e25034552791fdd34f5d34523d9310ded8affad09b1d1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15924f0bfc304087fc4bef40a1cf17b22585a5afefd9675ea56dd69566e66453(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c75ed9db6bb9ade3097216580112a92c64ea5ffbe7dad8621d666d89637fa7a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af1a398941e0d0f6192e310000c7cbe2a1f6099e8d6638b51c50f5f466e584c4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e23a9734fd924c885ef281a6fc8d1080d0600d28791a2485b81e6321e14ee2(
    *,
    continents: typing.Optional[typing.Sequence[builtins.str]] = None,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    location_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aff9204fdb5ced838838bed1c08e6674862215d9e21eb8b69cde64848dcc6acf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7738ab82c7c92255c9f2d69b0b3f093686458cb47db5a7f356bf0db98ab8ae(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5de60aada533ba60531777b3d803100b5a0a8320c2f2a84ea3dc5f77f696d893(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cd95d2526fd1693df4f3222dfc08fac4144a75a27b0f1a76739e1fe7f8a08cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b7e428851126bf8fe492ba5ada0a0150fd327daf2674031e54802adc9a4fd90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de456f7f49507423e6bc1baa0f5162a7835b107af47452a7b6a539a8e1a4c8bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82589ed316e0e2469fbd5df9a841956116998f3a71eec59c4dc35602e4b70228(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b512d4f3cd037f4853b06c2efcf501d1519bc7bd12cc3b63d72e3a1f9f39326c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__936065b5b059eca2179b3f1ef885555da861208b34e8ca52b18115e52580eabc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a45f5daa6da60230deae897d64b4d8ce7b3a03721c44e43df4a781fc8e91186a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionServerLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec3ccf741a28edd928fe12595c1bb84d4ba9a027b8e842e9582c545ce1778e1d(
    *,
    apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    begin_date: typing.Optional[builtins.str] = None,
    end_date: typing.Optional[builtins.str] = None,
    lasting_date: typing.Optional[builtins.str] = None,
    lasting_duration: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    repeat_begin_date: typing.Optional[builtins.str] = None,
    repeat_duration: typing.Optional[builtins.str] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1228b7cc5ec1ba8331145901e2fd97245644b390ece23ae0bf3c0e5ffa7239d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6a2af7eecf1d3e305f614245843e9f8c99a1c6e5ae3f2062f03621fd9f350a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c0c07d861d447b0182ae5e8dc5cf728edd886c6b5f6ccb3b1c55c77746af64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eec38241d2463dc297c94e01af1cf433f08edb1080f876a97815bee49af6edc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2def321d5a2d1310f7c46d966f6973b07c03f50f6bd55d0a033d7fcbffb7ddb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd246460f97a7b9ff15cb63ce5a85000fb5ef25d7d329d745e624c9f88f957e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20201278ebdbefbb04e1ff7cbc179c06e7f7f0714f633f3863007ea0fce6ac38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f558e85dcacd07025ebd09064b81dc80ca5103c06b612ae633d214d175d252f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86e6b44c7b518646220d8c31ee7c2b87bc06b6496e5ea49c7305fed63ae0a40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b20d2acf75eea1831140f3df157ea9870835a40c518add8fb09a7a9d12af44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e3d05e1769e09a7de804115b66d6c4962956d064c67fd9549665b894548d5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00298052a832025d6703f52f99e748b3916cf83a7b7dd1188b314f03328c23ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57dd90be50eb1009c9f7f5a94a2183b2606d6ee4353b96d23450c2825b905e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3548f2066ed6201c1b35d68e49246011417aed867e816e8e2fc63cef79b017(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTime],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd22162a1c4fea32bde06dd9284f4a8dc52d8c29f6ac04add08991db856c6bd3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55eea89d05ee55ed586f9e821a3be341a64f087f194170f67b841933a81ee5f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__390b12a8853a41978c8b2a22304b95ee3a5c5f929600417c125978a7659f2404(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4afda8342590e0af3be81a766ba61a15428c91b203699b07fabb6e10d60a3f90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f743999439f16a9f02a5064453fe3a8ada56f218e377212ba75225b75236f95(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595d43c5ecfa11179edbfe3cab4fdf0fa3c4ec1337b3505b5e749fff50532564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c308aeb6285dc25a92f0dd856a130d4913e8356038708e3a39b7880682cae804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a04e4efe44ab6ffd30bc3097c2354749036e19a833a1d84efbe1a2b20eb66b6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a61265d35647758dd9c8ef22c18a7dd8d0f252e6aa0fef3d4596cd1e6d4d171(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d21160e4f35e1ca442d2d4686bcab1f6cfbcef531c859ac5d30f3c37501b1b64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f79036f550658fac60bb8f749783a5da1252c63f3299ed128ceba1079066543f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51dc4b543ace02edde351b2ce150af390f4d00791b62e85b197a1c74d1ab3df8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d65b816aa7e998edc8eac903ea463058bae8290b6f0220f17c60b88018fef1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc63feab28574135a1354b0a96d316fc7f1449622cd18c460e365eec534647ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503903690e59f38897f0223bac5efbbf1234caa6c53242333de806a6c9cb9217(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810635ba002c8e2361d2647165edd934ecad795fcc27572fb3aa132f23f7fb7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a7370ad4a40f0b41f0ae2280332094748e13fb7c7ca4f1dcf4c2ab9af9e83c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4bb088d30eac67993a68b47746240e4efae7e36b639756dd3b523ad4c3c563(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserAgent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__851a69fa52b59b7d9024979348c927594c8e0ab97a54e29731055bff73c115fb(
    *,
    check_ips: typing.Optional[builtins.str] = None,
    continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4839458b45b028fd7d4f59aa86f3f37d6c73afcee67f3972d9618a790221851b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c354818956ab5a5caddbc20dbdb4c7731712d17fb5196cd62562b4ce44ddc119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4554fb4b557344e6eb125096ef351e6f2977c8166c2cff81bfa533be30353b42(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44224206808122a7b331e38b68a527934d985f0aa3594c79d37eb811759bf226(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be6eccd425e2ddf5d0c680736b51fc235bcae0c5f498e6aac3e5384f826133e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b303193d31ddebfe49ae716b5ea768abda0fb613606f487e60d269fad978c6f6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced4a3a2785285632e47d1de80e45e7714cc32c13597e4ed5aefd2ff159cf07b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac52c6a1a9d70c12704bc1d9d62a71991af9db79ef26dfeb7fe5867443effae(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a63773d89edbc00d1184ca03b98b7454db5466fee66a4f5a0f850078e90d13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2492976d4732a38c12d361c5f1d629096eda42a80561a95e6b3b7585db848572(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37e5da16149469d73c8305aa4d7616ac9b7e958715cd8a70bd40f9269a9b85c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee8d6ceea729cfe8b0784beedd2a2157565e33cd9723956ffac71a6ee6c731ae(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4147eb4a9a5239494d2e20be8c4bbb27e53a23c35c0aeed7304b30f47600d03(
    *,
    bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    check_ips: typing.Optional[builtins.str] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19f4f2bd5688b8b71c7c6e0fbbc674d0e99877b95e139ae71e7f306398e9630(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df30f7fc707ac9f7ea080ebbf4b96b8fd505da7a170635089bc6cbb067e38190(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780364880f924acc09838a3b3d173a80e5dd1ef51f51b9013dfea39a4720a1f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f016e266a1d5a7f1508a01ff4f220701c49e8fb18e30c297bc056ec9a049582(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d62f29a1e71486a8b606e89ada4396155a62c586bce875a555b5e3afd7faada8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f3b2b43c500e0224be886728b3b33782f64e975fdd4604c71310788de6b9466(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b21809eed2bdeb434294207ca0a5882d7bcc60aeba268639098cb5800a00cf(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710d36928ded37f4e4b59c1f93cea7cf6cdd3ee4a1ae708f37cba96585c8bf73(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3224ceefb622535a63fc9a4dc164c702a97d8c1097e6db1fa600d4b549a40057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea3e506cfde9e6307a269110a001c6bebd327c6f3d28fa363794f245495d49d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e4138da55a3f94ca8d6cf265dd273671e742826227955525248e4fcd4fc877(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c66e11a34f3e01df8b3c6cb716d9b7281289dc5d315f0ff381fef57e2b759b6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionUserNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c35e300b5adcb802ee68ef90d556d30fad9963616d1f16b5b89c2d128c48d35(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce356f284022fe028498e9318f30bf6295a794d63bf30deae36750474ca390d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c57e7a8bc04f95311107e16717d8884746c0c63efcfd25820ae3218779500be7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c91586f643a8b1421916dcc99a0a36336a416b2a13e2728dc5d0f65328eb4f54(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2999a80198218d06b5589c8eed4736b88261fa4b28eeec269f9a6a76cdafe205(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__701b1ee4889dd7b5704f5fea2d6472514b1c90ba0061e31e7d458c6f73428f90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0089ea88d8e72cf6052ee42f464b327d09523277446ac496ee5c8d7d978dc857(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ad57953c53c7fc05492d551fd1dd8182b03d72e0a9a64664b7756d38c3f4ac(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVariableError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d21a0d9c7258ebbf6ba754ba5ff62913530f1f77b58f83c60f5f87d881e65882(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5bb9f8f3216b0ee0e97d10c027332fe3821f358bb2a96f3c189eb420e717128(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232ec2d50d0fa390589c90a94da1422980b056870d549b76e3113b32a522add3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b940e48900533d4f6c10e1b06f18907270ab26af25638fc3445a32346490ec9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66020d0ea48b87343e7dfe1257e31f978da7adfc229449a16ca99fc0b9c8841e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e43a35e08ea18b31954f0d42cbe08b5a87622df2a5733783e0f3a30c5cb3e7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b43ad24caf345ac3ab7d5f09825d6de2654bab005e39846d67ec666e1f0734e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f00404a7806fe2f4afdfd855163c0399649ad0f9306433d7f3c1323b13b6b3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVirtualWaitingRoomRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26ece697e873c706307c7916f587686132018ddd58eaa5807c069b815757b90b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ebb7c34ae35286608060d58c74b55beacb499c3c46f031f646b32bb9197bc3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c20c4c1505fcbb1004cdd86674a5a4342fce774e82a262ee054599f34c856e3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d880119342e91c5c0149ae4bf190ddc46049ef62368f177ab83b77758e06d1e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0c8eb9e640bc3297e09ac8cfdd5c6a8e8838532a34420ac838e0acdd2fcaaa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db26a1669de6a90f683a43c0319895654407eae2c784fa8f47bd66b177e860f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c793acdc55e4199ce55ef36278a74ae0cb5184b4afd8b553797f3338c2aed95f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__405b5db98e7ee2b0649db7f656bedda19407c7376decc31b8d3499dc6f7b3409(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CriterionVisitorPrioritizationRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59305e96f688eae3550755c2cc94a2e994943335704903966d37840fb346a9f9(
    *,
    name: typing.Optional[builtins.str] = None,
    override_id: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8059dc97fa88e1e096d62d06b600c7331ee3f2523fa909dce5f4592ad25127a7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ddecab2e844abfecf069b399019f0db4f2fa450e3e1c34800414371ce39963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba136a876997b0261417249088bd50cef073d823d517dca61fb9b4bcf48baaed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f22a9580aeb56717fffe91686769bcfcfd7c9fba2f69e299613d0f6119370236(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920CustomOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac923e3b9a4b53417222dd06368f360c9d387860e76fc5742132b0f8c2b9fd6a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3d2b63c351a75a7072bfb05b0788fa8971b979131eff2c2d98d28216e83e85(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Behavior, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd07f4f67656309e9a4ddf04bce737a041842ce9a7a67282f656db363923915(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Criterion, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e53b42881bf067ae4ece224c714e3950915303194d0d70ee505c4f6c0ac6fc79(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20230920Variable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__355f18469459e46882c6781304a8309a5ccf4a69e1b7c974a7dfe3aa0a740b5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b61b2ec042a707fceae66f35bd07c5cc9a24c3e16e73dc488a3f985be2ca7c06(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d12cb5f458244351ecd850f4884ad31fb0fce75fea3ff5ec6872433b1ec9d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ed60ccc8d005f5321b5d8c6c7c84217e84544366eec6234beb542ab4660b07(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d10e7af5153d8af3fe020d1fe289acd8fee6a580a1bf9899102af7ada011bbbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1669190c3313fd50e412780a687fb9247f1b1a94c43856a3bc8a46f0b509e7f8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ee01b4a6be7ddca93eb3f1d22155284bcda1acb355f09abf5a0cac66039907(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b8f6d1327313f32cab219d0b8e247ff0a3e8a01e794fe9a9ad49ce36b17cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f28aa9ac9db79e0cdd5629ab25f6d88ba96ead3ebb989c9fcd896acac4ed38f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__633eff46f8a3d2fccb5122a9dc5eea2ddb8da22bb88933f197475af1d26f322f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daf745fd637075965bd4fce8f8dae3db7f6a2b221717bdac94c741685348c04d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20230920],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1343e67cbf9c4bb1bcea1f1f4367b14a918f3c300d3271ea43018891933e4714(
    *,
    description: builtins.str,
    hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    name: builtins.str,
    sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7315664288a75cb0e3db8f37d0f4a86939c5eec920ec492105612b5568235e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8cd1ba1d0412fee9ec922401fd07960a704f119dffcf6e25884fa5b0d2bef5b(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6c6718fb3a2d49252bc529305dbe6a8a2812009472fc0e7c8d852bdcf37bb2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8625aac0bde3761354bc4fe55612ae99631d0c8314131e9252fe831ff117ac6f(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__148d42c5bc14d9baa4c148415a74c74a5bd2b8410dfe8764ca2211b8b91311f1(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb242462183b9d7fb82ed1cccdc009d3a18834099dc5305f7394ad3ca40fa232(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20230920Variable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8bf658fb53d1a92e950b8e931e4a1d52b462b9264b6331709f4084a37a4ead(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465bfef6b7731d4bf0d021a4773072c3a06bec93c40be12b82f7f7b8709cb402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e40497a93c8f92f2bf22f0851b0b6c3376832313fba1f6e963c1457de31a9cff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e824e948990d5d91dfeb5cc50edcad63e2b9c7ccb9828c81ff68463395110a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ebe83a6054c24b0ee3447e00ffef57f068f5501354220ca1ff3dc6b0965506(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adfcb020e60b8188186132687e685ce8f856e816e4ed90007579e05530004569(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af8113c142451918f7df49edae9a5e23413b1a4f7bad90518c395e5fca2042b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20230920Variable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4daed88e35767fc6da1ff666a02b4c20f683bf501a821f8a1957d13bb7ee65b(
    *,
    name: builtins.str,
    advanced_override: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior, typing.Dict[builtins.str, typing.Any]]]]] = None,
    children: typing.Optional[typing.Sequence[builtins.str]] = None,
    comments: typing.Optional[builtins.str] = None,
    criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    criteria_must_satisfy: typing.Optional[builtins.str] = None,
    criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_link: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Variable, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8742c5d9d50c43e43359fe4934fc34fb1e92e23b157e9391a62a8f0e1d3a6ee(
    *,
    adaptive_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    adaptive_image_compression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression, typing.Dict[builtins.str, typing.Any]]] = None,
    ad_scaler_circuit_breaker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker, typing.Dict[builtins.str, typing.Any]]] = None,
    advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    aggregated_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag, typing.Dict[builtins.str, typing.Any]]] = None,
    all_http_in_cache_hierarchy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_cloudlets_origins: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_delete: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_cache_key_sharing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_downgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_options: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_patch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_put: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_transfer_encoding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding, typing.Dict[builtins.str, typing.Any]]] = None,
    alt_svc_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    api_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    application_load_balancer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer, typing.Dict[builtins.str, typing.Any]]] = None,
    audience_segmentation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation, typing.Dict[builtins.str, typing.Any]]] = None,
    auto_domain_validation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation, typing.Dict[builtins.str, typing.Any]]] = None,
    base_directory: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory, typing.Dict[builtins.str, typing.Any]]] = None,
    boss_beaconing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing, typing.Dict[builtins.str, typing.Any]]] = None,
    breadcrumbs: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs, typing.Dict[builtins.str, typing.Any]]] = None,
    break_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    brotli: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_ignore_case: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_query_params: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag_visible: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible, typing.Dict[builtins.str, typing.Any]]] = None,
    caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    central_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    chase_redirects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    client_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_interconnects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    common_media_client_data: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData, typing.Dict[builtins.str, typing.Any]]] = None,
    conditional_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    construct_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_amd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_dd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_large_file: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_live: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_vod: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod, typing.Dict[builtins.str, typing.Any]]] = None,
    content_pre_position: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition, typing.Dict[builtins.str, typing.Any]]] = None,
    content_targeting_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    cors_support: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    custom_behavior: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior, typing.Dict[builtins.str, typing.Any]]] = None,
    datastream: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_hmac_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_regex_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_substring_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_variable_extractor: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_default_authz_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_dev_relations: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_real_time_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    delivery_receipt: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_direct_failover_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_async_refresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_prefresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    downgrade_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    download_complete_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    download_notification: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification, typing.Dict[builtins.str, typing.Any]]] = None,
    downstream_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_web_content: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_bulk_upload: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_database: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_dataset: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_object_key: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_connect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_data_center: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_origin_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_redirector: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_scape: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_side_includes: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_worker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker, typing.Dict[builtins.str, typing.Any]]] = None,
    enforce_mtls_settings: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_akamai_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_proxy_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    epd_forward_header_enrichment: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment, typing.Dict[builtins.str, typing.Any]]] = None,
    fail_action: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction, typing.Dict[builtins.str, typing.Any]]] = None,
    failover_bot_manager_feature_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    fast_invalidate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate, typing.Dict[builtins.str, typing.Any]]] = None,
    fips: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing_plus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus, typing.Dict[builtins.str, typing.Any]]] = None,
    forward_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    g2_oheader: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader, typing.Dict[builtins.str, typing.Any]]] = None,
    global_request_number: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber, typing.Dict[builtins.str, typing.Any]]] = None,
    graphql_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    gzip_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    hd_data_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    health_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    hsaf_eip_binding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding, typing.Dict[builtins.str, typing.Any]]] = None,
    http2: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2, typing.Dict[builtins.str, typing.Any]]] = None,
    http3: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3, typing.Dict[builtins.str, typing.Any]]] = None,
    http_strict_transport_security: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity, typing.Dict[builtins.str, typing.Any]]] = None,
    http_to_https_upgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade, typing.Dict[builtins.str, typing.Any]]] = None,
    image_and_video_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager_video: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo, typing.Dict[builtins.str, typing.Any]]] = None,
    im_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    include: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude, typing.Dict[builtins.str, typing.Any]]] = None,
    instant: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant, typing.Dict[builtins.str, typing.Any]]] = None,
    instant_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    limit_bit_rate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate, typing.Dict[builtins.str, typing.Any]]] = None,
    log_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_personalization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_rerouting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting, typing.Dict[builtins.str, typing.Any]]] = None,
    manual_server_push: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration_quic_optout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout, typing.Dict[builtins.str, typing.Any]]] = None,
    media_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient, typing.Dict[builtins.str, typing.Any]]] = None,
    media_file_retrieval_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    media_origin_failover: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    mobile_sdk_performance: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_via_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    m_pulse: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse, typing.Dict[builtins.str, typing.Any]]] = None,
    origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics_wsd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_ip_acl: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl, typing.Dict[builtins.str, typing.Any]]] = None,
    permissions_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_client_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    personally_identifiable_information: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation, typing.Dict[builtins.str, typing.Any]]] = None,
    phased_release: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease, typing.Dict[builtins.str, typing.Any]]] = None,
    preconnect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_content_delivery: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_prefetching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetchable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable, typing.Dict[builtins.str, typing.Any]]] = None,
    prefresh_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache, typing.Dict[builtins.str, typing.Any]]] = None,
    quality: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality, typing.Dict[builtins.str, typing.Any]]] = None,
    quic_beta: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta, typing.Dict[builtins.str, typing.Any]]] = None,
    random_seek: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek, typing.Dict[builtins.str, typing.Any]]] = None,
    rapid: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid, typing.Dict[builtins.str, typing.Any]]] = None,
    read_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    real_time_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    real_user_monitoring: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring, typing.Dict[builtins.str, typing.Any]]] = None,
    redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    redirectplus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus, typing.Dict[builtins.str, typing.Any]]] = None,
    referer_checking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_query_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_vary: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary, typing.Dict[builtins.str, typing.Any]]] = None,
    report: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport, typing.Dict[builtins.str, typing.Any]]] = None,
    request_client_hints: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints, typing.Dict[builtins.str, typing.Any]]] = None,
    request_control: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer_extended_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    response_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    restrict_object_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    return_cache_status: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus, typing.Dict[builtins.str, typing.Any]]] = None,
    rewrite_url: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl, typing.Dict[builtins.str, typing.Any]]] = None,
    rum_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    saas_definitions: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    save_post_dca_processing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing, typing.Dict[builtins.str, typing.Any]]] = None,
    schedule_invalidation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation, typing.Dict[builtins.str, typing.Any]]] = None,
    script_management: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_content_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_streaming_prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    set_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    simulate_error_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode, typing.Dict[builtins.str, typing.Any]]] = None,
    site_shield: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    strict_header_parsing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing, typing.Dict[builtins.str, typing.Any]]] = None,
    sub_customer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer, typing.Dict[builtins.str, typing.Any]]] = None,
    sure_route: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute, typing.Dict[builtins.str, typing.Any]]] = None,
    tcp_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    tea_leaf: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_customization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization, typing.Dict[builtins.str, typing.Any]]] = None,
    timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    uid_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    validate_entity_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token_for_dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo_standalone: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone, typing.Dict[builtins.str, typing.Any]]] = None,
    watermarking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking, typing.Dict[builtins.str, typing.Any]]] = None,
    web_application_firewall: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall, typing.Dict[builtins.str, typing.Any]]] = None,
    webdav: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav, typing.Dict[builtins.str, typing.Any]]] = None,
    web_sockets: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f26a6cef6b3de75eedc143f335b2936322cd38b2553975437b5f4f07edec18c(
    *,
    fallback_action_response_code_based: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_codes: typing.Optional[builtins.str] = None,
    response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_delay_threshold: typing.Optional[builtins.str] = None,
    return_error_response_code_based: typing.Optional[builtins.str] = None,
    specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccfa4c6691a094289f1e30de935836a8b7c3af5f9265001cef58ceeb9974dd0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__293421fa67e3a9f452c58bdffc24843b58cc28854b8c6331c5ba512a2915c6f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb306f2ac5674f8949895b15dab3349e17ddc136a48810788750f0d8f7257a1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c1ff241bad1252dd5fed419333357b759663eef904ac677d650b2cc38a0e4d4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__405a6fa7fd82d03cd6baf8cfa13c52341c00ec845ebffb07c3f1e86be358b1c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8643dc38102748f7be9434037348c01f614539d5fdbe8a17e3ffaf879e5cce0c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a06c27547d8cadd1ad1a297fe9c28e181a5499ff27addb56167d202971e370(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c33d4a0ea60f2f8baef5f3679f5d069973cca34a311202d9e23d7634b750295(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312ab6dd9d844fe8493b2d6208a888aede29203f44fd3d88994a1c67748ccfbb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a692a21f64e6b0a923b5795aa11fbfb429a4c7e8aa69a66890f1b25286f7fd97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8084402be6dc2f50a1fb61aa63a9ee4b64a73d68cd0baa9cf17b8b1c362f58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecdf01817becd38aed4b6b73305b2387fad00c67971f39886bf589ecff8b6736(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdScalerCircuitBreaker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f86e2240a2b92204d3bccf27823272a2558089025c7ef182d920ae88dc62978(
    *,
    ab_logic: typing.Optional[builtins.str] = None,
    ab_testing: typing.Optional[builtins.str] = None,
    compression: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    source: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_brotli: typing.Optional[builtins.str] = None,
    title_http2_server_push: typing.Optional[builtins.str] = None,
    title_preconnect: typing.Optional[builtins.str] = None,
    title_preload: typing.Optional[builtins.str] = None,
    title_ro: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d18edce92e300c58d5edfb8cba50ff667e3139012cccba5ac58aca8a9c06edf1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e60dcd65bac733d531e43a784998bd2333b38fb0f31cb31acfc5c4a1e43ee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb609b5e8f8de101e1854940dd268f50435be27bcceb2288e1af16278c3f2605(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0094bc3b2f06613e7d0dee8e5f755138be480c595135b7377f6cbe7f6f1bf9ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f57f9c598a37ea75952358b7b3349069a9bdd5f2f8aad555059eb0b00b05ff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85ab9e9f0dd3c8edc268f6cad1e1819ef5630b01650378d79871cf8d78d53f70(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffe35ac9de0f9c54649edba9278bd45fae783bf7ca0c589b2b9183070df5b638(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1a9df73e51e233cde46c03124cd6ddee856cbcfb30c9dbe30d663dc4695625(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa16f748548d30fc7fc0ef4923a84fd19dadc035476f78689abea7bbaa3941b1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c68137575e35c29c8a21a900d35208e10f6d995c12d8b82231fc55b558618dfa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fda7de0ab64e64fcbcfcf8fbb334dc9a6faeabb76b9863d244a3cea5c8ca3c4a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0907dce32b283c1adef66f025f860b28c082789ce46a1b4896c2fe07587aa6c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b380eb7096c01e3fab7531a24a1948f467e8c458225ec9050a7e43851897b48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__912e8eeb09e0900a749aaa416576e919f406cc31315d28b199ed6828192f8e85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13cd113e45f2d3822dddc6f5cd47a8da71e0f4686ddb77917ca2ad1b1bc2affb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef540f3a55564d5c9b8a8faf17ee92a323afa00dd8931f154e37abba36cc8aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c40ec9ca88ab48a3c49d41e0984fe6572040c792a25f61f927af13a33de8f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5b9a84794bb547d29fefbded39dab970cd502abd937ddf3bcb4df62217c1946(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a299ae352cd4eabcd6fe0213c09eb8e8bf6392f1f9bc684438270a3448e410a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c07007f6fbe293b4e23abc1e4bcebf21c5e6e1d06aa581c33154dbb432f0c0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb158d874281c31d3b02df0755a76f0ec2434b2c4ec3a8a61a48bd08add498d1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1ab27123b375134dce62fec2cbbab364b0997c5f645db977a98f6d1f30356bc(
    *,
    compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier1_standard_compression_method: typing.Optional[builtins.str] = None,
    tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier2_standard_compression_method: typing.Optional[builtins.str] = None,
    tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier3_standard_compression_method: typing.Optional[builtins.str] = None,
    tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
    title_aic_mobile: typing.Optional[builtins.str] = None,
    title_aic_nonmobile: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18fd0a4bd54a29b7b44b43ac0cad0c899e323381cdef42f403d4212ff1e57d71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02347451de4dd0b7d60dd4d55d5288a918ce9df049acb96f339465418ff18ee3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d41a28039a0967617ebbd6d933b14680df59e795c77d7e6d2ee0c727ae9afd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e53f6bb2e80e318885c043ce5101e6cda0b916bd60cbb82abb6aed5416312544(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c60764e8b7c9469f2aacc7874e39d558c51e5133a839764677d1b8e73d02090f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1eaa4d2afd88d7ffc65771b76bcae6975f17764f89300086166f26a18c2810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23620b22815bf1d01923781d0d16a8d63f72a8f83a2d868ac8eb3f404b979f90(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee83f8cd599bde6ca89faa3c6c7283f86460537a420ace7030441fc6408b2eb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed04104a83b3775351b61254d493e1e8d68ec00e544d1ccccea3800244e69fe2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d46fbdd4a9dbfc9a4b37309b401aff77e9e5763e300c5346b6d5d64a0062c25f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e7789b67d44bdb3fc5d5045aecae9cacecdec44be13d64986e586922d644d1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62f7e7d4cfac2f1f1449334b4cacae028e4508c492380359a44748b5c41d374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3058454aee17859a3c763b46553608921ced014e73a894b3e9cf3c441bd45114(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a49f335d575744450fb2d8f5ab97d8bd2ebed84f0d47743b69253ec79105d25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a40c2a4f67ee36d2044d4d1bf3a42bc59a443df2a21c3bd503e6d2af9bbe73d4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f8aa9e09c248ab6943e63911d442461c066ca60e879669850debd45ef55b5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed32729bb5fe24babf156d9d9935bfeee94775908b2c689ee4d88fcbc3cd2365(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4243e96550b5a86fcb41e11711558f65cf5dbffc8c7786f0e13fc6ed9df1f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23aad0bc71039bbdda1ec71123a2534c5fd32d7e1b9b0ef61c8e4047f848693e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55efecf2f909249c5527d218f41686cfc011369f4ab644a01d24456782810124(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32c1e349ac835b7e8368640df856348064738cc1744975ca811103d9f266a85(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdaptiveImageCompression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04422e6f71f1eefed8611f8a78ada829eac556d256a1e8cc91ebfbd828c172c1(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4301deb2e3703d2d334463775fe7353e16d8f875ac4906d6d6857ad6a27bb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b29b8867448315174b0c8568d281cff23b3939a9b299cb06118813f513c8874(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__362e9d67acc2610654460ce429ae3ca8a45ce3d2eea54448b61297c7c6e102e7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__796201c0576c896b6fa1a77ffe9f2b98a658c7e9d38ad01b3f948a0edf3e5272(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ca9c107e4634f00e77bf991369f050a5ea4b98b2974a52d9d243520f2b7462(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52b77e78b072a9aab8a174b3b19cb66736abe949a54ef9493e1c7477e8f5d4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62a2d9e6507e3df061a613a013682d57f7a4b497b9b59abc4a702fba86ba9b8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99cf3bc28b9c6673050800452339e2417b3f7dea204a1261b4d5ddbb2347efea(
    *,
    attribute1: typing.Optional[builtins.str] = None,
    attribute2: typing.Optional[builtins.str] = None,
    attribute3: typing.Optional[builtins.str] = None,
    attribute4: typing.Optional[builtins.str] = None,
    attributes_count: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    report_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9d4e7c9dd4b1b130cfd132a7f1f7b129c4ac35f5fbcf1611d7df00b6c580b07(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30f35e121b78a4b68f50bda101514056fc3c948624feb67bb1ea65dbc344199c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0735db994535304f7d498b07d899677bd4e9d0e46baf8f26af88d8106deded09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fd407ba0f1467754e9c6f27e34d04ac523fffa68190445dc049610d3c0c9393(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac9b5e904c3ca70ea98c771985a37c413da3e83a6360a7a9cacb89008c9bf5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb61eecf2a6b88a71852f12a406fd9fc4fbd2ea418c209be813e46f26a7b321(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9eecbd8b43798cd5631c630567bd84dfdc69a2b28d6708c08ef759f0d07bad5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca0838c3d94e454f8a942c4075a2a4afbea9d1be3844896df78d9698242ab719(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3146595f7ca839bf6485fb2adae7726363ba89c2e095109df6b895ba14c31796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079b1f746338f4d2c20e32c471ee54a9bd99a29a629c8c9527f04ab57cbdc629(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa717fcbf1b88eb3dfc84180975b684abd01156d79ef6bca637ec8b79a62eed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef807e826d2a389b6a2ef35941eb6a43a3b16e73bd16200c7f06e5cf206e283(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAggregatedReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7dfee5ae5392cefeaa95afa3ba4b1e883aa1419a882390751770435dd2946dc(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f98f458c109cdd50c665596bf2d4f2fa7c55401551fed8f539edf7a2e2878f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fe74121df81d7c7adfb706245b8f025b6739b6c1ff89306d71fed668b8ed866(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__142cca7226a5a1cd7f5582782db8216ebcb78ea7432ab3e0c1bf50451ca116b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884b0774899b12c9d5a3456edd662bdc309ac347cc36bb9b034d76542bf44d87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25539e441800c936da7d842e0dc2cfdae962a1af589491ab2c469b9a15471ed1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1716b5dc2ea478d2a553f563f43a4227b7fa801f7a98b6ab873b026acd798ebd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ce3cbbe48508930f178711b9f8a67008fca5a659440dee84cd5e81f1725863(
    *,
    include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_hostname: typing.Optional[builtins.str] = None,
    replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    replacement_hostname: typing.Optional[builtins.str] = None,
    scope: typing.Optional[builtins.str] = None,
    tags_attribute: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bc320c35a725c5ac0d448817a31e96e15eae05a92b1b3d6f4dee6e4ebc11e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77b45f0a5371233e5ab21b4f3237efd879017cb3f3a5aeb6635545c142582a6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d66e593b7af3eccbd35fea30d409d29199fdce581002fc66a04e9bfad7da752(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__678aa88deb661a8dd2a358098d1d913974310bce10b364f8b114ca6fef046d1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f47b40172767368e3fc4fd840a97528eaaeb4efb2d4ca00544954ae59b9e98(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b7a8b85922fab6c815ffd32eb399456505446533339ab025690b58f1713996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2e5e0da3aa66b3ef3ff6b5126ba4b7b75c695658ed58ed6fa785c24fac9ad3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1f5e61ae086f1b8a66f0452ea2fd01cc4d75960b1c91818e9fa9f55853cb7cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceeb334937cd6f57601fe960e9531f2d1a107c3c33aeda27f6831d8bca9ff62b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__752b31c5f00f324bce017134f41b86dc7e59d06b97148a8b1a67f7df67116251(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1186cd7a7341ac66efda90a9c5956a021c132b4e7f35ecb0d628fd19d10c87d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAkamaizerTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab28b9466b4de1a1c5dadf0d9a57275966f2c29d3fc4ed5318c8f7cecc3a8adb(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b555b9c07bc9de947e5e6ba7feb3d0db0ce65f7b16e47092948037554e5f70ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc2c7b27d66594f221929f9a3e713c3d46d09a9aa0850241debee0d2388d572(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b38a24c6817788517b4345a351ebc5d9c62dd4557ccad7848a77fb7c803a1f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b25f844f868fb8e93a598478875775023166e23247b0b007432fae3ef786c0f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8dc02fcd91a7fef97624c560868adda92f333d893f3c25c07d8ca2cdfc60e03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84384819c6ca5f1c126825b44746a12f8d6aa5e9969077bdcc2bff14f3eb709a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllHttpInCacheHierarchy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d086f45e6377a96a8f33ecc199ac14efdbb4105f0c30bd1248819b35da914215(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_origin_query_parameter: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1d03bf5afa8511f31ec5b2ca9743224a26afc53999d92ae57b44e74c7ccb913(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4859845f4e240aeb85f5b64a1ed8014d494b89266876191d25c15fd8824a83b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__207eb18e325a89824a2a4bce63c79a8a409bb0b6443d5c3a5a91fdf371b46227(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07bb0a64138f9306eb91f0c300b2ee4d6f791c4d19b9bd375fc37c6fa450171b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6813be728bb42c254b5fab2c0cf3bc0872ada7b5fc2d48e7d54585f14c9b0f68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e40d0f74b78397f3d18a1082608ee354385409969bdf5919207748a5b40f95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903896768a2311b4c1c256b403d61435df2f0cfb494bee2e0fa68c8395c1abe6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0810646fc37f3842a4e7a303a58f11e55c6f3f8d635eefebb0933f0e53bd5e58(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowCloudletsOrigins],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1d5b58cf589b72d0e3870dff2aeee9dd92c903858ad4a8a3724c348fa6338d(
    *,
    allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d1c8819dc4f1e4ada98b2624086a8ed673d0e419ad179501634bb136820f10a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__842b66352efe3d152e8e263e9bf2f5656faa1397d134bab2bd77d2ca30cf6ab6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc8eaacc933af216b3e9ff2c74d8b1e5134b5939e01ce1f94754a56381c28ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f3f5b186533dd13be79ae935060e093f396bf860b6cdf4e96105b564d394ca4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d286acdf7a9507712e61e3737cdf21ff1ac969a1cc41d7a34ebc27262d9b5fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208a61bf7b255aa6c4259c6f76f1f56303e399e963b9cec287934301f977c75c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e12b5f13080796960360eee32fbc4760caae4bfa4c0ccfd6af66d54c44492f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowDelete],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe984fef3a9e6734e1d3c28f95f6e3dfa07489203c1f823454926ef09908e282(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8f2d17cca8efafb13459aba88dcf95a31b5eaa5b063e049c83e58beb3a83c0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590979185fa0e0c2cae3c1884d42b3241b78fad9d001a3a0faeb2aa4af6b0579(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a0d212b91f622601559c007faeffd9aa5ebe9e352a2ece381aa2b3a930d2ffb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f237249f170a806aff750873d5fb89b4ac54badc8862b4b7b7ece78cbdc5d662(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__654bec9d28acd72cdecbc396690f8f7e43f2baf03aad96ab8830e614b57dc75e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b0ff326817b5560a8424a3474f85c4607966e09957d946c17488a3cf71db979(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsCacheKeySharing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7d10b555eb4d5662e166a1e500c71037ab4ec7d1369da1d171bc4baf9622965(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9738dc507c418a143b6bf65ac03c3eb94545e4d51e0444804c3353de3774572(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6cd06b8dc08b6496242a1e2df98ab92c2a3a03b07c3d349e74e8c2e3d4140f3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b263e8ec27ba9e71cedf9c3e00efc457d08504bc8185cebea9e5d7664a09ccd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__049bd9dbae8852d1bae11f54e3d82cd38247433be1c86368021730a8af9b40b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a16ed4358383561772d45e13904bdaba817d144157ae2889dfaaa83e1aa254c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a11624c2b33fd3748b9d204294032d007e8c13dc82383f21d6ff91dd841e010(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowHttpsDowngrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a51135023333dd363b4d07504c73c6b4ae07e6ce5496d2f140c62c6f76518f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5101e571d04600870b1521095c545a0dd74d3cd5e2c0875b401dd81cf0d50f57(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db93b8664fc0d67f3d85a20fe58a7b474982eaeff265995dcdf5b2bc2a2f3093(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85057fd098501b8daacc7d2032bc36299301885dfe0079f16e8e174c9fde72ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1075babd217e78cecd63f7c8adf24a2580ff79d2bf671f89ad22c800f3b8c491(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c1ffbffc0a13b6467a69c746e1499be3584cc8a96332a719a7b5dedd5b7b485(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8aafd711e5198a2e454620004c3a9822598653723ea935cea0f274370f35f62(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowOptions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9d6f58ca72c05c0e9e25f3cbaaf7f8f5ccdc1be542300e09d66e76672c8c20(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f18e03d95f268a220af5779173c4cd4be9b775f826fa44d26abbdc455a553b93(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe7738c8d5e995e4e83ef383b74a7cb7ad06b73ac17197c12c2994be2ed8af7b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4daae92d669b9119336bc3b521840d95ad9daf66697c43354481900d875aa4ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baceced04f5f10288e3cb8e5e2045936274d74b09d04ad21fb153c92e017cfda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3364b1e9f7718f7399150e87944e4539a0042d4a65ac64ffb4fb354c7cc58cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4d8002e7817c5e18a10d76f33043f86ee23531745a22560270f36786644384(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6a765cbc56e9ffa7ba968e5966e8bb646d584abdc7cfdbb63b0ed7bf92497ad(
    *,
    allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a14bd8d348b4903bc4077bd079c40ff0d634d55dbe5c48e10c6e84dd229136f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf2adff7ab6f33d319787e7b1e69c079cd3a1e78ea2225c0d7addf6a470d7d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82fd476482b9751c843d61a6895bdf4312930192deabe85406c297ea64abc59d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446e577bb5de05b0418168808faff789bb8f7e35c126e043cada4a6e347a0322(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__889624f71d21b9151ad086a8bea0b7ad81b545c28a5594eccca2dbaec4689525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c3f7d6d1cca5ab48347c1d3707fd80b26d3f6654944d3bee29c5c46f07db63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec1e3e8965a4251cfc5d3a202243a0d39052025af91b2fb215c517d8bb59388f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19b4582e4d0f22a87be9769bc8c4b8bf63979cc224233b04c426dbe694a073f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee286d79e9f2e4e0eab6db3c5518075e79e1547111375b12b0cb6318a97c5639(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b4b3aebb38b31f59755429013d8c40da2183ad8b59723ee8383e5d2cd667e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9a622ab905e323330634f9fc418a66798932477a441c2279314ca5ec1c08f7b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a6327556b1683bb746e2a4e059a97f873c38fe9d6b173c180e4f570ec23f9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c75be5c8a7c4403d8c93bc2605d2454b6ac80de6edc8fef1dd3e5967dd079a84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b188b20c57f24104919e7a03f284e1aedd4e292a9a5ec199e173bed56ef523(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowPut],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbdfba31d87aa06fc5a3a8cec07e4e26a388f980b4d92412012a44a972635fdb(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652146d7d3bffb497800d5f9a4f42bdb9685838734a96a1c67802955c0d3bbbf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dabf623d2f45c677e78c2a89f1169de8fd6ba87ca2251da2df4a906030ee936(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5b1ca1b9d77a1ad591697c9b5a5b3450e19c3749d790c2d9e15d7170211a32c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4d3b0257e972f6b6014b3f5b644bf33084a0ff0e0f24bfa76d993d066f8a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224bd6c3b328843911f7291e95c3fdba599953cd37fa16e3cedad09fec797ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01dc73b4d7e6741a5fd1003680d05d290a9fc6dc55900aabc57012e2cd0bb0d7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAllowTransferEncoding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ada1ea4f62631663ad73f309c6bf2ce9b6fc3271b8a78771f1ca4555e25090ee(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c078dd94a6e3b80e7b4d7386933a87a50fd21c61329c0033615507062faa01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca1445cd11743d2a7901fb27800bc3113f00f9e77358a0a199553a4716344b1b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f11330ccd73d068b2aa5be832bbfde42dd8e8d473e9ae926a1883bb4f68fc7b5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a74c9d9c8ac3cd651904d8ce2475c353471d8413dd23761c959d57db1061c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d20f535ac45179cfccb98fabd2e09a87b70236cf543425c86025a0cd1bb86da7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82267d273a765e28e9c5abaa8f57c5e1e15ed254f964e063d849c41234080c26(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAltSvcHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4578d1c0b22daf46c49ff9cef630b05b7d72632737cd980cf9591db7de9851(
    *,
    alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    throttled_status_code: typing.Optional[jsii.Number] = None,
    use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3adc872aa9acf1e60fa41d4b136b837e22913cc86316773881e1f0ffcaa46b97(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28903236c5b0a6a697cea4611330a1d7c4b23f4d69b6487a7d680087eefa8d62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bee7778e29686388ef3446affdc92a7c8a373da91d2715635712c5c0ab2373c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afaf5d27640646255b68d307044f4b1ea6c304d9fe3c117315404134eb292f41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74fca4b29c06a0e3cacca35cab0d7ca1feebb9677b3dc23f01befaa34d1b5e84(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98339dda1ff2b7c5ba94b6ed7dedb0d2246c275e6932dea97a68f1a9e47b308e(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac86ca052ac6c702b7ac3bf825c5494048ca9406a5c19675433b7163cfb7383(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a49c23d69713aa52e9cca54fa4616b5bacd9fc829625ef9db327854d604560(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b7d46da0f74f3ce644aac70844527d05a9602b4dd13932f875475e15f50a3f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a3b2b45a584fe0b7161651116a71ccae2f8ca59abc155c1fe43a3b9561557c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4c93ed79595316edc117241c0316a8cc3dac75d485d865afb9b92dcf97ddd6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f7fd1376983ea7a27050b2c557c08f401e6ba3862ff28338b8860f719f2d62(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85aca0388fa4ecdebc1fd11e0b1901055452def717d80d4cd9dd352292a2cab3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc48117209554c6f8e50a915f28bae7a3e22d8f84e8df3a8d06415a4e70d8c8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08210ff0e15722a062ee4a16d1efd4bc497ab1bdfb7625b93f4da2084f58b29c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098d0269a1e41f7d919ffc62a7f91b4ce08965f1d1005f65ea9738ac079408a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e555045b73be2fbfa1ca4fbf2c44b604ddfe19887c474073f553c8fa5922f00a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f7a4da600ef636026c123f2ad4002d84bf905345d5b49618c1860a3f9ffb349(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee789903b6b56e81a1f5a1d85db11f46b62b8c3336367ad9eaea792c1651769(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e380fea5a1bd0d62e83d52113087219e63f346615c47a1a28b959f0cd3f5e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c078a177e887f3a400be4fbfb2ee33bf72d45b95157f8df1f701d90e428ce7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf61f14f0cdea34e41312276c5be0686d7c80f1e47a8deb7f07eda34ce2a632(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d91d40f39b587e10be2ccfd8c50c81627e876f17c14191b650fb3f01907c0863(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be78a2f9324d2ce1315d34dc0b8dc369bbfac36a16803919069da62a4a37207e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03293df6d554579035cbe897d2f0af050057fa444d6dc75b7ffc00b21584d34e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf985e8cebeef021c2278f57e26459baca3d0fccb7479c350220529c5bc41fff(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365c0f3a587afe2f0f09c907d2e5a04a0b88527d172b71aee66d6e9501517258(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__154a42bc21e121911a510162168a31a27f1a7a46d00d9e839502b50ed70377cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71de2418d462527222e01d728a3dca054678391777e5d1f2574cbcdafbf90ea2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21a6da21ae485c734aa485d8122fdfae971168c9d93997756768a47f8b61bad2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__682160ab6f5fcd4a4e7e9fed86ee9457c7abab7bb29d2868790e39509d612a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b9ee71e3a805571777ff71906efe04d8941cc0cd7baae21f7022b28d1df1ab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__452589a3c8eaea7fda2493a106bc8087af573d7458456942a494b69cf272a78c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658c3f572e1f27283d1329f7357663ffeceb968af911b771202bfb4ae68bb305(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__027c4a527b44c15547e2e791d45c95ad9e8359600b4c512ba0490ba577d1f046(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc37e09265c51eb8caa4dac74d3afdad2aede3d5786b8506e8d0fee592d0181a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f4bcc87abe4b81b99cf128f44e56c5cb083f415dcf470b8c079c120214ea937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ba7f92449431b6e9544240478a8a9d94eb87e2a7e6ab5c2df617edcc12feda(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4de8d0df7fc07aebee6b87ab41bf7472895f3045be02714a873859aca38b637(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApiPrioritizationThrottledCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a9447695a7a2ea6357c197749f16fc8b7b33f50134775f04bea4f6388c02db(
    *,
    all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    all_down_net_storage_file: typing.Optional[builtins.str] = None,
    all_down_status_code: typing.Optional[builtins.str] = None,
    all_down_title: typing.Optional[builtins.str] = None,
    allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cached_content_title: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_attempts_threshold: typing.Optional[jsii.Number] = None,
    failover_mode: typing.Optional[builtins.str] = None,
    failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_cookie_name: typing.Optional[builtins.str] = None,
    specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_domain: typing.Optional[builtins.str] = None,
    stickiness_cookie_salt: typing.Optional[builtins.str] = None,
    stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_type: typing.Optional[builtins.str] = None,
    stickiness_duration: typing.Optional[builtins.str] = None,
    stickiness_expiration_date: typing.Optional[builtins.str] = None,
    stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc919700881f815a41badd97784e3e6886d15bb7043c0e30704b8f73cd95bc6(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a5e1b12a7f302ccbd3f6974711641f1224d9537885a8093942d71d47d2602e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d553042ffce0dd8f0cf4d99f7c26bf69113002d6fee0417076b51c4d835943a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055fcfa307fc6a1290916572f0698337694125b14257cbae3cf1556b951b5ef2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccccc3ba2714d63dffab5f408652786b8e3cb6734d6f2f238e6c47ef9fd1f6d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91111e5b172362bf214900a68c0003c9f0fe784a2483a8f3a02374fdb4f10da5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerAllDownNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72dbc7c60bd950f4abd0aca5623c8e846bb397f76f59dce384267e83abc6ffe1(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c71c7f9359027f63619121de64405dc531f31e63971f283a81c0de469c11f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc39c5eabd69ae02a2a3fee59d0d5175199bf3a1d0ebce5fadcc45b703a2dfe7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a4fa94fef63b040943dfe216feeca209b7b14a8658b187497a1bc40a6bd026(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59326c473925ad444e8057fdbbc668c844e3673fec7c410969325eb2a2ec181a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__359dd69b360ed0e6f32697e7b9c74734d9595af6853b3156b8931e133319329e(
    *,
    from_origin_id: typing.Optional[builtins.str] = None,
    to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249922910232b1287277b14cdba0193813c3d30c3ce7cd69d0fb96e63aa0970e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b297fddfe3e69c8938a0a2c924b658057307bd7be29728ae43d443fcbff7094f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666441e5de62c5100ebf46fd415ae341234776026c4ae05c7edf2dc8a1709c31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a72157ef8992c8313cb36ff33999b236adc8e3de13d54eea2ee6c43ddb532b71(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2857769909063fd23b6a7a56c4f8c9d6dbe6e353b45c57c26f61b220a5ee108f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7721ad323a05b3d575c3163392dfc34491fa98576b4ee230eec4ace35c0965d1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0385594838701f053dc1a22bac3a184d35ea88a0807c573022e724f0f9cbe10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65da923dce9931f996a2734a46ac7937d6a06c774f8e59244e36658c3633791e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa750144bf15858553200a49adb48d815244e2bd17dac6e45d26a5291459697(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84683f5e53bac11d58470721b229dac30d90d566147c0a0db7e2123e791bf63(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__121b636723c7c6aa10c7690244d95abe40ffc73de1ed1c8709afc9a27336eb59(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__986bfbee059ab1fcfc7fc9c067f99c75fa26ea2d89dafd0154b7a6354102d8ec(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9d3fd30e60c6f95a26eafdfe3585d19fa1b88b0a418d90b812bfeba34c69f70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34311377e3d83046de22b6c44d627db9ba6a6b63d16281c06ca7a9c89a5855f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a91d04aa4363a200c496b7c4f62cb177b1b542fb3cf745710c35c2aca2b913(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01570c0fc341392365dc46f93d60edce89173360a51bde1cee764641bc9767be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44fb99f22716d1b6e5db0c1cc0b32121d61542da65b0b571e977af94b9a5fb5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a641b89ed70a14ed81507f55f253199c3f3db3335c1ace66767d7ad2de083b35(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec06ec5b7cf666e506b53476d5214b9a95049b4d948562adcb8b1b3df88ec765(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb651408c566d17b8a7dbfe0af8c1c9d9c61e3aea5dc1bfabee4266b11f701e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae36559422cfb4fb0fc6594ada01c37e58a83875363a1e9c403f54e18d4b1469(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ce6f6595a31ca0c1278ace59c243383dd1564e041358370794e5bc69d8112f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04ce29b4e577b37d5a4f77fef15c6ee591e5831d4b7bb18a0a12b48620591aa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ad63765c1e059541080b6f8b8a8a7020017ebc3d59d4365e5ebcaa77b3a38c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beaedc80ca25a4e72cba1187b2462e6401ef37da6d782bd9c7f0e22f74241f6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c0a90aa99f8d4a61b54e59b271fa65adc46b1542a8a91c395ea8a4bf5529d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bf3179a6130a8d8efcbeee58d4418426917788bdf4cb815ba3ee076380ec645(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4fa5cd3f3f6e65573c2fceda4a595096d606b2943ab8b51f8997fad877e57b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeed74968420a2a136a965cd09a64d15e7ee0dd4a683e194d00a23af64cef5d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf61de1f4b7ff1747403ca852ff833475d9ea232a6f44a666432b1f4f94e4b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f60b456269b72892ed10599c37f8b0dcf6f0a01cc8ddba36f4aec76fdb295a34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e3ade4204ae5a936212f68b089a4700cea12119287cb47da0deb83ad120717(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ee2da1d0014b2863e0207ffaeb858995ca0ba4db434c92f33347efb954ddbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0592cac50906021b7f664709ab68724e7a313ded7f83c37395114f83f0dc0b34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1830976c92d3eae475a75e1af4a6eb0ebf3eac5fb9051d0974b9959c6844526b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47682b76c2ff5ae95b1ce9766d3624a290c2223a6cb964ace99ce87db28ec510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c780b5c6f82d8c07cac586c980e90af36add558c62c6e18cd2e9c1f83a09997(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__480f1979e331d576612df120e1d0413200756715dcc5dd43b0bccb99c74bf80d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorApplicationLoadBalancer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37299cf58d77cc31c6c2f71182b0a92a086904ec022a8fec7e2ed6a0f5dce9fd(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_domain: typing.Optional[builtins.str] = None,
    population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_salt: typing.Optional[builtins.str] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
    segment_tracking_custom_header: typing.Optional[builtins.str] = None,
    segment_tracking_method: typing.Optional[builtins.str] = None,
    segment_tracking_query_param: typing.Optional[builtins.str] = None,
    segment_tracking_title: typing.Optional[builtins.str] = None,
    specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75549364b40a600301c14f083a615eeac5a2864c9a4d865646c3e2137030d53d(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6091c9dfc5f2e34a3d2f4e5f254f071d2401eb415d9f66e5077872700f6aa6b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d285aae15e11a7e424f98dbe4c8108263c357730d48d716d37942b938e990f2d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d32af900e2e657ba654748cf96773e25101032af8489cc2d9c4ad5be85156cbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63b7e6636966fe0e335bd03a3d2b09002c368b091fdc90485fe2db729f7fa70c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__460884a1135e57bbad136714e5f46016c2900b3d5986ac526410eeb4c74ac40c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33054186012d24626997e0394eb272c442dd3fc9656a6ff86a96e428efa113d8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3994d143d731eee29d54e2ef4bc8e037f65ce68d098997ee28388ec248a64a1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf78bdf8a1f046a0b116df245d422ff8ae556b6a67a8d2483046c6bd211f7b4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4012b8148e3f9899487279ef884022883c5c5cedbf2e79b2b1c898001e301c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9d84fe1e0c8acebb5f55f8768fd8a355374545eea484724b5e2bf4ed6bc0c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e825e667ec0abb806b80fd51143483b612464424702b10342a21c306ce551f8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae6b988bcf54b26179edb55a4e4e3e723f41f38cf2fec014acb013baec9b7446(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8051bb121189e42a530cb6003cea50ba0b43d1bbc1b930e4ca25ff9a6b243a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb14bae707a8942215b2497a38aa408d9b8d37c285f0ae281806780fe76df7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76ae2ecaa476b488e9ca2b3ecbada1f8e359a47fbd3b07d5865637a2d41363d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4648b149f746c5b59e10713878b2b304f8c2dd8935f299461067a9b31302e29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a9424288198e90636a9bf07497f05db3911b3df53561835c47f2ab70b7969e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f004c3e7fb559cbd1c3f9b03b204f4008307b04f77757c579e49461c2f53c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150ba122f1da24f5e378cdcc07868828c441d9face177c0b17c8c79a9454162f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e485aa2731126df070be0ec15aa5602745eb916a1c581aae241e5391905702b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad11dd08a5faa276495e27762b2e092a3fa3da5ae2ae0b6bfc63b22159559f4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f00a1b0dafc18621c0b98926a5e0a9ffb4d8ea2a2b6c9f2217e97a3387ac690e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc5d0e8ae472e885a5b7d792d0db16fc8b86626be0a86c52b9e039f80c07cc81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbbc84f41b3e1d6b336ffbb25d7b1ec1f22582e1b0c9fc5fde2d12565dc8abc7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f86373f974428185ccbde34b594e9538dc2d8ee86699e9a70c8606f6647b351(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f1325f1478344674b7286792ecfb45fff7a67c46bf93bc64a7b11aefaf8809(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b26b6f3593a1210608c59e875d6bcd65a4a613b80547b0d107147daed165060(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAudienceSegmentation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea4e6ece0a13ac799533dd022b2797e782eb59c1a9b13414af3592bfe85737f3(
    *,
    autodv: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728225d5070907ad0f1ba1c2b85c39b39429f4a83ab2ef13138459c142dc0302(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dd46f6150934ad1fb7cfdabd1cc2b799f71d4f6514c37c2715f7464856cb9fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1384ae68b86053bf7691d91a0ec09024bfeedb5cfc388cb00e6489290d82b40c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e913f0efe60c047d06a846b67b167dd3e2d2c0a9cb0b3a511d9bc9664a715e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2385852473fa2ea3da6d7fda99fce963a8576dc038eb37ccba01124eaf525c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b5e58f3da59814195704e7c945df512446e8f74b89e68d2565f64939f8616c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorAutoDomainValidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3032473b026fd68eac55b7468ffbdb610a1088cce7a48d648d1662dc4a6c778(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631738e0f9294bd1f367af7ff08915e97ad94be374ef00a0207f189eea6cb2f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5edd3aa16260574e900135d13d83a8d500a555ef991881d203aa42c1df8aace7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb6014a5c9c0b5c0dfbcfcfb86080563008ffc949e55f1b4f020da25a4ad9296(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a536c78c0be9f17375b71050bbfcd8b7128a302841793fe70f16e546534971(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6ac352551d386da1f4602266aa0c13e4b0c93e54a7622f130adb5106c2d482d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71713d9b3dc7c0aa3c40ef006559e5e529db3e13e71f0692ae044a718add9f74(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBaseDirectory],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9288e8b9832eda416ecb020d298980d00a3e10149c0bc0eaaaff3c5197c28ea7(
    *,
    conditional_error_pattern: typing.Optional[builtins.str] = None,
    conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
    conditional_sampling_frequency: typing.Optional[builtins.str] = None,
    cpcodes: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    sampling_frequency: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e77aec49fb5d0c4539ef74effa2faf2a6cf024e2e3dc5c91c337533b70a5bb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee48dfe71b2c02c317db30d1db5144a99bcef8dd94465e1cf0e57e8b74bb169a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdb404004a1152a2a92fb8653a7c0513a7eab28968363d696e24191852a3af9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2034fce04e3107026243b25835998e101f0bf4d55ca088043ae28f24f8297db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87a7191ccf9f72843b6a6c0f1547419034d73e31be9106714dd21b4d08ec5bda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d379729cf8a2655cd53373df978315b74b2b2c68ba211b649faa9ae56156bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4a4d0154e034a0a917fe84e287a88457ed3a6c7e842c816d1508f822f61bab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254b02d5342c0a0a54ba93975fe52a8bc1e2aa3de5c6cbd9ad3f9dd858e8f1a2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__381d15bd330bfbb884080780131dbdb3b1924570b12a56d1a7a300d8dc133fb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576f39386e4d247ee9656ed613cac3b33ef157b913e29c64611002fc5119aa24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe4e2af411a55762034f96e8daf323fdd86b2d78f6eb41bce9a6e22f51e9b49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20e80eb46eeea5e967a579f67adddfc290db933a9a163e7ffeeb262198c0b9a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac8f03f26cfa72ef56a21c6f33246b38c2f83f69e0fea204b8de4279b23184a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBossBeaconing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__241bb19eaddfd80863ea1656b9970e230525ebae5c13d9ae17cae852f6ee2e3b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c062259fa22aaf8ff28f61021248c6d97d23723f104dd162a10920850388fdc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3af18863597214be4a282503111c6eede6ccd748a52df9ef24dd5bffaaff4e6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b0cc28aa441c3587b8edf3af9913f813780f52f2357be43c550ae9c02d6f795(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9c77e79aeda540b33b4407f751f0f6bd0fb20229a4fa422a2134167b1608c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397b100b3d1c3338b0340b92d53caf87a0437a42048ebbfca0863b59f8e4ade2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6a372732c7a1334e57ea2374db654a52ab41a1ed2a2dd27d8dc654ee2b75bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b0cfe2e6ab7f15d4b7f4f7b9bdfd6b6f7da6dbb68c94c9ea04d39e60111b1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1615a30cff15389cc6175e16ec60849aadd20ad877de1174910e0a92b8504770(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreadcrumbs],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11ac5cb191ef9486e15bfa431927bc41503c8e549350853f225211312e20838(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8dd477b02343fa27f16105280770db95cc469f18233fecacceb734032905028(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e2a77ad3859ed7fddfecb19623bc9c380bba9d7dcc41ad039171baa828625d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ee53a9e958b1a0df5e1f0e77e69ec2ef91e19c8a9ee9ea68a14bd87f1d5604e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b22edeedd9ecd7e4a5227b56ca7978d923e8ef3a5085e635460ee8a403f45206(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ff946b722965ec89d52b29a65b92990ff71f16bf7b6efde91e9cb9a10980c1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8089b5c70abaed165d0c4a2357db0f51e889728f2c6ecb5b937f5a8a2e557b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBreakConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__060cd0fe58f6c7cdba8574826db708b618aa9eb563935774704fa27098adfecf(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d4e9312a7097dd7178c692cc78bb12768c72dd62024ec3f46ec064f95e3126f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae65b1234b4d997338ebe7fe8f016a3a982a8e8eb1080ee6b5bf9696e51b7ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cee2afe1b9342901e6c2f382d8bc00087eb56c6bcc48f1cb82c6bfc9261b883(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56fb42b10125e358fa218e0ef2d6a8abca1cb56d049913091428cdca766d07a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cfad3e74abe6dd8e39ca89eae9937d4a79e0cf9524defd92ad8e56ed66ad0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dec8a7a643f2ca193ed6913403c5281a0aaea3fcbf43ebc6364f03b921daccd3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorBrotli],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00f97b4321322661dd0c75bce323eab3d80207b98615b910c83bd5d31c129ef(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59f08db54a006739e070a089be3097a7ca170547269a4f426a3a5160905441f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b5b25bbde26daee05d4c740fc0a4ceeb99011653592b1c7c94de51e98dc3d42(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa23f0b91b82c04d7628e03713ec2ad7e4c2eca127925fc6fb479608c873d43a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891e9f4ae11e48f3be4918c8afd0b467bde677b803586f31c44c685a0ed0bc32(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a240be7915ea6fa8aea660ab918cf2ce041836c1cf5a317609b696a884f3118(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fbe42c2e4c86f89f17389aae82a91071b66b80b8cb3b5f2eac7ac0b32eff39f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf5c320f06d8c3759fac04f1e81eb3e85440d8d8b372089f1bfd3b0e247eb91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc96453fa807dee3a6a15b22193dcd63573f66c40b9c66a3bb89f93c621302f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b722a5db4a8a6f7177e07d10b31e4cd755ece93e40cd8595f141178d359ecf61(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rule: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0f07e0677b512aad2a0bb1e769652db68c2621a37a5483a87fd626a78f9189(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a995b52d78a5e933661882bbe6b0301d085dcf46ac2a1d17b2a1a4da13a411(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b28d00f5e18581901de38ce0101ceac2a76d9d7eb9257f75e702187a58fa44fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb52d9aa1c62d50a6c699a0ed1041b70bd219f5bcb627ebeeb29c3796a587c7d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ab06826588802e3d02b7908e92d5b6a34a4d5cebf53d3507c2113315866d88(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6268b25aafa7177b7c528c29dd4a7b09da9fcc305428dc779dfdb9eba1cc42da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45f4f7e1394206ece933b8c6984604e1ebabf237c0344879e8f7b39c9813eb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21794962e4265551adfa8bd62caa1ad5607a69a4ea1c49461530da49d86c1774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da55665770a42c1260b9612e93cbe6202b7ca5b0d2aab4747b77024a38d128a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__113646076a0ab9e1debef350fab719e86278cf6b73b9c69bf33a56c398b039db(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae5f0049e2398bb6a08a62d5e9f8b0fc4dbef53c9c17a8b537d0bde8ef17b61(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5cb863b1f3ff4bc77237d73bc8d716f7647f507c977b33f8956f02ed04a22dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f364daeb9289dea7e83fd9e69b7baa805ac5a38aa7cb8f66041b768a1b212e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2540f0581723dd3db243d94038e4bb94cb2e3b40cb2f4f3b66c825e7cd221afc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__528ad8bbe8cda1401056456c2be46ea5a5fe9b071d859e71ebb7c19c1ca676ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__635b33b4a3974f0c621557c21bc5dbd17b39ea5a8ce6933826e642e60e87f652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aefce9af1ab7ebb34f22bcd41c023a73819795c0aeadacd0182a7e67f75054f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyIgnoreCase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b94a9011314fe081347e180fc89f60f0404daf4e40033571e6dcb64e52087f(
    *,
    behavior: typing.Optional[builtins.str] = None,
    exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d280211ca4b718cd1055dd95ac5a6eef230e4a68ec5e2c847b9da0ac9ea07e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b5dfa810ee3136efe7062f23138660ce3cc62304a0b2a0d51b03e63cab552c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14f06f6b059b01fb72afb41028e5bc9e1d3c2444a265cfedd8e2b21fdcdf086(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107934d33202cf9641fb0ddff657c9094b8ad46a8749e93877be0c85903d03a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0b407dcdc593e4206142e819052bf1fd5157bfea1d40ef818fc8e928f03b0b1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__488d27c7bc37ae4dbbf185d56dae31b2edffc81a504045589ac3f913d3f7ce53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932218c1d198b51be47c47482b3182290db12a98252848a32123f80d6e9763e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b03b944298847e04506a6ed0559a87f6134cdb54f078fc545244b530be39e2a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyQueryParams],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7707559e5fd34e9d1d1d19ad91c03f345f70616c7a8aa0ee036fed5fdb8101(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d34f968ce18e74efc0ea240bcaff99294054bfd6280100cfb243e033580af2a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b3ccc580c3908042d90851720ed6fe728fdb4ff800ac9f5604f02df6ae6e64e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7648455e1dd5f71bfbb6c52a0f9a9097e7f82d83ce15f855da663d4ae67a37bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d55d3dc82bf2eef7a83ba1fb173534112fa69c325c7cf5ea6b60277ce16646(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d385133fc420f61dff333b15ae3c8c7299846259045080dbfc3fb54ced4dee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e166be4985e4470f9ea2781e0236d319423d0470703cf342b7c665020e363f7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheKeyRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7cf9d4e349cff7e2d8ffa27aa6379ba62c56060cec62705248903d7a9f481a4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_body: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2513a77e5e86c3fbebb556803bf7bb78a735a9be7e5158b32640889ac0103329(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7825be03dbbdf30b643d053cfe993cea9a6c87c699af85a19af6d209e5cf58b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cec897759b23e1df30bbb1356a6be6eff3c57be52dce2cc503930178f52ec96(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f175f42112e1311c470bdc008a6f679c2914ebca59edfae04558188df132fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2141cf814283b0b2bce34fc63eeb0c78ad459322e4ab3d159ac08eea31fce5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6affccc41b593d885ceee4d94302340f3cb54a20aac46da31471ee5e821066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e390153d2f5095c70fb6a421b02697d1046cb1e89f88ee6904fd410e6efd0779(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCachePost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6417bf53ee60c2f321c1c3a73db23876811f8a0c2c90e3f303dfc882ff9786e(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5458fad8f26a16a96ff9c3f18726445e92507ffd4a39244e0e4252015f40b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6099bc773f0833a0601ee3aebac5dae83fdf305d2003a7eb6c96ad088472cc9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12218e4381c9dcbcd5008536ba8c40b997ba01578e2c4b2e3f24fccc9ce03e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fdd2dc290b68f05c6d8f51a23750bd02b8c92769f31341e1d1da96203e87bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb6faabc091a5b016b5e44305f660604b02dc5453ab5bc6fe2d9c866f9b8c36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7bdf9bdd6b706c509244aca4e379d0b22dbe3152aba66e1674e1be956a234c4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281b097e441d27b8b26ef0fb07bd8ed246c175f9b0bff31640d2336f1571ab24(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tag: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fe063a09c591b8410f41780480e2e48ee4df373c6cbbf319bc8eaa02dc0013(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dac71b658c6d5dfe238c486a9ad144d6fd98f97190cec9d2d827b2521ebc7ef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6622252e8c6f480260b3cf59d5b34fbc2975ddc4e64e35307c4ec187002d7db5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f245ab0533e9a4a76f095cb7ad70c9adbeeed32f6219e9072d29d975c7b5253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0e60830fc2643e4a15d1060504b0f23e8bd4b022922203540ea2da28c30232(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b3d0ec05c0a3aaadd172c2efbef3e8d7ba4551ede82e77e70905fcaa36ca4e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d26247d2ea43777682fe8bcfe00781c6ca57cc3c5090628d43413837cceaa9(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__538d21170b4c7a9e220b0e87d0758061145dae4cae4f03532920f17b9d8ccc72(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa665a68c61172550a1f3414a1321d93072f32053e4f3455e43eb90e133d0da9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5637aca978237cd030b4e639e71b6b5c72da8bd4316f140590ee3573bc64d1ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2e3e7d1ca896f0eb10c0397c00992467b4a2d8a0943e59bfce75c2ec3212b30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fde0f2f3ea5c728ae0bca6b43e5fb02f7729f819c4b8e30dcc371133141491c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503f0b52751f9c01c8a9f0385025111e7a901ed1c6711dc7155b206ffa645a61(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCacheTagVisible],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78bad0d7247657de0aff531d907ed7ce1096cbd0c45b24d74950042bf5b00598(
    *,
    behavior: typing.Optional[builtins.str] = None,
    cacheability_settings: typing.Optional[builtins.str] = None,
    cache_control_directives: typing.Optional[builtins.str] = None,
    default_ttl: typing.Optional[builtins.str] = None,
    enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_settings: typing.Optional[builtins.str] = None,
    honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    revalidation_settings: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93eda11f09e542bab09d15b75d05039dc6b1e1b746ea32a449cb2157aade370(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c17b65619e897de2a09fb5a18b87488dfc4a76df62641838c315a0c468bc4bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ad05f8be0a4d456cc9a27ec0146ca71fb249679627a43adb8739d823ff72d70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ceffcfaba5600f5264be09a8c813918bb0a35fe6e6c1935de95b9dd24936023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97d03980370ebbc9b9ce8365ac5b9efe8c672ee08bf01406bce1d0dfda71679(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c9e2af945b92a5f2229815da1a02125da7e4f9513b73c9bda0e58604922d0f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c4e5ff9dd3b25139ca3db4bd7f724e33c612adb3dd99c696ede631c55f00aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c76a07873470d48dccf7705d5b43fccc6a35adea898d1aa2f51c2960d511fcc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b7a2871db555a3d630b63a789a9f74cce371caa90be30c0fe9da54a471ee3ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dbf2142ed95edd8917e695176b88f4586ce6dc31a82ba481acd2c3624ee881f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95de59bddca89318fd53f77705e143875eaa128d7a8b227e5718431834e3b1cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2084fd7ce53c5657ae5734ce690ee9b89e64878f9290867311ddde71b58da93c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ffe5a11ded1cb4fac9a270e08c0e6c300c630eea2e54487a681e4a97566fec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082648f4d1a646f736a154b1b5081c1ec29d0b216c9b89de80cba7cf53025b10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbbb262504a6edbcb096fdb2263d3d840433685fe6ee46287acd7aadd2800ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4f4d2eabae5bfa0b2886e0061f6c213eb3fd7c087cf11e6600e5a27d2a8215(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c82ec42137e037d603ab52d7d6799c2d156dec2437f7859cf5cb79a2359d5da7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6231f248d3be704af373b8a28f81ad49ae583e11380c03e39088bffb43f3b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4094513c64db173eeb5c370505ea851eceb5e167a47a5274a07d4f5c4b1433e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a4f2d185313dead9a3e2a81e6abc7d0c8f31c22c64ed455945efa1e36f14f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c820ec555fa8db3f36e331584b0f36f2afa717930f3f7c4d6e86b174fca8ba41(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a60149a976f5fe83f4c10c33808238a6adf8ff1a0c5cc430ff384053c8ac82a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1febcbc901f389ee36cdb4d7daf76034ff786a5e0f19e7a56abb5a53f84484(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef2fab65e4f5cb59a04f186089702323e494b55e6da30921e2f06d2123e8bb7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba9cae44a8b3e4a4562e3c6b494b2628ee0c8e102fb4ff38d25f059de3f78fe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e521254d8be4428874348f902f3b980de3d19abf85acdb8228cdf6a3baa86e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8227b8b683349be60de8ac754afa196082b12dfe97f24eef66cf490345e8ac22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3572f19f30117992c431a0891de36b81dc70d0db5578740f8d3b5dd72e0c2158(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCentralAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2151d15bc3ce6fb972f8086ba802b01b16d1af51fd91012d451eab179bc55285(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    limit: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865db6063b080061d1689a88ab5eca9e061aae59fdfef93a0b218c8bbdbfdced(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344b2a43031983b8e383c355e786148b088e6eb6957346913d8772e7a74206f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766652c2d2758f13ce89be0829ca67c6eea71cce08ab8620a77514c73e1f111e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b40c5e641498a87a7db4c6efe3188a2ae7bd07c619414a970fb6cc8d570bd9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899bb4804ff5a91bce6c733ab68cae28740da7a6b3b755bf611b491c0e205808(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162792d741c4131c0c501d9c44d033ec2d3a05673f2803272c3de09d638bbd8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c77040a99eb524927ccef24d3b763b2778039fbcafcc13de95f3f5f9f8481e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a6952f9d0427a6bd3680249a5aed496debfc1535d83d0cb9045dbce3263655d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorChaseRedirects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a56a79b0b00f720cd9c14d980e164e50712495d9b60d2478c51ed308db43f2d6(
    *,
    client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36caf20ea6af778ba04b5e434b60448c8e0beed8303e8d7f18a35a80308ee44e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9c738b72f9ad087845155b456895bcd94f72993d409b3f667e50e7f1fc804a7(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e338121d12356ec94a68f486ce8eb7ca8c0070da4b7cc6d7ac8dd537a7d8b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b8df0101ab49fe5607a3bd63b83ee61dbb43040e310e47f800e09c0a7eda22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406be6b5c34e089dfdefa89418bee1f398b4b0435294cc081d1fbefbea675472(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cac67b8e3fe39a0054262803ea01ddc41859f5f155adcf21c049b1fdc397c261(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1d951f4aa82ed5ca4874a5853a43fb1afb50d393592d9a43a407c4b4faad6ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bbe7704d6a1c6f7018f1367f88ca0f63b9a0457384c4ea9ff9a95f41882b8d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__884138edb9643734cd82133d771b526b7b332296836cae3bcd56944bb6d3f4dd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCertificateAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c032e4e43ef9107e1e7bc11573adc859713817ea1af77b8d0ddb40e9b7fad3e(
    *,
    country: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1cdeebcde7d98b9469677cf43bb166206201ed706920b8ddd1144c314511be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c0ce1bbada4e41b36645e6f147ac0c515ae040d32133b069a7e54190df71ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__285e2ad548a3ee3e04921427706b82271d1401c7ff9be0c263565769e234fe23(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b19141e35b8c120432f6aea3e3a7da7d7bf51445124b596b4e6826d183227e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455d43a2060565ba457a2421838a16337a865de705792db8dc847ac574922592(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4e8511629ae28564073bcedcc6377c4844100af15a92e5c35f9c9eff79bc197(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorClientCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a398fcf50f4df48effa80d28175acb7658d3eab288616821234e0980eb075bb(
    *,
    cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900a34f13e53f5d4f066b25e11874cf380c24b82c8b577eef7c5a7bb172c9999(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d88a2eca48ab648cff32d62eba44418bd26278f02a4e7d67a4a73fc1642062da(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4a29ea161ec1079a91720e4fe56ac63140052e7cb488e1d21aa24fd8e11011(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257df3c5f891c451dc11e1525c64b6185e694aa5bcc5144f34db315195f89203(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475c7a08579085b6db317bc7a38b94d0569ce0777cd82b9ee2f8ef4ba28b7b88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd472a437b09be658ac2320fed734dcb9cd8d026019175de63a22c4b04d440e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8d84d20186717f13f5d11be7f502944744671f5788a5f75f77a0a5d8441ac72(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudInterconnects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f52443d734b5f55eb1e7ca32e979196dbce8d2d0f0cf32db3821990e2b20f17(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721e8d17cc944b3a781fc7f3241bc463a11190146f1587a42fd13392811178e7(
    *,
    custom_failover_map: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_map: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530371cf566b55b9f958d162ed376dfe20addb3f9a9cc7a9173802aa5770b511(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b5d68faca9e23a9af231d8d8e6f3869448a9beae0b2a84e9178f65b8ed3d02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e01f75208a853e586064ca0076e8b86ddd78d66b0371de9da4d4de7594231d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f064a2b94d9609d0d2d53f51f2987cd652f57b578129c893c240e435939137b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5132b67cfad9cb65ec94a61b9332d01d80e5625245f3c0274a5846241f21b0b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dcc2671844ed600b7ae602c4e244d124d714c22e7e4e0f3c87a016c5835d43b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a3087cb2db066b3ad1c4b8401a71c700af325208956c7ff714be486614977b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__384305faecf9f6880d2180e60d4834422bbe0daf73ba71898e11d410ef70929f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapperAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d0273086882a88b81c45d7dc43c2ccaa270ee724a17e5c52056ed32b4fd87c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e09f0922b966113a57a28274aba1e167c4f1941582046c528067924b0af92c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55a5afa9f37c238a4734b0d987fe5871ced1a5acef4ede822ed61002ab42f94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27b6cbd8fbc18dd4d11805bc2209596d575361ee1913216021795d7b99c7575(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80869f4f700e51728eb7c10fddca8e29c40e4bccdc06a573bd50da17864c34f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f45077f92b5d8479ee0abee85102f4a9161b19757a97d471f3052943f35ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ea4f0f73e66bb5562a809dc8d23702ee69978ecbac1fc166ea0f7501bddbf8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCloudWrapper],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270087c20660b9f333ee67622b5543aa6c3c1413b01a5f73df552a00b2d037a1(
    *,
    enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cf7f9f181ef7bca40da02b7b992429b206fdb5f876d21e0defca9ec158705ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4da28ea1809ac6196dd8a1572375597628b1320c0adf359cb796e494be6b34ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c831879ed2fc968161228392a2995e9d31ab23929f8c994a89888e438e94d028(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a7f4a30f21325b3cb818bbad6b37d26bc6706499a8063d0f27410de68e319d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1544b2463af228e5900ed7e0aeb2da0940fa340e97f96e497e0e9d8be6b45ef7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8596ce816b5d57d81e6515e86a82b432b7f70038d0aa98a8299d774387174f6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCommonMediaClientData],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f1701bcb13b30286440ae50569a70ca8b27533eefbbf5e4701a9d0ae176dc3c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e01772fc9f443f85f8887475aa3fa7837dfc28c413c30814149af6c4339fb35a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fbb4ac9be3a4397ff9a02335abc742982ecb94228d749ec1ce668d9dc966ff0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b57b115a1dc8df4d6dcfe4e9381d4acc879c1978c36f5ecc2da40a344b801e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246b8e9ec46b0ca72b92d412aef9134ee5caaf99019c22f089e3a6cd837151d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0053523e5a1b814738daa9018035f2aa033da6bc036cc481e09adc86973f6ae7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__960479f717e1ab8ebf900c613b81ba6f28e55474b43300a8c9f195aec87fdc8b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConditionalOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cccb9b3139530b901296f27943f4480d326384cbe8d37e124bea0f63e8f29e1f(
    *,
    body: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__650884d181519ab3385f0eb614e6385d776fd0f0e16ca66bd4bc29d5b2890c4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0110a3ae468bb52a69b0dce9cae558c5b8a04133f6c49a060313709735776498(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0417756705ab3f2374b61313475841a63852c1641aa3afc7ca8d287fdd57e760(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0789361ac9e1f2e80d2c268992643d89cbeb0bde05e25752445913a3cd75d0de(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662a0fd44d0bb84d350d8b69689ed68ba5c4e1c3b25882245470e434e44fd289(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c11dda646aa7895565f7440e52fe17bf69997f728f9bcd560a30d47865c24ee2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1633fe61841c57954ddcc3aaa047e0282ae909766cb38c3dce760ce48dfdc404(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e35c9d633d0e550a29cd563d793d7125d8d040dd6b1f007ec5c9a7d1f262a7dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e68bc930c358c5f11e0d5d7d16dc38385cd6457d61521d2afa5721a7583ebe42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb9f492e06bb44d022a70720c7e581cfb46d32af6f59c223626d9c74c69a195(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorConstructResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d037c811f2205d70c3b107cd22dfd2c58b4de5cd82dee63efc78ed709a50bbc(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d76a77784112a8d40ae4b0e09afec99482b1a406ca90ba03b7532a007581fa63(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123137483c93f99dfccc46fd56b0028792fc2811573e3f5b769fec9d8a5b1ad9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c720ac00fa9414a437e223d5c12f9bad61a057a64804a3421a076c5b4b904789(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c1becd2143caf387a5a8e6d8e0591cbc80d54cbae46af6cfa25628319aae92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a88f83b980906335d23fdecfea793b36bd8ee70015d15bd4d98ca2c419d37f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__696b9c4c58fca8330add69f123feeeacc33adf9af524b0e813155de74149490e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caacdaafce3798bc67c2e7d58ca2a8848b4b862280f615db3440a81fd57ecd73(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13f870ab04d52d0aab6f37d865fc8051e98f25f3d814160332891a3787fc7586(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f41be4867444fe8e76581c1ac49a773ed9cec3668c7d6fab456cf599af7e2ed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe564902b997b5db9e5786294716e85bb280af23c6b7ae5976b72612773b5c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753dc13a0e94a1dd8b33cc777bedda77728ea4d25529b8062543c4a924fd0462(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d13e841646bd460ec6c5968598d8b12c8e3583d4c7851854f3bac72e76ad7e5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60a2e8ae750adc2a45d979f69ff3270eddb05aded49eb7d075668f090c9d44da(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902ed1b8832070495dbd9934440916fdf7ddc89b33b3cc24b29b25ad3b6cb869(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78562adfbf4ebf56a9fd42e8fd8dc2cf6de5577032d649dd0ef079a0e0dfd28(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9605b53c10fe947a01e605546738ef802c93c21d8e6635504ccd6bd7ec7be5f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1aaedcf8477cc4e49c0f258b0bf6bd44caf192ae5b0abc46091315b66d9151f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abe2acef2ad7849362511a74844ebccd9f6019cff76414a373f41d7375927b03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff383f3bab7863249d1332bbf4934c156696c1dfddc1f704f524fce7f1f13169(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c753e056fe427a7ef51c7f423e750c0a094bb511feb6e6e39cd6f0455f0d8be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f418c62ea949289434dccc3883e948c61c983b67e8ea2830ca2dcdb58d8d98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7014ec57d9e4fd56f953ad93bbf22d46b731ad3824fd7440530727fa5d208b2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50bd4ccd5fb861d00e5eea92e052be1aee6e63b4f162f552c8f38b367790087f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b25581e84ddf8443a6d3df0ab5de9130e300322664028d2aa5e7e5aaecc05ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4be55bf46e3d318f6599823dc7193fd80397e7c9b24ccd28784f328f37c43e7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsAmd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f462987cd04f48c61058ad7ff9573e42ea95192668a5c367d9538da0cbc2a760(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71bf47c78be8a5770cb25b70efd7deafcadd4a33d70583cdfac4ce6f184d440c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66cc7e0819b652a4e977f84b897c0c51a04b6a06781428a4364adf727a11fbec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a47f219f6e3cd9b5d47b8510222bfcd26a6c58269768b5b3156e6dbf9412bfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff444261cdbfe2491e8b306a9c0a0cba2f12a281469e886a662fc507677f436(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b93eda8c5354b46dd9a994f5fff916d0d98c159a710cd187c10eed2ccd8f7030(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db267b3921ebc81c517d061a675ba0ea8127e592e703a78037883220868f357d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4d641928f8d6c46212dc822e3bd1fd32ef42675c9ac977d3c1081d58c7e4d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2946b678e29866ce4b23334c1876faa5c12359c3b0e9a39cc4ccf2ce8bf089b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__152af1970659e8e2b5d8b5d985017d47384591680c317c306f5166ce64cec840(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3619d1881c05e8d70cd0916b7585a7d0090dcb464bfbf0a0b7a337de1d36743c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsDd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980c8027111766bd1158f43b23266b65c4b53fc21225041fadd7a67c19ec976d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99aa1161fe67980ea177c19e1e114255c711608e2d7b357ca340714681f8d1f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5237b9b33a6d2a84bda68a4ff8aedf8559d2781d29bc472b21367880ec460100(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebcd0c8baf5990f421d47d4cb5806536752570b8225cdb8dc5c6777a12c8aa26(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3757e75a0156ee3918611e00b9409b84a1156ea545ad992771111a9c48079e89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9f796662c3c153bdce546d33166cc35144d0c013d69b53e7c041e21483ea25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674fac49b06c3ef0f8d38a178c7efc2516c1dddc3902a1daa52f347738664e0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99a381610236207eef61684ef2117c33a51f73ce02e1147ec2d983859aa78b0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__744e3f9c37fe552fc41f214fce30d57219998bff635d9b2c1a86140c18ba268c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5a1b382c256ba93766dddb99fd13e02f5d0a295894b485184e67d3610a0a7b5(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1831fb716f961950943c6ab4a19f8208c54cf2f4a02012406dd283d84f56222e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303cd0820e0d58d8ce03d9d5b99e43b848e4b3409ef393b70f03f1c6668c0652(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8691804dc7da37745b4df9f8abc51946c59a5717ebaa6cd4c7a8f313ed2e0a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fdad3adb9f86b78e7a71f0788d10ecce8ccf9d135846eef5ec129a6444e01bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f145e2c14d0a77fca55b4e1ab209a5a278e42e25640df99253ef02715912c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__659a9042b8d9252f06130cc3f1a9028e95b24afbb429cae63962e1dfea25cce3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76fa1f3dc4c9666e32a856744d140462aa38f0c12d5c992c0757119752f104f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071e3e2ec1b9be8803c6b810adbe0ef0d085e5ad36a9696caf5822659fe39b4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9342b870a89bc6c6490d8b8496b0a1ae5929f683a98f89bfaca456158672402(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLargeFile],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44fb82059656a86973dc719e16d8a52846d14550ad9daeb6fd2f0ebfc9e01cd4(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c4e978172e4908f6dc302323604a6ce3287150f189d77742482e83ba72153db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e60fa28046feda32de8664e2d068508defcf6a2661cff4ec174d3f5d699bee6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f25fe92cfcd8b74af837946b85bd099c284f995215b001029857b4554551ad28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6981782cee3ad6120731de1cb4789c5f3a49676746b8bb19117627435e13b9a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d059703c431efe3e6054e9f3c33af69c7f419d399a3406ad9b079badb07530f2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d50408dfcc07f57dab49951a66df60265e9b30d5e7ac7ed42deb4fc80c587f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b37f6e849176f89a5c834a7a6119a409f58d6b1bc5943cedfcef0808ae7a6f52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69184091e94aec1643321d71647ef5fa95b747f8465cad6367076ef6da4f4aae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cace39cb275974f6c3551bf35939888a143c65c2a4614a928adacb227e0abf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaffc01cd30852a7cdeadc62b2287442d8993726da18387cf432b1db2ca410aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26412c4fff9adba6c12156956d9fa28b3ca99c070a2f21daaac24df27bdd0b2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68ed08bc42bb7cbbf7c3f1b47e0f46ab3d0adc4ab554607cb360f181d7334077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9da4bdac58f7bb89daf646428fd02ffad838580e13e337f29ae920bef1c6199(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eaf717e44a50c169b01d152e8bbde792d646a120b741e52804da4db1e89d079(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2824c7fccc82f244a0c0107fbc6b021b39839eb4bc392f906a41d747dff0fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7ad661ea91a61ff08c41a09dd8c352e09585a6e0749c3d27f16b7015170cb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7ca0ac561a1fc6c878fbe7945a5e2338d99fa96735b345d3a09701019c8570(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1fae5253f13bab11d758faf50c133aa06bd78a4127f606536f39fd93a30ff9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b935e65286584afa332afd989a9cac64ca0f9ced7f8774e548199f344e6db6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9087410bec061a6390508c13a85b8e03771f5ea0b7b7f30ff85baa0b9f7f0a9c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdLive],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc60c7c53ba1512330c8021ea9c2f29cab37147e6c9f4c922c9a8afe0ab05d61(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55247d5d0b87cedde9d96bb8072845dc540011dd3d97238b85f4e85167651b65(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd731943c262554355330eb864cbd80b5f99f27b5a45d79932890efa31909bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c94848ce688a29c0706c011568f99ecdb04cb1a3fa0e1655c567319c0b45cdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96855a92ac3675f21c47378698c97781c58da0b31415d212e6e3cdee259afa42(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9ab8377f4814a4f993c927e009f58da78d3727ba39c03edd5a7a9efc824677(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff8ff2bd8bf214a1b548fcba92d70c7f34dc0f94d01304c602a8458f95cdd76(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f64531893e4843154ad57516e89b4bdd4d62f29bbacb702e2da014d3743e8e5c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69fe48dad623840131a92601a5ad5bd95efe43f0b5e299a70794bc173edb9077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd26a3f37be9060d20858a50be5cda565a7186426a9630888d96057f5fa10b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b17985a1c040664ed5bd5daaeee39e38e133ec3221eef08d1c2b7dadc7dfcbfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b428a136c79fd6fc1a6c536926d6663e7800f6167d73064eb3aa2a972036b59a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a48039ea00eed205cfc5acf7c108a278f03c73abae2b732052a450eaab3bc6de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99d0193385c4c3f7f7f962adb35669fb0df4607dbe10a4db381c63355d1ec7af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a7b04d0a68e5efedd93839cd83e1cf3a419d8dee8f35d82cc5b411828f4ff6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2919e65b1d1114d2eb3aef148292d2bd76c240adf633757cc90ab4087bcc808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__854abd49dc299e547c98a031eec92ffdf2f810602aa05458acc7f1a2feff08de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6e65fbe4228099a5cf553c6c9efe2d6f794ba86913aaaea50b1ff692a8c25c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf9727223d0d9dfd7667edbeae8b938ea34f7afd336da40dc45e8aaaf7700ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9b46b265aebf2102dbe870b480a2fc81d1adcd20b7c413ed4b24d1507675fce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__802a50ba88e78187961fa4a55e7f124f804e82a1860ff511fe6dd5ab1fe2260f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentCharacteristicsWsdVod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb27cf4112dd306e6ca2ddc9959baa1f6c076e54fb1c60c4615d0c624e567be0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    first_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    second_location: typing.Optional[builtins.str] = None,
    source_type: typing.Optional[builtins.str] = None,
    targets: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71732527b9d280dba3d59a81a3096fc6c4bee1026abed12046c8c2aa0e8cf8af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4926e317ba91c4a98a928ba7cc08bf206ee9d2d4d522635870ca1956f4e8ccd8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__753096abb1465aa1e28b76e9e431a7fd27ca7e66498f7a67bd46f8a82ec9a92d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a86e3242ab286c30ce08bc2ceb849f49c66d66c5d8c66be5bd14a1da78ac645e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba86c7c1ad84daf484f5385ee3a80737d45a0497d4dd0edd0ee113be442c483f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be179966e7225ef7a4c0d014962b23af52ea7cfccdb0561815ba4a83cba604f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c37c93ed8d7957246c5ec8ec8a67aa2e83f79ce5e3f4ceb3dd58dbac257d5860(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73184937b22e539c20303422d8608fcbfb8cf1033f3e0a4b119bd02c54293452(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0be1fa36f4e0ec52a6bc2b0de48f23658712733a5676f2882d93be13422d740(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37296f7418f8d7fc07c3aca12377906c6cab80b9d3670359085aca9697092a3e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentPrePosition],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dcccb7d95fbe3c15a60aabc4b3835b01a6bffcafc0afaabc54323d179127765(
    *,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_protection_mode: typing.Optional[builtins.str] = None,
    geo_protection_title: typing.Optional[builtins.str] = None,
    geo_redirect_url: typing.Optional[builtins.str] = None,
    ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    ip_protection_mode: typing.Optional[builtins.str] = None,
    ip_protection_title: typing.Optional[builtins.str] = None,
    ip_redirect_url: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_protection_mode: typing.Optional[builtins.str] = None,
    referrer_protection_title: typing.Optional[builtins.str] = None,
    referrer_redirect_url: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1559ed8dded8b82d36536ca0f6de0b6197570b599aa2e09ed349d14004bc2e0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ebd11120aa232a6fec8d9ff5eb086353a33e8f3ab98d2944b47e22f22dda193(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd5ab7c6313f881e8150c4847b93d5d6a3e8ed331eab8fc64256b373da0c21d5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1085f4c03b154d0ed8511234ea5f86b083d711b1d4bbfb7b7da5fe62ae9275(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6430f5e866fe9f271893cb3d9f11a28207257f25bfe6a7c8d98ab65d26512aab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__349c264b0e07acfdffba03e1520a33352cf9a032044220227a3aaa7dc073d190(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91b9d052801e84b29f7bffc7deb5eeca7147c310f6e0a6f7164189b42882e78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f09753d9fb1dc260ca9476cddf22b5546c6bf883056b853c7c9730310c8a23(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ec8e6457337266f4ea393330465419cbd40cae9ed0fb57e8f099d3a10cfafe7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d091a5a956d9d385c1598a07e7d9de324e8b359f5dbd92178ff4de066f137fab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f4ad92420f167850ca3042e6c0a9b2411e05dca2f0daf4f35682f1eb18eb58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68b6299d2c68897c817f911c7edcad085a0814e43febed8f94ca32378cadcca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__224d63c6340da183b691d14640422529d797d9abdbbddb01d74bd92e7d5f0927(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f973c0a0864ac83ea4402e60e2790147b942ca6c7b9c94591d8c7147633ffd20(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac05f29b46b7a0657f7deb2674b7df5894214547f14286a4c8e239bc13f4ecb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32675e0204f31cbb22a24ea1aa516aca55a892aa0071974bfde8e0f01ac05cf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0f39e0e8eb19d03a4235c747d9d37c73386b53324b797cf6a2ec436d7cbe901(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35f59c2345795fc68aa3ac87c96be18c19906eab53c2a7c28f30dbb1dcd52240(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b873801ae2f3de70dd1d106b72b87a7a59b6b825a9fbb362fdf702990fdd503a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36a26d4b4d6d70a9bd72cb66abde6cf863f2b7cda8636538312de2387bbc120a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b5eeea1f86f8f23e699da90312e6643d8c8066a02486fbd0253c5f5b4c43fee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d45e0d2347829e4eaec4cb033f75b2a411f20d1c2ed85e2a9945a0545db3f58f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd4972794b19bf1590c8e805e93416f1d89e98cd4cdb7b610dd9ce45c0b659e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bba129ee7d8a27042eba8eb1770236b725dd23d92463431371e1d214abbbf37(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f15bf91619b83edabcdd1eabf29463d5811a93718adca44aae30131fd89909(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__734425712e784aa055326a8cc8c5c5f347ab195e7b9bcde3c9b8a8c558d003f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84807a39ba1b324259828dab5c200b108d594361681d26932f6bb94f3a98262(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorContentTargetingProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6056aa3a00bced75ebab76911fe6d38cb3335dbf7e24f33de6b7228bf75ae44(
    *,
    allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_headers: typing.Optional[builtins.str] = None,
    allow_origins: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    methods: typing.Optional[typing.Sequence[builtins.str]] = None,
    origins: typing.Optional[typing.Sequence[builtins.str]] = None,
    preflight_max_age: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef0c013e73529124568658f053f82c9fbe8b3975fc08b3e0aa842205545c31b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef192028814608e9b3f56089c7cb6a3bdca19d7fffd1c4e3aac3a1c28b628cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d95e5113e15a4d841e0ba45daea952f152c18214d4f701d63a49e5b3e476ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b653a4538a5e96bba9d7a4662b623a11389a056b36199eb21220a65e4fedd921(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed26a8e0c0bb91c630d3a4c61a777328e42353286969754e3b4447788b3120a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc666566cc2e486079274b8aa6e4e8090fb6220e6b4aff0f0e65659585637c14(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1099b6c390afc06e727467a39a3269ad76b0af398ea1adb369d00473548363db(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d119679f0b3b77cd738afa13f8436bad0357a85c424113ee990187f29ad963(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145c18f9137b646fa3f0fc4e5ea017626b49028d049dfdc587cd41c51a878953(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecf032da9a011e6ad8bb251d81addcd0065ce5a8a59ad18849a55306cf953871(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078a19a276b9e16fe8f806166522aac485fd89f531857e8ec11ff58f5c4ededb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6206ac25d1bffd61c4f5119cb119060f6ea15ad8accb8496cdd5db08935696b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb6851c93123c64cd1aac2f84b78df98e2137137b77c75350be727649790935(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e5293db71d7a0e656330022f16157c722ff89b212045352f98af2da310bfe4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCorsSupport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9234012dd196dfc16b9a9840faf618ad1da1d5ce0ff6daad6ff65796ef9b9aa0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae3e5ba5788a6d932ef5c97ae3afd7a8fb7513b8c8581466ef63c4bec22c711e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d19dd2c982174499728cce5a13ab2344ef1270b5f67c582db35c04b00b8c96c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b49ce215a2b095a9fcdb417dcbaa234ede5ab09c5464bf6ebeb935836b59e9b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62fee12165d1e082bade911e3631b26ef409a98a1136d9034d3b53c5f4341812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d63e6a78c89d9c71ed55b40312cce7fb56d05637a4a2745660c810a0975dd5b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019a63cbb4c8ac4a1dc94441c21262839d4bd2c69b45e5d31b320015d26c3370(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145ca88b1533b9647190006fc41483e8c87d9b42ded0e586c7f985fdac4ba9fe(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59574bcd307c8967dea9144f3b4eaef3ba99ad6653e59cf6c9f49360efc83053(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cbca6e7bcfd684a696a14b065bf6cb2c6fa215b7fce951e914763b95239cb05(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43568d80689116f491bd8f5f6f25ef851085a6b84d9768d105c9a990ca856854(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3fcf8eb9ce21b7d62a404602d1f046f7b7300b3c3e21221e921d762e5cd5b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd43f366dc22e277c963f4b1ea3c165ba5d3d792c38557397c87451ed2a40000(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a3d9181dc5eba8efeca41a2398ceffb52d8157662e935f6114b19aa0e46135f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e62d7eaeb5aefa953e7e5ba9f2cf283d7d7a019046b982535e1f0545713cce(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6be96babb072fa2419af5dfc4f335112af30795854d198e48abe6a6791e078f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d687d86c88d97e812072aa7aa2dae17b8f175267e453fad1b1444813db76ed26(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02072dee650ec854b4b4312207ad64eb00195a77a0d8047135271638a5631805(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f46587c3bf5458c77ee2ccb59199fcabbad9b651772085e01b378709874cc5d5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb4a99d6cb6ea11e0fca08896cda89f2455fc54157ca20f4b2944f5d30f7ede(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b952ee7b7136f20157d55ae321607351e7ccf11ae33885b16853edbd5f8b5764(
    *,
    behavior_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0380e256f9f630b67a261bbe2f602398afb28a2f6cffef156fa7263a02578fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de83fcba1c29b35b156d80c84b8c546b2d00062bbe3745246aa900b33bb5d42c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b929c0fb48bc9d2f9f1a86ea1078e07205703d399fd43619ff907c8840cb440b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5d2e5e6047fd1bba5d0d53af49eb7085b0b9d367bd24d49a986d186ebc4794a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__258b8a7ff9418f7b8725a172581652c34e5d50b638f08a6ebcf8fe3002647abc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a054c76bc842b94893669953b31196aaaa6301b9b70c1801fce956424c349f39(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorCustomBehavior],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e3fb3f73d8aa353a543195e3647a0c5b641aa56f39cf722635f55e2f3ea87d(
    *,
    beacon_stream_title: typing.Optional[builtins.str] = None,
    collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    datastream_ids: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
    log_stream_title: typing.Optional[builtins.str] = None,
    sampling_percentage: typing.Optional[jsii.Number] = None,
    stream_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__910dc7c4c36e201f1db3b4c900773b54bfb95c99ea2a3e10906cd1b3132a838a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5af5d829ad78ef08ab44d1bd251c08d89510ddda1f421f06458fbd7418d89229(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc6f2ce7b5b6dd8c1ac483bee9a385831d4cb06b47b1e6d71964a6d85142abd7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c77618df36e145d2f8eb3805192b8c8ff3ceeecd15e88b020705e6f0075c22d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc41da7ce43fb0d25ffce7710220c3524bf4e89eff03cba58e4b529035f3d9a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32f8bd9813099fead66afe20d97290fb545d491ffa885141dbb24dc527201fbf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72f72a3a43f6cd29d76167d6c89d0764e8246a8c9ef1993eab11b32c634a626f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__158ba65380abc4a876d0264de2f96b38efc90b5f8fc14ade52c0ff6c9e031da8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7f965fcdb1644b9e076490f3309bd0453b44cfe9191acf319144ef965437bd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8556770c7ae91745b824b89812134317945720b8ab7947bae0011b4c65746848(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee1e7971c9d6838aa6c070bee307b93a84abbdbe56ca83441ce57ede373404bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71bc269a20d90c35dd09083491e811cb671b8cecaf6d3858899e83856c92475f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fb157c0ca3af93c2ae8c0dfcf5a91d9c9aba5b9e73ef197a036fa6071fc2d9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__229485799a3c8cbb2b7ec5d48f510960370a52b9dff115674e22c86b87e93b64(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDatastream],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aa425cddd10b82b1ef14f194c393af0352fddaa76f08cb8fbb04372155a93cc(
    *,
    anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b740c6f4660e363fdb365a51bcad0c0a9263b959c980c62ef6a37be0c66c8551(
    *,
    hash_conversion_algorithm: typing.Optional[builtins.str] = None,
    hash_conversion_key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c553271bee1728c52832bdf636d581cc3ac88fbc8decbc53057764a4a47b4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4850e33c4600b312a9146cca0485a2fac8eabf9f04dd0ea1aa28bdf3a6af8ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__942cd30c30e83cd436d37a9faea27a4201750c3f9547ba5cbdc04c98e04c62fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478a3793f72ccbb6bc3fbf8443fd2ebc530d6268c7484d0a05e1b34a9b7f25d3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa284cf1e6ccc60b53768927ce5e8a23600ccb007e2dfd0546e36934fbc4b7ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99de1b538e34a91f323cb7b2aa7674ce9efbdb7d001845a9ea17d90a635a0e68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3250651cf48f9f08b32b4baae665644cd7ba1b370a1b19be8806dcc88af41c7d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthHmacTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa25a22181cd37a44508e6c292551566f54c7106f056f71ab91eb84f56b5f889(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bf592519c1a5103122cacc0c44d294e8ec131ff5efab4894caf44986e80c0dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab24c599401d5fb7f5d7c5a7b6dbd46c2f802eb36a55bf33bac89fae3d0c4236(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__211f55b2f6de9b3e0fb49c8ca613f8581677c4fa818d33cca2de5f755decb0c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65d3b885f308310f162ae6eba1cd2306a8634d078df776ab590f555eb984ee7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a9a17098f0641bab883a89a05f063dca7dec87c320531e1b0d6f6ecb1398ac9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f7e80ccdef5f43756fb3603f1efa279a801cbee73fcac6f20c2a69b744a42c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthRegexTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08b95d8a66110eed4e296171562e126dd4f2a2849d18f635ed875dde9fc7bca(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    substring_end: typing.Optional[builtins.str] = None,
    substring_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c6266d13abc821077133b1849cc767cf051ab4bcb2388daa0b4d67259d1f6d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27176e6688789ca6340a101c4b92b46fefc74534908bc4f9b6ccb340897ea764(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db2a55dce5b16efe13a7d68d1b4d0eb0c8c2abb61c81823c6527719927b933b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fca49fd13529dbec052c152e08a4a4d578cd607ee188f58f784818255e24d4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__594b12a8e2afd8d35b01caecc3664b26c0b686487946d31110c11595e7637e56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f5a3aa06c22db08df1fd96a848a5bab8d5378e50d04b7225ad5fca56cba8ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f73741d6ee27f69984b4be4c6538d891753a3b7799e015ad0c1214910cbc0e3a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthSubstringTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9ae2a1f060a9d3587a4c96f8fe0cdc043c34f993a6f12169104ae8d75a54dba(
    *,
    certificate_field: typing.Optional[builtins.str] = None,
    dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eaf8dfd7fcd1ca15419946ecdb896f5eba8733609a41b4dac88db573782396c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebec69a8cd6f6f1ebca8164647e6df4e77f1d938106547fd5beb9fd550ce2983(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b08bcf59ae6870edf28a37ac7d7aceed1206711e21b82ba43787cd8ddefa4c50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d034c94f65b0259057158f28666be0062813cdaabe5209d1b93cddf233e10384(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c236a4d132154fa8f5ca2d061d330bc0197655ec8215dce77fbf6e0345644b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a108c6c583e566a41d84e595a837776a7412645addfbc4b67ca0e0ec8c0b2a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__474649c55012f8a04178a2c0bf81a6ad8d1b5cefe284e4c6ee2aac5c8e43d27d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpAuthVariableExtractor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf59977e2f85b5b30b316fef992c9aaca8964ec7ad86681c2bca95e87d7bd954(
    *,
    group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581b59951f630aaec7e8c99bca84a9ce558315375d8eb5f784346513d791b6f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c5463bbdcdfcf89f85570347066135a66237cca0a5d5f64989d4de041966201(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__537cc63f10d272c23106b93e2791028ff7f2b45b8500b6f3482cd9e42b2e6c47(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1520ad7074167d49a78c4ea3a2cd1418ad86e894fa412d7ca6b3c1ee3405411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fecbd82019cbd790bcc57ea03a48e0312a787d1b432c861107ca15d3ab7df395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac35ff099c2738cb0706eb33a4e9eaf1268a54af8e1de70a6ea906291db4c49(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDefaultAuthzGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3856d19ee64eb381c86b7cae86e6c8c6aa40a95420a59359139c3ded678f5d5c(
    *,
    custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abfe9b69e51450b626fcfafcd115877d3c89da2523c83515cd1adc78ab68e885(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd530ee392da22730e6bdb3b5ae967e4d5d1b0ec9982177786b1d386f550970b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95c829cd7544c78be600fba27d76c070abee46b178142befdac1a56809453e61(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d2e60b1f28be7f9e555a081d5829ce713cc5ebaf4d1adef3fdc1da2bc56c53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__349542191ef8105560abce028c16d11b93d27ac9f0f7010cc59d4564ec6d9032(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69cc7a261696247c60edd6eefdd235c07bfb63871c8873e34789efbaa4d307fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb418b82da172e3a3cc23f0d88b3d7e55f78a7c28bb5054370d26698f9ea0d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c88c5d508a88475cdd258ddd0863bf5e569fd3cfd117fe28e6508e785e3f9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7860a0d2912581f1897237c633b9ea2851700c6e6f9b06966df76b875ac90815(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpDevRelations],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__702f7af04ca211de1d44f871831fd2ddc6b71ac237042a27461ee1b0cd8118dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b3db42554d94512caecf3ccab18a42cdd8d0da143b4f6bf3516a713be93b58(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b9f3164b32ca3aa876f3652e9a11177f57ec7dfe69ea8e02a18f027c607b5f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4c03c2e0bd15bcd2cd4c5b28379ee40b54f9b3cda44a0a7dd932b75dcc9224e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02be6f730531a33488965de6d0bd2fc05515a5bec1379da9f6f926e5992bc403(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebabaf704f3068bb9ee3f0371e675a87e29468aaa5ea198961dd7c31550c92a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10a22deb0168ca5cab84aaae2c767c54304fc0d630e38ea8d36a08dc3ea6033a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1071516280099a720ae519abe23ef7421421a1ad6aa9d0392920db90197ac050(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b3ac970d9155e278032d78ba25042625d4672d1fcb9c31383f79a127fb8316d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f7cb9e0a0aac62d1c67bdcbabb6ec6571a28eabe6fb96d9659df1a27313dfe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b50163c7bd80666f28a6abc197a4345099dd30072d3ce3e371608b738aca3b0d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__587ce5ff542c94b9be8911556928c9a9d8d2051b1decc05b971c4d87ebd2b742(
    *,
    extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname_claim: typing.Optional[builtins.str] = None,
    jurisdiction_claim: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_claim: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41823fd67eb3079fbe4ac252a1374f4155f353e85c40552333a024fbb5927e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__902645121a0566cd8bd801a00bb54dd822d041356bccb80fa07db55186deb6c2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd5b9ee412d070818b5644f3c6db60faa613238d7765be82e5ba6031265657e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073f1ad345131d6d6460432c24c967807096ef54827a28e540fa88fa8da92f39(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584a950dc7b77189b23e57800cfd0c4cd156e0f588e470a31010b37194ccf3c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5757dfd5de78d77ffbe311155d11478b7ad9ea324e0db509cf22c2abf43d2f6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85eefc198a26ab948db37a9d67bcda4ebfe6ab2ca9316b5f238fa53bec41e40e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d894e1cabdafab9456c520692527a03b37fc9fdfb325d9187ecb2a23a37864d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b20292d7c6a5cac7c84eb635e63886434e97521e835a31be6e30ead87b3dcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd71bac0df2a9bd2fdd8ff1c6561cfe2e4b61da36cbe16a94ed99a704178dd1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__610d2d56efb9ed557191d6115766cdce06e49ff13bfd92552b698b5ca6db4710(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDcpRealTimeAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abac3e1e8ea3bdc281c6c5daf57b47abdabb579b79b990f1011c40ae23a41792(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dbcc9c5d718327642f854e7b845cfa716465c0b1deb995d00e594678e6af12c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2efcee8910ed61c7a8893cbad8e3d1710381536681de852f9b0b99225aca8918(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287caf002382261563924ff15810a8dd9c5ba55d856305bc5632c187bfd0b6c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ece90571d0fa4a494b3f26428fa2efaf59b523682d34e5eb90054def3a2436e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835773033c43ff755d2c18d0c09709907d3da09ad19217a3eb808bafc675a72e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2ac2de2d3ddbd6c7ebce934d2095e1a9042895e9fa04802133b8e37fb4628a7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeliveryReceipt],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__400106aedd5fdeb788f14aeb3e7a4da51587ad24ac29dc0a231e86d243e0eb1a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reason: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc767867bcf3fa0c3921618033a8ca034725130ef2374d70efe94228c42e8fe0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c45eaf3da7e3f8a4ec6a95b6f736da0fdfaea65da228686a29f5a3cafd8f3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d72985878b1193ff4f0531a3911bff30cbfc10fc40c467b8e3c32a3ab3412f2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a634e0db31b8bd307845189102b3b8582a664c6b5d5aeef6992cfaf88babf23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4cec80795035b52bebe41c9c97f261c6388b1231a3d3053e146e9f83cfce5d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a860105da1b1005a81cd0c3343d72556351c08d4861e96675af9859670e385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4bc05cc3c65d8cdd595e99459f906fba6996fab4c643fce067d15640505c4a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f92ca12bbb0a8d65d2269fe2e8adfaaf22eff71bdb9c230e6f1e1305ba6b917(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ddebfbb8c07166be961d1e6048479013798fc15801bbdec5a397bdcab97e9a4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43b62769289836093f36915a3af0de175862fdedd929e48a64bb0ca34d15b5d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86383aa5127a5ab68d22276423b10fcbb14928fa61233cb4546bcb5ba51dd020(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13693b246db0caf879355b72ea34e36699b3c0df7f0d35acacdaee06e7203db0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7162ba4d20e7fb7c4d1fe4cf45a844f57f70ae43e2dc1c5b9c091e21e1c9ff3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__202af06bcc33dc84ac293778d2d218f92f0e24f96d3e99f17cfa3ac3dd74278a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDenyDirectFailoverAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d7f136eaac87fefb4274a1abfde424dc105d9aa59a5daf1d48ba8a5bd6e435c(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16736ebdfcbed453f77126e2c20a97bb15d8d7760877aa60fac93410202db486(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0d270c6359345df4df9743e9e594070e529e26fb35c258e77f52edeb64ffd51(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40906c622ba0d2dfc40861513c744736be168660804a5546946dfb266e214074(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a2e2189269194d6f8076b0c04e2c906cd7ea25be1150071810b8cb030329b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29bea9c5dd8fc6107e5d3243377f59588336e94035745c313ba9ef874748f65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87739636bd519d1f008d7fae6defe436536f087caa9b233bb39f275196052bca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448f30545894863b50700e1d180ad79172e9aba765f13e794611d08d6630f691(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00345cab493ecc25587a3c9388462d860ffb97282053d64b311d44eda67aac03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f46222b34a07effed2636cecdec1e6db9ab70e9ea44c6bfb28437ba37e2f79(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddab8eed8107fd4c9ebe462d18d013b33e8d33dbd13cf0072ead137b6fe01858(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094308d826086b00653e432b4a8b28398dc07d34957d07399999ecfd2eb90bf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0d1d179c41117cac0efd1fc4439ef922943f1459edb029868de5c251f6cb4fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd8953129e1609b296e380408e5e8cd1c8fceb4d67d1c7f5b677c2d695135254(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDeviceCharacteristicHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b47e395ff0ced2320d7d0d4d69476aec9c242fbf1e183d9a1e6e999d6d4db07(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0f9ed122df64f705ad8094e3c0c3156a8d39cca5361b06577c4ab6843331fb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74f702c2137b8c517d1f90eb60dad8644538baa1ca662e2746b5b659bc83ede(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd24b489a6bb7496794ef4994080408b14becb50a9fcf652a67699a27d24b671(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46bd0ad6dd08797256abc1b541bd719494c4d54339f8df3c3f4072c18fa4d43e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8913d74265d49730bee052b31565a1189053f8f1a86135d20fbce2312c00735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6ac1b11891e61a9e3b16a2aefea84b1863e53fe5129f76bead736f9f8052d39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c47b195bd63a00f9d8762ee7f00f68b16ea9b559ac9f4fac1ba2757d56d5d6e3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsAsyncRefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfd78373fc5e519d6e715fa38cc754f7d32384f7297b6647171b49a69eadd63b(
    *,
    delay: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc2a042a52e7bf0bf71d84d959ecf2bb5537f28ae8122e4a853e6ce9f3c8169(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63e7a0ef0a65631afa32746e938dfe7c9c96acaa0ab9e3382aeb72362030cd06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08132ec5de6c7d24780e267ea81fd86e7766a2f2ffbc259df0504c696b07189d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01dee227f5b8f140b46bb1bad232ef492bab9632e51e470e97a296c3c38363a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d7690a54c6f6725b06ff72196a22107b2353e4c805fb525a3ae4f68b2b1583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf0de76c0926b533dce486a249a391effb4b244e7f05796a61bb21bcbc231370(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26475a3ea5e96d3b7789310b9e78a4833ecb94f71852737106a09da368a7abf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df49f5a12a1c022296cf12b77b70b569fee4d1557115cb9edf649b0e9b7eb87d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDnsPrefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd41025202278a0a0ca56fc75c8472d9c2e0b07bc35e6064ab5355f5720a4ef(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059373bb09676754f44077a0fd689280003cf10f5d09a10728d20ba75f9873f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc887e2c0477adda397fa039872e485f9d6b3af7cf5752e443ada0dd5e38788a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd16aa091b09e94e9cece6bc2fff5017f30897dae255f3a98d60b7f3e57d8391(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5927697845ef69ad36cc6faeec9c9b4839f10f087da966a4bca7feb8de65e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684fe32f99d7910c7b9818270ee25ee15520729731547d82acf1d2215827483d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e36170c76a5e8f5f0ed83637a6a3fffe80d1d1c028a4ea167861d669b8c8a187(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDowngradeProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd0fcad3b8cdd3c0720e83152ff471ca13e83bdea39366e3378e3bccf09ecb12(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c8b08b6f071e93c8c9ed0f286596bac3dc96263624a20cc0739eb4d1a2ebb4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0620a57e7237b5133f8a1af1faac2dcf912e139c222e18cebeffdbcf998640fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e148e46696f398324c1461cf7f74b962ffea500ead71df18707493119c74fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097d93514d3e88e2533d34bd869df2d27968455e536cc4971fe697450c5ecb69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__191fd7e7ebeb3bdf7e2778bd990f1d4c34b1da50057db2947605b145bc16609f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de60d8b44670da19fcf3036c5e14b1e6f51dfa8d32d4c17a854bed37a96c690(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadCompleteMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3671b24b1385c6634b927a1f61fb355b642151d1d7e5dab44430c1abb89bbc94(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900bde751419d6c881b9a333840d49c582b5db27a035593b9d016b64621f54e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a2800e9a2019246dbc82be6e36c361762eaf0d64f2792cafb2aaa6d17a7f6c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49539a070291829c60ae7f0cb7c796d83a4ce3a51c3615cd37792974d3e4d21(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf59272bb881b913e4c42b0a0bf9936c0adf76435fe049dfb220707b5b5a5805(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf4264dfc0668a1494bd6c98d0ccc0525d8d709d14d2b542a577296a0913cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5b6b089ca388e6f62d38b49cf782f6d85960d8ad3dcb55c619308f7fb9efc6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownloadNotification],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b84601ddd27b4fe1d0111339edcc9fc3c699eae625be89bf039af9bb8098e069(
    *,
    allow_behavior: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    send_headers: typing.Optional[builtins.str] = None,
    send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f2b920430a01fd0ad677153927d1b59c540b064d25765df6656694089ecd7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be5cd9feb867cd240d80a2a3567128fa653866d45fc5ffab41d115eb939e75bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c92a28ecca8be1a3d189e69438ac858f06e81c71f4bec7372803f9126b9b810(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7791f01ca344695580a59f9041d891449f008686a03a7d3805534ce294405c63(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bfe551631cec0748e19b48d1071565fccf1cf9dff7a20621c9d67ca66a5ae9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ce8fecd2a0a50b7cd2da0aea217a715792a029ce86b8e214e8ce4f1d8f5cc95(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f29ed00e85cd203e9c12ea93e386971f90d4a9891850b53ebdb26d6e2a1a18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__017a74522e6a3d551d44bda2ee00aa406840e028d03cf1fd77e5587070fafeab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1345e4b8e1fd89153084fd51f6c4f1aa93d396e505f04b7cf6c3281fe8eed16b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf85ad07fa00111f16cb4b1500f7f8cf50e574762c03c57c0600b8df32f07685(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDownstreamCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae494af626cc336643ab0cd2a952ffb514a0609bcd22f7162246de3379ba208d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67277578b8a4ce5503e0a1fb9e4047fa175ff1a3a809535211bb21da49b9afc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbc1e3c13d53d9e1f4dc95d4f1338afd0738d689dfda9fd698c5ce18ce7fa2e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95f34a2920ebbb771ddff8caae6467e878075c7dd17dac0e5ab7572365eb9c8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5295cf58bcb3de3bd45f9d096b00d2adf730d49b715ce0101a20ebbf2d16e541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6caff9e191c95afde32db3269077afc2db677df28f02c50ffdfd97fd6a784c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68bf77328c5f390ed35face72b393bcd61e04e339f61ccac646671e47ef0ff9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a960ab6c2857ca44dffa3060ed766311c238c2735f6ddab15ef91253f5d118(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throughput: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebf78069bb230d8875bb16b7173b9c82413df8b076375c802b07778107c28648(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3996d8ab616612d0f94ac27b6040b0e1e95d5aa2b16fe63edd5fd498350c1d67(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73cff791103d1757b1266c89c391690122bb3e17a77c2ee5b6ac3388db617d3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef362fddf1580439d204a882fa9d0d0a1abb753fe27fa344820b19ce8fb00ff5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0d60a46571b369db950a9a6e08888bbb12f12c06f9982ac75d3d5197eab2a78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5769ea00c1dfb10c249dc810095ab0ce0499e901f011399bcab112d060ffb1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicThroughtputOptimizationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42a5fbb28e8cabc2f86cd8c135380f741a2baa535020a996eb4b86bee59fa919(
    *,
    image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0697f8803f2b3971ab2cc28f1e82e0063eca5c46d39b32fcfa2c54f79f8e5165(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26606f47e2cb1be95a3eaa14e58c8219b6b021e70998006ee0873df6d84b7bf8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba6ac027e864a9e97525d3653db3ab27de10023a770921e33c55476f9cef44c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a9fd15ca2a9b17e1a5b65d18793624bc7f463e3372013e55a3a1870a4baf8b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d107d3116ba7ce481abf6b4858a41e52fb938face9a7814df13c44a61d25ffe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef0c67e77e5f641d49b2e9f453a6df405dd2fc33d8c44641706e0182c2646632(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b823cf59ce0a4e7e6c0917062109276c4fcea84640a0bbe66757a0788ed31ae8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd943ee9550ac1fa19c0dcf2980d4a6a3971bbeb897b0667d7fb2a8d4046376(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2a5215fc56e6e8df4080252ab8e7be95a002eb4ad4606d04fb2226d4c4eb75(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorDynamicWebContent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9fbd3e9926b1e0ca2db80a341d7a9ee369dd9d6a7933c0644dfbe577bd6264a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddf07866b1bef50a48f3c49b4869b9c6823f0a6bfda19693aaa95878331d9e9a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d21d8866bc824690586339aeac1d2f4423bc78eb8c4dbe3619e867fd7af54b93(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b46f280bfb20ca90d1165ec161d63626838dc503966b66edd50ad1edebfc38c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b418e90594fceef965ca66e9b6f1ccd7733405fb806c98ad95e17744fde9fb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b6582010bcce2a39225c870a33214b8376863c97bec1fd62002322d764e109(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e323db1c51a39e465e80191a8c15f5fb78d112d7a6d4dce9ba649cae365ce3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsBulkUpload],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5826fc9e5a75df55b5b7fb0214ce713740cdc49130e5a4e2dfa9095894fb5bf3(
    *,
    database: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a9fa7fb4a72650690d053532c24a8fdb5d0bfa7cd588d8d4661ee6aa5596e30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216b8e8213ac98e7035fa152ef988e949777e724cf37aace9b091b904444a690(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1a87cf7f74109f4fa52428bf5c1d50f5f68ace2346e4c9ad7c5608d8dda03d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a05e7efc08630989a040df7a49b4534931ac1aa546c89aedba7e8ab7a00860(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e051df7a78865915d83253363f597cca07002e6c7ac1125cac19c803e9414a4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__127a5606f7e2889102454b093a61d1758fd66f76a904e3345a001e93331e4b6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32c216781c1879e404718a5ef0b053d5aa76910e9979d6fb4dc87ce1adea3e3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9f21f92a8971df66f1d2c78513ab0b8c4e6b9b13812dc62a307ea0af8f6ec2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b0f7e6991b39b2d33abfb4d5682ea083e66b51758ce5263430913acdfd6735e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a45f51a3abfb93878a100be2c679d79759fdb03f6a15baf4aa4079deb7eeb2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDatabase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37385c32ae666fb42728a6eb73412da6a54482302b940c7f7e659b9ea14e3748(
    *,
    dataset: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc7803a9f72a3a9380c31ad5a76cd33e2b56f3465c1e52c6d993e91e112da8e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b437c4e79358a7609a392df2a931b82f9e78ffa5a1a195183c3b432c944b62a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04b6a77743b736cf180ec86de5fbd9831354913351f54512e31f7e705cbc61ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4126882c0d9fbe47a2fbcacc2955b2ed7dfd97a9d052d75ac8ea44fa2f5c517(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__899c998589177af6ec780d2211dea96832b15f95c2af4edf6736decbc0c3d8c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9f997a36f52f0b1ddd9235ad22111f7abf0d4764c8de7e910e159c5c0d7818b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44a5bddf797e317c4e654dece09e47d8352016dfe1db3511da0b833beb5b796b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__867b4070fb1ec3f0106e421f446e10584a9268409a458cca20f49015bee90315(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee7a80f3180af496ebabfbcb570b799415aef865e6445c4d345466ec9d49ebb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c83ad5b702f7a08b4061e9aa10626dd5b2aa3dffea46396d60589c8bcf24b573(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsDataset],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f348435e0074b26aaae5249ae18ff87b6d1160c73ca097318f80735a864704ef(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374de470345dbe512a603cc1fa99eb33dc225b8632356eeacce03cc13c562098(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8317069f4a624d9aed976a91d53db613c45385e5ebe8631a4d968c0cec1e3ce4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b35e98b33887a3f631d70cd06304ade92e82719d6e470f15f2571d30d710a09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b19bbf7bb56cf141663b4972125e8993c8415e475be03bacc9d06bc19b31ac6f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ce0144f03f31fc8a59520aa56a2580e7aa355befa4f63f2b18d19bdf99f4ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af4b0ed3091b031088bb3a139364bfa03e76f85f53b5998dec1d8048c2e71460(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEcmsObjectKey],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8458099356f9644c3d3d4557ed2fcf65b3e2099df95171c725e5a2db5dc43160(
    *,
    aggregate_lines: typing.Optional[builtins.str] = None,
    aggregate_size: typing.Optional[builtins.str] = None,
    aggregate_time: typing.Optional[builtins.str] = None,
    api_connector: typing.Optional[builtins.str] = None,
    api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b99794d7c4574a61e291c920d2662392b3601252d07abc2a51156b707f476b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89080b7fa763727a45c2f8c1eb13ab1e8891d9d4227c7a6c80431f605ba2228f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34a0cde06be9ba879837ca1f342799fdf420dfe83290bb0bf615604259670691(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69b817dc5c520f8ebd64302b8ec770230981e3fd63e5fe81c2185c350508218(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea9bb78870d5efb939ae13e1f7022e347a99b21a79fc9dd8736a76dddebd7ebf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79400185df641a8e2a95d583f7a5d3fe9c8c90c955692dd66bd01b09bf3b2521(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83451340bd03f8d5a0b90c148f0a8482b1d17bc66c9e29cf3af88080a2c1493e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b5458eb9ed10ed66a14f6cb76053b6b791e29f35beebf952c4ded2f022fe9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf7efd2753be4d1c4ba8b6302d9fe03bdcc089cd9c49617eb341e9623bd2c526(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f730fda7a6e30987dc0c30f8c13ad37d7439ee79389e872f13f7328daa45933(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37c57f2d7ce1317f92aed99bad88a339b99d9811092a2183cd8d1e69e812574c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501076b72857d0cfbd18d8896609dda27a22e8b1ecbba3198f75abc6e47d7ee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54308907c3135eb9e4470915fae9423afc0ce48c0f93e87b04ba7170d626e16d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a612b0bbd597ae6007466fbc3146e9ac238f868244da4fadd8961a577e7eddd4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeConnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7864bf3665f0c5beb1ec557cfb5667b8e60be7c0e08e7acafd00d9dcea6719f1(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2ea9de5a4cf9acc8c4d6e25004371e54b803260ab00c847f4e77bd416993417(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf69f04a381b9282bb01c5db673708e8cb4ae97e77638dbc79486eb77988c56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00aa010fea57754ff3e18a1861c99df745160324b18dec174cae40c3a7755da3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc396899ebfda5887a015c0531e921004b4eddb4b546e5e609ce10f6134a8040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a528b00216445ce1c5758abf5f8bff76a4657599c6711686bb5ad1e63c11de1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b543b2aaf0c8dbbff8d036bd47d3d655bd6371c0fa09e8e66df03baf5d700fbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d82249abc51e14194b3b897b5b91b9336e29d96686ba967ee7dca920e9e8f985(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e259a2fc91c55aad66e99032ae211f3b9ce206f22354010152a6416efe5621d8(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    ip: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b32c426999290d7242f0c7b32e4569f906a8111837eea1097b3adae21cc6d157(
    *,
    absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    context_root: typing.Optional[builtins.str] = None,
    failover_hostname: typing.Optional[builtins.str] = None,
    modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bf709f810b3032a8744b0635792c13ba03bd7b263cdeb380cd1b3fe8001e497(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088abb6dc495a64ae6dbdccccf3cd2cbeae2afd2a759b56a2f835f7bbe6e40b0(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e57521043dc9d92b864854e8b41ef332982a0a9132fa41a3159a0c2f0b32eef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02ccddea24925fd96060c8142a5cc37e363f34015dd2420f4bf1e7156b934ac(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3061d92f78192eab95797eac928c467572fd43c90b6f5dec85ab82725be4bb5c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8b3fe3dcc889b4592258997c3a33fc4374cc02de2f37f1a7f3834b734f83779(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055f21bb08d7bcbcc297ae3098ecad86d227a3fe89436e43a94c818b4c332e14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21fe2bc4654c704f4ad84cedfc9f316c5d66db7678f411b309f3936a3d316363(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96619dd7a55545efc17e00a504849146ca3451b97a00597a91d758ce3901af26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb81a40717e9312df45b5fcf777691661db1d810d7904a2806ebbb202ec741fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__510f88166bb5cbeab17ae903ea04066d5789d6cc6d3b8f49c5bb7e9992eeda87(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549c01c9746d9daad7994fc2e7cdbda17f4af20bbf937d41ce24596560119934(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f132c610832bd5abd56cde961e01b93cc485594b58e2c82b4aed9b0730e25e2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3db9043610fdb2f15f42ee62391a259c313d45e416c5d0dc2bd1a971a7f801f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d25fa9e4b3343d9634b3f7adb85b2d9070f2ec14799d8d46fecdaa68b760022(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161d6a5f57a2781609a0dc947368aca70d3e4ddb583cea2395f8d3e3a7618f44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6419b1327f93f555eb4eeda04de831401a8c46ab720ec9e2189d3c0e06425e06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17432ad10aebabd11d7f973373207f8e9f6c3121dedd1732d0026fa34e32d97b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6557c61e3f889912f68735a4a72dbaa497acc72155364145398aa75feadb7049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__523852360fcbfa8ac1c00001ee854a50c103f5a9978b8c0783fc3623607ca056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f35f4e6e57b5a6760212d7ac95dcfd9731e356f7e7f8c955621a01462b530a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf23813ff0aa6922db418d0aa6ee518f0882b6be430fe51491ed06430c6b7ec8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6188b4dac1d8c9560d7d47f1cb60458aab1d6eba45a183a76a23244bb1af7dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e1023a7c5a507aee470c9527f2a4a40a5f69a181c99eb5a60f9c6898e09df9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6c0bafbdffa286d34b2ba17f543b83ac6624bbe643f8deb07c8eddb13aa694(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a95e15286d2922ba0ec3579a8f844fc219e120d3c5930376f232b9dd237f11(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingDataCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf5a88de65b5dfc5aa6bbdd2ba4b0fb7a8d84e3311cd28150662cca26ff1f7f7(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_persistence_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1c2c7c24774961ab2eeb3dd67cb9fbd314f2a918f07ad43b9408e401abb6d0e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__544201b4859df17d66c0c718fc4dfa49ece2c9fa74c4bf3e22e99bb2689c05e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e229020c3853419a9703801e2ace2d2ce6ec7f9a2c5916bca1a49d37f4879f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad504d777141dea506385e96e011639f4c2ec19606d232cff90da7b35ad5ef5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8887b45e5f1bcb2f0a9bcfcfca8690a963691b0487566194154b3aaf6fd094c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__213830989408a9a236b5a5c9e21bf5b0ac978efdbec47e261ece83564c0238c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42af38b1144285bce5a0af51785247ab54ac46fc4547d51bfcb85c9162b42085(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__206069db0ddc367adf8a4805c628390786bc73a15fe9b8f7d080aee8e7769021(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa17059a661eff9c3606f1fa7c75ecce02d6f11330c6eff3d11cf912cb2927a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fdc8ac4cbfb2f12f1eb588c44885fa76d2bd46bd17f1c0dddfc4ec747df5980(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b760cf3436ee2674a7e340bae9e6850f96eee5fac628244ed26cfe3ddfcbbc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeLoadBalancingOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b10f610c56b312990d3876e3c8d3d1a4c66267a5343f1c80f1c01f1baac561(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    domain: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c439b48d7df7a9e4b48f79553317e4c489a07f16b6284182812bdc97b6b39964(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02922206f3306c3252d0d5b65d93e5f95130cb668776c2067a664084a1235dd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d39e71fa71aa7f9c0564a8983dabce5cb71d931bd02745a9d61c5cd72dcfa28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66c89a13cef37d1d9a43177fc3f6816583c3a456b403421d223f341ed281e4b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4da30fd8056a7ff09077646270766304fe7f87f41aef153f7a7fe7c5db7ec4f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326b2328cf2ed1cb4a43071757407251f8474cfed741985020b3be3c7e2a3c22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc117da78e29dbc951162b64976e6c2dd875333fd862828355e5be6ca0a000cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed91a77c2141b79193c3ca80dc13150decab41b1b21dbcc45d9d0baecbc91634(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8c7d2f13f95837312cfe02de7528cc05ccc1d7591d41422380626f5fead65e1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeOriginAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd6a82b6513abdd3ca09f4bde7ca6238b2a203f09a32749dcb148655786691eb(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd6c8fa195cb4f619a8496edc770a8cb9fa4d7a5eceb72c659814785db4e15cd(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129100756f677d26c63762ab5ef443b562ed305d023905024dbadfb97ee07d4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__039a1d105cb67b99bd20a029d6491f2ae9e2f7c30754a79d39e6d9babe205048(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a10b780c1ed4e0d4d02fca7c0cd49570a396f5d9a01476c2c3adc0f5f42faac6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d88c5a5be1793214932ed412096ec6b250f8b5b49b7205bd7d9a18bc6178811(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirectorCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7362a4a75b6197c7a06b955cdb7eb2afa61c3b34215a467668c0333391787ed6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7248753ff70acaed1b262ca1626ed64793a67165da31cce68d637f16f373e81a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fdb86e6137bc6b46c5beeb64e3da2f3061ca1fbe55b11e8e396c06940c022e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a31c6d1ae91b1572375ae26e5bc4ead0cfa63f84e5b5d0fdf181e40f9d0766(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00398c231bd3e72f08a21b6dccb497f576992bc6f6309e772adf80c4c61f20b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215b3e36547febb8a6a6f3eb662cd80719371253623e902967f49c1050d87b0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__306f1ccb81def0a3bf8160b2acfe14c4b7be8f904ac2c295bee203692c041254(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492cea13ee3eb47af257dd913cdd8dec075d9fcc906a395b4ef5f57cdc207dc2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeRedirector],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8267955331128f8a2dcfd7376c66346ce6c3ceabec5ada3355f10f84860fb1c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__598c3c21aa8da3fbab197b623b35d2c9fb98e9b4f8c54efb4d40e2d0dbd0ad6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f044b4067e5d3f1c928837f35fc9c3cd53c7bf167b89698c42d08111939e498(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4163b1bdc06496cf0268e8a797c0994d383ee5ce86e30b8b5b285f2b014a7ba5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31df6cb3d35677107b9ff303712ec3daa95eb5c5113ba0bce18c100b3824f310(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714eec22509ccd6f8452a01e07c1fceffe1de7b7746f9f2b9d6a7e37980fce78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2827bbd7d8b7b716f62659c0700a20f2afa4ffd5cbe7e5d18138450fa6428cd8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeScape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b59a7c1bdfe109cbdbf0c9423d5e7b83b52da6f7210aea3268afe0fd1b7d25(
    *,
    detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
    i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9bb1937cd73c6ae7107642f6151e945b0c885a1ad6717cf13c48db68e92007(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e0203c9b2315cbb57b75a3537b158421cd450ea76148215f953be4fcc67423e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a97fe6f2274a0a720608ca9f8f023a4e0b456c50ed483c2bdd0648f8e89bb27(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67711c7c980395888da27fa445f7130f5eb234e8dd366747397cab1d7ceaec5e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa03fc134b2227a220bb8db42b84754a0282cf8e20da9496c72f915bc5b75cce(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40ca64b9e803a64e9bffb02ec9a06eca5beae5651d606bfa9efbc33ac486c2b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80749c85f9aebd0d3d0f42eca37312d4b4efa26a70d2135eedb069120f36983(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2626a03b0373557de0f97fcbbfb04c5052a95e5f0581238c45ba69dd89345c68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f11d50fc80d349ef70c0d60dfee2e9cb9af3c2420c6d3e815369703236da9cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f24521ff9065e3b31bcb8dcdaffb281cc215bebb65f772105eb8cd92b7997b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42135965537c9eb8d2a63e68a8847f128e00cae740150970f5be0923b36091dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78eac90a3da074c90c3421697533c903861bc58c41d8b86c1cc1517fa5ef0d1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeSideIncludes],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e408162cb7797b816ebb4c2d06af714275645ceda4f58b33aa417bfbeede9930(
    *,
    create_edge_worker: typing.Optional[builtins.str] = None,
    edge_worker_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    m_pulse_information: typing.Optional[builtins.str] = None,
    resource_tier: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d912b2223fcaba9b494cec6564d73e6c10d91ec2b8d992886c543e020c1d7c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf6f47b3bc0dbc46c833a237af9ac57f948bf73f79a238c7df1d293bc3cec72f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc8108265bc6e73e2e2c6f861042acc3e7a5f1a20e48c2d5b6f8e2c7a1c8795a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c7ef69b8424fa0e25987dc7dc3feb471f8b55e86bd80f83764f59ad82ea5441(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d9884e3e1b2addbc6318ce622a4916eb1cd445308d54bef15ff4dcfe1ee2d34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c61a5c3c78bb3b9e00b0d1476d782e754411957e70feb800355bc5d001dd9ddf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f009685528001419ff65809e9a648b05679dfdc75fc88ef089bba471d2975602(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97ead9da3ed58d6ad3478ae279b6c3aeb1d9665e81747bc7d55e8fd45a10238(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d97a9f0ad8c05e496b5a68cb6910f33875a495f3171fc670f27d292df0f894e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026abf369f38f822f78f36ec6d87330d17b8d644ef414c592cd4e306ee9cd728(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b461fb0d862983a591c5564495ffbdf19ad09ebae3fb8b95bb5909568c35dbab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEdgeWorker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab3c61937beef34362c849a4157235ca08e594aa6c6fced27738de4d02410a9(
    *,
    certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786eee57da3f99b0dbcdf9754fd986264896fe552b62e535820d2109a445ae2c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774ed4fbd56b2b7b734efd2deb1c51c077765afefd2b695e9ce82421bc2677a5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79896765075e204ab88797f39a090c65c47961d5873e415638590d65dd38e6fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1437a6eac12191d28615bc36af48aaf8b7c0e0eb1ba02901a20966aff3f8cfa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__557e163b113dc93b852fe872dde1f268bc5ba4b156592114e37d888f1dc5fc01(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39425083064bf314e69f5516c6a4799f1a943dcc989682ad37efd7770cf3340d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9934223606e38dcee45a8658cb85de833feea0378f247483fcc57c95efe7ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f55ef1ea045cb9a83854e16bb4dd9a449d02f9a21d1ebfee1d2406bbc8527431(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8fdf86a5ef7918f47afc532c2a3b1408f47837f533fa19e7fd816776f1dac2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnforceMtlsSettings],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c70f15bef530f9272d78d46bf83611e2cd8da4bc1429b25a1f1dfd1ce6a406(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__963460d5aa068259dbd9489285fa4277b7edb0ad81c1bf74f00c638d1865fad3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7562d41ef732aa00ed60fe4466be9fb931b5643b16c7ee75b261a553451ba39a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aff0d38352d4b05fe780b0b81ded1aa3c378c620d61aed7e4a312862bc1986b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eacc33aa8ba50eba977e432c6e3273b023ac4f3f7396b4dd7ebffb9aeebc538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15357abd8a0b16e4607a8409fc6a54e0e37cc5a4c7caea3f29a178005c8120f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea65f3b62fa387071badfa4149e9c17159a2f4887a0a925a0f1ffbc025e9cc0e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedAkamaiProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eeba1edc659378f5bb012ed4d1735eb48df456f88b88f3c1c947bbd10980e02(
    *,
    anonymous_vpn: typing.Optional[builtins.str] = None,
    best_practice_action: typing.Optional[builtins.str] = None,
    best_practice_redirecturl: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
    detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_hosting_provider_action: typing.Optional[builtins.str] = None,
    detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
    detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_public_proxy_action: typing.Optional[builtins.str] = None,
    detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_residential_proxy_action: typing.Optional[builtins.str] = None,
    detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
    detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
    detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
    detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
    enable_configuration_mode: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hosting_provider: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    public_proxy: typing.Optional[builtins.str] = None,
    residential_proxy: typing.Optional[builtins.str] = None,
    smart_dns_proxy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tor_exit_node: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    vpn_data_center: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b62bc6a9c1cfe6de0782a16628f0f82795a43121dd135eb1ae43a6505b430d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323f73d5a0bb9b0d66f3afb997efe53e36a1268b9027de4df39c8dfd607752d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280a2a0b6e6b0a15015f0f783ac5d26c55783d50798015374f40e279d3f77be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f27954554afb0bb31135139813b9738325c8acaac66e80050daf2c29f257c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16398dfbf452ff91adcfc885a677d3a4f6ac324426d6da3a572f0d85affceaac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d8c6751ce3e0a9ba9462b468a42401cd1cbd8c9f32e93fecd4206b1a8b5db29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__692e0f197f7e3229343e9d7870cc6cc85970d86d96049d4f32915dd0acf7a0bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb142f8f834297f3a9fce0b7049ad27f8e9442644b97737948411d2dd49e961e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf8b7b80017391e055fd62a8beafe0181b494e12b2bfe1378248480e039ef79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed6346b0f03aba1f4f54f6054d7b050a7d549f790a65d6fd5078f8ee8f73f3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ed43a784343d2d4f820ad9b1c408590ab45fc918e6c6fe5ca9591af6892bc31(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c0796d7add38b9f253121c571f0d8a0a349ed88c81bd1c2575d7d24578a486(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__892e445940bab34f8c61a5ca91a75da4996390f1b8b35d241c6a20cd3c17ba1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9d6476d7a8e4261662749574f5f1686d8eba7fbbe92d63384ac40d741812f6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0c1d7ba0252a1d270fa7621292013097118da18d6c58843464484004e4afee5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270a49c72153d5f63cca887c93f912a69f93959414c6f5b158edf7369730d3a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d95f5281237e2b1fcb64ce786b5dc9ed8347bc66521fe625484306cb13e95c76(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81785a3bdbbbb907a4539cf513f0999e89bf6e6d09d3eb46b71e6e0de341b184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4dfe6f863e1681bcc35fdba9a951be7de42441a300f46ddf8a7dba606f480f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe29eb934617a87a1f599488173e9fdd0a0ef84f26b1dbfbf8b272a838915d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__371a3c1f3b95604c373276ba98198401ba31126f466dd55e26e0a0d79bda23db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b695a8b5655536fef767a7531fbc0a00a247b958173d304502baa428adff791d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dee3e78d09fd1e09e275bbf3b2be0bc71e820b5b3983a2f53748d8ade1dffbeb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d2544276652f6cbf19592fb1e4563d2c520e9c78dd374871ff2d5fb0600dad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2df56d790f92e4e72ac2b782303740c2cf53a46f7476aa14f77f3702e52616d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b596c71447e1f90d14b0205c41bef1904a0cb4b34e7c90e37a76d676481bdc9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2aba021f673372a55ea2f3295097e9dc7dc24b112701afd658f833bcb75d9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__533287e5dbf8d0adb09900dffc9a00cd1ba311728710a4cebebba726f43b1a1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a62310185f98e42e834dfa9a9af5c9034433b8339a7bd3ed1c343c7f1857856a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__177a9b18ef382d8449285909cb49cc62e5e63313eb5305f60360ab849d8a9d01(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74222b121bc25841556194c66f0182e4cb77d110de3d69d733b467c3f67224dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5270515955d5c8ec63e3d8c7f9f21e2c857882d512f60fe0272c4599b0d68e71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f19fe1a19a9922e5e50b57a24acae217e56b9fca56372112c71d5d2c6e252da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f9c671c043a783ce7e818ea83befe6dfeb137f00d575c8967385e24c5066015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91e2142bb090bfb84eea4e19a332a6206c73de112ac1ebcacd4d64dff1685942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a86e55f4e928dd513b9bd9dc315b0af0df77db5eb301f5355b9bd4165307ebe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78886045f80ed9271a70b43a621e3775b7677d79de1f5a54ca103365f2b13591(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f6b8dfcfff234bf354d3af7c945011ef8f72064d5807883b7b3a6dbb0dd5eb8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEnhancedProxyDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e7f4863fbde395c3ee13956120873c563ba944030403961fcba396bf44a396f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac23e4fbf8cac48c093733e208525590921e7200832077925781214e461758a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e1aee87917e2a47a65a6624902a6cd0d1f4ecdcc6ef66052f584b00a51b242(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1f3a0f15f370333b44ecabd2fc6a3d2b94226003530587c3e6a969aedf13ef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0353dd20fc122857c130934594b84206ae2a0c58d5f61582f0e439a26b0661f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5da146891f626e554b192b901a7b9854a712f244357dffa60c2826ae454d4d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2a19ef83a01f89674f607d2d1dccd98be3bca74a15567d0efc3691891f3e6f5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorEpdForwardHeaderEnrichment],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec07b54fae3de0961443ad0e673c4b0ebd3f8d56ec4aae370dba56f6d6cabb8e(
    *,
    action_type: typing.Optional[builtins.str] = None,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_hostname: typing.Optional[builtins.str] = None,
    cex_path: typing.Optional[builtins.str] = None,
    content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_hostname: typing.Optional[builtins.str] = None,
    content_path: typing.Optional[builtins.str] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_method: typing.Optional[builtins.str] = None,
    dynamic_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    protocol: typing.Optional[builtins.str] = None,
    redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_hostname: typing.Optional[builtins.str] = None,
    redirect_hostname_type: typing.Optional[builtins.str] = None,
    redirect_method: typing.Optional[jsii.Number] = None,
    redirect_path: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3cf49af5c81c880288ebe12703d433a311e5c0de36dea0a2f374dfde4740708(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cbac125e43b45b3e4b9a502de7608e047fd8717b080798c69c9b454c5016690(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0166faa07f0ee0ec71b7eff39aaa4b5761d8a01835ccd9f274634546a3c686f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8549fee92810dae86c23365d7622e38037b4ee2148fe7bbd9086f0789dae2cc3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303eb2bcd41ceb098b421d7e97f1e69cb7eaa81cb56d7ff4948d7e8d0a7701e3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef6fe6745cfaa1f4210473f33392a6be001f4fd49d8ced2bd8746c577645460(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23a70a1da45d3d91570af982858432638d4f23a53fdf5a3010acb2b2624a5160(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4438f9562a555010af1516c6608976c855c32d0b04d6ae284392bb4eba31019(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93df6c6087137bd1fec424797a849d69f5a5172aa838b983bef9be8e3a85229d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60c6ff4cc3b41d3beaa088f5fa0c0796af234e9e5ef16a66bdf319353f849b5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7dc20b1e1ab2745cdb12054d5fda77a0836402667c9ca88d70a748c22ea451(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__408fc5d41e3513b347df3cc6364b28d8c9dca1f342b184401ec51d91e9e73574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55575fa784ce13098bb1d363b58172599c0b2e874ee17573fe5a8e82f04b9f0b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e1462d228a4fb2523ed836108004b47b25714ff904644d630001e4c1370547d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472cee32aa3b77deec8294c0e6cf0f98fc71120aad09cd29ce5db2db826bac40(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd787a7c64a6c65614cf0fb0ed34f1642a37d123f970c0bf6495804c73d5d88(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__825a7138bc5348c92b39962092d4d4cc3b25db146684f98747801e10b261b02a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__957f699d5318a829f94fb1073af4c11a0d78cd48a3d6235572eb5d9077529b3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__755c92072e1b788df5b5f91684da90cdaa63dbc02a63f2f6be0fef83d25755c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__781aea4641b7f08ba89388c67cc3fc1063d458f755ff8d3ac4c2d5adbd4eb6fe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailActionNetStorageHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10ea7d8bf99d468106f3902a534fbc40cf56e7a5809143fae386a91442a667a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdefc0218053ab78d5aae1a8ae0017e557609949d565638dc339b14dd34504a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd7960ee8cb8ce4e199cbb44048f7e98b001be26b012bfab534145ac032758f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d5f05cacf67d95ddb631ce27077fbe844e8c17052d16cfbc7fce6768a1272b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd058b52361cd21a0d986b9a94d1e23c1d138ba6bd945cb57cc1036b34fc5f73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f52af28820cf864365e4fd0e129ff9ea396a4b347eb7df42f1d260bd92e97ab7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b9c7d34d8bdc71ae58255cd429a90deb32349cf613bf824c7c8fcc6f7acafc2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb547ab1d4e78268eb20176d911f0433e2dbb89fff4bb3d0dad858926d8d021b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ca70001b82cc2615a91240bf7f3c5c0ac0e1d0c2453bdc2e20bec5b3e69764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6431b9482363cfb1d0e2cee953c12d7d27db36701cfc1a915760c2cef669895(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d0e253ae51335bb06b237ef1b0f9cdbac993ad29f5d09a07d0286931bf2837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15820788c5bdd3dc4c45dc3a48d654e7e1a9d203752bcb101641a2732ad52327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1ec4b767f7026acc66167ca510d10d6ad417ea72e091e953b57c29d0fef955(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4308d8b52c17461b7b7024c4cb52c18117c21ebe6f8456eabd198795e3f0d60(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd00de987fcad2274e82b328693a589c91e54cf6d54cced4d8362750b1b07677(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30932cd9c1fcd94d345c0029d5d313d4cca6484a9620abc71f818cb3fc14e5fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2350df6e5af19b7ed9077b315331bca0d20b49440894277247c6e60f7ac8e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034f836a95ba01077a2216a6ff1fca4e18fd8e312e13bea2e8736b2849aaa737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6515417c00879079916f41320738f95d8e4c682d58d4ba956bf509346363aab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057303ed075d205bab3171ed90a521d9055aed99a336af2eeea97eccfe5dc267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b9784c4cc9d025109b9850c6474f95cd547f4a62cac70a8fde942845ab48bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8270961106d9354ce276fe4724bf27450928c08d07c061c65330d34ce7b50e5d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f35f83f8bb4340deb60cb68724681a83482d83f306736e5b3c6108387dc57a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__359b5a2ca67474cd894f398769bdb3690a30f9cf8f35491633d682a320cf4c57(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0371ac1cbdc46779d11c53a92c4a7c8e514e023798dc4c54c4d1a0fee9e79d7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ffa8681433d03eeb83de56fa8c142e423ff36b6a558742f65c2d2eaa5be9f21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04adbe1c6829822f41abb382920d1852243276046b386281cdc40b98666ee35b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d230f0db77cfe08857560aa797ac064f48f546a25096f17c730d9281600ed5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ed33db45f332c71889c9782c2927cbd8a080d5a3f04079398a70f0121d2434a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c096f90c56bf50796ac6a731e87ec93b609d870bf00cbcce13c8d802362ad3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a79e27c36c14f5b22f988a983fc5d4ad711f36ffa0fd6523267b71da8ffd8f88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__012d388a4ec2840b1165e24fef3e702b9c4ac7dc107435f46bcc20018a74707f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616b5bc22aa37e019e91b3a46f926d7de4c0386e257bb399f62d4a9e0d4474a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__368807d2e3d2f3fc82e4194ed403bede480c7dc329e15839428402256205d2bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57029ed5665b40930bb35968ec46a1e21fc4c39f371a231e54f638506d7155a3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailAction],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4086a89cfe51441860e32111af3294261339f054891f01db2cc22f9f844a250(
    *,
    compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036f1a9acdcfab2204db1c9188ae2c86db387ee90987ff7e07e5e32726a6e453(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da9954f7959ba6a9465b2bde2ddbc29363abcd85813d1de4133c2bed4944ae25(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9da7f29603e52b75525e5486fc5aa932804577c4a5fd4987ab27cbee4deaa5ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d130f5fc8fe5ed909366ce85336a7f1fc919e23713577f4e6b01299789a38939(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a684e03e2371879f069eb6ac26da9625835c8ad4c5840f987932e51c705b49e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01ad6cb9db6ebe96e47a584584abe7b6f22d24ab018ec638e3665a49553d3b0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFailoverBotManagerFeatureCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e598a1b891bd3492e64fb7446fbab73297a36ccb7b90faacde66d5dae018ea85(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdc05e70f7b58edc4923aa9da044ce07db7d639c04d440431ab485df1f07829c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3fdcfec4407b8cfd8e54850509e47dea8ab741402f7d14e66a228b81ed84ba0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d96960c7a66440ae34f124df8e93259a0e2b3d8d04dcee8307e386ff2a6e53c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9660670e862db779e01ed1023c66bd40a7a11cc6ae90e7cd367a9ce984ecfbca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1471954f695ba4b5b969a7e67eb27d8b5281ead752842a27378f639be7b1f3db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a384c092f04a7f1635aee2b8a951a9cf890f0d137f279dd40f6f00b2d03cb08(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFastInvalidate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dad026a398ae8be7e33750f7b01b75a6601b8e141e3cf3c8cc5f6b0c4bc2879b(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a862724b9021436917b0afb84c34b47e53b3a328ed8fb195c79b85e84ad4fd74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e40de2196c1469f988d31dbb7600466fb62a9cf90328bd9f6636020e68d2669f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5e4a5be4a93d820f85e008bb882c8fd93f87bb62f4ddaa6524ea6184d2556a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cba4426350bd841c89be2c651da1c879408dd7c83f81ff038fc288cfe8ea9a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d4025537121c4a9d2cd0533a00da16175c3f3fbe372d085d60809f68ce6e72f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd06b3c9a96612181b5d34d63655d7405cfb2dc1165b4b2a2028a443e0e5d925(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFips],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4389177200494a552e89cdece835654b93372f466291dbce72d5d93ba32a9001(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a84ebcaf902ac021afa519b06e4a6c936e5cedd39963d1f8ab6434d36531755e(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23729a0b2c507e02fbdf6c2a04f6ca738ef04d2df68a205011d6b5d1e28eb6d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13bafb9f61ce0b58bced9231e915065a20b0d368805328338cac6cf42d90be55(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c81b493ab6e8b00f3036784adc5a5dd6269faf3cf089e8db70ffe7c1cec4d63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc00f132202c0568c8cb129a5837d78519044f62689070728a0d09e1b24ea884(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2300a8282f4decad0a1b8057c00d70a170410d745f28db8519f19dcbd625939d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0bcc7b83787181de9622d263e8375fa2716170c0bf307ced45aac2b064d6ae6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1124026634a0899e40d4eaf6abfc5c159a41981234d6f5ba6aa21410f6b8b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3392d603b53554980add634499ab2d5e58c6ae7f22396eab6b9608acee26d5fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d8e7b87c8cf84e6a8231ee08936251af6fd44f6652489af0fcb5e6194d32a4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d5f24cb635bad1d107a9af864cdd7fba35bcbd00a239eac6c60a992ed0491dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a183f87feff7510c52a9140d5565f6febc603f88d8a23b8a871590be9659f400(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9486c4c0589f5336b3fc965eaa39de21c869bd080ea53222f5e7b10329e4ecf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07d088941ced6cece814b59211e30539f773fe88b4f0e140008242742db70eb(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f052f04e98bd68b7be17f8b4eb89a7e65a106c701e2c31ec7d3483d41bc1442a(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7523c11e423be969b17694249c38d8e103beb60d45d931eb7abd13995b67377f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__366bad8b3474b283ea6b7b62f18d695d7caae7c1be10d9dc17825206125cddfa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba2a429d856a04ae6542fecad01a1bab524ccb8f989523091934086e426235d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322ec68468cc973250b356bf8dbe746655a802706e3aa2711a1d514eebb42470(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlusCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3768448ceb1ee64f7b73df83e98480e89f4479888522405fe2e7ac7ee6ca30e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0621834526308d2ce5ed4562c78d7a3b78c50092f42439f7d0c309a48454ae3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34ec8ef7f07ecf37d6ea6ec9bd51729425511e561ae65ab2ff7df67da07c94c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9651e05edf07f7fa4ecf4c74f40b85723620f8bde58bcecc3b28ed7899d5898(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de7a362260420027dadd5b9b77144ef922f52ff5ba665be7e090b3757f12c44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ae9ab1d623faf640a3740d55bd26e887fc6ac677087e2668c64c249ae3ab20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965a9acc48755588b9e025e64f566a2a879656a58d7fe9d877254a86807ac38e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__961a7b3b2ed20f4663509b4697c9b3a69efa8874406aa19927ee916aea5aaf4c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorFirstPartyMarketingPlus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e7e5a67685ddcd4f76eb309f240af0214e8e383cdbc2e32468fa3c90783d4e8(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce41404ae220bb52ee33bc463ba6818756d1293f8a663b793bb73d649ad29fb4(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cea8b73cc43c90192753d7ea55c2a410564d07965dea673925d499698c04ec6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__413e71f45f6d63f4c344ab09c127346d5be3ba7c29d225b1fb156bc3fe3b19a2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c950600a70f7d3c1b0a42476dfdc72e047f3b8c015633eae3f251bd6e7edaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6fcfea5c593145023a6a69236f7d142534ba4306cae7f49ce69aa55a4227901(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewriteCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4fa99485faed47a38ad3b9545097fd26529b91699a942dfffc38f473a967494(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e485a7ae61b8d3634a4dcf0e4a50b210f280e22ad09c09063f576d90cd1a8f6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44d0ef1ad204e8a7e2c797b09b6fbb11db04509914fab2a45b7b4b9a75e3c1dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82480e60bd18d2e1faebf0e9ba761aad1c246f05bae6d4c0750c58091ec65e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd3f9e09246a36c75cce6b97b2015b6186dffa84dae0b1671c58369383e7d3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__554b7f602603e8cdc07f7e232868fb2246f39a06e6a2768765b654b1a6134bff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dddcd1a4f75568a62b5b26e1648a26ecfae0fc29f5cd34809c1d834a09fffb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95434d4e52b2b9f5fe2a2687e7ba0f2ec3572f60c67d145f14fdd9e98c82603d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorForwardRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86778b6e82abc6c170110ed26208f336c6a318108877eb5b056b5d516ed2dec8(
    *,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    data_header: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nonce: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    signed_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d62cab4ade3df5a08c06f04f83e09afee96b092a415e18628c9f2641289631(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2dc96c4dce780ed07aa88705f9e66e393952773740806f7f6b1091858d65bbe(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a876c5716b48125f7ad4f672edd9d178ad94ab35e88504a91c171de18d65ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cebed31010eafaa9520477aa17fe932fc500f7641a97805e66cd934fb3041f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4258b59a332db3fe208ab620065ad6e2824956ce83a02b561225bc62da6accaa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__340b67f5e742a9a05161439b665a90c0327bce30a6ed9b13d372693cef94cec8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10198541e5106d72016484bf5cf4fb26cfda287e25359575ed1b51f68720fc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1403f551a6994cae8f7bd897096d466789eab084ceba9fadb6f05cecfebdfb91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__435b60b6cbdea23b6014ea4ec85ccc04325ca5ad6acb41ac0d68daf1d50df5f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa29a2b30ec54a04ea263dd1a465ccd328071171d918722a22716e5f76c1f32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f522ab8fef6bcfc7a8dac76dd9c3a9b7d2b9e28d3f07e573e38e4b12f4c933(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6b83aab786f3e8c11ca89ddbb407f99752f97d4c856f7395202e1858c0f2dfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45bb784390ddd61ce83e36799480f8471304d6491abd3028feeab35c81415437(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorG2Oheader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9040728db864bf5e1d79d443fa4c8802e52af1dc9135c1cd59a404557c2dad(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    output_option: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9da606372fcd6853a492937548185a76339861a2dcd91266a8d38b6c94208720(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2cb47fadcb5dc1f732d158a7607147840f7d6582680a352e16d3c75817d155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6b341b194e2060aa91701af0084967b0b226e8b558f67ef730721bc77e9bae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e00f75514de54d31cbde45406408aae7325b739de21fd5f8429021aae7f54cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d735fdba934d3e11b79d2375f96e4406fb47b69d4b4f42abdffb2ca4a7c2ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ea45560c474a1a63270fdabbfe30a1774cbe2b67b7856d18cf3597eb068cd54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4631f5729196bbc6ad523f4a2aef71c47c4135d8b73d416c08585628d93fcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88e8d88ed70aeb5198183d864b1f6ecfff8db03fbba79f52d01ebeda6a772a26(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGlobalRequestNumber],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134ccaf9b7fae144b42c97097f372b4ed8f3e42e8b18acde7cea085ca24f8e73(
    *,
    advanced: typing.Optional[builtins.str] = None,
    cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
    operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
    post_request_processing_error_handling: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a575e919826506cc7de01078543cee7abb1c45436bc3e90a9b4f2bb4c3495443(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b4d9f822413f6b18ef054bf52dff7fd4f41a8a67ac4d0acdef048380395340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7c09154a5878445d8bff16c86003d0cafdcf32053a906817ad34c5e1e14ee2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8154fba94d882e0eba409c5626ca5c32a3676db27e361da959a747ba47a6f2c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467ca70f2db60c91f2b1f2855a68a99b4210d56b974e47df886cc058d82f0ae8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce0368006431c4e06d54a01d99549f20193778ae1d1c5796bb25ef447d9c3b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84768266df50c70449e53e6a1afde62864fb2c20f7dd12bccdb078be9a9c410d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d72ad0cb80bc8f439d47ee93c75a3b47b1443d95b2716ebe53c00d59b6b48a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4974f158be8e00f887c80908855c5e5edf61e53f480a153412e3c7875efbbcfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09342f5111d825f4aead0d040b19a385637f99977bc520d6a2277dd59c6f18f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa37c7802b13e5dbcb8ec9ea54bebd33d00ceb75951d4e7eea1fd8df8eaf5166(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGraphqlCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254943865bc426ec75ee3313623fb287dec45c723d5bbc74b6261efdc92b0912(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff61f5d0aeedb52a55e79cb1b7ce9e566579234a5a89d8d1665d35a1364741b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79b20bc97f68bc2f528ab189e1ba1ce276d70389e923133bced83692bc73020(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc9b60b4e9341ed353b5ec15b229395f6c447a063045a5e3f325c413bf735b3e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__782248962718664d4fabe8ddff2f44c21c89d59bda1e13b2d1615c797b27fe7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15296bc74812f69d0449b4cbb26b237e5459c28f73baa6ee2890f98b19aefd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e42a5ea5ba0ea1651a93314c9db7d60381357d16164e54cf7f297b45a78f1814(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorGzipResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e70a3994ccf8f0b80b22e07b434de28c69001b3e123be3ed061c0948bc24928(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa6a6bc98980e024b62f31c7124d5e7c1639db35e1586d926d994a2be1d0bcec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beadb61e5bef1e13ce060aba1d9bd763bb156d20d5e2600a38d12a1ee69adf1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39dc30a25fa4ca0979e40c7faf39f28989cb705c993ff1b05f7c863d80431ce7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c33a7f20dc9fecc2c1ee85aa5098d27d7962d90e5d86846c67e090fb140585e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a42f7fa38b3a4de0137cab2f61dd491ed925f2fb43598763e0512d9e6bd4f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ffc7d7f486ad0b6a27e405cc635ebd23c2b28279cd3857a8fd7d9b031d30060(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01bd98f473085833b91b8cd46de6b706ef0de6ea7f293887d4795f3114c67575(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHdDataAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e01ded3e773d68bd0b434a279a5b9501b9ca63c1c5faed4d8991cccce51fd3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_reconnects: typing.Optional[jsii.Number] = None,
    retry_count: typing.Optional[jsii.Number] = None,
    retry_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e99b876279d4d5e40bbce721761777fb03af61183306676d347444d86c3c7571(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86d33be055229b06fb27279aea570cb86f3b8fe03b2f0221e3626bd63ee616d3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e94dc1c2483c670a427c295467232b65375229e1d836fd7b4a59097c58dc6bf9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf308b5a8b9d1dfc14a43153769db368cc6b3d24148aa9f3c3b8a52cdfcfd5f5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__574a5b71cd80e2004eb36b8424a7d826a61a11ac9a0756ce49648d07072a38d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b74c7b6e02af49d1c1f57f7f1b300aaa893cb84ce72390f8ce655839233726a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4f4bb700ed231a34f240683237adaf915744e64a5e375af6a0c2625a7b653b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbc357f5569c3e107b8a082579a6d217cfd1535da5fcb03be631240c15ae0180(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHealthDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1bd8fae5dac3f149c3f20398aabe07b257a483ddcd9acd1ce4b7b4ab5121bd1(
    *,
    custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hash_max_value: typing.Optional[jsii.Number] = None,
    hash_min_value: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d27589ab9844222b5a674a06c376f3ff20adbe7f92f5a24d221c7994d20ce27(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75d452baf6a5eecf86a93b475de25659b50709c837da013f83da47c4711f60f2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082025cccb742fed472216895755e21d5b946f97e9d715fc82ebb3bfdd447253(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bd54eef81e895de78808ff7c4f8faa4e21b87e3d915ef61a05bbb0986f31d0b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33e6cfd7de2586e204eaa41adee372e30a9eb27e0d57453f9affc5bfaa2e2e72(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b85a755b00402a9380b122078d0ef14ab98e858908c9f8360f76500b9ce39e6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c36b4cbc43824714603083bf54f4d0d826f303e096c24b9612c17506be4a31fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6948f6025ca41dbe83216603f66542cbf3186caefffc16b0bc97747842fbb500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66f5ae815534fef33680ec1b98a99098189fc2150637b5cac4497e8eb24ead80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33284e6d3dbc470e9e4650db8e956950e509c1dda04c5f6e6c9c2239f1d8b2f3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHsafEipBinding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f877873f0555d235ef859a42b1e2684b623c9e4ffb4a64fdb8ae3467eb2a4924(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab725ec8ff630d306a1085b99ebaa189df6b2db7d859cbd41b5d884358889356(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__911448b40c745b18e0252f6116e840e7cd7f65b6d2f56e3bb7eab98dd2a3108d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d538566858d6e09b05e7f57f5a680b3832f7e86b88e2f6374699dbb8af5c4725(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cfda00f09f65dd40f7069a1d15db66fe16b2b8b3c1caf1afe6f8276155800a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a5efc475bc13e06bafa33e95d9ac5968ef1b05065b2c68384bf100d2e528e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__865575ba69bd98919cc0e83051a5a2bff5330f7e1492835d6717a506c327dc01(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp2],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c5edc7a468e271eb465199653c81248870f1e9bffdd4adb72c96cde055783d5(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5ee0246b132be84b606d9fa1e55ad45273baf1904fb55efa2d8e4e9a840e0f4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85cb5d67b56f897641d0e8c1980f7502c8fea1d237120abe8f2c15231efb1b7d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__775311f8513c9a92b629bbf21200f8e8bb4955b11d260432efff35e5ea7dd362(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3cb5b16f63ab506b9bb467917b83ccb27cae6be220b4db190a0b226ea49b8a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3013448ec2c1a7701787bcd5c733a260e967ce429f074abf6b421c923557ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff5659a2493d0670bd2950f963ff4d125e2eedc56b2e1775c1320134f22a94e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttp3],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7b17ff3746333c993ae2b125b8c38560fadfb5a43af86ec85c9e59b751e0ef(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[builtins.str] = None,
    preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea004a4a811d73622c8eb88425d141d5b9e9b53fd51908eef15fe3ad124a2d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db4110c26b3e88ab5f2013a279883ee904fa105359a99a2178fd6244655b683e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95acd8a957aaf798daf2233d414285618fb8fb2e516abfbf86db713221c3cb1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5524bfd6d9c7c13e8fc92effd0c55b14f2989932e26eea9d26a5c8842e82e73b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3536d901734ba2cf35214f73e4d323e1da76c698066bdb8e90c8762ea85ec70f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eeb6fec0142ba670cf01610abe4e564b7e71a13813495aa2437547b2c79f537(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85df66287bc7b7daeade847ac0f1c6eb171df85a0b7bae7afc5cd874453c17bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a809821b27d24ea2a0620579cc9445babb65392193d5bc44b9458d503c63e9cd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b29776a46bfc4756a912d920d7de32adb19cc1f45acc7852525bf384b54a56d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5bb7b265f11b568994b1c6d472255b67656a01fb7671dac4a04b0d7f19358aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f865491d4e7e3517d4613ab48a737fd105ae3f0ea99053a5a78088ea7b6edf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpStrictTransportSecurity],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c29810247f811084720503d7ec9d3d4a410b1d7057ff82f0a9326afb1d3ae0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upgrade: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a6caf2cc949ee01c285d3b45f0dd94008ca582ec3a31063296aa75ff435182(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af3593a0d182a2d0e3713967372d11fecf488ba510591ca878c0af8d157f94ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a65faa35a834b8778a606a1816933c796e01dbf3112afb51de73b4b5ce7457d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c5d46a5445b7e3498a624d0ccbd656393a2ffb44372682d6729bad8f48fc91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da7c0413a6ac86c8ba13d19e650eade41b2a9913c6fc8680b3a5d1a25286f5db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3524627a98be9129865e9592f7fe62695661ddbd09f69214a4abda68118b3b5b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorHttpToHttpsUpgrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__553b39bb16d8d1740ab8111e3f9a56affd245490002d7b4c48a7f2ba8c249432(
    *,
    dpr: typing.Optional[jsii.Number] = None,
    dprvar: typing.Optional[builtins.str] = None,
    exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    format: typing.Optional[builtins.str] = None,
    formatvar: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    policyvar: typing.Optional[builtins.str] = None,
    policyvar_i_mvar: typing.Optional[builtins.str] = None,
    policyvar_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    typesel: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    width: typing.Optional[jsii.Number] = None,
    widthvar: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a222066cfe6d9cea40bb298afdf6ea9b3ddfd85bf1dc4b517e3c75d7f2504d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c1b592b3476842ffc42c6a82bc270fed93f4d8f2535c9c7e3ad3d9e467f1e9b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48d7da2e359163195e16daeced94760e4ba2bc5f4a08bbddf4f751d8c647eb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d85dd560eee4a7b3b78fc17d0831772a7f6c1ad069dcc7af2eed2704ee2a77c8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a2eae352c62e1dd137edecccc85feaf3094d8320d144c0f81543f6543bfca7d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed43f331f4977f2b6cd08d12759eb4b92e90f365bd8c24c2c47bab3844de78ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f363f3a5b36ecafb92b6305e49533de4e99fcec668b65e372df126153cd7093(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d6715e574db2a885df1eec26cd4b9eeaf0613372a769647b4bc65ef24326d2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9703a6eb2bf89ef4e1146f748a2844d8a87ddd272f07c584dfbce60eaffc99f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1f5a2ffa044f7759342bedff63f4f1df95c1a1164f70cc4cb406b4ab01c8e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49100767878e9c2fbae180d365cb4a4b83a85ca1595c8b2389ee987bdd5e1e20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9504f5a0fd2fd10cbf3cf9b60fda80f0e5a8d2efc8d62daa314d3f2e00d838a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__579ebe9e338b7a7e1892a688cfdd6c5cc46d908137b83de9ec04872e2fb48f71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e157b7148b0dffd9d065f89823f7a13ce8c090df53c7bcef5ece4284f7a7d25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a07f219318f1148b5625a12e5d5213b7ccb16b0c9710e377273b4f89a5c5c2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb81569e7e4d1fe98bc5feca93a04e27f3ab463eeffcb0e223b72587dd9ac54e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83abbf3d7c13e667e6bcc9fede1fa94f1057bda5b93bfd8adb58eae6bcd3e8b9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3083226c8f0b5b5514a703400e6e201db1ee3b26ff12b464ca9d97a0f29f5dd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a9f31c506f4ee5d83a40828a8d15f9f4950c5eb084c8205f6b6ea612bc8cc6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed6362ce9e63a5d539e7073e2eba14b59e27a7943b2866e3cda191e772cd108c(
    *,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    image_set: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set_type: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    video_set: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999a4728a727133948dde42e760db834cacdbb1789a36e8bdb72917ec15ae71c(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d95899cd34b813d03730f8c2ec01e08f31d3a48de0225d6364f8d63138c1cab(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b486dfabd27e274fb71e066d3ce2265b35af261f5f267706fd050e477075038c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7b7ac86f85925d4fb2ef731f5cc8ca8b52c60c8ce75881b83420e174c5dfd20(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0dd091327e8f2cee2ad1b5659fca124d381d99cb027ca415ad4b667574dfd2c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__350e259b5f5378e2e589f0ac2f4570e75f8ad842c378b12aed85e4ff1461f8ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f552fd4119e906b7cc1b455f7b20a20ef0c6820b93f36f2d64c5a81e53dd6fc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__052cbeffea074de872ee3e9ab9151fe05fe6ff31e3a2b7b0698774635fcff85b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5034fc0c6d5e0dd3d372c84fc2e48579896f2ba017fc824b06f56f3b8c70baa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf9bf17eb46b9f1c2ad517851f63e9e09a317c16200584510a642f25e069e045(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3776b2c5bf953ccecd3ac0595e1667e67312861efc497560de55bc2c09b3b106(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c2186e68ea4363a71d83d0f19e915dce9522c405317b54027a08b4c88706936(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35191ef9e3f1ae8fafa127fb31d5e415f529f548c07933051f4836a81fbe381a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e6300abe5dc12bcb708e80d43534721df0e8133d4159d8c25576d4f775d35c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c7cd344351d29f967908f224b4f68feb2fd8e46e159a3c9cc4b1d93204590cf(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9961ac163957e6db5e02e0b762f1745cff520e155c8221ead993a664f3fb13be(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fb338b10db3570479e6226be3de521059c3f73d4d7841804686172d06af98eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ad3553458b7328f7d90d2015452513a8f664d284bcd810fff71bfbc049869cd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77fc9c570749b8c2e162ca222ded7fe1d5be1b5732c97cd1801b2a078d65af55(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de041d2919fcc08e1ba61054a7807a62d34a388dcdafc28118d6cbc60cad33ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee483ab9d293f3e9ad9bb9c50b673eb52259928b4e0ea724d3da630417b940c8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38de15e9cbc978d54b66cc81f6e535e6ab999bce5ad033a929b2f1858e98bad7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13c14988d7dcd73cd6d7ef21bc737e238ee5d55e3575dcda982db1df557239a9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6ad2eee2d4205f6c19734d14fd62372c994d683d4e63c75057f7cb222e6ba5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73d63a664247d425358c926549c981202f65baffafbc2e4136baddaa72784e26(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2f4b95bae983d0e7e01b4257373fd806c5fffa0e2cbd45c0071a0864d4eb71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abb033bb96d6bac3ae67e3112c462ec422c66c74b9fe611584bf2b7e30417397(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f78aa6667e976a109a2db894c3161b8539752ce9125d0b7b1b143e89447cc2b6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b52268bc2afaba10b7820b3988dfa391dc20b27493dca9dd12a126de6bf27bbd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c91fc9e93939706080fc45853dbc1c7f898aef981461e04a778677c51ea4581(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ebe6f9ff943afb94c6abc790fdca83866e0d7ea110fa8a173e5c36c5407998(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73767ad375615a53ee8418657c403accd2876cf547ae9ee263b01e187dedf7a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52ab04478470d82a8b401db8ce8a347c2c41aab31df57a7f4ae4f79541019e76(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2540da24e82121ad2cdf4c1a5648f1fd94fa05fce253a6331aea9c5db9bc6449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6dd2ca410327c35b244f7cda86f64509f99a3db59ca3719c9ff4ea4c6d0ed2f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea4848817d3a8bf8ca67f8561fb69f493205acfbce5dd1bd2676e91acd954ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda8636b02e1d73508469105657b866cbb1eb41dff94f4b2eb54a54b698454f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf95a013cd27cf222584862bee03db796fc76207eb261f5e8590af6dce1f8f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc89d3e2fd687d149c1a3b1bba8dcbd7a72dfa9a26c1c6a3cfe8b735e618c404(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageAndVideoManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22ab9e86a598b78ffd8d162fdb2d47c23b4f9f9cbc62b33a101270cffef53d74(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57d6602f7363efac075a71cc9f858873473ff832d25de496c2edae547709a922(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74a140f4c50847601bab61260fc35d7acefd223edbbc8cbee267cfd00f2526ed(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be87c8e3f14e24a36ba1df26ba562140704636f998e204070def74990133b232(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519fe6fbba59945c52e5fbf601bf800cd36015ab8d14ed5a9a6e55f3082d3e64(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f9950aff38afeb922be7496cccae66e91b773c5eb84eaa797cc8132fdb5a6b7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb18ac33409262fff873848b6ad958bafcebe7b31b42fec01bbc5b871a281c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed57113b589aea491ab531e538130baabace1929acf1f81abc77754b574156d7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c5307d701d3072cfcae3ec4f7b3af2697648d6abffc26729d51b3bd852ce03d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cb21b96681b45467ec76c849f0c518ce05fceeada217057fb2f4c83f68c5e1a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1e496b7013226a7210a6f599035bda61c1ebde687bcfb33290fe24d2b4aac7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bdcfb3bbf309830ef25078541bc608666a717e1b98189a020d4473e84456192(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a11dd2a0044a414715f8e0124d5994f288dad3b69b737d075e8ffebe1a79219(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a2943931f30b1b07822c452262403fe804f1d1fc0c013120eb43eb0c9aa6403(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ce753ed0a3b665337ddcf20781d067176e9f3a8601895f364253ad1f2918f2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac38c69cd658049098449f4c44a417299348202511f0f378039e6c9da8791f84(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__765fa4f24f06bf248ce723359220565f1faa418992c114dca9d00ddfb70e1ccb(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f166108115d710a82160e6208b51a3c9b0c33c4db591d40578e13c5b9e7d78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f791927de986a030cd79acbd2b66ecc3ba6cca8438b4abb90686b8c2718182c8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5283cfe2fe2d7e1d9e210da548f772542f4231e5a3e4203cc76d296976a49f71(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d76bb943b073581833c06377af6139dff795c2e8c05babeeeaf9cdb4874343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4730f6ba93ad385356672872d1ac8db4d6efc4af473bc9d86b52de0820e7e66d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b458e4c6fa58cd47dde455b144b7e17a43f3f03e27bf54aec4e1e182cacd8aac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9526be76e48356e9c9e013ac6fa39d752c0be38cce954b37381f8fc9372b1151(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40587345d9434b454f4afa4d041d7fdda383c442e34879a36c8ced533adf39c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0beaa349af3a70ce150efa736ad6d49d98027422f9eb40ea94d5b5c3e30be3f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c54e0d33282b9c80288093148424306edffcdd3e0f5dbf26d9275a6808b669b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406e626a74ac8eafa21a6cbb4462dbaf38bee564c7eb3c907ad51ba5830e129c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aea7aa1e06e549fe77d0904ad53fa3f5ec16575ea2bd7520ed6c397a83cafe1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0b40e6acc9b7c6d556bed3b0ca0e48c6e7cb4d1a9a8bd164f461ead24b1e883(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03a79569c2372bec4cb6aff1db015ae03d8a253fd0cc40028a179c34baca80a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1946356275b4b0d6f122a222d14ac8925e3e0965940724616ad9da17f76db029(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eeb809de90fb8412a7b0e7461f25c093b2bba42264112ee544b4c53de9cb98a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48a66b70a33c50bc96ec7af760ad633367cfde804be77364ae6639a17342bc28(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a23bd7f96c63f80accbc90ef5ada7c12d0c4f58132057a890bcc348d11c781(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909acd9e1903609fa5fcbb92dcb51c13e75f20d7370c5dfdecd6ab6e486e3c78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f1b75c89961020e2f5867a03a19cb4422f5cdcdda1d7714d1eeb719aecb612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86277a27a84d8d0faa7b7f8324d6c6681531456eafd8c01e3eb1ac90a45f92ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ad01ac14514caaba21964dd6b2dfc95962e95722e4b05210d17165da76c397f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be46cbf748f88e8f83fb1425e555774647075178c5f41a4b38f0b5aacadf9090(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b24f62704a225e9ab7bf3414743ab60a4bb40f282711080907543a45e4190bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666bce842471b063ac3826e46cbe91466a0d67784897c5d72046c4d41b82a494(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa927a837254dcab1c0e3b94c149a5d4938c82c472418b908e2941c17715f0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045cda94f359db1b7112c670875a105adda4eebb8fce18dc929fca311b49e8fe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eef314b1cfb20e3ea578ec9c0c0453b9161aa9f4413bdd26d68f8ce059335e77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e4d91b7897beb8ac51512bcd587b2d985b255ec96e861c62d9f5583458eed0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c113af8fb4941a92c2dc37457ffd29d9d6f534f984c43730f4140989349362(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00fe840284fa1b3d742ab064e209ffd532cf35e041039549d0a1c0a6e876b181(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__164c0e532fb833936026e18b0d8651b60525a4ec0716340a021b5f823ecc6512(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4842d64d4a744097e2f8bc87594e44f9bb17395e68dfaee21573e8b1b2329b55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9869cc14e82341664187168aedd508d7b7e7285503689946e5dfd909e9792737(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c821c30f1a21c49959b23a0ab34357d313711badd2710f6a973fb72fbc13efb2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be1c20447660297c1add7c983fe2b2e7c45d8cf675492d7e63569a7263cbb367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72956961a65143f83ecc6c3d63b18af247229c83852c32bf5e11290803161c31(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e61d032d2a05526fd678c9d5d86f1cfcb0ca51db971d19ee92a263388e7ce5d1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce5626ceba77c4b8783815f2b45a375f72f77e2a092f7705b52bda2d62f5c1a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12f21907967e1d725dbe07fbf50f08269368d1c3090ab2852173635c7c75d8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b840002f51c01977ef29024b11a3393c56daecdb144c8201905d6202b1792a0c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29bfb39093881bc5c40caa1af9f618653bfbfc679783859f042b1d8906bb6977(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e570fa38efb6fa9824b31384d973ccf8bee4ab852641bcfe172e085ca6cc0376(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c751981bba89d7cd07726f1d22391818d5d9c033b937d557ae94e752282032e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e7293bf5b3be5917830321880298eca6a3714a9658967d31413bdf56c78a51a(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eb0fb190772e9a935707be6e4a873ef26be532dbb32667f8ee2710e8fbfe6d6(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17597b5d0bd4cc5e181fe8cd326bbc85da9d9c8425cb42e443df18adf3ec75f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdf696c75d9ac7963e1483cb46d6e8e9c1608ec64a690582339e075794a6166d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d869038c96509ad7df4f3327587ba52503dbe68bc4da409c86516975dd97c6(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41a046a3f9768a91e2b8b7cb09479bd9ad0555af4712d48d85d2597923a44f34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12a973e0ba74837d73fd032e16d0b53f314d609e8766f205312461211d1c1ee(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a66cd9be3151829a1960f85fdd2613c10134154f3b5947a8fe4e67dbf5c8e9c2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1045a53ede8dd9556e21f6da66d32393273fe564e9ae19feb65bdbe7f3e07db(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61c85331d994e01331c503f66b58141a539f5452c3a18c256594fc945ccad73d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__839e3007e181dca82c7aaa231b301bd2b0fe5dfe3f6a2b9e5267fb0f651bfb0f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8060379860b5f822da9068cd01dc8de28168faba97d7c316180b26401ec95de6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e583d4d0c8c52c8cf68d48efc18cbc3e954cf2ca21b4d27b1fb4836d9f03ea5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4da261a6b74b95957566f0da00282572436dcc305cf07db4e6452b8b3c4efcd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideoCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475bd14699c10008f8a3b7b4a77b5f0227a0f401d630d63519cb50497418be0f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__826cbbe8aca09c799f935a93d4d164aee7d132800c8882c0294ae9203f16649a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85b243bce4ed5d04edd1683cecc45c096135b45c262183d3f82a1e4d9af3dfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17625b03935864986761088b149f717a3044f32d9c03dbe283a0c07b2313cda3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c59587e681590f8b45b6394bf677d2ee470779740a2656a2776c8b415661957(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84985b6e9c6e85ee766521c56ee6bbc0f5687d2c88af6ad41194daef59504ed1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__715140934235a0fea31e76599a3b11bebba68c9d9d5110c77967192a45ea6867(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf67e0a226825034edb9e02b282098e57639f76e3371fae89d9deb3d94d696f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e658d63ee4d468bb48188d5afdbb29e4bf2f5e154666b6294fc93cd6b5736fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fa605ea9146cb7d5780049a045eb925ec3a0b0105fd1fea305fe799b39b864(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23657fe55b9f116f4871473cde82f9c8cc29ca942a643ed9d3d2ed8c48cd47ef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca13471f34b741a8d4b8c717b6155171eaf4f56f7c3fb30d900cf8b293f170b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8840aa0fe746b1d37ef598de1358cc23207b49b549f629a8e6d180465a03a75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca3ed2c59bccaeae1275bda5c062ecc8da6163648924f56457261c9ec91309a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__249e8402649ca84869c410005b4b9d846116e7635b41ee517bc77c3be136a1b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f92cdf6d4ea857d9778b0bdeb0d35684948c84a1c796f16fe1563e800d95e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__611b12c767e7018809b246e61152beebb5cd343dd8b95518f4b96d3233bee065(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorImageManagerVideo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a4829afd1eb8362cf6db5ce25a60100550474000820d6ff30549994781e124a(
    *,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be74a2d144eaea08edd399de3ac410a4324bd2854ff8fa5a7a38dcd60cdff10c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7391c19492acfe9c6ef291b52e6ee2c4179b3b79b3981ba641e37cd16a1e230(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca74b04a2d5cbb4677d1ee780439b3dd607061d09f1a9986973305a0e917dc65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9cb933ee9b647b22821b99efeb6c4bd08ed5333dd7733a98a0f2383c8c910e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f66d32d7d52b0b8d3a092b2ccf4d175b519297eece07d9cdd10e3d9c41f90d40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c334a98502deeeb7e27aad3991380b705952535312ff9cef639cb7fd8337232d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInclude],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcfd2465b9f9f687cb86c52b5fae26606153540c41b590cf192bba712c6a836a(
    *,
    custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee2089c8fef595d66f2ba3f45707335f19c6712fa4799d0e9fa43d480e0d30c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010c6b9196be860915936a846bdb877f5264b8279eec6bb2d1c519ed1ad28dd4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5172a55aa44a4b0062b904ba0517a001136ddcf5eb19b45f4ebbbf4f62a6e97a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca5c8e58200f00bc8a7cd0c517c956bd1c147b088ebb16f30add5bf0d1c2ada0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8ca7d59d42862f2895752c1e21bd69340522bd437f9053fb01a0fb10206894(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7072d967d6be240aa3b9961dac8b9ac918a9eb22786857797dcfbe0210a0ef08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a47cd35ea49f8ef9807b087519f5b8e2f0f933cb10980e82e2d3cc2593d6805(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstantConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f02ccda066eb762d00ad78f410550732c656e18e12b2c1318fe2fbc5c5c5314(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c33f1f39ce49d7a4857a4c031d8f8416fd983efc73fa283336904505d56de1e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__126e682dd46fe5c6640b289c410650e6203aaecf87c3656c6958b572df004c30(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb99c3435b11354489026f3f7669a4d5bbfea8e2c8c47d533e54efc2cd2881bd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eca64075c66ec6e5993e0837647637bdb396c402fb4bfff8aab388cb515b7a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb0e6c38ec7a72221b3681b426527f9cbc63dfa07685cb70493c597f2eb481d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8992ff29c2d97a0b791d464b3d03b51add115773f67c2b7b11102435ee98f4d8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff201a2e5aa8200e871149d81e87b452f6774b6477e2f85baa34e9d08cf8c42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ddad4deb62dca28e9bea58317d50c3547cc63c3577bb812713bbf904795721e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e419d090620c04c2eaf200fb88dd967be33c335e83bedc22c1bcd2b9dbeb4497(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorInstant],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8f07ad6bf4230431c603444953133689846b7d404df943456145b79701a9bbe(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_partial_object_caching: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    minimum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ee92039359def77ceec149598b1ca2046cc3544d61d5f8212a458ca8a95613(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    fragment_size: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    prefetch_after_request: typing.Optional[jsii.Number] = None,
    prefetch_during_request: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffd8adb2f073c8e89a4b477e5610780f4350c9584f6ad477580aacec6be3898(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f4e8c9ca8bbc7c829cce3f1d65fc128143a2d5b5fa8522049005b4a470628f6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bccf352b167a1b75035d837d70e1e7f2c5ba126eff7371cf4e275aaa80278c35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4efaa36309b599dbf11993ad566acd8ca0a3de0330cbad8a007de804e20ebe8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe17cbc161a022caa8266d3444c7f6cd5520fd87f22b2545deae159c3e4ea574(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd3f1f029eb0f5f03eaea31c7728eb0e355b12b8b1fd50192906ef337730a079(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0deca674b5a8a1576050ef662253d335fb85aee14f4a1026983da8b38fe6566(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6730765565aadbc274c2d51727b5e377fcdd06ecd6dafdb22f91278240e383bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b7f8abb68d90eb5e96d7c0ca9a645e8472df8e9466e27013fed9e56ffd44a4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc21662e0b3389b6efce94606391941e00e73348e38c1c5e12db19f2e789f5d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimizationAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0fa99a3f43dcfa9893a75b19ca219af9edf5ec34be5ffbe44f8d5b8ec9454dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__593e96eebf7d5cff763afcbfab437a0a7d7db80c0ce75d0898f98d660e853d9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbe7145ae0559d7a89d03da9c70a8ab0d3fdf0c16fca3f66591862070c2ff94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52ce2c97781dc901b14954db675a735693c4cb1797d41e8073f402d4ef297cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b3821469471d2d065ad56a69c231c6b955f64e5a608d5a351a80c46a3c00474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__406aeff3ace64cd2780c0273a338b3cb9fd73c51c3bec5390929d3b2b93b77be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f35cdf86929d33eb870bc9ced706e7d406a8ce4ae737bf69bd5e6fa5492054dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2862c3e9b5973852de4e8f1b9fc4d8290d69c8e7f9c9f8f2c730cc0d35b7e19b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc65c2b1eaa6334242d205c0c4f2ba1d71b30667e4fceb5dac25ba2d0dcf5fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36286e3c47c3e5c1f5d3df6fd774bdfa9ed299af33db360ebca41f31e0038d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLargeFileOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00c06a83f9cf94da2f15e42fe4bf6a49c2f1d912f832f155a1d2719f32352969(
    *,
    bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086d4e758a7b00e45f14d1e07c0c6e0b291becc3ce2d50ce15512b8d615bbbcc(
    *,
    bitrate_unit: typing.Optional[builtins.str] = None,
    bitrate_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1364466b2626900bff1a1079aefbdede9fdbc23052d38d32865013807dbaeb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca51cf4ca2bb4c5c2d2397cc3154f2fb684ac9caaa26583f50943a08bb9256a9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc3675bf9d0cc43929091b18f86640e961d7a5dc9ba48174429e0e71c6f9777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3517add0c8dfb7f77b255db15188d9ca659708db16e5d839d3addb2e62aed5d8(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d44317fcfe295676a713de412d91cbce8e903ee9f444368db36c26e7c2f30ee(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36413b54b51c22cb57f060b753dabe2c70a9f701954d2a2b3a37f077afd2a42a(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3eb944c3ef3a0133ce1156d7ba22b4a920b4c1dfe48f21e96c74b3e0173bf0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ba31f1d487b458ed4a3a329a4bda265f67d21b9c8cd2d71693ca103934a0f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c93786469d4a399e7dc6f99369eb20702fc67f07a9cbd56baf358a67f4baf8c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc5d5f2f8063ed875837514e401d6a55e92e8ceccf1c1090106fac25af5354b2(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22f3f5117234d0ea376073ffe15c50a2510d978ca5dc3a9ae545ae3e44acfba(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5b1bc4d3baf0e4dcac01f378c67061897fab85434274a37387a62cfb248768(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea96c3d437c8025f39dd3ac052e0431606090aac78539a42e8ea8bfd7f00103f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fdbaf76a4f57ebe0cb90bbccc6a04a035dc5d57fe2ed03c0c490a1777164275(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caaa07519fa4cfc6fbb144fc909e8722e5854041dd8cfb0a8c3c81b99db60307(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee9070780c4ad4226dda743ee3253ae875c5591e655da33ae59d6c5f61aaed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f9583ad52bf5403738790db35254410cdc7af979ca1979a512b662523638c47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f8a2ba0f343c6f462e891c975e2064f124c42b725b7f819347c1cfb456c6d9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c18bbbcd6de340dbee4d70717b934310992dca611e2a66eb15bc07303709b62(
    *,
    threshold_unit: typing.Optional[builtins.str] = None,
    threshold_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5661c565275eb262f21a9bf32d7c701c47a7136f3bbfe8afe4b43e2088440221(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__862a88a0935cdf3c030a7c04687cb0539fdae18df1fbe511574a340a5e2db783(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15f9120bb91c49975da634e8cfceb8bac6844d33c450aff736bde5f77440e460(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e40363cc72723e4e6558e743ec3ccafbfc89ee0d8aa48b0ea63a33e2512a096a(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa25553f2a210d87ca0dc9e0f287e608c3f24e017fa06fe2c8c52bea842ca88f(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f12eab2c8b544a29e5753e0e019c0dbaf4bd58f92d5bc068ba5239a8fc5ea47d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24205584c714e857764e33d4ac80fb7abade2ea52208f2eb2b46a863f5002017(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bca8e16fb1bceabfa937be3f09bf9e68a2939757d73fe0cc1445e0c653e1c0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7714415375335dc52a7874ca67a0de3051311d63638016cabc07ab969946dfd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c278ccae29d50c52e26cb312f57d028efd9f79569ecc052dfb8c72bb9d02734(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLimitBitRateThresholdTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14078fbccca60c1b30db048b5935c7cac7531bbb58fcf3892aa9842a88b9110e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7f58b639700790bcc8ca5e5dd2ab9852e45c09df17af6341f7ad31a8b752038(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f25321ace0afc002a20960c8699b9081a9e4f8ff0538394b682343bb2f8410(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab86fb5d64fc05c3b6ecaa56df370ceb5630a62477f3c3343a398aff55d725b6(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abd55ee52b5e9f6bbd7256531e338c83a21d7c3f16108d19132acd5d90ebc1dd(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d0a9a011f72eeca32e2cb73dbdbcb3182eb5a9d8f97266cb4a3c392fd15a23(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43993f4844de7b7a3ce2808d25aa82cd242ae9097cb98b2953235a8de43a8a0d(
    *,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19e969151f64e876797ebc2a451c7f1d1314e89da38e9ed891a8a5fa26c1c3c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f72b6eab1948f72f1dba63734d09a9475cfd78b5b94daa061c6bf38ef60c2aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bf3d0aa3f5c4ee05f62f903a7256d0ec1db25ed1f37fcf57b7393adc24c55be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40861e44fa5b6a04ebbe53d220a3645065606c1a10cbe1696e749d0bb529688a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe807730519090af265c9fd1a25a430de26dac41363401d373140aeb0744ed0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f7490f8a45db72e037ee1bb73a131ab52b04aba60bbcaff7dedcb841e9dd505(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199440026df2258d0f2f98afe71e39d81fa82e89b51c3fdec803c3652d583560(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorLogCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4b435e57437c1e3cdce2c0391c00e816606693051395f0a7ea20d580577722d(
    *,
    api_key: typing.Optional[builtins.str] = None,
    buffer_size: typing.Optional[builtins.str] = None,
    config_override: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    loader_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_optional: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f4cbe90a9648a7c6892f3dcd27a4d103990ea2a36e5ddd45fea415f7e4c564(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba540401bfda7678583bac7cc27fe59ae5fdc708fd0d226b0ef15b6f51351e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b08484f82cd2dd3bebfd084e6a51c4db79328088359ddccf629e816382e885e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4953c7e8e281087ce1f13b0740a3530db96f235a06284c8c4e7ac7fe19ab32a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a30f5f94b5914e1929ba31d405d20d553154c2d8219788ad68c9b3ce462676(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__611d87f564cc9c359985afcb847e2b0fc1e6ab700298bfea4f80dcca635a486e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f56808d1fc99d96e68e79a02cebc060b9ee7e3d91b2cf91981d3f68688c87e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38eda03603c64114514227554f30d16a13a5657914bd94178c7a09e9a8cc6d2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e08b6f81a95608c7dae0e6c0d760b20c178ead9851dd381af01221369281f24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39f6f922f41c7d88a7279be9996b89bfb09995d5563b18c2dfa4c659ec83b0a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9cf31d887f75b851ab069fda661a4e3467fa92ee749d445f38dbf49dae3f8c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aaff37835463e0f88d30820ee10c130f27d18e74baf52f6d55b449d8ddd96df(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMPulse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6469973e9780b6a22ba058cb7be863d39ec37db15fb44b82aa1101b1698091(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
    hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
    hls_mode: typing.Optional[builtins.str] = None,
    hls_preferred_bitrate: typing.Optional[builtins.str] = None,
    hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_query_param_secret_key: typing.Optional[builtins.str] = None,
    hls_query_param_transition_key: typing.Optional[builtins.str] = None,
    hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e99fb9f866bc4dcd1967b0479fa0b6adf497a7b4fc8ab21d72b51a9a8609b0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ef2b4a9ffabbece0da4a98c83dc5c4919fad9e94adbe13eebd9927453193e66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94be0392558db501eb01cb8ed5f8ae1ac270a8444fa114d672381f2c92de75a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dfa7616178a3e01e8addc97e0e55b036125dc142d67ddd04c673f479e4d22a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccf21840184707055861c1b6e3ff57fd096c07e6a20dda3e43d58fe885f305e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d9e1cf8924d653b4fab5eaffbab093fa7ada43db747ba98355eec6d84b56a31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc4d33b96f5ea7758afe2e385ed49271f4debf9c58abddab50edf82d4eecd0d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900ed75623c2a88311503b1d6fa61aec16d80c574b1dc8c78934546397ec2c14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6e9ee10462558cf30e684145c13c9536ecb39a9ecba779fbcfd6c09975b7cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e543a136102ce8d319b16c0106e397c1dd617d3eb3043161adf13b32e42beeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb7eead3c6d87b32bdb8b734fc3e109e017162087845b160f2521035386f105(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__762561d11433e482309f8109b94dda8134fbd7bdf0bdb30f6ef1fd036b6dea68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25714b993f798317d109cd81f578c99536c08e4253575b640707286e7b6e9c14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98b6b5c1952bed0e16fac810a3c5402049b6fc7ef4bcb53bc0bba446a9e22a2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50760f423ba55f42a582079e0f1029b9dc82f594830a9b86726d839adc8dcc40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f3aa95449d650c09280adea696ae78f8df486b784c1db7b9625e3effd42828(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c25cafdb37062c59c748c5d86d17c1f13b7b5fbfb2b8bff310f9dc67607ddf04(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestPersonalization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a130a2cc0ae281c8a25dbd921196fdbd35a474a39bbb974b42b9a94e6489468(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    username: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7bd468b3865e2b0874603596a87238dce32bfaf026d51d5892d4f0f55ef639(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc1dafc6e7ce421c08bc41ba6d29e4c447a53990de1a44d25534c3d6c5bacde(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f43e5fa449d43cd18360f8bb9cf0a9601432543554e8c1fd9c15a4c750ee97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__175c3a48bc6d5da5232ad7b15abeb214ca4fe012a4f8a3b62636f299fd53dabc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7542edef3bc46ec56b0d5ff6ceea7a25f59e1820e94fd659025004805b7c433(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bae67faa8dd91a8fd934249135fdf0a13293b69993249ae5fce36693072480(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b1e8ea6d76c0313a771f635a8b68de56306b5ad5a5ca02c8d38a8aa3a9259b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManifestRerouting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6caadb9f53c44e0d0ac4ae7f87d121b6487f431c017b2a8bece659c6f1cb545(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a7bf8d9ade368df1c644b7d773042348fdac8acb4fb2faf16dcf877a6864433(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07c289912b89d53b7cfad33d3fd9a3f7f306693dbe01b27abc89236735f525cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f15326719b05158bdd1423be394af80a4fb415596a43a5ab215e5263263b1ff2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b54d6d17ba89797646733b572faf9f793788848019ff6c9872b9d15512af8fdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d14f9ce42a1a25aa15d0f8ca800b2ecd8d92ab177e8eb705ec28b3d18a7b5c45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bfedf47f022cdd5e010c1bea6c961e47b8936e471e9dcdfd29f49a9ebfcbd4d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorManualServerPush],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce5b5ece3990409ce5b684430a27bcce395a2bdd82ac9771abca7f0f421970b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c988acefac7b62cb3ed19107053cc100f4eb025f302b3e794daa97fd49635394(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebfce4681b2677766878b3bf01ae4d36a33d694d00b3ecaec6e202655e7cbced(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7352a8c231a12fa2a95fdf20580166466e7d223f740beaeed61d80bdb9d6da0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9db59ee695e12e6df06a038622335820c05bbdf7d40ad2b1161c366cfdc01fee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d51dbcc2a7db22695e6f93af9f98dc8038e95caa1bc1bb6c5a1eedc9b0e82e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df6ba1a4bc41b3d3bbd70b79538a010888e407659f93897cfd843ae9a88e06b6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48b5ec9066803cbe4577e9f0c8869cc8896f24c2949427303d2b13952fe81f9a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optout: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8967d74c2ef3a9ebf53c56825eb843a7bb9bdb7abe312c475f4404a91f1e77f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0a71944f8ba1f866b951b5f83349d19b18ce1c5511cd165da5a14fa64cbc0fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ec859b36508b048e51e0db12c632059ff0fff3aa7ceed719fff87b941a4dc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4a20fbc453ab57a6eb61c82b5529fae5253c9993ba64ac9c3497e6ec9f96c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0363a57223ae9b363cdab06bf396127625147f73dfa58490836232587f51602(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__274f368b8e76cfca0bcb92a6a6cc652b7419375d29c41fa80dfd67c5adaeb1e5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaAccelerationQuicOptout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a789544e8e715749307052b1cdeb0123c07012609ed9a60a8fc56d8eaec764fc(
    *,
    beacon_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ad778f85ef8817859059220e052f7dcd7e6412efbc04463e435edd46a987c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4f929a9a37a60ab2e1843b54ea1a9785704fc8e681e704ff5354e5ecc6cd62(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a92e8c8355efa4c64a92925f8ca177629392c16bc59eee7399eefc2c0ed230e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81286db65e3dad0880626f6788af090361402895c36e97932c4354224a11842d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891fc5608cc12ece68b5f7aad5e64ee61da2de59ff7319cddefb7245c762e1c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8caaabe6b23c41ab92b11a51cf97e30216c87114498531fb5c19d7bb1d80f04b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66ebcc95307ffdaf6338df28d9e0d99abd972513f0319cbb10287a8a0e9b390d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f99de19595d4f2265599bb994c1c7e208e332b1a13675638b3d88c3b07bd8c49(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18f246113cdd1d08832a99db1f9b088bad973307cb589e448f0ba7c1dc830a0c(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f406a0910e6fe2825b0cbcf34f6a61025af471bf378c5c0ca38e138e1e13a9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd141bbfa4d6c29aa9994371328be7e9800dc019e1b48e47d51a988c6d65b563(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc53f3726cb065f283e8056b599ea7c4044ed3b590911e8d8ad062ab444ff14(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffab7ff4e691496c4d3574516c0eb4adc2f245f1ac384c9dcb154f88e22f6c75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7e5b957e446c276782ee80f61354ce09c7c49851cf4cf0cc2b7290f5d17332c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85fc14982573cca302449f03bd61b5e08ef694ccfeb5666a09fc4497c06a0ef4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaFileRetrievalOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9a281fa131e167774d9ecec251dd22f81c35e45edad2a8eaa93a5a949265069(
    *,
    cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_window: typing.Optional[builtins.str] = None,
    client_response_code: typing.Optional[builtins.str] = None,
    detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_object_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    object_unavailable_backup_host: typing.Optional[builtins.str] = None,
    object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_detection_level: typing.Optional[builtins.str] = None,
    object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_modified_path: typing.Optional[builtins.str] = None,
    object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_protocol: typing.Optional[builtins.str] = None,
    object_unavailable_recovery: typing.Optional[builtins.str] = None,
    object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
    origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
    origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
    origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_protocol: typing.Optional[builtins.str] = None,
    origin_unavailable_recovery: typing.Optional[builtins.str] = None,
    origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
    origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
    origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
    origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
    origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
    other_options: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf82e1cb438e3c16b434d882bba78ea07ce2e898fe8dec3eb79314117ff47a23(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2517a80b0de02f1a22b0df5f98dcd50490261acd3ef84a4aaab1857c38d08dde(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc662c53008e3d944a9e76e2d1a209945a190dfac59ce80733e7f974e054650e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe8029f55e485aa1de882ecc3d7e259d3f0cfcf4c481e577b739f4b5cabc392(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd6eb435f8a160b4c3722f5eb0b507388cef15eb5423416bd1cb13c2f5cedc1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfe785d8f1d40a72d0ec61a9ff57c0a6956dd8b261c51ebe10846e8ddd42d9ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd0171e8502d78fa91c35f3b94f2a25e7d97303aef7382ff236cf5b21a4166d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__941acb9297d881f8edfea59086a146912c24912c15a30f68f03b80dce286caf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f9d3bf689be7fc9d83d70606c955dc893ab7fc0cdab02912c87894ba4b9596c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d7659788c30bc0572000597533f305b15619a520b66021eb13ce88d28ad079(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec8551aec868a7ca5bcb017a402b9a73de10e5adf5420cf86892d05a8698339(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ff371217412c4664df7693ca0ec8113675c364f3f231e7a2a3627c9ce7a7c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78728ecf7427fe7d143dd6feff7900c2d8588f06b494a5cf45402a49d580359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__298a54899783dd3bc07f538316815e491f6c84985131a60083e1f0d717f91b55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70b2a52e76194a97695a2dc84c7ea5b572091b815c41b5378dff0526ca746149(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c98d044e7ff11b098548423ae70ff41041281078cf8cb7db7a63ac0cd44fb1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bde42a605500f14487c40d60c0e2f47346faefbdcb4fcc36b0ea44f453c93d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57959af9b0bf58ce330064100f476101a7a9855812b6f9b0318ce257b89ee6e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2a6156c4a319a232ac3d999a36078529994c279ea5d58fe454053d97520a0e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c813357b9aafe5eb5d263e5f442d6d001adb82e717bab7a2f23ea42690b1ce9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bf3eea8348846350a86ffa6615ba0a6abf49a32544ad4dd4eb1d4243ce60e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c863def4b9333b22956f5d51b57570e9fff7b52ca8f23dab4ef407f6ad1a72bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ab9424636260774dd7d9300db3b394e9ea8072d37c13308d2fc113f83585eee(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1acb31464711a36b0fbf1c207f3ff7c0d3e5893547adfcbd9d3a68d506cb23(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20ed8e3abf4b36a2a9170c33b22a6cd4bbb9c6467787d0458d13f9de6196e62e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd33ff6463f56c2d5682bdf84ca392d196141d96d175341a963d19eda450a881(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84cb3ec4c244db5974c2a3f7a796906cc754ccd6a0aebaedfdfa0b2e6a3f98c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8562c3446a3cffd6973eab830388bfbd82e124ed8d9e85ecae33a2e0aeee6c49(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785929bdef3f6e51b921796b6f45e417b05278f904f54560b4a9c755cb1fdf7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81c99cf88bfeaa4d7ae4ac442b9a20499f0f37551fbcba2fe336efc11107ffcb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d472d756680a5dee6b1748e346a2b8032b3322d21f849dd86a1947e997b5b6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07770bac3f1c63165feac796a655e324271148333861c0fc28e351898d8bdcb8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4206874196b1691fc8520c0ff5bf2067b1eff4cd330b7629843db751f0fe110(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a167b8b718869d2527417a3be01b87cfc79d44a24d07af9f706ad9aa3100c6c0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcc7c8303ecce8284abb4b36c3e048be961f5793fb21198db27893e20c1a01af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e1c0c402c5b387ecaa532340938592530bd7698ad72e943a0016a90f80e2cee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4bafc87ee4fded34e254d7158b786341a18fdf4207f0060d29d24adeb6b07d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d313861137ce13ef592ed1bbc65b92d0fc5525215ec49739d944b1ba82f91297(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8c59649cbdd2c21464c2548f18a64981378a2ecd57d0406ec24019b567c09e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43181138cb3a49644d5d9d7a71568dddd91e06a55945b0b17c7ff9fd9d5ad256(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a88041ca01478c93fd8e96ca73fcdf9f7dae8bf257d6f6b701f02e931df12905(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43fffb189aba4b87742bc6da903fd61a7d9cd60148302ac7c0681febead41d1c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7ef2378a5da93a541e78e34f4e75297a974a8ff69d79de80672fe0ee390c2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e159be7b00dd612c9c0b31a7d3426c489828e96ca8aa69ac9a017f4bb71165(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b81ad213fcacd63419a03cbaa972f851ffe79105b358587e7e91a0b2acec120(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5129d9cb125d4cd9b82db149637dd2ba7b5f10165ae0dbbe7ae946d8ec79d49(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d0748877d10807064dc4c2d7dc716fdbf2c2c6d40c5dd6105c898e76914974(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64022d24ca72ca7ccb9902ae5621e13de8cfdcc878ae323932378f32299b0bc5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0742831e0b5378f3b053b0f0071aaa3a64cd3657f6150ce2061b7858fd397f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47c6860b4217e5ef0e852b287c4b88d69350c227292d1f1d5abae6fd6a699b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6166aa33cc1afa93acd7c99cdd2a58bef4c2236b75f9f70aac360741cc15edd8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545f151f0fa26846043c5f18557c3edcc1fe40b5f4d8614f3ef6d63ac21f0e18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6685cb0460f76c92229fafc49b6ad56dfebe483f29e15487a44287d713256bd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0d52c2f3d88dc4cb68a1dd467cf16b394ed2f4c12d7e25445b149bc6d264da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__080207005b88749a416d6084b900d2f9850f372048f26a46d4a32bdfc31320f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__927fcda28696fb4c11358ce227a14858debaf80452e5b1baccdb48489d2661d6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMediaOriginFailover],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1d3f94a44919029f0e9c9cd44696e69bf41748b14503f8fa654ea4df09bab5(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__265c4f18c8a70ffd8db84c05784dd1f11ac4218336700008ab2982076c1a1e45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b01e07c05062f1d653747611b4ed68917ed490a425bc13ab8041df51d7c2341(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516393845c65d413a68e2d392bc88d343f1c51a85fa6692ad300c9a35ea4427b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__175811ac37ca675508dfaf69abf32b59ad3e0e40178e99366f9ad72369b8d541(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1041a62e813f7f3baa9dfb28d12433fa51136baf910bafbd4c67bd2dc93d035d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__226304654cee7578bc270179fdf1c4b6cf6f0ab0c8718a79e731c4bdfddbdf7d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMetadataCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d38f3ffe91fb9e57d1ce26aa8b4a4fb24ab85f33521612b2c9ee71e00b20214f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34ceb9de2c1c10e03ded83f2f78a1fc03bd36870392d66731324c53806668c01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376bbdc06e8eec220d022798abce48181b6ff4ac2b6e7b5c5e0e850d44f74f99(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f3c9b358de27494c9119491088f2e4f87dde7bc5e8ae7b908d7d3761e16f237(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea4fd7aeb2508b011673a70de237d9e146ba6f3fb8312d0b49312f0f24ca3cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb99e6acc1bbbd7d4f378ed0c824cc8207eb8b0fc53cc4ff2f53404206a72ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5833c26bba24642e123049bdac9c35e0bbb362d31a0b0d277e6ac504896a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20927e8ea181eeae347bfa2e92c40e91b0975ebbe81e390ddba3259f22cb4891(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorMobileSdkPerformance],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7c6c4a4e1cea87c8a7d2181dd347baee54d6e0336cf167d9628f22b1246f9c(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba732315f05f38f50539f9a12d377a0321cafbb67b61025d932e69dd70cfd1a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a20569b33a60c29cb2322a9a2064054855caa3f6f5b5e294c905ab99b28411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c315e693e2df9ed9f4055d70335b59f7ccf6048b1ac39d7417f9087478d6eee0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53163cadfd69e2bbdc573231a3329ce9582a771e64004c9d3be4fa57cb6cf99a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e5df798987babd3bcd8b7ba1a02fd1ecb31c2ce700706cc1f49053ac44a9e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a746c1622c2d8c6990f687b984f3d76f4bf55f5b9c523b35cff40078bc9774(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afc2d5952ca9245261dec47025810aacc41dc6b926a674f3aa655a7a27231402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a818a5e2bf8bdfa56918852e1b2cb590569adb8e36c89328e94bff9a883933e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813b616b37b25ea7f67cc5c3cdfa15f360aefa2f9924c72d86a06342f9e3833f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5964213cf6d00406591d50632980a8b3ef90ff39108993aaecbd959cbc65da03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d3c160631af20f504bc67afb548a9b641b32abac0e4ab8c4f108b7062f26e9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0114a9c78e973be328c636ca8264d32222b2dde66c665a33ab42302253292bd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d8c3a27b381b6c383b374389e7d79703c2a24e8240ba0a1aaa322aaa29cc00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70afe285798d012788221c52ebb7e94f1dc5abac23219fc22e4a569248a22f19(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5586a2303862547431f4ece2815bc0e43b5508828187c450b9c778404a99468(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64421f6d5b2480676b8e3d879666f3d2eb2cd22cfaea6a248d040673a51acd89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9976bb81e076727767ead3ff6cc23290cbef68b5d0e65906425182a3ba72c85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e373f9f8df1314c894d89bd3f98508ec15e83d2c43c2bc486146f1b6b03dfe8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b099405fea982875bde7c2dcde647b691cb3c446b9034af3470fa494ff68f2da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdd85d8c61291f389d75bdaec8df37071e15a3eb1f39204b8c517034ef5dd2b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94cca1947735b24f616f6b64af7f539f9d383d2bc9314d34743e5e4b61cd7818(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__358b7de1f8915537fc10a368ab68493d2e737bc8791a32be9c91f7cb9b0954dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__255c8d50bd65e202dc95194bddfc4bfd87c49c356d403fec8b067e417701cea7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5fc015b65022294914035bd7246c4fa71d4d043e4cb9fb8de3d2467160a48ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d3c2ce60ea378193fbc41c7b622b2ea027a71ce7af618e21eb451281b0ef2c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c4d5909a1aaf570442033d065ae9f9f4840c68b89ab4e91490d74e1c20297f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae8132cd81dbf2bcf581afb8326415bdb3cf3b3547eaf64dd0108022b024ea1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b77b781b1185cc8cc2e407d622afb22773ac881dabc49923480d88280a61765(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b5fdeb2fa34bd5f6dedf125ef61183399ef222562aa7da3df3e01c98002e7f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyIncomingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd447222f7bcc5abc114d2445669e377c93fed3cc684fcbb3e5577f4f9bf89c(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e686ba6e6fea80b7de19766d90314aeed451e9077efb424d115599216ae7f34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2137b858bc6cfe79d8a6ff1185cf29d9ebc49bec78e8ca3f5248825a19e85b2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d6859724592df85977800dfdec1becb8b9aa55b509b4f2c9da369ae2c8c4cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9f061a61a69b9f741c4260c08f9ea8ecc7b3e419bd7f5b0014062398a3e2b5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d6662c4bb4ad47a0fab03629be08b22a45a720fa1bd045c7b4688ba28de5656(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1510111a4030599eea769c2fcd438901f8424bf9c9f8111f5b7311d99efba152(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__858d3899368ec9f46c5892078f2c4f8996937474f66077aca6a4240b64a0669a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfa0e150295c9dcee8f2b9faaad1275555fd07971e687bde82ef88aef16086f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c427d3e2feacdff3d585382693542b369e782127e5c2b5d8b9cd54f38cfe634(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c731a291db3e5629699fd87a6767f93b13df98de0a12e46784dd407f0e6f62d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a3f7b1c2722f9f0a3ccc6229f446bbddb769791f34b5f9dfa2dd94a69b1c999(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de75c693dcc99ebc7d37d484972437fa4e515b4e671c6677c0c65de0990922e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b7d22df20b9d8cf78f6d8e4cdc266db27ec864512bacd418a65d2f80ce284c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbaaea4fe76759e1395eb033b686e8d274827aee38e9b0c5bbc350e3b8c04802(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33fc638bddbaa29abdb1604a57b6ccde695f740258e65b8d7b797ab5498721d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca5058dd9c5e90ce93e69a2243e9e534201933d3011152e1b76d9b22d226a22(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2203f4131d818c027cd6a6d09c25f65777e3c1eb32bd8006d5370ca1296c058(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa511c8f34f10baca1a6e3510c7dfc1b654c35ba980bb4228a10a8f1802170a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81603c42a5a747ecef35febc39bf9e79e0de6e4bc67ed9e39d33441df0058259(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b4bae1f68c480f381fbefaaadb5ad3d4398ec668541d207c34f917b85a8b594(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f11a1411c8c61483144698bfbdd2a75ed4eb914624ea54faaae75c48f11faba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a639b0235feb21ccb1fa488a6a862649df926953ff5df9b2c81a1a0a4f85ea0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc9e407f7bfe7fdaceb3254207b2fe105ca7825a740b1290b8a8ab277c14df68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46fc0f84e8356c58436a09d232080d2ec352cce69aa2d8568be75dd96ef82ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512f7538f24e2b8d064bf55197fb00fab810d9a3fe226ecc76fa8b41b6743bce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de14b6cb730802fd3baa73182b1b0e02bee1d4db749ec444cc12c36f7712327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb375ff2d84fc3a9d5e94792e6f0951e898f27a66a3c1373fb3b544e9da8970d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45db17ccfe2dde18aa5be63025d9e0216c88dd4ae922c2383065474159519131(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90b8975a631fdf3075d9675f2b54eb5e85d2851a37bb1121be55f2227e7cbb24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c18528bbf3d13c379afc7387b75af592555649cfe01e19e0056a47eebd72509(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a44820d65b1b8ff13affdc067c6354428790fc2a601949526a2a064778226f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4a86056d5a6aa7b656e20cfe607cc167fda4fb127322bb3ddc87849ae28a066(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__650f1c2cbf401f7a21bc2565e6ccda77c360b06c096e3ef4dcf4c153423d3cdf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyOutgoingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23bba040a5eae712244e4ab509f1653bb614f57853f621e96c34645e728d4806(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modification_option: typing.Optional[builtins.str] = None,
    rename_header_to: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a3a1e7175e11dffedc631d1bf491032b903b97ea66ea2612d2667f204bcd833(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4c371d2c53d9ba60e380d9440e52509fb413faaffaad88dd6e90bcff8d5a12b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b90c9d5b2ce72ee6eb5b6ed622d7c1fb1ac8bad4cf93d6333dd308283af3b394(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d31ae7484592d4c5382ef9bd09addfad0e1e6a51dc9c88e596d9e891d8437ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0804c56fefa7803231c48150ac96adf2c84f3834544f575d558ccb453677f6f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc1e2a8e1b9176c7d491f27786cc67c5c749265905570b2601d4dc48b5e1b693(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffc3e024e1329650ce3c74b0290e5b00e230e20eaa70c2c4c4e3e27a36873076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8025b019b33795739826807b030ce7504837eecb946d16ffc6273bac48df1843(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorModifyViaHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf5ae4c439391e6b0b5cd3ac1edb43bf465598d66a9920e76f31441c04e94e9(
    *,
    cache_key_hostname: typing.Optional[builtins.str] = None,
    compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_forward_host_header: typing.Optional[builtins.str] = None,
    custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_host_header: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    http_port: typing.Optional[jsii.Number] = None,
    https_port: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_tls_version: typing.Optional[builtins.str] = None,
    min_tls_version: typing.Optional[builtins.str] = None,
    mslorigin: typing.Optional[builtins.str] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_certificate: typing.Optional[builtins.str] = None,
    origin_certs_to_honor: typing.Optional[builtins.str] = None,
    origin_id: typing.Optional[builtins.str] = None,
    origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_type: typing.Optional[builtins.str] = None,
    ports: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    second_hostname: typing.Optional[builtins.str] = None,
    second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tls_version_title: typing.Optional[builtins.str] = None,
    true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    true_client_ip_header: typing.Optional[builtins.str] = None,
    use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_mode: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3ca5c5a51fd2e8c36988532ff5c083ce6be625655a918983d4c31980af8e38(
    *,
    access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    adc_title: typing.Optional[builtins.str] = None,
    authentication_method: typing.Optional[builtins.str] = None,
    authentication_method_title: typing.Optional[builtins.str] = None,
    aws_access_key_id: typing.Optional[builtins.str] = None,
    aws_access_key_version_guid: typing.Optional[builtins.str] = None,
    aws_ar_region: typing.Optional[builtins.str] = None,
    aws_host: typing.Optional[builtins.str] = None,
    aws_region: typing.Optional[builtins.str] = None,
    aws_secret_access_key: typing.Optional[builtins.str] = None,
    aws_service: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    direct_connect_geo: typing.Optional[builtins.str] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    end_point_service: typing.Optional[builtins.str] = None,
    gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
    gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
    gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
    hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mslkey: typing.Optional[builtins.str] = None,
    mslname: typing.Optional[builtins.str] = None,
    nonce: typing.Optional[builtins.str] = None,
    origin_location_title: typing.Optional[builtins.str] = None,
    property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    role_arn: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6427248fe7f71165c6db4b323102411b7faf058bea426b3ab60d6616a8914a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8df62630089a528f8d6ba30b3f1cf4df4975fa658f95d981d9dfe0bc20426dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129f43916f0c442d843cedbdb92944f09c83c631d1779f1cfd1f60531d3ff63f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b953e96b81f65c33785b9b956f03fff968d998a5401c75bea968e3a712ebc89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e81ceb7c863317fb94fa674b77671e1d7e2d4fef8fcec477a4551eea8d48b7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4666734bba271c0d8031a04ab2ab1c4d0351c6f24eb344fc8d69d83fbb2daf29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__140273347ecd6c3b4b4960905041054d697cbed6059f28bd6da4b9090e9862ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20b8662478f6e3e3b9297c62d7c465afd665a109273c35aa81ded655982723db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a41d6a641aa5a0dd5bc03841c2cf77089b12c230e1ba1569c24587621eb8dd64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32444c796822dfa455d47fb9f04944a65fb30873f6891cedc394992f43563b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973ce47aa563eb8e571ea445f819f0b3b4545ed8f86bee1dc75277c6104fac72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1714e1929569a955641995d83e7529da9b3602f62188011ee7da82b1b82a3a1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20c31db82b4609992ea59ecc9d22b9774e170cf496c93f4b096d42a30c09eb47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__579e9af71bb1454ed56739380efe9c5c3044034bfe0563aca02bd015edf9116d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4f0a0ea5a564586bf41fcc0d02a7e678059565a0acc7b2ec9ea35c0adb6613f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__104562f36ceddbbf9823b563f434a2cf2c1399acbcca5b9b7b71d504d03630f0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3136fe67229d3701f7f30cac75eece0f1607261f248104bcb50f4874c0d373ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ef7df8b2e958d2cad5bca7ab2c2ba7fcb105a67bf8f8ccfb0afe811219d650a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4393ffaede0ac46459ed25378da0b37557e96d4d12854f931f42a8cfb252d2a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346a1ffe4a5f10dca7071f2cd9976904b2c60b440ba0f7bde32ecf7be66964c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76fb036a182938d7b7a12d990cfe4f4854557f42d673052666f51c0c3e952c87(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b14a03bc38cd15038958548550631faf4a00524abab237c77d2c7bfa5353355e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c202138e578755a3dc727094725a5435a043da96d8edc0f7f021fc74a499a11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0e6567f23649c49fff7065cb924d0f3fb2478d0f0d060eba8b1e71a1fad7d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7504a7d74a4137e1303e73b3452d80966d027773ac22b863979ba77c97264bb7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c22487183c33d3eab3f8bf0f8b9525e6cd51d745f4ed18bd1d70c77456c75448(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c70a26c89c64b21057abe1b3c95e71f827e44abef1113a1427a9c20e5b2e31(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d026c95c82c242c132ca35fa0c91e412906846d5345dcb69ee5c3b13adb776d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__717c3240a9165ad7205d14850708426c25aeb4bf61253ca7489fb74d9667338c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fec921e5135386eed7f39b45570b7adf2af118cc0bf8cb64b139b66fb510420(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c00ccd88704112305b19580acaf00f1f099c3e0831e9b9980f106fa49e15a346(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9121b9ab5a19643d251ed4edcee6c40b4c076403e621532eafbc2c7689d2dee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__528ec21cd14d3f58ea63163b275bee6d024f1bd2c756f5dbfe94441b5967a6e7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3da44bdf30c562c4136dccc6e2bc012142ec06f1dfdf23e04bc3a999a8758be5(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origintype: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a4de26196eabd57612322d48bf5523f3cf84359f3c5af14acf7b7c805176a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83930ff41386397eb348d6a9153ff5c3694f2cdd1afaf33686684597b9916a64(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e8e7466de1e6f4c1f260eeac030afa2fc93d3c85a364601fe38741a3f86c024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99ed7c55b249e1e8bf869cf9129d68e80caf489e1e091d42968c5f5968dfbb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44011cb42abb3384cd364372dc49f5ada15671dab4983916160414c35a784dec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7d390e17b3355b71d6fdb0028eeffa94a07f55755be31c3fe4aeb46c280ef66(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCharacteristicsWsd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__683c481495cd290d132b7413469b4da86b9467046172c06ed3378fa6dbb352a0(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5eff24faf237a47be0d580241c8f58a8e4ff8ddbadddf61096897926d4c4061(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcbd314aef2e14c752a80b7d364b8f747ebb9fc6a1c07f5961bf99712c127e13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13163121c0297bd3312e3add74f223d5c765f6d0331f69c1e5c4d16f96d010fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879b8558ba23a2db5a6a1a2c5715fd6e12f751416180b5f3d1aecbd1abbd89bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2807400c8e044f0eb8b4343cb3bb7ad12350c7c973a06ee951695fe3e4c341b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__472dc09ada317ac43c94ada47a6835ef299b066b0949f44fdd5ddf2d6bfabbef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__785038d2e48f413e588b81b60ec873b39808cf4d5976ac01a0797c8839035d01(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aed3b08eb2ffe1cd895d174f699d57ba5c9011ae68237d9d4be03f54bd40f42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__153ff391c74e1592339f8c7aab3dcc33767ae89411c03949018e574ef3c575de(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a37aebf98397c22b0d60324ad6a76a6b24681e712b76c361a617c87f9459d023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8042f95afbad87037f8fb66df134be2845e5a3dc4f325da598591ff95aeb1b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b05009f4894886af0b0b523ced0ad2990cd7e603b92775a0d9f69e438233166(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11f13b1efc737913ac47aaaa0780378003326ab1a63d7586f93424f31093386(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d70f4e721229cc91a76691620914492453b9d3bea57320375c0e48293e1451(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ca1174d5560204c04fe65d112d94de1d5b0cd6cfa743bdb3de524e7d78d0733(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603fdc1c5fe6e8d362c8c59cda75bc8644b59786d89d90e6fe8b56bc6e1bbd6e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36615b55f78ccbbfa1fea349dbd9d28b9737d6b8d4cfbea9bce90696f9cc2fe3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd52a1d0ad9a13b402d6386dbfc2cc0b8ee3f8f27b4213c98d2e24a4fa4508fd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68120ff6ab3e19ac9954ef1bd1060db41e087388b430554f8b532f92cf092fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8797db748493aee641b38b270e98fac0bf8eda8aba4737794806057020eaefd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f92712eb7dca9f4f1a355777b32088d9d8c95820900e7d736ca52c7280c9c52(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1894c5ca3d58549b736b854f1443260be90fba0a80b1998a3cb2e70e44dce1e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__766eee13e6e984fe74477a03cefe512e78e60232b7e12021810e3ed42faa4895(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78038fb57b9c0bde72cd3068386018152f40f44adee01534d7e644fcf5488340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba15569e44ed2165f287f7a40899ff5003883df3bc794fff64a7c37a519ca50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e101628e1f76c42d3d4cfaa469dcaff496ee5ce607e11cadb4710348740bac4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e3333c9895609482daf03cb3deac4197255c42aa335bfb88296863454d2efea(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1305704926db9fa412e9b77b9a2914e1385765b90f4b3b006239cadfd14905a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37d51bf549ceb6aeeb92da54643832cb3908a34ef570abfc8b912e68a735965b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a85f77ab87f447bb340b25ffd487bad6b893d095fc7470ba20debdccf8e8bfe1(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf8ce42a98a112e5bbe3c3f2282a2d4a55b16394a78565040cc8fb158525481(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d886711f21c9f41409e1a0ab3fedb6bd2a174434ac5f4b364401b7cd66fc772a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b55cb80b880d3dbfd0825b313f8a491742a0cc2c20f9788acdab7c678b65c52e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f20b69d076940bd82d7022d4b6ae44f20a480b535821228a69eeec361c709fe1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83da465bfef418170fb9092b2d5c1b0503c3780342a2187dc0e70612d69318e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00fbfabf16bdb466391aee32783e84a04cdbc61d156762b779150553fd30e4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff17d1dc7a23f6fc283866b990714d31a6d5435f4caf9974d3c9ae0aacbb1cc0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f4dbab780c04afc413e837c1ed332a3df1e95326a620620f5f446b04e590b93(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d264e5051f8c6bf93d2f0ea6f16815a9c171e5a794f8099251c3d87a9b39c6(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f112ab7e6124fe31121820712cd2e8e8cf1f1f7c8ad7f87c24156249691fd268(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d258f5948b94c54bbc5be50713a74dc38599d0540e46ea0a8124a05e457bc10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9a84941210e83a0ae95ec5cde9f44fc8fa7bab58b7ee5986d79b0c16fc860c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ede463fe9aeddbdc55c0e45b7564d6f08c209d6fae8a902ee44e8be4c2210fa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4cc8bd2620d605dac0d954a8c57f25b8d3320701ae24323f00f4295ff1ac735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e6587a4e3e624cbcaf54b05d3d410afbedaa1fc42e402ec44d7f083ed7fd04(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0157ef900d02d6defeb0c486d562c7ab73f27be36b4a74be9530eb432a6a74a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c6d47e03f69607e39835a1a909f5f26727a1139dd0164059df6b1724214a6d(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11841a9ca8f63c0b853ebab2fb8ba1fd4a7d3f5431b847e673936f3237ef95a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9931f4f035a78a2e3c87f2ec9616282e635d4449297a6e6670e1ea9121d730c1(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73a40c2f9f6b26765ce47790fd29b10e4de16bba46d73fbb51adea1cad0bf559(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4afc784490392c6f151549d784b8c1465cd4a95b58c9c2f6ae523e7ef525bf51(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d9b4c71a448a7024b93de9162abda97c1856f1e8f35387f59b5243f171e9d7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__449206dc0f235a07740b7b900103015a01ed981468c61a3cfdb159c75e4bd4a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8d0201946418ef5271b9fa2a52b50659b301941ca124c8ad2a807a6e6e37c75(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0269e7eb00204603bd1dd3dc2aab5e5abd4d0382c69335b7280867960c33f673(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a783326e3a89079fa9597b4751faf534a9422346c393ed9cc6e1e81dfbe0a57(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01a71ade99ef954af12edcdad5586251d340f19578f94188f6887b7ec3bb494d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f532e834541c602c68a604d91c8a6c71883b2e5b50ace38955c2f9d0d38d3b1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613905d42eec45b6d93d465f462f1e78dfa824fe239fadcf20a60f234f9e92b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe284d3c597aa88eb89e2b0bb2d2a0c717fce9d3ebf0e98eb68df79451ad4212(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a2011af13ec47a37adf2a65bf76a4f6f00a49254c342a47423324181983486(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__901cc3bcf40da3e5c1525461cac859d6c0b876fb1bbd40a97a1102cdd396b264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c091f11c2d35ec392f7afc17b3a8942a914e3ca00671ceee1fb2b24e853f7368(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__228c488b32e11310aa676333b38dd4f188ab977d3f5bd15b5616ac61eb7fd3aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879bc5383beec1f9b4d7a2a05c55a2ad05c704c05a231f37a47e149ccdaededf(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd81a5612a7c6b023d824196fd2c65cec2cb2909771ffc04b45c7083dc6bb8b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3b0afff4b4f907c23fbca1f058f82059ef8ba56f343bec9ca22c7309ca36b56(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276f6829e2a133fc112a91b202b45b289e9331b54c182ff3ff89f69cb4822459(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7a386d45ca062619bebe750b5f3f766c8fdd852350ddfbef79416dad4c869b3(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d4dbf126b8b9a1cbb05ead561c374c2c829faba31390570e9235e52cd570b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0eecea784cd44caf9f2825ea7c9527333a999923732c2181249eb47a57b712c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7babd662279e6b37661e554b4a3e4e6d0e0266e581f585fdb4b25cf83a9addda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__160023eaff2be9ad012a9fe49cf86343ec53d270318ba0e497b83b4e4c006544(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3feb2960d97216a7003ddcc238f8e2f88891762d79c5955f261d0dd61f36d42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5f8b224a4bd82ac0a5533df5beb4b2b71b92751e78d45a5543e27c24b38725(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificatesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6251e842494e5b8e09aa2e461caccfd118149d2f0c4ffe1d6b5c9d733e985b9(
    *,
    custom_status_code: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    recovery_method: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1d944e0153c763c5b6d93c316c3acbb56f10dafe0ad5dc0c70694a200bf66f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df9d9d8bcd368296ffad56b8be9cd3b1f032af0fff7cb1dab375132dcd6715ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__590d02cc66b785080ce4cb5c9c710f3f8332c26880b0f2d65bd7a913f2796e4a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3769d3bc523e1c980134c8b925ca8f4e205a2c13ae8092b7023089cb45c9b31b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000fbde3e91d6accfe6a6f4d16fd9ae68affc2c8dfcd56efd4eff024324d8a49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0055054661e37acae2eddbe919c14f50c33bf223a959d933fa1c79c2fee0cf0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28d82f711b422a59c3ab56a0d8bce68a76f64532be97586d81b72ab150c346e4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f50b088a1b24bc8f5b91608934887b26c06e90c7f4018e7c6856da73c8447960(
    *,
    binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
    ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
    origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
    origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
    status_code_monitoring1: typing.Optional[builtins.str] = None,
    status_code_monitoring2: typing.Optional[builtins.str] = None,
    status_code_monitoring3: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tuning_parameters: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41deec78dfcba73056c294f3689bc27601ac5138457830bd074b4c3e268f2cfc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d89bd81425db42266f796d657b7a2d656b11563e5f40923edafc820113d47fc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f6af48d95eec8aee186a38df1a6c833f85511d101d5118af138ee1c159e86e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9af25ba31392604bcf16d59a95e987218bff054540ae37e612199c307feb72a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de6ed639276de8eff3e0963151ba20e3bc6d9f30d9c3c9d30235c01b5c6447c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0fb9ecc1d3c2f503239e390c32f67f20f21e50ab18267abf7ca0191c69ca145(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3fe2dcbe843152abaf9f36a2c5f6898f5162f721a185431f5434224959bb52d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4826f8e463a1b2650cdb5e7368b33b8fe2ebbbcbc69a187102fb6767939fd9af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b5b216599474fcb718a353fcb5faca359b046cc4da3e8443ea70d05fecf462(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a4ce3349a5e6a948a02aecf52d5e165c6497f1b9a14987a6bacfe4f4593aa6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e15463364ea3a17614abc715a36932f849eee9ee5a54e0f272c1f1318b42ad3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616512c93afdeb5ea6d1a8a2ef79d1dcc3246831a791027a8b37800731e35684(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbd44d60f2aad868c88e67dea19ef77f1965250e3ef35dc05325da002ef0b528(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bbe719048054b483d2f076d444a8290ff2e9cff7f7b76ebeb3f05400094efac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__276d8864f18fd39f0de886860c687549fee190a39f5794b25f54755829fdcfba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__783d38d1ecc6530bc83af52938009e534c23c41d633c13be1b86666143361362(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a81ba9c2248013669fd8ba7134028dc985978b0e3c2c86fad2e5f4f70c51b68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e30b527fbb5b23aeb1351bd66196e26dd8ec4e08e67a40b0f4b043a191a7336(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__199f7f2c735258cea01dd184756316fdb2ce48d9162fe77c9853d36fa187a224(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09393acce9ed25741f6e1132f4b155b1f8e9173d6a9bf4677a64ebc44c2e667b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d64cbb438f06502e0ce4bb695a6834f10ade106c43d87c4b840b37b487b27b87(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2912c56935b6a4ba12f1a7d92b7f2f7530d86c309f233d26beba40909730566d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376a6aae223bc92eee2bb54a98018635f9cf51113b9e082514dbcb004259e438(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3582d8b8923d456a3d7daac00d08959df39cf01d6e9e540fa0bc9efe19085f8a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d4a8db219bce32969f77573d694e0138da260c44883e995daca5ccab5fbb873(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f905e7b11644c9ba7997ee011ecaf2a27fdd0e026aeab9ffeb6d08f230e7ec2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa517ea36d7ef7d07b278125d642ff1951b3eb639b67fbfb600f181d8da7c35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dbe601031aa2e63be7d7ce4654cad5814c2c215891666aabd9d9d06908df0a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ea72a1914010b7d83bfaed87200662be7204992168d4563f68f610ab3434b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3ad35cfdacfb104d016d622b7b54953f9729f9036822c921d1c2bb894bea200(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db6bdfe111c0125c101b474c8be2c4068aa4b6be4d8e3ceb056653c4e1c5a83a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b36e075b4c31e7efaae9b46bf6b3e734c4e1c035f0980ca3e81d5869b9c0e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecbf91cd94f280aeb470297ac76e68de3e5405e462d2751c12e9b73eb2130337(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a852525c370867be6c7b3537f384642ac9d73fa7fa7680c88a56c161234aa56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c5258ab5d6baf19634786a582c82625ec87a14e1390ff51ffde8362a8991cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__669b104169153c200536e28e46c2d143cd486fc9d998c50b4bc88efd62fd4257(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginFailureRecoveryPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4ece89991942ab1e63e32877085705b76f7600409aa44e6a2bf4092155d7df(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7484a152122ff6e32386357b712b598e489866b11c25ec3fc72ceba13d83372(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d315b024c76a92144a322b236015ba539be0583ced321ea42fbbe42a6b1f80(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78640c8676006ba8b24969067d337cd3b1ddc08ff3b49fb350d8ba3e3501f85e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fef420da23d9300a696f9df40065683419187a814f32f6918bac24e0907ac65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f5537c53319b5a500e267b98d10c8906a4428d9309ee326a0cbed30576a110(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd020b1d4d494312473f86d3fde21ba703ee30454ced40e11c1191e6332da7c8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginIpAcl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3124b5c415f2ebbcbdbf684bb10defc738c1ef3a29e1029cda2a7e8e341714c(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__662785237fcd5b2995d52f36a37a98e60e33eac7750150097a686e8db3cea376(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e41a89f2bf730f15418e30a225bad880fdd81f371864ff7bc216b29e5516b2c5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da069ab269071f069b091c79a72a2a63963ee350c175743cda2ecddbe329cd14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__492b84512c510412a2edc053399ffbbee716152438d3c65d6c5a7f0b41ea2caa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc0e234de18395ddcbcced1c2c7e96902bd745f22e2f5dc8ce384e8e53dc0f34(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c240c3581ecdd6a5f93a6c6ee10cd2d421adeb30aca16b2c9a1c82957ee0cd6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b177137e97a325bf5b63a4735b47b4ffd0498b6d485a49beeabdd3b77f39c6(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9f80952ffb072fa8b5070207e8ae177c36e2e07f48df782268c72a0d46ae20(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06d7653462d7aa4af8c1a3821c506f97ea79d214a9a81665d48601186ae99d92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e98941358a04686629b6b7a3dc6f33cfca086c2d6e29a8463c3ed7140991e7d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ed6b756fe8f45ddf0c0b056a797e83760eac0cece31341b2e89006cfeb16af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d319acc0ce07365844ff223a99177c9b388d0cf3b0be9a6214fe1673daa228(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f09d681c1528546fc179f6b44a0e80d52b79186e3e09bc71fb11e2d34273097a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81116cc0306adb370ba78c2b08b6b294368f9774b86bc6fa162c7e9db93a459f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9230eb2ed62efb03bea86517d24938e8caa2e46bc314411784701f403b9a292a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a770f3f021481bc7b74adf73424339e70418684c1cb694d7dfd573e8d5b1e1ad(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10188f528bc4a07a443a3ec8ddfa44d9e8d476f15ffa026f1eb7c8c82c1dbbcb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c789c7e81abae84ba23556b1590bbca064545bf0379634e20f4d108b1f3395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6422ef0661049bc8101c8dc29cd5df919d5254d443a1af758984af043b319496(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e55840fd5c4835fd13463e0a5332b46a8965d73e7406d47652846ca715956945(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1713d593d1c8c0bfa8eaac3dc5b4db0553b57652ce3c4a7382a7ac485ce618dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29045787436005206c8e9bc6dac907b8042c48d5b62434749ac226eadf8368a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fff18e2a377cd5d3c15335a0aa54af944c522596af648365b997779613baaae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d939483a812d14bd0726b0659922b70d30254a2a48fa5972e4b7adc354ef1ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8bb3c9d93ced1c7155f9ec9eb1163ba1fae2ddedd7e766d39f880af63c3f853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de175b19b057f7f84e075f72cb13c333f9443281f8cdaaff46439d45634061ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc88311cd351d4f02578388325f3a69544dfa6d5e382a3416201a38bc4a397dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6016c20275296a2c18b1ceaeca5a438c3c24a97d86fd6cde002ecefdbff4b982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f45fa0051b6c7c8856e3ef81affbe55a5dc864d59e057be37d31d0908761c5a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c6f053198af90a65351f44b2cd0f551d6b0463307d6afaf7dcd351342b372c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1281bfcc70fded9dedb55b3979b99c9c4e3a501bc3a187bf0e0fb9aebfbe6d4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d148f62be069a0abd5e762066eac4e50337c1f290ac7fb4ed3cd4bdf32b27970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c60f644860b1324edc58f81c679bb5a5566f2f34a7d4867a32547decc5b9dee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e610af51d2c597630afa8cbe8073da0c0f5de0c23b9777ea629a72a965cad1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6eb3cd4be8e2d4f6bfda5ebdf3a236038508d02f67527c44c72474144e5260(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c406ca16f60643555cc091179ea413f6ffa144fe234cc3afc703885013b9359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98106bb1f75aa73a2728a054f2362dba005a53d4889e2bb9e657fc5a3ec55d8f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c131dc7b6910f42d938d33cb6c7a50b416d9d1b8242074b0a6290f3476e0c344(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f636297ed8910e1d1f0678355b63adda7499b0234994e1fbc9c7f2ace9a50c6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d47909c1da82dcbec4153a83d4b289fcb63f1bcf123c37c80b0640f114edcd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31188dc477e00a7202603777f05d9cba2e775ca16074f9eccf3363e6383d7dbd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9396265a3fc6337f9309b053ef5c6e5013adb1f2c74cd7f36d691f6d882e1263(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ee76fed98ec95f7b7b9ac4b6b0bfc5f39203f923d285ea840185d1f96f02360(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b69d29e766fa4202e281e4704cbeaeb1041fa9717269f2b97bb332fa1e7311b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e06cebbb7b6872284684b6584bb8abb7092cf82e56835c294ce1dda93eb79bc5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ca1e5fccc50247077f0ce1c69770a8b0455df0e915a666b1f925b30dc11b1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8959621f99816350318c26622bcad05c12e8b1b01b0aa670a0d70df60e8698ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56c399c4fcd226957e921f0f2eadb46c59ced694985d838a3bba345153d109f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3a9e86931f30bcfff3e767abd8bdad574a763118e18fbf233850ed5fe04b5e8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a1e5e9e5357c901f5e65b7337851ad6e850eaf8ae95f068e1eb5a7019a2dbb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Behavior]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7091a42f8be2744ce275baa24aab780a59fa71ecc9c66f85d87e4f740a834a40(
    *,
    allow_list: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c869ae57346ffff128c9fbca826aa2d3c8b9d583006e19021cb8ffbff6beec1f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bfdcfaa6bf3d87d6b912bd48a1fe53f3ce5786888b00890edd4bd6efaf66b04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3757ec85d6ec0e9a035ed7c4b8c76b0116ddec8ef674e068dd141985c07f15e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb79686106ce553df2acef6899e1a460a5d15a14b175f187610538d9acbe156(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4184d42b798a5a7fd4730d0708feb4c699a68d99c7249e87f645773d642efc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7309c6d7de0767003366bfc231d98973bb71d5d13d5576f6769c30c3a9620a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ad59ff7a58844ef8c0aba11a97e66f708de74672ee8b1affad611ed1bf9a38(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPermissionsPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a844444b9ae2ef1b7adf9eb163ea3faa424795f08f62cc60017169d3145dec(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__789b1496b02623a91086bf871837e98ccfa2f6c67ce1815c8d160547b7a4e91f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d594821377d3f2c4a64cac6b53d9b0b02f2ab40a2b6cfe80c9b42ad87e5ddae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98419358dcc94d4ea0fd72b7b54a08e5698e31a8b7e24403a1b2718f82a55d67(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__259ccedc34ddcb36fd4fa9c2f91c7e003f8923eeab056b289822865fb9b0f22f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c06543b4d0f9e28574af9d930e180366822ff56be00c3c52ae848943e19bccff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__708dcd55ea4b56c7d3e7771772185e3a0e689d25ff329a6e32bd8324048945ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0888a579fb495abf7ce8246884dcc3b84fda6f1a0931a955063943ce197d58d7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentClientConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__767efe347942bb0bcb55362375a85c88172d92c5d34b181149b762e33f1768fc(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e098b4e6203486067761b47a72d41456d015666fb9bb793f93cb7fe10793d4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c1d27b3bb2715e01a06e505becc08074f963316673970d91e87cc3bfb2013d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__500c89edd8f6c54fcf1be845d0b40a2abb696deb07503f10c98e099ad37be698(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc5d00f1bbcb14d846f0f28756e0112317a87b95a9c6dcba2e1ee355ff79398(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a1bbe8d4cf80eb03f3202cdebd3b6a486aa4acffbd9733ff5f0d45d30f3fc8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3fe9a81a087568e50dace00a7c19934b543a7b4367b557a977eac883007d3a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b91e8dad02e98086acb60bc1038fa305cdd1fc0ef7e0a30e5de3391f8a66c18(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersistentConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9489cba1eabf1630658db2d66a67e2feb7a84933bf2f8b94a42ca3251effd589(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e60d0663665b22fdd06dd558828a8100cc05f4f8e0d069464d2781e6c4c119(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eecca8a2384891110e78a17dd5c26c01d495bab38cd61ae555ab0a80ea218fae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3d1c5968f18b214e23704701156b68e9a77f6ad0d6fda4440a9d5ad3740acb9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b7225eeed0c82a7eaa026c693115e91cee7f494fa8d334a20102d7f893a8b3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086ddda370620d06d9ab131f1e2b69714f1533d70010c5d49566d0cb11d44eff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__551623aba53fb477671612011895ff57c1cccade5054b84973da90574a7fa0f6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPersonallyIdentifiableInformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41361c34db4f625597ae1fcfe588e010f6f8bee2ba2093e76ea507e8919c8227(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_duration: typing.Optional[jsii.Number] = None,
    failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_expiration_date: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c13fa95efa45ffcdb76664c64a4a7dfd9f14f145170464c99b87504edcfea4(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7060da6bfbccbb454dcddcd6050c47a81586bba722238e81e11fe2d1972e6f5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a56d78905541c766edb2f3e063d4d08b3e32f6313042749c2d72faa9257455d2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2ea3ee2edcf6a645843b3f7e9d86265dcc1f07abdc0c69eb572f6c96ae95239(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7dfd123ddf42ad7d17fddb76e9686d2bf3e53c4f9cbdc6d173c8fa835586db8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedReleaseCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d58f2312afe0029746e3c0ef2a5b92cf80f995d4eaddde40d84de4557e6aa7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aa4f0f0ae7f9db4d18eaec91f0ebb894913c46d63f4b67210f456743648e3a7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a72570dc1114933f94879799e3c8bc84fa7a1180fd5bada1cf62a877af727ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e684d3b9c4a59e2e9f08cfb5d5682d127ad668dd97b803959e37a7aecce376a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a415423eeb490129e730d23642e1d1a93ea210bee48e4c7f059c49165f8168(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27df57201cec801adcde237b6ca89d719805c92ea015646baa0998e900e1fd55(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d560c32ab72d949da67d5dd9c9957b0b8d6bb7696987343ef9d14e595d13d3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57c1c94c9c87949876c00fc578552202f5c01196d9a83f45c6f5de008cbf1a8c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9664b862a91ac63b7374a908270bc3c5f02ba9c50fb83293aa58602cdd8fe2ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ade9a849f7f671fee8ab8cd9eeac9c7017d0c7c57cd96cc1b1519c56941d226(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5918fdfca882b5940dbae5bdb96edc511ce8bf197f5a3a81935d9b579a66d533(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4d30a67bd0cc84ed654bff9d38c89202ade10b541f3e0701bd1676b43c37a2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f284f9af6e403cc1c450e4504ac34476fca73fb1f9b64ffd8687133f57ec9e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5fef91eaa9453f341078407c417a2ae46ea0bf3ef8a7e64c2db7c32578b24fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39156ec7cef6f3c27bcfbf80ae3be09d7c9f2694daa656f0fb92bfdaf813bc47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7acd58aef6d974a4ed7732cd1ef572aa84fc422cf651dc6da9df5804d850d71f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb5094f8c0ef56301fc26841f02785231774b0b34d4eed6ad75a26cd6633cff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a82b9d473a156163fc0d94f14eac17b18e79520808511c0627d6cf01a92e7e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPhasedRelease],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d641ec93235a501410dd6c67efc338453018907d985c21276ec9510c3c0f1d52(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5c1ec12ab25e15ca1780c436d47fd15c11221397a52a72dcd2271d7596ae76f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97eacd2e0a0fa7f35f143af77a001bc7a7d7bd28112a1d85c5cf84ea0928c557(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__644dc317022ea07261dc9f581b43e4ed1c039dfbaafb67945b851f6d759766f0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab4a47534302bee06acf9b66cfcaaacfa29700cb0d4a02c415d23b1a29f758db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b355d096176ee8080a530c2b2e06276700ae8b262b76c358a0d6b1073405a95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__880727e20120d90a0deb33f2552cad9ceab185ed90394245a4b81280abe95099(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPreconnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acaeb4fd2ffbe23fbb6da26923ccff06801e3081b5936f66c37e60a6ea34cbf8(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4533f7691b86d09d1f25d5d1e95337217fbe39a47854368b2f824f4f8288e0f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75e0514163af5918a921936aa45247a8cf9352b5c8e8ade8b58a931b798653c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a0396ae1cc99a49e6a204937fdce6caadcae0502db2d1e798b351e626d6e45(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c7c459bfa47d0955d2e9add3d33a53ded16fd47c668c084e58b88e465b0fad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__307859cab62e595dc94ef9dc139cbeb5a71f7d6232358ba2fe154001328c1ccc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb357f24e3ca7c958b34a6d613cd5bbd32a58c0bb276135a6de027204b45d72c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictiveContentDelivery],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e577b7e43fa544c7b5b4e8c990183a856a301cdcc0d3ece6c45e0d21ba3f92(
    *,
    accuracy_target: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b72ab2ddf5dd55ef25ff0cd3e57d01b122b20c42670fde1f057184bdf89683e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e7bf6fa054a6e19d0f55f64ae8eb3a0873ef1fe4e04ed12b352dba2869fc7c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fed03ee3d691027749b8913d726d7f4ce133819e707fbe644a7e21c91087a09(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a26726e8e9d5a43fa53d006eeee510c5d4a37bf81bd5a1b5bac34756d1b23718(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4f277d79c5c69d6dee7ca0780a1d788dc2946c3c179d6b2a6dcceee6a458f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7fa7634399f62721d660a37f8b071c48d40ac26a880000bb39d7df98953d697(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b3678137d372b0f924a912ee638187a46dd9e12a9290757a4529c7a84ead19(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPredictivePrefetching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10f3f3096aa3f24fda4fc1c2d2b08fabb7ae56a20ec0e05d9a7ae7bfbe9b93a7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__013a454bd9e01a789cc34d1b431d34046f68405b7cb7f5dc1ed9e4bb2d3020be(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d773784cc4448ddef033d44e5b5faff8972c8a37a1e186767ac1b75a04abc545(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a1ca48559594137d5a76a47ff69a855cd910e0f36a524b98fea55641ea07636(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48dc52adc7470d3dae6c3392620c719b7fba62759ef914b0967ea284a231b8a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a92fae0dcb9370b7c5a95742bfeae8250e3e40ee4a4785fbd48961927dac386c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45db2584085222f775df4de053c4f1bbbe64aa028bd7996e646d767a37f8c01a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b035848acc4ea0ebc022a2af1c20b45064d30c564b83b35e8a3d47a1a439e0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62ceb9a398ff89ba54b7ccbfe27e166076fcacc3c8139d30ebe69cd58476d0c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21caf1d234e0b05cfa776bea9aae54936e580d407844c659e5d611491038e57e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1081ef0d81b0dffb1139ef0fe9c71a5bce8b574bdab74d4d5fddc9cf608b2301(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27b076440fc59cddd49e4a0c81b07eef8b268d56ad0095dbe49ab3d89b9f36aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2214cff0d5d923800e393e80c8693d9067c61572894082e4ac0e28842bb7846d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7458dc3d3c3c127bb671774bafbd434d3634ec83df19cfb8287619502efcb8c9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefetchable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b7f28827ff670c9132005613ec86fc081625f997a0b152b5582ab96b7d5c24(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefreshval: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f637848654ac62ff5cb3da7db1df2bd653934220e91234c5cbdde60fcf9e2dbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7e6431101f9c8dc19e5ce551ef3cdc64e4b98b0eb18796fa14e0ebcc7928e00(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__344b2f33f8a95d105405c27dd8643d119b76c276b59d5c93e6f1e23391a9d705(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b515b788cf1173e804e8927937cc14007e1910ca04e443ee89d5b729d0b1b6e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5a71113af6114c4e28700df8370dcfb64a0570420f61105fcf6d520703c4712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2fceb7559667960878c5437fa14ac5c571ef4ca98f9a2097c0c1cd8bb374d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24127acf66c7bfd101fa5605ca7f26077c1fd43105e5939680b5b02fe890431c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorPrefreshCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27d1bd73d296d2d91a1da39976ed167da28e4dbce280f00a8b6262cb9bed2d4c(
    *,
    audience_settings: typing.Optional[builtins.str] = None,
    catalog_size: typing.Optional[builtins.str] = None,
    content_settings: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    delivery_format: typing.Optional[builtins.str] = None,
    delivery_type: typing.Optional[builtins.str] = None,
    download_type: typing.Optional[builtins.str] = None,
    end_user_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_concurrent_users: typing.Optional[builtins.str] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_for: typing.Optional[builtins.str] = None,
    origin_settings: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    refresh_rate: typing.Optional[builtins.str] = None,
    segment_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d057617276ec067dfb65bf4b95a66ab5b3c07978c4f1f5612471a12c46c7ed6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c6c727df368c87cc1b6fb6e1662d8c5feea54f174f2a5279455c42314f01dc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58f142d74a8c9491b79e1b8356e51fa745f07cfedc3d4d387c15739793941612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31f754fc7ec2583b0711336d59d7f9a37381e1a8bbc5f738b2310826891d7522(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76845ab13106a0d4b7767284279fee639258f232c8dc49f4c6145a6d6223df9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69bc1298051ff01e8b3958531d3a4b6c20010135b2d8088fe656601db7a8cf88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99770e704f81b6d626889a4aae65af5aec03f0b31a173756ab0d2ac83452ffc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d64a05590a6c5bb81ddbbe691c696992bfd91e866fd0222b3e775f641f5bf05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b030cf773f1565b0783693eec3ad6ab69782fc9f8e84e3659f77d69d298b09b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__597aeea36c0c5fcdb99b266a1b83c26f05ae16df17057f7feeb94a1913c8d1a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eab63d412f395371423cba36f3b4bbbf0e0853eab0605fe4ce71cd4fd2d7721b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f91ba844db6e8ffc1808e6dd765ddac5566e49cf2b120cc76cf5091c7e5c6a21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5bd104dc2f8502aa3b151b0eb7a1c0f839b5cd79963f2e4818749eb87698f94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95851a32c7aeffb975b46b61412f34d28674d9603ded346573c1c71d1ef9c135(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ff69946cdd074000984bc8c945c4d30af3d55d3bd441f0aae98b8726f0a9449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f8d624a800e17eabe1419b12b73f894428dab9440cae2de8d6308de2b032a4d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e725958adb55da9084927bd561ca6875657b4036815261010b69d4aaddc4b97a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cc383b0dc4297103ad44bbf85370db8ee8f51a922a6878b9e2e6a94e7f9069a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fd7dbeb2d1693be25921209c8c88f7ba18b12c340261d4c45d20f04eb280795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c540a83b19cbc9a176dd137edb5f5333a7699011b3fd54aa99539ba8d555c38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec0ead812748bf89238991531b174f737a15eb86a6d5b6386322a4e422bf7e2a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuality],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a43ba58a3adc60d15bf57373db149414d7b26674f5235d28e59ba21c38fdb0dc(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    quic_offer_percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253bdca8576b6ede4e79dc0ea47b4b531e819699d6f49655ba5e48307ad1915b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ca9fd6f639b7a476b5fc5a03d6fc9e908e2901157dee6538ed9e56bd033a125(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71dac56e54b400dfbcd14adff9a2fce05933188dae53093133a6c654d3a1431c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48cdcebb1cacacd54a36d3daeafecf21f527f9c435b01b463d6ddfa488f1d815(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78da5ae0cf9da33602f3fcc7b4d709211d28e66bef1e8b812a6de9412b52ccb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60e05198d5cc364a60f8cffb50615a3ca77d822a5d0261dca0e45ee722ff855f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7a89e08d69471d335511da2c1b9c80a21463b7e504aed466c13fa915ef1207(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorQuicBeta],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5970346df3002977e9deb0953e61504b4d5abaee163f3bdc67d06849ea782d2b(
    *,
    flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__055d04980750e4261c59ef7bfb2761b10f63fa2c168ad7133c7517f0670eb6d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__174e93ed3ee196be557ef005dd2f3acd240c7fe3dfeab416902fd25fff973a2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0513416aa8b1021355a4816608bc1f9912c88f73169aa1d7d961c6ef1294beac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39423145ec24e4b328fae731a5db24143467c6cb26d43fd17be8ed7ff61b8f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67d4a065d5a17e5856c79be58d6bb36c2e25aa77baac2092a33fc789e0d3f930(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa0cd353d9ac6ca5f9d7b01027e85caab1f946c249830d3e66f571398aee7ad8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9fd9fa51bdceec7bf0b6d120f9335361cd9f75a0ecbb36d45c0569d89fed604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f926af6e2a13b8875c69cd97183e95c64c1c1d7ddf963a65c487caecda692ceb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRandomSeek],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2cb451f7189d6542fc104005f5359c826547513375a2514e505fbbd30adedc7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6fb5ff6b4787392387a5469172a344fa4bb4b97fa3d6831623035e87050c6dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4ae8122a2c35c52e2e60ad084e28e1d7e221d10afe5b18597b866bedc80854(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4e69a4de55b2fff4321a33015666add85998c76d932b7beaab86f81c354b3f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__364a0257d4deb11d189a8d32fdecc152b2ed703edc2bb3316890988168b4dae7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7835dfa4769271147e229eaa19a1415bc5165c4e4a8f9689f77d7410540532b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2cfc2072fc6f8c70b3d867eaa0da77ed385ee058d24825f035bc26422025ef(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRapid],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fe50d4a82ca62e1fb4ac7d0b891d307f2a0049dba9ce236e605af1f69facf14(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b55dc2ffce737f8bcd340bab3048ee86e2bb57c93d984130da7efef55aaaf61(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf3b4712b3b1bdd7494f6b00394d83f76789f4a394f5147a42ffe74802a5430(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__286cb0eafcfb3894a40a6b7a60d01986abdcf049113a59673647fa3bb0106e41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa145f977f9276bb2a982cf647618e512e92eb81d25af654b36d53288eff7bb8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15419091fc6f4ba99669312da26cad0bc69c1c48199376633e3f928bddda6f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36640e0c813dcf959e6a36c8c28882e1a7745acae046fa3c22e42c3e7b830ee5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReadTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34805d27f44bbe6c02477e00ad3933f42d18ef69571d90498f7bcf2b83053ce2(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd204ecdad3838133d817957b3dbef3781f2e11210aaf11706fe51c51cb48ebd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef659bcad549eae4691c8eff5df824da5270bf4ebd868180cced2b833f34c5f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfc510bee70e2a08d9e9caa32ac563b1629e0493065848189000c9dd7a35954f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9290662611f7715af534b0467fd016808d83ebef36a5c4ca7e8e8de4cd3522ca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f71f087ecbab52743b321fb712a0e982559e3d3837ada1568540fc9011a34807(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f66efa8a0d1b4e30adecf5da51ca815bf4652a0d25c2cf6257bcc1b7a92b78a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20db63cdeb8425344716569a2bed3d2065d2c6331aa5e0ac57e26ccd0e1eedf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cff37fed091a37ca7e72bd4231fdfb95ce95dee43d10d8a3eb5fb8a28770688d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealTimeReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0eb58ea0f9c0177de90a9e14f65df403cf9cfb0dc87e45334833db55a30211(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52795ea15deed02e42c2c25ade7b9b2febcf947f5643114fe144f76a10108e4a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67e593849ea20ad73772fd59f8787459d4757bb7ef6832bd3e03c7bec1b31fe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85dc006cfa3b302d96e632087ef7157e6400b052994a63099ccde4b8b69f2391(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab1f0a49875cb2c9311364a9f58bded6363c4263267fe17b0af0994d8105da01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ea4025e26e5636c3291c2a1f4698da35b4c13e3e89cfd6b7e39eb5978e974e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dab28de30c4f83b398a1f2c316d9e10fd2abbb0ae058dddface68eb57ecd240a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRealUserMonitoring],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e89015165069709e41d58f87ebd9064d1fe4947942973562829d99ae22749cc5(
    *,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_hostname_other: typing.Optional[builtins.str] = None,
    destination_hostname_sibling: typing.Optional[builtins.str] = None,
    destination_hostname_subdomain: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    destination_path_other: typing.Optional[builtins.str] = None,
    destination_path_prefix: typing.Optional[builtins.str] = None,
    destination_path_suffix: typing.Optional[builtins.str] = None,
    destination_path_suffix_status: typing.Optional[builtins.str] = None,
    destination_protocol: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mobile_default_choice: typing.Optional[builtins.str] = None,
    query_string: typing.Optional[builtins.str] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9699fc8fce939ead677e17a40f9798f16cdac0de461e0498135378a0049ec1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96de42c906ed9d210552c1ea32373c108328dc74507c1236d5a5696bfa70b90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f81e53a48e400f149d358b6457b2f7bb39827b3f5fc893bd8d899081e830c32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f2193e9f99b8fc2fdf793dbb5c62256fa6677b46439785ca1408a7f2dd9e54(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcd70b51f216aedbee5448eeee8f3549b3fee1fe0bad87fbc9ffe051aa4b9c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40c4f4bc100141a468a9c1263e4bea67d62386b1dcb0d99f4637b8a3dfa051e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7c1c3982ef563cbc0325c1dc5473856542456f22c74fb9a9d3a5ea6e2b414df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00787d1e0843923601690ebb32da76a3c9c01399f7b7d7994c892f02eba18b9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c0344bdd4066ceb370393bb2e710652f16e4c0d3195473037fd8bd9ee46ce56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7640aab0d4afe8a12c9b82585efb2f7ea5acbc426d67cffb80521003c29a7562(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a706eae53c702762215c8b96a5a9eaeea37cab03ecdcb349447173a5dbfe2c96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__111683bc4e660a0244c5d385d02acb50f545329b179b8e87cd8ed3e973db639f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c46c1a90dca93a85d76348f2df96b2ee787fef45f313dd13d702918aa5533f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06886a03ada5beab922e0b7c4f8c58eefb1ad19d8c50c2c7d41667dfad65c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21f02b557fcafce492de6cca8dc264508530f84d80602d57fea6eee154cee77b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c36098460ffbfc4bae81f5286032b61e24ca63beb5604e428c0f15c74899cb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5497fadfc928419ac48ccbc94fc25f2d36bf8a0e0e9a1a65ce4cf3abe0b01fdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc14f1eeab1cb30cfd7d2f482769718c5d2d425327a5c466091c96ce22ba0fbb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad2b504cba13d44490b1d228e5e921a7459d9c489b2084959dfc87c42f70196f(
    *,
    destination: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6352848e0e7cd2f79f46b3b3e05801ce2c11a8e3001dadd32f9ace9626a4e261(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2590523d37d736b1f33a685408e36bcbca774c2f790fcdad202bcff35fccdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e227058b8a92fb57c1fee7d4e749fe69480f419c8c74a477349c3b85da70d7e2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a872c33fc67ad1f2bbc55ba4b734e9e91a9885653daa8fe18660eef7b86cf5e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a98c54b1b3232a720734e6d0be408c9fa7d5f4f5009b5b511593c4f0e91c18(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72a7633ad267bc4b7baab23ea677afc7549803f6ad1a137cf47bc6c118d3599(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7560b038e60a6df1773e29c1ba347d0fb06a6e0dfec5c94b91861c9dd0708297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__138034cce83fff03e9bee512a1a10506c6b43c7bdac37fe7934c186cf6cac892(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRedirectplus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a91ad232928ce7accc0ed262c4b0bdfdbb66c8bac8c016345d8f71fd210163b(
    *,
    allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978e9c7963752932e0a02be1d353d36a023c241f93d653160fa80a51e14ddd05(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ef61ae8e5ce92ba775a301550b3e911aac89f84378bfdd8de26fdeb6591c1d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7a45188d02d6c69c2837ca9412a0b984741402906bc30b75c63700936b98744(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdf74fb90f6d1d13897cd7d3db07aeeca6441ce54de764cdde56d55a174dcc90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e646d7634d6d7ba4b68ae6c2602b8c079c5e37bff53ec67e02101e59c26a046(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f66963e31857340808a39629d4527c638c1e7894dc79052d17fab06cd830485(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dd3c357d63af8d5b47b6ebade02903b6725a3e2ec93dc07847a12eef697ce1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b083130296f701bfba5989536ffa4da19948e9a2c4cf6376599a3cb6fddc269(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e112061194d881af261718355e185af8cf61f2142e2a8077ae316a9bdba3029d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRefererChecking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a19656bcf69ca894c432c12e4f1ff2cbb446fef7dc8f788cebbf5a30c94aad0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075e2c8c9a07d659e2b6f8714a2c5f6556242a2f7bb94de79d966b7fc0e62f37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53911107c8b966d4b54564785ab0929ce1aa4b4f204e580d9ee6f223b68e3c5e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978227919f7746a3a178bb075d6feee3566c0f31ce4f8f81e4e10580401c983f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f281339b09c88a10e9aa414fcee3279b16b5ea9b67898698ac5617b7c7a86b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4f58992e40c8d3b5375430f7b6c0a8c67934f0ff0170ad61d26abddb1e5c9bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d4e81a35a2989fce0ee254812259b16d9403b3d2e28fddd9293cecbfe310ce9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveQueryParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32725dc750e8444d1d6eb8973571b9b72f9daf65d0d3b7336e2eb378cd94199a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59d435502e5293d2881dc5a972ad2abd082fc1ab7ab3e3bd982c50633fd20f83(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32650ca1ebd51ceb5ccc64c8825a08ec8b7e8b4d2d12f3813f5d07734d8c20c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71fbae4e380d92262a950844e39146322c2da6a62ff9dcc1f70739d347efaa33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f985b20649c2ab50f08097a6df049bc04c770e1ebb728582270c39b393a1ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6acde44ef63ee04a55bd4fe908fc62ff16d4853350e4dc656b3f85ec5bf3fdaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5b84b861e4b8e440431532fd045999c7cb35a74c347055b968fe26d96ad005b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRemoveVary],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05408dc37e2b2348b4ecc67fe390dbd0331ea4d426dfe4aec5b6c70caeda314f(
    *,
    cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_cookies: typing.Optional[builtins.str] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de4b59891a3dc8b7d980abf516643a38d96d5991cf687ba5183611758fb4caa7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e7c4bc6aadb89868f5a80a1ecb15bf76bdc9f12bf486082cdbcc66c2335e35(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dba8dab9be50c49629f1c90fcb0cca5d45d4ccc428e8bc13363bd7f5cb8619cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__622b3d522a875461f809c60d246b45e362fd20ec1c140a1260a80250dd311faf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c6da8251a1521d3a94b8aa4d50d675714bf62493a233af06ef18c07089c7130(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1e2facb192e38f14357a789eb05f113e2868df7908cd3e1c1678c99beff9a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48d47087d0d4b6d5222368e7bd73f7082d6ed592dcbb1e10d55351ff88635a2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9ff7cdf33e59081218fbb48e9e57951155a4f7f119211466021adb8ffff2df4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbb1f52672edbd3bcfcdbcf5bbaaa135f3fc62441b172d625f4d492b7ef4c5fe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08c352f680a99e4e60687cefee6c0e29861810ffad48f42a20d867d51bfd90d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21c42a1e7ebe91269cd1a2120b9bc01bd06836c40fb6493e6b6cd0b8b541c04(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e8fe1ae936f5e9f4b701d3ea7498e8fb3999357fb661b140bc44082e754a8d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02d33641eb08fed8cc7cbf19940d86554de05805bd2c38c6242988fb006d0677(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a8539b74c7a33079d4f82ad3be03946715d9a810385daddb4d85c42f53cd658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__face5bc7f98c99339927b066ae406c5bc0a92cd709308cf92fda6b49957e836e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aef215cc128417aebd7cd711cb9b8d09faf2ce0832133c7e353b9d49dc4a4ed(
    *,
    accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
    accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df100268cc7d8c5b9f83b9178eeda2a857d4c7eb4fe89f52651888447af87ff6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea1ac81767a29686e023f6fe078f3700880cdaf75d4aee7af887d2e80cbb555f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65850d71525471d295e3adbd46e4189e470b74cc0fb9c6cd793eef815e4db8b0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5735f0119bc02114bebafe62c1bf42f1dee489f04edcce4db8999231e7bf9405(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6aeab13f562978e4745bb93fbcff32f89f63c8571a7884b841222aed781cf180(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c8812ea263dec7ca3654cc07e8321ccdf522c545de5b63dd3aad1f1c1544357(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfa314954689707563e5554b2916fcb660d8e9a7bbf0eedf82e4237fc8ad6a02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a4382c6865cee73b76760d4b122fea33160d766d2ace5bf2afc682a72494b22(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestClientHints],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff21a2e821755480c92683ef66ed8b224eb33e77faa7a3fdaec995c7df0cd210(
    *,
    branded403_file: typing.Optional[builtins.str] = None,
    branded403_status_code: typing.Optional[jsii.Number] = None,
    branded403_url: typing.Optional[builtins.str] = None,
    branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bef3e6745f875f93d1a6942861a4dc7f3b1daefc702d65490a17af24dfe9240b(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dfac7c84b05f31faba11436fe6654842097eabd374b1405f59a855df2b2ecde(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1083c42ee5db54bbd1e02fd504f9bc4c3f09a8bc8c8dda4533e763130a9a6abd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dba51d1058c6fdca13157c0502cd981a9bdef5e43452a13282799e70ba619d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66a2f991de1d2a170bbbabe71984d283236b957420598fe6076a68ab6cf9eb2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9abf7dff97e5d5fb21240bcea0569213205cc0dfc3758c1989245a81de113e5d(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a52e082fa85472fcd8252dc987b25bae4d1a09f0af7780f48932c6b9283faa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c4b791e46909bd5a7d8e6029cec5d3a886f17bdff958776430cdc7d4c461a4d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__501ceca46ee26ff7a62fc9feb527338e4ae4b2c604e5f87fdecb19ea419006d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be04b60a0e0cb3a991890bb2660fbca0611cbf9224fab06e82fba6922253b41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fefb003333846d754397ee72fed3e117cf55fffd7109d6585a4975fc70b7857(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControlNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d8fa59a13a79b97e58c686e6705bd7eb3aac0ee720db7d494dc7ee877f7ff87(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__280d49d4f5a6083e98e3e2166b621eb34cf74b8d4405f42aa13b64c3edd81947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e22ae2a22c5e8d1ed898187e1c7641765f610c741d4f4108588480b603f567(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5554c73d034be579c998aa5d398f1a8d33af8804169ba858cce13649ab90a30c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c535720804aa2001f4fa153878a08dbb2123bca14257b2f9d965b597f20342d2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60ab5c8778f667f4bc941368284fab4253f3e560a09be989ea86bff759c1d70(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4bca17a3f6aa40081da1c122e48100801c335ef64f71e31230de0e3bc83b823(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4166b42d5f4c5ab8008f7967b6d48db347fb41b08a70255c01518ef5d7368516(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b153eb0e9e43c5230106a3acbe24e730a037df543ab244dda876a8a82caae52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d383e6867d169931e8419cb49ba9c6366f32f8b4088158212df16e37ee88d27(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1027617f8155e40386b243d52fda56cf16f5061e445b50f7ca9f4136abd97f21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a34de7a6e03c0be8bda6b4be4ff18d02f135633782a97f307f199fe00767464(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3482658bd4db4a6aa7d75f083a3816e3a34f7479f4c86a7078bd64d204a2c063(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestControl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db61fbd827ee77deed75bce82ef4192cb67e8b5fa7648e9c8ad3c368fdb46d03(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef99b38ab6777c7cd78bfeab49b929ec0b4f4cd8757c5c11229694ea64ddbe99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__717db94e1f326abdb1f4cc32b9134bff00422758b28811e17183be6c0d892991(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d293a2e2875439853a920def469b226f4ecdaa88dae549ffe6011625a2948a80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e86071753a1285dab6f7d8adb2c0b28058f24a01f9335508536545acd1891242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e567beaeaa4a5b79326fa8525798244dc86077cb3a9b47ef6e7a5c51d9c0200a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5caec69174ec919fcc28aba92334d9067e3a28f571869bbe240f305a58c2649(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRequestTypeMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc6fb116bc16eaa944e013b0afbcef4d31ccd3d868480bc43e3ade1e44b7892(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3946bee8fafaa0e890673a11a32a78e6d34304dcaa3e704205b0eb691dab1c6e(
    *,
    enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__107310ef75e80dff2c0b221c4b3d536e10bb61095575b501c903592a0a789092(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c9f9e2ee9db88612ce49b62f46340fcd0ef6a745a44a10fc3d4320a9325b078(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79f97bf971887b6e571f484381eae22fdd7b0efa1a8c42c587decbfd480a7e89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79bdd207441cc230d78e7aa7146f03528fd68927ff807dc6688e4a69741d11d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057b080bb87cdcbe85586fad1f128e35e6f1d62073f89f0ceb24e9f47bba333c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bad09ddd5cb63af6531ba75151c251a0dcbde284f5aece9431c8f777210e1cf3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14f87046a5ba565031a072ccd6a79facbca9e348b9f3d1c8494c838b639c8310(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizerExtendedCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79ee5e3d2b6814293e6eaaf64f62ef34098882ae1441d6d085b747eb52da91b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92d89e2dc7b725da0ad8758c5f60f5e3933560ce54745aca3ebd50646e7b9a84(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70221af6f801681b4be1f297fa858030a276999a1c14c6fc7e910e1add87adb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04369245a574a1238619a72b39a32579a8b504533bec9d46c5783311e01dfb48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbf9338c45d8ad2f4ff4117db07dfe0bedad3c99290ec5d8317d8e15612e1643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db5b270b7078263ee4ece230b3cc1067ca32dd783cdea62a228594b25d10e4c5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResourceOptimizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__468241f686cbdf332520abecb990f4c08dd9a3badc5c0afca33cb5a83acff5a9(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b054c4e6d106fc5d716976123d5a9e548b9b154d1a20ec9779ce45cc619b71(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2f9a6ae4ef7fa60de6ffa6af9c10390ef0eb12a075585ed04bbfcf144b3dccd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ca34e82e764671025e2e26b07f8cf0574a75bac366dace0a12e706804d20994(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d464e8882cea8733b7b097ad87faa8d6366034fdbd636d3295ebb960882e6aea(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__371fd9ce88f6c81b4b9c1daac71412b85df440534dabae5d220c7ff80f2a9474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99950ef9e2d6641c6db5b7d0741ad5db0c79ae7865fb51113f540409fdc513e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1eb7b6f0a65c1516aefaf2d896543068a1408b23ef3ccd17497c8c14c54b727(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a667d4216330b2673acac720d8b61527c808d5b20dad4b8098b28c56385c23ac(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domain: typing.Optional[builtins.str] = None,
    duration: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_date: typing.Optional[builtins.str] = None,
    expires: typing.Optional[builtins.str] = None,
    format: typing.Optional[builtins.str] = None,
    http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    same_site: typing.Optional[builtins.str] = None,
    secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d042acb4ba57079379b7a1636257928e64d8c0bc1784cca3b97814de2243f9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__092f1a3400c81581eca56e0e602f0bbad4f63629c6e4b5508f33bbb40ecf2959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7847fb7c4d7f2a4f121829d779983399d47e8bd0f44970c52decf03b9fc365(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0b9a36c8522ab32aae46eba3b28f3730a64a999c479a882c25d5b681112c5ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc942efcd6676985acd743060bfade57c50f549f67beade17b22a0ffa81ef87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8303f961658b3c38a7d5c349b2accd0fcbdbbf281a8879fbb1aa9596b1dd5e27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02fc217086704ebd096bd31eb44967451bddcc99466dc44810f0a120f56f8dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca014fb4547ff4412b8551bb05062d9e9c287799e58d084f8342751782bc021c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea42c2eaeb0d9688514848ebf46d43f2016b741d8a14f4122fcba01c158a107e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091606eaeca6f24c3d1ba6b2c6db7029a18e9838bc67e70940db6d3cf38a55c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322303ae879018264baa1979d812404ffb1c569366ce2d537a725523ae516f15(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41857b73fbe0176b691e575b51703389cbab76815ea827dcd51ea5d4e9504c2b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3871adac1817ede9db5d3d09e9e76f63ec45512bbc38eeba26a205b1dc311606(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2df544c31a5467267fcb7e92533b90dabe3c4250ee11db1f23133726cf03f1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a1f978ed6e6eb4369ef4899c66ecc60cb2c5fc356fcda81d4f736655925817(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a98142302408226a553fb7e5f174d6642bad72a0c4b8ad403595bea7ea5cbbad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d087af0cb03fe5d3ab3d7dd4ca209f521c3f8505aa46119c4aa9a3a5edecaacc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f77164b0aa505844faa40c75b065cc8c896e2fc309e737f8fc05a4086d0a5b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f793de34f0c69adcf2caea262dd374a288c5ffb739f002d9dfdaf6944de3afda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8e4e0d642e4e6946578e5a7e9fceb8a28134710bee137926d6bc9e0a6a20bd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorResponseCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28bd00a4062316b77d68b4497649c988a7f6fc996be0c0884cbb58b30b09d61f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07bb6d36d7988837e9246ca95b6ada5273c10522ed971eb1bdaf78ba3e5e1838(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dd98acaecda518ee721996291da613037f122f20c9c4b738a95591d2bd6156a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6accbc18ad0cd23eed06e7f1aebeef95e1ccad1e74004a610de2c472067ae65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0d583dd3ab0b1d0a6ffbe0c3689dd547e324b60b90fbf9fcefda46d142fe510(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b200a932c8b0bb66b0702e6a9fb7e7e075be71f35f058fcb65785b4751f0464c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae81b5f8080cc3c5aa97d89d53c8065e7eac248532821f441293500c839a17f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRestrictObjectCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56ef508d67c9627e9e015f7f3f0c090c755647478f36f482d8dbb74d7651af2d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c89da2bcc4bc74f0e0fc7997a59b275a4d8346ca306c8bfe14cae4f6792f9cd8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e6a185bac2954e485efe9a0af3e8a6f672a35d5f070bb4c78fb740d216210bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4e0d24a66aef996a317d99d428684ac008ce94694fa29f8cdf052958fca1a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1582d187f6381fda798552bfeb9f333a491433b1a63f7762dd49e167af88e2f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648436b21632ac0618b0947eae7aab17dc5d25cdefc36c8e283fa22ef9b1179e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37de7b839ba05da5a56c4e1b500c4d58c373976107be754f1f7861bf7a9deed5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorReturnCacheStatus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e00eceeae2d45051a0e436fed4de599154df0c6b08d9f69a6312ae98e67eb0d(
    *,
    behavior: typing.Optional[builtins.str] = None,
    keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match: typing.Optional[builtins.str] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_regex: typing.Optional[builtins.str] = None,
    target_path: typing.Optional[builtins.str] = None,
    target_path_prepend: typing.Optional[builtins.str] = None,
    target_regex: typing.Optional[builtins.str] = None,
    target_url: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a30a47fe2a9c31f67314ec74a444b3f46e893088ade7d0b6c0586be4e79108(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d112ec7b35930826495436ff02bd069c06f80db7bf65fb932f12ed12ac7e6af6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1484c29323bae38ddf5953656d50aa2087c3a1675c00035286e23e32058c8802(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6de6a280a88ce9741e662882acf5848fbe9c8d28c5bc252b79bfec82a6f892(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88548e786b0c034806927c9923eb7200cfd01e1f1cef87189d348650cb3b26ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c479a9a7c875b183f5688755d009afb9a805c73c8c3d66117b0281f61677a95(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb6b2a5f84232ad6c07b6ea55e98d3a5a5fb6e02ce00ca04770f75809c858ab8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723958ee9a45dd3cc2c6a7cd42c97a0f9c1cc61ba536b37be4e090603837e31f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df999ca0fcbababd786f40815a5c6f23727f4a3a64024058153be2984a283911(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4204d5ea15bad0e4a1194083d11cbb66673db2668c1b3f7c0314d87c8178b02b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec5646e6e935ae8528e2ec156467ca790d3982f4a47cf7b76820a371883f8de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f5f4889ffcd3fc83957e28e8b25c6b0264abaacc90287cc18720e63fec1348(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e89fa953f1a8720667578949f3a6853c971b77d91f9e7b7fd1d975ba18c7516(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f5a9dfcdab4d25fbcf8312c98ff9665f0c2d0e465f4f9584fe376327b743d96(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRewriteUrl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a63127a0f6c6aaa21c4161eab7fea30e3b41cb9848500d032a1149e04b0243b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rum_group_name: typing.Optional[builtins.str] = None,
    rum_sample_rate: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ae9d424f5cb6521a15b87f78a74cdc2f72bd50c1335b59d3fb1822726575de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103b1029f8692212c90536658872e3b350a4fd7c480b35835c3822211f567dc7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ec90d76da5951146017b15de6ed5fe00a41ba6f63ba52580af653de1b71b621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__745ac8f5cbfd80920df88c9a677ae19dd44e5cb8f9164c481d524a1fbdb4006b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d489c58a9ff69fcf50d31decf329d22d9c70f19e740a2a9aee8e2da9c8f0af9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db121d7b319611a20e2499f526b32043cb536dbd6411eee62649858fe538e5a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__419a2d08671c2e02e001e840e4133f34fcab8852b2fc53f16cffd5ba2912867d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorRumCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f12fafc22eee57055d7a3e90253359385193a35a2f530bc134abc4b5303b7b6a(
    *,
    application_action: typing.Optional[builtins.str] = None,
    application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    application_cname_level: typing.Optional[jsii.Number] = None,
    application_cookie: typing.Optional[builtins.str] = None,
    application_query_string: typing.Optional[builtins.str] = None,
    application_regex: typing.Optional[builtins.str] = None,
    application_replace: typing.Optional[builtins.str] = None,
    application_title: typing.Optional[builtins.str] = None,
    customer_action: typing.Optional[builtins.str] = None,
    customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    customer_cname_level: typing.Optional[jsii.Number] = None,
    customer_cookie: typing.Optional[builtins.str] = None,
    customer_query_string: typing.Optional[builtins.str] = None,
    customer_regex: typing.Optional[builtins.str] = None,
    customer_replace: typing.Optional[builtins.str] = None,
    customer_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    users_action: typing.Optional[builtins.str] = None,
    users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    users_cname_level: typing.Optional[jsii.Number] = None,
    users_cookie: typing.Optional[builtins.str] = None,
    users_query_string: typing.Optional[builtins.str] = None,
    users_regex: typing.Optional[builtins.str] = None,
    users_replace: typing.Optional[builtins.str] = None,
    users_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad82c7cd42f542298bbac93b02d641d5411a24da3e6a0a048346431f1f00a520(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c01567d232b1fa8512d15a5d09c7dc79818676c5390e33bcfd9aa32b725a2a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3b1b5ca0be837b14d8466c08d663a1369050356936e70c47f5db4490490e20e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__faac54d78db1dc464f0c3a3a59f3185a893acfdcf8a7378fac0ba91a752921d1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5ac720d4732110afcc4fbf6122e2469c2a43c81d6ea69597ce3eef1bda269a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd43ece7b29fecb286f2d8ee571a0c1787c7f5c1e7357e69527042b099dcd02f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a654452f448abbfda1891be607907b36d971e44101aab63f031b2e85e3bbe33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4121cea52c16b17d86c3e5eaa57c9e307c2848f70da2091493e8fe42fcc9835(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924e89ec3982371599b7e54fdd67eb631083e1ba49953243be2f9a975a0486c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbcbc83c41322f665ed43a45ab1d5584da7139a0a94bf6c0eddb6ba8f16e9265(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b125f3b79a6190473acccde424003d72a6a9b9adcb3ba7e37932f6f3688df1ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae132aea7bb6075a073b9085071286c267c835434dc650d2c30dcb29c64c9df(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898ceeb6739e4bf04c5cd3ba3e44640e2bd755579231fb50bc5ea6192ce43186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae4a6d869a400a6c92b2067d66e07c0cf31d5adbc2781261d8c8d28465ff1f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13303a9977c79cd80bc842a4b3890993f5a29e9f80fa50432c66b7ad887f594e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e0f3a0dab1a88d9c16606524dfef8455bb44c7007554c00b09f1dade7bdcb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f56e3d119ad6cf6492dcb63c7977fa3a59647a06aefe0fe1280673a16cdd41f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff04ad2e7e478658ca0020b434783e84c6613c757f05a980fd428a4c4813f862(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbbabc0eebc043c0215ba2d62863569e937ca7ac6d977e00acdcbd071ba805f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e634ca46b5bc1d0308bb28bb43f19b830aa9406edb6e00e3035043bd3613331(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82d996df45d0cc39403c4bb5ff4b860a218b7b9a40793a9bca2e5701d143b73c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c185df0128a4532f13c5223fd79f47fede2c40f1a804232f35c9f2782b46b5a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c410410972cc2bb6c99353361e8c53c012e51cc9db00a83d87b2b910cf251a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2090b9ab06e1d2a98c4b28f8a867354764ced99f9757ec56dff69ee18ec0819d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12b921e52444420e24ac3e7d5d722651ea2e675f8fd1cba6335226b778997fbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3f8f929a2cab055587526dd5b285c690ef5074e4e189fd02a6eec422675e440(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5357ad698847c8d8c4129b7fea5d2c0b6ce16b9bc46e1b27cee1b88f1cc2eb0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21ff44b54249eabd90438eac2f7d7dca7728f5bf3e898e4d41b6f200fb56eba2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df277961291e85435ab5eec8877cb5c69d417cd2b59ac531bf139fb97a3ebb1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSaasDefinitions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85c8ce73d3c176a8d77509bbf33effd713bdb05d4460f4850f2d484b57c231a(
    *,
    allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    connector_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_host_header: typing.Optional[builtins.str] = None,
    origin_type: typing.Optional[builtins.str] = None,
    sf3_c_origin_host: typing.Optional[builtins.str] = None,
    sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e9f01c106aa493591616ad6bf6757eee63e88114e8621e8b96b6c5c1431773(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8641fc1028aec149c7b6a2bd4abd036b2a5c2cf083d3c562fb51cbedb586158(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b2bf2568ed2830c5de7f2fbea337fe53aedeca993c1fc468c2ee2edb777947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf68b5e3db1a36a04b27eb1934271eab1ef6ade37c40ef144dc6715f0df6e1a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18dda5c92da89afaa8b56e7bdbb960105a538bf6b7b17bc66efc3ea36d53a8c4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acccf8a18b4157d64ba5d421838fa4f71e3c7d4fc95fa3de610acd9a1ae4e162(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9340ef0256a6ea8533030e72afc6cee11d0efaeb25bb2d0a6482478c44c170dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdd9cce99b74d6925e537e6a4690556fdc9bbcb06ced2d7e58822997fa2a1784(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d56289d4fb1db6ab0d5ce0b594e0a0efa6449de65577a318f078cdc4ec13e499(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d09987de12865c6c76ec6da13b91d8e0c1be0045a41f24e6bcb9d5b76f55d363(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__129bb99bce76e3ca739cd943d7176afb7104ebf5f6e4ba3fa3414d542c624a0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7bcfbb1567bb960e25510edfc1671088a1a172f72690506d84e912845051160(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda85b5c8f3d90c420f5e1119b390f3d58b3bd9c47942c46edfea79c55633cbf(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1741cc9921c9619510d9b499206b9627a2323efc8e61f13a3ced1e58e2562cf5(
    *,
    host_header_source: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ab4868add2c83da7626ecbcc319d8bb82046e018eb6acbeb61710a951fc166(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6533584d78fa991ae03675f2ef43e8b75c0c6e7c8a37e1d4bac0c59fb5ebb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f27b17689cee7cf4caf08fe7c2a9af3310004c502592dc388786e944f5af501(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1781b5da0a9dd34b4a86a2a9c06497d353cf210a23fb311575a4d97a6b9fce0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6f72a6816e3681c76c3cbf26b6c2e1670f203ec884c8e3b58745fa5d31f96a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbfcb6bb76bc4a61e69514e6f1f561c3bd7232ec86ae79df74db3e8502032261(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProviderHostHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34fc3d4e0cd61e92f5c43ac6a3e6a5a6a3942ada65370c074c884288520be91b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef40151456c8a472c9408151c03c4d519db56e43bf2b7e2de36ce086a97a5d8f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fa85183a5ece2ec25bd6eed4fdc306cf638168a87f1333dd6cb0d3709fea463(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__220fd9ff1ead9244bfb182873b62674f7e57f90e502554bde1f3e0cbfc72dcac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9842a344d9048ae13f19bc544ce96c174131ebd7e151ac843b4e9c9a327504f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fbc5a27ed8607c89d1a1e205eb004c4b8cbe1532354c4365ce27941eb63994c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSalesForceCommerceCloudProvider],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3844a02efe7cae47df3335a6984f968bc8577cecef70a8167e785bfa62d4b56b(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9bc33c6bf2d36a2a573284c629e47e947acd1865d121a3bb468ee0cf3cf883f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0361f8c7305f0188b6de8d30b458fee0adbea1dcc28f57229eeb7d5b7de169e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d5ca90f1d152c1d929bd26089077687c8d99edc02f31229f8c3e3ba1b49092a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1e42fcdaa6556a223d4e763890e02c6c968e5ee84a6526645280ab7bb7aec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01d2b686a6d86e5ae2db7259fcea3ebdd4e5c82d3a4467fea24e73ee580befa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853be8f57e21b7e41a17522080a6d77c6c4924fa6b5dd0b7059317933a6343dc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSavePostDcaProcessing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a483402adec7ed7c08526b0d8242d6633d128fbe76055d2a299bfd26fde12526(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_method: typing.Optional[builtins.str] = None,
    repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9249425409b450b10391f255f1f8c02c1c0527735ad4b9ec4e117f86f83deaaf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f8ce0ff6d374c65fc9d0c3f4b2aa723dce2a333c49e251b23fb5421c835799(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e815a1d45a5cdf6e1f23fef77e9e76808eba7be9f8749531e9587e7319bcc1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2bae7ef94330523ffcb05b9a5283436ac0f5ee06897066efc3276b72cfa01f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74ed0037d6b440869fbd9544396c3599641e411e8d6d4fa607f7559c3242eefc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fddbfaa62667e04d9e2d634b69d6d0def89a63f8b379623c9f6e533370c62f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f982f2e41cc95316f7b3a70829df7e8abf9c7ed40b1a23afb5c715f4cf3360d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5097ae0c8c432f67d8af189822e4d5fdbfef75b9ba391a3db38c986ef49f039(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988e038521dc4997191ecfb31f41e2ef0c4c7abf47aad33d706a913ac9a777fb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScheduleInvalidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc543f02948b8d8e804fc15c112a979371bb5a29cbec23a0d3f5c755ca15cb34(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serviceworker: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timestamp: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000e0713cf7b139869b71d6f40879767155da59ae9e64cb185201ffa72dac214(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52ca09040b819e61e6f4452aa8e354af622e34a3bf3cdab16686b94970ddac8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0356ff8d63d0c19ec7d461f5364afa95c308d737c47e97f9f6bc0d5db7aa3233(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b334f6c9461b5670b910f48640a89c7c656cc2444626f4fb5e0ce3583168e534(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02ce24cf94a31e34c6703ad3eee4bb538b78bd636cb3ad078ce43d5d5174c9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c77d6a93c70332cbb60ad6386c749af1757cf006383bec0b8a28de435954306(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28a4541a1941c36c6e19eeb90f18eeb94ebf12e22ff7dae23cc23ba6e91e8c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__116e440209f9c42aa82bf45751cd5693424827b852d659eb14693cde09ec177f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorScriptManagement],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c448c13ac8a440d71e26e7416419c4e6879f0497a7dc73c73cf84a79a7c484e1(
    *,
    acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    field_carry_over: typing.Optional[builtins.str] = None,
    header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_encryption_title: typing.Optional[builtins.str] = None,
    revoked_list_id: typing.Optional[jsii.Number] = None,
    salt: typing.Optional[builtins.str] = None,
    session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authentication_title: typing.Optional[builtins.str] = None,
    token_auth_hls_title: typing.Optional[builtins.str] = None,
    token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    token_revocation_title: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b4b3fe0580ce127839a3b13feea663de96ecaa7f6670a66ba4a1dc3d9d73499(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8fb4dbd00f71db469a8f699c2831d2bc3c55033c3d409d1d97f55174b1761a3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dbfbe5b45a855d1f82c2330fc2c666899f571881a933ea0ce07c5f438faca64(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__098622e2ec2a1508ad47f4aff0d23b127f3311a60a65aadbb980f25121bfae8f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce73b8d79472fbe9cb43ed41a8ed7fe134595d4a0d0f848c29be01623696c94(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5eb1fe0ac8334f61f889e48ed43da06912d13f07452b9747eed4bb7eb05590a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913e0951d274a346525b9d0b2e53d5fc6639cd36ec2e065002e6756e1588f5ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8022c12474a6e5f9332ad21b16e4779bad036be1dc17afffcd2e561cf1d9ec49(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49410c3eb192208a39caf5180acfc440619cece859ec46219bd99d072f8786a4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4e2ebd445f6a12ce756d8bfeec00095f5d6189ce04616c2f9df7a4d743bb90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d4bb97e57b84286cae29f2e158ae3d741f6c0a7dcc9d2b265090c9335686028(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2498cc63df18d4e3325d36e6683b5a19fde808280eee41bf785123133296966(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30671d5483e5657b1b6bb57f5f6bb0baa4f6c5034e25e3b597e32a51e4f5e8c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9168a4991c183ad95357673b8feb90a74863ec0929eea1d2d011a0077af910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65923845437edf4e613d0ec251dd4fcb9aaf1ab800f0f1f2483d1121e28ff781(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbde30a8b2facff07472dbf6ba1e76788357e99a407eb5ea668ff0cc8f683264(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a8b7e8ab6928c299b188b0493e7b9cfb71c558d2080d9283ed3c2068ba9e34c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0662b326476031362db07793b107cbf5f93280e6ea3b6d3dc7577a00d115942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034faeb74cd7eadd0d4c8af5bb5f0995ecd2de8e037358be26c9ffe600ed4f47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85513724a1431467ca9cea693ab974d3a9808c9d6ed53a74c04eaba7f6229d66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd053c542e38584e1dd86249c6fa6957673a0619f4db29d485144d11048805f1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d7d4b9c6145f2bdebfc6f9e37309ee1c0f0a64214aec1fd34d55f4d49427d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72b62e5001cd3c754ef43ceda1965f82d26abe743191d6f25634ad09e168ff45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc48d9d19e0554ed7fbf4806416f2a971af963778ba1928ec05825dda7bdc19e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa99c2f68dcaa2939adf138528f9778f4f5adeb9025eaae178452e585b96596b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea4d19b61a56da29438599767045bb37cf06a7cd90caa73f4738a4f77977b11f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedContentProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f67614461e3b2e63293626fc8e5f44cc1f04476c73028cb9073ef72244a52552(
    *,
    behavior: typing.Optional[builtins.str] = None,
    dvr_type: typing.Optional[builtins.str] = None,
    dvr_window: typing.Optional[builtins.str] = None,
    enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    end_time: typing.Optional[builtins.str] = None,
    live_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    start_time: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1da4d0e36c37477afd45d371d33c3b102a57d74e357cfd8cdd8ef2eb9600a501(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c98e6d7b5c473878edcb42b773277d4c19bf784169f573280b5e5e1c159507(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ab21bc8984707359931d22cc7cf50ca1fad15221bea81acd4313ade73316deb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2d9709519c198c83129b3f55ee4c5a429bf887843bac79377c631092693ad7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__026db6c956ec4a552b84b309796e1fffbd3ae5633f8c6a68983e83219ac7641c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dad120297b58b39be86151ece3c9fc51ba56ef3d82223c68121ca79e7ffa62e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4817b2d39d496fe27386ecc8e9cd53f5280db1b8f68ed5ab6d1316101d9ab61e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32cd7263c24e2b6fade8cecf27b55691807f90b6a89904fb208b37381bc2159e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb1923745efb325871c565b8c71fad21b968ea94b2d0307b652b45c28a6283ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429aa05e4b5357f00d233375521b819c11be6a888a19815dd68740a6e21f7f0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628d3098bb24dc37bc43971812b8c3197c5c8024f6673e707bd950a500167168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc3350272855bd94835da3fbaf5486ffb96ee79943d87f426c53988afa2c156(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44ce3f4dea6a049432f01ff97701b04fb888e86d7f1e0605eb930c47277467d1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac4f750e0ca4a4c73423f80a727a6786fc6b15931bce5449f687f7eebd472c7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ca1a1363cc67f5c7737cc1835ba27f1cf5a35ad53090b984249ebb10de19a01(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4fd36630ca5164c99f07377bf354b8b3da99a3d023f1bc539d5aad098111a82(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a60c69478266438e982843c4535813e91258a72c6aac9e1ee7c6a28daf154b3e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d894da5330dc1d81a378cf73114b107f1b65205e9a8aee171f8d8beb696a5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5641856f239bf895fe7c4f731cc732aa60b993e740f626f45ebedb655d8cf777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de5bf2818de470ddd1238acb792f1af9d4b94fc6bb084cddd954a1f377ba99cf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSegmentedMediaStreamingPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65711c41efd53ac2331a2d2c7f364aaf440eb6582f5bb7966f337b3d9bc8515(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    certificate_field_name: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    device_profile: typing.Optional[builtins.str] = None,
    encryption_key: typing.Optional[builtins.str] = None,
    encryption_mode: typing.Optional[builtins.str] = None,
    end_index: typing.Optional[jsii.Number] = None,
    except_chars: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    force_chars: typing.Optional[builtins.str] = None,
    format_string: typing.Optional[builtins.str] = None,
    generator: typing.Optional[builtins.str] = None,
    global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    hmac_algorithm: typing.Optional[builtins.str] = None,
    hmac_key: typing.Optional[builtins.str] = None,
    initialization_vector: typing.Optional[builtins.str] = None,
    ipv4_prefix: typing.Optional[jsii.Number] = None,
    ipv6_prefix: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max: typing.Optional[jsii.Number] = None,
    max_random_number: typing.Optional[jsii.Number] = None,
    min: typing.Optional[jsii.Number] = None,
    min_random_number: typing.Optional[jsii.Number] = None,
    nonce: typing.Optional[builtins.str] = None,
    number_of_bytes: typing.Optional[jsii.Number] = None,
    operand_one: typing.Optional[builtins.str] = None,
    param_name: typing.Optional[builtins.str] = None,
    path_component_offset: typing.Optional[builtins.str] = None,
    prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    replacement: typing.Optional[builtins.str] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    separator: typing.Optional[builtins.str] = None,
    set_cookie_name: typing.Optional[builtins.str] = None,
    start_index: typing.Optional[jsii.Number] = None,
    sub_string: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transform: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value_source: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__086cec89abe5800acf896d7f83c3ac5bb13528e1c0bd38af4edc15b901f92f58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f245d00232e859941b52b33b80c643545621cca55e5e7557b39274765ca3b29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831059dffce0b5ff0edd90e16d6c2c602207bee9ca7c31f11a8ad0942e075e35(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de399fa70db889a9b8e1f7788db74339897ddc829ddbb4e43604563cef3896de(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c880dcfa9b9066b2beaab69674ea775545f2686e4ba4e92e48ca9911eab94737(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__033f20b7e852e9d19ce166ca1d2e890ed6b829b3f4dcce6d34cda425f5b7f20f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04523169d8a37e9c380f06fc17cad961dda3cdcb4164c544b67204b4ae9f6a16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef1c6cbd3c4ffab2f16a60b8d1050e646b5f0114b0bf98e1fec7cbfdb50778f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b05db9801c49fd8210434ff78e10e7de0cf9512781a6eca733174fdc9b9339(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f3459da2fcde72f2e0233401fbe37ca61db47d00a0420efd00f1d2a0c86379(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02897a75d7a81edd35b3d8d13fabd67e15d8d8b382048940dc29d072f84aa59d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2358522442f4d941ce19addbf7174f830c34a25a4274bd521a05ac146443d240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40813d88565527965ece7cb4ab5ca9d84870cb047af88dbd42bc2bf26470a94e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73b91e8059105535d985f6b4c73ee976faddd0b7a7f7f12f5908bb2094e77d1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e319bd43c14dc875278ea8f0af2bf9169d9bdc5bb66cb2d27b009eed724a9da9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecde1147636d6f2a932476d307227dd09599a7ba5547f7b19c36691bc2312b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__546ac32204cd426013b42335e77ed53a8b44abb038434519f3ec90fc46133a14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7125c3b9693cc99b587d1292aa3b112b79aed7ceed63437dc08a0302cb5438c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__244e5cf73cb513648d269358049519431d71bc3f2b841c37e8571f14f6ee841b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb11ee58a4705869d45a4c5390b54004c0d65e947bbde285684d3f9804f79fd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a4a251a469818508a7b77de05d391bc3848d4f3c1ec8bef43337a234bf2a1c8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfd1f812f2f41d4c0af37867274b3e07e0b93c4c7153f2a132d885abf0bc7112(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67056c6dbecacd355a357ae20abfc030d1e06a5c4efdad8f728bac4e428ed1ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e4d05665cb272d1d9cad69fa9cf481c0590f9328561db8d4e57ad0a6ee1cc5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e7d0e6522d9157b05b01dcfd3d2d00a83a0942bea7ef32900e27a0d41c77925(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b02101c36e795a55db032ba1ee0f5b2bc01460f15509351e6db63f6e53e8ce(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5577f510acce19b0fa899cc8963da5f4a2f09fd391e09a4f5b1068e247663c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c949e51f02675ee4a487780d9d8780e4e691c800bbaebe1d68103dc6f493e9ac(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fcee9d0c89c23f7462908bd69c1d5ebc87721d032e0bfad88b9c762b996dc1b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c73d71f1d36e3215cc40bf5a6d628e2259d45c839885f63ea16eacaf9d6daa0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29ec0acfaad0f3ae957685b50a083649489024d7006b81ec236732e8c25d9eaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123725cde29e563e046415f40b9d7ded7a320558d40b12c7a518fa87ea3b05e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd98d0bdcbf51f7a5cf5f9877651265282d9ee4f83f56b7caee8dfb9962664e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710955f296e99df4fbe4f20694df1fceca490236e5da73e1b77fce99f9b87410(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__516d25f4a812f4258c36b9a8fa469438be59f2dc4e5676a442e1369b83032e00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63445617cdc7dcd4ded0cfb44b0e2aaaad7fa9236e137f868eecf6d6f1d5bf99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33aa0964a8c43b8519c617482de67917473f3635cd25a007dda2fc9750431645(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acbe7c39a34d43031bf57e6bd127db54ac2fb5371089d81b516cfc56d8eb7b00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f30a2dc15e11e959ff9899ed86ae14ec652f579b1359548fcd5b469fe94ce75d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb11bcd5839f431f0d76a618400fecce9784c29ea1348ebc0e620731bbda206a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0931ee17533be2067cc34492bae8e7d6ac18dbe6ca224e2eb9be843279945490(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60fa7c85c90341b99d1675e4d0aa6b09f555a8412d43aba274f1fd92153abaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a6041b76a10ddec4ab6ec4fd2ef2db6bb599396b55e54870f522765b8aa3ec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d16a1e751d1520ea93b93cbe5896a64bf6e4755f628a4c83e4b440350aea4dca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9419b085d75c2d6554ca1827d7004f6e76f91c234b7e57bf83a8d866c5d37bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b950d84cc979604119fcbf40fe5296556e005fe00df7187a2ec615c174c1ab3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5667650624f4f63531751ecf321a754dc5a428abc7dbc29380ac602ea71065b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6eec0d7c60cd0c7e69a97550360451e45925e856551c78d31cc183404f4324f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64f2cbcd04154840a117422e06a5eaed0532948d91e08ee1d79440984f298d9e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSetVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8d6794f6da9a773df91fe98e193806e02587e553e0c99b150f1f604ab2eae27(
    *,
    error_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6687528252b8049975f5a90a0f004e383a6de0f66963b85e2b9373c1b76d2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff6705e626bfc2a262589a75aad523eef788b054ded022460aa43ff2b1d5854(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__500b970ad2088210d0bc17ed58889ce830981fde89d912d2edb6912cc47e8c6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79cf28fd000d138e1774cabf786ffbd156870635a4fb0346f248fa59d3494e0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63be88dd07e87ed57c111b175c544ca983f58654b6413854e4117669baad5b8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21bc70bc2ec88c430e80d52a0839ce72493132912ff4de18fff46f792f14e93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7047246b95f2801c829198f1330abbd2165098f4feee9d33e75dc0b0456782b3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSimulateErrorCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab82a66683c7d2e20d8c4d2436cdce04e3bdd8e709b7378c3eb1f0a2efa4b98b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nossmap: typing.Optional[builtins.str] = None,
    ssmap: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af2258765ca111e32b512a46f992a11b00f87fa44ece9e3943959786af02535f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73bc63f1d5397631fd1154ce3afe63ce06ccf82aace300299213fc247fd19037(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ecc2abf80e3e2e1a618a1d4bccf11da2db8974196351ba726d26b79723a3a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e17d4fe51a93165e2ce987f205b8838d2306993eef8dd82670cc6484ddc127(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba90c8420059cad98338ebb5befdd79c14bce4753c18a7bbcc51f2f76b80250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37eaae85838bef46538601efa2a5ea83f87face1d70d57f47f979a922573246(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShield],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6cb239b855d501a929de9c0eceb246e6c9b24bec33b72d19e0f7724cf60cbf(
    *,
    china_cdn_map: typing.Optional[builtins.str] = None,
    has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    name: typing.Optional[builtins.str] = None,
    src: typing.Optional[builtins.str] = None,
    srmap: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8a847f585b500c7ee714186d6442d7581f34ef5d28199921624c656557e904a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71d00e3410522a50dac851943543f196821d09f173913d1a534fe81220e21a64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fc01d0feefe6837a8c661d9468ac001d6a30849cc626672b928b2d9fb7dbf85(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66361f40004a262346d02584903d66308732c83c43468a06f9b2608435ee79c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__509797a1bac90e33632af9cfe1a580ed2f969b672fe235ce514ca44442c5ac80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c6154fadd2cf3831286ca053e0177205b35b701a2a8b70dbe561c274918a96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55114b40d86c773288c6bbacb96a9b06203bc6b267461007d38f42c6c3548782(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dda4378ab0f3228a192a6703c823026ea3871ec30277b1c022dbdf2e63d0ee22(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSiteShieldSsmap],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f185586c39551f3a9050bcdbc9adb673a4d5fb91503eb261b28de6ef157f8ccb(
    *,
    allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_sharing_duration: typing.Optional[jsii.Number] = None,
    cache_sharing_start_time: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_duration: typing.Optional[jsii.Number] = None,
    migration_from: typing.Optional[builtins.str] = None,
    migration_start_time: typing.Optional[builtins.str] = None,
    td_location: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eb005b6e82cf3758add61f27ecdbd535192cff22e89ad66dbfff3fc34ceef8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c1af43a288a93376d61333a37b492a844d8aec7b9c8564fb1f307238f2efbb8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__480138b065ea02edb8a4715f74dc1dc4e4d5c5220bd17325fa183824b5c61cdb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9c520726ca7f48cc31ffeefb613b614b6095931cbda08d87b225688d08f2fb0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86c26de49d74f3aa33f4a2a42fb09f898ae07cab596c9ce1f9d0e67918711ddf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__478a70902154404f227c8e8b77c163d601c78f408c42f00329f679523ec5cc9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__071d04ae549479fc9011f57cd09f0ddbdd9a6cf011426597d2d9350d4f985f0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197f52939bfe9f557af3ae93c370a391344cb8f4b5c5a59080c6075cebe68db9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036e5b91a151d3e1af51b03e32e54be5ef2acd936c600a976c0596d35adde114(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f4524282ade998fcc0e9f02b575b08f43fb7ba220d0a5cdfadebc596a79d2b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f72022b497d66447125d6d130efbd52d779edb02f78396307616428d4e767ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91ac214679b37aaa2c2208db0f7449b25d95caa3122ec0f73697afd75221f067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16daa9cf26e5e8e9dd1aa3a1749c9b55e729848232b031173ac4d43cf7c0d8e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__464acde94188cb17a8e5ad4b265dbc7081b17567935cab5be6718683810ff098(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80380653eec673b949722d7c709bd0d4b0a79af02b7690bde2d9771709ed1d58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352cbdbba965220a8df7b75dcb6e0d57d3ec681e5790bf9adaf76625d8d10f68(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce51bda3d26d99c71337be8677cfa9a7823c2b6c50d03d3e072814ee71099f70(
    *,
    info: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3872499fcf249f51e6cc42f853b5707d14096330e7046ee4ad29876bc0fccd7d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edf91654c27e1071b1fb0544d5c83d5116940f603a6daf85985b69db52c86220(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37c37e297a981744a639f271518a00828af1e5bfda0b06a6acad4824a9a30f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079400b0d44d3ca4d22e8a98d72c07a11610c90fc11fe2db548c84e78c3837e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1abad9119689eb6783c25241d71d4c44534c86f4ecef3e0e86426784981e0fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a6f102d923dcf1f7a76d4adc6cc6f43ffa279038f2eaa132ba0d83e15300945(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStandardTlsMigrationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92bbd636d86cacf23e7a05d5c729a41a75d3b59a14623a35ede7e954b10e07f3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85eff117de2d6d65a1129c1184d0332c671149d41c2d489fab2294f0ca9ff28b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee789461cb93ee82d970b3528e08ccaa640c687725ce42add4cfd8d565122dc8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__417cc1873685301028645becb7ad4694a102149a5cae7b71d32a5a4438cae38a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45436ef0143077654997a29d6f072081c03e90668d3adc6c694178829cf54b47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b4755cc5a015d976bf6d0fcd6085426c45d3cbe1402eb207e23c6e7cb73eb79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6931fe030115e2dcd6dc6b354406a75bbaf89259cbdb1f9e5695ee1f0cc3b996(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddeba2b41950a24cd8ed52e45830fbac659e4a4a77fa8760953e2544be46f46(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorStrictHeaderParsing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024681286cda2662c2c6ffb6ed0f853dbddb8b5801ff87c2f7f92ce3b7773ee7(
    *,
    access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner_domain_suffix: typing.Optional[builtins.str] = None,
    referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd253432dda4097fb503179245b85aed3e7b3b447c8f0351b536a0236acb1571(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fead867a2cb14ebe246b9c8c0b46ff11be827c4bf93239e766bf5042e0f32dec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4567c3621ba6a6936310213469d76d6e7f49b28b980dba5948f4023e68b9911(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fb8153862e5bf736a7232d288e632d40733ce012154a032e89a62759304e93f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4d2d635513992fc0b1cd629a93b6e4ff65612d3c5c4c6c6d18cceb5c9a7585(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ba05a2ea9986d4d28c8cee3b5d8dc66ebe4f47428b5ec7de6eb4a8ecdea19ac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f06ba1c09da9e7ec8ea3a4bb0bc3824f3c8ccdd479a7d222b8b9ad717dfb4ef8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3e8163484359d2bc0ae284a7172db5bf45ba17724bb8f876b8d101c11ec974(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c5a67fc50bb466da92dbb57dde07b14de08cc2f1a0052c623bff8f06f11b719(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485e2567c27c794e560bb44a3f1ac3508cc7cbfa25d85dae32f348fe4b2c11de(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a534697bbec949eb7387c5d3928ec7ac9e6a21a9c389d71c8929edb3bc3d228(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828bc9353f79f74b55f5138037c3e624c9d560e9a8b0a464c1dc9335eaac04d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__352121de04e4abe6e2fe1d1347ce97f57745cc8aa1a730f1d74a720edd77f0d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d687134a8f2a46d60b5ef3161252c22cfd357695e0e13de5c9d0c0b581258b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5474dcdafa3b3900969997054906ad868ec812efc1ec488ef546ed51b2ba1747(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7235003bdac4d0b91d6528a141c2344db350dba8c8a234f3bf156c985a0525f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54c4517d3461f4396d335794e8f40b199062ae459424a5acf0b053e42c79b0a1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3560c251fba946f1687dbf2f48609c2801736a6a292fc0ba5b44d55303921028(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbb74e53ba15e9f8a386bd799ce9aa719c165e70fd781b1ae19efea020a5a3f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dea13e4bc41513c9ca84c89e5ab40a3f2ec3412a58611fee5e5712b3096d608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c62cd9d29a4f0be84c8748d5c425198311cb36b71f83ced744c1d55b97c88df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a422cfd433a7a1b358c34c7f5e849164bf631eeb5eacfd0414c56ddc81dcef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccc3be53e2e6dce9b724b936f391d7afbd725a840f73a741bd2808808f885490(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475318e2149652e96c051f9ce938dd6eb7c9da03a4677858092a428ea39ad6ec(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSubCustomer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ade1e3a7527f0de48aba8509a74bed1b7f0cb9f086fa902645d77e9772a01e94(
    *,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map: typing.Optional[builtins.str] = None,
    custom_stat_key: typing.Optional[builtins.str] = None,
    enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    race_stat_ttl: typing.Optional[builtins.str] = None,
    sr_download_link_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    test_object_url: typing.Optional[builtins.str] = None,
    to_host: typing.Optional[builtins.str] = None,
    to_host_status: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abbeb965fcbc62faae85211f9f1a2ad06bfc4a9d644a123e5ad164f6043e0c56(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98fbc2d605ac28917a845fefd438007701b7ae060ab47c5c9caffb5e1d7556dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__757d8c4c815854122df17fe61550a39ce7518b481fa68c61358c2cbab35a5057(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0445f818dba498608e5fc1e978f450fc8a3b69e6e9592e319006cec38341761a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f9a70d418907737092dd990bd4a26873a5e75d0d8f8d8e82590fc3fd341b578(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6dbcf763470a4af9e5950ecf9a5e7f8e6a1d5528bc3474f2fe18f5c42d458af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a413be2004dc9d21503095f09c0112cbb85ff69b92ca26111116505869178f36(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ced0023ab1c835659ad1cbed0fea62e814a9200dfc2e79c0080b9e1bf0d308c8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3977aad82d406aa4a0274f283ef74b280218727392e416f99ac9b75e2122d4bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fd9f59f4ea0640c24f035562796e22d5d2024a11ab283ab9270b1232039782f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__444647e292143cb6e90a99c850d5c7264be990fa44b878406a1c8a737844e374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604851990b106b0ce5fb16534e027434f62f75cfa6fcdfaae1555edcaa7c2183(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3672a7f33e2fa6e6517965c1212ec09789f4b49b45658df90ac9db427de8109e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a986f4cd7f421263f917548d8a8a3937caea3edabef64904797aaee39101c2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__458912aea8c602165ae4d7c2b4d5f6e8179b02efbc26aa1cd8a897a482f6f8e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d515b3a3380ffde453570ed3e91f365bff39b34c86f0cded39379982041f611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5370367f04a529d6cdfdd87710bb6b2ab5bb4698eb16177db6aed7109d7ff9f5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorSureRoute],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f144b8a820491bda7acbf53ae19256d251174a4c0ad276d2c850026712b25972(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d58a5b4d5ea02a7454c680112015ff7a12e6a1556b694ec78b8d79f57a49ce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b1ff4e1ec5ac759d4d300ece4a322a4ad49720405cc2f96353a0c6da8ba48a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8957215cdd5f25e6f7364fd714ecac4e192f2c280e6acecf70cf6a61b685ed53(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3935a2f51d290532ab2ebb4e9c70cd6dbf7ad3bb6fab8182e257e57c7b37a620(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67fa88c608b8da2d984ff09ff431df48da52a8afd417e0accacd25fc7e184b12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dd9429f6a80eae4ddf6f99ceef534629ea7eda16537d54ed8c3ce166f2918d2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTcpOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a4cf81df081f2cb0f7b3c111af2d0143288fe78418e5d49c18fed0e5339af15(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ibm_customer_id: typing.Optional[jsii.Number] = None,
    limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f186ef88916503eee48b1d5cbd7e30eb634a04553878f77acf89d84db3ad0c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea02d52e67d5e090530588693e2a546c738da25fafbc87cd9c3c220768167a0a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef971903cf1c47259c2aadeb4a79c608d19751f5e4e89c55fc4d0ae86a701a8f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054c34fb48cb7ce086b9f30e77b3fdd6b80abb2de3a1e0057045a5130e8728ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67bbd5d2f6747852258a7652c87ce2b4a319e34a17cb85d607b660913cb80559(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4826aa5ce519e8fb478edd8389ba83eaa6bf136d4e98e7c2aa0118dadb9bf287(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613ec5b5fb11b044dfbcb6118458376330f841b9328e164f7cf3d6edc46fb5c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566378c3cc58982c8ee70267412095ce7c8e2f9ae3bce04d4fe9dca9ff8a76d6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTeaLeaf],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79074f83ceecfd1da7f3d494b77d5715ac31b944fca554eefa15b79052e11eba(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b523919918ba7077bea608bb7fdfa3790e9948f6bd05341e36c72540fee03951(
    *,
    allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    method: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__114b3e2a10a7d7018a52eea89ead2f5d884a843601be7fa5a5a75bd620c7c100(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef4361463fe961e411c20111ab451698202dad85aec6eef15781269f06081915(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1ee98cdfda8d6b3ab94d1d19425c0d1a4235edc04edcd72c532e3d581ba861(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddcaa123ce4d08754a8253fcc7785fa9fe3d458cd8d579fc3b5fb1667f61a4bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f58eb10a3aff01b39635c5d5e728d265f346e722499940dc4ab204aa99a8430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd64efa761c4a10fff310b892449e3888d79083e113a816e232d463ba99d264b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__709e4fdf2f4c36b545d015990b61d03682e7ff82c69de3287a780b70d1a163e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3befdccfb127cf7ed192d2e3a6fd077c989d8e46b3d20abf050dce163bb395c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68eab8a3cc6fa6263090aaacd277ee346f374ec892830dd216143e004de6f18e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6f460a80b1c453ce98ef94b712a58dca22345bbe114592f932d81d4e003d322(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2634062bb2a0ac951c186185b71d1c423888589bf592b0f7a64d69af4e7e3550(
    *,
    cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
    custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map_name: typing.Optional[builtins.str] = None,
    hash_algorithm: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_end_date: typing.Optional[builtins.str] = None,
    migration_start_date: typing.Optional[builtins.str] = None,
    migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_end: typing.Optional[builtins.str] = None,
    serial_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a385433eb06ab0322b0a8ff9fd53fc54a56876b266cba0c5a470461d5a170f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0d7047c6f1ddddede1d02ad0b22e44c18f9519edaffce2bdbbf09ed758b7ee0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__205b100163e5a957a17438e0a6393a7fcf75435eeba281181c0aa5a6160b7c8f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15ab3d165973ec7e028456dc80626fd2b3b64c502b898ff048597cb170a4f86a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c462ed9dee5d6c5837db1e585e3469dc2006c6d9a31fd72a67e194370689129c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7054b06e2ece531d367cd76ad2548e157f44484c0918e12661cc4676773bc74d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c703288e68a9bc27b02fca4e41206681a97edffd3f09e2f2b300efc1fdec1adb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e325f64f1cacf27b7988a6cb6de14809260ba73afa2c1e12262ff26b1e3caf52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd71dd7fe642417a162ea29e954bef058f22a4459bf514a949637f0af184b19f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35bfb4ae9e157c2d45249b5cf6b74d0e88a77d2891f0bc35f38372e7c138ab5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ceffb77cafd5f35f35fe7af8d3e3787a9de8f1b73bd3aa11deabf4d1dc87edd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__530db3e6ca2611332b525eac7fd205452749c155829a34e42946bea044a5a24d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88cb3722d2c5e548421cc0d84f96114904324d807d2f2b38f8e62da1ea360ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57a29ed9399d2c3e4b3d280a5cf7ccc37a18b97681fb08c9264b7f496d9f9b9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18a5a98029de0560ae4d303176492331cc12482eda9e5336bdffe0c1f2031a26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cea0ddc253e9f17e6e995b255fe5106a8c4d6ed129c5608508583be79055225(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__951228f161d60afc7645a7c125213fc07ac3966b59376c0530933dd90e324c65(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistributionCustomization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d116c852754256d4d220935080303340a0059e8db083ddad1d2262d42c3949c8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03433413c3e16a91ba0c823e3b820705917df3080be9dffce4c45e44983f123d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1caa60c6c0b13df82d5d4ab84ed31f8578e5b53df32d3f91c31bd14b5994b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3ba1554314dc75213fb7a0d0099688b6bf5c42c879e255c09aa357b546d7c3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__465cd6ea981a9e5030777242749c22da05bb9915f5e65d6feb73cd3f6779f1b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d6a942d72614c5566efe0582af01e59c1f628f4d5b70eb0a0cb5dc80ea6cc64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__deb62236e29101c7df1545471a6625080c6e3d0eb1424fa98cb95373f5900518(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTieredDistribution],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c65c6592b775298400fdf6f4e724be571a3fa18292437fc1a73cf8efacbae7(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6cf7663368250b5c87966d897cc0cf0f91b6fbdc7711a7d5237d43a6b4c886d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb84b16f2481f11d122b6469f38a2690da57fcbd5285e78f0b94dab413633e4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0fe040f8e5804b2c58536a13df67646e725f75a27e0f8dcc982a2b9f2776c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e3c2415e3b170111ad3007d33013c1899bf830bdd6772ef9e90debfd5d89cd6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd55be0f51e2e75d6ede83add0d0429b14b7fbbd1c227887a7a87c4193e9a25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d9f7310d47aca5a375834531bbfa8fe45c5357b1c4e27a758f18b8bf3a34a3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f103a4bb7f69b3e5c60cfb7a4e953d9996d7dd354906fe17e2b3e988d6d8ee0(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    legal_text: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30cf170f7738400a1f1bd423fc7551f19a25d111a4afe6e34281e515522b5b74(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd062750e425e88ceda943a62c98ea883645030abc761152539f85840b28788(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__895fd31aed69e14bf2640883ee3fc98e1f7e29597d1ada89a8f4fbbd5af48d85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20929267d8f37df8db24c249077bad19609912ac0fe35534ad749bcf04f8459b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd0820116afba9f9ddc3ede724e06319b461eca9d685af844096399a09188e72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d49ec0ba4c05bcd27933ce31aadf00d05debec3559ea768cd8439a2efca760(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6042445b6fa1f5d0a4afd0369f829fbe13d1cd8e76682a02011ec07ef78d0ab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32484873ba26e4a2dd97d30eb30924959def49730d81b27171e767207feb6c89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07955b57b74ea3d908bc64a27c2bdc044439649bd03a5d587a2d53aff4eb25d1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48f297c600fdbdb64c29a4f0a39ea32fcda2ac4e67dad4fd41fafc959186f2a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b3baa4d1eca0b8ed59b24bf425f0885032d76880df686fc9588018efc243eac(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorUidConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c263b03d98de17c98374d14e99e0fad5855fedc5115a4da5ddb40292f717097a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d60050c257084503da50c64308cc83d6cfa85dd96787b9bb38b51ceb67c62e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bfcd9d9d83b9261acb64254ae90c49975e17262ed6c8fe0f3d2359108374eca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f1a45537ea15ab40320af3dd5bc5909c47411c84067e4e0ff6d0e17fb49f34a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__808854d1fa22cce25bf1b3ae39b2baad2d0dae4cece690a05752259abee074bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b657cb2176d1c6b4a89b4907a5b1dfeef11bdba689f4b9a5e26059df9e1fb92(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0ad42b196d07a62169baa49899a45afefccdeed1c3e1122638036e14cbef882(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorValidateEntityTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4a02108f1b7d6a68df9874578842dc62713b0aa887c5dbf91d23f411236b0ca(
    *,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f2f312c48543b7417994ab1484a71defb9507678fe708c1b69b0aadac2daccb(
    *,
    authorizations: typing.Optional[builtins.str] = None,
    client_id: typing.Optional[builtins.str] = None,
    custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    primary_location: typing.Optional[builtins.str] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_name: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be2b8d7c100779b8d180665acbb8cf7edb0adfc3ab8e0cc62c862f6280e651df(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28cbedd34a6c8e52ce78b29d4e9dc9adcfbedf19b9c90576ffd8b47b453940c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfabff380189002c8085e6cecf385220353f0192b7382a68248ff24818c21c00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656adab768b18a103222971f0ca4e353c0ea84a8e409d95113aa3368c7d4553e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9648321eee89e400831a42a7e6476aa1642eb6d0dc5f6ec9376c5a99924b6a80(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__115e6c3c9bb3c901cb768cc302b8560aee4a2e0e575eb905700c99b1fb6b02cb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1d4a336e3c71e5159e58258ae8284978f5dbcf48f5660a61010ad013c1fbf1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c7857b59d741c64ef7d899e310a75cac4b0e0d252a41464258547b77ea8de40(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7293023d35c7d782275bc323d52d8dedc457f250bb20cfcbf691062075a8c074(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed1eb782737d45f8a83f7e548300434df5c8db948307258afa8d3b613c7a450(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__633e4cfb7b6c1621ac635e862b483ad087b414dc83ef7c489df8e18c5ef278b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1d1bff4df1127230d86a6ad33760be6022aa995dc37beac794a10ae8b2c616b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a0c37e525c755107537fa35aeda2407efa025d8b58a4de3e8231d8f5d1ce531(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2def9bbda2c876272db87cb654ff7c53af432545f5de327694d7cea3e12027dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97f68c42d97ff5fd1875c5385a78d2e6d43889721458452710fc67b5a5bd9762(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fcce352acf31606d3ebe086121477faa068ee5e28b2b1d812d459b0b08e8827(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc08995ac53bad8c6b7f6cbc7e6d637605499958bddcc9deabf4c059bf2e2a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__caf31afbc9928271d6d295731ae5bc5af86fe0ce23dce74f5c6742805a391155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8c170d960f8b3f39e7700a2b4cbac22c7debf123ccbd2a005e3005bfd38cc0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebTokenForDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b3a5a84ff39ca28bb4a5acf8e0e5da0e5cfb575907c0e86104f52076e3b36b5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50d56b2e261822d32b8d13a5ede796545ac6c6902286ea51186663eb3fb4a976(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a01f711c2473cc9a38b08b39163c0f4aaeccbe9d998cff76daca6946fa58a131(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8bad24457371395c4b7997be0e431134ca22e52099f41ec548331ace49eea80(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9e7fe0d7450cd2227b9b0a02ff923e6f1352bcc9340406cbff144a92b66c0f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7609ed8eab47cedb7d903ddae9b77b06710aabb3d96ba5fea759df839a964fd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3316fadff5aa5af4d01022cc6229f8f6df3a0abdcdd24be1627042871f7ffa9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e67ad408bdd51c362236caa5cf6c9aeb7a119684b1a4e98b9bba26ebd36d5659(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03768227bca912082509c7a0127422bfda0efae25182c13e5976c7d227ba5689(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3afaecb92043c9e41c6d9b55dd97b952cb5f67f9205bbd5f1a57e471532457b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6055935a2e7324fcbc830546c8a4ed2f2c49fe48cc623e2ccdcbe4fc39e0225d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyJsonWebToken],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40c14dea366f5114824698905ec239bbf6a7bdef0d26a25fe707e1c8d7d9ecc(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    salt: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9c1bfa5b8459ecb0aafd01b9c6f1a6335766a97327d46d467fe59048505206e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c1ca4e257858765ee5fc4eb08fff39de6e2bcf91d2863fee2e3b8c6e50b824c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__277f3eab81e2a3cfa4ea9a7bda9303364f688e5f1fed6e32790907579a3a8d99(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc3910a6ad1dc2edaa87647431855dd661a026efd4ca2bb1f0d75ea2a54dcb8c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf31f15a5cc8172ffeabcd37bbb959e4e77712e3631a10d79c63361a4a8ef68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69c53a9707e72e4c72939e7a1e26aebcffa17f0d75f58181fd02bf8587d64438(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafe06bedb2c4c2336f9ae25c856378119c0ec4ac4c9c45bb991310689a5ff01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41dc91218b760c31c352387924dad22f342117b23910b61d998e8e7d90135184(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f519c16086a5b7b5886475597b5c00fa07bde48b1698cae4e2fa4343f686d6b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d04bca09674d2c1635a7bd8b1bf91444bd02456a8f50ffb5ced61f0d3d07a7ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a06b3fd75eccdd0853898565d9deb01f6545a8db7a0260dfe286a9b9920f4f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5331424dbbf096fb81d426df58fe87822fc774cefa92dd77cf53d5c98e4da5a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76f62f30e6bcc16b7f2c1765db1374c5c705408db56870d046092bda03e46b3d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4487de1450019bc3e2c8b91851e6cb5c1a439fee465736005d267fc3068d8990(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81604337fbc8b1c7c98e2070fd053d0ad155273b3d49bde5378371a4424bd987(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVerifyTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed300f8598ecc0aca6243db28e0ce50f858b6783420dd43823942ccf37344233(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba3da47215b0b763afae60ff0a508e340b77d12bb1c250d9729b77d11a491e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e38a4f4e8a6db6c341a2dba2db6e8a83ee9edfd0f7ea4a2b7e03d72aa0246e76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f67f63550531625e2501bf501ef3e29cc154ddf787cc81d10d856d7a0d81ad(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b263c457a16084f0d285fd5c0160b15883367858fef8434b226a3345906a44e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b1f9613ba6fda740c859ddf8a7c51fef5e93b18ca42f092ab5e6073af6ad2a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac492078e9a200e8be085fa78042e87bb08cc7ef0c31636c0dfdd6e2a3bf382(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d2c07b24caf9c54f1ea93342fe5de41e47e50f09abd6f0cc302589299d8c680(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd999a90da46f0c8fbd08ea14496a3c1e08c4ba81477faf8b731162fa6b4ce4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23868aa6106eb5b225e06e803e4cd30a5b95a03447c494796b259ab30c4a0018(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04d31f97717e286692dc77b93648ed2868786616419a6daf1e95345412df3f12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6795537bfedfc2ba18a5470e1fcde0614d177dd4235263d1a297cee48f781256(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c85a325f24e2a4c735a8103a0dfd75b14ed2fb8dbc381de00d1f4be797b45d4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80466bfec6a602cea2c382fd388a8d7ed4e833fcb6d1a6038a05c626783abc94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33712f53ff1d298786ce0a29445c079eacdd41a9bc5627e313734b5bde0dbf01(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5aa86b72075713206a8dd3def6292841eab4efc6b77a78b20eff461363506ab(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3991895cc4bf03d59304b53eb97ba18e8aed8ec067ea21415641739ab581d4d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ed9d90fb7f564769829fd143a5e2f6d49919d6df280eb9763fedee4dc8f006c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75eb3480505fbc77ec959011d528360f23982c75a6fc8ea61164d74bf9e03b26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8cc9e1deea1c142650ce2512e2a1e679ab219a332576896c2041527d570d000(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d49dc10d0073b87f20d8d0159c0a3968ffdd5f154ce3265ea10c2a038300c1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVirtualWaitingRoomWithEdgeWorkers],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd01794780a27f8484ffbf7aefe0d3ac0cc23bce5bacaffbe2586fd651198ec6(
    *,
    allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
    allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
    allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
    allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_label: typing.Optional[builtins.str] = None,
    allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
    allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_key_cookie: typing.Optional[builtins.str] = None,
    user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
    waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
    waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_label: typing.Optional[builtins.str] = None,
    waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
    waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
    waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_directory: typing.Optional[builtins.str] = None,
    waiting_room_management_title: typing.Optional[builtins.str] = None,
    waiting_room_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_status_code: typing.Optional[jsii.Number] = None,
    waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68a0f3cd6f799bdfa63195fd2110bdcb32d2c6a996b745bf15f5119a34ef583f(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91743e1f543ff1d5f7509182c5066f4c41b19750534f77a45442ca7905d8b9d3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d486aed565e53953c8b1dbd01681569965ddfd48f7f8dce798ce2e331a2a39(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11d1962afb176efa9cd60cff2de80f6dd572e12fbfed5bed7518bd7e4c84be6e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0761e33de56bd2d3d2ded7967732b35723eeda79ab05958551a6b131ff62a4f1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46c093000b7866e29a56a8a42c5afdab412b07932d573cf24c8e2b91bb812f34(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__132b5a2a78c019f4ae2145f5fd2c88e916f5fcb180995e9809621ce7178dd1f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bfb2bf7023e30fe0011e4c4eea7911ac575328f3379273a3264fe5a31957fcad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7016cd5359b9c2caada4f3b7a5c1507b98c9ed12a903aed1b93ab00eb6991ef(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1101494a0da51bcf20d46b1b1ef07700a18d6c7e8e36618a66e30191df967b34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__005daacf0b2135dcc34031ce32dbe6b46a53a1f043b5b4efe46eb2db711e0de2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56062b667576d568277cdadeef0c9b739d39a554d23f6fae620a23f59b463d32(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e048e2ddb85d2d101527c2acc0705476bc3e21ba4c48848a4708f2d622b33f3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41d723efcaa2a1ca2350da13ab8f22645651336fb178518141fb8f63b4c7fc5b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0658aaa680fa4534f42897c5ba23d648e60ca892c8919dc483046df65fb2f0a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__036cd7ed8698b4e577dceb487ff0ec1401e428c66d8e903ca09082a0ca440316(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43f29a3c8a1f8bd62e896c4a558d648b1d49dda9421fd8f38fc32df93798845b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d915d79087d3bea663662d7494edd0bcb13a8c49785b0e997a812bff3dd6e9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30dc8dd0c2ebb7327551e6adb98bedd66728d2526816f9c4761947ce46470e4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f00864cda7438fa76260927f7795849bb10c6291bd99690eb77573ca8b3ff6b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791e43e9cc5383e99e76bcd674d728b6c7b5c5914d5b6afd0a5396a899636cea(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe9f7e3c89107069d8a00e2dc60f28ac3c5c9ddc2f503e5d144dc1feac9f22b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4feb38d712ddcdb0fcf98a79efe887ee00963f0e055dd584e7071971818d2be7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416be8445b446d57304bb309478a9dfd375443b8249e5396921ceb074627af26(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7804b474d2b49ae48acfa96607183e6f19dbacc25cb9f02e9a2c822cfac9b1e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__312c1285f4bef593f0b8900ebfa778e64ff16b9d265946c55da9ef1ba74616a4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationFifoStandalone],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42b9655921efdfb002529f077dda9515d269a0b90b3438f0e721fea1df3c4e0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__959951bb927d94c97f64f2a20a416bd0f94422a3fea167d31ef69e259b8d9e78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70c23950d69b84d1c5d7478eafadc8706e3cfaf09a30f78bdacd386132e22de9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f4c54874c54e474ca34dfec1f9b940f08cf71948f643c417820a099821f952(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bca70f5a0b060ac42b3afeb20c055df1cb5bbcc67fb937e12834cae55054fd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fc9d9903196ddd57cd5b2a1aba1b48c6e43703d31633f8a8566393a500a1e5a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb9f65a4a12aab523a42dd8665c6cb22a81398e3c9b223cc145764463e99e0ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8335474582f75b3b755ac83be460da20b1db2ac70eece8deb712ab0c2394e66b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51a86a9fc9c8cef8d903aee579754073290a2eef2de98e9a995e95de4b318ee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ec5312d610a8fd5f650cb422860b1737b27b8fa27eb83917f38d595b7f0bdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__693affdeb07e62ddd6b7c70759602d069726295653f6796b4b3b35bdb8cbc8b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__933c43bd324a670feafdb1e9a1cf85fddafdd29c2e45c34e15c505a77fe26088(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb383e75714d6e9afab63ef290fa667967a69efa82ed99dca3d1e03957330a8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20d9907f204467a5f5672d19a16f6cb689089f6d5c39d437d77e9ac0727a9a95(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11af8b3f59efcd4242041365ea00b052c6cb0a7d85927c90d5aabadafdae20c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f3a037951bcd21117cedfe7cfc9ec40ca1093f248c566ae2e26bc1e9cb72a05(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540dc7d39e9001cb05e539ab22f0fc51700fdbbb67ad91302af66ba88f7ca684(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cd60671973408ec09b2309c85dde3571e84b80073b47a2a4709806fcdc66b26(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e3c50de26ca94591feb327713e3ace35865a10b6ea0b780a2cbbdf432effc8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82f7ec02256e49ef6ee98e322c172b51dc7df9d35bc23c6093948a9ddfe1e3c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4901163700cf457ad49bd91134da749b8b753947f000269640003621f147070c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d03bf9c73475260d971ea5ba2cfc58a52a2fe55acf91873c08f517bc2e04c876(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__900a8e3176188337258ce346f2063809227f3d81ad00190de3216a74466ef5f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c6d0513a971dc940f8afc25b6b87267f0c962b39df425317413b2050c9a3e7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3b35d2f120b2e1f31c268acd80f5cd84dfd447a036dcaecdd7cf9fa5a269cc0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c267e7d01d821deed078f2e90c3a901ec3f12d0e39349071d0f4b8e2803fef3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4997d9094af209ba54e7b16c26bf2b2013c2c2c479f174bd384735b6a0df57d1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef880e115865dd822e293d1c827df31538f162c2e27e3bbdeba16745cfa01a03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04467210c7c6f186311eecf592cd55bebac35405304353408521fc609bb64aba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d6efd592437535ae777ccada27ebd3448192059d158c6e977d282080d86f9b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b5c0c47a8a65e6b9b3b5886445c323104e63b940606dcf05dc6e93fdc8dfd8f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5e067c49e5a442cdb05ed2c2322d94b5b66ee7a42d66ca251da2076eb2ab0e2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2945f2c883245d49989324603295ea4775f7745b71cc74080f6f36008857e911(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311102ec4f55a86043f5af2d42e71c194a79e7ee7bfd066d36e20b8697f86dd9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d0fde8007b4049027d43521282f772377d6c45c416432edbfa0f1dd4e1cd0aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cd13555b7146359bc13cfd2bac563c7fd43b66b5bce1f0ef791eb652a9c41a2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8f3c7d97b08583ad53533fa596a98873f65ab6d8190c6cd38c1ef2706b9f8bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d41d9cf7cf9697cd0473ea6d19d485b548b3b21895e22fe3c32217731ae4833b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2bea504b7a0f7a3a754b9c7a974eca34a9194895353bce055d5ccacd2d2b1e3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cfd14650b82cd665a28f818ab72bb4ebf758c6d94b48028f07cc2dd86341e40(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6d96f6f529dfbbaef6ad88572c0e74e62ab530c6edc125c9a6f0a00c06ab52a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__209430458b2c3ae209193043f98025dfd89c1db54101083299a094115f15c68b(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3599a106947e26c85856ac6bedf19819a4c50aa141b7a879399c317b8841bca3(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__974a027a1ab3c4ba2fb54cdb34bc80e2d7b9c50f77d87bfd86ee69b9e7e8bd0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7076cbed679cd1f4d10369eb177eea574845960547c9d2866c2988826d9fd5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d6c0e6089da2769f5486d6b422bbbb8e8a079b9d00b0ddc10ac5dfa6d44eed8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54ca5772e788fb03e6839faa63c474292652431b5933e43bb1bd41ac31f5fe27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7707366a777520b34eb796460e56e0ef9515ae8c6423d868b90da42c2257b89(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b07a23edda11023bdc6e1162d62caabde02ca322420a14359e3de70fd09bf476(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d54defce0ab63b2014e683f8fb94c97ba05e79c4b85afee769997518d49c0480(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6b947509b52fe8cdcfb30df659045dfd307f12da4d14aa48a7bd6151603640(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08979f6fd10e47c57b1eaac8d8e8514024d4dbd334dafb8ea9797c591ec42149(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777106a25377d743edcb7f833495d2ecb791aca87db7b4f97c2c30ded9c3f374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f9eaedf042b08eada12cd57ae1885f2e00f25c69f63541bf6b639df9fde511b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e4b79832be9eda98a40dcd0263ed9babf0e0807318f27c875e4c4e1b791018(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27ff3cdb5bf196ac3f2f039ebfd494ac8e3fc11059cbc38a9aa88ded168a0560(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7358f54a733fd07490e586b1bfba6ba5b1ba5a18c176fb7e5017b15e438edee5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6366c0bc0e1418bfd338b45589f2a14fea058d12446b3537788216706eb2384e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c15ed454b1c4fd106214e5fbfa6332213447a7ccfa9df17df35a5fa8393cc81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88b721a625d1ad0df5bb0abdb9b0d39f03fa078ae55da48e50ccc43651d463d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__122c75d53cd7e16ce5847298eee0daa3e9804bf83e9a810e53aa3d932a763b36(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorVisitorPrioritizationWaitingRoomNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6623180ba4364196ce694d959c6348d0177f07eecf291e91ef917e2f14401715(
    *,
    ab_variant_location: typing.Optional[builtins.str] = None,
    decryption_password1: typing.Optional[builtins.str] = None,
    decryption_password2: typing.Optional[builtins.str] = None,
    decryption_password_id1: typing.Optional[builtins.str] = None,
    decryption_password_id2: typing.Optional[builtins.str] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    miscellaneous_settings_title: typing.Optional[builtins.str] = None,
    pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pattern_encryption_title: typing.Optional[builtins.str] = None,
    signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_signing_title: typing.Optional[builtins.str] = None,
    use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_key_id1: typing.Optional[builtins.str] = None,
    verification_key_id2: typing.Optional[builtins.str] = None,
    verification_public_key1: typing.Optional[builtins.str] = None,
    verification_public_key2: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dda8a6fe9db90819dc15df9c39fb1acd5156a1287f00ed9fe8ee6bf4abb8227(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__932f04ac4fe7fb6afd057d524ed2c9882cca7db1956d74a476699a201cce3b1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83802d09f948c26bee5f195c0651c4cd71541ff9ae8cfa0b8c5c1514807f702b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7dd54ae6bbaa2d994581f507ebbdebd3f00ca465b934cf9708087f89daf3ee9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e061059db4c00224eab08647a85de939b0c7e48240e68edad1c17cb527e9587b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71082dfd2072b82945167ab2c874d73a9889ade78b11abb5e54613f27276ce6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f27384512f8d8332dbf6e3f169a2bb8b3ff0742839846e0a817a97f3246f57(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11ba3fd4e4cabc219c1e02264b65d5d94f10f008a99d2630b682bf5450dd1b17(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f3b0ced78f718978ac2fc2d765077be1912807af84b700c7b1a47774c15729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec90debf7d35107946c052b5a1a4b8b5425b3e4cc9415aef9d78a2f19cc5676a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba8474e1bbdd72af4c2459ad9d937f040c73ae183f8c4f54614121ef5d670c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__576514081fc34cf246853c47fc1e1e3489c33908ae313f866d18d19e26ec7462(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2b3069f4f73d3c605522578b68bc1668bfb5afaa6d54818c7d5e442ead3675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11becf5ae25be3015289cfb4654b68e985ce2dee5a2d4677a3924847d56025cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be0b4b1c9748d62293c1864863f92f34c90e7bea6f543f94d3f4ad7da05f9c9b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48492aa40f4b75869e30b965f95da0e17a852dacc1ed415dd5f7ed225487a2b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db6dac6d879647bdf214e9644884293aebc26b2d67860fd68f906fc2e9c1dfa9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ded6ad55a5ff4e3d5f884457887cf816548d93cb6d1e7d8423c4f9611a64543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c085f939d5bc22fc8efe9d296562bbba4a063793161fe777ec009aad2ec814(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e807c53e3e3b72e75567b78105c301ca3e267f20f3533a39dcf127d6aec475e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4968346afad9206eeb53a372ece1d6a57a7730c9d307c0d8f0e430d73db1fa9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWatermarking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89705212f4459c78121dbbe22f2b0aa79ab966517c91e69c7ee6da26eb073a50(
    *,
    firewall_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d82aa26353133fc46752931c309982c52ca060b4562c507067139e4c1dbde2b7(
    *,
    config_id: typing.Optional[jsii.Number] = None,
    file_name: typing.Optional[builtins.str] = None,
    production_status: typing.Optional[builtins.str] = None,
    production_version: typing.Optional[jsii.Number] = None,
    staging_status: typing.Optional[builtins.str] = None,
    staging_version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa9e942520e3b0f9c14e27505fd227cd8ebb993a1cdeabf8c3d2b7400d929b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27e9330930e8d28c07ff732d2dd18cf2ac349daa8de04e89b50cd5ff05e9989a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__944aba386f1e5a0abef1bbef186f0ae2b03da77e2b3c3c610b6de908621c5590(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef42aef1196a374a9b6dd3ff2a2497ea691b1418c73364c1cdaa174186392ae3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfca760a505689880fc4d3fbf0e6f862d87fbf6ac38c6150e6a9bfca4f5f78e7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5caa5f8cd28c30fcdf1317e220e43bbd42d767f80f3b7493ed6eaeefaf4665a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c7db73850b0ef6c6356f6b3afe548f0bebecd3411b89e6406986ff5eecd469(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaf18b4a2f3d6c905ed4fe4ed6d76baaa4caa3a8de798cd23852ccf52d5da518(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewallFirewallConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b403c7d3010865be7201f5baa9ee5612f31387c4edc1a56b25cef7b29a98dcc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a172160b1695aeb9e56d8d2782aa42684a1ace1d731f030c3adbbdc47b8ee3c1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89add191a511c736b222a7da3de869838fcacca0a9587c118128d80cd863de0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edb7554d7b15d2ec0451510c0d5fb9155f05a54eb4f9992eec98fb7f11871718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae381a423cfdfa834d300e8688c160f6029c34cc177cbdc703c72fd1f6117cad(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebApplicationFirewall],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a292ce8ea85665511d64d1e9c1772ee6fa48fe618d0942c628dd496ee009c565(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c9e9908e861bc890897e421088d1f3c986781b385d316f209ac94fa860a181(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0ec04de100486eb858d4e81e680cfdcdaed68ea2f79d038710e5182b4394332(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__647805858db91146960ee9377178cdc2ca04889180016f84e42123de7d11f383(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ba67efd04c11f09635376b85a54b2ac454bf764151458fc0e3fe7cca5fe853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa9469856e6b8960aae39f10ef525db4a71768d4e6a491d722c27c1d602c8ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4dd0590fcf4a1a45a410a03f298e60c5fd85d3812082740fc7bcb31ba5885e7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebSockets],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3aab2398b8b7fdb54ed51799909d96efcf70f79f5ad80745b16c478eada1afd(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb643adedb472520dec5dbbcf4c00c01fb542ccb70d6af7cbcbc4984358b0c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3473c9a0fc6cc572626b417ec1a796597cbf98458e6d613810cf672f4bea878(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3552ba39b0f2fc3b65c062f1dee516e79018cd7ae0927a3937f22c7e5e4205df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f22e25e664af32173fa6451b48b1d7233b80b1a4bed9c028f38dfea0bf914e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5e21fee0386f07807f67e4a04a59561330f917737f17ae82cc68ea5b406ac45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141146e80b58a75392fd1981d6534d524640b85dbb320021f8008aff5c0faa68(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030BehaviorWebdav],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d490beb6f5b26f7246ef9285a90c6838f5f61608138dc10735803b02ff902dc2(
    *,
    advanced_im_match: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch, typing.Dict[builtins.str, typing.Any]]] = None,
    bucket: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket, typing.Dict[builtins.str, typing.Any]]] = None,
    cacheability: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability, typing.Dict[builtins.str, typing.Any]]] = None,
    china_cdn_region: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip_version: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlets_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    content_delivery_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    content_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_scheme: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_is_authenticated: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_username: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_workers_failure: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure, typing.Dict[builtins.str, typing.Any]]] = None,
    file_extension: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension, typing.Dict[builtins.str, typing.Any]]] = None,
    filename: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename, typing.Dict[builtins.str, typing.Any]]] = None,
    hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    match_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    match_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_stage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    path: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath, typing.Dict[builtins.str, typing.Any]]] = None,
    query_string_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    random: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom, typing.Dict[builtins.str, typing.Any]]] = None,
    recovery_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    regular_expression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression, typing.Dict[builtins.str, typing.Any]]] = None,
    request_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    request_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    request_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType, typing.Dict[builtins.str, typing.Any]]] = None,
    response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    server_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    time: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime, typing.Dict[builtins.str, typing.Any]]] = None,
    token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    user_agent: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent, typing.Dict[builtins.str, typing.Any]]] = None,
    user_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    user_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    variable_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a31033154711b2cf13f66c426cebcc637fe5e0ef7ddfc4adfa22741232117f8(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8104279d864683163cd10286745d97d6e2f769dea6a4ba2bbd8811e33a3062f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4efd15f82c86c8cf6177420c6199fbcb902863922e3c5492d39cf7ae73bcb7c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd1fdee66d57b135297178689616a2d015a8060c6245e0eb88e951608cb6105c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb102aa2a0f55d741efa5e84143e4875322ba78e0b0f991a80fbb214490297bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3157ff50248fbbc5bb419161eac7f9033d62430a0d03ad8b2de0fd1def753335(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14b0099df8ba6f160e1e9f8c1c4442d001898bf33e7fcfb8b709356308493e09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b89fd7b44b555bcecdc64c7ec89bd1eab887f12da01af57e35aad7c833e4ed18(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionAdvancedImMatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ca7b25da5c9673d935c222f4df940571a0bf9cb3da65286a446152bfcb6bda(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd6535018e260cc25d72b73edb8156e20447cfe6d9c190d5e3d05df72510ffa5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7483952e45536a6b6096b9bc1b9c10357c4ac454b52baa9fb9b787776e2e64a4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b75b8d7645fbb06bd2408d83f0023376e71670338174341c020b07b0dae8ab2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3fe4094241ca466094aad373ca6d487059b37ae2e7e31a7e840728c5ddcfbde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c725d73b38d636b6ec298a8bc97b013c02aac7ac359da76944e1f1469e1e5a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8faefc9056614236ea712f809712f0e7cd2594a32e4d7a6915b6e2226787d1e7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionBucket],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4abb18381b1f3f9ef6b70e3dbcb4b75f1b2b207227b678263fe5b8d996ccdf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d282e4deaf89f7f0bfc1cc20871922d8d20c100640d6dd6b8216d6c6df9fcbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd23afbdfbf9bc2e6a7db276794b490194b32d022e984e72d78b0aacafa08644(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e284b2cd3968753d934004557d082eccf6b3d3cad0796617c6aaa5189201157b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68785ad3b8a4cf2767dbb8388dcac4c512ccc57034fed6c4ed839785c7c2e7cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba7ff5077806bd8e834a0445cb42135bb3b05cc801e41ad21ac6903fb4f3223(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d25c3ad033d4e0e17887f5605dd4d483b71cbf60f69694a93409ebfad8e65e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d1aae957fdf9178d4c3def3c1842b4945e0bb1923ef9d852184079c70143869(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCacheability],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a108e11c047791f9cded70770a9fc245e47c3cfb538ebe1a302119529a0abe4(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf88a358207672845a8b3a0909889040e0385a52ca1a7b9d641c4e8549a2f721(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__848064746fc3d9c56826833025e503229c7df371ca8b546614774bed199f5f02(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c8064690d61a3334c89247ab0dd2ee2ad38dea7c665e44646b5941d5f9ee2af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f02408bad03af7f1c3383c2de51fd6f023c4f086ce834e44b6778ecafee8a32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ded68bce45082eb6812b4f27d7e827c5ccc8fa6ad30b67d57cda4a1154cc8841(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc9b63a89edd878dfaedd4acce6885aab11fd078c72a26c0567e38532753822(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionChinaCdnRegion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fc2017f73615f99e490f54b636f531c279f1e3556e86d5979ab5d9517185f87(
    *,
    enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_valid: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__666416996629ebad04e3202b99c687def77661702a0802832d0eddf33263d04f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8ef36157e69e96b560b676df6e1512f0a1d43746e6e20c916de0dc770d683da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b26c1942d8c4d364f599ca6ac3deb22a69c41cfd792dc191d8accc148d663b9d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac2a82f3d78345bc5ab1c512cbab70ea36296f606ce117f5221e867c7ba2932(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a82b515e1f8f4df7e9361d419a16bac83458cba9ab19b746bc7d4c4f780f3a9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59138c79fbec30cf2dbcafa494fe477ec1e52299f006ee1d5ed8723e1f2c5f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b15daee425c2bff3237fa1c99856227e61a83739629e42a02fcc24d269e91543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42a76d2700c986811da3b386144ed79fc61d0051e0bc9d9694e04c071a4f53b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientCertificate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2724189a38b144f7204e2f5924d882067758787fd38fa3fc87203d2663ed4f16(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6920212ecc1ced508db64d13a2b22ccf4e1883ad744877fb870da2cd8378e26(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__123800315608a59cc6da6103fb0baac2fab5121dd0f2088a1b1a07691a813925(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3d59be4ce53bbb52597df4ba6a1a8011e41953bf8d42736e39822e199b0c32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ab9d37d6af18cecc70bd59baad544d3c61e0a1785117209769b8a9d581fa05(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d89fdfa3ad00ccea0dcab60902de2d5ebccd03c3673eb851091a980024052add(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d182f3bb59f30bfa01f346e0f45b3bc557a916019007611ccc0364121dee9a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d713cb867b186568680fa98342adddc5b460b124fd427c72ee34efe9e08c4393(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cca9476be7de375aaf31b3c39aad351e990688a6c6638f8a2d6f6e82d175c71(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0cabe36408ac23d4248eaaad31ca3d4ca9752e54a57e59a6603480f03740124(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47f394d2fc787751d942300fbf483838f55448f634ff3ee8befbf8bd0c79c4d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__385e93e45810fa090253ff440b7f0584b80f2d18f7dad35bab8fee80fa4c71a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588091535501667244b7327e453c4246ef9e67dbfe6c4604e88a2a69d64f7049(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36309b1fdb868a1208a94a6479bee65622ad368b5fd5f9d95f43dff73e73743a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3159f2892108fe48fda9e533ca16b090f7f20c0bbb0f470982b90f801ee282(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48323869985b42d04eec957c1e0872fad05c8e88b01c8e010197fd8e5b95686a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff841a92f4331428a227f376e49dbf3468793a1d3f7aa5ea53856c13887665c4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionClientIpVersion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5455aef6c1a1ab7641c6bf03ea9777292ca80e085083a72b7abaafcac1a578f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79c9306160c2d581b206ba509ed4c5157570b2a0eef6eaddc46aca3cb53f0fcd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6daa2f430fddb3da3fbe4b96537be7047fb6276d664fb1f8fae8de80c52ba9e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4b149b70bb2792bf7d42935eaa3042acf533306df687134260d61cf2134c61b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb5633ee882abf54f7cce056684b6c88bef394baa697c33bb303bbe362ff9654(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9edb1b3a027bfb162b973b5e14ff20e3947510359dddeba3dbd1bff474479240(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__261e8c492c07758f2e9693b9249d199986904024940d22aecfc9f592bbd03b64(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionCloudletsOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff2cee1c3df8410c32bf463e40af6b5e461d2b75f8843c5a25f9ec98d5813a34(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__940cfd10d635de2477a28f0c64df6a1975a2cf459932ddf536ab71e11045635b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbea5c519f2ee40c477b3d7f6fd7d3d4cd7783c8e68e916449dd502c6854a45a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeb458f43a4a3451592318353ad009040b021cc6bbf3edf2be90de3ecc7c3708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57401acca269eb2a3035d3857d1a2f5a992ce61003dfa8ec8bd38a84d4916612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ba3094f90e7f0e921c12ecdb3ad850f5395a39ccc480ec8987157b06cc2a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7c276d69aa4213bdb0ec09e109e9fa3e5632f29a387d4a2542ae36b422dbe09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf20b9e5704b5ea90184e7519b6412ee5383bb81ae336f5e40f43e5fd8b65bd6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentDeliveryNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409720cdc1fea0cc6987a414d0b4c4c90e60c071e91df2eb7ccec41744ebcc03(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcfa33164874f028586238efcf3b07cd245bfc24cb65499bc80afcac25858446(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ef1c2f212110d5f63dce9d3dad825bcea9147668a8ce1068f44e2c42dacb4cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__378d86d11438e7802a8f6395e6b31dbc05db1267adb4194ff7140259214d3118(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0dd96c8c7f68d6e39a07457ff0311823604a6d49670ea208f7a9331a8152e70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d215e02119e871b3fe893ae065271a1d4a03d74e63722fe61d505a6b0ec281(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d423084e345a6871d8249605605648cba52672004b64cbad2588919a8bc2343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bbfc4a404fa226ab558505978591f61fc1a3b636f21851e7949b5b8f106f996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4398a226773cc02d863fb192f63e0096f74a8d0e2176a03d40dfc2cfcae200c9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86f39909b628b277b35fd4b0049d5ed3e8822f8848d5c55d3c1439bf4476ab63(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionContentType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f0830d1ec098c813ab23b4909f0565f565add7640bb8d0660f768d4f05b253a(
    *,
    boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    characteristic: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    numeric_match_operator: typing.Optional[builtins.str] = None,
    numeric_value: typing.Optional[jsii.Number] = None,
    string_match_operator: typing.Optional[builtins.str] = None,
    string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    version_match_operator: typing.Optional[builtins.str] = None,
    version_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a898b0995710cb35d29253b6510e74d62ab62d6d46807d3f4b0cfc2679433b97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e37607c23d10cdcb27a43d3e2f5c60a8f8c85e6d25b22164b23d0756936d74b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb504d4cdd5f1d74c1db596c0b4e6d8cd78d109c0bdb9eaff1958a7cd249be9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c965deee401443b1236830a011d0fb1526847657f1a05e20d5432fdd70aae89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48f2b59a023e23c2c8340695064682adb0b7f4bc1a1b39085e4547aa183a5fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f860f6daf8d5ad864558fc82a54d601e4be2b0e1a68bec6ce8cd260968bbe16b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65337c833b4a569f7fd1c60245a6049e2bfe6a7844e230542fd0fa65b3b6d22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a14a2b03af3243bc58815cea167f18147cee28b742b79e73eb32ef30b55d45c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95ab861a491e6d57ef61b4871c81157e61ea96e2f70112e66630d3ceca39e1d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ed43c7645b612637b5b311cf341ad413fd9de61bcea8a942a2b5f538c1bb09(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4627c2701f28988b9ca43f18ac677b15dae9d06f84287ac0a09077db04d551b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe0ecfe66071c2e4ff78ac03f745f2c20cbf1abeab997bf104d49103d2a3e5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01cbc78818cc8aaed7c55420ab93f71c15641ac82ee3d3dc2b2d1979f2c24543(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339523c41fbecf8831456e0ca1d73e90fc24469602c2b7c27eebdce46346f5ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12dab9e8791069f49bb7a0d3c64ad38c17f1aab2bb3db1fa32254eda08f9b1c8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionDeviceCharacteristic],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10e4de296cd95fa18a76b0b27dc635af1a3e1f086ae286a2e8e7cbf2a12c78de(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65aba7366ac38c917ee73e64eb9339f1958f1eae1c5362689b6d005260e3dd97(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88544094444bd39768dd0d64a7068d388ed8d9fe30d1e5c9ab3780329be61a83(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fda06e775c1daa8390dfcb204b587800fb9d32363e8aa8c750cb63199ec5917(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d468d725b9879084ac9ccae2ef12c053918b8973810dfe594e89de45370c1b75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__685f316cd9f61a6fe28c4502ebbf3df318e6cdeb3ab388d6e85a7eff09d07942(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__828afe4e35700215f265edd07b8c9e2c72462149734c9c652d22f015986fce97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70523bc79af0b998eed3fa0105f93883973ca537a6b1120eb5c42548c4e86720(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1dc5262f25f0fc7544cfa081837fa543d9c8052b65b8babcaa946e81885717a(
    *,
    auth_scheme: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feec42c0abd371abe390501294233a0642feab5fa51be1c8a03f806d26b0a754(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19e2c28d33afe02faac3d8bee1c3441a3fbb9fecf256d78b176847271d5f030(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f59c6f45710a40c39487a5295a894658612452d5f6f51fd5f5e7e56e8714e41d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc4455bf6d41f4b9bf6bf37ffdfa953d5f65d4e0a29a6856971355a4def92e22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e6cd93160b6132f00468b1dc69716fecbc8ac0c5c507310b9de74c1ddd880d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dec6b479c774591c66ba6694a210485fc92e3bbeef573b2b2417208193b698c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdAuthScheme],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f658f388d6722a20524e8a7469603e81cbe9a86fc441329d11e85b58e7c30050(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f465754401d4550be594326af3f940050f2a3b2d466ca2e788f1f2944f098e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c58bb8f3fc54a6ac810374f62fe94b1d3eb1fa2b38413ef192ec494132600914(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d488a64f7ea4f6588fa862576fc39e4116a8a5ff739592dcf828e4f89578675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4910bb96a8cd8294ca0f394655fbf414972413855cac944c61e6824cdeff4e5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b36c5a9663fb5cebd4bde6a98e47a57e81d9f1e5f6af6191909b33493c9292ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56723c8607a920104f96e924f694289f4f7d734307be35ce99b674da4c2d1ff1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdIsAuthenticated],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b40fc986456f7398e89da3f6249d864b908c637dd17aca3fded6d3a73fe7646(
    *,
    length: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e0079212a20a17b8581fa9bdfb94327ca2fb7769710903ad492bfb28bb1ce67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e48ef8362ff4aa24075ce1b7b916a22c1777d455ebf77e8ede43c20663b7927(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581ea090fa8f5e17ad997d3220f21dfd675dc167bf0689daf772c889151992b5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75308557daf5a34bd79f2fc62e5fdeb91b1e52cfff5f9402fc4ec7d8326fc53a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54248e6d706908bf77ef518bf206341eba2ae3f249982071a4c3e2c04a71682e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63541d4199afa135c50459281229ebda26c6e303832ccf7478dc60848a17eb72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__440894acd935ed934e6aa77007aa73bbac60bcef4836fdd149eedcf419d20fee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa2f45002a067331381e7f460e5d8bcec5acda26c907f3f14cc28abf83c86abb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEcmdUsername],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bf216b3d3fa09b493dae1d6b3dcd8b609e6e8b1b8b92cd10650031e89d2abdd(
    *,
    exec_status: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04e1fc696a5d1be6a987edb59ba2de10c3935f351c364c2352b077e29ca48d99(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__059a19b58ff58fabd8edf2c82e26227208e9c6ed116723f20cb1aad7996fa474(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef814f7b8ce52d19647361d4fb6fd5a2bdb46f0c267a27b9242fd79f2959c6f8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19a3072d745d7939a364b791ed6038aab2cdaca1e5304be85e49401b37a74f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2eb2a851f754107b6056d2efb016bf1171cf47387a85522d35ca6b014f17ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca7fb5a4cdb15fae250bacfb5bba85ddc8aa27d050b2d4c94d90041cf022783(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionEdgeWorkersFailure],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0368031b4cd2f241525f944e63affd2e8d94d1719766743d75fb5456fa998ab0(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9de0c9045f93e0346e62d69e72349120f635fdc5c913185f78475b6a3ec303b2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b43cfd102bfb953406edba9f96514b0538fa0d17dced6410b6f6d602b00f7c52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af607c5b4ef431f1ad2669a898ed309fefa139ed19d05f222091b0a7730aebb4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af733c4b7b6daab47a74ea1c3df83100a51465718867c3b491aab823c4323acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34c0c0d9ad994801af0ea648368946bdaca614508e6e9c84f23ef3ed5cdd4ca9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddc98d86db8e17669472257fc79b16129e7cfe789e3f9d6a1ae5737b1fc14135(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d76aae7aa9cca072ad243e4443d55bf9e065d00630780838e4f9186c45fbe1cf(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bf72271964c74b67be951e0b4a9ad4af4402d6f1fc42c62c6e5d0067c535e77(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFileExtension],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eee3f394ab1b1567036bfd9656d7ac368e871be49bcc3b17b64491c7721af1d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7465e1354f44478de130bd90bb14a808388ea2a0318f32d19137278c8f33ae4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab016cfcb510916f21b4fe922def2ee7aadbc4878e4a7db169a318849cd7fc9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e87b512a139c80b69bcd8c105971d4f1b28576ae0a171afd0c30c83861dcfa89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79418b5741798f3afc7a881718e76dbc6a23c1beab183143f1ebfe1f75296c01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff85ffe64db2b64418eb92c2b730541a29c60e1cc4adc7810304a053796c28b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e503215476d195df8a92ffce977bda44c3f5677bf49f19e158ed779225361e25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3a1b73ababe87824a1783942f6e60c99c3e432e055f8ec293596952e3043f30(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dcd4f2c06bd41d6afb96e3bcf6f2689f55c043de874b5b0cfd4800f5c54a71c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionFilename],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a8c495e1ac7952907064904277676201014d559278cd795abb3a6c0fc33997(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53744a98a067e4beeb2c50c59c43c3dff672ce2f0b4c1f01cf9da356fe5dcf81(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0536dc85d6501647f3ec5c49497c444580a58920b84aa84578b301701b940eab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__924e52d08328a7f2b7f6d706e0b28c71b6800de49564b32d357d056dfb856da9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ce11b13a92f6cdf301f8c1587e052018d4d62ad0b3f75118c2acb4e17632812(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f2cdc94daf57d861ce4cd1294c59e758080b76ee847a9999183cecb3552a279(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0748ed0d1029777b51725f792fb4cf49b8fedc11c1ddb9c9ec8dfd859e09923(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694c993ae0c89a97f50a91f0193afb8a2f3adf6a835e8f09e78eee4c0850f91b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be517c40e95a21e6928a218430f8d69aa666280a29aedfb1cbe2b75186f02ed1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f269ca18d8559bcfc89b4734e8a61c40351e5dfec61650570272b9641cb1cc9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__409b09f020598cd5644f1821918b584ea22997ba2fe3fa0d3d75e9aa6891fe16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56d0866e13c4bed7d07388090cb71a73278bccafca111144121dcb38b898bd3b(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5361e44bb6b505137d0915d0008a5f3d1573fc9a9d8eb5a8d95c7a780419255e(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4cebc5a6e71cc22aa952fe4d799638c2bb7567d978968c777407266a6e75d0(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25862cc717afcba9c152cc268d60440c506445d3cb62b523718f0b5dbe3d779f(
    *,
    close_xml: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    open_xml: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e44e1bbdc1a77c0961e02d490bfbc4157649f40b894c3519f84c62e4b26b37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1fed18191b2e9fa83ac35514af0a5c168b3178b9cbf58c020d3e63396ab1712(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c69078240146a2732fc5572c8820daae0a53e8d4f3b0a1ab821187b7ca156d21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fdf9946888b9a82e99039d7cddb92cfe09c0c07d8db066a7500bc1f680d1394(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7109123d464780a15854fa4b9fec8dca0f43aafa7926138326d7d4ade64dfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__106e47701610f2a4c34a5cefbf5e678f5e2a0a60f88d5e0af3b743fecde1ae78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0fbf9de2f390b957507a2d077818a5238ea3a091bb5745fc8f17135ea49a0dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37cd1b2f2ff51bb348462a9b367214bb702ad5af39839458572b8048b9179fe5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf32692952e2ca33a001f7f42dafadd38f683201803fa6f4697a544a72f9243f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea05d52be1e70da6eee030b53783e2da6996084d36666609947c8d9c7bfb25f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30896d336a53f9460b7434c70bf96293fa299cb6ae8257f2c748500a0fe0e44a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e1117751d5f773c45ff22aa47cfd54bffd0f338593681c6b4ab878de4d3c97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eff1553b99fe43019a248b253039bc6c41d38ad8e48a4a8b04ac28657fb44c63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb3e7ad94d6c906b20586cac7d902d7f2cbb49be96eeb16df3c1eca35d64ff75(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078fcf3807e899f95b42c84733f187641dd59aaaf4296e2dbbe3d4987200b004(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__194d9e78d85815212b85047f72131d6add60c436e77f41caaeec1dd9a78589c4(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d291e52833b18df7fede5ac5e9e94f657fc9c4f84343ba68bd4fe274c8504cb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a9040502c2eeecc100b77cb68b1382b20e7c21487016fde0d2cacd24ae8d5a8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fc4991b2a535d2410ab58ca58da855415ef8d62015d78322e2025c8e703b619(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c170a8dbb488d13b4d6532599978b5060f4074539bca2e4b1dd5fd3b3cf3a3a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64c806bfe3fb0f81ab0f87d3248024617955f69529df3f85f4dc2049fe7fa306(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3eaa08ea04f270754c03a5e1cd1b4abc15c3a51c02d29065ad8d1c1b2536f06(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bacb0bc0cae1264efa5966ca746a938f41a46f40f9ddc251903924b6968e8e63(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40aaf6117c1ac454a7bc3b3621bd4b8d13bb0e2ef15f8e8dedace0c511051826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f4a50330b903ee22151ce538a5dd15d6257957de06b4d7b46d76527eb2fa49e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba9b9c6c35572e0e7fa11997f4b9d97882a6fc081263f1d7b60db0c104d4c0f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__580bef27afac82e8ce3455bb9bf753ae83f3c1b41fb2f31cfca366f4c274be62(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a297cf355865e245ed94dec91ae240f2bdfaaf609cde7a626dcb4ef1fd5b80b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__729c3bf967f84055bfe22f9deb13ec89420fca7d4a41f6bcefa7d2d494cc2d62(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b2ae90f3646d49ae93fa6823ad06c5c0ad3ebe978e02e35a165cdee53f51e6e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80f6d6ec4a062fd9b338da23ef2ea6ef6eef9215ad604c640cb4eeef7c0d6acf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e64f2a67ee388db05db8755c0c6a21246d6f1f70742d915d2fd0f71cc463f049(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed67ff2b627c5c3e39a2c4069bcc2019e36358da16e8f0bb5be9cf3e21f57ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8c2a599e871906b4f47daf5bb50c641e4c1d6ac4b2d3ee5391308dafeda5f74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9745b448709c94172fcb77e3bb619a42746f13633d6d47a634043d45abc03c00(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef09751008fe93cfa5ae31e0215120a0422746f899f999063c49958856d0e300(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a68256bbde83007316be7f1d83d144b04195a881b332985ed41e6c54db870066(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12c6d8e1a945510661018c0fa2b5d77a0f53b4c221bc004ec07a51e9984f229(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b7a498ac52590de7fa9883f9230456c519ad335eba826daba31f32a2ade6ec(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[builtins.str] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_expression: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e098548c77d94226c3969536776219c3f1e10307d11ad4417c78a18f409005(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12345b8150b6a768df2a35d322d93478328b0b29fc3295134fe7fec99923cbc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc563eeabde8a83d29d99c8a1d4832f0b43dd4321cafdeb605ada707b6eb12f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e2952bfd07377ec434a6089ad1763832f82e640c9e57e829768156e1abed6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccd4c7b1887b8df4027cf25c883385acfce17aaba0ff7e13cfa179a372f8073(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6003470c8838ac9662ca2ea63bb80411c3c915650e75fb2dc44b2dd9ac3190ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c35822ec12f778443fcf2d28d44366778654399fb2d6508ade0b0a0e479607a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__497c19c0d262897fd96fa847db5f62df92692264c0b10fbfe27ddb64a18f0710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b358cf69bfa1a85218ba6cb98c925fd0945f318d3ae3d6b679a0473127cfc27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__136ac2037a45f2557741af0e9eadb08294b6dcc2e6e4d202bad6a68cfbb4e60a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adac5d983501264d6112e62fcb05c8c8b085d20b81f7e543e711c0e4a3e3901d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76779e0d09627116b29fd5251c1a5421ad2d25b88f5de089eb9eabbacd50efb9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d5f09c89dc0139e44904b9a41b127b7fc5f10e85e098b883b69414baaf9278f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMatchVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f6abc02efc576cb741cb5f6082d553a82fb44e86a78ef14b11bdae429917388(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b09db7e7a6fc66994c41fd81dedc12ab97811efa5374f789eb6fdfd65a4ef17(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9b76239b5aabec477dd9aea889709ec0e69701685964cc5960011dbf6bc0906(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88a4d32df5ce04eac7354183338e470fe7bf6de1590dabb82d871014fefe825f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f732cdc4ec82c305476a47301539cfe8f0196f51a271ee1fe62cb9803bd9bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f9ca4686777b4e07fe52680b4c59e84435a666d7de867458eda55ab669b57d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e3b6f8b0c0532c228ab492bd89893df3ca3ee67d555b9dfc7375c7b7cb8067(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e8d83aa78c48c7fdd8190097a5e5f514a5926716ef571aeb47f8211c4aea5d1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionMetadataStage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c97e6f51646da5bc0aa0da935efc02ef64006d39e1c433aff6563674f7d099d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e50d307080e300ab97ba68a414311839d334366ee0b2571662c9a50207089b9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f30480bd835733f31bde584fbb63f715fddb4b2eb93c4131b0f7a7e434c72e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7cf61088d72891094bfa5639d7dabdca01090101c89b7837068a749b1d35142(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__937e10f75b13894ecde556eb2cf2f8018a7eb7bfcbc908ec50c316589958fe93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b94c36746985da55bfc7e8faed8c87af6c71457bee2666b2cd9ac48d3f75746(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff968ff362540b5004652c32f6a472a3359bcdcd6f2a4030fd191143f1fa4eaa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionOriginTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efe0d264f52c8bc762e2f4420b1fbe97e3fed158aa3954493585ebf09df174a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef047b7d4c769a1999e651c51734b085fa5e2f050ed00c0af4979c63721966b6(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Criterion]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e6efc1079716a55c4b414c0dccb56b2072d02a33983b05d782407ab5456b65f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5625908beef4650a90fcdcdf57f9cf3045c7db856a7140e6b5b0303f1dba456c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e51fcfbd4c09843541d89603e0c64658959c268272cba3ed6587b91c93fb51(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67bed213508d137db571b3bcaac87d8294a9704e51120c6a1c5ec19d21d2b3fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fbc7debf6da8ac06043c98a8aed286202daab2387931c42d9de6e7532b9fd27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39db7f7027c8c47804e6efbb643122c98df6b13f366d3ed0a3e2980e43f57b68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae492224013e8fe75ec34e62aeca7a26a357dfe33f9e8fcfd4f968f2b94e4b78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__469747e9de5b2b0c834c9fe208e102822c9e03c579be5ebe0d4539e6aad52732(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68e28720a5960c54698864da97566f7f2427839eec3b0a8c292b3ef431aa820f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a3e99c94bdd7fb7f221e765ebc7060b4f6ec40d1eb66b0dcedf5b3e5c8d62e6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionPath],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5babf0b45ebc91f4f28e797ecdc0414479f051a5ae247dbdcecce61a4882a8b(
    *,
    escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5e6c6e285fe17ca60ef4dcd756b70630f7bdcc781aeae82a2acd819677ad8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3af90b9db503251cdeb4f36a028e82899d1536965ffde24487b0a1273fa8211(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cecefcde72495edb4182b2b76fda82b5418f9b724659d4b138446cc5e121be8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319d1d250c9d24acbfddc9eb5144a659966e0b963c9429511a4fe8bffe465773(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd55a2f42b5bd10f74f7b4dc236974b35060a66b88f3478a12d98cc2156f03a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c93be9b647f90a7f69d01d511f81afb288404acfc4228baec91076797157f7b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__518e74f6d05b551eeb46c7879bb33b585430f14cfd4f1b403e068efe76a290df(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fe5c9db7b35711c279d8db410265b2819a39362a6d6fb28530ed452af4a3644(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3a165e22efcd9109fe6eff30b28f71b0969e2005177e74433c257179a30c3e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9397a3d87b8dc8d3b84497521c0bf7d38c84a4c9c792c8b5ba3c66da0d2dea10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7ce17c892e277d50f4ed24bfa6d86ce83b410798daa81934384e76ac05bc59b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdeb9691c764b1ea3045f3e55df771b1f1a807bf9e8780ca932e0d9786877cab(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64caa496fab805e63808ad2fabe996ce280c2fbda98e6a25fc864ec4a4e50a6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f1b13417cf33993520b5afd31a0ddef8ff52ab29196071ad2b080edb89f7ef0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04fe3a9f4e7cfd1940f4858e228888fa1f3069e3efbdb5b72ca63e48ca0f981e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionQueryStringParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88addb6bb9c3f1cc9255a0a31591748716b6496b388b8812195b55f9cb241b8d(
    *,
    bucket: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7f987eb352a98d51dd96270def4b77ee1898d3f104dcfa9e4ec9a18be1d9295(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d22aabdb3be601b4a32bc44b232f410eca66dd3c1e04e5e74b0a3c9a5ef4e24e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__466f6352e3bbd20b27b691ba526209d196d9186e02b5c1cced232e38054e9e34(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ec8871b0d14f4e48f9b555ed741214567a316e00cc1e95491db2835b0c4e7be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__606da7d53c88a359c35dae65e0cf5241e52cfa9d8739c49c64a3d4fc1da4d796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24d3a670e29c4b619641969e89f39defd4c3f464de3e8c8c2acad37df527566e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRandom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99524b9de9a9ad672e0ac8c7f468b5206fe1fcea0079bb81ff8e58cd41702633(
    *,
    config_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30c18e5e3924e572f0cc9b0478234119db4734860de50b633377c8df60d44896(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6af42acb38cde787116978d6fe591dc1a21c3a23e39a1a80a47cca145dcfb3c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e6f5bed8e9532070cb4fc822af1ecdf5a94740b922b2de7d3d2c6dd98beb2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a60fc5a7b26ce6bd85923d169dea109e8a980a6a81bd62305b175ff65a94acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcd6ac05bd5704237ac6e27ef60fcd96523e7df8a79688bc8423d5b664881d2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f6d7875d989f2170ff3d80f8bd508abc8ff8797c8ab756658613197704ac10(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRecoveryConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bc4fd6a7978a07bdbcfaa49b9c1e90a44ab66016ec1dfe037feef6aa0bc7908(
    *,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_string: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba99dcce2be6de0ce5bcd715ef079bbf9f4c52948886eeba12925f203c9f7cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a47ddb494f107834aac73b8cab1938e614760664cce7f1a709c08860005a522(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe81076d4c5262e413bd08f5e58a30dac7d4f73c9bf4e38d0e911363e2ffb17e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8d983b91e6fb04f7e4986b939a99a00251916d3997a2e613731181f4109419e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcdc89eda1e71b4583f8e833098a81d115b3a2758c321d74298bb9b9334a081a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d4d1124468426cadfd37ec75263ce600a8d44d3d6abe865c4eb3bd649f3997a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0e770c5003db3950e2f1155ed5f39e49fa74b4ea4fb09bdea8aa84dae0b8267(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07f2d5fc50d0ee78c64e2969dd4beae184802efabbc0a4affba6080be0afd99b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRegularExpression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__575deccca2ef75bee691ce2770f172f78dc32f6456b1c752d26157ca23d5a9f3(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73efaeda09228504578ca6f096af8205914f26ddc3bfdbd252e58bb4ad1bd041(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da2424e99ac7816673eb4320dd5238d913ac4b29b9a1f32ebbebf6005bd3b51d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__731c89ef84b0016138aaf0095f76e92a79e267a7e589cf5ded9319d484a1594a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1eda6056c91d54af51b5f3127ecc6786e5736b872c4bcd581f01aa348bc246db(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbff4cb6769d75c08d6846b8222db27b3a80aea35e6527b659997184e62f1ea4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831e934cf57a7f85427d545bf319feab07060116aeaf88bb31d4b830317343c2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e52c10e7e27f93a5a77f6fc271928423e633a9f9494127e7f38c59821008b1f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e8abfea17851f338b295f08bd2e0137e9c3dba32b8800b445b7f411918650e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1dc4fc3bdf148257a7386abe752b29ee7a699e3d28e88288668cff995fa1db8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__135c7d132e048021b8bfdfd57cb9008232e2d3d96321a78da969fe3b1f1a292a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24feea3ab4a9c9d1da05d4268e8fdda0027c0a880c9fb988a72dc2864cc77822(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf486804cce84bb1619f2c581ca40f979663d0ada7a26a8b33dd9b5597291dba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f37a97124512895155f7b335db5913159a528526eab4248f63d791a9fd51499(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f5a54c78f8a7cb5ae103b7185a2dbd6955dd85e253a1feea737ed856a19ee21(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e26b355e336a927d7d4448efd99cff40920e784b64b904a321aa3d5470f06c56(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04a2ba3bcbcb69546fc94996ad6984c0e3d186dbd929a0da70194bd77abeff6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08db75ee33dbca3c49457164ab6dc69e72a99ce2c81f792f73a9ff8390c5e431(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3190573153885aadaa832278bebadd6613fc290c52d5e5d627bbb0914d21d858(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aa997597d9e58f713d19bf622eb5cec29baf658fed9d65133a6c6cbf0725669(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f0e4ae1bec4247ea9fec50194e866208f212efb5f26982a7e57a1198d5a80b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e85e99a046752d793d17f1b0a76b8ad1c6df1f5f4f94ae7bbd293e58a0bd04cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0df3d1b180866c61df53c19c9ba3f2227c0ed1d3650a59fc6d1bcd6e8283047(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212892bbb7064116c3384bbc3e0f70df3819a36585dadaa823310f3d823fdabd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8952aec0e196f7c301b8308a39105bdb5d3056f3320f891f1d61bbc252ab9d5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cbde22fefe68327143554d9ec1b53d185e824c8718faac5ed6a600933803ed0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aeac12b7a7e51478fbe99d0f8ee9543393c3b1bdba6ab7cf10afbbb2b6061e9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6d4b41d1b8aac1635b7799f8b770b0025a4f8ae388d92db59050689eefcb7c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e41c51615eb2fca7efe86b78a6d06258a6740685504c47a653701c0cf6777e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45fccc0e87392bc5659f3da0ebb5b2137675a6492157855580a51968cc11d7dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__170aa28233aa70c7389a6b2e5e96d0c68d6614c50d2c7b755734380b53aeb56c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a6cf27dbb69d6e5e7453c80db5840d137c496ac3b78ade1f0e3651cd14163d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d799c2d83524de55a9e42fb526401bdc1703933132a46656854eb8a5e37f0bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d29aeb324dcb2b3fcd994a67c602891ce756e64b3bcabdf4c5754d77b8f3790(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45868a09609053ae8992377d69f5917bd0a1f74165e36af059758a514eda937d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a223c5ffdc4b47379c33478abea59fb7ef1918092fa7d3efc1bd0e23324eaa17(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bc63758625fd94ba090130ade85e1ebf212304e21f21d156dc79267064af77f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65e652af17d009b99206d8a4a694abaa3c13920035d29a1c5165e29b427bf4e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d25c516f32ccab40cef96af068f40ac06d654b426dcd2cf2228686c0b29dc25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9d712db69971aec9f5f1590a774ae633b37891d2a47f78865a89cee3a0c9484(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0de0686871f942446a861c8f81d3534813e84a9f0b12576f3db6927f2f8d638f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b40d4709d4aba2e9c5e663e4dad09e1307e64de91655e02d5d763c33d7cd027(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b59ce31c6b7adb9303432d15fabb0f2a3cbd24ae1aea98abd56b15d2ffa24e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f00d2252308e4ab5eedf17ebddd6f3a1c148cb85183e2665da9f12e7be67744(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8cc6d739b9639d32b5040bd4041c0cfaf3715e2d663afc0f2f7107b6e902aca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ebbd1f6ef6e3b11470d67fa46b4813ebd6e034ad13a8a9060ed17cb8f346788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3574fa58555a347da693c8fc12a1dee797051dd89c60e71a61d7daa358ff0ec8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee096c4b8efbb5ea22a324a326d13d3709ed072556e05640f419bacbea2c3f6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09c5c06e79b5e2681a90636b72145b693e42732d2d4b4c5ed0e271af0716b1d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb276d4c87684e46b30402915b7d27ead9e09111c00e87f737e5264d37281313(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionRequestType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd138cfe9a3685729d6fc300bf552d5d71f4cbc972ba6ecadc2afaba6b147b2(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__513a21b7cb18e48ccf3c23f9757e90fc4a71e60bf1f247ccbe34d179bd264bb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ceca6d622ba5547da52ce28caf61863e5a4ef8e0f01764875ffc7468e312f24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b3e3c9efe29e89133914160aa8bb6a3f2c48d5e08185cfd43507565f3670caf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9556ab3c1e54b976faab8aa985a948e2a5bf8a759acee0feb0b97668b91f8b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e294837c78283da2203cffbb20e49bc68a19f3c4bfa28ef7e4a4d3cb45cdf6c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f95fd20db1de0429f250d26138175e9f900b2aff8ccfc4e6b7ed5bcbcab2f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cd95c5169966759835c6a06e2244dbbbbad4ba770401b7626b0afabbab48dcb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7894b19c92f5876823144c258cb1c17ab54033dac6d11c96a19bb37105f3ae62(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56bbcd3ce4c59a666d233260ec8612c9f8e5f6a91a699995dd9acaca6cdcf5f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80ebf5e3c6d5c6c6c9c4e57c45ec6b46c6646239951f809e67f4237ff9db13a8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ead92513c0b7959b6db40c7be2143d2bd72df864242cf0acf3e662b76393bcd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd7d9adb4bcb9662efa2b533a0613d54c2916b83b11ef527ade0129f49b9da36(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b18a8552f0c86b5bc5fa900c8e3ff9dd6171282360d0d8599a942975572d69(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dee144618b099e5a1ddee9139e04dd72c99f7f21522de9053d96230404733f2(
    *,
    continents: typing.Optional[typing.Sequence[builtins.str]] = None,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    location_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50c44d7d25538068fa5124ba8aff9eb759061cffe316fc20ff99b149b3d8da2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f21e966487f9f9369f8fdcadd55a1e4f8f7a8a820fc915e7b30e986209c5156e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88ea9be71c0b4fb6c0ded28730c948a8b4094c4f9bee29966fdda2037556774e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e96e33b700a682a1e50bbc7803cbabdcbc078a52d6c152e9d6157a3130edecc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c8f210861a9fbb530c460b8822dc96a00832085a8f7e3d89f823b23bce938e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffd6c3736271ca7401f2c1d1145c6e5141873a8d2fe5db1490502a6693ac245c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f40d3343e928718301b01f5f9fbc7c9a8f28e41cbd8aefe1c6f17b0e904d9b22(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730603a34b604467071aae73f03593e77e25908e6e305f2b8e0e74d336f4bd06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cabc7c821fb61060bd7a93070ea07e124f36ca55499c9cee378d26d4b2b56a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ab94c7f45650facd9931844d72aa3b4924e906df6aa2154fd934ba35e1f4a4f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionServerLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a46f4c67ebbbd2b093b15b37531022513dfdcfc9a7ba2f945241863e9287265(
    *,
    apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    begin_date: typing.Optional[builtins.str] = None,
    end_date: typing.Optional[builtins.str] = None,
    lasting_date: typing.Optional[builtins.str] = None,
    lasting_duration: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    repeat_begin_date: typing.Optional[builtins.str] = None,
    repeat_duration: typing.Optional[builtins.str] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81cd2260773d2cd8b219d47f548aadc0bd09b25e275e9fc77e5dab6bf8e3f967(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50aefcfa821793adff60cdfd918a379de69e291054c1bbeb19a6f85662d66cbc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d8f62ed00d38fa3fbca74391a971aa0b3594a816b6475690282400ca364d9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988702f2b1dcc576ee218434ec3816fb3262bcadab340647c0ac5b8f96641769(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3728c98cdd9f1025c3e31d05ae694e29c55a26b884748604ba4f869347eaca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__346f9b732aef2872d9fc661641bc59930581dd81a13bcd546d67c48e9d06651e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8c7004c93a2981b87f0061c66d3799d807b528f7dad0cec1079c164cdb7765d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad54fdb46f0d8151b5d6521bf56b7819fa9e76f7e46c3bd91442352068ce7b90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d8ad20b39654ac01957bfae89c9d15d99de234b4d5becf15a79902787ecad0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2becaae24c2bef0ba752e2fbc32a761028d8f6567ff0f0a7925033331269d20b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4d5b99280c3995c752a101c9a3b97c028d50da04903c6356f1a8e9e35ec7c22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192ce26c2a2a67b9688c29cdc145ebd6df6895cf4909aa9c3c0a9dd6dcdec9f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4038a90a0de0e6ad3476831f5e73b915b063e15130a1720635ba0881e13d2291(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08e003d31bd5ca81488348b05442e2a74b9193da7a02009d5261d4aa78b61993(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTime],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea8c73cd5a52f76635f43a413ca570921e2eb0f93558151fa87a3efc49a2a4cb(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf2950b56b9b775b0ee26a1de9e1809bba69037e58a742776db597c596f85f37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db3347aa9bd00efe6c3291c0cb10e3331829131a600895f3fcc73e43652f5d58(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89037adce21169b4d67c46e3d98e90cc721cd4ee9eaed15f82f07f8c8a5e18db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa3da746c1effb554ea47fd9bc0ab85cc2e02bcdee527e3392a8f17abc7173b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cd98e24602c6fd69c10e3a52996edd0a805ecf9e39d7c1183ca86318cadb5ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be41ebfd82fde5bd4f6819a28429b2c773e1d6a92273287b84014968e3dd97ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3303b926e2d9f6c292ca5ed890461d6a9df531d4cb94db853f0bc54595477ca8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d457a2a596839a2c4f50d5cfc8fcbea2183111c820ed239c78b6f62b90f6e990(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__322dacebe404006773991d19d91943e7bf7a38069220cc8838f5a03412954c7e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1452148a59115f268d48f81cbf28f8371da9ae245de56529c9afa9cc00523ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d87eccb4d599bfb1b8adc0a028e998b8ad021210b54be221bb6c7f810acdbdc3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2142e372cdf2525a7fdd77208118393d20f36ed2769c509b76da2d936517ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17aff5771ded57f05f3e8211804e6f9a8d14e974550988f21bf1af6c4b09cc0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a75cc0e0d99b17526e9f3467955219fc329ab83a061402cab617462600c960(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3250cd8c45f2822f3f1a90187e0bf89fb4969dfef1f4ea35d8193ded9e384767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a304c1f58efd92782f3ee7487d540e77a065c565ffa751edf802c9cab080c4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f00d3212cae322a42879585bd55acb8a17484ce40d0a1495f39ee1a0fdc1757(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserAgent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a461bc51a61433a8c8bc2ca2d5735c7000c39e44cafca9cbdb836ee49208d20(
    *,
    check_ips: typing.Optional[builtins.str] = None,
    continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaf708d1a1829fb8c7e807aee949d3f016567fc1b50f5eac7d89a08dd3a8ef37(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f15265107b0cc7733102dde7e80d6db9fdbce4ae4e1433a0bf9159216cd1db7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae8c5dcf5a7c959abde388db3f66b935a8dfcfddfa15290ccbca2726956f829(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d38c287bad4ae2b85412c60ffa631fdd08b966248748c79362167d21ad79ba(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c4ccbda164677ef472a8be555fd7aa4607992fbb42f9f46a24ccbeef64adab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6329a913fae2afdc64a442a00fe176873021c71ba399e40a4e956248c101d3f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__320fed49d6e123fdeb02d3805d0c52464cd36670cc0fcd654e70abfb1956e9e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59aa0578b5ffa92e0a5fe7c5048805e87792d78814d83a9dd831545124b02cd0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ff7500c44ea5a01d96115d6722fed61a98ca97f091a71c3dd90823660cea83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36220cb9462c192f4cf11677fb538572e1be8457f74e2f43f74f7d755f8a871a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f332dc499c16bc1f1eb3e221578e33b007861286d52e0c654b23318df22064a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0b6336db8cb7c34af42ab0325fa7a31336ed3c098e643be5ee39532045b214c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca48777fda14068ee511771c52d43a1e0066ed49ec7103e7504cf3354549d72(
    *,
    bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    check_ips: typing.Optional[builtins.str] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6e0b9e7f28362a15cd03e322ce74fe40be3bca9d2e48a372eee5bc41445b30(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfda356e50da624cca699034ceefcc4c958405a4395f3e74739954afdd8d5a57(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b036d542580001aaa08ac2b43f4b2fa87abac3eb495563afbdd127e1663ad4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e22b6352e7acb1513ffaa35b3431d354ddd96796dbed650624c75d225bcd5d70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__531debc73e1f2e44ef785d2f0342f8ba0d5c96e53a16a7d7bde206a8eee594aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c0a6eb10438ab5f765f78fb1582c80dcf38ba46081bbe13c626a7b40d0b3e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad4b09a1732e71800a56dd7eb86ee5b4bae4dc0ef08b374a4972ab5d6b98f331(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a07c488c24c47024c443a45d1fceb646ba2fc5cd018c3ea612a662ea31b21cf3(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4215a44f10a1932233d77805981233f66efeba5e7c0a1d2c4937d03aa641a9f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fbc9a62785431d0d1706e17b2677b682c8ff501329db3fa5ed731084e77032a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a61ebb55a687042316c30e9228731405aca38eef18c5414800a541501c60f28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__301384aef514ba7809d8a9100aef6c143226ed33bb911d598c7df1be654ddbc4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionUserNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5fd7d3021e1efb6a7f546ca63a37ca1e2d035dae809db1a71ae1647a9a1b1e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a659fb8a24e789a6bd1c9dd08904194bfe515ba9c85ff706bb39f17bb5269c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d73211f70d08def9d976fb6f52698a1594261566177959cadffa16ae9d03b52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83ed3160c4cb954328eb7564637795aef13ec27788ee1f3a47e69f21446d6439(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d99b21a6fa586bafb0411eb11a8d06526d4a18424e7f23f2ebb7508f9974886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13b52ae761336b0970ab0b2b28f42d90316036f7ed893393656e87d8469f764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0eccfed6630e63c2cd8884666a8eb6675c4b6e1d8652d9fc13c4e5489c0933af(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33760837f55497909ee9bca4cae5cd453c9c6641292be756129218ccdc42b303(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVariableError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b8f913a9bec5097a8b9d0e9fd74faee878f4b0a36b2fb114d67dab176ec526a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f7af969f9bb82399683b0672db52005cb0839b54ed7582f42d6eeb6004b0a3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01333a8a23d294ea7f9f6d8197e376d47ccda6fd358bb6b31005d8b26fc29be7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7ec9b5b6149bc4c05e1174ba7e973fa9a25fedecac75a3897baba4a7efd2b63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__320c107062687a39c24c7dfe04829e7d3bf824c51d7df014e5a005449269a75d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728cddbf5ab977a7a911543ae998536cfd8d427e6bf29230a133a0aadd9bf26e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdd128d013d34900bd762a35c5d387c6317d9bf86cf7b9a2f5739b9edb892925(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__991c7e2bd190abdc3cee2c0573747871fb2ff5d73cdf3292bec96208d426cff8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVirtualWaitingRoomRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4898e3a4f2c89b2e42a45ac232285eb63d07ab96c8d41471c52ae575d3cd5a6b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bfc827bafb23b61f8f7b3b197ce9fc0246eac95ddf62a040812d38375e19f38(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ee7aceae9d4d6b888e0e03ff2ea1a2ed66f5bb298235c973854806ba305ff4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aceebeec00a8f1c183d77b41bf84c758beb473fb609a641f82aa9013a56aaa89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e560c55e2966935b9f08117394e4c43b428f9d6670f588373ed154e3200fb30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6348b6130fc58d47496543b8953324b3c071b78657ba85c94234d106f5876360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b601ec34ebb62b524b6d20a7d4969db0f3330bcf7cc5427751c94b456d1dcc88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fd9e117c9e731835ae10f47c736a0c3be564d1ea8e6accea25ad100340f314(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CriterionVisitorPrioritizationRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7111fc72581d70d809c70aa7c90ace993a5484b5792aee49a7190209d2e1c4fb(
    *,
    name: typing.Optional[builtins.str] = None,
    override_id: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__990a807e3fd59e279589a52eb4a36824c1737e50ef5ba3b56a6f0979855ee069(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__935dbfba0a0d88d3043cce50f229f268d2154d1751b819031fd331724a7aad06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab79eb777dfbe00e3cfca61d5a1bddbbe61f36069ed642d269583c66380ede22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b884212ff24f4cd4d05e8c473a777f74d71e085613c98aafbf7d8d993d1a8047(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030CustomOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b24d5b86074c4e79044531a8650d25046f736a2348985ef3ffa581adbf7be41(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0b4cc7db41b3a16e0734e692b9eaba4990bdbf2e66b5d551ae8796d942261f(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Behavior, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__455a126670d6d1089893276ad10fbba9fff9e196b69beb17dc4b7086a00ff2cb(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Criterion, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa4a91bda348758dff5c880a974a271e45dc8ec74730b298c3905aff13f8dd1(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20231030Variable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a3105cf776ad2796e75d1a0e64e5909470666baed639e8ea41f1e3a09dfcbd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de39cc9071b96124b6f50c1a7b9d975827c85422a92de899bb8314fd259bf2fa(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16ad930d84c9297a6c525a0380c951c7b3f256e41991b48106046c1269081e13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da617199a37ee70898eb56bfbb346bef7ed4293fe217ee747c0caeab84280da2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0e7ba58b32f3cbb224f9efc9d6edea86033b4ad540f923e50c26d01fc67124d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06201d9fec4d9bc025d0ea8196b2362bb7893f9b1107451b6b0558fed36b9a17(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f5c9c3c6028c284408b03cb66a245872f1e3f7727f8698d75876d70fcb4c72f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d7e78ce30f7d12d82f725dc67ef1282a70b45e06d52d14f24ac07eb76c18957(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e93f39c5c5fb98924b60bba52ba3505bdf173ce461731e06c7c4721080f86a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c2b06004af44814e9f1bc87de1e087addb4f22d51f485c9b4fb0f53924d90f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a7567b69688bcd7229478a64ebaecdc818673a1faf92f12c75d7fd756cafce2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20231030],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f78392066eeb11606b75355cb8f02afcaaa476d1b6f5741bbc7cf9117b7c211(
    *,
    description: builtins.str,
    hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    name: builtins.str,
    sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e731a17ddffedb426dab82d80175d6d7ef9dec62867630ae0b7850691904af51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4869df89cf49bc0e2ec45933d68ca74330d42d2bf3d5da177f8dc769cdafd61f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d0eccbf761b4d70233be3ca25c13749843e709a248adb2ada4a7f7c1f299d0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d1072c8ca5729d4570bd57ec9d1888922714a2f063ef32d479c3d7acbfff1dd(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f7ffe44fb934454100d34ae2a32563f0c2720f018db08b465618746f8693fd5(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91deaed8619c77715e95632f95cda8037687254470df9b5a47000d151f1b9be7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20231030Variable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d977bc8a69c851a88e811d51cd5fcecf43eea8cacd377834821417f688255f51(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e37f5da8daefa6d8b8333001a60a8718dbc56ac63b5ea96903388afd6e7472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea028025ae5747f9fc4d4d9878a1f48096530d6f7d17ac6c85a6ee194e15d04(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2834df03cfd6f3845aabd379fd87a963c58a00977c4c2e5905a7199e0cd8d23d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a33bafd5244e53f507e1514d633e5314f911ee6bdeb25c32d0279d377c92e6af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dc8690f4e71de566dca889950c2914238c46ad4bb2d64408453dab655ad6cfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292e7d97c809f8eb3336c77b92e77173bb8a6c639cbde4ca2e2d8015fe60e938(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20231030Variable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e66f021419346055dbbc5de45a62a1f4e53d088f70b57ec2f9e461497550c40(
    *,
    name: builtins.str,
    advanced_override: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior, typing.Dict[builtins.str, typing.Any]]]]] = None,
    children: typing.Optional[typing.Sequence[builtins.str]] = None,
    comments: typing.Optional[builtins.str] = None,
    criteria_locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    criteria_must_satisfy: typing.Optional[builtins.str] = None,
    criterion: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    is_secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_link: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Variable, typing.Dict[builtins.str, typing.Any]]]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__748537e1bdbcf95dde08e3f07362528b609924a638ab2cdc42e61e84894fcd38(
    *,
    adaptive_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    adaptive_image_compression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression, typing.Dict[builtins.str, typing.Any]]] = None,
    ad_scaler_circuit_breaker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker, typing.Dict[builtins.str, typing.Any]]] = None,
    advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    aggregated_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer, typing.Dict[builtins.str, typing.Any]]] = None,
    akamaizer_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag, typing.Dict[builtins.str, typing.Any]]] = None,
    all_http_in_cache_hierarchy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_cloudlets_origins: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_delete: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_cache_key_sharing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_https_downgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_options: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_patch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_put: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut, typing.Dict[builtins.str, typing.Any]]] = None,
    allow_transfer_encoding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding, typing.Dict[builtins.str, typing.Any]]] = None,
    alt_svc_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    api_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    application_load_balancer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer, typing.Dict[builtins.str, typing.Any]]] = None,
    audience_segmentation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation, typing.Dict[builtins.str, typing.Any]]] = None,
    auto_domain_validation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation, typing.Dict[builtins.str, typing.Any]]] = None,
    base_directory: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory, typing.Dict[builtins.str, typing.Any]]] = None,
    boss_beaconing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing, typing.Dict[builtins.str, typing.Any]]] = None,
    breadcrumbs: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs, typing.Dict[builtins.str, typing.Any]]] = None,
    break_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    brotli: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_ignore_case: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_query_params: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_key_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_post: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag, typing.Dict[builtins.str, typing.Any]]] = None,
    cache_tag_visible: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible, typing.Dict[builtins.str, typing.Any]]] = None,
    caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    central_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    chase_redirects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    client_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_interconnects: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper, typing.Dict[builtins.str, typing.Any]]] = None,
    cloud_wrapper_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    common_media_client_data: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData, typing.Dict[builtins.str, typing.Any]]] = None,
    conditional_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    construct_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_amd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_dd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_large_file: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_live: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive, typing.Dict[builtins.str, typing.Any]]] = None,
    content_characteristics_wsd_vod: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod, typing.Dict[builtins.str, typing.Any]]] = None,
    content_pre_position: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition, typing.Dict[builtins.str, typing.Any]]] = None,
    content_targeting_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    cors_support: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    custom_behavior: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior, typing.Dict[builtins.str, typing.Any]]] = None,
    datastream: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_hmac_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_regex_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_substring_transformation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_auth_variable_extractor: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_default_authz_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_dev_relations: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations, typing.Dict[builtins.str, typing.Any]]] = None,
    dcp_real_time_auth: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth, typing.Dict[builtins.str, typing.Any]]] = None,
    delivery_receipt: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    deny_direct_failover_access: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_cache_id: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_async_refresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    dns_prefresh: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh, typing.Dict[builtins.str, typing.Any]]] = None,
    downgrade_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    download_complete_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    download_notification: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification, typing.Dict[builtins.str, typing.Any]]] = None,
    downstream_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_throughtput_optimization_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_web_content: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_bulk_upload: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_database: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_dataset: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset, typing.Dict[builtins.str, typing.Any]]] = None,
    ecms_object_key: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_connect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_data_center: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_load_balancing_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_origin_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_redirector: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_scape: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_side_includes: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_worker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker, typing.Dict[builtins.str, typing.Any]]] = None,
    enforce_mtls_settings: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_akamai_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    enhanced_proxy_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    epd_forward_header_enrichment: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment, typing.Dict[builtins.str, typing.Any]]] = None,
    fail_action: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction, typing.Dict[builtins.str, typing.Any]]] = None,
    failover_bot_manager_feature_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    fast_invalidate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate, typing.Dict[builtins.str, typing.Any]]] = None,
    fips: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing, typing.Dict[builtins.str, typing.Any]]] = None,
    first_party_marketing_plus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus, typing.Dict[builtins.str, typing.Any]]] = None,
    forward_rewrite: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite, typing.Dict[builtins.str, typing.Any]]] = None,
    g2_oheader: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader, typing.Dict[builtins.str, typing.Any]]] = None,
    global_request_number: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber, typing.Dict[builtins.str, typing.Any]]] = None,
    graphql_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    gzip_response: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse, typing.Dict[builtins.str, typing.Any]]] = None,
    hd_data_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    health_detection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection, typing.Dict[builtins.str, typing.Any]]] = None,
    hsaf_eip_binding: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding, typing.Dict[builtins.str, typing.Any]]] = None,
    http2: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2, typing.Dict[builtins.str, typing.Any]]] = None,
    http3: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3, typing.Dict[builtins.str, typing.Any]]] = None,
    http_strict_transport_security: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity, typing.Dict[builtins.str, typing.Any]]] = None,
    http_to_https_upgrade: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade, typing.Dict[builtins.str, typing.Any]]] = None,
    image_and_video_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager, typing.Dict[builtins.str, typing.Any]]] = None,
    image_manager_video: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo, typing.Dict[builtins.str, typing.Any]]] = None,
    im_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    include: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude, typing.Dict[builtins.str, typing.Any]]] = None,
    instant: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant, typing.Dict[builtins.str, typing.Any]]] = None,
    instant_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    large_file_optimization_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    limit_bit_rate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate, typing.Dict[builtins.str, typing.Any]]] = None,
    log_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_personalization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization, typing.Dict[builtins.str, typing.Any]]] = None,
    manifest_rerouting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting, typing.Dict[builtins.str, typing.Any]]] = None,
    manual_server_push: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration, typing.Dict[builtins.str, typing.Any]]] = None,
    media_acceleration_quic_optout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout, typing.Dict[builtins.str, typing.Any]]] = None,
    media_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient, typing.Dict[builtins.str, typing.Any]]] = None,
    media_file_retrieval_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    media_origin_failover: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    mobile_sdk_performance: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_incoming_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_outgoing_response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    modify_via_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    m_pulse: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse, typing.Dict[builtins.str, typing.Any]]] = None,
    origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_characteristics_wsd: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_failure_recovery_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_ip_acl: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl, typing.Dict[builtins.str, typing.Any]]] = None,
    permissions_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_client_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    persistent_connection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection, typing.Dict[builtins.str, typing.Any]]] = None,
    personally_identifiable_information: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation, typing.Dict[builtins.str, typing.Any]]] = None,
    phased_release: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease, typing.Dict[builtins.str, typing.Any]]] = None,
    preconnect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_content_delivery: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery, typing.Dict[builtins.str, typing.Any]]] = None,
    predictive_prefetching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    prefetchable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable, typing.Dict[builtins.str, typing.Any]]] = None,
    prefresh_cache: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache, typing.Dict[builtins.str, typing.Any]]] = None,
    quality: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality, typing.Dict[builtins.str, typing.Any]]] = None,
    quic_beta: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta, typing.Dict[builtins.str, typing.Any]]] = None,
    random_seek: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek, typing.Dict[builtins.str, typing.Any]]] = None,
    rapid: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid, typing.Dict[builtins.str, typing.Any]]] = None,
    read_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    real_time_reporting: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting, typing.Dict[builtins.str, typing.Any]]] = None,
    real_user_monitoring: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring, typing.Dict[builtins.str, typing.Any]]] = None,
    redirect: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect, typing.Dict[builtins.str, typing.Any]]] = None,
    redirectplus: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus, typing.Dict[builtins.str, typing.Any]]] = None,
    referer_checking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_query_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    remove_vary: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary, typing.Dict[builtins.str, typing.Any]]] = None,
    report: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport, typing.Dict[builtins.str, typing.Any]]] = None,
    request_client_hints: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints, typing.Dict[builtins.str, typing.Any]]] = None,
    request_control: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type_marker: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer, typing.Dict[builtins.str, typing.Any]]] = None,
    resource_optimizer_extended_compatibility: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility, typing.Dict[builtins.str, typing.Any]]] = None,
    response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    response_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    restrict_object_caching: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching, typing.Dict[builtins.str, typing.Any]]] = None,
    return_cache_status: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus, typing.Dict[builtins.str, typing.Any]]] = None,
    rewrite_url: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl, typing.Dict[builtins.str, typing.Any]]] = None,
    rum_custom: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom, typing.Dict[builtins.str, typing.Any]]] = None,
    saas_definitions: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_client: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider, typing.Dict[builtins.str, typing.Any]]] = None,
    sales_force_commerce_cloud_provider_host_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    save_post_dca_processing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing, typing.Dict[builtins.str, typing.Any]]] = None,
    schedule_invalidation: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation, typing.Dict[builtins.str, typing.Any]]] = None,
    script_management: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_content_protection: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    segmented_media_streaming_prefetch: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch, typing.Dict[builtins.str, typing.Any]]] = None,
    set_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    simulate_error_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode, typing.Dict[builtins.str, typing.Any]]] = None,
    site_shield: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration, typing.Dict[builtins.str, typing.Any]]] = None,
    standard_tls_migration_override: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride, typing.Dict[builtins.str, typing.Any]]] = None,
    strict_header_parsing: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing, typing.Dict[builtins.str, typing.Any]]] = None,
    sub_customer: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer, typing.Dict[builtins.str, typing.Any]]] = None,
    sure_route: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute, typing.Dict[builtins.str, typing.Any]]] = None,
    tcp_optimization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization, typing.Dict[builtins.str, typing.Any]]] = None,
    tea_leaf: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    tiered_distribution_customization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization, typing.Dict[builtins.str, typing.Any]]] = None,
    timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    uid_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    validate_entity_tag: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_json_web_token_for_dcp: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp, typing.Dict[builtins.str, typing.Any]]] = None,
    verify_token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_with_edge_workers: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_fifo_standalone: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone, typing.Dict[builtins.str, typing.Any]]] = None,
    watermarking: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking, typing.Dict[builtins.str, typing.Any]]] = None,
    web_application_firewall: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall, typing.Dict[builtins.str, typing.Any]]] = None,
    webdav: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav, typing.Dict[builtins.str, typing.Any]]] = None,
    web_sockets: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f02dc0b818f1077d699a40e8a61d6a0f0c171dfc004f5ffa69713f3270f1500(
    *,
    fallback_action_response_code_based: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_codes: typing.Optional[builtins.str] = None,
    response_delay_based: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_delay_threshold: typing.Optional[builtins.str] = None,
    return_error_response_code_based: typing.Optional[builtins.str] = None,
    specify_your_own_response_code_based: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7fe7d4e62c73a152a5b01da35293cab4f025bbd4c53bb968b90f0d24203cd3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2628beb52e6c47a61b377b9a30ae6d82317b9d741f14b2d4e51c91df15eff76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e6338a67f7f3bf452f359d40c92fb0b59d31e48acf6b0c0c78a5b29011a94d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e7904e651b38a89a0744457b31144b3c27f1fe678bd092f2235f571dc17977d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d9e02ac176326bbe228636c7924c3f164fe14cfc2c8fc751b71b9d26ea28a3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf2dd3d48e8c3bd60aaf17b3befdf3eb641f9a5ead6ae2b0561ef2720852c5d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711b06481e3ea2f173896076c6117cbb0ea61ce3ae76846827c59543e488390a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46824708375d022953e8b3c04cd2261cd7d3f051e869ab039bc0e5d6d8e93cfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888fec4928f6898a1f4c75fc7bba6bb00f99d2a1355dad2676cb6bee9d30dfa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e61a80139b387b08a75a6c6e7ae0dc1db927c55ad511ed21ee691f317fb50c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c5720b360e6b4c795f9eb11436fa09e0d426b16c9dbbe096fedb2118ad278b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e8f6d5ed8375b7dd238e8e5c8b088481553efea4c361009e0f84a309285a03e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdScalerCircuitBreaker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a79ca13454765fb0b31c65a3e70eaf1c51aacca3967addc6d0695b55ada05a(
    *,
    ab_logic: typing.Optional[builtins.str] = None,
    ab_testing: typing.Optional[builtins.str] = None,
    compression: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    enable_brotli_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_for_noncacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_preconnect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_push: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ro: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preload_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    source: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_brotli: typing.Optional[builtins.str] = None,
    title_http2_server_push: typing.Optional[builtins.str] = None,
    title_preconnect: typing.Optional[builtins.str] = None,
    title_preload: typing.Optional[builtins.str] = None,
    title_ro: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c613ad4041e0d663a143fe48019ceeb5a9a0748eaaeed895d5df04bd1d3ea7e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd09899a34cdaba2198783ae6a3b1c2bfb976b12d68947ff5e620252f2589c87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__619e376430e6d683e13fc56117a110812cc0eabea21a6e262a734dcceff63215(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb119ecd03366d1f2eb4e0bd5174e67515d3e21fe3c70533d27fa0dfac17500d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0a7888c8cf3b86810807349fb1cee7030a97516fde68afc1bc4c7c4d7542150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c313f58a971799744d8efe0633493ef96a68c9240a04fe6d3ee20fa92a92c6b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599c3b9901926b2e92bb420578872789d76829b1eb20ea47f4fd54d9f0913846(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bb4df7c5d73f75b81a135f461e030c3a175236493091eb5697d97461b841b58(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e4d4824a8e775f60d949006fc72d973a8fbc0d4a49d3659e79770b227c08add(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9236423291c4d362b87e4e253fb45b1777740ae2dea2eae7b65d231a775327(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485ae48d756ed4f29c60a0da2314f7c2b0f9e56353929ddb1e0d6dc3e0301754(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf61867a6897bdb88bced46a1b3be19179a32033d5b4a8f9c5137be0b8fdfe6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85aa67a361bed6c94c66e267d91bfa384d02dffb209441e9299ca20fe8351653(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3ff300a77a158ece14a5584f37b15c959e740db30b3c5a166bcb02fa18c8c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bce92d7b1a717752cf241ea6bcc0d6414dcc731039b4e9f55b44c35f3094fa4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631665d8f17cceff7194014932697a7bd7534ed3852f3398fcd103eae663a99b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d223aad9a5e3db532b056362bf8d33a6c5b299a396265fde5539d5898c248cb9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f7cbbbd6a86cbaf5b0d18d61a4348bb5335af835c9a616d1029e2f65e924b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__931d5c0344bf799a310dbc156a87b83e5a72c2bf5ab515048305b9b51bfa94f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9753c881049c11a396a5c7e580d2065580521b40d233c4f0c4d94709dd2459(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbb0840cf53fae8fc1c6423495664212050d3514a7dac30b1525234a805fcf63(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5882da1f348797bd817fac268a5e0988c74895cd257a1d7bfe08fe089f3c8e6(
    *,
    compress_mobile: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    compress_standard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier1_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier1_standard_compression_method: typing.Optional[builtins.str] = None,
    tier1_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier2_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier2_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier2_standard_compression_method: typing.Optional[builtins.str] = None,
    tier2_standard_compression_value: typing.Optional[jsii.Number] = None,
    tier3_mobile_compression_method: typing.Optional[builtins.str] = None,
    tier3_mobile_compression_value: typing.Optional[jsii.Number] = None,
    tier3_standard_compression_method: typing.Optional[builtins.str] = None,
    tier3_standard_compression_value: typing.Optional[jsii.Number] = None,
    title_aic_mobile: typing.Optional[builtins.str] = None,
    title_aic_nonmobile: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2986d429097e49555464e4186fb64b51c38f0d0d63db8f4ba7d33b403e66f4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c19d1a548d289acf309da19e5b7d3fc31fc3ddb2de58c670cd94ec96cbf7ad79(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa112c4302d8a65f09caa54c654eefca677fd268b177303607af6bc32ab06ecd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0017ec29eef361c1f345fe1febd99895bea29362a4e6b06e6c56c01b462c4b96(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78892529196842169ffaad0b950d813afe6120d27677d8737d25aa0812e5e4d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37462151cc129d38ef91733e6d4abea069cd30e16bd2274225a638dccd8d3c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff511f3d0ab7a2d3d720992c7fe7afb0e54efd93d1c404c040615020bc2aefa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e72ba4e124a9b6cf37e8c31fd6c45abf211d81405fbe3a33a0880f1c01bec918(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8864430dce8d825197d695299e5b0aca6310a14e6f2be8185827a3398ed67b91(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a61b7ef0c3b4143b02369eb6d9b3fd78a10397bffa73fd4186cb911a82982bfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0bef8f6f56d85f0b247dd7d6d9318bd4b163cd68778f0a62e28ab45afabea1b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__538842108f3e935e40ce34dd10a0588297dbb19e9b4d06ce64c30c5148dabb4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e74946e959197d64409bd623bfb2ca5ba6c6a55dffa4f6969482b0ac252e9d85(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b234b62ba77adcd08fa939f9ccca510f568ab55c67dcbb2c0dbf39fa62ade571(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff8896ee716f5b1efc5b7c54723a68e0610c1d2e54dd7be642aeb280a1ce1ffb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f4c66e0bf58951b8d5c92f695bd84432042b2a6e51c8689722b373f4f1096c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76bce91d91f3d3b7303cf4e882ef5efa5dba10eb37415fc2d4890b6970aec0dd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5086e6c539b6739fbd7bb1e0c8c8172ee48497c9638d6c0705a5ce1c9df1465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216a7d5254458377f9fd50c15f8a97d1284b723382e8320bee222d45c7bfa028(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbd1ea043740e3d10df266c747277ba87bae3dd4dc531467e8bf20a2c7aef7e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3daa311cc8be02b6c9ca5402334a5e541cf2dc729300c75ee3f8346498394c5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdaptiveImageCompression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b008e8ce3ab59ac7dce9ef18b131a86d8a27793665f41895a2433a252fa168e(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62230289e1f2278beb9f0744ae75ba7ad44605b5425b72462777d4dd0aed17ac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b707767ec0e12727959dcbca76e0da72a30b41745d5bb231f687956a71fb418(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e8ea744d07ff712f04d832bdd128a676ec2b242f0d953fd588782a341e1126(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b8a8d3fd46af36da628ac2c216f52fab6b81c0c662c43223c470b36c6df89b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21490e16f6102285d4195835184bdef3dd735584c48e7c47d96154198c757f74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__260466bb38de9ffe4d216c9e7e83333fdb64ad4768eca076b9e6695077e0c0e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8123da6eff3b72d0b72d682b9c5b02561726dad6ac3236513206cda9232b2676(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__203936d2ce395d780f33d5bb944780429b1d54c1911da5acb98fcb365413db74(
    *,
    attribute1: typing.Optional[builtins.str] = None,
    attribute2: typing.Optional[builtins.str] = None,
    attribute3: typing.Optional[builtins.str] = None,
    attribute4: typing.Optional[builtins.str] = None,
    attributes_count: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    report_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2eef99868f5ff41ba91713cf29cd8a14229695e6f5f80e3409e895e18cfb2ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b38cfb5b75207fb6ddbb2812aeb9ccb80cfc9be410f7b4d8f9d9e06f1f3a20f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09a09e63854f3b213dbb91808f9354faa535993954539230472253f0ce173a25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3cc6d59ba37a03f8c7e2ab6e8a5602fabeaeb9b7ce16270b3d672e2026912b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c489e133e78bfc14baa6117c0c8765b81c940727cc483ea1828fa80d2f182fcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30c67562846afd94b975b8651a716b827f71b6fde8e10bca7c50a93648a54038(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d5504b9a121ada2d14acaf593c4eb44d7b3b7160b7fc65275c7e5cbe2fd1618(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bb9dafb0a82c6aa0857b09c7a491ff9901b2395ce310f8944c4e0d11110c7dd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3f52c21ef9d5c64bb12fd486b2b8c640ea40fb5c0e56fbcaa6857123425fa17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e58a4dd9141da0d551eb73642fde662e10a5ea5b1f01fb1983641744907bb99c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cea3a603740b2a928c590fa5736910d9655fec72e88b935c51cfb830fdff737b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb96d481238c0ed7a2353837d5de4d3e764aaacd4b98d9a21f2536343db7dcab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAggregatedReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b1254fe6d4bf98e06d7ba89462d8125afe44929267a16812c53d44df79152b4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c48aa7c0c57674dd382b2daa8529fe0a2d651332fd32fcb78b7c09e6b9ead3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd4f716fae178261102d8912235d546bb79d9487abc63e7fc9a8e50e8f34ad31(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6823d8cd8a0b073a6a35a617a79f2c8a86275b076b915b71dc0bc8283fc39e86(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__735a19a2ce9e030dd048f136071f1998c375ceef67d9c987b9549ab5f1960bba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c800ae3cada457612816cdbabf540a9620d42607afc43615df826820118adaee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d74e5bfa9fe7258312eac1d217d3c50602caa7664562e17f5b92a8f5af0e487a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b197cde6b5beb04dba4f4a17213fce85dcd8a3fc1177959b8725effe596a11ea(
    *,
    include_tags_attribute: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_hostname: typing.Optional[builtins.str] = None,
    replace_all: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    replacement_hostname: typing.Optional[builtins.str] = None,
    scope: typing.Optional[builtins.str] = None,
    tags_attribute: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c306a1c6a27034c7e561991b9b1a72f6a2ae0efbf6595611d7167795cad05fb1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83f1c10159363c02b82792d44c15f866899afcd9a46dc9d2cacda0457f9b7cae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b91b29344527851b7e60d401093baa22c2a78cde62f5e5b5ef955ef62efd1224(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d2f526e6f1cfb8a629e782d74cc0e3dd0daa11ea4fe443c8d0fb409860fd41f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9584ba5953f530f2946382ac35dd72179ef1b59595c272b4724dfc099528ce78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e260b86857e607aaabab8b9bdcac01918b9f57d680934da1ce7dea56dc279e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__002d8f2375288a7c2b3f18e31af2188a4c44567347068364bc3d94dbfcba1f16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1932f0290b85156698aa73fcb61eebd25a6ae09cd733966753b8b0ed5ccc78a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37fc0d2e5babd5c1ed2d5d7a1985c0788bd4f6db727f8996ce2cc80230b11053(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c3b85d1fa98c9f36532b8f38e383050d9fd159927375fd6d0fc812bd5da3d3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1789b7f253811b14ca33edb7df5fba51c045591aae6971a09dcd5501d604e54(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAkamaizerTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7cd4ea5cb327373372877b17f62fe9d6d6e02b8ff2ad437d7bbdfc045789c1(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__856a1f128de8d8409cb2d31840f6a216c36998f80df235f0ba01214214f50795(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd15510d82857f1ea261631390a26d490f97ee7ef5ad7116cb98ede482a38574(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60f424c480d568840084f7ba109101ac534bd337067bc31b07053997bfff99c3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f74d51c4cfe75c14cdd8e3653866d30f6d3cea763fe25411d15dde5f6f81778b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4960229e07cddb087a599d9fe9609179d10a10d16437c28ebfe0f91cd657501(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6224e1d4444630f7619612e8560f0c870fbc800bf3060083f04b2516dc0c6f1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllHttpInCacheHierarchy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ceb6f9f7baa4b8cd5dca4173b0edb7af9cbd492481eb60155c41baf2d7ca516(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_base_directory: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_origin_query_parameter: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3182fd7c328410f6513b32f73cc075ca586032037c163d6b28e8cff858ed4774(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4896e297dfd97ec076a001cf418f495d987a947ccfdf6860f14c5b5f3bcd0a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84e884fcd634cf60d5089a7eeed0966962b69e0cf11c1e790f8b69fbf94b4c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72e052de12687397a4e7cddafae74baf23edac59141d943c2e5bdba268c0ee43(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09e32adc04a639d74d35c5e2b6e1e8f1d6f25d7ac6894c852952e8f29f29b77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbedb300c74fb423e9216e5b4fe5e8f64fef2af5b8195bd9b4d32fa2de6b87c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49297502ccb03c09142f13c316f3bd1fe14ba32c46cd344a8e79f19745054197(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ea2fa64a79e967b7af69c09768540b322cd9e92018299d1f4f074249a9701b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowCloudletsOrigins],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf80c755a78ba015a337ece9f51276ed6f82b98f2648c37dd596121a2fbfceae(
    *,
    allow_body: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69d3608beffcf71ee9c6b52a73d3a6bc46d9486c130f9e57a133729dcfab90eb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec7416657e41e1534d0035ec102402a0eacc4061386e801fda505ad9ce27839(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85bd243ea90dc7c212aaa196e51c619d4a2504cfb82a992c248ec2a2f573f7eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8fec9ca71ff6fe5c39d552ad39db255fe095d55f071ba43d3c39d2d717d5f7f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aed2b2a0a1110f332916f6120df2c80044d4ba7fa8681009e1e4645ec40fe08c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2d68004a1a3449c0f1be8bb4d8107b944bcdd18a972dafd2fa33aaf63d30924(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6d9ca99e385bd0bef501a5fd0030431188f96fe8422a358babdc40752102998(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowDelete],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b6e8812da9229e605c109c09b1c8b0b0285df12836a5566f4a6bad944348b1d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc22b911546f5ecb6a132cc3b60c1775e9b99eacf8c7eea092ae2915d28524f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c79df386ae92c2274463ca1dd2050cfda5f632748e4ce203a503b27f01e8ce4f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a0b8708c99eee8bf0887ef60568e0f08e9e98700a77a7a82ff1c7ef3452a18(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d31beb79e05d8bef0617da1ab78813d81b85d5070b795d4c0c89cb478eb4fa14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5206158e08aec02a6409f8ad7765b5fc526fa04609d5f1b0a3b4265524908436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ba40517712bcc6884bde18f9e3db2f4ba7916f74725d8d3912313579dee3b50(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsCacheKeySharing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1475955850e66a2678a55c5878c799614fb8780dcdb423dc475427a4c52e37fa(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90807a2c5859eeacecf2f7b8fba7930406ce41b4d7f386c950bbd756ad348f58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bff480f700ead828a5a1bb984037cb450aeb24942c32d538393655ac4569b5b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bce4c8b605756cdf8c7bdb3fd992e7e68bdb366d8ea03561cf2d58bcef01c2d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ae7cbe25fb1913ffd3e030e710d2e962002b569308bcf1d6a33f6d2da7f7800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4096b97cf29774582137e76cfcd3ff72456eb63cd845c524cfa780fb647e6f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4e0d74d4e70119266164fa8c26d4aa5134768f95a486f042cb386232772ef3c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowHttpsDowngrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d0e34f821d7dd3a5c7cf0b5e400725deabee1f0df70df783110f2289387269(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__201e93715cf7bf9c03c399e9fa93a649bc7dcfad3dc231e65748cf0d371b1812(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e54239c0f580c10d433a78f87e26704de1878b170b0dc44e1a05550d68d6b63a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb8ef6e109c579f5e780ace6ca309f5507606e23e0854e4b75b3b9b244207ed8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8951d8ad173d486a85461f4c2c55099af67c444394f65e39905fabe972fa1ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76ec3b7eff124d06769daf589505d2e12f84fabb1c4ec033817e31bca0716bbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af00325156907cc83673849e222e16f2a83550c5bc8bee6d809579faefcb1b6a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowOptions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43d55badedc0a00ec655f7a84d8d24e65aa1214c886aa1e713e8bb57f8055c24(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__010b6b921e5c8bb381a49b005a0094a15ea16f16ccbd8983aab8ec5a7bd28276(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01313aa627e06d99982287ee5e7b67b88de8fd752087b8dfacf80636426a3596(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b9e90c9c147a18f4f1a8ac199c5a8074890751c22d7fc4ee7e22f60c45ed726(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6a656a5604c3fc6babee03afa6c5cd2a86cbe92b2cb41d35fc5e1ba3b22936e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b51280c0a1c223a2bb55933855f100c0e58365a9a678b75b0351fe7b3e9367(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58ec1681baec324a910182adf2f6a28bdec56f67fd79c07611475fffb930f33e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a770997a3cb99b6eb547de4f54f999c6ad25c2726ae9ee013aad61273c8d6772(
    *,
    allow_without_content_length: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a32e654e2fcaae57442d706f8d17fb828cac51f2a6cfff393c386c74dc99ea0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8bd0f1ea21419569ccf962991e4733a66912baa1818f94df21c378dd14b1d96a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c27e0555a1bf32d83a3ef57013e86751f26c22547f335b088f5423c2e394e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f89f7db321284bf173d641914aee362fe49de07ab854571481459a84b16ea27(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2acd9035403424acef73738122f81efae3deb9b452af4d6e83203350f42cf14a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dacb0b07f683d47053f9feaa3cc8abc0a2e1d9cc4b48c88b9375666d5d35f0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee59edbd547ec542cb0c74c7c9cf3d0be29c7c1ee427eeaf7972a784e0bf0b97(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe5bd1b6a8c3c94f5dab36ecc897bcf7d0f68a84083d38cad2b90a54423180e(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__441c551b5700f1e7802c9228619ecbe69e1123a9cda25a19aec730132a79963b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__763dcd41712326ad7cd8092e44fa021a1365ba63bed4519b60e62c2d00f08b9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6ac606487b25c2b790b24766e531d4ef6b8f256bad2ad87c870f7e66f1bbc7a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcee3751b7d598bff6ee1a2656beb26255eb9cd04f7987ae5c9352c4511cfb83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62a8677bc87c566b78b67d788f1479cae21c9ff074b9c70ef1cb6c310bff8f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__040f8aa4afff2349dc6ba2f54167ac7d90b5ac12bf25959a0780ff882d3c3952(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowPut],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49d4ca31f4e8cdeb06868af742fc80ad3daf6676b8f24b096069899c3ea1767d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac80b03c4cb8260cee4057ced5dc78f0f48e5238c739a7c0d91719f0441267dc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53112c14a37208b3bc75b98332718d1ab6d51dc2d3afa43a1a1e3e1bd4c410f7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0efcea4658814ef3c522d72b97f06e44dcfafe6fde650951d794a537f27fd72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9746bef3d797ce9bae3a10e1e3cac57de7aa0d2f2332e884fed8ca03be5ce6be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92e58e8a777f5a468c7af72547cc0eca149efc7a1ff8ba0cb689b1c01181ccf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eee24d5c07da0f95c7aac2eeafe3a25780aaa6fae88f7bc387523eb1c30ea387(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAllowTransferEncoding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6f21a6d7818804937af37a783f4a10cb347c224a080d4a55dd9f3e13e44909f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5bce02e9f5454470402b99901869e40fc3f0feaca931822f70fc1b318691b49(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdbc43498732c8d0209f17130c9fba7e01d5e5a9b71728efca26743362b6288(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c46a009121990cb8fe3c894c9df558a829f2217c6d18a9fe2948217c9e661dd0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f0828c06d9d1be361ce3108f27a98282066d5cb4d2e56242cbed3a5dde81b57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e005437ef8206a9a68a86d5b843bf7ba5f2dec63cf0c1dfd3d044a8dd2c364c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0196764f4e3c15e41ce14e1c9ec6806297db751836f3f9730243ac0719846e4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAltSvcHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90db49b96920868dcf475cb348145a7f767e81885b1502dae9cea4f01288d3c7(
    *,
    alternate_response_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throttled_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    throttled_status_code: typing.Optional[jsii.Number] = None,
    use_throttled_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    use_throttled_status_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4c29c0a1eff8f58ccee143b06725373cdb0035d4ac55dea7a8e5684a9c90796(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9aef64a99f5bd6c6423dc85faa5e132d4caef0b0000876786492b30250814f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8f5743aea5d090be14999a7201a94a83645f07e7317e766605da7e19fc3ce6d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d026f55ea3ae3972d061149c489b3a0cc61ea3aeef9bb0cd24a219a9fc608ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1fb048a2df7f125a60449d6ce27d181b6dc8125571f1b51a67a326103c5514e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__722b13ba5b27712da194cd2f21d31e536ba4d1ceb58d4758eecbc7e4f184ed3e(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c8b9e04480b4761c6a5bdd5d7a8e13b47a5df5a124055e3eb52c7605eb1914(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8438229015ea74b8f8bd439ba78b3698a4b4cf030d82896ea5c0cf2a81668f13(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95edbd28d410f2124287d5b38dc5d4e191466c824cf1739ac22936a91517dd84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6031e5d3721ba8446cf11d0de3a6b4824dc37d3c26b4e77fb30f4f000ed87aa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af5f91fabc5147f5af2aef12c074a7fd307e5aa27d97aedb11292bdc3b2ceac0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e11bab590fd0cf31f35b8bf94433b535dcaeaf1e5868f9a0e18c7dbf43d70c96(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8702ed0a5d049b9ca2ca6351a32bb4be779194a8a473026592ea8c0b841eff8a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__698834cbb4157acdc108ca1643c7911522d224c74c34b8298b7754c8f0b6ca28(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__141c03193bdda18b896f995f4f66dd395d50e5f8dcf0552ae25c99801b9b4f92(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81bcd3906949b05c5890d639bd106967dc9e761b62d627797d32091dceaae384(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3997c75d7b3037b59286439e1944654d27b13f41700e292bfc60f0c6e43be996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5caaa46b5a849632645abcbe479eabe2d99846c977dbf5838257c5dc2971dc91(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bd5f425bb994e384ccd273ed92741dacf294ed603cb5c008dd206a9c1d69757(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dedaedaf286394ea9fc12253b7e87214e35bd592936855bccf70231c09735076(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0f4475b91c21e11b36a69f5cadf7e1f1de995e1c1ae4238e0c2ad4b5cd28554(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46f649675633ee6520518ec94759de6a66b95733cc8aabc88363a74a6b40212(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f0dbf7e7436a8806df2cb67223cdd9381944495318df868c1915573a970eb82(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e06b7abb47fd736477e415b61d90196c08bf48552dda462fdc3fa4978bd0583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea796f2fe45bcdc2d3a662715019ff0c57d0576e6961928ad0122c5faa099637(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc7b97625fdf9336f1e848367b3c4a1cceca5758a305f43d7bbf2490d730f033(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a13398bcec96899b1493e35bdf2909dee0d58af9928250906284a859776c9f5b(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81b6fa637f8debacdff9b794bc4ea750fbe2aa7455eae8c6bbcd0a524e437e25(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1691c5716064ffec1e996e03bf5bc708432516b81e07b88a84a1c3a1c69075(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d724e2b5caa765df4d4d21c0b83b1a3f536bed61b7c60881de2f0dc14accf40(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811350fada08ec35ee10f4bfb94eeaac668d5e20dd5dbfb57b9c4e329b00d559(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7a441be4ec6bc0420bd2ca932a2e3c9e2007cce59837379068adfbc995cc72c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f769cf75565f649e30d3e213625e46c6d81254023a7e04a27c6aa998a6167487(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7f357e70b30f3e5633d6208648f0608d32813a1f0c36080abcc90415271eb29(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fef063fd7e5b45e41fa2338c3befe9f0c8bb8836eb8f2071acb037fc24c0f6c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a98c5aaece044eed87a8365fc082a985c8ada5c8a0078ebafb4a6720ca8d903(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20f8e957d97f83739abd4ca182c84a6a7a935739618d9a46c290aafca34a3119(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50566a62f13c3dd4af5d874400e0a20bf6e05a139e8466802836988ca931c7d0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d831a7e2b5fee3a9b5ef879d1b767561cac1160aa6c40c9994dfac364715ea5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApiPrioritizationThrottledCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3e9c3f8e92b45e8f79ffb9d156a975c8e348a836e363f19e1441863b155b2d4(
    *,
    all_down_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    all_down_net_storage_file: typing.Optional[builtins.str] = None,
    all_down_status_code: typing.Optional[builtins.str] = None,
    all_down_title: typing.Optional[builtins.str] = None,
    allow_cache_prefresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cached_content_title: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_attempts_threshold: typing.Optional[jsii.Number] = None,
    failover_mode: typing.Optional[builtins.str] = None,
    failover_origin_map: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_status_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_cookie_name: typing.Optional[builtins.str] = None,
    specify_stickiness_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_domain: typing.Optional[builtins.str] = None,
    stickiness_cookie_salt: typing.Optional[builtins.str] = None,
    stickiness_cookie_set_http_only_flag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_cookie_type: typing.Optional[builtins.str] = None,
    stickiness_duration: typing.Optional[builtins.str] = None,
    stickiness_expiration_date: typing.Optional[builtins.str] = None,
    stickiness_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    stickiness_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c756d2d7ebd07f5120772a1b41fb0efe96d574408c6c77b1ccc87be1339048f5(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a8d012356c547e4a68b1994fd354bbc463eb7802534b4fb1374b257e393b90(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2511d78b9c2b564ee6078b97d9f7adc2003620d7fd8ca3a4a9661eb4c028a5e8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef71dfa4b6b639a41ad31358863641a28d8632d253d6ba82eb0db948da2138f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f923211ca053c31116852637c90543c89b5ff1cf362d75fac156e83c446e3117(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60af920177f8916150f13b6047f23a91eb939e846c4772de28dfa72fc4031d61(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerAllDownNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86bac8485ec0557a02f1535b25bbb07b285f762a82bf75b7a876179faa5a0429(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d29b8c49a6508cf52e5aa9a68377c69167f945980fa20e2818a86f5016998b8d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce6ede4c8a907b0aaf39cd31df84fde5a219d53ea0dcf9f87be05e0422e34bd1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d51bedfad45ab593fde372b05a09366e04f7a4aadf54bc1620bbbbdda60fa9da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__237dd38658b466328e10d57699a5a6082ac79076868a4247d5228aeec46105c0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25513913f9864b60d9c41736dff5e65dfaab38c9f09f9391a36a59a2e0c8082c(
    *,
    from_origin_id: typing.Optional[builtins.str] = None,
    to_origin_ids: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a67fe3a9096c60a5385707e011ef5e5c6b3fd2092d006d9b9485bf3f0f586c89(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6095aa8728d57248aac8dc7b09739746b2b738ad72027482d1eac377cef5cde(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db400c106e291246b56acd9c48cd48f1f13eb3ba25f6cbb3614f3b8e3bf65982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0672d2bc4e4cf458d949592a8fe99d980ee5dc9b3c79cb1ae220543125b9499(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bff3fa13b2ec42c0ac589373739790cf56870d0292b2abaa1fdcd8335cf60ed(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e5785b35b09f05cca1d605a3a07b4247626bc0a00871505f44fe8f5a13f1676(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5618de8e45977ab57d8198a3a439ade2627ceebd6369332d590c37c57d43924(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__106eff6da9c38bdbad78d019105902c4a3e0fdae3e6fa0f8c291cae65781a02c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdde67fea5cf538677e0a763693e8bafceea2febc5a14a3b3d7de556f53fb29b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721d9e5a018e365fb6ba93ae8b5af80f46127ba4e80d21a25bcb01e5481ea2be(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__047fd1a881710104819fdc10e093eb6b95dc3b015ef75820a42011e4c722d426(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fae8dbfd445cf40c7207671d335995b191faa65ba9cd995a7667eb3641a4e6c0(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancerFailoverOriginMap, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72593e96828fa7a9bec1645fec69e30a22df8982436d0b6dd2285e5d2c417c17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__971d38294d4dc3ec11d782acb2f2f89bc8e0a70b1f7f30ec59fc431f4492de48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__389057084a84b822a05ede8d1f4d8fc2f34cb9cf72bc8a88b1920e8c41f1b402(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d98e889e38b30d6581b7cfd1c0a159bcc7f4a274e0085c0c4b2eabc9edcbb5c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc59bd672761692ccf1c865d7e0dc9ef36ae5a4f8ded1658976005340efcf95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1595ebcf6eb7c50331bce53574c60e818a4c39a42260c2dba37ba8d04712829a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f62a3aa24513de0c39ede349660693e97078f94087dc42cbfd6df2e21712b22(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a96086425f2f432569910d02d63e14d918195f65992c8d53536191f33ab565b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a7baeb886db20c2a05cfcd64d17aec2ffb23d6c34d98726af6a1d529db3103(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a02215f62c7815527aa4a80d7dd885bfbdcada980926a44230c66744b8159f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de977a2830162094bf23f8305d65abcac91066d32c89b982c177555a8e319926(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__416878e6e5a603626bc0635a32cc64cb44e34de1f4b7966b210e74c084765bef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__879277c9d74cbe28de0bb6ae7d0ff5fb8f0ac1e67670fe9d101620b0f4060ae0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e47c3321797950d1493c911aa4e26383e56fece248989569688d1a85e2fa7dde(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef162f3d7995bf5e5356beb6cc97ea6ec219551897b3e3cdc8162e89f6a284f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9c0d69d02a835f33577f63c8bf10753eceaf554a0b2972ba3b441b21c1509d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e7957ae531b0ebdcff25e399597c168b56d1683720b8917711b7c8049b44e49(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e617190a70452a0575ac87566e4409a4af7ebe797ddbb831141b1adb38fc008(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__251b69c56bafac2ea3ed3a34014a83ebac45d37875ef2ca0604c3c3ef6897b86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68d94d2a6899d8f7dd247c995f91575d9482568c1db1e93cde5daf9392cef963(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1820355702a69ef29d6e4796a356595b1a8afee0c1473a3f0e6a32f5d95cb9cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c95c43c845009c90bfd6f48ad1333f23c5d00151891bbd00e6ccc78a205c3e2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c3a697f9593cc476b02f336e62cd4c52ceee4534c469755dc5278e0d870c8fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae820ba5d8d5741ec17a56df849230c53f5f1b658351a7cbb8fc3638bd9df069(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20771f89e108d9b9d1298f158801976eefe2bfd5b78dc5cdfd8ce193345b933b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__327a698bb56e7a9ec008a70fac460b2fed794aa0e56942cb5ba02896acdf6885(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorApplicationLoadBalancer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78204291b829b439d126b0e9a7bd85467233f7bae6a441a6ece5e18ee894d94(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_domain: typing.Optional[builtins.str] = None,
    population_cookie_include_rule_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_salt: typing.Optional[builtins.str] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    segment_tracking_cookie_name: typing.Optional[builtins.str] = None,
    segment_tracking_custom_header: typing.Optional[builtins.str] = None,
    segment_tracking_method: typing.Optional[builtins.str] = None,
    segment_tracking_query_param: typing.Optional[builtins.str] = None,
    segment_tracking_title: typing.Optional[builtins.str] = None,
    specify_population_cookie_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39c17146d6460fee8bcb26f26790f2a38a5f8d3b884277eb90876b05080ec3eb(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c190f86d83268f249c4faea05c8e0e55b42432f2842e7ce0c01a0ddd05daa3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2271a5b73f903047d7c2cac76838836b6da06bea5adb0f2ae39110b12eaa25d1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0af034b978be9ea8e72758c2ece32d5de2e97c98b141f5435b5239b5f4d81f3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7bdaf2f998bcf8fa02ba6e7b6fdd1e734e18449270df18a8e355584c35078ab(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7567aad0dfa9e360854d44847780c1bd089692060985c58225bf255e29787894(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3041b0b33cd3d03121a4ab869fdff8ad5756fdcf015cf96dfa66f97ebb854e6b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0240f7c4faaa6083753a52a4dc06038b612e336fd5a54ed80527502e27667b63(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aba332586d62a8c731a73ee694510d7b99238568d94daff40407b93fef171a9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65615ac2a4727a85fa73313f26858d3fa673e9c39a3ca4d17e60de86b03c5ac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed5af354c8fc32338bf543adc39f1b598986068984ae43d33d4a08e2ed09f498(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96a49cb6ea88ad2d1df1fcd6ace9a776266a9d532a6df2e0d2a9fae85ed1800d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36a288d8228b4df9f4c057fd89dd5ae97164ca0b2d256d21b688f3dc62f2e93(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a91bcd8e14f64571dcbec29025a72630c0b3afc1ef7595bdfc4320ee6530e2ea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c2559909fb3b4cb6c6349baac1877804811b000a2f5eaa993e8b867b54e89a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2d4fd0055dffd61dad0daa48baacb6f64dea5ffdbb6de16ecabf45826c7f188(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af112bc128c2f21c78b1b89beae959302331a1fa79e98d7b32d92bad407f2775(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749fc3d69916e16d8ad5e39bd0ba5e037e11f5677fa4fa04bb822ff52cc4172f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88d7a79d7f04151c87528615f23ed519eba0d5e00045f57c7a7a5bafddbe8f2b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cf07dd0cdfdfacc1beafc8522ddbb6616d509b2dc509fee02fb194e17a8807b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9eea9a37c29c4d5d586b8e37eac35b20972603adb797909400040503369fcd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59ce8b2bc7827f9e14a9166df0934407ce010e485fba246702efe4b2389570fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08ff01b58c351b77f9ed3521546f814fcbf783d28b2315bb66c4954877dd64ba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f81c3ea7adfeb0e8bce83b4aaa1c56ee51880d2cae5aaa7abdeeea37169c50ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe129962322f732f2913df9099c82214f0a297b3880c2295268b1a092cdb83e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d57ebc9f8452c4ab4711a3a6b9fc00bd9c6025808e257e0512d289923eb7d61b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c087d1c8089145f47c7b2f74dd7eb9d73f437a188ed05086d5b703d0c2b60c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b7c97064e9a59de3d0bf5f616edf34593b958a91530dc5b59c8bd1051c230c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAudienceSegmentation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__779d3e4bbeefafe3dac9e737235af39b702c5872738b3a2c0ed54d7546ffb368(
    *,
    autodv: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f28131c5d8090885f048315c400590da2ca2592f85a97ae180867594b211771b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dea309c699aa3789c5bb6e1977bb58fc92ba070d0244c2ae5d34014954aa588e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__073a1c21eb87fb385024e02e26f9824ba4378a3c1d209b95d50bf0ead1f6138b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cac145c70fde071e7b608e52292fb1b691a3b69182c30d164b672537317522d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb248ab93c977f11d44ee72aadc1689c6f8c952731a404248fad42c5b01e966f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e689817a918a9e8700a017b420f5c82f84d1a5c73f082da0d6d141715d6c71e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorAutoDomainValidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a00771da1c23d364299551dcc67ffaa93fc25a7330138c0bb66ff8341d4e186(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd41c22873e819f3666a76f6442d3868bdf608065efb7b137f2a268a04e5237(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b912314b1ab86c3a6f80dd584160026579372955eab9622d6be77c1c3f121cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2047cd78876798948505335732a13c3df35544cf0ce39afe9693740bbe0837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b1825b9de53af37130a38006a9353d59ced693a8807b0999fb24945ae5728bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69f679aebcceab3f719208d7bed72bda1ed7b5d849ef37778a31a5d5399566b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a370cf4f9166ae3d31c902c71b2715741d63107b81686aaa6c8f8d764ff97c58(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBaseDirectory],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d871f86e6f90191d317365828641ed0f26fe4afa9d43c713bf2179b4390825(
    *,
    conditional_error_pattern: typing.Optional[builtins.str] = None,
    conditional_http_status: typing.Optional[typing.Sequence[builtins.str]] = None,
    conditional_sampling_frequency: typing.Optional[builtins.str] = None,
    cpcodes: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    sampling_frequency: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be0b4564a3aaeef05cbeef9c25bacf0f82b2201727e78866a2cd783779921bbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__545edae499b63c0b5cb4609a36f3ff65be082d3d961a69bf8b2b5722bbdcb8d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d8b84d7be93c356ffc24f2a2dc279dcd3889d093c0b9d683e6b6c33c5078f83(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23d4ad1a86462d9f852b4afe478f77c68266cce7e9185adb1787841db3983610(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14c343c43f2c262e00d27438b1253bcc20ed7723c268b5b43e97ee1b6c7945ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__904f5349aed9b4dd3f64d865f0bc533c3a7861a3084bd30579d646b563294c0c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b67fc2d717ea7de1604835c4cd8812d45c6f3e278cf83167633f92a9e5517e45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__588793f0d97741bafadd77fb5b7d06ea30ca45d0721016702ab1dab3756c00d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30386409ba047cf921f12ae55dfbab5a948d11d7196aedb863a47e44d482246f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c70391e458ab28a8c9ef8306ba960866c793d6c50ad5d05de1682327bfeff3a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__232726affc2d08ba767fedc1d170cb45ce9155f85b3f98bc06c45c09a0e54814(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a632f0d94fbc9b770a36f85f879001be87d4086a2d2021b8c0e22b39a15bbea2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42529d3ea8d32a03e7ff074b451632c86705fa8548d469bfefe2a8a5065100bf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBossBeaconing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19bece2a3d4e8a4aabc12573cb097cfab0bd2bf069e1896d868e65e45cb84592(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    logging_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    opt_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2905cc471be6416d6a9a44bcbb89ca93be91b4da063b91326a50008c7f04bc4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4fe801b22708d475ce98da3028fb8366aa345b1ac2b044d94c44bd1c783196d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__079f34ff5d7520edb0a9ab294c17d99772569bee7d01b91d0fdde491b8819bb8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4362f5c53105bbd22b356e75cbd8bf592f741e8a5e9dfdd855a7d402da5c22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262c109b232153d41b03514df1a6970333312a16666859bd90ac9bebd034b6e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__504a4d8aaa7974fc672f958735d9a401b91dd98a77ce62cbdf8fe9f20f0e8f83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d67816efb9ba0054ae0d9ba036f355bb7ff4a7c1e86805909ae1f09d76b474f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b82a47f394964ebc526a8a543e8acc0404fed2e5af832ec872d82faa31bb741(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreadcrumbs],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4b705a79bb5b244723ad97a238c3f14747ca83c1098954e5cf9cf0d50d414ed(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b516ff8647cc7d042c8111d5706f8c3e9787077ddb22de271d29f13743d168(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb79c5597b854625668043fb5e1fac3b33e8ab3b087d7150f44837f3baaf0677(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff76072456ad6aa40feb7bca4bd0b1dc168ea7fc39964866cac6d0d20fba11c2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03547cd4e0f78ca0d87defba73f1c7482c40ba2e13fa9f9690f07f6deda85ce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea76e1eeba864e25af800146b4f52dc8fe142bfd4702bb015f0920a74bdd3db4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14606628f4d1ae00db3ac07c210dceb8e9655ccc5f63389a6aebe59d0b44ab2c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBreakConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a666ab792ccd6f166f137d5302b7235159ada0ea9d01cb8a8039d7e45a6d17c4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a78e1da86a790fc8c9583408575222ee8a749bb83e037c7a4adf07ae9cae094(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91088b0b963a6b3aa1b1bd3e238240c1b28a336d7dd1889d05036aaf19603a04(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b754bf04a98212f4260b0611279c96b1e5250c4b428b69db467797d0c630fd2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19e7e237bccb06d0c97a4a2abcf2fef0b95703909a30a31b8fe1274f7f112bcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219aa60cb8a8eb046448489ba1c21ab76b68cc1c292eceeee9f5bb06a94091f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4675dcc9de31fce964821fc08cf79640c4db1cca4031f442837b10bc1aafc7be(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorBrotli],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35600f3026fa3440d1350ec7caa8210a5a23f2e4f46f533b76a0e640cc1a1cc4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preserve_stale: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e645fbf4a720cca6714e1a094b2aa0e9d3a362081f30a8c63f1b993f2d51f39c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723fb93ff21ad7a757554b42fbf662f216b60995a99b6f73572a7b1721ab1a17(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491173d857c5c857badd59c61488759a54a4246236abc3bd5d7b626aa7c46619(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a62c25ce73c9bb29eec7a0af90671e7d0db44fa039526b693ace3511da1c76(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d988d9b12942e7888547d8d368c15d0b29c090aecff938c1fe3996650a3f8221(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64b377f4582d491d5f06d893ad698a34731cc181be99f503bd9addd4a88f8523(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fbd0b73874fb2497f5b9eb8fb600c375da30b6180b23d07cda40caba9a3d3bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1387b575e95fd2d6b6d836424f13620baa807084398d1d8792bde2e75728b697(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6283dbc2464542cb10a509fc7385966c0907dd8f551da123525c90f265acba3c(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    include_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optional: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rule: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6403703d1472c2cd038e0b1c9b92564a15874947a92563ececc9655f6cfc0cbb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c9ffea1808ef4dcbc36a82850e13d3ec95277c26e9fb65cf418335c999718fd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae7cae71d735d81f73b42a2e7a33b6d92cfc266fa035b4608170522e6e075ec4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eb6c6d90e9beea81faab3446eac9a641695261636677d78b92cb95f095d6f55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c56d13066ba0a616c1cc02f2b054a60b6656563aa917655619426817cdb1ed08(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20938a1cdfb518f5c8a56b06addaefffcee310975f32e8411daeeac44f5ac865(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7584f0ad7652db671fae661267d49c36f132689d4bb370a1dd2b2a26b0cd3688(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ca4ecf21f2d6c6e7352c12ec8b7439e4fc60c1e46925fc5fe8c9d3ab5d1ce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4556ab8febd5cd51a1423b64a7f6bf54b7a5289093fb4d5386cadaedfaff521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0590bd1c943fc602fcd0b45e544d82c1a2a719b4d41198469420aaed46551632(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0129c8e34d23934cbeed2406d26adfbee5efd84a88f175a9863e01c48edbc7b1(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__192ee27dc084a7a3c43baa698b505c7c22c28fa20d1f2c26d10803aec478f918(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7c90fbf86bbce3752e826b977d02f7e3a695daf55180015e8ea54f64f24c346(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93fb7dd8286746805f0f60d9c70d6ba23527486de8589cc1541ababca32def2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b125d002418088c75f4a608316fd0fa3355af6e1ce687ebad9acf0cee954cbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d74e55479af4ec6963558e97fd9a7562b4b928b55eae8cdf1388dbda2cce0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__222fa11bb424985b130547f1ea35e057c36c8044c88ed3b9291724cb11ce03fa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyIgnoreCase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c99213359870cc73264116610d1d981649a3eb0e056956ff33a2e98f6ab58d4d(
    *,
    behavior: typing.Optional[builtins.str] = None,
    exact_match: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6bcfab5dbf144eab51d98b4e9d2f1fb63282a008f30c763a1af1c304a0fb29a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa03fcfc808067dc33e2e39e498171c4cfb09aa7db6b0d3345e03897c94d38eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b66b8683414b183a0f6937f71a5a18989fa7b74599e8e7116d6a606e4621d72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a3a116872c9f70762be2423944f176950006e18150ddc51f34cd3c7a1321a50(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab1f7f085cf4b9b6c6da3b86ef1039aec47052318ce6e7dc47c527ee39d785d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8a856816fddbacdd16aeb588d183cc7e318bed3c332635de5db1f9128c81a08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__686c61e22b2bc85cf0f5ed91774d9841c7e2cb5cfedce4ecd5439b4a89e3de48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c408878951f739b0a2539e243cb10d2c89cd51060683171867c0f25dc4d334d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyQueryParams],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__825538757376db0e797900fd94b90261899616e35af3ad672a9c2376810c8704(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    purge_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7d8fbfeca00becdd2276406d10933feffb10165e4ae0b3a90ff07987d05edb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80718b9a9063304c9fe5f71ad57e50bb505ef5803ca977a56aadfa9fe82801e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae1bc8e087afd82b714d190a5ca12364d85391dffbabd4f761866f106ac9a4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ef4a8a77c5775f06894da5826196781e3d815fe3e1ad29bcb4e1728d9738b27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eb01c5ec7159ade84cf9ab1fc92245d1aafb5b9be7bd15149f96596618a7371(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3a84f875986d3d379092c0dc49ba681e937e94cd3e15c8d75d93008e2e0a54e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheKeyRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__598cd951569c9dce844a9c8046dbd3755eeeb49ac4088a0294ee5b7d855b6cf7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_body: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbbc0c3502dbc647baf46c13223a8dc39dd17907c78fc8da86d510ab3761abce(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0a63f19bfee63d3fc5e1c4f1a891f54d0ca71b2d88174ec53beb9eed63e480(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1864cbbb8bfa89cc1cf43f71481ade251bfe4d0cedb6e9e8c831a09043e6b00(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcab72d0c4a2cd2cde035130c94da0003515ffad6d6b5cd961aac953dcd5859a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1a48e4ffec2f93f4ce540fb86ae549f57326a5e846dbfdecd9a545831b6eaec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__225a96039e2dfca18ff114c5017c3fa8d136e163eacb6d58b61d33ba96428608(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cb64598fc6cdffe7a4d59184e3a01627b6616294f4dac30a9ec1803b34c0ca1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCachePost],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b7186409fb34b239cf81dec7922a731234a9a5e72659750b3d71c63fc70e3d(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce606f53259f8cf5e18483e0b8161d38b16021e0329711505dbc2335cb78821(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7696da7d4f6253256a16da2710c4b7ae6c1778984d4712bed7e1960dc7cfc903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee85e7a1b4d90804c1152c1e485a9ca4415e85f9712a17bb3692125a4ef99a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72721acabb949107f4a10175d50dd3e50c172591c4a7990493d2c18d5b6ce0b0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbd38c91996390e4da2812292cb16b7053ce744b046c470a55aa0ffc6bc3320f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__048e0ab7b9d3f7398f55361e4b6d6a038fa90a402dde2ac7b6fae9ca5857c9fc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b821728a8ab340746cda0d2795b2e931ac791fd7c2256f8017b937d0aa6b8ad(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tag: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76222248fdbec7f56219e0490529cface299a5e5a4984c8e23d6aeb025830170(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4417d3adcf26e4f577583ca0dddcd2b2a561d1c9239d8bd39380185a09401593(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f08843b8b3292058ee4a3c11c7306148e1b4e54c22599ff36b36a38376af3cee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__627a44fa625ca45a2c7366451f76a64263059e5f21af5bd2d12f4ce406bc9ef6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db2686dd8280fc0079acde386e0aa962898290106336dbe0d93db5f305c0157(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c1a36d57be609d01f13a36110ea569f5797355058d8d5ed60744e3e0161e15f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e2c880ec31a1bddacd5484bcfc2edad2ae7f29e27d98c721f936470f6544aa6(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a5dd0b36c7038f39e5bc630dc6885989173395300e35d8c4caf1b1a06b29b67(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07e2bb2f466a81af86082f0b82b318d513b59ee84f3ee7b3a19296fe2e3f20e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00697b576302e0d5f8d032013a172ca5ad854eb3d757eee77b3d1460c3b99d2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b71320b07071be4dfaabe96860c472548a8b7bc78ff817c94f1688fffd8d7015(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4366b29477837c88e375f2d08da4d2bf53c72829c26dba95e3e36a3ff20b1b7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37a46c6b6e36136b3188232810f4effeaf73a5d0cb585be044bdeb238dbee722(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCacheTagVisible],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e54738d287eb02db48994035c014198315129c9bdf402397a44161c132d45ee(
    *,
    behavior: typing.Optional[builtins.str] = None,
    cacheability_settings: typing.Optional[builtins.str] = None,
    cache_control_directives: typing.Optional[builtins.str] = None,
    default_ttl: typing.Optional[builtins.str] = None,
    enhanced_rfc_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_settings: typing.Optional[builtins.str] = None,
    honor_max_age: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_cache: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_proxy_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    honor_s_maxage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    must_revalidate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    revalidation_settings: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110bf3382f2bffbc2966175aff70188e1716f1ad180e0dd0057d477e201b5ffa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f2e7e838202eadc266fdbf6f732200277e555d54f3efc92d5b55a1429bbbbc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9156e01c075d7d6a4d651a7953c431531e01d2899e56b9fc06d4e750f805c528(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c65514b507b6159ce344c1d028ec5a789c9f784f54f6393f4496334da3f610c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e1f1a3b05afc140e0953a30fce217f181d87cc1e93445f934f56cf270261daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63fbe5f36db092ebdc11325019a7eb195e348a8e244e567998cefdb0816823be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6cdbd70846014ad7c062f44c558b322a94e0e6551328d826afbc06d73ac81ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b3217ef096eccca7ecb998d764069a5c3faa58f394fe9c451f1d146681fdec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1beebf2e3804d6de03ea881cdc37b86ae28c601ebcb59d6802e934b6ab0267d4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33506ad5c44b90620eb6c8d4e1e22acf8ebf34564ff612521dc527f67c91dd17(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f9d09b773adbfefc5a879922daeac0937c8e6dc615d84a0313bb2ea39fed9ec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40e64148793132c016241555b1e08d6bde65c1f054e811c0ce4bd334c76ceb83(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94a58bd7720197e685dee6c294a0c1d3d5e0ed342434cdbd4a79b79e3c9ab835(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68164bb89a322b9f7f5b070444b1152fe74206f22402a0493e27786e9bc2111d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d65882d069d2cda7648692b9e783122fa64ee6b0de2d9ee3df12ac68299e4abf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29ff4f6bda44a4cee9c22a531c8fe3c9d7c11edde26d580420ba3b5bcab8351f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce0f236d3a713bbe5261e51cf315eecb65b4105d1fe0d75793ba896e8891de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd186a3ad211a65356db89143303ab7181a51a4451c057d046033332186d1500(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eeb2cd2756eb672c710ffd1bc136445998afcd3c2ab92ea9e73898cd5d09777(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__426a111c3167ba15cdafcbf1c8c627d94cbe33ae644075c068f96b167cd3e208(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8662d8a7391b504446da42a6f03e69276a3e28baa6749923affd225c06a29b48(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23404900324bcddf06dfcd7a312746f1a82275954ef5caca0c502ef619824e36(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1dd6de6d032d8a89b7fff3dc68ecbe2164a56a15b2455315d2cf4c10eecbf2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7005cb69693cf165445482713ed73296f194a89afeb9761f4e3f7c16685003(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9778ce239330161cc21160a77646b480c0744ed51b775d97e792ac872b083aea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e344363a4fe827a52cc0cb6f65ef7d3c4000557abc436b607ccb4642fa106b1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48da7b96a3f95af1c0278fdb89e48b9fc566e6f3e301048c2acc1d142650260b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b19394fca0149d9026442aa49520c661232796e13b6d687aca2c3c9ba444ad4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCentralAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9331747901280a6e44e92b7298c10508288d50ea07044ab427819e4d024d279a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    limit: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serve404: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c34e922bb17bb0fb5c1b6edd1f8a18f8c6c252502a3b66cdd644c401ff3a2d48(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9bb6e35795d3040e2764e10909f8f273dcc17e5cc47012d67d5a73e357e443(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7727e220e00bbdcc67de06fd5aa3b867b63b62ca280d522eb1c90270bb5a6c59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6fd9dfbf1cddffe676aea8eabe3820e664ad30a64511be47c7225a8b4fe44ac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270e46d36548d5f18f5c4b423b108ffc0d74e8de8351983f04425b708d625a8f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57522d83620f9413a92bedd31410c6820d2f5379ca87cd0715f5d5a5d0a9d800(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddab63cceea0d4f06e20263c395206b51666891f4c7fdf71956aca78f1a4bf7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75b1a86718900d24098658cbf0525355312a804b7a6e60a771b9a1e4d4f51dad(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorChaseRedirects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee647821f09bee04711d39484fb896be888398bf6d93b31177f8406a1e32a073(
    *,
    client_certificate_attributes: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_client_certificate_validation_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_complete_client_certificate: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8e85045ab9f656f1d6f08222d43ff3c9b67eb62e3a6c8ed181bddf492c9bad7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eedae5aaf664dcb1d9bef929aa7f79770d8dac62205b5c2b3ad613d203cbca1c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d77ab3a449bcc895401f05fdd4a0b8b2db47454f91905316365c4d4d09abd724(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acedfd9e62b177dc3d433a263e1653136d22f1165f763451a875a0a6e4ec37d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8eadae9282668c7ea78b02d69c4cc1c55721463a0eb74a2a7a52d6a34a432f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd40a33b8ab59eeff7cf2973ea2075d30ae60b9b151a7f94548ebc361affa22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50eec85ff32551b6c5efd18369c504063f42ddfde2719ff1e81ae246a5346975(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ff5fadac6f4c158a8fa5a42db32e6dacb2e8853ca356353146aeb2832c24def(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f92c923dd8c567c85aebe8df75d31d51eb16204bf4eb510b5c6088b46fb5f4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCertificateAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d919a4577f4c80ea938d166df2d322d7d8c145621dd3a9dcf5dd7a61f2fde810(
    *,
    country: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a56291ee1ba934c57832a31fc30d9b5d31d7622acd1ed713c7b90aff05ace06f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97b8a35b29e4d6693951f835101070d399032906f9096da6761496923dfd998c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c15939625c97bb4974ac7482515d415fbb9289216f4b26e4eab4b413bb225fda(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__833b76b8dd07a0b27a7084c97e5e5c9a0c0f6f0c44df97ed36c800285ad0c824(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__746d81d32590450e6622371df08f76f32695727ee4655ee9c2f79498e62e642a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f5f256f9f2687d2c06c24d8aa2955615c5cb82c9b2404f0ed08bc7face8f45(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorClientCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61bc03fbc40271e63bf2e34e1bc8c226a91ff60e177ed7166595e170db818340(
    *,
    cloud_locations: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__afa1e8c8925573efb45e010c008e6e829aabb02d6e5ed67c42f97dc474371927(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__310943d9fdc9c0b63cea3b9b250af8e3a35d8e2f7015f926604e2190f0804135(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__860416d7e89b93b87a214f5748a1e56ec0d96254a660500474694dbafa106624(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92c28e164ae19f03e6fe97b5d757fda9e9f8ac07cbdf63a911cc095d8ab4a633(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8cba5df39a21485a6a58ed8903bfaae64453f27c64c65843d3888e16613df41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8191c8fc44e8b134688288e61361ff5197c4baeea2c256fe0af07d8448acb98c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93e16fe7c603bfa75f452382f25a8cdad48c2b6e3705ad83904643e82a8c5ad9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudInterconnects],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48e1f32d0b7007bae54ce1f01eb9c692580069eebd5b44025de909f7b07c321(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d9deabaaf904f0c8b797358ea3c9b359cdf26a5094445df64eaf39d3da07bb(
    *,
    custom_failover_map: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_map: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9908de47c41280f9b3f130771d38389afcc2b4d5781bd64c393208f09563bf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3f8f1020cfee5a2b9b2313cd37211d852ff07d32df9f8888b8849a5693b779b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c553eb062d1c26f17c582b54fead7371cc009aa5ea19d9f0beb0de3ac47585e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__987ab49130e322b50aec408eeafd64983d5e9f8dbcf7976da5d32ed1c9e1ccaf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7a8d5245bb549867dd9af91d260e145c4dff5b945868ecefa70d29727a042f8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ceef25ad0b90477e1d3f557b8b4fad5ca8759daced4bc112fdbb4625ee4debf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3383c2926fb8b582fa85d0f74701e68eb30e85ecf6367913c901ac2209ece1e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8a9a10c304e64ef05c91e710f5f1e677d4067d81f3b1b3235b24639247d94a7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapperAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__303fe067bb79610e2dca96e1cfee83c6e14e26abefabf360b9c0bf2d81de32e2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f1b532320d96d6a7b04c39b039d3faa4404598de4c14f878ad5e4a25eaa39d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db14336bc6f963273cbcaf10fa92d69598b76e1a6e8891c37b4c3e9d9d0e9aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fd5e8dba5297216cb4a0d40682a2c1f737154730fdc92509dc6d22092fbbf0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b51a6ad1933f2ac703b4541cba38b391fad6be1c28a37f1bda1bec695af6d931(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5bfce05ecbd3436ac040a99f8b59dc8da168c2fba3e1914a88d9939c22ada61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8991f46b7f2f2751098a4a61c6d2b0e0b213383aca2926c2802b623880e6cacb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCloudWrapper],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c603a0aceaca1f4d59dd8af2ae08e87a5a35109033756fa8589a2b4ffcb2b6(
    *,
    enable_cmcd_segment_prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a69d4a203e8776ec0b2566e82eb7c4c7b4488774ecb95914dfcf0fa3d9710f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de9035d5c0e680f0d77920c8c02945db60a3edb47db3cfc596cd5db32618c9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b676a9f464c763c0147a587e5e85f2e8762c403a2e48d22104e090aa30a0ec2d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac77a79ff1cb5f6d6fd3a5e502bf3aca179cf12859422d68125d83e2a0ce50af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1d320f6b7ff460f1ffe21889a3681c2fdfc6e879b37232ab9ae39717b4a2e8b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281fdd0e14759cc3ad8f52c5cae5d85116d991effc2fa0d1c13ca5e37744f96a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCommonMediaClientData],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d44e3f319888ab59cd3f9471714a8ec78515bd8d239291ccd8197f4c340416f(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2e84740a1a4499da0502355a87b808ab78ff06574e506218b6190d60168ece6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f95050e3f6cad519882f74aca4343256e207b9884490494a9c756007094ca89e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7499715c8025181aa456193603d1c0999bd20002ff2be5fb0373b79f9b33449(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__291ab059ca29d77d3f60034df665db32baa16ce29e80e72fbf2f71ff3f0b207b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5561dfa5fcd0c33b50f56008e6db0bb2d5a9b8aff6ad97ec618b7afdb4f0495(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b062fa13a4fa8ea1a891f383e66f95a7fced7707aa40301df431c5ba2896ccbb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConditionalOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6b23e26ac6d83321b081cb9e3b70e3bad3823d7a889bed83276a0bd7f10f0c8(
    *,
    body: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_eviction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_purge: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__254ba6afda9fbb5d62aac6510a4996835d755baa4194a5f04ec7e9bee6d7a083(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d302f961a5903faec4a9fd37b66863696deff5b8c60f55e18610ad686f78d91e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2bf3c63a9355ef8827aafd87cf8c95026240977c52fbded836ead3a51d8f9f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd22d75e0c37d2aaa73945fcf7db3125699e445c5392306c6a599e7fa9166a86(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6374431d39c8e334567f3be731af66191c2e2b9f84a4da6493fbfe0b27393bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e46779535e2b66e11bc1cca6c7841a2a2ba965f06d2c2718bfa7571836afb05(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__946d254a7ea6fce27b60298fa0e7da7c48d8668aa3179d6e33c54740a1fe0d1c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3618ffaf4a2de588ef54744abdfc775b3bdc6aa7b0e478e1ee60d8238b70e887(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7809f6c86be32452c880ec6517a3f35ffb13ae5807d56c9e31a5cd459c1ae5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e09430d574c6f9d154d40880ec9f851ef50bdedf598cf4d30aff57c614c6b6dd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorConstructResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__094fe25151123bde365520f050efa460a24bad3525c67dd88944466e35d88c2c(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12505f985f83f9604e969d3ad883794f7dbe46e1046007453309418b1a74631a(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_dash_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hds_custom: typing.Optional[jsii.Number] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_hls_custom: typing.Optional[jsii.Number] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_duration_smooth_custom: typing.Optional[jsii.Number] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9258470aa6bda82b2752394930f8527b65cf3471531ff2acb8d64e5d69f9ae60(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0473fb6c5b5629de343216482db5932ed312a936d709ad79da594a0a33a8df07(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aff5a438beaf3c315a8c5fc0aad269943a5fa84bdf6eda8e545e0063803f7e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fc606e3372f768e53238bfd66e65e74d7aa911653a917b34b82fbdb2ff58070(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3123b5229d3e3c2493a9e100c74a479ad9b0b17a4a624fe85e98f0402dd3814f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae509aca154e762ccdd2bbe29dcdddaefb962d92313b9258dd0ed4fecd723e0d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607ee54a7f21790e026cebd508415793d4410be2f37b614bb4c532bfb3b237a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784c9fa8d88a509372edd8ca0c4bf9f285143aceb867c8adb0dbb45893b37c85(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adb8d4457e8a8ee7b4d98b7e7fd644383180ab3ba5278e5e9e863d223806254c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc4b6bafc8296bf9ef86de16c0f9810e008032cac230f08442b10f94d971b46c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dac17f03b6577938648b16bac268571221de1670ef206e3e5e1437f91abb2dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3e94c96ecd6fc8d3bfd1446be7b2023537e2247c660c8041df6905b463ce09c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72abfead25bc65f3ad4841322d66fd1acc59a871c7cfc6c02368d91409fbb22a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3247be488c34b4450edfe9c9ac2dba1fdac60fc84f50e73073d0d97f234e0a5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb675387dfada228b0bfb568b71522170725e359c011df6db4200b89aa872190(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17e0ee808e0a7b1ae3e0a4b9aa250a878c8da355bbd228de9bf8141cfe92731(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3ed90a71e1d4925c680704ceba6797cbb13fb3cd1207381ce8a1f63d236f35d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c1ab4f3b32683ba08e358b2ca350046284a12d176a4e23e9ca5d70ceb7a1b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9dc349a336dd9b8947bacb8c973689c149d8fc5ecad1c9c0d1d333a7042848f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4600b5b3373c5d16adb5fe3da54bc1d60b794297c67ce0aa454415a364f7b0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd60a361dec9614e0b62773d2267612bf4cb3678e04618a336e74651ad2704cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b0b7f27582c9cc209b56b6aad1301a3d74b37221defdc9b5463880958fc95bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b997209716b743febe2507df0befce4249dde12359ada97e0819cd41bfc6738d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5df1da94cfdb5264d4fcacf3bbfd9d7991f60c6c4a66a9e8112a2bb9e40e541f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsAmd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e575245db0af3c8eb07bebb6b164e40c8e30f8e9e2811b12d070a4e07d54f9f6(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_option: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45fb70a403a17ce74807968cbb2ed39128dd6dcd5657f27327381d48deff40e9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bce40e4962420a84a4076f6a66312a87e58fce8850020e10bdd344b5a3b895f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29a4b9ec01d5ed5b8648d8edcf5f6cdc89547069f2439e84ee80a9f6b0ba338a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba91f00df2fc2090c83b67fbfe1c49dcacc227d6763804184b3cde72bffc09b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c6ef1181e025cde72a23d18c11f7679d51ee84b90638b01e9e08779614791e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c0da9f73f9ce9e4bad9925edf13387a508e4a098c31b7ffd7a1712d9ffb8396(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a167ab4b42266cf206a08f71d3f6c12baa42273c1df178daf0ea9554d7a2f1a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__652b1b29e9e0e5b15e41a9903509c1d18b3642adb2cb91c34e87eb2282f72575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdf9a07fd26e5c46e04c8af65fda96f8837b156fc5ee05dc88553982f32108e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a6acbf2528fabfdd0adf7d1beb2e93a786b54181e7d79497104c21ef79cb28(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsDd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eba95ed3438f1a8fa2c54be02fcc5bb28032b367a8d574b7273ea76ee3924cc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6074bd17182c11df49054524946dacd6ece345dd0a9030198391939c160fdb28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f431497bc426877c1661b43d4b40c884c44f8a4048a4c1db6fd831222c7e65d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c74ae1cf38ef235238778395f9ecebe46ab6826c72617d338c188b300d1cfb0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b859a9e0059a9d9cab5f5f17f909653fb2678a03c54d29b6a7de9b32be66b179(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__552aee1e29d62cd64b0dbf5578f9d094b0b6143d53152107af397deddae4fd70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__069f12816b4b8fd72be7fa4e98c56ec5834a94e8ad83fecddea46eca03551ef0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__328916e2783ef7ab7b4d850e536500cd7950597c459a5262fe955c62afd40096(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14258d55af9b9811ab7be0bcadeb23fbaa3f9d6c179d09b4f943454de0cdc69e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4f01d2ec15c1b44d0d70b9bec1f8e9b0fce2b297cadadaee368e23414a22b33(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0174ff21d12e2c4fd1fc2b621e695c11a0c75a3ad8324413352e2c87f213f47b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92a9900b838ae71d02d477941374869823c53b74baa5b3bd61df78cd4243a1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a25d80583c0b993020dab9eb9be61d639a851dce0507233d43aa200152305168(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a99fdfbf92a5c9838a31e11262669886bed0e0c3e2c35d00877b2556b5205ab1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7b02a713e2e3e2b782ff824a86d809493f346c2ffc9b49d786952dc53943ec4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769b260986235fa435bbee7931cf808afc7cdf966768a39ffeebd272eb08ffad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a3d27ab43d8deb8a5f0532ddc795dee0922211809f8dfc02bb136428707120(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3827fa854d2d8442ccec2048d50dd87f6c17cfdb80f45adcdf360cc4ccf4b0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc71e3bee8efa8f17a27094e5f7736d4a34946224da57978d570facefed981e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLargeFile],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe455d032556fccb0157c07511578112b8e6898a0b63293a036fa7791458670f(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d84d21f0253046cce56b20c821b46dc9ed797c03e8a4a2566fd0d932d6790ceb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431a6daef726f438610cb83a2fe915d3374f8ff10970ff3981575ab1be3a605e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b143331da47bf1d8aba9388e9e420199209366655c9c2269cf05b466401ac8cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f3a675aed8f8deee2a2f80d5e0247fa813e930b91f68880977424ac27588681(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6df4cda91ed527ab5c70e809eb7eb198d595e8d4782fac5bef6b6f1e554c9785(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2d84a15198a35f0bfbdd4bded393e3a64a7c0c2e883ffb48f2bf99eaa953ad8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bba0d9403e91095c8180697d685a721dc0cd93504ed02d8b8645db94c2b4a60e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467d389ea4b70292d560288a912a1acd136fd0afa28241a9a4b38d040ddd1bdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fea1f5cb3d3b2a005bc1c21c96b844615fb2952d20a00e7e0841094845bac2e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74b3693adb252da011f05b31d544fa210efe532e37f0dad799ffb80d57ff1be2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98086471f3b83778a60e44c696bd942ee0eb77f2c8f647f9689edf4e9b8bf968(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4015b9594d903ccda34c19cf9594887ad9030f9e2dd63b3cb093b5c2f39430ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb03a940b613271d310b275192dd0056d11d3fa3d728c2f25e198034240608cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c265845723fdbc40f650eee6e7cd91c36294b4b7fc4342d422f0cfb541563594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc080222089887ac84dbec6fb5f13e3ffc2027e6af2ecf08a791dc114ec6d69(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0ca8f93cbac93887012806b831e581f728ec6a864289365715bf38d7239d3f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1e9cf9b236147d02442cf2fd69b157f6ba9797c047f8cbda7b2c9d76779f718(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4fe1b7e11309d4f0c1ca8dce37d3f4d570f705ac3744e1642a34e38551a3fd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fbcb1d6c4564d210fe3b3734d1fc934b8a05a160510ec54a8d8314f8d6ffe53(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c98a69c38a80657ecc55ef289f1bf1e1e63ca1de8ee92727a7ea0a554e15eaf5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdLive],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f686eaf5fcbb94624780fb7a4bf1e2823d28716cfe1795efab8b7ea1b4955ef(
    *,
    catalog_size: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    dash: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hds: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    segment_duration_dash: typing.Optional[builtins.str] = None,
    segment_duration_hds: typing.Optional[builtins.str] = None,
    segment_duration_hls: typing.Optional[builtins.str] = None,
    segment_duration_smooth: typing.Optional[builtins.str] = None,
    segment_size_dash: typing.Optional[builtins.str] = None,
    segment_size_hds: typing.Optional[builtins.str] = None,
    segment_size_hls: typing.Optional[builtins.str] = None,
    segment_size_smooth: typing.Optional[builtins.str] = None,
    smooth: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0a166745a8125b763cfee2a38eb2ad3853dcaf6be14e78d0771172de76efa9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a0a83ed962c4585484088801ee1366c6179e425becd74f90884cfe63073b21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0a817fec1e2a8fff68048663910a416affae8bf4fad4f25984dbf857a35a2b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71709a920bb3c056da6224e5c359a2b6aa664c7d017c109cbb2c01a8dae14e3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512dd805099b4c8c700ac0336fc3166fe1399fcb29deae9f35d67e2955cab0b3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f0ac5d697aa50fd2295c65eb0757ef2c02100938c8ec6732cd75dff6432c07b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__337714f63a94a4dad4ae0cd93ec3404a51c332ce995dea91cf288ee477ba2978(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d3474557e4c757f468190739ea5d54417ac76140cb34a0ef3a6367fdca02b7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5777554fd6d62cedaf9d84fe22233186bfdd009f2b9f38f99d703d632d17148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc5b5cf6c03c7ba93ccbb5ce3b207f3fb1101a6dd779370018af65b20d685a73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7131865aaf69aa6b4b044e7758a6bfe6876ab13b977a2fae9e6d7acaa5fb74f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dd695ac64b8a07307e4717a8dbfef7a7e8411b33057790c15fcac8ca975284e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__195a00c1df5f8aa37a47a6640bcac0bedbd724c5dee2d374091a3f4af6ae6fc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d83a8aa2a7382a3bf6ec31b38fa78792feae708315255bc0ca4a4dc22b731b1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78598276800d7ea44ba1ab803ddd2c1f791b781b5438d9e208279bca612bf116(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85225c6c53fc2e7af735299f6901e7288f0354515752ffdafb7f0659d2592999(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b83e16a9916b5844138f8d115970d70754f45634ec20ab601ee3cc57de2db1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e693416c719f55a0c66bfba4853533856bff519e4236d259a6cab8a8b5016fd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae2c59c4b7cf7f0bc55d00251b4f99c16f1dddffe431d70535a906fe12c8736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0f648960527a7f3c5713514777bbbfc4392427e6c9e321769650f6c870708c8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentCharacteristicsWsdVod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93d62cbd3220599479088e44c940517e50e56b1385d6480e7bfc3112fdbe76a5(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    first_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    second_location: typing.Optional[builtins.str] = None,
    source_type: typing.Optional[builtins.str] = None,
    targets: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2f27808d2e909d046bc37db54c40f139956d6abfc5b28040ceeb882d1d84cdb(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf12aa68bc677c397020692a9f0d5ab97006b5a62d48d0aebb55678995bffa23(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff12b2c69132b5e3dc5b65272c49d2c79a809766ca598df53d598719fdcf383b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bf6c558fe127fc2f4935a0309091108baa76a49caf72f7111e8c6e2a9cb991(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f6474115e6a44f03a800879662592fe861b458412a4cdf8a58f8be1b4da414c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed581d555284d67154638115c56a61af2f419bca1ec4ff785fa99c36699c40d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7644cce10d105dd9b8d6fd30fe8337ebb21cc3a8e03de0dee309690979c4fff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ecbfeba1d0684ec96fc82042c33bedbb07df1633d164d1eb3b7c38aacf59c45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd78db356682474f02ff9b5dae92fe016ede0fe4985cd8974cec4bf3499ba0cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3c0319baea709e7a3a449f17f3575ee5fdf851476055fc56f3012a8c3d862af(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentPrePosition],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfa4d8afd92331bf25d615401bf8175c75f80c540bec447f6e2992065cf48098(
    *,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    dmas: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_geo_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_protection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_referrer_redirect_on_deny: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_protection_mode: typing.Optional[builtins.str] = None,
    geo_protection_title: typing.Optional[builtins.str] = None,
    geo_redirect_url: typing.Optional[builtins.str] = None,
    ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    ip_protection_mode: typing.Optional[builtins.str] = None,
    ip_protection_title: typing.Optional[builtins.str] = None,
    ip_redirect_url: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_ip_addresses: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    referrer_protection_mode: typing.Optional[builtins.str] = None,
    referrer_protection_title: typing.Optional[builtins.str] = None,
    referrer_redirect_url: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__648583d18293b9225e7658c9c133ff69b83cb8e2fb9183fde5af92f4e94b625c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__061344605bf4b73660b4d4fac3d310ede9fd003fb4e62ebf5864ee26b21ac3ea(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1292a7ec2c1f1f2b41fff14c0ca5443c314ac9e61cf4fa7624b1a1efebd892(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446cc453799c1cc40b17af5b27a84ae4c7105c8f1afd7d8717bc5bf2bc28f341(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3501834fea02fe0a63abfd80c7f411aeaa5680a127b15d6bdbd11301947ea87(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b9d35e186ca0031737a0e0be49dc03d71e816f444940090aa09150955a1fe6f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82387685b7043e6664946f75dfcf3f086359ae661d7513445b883873c5aa89d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da7cc57ac45fa85f5464ef7cff5e5bd3f7011a0af05e6333a85e9ef63f2b4744(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea3b743fe36ae55c3334dd388dd10a843eb65a1b60cf8992162335bd88ae2a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9641308cad71357d5a8f47bcc1fb3a2dc19934db36b5a140085bb358f1309c8e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fdee0089eed8bee354b3ad856880886ec53f62d8b84aa64ddb7a00fc8d26d23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ae244db6108d0a63eb6cafd45a5cb3a2135f482424bda2c26ceae76250b3d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a492bb23c094a853ea1f2c5ab59b1c3bec6c5ed77fc38c279b47ee31068e2bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a4c608f2a6a154c31b47a41b70fafd8a9989ec5fc81f9ccde54c089a8ac31cb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee55f2473959a0b10bdf5386cd3203db31d344875ca3d344da0feb7b9fd6135(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61233e60a95158cb4a2787056631f1e652f5e3e775599ebf976e4c14a6be195a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a2786983077d1fc5a22c3b78a530c9e6d7f0a20c21a6b06f734dc4780b36e7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1da6419ed0d63dba8f9b11c0301c17fb0df63d1253ca80109b08174a464cde3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df79a41d28322a89ca27a38a0f8f5628091e2c2d70259b1e818c9ef23d15801d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__262c38ff1968d6f5c0bfe8fad7ead955484777c514fda70341ec84c2c3cbe36c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f6e57f21fa7dc9e9f415f21d9e110ca17eb94e5eafe737765c925068312443c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__438c700647e2172cd69aab958f7065acf57d537840332c613f98171a8da9f216(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cafc0994ce6460b9e0d7d4e264543f1026a2d473838b4155d3e5f3c09f066e84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a33595eb383e52b61590656da5bef51a42f0b61ff3227d96b349b450551a008(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2f04679383373f2d7c04dd24839d3e5f94b4daa52725247b122a23746ef5c35(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff52c4a70a54a472e913f5723d4e2318dffb44bbc9968352efd9e06f37d4e69a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79a1cf767fb3d310beb751b52638b4a6eecd4b1d23a00cabce2a897ac47179b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorContentTargetingProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20ba596f70f863bbf68aa80036bd21890d04c048a9ea0b88d3a66c4b97abbc4d(
    *,
    allow_credentials: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_headers: typing.Optional[builtins.str] = None,
    allow_origins: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expose_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    methods: typing.Optional[typing.Sequence[builtins.str]] = None,
    origins: typing.Optional[typing.Sequence[builtins.str]] = None,
    preflight_max_age: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6123e70c362336259f7703146c9d2c83dbff72444fc9a9e29f421b189f12942(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc5b5e961ae575804ba3cbcfba4af23545ca36b13d7d45e45817dfc691c960d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d49b779f8ffb64a347776eb4e168e2c55410661bd6b15747fafdef736f0457a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25e2d0a91dd132ead4916c2bf1922f9152d5385a49215eb7a74876c9b332514c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be50ebc7c42684bddfce4d476420602f9327d329000b99a8d9dfcdabc88a5afe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f428be0c9d5562fade283e7b0907b332ae119a2d36c6653f4472b4702e0b302(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7066b2531e2ef1d243cf9c1a38fa0354485770966fe5959100f85cc47a41c3fa(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4693fdee0e5a44ae462e524cf4c373edb1ca4498afd790b694ff792ef9b588b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4857da0f68eaa43689808ff28ef1b5af8797d584906493e426c8700417593952(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__117cba2d27bcafe92b82f7bacbd2e515dbfdee538b2e2024731d747f0fb3657d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de50a4b9e72c4cdf7746d27656ec7fa7a24553670e30ff2ae3194954ba6c71e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21212ce1a565a707cbb959dc8400fd17b58fbe23d6950789919f0dddf9c7d2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab2a5ccd3372de32ebb64abe666c37c5a623909565bb289eaae84712b6442daf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46537fb43efe0e9a3884c6a315d6fb105e46772b09d1234c05ebf4a2fe57d1e4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCorsSupport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c647c93da84cf392f5da45bdc135752f3b59958639a9f8c320a311851e7971c9(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__630f6172f7bdb7d869325ae85169871d98e6b814251ebf79f72948b4e18f0e24(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2be4d90db665f30bbde0979f7dd795d67d9330947fe4fc1ba1baa55c598116c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99b72c0859980f11fe92fe5e15b1063f03d322f28c1230883e1c586ca2561db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ed933ab6ae4abe3d76ded177046124a73b1f06a3d941dc17744970088631675(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__145baca2cf2419f205ff63ac69873404ccb299f3a97dcdaffe043070b2512dcd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1374fc6f8a387e0d264acab156279c6c0efbd7aeefae617e5ae4e4a1fc046c(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091e71487d9a1d3799128ac7e39b705a7fe4f90c5e46c83355788d29fe04a11e(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14bd8216afec08039bd969a3c52377c181d0214ae7e569c400bb1bfc25a9aad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f6ad9c58d7b2ac689128fc0002372fe9b34d42b71ce99c291d13c9abcdadea5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0066a6a861fbc7e6fe7b0a733476589c7edbdb700cb30017be21c9f4a56c8512(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84fd75c0eabc12f7165b98237f8b8ecbfa75ff374fa263f76185a69e25e38729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41c196fd5a904d797e83c01cf8538d36da16402960e7c4dda135afa704009752(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9072f46d3c6f0f1ba43af4f35333d1846f949b9e3d6b0ee64d35a2b79e01daa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe4eb17a0a87c9cf2d434ffa8341be6224332f392e6b4533272e7805cdecbfa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51579a6aa0af2b4ee65fe65f31c5c41dbc95c3e723160033c013bdb07cfef4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f01da6c01789c90e9ec85754dfa44911f7930828efc0691958c434d6dce0f519(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a545113fc28c01869a5799b734bb72c368ff2c02ad5e3cd3e67968adae68b228(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26e59822b2c9eef30c9e0ddae3b8f5dc46fac6a2e5cf733f0df78d970bc1b905(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1ebe042f794e0a047e11480e58def41cc84c82064b30981f7441ffc0079f3c5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca4d3abe69e3ce3ec8255b2d755209753b931243648fd132ec867f421d16d0b0(
    *,
    behavior_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b58deb819e3cf1e545075fbf758b8b7586041754b45828d7e9cf7de1b26824(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b3b9753209fa6543cb96f8c75e0751ceeeec332a2e56a1a02fb78f90edc2da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__600006f8089f96fe504f62d31d1138d54bb7db139143ce73e4f4a798ec1461f2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77002543f1a4b61f6f74ac799b6f88e6a195c388da96c76ef9e77f49d0a16a0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d403ebc26beb80eed7eeadfddfeec746ccc7572f2aecac315c3f7edc7d3b4bc0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__925a0daf64275cb9ef6ac6d3dd0701dff22f7e666d80ead66e99e46313fb12de(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorCustomBehavior],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed17d9f530f27957f1e480b3d624238743892c1ff3b408d9e34929a3bb1b2007(
    *,
    beacon_stream_title: typing.Optional[builtins.str] = None,
    collect_midgress_traffic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    datastream_ids: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_stream_name: typing.Optional[typing.Sequence[builtins.str]] = None,
    log_stream_title: typing.Optional[builtins.str] = None,
    sampling_percentage: typing.Optional[jsii.Number] = None,
    stream_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb2901818bbe86de55f7e807891fa67c2ce6f9c0476836ec3a1782845a64ec3f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70eb87720a56c0492e1fe8d5509018d8aa98243baef3cb34fd0d3ce163854a59(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06baab5503ea4c4ffebcbd76015b2dbd15a6469904ee0f3d57279af52409f320(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66d3da38445cdfb97ba13cf0c61dd57c1e8573c6af76876dce06908b7b77af7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__057acca036351a1c6cfc61ef4aa5bf0e0a8bcf1dcfc4387e3f90abece27237aa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9907f3406d067af2e3449984e90a624e1dab47fa0d2c69d31b80468d11f6f848(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d32204ff0f2547935d32c908d6257d79a80b9089f3387d4e465c21e5a79312(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b27e59d5efca8de405877c24cc12bee61302a74c6a3ac66a785892b8c016d385(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3da94e721feebd115621a88f491e59fa13ed5ac6587c04e8373a25059481ed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83538f670acab538ff8eaa7cc32f823a59a0f4148190247b3e77cc0caf42b3c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db1be8738a70f1d1457d11db1e179f0fe3ac95ed2455c44e5b79047564fd5db6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__939444efcefb1580abaaac1dad221a1b9661552487893a488fe22cbb2f2810e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89dce5c4f98c9e39971c8625f4834b512a009807e48bfbd40d255374a1e26792(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b130f95b791230ba33f5559664c3e2f6523d064243a31dbfa431dac004c13f0e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDatastream],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6c739fb0b7e1f3e861220ecc8651dae068571914415e382d806cbc4fb2fe597(
    *,
    anonymous: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    gwenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tlsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    wsenabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76111d68d18fa06da4395eb1609595909ca956c492a999d90f1d4ce3bce759c3(
    *,
    hash_conversion_algorithm: typing.Optional[builtins.str] = None,
    hash_conversion_key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__281d324eafee6ba6ac224e90fe87f6a2f089d6f7091deb506303892bf350c48d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fcd372279c295cee85475efbf8a74ac58db50306fddeb1a7465e293410de1eb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6484ed9c8c0fc811d7a1879aa77a24453ac56c0a482f05dde8e2d5fd5be7e727(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8a183d5b721c4403e96d371c1881bc3294d6de2d8f40911b0325cb8cb92ca32(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00a658ff5cc29a9f5eb273d36285c94931dc530e84f2ba7ab9d3a451c0dbcd42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2179f94bdd8cc11f4f83e09f85c40e5ee11131410d9fec01dde143a105268c66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e1003175a7abcdce5940f451b17bf52ff3474f1de478ba62a13750ab73e585d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthHmacTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a818218e7d491014294c6c8ae7cee0ee7f8d4f53b4b6546245214247ba0d50c3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8919fe97cc612138b36cb9be0f5859dbd937a0dfef7db1b039cee4fc1b2cfd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5223c9d9dfa594fc2b76cd3840e5023975799b55eda9f07560d06e5bc9ff619f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63239a70f8a1f2b8c488f43f0b52c3d4672aef5714fea75ef75b08b899ebbae2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d858e02a5a9d49d50434e93d9a61dcc1e5a7cfd6d3ba5b838607d7d1be5a7f20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c21ab7179dc8a0458b1bfdd02a7554830ad9981542d566c3896e756f3c05164b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f517337347886b4b22dac3013917b46f3f5b43783b04b96a3757b67774c0008(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthRegexTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__780d35335be68a2bd362d8fbaaa89daf975bfceb55ad0f2e97e676531ff600de(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    substring_end: typing.Optional[builtins.str] = None,
    substring_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25204e1c87d7d6ac9d53013b9b406b5a73b7732eda5f85f641f1a06e5927f1a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc354fe1e5ee17a4cc1109736f027065060dce587541b25719ed227c2c689d7d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__290f0f3a56db0c544ec1e8d0233c5dd424e00c7bb1fe874a7ea5df4f3aa1732e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ac75064b2a9934cfe56d0ceeeaab36f0afceaded8d762ad88af8fc7137628a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d747bd5e81a08e2b5f304d94ba4a255bfc44a230a2c925fd5274fa2a3c15a091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f3cf884daaefeb9c8fac48321b6216453d28a97a6bab021010e762f39ef05a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd6c4d391da50771a8d55c5ef1e27a52fedc9f1e469f11a8a208c08fc1095fb5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthSubstringTransformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a693046779e8217e88145536258c09a3df0b9503e1477c2825100022ba10c2d(
    *,
    certificate_field: typing.Optional[builtins.str] = None,
    dcp_mutual_auth_processing_variable_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4e1a6a56792139586b36123a36f58ba7858f436825738b8aeaf15e43bae62d6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c0418e54cddf191f1416cbc5fa22c956446f70ee3ee256d6f4e43fac8f4979(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a11d10db91ae36ae2aa7faf1b583ccaa2173515d83ee248d44b95f4e3756aa61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb45fa67183a0ec8962cadfa4eaa4c282c206e768fe55af1cb5898814565425c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b012ca3b19109b0a4894d4db7bafe232e3b1d219968c33f22f72ba42d8140d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a824b95679d1ce15b111e13d3c3e78ef3186ed0479ee0111c07d48622437af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a023c6b5cd93378aa2e8f8cabc380a051831801f57b75fc5199cb8722957246e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpAuthVariableExtractor],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3ec8840fe74c211615709912d7c0ad5a9b665fa9b6119e3df998919dfd3a662(
    *,
    group_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27fef64d9ccb31f3389515ff8d5f0e64f85010b0657caea5f92ed3dd54afc421(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98f0ca0f654e20421d9bab8ca5b2b420015d0e346a0200220ef67c887e4cd2c9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfe5d1e0bc58f96cdb7ec3e581ee5909357d466fe056387793df86090df59395(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8dcc3628a65253594fdc3670532e21bef2e15dc26aafd7b0481e24d2b47c3d66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__246fb5c0e728dc6c740cf576e1b8a709af498ecb230d70c3518679251ca3e8a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7edce798ad8c182a62c0d3019233896770c7d0d95643d4ce73c39a7efc1fe5fe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDefaultAuthzGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d4f547fa801be47f7aaab5abb998f934f9beec6e034a71571faa88160b40a9(
    *,
    custom_values: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4035a0aac37b71ad4026abe62a48bb0ea26b91d025c472308b66c7e4b9abd7a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7498a61e8920ab52a33d9fad4d1967e69187bbb63b72cf510d9777df0158e33d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a5cf1fbaac2ca833a69a21d6ddd3d66a090c4ba3179c06241c7af5debd81f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03e9a7b2dfaaf8a5585e7b7f65a9271df566c770b3e9f414c33bfde0b32b96b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee365cd1321b2a60c912e501b31ff7c538fb23ada8015fcbd7d67f06bd7e6d25(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8671ea088b5a33e5be3a6baf928163265516645c9e0b86b13ed149d8a06546c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d092d78fb1ca7e1b93e48e04cc40ea27c3784731e09dc7a201680934a1880d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9f3e31996418374dd74e70f8f192a203f7161378ceeca59059660ed9e791d38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c078ce00e1ffac119a2a43127a663f8bfc645e0b9d62875158c37db4537020f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpDevRelations],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4d7ed5cbe42d559c0e80898822fb5c5b65d0d20455bae35e0544053e3728d6d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3dce12a2b340fb5b0a61afca415b05f877227015ed2e4d2f1738ec743973122(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5685c7e433fd5f768ffa9e1a31a45c73e09990c70fb8ce82fda8563f58a79ea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4134552e2f933258fe6cd535e30fdccf7905282dd87f46140d00b374159db86(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__718db57bc183e9824ae0d8f3bb396317b861c3389cc37f4a890f915230d4edfc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__215a927a9873b45f1e44993d748c4b3feb5cfbf55149385530c34313a90f50c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a763ccef43d92274feab1bdcd522f4f755ba6655bcec48b3ad55dbf671058521(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8454287f2a6955d4cf603caa0e309e13bfaeeb7c37a6340610781627dcda1bc8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cfbdb0738ef0945ff03ea8e13f09f051ab549e9dc3a0885380920b99e35dfca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a900885d4c84a1680acae63d637cc705dc25de7fbd2cc4c5028fe37eb7d74143(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d1355672f5de510fa8891851c46a3e48c55a3a7ca6ddb316a59ad7d035815e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63285d845501b910ec0b0c146cd61f1ad7cea0a5c73a1150c12258d23e5cdd96(
    *,
    extract_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_jurisdiction: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_namespace: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname_claim: typing.Optional[builtins.str] = None,
    jurisdiction_claim: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    namespace_claim: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32d7d3d45880fbd2056eeacfe9b0546e0a99d3ebcd6d090c619d0bf42de8a687(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c0e23f925e8ba5b8e471193400ac6d419510e36c7566aee93c4244537f82b71(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6430a7bb3f2a12b2c6752b5abe78650c84adc4e96a6721b27e1aaaaf0748276(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df56ec2bd3635a0c201f144364dcde0c291ccd2fd66d3c3c6ed40c8169654ae9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0c55f0d5d8dcab2f237237820fee776d44911584577ff35ac9f449bfcd2c344(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c83c9e94a144ff7212ea8c85e1819f0fe699843a9c7b23ece62b433af32da203(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56056fbb8a43673edbd7d01585111f8e1dba65db6924a87266bb1ec734f02bcc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d32e57115625461ddc5b0b2dbf4b7c0245138461eac38516e289a18b2ea375(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c991173aa80cd53fdc7a2277ae313295ef66e8c4599417825ff345714ab66d57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__275a9d7f7c4b934c108729fc5ec7028311da0a8ae47e8082b895dd597d264dd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fbea1856c698e9dd52ee7524da47e96947b19a42fcf7acdac4c04b82c9db9da(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDcpRealTimeAuth],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b2a85d48028dc6183310a690bc2b299713a89a6438032078aa29cf81a9229a9(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f61c72986963d0f109dca81746b2247a9d7d24c17ef35c081a738dd15db7729(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3348405011531ff26cce3d8837e207016ed08b3a20c8e4ce95b8e9c0eb94e33(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33489f0173af581bda5fbc8a823c4ec186d33e0791a74e6fd0ab7fe80b6a6074(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d1ba0a28cb21100c3ac4acedb960fa41ca4bab9e9df087947786f0a7ef33422(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f42aec63c6317d2f6071b6ed0130d22b1704cd98c6a374a398ccb83e90d36d61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f5b7cfe7cd74df13f6701c73fb78faa2a03f329b2c9d61ea160d588683d2201(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeliveryReceipt],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b4933a69d6aa735f58f8abdb8c697d65d0f380503ef08b0be7b08f8f46f835(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reason: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1fda297769dc7fb2631a194c5d308636ce2d78c00794431c558e49735e8d4e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40d71b5e0831315e47d95528fad93d5191a5bccc8bf9be2dafdaa82d5363b68(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4d4cff103831d35f8b6ef3e6171d50eab17950bd16062b31e09f5fc03d83977(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c4318ee4085676ccdd187495460e40ad07a571f79d8ebca30549345f1b615d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beed8ec4147b02cc5dfc09c291e06347fffb77ac32881f73a326dbe58f3159c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd853132308700a8a7a86b243ece7a65837828ac96f67545608321429198da4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e53742f7362a260784d7728702d36e1fcef3617fd56c0345fd951bb3c9fafa5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab683aaefed1cb4064043f9b5a4835677e34d1ebda5e584c3023a99c1873e119(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f721570016921412cc48d0c03be96a09d3b7791a1e4d631d84b274d5ff65783(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a83d9a1d1bb7d8d1a07e73622e7017e0edc0911b7117247a5ff048ceeb37279(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83122f96aae0a0f66fe2fda11f759624da70c10d2c7b00fe43b1d5a79a2f88f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca80ea8fe963e046632bfe6e56efc50cbb0be2a33daf510769cd216b85a378e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a52d4d5aadcf7932342b528c88253b62e7116544e2c1bf1c3134eb59124047ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16d16f6ccb64d1053be24639cdf0c0ae6558d776ce20c1ee2ea0481e0d42076(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDenyDirectFailoverAccess],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58f2c0c02d8be46f1cffcb82abd2810640ff702573a23baac8b74befb96e552(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c397e7475f89a457ae2bde3633f685fe751bf6679079eeb61860a0149bf23bc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6841272ced7031082aa633fd9ba69728e689c1b459ba08b93af3ccc52b2394cf(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbcf40f817c3111cb2c766315f10dc99d271efaceab812a26471a439e263ff27(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264cc801719eb9dd8450d3cda26098fbd9dd191f37f730b8247242d3b3b43871(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1506ef8c4d4ac10a44b73ddfebeae06839310ca68c4c782d0b6b360562aa5b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ea756e4d6b1c1190777c6e50a6135a16d02e35cc6538b4d937bec41a5287e6d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicCacheId],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d14a4d3304e3582bfa395c2889984ce53592a53f03283ee6d5f20364fa9ddf90(
    *,
    elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed4c478a8f5ea8327f0508211c902ed4eca3ab69bb12ea60aa192b87d0c39766(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078d3b2f9b60eb947c395f81e3a91e18aa58b6ebe409ba4794ba39d4da7a6cdd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a49ac659a66934bf78530620999be9ea8d82d4b5c65304d20e66a9670717df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a687115457e9dfb905ca7acffff3f17f4b2809baaf99ed3a889d0fbbf20b426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e630ad17e20a8df37cd91b4012b5cdc2b6b14497d9fe0ce66bcf30ded1efcd11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d00b9e26ddf738225af3556291a7688fc8c8958c48e9242c813a71e82d521fbd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDeviceCharacteristicHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4ee04db3ddbf72d3174d76bc5730f4edf4c005406518efdec76de39b2566e40(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef7a610c06c7c41bdc34408ba4e3ba12cfcce03a950d3ea70c012f42ef907736(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25d857ef55c850ff61eae21d41f8e48b3290f588fee6fed6512f926a85160d56(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6ff2cab6e85a9477fa7de6a94558b43abca6c8c510ba86e9bb92c92f0ad312(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce2afdede3c65de6df38037574b1a47abcc04ec701eb44a3ac118104f2d9f8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__697c03b3d63a597a7504048f019fdfa1704434be6c95c30b55d39cbc4e28f0d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65ac967fc07e49543382196a9603788f54b7553393a14b431c059e84ebd42d89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e8a573ace3717a2b342ef20ab5c996233e282fd46954b9493a1c7b28bf8079c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsAsyncRefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4eb0f105b13713cfdec65a15c6fd8b3464ad2dc583ec43a5601f0bfeda1795(
    *,
    delay: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe47582364d19764e01aae8bff622c0569773a6684a0e37bd51677f922443c0b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365f3efff94525fc7cea8255179055debc8bcf04001f0dbc335ddc0fd0511beb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a618f2c2971fbf5f66508b2453ee465ca59104e7e9096c74dfcee4a69cef2fb3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d5794dbbb9d83f83e5b9c6a6de83d99bf7b76bc598ab8d87f001f742d1468d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8146e433f4375b0b2e2b994ca506e898008933fc10427d46ab36d148a7b43406(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e2406c6acb8bb4d7e1fcfd2bb293b1464092b1e8dbe9147e4d969f5ba5150f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bc1787295767b194aac68e6c3307f6aa16656d381c31900c5aeb7d003567fc5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b2723f67ce2cfb18b665814bcd826514e9213434d6e195d4fc4263748a08a79(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDnsPrefresh],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9cc5cb4190d43f93255af923c1b4212badf2a2dea167fdf06d68d8afbae94ee(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4d9bbbd2abfc0b9ad500469590ab0bb2b4b8d16e8d145a78a7ec5d5bb4c0748(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e90924ea926bc77d33d9fcc6bc2cf4c37379f21beca5444d7e55058c2d02af60(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__264cf4ecf4cb8e5b5a098c1adfdaa2c4739c6376d81aed81f80265131e1cb930(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efe92cc8402b5894138e09da144015d73da28eedb42a63baab97137e7dd2d81f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4620975d8d95ceac2679d7d2c1e5ac38a3e4754d7793b52a212d12dd6adf174c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94c1553cb33cc0f5f6e9fe4f0f4dfda1c4a70d0c3c79a5b97ff40a03e450630b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDowngradeProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdaaa220e4ea1ab3fc33e337f08c3d5afc029e910aff38bfb0105b87aadef9e0(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f751fbaa176e4a71d5a849e7c82c3e8364d3d228a4c898f44b30a63a98a70bf5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92796c75d656ae2ef3182c7b6ee269220e404191148b61fad76b0850672c5313(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e3cf8da4f377bde367f700b120f88f186e80b12c000582f358d560418b3d760(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53b1e1fbe46f0037179f670f4b985bbe75c628af8f4c9b2d375fe503bcc57b55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de5b7da1da7398b365ac411867b0424c80b0dc856a5b0ef1414443cb80bbc31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8824e47aa6810e617a153e1aa136431847f65063f8e5900e466f9c23dd69b6cf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadCompleteMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80058994f07b5dc4a1104040dee7c588e4a4307965b6373f26f6a43f84a34a02(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c4f750efe63bb09fc5566a921dd53c41970333b7835664dd9657c29a28d1d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9823a2bd5db936ee51b2d0f3df633228e3794b79b5baa48c1feec63fcff2fd94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f76ebcf6a903d7aa1fec02f37491f1bc5700f1a71ae4a96cf5823b6a9441e7e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f9c0ece340bc30ea022de89cd5567441bd0f71a1759bc847040bfbc8a26c550(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bf1dede66e34a291eaa59c2519bb6e0fe2ceb54e1bf0ed1e95ef87f72ecfb32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ddfef0730020e0de9545c6896015d80d415f362389cae807f2f9f09bdca1372(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownloadNotification],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55a7f4b741d6a6fea807978f47aa68915ed419d627ef47f99caf6d91ff19c01(
    *,
    allow_behavior: typing.Optional[builtins.str] = None,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    send_headers: typing.Optional[builtins.str] = None,
    send_private: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    ttl: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63c0910a181e179b1d542e7c44a6a4e08bf8cdeae61f275e691441bba24f8ede(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ed9cd01fa0ddf9bc0f682eafabfae4845079781a40471690a3f04a5b5f1ce6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef67c7e7315853b587839baec91462d21b1b479e8132c1027ec4a0422f7393f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad154af65362b9fe37fdbd3e9798edfbdcb26f39feb05b4f5ad78ba40de8ed7f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c77f960f334e88a1709cbb3270e1e9c697d6d9347b3e85dde9fcfdaed33f7b70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__150796f5f49f727b2d213ed67e909882042266c3799527226a14cf6dc58a282b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96eeace99890146a55b9c2e2d4874e3556a8ccbec5994103f11a75118dc5dfc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd703e9b16d60a9a8ddc46c8d2e4f0e653149dff6b358d0a27e7031020f76be6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c3d265422f13ce79dc9ba406525e98b2db20ade81a8558b730d247f80bb93f2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b156eb1f19a3d4648cc6d85146846f70ace28972cd6398a324c748988600869(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDownstreamCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__677415cae9b133f0499d35a46eb096f73afb98b714fc63fcb7a0e3e630c27794(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ce645b22f1cfffa18ed62f73b6c67359703dbb34363051575699ed4ecaac50(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09fdbcaccb7b012cf91178ffa25bcb7c9a7953fc024eeca1dc771f732160b631(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3e928d99106b8d2fadb857c9ce85650806f0f330f8488776ddfc30cb325d5cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14936c21088b83d952e83be04eb793af98f564840ae5b52592f278f82abf7fd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3505da1b8906d6c46899a06f676480e57345c5a96bde7a6c744cd09b26dc13fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b53a3ad7fd1a9352240702f3a4f6e2832f3a1bdd6af3db8a6747e32d6f48a9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d2601da929c28f5041fe12ab48d113adfa91c84910a02dced85fe632e1456e8(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    throughput: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7c4a013f929e5baeae0dc15f8744f2fd845dc16443c3926e62446fc5b887330(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffffe735bc3f0be15b265b9cbb5336854eb270a52d8a44ec41006c2a1d43b8bd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfdde72e2358c3ab98601de496055a2fe0341b4c77929f5e1388ee27eba12d74(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70ff19cd56192f5939b329be24084ba9b6faa6eab0492a4f3c7c0b626cdcfed5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__483244c1415c70e4be61c897dd018497207c74f5d8e0f46a590f9998723a6c83(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b65394fbe3c54c2601275405a3a1b810b47aad3691ff5082c9a38a0aab548696(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicThroughtputOptimizationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1e99d2f1311b09b318f521d9a18940fa2c1aed750d5ac854fe2cfe01c5deb60(
    *,
    image_compression: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    real_user_monitoring: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    sure_route: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f623b75fa09ed0c728fe5d698c7481ba1ae839945ca3eceb00ebba07c8cbec9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__274c56cb58faf069ab0bc56ede0f3aee056b6a7b4ba06d4584b9a5e957a8d512(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89667fe8e9b290740a23270255576990fadac79839439cf1e5e3293c2f3937fd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__930b92d3bba068363a2c1901c3e8bdd41d87b7adc285198d51658cb611122ae2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c407f3b15cde37e77c4271978df2ff4dc34b5f5153e10532ae7da1dc2244a969(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaa634a7815f2a675130223323969d1dc1d2b4d526ee95c0d7254bec9db4f4c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cddc927a3116e143297dd82d658714cb5fb6c16234701634306c45e62dc37621(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a979c6f39d58a0d8f1041b03a87cd7c7271efdc6e1a58b425fc75545726380(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784e3fea6f1cac8d9984c0281638b7d0d3538669d8233ef5c3bbd43a4c67aab0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorDynamicWebContent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__967961039ac4f0dcb226612104c76bc13628f29f8ea25417ca0c45e77980ad12(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67965f4169ac6356e6a072b004228df0e9a3671bf54a51c3263247eccc8381b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71c4461b106a1c46ac120f187a725a2e3e74e2b01f7a40e7ce64ff2f86470004(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cf9f1e7857d8a95bbcbc9306ae6b6d3b255ebcf4278daebc44aa7c662959133(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f92562983bb35d5dc57dde9459a1c67363dd49eca1be5010cee73ad7784ca0b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de849068aa81d7ee2414f8e4c5c98502241e4e66e0f6e967b191ed897fa5856(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0862b5a1869881d1cdb8ae8234f4dd609234a18c4de9335ac19dfa13ddfce57(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsBulkUpload],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b62b7bbcd4ecc7e2bd75fcd6a0967db0fa23bdf2db796978f6d59e3d20d8fe52(
    *,
    database: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ee2cd80f3438edfb0066e074cd2da67e695185a3688c59e0a8825c17f7a5cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42051d839c1cb8e22f3fac5135eb3274fb4354e1754236d8fbba5bd17cffc5fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__730639e8a1c8413dc0a5c454d04988383f5211094811997dae262bae5fb6ce2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661767a4d7e5fa3994f2d85ba172b85e19ff8a17a634327c5b0171f37a027ce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cf303e4fadd094f9d1196160335f8905f36421bb5fa3e0458fc682905ee9481(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddaf106e25bd4a5582390ba625e563078abbcd9736a107073770652ff1f6764a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5460acf2bd3233df43fe563a16039e45c09d378ea759842414ba65d8cc7ba64d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2b16be7a520516f200deb18cd9e8229fece674003ca86c722f01f39564a9710(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e69794c2e9e39dd11bbcfd3471fc793cb5386a212c40adf65b048c384dd756d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8df4a8fb0c214e285fbf1a9a799e7d6dd96f63103b3372ae76356759bb64e5ce(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDatabase],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bde58ff9210a03b705e2938699f37353a5e437652a1272c622bc6fc446dccd94(
    *,
    dataset: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex_pattern: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78baabd60bd19395f19080ab30b088f9c8609f2a8ba96beec00e051c76160352(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8bd088a33aa9bea1d18886353b492fe3657d02ee30f13b56fb8560457606b1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1869672a762902762fff20cf240a29cdeed3bf3a4cf0df748ebfa7757e7989f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31646e23c0168ba62826da5bd3de5dcab9b79a3936cce660b45c6150deaed989(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e285b2c6abc3c9013a30727f911fb77a8343b245a7178bb3ad09a21889a515(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__759e86582d50529242f770e3b48350f6bbc77592163d88aad97e366cf869e2fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a76e896bbd90a29a53b5221c623e1a5b53df01e6e846c2cf871c31a445dc056(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63eb3bfc60a5aa1aecbfbb4004ffb3215a3ed4c9a5f51a2b6d6d9418efb05775(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891972938def4d3116c46c78144a104d1ab680a14f6525359d294a1e04b651ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6e1c398f540c4a7c24058721af3d87f3ba17d86955ca1033b86436b9858b013(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsDataset],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2800517951b18eeea4d9e55c781ef4500f5af184285d5e664e54883dddce9b3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73381d39e2f9dca04af8c4cea2d08cfb5989191296859cddead863acc7bc79de(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2459462a2f339724acbbf544524c0f758eca538bee6f62b4ca012189840d2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__891dbaf7c812c5c02bfe22e79313b6b012f005c7ac12768d4629026b9bb6afc1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd4337ac2b12e8fd0f654b2fc902cad80c47e1cade2aee5febc1d59531365e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbfbb936d301cd2022ebe7cff14c51fd3c8bec81448a1d1b6ea7abb9394e9332(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14318d6df4566abe78d967680477ff40a99c7cef0870f885de10158a35f7b79f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEcmsObjectKey],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a8f27f86bf5672abc616598735354f7b4d4a0ffd3fad196c1c852a43399656e(
    *,
    aggregate_lines: typing.Optional[builtins.str] = None,
    aggregate_size: typing.Optional[builtins.str] = None,
    aggregate_time: typing.Optional[builtins.str] = None,
    api_connector: typing.Optional[builtins.str] = None,
    api_data_elements: typing.Optional[typing.Sequence[builtins.str]] = None,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_aggregate_settings: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3724b2ff04ed862bc99d4958131ae44d7d17b373c97a26ef2250256bf82b1ba6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be511be8fa940a0667af5d95e416b49b27704abec7cc2f761e55346ff449bd9c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92bc71a24aedbce8600386cc21fe640975c13f50d7d0db4771880f0d00cb784a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7baacc86f38b7d9c6c348588046bd152f0fa2894a0db4c512505a5446627665(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41b1a797b18efb9b6614d8f0dfd7bc485291b06131c8311c29d4ba1009bf8d30(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ad34d44a04441c04e343c094d099dc89852b4e666eb842374a884de3e636df(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f629e03462b3b9a331dd1578e4cf09fc123fc424d70f073ffdd7f90c1c6289f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcb272e3ee3ee6ccf9041a2c4cb32a97f3d14a85d8e64145625c0f5df131036a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e708a58a452500559901e623b1caec7c01b210d8f1fdad3f7c91fce09ad6e78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__540bd1934bff0874a7be55de186678b4b07473bcac141703e7a18790e2ffc3b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a17ef9e557b0dae18d5c6f0884683f54ec50d704258ebc98de2c9e3f54c66f78(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07a7fa1b0cb02732269196788c338449c9dfc71c48cb57372f317fd9639a3c2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66d359041b78facbe818c07d1c62d65e765cd8eb4aff62fcf5207835ba64036(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb85b8ccab07564784c7eaa2c894ac1e98d0679994afb0e8ab5ce48d43ba10f4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeConnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc7da95f53a71ed24017c4f8570ff8740285bb2dc7cf2d4b9b422e4427f6ed9(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4aad7265995d0d15348d7d053d6a4a5a3db7970350f2499eafaab9c9d907e6ad(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf83af430a82fe1f793b5b0daa7c29f4925a8d1e25a0af25d50538e0dd3b47a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3239f17b20709be5a800e5fcaafb9fa882b2c229362d0fa09eeccef3391d8013(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b4bb3431fb6f9c419e51820a3b6837cc56f0555cb77cead4807427529637a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10eaaa41dd088ff25f637b25f46b5c7ab1d93542b648ae2185de96680b9051ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f837b0782a4cd0bd2f85e4871b58dfff39cf935240e8b0e242139b77b9285e7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be25788cc77084cdab17f61b8fc8be216ba726820f37cb2fa38ca5cb49897aa(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b801ec7c1e27982a4cf4a6f650a949f413b25f22691bd92d092a707f4c5231b(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_rules: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    ip: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad9fec87c0b0d37405b8762a744727ca6fab2a44af7efbb0c34262e13b37a96f(
    *,
    absolute_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    context_root: typing.Optional[builtins.str] = None,
    failover_hostname: typing.Optional[builtins.str] = None,
    modify_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override_hostname: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ac563f0f58c63258b75b0f95b268eb5e6e99b34eecf7b4b32ba98e6d0187bed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3dc7d975136fa3e0586eb434e15b3a4b133b49d7e9b714f1141216866909abf7(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc6aeadcf9b788e1b695bdbc34f4b6e0ceb56d438a6f326b238d916b1d30e255(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b6345091573bc76ce5906eab3a9788b8ef7bf39703b0fb29d1a4f9e8ac84b28(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3fb1c9d026f6821d0dd586c83a71de928fcf7af12d90177f5ee1e6a068f5f3c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__68b707477b21abbb6d2f2cf90334e36fe38db1ed1591bbcd5b940308d3bd694d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c875159bc713849f0cbf96b6d46b2850808a05b6a44139e4c95981e1aa5f094e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a57b5702365d54f7000c3b177903b9c5508ebc10c90580476b0bf4194d746d3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7563fac2512d4f25db549e3f248fe71020f678e8c5033d75a97ad044443f4d9d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e84920ea37bcb6ab128faaa030573b04ebf3d29cb4efd95cf4452054c62bc266(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4038111df9f0e726fc3fb27956868e29b4d754be4d6d7d101babb6f41e46a270(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69cd3f5aec4d08c290e9b6846b0c8a42e684ce266e25199ed50abb4fbbdc580c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e8a26719cd0a923a5d9a5f014bf1077a8e00020cbc68bf533a363f0d4cc4cdd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65b948ee512fcd37c0cd0cb88b3ed5c7df14d82396486c2329fde27461dfdd95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeaa82cc660771140bee9067dc27163095044312a99b30f332f07a9c05aec867(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenterFailoverRules, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0acc23f7e452ad2fc2d891affb217f844a15f42f9926d5b423410385fc324f7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de2eec43949be69b2c7c92882505dddd291700c31a3719aacc370cff0ed6de5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b8f3787357de0ba01515a0ccad25319a09d945957df039bd2e4b5997f62947(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67ab505cd63e054c75f594c1ee5af953a3b79dbef2fb5abb9a471cc86faf9f5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ba1514b800d2ed8d249b5d19bfd6e30c47213a02483070af5b98356e156635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7da8afe8a42e383bc8736793af8e975d16be66d71b9cbeff68e6eb78e009f9ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8643a9e49c54eb363a067f1504e9270df171fef173738db99bb4023b1952660d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__448ce3940125fffe5af58f9777b347c1940fb2ccfd9015f8807cdf44ffd6e15d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fccac880171c54a583e2c0f99f3b20ed7d169d41cbe11948e09a866c6547eac5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb9b58ffca707c84bac86335b6d5cc7a08ff5eb0bbffbfef548c03f02ab59bc2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28ec5942715c0260a9fa9f635d73b5ae11cf0a4a866ed2ad1b460074efa6718(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingDataCenter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc863a80716a90ed8f4eb5d0b97ab24afe1b03cf55b965c44056d1710df405cf(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    enable_session_persistence: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hostname: typing.Optional[builtins.str] = None,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_persistence_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18792a0db6f7d8edf47d9ce3a3cded1afc2b19034dfb28af0f750f51c0aed923(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e61dfed1fca3724bb2b9f064a95f9b14c5e20a1812709511f405a46ffd924b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19fcd65bd0244f4e08841cd7f4d1a38fd05f7ed9244517382ac8b98d9fefeb5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70d5aceb491d2a07cd81f474845f131368dbb5106ce27761390534723f10990b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e94cddeb4071658e72a2fd35f8908348374cb1ba6b8c894ec113caa839e8bfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17948b0a43974c30d2b9d8ae91c6793c0b3d9284417093c968466a1f034c2a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d07dfb6531014b6072dfa3d8943ed8ef0530cdf185a10e9c852f21631098d90c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a8e551544b0e234c93020397a9bd29fcf359190ef7e336e1983121d039bb02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3fd94d3a06c01593febb0c655c392035fd798f2f7539e60260423cf99a74e88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a457cfc425adac1219b350d027472738378650b3954eb80a98203aaa0229036(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e3d4619e4e21edade60f5a81525b7d1e5462ffd4de920c72ae4aefa594964a9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeLoadBalancingOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bd415f9cdebd214e3a8a95a7a7be59825ed8392bbf57acfb25ec589ffd6b511(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    domain: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2440f8eac7360f8f2705b6378fa82035d88395047d98bbbcb07f23e32c4d059a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b7d2a0bd437abf72cb93862299344da7a585b3f6fc2f8bd73324d56ab023aac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b48deef7ac28238dd7c22a60aba6b6d5bd124fccc9fbc5e4dad39fddecf1828(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22e9d018fae4995e75371d251c487333d86249bda9f68168504ba72c46d9798e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc3bdddae46e4e5bb82d27a7dfec7830e2bfaf99dc316c9f3b3fcf25b68c9fe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549c783952ba4cfd3e7d1a9a9287b89ddeaa16aad0bdf73b6fb59e94b31b8ec6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa8cc184a0d1c910cee5b8989df51e3d843877980c78289602456feec27cc207(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a24ec09a9a938be7b5339a5c74084c3b0788e303caca9d51ea12ad58b1dc7903(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8ff1a66e1dc5a0a6899562ce5c0066844a40d351a37f07c6c83e0951d445298(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeOriginAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9bad4e16d2c349ccd9dab43e07c445a99404787ec8ca5963f775e930e6a48a(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__375419442d3ef4715a4f44b518ec45f4bf3dbde2069877d30206b7c562b5fe0b(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__771ca77b5b7d11ca139d07f7f51113f5954bc22928032bd74378667022ddf9e4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08b0137acb1ce57b1d5752f3fb7c5e3d77373d28036f2fae32535e2a3c3e1b6f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ae5494c49f5d0b33a1e5da7d5604fc75c184eff3ebe7e560faf45f61d851c24(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83747136a8a199d1f2cdd4c890c4662c428840a956eb073a27f7da2ddab73373(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirectorCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0a72fe5bd1264780298288f4ba283aaa640cd082b14bd0eba80fe26c0575e55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da7b8248ec9ef4f176637363e15ec08cbb33715815713c8043037f512b490882(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a245f2b42cd5c81f885775de9722ecd0ad19a7815972e92cc9682514aa7774c2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b2498c47f9a7d7eb345a645a8605134afe2e44a740c1df500cf43431f32ff9b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4274db55ad49e1e3878cea9b53f26d09268fc53d961b937f73a4bf6500b2864e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee4fd9232573426c1d72e3ead00602d58c6bafbd8ee227fe799f7d6fba58c0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b0ef1bea263173cc93c7662fb0e507f36a80c04ea08ca6146f10962e94a169(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94748bf7376f3af9133b982064e46c5b19d31a39a9e4708d656d62ce982da1e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeRedirector],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a0c626f52337a7005b03da4bc39d0f1ef422ed669524e3c6a9fe03f417b1009(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdfe4da01c3284cfbafe6852c9ed32029c4cb8fac089cf48b5f5f41797956c53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6c80cb1b7b6fa5d6c3db79e55732a7e3e31f9587459fb57c7b6a3c2f4f9170(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd3bf3707ad112f881978db4957371442f738589bc39a5c8e938dd9eba3b1521(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198437edde8c6042f795044df0a729c6cd4f3c27b1c038696418e1ae072a4c70(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2af3f49b0aa6f1134d4efff835dc53c5fd72e2a71e4031ae7df5390b52d2f81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4dff7be4a62150e47d0fc2c38a4d2f3d0bfd91082419d74822b1d7597798760(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeScape],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__549cbd107a664ef96cd175202998e0f5cb929fb2142c571ad0ad2e0b86f2cf75(
    *,
    detect_injection: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_via_http: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    i18_n_charset: typing.Optional[typing.Sequence[builtins.str]] = None,
    i18_n_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pass_set_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13aed92e64d73ac26029d3e01e938f234308389ecd6fa37d24be92ed023b107(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc536288c62917f8b0bd6c5649cef669ac8396601f7c974efc824b171ea4c33d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3db762d56535fa4d11a027539baf8b509d2f503fc1903a7db18aa290aa445f44(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581c29190590a8d650443766b65d44e67fa860d016a7e79acc5ebc82b813ea48(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a5d9916d627cbce92d46e34ce80750fe94bbe9bcb1f2b4553be32529c8bc54c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5f32e378a7b4af9f6a8d712fa6f26a9e333959796e7f61e241525b044adba1f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d11870402383098dcc88c74e094746fd37b496f4d9eb76fc4ba16c4b51a43412(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c970cb29dea145a65c267b24596fde7f27f08e8b7a490f54497886542045babf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d395ba3f882a5ee8a0f66a3fd555e01b7f9b64cc8b824ca097f294dece8c48e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71ad869d80c1c9a7999adf251a4702296daaa8a1b19c21c7b9eb0d3a526fe1c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc9cb1633c792ea316e4188fdd3bd7574f47b616aa70904839dcc7cc5dd5d12c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e037c1201b191fbb08a017e4cf2effa729c7369e93abda0fa1161ebf19004918(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeSideIncludes],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180a6fdb610da09c6030ad1273745c62eae9b107be5b954e54a48e178d32df17(
    *,
    create_edge_worker: typing.Optional[builtins.str] = None,
    edge_worker_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    m_pulse: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    m_pulse_information: typing.Optional[builtins.str] = None,
    resource_tier: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c09b6f86552c25db7f47e4c5b1196ff9b95c0896f407d58ba82a5343bf6f0a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c41dd0ce6c926d4dcd71a641d1155646653a8f85b89c7c0832f00f346a21fa31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af825e8ec71a7a289a0119d62c9c2bea88b194f47ec1b280195e873dfce802d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af94c62d38dd6afbebcf6a01d591b0a2c68909c1bfbe35ea71cc15f7a853aae6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f1efe3bd7dc8369be344b7afc2267196d1ca8bfac4c17d99d077cdd977be492(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33a202b077a69c2456457ccc9d8f47944647f0e34ac20b18081f2f457fb40323(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aaaf0aa12198a23640f62272969260b3c6e11e2253b3921e3874192bdc30d52d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__656ebdec99fdf7026b745c7c75a843775d6e0dd8dc7777428b580c831f47ac8c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a47157d28542c0eb52c41fb59ca7d4e41ae4946b8b854b985e649aa2616b9e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39023327a12126fa6474689f1cc56ee3bd43f49ec8fb46e5cce14a531458d091(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6930c9cac84e055b1b12085381ddad79cf88e47d3d89004a07ef546edb0eefd9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEdgeWorker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01c010ba99422f66ae1ff01f91ee4c99c3d5ed70b2e8a44726c672073ac5f35c(
    *,
    certificate_authority_set: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_auth_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_deny_request: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ocsp_status: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c1f327e736b8bee52770e1f1e470495c70e2d8a57c86ba1f1fe9feacfd0eeb2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f76185fc12fffeea09dda2726cbeebc4c6853513bcdbc0c3fd1433d4a2790f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761a81c7bedb95a0ec69d5af1d1181c3904d041384717ef45c98967e6f1a179b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__663ad964161f28a9dc5a20feeed5ad5bb8cdf6fd6540af881a5b15167053b295(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebc40b1e858d2bbf1a8a7cdbdb4d52a2c72e32989f9477bab6441b880a981e29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__761128a153600b9979957a62a4c36a9cf172f5542c8e77e056bab425393a2bfe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e08c3a3b152c543c6a42acaf15a93108c29e4fc88619f056d906ceb21d140ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d3e456ab88889ee7b3d118713bec4bf1ae15ea8da75884599e973680687f627(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a6466303eb19f80c09f43bf552c1d97d53682366437c9c87fae378d0baf37d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnforceMtlsSettings],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12bab2c80fed15ed079e8ebf9bedefc0673ee25be2f65ae7f324b0f52057e3a2(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03a49c98bed1ed036a14a5c755c00adeb0b5212b09a77d140f292eed4fe22e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1949b0c6fb6045a4645d1449084ea0d2b1a416dce0ed896bf0f1d1de856edee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c7185c4650dee24fafc9c6508128e515887090e1636236dc53a3f4bcc6d1ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c51464e5c3d7ddc6cf1d92f2dfce97cb97838717bea75c18543c5e3c44801e65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5b1d2f5ca1fd69d77c245cd19caba4dd77eb9cc7a20092e095818c333970e20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b9619abcb2d2cb68aae9376d06c06e2e12896f046b3a24d6dccc558a7100664(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedAkamaiProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3701bffb2f30ebcfe93ea44cbc3340db429d49355e32abc935e90bd04c63ccba(
    *,
    anonymous_vpn: typing.Optional[builtins.str] = None,
    best_practice_action: typing.Optional[builtins.str] = None,
    best_practice_redirecturl: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_anonymous_vpn_action: typing.Optional[builtins.str] = None,
    detect_anonymous_vpn_redirecturl: typing.Optional[builtins.str] = None,
    detect_hosting_provider: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_hosting_provider_action: typing.Optional[builtins.str] = None,
    detect_hosting_provider_redirecturl: typing.Optional[builtins.str] = None,
    detect_public_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_public_proxy_action: typing.Optional[builtins.str] = None,
    detect_public_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_residential_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_residential_proxy_action: typing.Optional[builtins.str] = None,
    detect_residential_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_smart_dns_proxy_action: typing.Optional[builtins.str] = None,
    detect_smart_dns_proxy_redirecturl: typing.Optional[builtins.str] = None,
    detect_tor_exit_node: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_tor_exit_node_action: typing.Optional[builtins.str] = None,
    detect_tor_exit_node_redirecturl: typing.Optional[builtins.str] = None,
    detect_vpn_data_center: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_vpn_data_center_action: typing.Optional[builtins.str] = None,
    detect_vpn_data_center_redirecturl: typing.Optional[builtins.str] = None,
    enable_configuration_mode: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_header_enrichment: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hosting_provider: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    public_proxy: typing.Optional[builtins.str] = None,
    residential_proxy: typing.Optional[builtins.str] = None,
    smart_dns_proxy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tor_exit_node: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    vpn_data_center: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7869a4574ec186d0ed93fedf012459004c92607a3b0e95472d01998e74c79110(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44b99931efee966e6c2cf2f43236c390c6c8974fb925537607cc24eaf920571d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e38de6fdb49cea2cbb5e8f163bfa791b76853382e8f56b5ef1109191cf36612(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b399f00089f2b89b7fa8afcf734e1d5ad5ec210d764e65b1ecdccf060d62a247(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__723f1475c3599e574c6cfd47e4965f177eca044fddf7aebee21e1434defd0fff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be21ea5a89b28ed83120765deb8b21f4f5fffd8981266816b5eb9b82656c5900(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93cfaa0dc165e823bcecc6a9ab283f4582f1c7e2c78f58315cfecf180c9485d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66e61a4d551400f18a8cc142e6c516bc73c7eabea59641cec0d5923dcff9e392(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__45d185cc186654f3f70798688b42e364f5da8b3e5e6ff576460847bf63f50798(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__711d265873a8b951f85c40d7e155366daabd65e38eacc52519471a75f2073c17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1f3f72692d7275739d280741e0f0b1797e4f5ed38d038d46b3a9d29f916a624(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1a4a0a929ed796df0245fa9228754204f3d1bddb3867a0fbf2983a19fe0248c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83a26e09e250fba1b20f08005f7c4b1332a48b7c1f9debe5ab2d86128e9f6708(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2530ac742b2afaf7a2e9da74eae193125247a97bbffff348a3f59cee23ca81b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__559f7be471d6f4730e17e36d8bd357418de61f163b274f03f160aeb85fb0766a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b347b99ceb2336e01e073639faa1b50e806a094923d6a62fa5286e69eac85b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd152fb9e9b1515defd06c6fc63d28953852e25aaf4c409d5e786ef5578f437b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9154dc49d10dbb934066a85e58460b25eca2be90c746b3fee0e29854506afdeb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__923e9b874777044ec1b2b511686d651842add2e2ee97fc634a22241dde54b338(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4266c60aee9fcea8cb693e16c59e42c42ba6ae801198ddb16cf0cb081259c1a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577c6efdd723151865d0fde162403734a1cafbc210bca3fe56dbe553964b267e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d4f7c46e31f3cd1aea46631c16a7e0ff6a7b8ade33635f61770356219860736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c7a07b5090c2bcc9bca4d0af00c6f48de4409c8a5360253e6641bf2af3783d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fb75af41941810f2c643b785a4c745f6b4c09ea7a45ef02351eaa525f6c0bb6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eee1a7fa4495211ed09dd849f95ed50c082c6d6f2c58683a3a36a20bd1ea6fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3938ac4be31aaaeeea570dc63ee89f43e80e291c0fe68b9310b46ab4a1d9b29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc54e990f6ef24f7e5f21cb22dffd3b53fa62a7831c8af005c4e7f4422d4e28d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c168b40ece3c82d6b5a3ef7040e20b0118e472119c350fb04022b0abbe43a4d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f55c4a2a55752c4063921e326b567a51ee4c63394bdd5626a3f64f9e79f530a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca27a0b4dd41223610ddfb29904a07099ccb9ea8192bbc9e951bee3b796cfa50(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2143642ac75b30375e4c6e9f57d61a37e0e676eff71be349d4bb83cb1ecd89d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac32aa41df9c8ad825eb69605cd38f259028bf3cd5506f3a238746d28f1fd999(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36d815d8d01c3c2560e0b9db655557900314922ddf22ec1c7e13c88dcb1f7fb2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1706693efcc4d5629ba7cb92a4c6fb9311d0abd8070d7977b1666e309b2ecc8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f84eb43c90c74724bb90816618de6f204d7f2ea7c7316e787df41c384a07daf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f70c0bb279fa3f38378d1918f343a214f6aad0f2b8013522d9a19b47d79f818(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edd00706c894afc0f6b0435ea6bea5ccf170587ae93537ec56ff12b07cc8c617(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b84bb0c6307a22c6c67d6e5d995f337896b96c6170cf33ef8792fb567142256(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEnhancedProxyDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bc829060a0ea269038ef53e280de64f9f26af563df6953f9b463c760259ce61(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66884955d024094bcbaed2db9b1fce2ed56047d4fc26eba71a4dff7ec480c7f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3eb41a7160c005a5e109abef0e7c5ead6e89c367c37658ec164a1c92f0d42bd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4c62af3c18c3636c28d709f21c1d19141293cd7413d532c02899d7ca64fbc52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc2a9c7a722051adbb5f8c3d6dae1fc55ea3b04d0c82d56e62a44b324fed1e60(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ece661f810acbf3e6c768a8b878a4a7576b85ad82ec8da64fff846f3f11b023(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36185b05c3c097fc4f33b44e0751eec21bf8a33a4be35e66160e877f488b2924(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorEpdForwardHeaderEnrichment],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cf5989ba12ede946b228ae7549984dc342d435dfa66d11c9b129d2cdbbca627(
    *,
    action_type: typing.Optional[builtins.str] = None,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cex_hostname: typing.Optional[builtins.str] = None,
    cex_path: typing.Optional[builtins.str] = None,
    content_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_hostname: typing.Optional[builtins.str] = None,
    content_path: typing.Optional[builtins.str] = None,
    cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    dynamic_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_method: typing.Optional[builtins.str] = None,
    dynamic_path: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage_hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    net_storage_path: typing.Optional[builtins.str] = None,
    preserve_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    protocol: typing.Optional[builtins.str] = None,
    redirect_custom_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_hostname: typing.Optional[builtins.str] = None,
    redirect_hostname_type: typing.Optional[builtins.str] = None,
    redirect_method: typing.Optional[jsii.Number] = None,
    redirect_path: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cefc850170ee7b415417c2d7bef7bd1bc94622841b4c186595cac54764536db(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__710e66f29febeb5ae4e73e344e603b6d7ee594823edc79da57fa0ab1d14775ac(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94cebb8833b97db9ca8faaacacf9a010b9ef1b433b5f5ee1e33c01f97f3ded3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6c8689ff0c0827d8380f40688bccb0565599d1a086939572e47cfd4b3e88e17(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6d666e8eea2a8a25f8bd2a1939e1b7e138785d0246a5970f2ee1fca31c69c4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97262b1aeb0d227d78aebda3e1a669172f02460476152e0ce2b9c3d8d5764b8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b9ce65936c29ae7be58ebf975918efe3aefefe171d33d9791b370d4def6bbe6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc40fe3f87311641130eb4ad522b144206bd899ea403ffe50fc45115f6aa7d02(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216f93f89b7fc2ef430deb1316a653788e5c361da6224cc179ad09c1e6a0937d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5712da6215949699aedc3ed82bfa2a40cf59f1e65ce0ed134b66f2ff739436ae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2337d3f3d78995f8f4dc3b205626efab4cc796233e73415dd99e29f227425c9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80b20532c7b41a265c0879474d22765e01988290734463967de4acb8b2d31c29(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21b38ac2184b89faf19567f4edd03c334b84e8337993a47b28e2c74eebf86db6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f97056046f359fbbfc6c90c0c37849d07fd2b811126630e5dbf56c8bdb0c7119(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c67f9601acfe694c9c58b30b960cdb7181e95d1968d92bd4b3a4ff01eeba2c5b(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311a213aa1bd4aa19e8a024ab8bf72c61eeef4648de7467d547db8f428b58df3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__485d3763746beaea5f5a082c670d598a86f4952912819f04acc55b4ffd33c4fc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c06b69f2b1a9ea823bb3b1b4155de82733bebdd72553cc68b43efed78bd88aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7110fa13b9adfd58a580f864459f3a4bb93412bc8b1772a6c964c45f8780f2c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed66df30c0a8ce9331cad678a3483093f98a35d2378dd0cfcd86e6e61dc842cd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailActionNetStorageHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376009e59e93b6891b8e9a6cbb970ed98b92fbbaf890c301f5d2c02d3de987f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__905b6897901fb79125de4b4ca61763247b9660056dbd51964cd14244523fc5c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a0e3b0b313885ea5bd6b70f85d9919a98642de74d11d5129c23bc9aed3cc83(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__769f8d95d9560cdcab094455f322caac866b0f1601f3c7dfb3d7ddb719acb426(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__453ea6253adda90a38c2f2b98fee5b74d6335d9381708be5cc002dfc9de6c7a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dcaa56c0f363361b309be50921589f125eceb897d89b2037997bac5b9fd0ab8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d89ba8718fce9347088aeae5537f5dc21f598e2f2a8b8f5e4e2befe9ed24e6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05826629a45a043a972876f0157a0c5e827e3a63a4ccf9c68e4ac5b559146394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a89fd5f8cbade2861c060639e78f80a9edf40bcefc067f250b81b7b970b59c13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e76b9ea35aed1215be8baacdf946584e1dcba91708f64d38bab07734468efa5a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162a19c9073a7090c2abc83f6dd203282df2527aefeb045a9050d5d9bd5ffb89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce81a15277d73777f396f9ff8aef53e28133e450e8c8732e8274f1079e136450(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43fcbe7c9c095b2284ca272b615ce2eaa8f5087ca6c7f6279e6acf94308ea21d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd9f518483c3f2ae404cae720e993afa95ca8127b6e98538103f52d0106dba81(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18ad6e642938f4cf6f2d0a5c3e880f8ceebf7dbb76805ebb77f00e3f9152e1ea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c89866bb0cac1f7bda48188ff83617a3198946edcd7bbb7d14b54406636307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d5d6177ade9beadba300b2bd34b4b75064016297a4da2f7d62c7fd5d3d8cc08(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__181662578da77278781eafc27b993d7028f8930682601fec1055aa46d9b7a78b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c10a861f7ebe9892ed1c014d709b816993c7490f0508d03bb3aee6d688ef15d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6a90af58c0dfd5619a422beacbaacb0ed12cd378ccb43ce09672928fa330385(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce508540b692516b5cdec85fd4827fb67408518b4c2a54c0a0f46632411e92cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__020abdaeb25cbb787c0efcab8e14f8f26c5d38709ff29c35ba0d697684434b87(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__045f1469a45eb351197e04f641afa0335554834ebcba76fbad9032793961d3e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a5567dc49c29475f070d47b63d445ad85fc51e1a6c991db4b9dc9321115049f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d0679c07981ac23306cf09191b9e242fb4b5c439b46071519bcb14e0965216(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0c9dca42433036548c70b2e679f43105da5dd27a4dd5844fa52d87f7c6c329f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a6d0bd0e4eb4171d157475430b3176947211fb64e973319e7870a4590e6a393(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ff287e3f9e465fb5e65e0e01c1a41ef89d513ef02fd7a2fa39266a13c59816c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628f176e7b305a0e148293aa53e8a4b080ba00c35f1342e099f0baf52cd58937(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f5b3636e505cd5a7f21442a80cb88d4c1a4aa4362cf8e83f860f962a13a5bf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9a120d81012c5c52e730f1aa0191b27eb15c8d20c85b40d6eb5ea506f7e1397(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b9cbc771e30e021e5d87a3342bf6ad1e552e9bf274b9878578cbff6257fc536(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ef35d14d62a6b96d14f603cd9dc38e29cfd8e3180f64504af908df67d3fc94f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__835ff272d1cbdc152da2344b3db6610b0e39688bb5a645c2a77fe4657457602c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d916791bd9f1bb343404a550bb54b074382cb84de94e6733b9176e4f57b18e5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailAction],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce37576b87dd57e7c8f32a641f6bef3a3933f77a5cdac283a9c074a051c97b31(
    *,
    compatibility: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d94a6ecd970279c7ccafe44f1656e7b1bf65725f9a03911926573d9d3493af8e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11f8d30b82a7e60343332e11fe18d31320350e021862b116ad66cfedcb7cc7ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__739b974750db73cffd4aae8f127d2c91ce4a35dcb171479d3ddc1a6adfbd7837(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b77ab9b6f589bbb25822a2dc83b3a58eb64710e0d9963382e3edac653c83520(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02c389f2b65d10fea29b3fd7a821bf87cf33b76cec1a6bb8dbcbb0f786fcf13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71a19bcd3b49dac107424919ff66cec77c6ef953e72b04dd78add2c0c2b5a0d3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFailoverBotManagerFeatureCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f72227e1a09e49dc628da0e2dc397d7d1ae73d0f77caef84e43d19b3a081ce4(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e381c66d1941953b0969e2a01e8e6cc790555470ee1ccc19e327b46f480a27f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a71590fd9dd078cb540014fb9eac5416849556461875267badf294b63cf971d4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6d182630174c19c69c2f5d61c730506f456b776725b1a7bbf5681f8a86b0756(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e39ed947b89ab71721b41dba01731d0048f50a17db9e01eef6916d05d39bbf9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef38caf0ed155fdde3d2451613b0ea461738af389c05245e816100bbbc8d705f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76d008d5f77642994b74745a0dfc2dbc92319ea8aa16d900cf957807bb5bd435(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFastInvalidate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9ff60b5c0efd6935f81ea783d94bb6b583a1e3fb6dbd7c3e22f81fb8d6fcafa(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f20f4f5f5cbfb69bd3ebceaaa82da45a4a3ff5da45a6d7934545c98a0c88ffc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecb89b7fc44ce86602ba7068fcd5ef1206f5c2055de89d1d9fbd5fd0e3f899fc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__992e0c542d4eebee10b5af9cba08f86431db37314a76e196fdf5f539bd70a0e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d92fc5d58aec4006633f34ac06cc5f136446b66407d981bf0bf01fc9095a420c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6be172157eb88071b9ab6557b29f5df643060d5d4e3d731dfe73b1119df80a86(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac85150147fe384be6aadfd1f9e37f10d7b83c1fd8715fbffb9e0dfd3d63705(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFips],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a30190b24e9953a9341603cd78f0c9e1e38aa9943c384bcda9d03b588eb99dd3(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12cef9ba4acef778680f66e8a3832e5c37eb62f059fa362a36f823d9f4c6c7d(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9734f655e0f53d93d7fe2cfc1a2e501a685d44c209394450654e3027588806e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cf840c93f59473034144fc1e51c8c3259807b56169a4c0a854779903e1e100b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31206dde591f1f1d811ee4af904cc20d9506524d14b2d0827b8e6e4c4a3f981e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be51e3c14f911b46f609461d762e080067d258f47f0fa76383eda30847de480b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36533414d70336020f75d99e89e4e7860f08f1df08ab7909ea60134ba7aceb9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__548eee75261555e29db0127021aaddbc1b98530576fb1d1200ed09232ee2a640(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97831a0329dc3012b07cccc2d7335155b6d42233a10836be846175f4dfb04426(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93b0a24680cd36a4ab4e9750a251471c008bdf13166530f1d0a32be610b0d70c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e44fb4e2610eda91591803eb1b428158e3d44ffceae3ef1c44c37da1e4c692f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2de435c2ef013312ecdb0fbf88f76bc27d2218ca2ffc5d7d09365aa381587c73(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86b6823aebf970ec29bdffe1efc7814b03915859d9d4a69b12392401430c0660(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a330fd42ee58480e5e4b3313a1e4220b5d3bac044151aeb098b8ba335e0aae2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a403d7dcf287b48f0dcddab5566f75f01baed04e41f99a1348a0e705037f8073(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    java_script_insertion_rule: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_math_prefix: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ab954a8f71fb2b225bffeaca87b9cb446aa788221cc2c5a694461580b5b7718(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c59665866b187d04cf1d711f2540fee18336acfd03db84abf74099da5ac9538(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2787f8f9c4a1865366b1ec1921a07a9e135b87b5019393bbeef9a6c956a5d622(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d73cdfe2839b4958293b3204945d8a8275bf022939daf66efed8f9922a38ad3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35a62074650f8e23f3cfc5ea0c5114f489984db714b889b8557fb7fc8b68e9cc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlusCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bdf1f44f70cec29f26abfe1b8ac4de82f098a7ba372520e38f8d082cc9f4c34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f6227fc76e3b2c0f295ffaaa77dfb175cf6fc4f6374d483337495a71b7c7f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b18254da0e31c63562ed72dbe9b8f5aa381503f84ff3f978cab9a52b79a0e1f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ac06af132ece5c542d7d338c00426cce5e92e5f58a03e1c180db5b4d6010b10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7e00e71c486c8f33982e62535cad000765557683abbb2c74b887c2346f33ecd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a9073ff70625e2d659f1ccb2e989a76c80b432069f5b3082d0d6b42427e42d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8357de776cc3597a894044a85c0fa4c061a40db585d5e0678f626ec950a6481(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8266b70d65e9c6f75604941c4870d96c5e4a029b2d655aa970e11b03352afd3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorFirstPartyMarketingPlus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e97f639cbf5c69100e2f9c622afe3124feb7a417d145e8c58e0d13c2b0e674c0(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d4f7e96a7d2983ac4b40fd0d6da830539005f2ab54bbdcc66071467d3a33da(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b148d07452beab1a550d372e768b7e2262f6f48e0f91f3317c1a8b216de1792a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b8ca875a4ffc0e212878583f931fcd07205f86bf5940a8e559f5620bfefa21f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc49ef9a83da22ef7a59f3356eeeddab3c422f56b71537bf59ed145037b0d88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b185cd50b72b5dffd12af67add838362c4082d7cb70f32be7dad4a098a02b549(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewriteCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aae523208cf9ea377fb85ad77b0736b417928ba1751d6540052c60f700525435(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cae6db698501e41aa669f549e0272b7caf0c8d57af91f406141104a4ec26b24(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__105b34eb1e11b27c25afb105041bcd7ffc2ba3d8a6d0f178ccfcb42e2786ef3a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53fed39e994e24d1273f1daa22bcf247aec3150428066c42967dee7ecd9b0edf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d806c94d280ac047b83dc3f374ac2a992d51d54d8e528c0615ad3e9b259b7ffe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7de18656a55c0e7215a79f723a28f7642611a9a3612ec421ee5a60ea7c6d65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8d445ee396651126d57d0f64e7c9dd182345e159895697bd51c964dacc0f2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4e687f74e0b0933b9049312dfd7c6157fb54d6487ac1a178e1d51021a5cba21(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorForwardRewrite],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871c71b523862dd46448fedaae56768dbac7d99845e5f976ffa2a822655472d6(
    *,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    data_header: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nonce: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    signed_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__268efa158852728af9d3980d8981bceccbbf0ecdd6013acd0284a9f7772dea92(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__054e4d991cdb34a22c7437996c7bdd9c2eaad2fe7feade5bcf4c31a23482213a(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d19ee845d087e64ff580f6b5c2d3b56f11cadc2c0c15ab96c4b3303ca5a926dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3470c84fae8c68d3481946ad86bdf2bc66f2f90ef6f2c35d0b284eddab4c760(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa413c1e052070b400f3b86c66500fca67c3062a74a7654d33ad006a80a9ccd3(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c7a289aab55c880249bd90ab570e61a26dba0b92e7e83c40fafc549890318d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d016fece97130a43722819bb119ee439c64f7945aa46617a2dd8f050ec67583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc1cea5c51a5766ef26467001a8d5c1f7305546305a8b3bd738dac7d997bac5b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819290d0ece80b58655823dd804ba64c43646324cdbb2a88a466416d026646ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b41780dd7647ba4986eaf0489229bcafa6d6ecf0e1b213bcf9fb008f35adf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a970b87e50941b1dcfa1ac0c27b2138337766b284de7de761c5b31979b18b81d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3103b96384af65cde82d8c3d9425accba8c6645eba7dd6e301164bb5ebe18c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55e0989e38d986c7da5eb9b46b7e7c5079cc83f108cd78335454d5bbec0c0e47(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorG2Oheader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__338fb9ee4cf62b571ffa7268f061897321c6c2b38f513d1ce0a95ccade0695e6(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    output_option: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__330e4153fa53cd17af6d4d4c3bfe5ddb6a8561ecf204c32f50da3d080f48695a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b73f168fd8786bad4775b01019eb8e313d0e24ec9a73f0f04080ed88fabb297(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__877318aaef5ba5e1344cf4e24d6b075da3058dfaed741f02209cb3cc088012d8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d020c587fee6d42b8f274ab46c89d81225c7557f174fc23583cdab121dcfe3f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b05ab11aefc97612848d376dba1bffc977aa2b2499a1614c28dbe018e73a17a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__519689b4795d122e3564a3a850f2158d27d28d981bad9569bf3cd9b3ef11504c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0da0bbd3e9ebfade1e68ab02a1fad9302dce3f049fcfca0ed3a391d9cdddd825(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3a4d0ce65e33e6a27d384309f4d4a455a254b1d210373e089850ad66b8c04b2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGlobalRequestNumber],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f959ad0e3f74154755efecd76e6fc1e619e4fdfaae456b78a5bdd524ee11b083(
    *,
    advanced: typing.Optional[builtins.str] = None,
    cache_responses_with_errors: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    operations_json_body_parameter_name: typing.Optional[builtins.str] = None,
    operations_url_query_parameter_name: typing.Optional[builtins.str] = None,
    post_request_processing_error_handling: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d36eb51d8dfefe693677496ca482924eb3303791078132858dfe10ba1f7e4d69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f75ba58b056b9955911fe3fe2093c4b498fa0237036bf260e39c47ccc28dbb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22d02c5cf81431cd96fc94e4989baae1d81dc0f338baee867b5093dda9fb27d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98ba6db2c301913fcad796653742e80e4ff2e90d91f1df1c20fd58baba44d081(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7fade7f2cf66bc28dfb2106cec60b8a8357c222052f706551857eb386f1e79ef(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30ecb50322daa65910186e43175cd29fbfd807f5781c1db8973ae86b4b7f0e46(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84a5b0fca81b9a8faa02a1f10f1bc96954a0f4b75f18c624ebd20493da8ddc8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39b33a3ead699e2465772235bf0c9f1e7b95a57c15202a5d96e2563c8b1db9e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33cdaa993b1e0e00392a48f990b3197b3cd8eaff05eb7877fc2e8eb40c8f5e21(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec97a594ca815f4e9dd514a38cd4c0361db8e385abe1b216513f82b67d10736(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__110845b25fbbb276738f726c2ed2697e9960b9577d6e677eada13d0c1423d837(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGraphqlCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa9ae2194f3ddf358e4f43b0c03160be689e662991f37115e764faf48a9c0a21(
    *,
    behavior: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__777ae09aa7a8f638fb572649a76c46a0d51068c650829d35842d051e304c7887(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c56a7e4dd4d1d7362ab07d9740cee3d3c73a0fc51fa79aa0cccc84fe2a8d57a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7608ce8b70ecf312b27b764da45f199924a10f30a01cbccf24b84821345fd84f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba6bb1bd387f5c9806f7a9d6764a7bec144e23d0b9846d8752c1b0b889e9288a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aee3b8f58686b5b198cd12fe9a2a57c69a0d924d483f168ae1c0a222b234c345(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac1f508f146ae5323ce1e139eba000aa50952264137e01be61e0fac4ec2f6dda(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorGzipResponse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0df490b881c569690b0f5abdb38b3ca66b7d7b22a56fb30ecf1686d71f8608e2(
    *,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    xml: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcf4da3a430a3f3a3082ed1b79063072ba1a19551883cb2c972fc45246cc855(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78fdc68046c65e1057d2da93a3aae15e9eb0bbe12ae7160caef5d5f8ec70718(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__257a3311786608dbc3006904afdadbf8bf308a362ff64070066147eb070b0cc0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bbddb0320c90a8be8bee7b09425e6954aff56d8abaa775ec172ea4a678b4538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11b46da674ecec2d802c70343d573b9774e76603017c6e7f2aeaddcd5ba78338(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33306f3e385fd6652f3b3f22da3ec045e1f96605da2b6084bf40d7dc2b0ad67d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c8d55adf261667012a27f5beadbef73452e0366f3c3e7c2665a15df6a82c958(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHdDataAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c194236e8a6a87836f32b7c7190fc8ce569bef431bb68ee3eecd2b78b4d281fa(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_reconnects: typing.Optional[jsii.Number] = None,
    retry_count: typing.Optional[jsii.Number] = None,
    retry_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb802e1d0dbfd670b72a5ece9dd2240805dfe1d65a7f7923d43a89ccb869d95(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0660349edbb5cf3c74fffe5e987f5643759b02ca1b31be6810d8287ea0fc1b7e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf1bccead7fc94aea5ed40eafa7ec1b4c281613897a4f4ed7aeecc8756d6ed06(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24c287fe466ee8de86ad760c4642a7a4f03a187f80ba1537c05485159a5871dc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c58370c2adabc901295698dbc8bd43c8d30d98dc06fb2b1cc3f3b3d428c9fbd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ce244919a58d97153a5158f2887296ab8cf065c6cdd4393b2fe07aadd97529d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f29d2dd73382088093ac77a690d2057bf065b269842476262306dd46d5237e7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7e7829a46714ce8ba083b3c8f3e7084ba173d39f93ac6e22ddb0a6cd1f738c1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHealthDetection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86138294376c194d14be92f9404ef30d06caa4faa21f42b68da9f44e770570e2(
    *,
    custom_extracted_serial: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hash_max_value: typing.Optional[jsii.Number] = None,
    hash_min_value: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8740020774e17b7cdbb11f40e601cc27315e4764e089f401b0c4d8950678da9e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17f040e4cc8092542bdc8e01c50ba620bc1a093c5d6cb0e80359c7b0e4df4333(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecac1a078621929b9ab3d8e2a38f3164b37e05e564b0ee4a95359d146dc0cd72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c632ba717377069f777fe5d1dcce3a469d1a45ea6e5effd70725524aa4bdb7a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8851c37e069cb489e7a3f6007635ee4c5277901ebab8dbc7b5abbb6860bbd615(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09877befb21ecfd362a0ee407a2d8ced179f555978fdb5d3792cd066799e80b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e972829c10e8eac5f9b48e55fa4be78eae4227575e4f7542c6ae5018472a87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bb2069f74b84941c885e7da533653343313269fd558b3bf604e2babc8862daa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16aa7a70cca6c5836a74a928f6996d185fcdba86a59dbc70cc9cb7809e909f72(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61b10650563c7680071c6a44f0dcb75dd2dc84f52b82053cc4ed86e806f134c9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHsafEipBinding],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc559fcc885f19559ede772a08e803c0c7e17ac1abdcc8f7e8217e092f1f1839(
    *,
    enabled: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbd2b523b1f7619cfb1df089a8fe9c8ee5aa70363e1fe56b9aa00ce47c0a7c34(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f406197d3b836c87565e22afb7abe762e45e19f612b2b769b912dc7f4ca82ff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e6f1afa01bdaae59a36ac7b481b1f7860cf0d29fbc17cae304d194173530933(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd499f2d614808ad0ac0c2d91e7a8c5778450eb1bdc6ae3415f81aec79bdd435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4336a5516b86de3430abd815f362e5b043bcaadd08871ad8eb7e796e56ac87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f0dbbc9ded7f569a030760c91678953977ad4d88dc9839286dca8189f2e4a92(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp2],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5322539a2d99a4eadc5e01da36b23f3e03aa4250e662670e5764d3064e31e5(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1014ba38612c60217e1714f1ff110156ed6a26e4f28b8b99982d37e995db75(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2eb973883619ac33c568ba8ef7ddd527383d5d8814acb961452a3ea9e64fdfaf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e963f9dcffa00d831566e030d8eaaf802e0f528aa008bda23e1a20974ebf9311(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0010b482fd17fee43c68a0bb2579acc6d048b1b65a65290fa56456699adb572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5feaf55b9f79df36ab69a5fd04401db478e5355a0db95e8fd41d752041f09fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b72171f8606154fa6b018d2ec47b7003322a47fac3261c7c7293e6a42dd4734(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttp3],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__512f8d5c8eeb7ba5d21e5ec396c5582a32a6bbaedffe9456848b4b0040b5a101(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    include_sub_domains: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_age: typing.Optional[builtins.str] = None,
    preload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    redirect_status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12ae9d20a3a7313ab09c430366f1ce33b6965bcf9fd7cc3fbd3887438146648d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89068ebf1e8965f591fd0dbccfc603cedaac7887d305660ae94839d61100de3c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e5569330345e3b724085275f26837e978bbb2dd53b8c0081b8538046019e76(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bbb932039dc69bf7cf66d4403d40a30a8e3086eec1eee78472aa07a2e4f80487(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53d2f020ba3c87d46e08292c59c1b2eb79ef4b3ac02b6ed4ea1b8a66ce11fa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__217485d8c32549eeb6f9de874612c80e7434dc3fcfe6580a2b00b2d39ec1196f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbb58eb3e1f567524356e66dcde59189c1cccd3cc2809f254f07199715bd3723(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90cb9d63c95ac9a6fecfe9c3252221cc605da387fbc2d742744f9945839aac98(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ee3947b94d2a24bdd39684b6e0ff9a532cf9e2fa5c78335930ede9528b43508(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0aeb400434044724fa9b8f3e1cf0c6ab77bbf29a4969a8ce7b0c9540255d4e90(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f47a05d7807737f4fa83149586aa1b3fe91c6b529b48ef55080f30fdae9c5b2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpStrictTransportSecurity],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f44484001e4f75b4dd0b77505cdccc6b44ccc800d0b860f1c84acba5201d511(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upgrade: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21057fe510b80aeaf4eeb114005401721a47fe8192663c855c2a3ef10fcf531d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18e73bc2d871b7aa04e8bd554dfe46e182968e9dfca75a9da48180511c256f2b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84487b1382bd90c0080444dbd308ec91840aedf47145c370d999de2a5f94dea3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18da36e7bf28d1d126aea577273470a9115f5deb0bf0be270ee44fae9d7890f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cca4619ce34b81edafd47792657b84eac4c2dc0e55de5ff643b5d087767b06e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b73b12bbe4e7a65e730fa1ac26266bfa189f0d8af1c12e73a4d574f1110b7b9f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorHttpToHttpsUpgrade],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b5d928316353571b89d0e521c4ef74a874aecec98851442cad2959feaaec7fb(
    *,
    dpr: typing.Optional[jsii.Number] = None,
    dprvar: typing.Optional[builtins.str] = None,
    exclude_all_query_parameters: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    excluded_query_parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    format: typing.Optional[builtins.str] = None,
    formatvar: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    policyvar: typing.Optional[builtins.str] = None,
    policyvar_i_mvar: typing.Optional[builtins.str] = None,
    policyvar_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    typesel: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    width: typing.Optional[jsii.Number] = None,
    widthvar: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2037ea1beeacf51640c4e47dade764a2b0b5e42a541790021d420c8ed6f0e17e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb5a9285699384e8d14f245de94065dbbcac072e6283f3ae1db8338f077ba6fa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a76b1ec827f8747e20c238c08cdf15cc8f9130afe0b882b8d0ac85a357dbb7f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__287aeb6d3c6b0b0cdebf98d41c70172ec8a0b9a0aceea1c535297b020dcc8491(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8251ebf9c55dddd46499b9a8c5d8d67b3490a596f5b572b4c031c068ecc695(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42f07e642d0670afa9b757e6aa33406ec5cf7b1f4e6d829450e49c1c1cb63e09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f87f1aff0580d216217ef5e13265f9c318e8fb2b705f012036724ff8082186b6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e11fc92a30b98fb226a21865ebb408aa634780442de12a0be830f7c7a5f807c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__959464e785c974bb7a3368d6cc3d17651cf5643372e15de385a59987ecbfd0f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3832892873eec9352f14175bb6bc8d0f442491c50affc4cd51313f02e88cbb2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8041b70ecac879863b8da6d1b823f9cb2d97fc28272248c0b5086836ce00a071(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdc4616f9069c5723889f01695f3eeeff69956c3ed96c8c6450f1280086a75fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a473ceab6decb12ba3bdbab74ce796a636dcef6c482055179df222e6630319ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d323195ba7faf25b795ce6ff130fe31883085130a540cc9ecf5efb3ebdca014(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9744aeaaee3bc19ab14ab1a596433ce722f2acc966f0bbd63cddb352c1d3c85d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e783ec7cbc822aa9bcd09a0ce909b958c41e66079770bcdad92d5ef20f702db6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3282c6230041c54dacd4691366bbfe1b918222b686a9c72a81404b45022234(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a312eb97c06c13571ec8c502c0b3d61d8b57a97e50dc78d854bd6a003ba96e64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0033c05890fbc4fcdeb6bfcb415cdb6fcbb6dd825e3d4787e471812d8bdbe14(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d952560ff0f025bb14f27965cc5c17b7cca027e3a5de50118bc34dd88a531ded(
    *,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    image_set: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set_type: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    video_set: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb5838c818f975dc382e5b7da6bf43d06023a7e6e77f5da10bf83412632248e2(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5e6b72f109c1a9cbdcfdb5974ddb0964dc65d49cd1c0fca583d2873f22677f7(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__467266a91735f0a043f875f435d1166a5eef124e922a6acd3b02c44494312db3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517d092dcaf2a7b2b6b2f87d97437e7cd3d98e197bbacaa84e9628c2cb1eb0e8(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26b2f1acb0b250c1ed1432a8d496e93618c7ac87948e2b4c71670617a5d776b7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42c889e88a50358a6c173c736138f47027a4fdf20b9adadd9f52ddb2535f05ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70de8022833b87d837b26bd996dd54d50d025e3a5e808778778c267366eb5adb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e986ffc4e4327f4c96e718a6de26be39112e65126ab56ba6d46d08de1cb80e5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b2b37f80986f3ef060eacd2656d6c7c9fefd82d3a70dcd63d6220e718e40421(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b85f322bc07e20d21109d1ddfc90e8d2fb47aaca55d093ae890c75b6f04e7a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05059596730b8340560846d0b780cae6490fa3fdd24123eb720196e7f2b028f7(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__805b2ccc83f513957739e2c10a24d581f6091e0589ea9227e18563ddb03faecd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f790e112bbb3e9e06b8ce8bc17ecbbe2007c8e0b639866e06d78557bae83eab2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__091539fdcc030909c62633f664185953aaea55ca8f7880c2f3048f2b98871c51(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__740182cabda610fbe85cc8c31c9786f513264730c2d1e1b4832bddc1ffffd948(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ae6b78cd8ec98d469342fc8a2f78818a568a79512aeb0ec506a14012a2344b1(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0411e34aa3634927ef1d3bd0716aac885b53c6c45307252a239340a79f2b4cd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0906c4b1e0bea444d01e5971a0f847245b93310a4f240dec6bceca82a15634d0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__983758906085f2fbff74c1a02353c9948c3fa94890a5aa1bbdef15de23ae74b4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4b5176f396413b4236782a9d314debc4d024545485ac2b2aaaee999eb502625(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29425139dfb661d3a9e47ecb66c7c7a7eea72fc939f4cb499eff85540e027941(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ba04035de549ec0fae8a8aadb99a7b045ec9bb9720217cb9737e9a1e9624a2d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2615e637c09a8e8543b4da7a3c85ce464260c03d2c72435e451c77f7484bfc2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f4aacefb8004837494d5f96720c4e9fc28f033c950ed32444e537a9e1fb075(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e30a7fee8c85fd32ea19f2f3d4dde9cf7e07d3934aeae69d7e37be8ff2fb94e9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6d10ad46abfc400325faa4444bccfe81a32bf8cd06e8028ec3f2fb0f14d0476(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d2d6c2edede0c9b3bc05a42cdd53337023805356b1cf0d4296e3eb56556578f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f02db95858bfb21814d0757eb9e4533bf01e30c7f3d667c842311ae29df9715(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ad50ce75f5d50b79964d696d470d1d39988316b4353f92b868cb56d22a1d0d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__431b4757dd3b34a34c126db5fc9656c61f789c8cb7e25eda4377066f830beb13(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c353d133657078d4bf2f75f77a6b9df2692ef508b3b9e52287329dedadd1315(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e6c73b3dbb25cab4ce8d6777928f8738735598db330992c7518468b1054411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd9fd970aa51c2f91315e29ec29addae04f106a8ba915b6219b4e7129401d607(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d1b552eed3f5869acf29db507d33d93c38b3bb7041aceec8b1b0cb8c0bcaa79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94c033e5843497c276f6ed209b17fdb8cdba0f3e61f30eb44581b0d4332e03d6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82bb0162769585439c2bfdc125eba922200cc7cee5160447a4b4d3b8d1b15ccb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b7c3f817fa089fb76e6e8c7492f034bb1e1a27a580e757d70d86c1cc974e7dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d8f5b5ad712aec42a66380f35a0d282fa3f9bb4b4c9978d2ea91d8c97ec2143(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dabe4e3ce06135539dd9d77d084b485e88ab70910afa940fc33b58d5c78aa54(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageAndVideoManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b37fca31ee38d5ae14191f5e55c57b5ad10dcbf1897e7b127e8fcc0df469119c(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e38b463169b061c4e42ca8ef745c0aca8a46229929025f8fdc8bff002f8f7601(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__881f2b7e103acc3ef19f776864ea94ad5df97d421d6f1b0d751a84cfe7c0f11d(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c571a65d93d2e85c924dc1c291777207a619c4aaf8c15c49222641c06259a582(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e60574b92210a845428a0b3d4fed8d5a9b8618cc0ff549faf9f6db5fe230d1ac(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a27b09d1262c7fb4ca28ecf13c874b03a04cfab605ff5219be7bcaaf4aed2c15(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490954a3f117c438a595bfedb27482d95c13bdf99ef8e7d71d892c6e7b6cd33b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d797a9ede9fe35156eb7bb782f03961b964735ffc41edb5764049b42004d9fb2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cfea5a65eba6180211bffe4f6ccc0060e1c163ea8cebd4ea88a647fe90bf2aa(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eaa987c683e7f26ab51d70a99de08ea8e2b6051e5224787d20a144347455eeca(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fe5d416488aaed0e4044420371a054a14c726c8adaa68b782137064ad5ca2e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5d89a4a30c25d56c536ebd07df2366c47516ca4c5f1cb2881f84ad43e7734bd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b9a64ba86e3a2c49e02d189e0daf5e9fe361c1b495021c0d710adb756e8c69d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ddbc9ed01f612ca22adc0331bd84a928a3dbbefe1ed8ad2007e5f8863ef5377(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc74c3f6d4debf82af3f99e2a63f1d3ea5392a5fd6900414fb241031d728ff2b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d5ae64b115f69a52217f2c3578a15231e3eb79cfc99bc405cbf0aadd8b7182(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2ef414f261b67e4dbc1d574164c1466c817f79701d94f33ec5a47cf18c8ab5d(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d2823b2ee9b5c635b3a43a4bfb99117fecff333eee327d78cf4e0f8efc66da(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff4bf1a955e1da8474623e1b647b35ac56d36085c8b66eb87f183f5a0635e8ca(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d7a0345f3a6c5d472f8feda3ca4482599ed3dd355406611b55fa656c21973cd(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0939c4a12ce4fec8ffa78727a7dfbca44c18783854ceec0310e846ddbe08cdbf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b7774f5e398ef7554d6ecfc4999f42107d1f58a0c2c91190c63e71e35600c04(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ceca2c83534646243e49ac8d310fcb4633676053d7c15ce75321dc28aaefdf3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de721a401008ae63f08cac423b32e1d379446a4d34ba86c23a39f57a6ac1775(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cfb0605fcdcd3bb62c66eca56012c758c5b0d19900ec1ea5541ca471fe5645d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35973419376350dd277d6d2e406de10080aece71495423b9e1e7dbda5d0d828c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f52aa0ee97b9d2e091cef4b8098d9b7140a34a65e286dd63d505c020faaa4ea(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d26d99f50cc4e6dd64f1267f736f6ec2a5bdce13bd90d60b7d9fe323e9ec1721(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03347b699d0b3d0cfdd040a5e26d33f9aa5eb7863316c338161cfe17b40ec574(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4699de71d1e825e8548f01f0d13b101e070139627ec033adb7f223a58973110(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f79764fee0ffbcb145896cd54e36f26b100acd095f82eb7f5e33898487ed77e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d77f19487f30c0af0ad0ea8da2526d377aeca4daa8c293acb180244cb883546a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__804893d26d4fb911769d25cb076c925ec392e7039c8018be64866a34bddecf07(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fbfe6fec503cc88f2591e470669f4e051b610d46ffe9d38f6780cd4b89fe9d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfac3063e297f876a731f2a53f52e050970369cf78ddad79a67fd254c6b461dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f462b9da74d68cd05efbf81da3851d792e076d11ee182e41da2214a35be4e63(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89b1d191cbbfb5eac5d2e0aeb9d5a54954317dc16954b64810b275a05c0a7767(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a474aa9a4813937f3790b7482fa2ef3b29126bb59f511bbe8617852ba54da5cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1a9b5b6e222a9b951a222348ac74820cde361ae4b4be93f57737febb6378912(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8b53f5c95c286276294c700c9a095c5e7189408f66e0031ada0319a6de42c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09aa66f250dd5076fcb4483b88ecf5cb56e8c6ab56b5463f3246ea867c08153c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8cd4840a804fa852314f1c387bfe6ca296a7a32ad4372539b06fc640b7b3a4c2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0decf7ee1a257906bf5aff60bc1d00602041003eea7628efb4b7458cd01cb002(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65d85cc9c38771ddf6fcf1481032ef5eb327df7d09b05cf734b54611e868dfa0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d52dc0eb17a2d275fdcf30a0cb1090dd4ba0e71775ab935122f102a7d16c8f2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16fffdc0d5d29a1855917a0f808fecf1ff27de53d1e2d3df6c4b931bfd41b6ae(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManager],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15dc0f6d42e16002ee7f776da49cceb2869f040c26bee3cb21b493fd92ee7761(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    api_reference_title: typing.Optional[builtins.str] = None,
    apply_best_file_type: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cp_code_original: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal, typing.Dict[builtins.str, typing.Any]]] = None,
    cp_code_transformed: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    policy_set: typing.Optional[builtins.str] = None,
    policy_token: typing.Optional[builtins.str] = None,
    policy_token_default: typing.Optional[builtins.str] = None,
    resize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    settings_title: typing.Optional[builtins.str] = None,
    super_cache_region: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    traffic_title: typing.Optional[builtins.str] = None,
    use_existing_policy_set: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff7f343ecbf86710504f00e7abce1510fe8fcf3bd7ef4786c8e80ec6551530b2(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1828081d6bbb0d9014aaed23aed8a314fc305cc2ea14ec83c45caabdeb5abf(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78a86bd81d84c4c9a4f9d344a70495836a8e7e2333eb19837607783be2e588b8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0772a1c44ff1ab2f35d58334d7ff2136da14615518f51df1f1097aacd316b5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00a97b1f5b98a7212ce4d5d8731ad6bd347396b817f0366e0f24a52f054f1162(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4426377b9aad1f7ca5a2eb2cdb99ac5e7816addbe1086c961112d0008b07b162(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41ba2b4517054ffd9a082eac4c019b8b93203b71ca2d234cda1729ce2b5805ef(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginalCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44045d6834a5bfaf415ec51eb2a9b29f0b47247ef8ff9f9a8bfb3f491a280fc9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__883a46f6ad778208856cd572c765c08d4f5646bc4ae5e023294e91a06c47424f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2085ad4f95fe0733377bb5c53ed7a14021ef704ebdeef2b7b2269e7f3cb9853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d374315c954b72259cb95f2f2f368ab668c5b69f17b2514176edb40d7bceadb0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28676555c6b8a407782f528a0f10c1ebb60edd35589df790377d3fc3792d0e16(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a43a34175958c1d10b75563ffe34ef1b8b1259409e4f436d896eb8538818ae2(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e82baa8afb6e002247ff7bda152cb51df51470c796858e4a5f1b140658081fee(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeOriginal],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82eed5aae8a8a4449f568123acfa9117f54dece67697f8c93c7009fd62e2ade7(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a62ed7bf2e0565081f0601b585e3307e860404c161c2aa03a61753706e949665(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d57f5d2987f2b377eea41b4276d5e8b72114c844bc73425f456c5d192082e47(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e005b2ef9464a6fbd25b729258788d3803d4f029e3e1a202b36551c5e7037b9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14e7f7b0ac78da80ab353aee3651cc64d53f201e5a6cfa87bf6bc44ff96a2105(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__248a8bedc6a8b61cd41177e2ac8c3fa6ecf52de35d2aa9491a7eba9719e4965f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d608c2a64978211f7f2e2e444700eb244a5087fc2bbc5ba5081eb7b47b27d54(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformedCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc51acc22b2f269dd0925d670e501967c1e9ddfdd443c6e494726b55a493cb7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae1ef1f143feebc49c5fb6d6be27916bba8fe404e384084f9307c14a5331dfba(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8ca096d59897ef4bb6ecf718a83df893133414c3beecf819e56d692b56fb7c6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ebdd4d4981e08e260f466ee3ff64237b4b09f13967c4ef5923342167cde1c6e9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bacbe70083c143ebd0d6d7d6bb913f3fecc6de35b99a9774af7eb82c9841aca1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19eebf67d9b89d0c1899556b90d637ffa6b8a91e9a4b9d9a9fb8d1b1b3fdba4e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__119045585a2e7e4f778757c4834984b5476c03301527e13e77bf9b2c39e0e509(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideoCpCodeTransformed],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e07d54d3ecdd255bb2f54e228990182481557be2450050103de9937dbf1b552(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c2c1af432c5e075901888a8c633ff0eef3df438f817e3af1e05f409b3d0e9ce(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7164cba2877e8376864f0f26524197a45a8f5d11abfa2b9340508433d41475b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a2bd2eb7d6d2dce9c7e97cf05e25192804921fecc5db338f7280b362fea2b1f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589feed43c8c9e8586604fe820de36e7d259c21a22eb215c01eebbd6893facb8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b73a449017f0b42e25b22c77aea73642a67de1adcbe09af83f44b04a7f82160(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9e6732b21a4f16a46adae61a0a53be6fd9dbe7d72e64c76607159b377e76436(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a657c17a8add561f7c428e5973a792394a1eca9f0e883da1155104d727f6947(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d6165962106b2b237d3fecdfd966396caad7373d4bf5372108155dd425a355d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e73e3dd8a556ae4522f2ca677cd3726424d4acd84a96e70391c63c8d1f4f2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad8b1f1c42d7583a8c2661d1dba427e2159b3b1f8ccd20dff2327b1b86ca48d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a58a01f66e4b2d4635b94958e828e7680b8675bec1fc42be7f748e950d641def(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04829dcf3147b15aa633314908721bae0ecc9f49651bd7e7c08ca3dd2599d6cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee01df4921118c478c7d28bb634645ff3f6c78061c25d3cec530464c5143a35a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd43595af0b4502fd5c430ad6d4cdc23bc22be763ef89c8ecefd0767828f9bf1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59b3251ef47894604e81693753455db574f5c00fd2f82558cbfd91e6e32665f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fd2491133dcd32e4c5e012279be8916ff537d649a75853bd69fcfb98cafceb0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorImageManagerVideo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f524e6a81e2c0a10bccf4e698725ca1443252062eaee0a14579be0526692cf66(
    *,
    id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f4e7a8bb5f633ee7a19ee70ad58bf31eff5723a39b40b5ba098a742a8ea30cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ee5f2920735760dcb67f0b125708f9ddf19ecffbae6b5fb70649e46a803919f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3df35d69fe5463b02afc7dc7bd55c4c27728d0c508bd08b9b24ecdc7ccf8654d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ac88daf48bc0195e5dd5add0ef02e431dd5f5f00d7fae51dce9212964e3052e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fa2eb0a3e359ab61a6ca0fb8d4f0489e8f69fe252900d4efc720a19117d2a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2464b17d482c230c69466092495236b9f898d7f1fd7e7c24fa48217a3599a07c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInclude],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f38813b653691ad247fdd92692032c0fcb6ca361ac2863b20c9a14fc6cbe0dd8(
    *,
    custom_link_relations: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_cacheable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_html: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefetch_no_store_extensions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f695f38bd4c3e2cec7c79fb5791586f8aab7b47305df3864d9f911c359481aa(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__082a2fc481f1aa44b2bad6d52f6c1c81016898c3834d6ee38191c60daaae7b9f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab1448fd88d77444fa267345fa33a227a2edf8de2d3d87340d058ad26d0bad1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e128fee74f187da216cbab986b572e94268c9d97c61a92d42b042b6addff0b66(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cca9597c9c0d61e74969072e5598060b7c8a3f4ac4f106a169a981bc2b53764(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7f2435f81992cdeb6d1462ccc10625f206ddd30b7322e8b4c2df03421be63f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a63dac4c8265e3ecff0529796817063473bb152215a9c458b5b11b5387f26e2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstantConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5354988ca70c632b1cffc0c61efa468bd72476e8679648a647f64c07d0207616(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d0e83e15c4dc4106a381c13d20d243276b65529420a0c597826a2fd2326c220(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e332764f4fbff9c9043df6d69aaa626c0e4dd173531a1d809d4568b720b52885(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f833e3388c8a623efac68486f1a2fd89a084cfd4cecd3df85ac225cda17c4803(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd542ab36f30c658984cea722ab7ff85668b6110abc55eb67351e616c5537fdf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51255d7b1df8369770ac6e4f67623b7b4459881441a60fc3690de8b47d0b50a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__211a1305be47eaaab12f52e62cbd6bf98712577763ee694ca8b5732a4ca6a387(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbbd97d33e6331aad64eb5b20fad93fa22d80efafaebbf3bf8681b45a9733430(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b64173a153cc240f21500f2a5ca35e23b5a089560314134fe82d8b15b97b7f8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e2e76dca9d475112359cce9abc9d9b54c2a07b4f1b458bc50e8c110e603cb8d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorInstant],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0089b659d2c0f010c7c74ed9b5ef74a227a76a104d495cf5041f1e3ca8bc5035(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_partial_object_caching: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    minimum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_versioning: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9105810c0eacc30652cc78482e13fbe95ac2c07fe16f6e6153ff1aeebd84eb43(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    fragment_size: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_size: typing.Optional[builtins.str] = None,
    prefetch_after_request: typing.Optional[jsii.Number] = None,
    prefetch_during_request: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42ad028eecf0f18319e2318ce9cfb1e630f3f22a4990da71f9a90eaeaffea0c3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47bad84fc5a54b8ea0b08cbbd4b96eb90868046bd5185c26a87beb52ca893b9f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ac0612284984b745ce28d7f57b7e4b69b3417440a810a93c35b511a70f6ae15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a720c32fcc903395070597c62929d2467b87d508a84754f4ced461c4b037b26(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e46676272e3fa153233829468e667d538a52a3709ac9a19397b39ddcadbde411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3abad7d4ca0f22e89395091f7d6a2f2bc195d9ff76d463d1dc52b00c005208a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85c08c8dfbf9f59c0bdbb4af481243a444d330f09a8df13531d2c5caabcc97fa(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__412586e51fe331f160f912545eeac1b9278fc6c7201ccff8d67f1436b135bd68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06735e5e6240d35c18ec4d41386a7fd49ac32cafd864386798fe2697c4299439(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84056ebc108e589ca916f2410fc4fe9667944b3add33008deb3bd2f8e498153e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimizationAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58652e71e5a1cd37cbb777bc12f8f60fbe3d9ea34ce430c2fd62253f78f48d3d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b750e7f537176b1a9ccdbaefbadbd6243ced3ea16db2ce382c6ee62a15566ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b68278bf77475e0da97c0746ab8e519ffb5ca1214a0aea80a42a07b08679f39a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a2644a04c0d494caf12ea858b847f6db3fd0a9b4d490b0f672b53efe19d9311(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65a0c7932acc77fc6396e512e8839313d58f0f6400b1ab70fcaf44a711cef643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b786a807c452c28d136379eb6267e67d7e06114a1351d661abeefaccbb9e9062(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7699510fd8a38110ace01c12eb222f09ebb20c576e8f5e2d68a19508219d67e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0357559c666fa3fc5079a1da6dbe421476d51dacbcdc29de0938269b45ee01ae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14ce8ace41f8f0359917527c98e0bcd5320dfe31e3156d97a499527907016df0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1da6807206e3bb47c7ca78f94d8ec45d9c2d084fa02d12193dc3fc86e9a2c68(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLargeFileOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b209667c1f2cbcf2eb6d7c34d02711dbf8d9d17b8919e362981ef58f1fed2d22(
    *,
    bitrate_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    threshold_table: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be84f132aa9715aaa238a6849f25fe5806c1590ffa3d097644935fbc0bf6d51(
    *,
    bitrate_unit: typing.Optional[builtins.str] = None,
    bitrate_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73437b479abd008c99fbc3a1d411cd1bedf34fbc900f30046ebad71c302909f8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a749827e85e41e13822dc1d990f95622baadfe0db8630eb29e8e6247a0ad450(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd45b5eea553eeed5376d366a62ca2164f827c16b8908db6148851f0a646d5f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2886712e6e06efed4c6166116102b75d56ba60982e865d398cd281d5aee62b92(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a422c1b0ee9d4664c6f1e4c85d27855cfebffd8a0ac7ba1ef0b1c90da3e00a98(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a030c5275c2eab763859e40c9f233a932ce901a59188792c7405cc599ca492d(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e2063809d5980ecb0bd1121a2e75314d249a0fe30197466fbd834a59b918106(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16d12fb159da516e32bee85bf45c37aede165b5002c482126afa6476d149733(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17b3eace01c45cd7e8de64c0f83639fa8ebb5db42200c90ffe3566d6f2961862(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7e558d643fe5e44409b024596c3ae1557edf9fdb56b3faa31c1e1388afff9c9(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6de283c7484deda78066037eacba8639683ebeff0a255e761f16be66d3ea8d78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__30e9113e7f9a9bd16ef5b08fece6e7ca2de6ba0efc0f46e4e72064f2c9b95882(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateBitrateTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b35c99f47d17eb0e7c80bc4553ab9163315436d646e04be0eb33f017e7898e(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__635628cabaa746cb9c763c77a471c975807918884a7d62f74b67a1d7ac4ca887(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5284ccc3157530276766f97f2e3fd7bf7068a9946f3069b84806960f8a5c2dc7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4da1e28df76aa7a7602f394208b184ac51d5641090a3edfd588d35ec4cd4242(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f992f21488a3a8debe88f9f4b0f036ef64f3f17bddd745364e27b459edca173c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f529a9592b70a4ed126b06fb0fcf9420c0b30400774b6266a218184148772380(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54a0e45fc16e5d5fab0b656799e98489e5380dba945cf4b22b80fbabff5b6d14(
    *,
    threshold_unit: typing.Optional[builtins.str] = None,
    threshold_value: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b53c752b9c9e092b7c0ae799c3bd5c38377f6a12111ecbf69155552955ce98e7(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ca5b6c2ef4887abfc64a27a9bd9079548ed2d5c83c2cd07871ddc1b374b96c(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1047ba335c697c3cf75d23453bef7597dde3321295e7f083d66c9635a6ecccb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0778d8da9f07a2d553c440dfe7a93ffe82b97791adfbe5072da5e12ce601857c(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b444d3035127a3819b307f9518a69325033a072def8518f2fcac85f46752ad49(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8399934203a27938acc2e4abf68bbfa0568a6a706a85f7689e5fe33d2f11ea73(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fc2150079e819e3977d162654c35c860a501975ee977f019a3c84b839ed023d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40f24213248849dc23aca47707383a880f8f77920963bc2aa2cbb28f574fd60e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c2c2333ac7e3c9c132ad0c94d42a41f01b0ac01a2c47f21ac022906df70ef46(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddb6e84088f46c2943bc6b610a0d783f8c5df7c2922d6934c2f94a62856cc47(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLimitBitRateThresholdTable]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3cb004b4b661f883b3cab47dea2c094d78581200b8948e41c0dde5339b4d2704(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843f2ed6ea110f0dad268ba82c83ada593dc39fa1693bd94f2b67a39c6c922f9(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cde8b72b7116f5e1d9b90e624ce3195f0205ec50738cc925c5b34eee0a772bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__429efb05cbe0fcc55b205644ebfeee6f8c629026492e63fa07165d5711c17b68(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aca9d3ba22ac9f6163d820ae05f1e1515cb51b34e2c8af267f296513a4c0ea29(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2169b961d668f3cfd322a1b8e90c1d31e86d40a99745cc6bda3a66546c0813e7(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f45a586cbd7f145a6d7a7144ec852c5915163c223dda94c558ee8fec77f3827f(
    *,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8e9a84e5f6710001571adeca1b13b4780390a6bbdac454ed3a8cfd1ac180509(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22c057bce33d192b89c4e19da2fa51ed17b468b14ed4561326799ff123a018ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a6e8599c950d4682a1be0c2e8c88fda5be0f45f529af109679702afcce0028(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82c4c8adc521038c3f5c517fc2321c2cf54a1d7659b765201a8da87ee757d5e2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55aa2aa4c6905b4f5fb201daa752ac1e5ebaf0e54ae29cbc8f065e711706acda(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c418333f014d2f5ecdd02d5bed5816a83eb9f687cb8f7c2e53073701a2e8c32(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fbe22ef5b95596cb78391854e321f075a603221af372b8728e36b6c4db1936f2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorLogCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__beb94403b10d56acc7f3479e6db0755dde2ad132b48388efcf7b7db997eb808b(
    *,
    api_key: typing.Optional[builtins.str] = None,
    buffer_size: typing.Optional[builtins.str] = None,
    config_override: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    loader_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    require_pci: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    title_optional: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bafdbbf953a8f3b3218e221b83fac7d224687b00bd10e63eafec66a789ba024(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15df56f4e4365746d5664b96365c541b96b4383bd96c73289c48a8cf46914525(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9ad73bf95b769d0d6e9c17e77791f61cd006b2c99b272967a50172d5d2e4eff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac8b3d0c512df5192d0f28d4db7f6a20f4c59aef981ddbbc5b673404d1ce16e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db392791ac4df7937b869f6110090ff8e52fcffa0061f2878942236e73757fbc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef2dac179c3ed87cf57f9c96c2be5625ed4708ffd3d8d9ca703e4be474b24459(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0854f9a12e5cb6689d04c0dfdaa2b1ed9344369ce64144353884bf3e23b689(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ca1247ec9619113cd7312c370e717fb38af3240bdfccc14885804ff11abc9d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d97561ed57a3c53c74a2043fbd9ae4daf0a02aba7e8b6d16a394a40593015395(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__869efa5da08a644cb9fed2cec8ac799a28f749643a1337cafec22a33e5d40598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c2d3a66a56324b8333f22cd35fe72b0ab14689b0d01dd7f283b195644d9d664(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28cafb7e65654badaadaa1980ceea54b0a128b30acb29f75a3186dafcfc6153(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMPulse],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef8b52aa65fad53a59e52b2738248b15c74b989c7c8af3c1d6f8db1e19f6b92a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_enable_debug_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_filter_in_bitrate_ranges: typing.Optional[builtins.str] = None,
    hls_filter_in_bitrates: typing.Optional[builtins.str] = None,
    hls_mode: typing.Optional[builtins.str] = None,
    hls_preferred_bitrate: typing.Optional[builtins.str] = None,
    hls_query_param_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_query_param_secret_key: typing.Optional[builtins.str] = None,
    hls_query_param_transition_key: typing.Optional[builtins.str] = None,
    hls_show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    hls_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__badbc5eecfbc1f8110c64f37ff1faef255bcc59e1c09a3b91b6f2419cde7212c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d490f1e283aad01d66c5a7361a4e06ecd3ba8c2def522c07978bf27f99390131(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8387b250aa257a09f8ddf73a73b303d0011ac5350a25f760dbb6e18b764418b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4a972452c9d5ea680a3cfc7998bac28242e888afded7c00f85f84ad644a0277(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90dc46a6df813e31609acba98b1e050335269fab5ffb191065ec648dba031b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2c76670314153ad3a368160f0b450a95832951b294e8c311ddcb0905da0f7dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35e0782fec76b533e0c71fed5ea2f0168b93b4be10a4780be1bb14f3bb8a7065(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9e131cfb68d725558c8a7a40d01e1e64656326c07e31b70d26ad17b6e706f27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae9956279d2109ad5b2813e517923d22ebb51ffe60a19de02ff930deffdf3980(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__831e1f9d4af91c5add2245c5209a00ee6a2f8e3a7aa6b8a50af1441bd079d57a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f6c14db47d5a2752fd6b23ec9680eeca61f0ef6ea2f7c11e0be12852db8e403(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9d47ebb3abad4e6385a928eb5048282b098b75504520181d3360be949070ca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f89c056832541d9cc9987bdb88ef8b570521e58016967ae79feb6b659261e2c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4c8d3ab4e0423434fa3a68ff8291c0ea103ef9eeb31b1d1fbf6c086cef899de(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__abba7aebe7e434b834fa54273a2e5015c9c662ddf0a49142305f5bcdcaaa1465(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b09206538138428f22e41fef90c3d1c9cc486b38bf7fe16aef92a777cc531ad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__479475f15665d5377269581613aac7abf4a00a34accb4b0ed416368f198aa919(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestPersonalization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a5e544cc65ceda4a098399a608cba79be43a8dd2f7a99c8cd1f18abec3907b2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    username: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__843155514a6e82da2cb3e603cb25a5fad2b8771a847e64c32b83f9a94dc03efd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__320b3cbc4be7eb34b40942006485a167b6ffe2433573a293eb16eda5d6c8845c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__529078b1bf4f1176276e6808b0e813eee3ee06b8b4961cd4260962079d7647ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be8414c436cde914530f192412db188bd6ad461b2e6126fc4775298b5431b49b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e31b295e8f56f3ccaf4a5a8c8e3dc419d71d12ba860eea588d2c02b78348ce18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__212bd261badfd453e7e26bd827e9c9714e6450e287107a804766ef4291cd08e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e845ec354a8fb317a74eeaefc31f3d6da4578a89fddc1b648175f7d8942ff8e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManifestRerouting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71f54ca710cdd1749a1c3d6a0804826bce98a445768663f918ca39f0930aef40(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serverpushlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89670eff3277630ccf41270df8109678f64587e8b111e13612d655c2b0310218(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3633417ff7d5a26a0788513671d8f2ec16daa5492f3a5941d55955f0e1ce948a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__954d1cd5057ec9bfd561dcc0de1627f0f7512588036ae0c324dfbe69b4344d8b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0230c3e7163e14771a4b5f313c1c8cba8475a7a55fb448c4c1732423981c5b87(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fba0657670a8f99e3c4b3c4859e918e4aa179d5b34d9a06cba70fb05e993d03b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6783c6d6e27028d5e55f428ae7a39d0c8ddc6ccce96507bd895e4c48927c2ce(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorManualServerPush],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a99f5605792c37a420e28862ff87e4a2e14db9f5b53eaa1e23d8e7a5cd4587a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ff5fdfd574ea9244114dce3afef8668991de124e59484ffd08a49728fd67816(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__072221981e23b76c6042490258d629688ee35b4c3f3d0e151fd9aac8e0b501a7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b4fc36db3ff23e9b27c8885bde38242e4fc64a0f869d4dbbde9115b22c37f38(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3906747a32aab08bed45110718194edd034ed4611a678aea971f4998432adf03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24e6d23248f705dc76c980d84d73637fd68f7345e8b42c9eedc41e6cde06fae1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d2c43516da79a74f689da26937e6991b52c2351d80b3e1f2e90bd9638935def(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAcceleration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ac1a8ba1033551aaa39584eb89f49f318da687fc10b03144865a6efe19aa679(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    optout: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ab5c02a7e60ec8efdb8527f155e20ee53392292f80bd168c42a3783642a258(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34582cee0dc46ca934648924e2805ca62f8866d03ed5b1a843bdb21bb64fd275(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63567fb7abd643c2a669ae5d55b9ca3010b0ca9b16e5e673cac94035ec18821c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b4a0c65bf160d9850d08863e3ff1c357d36a10ecc7948267245c8941ae87dac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98fbea2267a2da819eb7b48f39e5afc4b780d50c5b4425fcf7b661a2c5a67955(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e94f713e0d14888942a50c7c0d8fcdfe7528a0117b434e1ce21d7923efa058f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaAccelerationQuicOptout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b604d2596b4f72c174abd3031c326c1e97c5f57ae2b7ca564c8d187dbf2d101(
    *,
    beacon_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_hybrid_http_udp: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33ce48d03d71899a8415761b2ebe45c10cb46dcf8701c594c84584e5da6b7c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0447591e215754c2977650d3d48e0a222d71a60dc726a84e7d24480ca4dd1dc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e7c1dd54cdc1628840f60e6fc1d84f21ad0fcb804677acb2dd0d4c175ea37c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5112273fdf4d84231675e59a9b8f9ab946a5a6265ce4f3c19a58a040f8e33509(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be2125ccd338815dec2ea8584f04af93aa2107014f72873ccaf910ccc92f5cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6132af03668a5bcdb9b888d1ef8a6153883b10225ebe9b2f1cf441720bacc338(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f24af2ef334205dbc14784642473115cad248c70a452ef907d906feaf517a81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dbd39b5c94161a12d3e25382ad830536195b7401e0b8f1580a0067cc984f98d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d11b4bf9731bb8228d3bf745853b3eeab585f2f54da4b6fe542598f0e4727bd(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5e525c69147109db6a734c0001df2141e0bf529e3e03561b4ea546d9c2aff3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161a058fc888d3b872b7f1824279ff86a8c06570911ed6b78541231931b31fed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed0261aa82ff848be8dfcd0e5b1a38619b6c36970411d2614ff614b4225e5a5a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2692e99662875de4823233b453911cefc69950ede689aa5741e49b1f7aa3fd09(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0203bf089ce3d83061bbbbb2cce8025bd7d1e3422d13d1d330307214d87f1cab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dcef50c39d968fb810f8ee9853a44400824de14ce15c2e5b1e60d39207527ec6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaFileRetrievalOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c3b47ac97d86c104846bc9948754995d1569387ecc4094465f72a8181f76539(
    *,
    cache_error_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_window: typing.Optional[builtins.str] = None,
    client_response_code: typing.Optional[builtins.str] = None,
    detect_object_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_object_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unavailable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unavailable_title: typing.Optional[builtins.str] = None,
    detect_origin_unresponsive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    detect_origin_unresponsive_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    object_unavailable_backup_host: typing.Optional[builtins.str] = None,
    object_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    object_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_detection_level: typing.Optional[builtins.str] = None,
    object_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_modified_path: typing.Optional[builtins.str] = None,
    object_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    object_unavailable_protocol: typing.Optional[builtins.str] = None,
    object_unavailable_recovery: typing.Optional[builtins.str] = None,
    object_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    object_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    object_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unavailable_alternate_host: typing.Optional[builtins.str] = None,
    origin_unavailable_backup_host: typing.Optional[builtins.str] = None,
    origin_unavailable_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unavailable_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_detection_level: typing.Optional[builtins.str] = None,
    origin_unavailable_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_modified_path: typing.Optional[builtins.str] = None,
    origin_unavailable_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unavailable_protocol: typing.Optional[builtins.str] = None,
    origin_unavailable_recovery: typing.Optional[builtins.str] = None,
    origin_unavailable_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unavailable_response_codes: typing.Optional[typing.Sequence[builtins.str]] = None,
    origin_unavailable_retry_limit: typing.Optional[builtins.str] = None,
    origin_unresponsive_alternate_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_backup_host: typing.Optional[builtins.str] = None,
    origin_unresponsive_blacklist_origin_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_blacklist_window: typing.Optional[builtins.str] = None,
    origin_unresponsive_change_protocol: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_detection_level: typing.Optional[builtins.str] = None,
    origin_unresponsive_include_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_modified_path: typing.Optional[builtins.str] = None,
    origin_unresponsive_modify_request_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_unresponsive_protocol: typing.Optional[builtins.str] = None,
    origin_unresponsive_recovery: typing.Optional[builtins.str] = None,
    origin_unresponsive_redirect_method: typing.Optional[jsii.Number] = None,
    origin_unresponsive_retry_limit: typing.Optional[builtins.str] = None,
    other_options: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c94216cea022b11a9bf2a8da80f3024f3e2b985ddfc6fa56b6bc613812df6a08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__595f3c7c2b2ba64532c5811ecff8aacec96167c23591e70b7a5ab5dc5489b4c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f3ec238baa5990dd143a9437b6b8867e2a47d90e16bd69134cd8ee2d8a4a1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc1cf89c7c13d31274913df861c9271158f1b82a4fe76fd130a971304d42451(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02953748a3f4beb3f54958cc913a62818dcddfd105a036a462f6639728ff2e06(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aeab18a5be2c55bacda26cfc7ce98368fdad451335cb85c069a8f1e968c3788(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c4fd77795bc1977e46c5661a510a849a01381a41ee32098a8b5ec560a3f5c8b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2fdb9e618138254636f107fd4b5766b290847d79e285ca840a536979a9bd2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91dd92664a2b7608ffa469f48c25d7872564be9d5e758e582ff1e0f750250e52(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a93ba412b1f65f11b9970ec74cbb1c5f0da1b6a2e68efa86fefcd6d5ff2e409(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca47058355d04895c5867261cd22323b89750f24f6fa51a5338b35cca87f1b88(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d2cd69f3d8c083c7ad6d654e9bdfd879eaa2209ba49a8347a5fc8597986b3b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fcf111b91bd21beb45b10867d4a4b3b1c6f03c8f3eb38ad8ba5de0834beccb5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d68aed7f94af34f116d737698b4e1542b996c22a16a5cdbb1f19f8b0df67f5ea(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9df124629f1037ae5cfb5366e7ae4deb500fe8296c06e08e9d6da40fef890fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bdc92b3c2e673eccc7ee356a5a455d8ae5a3642925d2ae1ce255b35786588ca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d9600ff750596494a1a64dac16d6665fa5835c2e53bba371430669ba692b8a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74e7bb80a8c8f9f3a720b619891d6db6ade4cd123f9aa4aa690dd9c69dae28f6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49991d17c3cb6bab0f6048256d5cddfa3d189ae1c2034bb9057a31e83c67e089(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1be7b3ae268277f0c1305a8a134feb00fd0417e73bf92be8ee857a12b2b62f3f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd4cf9d3282216a7961abb6335ca195bc3e79f510645dd02e5881d5e6ddd2def(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d81bc80973146a331603c0f83fd32744eb00a0ddaff12cbfa34ba47f57c1d735(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21726838e6425737050b033837a10a0aaf1c5d98a6eff15c57e8c3aa51e25b5c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1709aa465acb841b8549cad7329810d55355eed66ca2d607e0b7e5b492d8e569(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__423e81e2e81639b2820428e888f478515f4111989718175a3c12644c1b33f3fc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69b46d343fdc27ec48b80c50f8b4f8dcdb16f4f6620edfbd62c47c488a66d2f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9cfd84a0a8e23034850fb662e59aa96f4fa24628b56dc370bf76402501fe916(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cffef49ea72d037db749db2598598b55ddfe07e864a4d548451f2d9dd415325e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__661fe96888fceda81f8e4269da318b6e45673a54f04223340eec4742e890031c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f19a3c327f250102f1f75158f843b1bdde79a93bfb260cefb8c79b2e114c62ac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7e2e87b1aec58776adadf25c72e79e726b0f952cfecc99d7013d94bd60f793a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acf6ede2fcb6cc89de7902190c4131bdb0e547a3b8673aecf03cc5c85d48f1cc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc72a8d412228c8902b0f68d5a83dc219c428f09658e91c0d911ebdd6ca5edb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7f6ac0a6e70e8e38fdf7a6da12c673f35eb1dc2a49a3a6ea22f71fddbf175c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab361e50ccf6144e462459f903c89c629736ed46a5cae92cb23ba5c1cf506ee1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0756048b03e36d6077b981d9f66ea824953bb9cc63b05d4b19a25a1f91b4c635(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__044630fe69285ed751847990059a1d55315ff2a3a1a3ac1b3de4cf7ad7da2e95(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0df6cf3480b0a86a72e12696040d3e6435f5431717ba193e16162e21356a020(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa626c8d07b8335eb8134eb73f1e2bcd0f411784980aa038416b078310b9959(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a12552ce24cf6a12d67f034628f63138c5b7255510e3039975b2c9ddf6db153(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48ad64e8526fc321f5baa40f7f12085404869d051cac4b8ca05c4f9b3ee67bb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__762d488d37fd8dba64cc3bd8690b375475d9a490f1474a8eb3117e4a802b7af2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e772d22a808545aa34a163a4a741c7dff3a81e11d4573102a24401f0714e2a71(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d23ab7cc134658579f19e29d9dbafdcd13488995fad36a62d6ce0f5d7e3fdaca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe9a5754bfac4030091a7b9a4fc0fde46078aa57e16cbaf3164df168dbaa4b02(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eac1854929cdf1365ab7b110077c837ce17b3e41067e175516229d748bd62c3f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__671c32c3ce7e22c4129690d62243f7d34dc35207652350222bd281513a1ba2a9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c241d9647e20aca543d64ede5002528da36bf601aaae7ba5503a4cbd5911ac75(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__754eeb16f93303ba14884daa479b64cd23c4979eed587f592e0194f4d129be39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb39f2e9d797d84f68b521ea7ad5f389a53f662fb1f99ce277ebab3682d246d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__162985e02e825882241d7e75714207ae525c369c53758a710612b60ed8566857(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b04dc87796c7352fac3d3c7a965e0fac23d3addf21f320593ef64c00dd51fc45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad12210a9aa3b9c739691cdc1fe895ef8e7d417bf1c46217be86772f1d19ada(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff499eaec8257372d38e52bcdf9d042c3f35fdb438b740cf7c96109429de5750(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__965cb376b9d0941eeac4207b5c051eed2fbf78df5aeba36f59ad5711bbf68774(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cc4b8506f2a68328ad0a3978da860e7172b669924f21b8082adfd6e93c94e1c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMediaOriginFailover],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2abf60bf510270676e8f8a1a93e3248a0f9dffae508f9ff13017ca617f60f21f(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baf08814f4636d658f6b50b34778951eb51f183df217c8281b17e0c2fd94e158(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa22adfd2032014530d496d6fc6d910b96d89c256c12d447e654032e3c29f199(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af9cd6415ba5ade9ff2351aee09d15d6552cfcde7c92df714432a83e72e9e3e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04802100ccd5233d0bf44862b7de46f0d3aba5e368a53e63aec92ee096135276(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18585fbbac6792b260efc7afbd43b08a91bb69c3b810da05ae734689235f4b89(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d52f7f81baf429b1709c11f9435c50e3088d35a069c78d2cbcec070ab22511(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMetadataCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9540fb67b745e15807bb4ffb545afe6e3832fd37918c93255575ad4cbc6ef780(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    secondary_multipath_to_origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31189cba8ce10dc2622cfa817770f9cd75fc642eee93c5aeca44aa56c37d7e10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f89798c6196e3cbdb6790f48ee05661b2d403c9950bc2e5455ed7228e9437d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecd3d1b0a473a2c291edaa589f5c48fc6cad92064874b2722d49942bc236f202(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c123d15d9f64f4cc46579e675dc5ab7fe700db9bda76c5e0de2347272981c85c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__969d763dead419cfe3f9770ec6858540c2adde7674a6b6e029b2d9f5b9191433(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5131cf6aa6058d3d4e2aef4b8b4d7d489952cd726f90e18e9391612062b404b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93d59c2a0dc082109d04d73e53612293bca3cd893f5eaf544d85736e53a95027(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorMobileSdkPerformance],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e02af80433b4b1e58849b2b412879102b8a4f8cf3c8a50410f73072d85a3deac(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a12bebf8c662094cb7cae91ae6e9dec37dfa903a89cf3a3ddcc9f526e086f7ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__639d65801ed2c725948c064d28a815462f723bceda8203da81ddb2b7aae9769b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb70395d6da3bb4a167e8ad73d3bcfc995016b77a90c93dbd744c71eb321ca6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b8ad99bd9885271b20c3f3e2d213d2d99b02fb77e2635983eb847001ad9730f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cba60dd0c676bcbb46dab788324b0ce512b655e7e58817dcd6b58894469e2b20(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4053ae7d15e5fed28f2465246fc9076da30c0d31fb0f09de2e72b03da431665(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f080c35f2a2a3456a4cbec7a39b1e3c0b81a8357f764c3ada3d4a82205439f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78b44b1b43120986cba302fabd37c819307dd0a9bf050b38379319163dd9e8d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc79e29fc96eb112c8f3c54812229160868ac93e2e37ea8a18aff55f7fe2cc40(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c067b4f138763f5a5a665efc568186d4863bf8a93c898291d85f9c7fc8af61b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb6e24b98a4824a5669b47c3a254950b10b7bee81b1a070560c42b8d37f158f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0360cec6f0b3a0303da24981e3f4703f468312ca2e88eaa191a969291d90f04a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71754393addbe5ece715f0420b3c840c9f39f59746b1e935eb8159062b5b5eaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1311abc5b204477f9f610dc48c95087df2f27b3fa40562b9775a90f43beacef5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1c4fdd08b308b1b914a2f7acf52e5fa90942858d2c8d501eecc51b04bac8a69(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    standard_pass_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__786e8544836be59a497ba51027c08d6f9bafff63ffb9b1303f2ae88e42ed6c13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc7289174966e5133a0b7d233ea14987e51d8fbdeba68cc48de444d48a0b1a82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__283c213819e432526e0db235f3b597b7293b9be2c8255bffeb36cea6eb423586(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18752f8cc817455ee2613148343a63c2cd97f68104a8901fa09911fe0c6fc6f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf27d25af3cfbadce5bf4693d2eed660d062b3750b23372ea304f88e428fca9a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3f86b30aa303f76c72174192e397e85eea6130de9831ab6353261c52024c8a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ff715191905caff32594f9992e14fcd55ea8f8b379cec2e44cf6555bb5563a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1536c02036485d61bd29523424fe5941d91c9f68b24f7f4b651fba80d72e65cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b53d427345d405af25d9c12bb4f3179df176f1f0d62dd069148b9898425a23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce0aeb7f65f06bd9782ef128fcae198a64679f7c2b87dde9c80b9923c8ec5327(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ca5b653cd83e2f4f826c4293046b9fcf9a4b60e97b1b17de2a281f9d966c3d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c78c6e052798f6496e9710598778c23735184365158d4015da0dd22ce5a5ec3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d32ea76b8cf412cafcf276c4dac9b8a083a288db2ad9a9771733cacdceb07d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025b1050a0eb6f29dd4911168ce86ac499ac5b88ada9a3ae9422dea1a51e8184(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyIncomingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__909e31f7f101958683faa24fd7b6408f98f90b9c39fe649ba17a5185298d08cd(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93c5ccb541c3b04beb60b5c705a4a5a9bf7265cd9d010075d1b13a657e5e3f3a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9f23dd47469890d6599dd98d9c4aac21363b7e7796b0950b6d372b68d53a7dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97c77879498b40c6de6d55e352fa400b4c182678fddf0ed85c637c253c09929(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dc7c7aec75b179b447b7529785fef5750d2fb32a6c2d928f981fd99780c22d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db4268efcf83151fbdc36de14c7fee2711c4fe16589d85fcb58703045922625a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98afcde48929e52f9f7dd554d3c18c74b9e3dfcff84257430d6704d1f5def379(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e4723bb23e84e23628c729f8d5f0f3566032ac6f645a9a3df51ff3e2d9d0915(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421be889610b93c343929cbb0cf94bb081aed29643baede0fdbc5794b5949bdd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dae8721413b9d5a006dfd067bfe0a72e9d767b2620977fc5262ce27df416e0cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b74df4a7e45da27d7f43c0a54b88f34760514394f941c4e59af65dad02ef9638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f62dbea4aaacaef4f01133a27025be13b10fd8fed961f6bc270ede7dc9e005b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1be0ba97eb6d2674b4f850c03884a2a86cb0904472085206ff37598528ed0359(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8ae527aa0e25ca74b37f64d94c9f6fc43cc8e9b16702cbbd9f07092378c5f14f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de60b0eda11859624dce910f5d333e69d5b10dac5d1fd1541a8fd65da8d87de0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd557b035b69c4e573605b75afbb9c57d55d6aa908d9b8d690e33312f8b6b4ab(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78aed3e20ac9fae68ecd160eac6efe57a7ab405c913dd01ee980ffce35c4e8f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d14cf0b1de8ff62acaba4532db1fac3cbbe9191314a95c9d705d388ec9f7892(
    *,
    action: typing.Optional[builtins.str] = None,
    avoid_duplicate_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_header_name: typing.Optional[builtins.str] = None,
    header_value: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    new_header_value: typing.Optional[builtins.str] = None,
    regex_header_match: typing.Optional[builtins.str] = None,
    regex_header_replace: typing.Optional[builtins.str] = None,
    standard_add_header_name: typing.Optional[builtins.str] = None,
    standard_delete_header_name: typing.Optional[builtins.str] = None,
    standard_modify_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e9734a172f7daa4cccfb94c0db7412a749e514089e6e501604998bae8a2827ab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9c8a75c4d6ba0f7c8d64913676024083c21d24611bf9742ce9bd6c1b2776fc65(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94f58a549cf27c1ed6ecc885455fd9bb7e622477af5e094491463a64b2206bf7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f35c31df6db56a53c2ea13dab5ca254f74c9f004d603d94393782ea7114f47e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2dd82d18d08c7020a54e6f5fea195375f2595cf8f22f77184e9b5009c878b334(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9555f413b61f32f033fac2772e8f73cc407f39a852d8f316bf4c2e34838a4e6b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29d39367c567e2c4999b52220d01e4ee54698d4cd5d5bf4546164e57797a9d9c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1580ec9113ea8f290785e0e6fb5015244f0ffda64f6f8d85a8b47a160eb6c557(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1dc8b05cd9af1fbca8a336572ff7d5ee789722f095c0019f5a195e664ceb804(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7083721112af575851c33cd5b906a20c3cd0ecb8ad836a1eb3b34a1d698abc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bd88ddfdede8911f269278a173c12ef83a9b4a331576fce77f554acd6a52132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b366bcb56f216b976142cfac3eb9b75d1607567c0ef498c8fe59869cbe98c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a351398147e53989524febfa4c79fd6c4df1e1d4bd73eba98218b5f4a0c3c3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f24cc5acb95368ec806d629c0684ad19ca13b486b1282505d06598cb9076b41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99bc0ceae0b943b139b0eb9b1fa024127afea3145204c06ab492718d0402a319(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__524f57847d4ac97a0cd32adc2dda6864f6fbd8754db03ae3378633b66df16ad8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyOutgoingResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8a11408500ecfbdd941f4f18656d41723250492dd24d278c04cd4db499e9d33(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modification_option: typing.Optional[builtins.str] = None,
    rename_header_to: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b482be1b7370eb0040984e9ece19bb9b36c89925cf876c0903d9983f553eb42(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ea007679b23441356a13aa199b02fbd5abfe9b948e50c8980ff7d00fae3a260(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99fcf11a2af0bd7fef62dfdd36e8b301d0aab463dc3602076ac82bff94d8289f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fffcc8848f279ae9d19c05033e4a97af2694a41c9f8f4a98895309c3b77306b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad26a2beb0a362b19f7dc1b1ca672ad51c9501890d1cdd77d647415f9d36f0cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5291a770ae94e8c3c8825c181811427dd0c5f5ca334dcbbc01ffc6f3e1c5f4f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13e2ec7fb0f0615cdfee3ff52d14d0f5009de7ef85bfdbc11484273648d0bd01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e565319a8425f2cea3085a5bab785ee6eb1dd15cdfb25285b6a0191bc81622d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorModifyViaHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b371ff458ffc0824504ff224bc0398fb39ea7311c22d6a4e3d09c6be707c5fe1(
    *,
    cache_key_hostname: typing.Optional[builtins.str] = None,
    compress: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_certificate_authorities: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_certificates: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]]] = None,
    custom_forward_host_header: typing.Optional[builtins.str] = None,
    custom_valid_cn_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    enable_true_client_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    forward_host_header: typing.Optional[builtins.str] = None,
    hostname: typing.Optional[builtins.str] = None,
    http_port: typing.Optional[jsii.Number] = None,
    https_port: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max_tls_version: typing.Optional[builtins.str] = None,
    min_tls_version: typing.Optional[builtins.str] = None,
    mslorigin: typing.Optional[builtins.str] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_certificate: typing.Optional[builtins.str] = None,
    origin_certs_to_honor: typing.Optional[builtins.str] = None,
    origin_id: typing.Optional[builtins.str] = None,
    origin_sni: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_type: typing.Optional[builtins.str] = None,
    ports: typing.Optional[builtins.str] = None,
    saas_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    saas_cname_level: typing.Optional[jsii.Number] = None,
    saas_cookie: typing.Optional[builtins.str] = None,
    saas_query_string: typing.Optional[builtins.str] = None,
    saas_regex: typing.Optional[builtins.str] = None,
    saas_replace: typing.Optional[builtins.str] = None,
    saas_suffix: typing.Optional[builtins.str] = None,
    saas_type: typing.Optional[builtins.str] = None,
    second_hostname: typing.Optional[builtins.str] = None,
    second_hostname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    standard_certificate_authorities: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tls13_support: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    tls_version_title: typing.Optional[builtins.str] = None,
    true_client_ip_client_setting: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    true_client_ip_header: typing.Optional[builtins.str] = None,
    use_unique_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_mode: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49a703847002a81e81e7cdce710b38ad36e7cbe53be9032f4cb7f246c3bf7e65(
    *,
    access_key_encrypted_storage: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    adc_title: typing.Optional[builtins.str] = None,
    authentication_method: typing.Optional[builtins.str] = None,
    authentication_method_title: typing.Optional[builtins.str] = None,
    aws_access_key_id: typing.Optional[builtins.str] = None,
    aws_access_key_version_guid: typing.Optional[builtins.str] = None,
    aws_ar_region: typing.Optional[builtins.str] = None,
    aws_host: typing.Optional[builtins.str] = None,
    aws_region: typing.Optional[builtins.str] = None,
    aws_secret_access_key: typing.Optional[builtins.str] = None,
    aws_service: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    custom_sign_string: typing.Optional[typing.Sequence[builtins.str]] = None,
    direct_connect_geo: typing.Optional[builtins.str] = None,
    encoding_version: typing.Optional[jsii.Number] = None,
    end_point_service: typing.Optional[builtins.str] = None,
    gcs_access_key_version_guid: typing.Optional[builtins.str] = None,
    gcs_hmac_key_access_id: typing.Optional[builtins.str] = None,
    gcs_hmac_key_secret: typing.Optional[builtins.str] = None,
    hostname_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mslkey: typing.Optional[builtins.str] = None,
    mslname: typing.Optional[builtins.str] = None,
    nonce: typing.Optional[builtins.str] = None,
    origin_location_title: typing.Optional[builtins.str] = None,
    property_id_tag: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    role_arn: typing.Optional[builtins.str] = None,
    secret_key: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_custom_sign_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7560fef56f48f62e283ad4dff97c7ab8de37feff5ad2b7ed662dc48913be2a8(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef185933ff289f3485b881ca410389296ebf137a921bae8d30c926df368b18ca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35fb585a2c8c1048338c5481c76049f66c71f79bd8757cb5a617d7cbfa5d3564(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1fc81a3dec21ef3e33ed71e5f6243f7a30826e798a508f6aa6fbdf885761e3ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9594c406a33fa174102d3ab97e5641fff5ab77a5519ae28097fe5413d243c38(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06acacc3112494f1923a7c831e44a8c50cf9ec8e07fb3c0490e360fed555237c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a03b98004a55d9f833052663cdf08ac4054458e3a9259fcb359a5a9f21ce4cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd997c9140d75842e354b056b7ec5d62c02a1fe73b7da11836c7f3bd57bbb7c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f3a87acac0493646e0a2c1ef5575ddeddfdba53ed9319bb2de99dc2f7955e3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b1c2129abb4252f1ebe7f7c6f7543c649db81433fbea4f239d53df83535f39e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a264cebf994e45d828c80295881cad19b9b6caa5c252b22069967c2377688f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7c813a27acd9250783705bc74323ff55ad7f5552c09dba1ef6261e686cc5c58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baa7213cd38dd002f8df1c5be96a1be123286ad6bb49d5cd5aaa6a46ac3ed13c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bac801b022701948143428181cc9229ecf66c6478bb56a33f20cfccac876a2c8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61ccba51c7fad485623594ca65fd1d0947de8ffea1c009b42b66a695060aed39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87b598bc9364eb72cb474743efd79342fb3603fd5ff42eeb871cf5dd07ad4c27(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05664bd3616842457eddd459e23ec22b15829bc36900db17e1a3765c8dc81eaa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71938c8ff3cdf9a588d356c9493625e5c1c1c229aeca57f5050f605f882d3155(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e8f8bd423ad3a534b5e7f252791d92f46a5f3436036959cec553c7446d42442(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__60ce846baa79a072f0e5663f2fd916ac7ce13bfff3b345a20497b021e366f415(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6cd0107dfb9e82d81a716c49b06f2179d84a1b8465f16d3385dee551f364018(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e383b72e51553212435458f9b05423583f36129d176eec5c97e88f45f9df651(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57cda99e98069ee36bdc7461308df94dad6d2a7d89ea9abd9cdf1c0ab1f76948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a89505cfcb908da5b9fc7fc37f9d4ed6d0d791fd338ed92b118b98f7b694a00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8f0172a49b87e44b8661613703e68a863ab218084ec27abf198c5651939544d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b359136c0a72b519f5be720d964cb0ccf8f5d5b432bd507c6d221eb22140ea2f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4a213446f4e5fe6514a6226d3f013f3939744ac5f4f8e0eb214a84e229f00a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294f9a0de032b23909335619a1394b0ab4bbb323dc37e55dbade9f932333e0bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94bb6d07a5260e48858a42b4a755f1197e5fa72f24a7b97875e55a9c57d22604(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__616266bbb0a197d904aaa14e90f7681c6efc7471e10a29cf4e16aa25531016a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33de5dffdffe85dc91348c39602014eb5b3502cc1d7ea28b56ac9df8a8aae6f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__baaec1119fa94afdd13d68a39bd7c83daf568746c25d2a5f91b5238c7f15a74e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67aebb7f38061a9532ed8de097449082cd8d00a6a201dd340a963f9f634ee7bf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristics],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5831c6700f0195dbc738fa7a72d06b9cbd8f4532ba2000e94384c21cc2d45f96(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origintype: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c117baac34f298bdda8aae0ab81473bac11a721d09107f8fdd2dbf2883f34cec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__493f7cc81f8dd2928280f4ea85a855836f13b014d270da6b6962c678a7358874(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02109a60e0765ff73cdc3e954b244c019c4abd249f7e3d037dce398bbfb9bc91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fa24c3cac23bc6c1710e8bbaaf82644d6c67e6c3aba9f93a41c21e0e27ffda4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c2e4a88e9c382825c574dc29b605fa062c755fbb8f03179f65f87ab307bab307(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5093e86715ccf8c144dd2ac1acac75780370d0f12a150d13c91a09dff9256724(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCharacteristicsWsd],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b076456c5f6c8ef40afff998c7cc079c401478e08bc31d743e2b113ee3507af(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b2cac2de32d818a07d6d9feb5308184e02ca695784036b287f2c095e6b8fa5e(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7796ded68060a1e4b9d607b012bce38819c3033ee8527d42c479c605169101e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4de623d94d5cb018a13bfd1f4f4b60bd65f0b2245beaae3e938a802059d538e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5941c6013dbd31ba7f1cb08f142a392141322629ba1808708a609e281b0388a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57e4161f8022fac23875a6f263fe1a61ed031ec723cefe0cac268ed16d9ce6ee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9944bf6e60adde28926fa278fb6c9626c5631c1590920db29c36070ec5cc3cf7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db9768d39e65b8687129130400e4cbe3fb893fa3eb425a3da419131c35db7485(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe4c50598ffdfa5e2bba76f92325937c0e359165df91ac3353c25300b8791d31(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1709480d648333a612b765473ae1fa58be8906cb707d8034d4fc4903f0f4e5ef(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d22a8deec098e167887e2cfe3689fe750d6707e15f40e4ac68d3d2a20e5bb4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a794d23b410e0bcf89ae11f0495ce33c3982f1e77ca7cd0a43e1448440840df0(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2934b1aa3eabb91a6f18947a869dacb28c9fb94a278de9e599ed25585d9ad4(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78566649d785f541151c1345d49506f7ad160c5fe7b9c939915e717ac1d6e249(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__356121a15f52f159931982ecbd3d615d85a114a24277b1eada62c980ebefbd10(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2f4503953b1622579d060dfd335cff94afef93b1f3311a9a9ae1527cbed0be4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61afd42612b5c35bfe643465da126c145818f0f54dd2d74b5d4cae6112f7d674(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4809640f86cee2f2d45b3fd0acda5b0ffd78c03b2a3fecb71482e72574ff24(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4d2bd16ad1b628c6f77ce9fac9dbdeded8af27f83a90d36755da5d274ea7f0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2c5283620bef581adc76359b7933e7ef45e496a3fb6878d0d659effd90112a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a551ef827ae5ef3d3dbd96b3de913c7673c4b521fdd63719e31dd4c4c03e910(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25576b6e08a006d1fcda3660051d93dca8e5c13ccead285bd1fec9955656ea14(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db01ada76b2a87c8b4afc5ae8a81d2b5b0293728dd65c09727273ff76140f132(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a81bc97943129e64f3d6afdd1508da2fe5f2a2607e6b9563d66a3d321fa5858d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cf3b51c0c1ac9dc8072fc490e13dff7b2e71c0fe1bd488968a76e7dccc22811(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b8b7e362a0d7f15b3c310e9795cffbbc124c5f5f61f3ee867e8550ed1445be4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__372bc3eda3f6bcb6cee2977769cd5c0c84f2787b57a8a8ec03e38421782d323b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__50cb6d024454b07b4ea52066e6be901e7cbaaf2ca6156c247ad177ed2d1c52c0(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80c042085dacd8c0c310b6136163ced0152395b9bc1c575bd48a2dc6599cc88f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2e5443979215c47ffb5ce0a5e5d58a4ccdd4411d5f3fc89b1b5c9af89e3636b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12f0ad967b9df6722b82e175bf02cdcfb3203a97c7a346adf4be8d749bbb6804(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d8fb2a3270cbf6a230daef0cdf20719e521b7197807dbcab10092b83092a2b6(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02a201447681d27cd952b75dc7bd953fbd065588262a725bb26aea4013031d2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d067cd5739f65efa4e78f2dec461e986335df3afb8b4cedee67b47f29bddfb7a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96d11369b31bc6df9f00abe6b3685a67e19b6d41fbbab84bea6dfc9af74aaaee(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41e26451573b6e7900f5992ca201cd40dcdb41930daae37691d51636029e95ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__124d26c5c3823fe90d2814364c91c107d9754d2e228226fd1ef66e5d4ac231a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599fa383fda799025635be51b873ba5d83e230674492f22b5661b4b33a118499(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthoritiesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df350bc65ecf4979b0dbc8fbc1b4c486c205220a835a50e4949a6924bf3ba2bb(
    *,
    can_be_ca: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    can_be_leaf: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    issuer_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    not_after: typing.Optional[jsii.Number] = None,
    not_before: typing.Optional[jsii.Number] = None,
    pem_encoded_cert: typing.Optional[builtins.str] = None,
    public_key: typing.Optional[builtins.str] = None,
    public_key_algorithm: typing.Optional[builtins.str] = None,
    public_key_format: typing.Optional[builtins.str] = None,
    self_signed: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_number: typing.Optional[builtins.str] = None,
    sha1_fingerprint: typing.Optional[builtins.str] = None,
    sig_alg_name: typing.Optional[builtins.str] = None,
    subject_alternative_names: typing.Optional[typing.Sequence[builtins.str]] = None,
    subject_cn: typing.Optional[builtins.str] = None,
    subject_rdns: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns, typing.Dict[builtins.str, typing.Any]]] = None,
    version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb1bc2479bef465702d85be99ab970ea738e24c133a6f0d121de4f9df181852d(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3c5e2fba20894a2f25e4fa76925d82a2a14deac44f77c5cff00ab7001d8259c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b228542d48ba8f234b6ffbe0a79edd3e98445f878db1032894393d2011d5d668(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d04ca099272e649fbb6e1bc28421b72f5f2a49e9f1d7349f787af8460c4bfc6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__49f26d26d2002ff4086a0d723431685432544338f05b52071e606c5abab66a88(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8382caac5c8cb88fb1e6317d55fb101f06cd35cf347c66c47fda3da59dcc8425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a62ada284bed67a2960d3ca6d4bbffef54ec40696f1e658151a9f80a054a3218(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesIssuerRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02822a7400a7a494a9e54df31d28eb707900743159ebc086101e1fc5cb49af4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__425de90d2a00e28fb5de4dc0c0c3635664ce172d6724bfd977368e11d9f95626(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f0fa24a5dd438bb2eecf8c5a3a35f909e115d9c5abb49658211657f8cbcf8c12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75535e6ee35231cc916535258f0c31cff400f6993d3531da39cf8b3d0294a180(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1172f03e87b5e86ef7a246a0df1f250a3665bcdc88c6fcde901b27bcf117513(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7027a101e4c64fb18f3114377bd02ea0ddc7d3094495b8cb9026af2c44b7abb(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53907eb64d785ddc30a0404d7314a9d559c6635a6195d0c38379f06948294bb0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cf4b55a0f9c52d66b9f9bcea8791b8da2fb620bce1ce5d72d4ca737206b54366(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2c59ba697f07d7931d2bafe37acdb08670e42f07ef7cb70b937ff513c7b9dc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__219aa3eadc53495d5ae70023bd1b479ac9128ae31a05fd0ddce09976f6f4f4cb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6544dfb32fe4a9af81d347f3d17238e21fd55986f3a03fde7e29087135c528a0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1d51deb7a535286043226c311b92c1404939ea8c8d0f77c5efc9190c73ac41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2956e8d2f969f55a0cbd2b6978e2bb5e8a22f3475cf6a4a7b5d844f66e7ce47b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c877b85297c5ad8989d426388079a73b9128f2019d5357e2ea45146c6da44c2d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06edae8724c2db10152de525a10ac27bfb5c7268ed98c3c59488b92444c31674(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bae6f17bdb61db7450aac057d68a9a1091d421750438de3898a62fa3a4faef2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3886b573dd9df16ad3ebe0feac45d194625ccfa6387db2e859fcdaabbf412bfc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a04280f76858579e2ee0f2b38c4a66667b5bf68d5fad0c7d41b61f53ab4bc95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8755e379a2214463be9cf40542010aa7ad2c8cae19f82999469d632171c065d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d37538c75df459281312f703221cb443471460bb4e634ae91bb88ad44693a7d4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16298bb1b5c47fb9e813a0dda2d99a9fcd42b19e944bee06abb3b395ccd6c1ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26c6d832669a59c85833d3a899354f2ba68a8f17dbc8f50881bf2de0b7f473b0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64580cb7bf59198918e6e7f61b1d8702f35faf41e23c12597ab73b4b7a5e1272(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__599e97b2fbe41dbd3de92965a6a11e6b42e1f6087dcb22de2b480e7f41e4b7d8(
    *,
    c: typing.Optional[builtins.str] = None,
    cn: typing.Optional[builtins.str] = None,
    o: typing.Optional[builtins.str] = None,
    ou: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__673b22b8bea935aefe5b48b02265f8d67e56233e184a993995a65a9963b4d44f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3867d151e59238564712af3526ec0d90a45ba15fbf6eb1ca118a7d00c88d6ad5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ce1e4b08404c0003a8ee18ebb67608942c699c332e773869abf09919b3fa42e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a050856beb3cfdb195cf97049a123e6876b6ab781d7bd7a4425230be2783689b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cab543356b74fee1903e9d29fb825c77546b323600eda0a090836933b9c0bcde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__819f50db6a5fc0e619fb6c5a0455cf8dd414dff5c9df9afea2f030b2da7a4941(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificatesSubjectRdns],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15db40ebfe3676dac9091c28106557b319b175973a67151fbe8194f2be4e953f(
    *,
    custom_status_code: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    recovery_method: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd91cbd281b9d1ccfc8a022d32259e80ff740ce571d372381e55d4b1ac1c3f02(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1072e5f61c1ab018abac13a38d4e37edcd331137e8cd55dcb99f221bb56a02c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e598136219c90a8520f6d34bffbf889497753019f3eac4ed3b3a016573ffa9e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fa2d9a3918add49580be86619412d7a78e406057046dd1f477b676fc9c735982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72c5323df35176077048eaa97359492f6118d512090578b0c8295633e0ad2676(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeece6486b02883500dd3a79b43cfb37ca1b1ec7f771365e2279a0ba93f3b9f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ee75c497a9b49dcd44bd7ee555cc5f1b010e9309d207329de1edce184599763(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b638e9e860f7614965b5bd97f51f8c092b039872a953e3422d8f9b1821dd7eb2(
    *,
    binary_equivalent_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_ip_avoidance: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip_avoidance_error_threshold: typing.Optional[jsii.Number] = None,
    ip_avoidance_retry_interval: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_origin_responsiveness: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_response_codes1: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes2: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_response_codes3: typing.Optional[typing.Sequence[builtins.str]] = None,
    monitor_status_codes1: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes1_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes2: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes2_recovery_config_name: typing.Optional[builtins.str] = None,
    monitor_status_codes3: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    monitor_status_codes3_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_custom_timeout: typing.Optional[jsii.Number] = None,
    origin_responsiveness_enable_recovery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_enable_retry: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_responsiveness_monitoring: typing.Optional[builtins.str] = None,
    origin_responsiveness_recovery_config_name: typing.Optional[builtins.str] = None,
    origin_responsiveness_timeout: typing.Optional[builtins.str] = None,
    status_code_monitoring1: typing.Optional[builtins.str] = None,
    status_code_monitoring2: typing.Optional[builtins.str] = None,
    status_code_monitoring3: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tuning_parameters: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d1b4a56aaf72a6b54c68463091ceed3ca6eb896b93308262434c299e2516327(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__294e0f8d0c79caf6a2cfc26fb26758b4c700cde92ba82bdae90dfbb54cc9ce33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2380f876057b68149cb9221e133e4489d30c8414d00f70afc633bf8045d300c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__853423f0571560226da479255de61b8ff5f1d8e4ef61ed9e061c2fe0c9bded73(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379abdfbfe21cf158cb5bdeceb039b50d3d7bd17b27b39eb93793bda12c7d7e4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be94552f8eeab9a5f5a35b66445e73a09bc4de323745a80323a04ec408cc6ec1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e79d4f741d33d4bfa934b09f89171f3305928501f0d343b3a720eea337fd3f1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d380f7aead6ff968076eb168647c8195881a8773841376fa2743ca5e9fc99ca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b20866790eecea3af19ffa1315a1b4b0c7106029a56eec36730fb2fcd7a741b5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c8e71a5856afd85ba57bfaa692351bfc41baf2b9392367c25a847593701137(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6dc3ce8b1e422e9a5be053cb7cbf5516fa5bfc4f24d984ab518e506a30a16d8(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd42558edf00b933d3b812e308386fd1e2ec69e5cbb0325009502aa32dc8b74a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d825808b914932079c55b315e681204d415c8e8205a269f41350d621ec9f1d2e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55570879c78d27d3365bd0392e723df3dfff3d9a20e6cddfa228f1ecf5c5c7cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__003c59410ea4461391df912e025b95647845e447656ad96a8534e8781aced50f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a5712fc42efb967bec5dde24e41ccdfbdc769d5f5d89e9410b8d41416806df2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2a6759750dd6d3091d52e48f340917747450d370142314805456052be069e79(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80054aa4f61921faefd08c0b95326b371a9b0a5aed5f36c23a11c440282bd98b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__76c19fe503f1879e77c3e6dccf5dfe2ad5a688ed5d9965aacb5efc5ed3e8001f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfb742bf857608656ddb1c61f47fa25400131e5afcb085fe86cc97354c36c779(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d0fb38c852a4ed0a5999c3acc7d03b47de964afacd1e54a38681a824050b5a0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7cc25e3dc68023fdd610f199fee2843de6f6f454e2729169938b368f2ede6105(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43305f6983aee1d4bf50cdb5d72e5bc88599de5f578df17a997bccd7eafa4e82(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ebd7fabcef6cddd76337286860696e72e15dffb545a4a74c2947d86921f552a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__667fcc8bfa2d70bb2ab45be3d39dc45defe7d60ea5829ed6babce92f35a77519(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f42e9c8a6bae71c122ca7fbc82127695b3de7e4ea98db2c13db44f037e3496c0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6590e8edcaadce48fdd8d1193f741d5bc12573aceddb7c06aef99056de77898b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a93e98e6f4156e7152db2fbe397df1d00810303e84c8831c216d54abdd8f443(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1724999dc37b41e5e0f402504eb50d497586a49cbf7dfd0c8987353dc612f6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6d4576709f58d52f08e79ab0de46a3f2c8d62913abf78197e9aef50e2735976(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7595c25f240a01ca119ad9a9b15df120a15d4e22e30ca9be3598cc802c103b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbc828e19023e8717ad035ec3e83d824a8a291e517d97edab50053c2a8d59a6b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d02b6cf2b440c87c16508b759fefea9bb59762f79e334a5630483fa74dd3237(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3feba49c4f6595b49a4ed06dd40aadb6b87f36bfe9bc758bd668ec403717996(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a9f8f4fc41047b934cd875db68b8b4a971e2684a3527986ebd9de84889d5c8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad32a67a1a4f1b4055feb681c53891f66b34afa35ea51ad3dca42f97c6b00228(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginFailureRecoveryPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e04606e3e86036b68ecc9fa7dcb244228e913f3f8c6786c7b11b111867d90e68(
    *,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__998ff54a1b3ebc215cb1c4b35a4dc7ed8c9502eca08590fd4a3a9fe25cb7066d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ef36fddd46bf7a7d915e10a300a3dc42b4c089edc30e15e30eab6fce0d11b37(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2b99315515bc8053c476c3f11bc1306ebeb346b9c4fac7ea87a93931f23979c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7007835b2d654190077b4173e4b0c46554fb10bb9a0e4e0ce1936029dfa56e13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5635d5c698137f7e04419c02fcfdcb9481fa19e66ad6b69580d12c3e5362468(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3952d7d030d9a32369809a90f97a09a42e3b9940ccb44d566231054674b30e9b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginIpAcl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25108e73df6c55df2542e18c0764e2d0eacaa781d5c79e015f2b4a8aa6da00dc(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d17672946af7e730f5a38080c233408cafa75ffb5cc8b1e78f7e4725d0a707a0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4ddf420c65e994874eba9a793e3a8ecb68d740297b157ac97740a09b931bb8e9(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__388c67b68c994e14226f60ba23a4c465ce4fc3354be6c86b102db2773fbcb285(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f32082d0be633745b5825d50f6ce7b27150bcec0a152cc03d72b89bf73aa34e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c43f84c7d1da7479bb5d333ea6681344bdc36f2ee73f6ef063c54d388e83401(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df845407da98d830438b77aaaf99edd2a930244ae5bfedcf76e80295530eee4f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__161ac6cdfaa99f4b209cbc4cf4043a82551465950b1e81e601ac2c7683f4b177(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificateAuthorities, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47fb21c2e999d813665eb79b3c8b7b0b685085670ec010ae9aa1e0df31171b42(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOriginCustomCertificates, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f22bebcfc83a75d7bca161126cdf930ff5a5c5c4d2738f13cd1f6e7a1533121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4868a5f128637538fe967ead06a0ab9b64b4ca83d6a3d2bbcb459628fa27d7fb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eb837f3efded3b5d9d71cbe84282a0b399fd76ddc62f032df4f8fbc4bad09170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__938b897a70b679947b9a38e65aa869f0a2f483ce7aa6f47750e38e780a7ab83c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f0bac425785163dda5a85ac79cd23d45e5c5e8142a269db646425c36a21f96b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff637ab3e3d35bfce9b6b1b2b0340624e8d9c92a887586ea6b6a24d76f5fe982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21c8a854aa9e91cdfdaae080441b519683449afc881960ce3546752f8ad238e5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1bb99b4db671f8f9d0910d478a6ba5c21d9a5212495ec218075f767b59a97dba(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__533d4bb5d8c2a51cd433a4bf7c894867bf56c6b03a13aad016fe3a489c79b447(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f49a64a92e06c3927fedf33a2e93a521fd499d68798c326768e715cc9daa00a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51edbd45720a0d7f7c673133796d00d0ea59ca2196ae30e10298e1bb335dd1c5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8617adbadee258200263c06600b4d2973b5825e28805a501da14ee88c51bb79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3631a2d4411693b31bbed6dc216c2aabb41e8c3940d97a48bba4bd688f34d04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca05ec227000353d87873de671ca49b40ab8baaadb45a99973a60f18c79741c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59797642b8d10ce5f16007033cb5cacad8c932378caa3e990ee6915139ede24e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32256ddb2e96674cdd78879df54b3d4d098b2bbbb509c9b317cce2b7d4af8fae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c0559be2ff77f1baad769a6224cefe051e35cb65c9b2a5a2751887f247e00a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72ffc1640584b7bdd0beff6d57a292f672e17c830dc2a007247f20cc25aaff25(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d08934e7bfadbce23f5a0f7ea4ec4949da43ed0870806273384d16c7e0da8dae(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__daa1c34112aa42bfb050f6cd0a01cdf8b42cc88241c1e3e12200811232d31eca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1b01c89e2d91bcfba2abad6a6f624cdbef21cb858dd072c815934a72390e491(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__507be261daada3b6e0eaad62a321f7df73b237302c671e025644ac78996edc6c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74db62f1dbcb8b2fe400a2f5ac332207333a0b351880865ba724af8c053d1676(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82db1ae169a01623fc770b7b11875bc284d9b47e784f08359f7e129b90d0e148(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6ecf6f2331e9d9df83ef9a64fe2579a70df6d4289cf0bf68d1d463feca4a5aa1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0743eb910615958adeddf9344c1b1fd7d671182ef359b053a0e7b0a5b43e9561(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05c9795039d0d10e22c7835f89ec18a9057d6d250cca174b10cba8c80086cdf2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ca964755532cc34ee9ff7fe5543794510bf5d8c9277f03fae3474f5956a0b12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d6e7327b605e78c1e54bf27ff600af63cce11f012e8ec61e6fb060566ad7161(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11dd33cbdafbff5aabed8b9bed0bc2a7384c23c74ca3635ac8853ef5b09e8f2c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7479b1ce1c92e098107946b8014b2f029208a69a061c79ab51a354614a4e3ed4(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e024bbc09bb147ed7e58431a4548ffa531599a3ac6682b67eeee7f3da4ef24e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1d9c438edd5aa6a519c7589993a517714225410ab29c44f41d0203aeea8c2d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f82eb34b175b33d3f4be668473cae86b168628c1fa710f9d4b8e2acce82a6ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e83bbab0b360e761574de1a5f96c81cf5b46afc34a2da3eff92d627600f2d7be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bc59639c99978837f1307fe859433f92317bc70d8b8226a4fe6524ebaae5e0d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a95be1223a6bee36e44f84c5755be641496af3f899ea4ae5f90083677ec7af8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e969429dbbdab64b07ea15cfa17f25a555bda0a790f00a0fa866d146fba93b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cfc651e8f291dc6e28e937f596d9730a59624d55f9b682e2437247215551ce4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adf8709787ae023480f15e71f40587538949d55e85cd42a1462f7f2b4478ea52(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__605f646db0684b7de3b848d3f61c406981349c7bfda480a1d2acd9e1ffee3674(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__236e9a89cee854e5c619b92b11d66dc3107a29c2d01a1ad44a64f864e03bb4cd(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Behavior]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16efb7ed1476f4ea4419d9a13239760353624854ddbd4c7950c52259a8dd06f2(
    *,
    allow_list: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    permissions_policy_directive: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4db414e2274f81a16f030548d24a5f88d8dc1a97d9ef4827817b057aba0114ed(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96791e6a53d64d59bda7c69883c6b41823648628bc040815a41d10389e701583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83d4c7a2c4cd79cbde2c146a5b64c9c41b62d43ac3d9d59c8213735baa7bd633(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46b4d0b220efca69bcb54cc281665eea00c31406ca9475b376ff76516a3fb144(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c254238c908e2ee84d1cf8df39a25eb0f17a2f838b59e5d2c2e467bd2bf8a9b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad780cbbb9caefcf6add59e796d2c953daf5d89332b02f484acb2d0c1c61bb15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66172df2c8b4c9c8f8dc361b1d8d98d87c1c6102bf497b444887411d23a2ae4d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPermissionsPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63ff9db1862bf61ffc1d25e8d07dad56b5a1376f0a6d4abef76aa4b681d18885(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10bb64f174874a4b8204e766d8f0f527a795f06e36f697b290609001556d8c5c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b412dc950f2d46376ceb619481cff75ac162415fdf6b90a189e425b45938ee(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5869b424a6684e01712fa4a32b3007fce719662e20fd902f4ad99167c12805b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2aff8287bad4cbf426f4614cd4be06ff0264366f3f3d89e1d4f8a2fb7573c6ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8b348dd54480d4e4db772242051a77df4d81cbcf58b28105c56e13039a3ebdc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fef3ccaafd21591a0319b8f33d934ee24a5f187347b92358b4bbf42ebfe22cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6636ba25f614155de0d0e3ce22c42afd1c5b5f269f884bacdca4a99757ca3c1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentClientConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04370d3fbbe4c2a6d4e4e1fa1c9f6aeaf98be4dbbd34235fab24526240421dc5(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be0e13112835795a771fc6e9f54ee1d16ea4d77d38011b71797da56d46d43416(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a0b96b80c3aabe6ae6988588ce252a05a64590f239f4124ecaec1ef091a2bac(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f681c475857bc831eb01516ec9eb2fa33f18796f348bfd420172bb801633fdd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3ea05a474a9d7dabf05c401fa385fb27543080d2a8859c1345b0f46a74ed686(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab198f9c90c4bbd8096f2fcc59cecb186286840ec609d49e337f828c10c742c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfd7be0bd67fb1cd06ccd2a4370f4c62b4191da845e2d3b1477ed3f79d20fadd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa190aafa4704a0be94fae43fa50622506d2bd05c39154419ed159c5e739aaf4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersistentConnection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0c9633f16315bc3d55aba2184d432f3507fe60eabc18472f9623c1696773ab(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__151f17653dd8554728efbd4761e6b3cc805c28da55b22e9c03c73924c7f0de45(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae59d92b4e2578cab9c1e2a975130201b05a46478ff529daa49960d5d8f97d33(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11c6d124b41f959b76ca527ed35008f304377265efdd4a0cd00913d3e3a7b0db(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd382e3b73c517de664f34d8858c29bed29824ce3a8139b8bf3955a2f4cd05f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81fcfad76abf2cc7c5848e88b7a106d6c462f7795c556a05f2aa7064960e2fec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef079d7b362348766cecd5757bc4a1707387f31eadf885170ee4ebf90ad13388(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPersonallyIdentifiableInformation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af2266a68bf079effa6573a935e9f077eed6f0a73b4d8adea7426acee76647d6(
    *,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_duration: typing.Optional[jsii.Number] = None,
    failover_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failover_response_code: typing.Optional[typing.Sequence[builtins.str]] = None,
    failover_title: typing.Optional[builtins.str] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    label: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_cookie_type: typing.Optional[builtins.str] = None,
    population_duration: typing.Optional[builtins.str] = None,
    population_expiration_date: typing.Optional[builtins.str] = None,
    population_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    population_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccb0d921c6f691a4cceea1e784089c92ceb7e5a5fdf6dd709bd8f1978fdbc200(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07d392e23445d22aaf3bb5703f5f67708612f9e18a8d26d599e7f094be04f261(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9994b83fd498dbc6fe96dbe0bad6da083a16b1e8093378c30bf525c599c247ae(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72a17302f35ffe19e54e75d7e9a4b5fa001ca969ca629e340fc40b20e5f5c070(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2668ed09ea5762f706e0cd82950023bffc9efdd2f0a70b704858dd6e506b63f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedReleaseCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10df4b2e20a69ac3ae065a27eee60d63f765333de52b25953b8afd05f07db9b4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99cc43f19aaa02ccf977c37e697f7fad25473dc0184ee1ac254007971da6b8e2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__399d5b52a0f91a4e301ab0a7e602c1ea5a936986888c9b3c96acf4444db05bd4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b10c7542ae6d3715439134faf19c09eaa1fbc8c0a89ad9baba7db25ec2179b3a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be22cdd0f14a5639630ea637cd8b8e13c0cee54e6efa822194b8a68348ab83e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5773de14829c6752d346332e68aaab302c924b2215fa9e32a94d6a53dd80a93f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__292419f9526b2544cc470516d9d4657df6f0cc3114f54abf1537a7b43d2951e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bc9498da0f3f30a31f19f6c9d4e059bda7a818c6a081cd12296b907d14d821c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__623d409a1a80ed18e157b45ba7be6169937a49a467eac4ba333c3b82f8620575(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b76b35faa0a47a92bc5685fc553895d926dd6a0d0925c841c66c39999bc19b40(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5429d37f3a6e97418ccca2a56db5150143542151631f799f6536253fc7a9666b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c55f5b6a63b9da9ffa05a8f48cf1d32eb5aa98b86794d0193dbb63399df168b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe68b6c255281ad824cf93ef76cad41765cba3e669cab3b360f872169596f22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6e28d11c066ec1583497b1a0959accd58cb5c9cce9916f06b15f4e744032cb8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7152e2a03da91fece896b87d68765b76e4a8a27ec0717e50c9e7519d41ff1948(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84ecda0f0b897088c41dda7762159c6299c3c4e1b20ef8a007f48ec7f206af50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92f6d0d7f5a39751cecfe3af4b8efe5abbab76eca797511c6d45537c02447dcc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f7a0a43413a3b979adcd8fcb088180ed649801ab0e4437cd3147ea01687079a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPhasedRelease],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b4522082d31135482af2805d11ac7025b09dd4f6929fc98b23bcf778f49898e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    preconnectlist: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7191f0457d90541f8280d43b1453b5f2263c24606a322c0d1633b832557b7ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b11386520739eb97573db5bc52616694db2f39ef877522f20d218b9d0a040b7b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24f9f49ec3b36ff8cb4d1f106a740e1acd21dfdb5137c32a23c52a9bef67d701(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd8807dd347950a17a9ce5c66cc972f016229eac4b4412eedbe7e605b4e1e30b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__721a799f1fbcd5909bbacdb1631733099124d960db3245f5f5e55e92c011492a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b655acc03efac4b041c711db4fc592eddfbfc557b6bcc9aac1687d502248807(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPreconnect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43078f96358397b1fce10f06ab7bf5c18255615e93c3b1be4ead091e0e7990bf(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f830442c1e213c18b283074b2f31ad2d5bd8900e9b8c436c1d4479d7636f8a8b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589c7b2a92044dc13061596d89f10c59f1aab2aeb4ae898bb64ab43215852ed1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28d415f4c6d829831349a8ec21fc872c5639dff6b352fd68acf5936cc1911a5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92df952188acfcad2e55663fdd7dffa3d412b9b33a7562d34f273c26141ac5c4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d285dc9ab97e65ed4dbdd9774867eb8bf03c23640ebd3cd1116a65222b5d01ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95aeb9d82d821f78109f19e892cdc81bf4a1a00bf933d9923a2d1b12da453348(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictiveContentDelivery],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71628e1d451ba1d685c3a36c8e455e96db2e4588a2e97eae2114452a9a585af2(
    *,
    accuracy_target: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d28bcfed6098d4273eddd4074dae502c076475d046ad230a24bb8402f16e1e14(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__210cb115ea4765ec20df077fbd79374c22dad917470a2e054be4580a4f69208e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__993c00d870dd8b8d0d8bbfbdd4b9387582c41443b97be9f4b0f7300ca0182edb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97e2fe3b690e203de0c51ea1492c45fb3426371cc9d1fc7de92bfb0fbbbf464f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed46a8bef25585848dad045e63e05f7ba376d6ee5539ca721a57269c2768ca4e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc83b55b94791cb5bd5086c116e213b0640da41ee6f803f446e2dcd6c5b864b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__913c8fc29a1829bdfee88f7f834e29a7aec3ac2a971874a6947882f168304f69(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPredictivePrefetching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b7ba32440736202f794813ae4a84b33900ce2be94dafeff62ab17826250cd796(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a737ae1a284a53b8644b59c31765c3988c85bae6f144193f43a055aca93c2091(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2e2f2b031915a02dd18ee32c0acb9b2071c8841b5ca37df85acf48ff5a4be51(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2258aaf8bfe865232cf1a00e31a1a534083981cff5de6a43271727a11b1f919(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ce5f9b6f67375048e860485a7278d18cdc8b3c67b3e593a1404fe85f9fe21a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__025fd29c6e4fcee09143c4edac931581a6185bbf7b31bb67926d82507cb1423f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79a0a4831cdd9b8e9dd4e95e295ddf3d95cc16a132f71747265dd01f39f08795(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a623ea17ccc97d4b443f71c8b3c5384105a0e37bb9b0ddec6263741d7278f666(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__760cfae25af6cdaf92993a3c9a3637f6ca85d0cce332be621a55b088e845a31f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79b9af688cf9641e7e799f8f3a6941cfd8f5bab5586ca502f798657995800a24(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__704aab6d3fe0d49e4f21abf329a5e7e24119e3d8244d376e819137e67ed1e788(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05d1ee0b863dba0a77cb5d525160f183124156acdc9a873664c72cd10f1420b1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__175bc06aaadad862b2714a0d27ae2d52860f9f468163e946736963931a01ada7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ecfb717e9c82ac46fa5adb30d060ccb8d4a343a4644b5057e04897992fb0444(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefetchable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70bb29c74c40dd2b2d8ec25282a1fb8f5b3347d4f0041a42db5fc6469b41687a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    prefreshval: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bb9de741ffc9470927e4775fae58fd07174c636c6d9aa540775b44e45bd66f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7724cb0606fb77d947f6db8a7eeff7a975dd6d1aa1a4ca27c1521ef31bc553d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02fef0d11974c159541e74547ef0ad2c9acbae8f196a9601d156761b51540ec6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba3be47e7a35270da2b376ec7908dd057fb4bfb6c0dbd46d7af83e76bc772cee(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6be1695641340894fc3496f0f1a05a51ad05625131777206ae4092f0592e13f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f304db7ba662646e2cc0a156d89cfcc2b9db88dc6745ab6a7a6d3c01f92b3a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b1b97fd458c08483a839c7553b12ac69740d18c05eae4a447b29855a96328d3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorPrefreshCache],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c9c8f22baf6d0209b685b3bb5223e20a4c38640b3b033c3369ed68c515134d5(
    *,
    audience_settings: typing.Optional[builtins.str] = None,
    catalog_size: typing.Optional[builtins.str] = None,
    content_settings: typing.Optional[builtins.str] = None,
    content_type: typing.Optional[builtins.str] = None,
    country: typing.Optional[builtins.str] = None,
    delivery_format: typing.Optional[builtins.str] = None,
    delivery_type: typing.Optional[builtins.str] = None,
    download_type: typing.Optional[builtins.str] = None,
    end_user_location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_concurrent_users: typing.Optional[builtins.str] = None,
    object_size: typing.Optional[builtins.str] = None,
    optimize_for: typing.Optional[builtins.str] = None,
    origin_settings: typing.Optional[builtins.str] = None,
    popularity_distribution: typing.Optional[builtins.str] = None,
    refresh_rate: typing.Optional[builtins.str] = None,
    segment_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3200cf66b491a66a09b4f92c964d2cf45fb79095e37a7e2f5693d27e12ae3ad4(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff9a06f7a07795f6570bac346a27c95ef733926573d15f61694283acce2a4c17(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3bb5068795f4e7a67f73d22f988af35fc34c67a402e11ed1c42dde6fa59c1e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa6f3048a15253151d01a8a43af0f2c69b67fdb9d3b6c28d2529ca9077b2fffe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aabbdfcfaea670af55d565e0f4b80cf25bd51b5a1f43dc367a91a30d88d9dc34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ccf5fc86e200382ee2a3434ca8e2a86c47bb7107c1c42bd6f0ddfb89fb1399(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__999e440a37a741bc3352930d6d43919b32f71a0847d0fd04cbbfb3e528a79811(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3262a62f1562a0c722c6f3b2a21bc3ec3bbd31e94476e796554cc2c02e10a8c0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35c94a5857c5a6ffdf073cc0b68f7889b556f60378d571b1f547bda19cb897ed(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e226a54117e794726f2d40931c22e40cd5e3508ad66631acb789ee77a54d849(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b3c53ab42425c2b755ca0296a65d327816b3e0224275b37e9d54de4b53743fa(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4ad9e77bb7e9353b609324da8c6620af6c604339fa005b0016575770fc2640(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97d8e7fffccb41330f75a906350bf50b179e0ff90da1debb2fda6350d6f5040(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dc5a0da318c9b3fa95c63a931807f3868286606b53cac1709513b35f1ac4463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339e2a9de95157015747369bec3674fc8a7db0293a5a61309fa6454437c82deb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62b4d73f14e59b0bbd4c3b42667cd70c92221f81c8d5a35594c7b7c05cdab2fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dc99d2f7ddbcb7ac57d86aafa2c09c03b39b131da2845968ca8b8ae83dc3c4b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea0b3fa1c1e5bdf9ad00a2494512e9213f377a59e6ffea21ade80a3b2a7b58f4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42135fabe2dc8912dad25aa389845ec38b0849971a9ebd87c434ef3aed7ba598(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e919799c2bfda2e449f5de77caded706c90eda90ced3bc1edc5db99573f4f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__088e7a9721b287cf7770f12dcf3bbf9376828d4656d7c39f88609947a89960ae(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuality],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06cad1eeb7b8954da8fb2beaa88d297dbdf4a26e14ca1fcec4f079a78190cdf9(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    quic_offer_percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52006e1475d25efd5616ecaf5d35ae43844cb09c286be8eb413c5f4c5c727b1d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7832a9adf79cc7846f428a7b96435410c5136fd6ff4b0582cda7da6c237a0045(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15c21866738d24363711a27eb9465540c0e15a878846b7d6ad0a54e6ecfb8491(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0002b4cf6617a7c9627a33f6e85a5ccca7f95d116bc425a38078843d3f784b08(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22f9d6118970f8018f65f3fb711170b7832c451e061aa979b5171005a9bdbec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dce224066aa3541e70de06f2cb33aef553a68efce858ef59e7eb5c8eacd9adc4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__547516f4afa31ccf2b592e9a29d60854e26d84a589f81a41898a3c1faf2f986d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorQuicBeta],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__83585d0da3216c017a6f52b6075785cfd5a824cb6044fb3c85ce331dd6870fa0(
    *,
    flv: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    mp4: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f5d57bf9bb170f098f6947aa0fcfd0e845d2479c1e5421a515e4296b05967d0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06e9c63fa426502a27e0f454e06c45bbf2b106f44cca89c7920c5e8efffb5d1f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a259e7c51760554cc2baaf66471086ba5b44db76799cef6a035bcc697f64c10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9801f1bea25e0aa21090efe1f299749440754a51774732d8c0dc8890862199e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51bffe2538b343d9f0bb9f7cc5c8ff86b4c2cd9a68b9a3d0136c53298a60828e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a1d6e8ca3b8ac9af71520e7c9a7d5f28de22a934dba958c45c0ca26b31c2411(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__360541ed38ff505574ab190b3803b8c0df43bf4593670a8d70e0173802c2fee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21d5a600e283c2c9e1fd1e5c2018649d013affad49a963c993321f3f123a6b37(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRandomSeek],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__577868ec8252dcd9356d0f93c9fbb4c24ef2978462232698dc4ad7fe5ebdf184(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__358417e8ed0a017f70996b53305886cd363b8e50159fbceda51d41e2aba0d2fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__628043d487709aae3c45f0bb9cfa302bd62a506aed71db09ec334152eb369fb1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef1a90e1aaa153accda67c0f03b3cea3c9f742f7844f26325ddb68a6e08a1420(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b526fda9af0e3547e8082d126a5a6fc5a5960661b72fbeb2f737f3fdf4627448(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea823e90ecddd78cc07c604538311173279faa971b9d4cb1f6df3fe75b211dd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__691c54924617df8d5dcc38f2756f4a5689b86eff5cbf2cd398889be68c50f2f3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRapid],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0b8ea8be66338f57308ba645581234b4c1020c364498f1638f852840e6e3ed3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4cc78f97d45d095f9631d245cc456026f617a8552f9698522e365465e40425f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92b55d8dc31afe42c36878a1a1ce3f706557f143cf375cfc61414f8eff05d0a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__144588d9605ec196f12e21eee4e5bc677f21df07ba358761ff724306c6ea2df5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__841fda9320d7bd773539083ab5a0477d6a4201db188483cbda3d919d7608bed2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc12cc340aae73c74adf60f2f656b7bd713f9b1cb9e8bc22b2da6a9ec76ed8db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a758aa3e95d3ca917f88d29c674ccfcd8123f1606475a7d7596b295f143484a9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReadTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f4096c7861047c8546bbf10120b9a8542b7f2d44ddcd5f1986ddb2134bdcae8(
    *,
    advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    beacon_sampling_percentage: typing.Optional[jsii.Number] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57539fac22cea7a63761503ea3f1010c2e8d3624bd6d143f4cba0caa4c05e6ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b06308e8bed25372aadc8e1fc33b453de01b740e6dbffc1add03e50c2af90225(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54bcc69772587afad4c0000184c36099f473bf4bd8cba56abec1975ff8377593(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__319821d89495d26804208e9089a44f37b2e569881c848ac7bb7450c7266b8ea0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee3ad2e1b081b7c4079aa1198a44a911e21d4c404b8d43698f9be00cfb192602(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b97ec1d0c96dea630c03fd1ee66fcc88d2f388af9420d74ab716909727a590e0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6144adf90ff9374b1d1e1d10fcb876bd1e9bd235b32f3a2094458de0997411a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fcd78e6ce8cbba00bbe199dba8fa03bdb36282b7f3f67c2ee75684dde04928b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealTimeReporting],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d249b3cb0a878125918498af997812a57d95e95b826850116871836b7ab6ef(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f32d6b0272c5a87d42058296d5fc690bd85ef799458f5d7f02263440f9dd8ca(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac3b773e18afc1c9dadb1e6ac334c8bbe57ab86a78589feda5dd534a5851c45b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70810d78ccf4c88c6c20f8767475de05c65cfe22464367355916b5108c7ee92e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cf229482ff8352538ce61bebbb88515abbdce29ac61ea7c58eac784a1ca2cd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b77a37fa91f18dee2e5b1a6218b808aabf7f7815f80a2e9229a1c58808e3e0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a34989fedaee97725aa3fab61eb3dda43d3ff6d0f0adf6eb757cb70631eec86c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRealUserMonitoring],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4856a5de217b693d70a34ca0bd2075f75bedca7b4cec2aff2b5cf08121ad494(
    *,
    destination_hostname: typing.Optional[builtins.str] = None,
    destination_hostname_other: typing.Optional[builtins.str] = None,
    destination_hostname_sibling: typing.Optional[builtins.str] = None,
    destination_hostname_subdomain: typing.Optional[builtins.str] = None,
    destination_path: typing.Optional[builtins.str] = None,
    destination_path_other: typing.Optional[builtins.str] = None,
    destination_path_prefix: typing.Optional[builtins.str] = None,
    destination_path_suffix: typing.Optional[builtins.str] = None,
    destination_path_suffix_status: typing.Optional[builtins.str] = None,
    destination_protocol: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    mobile_default_choice: typing.Optional[builtins.str] = None,
    query_string: typing.Optional[builtins.str] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0fa21fdec7ea650ecbd4f4c03044c3993110bfcaa4c967b497731276feb7f4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55f9df4a025f6692af0eca71d9162cdd5b31f3a913ec8bd4c07bbf2cc5a7a6f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__64654981abaa6c9c334487c6305631c680b514345ceaaac0b25b9f54d4c4e6cd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd05a01f4d2b74ee0947a03c51ec8f6e5bb2cf4f7bd98cebe83db3ef7f531e7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0997003ae6986e43ae9b57a915ac9811cffb0fe13329c04c0694eca99009781(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33b7289720ac8f7c6aa4bc1cf755c3d82f0d6a1b5a457633e48bec9c6288f3d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3d3ca0a0bd456ed4921217b6b6a5b86098ab4531389e593302a1f4382072f78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__de7f280652b9953838f4f9d807e7c30a881d5770f746840ff108c83f028e0808(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d149340c38053f44a9b3727640485788bc83916875007f51e51349aa021bda2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a02fd141f29ed95719bbd939dd40d1ac371697b0da1ed0f549d8f2bbbf64100f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__282e475ac6bb1b4d5c3a7ebee4087f6ab8ecf46603f5fcfa5b2fed63e6933a43(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acc61f6de412812ba3a981073c08ea3f3eb40225d8edbca1c7f2968e88b97695(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbac1d31f9269e56ebc077e37c1c06077af9c7e9e50ae9f2392786d16bc1bbfb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11085587cc4faa0c9c1086ba4b81ee411386dbb76aab5cd96b86c209b1059651(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e79b4dc35b232ddd2d2dae1b5beeedd9e25288c998ded017ab2cc464d2df181e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a048ef79ab11de9b041d772eb77975dccca799dd01da0b09aa56c5ef2c40812c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c59037bf99149f3731a1ad763c310313f523bc14aed54d82c1efb7171890c1b7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__11adef81b52623dee161ed7aaedb1696c5a2c4596b424225e7b38ba5edd592b1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirect],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed3581843e69b4fa941b74ff857012db00045869d2c300867301eda5e491d100(
    *,
    destination: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2355162cf49bc218954789069acbbbf746fea7d1b69627e2c4c87beb81b8fc3b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c6ae855e209507bfca7a4ae48174cdfb8cf226feedb6bf24ec9b03b625754f3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd7ec13402bf25d59aec1103ea66589bb1f234541ffa895a0222c453e73061e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f2e27740d734474e8f661d9fcb0e70fc586781750923d8b46a26b2562b26ed(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a26117170415278cf87212d6b4959b204b51c4f094346ddbcd1690ed04b6e421(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fd108f9588cee48c2d911bb6bf9964dfc53a76838d72585e973e5f5b053f752(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5ca4f9d7d9dbd719f2644e8e2fa8e3c215f6bff57d0a432989c7feb5c96ebd4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c21f1c4f953aa91976a77841c1279c16cddf10efa89a8f6c0f5b0dbc87e6c1a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRedirectplus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__157c9dfcf593309d2b11174f073b2bfeeecfc70f89bf25ffef0897a7940b721d(
    *,
    allow_children: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domains: typing.Optional[typing.Sequence[builtins.str]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dccf7f5940a0a2fea564a5bea6dc359f92290b65fdddb81a95007cc82f8aa1ee(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f425e6550ee595dced1535e5858b6100e4c29b5c0f9ebf615a2a343d55db838(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421bc8adc6f3f0ac60fe61e12d6603449e625d568c9ad5fe65e4fb9aab4a5430(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa07a258cd66784a9f7f1b450103e33234d47789639d1d0bed4f90506aeb78c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a97557251ee1d429493be2535fbbb6cd4a9c3b7eded362979eb5c00a29a58b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e1890f2df74be216e982f97f54f3dbcad392251493ef3a90f101377aeefc69(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51b51465988588a1fb29877b1581bab8db02e64680e3febed023433b94eb2438(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__024cc821bddc319dedda8f03dbc0985e199b371a20a5fbddacf760482b84c9a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58db347810ca8d1075cf4d1727c37391d4ef00be365ddec71d6082c45b5918f8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRefererChecking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b14437612fe5d82abdd55c27fe146d535c5a6e052f671c32b667457601eae04(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameters: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7321013826967a5011ea3c16115aca62c7e2a7d0187ea278e5de2b3e9fbca5f0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e76c7229f443265b2d163241e4b5637de7f081792523151890aedd38b812c8c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ef3268db56bac9eef623dda19cfcd08f69f7aa2e83a59bfe373a1e56a83c55f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3545e2aac7736338511384f8d942ebea649aa3d20af2ca3ac1a248519ec07bb0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9958fe35ce85812d22954eb1fdf772741697dea5d60a46171b2b722b49cb2cbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7eb66567edd5c15f2ea889c69d9fd8109a92d2f66c2373c19117d13e52cf69da(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveQueryParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5fa197c80733ebae3ba9a61320359c3f086cf31c1b408811858e2f794db09f26(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__26172127b94bc54b31d3757f63d874f8a81b1375210e9711b244ae8fb96599dd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa14fdd511369e2de8402e466c851e826588459b9ef77c0609aff95bb4bd2d58(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7bdcea847753dad446ca0ad8f965ddd24e1d1dc6b00fe9585da73d4f338fbc29(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0ef2c355d19030925adc3e73734620750a30bb3421d3a57764c54617ac1d43d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f93e77e810aa33e657d71f4506102c59e2ee394fb9d57be29172fa6a1b283aec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b12c55574f696ebbe215e146b811541d3dc5b50f59b0d36c2af11ae98e2b6cb0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRemoveVary],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9feeee19886a94b4afd0f952b0ee22830c07031d3f5864d5db94dc95bc51bda0(
    *,
    cookies: typing.Optional[typing.Sequence[builtins.str]] = None,
    custom_log_field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_accept_language: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_cookies: typing.Optional[builtins.str] = None,
    log_custom_log_field: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_edge_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_host: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_referer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_user_agent: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    log_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98a464135a63e06dc9a6cb1e8008c4a0103be45df0f0d4714e7431b8cd702428(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f938a535c0436910243fc5052a5430ae7ec96d27766bafa05fb9555162ce2eb(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3be4ad3185e0c4d318844befa391076f1279718437bfecafd7120b6a8813bb10(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a4a6f7069149151d65aa98ac44f324e1aa356cbf3c3d7e48cbfabf36beca7d7f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47a194c42613258213ae47583d40df00daf73ca0bd1da0363bb7dd425fea19df(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac7fba0a1cf55d15c0a0ad9a2f437544f7788508bf8d22c3e562737dec968a22(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b05d199298964fb854552e5ab3fc9f7077b008b6631c862364ef306d24f5512e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb989ed3610f4b1c228c34ecd1c7d88c17ec7916ac7ef4da44b66d4e7065094(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__28c06dcb5179b33b5b4e25697cdf926cb393e7a638e89fce772b9806d8b214f2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c72cdc0df9a29a10fa6bf325b871282e025e18fcdfd7af8bc78fa84c8f191679(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6ffe1f78efb5bb44f49b6bde38b3047b89aa0f3273d6def27876b5fdfef8129(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__728367df451ea98d2390802c0249e1583da72751329784b8e22563f454decb57(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5aa827d4ef02eb167045c56b4362cbc0a7c3f35e652fbaf975979271c047d98a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61d757834a4eb7244b2acc5b5aab1e58a7f74098eb6b382cb7d2770631136fc3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccd620385827120caa5c852fab87848f350f8d3b151e87394f365da946e48722(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReport],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9d2d168e4298a2822e6897e12b839262e4c176b31b5156b6494f6ca1b85c16b(
    *,
    accept_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
    accept_critical_ch: typing.Optional[typing.Sequence[builtins.str]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    reset: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c60105281b496898ab48b95c2ad41a568cee6376c5f14c5d12f389a0940559e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0a4cafa0ae2c6b83b7b8842ae726177e35e51e9da043d3f03f281fc1f81dbd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b48589ab689675821bccd500f8ddf53526696d6ec966b4abbcccf8ca82c179a9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__04c29dfa29ca4d4977cce2e99dcedfd4a715c064f7e1a20c8ee1b7a11041684e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b219d16e663e214628d8960a75bf3545c250806eef19b84e863505b804173b2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d7bcc5637391853c93093f3bf36ebf106e538b79898a32c7d061f38dea3fde3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c88cf72580ce34a9b163e141a323a0fa167b84f3adbda7810046ced1ebfe3827(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39947c7d67b707c71d6a3d322f43c327eff86fe507028ce42930acf43a55dbdd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestClientHints],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e33529cd55131a5ad93a11bf42a099bbce081d484d961de6516bf98e37803528(
    *,
    branded403_file: typing.Optional[builtins.str] = None,
    branded403_status_code: typing.Optional[jsii.Number] = None,
    branded403_url: typing.Optional[builtins.str] = None,
    branded_deny_cache_ttl: typing.Optional[jsii.Number] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    enable_branded403: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_shared_policy: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ab2865e219a452c1020f7795c29c1cdabcbeac05f793267f575cac85b692b3a(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a260052204026eed1239527f289996fd694ef9f81eaf42afcb8c41d7d021ecc5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d591b268b286f54f34d321419938c75db5802bffe3478dd3b261a5d09b93bdc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c6c421d88aa1c0baa5a9d78709f580040e50e6012672d0e92952ae16c808a94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffee7effde2b9e1658a6c0272cf849ccc6ea25dc42cb106bf21265ec8d5a5dca(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e900d939fd8a0032df2fd5ab01336341edaece29e662fd943318bc724f0f54fb(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7f12d291bb4fbf97d603d23993d597e4ba466a03652dd9694aed1b98e38eb66e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b6afb300f9a2c5a13166d6971f55b2a959c283cfd9e533216badac6d214708a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d93367f67821ac9eec59a3a8380252180d57d646bbc6f218fd1ed9694c636ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c61e22b058a6b559c5c32a8abe17a72a0a2f35bfbdad845b6e5ddba6b76105c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48ea57b9925d94c00a12fc3a3895a325418721e14331c88e46dcdbc8cb637b9e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControlNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd001e89f71ef0dc85ce47d608b7c4bdea059434959dfbc5c08cc29431afb51e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b9dbdad89f09f61cc0768fe727942fe9eef19395ad9b0d61ad4a5ff05f57df4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__197aea871d7e3a30974cec20be7367216993271a3e7bbae273f76af0090625bf(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621687331e56e1c6178b0033f47aa41f06f9d140c4cc09df3a718fc8be05f29d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7684f130addf74d682797fea66abc5912c33c08dbe1b661681bd6c1faafc2a1f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a96772bff22cfbc781773510eeb4c30850466edd78c9d4c9621f6736a347f84(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__756d62701a392ff68dd660e477324390fdf6d332bfd8697196fadc2d85563fca(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0785d6d276ef908a33b43f7b39d706ef48f817ebe48c24b0beacc07816982787(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d55389deb72c9599511c8b0a53302b956565edb9c7d9263f810e8441d74050fc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__517c5eb53525a673e0aea7a58ffe2750ba02e284666a6e51b1840fa7cf4d84f9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__764e1d4acfffad59550989f26d422c9db761373b169d266fa0ea1ed9f0270b2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c16d830850b4584d3ead3136217ff3a7a509e7e0aeffc3dce728c06639b03f15(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b827a88ec50aa9b77ce578264724baf71d2419b7d3349686417b9191600c65b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestControl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41bebe3835859962222ec8984e87a61b47b4deb3d2332509d7c52a04ac1e7e7c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    request_type: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf8dc83855d06652cc705cdc4768fe88436e918d4a19fb2df84fbac5f995d574(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6236313e19a5fa953b6c229408979c2457c116482a2cecf047fa3a340e7238d2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__574c950000bd639b833d19bedb4788ee27aa25573d6da66ea0011f7ac7a895d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cd7f2595cb13b1a5b6c7f956a6ebe2f8fec3fdf0ac77e5eb1a6ce07fd8f2776(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d7ea7604b3c3c6c31ea8fdd0624f3e315347ad0ada63423a4f41407e367be7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b693b88483a33863bc2c4f6acfb1850ad424b47926be4ce07011e732b3fc270(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRequestTypeMarker],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dfd3baec07818a9e51219b049361f326d0840584521251c7059fad0051354dfb(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e4ea898c527eab8938f0a8e70bef12cf35916b3ff1d660cf56a3a69e7932dfd(
    *,
    enable_all_features: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6864a7565a9d34e9190e220b7ac8264263cd0dec11fb86506f2e7c0bdfbcd2b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e519003f1ebc49f5af57a1f3bcc96567623344e96021dbbe807f452fcd1d0bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__945e89eaf7b830343b374a8f3b679674db1c8defbe8aad91ae8f85f4d8f7596c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ef86e0eac476187a7cea8969ab3b3e9ae6ec6c6e8c969a13fbf670d8e8d7364(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0014dee316922f7604387691082a30b33c892853cdff2896b4795845241047b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec873129e8a48b55bf63a769a3f6ca7ba570816d7ab1214e7dae9ce1afad7333(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1f833ef75c65cf314f7c9f632b18aadc2da70fb6ad35041c37b0075d791b8bb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizerExtendedCompatibility],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b95abf8a4c10658e3d4d940fc6bb7ba925aff43d1f3e0c091e4f6eb0004b0f5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__738fbda2fb4fc0b8e00b3ff120ebc862247f4357494e3ca235ad69b374daf0b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c12d2a5891ac29dcbbba8df922a1d23b98a9ccbd624ba4576e6d1fd677d57a88(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa74648c4695b8284c5751a6ba3e03092fdce3f7722fc91860647996bd14a922(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3839c6bac262402cd2a5c19a716f6b55945675e7850632432cc06e1a7c473b79(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd408f51ee73c57487566526f0886989197e1ffc52ba73f6831fd2495e114547(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResourceOptimizer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b75ad94f5a9b5d53c07ddb75ff95aaaa16663ff51f63733208d14dd3a38e6147(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    override206: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    status_code: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7ba650557db62564ec8bf1c8c5ab0581abf597178675fbc0d518478540b506(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f691ac214e4c48acb50f8e9f735d2e474ef4717abd3bde3789843edd3a96b96d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b3feca4f49734dc19cf5cf97a21b47ab357cb327240dbaae1e9ed4658fc2a65(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ddd336050f07e85404105c35e134b0aeda746500290253c851cbf05caea8837b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18bd5c0e55f2438459404668d56a62185fdb0b5a414aa5bf0dc8c30232ed4371(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0564094ae540cf92cd410937f9e01fc98ce69c585c7069ab2fe80cfb22df746(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__584518c1946aad7b97d952e4f4a772b4b114a4d6bef0afeba2782a5322c3e638(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8aa885de3c307a1c4586dd3802f025eb3f028eb74d8267f2af3bf29863de09(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    default_domain: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    default_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    domain: typing.Optional[builtins.str] = None,
    duration: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    expiration_date: typing.Optional[builtins.str] = None,
    expires: typing.Optional[builtins.str] = None,
    format: typing.Optional[builtins.str] = None,
    http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    path: typing.Optional[builtins.str] = None,
    same_site: typing.Optional[builtins.str] = None,
    secure: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__716a2a991bba7619200d4e9403a464b287a86fd1aedb21df0c8d97f3112b786f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5103fa573ef2e3de1fdd0433de95153b7cc3bd16cc45035ceb22d75b678b5731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a09cfb0634b0b545df27204057bf7a61c90e89638f98b0804ee8046256e7b27b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df2322c1923bc04052d31714fd53cbb06c557e4b78675d698dbad923c6c3a4e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3bb2223b051fa79a42243f883d2e7ad46643a7d17ae91b7955df67f461e08340(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4846c20e454f183ac76deb4ef34809966985b1f8fda0993fa5ab43e005030292(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9582b318c62d26422a13024e953f3fee031262f2f973e25f9c087c580badff4b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae22dad0158c13c63d0076bfd92d7038b3861e85529642994f060322d65bb0bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__183b97667defa9ebb57c4912e09031cc864c70e74f10bfd8b68c7e76e623da36(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50b5ef2c7875781169e94f77c943e811e92b0b847af75c24c1c001ddf61b3b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97828c418f2d59259f25ffc11e972ec2ed8693fbc552372ba337167fd831ab1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73428ea4ce087eb9c7b93221e178767542a17b04148c887c67a6a78df8d4c2e0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8b335c52ec7b0669c44d0ba01af44ce37dcafd6af393e61bf2bfd0abb74ae7c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f933ebd39e5daa9c739ee010ab1d4e1b0bf10c566b0f6dba8b39e7e3ac258bf6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__def84d2596e4f8c0cc6408924ee7167c571f7abeaab68d8a68bbecdc96965a4c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__483462e2abccd2558d966bd68ad303da8518cdd56e6012f818fadc6aa9979fd8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89a95aee4956588e4335a54a20b225cfd34ad4dfbd1a7b66d1f4d0250db0baad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__376287a8942d56771c88278f287a44d170394f3c707895e3278d99569f18456d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e73d7453bcdc25258de152f18ebd7fb53f356a623d5207955e1f599f67f2ae0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbc1f9397761f19f8cc83b078eee39f4f0c73dc39fd8d4a40f1c76ba7878695(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorResponseCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d6ba1beb3065c47418f243015154e1482788fd8481312459a5e3cbf7aecb70d(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    maximum_size: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66a35d998aee5f1537490911361620684f67749572ba45f0ccbc3036b9b604a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__583678f67de735b3cc8cacfd51e93190252ae8b33d7a87deffcf3eb21f6c514f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffed2da6d71dc13bdfa97fb05e70efdf12639a09b5428d0b2b5da3a2e51d2cfe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2cdd42f6017a547681be159e4b0adae6c8ffba99498e51ed0e278a48ac898b94(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c27a86053eb02868f088e20519de2eff60a43b011f9fafe14771468dca318b3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b40745d96aee422f894894c0955f393af89f909d7888fa92784523a0eee9d72f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRestrictObjectCaching],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7855958fe618a271f81a46855b48502f1d89ab04a9c008fa0ed5132dffee5ea1(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38785f236836e0ced572f5039f97e40d6ba2a83cc3c769c18785d8c1b1ea9f04(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d110f1936ecff2fc7f97027d04cfb73dd4f41f7b55b77b8f91db1eff7ec64369(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c14be7cc3a6ce1b54a383d9344e83b3ffb0652f811bf8a0349fd695939dd391(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee64a3cb96659b878dc9eafcc8bacf0fae61e6a42c4dd17c86dcf7de8955cba3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd45c3b0efc169ec48b28cba6406c9ce04cad11199d8676452744a3d6927694d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3a896f0f492d10b1480d45e8e304d430c8d12eaeab3464d4787aa53f94e85ff(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorReturnCacheStatus],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24a0ec2014e086b997b5d68efca8325526140e8a62004b552d99212a28de6c0a(
    *,
    behavior: typing.Optional[builtins.str] = None,
    keep_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match: typing.Optional[builtins.str] = None,
    match_multiple: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_regex: typing.Optional[builtins.str] = None,
    target_path: typing.Optional[builtins.str] = None,
    target_path_prepend: typing.Optional[builtins.str] = None,
    target_regex: typing.Optional[builtins.str] = None,
    target_url: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d364e8d8265afd6ccc000daf73d2bd8d03c9e79a5cef13ef909135f5b63042a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61793fb4b6abfe62448c76fd10098d90bf244a93cca45c375fd253e6ab7f6c13(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9de6990ecc9f25d1ea4c15d18e2ed8703a4baaaba29da68be88c147d510cacf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4bba83032b4f452d5b2a4f1f595ae93b012b7595a24615259ff6e44e4d27bb9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__73dcebd4ef13a9b143861bd69b0141816ec64a354553af77c48d6b615a4b4643(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee03c06106caa660340d70c2429a11b85d0528d8bad8c66618730a11fb3897da(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__688a52094e109fc48a5dd3de674a9e5e42f28ab0e113f2834f251345eb6b391a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab845e26334b124e0c84ccd0b68fb94a97f46b210889bd7339bcca82e1137654(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__24ff5a05f766a787fdfbab9639fe14588955a47180862e77a8175a71a03eca55(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14fb7fd79ee3bef338be2eb2c059f01bade2e3739d2b8263d979ba56c289ea51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d48119690ad51de936af20d7f6eebf7eb478fb1187b8186cdc71cf7d45a20321(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9df20b2adeddfeb5806799252f606808ff1767fdc4eeb0c2a79ddc4127ec37d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a604e7695d75e6b6cdeeef9ab34da3272caeb581a040c2c088b4799c0eefda3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c45ef26e1f542ce0f4fbb6d7bf93d9327e75b15db561916ea7e6ccc32f483575(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRewriteUrl],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5484fff6cc80f3f2d1b09059074ebd9801e3f5ccb68815c264bd9946a0f342b2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    rum_group_name: typing.Optional[builtins.str] = None,
    rum_sample_rate: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc6febc6b3797d80e466876c2a642c57f1f1867db2f6ef463c8441cef524897(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__270bf978bfa33a181e7fc45cad893ba8cf102c8b1b5debfffed5ab72f2e385ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33c6d9e07b81b400e0b73c910bdb1b26efa896b5d36919e772d8bd39471bf45b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56eb76213fd42cd1e14cf165d7ab834f09b218a1aefb65cb28547fac91082d2f(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df282890eea50ad588eceef5a004c1464ce291b8f72cb5cda719d025b2d64b5e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d30159216106ae23748eac649e546e8afcc53bb1aa33c54b6a38fb64b55362d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__813c24279792ff24287d9cb7105e5e7add2de03a2d1b9025d7dedb61d5cd6e7c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorRumCustom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18b0e70582f51ae2a2091b31bcce5bf37bb9328773fa7114e3b21280f49be4c9(
    *,
    application_action: typing.Optional[builtins.str] = None,
    application_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    application_cname_level: typing.Optional[jsii.Number] = None,
    application_cookie: typing.Optional[builtins.str] = None,
    application_query_string: typing.Optional[builtins.str] = None,
    application_regex: typing.Optional[builtins.str] = None,
    application_replace: typing.Optional[builtins.str] = None,
    application_title: typing.Optional[builtins.str] = None,
    customer_action: typing.Optional[builtins.str] = None,
    customer_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    customer_cname_level: typing.Optional[jsii.Number] = None,
    customer_cookie: typing.Optional[builtins.str] = None,
    customer_query_string: typing.Optional[builtins.str] = None,
    customer_regex: typing.Optional[builtins.str] = None,
    customer_replace: typing.Optional[builtins.str] = None,
    customer_title: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    users_action: typing.Optional[builtins.str] = None,
    users_cname_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    users_cname_level: typing.Optional[jsii.Number] = None,
    users_cookie: typing.Optional[builtins.str] = None,
    users_query_string: typing.Optional[builtins.str] = None,
    users_regex: typing.Optional[builtins.str] = None,
    users_replace: typing.Optional[builtins.str] = None,
    users_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c3e45e0829196da0d3804d422514049bf6deb8e659d156791b5eadf13e7f5b1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9626b8b16d4ae7536abf7dfe91ae634227ba03ef54b515469f3e787330840658(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87e5d6672b3b7dfb286ad07208307da29ae7b6b6cdb6c24fa534cef4ec8bcfbc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25f9d3ff71a7c51758fcdd7cbff4ed84267321c9f83786a6c4eb17febc33b75b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__475df8665da20d3bb5729b6e8e02702a0fa0467b4b607b53a0fdca0fcc9f4be5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f6fc78442bec033157f857cb1ca7efeee95c7e3b7369fb26d3dfe0c65e8959b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ed28c1917e26519e619ddc07cfa4292ded97d3410e7fe25d81dbcc94c2fce1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93457985b258ca39c12d024b23fb667887e5cdf19662f72862825bc69e5d0f56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d426c5d2354f36a9e1bbda0145a104f38b2508bdf581b111240733f08354b8ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61effa1925f04052d5501afb3afb78c7d6bc6f68361dbfc7f78cf014db326342(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__811dd01c779510e5ed91bad6bba567d0ab3fc7d5cbcaece0409a80e5151873e5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf1c4b2f30ab1ebbd9daca5f968ec8a6b6892be2f80b251af6e5fdf68df31f1d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ae150411a15533dc838780b038fb10224c817144879233e0f0f51337252145d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aad2330f7ba9a53189e78892eaba1f690cd51d804411b450f5465b3f13cd419(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__be3dec2844702b8cc5829e0f24fd2d01af21bcb7d992f7339f60a02ced31ca6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1569956cfbf6a6c1a66b5b7f1842f40926a5e60f73ee4d2f1e4f49f74557fa12(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a48f62fe2400117914e5bcf5e00b27276bbddaca0f28150b15f2988a6148d95(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8e1a82e6d848f4f4a34d8ce73e603ed0d0ab026c63ba7bf534dcab4dfb97cae(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f10395c1abac37ec495258e8ae6aa72821acffe8b6618e75cce1c1a5a9dec7e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96ed18f2930863fcb0e15066dd0dbc0c455ea69b61e6ae3d012b439c1ad6f1a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d943bc36712d0c18a2e9502cd68df1acbde13579ec4836393e06a84eb733c6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbe656839cae9da10937bf077e08ac84bd9f6cb7dadb3f946109713185884111(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aef765f7a2fb361db321fd343f63bac5cdd39ee413ae1e488e0410e867f02a7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a97c16aa45028b2a073e0612a1d6320928f98af7b4b50329dace5e79dcb9be27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b3800dab527a74e5b48f1839d1b1f07cbabc92df9646935f7b38356b62e558ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcdbe24a5edb89cb65764edf400aa24cb2e3ef164f84602519f15c5ec623ceef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8595c43ad4b1154b0cdc1ae56319e11969b1aa971f1ab76a2576c7eda2e7ae11(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d5b91e1caf0ecb49efcd3163cbdfd1402302c29f9ac6e8ead4acf8188af4472(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7bb06f7d2e0a3f1e9216937fb130d86d5fa2f8c4ef500df20af7286f8b581b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSaasDefinitions],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__198dcfbc063f9c39165679caaae70e9e3d214d3d44c5257e9deec69127345976(
    *,
    allow_override_origin_cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    connector_id: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_host_header: typing.Optional[builtins.str] = None,
    origin_type: typing.Optional[builtins.str] = None,
    sf3_c_origin_host: typing.Optional[builtins.str] = None,
    sf3_c_origin_host_header: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9bc9db6df4b215b0513d2914ef5c4119d4254c8bf6eb62a8770ec96dbb70af1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fec176e6bf876f72fb6dfa3d75e2ab1a7f046b4f6017e38c088bff0713643a91(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa932d32aa6d0ca7dbc90b96ba2fdce977d88338868a47dcb903033c29209b3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__61391b65e412606bf9ce31055c9499493ad7699791e5876616021ab8754ddcbb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fc008bdde963b1f4e6af2629de2d4bf211521b3cee894340e1a29f56e7f4a4f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee3f7613447a695c1bfe0b3336ed975a2c55aa39e13f37528e8f10210eaacedf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6333ec8f16387d19d43d6d9d5400ec7225c6d4ea20c1bd5b4dcf720f7cf80638(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5788379d03b952dfbb50ebd2d6064a5bc20fe762176e21da27d32fd970871e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03fdac6ebc738dc66fcaf22c84a244220f05c35235eb82389e4406223744f731(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5c9252560055dc13286d7965c236b3f655649154e6e2903ddb23402f181a72b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b9db22fa6ca9803d0502c623bf775906b40b4f9c8d1e8c3ad9a54cfbb385f42(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67060902c7c5a7eeb7c65f80879bbc4e7d0fa4209aa1d719ff9bf6b0a9832988(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudClient],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3603b6e27bf03181e3cd390a7d5ad107507508e0430eff6549c998effd34b79a(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__063592a1188fc5e6712334d5e7b84a0038aa704991ecac79236549dace2f7585(
    *,
    host_header_source: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18fe29fdd1bc80175cdc1a4bb61fd955b4957f1ff5bb66fedbc1fdbcfb2063ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd9a11d8f274c4e7ed2bde479cf3a359178ef48705964a1aea769c864f831ba5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a1d6dd2eb84ad9767f489a9b9fd1d828dfd980b3f17c3559c0853338f80ff1a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46fe0f88b5b52430c5bb674788d035ff1c6f881364618f8768e7438a7633541b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c92c500935d1cd03cf1202aa856be85dddfbd2e6c3c3f000dec8398b59174163(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0db4744e99eeecdb7f1fa9989fcae7ded9c9296057d47176bcca8751501ea4b0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProviderHostHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dd48c38a60395f896821cc534b6a98eaae65275de16e007cda8d2cb3b46ae1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463cf8dd56131b3c2889a65d7c8109afd8c60c0b18cd2e76873678a1627bbc21(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53128aa13dff40b82ce856736ce55967344ccc0f3db7d19f5d542cf06c88d7f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d80eebada80bbe23ff25d018cbd29471c6a5e83d17809813e093c43410c5dcd2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc49419efd0bdff58a5c59910b99989486539d63d3d60c1305ffddf7509f25b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36ebca3bcace3f9991faada8ca2fc0acf77e782b9ce76b3eb9550bd83ab4845e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSalesForceCommerceCloudProvider],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cebddfd88e699c5c19de0989527cce7907263704d24cd084ef0a8029c623dc2(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13f346edb2ddf0d83249bc2d2acb4531447bb58d160d1262a9526409e18cacd(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__75a9f24017cb61d42347d79a72450bdba56b8f038c6ea2ef943d998a91024a7a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdd5059f6c1d014a393374ad15b6b1555f7141429d31e8521397382e4210dd86(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6065311ded0edf7b21ed214af146524801092238b5786f8d5354f83189ca9837(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2fee66ac9f0d73a6fd3d3e24ae5d53d6e1d2bf637fb656b3b8b0e00e89bf40d2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a00d58e5c61d965ff15d5e3691e9cc8c20eed862401f205cca1bbf944a701fe6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSavePostDcaProcessing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9684b6f1cfbe2b69fb76131893d99f24785c2935d16d52e657aa63a6aaa3939(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_method: typing.Optional[builtins.str] = None,
    repeat: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e29be8e44b0c7d73ab8767a54cf2a17ee61a336d13726dec69e909bf4cf9bae6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dbdb0f2583d7f48744d22b26165505a79d027660e7c9621f5e83289d85ae5039(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac6ed57a9774ec188e5042af30e13837188554744d68678b6e78df6e13e7dd1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66136d877c08717ffe402516a3962de6fdd4b69153bcbc898b63ef1d3f7a1e8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f9429f68d049bffa2bcc6192f082bad1740bee8ed276c4cfb4e0ab6425c2343(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c727f7025bdf8857c316968f701c1d32a60b6a11c1c21576ac85a896a47bc121(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__470cc246f8b7af90e15a9251ea141cbe0b9cbb9fae3b5f09e109f8d3537289c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1371dd0f6851fa940319b6e9cd4cbc70b905e61d5b9ae82a45087c80f88f2f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c05aad0147aa60faefb29fa9191536ebf95a48384b0d1d345632d08f1c4504b5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScheduleInvalidation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06afd6ba79d44eaff4bce5f679de8820a70ad5d234f7edfdae7d5cd50ab89cf7(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serviceworker: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timestamp: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__436f55944fe184bf711eba1a4c5f8c2fe3f984c14b0d23acad22c99d04bf1e53(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7add2ca197e97f3ad03f549b056a35a2aebfb581d38b3365d1f12bdbbc4093a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__859d9e3826f7dc29ae9287f201047c162f35a1f274f087c5460dc0fafaa6b373(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b41822a5984a81c0230a4c233d9d4463de3765caf3ffe874148388d70c88fdd7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__263fa6313257e10cbc7137e74c032d3f01f103820191ce6c776b73e32d8713f0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03dab271fe61ad3fbd02b6f1c5bd580abae9c14e4fdd9bddff084b907d528030(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7c4278935c9f0a6d139a9d290045806b7a50c1891aa56f9577b91d9777bc9463(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da0ffaf40f23a6f933e8c19ba0fcdc2fec072c93683b6a3208b8ee3ccdf26d42(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorScriptManagement],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ec91e5f7368b564ff96464966424b9021828c149d2621bf860231208a13821e(
    *,
    acl: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dash_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    data_payload: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_token_in_uri: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    field_carry_over: typing.Optional[builtins.str] = None,
    header_for_salt: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_master_manifest_files: typing.Optional[typing.Sequence[builtins.str]] = None,
    hls_media_encryption: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    media_encryption_title: typing.Optional[builtins.str] = None,
    revoked_list_id: typing.Optional[jsii.Number] = None,
    salt: typing.Optional[builtins.str] = None,
    session_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authentication_title: typing.Optional[builtins.str] = None,
    token_auth_hls_title: typing.Optional[builtins.str] = None,
    token_revocation_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    token_revocation_title: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56008c61c98747255746f572a1d6ba9c9f460940bc6bd7d32e35979ca0f44a79(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a1864960950f92ca562f1b6e8d39e39e192335ea1faa0d1a35ddfb221e19c6b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63bb27773724229106a6c6f6d28e9ce370ba67529efcc1fb05ceda0176774254(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4d602e7d4b4d88cdc0d2c29be0702b01ca9b22c4285ce9b296e0cad9d135332(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ef16ba1cef94a61b9a27410febaec9a5fa3eb49df2f256895f379ed22a1c966(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e9f6e9f6d4e067ea959a58a5e714322a31ccc19a6b90f50336aa9e91f8c7a6e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__168d28fefb19a420d7b4a256240a74531866693231f8f3111589a5afe27e06f5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81fa0a8d5a66545fc7ba7d289c5195cd4a9a7814d1de17ed91fc25999df7c523(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac9c3c6bb987bbbae61cd76b7a42cca04873dd1c3ac3226bb79f7557a72b4fdd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44e177be7f2d37e9d6703ef626ae57d4bb86be8c6aef162558c7ba4ff8b3a503(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3d9a7ed731c36935e498e1c3d37f053c28dc2934c90c48291557963e2177228(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce8ec2bcb903cb05b36dc6bf8bf38b9ac49dc67715f50381d41d19c74139ad4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7db551c904456642672ec33ac2c73087ce230e70ee4ba2e3ff6a8d3e969cd2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3049dec4d12c3073e2b889584bf9135cb7f2fae4926a26fd87fd7adcfd2d8027(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5613b4dd9983130e2e1e01b3324c7863a396634f5775b6c3a44506e0cabe3223(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99ee2947c420bedab183663d79da8b41ae36003a449444e876cd2dc965db353(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e3af3923c4613be66a50b7bc9e32ed7f71a99ec945e7d7c64a8058ca4835149(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cfc595e30b75c9df7a7f2392140ddba3bea9f065525e46fb956533ff0d2df98(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9224cf26f354d4a10f51af2838a287a66711107c3ca92d40f131d523e9565526(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4cf050f50e88c09c9433ea8a5b64c6a31f4cc1d0f18ebdb837c52d485053af0c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ecc820650753ca5812c5524b14b0d37a358d3e4cf704f3ae7858b2914a0a90c7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f16f1068385b61a783e8cbf78beb49d4196dfd2e5cafe852fa01d380fdce7f00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4af4117faa3697f7519271e30f4c07648ca1cedbe8f3c8af90db8e1ed494c8ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b06b80d45e3f5040b669cb4137ed732e66cb18eaec0899f1c512af6481ae88e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__851aa21ffdcc301de3c7aeed20c63220b11741ff625f04cd46c451e9d5d16b19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c417029ccf849ae99b77d6f666e148ffd8eb7265c178dab41c03fe05baec3986(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedContentProtection],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__871edcea16131a1cdfbb7fde0b3d835f5ec1fc17473b3dafbb3f1864f7ea0e0b(
    *,
    behavior: typing.Optional[builtins.str] = None,
    dvr_type: typing.Optional[builtins.str] = None,
    dvr_window: typing.Optional[builtins.str] = None,
    enable_ull_streaming: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    end_time: typing.Optional[builtins.str] = None,
    live_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    show_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    start_time: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__893cd9e9e6db1ee10ea7ef266b049e8d9c42e404c5857fb988649f3c1dde52c6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d24a21fff83781379d676769ed75f8162ce841d76f795e7a050bca477cbb8ef3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__341e8a47ec19384208410c755fff13e7bff7dc4a41555f379a3379a4c52b7c47(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cbcaa8218af4516c7906d3a37505a297cb47994e69bcca73a6fa7d716512099(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75b3bd8f7432308b0dca0f93ba94e454df15c540d4488baace031d9bef4dcfb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97d2b697e0f02b86ec762cd06c7054c528ea237727e727a7af4c81da3f174aba(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fb7bb050c1a59ea6562bb8df66b3b529ae2365137137017dbec611c6d7db404(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__40d081544a29e4c35e2a771c1f024866a1f23883387d295d0068090f7d284111(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd4b6d7a674376c536b262a64f021842cc87cd6a284b4f14c043584ae5cc1ce1(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7a8e7735961eadc1e2c64d54e3e2ba979ed8666f9721fb48e670a0c597e71c99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__172540afee6c64f3c2c0c56fe1cb2a42e1f316817c5b6c31c20fa72080d9a175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac03b658203555e336fb5851bf61aaf5063c3af9f95a0f1d331163171e7f15cf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec2a9a69e56bacbbc98c01e2a5cf4ecfec211adc586eddaf67eb9a986d57217(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__313de4a7775d81a9eb8654741a7135b89372007d87dde2ecbfa60d6ae89d6ae3(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c55958466a391e4134b43a46bd4870f089e0e60172b82677779a8e856b44313(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2acaf290158e8025f29c649b1d76f8c029da560a709eb2e873aa713d3868f5a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1b823aa9dbfea39e10ab2c9607597f0780e6e9015375349b9ac3a66f79b84889(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5899e0d73841f4a5c4ed44a9123f2cf4f24158f88587d0d9142a59344858d97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99951e570a0307e6cfa49bf9f0867b3edc379e4af2b0ee92266b437824aeb78f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__855f3b5eacac175c2ce7554f80cfa225e5ec75efb98d13a4f32e6e0cd60e2024(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSegmentedMediaStreamingPrefetch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e58af4a03db48ab00d3aa7472db2abffd7a8783767ef9acf2b31ae4ec026cec(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    certificate_field_name: typing.Optional[builtins.str] = None,
    cookie_name: typing.Optional[builtins.str] = None,
    device_profile: typing.Optional[builtins.str] = None,
    encryption_key: typing.Optional[builtins.str] = None,
    encryption_mode: typing.Optional[builtins.str] = None,
    end_index: typing.Optional[jsii.Number] = None,
    except_chars: typing.Optional[builtins.str] = None,
    extract_location: typing.Optional[builtins.str] = None,
    force_chars: typing.Optional[builtins.str] = None,
    format_string: typing.Optional[builtins.str] = None,
    generator: typing.Optional[builtins.str] = None,
    global_substitution: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    hmac_algorithm: typing.Optional[builtins.str] = None,
    hmac_key: typing.Optional[builtins.str] = None,
    initialization_vector: typing.Optional[builtins.str] = None,
    ipv4_prefix: typing.Optional[jsii.Number] = None,
    ipv6_prefix: typing.Optional[jsii.Number] = None,
    ip_version: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    max: typing.Optional[jsii.Number] = None,
    max_random_number: typing.Optional[jsii.Number] = None,
    min: typing.Optional[jsii.Number] = None,
    min_random_number: typing.Optional[jsii.Number] = None,
    nonce: typing.Optional[builtins.str] = None,
    number_of_bytes: typing.Optional[jsii.Number] = None,
    operand_one: typing.Optional[builtins.str] = None,
    param_name: typing.Optional[builtins.str] = None,
    path_component_offset: typing.Optional[builtins.str] = None,
    prepend_bytes: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    replacement: typing.Optional[builtins.str] = None,
    response_header_name: typing.Optional[builtins.str] = None,
    separator: typing.Optional[builtins.str] = None,
    set_cookie_name: typing.Optional[builtins.str] = None,
    start_index: typing.Optional[jsii.Number] = None,
    sub_string: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transform: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value_source: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22bfaac10bca1243a0e09206629bcb0663693ad68eaebcd68981f7742f7549f6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b7bb220d05143f10e97f5d76a258f4e82041b55ac733693229932fd53e420d0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bec78bbb7decf82c2f7ec6b72cf6c0934a13eb4ab69ad4c2a8e3673dd7f8e976(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adaf5c77f805f6c1bb3a224225621518f1f9bcd1c3c00ba5d50953dedecf7f51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253ec4ebf28f149214700f6a41b8e2647d209d0745956cc81e4d18a841b372e4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__80e9c91f4a1eca7de2a7b4c2831b73a9b2b4bc8b75758d2290e850318a9d2da4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35426add12bdf6759fca5e887da0c5812f938bcf2b0db49b6ed79a1ffa3b9f06(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2530e0180ef1afe936571f803b7d18b11544c5d1b90700f063b9328dd60596b8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__329e41a4edc5c375d27efe1ab3b49242cc883b4333fe16396baad82c7f3689b2(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ac02b6ae332746326444d31d8bb2cd2bd5ef3ddde4730702557292c410ecc2e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bde55be38550c43420fdf208f8a842eb7529692657e44d081ec4b0c1a38c705(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3cbe5add18904d3ae5a982af259ae712bb4bdc44b89abeb772590204c1a43ff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62f836f94e70b3c5267cdb9dfe6858c6730cd594f310eb6912958f3b6c8b82e9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d1ad7eee8bd3cdb44a2367d07889e3662bcf3ce82a6f323b5ac789016b5d69c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7430dd80edb4db17ac480fc639672c2be46d0d9a29fcd5030838f4ccb4c27174(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__784be34ae7bfe2b3634eb45a0e73c8e5f89e508f6a7db5b4c1e66f44342cc5c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a061d7c575a5ca8cb287c394797ee66f63fcb95df04a10ac11bfab6253b6a4a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17ac40e5b09897499a56a970d2bf866c8717773c3a3a21ef48da595d1e7091a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdec004ce5ed65b5bde2f0ec02b17d55860181af7e720373c41c54a382f7e551(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__209a38ba9c349d001a149a263db302da00db8a818b35d8f9f0f8f643eb0891c4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb7bc2cac8e353602a9bd300db526937edc08e4f782fc106ac2bd4f1e02660d0(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a87226a683084e994c8e11dfff47b53dccaaeec5a8def3858ccbae4a2e90d611(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38affdbf8c9039cf8c515d29817a6ff9148928347347416c99de059ffebea594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af0f921dcf86e9e3df0ec1b17b11a2c974048805d8eb2de64277a90b738e4a46(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86ecc4f73bbe96aef1de3b4cba48e5e5ae5af986b453b8da74c3f5b5f49cd34d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2033491dbbd200f346a7e016ac1f2041222eae2113ea8a09d3ac8ed4674a13a4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9212bb01c140ff82130b7f250523b81d6d4fbbeacffca30186d038385773d3a(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5a8db92c471f446544eb3e4e6c3504123fab1578d1268524ddb1b90b8b93803(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__684a14bcd91d66cf06903e9ceefcea0cfd49895a24fd4c611e2936e01c04f45a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eda1d1a006243a9c9478de7ad6eadb842dacd0510a67f43a7237612ac654ef49(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c668840a1ec6f9c4a95d5740616ee1a456dfb92205df7fc6a644e592622e2bf0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8331d25cd2daee84f99949bbf6e92a62fd506579994ad9f08a69ac753e51c253(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a3d05f304c06e1255eaf476f7d6dfacde1284655ff3d15258054517f0286077(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0a5861c86cd100e7d780bf0c774de27cc3e853d80f1936eba95792bbc4d9da0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc30a0a0269aea0bacb7a014aa524f974b0047be6055bbd5287e5c1f646e3170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339647f569706175b0f635639933c5fcc569540c01237314b85764149da423c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__88581f9fcad4664c5e7f0d11f2cb0e25d6ee96d76df443c61eb7f78b3237e37a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fa4be0c7b955d9fb07a967ef3bcc2f611d9ac6eb433f70b5967f5a6b9e142d8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952108cf2fa1fc3a4f9eb86f3be7fe543c768257ae3a7aabea2346462824b12a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5f9a6f963a7429ef4fbfc47873068d95ccab1969f1daf9208b24ff346c79b317(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__efa0689c62c74b6d76afe08e255e3af665d567a765cab2516391563abc0d4b6c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f400781b95a7ddd97fefb1fb52a5095c2e0fdb17934bb54bb33817a3bcf6d998(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cfda5de1fba435ce3f51254decb6ee21009ce6a4160cc0c1745e4d1186f5ed0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c518539583be5eb2100aa138c1aeb75a2f1a7c1f5ba9d82028205dbdc80e5da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b99b55be8ceb520e8546f3e952d66079e3a11a278ae31a3476f5d1d6c985d5c3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b1e26335e1f2313f9f65cd9bbb8ee51e4f0b21257ac91f5b99ce9edd3e9e95f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__043d63fe2f5787c353afdc08ca9a9fec7a8fc41d6cf373cf681603a9d8ad6970(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a59ff42e54a2dd34b96f5a1f557a8417354ba98e201869bf5884d4010a63d055(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4c4d116a91686b29b596b4d07a0737c971e7f8acf172fa7d13b511833faf392(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSetVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8b2f8daec36b8d6e242621a3e70363cfa5c6d7953bb116a367395f2843dd3c(
    *,
    error_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    timeout: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d97ce705301ee558d4fd81a122a476b5ddce9ba0857300b10d87a324c88e106(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4a7812cf6eaaa60482903fceb526550eb9cfa1334d29a1a79d55e1f785d54b7b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac79d1e5111e41cf1b730984346afabacd532dda032a45f98c8ca820562ba417(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1dd9a33804ef2b82cf0acda15a0d76f56f3dee5db728bf3c763ffa4c2cd341e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51445e60f9a76283c6dac392db7ba8f3b4d763fb986ac551be6a427e5d247538(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cb63b028fdb90b5a347a1da465eafe694b71e245fb83df26564283f96005186(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b72da8c0da9cdf7cfd5949cb6e3f0598dc390d990a77f79e1fa01ea267a39767(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSimulateErrorCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d8aa59d563feb4bde9fa7cd48dc77eac80e45f7226554073048f481b44aeef5(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    nossmap: typing.Optional[builtins.str] = None,
    ssmap: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap, typing.Dict[builtins.str, typing.Any]]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ec61a5d8202e51bc077e70e2b7300b0e4e1009208c5ae851a1d78ad3b263f64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__52bb0120b925d68a238ba7b373364d53066b0b9f89c686cf7c6a04e6e95e26bf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16247fc89afafd9f6d98383946ab7b0cd96ce5e73e6cbfe9120cd6093a4a1389(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ca1bb471d700ec47700426a6826defc795b9757f5cc3d63850612760e2680cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3e87ab368682e774ddc1901764dd30a6e8631484ae2656b64c7d65dc4d934ca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d7b95688be632b79d43ec6300c11bd764af1ff1696b9954589fbc4e5376c973(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShield],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__074589abff8836de4c10929b11936f1cfdcbda3bc69abef24d81e9cdff703828(
    *,
    china_cdn_map: typing.Optional[builtins.str] = None,
    has_mixed_hosts: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    name: typing.Optional[builtins.str] = None,
    src: typing.Optional[builtins.str] = None,
    srmap: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fde3fbb4327284198e21798ad5b71ab543d9d078910b523a58f7474a1c73968(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d61bda3c7147d3abd72b2fd31c43e5ad3490ed4e80467b6470f3a145edbb6dc7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c92112c58383d8c457b64b83cadb9186013e284a1af4ea7fc58b803831ab6eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__171f28141d7b862437d5cb43ba83cccc9660be435255c17da0370da760362805(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bc640e2a400665645ea051fb22f700c0683fe81bd5736a016e58535ee491dc9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13ca6e66418056898f7d00547c16f4e677442c4fe9c57d73fc5d0d9d6c7f4175(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22a680c8c204667ea5b3b5531309f29fa97f6a9aafbf381397c1bee1e17b6c1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aa6923679654cdd9e973bcb301a79b921052fda3b34520640ec02e1b7567b51(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSiteShieldSsmap],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01927461f0f2acca49c101add29dd2cd23363c7503a8985e99e44943c9853789(
    *,
    allow_https_downgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allow_https_upgrade: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_sharing_duration: typing.Optional[jsii.Number] = None,
    cache_sharing_start_time: typing.Optional[builtins.str] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_sni_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_tiered_distribution_used: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_duration: typing.Optional[jsii.Number] = None,
    migration_from: typing.Optional[builtins.str] = None,
    migration_start_time: typing.Optional[builtins.str] = None,
    td_location: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ae65c7284b6ccb39eab7f2276db71adf07fe97f3d12dc4250b8b784981bd041(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb3def89a93b724744cca8f2e722dfd9853a786264343f3f0e28d596937ba0ad(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d8a0b40b35019f1985cbfa8c2890ac9e18cea1df064190012716b923623a09a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6afdf6ffc74d8946db65dfd497458e991a7bb334ef82bdf3e05fb2aa12fca637(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103737a5655e81786581b83bd7d2a1b3fab8a8de8becb0b814d20b294af85db4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__947bc3c707847b681f06772e58620363c25bd96ebde9f2db56aee0212377ba90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c71ad69ff8c054e7c7d3308ac7f2454850d15f55071c0a29451e095ea1427ab(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0b6c3a7048714596c13f5f5ca9e40e5f800759cf2ca8d14d872cecafb91ac204(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__489de337b7fa2bb94b629ec7af9297899538f3a3f842583bcde8c344ed344ea0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72d64745dc6a75b827a6c09dcf6363c81a7f912bc4fb4a6ef5c3d0e74cbc8f74(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4dd99c72a4471f8238e44dd1d32c648f83ced0f92ba2d205bc37f71cee196bf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3708ef33652493b0ddd1809397872567013fcee950b92b06a6896c80fe59eceb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19356d9082a3cd0e397cfa3aaef1c6fcfbb914249b844e2c8c37084ffd989005(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e31265668ed962cec0dd0439c5b35f16fa0f1588ae39bddee1d0b186dcfb80f8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a681d9990d01c6e0f4ac1f27699a069410dedaf20e46acc580f00356b392a34b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac81a34083ce019a9af93c983cde2768bd33f2376a5fe2bdf34b79a73f445198(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d5eec8c6891d3b328d6d5cf083db7ac9d8ec55b02eb50c96be6f73f332cf6ed(
    *,
    info: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ee1eb40420dd641b1688dd784f94a6054b4e5c735d64229765472048d90799f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ebbd56c561340fe099e41a1bf20ba77f898bc83e8575363b793f38a5cbd89f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__323453c1a3de17c79e036fe988dead24eabd943e8924e654ebd5132361a04f30(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff3f9ee406fb6379d7a0b0fc8a81a461611cbd04c3a42e7e4643a7478d9b0294(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__566a0bac5e7929fc8e1e884e2dd889aec8ef202454c383b45947749eedc39f8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c011c455a82875ddd5d0d3b6671182ba9b0f31edfff45b0e1f033f64af2aae8f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStandardTlsMigrationOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d05c64480c0cfe7321915f7962bc3ab16522134152f286ae96aba67d268402a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    strict_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    valid_mode: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da58acb6017590c9f0e98582f20244468e067518274d7f889b1e0338bbef1dab(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47dd449adb5c4cb686b4b3d699fa1e10406e5a93b1a728b7cd4d327f803d18d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f8fa092b1d87e57a08a9d8eb549418f188a36c22d75172322ae3d2f865b0e70b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__155972882a9d1ca3f8c3e0eae6d3980b7a16ed70003d94ab62e5637218e71b97(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c3f4a9f67f70aa85a0f7ef0000b46577b6ab39184b9d7740ae88cd930e1f7ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37e479354ab62b6863c63d59b2ccd111a784d17680123df3ee3e7bf0f205654(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c99dcf56a383d62e961d151aa57dea44d28821af4c3107cb4a6678db18d6147(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorStrictHeaderParsing],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b5c3937ebf5f7219287eecbc4e4a3e76c5c1c27f14358bfc8bf11523e6b4a9(
    *,
    access_control: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    cache_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    caching: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    content_compressor: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    dynamic_web_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    geo_location: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    large_file_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    live_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    modify_path: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    on_demand_video_delivery: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    partner_domain_suffix: typing.Optional[builtins.str] = None,
    referrer: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    refresh_content: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    site_failover: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_authorization: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    web_application_firewall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55034ad4a93790ee566051a0c4de9726a26d63da6b3768d62fc875be546404f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d48ebff8ebad99d48705e1ec070e66340a24b9cdd3d6e2127c08ecaf420a451(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e05f51c4932f57d97dcb6154ebac43efe4e3e07e82d41df224f3eaf5e64046cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeded650a0dcfa3bfcc3ae642c8aff9d55063989c06a65c6d6c658ad434ecb9c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9a0bbf47699e2c1517d061c2637d268de7b9dffa10fe5788e648fd78388c50f2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c854a431c2970293240fadb68a0f137e897bf06a484feaf5d84a1982a2e63f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5586d86a6ad1a1f29ae93ded16f0fddddfd12e2b40da8d416b3fb90e957b1fec(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55ae3997ddcf5f4b6e6bfc66e0f80d15f10a9f5e9116e707931834da34f758b8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb13e175ff328fe8963528bfee553b27b075e75c4670cf9f9e2cf53f1f5adc44(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55b3228ea22dd45a494b22e79f2db605ae4158a9e0ba8b9fe1e3fdf4181c0863(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d797dc60cc7ccd9e8ccbe510e0dc30d3188d1cd07bba9cc7427351538722b2a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f527c11989c80a3d1817b3ea783b920a3460f4644b62e567b75b87a1c723212(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16c9b679e5e66127c074c10d8f98c9bd22925399b02f153e4f4f7aa60d1c3347(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d115052f409da3ee8102891e0086d8a1ab46fdde108074b43af0182b37a0b84(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd670aacf0b9a77d61b404ac53f7fde49e06ff19c2474e60d10b5d8836639417(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44835b39c58560d564e818930ac22ebfbd871febfe9a133b23b8dacd7e9940da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4ce27e4ae625ed6910e5878dbd9a6a4f6695bd8718a2467da68834fe24d1d72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af54ff5b2d5b01e4e9290ab47014762b0c2a12f4f4cb8d8670cf8a83d4849784(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__230e1bcecc92d18fdbefb2c74dc0004048b6ee81ee8f5ea44386ddd6a7cc9678(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17a01484e3e1759cbd297e91e32db13ccc36637d110971dc99d24afb1883f32c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dd05303a8444713d4b2cf79c9486f4f8679202fcc62085b14b8ba195c2175e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ba5b0eed65d0e068a105db22a765fee5be7374acd8222f52c33d79bdeb318e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589684be1d254ea86173fac9c4b534e98fa0536955e978a47d0be5606288a50b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d8347e2f03a1745ab2057b9a18c19d8cb0db8243196c333aac4ad871675163(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSubCustomer],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5a6efa90e7573b1f470ae5406242155ddc05e4976b0e1f050877a9c254dbbe16(
    *,
    allow_fcm_parent_override: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map: typing.Optional[builtins.str] = None,
    custom_stat_key: typing.Optional[builtins.str] = None,
    enable_custom_key: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    force_ssl_forward: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    race_stat_ttl: typing.Optional[builtins.str] = None,
    sr_download_link_title: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    test_object_url: typing.Optional[builtins.str] = None,
    to_host: typing.Optional[builtins.str] = None,
    to_host_status: typing.Optional[builtins.str] = None,
    type: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aafe6ba6e09b928c146d17a7eab484d120b9cd89e0fc5d89b47681c096ddb8f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9b4f3fed2ad5dd7ac4a7be2385790cfdd11024a9d9cd973a4ddfacd446d1bc5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d270f5ebe37814d20bc2c0ba3c29b8776b6211c19d6c79b7bd8675eb9ba9219c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81960d5fa4b5e479842092f1edecccdfd5440488c6096514ce40281f525cecf1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a4ba90ecfe85f77bd0d0ae9d8b1800fedf6f491661be9ce78ce1c16d1f5f743(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82e3b67c2d0eec7ea8c33eef0030cd182b0369b6934192814f775a765cdfc4a8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2288f769bb782de8e83bccd3a0c33615cc181e451c9eb426eb5edeed0f206aa5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__176b77edd1f424aff22aaccccdab2ec68d6a94de96616be3d9835cb5932d547f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7aff2074bf53721237919842de0bdf1f1603fad2ea0f01e277a9f9d2e93692c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e1ac5c7b8741a41bb67855a9e105225b2038a0e42e6149e845caf4168b665c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__491cd6e629ae217cb2dd4ab1d7567d11457b87ca2c66e4c21723bc2d8c86d14d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__674baf3504be22233dfb601ee588d55f697765ff38a2a6d5a600ff833bb05537(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0057dfc6e0c21a45f529f2f080b16483c2ebf84161c495ea6f26037506b09c1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da709f7d3de0bd564536a7f45bdc4e0f354055d6bda61704ebfa88398f2521af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__97c4eb4d7df4e13e2687e3230460162515f29a00e5eba3b0397158ad022260bc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c84bda76e8a9791080bcd02efcf435eb13aaadd01b3af5c4fa210e690db01fa0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__14d629b9ff47b12b107621094c7e70cb0e1f88209c84b88e423edfa9811c7a4c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorSureRoute],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d179c2887d5449388118e50f593e9129815473eca66928e762d09fc1b28a66e(
    *,
    display: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77bf925b6c1c357015073b9decfc49d69e9308c31e77a6476f01559a2bb92261(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c0dcd07f2804fd41a51d51d619af86b8ff4c89a988af5747661b0d59676817a6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd930e8479e2d83e94485fa80673b335e0a161a837d4eb577c3e0261f88fefb5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e053811894b6b156de42a5de7484cc0d6801b7e7e6ec830fa9ae40e56ef273dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd22e2f6a87cc5fd3bc196d6d0fd893cbbd0529d2e0da2ddde247e2848b2dcf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29e2f8e8f8323a1beb0e2821712cf05398062b651b4a17cbd6c2c6b35348b691(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTcpOptimization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2dd9853fe998e639850bcc14bf4e408d102516c421a930b4d38c558a3206d41(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ibm_customer_id: typing.Optional[jsii.Number] = None,
    limit_to_dynamic: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70fc7daae62257521fe5d4538c172188b5b03d94ec62d1595a1b7394d7f9a03a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0b48444ee476bf8ab08c510b6eec2e58e8ce76fcc3e3dfe13d602774da05e07(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__503823b36d8ca37dc481ed1487011a63db8b63782739c348a977f18502dee6fc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__888bd529290dccd60370e6facc8283e9bed3834ee0fe01dbcd2d3d7fda5a5d7c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a91ab9ccf97d5c7ee3b6970d330944faa86a7be42c55406fef2e4eb283fa070(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0060bb48ae9c180451cdeb21f3239a4cbb3c5bb0b28331070bccd6caac5af51c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20775da55699cf818e120631f4b02f16e5d6e7d8851935ad1bdb4f13074bf03a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f7cf941ec0bb422e944db9f5dfbaf3ab481cd3cebe0aa81b97373d66e626f9a1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTeaLeaf],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f1955ed15492219efcba9f5f7d5e0ae43a48cc8a4dc3888e8e9e05fb587db00(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4284078d75774b0f4ead9828cb5c278411a34963e279a15bd8872c52277ddf75(
    *,
    allowall: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    method: typing.Optional[builtins.str] = None,
    policy: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tiered_distribution_map: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__631342eb484d35c6508bcbcc76a83093e9a1622222014e176011753404244328(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fd34a90d2cc5fc5ec9e19d29bcdb6e85bbc903175ef059b82cb2210c2dad6ff7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e729c626586ef4aa78c9bd88d55204a9b808acf0357bba8371b383ab5940bb50(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f63f9277977d379641acdb1c1bf322cea15545b5b7c50d808de777dc4f7a4bc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__311594a8eee4756cfd1304559955958a16079cf8a8b635614cd74967bfb8bdd1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74d68e9dcd9530dd696a4473f0cc9e3045f3108776426822404b81496f8bddf5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__582e056802f99645744887858c595128b092ae455a9548d3d074394392b8089f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__42908fa899ba5667f9fe00a95f655fa455379eac343f520d12850344ed8d6a7d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8236b623350aaebdb4dcffb2bb40a671335585daab61e363840c0c0471d29241(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__528b0984bee06876b122f17ccd02c1772aa86b90626612c17dfe193adc6c2d41(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__097f8ce3e23f81734623e2b7fa84a34a28ac6bf0ce0cf41ca5e08721739ca29b(
    *,
    cloudwrapper_map_migration_title: typing.Optional[builtins.str] = None,
    custom_map_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    custom_map_name: typing.Optional[builtins.str] = None,
    hash_algorithm: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    map_migration_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    migration_end_date: typing.Optional[builtins.str] = None,
    migration_start_date: typing.Optional[builtins.str] = None,
    migration_within_cw_maps_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    serial_end: typing.Optional[builtins.str] = None,
    serial_start: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    tier1_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36e3d446f0a8e3df7cabc7bd46fd749a9f0cfe3bcf63a96e33e6e7a4a8873a69(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc026a385237443d93f653d99aee585ae9af31c218ebada1b2ec23322f416373(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ec4868facfc9566a45013007bc8860630660ceb2222c7bf1f6574d256a15f1d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4b5374e20aa5dddb08de5baafee637632907e03d584b20c4acab1af70512551a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f082a22c18835b6deef606dce31f3a9607618bdeb2fea04150dcaa333253e514(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397e95a0f75231417d43edb5bb9304ff80b897c1fe04469f9a0cd122641afc66(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46d116bc396bd3dc266d7684a8ccc6c6fb29e9625de4e82d2c9bbccc4325e436(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__083b652a8039b30ec7127e5bd42fd8afdf46957b8ef98295ce0c47b46d82d451(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e7d139e0af6ef38a9048a2a3d200b88ac56b8b04487e5b2df924bbec07f2918(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bb7d096ccfdc904910179ce4f142c599ba3a252b99e99b737661798357eb59f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08d744fdad1d12ab37f3a6c4146e799de1f67e88c58084d904379c36871291c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6f866ce315738df0771ff8f6392358cdaef048bbe3220ee76b420d89e6aafb3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a358c18ba02e4572c496c8480ce6b1aeab9573ee532f784dfd7326abaaf2192(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1faabbbd3b28b52b922e9629da6d8e72a04926734f61dce809609aaa6599b3f1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5df64d71d86584a07e65683e6dde487de2521860873b662410c10a93cde801(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8d0d408556126c404b9babc962e1bc3a7a2aa27ba661e0bd1a298ff55855150(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34e0206052238370127b906f7b960b81a95130992df58d562ce5bb94ce0cad1e(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistributionCustomization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb3dbdbc48668d4dfc6bff0f195f455db947ac65d26510bf5f86f9309a408335(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62390ed8bc5f5358b22293e31870b0a49fa72b7a0c9c568fb5e842b44b3c62bb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1210cb8e868bf129b80f89803582e418e464cbd82a2f5ee1c116928c70bc7e9d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b4b21fde9f863bcd53e9da0590e3adcb39a96f70a496fb3a5d288995d835594(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35cefe8c4e8a36b25eb08172357ff8169cb908f8ad0cf0d54db5386c30eaf42a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9afdb333f0247cf701550f71653e2ed8ded99aacc3792bb37ecaaa2b6f917f6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__44c897a69b4cc7e6f68357f185f39d5d0ff6143eafc03b3adc163b57df79e268(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTieredDistribution],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca2cd6f6ebe9a7dcb2eb27b0eccfdfa52cb7140ed28bbc8f05e132fef9d472fb(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6eb4c2c006d4a7234c001e4e5879b9ef54fa3dd439f551b22f192f1bcfd67c08(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ef76eba7a409670d5fb246280037793845cac5451d602b40cebb3cab5864aad3(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__008f680143080ccdf61017aa26ab0cbf423f903d79a4bff51cc1ed11d6efd435(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcb008033103b734fa14358cad02b59ba7ad24d35fb15e2fccc1559259e0bb64(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f930bd2ccbaf0f720d9a8061ed7bd0d597e72f996c271bfcc1d35e978d037fa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02a5c1358a38cb171b0ea5b00d0bc05ed9546c26575f839d914eef9b75c827b3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae5a999d44d8892a9ecfc462c2ac4654dead5e8f156d686ee49487b52a57cae9(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    legal_text: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5dd185b483022e170feba95416978f0de46424c93ba0015f155f08bc0a0864d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98c2b6d0358592094a60cca2527876bc6eebaae06cb76a337db8a07c0dcb9131(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f5dbbfda7477b1a99d20210c74fdbdea55d1920badb44e519d2b57d0d9ec8da6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fc844763acb1bd9cc873f0b7838d9d0bfcab714e0e8900dbaa77448ab6d14ff4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5e12bdd0fe300d95a61529eb0212210b04742b23fd79c77f1ceea29f507399a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d7b80bdf066b13da4cc943f9ed248c1bb5bda4253c8a47981734c80a7b2e0061(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c0dba6a5bd51495d6a792491b8c92b8f8cdf731ecdd70d4be6f5bf3bd862ad0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d0775b6d78300da879c42512e118e665ff9e94382d60b7be6d10e937a2c2f13b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0816bf07015268ee956f57ee1674b8a38a1245ca609687fcc8386eec19f4c374(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea2787a97f06a0e14d321ed30c709c2ec66b965f974c5fe4ed6b1555e59bdeef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b179d22b519c5e9be4b6632cfdf806daa4548a0ce989429d41d471e27a9e8d0(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorUidConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb4cccc5fc33f8baa790227e2afcfa1bfe752f1242a73a746550b98cd0069056(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15d7815575802b85cc65e9b5e49d978914e20d57931c7b16a79695b9fbd546a2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ea41e7e92d10965218791ca3f6124bcb55e71e6024791ddd01565bb0c402db5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea5357c8dd28910d82d380c2ff2d7fbfb1256f1dcd6d218443d985d10b763a17(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f594377806ca4e06ec0f8810d8133155b6c42424d1145d68901249c13f683299(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__446cc49e4bb54941c3b9acd56b3d2717eb332f0efff349bee6612f471d87ef1a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58997628556cdcd85bfddda547acdebd25cdd4462910e1b4593928367246e85a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorValidateEntityTag],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8169c2ee43cb930b7d064eb68d250a1453bdc713aeafb373c69cd9c8adf5de0(
    *,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7228d4e00ea12949e222a9b4d5f2f3d62c683bc555315a33f5b7703a82104d43(
    *,
    authorizations: typing.Optional[builtins.str] = None,
    client_id: typing.Optional[builtins.str] = None,
    custom_header: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_es256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    enable_rs256: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_authorizations: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_client_id: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    extract_location: typing.Optional[builtins.str] = None,
    extract_user_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    header_name: typing.Optional[builtins.str] = None,
    jwt: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    primary_location: typing.Optional[builtins.str] = None,
    query_parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_name: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3c59e5a746d702edad2e7c49c15f360bbbed31d70f11d15a4d2dfe3a29e3419b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23ae7e811253c7ff239d3034faf70826b893b152c66d3ae0ef85340af5ff7548(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f75950dcd98e36f92308f3a4e55e37a6a73ebae4d16b68a9fbe4e236e2f2142f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed9b86c6390f2c3173aee0786ad2f9ab33e96fe9bc71fe8018701489146f5705(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__56e232d4f3ad843ab6559f2600faa7b436e9ea0c92253b04e2d143da19d40e46(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e4c9e22a832d8a0c4c0a5951647bfc4b52fd40b94f16366d7f65de20c54ca90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23fd4606d672de1bfd4107cac254c199dc67981dd138ed487f6b809ce7b5d0e9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27f0a28735073c9cd139ecab8819f915780e46fa89da17ed9dfbb66f31c36372(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4bcc29f3c70b827c4b353bd19ef62b44bc6a8af7c1dba8a52dfc6cf8af7da2c5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b002621af6cd0971029fac2ba69974ac4a5a217811605d1637a160820d877997(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca02aac0a857b6416300dc681a4d881677e9ab365a3a37d400abd4b6c7650473(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55a206f8c7edfce80cbdb7b8a8a1522d637c12a3f06ba03a818c5fb02e409703(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bcdb6efecb77c3605f1b47df9946dfa3e9a64acb8443ccc17d78bc501601a770(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96f484732a1d6ffbcea9b95afb5aaacdf231fa2313d54d9446f3bf732a7fb7be(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b4f400bfbe75298c0e472410b37d98d6e8bd863d08ecb592325ecfe12db35e6d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b266f57baa5a93eab7e36e55ddb1fa0a402c0d55ef04850338b019205c271ddf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6dc49f56bc0343e7adaf694439c6d94cac02d3b88ce3bbdcb94fd2dd45457492(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b8e94dcba6bfefa6b3b5c67e6170af71eeb0c24b8e9b8438a210b9cbd0a70ae1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__495a041fa2fb47f7f0c0b463fb1d4d9711a5bb85c4310b60d523e968f6c051a3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebTokenForDcp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__90a676ab9fd007946665128c2af97f1a05f0af98758fed4c8138bf8c61b5db6f(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c573c31f2faf4cef6ad82c4d31c7c0ec3c749c5c0be6274ddec4b5bb30ae3a92(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b820a02baa6e8c3befdb8d159ccf14e10a8bc4e968d16765a563111379f4aa37(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77da3ec5efa7b3c65787157a8ab103a8e05e2ca74a5b9212732a9e4d2bf7d6e2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fac9373f337e0186e5c2430ee56870356ea1e2e95e353896305004bea88d36d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__087fc8f2a2d0dc04bd9ac2319b0bd2c9aa6eaafd533a139ba29859f1e763bf19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1987b2166bc4eb54948357af3d500b02548a46cdfa348dcaa4dc6b994b5fa513(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d83d5cd5b8709eaffc35c051f330311c16313e3578d1893ffc771f10a0ecc34(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c416025e1f75e9c24f5a968aa188c4267b008ffc41add94ef413904050151f96(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95a810037e397d43b17de272701d7626379c92ade908552553ba5c5d516a74a5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fdb696e0130b4be4d9b259cb8c8296ea90c11f2ad26244088385ad384b6fe641(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyJsonWebToken],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5658c53b8358383f21be1f134c6b4f62b8aa08c1298edefe203027d3f15518fc(
    *,
    algorithm: typing.Optional[builtins.str] = None,
    escape_hmac_inputs: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    failure_response: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    ignore_query_string: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    key: typing.Optional[builtins.str] = None,
    location: typing.Optional[builtins.str] = None,
    location_id: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    salt: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    transition_key: typing.Optional[builtins.str] = None,
    use_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92653f8fd8f47b070fa967f1d2d00315ddbae5cc41583fdff031abd3fa7f8e03(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__51ccdcfea9c7b91709914e83ade95034a1fa9c5411fca31d89fb1dbd9e339a0b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34f68f7e252f2e01ddf412265e4e95c2ef11b4022e5159a5866b36f472b954ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aded4c148a772c2aa0e4593ee81e056f1e7bb7d2f107111ed5834d82c77102eb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d02850a5e163aee2583292062f611c841b420636a3853114f2874933d204363(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00ceb567a094a907a7df1c38ac808bd91f488baf52057f3b0153d66119210b37(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e27f09ab73f345b473c39708e800b662ee78aeb35cefaaab039cf0fb01a1b3d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb5cdf43aa1396a51a296f6239c4ac5ac352982ef51a4d1b9bf88ab2a0a95c7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__15db987eb1fc3054eb36d47e9342c7ae26cda3c1cd232b69a93d8fc96dfc9646(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19ec7c95b939b42549c2142687356d33fdc5180e3ebf57f5d261e6ca67f1221d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__00723e6b6588a77cf4193f801bf79e917b9450e4d93edebe4fbdcd43482bc8b2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a05d728e4482af6f099c9013b9d4f49f7198d3096e2c3aecd76f0f6a471688e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9b001b02b9b6f7cab4135747a4f43e24f24296f909fd741baf1c817bd7872f6d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f6a619e19f27a34e4144755d6fd2a37c6bc554b60327655c6079fa20fc3d9d48(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c8f3a0abc627ec05872e71a008d465fa86e59b6a6d16fecf68701eae39be10ee(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVerifyTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d719b5476a65d5e8d1a861c44afe37bc38aa4bcf434c534d26b67a6ea1f0b79(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7517fa339a6f2e8337a1d7f7a718c76232773ff4cb95b413bb3d65f2331f85ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38b4291bc0103287b46192ce299e1c8f40d6dcc725c432f00d0de9b6264ebaad(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6b0ce94f62a4759c642c3880a9a4fe07b7fdb5329eac72b07f5adf599c04efb(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab0b32b34e3506f8a09fd6f0ad137423f805dd7b651cc5a6a6719dcc0cd2111c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fb83b8ccecc484c9e7c37e7426367fbec2ba764fca3c6b6ea428c25cc42851f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8150c1020d11efe021e302a1bb34b14fb0bf125b3488c8fe4b1cdb5989c1f848(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f1aef692de2547ab5acac2712ea80ec3d44536d285f2b155010f968c5c07787(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fe20fbf6f8e90bff90f426b738efdfd069d1fa590a753b9ab667178a3534b314(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d9ddbadb67222bdadf7b5e8a5bcf5d052a7e83ddd2e5bd9dcb9f15a5f49838a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0049c759d180dc0edbc1669932b55873b1b5a7edb810c903050152467cafc821(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a312c3c47bdf1aa0a9591e16f961310c420f5571f3bf08fb3e33ce4101b1d968(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b3f8644066024fccb7b25a2b53769c7f8ac1e5641560401cb24cfc425a8b79c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5d4ba1728a1178585d3f5cb3f8f2f9655d1b4155b93e1219afaada962be8853(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7daa945c3b86cd3e228380d3ba69888c3d20a5a235aa66f1df9887c202df396d(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f59fc89323df4dfb8a5cf337b241c5cc0c6ad120e073a2f92f19c129a0aa1c5(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1458468a4579b171064ff5f37811a34a97a9c5910113a25cedde51d484b3c9ec(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5f76af32a7edd4c16ebf239408476d9d443e1f4bdaad9e1d8978bc195327bf2(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__694b5ce43092fb020bb2543203ee41d9ea44eaee8775474fd60176f45f9c6a3f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__807df0925db8131aa41decbc2d32edc43d1776acf45b3268186ec07130698991(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e658dd975c90e69cf6e47e3933039a8c090aef9d38021d6e0a9761b3c85feed(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVirtualWaitingRoomWithEdgeWorkers],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__134b7a4cf13f7c8a5631c91f73a669a5d05e7212c307017802604927636a3dd0(
    *,
    allowed_user_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_domain: typing.Optional[builtins.str] = None,
    allowed_user_cookie_domain_type: typing.Optional[builtins.str] = None,
    allowed_user_cookie_duration: typing.Optional[jsii.Number] = None,
    allowed_user_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_label: typing.Optional[builtins.str] = None,
    allowed_user_cookie_management_title: typing.Optional[builtins.str] = None,
    allowed_user_cookie_refresh: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    allowed_user_cookie_salt: typing.Optional[builtins.str] = None,
    cloudlet_policy: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy, typing.Dict[builtins.str, typing.Any]]] = None,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    user_identification_by_cookie: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_by_params: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    user_identification_key_cookie: typing.Optional[builtins.str] = None,
    user_identification_key_headers: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_key_params: typing.Optional[typing.Sequence[builtins.str]] = None,
    user_identification_title: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_cache_ttl: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_advanced: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_automatic_salt: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_domain: typing.Optional[builtins.str] = None,
    waiting_room_cookie_domain_type: typing.Optional[builtins.str] = None,
    waiting_room_cookie_duration: typing.Optional[jsii.Number] = None,
    waiting_room_cookie_enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_http_only: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cookie_label: typing.Optional[builtins.str] = None,
    waiting_room_cookie_management_title: typing.Optional[builtins.str] = None,
    waiting_room_cookie_salt: typing.Optional[builtins.str] = None,
    waiting_room_cookie_share_label: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    waiting_room_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_directory: typing.Optional[builtins.str] = None,
    waiting_room_management_title: typing.Optional[builtins.str] = None,
    waiting_room_net_storage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage, typing.Dict[builtins.str, typing.Any]]] = None,
    waiting_room_status_code: typing.Optional[jsii.Number] = None,
    waiting_room_use_cp_code: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57f59e4890f308d98f1ff7f5aaf06e13ef717021765309f56c283b913e5700a6(
    *,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__93187d68e2d169a697b66b59d6f08d45ff3043070ddf9ba76a301e4ae0646d8a(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f72f2afa42dee7cb097908fac49542286b8588951ccc1c25da76e77cf03fd86(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72098d186bc211080cd46ead08bdd3a2b687cbbd9b2684b02de1fee7cdddcbca(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2512037ecc513376aca4e785f12e6e878d7c25810456ce3c443af9735c5a0055(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationCloudletPolicy],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7bf47c991565b2d74e594563f38970a649a66f7275d8c20505b0e73bc4f51b3(
    *,
    access_title: typing.Optional[builtins.str] = None,
    cloudlet_shared_policy: typing.Optional[jsii.Number] = None,
    custom_cookie_domain: typing.Optional[builtins.str] = None,
    domain_config: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_auto_prolong: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    session_duration: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    waiting_room_assets_paths: typing.Optional[typing.Sequence[builtins.str]] = None,
    waiting_room_path: typing.Optional[builtins.str] = None,
    waiting_room_title: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c671f98a01f4047a0299893604121cbe6e51c852f473a2a989c7665b9cb7ca64(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__269636c22d1f4083249cf59ff29b9273b9f302cb3269ecd81a87378a801717c1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e3dee6daecc35679ca563877a873320060eb7dde2df8327b5a5b80d966a12ae(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__724435c0feb950ba135448a6959e83d44417ebbbd1979d72390b939f78def394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd283cb09fc335447fc7f27941b379b472a9e3e6c1e897d72b73712701862cd0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2651eef3f7c449f18f4747ffa2e34699e2a909f88010a40e0456686d20a86446(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdb5fa8a0ee678a69ef75a3aeb6a5c000e12850032368774406ad7907874d4ba(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__326a69c2740482bf5d2f24f3ff3a2ffa4ec603f6e6d4604167dbd34bca1183e5(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6370190d60fba79455eb8590cc6961212bf073c2a87c1fd11d6740f0d3c9444(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__573d2d28cbc1ee17752c6b615e9dee2f94351c609753426facbceae114ae59fe(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee6a6207795ccd9d5858e79133bf0f47da2b09f97a9ea6c5431546012179247f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9682ec240a0c3cb50cd243a9a4c66d4ef272fdef72587a0b7fa3e50830002f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8730153be65e8c0345c409da3ba5bd751e2be44504018107c28aa4210f3b2ec5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82292dccb14543ae3ad5657b5048f61d5e4247426405279acc5baac7a0b27cbf(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifo],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c19a193ac27beee22f14f0b9f7c2f2f1c3490b4142f9897fc60fbe97b521bd(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__000ff5421ed09630631142106deca0d6ca791236e5fa64c64e5c6c17258abd39(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2521637a122cb0a4ee034d740767683f786fcda4bb92562cc8cc5232dc522d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f711fdcaa11d7f85be8dcdda792047b374f5ed127b20f5aaa6224e83d87bd81(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4442ab468688c38e6a94d2fbda9befdca7ab4ed30005d5f16b7a953ad19a618(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac2035c55dfc0fb59a823ff09bb7e195b1ddb0c83a976965f647aaba8ec75ae8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationFifoStandalone],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b831bdb770c017c99c10e4e39253cded253a0b3cdc0aba5dc6c8ddee357d8ced(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bb852367e4efddd5bc82a8abb35528cc74740e3a6beb6064922478308865944(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__211b5b998644d2ea9d69423fcafa3317f246fa2dba1649c2dc680fdc4a1af59c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2d0613fcdfd2c26fa7b2eaa954517d3872c03ee4dbabd647680bb57a553fae77(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9400ae2fb26aa41625bf27675643c00b465c22d5e92b71ddc2da8fe5effb000e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6a8a2d4e598c0b338607f1a6d7dda4fd31a70e59de96cc160c7e49232fae383b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8c514ac4683605df323b189f9e2d071d675b92defb93ab850399cae367b8cdd4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a506cb9cff5d9f8229dc97e0880dfecfcc4bccf60a172ebf2d88f3c6e1b3812b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9060d0d83bc12e95d71172a5c9a62f5df8fb71952df7a11edb621862d4b2d1e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b946f84a5d9a00ceec022b83e237602725903c9f8ef37eff498bf5da2302982(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e2b142ebab89ecaa6d480c6597d8f7ced401b403387e8dc053bda25f2181e72(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b9f5eb2446a5467788098347f071e256b4033cfeb43055dfb560ca2ec1c0425(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__06807613cd2abe89d0ecdccb8dc9e05dc9a0b4c6b532b182f703fd3752071cfe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d920bd783e5139f6ac181ab7b270beb9796b48529a4e7a2a175c59e5b0b480c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33d4a3da29a3aafbf885ffcac7f8b535072718a3f68b98127f06713871252916(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__621e9f882254a32311e5e4c14a3ca8696e9cc53c7081483f4c7c1036c5bfcfc7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d06743635739287d3a5e73f0104b0728ce81a2076ff1541cc82ffa9f68c7e534(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b11f95ce1801b8d8ba38e3775076d075199ea08b0acceeaefbd09dc3f1d1f07a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4764eb58323aac85e57aaff35fb7ee17acc262b67c4698c1a4219cebd5007af4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__758434d098c058ebffe63dd27197af37bb1e0799c5396087a701f79ad67efca5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92149b263472cb047ae5e320ea8a1adb01f9ca6ebbdefd441c1c4f4169f6a957(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78dfa28120cc3c54c9999188ea9b84a3917f6534e7abce3723effebd55d21fa5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f921d5e77d31763c2a21ca4024279608b5763de7d7d5c4d2938fd822a118a25(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77beb1d9e997b34782828bf47a02da4d825f1986e9c67866319a5aa079a6f75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9fbeabeaf87eeedf587c267aa10583b7e6045193ee83f468170b5f6c71bb51af(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8bc4b24e6101d2532eec12249a70bb0bbe1afef366caff5e4a0b4d6b13f667(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d288f94e390d21bc28bb75b0b838965ebed617e760cd978c09563183b78858d0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57ea7bc92bb59dbdb03916a62616d83d336a07f5aa5d094c5e54d8beab14d6a4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee473ffa0404ece8351b6e70f25a93488cd2da641991ef88518d68d3dd3f5099(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2d728c2b3acec109f50085069274545da8250e680d0c1cc2610b2deb2c11385(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8628b490841557cf81d91b17c1bb1d5b3083de1d34ec0e10fbcc8b102501056c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63def3ca65306746348159ec74b0beb8bfc4f34e31c46110332ce2bc42360213(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5c4f80014fdcdd768e3f79e8db2de75d93a12d1e111c293b3fe24f52aa97c428(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6cfdd3dad06afac783ce793d2b01d991e1ca498c1290f67c607bf2073bbe4807(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71793470e2a168a0c7e80f67a1d28ef55946f22a8a9059ed46d2f3a8c5e15f84(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cc42f7adc51a8877b524455bc048bc4cb7ba6fc98b96403e59aa8beaa2deb479(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__810640f16b35755ec72298a2ae245579fd6ba38c57786734a9d8c34cef5196d7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87c8c08d97d84a026e8362a0a034f29c4a79cf0784e7d4556b025dc877c2019e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c49cb489ab839cfa18fe5074e87fce2c99528f67c6fdc5ed259ce13dd1641f5e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__920e3d9c3431e9c37487ae4d1e565d9ac501eca1b751c7f987252d4ded2d0d92(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d377e1211230620d56d7055008a837b83c0a07664949e4af327d7dc1fed34cd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__19a8dc6ae363280ba4b43e7b0130c234c184184d9edec31451540f3e67fcd0b3(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__558142d4d4806d694a223b0b676742fd78fc746a76f5fbca20d8c55654a8f023(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__607b5a23a2cf8292e9691f36479d5b1070a7e3f7d706efb822c73f523421dc9d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9094b206dec46e2dc432f74538f9b7608ace3e3cba819fc7883c42b45e94b5e(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__07955b51d8d15bf1ceb1cf46418867ea7ad11ee9dc825d42646665f9e24bf307(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__887edde0bf47d571d3c101098ba051c74d8abfe69f96a45b06dfb94577bfa381(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__81d8da9920aef6ec795da45606bbf00c396274ad32c54f54ed34dc87fd4373e8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCodeCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__387ed77a78d9a7c6309d55bacbbc56ab5749d166f5d030d726ef8d46d5b74086(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4641387ebcad24f645496d411c79a4398ff09c09226e161e5d118a4736ea2c8b(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3fdfdf13c4584a75c47436036eaeb06d00feaefd6dc70b6f64d914ada455e7fd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed1c5f477b0a7756ebd39e7b8d95ddfd69bf4ef71f1260c38d6b7e478e43f5b4(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1448a7af694ce932c96f54666c6fec78cb89a54fd90c22dca2f633bb5eeb710f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c42e49c69afca645b929f65e682400c3771ce3fd3445848861083b3012197943(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f72a8ef7ff24f15fbc59f2f60f30bff5e6348164c6d7b3baf3c5e512fce40eb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__12563490863815ae630ef90e8742ab5984143402715e9711c2f18d07b3838b5b(
    *,
    cp_code: typing.Optional[jsii.Number] = None,
    download_domain_name: typing.Optional[builtins.str] = None,
    g2_o_token: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9324cf776487fd944201d6bb154d863cbb99b344968b23f46f90ea2103d6c6b6(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0062b96c9d13033124e660a6d70c0d166679de6f15e931a58ee54408f1f5c57(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8677f54206ff2d20c36ca1533814e7be58ad5489876f0597f76aa96d800bcde6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78cd5a35fbe28671513f02c53cad23ed6d3c12e44f9972e8825a8f9aa1f7abf8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0dea2c22cad6dd2779824264df51d96d6be634a6553c18b775f78cfc1a66f530(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorVisitorPrioritizationWaitingRoomNetStorage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a03483a53502fe506ecdb9ffaf4284778a006b44b42123717bdf8be1d60528d(
    *,
    ab_variant_location: typing.Optional[builtins.str] = None,
    decryption_password1: typing.Optional[builtins.str] = None,
    decryption_password2: typing.Optional[builtins.str] = None,
    decryption_password_id1: typing.Optional[builtins.str] = None,
    decryption_password_id2: typing.Optional[builtins.str] = None,
    enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    miscellaneous_settings_title: typing.Optional[builtins.str] = None,
    pattern_decryption_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    pattern_encryption_title: typing.Optional[builtins.str] = None,
    signature_verification_enable: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    token_signing_title: typing.Optional[builtins.str] = None,
    use_original_as_a: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    verification_key_id1: typing.Optional[builtins.str] = None,
    verification_key_id2: typing.Optional[builtins.str] = None,
    verification_public_key1: typing.Optional[builtins.str] = None,
    verification_public_key2: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__463fff504aa3b9c74b140ada8001f8522fd3ab1ec01c5902be6b7986b7d8c3fe(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2968c5c22acfe7f47d6b4d90a8d8132bf0de424d448372340d7fd1a04d8437a2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__22144b93ab80308fa99e7be9752fb455d3216fa15bcd71638906a4eb284603d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f72e67c9c20d29ea46fba8304a3326c0ed78b50b23c49ac3e03df51b2229e52f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67a806131d11cc77072b8ad767ceb3114847a986dd3141a518b795ff179978af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32b901fc7476112fdc8173b20567b0b47bdc412aba255694f57af607b46b4e2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__414eccb0e81b88e8ba2b56d21a5f8ee6bb6f5db5f496e245174d0cf02e4778e6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05019c95cf0ad5942f34f6ea4ebd6b1f072cee9e498039df73044da6c6d84f87(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6446d184ce02fcf0f0592f1821c6be6b2b5dfff6fa87dab0abbca11d8f54c5a8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__626c4b5bcc404f4411767de1e74b0e585871cf73917a07033e583c7d8fc49f21(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cfc9bb2b14b82fc11086c4dc33961887739aaf7d92bbfdcdac17378e14505768(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4542ebe9c074930b72260eca4e726d06d48ee18b384e1777208407c81691a347(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d66cffce25e60c9c0ce82f808ac0055103391ccd6660cf3beb4fccb3a90640a1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa4f22559f67a6d52eb976aef318bbf2cf094febd9d2ae88d79bc9af2d576250(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__490d566527be68d51c8192426f4ec34f7c02626ccb87ab2379936e2912aecdbe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2655c424d914b3d677ab2ea6cb4ef9529e87b18c55f4cb90da9283168b27252(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__94ab60e0e24b33485c7944fa401f36314a60283e195c7c8b59c256014af11b27(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__180901bf65b061e36dc5adebcc51b55fb5be2b0551f4f6ea5791e4740a02197e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__988f076dc860e3047bc186879f7763b0a9fa68a4b2da4fb73fb3ecd4166c0164(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__581dd51ced9c88514e4a84b9c017a689733d66f3be2d6e838c80c4072be5fe5c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d86ba62545f6ce4495fb7205e8af4a42ac90051d5734ea03f57e3c2260d4df16(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWatermarking],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9865256312a59f84c24c2a1b788e61ade03f90bf585ecf16ed7802882a6ed41e(
    *,
    firewall_configuration: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration, typing.Dict[builtins.str, typing.Any]]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6661fb572c91f629da7e573df3f64ca50004a937ac31bd628e4a6e3afeef7098(
    *,
    config_id: typing.Optional[jsii.Number] = None,
    file_name: typing.Optional[builtins.str] = None,
    production_status: typing.Optional[builtins.str] = None,
    production_version: typing.Optional[jsii.Number] = None,
    staging_status: typing.Optional[builtins.str] = None,
    staging_version: typing.Optional[jsii.Number] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__103b085d171185bef0556f878cd7bdd1b112d7d5044942812d667862e55b1a91(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b6d6da236d97ee41006ddfdf467a34aa8a8c2593d2df112b8ade2be39327be14(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad7f697de0dba5767a7304300f8bd471eecaeb8a94f499c737a29e321b8e562d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cc9f6d3114d8d32bf667a2b2f1b6626c5483e864497936355ee1034681af908(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bdba29fb792820fdf6b6e4ac047097e80e6eda90732e36193c4bd8c4457bb41(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c568165fc4c8c8b42eb536c3b6410e0a6f74d309dc0a183b0fd878b64f32265e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32dcb0c9a697266b3abae2a33a479904b012c3fb1835abadf1c776a377ff4ced(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e44ad29165e558fbbf057a7b8d146403edb2854dffbc88106bbdd9562712b57b(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewallFirewallConfiguration],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__74c6ca56eef25bd53419a804ab4c7c1a540189af89618dd0ca863d7bb901a5a3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e98ba9c83a3cb2a73429dd6c49b246846ddf9339e22109b0e3755283dc0ab64(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf4f9818033775199d44748f3dca2d56e6c86789e1ab7da7588c32d93308aaa2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8aac6f101bc9c91cb566e2ae954702d911ab08817d3b4b9e3e58bfd1d2853daf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6cc2deb9ca764e03c7d8379793ea448ed0a669dfd8083e3d64a538b02af96de(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebApplicationFirewall],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d483a73632d55d341e3ff042888917815c86f920f207bb08b286e15e8f48139d(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9cad92f477d0f1d05bdd5ce063290e54793bfa2732976123350d0a94ce3ea7e0(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b774dee5d0aa547842591229888cebb2fe69364c083284ce220b4d6e98139ff4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0439f0e20265fbd8ff6963ccaef4515743df665d9cb92eb8a8210e69661c5c24(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2535d0ee517b0ef617131def027af2e88c28367cc2f174ebaf3fe8c7b7c201cb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f636bd5aa66dd845990bd61aba881e72dbadf480dd2baa571a4ffc41da27b886(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e7443f88f02c5d105e461c98fd79946407caf18060d70e27c011e539c52353dc(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebSockets],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce4bf29dd10cac4f6b947fd220eaa077dc6555f4bdba7073c72d5ba4c678a87(
    *,
    enabled: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__934194c0b64aa72032a27509a7379dcd2f696bfb47bdce044357166128c031af(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25dc1f3410b1b4591290e44425b82dff6801e115d946ab99466ea035536cc05f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__acb9821572e47e434baf0ca3f67b575155e48d00276fae5504fe6023f50224f8(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39990c5faa586b4423c46721ac48e6d8682fbb195da4c1d9993b53ca3d5c336d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cfdee8b0402fe414077c973f4a640f78d1496d2ca7847449586927aa1a6dc0a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d87f994b5183f4d5bee4120b2222dd83cf0e55007c1005c6acdd25c5c9dd1c11(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109BehaviorWebdav],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bde48029c8efb5a283ce37a912bf4776eca5f2e4547a0f98882ed31a2cc780a(
    *,
    advanced_im_match: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch, typing.Dict[builtins.str, typing.Any]]] = None,
    bucket: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket, typing.Dict[builtins.str, typing.Any]]] = None,
    cacheability: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability, typing.Dict[builtins.str, typing.Any]]] = None,
    china_cdn_region: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion, typing.Dict[builtins.str, typing.Any]]] = None,
    client_certificate: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp, typing.Dict[builtins.str, typing.Any]]] = None,
    client_ip_version: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion, typing.Dict[builtins.str, typing.Any]]] = None,
    cloudlets_origin: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin, typing.Dict[builtins.str, typing.Any]]] = None,
    content_delivery_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    content_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType, typing.Dict[builtins.str, typing.Any]]] = None,
    device_characteristic: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_groups: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_auth_scheme: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_is_authenticated: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated, typing.Dict[builtins.str, typing.Any]]] = None,
    ecmd_username: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername, typing.Dict[builtins.str, typing.Any]]] = None,
    edge_workers_failure: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure, typing.Dict[builtins.str, typing.Any]]] = None,
    file_extension: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension, typing.Dict[builtins.str, typing.Any]]] = None,
    filename: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename, typing.Dict[builtins.str, typing.Any]]] = None,
    hostname: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname, typing.Dict[builtins.str, typing.Any]]] = None,
    match_advanced: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced, typing.Dict[builtins.str, typing.Any]]] = None,
    match_cp_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_response_code: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode, typing.Dict[builtins.str, typing.Any]]] = None,
    match_variable: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable, typing.Dict[builtins.str, typing.Any]]] = None,
    metadata_stage: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage, typing.Dict[builtins.str, typing.Any]]] = None,
    origin_timeout: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout, typing.Dict[builtins.str, typing.Any]]] = None,
    path: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath, typing.Dict[builtins.str, typing.Any]]] = None,
    query_string_parameter: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter, typing.Dict[builtins.str, typing.Any]]] = None,
    random: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom, typing.Dict[builtins.str, typing.Any]]] = None,
    recovery_config: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig, typing.Dict[builtins.str, typing.Any]]] = None,
    regular_expression: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression, typing.Dict[builtins.str, typing.Any]]] = None,
    request_cookie: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie, typing.Dict[builtins.str, typing.Any]]] = None,
    request_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    request_method: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod, typing.Dict[builtins.str, typing.Any]]] = None,
    request_protocol: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol, typing.Dict[builtins.str, typing.Any]]] = None,
    request_type: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType, typing.Dict[builtins.str, typing.Any]]] = None,
    response_header: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader, typing.Dict[builtins.str, typing.Any]]] = None,
    server_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    time: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime, typing.Dict[builtins.str, typing.Any]]] = None,
    token_authorization: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization, typing.Dict[builtins.str, typing.Any]]] = None,
    user_agent: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent, typing.Dict[builtins.str, typing.Any]]] = None,
    user_location: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation, typing.Dict[builtins.str, typing.Any]]] = None,
    user_network: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork, typing.Dict[builtins.str, typing.Any]]] = None,
    variable_error: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError, typing.Dict[builtins.str, typing.Any]]] = None,
    virtual_waiting_room_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest, typing.Dict[builtins.str, typing.Any]]] = None,
    visitor_prioritization_request: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9252ac1c14ac359198bd07c7d1355770f6e36e80818ad00b42f2f00aa31e01c6(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__23e7b509349e9aa91b6e0c4872875fee908b05e264c2eff1b715a7d042a904c9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7031a3f6a65dc8d564686be6b569cb232adb4180807c093a479a81a0d97b10d7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69ca5fdb1c56496ff1014a1dade7b28403343780db2a5cbecb44f7b43a3fff99(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5295265b7bd2c80b158e2c84cb102100b7081794b93389829034e0a01f31acd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3f3d0f01c2d93e751938ea591bf95ff7e1655aaac4e6559eb4efb79bfc890c76(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__440c2186e20d0e911efb5309630aea896dcfd44ae668d8bb7d071791014a1160(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9e2ddc089a7e8ef8549b2d8c35afc0e301249dc6644a22b99ae6e0f8eaafd0d9(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionAdvancedImMatch],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9463c8b57c4aa4fe260b9d3e94427009e2561578048a32a215eeca89874ce51e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    percentage: typing.Optional[jsii.Number] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d92598fe3548c1091621fc0b6702f92a841ca8b8a1df4ebdea41d89e383f58(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__53091059ce6b698d7462a22df0ddb73d34b283a4a1c088eb5e7b57300ad9bc55(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87ae1aa9a8a79dc8243348d49005da6767214fdab1b0e146cade127861305646(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__27386074b0bcccaf104da5d7461aba21801789bf45f4cb81ff185d2e808df826(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab7e5f0b138198f782847071b555032896af80878926e40097b4fa94a77fd992(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2094ce02fed5b6cb1b7e86dfbd659e026c1e903b488e40a03e4a2bc6147ae94a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionBucket],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2c713882c20597c4fb92ceb3e69bc7101e15755b19b86678139473354d8ae7c8(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3b76c973f9506ec344babd656c4439e22713b9c9eeed3b3e05bcba6f723921d5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__749c13bb25e16a6ad68c40375b34f6f8630e53de522d4aab413ffd6bfb9a26a6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7d29817503549c9598516e74c1a657e68f8eb2a6ce33ecadabc4c81fab3a83aa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6e9d73bd022b7a0a11a0a28469791412e006af0bb2a24c2625e77885383352c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__29f25da768a5ee38372377df760fafb0648014741b8b910f42389b7c5e92c13b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d1683ee75ffd3f9f08caf2f80898f183275fcf6d79f25943c985f51ddb22d56(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dc0e20e46c95904f5723c31a47a595adb27cdc0d6172be914fe1559d0801519(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCacheability],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__035bc3e495da6f6f51e9b168dbd56162bee4dd978ae64dfbbbb8a14ec29f0226(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5b018edc1af1c99cfbd0842f13f51b5889667954ad9ade359334afc6c249e7f2(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a8b7610b917e9bed46d745fad6d0e127fb92e19a912983ba07cf6e4d782e2c89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5bdcf61a7e25ab1be5beb81390d889e3e1cc76d0166d6f52e75614b67e5b4dd3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca1489fd58e616026b482a5b9365829c25a088547ba315a8b9ef399df181fd8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__01b565e6dacdde29e6d292d5efcd335c3e0efb188acd71bb69d791716316b72d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da378f1e36ae0c51c5764ca1426c2d099587bfaae0941911dc70b78a979e6279(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionChinaCdnRegion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__706f56c47fddc01fc8a64fc501a62d11fc7f038dcaa2b2d0fd29a82890f2d534(
    *,
    enforce_mtls: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_present: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    is_certificate_valid: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3015825b3ef8df852b765e9e940592697f79ff900abb474273e670d809a6418(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bdc04376d428cf6f6785c8e592b03d2f5923ba9c8e5e8bf8ff8412e96ee88b6e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9202541e017ab45d370956f6d8c5161874aacb9814863e068ecb8ba1885f625a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6379b8897cf8566230a44ee2d9bbae553ddd4c0d2ce730ba855ac44766315ec2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4c1afcd2975759220c01f0d5fc8181c4df215aee34956f385dee9177245ba11(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca0b246f27becb0d173d4b16ef85141eb5eb97d11563363c1274dfcfecc6da45(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4d02a03c24d17b79bd59e3a06a58f44a20501eff9028601c41d35bc39944526f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feec29facfdaad8fe9424fac96519ced89d5fcf9b912525dd95a911d23349469(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientCertificate],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eec00cb2affa72070e12870b59ab18452be9c98cd5fa8b81b7d5f5816a88a75e(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_headers: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0ee465ffaea7435f4f9e2dfb042bbaee3fe4e3e2db6dce97a6e1e047e6a0651(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5abbceacf480297eed04289d2c2827bbde5dcdd72583f5ff7b2f71588eaf8070(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a21d35046404e17d9627cda034c013090c95669093e68bacce7766ae439c6230(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df4b9cba95bba5c189a70124fe6491f46d8fb8ec7d52234fa4d5d7b751411b0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ea79b68c85288072de8fd55e9e8f63272d1ab93c8c8c516feb6196c43f89986d(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f1fd5b3aeb342c7e90191be676731beab3d710f4ff96523d7f0a07ef64f71fdb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aac24541716f4b29bbe633f6492e005ad683d42a07dc975373b55f629d92d33e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5a41d18a333a7d0a0d6b923da436d0059cdc5eb486a1496ac8cbb410950bab6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIp],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd6918c53312af58b774d4355e344a85b92a3cea95f7609ed6341ad4a81082c6(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_x_forwarded_for: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__361437516a63bc5d4b3f512efe1801734f1bd9d336d7f72ba67b3641b6221721(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a045c309a0f70c086234b1ae993c6b2cbd2c157e5ba351ec594a3ab7f2a8db7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d67f6f6b0c05a7b6850dbdffc5805e4f91ca6f6c25967a915c4d89c6e2f90332(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__57b740a42cf2352100cd7c813998362bc57c40447da5fcd3fab911d7011f1bdc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0e331a95e43483c72dd869fd79d841d5c605cbf060613e5c705d3d4f009236e1(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8f8eaa134d0945aecbcaf71a2f1610dc2b09061000c33f3b1dbee01405b59606(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1e1aee421cea361c5907d4ec6966b85186439459d0e359383074b826530b5b69(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionClientIpVersion],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5629b1c630a26d1f44e6367dde7716b1df754ebac9254eaf3b0ed156cca2e8f3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    origin_id: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bebeed73ddecdd771885b09654812cec7009ffed59f3719272dd209cade3afff(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__31b08671bf593bcea03e8435fa2ad8764aac1a9f1e34161e3d959049abc873f0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aa6a3da7403e6b01dfc8dc22d9d74a74a2b01fde7c00e0471df70479dbef7c08(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71abb130f2f1a7e35db2680774cd2025a43fd8aa62064e84665632afd703024c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8e13312f4c4e5af28130003ed349ddcdf241295ce1bf2182681fdd46a5628e23(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87db10858e4b554a2524d8565da43600179f9892f599d5d771491f091b07932a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionCloudletsOrigin],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__16e08b294641b2fab10c2e62cafb81a92aa8e39ceac324e128dc859963481cd7(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5569ba7fb971e192cf87f4b8fe0609a59b62e7de245414d2c63018935802931d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d9711a685e48a0461a013640708abfdfed594098e899312118accf2cc939fdcd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2f3d0436dbcda54bf78d1558425fc350c75fac53f3c787756826133235ac4df9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a6869e6c69d76b6140e5ab8249682a6e7d8a7b825148ddd4d2a0ca5ea6942e5d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5b089176a0cce5b1aa87cb40bdd489e66fe5430f8215dce5655cb8361a54b1d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4e0878fecc9c954df202115b302af78f680f5e5cb97b73455d9757c01f34bd28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2e4060292019eb4c3aca5d30b72cdd4326395c58ae5638a4a8623582672f38f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentDeliveryNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a9a3585f0522f062eafb4360b2f66c3dcf6c1ee870039de17d01fbaed645d5e8(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__feee33c702f194a5a9e4d07fe6fa7f60722b1ca0c4ea3a67fef8c21c01137d13(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd59f5700c4a5ada5fd77c7124710e48f83a2dbd25ca696cabe404fcedc97f4(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f7b6848baefac66cce1977326ee042e123dcdc4cd1ca388658ebf1a2bb9409a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1af1f404776715d55218ac2a7f128314400985c839bb99014d8c117eae49bfa(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__208c8af487ab71ae1d0d33fa93fbc130f4b9f070d298dd494ae953882b7b9110(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5e03c8726d23f3b5b14a9c680798da42ec6bb8ce1f8395ef0f8df7c1e5626749(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b23f0bd53e5ebd8bd658f4cc823e4e3a6dacdc67b5375d2667bccc8cc438fb78(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab83b6c4c8d851be935b4838880c2a5c1e34622dcfff8dc0d776dc8556e88f62(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fed06ac5c830b2b9914cb03d8146740db25b73d2571abdd687da1f5bb50706a1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionContentType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__96993abbefeb91b7fd72e9299276e1a615803a1338532810e8e15e92e56024bb(
    *,
    boolean_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    characteristic: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    numeric_match_operator: typing.Optional[builtins.str] = None,
    numeric_value: typing.Optional[jsii.Number] = None,
    string_match_operator: typing.Optional[builtins.str] = None,
    string_value: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    version_match_operator: typing.Optional[builtins.str] = None,
    version_value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2aa2ebac18aa0e8c09c959990f76d3ee9bcdee2da0bce3d983e8b9d2456a375(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2a238d724f74bb3ebfb93765cb004464b13de7b81227c470758bf4684f5ff16c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71226ec80afa8846ac0502ba67031216ef5d1db8aad10576376d1d3e210f64cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__41f1879ed915f5e5cbf27a9bf97e78f2e6332961a041dc8a4f8fd54bdd8beebe(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__af7c7a4e5acda2061f04e3c0e85122e36520d6e4b03bd41c1293b87ef3a93c3a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7520194748f7b0d99948e6879a09691c7b94468405383e00bcc12fc57ae58871(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e7efa3485e08e6887366042e3d101c3c84220b1cdb930be23251981d66a4a31(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bf5a903afe2dac2754362c8daafd143120935191dd708c0ed9e5b652662d7b08(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6fea624584ee402e65e9620e566b0ff76c9d41166afdf7f65fe21eab454c9c7e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b0314d37286a3d6022880e1dbe99a2bd44d9811f5bbebfb060c87a7d406f47f6(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__700ddfd88eb48d53c7bf8cff28e925240bf58980e7f98bf46a429f9344b285ac(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95d0ba18181a484bdcdec9e32eac60b7b4caf4dd3e6021e4b423c75e3f308bcf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff197ab90e12b169ad4a24f63777f9758ef156ccad231879191cff1e31c6155b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__df1bb585ef81a79d76b4a349e3520dc3819debb8a62095f099424a1a836f9e8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4df0e5b3726f2c0a092fb02ae388821e2da7c6c0f3ccd609f0e8d31263dc0e49(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionDeviceCharacteristic],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7837fcd40be05cb7f6ebcbe83404d4533dcddeb9a403f347ac766b26fceaa7ac(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e633ccfd5c8a0fb1c1786a71d579e55a0080a667451aeb81dd6b0bb32247a429(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2834a8a9551c777ab82821d97e8d32e290ab9a189364e4e0124e7574a2fc051e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7dd73969628f0a8e6bc2b73c1e47292ef0cf150e2282c29768ea0b49b551aa57(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6c1cc3f4da38b1d7a95580b6917dd359b6526317d360f18811ffe6ab4bbc227b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4dfebf9063349cb961918b57e3bb3900fc7ff893fde21630fbb8cc5341ed380d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed28b23601b39eea14bfa79e95836ddac0a27655221764074060ed2f1034aa39(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55dcb4a476dfae845ef36f335e448199ae2ca65bd90a3937f764d2ec959769d5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthGroups],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a77b70a609e50e1ae7243220e7217ae604d5bfe7af2156ccdd46b2af28c0ce35(
    *,
    auth_scheme: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91f5a076326eafcf713acf9876464305e2b4d855d7725401d752caea4f5fa07e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a54b5919adbd78e2f294106573fef5cce3b9a934d3f5b1d7abc775cfe08f7a3b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0fb32802e6607a5d59eda315d6e6021936430f21e1fdccc802ec6353bbe432b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8082cd1271c40a18ff93901a35304d422f1591a9c86bae2b036c3b19db152e18(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__962d1c0c71237304dcd209fa2532aedeacb3082b488d8523bc584a24ce0b0360(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0ba2bc784d6b9309f082678020c6e9097265deecc53ce3550e2982fb9271be5c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdAuthScheme],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b78390cf1ec683bcd7e9d3b32ae61574aee6bfa0b1ca15185fb7a8e20398205c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__604cf6014e4252db350c878e25bc774adfebaef4b06cfdc79b474ebec6c71100(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__861ab2d7d238aecf8b57b8f2b1646e910a65bef4e199ddb4c14b870fa3737f79(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__078649a8fbdd196980d816c86e36c5f76d194a4338f2bdb07b7b917a3e23473c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__421c1a32ceb3fb7e7d1e327ee087ee4e4e2c876e56d283b18d8d0be15ac22641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d73633dd4edfc3bbc8ccee644623a06578d9d319bf93b5071f9deb8eb1a53e5f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aea046ac607903251360a7148c52b95291fed43e5756bc446989d907d7408f87(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdIsAuthenticated],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c9b818e796b190dc2573bd6fd2154b56caa6ad620fdd553d8fb8546d900ceee1(
    *,
    length: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__08a9c27aacf8c5ae2724cbf2a9629d1d721454fb84017c4714ac698c423b0f4c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8a003960615964a69b6cacf3fde0e8fbd29edb246069cedb87f00dc09597e394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e8ab97ca7fcf317392e992b1066ce9b0569a632fc1f0d388fe30cc4a641745f5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__422c73758c88c7fc6da66431ea6b0eb8b22a15550bb1baedd7103af54b94f63b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d54fe9ff3568a5bc16dc12638c5c6969a140f84647fa089d26cdb6f7efc1b6c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dcdf8c97941179ac4da58146970b2c9e08a493d5460e2c5eb0abcdb4a2d5b68(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5d7e621979396188ccdcc194e39ff05df67c676e309be3f857f39cad9d98ac0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__973e0206f68674fc3a3dc849b29cc4de7087639cbe9baa3c72e264f1b1f806b7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEcmdUsername],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__98048e3960cc9a1a1ef5551ff53c4788eaf482bac1c192eb7327c6125f04848c(
    *,
    exec_status: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__034aa5d429a8e1c5cea759921097e45c8ba7210fd3d60a40456554a46ef5f49d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71cf88df8a588b8bd0428d37f48316b046f00b6eaf6e8643438ff8e540449df7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__714b25ace7f5b61a170921b9fa230e9db87ba06cfd4d53a6a910b0779dd9f81c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13493f771088f0abafaea36bb8b8c4400e5abc45ec6713053faf96046c8cc7e6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e997e3b027bd4486ae4c1d21ffe78ae5175d7d2d16f7ca928c5ce18673ead273(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1396b2cb05a89acbef69fca687426b2e2bce61e9863105e93d71d1d7747cf0c3(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionEdgeWorkersFailure],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d4ec59165a97e015d79f2f32b4262e3f37229c70e8002c3cd7bf2eca0690d325(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8fb03876612997d2cdf4f134d561b34174f948a79329910c4b5bdcdbfa4e8cb9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3cecbde89a433371134552a5f2119b042d2fb88aa15b41bcd00d77200fcf852(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__832231906d703f79b4774bfcb2382b9ca1033f663f966390568488cb11d32952(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c5632f3aef4b5aea03a5b7385d18e4cc9b6da7cf2f576246f59b47f138f8b74a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f488315d14364cd6ff8e22aa4034f00e71571543262689f9e476e3a6bd8a90b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6678ed97203e13c2ded419cb071437f33b61586f2bc9e929c44aad54452e95ec(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__99e4161a7fcfd421d662c7698508ef5eee3e3718d5bac07a3ab688a50250df8e(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__382534295f8bfb4fd3e416280905d700b5005ff527bb65ebf201307671395c85(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFileExtension],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2acf3bfd3326fd89bc95bd24a656e7ac44ecf7f273ca3f149c6637bbe6b38b2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__77a51244ba2efb8c4771d86c2db26302d8c25fd5f3edaa49781e50521e6d8c66(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d8e125cebdab888b52eb230d573bf077ad7dfc4f8ac62bb6df2dbe710b3ba3f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__78e04eed75c315f1d02a67da87c209f8a48c4bebe4c01c4ba8ccf59a5ca15fa0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__019eda56dde8c7ca1e62f2799317955c9b5c26fabd4fe9406ca8b320d88756e8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6f69079a875653e45a0b75429a8454b6cf089bec6b38c0f7c3da9cd1797faa75(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b2137331601afa5de2e228736c610d89cddebabe4bdfd8d41d594169af55611f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d3d9d1a954556aa80a9c36b0573171ff13d9044ba762f3f48214631f2ec2e3b5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__885158b100a71cdddc5af8263cd4dfcce679ff643df591558d5e73ec435ab6a5(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionFilename],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e77630b9a302f1e6d6cd6593b62639f0f62fa5a14e935ba383b5efd024d3a809(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35b295c2560cc04f68f8d2771b910b6a70405e96a26eadc8c9fa557a4762aed9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__58e80fe6f61b1a545aebda8ace747d5c45a3f2b240147da0befe630359947295(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd48c683b73e8faad00a8dc12e20119a494e7412c590bc1284374b7c6d6d4b0e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1ecc6278d8e4db10bf8e92d4792cf32856e45e0d8b6b7423850d8d29b5993fde(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f768cf815ea2d07ca8c19c08100f0e920320ada42bb2854d2f31b57900eedbc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cb4492eb3d3cf5a0e7f29cf309c4c2b3094104180f6bbaff0a7394c6c131acdd(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c6cc08e8d9985e4997f732636082f55734698e9b098a0bb8f22a01dc39c0dafe(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionHostname],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10403448a20bfe0ede9d79f3a443cb43bb7c96cdc3ef3b42f130cafdc188a7b(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17d645f9435d39aa5ce482d44b4702ef3b868a335bf60e5a6200659eebc0919f(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e0c60d9ea086c437c8710e044e13648fccaaffd40d87d956e4d0187f23dc7e51(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ca936b3b607a0f9f5b6e0b5c1de9439dd943036e46cda2b605ee9115e5d66370(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a2370743c73134165bc34c40dfbc686bf7be06b02b285b35e33ba7cc4736832c(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d041f4af8f90430f1480151f32024e08295218f5e12b1af623602888fc346883(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fff9939745b7365aeaefa2e243e89aa8af4b7a0184425b61cae978981cdda339(
    *,
    close_xml: typing.Optional[builtins.str] = None,
    description: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    open_xml: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39ab5a18fcb5d28aca18c717f695e75a023f38bf7e040118efee144c52c677a5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13fcbebd39f711d061e2b814de56be922b42b4fe5fda692e01e97901cc14ed9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eacfc963f73e4227e4f64fcfa92a524fb65562f7cd5293150217c38d7a16154c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c656e807e371540ee30d05715c2e27d9e5b72a4eb1d4cf99ae1697a5310c76e7(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6b056af4575ab0ede36cf66b69eeb5a74e14d7abb8723fa8d6451555702bc4d9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d460cbc014390d30d5984125dfdf515926e55373a5760e010ee7e29d41507953(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b7248bb6ee3f96cd4e04f8342deb2bc2f18e6bc0b269cbd9ae44afbdd2ebaa4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f13d5cdaff42341ce7cddff2bd586362d9061dce052c5c529cdcc3574f46c7f1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchAdvanced],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__84e3af6ddaa9babf679203012654ee1fd71604de3a3e20242ac7f3460da4a1e2(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue, typing.Dict[builtins.str, typing.Any]]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6490c5bef368565e6bf065dbcd9806bfc36b36d76e8be8214d15b754e3859db3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__213a9138796cfce1d95b4ee6d712d743f1b9a2a512fafde714b73bf6543b2fb0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2e91154bf8817e05b9e49d542d398c18cada56060633e0ee0c25e4098097df00(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c7d913c36756313371cae0663901498d423352a11333fa4c51dab73e5a9b0af(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a95b183b8d1f90959e6f1b4b64b535903577977c5d2f59048a3b6875a46491fb(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c10d4140619a2e27dac80fc1af94a12a4c8e3c7ca09e1eb192de93d1490c9d92(
    *,
    cp_code_limits: typing.Optional[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits, typing.Dict[builtins.str, typing.Any]]] = None,
    created_date: typing.Optional[jsii.Number] = None,
    description: typing.Optional[builtins.str] = None,
    id: typing.Optional[jsii.Number] = None,
    name: typing.Optional[builtins.str] = None,
    products: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c66321f4f138149a1d6449da45ae2d4e1e1570a52352620fb669e11a72d13bd(
    *,
    current_capacity: typing.Optional[jsii.Number] = None,
    limit: typing.Optional[jsii.Number] = None,
    limit_type: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603eb9444ad7428b9b30134a1f0d3019223c8abf5f99075b2a8d733243065c55(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__62d0ca2c3184a4810bed9d7b50521d3a823ac7e09335f6efcd9786ebb223e5dc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__952505dc62aaa829e9c58120af089aa32b81ebca8a522f6dcc3be1159cefe4ed(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d8662a6a050e548c2ba96f0ebc2a5d669d2d4212cb28da4cce2a6da1d510ee4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__69e861e450573d784a6fd5f74123bd15c8a490ee6120c38e2b8c6d98c6f897f1(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValueCpCodeLimits],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2852d755a184b0411541742ace08a8591a166f5160a1faf3028b634332e29dd9(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7ee134ed4638afd182f7d37b9791685d26f41880b4622fae033284f7b36f8e55(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d78b571f593c848c94ba32b33191d3db4fef4f91a2d4afec6bd51a929fa32ff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__216b30c407648fff704196b21b74802325c822d7eb3071cf75ef522f166db66c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a7d6987be12e0b3a6f168a0a8af2368678505d098fb219653e02ac3aeb0dd4c9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb36dca7e1e7cc7cf1570a9762eaad74c83a9edc263795914afdbc48d54a137f(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__32bb142def577f2b9b3394e8ac2af57923c1dfb523d615fbc5a29c67c7d99e55(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchCpCodeValue],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d50003084d87276ff7a0183fc08ab7db69307f733a8b01f19e5e35f97ff8dd33(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1f90d03cd35142462803de548516dff0c9380bd6b546137287e88ef2e53fc276(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d01c6e3dc993f47a2aabd17c9dc28fdf4bfb58aae426d051803ed1389698a705(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dac3967c757d8235e5d7b522b2fc1179f2c50dd5104548b839d53e78c3e0ed8d(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9eaac4f17f0645929dcec0cd9d31736e4d992c543b7b76b18245773ebbf61572(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d39db28a31e6639d97ae8f9d3f744ab27cff2a77c5455e991f6f98f81d375ce(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__028c95e6bc846444c19239238859ffe760bdb157937d1d9adc6e2fa374288277(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__02f0013ea8d21dc3a6c520992661dd2723f94f8ec94c1bfbbaa6b626f8bceabb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bb6d7fc20b055113b60db4e0adcbdd7b87996371013867674eb18c33969fd4df(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9ab1bfdf1a32e3f525e483cd1c3a919c893a5522fc19ccc10f31a7ed5a072018(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchResponseCode],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10c8d229db9313e1628f6c096fb623db7371ae9e303af825ffa655a647c9aa8b(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[builtins.str] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_expression: typing.Optional[builtins.str] = None,
    variable_name: typing.Optional[builtins.str] = None,
    variable_values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ad4713831eee03a2d9588e2d4e219f02630d2e5391e54974c39b4c88edb0a28(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70be376db103dfbf54f69e2ccea31145ab2fedd34ec6acd902a479c69a9f6e90(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9efede69e1e440b520caca95b61491e41336e4b5787f13796d2161eb73e2b796(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14fa37ffdbf5df19117734be7eb73dacc66627b0725868bf4fc95de63925536(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f7164a24b79266f50035eb75a26c9b08ccf1b893547f9a98706a589c59bb351(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3853fe7cdfdb31382f5e8b68f33f33a68d1334e4f4b6264fead89256cf17982a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e2a2f3ca82f2ec39cba4b5c57b57bec39bb0a6516cdc49afa189d0435c09f372(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8b497fa07bba24845096b05e6a52bca0f46f8f35af99fcb89ec3ea2ba7023e44(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5368e9c48c646ece15323801567715fe105b2f29d9fe248fca3239300d8ec170(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce627499e3b0b284f18d59233c13c576814e5471e6a38602a38415bbbccbce04(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d622bf616eefcc549273930189ec65b584b9015d9b969f413c7858ef49923f5a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1921455dbc7104a14be3a87cc165dd632bbb849d435fb778824054792e94842b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__863857984948eab4b1e6a844ce100d96c165d0a9e3e1fd34cc08923707f41644(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMatchVariable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee40254551d115bf094c1c4c8afd64172ea1aced9a6f6bf1c8032c801a3c8559(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9becc9f907d7c63f914b6906ad2f4941efe73fbebd29cab22f238dc20ec68ea(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4bbeff472c874b30074e355458ba5f2c214b6d378533960cf2778ff3775a955(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f9e87e54de69c042726bfbac61619908be6a81c122ade63abbf113fadd30a589(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__91b800252f89528b61d9e108cd3d6b75e6cc5abb330c5af98e8cd5ce2e1ac50d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f3c12752b9ea4089038f1bcd79e975bc31a5807d0ae208845b1645e9ffdea46c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4edca54a58586e437f80a3260d2f38dcb8475b66fa488e19a81dc28038220b50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__33decb025e69e730bb34832154976668038bc13cd620a481bfbc6f2f46873da2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionMetadataStage],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7380578bd4a889b6598a960c4467205041934df21aaf8aa3263376258c25d3cf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5576de75343f47da9d4881a905efb3c1ea4c471b51fbbb583aed788c40522153(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__65f6e73182420875735108b6184ba40ac0ab26c6115d9cb8b8d7e90069ea2734(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1431beab0862144c16406b34d1b8d5f6c01999640f0680d6b8d35d4c9e90bd28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5cb6f585389212058e937f4550fac58068614025a3e416209e7d4253f1427f2c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba77557ea119dd1b968706294f35ac01746a73ced90919fd9ffa1413127b3c3e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__89e5aa9203dae8db384d876674b048b304c1b28603d4ef493119311e0f1ed849(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionOriginTimeout],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae94e059263977e3a5efdf551a32572acf98c286780fbdbd4877c3bc89335761(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__37187da11a49b3d295264e7e388f6fd5f126aab4c82dc5e6068cdf2e681f5e53(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Criterion]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__227ab89d16a858d8c6e4cdbdfff516e19ea4137ad5b6c14d7aa2a852ba02b97c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    normalize: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a78a93ceb0f5681a38239e9a174bc7b5ce55c8f6589983340655593b76b2b966(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__72340353d75f00a7a520890274d13451a307f333512f203357a8da4458106205(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0bdf723676c2496470d5cb14b1a99884dcec604fc7418a682650fe65a5afb4af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e03ae4c43d44d4269cc8f69de4fe8d7dce8f76c6f738a1e36a69e555a937fcff(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ffbfcf43ba15978f29df9e2b73434e82eb0ef8b58f985845335f13511ab35a22(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3de3b66c59230e4d53e811987f31a106ab4aa820f7d8ec9883cf327174dae7fb(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__339b8fd723b984fed83fe09d040f80cf4743e0b703b3b2fff23385c21d0732dd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__870ef1d74def58700afa1d03e5adb28596b481e56d8eb2b69bd229a8d5964e05(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e73d7e05ea35002484cbd9ba2f7d16a91d5dd470a4ee840b83984fc992e83c7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionPath],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2ce566b9089df2918187bb250d57c219a71e46fbb2c683348d858eaac0233480(
    *,
    escape_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    parameter_name: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d2881598c9cef1e080498fc30ec9766e79e42dfb7898dbbf8f93376ef12d2d78(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__67eefa6a0867b2ab2ead0398931b10aaba15db989f5735d81fb3c407eba57b10(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3eda5683cef963a0cc7616e14c71d2212b6edcd64d712eaebe9b0370729b4588(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__db7b6fd3c640169982711364f116d9db560ff8f7cbdfdecd30fe2f5a785cc8dc(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59874b6837011dd95f58e0595825dc617ffd8a6db9d36a83eeffd6732a829e75(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7efa81813ce731d3d3422cd6e2196af0404acda1c43e3c9836f96472e2bd0349(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c7d6c184017a67301af3f98a71261272b7a2113a1d953e56cc894425c2296dd5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__374f9a4422fcf4766e6896ea159c52c80554727f69ef90706f4cd8893f556239(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63818807ebc7e76d9c2894f4dcba38bdf4103293ac447a2b50fb32b603f0f5af(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2bbcfd4b427f2276e928bb2926bae5977c05220ea4a4d6afc322841d8323c1da(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__95f0c9470dc175d741c015db5106dcba38730f6904fbc999222eef87aafff3b5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd8f859116c4aa9e1c34027b9ed1d21114a8f5e8bd744c73a1822bfbc9346d77(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6d3019ee6c066b80cc05b24344eae09c5fb458339940400d751776db9b9a3394(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__66677c0818f8d84bbbbcd5b20a4eb8b4d79c7b381ad9b0eb39b551d0fd5835d5(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0370204efc79552cc079da5ec140573f297b8735f9621880e17b275be80218d6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionQueryStringParameter],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__788e4f8fcefdb43b6a1c2896a441cc085335e9e16cdb89cb1b1543c49f403e32(
    *,
    bucket: typing.Optional[jsii.Number] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ccefa64383587f62cb8d647aa80ae8a6372954543a3bfaf274eee4042afff422(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__133e7a5bac654f5e49174d6c8aba2657fee631905c0774917edb1c0ae516e3df(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__791e8d01da3f3e529d6a4682e3e1f405912a14ae7a2a723affdfa4944a406d0f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__82b8f00d363fb1e70c176d726e5380cca2e3a1558a9d8ee570f24dd3cc838929(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__186c7f5ff16800d523f8e4ae72c4d9247bf4984bb90520177e55c05b5c43093a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__05b08b747bffc3473d9d69a6aea18454189bf18dedcfbac81e5336a7fcdaadba(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRandom],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c6fe3c7cf2b06edf4ba2cd413a3bec3f415ed586ff1c1e53c120e7283af544f(
    *,
    config_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc8b175ff36baca60153b541cdb9fc305c29f369084b0a86b0a79b7b7bf36cda(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__471a9b3a4a38333d987f9ddd30bf5bcc73ada24b33f590335885dc520d90da8e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__70e35ace0243c492c9ab79593e6a0e52c9809e321a1dffc08dd0205f5033654f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5d5e4bc251ae6a81cdd39bd1920b55eb1c7bd5cfcaac66eb9702a0163aebc601(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c89e7efb7273cda3ad94694e13fac873df26a6e45dbccb46abf651edc883216(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c43f94c61fc8fee8840069f3a69f725742d61afb69ec0ebceb8950c2f5d239c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRecoveryConfig],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20a4509b8d217e7203e77c4402a3168fe70f830ff57b5acf328128a169a6ba97(
    *,
    case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_string: typing.Optional[builtins.str] = None,
    regex: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b83c6d9a8f490bfc4b4d42c6058e93e80494b283e35b5685077afc93647a4ff1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c7170927714c3c0c28709effd695aaf44d7923b8051a1a51566d9f82532fafb(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ae75c5cd8bf62a112fc8db99d99abe2c293942d1f5e48ca4516989fcfec3c376(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a648c781ce43078373edfcb5bf080282c1f1e2a687f5a474dca1992cc68c3d01(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eeb95030849af3443eedf4bd7c19401e6293b8e19e10b21720568aa39bea064f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9bd5a58b7e7de36cf7a9192a4367b00cf74f8cbe97a49e9701fad931e83b4024(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d0909fbe2d7e6c2f95e12dcf6db1473f1d283052e5d952db4b5608dafb67140(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e6c58cf26b9a6291d1b4a9a2125a38092cf41d2ad4cec00cb3031230a2636515(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRegularExpression],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0f030d5dbbfa678c92071a48071f278bd680ef63b105bd0b50ccea011bed550(
    *,
    cookie_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d6779d0adc109dade38be138b8142a37c4532ed5cf79433d27ca758fe1ac02f1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ad1b99d7c0077020c7c2b8496da2d1be8087ca65e3de952d7cdcad8c9dc40270(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a80d34ad602ae75221d700e79903b080a60df7a39cd2f89e484165360edd157a(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a0bc164426516d7ea46efa0e7aaa7e99e7d6577a9db99ad7bd73a5f7e86cc452(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4eb134acf9f01938e8a1bcb0dd1686aae115662c62d441b3a71d34a2c143edcc(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1579a6d59695941c7632ede348539c7a35e9db91a331c290ab0a91d82d2f1d9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__014567db57c2e76180ef7616972ed6c922e0d77bc200d397f45d774b15a5b792(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03be9156ce0d253211a2d7559b92c685f7559c11fece09e22c440a9d001031b9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__38adbd57ad309c5e5c13c8be5cccc74fb651e3666bfcc1b56483fd3cdb1af8b6(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__47848bcb81e15bf2dc13809c4cbbc2991db2e051df5bee5c679b51fe80d45967(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b5f1e7c50eeae09fb380404ba35688a93f3430e08129dcc91fadd6dd673dd0a1(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f1a68159081477441155ba25c3387a57818e579eb59c69f27663a8621ebd61(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__397093a859e8b8fecdda0a2aede186e0a4b1b9c34b8d16e7a7a46c096c8c8ab5(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d5a280331e68366a4d214bbf6816194baec9fa7ba18b8694565bf924358b82a8(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestCookie],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a3a7b6dedaec985a82ea52a76de7345a18072d7ee2e8bf47ab2ffb28d8bcb420(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aec7bf27dc29757d63676f8a6699b95bb53275d5c48e8812c33bb727354e40b3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21bd66bb884009aa0ab135cc4bf698750667bfc23dc6eeb1b25c6f0aab3aebef(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__da27a862cfd37d565f073a98f409f266dabb758129c90a37a1ab645f972172cd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__43ecb5cdbd509be7dbfbe04322cbee012b4e3575cd936a48c1380c6f3dae3997(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__589b97364483ef38005229cc2dfebc01a80f2398d62af2797a73bbfa38e45816(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1341ed7d5cedbe80429eb4b5fbc9f458ed0d3f3c909b2bc2fa51236dd350394c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__613506e25d7a006d8208a2480e42623b354d1655129c352b9e5b620b630e827c(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1334d672e04b0d2a14dff89a48b3864ac881aa75b67b20ccb575dc4683ca0abd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03f9ea8cbd18ea84fdd3132fa8f5372b48a3c2719f7c5ac7cd7536b2141510b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7af2e96feffb20065913a308990fc388d058308238b20d224781118f10b2cfc1(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__36b17e3642b906764c8f5650e451f32e826f87fa471eceab35629a4d967269a2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__695317ba2b80f749dea23447a19355a20ebeb8e51e7cf792263ad12c471ec075(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ba54d43a854dcafd58c886e8dd6fcb299a3d1e4bae10b7847b8bf80b836ae395(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f5ad4ce9ed47c98de353f0c663f3afad6d2d76cc52c40f606f8202c2994767f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4fab0c52c2a7cb5f72122a9e3b177d1e73b1012a346e2e8c78aaf7d72f1a046a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6549ed6710bcb7d2840efab7d406fa86ddfdf3ded77289d32b30b1e96ef78628(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d8a97443e63f8616c6f885daa4f09feaf4a7b04fc924149ce707cd5349a7cb6a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d863e42e44bdb6136c45c24136ce321575a00eca6cbc6a737468e51376a319d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__adcca86ff0c7a621f1faceca5a5fca7379af20c5563bffa250f8332f5f63b3fd(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestMethod],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__365339a0fc2c05fa5dd27ae8cb80abe9b2de8b4ad10b4b54239e7abe4abc8b4c(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f14b8037e10507e694343f1420e9eed1f496cfde573cd8a4941c0b283d243788(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c1ea917581b92355889cc47ae7ad0edbb2ac1d410a9e21f7abfe5a875fa90ba5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b85ecbc704a466c89499b450c113cca8693904f2c52b1d1f6dec9d214890536c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a5c5912310f153985aa3c271ab24df84f41a81d6726b0d0b45848beac2028754(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__71bdbf349095e372fa859a62aa9a3b48383a59904c17f6b416e76464aeb3c63d(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d39ee647aea3bd9756fa7ea7e577b74b834dec2da943236a2aaffdbfef7633e2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestProtocol],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3a9221156f46ce1318c9425ffc31ceb448cc19a5890dfa594de08a2dbbdf9001(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    value: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4c2cc2389ca5712788a7eefa09a452b620d66115c4c9fe02e7a34402ce5d225e(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0624f12a7f9847882b5d144f0cb9c20ce303900b3de90bc21683ba2df70cc00f(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c4b99891031f732126d4bdf911b5b21e02cb31b46b39d4680c99b637c7674663(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__10c7008fe6e48d54fd2dd8dcbee71301fe7de1710effdc5747d027f69030cab2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5eae00883d293f161486c159bdc091c97795dcd43f0967b0bef5bd7a629f3c2a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86249e26227726b985a0c241742da8e40c63a36d3b7dee0829e15eb5d21cbc1c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d10073c69e92a7535261aae109db3189e92df8d9a3711708b12708e2d50c4941(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionRequestType],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__63f5a13a3ac2026528418cd1ac83399345a38b14d0e497ef47c627b6a6afdbf7(
    *,
    header_name: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    lower_bound: typing.Optional[jsii.Number] = None,
    match_case_sensitive_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard_name: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_wildcard_value: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    upper_bound: typing.Optional[jsii.Number] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__34d098e6c319cc7e1d984c2be4b6cb06f1f2e43683a3d16bfc5a1832a373f3ef(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f37315ef33ad961ef66f895c049627cac800e7480b22b05096fff875aca9b33a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__eae59def5df490cc68876172fdf8d87048f231ab1b1734443114eca24ddea4c0(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee72a5340b2103906641d22b33e7ad34ed460ba653add0dca76f27241cad680c(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__253e5512178c3d3d7bf5ce3ceb6c8b387b7eaaa01c05ef6f3754c4345d73f558(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__03b18dc30f0563ee1f246c07bbcdf9e163ab02cdff2e5011821b8f26ba938134(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__35d4cced69744e42b51a3fe7a61eec1db5cd932541f9844bbe4f092fe09b8857(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c091716ada9ab83d0b702f602bc5b0b23bd913f9d8e3ea56c389ec7e246e18c9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1005943eea919d7f155ca4d83a6db6544d3fb3bf27b93934d0c30e618b10a4f7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__379d7b7e7cfd86fc2f336a19caa6656db1600a6cfd49eb6787086595a023fd29(
    value: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3149838cabce2dfe2ed0f200cc7ed97a86b4007a4e5bd0f97cdb6b39017f000a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e48b9410b5ffbf74c0381d06b9cd74c92d0f20dd97b8297155720483cff7b8cc(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__658d8c5a49fb741f6a422839a93c531ec190ccf1d4de1a7558f9e445b9a899f7(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionResponseHeader],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1c0312e30391e481f5e6b9427a1a09ada44f9a99395a92675288b3340e76c848(
    *,
    continents: typing.Optional[typing.Sequence[builtins.str]] = None,
    countries: typing.Optional[typing.Sequence[builtins.str]] = None,
    location_type: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    regions: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ac17931ba0b3fba889877c1cda29d339985e4226bde707c04a7ce242626ecfac(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__774eaae17f8c584e90a295932b11f79f412e8f4c25a4ad070274b0a6e05375ce(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__903736816160d8317b7535d4910e0e0d8ddf5f6bbdaa8bc36ab1a832eeba274d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9f89b40e6190c58b4e8eae15979b7be4687be27f706f4e3de8a888d1c43e4df8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c62e8deced25b29dc2a0db48e7b0cdbf2b5333fb6efa7d7d62cb57b456e3b297(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85a221f05e232e8786dbbe0ba50e2a36d62dbae25a848e2fc7a051fc847bc7db(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__79e3253b6670368eb96d16615d31160c64ef9b192e092d013c3b6afbb0ac40e9(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7455645fd384e8e5dd3a93db6b81f81004b92258457a4bfcd37fffc42e1b411e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4823b1a15b3c82d3e586a5e3ed25fa49da779364d3297584b612b88ba1334583(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e16b1d39db6f92feacc486c0249a74b223c9b8043e79c6139f08d22c5e8adb9f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionServerLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__59bb591b5b3c80a317068a79a8d876fa66a98dfa2f71c01b64fcbed7cfd6c013(
    *,
    apply_daylight_savings_time: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    begin_date: typing.Optional[builtins.str] = None,
    end_date: typing.Optional[builtins.str] = None,
    lasting_date: typing.Optional[builtins.str] = None,
    lasting_duration: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    repeat_begin_date: typing.Optional[builtins.str] = None,
    repeat_duration: typing.Optional[builtins.str] = None,
    repeat_interval: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__603216c284c05b71c82c9af6a7ec05187d8543a386ac2d09eb4c34aa01c65e4d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f4189df5d8d9ccf7a728d204b674f799f9ee8281323ecc9f45e1b34c55137f89(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__404f4d10ccb2d1c64effa1cc22de15c00f50c93f9c75a82d5ab240872eee3e41(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f96bdaf1cf6dbc6104408ef9aa82982d6ad7aabef3cd22287218a5cbaeb3cf0f(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cef6e0d1fa116669275728710ff06593b2cdcbaf43430520fa14ddf0ec9023a0(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__edf0094a7f96740adef0801fe793d644e35884e6ea33a5e207e9a73e8583694e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f65bfc4b99c1c00d77071a667a2c9d9a7050f8abc39f9313051ec12f808364bd(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b0b18c2635b5198506c24e8fbe741af40bf3e9f96a2cdc29726288ed8eb6b58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8916ea34098e75c5ef757a308ecc48aa2989382a9811fa7a5f32afca2bf8433e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7e68d9d8e2fa983cf58ba96ee5f02850e68ce3bd8f08aa7dd69481d77b6a5ff2(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0cc394b57200b1042eb4ca8e273d3dd738816836cf5b60a33b5bcdf44ff95672(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d8959cf9076f566cf2594751c420e8efb3915586cd9dd3c725e4fba61847fa7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b9957831a21c339dff0d69bcbf9d317797c0315e62bb200a826c8a928fbb5a19(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__18052ea6c9b61cdede61c4f54af4cba62db13218799aaaee7eb6fe35b499952c(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTime],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbe5cf1477c97f38ab56dd06efc32aa63bdfd522e2d728aca192d2367e3b0b41(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    status_list: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86a1ab1800f37e91efe495bacd24865df8d6314ca15cccefab6b61a77e4c0f1c(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e4dfa76f2b4de58a61d674c4f2bdba3957fa1c3398759f15929ce28613f5e159(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46af5f420ddee99e0d9f16727fb12790b5399e38e504b4348a9b1193c86a157a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1cbe60527125639bba5b35ed14e0e3ce952c1059f3f81c1d27f232c046ad966d(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c3493b4fff15e9f1b5c2a0721bc35d23b04a65a09740cfd12026e37c17b9e8a7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e660d1cf4d9a860b04be158a112dea9914b4d16f73e9f0274a44157b396fe9cc(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__39175aa1514083242b0810307e5452b13a7a3da0f0bb2c08b822ef0a9e436ad4(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionTokenAuthorization],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4270c82b7307160e48eb2e4bebd602cd23c5a938376094bca81ce4c5a08eabdf(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_case_sensitive: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    match_wildcard: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    values: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9344d6fc91485af58c155590e22112ee1e35628c6faafdb152613f5b8ae4a21d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4f621b5e48830b572f92b77511a5da416659aea15c23326e95ffff6c4ee40b93(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9628ae77c89167402e9975599286c492d8b260552a6364f52feab6ae5aed45ff(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e1e5341102bc9e0c348b786dfe9de16fb6f1cb9a394b6fdda336e7225f361a50(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__86dfeee87381b6bd510bd17fe3430800994377087bfe1c7a78331ff79630319b(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce809d9d2a5d76c264c084cf00acef605e89450777b167632e5170fc4c94ed03(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd758da319c3f0cd35dd513415a27ada9242728e07ac634cb8cdd50c84588bf4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9aa097369bca78dd00cc03a34c52bb9a3a98549d2f10dddb757566e9261df349(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cd61ef598966e108bd8283587fcf21927bc70646b94347a584cb0682e31f6328(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserAgent],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17986b5fa75542d47f2be06d37efd02bf1cd8585be26f92739db6dd672e5416b(
    *,
    check_ips: typing.Optional[builtins.str] = None,
    continent_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    country_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    region_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3ea485a35dcea73e8e71807d52cef67be5229cb1db9161a76b862b0fdb29645d(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__13eb3f56e9282827bfec8b09b97b89797310d4e2b0a178f6e9df3a64260d681e(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8932c2400fc1c0fe539ea5eaaa22a246d4f78e998d4c14a083ed17cae93ef994(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9d2c8b426a1f4fe1efa9c67e4a53f833c557ec344082fb6c4768442983f15c5b(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1d08633a98625b611ec1b0c929f72b76d7bced3262ede81e1912b64ab9bb026a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ab470dc8eddced061f927a6b6ac70878bf062fa35556b765fda770659143df9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bd2ecd38b291af5a64c8e9be856680556fc0f177161ab12a2c54a9eeca10e124(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d655cbc3ead0f2855ea62522c91e3056f496adb36a47c077b81b32e17dcb1d7(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ce150dddc0d62be2bb2b93bef62438e2c4b2925212dd0650919925e888e87131(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a933e60ff4a2a1fcc78df361a842bd506bb1dfd77cb20d939dc9375a6cc293cf(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__980b32fe07a71d9226cb4ae50fdd982f2e943d12e9d5b1827840824e5f413d91(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cbbe83d93df8650c0ca13f3358c9fb83631958bbfd844286f97b1eeba6f6ef95(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserLocation],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0a9dc575edddaa55c21e4f8fa2abae7306397245640b2b80b7d944813944e22d(
    *,
    bandwidth_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    check_ips: typing.Optional[builtins.str] = None,
    field: typing.Optional[builtins.str] = None,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_operator: typing.Optional[builtins.str] = None,
    network_type_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    network_values: typing.Optional[typing.Sequence[builtins.str]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    use_only_first_x_forwarded_for_ip: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__578556078ce71dda01cbe3bdb74f71d1653ba7fd8215ce6e07ea3bc9e301fbbc(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bc7550d65d6849fea9060dfbfdbc2a7bbb931c7273bcd99f1b8c9bd929df5052(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dd2f68ce0fbf47ba0b394b8287b864e89087eb2722d22a0722843b3cc5da87f4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__cdedb06d3eed50559775c443a2c66ba7fb7c17dd0b38e84901f63ee841784845(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f2083d279e75f1ec450d8d9179d551c7c58bbd8623719131dc04af0ce51c0f14(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__46910b42c1ffa25ef43984ba448104b0bcc67ccee4fbe4a055f5568d7ec47955(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__54b871624ded350534edcecbf7a378c14858f15d97faea0db4476cfb7622febe(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__25238cd487252689eb11769db52cffc3929a12ea6c2083adabfaef3177152438(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e04ea10b45053fb5540e229fe313211d772da37b42a92d1f4c1e333210c3e729(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5dccb6b034e3844485eda17b11347efdb64d0cd0f1eb647808cda95da98b2178(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__55cc738420dd606419c8a091a256252fdd146717fe42ad308c7bf971171d8c3c(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e91631dc7da6c8185f3943d5dc784d718c27dbe60cf77c9500a762d9da3c682a(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionUserNetwork],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ee3a113aefdde47d9c6d048a48be2a2ea0154ebcdd7d25718f1a6a07daf31ff3(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    result: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
    variable_names: typing.Optional[typing.Sequence[builtins.str]] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__2b1aa22a964ba0e5de16016a62320d5737b93096047ea9fb792fc53219e457db(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__a327edb761944e824221f8bb03a1c3ded7e7bfc7253193f9c4dd533279796446(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__20ff7934bcda10c6e93cba5742cc2a92e7d5557f9c7f9ad595b83fe081c38667(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0846ee63f033445872d3d8c8fb9646f8c7e3b9f5c2da8a65cc4c1d3e1fc3a44a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__17188998b60161e886db97c4e76f1ed291404d2676ca4b30eab248ec46bb93b4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f153af93a5107e50f4bdd3026cf2be1a0e59e56aae7963cc4078937c79c1224c(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b236c7e2ae6a4a6f84dd7f31b94f8517047282b1a72c993a71aee8437f37d2c6(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVariableError],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e5ba42dfcf6755cb259f6cc8612843620d4346a0a8228b28ad32fe12a496a633(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0f15d715c8e20f6725081d9ed37ec43854659520faa47a816ecfe2e8077ec0c1(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b95a2d4140ec6558d3a5d12b8732beb272fbe517e27bc9ea6486627e9375fb9e(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87d311ee3d68df1fb2dfc3421119c04782fa54b1f5ea0b88823b2869b9f151f9(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3e81a48a9bc2b25bd0e86772716ca575f07c1ffba73a81cb316c45789da26bdf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__163f36f4eac90b6733aec31b7a739424728d26355c7eaac85581c0b36e9bb5d6(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7baa250035b6b6687fa35dc5b782d902371949db842b184500fc7acf5d7ff560(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b404d89e56efb2ddb4fa29f6b6ae49d1861667cf2a914cf9d80a1e17ebf072f2(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVirtualWaitingRoomRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__7b74ab15b575410a2ac929e19ecc0015e01a799f4823cfafa6113d112eb4f70a(
    *,
    locked: typing.Optional[typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable]] = None,
    match_on: typing.Optional[builtins.str] = None,
    match_operator: typing.Optional[builtins.str] = None,
    template_uuid: typing.Optional[builtins.str] = None,
    uuid: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__dc29f60e944982a6c942896882f6d9fb6eb66cd8233d6dccb9472bfaf51ea5f3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__978730cb531f36b640ad9e0e522d6e8f1d863cd9a2ecf0cd901a6d3863d6c7a9(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__aeba7a2c8ef4836a9b1173fe65e883c66d5b2e871ec010e655cf45ff94fcfacf(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__801c61941c8900c04cd91d8365fbf3c7b42ebd4d81adf329ebf891393f318ec7(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8263a2e82036acbd4d90445baee60d24cbbb35fb3e0d8cfbde564ec619465795(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__075bd170781e0863245acd01196f8195b9c1dd9aab8d3c49be0579e80d9bd0d3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ab7d795023241d78b77d0fdc5bab8fa0443de990bc0bd0d3ee9713a6afcb1635(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CriterionVisitorPrioritizationRequest],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__3d4b267e2bd502e05b24e5ad9ca152f1d80c9e5bfc5acb9f9022fa58d9c85dfb(
    *,
    name: typing.Optional[builtins.str] = None,
    override_id: typing.Optional[builtins.str] = None,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ed8f00d29c215c74fc24a787f00e358e3cf87edb30be856dc968a12df3e92800(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__c28bb8f47fcd0901c6300e715afa3685797f5f85a60bdc524f38b079a421d4c8(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__6bef4a158a30ae41637d25159d33cae46847b959b6fb3c486394fcf3d74cd54a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__87cc153e17d55813afbbf1ee9082ef75b353d186c9421324766a7d394ada8e98(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109CustomOverride],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0c7dd3cebb21adbbc6a96ce7bf413e0eafcea794046de16e4041eadbb9df19e3(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__632555e193424c4981e350bc2e3fc08e722218869dbf7faad975abab932bc292(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Behavior, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__09d10fffcdd9b66f8b4b82d897ace8f864c8598c367db4ffafa0e208b1258a6d(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Criterion, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d661a878e20df7e439a219e717111ff80283f75066120d0b916159e0d3b15b12(
    value: typing.Union[_cdktf_9a9027ec.IResolvable, typing.Sequence[typing.Union[DataAkamaiPropertyRulesBuilderRulesV20240109Variable, typing.Dict[builtins.str, typing.Any]]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__433d56e75e17c15848569aa60aef3ad239a7384d09c9e6c64b13fbc19bc33e58(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__85782cd6cd5409766bf6d484db7faebf59f135e443790767e658ffe702fb7082(
    value: typing.List[builtins.str],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__9be38ce260dfea222ac1dce4e96f6b63569e5ec37682e184e2289f1abc5b987b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__b13863201febc6d2c8089c2db95a2edc32d5343364720e3c686b28efe5283011(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__ff541c3ad8751f4748a5f5ea4f5c1fda2a8c5e6d3db54e557dcf09cc1320b131(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8599a6e3178560506e03a26d17a4d65f2c2da41952e622e81b86ae896df024be(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__320037a1726795f3422ead617a731ef1b94700bec1a2209ce7d1850568473797(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e3c4943916af43ac98c8eabd3561d66c693496d2f3e38a9e308bc57d78b901e3(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8d920e305056390bb5f2eb28137dcebd0dc355141703a52a0b40eddc4e77f1d4(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__8be3399e190ed577bbd0f15db3d7b738bad73b5602ced60d00986ca368553641(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__e038058591bedb56d969ce13f1cbb985ca189ed4cc9f32a08096f6077562f47f(
    value: typing.Optional[DataAkamaiPropertyRulesBuilderRulesV20240109],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d375756145ed8648216086d073d4441340647818911e496e27dfb8db42d5bc69(
    *,
    description: builtins.str,
    hidden: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    name: builtins.str,
    sensitive: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__4731289bccb450e88090f1c208247c094ac9cd8178870f864738b083bfd097cf(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    wraps_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__703186223b67ff12e800fe72be98540eade21a89cfae3eb88a2fb3c7bd07271a(
    index: jsii.Number,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__21e71773b0d6922e009dabc7160b6ef34a092b60e5b3df8d77149c36a9a380bd(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__5ddfc08cbc87e101dce06e53f1173c47fef8a7d6e1bd6c4ce0c71ff8c017cff9(
    value: _cdktf_9a9027ec.IInterpolatingParent,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__f02e70ba6d8190f2c4fd218f006d6cbac308681320002612122bca81b02ac361(
    value: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__48875eff9cced7e71d4b0b7939782ba5ac2ac24c482ffeb82cddabcca0c6c032(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, typing.List[DataAkamaiPropertyRulesBuilderRulesV20240109Variable]]],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__898d607c3643fdfb4fa6576406fa539d3b400495a6bf888b49dd1c8d049babb5(
    terraform_resource: _cdktf_9a9027ec.IInterpolatingParent,
    terraform_attribute: builtins.str,
    complex_object_index: jsii.Number,
    complex_object_is_from_set: builtins.bool,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__0d3bb27fde4a93fb0797fda4d8d05383b2dbdc7a28b2e8ac013a99b48c308c8a(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__92a04ba46b1fa2626d2f165ae245935f3fabfcefb66e4ea17a616021b29371d5(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__d99bbdbb7404a3ff5f0f236180a66bd1ba7673e09aa0d1cadeed125e7cd5fd28(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__fab165c8b8b4b964667d27405aac76a2fb6a23c97f05cd3fe87503b78db4d091(
    value: typing.Union[builtins.bool, _cdktf_9a9027ec.IResolvable],
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__1a01b68706332ea98a75002ce728fd1ed20efc742ee25e7607c86709ce4a963b(
    value: builtins.str,
) -> None:
    """Type checking stubs"""
    pass

def _typecheckingstub__bffdbb1e2ebf930562bb70fcf43605fc42f2cd834f5bc8f03ab8065c8d528fdc(
    value: typing.Optional[typing.Union[_cdktf_9a9027ec.IResolvable, DataAkamaiPropertyRulesBuilderRulesV20240109Variable]],
) -> None:
    """Type checking stubs"""
    pass
